var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a, prop, b2[prop]);
    }
  return a;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import * as React from "react";
import React__default, { useState, useMemo, useRef, useEffect, createContext, useContext } from "react";
var __read$3 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useToggle(defaultValue, reverseValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$3(useState(defaultValue), 2), state = _a2[0], setState = _a2[1];
  var actions2 = useMemo(function() {
    var reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    var toggle = function toggle2() {
      return setState(function(s) {
        return s === defaultValue ? reverseValueOrigin : defaultValue;
      });
    };
    var set2 = function set3(value) {
      return setState(value);
    };
    var setLeft = function setLeft2() {
      return setState(defaultValue);
    };
    var setRight = function setRight2() {
      return setState(reverseValueOrigin);
    };
    return {
      toggle,
      set: set2,
      setLeft,
      setRight
    };
  }, []);
  return [state, actions2];
}
var __read$2 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$2(useToggle(defaultValue), 2), state = _a2[0], _b2 = _a2[1], toggle = _b2.toggle, _set = _b2.set;
  var actions2 = useMemo(function() {
    var setTrue = function setTrue2() {
      return _set(true);
    };
    var setFalse = function setFalse2() {
      return _set(false);
    };
    return {
      toggle,
      set: function set2(v4) {
        return _set(!!v4);
      },
      setTrue,
      setFalse
    };
  }, []);
  return [state, actions2];
}
function useLatest(value) {
  var ref = useRef(value);
  ref.current = value;
  return ref;
}
var isBrowser = !!(typeof window !== "undefined" && window.document && window.document.createElement);
var isBrowser$1 = isBrowser;
function getTargetElement(target, defaultElement) {
  if (!isBrowser$1) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  var targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if ("current" in target) {
    targetElement = target.current;
  } else {
    targetElement = target;
  }
  return targetElement;
}
var useUnmount = function useUnmount2(fn) {
  var fnRef = useLatest(fn);
  useEffect(function() {
    return function() {
      fnRef.current();
    };
  }, []);
};
var useUnmount$1 = useUnmount;
function depsAreSame(oldDeps, deps) {
  if (oldDeps === deps)
    return true;
  for (var i = 0; i < oldDeps.length; i++) {
    if (!Object.is(oldDeps[i], deps[i]))
      return false;
  }
  return true;
}
var createEffectWithTarget = function createEffectWithTarget2(useEffectType) {
  var useEffectWithTarget2 = function useEffectWithTarget3(effect, deps, target) {
    var hasInitRef = useRef(false);
    var lastElementRef = useRef([]);
    var lastDepsRef = useRef([]);
    var unLoadRef = useRef();
    useEffectType(function() {
      var _a2;
      var targets = Array.isArray(target) ? target : [target];
      var els = targets.map(function(item) {
        return getTargetElement(item);
      });
      if (!hasInitRef.current) {
        hasInitRef.current = true;
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
        return;
      }
      if (els.length !== lastElementRef.current.length || !depsAreSame(els, lastElementRef.current) || !depsAreSame(deps, lastDepsRef.current)) {
        (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
      }
    });
    useUnmount$1(function() {
      var _a2;
      (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
      hasInitRef.current = false;
    });
  };
  return useEffectWithTarget2;
};
var createEffectWithTarget$1 = createEffectWithTarget;
var useEffectWithTarget = createEffectWithTarget$1(useEffect);
var useEffectWithTarget$1 = useEffectWithTarget;
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x2) {
  return x2 && x2.__esModule && Object.prototype.hasOwnProperty.call(x2, "default") ? x2["default"] : x2;
}
function isObject$7(value) {
  var type4 = typeof value;
  return value != null && (type4 == "object" || type4 == "function");
}
var isObject_1 = isObject$7;
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var _freeGlobal = freeGlobal$1;
var freeGlobal = _freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root$2 = freeGlobal || freeSelf || Function("return this")();
var _root = root$2;
var root$1 = _root;
var now$1 = function() {
  return root$1.Date.now();
};
var now_1 = now$1;
var reWhitespace = /\s/;
function trimmedEndIndex$1(string3) {
  var index2 = string3.length;
  while (index2-- && reWhitespace.test(string3.charAt(index2))) {
  }
  return index2;
}
var _trimmedEndIndex = trimmedEndIndex$1;
var trimmedEndIndex = _trimmedEndIndex;
var reTrimStart = /^\s+/;
function baseTrim$1(string3) {
  return string3 ? string3.slice(0, trimmedEndIndex(string3) + 1).replace(reTrimStart, "") : string3;
}
var _baseTrim = baseTrim$1;
var root = _root;
var Symbol$4 = root.Symbol;
var _Symbol = Symbol$4;
var Symbol$3 = _Symbol;
var objectProto$1 = Object.prototype;
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;
var nativeObjectToString$1 = objectProto$1.toString;
var symToStringTag$1 = Symbol$3 ? Symbol$3.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$1.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e2) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var _getRawTag = getRawTag$1;
var objectProto = Object.prototype;
var nativeObjectToString = objectProto.toString;
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}
var _objectToString = objectToString$1;
var Symbol$2 = _Symbol, getRawTag = _getRawTag, objectToString = _objectToString;
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
function baseGetTag$1(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
var _baseGetTag = baseGetTag$1;
function isObjectLike$1(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_1 = isObjectLike$1;
var baseGetTag = _baseGetTag, isObjectLike = isObjectLike_1;
var symbolTag = "[object Symbol]";
function isSymbol$1(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
}
var isSymbol_1 = isSymbol$1;
var baseTrim = _baseTrim, isObject$6 = isObject_1, isSymbol = isSymbol_1;
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber$1(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject$6(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject$6(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var toNumber_1 = toNumber$1;
var isObject$5 = isObject_1, now = now_1, toNumber = toNumber_1;
var FUNC_ERROR_TEXT = "Expected a function";
var nativeMax = Math.max, nativeMin = Math.min;
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject$5(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel2() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now());
  }
  function debounced() {
    var time = now(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel2;
  debounced.flush = flush;
  return debounced;
}
var debounce_1 = debounce;
var __read$1 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
var __spread = globalThis && globalThis.__spread || function() {
  for (var ar = [], i = 0; i < arguments.length; i++) {
    ar = ar.concat(__read$1(arguments[i]));
  }
  return ar;
};
function useDebounceFn(fn, options) {
  var _a2;
  var fnRef = useLatest(fn);
  var wait = (_a2 = options === null || options === void 0 ? void 0 : options.wait) !== null && _a2 !== void 0 ? _a2 : 1e3;
  var debounced = useMemo(function() {
    return debounce_1(function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return fnRef.current.apply(fnRef, __spread(args));
    }, wait, options);
  }, []);
  useUnmount$1(function() {
    debounced.cancel();
  });
  return {
    run: debounced,
    cancel: debounced.cancel,
    flush: debounced.flush
  };
}
var createUpdateEffect = function createUpdateEffect2(hook) {
  return function(effect, deps) {
    var isMounted = useRef(false);
    hook(function() {
      return function() {
        isMounted.current = false;
      };
    }, []);
    hook(function() {
      if (!isMounted.current) {
        isMounted.current = true;
      } else {
        return effect();
      }
    }, deps);
  };
};
var useUpdateEffect = createUpdateEffect(useEffect);
var __read = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useDebounceEffect(effect, deps, options) {
  var _a2 = __read(useState({}), 2), flag = _a2[0], setFlag = _a2[1];
  var _b2 = useDebounceFn(function() {
    setFlag({});
  }, options), run = _b2.run, cancel2 = _b2.cancel;
  useEffect(function() {
    return run();
  }, deps);
  useUnmount$1(cancel2);
  useUpdateEffect(effect, [flag]);
}
function useEventListener(eventName, handler, options) {
  if (options === void 0) {
    options = {};
  }
  var handlerRef = useLatest(handler);
  useEffectWithTarget$1(function() {
    var targetElement = getTargetElement(options.target, window);
    if (!(targetElement === null || targetElement === void 0 ? void 0 : targetElement.addEventListener)) {
      return;
    }
    var eventListener = function eventListener2(event) {
      return handlerRef.current(event);
    };
    targetElement.addEventListener(eventName, eventListener, {
      capture: options.capture,
      once: options.once,
      passive: options.passive
    });
    return function() {
      targetElement.removeEventListener(eventName, eventListener, {
        capture: options.capture
      });
    };
  }, [eventName, options.capture, options.once, options.passive], options.target);
}
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var extendStatics = function(d2, b2) {
  extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b3) {
    d3.__proto__ = b3;
  } || function(d3, b3) {
    for (var p2 in b3)
      if (Object.prototype.hasOwnProperty.call(b3, p2))
        d3[p2] = b3[p2];
  };
  return extendStatics(d2, b2);
};
function __extends(d2, b2) {
  if (typeof b2 !== "function" && b2 !== null)
    throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
  extendStatics(d2, b2);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
}
var Browser = function() {
  function Browser2() {
    this.firefox = false;
    this.ie = false;
    this.edge = false;
    this.newEdge = false;
    this.weChat = false;
  }
  return Browser2;
}();
var Env = function() {
  function Env2() {
    this.browser = new Browser();
    this.node = false;
    this.wxa = false;
    this.worker = false;
    this.svgSupported = false;
    this.touchEventsSupported = false;
    this.pointerEventsSupported = false;
    this.domSupported = false;
    this.transformSupported = false;
    this.transform3dSupported = false;
    this.hasGlobalWindow = typeof window !== "undefined";
  }
  return Env2;
}();
var env = new Env();
if (typeof wx === "object" && typeof wx.getSystemInfoSync === "function") {
  env.wxa = true;
  env.touchEventsSupported = true;
} else if (typeof document === "undefined" && typeof self !== "undefined") {
  env.worker = true;
} else if (typeof navigator === "undefined") {
  env.node = true;
  env.svgSupported = true;
} else {
  detect(navigator.userAgent, env);
}
function detect(ua, env2) {
  var browser = env2.browser;
  var firefox = ua.match(/Firefox\/([\d.]+)/);
  var ie = ua.match(/MSIE\s([\d.]+)/) || ua.match(/Trident\/.+?rv:(([\d.]+))/);
  var edge = ua.match(/Edge?\/([\d.]+)/);
  var weChat = /micromessenger/i.test(ua);
  if (firefox) {
    browser.firefox = true;
    browser.version = firefox[1];
  }
  if (ie) {
    browser.ie = true;
    browser.version = ie[1];
  }
  if (edge) {
    browser.edge = true;
    browser.version = edge[1];
    browser.newEdge = +edge[1].split(".")[0] > 18;
  }
  if (weChat) {
    browser.weChat = true;
  }
  env2.svgSupported = typeof SVGRect !== "undefined";
  env2.touchEventsSupported = "ontouchstart" in window && !browser.ie && !browser.edge;
  env2.pointerEventsSupported = "onpointerdown" in window && (browser.edge || browser.ie && +browser.version >= 11);
  env2.domSupported = typeof document !== "undefined";
  var style = document.documentElement.style;
  env2.transform3dSupported = (browser.ie && "transition" in style || browser.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in style) && !("OTransition" in style);
  env2.transformSupported = env2.transform3dSupported || browser.ie && +browser.version >= 9;
}
var env$1 = env;
var DEFAULT_FONT_SIZE = 12;
var DEFAULT_FONT_FAMILY = "sans-serif";
var DEFAULT_FONT = DEFAULT_FONT_SIZE + "px " + DEFAULT_FONT_FAMILY;
var OFFSET = 20;
var SCALE = 100;
var defaultWidthMapStr = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
function getTextWidthMap(mapStr) {
  var map2 = {};
  if (typeof JSON === "undefined") {
    return map2;
  }
  for (var i = 0; i < mapStr.length; i++) {
    var char = String.fromCharCode(i + 32);
    var size = (mapStr.charCodeAt(i) - OFFSET) / SCALE;
    map2[char] = size;
  }
  return map2;
}
var DEFAULT_TEXT_WIDTH_MAP = getTextWidthMap(defaultWidthMapStr);
var platformApi = {
  createCanvas: function() {
    return typeof document !== "undefined" && document.createElement("canvas");
  },
  measureText: function() {
    var _ctx;
    var _cachedFont;
    return function(text, font) {
      if (!_ctx) {
        var canvas = platformApi.createCanvas();
        _ctx = canvas && canvas.getContext("2d");
      }
      if (_ctx) {
        if (_cachedFont !== font) {
          _cachedFont = _ctx.font = font || DEFAULT_FONT;
        }
        return _ctx.measureText(text);
      } else {
        text = text || "";
        font = font || DEFAULT_FONT;
        var res = /^([0-9]*?)px$/.exec(font);
        var fontSize = +(res && res[1]) || DEFAULT_FONT_SIZE;
        var width = 0;
        if (font.indexOf("mono") >= 0) {
          width = fontSize * text.length;
        } else {
          for (var i = 0; i < text.length; i++) {
            var preCalcWidth = DEFAULT_TEXT_WIDTH_MAP[text[i]];
            width += preCalcWidth == null ? fontSize : preCalcWidth * fontSize;
          }
        }
        return { width };
      }
    };
  }(),
  loadImage: function(src, onload, onerror) {
    var image = new Image();
    image.onload = onload;
    image.onerror = onerror;
    image.src = src;
    return image;
  }
};
var BUILTIN_OBJECT = reduce([
  "Function",
  "RegExp",
  "Date",
  "Error",
  "CanvasGradient",
  "CanvasPattern",
  "Image",
  "Canvas"
], function(obj, val) {
  obj["[object " + val + "]"] = true;
  return obj;
}, {});
var TYPED_ARRAY = reduce([
  "Int8",
  "Uint8",
  "Uint8Clamped",
  "Int16",
  "Uint16",
  "Int32",
  "Uint32",
  "Float32",
  "Float64"
], function(obj, val) {
  obj["[object " + val + "Array]"] = true;
  return obj;
}, {});
var objToString = Object.prototype.toString;
var arrayProto = Array.prototype;
var nativeForEach = arrayProto.forEach;
var nativeFilter = arrayProto.filter;
var nativeSlice = arrayProto.slice;
var nativeMap = arrayProto.map;
var ctorFunction = function() {
}.constructor;
var protoFunction = ctorFunction ? ctorFunction.prototype : null;
var protoKey = "__proto__";
var idStart = 2311;
function guid() {
  return idStart++;
}
function logError() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  if (typeof console !== "undefined") {
    console.error.apply(console, args);
  }
}
function clone$4(source) {
  if (source == null || typeof source !== "object") {
    return source;
  }
  var result = source;
  var typeStr = objToString.call(source);
  if (typeStr === "[object Array]") {
    if (!isPrimitive(source)) {
      result = [];
      for (var i = 0, len2 = source.length; i < len2; i++) {
        result[i] = clone$4(source[i]);
      }
    }
  } else if (TYPED_ARRAY[typeStr]) {
    if (!isPrimitive(source)) {
      var Ctor = source.constructor;
      if (Ctor.from) {
        result = Ctor.from(source);
      } else {
        result = new Ctor(source.length);
        for (var i = 0, len2 = source.length; i < len2; i++) {
          result[i] = source[i];
        }
      }
    }
  } else if (!BUILTIN_OBJECT[typeStr] && !isPrimitive(source) && !isDom(source)) {
    result = {};
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        result[key] = clone$4(source[key]);
      }
    }
  }
  return result;
}
function merge(target, source, overwrite) {
  if (!isObject$4(source) || !isObject$4(target)) {
    return overwrite ? clone$4(source) : target;
  }
  for (var key in source) {
    if (source.hasOwnProperty(key) && key !== protoKey) {
      var targetProp = target[key];
      var sourceProp = source[key];
      if (isObject$4(sourceProp) && isObject$4(targetProp) && !isArray$1(sourceProp) && !isArray$1(targetProp) && !isDom(sourceProp) && !isDom(targetProp) && !isBuiltInObject(sourceProp) && !isBuiltInObject(targetProp) && !isPrimitive(sourceProp) && !isPrimitive(targetProp)) {
        merge(targetProp, sourceProp, overwrite);
      } else if (overwrite || !(key in target)) {
        target[key] = clone$4(source[key]);
      }
    }
  }
  return target;
}
function mergeAll(targetAndSources, overwrite) {
  var result = targetAndSources[0];
  for (var i = 1, len2 = targetAndSources.length; i < len2; i++) {
    result = merge(result, targetAndSources[i], overwrite);
  }
  return result;
}
function extend(target, source) {
  if (Object.assign) {
    Object.assign(target, source);
  } else {
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        target[key] = source[key];
      }
    }
  }
  return target;
}
function defaults(target, source, overlay) {
  var keysArr = keys(source);
  for (var i = 0; i < keysArr.length; i++) {
    var key = keysArr[i];
    if (overlay ? source[key] != null : target[key] == null) {
      target[key] = source[key];
    }
  }
  return target;
}
platformApi.createCanvas;
function indexOf(array4, value) {
  if (array4) {
    if (array4.indexOf) {
      return array4.indexOf(value);
    }
    for (var i = 0, len2 = array4.length; i < len2; i++) {
      if (array4[i] === value) {
        return i;
      }
    }
  }
  return -1;
}
function inherits(clazz, baseClazz) {
  var clazzPrototype = clazz.prototype;
  function F() {
  }
  F.prototype = baseClazz.prototype;
  clazz.prototype = new F();
  for (var prop in clazzPrototype) {
    if (clazzPrototype.hasOwnProperty(prop)) {
      clazz.prototype[prop] = clazzPrototype[prop];
    }
  }
  clazz.prototype.constructor = clazz;
  clazz.superClass = baseClazz;
}
function mixin(target, source, override) {
  target = "prototype" in target ? target.prototype : target;
  source = "prototype" in source ? source.prototype : source;
  if (Object.getOwnPropertyNames) {
    var keyList = Object.getOwnPropertyNames(source);
    for (var i = 0; i < keyList.length; i++) {
      var key = keyList[i];
      if (key !== "constructor") {
        if (override ? source[key] != null : target[key] == null) {
          target[key] = source[key];
        }
      }
    }
  } else {
    defaults(target, source, override);
  }
}
function isArrayLike(data) {
  if (!data) {
    return false;
  }
  if (typeof data === "string") {
    return false;
  }
  return typeof data.length === "number";
}
function each$f(arr, cb, context) {
  if (!(arr && cb)) {
    return;
  }
  if (arr.forEach && arr.forEach === nativeForEach) {
    arr.forEach(cb, context);
  } else if (arr.length === +arr.length) {
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      cb.call(context, arr[i], i, arr);
    }
  } else {
    for (var key in arr) {
      if (arr.hasOwnProperty(key)) {
        cb.call(context, arr[key], key, arr);
      }
    }
  }
}
function map$1(arr, cb, context) {
  if (!arr) {
    return [];
  }
  if (!cb) {
    return slice(arr);
  }
  if (arr.map && arr.map === nativeMap) {
    return arr.map(cb, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      result.push(cb.call(context, arr[i], i, arr));
    }
    return result;
  }
}
function reduce(arr, cb, memo, context) {
  if (!(arr && cb)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    memo = cb.call(context, memo, arr[i], i, arr);
  }
  return memo;
}
function filter(arr, cb, context) {
  if (!arr) {
    return [];
  }
  if (!cb) {
    return slice(arr);
  }
  if (arr.filter && arr.filter === nativeFilter) {
    return arr.filter(cb, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      if (cb.call(context, arr[i], i, arr)) {
        result.push(arr[i]);
      }
    }
    return result;
  }
}
function find(arr, cb, context) {
  if (!(arr && cb)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    if (cb.call(context, arr[i], i, arr)) {
      return arr[i];
    }
  }
}
function keys(obj) {
  if (!obj) {
    return [];
  }
  if (Object.keys) {
    return Object.keys(obj);
  }
  var keyList = [];
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      keyList.push(key);
    }
  }
  return keyList;
}
function bindPolyfill(func, context) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return function() {
    return func.apply(context, args.concat(nativeSlice.call(arguments)));
  };
}
var bind$1 = protoFunction && isFunction(protoFunction.bind) ? protoFunction.call.bind(protoFunction.bind) : bindPolyfill;
function curry$1(func) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return function() {
    return func.apply(this, args.concat(nativeSlice.call(arguments)));
  };
}
function isArray$1(value) {
  if (Array.isArray) {
    return Array.isArray(value);
  }
  return objToString.call(value) === "[object Array]";
}
function isFunction(value) {
  return typeof value === "function";
}
function isString(value) {
  return typeof value === "string";
}
function isStringSafe(value) {
  return objToString.call(value) === "[object String]";
}
function isNumber(value) {
  return typeof value === "number";
}
function isObject$4(value) {
  var type4 = typeof value;
  return type4 === "function" || !!value && type4 === "object";
}
function isBuiltInObject(value) {
  return !!BUILTIN_OBJECT[objToString.call(value)];
}
function isTypedArray(value) {
  return !!TYPED_ARRAY[objToString.call(value)];
}
function isDom(value) {
  return typeof value === "object" && typeof value.nodeType === "number" && typeof value.ownerDocument === "object";
}
function isGradientObject(value) {
  return value.colorStops != null;
}
function isImagePatternObject(value) {
  return value.image != null;
}
function isRegExp(value) {
  return objToString.call(value) === "[object RegExp]";
}
function eqNaN(value) {
  return value !== value;
}
function retrieve() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  for (var i = 0, len2 = args.length; i < len2; i++) {
    if (args[i] != null) {
      return args[i];
    }
  }
}
function retrieve2(value0, value1) {
  return value0 != null ? value0 : value1;
}
function retrieve3(value0, value1, value2) {
  return value0 != null ? value0 : value1 != null ? value1 : value2;
}
function slice(arr) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return nativeSlice.apply(arr, args);
}
function normalizeCssArray$1(val) {
  if (typeof val === "number") {
    return [val, val, val, val];
  }
  var len2 = val.length;
  if (len2 === 2) {
    return [val[0], val[1], val[0], val[1]];
  } else if (len2 === 3) {
    return [val[0], val[1], val[2], val[1]];
  }
  return val;
}
function assert(condition, message) {
  if (!condition) {
    throw new Error(message);
  }
}
function trim$1(str) {
  if (str == null) {
    return null;
  } else if (typeof str.trim === "function") {
    return str.trim();
  } else {
    return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
}
var primitiveKey = "__ec_primitive__";
function setAsPrimitive(obj) {
  obj[primitiveKey] = true;
}
function isPrimitive(obj) {
  return obj[primitiveKey];
}
var HashMap = function() {
  function HashMap2(obj) {
    this.data = {};
    var isArr = isArray$1(obj);
    this.data = {};
    var thisMap = this;
    obj instanceof HashMap2 ? obj.each(visit) : obj && each$f(obj, visit);
    function visit(value, key) {
      isArr ? thisMap.set(value, key) : thisMap.set(key, value);
    }
  }
  HashMap2.prototype.get = function(key) {
    return this.data.hasOwnProperty(key) ? this.data[key] : null;
  };
  HashMap2.prototype.set = function(key, value) {
    return this.data[key] = value;
  };
  HashMap2.prototype.each = function(cb, context) {
    for (var key in this.data) {
      if (this.data.hasOwnProperty(key)) {
        cb.call(context, this.data[key], key);
      }
    }
  };
  HashMap2.prototype.keys = function() {
    return keys(this.data);
  };
  HashMap2.prototype.removeKey = function(key) {
    delete this.data[key];
  };
  return HashMap2;
}();
function createHashMap(obj) {
  return new HashMap(obj);
}
function concatArray(a, b2) {
  var newArray = new a.constructor(a.length + b2.length);
  for (var i = 0; i < a.length; i++) {
    newArray[i] = a[i];
  }
  var offset = a.length;
  for (var i = 0; i < b2.length; i++) {
    newArray[i + offset] = b2[i];
  }
  return newArray;
}
function createObject(proto2, properties) {
  var obj;
  if (Object.create) {
    obj = Object.create(proto2);
  } else {
    var StyleCtor = function() {
    };
    StyleCtor.prototype = proto2;
    obj = new StyleCtor();
  }
  if (properties) {
    extend(obj, properties);
  }
  return obj;
}
function disableUserSelect(dom) {
  var domStyle = dom.style;
  domStyle.webkitUserSelect = "none";
  domStyle.userSelect = "none";
  domStyle.webkitTapHighlightColor = "rgba(0,0,0,0)";
  domStyle["-webkit-touch-callout"] = "none";
}
function hasOwn(own, prop) {
  return own.hasOwnProperty(prop);
}
function noop() {
}
var RADIAN_TO_DEGREE = 180 / Math.PI;
function create$2(x2, y2) {
  if (x2 == null) {
    x2 = 0;
  }
  if (y2 == null) {
    y2 = 0;
  }
  return [x2, y2];
}
function copy$1(out2, v4) {
  out2[0] = v4[0];
  out2[1] = v4[1];
  return out2;
}
function clone$3(v4) {
  return [v4[0], v4[1]];
}
function set$2(out2, a, b2) {
  out2[0] = a;
  out2[1] = b2;
  return out2;
}
function add(out2, v12, v22) {
  out2[0] = v12[0] + v22[0];
  out2[1] = v12[1] + v22[1];
  return out2;
}
function scaleAndAdd$1(out2, v12, v22, a) {
  out2[0] = v12[0] + v22[0] * a;
  out2[1] = v12[1] + v22[1] * a;
  return out2;
}
function sub(out2, v12, v22) {
  out2[0] = v12[0] - v22[0];
  out2[1] = v12[1] - v22[1];
  return out2;
}
function len(v4) {
  return Math.sqrt(lenSquare(v4));
}
function lenSquare(v4) {
  return v4[0] * v4[0] + v4[1] * v4[1];
}
function scale$2(out2, v4, s) {
  out2[0] = v4[0] * s;
  out2[1] = v4[1] * s;
  return out2;
}
function normalize$4(out2, v4) {
  var d2 = len(v4);
  if (d2 === 0) {
    out2[0] = 0;
    out2[1] = 0;
  } else {
    out2[0] = v4[0] / d2;
    out2[1] = v4[1] / d2;
  }
  return out2;
}
function distance(v12, v22) {
  return Math.sqrt((v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]));
}
var dist$1 = distance;
function distanceSquare(v12, v22) {
  return (v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]);
}
var distSquare = distanceSquare;
function lerp$1(out2, v12, v22, t2) {
  out2[0] = v12[0] + t2 * (v22[0] - v12[0]);
  out2[1] = v12[1] + t2 * (v22[1] - v12[1]);
  return out2;
}
function applyTransform$1(out2, v4, m2) {
  var x2 = v4[0];
  var y2 = v4[1];
  out2[0] = m2[0] * x2 + m2[2] * y2 + m2[4];
  out2[1] = m2[1] * x2 + m2[3] * y2 + m2[5];
  return out2;
}
function min$1(out2, v12, v22) {
  out2[0] = Math.min(v12[0], v22[0]);
  out2[1] = Math.min(v12[1], v22[1]);
  return out2;
}
function max$1(out2, v12, v22) {
  out2[0] = Math.max(v12[0], v22[0]);
  out2[1] = Math.max(v12[1], v22[1]);
  return out2;
}
var Param = function() {
  function Param2(target, e2) {
    this.target = target;
    this.topTarget = e2 && e2.topTarget;
  }
  return Param2;
}();
var Draggable = function() {
  function Draggable2(handler) {
    this.handler = handler;
    handler.on("mousedown", this._dragStart, this);
    handler.on("mousemove", this._drag, this);
    handler.on("mouseup", this._dragEnd, this);
  }
  Draggable2.prototype._dragStart = function(e2) {
    var draggingTarget = e2.target;
    while (draggingTarget && !draggingTarget.draggable) {
      draggingTarget = draggingTarget.parent || draggingTarget.__hostTarget;
    }
    if (draggingTarget) {
      this._draggingTarget = draggingTarget;
      draggingTarget.dragging = true;
      this._x = e2.offsetX;
      this._y = e2.offsetY;
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragstart", e2.event);
    }
  };
  Draggable2.prototype._drag = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      var x2 = e2.offsetX;
      var y2 = e2.offsetY;
      var dx = x2 - this._x;
      var dy = y2 - this._y;
      this._x = x2;
      this._y = y2;
      draggingTarget.drift(dx, dy, e2);
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "drag", e2.event);
      var dropTarget = this.handler.findHover(x2, y2, draggingTarget).target;
      var lastDropTarget = this._dropTarget;
      this._dropTarget = dropTarget;
      if (draggingTarget !== dropTarget) {
        if (lastDropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(lastDropTarget, e2), "dragleave", e2.event);
        }
        if (dropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(dropTarget, e2), "dragenter", e2.event);
        }
      }
    }
  };
  Draggable2.prototype._dragEnd = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      draggingTarget.dragging = false;
    }
    this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragend", e2.event);
    if (this._dropTarget) {
      this.handler.dispatchToElement(new Param(this._dropTarget, e2), "drop", e2.event);
    }
    this._draggingTarget = null;
    this._dropTarget = null;
  };
  return Draggable2;
}();
var Draggable$1 = Draggable;
var Eventful = function() {
  function Eventful2(eventProcessors) {
    if (eventProcessors) {
      this._$eventProcessor = eventProcessors;
    }
  }
  Eventful2.prototype.on = function(event, query, handler, context) {
    if (!this._$handlers) {
      this._$handlers = {};
    }
    var _h = this._$handlers;
    if (typeof query === "function") {
      context = handler;
      handler = query;
      query = null;
    }
    if (!handler || !event) {
      return this;
    }
    var eventProcessor = this._$eventProcessor;
    if (query != null && eventProcessor && eventProcessor.normalizeQuery) {
      query = eventProcessor.normalizeQuery(query);
    }
    if (!_h[event]) {
      _h[event] = [];
    }
    for (var i = 0; i < _h[event].length; i++) {
      if (_h[event][i].h === handler) {
        return this;
      }
    }
    var wrap = {
      h: handler,
      query,
      ctx: context || this,
      callAtLast: handler.zrEventfulCallAtLast
    };
    var lastIndex = _h[event].length - 1;
    var lastWrap = _h[event][lastIndex];
    lastWrap && lastWrap.callAtLast ? _h[event].splice(lastIndex, 0, wrap) : _h[event].push(wrap);
    return this;
  };
  Eventful2.prototype.isSilent = function(eventName) {
    var _h = this._$handlers;
    return !_h || !_h[eventName] || !_h[eventName].length;
  };
  Eventful2.prototype.off = function(eventType, handler) {
    var _h = this._$handlers;
    if (!_h) {
      return this;
    }
    if (!eventType) {
      this._$handlers = {};
      return this;
    }
    if (handler) {
      if (_h[eventType]) {
        var newList = [];
        for (var i = 0, l2 = _h[eventType].length; i < l2; i++) {
          if (_h[eventType][i].h !== handler) {
            newList.push(_h[eventType][i]);
          }
        }
        _h[eventType] = newList;
      }
      if (_h[eventType] && _h[eventType].length === 0) {
        delete _h[eventType];
      }
    } else {
      delete _h[eventType];
    }
    return this;
  };
  Eventful2.prototype.trigger = function(eventType) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[eventType];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(eventType, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(hItem.ctx);
            break;
          case 1:
            hItem.h.call(hItem.ctx, args[0]);
            break;
          case 2:
            hItem.h.call(hItem.ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(hItem.ctx, args);
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(eventType);
    return this;
  };
  Eventful2.prototype.triggerWithContext = function(type4) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[type4];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var ctx = args[argLen - 1];
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(type4, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(ctx);
            break;
          case 1:
            hItem.h.call(ctx, args[0]);
            break;
          case 2:
            hItem.h.call(ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(ctx, args.slice(1, argLen - 1));
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(type4);
    return this;
  };
  return Eventful2;
}();
var Eventful$1 = Eventful;
var LN2 = Math.log(2);
function determinant(rows, rank, rowStart, rowMask, colMask, detCache) {
  var cacheKey = rowMask + "-" + colMask;
  var fullRank = rows.length;
  if (detCache.hasOwnProperty(cacheKey)) {
    return detCache[cacheKey];
  }
  if (rank === 1) {
    var colStart = Math.round(Math.log((1 << fullRank) - 1 & ~colMask) / LN2);
    return rows[rowStart][colStart];
  }
  var subRowMask = rowMask | 1 << rowStart;
  var subRowStart = rowStart + 1;
  while (rowMask & 1 << subRowStart) {
    subRowStart++;
  }
  var sum2 = 0;
  for (var j = 0, colLocalIdx = 0; j < fullRank; j++) {
    var colTag = 1 << j;
    if (!(colTag & colMask)) {
      sum2 += (colLocalIdx % 2 ? -1 : 1) * rows[rowStart][j] * determinant(rows, rank - 1, subRowStart, subRowMask, colMask | colTag, detCache);
      colLocalIdx++;
    }
  }
  detCache[cacheKey] = sum2;
  return sum2;
}
function buildTransformer(src, dest) {
  var mA = [
    [src[0], src[1], 1, 0, 0, 0, -dest[0] * src[0], -dest[0] * src[1]],
    [0, 0, 0, src[0], src[1], 1, -dest[1] * src[0], -dest[1] * src[1]],
    [src[2], src[3], 1, 0, 0, 0, -dest[2] * src[2], -dest[2] * src[3]],
    [0, 0, 0, src[2], src[3], 1, -dest[3] * src[2], -dest[3] * src[3]],
    [src[4], src[5], 1, 0, 0, 0, -dest[4] * src[4], -dest[4] * src[5]],
    [0, 0, 0, src[4], src[5], 1, -dest[5] * src[4], -dest[5] * src[5]],
    [src[6], src[7], 1, 0, 0, 0, -dest[6] * src[6], -dest[6] * src[7]],
    [0, 0, 0, src[6], src[7], 1, -dest[7] * src[6], -dest[7] * src[7]]
  ];
  var detCache = {};
  var det = determinant(mA, 8, 0, 0, 0, detCache);
  if (det === 0) {
    return;
  }
  var vh = [];
  for (var i = 0; i < 8; i++) {
    for (var j = 0; j < 8; j++) {
      vh[j] == null && (vh[j] = 0);
      vh[j] += ((i + j) % 2 ? -1 : 1) * determinant(mA, 7, i === 0 ? 1 : 0, 1 << i, 1 << j, detCache) / det * dest[i];
    }
  }
  return function(out2, srcPointX, srcPointY) {
    var pk = srcPointX * vh[6] + srcPointY * vh[7] + 1;
    out2[0] = (srcPointX * vh[0] + srcPointY * vh[1] + vh[2]) / pk;
    out2[1] = (srcPointX * vh[3] + srcPointY * vh[4] + vh[5]) / pk;
  };
}
var EVENT_SAVED_PROP = "___zrEVENTSAVED";
var _calcOut$1 = [];
function transformLocalCoord(out2, elFrom, elTarget, inX, inY) {
  return transformCoordWithViewport(_calcOut$1, elFrom, inX, inY, true) && transformCoordWithViewport(out2, elTarget, _calcOut$1[0], _calcOut$1[1]);
}
function transformCoordWithViewport(out2, el, inX, inY, inverse) {
  if (el.getBoundingClientRect && env$1.domSupported && !isCanvasEl(el)) {
    var saved = el[EVENT_SAVED_PROP] || (el[EVENT_SAVED_PROP] = {});
    var markers = prepareCoordMarkers(el, saved);
    var transformer = preparePointerTransformer(markers, saved, inverse);
    if (transformer) {
      transformer(out2, inX, inY);
      return true;
    }
  }
  return false;
}
function prepareCoordMarkers(el, saved) {
  var markers = saved.markers;
  if (markers) {
    return markers;
  }
  markers = saved.markers = [];
  var propLR = ["left", "right"];
  var propTB = ["top", "bottom"];
  for (var i = 0; i < 4; i++) {
    var marker = document.createElement("div");
    var stl = marker.style;
    var idxLR = i % 2;
    var idxTB = (i >> 1) % 2;
    stl.cssText = [
      "position: absolute",
      "visibility: hidden",
      "padding: 0",
      "margin: 0",
      "border-width: 0",
      "user-select: none",
      "width:0",
      "height:0",
      propLR[idxLR] + ":0",
      propTB[idxTB] + ":0",
      propLR[1 - idxLR] + ":auto",
      propTB[1 - idxTB] + ":auto",
      ""
    ].join("!important;");
    el.appendChild(marker);
    markers.push(marker);
  }
  return markers;
}
function preparePointerTransformer(markers, saved, inverse) {
  var transformerName = inverse ? "invTrans" : "trans";
  var transformer = saved[transformerName];
  var oldSrcCoords = saved.srcCoords;
  var srcCoords = [];
  var destCoords = [];
  var oldCoordTheSame = true;
  for (var i = 0; i < 4; i++) {
    var rect = markers[i].getBoundingClientRect();
    var ii = 2 * i;
    var x2 = rect.left;
    var y2 = rect.top;
    srcCoords.push(x2, y2);
    oldCoordTheSame = oldCoordTheSame && oldSrcCoords && x2 === oldSrcCoords[ii] && y2 === oldSrcCoords[ii + 1];
    destCoords.push(markers[i].offsetLeft, markers[i].offsetTop);
  }
  return oldCoordTheSame && transformer ? transformer : (saved.srcCoords = srcCoords, saved[transformerName] = inverse ? buildTransformer(destCoords, srcCoords) : buildTransformer(srcCoords, destCoords));
}
function isCanvasEl(el) {
  return el.nodeName.toUpperCase() === "CANVAS";
}
var MOUSE_EVENT_REG = /^(?:mouse|pointer|contextmenu|drag|drop)|click/;
var _calcOut = [];
var firefoxNotSupportOffsetXY = env$1.browser.firefox && +env$1.browser.version.split(".")[0] < 39;
function clientToLocal(el, e2, out2, calculate) {
  out2 = out2 || {};
  if (calculate) {
    calculateZrXY(el, e2, out2);
  } else if (firefoxNotSupportOffsetXY && e2.layerX != null && e2.layerX !== e2.offsetX) {
    out2.zrX = e2.layerX;
    out2.zrY = e2.layerY;
  } else if (e2.offsetX != null) {
    out2.zrX = e2.offsetX;
    out2.zrY = e2.offsetY;
  } else {
    calculateZrXY(el, e2, out2);
  }
  return out2;
}
function calculateZrXY(el, e2, out2) {
  if (env$1.domSupported && el.getBoundingClientRect) {
    var ex = e2.clientX;
    var ey = e2.clientY;
    if (isCanvasEl(el)) {
      var box2 = el.getBoundingClientRect();
      out2.zrX = ex - box2.left;
      out2.zrY = ey - box2.top;
      return;
    } else {
      if (transformCoordWithViewport(_calcOut, el, ex, ey)) {
        out2.zrX = _calcOut[0];
        out2.zrY = _calcOut[1];
        return;
      }
    }
  }
  out2.zrX = out2.zrY = 0;
}
function getNativeEvent(e2) {
  return e2 || window.event;
}
function normalizeEvent(el, e2, calculate) {
  e2 = getNativeEvent(e2);
  if (e2.zrX != null) {
    return e2;
  }
  var eventType = e2.type;
  var isTouch = eventType && eventType.indexOf("touch") >= 0;
  if (!isTouch) {
    clientToLocal(el, e2, e2, calculate);
    var wheelDelta = getWheelDeltaMayPolyfill(e2);
    e2.zrDelta = wheelDelta ? wheelDelta / 120 : -(e2.detail || 0) / 3;
  } else {
    var touch = eventType !== "touchend" ? e2.targetTouches[0] : e2.changedTouches[0];
    touch && clientToLocal(el, touch, e2, calculate);
  }
  var button = e2.button;
  if (e2.which == null && button !== void 0 && MOUSE_EVENT_REG.test(e2.type)) {
    e2.which = button & 1 ? 1 : button & 2 ? 3 : button & 4 ? 2 : 0;
  }
  return e2;
}
function getWheelDeltaMayPolyfill(e2) {
  var rawWheelDelta = e2.wheelDelta;
  if (rawWheelDelta) {
    return rawWheelDelta;
  }
  var deltaX = e2.deltaX;
  var deltaY = e2.deltaY;
  if (deltaX == null || deltaY == null) {
    return rawWheelDelta;
  }
  var delta = deltaY !== 0 ? Math.abs(deltaY) : Math.abs(deltaX);
  var sign = deltaY > 0 ? -1 : deltaY < 0 ? 1 : deltaX > 0 ? -1 : 1;
  return 3 * delta * sign;
}
function addEventListener(el, name, handler, opt) {
  el.addEventListener(name, handler, opt);
}
function removeEventListener(el, name, handler, opt) {
  el.removeEventListener(name, handler, opt);
}
var stop = function(e2) {
  e2.preventDefault();
  e2.stopPropagation();
  e2.cancelBubble = true;
};
function isMiddleOrRightButtonOnMouseUpDown(e2) {
  return e2.which === 2 || e2.which === 3;
}
var GestureMgr = function() {
  function GestureMgr2() {
    this._track = [];
  }
  GestureMgr2.prototype.recognize = function(event, target, root2) {
    this._doTrack(event, target, root2);
    return this._recognize(event);
  };
  GestureMgr2.prototype.clear = function() {
    this._track.length = 0;
    return this;
  };
  GestureMgr2.prototype._doTrack = function(event, target, root2) {
    var touches = event.touches;
    if (!touches) {
      return;
    }
    var trackItem = {
      points: [],
      touches: [],
      target,
      event
    };
    for (var i = 0, len2 = touches.length; i < len2; i++) {
      var touch = touches[i];
      var pos = clientToLocal(root2, touch, {});
      trackItem.points.push([pos.zrX, pos.zrY]);
      trackItem.touches.push(touch);
    }
    this._track.push(trackItem);
  };
  GestureMgr2.prototype._recognize = function(event) {
    for (var eventName in recognizers) {
      if (recognizers.hasOwnProperty(eventName)) {
        var gestureInfo = recognizers[eventName](this._track, event);
        if (gestureInfo) {
          return gestureInfo;
        }
      }
    }
  };
  return GestureMgr2;
}();
function dist(pointPair) {
  var dx = pointPair[1][0] - pointPair[0][0];
  var dy = pointPair[1][1] - pointPair[0][1];
  return Math.sqrt(dx * dx + dy * dy);
}
function center$1(pointPair) {
  return [
    (pointPair[0][0] + pointPair[1][0]) / 2,
    (pointPair[0][1] + pointPair[1][1]) / 2
  ];
}
var recognizers = {
  pinch: function(tracks, event) {
    var trackLen = tracks.length;
    if (!trackLen) {
      return;
    }
    var pinchEnd = (tracks[trackLen - 1] || {}).points;
    var pinchPre = (tracks[trackLen - 2] || {}).points || pinchEnd;
    if (pinchPre && pinchPre.length > 1 && pinchEnd && pinchEnd.length > 1) {
      var pinchScale = dist(pinchEnd) / dist(pinchPre);
      !isFinite(pinchScale) && (pinchScale = 1);
      event.pinchScale = pinchScale;
      var pinchCenter = center$1(pinchEnd);
      event.pinchX = pinchCenter[0];
      event.pinchY = pinchCenter[1];
      return {
        type: "pinch",
        target: tracks[0].target,
        event
      };
    }
  }
};
var SILENT = "silent";
function makeEventPacket(eveType, targetInfo, event) {
  return {
    type: eveType,
    event,
    target: targetInfo.target,
    topTarget: targetInfo.topTarget,
    cancelBubble: false,
    offsetX: event.zrX,
    offsetY: event.zrY,
    gestureEvent: event.gestureEvent,
    pinchX: event.pinchX,
    pinchY: event.pinchY,
    pinchScale: event.pinchScale,
    wheelDelta: event.zrDelta,
    zrByTouch: event.zrByTouch,
    which: event.which,
    stop: stopEvent
  };
}
function stopEvent() {
  stop(this.event);
}
var EmptyProxy = function(_super) {
  __extends(EmptyProxy2, _super);
  function EmptyProxy2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.handler = null;
    return _this;
  }
  EmptyProxy2.prototype.dispose = function() {
  };
  EmptyProxy2.prototype.setCursor = function() {
  };
  return EmptyProxy2;
}(Eventful$1);
var HoveredResult = function() {
  function HoveredResult2(x2, y2) {
    this.x = x2;
    this.y = y2;
  }
  return HoveredResult2;
}();
var handlerNames = [
  "click",
  "dblclick",
  "mousewheel",
  "mouseout",
  "mouseup",
  "mousedown",
  "mousemove",
  "contextmenu"
];
var Handler = function(_super) {
  __extends(Handler2, _super);
  function Handler2(storage2, painter, proxy, painterRoot) {
    var _this = _super.call(this) || this;
    _this._hovered = new HoveredResult(0, 0);
    _this.storage = storage2;
    _this.painter = painter;
    _this.painterRoot = painterRoot;
    proxy = proxy || new EmptyProxy();
    _this.proxy = null;
    _this.setHandlerProxy(proxy);
    _this._draggingMgr = new Draggable$1(_this);
    return _this;
  }
  Handler2.prototype.setHandlerProxy = function(proxy) {
    if (this.proxy) {
      this.proxy.dispose();
    }
    if (proxy) {
      each$f(handlerNames, function(name) {
        proxy.on && proxy.on(name, this[name], this);
      }, this);
      proxy.handler = this;
    }
    this.proxy = proxy;
  };
  Handler2.prototype.mousemove = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var lastHovered = this._hovered;
    var lastHoveredTarget = lastHovered.target;
    if (lastHoveredTarget && !lastHoveredTarget.__zr) {
      lastHovered = this.findHover(lastHovered.x, lastHovered.y);
      lastHoveredTarget = lastHovered.target;
    }
    var hovered = this._hovered = isOutside ? new HoveredResult(x2, y2) : this.findHover(x2, y2);
    var hoveredTarget = hovered.target;
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(hoveredTarget ? hoveredTarget.cursor : "default");
    if (lastHoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(lastHovered, "mouseout", event);
    }
    this.dispatchToElement(hovered, "mousemove", event);
    if (hoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(hovered, "mouseover", event);
    }
  };
  Handler2.prototype.mouseout = function(event) {
    var eventControl = event.zrEventControl;
    if (eventControl !== "only_globalout") {
      this.dispatchToElement(this._hovered, "mouseout", event);
    }
    if (eventControl !== "no_globalout") {
      this.trigger("globalout", { type: "globalout", event });
    }
  };
  Handler2.prototype.resize = function() {
    this._hovered = new HoveredResult(0, 0);
  };
  Handler2.prototype.dispatch = function(eventName, eventArgs) {
    var handler = this[eventName];
    handler && handler.call(this, eventArgs);
  };
  Handler2.prototype.dispose = function() {
    this.proxy.dispose();
    this.storage = null;
    this.proxy = null;
    this.painter = null;
  };
  Handler2.prototype.setCursorStyle = function(cursorStyle) {
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(cursorStyle);
  };
  Handler2.prototype.dispatchToElement = function(targetInfo, eventName, event) {
    targetInfo = targetInfo || {};
    var el = targetInfo.target;
    if (el && el.silent) {
      return;
    }
    var eventKey = "on" + eventName;
    var eventPacket = makeEventPacket(eventName, targetInfo, event);
    while (el) {
      el[eventKey] && (eventPacket.cancelBubble = !!el[eventKey].call(el, eventPacket));
      el.trigger(eventName, eventPacket);
      el = el.__hostTarget ? el.__hostTarget : el.parent;
      if (eventPacket.cancelBubble) {
        break;
      }
    }
    if (!eventPacket.cancelBubble) {
      this.trigger(eventName, eventPacket);
      if (this.painter && this.painter.eachOtherLayer) {
        this.painter.eachOtherLayer(function(layer) {
          if (typeof layer[eventKey] === "function") {
            layer[eventKey].call(layer, eventPacket);
          }
          if (layer.trigger) {
            layer.trigger(eventName, eventPacket);
          }
        });
      }
    }
  };
  Handler2.prototype.findHover = function(x2, y2, exclude) {
    var list = this.storage.getDisplayList();
    var out2 = new HoveredResult(x2, y2);
    for (var i = list.length - 1; i >= 0; i--) {
      var hoverCheckResult = void 0;
      if (list[i] !== exclude && !list[i].ignore && (hoverCheckResult = isHover(list[i], x2, y2))) {
        !out2.topTarget && (out2.topTarget = list[i]);
        if (hoverCheckResult !== SILENT) {
          out2.target = list[i];
          break;
        }
      }
    }
    return out2;
  };
  Handler2.prototype.processGesture = function(event, stage) {
    if (!this._gestureMgr) {
      this._gestureMgr = new GestureMgr();
    }
    var gestureMgr = this._gestureMgr;
    stage === "start" && gestureMgr.clear();
    var gestureInfo = gestureMgr.recognize(event, this.findHover(event.zrX, event.zrY, null).target, this.proxy.dom);
    stage === "end" && gestureMgr.clear();
    if (gestureInfo) {
      var type4 = gestureInfo.type;
      event.gestureEvent = type4;
      var res = new HoveredResult();
      res.target = gestureInfo.target;
      this.dispatchToElement(res, type4, gestureInfo.event);
    }
  };
  return Handler2;
}(Eventful$1);
each$f(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(name) {
  Handler.prototype[name] = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var hovered;
    var hoveredTarget;
    if (name !== "mouseup" || !isOutside) {
      hovered = this.findHover(x2, y2);
      hoveredTarget = hovered.target;
    }
    if (name === "mousedown") {
      this._downEl = hoveredTarget;
      this._downPoint = [event.zrX, event.zrY];
      this._upEl = hoveredTarget;
    } else if (name === "mouseup") {
      this._upEl = hoveredTarget;
    } else if (name === "click") {
      if (this._downEl !== this._upEl || !this._downPoint || dist$1(this._downPoint, [event.zrX, event.zrY]) > 4) {
        return;
      }
      this._downPoint = null;
    }
    this.dispatchToElement(hovered, name, event);
  };
});
function isHover(displayable, x2, y2) {
  if (displayable[displayable.rectHover ? "rectContain" : "contain"](x2, y2)) {
    var el = displayable;
    var isSilent = void 0;
    var ignoreClip = false;
    while (el) {
      if (el.ignoreClip) {
        ignoreClip = true;
      }
      if (!ignoreClip) {
        var clipPath = el.getClipPath();
        if (clipPath && !clipPath.contain(x2, y2)) {
          return false;
        }
        if (el.silent) {
          isSilent = true;
        }
      }
      var hostEl = el.__hostTarget;
      el = hostEl ? hostEl : el.parent;
    }
    return isSilent ? SILENT : true;
  }
  return false;
}
function isOutsideBoundary(handlerInstance, x2, y2) {
  var painter = handlerInstance.painter;
  return x2 < 0 || x2 > painter.getWidth() || y2 < 0 || y2 > painter.getHeight();
}
var Handler$1 = Handler;
var DEFAULT_MIN_MERGE = 32;
var DEFAULT_MIN_GALLOPING = 7;
function minRunLength(n2) {
  var r2 = 0;
  while (n2 >= DEFAULT_MIN_MERGE) {
    r2 |= n2 & 1;
    n2 >>= 1;
  }
  return n2 + r2;
}
function makeAscendingRun(array4, lo, hi, compare2) {
  var runHi = lo + 1;
  if (runHi === hi) {
    return 1;
  }
  if (compare2(array4[runHi++], array4[lo]) < 0) {
    while (runHi < hi && compare2(array4[runHi], array4[runHi - 1]) < 0) {
      runHi++;
    }
    reverseRun(array4, lo, runHi);
  } else {
    while (runHi < hi && compare2(array4[runHi], array4[runHi - 1]) >= 0) {
      runHi++;
    }
  }
  return runHi - lo;
}
function reverseRun(array4, lo, hi) {
  hi--;
  while (lo < hi) {
    var t2 = array4[lo];
    array4[lo++] = array4[hi];
    array4[hi--] = t2;
  }
}
function binaryInsertionSort(array4, lo, hi, start2, compare2) {
  if (start2 === lo) {
    start2++;
  }
  for (; start2 < hi; start2++) {
    var pivot = array4[start2];
    var left = lo;
    var right = start2;
    var mid;
    while (left < right) {
      mid = left + right >>> 1;
      if (compare2(pivot, array4[mid]) < 0) {
        right = mid;
      } else {
        left = mid + 1;
      }
    }
    var n2 = start2 - left;
    switch (n2) {
      case 3:
        array4[left + 3] = array4[left + 2];
      case 2:
        array4[left + 2] = array4[left + 1];
      case 1:
        array4[left + 1] = array4[left];
        break;
      default:
        while (n2 > 0) {
          array4[left + n2] = array4[left + n2 - 1];
          n2--;
        }
    }
    array4[left] = pivot;
  }
}
function gallopLeft(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset = 1;
  if (compare2(value, array4[start2 + hint]) > 0) {
    maxOffset = length - hint;
    while (offset < maxOffset && compare2(value, array4[start2 + hint + offset]) > 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    lastOffset += hint;
    offset += hint;
  } else {
    maxOffset = hint + 1;
    while (offset < maxOffset && compare2(value, array4[start2 + hint - offset]) <= 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset;
    offset = hint - tmp;
  }
  lastOffset++;
  while (lastOffset < offset) {
    var m2 = lastOffset + (offset - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) > 0) {
      lastOffset = m2 + 1;
    } else {
      offset = m2;
    }
  }
  return offset;
}
function gallopRight(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset = 1;
  if (compare2(value, array4[start2 + hint]) < 0) {
    maxOffset = hint + 1;
    while (offset < maxOffset && compare2(value, array4[start2 + hint - offset]) < 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset;
    offset = hint - tmp;
  } else {
    maxOffset = length - hint;
    while (offset < maxOffset && compare2(value, array4[start2 + hint + offset]) >= 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    lastOffset += hint;
    offset += hint;
  }
  lastOffset++;
  while (lastOffset < offset) {
    var m2 = lastOffset + (offset - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) < 0) {
      offset = m2;
    } else {
      lastOffset = m2 + 1;
    }
  }
  return offset;
}
function TimSort(array4, compare2) {
  var minGallop = DEFAULT_MIN_GALLOPING;
  var runStart;
  var runLength;
  var stackSize = 0;
  var tmp = [];
  runStart = [];
  runLength = [];
  function pushRun(_runStart, _runLength) {
    runStart[stackSize] = _runStart;
    runLength[stackSize] = _runLength;
    stackSize += 1;
  }
  function mergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 >= 1 && runLength[n2 - 1] <= runLength[n2] + runLength[n2 + 1] || n2 >= 2 && runLength[n2 - 2] <= runLength[n2] + runLength[n2 - 1]) {
        if (runLength[n2 - 1] < runLength[n2 + 1]) {
          n2--;
        }
      } else if (runLength[n2] > runLength[n2 + 1]) {
        break;
      }
      mergeAt(n2);
    }
  }
  function forceMergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 > 0 && runLength[n2 - 1] < runLength[n2 + 1]) {
        n2--;
      }
      mergeAt(n2);
    }
  }
  function mergeAt(i) {
    var start1 = runStart[i];
    var length1 = runLength[i];
    var start2 = runStart[i + 1];
    var length2 = runLength[i + 1];
    runLength[i] = length1 + length2;
    if (i === stackSize - 3) {
      runStart[i + 1] = runStart[i + 2];
      runLength[i + 1] = runLength[i + 2];
    }
    stackSize--;
    var k2 = gallopRight(array4[start2], array4, start1, length1, 0, compare2);
    start1 += k2;
    length1 -= k2;
    if (length1 === 0) {
      return;
    }
    length2 = gallopLeft(array4[start1 + length1 - 1], array4, start2, length2, length2 - 1, compare2);
    if (length2 === 0) {
      return;
    }
    if (length1 <= length2) {
      mergeLow(start1, length1, start2, length2);
    } else {
      mergeHigh(start1, length1, start2, length2);
    }
  }
  function mergeLow(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length1; i++) {
      tmp[i] = array4[start1 + i];
    }
    var cursor1 = 0;
    var cursor2 = start2;
    var dest = start1;
    array4[dest++] = array4[cursor2++];
    if (--length2 === 0) {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
      return;
    }
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
      return;
    }
    var _minGallop = minGallop;
    var count1;
    var count2;
    var exit;
    while (1) {
      count1 = 0;
      count2 = 0;
      exit = false;
      do {
        if (compare2(array4[cursor2], tmp[cursor1]) < 0) {
          array4[dest++] = array4[cursor2++];
          count2++;
          count1 = 0;
          if (--length2 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest++] = tmp[cursor1++];
          count1++;
          count2 = 0;
          if (--length1 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = gallopRight(array4[cursor2], tmp, cursor1, length1, 0, compare2);
        if (count1 !== 0) {
          for (i = 0; i < count1; i++) {
            array4[dest + i] = tmp[cursor1 + i];
          }
          dest += count1;
          cursor1 += count1;
          length1 -= count1;
          if (length1 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest++] = array4[cursor2++];
        if (--length2 === 0) {
          exit = true;
          break;
        }
        count2 = gallopLeft(tmp[cursor1], array4, cursor2, length2, 0, compare2);
        if (count2 !== 0) {
          for (i = 0; i < count2; i++) {
            array4[dest + i] = array4[cursor2 + i];
          }
          dest += count2;
          cursor2 += count2;
          length2 -= count2;
          if (length2 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest++] = tmp[cursor1++];
        if (--length1 === 1) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    minGallop < 1 && (minGallop = 1);
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
    } else if (length1 === 0) {
      throw new Error();
    } else {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
    }
  }
  function mergeHigh(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length2; i++) {
      tmp[i] = array4[start2 + i];
    }
    var cursor1 = start1 + length1 - 1;
    var cursor2 = length2 - 1;
    var dest = start2 + length2 - 1;
    var customCursor = 0;
    var customDest = 0;
    array4[dest--] = array4[cursor1--];
    if (--length1 === 0) {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
      return;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
      return;
    }
    var _minGallop = minGallop;
    while (true) {
      var count1 = 0;
      var count2 = 0;
      var exit = false;
      do {
        if (compare2(tmp[cursor2], array4[cursor1]) < 0) {
          array4[dest--] = array4[cursor1--];
          count1++;
          count2 = 0;
          if (--length1 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest--] = tmp[cursor2--];
          count2++;
          count1 = 0;
          if (--length2 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = length1 - gallopRight(tmp[cursor2], array4, start1, length1, length1 - 1, compare2);
        if (count1 !== 0) {
          dest -= count1;
          cursor1 -= count1;
          length1 -= count1;
          customDest = dest + 1;
          customCursor = cursor1 + 1;
          for (i = count1 - 1; i >= 0; i--) {
            array4[customDest + i] = array4[customCursor + i];
          }
          if (length1 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest--] = tmp[cursor2--];
        if (--length2 === 1) {
          exit = true;
          break;
        }
        count2 = length2 - gallopLeft(array4[cursor1], tmp, 0, length2, length2 - 1, compare2);
        if (count2 !== 0) {
          dest -= count2;
          cursor2 -= count2;
          length2 -= count2;
          customDest = dest + 1;
          customCursor = cursor2 + 1;
          for (i = 0; i < count2; i++) {
            array4[customDest + i] = tmp[customCursor + i];
          }
          if (length2 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest--] = array4[cursor1--];
        if (--length1 === 0) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    if (minGallop < 1) {
      minGallop = 1;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
    } else if (length2 === 0) {
      throw new Error();
    } else {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
    }
  }
  return {
    mergeRuns,
    forceMergeRuns,
    pushRun
  };
}
function sort$2(array4, compare2, lo, hi) {
  if (!lo) {
    lo = 0;
  }
  if (!hi) {
    hi = array4.length;
  }
  var remaining = hi - lo;
  if (remaining < 2) {
    return;
  }
  var runLength = 0;
  if (remaining < DEFAULT_MIN_MERGE) {
    runLength = makeAscendingRun(array4, lo, hi, compare2);
    binaryInsertionSort(array4, lo, hi, lo + runLength, compare2);
    return;
  }
  var ts = TimSort(array4, compare2);
  var minRun = minRunLength(remaining);
  do {
    runLength = makeAscendingRun(array4, lo, hi, compare2);
    if (runLength < minRun) {
      var force = remaining;
      if (force > minRun) {
        force = minRun;
      }
      binaryInsertionSort(array4, lo, lo + force, lo + runLength, compare2);
      runLength = force;
    }
    ts.pushRun(lo, runLength);
    ts.mergeRuns();
    remaining -= runLength;
    lo += runLength;
  } while (remaining !== 0);
  ts.forceMergeRuns();
}
var REDRAW_BIT = 1;
var STYLE_CHANGED_BIT = 2;
var SHAPE_CHANGED_BIT = 4;
var invalidZErrorLogged = false;
function logInvalidZError() {
  if (invalidZErrorLogged) {
    return;
  }
  invalidZErrorLogged = true;
  console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors");
}
function shapeCompareFunc(a, b2) {
  if (a.zlevel === b2.zlevel) {
    if (a.z === b2.z) {
      return a.z2 - b2.z2;
    }
    return a.z - b2.z;
  }
  return a.zlevel - b2.zlevel;
}
var Storage = function() {
  function Storage2() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    this.displayableSortFunc = shapeCompareFunc;
  }
  Storage2.prototype.traverse = function(cb, context) {
    for (var i = 0; i < this._roots.length; i++) {
      this._roots[i].traverse(cb, context);
    }
  };
  Storage2.prototype.getDisplayList = function(update, includeIgnore) {
    includeIgnore = includeIgnore || false;
    var displayList = this._displayList;
    if (update || !displayList.length) {
      this.updateDisplayList(includeIgnore);
    }
    return displayList;
  };
  Storage2.prototype.updateDisplayList = function(includeIgnore) {
    this._displayListLen = 0;
    var roots2 = this._roots;
    var displayList = this._displayList;
    for (var i = 0, len2 = roots2.length; i < len2; i++) {
      this._updateAndAddDisplayable(roots2[i], null, includeIgnore);
    }
    displayList.length = this._displayListLen;
    sort$2(displayList, shapeCompareFunc);
  };
  Storage2.prototype._updateAndAddDisplayable = function(el, clipPaths, includeIgnore) {
    if (el.ignore && !includeIgnore) {
      return;
    }
    el.beforeUpdate();
    el.update();
    el.afterUpdate();
    var userSetClipPath = el.getClipPath();
    if (el.ignoreClip) {
      clipPaths = null;
    } else if (userSetClipPath) {
      if (clipPaths) {
        clipPaths = clipPaths.slice();
      } else {
        clipPaths = [];
      }
      var currentClipPath = userSetClipPath;
      var parentClipPath = el;
      while (currentClipPath) {
        currentClipPath.parent = parentClipPath;
        currentClipPath.updateTransform();
        clipPaths.push(currentClipPath);
        parentClipPath = currentClipPath;
        currentClipPath = currentClipPath.getClipPath();
      }
    }
    if (el.childrenRef) {
      var children = el.childrenRef();
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if (el.__dirty) {
          child.__dirty |= REDRAW_BIT;
        }
        this._updateAndAddDisplayable(child, clipPaths, includeIgnore);
      }
      el.__dirty = 0;
    } else {
      var disp = el;
      if (clipPaths && clipPaths.length) {
        disp.__clipPaths = clipPaths;
      } else if (disp.__clipPaths && disp.__clipPaths.length > 0) {
        disp.__clipPaths = [];
      }
      if (isNaN(disp.z)) {
        logInvalidZError();
        disp.z = 0;
      }
      if (isNaN(disp.z2)) {
        logInvalidZError();
        disp.z2 = 0;
      }
      if (isNaN(disp.zlevel)) {
        logInvalidZError();
        disp.zlevel = 0;
      }
      this._displayList[this._displayListLen++] = disp;
    }
    var decalEl = el.getDecalElement && el.getDecalElement();
    if (decalEl) {
      this._updateAndAddDisplayable(decalEl, clipPaths, includeIgnore);
    }
    var textGuide = el.getTextGuideLine();
    if (textGuide) {
      this._updateAndAddDisplayable(textGuide, clipPaths, includeIgnore);
    }
    var textEl = el.getTextContent();
    if (textEl) {
      this._updateAndAddDisplayable(textEl, clipPaths, includeIgnore);
    }
  };
  Storage2.prototype.addRoot = function(el) {
    if (el.__zr && el.__zr.storage === this) {
      return;
    }
    this._roots.push(el);
  };
  Storage2.prototype.delRoot = function(el) {
    if (el instanceof Array) {
      for (var i = 0, l2 = el.length; i < l2; i++) {
        this.delRoot(el[i]);
      }
      return;
    }
    var idx = indexOf(this._roots, el);
    if (idx >= 0) {
      this._roots.splice(idx, 1);
    }
  };
  Storage2.prototype.delAllRoots = function() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    return;
  };
  Storage2.prototype.getRoots = function() {
    return this._roots;
  };
  Storage2.prototype.dispose = function() {
    this._displayList = null;
    this._roots = null;
  };
  return Storage2;
}();
var Storage$1 = Storage;
var requestAnimationFrame$1;
requestAnimationFrame$1 = env$1.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(func) {
  return setTimeout(func, 16);
};
var requestAnimationFrame$2 = requestAnimationFrame$1;
var easingFuncs = {
  linear: function(k2) {
    return k2;
  },
  quadraticIn: function(k2) {
    return k2 * k2;
  },
  quadraticOut: function(k2) {
    return k2 * (2 - k2);
  },
  quadraticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2;
    }
    return -0.5 * (--k2 * (k2 - 2) - 1);
  },
  cubicIn: function(k2) {
    return k2 * k2 * k2;
  },
  cubicOut: function(k2) {
    return --k2 * k2 * k2 + 1;
  },
  cubicInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 + 2);
  },
  quarticIn: function(k2) {
    return k2 * k2 * k2 * k2;
  },
  quarticOut: function(k2) {
    return 1 - --k2 * k2 * k2 * k2;
  },
  quarticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2;
    }
    return -0.5 * ((k2 -= 2) * k2 * k2 * k2 - 2);
  },
  quinticIn: function(k2) {
    return k2 * k2 * k2 * k2 * k2;
  },
  quinticOut: function(k2) {
    return --k2 * k2 * k2 * k2 * k2 + 1;
  },
  quinticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 * k2 * k2 + 2);
  },
  sinusoidalIn: function(k2) {
    return 1 - Math.cos(k2 * Math.PI / 2);
  },
  sinusoidalOut: function(k2) {
    return Math.sin(k2 * Math.PI / 2);
  },
  sinusoidalInOut: function(k2) {
    return 0.5 * (1 - Math.cos(Math.PI * k2));
  },
  exponentialIn: function(k2) {
    return k2 === 0 ? 0 : Math.pow(1024, k2 - 1);
  },
  exponentialOut: function(k2) {
    return k2 === 1 ? 1 : 1 - Math.pow(2, -10 * k2);
  },
  exponentialInOut: function(k2) {
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if ((k2 *= 2) < 1) {
      return 0.5 * Math.pow(1024, k2 - 1);
    }
    return 0.5 * (-Math.pow(2, -10 * (k2 - 1)) + 2);
  },
  circularIn: function(k2) {
    return 1 - Math.sqrt(1 - k2 * k2);
  },
  circularOut: function(k2) {
    return Math.sqrt(1 - --k2 * k2);
  },
  circularInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return -0.5 * (Math.sqrt(1 - k2 * k2) - 1);
    }
    return 0.5 * (Math.sqrt(1 - (k2 -= 2) * k2) + 1);
  },
  elasticIn: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return -(a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
  },
  elasticOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return a * Math.pow(2, -10 * k2) * Math.sin((k2 - s) * (2 * Math.PI) / p2) + 1;
  },
  elasticInOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    if ((k2 *= 2) < 1) {
      return -0.5 * (a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
    }
    return a * Math.pow(2, -10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2) * 0.5 + 1;
  },
  backIn: function(k2) {
    var s = 1.70158;
    return k2 * k2 * ((s + 1) * k2 - s);
  },
  backOut: function(k2) {
    var s = 1.70158;
    return --k2 * k2 * ((s + 1) * k2 + s) + 1;
  },
  backInOut: function(k2) {
    var s = 1.70158 * 1.525;
    if ((k2 *= 2) < 1) {
      return 0.5 * (k2 * k2 * ((s + 1) * k2 - s));
    }
    return 0.5 * ((k2 -= 2) * k2 * ((s + 1) * k2 + s) + 2);
  },
  bounceIn: function(k2) {
    return 1 - easingFuncs.bounceOut(1 - k2);
  },
  bounceOut: function(k2) {
    if (k2 < 1 / 2.75) {
      return 7.5625 * k2 * k2;
    } else if (k2 < 2 / 2.75) {
      return 7.5625 * (k2 -= 1.5 / 2.75) * k2 + 0.75;
    } else if (k2 < 2.5 / 2.75) {
      return 7.5625 * (k2 -= 2.25 / 2.75) * k2 + 0.9375;
    } else {
      return 7.5625 * (k2 -= 2.625 / 2.75) * k2 + 0.984375;
    }
  },
  bounceInOut: function(k2) {
    if (k2 < 0.5) {
      return easingFuncs.bounceIn(k2 * 2) * 0.5;
    }
    return easingFuncs.bounceOut(k2 * 2 - 1) * 0.5 + 0.5;
  }
};
var easingFuncs$1 = easingFuncs;
var mathPow$2 = Math.pow;
var mathSqrt$3 = Math.sqrt;
var EPSILON$4 = 1e-8;
var EPSILON_NUMERIC = 1e-4;
var THREE_SQRT = mathSqrt$3(3);
var ONE_THIRD = 1 / 3;
var _v0 = create$2();
var _v1 = create$2();
var _v2 = create$2();
function isAroundZero$1(val) {
  return val > -EPSILON$4 && val < EPSILON$4;
}
function isNotAroundZero$1(val) {
  return val > EPSILON$4 || val < -EPSILON$4;
}
function cubicAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return onet * onet * (onet * p0 + 3 * t2 * p1) + t2 * t2 * (t2 * p3 + 3 * onet * p2);
}
function cubicDerivativeAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return 3 * (((p1 - p0) * onet + 2 * (p2 - p1) * t2) * onet + (p3 - p2) * t2 * t2);
}
function cubicRootAt(p0, p1, p2, p3, val, roots2) {
  var a = p3 + 3 * (p1 - p2) - p0;
  var b2 = 3 * (p2 - p1 * 2 + p0);
  var c2 = 3 * (p1 - p0);
  var d2 = p0 - val;
  var A2 = b2 * b2 - 3 * a * c2;
  var B = b2 * c2 - 9 * a * d2;
  var C = c2 * c2 - 3 * b2 * d2;
  var n2 = 0;
  if (isAroundZero$1(A2) && isAroundZero$1(B)) {
    if (isAroundZero$1(b2)) {
      roots2[0] = 0;
    } else {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = B * B - 4 * A2 * C;
    if (isAroundZero$1(disc)) {
      var K = B / A2;
      var t1 = -b2 / a + K;
      var t2 = -K / 2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var Y1 = A2 * b2 + 1.5 * a * (-B + discSqrt);
      var Y2 = A2 * b2 + 1.5 * a * (-B - discSqrt);
      if (Y1 < 0) {
        Y1 = -mathPow$2(-Y1, ONE_THIRD);
      } else {
        Y1 = mathPow$2(Y1, ONE_THIRD);
      }
      if (Y2 < 0) {
        Y2 = -mathPow$2(-Y2, ONE_THIRD);
      } else {
        Y2 = mathPow$2(Y2, ONE_THIRD);
      }
      var t1 = (-b2 - (Y1 + Y2)) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else {
      var T = (2 * A2 * b2 - 3 * a * B) / (2 * mathSqrt$3(A2 * A2 * A2));
      var theta = Math.acos(T) / 3;
      var ASqrt = mathSqrt$3(A2);
      var tmp = Math.cos(theta);
      var t1 = (-b2 - 2 * ASqrt * tmp) / (3 * a);
      var t2 = (-b2 + ASqrt * (tmp + THREE_SQRT * Math.sin(theta))) / (3 * a);
      var t3 = (-b2 + ASqrt * (tmp - THREE_SQRT * Math.sin(theta))) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
      if (t3 >= 0 && t3 <= 1) {
        roots2[n2++] = t3;
      }
    }
  }
  return n2;
}
function cubicExtrema(p0, p1, p2, p3, extrema2) {
  var b2 = 6 * p2 - 12 * p1 + 6 * p0;
  var a = 9 * p1 + 3 * p3 - 3 * p0 - 9 * p2;
  var c2 = 3 * p1 - 3 * p0;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      extrema2[0] = -b2 / (2 * a);
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        extrema2[n2++] = t2;
      }
    }
  }
  return n2;
}
function cubicSubdivide(p0, p1, p2, p3, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p23 = (p3 - p2) * t2 + p2;
  var p012 = (p12 - p01) * t2 + p01;
  var p123 = (p23 - p12) * t2 + p12;
  var p0123 = (p123 - p012) * t2 + p012;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p0123;
  out2[4] = p0123;
  out2[5] = p123;
  out2[6] = p23;
  out2[7] = p3;
}
function cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  var prev;
  var next;
  var d1;
  var d22;
  _v0[0] = x4;
  _v0[1] = y4;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = cubicAt(x0, x1, x2, x3, _t);
    _v1[1] = cubicAt(y0, y1, y2, y3, _t);
    d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    prev = t2 - interval;
    next = t2 + interval;
    _v1[0] = cubicAt(x0, x1, x2, x3, prev);
    _v1[1] = cubicAt(y0, y1, y2, y3, prev);
    d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = cubicAt(x0, x1, x2, x3, next);
      _v2[1] = cubicAt(y0, y1, y2, y3, next);
      d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = cubicAt(x0, x1, x2, x3, t2);
    out2[1] = cubicAt(y0, y1, y2, y3, t2);
  }
  return mathSqrt$3(d2);
}
function cubicLength(x0, y0, x1, y1, x2, y2, x3, y3, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x4 = cubicAt(x0, x1, x2, x3, t2);
    var y4 = cubicAt(y0, y1, y2, y3, t2);
    var dx = x4 - px;
    var dy = y4 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x4;
    py = y4;
  }
  return d2;
}
function quadraticAt$1(p0, p1, p2, t2) {
  var onet = 1 - t2;
  return onet * (onet * p0 + 2 * t2 * p1) + t2 * t2 * p2;
}
function quadraticDerivativeAt(p0, p1, p2, t2) {
  return 2 * ((1 - t2) * (p1 - p0) + t2 * (p2 - p1));
}
function quadraticRootAt(p0, p1, p2, val, roots2) {
  var a = p0 - 2 * p1 + p2;
  var b2 = 2 * (p1 - p0);
  var c2 = p0 - val;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      var t1 = -b2 / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    }
  }
  return n2;
}
function quadraticExtremum(p0, p1, p2) {
  var divider = p0 + p2 - 2 * p1;
  if (divider === 0) {
    return 0.5;
  } else {
    return (p0 - p1) / divider;
  }
}
function quadraticSubdivide(p0, p1, p2, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p012 = (p12 - p01) * t2 + p01;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p012;
  out2[4] = p12;
  out2[5] = p2;
}
function quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  _v0[0] = x3;
  _v0[1] = y3;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = quadraticAt$1(x0, x1, x2, _t);
    _v1[1] = quadraticAt$1(y0, y1, y2, _t);
    var d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    var prev = t2 - interval;
    var next = t2 + interval;
    _v1[0] = quadraticAt$1(x0, x1, x2, prev);
    _v1[1] = quadraticAt$1(y0, y1, y2, prev);
    var d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = quadraticAt$1(x0, x1, x2, next);
      _v2[1] = quadraticAt$1(y0, y1, y2, next);
      var d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = quadraticAt$1(x0, x1, x2, t2);
    out2[1] = quadraticAt$1(y0, y1, y2, t2);
  }
  return mathSqrt$3(d2);
}
function quadraticLength(x0, y0, x1, y1, x2, y2, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x3 = quadraticAt$1(x0, x1, x2, t2);
    var y3 = quadraticAt$1(y0, y1, y2, t2);
    var dx = x3 - px;
    var dy = y3 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x3;
    py = y3;
  }
  return d2;
}
var regexp$1 = /cubic-bezier\(([0-9,\.e ]+)\)/;
function createCubicEasingFunc(cubicEasingStr) {
  var cubic = cubicEasingStr && regexp$1.exec(cubicEasingStr);
  if (cubic) {
    var points2 = cubic[1].split(",");
    var a_1 = +trim$1(points2[0]);
    var b_1 = +trim$1(points2[1]);
    var c_1 = +trim$1(points2[2]);
    var d_1 = +trim$1(points2[3]);
    if (isNaN(a_1 + b_1 + c_1 + d_1)) {
      return;
    }
    var roots_1 = [];
    return function(p2) {
      return p2 <= 0 ? 0 : p2 >= 1 ? 1 : cubicRootAt(0, a_1, c_1, 1, p2, roots_1) && cubicAt(0, b_1, d_1, 1, roots_1[0]);
    };
  }
}
var Clip = function() {
  function Clip2(opts) {
    this._inited = false;
    this._startTime = 0;
    this._pausedTime = 0;
    this._paused = false;
    this._life = opts.life || 1e3;
    this._delay = opts.delay || 0;
    this.loop = opts.loop || false;
    this.onframe = opts.onframe || noop;
    this.ondestroy = opts.ondestroy || noop;
    this.onrestart = opts.onrestart || noop;
    opts.easing && this.setEasing(opts.easing);
  }
  Clip2.prototype.step = function(globalTime, deltaTime) {
    if (!this._inited) {
      this._startTime = globalTime + this._delay;
      this._inited = true;
    }
    if (this._paused) {
      this._pausedTime += deltaTime;
      return;
    }
    var life = this._life;
    var elapsedTime = globalTime - this._startTime - this._pausedTime;
    var percent = elapsedTime / life;
    if (percent < 0) {
      percent = 0;
    }
    percent = Math.min(percent, 1);
    var easingFunc = this.easingFunc;
    var schedule = easingFunc ? easingFunc(percent) : percent;
    this.onframe(schedule);
    if (percent === 1) {
      if (this.loop) {
        var remainder = elapsedTime % life;
        this._startTime = globalTime - remainder;
        this._pausedTime = 0;
        this.onrestart();
      } else {
        return true;
      }
    }
    return false;
  };
  Clip2.prototype.pause = function() {
    this._paused = true;
  };
  Clip2.prototype.resume = function() {
    this._paused = false;
  };
  Clip2.prototype.setEasing = function(easing) {
    this.easing = easing;
    this.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
  };
  return Clip2;
}();
var Clip$1 = Clip;
var Entry = function() {
  function Entry2(val) {
    this.value = val;
  }
  return Entry2;
}();
var LinkedList = function() {
  function LinkedList2() {
    this._len = 0;
  }
  LinkedList2.prototype.insert = function(val) {
    var entry = new Entry(val);
    this.insertEntry(entry);
    return entry;
  };
  LinkedList2.prototype.insertEntry = function(entry) {
    if (!this.head) {
      this.head = this.tail = entry;
    } else {
      this.tail.next = entry;
      entry.prev = this.tail;
      entry.next = null;
      this.tail = entry;
    }
    this._len++;
  };
  LinkedList2.prototype.remove = function(entry) {
    var prev = entry.prev;
    var next = entry.next;
    if (prev) {
      prev.next = next;
    } else {
      this.head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this.tail = prev;
    }
    entry.next = entry.prev = null;
    this._len--;
  };
  LinkedList2.prototype.len = function() {
    return this._len;
  };
  LinkedList2.prototype.clear = function() {
    this.head = this.tail = null;
    this._len = 0;
  };
  return LinkedList2;
}();
var LRU = function() {
  function LRU2(maxSize) {
    this._list = new LinkedList();
    this._maxSize = 10;
    this._map = {};
    this._maxSize = maxSize;
  }
  LRU2.prototype.put = function(key, value) {
    var list = this._list;
    var map2 = this._map;
    var removed = null;
    if (map2[key] == null) {
      var len2 = list.len();
      var entry = this._lastRemovedEntry;
      if (len2 >= this._maxSize && len2 > 0) {
        var leastUsedEntry = list.head;
        list.remove(leastUsedEntry);
        delete map2[leastUsedEntry.key];
        removed = leastUsedEntry.value;
        this._lastRemovedEntry = leastUsedEntry;
      }
      if (entry) {
        entry.value = value;
      } else {
        entry = new Entry(value);
      }
      entry.key = key;
      list.insertEntry(entry);
      map2[key] = entry;
    }
    return removed;
  };
  LRU2.prototype.get = function(key) {
    var entry = this._map[key];
    var list = this._list;
    if (entry != null) {
      if (entry !== list.tail) {
        list.remove(entry);
        list.insertEntry(entry);
      }
      return entry.value;
    }
  };
  LRU2.prototype.clear = function() {
    this._list.clear();
    this._map = {};
  };
  LRU2.prototype.len = function() {
    return this._list.len();
  };
  return LRU2;
}();
var LRU$1 = LRU;
var kCSSColorTable = {
  "transparent": [0, 0, 0, 0],
  "aliceblue": [240, 248, 255, 1],
  "antiquewhite": [250, 235, 215, 1],
  "aqua": [0, 255, 255, 1],
  "aquamarine": [127, 255, 212, 1],
  "azure": [240, 255, 255, 1],
  "beige": [245, 245, 220, 1],
  "bisque": [255, 228, 196, 1],
  "black": [0, 0, 0, 1],
  "blanchedalmond": [255, 235, 205, 1],
  "blue": [0, 0, 255, 1],
  "blueviolet": [138, 43, 226, 1],
  "brown": [165, 42, 42, 1],
  "burlywood": [222, 184, 135, 1],
  "cadetblue": [95, 158, 160, 1],
  "chartreuse": [127, 255, 0, 1],
  "chocolate": [210, 105, 30, 1],
  "coral": [255, 127, 80, 1],
  "cornflowerblue": [100, 149, 237, 1],
  "cornsilk": [255, 248, 220, 1],
  "crimson": [220, 20, 60, 1],
  "cyan": [0, 255, 255, 1],
  "darkblue": [0, 0, 139, 1],
  "darkcyan": [0, 139, 139, 1],
  "darkgoldenrod": [184, 134, 11, 1],
  "darkgray": [169, 169, 169, 1],
  "darkgreen": [0, 100, 0, 1],
  "darkgrey": [169, 169, 169, 1],
  "darkkhaki": [189, 183, 107, 1],
  "darkmagenta": [139, 0, 139, 1],
  "darkolivegreen": [85, 107, 47, 1],
  "darkorange": [255, 140, 0, 1],
  "darkorchid": [153, 50, 204, 1],
  "darkred": [139, 0, 0, 1],
  "darksalmon": [233, 150, 122, 1],
  "darkseagreen": [143, 188, 143, 1],
  "darkslateblue": [72, 61, 139, 1],
  "darkslategray": [47, 79, 79, 1],
  "darkslategrey": [47, 79, 79, 1],
  "darkturquoise": [0, 206, 209, 1],
  "darkviolet": [148, 0, 211, 1],
  "deeppink": [255, 20, 147, 1],
  "deepskyblue": [0, 191, 255, 1],
  "dimgray": [105, 105, 105, 1],
  "dimgrey": [105, 105, 105, 1],
  "dodgerblue": [30, 144, 255, 1],
  "firebrick": [178, 34, 34, 1],
  "floralwhite": [255, 250, 240, 1],
  "forestgreen": [34, 139, 34, 1],
  "fuchsia": [255, 0, 255, 1],
  "gainsboro": [220, 220, 220, 1],
  "ghostwhite": [248, 248, 255, 1],
  "gold": [255, 215, 0, 1],
  "goldenrod": [218, 165, 32, 1],
  "gray": [128, 128, 128, 1],
  "green": [0, 128, 0, 1],
  "greenyellow": [173, 255, 47, 1],
  "grey": [128, 128, 128, 1],
  "honeydew": [240, 255, 240, 1],
  "hotpink": [255, 105, 180, 1],
  "indianred": [205, 92, 92, 1],
  "indigo": [75, 0, 130, 1],
  "ivory": [255, 255, 240, 1],
  "khaki": [240, 230, 140, 1],
  "lavender": [230, 230, 250, 1],
  "lavenderblush": [255, 240, 245, 1],
  "lawngreen": [124, 252, 0, 1],
  "lemonchiffon": [255, 250, 205, 1],
  "lightblue": [173, 216, 230, 1],
  "lightcoral": [240, 128, 128, 1],
  "lightcyan": [224, 255, 255, 1],
  "lightgoldenrodyellow": [250, 250, 210, 1],
  "lightgray": [211, 211, 211, 1],
  "lightgreen": [144, 238, 144, 1],
  "lightgrey": [211, 211, 211, 1],
  "lightpink": [255, 182, 193, 1],
  "lightsalmon": [255, 160, 122, 1],
  "lightseagreen": [32, 178, 170, 1],
  "lightskyblue": [135, 206, 250, 1],
  "lightslategray": [119, 136, 153, 1],
  "lightslategrey": [119, 136, 153, 1],
  "lightsteelblue": [176, 196, 222, 1],
  "lightyellow": [255, 255, 224, 1],
  "lime": [0, 255, 0, 1],
  "limegreen": [50, 205, 50, 1],
  "linen": [250, 240, 230, 1],
  "magenta": [255, 0, 255, 1],
  "maroon": [128, 0, 0, 1],
  "mediumaquamarine": [102, 205, 170, 1],
  "mediumblue": [0, 0, 205, 1],
  "mediumorchid": [186, 85, 211, 1],
  "mediumpurple": [147, 112, 219, 1],
  "mediumseagreen": [60, 179, 113, 1],
  "mediumslateblue": [123, 104, 238, 1],
  "mediumspringgreen": [0, 250, 154, 1],
  "mediumturquoise": [72, 209, 204, 1],
  "mediumvioletred": [199, 21, 133, 1],
  "midnightblue": [25, 25, 112, 1],
  "mintcream": [245, 255, 250, 1],
  "mistyrose": [255, 228, 225, 1],
  "moccasin": [255, 228, 181, 1],
  "navajowhite": [255, 222, 173, 1],
  "navy": [0, 0, 128, 1],
  "oldlace": [253, 245, 230, 1],
  "olive": [128, 128, 0, 1],
  "olivedrab": [107, 142, 35, 1],
  "orange": [255, 165, 0, 1],
  "orangered": [255, 69, 0, 1],
  "orchid": [218, 112, 214, 1],
  "palegoldenrod": [238, 232, 170, 1],
  "palegreen": [152, 251, 152, 1],
  "paleturquoise": [175, 238, 238, 1],
  "palevioletred": [219, 112, 147, 1],
  "papayawhip": [255, 239, 213, 1],
  "peachpuff": [255, 218, 185, 1],
  "peru": [205, 133, 63, 1],
  "pink": [255, 192, 203, 1],
  "plum": [221, 160, 221, 1],
  "powderblue": [176, 224, 230, 1],
  "purple": [128, 0, 128, 1],
  "red": [255, 0, 0, 1],
  "rosybrown": [188, 143, 143, 1],
  "royalblue": [65, 105, 225, 1],
  "saddlebrown": [139, 69, 19, 1],
  "salmon": [250, 128, 114, 1],
  "sandybrown": [244, 164, 96, 1],
  "seagreen": [46, 139, 87, 1],
  "seashell": [255, 245, 238, 1],
  "sienna": [160, 82, 45, 1],
  "silver": [192, 192, 192, 1],
  "skyblue": [135, 206, 235, 1],
  "slateblue": [106, 90, 205, 1],
  "slategray": [112, 128, 144, 1],
  "slategrey": [112, 128, 144, 1],
  "snow": [255, 250, 250, 1],
  "springgreen": [0, 255, 127, 1],
  "steelblue": [70, 130, 180, 1],
  "tan": [210, 180, 140, 1],
  "teal": [0, 128, 128, 1],
  "thistle": [216, 191, 216, 1],
  "tomato": [255, 99, 71, 1],
  "turquoise": [64, 224, 208, 1],
  "violet": [238, 130, 238, 1],
  "wheat": [245, 222, 179, 1],
  "white": [255, 255, 255, 1],
  "whitesmoke": [245, 245, 245, 1],
  "yellow": [255, 255, 0, 1],
  "yellowgreen": [154, 205, 50, 1]
};
function clampCssByte(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 255 ? 255 : i;
}
function clampCssAngle(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 360 ? 360 : i;
}
function clampCssFloat(f2) {
  return f2 < 0 ? 0 : f2 > 1 ? 1 : f2;
}
function parseCssInt(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssByte(parseFloat(str) / 100 * 255);
  }
  return clampCssByte(parseInt(str, 10));
}
function parseCssFloat(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssFloat(parseFloat(str) / 100);
  }
  return clampCssFloat(parseFloat(str));
}
function cssHueToRgb(m1, m2, h) {
  if (h < 0) {
    h += 1;
  } else if (h > 1) {
    h -= 1;
  }
  if (h * 6 < 1) {
    return m1 + (m2 - m1) * h * 6;
  }
  if (h * 2 < 1) {
    return m2;
  }
  if (h * 3 < 2) {
    return m1 + (m2 - m1) * (2 / 3 - h) * 6;
  }
  return m1;
}
function lerpNumber(a, b2, p2) {
  return a + (b2 - a) * p2;
}
function setRgba(out2, r2, g2, b2, a) {
  out2[0] = r2;
  out2[1] = g2;
  out2[2] = b2;
  out2[3] = a;
  return out2;
}
function copyRgba(out2, a) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  return out2;
}
var colorCache = new LRU$1(20);
var lastRemovedArr = null;
function putToCache(colorStr, rgbaArr) {
  if (lastRemovedArr) {
    copyRgba(lastRemovedArr, rgbaArr);
  }
  lastRemovedArr = colorCache.put(colorStr, lastRemovedArr || rgbaArr.slice());
}
function parse(colorStr, rgbaArr) {
  if (!colorStr) {
    return;
  }
  rgbaArr = rgbaArr || [];
  var cached = colorCache.get(colorStr);
  if (cached) {
    return copyRgba(rgbaArr, cached);
  }
  colorStr = colorStr + "";
  var str = colorStr.replace(/ /g, "").toLowerCase();
  if (str in kCSSColorTable) {
    copyRgba(rgbaArr, kCSSColorTable[str]);
    putToCache(colorStr, rgbaArr);
    return rgbaArr;
  }
  var strLen = str.length;
  if (str.charAt(0) === "#") {
    if (strLen === 4 || strLen === 5) {
      var iv = parseInt(str.slice(1, 4), 16);
      if (!(iv >= 0 && iv <= 4095)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 3840) >> 4 | (iv & 3840) >> 8, iv & 240 | (iv & 240) >> 4, iv & 15 | (iv & 15) << 4, strLen === 5 ? parseInt(str.slice(4), 16) / 15 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    } else if (strLen === 7 || strLen === 9) {
      var iv = parseInt(str.slice(1, 7), 16);
      if (!(iv >= 0 && iv <= 16777215)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 16711680) >> 16, (iv & 65280) >> 8, iv & 255, strLen === 9 ? parseInt(str.slice(7), 16) / 255 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    }
    return;
  }
  var op = str.indexOf("(");
  var ep = str.indexOf(")");
  if (op !== -1 && ep + 1 === strLen) {
    var fname = str.substr(0, op);
    var params = str.substr(op + 1, ep - (op + 1)).split(",");
    var alpha = 1;
    switch (fname) {
      case "rgba":
        if (params.length !== 4) {
          return params.length === 3 ? setRgba(rgbaArr, +params[0], +params[1], +params[2], 1) : setRgba(rgbaArr, 0, 0, 0, 1);
        }
        alpha = parseCssFloat(params.pop());
      case "rgb":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        setRgba(rgbaArr, parseCssInt(params[0]), parseCssInt(params[1]), parseCssInt(params[2]), alpha);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsla":
        if (params.length !== 4) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        params[3] = parseCssFloat(params[3]);
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsl":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      default:
        return;
    }
  }
  setRgba(rgbaArr, 0, 0, 0, 1);
  return;
}
function hsla2rgba(hsla, rgba) {
  var h = (parseFloat(hsla[0]) % 360 + 360) % 360 / 360;
  var s = parseCssFloat(hsla[1]);
  var l2 = parseCssFloat(hsla[2]);
  var m2 = l2 <= 0.5 ? l2 * (s + 1) : l2 + s - l2 * s;
  var m1 = l2 * 2 - m2;
  rgba = rgba || [];
  setRgba(rgba, clampCssByte(cssHueToRgb(m1, m2, h + 1 / 3) * 255), clampCssByte(cssHueToRgb(m1, m2, h) * 255), clampCssByte(cssHueToRgb(m1, m2, h - 1 / 3) * 255), 1);
  if (hsla.length === 4) {
    rgba[3] = hsla[3];
  }
  return rgba;
}
function rgba2hsla(rgba) {
  if (!rgba) {
    return;
  }
  var R = rgba[0] / 255;
  var G = rgba[1] / 255;
  var B = rgba[2] / 255;
  var vMin = Math.min(R, G, B);
  var vMax = Math.max(R, G, B);
  var delta = vMax - vMin;
  var L = (vMax + vMin) / 2;
  var H;
  var S;
  if (delta === 0) {
    H = 0;
    S = 0;
  } else {
    if (L < 0.5) {
      S = delta / (vMax + vMin);
    } else {
      S = delta / (2 - vMax - vMin);
    }
    var deltaR = ((vMax - R) / 6 + delta / 2) / delta;
    var deltaG = ((vMax - G) / 6 + delta / 2) / delta;
    var deltaB = ((vMax - B) / 6 + delta / 2) / delta;
    if (R === vMax) {
      H = deltaB - deltaG;
    } else if (G === vMax) {
      H = 1 / 3 + deltaR - deltaB;
    } else if (B === vMax) {
      H = 2 / 3 + deltaG - deltaR;
    }
    if (H < 0) {
      H += 1;
    }
    if (H > 1) {
      H -= 1;
    }
  }
  var hsla = [H * 360, S, L];
  if (rgba[3] != null) {
    hsla.push(rgba[3]);
  }
  return hsla;
}
function lift(color, level) {
  var colorArr = parse(color);
  if (colorArr) {
    for (var i = 0; i < 3; i++) {
      if (level < 0) {
        colorArr[i] = colorArr[i] * (1 - level) | 0;
      } else {
        colorArr[i] = (255 - colorArr[i]) * level + colorArr[i] | 0;
      }
      if (colorArr[i] > 255) {
        colorArr[i] = 255;
      } else if (colorArr[i] < 0) {
        colorArr[i] = 0;
      }
    }
    return stringify(colorArr, colorArr.length === 4 ? "rgba" : "rgb");
  }
}
function fastLerp(normalizedValue, colors, out2) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  out2 = out2 || [];
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = colors[leftIndex];
  var rightColor = colors[rightIndex];
  var dv = value - leftIndex;
  out2[0] = clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv));
  out2[1] = clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv));
  out2[2] = clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv));
  out2[3] = clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv));
  return out2;
}
function lerp(normalizedValue, colors, fullOutput) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = parse(colors[leftIndex]);
  var rightColor = parse(colors[rightIndex]);
  var dv = value - leftIndex;
  var color = stringify([
    clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv)),
    clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv)),
    clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv)),
    clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv))
  ], "rgba");
  return fullOutput ? {
    color,
    leftIndex,
    rightIndex,
    value
  } : color;
}
function modifyHSL(color, h, s, l2) {
  var colorArr = parse(color);
  if (color) {
    colorArr = rgba2hsla(colorArr);
    h != null && (colorArr[0] = clampCssAngle(h));
    s != null && (colorArr[1] = parseCssFloat(s));
    l2 != null && (colorArr[2] = parseCssFloat(l2));
    return stringify(hsla2rgba(colorArr), "rgba");
  }
}
function modifyAlpha(color, alpha) {
  var colorArr = parse(color);
  if (colorArr && alpha != null) {
    colorArr[3] = clampCssFloat(alpha);
    return stringify(colorArr, "rgba");
  }
}
function stringify(arrColor, type4) {
  if (!arrColor || !arrColor.length) {
    return;
  }
  var colorStr = arrColor[0] + "," + arrColor[1] + "," + arrColor[2];
  if (type4 === "rgba" || type4 === "hsva" || type4 === "hsla") {
    colorStr += "," + arrColor[3];
  }
  return type4 + "(" + colorStr + ")";
}
function lum(color, backgroundLum) {
  var arr = parse(color);
  return arr ? (0.299 * arr[0] + 0.587 * arr[1] + 0.114 * arr[2]) * arr[3] / 255 + (1 - arr[3]) * backgroundLum : 0;
}
var mathRound$1 = Math.round;
function normalizeColor(color) {
  var opacity;
  if (!color || color === "transparent") {
    color = "none";
  } else if (typeof color === "string" && color.indexOf("rgba") > -1) {
    var arr = parse(color);
    if (arr) {
      color = "rgb(" + arr[0] + "," + arr[1] + "," + arr[2] + ")";
      opacity = arr[3];
    }
  }
  return {
    color,
    opacity: opacity == null ? 1 : opacity
  };
}
var EPSILON$3 = 1e-4;
function isAroundZero(transform2) {
  return transform2 < EPSILON$3 && transform2 > -EPSILON$3;
}
function round3(transform2) {
  return mathRound$1(transform2 * 1e3) / 1e3;
}
function round4(transform2) {
  return mathRound$1(transform2 * 1e4) / 1e4;
}
function getMatrixStr(m2) {
  return "matrix(" + round3(m2[0]) + "," + round3(m2[1]) + "," + round3(m2[2]) + "," + round3(m2[3]) + "," + round4(m2[4]) + "," + round4(m2[5]) + ")";
}
var TEXT_ALIGN_TO_ANCHOR = {
  left: "start",
  right: "end",
  center: "middle",
  middle: "middle"
};
function adjustTextY$1(y2, lineHeight, textBaseline) {
  if (textBaseline === "top") {
    y2 += lineHeight / 2;
  } else if (textBaseline === "bottom") {
    y2 -= lineHeight / 2;
  }
  return y2;
}
function hasShadow(style) {
  return style && (style.shadowBlur || style.shadowOffsetX || style.shadowOffsetY);
}
function getShadowKey(displayable) {
  var style = displayable.style;
  var globalScale = displayable.getGlobalScale();
  return [
    style.shadowColor,
    (style.shadowBlur || 0).toFixed(2),
    (style.shadowOffsetX || 0).toFixed(2),
    (style.shadowOffsetY || 0).toFixed(2),
    globalScale[0],
    globalScale[1]
  ].join(",");
}
function isImagePattern(val) {
  return val && !!val.image;
}
function isSVGPattern(val) {
  return val && !!val.svgElement;
}
function isPattern(val) {
  return isImagePattern(val) || isSVGPattern(val);
}
function isLinearGradient(val) {
  return val.type === "linear";
}
function isRadialGradient(val) {
  return val.type === "radial";
}
function isGradient(val) {
  return val && (val.type === "linear" || val.type === "radial");
}
function getIdURL(id2) {
  return "url(#" + id2 + ")";
}
function getPathPrecision(el) {
  var scale2 = el.getGlobalScale();
  var size = Math.max(scale2[0], scale2[1]);
  return Math.max(Math.ceil(Math.log(size) / Math.log(10)), 1);
}
function getSRTTransformString(transform2) {
  var x2 = transform2.x || 0;
  var y2 = transform2.y || 0;
  var rotation = (transform2.rotation || 0) * RADIAN_TO_DEGREE;
  var scaleX = retrieve2(transform2.scaleX, 1);
  var scaleY = retrieve2(transform2.scaleY, 1);
  var skewX = transform2.skewX || 0;
  var skewY = transform2.skewY || 0;
  var res = [];
  if (x2 || y2) {
    res.push("translate(" + x2 + "px," + y2 + "px)");
  }
  if (rotation) {
    res.push("rotate(" + rotation + ")");
  }
  if (scaleX !== 1 || scaleY !== 1) {
    res.push("scale(" + scaleX + "," + scaleY + ")");
  }
  if (skewX || skewY) {
    res.push("skew(" + mathRound$1(skewX * RADIAN_TO_DEGREE) + "deg, " + mathRound$1(skewY * RADIAN_TO_DEGREE) + "deg)");
  }
  return res.join(" ");
}
var encodeBase64 = function() {
  if (env$1.hasGlobalWindow && isFunction(window.btoa)) {
    return function(str) {
      return window.btoa(unescape(str));
    };
  }
  if (typeof Buffer !== "undefined") {
    return function(str) {
      return Buffer.from(str).toString("base64");
    };
  }
  return function(str) {
    return null;
  };
}();
var arraySlice = Array.prototype.slice;
function interpolateNumber$1(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
function interpolate1DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = interpolateNumber$1(p0[i], p1[i], percent);
  }
  return out2;
}
function interpolate2DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = interpolateNumber$1(p0[i][j], p1[i][j], percent);
    }
  }
  return out2;
}
function add1DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = p0[i] + p1[i] * sign;
  }
  return out2;
}
function add2DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = p0[i][j] + p1[i][j] * sign;
    }
  }
  return out2;
}
function fillColorStops(val0, val1) {
  var len0 = val0.length;
  var len1 = val1.length;
  var shorterArr = len0 > len1 ? val1 : val0;
  var shorterLen = Math.min(len0, len1);
  var last = shorterArr[shorterLen - 1] || { color: [0, 0, 0, 0], offset: 0 };
  for (var i = shorterLen; i < Math.max(len0, len1); i++) {
    shorterArr.push({
      offset: last.offset,
      color: last.color.slice()
    });
  }
}
function fillArray(val0, val1, arrDim) {
  var arr0 = val0;
  var arr1 = val1;
  if (!arr0.push || !arr1.push) {
    return;
  }
  var arr0Len = arr0.length;
  var arr1Len = arr1.length;
  if (arr0Len !== arr1Len) {
    var isPreviousLarger = arr0Len > arr1Len;
    if (isPreviousLarger) {
      arr0.length = arr1Len;
    } else {
      for (var i = arr0Len; i < arr1Len; i++) {
        arr0.push(arrDim === 1 ? arr1[i] : arraySlice.call(arr1[i]));
      }
    }
  }
  var len2 = arr0[0] && arr0[0].length;
  for (var i = 0; i < arr0.length; i++) {
    if (arrDim === 1) {
      if (isNaN(arr0[i])) {
        arr0[i] = arr1[i];
      }
    } else {
      for (var j = 0; j < len2; j++) {
        if (isNaN(arr0[i][j])) {
          arr0[i][j] = arr1[i][j];
        }
      }
    }
  }
}
function cloneValue(value) {
  if (isArrayLike(value)) {
    var len2 = value.length;
    if (isArrayLike(value[0])) {
      var ret = [];
      for (var i = 0; i < len2; i++) {
        ret.push(arraySlice.call(value[i]));
      }
      return ret;
    }
    return arraySlice.call(value);
  }
  return value;
}
function rgba2String(rgba) {
  rgba[0] = Math.floor(rgba[0]) || 0;
  rgba[1] = Math.floor(rgba[1]) || 0;
  rgba[2] = Math.floor(rgba[2]) || 0;
  rgba[3] = rgba[3] == null ? 1 : rgba[3];
  return "rgba(" + rgba.join(",") + ")";
}
function guessArrayDim(value) {
  return isArrayLike(value && value[0]) ? 2 : 1;
}
var VALUE_TYPE_NUMBER = 0;
var VALUE_TYPE_1D_ARRAY = 1;
var VALUE_TYPE_2D_ARRAY = 2;
var VALUE_TYPE_COLOR = 3;
var VALUE_TYPE_LINEAR_GRADIENT = 4;
var VALUE_TYPE_RADIAL_GRADIENT = 5;
var VALUE_TYPE_UNKOWN = 6;
function isGradientValueType(valType) {
  return valType === VALUE_TYPE_LINEAR_GRADIENT || valType === VALUE_TYPE_RADIAL_GRADIENT;
}
function isArrayValueType(valType) {
  return valType === VALUE_TYPE_1D_ARRAY || valType === VALUE_TYPE_2D_ARRAY;
}
var tmpRgba = [0, 0, 0, 0];
var Track = function() {
  function Track2(propName) {
    this.keyframes = [];
    this.discrete = false;
    this._invalid = false;
    this._needsSort = false;
    this._lastFr = 0;
    this._lastFrP = 0;
    this.propName = propName;
  }
  Track2.prototype.isFinished = function() {
    return this._finished;
  };
  Track2.prototype.setFinished = function() {
    this._finished = true;
    if (this._additiveTrack) {
      this._additiveTrack.setFinished();
    }
  };
  Track2.prototype.needsAnimate = function() {
    return this.keyframes.length >= 1;
  };
  Track2.prototype.getAdditiveTrack = function() {
    return this._additiveTrack;
  };
  Track2.prototype.addKeyframe = function(time, rawValue, easing) {
    this._needsSort = true;
    var keyframes = this.keyframes;
    var len2 = keyframes.length;
    var discrete = false;
    var valType = VALUE_TYPE_UNKOWN;
    var value = rawValue;
    if (isArrayLike(rawValue)) {
      var arrayDim = guessArrayDim(rawValue);
      valType = arrayDim;
      if (arrayDim === 1 && !isNumber(rawValue[0]) || arrayDim === 2 && !isNumber(rawValue[0][0])) {
        discrete = true;
      }
    } else {
      if (isNumber(rawValue) && !eqNaN(rawValue)) {
        valType = VALUE_TYPE_NUMBER;
      } else if (isString(rawValue)) {
        if (!isNaN(+rawValue)) {
          valType = VALUE_TYPE_NUMBER;
        } else {
          var colorArray = parse(rawValue);
          if (colorArray) {
            value = colorArray;
            valType = VALUE_TYPE_COLOR;
          }
        }
      } else if (isGradientObject(rawValue)) {
        var parsedGradient = extend({}, value);
        parsedGradient.colorStops = map$1(rawValue.colorStops, function(colorStop) {
          return {
            offset: colorStop.offset,
            color: parse(colorStop.color)
          };
        });
        if (isLinearGradient(rawValue)) {
          valType = VALUE_TYPE_LINEAR_GRADIENT;
        } else if (isRadialGradient(rawValue)) {
          valType = VALUE_TYPE_RADIAL_GRADIENT;
        }
        value = parsedGradient;
      }
    }
    if (len2 === 0) {
      this.valType = valType;
    } else if (valType !== this.valType || valType === VALUE_TYPE_UNKOWN) {
      discrete = true;
    }
    this.discrete = this.discrete || discrete;
    var kf = {
      time,
      value,
      rawValue,
      percent: 0
    };
    if (easing) {
      kf.easing = easing;
      kf.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
    }
    keyframes.push(kf);
    return kf;
  };
  Track2.prototype.prepare = function(maxTime, additiveTrack) {
    var kfs = this.keyframes;
    if (this._needsSort) {
      kfs.sort(function(a, b2) {
        return a.time - b2.time;
      });
    }
    var valType = this.valType;
    var kfsLen = kfs.length;
    var lastKf = kfs[kfsLen - 1];
    var isDiscrete = this.discrete;
    var isArr = isArrayValueType(valType);
    var isGradient2 = isGradientValueType(valType);
    for (var i = 0; i < kfsLen; i++) {
      var kf = kfs[i];
      var value = kf.value;
      var lastValue = lastKf.value;
      kf.percent = kf.time / maxTime;
      if (!isDiscrete) {
        if (isArr && i !== kfsLen - 1) {
          fillArray(value, lastValue, valType);
        } else if (isGradient2) {
          fillColorStops(value.colorStops, lastValue.colorStops);
        }
      }
    }
    if (!isDiscrete && valType !== VALUE_TYPE_RADIAL_GRADIENT && additiveTrack && this.needsAnimate() && additiveTrack.needsAnimate() && valType === additiveTrack.valType && !additiveTrack._finished) {
      this._additiveTrack = additiveTrack;
      var startValue = kfs[0].value;
      for (var i = 0; i < kfsLen; i++) {
        if (valType === VALUE_TYPE_NUMBER) {
          kfs[i].additiveValue = kfs[i].value - startValue;
        } else if (valType === VALUE_TYPE_COLOR) {
          kfs[i].additiveValue = add1DArray([], kfs[i].value, startValue, -1);
        } else if (isArrayValueType(valType)) {
          kfs[i].additiveValue = valType === VALUE_TYPE_1D_ARRAY ? add1DArray([], kfs[i].value, startValue, -1) : add2DArray([], kfs[i].value, startValue, -1);
        }
      }
    }
  };
  Track2.prototype.step = function(target, percent) {
    if (this._finished) {
      return;
    }
    if (this._additiveTrack && this._additiveTrack._finished) {
      this._additiveTrack = null;
    }
    var isAdditive = this._additiveTrack != null;
    var valueKey = isAdditive ? "additiveValue" : "value";
    var valType = this.valType;
    var keyframes = this.keyframes;
    var kfsNum = keyframes.length;
    var propName = this.propName;
    var isValueColor = valType === VALUE_TYPE_COLOR;
    var frameIdx;
    var lastFrame = this._lastFr;
    var mathMin2 = Math.min;
    var frame;
    var nextFrame;
    if (kfsNum === 1) {
      frame = nextFrame = keyframes[0];
    } else {
      if (percent < 0) {
        frameIdx = 0;
      } else if (percent < this._lastFrP) {
        var start2 = mathMin2(lastFrame + 1, kfsNum - 1);
        for (frameIdx = start2; frameIdx >= 0; frameIdx--) {
          if (keyframes[frameIdx].percent <= percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx, kfsNum - 2);
      } else {
        for (frameIdx = lastFrame; frameIdx < kfsNum; frameIdx++) {
          if (keyframes[frameIdx].percent > percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx - 1, kfsNum - 2);
      }
      nextFrame = keyframes[frameIdx + 1];
      frame = keyframes[frameIdx];
    }
    if (!(frame && nextFrame)) {
      return;
    }
    this._lastFr = frameIdx;
    this._lastFrP = percent;
    var interval = nextFrame.percent - frame.percent;
    var w2 = interval === 0 ? 1 : mathMin2((percent - frame.percent) / interval, 1);
    if (nextFrame.easingFunc) {
      w2 = nextFrame.easingFunc(w2);
    }
    var targetArr = isAdditive ? this._additiveValue : isValueColor ? tmpRgba : target[propName];
    if ((isArrayValueType(valType) || isValueColor) && !targetArr) {
      targetArr = this._additiveValue = [];
    }
    if (this.discrete) {
      target[propName] = w2 < 1 ? frame.rawValue : nextFrame.rawValue;
    } else if (isArrayValueType(valType)) {
      valType === VALUE_TYPE_1D_ARRAY ? interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2) : interpolate2DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
    } else if (isGradientValueType(valType)) {
      var val = frame[valueKey];
      var nextVal_1 = nextFrame[valueKey];
      var isLinearGradient_1 = valType === VALUE_TYPE_LINEAR_GRADIENT;
      target[propName] = {
        type: isLinearGradient_1 ? "linear" : "radial",
        x: interpolateNumber$1(val.x, nextVal_1.x, w2),
        y: interpolateNumber$1(val.y, nextVal_1.y, w2),
        colorStops: map$1(val.colorStops, function(colorStop, idx) {
          var nextColorStop = nextVal_1.colorStops[idx];
          return {
            offset: interpolateNumber$1(colorStop.offset, nextColorStop.offset, w2),
            color: rgba2String(interpolate1DArray([], colorStop.color, nextColorStop.color, w2))
          };
        }),
        global: nextVal_1.global
      };
      if (isLinearGradient_1) {
        target[propName].x2 = interpolateNumber$1(val.x2, nextVal_1.x2, w2);
        target[propName].y2 = interpolateNumber$1(val.y2, nextVal_1.y2, w2);
      } else {
        target[propName].r = interpolateNumber$1(val.r, nextVal_1.r, w2);
      }
    } else if (isValueColor) {
      interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
      if (!isAdditive) {
        target[propName] = rgba2String(targetArr);
      }
    } else {
      var value = interpolateNumber$1(frame[valueKey], nextFrame[valueKey], w2);
      if (isAdditive) {
        this._additiveValue = value;
      } else {
        target[propName] = value;
      }
    }
    if (isAdditive) {
      this._addToTarget(target);
    }
  };
  Track2.prototype._addToTarget = function(target) {
    var valType = this.valType;
    var propName = this.propName;
    var additiveValue = this._additiveValue;
    if (valType === VALUE_TYPE_NUMBER) {
      target[propName] = target[propName] + additiveValue;
    } else if (valType === VALUE_TYPE_COLOR) {
      parse(target[propName], tmpRgba);
      add1DArray(tmpRgba, tmpRgba, additiveValue, 1);
      target[propName] = rgba2String(tmpRgba);
    } else if (valType === VALUE_TYPE_1D_ARRAY) {
      add1DArray(target[propName], target[propName], additiveValue, 1);
    } else if (valType === VALUE_TYPE_2D_ARRAY) {
      add2DArray(target[propName], target[propName], additiveValue, 1);
    }
  };
  return Track2;
}();
var Animator = function() {
  function Animator2(target, loop, allowDiscreteAnimation, additiveTo) {
    this._tracks = {};
    this._trackKeys = [];
    this._maxTime = 0;
    this._started = 0;
    this._clip = null;
    this._target = target;
    this._loop = loop;
    if (loop && additiveTo) {
      logError("Can' use additive animation on looped animation.");
      return;
    }
    this._additiveAnimators = additiveTo;
    this._allowDiscrete = allowDiscreteAnimation;
  }
  Animator2.prototype.getMaxTime = function() {
    return this._maxTime;
  };
  Animator2.prototype.getDelay = function() {
    return this._delay;
  };
  Animator2.prototype.getLoop = function() {
    return this._loop;
  };
  Animator2.prototype.getTarget = function() {
    return this._target;
  };
  Animator2.prototype.changeTarget = function(target) {
    this._target = target;
  };
  Animator2.prototype.when = function(time, props, easing) {
    return this.whenWithKeys(time, props, keys(props), easing);
  };
  Animator2.prototype.whenWithKeys = function(time, props, propNames, easing) {
    var tracks = this._tracks;
    for (var i = 0; i < propNames.length; i++) {
      var propName = propNames[i];
      var track = tracks[propName];
      if (!track) {
        track = tracks[propName] = new Track(propName);
        var initialValue = void 0;
        var additiveTrack = this._getAdditiveTrack(propName);
        if (additiveTrack) {
          var addtiveTrackKfs = additiveTrack.keyframes;
          var lastFinalKf = addtiveTrackKfs[addtiveTrackKfs.length - 1];
          initialValue = lastFinalKf && lastFinalKf.value;
          if (additiveTrack.valType === VALUE_TYPE_COLOR && initialValue) {
            initialValue = rgba2String(initialValue);
          }
        } else {
          initialValue = this._target[propName];
        }
        if (initialValue == null) {
          continue;
        }
        if (time > 0) {
          track.addKeyframe(0, cloneValue(initialValue), easing);
        }
        this._trackKeys.push(propName);
      }
      track.addKeyframe(time, cloneValue(props[propName]), easing);
    }
    this._maxTime = Math.max(this._maxTime, time);
    return this;
  };
  Animator2.prototype.pause = function() {
    this._clip.pause();
    this._paused = true;
  };
  Animator2.prototype.resume = function() {
    this._clip.resume();
    this._paused = false;
  };
  Animator2.prototype.isPaused = function() {
    return !!this._paused;
  };
  Animator2.prototype.duration = function(duration) {
    this._maxTime = duration;
    this._force = true;
    return this;
  };
  Animator2.prototype._doneCallback = function() {
    this._setTracksFinished();
    this._clip = null;
    var doneList = this._doneCbs;
    if (doneList) {
      var len2 = doneList.length;
      for (var i = 0; i < len2; i++) {
        doneList[i].call(this);
      }
    }
  };
  Animator2.prototype._abortedCallback = function() {
    this._setTracksFinished();
    var animation = this.animation;
    var abortedList = this._abortedCbs;
    if (animation) {
      animation.removeClip(this._clip);
    }
    this._clip = null;
    if (abortedList) {
      for (var i = 0; i < abortedList.length; i++) {
        abortedList[i].call(this);
      }
    }
  };
  Animator2.prototype._setTracksFinished = function() {
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < tracksKeys.length; i++) {
      tracks[tracksKeys[i]].setFinished();
    }
  };
  Animator2.prototype._getAdditiveTrack = function(trackName) {
    var additiveTrack;
    var additiveAnimators = this._additiveAnimators;
    if (additiveAnimators) {
      for (var i = 0; i < additiveAnimators.length; i++) {
        var track = additiveAnimators[i].getTrack(trackName);
        if (track) {
          additiveTrack = track;
        }
      }
    }
    return additiveTrack;
  };
  Animator2.prototype.start = function(easing) {
    if (this._started > 0) {
      return;
    }
    this._started = 1;
    var self2 = this;
    var tracks = [];
    var maxTime = this._maxTime || 0;
    for (var i = 0; i < this._trackKeys.length; i++) {
      var propName = this._trackKeys[i];
      var track = this._tracks[propName];
      var additiveTrack = this._getAdditiveTrack(propName);
      var kfs = track.keyframes;
      var kfsNum = kfs.length;
      track.prepare(maxTime, additiveTrack);
      if (track.needsAnimate()) {
        if (!this._allowDiscrete && track.discrete) {
          var lastKf = kfs[kfsNum - 1];
          if (lastKf) {
            self2._target[track.propName] = lastKf.rawValue;
          }
          track.setFinished();
        } else {
          tracks.push(track);
        }
      }
    }
    if (tracks.length || this._force) {
      var clip2 = new Clip$1({
        life: maxTime,
        loop: this._loop,
        delay: this._delay || 0,
        onframe: function(percent) {
          self2._started = 2;
          var additiveAnimators = self2._additiveAnimators;
          if (additiveAnimators) {
            var stillHasAdditiveAnimator = false;
            for (var i2 = 0; i2 < additiveAnimators.length; i2++) {
              if (additiveAnimators[i2]._clip) {
                stillHasAdditiveAnimator = true;
                break;
              }
            }
            if (!stillHasAdditiveAnimator) {
              self2._additiveAnimators = null;
            }
          }
          for (var i2 = 0; i2 < tracks.length; i2++) {
            tracks[i2].step(self2._target, percent);
          }
          var onframeList = self2._onframeCbs;
          if (onframeList) {
            for (var i2 = 0; i2 < onframeList.length; i2++) {
              onframeList[i2](self2._target, percent);
            }
          }
        },
        ondestroy: function() {
          self2._doneCallback();
        }
      });
      this._clip = clip2;
      if (this.animation) {
        this.animation.addClip(clip2);
      }
      if (easing) {
        clip2.setEasing(easing);
      }
    } else {
      this._doneCallback();
    }
    return this;
  };
  Animator2.prototype.stop = function(forwardToLast) {
    if (!this._clip) {
      return;
    }
    var clip2 = this._clip;
    if (forwardToLast) {
      clip2.onframe(1);
    }
    this._abortedCallback();
  };
  Animator2.prototype.delay = function(time) {
    this._delay = time;
    return this;
  };
  Animator2.prototype.during = function(cb) {
    if (cb) {
      if (!this._onframeCbs) {
        this._onframeCbs = [];
      }
      this._onframeCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.done = function(cb) {
    if (cb) {
      if (!this._doneCbs) {
        this._doneCbs = [];
      }
      this._doneCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.aborted = function(cb) {
    if (cb) {
      if (!this._abortedCbs) {
        this._abortedCbs = [];
      }
      this._abortedCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.getClip = function() {
    return this._clip;
  };
  Animator2.prototype.getTrack = function(propName) {
    return this._tracks[propName];
  };
  Animator2.prototype.getTracks = function() {
    var _this = this;
    return map$1(this._trackKeys, function(key) {
      return _this._tracks[key];
    });
  };
  Animator2.prototype.stopTracks = function(propNames, forwardToLast) {
    if (!propNames.length || !this._clip) {
      return true;
    }
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < propNames.length; i++) {
      var track = tracks[propNames[i]];
      if (track && !track.isFinished()) {
        if (forwardToLast) {
          track.step(this._target, 1);
        } else if (this._started === 1) {
          track.step(this._target, 0);
        }
        track.setFinished();
      }
    }
    var allAborted = true;
    for (var i = 0; i < tracksKeys.length; i++) {
      if (!tracks[tracksKeys[i]].isFinished()) {
        allAborted = false;
        break;
      }
    }
    if (allAborted) {
      this._abortedCallback();
    }
    return allAborted;
  };
  Animator2.prototype.saveTo = function(target, trackKeys, firstOrLast) {
    if (!target) {
      return;
    }
    trackKeys = trackKeys || this._trackKeys;
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track || track.isFinished()) {
        continue;
      }
      var kfs = track.keyframes;
      var kf = kfs[firstOrLast ? 0 : kfs.length - 1];
      if (kf) {
        target[propName] = cloneValue(kf.rawValue);
      }
    }
  };
  Animator2.prototype.__changeFinalValue = function(finalProps, trackKeys) {
    trackKeys = trackKeys || keys(finalProps);
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track) {
        continue;
      }
      var kfs = track.keyframes;
      if (kfs.length > 1) {
        var lastKf = kfs.pop();
        track.addKeyframe(lastKf.time, finalProps[propName]);
        track.prepare(this._maxTime, track.getAdditiveTrack());
      }
    }
  };
  return Animator2;
}();
function getTime() {
  return new Date().getTime();
}
var Animation = function(_super) {
  __extends(Animation2, _super);
  function Animation2(opts) {
    var _this = _super.call(this) || this;
    _this._running = false;
    _this._time = 0;
    _this._pausedTime = 0;
    _this._pauseStart = 0;
    _this._paused = false;
    opts = opts || {};
    _this.stage = opts.stage || {};
    return _this;
  }
  Animation2.prototype.addClip = function(clip2) {
    if (clip2.animation) {
      this.removeClip(clip2);
    }
    if (!this._head) {
      this._head = this._tail = clip2;
    } else {
      this._tail.next = clip2;
      clip2.prev = this._tail;
      clip2.next = null;
      this._tail = clip2;
    }
    clip2.animation = this;
  };
  Animation2.prototype.addAnimator = function(animator) {
    animator.animation = this;
    var clip2 = animator.getClip();
    if (clip2) {
      this.addClip(clip2);
    }
  };
  Animation2.prototype.removeClip = function(clip2) {
    if (!clip2.animation) {
      return;
    }
    var prev = clip2.prev;
    var next = clip2.next;
    if (prev) {
      prev.next = next;
    } else {
      this._head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this._tail = prev;
    }
    clip2.next = clip2.prev = clip2.animation = null;
  };
  Animation2.prototype.removeAnimator = function(animator) {
    var clip2 = animator.getClip();
    if (clip2) {
      this.removeClip(clip2);
    }
    animator.animation = null;
  };
  Animation2.prototype.update = function(notTriggerFrameAndStageUpdate) {
    var time = getTime() - this._pausedTime;
    var delta = time - this._time;
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      var finished = clip2.step(time, delta);
      if (finished) {
        clip2.ondestroy();
        this.removeClip(clip2);
        clip2 = nextClip;
      } else {
        clip2 = nextClip;
      }
    }
    this._time = time;
    if (!notTriggerFrameAndStageUpdate) {
      this.trigger("frame", delta);
      this.stage.update && this.stage.update();
    }
  };
  Animation2.prototype._startLoop = function() {
    var self2 = this;
    this._running = true;
    function step() {
      if (self2._running) {
        requestAnimationFrame$2(step);
        !self2._paused && self2.update();
      }
    }
    requestAnimationFrame$2(step);
  };
  Animation2.prototype.start = function() {
    if (this._running) {
      return;
    }
    this._time = getTime();
    this._pausedTime = 0;
    this._startLoop();
  };
  Animation2.prototype.stop = function() {
    this._running = false;
  };
  Animation2.prototype.pause = function() {
    if (!this._paused) {
      this._pauseStart = getTime();
      this._paused = true;
    }
  };
  Animation2.prototype.resume = function() {
    if (this._paused) {
      this._pausedTime += getTime() - this._pauseStart;
      this._paused = false;
    }
  };
  Animation2.prototype.clear = function() {
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      clip2.prev = clip2.next = clip2.animation = null;
      clip2 = nextClip;
    }
    this._head = this._tail = null;
  };
  Animation2.prototype.isFinished = function() {
    return this._head == null;
  };
  Animation2.prototype.animate = function(target, options) {
    options = options || {};
    this.start();
    var animator = new Animator(target, options.loop);
    this.addAnimator(animator);
    return animator;
  };
  return Animation2;
}(Eventful$1);
var Animation$1 = Animation;
var TOUCH_CLICK_DELAY = 300;
var globalEventSupported = env$1.domSupported;
var localNativeListenerNames = function() {
  var mouseHandlerNames = [
    "click",
    "dblclick",
    "mousewheel",
    "wheel",
    "mouseout",
    "mouseup",
    "mousedown",
    "mousemove",
    "contextmenu"
  ];
  var touchHandlerNames = [
    "touchstart",
    "touchend",
    "touchmove"
  ];
  var pointerEventNameMap = {
    pointerdown: 1,
    pointerup: 1,
    pointermove: 1,
    pointerout: 1
  };
  var pointerHandlerNames = map$1(mouseHandlerNames, function(name) {
    var nm = name.replace("mouse", "pointer");
    return pointerEventNameMap.hasOwnProperty(nm) ? nm : name;
  });
  return {
    mouse: mouseHandlerNames,
    touch: touchHandlerNames,
    pointer: pointerHandlerNames
  };
}();
var globalNativeListenerNames = {
  mouse: ["mousemove", "mouseup"],
  pointer: ["pointermove", "pointerup"]
};
var wheelEventSupported = false;
function isPointerFromTouch(event) {
  var pointerType = event.pointerType;
  return pointerType === "pen" || pointerType === "touch";
}
function setTouchTimer(scope) {
  scope.touching = true;
  if (scope.touchTimer != null) {
    clearTimeout(scope.touchTimer);
    scope.touchTimer = null;
  }
  scope.touchTimer = setTimeout(function() {
    scope.touching = false;
    scope.touchTimer = null;
  }, 700);
}
function markTouch(event) {
  event && (event.zrByTouch = true);
}
function normalizeGlobalEvent(instance, event) {
  return normalizeEvent(instance.dom, new FakeGlobalEvent(instance, event), true);
}
function isLocalEl(instance, el) {
  var elTmp = el;
  var isLocal = false;
  while (elTmp && elTmp.nodeType !== 9 && !(isLocal = elTmp.domBelongToZr || elTmp !== el && elTmp === instance.painterRoot)) {
    elTmp = elTmp.parentNode;
  }
  return isLocal;
}
var FakeGlobalEvent = function() {
  function FakeGlobalEvent2(instance, event) {
    this.stopPropagation = noop;
    this.stopImmediatePropagation = noop;
    this.preventDefault = noop;
    this.type = event.type;
    this.target = this.currentTarget = instance.dom;
    this.pointerType = event.pointerType;
    this.clientX = event.clientX;
    this.clientY = event.clientY;
  }
  return FakeGlobalEvent2;
}();
var localDOMHandlers = {
  mousedown: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__mayPointerCapture = [event.zrX, event.zrY];
    this.trigger("mousedown", event);
  },
  mousemove: function(event) {
    event = normalizeEvent(this.dom, event);
    var downPoint = this.__mayPointerCapture;
    if (downPoint && (event.zrX !== downPoint[0] || event.zrY !== downPoint[1])) {
      this.__togglePointerCapture(true);
    }
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
  },
  mouseout: function(event) {
    event = normalizeEvent(this.dom, event);
    var element = event.toElement || event.relatedTarget;
    if (!isLocalEl(this, element)) {
      if (this.__pointerCapturing) {
        event.zrEventControl = "no_globalout";
      }
      this.trigger("mouseout", event);
    }
  },
  wheel: function(event) {
    wheelEventSupported = true;
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  mousewheel: function(event) {
    if (wheelEventSupported) {
      return;
    }
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  touchstart: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.__lastTouchMoment = new Date();
    this.handler.processGesture(event, "start");
    localDOMHandlers.mousemove.call(this, event);
    localDOMHandlers.mousedown.call(this, event);
  },
  touchmove: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "change");
    localDOMHandlers.mousemove.call(this, event);
  },
  touchend: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "end");
    localDOMHandlers.mouseup.call(this, event);
    if (+new Date() - +this.__lastTouchMoment < TOUCH_CLICK_DELAY) {
      localDOMHandlers.click.call(this, event);
    }
  },
  pointerdown: function(event) {
    localDOMHandlers.mousedown.call(this, event);
  },
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    localDOMHandlers.mouseup.call(this, event);
  },
  pointerout: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mouseout.call(this, event);
    }
  }
};
each$f(["click", "dblclick", "contextmenu"], function(name) {
  localDOMHandlers[name] = function(event) {
    event = normalizeEvent(this.dom, event);
    this.trigger(name, event);
  };
});
var globalDOMHandlers = {
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      globalDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    globalDOMHandlers.mouseup.call(this, event);
  },
  mousemove: function(event) {
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    var pointerCaptureReleasing = this.__pointerCapturing;
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
    if (pointerCaptureReleasing) {
      event.zrEventControl = "only_globalout";
      this.trigger("mouseout", event);
    }
  }
};
function mountLocalDOMEventListeners(instance, scope) {
  var domHandlers = scope.domHandlers;
  if (env$1.pointerEventsSupported) {
    each$f(localNativeListenerNames.pointer, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        domHandlers[nativeEventName].call(instance, event);
      });
    });
  } else {
    if (env$1.touchEventsSupported) {
      each$f(localNativeListenerNames.touch, function(nativeEventName) {
        mountSingleDOMEventListener(scope, nativeEventName, function(event) {
          domHandlers[nativeEventName].call(instance, event);
          setTouchTimer(scope);
        });
      });
    }
    each$f(localNativeListenerNames.mouse, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        event = getNativeEvent(event);
        if (!scope.touching) {
          domHandlers[nativeEventName].call(instance, event);
        }
      });
    });
  }
}
function mountGlobalDOMEventListeners(instance, scope) {
  if (env$1.pointerEventsSupported) {
    each$f(globalNativeListenerNames.pointer, mount);
  } else if (!env$1.touchEventsSupported) {
    each$f(globalNativeListenerNames.mouse, mount);
  }
  function mount(nativeEventName) {
    function nativeEventListener(event) {
      event = getNativeEvent(event);
      if (!isLocalEl(instance, event.target)) {
        event = normalizeGlobalEvent(instance, event);
        scope.domHandlers[nativeEventName].call(instance, event);
      }
    }
    mountSingleDOMEventListener(scope, nativeEventName, nativeEventListener, { capture: true });
  }
}
function mountSingleDOMEventListener(scope, nativeEventName, listener, opt) {
  scope.mounted[nativeEventName] = listener;
  scope.listenerOpts[nativeEventName] = opt;
  addEventListener(scope.domTarget, nativeEventName, listener, opt);
}
function unmountDOMEventListeners(scope) {
  var mounted = scope.mounted;
  for (var nativeEventName in mounted) {
    if (mounted.hasOwnProperty(nativeEventName)) {
      removeEventListener(scope.domTarget, nativeEventName, mounted[nativeEventName], scope.listenerOpts[nativeEventName]);
    }
  }
  scope.mounted = {};
}
var DOMHandlerScope = function() {
  function DOMHandlerScope2(domTarget, domHandlers) {
    this.mounted = {};
    this.listenerOpts = {};
    this.touching = false;
    this.domTarget = domTarget;
    this.domHandlers = domHandlers;
  }
  return DOMHandlerScope2;
}();
var HandlerDomProxy = function(_super) {
  __extends(HandlerDomProxy2, _super);
  function HandlerDomProxy2(dom, painterRoot) {
    var _this = _super.call(this) || this;
    _this.__pointerCapturing = false;
    _this.dom = dom;
    _this.painterRoot = painterRoot;
    _this._localHandlerScope = new DOMHandlerScope(dom, localDOMHandlers);
    if (globalEventSupported) {
      _this._globalHandlerScope = new DOMHandlerScope(document, globalDOMHandlers);
    }
    mountLocalDOMEventListeners(_this, _this._localHandlerScope);
    return _this;
  }
  HandlerDomProxy2.prototype.dispose = function() {
    unmountDOMEventListeners(this._localHandlerScope);
    if (globalEventSupported) {
      unmountDOMEventListeners(this._globalHandlerScope);
    }
  };
  HandlerDomProxy2.prototype.setCursor = function(cursorStyle) {
    this.dom.style && (this.dom.style.cursor = cursorStyle || "default");
  };
  HandlerDomProxy2.prototype.__togglePointerCapture = function(isPointerCapturing) {
    this.__mayPointerCapture = null;
    if (globalEventSupported && +this.__pointerCapturing ^ +isPointerCapturing) {
      this.__pointerCapturing = isPointerCapturing;
      var globalHandlerScope = this._globalHandlerScope;
      isPointerCapturing ? mountGlobalDOMEventListeners(this, globalHandlerScope) : unmountDOMEventListeners(globalHandlerScope);
    }
  };
  return HandlerDomProxy2;
}(Eventful$1);
var HandlerProxy = HandlerDomProxy;
var dpr = 1;
if (env$1.hasGlobalWindow) {
  dpr = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1);
}
var devicePixelRatio = dpr;
var DARK_MODE_THRESHOLD = 0.4;
var DARK_LABEL_COLOR = "#333";
var LIGHT_LABEL_COLOR = "#ccc";
var LIGHTER_LABEL_COLOR = "#eee";
function create$1() {
  return [1, 0, 0, 1, 0, 0];
}
function identity(out2) {
  out2[0] = 1;
  out2[1] = 0;
  out2[2] = 0;
  out2[3] = 1;
  out2[4] = 0;
  out2[5] = 0;
  return out2;
}
function copy(out2, m2) {
  out2[0] = m2[0];
  out2[1] = m2[1];
  out2[2] = m2[2];
  out2[3] = m2[3];
  out2[4] = m2[4];
  out2[5] = m2[5];
  return out2;
}
function mul(out2, m1, m2) {
  var out0 = m1[0] * m2[0] + m1[2] * m2[1];
  var out1 = m1[1] * m2[0] + m1[3] * m2[1];
  var out22 = m1[0] * m2[2] + m1[2] * m2[3];
  var out3 = m1[1] * m2[2] + m1[3] * m2[3];
  var out4 = m1[0] * m2[4] + m1[2] * m2[5] + m1[4];
  var out5 = m1[1] * m2[4] + m1[3] * m2[5] + m1[5];
  out2[0] = out0;
  out2[1] = out1;
  out2[2] = out22;
  out2[3] = out3;
  out2[4] = out4;
  out2[5] = out5;
  return out2;
}
function translate(out2, a, v4) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  out2[4] = a[4] + v4[0];
  out2[5] = a[5] + v4[1];
  return out2;
}
function rotate(out2, a, rad) {
  var aa = a[0];
  var ac = a[2];
  var atx = a[4];
  var ab = a[1];
  var ad = a[3];
  var aty = a[5];
  var st = Math.sin(rad);
  var ct = Math.cos(rad);
  out2[0] = aa * ct + ab * st;
  out2[1] = -aa * st + ab * ct;
  out2[2] = ac * ct + ad * st;
  out2[3] = -ac * st + ct * ad;
  out2[4] = ct * atx + st * aty;
  out2[5] = ct * aty - st * atx;
  return out2;
}
function scale$1(out2, a, v4) {
  var vx = v4[0];
  var vy = v4[1];
  out2[0] = a[0] * vx;
  out2[1] = a[1] * vy;
  out2[2] = a[2] * vx;
  out2[3] = a[3] * vy;
  out2[4] = a[4] * vx;
  out2[5] = a[5] * vy;
  return out2;
}
function invert(out2, a) {
  var aa = a[0];
  var ac = a[2];
  var atx = a[4];
  var ab = a[1];
  var ad = a[3];
  var aty = a[5];
  var det = aa * ad - ab * ac;
  if (!det) {
    return null;
  }
  det = 1 / det;
  out2[0] = ad * det;
  out2[1] = -ab * det;
  out2[2] = -ac * det;
  out2[3] = aa * det;
  out2[4] = (ac * aty - ad * atx) * det;
  out2[5] = (ab * atx - aa * aty) * det;
  return out2;
}
function clone$2(a) {
  var b2 = create$1();
  copy(b2, a);
  return b2;
}
var mIdentity = identity;
var EPSILON$2 = 5e-5;
function isNotAroundZero(val) {
  return val > EPSILON$2 || val < -EPSILON$2;
}
var scaleTmp = [];
var tmpTransform = [];
var originTransform = create$1();
var abs = Math.abs;
var Transformable = function() {
  function Transformable2() {
  }
  Transformable2.prototype.getLocalTransform = function(m2) {
    return Transformable2.getLocalTransform(this, m2);
  };
  Transformable2.prototype.setPosition = function(arr) {
    this.x = arr[0];
    this.y = arr[1];
  };
  Transformable2.prototype.setScale = function(arr) {
    this.scaleX = arr[0];
    this.scaleY = arr[1];
  };
  Transformable2.prototype.setSkew = function(arr) {
    this.skewX = arr[0];
    this.skewY = arr[1];
  };
  Transformable2.prototype.setOrigin = function(arr) {
    this.originX = arr[0];
    this.originY = arr[1];
  };
  Transformable2.prototype.needLocalTransform = function() {
    return isNotAroundZero(this.rotation) || isNotAroundZero(this.x) || isNotAroundZero(this.y) || isNotAroundZero(this.scaleX - 1) || isNotAroundZero(this.scaleY - 1) || isNotAroundZero(this.skewX) || isNotAroundZero(this.skewY);
  };
  Transformable2.prototype.updateTransform = function() {
    var parentTransform = this.parent && this.parent.transform;
    var needLocalTransform = this.needLocalTransform();
    var m2 = this.transform;
    if (!(needLocalTransform || parentTransform)) {
      m2 && mIdentity(m2);
      return;
    }
    m2 = m2 || create$1();
    if (needLocalTransform) {
      this.getLocalTransform(m2);
    } else {
      mIdentity(m2);
    }
    if (parentTransform) {
      if (needLocalTransform) {
        mul(m2, parentTransform, m2);
      } else {
        copy(m2, parentTransform);
      }
    }
    this.transform = m2;
    this._resolveGlobalScaleRatio(m2);
  };
  Transformable2.prototype._resolveGlobalScaleRatio = function(m2) {
    var globalScaleRatio = this.globalScaleRatio;
    if (globalScaleRatio != null && globalScaleRatio !== 1) {
      this.getGlobalScale(scaleTmp);
      var relX = scaleTmp[0] < 0 ? -1 : 1;
      var relY = scaleTmp[1] < 0 ? -1 : 1;
      var sx = ((scaleTmp[0] - relX) * globalScaleRatio + relX) / scaleTmp[0] || 0;
      var sy = ((scaleTmp[1] - relY) * globalScaleRatio + relY) / scaleTmp[1] || 0;
      m2[0] *= sx;
      m2[1] *= sx;
      m2[2] *= sy;
      m2[3] *= sy;
    }
    this.invTransform = this.invTransform || create$1();
    invert(this.invTransform, m2);
  };
  Transformable2.prototype.getComputedTransform = function() {
    var transformNode = this;
    var ancestors = [];
    while (transformNode) {
      ancestors.push(transformNode);
      transformNode = transformNode.parent;
    }
    while (transformNode = ancestors.pop()) {
      transformNode.updateTransform();
    }
    return this.transform;
  };
  Transformable2.prototype.setLocalTransform = function(m2) {
    if (!m2) {
      return;
    }
    var sx = m2[0] * m2[0] + m2[1] * m2[1];
    var sy = m2[2] * m2[2] + m2[3] * m2[3];
    var rotation = Math.atan2(m2[1], m2[0]);
    var shearX = Math.PI / 2 + rotation - Math.atan2(m2[3], m2[2]);
    sy = Math.sqrt(sy) * Math.cos(shearX);
    sx = Math.sqrt(sx);
    this.skewX = shearX;
    this.skewY = 0;
    this.rotation = -rotation;
    this.x = +m2[4];
    this.y = +m2[5];
    this.scaleX = sx;
    this.scaleY = sy;
    this.originX = 0;
    this.originY = 0;
  };
  Transformable2.prototype.decomposeTransform = function() {
    if (!this.transform) {
      return;
    }
    var parent = this.parent;
    var m2 = this.transform;
    if (parent && parent.transform) {
      mul(tmpTransform, parent.invTransform, m2);
      m2 = tmpTransform;
    }
    var ox = this.originX;
    var oy = this.originY;
    if (ox || oy) {
      originTransform[4] = ox;
      originTransform[5] = oy;
      mul(tmpTransform, m2, originTransform);
      tmpTransform[4] -= ox;
      tmpTransform[5] -= oy;
      m2 = tmpTransform;
    }
    this.setLocalTransform(m2);
  };
  Transformable2.prototype.getGlobalScale = function(out2) {
    var m2 = this.transform;
    out2 = out2 || [];
    if (!m2) {
      out2[0] = 1;
      out2[1] = 1;
      return out2;
    }
    out2[0] = Math.sqrt(m2[0] * m2[0] + m2[1] * m2[1]);
    out2[1] = Math.sqrt(m2[2] * m2[2] + m2[3] * m2[3]);
    if (m2[0] < 0) {
      out2[0] = -out2[0];
    }
    if (m2[3] < 0) {
      out2[1] = -out2[1];
    }
    return out2;
  };
  Transformable2.prototype.transformCoordToLocal = function(x2, y2) {
    var v22 = [x2, y2];
    var invTransform = this.invTransform;
    if (invTransform) {
      applyTransform$1(v22, v22, invTransform);
    }
    return v22;
  };
  Transformable2.prototype.transformCoordToGlobal = function(x2, y2) {
    var v22 = [x2, y2];
    var transform2 = this.transform;
    if (transform2) {
      applyTransform$1(v22, v22, transform2);
    }
    return v22;
  };
  Transformable2.prototype.getLineScale = function() {
    var m2 = this.transform;
    return m2 && abs(m2[0] - 1) > 1e-10 && abs(m2[3] - 1) > 1e-10 ? Math.sqrt(abs(m2[0] * m2[3] - m2[2] * m2[1])) : 1;
  };
  Transformable2.prototype.copyTransform = function(source) {
    copyTransform(this, source);
  };
  Transformable2.getLocalTransform = function(target, m2) {
    m2 = m2 || [];
    var ox = target.originX || 0;
    var oy = target.originY || 0;
    var sx = target.scaleX;
    var sy = target.scaleY;
    var ax = target.anchorX;
    var ay = target.anchorY;
    var rotation = target.rotation || 0;
    var x2 = target.x;
    var y2 = target.y;
    var skewX = target.skewX ? Math.tan(target.skewX) : 0;
    var skewY = target.skewY ? Math.tan(-target.skewY) : 0;
    if (ox || oy || ax || ay) {
      var dx = ox + ax;
      var dy = oy + ay;
      m2[4] = -dx * sx - skewX * dy * sy;
      m2[5] = -dy * sy - skewY * dx * sx;
    } else {
      m2[4] = m2[5] = 0;
    }
    m2[0] = sx;
    m2[3] = sy;
    m2[1] = skewY * sx;
    m2[2] = skewX * sy;
    rotation && rotate(m2, m2, rotation);
    m2[4] += ox + x2;
    m2[5] += oy + y2;
    return m2;
  };
  Transformable2.initDefaultProps = function() {
    var proto2 = Transformable2.prototype;
    proto2.scaleX = proto2.scaleY = proto2.globalScaleRatio = 1;
    proto2.x = proto2.y = proto2.originX = proto2.originY = proto2.skewX = proto2.skewY = proto2.rotation = proto2.anchorX = proto2.anchorY = 0;
  }();
  return Transformable2;
}();
var TRANSFORMABLE_PROPS = [
  "x",
  "y",
  "originX",
  "originY",
  "anchorX",
  "anchorY",
  "rotation",
  "scaleX",
  "scaleY",
  "skewX",
  "skewY"
];
function copyTransform(target, source) {
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var propName = TRANSFORMABLE_PROPS[i];
    target[propName] = source[propName];
  }
}
var Transformable$1 = Transformable;
var Point = function() {
  function Point2(x2, y2) {
    this.x = x2 || 0;
    this.y = y2 || 0;
  }
  Point2.prototype.copy = function(other) {
    this.x = other.x;
    this.y = other.y;
    return this;
  };
  Point2.prototype.clone = function() {
    return new Point2(this.x, this.y);
  };
  Point2.prototype.set = function(x2, y2) {
    this.x = x2;
    this.y = y2;
    return this;
  };
  Point2.prototype.equal = function(other) {
    return other.x === this.x && other.y === this.y;
  };
  Point2.prototype.add = function(other) {
    this.x += other.x;
    this.y += other.y;
    return this;
  };
  Point2.prototype.scale = function(scalar) {
    this.x *= scalar;
    this.y *= scalar;
  };
  Point2.prototype.scaleAndAdd = function(other, scalar) {
    this.x += other.x * scalar;
    this.y += other.y * scalar;
  };
  Point2.prototype.sub = function(other) {
    this.x -= other.x;
    this.y -= other.y;
    return this;
  };
  Point2.prototype.dot = function(other) {
    return this.x * other.x + this.y * other.y;
  };
  Point2.prototype.len = function() {
    return Math.sqrt(this.x * this.x + this.y * this.y);
  };
  Point2.prototype.lenSquare = function() {
    return this.x * this.x + this.y * this.y;
  };
  Point2.prototype.normalize = function() {
    var len2 = this.len();
    this.x /= len2;
    this.y /= len2;
    return this;
  };
  Point2.prototype.distance = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return Math.sqrt(dx * dx + dy * dy);
  };
  Point2.prototype.distanceSquare = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return dx * dx + dy * dy;
  };
  Point2.prototype.negate = function() {
    this.x = -this.x;
    this.y = -this.y;
    return this;
  };
  Point2.prototype.transform = function(m2) {
    if (!m2) {
      return;
    }
    var x2 = this.x;
    var y2 = this.y;
    this.x = m2[0] * x2 + m2[2] * y2 + m2[4];
    this.y = m2[1] * x2 + m2[3] * y2 + m2[5];
    return this;
  };
  Point2.prototype.toArray = function(out2) {
    out2[0] = this.x;
    out2[1] = this.y;
    return out2;
  };
  Point2.prototype.fromArray = function(input) {
    this.x = input[0];
    this.y = input[1];
  };
  Point2.set = function(p2, x2, y2) {
    p2.x = x2;
    p2.y = y2;
  };
  Point2.copy = function(p2, p22) {
    p2.x = p22.x;
    p2.y = p22.y;
  };
  Point2.len = function(p2) {
    return Math.sqrt(p2.x * p2.x + p2.y * p2.y);
  };
  Point2.lenSquare = function(p2) {
    return p2.x * p2.x + p2.y * p2.y;
  };
  Point2.dot = function(p0, p1) {
    return p0.x * p1.x + p0.y * p1.y;
  };
  Point2.add = function(out2, p0, p1) {
    out2.x = p0.x + p1.x;
    out2.y = p0.y + p1.y;
  };
  Point2.sub = function(out2, p0, p1) {
    out2.x = p0.x - p1.x;
    out2.y = p0.y - p1.y;
  };
  Point2.scale = function(out2, p0, scalar) {
    out2.x = p0.x * scalar;
    out2.y = p0.y * scalar;
  };
  Point2.scaleAndAdd = function(out2, p0, p1, scalar) {
    out2.x = p0.x + p1.x * scalar;
    out2.y = p0.y + p1.y * scalar;
  };
  Point2.lerp = function(out2, p0, p1, t2) {
    var onet = 1 - t2;
    out2.x = onet * p0.x + t2 * p1.x;
    out2.y = onet * p0.y + t2 * p1.y;
  };
  return Point2;
}();
var Point$1 = Point;
var mathMin$a = Math.min;
var mathMax$a = Math.max;
var lt = new Point$1();
var rb = new Point$1();
var lb = new Point$1();
var rt = new Point$1();
var minTv$1 = new Point$1();
var maxTv$1 = new Point$1();
var BoundingRect = function() {
  function BoundingRect2(x2, y2, width, height) {
    if (width < 0) {
      x2 = x2 + width;
      width = -width;
    }
    if (height < 0) {
      y2 = y2 + height;
      height = -height;
    }
    this.x = x2;
    this.y = y2;
    this.width = width;
    this.height = height;
  }
  BoundingRect2.prototype.union = function(other) {
    var x2 = mathMin$a(other.x, this.x);
    var y2 = mathMin$a(other.y, this.y);
    if (isFinite(this.x) && isFinite(this.width)) {
      this.width = mathMax$a(other.x + other.width, this.x + this.width) - x2;
    } else {
      this.width = other.width;
    }
    if (isFinite(this.y) && isFinite(this.height)) {
      this.height = mathMax$a(other.y + other.height, this.y + this.height) - y2;
    } else {
      this.height = other.height;
    }
    this.x = x2;
    this.y = y2;
  };
  BoundingRect2.prototype.applyTransform = function(m2) {
    BoundingRect2.applyTransform(this, this, m2);
  };
  BoundingRect2.prototype.calculateTransform = function(b2) {
    var a = this;
    var sx = b2.width / a.width;
    var sy = b2.height / a.height;
    var m2 = create$1();
    translate(m2, m2, [-a.x, -a.y]);
    scale$1(m2, m2, [sx, sy]);
    translate(m2, m2, [b2.x, b2.y]);
    return m2;
  };
  BoundingRect2.prototype.intersect = function(b2, mtv) {
    if (!b2) {
      return false;
    }
    if (!(b2 instanceof BoundingRect2)) {
      b2 = BoundingRect2.create(b2);
    }
    var a = this;
    var ax0 = a.x;
    var ax1 = a.x + a.width;
    var ay0 = a.y;
    var ay1 = a.y + a.height;
    var bx0 = b2.x;
    var bx1 = b2.x + b2.width;
    var by0 = b2.y;
    var by1 = b2.y + b2.height;
    var overlap = !(ax1 < bx0 || bx1 < ax0 || ay1 < by0 || by1 < ay0);
    if (mtv) {
      var dMin = Infinity;
      var dMax = 0;
      var d0 = Math.abs(ax1 - bx0);
      var d1 = Math.abs(bx1 - ax0);
      var d2 = Math.abs(ay1 - by0);
      var d3 = Math.abs(by1 - ay0);
      var dx = Math.min(d0, d1);
      var dy = Math.min(d2, d3);
      if (ax1 < bx0 || bx1 < ax0) {
        if (dx > dMax) {
          dMax = dx;
          if (d0 < d1) {
            Point$1.set(maxTv$1, -d0, 0);
          } else {
            Point$1.set(maxTv$1, d1, 0);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d0 < d1) {
            Point$1.set(minTv$1, d0, 0);
          } else {
            Point$1.set(minTv$1, -d1, 0);
          }
        }
      }
      if (ay1 < by0 || by1 < ay0) {
        if (dy > dMax) {
          dMax = dy;
          if (d2 < d3) {
            Point$1.set(maxTv$1, 0, -d2);
          } else {
            Point$1.set(maxTv$1, 0, d3);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d2 < d3) {
            Point$1.set(minTv$1, 0, d2);
          } else {
            Point$1.set(minTv$1, 0, -d3);
          }
        }
      }
    }
    if (mtv) {
      Point$1.copy(mtv, overlap ? minTv$1 : maxTv$1);
    }
    return overlap;
  };
  BoundingRect2.prototype.contain = function(x2, y2) {
    var rect = this;
    return x2 >= rect.x && x2 <= rect.x + rect.width && y2 >= rect.y && y2 <= rect.y + rect.height;
  };
  BoundingRect2.prototype.clone = function() {
    return new BoundingRect2(this.x, this.y, this.width, this.height);
  };
  BoundingRect2.prototype.copy = function(other) {
    BoundingRect2.copy(this, other);
  };
  BoundingRect2.prototype.plain = function() {
    return {
      x: this.x,
      y: this.y,
      width: this.width,
      height: this.height
    };
  };
  BoundingRect2.prototype.isFinite = function() {
    return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
  };
  BoundingRect2.prototype.isZero = function() {
    return this.width === 0 || this.height === 0;
  };
  BoundingRect2.create = function(rect) {
    return new BoundingRect2(rect.x, rect.y, rect.width, rect.height);
  };
  BoundingRect2.copy = function(target, source) {
    target.x = source.x;
    target.y = source.y;
    target.width = source.width;
    target.height = source.height;
  };
  BoundingRect2.applyTransform = function(target, source, m2) {
    if (!m2) {
      if (target !== source) {
        BoundingRect2.copy(target, source);
      }
      return;
    }
    if (m2[1] < 1e-5 && m2[1] > -1e-5 && m2[2] < 1e-5 && m2[2] > -1e-5) {
      var sx = m2[0];
      var sy = m2[3];
      var tx = m2[4];
      var ty = m2[5];
      target.x = source.x * sx + tx;
      target.y = source.y * sy + ty;
      target.width = source.width * sx;
      target.height = source.height * sy;
      if (target.width < 0) {
        target.x += target.width;
        target.width = -target.width;
      }
      if (target.height < 0) {
        target.y += target.height;
        target.height = -target.height;
      }
      return;
    }
    lt.x = lb.x = source.x;
    lt.y = rt.y = source.y;
    rb.x = rt.x = source.x + source.width;
    rb.y = lb.y = source.y + source.height;
    lt.transform(m2);
    rt.transform(m2);
    rb.transform(m2);
    lb.transform(m2);
    target.x = mathMin$a(lt.x, rb.x, lb.x, rt.x);
    target.y = mathMin$a(lt.y, rb.y, lb.y, rt.y);
    var maxX = mathMax$a(lt.x, rb.x, lb.x, rt.x);
    var maxY = mathMax$a(lt.y, rb.y, lb.y, rt.y);
    target.width = maxX - target.x;
    target.height = maxY - target.y;
  };
  return BoundingRect2;
}();
var BoundingRect$1 = BoundingRect;
var textWidthCache = {};
function getWidth(text, font) {
  font = font || DEFAULT_FONT;
  var cacheOfFont = textWidthCache[font];
  if (!cacheOfFont) {
    cacheOfFont = textWidthCache[font] = new LRU$1(500);
  }
  var width = cacheOfFont.get(text);
  if (width == null) {
    width = platformApi.measureText(text, font).width;
    cacheOfFont.put(text, width);
  }
  return width;
}
function innerGetBoundingRect(text, font, textAlign, textBaseline) {
  var width = getWidth(text, font);
  var height = getLineHeight(font);
  var x2 = adjustTextX(0, width, textAlign);
  var y2 = adjustTextY(0, height, textBaseline);
  var rect = new BoundingRect$1(x2, y2, width, height);
  return rect;
}
function getBoundingRect(text, font, textAlign, textBaseline) {
  var textLines = ((text || "") + "").split("\n");
  var len2 = textLines.length;
  if (len2 === 1) {
    return innerGetBoundingRect(textLines[0], font, textAlign, textBaseline);
  } else {
    var uniondRect = new BoundingRect$1(0, 0, 0, 0);
    for (var i = 0; i < textLines.length; i++) {
      var rect = innerGetBoundingRect(textLines[i], font, textAlign, textBaseline);
      i === 0 ? uniondRect.copy(rect) : uniondRect.union(rect);
    }
    return uniondRect;
  }
}
function adjustTextX(x2, width, textAlign) {
  if (textAlign === "right") {
    x2 -= width;
  } else if (textAlign === "center") {
    x2 -= width / 2;
  }
  return x2;
}
function adjustTextY(y2, height, verticalAlign) {
  if (verticalAlign === "middle") {
    y2 -= height / 2;
  } else if (verticalAlign === "bottom") {
    y2 -= height;
  }
  return y2;
}
function getLineHeight(font) {
  return getWidth("\u56FD", font);
}
function parsePercent$1(value, maxValue) {
  if (typeof value === "string") {
    if (value.lastIndexOf("%") >= 0) {
      return parseFloat(value) / 100 * maxValue;
    }
    return parseFloat(value);
  }
  return value;
}
function calculateTextPosition(out2, opts, rect) {
  var textPosition = opts.position || "inside";
  var distance2 = opts.distance != null ? opts.distance : 5;
  var height = rect.height;
  var width = rect.width;
  var halfHeight = height / 2;
  var x2 = rect.x;
  var y2 = rect.y;
  var textAlign = "left";
  var textVerticalAlign = "top";
  if (textPosition instanceof Array) {
    x2 += parsePercent$1(textPosition[0], rect.width);
    y2 += parsePercent$1(textPosition[1], rect.height);
    textAlign = null;
    textVerticalAlign = null;
  } else {
    switch (textPosition) {
      case "left":
        x2 -= distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "right":
        x2 += distance2 + width;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "top":
        x2 += width / 2;
        y2 -= distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "bottom":
        x2 += width / 2;
        y2 += height + distance2;
        textAlign = "center";
        break;
      case "inside":
        x2 += width / 2;
        y2 += halfHeight;
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "insideLeft":
        x2 += distance2;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "insideRight":
        x2 += width - distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideTop":
        x2 += width / 2;
        y2 += distance2;
        textAlign = "center";
        break;
      case "insideBottom":
        x2 += width / 2;
        y2 += height - distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideTopLeft":
        x2 += distance2;
        y2 += distance2;
        break;
      case "insideTopRight":
        x2 += width - distance2;
        y2 += distance2;
        textAlign = "right";
        break;
      case "insideBottomLeft":
        x2 += distance2;
        y2 += height - distance2;
        textVerticalAlign = "bottom";
        break;
      case "insideBottomRight":
        x2 += width - distance2;
        y2 += height - distance2;
        textAlign = "right";
        textVerticalAlign = "bottom";
        break;
    }
  }
  out2 = out2 || {};
  out2.x = x2;
  out2.y = y2;
  out2.align = textAlign;
  out2.verticalAlign = textVerticalAlign;
  return out2;
}
var PRESERVED_NORMAL_STATE = "__zr_normal__";
var PRIMARY_STATES_KEYS$1 = TRANSFORMABLE_PROPS.concat(["ignore"]);
var DEFAULT_ANIMATABLE_MAP = reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = true;
  return obj;
}, { ignore: false });
var tmpTextPosCalcRes = {};
var tmpBoundingRect = new BoundingRect$1(0, 0, 0, 0);
var Element$1 = function() {
  function Element2(props) {
    this.id = guid();
    this.animators = [];
    this.currentStates = [];
    this.states = {};
    this._init(props);
  }
  Element2.prototype._init = function(props) {
    this.attr(props);
  };
  Element2.prototype.drift = function(dx, dy, e2) {
    switch (this.draggable) {
      case "horizontal":
        dy = 0;
        break;
      case "vertical":
        dx = 0;
        break;
    }
    var m2 = this.transform;
    if (!m2) {
      m2 = this.transform = [1, 0, 0, 1, 0, 0];
    }
    m2[4] += dx;
    m2[5] += dy;
    this.decomposeTransform();
    this.markRedraw();
  };
  Element2.prototype.beforeUpdate = function() {
  };
  Element2.prototype.afterUpdate = function() {
  };
  Element2.prototype.update = function() {
    this.updateTransform();
    if (this.__dirty) {
      this.updateInnerText();
    }
  };
  Element2.prototype.updateInnerText = function(forceUpdate) {
    var textEl = this._textContent;
    if (textEl && (!textEl.ignore || forceUpdate)) {
      if (!this.textConfig) {
        this.textConfig = {};
      }
      var textConfig = this.textConfig;
      var isLocal = textConfig.local;
      var innerTransformable = textEl.innerTransformable;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var textStyleChanged = false;
      innerTransformable.parent = isLocal ? this : null;
      var innerOrigin = false;
      innerTransformable.copyTransform(textEl);
      if (textConfig.position != null) {
        var layoutRect = tmpBoundingRect;
        if (textConfig.layoutRect) {
          layoutRect.copy(textConfig.layoutRect);
        } else {
          layoutRect.copy(this.getBoundingRect());
        }
        if (!isLocal) {
          layoutRect.applyTransform(this.transform);
        }
        if (this.calculateTextPosition) {
          this.calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        } else {
          calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        }
        innerTransformable.x = tmpTextPosCalcRes.x;
        innerTransformable.y = tmpTextPosCalcRes.y;
        textAlign = tmpTextPosCalcRes.align;
        textVerticalAlign = tmpTextPosCalcRes.verticalAlign;
        var textOrigin = textConfig.origin;
        if (textOrigin && textConfig.rotation != null) {
          var relOriginX = void 0;
          var relOriginY = void 0;
          if (textOrigin === "center") {
            relOriginX = layoutRect.width * 0.5;
            relOriginY = layoutRect.height * 0.5;
          } else {
            relOriginX = parsePercent$1(textOrigin[0], layoutRect.width);
            relOriginY = parsePercent$1(textOrigin[1], layoutRect.height);
          }
          innerOrigin = true;
          innerTransformable.originX = -innerTransformable.x + relOriginX + (isLocal ? 0 : layoutRect.x);
          innerTransformable.originY = -innerTransformable.y + relOriginY + (isLocal ? 0 : layoutRect.y);
        }
      }
      if (textConfig.rotation != null) {
        innerTransformable.rotation = textConfig.rotation;
      }
      var textOffset = textConfig.offset;
      if (textOffset) {
        innerTransformable.x += textOffset[0];
        innerTransformable.y += textOffset[1];
        if (!innerOrigin) {
          innerTransformable.originX = -textOffset[0];
          innerTransformable.originY = -textOffset[1];
        }
      }
      var isInside = textConfig.inside == null ? typeof textConfig.position === "string" && textConfig.position.indexOf("inside") >= 0 : textConfig.inside;
      var innerTextDefaultStyle = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {});
      var textFill = void 0;
      var textStroke = void 0;
      var autoStroke = void 0;
      if (isInside && this.canBeInsideText()) {
        textFill = textConfig.insideFill;
        textStroke = textConfig.insideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getInsideTextFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getInsideTextStroke(textFill);
          autoStroke = true;
        }
      } else {
        textFill = textConfig.outsideFill;
        textStroke = textConfig.outsideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getOutsideFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getOutsideStroke(textFill);
          autoStroke = true;
        }
      }
      textFill = textFill || "#000";
      if (textFill !== innerTextDefaultStyle.fill || textStroke !== innerTextDefaultStyle.stroke || autoStroke !== innerTextDefaultStyle.autoStroke || textAlign !== innerTextDefaultStyle.align || textVerticalAlign !== innerTextDefaultStyle.verticalAlign) {
        textStyleChanged = true;
        innerTextDefaultStyle.fill = textFill;
        innerTextDefaultStyle.stroke = textStroke;
        innerTextDefaultStyle.autoStroke = autoStroke;
        innerTextDefaultStyle.align = textAlign;
        innerTextDefaultStyle.verticalAlign = textVerticalAlign;
        textEl.setDefaultTextStyle(innerTextDefaultStyle);
      }
      textEl.__dirty |= REDRAW_BIT;
      if (textStyleChanged) {
        textEl.dirtyStyle(true);
      }
    }
  };
  Element2.prototype.canBeInsideText = function() {
    return true;
  };
  Element2.prototype.getInsideTextFill = function() {
    return "#fff";
  };
  Element2.prototype.getInsideTextStroke = function(textFill) {
    return "#000";
  };
  Element2.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? LIGHT_LABEL_COLOR : DARK_LABEL_COLOR;
  };
  Element2.prototype.getOutsideStroke = function(textFill) {
    var backgroundColor2 = this.__zr && this.__zr.getBackgroundColor();
    var colorArr = typeof backgroundColor2 === "string" && parse(backgroundColor2);
    if (!colorArr) {
      colorArr = [255, 255, 255, 1];
    }
    var alpha = colorArr[3];
    var isDark = this.__zr.isDarkMode();
    for (var i = 0; i < 3; i++) {
      colorArr[i] = colorArr[i] * alpha + (isDark ? 0 : 255) * (1 - alpha);
    }
    colorArr[3] = 1;
    return stringify(colorArr, "rgba");
  };
  Element2.prototype.traverse = function(cb, context) {
  };
  Element2.prototype.attrKV = function(key, value) {
    if (key === "textConfig") {
      this.setTextConfig(value);
    } else if (key === "textContent") {
      this.setTextContent(value);
    } else if (key === "clipPath") {
      this.setClipPath(value);
    } else if (key === "extra") {
      this.extra = this.extra || {};
      extend(this.extra, value);
    } else {
      this[key] = value;
    }
  };
  Element2.prototype.hide = function() {
    this.ignore = true;
    this.markRedraw();
  };
  Element2.prototype.show = function() {
    this.ignore = false;
    this.markRedraw();
  };
  Element2.prototype.attr = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.attrKV(keyOrObj, value);
    } else if (isObject$4(keyOrObj)) {
      var obj = keyOrObj;
      var keysArr = keys(obj);
      for (var i = 0; i < keysArr.length; i++) {
        var key = keysArr[i];
        this.attrKV(key, keyOrObj[key]);
      }
    }
    this.markRedraw();
    return this;
  };
  Element2.prototype.saveCurrentToNormalState = function(toState) {
    this._innerSaveToNormal(toState);
    var normalState = this._normalState;
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      var fromStateTransition = animator.__fromStateTransition;
      if (animator.getLoop() || fromStateTransition && fromStateTransition !== PRESERVED_NORMAL_STATE) {
        continue;
      }
      var targetName = animator.targetName;
      var target = targetName ? normalState[targetName] : normalState;
      animator.saveTo(target);
    }
  };
  Element2.prototype._innerSaveToNormal = function(toState) {
    var normalState = this._normalState;
    if (!normalState) {
      normalState = this._normalState = {};
    }
    if (toState.textConfig && !normalState.textConfig) {
      normalState.textConfig = this.textConfig;
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS$1);
  };
  Element2.prototype._savePrimaryToNormal = function(toState, normalState, primaryKeys) {
    for (var i = 0; i < primaryKeys.length; i++) {
      var key = primaryKeys[i];
      if (toState[key] != null && !(key in normalState)) {
        normalState[key] = this[key];
      }
    }
  };
  Element2.prototype.hasState = function() {
    return this.currentStates.length > 0;
  };
  Element2.prototype.getState = function(name) {
    return this.states[name];
  };
  Element2.prototype.ensureState = function(name) {
    var states = this.states;
    if (!states[name]) {
      states[name] = {};
    }
    return states[name];
  };
  Element2.prototype.clearStates = function(noAnimation) {
    this.useState(PRESERVED_NORMAL_STATE, false, noAnimation);
  };
  Element2.prototype.useState = function(stateName, keepCurrentStates, noAnimation, forceUseHoverLayer) {
    var toNormalState = stateName === PRESERVED_NORMAL_STATE;
    var hasStates = this.hasState();
    if (!hasStates && toNormalState) {
      return;
    }
    var currentStates = this.currentStates;
    var animationCfg = this.stateTransition;
    if (indexOf(currentStates, stateName) >= 0 && (keepCurrentStates || currentStates.length === 1)) {
      return;
    }
    var state;
    if (this.stateProxy && !toNormalState) {
      state = this.stateProxy(stateName);
    }
    if (!state) {
      state = this.states && this.states[stateName];
    }
    if (!state && !toNormalState) {
      logError("State " + stateName + " not exists.");
      return;
    }
    if (!toNormalState) {
      this.saveCurrentToNormalState(state);
    }
    var useHoverLayer = !!(state && state.hoverLayer || forceUseHoverLayer);
    if (useHoverLayer) {
      this._toggleHoverLayerFlag(true);
    }
    this._applyStateObj(stateName, state, this._normalState, keepCurrentStates, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (textGuide) {
      textGuide.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (toNormalState) {
      this.currentStates = [];
      this._normalState = {};
    } else {
      if (!keepCurrentStates) {
        this.currentStates = [stateName];
      } else {
        this.currentStates.push(stateName);
      }
    }
    this._updateAnimationTargets();
    this.markRedraw();
    if (!useHoverLayer && this.__inHover) {
      this._toggleHoverLayerFlag(false);
      this.__dirty &= ~REDRAW_BIT;
    }
    return state;
  };
  Element2.prototype.useStates = function(states, noAnimation, forceUseHoverLayer) {
    if (!states.length) {
      this.clearStates();
    } else {
      var stateObjects = [];
      var currentStates = this.currentStates;
      var len2 = states.length;
      var notChange = len2 === currentStates.length;
      if (notChange) {
        for (var i = 0; i < len2; i++) {
          if (states[i] !== currentStates[i]) {
            notChange = false;
            break;
          }
        }
      }
      if (notChange) {
        return;
      }
      for (var i = 0; i < len2; i++) {
        var stateName = states[i];
        var stateObj = void 0;
        if (this.stateProxy) {
          stateObj = this.stateProxy(stateName, states);
        }
        if (!stateObj) {
          stateObj = this.states[stateName];
        }
        if (stateObj) {
          stateObjects.push(stateObj);
        }
      }
      var lastStateObj = stateObjects[len2 - 1];
      var useHoverLayer = !!(lastStateObj && lastStateObj.hoverLayer || forceUseHoverLayer);
      if (useHoverLayer) {
        this._toggleHoverLayerFlag(true);
      }
      var mergedState = this._mergeStates(stateObjects);
      var animationCfg = this.stateTransition;
      this.saveCurrentToNormalState(mergedState);
      this._applyStateObj(states.join(","), mergedState, this._normalState, false, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
      var textContent = this._textContent;
      var textGuide = this._textGuide;
      if (textContent) {
        textContent.useStates(states, noAnimation, useHoverLayer);
      }
      if (textGuide) {
        textGuide.useStates(states, noAnimation, useHoverLayer);
      }
      this._updateAnimationTargets();
      this.currentStates = states.slice();
      this.markRedraw();
      if (!useHoverLayer && this.__inHover) {
        this._toggleHoverLayerFlag(false);
        this.__dirty &= ~REDRAW_BIT;
      }
    }
  };
  Element2.prototype._updateAnimationTargets = function() {
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      if (animator.targetName) {
        animator.changeTarget(this[animator.targetName]);
      }
    }
  };
  Element2.prototype.removeState = function(state) {
    var idx = indexOf(this.currentStates, state);
    if (idx >= 0) {
      var currentStates = this.currentStates.slice();
      currentStates.splice(idx, 1);
      this.useStates(currentStates);
    }
  };
  Element2.prototype.replaceState = function(oldState, newState, forceAdd) {
    var currentStates = this.currentStates.slice();
    var idx = indexOf(currentStates, oldState);
    var newStateExists = indexOf(currentStates, newState) >= 0;
    if (idx >= 0) {
      if (!newStateExists) {
        currentStates[idx] = newState;
      } else {
        currentStates.splice(idx, 1);
      }
    } else if (forceAdd && !newStateExists) {
      currentStates.push(newState);
    }
    this.useStates(currentStates);
  };
  Element2.prototype.toggleState = function(state, enable) {
    if (enable) {
      this.useState(state, true);
    } else {
      this.removeState(state);
    }
  };
  Element2.prototype._mergeStates = function(states) {
    var mergedState = {};
    var mergedTextConfig;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      extend(mergedState, state);
      if (state.textConfig) {
        mergedTextConfig = mergedTextConfig || {};
        extend(mergedTextConfig, state.textConfig);
      }
    }
    if (mergedTextConfig) {
      mergedState.textConfig = mergedTextConfig;
    }
    return mergedState;
  };
  Element2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    var needsRestoreToNormal = !(state && keepCurrentStates);
    if (state && state.textConfig) {
      this.textConfig = extend({}, keepCurrentStates ? this.textConfig : normalState.textConfig);
      extend(this.textConfig, state.textConfig);
    } else if (needsRestoreToNormal) {
      if (normalState.textConfig) {
        this.textConfig = normalState.textConfig;
      }
    }
    var transitionTarget = {};
    var hasTransition = false;
    for (var i = 0; i < PRIMARY_STATES_KEYS$1.length; i++) {
      var key = PRIMARY_STATES_KEYS$1[i];
      var propNeedsTransition = transition && DEFAULT_ANIMATABLE_MAP[key];
      if (state && state[key] != null) {
        if (propNeedsTransition) {
          hasTransition = true;
          transitionTarget[key] = state[key];
        } else {
          this[key] = state[key];
        }
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          if (propNeedsTransition) {
            hasTransition = true;
            transitionTarget[key] = normalState[key];
          } else {
            this[key] = normalState[key];
          }
        }
      }
    }
    if (!transition) {
      for (var i = 0; i < this.animators.length; i++) {
        var animator = this.animators[i];
        var targetName = animator.targetName;
        if (!animator.getLoop()) {
          animator.__changeFinalValue(targetName ? (state || normalState)[targetName] : state || normalState);
        }
      }
    }
    if (hasTransition) {
      this._transitionState(stateName, transitionTarget, animationCfg);
    }
  };
  Element2.prototype._attachComponent = function(componentEl) {
    if (componentEl.__zr && !componentEl.__hostTarget) {
      return;
    }
    if (componentEl === this) {
      return;
    }
    var zr = this.__zr;
    if (zr) {
      componentEl.addSelfToZr(zr);
    }
    componentEl.__zr = zr;
    componentEl.__hostTarget = this;
  };
  Element2.prototype._detachComponent = function(componentEl) {
    if (componentEl.__zr) {
      componentEl.removeSelfFromZr(componentEl.__zr);
    }
    componentEl.__zr = null;
    componentEl.__hostTarget = null;
  };
  Element2.prototype.getClipPath = function() {
    return this._clipPath;
  };
  Element2.prototype.setClipPath = function(clipPath) {
    if (this._clipPath && this._clipPath !== clipPath) {
      this.removeClipPath();
    }
    this._attachComponent(clipPath);
    this._clipPath = clipPath;
    this.markRedraw();
  };
  Element2.prototype.removeClipPath = function() {
    var clipPath = this._clipPath;
    if (clipPath) {
      this._detachComponent(clipPath);
      this._clipPath = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextContent = function() {
    return this._textContent;
  };
  Element2.prototype.setTextContent = function(textEl) {
    var previousTextContent = this._textContent;
    if (previousTextContent === textEl) {
      return;
    }
    if (previousTextContent && previousTextContent !== textEl) {
      this.removeTextContent();
    }
    textEl.innerTransformable = new Transformable$1();
    this._attachComponent(textEl);
    this._textContent = textEl;
    this.markRedraw();
  };
  Element2.prototype.setTextConfig = function(cfg) {
    if (!this.textConfig) {
      this.textConfig = {};
    }
    extend(this.textConfig, cfg);
    this.markRedraw();
  };
  Element2.prototype.removeTextConfig = function() {
    this.textConfig = null;
    this.markRedraw();
  };
  Element2.prototype.removeTextContent = function() {
    var textEl = this._textContent;
    if (textEl) {
      textEl.innerTransformable = null;
      this._detachComponent(textEl);
      this._textContent = null;
      this._innerTextDefaultStyle = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextGuideLine = function() {
    return this._textGuide;
  };
  Element2.prototype.setTextGuideLine = function(guideLine) {
    if (this._textGuide && this._textGuide !== guideLine) {
      this.removeTextGuideLine();
    }
    this._attachComponent(guideLine);
    this._textGuide = guideLine;
    this.markRedraw();
  };
  Element2.prototype.removeTextGuideLine = function() {
    var textGuide = this._textGuide;
    if (textGuide) {
      this._detachComponent(textGuide);
      this._textGuide = null;
      this.markRedraw();
    }
  };
  Element2.prototype.markRedraw = function() {
    this.__dirty |= REDRAW_BIT;
    var zr = this.__zr;
    if (zr) {
      if (this.__inHover) {
        zr.refreshHover();
      } else {
        zr.refresh();
      }
    }
    if (this.__hostTarget) {
      this.__hostTarget.markRedraw();
    }
  };
  Element2.prototype.dirty = function() {
    this.markRedraw();
  };
  Element2.prototype._toggleHoverLayerFlag = function(inHover) {
    this.__inHover = inHover;
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.__inHover = inHover;
    }
    if (textGuide) {
      textGuide.__inHover = inHover;
    }
  };
  Element2.prototype.addSelfToZr = function(zr) {
    if (this.__zr === zr) {
      return;
    }
    this.__zr = zr;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.addAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.addSelfToZr(zr);
    }
    if (this._textContent) {
      this._textContent.addSelfToZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.addSelfToZr(zr);
    }
  };
  Element2.prototype.removeSelfFromZr = function(zr) {
    if (!this.__zr) {
      return;
    }
    this.__zr = null;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.removeAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.removeSelfFromZr(zr);
    }
    if (this._textContent) {
      this._textContent.removeSelfFromZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.removeSelfFromZr(zr);
    }
  };
  Element2.prototype.animate = function(key, loop, allowDiscreteAnimation) {
    var target = key ? this[key] : this;
    var animator = new Animator(target, loop, allowDiscreteAnimation);
    key && (animator.targetName = key);
    this.addAnimator(animator, key);
    return animator;
  };
  Element2.prototype.addAnimator = function(animator, key) {
    var zr = this.__zr;
    var el = this;
    animator.during(function() {
      el.updateDuringAnimation(key);
    }).done(function() {
      var animators = el.animators;
      var idx = indexOf(animators, animator);
      if (idx >= 0) {
        animators.splice(idx, 1);
      }
    });
    this.animators.push(animator);
    if (zr) {
      zr.animation.addAnimator(animator);
    }
    zr && zr.wakeUp();
  };
  Element2.prototype.updateDuringAnimation = function(key) {
    this.markRedraw();
  };
  Element2.prototype.stopAnimation = function(scope, forwardToLast) {
    var animators = this.animators;
    var len2 = animators.length;
    var leftAnimators = [];
    for (var i = 0; i < len2; i++) {
      var animator = animators[i];
      if (!scope || scope === animator.scope) {
        animator.stop(forwardToLast);
      } else {
        leftAnimators.push(animator);
      }
    }
    this.animators = leftAnimators;
    return this;
  };
  Element2.prototype.animateTo = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps);
  };
  Element2.prototype.animateFrom = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps, true);
  };
  Element2.prototype._transitionState = function(stateName, target, cfg, animationProps) {
    var animators = animateTo(this, target, cfg, animationProps);
    for (var i = 0; i < animators.length; i++) {
      animators[i].__fromStateTransition = stateName;
    }
  };
  Element2.prototype.getBoundingRect = function() {
    return null;
  };
  Element2.prototype.getPaintRect = function() {
    return null;
  };
  Element2.initDefaultProps = function() {
    var elProto = Element2.prototype;
    elProto.type = "element";
    elProto.name = "";
    elProto.ignore = elProto.silent = elProto.isGroup = elProto.draggable = elProto.dragging = elProto.ignoreClip = elProto.__inHover = false;
    elProto.__dirty = REDRAW_BIT;
    function createLegacyProperty(key, privateKey, xKey, yKey) {
      Object.defineProperty(elProto, key, {
        get: function() {
          if (!this[privateKey]) {
            var pos = this[privateKey] = [];
            enhanceArray(this, pos);
          }
          return this[privateKey];
        },
        set: function(pos) {
          this[xKey] = pos[0];
          this[yKey] = pos[1];
          this[privateKey] = pos;
          enhanceArray(this, pos);
        }
      });
      function enhanceArray(self2, pos) {
        Object.defineProperty(pos, 0, {
          get: function() {
            return self2[xKey];
          },
          set: function(val) {
            self2[xKey] = val;
          }
        });
        Object.defineProperty(pos, 1, {
          get: function() {
            return self2[yKey];
          },
          set: function(val) {
            self2[yKey] = val;
          }
        });
      }
    }
    if (Object.defineProperty) {
      createLegacyProperty("position", "_legacyPos", "x", "y");
      createLegacyProperty("scale", "_legacyScale", "scaleX", "scaleY");
      createLegacyProperty("origin", "_legacyOrigin", "originX", "originY");
    }
  }();
  return Element2;
}();
mixin(Element$1, Eventful$1);
mixin(Element$1, Transformable$1);
function animateTo(animatable, target, cfg, animationProps, reverse2) {
  cfg = cfg || {};
  var animators = [];
  animateToShallow(animatable, "", animatable, target, cfg, animationProps, animators, reverse2);
  var finishCount = animators.length;
  var doneHappened = false;
  var cfgDone = cfg.done;
  var cfgAborted = cfg.aborted;
  var doneCb = function() {
    doneHappened = true;
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  var abortedCb = function() {
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  if (!finishCount) {
    cfgDone && cfgDone();
  }
  if (animators.length > 0 && cfg.during) {
    animators[0].during(function(target2, percent) {
      cfg.during(percent);
    });
  }
  for (var i = 0; i < animators.length; i++) {
    var animator = animators[i];
    if (doneCb) {
      animator.done(doneCb);
    }
    if (abortedCb) {
      animator.aborted(abortedCb);
    }
    if (cfg.force) {
      animator.duration(cfg.duration);
    }
    animator.start(cfg.easing);
  }
  return animators;
}
function copyArrShallow(source, target, len2) {
  for (var i = 0; i < len2; i++) {
    source[i] = target[i];
  }
}
function is2DArray(value) {
  return isArrayLike(value[0]);
}
function copyValue(target, source, key) {
  if (isArrayLike(source[key])) {
    if (!isArrayLike(target[key])) {
      target[key] = [];
    }
    if (isTypedArray(source[key])) {
      var len2 = source[key].length;
      if (target[key].length !== len2) {
        target[key] = new source[key].constructor(len2);
        copyArrShallow(target[key], source[key], len2);
      }
    } else {
      var sourceArr = source[key];
      var targetArr = target[key];
      var len0 = sourceArr.length;
      if (is2DArray(sourceArr)) {
        var len1 = sourceArr[0].length;
        for (var i = 0; i < len0; i++) {
          if (!targetArr[i]) {
            targetArr[i] = Array.prototype.slice.call(sourceArr[i]);
          } else {
            copyArrShallow(targetArr[i], sourceArr[i], len1);
          }
        }
      } else {
        copyArrShallow(targetArr, sourceArr, len0);
      }
      targetArr.length = sourceArr.length;
    }
  } else {
    target[key] = source[key];
  }
}
function isValueSame(val1, val2) {
  return val1 === val2 || isArrayLike(val1) && isArrayLike(val2) && is1DArraySame(val1, val2);
}
function is1DArraySame(arr0, arr1) {
  var len2 = arr0.length;
  if (len2 !== arr1.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    if (arr0[i] !== arr1[i]) {
      return false;
    }
  }
  return true;
}
function animateToShallow(animatable, topKey, animateObj, target, cfg, animationProps, animators, reverse2) {
  var targetKeys = keys(target);
  var duration = cfg.duration;
  var delay = cfg.delay;
  var additive = cfg.additive;
  var setToFinal = cfg.setToFinal;
  var animateAll = !isObject$4(animationProps);
  var existsAnimators = animatable.animators;
  var animationKeys = [];
  for (var k2 = 0; k2 < targetKeys.length; k2++) {
    var innerKey = targetKeys[k2];
    var targetVal = target[innerKey];
    if (targetVal != null && animateObj[innerKey] != null && (animateAll || animationProps[innerKey])) {
      if (isObject$4(targetVal) && !isArrayLike(targetVal) && !isGradientObject(targetVal)) {
        if (topKey) {
          if (!reverse2) {
            animateObj[innerKey] = targetVal;
            animatable.updateDuringAnimation(topKey);
          }
          continue;
        }
        animateToShallow(animatable, innerKey, animateObj[innerKey], targetVal, cfg, animationProps && animationProps[innerKey], animators, reverse2);
      } else {
        animationKeys.push(innerKey);
      }
    } else if (!reverse2) {
      animateObj[innerKey] = targetVal;
      animatable.updateDuringAnimation(topKey);
      animationKeys.push(innerKey);
    }
  }
  var keyLen = animationKeys.length;
  if (!additive && keyLen) {
    for (var i = 0; i < existsAnimators.length; i++) {
      var animator = existsAnimators[i];
      if (animator.targetName === topKey) {
        var allAborted = animator.stopTracks(animationKeys);
        if (allAborted) {
          var idx = indexOf(existsAnimators, animator);
          existsAnimators.splice(idx, 1);
        }
      }
    }
  }
  if (!cfg.force) {
    animationKeys = filter(animationKeys, function(key) {
      return !isValueSame(target[key], animateObj[key]);
    });
    keyLen = animationKeys.length;
  }
  if (keyLen > 0 || cfg.force && !animators.length) {
    var revertedSource = void 0;
    var reversedTarget = void 0;
    var sourceClone = void 0;
    if (reverse2) {
      reversedTarget = {};
      if (setToFinal) {
        revertedSource = {};
      }
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        reversedTarget[innerKey] = animateObj[innerKey];
        if (setToFinal) {
          revertedSource[innerKey] = target[innerKey];
        } else {
          animateObj[innerKey] = target[innerKey];
        }
      }
    } else if (setToFinal) {
      sourceClone = {};
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        sourceClone[innerKey] = cloneValue(animateObj[innerKey]);
        copyValue(animateObj, target, innerKey);
      }
    }
    var animator = new Animator(animateObj, false, false, additive ? filter(existsAnimators, function(animator2) {
      return animator2.targetName === topKey;
    }) : null);
    animator.targetName = topKey;
    if (cfg.scope) {
      animator.scope = cfg.scope;
    }
    if (setToFinal && revertedSource) {
      animator.whenWithKeys(0, revertedSource, animationKeys);
    }
    if (sourceClone) {
      animator.whenWithKeys(0, sourceClone, animationKeys);
    }
    animator.whenWithKeys(duration == null ? 500 : duration, reverse2 ? reversedTarget : target, animationKeys).delay(delay || 0);
    animatable.addAnimator(animator, topKey);
    animators.push(animator);
  }
}
var Element$2 = Element$1;
var Group$3 = function(_super) {
  __extends(Group2, _super);
  function Group2(opts) {
    var _this = _super.call(this) || this;
    _this.isGroup = true;
    _this._children = [];
    _this.attr(opts);
    return _this;
  }
  Group2.prototype.childrenRef = function() {
    return this._children;
  };
  Group2.prototype.children = function() {
    return this._children.slice();
  };
  Group2.prototype.childAt = function(idx) {
    return this._children[idx];
  };
  Group2.prototype.childOfName = function(name) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].name === name) {
        return children[i];
      }
    }
  };
  Group2.prototype.childCount = function() {
    return this._children.length;
  };
  Group2.prototype.add = function(child) {
    if (child) {
      if (child !== this && child.parent !== this) {
        this._children.push(child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.addBefore = function(child, nextSibling2) {
    if (child && child !== this && child.parent !== this && nextSibling2 && nextSibling2.parent === this) {
      var children = this._children;
      var idx = children.indexOf(nextSibling2);
      if (idx >= 0) {
        children.splice(idx, 0, child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.replace = function(oldChild, newChild) {
    var idx = indexOf(this._children, oldChild);
    if (idx >= 0) {
      this.replaceAt(newChild, idx);
    }
    return this;
  };
  Group2.prototype.replaceAt = function(child, index2) {
    var children = this._children;
    var old = children[index2];
    if (child && child !== this && child.parent !== this && child !== old) {
      children[index2] = child;
      old.parent = null;
      var zr = this.__zr;
      if (zr) {
        old.removeSelfFromZr(zr);
      }
      this._doAdd(child);
    }
    return this;
  };
  Group2.prototype._doAdd = function(child) {
    if (child.parent) {
      child.parent.remove(child);
    }
    child.parent = this;
    var zr = this.__zr;
    if (zr && zr !== child.__zr) {
      child.addSelfToZr(zr);
    }
    zr && zr.refresh();
  };
  Group2.prototype.remove = function(child) {
    var zr = this.__zr;
    var children = this._children;
    var idx = indexOf(children, child);
    if (idx < 0) {
      return this;
    }
    children.splice(idx, 1);
    child.parent = null;
    if (zr) {
      child.removeSelfFromZr(zr);
    }
    zr && zr.refresh();
    return this;
  };
  Group2.prototype.removeAll = function() {
    var children = this._children;
    var zr = this.__zr;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (zr) {
        child.removeSelfFromZr(zr);
      }
      child.parent = null;
    }
    children.length = 0;
    return this;
  };
  Group2.prototype.eachChild = function(cb, context) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      cb.call(context, child, i);
    }
    return this;
  };
  Group2.prototype.traverse = function(cb, context) {
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      var stopped = cb.call(context, child);
      if (child.isGroup && !stopped) {
        child.traverse(cb, context);
      }
    }
    return this;
  };
  Group2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.addSelfToZr(zr);
    }
  };
  Group2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.removeSelfFromZr(zr);
    }
  };
  Group2.prototype.getBoundingRect = function(includeChildren) {
    var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
    var children = includeChildren || this._children;
    var tmpMat = [];
    var rect = null;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child.ignore || child.invisible) {
        continue;
      }
      var childRect = child.getBoundingRect();
      var transform2 = child.getLocalTransform(tmpMat);
      if (transform2) {
        BoundingRect$1.applyTransform(tmpRect2, childRect, transform2);
        rect = rect || tmpRect2.clone();
        rect.union(tmpRect2);
      } else {
        rect = rect || childRect.clone();
        rect.union(childRect);
      }
    }
    return rect || tmpRect2;
  };
  return Group2;
}(Element$2);
Group$3.prototype.type = "group";
var Group$4 = Group$3;
/*!
* ZRender, a high performance 2d drawing library.
*
* Copyright (c) 2013, Baidu Inc.
* All rights reserved.
*
* LICENSE
* https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
*/
var painterCtors = {};
var instances$1 = {};
function delInstance(id2) {
  delete instances$1[id2];
}
function isDarkMode(backgroundColor2) {
  if (!backgroundColor2) {
    return false;
  }
  if (typeof backgroundColor2 === "string") {
    return lum(backgroundColor2, 1) < DARK_MODE_THRESHOLD;
  } else if (backgroundColor2.colorStops) {
    var colorStops = backgroundColor2.colorStops;
    var totalLum = 0;
    var len2 = colorStops.length;
    for (var i = 0; i < len2; i++) {
      totalLum += lum(colorStops[i].color, 1);
    }
    totalLum /= len2;
    return totalLum < DARK_MODE_THRESHOLD;
  }
  return false;
}
var ZRender = function() {
  function ZRender2(id2, dom, opts) {
    var _this = this;
    this._sleepAfterStill = 10;
    this._stillFrameAccum = 0;
    this._needsRefresh = true;
    this._needsRefreshHover = true;
    this._darkMode = false;
    opts = opts || {};
    this.dom = dom;
    this.id = id2;
    var storage2 = new Storage$1();
    var rendererType = opts.renderer || "canvas";
    if (!painterCtors[rendererType]) {
      rendererType = keys(painterCtors)[0];
    }
    opts.useDirtyRect = opts.useDirtyRect == null ? false : opts.useDirtyRect;
    var painter = new painterCtors[rendererType](dom, storage2, opts, id2);
    var ssrMode = opts.ssr || painter.ssrOnly;
    this.storage = storage2;
    this.painter = painter;
    var handerProxy = !env$1.node && !env$1.worker && !ssrMode ? new HandlerProxy(painter.getViewportRoot(), painter.root) : null;
    this.handler = new Handler$1(storage2, painter, handerProxy, painter.root);
    this.animation = new Animation$1({
      stage: {
        update: ssrMode ? null : function() {
          return _this._flush(true);
        }
      }
    });
    if (!ssrMode) {
      this.animation.start();
    }
  }
  ZRender2.prototype.add = function(el) {
    if (!el) {
      return;
    }
    this.storage.addRoot(el);
    el.addSelfToZr(this);
    this.refresh();
  };
  ZRender2.prototype.remove = function(el) {
    if (!el) {
      return;
    }
    this.storage.delRoot(el);
    el.removeSelfFromZr(this);
    this.refresh();
  };
  ZRender2.prototype.configLayer = function(zLevel, config) {
    if (this.painter.configLayer) {
      this.painter.configLayer(zLevel, config);
    }
    this.refresh();
  };
  ZRender2.prototype.setBackgroundColor = function(backgroundColor2) {
    if (this.painter.setBackgroundColor) {
      this.painter.setBackgroundColor(backgroundColor2);
    }
    this.refresh();
    this._backgroundColor = backgroundColor2;
    this._darkMode = isDarkMode(backgroundColor2);
  };
  ZRender2.prototype.getBackgroundColor = function() {
    return this._backgroundColor;
  };
  ZRender2.prototype.setDarkMode = function(darkMode) {
    this._darkMode = darkMode;
  };
  ZRender2.prototype.isDarkMode = function() {
    return this._darkMode;
  };
  ZRender2.prototype.refreshImmediately = function(fromInside) {
    if (!fromInside) {
      this.animation.update(true);
    }
    this._needsRefresh = false;
    this.painter.refresh();
    this._needsRefresh = false;
  };
  ZRender2.prototype.refresh = function() {
    this._needsRefresh = true;
    this.animation.start();
  };
  ZRender2.prototype.flush = function() {
    this._flush(false);
  };
  ZRender2.prototype._flush = function(fromInside) {
    var triggerRendered;
    var start2 = getTime();
    if (this._needsRefresh) {
      triggerRendered = true;
      this.refreshImmediately(fromInside);
    }
    if (this._needsRefreshHover) {
      triggerRendered = true;
      this.refreshHoverImmediately();
    }
    var end2 = getTime();
    if (triggerRendered) {
      this._stillFrameAccum = 0;
      this.trigger("rendered", {
        elapsedTime: end2 - start2
      });
    } else if (this._sleepAfterStill > 0) {
      this._stillFrameAccum++;
      if (this._stillFrameAccum > this._sleepAfterStill) {
        this.animation.stop();
      }
    }
  };
  ZRender2.prototype.setSleepAfterStill = function(stillFramesCount) {
    this._sleepAfterStill = stillFramesCount;
  };
  ZRender2.prototype.wakeUp = function() {
    this.animation.start();
    this._stillFrameAccum = 0;
  };
  ZRender2.prototype.refreshHover = function() {
    this._needsRefreshHover = true;
  };
  ZRender2.prototype.refreshHoverImmediately = function() {
    this._needsRefreshHover = false;
    if (this.painter.refreshHover && this.painter.getType() === "canvas") {
      this.painter.refreshHover();
    }
  };
  ZRender2.prototype.resize = function(opts) {
    opts = opts || {};
    this.painter.resize(opts.width, opts.height);
    this.handler.resize();
  };
  ZRender2.prototype.clearAnimation = function() {
    this.animation.clear();
  };
  ZRender2.prototype.getWidth = function() {
    return this.painter.getWidth();
  };
  ZRender2.prototype.getHeight = function() {
    return this.painter.getHeight();
  };
  ZRender2.prototype.setCursorStyle = function(cursorStyle) {
    this.handler.setCursorStyle(cursorStyle);
  };
  ZRender2.prototype.findHover = function(x2, y2) {
    return this.handler.findHover(x2, y2);
  };
  ZRender2.prototype.on = function(eventName, eventHandler, context) {
    this.handler.on(eventName, eventHandler, context);
    return this;
  };
  ZRender2.prototype.off = function(eventName, eventHandler) {
    this.handler.off(eventName, eventHandler);
  };
  ZRender2.prototype.trigger = function(eventName, event) {
    this.handler.trigger(eventName, event);
  };
  ZRender2.prototype.clear = function() {
    var roots2 = this.storage.getRoots();
    for (var i = 0; i < roots2.length; i++) {
      if (roots2[i] instanceof Group$4) {
        roots2[i].removeSelfFromZr(this);
      }
    }
    this.storage.delAllRoots();
    this.painter.clear();
  };
  ZRender2.prototype.dispose = function() {
    this.animation.stop();
    this.clear();
    this.storage.dispose();
    this.painter.dispose();
    this.handler.dispose();
    this.animation = this.storage = this.painter = this.handler = null;
    delInstance(this.id);
  };
  return ZRender2;
}();
function init$2(dom, opts) {
  var zr = new ZRender(guid(), dom, opts);
  instances$1[zr.id] = zr;
  return zr;
}
function registerPainter(name, Ctor) {
  painterCtors[name] = Ctor;
}
var RADIAN_EPSILON = 1e-4;
var ROUND_SUPPORTED_PRECISION_MAX = 20;
function _trim(str) {
  return str.replace(/^\s+|\s+$/g, "");
}
function linearMap$2(val, domain, range3, clamp2) {
  var d0 = domain[0];
  var d1 = domain[1];
  var r0 = range3[0];
  var r1 = range3[1];
  var subDomain = d1 - d0;
  var subRange = r1 - r0;
  if (subDomain === 0) {
    return subRange === 0 ? r0 : (r0 + r1) / 2;
  }
  if (clamp2) {
    if (subDomain > 0) {
      if (val <= d0) {
        return r0;
      } else if (val >= d1) {
        return r1;
      }
    } else {
      if (val >= d0) {
        return r0;
      } else if (val <= d1) {
        return r1;
      }
    }
  } else {
    if (val === d0) {
      return r0;
    }
    if (val === d1) {
      return r1;
    }
  }
  return (val - d0) / subDomain * subRange + r0;
}
function parsePercent(percent, all) {
  switch (percent) {
    case "center":
    case "middle":
      percent = "50%";
      break;
    case "left":
    case "top":
      percent = "0%";
      break;
    case "right":
    case "bottom":
      percent = "100%";
      break;
  }
  if (isString(percent)) {
    if (_trim(percent).match(/%$/)) {
      return parseFloat(percent) / 100 * all;
    }
    return parseFloat(percent);
  }
  return percent == null ? NaN : +percent;
}
function round$3(x2, precision, returnStr) {
  if (precision == null) {
    precision = 10;
  }
  precision = Math.min(Math.max(0, precision), ROUND_SUPPORTED_PRECISION_MAX);
  x2 = (+x2).toFixed(precision);
  return returnStr ? x2 : +x2;
}
function asc$2(arr) {
  arr.sort(function(a, b2) {
    return a - b2;
  });
  return arr;
}
function getPrecision(val) {
  val = +val;
  if (isNaN(val)) {
    return 0;
  }
  if (val > 1e-14) {
    var e2 = 1;
    for (var i = 0; i < 15; i++, e2 *= 10) {
      if (Math.round(val * e2) / e2 === val) {
        return i;
      }
    }
  }
  return getPrecisionSafe(val);
}
function getPrecisionSafe(val) {
  var str = val.toString().toLowerCase();
  var eIndex = str.indexOf("e");
  var exp = eIndex > 0 ? +str.slice(eIndex + 1) : 0;
  var significandPartLen = eIndex > 0 ? eIndex : str.length;
  var dotIndex = str.indexOf(".");
  var decimalPartLen = dotIndex < 0 ? 0 : significandPartLen - 1 - dotIndex;
  return Math.max(0, decimalPartLen - exp);
}
function getPixelPrecision(dataExtent, pixelExtent) {
  var log = Math.log;
  var LN10 = Math.LN10;
  var dataQuantity = Math.floor(log(dataExtent[1] - dataExtent[0]) / LN10);
  var sizeQuantity = Math.round(log(Math.abs(pixelExtent[1] - pixelExtent[0])) / LN10);
  var precision = Math.min(Math.max(-dataQuantity + sizeQuantity, 0), 20);
  return !isFinite(precision) ? 20 : precision;
}
function getPercentWithPrecision(valueList, idx, precision) {
  if (!valueList[idx]) {
    return 0;
  }
  var sum2 = reduce(valueList, function(acc, val) {
    return acc + (isNaN(val) ? 0 : val);
  }, 0);
  if (sum2 === 0) {
    return 0;
  }
  var digits = Math.pow(10, precision);
  var votesPerQuota = map$1(valueList, function(val) {
    return (isNaN(val) ? 0 : val) / sum2 * digits * 100;
  });
  var targetSeats = digits * 100;
  var seats = map$1(votesPerQuota, function(votes) {
    return Math.floor(votes);
  });
  var currentSum = reduce(seats, function(acc, val) {
    return acc + val;
  }, 0);
  var remainder = map$1(votesPerQuota, function(votes, idx2) {
    return votes - seats[idx2];
  });
  while (currentSum < targetSeats) {
    var max3 = Number.NEGATIVE_INFINITY;
    var maxId = null;
    for (var i = 0, len2 = remainder.length; i < len2; ++i) {
      if (remainder[i] > max3) {
        max3 = remainder[i];
        maxId = i;
      }
    }
    ++seats[maxId];
    remainder[maxId] = 0;
    ++currentSum;
  }
  return seats[idx] / digits;
}
function addSafe(val0, val1) {
  var maxPrecision = Math.max(getPrecision(val0), getPrecision(val1));
  var sum2 = val0 + val1;
  return maxPrecision > ROUND_SUPPORTED_PRECISION_MAX ? sum2 : round$3(sum2, maxPrecision);
}
var MAX_SAFE_INTEGER = 9007199254740991;
function remRadian(radian) {
  var pi2 = Math.PI * 2;
  return (radian % pi2 + pi2) % pi2;
}
function isRadianAroundZero(val) {
  return val > -RADIAN_EPSILON && val < RADIAN_EPSILON;
}
var TIME_REG = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
function parseDate(value) {
  if (value instanceof Date) {
    return value;
  } else if (isString(value)) {
    var match = TIME_REG.exec(value);
    if (!match) {
      return new Date(NaN);
    }
    if (!match[8]) {
      return new Date(+match[1], +(match[2] || 1) - 1, +match[3] || 1, +match[4] || 0, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0);
    } else {
      var hour = +match[4] || 0;
      if (match[8].toUpperCase() !== "Z") {
        hour -= +match[8].slice(0, 3);
      }
      return new Date(Date.UTC(+match[1], +(match[2] || 1) - 1, +match[3] || 1, hour, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0));
    }
  } else if (value == null) {
    return new Date(NaN);
  }
  return new Date(Math.round(value));
}
function quantity(val) {
  return Math.pow(10, quantityExponent(val));
}
function quantityExponent(val) {
  if (val === 0) {
    return 0;
  }
  var exp = Math.floor(Math.log(val) / Math.LN10);
  if (val / Math.pow(10, exp) >= 10) {
    exp++;
  }
  return exp;
}
function nice(val, round2) {
  var exponent = quantityExponent(val);
  var exp10 = Math.pow(10, exponent);
  var f2 = val / exp10;
  var nf;
  if (round2) {
    if (f2 < 1.5) {
      nf = 1;
    } else if (f2 < 2.5) {
      nf = 2;
    } else if (f2 < 4) {
      nf = 3;
    } else if (f2 < 7) {
      nf = 5;
    } else {
      nf = 10;
    }
  } else {
    if (f2 < 1) {
      nf = 1;
    } else if (f2 < 2) {
      nf = 2;
    } else if (f2 < 3) {
      nf = 3;
    } else if (f2 < 5) {
      nf = 5;
    } else {
      nf = 10;
    }
  }
  val = nf * exp10;
  return exponent >= -20 ? +val.toFixed(exponent < 0 ? -exponent : 0) : val;
}
function quantile(ascArr, p2) {
  var H = (ascArr.length - 1) * p2 + 1;
  var h = Math.floor(H);
  var v4 = +ascArr[h - 1];
  var e2 = H - h;
  return e2 ? v4 + e2 * (ascArr[h] - v4) : v4;
}
function reformIntervals(list) {
  list.sort(function(a, b2) {
    return littleThan2(a, b2, 0) ? -1 : 1;
  });
  var curr = -Infinity;
  var currClose = 1;
  for (var i = 0; i < list.length; ) {
    var interval = list[i].interval;
    var close_1 = list[i].close;
    for (var lg = 0; lg < 2; lg++) {
      if (interval[lg] <= curr) {
        interval[lg] = curr;
        close_1[lg] = !lg ? 1 - currClose : 1;
      }
      curr = interval[lg];
      currClose = close_1[lg];
    }
    if (interval[0] === interval[1] && close_1[0] * close_1[1] !== 1) {
      list.splice(i, 1);
    } else {
      i++;
    }
  }
  return list;
  function littleThan2(a, b2, lg2) {
    return a.interval[lg2] < b2.interval[lg2] || a.interval[lg2] === b2.interval[lg2] && (a.close[lg2] - b2.close[lg2] === (!lg2 ? 1 : -1) || !lg2 && littleThan2(a, b2, 1));
  }
}
function numericToNumber(val) {
  var valFloat = parseFloat(val);
  return valFloat == val && (valFloat !== 0 || !isString(val) || val.indexOf("x") <= 0) ? valFloat : NaN;
}
function isNumeric(val) {
  return !isNaN(numericToNumber(val));
}
function getRandomIdBase() {
  return Math.round(Math.random() * 9);
}
function getGreatestCommonDividor(a, b2) {
  if (b2 === 0) {
    return a;
  }
  return getGreatestCommonDividor(b2, a % b2);
}
function getLeastCommonMultiple(a, b2) {
  if (a == null) {
    return b2;
  }
  if (b2 == null) {
    return a;
  }
  return a * b2 / getGreatestCommonDividor(a, b2);
}
function throwError(msg) {
  throw new Error(msg);
}
function interpolateNumber(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
var DUMMY_COMPONENT_NAME_PREFIX = "series\0";
var INTERNAL_COMPONENT_ID_PREFIX = "\0_ec_\0";
function normalizeToArray(value) {
  return value instanceof Array ? value : value == null ? [] : [value];
}
function defaultEmphasis(opt, key, subOpts) {
  if (opt) {
    opt[key] = opt[key] || {};
    opt.emphasis = opt.emphasis || {};
    opt.emphasis[key] = opt.emphasis[key] || {};
    for (var i = 0, len2 = subOpts.length; i < len2; i++) {
      var subOptName = subOpts[i];
      if (!opt.emphasis[key].hasOwnProperty(subOptName) && opt[key].hasOwnProperty(subOptName)) {
        opt.emphasis[key][subOptName] = opt[key][subOptName];
      }
    }
  }
}
var TEXT_STYLE_OPTIONS = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
function getDataItemValue(dataItem) {
  return isObject$4(dataItem) && !isArray$1(dataItem) && !(dataItem instanceof Date) ? dataItem.value : dataItem;
}
function isDataItemOption(dataItem) {
  return isObject$4(dataItem) && !(dataItem instanceof Array);
}
function mappingToExists(existings, newCmptOptions, mode) {
  var isNormalMergeMode = mode === "normalMerge";
  var isReplaceMergeMode = mode === "replaceMerge";
  var isReplaceAllMode = mode === "replaceAll";
  existings = existings || [];
  newCmptOptions = (newCmptOptions || []).slice();
  var existingIdIdxMap = createHashMap();
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!isObject$4(cmptOption)) {
      newCmptOptions[index2] = null;
      return;
    }
  });
  var result = prepareResult(existings, existingIdIdxMap, mode);
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingById(result, existings, existingIdIdxMap, newCmptOptions);
  }
  if (isNormalMergeMode) {
    mappingByName(result, newCmptOptions);
  }
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingByIndex(result, newCmptOptions, isReplaceMergeMode);
  } else if (isReplaceAllMode) {
    mappingInReplaceAllMode(result, newCmptOptions);
  }
  makeIdAndName(result);
  return result;
}
function prepareResult(existings, existingIdIdxMap, mode) {
  var result = [];
  if (mode === "replaceAll") {
    return result;
  }
  for (var index2 = 0; index2 < existings.length; index2++) {
    var existing = existings[index2];
    if (existing && existing.id != null) {
      existingIdIdxMap.set(existing.id, index2);
    }
    result.push({
      existing: mode === "replaceMerge" || isComponentIdInternal(existing) ? null : existing,
      newOption: null,
      keyInfo: null,
      brandNew: null
    });
  }
  return result;
}
function mappingById(result, existings, existingIdIdxMap, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.id == null) {
      return;
    }
    var optionId = makeComparableKey(cmptOption.id);
    var existingIdx = existingIdIdxMap.get(optionId);
    if (existingIdx != null) {
      var resultItem = result[existingIdx];
      assert(!resultItem.newOption, 'Duplicated option on id "' + optionId + '".');
      resultItem.newOption = cmptOption;
      resultItem.existing = existings[existingIdx];
      newCmptOptions[index2] = null;
    }
  });
}
function mappingByName(result, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.name == null) {
      return;
    }
    for (var i = 0; i < result.length; i++) {
      var existing = result[i].existing;
      if (!result[i].newOption && existing && (existing.id == null || cmptOption.id == null) && !isComponentIdInternal(cmptOption) && !isComponentIdInternal(existing) && keyExistAndEqual("name", existing, cmptOption)) {
        result[i].newOption = cmptOption;
        newCmptOptions[index2] = null;
        return;
      }
    }
  });
}
function mappingByIndex(result, newCmptOptions, brandNew) {
  each$f(newCmptOptions, function(cmptOption) {
    if (!cmptOption) {
      return;
    }
    var resultItem;
    var nextIdx = 0;
    while ((resultItem = result[nextIdx]) && (resultItem.newOption || isComponentIdInternal(resultItem.existing) || resultItem.existing && cmptOption.id != null && !keyExistAndEqual("id", cmptOption, resultItem.existing))) {
      nextIdx++;
    }
    if (resultItem) {
      resultItem.newOption = cmptOption;
      resultItem.brandNew = brandNew;
    } else {
      result.push({
        newOption: cmptOption,
        brandNew,
        existing: null,
        keyInfo: null
      });
    }
    nextIdx++;
  });
}
function mappingInReplaceAllMode(result, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption) {
    result.push({
      newOption: cmptOption,
      brandNew: true,
      existing: null,
      keyInfo: null
    });
  });
}
function makeIdAndName(mapResult) {
  var idMap = createHashMap();
  each$f(mapResult, function(item) {
    var existing = item.existing;
    existing && idMap.set(existing.id, item);
  });
  each$f(mapResult, function(item) {
    var opt = item.newOption;
    assert(!opt || opt.id == null || !idMap.get(opt.id) || idMap.get(opt.id) === item, "id duplicates: " + (opt && opt.id));
    opt && opt.id != null && idMap.set(opt.id, item);
    !item.keyInfo && (item.keyInfo = {});
  });
  each$f(mapResult, function(item, index2) {
    var existing = item.existing;
    var opt = item.newOption;
    var keyInfo = item.keyInfo;
    if (!isObject$4(opt)) {
      return;
    }
    keyInfo.name = opt.name != null ? makeComparableKey(opt.name) : existing ? existing.name : DUMMY_COMPONENT_NAME_PREFIX + index2;
    if (existing) {
      keyInfo.id = makeComparableKey(existing.id);
    } else if (opt.id != null) {
      keyInfo.id = makeComparableKey(opt.id);
    } else {
      var idNum = 0;
      do {
        keyInfo.id = "\0" + keyInfo.name + "\0" + idNum++;
      } while (idMap.get(keyInfo.id));
    }
    idMap.set(keyInfo.id, item);
  });
}
function keyExistAndEqual(attr, obj1, obj2) {
  var key1 = convertOptionIdName(obj1[attr], null);
  var key2 = convertOptionIdName(obj2[attr], null);
  return key1 != null && key2 != null && key1 === key2;
}
function makeComparableKey(val) {
  return convertOptionIdName(val, "");
}
function convertOptionIdName(idOrName, defaultValue) {
  if (idOrName == null) {
    return defaultValue;
  }
  return isString(idOrName) ? idOrName : isNumber(idOrName) || isStringSafe(idOrName) ? idOrName + "" : defaultValue;
}
function isNameSpecified(componentModel) {
  var name = componentModel.name;
  return !!(name && name.indexOf(DUMMY_COMPONENT_NAME_PREFIX));
}
function isComponentIdInternal(cmptOption) {
  return cmptOption && cmptOption.id != null && makeComparableKey(cmptOption.id).indexOf(INTERNAL_COMPONENT_ID_PREFIX) === 0;
}
function makeInternalComponentId(idSuffix) {
  return INTERNAL_COMPONENT_ID_PREFIX + idSuffix;
}
function setComponentTypeToKeyInfo(mappingResult, mainType, componentModelCtor) {
  each$f(mappingResult, function(item) {
    var newOption = item.newOption;
    if (isObject$4(newOption)) {
      item.keyInfo.mainType = mainType;
      item.keyInfo.subType = determineSubType(mainType, newOption, item.existing, componentModelCtor);
    }
  });
}
function determineSubType(mainType, newCmptOption, existComponent, componentModelCtor) {
  var subType = newCmptOption.type ? newCmptOption.type : existComponent ? existComponent.subType : componentModelCtor.determineSubType(mainType, newCmptOption);
  return subType;
}
function compressBatches(batchA, batchB) {
  var mapA = {};
  var mapB = {};
  makeMap(batchA || [], mapA);
  makeMap(batchB || [], mapB, mapA);
  return [mapToArray(mapA), mapToArray(mapB)];
  function makeMap(sourceBatch, map2, otherMap) {
    for (var i = 0, len2 = sourceBatch.length; i < len2; i++) {
      var seriesId = convertOptionIdName(sourceBatch[i].seriesId, null);
      if (seriesId == null) {
        return;
      }
      var dataIndices = normalizeToArray(sourceBatch[i].dataIndex);
      var otherDataIndices = otherMap && otherMap[seriesId];
      for (var j = 0, lenj = dataIndices.length; j < lenj; j++) {
        var dataIndex = dataIndices[j];
        if (otherDataIndices && otherDataIndices[dataIndex]) {
          otherDataIndices[dataIndex] = null;
        } else {
          (map2[seriesId] || (map2[seriesId] = {}))[dataIndex] = 1;
        }
      }
    }
  }
  function mapToArray(map2, isData) {
    var result = [];
    for (var i in map2) {
      if (map2.hasOwnProperty(i) && map2[i] != null) {
        if (isData) {
          result.push(+i);
        } else {
          var dataIndices = mapToArray(map2[i], true);
          dataIndices.length && result.push({
            seriesId: i,
            dataIndex: dataIndices
          });
        }
      }
    }
    return result;
  }
}
function queryDataIndex(data, payload) {
  if (payload.dataIndexInside != null) {
    return payload.dataIndexInside;
  } else if (payload.dataIndex != null) {
    return isArray$1(payload.dataIndex) ? map$1(payload.dataIndex, function(value) {
      return data.indexOfRawIndex(value);
    }) : data.indexOfRawIndex(payload.dataIndex);
  } else if (payload.name != null) {
    return isArray$1(payload.name) ? map$1(payload.name, function(value) {
      return data.indexOfName(value);
    }) : data.indexOfName(payload.name);
  }
}
function makeInner() {
  var key = "__ec_inner_" + innerUniqueIndex++;
  return function(hostObj) {
    return hostObj[key] || (hostObj[key] = {});
  };
}
var innerUniqueIndex = getRandomIdBase();
function parseFinder$1(ecModel, finderInput, opt) {
  var _a2 = preParseFinder(finderInput, opt), mainTypeSpecified = _a2.mainTypeSpecified, queryOptionMap = _a2.queryOptionMap, others = _a2.others;
  var result = others;
  var defaultMainType = opt ? opt.defaultMainType : null;
  if (!mainTypeSpecified && defaultMainType) {
    queryOptionMap.set(defaultMainType, {});
  }
  queryOptionMap.each(function(queryOption, mainType) {
    var queryResult = queryReferringComponents(ecModel, mainType, queryOption, {
      useDefault: defaultMainType === mainType,
      enableAll: opt && opt.enableAll != null ? opt.enableAll : true,
      enableNone: opt && opt.enableNone != null ? opt.enableNone : true
    });
    result[mainType + "Models"] = queryResult.models;
    result[mainType + "Model"] = queryResult.models[0];
  });
  return result;
}
function preParseFinder(finderInput, opt) {
  var finder;
  if (isString(finderInput)) {
    var obj = {};
    obj[finderInput + "Index"] = 0;
    finder = obj;
  } else {
    finder = finderInput;
  }
  var queryOptionMap = createHashMap();
  var others = {};
  var mainTypeSpecified = false;
  each$f(finder, function(value, key) {
    if (key === "dataIndex" || key === "dataIndexInside") {
      others[key] = value;
      return;
    }
    var parsedKey = key.match(/^(\w+)(Index|Id|Name)$/) || [];
    var mainType = parsedKey[1];
    var queryType = (parsedKey[2] || "").toLowerCase();
    if (!mainType || !queryType || opt && opt.includeMainTypes && indexOf(opt.includeMainTypes, mainType) < 0) {
      return;
    }
    mainTypeSpecified = mainTypeSpecified || !!mainType;
    var queryOption = queryOptionMap.get(mainType) || queryOptionMap.set(mainType, {});
    queryOption[queryType] = value;
  });
  return {
    mainTypeSpecified,
    queryOptionMap,
    others
  };
}
var SINGLE_REFERRING = {
  useDefault: true,
  enableAll: false,
  enableNone: false
};
var MULTIPLE_REFERRING = {
  useDefault: false,
  enableAll: true,
  enableNone: true
};
function queryReferringComponents(ecModel, mainType, userOption, opt) {
  opt = opt || SINGLE_REFERRING;
  var indexOption = userOption.index;
  var idOption = userOption.id;
  var nameOption = userOption.name;
  var result = {
    models: null,
    specified: indexOption != null || idOption != null || nameOption != null
  };
  if (!result.specified) {
    var firstCmpt = void 0;
    result.models = opt.useDefault && (firstCmpt = ecModel.getComponent(mainType)) ? [firstCmpt] : [];
    return result;
  }
  if (indexOption === "none" || indexOption === false) {
    assert(opt.enableNone, '`"none"` or `false` is not a valid value on index option.');
    result.models = [];
    return result;
  }
  if (indexOption === "all") {
    assert(opt.enableAll, '`"all"` is not a valid value on index option.');
    indexOption = idOption = nameOption = null;
  }
  result.models = ecModel.queryComponents({
    mainType,
    index: indexOption,
    id: idOption,
    name: nameOption
  });
  return result;
}
function setAttribute(dom, key, value) {
  dom.setAttribute ? dom.setAttribute(key, value) : dom[key] = value;
}
function getAttribute(dom, key) {
  return dom.getAttribute ? dom.getAttribute(key) : dom[key];
}
function getTooltipRenderMode(renderModeOption) {
  if (renderModeOption === "auto") {
    return env$1.domSupported ? "html" : "richText";
  } else {
    return renderModeOption || "html";
  }
}
function groupData(array4, getKey2) {
  var buckets = createHashMap();
  var keys2 = [];
  each$f(array4, function(item) {
    var key = getKey2(item);
    (buckets.get(key) || (keys2.push(key), buckets.set(key, []))).push(item);
  });
  return {
    keys: keys2,
    buckets
  };
}
function interpolateRawValues(data, precision, sourceValue, targetValue, percent) {
  var isAutoPrecision = precision == null || precision === "auto";
  if (targetValue == null) {
    return targetValue;
  }
  if (isNumber(targetValue)) {
    var value = interpolateNumber(sourceValue || 0, targetValue, percent);
    return round$3(value, isAutoPrecision ? Math.max(getPrecision(sourceValue || 0), getPrecision(targetValue)) : precision);
  } else if (isString(targetValue)) {
    return percent < 1 ? sourceValue : targetValue;
  } else {
    var interpolated = [];
    var leftArr = sourceValue;
    var rightArr = targetValue;
    var length_1 = Math.max(leftArr ? leftArr.length : 0, rightArr.length);
    for (var i = 0; i < length_1; ++i) {
      var info = data.getDimensionInfo(i);
      if (info && info.type === "ordinal") {
        interpolated[i] = (percent < 1 && leftArr ? leftArr : rightArr)[i];
      } else {
        var leftVal = leftArr && leftArr[i] ? leftArr[i] : 0;
        var rightVal = rightArr[i];
        var value = interpolateNumber(leftVal, rightVal, percent);
        interpolated[i] = round$3(value, isAutoPrecision ? Math.max(getPrecision(leftVal), getPrecision(rightVal)) : precision);
      }
    }
    return interpolated;
  }
}
var TYPE_DELIMITER = ".";
var IS_CONTAINER = "___EC__COMPONENT__CONTAINER___";
var IS_EXTENDED_CLASS = "___EC__EXTENDED_CLASS___";
function parseClassType(componentType) {
  var ret = {
    main: "",
    sub: ""
  };
  if (componentType) {
    var typeArr = componentType.split(TYPE_DELIMITER);
    ret.main = typeArr[0] || "";
    ret.sub = typeArr[1] || "";
  }
  return ret;
}
function checkClassType(componentType) {
  assert(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(componentType), 'componentType "' + componentType + '" illegal');
}
function isExtendedClass(clz) {
  return !!(clz && clz[IS_EXTENDED_CLASS]);
}
function enableClassExtend(rootClz, mandatoryMethods) {
  rootClz.$constructor = rootClz;
  rootClz.extend = function(proto2) {
    var superClass = this;
    var ExtendedClass;
    if (isESClass(superClass)) {
      ExtendedClass = function(_super) {
        __extends(class_1, _super);
        function class_1() {
          return _super.apply(this, arguments) || this;
        }
        return class_1;
      }(superClass);
    } else {
      ExtendedClass = function() {
        (proto2.$constructor || superClass).apply(this, arguments);
      };
      inherits(ExtendedClass, this);
    }
    extend(ExtendedClass.prototype, proto2);
    ExtendedClass[IS_EXTENDED_CLASS] = true;
    ExtendedClass.extend = this.extend;
    ExtendedClass.superCall = superCall;
    ExtendedClass.superApply = superApply;
    ExtendedClass.superClass = superClass;
    return ExtendedClass;
  };
}
function isESClass(fn) {
  return isFunction(fn) && /^class\s/.test(Function.prototype.toString.call(fn));
}
function mountExtend(SubClz, SupperClz) {
  SubClz.extend = SupperClz.extend;
}
var classBase = Math.round(Math.random() * 10);
function enableClassCheck(target) {
  var classAttr = ["__\0is_clz", classBase++].join("_");
  target.prototype[classAttr] = true;
  target.isInstance = function(obj) {
    return !!(obj && obj[classAttr]);
  };
}
function superCall(context, methodName) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return this.superClass.prototype[methodName].apply(context, args);
}
function superApply(context, methodName, args) {
  return this.superClass.prototype[methodName].apply(context, args);
}
function enableClassManagement(target) {
  var storage2 = {};
  target.registerClass = function(clz) {
    var componentFullType = clz.type || clz.prototype.type;
    if (componentFullType) {
      checkClassType(componentFullType);
      clz.prototype.type = componentFullType;
      var componentTypeInfo = parseClassType(componentFullType);
      if (!componentTypeInfo.sub) {
        storage2[componentTypeInfo.main] = clz;
      } else if (componentTypeInfo.sub !== IS_CONTAINER) {
        var container2 = makeContainer(componentTypeInfo);
        container2[componentTypeInfo.sub] = clz;
      }
    }
    return clz;
  };
  target.getClass = function(mainType, subType, throwWhenNotFound) {
    var clz = storage2[mainType];
    if (clz && clz[IS_CONTAINER]) {
      clz = subType ? clz[subType] : null;
    }
    if (throwWhenNotFound && !clz) {
      throw new Error(!subType ? mainType + ".type should be specified." : "Component " + mainType + "." + (subType || "") + " is used but not imported.");
    }
    return clz;
  };
  target.getClassesByMainType = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var result = [];
    var obj = storage2[componentTypeInfo.main];
    if (obj && obj[IS_CONTAINER]) {
      each$f(obj, function(o, type4) {
        type4 !== IS_CONTAINER && result.push(o);
      });
    } else {
      result.push(obj);
    }
    return result;
  };
  target.hasClass = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    return !!storage2[componentTypeInfo.main];
  };
  target.getAllClassMainTypes = function() {
    var types2 = [];
    each$f(storage2, function(obj, type4) {
      types2.push(type4);
    });
    return types2;
  };
  target.hasSubTypes = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var obj = storage2[componentTypeInfo.main];
    return obj && obj[IS_CONTAINER];
  };
  function makeContainer(componentTypeInfo) {
    var container2 = storage2[componentTypeInfo.main];
    if (!container2 || !container2[IS_CONTAINER]) {
      container2 = storage2[componentTypeInfo.main] = {};
      container2[IS_CONTAINER] = true;
    }
    return container2;
  }
}
function makeStyleMapper(properties, ignoreParent) {
  for (var i = 0; i < properties.length; i++) {
    if (!properties[i][1]) {
      properties[i][1] = properties[i][0];
    }
  }
  ignoreParent = ignoreParent || false;
  return function(model, excludes, includes) {
    var style = {};
    for (var i2 = 0; i2 < properties.length; i2++) {
      var propName = properties[i2][1];
      if (excludes && indexOf(excludes, propName) >= 0 || includes && indexOf(includes, propName) < 0) {
        continue;
      }
      var val = model.getShallow(propName, ignoreParent);
      if (val != null) {
        style[properties[i2][0]] = val;
      }
    }
    return style;
  };
}
var AREA_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["opacity"],
  ["shadowColor"]
];
var getAreaStyle = makeStyleMapper(AREA_STYLE_KEY_MAP);
var AreaStyleMixin = function() {
  function AreaStyleMixin2() {
  }
  AreaStyleMixin2.prototype.getAreaStyle = function(excludes, includes) {
    return getAreaStyle(this, excludes, includes);
  };
  return AreaStyleMixin2;
}();
var globalImageCache = new LRU$1(50);
function findExistImage(newImageOrSrc) {
  if (typeof newImageOrSrc === "string") {
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    return cachedImgObj && cachedImgObj.image;
  } else {
    return newImageOrSrc;
  }
}
function createOrUpdateImage(newImageOrSrc, image, hostEl, onload, cbPayload) {
  if (!newImageOrSrc) {
    return image;
  } else if (typeof newImageOrSrc === "string") {
    if (image && image.__zrImageSrc === newImageOrSrc || !hostEl) {
      return image;
    }
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    var pendingWrap = { hostEl, cb: onload, cbPayload };
    if (cachedImgObj) {
      image = cachedImgObj.image;
      !isImageReady(image) && cachedImgObj.pending.push(pendingWrap);
    } else {
      var image_1 = platformApi.loadImage(newImageOrSrc, imageOnLoad, imageOnLoad);
      image_1.__zrImageSrc = newImageOrSrc;
      globalImageCache.put(newImageOrSrc, image_1.__cachedImgObj = {
        image: image_1,
        pending: [pendingWrap]
      });
    }
    return image;
  } else {
    return newImageOrSrc;
  }
}
function imageOnLoad() {
  var cachedImgObj = this.__cachedImgObj;
  this.onload = this.onerror = this.__cachedImgObj = null;
  for (var i = 0; i < cachedImgObj.pending.length; i++) {
    var pendingWrap = cachedImgObj.pending[i];
    var cb = pendingWrap.cb;
    cb && cb(this, pendingWrap.cbPayload);
    pendingWrap.hostEl.dirty();
  }
  cachedImgObj.pending.length = 0;
}
function isImageReady(image) {
  return image && image.width && image.height;
}
var STYLE_REG = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
function truncateText(text, containerWidth, font, ellipsis, options) {
  if (!containerWidth) {
    return "";
  }
  var textLines = (text + "").split("\n");
  options = prepareTruncateOptions(containerWidth, font, ellipsis, options);
  for (var i = 0, len2 = textLines.length; i < len2; i++) {
    textLines[i] = truncateSingleLine(textLines[i], options);
  }
  return textLines.join("\n");
}
function prepareTruncateOptions(containerWidth, font, ellipsis, options) {
  options = options || {};
  var preparedOpts = extend({}, options);
  preparedOpts.font = font;
  ellipsis = retrieve2(ellipsis, "...");
  preparedOpts.maxIterations = retrieve2(options.maxIterations, 2);
  var minChar = preparedOpts.minChar = retrieve2(options.minChar, 0);
  preparedOpts.cnCharWidth = getWidth("\u56FD", font);
  var ascCharWidth = preparedOpts.ascCharWidth = getWidth("a", font);
  preparedOpts.placeholder = retrieve2(options.placeholder, "");
  var contentWidth = containerWidth = Math.max(0, containerWidth - 1);
  for (var i = 0; i < minChar && contentWidth >= ascCharWidth; i++) {
    contentWidth -= ascCharWidth;
  }
  var ellipsisWidth = getWidth(ellipsis, font);
  if (ellipsisWidth > contentWidth) {
    ellipsis = "";
    ellipsisWidth = 0;
  }
  contentWidth = containerWidth - ellipsisWidth;
  preparedOpts.ellipsis = ellipsis;
  preparedOpts.ellipsisWidth = ellipsisWidth;
  preparedOpts.contentWidth = contentWidth;
  preparedOpts.containerWidth = containerWidth;
  return preparedOpts;
}
function truncateSingleLine(textLine, options) {
  var containerWidth = options.containerWidth;
  var font = options.font;
  var contentWidth = options.contentWidth;
  if (!containerWidth) {
    return "";
  }
  var lineWidth = getWidth(textLine, font);
  if (lineWidth <= containerWidth) {
    return textLine;
  }
  for (var j = 0; ; j++) {
    if (lineWidth <= contentWidth || j >= options.maxIterations) {
      textLine += options.ellipsis;
      break;
    }
    var subLength = j === 0 ? estimateLength(textLine, contentWidth, options.ascCharWidth, options.cnCharWidth) : lineWidth > 0 ? Math.floor(textLine.length * contentWidth / lineWidth) : 0;
    textLine = textLine.substr(0, subLength);
    lineWidth = getWidth(textLine, font);
  }
  if (textLine === "") {
    textLine = options.placeholder;
  }
  return textLine;
}
function estimateLength(text, contentWidth, ascCharWidth, cnCharWidth) {
  var width = 0;
  var i = 0;
  for (var len2 = text.length; i < len2 && width < contentWidth; i++) {
    var charCode = text.charCodeAt(i);
    width += 0 <= charCode && charCode <= 127 ? ascCharWidth : cnCharWidth;
  }
  return i;
}
function parsePlainText(text, style) {
  text != null && (text += "");
  var overflow = style.overflow;
  var padding = style.padding;
  var font = style.font;
  var truncate = overflow === "truncate";
  var calculatedLineHeight = getLineHeight(font);
  var lineHeight = retrieve2(style.lineHeight, calculatedLineHeight);
  var bgColorDrawn = !!style.backgroundColor;
  var truncateLineOverflow = style.lineOverflow === "truncate";
  var width = style.width;
  var lines;
  if (width != null && (overflow === "break" || overflow === "breakAll")) {
    lines = text ? wrapText(text, style.font, width, overflow === "breakAll", 0).lines : [];
  } else {
    lines = text ? text.split("\n") : [];
  }
  var contentHeight = lines.length * lineHeight;
  var height = retrieve2(style.height, contentHeight);
  if (contentHeight > height && truncateLineOverflow) {
    var lineCount = Math.floor(height / lineHeight);
    lines = lines.slice(0, lineCount);
  }
  if (text && truncate && width != null) {
    var options = prepareTruncateOptions(width, font, style.ellipsis, {
      minChar: style.truncateMinChar,
      placeholder: style.placeholder
    });
    for (var i = 0; i < lines.length; i++) {
      lines[i] = truncateSingleLine(lines[i], options);
    }
  }
  var outerHeight = height;
  var contentWidth = 0;
  for (var i = 0; i < lines.length; i++) {
    contentWidth = Math.max(getWidth(lines[i], font), contentWidth);
  }
  if (width == null) {
    width = contentWidth;
  }
  var outerWidth = contentWidth;
  if (padding) {
    outerHeight += padding[0] + padding[2];
    outerWidth += padding[1] + padding[3];
    width += padding[1] + padding[3];
  }
  if (bgColorDrawn) {
    outerWidth = width;
  }
  return {
    lines,
    height,
    outerWidth,
    outerHeight,
    lineHeight,
    calculatedLineHeight,
    contentWidth,
    contentHeight,
    width
  };
}
var RichTextToken = function() {
  function RichTextToken2() {
  }
  return RichTextToken2;
}();
var RichTextLine = function() {
  function RichTextLine2(tokens) {
    this.tokens = [];
    if (tokens) {
      this.tokens = tokens;
    }
  }
  return RichTextLine2;
}();
var RichTextContentBlock = function() {
  function RichTextContentBlock2() {
    this.width = 0;
    this.height = 0;
    this.contentWidth = 0;
    this.contentHeight = 0;
    this.outerWidth = 0;
    this.outerHeight = 0;
    this.lines = [];
  }
  return RichTextContentBlock2;
}();
function parseRichText(text, style) {
  var contentBlock = new RichTextContentBlock();
  text != null && (text += "");
  if (!text) {
    return contentBlock;
  }
  var topWidth = style.width;
  var topHeight = style.height;
  var overflow = style.overflow;
  var wrapInfo = (overflow === "break" || overflow === "breakAll") && topWidth != null ? { width: topWidth, accumWidth: 0, breakAll: overflow === "breakAll" } : null;
  var lastIndex = STYLE_REG.lastIndex = 0;
  var result;
  while ((result = STYLE_REG.exec(text)) != null) {
    var matchedIndex = result.index;
    if (matchedIndex > lastIndex) {
      pushTokens(contentBlock, text.substring(lastIndex, matchedIndex), style, wrapInfo);
    }
    pushTokens(contentBlock, result[2], style, wrapInfo, result[1]);
    lastIndex = STYLE_REG.lastIndex;
  }
  if (lastIndex < text.length) {
    pushTokens(contentBlock, text.substring(lastIndex, text.length), style, wrapInfo);
  }
  var pendingList = [];
  var calculatedHeight = 0;
  var calculatedWidth = 0;
  var stlPadding = style.padding;
  var truncate = overflow === "truncate";
  var truncateLine = style.lineOverflow === "truncate";
  function finishLine(line2, lineWidth2, lineHeight2) {
    line2.width = lineWidth2;
    line2.lineHeight = lineHeight2;
    calculatedHeight += lineHeight2;
    calculatedWidth = Math.max(calculatedWidth, lineWidth2);
  }
  outer:
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var lineHeight = 0;
      var lineWidth = 0;
      for (var j = 0; j < line.tokens.length; j++) {
        var token = line.tokens[j];
        var tokenStyle = token.styleName && style.rich[token.styleName] || {};
        var textPadding = token.textPadding = tokenStyle.padding;
        var paddingH = textPadding ? textPadding[1] + textPadding[3] : 0;
        var font = token.font = tokenStyle.font || style.font;
        token.contentHeight = getLineHeight(font);
        var tokenHeight = retrieve2(tokenStyle.height, token.contentHeight);
        token.innerHeight = tokenHeight;
        textPadding && (tokenHeight += textPadding[0] + textPadding[2]);
        token.height = tokenHeight;
        token.lineHeight = retrieve3(tokenStyle.lineHeight, style.lineHeight, tokenHeight);
        token.align = tokenStyle && tokenStyle.align || style.align;
        token.verticalAlign = tokenStyle && tokenStyle.verticalAlign || "middle";
        if (truncateLine && topHeight != null && calculatedHeight + token.lineHeight > topHeight) {
          if (j > 0) {
            line.tokens = line.tokens.slice(0, j);
            finishLine(line, lineWidth, lineHeight);
            contentBlock.lines = contentBlock.lines.slice(0, i + 1);
          } else {
            contentBlock.lines = contentBlock.lines.slice(0, i);
          }
          break outer;
        }
        var styleTokenWidth = tokenStyle.width;
        var tokenWidthNotSpecified = styleTokenWidth == null || styleTokenWidth === "auto";
        if (typeof styleTokenWidth === "string" && styleTokenWidth.charAt(styleTokenWidth.length - 1) === "%") {
          token.percentWidth = styleTokenWidth;
          pendingList.push(token);
          token.contentWidth = getWidth(token.text, font);
        } else {
          if (tokenWidthNotSpecified) {
            var textBackgroundColor = tokenStyle.backgroundColor;
            var bgImg = textBackgroundColor && textBackgroundColor.image;
            if (bgImg) {
              bgImg = findExistImage(bgImg);
              if (isImageReady(bgImg)) {
                token.width = Math.max(token.width, bgImg.width * tokenHeight / bgImg.height);
              }
            }
          }
          var remainTruncWidth = truncate && topWidth != null ? topWidth - lineWidth : null;
          if (remainTruncWidth != null && remainTruncWidth < token.width) {
            if (!tokenWidthNotSpecified || remainTruncWidth < paddingH) {
              token.text = "";
              token.width = token.contentWidth = 0;
            } else {
              token.text = truncateText(token.text, remainTruncWidth - paddingH, font, style.ellipsis, { minChar: style.truncateMinChar });
              token.width = token.contentWidth = getWidth(token.text, font);
            }
          } else {
            token.contentWidth = getWidth(token.text, font);
          }
        }
        token.width += paddingH;
        lineWidth += token.width;
        tokenStyle && (lineHeight = Math.max(lineHeight, token.lineHeight));
      }
      finishLine(line, lineWidth, lineHeight);
    }
  contentBlock.outerWidth = contentBlock.width = retrieve2(topWidth, calculatedWidth);
  contentBlock.outerHeight = contentBlock.height = retrieve2(topHeight, calculatedHeight);
  contentBlock.contentHeight = calculatedHeight;
  contentBlock.contentWidth = calculatedWidth;
  if (stlPadding) {
    contentBlock.outerWidth += stlPadding[1] + stlPadding[3];
    contentBlock.outerHeight += stlPadding[0] + stlPadding[2];
  }
  for (var i = 0; i < pendingList.length; i++) {
    var token = pendingList[i];
    var percentWidth = token.percentWidth;
    token.width = parseInt(percentWidth, 10) / 100 * contentBlock.width;
  }
  return contentBlock;
}
function pushTokens(block, str, style, wrapInfo, styleName) {
  var isEmptyStr = str === "";
  var tokenStyle = styleName && style.rich[styleName] || {};
  var lines = block.lines;
  var font = tokenStyle.font || style.font;
  var newLine = false;
  var strLines;
  var linesWidths;
  if (wrapInfo) {
    var tokenPadding = tokenStyle.padding;
    var tokenPaddingH = tokenPadding ? tokenPadding[1] + tokenPadding[3] : 0;
    if (tokenStyle.width != null && tokenStyle.width !== "auto") {
      var outerWidth_1 = parsePercent$1(tokenStyle.width, wrapInfo.width) + tokenPaddingH;
      if (lines.length > 0) {
        if (outerWidth_1 + wrapInfo.accumWidth > wrapInfo.width) {
          strLines = str.split("\n");
          newLine = true;
        }
      }
      wrapInfo.accumWidth = outerWidth_1;
    } else {
      var res = wrapText(str, font, wrapInfo.width, wrapInfo.breakAll, wrapInfo.accumWidth);
      wrapInfo.accumWidth = res.accumWidth + tokenPaddingH;
      linesWidths = res.linesWidths;
      strLines = res.lines;
    }
  } else {
    strLines = str.split("\n");
  }
  for (var i = 0; i < strLines.length; i++) {
    var text = strLines[i];
    var token = new RichTextToken();
    token.styleName = styleName;
    token.text = text;
    token.isLineHolder = !text && !isEmptyStr;
    if (typeof tokenStyle.width === "number") {
      token.width = tokenStyle.width;
    } else {
      token.width = linesWidths ? linesWidths[i] : getWidth(text, font);
    }
    if (!i && !newLine) {
      var tokens = (lines[lines.length - 1] || (lines[0] = new RichTextLine())).tokens;
      var tokensLen = tokens.length;
      tokensLen === 1 && tokens[0].isLineHolder ? tokens[0] = token : (text || !tokensLen || isEmptyStr) && tokens.push(token);
    } else {
      lines.push(new RichTextLine([token]));
    }
  }
}
function isLatin(ch) {
  var code = ch.charCodeAt(0);
  return code >= 33 && code <= 383;
}
var breakCharMap = reduce(",&?/;] ".split(""), function(obj, ch) {
  obj[ch] = true;
  return obj;
}, {});
function isWordBreakChar(ch) {
  if (isLatin(ch)) {
    if (breakCharMap[ch]) {
      return true;
    }
    return false;
  }
  return true;
}
function wrapText(text, font, lineWidth, isBreakAll, lastAccumWidth) {
  var lines = [];
  var linesWidths = [];
  var line = "";
  var currentWord = "";
  var currentWordWidth = 0;
  var accumWidth = 0;
  for (var i = 0; i < text.length; i++) {
    var ch = text.charAt(i);
    if (ch === "\n") {
      if (currentWord) {
        line += currentWord;
        accumWidth += currentWordWidth;
      }
      lines.push(line);
      linesWidths.push(accumWidth);
      line = "";
      currentWord = "";
      currentWordWidth = 0;
      accumWidth = 0;
      continue;
    }
    var chWidth = getWidth(ch, font);
    var inWord = isBreakAll ? false : !isWordBreakChar(ch);
    if (!lines.length ? lastAccumWidth + accumWidth + chWidth > lineWidth : accumWidth + chWidth > lineWidth) {
      if (!accumWidth) {
        if (inWord) {
          lines.push(currentWord);
          linesWidths.push(currentWordWidth);
          currentWord = ch;
          currentWordWidth = chWidth;
        } else {
          lines.push(ch);
          linesWidths.push(chWidth);
        }
      } else if (line || currentWord) {
        if (inWord) {
          if (!line) {
            line = currentWord;
            currentWord = "";
            currentWordWidth = 0;
            accumWidth = currentWordWidth;
          }
          lines.push(line);
          linesWidths.push(accumWidth - currentWordWidth);
          currentWord += ch;
          currentWordWidth += chWidth;
          line = "";
          accumWidth = currentWordWidth;
        } else {
          if (currentWord) {
            line += currentWord;
            currentWord = "";
            currentWordWidth = 0;
          }
          lines.push(line);
          linesWidths.push(accumWidth);
          line = ch;
          accumWidth = chWidth;
        }
      }
      continue;
    }
    accumWidth += chWidth;
    if (inWord) {
      currentWord += ch;
      currentWordWidth += chWidth;
    } else {
      if (currentWord) {
        line += currentWord;
        currentWord = "";
        currentWordWidth = 0;
      }
      line += ch;
    }
  }
  if (!lines.length && !line) {
    line = text;
    currentWord = "";
    currentWordWidth = 0;
  }
  if (currentWord) {
    line += currentWord;
  }
  if (line) {
    lines.push(line);
    linesWidths.push(accumWidth);
  }
  if (lines.length === 1) {
    accumWidth += lastAccumWidth;
  }
  return {
    accumWidth,
    lines,
    linesWidths
  };
}
var STYLE_MAGIC_KEY = "__zr_style_" + Math.round(Math.random() * 10);
var DEFAULT_COMMON_STYLE = {
  shadowBlur: 0,
  shadowOffsetX: 0,
  shadowOffsetY: 0,
  shadowColor: "#000",
  opacity: 1,
  blend: "source-over"
};
var DEFAULT_COMMON_ANIMATION_PROPS = {
  style: {
    shadowBlur: true,
    shadowOffsetX: true,
    shadowOffsetY: true,
    shadowColor: true,
    opacity: true
  }
};
DEFAULT_COMMON_STYLE[STYLE_MAGIC_KEY] = true;
var PRIMARY_STATES_KEYS = ["z", "z2", "invisible"];
var PRIMARY_STATES_KEYS_IN_HOVER_LAYER = ["invisible"];
var Displayable = function(_super) {
  __extends(Displayable2, _super);
  function Displayable2(props) {
    return _super.call(this, props) || this;
  }
  Displayable2.prototype._init = function(props) {
    var keysArr = keys(props);
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      if (key === "style") {
        this.useStyle(props[key]);
      } else {
        _super.prototype.attrKV.call(this, key, props[key]);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Displayable2.prototype.beforeBrush = function() {
  };
  Displayable2.prototype.afterBrush = function() {
  };
  Displayable2.prototype.innerBeforeBrush = function() {
  };
  Displayable2.prototype.innerAfterBrush = function() {
  };
  Displayable2.prototype.shouldBePainted = function(viewWidth, viewHeight, considerClipPath, considerAncestors) {
    var m2 = this.transform;
    if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && isDisplayableCulled(this, viewWidth, viewHeight) || m2 && !m2[0] && !m2[3]) {
      return false;
    }
    if (considerClipPath && this.__clipPaths) {
      for (var i = 0; i < this.__clipPaths.length; ++i) {
        if (this.__clipPaths[i].isZeroArea()) {
          return false;
        }
      }
    }
    if (considerAncestors && this.parent) {
      var parent_1 = this.parent;
      while (parent_1) {
        if (parent_1.ignore) {
          return false;
        }
        parent_1 = parent_1.parent;
      }
    }
    return true;
  };
  Displayable2.prototype.contain = function(x2, y2) {
    return this.rectContain(x2, y2);
  };
  Displayable2.prototype.traverse = function(cb, context) {
    cb.call(context, this);
  };
  Displayable2.prototype.rectContain = function(x2, y2) {
    var coord = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    return rect.contain(coord[0], coord[1]);
  };
  Displayable2.prototype.getPaintRect = function() {
    var rect = this._paintRect;
    if (!this._paintRect || this.__dirty) {
      var transform2 = this.transform;
      var elRect = this.getBoundingRect();
      var style = this.style;
      var shadowSize = style.shadowBlur || 0;
      var shadowOffsetX = style.shadowOffsetX || 0;
      var shadowOffsetY = style.shadowOffsetY || 0;
      rect = this._paintRect || (this._paintRect = new BoundingRect$1(0, 0, 0, 0));
      if (transform2) {
        BoundingRect$1.applyTransform(rect, elRect, transform2);
      } else {
        rect.copy(elRect);
      }
      if (shadowSize || shadowOffsetX || shadowOffsetY) {
        rect.width += shadowSize * 2 + Math.abs(shadowOffsetX);
        rect.height += shadowSize * 2 + Math.abs(shadowOffsetY);
        rect.x = Math.min(rect.x, rect.x + shadowOffsetX - shadowSize);
        rect.y = Math.min(rect.y, rect.y + shadowOffsetY - shadowSize);
      }
      var tolerance = this.dirtyRectTolerance;
      if (!rect.isZero()) {
        rect.x = Math.floor(rect.x - tolerance);
        rect.y = Math.floor(rect.y - tolerance);
        rect.width = Math.ceil(rect.width + 1 + tolerance * 2);
        rect.height = Math.ceil(rect.height + 1 + tolerance * 2);
      }
    }
    return rect;
  };
  Displayable2.prototype.setPrevPaintRect = function(paintRect) {
    if (paintRect) {
      this._prevPaintRect = this._prevPaintRect || new BoundingRect$1(0, 0, 0, 0);
      this._prevPaintRect.copy(paintRect);
    } else {
      this._prevPaintRect = null;
    }
  };
  Displayable2.prototype.getPrevPaintRect = function() {
    return this._prevPaintRect;
  };
  Displayable2.prototype.animateStyle = function(loop) {
    return this.animate("style", loop);
  };
  Displayable2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else {
      this.markRedraw();
    }
  };
  Displayable2.prototype.attrKV = function(key, value) {
    if (key !== "style") {
      _super.prototype.attrKV.call(this, key, value);
    } else {
      if (!this.style) {
        this.useStyle(value);
      } else {
        this.setStyle(value);
      }
    }
  };
  Displayable2.prototype.setStyle = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.style[keyOrObj] = value;
    } else {
      extend(this.style, keyOrObj);
    }
    this.dirtyStyle();
    return this;
  };
  Displayable2.prototype.dirtyStyle = function(notRedraw) {
    if (!notRedraw) {
      this.markRedraw();
    }
    this.__dirty |= STYLE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
  };
  Displayable2.prototype.dirty = function() {
    this.dirtyStyle();
  };
  Displayable2.prototype.styleChanged = function() {
    return !!(this.__dirty & STYLE_CHANGED_BIT);
  };
  Displayable2.prototype.styleUpdated = function() {
    this.__dirty &= ~STYLE_CHANGED_BIT;
  };
  Displayable2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_COMMON_STYLE, obj);
  };
  Displayable2.prototype.useStyle = function(obj) {
    if (!obj[STYLE_MAGIC_KEY]) {
      obj = this.createStyle(obj);
    }
    if (this.__inHover) {
      this.__hoverStyle = obj;
    } else {
      this.style = obj;
    }
    this.dirtyStyle();
  };
  Displayable2.prototype.isStyleObject = function(obj) {
    return obj[STYLE_MAGIC_KEY];
  };
  Displayable2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.style && !normalState.style) {
      normalState.style = this._mergeStyle(this.createStyle(), this.style);
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS);
  };
  Displayable2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetStyle;
    if (state && state.style) {
      if (transition) {
        if (keepCurrentStates) {
          targetStyle = state.style;
        } else {
          targetStyle = this._mergeStyle(this.createStyle(), normalState.style);
          this._mergeStyle(targetStyle, state.style);
        }
      } else {
        targetStyle = this._mergeStyle(this.createStyle(), keepCurrentStates ? this.style : normalState.style);
        this._mergeStyle(targetStyle, state.style);
      }
    } else if (needsRestoreToNormal) {
      targetStyle = normalState.style;
    }
    if (targetStyle) {
      if (transition) {
        var sourceStyle = this.style;
        this.style = this.createStyle(needsRestoreToNormal ? {} : sourceStyle);
        if (needsRestoreToNormal) {
          var changedKeys = keys(sourceStyle);
          for (var i = 0; i < changedKeys.length; i++) {
            var key = changedKeys[i];
            if (key in targetStyle) {
              targetStyle[key] = targetStyle[key];
              this.style[key] = sourceStyle[key];
            }
          }
        }
        var targetKeys = keys(targetStyle);
        for (var i = 0; i < targetKeys.length; i++) {
          var key = targetKeys[i];
          this.style[key] = this.style[key];
        }
        this._transitionState(stateName, {
          style: targetStyle
        }, animationCfg, this.getAnimationStyleProps());
      } else {
        this.useStyle(targetStyle);
      }
    }
    var statesKeys = this.__inHover ? PRIMARY_STATES_KEYS_IN_HOVER_LAYER : PRIMARY_STATES_KEYS;
    for (var i = 0; i < statesKeys.length; i++) {
      var key = statesKeys[i];
      if (state && state[key] != null) {
        this[key] = state[key];
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          this[key] = normalState[key];
        }
      }
    }
  };
  Displayable2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedStyle;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.style) {
        mergedStyle = mergedStyle || {};
        this._mergeStyle(mergedStyle, state.style);
      }
    }
    if (mergedStyle) {
      mergedState.style = mergedStyle;
    }
    return mergedState;
  };
  Displayable2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    extend(targetStyle, sourceStyle);
    return targetStyle;
  };
  Displayable2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_COMMON_ANIMATION_PROPS;
  };
  Displayable2.initDefaultProps = function() {
    var dispProto = Displayable2.prototype;
    dispProto.type = "displayable";
    dispProto.invisible = false;
    dispProto.z = 0;
    dispProto.z2 = 0;
    dispProto.zlevel = 0;
    dispProto.culling = false;
    dispProto.cursor = "pointer";
    dispProto.rectHover = false;
    dispProto.incremental = false;
    dispProto._rect = null;
    dispProto.dirtyRectTolerance = 0;
    dispProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT;
  }();
  return Displayable2;
}(Element$2);
var tmpRect = new BoundingRect$1(0, 0, 0, 0);
var viewRect = new BoundingRect$1(0, 0, 0, 0);
function isDisplayableCulled(el, width, height) {
  tmpRect.copy(el.getBoundingRect());
  if (el.transform) {
    tmpRect.applyTransform(el.transform);
  }
  viewRect.width = width;
  viewRect.height = height;
  return !tmpRect.intersect(viewRect);
}
var Displayable$1 = Displayable;
var mathMin$9 = Math.min;
var mathMax$9 = Math.max;
var mathSin$4 = Math.sin;
var mathCos$4 = Math.cos;
var PI2$9 = Math.PI * 2;
var start = create$2();
var end = create$2();
var extremity = create$2();
function fromPoints(points2, min3, max3) {
  if (points2.length === 0) {
    return;
  }
  var p2 = points2[0];
  var left = p2[0];
  var right = p2[0];
  var top = p2[1];
  var bottom = p2[1];
  for (var i = 1; i < points2.length; i++) {
    p2 = points2[i];
    left = mathMin$9(left, p2[0]);
    right = mathMax$9(right, p2[0]);
    top = mathMin$9(top, p2[1]);
    bottom = mathMax$9(bottom, p2[1]);
  }
  min3[0] = left;
  min3[1] = top;
  max3[0] = right;
  max3[1] = bottom;
}
function fromLine(x0, y0, x1, y1, min3, max3) {
  min3[0] = mathMin$9(x0, x1);
  min3[1] = mathMin$9(y0, y1);
  max3[0] = mathMax$9(x0, x1);
  max3[1] = mathMax$9(y0, y1);
}
var xDim = [];
var yDim = [];
function fromCubic(x0, y0, x1, y1, x2, y2, x3, y3, min3, max3) {
  var cubicExtrema$1 = cubicExtrema;
  var cubicAt$1 = cubicAt;
  var n2 = cubicExtrema$1(x0, x1, x2, x3, xDim);
  min3[0] = Infinity;
  min3[1] = Infinity;
  max3[0] = -Infinity;
  max3[1] = -Infinity;
  for (var i = 0; i < n2; i++) {
    var x4 = cubicAt$1(x0, x1, x2, x3, xDim[i]);
    min3[0] = mathMin$9(x4, min3[0]);
    max3[0] = mathMax$9(x4, max3[0]);
  }
  n2 = cubicExtrema$1(y0, y1, y2, y3, yDim);
  for (var i = 0; i < n2; i++) {
    var y4 = cubicAt$1(y0, y1, y2, y3, yDim[i]);
    min3[1] = mathMin$9(y4, min3[1]);
    max3[1] = mathMax$9(y4, max3[1]);
  }
  min3[0] = mathMin$9(x0, min3[0]);
  max3[0] = mathMax$9(x0, max3[0]);
  min3[0] = mathMin$9(x3, min3[0]);
  max3[0] = mathMax$9(x3, max3[0]);
  min3[1] = mathMin$9(y0, min3[1]);
  max3[1] = mathMax$9(y0, max3[1]);
  min3[1] = mathMin$9(y3, min3[1]);
  max3[1] = mathMax$9(y3, max3[1]);
}
function fromQuadratic(x0, y0, x1, y1, x2, y2, min3, max3) {
  var quadraticExtremum$1 = quadraticExtremum;
  var quadraticAt2 = quadraticAt$1;
  var tx = mathMax$9(mathMin$9(quadraticExtremum$1(x0, x1, x2), 1), 0);
  var ty = mathMax$9(mathMin$9(quadraticExtremum$1(y0, y1, y2), 1), 0);
  var x3 = quadraticAt2(x0, x1, x2, tx);
  var y3 = quadraticAt2(y0, y1, y2, ty);
  min3[0] = mathMin$9(x0, x2, x3);
  min3[1] = mathMin$9(y0, y2, y3);
  max3[0] = mathMax$9(x0, x2, x3);
  max3[1] = mathMax$9(y0, y2, y3);
}
function fromArc(x2, y2, rx, ry, startAngle, endAngle, anticlockwise, min3, max3) {
  var vec2Min = min$1;
  var vec2Max = max$1;
  var diff = Math.abs(startAngle - endAngle);
  if (diff % PI2$9 < 1e-4 && diff > 1e-4) {
    min3[0] = x2 - rx;
    min3[1] = y2 - ry;
    max3[0] = x2 + rx;
    max3[1] = y2 + ry;
    return;
  }
  start[0] = mathCos$4(startAngle) * rx + x2;
  start[1] = mathSin$4(startAngle) * ry + y2;
  end[0] = mathCos$4(endAngle) * rx + x2;
  end[1] = mathSin$4(endAngle) * ry + y2;
  vec2Min(min3, start, end);
  vec2Max(max3, start, end);
  startAngle = startAngle % PI2$9;
  if (startAngle < 0) {
    startAngle = startAngle + PI2$9;
  }
  endAngle = endAngle % PI2$9;
  if (endAngle < 0) {
    endAngle = endAngle + PI2$9;
  }
  if (startAngle > endAngle && !anticlockwise) {
    endAngle += PI2$9;
  } else if (startAngle < endAngle && anticlockwise) {
    startAngle += PI2$9;
  }
  if (anticlockwise) {
    var tmp = endAngle;
    endAngle = startAngle;
    startAngle = tmp;
  }
  for (var angle = 0; angle < endAngle; angle += Math.PI / 2) {
    if (angle > startAngle) {
      extremity[0] = mathCos$4(angle) * rx + x2;
      extremity[1] = mathSin$4(angle) * ry + y2;
      vec2Min(min3, extremity, min3);
      vec2Max(max3, extremity, max3);
    }
  }
}
var CMD$4 = {
  M: 1,
  L: 2,
  C: 3,
  Q: 4,
  A: 5,
  Z: 6,
  R: 7
};
var tmpOutX = [];
var tmpOutY = [];
var min = [];
var max = [];
var min2 = [];
var max2 = [];
var mathMin$8 = Math.min;
var mathMax$8 = Math.max;
var mathCos$3 = Math.cos;
var mathSin$3 = Math.sin;
var mathAbs$2 = Math.abs;
var PI$8 = Math.PI;
var PI2$8 = PI$8 * 2;
var hasTypedArray = typeof Float32Array !== "undefined";
var tmpAngles = [];
function modPI2(radian) {
  var n2 = Math.round(radian / PI$8 * 1e8) / 1e8;
  return n2 % 2 * PI$8;
}
function normalizeArcAngles(angles, anticlockwise) {
  var newStartAngle = modPI2(angles[0]);
  if (newStartAngle < 0) {
    newStartAngle += PI2$8;
  }
  var delta = newStartAngle - angles[0];
  var newEndAngle = angles[1];
  newEndAngle += delta;
  if (!anticlockwise && newEndAngle - newStartAngle >= PI2$8) {
    newEndAngle = newStartAngle + PI2$8;
  } else if (anticlockwise && newStartAngle - newEndAngle >= PI2$8) {
    newEndAngle = newStartAngle - PI2$8;
  } else if (!anticlockwise && newStartAngle > newEndAngle) {
    newEndAngle = newStartAngle + (PI2$8 - modPI2(newStartAngle - newEndAngle));
  } else if (anticlockwise && newStartAngle < newEndAngle) {
    newEndAngle = newStartAngle - (PI2$8 - modPI2(newEndAngle - newStartAngle));
  }
  angles[0] = newStartAngle;
  angles[1] = newEndAngle;
}
var PathProxy = function() {
  function PathProxy2(notSaveData) {
    this.dpr = 1;
    this._xi = 0;
    this._yi = 0;
    this._x0 = 0;
    this._y0 = 0;
    this._len = 0;
    if (notSaveData) {
      this._saveData = false;
    }
    if (this._saveData) {
      this.data = [];
    }
  }
  PathProxy2.prototype.increaseVersion = function() {
    this._version++;
  };
  PathProxy2.prototype.getVersion = function() {
    return this._version;
  };
  PathProxy2.prototype.setScale = function(sx, sy, segmentIgnoreThreshold) {
    segmentIgnoreThreshold = segmentIgnoreThreshold || 0;
    if (segmentIgnoreThreshold > 0) {
      this._ux = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sx) || 0;
      this._uy = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sy) || 0;
    }
  };
  PathProxy2.prototype.setDPR = function(dpr2) {
    this.dpr = dpr2;
  };
  PathProxy2.prototype.setContext = function(ctx) {
    this._ctx = ctx;
  };
  PathProxy2.prototype.getContext = function() {
    return this._ctx;
  };
  PathProxy2.prototype.beginPath = function() {
    this._ctx && this._ctx.beginPath();
    this.reset();
    return this;
  };
  PathProxy2.prototype.reset = function() {
    if (this._saveData) {
      this._len = 0;
    }
    if (this._pathSegLen) {
      this._pathSegLen = null;
      this._pathLen = 0;
    }
    this._version++;
  };
  PathProxy2.prototype.moveTo = function(x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.M, x2, y2);
    this._ctx && this._ctx.moveTo(x2, y2);
    this._x0 = x2;
    this._y0 = y2;
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.lineTo = function(x2, y2) {
    var dx = mathAbs$2(x2 - this._xi);
    var dy = mathAbs$2(y2 - this._yi);
    var exceedUnit = dx > this._ux || dy > this._uy;
    this.addData(CMD$4.L, x2, y2);
    if (this._ctx && exceedUnit) {
      this._ctx.lineTo(x2, y2);
    }
    if (exceedUnit) {
      this._xi = x2;
      this._yi = y2;
      this._pendingPtDist = 0;
    } else {
      var d2 = dx * dx + dy * dy;
      if (d2 > this._pendingPtDist) {
        this._pendingPtX = x2;
        this._pendingPtY = y2;
        this._pendingPtDist = d2;
      }
    }
    return this;
  };
  PathProxy2.prototype.bezierCurveTo = function(x1, y1, x2, y2, x3, y3) {
    this._drawPendingPt();
    this.addData(CMD$4.C, x1, y1, x2, y2, x3, y3);
    if (this._ctx) {
      this._ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
    }
    this._xi = x3;
    this._yi = y3;
    return this;
  };
  PathProxy2.prototype.quadraticCurveTo = function(x1, y1, x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.Q, x1, y1, x2, y2);
    if (this._ctx) {
      this._ctx.quadraticCurveTo(x1, y1, x2, y2);
    }
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this._drawPendingPt();
    tmpAngles[0] = startAngle;
    tmpAngles[1] = endAngle;
    normalizeArcAngles(tmpAngles, anticlockwise);
    startAngle = tmpAngles[0];
    endAngle = tmpAngles[1];
    var delta = endAngle - startAngle;
    this.addData(CMD$4.A, cx, cy, r2, r2, startAngle, delta, 0, anticlockwise ? 0 : 1);
    this._ctx && this._ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
    this._xi = mathCos$3(endAngle) * r2 + cx;
    this._yi = mathSin$3(endAngle) * r2 + cy;
    return this;
  };
  PathProxy2.prototype.arcTo = function(x1, y1, x2, y2, radius) {
    this._drawPendingPt();
    if (this._ctx) {
      this._ctx.arcTo(x1, y1, x2, y2, radius);
    }
    return this;
  };
  PathProxy2.prototype.rect = function(x2, y2, w2, h) {
    this._drawPendingPt();
    this._ctx && this._ctx.rect(x2, y2, w2, h);
    this.addData(CMD$4.R, x2, y2, w2, h);
    return this;
  };
  PathProxy2.prototype.closePath = function() {
    this._drawPendingPt();
    this.addData(CMD$4.Z);
    var ctx = this._ctx;
    var x0 = this._x0;
    var y0 = this._y0;
    if (ctx) {
      ctx.closePath();
    }
    this._xi = x0;
    this._yi = y0;
    return this;
  };
  PathProxy2.prototype.fill = function(ctx) {
    ctx && ctx.fill();
    this.toStatic();
  };
  PathProxy2.prototype.stroke = function(ctx) {
    ctx && ctx.stroke();
    this.toStatic();
  };
  PathProxy2.prototype.len = function() {
    return this._len;
  };
  PathProxy2.prototype.setData = function(data) {
    var len2 = data.length;
    if (!(this.data && this.data.length === len2) && hasTypedArray) {
      this.data = new Float32Array(len2);
    }
    for (var i = 0; i < len2; i++) {
      this.data[i] = data[i];
    }
    this._len = len2;
  };
  PathProxy2.prototype.appendPath = function(path) {
    if (!(path instanceof Array)) {
      path = [path];
    }
    var len2 = path.length;
    var appendSize = 0;
    var offset = this._len;
    for (var i = 0; i < len2; i++) {
      appendSize += path[i].len();
    }
    if (hasTypedArray && this.data instanceof Float32Array) {
      this.data = new Float32Array(offset + appendSize);
    }
    for (var i = 0; i < len2; i++) {
      var appendPathData = path[i].data;
      for (var k2 = 0; k2 < appendPathData.length; k2++) {
        this.data[offset++] = appendPathData[k2];
      }
    }
    this._len = offset;
  };
  PathProxy2.prototype.addData = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    if (!this._saveData) {
      return;
    }
    var data = this.data;
    if (this._len + arguments.length > data.length) {
      this._expandData();
      data = this.data;
    }
    for (var i = 0; i < arguments.length; i++) {
      data[this._len++] = arguments[i];
    }
  };
  PathProxy2.prototype._drawPendingPt = function() {
    if (this._pendingPtDist > 0) {
      this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY);
      this._pendingPtDist = 0;
    }
  };
  PathProxy2.prototype._expandData = function() {
    if (!(this.data instanceof Array)) {
      var newData = [];
      for (var i = 0; i < this._len; i++) {
        newData[i] = this.data[i];
      }
      this.data = newData;
    }
  };
  PathProxy2.prototype.toStatic = function() {
    if (!this._saveData) {
      return;
    }
    this._drawPendingPt();
    var data = this.data;
    if (data instanceof Array) {
      data.length = this._len;
      if (hasTypedArray && this._len > 11) {
        this.data = new Float32Array(data);
      }
    }
  };
  PathProxy2.prototype.getBoundingRect = function() {
    min[0] = min[1] = min2[0] = min2[1] = Number.MAX_VALUE;
    max[0] = max[1] = max2[0] = max2[1] = -Number.MAX_VALUE;
    var data = this.data;
    var xi = 0;
    var yi = 0;
    var x0 = 0;
    var y0 = 0;
    var i;
    for (i = 0; i < this._len; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi = data[i];
        yi = data[i + 1];
        x0 = xi;
        y0 = yi;
      }
      switch (cmd) {
        case CMD$4.M:
          xi = x0 = data[i++];
          yi = y0 = data[i++];
          min2[0] = x0;
          min2[1] = y0;
          max2[0] = x0;
          max2[1] = y0;
          break;
        case CMD$4.L:
          fromLine(xi, yi, data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.C:
          fromCubic(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.Q:
          fromQuadratic(xi, yi, data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var endAngle = data[i++] + startAngle;
          i += 1;
          var anticlockwise = !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          fromArc(cx, cy, rx, ry, startAngle, endAngle, anticlockwise, min2, max2);
          xi = mathCos$3(endAngle) * rx + cx;
          yi = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R:
          x0 = xi = data[i++];
          y0 = yi = data[i++];
          var width = data[i++];
          var height = data[i++];
          fromLine(x0, y0, x0 + width, y0 + height, min2, max2);
          break;
        case CMD$4.Z:
          xi = x0;
          yi = y0;
          break;
      }
      min$1(min, min, min2);
      max$1(max, max, max2);
    }
    if (i === 0) {
      min[0] = min[1] = max[0] = max[1] = 0;
    }
    return new BoundingRect$1(min[0], min[1], max[0] - min[0], max[1] - min[1]);
  };
  PathProxy2.prototype._calculateLength = function() {
    var data = this.data;
    var len2 = this._len;
    var ux = this._ux;
    var uy = this._uy;
    var xi = 0;
    var yi = 0;
    var x0 = 0;
    var y0 = 0;
    if (!this._pathSegLen) {
      this._pathSegLen = [];
    }
    var pathSegLen = this._pathSegLen;
    var pathTotalLen = 0;
    var segCount = 0;
    for (var i = 0; i < len2; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi = data[i];
        yi = data[i + 1];
        x0 = xi;
        y0 = yi;
      }
      var l2 = -1;
      switch (cmd) {
        case CMD$4.M:
          xi = x0 = data[i++];
          yi = y0 = data[i++];
          break;
        case CMD$4.L: {
          var x2 = data[i++];
          var y2 = data[i++];
          var dx = x2 - xi;
          var dy = y2 - yi;
          if (mathAbs$2(dx) > ux || mathAbs$2(dy) > uy || i === len2 - 1) {
            l2 = Math.sqrt(dx * dx + dy * dy);
            xi = x2;
            yi = y2;
          }
          break;
        }
        case CMD$4.C: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          var x3 = data[i++];
          var y3 = data[i++];
          l2 = cubicLength(xi, yi, x1, y1, x2, y2, x3, y3, 10);
          xi = x3;
          yi = y3;
          break;
        }
        case CMD$4.Q: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          l2 = quadraticLength(xi, yi, x1, y1, x2, y2, 10);
          xi = x2;
          yi = y2;
          break;
        }
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var delta = data[i++];
          var endAngle = delta + startAngle;
          i += 1;
          !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          l2 = mathMax$8(rx, ry) * mathMin$8(PI2$8, Math.abs(delta));
          xi = mathCos$3(endAngle) * rx + cx;
          yi = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R: {
          x0 = xi = data[i++];
          y0 = yi = data[i++];
          var width = data[i++];
          var height = data[i++];
          l2 = width * 2 + height * 2;
          break;
        }
        case CMD$4.Z: {
          var dx = x0 - xi;
          var dy = y0 - yi;
          l2 = Math.sqrt(dx * dx + dy * dy);
          xi = x0;
          yi = y0;
          break;
        }
      }
      if (l2 >= 0) {
        pathSegLen[segCount++] = l2;
        pathTotalLen += l2;
      }
    }
    this._pathLen = pathTotalLen;
    return pathTotalLen;
  };
  PathProxy2.prototype.rebuildPath = function(ctx, percent) {
    var d2 = this.data;
    var ux = this._ux;
    var uy = this._uy;
    var len2 = this._len;
    var x0;
    var y0;
    var xi;
    var yi;
    var x2;
    var y2;
    var drawPart = percent < 1;
    var pathSegLen;
    var pathTotalLen;
    var accumLength = 0;
    var segCount = 0;
    var displayedLength;
    var pendingPtDist = 0;
    var pendingPtX;
    var pendingPtY;
    if (drawPart) {
      if (!this._pathSegLen) {
        this._calculateLength();
      }
      pathSegLen = this._pathSegLen;
      pathTotalLen = this._pathLen;
      displayedLength = percent * pathTotalLen;
      if (!displayedLength) {
        return;
      }
    }
    lo:
      for (var i = 0; i < len2; ) {
        var cmd = d2[i++];
        var isFirst = i === 1;
        if (isFirst) {
          xi = d2[i];
          yi = d2[i + 1];
          x0 = xi;
          y0 = yi;
        }
        if (cmd !== CMD$4.L && pendingPtDist > 0) {
          ctx.lineTo(pendingPtX, pendingPtY);
          pendingPtDist = 0;
        }
        switch (cmd) {
          case CMD$4.M:
            x0 = xi = d2[i++];
            y0 = yi = d2[i++];
            ctx.moveTo(xi, yi);
            break;
          case CMD$4.L: {
            x2 = d2[i++];
            y2 = d2[i++];
            var dx = mathAbs$2(x2 - xi);
            var dy = mathAbs$2(y2 - yi);
            if (dx > ux || dy > uy) {
              if (drawPart) {
                var l2 = pathSegLen[segCount++];
                if (accumLength + l2 > displayedLength) {
                  var t2 = (displayedLength - accumLength) / l2;
                  ctx.lineTo(xi * (1 - t2) + x2 * t2, yi * (1 - t2) + y2 * t2);
                  break lo;
                }
                accumLength += l2;
              }
              ctx.lineTo(x2, y2);
              xi = x2;
              yi = y2;
              pendingPtDist = 0;
            } else {
              var d22 = dx * dx + dy * dy;
              if (d22 > pendingPtDist) {
                pendingPtX = x2;
                pendingPtY = y2;
                pendingPtDist = d22;
              }
            }
            break;
          }
          case CMD$4.C: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            var x3 = d2[i++];
            var y3 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                cubicSubdivide(xi, x1, x22, x3, t2, tmpOutX);
                cubicSubdivide(yi, y1, y22, y3, t2, tmpOutY);
                ctx.bezierCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2], tmpOutX[3], tmpOutY[3]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.bezierCurveTo(x1, y1, x22, y22, x3, y3);
            xi = x3;
            yi = y3;
            break;
          }
          case CMD$4.Q: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                quadraticSubdivide(xi, x1, x22, t2, tmpOutX);
                quadraticSubdivide(yi, y1, y22, t2, tmpOutY);
                ctx.quadraticCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.quadraticCurveTo(x1, y1, x22, y22);
            xi = x22;
            yi = y22;
            break;
          }
          case CMD$4.A:
            var cx = d2[i++];
            var cy = d2[i++];
            var rx = d2[i++];
            var ry = d2[i++];
            var startAngle = d2[i++];
            var delta = d2[i++];
            var psi = d2[i++];
            var anticlockwise = !d2[i++];
            var r2 = rx > ry ? rx : ry;
            var isEllipse = mathAbs$2(rx - ry) > 1e-3;
            var endAngle = startAngle + delta;
            var breakBuild = false;
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                endAngle = startAngle + delta * (displayedLength - accumLength) / l2;
                breakBuild = true;
              }
              accumLength += l2;
            }
            if (isEllipse && ctx.ellipse) {
              ctx.ellipse(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise);
            } else {
              ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
            }
            if (breakBuild) {
              break lo;
            }
            if (isFirst) {
              x0 = mathCos$3(startAngle) * rx + cx;
              y0 = mathSin$3(startAngle) * ry + cy;
            }
            xi = mathCos$3(endAngle) * rx + cx;
            yi = mathSin$3(endAngle) * ry + cy;
            break;
          case CMD$4.R:
            x0 = xi = d2[i];
            y0 = yi = d2[i + 1];
            x2 = d2[i++];
            y2 = d2[i++];
            var width = d2[i++];
            var height = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var d_1 = displayedLength - accumLength;
                ctx.moveTo(x2, y2);
                ctx.lineTo(x2 + mathMin$8(d_1, width), y2);
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + width, y2 + mathMin$8(d_1, height));
                }
                d_1 -= height;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + mathMax$8(width - d_1, 0), y2 + height);
                }
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2, y2 + mathMax$8(height - d_1, 0));
                }
                break lo;
              }
              accumLength += l2;
            }
            ctx.rect(x2, y2, width, height);
            break;
          case CMD$4.Z:
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                ctx.lineTo(xi * (1 - t2) + x0 * t2, yi * (1 - t2) + y0 * t2);
                break lo;
              }
              accumLength += l2;
            }
            ctx.closePath();
            xi = x0;
            yi = y0;
        }
      }
  };
  PathProxy2.prototype.clone = function() {
    var newProxy = new PathProxy2();
    var data = this.data;
    newProxy.data = data.slice ? data.slice() : Array.prototype.slice.call(data);
    newProxy._len = this._len;
    return newProxy;
  };
  PathProxy2.CMD = CMD$4;
  PathProxy2.initDefaultProps = function() {
    var proto2 = PathProxy2.prototype;
    proto2._saveData = true;
    proto2._ux = 0;
    proto2._uy = 0;
    proto2._pendingPtDist = 0;
    proto2._version = 0;
  }();
  return PathProxy2;
}();
var PathProxy$1 = PathProxy;
function containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  var _a2 = 0;
  var _b2 = x0;
  if (y2 > y0 + _l && y2 > y1 + _l || y2 < y0 - _l && y2 < y1 - _l || x2 > x0 + _l && x2 > x1 + _l || x2 < x0 - _l && x2 < x1 - _l) {
    return false;
  }
  if (x0 !== x1) {
    _a2 = (y0 - y1) / (x0 - x1);
    _b2 = (x0 * y1 - x1 * y0) / (x0 - x1);
  } else {
    return Math.abs(x2 - x0) <= _l / 2;
  }
  var tmp = _a2 * x2 - y2 + _b2;
  var _s = tmp * tmp / (_a2 * _a2 + 1);
  return _s <= _l / 2 * _l / 2;
}
function containStroke$3(x0, y0, x1, y1, x2, y2, x3, y3, lineWidth, x4, y4) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y4 > y0 + _l && y4 > y1 + _l && y4 > y2 + _l && y4 > y3 + _l || y4 < y0 - _l && y4 < y1 - _l && y4 < y2 - _l && y4 < y3 - _l || x4 > x0 + _l && x4 > x1 + _l && x4 > x2 + _l && x4 > x3 + _l || x4 < x0 - _l && x4 < x1 - _l && x4 < x2 - _l && x4 < x3 - _l) {
    return false;
  }
  var d2 = cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, null);
  return d2 <= _l / 2;
}
function containStroke$2(x0, y0, x1, y1, x2, y2, lineWidth, x3, y3) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y3 > y0 + _l && y3 > y1 + _l && y3 > y2 + _l || y3 < y0 - _l && y3 < y1 - _l && y3 < y2 - _l || x3 > x0 + _l && x3 > x1 + _l && x3 > x2 + _l || x3 < x0 - _l && x3 < x1 - _l && x3 < x2 - _l) {
    return false;
  }
  var d2 = quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, null);
  return d2 <= _l / 2;
}
var PI2$7 = Math.PI * 2;
function normalizeRadian(angle) {
  angle %= PI2$7;
  if (angle < 0) {
    angle += PI2$7;
  }
  return angle;
}
var PI2$6 = Math.PI * 2;
function containStroke$1(cx, cy, r2, startAngle, endAngle, anticlockwise, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  if (d2 - _l > r2 || d2 + _l < r2) {
    return false;
  }
  if (Math.abs(startAngle - endAngle) % PI2$6 < 1e-4) {
    return true;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$6;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$6;
  }
  return angle >= startAngle && angle <= endAngle || angle + PI2$6 >= startAngle && angle + PI2$6 <= endAngle;
}
function windingLine(x0, y0, x1, y1, x2, y2) {
  if (y2 > y0 && y2 > y1 || y2 < y0 && y2 < y1) {
    return 0;
  }
  if (y1 === y0) {
    return 0;
  }
  var t2 = (y2 - y0) / (y1 - y0);
  var dir3 = y1 < y0 ? 1 : -1;
  if (t2 === 1 || t2 === 0) {
    dir3 = y1 < y0 ? 0.5 : -0.5;
  }
  var x_ = t2 * (x1 - x0) + x0;
  return x_ === x2 ? Infinity : x_ > x2 ? dir3 : 0;
}
var CMD$3 = PathProxy$1.CMD;
var PI2$5 = Math.PI * 2;
var EPSILON$1 = 1e-4;
function isAroundEqual$1(a, b2) {
  return Math.abs(a - b2) < EPSILON$1;
}
var roots = [-1, -1, -1];
var extrema = [-1, -1];
function swapExtrema() {
  var tmp = extrema[0];
  extrema[0] = extrema[1];
  extrema[1] = tmp;
}
function windingCubic(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4) {
  if (y4 > y0 && y4 > y1 && y4 > y2 && y4 > y3 || y4 < y0 && y4 < y1 && y4 < y2 && y4 < y3) {
    return 0;
  }
  var nRoots = cubicRootAt(y0, y1, y2, y3, y4, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var w2 = 0;
    var nExtrema = -1;
    var y0_ = void 0;
    var y1_ = void 0;
    for (var i = 0; i < nRoots; i++) {
      var t2 = roots[i];
      var unit = t2 === 0 || t2 === 1 ? 0.5 : 1;
      var x_ = cubicAt(x0, x1, x2, x3, t2);
      if (x_ < x4) {
        continue;
      }
      if (nExtrema < 0) {
        nExtrema = cubicExtrema(y0, y1, y2, y3, extrema);
        if (extrema[1] < extrema[0] && nExtrema > 1) {
          swapExtrema();
        }
        y0_ = cubicAt(y0, y1, y2, y3, extrema[0]);
        if (nExtrema > 1) {
          y1_ = cubicAt(y0, y1, y2, y3, extrema[1]);
        }
      }
      if (nExtrema === 2) {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else if (t2 < extrema[1]) {
          w2 += y1_ < y0_ ? unit : -unit;
        } else {
          w2 += y3 < y1_ ? unit : -unit;
        }
      } else {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else {
          w2 += y3 < y0_ ? unit : -unit;
        }
      }
    }
    return w2;
  }
}
function windingQuadratic(x0, y0, x1, y1, x2, y2, x3, y3) {
  if (y3 > y0 && y3 > y1 && y3 > y2 || y3 < y0 && y3 < y1 && y3 < y2) {
    return 0;
  }
  var nRoots = quadraticRootAt(y0, y1, y2, y3, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var t2 = quadraticExtremum(y0, y1, y2);
    if (t2 >= 0 && t2 <= 1) {
      var w2 = 0;
      var y_ = quadraticAt$1(y0, y1, y2, t2);
      for (var i = 0; i < nRoots; i++) {
        var unit = roots[i] === 0 || roots[i] === 1 ? 0.5 : 1;
        var x_ = quadraticAt$1(x0, x1, x2, roots[i]);
        if (x_ < x3) {
          continue;
        }
        if (roots[i] < t2) {
          w2 += y_ < y0 ? unit : -unit;
        } else {
          w2 += y2 < y_ ? unit : -unit;
        }
      }
      return w2;
    } else {
      var unit = roots[0] === 0 || roots[0] === 1 ? 0.5 : 1;
      var x_ = quadraticAt$1(x0, x1, x2, roots[0]);
      if (x_ < x3) {
        return 0;
      }
      return y2 < y0 ? unit : -unit;
    }
  }
}
function windingArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2) {
  y2 -= cy;
  if (y2 > r2 || y2 < -r2) {
    return 0;
  }
  var tmp = Math.sqrt(r2 * r2 - y2 * y2);
  roots[0] = -tmp;
  roots[1] = tmp;
  var dTheta = Math.abs(startAngle - endAngle);
  if (dTheta < 1e-4) {
    return 0;
  }
  if (dTheta >= PI2$5 - 1e-4) {
    startAngle = 0;
    endAngle = PI2$5;
    var dir3 = anticlockwise ? 1 : -1;
    if (x2 >= roots[0] + cx && x2 <= roots[1] + cx) {
      return dir3;
    } else {
      return 0;
    }
  }
  if (startAngle > endAngle) {
    var tmp_1 = startAngle;
    startAngle = endAngle;
    endAngle = tmp_1;
  }
  if (startAngle < 0) {
    startAngle += PI2$5;
    endAngle += PI2$5;
  }
  var w2 = 0;
  for (var i = 0; i < 2; i++) {
    var x_ = roots[i];
    if (x_ + cx > x2) {
      var angle = Math.atan2(y2, x_);
      var dir3 = anticlockwise ? 1 : -1;
      if (angle < 0) {
        angle = PI2$5 + angle;
      }
      if (angle >= startAngle && angle <= endAngle || angle + PI2$5 >= startAngle && angle + PI2$5 <= endAngle) {
        if (angle > Math.PI / 2 && angle < Math.PI * 1.5) {
          dir3 = -dir3;
        }
        w2 += dir3;
      }
    }
  }
  return w2;
}
function containPath(path, lineWidth, isStroke, x2, y2) {
  var data = path.data;
  var len2 = path.len();
  var w2 = 0;
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (cmd === CMD$3.M && i > 1) {
      if (!isStroke) {
        w2 += windingLine(xi, yi, x0, y0, x2, y2);
      }
    }
    if (isFirst) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
    }
    switch (cmd) {
      case CMD$3.M:
        x0 = data[i++];
        y0 = data[i++];
        xi = x0;
        yi = y0;
        break;
      case CMD$3.L:
        if (isStroke) {
          if (containStroke$4(xi, yi, data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi, yi, data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.C:
        if (isStroke) {
          if (containStroke$3(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingCubic(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.Q:
        if (isStroke) {
          if (containStroke$2(xi, yi, data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingQuadratic(xi, yi, data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (!isFirst) {
          w2 += windingLine(xi, yi, x1, y1, x2, y2);
        } else {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        if (isStroke) {
          if (containStroke$1(cx, cy, ry, theta, theta + dTheta, anticlockwise, lineWidth, _x, y2)) {
            return true;
          }
        } else {
          w2 += windingArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2);
        }
        xi = Math.cos(theta + dTheta) * rx + cx;
        yi = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$3.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        var width = data[i++];
        var height = data[i++];
        x1 = x0 + width;
        y1 = y0 + height;
        if (isStroke) {
          if (containStroke$4(x0, y0, x1, y0, lineWidth, x2, y2) || containStroke$4(x1, y0, x1, y1, lineWidth, x2, y2) || containStroke$4(x1, y1, x0, y1, lineWidth, x2, y2) || containStroke$4(x0, y1, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(x1, y0, x1, y1, x2, y2);
          w2 += windingLine(x0, y1, x0, y0, x2, y2);
        }
        break;
      case CMD$3.Z:
        if (isStroke) {
          if (containStroke$4(xi, yi, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi, yi, x0, y0, x2, y2);
        }
        xi = x0;
        yi = y0;
        break;
    }
  }
  if (!isStroke && !isAroundEqual$1(yi, y0)) {
    w2 += windingLine(xi, yi, x0, y0, x2, y2) || 0;
  }
  return w2 !== 0;
}
function contain$2(pathProxy, x2, y2) {
  return containPath(pathProxy, 0, false, x2, y2);
}
function containStroke(pathProxy, lineWidth, x2, y2) {
  return containPath(pathProxy, lineWidth, true, x2, y2);
}
var DEFAULT_PATH_STYLE = defaults({
  fill: "#000",
  stroke: null,
  strokePercent: 1,
  fillOpacity: 1,
  strokeOpacity: 1,
  lineDashOffset: 0,
  lineWidth: 1,
  lineCap: "butt",
  miterLimit: 10,
  strokeNoScale: false,
  strokeFirst: false
}, DEFAULT_COMMON_STYLE);
var DEFAULT_PATH_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    strokePercent: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineDashOffset: true,
    lineWidth: true,
    miterLimit: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var pathCopyParams = TRANSFORMABLE_PROPS.concat([
  "invisible",
  "culling",
  "z",
  "z2",
  "zlevel",
  "parent"
]);
var Path = function(_super) {
  __extends(Path2, _super);
  function Path2(opts) {
    return _super.call(this, opts) || this;
  }
  Path2.prototype.update = function() {
    var _this = this;
    _super.prototype.update.call(this);
    var style = this.style;
    if (style.decal) {
      var decalEl = this._decalEl = this._decalEl || new Path2();
      if (decalEl.buildPath === Path2.prototype.buildPath) {
        decalEl.buildPath = function(ctx) {
          _this.buildPath(ctx, _this.shape);
        };
      }
      decalEl.silent = true;
      var decalElStyle = decalEl.style;
      for (var key in style) {
        if (decalElStyle[key] !== style[key]) {
          decalElStyle[key] = style[key];
        }
      }
      decalElStyle.fill = style.fill ? style.decal : null;
      decalElStyle.decal = null;
      decalElStyle.shadowColor = null;
      style.strokeFirst && (decalElStyle.stroke = null);
      for (var i = 0; i < pathCopyParams.length; ++i) {
        decalEl[pathCopyParams[i]] = this[pathCopyParams[i]];
      }
      decalEl.__dirty |= REDRAW_BIT;
    } else if (this._decalEl) {
      this._decalEl = null;
    }
  };
  Path2.prototype.getDecalElement = function() {
    return this._decalEl;
  };
  Path2.prototype._init = function(props) {
    var keysArr = keys(props);
    this.shape = this.getDefaultShape();
    var defaultStyle = this.getDefaultStyle();
    if (defaultStyle) {
      this.useStyle(defaultStyle);
    }
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      var value = props[key];
      if (key === "style") {
        if (!this.style) {
          this.useStyle(value);
        } else {
          extend(this.style, value);
        }
      } else if (key === "shape") {
        extend(this.shape, value);
      } else {
        _super.prototype.attrKV.call(this, key, value);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Path2.prototype.getDefaultStyle = function() {
    return null;
  };
  Path2.prototype.getDefaultShape = function() {
    return {};
  };
  Path2.prototype.canBeInsideText = function() {
    return this.hasFill();
  };
  Path2.prototype.getInsideTextFill = function() {
    var pathFill = this.style.fill;
    if (pathFill !== "none") {
      if (isString(pathFill)) {
        var fillLum = lum(pathFill, 0);
        if (fillLum > 0.5) {
          return DARK_LABEL_COLOR;
        } else if (fillLum > 0.2) {
          return LIGHTER_LABEL_COLOR;
        }
        return LIGHT_LABEL_COLOR;
      } else if (pathFill) {
        return LIGHT_LABEL_COLOR;
      }
    }
    return DARK_LABEL_COLOR;
  };
  Path2.prototype.getInsideTextStroke = function(textFill) {
    var pathFill = this.style.fill;
    if (isString(pathFill)) {
      var zr = this.__zr;
      var isDarkMode2 = !!(zr && zr.isDarkMode());
      var isDarkLabel = lum(textFill, 0) < DARK_MODE_THRESHOLD;
      if (isDarkMode2 === isDarkLabel) {
        return pathFill;
      }
    }
  };
  Path2.prototype.buildPath = function(ctx, shapeCfg, inBatch) {
  };
  Path2.prototype.pathUpdated = function() {
    this.__dirty &= ~SHAPE_CHANGED_BIT;
  };
  Path2.prototype.getUpdatedPathProxy = function(inBatch) {
    !this.path && this.createPathProxy();
    this.path.beginPath();
    this.buildPath(this.path, this.shape, inBatch);
    return this.path;
  };
  Path2.prototype.createPathProxy = function() {
    this.path = new PathProxy$1(false);
  };
  Path2.prototype.hasStroke = function() {
    var style = this.style;
    var stroke = style.stroke;
    return !(stroke == null || stroke === "none" || !(style.lineWidth > 0));
  };
  Path2.prototype.hasFill = function() {
    var style = this.style;
    var fill = style.fill;
    return fill != null && fill !== "none";
  };
  Path2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    var style = this.style;
    var needsUpdateRect = !rect;
    if (needsUpdateRect) {
      var firstInvoke = false;
      if (!this.path) {
        firstInvoke = true;
        this.createPathProxy();
      }
      var path = this.path;
      if (firstInvoke || this.__dirty & SHAPE_CHANGED_BIT) {
        path.beginPath();
        this.buildPath(path, this.shape, false);
        this.pathUpdated();
      }
      rect = path.getBoundingRect();
    }
    this._rect = rect;
    if (this.hasStroke() && this.path && this.path.len() > 0) {
      var rectStroke = this._rectStroke || (this._rectStroke = rect.clone());
      if (this.__dirty || needsUpdateRect) {
        rectStroke.copy(rect);
        var lineScale = style.strokeNoScale ? this.getLineScale() : 1;
        var w2 = style.lineWidth;
        if (!this.hasFill()) {
          var strokeContainThreshold = this.strokeContainThreshold;
          w2 = Math.max(w2, strokeContainThreshold == null ? 4 : strokeContainThreshold);
        }
        if (lineScale > 1e-10) {
          rectStroke.width += w2 / lineScale;
          rectStroke.height += w2 / lineScale;
          rectStroke.x -= w2 / lineScale / 2;
          rectStroke.y -= w2 / lineScale / 2;
        }
      }
      return rectStroke;
    }
    return rect;
  };
  Path2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    var style = this.style;
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var pathProxy = this.path;
      if (this.hasStroke()) {
        var lineWidth = style.lineWidth;
        var lineScale = style.strokeNoScale ? this.getLineScale() : 1;
        if (lineScale > 1e-10) {
          if (!this.hasFill()) {
            lineWidth = Math.max(lineWidth, this.strokeContainThreshold);
          }
          if (containStroke(pathProxy, lineWidth / lineScale, x2, y2)) {
            return true;
          }
        }
      }
      if (this.hasFill()) {
        return contain$2(pathProxy, x2, y2);
      }
    }
    return false;
  };
  Path2.prototype.dirtyShape = function() {
    this.__dirty |= SHAPE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
    if (this._decalEl) {
      this._decalEl.dirtyShape();
    }
    this.markRedraw();
  };
  Path2.prototype.dirty = function() {
    this.dirtyStyle();
    this.dirtyShape();
  };
  Path2.prototype.animateShape = function(loop) {
    return this.animate("shape", loop);
  };
  Path2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else if (targetKey === "shape") {
      this.dirtyShape();
    } else {
      this.markRedraw();
    }
  };
  Path2.prototype.attrKV = function(key, value) {
    if (key === "shape") {
      this.setShape(value);
    } else {
      _super.prototype.attrKV.call(this, key, value);
    }
  };
  Path2.prototype.setShape = function(keyOrObj, value) {
    var shape = this.shape;
    if (!shape) {
      shape = this.shape = {};
    }
    if (typeof keyOrObj === "string") {
      shape[keyOrObj] = value;
    } else {
      extend(shape, keyOrObj);
    }
    this.dirtyShape();
    return this;
  };
  Path2.prototype.shapeChanged = function() {
    return !!(this.__dirty & SHAPE_CHANGED_BIT);
  };
  Path2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_PATH_STYLE, obj);
  };
  Path2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.shape && !normalState.shape) {
      normalState.shape = extend({}, this.shape);
    }
  };
  Path2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetShape;
    if (state && state.shape) {
      if (transition) {
        if (keepCurrentStates) {
          targetShape = state.shape;
        } else {
          targetShape = extend({}, normalState.shape);
          extend(targetShape, state.shape);
        }
      } else {
        targetShape = extend({}, keepCurrentStates ? this.shape : normalState.shape);
        extend(targetShape, state.shape);
      }
    } else if (needsRestoreToNormal) {
      targetShape = normalState.shape;
    }
    if (targetShape) {
      if (transition) {
        this.shape = extend({}, this.shape);
        var targetShapePrimaryProps = {};
        var shapeKeys = keys(targetShape);
        for (var i = 0; i < shapeKeys.length; i++) {
          var key = shapeKeys[i];
          if (typeof targetShape[key] === "object") {
            this.shape[key] = targetShape[key];
          } else {
            targetShapePrimaryProps[key] = targetShape[key];
          }
        }
        this._transitionState(stateName, {
          shape: targetShapePrimaryProps
        }, animationCfg);
      } else {
        this.shape = targetShape;
        this.dirtyShape();
      }
    }
  };
  Path2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedShape;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.shape) {
        mergedShape = mergedShape || {};
        this._mergeStyle(mergedShape, state.shape);
      }
    }
    if (mergedShape) {
      mergedState.shape = mergedShape;
    }
    return mergedState;
  };
  Path2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_PATH_ANIMATION_PROPS;
  };
  Path2.prototype.isZeroArea = function() {
    return false;
  };
  Path2.extend = function(defaultProps) {
    var Sub = function(_super2) {
      __extends(Sub2, _super2);
      function Sub2(opts) {
        var _this = _super2.call(this, opts) || this;
        defaultProps.init && defaultProps.init.call(_this, opts);
        return _this;
      }
      Sub2.prototype.getDefaultStyle = function() {
        return clone$4(defaultProps.style);
      };
      Sub2.prototype.getDefaultShape = function() {
        return clone$4(defaultProps.shape);
      };
      return Sub2;
    }(Path2);
    for (var key in defaultProps) {
      if (typeof defaultProps[key] === "function") {
        Sub.prototype[key] = defaultProps[key];
      }
    }
    return Sub;
  };
  Path2.initDefaultProps = function() {
    var pathProto = Path2.prototype;
    pathProto.type = "path";
    pathProto.strokeContainThreshold = 5;
    pathProto.segmentIgnoreThreshold = 0;
    pathProto.subPixelOptimize = false;
    pathProto.autoBatch = false;
    pathProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT | SHAPE_CHANGED_BIT;
  }();
  return Path2;
}(Displayable$1);
var Path$1 = Path;
var DEFAULT_TSPAN_STYLE = defaults({
  strokeFirst: true,
  font: DEFAULT_FONT,
  x: 0,
  y: 0,
  textAlign: "left",
  textBaseline: "top",
  miterLimit: 2
}, DEFAULT_PATH_STYLE);
var TSpan = function(_super) {
  __extends(TSpan2, _super);
  function TSpan2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  TSpan2.prototype.hasStroke = function() {
    var style = this.style;
    var stroke = style.stroke;
    return stroke != null && stroke !== "none" && style.lineWidth > 0;
  };
  TSpan2.prototype.hasFill = function() {
    var style = this.style;
    var fill = style.fill;
    return fill != null && fill !== "none";
  };
  TSpan2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_TSPAN_STYLE, obj);
  };
  TSpan2.prototype.setBoundingRect = function(rect) {
    this._rect = rect;
  };
  TSpan2.prototype.getBoundingRect = function() {
    var style = this.style;
    if (!this._rect) {
      var text = style.text;
      text != null ? text += "" : text = "";
      var rect = getBoundingRect(text, style.font, style.textAlign, style.textBaseline);
      rect.x += style.x || 0;
      rect.y += style.y || 0;
      if (this.hasStroke()) {
        var w2 = style.lineWidth;
        rect.x -= w2 / 2;
        rect.y -= w2 / 2;
        rect.width += w2;
        rect.height += w2;
      }
      this._rect = rect;
    }
    return this._rect;
  };
  TSpan2.initDefaultProps = function() {
    var tspanProto = TSpan2.prototype;
    tspanProto.dirtyRectTolerance = 10;
  }();
  return TSpan2;
}(Displayable$1);
TSpan.prototype.type = "tspan";
var TSpan$1 = TSpan;
var DEFAULT_IMAGE_STYLE = defaults({
  x: 0,
  y: 0
}, DEFAULT_COMMON_STYLE);
var DEFAULT_IMAGE_ANIMATION_PROPS = {
  style: defaults({
    x: true,
    y: true,
    width: true,
    height: true,
    sx: true,
    sy: true,
    sWidth: true,
    sHeight: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
function isImageLike$1(source) {
  return !!(source && typeof source !== "string" && source.width && source.height);
}
var ZRImage = function(_super) {
  __extends(ZRImage2, _super);
  function ZRImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ZRImage2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_IMAGE_STYLE, obj);
  };
  ZRImage2.prototype._getSize = function(dim) {
    var style = this.style;
    var size = style[dim];
    if (size != null) {
      return size;
    }
    var imageSource = isImageLike$1(style.image) ? style.image : this.__image;
    if (!imageSource) {
      return 0;
    }
    var otherDim = dim === "width" ? "height" : "width";
    var otherDimSize = style[otherDim];
    if (otherDimSize == null) {
      return imageSource[dim];
    } else {
      return imageSource[dim] / imageSource[otherDim] * otherDimSize;
    }
  };
  ZRImage2.prototype.getWidth = function() {
    return this._getSize("width");
  };
  ZRImage2.prototype.getHeight = function() {
    return this._getSize("height");
  };
  ZRImage2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_IMAGE_ANIMATION_PROPS;
  };
  ZRImage2.prototype.getBoundingRect = function() {
    var style = this.style;
    if (!this._rect) {
      this._rect = new BoundingRect$1(style.x || 0, style.y || 0, this.getWidth(), this.getHeight());
    }
    return this._rect;
  };
  return ZRImage2;
}(Displayable$1);
ZRImage.prototype.type = "image";
var ZRImage$1 = ZRImage;
function buildPath$2(ctx, shape) {
  var x2 = shape.x;
  var y2 = shape.y;
  var width = shape.width;
  var height = shape.height;
  var r2 = shape.r;
  var r1;
  var r22;
  var r3;
  var r4;
  if (width < 0) {
    x2 = x2 + width;
    width = -width;
  }
  if (height < 0) {
    y2 = y2 + height;
    height = -height;
  }
  if (typeof r2 === "number") {
    r1 = r22 = r3 = r4 = r2;
  } else if (r2 instanceof Array) {
    if (r2.length === 1) {
      r1 = r22 = r3 = r4 = r2[0];
    } else if (r2.length === 2) {
      r1 = r3 = r2[0];
      r22 = r4 = r2[1];
    } else if (r2.length === 3) {
      r1 = r2[0];
      r22 = r4 = r2[1];
      r3 = r2[2];
    } else {
      r1 = r2[0];
      r22 = r2[1];
      r3 = r2[2];
      r4 = r2[3];
    }
  } else {
    r1 = r22 = r3 = r4 = 0;
  }
  var total;
  if (r1 + r22 > width) {
    total = r1 + r22;
    r1 *= width / total;
    r22 *= width / total;
  }
  if (r3 + r4 > width) {
    total = r3 + r4;
    r3 *= width / total;
    r4 *= width / total;
  }
  if (r22 + r3 > height) {
    total = r22 + r3;
    r22 *= height / total;
    r3 *= height / total;
  }
  if (r1 + r4 > height) {
    total = r1 + r4;
    r1 *= height / total;
    r4 *= height / total;
  }
  ctx.moveTo(x2 + r1, y2);
  ctx.lineTo(x2 + width - r22, y2);
  r22 !== 0 && ctx.arc(x2 + width - r22, y2 + r22, r22, -Math.PI / 2, 0);
  ctx.lineTo(x2 + width, y2 + height - r3);
  r3 !== 0 && ctx.arc(x2 + width - r3, y2 + height - r3, r3, 0, Math.PI / 2);
  ctx.lineTo(x2 + r4, y2 + height);
  r4 !== 0 && ctx.arc(x2 + r4, y2 + height - r4, r4, Math.PI / 2, Math.PI);
  ctx.lineTo(x2, y2 + r1);
  r1 !== 0 && ctx.arc(x2 + r1, y2 + r1, r1, Math.PI, Math.PI * 1.5);
}
var round$2 = Math.round;
function subPixelOptimizeLine$1(outputShape, inputShape, style) {
  if (!inputShape) {
    return;
  }
  var x1 = inputShape.x1;
  var x2 = inputShape.x2;
  var y1 = inputShape.y1;
  var y2 = inputShape.y2;
  outputShape.x1 = x1;
  outputShape.x2 = x2;
  outputShape.y1 = y1;
  outputShape.y2 = y2;
  var lineWidth = style && style.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  if (round$2(x1 * 2) === round$2(x2 * 2)) {
    outputShape.x1 = outputShape.x2 = subPixelOptimize$1(x1, lineWidth, true);
  }
  if (round$2(y1 * 2) === round$2(y2 * 2)) {
    outputShape.y1 = outputShape.y2 = subPixelOptimize$1(y1, lineWidth, true);
  }
  return outputShape;
}
function subPixelOptimizeRect$1(outputShape, inputShape, style) {
  if (!inputShape) {
    return;
  }
  var originX = inputShape.x;
  var originY = inputShape.y;
  var originWidth = inputShape.width;
  var originHeight = inputShape.height;
  outputShape.x = originX;
  outputShape.y = originY;
  outputShape.width = originWidth;
  outputShape.height = originHeight;
  var lineWidth = style && style.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  outputShape.x = subPixelOptimize$1(originX, lineWidth, true);
  outputShape.y = subPixelOptimize$1(originY, lineWidth, true);
  outputShape.width = Math.max(subPixelOptimize$1(originX + originWidth, lineWidth, false) - outputShape.x, originWidth === 0 ? 0 : 1);
  outputShape.height = Math.max(subPixelOptimize$1(originY + originHeight, lineWidth, false) - outputShape.y, originHeight === 0 ? 0 : 1);
  return outputShape;
}
function subPixelOptimize$1(position2, lineWidth, positiveOrNegative) {
  if (!lineWidth) {
    return position2;
  }
  var doubledPosition = round$2(position2 * 2);
  return (doubledPosition + round$2(lineWidth)) % 2 === 0 ? doubledPosition / 2 : (doubledPosition + (positiveOrNegative ? 1 : -1)) / 2;
}
var RectShape = function() {
  function RectShape2() {
    this.x = 0;
    this.y = 0;
    this.width = 0;
    this.height = 0;
  }
  return RectShape2;
}();
var subPixelOptimizeOutputShape$1 = {};
var Rect$2 = function(_super) {
  __extends(Rect2, _super);
  function Rect2(opts) {
    return _super.call(this, opts) || this;
  }
  Rect2.prototype.getDefaultShape = function() {
    return new RectShape();
  };
  Rect2.prototype.buildPath = function(ctx, shape) {
    var x2;
    var y2;
    var width;
    var height;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeRect$1(subPixelOptimizeOutputShape$1, shape, this.style);
      x2 = optimizedShape.x;
      y2 = optimizedShape.y;
      width = optimizedShape.width;
      height = optimizedShape.height;
      optimizedShape.r = shape.r;
      shape = optimizedShape;
    } else {
      x2 = shape.x;
      y2 = shape.y;
      width = shape.width;
      height = shape.height;
    }
    if (!shape.r) {
      ctx.rect(x2, y2, width, height);
    } else {
      buildPath$2(ctx, shape);
    }
  };
  Rect2.prototype.isZeroArea = function() {
    return !this.shape.width || !this.shape.height;
  };
  return Rect2;
}(Path$1);
Rect$2.prototype.type = "rect";
var Rect$3 = Rect$2;
var DEFAULT_RICH_TEXT_COLOR = {
  fill: "#000"
};
var DEFAULT_STROKE_LINE_WIDTH = 2;
var DEFAULT_TEXT_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineWidth: true,
    fontSize: true,
    lineHeight: true,
    width: true,
    height: true,
    textShadowColor: true,
    textShadowBlur: true,
    textShadowOffsetX: true,
    textShadowOffsetY: true,
    backgroundColor: true,
    padding: true,
    borderColor: true,
    borderWidth: true,
    borderRadius: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var ZRText = function(_super) {
  __extends(ZRText2, _super);
  function ZRText2(opts) {
    var _this = _super.call(this) || this;
    _this.type = "text";
    _this._children = [];
    _this._defaultStyle = DEFAULT_RICH_TEXT_COLOR;
    _this.attr(opts);
    return _this;
  }
  ZRText2.prototype.childrenRef = function() {
    return this._children;
  };
  ZRText2.prototype.update = function() {
    _super.prototype.update.call(this);
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.zlevel = this.zlevel;
      child.z = this.z;
      child.z2 = this.z2;
      child.culling = this.culling;
      child.cursor = this.cursor;
      child.invisible = this.invisible;
    }
  };
  ZRText2.prototype.updateTransform = function() {
    var innerTransformable = this.innerTransformable;
    if (innerTransformable) {
      innerTransformable.updateTransform();
      if (innerTransformable.transform) {
        this.transform = innerTransformable.transform;
      }
    } else {
      _super.prototype.updateTransform.call(this);
    }
  };
  ZRText2.prototype.getLocalTransform = function(m2) {
    var innerTransformable = this.innerTransformable;
    return innerTransformable ? innerTransformable.getLocalTransform(m2) : _super.prototype.getLocalTransform.call(this, m2);
  };
  ZRText2.prototype.getComputedTransform = function() {
    if (this.__hostTarget) {
      this.__hostTarget.getComputedTransform();
      this.__hostTarget.updateInnerText(true);
    }
    return _super.prototype.getComputedTransform.call(this);
  };
  ZRText2.prototype._updateSubTexts = function() {
    this._childCursor = 0;
    normalizeTextStyle(this.style);
    this.style.rich ? this._updateRichTexts() : this._updatePlainTexts();
    this._children.length = this._childCursor;
    this.styleUpdated();
  };
  ZRText2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = zr;
    }
  };
  ZRText2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = null;
    }
  };
  ZRText2.prototype.getBoundingRect = function() {
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    if (!this._rect) {
      var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
      var children = this._children;
      var tmpMat = [];
      var rect = null;
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        var childRect = child.getBoundingRect();
        var transform2 = child.getLocalTransform(tmpMat);
        if (transform2) {
          tmpRect2.copy(childRect);
          tmpRect2.applyTransform(transform2);
          rect = rect || tmpRect2.clone();
          rect.union(tmpRect2);
        } else {
          rect = rect || childRect.clone();
          rect.union(childRect);
        }
      }
      this._rect = rect || tmpRect2;
    }
    return this._rect;
  };
  ZRText2.prototype.setDefaultTextStyle = function(defaultTextStyle) {
    this._defaultStyle = defaultTextStyle || DEFAULT_RICH_TEXT_COLOR;
  };
  ZRText2.prototype.setTextContent = function(textContent) {
  };
  ZRText2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    if (!sourceStyle) {
      return targetStyle;
    }
    var sourceRich = sourceStyle.rich;
    var targetRich = targetStyle.rich || sourceRich && {};
    extend(targetStyle, sourceStyle);
    if (sourceRich && targetRich) {
      this._mergeRich(targetRich, sourceRich);
      targetStyle.rich = targetRich;
    } else if (targetRich) {
      targetStyle.rich = targetRich;
    }
    return targetStyle;
  };
  ZRText2.prototype._mergeRich = function(targetRich, sourceRich) {
    var richNames = keys(sourceRich);
    for (var i = 0; i < richNames.length; i++) {
      var richName = richNames[i];
      targetRich[richName] = targetRich[richName] || {};
      extend(targetRich[richName], sourceRich[richName]);
    }
  };
  ZRText2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_TEXT_ANIMATION_PROPS;
  };
  ZRText2.prototype._getOrCreateChild = function(Ctor) {
    var child = this._children[this._childCursor];
    if (!child || !(child instanceof Ctor)) {
      child = new Ctor();
    }
    this._children[this._childCursor++] = child;
    child.__zr = this.__zr;
    child.parent = this;
    return child;
  };
  ZRText2.prototype._updatePlainTexts = function() {
    var style = this.style;
    var textFont = style.font || DEFAULT_FONT;
    var textPadding = style.padding;
    var text = getStyleText(style);
    var contentBlock = parsePlainText(text, style);
    var needDrawBg = needDrawBackground(style);
    var bgColorDrawn = !!style.backgroundColor;
    var outerHeight = contentBlock.outerHeight;
    var outerWidth = contentBlock.outerWidth;
    var contentWidth = contentBlock.contentWidth;
    var textLines = contentBlock.lines;
    var lineHeight = contentBlock.lineHeight;
    var defaultStyle = this._defaultStyle;
    var baseX = style.x || 0;
    var baseY = style.y || 0;
    var textAlign = style.align || defaultStyle.align || "left";
    var verticalAlign = style.verticalAlign || defaultStyle.verticalAlign || "top";
    var textX = baseX;
    var textY = adjustTextY(baseY, contentBlock.contentHeight, verticalAlign);
    if (needDrawBg || textPadding) {
      var boxX = adjustTextX(baseX, outerWidth, textAlign);
      var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
      needDrawBg && this._renderBackground(style, style, boxX, boxY, outerWidth, outerHeight);
    }
    textY += lineHeight / 2;
    if (textPadding) {
      textX = getTextXForPadding(baseX, textAlign, textPadding);
      if (verticalAlign === "top") {
        textY += textPadding[0];
      } else if (verticalAlign === "bottom") {
        textY -= textPadding[2];
      }
    }
    var defaultLineWidth = 0;
    var useDefaultFill = false;
    var textFill = getFill("fill" in style ? style.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in style ? style.stroke : !bgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = style.textShadowBlur > 0;
    var fixedBoundingRect = style.width != null && (style.overflow === "truncate" || style.overflow === "break" || style.overflow === "breakAll");
    var calculatedLineHeight = contentBlock.calculatedLineHeight;
    for (var i = 0; i < textLines.length; i++) {
      var el = this._getOrCreateChild(TSpan$1);
      var subElStyle = el.createStyle();
      el.useStyle(subElStyle);
      subElStyle.text = textLines[i];
      subElStyle.x = textX;
      subElStyle.y = textY;
      if (textAlign) {
        subElStyle.textAlign = textAlign;
      }
      subElStyle.textBaseline = "middle";
      subElStyle.opacity = style.opacity;
      subElStyle.strokeFirst = true;
      if (hasShadow2) {
        subElStyle.shadowBlur = style.textShadowBlur || 0;
        subElStyle.shadowColor = style.textShadowColor || "transparent";
        subElStyle.shadowOffsetX = style.textShadowOffsetX || 0;
        subElStyle.shadowOffsetY = style.textShadowOffsetY || 0;
      }
      subElStyle.stroke = textStroke;
      subElStyle.fill = textFill;
      if (textStroke) {
        subElStyle.lineWidth = style.lineWidth || defaultLineWidth;
        subElStyle.lineDash = style.lineDash;
        subElStyle.lineDashOffset = style.lineDashOffset || 0;
      }
      subElStyle.font = textFont;
      setSeparateFont(subElStyle, style);
      textY += lineHeight;
      if (fixedBoundingRect) {
        el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, style.width, subElStyle.textAlign), adjustTextY(subElStyle.y, calculatedLineHeight, subElStyle.textBaseline), contentWidth, calculatedLineHeight));
      }
    }
  };
  ZRText2.prototype._updateRichTexts = function() {
    var style = this.style;
    var text = getStyleText(style);
    var contentBlock = parseRichText(text, style);
    var contentWidth = contentBlock.width;
    var outerWidth = contentBlock.outerWidth;
    var outerHeight = contentBlock.outerHeight;
    var textPadding = style.padding;
    var baseX = style.x || 0;
    var baseY = style.y || 0;
    var defaultStyle = this._defaultStyle;
    var textAlign = style.align || defaultStyle.align;
    var verticalAlign = style.verticalAlign || defaultStyle.verticalAlign;
    var boxX = adjustTextX(baseX, outerWidth, textAlign);
    var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
    var xLeft = boxX;
    var lineTop = boxY;
    if (textPadding) {
      xLeft += textPadding[3];
      lineTop += textPadding[0];
    }
    var xRight = xLeft + contentWidth;
    if (needDrawBackground(style)) {
      this._renderBackground(style, style, boxX, boxY, outerWidth, outerHeight);
    }
    var bgColorDrawn = !!style.backgroundColor;
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var tokens = line.tokens;
      var tokenCount = tokens.length;
      var lineHeight = line.lineHeight;
      var remainedWidth = line.width;
      var leftIndex = 0;
      var lineXLeft = xLeft;
      var lineXRight = xRight;
      var rightIndex = tokenCount - 1;
      var token = void 0;
      while (leftIndex < tokenCount && (token = tokens[leftIndex], !token.align || token.align === "left")) {
        this._placeToken(token, style, lineHeight, lineTop, lineXLeft, "left", bgColorDrawn);
        remainedWidth -= token.width;
        lineXLeft += token.width;
        leftIndex++;
      }
      while (rightIndex >= 0 && (token = tokens[rightIndex], token.align === "right")) {
        this._placeToken(token, style, lineHeight, lineTop, lineXRight, "right", bgColorDrawn);
        remainedWidth -= token.width;
        lineXRight -= token.width;
        rightIndex--;
      }
      lineXLeft += (contentWidth - (lineXLeft - xLeft) - (xRight - lineXRight) - remainedWidth) / 2;
      while (leftIndex <= rightIndex) {
        token = tokens[leftIndex];
        this._placeToken(token, style, lineHeight, lineTop, lineXLeft + token.width / 2, "center", bgColorDrawn);
        lineXLeft += token.width;
        leftIndex++;
      }
      lineTop += lineHeight;
    }
  };
  ZRText2.prototype._placeToken = function(token, style, lineHeight, lineTop, x2, textAlign, parentBgColorDrawn) {
    var tokenStyle = style.rich[token.styleName] || {};
    tokenStyle.text = token.text;
    var verticalAlign = token.verticalAlign;
    var y2 = lineTop + lineHeight / 2;
    if (verticalAlign === "top") {
      y2 = lineTop + token.height / 2;
    } else if (verticalAlign === "bottom") {
      y2 = lineTop + lineHeight - token.height / 2;
    }
    var needDrawBg = !token.isLineHolder && needDrawBackground(tokenStyle);
    needDrawBg && this._renderBackground(tokenStyle, style, textAlign === "right" ? x2 - token.width : textAlign === "center" ? x2 - token.width / 2 : x2, y2 - token.height / 2, token.width, token.height);
    var bgColorDrawn = !!tokenStyle.backgroundColor;
    var textPadding = token.textPadding;
    if (textPadding) {
      x2 = getTextXForPadding(x2, textAlign, textPadding);
      y2 -= token.height / 2 - textPadding[0] - token.innerHeight / 2;
    }
    var el = this._getOrCreateChild(TSpan$1);
    var subElStyle = el.createStyle();
    el.useStyle(subElStyle);
    var defaultStyle = this._defaultStyle;
    var useDefaultFill = false;
    var defaultLineWidth = 0;
    var textFill = getFill("fill" in tokenStyle ? tokenStyle.fill : "fill" in style ? style.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in tokenStyle ? tokenStyle.stroke : "stroke" in style ? style.stroke : !bgColorDrawn && !parentBgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = tokenStyle.textShadowBlur > 0 || style.textShadowBlur > 0;
    subElStyle.text = token.text;
    subElStyle.x = x2;
    subElStyle.y = y2;
    if (hasShadow2) {
      subElStyle.shadowBlur = tokenStyle.textShadowBlur || style.textShadowBlur || 0;
      subElStyle.shadowColor = tokenStyle.textShadowColor || style.textShadowColor || "transparent";
      subElStyle.shadowOffsetX = tokenStyle.textShadowOffsetX || style.textShadowOffsetX || 0;
      subElStyle.shadowOffsetY = tokenStyle.textShadowOffsetY || style.textShadowOffsetY || 0;
    }
    subElStyle.textAlign = textAlign;
    subElStyle.textBaseline = "middle";
    subElStyle.font = token.font || DEFAULT_FONT;
    subElStyle.opacity = retrieve3(tokenStyle.opacity, style.opacity, 1);
    setSeparateFont(subElStyle, tokenStyle);
    if (textStroke) {
      subElStyle.lineWidth = retrieve3(tokenStyle.lineWidth, style.lineWidth, defaultLineWidth);
      subElStyle.lineDash = retrieve2(tokenStyle.lineDash, style.lineDash);
      subElStyle.lineDashOffset = style.lineDashOffset || 0;
      subElStyle.stroke = textStroke;
    }
    if (textFill) {
      subElStyle.fill = textFill;
    }
    var textWidth = token.contentWidth;
    var textHeight = token.contentHeight;
    el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, textWidth, subElStyle.textAlign), adjustTextY(subElStyle.y, textHeight, subElStyle.textBaseline), textWidth, textHeight));
  };
  ZRText2.prototype._renderBackground = function(style, topStyle, x2, y2, width, height) {
    var textBackgroundColor = style.backgroundColor;
    var textBorderWidth = style.borderWidth;
    var textBorderColor = style.borderColor;
    var isImageBg = textBackgroundColor && textBackgroundColor.image;
    var isPlainOrGradientBg = textBackgroundColor && !isImageBg;
    var textBorderRadius = style.borderRadius;
    var self2 = this;
    var rectEl;
    var imgEl;
    if (isPlainOrGradientBg || style.lineHeight || textBorderWidth && textBorderColor) {
      rectEl = this._getOrCreateChild(Rect$3);
      rectEl.useStyle(rectEl.createStyle());
      rectEl.style.fill = null;
      var rectShape = rectEl.shape;
      rectShape.x = x2;
      rectShape.y = y2;
      rectShape.width = width;
      rectShape.height = height;
      rectShape.r = textBorderRadius;
      rectEl.dirtyShape();
    }
    if (isPlainOrGradientBg) {
      var rectStyle = rectEl.style;
      rectStyle.fill = textBackgroundColor || null;
      rectStyle.fillOpacity = retrieve2(style.fillOpacity, 1);
    } else if (isImageBg) {
      imgEl = this._getOrCreateChild(ZRImage$1);
      imgEl.onload = function() {
        self2.dirtyStyle();
      };
      var imgStyle = imgEl.style;
      imgStyle.image = textBackgroundColor.image;
      imgStyle.x = x2;
      imgStyle.y = y2;
      imgStyle.width = width;
      imgStyle.height = height;
    }
    if (textBorderWidth && textBorderColor) {
      var rectStyle = rectEl.style;
      rectStyle.lineWidth = textBorderWidth;
      rectStyle.stroke = textBorderColor;
      rectStyle.strokeOpacity = retrieve2(style.strokeOpacity, 1);
      rectStyle.lineDash = style.borderDash;
      rectStyle.lineDashOffset = style.borderDashOffset || 0;
      rectEl.strokeContainThreshold = 0;
      if (rectEl.hasFill() && rectEl.hasStroke()) {
        rectStyle.strokeFirst = true;
        rectStyle.lineWidth *= 2;
      }
    }
    var commonStyle = (rectEl || imgEl).style;
    commonStyle.shadowBlur = style.shadowBlur || 0;
    commonStyle.shadowColor = style.shadowColor || "transparent";
    commonStyle.shadowOffsetX = style.shadowOffsetX || 0;
    commonStyle.shadowOffsetY = style.shadowOffsetY || 0;
    commonStyle.opacity = retrieve3(style.opacity, topStyle.opacity, 1);
  };
  ZRText2.makeFont = function(style) {
    var font = "";
    if (hasSeparateFont(style)) {
      font = [
        style.fontStyle,
        style.fontWeight,
        parseFontSize(style.fontSize),
        style.fontFamily || "sans-serif"
      ].join(" ");
    }
    return font && trim$1(font) || style.textFont || style.font;
  };
  return ZRText2;
}(Displayable$1);
var VALID_TEXT_ALIGN = { left: true, right: 1, center: 1 };
var VALID_TEXT_VERTICAL_ALIGN = { top: 1, bottom: 1, middle: 1 };
var FONT_PARTS = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
function parseFontSize(fontSize) {
  if (typeof fontSize === "string" && (fontSize.indexOf("px") !== -1 || fontSize.indexOf("rem") !== -1 || fontSize.indexOf("em") !== -1)) {
    return fontSize;
  } else if (!isNaN(+fontSize)) {
    return fontSize + "px";
  } else {
    return DEFAULT_FONT_SIZE + "px";
  }
}
function setSeparateFont(targetStyle, sourceStyle) {
  for (var i = 0; i < FONT_PARTS.length; i++) {
    var fontProp = FONT_PARTS[i];
    var val = sourceStyle[fontProp];
    if (val != null) {
      targetStyle[fontProp] = val;
    }
  }
}
function hasSeparateFont(style) {
  return style.fontSize != null || style.fontFamily || style.fontWeight;
}
function normalizeTextStyle(style) {
  normalizeStyle(style);
  each$f(style.rich, normalizeStyle);
  return style;
}
function normalizeStyle(style) {
  if (style) {
    style.font = ZRText.makeFont(style);
    var textAlign = style.align;
    textAlign === "middle" && (textAlign = "center");
    style.align = textAlign == null || VALID_TEXT_ALIGN[textAlign] ? textAlign : "left";
    var verticalAlign = style.verticalAlign;
    verticalAlign === "center" && (verticalAlign = "middle");
    style.verticalAlign = verticalAlign == null || VALID_TEXT_VERTICAL_ALIGN[verticalAlign] ? verticalAlign : "top";
    var textPadding = style.padding;
    if (textPadding) {
      style.padding = normalizeCssArray$1(style.padding);
    }
  }
}
function getStroke(stroke, lineWidth) {
  return stroke == null || lineWidth <= 0 || stroke === "transparent" || stroke === "none" ? null : stroke.image || stroke.colorStops ? "#000" : stroke;
}
function getFill(fill) {
  return fill == null || fill === "none" ? null : fill.image || fill.colorStops ? "#000" : fill;
}
function getTextXForPadding(x2, textAlign, textPadding) {
  return textAlign === "right" ? x2 - textPadding[1] : textAlign === "center" ? x2 + textPadding[3] / 2 - textPadding[1] / 2 : x2 + textPadding[3];
}
function getStyleText(style) {
  var text = style.text;
  text != null && (text += "");
  return text;
}
function needDrawBackground(style) {
  return !!(style.backgroundColor || style.lineHeight || style.borderWidth && style.borderColor);
}
var ZRText$1 = ZRText;
var getECData = makeInner();
var setCommonECData = function(seriesIndex, dataType, dataIdx, el) {
  if (el) {
    var ecData = getECData(el);
    ecData.dataIndex = dataIdx;
    ecData.dataType = dataType;
    ecData.seriesIndex = seriesIndex;
    if (el.type === "group") {
      el.traverse(function(child) {
        var childECData = getECData(child);
        childECData.seriesIndex = seriesIndex;
        childECData.dataIndex = dataIdx;
        childECData.dataType = dataType;
      });
    }
  }
};
var _highlightNextDigit = 1;
var _highlightKeyMap = {};
var getSavedStates = makeInner();
var getComponentStates = makeInner();
var HOVER_STATE_NORMAL = 0;
var HOVER_STATE_BLUR = 1;
var HOVER_STATE_EMPHASIS = 2;
var SPECIAL_STATES = ["emphasis", "blur", "select"];
var DISPLAY_STATES = ["normal", "emphasis", "blur", "select"];
var Z2_EMPHASIS_LIFT = 10;
var Z2_SELECT_LIFT = 9;
var HIGHLIGHT_ACTION_TYPE = "highlight";
var DOWNPLAY_ACTION_TYPE = "downplay";
var SELECT_ACTION_TYPE = "select";
var UNSELECT_ACTION_TYPE = "unselect";
var TOGGLE_SELECT_ACTION_TYPE = "toggleSelect";
function hasFillOrStroke(fillOrStroke) {
  return fillOrStroke != null && fillOrStroke !== "none";
}
var liftedColorCache = new LRU$1(100);
function liftColor(color) {
  if (isString(color)) {
    var liftedColor = liftedColorCache.get(color);
    if (!liftedColor) {
      liftedColor = lift(color, -0.1);
      liftedColorCache.put(color, liftedColor);
    }
    return liftedColor;
  } else if (isGradientObject(color)) {
    var ret = extend({}, color);
    ret.colorStops = map$1(color.colorStops, function(stop2) {
      return {
        offset: stop2.offset,
        color: lift(stop2.color, -0.1)
      };
    });
    return ret;
  }
  return color;
}
function doChangeHoverState(el, stateName, hoverStateEnum) {
  if (el.onHoverStateChange && (el.hoverState || 0) !== hoverStateEnum) {
    el.onHoverStateChange(stateName);
  }
  el.hoverState = hoverStateEnum;
}
function singleEnterEmphasis(el) {
  doChangeHoverState(el, "emphasis", HOVER_STATE_EMPHASIS);
}
function singleLeaveEmphasis(el) {
  if (el.hoverState === HOVER_STATE_EMPHASIS) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterBlur(el) {
  doChangeHoverState(el, "blur", HOVER_STATE_BLUR);
}
function singleLeaveBlur(el) {
  if (el.hoverState === HOVER_STATE_BLUR) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterSelect(el) {
  el.selected = true;
}
function singleLeaveSelect(el) {
  el.selected = false;
}
function updateElementState(el, updater, commonParam) {
  updater(el, commonParam);
}
function traverseUpdateState(el, updater, commonParam) {
  updateElementState(el, updater, commonParam);
  el.isGroup && el.traverse(function(child) {
    updateElementState(child, updater, commonParam);
  });
}
function setStatesFlag(el, stateName) {
  switch (stateName) {
    case "emphasis":
      el.hoverState = HOVER_STATE_EMPHASIS;
      break;
    case "normal":
      el.hoverState = HOVER_STATE_NORMAL;
      break;
    case "blur":
      el.hoverState = HOVER_STATE_BLUR;
      break;
    case "select":
      el.selected = true;
  }
}
function getFromStateStyle(el, props, toStateName, defaultValue) {
  var style = el.style;
  var fromState = {};
  for (var i = 0; i < props.length; i++) {
    var propName = props[i];
    var val = style[propName];
    fromState[propName] = val == null ? defaultValue && defaultValue[propName] : val;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.__fromStateTransition && animator.__fromStateTransition.indexOf(toStateName) < 0 && animator.targetName === "style") {
      animator.saveTo(fromState, props);
    }
  }
  return fromState;
}
function createEmphasisDefaultState(el, stateName, targetStates, state) {
  var hasSelect = targetStates && indexOf(targetStates, "select") >= 0;
  var cloned = false;
  if (el instanceof Path$1) {
    var store = getSavedStates(el);
    var fromFill = hasSelect ? store.selectFill || store.normalFill : store.normalFill;
    var fromStroke = hasSelect ? store.selectStroke || store.normalStroke : store.normalStroke;
    if (hasFillOrStroke(fromFill) || hasFillOrStroke(fromStroke)) {
      state = state || {};
      var emphasisStyle = state.style || {};
      if (emphasisStyle.fill === "inherit") {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = fromFill;
      } else if (!hasFillOrStroke(emphasisStyle.fill) && hasFillOrStroke(fromFill)) {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = liftColor(fromFill);
      } else if (!hasFillOrStroke(emphasisStyle.stroke) && hasFillOrStroke(fromStroke)) {
        if (!cloned) {
          state = extend({}, state);
          emphasisStyle = extend({}, emphasisStyle);
        }
        emphasisStyle.stroke = liftColor(fromStroke);
      }
      state.style = emphasisStyle;
    }
  }
  if (state) {
    if (state.z2 == null) {
      if (!cloned) {
        state = extend({}, state);
      }
      var z2EmphasisLift = el.z2EmphasisLift;
      state.z2 = el.z2 + (z2EmphasisLift != null ? z2EmphasisLift : Z2_EMPHASIS_LIFT);
    }
  }
  return state;
}
function createSelectDefaultState(el, stateName, state) {
  if (state) {
    if (state.z2 == null) {
      state = extend({}, state);
      var z2SelectLift = el.z2SelectLift;
      state.z2 = el.z2 + (z2SelectLift != null ? z2SelectLift : Z2_SELECT_LIFT);
    }
  }
  return state;
}
function createBlurDefaultState(el, stateName, state) {
  var hasBlur = indexOf(el.currentStates, stateName) >= 0;
  var currentOpacity = el.style.opacity;
  var fromState = !hasBlur ? getFromStateStyle(el, ["opacity"], stateName, {
    opacity: 1
  }) : null;
  state = state || {};
  var blurStyle = state.style || {};
  if (blurStyle.opacity == null) {
    state = extend({}, state);
    blurStyle = extend({
      opacity: hasBlur ? currentOpacity : fromState.opacity * 0.1
    }, blurStyle);
    state.style = blurStyle;
  }
  return state;
}
function elementStateProxy(stateName, targetStates) {
  var state = this.states[stateName];
  if (this.style) {
    if (stateName === "emphasis") {
      return createEmphasisDefaultState(this, stateName, targetStates, state);
    } else if (stateName === "blur") {
      return createBlurDefaultState(this, stateName, state);
    } else if (stateName === "select") {
      return createSelectDefaultState(this, stateName, state);
    }
  }
  return state;
}
function setDefaultStateProxy(el) {
  el.stateProxy = elementStateProxy;
  var textContent = el.getTextContent();
  var textGuide = el.getTextGuideLine();
  if (textContent) {
    textContent.stateProxy = elementStateProxy;
  }
  if (textGuide) {
    textGuide.stateProxy = elementStateProxy;
  }
}
function enterEmphasisWhenMouseOver(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasisWhenMouseOut(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterEmphasis(el, highlightDigit) {
  el.__highByOuter |= 1 << (highlightDigit || 0);
  traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasis(el, highlightDigit) {
  !(el.__highByOuter &= ~(1 << (highlightDigit || 0))) && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterBlur(el) {
  traverseUpdateState(el, singleEnterBlur);
}
function leaveBlur(el) {
  traverseUpdateState(el, singleLeaveBlur);
}
function enterSelect(el) {
  traverseUpdateState(el, singleEnterSelect);
}
function leaveSelect(el) {
  traverseUpdateState(el, singleLeaveSelect);
}
function shouldSilent(el, e2) {
  return el.__highDownSilentOnTouch && e2.zrByTouch;
}
function allLeaveBlur(api) {
  var model = api.getModel();
  model.eachComponent(function(componentType, componentModel) {
    var componentStates = getComponentStates(componentModel);
    if (componentStates.isBlured) {
      var view = componentType === "series" ? api.getViewOfSeriesModel(componentModel) : api.getViewOfComponentModel(componentModel);
      view.group.traverse(function(child) {
        singleLeaveBlur(child);
      });
    }
    componentStates.isBlured = false;
  });
}
function blurSeries(targetSeriesIndex, focus, blurScope, api) {
  var ecModel = api.getModel();
  blurScope = blurScope || "coordinateSystem";
  function leaveBlurOfIndices(data, dataIndices) {
    for (var i = 0; i < dataIndices.length; i++) {
      var itemEl = data.getItemGraphicEl(dataIndices[i]);
      itemEl && leaveBlur(itemEl);
    }
  }
  if (targetSeriesIndex == null) {
    return;
  }
  if (!focus || focus === "none") {
    return;
  }
  var targetSeriesModel = ecModel.getSeriesByIndex(targetSeriesIndex);
  var targetCoordSys = targetSeriesModel.coordinateSystem;
  if (targetCoordSys && targetCoordSys.master) {
    targetCoordSys = targetCoordSys.master;
  }
  var blurredSeries = [];
  ecModel.eachSeries(function(seriesModel) {
    var sameSeries = targetSeriesModel === seriesModel;
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.master) {
      coordSys = coordSys.master;
    }
    var sameCoordSys = coordSys && targetCoordSys ? coordSys === targetCoordSys : sameSeries;
    if (!(blurScope === "series" && !sameSeries || blurScope === "coordinateSystem" && !sameCoordSys || focus === "series" && sameSeries)) {
      var view = api.getViewOfSeriesModel(seriesModel);
      view.group.traverse(function(child) {
        singleEnterBlur(child);
      });
      if (isArrayLike(focus)) {
        leaveBlurOfIndices(seriesModel.getData(), focus);
      } else if (isObject$4(focus)) {
        var dataTypes = keys(focus);
        for (var d2 = 0; d2 < dataTypes.length; d2++) {
          leaveBlurOfIndices(seriesModel.getData(dataTypes[d2]), focus[dataTypes[d2]]);
        }
      }
      blurredSeries.push(seriesModel);
      getComponentStates(seriesModel).isBlured = true;
    }
  });
  ecModel.eachComponent(function(componentType, componentModel) {
    if (componentType === "series") {
      return;
    }
    var view = api.getViewOfComponentModel(componentModel);
    if (view && view.blurSeries) {
      view.blurSeries(blurredSeries, ecModel);
    }
  });
}
function blurComponent(componentMainType, componentIndex, api) {
  if (componentMainType == null || componentIndex == null) {
    return;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return;
  }
  getComponentStates(componentModel).isBlured = true;
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.focusBlurEnabled) {
    return;
  }
  view.group.traverse(function(child) {
    singleEnterBlur(child);
  });
}
function blurSeriesFromHighlightPayload(seriesModel, payload, api) {
  var seriesIndex = seriesModel.seriesIndex;
  var data = seriesModel.getData(payload.dataType);
  if (!data) {
    return;
  }
  var dataIndex = queryDataIndex(data, payload);
  dataIndex = (isArray$1(dataIndex) ? dataIndex[0] : dataIndex) || 0;
  var el = data.getItemGraphicEl(dataIndex);
  if (!el) {
    var count2 = data.count();
    var current = 0;
    while (!el && current < count2) {
      el = data.getItemGraphicEl(current++);
    }
  }
  if (el) {
    var ecData = getECData(el);
    blurSeries(seriesIndex, ecData.focus, ecData.blurScope, api);
  } else {
    var focus_1 = seriesModel.get(["emphasis", "focus"]);
    var blurScope = seriesModel.get(["emphasis", "blurScope"]);
    if (focus_1 != null) {
      blurSeries(seriesIndex, focus_1, blurScope, api);
    }
  }
}
function findComponentHighDownDispatchers(componentMainType, componentIndex, name, api) {
  var ret = {
    focusSelf: false,
    dispatchers: null
  };
  if (componentMainType == null || componentMainType === "series" || componentIndex == null || name == null) {
    return ret;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return ret;
  }
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.findHighDownDispatchers) {
    return ret;
  }
  var dispatchers = view.findHighDownDispatchers(name);
  var focusSelf;
  for (var i = 0; i < dispatchers.length; i++) {
    if (getECData(dispatchers[i]).focus === "self") {
      focusSelf = true;
      break;
    }
  }
  return {
    focusSelf,
    dispatchers
  };
}
function handleGlobalMouseOverForHighDown(dispatcher, e2, api) {
  var ecData = getECData(dispatcher);
  var _a2 = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api), dispatchers = _a2.dispatchers, focusSelf = _a2.focusSelf;
  if (dispatchers) {
    if (focusSelf) {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    each$f(dispatchers, function(dispatcher2) {
      return enterEmphasisWhenMouseOver(dispatcher2, e2);
    });
  } else {
    blurSeries(ecData.seriesIndex, ecData.focus, ecData.blurScope, api);
    if (ecData.focus === "self") {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    enterEmphasisWhenMouseOver(dispatcher, e2);
  }
}
function handleGlobalMouseOutForHighDown(dispatcher, e2, api) {
  allLeaveBlur(api);
  var ecData = getECData(dispatcher);
  var dispatchers = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api).dispatchers;
  if (dispatchers) {
    each$f(dispatchers, function(dispatcher2) {
      return leaveEmphasisWhenMouseOut(dispatcher2, e2);
    });
  } else {
    leaveEmphasisWhenMouseOut(dispatcher, e2);
  }
}
function toggleSelectionFromPayload(seriesModel, payload, api) {
  if (!isSelectChangePayload(payload)) {
    return;
  }
  var dataType = payload.dataType;
  var data = seriesModel.getData(dataType);
  var dataIndex = queryDataIndex(data, payload);
  if (!isArray$1(dataIndex)) {
    dataIndex = [dataIndex];
  }
  seriesModel[payload.type === TOGGLE_SELECT_ACTION_TYPE ? "toggleSelect" : payload.type === SELECT_ACTION_TYPE ? "select" : "unselect"](dataIndex, dataType);
}
function updateSeriesElementSelection(seriesModel) {
  var allData = seriesModel.getAllData();
  each$f(allData, function(_a2) {
    var data = _a2.data, type4 = _a2.type;
    data.eachItemGraphicEl(function(el, idx) {
      seriesModel.isSelected(idx, type4) ? enterSelect(el) : leaveSelect(el);
    });
  });
}
function getAllSelectedIndices(ecModel) {
  var ret = [];
  ecModel.eachSeries(function(seriesModel) {
    var allData = seriesModel.getAllData();
    each$f(allData, function(_a2) {
      _a2.data;
      var type4 = _a2.type;
      var dataIndices = seriesModel.getSelectedDataIndices();
      if (dataIndices.length > 0) {
        var item = {
          dataIndex: dataIndices,
          seriesIndex: seriesModel.seriesIndex
        };
        if (type4 != null) {
          item.dataType = type4;
        }
        ret.push(item);
      }
    });
  });
  return ret;
}
function enableHoverEmphasis(el, focus, blurScope) {
  setAsHighDownDispatcher(el, true);
  traverseUpdateState(el, setDefaultStateProxy);
  enableHoverFocus(el, focus, blurScope);
}
function disableHoverEmphasis(el) {
  setAsHighDownDispatcher(el, false);
}
function toggleHoverEmphasis(el, focus, blurScope, isDisabled) {
  isDisabled ? disableHoverEmphasis(el) : enableHoverEmphasis(el, focus, blurScope);
}
function enableHoverFocus(el, focus, blurScope) {
  var ecData = getECData(el);
  if (focus != null) {
    ecData.focus = focus;
    ecData.blurScope = blurScope;
  } else if (ecData.focus) {
    ecData.focus = null;
  }
}
var OTHER_STATES = ["emphasis", "blur", "select"];
var defaultStyleGetterMap = {
  itemStyle: "getItemStyle",
  lineStyle: "getLineStyle",
  areaStyle: "getAreaStyle"
};
function setStatesStylesFromModel(el, itemModel, styleType, getter) {
  styleType = styleType || "itemStyle";
  for (var i = 0; i < OTHER_STATES.length; i++) {
    var stateName = OTHER_STATES[i];
    var model = itemModel.getModel([stateName, styleType]);
    var state = el.ensureState(stateName);
    state.style = getter ? getter(model) : model[defaultStyleGetterMap[styleType]]();
  }
}
function setAsHighDownDispatcher(el, asDispatcher) {
  var disable = asDispatcher === false;
  var extendedEl = el;
  if (el.highDownSilentOnTouch) {
    extendedEl.__highDownSilentOnTouch = el.highDownSilentOnTouch;
  }
  if (!disable || extendedEl.__highDownDispatcher) {
    extendedEl.__highByOuter = extendedEl.__highByOuter || 0;
    extendedEl.__highDownDispatcher = !disable;
  }
}
function isHighDownDispatcher(el) {
  return !!(el && el.__highDownDispatcher);
}
function enableComponentHighDownFeatures(el, componentModel, componentHighDownName) {
  var ecData = getECData(el);
  ecData.componentMainType = componentModel.mainType;
  ecData.componentIndex = componentModel.componentIndex;
  ecData.componentHighDownName = componentHighDownName;
}
function getHighlightDigit(highlightKey) {
  var highlightDigit = _highlightKeyMap[highlightKey];
  if (highlightDigit == null && _highlightNextDigit <= 32) {
    highlightDigit = _highlightKeyMap[highlightKey] = _highlightNextDigit++;
  }
  return highlightDigit;
}
function isSelectChangePayload(payload) {
  var payloadType = payload.type;
  return payloadType === SELECT_ACTION_TYPE || payloadType === UNSELECT_ACTION_TYPE || payloadType === TOGGLE_SELECT_ACTION_TYPE;
}
function isHighDownPayload(payload) {
  var payloadType = payload.type;
  return payloadType === HIGHLIGHT_ACTION_TYPE || payloadType === DOWNPLAY_ACTION_TYPE;
}
function savePathStates(el) {
  var store = getSavedStates(el);
  store.normalFill = el.style.fill;
  store.normalStroke = el.style.stroke;
  var selectState = el.states.select || {};
  store.selectFill = selectState.style && selectState.style.fill || null;
  store.selectStroke = selectState.style && selectState.style.stroke || null;
}
var CMD$2 = PathProxy$1.CMD;
var points$2 = [[], [], []];
var mathSqrt$2 = Math.sqrt;
var mathAtan2 = Math.atan2;
function transformPath(path, m2) {
  if (!m2) {
    return;
  }
  var data = path.data;
  var len2 = path.len();
  var cmd;
  var nPoint;
  var i;
  var j;
  var k2;
  var p2;
  var M = CMD$2.M;
  var C = CMD$2.C;
  var L = CMD$2.L;
  var R = CMD$2.R;
  var A2 = CMD$2.A;
  var Q = CMD$2.Q;
  for (i = 0, j = 0; i < len2; ) {
    cmd = data[i++];
    j = i;
    nPoint = 0;
    switch (cmd) {
      case M:
        nPoint = 1;
        break;
      case L:
        nPoint = 1;
        break;
      case C:
        nPoint = 3;
        break;
      case Q:
        nPoint = 2;
        break;
      case A2:
        var x2 = m2[4];
        var y2 = m2[5];
        var sx = mathSqrt$2(m2[0] * m2[0] + m2[1] * m2[1]);
        var sy = mathSqrt$2(m2[2] * m2[2] + m2[3] * m2[3]);
        var angle = mathAtan2(-m2[1] / sy, m2[0] / sx);
        data[i] *= sx;
        data[i++] += x2;
        data[i] *= sy;
        data[i++] += y2;
        data[i++] *= sx;
        data[i++] *= sy;
        data[i++] += angle;
        data[i++] += angle;
        i += 2;
        j = i;
        break;
      case R:
        p2[0] = data[i++];
        p2[1] = data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
        p2[0] += data[i++];
        p2[1] += data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
    }
    for (k2 = 0; k2 < nPoint; k2++) {
      var p_1 = points$2[k2];
      p_1[0] = data[i++];
      p_1[1] = data[i++];
      applyTransform$1(p_1, p_1, m2);
      data[j++] = p_1[0];
      data[j++] = p_1[1];
    }
  }
  path.increaseVersion();
}
var mathSqrt$1 = Math.sqrt;
var mathSin$2 = Math.sin;
var mathCos$2 = Math.cos;
var PI$7 = Math.PI;
function vMag(v4) {
  return Math.sqrt(v4[0] * v4[0] + v4[1] * v4[1]);
}
function vRatio(u, v4) {
  return (u[0] * v4[0] + u[1] * v4[1]) / (vMag(u) * vMag(v4));
}
function vAngle(u, v4) {
  return (u[0] * v4[1] < u[1] * v4[0] ? -1 : 1) * Math.acos(vRatio(u, v4));
}
function processArc(x1, y1, x2, y2, fa, fs, rx, ry, psiDeg, cmd, path) {
  var psi = psiDeg * (PI$7 / 180);
  var xp = mathCos$2(psi) * (x1 - x2) / 2 + mathSin$2(psi) * (y1 - y2) / 2;
  var yp = -1 * mathSin$2(psi) * (x1 - x2) / 2 + mathCos$2(psi) * (y1 - y2) / 2;
  var lambda = xp * xp / (rx * rx) + yp * yp / (ry * ry);
  if (lambda > 1) {
    rx *= mathSqrt$1(lambda);
    ry *= mathSqrt$1(lambda);
  }
  var f2 = (fa === fs ? -1 : 1) * mathSqrt$1((rx * rx * (ry * ry) - rx * rx * (yp * yp) - ry * ry * (xp * xp)) / (rx * rx * (yp * yp) + ry * ry * (xp * xp))) || 0;
  var cxp = f2 * rx * yp / ry;
  var cyp = f2 * -ry * xp / rx;
  var cx = (x1 + x2) / 2 + mathCos$2(psi) * cxp - mathSin$2(psi) * cyp;
  var cy = (y1 + y2) / 2 + mathSin$2(psi) * cxp + mathCos$2(psi) * cyp;
  var theta = vAngle([1, 0], [(xp - cxp) / rx, (yp - cyp) / ry]);
  var u = [(xp - cxp) / rx, (yp - cyp) / ry];
  var v4 = [(-1 * xp - cxp) / rx, (-1 * yp - cyp) / ry];
  var dTheta = vAngle(u, v4);
  if (vRatio(u, v4) <= -1) {
    dTheta = PI$7;
  }
  if (vRatio(u, v4) >= 1) {
    dTheta = 0;
  }
  if (dTheta < 0) {
    var n2 = Math.round(dTheta / PI$7 * 1e6) / 1e6;
    dTheta = PI$7 * 2 + n2 % 2 * PI$7;
  }
  path.addData(cmd, cx, cy, rx, ry, theta, dTheta, psi, fs);
}
var commandReg = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig;
var numberReg$1 = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function createPathProxyFromString(data) {
  var path = new PathProxy$1();
  if (!data) {
    return path;
  }
  var cpx = 0;
  var cpy = 0;
  var subpathX = cpx;
  var subpathY = cpy;
  var prevCmd;
  var CMD2 = PathProxy$1.CMD;
  var cmdList = data.match(commandReg);
  if (!cmdList) {
    return path;
  }
  for (var l2 = 0; l2 < cmdList.length; l2++) {
    var cmdText = cmdList[l2];
    var cmdStr = cmdText.charAt(0);
    var cmd = void 0;
    var p2 = cmdText.match(numberReg$1) || [];
    var pLen = p2.length;
    for (var i = 0; i < pLen; i++) {
      p2[i] = parseFloat(p2[i]);
    }
    var off = 0;
    while (off < pLen) {
      var ctlPtx = void 0;
      var ctlPty = void 0;
      var rx = void 0;
      var ry = void 0;
      var psi = void 0;
      var fa = void 0;
      var fs = void 0;
      var x1 = cpx;
      var y1 = cpy;
      var len2 = void 0;
      var pathData = void 0;
      switch (cmdStr) {
        case "l":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "L":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "m":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "l";
          break;
        case "M":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "L";
          break;
        case "h":
          cpx += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "H":
          cpx = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "v":
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "V":
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "C":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++], p2[off++], p2[off++], p2[off++], p2[off++], p2[off++]);
          cpx = p2[off - 2];
          cpy = p2[off - 1];
          break;
        case "c":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy);
          cpx += p2[off - 2];
          cpy += p2[off - 1];
          break;
        case "S":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "s":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = cpx + p2[off++];
          y1 = cpy + p2[off++];
          cpx += p2[off++];
          cpy += p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "Q":
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "q":
          x1 = p2[off++] + cpx;
          y1 = p2[off++] + cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "T":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "t":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "A":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa, fs, rx, ry, psi, cmd, path);
          break;
        case "a":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa, fs, rx, ry, psi, cmd, path);
          break;
      }
    }
    if (cmdStr === "z" || cmdStr === "Z") {
      cmd = CMD2.Z;
      path.addData(cmd);
      cpx = subpathX;
      cpy = subpathY;
    }
    prevCmd = cmd;
  }
  path.toStatic();
  return path;
}
var SVGPath = function(_super) {
  __extends(SVGPath2, _super);
  function SVGPath2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SVGPath2.prototype.applyTransform = function(m2) {
  };
  return SVGPath2;
}(Path$1);
function isPathProxy(path) {
  return path.setData != null;
}
function createPathOptions(str, opts) {
  var pathProxy = createPathProxyFromString(str);
  var innerOpts = extend({}, opts);
  innerOpts.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.setData(pathProxy.data);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    } else {
      var ctx = path;
      pathProxy.rebuildPath(ctx, 1);
    }
  };
  innerOpts.applyTransform = function(m2) {
    transformPath(pathProxy, m2);
    this.dirtyShape();
  };
  return innerOpts;
}
function createFromString(str, opts) {
  return new SVGPath(createPathOptions(str, opts));
}
function extendFromString(str, defaultOpts) {
  var innerOpts = createPathOptions(str, defaultOpts);
  var Sub = function(_super) {
    __extends(Sub2, _super);
    function Sub2(opts) {
      var _this = _super.call(this, opts) || this;
      _this.applyTransform = innerOpts.applyTransform;
      _this.buildPath = innerOpts.buildPath;
      return _this;
    }
    return Sub2;
  }(SVGPath);
  return Sub;
}
function mergePath$1(pathEls, opts) {
  var pathList = [];
  var len2 = pathEls.length;
  for (var i = 0; i < len2; i++) {
    var pathEl = pathEls[i];
    pathList.push(pathEl.getUpdatedPathProxy(true));
  }
  var pathBundle = new Path$1(opts);
  pathBundle.createPathProxy();
  pathBundle.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.appendPath(pathList);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    }
  };
  return pathBundle;
}
function clonePath(sourcePath, opts) {
  opts = opts || {};
  var path = new Path$1();
  if (sourcePath.shape) {
    path.setShape(sourcePath.shape);
  }
  path.setStyle(sourcePath.style);
  if (opts.bakeTransform) {
    transformPath(path.path, sourcePath.getComputedTransform());
  } else {
    if (opts.toLocal) {
      path.setLocalTransform(sourcePath.getComputedTransform());
    } else {
      path.copyTransform(sourcePath);
    }
  }
  path.buildPath = sourcePath.buildPath;
  path.applyTransform = path.applyTransform;
  path.z = sourcePath.z;
  path.z2 = sourcePath.z2;
  path.zlevel = sourcePath.zlevel;
  return path;
}
var CircleShape = function() {
  function CircleShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
  }
  return CircleShape2;
}();
var Circle = function(_super) {
  __extends(Circle2, _super);
  function Circle2(opts) {
    return _super.call(this, opts) || this;
  }
  Circle2.prototype.getDefaultShape = function() {
    return new CircleShape();
  };
  Circle2.prototype.buildPath = function(ctx, shape) {
    ctx.moveTo(shape.cx + shape.r, shape.cy);
    ctx.arc(shape.cx, shape.cy, shape.r, 0, Math.PI * 2);
  };
  return Circle2;
}(Path$1);
Circle.prototype.type = "circle";
var Circle$1 = Circle;
var EllipseShape = function() {
  function EllipseShape2() {
    this.cx = 0;
    this.cy = 0;
    this.rx = 0;
    this.ry = 0;
  }
  return EllipseShape2;
}();
var Ellipse = function(_super) {
  __extends(Ellipse2, _super);
  function Ellipse2(opts) {
    return _super.call(this, opts) || this;
  }
  Ellipse2.prototype.getDefaultShape = function() {
    return new EllipseShape();
  };
  Ellipse2.prototype.buildPath = function(ctx, shape) {
    var k2 = 0.5522848;
    var x2 = shape.cx;
    var y2 = shape.cy;
    var a = shape.rx;
    var b2 = shape.ry;
    var ox = a * k2;
    var oy = b2 * k2;
    ctx.moveTo(x2 - a, y2);
    ctx.bezierCurveTo(x2 - a, y2 - oy, x2 - ox, y2 - b2, x2, y2 - b2);
    ctx.bezierCurveTo(x2 + ox, y2 - b2, x2 + a, y2 - oy, x2 + a, y2);
    ctx.bezierCurveTo(x2 + a, y2 + oy, x2 + ox, y2 + b2, x2, y2 + b2);
    ctx.bezierCurveTo(x2 - ox, y2 + b2, x2 - a, y2 + oy, x2 - a, y2);
    ctx.closePath();
  };
  return Ellipse2;
}(Path$1);
Ellipse.prototype.type = "ellipse";
var Ellipse$1 = Ellipse;
var PI$6 = Math.PI;
var PI2$4 = PI$6 * 2;
var mathSin$1 = Math.sin;
var mathCos$1 = Math.cos;
var mathACos = Math.acos;
var mathATan2 = Math.atan2;
var mathAbs$1 = Math.abs;
var mathSqrt = Math.sqrt;
var mathMax$7 = Math.max;
var mathMin$7 = Math.min;
var e$1 = 1e-4;
function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
  var dx10 = x1 - x0;
  var dy10 = y1 - y0;
  var dx32 = x3 - x2;
  var dy32 = y3 - y2;
  var t2 = dy32 * dx10 - dx32 * dy10;
  if (t2 * t2 < e$1) {
    return;
  }
  t2 = (dx32 * (y0 - y2) - dy32 * (x0 - x2)) / t2;
  return [x0 + t2 * dx10, y0 + t2 * dy10];
}
function computeCornerTangents(x0, y0, x1, y1, radius, cr, clockwise) {
  var x01 = x0 - x1;
  var y01 = y0 - y1;
  var lo = (clockwise ? cr : -cr) / mathSqrt(x01 * x01 + y01 * y01);
  var ox = lo * y01;
  var oy = -lo * x01;
  var x11 = x0 + ox;
  var y11 = y0 + oy;
  var x10 = x1 + ox;
  var y10 = y1 + oy;
  var x00 = (x11 + x10) / 2;
  var y00 = (y11 + y10) / 2;
  var dx = x10 - x11;
  var dy = y10 - y11;
  var d2 = dx * dx + dy * dy;
  var r2 = radius - cr;
  var s = x11 * y10 - x10 * y11;
  var d3 = (dy < 0 ? -1 : 1) * mathSqrt(mathMax$7(0, r2 * r2 * d2 - s * s));
  var cx0 = (s * dy - dx * d3) / d2;
  var cy0 = (-s * dx - dy * d3) / d2;
  var cx1 = (s * dy + dx * d3) / d2;
  var cy1 = (-s * dx + dy * d3) / d2;
  var dx0 = cx0 - x00;
  var dy0 = cy0 - y00;
  var dx1 = cx1 - x00;
  var dy1 = cy1 - y00;
  if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) {
    cx0 = cx1;
    cy0 = cy1;
  }
  return {
    cx: cx0,
    cy: cy0,
    x0: -ox,
    y0: -oy,
    x1: cx0 * (radius / r2 - 1),
    y1: cy0 * (radius / r2 - 1)
  };
}
function normalizeCornerRadius(cr) {
  var arr;
  if (isArray$1(cr)) {
    var len2 = cr.length;
    if (!len2) {
      return cr;
    }
    if (len2 === 1) {
      arr = [cr[0], cr[0], 0, 0];
    } else if (len2 === 2) {
      arr = [cr[0], cr[0], cr[1], cr[1]];
    } else if (len2 === 3) {
      arr = cr.concat(cr[2]);
    } else {
      arr = cr;
    }
  } else {
    arr = [cr, cr, cr, cr];
  }
  return arr;
}
function buildPath$1(ctx, shape) {
  var _a2;
  var radius = mathMax$7(shape.r, 0);
  var innerRadius = mathMax$7(shape.r0 || 0, 0);
  var hasRadius = radius > 0;
  var hasInnerRadius = innerRadius > 0;
  if (!hasRadius && !hasInnerRadius) {
    return;
  }
  if (!hasRadius) {
    radius = innerRadius;
    innerRadius = 0;
  }
  if (innerRadius > radius) {
    var tmp = radius;
    radius = innerRadius;
    innerRadius = tmp;
  }
  var startAngle = shape.startAngle, endAngle = shape.endAngle;
  if (isNaN(startAngle) || isNaN(endAngle)) {
    return;
  }
  var cx = shape.cx, cy = shape.cy;
  var clockwise = !!shape.clockwise;
  var arc = mathAbs$1(endAngle - startAngle);
  var mod = arc > PI2$4 && arc % PI2$4;
  mod > e$1 && (arc = mod);
  if (!(radius > e$1)) {
    ctx.moveTo(cx, cy);
  } else if (arc > PI2$4 - e$1) {
    ctx.moveTo(cx + radius * mathCos$1(startAngle), cy + radius * mathSin$1(startAngle));
    ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    if (innerRadius > e$1) {
      ctx.moveTo(cx + innerRadius * mathCos$1(endAngle), cy + innerRadius * mathSin$1(endAngle));
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  } else {
    var icrStart = void 0;
    var icrEnd = void 0;
    var ocrStart = void 0;
    var ocrEnd = void 0;
    var ocrs = void 0;
    var ocre = void 0;
    var icrs = void 0;
    var icre = void 0;
    var ocrMax = void 0;
    var icrMax = void 0;
    var limitedOcrMax = void 0;
    var limitedIcrMax = void 0;
    var xre = void 0;
    var yre = void 0;
    var xirs = void 0;
    var yirs = void 0;
    var xrs = radius * mathCos$1(startAngle);
    var yrs = radius * mathSin$1(startAngle);
    var xire = innerRadius * mathCos$1(endAngle);
    var yire = innerRadius * mathSin$1(endAngle);
    var hasArc = arc > e$1;
    if (hasArc) {
      var cornerRadius = shape.cornerRadius;
      if (cornerRadius) {
        _a2 = normalizeCornerRadius(cornerRadius), icrStart = _a2[0], icrEnd = _a2[1], ocrStart = _a2[2], ocrEnd = _a2[3];
      }
      var halfRd = mathAbs$1(radius - innerRadius) / 2;
      ocrs = mathMin$7(halfRd, ocrStart);
      ocre = mathMin$7(halfRd, ocrEnd);
      icrs = mathMin$7(halfRd, icrStart);
      icre = mathMin$7(halfRd, icrEnd);
      limitedOcrMax = ocrMax = mathMax$7(ocrs, ocre);
      limitedIcrMax = icrMax = mathMax$7(icrs, icre);
      if (ocrMax > e$1 || icrMax > e$1) {
        xre = radius * mathCos$1(endAngle);
        yre = radius * mathSin$1(endAngle);
        xirs = innerRadius * mathCos$1(startAngle);
        yirs = innerRadius * mathSin$1(startAngle);
        if (arc < PI$6) {
          var it_1 = intersect(xrs, yrs, xirs, yirs, xre, yre, xire, yire);
          if (it_1) {
            var x0 = xrs - it_1[0];
            var y0 = yrs - it_1[1];
            var x1 = xre - it_1[0];
            var y1 = yre - it_1[1];
            var a = 1 / mathSin$1(mathACos((x0 * x1 + y0 * y1) / (mathSqrt(x0 * x0 + y0 * y0) * mathSqrt(x1 * x1 + y1 * y1))) / 2);
            var b2 = mathSqrt(it_1[0] * it_1[0] + it_1[1] * it_1[1]);
            limitedOcrMax = mathMin$7(ocrMax, (radius - b2) / (a + 1));
            limitedIcrMax = mathMin$7(icrMax, (innerRadius - b2) / (a - 1));
          }
        }
      }
    }
    if (!hasArc) {
      ctx.moveTo(cx + xrs, cy + yrs);
    } else if (limitedOcrMax > e$1) {
      var crStart = mathMin$7(ocrStart, limitedOcrMax);
      var crEnd = mathMin$7(ocrEnd, limitedOcrMax);
      var ct0 = computeCornerTangents(xirs, yirs, xrs, yrs, radius, crStart, clockwise);
      var ct1 = computeCornerTangents(xre, yre, xire, yire, radius, crEnd, clockwise);
      ctx.moveTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedOcrMax < ocrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedOcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crStart > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crStart, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, radius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), !clockwise);
        crEnd > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crEnd, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.moveTo(cx + xrs, cy + yrs);
      ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    }
    if (!(innerRadius > e$1) || !hasArc) {
      ctx.lineTo(cx + xire, cy + yire);
    } else if (limitedIcrMax > e$1) {
      var crStart = mathMin$7(icrStart, limitedIcrMax);
      var crEnd = mathMin$7(icrEnd, limitedIcrMax);
      var ct0 = computeCornerTangents(xire, yire, xre, yre, innerRadius, -crEnd, clockwise);
      var ct1 = computeCornerTangents(xrs, yrs, xirs, yirs, innerRadius, -crStart, clockwise);
      ctx.lineTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedIcrMax < icrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedIcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crEnd > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crEnd, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, innerRadius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), clockwise);
        crStart > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crStart, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.lineTo(cx + xire, cy + yire);
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  }
  ctx.closePath();
}
var SectorShape = function() {
  function SectorShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
    this.cornerRadius = 0;
  }
  return SectorShape2;
}();
var Sector = function(_super) {
  __extends(Sector2, _super);
  function Sector2(opts) {
    return _super.call(this, opts) || this;
  }
  Sector2.prototype.getDefaultShape = function() {
    return new SectorShape();
  };
  Sector2.prototype.buildPath = function(ctx, shape) {
    buildPath$1(ctx, shape);
  };
  Sector2.prototype.isZeroArea = function() {
    return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
  };
  return Sector2;
}(Path$1);
Sector.prototype.type = "sector";
var Sector$1 = Sector;
var RingShape = function() {
  function RingShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.r0 = 0;
  }
  return RingShape2;
}();
var Ring = function(_super) {
  __extends(Ring2, _super);
  function Ring2(opts) {
    return _super.call(this, opts) || this;
  }
  Ring2.prototype.getDefaultShape = function() {
    return new RingShape();
  };
  Ring2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var PI22 = Math.PI * 2;
    ctx.moveTo(x2 + shape.r, y2);
    ctx.arc(x2, y2, shape.r, 0, PI22, false);
    ctx.moveTo(x2 + shape.r0, y2);
    ctx.arc(x2, y2, shape.r0, 0, PI22, true);
  };
  return Ring2;
}(Path$1);
Ring.prototype.type = "ring";
var Ring$1 = Ring;
function smoothBezier(points2, smooth, isLoop, constraint) {
  var cps = [];
  var v4 = [];
  var v12 = [];
  var v22 = [];
  var prevPoint;
  var nextPoint;
  var min3;
  var max3;
  if (constraint) {
    min3 = [Infinity, Infinity];
    max3 = [-Infinity, -Infinity];
    for (var i = 0, len2 = points2.length; i < len2; i++) {
      min$1(min3, min3, points2[i]);
      max$1(max3, max3, points2[i]);
    }
    min$1(min3, min3, constraint[0]);
    max$1(max3, max3, constraint[1]);
  }
  for (var i = 0, len2 = points2.length; i < len2; i++) {
    var point = points2[i];
    if (isLoop) {
      prevPoint = points2[i ? i - 1 : len2 - 1];
      nextPoint = points2[(i + 1) % len2];
    } else {
      if (i === 0 || i === len2 - 1) {
        cps.push(clone$3(points2[i]));
        continue;
      } else {
        prevPoint = points2[i - 1];
        nextPoint = points2[i + 1];
      }
    }
    sub(v4, nextPoint, prevPoint);
    scale$2(v4, v4, smooth);
    var d0 = distance(point, prevPoint);
    var d1 = distance(point, nextPoint);
    var sum2 = d0 + d1;
    if (sum2 !== 0) {
      d0 /= sum2;
      d1 /= sum2;
    }
    scale$2(v12, v4, -d0);
    scale$2(v22, v4, d1);
    var cp0 = add([], point, v12);
    var cp1 = add([], point, v22);
    if (constraint) {
      max$1(cp0, cp0, min3);
      min$1(cp0, cp0, max3);
      max$1(cp1, cp1, min3);
      min$1(cp1, cp1, max3);
    }
    cps.push(cp0);
    cps.push(cp1);
  }
  if (isLoop) {
    cps.push(cps.shift());
  }
  return cps;
}
function buildPath(ctx, shape, closePath) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (points2 && points2.length >= 2) {
    if (smooth) {
      var controlPoints = smoothBezier(points2, smooth, closePath, shape.smoothConstraint);
      ctx.moveTo(points2[0][0], points2[0][1]);
      var len2 = points2.length;
      for (var i = 0; i < (closePath ? len2 : len2 - 1); i++) {
        var cp1 = controlPoints[i * 2];
        var cp2 = controlPoints[i * 2 + 1];
        var p2 = points2[(i + 1) % len2];
        ctx.bezierCurveTo(cp1[0], cp1[1], cp2[0], cp2[1], p2[0], p2[1]);
      }
    } else {
      ctx.moveTo(points2[0][0], points2[0][1]);
      for (var i = 1, l2 = points2.length; i < l2; i++) {
        ctx.lineTo(points2[i][0], points2[i][1]);
      }
    }
    closePath && ctx.closePath();
  }
}
var PolygonShape = function() {
  function PolygonShape2() {
    this.points = null;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolygonShape2;
}();
var Polygon = function(_super) {
  __extends(Polygon2, _super);
  function Polygon2(opts) {
    return _super.call(this, opts) || this;
  }
  Polygon2.prototype.getDefaultShape = function() {
    return new PolygonShape();
  };
  Polygon2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, true);
  };
  return Polygon2;
}(Path$1);
Polygon.prototype.type = "polygon";
var Polygon$1 = Polygon;
var PolylineShape = function() {
  function PolylineShape2() {
    this.points = null;
    this.percent = 1;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolylineShape2;
}();
var Polyline$2 = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(opts) {
    return _super.call(this, opts) || this;
  }
  Polyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Polyline2.prototype.getDefaultShape = function() {
    return new PolylineShape();
  };
  Polyline2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, false);
  };
  return Polyline2;
}(Path$1);
Polyline$2.prototype.type = "polyline";
var Polyline$3 = Polyline$2;
var subPixelOptimizeOutputShape = {};
var LineShape = function() {
  function LineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return LineShape2;
}();
var Line$2 = function(_super) {
  __extends(Line2, _super);
  function Line2(opts) {
    return _super.call(this, opts) || this;
  }
  Line2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Line2.prototype.getDefaultShape = function() {
    return new LineShape();
  };
  Line2.prototype.buildPath = function(ctx, shape) {
    var x1;
    var y1;
    var x2;
    var y2;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeLine$1(subPixelOptimizeOutputShape, shape, this.style);
      x1 = optimizedShape.x1;
      y1 = optimizedShape.y1;
      x2 = optimizedShape.x2;
      y2 = optimizedShape.y2;
    } else {
      x1 = shape.x1;
      y1 = shape.y1;
      x2 = shape.x2;
      y2 = shape.y2;
    }
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (percent < 1) {
      x2 = x1 * (1 - percent) + x2 * percent;
      y2 = y1 * (1 - percent) + y2 * percent;
    }
    ctx.lineTo(x2, y2);
  };
  Line2.prototype.pointAt = function(p2) {
    var shape = this.shape;
    return [
      shape.x1 * (1 - p2) + shape.x2 * p2,
      shape.y1 * (1 - p2) + shape.y2 * p2
    ];
  };
  return Line2;
}(Path$1);
Line$2.prototype.type = "line";
var Line$3 = Line$2;
var out = [];
var BezierCurveShape = function() {
  function BezierCurveShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.percent = 1;
  }
  return BezierCurveShape2;
}();
function someVectorAt(shape, t2, isTangent) {
  var cpx2 = shape.cpx2;
  var cpy2 = shape.cpy2;
  if (cpx2 != null || cpy2 != null) {
    return [
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.x1, shape.cpx1, shape.cpx2, shape.x2, t2),
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.y1, shape.cpy1, shape.cpy2, shape.y2, t2)
    ];
  } else {
    return [
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.x1, shape.cpx1, shape.x2, t2),
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.y1, shape.cpy1, shape.y2, t2)
    ];
  }
}
var BezierCurve = function(_super) {
  __extends(BezierCurve2, _super);
  function BezierCurve2(opts) {
    return _super.call(this, opts) || this;
  }
  BezierCurve2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  BezierCurve2.prototype.getDefaultShape = function() {
    return new BezierCurveShape();
  };
  BezierCurve2.prototype.buildPath = function(ctx, shape) {
    var x1 = shape.x1;
    var y1 = shape.y1;
    var x2 = shape.x2;
    var y2 = shape.y2;
    var cpx1 = shape.cpx1;
    var cpy1 = shape.cpy1;
    var cpx2 = shape.cpx2;
    var cpy2 = shape.cpy2;
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (cpx2 == null || cpy2 == null) {
      if (percent < 1) {
        quadraticSubdivide(x1, cpx1, x2, percent, out);
        cpx1 = out[1];
        x2 = out[2];
        quadraticSubdivide(y1, cpy1, y2, percent, out);
        cpy1 = out[1];
        y2 = out[2];
      }
      ctx.quadraticCurveTo(cpx1, cpy1, x2, y2);
    } else {
      if (percent < 1) {
        cubicSubdivide(x1, cpx1, cpx2, x2, percent, out);
        cpx1 = out[1];
        cpx2 = out[2];
        x2 = out[3];
        cubicSubdivide(y1, cpy1, cpy2, y2, percent, out);
        cpy1 = out[1];
        cpy2 = out[2];
        y2 = out[3];
      }
      ctx.bezierCurveTo(cpx1, cpy1, cpx2, cpy2, x2, y2);
    }
  };
  BezierCurve2.prototype.pointAt = function(t2) {
    return someVectorAt(this.shape, t2, false);
  };
  BezierCurve2.prototype.tangentAt = function(t2) {
    var p2 = someVectorAt(this.shape, t2, true);
    return normalize$4(p2, p2);
  };
  return BezierCurve2;
}(Path$1);
BezierCurve.prototype.type = "bezier-curve";
var BezierCurve$1 = BezierCurve;
var ArcShape = function() {
  function ArcShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return ArcShape2;
}();
var Arc = function(_super) {
  __extends(Arc2, _super);
  function Arc2(opts) {
    return _super.call(this, opts) || this;
  }
  Arc2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Arc2.prototype.getDefaultShape = function() {
    return new ArcShape();
  };
  Arc2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var r2 = Math.max(shape.r, 0);
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var unitX = Math.cos(startAngle);
    var unitY = Math.sin(startAngle);
    ctx.moveTo(unitX * r2 + x2, unitY * r2 + y2);
    ctx.arc(x2, y2, r2, startAngle, endAngle, !clockwise);
  };
  return Arc2;
}(Path$1);
Arc.prototype.type = "arc";
var Arc$1 = Arc;
var CompoundPath = function(_super) {
  __extends(CompoundPath2, _super);
  function CompoundPath2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "compound";
    return _this;
  }
  CompoundPath2.prototype._updatePathDirty = function() {
    var paths = this.shape.paths;
    var dirtyPath = this.shapeChanged();
    for (var i = 0; i < paths.length; i++) {
      dirtyPath = dirtyPath || paths[i].shapeChanged();
    }
    if (dirtyPath) {
      this.dirtyShape();
    }
  };
  CompoundPath2.prototype.beforeBrush = function() {
    this._updatePathDirty();
    var paths = this.shape.paths || [];
    var scale2 = this.getGlobalScale();
    for (var i = 0; i < paths.length; i++) {
      if (!paths[i].path) {
        paths[i].createPathProxy();
      }
      paths[i].path.setScale(scale2[0], scale2[1], paths[i].segmentIgnoreThreshold);
    }
  };
  CompoundPath2.prototype.buildPath = function(ctx, shape) {
    var paths = shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].buildPath(ctx, paths[i].shape, true);
    }
  };
  CompoundPath2.prototype.afterBrush = function() {
    var paths = this.shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].pathUpdated();
    }
  };
  CompoundPath2.prototype.getBoundingRect = function() {
    this._updatePathDirty.call(this);
    return Path$1.prototype.getBoundingRect.call(this);
  };
  return CompoundPath2;
}(Path$1);
var CompoundPath$1 = CompoundPath;
var Gradient = function() {
  function Gradient2(colorStops) {
    this.colorStops = colorStops || [];
  }
  Gradient2.prototype.addColorStop = function(offset, color) {
    this.colorStops.push({
      offset,
      color
    });
  };
  return Gradient2;
}();
var Gradient$1 = Gradient;
var LinearGradient = function(_super) {
  __extends(LinearGradient2, _super);
  function LinearGradient2(x2, y2, x22, y22, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0 : x2;
    _this.y = y2 == null ? 0 : y2;
    _this.x2 = x22 == null ? 1 : x22;
    _this.y2 = y22 == null ? 0 : y22;
    _this.type = "linear";
    _this.global = globalCoord || false;
    return _this;
  }
  return LinearGradient2;
}(Gradient$1);
var LinearGradient$1 = LinearGradient;
var RadialGradient = function(_super) {
  __extends(RadialGradient2, _super);
  function RadialGradient2(x2, y2, r2, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0.5 : x2;
    _this.y = y2 == null ? 0.5 : y2;
    _this.r = r2 == null ? 0.5 : r2;
    _this.type = "radial";
    _this.global = globalCoord || false;
    return _this;
  }
  return RadialGradient2;
}(Gradient$1);
var RadialGradient$1 = RadialGradient;
var extent = [0, 0];
var extent2 = [0, 0];
var minTv = new Point$1();
var maxTv = new Point$1();
var OrientedBoundingRect = function() {
  function OrientedBoundingRect2(rect, transform2) {
    this._corners = [];
    this._axes = [];
    this._origin = [0, 0];
    for (var i = 0; i < 4; i++) {
      this._corners[i] = new Point$1();
    }
    for (var i = 0; i < 2; i++) {
      this._axes[i] = new Point$1();
    }
    if (rect) {
      this.fromBoundingRect(rect, transform2);
    }
  }
  OrientedBoundingRect2.prototype.fromBoundingRect = function(rect, transform2) {
    var corners = this._corners;
    var axes = this._axes;
    var x2 = rect.x;
    var y2 = rect.y;
    var x22 = x2 + rect.width;
    var y22 = y2 + rect.height;
    corners[0].set(x2, y2);
    corners[1].set(x22, y2);
    corners[2].set(x22, y22);
    corners[3].set(x2, y22);
    if (transform2) {
      for (var i = 0; i < 4; i++) {
        corners[i].transform(transform2);
      }
    }
    Point$1.sub(axes[0], corners[1], corners[0]);
    Point$1.sub(axes[1], corners[3], corners[0]);
    axes[0].normalize();
    axes[1].normalize();
    for (var i = 0; i < 2; i++) {
      this._origin[i] = axes[i].dot(corners[0]);
    }
  };
  OrientedBoundingRect2.prototype.intersect = function(other, mtv) {
    var overlapped = true;
    var noMtv = !mtv;
    minTv.set(Infinity, Infinity);
    maxTv.set(0, 0);
    if (!this._intersectCheckOneSide(this, other, minTv, maxTv, noMtv, 1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!this._intersectCheckOneSide(other, this, minTv, maxTv, noMtv, -1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!noMtv) {
      Point$1.copy(mtv, overlapped ? minTv : maxTv);
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._intersectCheckOneSide = function(self2, other, minTv2, maxTv2, noMtv, inverse) {
    var overlapped = true;
    for (var i = 0; i < 2; i++) {
      var axis = this._axes[i];
      this._getProjMinMaxOnAxis(i, self2._corners, extent);
      this._getProjMinMaxOnAxis(i, other._corners, extent2);
      if (extent[1] < extent2[0] || extent[0] > extent2[1]) {
        overlapped = false;
        if (noMtv) {
          return overlapped;
        }
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) > maxTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(maxTv2, axis, -dist0 * inverse);
          } else {
            Point$1.scale(maxTv2, axis, dist1 * inverse);
          }
        }
      } else if (minTv2) {
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) < minTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(minTv2, axis, dist0 * inverse);
          } else {
            Point$1.scale(minTv2, axis, -dist1 * inverse);
          }
        }
      }
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._getProjMinMaxOnAxis = function(dim, corners, out2) {
    var axis = this._axes[dim];
    var origin = this._origin;
    var proj = corners[0].dot(axis) + origin[dim];
    var min3 = proj;
    var max3 = proj;
    for (var i = 1; i < corners.length; i++) {
      var proj_1 = corners[i].dot(axis) + origin[dim];
      min3 = Math.min(proj_1, min3);
      max3 = Math.max(proj_1, max3);
    }
    out2[0] = min3;
    out2[1] = max3;
  };
  return OrientedBoundingRect2;
}();
var OrientedBoundingRect$1 = OrientedBoundingRect;
var m$2 = [];
var IncrementalDisplayable = function(_super) {
  __extends(IncrementalDisplayable2, _super);
  function IncrementalDisplayable2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.notClear = true;
    _this.incremental = true;
    _this._displayables = [];
    _this._temporaryDisplayables = [];
    _this._cursor = 0;
    return _this;
  }
  IncrementalDisplayable2.prototype.traverse = function(cb, context) {
    cb.call(context, this);
  };
  IncrementalDisplayable2.prototype.useStyle = function() {
    this.style = {};
  };
  IncrementalDisplayable2.prototype.getCursor = function() {
    return this._cursor;
  };
  IncrementalDisplayable2.prototype.innerAfterBrush = function() {
    this._cursor = this._displayables.length;
  };
  IncrementalDisplayable2.prototype.clearDisplaybles = function() {
    this._displayables = [];
    this._temporaryDisplayables = [];
    this._cursor = 0;
    this.markRedraw();
    this.notClear = false;
  };
  IncrementalDisplayable2.prototype.clearTemporalDisplayables = function() {
    this._temporaryDisplayables = [];
  };
  IncrementalDisplayable2.prototype.addDisplayable = function(displayable, notPersistent) {
    if (notPersistent) {
      this._temporaryDisplayables.push(displayable);
    } else {
      this._displayables.push(displayable);
    }
    this.markRedraw();
  };
  IncrementalDisplayable2.prototype.addDisplayables = function(displayables, notPersistent) {
    notPersistent = notPersistent || false;
    for (var i = 0; i < displayables.length; i++) {
      this.addDisplayable(displayables[i], notPersistent);
    }
  };
  IncrementalDisplayable2.prototype.getDisplayables = function() {
    return this._displayables;
  };
  IncrementalDisplayable2.prototype.getTemporalDisplayables = function() {
    return this._temporaryDisplayables;
  };
  IncrementalDisplayable2.prototype.eachPendingDisplayable = function(cb) {
    for (var i = this._cursor; i < this._displayables.length; i++) {
      cb && cb(this._displayables[i]);
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      cb && cb(this._temporaryDisplayables[i]);
    }
  };
  IncrementalDisplayable2.prototype.update = function() {
    this.updateTransform();
    for (var i = this._cursor; i < this._displayables.length; i++) {
      var displayable = this._displayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      var displayable = this._temporaryDisplayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
  };
  IncrementalDisplayable2.prototype.getBoundingRect = function() {
    if (!this._rect) {
      var rect = new BoundingRect$1(Infinity, Infinity, -Infinity, -Infinity);
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        var childRect = displayable.getBoundingRect().clone();
        if (displayable.needLocalTransform()) {
          childRect.applyTransform(displayable.getLocalTransform(m$2));
        }
        rect.union(childRect);
      }
      this._rect = rect;
    }
    return this._rect;
  };
  IncrementalDisplayable2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    if (rect.contain(localPos[0], localPos[1])) {
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        if (displayable.contain(x2, y2)) {
          return true;
        }
      }
    }
    return false;
  };
  return IncrementalDisplayable2;
}(Displayable$1);
var IncrementalDisplayable$1 = IncrementalDisplayable;
var transitionStore = makeInner();
function getAnimationConfig(animationType, animatableModel, dataIndex, extraOpts, extraDelayParams) {
  var animationPayload;
  if (animatableModel && animatableModel.ecModel) {
    var updatePayload = animatableModel.ecModel.getUpdatePayload();
    animationPayload = updatePayload && updatePayload.animation;
  }
  var animationEnabled = animatableModel && animatableModel.isAnimationEnabled();
  var isUpdate = animationType === "update";
  if (animationEnabled) {
    var duration = void 0;
    var easing = void 0;
    var delay = void 0;
    if (extraOpts) {
      duration = retrieve2(extraOpts.duration, 200);
      easing = retrieve2(extraOpts.easing, "cubicOut");
      delay = 0;
    } else {
      duration = animatableModel.getShallow(isUpdate ? "animationDurationUpdate" : "animationDuration");
      easing = animatableModel.getShallow(isUpdate ? "animationEasingUpdate" : "animationEasing");
      delay = animatableModel.getShallow(isUpdate ? "animationDelayUpdate" : "animationDelay");
    }
    if (animationPayload) {
      animationPayload.duration != null && (duration = animationPayload.duration);
      animationPayload.easing != null && (easing = animationPayload.easing);
      animationPayload.delay != null && (delay = animationPayload.delay);
    }
    if (isFunction(delay)) {
      delay = delay(dataIndex, extraDelayParams);
    }
    if (isFunction(duration)) {
      duration = duration(dataIndex);
    }
    var config = {
      duration: duration || 0,
      delay,
      easing
    };
    return config;
  } else {
    return null;
  }
}
function animateOrSetProps(animationType, el, props, animatableModel, dataIndex, cb, during) {
  var isFrom = false;
  var removeOpt;
  if (isFunction(dataIndex)) {
    during = cb;
    cb = dataIndex;
    dataIndex = null;
  } else if (isObject$4(dataIndex)) {
    cb = dataIndex.cb;
    during = dataIndex.during;
    isFrom = dataIndex.isFrom;
    removeOpt = dataIndex.removeOpt;
    dataIndex = dataIndex.dataIndex;
  }
  var isRemove = animationType === "leave";
  if (!isRemove) {
    el.stopAnimation("leave");
  }
  var animationConfig = getAnimationConfig(animationType, animatableModel, dataIndex, isRemove ? removeOpt || {} : null, animatableModel && animatableModel.getAnimationDelayParams ? animatableModel.getAnimationDelayParams(el, dataIndex) : null);
  if (animationConfig && animationConfig.duration > 0) {
    var duration = animationConfig.duration;
    var animationDelay = animationConfig.delay;
    var animationEasing = animationConfig.easing;
    var animateConfig = {
      duration,
      delay: animationDelay || 0,
      easing: animationEasing,
      done: cb,
      force: !!cb || !!during,
      setToFinal: !isRemove,
      scope: animationType,
      during
    };
    isFrom ? el.animateFrom(props, animateConfig) : el.animateTo(props, animateConfig);
  } else {
    el.stopAnimation();
    !isFrom && el.attr(props);
    during && during(1);
    cb && cb();
  }
}
function updateProps$1(el, props, animatableModel, dataIndex, cb, during) {
  animateOrSetProps("update", el, props, animatableModel, dataIndex, cb, during);
}
function initProps(el, props, animatableModel, dataIndex, cb, during) {
  animateOrSetProps("enter", el, props, animatableModel, dataIndex, cb, during);
}
function isElementRemoved(el) {
  if (!el.__zr) {
    return true;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.scope === "leave") {
      return true;
    }
  }
  return false;
}
function removeElement(el, props, animatableModel, dataIndex, cb, during) {
  if (isElementRemoved(el)) {
    return;
  }
  animateOrSetProps("leave", el, props, animatableModel, dataIndex, cb, during);
}
function fadeOutDisplayable(el, animatableModel, dataIndex, done) {
  el.removeTextContent();
  el.removeTextGuideLine();
  removeElement(el, {
    style: {
      opacity: 0
    }
  }, animatableModel, dataIndex, done);
}
function removeElementWithFadeOut(el, animatableModel, dataIndex) {
  function doRemove() {
    el.parent && el.parent.remove(el);
  }
  if (!el.isGroup) {
    fadeOutDisplayable(el, animatableModel, dataIndex, doRemove);
  } else {
    el.traverse(function(disp) {
      if (!disp.isGroup) {
        fadeOutDisplayable(disp, animatableModel, dataIndex, doRemove);
      }
    });
  }
}
function saveOldStyle(el) {
  transitionStore(el).oldStyle = el.style;
}
function getOldStyle(el) {
  return transitionStore(el).oldStyle;
}
var mathMax$6 = Math.max;
var mathMin$6 = Math.min;
var _customShapeMap = {};
function extendShape(opts) {
  return Path$1.extend(opts);
}
var extendPathFromString = extendFromString;
function extendPath(pathData, opts) {
  return extendPathFromString(pathData, opts);
}
function registerShape(name, ShapeClass) {
  _customShapeMap[name] = ShapeClass;
}
function getShapeClass(name) {
  if (_customShapeMap.hasOwnProperty(name)) {
    return _customShapeMap[name];
  }
}
function makePath(pathData, opts, rect, layout2) {
  var path = createFromString(pathData, opts);
  if (rect) {
    if (layout2 === "center") {
      rect = centerGraphic(rect, path.getBoundingRect());
    }
    resizePath(path, rect);
  }
  return path;
}
function makeImage(imageUrl, rect, layout2) {
  var zrImg = new ZRImage$1({
    style: {
      image: imageUrl,
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    onload: function(img) {
      if (layout2 === "center") {
        var boundingRect = {
          width: img.width,
          height: img.height
        };
        zrImg.setStyle(centerGraphic(rect, boundingRect));
      }
    }
  });
  return zrImg;
}
function centerGraphic(rect, boundingRect) {
  var aspect = boundingRect.width / boundingRect.height;
  var width = rect.height * aspect;
  var height;
  if (width <= rect.width) {
    height = rect.height;
  } else {
    width = rect.width;
    height = width / aspect;
  }
  var cx = rect.x + rect.width / 2;
  var cy = rect.y + rect.height / 2;
  return {
    x: cx - width / 2,
    y: cy - height / 2,
    width,
    height
  };
}
var mergePath = mergePath$1;
function resizePath(path, rect) {
  if (!path.applyTransform) {
    return;
  }
  var pathRect = path.getBoundingRect();
  var m2 = pathRect.calculateTransform(rect);
  path.applyTransform(m2);
}
function subPixelOptimizeLine(param) {
  subPixelOptimizeLine$1(param.shape, param.shape, param.style);
  return param;
}
function subPixelOptimizeRect(param) {
  subPixelOptimizeRect$1(param.shape, param.shape, param.style);
  return param;
}
var subPixelOptimize = subPixelOptimize$1;
function getTransform$1(target, ancestor) {
  var mat = identity([]);
  while (target && target !== ancestor) {
    mul(mat, target.getLocalTransform(), mat);
    target = target.parent;
  }
  return mat;
}
function applyTransform(target, transform2, invert$1) {
  if (transform2 && !isArrayLike(transform2)) {
    transform2 = Transformable$1.getLocalTransform(transform2);
  }
  if (invert$1) {
    transform2 = invert([], transform2);
  }
  return applyTransform$1([], target, transform2);
}
function transformDirection(direction, transform2, invert2) {
  var hBase = transform2[4] === 0 || transform2[5] === 0 || transform2[0] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[0]);
  var vBase = transform2[4] === 0 || transform2[5] === 0 || transform2[2] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[2]);
  var vertex = [direction === "left" ? -hBase : direction === "right" ? hBase : 0, direction === "top" ? -vBase : direction === "bottom" ? vBase : 0];
  vertex = applyTransform(vertex, transform2, invert2);
  return Math.abs(vertex[0]) > Math.abs(vertex[1]) ? vertex[0] > 0 ? "right" : "left" : vertex[1] > 0 ? "bottom" : "top";
}
function isNotGroup(el) {
  return !el.isGroup;
}
function isPath$1(el) {
  return el.shape != null;
}
function groupTransition(g1, g2, animatableModel) {
  if (!g1 || !g2) {
    return;
  }
  function getElMap(g3) {
    var elMap = {};
    g3.traverse(function(el) {
      if (isNotGroup(el) && el.anid) {
        elMap[el.anid] = el;
      }
    });
    return elMap;
  }
  function getAnimatableProps(el) {
    var obj = {
      x: el.x,
      y: el.y,
      rotation: el.rotation
    };
    if (isPath$1(el)) {
      obj.shape = extend({}, el.shape);
    }
    return obj;
  }
  var elMap1 = getElMap(g1);
  g2.traverse(function(el) {
    if (isNotGroup(el) && el.anid) {
      var oldEl = elMap1[el.anid];
      if (oldEl) {
        var newProp = getAnimatableProps(el);
        el.attr(getAnimatableProps(oldEl));
        updateProps$1(el, newProp, animatableModel, getECData(el).dataIndex);
      }
    }
  });
}
function clipPointsByRect(points2, rect) {
  return map$1(points2, function(point) {
    var x2 = point[0];
    x2 = mathMax$6(x2, rect.x);
    x2 = mathMin$6(x2, rect.x + rect.width);
    var y2 = point[1];
    y2 = mathMax$6(y2, rect.y);
    y2 = mathMin$6(y2, rect.y + rect.height);
    return [x2, y2];
  });
}
function clipRectByRect(targetRect, rect) {
  var x2 = mathMax$6(targetRect.x, rect.x);
  var x22 = mathMin$6(targetRect.x + targetRect.width, rect.x + rect.width);
  var y2 = mathMax$6(targetRect.y, rect.y);
  var y22 = mathMin$6(targetRect.y + targetRect.height, rect.y + rect.height);
  if (x22 >= x2 && y22 >= y2) {
    return {
      x: x2,
      y: y2,
      width: x22 - x2,
      height: y22 - y2
    };
  }
}
function createIcon(iconStr, opt, rect) {
  var innerOpts = extend({
    rectHover: true
  }, opt);
  var style = innerOpts.style = {
    strokeNoScale: true
  };
  rect = rect || {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  };
  if (iconStr) {
    return iconStr.indexOf("image://") === 0 ? (style.image = iconStr.slice(8), defaults(style, rect), new ZRImage$1(innerOpts)) : makePath(iconStr.replace("path://", ""), innerOpts, rect, "center");
  }
}
function linePolygonIntersect(a1x, a1y, a2x, a2y, points2) {
  for (var i = 0, p2 = points2[points2.length - 1]; i < points2.length; i++) {
    var p3 = points2[i];
    if (lineLineIntersect$1(a1x, a1y, a2x, a2y, p3[0], p3[1], p2[0], p2[1])) {
      return true;
    }
    p2 = p3;
  }
}
function lineLineIntersect$1(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d$1(nx, ny, mx, my);
  if (nearZero(nmCrossProduct)) {
    return false;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var q2 = crossProduct2d$1(b1a1x, b1a1y, mx, my) / nmCrossProduct;
  if (q2 < 0 || q2 > 1) {
    return false;
  }
  var p2 = crossProduct2d$1(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return false;
  }
  return true;
}
function crossProduct2d$1(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function nearZero(val) {
  return val <= 1e-6 && val >= -1e-6;
}
function setTooltipConfig(opt) {
  var itemTooltipOption = opt.itemTooltipOption;
  var componentModel = opt.componentModel;
  var itemName = opt.itemName;
  var itemTooltipOptionObj = isString(itemTooltipOption) ? {
    formatter: itemTooltipOption
  } : itemTooltipOption;
  var mainType = componentModel.mainType;
  var componentIndex = componentModel.componentIndex;
  var formatterParams = {
    componentType: mainType,
    name: itemName,
    $vars: ["name"]
  };
  formatterParams[mainType + "Index"] = componentIndex;
  var formatterParamsExtra = opt.formatterParamsExtra;
  if (formatterParamsExtra) {
    each$f(keys(formatterParamsExtra), function(key) {
      if (!hasOwn(formatterParams, key)) {
        formatterParams[key] = formatterParamsExtra[key];
        formatterParams.$vars.push(key);
      }
    });
  }
  var ecData = getECData(opt.el);
  ecData.componentMainType = mainType;
  ecData.componentIndex = componentIndex;
  ecData.tooltipConfig = {
    name: itemName,
    option: defaults({
      content: itemName,
      formatterParams
    }, itemTooltipOptionObj)
  };
}
function traverseElement(el, cb) {
  var stopped;
  if (el.isGroup) {
    stopped = cb(el);
  }
  if (!stopped) {
    el.traverse(cb);
  }
}
function traverseElements(els, cb) {
  if (els) {
    if (isArray$1(els)) {
      for (var i = 0; i < els.length; i++) {
        traverseElement(els[i], cb);
      }
    } else {
      traverseElement(els, cb);
    }
  }
}
registerShape("circle", Circle$1);
registerShape("ellipse", Ellipse$1);
registerShape("sector", Sector$1);
registerShape("ring", Ring$1);
registerShape("polygon", Polygon$1);
registerShape("polyline", Polyline$3);
registerShape("rect", Rect$3);
registerShape("line", Line$3);
registerShape("bezierCurve", BezierCurve$1);
registerShape("arc", Arc$1);
var graphic = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  updateProps: updateProps$1,
  initProps,
  removeElement,
  removeElementWithFadeOut,
  isElementRemoved,
  extendShape,
  extendPath,
  registerShape,
  getShapeClass,
  makePath,
  makeImage,
  mergePath,
  resizePath,
  subPixelOptimizeLine,
  subPixelOptimizeRect,
  subPixelOptimize,
  getTransform: getTransform$1,
  applyTransform,
  transformDirection,
  groupTransition,
  clipPointsByRect,
  clipRectByRect,
  createIcon,
  linePolygonIntersect,
  lineLineIntersect: lineLineIntersect$1,
  setTooltipConfig,
  traverseElements,
  Group: Group$4,
  Image: ZRImage$1,
  Text: ZRText$1,
  Circle: Circle$1,
  Ellipse: Ellipse$1,
  Sector: Sector$1,
  Ring: Ring$1,
  Polygon: Polygon$1,
  Polyline: Polyline$3,
  Rect: Rect$3,
  Line: Line$3,
  BezierCurve: BezierCurve$1,
  Arc: Arc$1,
  IncrementalDisplayable: IncrementalDisplayable$1,
  CompoundPath: CompoundPath$1,
  LinearGradient: LinearGradient$1,
  RadialGradient: RadialGradient$1,
  BoundingRect: BoundingRect$1,
  OrientedBoundingRect: OrientedBoundingRect$1,
  Point: Point$1,
  Path: Path$1
}, Symbol.toStringTag, { value: "Module" }));
var EMPTY_OBJ = {};
function setLabelText(label, labelTexts) {
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var text = labelTexts[stateName];
    var state = label.ensureState(stateName);
    state.style = state.style || {};
    state.style.text = text;
  }
  var oldStates = label.currentStates.slice();
  label.clearStates(true);
  label.setStyle({
    text: labelTexts.normal
  });
  label.useStates(oldStates, true);
}
function getLabelText(opt, stateModels, interpolatedValue) {
  var labelFetcher = opt.labelFetcher;
  var labelDataIndex = opt.labelDataIndex;
  var labelDimIndex = opt.labelDimIndex;
  var normalModel = stateModels.normal;
  var baseText;
  if (labelFetcher) {
    baseText = labelFetcher.getFormattedLabel(labelDataIndex, "normal", null, labelDimIndex, normalModel && normalModel.get("formatter"), interpolatedValue != null ? {
      interpolatedValue
    } : null);
  }
  if (baseText == null) {
    baseText = isFunction(opt.defaultText) ? opt.defaultText(labelDataIndex, opt, interpolatedValue) : opt.defaultText;
  }
  var statesText = {
    normal: baseText
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var stateModel = stateModels[stateName];
    statesText[stateName] = retrieve2(labelFetcher ? labelFetcher.getFormattedLabel(labelDataIndex, stateName, null, labelDimIndex, stateModel && stateModel.get("formatter")) : null, baseText);
  }
  return statesText;
}
function setLabelStyle(targetEl, labelStatesModels, opt, stateSpecified) {
  opt = opt || EMPTY_OBJ;
  var isSetOnText = targetEl instanceof ZRText$1;
  var needsCreateText = false;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateModel = labelStatesModels[DISPLAY_STATES[i]];
    if (stateModel && stateModel.getShallow("show")) {
      needsCreateText = true;
      break;
    }
  }
  var textContent = isSetOnText ? targetEl : targetEl.getTextContent();
  if (needsCreateText) {
    if (!isSetOnText) {
      if (!textContent) {
        textContent = new ZRText$1();
        targetEl.setTextContent(textContent);
      }
      if (targetEl.stateProxy) {
        textContent.stateProxy = targetEl.stateProxy;
      }
    }
    var labelStatesTexts = getLabelText(opt, labelStatesModels);
    var normalModel = labelStatesModels.normal;
    var showNormal = !!normalModel.getShallow("show");
    var normalStyle = createTextStyle(normalModel, stateSpecified && stateSpecified.normal, opt, false, !isSetOnText);
    normalStyle.text = labelStatesTexts.normal;
    if (!isSetOnText) {
      targetEl.setTextConfig(createTextConfig(normalModel, opt, false));
    }
    for (var i = 0; i < SPECIAL_STATES.length; i++) {
      var stateName = SPECIAL_STATES[i];
      var stateModel = labelStatesModels[stateName];
      if (stateModel) {
        var stateObj = textContent.ensureState(stateName);
        var stateShow = !!retrieve2(stateModel.getShallow("show"), showNormal);
        if (stateShow !== showNormal) {
          stateObj.ignore = !stateShow;
        }
        stateObj.style = createTextStyle(stateModel, stateSpecified && stateSpecified[stateName], opt, true, !isSetOnText);
        stateObj.style.text = labelStatesTexts[stateName];
        if (!isSetOnText) {
          var targetElEmphasisState = targetEl.ensureState(stateName);
          targetElEmphasisState.textConfig = createTextConfig(stateModel, opt, true);
        }
      }
    }
    textContent.silent = !!normalModel.getShallow("silent");
    if (textContent.style.x != null) {
      normalStyle.x = textContent.style.x;
    }
    if (textContent.style.y != null) {
      normalStyle.y = textContent.style.y;
    }
    textContent.ignore = !showNormal;
    textContent.useStyle(normalStyle);
    textContent.dirty();
    if (opt.enableTextSetter) {
      labelInner(textContent).setLabelText = function(interpolatedValue) {
        var labelStatesTexts2 = getLabelText(opt, labelStatesModels, interpolatedValue);
        setLabelText(textContent, labelStatesTexts2);
      };
    }
  } else if (textContent) {
    textContent.ignore = true;
  }
  targetEl.dirty();
}
function getLabelStatesModels(itemModel, labelName) {
  labelName = labelName || "label";
  var statesModels = {
    normal: itemModel.getModel(labelName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelName]);
  }
  return statesModels;
}
function createTextStyle(textStyleModel, specifiedTextStyle, opt, isNotNormal, isAttached) {
  var textStyle = {};
  setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached);
  specifiedTextStyle && extend(textStyle, specifiedTextStyle);
  return textStyle;
}
function createTextConfig(textStyleModel, opt, isNotNormal) {
  opt = opt || {};
  var textConfig = {};
  var labelPosition;
  var labelRotate = textStyleModel.getShallow("rotate");
  var labelDistance = retrieve2(textStyleModel.getShallow("distance"), isNotNormal ? null : 5);
  var labelOffset = textStyleModel.getShallow("offset");
  labelPosition = textStyleModel.getShallow("position") || (isNotNormal ? null : "inside");
  labelPosition === "outside" && (labelPosition = opt.defaultOutsidePosition || "top");
  if (labelPosition != null) {
    textConfig.position = labelPosition;
  }
  if (labelOffset != null) {
    textConfig.offset = labelOffset;
  }
  if (labelRotate != null) {
    labelRotate *= Math.PI / 180;
    textConfig.rotation = labelRotate;
  }
  if (labelDistance != null) {
    textConfig.distance = labelDistance;
  }
  textConfig.outsideFill = textStyleModel.get("color") === "inherit" ? opt.inheritColor || null : "auto";
  return textConfig;
}
function setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached) {
  opt = opt || EMPTY_OBJ;
  var ecModel = textStyleModel.ecModel;
  var globalTextStyle = ecModel && ecModel.option.textStyle;
  var richItemNames = getRichItemNames(textStyleModel);
  var richResult;
  if (richItemNames) {
    richResult = {};
    for (var name_1 in richItemNames) {
      if (richItemNames.hasOwnProperty(name_1)) {
        var richTextStyle = textStyleModel.getModel(["rich", name_1]);
        setTokenTextStyle(richResult[name_1] = {}, richTextStyle, globalTextStyle, opt, isNotNormal, isAttached, false, true);
      }
    }
  }
  if (richResult) {
    textStyle.rich = richResult;
  }
  var overflow = textStyleModel.get("overflow");
  if (overflow) {
    textStyle.overflow = overflow;
  }
  var margin = textStyleModel.get("minMargin");
  if (margin != null) {
    textStyle.margin = margin;
  }
  setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, true, false);
}
function getRichItemNames(textStyleModel) {
  var richItemNameMap;
  while (textStyleModel && textStyleModel !== textStyleModel.ecModel) {
    var rich = (textStyleModel.option || EMPTY_OBJ).rich;
    if (rich) {
      richItemNameMap = richItemNameMap || {};
      var richKeys = keys(rich);
      for (var i = 0; i < richKeys.length; i++) {
        var richKey = richKeys[i];
        richItemNameMap[richKey] = 1;
      }
    }
    textStyleModel = textStyleModel.parentModel;
  }
  return richItemNameMap;
}
var TEXT_PROPS_WITH_GLOBAL = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"];
var TEXT_PROPS_SELF = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"];
var TEXT_PROPS_BOX = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
function setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, isBlock, inRich) {
  globalTextStyle = !isNotNormal && globalTextStyle || EMPTY_OBJ;
  var inheritColor = opt && opt.inheritColor;
  var fillColor = textStyleModel.getShallow("color");
  var strokeColor = textStyleModel.getShallow("textBorderColor");
  var opacity = retrieve2(textStyleModel.getShallow("opacity"), globalTextStyle.opacity);
  if (fillColor === "inherit" || fillColor === "auto") {
    if (inheritColor) {
      fillColor = inheritColor;
    } else {
      fillColor = null;
    }
  }
  if (strokeColor === "inherit" || strokeColor === "auto") {
    if (inheritColor) {
      strokeColor = inheritColor;
    } else {
      strokeColor = null;
    }
  }
  if (!isAttached) {
    fillColor = fillColor || globalTextStyle.color;
    strokeColor = strokeColor || globalTextStyle.textBorderColor;
  }
  if (fillColor != null) {
    textStyle.fill = fillColor;
  }
  if (strokeColor != null) {
    textStyle.stroke = strokeColor;
  }
  var textBorderWidth = retrieve2(textStyleModel.getShallow("textBorderWidth"), globalTextStyle.textBorderWidth);
  if (textBorderWidth != null) {
    textStyle.lineWidth = textBorderWidth;
  }
  var textBorderType = retrieve2(textStyleModel.getShallow("textBorderType"), globalTextStyle.textBorderType);
  if (textBorderType != null) {
    textStyle.lineDash = textBorderType;
  }
  var textBorderDashOffset = retrieve2(textStyleModel.getShallow("textBorderDashOffset"), globalTextStyle.textBorderDashOffset);
  if (textBorderDashOffset != null) {
    textStyle.lineDashOffset = textBorderDashOffset;
  }
  if (!isNotNormal && opacity == null && !inRich) {
    opacity = opt && opt.defaultOpacity;
  }
  if (opacity != null) {
    textStyle.opacity = opacity;
  }
  if (!isNotNormal && !isAttached) {
    if (textStyle.fill == null && opt.inheritColor) {
      textStyle.fill = opt.inheritColor;
    }
  }
  for (var i = 0; i < TEXT_PROPS_WITH_GLOBAL.length; i++) {
    var key = TEXT_PROPS_WITH_GLOBAL[i];
    var val = retrieve2(textStyleModel.getShallow(key), globalTextStyle[key]);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  for (var i = 0; i < TEXT_PROPS_SELF.length; i++) {
    var key = TEXT_PROPS_SELF[i];
    var val = textStyleModel.getShallow(key);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  if (textStyle.verticalAlign == null) {
    var baseline = textStyleModel.getShallow("baseline");
    if (baseline != null) {
      textStyle.verticalAlign = baseline;
    }
  }
  if (!isBlock || !opt.disableBox) {
    for (var i = 0; i < TEXT_PROPS_BOX.length; i++) {
      var key = TEXT_PROPS_BOX[i];
      var val = textStyleModel.getShallow(key);
      if (val != null) {
        textStyle[key] = val;
      }
    }
    var borderType = textStyleModel.getShallow("borderType");
    if (borderType != null) {
      textStyle.borderDash = borderType;
    }
    if ((textStyle.backgroundColor === "auto" || textStyle.backgroundColor === "inherit") && inheritColor) {
      textStyle.backgroundColor = inheritColor;
    }
    if ((textStyle.borderColor === "auto" || textStyle.borderColor === "inherit") && inheritColor) {
      textStyle.borderColor = inheritColor;
    }
  }
}
function getFont(opt, ecModel) {
  var gTextStyleModel = ecModel && ecModel.getModel("textStyle");
  return trim$1([
    opt.fontStyle || gTextStyleModel && gTextStyleModel.getShallow("fontStyle") || "",
    opt.fontWeight || gTextStyleModel && gTextStyleModel.getShallow("fontWeight") || "",
    (opt.fontSize || gTextStyleModel && gTextStyleModel.getShallow("fontSize") || 12) + "px",
    opt.fontFamily || gTextStyleModel && gTextStyleModel.getShallow("fontFamily") || "sans-serif"
  ].join(" "));
}
var labelInner = makeInner();
function setLabelValueAnimation(label, labelStatesModels, value, getDefaultText) {
  if (!label) {
    return;
  }
  var obj = labelInner(label);
  obj.prevValue = obj.value;
  obj.value = value;
  var normalLabelModel = labelStatesModels.normal;
  obj.valueAnimation = normalLabelModel.get("valueAnimation");
  if (obj.valueAnimation) {
    obj.precision = normalLabelModel.get("precision");
    obj.defaultInterpolatedText = getDefaultText;
    obj.statesModels = labelStatesModels;
  }
}
function animateLabelValue(textEl, dataIndex, data, animatableModel, labelFetcher) {
  var labelInnerStore = labelInner(textEl);
  if (!labelInnerStore.valueAnimation || labelInnerStore.prevValue === labelInnerStore.value) {
    return;
  }
  var defaultInterpolatedText = labelInnerStore.defaultInterpolatedText;
  var currValue = retrieve2(labelInnerStore.interpolatedValue, labelInnerStore.prevValue);
  var targetValue = labelInnerStore.value;
  function during(percent) {
    var interpolated = interpolateRawValues(data, labelInnerStore.precision, currValue, targetValue, percent);
    labelInnerStore.interpolatedValue = percent === 1 ? null : interpolated;
    var labelText = getLabelText({
      labelDataIndex: dataIndex,
      labelFetcher,
      defaultText: defaultInterpolatedText ? defaultInterpolatedText(interpolated) : interpolated + ""
    }, labelInnerStore.statesModels, interpolated);
    setLabelText(textEl, labelText);
  }
  textEl.percent = 0;
  (labelInnerStore.prevValue == null ? initProps : updateProps$1)(textEl, {
    percent: 1
  }, animatableModel, dataIndex, null, during);
}
var PATH_COLOR = ["textStyle", "color"];
var textStyleParams = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"];
var tmpText = new ZRText$1();
var TextStyleMixin = function() {
  function TextStyleMixin2() {
  }
  TextStyleMixin2.prototype.getTextColor = function(isEmphasis) {
    var ecModel = this.ecModel;
    return this.getShallow("color") || (!isEmphasis && ecModel ? ecModel.get(PATH_COLOR) : null);
  };
  TextStyleMixin2.prototype.getFont = function() {
    return getFont({
      fontStyle: this.getShallow("fontStyle"),
      fontWeight: this.getShallow("fontWeight"),
      fontSize: this.getShallow("fontSize"),
      fontFamily: this.getShallow("fontFamily")
    }, this.ecModel);
  };
  TextStyleMixin2.prototype.getTextRect = function(text) {
    var style = {
      text,
      verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline")
    };
    for (var i = 0; i < textStyleParams.length; i++) {
      style[textStyleParams[i]] = this.getShallow(textStyleParams[i]);
    }
    tmpText.useStyle(style);
    tmpText.update();
    return tmpText.getBoundingRect();
  };
  return TextStyleMixin2;
}();
var TextStyleMixin$1 = TextStyleMixin;
var LINE_STYLE_KEY_MAP = [
  ["lineWidth", "width"],
  ["stroke", "color"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "type"],
  ["lineDashOffset", "dashOffset"],
  ["lineCap", "cap"],
  ["lineJoin", "join"],
  ["miterLimit"]
];
var getLineStyle = makeStyleMapper(LINE_STYLE_KEY_MAP);
var LineStyleMixin = function() {
  function LineStyleMixin2() {
  }
  LineStyleMixin2.prototype.getLineStyle = function(excludes) {
    return getLineStyle(this, excludes);
  };
  return LineStyleMixin2;
}();
var ITEM_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["stroke", "borderColor"],
  ["lineWidth", "borderWidth"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "borderType"],
  ["lineDashOffset", "borderDashOffset"],
  ["lineCap", "borderCap"],
  ["lineJoin", "borderJoin"],
  ["miterLimit", "borderMiterLimit"]
];
var getItemStyle = makeStyleMapper(ITEM_STYLE_KEY_MAP);
var ItemStyleMixin = function() {
  function ItemStyleMixin2() {
  }
  ItemStyleMixin2.prototype.getItemStyle = function(excludes, includes) {
    return getItemStyle(this, excludes, includes);
  };
  return ItemStyleMixin2;
}();
var Model = function() {
  function Model2(option, parentModel, ecModel) {
    this.parentModel = parentModel;
    this.ecModel = ecModel;
    this.option = option;
  }
  Model2.prototype.init = function(option, parentModel, ecModel) {
    var rest = [];
    for (var _i = 3; _i < arguments.length; _i++) {
      rest[_i - 3] = arguments[_i];
    }
  };
  Model2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
  };
  Model2.prototype.get = function(path, ignoreParent) {
    if (path == null) {
      return this.option;
    }
    return this._doGet(this.parsePath(path), !ignoreParent && this.parentModel);
  };
  Model2.prototype.getShallow = function(key, ignoreParent) {
    var option = this.option;
    var val = option == null ? option : option[key];
    if (val == null && !ignoreParent) {
      var parentModel = this.parentModel;
      if (parentModel) {
        val = parentModel.getShallow(key);
      }
    }
    return val;
  };
  Model2.prototype.getModel = function(path, parentModel) {
    var hasPath = path != null;
    var pathFinal = hasPath ? this.parsePath(path) : null;
    var obj = hasPath ? this._doGet(pathFinal) : this.option;
    parentModel = parentModel || this.parentModel && this.parentModel.getModel(this.resolveParentPath(pathFinal));
    return new Model2(obj, parentModel, this.ecModel);
  };
  Model2.prototype.isEmpty = function() {
    return this.option == null;
  };
  Model2.prototype.restoreData = function() {
  };
  Model2.prototype.clone = function() {
    var Ctor = this.constructor;
    return new Ctor(clone$4(this.option));
  };
  Model2.prototype.parsePath = function(path) {
    if (typeof path === "string") {
      return path.split(".");
    }
    return path;
  };
  Model2.prototype.resolveParentPath = function(path) {
    return path;
  };
  Model2.prototype.isAnimationEnabled = function() {
    if (!env$1.node && this.option) {
      if (this.option.animation != null) {
        return !!this.option.animation;
      } else if (this.parentModel) {
        return this.parentModel.isAnimationEnabled();
      }
    }
  };
  Model2.prototype._doGet = function(pathArr, parentModel) {
    var obj = this.option;
    if (!pathArr) {
      return obj;
    }
    for (var i = 0; i < pathArr.length; i++) {
      if (!pathArr[i]) {
        continue;
      }
      obj = obj && typeof obj === "object" ? obj[pathArr[i]] : null;
      if (obj == null) {
        break;
      }
    }
    if (obj == null && parentModel) {
      obj = parentModel._doGet(this.resolveParentPath(pathArr), parentModel.parentModel);
    }
    return obj;
  };
  return Model2;
}();
enableClassExtend(Model);
enableClassCheck(Model);
mixin(Model, LineStyleMixin);
mixin(Model, ItemStyleMixin);
mixin(Model, AreaStyleMixin);
mixin(Model, TextStyleMixin$1);
var Model$1 = Model;
var base = Math.round(Math.random() * 10);
function getUID(type4) {
  return [type4 || "", base++].join("_");
}
function enableSubTypeDefaulter(target) {
  var subTypeDefaulters = {};
  target.registerSubTypeDefaulter = function(componentType, defaulter) {
    var componentTypeInfo = parseClassType(componentType);
    subTypeDefaulters[componentTypeInfo.main] = defaulter;
  };
  target.determineSubType = function(componentType, option) {
    var type4 = option.type;
    if (!type4) {
      var componentTypeMain = parseClassType(componentType).main;
      if (target.hasSubTypes(componentType) && subTypeDefaulters[componentTypeMain]) {
        type4 = subTypeDefaulters[componentTypeMain](option);
      }
    }
    return type4;
  };
}
function enableTopologicalTravel(entity, dependencyGetter) {
  entity.topologicalTravel = function(targetNameList, fullNameList, callback, context) {
    if (!targetNameList.length) {
      return;
    }
    var result = makeDepndencyGraph(fullNameList);
    var graph = result.graph;
    var noEntryList = result.noEntryList;
    var targetNameSet = {};
    each$f(targetNameList, function(name) {
      targetNameSet[name] = true;
    });
    while (noEntryList.length) {
      var currComponentType = noEntryList.pop();
      var currVertex = graph[currComponentType];
      var isInTargetNameSet = !!targetNameSet[currComponentType];
      if (isInTargetNameSet) {
        callback.call(context, currComponentType, currVertex.originalDeps.slice());
        delete targetNameSet[currComponentType];
      }
      each$f(currVertex.successor, isInTargetNameSet ? removeEdgeAndAdd : removeEdge);
    }
    each$f(targetNameSet, function() {
      var errMsg = "";
      throw new Error(errMsg);
    });
    function removeEdge(succComponentType) {
      graph[succComponentType].entryCount--;
      if (graph[succComponentType].entryCount === 0) {
        noEntryList.push(succComponentType);
      }
    }
    function removeEdgeAndAdd(succComponentType) {
      targetNameSet[succComponentType] = true;
      removeEdge(succComponentType);
    }
  };
  function makeDepndencyGraph(fullNameList) {
    var graph = {};
    var noEntryList = [];
    each$f(fullNameList, function(name) {
      var thisItem = createDependencyGraphItem(graph, name);
      var originalDeps = thisItem.originalDeps = dependencyGetter(name);
      var availableDeps = getAvailableDependencies(originalDeps, fullNameList);
      thisItem.entryCount = availableDeps.length;
      if (thisItem.entryCount === 0) {
        noEntryList.push(name);
      }
      each$f(availableDeps, function(dependentName) {
        if (indexOf(thisItem.predecessor, dependentName) < 0) {
          thisItem.predecessor.push(dependentName);
        }
        var thatItem = createDependencyGraphItem(graph, dependentName);
        if (indexOf(thatItem.successor, dependentName) < 0) {
          thatItem.successor.push(name);
        }
      });
    });
    return {
      graph,
      noEntryList
    };
  }
  function createDependencyGraphItem(graph, name) {
    if (!graph[name]) {
      graph[name] = {
        predecessor: [],
        successor: []
      };
    }
    return graph[name];
  }
  function getAvailableDependencies(originalDeps, fullNameList) {
    var availableDeps = [];
    each$f(originalDeps, function(dep) {
      indexOf(fullNameList, dep) >= 0 && availableDeps.push(dep);
    });
    return availableDeps;
  }
}
function inheritDefaultOption(superOption, subOption) {
  return merge(merge({}, superOption, true), subOption, true);
}
var langEN = {
  time: {
    month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
    dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
  },
  legend: {
    selector: {
      all: "All",
      inverse: "Inv"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "Box Select",
        polygon: "Lasso Select",
        lineX: "Horizontally Select",
        lineY: "Vertically Select",
        keep: "Keep Selections",
        clear: "Clear Selections"
      }
    },
    dataView: {
      title: "Data View",
      lang: ["Data View", "Close", "Refresh"]
    },
    dataZoom: {
      title: {
        zoom: "Zoom",
        back: "Zoom Reset"
      }
    },
    magicType: {
      title: {
        line: "Switch to Line Chart",
        bar: "Switch to Bar Chart",
        stack: "Stack",
        tiled: "Tile"
      }
    },
    restore: {
      title: "Restore"
    },
    saveAsImage: {
      title: "Save as Image",
      lang: ["Right Click to Save Image"]
    }
  },
  series: {
    typeNames: {
      pie: "Pie chart",
      bar: "Bar chart",
      line: "Line chart",
      scatter: "Scatter plot",
      effectScatter: "Ripple scatter plot",
      radar: "Radar chart",
      tree: "Tree",
      treemap: "Treemap",
      boxplot: "Boxplot",
      candlestick: "Candlestick",
      k: "K line chart",
      heatmap: "Heat map",
      map: "Map",
      parallel: "Parallel coordinate map",
      lines: "Line graph",
      graph: "Relationship graph",
      sankey: "Sankey diagram",
      funnel: "Funnel chart",
      gauge: "Gauge",
      pictorialBar: "Pictorial bar",
      themeRiver: "Theme River Map",
      sunburst: "Sunburst"
    }
  },
  aria: {
    general: {
      withTitle: 'This is a chart about "{title}"',
      withoutTitle: "This is a chart"
    },
    series: {
      single: {
        prefix: "",
        withName: " with type {seriesType} named {seriesName}.",
        withoutName: " with type {seriesType}."
      },
      multiple: {
        prefix: ". It consists of {seriesCount} series count.",
        withName: " The {seriesId} series is a {seriesType} representing {seriesName}.",
        withoutName: " The {seriesId} series is a {seriesType}.",
        separator: {
          middle: "",
          end: ""
        }
      }
    },
    data: {
      allData: "The data is as follows: ",
      partialData: "The first {displayCnt} items are: ",
      withName: "the data for {name} is {value}",
      withoutName: "{value}",
      separator: {
        middle: ", ",
        end: ". "
      }
    }
  }
};
var langZH = {
  time: {
    month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"],
    monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"],
    dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"],
    dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"]
  },
  legend: {
    selector: {
      all: "\u5168\u9009",
      inverse: "\u53CD\u9009"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "\u77E9\u5F62\u9009\u62E9",
        polygon: "\u5708\u9009",
        lineX: "\u6A2A\u5411\u9009\u62E9",
        lineY: "\u7EB5\u5411\u9009\u62E9",
        keep: "\u4FDD\u6301\u9009\u62E9",
        clear: "\u6E05\u9664\u9009\u62E9"
      }
    },
    dataView: {
      title: "\u6570\u636E\u89C6\u56FE",
      lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"]
    },
    dataZoom: {
      title: {
        zoom: "\u533A\u57DF\u7F29\u653E",
        back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F"
      }
    },
    magicType: {
      title: {
        line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE",
        bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE",
        stack: "\u5207\u6362\u4E3A\u5806\u53E0",
        tiled: "\u5207\u6362\u4E3A\u5E73\u94FA"
      }
    },
    restore: {
      title: "\u8FD8\u539F"
    },
    saveAsImage: {
      title: "\u4FDD\u5B58\u4E3A\u56FE\u7247",
      lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"]
    }
  },
  series: {
    typeNames: {
      pie: "\u997C\u56FE",
      bar: "\u67F1\u72B6\u56FE",
      line: "\u6298\u7EBF\u56FE",
      scatter: "\u6563\u70B9\u56FE",
      effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE",
      radar: "\u96F7\u8FBE\u56FE",
      tree: "\u6811\u56FE",
      treemap: "\u77E9\u5F62\u6811\u56FE",
      boxplot: "\u7BB1\u578B\u56FE",
      candlestick: "K\u7EBF\u56FE",
      k: "K\u7EBF\u56FE",
      heatmap: "\u70ED\u529B\u56FE",
      map: "\u5730\u56FE",
      parallel: "\u5E73\u884C\u5750\u6807\u56FE",
      lines: "\u7EBF\u56FE",
      graph: "\u5173\u7CFB\u56FE",
      sankey: "\u6851\u57FA\u56FE",
      funnel: "\u6F0F\u6597\u56FE",
      gauge: "\u4EEA\u8868\u76D8\u56FE",
      pictorialBar: "\u8C61\u5F62\u67F1\u56FE",
      themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE",
      sunburst: "\u65ED\u65E5\u56FE"
    }
  },
  aria: {
    general: {
      withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002",
      withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C"
    },
    series: {
      single: {
        prefix: "",
        withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002",
        withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002"
      },
      multiple: {
        prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002",
        withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C",
        withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C",
        separator: {
          middle: "\uFF1B",
          end: "\u3002"
        }
      }
    },
    data: {
      allData: "\u5176\u6570\u636E\u662F\u2014\u2014",
      partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014",
      withName: "{name}\u7684\u6570\u636E\u662F{value}",
      withoutName: "{value}",
      separator: {
        middle: "\uFF0C",
        end: ""
      }
    }
  }
};
var LOCALE_ZH = "ZH";
var LOCALE_EN = "EN";
var DEFAULT_LOCALE = LOCALE_EN;
var localeStorage = {};
var localeModels = {};
var SYSTEM_LANG = !env$1.domSupported ? DEFAULT_LOCALE : function() {
  var langStr = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
  return langStr.indexOf(LOCALE_ZH) > -1 ? LOCALE_ZH : DEFAULT_LOCALE;
}();
function registerLocale(locale2, localeObj) {
  locale2 = locale2.toUpperCase();
  localeModels[locale2] = new Model$1(localeObj);
  localeStorage[locale2] = localeObj;
}
function createLocaleObject(locale2) {
  if (isString(locale2)) {
    var localeObj = localeStorage[locale2.toUpperCase()] || {};
    if (locale2 === LOCALE_ZH || locale2 === LOCALE_EN) {
      return clone$4(localeObj);
    } else {
      return merge(clone$4(localeObj), clone$4(localeStorage[DEFAULT_LOCALE]), false);
    }
  } else {
    return merge(clone$4(locale2), clone$4(localeStorage[DEFAULT_LOCALE]), false);
  }
}
function getLocaleModel(lang) {
  return localeModels[lang];
}
function getDefaultLocaleModel() {
  return localeModels[DEFAULT_LOCALE];
}
registerLocale(LOCALE_EN, langEN);
registerLocale(LOCALE_ZH, langZH);
var ONE_SECOND = 1e3;
var ONE_MINUTE = ONE_SECOND * 60;
var ONE_HOUR = ONE_MINUTE * 60;
var ONE_DAY = ONE_HOUR * 24;
var ONE_YEAR = ONE_DAY * 365;
var defaultLeveledFormatter = {
  year: "{yyyy}",
  month: "{MMM}",
  day: "{d}",
  hour: "{HH}:{mm}",
  minute: "{HH}:{mm}",
  second: "{HH}:{mm}:{ss}",
  millisecond: "{HH}:{mm}:{ss} {SSS}",
  none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}"
};
var fullDayFormatter = "{yyyy}-{MM}-{dd}";
var fullLeveledFormatter = {
  year: "{yyyy}",
  month: "{yyyy}-{MM}",
  day: fullDayFormatter,
  hour: fullDayFormatter + " " + defaultLeveledFormatter.hour,
  minute: fullDayFormatter + " " + defaultLeveledFormatter.minute,
  second: fullDayFormatter + " " + defaultLeveledFormatter.second,
  millisecond: defaultLeveledFormatter.none
};
var primaryTimeUnits = ["year", "month", "day", "hour", "minute", "second", "millisecond"];
var timeUnits = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
function pad(str, len2) {
  str += "";
  return "0000".substr(0, len2 - str.length) + str;
}
function getPrimaryTimeUnit(timeUnit) {
  switch (timeUnit) {
    case "half-year":
    case "quarter":
      return "month";
    case "week":
    case "half-week":
      return "day";
    case "half-day":
    case "quarter-day":
      return "hour";
    default:
      return timeUnit;
  }
}
function isPrimaryTimeUnit(timeUnit) {
  return timeUnit === getPrimaryTimeUnit(timeUnit);
}
function getDefaultFormatPrecisionOfInterval(timeUnit) {
  switch (timeUnit) {
    case "year":
    case "month":
      return "day";
    case "millisecond":
      return "millisecond";
    default:
      return "second";
  }
}
function format$1(time, template, isUTC, lang) {
  var date4 = parseDate(time);
  var y2 = date4[fullYearGetterName(isUTC)]();
  var M = date4[monthGetterName(isUTC)]() + 1;
  var q2 = Math.floor((M - 1) / 4) + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var e2 = date4["get" + (isUTC ? "UTC" : "") + "Day"]();
  var H = date4[hoursGetterName(isUTC)]();
  var h = (H - 1) % 12 + 1;
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S = date4[millisecondsGetterName(isUTC)]();
  var localeModel = lang instanceof Model$1 ? lang : getLocaleModel(lang || SYSTEM_LANG) || getDefaultLocaleModel();
  var timeModel = localeModel.getModel("time");
  var month = timeModel.get("month");
  var monthAbbr = timeModel.get("monthAbbr");
  var dayOfWeek = timeModel.get("dayOfWeek");
  var dayOfWeekAbbr = timeModel.get("dayOfWeekAbbr");
  return (template || "").replace(/{yyyy}/g, y2 + "").replace(/{yy}/g, y2 % 100 + "").replace(/{Q}/g, q2 + "").replace(/{MMMM}/g, month[M - 1]).replace(/{MMM}/g, monthAbbr[M - 1]).replace(/{MM}/g, pad(M, 2)).replace(/{M}/g, M + "").replace(/{dd}/g, pad(d2, 2)).replace(/{d}/g, d2 + "").replace(/{eeee}/g, dayOfWeek[e2]).replace(/{ee}/g, dayOfWeekAbbr[e2]).replace(/{e}/g, e2 + "").replace(/{HH}/g, pad(H, 2)).replace(/{H}/g, H + "").replace(/{hh}/g, pad(h + "", 2)).replace(/{h}/g, h + "").replace(/{mm}/g, pad(m2, 2)).replace(/{m}/g, m2 + "").replace(/{ss}/g, pad(s, 2)).replace(/{s}/g, s + "").replace(/{SSS}/g, pad(S, 3)).replace(/{S}/g, S + "");
}
function leveledFormat(tick, idx, formatter, lang, isUTC) {
  var template = null;
  if (isString(formatter)) {
    template = formatter;
  } else if (isFunction(formatter)) {
    template = formatter(tick.value, idx, {
      level: tick.level
    });
  } else {
    var defaults$1 = extend({}, defaultLeveledFormatter);
    if (tick.level > 0) {
      for (var i = 0; i < primaryTimeUnits.length; ++i) {
        defaults$1[primaryTimeUnits[i]] = "{primary|" + defaults$1[primaryTimeUnits[i]] + "}";
      }
    }
    var mergedFormatter = formatter ? formatter.inherit === false ? formatter : defaults(formatter, defaults$1) : defaults$1;
    var unit = getUnitFromValue(tick.value, isUTC);
    if (mergedFormatter[unit]) {
      template = mergedFormatter[unit];
    } else if (mergedFormatter.inherit) {
      var targetId = timeUnits.indexOf(unit);
      for (var i = targetId - 1; i >= 0; --i) {
        if (mergedFormatter[unit]) {
          template = mergedFormatter[unit];
          break;
        }
      }
      template = template || defaults$1.none;
    }
    if (isArray$1(template)) {
      var levelId = tick.level == null ? 0 : tick.level >= 0 ? tick.level : template.length + tick.level;
      levelId = Math.min(levelId, template.length - 1);
      template = template[levelId];
    }
  }
  return format$1(new Date(tick.value), template, isUTC, lang);
}
function getUnitFromValue(value, isUTC) {
  var date4 = parseDate(value);
  var M = date4[monthGetterName(isUTC)]() + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var h = date4[hoursGetterName(isUTC)]();
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S = date4[millisecondsGetterName(isUTC)]();
  var isSecond = S === 0;
  var isMinute = isSecond && s === 0;
  var isHour = isMinute && m2 === 0;
  var isDay = isHour && h === 0;
  var isMonth = isDay && d2 === 1;
  var isYear = isMonth && M === 1;
  if (isYear) {
    return "year";
  } else if (isMonth) {
    return "month";
  } else if (isDay) {
    return "day";
  } else if (isHour) {
    return "hour";
  } else if (isMinute) {
    return "minute";
  } else if (isSecond) {
    return "second";
  } else {
    return "millisecond";
  }
}
function getUnitValue(value, unit, isUTC) {
  var date4 = isNumber(value) ? parseDate(value) : value;
  unit = unit || getUnitFromValue(value, isUTC);
  switch (unit) {
    case "year":
      return date4[fullYearGetterName(isUTC)]();
    case "half-year":
      return date4[monthGetterName(isUTC)]() >= 6 ? 1 : 0;
    case "quarter":
      return Math.floor((date4[monthGetterName(isUTC)]() + 1) / 4);
    case "month":
      return date4[monthGetterName(isUTC)]();
    case "day":
      return date4[dateGetterName(isUTC)]();
    case "half-day":
      return date4[hoursGetterName(isUTC)]() / 24;
    case "hour":
      return date4[hoursGetterName(isUTC)]();
    case "minute":
      return date4[minutesGetterName(isUTC)]();
    case "second":
      return date4[secondsGetterName(isUTC)]();
    case "millisecond":
      return date4[millisecondsGetterName(isUTC)]();
  }
}
function fullYearGetterName(isUTC) {
  return isUTC ? "getUTCFullYear" : "getFullYear";
}
function monthGetterName(isUTC) {
  return isUTC ? "getUTCMonth" : "getMonth";
}
function dateGetterName(isUTC) {
  return isUTC ? "getUTCDate" : "getDate";
}
function hoursGetterName(isUTC) {
  return isUTC ? "getUTCHours" : "getHours";
}
function minutesGetterName(isUTC) {
  return isUTC ? "getUTCMinutes" : "getMinutes";
}
function secondsGetterName(isUTC) {
  return isUTC ? "getUTCSeconds" : "getSeconds";
}
function millisecondsGetterName(isUTC) {
  return isUTC ? "getUTCMilliseconds" : "getMilliseconds";
}
function fullYearSetterName(isUTC) {
  return isUTC ? "setUTCFullYear" : "setFullYear";
}
function monthSetterName(isUTC) {
  return isUTC ? "setUTCMonth" : "setMonth";
}
function dateSetterName(isUTC) {
  return isUTC ? "setUTCDate" : "setDate";
}
function hoursSetterName(isUTC) {
  return isUTC ? "setUTCHours" : "setHours";
}
function minutesSetterName(isUTC) {
  return isUTC ? "setUTCMinutes" : "setMinutes";
}
function secondsSetterName(isUTC) {
  return isUTC ? "setUTCSeconds" : "setSeconds";
}
function millisecondsSetterName(isUTC) {
  return isUTC ? "setUTCMilliseconds" : "setMilliseconds";
}
function addCommas(x2) {
  if (!isNumeric(x2)) {
    return isString(x2) ? x2 : "-";
  }
  var parts = (x2 + "").split(".");
  return parts[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (parts.length > 1 ? "." + parts[1] : "");
}
function toCamelCase(str, upperCaseFirst) {
  str = (str || "").toLowerCase().replace(/-(.)/g, function(match, group1) {
    return group1.toUpperCase();
  });
  if (upperCaseFirst && str) {
    str = str.charAt(0).toUpperCase() + str.slice(1);
  }
  return str;
}
var normalizeCssArray = normalizeCssArray$1;
var replaceReg = /([&<>"'])/g;
var replaceMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;"
};
function encodeHTML(source) {
  return source == null ? "" : (source + "").replace(replaceReg, function(str, c2) {
    return replaceMap[c2];
  });
}
function makeValueReadable(value, valueType, useUTC) {
  var USER_READABLE_DEFUALT_TIME_PATTERN = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
  function stringToUserReadable(str) {
    return str && trim$1(str) ? str : "-";
  }
  function isNumberUserReadable(num) {
    return !!(num != null && !isNaN(num) && isFinite(num));
  }
  var isTypeTime = valueType === "time";
  var isValueDate = value instanceof Date;
  if (isTypeTime || isValueDate) {
    var date4 = isTypeTime ? parseDate(value) : value;
    if (!isNaN(+date4)) {
      return format$1(date4, USER_READABLE_DEFUALT_TIME_PATTERN, useUTC);
    } else if (isValueDate) {
      return "-";
    }
  }
  if (valueType === "ordinal") {
    return isStringSafe(value) ? stringToUserReadable(value) : isNumber(value) ? isNumberUserReadable(value) ? value + "" : "-" : "-";
  }
  var numericResult = numericToNumber(value);
  return isNumberUserReadable(numericResult) ? addCommas(numericResult) : isStringSafe(value) ? stringToUserReadable(value) : typeof value === "boolean" ? value + "" : "-";
}
var TPL_VAR_ALIAS = ["a", "b", "c", "d", "e", "f", "g"];
var wrapVar = function(varName, seriesIdx) {
  return "{" + varName + (seriesIdx == null ? "" : seriesIdx) + "}";
};
function formatTpl(tpl, paramsList, encode) {
  if (!isArray$1(paramsList)) {
    paramsList = [paramsList];
  }
  var seriesLen = paramsList.length;
  if (!seriesLen) {
    return "";
  }
  var $vars = paramsList[0].$vars || [];
  for (var i = 0; i < $vars.length; i++) {
    var alias = TPL_VAR_ALIAS[i];
    tpl = tpl.replace(wrapVar(alias), wrapVar(alias, 0));
  }
  for (var seriesIdx = 0; seriesIdx < seriesLen; seriesIdx++) {
    for (var k2 = 0; k2 < $vars.length; k2++) {
      var val = paramsList[seriesIdx][$vars[k2]];
      tpl = tpl.replace(wrapVar(TPL_VAR_ALIAS[k2], seriesIdx), encode ? encodeHTML(val) : val);
    }
  }
  return tpl;
}
function formatTplSimple(tpl, param, encode) {
  each$f(param, function(value, key) {
    tpl = tpl.replace("{" + key + "}", encode ? encodeHTML(value) : value);
  });
  return tpl;
}
function getTooltipMarker(inOpt, extraCssText) {
  var opt = isString(inOpt) ? {
    color: inOpt,
    extraCssText
  } : inOpt || {};
  var color = opt.color;
  var type4 = opt.type;
  extraCssText = opt.extraCssText;
  var renderMode = opt.renderMode || "html";
  if (!color) {
    return "";
  }
  if (renderMode === "html") {
    return type4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>';
  } else {
    var markerId = opt.markerId || "markerX";
    return {
      renderMode,
      content: "{" + markerId + "|}  ",
      style: type4 === "subItem" ? {
        width: 4,
        height: 4,
        borderRadius: 2,
        backgroundColor: color
      } : {
        width: 10,
        height: 10,
        borderRadius: 5,
        backgroundColor: color
      }
    };
  }
}
function convertToColorString(color, defaultColor) {
  defaultColor = defaultColor || "transparent";
  return isString(color) ? color : isObject$4(color) ? color.colorStops && (color.colorStops[0] || {}).color || defaultColor : defaultColor;
}
function windowOpen(link, target) {
  if (target === "_blank" || target === "blank") {
    var blank = window.open();
    blank.opener = null;
    blank.location.href = link;
  } else {
    window.open(link, target);
  }
}
var each$e = each$f;
var LOCATION_PARAMS = ["left", "right", "top", "bottom", "width", "height"];
var HV_NAMES = [["width", "left", "right"], ["height", "top", "bottom"]];
function boxLayout(orient, group, gap, maxWidth, maxHeight) {
  var x2 = 0;
  var y2 = 0;
  if (maxWidth == null) {
    maxWidth = Infinity;
  }
  if (maxHeight == null) {
    maxHeight = Infinity;
  }
  var currentLineMaxSize = 0;
  group.eachChild(function(child, idx) {
    var rect = child.getBoundingRect();
    var nextChild = group.childAt(idx + 1);
    var nextChildRect = nextChild && nextChild.getBoundingRect();
    var nextX;
    var nextY;
    if (orient === "horizontal") {
      var moveX = rect.width + (nextChildRect ? -nextChildRect.x + rect.x : 0);
      nextX = x2 + moveX;
      if (nextX > maxWidth || child.newline) {
        x2 = 0;
        nextX = moveX;
        y2 += currentLineMaxSize + gap;
        currentLineMaxSize = rect.height;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.height);
      }
    } else {
      var moveY = rect.height + (nextChildRect ? -nextChildRect.y + rect.y : 0);
      nextY = y2 + moveY;
      if (nextY > maxHeight || child.newline) {
        x2 += currentLineMaxSize + gap;
        y2 = 0;
        nextY = moveY;
        currentLineMaxSize = rect.width;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.width);
      }
    }
    if (child.newline) {
      return;
    }
    child.x = x2;
    child.y = y2;
    child.markRedraw();
    orient === "horizontal" ? x2 = nextX + gap : y2 = nextY + gap;
  });
}
var box = boxLayout;
curry$1(boxLayout, "vertical");
curry$1(boxLayout, "horizontal");
function getAvailableSize(positionInfo, containerRect, margin) {
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var x2 = parsePercent(positionInfo.left, containerWidth);
  var y2 = parsePercent(positionInfo.top, containerHeight);
  var x22 = parsePercent(positionInfo.right, containerWidth);
  var y22 = parsePercent(positionInfo.bottom, containerHeight);
  (isNaN(x2) || isNaN(parseFloat(positionInfo.left))) && (x2 = 0);
  (isNaN(x22) || isNaN(parseFloat(positionInfo.right))) && (x22 = containerWidth);
  (isNaN(y2) || isNaN(parseFloat(positionInfo.top))) && (y2 = 0);
  (isNaN(y22) || isNaN(parseFloat(positionInfo.bottom))) && (y22 = containerHeight);
  margin = normalizeCssArray(margin || 0);
  return {
    width: Math.max(x22 - x2 - margin[1] - margin[3], 0),
    height: Math.max(y22 - y2 - margin[0] - margin[2], 0)
  };
}
function getLayoutRect(positionInfo, containerRect, margin) {
  margin = normalizeCssArray(margin || 0);
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var left = parsePercent(positionInfo.left, containerWidth);
  var top = parsePercent(positionInfo.top, containerHeight);
  var right = parsePercent(positionInfo.right, containerWidth);
  var bottom = parsePercent(positionInfo.bottom, containerHeight);
  var width = parsePercent(positionInfo.width, containerWidth);
  var height = parsePercent(positionInfo.height, containerHeight);
  var verticalMargin = margin[2] + margin[0];
  var horizontalMargin = margin[1] + margin[3];
  var aspect = positionInfo.aspect;
  if (isNaN(width)) {
    width = containerWidth - right - horizontalMargin - left;
  }
  if (isNaN(height)) {
    height = containerHeight - bottom - verticalMargin - top;
  }
  if (aspect != null) {
    if (isNaN(width) && isNaN(height)) {
      if (aspect > containerWidth / containerHeight) {
        width = containerWidth * 0.8;
      } else {
        height = containerHeight * 0.8;
      }
    }
    if (isNaN(width)) {
      width = aspect * height;
    }
    if (isNaN(height)) {
      height = width / aspect;
    }
  }
  if (isNaN(left)) {
    left = containerWidth - right - width - horizontalMargin;
  }
  if (isNaN(top)) {
    top = containerHeight - bottom - height - verticalMargin;
  }
  switch (positionInfo.left || positionInfo.right) {
    case "center":
      left = containerWidth / 2 - width / 2 - margin[3];
      break;
    case "right":
      left = containerWidth - width - horizontalMargin;
      break;
  }
  switch (positionInfo.top || positionInfo.bottom) {
    case "middle":
    case "center":
      top = containerHeight / 2 - height / 2 - margin[0];
      break;
    case "bottom":
      top = containerHeight - height - verticalMargin;
      break;
  }
  left = left || 0;
  top = top || 0;
  if (isNaN(width)) {
    width = containerWidth - horizontalMargin - left - (right || 0);
  }
  if (isNaN(height)) {
    height = containerHeight - verticalMargin - top - (bottom || 0);
  }
  var rect = new BoundingRect$1(left + margin[3], top + margin[0], width, height);
  rect.margin = margin;
  return rect;
}
function positionElement(el, positionInfo, containerRect, margin, opt, out2) {
  var h = !opt || !opt.hv || opt.hv[0];
  var v4 = !opt || !opt.hv || opt.hv[1];
  var boundingMode = opt && opt.boundingMode || "all";
  out2 = out2 || el;
  out2.x = el.x;
  out2.y = el.y;
  if (!h && !v4) {
    return false;
  }
  var rect;
  if (boundingMode === "raw") {
    rect = el.type === "group" ? new BoundingRect$1(0, 0, +positionInfo.width || 0, +positionInfo.height || 0) : el.getBoundingRect();
  } else {
    rect = el.getBoundingRect();
    if (el.needLocalTransform()) {
      var transform2 = el.getLocalTransform();
      rect = rect.clone();
      rect.applyTransform(transform2);
    }
  }
  var layoutRect = getLayoutRect(defaults({
    width: rect.width,
    height: rect.height
  }, positionInfo), containerRect, margin);
  var dx = h ? layoutRect.x - rect.x : 0;
  var dy = v4 ? layoutRect.y - rect.y : 0;
  if (boundingMode === "raw") {
    out2.x = dx;
    out2.y = dy;
  } else {
    out2.x += dx;
    out2.y += dy;
  }
  if (out2 === el) {
    el.markRedraw();
  }
  return true;
}
function sizeCalculable(option, hvIdx) {
  return option[HV_NAMES[hvIdx][0]] != null || option[HV_NAMES[hvIdx][1]] != null && option[HV_NAMES[hvIdx][2]] != null;
}
function fetchLayoutMode(ins) {
  var layoutMode = ins.layoutMode || ins.constructor.layoutMode;
  return isObject$4(layoutMode) ? layoutMode : layoutMode ? {
    type: layoutMode
  } : null;
}
function mergeLayoutParam(targetOption, newOption, opt) {
  var ignoreSize = opt && opt.ignoreSize;
  !isArray$1(ignoreSize) && (ignoreSize = [ignoreSize, ignoreSize]);
  var hResult = merge2(HV_NAMES[0], 0);
  var vResult = merge2(HV_NAMES[1], 1);
  copy2(HV_NAMES[0], targetOption, hResult);
  copy2(HV_NAMES[1], targetOption, vResult);
  function merge2(names2, hvIdx) {
    var newParams = {};
    var newValueCount = 0;
    var merged = {};
    var mergedValueCount = 0;
    var enoughParamNumber = 2;
    each$e(names2, function(name) {
      merged[name] = targetOption[name];
    });
    each$e(names2, function(name) {
      hasProp(newOption, name) && (newParams[name] = merged[name] = newOption[name]);
      hasValue(newParams, name) && newValueCount++;
      hasValue(merged, name) && mergedValueCount++;
    });
    if (ignoreSize[hvIdx]) {
      if (hasValue(newOption, names2[1])) {
        merged[names2[2]] = null;
      } else if (hasValue(newOption, names2[2])) {
        merged[names2[1]] = null;
      }
      return merged;
    }
    if (mergedValueCount === enoughParamNumber || !newValueCount) {
      return merged;
    } else if (newValueCount >= enoughParamNumber) {
      return newParams;
    } else {
      for (var i = 0; i < names2.length; i++) {
        var name_1 = names2[i];
        if (!hasProp(newParams, name_1) && hasProp(targetOption, name_1)) {
          newParams[name_1] = targetOption[name_1];
          break;
        }
      }
      return newParams;
    }
  }
  function hasProp(obj, name) {
    return obj.hasOwnProperty(name);
  }
  function hasValue(obj, name) {
    return obj[name] != null && obj[name] !== "auto";
  }
  function copy2(names2, target, source) {
    each$e(names2, function(name) {
      target[name] = source[name];
    });
  }
}
function getLayoutParams(source) {
  return copyLayoutParams({}, source);
}
function copyLayoutParams(target, source) {
  source && target && each$e(LOCATION_PARAMS, function(name) {
    source.hasOwnProperty(name) && (target[name] = source[name]);
  });
  return target;
}
var inner$l = makeInner();
var ComponentModel = function(_super) {
  __extends(ComponentModel2, _super);
  function ComponentModel2(option, parentModel, ecModel) {
    var _this = _super.call(this, option, parentModel, ecModel) || this;
    _this.uid = getUID("ec_cpt_model");
    return _this;
  }
  ComponentModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  ComponentModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeModel = ecModel.getTheme();
    merge(option, themeModel.get(this.mainType));
    merge(option, this.getDefaultOption());
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  ComponentModel2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, option, layoutMode);
    }
  };
  ComponentModel2.prototype.optionUpdated = function(newCptOption, isInit) {
  };
  ComponentModel2.prototype.getDefaultOption = function() {
    var ctor = this.constructor;
    if (!isExtendedClass(ctor)) {
      return ctor.defaultOption;
    }
    var fields = inner$l(this);
    if (!fields.defaultOption) {
      var optList = [];
      var clz = ctor;
      while (clz) {
        var opt = clz.prototype.defaultOption;
        opt && optList.push(opt);
        clz = clz.superClass;
      }
      var defaultOption2 = {};
      for (var i = optList.length - 1; i >= 0; i--) {
        defaultOption2 = merge(defaultOption2, optList[i], true);
      }
      fields.defaultOption = defaultOption2;
    }
    return fields.defaultOption;
  };
  ComponentModel2.prototype.getReferringComponents = function(mainType, opt) {
    var indexKey = mainType + "Index";
    var idKey = mainType + "Id";
    return queryReferringComponents(this.ecModel, mainType, {
      index: this.get(indexKey, true),
      id: this.get(idKey, true)
    }, opt);
  };
  ComponentModel2.prototype.getBoxLayoutParams = function() {
    var boxLayoutModel = this;
    return {
      left: boxLayoutModel.get("left"),
      top: boxLayoutModel.get("top"),
      right: boxLayoutModel.get("right"),
      bottom: boxLayoutModel.get("bottom"),
      width: boxLayoutModel.get("width"),
      height: boxLayoutModel.get("height")
    };
  };
  ComponentModel2.prototype.getZLevelKey = function() {
    return "";
  };
  ComponentModel2.prototype.setZLevel = function(zlevel) {
    this.option.zlevel = zlevel;
  };
  ComponentModel2.protoInitialize = function() {
    var proto2 = ComponentModel2.prototype;
    proto2.type = "component";
    proto2.id = "";
    proto2.name = "";
    proto2.mainType = "";
    proto2.subType = "";
    proto2.componentIndex = 0;
  }();
  return ComponentModel2;
}(Model$1);
mountExtend(ComponentModel, Model$1);
enableClassManagement(ComponentModel);
enableSubTypeDefaulter(ComponentModel);
enableTopologicalTravel(ComponentModel, getDependencies);
function getDependencies(componentType) {
  var deps = [];
  each$f(ComponentModel.getClassesByMainType(componentType), function(clz) {
    deps = deps.concat(clz.dependencies || clz.prototype.dependencies || []);
  });
  deps = map$1(deps, function(type4) {
    return parseClassType(type4).main;
  });
  if (componentType !== "dataset" && indexOf(deps, "dataset") <= 0) {
    deps.unshift("dataset");
  }
  return deps;
}
var ComponentModel$1 = ComponentModel;
var platform = "";
if (typeof navigator !== "undefined") {
  platform = navigator.platform || "";
}
var decalColor = "rgba(0, 0, 0, 0.2)";
var globalDefault = {
  darkMode: "auto",
  colorBy: "series",
  color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"],
  gradientColor: ["#f6efa6", "#d88273", "#bf444c"],
  aria: {
    decal: {
      decals: [{
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [2, 5],
        symbolSize: 1,
        rotation: Math.PI / 6
      }, {
        color: decalColor,
        symbol: "circle",
        dashArrayX: [[8, 8], [0, 8, 8, 0]],
        dashArrayY: [6, 0],
        symbolSize: 0.8
      }, {
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [4, 3],
        rotation: -Math.PI / 4
      }, {
        color: decalColor,
        dashArrayX: [[6, 6], [0, 6, 6, 0]],
        dashArrayY: [6, 0]
      }, {
        color: decalColor,
        dashArrayX: [[1, 0], [1, 6]],
        dashArrayY: [1, 0, 6, 0],
        rotation: Math.PI / 4
      }, {
        color: decalColor,
        symbol: "triangle",
        dashArrayX: [[9, 9], [0, 9, 9, 0]],
        dashArrayY: [7, 2],
        symbolSize: 0.75
      }]
    }
  },
  textStyle: {
    fontFamily: platform.match(/^Win/) ? "Microsoft YaHei" : "sans-serif",
    fontSize: 12,
    fontStyle: "normal",
    fontWeight: "normal"
  },
  blendMode: null,
  stateAnimation: {
    duration: 300,
    easing: "cubicOut"
  },
  animation: "auto",
  animationDuration: 1e3,
  animationDurationUpdate: 500,
  animationEasing: "cubicInOut",
  animationEasingUpdate: "cubicInOut",
  animationThreshold: 2e3,
  progressiveThreshold: 3e3,
  progressive: 400,
  hoverLayerThreshold: 3e3,
  useUTC: false
};
var VISUAL_DIMENSIONS = createHashMap(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]);
var SOURCE_FORMAT_ORIGINAL = "original";
var SOURCE_FORMAT_ARRAY_ROWS = "arrayRows";
var SOURCE_FORMAT_OBJECT_ROWS = "objectRows";
var SOURCE_FORMAT_KEYED_COLUMNS = "keyedColumns";
var SOURCE_FORMAT_TYPED_ARRAY = "typedArray";
var SOURCE_FORMAT_UNKNOWN = "unknown";
var SERIES_LAYOUT_BY_COLUMN = "column";
var SERIES_LAYOUT_BY_ROW = "row";
var BE_ORDINAL = {
  Must: 1,
  Might: 2,
  Not: 3
};
var innerGlobalModel = makeInner();
function resetSourceDefaulter(ecModel) {
  innerGlobalModel(ecModel).datasetMap = createHashMap();
}
function makeSeriesEncodeForAxisCoordSys(coordDimensions, seriesModel, source) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel || !coordDimensions) {
    return encode;
  }
  var encodeItemName = [];
  var encodeSeriesName = [];
  var ecModel = seriesModel.ecModel;
  var datasetMap = innerGlobalModel(ecModel).datasetMap;
  var key = datasetModel.uid + "_" + source.seriesLayoutBy;
  var baseCategoryDimIndex;
  var categoryWayValueDimStart;
  coordDimensions = coordDimensions.slice();
  each$f(coordDimensions, function(coordDimInfoLoose, coordDimIdx) {
    var coordDimInfo = isObject$4(coordDimInfoLoose) ? coordDimInfoLoose : coordDimensions[coordDimIdx] = {
      name: coordDimInfoLoose
    };
    if (coordDimInfo.type === "ordinal" && baseCategoryDimIndex == null) {
      baseCategoryDimIndex = coordDimIdx;
      categoryWayValueDimStart = getDataDimCountOnCoordDim(coordDimInfo);
    }
    encode[coordDimInfo.name] = [];
  });
  var datasetRecord = datasetMap.get(key) || datasetMap.set(key, {
    categoryWayDim: categoryWayValueDimStart,
    valueWayDim: 0
  });
  each$f(coordDimensions, function(coordDimInfo, coordDimIdx) {
    var coordDimName = coordDimInfo.name;
    var count2 = getDataDimCountOnCoordDim(coordDimInfo);
    if (baseCategoryDimIndex == null) {
      var start2 = datasetRecord.valueWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.valueWayDim += count2;
    } else if (baseCategoryDimIndex === coordDimIdx) {
      pushDim(encode[coordDimName], 0, count2);
      pushDim(encodeItemName, 0, count2);
    } else {
      var start2 = datasetRecord.categoryWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.categoryWayDim += count2;
    }
  });
  function pushDim(dimIdxArr, idxFrom, idxCount) {
    for (var i = 0; i < idxCount; i++) {
      dimIdxArr.push(idxFrom + i);
    }
  }
  function getDataDimCountOnCoordDim(coordDimInfo) {
    var dimsDef = coordDimInfo.dimsDef;
    return dimsDef ? dimsDef.length : 1;
  }
  encodeItemName.length && (encode.itemName = encodeItemName);
  encodeSeriesName.length && (encode.seriesName = encodeSeriesName);
  return encode;
}
function makeSeriesEncodeForNameBased(seriesModel, source, dimCount) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel) {
    return encode;
  }
  var sourceFormat = source.sourceFormat;
  var dimensionsDefine = source.dimensionsDefine;
  var potentialNameDimIndex;
  if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    each$f(dimensionsDefine, function(dim, idx) {
      if ((isObject$4(dim) ? dim.name : dim) === "name") {
        potentialNameDimIndex = idx;
      }
    });
  }
  var idxResult = function() {
    var idxRes0 = {};
    var idxRes1 = {};
    var guessRecords = [];
    for (var i = 0, len2 = Math.min(5, dimCount); i < len2; i++) {
      var guessResult = doGuessOrdinal(source.data, sourceFormat, source.seriesLayoutBy, dimensionsDefine, source.startIndex, i);
      guessRecords.push(guessResult);
      var isPureNumber = guessResult === BE_ORDINAL.Not;
      if (isPureNumber && idxRes0.v == null && i !== potentialNameDimIndex) {
        idxRes0.v = i;
      }
      if (idxRes0.n == null || idxRes0.n === idxRes0.v || !isPureNumber && guessRecords[idxRes0.n] === BE_ORDINAL.Not) {
        idxRes0.n = i;
      }
      if (fulfilled(idxRes0) && guessRecords[idxRes0.n] !== BE_ORDINAL.Not) {
        return idxRes0;
      }
      if (!isPureNumber) {
        if (guessResult === BE_ORDINAL.Might && idxRes1.v == null && i !== potentialNameDimIndex) {
          idxRes1.v = i;
        }
        if (idxRes1.n == null || idxRes1.n === idxRes1.v) {
          idxRes1.n = i;
        }
      }
    }
    function fulfilled(idxResult2) {
      return idxResult2.v != null && idxResult2.n != null;
    }
    return fulfilled(idxRes0) ? idxRes0 : fulfilled(idxRes1) ? idxRes1 : null;
  }();
  if (idxResult) {
    encode.value = [idxResult.v];
    var nameDimIndex = potentialNameDimIndex != null ? potentialNameDimIndex : idxResult.n;
    encode.itemName = [nameDimIndex];
    encode.seriesName = [nameDimIndex];
  }
  return encode;
}
function querySeriesUpstreamDatasetModel(seriesModel) {
  var thisData = seriesModel.get("data", true);
  if (!thisData) {
    return queryReferringComponents(seriesModel.ecModel, "dataset", {
      index: seriesModel.get("datasetIndex", true),
      id: seriesModel.get("datasetId", true)
    }, SINGLE_REFERRING).models[0];
  }
}
function queryDatasetUpstreamDatasetModels(datasetModel) {
  if (!datasetModel.get("transform", true) && !datasetModel.get("fromTransformResult", true)) {
    return [];
  }
  return queryReferringComponents(datasetModel.ecModel, "dataset", {
    index: datasetModel.get("fromDatasetIndex", true),
    id: datasetModel.get("fromDatasetId", true)
  }, SINGLE_REFERRING).models;
}
function guessOrdinal(source, dimIndex) {
  return doGuessOrdinal(source.data, source.sourceFormat, source.seriesLayoutBy, source.dimensionsDefine, source.startIndex, dimIndex);
}
function doGuessOrdinal(data, sourceFormat, seriesLayoutBy, dimensionsDefine, startIndex, dimIndex) {
  var result;
  var maxLoop = 5;
  if (isTypedArray(data)) {
    return BE_ORDINAL.Not;
  }
  var dimName;
  var dimType;
  if (dimensionsDefine) {
    var dimDefItem = dimensionsDefine[dimIndex];
    if (isObject$4(dimDefItem)) {
      dimName = dimDefItem.name;
      dimType = dimDefItem.type;
    } else if (isString(dimDefItem)) {
      dimName = dimDefItem;
    }
  }
  if (dimType != null) {
    return dimType === "ordinal" ? BE_ORDINAL.Must : BE_ORDINAL.Not;
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
      var sample = dataArrayRows[dimIndex];
      for (var i = 0; i < (sample || []).length && i < maxLoop; i++) {
        if ((result = detectValue(sample[startIndex + i])) != null) {
          return result;
        }
      }
    } else {
      for (var i = 0; i < dataArrayRows.length && i < maxLoop; i++) {
        var row = dataArrayRows[startIndex + i];
        if (row && (result = detectValue(row[dimIndex])) != null) {
          return result;
        }
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var dataObjectRows = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < dataObjectRows.length && i < maxLoop; i++) {
      var item = dataObjectRows[i];
      if (item && (result = detectValue(item[dimName])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    var dataKeyedColumns = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    var sample = dataKeyedColumns[dimName];
    if (!sample || isTypedArray(sample)) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < sample.length && i < maxLoop; i++) {
      if ((result = detectValue(sample[i])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var dataOriginal = data;
    for (var i = 0; i < dataOriginal.length && i < maxLoop; i++) {
      var item = dataOriginal[i];
      var val = getDataItemValue(item);
      if (!isArray$1(val)) {
        return BE_ORDINAL.Not;
      }
      if ((result = detectValue(val[dimIndex])) != null) {
        return result;
      }
    }
  }
  function detectValue(val2) {
    var beStr = isString(val2);
    if (val2 != null && isFinite(val2) && val2 !== "") {
      return beStr ? BE_ORDINAL.Might : BE_ORDINAL.Not;
    } else if (beStr && val2 !== "-") {
      return BE_ORDINAL.Must;
    }
  }
  return BE_ORDINAL.Not;
}
var internalOptionCreatorMap = createHashMap();
function registerInternalOptionCreator(mainType, creator) {
  assert(internalOptionCreatorMap.get(mainType) == null && creator);
  internalOptionCreatorMap.set(mainType, creator);
}
function concatInternalOptions(ecModel, mainType, newCmptOptionList) {
  var internalOptionCreator = internalOptionCreatorMap.get(mainType);
  if (!internalOptionCreator) {
    return newCmptOptionList;
  }
  var internalOptions = internalOptionCreator(ecModel);
  if (!internalOptions) {
    return newCmptOptionList;
  }
  return newCmptOptionList.concat(internalOptions);
}
var innerColor = makeInner();
var innerDecal = makeInner();
var PaletteMixin = function() {
  function PaletteMixin2() {
  }
  PaletteMixin2.prototype.getColorFromPalette = function(name, scope, requestNum) {
    var defaultPalette = normalizeToArray(this.get("color", true));
    var layeredPalette = this.get("colorLayer", true);
    return getFromPalette(this, innerColor, defaultPalette, layeredPalette, name, scope, requestNum);
  };
  PaletteMixin2.prototype.clearColorPalette = function() {
    clearPalette(this, innerColor);
  };
  return PaletteMixin2;
}();
function getDecalFromPalette(ecModel, name, scope, requestNum) {
  var defaultDecals = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  return getFromPalette(ecModel, innerDecal, defaultDecals, null, name, scope, requestNum);
}
function getNearestPalette(palettes, requestColorNum) {
  var paletteNum = palettes.length;
  for (var i = 0; i < paletteNum; i++) {
    if (palettes[i].length > requestColorNum) {
      return palettes[i];
    }
  }
  return palettes[paletteNum - 1];
}
function getFromPalette(that, inner2, defaultPalette, layeredPalette, name, scope, requestNum) {
  scope = scope || that;
  var scopeFields = inner2(scope);
  var paletteIdx = scopeFields.paletteIdx || 0;
  var paletteNameMap = scopeFields.paletteNameMap = scopeFields.paletteNameMap || {};
  if (paletteNameMap.hasOwnProperty(name)) {
    return paletteNameMap[name];
  }
  var palette = requestNum == null || !layeredPalette ? defaultPalette : getNearestPalette(layeredPalette, requestNum);
  palette = palette || defaultPalette;
  if (!palette || !palette.length) {
    return;
  }
  var pickedPaletteItem = palette[paletteIdx];
  if (name) {
    paletteNameMap[name] = pickedPaletteItem;
  }
  scopeFields.paletteIdx = (paletteIdx + 1) % palette.length;
  return pickedPaletteItem;
}
function clearPalette(that, inner2) {
  inner2(that).paletteIdx = 0;
  inner2(that).paletteNameMap = {};
}
var reCreateSeriesIndices;
var assertSeriesInitialized;
var initBase;
var OPTION_INNER_KEY = "\0_ec_inner";
var OPTION_INNER_VALUE = 1;
var GlobalModel = function(_super) {
  __extends(GlobalModel2, _super);
  function GlobalModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GlobalModel2.prototype.init = function(option, parentModel, ecModel, theme2, locale2, optionManager) {
    theme2 = theme2 || {};
    this.option = null;
    this._theme = new Model$1(theme2);
    this._locale = new Model$1(locale2);
    this._optionManager = optionManager;
  };
  GlobalModel2.prototype.setOption = function(option, opts, optionPreprocessorFuncs2) {
    var innerOpt = normalizeSetOptionInput(opts);
    this._optionManager.setOption(option, optionPreprocessorFuncs2, innerOpt);
    this._resetOption(null, innerOpt);
  };
  GlobalModel2.prototype.resetOption = function(type4, opt) {
    return this._resetOption(type4, normalizeSetOptionInput(opt));
  };
  GlobalModel2.prototype._resetOption = function(type4, opt) {
    var optionChanged = false;
    var optionManager = this._optionManager;
    if (!type4 || type4 === "recreate") {
      var baseOption = optionManager.mountOption(type4 === "recreate");
      if (!this.option || type4 === "recreate") {
        initBase(this, baseOption);
      } else {
        this.restoreData();
        this._mergeOption(baseOption, opt);
      }
      optionChanged = true;
    }
    if (type4 === "timeline" || type4 === "media") {
      this.restoreData();
    }
    if (!type4 || type4 === "recreate" || type4 === "timeline") {
      var timelineOption = optionManager.getTimelineOption(this);
      if (timelineOption) {
        optionChanged = true;
        this._mergeOption(timelineOption, opt);
      }
    }
    if (!type4 || type4 === "recreate" || type4 === "media") {
      var mediaOptions = optionManager.getMediaOption(this);
      if (mediaOptions.length) {
        each$f(mediaOptions, function(mediaOption) {
          optionChanged = true;
          this._mergeOption(mediaOption, opt);
        }, this);
      }
    }
    return optionChanged;
  };
  GlobalModel2.prototype.mergeOption = function(option) {
    this._mergeOption(option, null);
  };
  GlobalModel2.prototype._mergeOption = function(newOption, opt) {
    var option = this.option;
    var componentsMap = this._componentsMap;
    var componentsCount = this._componentsCount;
    var newCmptTypes = [];
    var newCmptTypeMap = createHashMap();
    var replaceMergeMainTypeMap = opt && opt.replaceMergeMainTypeMap;
    resetSourceDefaulter(this);
    each$f(newOption, function(componentOption, mainType) {
      if (componentOption == null) {
        return;
      }
      if (!ComponentModel$1.hasClass(mainType)) {
        option[mainType] = option[mainType] == null ? clone$4(componentOption) : merge(option[mainType], componentOption, true);
      } else if (mainType) {
        newCmptTypes.push(mainType);
        newCmptTypeMap.set(mainType, true);
      }
    });
    if (replaceMergeMainTypeMap) {
      replaceMergeMainTypeMap.each(function(val, mainTypeInReplaceMerge) {
        if (ComponentModel$1.hasClass(mainTypeInReplaceMerge) && !newCmptTypeMap.get(mainTypeInReplaceMerge)) {
          newCmptTypes.push(mainTypeInReplaceMerge);
          newCmptTypeMap.set(mainTypeInReplaceMerge, true);
        }
      });
    }
    ComponentModel$1.topologicalTravel(newCmptTypes, ComponentModel$1.getAllClassMainTypes(), visitComponent, this);
    function visitComponent(mainType) {
      var newCmptOptionList = concatInternalOptions(this, mainType, normalizeToArray(newOption[mainType]));
      var oldCmptList = componentsMap.get(mainType);
      var mergeMode = !oldCmptList ? "replaceAll" : replaceMergeMainTypeMap && replaceMergeMainTypeMap.get(mainType) ? "replaceMerge" : "normalMerge";
      var mappingResult = mappingToExists(oldCmptList, newCmptOptionList, mergeMode);
      setComponentTypeToKeyInfo(mappingResult, mainType, ComponentModel$1);
      option[mainType] = null;
      componentsMap.set(mainType, null);
      componentsCount.set(mainType, 0);
      var optionsByMainType = [];
      var cmptsByMainType = [];
      var cmptsCountByMainType = 0;
      var tooltipExists;
      each$f(mappingResult, function(resultItem, index2) {
        var componentModel = resultItem.existing;
        var newCmptOption = resultItem.newOption;
        if (!newCmptOption) {
          if (componentModel) {
            componentModel.mergeOption({}, this);
            componentModel.optionUpdated({}, false);
          }
        } else {
          var isSeriesType = mainType === "series";
          var ComponentModelClass = ComponentModel$1.getClass(mainType, resultItem.keyInfo.subType, !isSeriesType);
          if (!ComponentModelClass) {
            return;
          }
          if (mainType === "tooltip") {
            if (tooltipExists) {
              return;
            }
            tooltipExists = true;
          }
          if (componentModel && componentModel.constructor === ComponentModelClass) {
            componentModel.name = resultItem.keyInfo.name;
            componentModel.mergeOption(newCmptOption, this);
            componentModel.optionUpdated(newCmptOption, false);
          } else {
            var extraOpt = extend({
              componentIndex: index2
            }, resultItem.keyInfo);
            componentModel = new ComponentModelClass(newCmptOption, this, this, extraOpt);
            extend(componentModel, extraOpt);
            if (resultItem.brandNew) {
              componentModel.__requireNewView = true;
            }
            componentModel.init(newCmptOption, this, this);
            componentModel.optionUpdated(null, true);
          }
        }
        if (componentModel) {
          optionsByMainType.push(componentModel.option);
          cmptsByMainType.push(componentModel);
          cmptsCountByMainType++;
        } else {
          optionsByMainType.push(void 0);
          cmptsByMainType.push(void 0);
        }
      }, this);
      option[mainType] = optionsByMainType;
      componentsMap.set(mainType, cmptsByMainType);
      componentsCount.set(mainType, cmptsCountByMainType);
      if (mainType === "series") {
        reCreateSeriesIndices(this);
      }
    }
    if (!this._seriesIndices) {
      reCreateSeriesIndices(this);
    }
  };
  GlobalModel2.prototype.getOption = function() {
    var option = clone$4(this.option);
    each$f(option, function(optInMainType, mainType) {
      if (ComponentModel$1.hasClass(mainType)) {
        var opts = normalizeToArray(optInMainType);
        var realLen = opts.length;
        var metNonInner = false;
        for (var i = realLen - 1; i >= 0; i--) {
          if (opts[i] && !isComponentIdInternal(opts[i])) {
            metNonInner = true;
          } else {
            opts[i] = null;
            !metNonInner && realLen--;
          }
        }
        opts.length = realLen;
        option[mainType] = opts;
      }
    });
    delete option[OPTION_INNER_KEY];
    return option;
  };
  GlobalModel2.prototype.getTheme = function() {
    return this._theme;
  };
  GlobalModel2.prototype.getLocaleModel = function() {
    return this._locale;
  };
  GlobalModel2.prototype.setUpdatePayload = function(payload) {
    this._payload = payload;
  };
  GlobalModel2.prototype.getUpdatePayload = function() {
    return this._payload;
  };
  GlobalModel2.prototype.getComponent = function(mainType, idx) {
    var list = this._componentsMap.get(mainType);
    if (list) {
      var cmpt = list[idx || 0];
      if (cmpt) {
        return cmpt;
      } else if (idx == null) {
        for (var i = 0; i < list.length; i++) {
          if (list[i]) {
            return list[i];
          }
        }
      }
    }
  };
  GlobalModel2.prototype.queryComponents = function(condition) {
    var mainType = condition.mainType;
    if (!mainType) {
      return [];
    }
    var index2 = condition.index;
    var id2 = condition.id;
    var name = condition.name;
    var cmpts = this._componentsMap.get(mainType);
    if (!cmpts || !cmpts.length) {
      return [];
    }
    var result;
    if (index2 != null) {
      result = [];
      each$f(normalizeToArray(index2), function(idx) {
        cmpts[idx] && result.push(cmpts[idx]);
      });
    } else if (id2 != null) {
      result = queryByIdOrName("id", id2, cmpts);
    } else if (name != null) {
      result = queryByIdOrName("name", name, cmpts);
    } else {
      result = filter(cmpts, function(cmpt) {
        return !!cmpt;
      });
    }
    return filterBySubType(result, condition);
  };
  GlobalModel2.prototype.findComponents = function(condition) {
    var query = condition.query;
    var mainType = condition.mainType;
    var queryCond = getQueryCond(query);
    var result = queryCond ? this.queryComponents(queryCond) : filter(this._componentsMap.get(mainType), function(cmpt) {
      return !!cmpt;
    });
    return doFilter(filterBySubType(result, condition));
    function getQueryCond(q2) {
      var indexAttr = mainType + "Index";
      var idAttr = mainType + "Id";
      var nameAttr = mainType + "Name";
      return q2 && (q2[indexAttr] != null || q2[idAttr] != null || q2[nameAttr] != null) ? {
        mainType,
        index: q2[indexAttr],
        id: q2[idAttr],
        name: q2[nameAttr]
      } : null;
    }
    function doFilter(res) {
      return condition.filter ? filter(res, condition.filter) : res;
    }
  };
  GlobalModel2.prototype.eachComponent = function(mainType, cb, context) {
    var componentsMap = this._componentsMap;
    if (isFunction(mainType)) {
      var ctxForAll_1 = cb;
      var cbForAll_1 = mainType;
      componentsMap.each(function(cmpts2, componentType) {
        for (var i2 = 0; cmpts2 && i2 < cmpts2.length; i2++) {
          var cmpt2 = cmpts2[i2];
          cmpt2 && cbForAll_1.call(ctxForAll_1, componentType, cmpt2, cmpt2.componentIndex);
        }
      });
    } else {
      var cmpts = isString(mainType) ? componentsMap.get(mainType) : isObject$4(mainType) ? this.findComponents(mainType) : null;
      for (var i = 0; cmpts && i < cmpts.length; i++) {
        var cmpt = cmpts[i];
        cmpt && cb.call(context, cmpt, cmpt.componentIndex);
      }
    }
  };
  GlobalModel2.prototype.getSeriesByName = function(name) {
    var nameStr = convertOptionIdName(name, null);
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && nameStr != null && oneSeries.name === nameStr;
    });
  };
  GlobalModel2.prototype.getSeriesByIndex = function(seriesIndex) {
    return this._componentsMap.get("series")[seriesIndex];
  };
  GlobalModel2.prototype.getSeriesByType = function(subType) {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && oneSeries.subType === subType;
    });
  };
  GlobalModel2.prototype.getSeries = function() {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries;
    });
  };
  GlobalModel2.prototype.getSeriesCount = function() {
    return this._componentsCount.get("series");
  };
  GlobalModel2.prototype.eachSeries = function(cb, context) {
    assertSeriesInitialized(this);
    each$f(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      cb.call(context, series, rawSeriesIndex);
    }, this);
  };
  GlobalModel2.prototype.eachRawSeries = function(cb, context) {
    each$f(this._componentsMap.get("series"), function(series) {
      series && cb.call(context, series, series.componentIndex);
    });
  };
  GlobalModel2.prototype.eachSeriesByType = function(subType, cb, context) {
    assertSeriesInitialized(this);
    each$f(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      if (series.subType === subType) {
        cb.call(context, series, rawSeriesIndex);
      }
    }, this);
  };
  GlobalModel2.prototype.eachRawSeriesByType = function(subType, cb, context) {
    return each$f(this.getSeriesByType(subType), cb, context);
  };
  GlobalModel2.prototype.isSeriesFiltered = function(seriesModel) {
    assertSeriesInitialized(this);
    return this._seriesIndicesMap.get(seriesModel.componentIndex) == null;
  };
  GlobalModel2.prototype.getCurrentSeriesIndices = function() {
    return (this._seriesIndices || []).slice();
  };
  GlobalModel2.prototype.filterSeries = function(cb, context) {
    assertSeriesInitialized(this);
    var newSeriesIndices = [];
    each$f(this._seriesIndices, function(seriesRawIdx) {
      var series = this._componentsMap.get("series")[seriesRawIdx];
      cb.call(context, series, seriesRawIdx) && newSeriesIndices.push(seriesRawIdx);
    }, this);
    this._seriesIndices = newSeriesIndices;
    this._seriesIndicesMap = createHashMap(newSeriesIndices);
  };
  GlobalModel2.prototype.restoreData = function(payload) {
    reCreateSeriesIndices(this);
    var componentsMap = this._componentsMap;
    var componentTypes = [];
    componentsMap.each(function(components, componentType) {
      if (ComponentModel$1.hasClass(componentType)) {
        componentTypes.push(componentType);
      }
    });
    ComponentModel$1.topologicalTravel(componentTypes, ComponentModel$1.getAllClassMainTypes(), function(componentType) {
      each$f(componentsMap.get(componentType), function(component) {
        if (component && (componentType !== "series" || !isNotTargetSeries(component, payload))) {
          component.restoreData();
        }
      });
    });
  };
  GlobalModel2.internalField = function() {
    reCreateSeriesIndices = function(ecModel) {
      var seriesIndices = ecModel._seriesIndices = [];
      each$f(ecModel._componentsMap.get("series"), function(series) {
        series && seriesIndices.push(series.componentIndex);
      });
      ecModel._seriesIndicesMap = createHashMap(seriesIndices);
    };
    assertSeriesInitialized = function(ecModel) {
    };
    initBase = function(ecModel, baseOption) {
      ecModel.option = {};
      ecModel.option[OPTION_INNER_KEY] = OPTION_INNER_VALUE;
      ecModel._componentsMap = createHashMap({
        series: []
      });
      ecModel._componentsCount = createHashMap();
      var airaOption = baseOption.aria;
      if (isObject$4(airaOption) && airaOption.enabled == null) {
        airaOption.enabled = true;
      }
      mergeTheme(baseOption, ecModel._theme.option);
      merge(baseOption, globalDefault, false);
      ecModel._mergeOption(baseOption, null);
    };
  }();
  return GlobalModel2;
}(Model$1);
function isNotTargetSeries(seriesModel, payload) {
  if (payload) {
    var index2 = payload.seriesIndex;
    var id2 = payload.seriesId;
    var name_1 = payload.seriesName;
    return index2 != null && seriesModel.componentIndex !== index2 || id2 != null && seriesModel.id !== id2 || name_1 != null && seriesModel.name !== name_1;
  }
}
function mergeTheme(option, theme2) {
  var notMergeColorLayer = option.color && !option.colorLayer;
  each$f(theme2, function(themeItem, name) {
    if (name === "colorLayer" && notMergeColorLayer) {
      return;
    }
    if (!ComponentModel$1.hasClass(name)) {
      if (typeof themeItem === "object") {
        option[name] = !option[name] ? clone$4(themeItem) : merge(option[name], themeItem, false);
      } else {
        if (option[name] == null) {
          option[name] = themeItem;
        }
      }
    }
  });
}
function queryByIdOrName(attr, idOrName, cmpts) {
  if (isArray$1(idOrName)) {
    var keyMap_1 = createHashMap();
    each$f(idOrName, function(idOrNameItem) {
      if (idOrNameItem != null) {
        var idName = convertOptionIdName(idOrNameItem, null);
        idName != null && keyMap_1.set(idOrNameItem, true);
      }
    });
    return filter(cmpts, function(cmpt) {
      return cmpt && keyMap_1.get(cmpt[attr]);
    });
  } else {
    var idName_1 = convertOptionIdName(idOrName, null);
    return filter(cmpts, function(cmpt) {
      return cmpt && idName_1 != null && cmpt[attr] === idName_1;
    });
  }
}
function filterBySubType(components, condition) {
  return condition.hasOwnProperty("subType") ? filter(components, function(cmpt) {
    return cmpt && cmpt.subType === condition.subType;
  }) : components;
}
function normalizeSetOptionInput(opts) {
  var replaceMergeMainTypeMap = createHashMap();
  opts && each$f(normalizeToArray(opts.replaceMerge), function(mainType) {
    replaceMergeMainTypeMap.set(mainType, true);
  });
  return {
    replaceMergeMainTypeMap
  };
}
mixin(GlobalModel, PaletteMixin);
var GlobalModel$1 = GlobalModel;
var availableMethods = [
  "getDom",
  "getZr",
  "getWidth",
  "getHeight",
  "getDevicePixelRatio",
  "dispatchAction",
  "isSSR",
  "isDisposed",
  "on",
  "off",
  "getDataURL",
  "getConnectedDataURL",
  "getOption",
  "getId",
  "updateLabelLayout"
];
var ExtensionAPI = function() {
  function ExtensionAPI2(ecInstance) {
    each$f(availableMethods, function(methodName) {
      this[methodName] = bind$1(ecInstance[methodName], ecInstance);
    }, this);
  }
  return ExtensionAPI2;
}();
var ExtensionAPI$1 = ExtensionAPI;
var coordinateSystemCreators = {};
var CoordinateSystemManager = function() {
  function CoordinateSystemManager2() {
    this._coordinateSystems = [];
  }
  CoordinateSystemManager2.prototype.create = function(ecModel, api) {
    var coordinateSystems = [];
    each$f(coordinateSystemCreators, function(creater, type4) {
      var list = creater.create(ecModel, api);
      coordinateSystems = coordinateSystems.concat(list || []);
    });
    this._coordinateSystems = coordinateSystems;
  };
  CoordinateSystemManager2.prototype.update = function(ecModel, api) {
    each$f(this._coordinateSystems, function(coordSys) {
      coordSys.update && coordSys.update(ecModel, api);
    });
  };
  CoordinateSystemManager2.prototype.getCoordinateSystems = function() {
    return this._coordinateSystems.slice();
  };
  CoordinateSystemManager2.register = function(type4, creator) {
    coordinateSystemCreators[type4] = creator;
  };
  CoordinateSystemManager2.get = function(type4) {
    return coordinateSystemCreators[type4];
  };
  return CoordinateSystemManager2;
}();
var CoordinateSystem = CoordinateSystemManager;
var QUERY_REG = /^(min|max)?(.+)$/;
var OptionManager = function() {
  function OptionManager2(api) {
    this._timelineOptions = [];
    this._mediaList = [];
    this._currentMediaIndices = [];
    this._api = api;
  }
  OptionManager2.prototype.setOption = function(rawOption, optionPreprocessorFuncs2, opt) {
    if (rawOption) {
      each$f(normalizeToArray(rawOption.series), function(series) {
        series && series.data && isTypedArray(series.data) && setAsPrimitive(series.data);
      });
      each$f(normalizeToArray(rawOption.dataset), function(dataset) {
        dataset && dataset.source && isTypedArray(dataset.source) && setAsPrimitive(dataset.source);
      });
    }
    rawOption = clone$4(rawOption);
    var optionBackup = this._optionBackup;
    var newParsedOption = parseRawOption(rawOption, optionPreprocessorFuncs2, !optionBackup);
    this._newBaseOption = newParsedOption.baseOption;
    if (optionBackup) {
      if (newParsedOption.timelineOptions.length) {
        optionBackup.timelineOptions = newParsedOption.timelineOptions;
      }
      if (newParsedOption.mediaList.length) {
        optionBackup.mediaList = newParsedOption.mediaList;
      }
      if (newParsedOption.mediaDefault) {
        optionBackup.mediaDefault = newParsedOption.mediaDefault;
      }
    } else {
      this._optionBackup = newParsedOption;
    }
  };
  OptionManager2.prototype.mountOption = function(isRecreate) {
    var optionBackup = this._optionBackup;
    this._timelineOptions = optionBackup.timelineOptions;
    this._mediaList = optionBackup.mediaList;
    this._mediaDefault = optionBackup.mediaDefault;
    this._currentMediaIndices = [];
    return clone$4(isRecreate ? optionBackup.baseOption : this._newBaseOption);
  };
  OptionManager2.prototype.getTimelineOption = function(ecModel) {
    var option;
    var timelineOptions = this._timelineOptions;
    if (timelineOptions.length) {
      var timelineModel = ecModel.getComponent("timeline");
      if (timelineModel) {
        option = clone$4(timelineOptions[timelineModel.getCurrentIndex()]);
      }
    }
    return option;
  };
  OptionManager2.prototype.getMediaOption = function(ecModel) {
    var ecWidth = this._api.getWidth();
    var ecHeight = this._api.getHeight();
    var mediaList = this._mediaList;
    var mediaDefault = this._mediaDefault;
    var indices = [];
    var result = [];
    if (!mediaList.length && !mediaDefault) {
      return result;
    }
    for (var i = 0, len2 = mediaList.length; i < len2; i++) {
      if (applyMediaQuery(mediaList[i].query, ecWidth, ecHeight)) {
        indices.push(i);
      }
    }
    if (!indices.length && mediaDefault) {
      indices = [-1];
    }
    if (indices.length && !indicesEquals(indices, this._currentMediaIndices)) {
      result = map$1(indices, function(index2) {
        return clone$4(index2 === -1 ? mediaDefault.option : mediaList[index2].option);
      });
    }
    this._currentMediaIndices = indices;
    return result;
  };
  return OptionManager2;
}();
function parseRawOption(rawOption, optionPreprocessorFuncs2, isNew) {
  var mediaList = [];
  var mediaDefault;
  var baseOption;
  var declaredBaseOption = rawOption.baseOption;
  var timelineOnRoot = rawOption.timeline;
  var timelineOptionsOnRoot = rawOption.options;
  var mediaOnRoot = rawOption.media;
  var hasMedia = !!rawOption.media;
  var hasTimeline = !!(timelineOptionsOnRoot || timelineOnRoot || declaredBaseOption && declaredBaseOption.timeline);
  if (declaredBaseOption) {
    baseOption = declaredBaseOption;
    if (!baseOption.timeline) {
      baseOption.timeline = timelineOnRoot;
    }
  } else {
    if (hasTimeline || hasMedia) {
      rawOption.options = rawOption.media = null;
    }
    baseOption = rawOption;
  }
  if (hasMedia) {
    if (isArray$1(mediaOnRoot)) {
      each$f(mediaOnRoot, function(singleMedia) {
        if (singleMedia && singleMedia.option) {
          if (singleMedia.query) {
            mediaList.push(singleMedia);
          } else if (!mediaDefault) {
            mediaDefault = singleMedia;
          }
        }
      });
    }
  }
  doPreprocess(baseOption);
  each$f(timelineOptionsOnRoot, function(option) {
    return doPreprocess(option);
  });
  each$f(mediaList, function(media) {
    return doPreprocess(media.option);
  });
  function doPreprocess(option) {
    each$f(optionPreprocessorFuncs2, function(preProcess) {
      preProcess(option, isNew);
    });
  }
  return {
    baseOption,
    timelineOptions: timelineOptionsOnRoot || [],
    mediaDefault,
    mediaList
  };
}
function applyMediaQuery(query, ecWidth, ecHeight) {
  var realMap = {
    width: ecWidth,
    height: ecHeight,
    aspectratio: ecWidth / ecHeight
  };
  var applicatable = true;
  each$f(query, function(value, attr) {
    var matched = attr.match(QUERY_REG);
    if (!matched || !matched[1] || !matched[2]) {
      return;
    }
    var operator = matched[1];
    var realAttr = matched[2].toLowerCase();
    if (!compare(realMap[realAttr], value, operator)) {
      applicatable = false;
    }
  });
  return applicatable;
}
function compare(real, expect, operator) {
  if (operator === "min") {
    return real >= expect;
  } else if (operator === "max") {
    return real <= expect;
  } else {
    return real === expect;
  }
}
function indicesEquals(indices1, indices2) {
  return indices1.join(",") === indices2.join(",");
}
var OptionManager$1 = OptionManager;
var each$d = each$f;
var isObject$3 = isObject$4;
var POSSIBLE_STYLES = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
function compatEC2ItemStyle(opt) {
  var itemStyleOpt = opt && opt.itemStyle;
  if (!itemStyleOpt) {
    return;
  }
  for (var i = 0, len2 = POSSIBLE_STYLES.length; i < len2; i++) {
    var styleName = POSSIBLE_STYLES[i];
    var normalItemStyleOpt = itemStyleOpt.normal;
    var emphasisItemStyleOpt = itemStyleOpt.emphasis;
    if (normalItemStyleOpt && normalItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].normal) {
        opt[styleName].normal = normalItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].normal, normalItemStyleOpt[styleName]);
      }
      normalItemStyleOpt[styleName] = null;
    }
    if (emphasisItemStyleOpt && emphasisItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].emphasis) {
        opt[styleName].emphasis = emphasisItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].emphasis, emphasisItemStyleOpt[styleName]);
      }
      emphasisItemStyleOpt[styleName] = null;
    }
  }
}
function convertNormalEmphasis(opt, optType, useExtend) {
  if (opt && opt[optType] && (opt[optType].normal || opt[optType].emphasis)) {
    var normalOpt = opt[optType].normal;
    var emphasisOpt = opt[optType].emphasis;
    if (normalOpt) {
      if (useExtend) {
        opt[optType].normal = opt[optType].emphasis = null;
        defaults(opt[optType], normalOpt);
      } else {
        opt[optType] = normalOpt;
      }
    }
    if (emphasisOpt) {
      opt.emphasis = opt.emphasis || {};
      opt.emphasis[optType] = emphasisOpt;
      if (emphasisOpt.focus) {
        opt.emphasis.focus = emphasisOpt.focus;
      }
      if (emphasisOpt.blurScope) {
        opt.emphasis.blurScope = emphasisOpt.blurScope;
      }
    }
  }
}
function removeEC3NormalStatus(opt) {
  convertNormalEmphasis(opt, "itemStyle");
  convertNormalEmphasis(opt, "lineStyle");
  convertNormalEmphasis(opt, "areaStyle");
  convertNormalEmphasis(opt, "label");
  convertNormalEmphasis(opt, "labelLine");
  convertNormalEmphasis(opt, "upperLabel");
  convertNormalEmphasis(opt, "edgeLabel");
}
function compatTextStyle(opt, propName) {
  var labelOptSingle = isObject$3(opt) && opt[propName];
  var textStyle = isObject$3(labelOptSingle) && labelOptSingle.textStyle;
  if (textStyle) {
    for (var i = 0, len2 = TEXT_STYLE_OPTIONS.length; i < len2; i++) {
      var textPropName = TEXT_STYLE_OPTIONS[i];
      if (textStyle.hasOwnProperty(textPropName)) {
        labelOptSingle[textPropName] = textStyle[textPropName];
      }
    }
  }
}
function compatEC3CommonStyles(opt) {
  if (opt) {
    removeEC3NormalStatus(opt);
    compatTextStyle(opt, "label");
    opt.emphasis && compatTextStyle(opt.emphasis, "label");
  }
}
function processSeries(seriesOpt) {
  if (!isObject$3(seriesOpt)) {
    return;
  }
  compatEC2ItemStyle(seriesOpt);
  removeEC3NormalStatus(seriesOpt);
  compatTextStyle(seriesOpt, "label");
  compatTextStyle(seriesOpt, "upperLabel");
  compatTextStyle(seriesOpt, "edgeLabel");
  if (seriesOpt.emphasis) {
    compatTextStyle(seriesOpt.emphasis, "label");
    compatTextStyle(seriesOpt.emphasis, "upperLabel");
    compatTextStyle(seriesOpt.emphasis, "edgeLabel");
  }
  var markPoint = seriesOpt.markPoint;
  if (markPoint) {
    compatEC2ItemStyle(markPoint);
    compatEC3CommonStyles(markPoint);
  }
  var markLine = seriesOpt.markLine;
  if (markLine) {
    compatEC2ItemStyle(markLine);
    compatEC3CommonStyles(markLine);
  }
  var markArea = seriesOpt.markArea;
  if (markArea) {
    compatEC3CommonStyles(markArea);
  }
  var data = seriesOpt.data;
  if (seriesOpt.type === "graph") {
    data = data || seriesOpt.nodes;
    var edgeData = seriesOpt.links || seriesOpt.edges;
    if (edgeData && !isTypedArray(edgeData)) {
      for (var i = 0; i < edgeData.length; i++) {
        compatEC3CommonStyles(edgeData[i]);
      }
    }
    each$f(seriesOpt.categories, function(opt) {
      removeEC3NormalStatus(opt);
    });
  }
  if (data && !isTypedArray(data)) {
    for (var i = 0; i < data.length; i++) {
      compatEC3CommonStyles(data[i]);
    }
  }
  markPoint = seriesOpt.markPoint;
  if (markPoint && markPoint.data) {
    var mpData = markPoint.data;
    for (var i = 0; i < mpData.length; i++) {
      compatEC3CommonStyles(mpData[i]);
    }
  }
  markLine = seriesOpt.markLine;
  if (markLine && markLine.data) {
    var mlData = markLine.data;
    for (var i = 0; i < mlData.length; i++) {
      if (isArray$1(mlData[i])) {
        compatEC3CommonStyles(mlData[i][0]);
        compatEC3CommonStyles(mlData[i][1]);
      } else {
        compatEC3CommonStyles(mlData[i]);
      }
    }
  }
  if (seriesOpt.type === "gauge") {
    compatTextStyle(seriesOpt, "axisLabel");
    compatTextStyle(seriesOpt, "title");
    compatTextStyle(seriesOpt, "detail");
  } else if (seriesOpt.type === "treemap") {
    convertNormalEmphasis(seriesOpt.breadcrumb, "itemStyle");
    each$f(seriesOpt.levels, function(opt) {
      removeEC3NormalStatus(opt);
    });
  } else if (seriesOpt.type === "tree") {
    removeEC3NormalStatus(seriesOpt.leaves);
  }
}
function toArr(o) {
  return isArray$1(o) ? o : o ? [o] : [];
}
function toObj(o) {
  return (isArray$1(o) ? o[0] : o) || {};
}
function globalCompatStyle(option, isTheme) {
  each$d(toArr(option.series), function(seriesOpt) {
    isObject$3(seriesOpt) && processSeries(seriesOpt);
  });
  var axes = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
  isTheme && axes.push("valueAxis", "categoryAxis", "logAxis", "timeAxis");
  each$d(axes, function(axisName) {
    each$d(toArr(option[axisName]), function(axisOpt) {
      if (axisOpt) {
        compatTextStyle(axisOpt, "axisLabel");
        compatTextStyle(axisOpt.axisPointer, "label");
      }
    });
  });
  each$d(toArr(option.parallel), function(parallelOpt) {
    var parallelAxisDefault = parallelOpt && parallelOpt.parallelAxisDefault;
    compatTextStyle(parallelAxisDefault, "axisLabel");
    compatTextStyle(parallelAxisDefault && parallelAxisDefault.axisPointer, "label");
  });
  each$d(toArr(option.calendar), function(calendarOpt) {
    convertNormalEmphasis(calendarOpt, "itemStyle");
    compatTextStyle(calendarOpt, "dayLabel");
    compatTextStyle(calendarOpt, "monthLabel");
    compatTextStyle(calendarOpt, "yearLabel");
  });
  each$d(toArr(option.radar), function(radarOpt) {
    compatTextStyle(radarOpt, "name");
    if (radarOpt.name && radarOpt.axisName == null) {
      radarOpt.axisName = radarOpt.name;
      delete radarOpt.name;
    }
    if (radarOpt.nameGap != null && radarOpt.axisNameGap == null) {
      radarOpt.axisNameGap = radarOpt.nameGap;
      delete radarOpt.nameGap;
    }
  });
  each$d(toArr(option.geo), function(geoOpt) {
    if (isObject$3(geoOpt)) {
      compatEC3CommonStyles(geoOpt);
      each$d(toArr(geoOpt.regions), function(regionObj) {
        compatEC3CommonStyles(regionObj);
      });
    }
  });
  each$d(toArr(option.timeline), function(timelineOpt) {
    compatEC3CommonStyles(timelineOpt);
    convertNormalEmphasis(timelineOpt, "label");
    convertNormalEmphasis(timelineOpt, "itemStyle");
    convertNormalEmphasis(timelineOpt, "controlStyle", true);
    var data = timelineOpt.data;
    isArray$1(data) && each$f(data, function(item) {
      if (isObject$4(item)) {
        convertNormalEmphasis(item, "label");
        convertNormalEmphasis(item, "itemStyle");
      }
    });
  });
  each$d(toArr(option.toolbox), function(toolboxOpt) {
    convertNormalEmphasis(toolboxOpt, "iconStyle");
    each$d(toolboxOpt.feature, function(featureOpt) {
      convertNormalEmphasis(featureOpt, "iconStyle");
    });
  });
  compatTextStyle(toObj(option.axisPointer), "label");
  compatTextStyle(toObj(option.tooltip).axisPointer, "label");
}
function get$1(opt, path) {
  var pathArr = path.split(",");
  var obj = opt;
  for (var i = 0; i < pathArr.length; i++) {
    obj = obj && obj[pathArr[i]];
    if (obj == null) {
      break;
    }
  }
  return obj;
}
function set$1(opt, path, val, overwrite) {
  var pathArr = path.split(",");
  var obj = opt;
  var key;
  var i = 0;
  for (; i < pathArr.length - 1; i++) {
    key = pathArr[i];
    if (obj[key] == null) {
      obj[key] = {};
    }
    obj = obj[key];
  }
  if (overwrite || obj[pathArr[i]] == null) {
    obj[pathArr[i]] = val;
  }
}
function compatLayoutProperties(option) {
  option && each$f(LAYOUT_PROPERTIES, function(prop) {
    if (prop[0] in option && !(prop[1] in option)) {
      option[prop[1]] = option[prop[0]];
    }
  });
}
var LAYOUT_PROPERTIES = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]];
var COMPATITABLE_COMPONENTS = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"];
var BAR_ITEM_STYLE_MAP = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
function compatBarItemStyle(option) {
  var itemStyle = option && option.itemStyle;
  if (itemStyle) {
    for (var i = 0; i < BAR_ITEM_STYLE_MAP.length; i++) {
      var oldName = BAR_ITEM_STYLE_MAP[i][1];
      var newName = BAR_ITEM_STYLE_MAP[i][0];
      if (itemStyle[oldName] != null) {
        itemStyle[newName] = itemStyle[oldName];
      }
    }
  }
}
function compatPieLabel(option) {
  if (!option) {
    return;
  }
  if (option.alignTo === "edge" && option.margin != null && option.edgeDistance == null) {
    option.edgeDistance = option.margin;
  }
}
function compatSunburstState(option) {
  if (!option) {
    return;
  }
  if (option.downplay && !option.blur) {
    option.blur = option.downplay;
  }
}
function compatGraphFocus(option) {
  if (!option) {
    return;
  }
  if (option.focusNodeAdjacency != null) {
    option.emphasis = option.emphasis || {};
    if (option.emphasis.focus == null) {
      option.emphasis.focus = "adjacency";
    }
  }
}
function traverseTree(data, cb) {
  if (data) {
    for (var i = 0; i < data.length; i++) {
      cb(data[i]);
      data[i] && traverseTree(data[i].children, cb);
    }
  }
}
function globalBackwardCompat(option, isTheme) {
  globalCompatStyle(option, isTheme);
  option.series = normalizeToArray(option.series);
  each$f(option.series, function(seriesOpt) {
    if (!isObject$4(seriesOpt)) {
      return;
    }
    var seriesType2 = seriesOpt.type;
    if (seriesType2 === "line") {
      if (seriesOpt.clipOverflow != null) {
        seriesOpt.clip = seriesOpt.clipOverflow;
      }
    } else if (seriesType2 === "pie" || seriesType2 === "gauge") {
      if (seriesOpt.clockWise != null) {
        seriesOpt.clockwise = seriesOpt.clockWise;
      }
      compatPieLabel(seriesOpt.label);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          compatPieLabel(data[i]);
        }
      }
      if (seriesOpt.hoverOffset != null) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (seriesOpt.emphasis.scaleSize = null) {
          seriesOpt.emphasis.scaleSize = seriesOpt.hoverOffset;
        }
      }
    } else if (seriesType2 === "gauge") {
      var pointerColor = get$1(seriesOpt, "pointer.color");
      pointerColor != null && set$1(seriesOpt, "itemStyle.color", pointerColor);
    } else if (seriesType2 === "bar") {
      compatBarItemStyle(seriesOpt);
      compatBarItemStyle(seriesOpt.backgroundStyle);
      compatBarItemStyle(seriesOpt.emphasis);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          if (typeof data[i] === "object") {
            compatBarItemStyle(data[i]);
            compatBarItemStyle(data[i] && data[i].emphasis);
          }
        }
      }
    } else if (seriesType2 === "sunburst") {
      var highlightPolicy = seriesOpt.highlightPolicy;
      if (highlightPolicy) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (!seriesOpt.emphasis.focus) {
          seriesOpt.emphasis.focus = highlightPolicy;
        }
      }
      compatSunburstState(seriesOpt);
      traverseTree(seriesOpt.data, compatSunburstState);
    } else if (seriesType2 === "graph" || seriesType2 === "sankey") {
      compatGraphFocus(seriesOpt);
    } else if (seriesType2 === "map") {
      if (seriesOpt.mapType && !seriesOpt.map) {
        seriesOpt.map = seriesOpt.mapType;
      }
      if (seriesOpt.mapLocation) {
        defaults(seriesOpt, seriesOpt.mapLocation);
      }
    }
    if (seriesOpt.hoverAnimation != null) {
      seriesOpt.emphasis = seriesOpt.emphasis || {};
      if (seriesOpt.emphasis && seriesOpt.emphasis.scale == null) {
        seriesOpt.emphasis.scale = seriesOpt.hoverAnimation;
      }
    }
    compatLayoutProperties(seriesOpt);
  });
  if (option.dataRange) {
    option.visualMap = option.dataRange;
  }
  each$f(COMPATITABLE_COMPONENTS, function(componentName) {
    var options = option[componentName];
    if (options) {
      if (!isArray$1(options)) {
        options = [options];
      }
      each$f(options, function(option2) {
        compatLayoutProperties(option2);
      });
    }
  });
}
function dataStack(ecModel) {
  var stackInfoMap = createHashMap();
  ecModel.eachSeries(function(seriesModel) {
    var stack = seriesModel.get("stack");
    if (stack) {
      var stackInfoList = stackInfoMap.get(stack) || stackInfoMap.set(stack, []);
      var data = seriesModel.getData();
      var stackInfo = {
        stackResultDimension: data.getCalculationInfo("stackResultDimension"),
        stackedOverDimension: data.getCalculationInfo("stackedOverDimension"),
        stackedDimension: data.getCalculationInfo("stackedDimension"),
        stackedByDimension: data.getCalculationInfo("stackedByDimension"),
        isStackedByIndex: data.getCalculationInfo("isStackedByIndex"),
        data,
        seriesModel
      };
      if (!stackInfo.stackedDimension || !(stackInfo.isStackedByIndex || stackInfo.stackedByDimension)) {
        return;
      }
      stackInfoList.length && data.setCalculationInfo("stackedOnSeries", stackInfoList[stackInfoList.length - 1].seriesModel);
      stackInfoList.push(stackInfo);
    }
  });
  stackInfoMap.each(calculateStack);
}
function calculateStack(stackInfoList) {
  each$f(stackInfoList, function(targetStackInfo, idxInStack) {
    var resultVal = [];
    var resultNaN = [NaN, NaN];
    var dims = [targetStackInfo.stackResultDimension, targetStackInfo.stackedOverDimension];
    var targetData = targetStackInfo.data;
    var isStackedByIndex = targetStackInfo.isStackedByIndex;
    targetData.modify(dims, function(v0, v12, dataIndex) {
      var sum2 = targetData.get(targetStackInfo.stackedDimension, dataIndex);
      if (isNaN(sum2)) {
        return resultNaN;
      }
      var byValue;
      var stackedDataRawIndex;
      if (isStackedByIndex) {
        stackedDataRawIndex = targetData.getRawIndex(dataIndex);
      } else {
        byValue = targetData.get(targetStackInfo.stackedByDimension, dataIndex);
      }
      var stackedOver = NaN;
      for (var j = idxInStack - 1; j >= 0; j--) {
        var stackInfo = stackInfoList[j];
        if (!isStackedByIndex) {
          stackedDataRawIndex = stackInfo.data.rawIndexOf(stackInfo.stackedByDimension, byValue);
        }
        if (stackedDataRawIndex >= 0) {
          var val = stackInfo.data.getByRawIndex(stackInfo.stackResultDimension, stackedDataRawIndex);
          if (sum2 >= 0 && val > 0 || sum2 <= 0 && val < 0) {
            sum2 = addSafe(sum2, val);
            stackedOver = val;
            break;
          }
        }
      }
      resultVal[0] = sum2;
      resultVal[1] = stackedOver;
      return resultVal;
    });
  });
}
var SourceImpl = function() {
  function SourceImpl2(fields) {
    this.data = fields.data || (fields.sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS ? {} : []);
    this.sourceFormat = fields.sourceFormat || SOURCE_FORMAT_UNKNOWN;
    this.seriesLayoutBy = fields.seriesLayoutBy || SERIES_LAYOUT_BY_COLUMN;
    this.startIndex = fields.startIndex || 0;
    this.dimensionsDetectedCount = fields.dimensionsDetectedCount;
    this.metaRawOption = fields.metaRawOption;
    var dimensionsDefine = this.dimensionsDefine = fields.dimensionsDefine;
    if (dimensionsDefine) {
      for (var i = 0; i < dimensionsDefine.length; i++) {
        var dim = dimensionsDefine[i];
        if (dim.type == null) {
          if (guessOrdinal(this, i) === BE_ORDINAL.Must) {
            dim.type = "ordinal";
          }
        }
      }
    }
  }
  return SourceImpl2;
}();
function isSourceInstance(val) {
  return val instanceof SourceImpl;
}
function createSource(sourceData, thisMetaRawOption, sourceFormat) {
  sourceFormat = sourceFormat || detectSourceFormat(sourceData);
  var seriesLayoutBy = thisMetaRawOption.seriesLayoutBy;
  var determined = determineSourceDimensions(sourceData, sourceFormat, seriesLayoutBy, thisMetaRawOption.sourceHeader, thisMetaRawOption.dimensions);
  var source = new SourceImpl({
    data: sourceData,
    sourceFormat,
    seriesLayoutBy,
    dimensionsDefine: determined.dimensionsDefine,
    startIndex: determined.startIndex,
    dimensionsDetectedCount: determined.dimensionsDetectedCount,
    metaRawOption: clone$4(thisMetaRawOption)
  });
  return source;
}
function createSourceFromSeriesDataOption(data) {
  return new SourceImpl({
    data,
    sourceFormat: isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL
  });
}
function cloneSourceShallow(source) {
  return new SourceImpl({
    data: source.data,
    sourceFormat: source.sourceFormat,
    seriesLayoutBy: source.seriesLayoutBy,
    dimensionsDefine: clone$4(source.dimensionsDefine),
    startIndex: source.startIndex,
    dimensionsDetectedCount: source.dimensionsDetectedCount
  });
}
function detectSourceFormat(data) {
  var sourceFormat = SOURCE_FORMAT_UNKNOWN;
  if (isTypedArray(data)) {
    sourceFormat = SOURCE_FORMAT_TYPED_ARRAY;
  } else if (isArray$1(data)) {
    if (data.length === 0) {
      sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
    }
    for (var i = 0, len2 = data.length; i < len2; i++) {
      var item = data[i];
      if (item == null) {
        continue;
      } else if (isArray$1(item)) {
        sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
        break;
      } else if (isObject$4(item)) {
        sourceFormat = SOURCE_FORMAT_OBJECT_ROWS;
        break;
      }
    }
  } else if (isObject$4(data)) {
    for (var key in data) {
      if (hasOwn(data, key) && isArrayLike(data[key])) {
        sourceFormat = SOURCE_FORMAT_KEYED_COLUMNS;
        break;
      }
    }
  }
  return sourceFormat;
}
function determineSourceDimensions(data, sourceFormat, seriesLayoutBy, sourceHeader, dimensionsDefine) {
  var dimensionsDetectedCount;
  var startIndex;
  if (!data) {
    return {
      dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
      startIndex,
      dimensionsDetectedCount
    };
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (sourceHeader === "auto" || sourceHeader == null) {
      arrayRowsTravelFirst(function(val) {
        if (val != null && val !== "-") {
          if (isString(val)) {
            startIndex == null && (startIndex = 1);
          } else {
            startIndex = 0;
          }
        }
      }, seriesLayoutBy, dataArrayRows, 10);
    } else {
      startIndex = isNumber(sourceHeader) ? sourceHeader : sourceHeader ? 1 : 0;
    }
    if (!dimensionsDefine && startIndex === 1) {
      dimensionsDefine = [];
      arrayRowsTravelFirst(function(val, index2) {
        dimensionsDefine[index2] = val != null ? val + "" : "";
      }, seriesLayoutBy, dataArrayRows, Infinity);
    }
    dimensionsDetectedCount = dimensionsDefine ? dimensionsDefine.length : seriesLayoutBy === SERIES_LAYOUT_BY_ROW ? dataArrayRows.length : dataArrayRows[0] ? dataArrayRows[0].length : null;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    if (!dimensionsDefine) {
      dimensionsDefine = objectRowsCollectDimensions(data);
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    if (!dimensionsDefine) {
      dimensionsDefine = [];
      each$f(data, function(colArr, key) {
        dimensionsDefine.push(key);
      });
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var value0 = getDataItemValue(data[0]);
    dimensionsDetectedCount = isArray$1(value0) && value0.length || 1;
  } else
    ;
  return {
    startIndex,
    dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
    dimensionsDetectedCount
  };
}
function objectRowsCollectDimensions(data) {
  var firstIndex = 0;
  var obj;
  while (firstIndex < data.length && !(obj = data[firstIndex++])) {
  }
  if (obj) {
    var dimensions_1 = [];
    each$f(obj, function(value, key) {
      dimensions_1.push(key);
    });
    return dimensions_1;
  }
}
function normalizeDimensionsOption(dimensionsDefine) {
  if (!dimensionsDefine) {
    return;
  }
  var nameMap = createHashMap();
  return map$1(dimensionsDefine, function(rawItem, index2) {
    rawItem = isObject$4(rawItem) ? rawItem : {
      name: rawItem
    };
    var item = {
      name: rawItem.name,
      displayName: rawItem.displayName,
      type: rawItem.type
    };
    if (item.name == null) {
      return item;
    }
    item.name += "";
    if (item.displayName == null) {
      item.displayName = item.name;
    }
    var exist = nameMap.get(item.name);
    if (!exist) {
      nameMap.set(item.name, {
        count: 1
      });
    } else {
      item.name += "-" + exist.count++;
    }
    return item;
  });
}
function arrayRowsTravelFirst(cb, seriesLayoutBy, data, maxLoop) {
  if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
    for (var i = 0; i < data.length && i < maxLoop; i++) {
      cb(data[i] ? data[i][0] : null, i);
    }
  } else {
    var value0 = data[0] || [];
    for (var i = 0; i < value0.length && i < maxLoop; i++) {
      cb(value0[i], i);
    }
  }
}
function shouldRetrieveDataByName(source) {
  var sourceFormat = source.sourceFormat;
  return sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS;
}
var _a, _b, _c;
var providerMethods;
var mountMethods;
var DefaultDataProvider = function() {
  function DefaultDataProvider2(sourceParam, dimSize) {
    var source = !isSourceInstance(sourceParam) ? createSourceFromSeriesDataOption(sourceParam) : sourceParam;
    this._source = source;
    var data = this._data = source.data;
    if (source.sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
      this._offset = 0;
      this._dimSize = dimSize;
      this._data = data;
    }
    mountMethods(this, data, source);
  }
  DefaultDataProvider2.prototype.getSource = function() {
    return this._source;
  };
  DefaultDataProvider2.prototype.count = function() {
    return 0;
  };
  DefaultDataProvider2.prototype.getItem = function(idx, out2) {
    return;
  };
  DefaultDataProvider2.prototype.appendData = function(newData) {
  };
  DefaultDataProvider2.prototype.clean = function() {
  };
  DefaultDataProvider2.protoInitialize = function() {
    var proto2 = DefaultDataProvider2.prototype;
    proto2.pure = false;
    proto2.persistent = true;
  }();
  DefaultDataProvider2.internalField = function() {
    var _a2;
    mountMethods = function(provider, data, source) {
      var sourceFormat = source.sourceFormat;
      var seriesLayoutBy = source.seriesLayoutBy;
      var startIndex = source.startIndex;
      var dimsDef = source.dimensionsDefine;
      var methods = providerMethods[getMethodMapKey(sourceFormat, seriesLayoutBy)];
      extend(provider, methods);
      if (sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
        provider.getItem = getItemForTypedArray;
        provider.count = countForTypedArray;
        provider.fillStorage = fillStorageForTypedArray;
      } else {
        var rawItemGetter = getRawSourceItemGetter(sourceFormat, seriesLayoutBy);
        provider.getItem = bind$1(rawItemGetter, null, data, startIndex, dimsDef);
        var rawCounter = getRawSourceDataCounter(sourceFormat, seriesLayoutBy);
        provider.count = bind$1(rawCounter, null, data, startIndex, dimsDef);
      }
    };
    var getItemForTypedArray = function(idx, out2) {
      idx = idx - this._offset;
      out2 = out2 || [];
      var data = this._data;
      var dimSize = this._dimSize;
      var offset = dimSize * idx;
      for (var i = 0; i < dimSize; i++) {
        out2[i] = data[offset + i];
      }
      return out2;
    };
    var fillStorageForTypedArray = function(start2, end2, storage2, extent3) {
      var data = this._data;
      var dimSize = this._dimSize;
      for (var dim = 0; dim < dimSize; dim++) {
        var dimExtent = extent3[dim];
        var min3 = dimExtent[0] == null ? Infinity : dimExtent[0];
        var max3 = dimExtent[1] == null ? -Infinity : dimExtent[1];
        var count2 = end2 - start2;
        var arr = storage2[dim];
        for (var i = 0; i < count2; i++) {
          var val = data[i * dimSize + dim];
          arr[start2 + i] = val;
          val < min3 && (min3 = val);
          val > max3 && (max3 = val);
        }
        dimExtent[0] = min3;
        dimExtent[1] = max3;
      }
    };
    var countForTypedArray = function() {
      return this._data ? this._data.length / this._dimSize : 0;
    };
    providerMethods = (_a2 = {}, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = {
      pure: true,
      appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      }
    }, _a2[SOURCE_FORMAT_OBJECT_ROWS] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_KEYED_COLUMNS] = {
      pure: true,
      appendData: function(newData) {
        var data = this._data;
        each$f(newData, function(newCol, key) {
          var oldCol = data[key] || (data[key] = []);
          for (var i = 0; i < (newCol || []).length; i++) {
            oldCol.push(newCol[i]);
          }
        });
      }
    }, _a2[SOURCE_FORMAT_ORIGINAL] = {
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_TYPED_ARRAY] = {
      persistent: false,
      pure: true,
      appendData: function(newData) {
        this._data = newData;
      },
      clean: function() {
        this._offset += this.count();
        this._data = null;
      }
    }, _a2);
    function appendDataSimply(newData) {
      for (var i = 0; i < newData.length; i++) {
        this._data.push(newData[i]);
      }
    }
  }();
  return DefaultDataProvider2;
}();
var getItemSimply = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx];
};
var rawSourceItemGetterMap = (_a = {}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx + startIndex];
}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef, idx, out2) {
  idx += startIndex;
  var item = out2 || [];
  var data = rawData;
  for (var i = 0; i < data.length; i++) {
    var row = data[i];
    item[i] = row ? row[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_OBJECT_ROWS] = getItemSimply, _a[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef, idx, out2) {
  var item = out2 || [];
  for (var i = 0; i < dimsDef.length; i++) {
    var dimName = dimsDef[i].name;
    var col = rawData[dimName];
    item[i] = col ? col[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_ORIGINAL] = getItemSimply, _a);
function getRawSourceItemGetter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceItemGetterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var countSimply = function(rawData, startIndex, dimsDef) {
  return rawData.length;
};
var rawSourceDataCounterMap = (_b = {}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef) {
  return Math.max(0, rawData.length - startIndex);
}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef) {
  var row = rawData[0];
  return row ? Math.max(0, row.length - startIndex) : 0;
}, _b[SOURCE_FORMAT_OBJECT_ROWS] = countSimply, _b[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef) {
  var dimName = dimsDef[0].name;
  var col = rawData[dimName];
  return col ? col.length : 0;
}, _b[SOURCE_FORMAT_ORIGINAL] = countSimply, _b);
function getRawSourceDataCounter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceDataCounterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var getRawValueSimply = function(dataItem, dimIndex, property) {
  return dataItem[dimIndex];
};
var rawSourceValueGetterMap = (_c = {}, _c[SOURCE_FORMAT_ARRAY_ROWS] = getRawValueSimply, _c[SOURCE_FORMAT_OBJECT_ROWS] = function(dataItem, dimIndex, property) {
  return dataItem[property];
}, _c[SOURCE_FORMAT_KEYED_COLUMNS] = getRawValueSimply, _c[SOURCE_FORMAT_ORIGINAL] = function(dataItem, dimIndex, property) {
  var value = getDataItemValue(dataItem);
  return !(value instanceof Array) ? value : value[dimIndex];
}, _c[SOURCE_FORMAT_TYPED_ARRAY] = getRawValueSimply, _c);
function getRawSourceValueGetter(sourceFormat) {
  var method4 = rawSourceValueGetterMap[sourceFormat];
  return method4;
}
function getMethodMapKey(sourceFormat, seriesLayoutBy) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS ? sourceFormat + "_" + seriesLayoutBy : sourceFormat;
}
function retrieveRawValue(data, dataIndex, dim) {
  if (!data) {
    return;
  }
  var dataItem = data.getRawDataItem(dataIndex);
  if (dataItem == null) {
    return;
  }
  var store = data.getStore();
  var sourceFormat = store.getSource().sourceFormat;
  if (dim != null) {
    var dimIndex = data.getDimensionIndex(dim);
    var property = store.getDimensionProperty(dimIndex);
    return getRawSourceValueGetter(sourceFormat)(dataItem, dimIndex, property);
  } else {
    var result = dataItem;
    if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
      result = getDataItemValue(dataItem);
    }
    return result;
  }
}
var DIMENSION_LABEL_REG = /\{@(.+?)\}/g;
var DataFormatMixin = function() {
  function DataFormatMixin2() {
  }
  DataFormatMixin2.prototype.getDataParams = function(dataIndex, dataType) {
    var data = this.getData(dataType);
    var rawValue = this.getRawValue(dataIndex, dataType);
    var rawDataIndex = data.getRawIndex(dataIndex);
    var name = data.getName(dataIndex);
    var itemOpt = data.getRawDataItem(dataIndex);
    var style = data.getItemVisual(dataIndex, "style");
    var color = style && style[data.getItemVisual(dataIndex, "drawType") || "fill"];
    var borderColor = style && style.stroke;
    var mainType = this.mainType;
    var isSeries2 = mainType === "series";
    var userOutput = data.userOutput && data.userOutput.get();
    return {
      componentType: mainType,
      componentSubType: this.subType,
      componentIndex: this.componentIndex,
      seriesType: isSeries2 ? this.subType : null,
      seriesIndex: this.seriesIndex,
      seriesId: isSeries2 ? this.id : null,
      seriesName: isSeries2 ? this.name : null,
      name,
      dataIndex: rawDataIndex,
      data: itemOpt,
      dataType,
      value: rawValue,
      color,
      borderColor,
      dimensionNames: userOutput ? userOutput.fullDimensions : null,
      encode: userOutput ? userOutput.encode : null,
      $vars: ["seriesName", "name", "value"]
    };
  };
  DataFormatMixin2.prototype.getFormattedLabel = function(dataIndex, status, dataType, labelDimIndex, formatter, extendParams) {
    status = status || "normal";
    var data = this.getData(dataType);
    var params = this.getDataParams(dataIndex, dataType);
    if (extendParams) {
      params.value = extendParams.interpolatedValue;
    }
    if (labelDimIndex != null && isArray$1(params.value)) {
      params.value = params.value[labelDimIndex];
    }
    if (!formatter) {
      var itemModel = data.getItemModel(dataIndex);
      formatter = itemModel.get(status === "normal" ? ["label", "formatter"] : [status, "label", "formatter"]);
    }
    if (isFunction(formatter)) {
      params.status = status;
      params.dimensionIndex = labelDimIndex;
      return formatter(params);
    } else if (isString(formatter)) {
      var str = formatTpl(formatter, params);
      return str.replace(DIMENSION_LABEL_REG, function(origin, dimStr) {
        var len2 = dimStr.length;
        var dimLoose = dimStr;
        if (dimLoose.charAt(0) === "[" && dimLoose.charAt(len2 - 1) === "]") {
          dimLoose = +dimLoose.slice(1, len2 - 1);
        }
        var val = retrieveRawValue(data, dataIndex, dimLoose);
        if (extendParams && isArray$1(extendParams.interpolatedValue)) {
          var dimIndex = data.getDimensionIndex(dimLoose);
          if (dimIndex >= 0) {
            val = extendParams.interpolatedValue[dimIndex];
          }
        }
        return val != null ? val + "" : "";
      });
    }
  };
  DataFormatMixin2.prototype.getRawValue = function(idx, dataType) {
    return retrieveRawValue(this.getData(dataType), idx);
  };
  DataFormatMixin2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return;
  };
  return DataFormatMixin2;
}();
function normalizeTooltipFormatResult(result) {
  var markupText;
  var markupFragment;
  if (isObject$4(result)) {
    if (result.type) {
      markupFragment = result;
    }
  } else {
    markupText = result;
  }
  return {
    text: markupText,
    frag: markupFragment
  };
}
function createTask(define) {
  return new Task(define);
}
var Task = function() {
  function Task2(define) {
    define = define || {};
    this._reset = define.reset;
    this._plan = define.plan;
    this._count = define.count;
    this._onDirty = define.onDirty;
    this._dirty = true;
  }
  Task2.prototype.perform = function(performArgs) {
    var upTask = this._upstream;
    var skip = performArgs && performArgs.skip;
    if (this._dirty && upTask) {
      var context = this.context;
      context.data = context.outputData = upTask.context.outputData;
    }
    if (this.__pipeline) {
      this.__pipeline.currentTask = this;
    }
    var planResult;
    if (this._plan && !skip) {
      planResult = this._plan(this.context);
    }
    var lastModBy = normalizeModBy(this._modBy);
    var lastModDataCount = this._modDataCount || 0;
    var modBy = normalizeModBy(performArgs && performArgs.modBy);
    var modDataCount = performArgs && performArgs.modDataCount || 0;
    if (lastModBy !== modBy || lastModDataCount !== modDataCount) {
      planResult = "reset";
    }
    function normalizeModBy(val) {
      !(val >= 1) && (val = 1);
      return val;
    }
    var forceFirstProgress;
    if (this._dirty || planResult === "reset") {
      this._dirty = false;
      forceFirstProgress = this._doReset(skip);
    }
    this._modBy = modBy;
    this._modDataCount = modDataCount;
    var step = performArgs && performArgs.step;
    if (upTask) {
      this._dueEnd = upTask._outputDueEnd;
    } else {
      this._dueEnd = this._count ? this._count(this.context) : Infinity;
    }
    if (this._progress) {
      var start2 = this._dueIndex;
      var end2 = Math.min(step != null ? this._dueIndex + step : Infinity, this._dueEnd);
      if (!skip && (forceFirstProgress || start2 < end2)) {
        var progress = this._progress;
        if (isArray$1(progress)) {
          for (var i = 0; i < progress.length; i++) {
            this._doProgress(progress[i], start2, end2, modBy, modDataCount);
          }
        } else {
          this._doProgress(progress, start2, end2, modBy, modDataCount);
        }
      }
      this._dueIndex = end2;
      var outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : end2;
      this._outputDueEnd = outputDueEnd;
    } else {
      this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
    }
    return this.unfinished();
  };
  Task2.prototype.dirty = function() {
    this._dirty = true;
    this._onDirty && this._onDirty(this.context);
  };
  Task2.prototype._doProgress = function(progress, start2, end2, modBy, modDataCount) {
    iterator.reset(start2, end2, modBy, modDataCount);
    this._callingProgress = progress;
    this._callingProgress({
      start: start2,
      end: end2,
      count: end2 - start2,
      next: iterator.next
    }, this.context);
  };
  Task2.prototype._doReset = function(skip) {
    this._dueIndex = this._outputDueEnd = this._dueEnd = 0;
    this._settedOutputEnd = null;
    var progress;
    var forceFirstProgress;
    if (!skip && this._reset) {
      progress = this._reset(this.context);
      if (progress && progress.progress) {
        forceFirstProgress = progress.forceFirstProgress;
        progress = progress.progress;
      }
      if (isArray$1(progress) && !progress.length) {
        progress = null;
      }
    }
    this._progress = progress;
    this._modBy = this._modDataCount = null;
    var downstream = this._downstream;
    downstream && downstream.dirty();
    return forceFirstProgress;
  };
  Task2.prototype.unfinished = function() {
    return this._progress && this._dueIndex < this._dueEnd;
  };
  Task2.prototype.pipe = function(downTask) {
    if (this._downstream !== downTask || this._dirty) {
      this._downstream = downTask;
      downTask._upstream = this;
      downTask.dirty();
    }
  };
  Task2.prototype.dispose = function() {
    if (this._disposed) {
      return;
    }
    this._upstream && (this._upstream._downstream = null);
    this._downstream && (this._downstream._upstream = null);
    this._dirty = false;
    this._disposed = true;
  };
  Task2.prototype.getUpstream = function() {
    return this._upstream;
  };
  Task2.prototype.getDownstream = function() {
    return this._downstream;
  };
  Task2.prototype.setOutputEnd = function(end2) {
    this._outputDueEnd = this._settedOutputEnd = end2;
  };
  return Task2;
}();
var iterator = function() {
  var end2;
  var current;
  var modBy;
  var modDataCount;
  var winCount;
  var it = {
    reset: function(s, e2, sStep, sCount) {
      current = s;
      end2 = e2;
      modBy = sStep;
      modDataCount = sCount;
      winCount = Math.ceil(modDataCount / modBy);
      it.next = modBy > 1 && modDataCount > 0 ? modNext : sequentialNext;
    }
  };
  return it;
  function sequentialNext() {
    return current < end2 ? current++ : null;
  }
  function modNext() {
    var dataIndex = current % winCount * modBy + Math.ceil(current / winCount);
    var result = current >= end2 ? null : dataIndex < modDataCount ? dataIndex : current;
    current++;
    return result;
  }
}();
function parseDataValue(value, opt) {
  var dimType = opt && opt.type;
  if (dimType === "ordinal") {
    return value;
  }
  if (dimType === "time" && !isNumber(value) && value != null && value !== "-") {
    value = +parseDate(value);
  }
  return value == null || value === "" ? NaN : +value;
}
var valueParserMap = createHashMap({
  "number": function(val) {
    return parseFloat(val);
  },
  "time": function(val) {
    return +parseDate(val);
  },
  "trim": function(val) {
    return isString(val) ? trim$1(val) : val;
  }
});
function getRawValueParser(type4) {
  return valueParserMap.get(type4);
}
var ORDER_COMPARISON_OP_MAP = {
  lt: function(lval, rval) {
    return lval < rval;
  },
  lte: function(lval, rval) {
    return lval <= rval;
  },
  gt: function(lval, rval) {
    return lval > rval;
  },
  gte: function(lval, rval) {
    return lval >= rval;
  }
};
var FilterOrderComparator = function() {
  function FilterOrderComparator2(op, rval) {
    if (!isNumber(rval)) {
      var errMsg = "";
      throwError(errMsg);
    }
    this._opFn = ORDER_COMPARISON_OP_MAP[op];
    this._rvalFloat = numericToNumber(rval);
  }
  FilterOrderComparator2.prototype.evaluate = function(lval) {
    return isNumber(lval) ? this._opFn(lval, this._rvalFloat) : this._opFn(numericToNumber(lval), this._rvalFloat);
  };
  return FilterOrderComparator2;
}();
var SortOrderComparator = function() {
  function SortOrderComparator2(order, incomparable) {
    var isDesc = order === "desc";
    this._resultLT = isDesc ? 1 : -1;
    if (incomparable == null) {
      incomparable = isDesc ? "min" : "max";
    }
    this._incomparable = incomparable === "min" ? -Infinity : Infinity;
  }
  SortOrderComparator2.prototype.evaluate = function(lval, rval) {
    var lvalFloat = isNumber(lval) ? lval : numericToNumber(lval);
    var rvalFloat = isNumber(rval) ? rval : numericToNumber(rval);
    var lvalNotNumeric = isNaN(lvalFloat);
    var rvalNotNumeric = isNaN(rvalFloat);
    if (lvalNotNumeric) {
      lvalFloat = this._incomparable;
    }
    if (rvalNotNumeric) {
      rvalFloat = this._incomparable;
    }
    if (lvalNotNumeric && rvalNotNumeric) {
      var lvalIsStr = isString(lval);
      var rvalIsStr = isString(rval);
      if (lvalIsStr) {
        lvalFloat = rvalIsStr ? lval : 0;
      }
      if (rvalIsStr) {
        rvalFloat = lvalIsStr ? rval : 0;
      }
    }
    return lvalFloat < rvalFloat ? this._resultLT : lvalFloat > rvalFloat ? -this._resultLT : 0;
  };
  return SortOrderComparator2;
}();
var FilterEqualityComparator = function() {
  function FilterEqualityComparator2(isEq, rval) {
    this._rval = rval;
    this._isEQ = isEq;
    this._rvalTypeof = typeof rval;
    this._rvalFloat = numericToNumber(rval);
  }
  FilterEqualityComparator2.prototype.evaluate = function(lval) {
    var eqResult = lval === this._rval;
    if (!eqResult) {
      var lvalTypeof = typeof lval;
      if (lvalTypeof !== this._rvalTypeof && (lvalTypeof === "number" || this._rvalTypeof === "number")) {
        eqResult = numericToNumber(lval) === this._rvalFloat;
      }
    }
    return this._isEQ ? eqResult : !eqResult;
  };
  return FilterEqualityComparator2;
}();
function createFilterComparator(op, rval) {
  return op === "eq" || op === "ne" ? new FilterEqualityComparator(op === "eq", rval) : hasOwn(ORDER_COMPARISON_OP_MAP, op) ? new FilterOrderComparator(op, rval) : null;
}
var ExternalSource = function() {
  function ExternalSource2() {
  }
  ExternalSource2.prototype.getRawData = function() {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.getRawDataItem = function(dataIndex) {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.cloneRawData = function() {
    return;
  };
  ExternalSource2.prototype.getDimensionInfo = function(dim) {
    return;
  };
  ExternalSource2.prototype.cloneAllDimensionInfo = function() {
    return;
  };
  ExternalSource2.prototype.count = function() {
    return;
  };
  ExternalSource2.prototype.retrieveValue = function(dataIndex, dimIndex) {
    return;
  };
  ExternalSource2.prototype.retrieveValueFromItem = function(dataItem, dimIndex) {
    return;
  };
  ExternalSource2.prototype.convertValue = function(rawVal, dimInfo) {
    return parseDataValue(rawVal, dimInfo);
  };
  return ExternalSource2;
}();
function createExternalSource(internalSource, externalTransform) {
  var extSource = new ExternalSource();
  var data = internalSource.data;
  var sourceFormat = extSource.sourceFormat = internalSource.sourceFormat;
  var sourceHeaderCount = internalSource.startIndex;
  var errMsg = "";
  if (internalSource.seriesLayoutBy !== SERIES_LAYOUT_BY_COLUMN) {
    throwError(errMsg);
  }
  var dimensions = [];
  var dimsByName = {};
  var dimsDef = internalSource.dimensionsDefine;
  if (dimsDef) {
    each$f(dimsDef, function(dimDef, idx) {
      var name = dimDef.name;
      var dimDefExt = {
        index: idx,
        name,
        displayName: dimDef.displayName
      };
      dimensions.push(dimDefExt);
      if (name != null) {
        var errMsg_1 = "";
        if (hasOwn(dimsByName, name)) {
          throwError(errMsg_1);
        }
        dimsByName[name] = dimDefExt;
      }
    });
  } else {
    for (var i = 0; i < internalSource.dimensionsDetectedCount || 0; i++) {
      dimensions.push({
        index: i
      });
    }
  }
  var rawItemGetter = getRawSourceItemGetter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  if (externalTransform.__isBuiltIn) {
    extSource.getRawDataItem = function(dataIndex) {
      return rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    };
    extSource.getRawData = bind$1(getRawData, null, internalSource);
  }
  extSource.cloneRawData = bind$1(cloneRawData, null, internalSource);
  var rawCounter = getRawSourceDataCounter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  extSource.count = bind$1(rawCounter, null, data, sourceHeaderCount, dimensions);
  var rawValueGetter = getRawSourceValueGetter(sourceFormat);
  extSource.retrieveValue = function(dataIndex, dimIndex) {
    var rawItem = rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    return retrieveValueFromItem(rawItem, dimIndex);
  };
  var retrieveValueFromItem = extSource.retrieveValueFromItem = function(dataItem, dimIndex) {
    if (dataItem == null) {
      return;
    }
    var dimDef = dimensions[dimIndex];
    if (dimDef) {
      return rawValueGetter(dataItem, dimIndex, dimDef.name);
    }
  };
  extSource.getDimensionInfo = bind$1(getDimensionInfo, null, dimensions, dimsByName);
  extSource.cloneAllDimensionInfo = bind$1(cloneAllDimensionInfo, null, dimensions);
  return extSource;
}
function getRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  return upstream.data;
}
function cloneRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  var data = upstream.data;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(data[i].slice());
    }
    return result;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(extend({}, data[i]));
    }
    return result;
  }
}
function getDimensionInfo(dimensions, dimsByName, dim) {
  if (dim == null) {
    return;
  }
  if (isNumber(dim) || !isNaN(dim) && !hasOwn(dimsByName, dim)) {
    return dimensions[dim];
  } else if (hasOwn(dimsByName, dim)) {
    return dimsByName[dim];
  }
}
function cloneAllDimensionInfo(dimensions) {
  return clone$4(dimensions);
}
var externalTransformMap = createHashMap();
function registerExternalTransform(externalTransform) {
  externalTransform = clone$4(externalTransform);
  var type4 = externalTransform.type;
  var errMsg = "";
  if (!type4) {
    throwError(errMsg);
  }
  var typeParsed = type4.split(":");
  if (typeParsed.length !== 2) {
    throwError(errMsg);
  }
  var isBuiltIn = false;
  if (typeParsed[0] === "echarts") {
    type4 = typeParsed[1];
    isBuiltIn = true;
  }
  externalTransform.__isBuiltIn = isBuiltIn;
  externalTransformMap.set(type4, externalTransform);
}
function applyDataTransform(rawTransOption, sourceList, infoForPrint) {
  var pipedTransOption = normalizeToArray(rawTransOption);
  var pipeLen = pipedTransOption.length;
  var errMsg = "";
  if (!pipeLen) {
    throwError(errMsg);
  }
  for (var i = 0, len2 = pipeLen; i < len2; i++) {
    var transOption = pipedTransOption[i];
    sourceList = applySingleDataTransform(transOption, sourceList);
    if (i !== len2 - 1) {
      sourceList.length = Math.max(sourceList.length, 1);
    }
  }
  return sourceList;
}
function applySingleDataTransform(transOption, upSourceList, infoForPrint, pipeIndex) {
  var errMsg = "";
  if (!upSourceList.length) {
    throwError(errMsg);
  }
  if (!isObject$4(transOption)) {
    throwError(errMsg);
  }
  var transType = transOption.type;
  var externalTransform = externalTransformMap.get(transType);
  if (!externalTransform) {
    throwError(errMsg);
  }
  var extUpSourceList = map$1(upSourceList, function(upSource) {
    return createExternalSource(upSource, externalTransform);
  });
  var resultList = normalizeToArray(externalTransform.transform({
    upstream: extUpSourceList[0],
    upstreamList: extUpSourceList,
    config: clone$4(transOption.config)
  }));
  return map$1(resultList, function(result, resultIndex) {
    var errMsg2 = "";
    if (!isObject$4(result)) {
      throwError(errMsg2);
    }
    if (!result.data) {
      throwError(errMsg2);
    }
    var sourceFormat = detectSourceFormat(result.data);
    if (!isSupportedSourceFormat(sourceFormat)) {
      throwError(errMsg2);
    }
    var resultMetaRawOption;
    var firstUpSource = upSourceList[0];
    if (firstUpSource && resultIndex === 0 && !result.dimensions) {
      var startIndex = firstUpSource.startIndex;
      if (startIndex) {
        result.data = firstUpSource.data.slice(0, startIndex).concat(result.data);
      }
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: startIndex,
        dimensions: firstUpSource.metaRawOption.dimensions
      };
    } else {
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: 0,
        dimensions: result.dimensions
      };
    }
    return createSource(result.data, resultMetaRawOption, null);
  });
}
function isSupportedSourceFormat(sourceFormat) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS || sourceFormat === SOURCE_FORMAT_OBJECT_ROWS;
}
var UNDEFINED = "undefined";
var CtorUint32Array = typeof Uint32Array === UNDEFINED ? Array : Uint32Array;
var CtorUint16Array = typeof Uint16Array === UNDEFINED ? Array : Uint16Array;
var CtorInt32Array$1 = typeof Int32Array === UNDEFINED ? Array : Int32Array;
var CtorFloat64Array = typeof Float64Array === UNDEFINED ? Array : Float64Array;
var dataCtors = {
  "float": CtorFloat64Array,
  "int": CtorInt32Array$1,
  "ordinal": Array,
  "number": Array,
  "time": CtorFloat64Array
};
var defaultDimValueGetters;
function getIndicesCtor(rawCount) {
  return rawCount > 65535 ? CtorUint32Array : CtorUint16Array;
}
function getInitialExtent() {
  return [Infinity, -Infinity];
}
function cloneChunk(originalChunk) {
  var Ctor = originalChunk.constructor;
  return Ctor === Array ? originalChunk.slice() : new Ctor(originalChunk);
}
function prepareStore(store, dimIdx, dimType, end2, append) {
  var DataCtor = dataCtors[dimType || "float"];
  if (append) {
    var oldStore = store[dimIdx];
    var oldLen = oldStore && oldStore.length;
    if (!(oldLen === end2)) {
      var newStore = new DataCtor(end2);
      for (var j = 0; j < oldLen; j++) {
        newStore[j] = oldStore[j];
      }
      store[dimIdx] = newStore;
    }
  } else {
    store[dimIdx] = new DataCtor(end2);
  }
}
var DataStore = function() {
  function DataStore2() {
    this._chunks = [];
    this._rawExtent = [];
    this._extent = [];
    this._count = 0;
    this._rawCount = 0;
    this._calcDimNameToIdx = createHashMap();
  }
  DataStore2.prototype.initData = function(provider, inputDimensions, dimValueGetter) {
    this._provider = provider;
    this._chunks = [];
    this._indices = null;
    this.getRawIndex = this._getRawIdxIdentity;
    var source = provider.getSource();
    var defaultGetter = this.defaultDimValueGetter = defaultDimValueGetters[source.sourceFormat];
    this._dimValueGetter = dimValueGetter || defaultGetter;
    this._rawExtent = [];
    shouldRetrieveDataByName(source);
    this._dimensions = map$1(inputDimensions, function(dim) {
      return {
        type: dim.type,
        property: dim.property
      };
    });
    this._initDataFromProvider(0, provider.count());
  };
  DataStore2.prototype.getProvider = function() {
    return this._provider;
  };
  DataStore2.prototype.getSource = function() {
    return this._provider.getSource();
  };
  DataStore2.prototype.ensureCalculationDimension = function(dimName, type4) {
    var calcDimNameToIdx = this._calcDimNameToIdx;
    var dimensions = this._dimensions;
    var calcDimIdx = calcDimNameToIdx.get(dimName);
    if (calcDimIdx != null) {
      if (dimensions[calcDimIdx].type === type4) {
        return calcDimIdx;
      }
    } else {
      calcDimIdx = dimensions.length;
    }
    dimensions[calcDimIdx] = {
      type: type4
    };
    calcDimNameToIdx.set(dimName, calcDimIdx);
    this._chunks[calcDimIdx] = new dataCtors[type4 || "float"](this._rawCount);
    this._rawExtent[calcDimIdx] = getInitialExtent();
    return calcDimIdx;
  };
  DataStore2.prototype.collectOrdinalMeta = function(dimIdx, ordinalMeta) {
    var chunk = this._chunks[dimIdx];
    var dim = this._dimensions[dimIdx];
    var rawExtents = this._rawExtent;
    var offset = dim.ordinalOffset || 0;
    var len2 = chunk.length;
    if (offset === 0) {
      rawExtents[dimIdx] = getInitialExtent();
    }
    var dimRawExtent = rawExtents[dimIdx];
    for (var i = offset; i < len2; i++) {
      var val = chunk[i] = ordinalMeta.parseAndCollect(chunk[i]);
      dimRawExtent[0] = Math.min(val, dimRawExtent[0]);
      dimRawExtent[1] = Math.max(val, dimRawExtent[1]);
    }
    dim.ordinalMeta = ordinalMeta;
    dim.ordinalOffset = len2;
    dim.type = "ordinal";
  };
  DataStore2.prototype.getOrdinalMeta = function(dimIdx) {
    var dimInfo = this._dimensions[dimIdx];
    var ordinalMeta = dimInfo.ordinalMeta;
    return ordinalMeta;
  };
  DataStore2.prototype.getDimensionProperty = function(dimIndex) {
    var item = this._dimensions[dimIndex];
    return item && item.property;
  };
  DataStore2.prototype.appendData = function(data) {
    var provider = this._provider;
    var start2 = this.count();
    provider.appendData(data);
    var end2 = provider.count();
    if (!provider.persistent) {
      end2 += start2;
    }
    if (start2 < end2) {
      this._initDataFromProvider(start2, end2, true);
    }
    return [start2, end2];
  };
  DataStore2.prototype.appendValues = function(values, minFillLen) {
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var start2 = this.count();
    var end2 = start2 + Math.max(values.length, minFillLen || 0);
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      prepareStore(chunks, i, dim.type, end2, true);
    }
    var emptyDataItem = [];
    for (var idx = start2; idx < end2; idx++) {
      var sourceIdx = idx - start2;
      for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
        var dim = dimensions[dimIdx];
        var val = defaultDimValueGetters.arrayRows.call(this, values[sourceIdx] || emptyDataItem, dim.property, sourceIdx, dimIdx);
        chunks[dimIdx][idx] = val;
        var dimRawExtent = rawExtent[dimIdx];
        val < dimRawExtent[0] && (dimRawExtent[0] = val);
        val > dimRawExtent[1] && (dimRawExtent[1] = val);
      }
    }
    this._rawCount = this._count = end2;
    return {
      start: start2,
      end: end2
    };
  };
  DataStore2.prototype._initDataFromProvider = function(start2, end2, append) {
    var provider = this._provider;
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var dimNames = map$1(dimensions, function(dim2) {
      return dim2.property;
    });
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      if (!rawExtent[i]) {
        rawExtent[i] = getInitialExtent();
      }
      prepareStore(chunks, i, dim.type, end2, append);
    }
    if (provider.fillStorage) {
      provider.fillStorage(start2, end2, chunks, rawExtent);
    } else {
      var dataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        dataItem = provider.getItem(idx, dataItem);
        for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
          var dimStorage = chunks[dimIdx];
          var val = this._dimValueGetter(dataItem, dimNames[dimIdx], idx, dimIdx);
          dimStorage[idx] = val;
          var dimRawExtent = rawExtent[dimIdx];
          val < dimRawExtent[0] && (dimRawExtent[0] = val);
          val > dimRawExtent[1] && (dimRawExtent[1] = val);
        }
      }
    }
    if (!provider.persistent && provider.clean) {
      provider.clean();
    }
    this._rawCount = this._count = end2;
    this._extent = [];
  };
  DataStore2.prototype.count = function() {
    return this._count;
  };
  DataStore2.prototype.get = function(dim, idx) {
    if (!(idx >= 0 && idx < this._count)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[this.getRawIndex(idx)] : NaN;
  };
  DataStore2.prototype.getValues = function(dimensions, idx) {
    var values = [];
    var dimArr = [];
    if (idx == null) {
      idx = dimensions;
      dimensions = [];
      for (var i = 0; i < this._dimensions.length; i++) {
        dimArr.push(i);
      }
    } else {
      dimArr = dimensions;
    }
    for (var i = 0, len2 = dimArr.length; i < len2; i++) {
      values.push(this.get(dimArr[i], idx));
    }
    return values;
  };
  DataStore2.prototype.getByRawIndex = function(dim, rawIdx) {
    if (!(rawIdx >= 0 && rawIdx < this._rawCount)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[rawIdx] : NaN;
  };
  DataStore2.prototype.getSum = function(dim) {
    var dimData = this._chunks[dim];
    var sum2 = 0;
    if (dimData) {
      for (var i = 0, len2 = this.count(); i < len2; i++) {
        var value = this.get(dim, i);
        if (!isNaN(value)) {
          sum2 += value;
        }
      }
    }
    return sum2;
  };
  DataStore2.prototype.getMedian = function(dim) {
    var dimDataArray = [];
    this.each([dim], function(val) {
      if (!isNaN(val)) {
        dimDataArray.push(val);
      }
    });
    var sortedDimDataArray = dimDataArray.sort(function(a, b2) {
      return a - b2;
    });
    var len2 = this.count();
    return len2 === 0 ? 0 : len2 % 2 === 1 ? sortedDimDataArray[(len2 - 1) / 2] : (sortedDimDataArray[len2 / 2] + sortedDimDataArray[len2 / 2 - 1]) / 2;
  };
  DataStore2.prototype.indexOfRawIndex = function(rawIndex) {
    if (rawIndex >= this._rawCount || rawIndex < 0) {
      return -1;
    }
    if (!this._indices) {
      return rawIndex;
    }
    var indices = this._indices;
    var rawDataIndex = indices[rawIndex];
    if (rawDataIndex != null && rawDataIndex < this._count && rawDataIndex === rawIndex) {
      return rawIndex;
    }
    var left = 0;
    var right = this._count - 1;
    while (left <= right) {
      var mid = (left + right) / 2 | 0;
      if (indices[mid] < rawIndex) {
        left = mid + 1;
      } else if (indices[mid] > rawIndex) {
        right = mid - 1;
      } else {
        return mid;
      }
    }
    return -1;
  };
  DataStore2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    var chunks = this._chunks;
    var dimData = chunks[dim];
    var nearestIndices = [];
    if (!dimData) {
      return nearestIndices;
    }
    if (maxDistance == null) {
      maxDistance = Infinity;
    }
    var minDist = Infinity;
    var minDiff = -1;
    var nearestIndicesLen = 0;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var dataIndex = this.getRawIndex(i);
      var diff = value - dimData[dataIndex];
      var dist2 = Math.abs(diff);
      if (dist2 <= maxDistance) {
        if (dist2 < minDist || dist2 === minDist && diff >= 0 && minDiff < 0) {
          minDist = dist2;
          minDiff = diff;
          nearestIndicesLen = 0;
        }
        if (diff === minDiff) {
          nearestIndices[nearestIndicesLen++] = i;
        }
      }
    }
    nearestIndices.length = nearestIndicesLen;
    return nearestIndices;
  };
  DataStore2.prototype.getIndices = function() {
    var newIndices;
    var indices = this._indices;
    if (indices) {
      var Ctor = indices.constructor;
      var thisCount = this._count;
      if (Ctor === Array) {
        newIndices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          newIndices[i] = indices[i];
        }
      } else {
        newIndices = new Ctor(indices.buffer, 0, thisCount);
      }
    } else {
      var Ctor = getIndicesCtor(this._rawCount);
      newIndices = new Ctor(this.count());
      for (var i = 0; i < newIndices.length; i++) {
        newIndices[i] = i;
      }
    }
    return newIndices;
  };
  DataStore2.prototype.filter = function(dims, cb) {
    if (!this._count) {
      return this;
    }
    var newStore = this.clone();
    var count2 = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(count2);
    var value = [];
    var dimSize = dims.length;
    var offset = 0;
    var dim0 = dims[0];
    var chunks = newStore._chunks;
    for (var i = 0; i < count2; i++) {
      var keep = void 0;
      var rawIdx = newStore.getRawIndex(i);
      if (dimSize === 0) {
        keep = cb(i);
      } else if (dimSize === 1) {
        var val = chunks[dim0][rawIdx];
        keep = cb(val, i);
      } else {
        var k2 = 0;
        for (; k2 < dimSize; k2++) {
          value[k2] = chunks[dims[k2]][rawIdx];
        }
        value[k2] = i;
        keep = cb.apply(null, value);
      }
      if (keep) {
        newIndices[offset++] = rawIdx;
      }
    }
    if (offset < count2) {
      newStore._indices = newIndices;
    }
    newStore._count = offset;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.selectRange = function(range3) {
    var newStore = this.clone();
    var len2 = newStore._count;
    if (!len2) {
      return this;
    }
    var dims = keys(range3);
    var dimSize = dims.length;
    if (!dimSize) {
      return this;
    }
    var originalCount = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(originalCount);
    var offset = 0;
    var dim0 = dims[0];
    var min3 = range3[dim0][0];
    var max3 = range3[dim0][1];
    var storeArr = newStore._chunks;
    var quickFinished = false;
    if (!newStore._indices) {
      var idx = 0;
      if (dimSize === 1) {
        var dimStorage = storeArr[dims[0]];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      } else if (dimSize === 2) {
        var dimStorage = storeArr[dims[0]];
        var dimStorage2 = storeArr[dims[1]];
        var min22 = range3[dims[1]][0];
        var max22 = range3[dims[1]][1];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          var val2 = dimStorage2[i];
          if ((val >= min3 && val <= max3 || isNaN(val)) && (val2 >= min22 && val2 <= max22 || isNaN(val2))) {
            newIndices[offset++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      }
    }
    if (!quickFinished) {
      if (dimSize === 1) {
        for (var i = 0; i < originalCount; i++) {
          var rawIndex = newStore.getRawIndex(i);
          var val = storeArr[dims[0]][rawIndex];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset++] = rawIndex;
          }
        }
      } else {
        for (var i = 0; i < originalCount; i++) {
          var keep = true;
          var rawIndex = newStore.getRawIndex(i);
          for (var k2 = 0; k2 < dimSize; k2++) {
            var dimk = dims[k2];
            var val = storeArr[dimk][rawIndex];
            if (val < range3[dimk][0] || val > range3[dimk][1]) {
              keep = false;
            }
          }
          if (keep) {
            newIndices[offset++] = newStore.getRawIndex(i);
          }
        }
      }
    }
    if (offset < originalCount) {
      newStore._indices = newIndices;
    }
    newStore._count = offset;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.map = function(dims, cb) {
    var target = this.clone(dims);
    this._updateDims(target, dims, cb);
    return target;
  };
  DataStore2.prototype.modify = function(dims, cb) {
    this._updateDims(this, dims, cb);
  };
  DataStore2.prototype._updateDims = function(target, dims, cb) {
    var targetChunks = target._chunks;
    var tmpRetValue = [];
    var dimSize = dims.length;
    var dataCount = target.count();
    var values = [];
    var rawExtent = target._rawExtent;
    for (var i = 0; i < dims.length; i++) {
      rawExtent[dims[i]] = getInitialExtent();
    }
    for (var dataIndex = 0; dataIndex < dataCount; dataIndex++) {
      var rawIndex = target.getRawIndex(dataIndex);
      for (var k2 = 0; k2 < dimSize; k2++) {
        values[k2] = targetChunks[dims[k2]][rawIndex];
      }
      values[dimSize] = dataIndex;
      var retValue = cb && cb.apply(null, values);
      if (retValue != null) {
        if (typeof retValue !== "object") {
          tmpRetValue[0] = retValue;
          retValue = tmpRetValue;
        }
        for (var i = 0; i < retValue.length; i++) {
          var dim = dims[i];
          var val = retValue[i];
          var rawExtentOnDim = rawExtent[dim];
          var dimStore = targetChunks[dim];
          if (dimStore) {
            dimStore[rawIndex] = val;
          }
          if (val < rawExtentOnDim[0]) {
            rawExtentOnDim[0] = val;
          }
          if (val > rawExtentOnDim[1]) {
            rawExtentOnDim[1] = val;
          }
        }
      }
    }
  };
  DataStore2.prototype.lttbDownSample = function(valueDimension, rate) {
    var target = this.clone([valueDimension], true);
    var targetStorage = target._chunks;
    var dimStore = targetStorage[valueDimension];
    var len2 = this.count();
    var sampledIndex = 0;
    var frameSize = Math.floor(1 / rate);
    var currentRawIndex = this.getRawIndex(0);
    var maxArea;
    var area;
    var nextRawIndex;
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.min((Math.ceil(len2 / frameSize) + 2) * 2, len2));
    newIndices[sampledIndex++] = currentRawIndex;
    for (var i = 1; i < len2 - 1; i += frameSize) {
      var nextFrameStart = Math.min(i + frameSize, len2 - 1);
      var nextFrameEnd = Math.min(i + frameSize * 2, len2);
      var avgX = (nextFrameEnd + nextFrameStart) / 2;
      var avgY = 0;
      for (var idx = nextFrameStart; idx < nextFrameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          continue;
        }
        avgY += y2;
      }
      avgY /= nextFrameEnd - nextFrameStart;
      var frameStart = i;
      var frameEnd = Math.min(i + frameSize, len2);
      var pointAX = i - 1;
      var pointAY = dimStore[currentRawIndex];
      maxArea = -1;
      nextRawIndex = frameStart;
      var firstNaNIndex = -1;
      var countNaN = 0;
      for (var idx = frameStart; idx < frameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          countNaN++;
          if (firstNaNIndex < 0) {
            firstNaNIndex = rawIndex;
          }
          continue;
        }
        area = Math.abs((pointAX - avgX) * (y2 - pointAY) - (pointAX - idx) * (avgY - pointAY));
        if (area > maxArea) {
          maxArea = area;
          nextRawIndex = rawIndex;
        }
      }
      if (countNaN > 0 && countNaN < frameEnd - frameStart) {
        newIndices[sampledIndex++] = Math.min(firstNaNIndex, nextRawIndex);
        nextRawIndex = Math.max(firstNaNIndex, nextRawIndex);
      }
      newIndices[sampledIndex++] = nextRawIndex;
      currentRawIndex = nextRawIndex;
    }
    newIndices[sampledIndex++] = this.getRawIndex(len2 - 1);
    target._count = sampledIndex;
    target._indices = newIndices;
    target.getRawIndex = this._getRawIdx;
    return target;
  };
  DataStore2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var target = this.clone([dimension], true);
    var targetStorage = target._chunks;
    var frameValues = [];
    var frameSize = Math.floor(1 / rate);
    var dimStore = targetStorage[dimension];
    var len2 = this.count();
    var rawExtentOnDim = target._rawExtent[dimension] = getInitialExtent();
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.ceil(len2 / frameSize));
    var offset = 0;
    for (var i = 0; i < len2; i += frameSize) {
      if (frameSize > len2 - i) {
        frameSize = len2 - i;
        frameValues.length = frameSize;
      }
      for (var k2 = 0; k2 < frameSize; k2++) {
        var dataIdx = this.getRawIndex(i + k2);
        frameValues[k2] = dimStore[dataIdx];
      }
      var value = sampleValue(frameValues);
      var sampleFrameIdx = this.getRawIndex(Math.min(i + sampleIndex(frameValues, value) || 0, len2 - 1));
      dimStore[sampleFrameIdx] = value;
      if (value < rawExtentOnDim[0]) {
        rawExtentOnDim[0] = value;
      }
      if (value > rawExtentOnDim[1]) {
        rawExtentOnDim[1] = value;
      }
      newIndices[offset++] = sampleFrameIdx;
    }
    target._count = offset;
    target._indices = newIndices;
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype.each = function(dims, cb) {
    if (!this._count) {
      return;
    }
    var dimSize = dims.length;
    var chunks = this._chunks;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var rawIdx = this.getRawIndex(i);
      switch (dimSize) {
        case 0:
          cb(i);
          break;
        case 1:
          cb(chunks[dims[0]][rawIdx], i);
          break;
        case 2:
          cb(chunks[dims[0]][rawIdx], chunks[dims[1]][rawIdx], i);
          break;
        default:
          var k2 = 0;
          var value = [];
          for (; k2 < dimSize; k2++) {
            value[k2] = chunks[dims[k2]][rawIdx];
          }
          value[k2] = i;
          cb.apply(null, value);
      }
    }
  };
  DataStore2.prototype.getDataExtent = function(dim) {
    var dimData = this._chunks[dim];
    var initialExtent = getInitialExtent();
    if (!dimData) {
      return initialExtent;
    }
    var currEnd = this.count();
    var useRaw = !this._indices;
    var dimExtent;
    if (useRaw) {
      return this._rawExtent[dim].slice();
    }
    dimExtent = this._extent[dim];
    if (dimExtent) {
      return dimExtent.slice();
    }
    dimExtent = initialExtent;
    var min3 = dimExtent[0];
    var max3 = dimExtent[1];
    for (var i = 0; i < currEnd; i++) {
      var rawIdx = this.getRawIndex(i);
      var value = dimData[rawIdx];
      value < min3 && (min3 = value);
      value > max3 && (max3 = value);
    }
    dimExtent = [min3, max3];
    this._extent[dim] = dimExtent;
    return dimExtent;
  };
  DataStore2.prototype.getRawDataItem = function(idx) {
    var rawIdx = this.getRawIndex(idx);
    if (!this._provider.persistent) {
      var val = [];
      var chunks = this._chunks;
      for (var i = 0; i < chunks.length; i++) {
        val.push(chunks[i][rawIdx]);
      }
      return val;
    } else {
      return this._provider.getItem(rawIdx);
    }
  };
  DataStore2.prototype.clone = function(clonedDims, ignoreIndices) {
    var target = new DataStore2();
    var chunks = this._chunks;
    var clonedDimsMap = clonedDims && reduce(clonedDims, function(obj, dimIdx) {
      obj[dimIdx] = true;
      return obj;
    }, {});
    if (clonedDimsMap) {
      for (var i = 0; i < chunks.length; i++) {
        target._chunks[i] = !clonedDimsMap[i] ? chunks[i] : cloneChunk(chunks[i]);
      }
    } else {
      target._chunks = chunks;
    }
    this._copyCommonProps(target);
    if (!ignoreIndices) {
      target._indices = this._cloneIndices();
    }
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype._copyCommonProps = function(target) {
    target._count = this._count;
    target._rawCount = this._rawCount;
    target._provider = this._provider;
    target._dimensions = this._dimensions;
    target._extent = clone$4(this._extent);
    target._rawExtent = clone$4(this._rawExtent);
  };
  DataStore2.prototype._cloneIndices = function() {
    if (this._indices) {
      var Ctor = this._indices.constructor;
      var indices = void 0;
      if (Ctor === Array) {
        var thisCount = this._indices.length;
        indices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          indices[i] = this._indices[i];
        }
      } else {
        indices = new Ctor(this._indices);
      }
      return indices;
    }
    return null;
  };
  DataStore2.prototype._getRawIdxIdentity = function(idx) {
    return idx;
  };
  DataStore2.prototype._getRawIdx = function(idx) {
    if (idx < this._count && idx >= 0) {
      return this._indices[idx];
    }
    return -1;
  };
  DataStore2.prototype._updateGetRawIdx = function() {
    this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
  };
  DataStore2.internalField = function() {
    function getDimValueSimply(dataItem, property, dataIndex, dimIndex) {
      return parseDataValue(dataItem[dimIndex], this._dimensions[dimIndex]);
    }
    defaultDimValueGetters = {
      arrayRows: getDimValueSimply,
      objectRows: function(dataItem, property, dataIndex, dimIndex) {
        return parseDataValue(dataItem[property], this._dimensions[dimIndex]);
      },
      keyedColumns: getDimValueSimply,
      original: function(dataItem, property, dataIndex, dimIndex) {
        var value = dataItem && (dataItem.value == null ? dataItem : dataItem.value);
        return parseDataValue(value instanceof Array ? value[dimIndex] : value, this._dimensions[dimIndex]);
      },
      typedArray: function(dataItem, property, dataIndex, dimIndex) {
        return dataItem[dimIndex];
      }
    };
  }();
  return DataStore2;
}();
var SourceManager = function() {
  function SourceManager2(sourceHost) {
    this._sourceList = [];
    this._storeList = [];
    this._upstreamSignList = [];
    this._versionSignBase = 0;
    this._dirty = true;
    this._sourceHost = sourceHost;
  }
  SourceManager2.prototype.dirty = function() {
    this._setLocalSource([], []);
    this._storeList = [];
    this._dirty = true;
  };
  SourceManager2.prototype._setLocalSource = function(sourceList, upstreamSignList) {
    this._sourceList = sourceList;
    this._upstreamSignList = upstreamSignList;
    this._versionSignBase++;
    if (this._versionSignBase > 9e10) {
      this._versionSignBase = 0;
    }
  };
  SourceManager2.prototype._getVersionSign = function() {
    return this._sourceHost.uid + "_" + this._versionSignBase;
  };
  SourceManager2.prototype.prepareSource = function() {
    if (this._isDirty()) {
      this._createSource();
      this._dirty = false;
    }
  };
  SourceManager2.prototype._createSource = function() {
    this._setLocalSource([], []);
    var sourceHost = this._sourceHost;
    var upSourceMgrList = this._getUpstreamSourceManagers();
    var hasUpstream = !!upSourceMgrList.length;
    var resultSourceList;
    var upstreamSignList;
    if (isSeries(sourceHost)) {
      var seriesModel = sourceHost;
      var data = void 0;
      var sourceFormat = void 0;
      var upSource = void 0;
      if (hasUpstream) {
        var upSourceMgr = upSourceMgrList[0];
        upSourceMgr.prepareSource();
        upSource = upSourceMgr.getSource();
        data = upSource.data;
        sourceFormat = upSource.sourceFormat;
        upstreamSignList = [upSourceMgr._getVersionSign()];
      } else {
        data = seriesModel.get("data", true);
        sourceFormat = isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL;
        upstreamSignList = [];
      }
      var newMetaRawOption = this._getSourceMetaRawOption() || {};
      var upMetaRawOption = upSource && upSource.metaRawOption || {};
      var seriesLayoutBy = retrieve2(newMetaRawOption.seriesLayoutBy, upMetaRawOption.seriesLayoutBy) || null;
      var sourceHeader = retrieve2(newMetaRawOption.sourceHeader, upMetaRawOption.sourceHeader);
      var dimensions = retrieve2(newMetaRawOption.dimensions, upMetaRawOption.dimensions);
      var needsCreateSource = seriesLayoutBy !== upMetaRawOption.seriesLayoutBy || !!sourceHeader !== !!upMetaRawOption.sourceHeader || dimensions;
      resultSourceList = needsCreateSource ? [createSource(data, {
        seriesLayoutBy,
        sourceHeader,
        dimensions
      }, sourceFormat)] : [];
    } else {
      var datasetModel = sourceHost;
      if (hasUpstream) {
        var result = this._applyTransform(upSourceMgrList);
        resultSourceList = result.sourceList;
        upstreamSignList = result.upstreamSignList;
      } else {
        var sourceData = datasetModel.get("source", true);
        resultSourceList = [createSource(sourceData, this._getSourceMetaRawOption(), null)];
        upstreamSignList = [];
      }
    }
    this._setLocalSource(resultSourceList, upstreamSignList);
  };
  SourceManager2.prototype._applyTransform = function(upMgrList) {
    var datasetModel = this._sourceHost;
    var transformOption = datasetModel.get("transform", true);
    var fromTransformResult = datasetModel.get("fromTransformResult", true);
    if (fromTransformResult != null) {
      var errMsg = "";
      if (upMgrList.length !== 1) {
        doThrow(errMsg);
      }
    }
    var sourceList;
    var upSourceList = [];
    var upstreamSignList = [];
    each$f(upMgrList, function(upMgr) {
      upMgr.prepareSource();
      var upSource = upMgr.getSource(fromTransformResult || 0);
      var errMsg2 = "";
      if (fromTransformResult != null && !upSource) {
        doThrow(errMsg2);
      }
      upSourceList.push(upSource);
      upstreamSignList.push(upMgr._getVersionSign());
    });
    if (transformOption) {
      sourceList = applyDataTransform(transformOption, upSourceList, {
        datasetIndex: datasetModel.componentIndex
      });
    } else if (fromTransformResult != null) {
      sourceList = [cloneSourceShallow(upSourceList[0])];
    }
    return {
      sourceList,
      upstreamSignList
    };
  };
  SourceManager2.prototype._isDirty = function() {
    if (this._dirty) {
      return true;
    }
    var upSourceMgrList = this._getUpstreamSourceManagers();
    for (var i = 0; i < upSourceMgrList.length; i++) {
      var upSrcMgr = upSourceMgrList[i];
      if (upSrcMgr._isDirty() || this._upstreamSignList[i] !== upSrcMgr._getVersionSign()) {
        return true;
      }
    }
  };
  SourceManager2.prototype.getSource = function(sourceIndex) {
    sourceIndex = sourceIndex || 0;
    var source = this._sourceList[sourceIndex];
    if (!source) {
      var upSourceMgrList = this._getUpstreamSourceManagers();
      return upSourceMgrList[0] && upSourceMgrList[0].getSource(sourceIndex);
    }
    return source;
  };
  SourceManager2.prototype.getSharedDataStore = function(seriesDimRequest) {
    var schema = seriesDimRequest.makeStoreSchema();
    return this._innerGetDataStore(schema.dimensions, seriesDimRequest.source, schema.hash);
  };
  SourceManager2.prototype._innerGetDataStore = function(storeDims, seriesSource, sourceReadKey) {
    var sourceIndex = 0;
    var storeList = this._storeList;
    var cachedStoreMap = storeList[sourceIndex];
    if (!cachedStoreMap) {
      cachedStoreMap = storeList[sourceIndex] = {};
    }
    var cachedStore = cachedStoreMap[sourceReadKey];
    if (!cachedStore) {
      var upSourceMgr = this._getUpstreamSourceManagers()[0];
      if (isSeries(this._sourceHost) && upSourceMgr) {
        cachedStore = upSourceMgr._innerGetDataStore(storeDims, seriesSource, sourceReadKey);
      } else {
        cachedStore = new DataStore();
        cachedStore.initData(new DefaultDataProvider(seriesSource, storeDims.length), storeDims);
      }
      cachedStoreMap[sourceReadKey] = cachedStore;
    }
    return cachedStore;
  };
  SourceManager2.prototype._getUpstreamSourceManagers = function() {
    var sourceHost = this._sourceHost;
    if (isSeries(sourceHost)) {
      var datasetModel = querySeriesUpstreamDatasetModel(sourceHost);
      return !datasetModel ? [] : [datasetModel.getSourceManager()];
    } else {
      return map$1(queryDatasetUpstreamDatasetModels(sourceHost), function(datasetModel2) {
        return datasetModel2.getSourceManager();
      });
    }
  };
  SourceManager2.prototype._getSourceMetaRawOption = function() {
    var sourceHost = this._sourceHost;
    var seriesLayoutBy;
    var sourceHeader;
    var dimensions;
    if (isSeries(sourceHost)) {
      seriesLayoutBy = sourceHost.get("seriesLayoutBy", true);
      sourceHeader = sourceHost.get("sourceHeader", true);
      dimensions = sourceHost.get("dimensions", true);
    } else if (!this._getUpstreamSourceManagers().length) {
      var model = sourceHost;
      seriesLayoutBy = model.get("seriesLayoutBy", true);
      sourceHeader = model.get("sourceHeader", true);
      dimensions = model.get("dimensions", true);
    }
    return {
      seriesLayoutBy,
      sourceHeader,
      dimensions
    };
  };
  return SourceManager2;
}();
function disableTransformOptionMerge(datasetModel) {
  var transformOption = datasetModel.option.transform;
  transformOption && setAsPrimitive(datasetModel.option.transform);
}
function isSeries(sourceHost) {
  return sourceHost.mainType === "series";
}
function doThrow(errMsg) {
  throw new Error(errMsg);
}
var TOOLTIP_LINE_HEIGHT_CSS = "line-height:1";
function getTooltipTextStyle(textStyle, renderMode) {
  var nameFontColor = textStyle.color || "#6e7079";
  var nameFontSize = textStyle.fontSize || 12;
  var nameFontWeight = textStyle.fontWeight || "400";
  var valueFontColor = textStyle.color || "#464646";
  var valueFontSize = textStyle.fontSize || 14;
  var valueFontWeight = textStyle.fontWeight || "900";
  if (renderMode === "html") {
    return {
      nameStyle: "font-size:" + encodeHTML(nameFontSize + "") + "px;color:" + encodeHTML(nameFontColor) + ";font-weight:" + encodeHTML(nameFontWeight + ""),
      valueStyle: "font-size:" + encodeHTML(valueFontSize + "") + "px;color:" + encodeHTML(valueFontColor) + ";font-weight:" + encodeHTML(valueFontWeight + "")
    };
  } else {
    return {
      nameStyle: {
        fontSize: nameFontSize,
        fill: nameFontColor,
        fontWeight: nameFontWeight
      },
      valueStyle: {
        fontSize: valueFontSize,
        fill: valueFontColor,
        fontWeight: valueFontWeight
      }
    };
  }
}
var HTML_GAPS = [0, 10, 20, 30];
var RICH_TEXT_GAPS = ["", "\n", "\n\n", "\n\n\n"];
function createTooltipMarkup(type4, option) {
  option.type = type4;
  return option;
}
function isSectionFragment(frag) {
  return frag.type === "section";
}
function getBuilder(frag) {
  return isSectionFragment(frag) ? buildSection : buildNameValue;
}
function getBlockGapLevel(frag) {
  if (isSectionFragment(frag)) {
    var gapLevel_1 = 0;
    var subBlockLen = frag.blocks.length;
    var hasInnerGap_1 = subBlockLen > 1 || subBlockLen > 0 && !frag.noHeader;
    each$f(frag.blocks, function(subBlock) {
      var subGapLevel = getBlockGapLevel(subBlock);
      if (subGapLevel >= gapLevel_1) {
        gapLevel_1 = subGapLevel + +(hasInnerGap_1 && (!subGapLevel || isSectionFragment(subBlock) && !subBlock.noHeader));
      }
    });
    return gapLevel_1;
  }
  return 0;
}
function buildSection(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var noHeader = fragment.noHeader;
  var gaps = getGap(getBlockGapLevel(fragment));
  var subMarkupTextList = [];
  var subBlocks = fragment.blocks || [];
  assert(!subBlocks || isArray$1(subBlocks));
  subBlocks = subBlocks || [];
  var orderMode = ctx.orderMode;
  if (fragment.sortBlocks && orderMode) {
    subBlocks = subBlocks.slice();
    var orderMap = {
      valueAsc: "asc",
      valueDesc: "desc"
    };
    if (hasOwn(orderMap, orderMode)) {
      var comparator_1 = new SortOrderComparator(orderMap[orderMode], null);
      subBlocks.sort(function(a, b2) {
        return comparator_1.evaluate(a.sortParam, b2.sortParam);
      });
    } else if (orderMode === "seriesDesc") {
      subBlocks.reverse();
    }
  }
  each$f(subBlocks, function(subBlock, idx) {
    var valueFormatter = fragment.valueFormatter;
    var subMarkupText2 = getBuilder(subBlock)(valueFormatter ? extend(extend({}, ctx), {
      valueFormatter
    }) : ctx, subBlock, idx > 0 ? gaps.html : 0, toolTipTextStyle);
    subMarkupText2 != null && subMarkupTextList.push(subMarkupText2);
  });
  var subMarkupText = ctx.renderMode === "richText" ? subMarkupTextList.join(gaps.richText) : wrapBlockHTML(subMarkupTextList.join(""), noHeader ? topMarginForOuterGap : gaps.html);
  if (noHeader) {
    return subMarkupText;
  }
  var displayableHeader = makeValueReadable(fragment.header, "ordinal", ctx.useUTC);
  var nameStyle = getTooltipTextStyle(toolTipTextStyle, ctx.renderMode).nameStyle;
  if (ctx.renderMode === "richText") {
    return wrapInlineNameRichText(ctx, displayableHeader, nameStyle) + gaps.richText + subMarkupText;
  } else {
    return wrapBlockHTML('<div style="' + nameStyle + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodeHTML(displayableHeader) + "</div>" + subMarkupText, topMarginForOuterGap);
  }
}
function buildNameValue(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var renderMode = ctx.renderMode;
  var noName = fragment.noName;
  var noValue = fragment.noValue;
  var noMarker = !fragment.markerType;
  var name = fragment.name;
  var useUTC = ctx.useUTC;
  var valueFormatter = fragment.valueFormatter || ctx.valueFormatter || function(value) {
    value = isArray$1(value) ? value : [value];
    return map$1(value, function(val, idx) {
      return makeValueReadable(val, isArray$1(valueTypeOption) ? valueTypeOption[idx] : valueTypeOption, useUTC);
    });
  };
  if (noName && noValue) {
    return;
  }
  var markerStr = noMarker ? "" : ctx.markupStyleCreator.makeTooltipMarker(fragment.markerType, fragment.markerColor || "#333", renderMode);
  var readableName = noName ? "" : makeValueReadable(name, "ordinal", useUTC);
  var valueTypeOption = fragment.valueType;
  var readableValueList = noValue ? [] : valueFormatter(fragment.value);
  var valueAlignRight = !noMarker || !noName;
  var valueCloseToMarker = !noMarker && noName;
  var _a2 = getTooltipTextStyle(toolTipTextStyle, renderMode), nameStyle = _a2.nameStyle, valueStyle = _a2.valueStyle;
  return renderMode === "richText" ? (noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameRichText(ctx, readableName, nameStyle)) + (noValue ? "" : wrapInlineValueRichText(ctx, readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)) : wrapBlockHTML((noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameHTML(readableName, !noMarker, nameStyle)) + (noValue ? "" : wrapInlineValueHTML(readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)), topMarginForOuterGap);
}
function buildTooltipMarkup(fragment, markupStyleCreator, renderMode, orderMode, useUTC, toolTipTextStyle) {
  if (!fragment) {
    return;
  }
  var builder = getBuilder(fragment);
  var ctx = {
    useUTC,
    renderMode,
    orderMode,
    markupStyleCreator,
    valueFormatter: fragment.valueFormatter
  };
  return builder(ctx, fragment, 0, toolTipTextStyle);
}
function getGap(gapLevel) {
  return {
    html: HTML_GAPS[gapLevel],
    richText: RICH_TEXT_GAPS[gapLevel]
  };
}
function wrapBlockHTML(encodedContent, topGap) {
  var clearfix = '<div style="clear:both"></div>';
  var marginCSS = "margin: " + topGap + "px 0 0";
  return '<div style="' + marginCSS + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodedContent + clearfix + "</div>";
}
function wrapInlineNameHTML(name, leftHasMarker, style) {
  var marginCss = leftHasMarker ? "margin-left:2px" : "";
  return '<span style="' + style + ";" + marginCss + '">' + encodeHTML(name) + "</span>";
}
function wrapInlineValueHTML(valueList, alignRight, valueCloseToMarker, style) {
  var paddingStr = valueCloseToMarker ? "10px" : "20px";
  var alignCSS = alignRight ? "float:right;margin-left:" + paddingStr : "";
  valueList = isArray$1(valueList) ? valueList : [valueList];
  return '<span style="' + alignCSS + ";" + style + '">' + map$1(valueList, function(value) {
    return encodeHTML(value);
  }).join("&nbsp;&nbsp;") + "</span>";
}
function wrapInlineNameRichText(ctx, name, style) {
  return ctx.markupStyleCreator.wrapRichTextStyle(name, style);
}
function wrapInlineValueRichText(ctx, values, alignRight, valueCloseToMarker, style) {
  var styles2 = [style];
  var paddingLeft = valueCloseToMarker ? 10 : 20;
  alignRight && styles2.push({
    padding: [0, 0, 0, paddingLeft],
    align: "right"
  });
  return ctx.markupStyleCreator.wrapRichTextStyle(isArray$1(values) ? values.join("  ") : values, styles2);
}
function retrieveVisualColorForTooltipMarker(series, dataIndex) {
  var style = series.getData().getItemVisual(dataIndex, "style");
  var color = style[series.visualDrawType];
  return convertToColorString(color);
}
function getPaddingFromTooltipModel(model, renderMode) {
  var padding = model.get("padding");
  return padding != null ? padding : renderMode === "richText" ? [8, 10] : 10;
}
var TooltipMarkupStyleCreator = function() {
  function TooltipMarkupStyleCreator2() {
    this.richTextStyles = {};
    this._nextStyleNameId = getRandomIdBase();
  }
  TooltipMarkupStyleCreator2.prototype._generateStyleName = function() {
    return "__EC_aUTo_" + this._nextStyleNameId++;
  };
  TooltipMarkupStyleCreator2.prototype.makeTooltipMarker = function(markerType, colorStr, renderMode) {
    var markerId = renderMode === "richText" ? this._generateStyleName() : null;
    var marker = getTooltipMarker({
      color: colorStr,
      type: markerType,
      renderMode,
      markerId
    });
    if (isString(marker)) {
      return marker;
    } else {
      this.richTextStyles[markerId] = marker.style;
      return marker.content;
    }
  };
  TooltipMarkupStyleCreator2.prototype.wrapRichTextStyle = function(text, styles2) {
    var finalStl = {};
    if (isArray$1(styles2)) {
      each$f(styles2, function(stl) {
        return extend(finalStl, stl);
      });
    } else {
      extend(finalStl, styles2);
    }
    var styleName = this._generateStyleName();
    this.richTextStyles[styleName] = finalStl;
    return "{" + styleName + "|" + text + "}";
  };
  return TooltipMarkupStyleCreator2;
}();
function defaultSeriesFormatTooltip(opt) {
  var series = opt.series;
  var dataIndex = opt.dataIndex;
  var multipleSeries = opt.multipleSeries;
  var data = series.getData();
  var tooltipDims = data.mapDimensionsAll("defaultedTooltip");
  var tooltipDimLen = tooltipDims.length;
  var value = series.getRawValue(dataIndex);
  var isValueArr = isArray$1(value);
  var markerColor = retrieveVisualColorForTooltipMarker(series, dataIndex);
  var inlineValue;
  var inlineValueType;
  var subBlocks;
  var sortParam;
  if (tooltipDimLen > 1 || isValueArr && !tooltipDimLen) {
    var formatArrResult = formatTooltipArrayValue(value, series, dataIndex, tooltipDims, markerColor);
    inlineValue = formatArrResult.inlineValues;
    inlineValueType = formatArrResult.inlineValueTypes;
    subBlocks = formatArrResult.blocks;
    sortParam = formatArrResult.inlineValues[0];
  } else if (tooltipDimLen) {
    var dimInfo = data.getDimensionInfo(tooltipDims[0]);
    sortParam = inlineValue = retrieveRawValue(data, dataIndex, tooltipDims[0]);
    inlineValueType = dimInfo.type;
  } else {
    sortParam = inlineValue = isValueArr ? value[0] : value;
  }
  var seriesNameSpecified = isNameSpecified(series);
  var seriesName = seriesNameSpecified && series.name || "";
  var itemName = data.getName(dataIndex);
  var inlineName = multipleSeries ? seriesName : itemName;
  return createTooltipMarkup("section", {
    header: seriesName,
    noHeader: multipleSeries || !seriesNameSpecified,
    sortParam,
    blocks: [createTooltipMarkup("nameValue", {
      markerType: "item",
      markerColor,
      name: inlineName,
      noName: !trim$1(inlineName),
      value: inlineValue,
      valueType: inlineValueType
    })].concat(subBlocks || [])
  });
}
function formatTooltipArrayValue(value, series, dataIndex, tooltipDims, colorStr) {
  var data = series.getData();
  var isValueMultipleLine = reduce(value, function(isValueMultipleLine2, val, idx) {
    var dimItem = data.getDimensionInfo(idx);
    return isValueMultipleLine2 = isValueMultipleLine2 || dimItem && dimItem.tooltip !== false && dimItem.displayName != null;
  }, false);
  var inlineValues = [];
  var inlineValueTypes = [];
  var blocks = [];
  tooltipDims.length ? each$f(tooltipDims, function(dim) {
    setEachItem(retrieveRawValue(data, dataIndex, dim), dim);
  }) : each$f(value, setEachItem);
  function setEachItem(val, dim) {
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo || dimInfo.otherDims.tooltip === false) {
      return;
    }
    if (isValueMultipleLine) {
      blocks.push(createTooltipMarkup("nameValue", {
        markerType: "subItem",
        markerColor: colorStr,
        name: dimInfo.displayName,
        value: val,
        valueType: dimInfo.type
      }));
    } else {
      inlineValues.push(val);
      inlineValueTypes.push(dimInfo.type);
    }
  }
  return {
    inlineValues,
    inlineValueTypes,
    blocks
  };
}
var inner$k = makeInner();
function getSelectionKey(data, dataIndex) {
  return data.getName(dataIndex) || data.getId(dataIndex);
}
var SERIES_UNIVERSAL_TRANSITION_PROP = "__universalTransitionEnabled";
var SeriesModel = function(_super) {
  __extends(SeriesModel2, _super);
  function SeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._selectedDataIndicesMap = {};
    return _this;
  }
  SeriesModel2.prototype.init = function(option, parentModel, ecModel) {
    this.seriesIndex = this.componentIndex;
    this.dataTask = createTask({
      count: dataTaskCount,
      reset: dataTaskReset
    });
    this.dataTask.context = {
      model: this
    };
    this.mergeDefaultAndTheme(option, ecModel);
    var sourceManager = inner$k(this).sourceManager = new SourceManager(this);
    sourceManager.prepareSource();
    var data = this.getInitialData(option, ecModel);
    wrapData(data, this);
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeSubType = this.subType;
    if (ComponentModel$1.hasClass(themeSubType)) {
      themeSubType += "Series";
    }
    merge(option, ecModel.getTheme().get(this.subType));
    merge(option, this.getDefaultOption());
    defaultEmphasis(option, "label", ["show"]);
    this.fillDataTextStyle(option.data);
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  SeriesModel2.prototype.mergeOption = function(newSeriesOption, ecModel) {
    newSeriesOption = merge(this.option, newSeriesOption, true);
    this.fillDataTextStyle(newSeriesOption.data);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, newSeriesOption, layoutMode);
    }
    var sourceManager = inner$k(this).sourceManager;
    sourceManager.dirty();
    sourceManager.prepareSource();
    var data = this.getInitialData(newSeriesOption, ecModel);
    wrapData(data, this);
    this.dataTask.dirty();
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.fillDataTextStyle = function(data) {
    if (data && !isTypedArray(data)) {
      var props = ["show"];
      for (var i = 0; i < data.length; i++) {
        if (data[i] && data[i].label) {
          defaultEmphasis(data[i], "label", props);
        }
      }
    }
  };
  SeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return;
  };
  SeriesModel2.prototype.appendData = function(params) {
    var data = this.getRawData();
    data.appendData(params.data);
  };
  SeriesModel2.prototype.getData = function(dataType) {
    var task = getCurrentTask(this);
    if (task) {
      var data = task.context.data;
      return dataType == null ? data : data.getLinkedData(dataType);
    } else {
      return inner$k(this).data;
    }
  };
  SeriesModel2.prototype.getAllData = function() {
    var mainData = this.getData();
    return mainData && mainData.getLinkedDataAll ? mainData.getLinkedDataAll() : [{
      data: mainData
    }];
  };
  SeriesModel2.prototype.setData = function(data) {
    var task = getCurrentTask(this);
    if (task) {
      var context = task.context;
      context.outputData = data;
      if (task !== this.dataTask) {
        context.data = data;
      }
    }
    inner$k(this).data = data;
  };
  SeriesModel2.prototype.getEncode = function() {
    var encode = this.get("encode", true);
    if (encode) {
      return createHashMap(encode);
    }
  };
  SeriesModel2.prototype.getSourceManager = function() {
    return inner$k(this).sourceManager;
  };
  SeriesModel2.prototype.getSource = function() {
    return this.getSourceManager().getSource();
  };
  SeriesModel2.prototype.getRawData = function() {
    return inner$k(this).dataBeforeProcessed;
  };
  SeriesModel2.prototype.getColorBy = function() {
    var colorBy = this.get("colorBy");
    return colorBy || "series";
  };
  SeriesModel2.prototype.isColorBySeries = function() {
    return this.getColorBy() === "series";
  };
  SeriesModel2.prototype.getBaseAxis = function() {
    var coordSys = this.coordinateSystem;
    return coordSys && coordSys.getBaseAxis && coordSys.getBaseAxis();
  };
  SeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
  };
  SeriesModel2.prototype.isAnimationEnabled = function() {
    var ecModel = this.ecModel;
    if (env$1.node && !(ecModel && ecModel.ssr)) {
      return false;
    }
    var animationEnabled = this.getShallow("animation");
    if (animationEnabled) {
      if (this.getData().count() > this.getShallow("animationThreshold")) {
        animationEnabled = false;
      }
    }
    return !!animationEnabled;
  };
  SeriesModel2.prototype.restoreData = function() {
    this.dataTask.dirty();
  };
  SeriesModel2.prototype.getColorFromPalette = function(name, scope, requestColorNum) {
    var ecModel = this.ecModel;
    var color = PaletteMixin.prototype.getColorFromPalette.call(this, name, scope, requestColorNum);
    if (!color) {
      color = ecModel.getColorFromPalette(name, scope, requestColorNum);
    }
    return color;
  };
  SeriesModel2.prototype.coordDimToDataDim = function(coordDim) {
    return this.getRawData().mapDimensionsAll(coordDim);
  };
  SeriesModel2.prototype.getProgressive = function() {
    return this.get("progressive");
  };
  SeriesModel2.prototype.getProgressiveThreshold = function() {
    return this.get("progressiveThreshold");
  };
  SeriesModel2.prototype.select = function(innerDataIndices, dataType) {
    this._innerSelect(this.getData(dataType), innerDataIndices);
  };
  SeriesModel2.prototype.unselect = function(innerDataIndices, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return;
    }
    var selectedMode = this.option.selectedMode;
    var data = this.getData(dataType);
    if (selectedMode === "series" || selectedMap === "all") {
      this.option.selectedMap = {};
      this._selectedDataIndicesMap = {};
      return;
    }
    for (var i = 0; i < innerDataIndices.length; i++) {
      var dataIndex = innerDataIndices[i];
      var nameOrId = getSelectionKey(data, dataIndex);
      selectedMap[nameOrId] = false;
      this._selectedDataIndicesMap[nameOrId] = -1;
    }
  };
  SeriesModel2.prototype.toggleSelect = function(innerDataIndices, dataType) {
    var tmpArr2 = [];
    for (var i = 0; i < innerDataIndices.length; i++) {
      tmpArr2[0] = innerDataIndices[i];
      this.isSelected(innerDataIndices[i], dataType) ? this.unselect(tmpArr2, dataType) : this.select(tmpArr2, dataType);
    }
  };
  SeriesModel2.prototype.getSelectedDataIndices = function() {
    if (this.option.selectedMap === "all") {
      return [].slice.call(this.getData().getIndices());
    }
    var selectedDataIndicesMap = this._selectedDataIndicesMap;
    var nameOrIds = keys(selectedDataIndicesMap);
    var dataIndices = [];
    for (var i = 0; i < nameOrIds.length; i++) {
      var dataIndex = selectedDataIndicesMap[nameOrIds[i]];
      if (dataIndex >= 0) {
        dataIndices.push(dataIndex);
      }
    }
    return dataIndices;
  };
  SeriesModel2.prototype.isSelected = function(dataIndex, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return false;
    }
    var data = this.getData(dataType);
    return (selectedMap === "all" || selectedMap[getSelectionKey(data, dataIndex)]) && !data.getItemModel(dataIndex).get(["select", "disabled"]);
  };
  SeriesModel2.prototype.isUniversalTransitionEnabled = function() {
    if (this[SERIES_UNIVERSAL_TRANSITION_PROP]) {
      return true;
    }
    var universalTransitionOpt = this.option.universalTransition;
    if (!universalTransitionOpt) {
      return false;
    }
    if (universalTransitionOpt === true) {
      return true;
    }
    return universalTransitionOpt && universalTransitionOpt.enabled;
  };
  SeriesModel2.prototype._innerSelect = function(data, innerDataIndices) {
    var _a2, _b2;
    var option = this.option;
    var selectedMode = option.selectedMode;
    var len2 = innerDataIndices.length;
    if (!selectedMode || !len2) {
      return;
    }
    if (selectedMode === "series") {
      option.selectedMap = "all";
    } else if (selectedMode === "multiple") {
      if (!isObject$4(option.selectedMap)) {
        option.selectedMap = {};
      }
      var selectedMap = option.selectedMap;
      for (var i = 0; i < len2; i++) {
        var dataIndex = innerDataIndices[i];
        var nameOrId = getSelectionKey(data, dataIndex);
        selectedMap[nameOrId] = true;
        this._selectedDataIndicesMap[nameOrId] = data.getRawIndex(dataIndex);
      }
    } else if (selectedMode === "single" || selectedMode === true) {
      var lastDataIndex = innerDataIndices[len2 - 1];
      var nameOrId = getSelectionKey(data, lastDataIndex);
      option.selectedMap = (_a2 = {}, _a2[nameOrId] = true, _a2);
      this._selectedDataIndicesMap = (_b2 = {}, _b2[nameOrId] = data.getRawIndex(lastDataIndex), _b2);
    }
  };
  SeriesModel2.prototype._initSelectedMapFromData = function(data) {
    if (this.option.selectedMap) {
      return;
    }
    var dataIndices = [];
    if (data.hasItemOption) {
      data.each(function(idx) {
        var rawItem = data.getRawDataItem(idx);
        if (rawItem && rawItem.selected) {
          dataIndices.push(idx);
        }
      });
    }
    if (dataIndices.length > 0) {
      this._innerSelect(data, dataIndices);
    }
  };
  SeriesModel2.registerClass = function(clz) {
    return ComponentModel$1.registerClass(clz);
  };
  SeriesModel2.protoInitialize = function() {
    var proto2 = SeriesModel2.prototype;
    proto2.type = "series.__base__";
    proto2.seriesIndex = 0;
    proto2.ignoreStyleOnData = false;
    proto2.hasSymbolVisual = false;
    proto2.defaultSymbol = "circle";
    proto2.visualStyleAccessPath = "itemStyle";
    proto2.visualDrawType = "fill";
  }();
  return SeriesModel2;
}(ComponentModel$1);
mixin(SeriesModel, DataFormatMixin);
mixin(SeriesModel, PaletteMixin);
mountExtend(SeriesModel, ComponentModel$1);
function autoSeriesName(seriesModel) {
  var name = seriesModel.name;
  if (!isNameSpecified(seriesModel)) {
    seriesModel.name = getSeriesAutoName(seriesModel) || name;
  }
}
function getSeriesAutoName(seriesModel) {
  var data = seriesModel.getRawData();
  var dataDims = data.mapDimensionsAll("seriesName");
  var nameArr = [];
  each$f(dataDims, function(dataDim) {
    var dimInfo = data.getDimensionInfo(dataDim);
    dimInfo.displayName && nameArr.push(dimInfo.displayName);
  });
  return nameArr.join(" ");
}
function dataTaskCount(context) {
  return context.model.getRawData().count();
}
function dataTaskReset(context) {
  var seriesModel = context.model;
  seriesModel.setData(seriesModel.getRawData().cloneShallow());
  return dataTaskProgress;
}
function dataTaskProgress(param, context) {
  if (context.outputData && param.end > context.outputData.count()) {
    context.model.getRawData().cloneShallow(context.outputData);
  }
}
function wrapData(data, seriesModel) {
  each$f(concatArray(data.CHANGABLE_METHODS, data.DOWNSAMPLE_METHODS), function(methodName) {
    data.wrapMethod(methodName, curry$1(onDataChange, seriesModel));
  });
}
function onDataChange(seriesModel, newList) {
  var task = getCurrentTask(seriesModel);
  if (task) {
    task.setOutputEnd((newList || this).count());
  }
  return newList;
}
function getCurrentTask(seriesModel) {
  var scheduler = (seriesModel.ecModel || {}).scheduler;
  var pipeline = scheduler && scheduler.getPipeline(seriesModel.uid);
  if (pipeline) {
    var task = pipeline.currentTask;
    if (task) {
      var agentStubMap = task.agentStubMap;
      if (agentStubMap) {
        task = agentStubMap.get(seriesModel.uid);
      }
    }
    return task;
  }
}
var SeriesModel$1 = SeriesModel;
var ComponentView = function() {
  function ComponentView2() {
    this.group = new Group$4();
    this.uid = getUID("viewComponent");
  }
  ComponentView2.prototype.init = function(ecModel, api) {
  };
  ComponentView2.prototype.render = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.dispose = function(ecModel, api) {
  };
  ComponentView2.prototype.updateView = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateLayout = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateVisual = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.blurSeries = function(seriesModels, ecModel) {
  };
  ComponentView2.prototype.eachRendered = function(cb) {
    var group = this.group;
    if (group) {
      group.traverse(cb);
    }
  };
  return ComponentView2;
}();
enableClassExtend(ComponentView);
enableClassManagement(ComponentView);
var ComponentView$1 = ComponentView;
function createRenderPlanner() {
  var inner2 = makeInner();
  return function(seriesModel) {
    var fields = inner2(seriesModel);
    var pipelineContext = seriesModel.pipelineContext;
    var originalLarge = !!fields.large;
    var originalProgressive = !!fields.progressiveRender;
    var large = fields.large = !!(pipelineContext && pipelineContext.large);
    var progressive = fields.progressiveRender = !!(pipelineContext && pipelineContext.progressiveRender);
    return !!(originalLarge !== large || originalProgressive !== progressive) && "reset";
  };
}
var inner$j = makeInner();
var renderPlanner = createRenderPlanner();
var ChartView = function() {
  function ChartView2() {
    this.group = new Group$4();
    this.uid = getUID("viewChart");
    this.renderTask = createTask({
      plan: renderTaskPlan,
      reset: renderTaskReset
    });
    this.renderTask.context = {
      view: this
    };
  }
  ChartView2.prototype.init = function(ecModel, api) {
  };
  ChartView2.prototype.render = function(seriesModel, ecModel, api, payload) {
  };
  ChartView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "emphasis");
  };
  ChartView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "normal");
  };
  ChartView2.prototype.remove = function(ecModel, api) {
    this.group.removeAll();
  };
  ChartView2.prototype.dispose = function(ecModel, api) {
  };
  ChartView2.prototype.updateView = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateLayout = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateVisual = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.eachRendered = function(cb) {
    traverseElements(this.group, cb);
  };
  ChartView2.markUpdateMethod = function(payload, methodName) {
    inner$j(payload).updateMethod = methodName;
  };
  ChartView2.protoInitialize = function() {
    var proto2 = ChartView2.prototype;
    proto2.type = "chart";
  }();
  return ChartView2;
}();
function elSetState(el, state, highlightDigit) {
  if (el && isHighDownDispatcher(el)) {
    (state === "emphasis" ? enterEmphasis : leaveEmphasis)(el, highlightDigit);
  }
}
function toggleHighlight(data, payload, state) {
  var dataIndex = queryDataIndex(data, payload);
  var highlightDigit = payload && payload.highlightKey != null ? getHighlightDigit(payload.highlightKey) : null;
  if (dataIndex != null) {
    each$f(normalizeToArray(dataIndex), function(dataIdx) {
      elSetState(data.getItemGraphicEl(dataIdx), state, highlightDigit);
    });
  } else {
    data.eachItemGraphicEl(function(el) {
      elSetState(el, state, highlightDigit);
    });
  }
}
enableClassExtend(ChartView);
enableClassManagement(ChartView);
function renderTaskPlan(context) {
  return renderPlanner(context.model);
}
function renderTaskReset(context) {
  var seriesModel = context.model;
  var ecModel = context.ecModel;
  var api = context.api;
  var payload = context.payload;
  var progressiveRender = seriesModel.pipelineContext.progressiveRender;
  var view = context.view;
  var updateMethod = payload && inner$j(payload).updateMethod;
  var methodName = progressiveRender ? "incrementalPrepareRender" : updateMethod && view[updateMethod] ? updateMethod : "render";
  if (methodName !== "render") {
    view[methodName](seriesModel, ecModel, api, payload);
  }
  return progressMethodMap[methodName];
}
var progressMethodMap = {
  incrementalPrepareRender: {
    progress: function(params, context) {
      context.view.incrementalRender(params, context.model, context.ecModel, context.api, context.payload);
    }
  },
  render: {
    forceFirstProgress: true,
    progress: function(params, context) {
      context.view.render(context.model, context.ecModel, context.api, context.payload);
    }
  }
};
var ChartView$1 = ChartView;
var ORIGIN_METHOD = "\0__throttleOriginMethod";
var RATE = "\0__throttleRate";
var THROTTLE_TYPE = "\0__throttleType";
function throttle(fn, delay, debounce2) {
  var currCall;
  var lastCall = 0;
  var lastExec = 0;
  var timer = null;
  var diff;
  var scope;
  var args;
  var debounceNextCall;
  delay = delay || 0;
  function exec() {
    lastExec = new Date().getTime();
    timer = null;
    fn.apply(scope, args || []);
  }
  var cb = function() {
    var cbArgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      cbArgs[_i] = arguments[_i];
    }
    currCall = new Date().getTime();
    scope = this;
    args = cbArgs;
    var thisDelay = debounceNextCall || delay;
    var thisDebounce = debounceNextCall || debounce2;
    debounceNextCall = null;
    diff = currCall - (thisDebounce ? lastCall : lastExec) - thisDelay;
    clearTimeout(timer);
    if (thisDebounce) {
      timer = setTimeout(exec, thisDelay);
    } else {
      if (diff >= 0) {
        exec();
      } else {
        timer = setTimeout(exec, -diff);
      }
    }
    lastCall = currCall;
  };
  cb.clear = function() {
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
  };
  cb.debounceNextCall = function(debounceDelay) {
    debounceNextCall = debounceDelay;
  };
  return cb;
}
function createOrUpdate(obj, fnAttr, rate, throttleType) {
  var fn = obj[fnAttr];
  if (!fn) {
    return;
  }
  var originFn = fn[ORIGIN_METHOD] || fn;
  var lastThrottleType = fn[THROTTLE_TYPE];
  var lastRate = fn[RATE];
  if (lastRate !== rate || lastThrottleType !== throttleType) {
    if (rate == null || !throttleType) {
      return obj[fnAttr] = originFn;
    }
    fn = obj[fnAttr] = throttle(originFn, rate, throttleType === "debounce");
    fn[ORIGIN_METHOD] = originFn;
    fn[THROTTLE_TYPE] = throttleType;
    fn[RATE] = rate;
  }
  return fn;
}
function clear$1(obj, fnAttr) {
  var fn = obj[fnAttr];
  if (fn && fn[ORIGIN_METHOD]) {
    fn.clear && fn.clear();
    obj[fnAttr] = fn[ORIGIN_METHOD];
  }
}
var inner$i = makeInner();
var defaultStyleMappers = {
  itemStyle: makeStyleMapper(ITEM_STYLE_KEY_MAP, true),
  lineStyle: makeStyleMapper(LINE_STYLE_KEY_MAP, true)
};
var defaultColorKey = {
  lineStyle: "stroke",
  itemStyle: "fill"
};
function getStyleMapper(seriesModel, stylePath) {
  var styleMapper = seriesModel.visualStyleMapper || defaultStyleMappers[stylePath];
  if (!styleMapper) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return defaultStyleMappers.itemStyle;
  }
  return styleMapper;
}
function getDefaultColorKey(seriesModel, stylePath) {
  var colorKey = seriesModel.visualDrawType || defaultColorKey[stylePath];
  if (!colorKey) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return "fill";
  }
  return colorKey;
}
var seriesStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var styleModel = seriesModel.getModel(stylePath);
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var globalStyle = getStyle2(styleModel);
    var decalOption = styleModel.getShallow("decal");
    if (decalOption) {
      data.setVisual("decal", decalOption);
      decalOption.dirty = true;
    }
    var colorKey = getDefaultColorKey(seriesModel, stylePath);
    var color = globalStyle[colorKey];
    var colorCallback = isFunction(color) ? color : null;
    var hasAutoColor = globalStyle.fill === "auto" || globalStyle.stroke === "auto";
    if (!globalStyle[colorKey] || colorCallback || hasAutoColor) {
      var colorPalette2 = seriesModel.getColorFromPalette(seriesModel.name, null, ecModel.getSeriesCount());
      if (!globalStyle[colorKey]) {
        globalStyle[colorKey] = colorPalette2;
        data.setVisual("colorFromPalette", true);
      }
      globalStyle.fill = globalStyle.fill === "auto" || isFunction(globalStyle.fill) ? colorPalette2 : globalStyle.fill;
      globalStyle.stroke = globalStyle.stroke === "auto" || isFunction(globalStyle.stroke) ? colorPalette2 : globalStyle.stroke;
    }
    data.setVisual("style", globalStyle);
    data.setVisual("drawType", colorKey);
    if (!ecModel.isSeriesFiltered(seriesModel) && colorCallback) {
      data.setVisual("colorFromPalette", false);
      return {
        dataEach: function(data2, idx) {
          var dataParams = seriesModel.getDataParams(idx);
          var itemStyle = extend({}, globalStyle);
          itemStyle[colorKey] = colorCallback(dataParams);
          data2.setItemVisual(idx, "style", itemStyle);
        }
      };
    }
  }
};
var sharedModel = new Model$1();
var dataStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (seriesModel.ignoreStyleOnData || ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var colorKey = data.getVisual("drawType");
    return {
      dataEach: data.hasItemOption ? function(data2, idx) {
        var rawItem = data2.getRawDataItem(idx);
        if (rawItem && rawItem[stylePath]) {
          sharedModel.option = rawItem[stylePath];
          var style = getStyle2(sharedModel);
          var existsStyle = data2.ensureUniqueItemVisual(idx, "style");
          extend(existsStyle, style);
          if (sharedModel.option.decal) {
            data2.setItemVisual(idx, "decal", sharedModel.option.decal);
            sharedModel.option.decal.dirty = true;
          }
          if (colorKey in style) {
            data2.setItemVisual(idx, "colorFromPalette", false);
          }
        }
      } : null
    };
  }
};
var dataColorPaletteTask = {
  performRawSeries: true,
  overallReset: function(ecModel) {
    var paletteScopeGroupByType = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var colorBy = seriesModel.getColorBy();
      if (seriesModel.isColorBySeries()) {
        return;
      }
      var key = seriesModel.type + "-" + colorBy;
      var colorScope = paletteScopeGroupByType.get(key);
      if (!colorScope) {
        colorScope = {};
        paletteScopeGroupByType.set(key, colorScope);
      }
      inner$i(seriesModel).scope = colorScope;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.isColorBySeries() || ecModel.isSeriesFiltered(seriesModel)) {
        return;
      }
      var dataAll = seriesModel.getRawData();
      var idxMap = {};
      var data = seriesModel.getData();
      var colorScope = inner$i(seriesModel).scope;
      var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
      var colorKey = getDefaultColorKey(seriesModel, stylePath);
      data.each(function(idx) {
        var rawIdx = data.getRawIndex(idx);
        idxMap[rawIdx] = idx;
      });
      dataAll.each(function(rawIdx) {
        var idx = idxMap[rawIdx];
        var fromPalette = data.getItemVisual(idx, "colorFromPalette");
        if (fromPalette) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          var name_1 = dataAll.getName(rawIdx) || rawIdx + "";
          var dataCount = dataAll.count();
          itemStyle[colorKey] = seriesModel.getColorFromPalette(name_1, colorScope, dataCount);
        }
      });
    });
  }
};
var PI$5 = Math.PI;
function defaultLoading(api, opts) {
  opts = opts || {};
  defaults(opts, {
    text: "loading",
    textColor: "#000",
    fontSize: 12,
    fontWeight: "normal",
    fontStyle: "normal",
    fontFamily: "sans-serif",
    maskColor: "rgba(255, 255, 255, 0.8)",
    showSpinner: true,
    color: "#5470c6",
    spinnerRadius: 10,
    lineWidth: 5,
    zlevel: 0
  });
  var group = new Group$4();
  var mask = new Rect$3({
    style: {
      fill: opts.maskColor
    },
    zlevel: opts.zlevel,
    z: 1e4
  });
  group.add(mask);
  var textContent = new ZRText$1({
    style: {
      text: opts.text,
      fill: opts.textColor,
      fontSize: opts.fontSize,
      fontWeight: opts.fontWeight,
      fontStyle: opts.fontStyle,
      fontFamily: opts.fontFamily
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  var labelRect = new Rect$3({
    style: {
      fill: "none"
    },
    textContent,
    textConfig: {
      position: "right",
      distance: 10
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  group.add(labelRect);
  var arc;
  if (opts.showSpinner) {
    arc = new Arc$1({
      shape: {
        startAngle: -PI$5 / 2,
        endAngle: -PI$5 / 2 + 0.1,
        r: opts.spinnerRadius
      },
      style: {
        stroke: opts.color,
        lineCap: "round",
        lineWidth: opts.lineWidth
      },
      zlevel: opts.zlevel,
      z: 10001
    });
    arc.animateShape(true).when(1e3, {
      endAngle: PI$5 * 3 / 2
    }).start("circularInOut");
    arc.animateShape(true).when(1e3, {
      startAngle: PI$5 * 3 / 2
    }).delay(300).start("circularInOut");
    group.add(arc);
  }
  group.resize = function() {
    var textWidth = textContent.getBoundingRect().width;
    var r2 = opts.showSpinner ? opts.spinnerRadius : 0;
    var cx = (api.getWidth() - r2 * 2 - (opts.showSpinner && textWidth ? 10 : 0) - textWidth) / 2 - (opts.showSpinner && textWidth ? 0 : 5 + textWidth / 2) + (opts.showSpinner ? 0 : textWidth / 2) + (textWidth ? 0 : r2);
    var cy = api.getHeight() / 2;
    opts.showSpinner && arc.setShape({
      cx,
      cy
    });
    labelRect.setShape({
      x: cx - r2,
      y: cy - r2,
      width: r2 * 2,
      height: r2 * 2
    });
    mask.setShape({
      x: 0,
      y: 0,
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  group.resize();
  return group;
}
var Scheduler = function() {
  function Scheduler2(ecInstance, api, dataProcessorHandlers, visualHandlers) {
    this._stageTaskMap = createHashMap();
    this.ecInstance = ecInstance;
    this.api = api;
    dataProcessorHandlers = this._dataProcessorHandlers = dataProcessorHandlers.slice();
    visualHandlers = this._visualHandlers = visualHandlers.slice();
    this._allHandlers = dataProcessorHandlers.concat(visualHandlers);
  }
  Scheduler2.prototype.restoreData = function(ecModel, payload) {
    ecModel.restoreData(payload);
    this._stageTaskMap.each(function(taskRecord) {
      var overallTask = taskRecord.overallTask;
      overallTask && overallTask.dirty();
    });
  };
  Scheduler2.prototype.getPerformArgs = function(task, isBlock) {
    if (!task.__pipeline) {
      return;
    }
    var pipeline = this._pipelineMap.get(task.__pipeline.id);
    var pCtx = pipeline.context;
    var incremental = !isBlock && pipeline.progressiveEnabled && (!pCtx || pCtx.progressiveRender) && task.__idxInPipeline > pipeline.blockIndex;
    var step = incremental ? pipeline.step : null;
    var modDataCount = pCtx && pCtx.modDataCount;
    var modBy = modDataCount != null ? Math.ceil(modDataCount / step) : null;
    return {
      step,
      modBy,
      modDataCount
    };
  };
  Scheduler2.prototype.getPipeline = function(pipelineId) {
    return this._pipelineMap.get(pipelineId);
  };
  Scheduler2.prototype.updateStreamModes = function(seriesModel, view) {
    var pipeline = this._pipelineMap.get(seriesModel.uid);
    var data = seriesModel.getData();
    var dataLen = data.count();
    var progressiveRender = pipeline.progressiveEnabled && view.incrementalPrepareRender && dataLen >= pipeline.threshold;
    var large = seriesModel.get("large") && dataLen >= seriesModel.get("largeThreshold");
    var modDataCount = seriesModel.get("progressiveChunkMode") === "mod" ? dataLen : null;
    seriesModel.pipelineContext = pipeline.context = {
      progressiveRender,
      modDataCount,
      large
    };
  };
  Scheduler2.prototype.restorePipelines = function(ecModel) {
    var scheduler = this;
    var pipelineMap = scheduler._pipelineMap = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var progressive = seriesModel.getProgressive();
      var pipelineId = seriesModel.uid;
      pipelineMap.set(pipelineId, {
        id: pipelineId,
        head: null,
        tail: null,
        threshold: seriesModel.getProgressiveThreshold(),
        progressiveEnabled: progressive && !(seriesModel.preventIncremental && seriesModel.preventIncremental()),
        blockIndex: -1,
        step: Math.round(progressive || 700),
        count: 0
      });
      scheduler._pipe(seriesModel, seriesModel.dataTask);
    });
  };
  Scheduler2.prototype.prepareStageTasks = function() {
    var stageTaskMap = this._stageTaskMap;
    var ecModel = this.api.getModel();
    var api = this.api;
    each$f(this._allHandlers, function(handler) {
      var record = stageTaskMap.get(handler.uid) || stageTaskMap.set(handler.uid, {});
      var errMsg = "";
      assert(!(handler.reset && handler.overallReset), errMsg);
      handler.reset && this._createSeriesStageTask(handler, record, ecModel, api);
      handler.overallReset && this._createOverallStageTask(handler, record, ecModel, api);
    }, this);
  };
  Scheduler2.prototype.prepareView = function(view, model, ecModel, api) {
    var renderTask = view.renderTask;
    var context = renderTask.context;
    context.model = model;
    context.ecModel = ecModel;
    context.api = api;
    renderTask.__block = !view.incrementalPrepareRender;
    this._pipe(model, renderTask);
  };
  Scheduler2.prototype.performDataProcessorTasks = function(ecModel, payload) {
    this._performStageTasks(this._dataProcessorHandlers, ecModel, payload, {
      block: true
    });
  };
  Scheduler2.prototype.performVisualTasks = function(ecModel, payload, opt) {
    this._performStageTasks(this._visualHandlers, ecModel, payload, opt);
  };
  Scheduler2.prototype._performStageTasks = function(stageHandlers, ecModel, payload, opt) {
    opt = opt || {};
    var unfinished = false;
    var scheduler = this;
    each$f(stageHandlers, function(stageHandler, idx) {
      if (opt.visualType && opt.visualType !== stageHandler.visualType) {
        return;
      }
      var stageHandlerRecord = scheduler._stageTaskMap.get(stageHandler.uid);
      var seriesTaskMap = stageHandlerRecord.seriesTaskMap;
      var overallTask = stageHandlerRecord.overallTask;
      if (overallTask) {
        var overallNeedDirty_1;
        var agentStubMap = overallTask.agentStubMap;
        agentStubMap.each(function(stub) {
          if (needSetDirty(opt, stub)) {
            stub.dirty();
            overallNeedDirty_1 = true;
          }
        });
        overallNeedDirty_1 && overallTask.dirty();
        scheduler.updatePayload(overallTask, payload);
        var performArgs_1 = scheduler.getPerformArgs(overallTask, opt.block);
        agentStubMap.each(function(stub) {
          stub.perform(performArgs_1);
        });
        if (overallTask.perform(performArgs_1)) {
          unfinished = true;
        }
      } else if (seriesTaskMap) {
        seriesTaskMap.each(function(task, pipelineId) {
          if (needSetDirty(opt, task)) {
            task.dirty();
          }
          var performArgs = scheduler.getPerformArgs(task, opt.block);
          performArgs.skip = !stageHandler.performRawSeries && ecModel.isSeriesFiltered(task.context.model);
          scheduler.updatePayload(task, payload);
          if (task.perform(performArgs)) {
            unfinished = true;
          }
        });
      }
    });
    function needSetDirty(opt2, task) {
      return opt2.setDirty && (!opt2.dirtyMap || opt2.dirtyMap.get(task.__pipeline.id));
    }
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.performSeriesTasks = function(ecModel) {
    var unfinished;
    ecModel.eachSeries(function(seriesModel) {
      unfinished = seriesModel.dataTask.perform() || unfinished;
    });
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.plan = function() {
    this._pipelineMap.each(function(pipeline) {
      var task = pipeline.tail;
      do {
        if (task.__block) {
          pipeline.blockIndex = task.__idxInPipeline;
          break;
        }
        task = task.getUpstream();
      } while (task);
    });
  };
  Scheduler2.prototype.updatePayload = function(task, payload) {
    payload !== "remain" && (task.context.payload = payload);
  };
  Scheduler2.prototype._createSeriesStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler = this;
    var oldSeriesTaskMap = stageHandlerRecord.seriesTaskMap;
    var newSeriesTaskMap = stageHandlerRecord.seriesTaskMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    if (stageHandler.createOnAllSeries) {
      ecModel.eachRawSeries(create2);
    } else if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, create2);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(create2);
    }
    function create2(seriesModel) {
      var pipelineId = seriesModel.uid;
      var task = newSeriesTaskMap.set(pipelineId, oldSeriesTaskMap && oldSeriesTaskMap.get(pipelineId) || createTask({
        plan: seriesTaskPlan,
        reset: seriesTaskReset,
        count: seriesTaskCount
      }));
      task.context = {
        model: seriesModel,
        ecModel,
        api,
        useClearVisual: stageHandler.isVisual && !stageHandler.isLayout,
        plan: stageHandler.plan,
        reset: stageHandler.reset,
        scheduler
      };
      scheduler._pipe(seriesModel, task);
    }
  };
  Scheduler2.prototype._createOverallStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler = this;
    var overallTask = stageHandlerRecord.overallTask = stageHandlerRecord.overallTask || createTask({
      reset: overallTaskReset
    });
    overallTask.context = {
      ecModel,
      api,
      overallReset: stageHandler.overallReset,
      scheduler
    };
    var oldAgentStubMap = overallTask.agentStubMap;
    var newAgentStubMap = overallTask.agentStubMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    var overallProgress = true;
    var shouldOverallTaskDirty = false;
    var errMsg = "";
    assert(!stageHandler.createOnAllSeries, errMsg);
    if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, createStub);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(createStub);
    } else {
      overallProgress = false;
      each$f(ecModel.getSeries(), createStub);
    }
    function createStub(seriesModel) {
      var pipelineId = seriesModel.uid;
      var stub = newAgentStubMap.set(pipelineId, oldAgentStubMap && oldAgentStubMap.get(pipelineId) || (shouldOverallTaskDirty = true, createTask({
        reset: stubReset,
        onDirty: stubOnDirty
      })));
      stub.context = {
        model: seriesModel,
        overallProgress
      };
      stub.agent = overallTask;
      stub.__block = overallProgress;
      scheduler._pipe(seriesModel, stub);
    }
    if (shouldOverallTaskDirty) {
      overallTask.dirty();
    }
  };
  Scheduler2.prototype._pipe = function(seriesModel, task) {
    var pipelineId = seriesModel.uid;
    var pipeline = this._pipelineMap.get(pipelineId);
    !pipeline.head && (pipeline.head = task);
    pipeline.tail && pipeline.tail.pipe(task);
    pipeline.tail = task;
    task.__idxInPipeline = pipeline.count++;
    task.__pipeline = pipeline;
  };
  Scheduler2.wrapStageHandler = function(stageHandler, visualType) {
    if (isFunction(stageHandler)) {
      stageHandler = {
        overallReset: stageHandler,
        seriesType: detectSeriseType(stageHandler)
      };
    }
    stageHandler.uid = getUID("stageHandler");
    visualType && (stageHandler.visualType = visualType);
    return stageHandler;
  };
  return Scheduler2;
}();
function overallTaskReset(context) {
  context.overallReset(context.ecModel, context.api, context.payload);
}
function stubReset(context) {
  return context.overallProgress && stubProgress;
}
function stubProgress() {
  this.agent.dirty();
  this.getDownstream().dirty();
}
function stubOnDirty() {
  this.agent && this.agent.dirty();
}
function seriesTaskPlan(context) {
  return context.plan ? context.plan(context.model, context.ecModel, context.api, context.payload) : null;
}
function seriesTaskReset(context) {
  if (context.useClearVisual) {
    context.data.clearAllVisual();
  }
  var resetDefines = context.resetDefines = normalizeToArray(context.reset(context.model, context.ecModel, context.api, context.payload));
  return resetDefines.length > 1 ? map$1(resetDefines, function(v4, idx) {
    return makeSeriesTaskProgress(idx);
  }) : singleSeriesTaskProgress;
}
var singleSeriesTaskProgress = makeSeriesTaskProgress(0);
function makeSeriesTaskProgress(resetDefineIdx) {
  return function(params, context) {
    var data = context.data;
    var resetDefine = context.resetDefines[resetDefineIdx];
    if (resetDefine && resetDefine.dataEach) {
      for (var i = params.start; i < params.end; i++) {
        resetDefine.dataEach(data, i);
      }
    } else if (resetDefine && resetDefine.progress) {
      resetDefine.progress(params, data);
    }
  };
}
function seriesTaskCount(context) {
  return context.data.count();
}
function detectSeriseType(legacyFunc) {
  seriesType = null;
  try {
    legacyFunc(ecModelMock, apiMock);
  } catch (e2) {
  }
  return seriesType;
}
var ecModelMock = {};
var apiMock = {};
var seriesType;
mockMethods(ecModelMock, GlobalModel$1);
mockMethods(apiMock, ExtensionAPI$1);
ecModelMock.eachSeriesByType = ecModelMock.eachRawSeriesByType = function(type4) {
  seriesType = type4;
};
ecModelMock.eachComponent = function(cond) {
  if (cond.mainType === "series" && cond.subType) {
    seriesType = cond.subType;
  }
};
function mockMethods(target, Clz) {
  for (var name_1 in Clz.prototype) {
    target[name_1] = noop;
  }
}
var Scheduler$1 = Scheduler;
var colorAll = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"];
var lightTheme = {
  color: colorAll,
  colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], colorAll]
};
var contrastColor = "#B9B8CE";
var backgroundColor = "#100C2A";
var axisCommon = function() {
  return {
    axisLine: {
      lineStyle: {
        color: contrastColor
      }
    },
    splitLine: {
      lineStyle: {
        color: "#484753"
      }
    },
    splitArea: {
      areaStyle: {
        color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"]
      }
    },
    minorSplitLine: {
      lineStyle: {
        color: "#20203B"
      }
    }
  };
};
var colorPalette = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"];
var theme = {
  darkMode: true,
  color: colorPalette,
  backgroundColor,
  axisPointer: {
    lineStyle: {
      color: "#817f91"
    },
    crossStyle: {
      color: "#817f91"
    },
    label: {
      color: "#fff"
    }
  },
  legend: {
    textStyle: {
      color: contrastColor
    }
  },
  textStyle: {
    color: contrastColor
  },
  title: {
    textStyle: {
      color: "#EEF1FA"
    },
    subtextStyle: {
      color: "#B9B8CE"
    }
  },
  toolbox: {
    iconStyle: {
      borderColor: contrastColor
    }
  },
  dataZoom: {
    borderColor: "#71708A",
    textStyle: {
      color: contrastColor
    },
    brushStyle: {
      color: "rgba(135,163,206,0.3)"
    },
    handleStyle: {
      color: "#353450",
      borderColor: "#C5CBE3"
    },
    moveHandleStyle: {
      color: "#B0B6C3",
      opacity: 0.3
    },
    fillerColor: "rgba(135,163,206,0.2)",
    emphasis: {
      handleStyle: {
        borderColor: "#91B7F2",
        color: "#4D587D"
      },
      moveHandleStyle: {
        color: "#636D9A",
        opacity: 0.7
      }
    },
    dataBackground: {
      lineStyle: {
        color: "#71708A",
        width: 1
      },
      areaStyle: {
        color: "#71708A"
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#87A3CE"
      },
      areaStyle: {
        color: "#87A3CE"
      }
    }
  },
  visualMap: {
    textStyle: {
      color: contrastColor
    }
  },
  timeline: {
    lineStyle: {
      color: contrastColor
    },
    label: {
      color: contrastColor
    },
    controlStyle: {
      color: contrastColor,
      borderColor: contrastColor
    }
  },
  calendar: {
    itemStyle: {
      color: backgroundColor
    },
    dayLabel: {
      color: contrastColor
    },
    monthLabel: {
      color: contrastColor
    },
    yearLabel: {
      color: contrastColor
    }
  },
  timeAxis: axisCommon(),
  logAxis: axisCommon(),
  valueAxis: axisCommon(),
  categoryAxis: axisCommon(),
  line: {
    symbol: "circle"
  },
  graph: {
    color: colorPalette
  },
  gauge: {
    title: {
      color: contrastColor
    },
    axisLine: {
      lineStyle: {
        color: [[1, "rgba(207,212,219,0.2)"]]
      }
    },
    axisLabel: {
      color: contrastColor
    },
    detail: {
      color: "#EEF1FA"
    }
  },
  candlestick: {
    itemStyle: {
      color: "#f64e56",
      color0: "#54ea92",
      borderColor: "#f64e56",
      borderColor0: "#54ea92"
    }
  }
};
theme.categoryAxis.splitLine.show = false;
var darkTheme = theme;
var ECEventProcessor = function() {
  function ECEventProcessor2() {
  }
  ECEventProcessor2.prototype.normalizeQuery = function(query) {
    var cptQuery = {};
    var dataQuery = {};
    var otherQuery = {};
    if (isString(query)) {
      var condCptType = parseClassType(query);
      cptQuery.mainType = condCptType.main || null;
      cptQuery.subType = condCptType.sub || null;
    } else {
      var suffixes_1 = ["Index", "Name", "Id"];
      var dataKeys_1 = {
        name: 1,
        dataIndex: 1,
        dataType: 1
      };
      each$f(query, function(val, key) {
        var reserved = false;
        for (var i = 0; i < suffixes_1.length; i++) {
          var propSuffix = suffixes_1[i];
          var suffixPos = key.lastIndexOf(propSuffix);
          if (suffixPos > 0 && suffixPos === key.length - propSuffix.length) {
            var mainType = key.slice(0, suffixPos);
            if (mainType !== "data") {
              cptQuery.mainType = mainType;
              cptQuery[propSuffix.toLowerCase()] = val;
              reserved = true;
            }
          }
        }
        if (dataKeys_1.hasOwnProperty(key)) {
          dataQuery[key] = val;
          reserved = true;
        }
        if (!reserved) {
          otherQuery[key] = val;
        }
      });
    }
    return {
      cptQuery,
      dataQuery,
      otherQuery
    };
  };
  ECEventProcessor2.prototype.filter = function(eventType, query) {
    var eventInfo = this.eventInfo;
    if (!eventInfo) {
      return true;
    }
    var targetEl = eventInfo.targetEl;
    var packedEvent = eventInfo.packedEvent;
    var model = eventInfo.model;
    var view = eventInfo.view;
    if (!model || !view) {
      return true;
    }
    var cptQuery = query.cptQuery;
    var dataQuery = query.dataQuery;
    return check(cptQuery, model, "mainType") && check(cptQuery, model, "subType") && check(cptQuery, model, "index", "componentIndex") && check(cptQuery, model, "name") && check(cptQuery, model, "id") && check(dataQuery, packedEvent, "name") && check(dataQuery, packedEvent, "dataIndex") && check(dataQuery, packedEvent, "dataType") && (!view.filterForExposedEvent || view.filterForExposedEvent(eventType, query.otherQuery, targetEl, packedEvent));
    function check(query2, host, prop, propOnHost) {
      return query2[prop] == null || host[propOnHost || prop] === query2[prop];
    }
  };
  ECEventProcessor2.prototype.afterTrigger = function() {
    this.eventInfo = null;
  };
  return ECEventProcessor2;
}();
var SYMBOL_PROPS_WITH_CB = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"];
var SYMBOL_PROPS = SYMBOL_PROPS_WITH_CB.concat(["symbolKeepAspect"]);
var seriesSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    if (seriesModel.legendIcon) {
      data.setVisual("legendIcon", seriesModel.legendIcon);
    }
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    var symbolOptions = {};
    var symbolOptionsCb = {};
    var hasCallback = false;
    for (var i = 0; i < SYMBOL_PROPS_WITH_CB.length; i++) {
      var symbolPropName = SYMBOL_PROPS_WITH_CB[i];
      var val = seriesModel.get(symbolPropName);
      if (isFunction(val)) {
        hasCallback = true;
        symbolOptionsCb[symbolPropName] = val;
      } else {
        symbolOptions[symbolPropName] = val;
      }
    }
    symbolOptions.symbol = symbolOptions.symbol || seriesModel.defaultSymbol;
    data.setVisual(extend({
      legendIcon: seriesModel.legendIcon || symbolOptions.symbol,
      symbolKeepAspect: seriesModel.get("symbolKeepAspect")
    }, symbolOptions));
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var symbolPropsCb = keys(symbolOptionsCb);
    function dataEach(data2, idx) {
      var rawValue = seriesModel.getRawValue(idx);
      var params = seriesModel.getDataParams(idx);
      for (var i2 = 0; i2 < symbolPropsCb.length; i2++) {
        var symbolPropName2 = symbolPropsCb[i2];
        data2.setItemVisual(idx, symbolPropName2, symbolOptionsCb[symbolPropName2](rawValue, params));
      }
    }
    return {
      dataEach: hasCallback ? dataEach : null
    };
  }
};
var dataSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      for (var i = 0; i < SYMBOL_PROPS.length; i++) {
        var symbolPropName = SYMBOL_PROPS[i];
        var val = itemModel.getShallow(symbolPropName, true);
        if (val != null) {
          data2.setItemVisual(idx, symbolPropName, val);
        }
      }
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
function getItemVisualFromData(data, dataIndex, key) {
  switch (key) {
    case "color":
      var style = data.getItemVisual(dataIndex, "style");
      return style[data.getVisual("drawType")];
    case "opacity":
      return data.getItemVisual(dataIndex, "style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getItemVisual(dataIndex, key);
  }
}
function getVisualFromData(data, key) {
  switch (key) {
    case "color":
      var style = data.getVisual("style");
      return style[data.getVisual("drawType")];
    case "opacity":
      return data.getVisual("style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getVisual(key);
  }
}
function setItemVisualFromData(data, dataIndex, key, value) {
  switch (key) {
    case "color":
      var style = data.ensureUniqueItemVisual(dataIndex, "style");
      style[data.getVisual("drawType")] = value;
      data.setItemVisual(dataIndex, "colorFromPalette", false);
      break;
    case "opacity":
      data.ensureUniqueItemVisual(dataIndex, "style").opacity = value;
      break;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      data.setItemVisual(dataIndex, key, value);
      break;
  }
}
function createLegacyDataSelectAction(seriesType2, ecRegisterAction) {
  function getSeriesIndices(ecModel, payload) {
    var seriesIndices = [];
    ecModel.eachComponent({
      mainType: "series",
      subType: seriesType2,
      query: payload
    }, function(seriesModel) {
      seriesIndices.push(seriesModel.seriesIndex);
    });
    return seriesIndices;
  }
  each$f([[seriesType2 + "ToggleSelect", "toggleSelect"], [seriesType2 + "Select", "select"], [seriesType2 + "UnSelect", "unselect"]], function(eventsMap) {
    ecRegisterAction(eventsMap[0], function(payload, ecModel, api) {
      payload = extend({}, payload);
      api.dispatchAction(extend(payload, {
        type: eventsMap[1],
        seriesIndex: getSeriesIndices(ecModel, payload)
      }));
    });
  });
}
function handleSeriesLegacySelectEvents(type4, eventPostfix, ecIns, ecModel, payload) {
  var legacyEventName = type4 + eventPostfix;
  if (!ecIns.isSilent(legacyEventName)) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "pie"
    }, function(seriesModel) {
      var seriesIndex = seriesModel.seriesIndex;
      var selectedMap = seriesModel.option.selectedMap;
      var selected = payload.selected;
      for (var i = 0; i < selected.length; i++) {
        if (selected[i].seriesIndex === seriesIndex) {
          var data = seriesModel.getData();
          var dataIndex = queryDataIndex(data, payload.fromActionPayload);
          ecIns.trigger(legacyEventName, {
            type: legacyEventName,
            seriesId: seriesModel.id,
            name: isArray$1(dataIndex) ? data.getName(dataIndex[0]) : data.getName(dataIndex),
            selected: isString(selectedMap) ? selectedMap : extend({}, selectedMap)
          });
        }
      }
    });
  }
}
function handleLegacySelectEvents(messageCenter, ecIns, api) {
  messageCenter.on("selectchanged", function(params) {
    var ecModel = api.getModel();
    if (params.isFromClick) {
      handleSeriesLegacySelectEvents("map", "selectchanged", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selectchanged", ecIns, ecModel, params);
    } else if (params.fromAction === "select") {
      handleSeriesLegacySelectEvents("map", "selected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selected", ecIns, ecModel, params);
    } else if (params.fromAction === "unselect") {
      handleSeriesLegacySelectEvents("map", "unselected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "unselected", ecIns, ecModel, params);
    }
  });
}
function findEventDispatcher(target, det, returnFirstMatch) {
  var found;
  while (target) {
    if (det(target)) {
      found = target;
      if (returnFirstMatch) {
        break;
      }
    }
    target = target.__hostTarget || target.parent;
  }
  return found;
}
var wmUniqueIndex = Math.round(Math.random() * 9);
var supportDefineProperty = typeof Object.defineProperty === "function";
var WeakMap2 = function() {
  function WeakMap3() {
    this._id = "__ec_inner_" + wmUniqueIndex++;
  }
  WeakMap3.prototype.get = function(key) {
    return this._guard(key)[this._id];
  };
  WeakMap3.prototype.set = function(key, value) {
    var target = this._guard(key);
    if (supportDefineProperty) {
      Object.defineProperty(target, this._id, {
        value,
        enumerable: false,
        configurable: true
      });
    } else {
      target[this._id] = value;
    }
    return this;
  };
  WeakMap3.prototype["delete"] = function(key) {
    if (this.has(key)) {
      delete this._guard(key)[this._id];
      return true;
    }
    return false;
  };
  WeakMap3.prototype.has = function(key) {
    return !!this._guard(key)[this._id];
  };
  WeakMap3.prototype._guard = function(key) {
    if (key !== Object(key)) {
      throw TypeError("Value of WeakMap is not a non-null object.");
    }
    return key;
  };
  return WeakMap3;
}();
var WeakMap$1 = WeakMap2;
var Triangle = Path$1.extend({
  type: "triangle",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy + height);
    path.lineTo(cx - width, cy + height);
    path.closePath();
  }
});
var Diamond = Path$1.extend({
  type: "diamond",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy);
    path.lineTo(cx, cy + height);
    path.lineTo(cx - width, cy);
    path.closePath();
  }
});
var Pin = Path$1.extend({
  type: "pin",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var x2 = shape.x;
    var y2 = shape.y;
    var w2 = shape.width / 5 * 3;
    var h = Math.max(w2, shape.height);
    var r2 = w2 / 2;
    var dy = r2 * r2 / (h - r2);
    var cy = y2 - h + r2 + dy;
    var angle = Math.asin(dy / r2);
    var dx = Math.cos(angle) * r2;
    var tanX = Math.sin(angle);
    var tanY = Math.cos(angle);
    var cpLen = r2 * 0.6;
    var cpLen2 = r2 * 0.7;
    path.moveTo(x2 - dx, cy + dy);
    path.arc(x2, cy, r2, Math.PI - angle, Math.PI * 2 + angle);
    path.bezierCurveTo(x2 + dx - tanX * cpLen, cy + dy + tanY * cpLen, x2, y2 - cpLen2, x2, y2);
    path.bezierCurveTo(x2, y2 - cpLen2, x2 - dx + tanX * cpLen, cy + dy + tanY * cpLen, x2 - dx, cy + dy);
    path.closePath();
  }
});
var Arrow = Path$1.extend({
  type: "arrow",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(ctx, shape) {
    var height = shape.height;
    var width = shape.width;
    var x2 = shape.x;
    var y2 = shape.y;
    var dx = width / 3 * 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(x2 + dx, y2 + height);
    ctx.lineTo(x2, y2 + height / 4 * 3);
    ctx.lineTo(x2 - dx, y2 + height);
    ctx.lineTo(x2, y2);
    ctx.closePath();
  }
});
var symbolCtors = {
  line: Line$3,
  rect: Rect$3,
  roundRect: Rect$3,
  square: Rect$3,
  circle: Circle$1,
  diamond: Diamond,
  pin: Pin,
  arrow: Arrow,
  triangle: Triangle
};
var symbolShapeMakers = {
  line: function(x2, y2, w2, h, shape) {
    shape.x1 = x2;
    shape.y1 = y2 + h / 2;
    shape.x2 = x2 + w2;
    shape.y2 = y2 + h / 2;
  },
  rect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
  },
  roundRect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
    shape.r = Math.min(w2, h) / 4;
  },
  square: function(x2, y2, w2, h, shape) {
    var size = Math.min(w2, h);
    shape.x = x2;
    shape.y = y2;
    shape.width = size;
    shape.height = size;
  },
  circle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.r = Math.min(w2, h) / 2;
  },
  diamond: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  pin: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  arrow: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  triangle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  }
};
var symbolBuildProxies = {};
each$f(symbolCtors, function(Ctor, name) {
  symbolBuildProxies[name] = new Ctor();
});
var SymbolClz$1 = Path$1.extend({
  type: "symbol",
  shape: {
    symbolType: "",
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  calculateTextPosition: function(out2, config, rect) {
    var res = calculateTextPosition(out2, config, rect);
    var shape = this.shape;
    if (shape && shape.symbolType === "pin" && config.position === "inside") {
      res.y = rect.y + rect.height * 0.4;
    }
    return res;
  },
  buildPath: function(ctx, shape, inBundle) {
    var symbolType = shape.symbolType;
    if (symbolType !== "none") {
      var proxySymbol = symbolBuildProxies[symbolType];
      if (!proxySymbol) {
        symbolType = "rect";
        proxySymbol = symbolBuildProxies[symbolType];
      }
      symbolShapeMakers[symbolType](shape.x, shape.y, shape.width, shape.height, proxySymbol.shape);
      proxySymbol.buildPath(ctx, proxySymbol.shape, inBundle);
    }
  }
});
function symbolPathSetColor(color, innerColor2) {
  if (this.type !== "image") {
    var symbolStyle = this.style;
    if (this.__isEmptyBrush) {
      symbolStyle.stroke = color;
      symbolStyle.fill = innerColor2 || "#fff";
      symbolStyle.lineWidth = 2;
    } else if (this.shape.symbolType === "line") {
      symbolStyle.stroke = color;
    } else {
      symbolStyle.fill = color;
    }
    this.markRedraw();
  }
}
function createSymbol$1(symbolType, x2, y2, w2, h, color, keepAspect) {
  var isEmpty = symbolType.indexOf("empty") === 0;
  if (isEmpty) {
    symbolType = symbolType.substr(5, 1).toLowerCase() + symbolType.substr(6);
  }
  var symbolPath;
  if (symbolType.indexOf("image://") === 0) {
    symbolPath = makeImage(symbolType.slice(8), new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else if (symbolType.indexOf("path://") === 0) {
    symbolPath = makePath(symbolType.slice(7), {}, new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else {
    symbolPath = new SymbolClz$1({
      shape: {
        symbolType,
        x: x2,
        y: y2,
        width: w2,
        height: h
      }
    });
  }
  symbolPath.__isEmptyBrush = isEmpty;
  symbolPath.setColor = symbolPathSetColor;
  if (color) {
    symbolPath.setColor(color);
  }
  return symbolPath;
}
function normalizeSymbolSize(symbolSize) {
  if (!isArray$1(symbolSize)) {
    symbolSize = [+symbolSize, +symbolSize];
  }
  return [symbolSize[0] || 0, symbolSize[1] || 0];
}
function normalizeSymbolOffset(symbolOffset, symbolSize) {
  if (symbolOffset == null) {
    return;
  }
  if (!isArray$1(symbolOffset)) {
    symbolOffset = [symbolOffset, symbolOffset];
  }
  return [parsePercent(symbolOffset[0], symbolSize[0]) || 0, parsePercent(retrieve2(symbolOffset[1], symbolOffset[0]), symbolSize[1]) || 0];
}
function createLinearGradient(ctx, obj, rect) {
  var x2 = obj.x == null ? 0 : obj.x;
  var x22 = obj.x2 == null ? 1 : obj.x2;
  var y2 = obj.y == null ? 0 : obj.y;
  var y22 = obj.y2 == null ? 0 : obj.y2;
  if (!obj.global) {
    x2 = x2 * rect.width + rect.x;
    x22 = x22 * rect.width + rect.x;
    y2 = y2 * rect.height + rect.y;
    y22 = y22 * rect.height + rect.y;
  }
  x2 = isNaN(x2) ? 0 : x2;
  x22 = isNaN(x22) ? 1 : x22;
  y2 = isNaN(y2) ? 0 : y2;
  y22 = isNaN(y22) ? 0 : y22;
  var canvasGradient = ctx.createLinearGradient(x2, y2, x22, y22);
  return canvasGradient;
}
function createRadialGradient(ctx, obj, rect) {
  var width = rect.width;
  var height = rect.height;
  var min3 = Math.min(width, height);
  var x2 = obj.x == null ? 0.5 : obj.x;
  var y2 = obj.y == null ? 0.5 : obj.y;
  var r2 = obj.r == null ? 0.5 : obj.r;
  if (!obj.global) {
    x2 = x2 * width + rect.x;
    y2 = y2 * height + rect.y;
    r2 = r2 * min3;
  }
  var canvasGradient = ctx.createRadialGradient(x2, y2, 0, x2, y2, r2);
  return canvasGradient;
}
function getCanvasGradient(ctx, obj, rect) {
  var canvasGradient = obj.type === "radial" ? createRadialGradient(ctx, obj, rect) : createLinearGradient(ctx, obj, rect);
  var colorStops = obj.colorStops;
  for (var i = 0; i < colorStops.length; i++) {
    canvasGradient.addColorStop(colorStops[i].offset, colorStops[i].color);
  }
  return canvasGradient;
}
function isClipPathChanged(clipPaths, prevClipPaths) {
  if (clipPaths === prevClipPaths || !clipPaths && !prevClipPaths) {
    return false;
  }
  if (!clipPaths || !prevClipPaths || clipPaths.length !== prevClipPaths.length) {
    return true;
  }
  for (var i = 0; i < clipPaths.length; i++) {
    if (clipPaths[i] !== prevClipPaths[i]) {
      return true;
    }
  }
  return false;
}
function parseInt10(val) {
  return parseInt(val, 10);
}
function getSize$1(root2, whIdx, opts) {
  var wh = ["width", "height"][whIdx];
  var cwh = ["clientWidth", "clientHeight"][whIdx];
  var plt = ["paddingLeft", "paddingTop"][whIdx];
  var prb = ["paddingRight", "paddingBottom"][whIdx];
  if (opts[wh] != null && opts[wh] !== "auto") {
    return parseFloat(opts[wh]);
  }
  var stl = document.defaultView.getComputedStyle(root2);
  return (root2[cwh] || parseInt10(stl[wh]) || parseInt10(root2.style[wh])) - (parseInt10(stl[plt]) || 0) - (parseInt10(stl[prb]) || 0) | 0;
}
function normalizeLineDash(lineType, lineWidth) {
  if (!lineType || lineType === "solid" || !(lineWidth > 0)) {
    return null;
  }
  return lineType === "dashed" ? [4 * lineWidth, 2 * lineWidth] : lineType === "dotted" ? [lineWidth] : isNumber(lineType) ? [lineType] : isArray$1(lineType) ? lineType : null;
}
function getLineDash(el) {
  var style = el.style;
  var lineDash = style.lineDash && style.lineWidth > 0 && normalizeLineDash(style.lineDash, style.lineWidth);
  var lineDashOffset = style.lineDashOffset;
  if (lineDash) {
    var lineScale_1 = style.strokeNoScale && el.getLineScale ? el.getLineScale() : 1;
    if (lineScale_1 && lineScale_1 !== 1) {
      lineDash = map$1(lineDash, function(rawVal) {
        return rawVal / lineScale_1;
      });
      lineDashOffset /= lineScale_1;
    }
  }
  return [lineDash, lineDashOffset];
}
var pathProxyForDraw = new PathProxy$1(true);
function styleHasStroke(style) {
  var stroke = style.stroke;
  return !(stroke == null || stroke === "none" || !(style.lineWidth > 0));
}
function isValidStrokeFillStyle(strokeOrFill) {
  return typeof strokeOrFill === "string" && strokeOrFill !== "none";
}
function styleHasFill(style) {
  var fill = style.fill;
  return fill != null && fill !== "none";
}
function doFillPath(ctx, style) {
  if (style.fillOpacity != null && style.fillOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style.fillOpacity * style.opacity;
    ctx.fill();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.fill();
  }
}
function doStrokePath(ctx, style) {
  if (style.strokeOpacity != null && style.strokeOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style.strokeOpacity * style.opacity;
    ctx.stroke();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.stroke();
  }
}
function createCanvasPattern(ctx, pattern4, el) {
  var image = createOrUpdateImage(pattern4.image, pattern4.__image, el);
  if (isImageReady(image)) {
    var canvasPattern = ctx.createPattern(image, pattern4.repeat || "repeat");
    if (typeof DOMMatrix === "function" && canvasPattern && canvasPattern.setTransform) {
      var matrix = new DOMMatrix();
      matrix.translateSelf(pattern4.x || 0, pattern4.y || 0);
      matrix.rotateSelf(0, 0, (pattern4.rotation || 0) * RADIAN_TO_DEGREE);
      matrix.scaleSelf(pattern4.scaleX || 1, pattern4.scaleY || 1);
      canvasPattern.setTransform(matrix);
    }
    return canvasPattern;
  }
}
function brushPath(ctx, el, style, inBatch) {
  var _a2;
  var hasStroke = styleHasStroke(style);
  var hasFill = styleHasFill(style);
  var strokePercent = style.strokePercent;
  var strokePart = strokePercent < 1;
  var firstDraw = !el.path;
  if ((!el.silent || strokePart) && firstDraw) {
    el.createPathProxy();
  }
  var path = el.path || pathProxyForDraw;
  var dirtyFlag = el.__dirty;
  if (!inBatch) {
    var fill = style.fill;
    var stroke = style.stroke;
    var hasFillGradient = hasFill && !!fill.colorStops;
    var hasStrokeGradient = hasStroke && !!stroke.colorStops;
    var hasFillPattern = hasFill && !!fill.image;
    var hasStrokePattern = hasStroke && !!stroke.image;
    var fillGradient = void 0;
    var strokeGradient = void 0;
    var fillPattern = void 0;
    var strokePattern = void 0;
    var rect = void 0;
    if (hasFillGradient || hasStrokeGradient) {
      rect = el.getBoundingRect();
    }
    if (hasFillGradient) {
      fillGradient = dirtyFlag ? getCanvasGradient(ctx, fill, rect) : el.__canvasFillGradient;
      el.__canvasFillGradient = fillGradient;
    }
    if (hasStrokeGradient) {
      strokeGradient = dirtyFlag ? getCanvasGradient(ctx, stroke, rect) : el.__canvasStrokeGradient;
      el.__canvasStrokeGradient = strokeGradient;
    }
    if (hasFillPattern) {
      fillPattern = dirtyFlag || !el.__canvasFillPattern ? createCanvasPattern(ctx, fill, el) : el.__canvasFillPattern;
      el.__canvasFillPattern = fillPattern;
    }
    if (hasStrokePattern) {
      strokePattern = dirtyFlag || !el.__canvasStrokePattern ? createCanvasPattern(ctx, stroke, el) : el.__canvasStrokePattern;
      el.__canvasStrokePattern = fillPattern;
    }
    if (hasFillGradient) {
      ctx.fillStyle = fillGradient;
    } else if (hasFillPattern) {
      if (fillPattern) {
        ctx.fillStyle = fillPattern;
      } else {
        hasFill = false;
      }
    }
    if (hasStrokeGradient) {
      ctx.strokeStyle = strokeGradient;
    } else if (hasStrokePattern) {
      if (strokePattern) {
        ctx.strokeStyle = strokePattern;
      } else {
        hasStroke = false;
      }
    }
  }
  var scale2 = el.getGlobalScale();
  path.setScale(scale2[0], scale2[1], el.segmentIgnoreThreshold);
  var lineDash;
  var lineDashOffset;
  if (ctx.setLineDash && style.lineDash) {
    _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
  }
  var needsRebuild = true;
  if (firstDraw || dirtyFlag & SHAPE_CHANGED_BIT) {
    path.setDPR(ctx.dpr);
    if (strokePart) {
      path.setContext(null);
    } else {
      path.setContext(ctx);
      needsRebuild = false;
    }
    path.reset();
    el.buildPath(path, el.shape, inBatch);
    path.toStatic();
    el.pathUpdated();
  }
  if (needsRebuild) {
    path.rebuildPath(ctx, strokePart ? strokePercent : 1);
  }
  if (lineDash) {
    ctx.setLineDash(lineDash);
    ctx.lineDashOffset = lineDashOffset;
  }
  if (!inBatch) {
    if (style.strokeFirst) {
      if (hasStroke) {
        doStrokePath(ctx, style);
      }
      if (hasFill) {
        doFillPath(ctx, style);
      }
    } else {
      if (hasFill) {
        doFillPath(ctx, style);
      }
      if (hasStroke) {
        doStrokePath(ctx, style);
      }
    }
  }
  if (lineDash) {
    ctx.setLineDash([]);
  }
}
function brushImage(ctx, el, style) {
  var image = el.__image = createOrUpdateImage(style.image, el.__image, el, el.onload);
  if (!image || !isImageReady(image)) {
    return;
  }
  var x2 = style.x || 0;
  var y2 = style.y || 0;
  var width = el.getWidth();
  var height = el.getHeight();
  var aspect = image.width / image.height;
  if (width == null && height != null) {
    width = height * aspect;
  } else if (height == null && width != null) {
    height = width / aspect;
  } else if (width == null && height == null) {
    width = image.width;
    height = image.height;
  }
  if (style.sWidth && style.sHeight) {
    var sx = style.sx || 0;
    var sy = style.sy || 0;
    ctx.drawImage(image, sx, sy, style.sWidth, style.sHeight, x2, y2, width, height);
  } else if (style.sx && style.sy) {
    var sx = style.sx;
    var sy = style.sy;
    var sWidth = width - sx;
    var sHeight = height - sy;
    ctx.drawImage(image, sx, sy, sWidth, sHeight, x2, y2, width, height);
  } else {
    ctx.drawImage(image, x2, y2, width, height);
  }
}
function brushText(ctx, el, style) {
  var _a2;
  var text = style.text;
  text != null && (text += "");
  if (text) {
    ctx.font = style.font || DEFAULT_FONT;
    ctx.textAlign = style.textAlign;
    ctx.textBaseline = style.textBaseline;
    var lineDash = void 0;
    var lineDashOffset = void 0;
    if (ctx.setLineDash && style.lineDash) {
      _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
    }
    if (lineDash) {
      ctx.setLineDash(lineDash);
      ctx.lineDashOffset = lineDashOffset;
    }
    if (style.strokeFirst) {
      if (styleHasStroke(style)) {
        ctx.strokeText(text, style.x, style.y);
      }
      if (styleHasFill(style)) {
        ctx.fillText(text, style.x, style.y);
      }
    } else {
      if (styleHasFill(style)) {
        ctx.fillText(text, style.x, style.y);
      }
      if (styleHasStroke(style)) {
        ctx.strokeText(text, style.x, style.y);
      }
    }
    if (lineDash) {
      ctx.setLineDash([]);
    }
  }
}
var SHADOW_NUMBER_PROPS = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"];
var STROKE_PROPS = [
  ["lineCap", "butt"],
  ["lineJoin", "miter"],
  ["miterLimit", 10]
];
function bindCommonProps(ctx, style, prevStyle, forceSetAll, scope) {
  var styleChanged = false;
  if (!forceSetAll) {
    prevStyle = prevStyle || {};
    if (style === prevStyle) {
      return false;
    }
  }
  if (forceSetAll || style.opacity !== prevStyle.opacity) {
    flushPathDrawn(ctx, scope);
    styleChanged = true;
    var opacity = Math.max(Math.min(style.opacity, 1), 0);
    ctx.globalAlpha = isNaN(opacity) ? DEFAULT_COMMON_STYLE.opacity : opacity;
  }
  if (forceSetAll || style.blend !== prevStyle.blend) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalCompositeOperation = style.blend || DEFAULT_COMMON_STYLE.blend;
  }
  for (var i = 0; i < SHADOW_NUMBER_PROPS.length; i++) {
    var propName = SHADOW_NUMBER_PROPS[i];
    if (forceSetAll || style[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = ctx.dpr * (style[propName] || 0);
    }
  }
  if (forceSetAll || style.shadowColor !== prevStyle.shadowColor) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.shadowColor = style.shadowColor || DEFAULT_COMMON_STYLE.shadowColor;
  }
  return styleChanged;
}
function bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetAll, scope) {
  var style = getStyle(el, scope.inHover);
  var prevStyle = forceSetAll ? null : prevEl && getStyle(prevEl, scope.inHover) || {};
  if (style === prevStyle) {
    return false;
  }
  var styleChanged = bindCommonProps(ctx, style, prevStyle, forceSetAll, scope);
  if (forceSetAll || style.fill !== prevStyle.fill) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style.fill) && (ctx.fillStyle = style.fill);
  }
  if (forceSetAll || style.stroke !== prevStyle.stroke) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style.stroke) && (ctx.strokeStyle = style.stroke);
  }
  if (forceSetAll || style.opacity !== prevStyle.opacity) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalAlpha = style.opacity == null ? 1 : style.opacity;
  }
  if (el.hasStroke()) {
    var lineWidth = style.lineWidth;
    var newLineWidth = lineWidth / (style.strokeNoScale && el.getLineScale ? el.getLineScale() : 1);
    if (ctx.lineWidth !== newLineWidth) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx.lineWidth = newLineWidth;
    }
  }
  for (var i = 0; i < STROKE_PROPS.length; i++) {
    var prop = STROKE_PROPS[i];
    var propName = prop[0];
    if (forceSetAll || style[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = style[propName] || prop[1];
    }
  }
  return styleChanged;
}
function bindImageStyle(ctx, el, prevEl, forceSetAll, scope) {
  return bindCommonProps(ctx, getStyle(el, scope.inHover), prevEl && getStyle(prevEl, scope.inHover), forceSetAll, scope);
}
function setContextTransform(ctx, el) {
  var m2 = el.transform;
  var dpr2 = ctx.dpr || 1;
  if (m2) {
    ctx.setTransform(dpr2 * m2[0], dpr2 * m2[1], dpr2 * m2[2], dpr2 * m2[3], dpr2 * m2[4], dpr2 * m2[5]);
  } else {
    ctx.setTransform(dpr2, 0, 0, dpr2, 0, 0);
  }
}
function updateClipStatus(clipPaths, ctx, scope) {
  var allClipped = false;
  for (var i = 0; i < clipPaths.length; i++) {
    var clipPath = clipPaths[i];
    allClipped = allClipped || clipPath.isZeroArea();
    setContextTransform(ctx, clipPath);
    ctx.beginPath();
    clipPath.buildPath(ctx, clipPath.shape);
    ctx.clip();
  }
  scope.allClipped = allClipped;
}
function isTransformChanged(m0, m1) {
  if (m0 && m1) {
    return m0[0] !== m1[0] || m0[1] !== m1[1] || m0[2] !== m1[2] || m0[3] !== m1[3] || m0[4] !== m1[4] || m0[5] !== m1[5];
  } else if (!m0 && !m1) {
    return false;
  }
  return true;
}
var DRAW_TYPE_PATH = 1;
var DRAW_TYPE_IMAGE = 2;
var DRAW_TYPE_TEXT = 3;
var DRAW_TYPE_INCREMENTAL = 4;
function canPathBatch(style) {
  var hasFill = styleHasFill(style);
  var hasStroke = styleHasStroke(style);
  return !(style.lineDash || !(+hasFill ^ +hasStroke) || hasFill && typeof style.fill !== "string" || hasStroke && typeof style.stroke !== "string" || style.strokePercent < 1 || style.strokeOpacity < 1 || style.fillOpacity < 1);
}
function flushPathDrawn(ctx, scope) {
  scope.batchFill && ctx.fill();
  scope.batchStroke && ctx.stroke();
  scope.batchFill = "";
  scope.batchStroke = "";
}
function getStyle(el, inHover) {
  return inHover ? el.__hoverStyle || el.style : el.style;
}
function brushSingle(ctx, el) {
  brush$1(ctx, el, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
}
function brush$1(ctx, el, scope, isLast) {
  var m2 = el.transform;
  if (!el.shouldBePainted(scope.viewWidth, scope.viewHeight, false, false)) {
    el.__dirty &= ~REDRAW_BIT;
    el.__isRendered = false;
    return;
  }
  var clipPaths = el.__clipPaths;
  var prevElClipPaths = scope.prevElClipPaths;
  var forceSetTransform = false;
  var forceSetStyle = false;
  if (!prevElClipPaths || isClipPathChanged(clipPaths, prevElClipPaths)) {
    if (prevElClipPaths && prevElClipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.restore();
      forceSetStyle = forceSetTransform = true;
      scope.prevElClipPaths = null;
      scope.allClipped = false;
      scope.prevEl = null;
    }
    if (clipPaths && clipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.save();
      updateClipStatus(clipPaths, ctx, scope);
      forceSetTransform = true;
    }
    scope.prevElClipPaths = clipPaths;
  }
  if (scope.allClipped) {
    el.__isRendered = false;
    return;
  }
  el.beforeBrush && el.beforeBrush();
  el.innerBeforeBrush();
  var prevEl = scope.prevEl;
  if (!prevEl) {
    forceSetStyle = forceSetTransform = true;
  }
  var canBatchPath = el instanceof Path$1 && el.autoBatch && canPathBatch(el.style);
  if (forceSetTransform || isTransformChanged(m2, prevEl.transform)) {
    flushPathDrawn(ctx, scope);
    setContextTransform(ctx, el);
  } else if (!canBatchPath) {
    flushPathDrawn(ctx, scope);
  }
  var style = getStyle(el, scope.inHover);
  if (el instanceof Path$1) {
    if (scope.lastDrawType !== DRAW_TYPE_PATH) {
      forceSetStyle = true;
      scope.lastDrawType = DRAW_TYPE_PATH;
    }
    bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
    if (!canBatchPath || !scope.batchFill && !scope.batchStroke) {
      ctx.beginPath();
    }
    brushPath(ctx, el, style, canBatchPath);
    if (canBatchPath) {
      scope.batchFill = style.fill || "";
      scope.batchStroke = style.stroke || "";
    }
  } else {
    if (el instanceof TSpan$1) {
      if (scope.lastDrawType !== DRAW_TYPE_TEXT) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_TEXT;
      }
      bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushText(ctx, el, style);
    } else if (el instanceof ZRImage$1) {
      if (scope.lastDrawType !== DRAW_TYPE_IMAGE) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_IMAGE;
      }
      bindImageStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushImage(ctx, el, style);
    } else if (el.getTemporalDisplayables) {
      if (scope.lastDrawType !== DRAW_TYPE_INCREMENTAL) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_INCREMENTAL;
      }
      brushIncremental(ctx, el, scope);
    }
  }
  if (canBatchPath && isLast) {
    flushPathDrawn(ctx, scope);
  }
  el.innerAfterBrush();
  el.afterBrush && el.afterBrush();
  scope.prevEl = el;
  el.__dirty = 0;
  el.__isRendered = true;
}
function brushIncremental(ctx, el, scope) {
  var displayables = el.getDisplayables();
  var temporalDisplayables = el.getTemporalDisplayables();
  ctx.save();
  var innerScope = {
    prevElClipPaths: null,
    prevEl: null,
    allClipped: false,
    viewWidth: scope.viewWidth,
    viewHeight: scope.viewHeight,
    inHover: scope.inHover
  };
  var i;
  var len2;
  for (i = el.getCursor(), len2 = displayables.length; i < len2; i++) {
    var displayable = displayables[i];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i === len2 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  for (var i_1 = 0, len_1 = temporalDisplayables.length; i_1 < len_1; i_1++) {
    var displayable = temporalDisplayables[i_1];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i_1 === len_1 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  el.clearTemporalDisplayables();
  el.notClear = true;
  ctx.restore();
}
var decalMap = new WeakMap$1();
var decalCache = new LRU$1(100);
var decalKeys = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
function createOrUpdatePatternFromDecal(decalObject, api) {
  if (decalObject === "none") {
    return null;
  }
  var dpr2 = api.getDevicePixelRatio();
  var zr = api.getZr();
  var isSVG = zr.painter.type === "svg";
  if (decalObject.dirty) {
    decalMap["delete"](decalObject);
  }
  var oldPattern = decalMap.get(decalObject);
  if (oldPattern) {
    return oldPattern;
  }
  var decalOpt = defaults(decalObject, {
    symbol: "rect",
    symbolSize: 1,
    symbolKeepAspect: true,
    color: "rgba(0, 0, 0, 0.2)",
    backgroundColor: null,
    dashArrayX: 5,
    dashArrayY: 5,
    rotation: 0,
    maxTileWidth: 512,
    maxTileHeight: 512
  });
  if (decalOpt.backgroundColor === "none") {
    decalOpt.backgroundColor = null;
  }
  var pattern4 = {
    repeat: "repeat"
  };
  setPatternnSource(pattern4);
  pattern4.rotation = decalOpt.rotation;
  pattern4.scaleX = pattern4.scaleY = isSVG ? 1 : 1 / dpr2;
  decalMap.set(decalObject, pattern4);
  decalObject.dirty = false;
  return pattern4;
  function setPatternnSource(pattern5) {
    var keys2 = [dpr2];
    var isValidKey = true;
    for (var i = 0; i < decalKeys.length; ++i) {
      var value = decalOpt[decalKeys[i]];
      if (value != null && !isArray$1(value) && !isString(value) && !isNumber(value) && typeof value !== "boolean") {
        isValidKey = false;
        break;
      }
      keys2.push(value);
    }
    var cacheKey;
    if (isValidKey) {
      cacheKey = keys2.join(",") + (isSVG ? "-svg" : "");
      var cache = decalCache.get(cacheKey);
      if (cache) {
        isSVG ? pattern5.svgElement = cache : pattern5.image = cache;
      }
    }
    var dashArrayX = normalizeDashArrayX(decalOpt.dashArrayX);
    var dashArrayY = normalizeDashArrayY(decalOpt.dashArrayY);
    var symbolArray = normalizeSymbolArray(decalOpt.symbol);
    var lineBlockLengthsX = getLineBlockLengthX(dashArrayX);
    var lineBlockLengthY = getLineBlockLengthY(dashArrayY);
    var canvas = !isSVG && platformApi.createCanvas();
    var svgRoot = isSVG && {
      tag: "g",
      attrs: {},
      key: "dcl",
      children: []
    };
    var pSize = getPatternSize();
    var ctx;
    if (canvas) {
      canvas.width = pSize.width * dpr2;
      canvas.height = pSize.height * dpr2;
      ctx = canvas.getContext("2d");
    }
    brushDecal();
    if (isValidKey) {
      decalCache.put(cacheKey, canvas || svgRoot);
    }
    pattern5.image = canvas;
    pattern5.svgElement = svgRoot;
    pattern5.svgWidth = pSize.width;
    pattern5.svgHeight = pSize.height;
    function getPatternSize() {
      var width = 1;
      for (var i2 = 0, xlen = lineBlockLengthsX.length; i2 < xlen; ++i2) {
        width = getLeastCommonMultiple(width, lineBlockLengthsX[i2]);
      }
      var symbolRepeats = 1;
      for (var i2 = 0, xlen = symbolArray.length; i2 < xlen; ++i2) {
        symbolRepeats = getLeastCommonMultiple(symbolRepeats, symbolArray[i2].length);
      }
      width *= symbolRepeats;
      var height = lineBlockLengthY * lineBlockLengthsX.length * symbolArray.length;
      return {
        width: Math.max(1, Math.min(width, decalOpt.maxTileWidth)),
        height: Math.max(1, Math.min(height, decalOpt.maxTileHeight))
      };
    }
    function brushDecal() {
      if (ctx) {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        if (decalOpt.backgroundColor) {
          ctx.fillStyle = decalOpt.backgroundColor;
          ctx.fillRect(0, 0, canvas.width, canvas.height);
        }
      }
      var ySum = 0;
      for (var i2 = 0; i2 < dashArrayY.length; ++i2) {
        ySum += dashArrayY[i2];
      }
      if (ySum <= 0) {
        return;
      }
      var y2 = -lineBlockLengthY;
      var yId = 0;
      var yIdTotal = 0;
      var xId0 = 0;
      while (y2 < pSize.height) {
        if (yId % 2 === 0) {
          var symbolYId = yIdTotal / 2 % symbolArray.length;
          var x2 = 0;
          var xId1 = 0;
          var xId1Total = 0;
          while (x2 < pSize.width * 2) {
            var xSum = 0;
            for (var i2 = 0; i2 < dashArrayX[xId0].length; ++i2) {
              xSum += dashArrayX[xId0][i2];
            }
            if (xSum <= 0) {
              break;
            }
            if (xId1 % 2 === 0) {
              var size = (1 - decalOpt.symbolSize) * 0.5;
              var left = x2 + dashArrayX[xId0][xId1] * size;
              var top_1 = y2 + dashArrayY[yId] * size;
              var width = dashArrayX[xId0][xId1] * decalOpt.symbolSize;
              var height = dashArrayY[yId] * decalOpt.symbolSize;
              var symbolXId = xId1Total / 2 % symbolArray[symbolYId].length;
              brushSymbol(left, top_1, width, height, symbolArray[symbolYId][symbolXId]);
            }
            x2 += dashArrayX[xId0][xId1];
            ++xId1Total;
            ++xId1;
            if (xId1 === dashArrayX[xId0].length) {
              xId1 = 0;
            }
          }
          ++xId0;
          if (xId0 === dashArrayX.length) {
            xId0 = 0;
          }
        }
        y2 += dashArrayY[yId];
        ++yIdTotal;
        ++yId;
        if (yId === dashArrayY.length) {
          yId = 0;
        }
      }
      function brushSymbol(x3, y3, width2, height2, symbolType) {
        var scale2 = isSVG ? 1 : dpr2;
        var symbol = createSymbol$1(symbolType, x3 * scale2, y3 * scale2, width2 * scale2, height2 * scale2, decalOpt.color, decalOpt.symbolKeepAspect);
        if (isSVG) {
          var symbolVNode = zr.painter.renderOneToVNode(symbol);
          if (symbolVNode) {
            svgRoot.children.push(symbolVNode);
          }
        } else {
          brushSingle(ctx, symbol);
        }
      }
    }
  }
}
function normalizeSymbolArray(symbol) {
  if (!symbol || symbol.length === 0) {
    return [["rect"]];
  }
  if (isString(symbol)) {
    return [[symbol]];
  }
  var isAllString = true;
  for (var i = 0; i < symbol.length; ++i) {
    if (!isString(symbol[i])) {
      isAllString = false;
      break;
    }
  }
  if (isAllString) {
    return normalizeSymbolArray([symbol]);
  }
  var result = [];
  for (var i = 0; i < symbol.length; ++i) {
    if (isString(symbol[i])) {
      result.push([symbol[i]]);
    } else {
      result.push(symbol[i]);
    }
  }
  return result;
}
function normalizeDashArrayX(dash) {
  if (!dash || dash.length === 0) {
    return [[0, 0]];
  }
  if (isNumber(dash)) {
    var dashValue = Math.ceil(dash);
    return [[dashValue, dashValue]];
  }
  var isAllNumber = true;
  for (var i = 0; i < dash.length; ++i) {
    if (!isNumber(dash[i])) {
      isAllNumber = false;
      break;
    }
  }
  if (isAllNumber) {
    return normalizeDashArrayX([dash]);
  }
  var result = [];
  for (var i = 0; i < dash.length; ++i) {
    if (isNumber(dash[i])) {
      var dashValue = Math.ceil(dash[i]);
      result.push([dashValue, dashValue]);
    } else {
      var dashValue = map$1(dash[i], function(n2) {
        return Math.ceil(n2);
      });
      if (dashValue.length % 2 === 1) {
        result.push(dashValue.concat(dashValue));
      } else {
        result.push(dashValue);
      }
    }
  }
  return result;
}
function normalizeDashArrayY(dash) {
  if (!dash || typeof dash === "object" && dash.length === 0) {
    return [0, 0];
  }
  if (isNumber(dash)) {
    var dashValue_1 = Math.ceil(dash);
    return [dashValue_1, dashValue_1];
  }
  var dashValue = map$1(dash, function(n2) {
    return Math.ceil(n2);
  });
  return dash.length % 2 ? dashValue.concat(dashValue) : dashValue;
}
function getLineBlockLengthX(dash) {
  return map$1(dash, function(line) {
    return getLineBlockLengthY(line);
  });
}
function getLineBlockLengthY(dash) {
  var blockLength = 0;
  for (var i = 0; i < dash.length; ++i) {
    blockLength += dash[i];
  }
  if (dash.length % 2 === 1) {
    return blockLength * 2;
  }
  return blockLength;
}
function decalVisual(ecModel, api) {
  ecModel.eachRawSeries(function(seriesModel) {
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    if (data.hasItemVisual()) {
      data.each(function(idx) {
        var decal2 = data.getItemVisual(idx, "decal");
        if (decal2) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          itemStyle.decal = createOrUpdatePatternFromDecal(decal2, api);
        }
      });
    }
    var decal = data.getVisual("decal");
    if (decal) {
      var style = data.getVisual("style");
      style.decal = createOrUpdatePatternFromDecal(decal, api);
    }
  });
}
var lifecycle = new Eventful$1();
var lifecycle$1 = lifecycle;
var implsStore = {};
function registerImpl(name, impl) {
  implsStore[name] = impl;
}
function getImpl(name) {
  return implsStore[name];
}
var hasWindow = typeof window !== "undefined";
var TEST_FRAME_REMAIN_TIME = 1;
var PRIORITY_PROCESSOR_SERIES_FILTER = 800;
var PRIORITY_PROCESSOR_DATASTACK = 900;
var PRIORITY_PROCESSOR_FILTER = 1e3;
var PRIORITY_PROCESSOR_DEFAULT = 2e3;
var PRIORITY_PROCESSOR_STATISTIC = 5e3;
var PRIORITY_VISUAL_LAYOUT = 1e3;
var PRIORITY_VISUAL_PROGRESSIVE_LAYOUT = 1100;
var PRIORITY_VISUAL_GLOBAL = 2e3;
var PRIORITY_VISUAL_CHART = 3e3;
var PRIORITY_VISUAL_COMPONENT = 4e3;
var PRIORITY_VISUAL_CHART_DATA_CUSTOM = 4500;
var PRIORITY_VISUAL_POST_CHART_LAYOUT = 4600;
var PRIORITY_VISUAL_BRUSH = 5e3;
var PRIORITY_VISUAL_ARIA = 6e3;
var PRIORITY_VISUAL_DECAL = 7e3;
var PRIORITY = {
  PROCESSOR: {
    FILTER: PRIORITY_PROCESSOR_FILTER,
    SERIES_FILTER: PRIORITY_PROCESSOR_SERIES_FILTER,
    STATISTIC: PRIORITY_PROCESSOR_STATISTIC
  },
  VISUAL: {
    LAYOUT: PRIORITY_VISUAL_LAYOUT,
    PROGRESSIVE_LAYOUT: PRIORITY_VISUAL_PROGRESSIVE_LAYOUT,
    GLOBAL: PRIORITY_VISUAL_GLOBAL,
    CHART: PRIORITY_VISUAL_CHART,
    POST_CHART_LAYOUT: PRIORITY_VISUAL_POST_CHART_LAYOUT,
    COMPONENT: PRIORITY_VISUAL_COMPONENT,
    BRUSH: PRIORITY_VISUAL_BRUSH,
    CHART_ITEM: PRIORITY_VISUAL_CHART_DATA_CUSTOM,
    ARIA: PRIORITY_VISUAL_ARIA,
    DECAL: PRIORITY_VISUAL_DECAL
  }
};
var IN_MAIN_PROCESS_KEY = "__flagInMainProcess";
var PENDING_UPDATE = "__pendingUpdate";
var STATUS_NEEDS_UPDATE_KEY = "__needsUpdateStatus";
var ACTION_REG = /^[a-zA-Z0-9_]+$/;
var CONNECT_STATUS_KEY = "__connectUpdateStatus";
var CONNECT_STATUS_PENDING = 0;
var CONNECT_STATUS_UPDATING = 1;
var CONNECT_STATUS_UPDATED = 2;
function createRegisterEventWithLowercaseECharts(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    if (this.isDisposed()) {
      disposedWarning(this.id);
      return;
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function createRegisterEventWithLowercaseMessageCenter(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function toLowercaseNameAndCallEventful(host, method4, args) {
  args[0] = args[0] && args[0].toLowerCase();
  return Eventful$1.prototype[method4].apply(host, args);
}
var MessageCenter = function(_super) {
  __extends(MessageCenter2, _super);
  function MessageCenter2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return MessageCenter2;
}(Eventful$1);
var messageCenterProto = MessageCenter.prototype;
messageCenterProto.on = createRegisterEventWithLowercaseMessageCenter("on");
messageCenterProto.off = createRegisterEventWithLowercaseMessageCenter("off");
var prepare;
var prepareView;
var updateDirectly;
var updateMethods;
var doConvertPixel;
var updateStreamModes;
var doDispatchAction;
var flushPendingActions;
var triggerUpdatedEvent;
var bindRenderedEvent;
var bindMouseEvent;
var render;
var renderComponents;
var renderSeries;
var createExtensionAPI;
var enableConnect;
var markStatusToUpdate;
var applyChangedStates;
var ECharts = function(_super) {
  __extends(ECharts2, _super);
  function ECharts2(dom, theme2, opts) {
    var _this = _super.call(this, new ECEventProcessor()) || this;
    _this._chartsViews = [];
    _this._chartsMap = {};
    _this._componentsViews = [];
    _this._componentsMap = {};
    _this._pendingActions = [];
    opts = opts || {};
    if (isString(theme2)) {
      theme2 = themeStorage[theme2];
    }
    _this._dom = dom;
    var defaultRenderer = "canvas";
    var defaultUseDirtyRect = false;
    var zr = _this._zr = init$2(dom, {
      renderer: opts.renderer || defaultRenderer,
      devicePixelRatio: opts.devicePixelRatio,
      width: opts.width,
      height: opts.height,
      ssr: opts.ssr,
      useDirtyRect: opts.useDirtyRect == null ? defaultUseDirtyRect : opts.useDirtyRect
    });
    _this._ssr = opts.ssr;
    _this._throttledZrFlush = throttle(bind$1(zr.flush, zr), 17);
    theme2 = clone$4(theme2);
    theme2 && globalBackwardCompat(theme2, true);
    _this._theme = theme2;
    _this._locale = createLocaleObject(opts.locale || SYSTEM_LANG);
    _this._coordSysMgr = new CoordinateSystem();
    var api = _this._api = createExtensionAPI(_this);
    function prioritySortFunc(a, b2) {
      return a.__prio - b2.__prio;
    }
    sort$2(visualFuncs, prioritySortFunc);
    sort$2(dataProcessorFuncs, prioritySortFunc);
    _this._scheduler = new Scheduler$1(_this, api, dataProcessorFuncs, visualFuncs);
    _this._messageCenter = new MessageCenter();
    _this._initEvents();
    _this.resize = bind$1(_this.resize, _this);
    zr.animation.on("frame", _this._onframe, _this);
    bindRenderedEvent(zr, _this);
    bindMouseEvent(zr, _this);
    setAsPrimitive(_this);
    return _this;
  }
  ECharts2.prototype._onframe = function() {
    if (this._disposed) {
      return;
    }
    applyChangedStates(this);
    var scheduler = this._scheduler;
    if (this[PENDING_UPDATE]) {
      var silent = this[PENDING_UPDATE].silent;
      this[IN_MAIN_PROCESS_KEY] = true;
      try {
        prepare(this);
        updateMethods.update.call(this, null, this[PENDING_UPDATE].updateParams);
      } catch (e2) {
        this[IN_MAIN_PROCESS_KEY] = false;
        this[PENDING_UPDATE] = null;
        throw e2;
      }
      this._zr.flush();
      this[IN_MAIN_PROCESS_KEY] = false;
      this[PENDING_UPDATE] = null;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    } else if (scheduler.unfinished) {
      var remainTime = TEST_FRAME_REMAIN_TIME;
      var ecModel = this._model;
      var api = this._api;
      scheduler.unfinished = false;
      do {
        var startTime = +new Date();
        scheduler.performSeriesTasks(ecModel);
        scheduler.performDataProcessorTasks(ecModel);
        updateStreamModes(this, ecModel);
        scheduler.performVisualTasks(ecModel);
        renderSeries(this, this._model, api, "remain", {});
        remainTime -= +new Date() - startTime;
      } while (remainTime > 0 && scheduler.unfinished);
      if (!scheduler.unfinished) {
        this._zr.flush();
      }
    }
  };
  ECharts2.prototype.getDom = function() {
    return this._dom;
  };
  ECharts2.prototype.getId = function() {
    return this.id;
  };
  ECharts2.prototype.getZr = function() {
    return this._zr;
  };
  ECharts2.prototype.isSSR = function() {
    return this._ssr;
  };
  ECharts2.prototype.setOption = function(option, notMerge, lazyUpdate) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var silent;
    var replaceMerge;
    var transitionOpt;
    if (isObject$4(notMerge)) {
      lazyUpdate = notMerge.lazyUpdate;
      silent = notMerge.silent;
      replaceMerge = notMerge.replaceMerge;
      transitionOpt = notMerge.transition;
      notMerge = notMerge.notMerge;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    if (!this._model || notMerge) {
      var optionManager = new OptionManager$1(this._api);
      var theme2 = this._theme;
      var ecModel = this._model = new GlobalModel$1();
      ecModel.scheduler = this._scheduler;
      ecModel.ssr = this._ssr;
      ecModel.init(null, null, null, theme2, this._locale, optionManager);
    }
    this._model.setOption(option, {
      replaceMerge
    }, optionPreprocessorFuncs);
    var updateParams = {
      seriesTransition: transitionOpt,
      optionChanged: true
    };
    if (lazyUpdate) {
      this[PENDING_UPDATE] = {
        silent,
        updateParams
      };
      this[IN_MAIN_PROCESS_KEY] = false;
      this.getZr().wakeUp();
    } else {
      try {
        prepare(this);
        updateMethods.update.call(this, null, updateParams);
      } catch (e2) {
        this[PENDING_UPDATE] = null;
        this[IN_MAIN_PROCESS_KEY] = false;
        throw e2;
      }
      if (!this._ssr) {
        this._zr.flush();
      }
      this[PENDING_UPDATE] = null;
      this[IN_MAIN_PROCESS_KEY] = false;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    }
  };
  ECharts2.prototype.setTheme = function() {
  };
  ECharts2.prototype.getModel = function() {
    return this._model;
  };
  ECharts2.prototype.getOption = function() {
    return this._model && this._model.getOption();
  };
  ECharts2.prototype.getWidth = function() {
    return this._zr.getWidth();
  };
  ECharts2.prototype.getHeight = function() {
    return this._zr.getHeight();
  };
  ECharts2.prototype.getDevicePixelRatio = function() {
    return this._zr.painter.dpr || hasWindow && window.devicePixelRatio || 1;
  };
  ECharts2.prototype.getRenderedCanvas = function(opts) {
    return this.renderToCanvas(opts);
  };
  ECharts2.prototype.renderToCanvas = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.getRenderedCanvas({
      backgroundColor: opts.backgroundColor || this._model.get("backgroundColor"),
      pixelRatio: opts.pixelRatio || this.getDevicePixelRatio()
    });
  };
  ECharts2.prototype.renderToSVGString = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.renderToString({
      useViewBox: opts.useViewBox
    });
  };
  ECharts2.prototype.getSvgDataURL = function() {
    if (!env$1.svgSupported) {
      return;
    }
    var zr = this._zr;
    var list = zr.storage.getDisplayList();
    each$f(list, function(el) {
      el.stopAnimation(null, true);
    });
    return zr.painter.toDataURL();
  };
  ECharts2.prototype.getDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    opts = opts || {};
    var excludeComponents = opts.excludeComponents;
    var ecModel = this._model;
    var excludesComponentViews = [];
    var self2 = this;
    each$f(excludeComponents, function(componentType) {
      ecModel.eachComponent({
        mainType: componentType
      }, function(component) {
        var view = self2._componentsMap[component.__viewId];
        if (!view.group.ignore) {
          excludesComponentViews.push(view);
          view.group.ignore = true;
        }
      });
    });
    var url2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(opts).toDataURL("image/" + (opts && opts.type || "png"));
    each$f(excludesComponentViews, function(view) {
      view.group.ignore = false;
    });
    return url2;
  };
  ECharts2.prototype.getConnectedDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var isSvg = opts.type === "svg";
    var groupId = this.group;
    var mathMin2 = Math.min;
    var mathMax2 = Math.max;
    var MAX_NUMBER = Infinity;
    if (connectedGroups[groupId]) {
      var left_1 = MAX_NUMBER;
      var top_1 = MAX_NUMBER;
      var right_1 = -MAX_NUMBER;
      var bottom_1 = -MAX_NUMBER;
      var canvasList_1 = [];
      var dpr_1 = opts && opts.pixelRatio || this.getDevicePixelRatio();
      each$f(instances, function(chart, id2) {
        if (chart.group === groupId) {
          var canvas = isSvg ? chart.getZr().painter.getSvgDom().innerHTML : chart.renderToCanvas(clone$4(opts));
          var boundingRect = chart.getDom().getBoundingClientRect();
          left_1 = mathMin2(boundingRect.left, left_1);
          top_1 = mathMin2(boundingRect.top, top_1);
          right_1 = mathMax2(boundingRect.right, right_1);
          bottom_1 = mathMax2(boundingRect.bottom, bottom_1);
          canvasList_1.push({
            dom: canvas,
            left: boundingRect.left,
            top: boundingRect.top
          });
        }
      });
      left_1 *= dpr_1;
      top_1 *= dpr_1;
      right_1 *= dpr_1;
      bottom_1 *= dpr_1;
      var width = right_1 - left_1;
      var height = bottom_1 - top_1;
      var targetCanvas = platformApi.createCanvas();
      var zr_1 = init$2(targetCanvas, {
        renderer: isSvg ? "svg" : "canvas"
      });
      zr_1.resize({
        width,
        height
      });
      if (isSvg) {
        var content_1 = "";
        each$f(canvasList_1, function(item) {
          var x2 = item.left - left_1;
          var y2 = item.top - top_1;
          content_1 += '<g transform="translate(' + x2 + "," + y2 + ')">' + item.dom + "</g>";
        });
        zr_1.painter.getSvgRoot().innerHTML = content_1;
        if (opts.connectedBackgroundColor) {
          zr_1.painter.setBackgroundColor(opts.connectedBackgroundColor);
        }
        zr_1.refreshImmediately();
        return zr_1.painter.toDataURL();
      } else {
        if (opts.connectedBackgroundColor) {
          zr_1.add(new Rect$3({
            shape: {
              x: 0,
              y: 0,
              width,
              height
            },
            style: {
              fill: opts.connectedBackgroundColor
            }
          }));
        }
        each$f(canvasList_1, function(item) {
          var img = new ZRImage$1({
            style: {
              x: item.left * dpr_1 - left_1,
              y: item.top * dpr_1 - top_1,
              image: item.dom
            }
          });
          zr_1.add(img);
        });
        zr_1.refreshImmediately();
        return targetCanvas.toDataURL("image/" + (opts && opts.type || "png"));
      }
    } else {
      return this.getDataURL(opts);
    }
  };
  ECharts2.prototype.convertToPixel = function(finder, value) {
    return doConvertPixel(this, "convertToPixel", finder, value);
  };
  ECharts2.prototype.convertFromPixel = function(finder, value) {
    return doConvertPixel(this, "convertFromPixel", finder, value);
  };
  ECharts2.prototype.containPixel = function(finder, value) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var ecModel = this._model;
    var result;
    var findResult = parseFinder$1(ecModel, finder);
    each$f(findResult, function(models, key) {
      key.indexOf("Models") >= 0 && each$f(models, function(model) {
        var coordSys = model.coordinateSystem;
        if (coordSys && coordSys.containPoint) {
          result = result || !!coordSys.containPoint(value);
        } else if (key === "seriesModels") {
          var view = this._chartsMap[model.__viewId];
          if (view && view.containPoint) {
            result = result || view.containPoint(value, model);
          }
        } else
          ;
      }, this);
    }, this);
    return !!result;
  };
  ECharts2.prototype.getVisual = function(finder, visualType) {
    var ecModel = this._model;
    var parsedFinder = parseFinder$1(ecModel, finder, {
      defaultMainType: "series"
    });
    var seriesModel = parsedFinder.seriesModel;
    var data = seriesModel.getData();
    var dataIndexInside = parsedFinder.hasOwnProperty("dataIndexInside") ? parsedFinder.dataIndexInside : parsedFinder.hasOwnProperty("dataIndex") ? data.indexOfRawIndex(parsedFinder.dataIndex) : null;
    return dataIndexInside != null ? getItemVisualFromData(data, dataIndexInside, visualType) : getVisualFromData(data, visualType);
  };
  ECharts2.prototype.getViewOfComponentModel = function(componentModel) {
    return this._componentsMap[componentModel.__viewId];
  };
  ECharts2.prototype.getViewOfSeriesModel = function(seriesModel) {
    return this._chartsMap[seriesModel.__viewId];
  };
  ECharts2.prototype._initEvents = function() {
    var _this = this;
    each$f(MOUSE_EVENT_NAMES, function(eveName) {
      var handler = function(e2) {
        var ecModel = _this.getModel();
        var el = e2.target;
        var params;
        var isGlobalOut = eveName === "globalout";
        if (isGlobalOut) {
          params = {};
        } else {
          el && findEventDispatcher(el, function(parent) {
            var ecData = getECData(parent);
            if (ecData && ecData.dataIndex != null) {
              var dataModel = ecData.dataModel || ecModel.getSeriesByIndex(ecData.seriesIndex);
              params = dataModel && dataModel.getDataParams(ecData.dataIndex, ecData.dataType) || {};
              return true;
            } else if (ecData.eventData) {
              params = extend({}, ecData.eventData);
              return true;
            }
          }, true);
        }
        if (params) {
          var componentType = params.componentType;
          var componentIndex = params.componentIndex;
          if (componentType === "markLine" || componentType === "markPoint" || componentType === "markArea") {
            componentType = "series";
            componentIndex = params.seriesIndex;
          }
          var model = componentType && componentIndex != null && ecModel.getComponent(componentType, componentIndex);
          var view = model && _this[model.mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId];
          params.event = e2;
          params.type = eveName;
          _this._$eventProcessor.eventInfo = {
            targetEl: el,
            packedEvent: params,
            model,
            view
          };
          _this.trigger(eveName, params);
        }
      };
      handler.zrEventfulCallAtLast = true;
      _this._zr.on(eveName, handler, _this);
    });
    each$f(eventActionMap, function(actionType, eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    each$f(["selectchanged"], function(eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    handleLegacySelectEvents(this._messageCenter, this, this._api);
  };
  ECharts2.prototype.isDisposed = function() {
    return this._disposed;
  };
  ECharts2.prototype.clear = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this.setOption({
      series: []
    }, true);
  };
  ECharts2.prototype.dispose = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._disposed = true;
    var dom = this.getDom();
    if (dom) {
      setAttribute(this.getDom(), DOM_ATTRIBUTE_KEY, "");
    }
    var chart = this;
    var api = chart._api;
    var ecModel = chart._model;
    each$f(chart._componentsViews, function(component) {
      component.dispose(ecModel, api);
    });
    each$f(chart._chartsViews, function(chart2) {
      chart2.dispose(ecModel, api);
    });
    chart._zr.dispose();
    chart._dom = chart._model = chart._chartsMap = chart._componentsMap = chart._chartsViews = chart._componentsViews = chart._scheduler = chart._api = chart._zr = chart._throttledZrFlush = chart._theme = chart._coordSysMgr = chart._messageCenter = null;
    delete instances[chart.id];
  };
  ECharts2.prototype.resize = function(opts) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._zr.resize(opts);
    var ecModel = this._model;
    this._loadingFX && this._loadingFX.resize();
    if (!ecModel) {
      return;
    }
    var needPrepare = ecModel.resetOption("media");
    var silent = opts && opts.silent;
    if (this[PENDING_UPDATE]) {
      if (silent == null) {
        silent = this[PENDING_UPDATE].silent;
      }
      needPrepare = true;
      this[PENDING_UPDATE] = null;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    try {
      needPrepare && prepare(this);
      updateMethods.update.call(this, {
        type: "resize",
        animation: extend({
          duration: 0
        }, opts && opts.animation)
      });
    } catch (e2) {
      this[IN_MAIN_PROCESS_KEY] = false;
      throw e2;
    }
    this[IN_MAIN_PROCESS_KEY] = false;
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.showLoading = function(name, cfg) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (isObject$4(name)) {
      cfg = name;
      name = "";
    }
    name = name || "default";
    this.hideLoading();
    if (!loadingEffects[name]) {
      return;
    }
    var el = loadingEffects[name](this._api, cfg);
    var zr = this._zr;
    this._loadingFX = el;
    zr.add(el);
  };
  ECharts2.prototype.hideLoading = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._loadingFX && this._zr.remove(this._loadingFX);
    this._loadingFX = null;
  };
  ECharts2.prototype.makeActionFromEvent = function(eventObj) {
    var payload = extend({}, eventObj);
    payload.type = eventActionMap[eventObj.type];
    return payload;
  };
  ECharts2.prototype.dispatchAction = function(payload, opt) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (!isObject$4(opt)) {
      opt = {
        silent: !!opt
      };
    }
    if (!actions[payload.type]) {
      return;
    }
    if (!this._model) {
      return;
    }
    if (this[IN_MAIN_PROCESS_KEY]) {
      this._pendingActions.push(payload);
      return;
    }
    var silent = opt.silent;
    doDispatchAction.call(this, payload, silent);
    var flush = opt.flush;
    if (flush) {
      this._zr.flush();
    } else if (flush !== false && env$1.browser.weChat) {
      this._throttledZrFlush();
    }
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.updateLabelLayout = function() {
    lifecycle$1.trigger("series:layoutlabels", this._model, this._api, {
      updatedSeries: []
    });
  };
  ECharts2.prototype.appendData = function(params) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var seriesIndex = params.seriesIndex;
    var ecModel = this.getModel();
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    seriesModel.appendData(params);
    this._scheduler.unfinished = true;
    this.getZr().wakeUp();
  };
  ECharts2.internalField = function() {
    prepare = function(ecIns) {
      var scheduler = ecIns._scheduler;
      scheduler.restorePipelines(ecIns._model);
      scheduler.prepareStageTasks();
      prepareView(ecIns, true);
      prepareView(ecIns, false);
      scheduler.plan();
    };
    prepareView = function(ecIns, isComponent) {
      var ecModel = ecIns._model;
      var scheduler = ecIns._scheduler;
      var viewList = isComponent ? ecIns._componentsViews : ecIns._chartsViews;
      var viewMap = isComponent ? ecIns._componentsMap : ecIns._chartsMap;
      var zr = ecIns._zr;
      var api = ecIns._api;
      for (var i = 0; i < viewList.length; i++) {
        viewList[i].__alive = false;
      }
      isComponent ? ecModel.eachComponent(function(componentType, model) {
        componentType !== "series" && doPrepare(model);
      }) : ecModel.eachSeries(doPrepare);
      function doPrepare(model) {
        var requireNewView = model.__requireNewView;
        model.__requireNewView = false;
        var viewId = "_ec_" + model.id + "_" + model.type;
        var view2 = !requireNewView && viewMap[viewId];
        if (!view2) {
          var classType = parseClassType(model.type);
          var Clazz = isComponent ? ComponentView$1.getClass(classType.main, classType.sub) : ChartView$1.getClass(classType.sub);
          view2 = new Clazz();
          view2.init(ecModel, api);
          viewMap[viewId] = view2;
          viewList.push(view2);
          zr.add(view2.group);
        }
        model.__viewId = view2.__id = viewId;
        view2.__alive = true;
        view2.__model = model;
        view2.group.__ecComponentInfo = {
          mainType: model.mainType,
          index: model.componentIndex
        };
        !isComponent && scheduler.prepareView(view2, model, ecModel, api);
      }
      for (var i = 0; i < viewList.length; ) {
        var view = viewList[i];
        if (!view.__alive) {
          !isComponent && view.renderTask.dispose();
          zr.remove(view.group);
          view.dispose(ecModel, api);
          viewList.splice(i, 1);
          if (viewMap[view.__id] === view) {
            delete viewMap[view.__id];
          }
          view.__id = view.group.__ecComponentInfo = null;
        } else {
          i++;
        }
      }
    };
    updateDirectly = function(ecIns, method4, payload, mainType, subType) {
      var ecModel = ecIns._model;
      ecModel.setUpdatePayload(payload);
      if (!mainType) {
        each$f([].concat(ecIns._componentsViews).concat(ecIns._chartsViews), callView);
        return;
      }
      var query = {};
      query[mainType + "Id"] = payload[mainType + "Id"];
      query[mainType + "Index"] = payload[mainType + "Index"];
      query[mainType + "Name"] = payload[mainType + "Name"];
      var condition = {
        mainType,
        query
      };
      subType && (condition.subType = subType);
      var excludeSeriesId = payload.excludeSeriesId;
      var excludeSeriesIdMap;
      if (excludeSeriesId != null) {
        excludeSeriesIdMap = createHashMap();
        each$f(normalizeToArray(excludeSeriesId), function(id2) {
          var modelId = convertOptionIdName(id2, null);
          if (modelId != null) {
            excludeSeriesIdMap.set(modelId, true);
          }
        });
      }
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        if (isHighDownPayload(payload)) {
          if (model instanceof SeriesModel$1) {
            if (payload.type === HIGHLIGHT_ACTION_TYPE && !payload.notBlur && !model.get(["emphasis", "disabled"])) {
              blurSeriesFromHighlightPayload(model, payload, ecIns._api);
            }
          } else {
            var _a2 = findComponentHighDownDispatchers(model.mainType, model.componentIndex, payload.name, ecIns._api), focusSelf = _a2.focusSelf, dispatchers = _a2.dispatchers;
            if (payload.type === HIGHLIGHT_ACTION_TYPE && focusSelf && !payload.notBlur) {
              blurComponent(model.mainType, model.componentIndex, ecIns._api);
            }
            if (dispatchers) {
              each$f(dispatchers, function(dispatcher) {
                payload.type === HIGHLIGHT_ACTION_TYPE ? enterEmphasis(dispatcher) : leaveEmphasis(dispatcher);
              });
            }
          }
        } else if (isSelectChangePayload(payload)) {
          if (model instanceof SeriesModel$1) {
            toggleSelectionFromPayload(model, payload, ecIns._api);
            updateSeriesElementSelection(model);
            markStatusToUpdate(ecIns);
          }
        }
      }, ecIns);
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        callView(ecIns[mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId]);
      }, ecIns);
      function callView(view) {
        view && view.__alive && view[method4] && view[method4](view.__model, ecModel, ecIns._api, payload);
      }
    };
    updateMethods = {
      prepareAndUpdate: function(payload) {
        prepare(this);
        updateMethods.update.call(this, payload, {
          optionChanged: payload.newOption != null
        });
      },
      update: function(payload, updateParams) {
        var ecModel = this._model;
        var api = this._api;
        var zr = this._zr;
        var coordSysMgr = this._coordSysMgr;
        var scheduler = this._scheduler;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        scheduler.restoreData(ecModel, payload);
        scheduler.performSeriesTasks(ecModel);
        coordSysMgr.create(ecModel, api);
        scheduler.performDataProcessorTasks(ecModel, payload);
        updateStreamModes(this, ecModel);
        coordSysMgr.update(ecModel, api);
        clearColorPalette(ecModel);
        scheduler.performVisualTasks(ecModel, payload);
        render(this, ecModel, api, payload, updateParams);
        var backgroundColor2 = ecModel.get("backgroundColor") || "transparent";
        var darkMode = ecModel.get("darkMode");
        zr.setBackgroundColor(backgroundColor2);
        if (darkMode != null && darkMode !== "auto") {
          zr.setDarkMode(darkMode);
        }
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateTransform: function(payload) {
        var _this = this;
        var ecModel = this._model;
        var api = this._api;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        var componentDirtyList = [];
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType === "series") {
            return;
          }
          var componentView = _this.getViewOfComponentModel(componentModel);
          if (componentView && componentView.__alive) {
            if (componentView.updateTransform) {
              var result = componentView.updateTransform(componentModel, ecModel, api, payload);
              result && result.update && componentDirtyList.push(componentView);
            } else {
              componentDirtyList.push(componentView);
            }
          }
        });
        var seriesDirtyMap = createHashMap();
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          if (chartView.updateTransform) {
            var result = chartView.updateTransform(seriesModel, ecModel, api, payload);
            result && result.update && seriesDirtyMap.set(seriesModel.uid, 1);
          } else {
            seriesDirtyMap.set(seriesModel.uid, 1);
          }
        });
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true,
          dirtyMap: seriesDirtyMap
        });
        renderSeries(this, ecModel, api, payload, {}, seriesDirtyMap);
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateView: function(payload) {
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ChartView$1.markUpdateMethod(payload, "updateView");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true
        });
        render(this, ecModel, this._api, payload, {});
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateVisual: function(payload) {
        var _this = this;
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ecModel.eachSeries(function(seriesModel) {
          seriesModel.getData().clearAllVisual();
        });
        ChartView$1.markUpdateMethod(payload, "updateVisual");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          visualType: "visual",
          setDirty: true
        });
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType !== "series") {
            var componentView = _this.getViewOfComponentModel(componentModel);
            componentView && componentView.__alive && componentView.updateVisual(componentModel, ecModel, _this._api, payload);
          }
        });
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          chartView.updateVisual(seriesModel, ecModel, _this._api, payload);
        });
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateLayout: function(payload) {
        updateMethods.update.call(this, payload);
      }
    };
    doConvertPixel = function(ecIns, methodName, finder, value) {
      if (ecIns._disposed) {
        disposedWarning(ecIns.id);
        return;
      }
      var ecModel = ecIns._model;
      var coordSysList = ecIns._coordSysMgr.getCoordinateSystems();
      var result;
      var parsedFinder = parseFinder$1(ecModel, finder);
      for (var i = 0; i < coordSysList.length; i++) {
        var coordSys = coordSysList[i];
        if (coordSys[methodName] && (result = coordSys[methodName](ecModel, parsedFinder, value)) != null) {
          return result;
        }
      }
    };
    updateStreamModes = function(ecIns, ecModel) {
      var chartsMap = ecIns._chartsMap;
      var scheduler = ecIns._scheduler;
      ecModel.eachSeries(function(seriesModel) {
        scheduler.updateStreamModes(seriesModel, chartsMap[seriesModel.__viewId]);
      });
    };
    doDispatchAction = function(payload, silent) {
      var _this = this;
      var ecModel = this.getModel();
      var payloadType = payload.type;
      var escapeConnect = payload.escapeConnect;
      var actionWrap = actions[payloadType];
      var actionInfo2 = actionWrap.actionInfo;
      var cptTypeTmp = (actionInfo2.update || "update").split(":");
      var updateMethod = cptTypeTmp.pop();
      var cptType = cptTypeTmp[0] != null && parseClassType(cptTypeTmp[0]);
      this[IN_MAIN_PROCESS_KEY] = true;
      var payloads = [payload];
      var batched = false;
      if (payload.batch) {
        batched = true;
        payloads = map$1(payload.batch, function(item) {
          item = defaults(extend({}, item), payload);
          item.batch = null;
          return item;
        });
      }
      var eventObjBatch = [];
      var eventObj;
      var isSelectChange = isSelectChangePayload(payload);
      var isHighDown = isHighDownPayload(payload);
      if (isHighDown) {
        allLeaveBlur(this._api);
      }
      each$f(payloads, function(batchItem) {
        eventObj = actionWrap.action(batchItem, _this._model, _this._api);
        eventObj = eventObj || extend({}, batchItem);
        eventObj.type = actionInfo2.event || eventObj.type;
        eventObjBatch.push(eventObj);
        if (isHighDown) {
          var _a2 = preParseFinder(payload), queryOptionMap = _a2.queryOptionMap, mainTypeSpecified = _a2.mainTypeSpecified;
          var componentMainType = mainTypeSpecified ? queryOptionMap.keys()[0] : "series";
          updateDirectly(_this, updateMethod, batchItem, componentMainType);
          markStatusToUpdate(_this);
        } else if (isSelectChange) {
          updateDirectly(_this, updateMethod, batchItem, "series");
          markStatusToUpdate(_this);
        } else if (cptType) {
          updateDirectly(_this, updateMethod, batchItem, cptType.main, cptType.sub);
        }
      });
      if (updateMethod !== "none" && !isHighDown && !isSelectChange && !cptType) {
        try {
          if (this[PENDING_UPDATE]) {
            prepare(this);
            updateMethods.update.call(this, payload);
            this[PENDING_UPDATE] = null;
          } else {
            updateMethods[updateMethod].call(this, payload);
          }
        } catch (e2) {
          this[IN_MAIN_PROCESS_KEY] = false;
          throw e2;
        }
      }
      if (batched) {
        eventObj = {
          type: actionInfo2.event || payloadType,
          escapeConnect,
          batch: eventObjBatch
        };
      } else {
        eventObj = eventObjBatch[0];
      }
      this[IN_MAIN_PROCESS_KEY] = false;
      if (!silent) {
        var messageCenter = this._messageCenter;
        messageCenter.trigger(eventObj.type, eventObj);
        if (isSelectChange) {
          var newObj = {
            type: "selectchanged",
            escapeConnect,
            selected: getAllSelectedIndices(ecModel),
            isFromClick: payload.isFromClick || false,
            fromAction: payload.type,
            fromActionPayload: payload
          };
          messageCenter.trigger(newObj.type, newObj);
        }
      }
    };
    flushPendingActions = function(silent) {
      var pendingActions = this._pendingActions;
      while (pendingActions.length) {
        var payload = pendingActions.shift();
        doDispatchAction.call(this, payload, silent);
      }
    };
    triggerUpdatedEvent = function(silent) {
      !silent && this.trigger("updated");
    };
    bindRenderedEvent = function(zr, ecIns) {
      zr.on("rendered", function(params) {
        ecIns.trigger("rendered", params);
        if (zr.animation.isFinished() && !ecIns[PENDING_UPDATE] && !ecIns._scheduler.unfinished && !ecIns._pendingActions.length) {
          ecIns.trigger("finished");
        }
      });
    };
    bindMouseEvent = function(zr, ecIns) {
      zr.on("mouseover", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOverForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("mouseout", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOutForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("click", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, function(target) {
          return getECData(target).dataIndex != null;
        }, true);
        if (dispatcher) {
          var actionType = dispatcher.selected ? "unselect" : "select";
          var ecData = getECData(dispatcher);
          ecIns._api.dispatchAction({
            type: actionType,
            dataType: ecData.dataType,
            dataIndexInside: ecData.dataIndex,
            seriesIndex: ecData.seriesIndex,
            isFromClick: true
          });
        }
      });
    };
    function clearColorPalette(ecModel) {
      ecModel.clearColorPalette();
      ecModel.eachSeries(function(seriesModel) {
        seriesModel.clearColorPalette();
      });
    }
    function allocateZlevels(ecModel) {
      var componentZLevels = [];
      var seriesZLevels = [];
      var hasSeperateZLevel = false;
      ecModel.eachComponent(function(componentType, componentModel) {
        var zlevel = componentModel.get("zlevel") || 0;
        var z2 = componentModel.get("z") || 0;
        var zlevelKey = componentModel.getZLevelKey();
        hasSeperateZLevel = hasSeperateZLevel || !!zlevelKey;
        (componentType === "series" ? seriesZLevels : componentZLevels).push({
          zlevel,
          z: z2,
          idx: componentModel.componentIndex,
          type: componentType,
          key: zlevelKey
        });
      });
      if (hasSeperateZLevel) {
        var zLevels = componentZLevels.concat(seriesZLevels);
        var lastSeriesZLevel_1;
        var lastSeriesKey_1;
        sort$2(zLevels, function(a, b2) {
          if (a.zlevel === b2.zlevel) {
            return a.z - b2.z;
          }
          return a.zlevel - b2.zlevel;
        });
        each$f(zLevels, function(item) {
          var componentModel = ecModel.getComponent(item.type, item.idx);
          var zlevel = item.zlevel;
          var key = item.key;
          if (lastSeriesZLevel_1 != null) {
            zlevel = Math.max(lastSeriesZLevel_1, zlevel);
          }
          if (key) {
            if (zlevel === lastSeriesZLevel_1 && key !== lastSeriesKey_1) {
              zlevel++;
            }
            lastSeriesKey_1 = key;
          } else if (lastSeriesKey_1) {
            if (zlevel === lastSeriesZLevel_1) {
              zlevel++;
            }
            lastSeriesKey_1 = "";
          }
          lastSeriesZLevel_1 = zlevel;
          componentModel.setZLevel(zlevel);
        });
      }
    }
    render = function(ecIns, ecModel, api, payload, updateParams) {
      allocateZlevels(ecModel);
      renderComponents(ecIns, ecModel, api, payload, updateParams);
      each$f(ecIns._chartsViews, function(chart) {
        chart.__alive = false;
      });
      renderSeries(ecIns, ecModel, api, payload, updateParams);
      each$f(ecIns._chartsViews, function(chart) {
        if (!chart.__alive) {
          chart.remove(ecModel, api);
        }
      });
    };
    renderComponents = function(ecIns, ecModel, api, payload, updateParams, dirtyList) {
      each$f(dirtyList || ecIns._componentsViews, function(componentView) {
        var componentModel = componentView.__model;
        clearStates(componentModel, componentView);
        componentView.render(componentModel, ecModel, api, payload);
        updateZ2(componentModel, componentView);
        updateStates(componentModel, componentView);
      });
    };
    renderSeries = function(ecIns, ecModel, api, payload, updateParams, dirtyMap) {
      var scheduler = ecIns._scheduler;
      updateParams = extend(updateParams || {}, {
        updatedSeries: ecModel.getSeries()
      });
      lifecycle$1.trigger("series:beforeupdate", ecModel, api, updateParams);
      var unfinished = false;
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        chartView.__alive = true;
        var renderTask = chartView.renderTask;
        scheduler.updatePayload(renderTask, payload);
        clearStates(seriesModel, chartView);
        if (dirtyMap && dirtyMap.get(seriesModel.uid)) {
          renderTask.dirty();
        }
        if (renderTask.perform(scheduler.getPerformArgs(renderTask))) {
          unfinished = true;
        }
        chartView.group.silent = !!seriesModel.get("silent");
        updateBlend(seriesModel, chartView);
        updateSeriesElementSelection(seriesModel);
      });
      scheduler.unfinished = unfinished || scheduler.unfinished;
      lifecycle$1.trigger("series:layoutlabels", ecModel, api, updateParams);
      lifecycle$1.trigger("series:transition", ecModel, api, updateParams);
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        updateZ2(seriesModel, chartView);
        updateStates(seriesModel, chartView);
      });
      updateHoverLayerStatus(ecIns, ecModel);
      lifecycle$1.trigger("series:afterupdate", ecModel, api, updateParams);
    };
    markStatusToUpdate = function(ecIns) {
      ecIns[STATUS_NEEDS_UPDATE_KEY] = true;
      ecIns.getZr().wakeUp();
    };
    applyChangedStates = function(ecIns) {
      if (!ecIns[STATUS_NEEDS_UPDATE_KEY]) {
        return;
      }
      ecIns.getZr().storage.traverse(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        applyElementStates(el);
      });
      ecIns[STATUS_NEEDS_UPDATE_KEY] = false;
    };
    function applyElementStates(el) {
      var newStates = [];
      var oldStates = el.currentStates;
      for (var i = 0; i < oldStates.length; i++) {
        var stateName = oldStates[i];
        if (!(stateName === "emphasis" || stateName === "blur" || stateName === "select")) {
          newStates.push(stateName);
        }
      }
      if (el.selected && el.states.select) {
        newStates.push("select");
      }
      if (el.hoverState === HOVER_STATE_EMPHASIS && el.states.emphasis) {
        newStates.push("emphasis");
      } else if (el.hoverState === HOVER_STATE_BLUR && el.states.blur) {
        newStates.push("blur");
      }
      el.useStates(newStates);
    }
    function updateHoverLayerStatus(ecIns, ecModel) {
      var zr = ecIns._zr;
      var storage2 = zr.storage;
      var elCount = 0;
      storage2.traverse(function(el) {
        if (!el.isGroup) {
          elCount++;
        }
      });
      if (elCount > ecModel.get("hoverLayerThreshold") && !env$1.node && !env$1.worker) {
        ecModel.eachSeries(function(seriesModel) {
          if (seriesModel.preventUsingHoverLayer) {
            return;
          }
          var chartView = ecIns._chartsMap[seriesModel.__viewId];
          if (chartView.__alive) {
            chartView.eachRendered(function(el) {
              if (el.states.emphasis) {
                el.states.emphasis.hoverLayer = true;
              }
            });
          }
        });
      }
    }
    function updateBlend(seriesModel, chartView) {
      var blendMode = seriesModel.get("blendMode") || null;
      chartView.eachRendered(function(el) {
        if (!el.isGroup) {
          el.style.blend = blendMode;
        }
      });
    }
    function updateZ2(model, view) {
      if (model.preventAutoZ) {
        return;
      }
      var z2 = model.get("z") || 0;
      var zlevel = model.get("zlevel") || 0;
      view.eachRendered(function(el) {
        doUpdateZ(el, z2, zlevel, -Infinity);
        return true;
      });
    }
    function doUpdateZ(el, z2, zlevel, maxZ2) {
      var label = el.getTextContent();
      var labelLine = el.getTextGuideLine();
      var isGroup = el.isGroup;
      if (isGroup) {
        var children = el.childrenRef();
        for (var i = 0; i < children.length; i++) {
          maxZ2 = Math.max(doUpdateZ(children[i], z2, zlevel, maxZ2), maxZ2);
        }
      } else {
        el.z = z2;
        el.zlevel = zlevel;
        maxZ2 = Math.max(el.z2, maxZ2);
      }
      if (label) {
        label.z = z2;
        label.zlevel = zlevel;
        isFinite(maxZ2) && (label.z2 = maxZ2 + 2);
      }
      if (labelLine) {
        var textGuideLineConfig = el.textGuideLineConfig;
        labelLine.z = z2;
        labelLine.zlevel = zlevel;
        isFinite(maxZ2) && (labelLine.z2 = maxZ2 + (textGuideLineConfig && textGuideLineConfig.showAbove ? 1 : -1));
      }
      return maxZ2;
    }
    function clearStates(model, view) {
      view.eachRendered(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        var textContent = el.getTextContent();
        var textGuide = el.getTextGuideLine();
        if (el.stateTransition) {
          el.stateTransition = null;
        }
        if (textContent && textContent.stateTransition) {
          textContent.stateTransition = null;
        }
        if (textGuide && textGuide.stateTransition) {
          textGuide.stateTransition = null;
        }
        if (el.hasState()) {
          el.prevStates = el.currentStates;
          el.clearStates();
        } else if (el.prevStates) {
          el.prevStates = null;
        }
      });
    }
    function updateStates(model, view) {
      var stateAnimationModel = model.getModel("stateAnimation");
      var enableAnimation = model.isAnimationEnabled();
      var duration = stateAnimationModel.get("duration");
      var stateTransition = duration > 0 ? {
        duration,
        delay: stateAnimationModel.get("delay"),
        easing: stateAnimationModel.get("easing")
      } : null;
      view.eachRendered(function(el) {
        if (el.states && el.states.emphasis) {
          if (isElementRemoved(el)) {
            return;
          }
          if (el instanceof Path$1) {
            savePathStates(el);
          }
          if (el.__dirty) {
            var prevStates = el.prevStates;
            if (prevStates) {
              el.useStates(prevStates);
            }
          }
          if (enableAnimation) {
            el.stateTransition = stateTransition;
            var textContent = el.getTextContent();
            var textGuide = el.getTextGuideLine();
            if (textContent) {
              textContent.stateTransition = stateTransition;
            }
            if (textGuide) {
              textGuide.stateTransition = stateTransition;
            }
          }
          if (el.__dirty) {
            applyElementStates(el);
          }
        }
      });
    }
    createExtensionAPI = function(ecIns) {
      return new (function(_super2) {
        __extends(class_1, _super2);
        function class_1() {
          return _super2 !== null && _super2.apply(this, arguments) || this;
        }
        class_1.prototype.getCoordinateSystems = function() {
          return ecIns._coordSysMgr.getCoordinateSystems();
        };
        class_1.prototype.getComponentByElement = function(el) {
          while (el) {
            var modelInfo = el.__ecComponentInfo;
            if (modelInfo != null) {
              return ecIns._model.getComponent(modelInfo.mainType, modelInfo.index);
            }
            el = el.parent;
          }
        };
        class_1.prototype.enterEmphasis = function(el, highlightDigit) {
          enterEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveEmphasis = function(el, highlightDigit) {
          leaveEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterBlur = function(el) {
          enterBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveBlur = function(el) {
          leaveBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterSelect = function(el) {
          enterSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveSelect = function(el) {
          leaveSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.getModel = function() {
          return ecIns.getModel();
        };
        class_1.prototype.getViewOfComponentModel = function(componentModel) {
          return ecIns.getViewOfComponentModel(componentModel);
        };
        class_1.prototype.getViewOfSeriesModel = function(seriesModel) {
          return ecIns.getViewOfSeriesModel(seriesModel);
        };
        return class_1;
      }(ExtensionAPI$1))(ecIns);
    };
    enableConnect = function(chart) {
      function updateConnectedChartsStatus(charts, status) {
        for (var i = 0; i < charts.length; i++) {
          var otherChart = charts[i];
          otherChart[CONNECT_STATUS_KEY] = status;
        }
      }
      each$f(eventActionMap, function(actionType, eventType) {
        chart._messageCenter.on(eventType, function(event) {
          if (connectedGroups[chart.group] && chart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_PENDING) {
            if (event && event.escapeConnect) {
              return;
            }
            var action_1 = chart.makeActionFromEvent(event);
            var otherCharts_1 = [];
            each$f(instances, function(otherChart) {
              if (otherChart !== chart && otherChart.group === chart.group) {
                otherCharts_1.push(otherChart);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_PENDING);
            each$f(otherCharts_1, function(otherChart) {
              if (otherChart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_UPDATING) {
                otherChart.dispatchAction(action_1);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_UPDATED);
          }
        });
      });
    };
  }();
  return ECharts2;
}(Eventful$1);
var echartsProto = ECharts.prototype;
echartsProto.on = createRegisterEventWithLowercaseECharts("on");
echartsProto.off = createRegisterEventWithLowercaseECharts("off");
echartsProto.one = function(eventName, cb, ctx) {
  var self2 = this;
  function wrapped() {
    var args2 = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args2[_i] = arguments[_i];
    }
    cb && cb.apply && cb.apply(this, args2);
    self2.off(eventName, wrapped);
  }
  this.on.call(this, eventName, wrapped, ctx);
};
var MOUSE_EVENT_NAMES = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
function disposedWarning(id2) {
}
var actions = {};
var eventActionMap = {};
var dataProcessorFuncs = [];
var optionPreprocessorFuncs = [];
var visualFuncs = [];
var themeStorage = {};
var loadingEffects = {};
var instances = {};
var connectedGroups = {};
var idBase = +new Date() - 0;
var DOM_ATTRIBUTE_KEY = "_echarts_instance_";
function init$1(dom, theme2, opts) {
  var isClient = !(opts && opts.ssr);
  if (isClient) {
    var existInstance = getInstanceByDom(dom);
    if (existInstance) {
      return existInstance;
    }
  }
  var chart = new ECharts(dom, theme2, opts);
  chart.id = "ec_" + idBase++;
  instances[chart.id] = chart;
  isClient && setAttribute(dom, DOM_ATTRIBUTE_KEY, chart.id);
  enableConnect(chart);
  lifecycle$1.trigger("afterinit", chart);
  return chart;
}
function getInstanceByDom(dom) {
  return instances[getAttribute(dom, DOM_ATTRIBUTE_KEY)];
}
function registerTheme(name, theme2) {
  themeStorage[name] = theme2;
}
function registerPreprocessor(preprocessorFunc) {
  if (indexOf(optionPreprocessorFuncs, preprocessorFunc) < 0) {
    optionPreprocessorFuncs.push(preprocessorFunc);
  }
}
function registerProcessor(priority, processor) {
  normalizeRegister(dataProcessorFuncs, priority, processor, PRIORITY_PROCESSOR_DEFAULT);
}
function registerPostInit(postInitFunc) {
  registerUpdateLifecycle("afterinit", postInitFunc);
}
function registerPostUpdate(postUpdateFunc) {
  registerUpdateLifecycle("afterupdate", postUpdateFunc);
}
function registerUpdateLifecycle(name, cb) {
  lifecycle$1.on(name, cb);
}
function registerAction(actionInfo2, eventName, action) {
  if (isFunction(eventName)) {
    action = eventName;
    eventName = "";
  }
  var actionType = isObject$4(actionInfo2) ? actionInfo2.type : [actionInfo2, actionInfo2 = {
    event: eventName
  }][0];
  actionInfo2.event = (actionInfo2.event || actionType).toLowerCase();
  eventName = actionInfo2.event;
  if (eventActionMap[eventName]) {
    return;
  }
  assert(ACTION_REG.test(actionType) && ACTION_REG.test(eventName));
  if (!actions[actionType]) {
    actions[actionType] = {
      action,
      actionInfo: actionInfo2
    };
  }
  eventActionMap[eventName] = actionType;
}
function registerCoordinateSystem(type4, coordSysCreator) {
  CoordinateSystem.register(type4, coordSysCreator);
}
function registerLayout(priority, layoutTask) {
  normalizeRegister(visualFuncs, priority, layoutTask, PRIORITY_VISUAL_LAYOUT, "layout");
}
function registerVisual(priority, visualTask) {
  normalizeRegister(visualFuncs, priority, visualTask, PRIORITY_VISUAL_CHART, "visual");
}
var registeredTasks = [];
function normalizeRegister(targetList, priority, fn, defaultPriority, visualType) {
  if (isFunction(priority) || isObject$4(priority)) {
    fn = priority;
    priority = defaultPriority;
  }
  if (indexOf(registeredTasks, fn) >= 0) {
    return;
  }
  registeredTasks.push(fn);
  var stageHandler = Scheduler$1.wrapStageHandler(fn, visualType);
  stageHandler.__prio = priority;
  stageHandler.__raw = fn;
  targetList.push(stageHandler);
}
function registerLoading(name, loadingFx) {
  loadingEffects[name] = loadingFx;
}
function registerMap$1(mapName, geoJson, specialAreas) {
  var registerMap2 = getImpl("registerMap");
  registerMap2 && registerMap2(mapName, geoJson, specialAreas);
}
var registerTransform = registerExternalTransform;
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataColorPaletteTask);
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesSymbolTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataSymbolTask);
registerVisual(PRIORITY_VISUAL_DECAL, decalVisual);
registerPreprocessor(globalBackwardCompat);
registerProcessor(PRIORITY_PROCESSOR_DATASTACK, dataStack);
registerLoading("default", defaultLoading);
registerAction({
  type: HIGHLIGHT_ACTION_TYPE,
  event: HIGHLIGHT_ACTION_TYPE,
  update: HIGHLIGHT_ACTION_TYPE
}, noop);
registerAction({
  type: DOWNPLAY_ACTION_TYPE,
  event: DOWNPLAY_ACTION_TYPE,
  update: DOWNPLAY_ACTION_TYPE
}, noop);
registerAction({
  type: SELECT_ACTION_TYPE,
  event: SELECT_ACTION_TYPE,
  update: SELECT_ACTION_TYPE
}, noop);
registerAction({
  type: UNSELECT_ACTION_TYPE,
  event: UNSELECT_ACTION_TYPE,
  update: UNSELECT_ACTION_TYPE
}, noop);
registerAction({
  type: TOGGLE_SELECT_ACTION_TYPE,
  event: TOGGLE_SELECT_ACTION_TYPE,
  update: TOGGLE_SELECT_ACTION_TYPE
}, noop);
registerTheme("light", lightTheme);
registerTheme("dark", darkTheme);
var extensions = [];
var extensionRegisters = {
  registerPreprocessor,
  registerProcessor,
  registerPostInit,
  registerPostUpdate,
  registerUpdateLifecycle,
  registerAction,
  registerCoordinateSystem,
  registerLayout,
  registerVisual,
  registerTransform,
  registerLoading,
  registerMap: registerMap$1,
  registerImpl,
  PRIORITY,
  ComponentModel: ComponentModel$1,
  ComponentView: ComponentView$1,
  SeriesModel: SeriesModel$1,
  ChartView: ChartView$1,
  registerComponentModel: function(ComponentModelClass) {
    ComponentModel$1.registerClass(ComponentModelClass);
  },
  registerComponentView: function(ComponentViewClass) {
    ComponentView$1.registerClass(ComponentViewClass);
  },
  registerSeriesModel: function(SeriesModelClass) {
    SeriesModel$1.registerClass(SeriesModelClass);
  },
  registerChartView: function(ChartViewClass) {
    ChartView$1.registerClass(ChartViewClass);
  },
  registerSubTypeDefaulter: function(componentType, defaulter) {
    ComponentModel$1.registerSubTypeDefaulter(componentType, defaulter);
  },
  registerPainter: function(painterType, PainterCtor) {
    registerPainter(painterType, PainterCtor);
  }
};
function use(ext) {
  if (isArray$1(ext)) {
    each$f(ext, function(singleExt) {
      use(singleExt);
    });
    return;
  }
  if (indexOf(extensions, ext) >= 0) {
    return;
  }
  extensions.push(ext);
  if (isFunction(ext)) {
    ext = {
      install: ext
    };
  }
  ext.install(extensionRegisters);
}
function dataIndexMapValueLength(valNumOrArrLengthMoreThan2) {
  return valNumOrArrLengthMoreThan2 == null ? 0 : valNumOrArrLengthMoreThan2.length || 1;
}
function defaultKeyGetter(item) {
  return item;
}
var DataDiffer = function() {
  function DataDiffer2(oldArr, newArr, oldKeyGetter, newKeyGetter, context, diffMode) {
    this._old = oldArr;
    this._new = newArr;
    this._oldKeyGetter = oldKeyGetter || defaultKeyGetter;
    this._newKeyGetter = newKeyGetter || defaultKeyGetter;
    this.context = context;
    this._diffModeMultiple = diffMode === "multiple";
  }
  DataDiffer2.prototype.add = function(func) {
    this._add = func;
    return this;
  };
  DataDiffer2.prototype.update = function(func) {
    this._update = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToOne = function(func) {
    this._updateManyToOne = func;
    return this;
  };
  DataDiffer2.prototype.updateOneToMany = function(func) {
    this._updateOneToMany = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToMany = function(func) {
    this._updateManyToMany = func;
    return this;
  };
  DataDiffer2.prototype.remove = function(func) {
    this._remove = func;
    return this;
  };
  DataDiffer2.prototype.execute = function() {
    this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
  };
  DataDiffer2.prototype._executeOneToOne = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var newDataIndexMap = {};
    var oldDataKeyArr = new Array(oldArr.length);
    var newDataKeyArr = new Array(newArr.length);
    this._initIndexMap(oldArr, null, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (newIdxMapValLen > 1) {
        var newIdx = newIdxMapVal.shift();
        if (newIdxMapVal.length === 1) {
          newDataIndexMap[oldKey] = newIdxMapVal[0];
        }
        this._update && this._update(newIdx, i);
      } else if (newIdxMapValLen === 1) {
        newDataIndexMap[oldKey] = null;
        this._update && this._update(newIdxMapVal, i);
      } else {
        this._remove && this._remove(i);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._executeMultiple = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var oldDataIndexMap = {};
    var newDataIndexMap = {};
    var oldDataKeyArr = [];
    var newDataKeyArr = [];
    this._initIndexMap(oldArr, oldDataIndexMap, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldDataKeyArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var oldIdxMapVal = oldDataIndexMap[oldKey];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var oldIdxMapValLen = dataIndexMapValueLength(oldIdxMapVal);
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (oldIdxMapValLen > 1 && newIdxMapValLen === 1) {
        this._updateManyToOne && this._updateManyToOne(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen > 1) {
        this._updateOneToMany && this._updateOneToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen === 1) {
        this._update && this._update(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1 && newIdxMapValLen > 1) {
        this._updateManyToMany && this._updateManyToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1) {
        for (var i_1 = 0; i_1 < oldIdxMapValLen; i_1++) {
          this._remove && this._remove(oldIdxMapVal[i_1]);
        }
      } else {
        this._remove && this._remove(oldIdxMapVal);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._performRestAdd = function(newDataKeyArr, newDataIndexMap) {
    for (var i = 0; i < newDataKeyArr.length; i++) {
      var newKey = newDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[newKey];
      var idxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (idxMapValLen > 1) {
        for (var j = 0; j < idxMapValLen; j++) {
          this._add && this._add(newIdxMapVal[j]);
        }
      } else if (idxMapValLen === 1) {
        this._add && this._add(newIdxMapVal);
      }
      newDataIndexMap[newKey] = null;
    }
  };
  DataDiffer2.prototype._initIndexMap = function(arr, map2, keyArr, keyGetterName) {
    var cbModeMultiple = this._diffModeMultiple;
    for (var i = 0; i < arr.length; i++) {
      var key = "_ec_" + this[keyGetterName](arr[i], i);
      if (!cbModeMultiple) {
        keyArr[i] = key;
      }
      if (!map2) {
        continue;
      }
      var idxMapVal = map2[key];
      var idxMapValLen = dataIndexMapValueLength(idxMapVal);
      if (idxMapValLen === 0) {
        map2[key] = i;
        if (cbModeMultiple) {
          keyArr.push(key);
        }
      } else if (idxMapValLen === 1) {
        map2[key] = [idxMapVal, i];
      } else {
        idxMapVal.push(i);
      }
    }
  };
  return DataDiffer2;
}();
var DataDiffer$1 = DataDiffer;
var DimensionUserOuput = function() {
  function DimensionUserOuput2(encode, dimRequest) {
    this._encode = encode;
    this._schema = dimRequest;
  }
  DimensionUserOuput2.prototype.get = function() {
    return {
      fullDimensions: this._getFullDimensionNames(),
      encode: this._encode
    };
  };
  DimensionUserOuput2.prototype._getFullDimensionNames = function() {
    if (!this._cachedDimNames) {
      this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : [];
    }
    return this._cachedDimNames;
  };
  return DimensionUserOuput2;
}();
function summarizeDimensions(data, schema) {
  var summary = {};
  var encode = summary.encode = {};
  var notExtraCoordDimMap = createHashMap();
  var defaultedLabel = [];
  var defaultedTooltip = [];
  var userOutputEncode = {};
  each$f(data.dimensions, function(dimName) {
    var dimItem = data.getDimensionInfo(dimName);
    var coordDim = dimItem.coordDim;
    if (coordDim) {
      var coordDimIndex = dimItem.coordDimIndex;
      getOrCreateEncodeArr(encode, coordDim)[coordDimIndex] = dimName;
      if (!dimItem.isExtraCoord) {
        notExtraCoordDimMap.set(coordDim, 1);
        if (mayLabelDimType(dimItem.type)) {
          defaultedLabel[0] = dimName;
        }
        getOrCreateEncodeArr(userOutputEncode, coordDim)[coordDimIndex] = data.getDimensionIndex(dimItem.name);
      }
      if (dimItem.defaultTooltip) {
        defaultedTooltip.push(dimName);
      }
    }
    VISUAL_DIMENSIONS.each(function(v4, otherDim) {
      var encodeArr = getOrCreateEncodeArr(encode, otherDim);
      var dimIndex = dimItem.otherDims[otherDim];
      if (dimIndex != null && dimIndex !== false) {
        encodeArr[dimIndex] = dimItem.name;
      }
    });
  });
  var dataDimsOnCoord = [];
  var encodeFirstDimNotExtra = {};
  notExtraCoordDimMap.each(function(v4, coordDim) {
    var dimArr = encode[coordDim];
    encodeFirstDimNotExtra[coordDim] = dimArr[0];
    dataDimsOnCoord = dataDimsOnCoord.concat(dimArr);
  });
  summary.dataDimsOnCoord = dataDimsOnCoord;
  summary.dataDimIndicesOnCoord = map$1(dataDimsOnCoord, function(dimName) {
    return data.getDimensionInfo(dimName).storeDimIndex;
  });
  summary.encodeFirstDimNotExtra = encodeFirstDimNotExtra;
  var encodeLabel = encode.label;
  if (encodeLabel && encodeLabel.length) {
    defaultedLabel = encodeLabel.slice();
  }
  var encodeTooltip = encode.tooltip;
  if (encodeTooltip && encodeTooltip.length) {
    defaultedTooltip = encodeTooltip.slice();
  } else if (!defaultedTooltip.length) {
    defaultedTooltip = defaultedLabel.slice();
  }
  encode.defaultedLabel = defaultedLabel;
  encode.defaultedTooltip = defaultedTooltip;
  summary.userOutput = new DimensionUserOuput(userOutputEncode, schema);
  return summary;
}
function getOrCreateEncodeArr(encode, dim) {
  if (!encode.hasOwnProperty(dim)) {
    encode[dim] = [];
  }
  return encode[dim];
}
function getDimensionTypeByAxis(axisType) {
  return axisType === "category" ? "ordinal" : axisType === "time" ? "time" : "float";
}
function mayLabelDimType(dimType) {
  return !(dimType === "ordinal" || dimType === "time");
}
var SeriesDimensionDefine = function() {
  function SeriesDimensionDefine2(opt) {
    this.otherDims = {};
    if (opt != null) {
      extend(this, opt);
    }
  }
  return SeriesDimensionDefine2;
}();
var SeriesDimensionDefine$1 = SeriesDimensionDefine;
var inner$h = makeInner();
var dimTypeShort = {
  float: "f",
  int: "i",
  ordinal: "o",
  number: "n",
  time: "t"
};
var SeriesDataSchema = function() {
  function SeriesDataSchema2(opt) {
    this.dimensions = opt.dimensions;
    this._dimOmitted = opt.dimensionOmitted;
    this.source = opt.source;
    this._fullDimCount = opt.fullDimensionCount;
    this._updateDimOmitted(opt.dimensionOmitted);
  }
  SeriesDataSchema2.prototype.isDimensionOmitted = function() {
    return this._dimOmitted;
  };
  SeriesDataSchema2.prototype._updateDimOmitted = function(dimensionOmitted) {
    this._dimOmitted = dimensionOmitted;
    if (!dimensionOmitted) {
      return;
    }
    if (!this._dimNameMap) {
      this._dimNameMap = ensureSourceDimNameMap(this.source);
    }
  };
  SeriesDataSchema2.prototype.getSourceDimensionIndex = function(dimName) {
    return retrieve2(this._dimNameMap.get(dimName), -1);
  };
  SeriesDataSchema2.prototype.getSourceDimension = function(dimIndex) {
    var dimensionsDefine = this.source.dimensionsDefine;
    if (dimensionsDefine) {
      return dimensionsDefine[dimIndex];
    }
  };
  SeriesDataSchema2.prototype.makeStoreSchema = function() {
    var dimCount = this._fullDimCount;
    var willRetrieveDataByName = shouldRetrieveDataByName(this.source);
    var makeHashStrict = !shouldOmitUnusedDimensions(dimCount);
    var dimHash = "";
    var dims = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < dimCount; fullDimIdx++) {
      var property = void 0;
      var type4 = void 0;
      var ordinalMeta = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        property = willRetrieveDataByName ? seriesDimDef.name : null;
        type4 = seriesDimDef.type;
        ordinalMeta = seriesDimDef.ordinalMeta;
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          property = willRetrieveDataByName ? sourceDimDef.name : null;
          type4 = sourceDimDef.type;
        }
      }
      dims.push({
        property,
        type: type4,
        ordinalMeta
      });
      if (willRetrieveDataByName && property != null && (!seriesDimDef || !seriesDimDef.isCalculationCoord)) {
        dimHash += makeHashStrict ? property.replace(/\`/g, "`1").replace(/\$/g, "`2") : property;
      }
      dimHash += "$";
      dimHash += dimTypeShort[type4] || "f";
      if (ordinalMeta) {
        dimHash += ordinalMeta.uid;
      }
      dimHash += "$";
    }
    var source = this.source;
    var hash = [source.seriesLayoutBy, source.startIndex, dimHash].join("$$");
    return {
      dimensions: dims,
      hash
    };
  };
  SeriesDataSchema2.prototype.makeOutputDimensionNames = function() {
    var result = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < this._fullDimCount; fullDimIdx++) {
      var name_1 = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        if (!seriesDimDef.isCalculationCoord) {
          name_1 = seriesDimDef.name;
        }
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          name_1 = sourceDimDef.name;
        }
      }
      result.push(name_1);
    }
    return result;
  };
  SeriesDataSchema2.prototype.appendCalculationDimension = function(dimDef) {
    this.dimensions.push(dimDef);
    dimDef.isCalculationCoord = true;
    this._fullDimCount++;
    this._updateDimOmitted(true);
  };
  return SeriesDataSchema2;
}();
function isSeriesDataSchema(schema) {
  return schema instanceof SeriesDataSchema;
}
function createDimNameMap(dimsDef) {
  var dataDimNameMap = createHashMap();
  for (var i = 0; i < (dimsDef || []).length; i++) {
    var dimDefItemRaw = dimsDef[i];
    var userDimName = isObject$4(dimDefItemRaw) ? dimDefItemRaw.name : dimDefItemRaw;
    if (userDimName != null && dataDimNameMap.get(userDimName) == null) {
      dataDimNameMap.set(userDimName, i);
    }
  }
  return dataDimNameMap;
}
function ensureSourceDimNameMap(source) {
  var innerSource = inner$h(source);
  return innerSource.dimNameMap || (innerSource.dimNameMap = createDimNameMap(source.dimensionsDefine));
}
function shouldOmitUnusedDimensions(dimCount) {
  return dimCount > 30;
}
var isObject$2 = isObject$4;
var map = map$1;
var CtorInt32Array = typeof Int32Array === "undefined" ? Array : Int32Array;
var ID_PREFIX = "e\0\0";
var INDEX_NOT_FOUND = -1;
var TRANSFERABLE_PROPERTIES = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"];
var CLONE_PROPERTIES = ["_approximateExtent"];
var prepareInvertedIndex;
var getId;
var getIdNameFromStore;
var normalizeDimensions;
var transferProperties;
var cloneListForMapAndSample;
var makeIdFromName;
var SeriesData = function() {
  function SeriesData2(dimensionsInput, hostModel) {
    this.type = "list";
    this._dimOmitted = false;
    this._nameList = [];
    this._idList = [];
    this._visual = {};
    this._layout = {};
    this._itemVisuals = [];
    this._itemLayouts = [];
    this._graphicEls = [];
    this._approximateExtent = {};
    this._calculationInfo = {};
    this.hasItemOption = false;
    this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"];
    this.CHANGABLE_METHODS = ["filterSelf", "selectRange"];
    this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
    var dimensions;
    var assignStoreDimIdx = false;
    if (isSeriesDataSchema(dimensionsInput)) {
      dimensions = dimensionsInput.dimensions;
      this._dimOmitted = dimensionsInput.isDimensionOmitted();
      this._schema = dimensionsInput;
    } else {
      assignStoreDimIdx = true;
      dimensions = dimensionsInput;
    }
    dimensions = dimensions || ["x", "y"];
    var dimensionInfos = {};
    var dimensionNames = [];
    var invertedIndicesMap = {};
    var needsHasOwn = false;
    var emptyObj = {};
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfoInput = dimensions[i];
      var dimensionInfo = isString(dimInfoInput) ? new SeriesDimensionDefine$1({
        name: dimInfoInput
      }) : !(dimInfoInput instanceof SeriesDimensionDefine$1) ? new SeriesDimensionDefine$1(dimInfoInput) : dimInfoInput;
      var dimensionName = dimensionInfo.name;
      dimensionInfo.type = dimensionInfo.type || "float";
      if (!dimensionInfo.coordDim) {
        dimensionInfo.coordDim = dimensionName;
        dimensionInfo.coordDimIndex = 0;
      }
      var otherDims = dimensionInfo.otherDims = dimensionInfo.otherDims || {};
      dimensionNames.push(dimensionName);
      dimensionInfos[dimensionName] = dimensionInfo;
      if (emptyObj[dimensionName] != null) {
        needsHasOwn = true;
      }
      if (dimensionInfo.createInvertedIndices) {
        invertedIndicesMap[dimensionName] = [];
      }
      if (otherDims.itemName === 0) {
        this._nameDimIdx = i;
      }
      if (otherDims.itemId === 0) {
        this._idDimIdx = i;
      }
      if (assignStoreDimIdx) {
        dimensionInfo.storeDimIndex = i;
      }
    }
    this.dimensions = dimensionNames;
    this._dimInfos = dimensionInfos;
    this._initGetDimensionInfo(needsHasOwn);
    this.hostModel = hostModel;
    this._invertedIndicesMap = invertedIndicesMap;
    if (this._dimOmitted) {
      var dimIdxToName_1 = this._dimIdxToName = createHashMap();
      each$f(dimensionNames, function(dimName) {
        dimIdxToName_1.set(dimensionInfos[dimName].storeDimIndex, dimName);
      });
    }
  }
  SeriesData2.prototype.getDimension = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx == null) {
      return dim;
    }
    dimIdx = dim;
    if (!this._dimOmitted) {
      return this.dimensions[dimIdx];
    }
    var dimName = this._dimIdxToName.get(dimIdx);
    if (dimName != null) {
      return dimName;
    }
    var sourceDimDef = this._schema.getSourceDimension(dimIdx);
    if (sourceDimDef) {
      return sourceDimDef.name;
    }
  };
  SeriesData2.prototype.getDimensionIndex = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx != null) {
      return dimIdx;
    }
    if (dim == null) {
      return -1;
    }
    var dimInfo = this._getDimInfo(dim);
    return dimInfo ? dimInfo.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(dim) : -1;
  };
  SeriesData2.prototype._recognizeDimIndex = function(dim) {
    if (isNumber(dim) || dim != null && !isNaN(dim) && !this._getDimInfo(dim) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(dim) < 0)) {
      return +dim;
    }
  };
  SeriesData2.prototype._getStoreDimIndex = function(dim) {
    var dimIdx = this.getDimensionIndex(dim);
    return dimIdx;
  };
  SeriesData2.prototype.getDimensionInfo = function(dim) {
    return this._getDimInfo(this.getDimension(dim));
  };
  SeriesData2.prototype._initGetDimensionInfo = function(needsHasOwn) {
    var dimensionInfos = this._dimInfos;
    this._getDimInfo = needsHasOwn ? function(dimName) {
      return dimensionInfos.hasOwnProperty(dimName) ? dimensionInfos[dimName] : void 0;
    } : function(dimName) {
      return dimensionInfos[dimName];
    };
  };
  SeriesData2.prototype.getDimensionsOnCoord = function() {
    return this._dimSummary.dataDimsOnCoord.slice();
  };
  SeriesData2.prototype.mapDimension = function(coordDim, idx) {
    var dimensionsSummary = this._dimSummary;
    if (idx == null) {
      return dimensionsSummary.encodeFirstDimNotExtra[coordDim];
    }
    var dims = dimensionsSummary.encode[coordDim];
    return dims ? dims[idx] : null;
  };
  SeriesData2.prototype.mapDimensionsAll = function(coordDim) {
    var dimensionsSummary = this._dimSummary;
    var dims = dimensionsSummary.encode[coordDim];
    return (dims || []).slice();
  };
  SeriesData2.prototype.getStore = function() {
    return this._store;
  };
  SeriesData2.prototype.initData = function(data, nameList, dimValueGetter) {
    var _this = this;
    var store;
    if (data instanceof DataStore) {
      store = data;
    }
    if (!store) {
      var dimensions = this.dimensions;
      var provider = isSourceInstance(data) || isArrayLike(data) ? new DefaultDataProvider(data, dimensions.length) : data;
      store = new DataStore();
      var dimensionInfos = map(dimensions, function(dimName) {
        return {
          type: _this._dimInfos[dimName].type,
          property: dimName
        };
      });
      store.initData(provider, dimensionInfos, dimValueGetter);
    }
    this._store = store;
    this._nameList = (nameList || []).slice();
    this._idList = [];
    this._nameRepeatCount = {};
    this._doInit(0, store.count());
    this._dimSummary = summarizeDimensions(this, this._schema);
    this.userOutput = this._dimSummary.userOutput;
  };
  SeriesData2.prototype.appendData = function(data) {
    var range3 = this._store.appendData(data);
    this._doInit(range3[0], range3[1]);
  };
  SeriesData2.prototype.appendValues = function(values, names2) {
    var _a2 = this._store.appendValues(values, names2.length), start2 = _a2.start, end2 = _a2.end;
    var shouldMakeIdFromName = this._shouldMakeIdFromName();
    this._updateOrdinalMeta();
    if (names2) {
      for (var idx = start2; idx < end2; idx++) {
        var sourceIdx = idx - start2;
        this._nameList[idx] = names2[sourceIdx];
        if (shouldMakeIdFromName) {
          makeIdFromName(this, idx);
        }
      }
    }
  };
  SeriesData2.prototype._updateOrdinalMeta = function() {
    var store = this._store;
    var dimensions = this.dimensions;
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfo = this._dimInfos[dimensions[i]];
      if (dimInfo.ordinalMeta) {
        store.collectOrdinalMeta(dimInfo.storeDimIndex, dimInfo.ordinalMeta);
      }
    }
  };
  SeriesData2.prototype._shouldMakeIdFromName = function() {
    var provider = this._store.getProvider();
    return this._idDimIdx == null && provider.getSource().sourceFormat !== SOURCE_FORMAT_TYPED_ARRAY && !provider.fillStorage;
  };
  SeriesData2.prototype._doInit = function(start2, end2) {
    if (start2 >= end2) {
      return;
    }
    var store = this._store;
    var provider = store.getProvider();
    this._updateOrdinalMeta();
    var nameList = this._nameList;
    var idList = this._idList;
    var sourceFormat = provider.getSource().sourceFormat;
    var isFormatOriginal = sourceFormat === SOURCE_FORMAT_ORIGINAL;
    if (isFormatOriginal && !provider.pure) {
      var sharedDataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        var dataItem = provider.getItem(idx, sharedDataItem);
        if (!this.hasItemOption && isDataItemOption(dataItem)) {
          this.hasItemOption = true;
        }
        if (dataItem) {
          var itemName = dataItem.name;
          if (nameList[idx] == null && itemName != null) {
            nameList[idx] = convertOptionIdName(itemName, null);
          }
          var itemId = dataItem.id;
          if (idList[idx] == null && itemId != null) {
            idList[idx] = convertOptionIdName(itemId, null);
          }
        }
      }
    }
    if (this._shouldMakeIdFromName()) {
      for (var idx = start2; idx < end2; idx++) {
        makeIdFromName(this, idx);
      }
    }
    prepareInvertedIndex(this);
  };
  SeriesData2.prototype.getApproximateExtent = function(dim) {
    return this._approximateExtent[dim] || this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.setApproximateExtent = function(extent3, dim) {
    dim = this.getDimension(dim);
    this._approximateExtent[dim] = extent3.slice();
  };
  SeriesData2.prototype.getCalculationInfo = function(key) {
    return this._calculationInfo[key];
  };
  SeriesData2.prototype.setCalculationInfo = function(key, value) {
    isObject$2(key) ? extend(this._calculationInfo, key) : this._calculationInfo[key] = value;
  };
  SeriesData2.prototype.getName = function(idx) {
    var rawIndex = this.getRawIndex(idx);
    var name = this._nameList[rawIndex];
    if (name == null && this._nameDimIdx != null) {
      name = getIdNameFromStore(this, this._nameDimIdx, rawIndex);
    }
    if (name == null) {
      name = "";
    }
    return name;
  };
  SeriesData2.prototype._getCategory = function(dimIdx, idx) {
    var ordinal = this._store.get(dimIdx, idx);
    var ordinalMeta = this._store.getOrdinalMeta(dimIdx);
    if (ordinalMeta) {
      return ordinalMeta.categories[ordinal];
    }
    return ordinal;
  };
  SeriesData2.prototype.getId = function(idx) {
    return getId(this, this.getRawIndex(idx));
  };
  SeriesData2.prototype.count = function() {
    return this._store.count();
  };
  SeriesData2.prototype.get = function(dim, idx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.get(dimInfo.storeDimIndex, idx);
    }
  };
  SeriesData2.prototype.getByRawIndex = function(dim, rawIdx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.getByRawIndex(dimInfo.storeDimIndex, rawIdx);
    }
  };
  SeriesData2.prototype.getIndices = function() {
    return this._store.getIndices();
  };
  SeriesData2.prototype.getDataExtent = function(dim) {
    return this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getSum = function(dim) {
    return this._store.getSum(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getMedian = function(dim) {
    return this._store.getMedian(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getValues = function(dimensions, idx) {
    var _this = this;
    var store = this._store;
    return isArray$1(dimensions) ? store.getValues(map(dimensions, function(dim) {
      return _this._getStoreDimIndex(dim);
    }), idx) : store.getValues(dimensions);
  };
  SeriesData2.prototype.hasValue = function(idx) {
    var dataDimIndicesOnCoord = this._dimSummary.dataDimIndicesOnCoord;
    for (var i = 0, len2 = dataDimIndicesOnCoord.length; i < len2; i++) {
      if (isNaN(this._store.get(dataDimIndicesOnCoord[i], idx))) {
        return false;
      }
    }
    return true;
  };
  SeriesData2.prototype.indexOfName = function(name) {
    for (var i = 0, len2 = this._store.count(); i < len2; i++) {
      if (this.getName(i) === name) {
        return i;
      }
    }
    return -1;
  };
  SeriesData2.prototype.getRawIndex = function(idx) {
    return this._store.getRawIndex(idx);
  };
  SeriesData2.prototype.indexOfRawIndex = function(rawIndex) {
    return this._store.indexOfRawIndex(rawIndex);
  };
  SeriesData2.prototype.rawIndexOf = function(dim, value) {
    var invertedIndices = dim && this._invertedIndicesMap[dim];
    var rawIndex = invertedIndices[value];
    if (rawIndex == null || isNaN(rawIndex)) {
      return INDEX_NOT_FOUND;
    }
    return rawIndex;
  };
  SeriesData2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    return this._store.indicesOfNearest(this._getStoreDimIndex(dim), value, maxDistance);
  };
  SeriesData2.prototype.each = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.each(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
  };
  SeriesData2.prototype.filterSelf = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store = this._store.filter(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
    return this;
  };
  SeriesData2.prototype.selectRange = function(range3) {
    var _this = this;
    var innerRange = {};
    var dims = keys(range3);
    each$f(dims, function(dim) {
      var dimIdx = _this._getStoreDimIndex(dim);
      innerRange[dimIdx] = range3[dim];
    });
    this._store = this._store.selectRange(innerRange);
    return this;
  };
  SeriesData2.prototype.mapArray = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    ctx = ctx || this;
    var result = [];
    this.each(dims, function() {
      result.push(cb && cb.apply(this, arguments));
    }, ctx);
    return result;
  };
  SeriesData2.prototype.map = function(dims, cb, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    var list = cloneListForMapAndSample(this);
    list._store = this._store.map(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
    return list;
  };
  SeriesData2.prototype.modify = function(dims, cb, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.modify(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
  };
  SeriesData2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.downSample(this._getStoreDimIndex(dimension), rate, sampleValue, sampleIndex);
    return list;
  };
  SeriesData2.prototype.lttbDownSample = function(valueDimension, rate) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.lttbDownSample(this._getStoreDimIndex(valueDimension), rate);
    return list;
  };
  SeriesData2.prototype.getRawDataItem = function(idx) {
    return this._store.getRawDataItem(idx);
  };
  SeriesData2.prototype.getItemModel = function(idx) {
    var hostModel = this.hostModel;
    var dataItem = this.getRawDataItem(idx);
    return new Model$1(dataItem, hostModel, hostModel && hostModel.ecModel);
  };
  SeriesData2.prototype.diff = function(otherList) {
    var thisList = this;
    return new DataDiffer$1(otherList ? otherList.getStore().getIndices() : [], this.getStore().getIndices(), function(idx) {
      return getId(otherList, idx);
    }, function(idx) {
      return getId(thisList, idx);
    });
  };
  SeriesData2.prototype.getVisual = function(key) {
    var visual = this._visual;
    return visual && visual[key];
  };
  SeriesData2.prototype.setVisual = function(kvObj, val) {
    this._visual = this._visual || {};
    if (isObject$2(kvObj)) {
      extend(this._visual, kvObj);
    } else {
      this._visual[kvObj] = val;
    }
  };
  SeriesData2.prototype.getItemVisual = function(idx, key) {
    var itemVisual = this._itemVisuals[idx];
    var val = itemVisual && itemVisual[key];
    if (val == null) {
      return this.getVisual(key);
    }
    return val;
  };
  SeriesData2.prototype.hasItemVisual = function() {
    return this._itemVisuals.length > 0;
  };
  SeriesData2.prototype.ensureUniqueItemVisual = function(idx, key) {
    var itemVisuals = this._itemVisuals;
    var itemVisual = itemVisuals[idx];
    if (!itemVisual) {
      itemVisual = itemVisuals[idx] = {};
    }
    var val = itemVisual[key];
    if (val == null) {
      val = this.getVisual(key);
      if (isArray$1(val)) {
        val = val.slice();
      } else if (isObject$2(val)) {
        val = extend({}, val);
      }
      itemVisual[key] = val;
    }
    return val;
  };
  SeriesData2.prototype.setItemVisual = function(idx, key, value) {
    var itemVisual = this._itemVisuals[idx] || {};
    this._itemVisuals[idx] = itemVisual;
    if (isObject$2(key)) {
      extend(itemVisual, key);
    } else {
      itemVisual[key] = value;
    }
  };
  SeriesData2.prototype.clearAllVisual = function() {
    this._visual = {};
    this._itemVisuals = [];
  };
  SeriesData2.prototype.setLayout = function(key, val) {
    isObject$2(key) ? extend(this._layout, key) : this._layout[key] = val;
  };
  SeriesData2.prototype.getLayout = function(key) {
    return this._layout[key];
  };
  SeriesData2.prototype.getItemLayout = function(idx) {
    return this._itemLayouts[idx];
  };
  SeriesData2.prototype.setItemLayout = function(idx, layout2, merge2) {
    this._itemLayouts[idx] = merge2 ? extend(this._itemLayouts[idx] || {}, layout2) : layout2;
  };
  SeriesData2.prototype.clearItemLayouts = function() {
    this._itemLayouts.length = 0;
  };
  SeriesData2.prototype.setItemGraphicEl = function(idx, el) {
    var seriesIndex = this.hostModel && this.hostModel.seriesIndex;
    setCommonECData(seriesIndex, this.dataType, idx, el);
    this._graphicEls[idx] = el;
  };
  SeriesData2.prototype.getItemGraphicEl = function(idx) {
    return this._graphicEls[idx];
  };
  SeriesData2.prototype.eachItemGraphicEl = function(cb, context) {
    each$f(this._graphicEls, function(el, idx) {
      if (el) {
        cb && cb.call(context, el, idx);
      }
    });
  };
  SeriesData2.prototype.cloneShallow = function(list) {
    if (!list) {
      list = new SeriesData2(this._schema ? this._schema : map(this.dimensions, this._getDimInfo, this), this.hostModel);
    }
    transferProperties(list, this);
    list._store = this._store;
    return list;
  };
  SeriesData2.prototype.wrapMethod = function(methodName, injectFunction) {
    var originalMethod = this[methodName];
    if (!isFunction(originalMethod)) {
      return;
    }
    this.__wrappedMethods = this.__wrappedMethods || [];
    this.__wrappedMethods.push(methodName);
    this[methodName] = function() {
      var res = originalMethod.apply(this, arguments);
      return injectFunction.apply(this, [res].concat(slice(arguments)));
    };
  };
  SeriesData2.internalField = function() {
    prepareInvertedIndex = function(data) {
      var invertedIndicesMap = data._invertedIndicesMap;
      each$f(invertedIndicesMap, function(invertedIndices, dim) {
        var dimInfo = data._dimInfos[dim];
        var ordinalMeta = dimInfo.ordinalMeta;
        var store = data._store;
        if (ordinalMeta) {
          invertedIndices = invertedIndicesMap[dim] = new CtorInt32Array(ordinalMeta.categories.length);
          for (var i = 0; i < invertedIndices.length; i++) {
            invertedIndices[i] = INDEX_NOT_FOUND;
          }
          for (var i = 0; i < store.count(); i++) {
            invertedIndices[store.get(dimInfo.storeDimIndex, i)] = i;
          }
        }
      });
    };
    getIdNameFromStore = function(data, dimIdx, idx) {
      return convertOptionIdName(data._getCategory(dimIdx, idx), null);
    };
    getId = function(data, rawIndex) {
      var id2 = data._idList[rawIndex];
      if (id2 == null && data._idDimIdx != null) {
        id2 = getIdNameFromStore(data, data._idDimIdx, rawIndex);
      }
      if (id2 == null) {
        id2 = ID_PREFIX + rawIndex;
      }
      return id2;
    };
    normalizeDimensions = function(dimensions) {
      if (!isArray$1(dimensions)) {
        dimensions = dimensions != null ? [dimensions] : [];
      }
      return dimensions;
    };
    cloneListForMapAndSample = function(original) {
      var list = new SeriesData2(original._schema ? original._schema : map(original.dimensions, original._getDimInfo, original), original.hostModel);
      transferProperties(list, original);
      return list;
    };
    transferProperties = function(target, source) {
      each$f(TRANSFERABLE_PROPERTIES.concat(source.__wrappedMethods || []), function(propName) {
        if (source.hasOwnProperty(propName)) {
          target[propName] = source[propName];
        }
      });
      target.__wrappedMethods = source.__wrappedMethods;
      each$f(CLONE_PROPERTIES, function(propName) {
        target[propName] = clone$4(source[propName]);
      });
      target._calculationInfo = extend({}, source._calculationInfo);
    };
    makeIdFromName = function(data, idx) {
      var nameList = data._nameList;
      var idList = data._idList;
      var nameDimIdx = data._nameDimIdx;
      var idDimIdx = data._idDimIdx;
      var name = nameList[idx];
      var id2 = idList[idx];
      if (name == null && nameDimIdx != null) {
        nameList[idx] = name = getIdNameFromStore(data, nameDimIdx, idx);
      }
      if (id2 == null && idDimIdx != null) {
        idList[idx] = id2 = getIdNameFromStore(data, idDimIdx, idx);
      }
      if (id2 == null && name != null) {
        var nameRepeatCount = data._nameRepeatCount;
        var nmCnt = nameRepeatCount[name] = (nameRepeatCount[name] || 0) + 1;
        id2 = name;
        if (nmCnt > 1) {
          id2 += "__ec__" + nmCnt;
        }
        idList[idx] = id2;
      }
    };
  }();
  return SeriesData2;
}();
var SeriesData$1 = SeriesData;
function prepareSeriesDataSchema(source, opt) {
  if (!isSourceInstance(source)) {
    source = createSourceFromSeriesDataOption(source);
  }
  opt = opt || {};
  var sysDims = opt.coordDimensions || [];
  var dimsDef = opt.dimensionsDefine || source.dimensionsDefine || [];
  var coordDimNameMap = createHashMap();
  var resultList = [];
  var dimCount = getDimCount(source, sysDims, dimsDef, opt.dimensionsCount);
  var omitUnusedDimensions = opt.canOmitUnusedDimensions && shouldOmitUnusedDimensions(dimCount);
  var isUsingSourceDimensionsDef = dimsDef === source.dimensionsDefine;
  var dataDimNameMap = isUsingSourceDimensionsDef ? ensureSourceDimNameMap(source) : createDimNameMap(dimsDef);
  var encodeDef = opt.encodeDefine;
  if (!encodeDef && opt.encodeDefaulter) {
    encodeDef = opt.encodeDefaulter(source, dimCount);
  }
  var encodeDefMap = createHashMap(encodeDef);
  var indicesMap = new CtorInt32Array$1(dimCount);
  for (var i = 0; i < indicesMap.length; i++) {
    indicesMap[i] = -1;
  }
  function getResultItem(dimIdx) {
    var idx = indicesMap[dimIdx];
    if (idx < 0) {
      var dimDefItemRaw = dimsDef[dimIdx];
      var dimDefItem = isObject$4(dimDefItemRaw) ? dimDefItemRaw : {
        name: dimDefItemRaw
      };
      var resultItem2 = new SeriesDimensionDefine$1();
      var userDimName = dimDefItem.name;
      if (userDimName != null && dataDimNameMap.get(userDimName) != null) {
        resultItem2.name = resultItem2.displayName = userDimName;
      }
      dimDefItem.type != null && (resultItem2.type = dimDefItem.type);
      dimDefItem.displayName != null && (resultItem2.displayName = dimDefItem.displayName);
      var newIdx = resultList.length;
      indicesMap[dimIdx] = newIdx;
      resultItem2.storeDimIndex = dimIdx;
      resultList.push(resultItem2);
      return resultItem2;
    }
    return resultList[idx];
  }
  if (!omitUnusedDimensions) {
    for (var i = 0; i < dimCount; i++) {
      getResultItem(i);
    }
  }
  encodeDefMap.each(function(dataDimsRaw, coordDim2) {
    var dataDims = normalizeToArray(dataDimsRaw).slice();
    if (dataDims.length === 1 && !isString(dataDims[0]) && dataDims[0] < 0) {
      encodeDefMap.set(coordDim2, false);
      return;
    }
    var validDataDims = encodeDefMap.set(coordDim2, []);
    each$f(dataDims, function(resultDimIdxOrName, idx) {
      var resultDimIdx2 = isString(resultDimIdxOrName) ? dataDimNameMap.get(resultDimIdxOrName) : resultDimIdxOrName;
      if (resultDimIdx2 != null && resultDimIdx2 < dimCount) {
        validDataDims[idx] = resultDimIdx2;
        applyDim(getResultItem(resultDimIdx2), coordDim2, idx);
      }
    });
  });
  var availDimIdx = 0;
  each$f(sysDims, function(sysDimItemRaw) {
    var coordDim2;
    var sysDimItemDimsDef;
    var sysDimItemOtherDims;
    var sysDimItem;
    if (isString(sysDimItemRaw)) {
      coordDim2 = sysDimItemRaw;
      sysDimItem = {};
    } else {
      sysDimItem = sysDimItemRaw;
      coordDim2 = sysDimItem.name;
      var ordinalMeta = sysDimItem.ordinalMeta;
      sysDimItem.ordinalMeta = null;
      sysDimItem = extend({}, sysDimItem);
      sysDimItem.ordinalMeta = ordinalMeta;
      sysDimItemDimsDef = sysDimItem.dimsDef;
      sysDimItemOtherDims = sysDimItem.otherDims;
      sysDimItem.name = sysDimItem.coordDim = sysDimItem.coordDimIndex = sysDimItem.dimsDef = sysDimItem.otherDims = null;
    }
    var dataDims = encodeDefMap.get(coordDim2);
    if (dataDims === false) {
      return;
    }
    dataDims = normalizeToArray(dataDims);
    if (!dataDims.length) {
      for (var i2 = 0; i2 < (sysDimItemDimsDef && sysDimItemDimsDef.length || 1); i2++) {
        while (availDimIdx < dimCount && getResultItem(availDimIdx).coordDim != null) {
          availDimIdx++;
        }
        availDimIdx < dimCount && dataDims.push(availDimIdx++);
      }
    }
    each$f(dataDims, function(resultDimIdx2, coordDimIndex) {
      var resultItem2 = getResultItem(resultDimIdx2);
      if (isUsingSourceDimensionsDef && sysDimItem.type != null) {
        resultItem2.type = sysDimItem.type;
      }
      applyDim(defaults(resultItem2, sysDimItem), coordDim2, coordDimIndex);
      if (resultItem2.name == null && sysDimItemDimsDef) {
        var sysDimItemDimsDefItem = sysDimItemDimsDef[coordDimIndex];
        !isObject$4(sysDimItemDimsDefItem) && (sysDimItemDimsDefItem = {
          name: sysDimItemDimsDefItem
        });
        resultItem2.name = resultItem2.displayName = sysDimItemDimsDefItem.name;
        resultItem2.defaultTooltip = sysDimItemDimsDefItem.defaultTooltip;
      }
      sysDimItemOtherDims && defaults(resultItem2.otherDims, sysDimItemOtherDims);
    });
  });
  function applyDim(resultItem2, coordDim2, coordDimIndex) {
    if (VISUAL_DIMENSIONS.get(coordDim2) != null) {
      resultItem2.otherDims[coordDim2] = coordDimIndex;
    } else {
      resultItem2.coordDim = coordDim2;
      resultItem2.coordDimIndex = coordDimIndex;
      coordDimNameMap.set(coordDim2, true);
    }
  }
  var generateCoord = opt.generateCoord;
  var generateCoordCount = opt.generateCoordCount;
  var fromZero = generateCoordCount != null;
  generateCoordCount = generateCoord ? generateCoordCount || 1 : 0;
  var extra = generateCoord || "value";
  function ifNoNameFillWithCoordName(resultItem2) {
    if (resultItem2.name == null) {
      resultItem2.name = resultItem2.coordDim;
    }
  }
  if (!omitUnusedDimensions) {
    for (var resultDimIdx = 0; resultDimIdx < dimCount; resultDimIdx++) {
      var resultItem = getResultItem(resultDimIdx);
      var coordDim = resultItem.coordDim;
      if (coordDim == null) {
        resultItem.coordDim = genCoordDimName(extra, coordDimNameMap, fromZero);
        resultItem.coordDimIndex = 0;
        if (!generateCoord || generateCoordCount <= 0) {
          resultItem.isExtraCoord = true;
        }
        generateCoordCount--;
      }
      ifNoNameFillWithCoordName(resultItem);
      if (resultItem.type == null && (guessOrdinal(source, resultDimIdx) === BE_ORDINAL.Must || resultItem.isExtraCoord && (resultItem.otherDims.itemName != null || resultItem.otherDims.seriesName != null))) {
        resultItem.type = "ordinal";
      }
    }
  } else {
    each$f(resultList, function(resultItem2) {
      ifNoNameFillWithCoordName(resultItem2);
    });
    resultList.sort(function(item0, item1) {
      return item0.storeDimIndex - item1.storeDimIndex;
    });
  }
  removeDuplication(resultList);
  return new SeriesDataSchema({
    source,
    dimensions: resultList,
    fullDimensionCount: dimCount,
    dimensionOmitted: omitUnusedDimensions
  });
}
function removeDuplication(result) {
  var duplicationMap = createHashMap();
  for (var i = 0; i < result.length; i++) {
    var dim = result[i];
    var dimOriginalName = dim.name;
    var count2 = duplicationMap.get(dimOriginalName) || 0;
    if (count2 > 0) {
      dim.name = dimOriginalName + (count2 - 1);
    }
    count2++;
    duplicationMap.set(dimOriginalName, count2);
  }
}
function getDimCount(source, sysDims, dimsDef, optDimCount) {
  var dimCount = Math.max(source.dimensionsDetectedCount || 1, sysDims.length, dimsDef.length, optDimCount || 0);
  each$f(sysDims, function(sysDimItem) {
    var sysDimItemDimsDef;
    if (isObject$4(sysDimItem) && (sysDimItemDimsDef = sysDimItem.dimsDef)) {
      dimCount = Math.max(dimCount, sysDimItemDimsDef.length);
    }
  });
  return dimCount;
}
function genCoordDimName(name, map2, fromZero) {
  var mapData = map2.data;
  if (fromZero || mapData.hasOwnProperty(name)) {
    var i = 0;
    while (mapData.hasOwnProperty(name + i)) {
      i++;
    }
    name += i;
  }
  map2.set(name, true);
  return name;
}
var CoordSysInfo = function() {
  function CoordSysInfo2(coordSysName) {
    this.coordSysDims = [];
    this.axisMap = createHashMap();
    this.categoryAxisMap = createHashMap();
    this.coordSysName = coordSysName;
  }
  return CoordSysInfo2;
}();
function getCoordSysInfoBySeries(seriesModel) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var result = new CoordSysInfo(coordSysName);
  var fetch = fetchers[coordSysName];
  if (fetch) {
    fetch(seriesModel, result, result.axisMap, result.categoryAxisMap);
    return result;
  }
}
var fetchers = {
  cartesian2d: function(seriesModel, result, axisMap, categoryAxisMap) {
    var xAxisModel = seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["x", "y"];
    axisMap.set("x", xAxisModel);
    axisMap.set("y", yAxisModel);
    if (isCategory(xAxisModel)) {
      categoryAxisMap.set("x", xAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(yAxisModel)) {
      categoryAxisMap.set("y", yAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  singleAxis: function(seriesModel, result, axisMap, categoryAxisMap) {
    var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["single"];
    axisMap.set("single", singleAxisModel);
    if (isCategory(singleAxisModel)) {
      categoryAxisMap.set("single", singleAxisModel);
      result.firstCategoryDimIndex = 0;
    }
  },
  polar: function(seriesModel, result, axisMap, categoryAxisMap) {
    var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
    var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
    var angleAxisModel = polarModel.findAxisModel("angleAxis");
    result.coordSysDims = ["radius", "angle"];
    axisMap.set("radius", radiusAxisModel);
    axisMap.set("angle", angleAxisModel);
    if (isCategory(radiusAxisModel)) {
      categoryAxisMap.set("radius", radiusAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(angleAxisModel)) {
      categoryAxisMap.set("angle", angleAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  geo: function(seriesModel, result, axisMap, categoryAxisMap) {
    result.coordSysDims = ["lng", "lat"];
  },
  parallel: function(seriesModel, result, axisMap, categoryAxisMap) {
    var ecModel = seriesModel.ecModel;
    var parallelModel = ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
    var coordSysDims = result.coordSysDims = parallelModel.dimensions.slice();
    each$f(parallelModel.parallelAxisIndex, function(axisIndex, index2) {
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axisDim = coordSysDims[index2];
      axisMap.set(axisDim, axisModel);
      if (isCategory(axisModel)) {
        categoryAxisMap.set(axisDim, axisModel);
        if (result.firstCategoryDimIndex == null) {
          result.firstCategoryDimIndex = index2;
        }
      }
    });
  }
};
function isCategory(axisModel) {
  return axisModel.get("type") === "category";
}
function enableDataStack(seriesModel, dimensionsInput, opt) {
  opt = opt || {};
  var byIndex = opt.byIndex;
  var stackedCoordDimension = opt.stackedCoordDimension;
  var dimensionDefineList;
  var schema;
  var store;
  if (isLegacyDimensionsInput(dimensionsInput)) {
    dimensionDefineList = dimensionsInput;
  } else {
    schema = dimensionsInput.schema;
    dimensionDefineList = schema.dimensions;
    store = dimensionsInput.store;
  }
  var mayStack = !!(seriesModel && seriesModel.get("stack"));
  var stackedByDimInfo;
  var stackedDimInfo;
  var stackResultDimension;
  var stackedOverDimension;
  each$f(dimensionDefineList, function(dimensionInfo, index2) {
    if (isString(dimensionInfo)) {
      dimensionDefineList[index2] = dimensionInfo = {
        name: dimensionInfo
      };
    }
    if (mayStack && !dimensionInfo.isExtraCoord) {
      if (!byIndex && !stackedByDimInfo && dimensionInfo.ordinalMeta) {
        stackedByDimInfo = dimensionInfo;
      }
      if (!stackedDimInfo && dimensionInfo.type !== "ordinal" && dimensionInfo.type !== "time" && (!stackedCoordDimension || stackedCoordDimension === dimensionInfo.coordDim)) {
        stackedDimInfo = dimensionInfo;
      }
    }
  });
  if (stackedDimInfo && !byIndex && !stackedByDimInfo) {
    byIndex = true;
  }
  if (stackedDimInfo) {
    stackResultDimension = "__\0ecstackresult_" + seriesModel.id;
    stackedOverDimension = "__\0ecstackedover_" + seriesModel.id;
    if (stackedByDimInfo) {
      stackedByDimInfo.createInvertedIndices = true;
    }
    var stackedDimCoordDim_1 = stackedDimInfo.coordDim;
    var stackedDimType = stackedDimInfo.type;
    var stackedDimCoordIndex_1 = 0;
    each$f(dimensionDefineList, function(dimensionInfo) {
      if (dimensionInfo.coordDim === stackedDimCoordDim_1) {
        stackedDimCoordIndex_1++;
      }
    });
    var stackedOverDimensionDefine = {
      name: stackResultDimension,
      coordDim: stackedDimCoordDim_1,
      coordDimIndex: stackedDimCoordIndex_1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length
    };
    var stackResultDimensionDefine = {
      name: stackedOverDimension,
      coordDim: stackedOverDimension,
      coordDimIndex: stackedDimCoordIndex_1 + 1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length + 1
    };
    if (schema) {
      if (store) {
        stackedOverDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackedOverDimension, stackedDimType);
        stackResultDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackResultDimension, stackedDimType);
      }
      schema.appendCalculationDimension(stackedOverDimensionDefine);
      schema.appendCalculationDimension(stackResultDimensionDefine);
    } else {
      dimensionDefineList.push(stackedOverDimensionDefine);
      dimensionDefineList.push(stackResultDimensionDefine);
    }
  }
  return {
    stackedDimension: stackedDimInfo && stackedDimInfo.name,
    stackedByDimension: stackedByDimInfo && stackedByDimInfo.name,
    isStackedByIndex: byIndex,
    stackedOverDimension,
    stackResultDimension
  };
}
function isLegacyDimensionsInput(dimensionsInput) {
  return !isSeriesDataSchema(dimensionsInput.schema);
}
function isDimensionStacked(data, stackedDim) {
  return !!stackedDim && stackedDim === data.getCalculationInfo("stackedDimension");
}
function getStackedDimension(data, targetDim) {
  return isDimensionStacked(data, targetDim) ? data.getCalculationInfo("stackResultDimension") : targetDim;
}
function getCoordSysDimDefs(seriesModel, coordSysInfo) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var registeredCoordSys = CoordinateSystem.get(coordSysName);
  var coordSysDimDefs;
  if (coordSysInfo && coordSysInfo.coordSysDims) {
    coordSysDimDefs = map$1(coordSysInfo.coordSysDims, function(dim) {
      var dimInfo = {
        name: dim
      };
      var axisModel = coordSysInfo.axisMap.get(dim);
      if (axisModel) {
        var axisType = axisModel.get("type");
        dimInfo.type = getDimensionTypeByAxis(axisType);
      }
      return dimInfo;
    });
  }
  if (!coordSysDimDefs) {
    coordSysDimDefs = registeredCoordSys && (registeredCoordSys.getDimensionsInfo ? registeredCoordSys.getDimensionsInfo() : registeredCoordSys.dimensions.slice()) || ["x", "y"];
  }
  return coordSysDimDefs;
}
function injectOrdinalMeta(dimInfoList, createInvertedIndices, coordSysInfo) {
  var firstCategoryDimIndex;
  var hasNameEncode;
  coordSysInfo && each$f(dimInfoList, function(dimInfo, dimIndex) {
    var coordDim = dimInfo.coordDim;
    var categoryAxisModel = coordSysInfo.categoryAxisMap.get(coordDim);
    if (categoryAxisModel) {
      if (firstCategoryDimIndex == null) {
        firstCategoryDimIndex = dimIndex;
      }
      dimInfo.ordinalMeta = categoryAxisModel.getOrdinalMeta();
      if (createInvertedIndices) {
        dimInfo.createInvertedIndices = true;
      }
    }
    if (dimInfo.otherDims.itemName != null) {
      hasNameEncode = true;
    }
  });
  if (!hasNameEncode && firstCategoryDimIndex != null) {
    dimInfoList[firstCategoryDimIndex].otherDims.itemName = 0;
  }
  return firstCategoryDimIndex;
}
function createSeriesData(sourceRaw, seriesModel, opt) {
  opt = opt || {};
  var sourceManager = seriesModel.getSourceManager();
  var source;
  var isOriginalSource = false;
  if (sourceRaw) {
    isOriginalSource = true;
    source = createSourceFromSeriesDataOption(sourceRaw);
  } else {
    source = sourceManager.getSource();
    isOriginalSource = source.sourceFormat === SOURCE_FORMAT_ORIGINAL;
  }
  var coordSysInfo = getCoordSysInfoBySeries(seriesModel);
  var coordSysDimDefs = getCoordSysDimDefs(seriesModel, coordSysInfo);
  var useEncodeDefaulter = opt.useEncodeDefaulter;
  var encodeDefaulter = isFunction(useEncodeDefaulter) ? useEncodeDefaulter : useEncodeDefaulter ? curry$1(makeSeriesEncodeForAxisCoordSys, coordSysDimDefs, seriesModel) : null;
  var createDimensionOptions = {
    coordDimensions: coordSysDimDefs,
    generateCoord: opt.generateCoord,
    encodeDefine: seriesModel.getEncode(),
    encodeDefaulter,
    canOmitUnusedDimensions: !isOriginalSource
  };
  var schema = prepareSeriesDataSchema(source, createDimensionOptions);
  var firstCategoryDimIndex = injectOrdinalMeta(schema.dimensions, opt.createInvertedIndices, coordSysInfo);
  var store = !isOriginalSource ? sourceManager.getSharedDataStore(schema) : null;
  var stackCalculationInfo = enableDataStack(seriesModel, {
    schema,
    store
  });
  var data = new SeriesData$1(schema, seriesModel);
  data.setCalculationInfo(stackCalculationInfo);
  var dimValueGetter = firstCategoryDimIndex != null && isNeedCompleteOrdinalData(source) ? function(itemOpt, dimName, dataIndex, dimIndex) {
    return dimIndex === firstCategoryDimIndex ? dataIndex : this.defaultDimValueGetter(itemOpt, dimName, dataIndex, dimIndex);
  } : null;
  data.hasItemOption = false;
  data.initData(isOriginalSource ? source : store, null, dimValueGetter);
  return data;
}
function isNeedCompleteOrdinalData(source) {
  if (source.sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var sampleItem = firstDataNotNull(source.data || []);
    return !isArray$1(getDataItemValue(sampleItem));
  }
}
function firstDataNotNull(arr) {
  var i = 0;
  while (i < arr.length && arr[i] == null) {
    i++;
  }
  return arr[i];
}
var Scale = function() {
  function Scale2(setting) {
    this._setting = setting || {};
    this._extent = [Infinity, -Infinity];
  }
  Scale2.prototype.getSetting = function(name) {
    return this._setting[name];
  };
  Scale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
  };
  Scale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  Scale2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Scale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = start2;
    }
    if (!isNaN(end2)) {
      thisExtent[1] = end2;
    }
  };
  Scale2.prototype.isInExtentRange = function(value) {
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  Scale2.prototype.isBlank = function() {
    return this._isBlank;
  };
  Scale2.prototype.setBlank = function(isBlank) {
    this._isBlank = isBlank;
  };
  return Scale2;
}();
enableClassManagement(Scale);
var Scale$1 = Scale;
var uidBase = 0;
var OrdinalMeta = function() {
  function OrdinalMeta2(opt) {
    this.categories = opt.categories || [];
    this._needCollect = opt.needCollect;
    this._deduplication = opt.deduplication;
    this.uid = ++uidBase;
  }
  OrdinalMeta2.createByAxisModel = function(axisModel) {
    var option = axisModel.option;
    var data = option.data;
    var categories = data && map$1(data, getName);
    return new OrdinalMeta2({
      categories,
      needCollect: !categories,
      deduplication: option.dedplication !== false
    });
  };
  OrdinalMeta2.prototype.getOrdinal = function(category) {
    return this._getOrCreateMap().get(category);
  };
  OrdinalMeta2.prototype.parseAndCollect = function(category) {
    var index2;
    var needCollect = this._needCollect;
    if (!isString(category) && !needCollect) {
      return category;
    }
    if (needCollect && !this._deduplication) {
      index2 = this.categories.length;
      this.categories[index2] = category;
      return index2;
    }
    var map2 = this._getOrCreateMap();
    index2 = map2.get(category);
    if (index2 == null) {
      if (needCollect) {
        index2 = this.categories.length;
        this.categories[index2] = category;
        map2.set(category, index2);
      } else {
        index2 = NaN;
      }
    }
    return index2;
  };
  OrdinalMeta2.prototype._getOrCreateMap = function() {
    return this._map || (this._map = createHashMap(this.categories));
  };
  return OrdinalMeta2;
}();
function getName(obj) {
  if (isObject$4(obj) && obj.value != null) {
    return obj.value;
  } else {
    return obj + "";
  }
}
var OrdinalMeta$1 = OrdinalMeta;
function isIntervalOrLogScale(scale2) {
  return scale2.type === "interval" || scale2.type === "log";
}
function intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval) {
  var result = {};
  var span = extent3[1] - extent3[0];
  var interval = result.interval = nice(span / splitNumber, true);
  if (minInterval != null && interval < minInterval) {
    interval = result.interval = minInterval;
  }
  if (maxInterval != null && interval > maxInterval) {
    interval = result.interval = maxInterval;
  }
  var precision = result.intervalPrecision = getIntervalPrecision(interval);
  var niceTickExtent = result.niceTickExtent = [round$3(Math.ceil(extent3[0] / interval) * interval, precision), round$3(Math.floor(extent3[1] / interval) * interval, precision)];
  fixExtent(niceTickExtent, extent3);
  return result;
}
function increaseInterval(interval) {
  var exp10 = Math.pow(10, quantityExponent(interval));
  var f2 = interval / exp10;
  if (!f2) {
    f2 = 1;
  } else if (f2 === 2) {
    f2 = 3;
  } else if (f2 === 3) {
    f2 = 5;
  } else {
    f2 *= 2;
  }
  return round$3(f2 * exp10);
}
function getIntervalPrecision(interval) {
  return getPrecision(interval) + 2;
}
function clamp(niceTickExtent, idx, extent3) {
  niceTickExtent[idx] = Math.max(Math.min(niceTickExtent[idx], extent3[1]), extent3[0]);
}
function fixExtent(niceTickExtent, extent3) {
  !isFinite(niceTickExtent[0]) && (niceTickExtent[0] = extent3[0]);
  !isFinite(niceTickExtent[1]) && (niceTickExtent[1] = extent3[1]);
  clamp(niceTickExtent, 0, extent3);
  clamp(niceTickExtent, 1, extent3);
  if (niceTickExtent[0] > niceTickExtent[1]) {
    niceTickExtent[0] = niceTickExtent[1];
  }
}
function contain$1(val, extent3) {
  return val >= extent3[0] && val <= extent3[1];
}
function normalize$3(val, extent3) {
  if (extent3[1] === extent3[0]) {
    return 0.5;
  }
  return (val - extent3[0]) / (extent3[1] - extent3[0]);
}
function scale(val, extent3) {
  return val * (extent3[1] - extent3[0]) + extent3[0];
}
var OrdinalScale = function(_super) {
  __extends(OrdinalScale2, _super);
  function OrdinalScale2(setting) {
    var _this = _super.call(this, setting) || this;
    _this.type = "ordinal";
    var ordinalMeta = _this.getSetting("ordinalMeta");
    if (!ordinalMeta) {
      ordinalMeta = new OrdinalMeta$1({});
    }
    if (isArray$1(ordinalMeta)) {
      ordinalMeta = new OrdinalMeta$1({
        categories: map$1(ordinalMeta, function(item) {
          return isObject$4(item) ? item.value : item;
        })
      });
    }
    _this._ordinalMeta = ordinalMeta;
    _this._extent = _this.getSetting("extent") || [0, ordinalMeta.categories.length - 1];
    return _this;
  }
  OrdinalScale2.prototype.parse = function(val) {
    return isString(val) ? this._ordinalMeta.getOrdinal(val) : Math.round(val);
  };
  OrdinalScale2.prototype.contain = function(rank) {
    rank = this.parse(rank);
    return contain$1(rank, this._extent) && this._ordinalMeta.categories[rank] != null;
  };
  OrdinalScale2.prototype.normalize = function(val) {
    val = this._getTickNumber(this.parse(val));
    return normalize$3(val, this._extent);
  };
  OrdinalScale2.prototype.scale = function(val) {
    val = Math.round(scale(val, this._extent));
    return this.getRawOrdinalNumber(val);
  };
  OrdinalScale2.prototype.getTicks = function() {
    var ticks = [];
    var extent3 = this._extent;
    var rank = extent3[0];
    while (rank <= extent3[1]) {
      ticks.push({
        value: rank
      });
      rank++;
    }
    return ticks;
  };
  OrdinalScale2.prototype.getMinorTicks = function(splitNumber) {
    return;
  };
  OrdinalScale2.prototype.setSortInfo = function(info) {
    if (info == null) {
      this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
      return;
    }
    var infoOrdinalNumbers = info.ordinalNumbers;
    var ordinalsByTick = this._ordinalNumbersByTick = [];
    var ticksByOrdinal = this._ticksByOrdinalNumber = [];
    var tickNum = 0;
    var allCategoryLen = this._ordinalMeta.categories.length;
    for (var len2 = Math.min(allCategoryLen, infoOrdinalNumbers.length); tickNum < len2; ++tickNum) {
      var ordinalNumber = infoOrdinalNumbers[tickNum];
      ordinalsByTick[tickNum] = ordinalNumber;
      ticksByOrdinal[ordinalNumber] = tickNum;
    }
    var unusedOrdinal = 0;
    for (; tickNum < allCategoryLen; ++tickNum) {
      while (ticksByOrdinal[unusedOrdinal] != null) {
        unusedOrdinal++;
      }
      ordinalsByTick.push(unusedOrdinal);
      ticksByOrdinal[unusedOrdinal] = tickNum;
    }
  };
  OrdinalScale2.prototype._getTickNumber = function(ordinal) {
    var ticksByOrdinalNumber = this._ticksByOrdinalNumber;
    return ticksByOrdinalNumber && ordinal >= 0 && ordinal < ticksByOrdinalNumber.length ? ticksByOrdinalNumber[ordinal] : ordinal;
  };
  OrdinalScale2.prototype.getRawOrdinalNumber = function(tickNumber) {
    var ordinalNumbersByTick = this._ordinalNumbersByTick;
    return ordinalNumbersByTick && tickNumber >= 0 && tickNumber < ordinalNumbersByTick.length ? ordinalNumbersByTick[tickNumber] : tickNumber;
  };
  OrdinalScale2.prototype.getLabel = function(tick) {
    if (!this.isBlank()) {
      var ordinalNumber = this.getRawOrdinalNumber(tick.value);
      var cateogry = this._ordinalMeta.categories[ordinalNumber];
      return cateogry == null ? "" : cateogry + "";
    }
  };
  OrdinalScale2.prototype.count = function() {
    return this._extent[1] - this._extent[0] + 1;
  };
  OrdinalScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  OrdinalScale2.prototype.isInExtentRange = function(value) {
    value = this._getTickNumber(value);
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  OrdinalScale2.prototype.getOrdinalMeta = function() {
    return this._ordinalMeta;
  };
  OrdinalScale2.prototype.calcNiceTicks = function() {
  };
  OrdinalScale2.prototype.calcNiceExtent = function() {
  };
  OrdinalScale2.type = "ordinal";
  return OrdinalScale2;
}(Scale$1);
Scale$1.registerClass(OrdinalScale);
var OrdinalScale$1 = OrdinalScale;
var roundNumber = round$3;
var IntervalScale = function(_super) {
  __extends(IntervalScale2, _super);
  function IntervalScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "interval";
    _this._interval = 0;
    _this._intervalPrecision = 2;
    return _this;
  }
  IntervalScale2.prototype.parse = function(val) {
    return val;
  };
  IntervalScale2.prototype.contain = function(val) {
    return contain$1(val, this._extent);
  };
  IntervalScale2.prototype.normalize = function(val) {
    return normalize$3(val, this._extent);
  };
  IntervalScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  IntervalScale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = parseFloat(start2);
    }
    if (!isNaN(end2)) {
      thisExtent[1] = parseFloat(end2);
    }
  };
  IntervalScale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
    this.setExtent(extent3[0], extent3[1]);
  };
  IntervalScale2.prototype.getInterval = function() {
    return this._interval;
  };
  IntervalScale2.prototype.setInterval = function(interval) {
    this._interval = interval;
    this._niceExtent = this._extent.slice();
    this._intervalPrecision = getIntervalPrecision(interval);
  };
  IntervalScale2.prototype.getTicks = function(expandToNicedExtent) {
    var interval = this._interval;
    var extent3 = this._extent;
    var niceTickExtent = this._niceExtent;
    var intervalPrecision = this._intervalPrecision;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    var safeLimit = 1e4;
    if (extent3[0] < niceTickExtent[0]) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(niceTickExtent[0] - interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[0]
        });
      }
    }
    var tick = niceTickExtent[0];
    while (tick <= niceTickExtent[1]) {
      ticks.push({
        value: tick
      });
      tick = roundNumber(tick + interval, intervalPrecision);
      if (tick === ticks[ticks.length - 1].value) {
        break;
      }
      if (ticks.length > safeLimit) {
        return [];
      }
    }
    var lastNiceTick = ticks.length ? ticks[ticks.length - 1].value : niceTickExtent[1];
    if (extent3[1] > lastNiceTick) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(lastNiceTick + interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[1]
        });
      }
    }
    return ticks;
  };
  IntervalScale2.prototype.getMinorTicks = function(splitNumber) {
    var ticks = this.getTicks(true);
    var minorTicks = [];
    var extent3 = this.getExtent();
    for (var i = 1; i < ticks.length; i++) {
      var nextTick = ticks[i];
      var prevTick = ticks[i - 1];
      var count2 = 0;
      var minorTicksGroup = [];
      var interval = nextTick.value - prevTick.value;
      var minorInterval = interval / splitNumber;
      while (count2 < splitNumber - 1) {
        var minorTick = roundNumber(prevTick.value + (count2 + 1) * minorInterval);
        if (minorTick > extent3[0] && minorTick < extent3[1]) {
          minorTicksGroup.push(minorTick);
        }
        count2++;
      }
      minorTicks.push(minorTicksGroup);
    }
    return minorTicks;
  };
  IntervalScale2.prototype.getLabel = function(data, opt) {
    if (data == null) {
      return "";
    }
    var precision = opt && opt.precision;
    if (precision == null) {
      precision = getPrecision(data.value) || 0;
    } else if (precision === "auto") {
      precision = this._intervalPrecision;
    }
    var dataNum = roundNumber(data.value, precision, true);
    return addCommas(dataNum);
  };
  IntervalScale2.prototype.calcNiceTicks = function(splitNumber, minInterval, maxInterval) {
    splitNumber = splitNumber || 5;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      return;
    }
    if (span < 0) {
      span = -span;
      extent3.reverse();
    }
    var result = intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval);
    this._intervalPrecision = result.intervalPrecision;
    this._interval = result.interval;
    this._niceExtent = result.niceTickExtent;
  };
  IntervalScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      if (extent3[0] !== 0) {
        var expandSize = extent3[0];
        if (!opt.fixMax) {
          extent3[1] += expandSize / 2;
          extent3[0] -= expandSize / 2;
        } else {
          extent3[0] -= expandSize / 2;
        }
      } else {
        extent3[1] = 1;
      }
    }
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      extent3[0] = 0;
      extent3[1] = 1;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
    var interval = this._interval;
    if (!opt.fixMin) {
      extent3[0] = roundNumber(Math.floor(extent3[0] / interval) * interval);
    }
    if (!opt.fixMax) {
      extent3[1] = roundNumber(Math.ceil(extent3[1] / interval) * interval);
    }
  };
  IntervalScale2.prototype.setNiceExtent = function(min3, max3) {
    this._niceExtent = [min3, max3];
  };
  IntervalScale2.type = "interval";
  return IntervalScale2;
}(Scale$1);
Scale$1.registerClass(IntervalScale);
var IntervalScale$1 = IntervalScale;
var supportFloat32Array = typeof Float32Array !== "undefined";
var Float32ArrayCtor = !supportFloat32Array ? Array : Float32Array;
function createFloat32Array(arg) {
  if (isArray$1(arg)) {
    return supportFloat32Array ? new Float32Array(arg) : arg;
  }
  return new Float32ArrayCtor(arg);
}
var STACK_PREFIX = "__ec_stack_";
function getSeriesStackId$1(seriesModel) {
  return seriesModel.get("stack") || STACK_PREFIX + seriesModel.seriesIndex;
}
function getAxisKey$1(axis) {
  return axis.dim + axis.index;
}
function getLayoutOnAxis(opt) {
  var params = [];
  var baseAxis = opt.axis;
  var axisKey = "axis0";
  if (baseAxis.type !== "category") {
    return;
  }
  var bandWidth = baseAxis.getBandWidth();
  for (var i = 0; i < opt.count || 0; i++) {
    params.push(defaults({
      bandWidth,
      axisKey,
      stackId: STACK_PREFIX + i
    }, opt));
  }
  var widthAndOffsets = doCalBarWidthAndOffset(params);
  var result = [];
  for (var i = 0; i < opt.count; i++) {
    var item = widthAndOffsets[axisKey][STACK_PREFIX + i];
    item.offsetCenter = item.offset + item.width / 2;
    result.push(item);
  }
  return result;
}
function prepareLayoutBarSeries(seriesType2, ecModel) {
  var seriesModels = [];
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (isOnCartesian(seriesModel)) {
      seriesModels.push(seriesModel);
    }
  });
  return seriesModels;
}
function getValueAxesMinGaps(barSeries) {
  var axisValues = {};
  each$f(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    if (baseAxis.type !== "time" && baseAxis.type !== "value") {
      return;
    }
    var data = seriesModel.getData();
    var key2 = baseAxis.dim + "_" + baseAxis.index;
    var dimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
    var store = data.getStore();
    for (var i = 0, cnt = store.count(); i < cnt; ++i) {
      var value = store.get(dimIdx, i);
      if (!axisValues[key2]) {
        axisValues[key2] = [value];
      } else {
        axisValues[key2].push(value);
      }
    }
  });
  var axisMinGaps = {};
  for (var key in axisValues) {
    if (axisValues.hasOwnProperty(key)) {
      var valuesInAxis = axisValues[key];
      if (valuesInAxis) {
        valuesInAxis.sort(function(a, b2) {
          return a - b2;
        });
        var min3 = null;
        for (var j = 1; j < valuesInAxis.length; ++j) {
          var delta = valuesInAxis[j] - valuesInAxis[j - 1];
          if (delta > 0) {
            min3 = min3 === null ? delta : Math.min(min3, delta);
          }
        }
        axisMinGaps[key] = min3;
      }
    }
  }
  return axisMinGaps;
}
function makeColumnLayout(barSeries) {
  var axisMinGaps = getValueAxesMinGaps(barSeries);
  var seriesInfoList = [];
  each$f(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var axisExtent = baseAxis.getExtent();
    var bandWidth;
    if (baseAxis.type === "category") {
      bandWidth = baseAxis.getBandWidth();
    } else if (baseAxis.type === "value" || baseAxis.type === "time") {
      var key = baseAxis.dim + "_" + baseAxis.index;
      var minGap = axisMinGaps[key];
      var extentSpan = Math.abs(axisExtent[1] - axisExtent[0]);
      var scale2 = baseAxis.scale.getExtent();
      var scaleSpan = Math.abs(scale2[1] - scale2[0]);
      bandWidth = minGap ? extentSpan / scaleSpan * minGap : extentSpan;
    } else {
      var data = seriesModel.getData();
      bandWidth = Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    }
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barMinWidth = parsePercent(seriesModel.get("barMinWidth") || (isInLargeMode(seriesModel) ? 0.5 : 1), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    seriesInfoList.push({
      bandWidth,
      barWidth,
      barMaxWidth,
      barMinWidth,
      barGap,
      barCategoryGap,
      axisKey: getAxisKey$1(baseAxis),
      stackId: getSeriesStackId$1(seriesModel)
    });
  });
  return doCalBarWidthAndOffset(seriesInfoList);
}
function doCalBarWidthAndOffset(seriesInfoList) {
  var columnsMap = {};
  each$f(seriesInfoList, function(seriesInfo, idx) {
    var axisKey = seriesInfo.axisKey;
    var bandWidth = seriesInfo.bandWidth;
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: null,
      gap: "20%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = seriesInfo.stackId;
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = seriesInfo.barWidth;
    if (barWidth && !stacks[stackId].width) {
      stacks[stackId].width = barWidth;
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      columnsOnAxis.remainedWidth -= barWidth;
    }
    var barMaxWidth = seriesInfo.barMaxWidth;
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    var barMinWidth = seriesInfo.barMinWidth;
    barMinWidth && (stacks[stackId].minWidth = barMinWidth);
    var barGap = seriesInfo.barGap;
    barGap != null && (columnsOnAxis.gap = barGap);
    var barCategoryGap = seriesInfo.barCategoryGap;
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$f(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGapPercent = columnsOnAxis.categoryGap;
    if (categoryGapPercent == null) {
      var columnCount = keys(stacks).length;
      categoryGapPercent = Math.max(35 - columnCount * 4, 15) + "%";
    }
    var categoryGap = parsePercent(categoryGapPercent, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$f(stacks, function(column) {
      var maxWidth = column.maxWidth;
      var minWidth = column.minWidth;
      if (!column.width) {
        var finalWidth = autoWidth;
        if (maxWidth && maxWidth < finalWidth) {
          finalWidth = Math.min(maxWidth, remainedWidth);
        }
        if (minWidth && minWidth > finalWidth) {
          finalWidth = minWidth;
        }
        if (finalWidth !== autoWidth) {
          column.width = finalWidth;
          remainedWidth -= finalWidth + barGapPercent * finalWidth;
          autoWidthCount--;
        }
      } else {
        var finalWidth = column.width;
        if (maxWidth) {
          finalWidth = Math.min(finalWidth, maxWidth);
        }
        if (minWidth) {
          finalWidth = Math.max(finalWidth, minWidth);
        }
        column.width = finalWidth;
        remainedWidth -= finalWidth + barGapPercent * finalWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$f(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset = -widthSum / 2;
    each$f(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        bandWidth,
        offset,
        width: column.width
      };
      offset += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
function retrieveColumnLayout(barWidthAndOffset, axis, seriesModel) {
  if (barWidthAndOffset && axis) {
    var result = barWidthAndOffset[getAxisKey$1(axis)];
    if (result != null && seriesModel != null) {
      return result[getSeriesStackId$1(seriesModel)];
    }
    return result;
  }
}
function layout$3(seriesType2, ecModel) {
  var seriesModels = prepareLayoutBarSeries(seriesType2, ecModel);
  var barWidthAndOffset = makeColumnLayout(seriesModels);
  each$f(seriesModels, function(seriesModel) {
    var data = seriesModel.getData();
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var stackId = getSeriesStackId$1(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[getAxisKey$1(baseAxis)][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    data.setLayout({
      bandWidth: columnLayoutInfo.bandWidth,
      offset: columnOffset,
      size: columnWidth
    });
  });
}
function createProgressiveLayout(seriesType2) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      if (!isOnCartesian(seriesModel)) {
        return;
      }
      var data = seriesModel.getData();
      var cartesian = seriesModel.coordinateSystem;
      var baseAxis = cartesian.getBaseAxis();
      var valueAxis2 = cartesian.getOtherAxis(baseAxis);
      var valueDimIdx = data.getDimensionIndex(data.mapDimension(valueAxis2.dim));
      var baseDimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
      var drawBackground = seriesModel.get("showBackground", true);
      var valueDim = data.mapDimension(valueAxis2.dim);
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      var stacked = isDimensionStacked(data, valueDim) && !!data.getCalculationInfo("stackedOnSeries");
      var isValueAxisH = valueAxis2.isHorizontal();
      var valueAxisStart = getValueAxisStart(baseAxis, valueAxis2);
      var isLarge = isInLargeMode(seriesModel);
      var barMinHeight = seriesModel.get("barMinHeight") || 0;
      var stackedDimIdx = stackResultDim && data.getDimensionIndex(stackResultDim);
      var columnWidth = data.getLayout("size");
      var columnOffset = data.getLayout("offset");
      return {
        progress: function(params, data2) {
          var count2 = params.count;
          var largePoints = isLarge && createFloat32Array(count2 * 3);
          var largeBackgroundPoints = isLarge && drawBackground && createFloat32Array(count2 * 3);
          var largeDataIndices = isLarge && createFloat32Array(count2);
          var coordLayout = cartesian.master.getRect();
          var bgSize = isValueAxisH ? coordLayout.width : coordLayout.height;
          var dataIndex;
          var store = data2.getStore();
          var idxOffset = 0;
          while ((dataIndex = params.next()) != null) {
            var value = store.get(stacked ? stackedDimIdx : valueDimIdx, dataIndex);
            var baseValue = store.get(baseDimIdx, dataIndex);
            var baseCoord = valueAxisStart;
            var startValue = void 0;
            if (stacked) {
              startValue = +value - store.get(valueDimIdx, dataIndex);
            }
            var x2 = void 0;
            var y2 = void 0;
            var width = void 0;
            var height = void 0;
            if (isValueAxisH) {
              var coord = cartesian.dataToPoint([value, baseValue]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([startValue, baseValue]);
                baseCoord = startCoord[0];
              }
              x2 = baseCoord;
              y2 = coord[1] + columnOffset;
              width = coord[0] - baseCoord;
              height = columnWidth;
              if (Math.abs(width) < barMinHeight) {
                width = (width < 0 ? -1 : 1) * barMinHeight;
              }
            } else {
              var coord = cartesian.dataToPoint([baseValue, value]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([baseValue, startValue]);
                baseCoord = startCoord[1];
              }
              x2 = coord[0] + columnOffset;
              y2 = baseCoord;
              width = columnWidth;
              height = coord[1] - baseCoord;
              if (Math.abs(height) < barMinHeight) {
                height = (height <= 0 ? -1 : 1) * barMinHeight;
              }
            }
            if (!isLarge) {
              data2.setItemLayout(dataIndex, {
                x: x2,
                y: y2,
                width,
                height
              });
            } else {
              largePoints[idxOffset] = x2;
              largePoints[idxOffset + 1] = y2;
              largePoints[idxOffset + 2] = isValueAxisH ? width : height;
              if (largeBackgroundPoints) {
                largeBackgroundPoints[idxOffset] = isValueAxisH ? coordLayout.x : x2;
                largeBackgroundPoints[idxOffset + 1] = isValueAxisH ? y2 : coordLayout.y;
                largeBackgroundPoints[idxOffset + 2] = bgSize;
              }
              largeDataIndices[dataIndex] = dataIndex;
            }
            idxOffset += 3;
          }
          if (isLarge) {
            data2.setLayout({
              largePoints,
              largeDataIndices,
              largeBackgroundPoints,
              valueAxisHorizontal: isValueAxisH
            });
          }
        }
      };
    }
  };
}
function isOnCartesian(seriesModel) {
  return seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "cartesian2d";
}
function isInLargeMode(seriesModel) {
  return seriesModel.pipelineContext && seriesModel.pipelineContext.large;
}
function getValueAxisStart(baseAxis, valueAxis2) {
  return valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(valueAxis2.type === "log" ? 1 : 0));
}
var bisect = function(a, x2, lo, hi) {
  while (lo < hi) {
    var mid = lo + hi >>> 1;
    if (a[mid][1] < x2) {
      lo = mid + 1;
    } else {
      hi = mid;
    }
  }
  return lo;
};
var TimeScale = function(_super) {
  __extends(TimeScale2, _super);
  function TimeScale2(settings) {
    var _this = _super.call(this, settings) || this;
    _this.type = "time";
    return _this;
  }
  TimeScale2.prototype.getLabel = function(tick) {
    var useUTC = this.getSetting("useUTC");
    return format$1(tick.value, fullLeveledFormatter[getDefaultFormatPrecisionOfInterval(getPrimaryTimeUnit(this._minLevelUnit))] || fullLeveledFormatter.second, useUTC, this.getSetting("locale"));
  };
  TimeScale2.prototype.getFormattedLabel = function(tick, idx, labelFormatter) {
    var isUTC = this.getSetting("useUTC");
    var lang = this.getSetting("locale");
    return leveledFormat(tick, idx, labelFormatter, lang, isUTC);
  };
  TimeScale2.prototype.getTicks = function() {
    var interval = this._interval;
    var extent3 = this._extent;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    ticks.push({
      value: extent3[0],
      level: 0
    });
    var useUTC = this.getSetting("useUTC");
    var innerTicks = getIntervalTicks(this._minLevelUnit, this._approxInterval, useUTC, extent3);
    ticks = ticks.concat(innerTicks);
    ticks.push({
      value: extent3[1],
      level: 0
    });
    return ticks;
  };
  TimeScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      extent3[0] -= ONE_DAY;
      extent3[1] += ONE_DAY;
    }
    if (extent3[1] === -Infinity && extent3[0] === Infinity) {
      var d2 = new Date();
      extent3[1] = +new Date(d2.getFullYear(), d2.getMonth(), d2.getDate());
      extent3[0] = extent3[1] - ONE_DAY;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
  };
  TimeScale2.prototype.calcNiceTicks = function(approxTickNum, minInterval, maxInterval) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    this._approxInterval = span / approxTickNum;
    if (minInterval != null && this._approxInterval < minInterval) {
      this._approxInterval = minInterval;
    }
    if (maxInterval != null && this._approxInterval > maxInterval) {
      this._approxInterval = maxInterval;
    }
    var scaleIntervalsLen = scaleIntervals.length;
    var idx = Math.min(bisect(scaleIntervals, this._approxInterval, 0, scaleIntervalsLen), scaleIntervalsLen - 1);
    this._interval = scaleIntervals[idx][1];
    this._minLevelUnit = scaleIntervals[Math.max(idx - 1, 0)][0];
  };
  TimeScale2.prototype.parse = function(val) {
    return isNumber(val) ? val : +parseDate(val);
  };
  TimeScale2.prototype.contain = function(val) {
    return contain$1(this.parse(val), this._extent);
  };
  TimeScale2.prototype.normalize = function(val) {
    return normalize$3(this.parse(val), this._extent);
  };
  TimeScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  TimeScale2.type = "time";
  return TimeScale2;
}(IntervalScale$1);
var scaleIntervals = [
  ["second", ONE_SECOND],
  ["minute", ONE_MINUTE],
  ["hour", ONE_HOUR],
  ["quarter-day", ONE_HOUR * 6],
  ["half-day", ONE_HOUR * 12],
  ["day", ONE_DAY * 1.2],
  ["half-week", ONE_DAY * 3.5],
  ["week", ONE_DAY * 7],
  ["month", ONE_DAY * 31],
  ["quarter", ONE_DAY * 95],
  ["half-year", ONE_YEAR / 2],
  ["year", ONE_YEAR]
];
function isUnitValueSame(unit, valueA, valueB, isUTC) {
  var dateA = parseDate(valueA);
  var dateB = parseDate(valueB);
  var isSame = function(unit2) {
    return getUnitValue(dateA, unit2, isUTC) === getUnitValue(dateB, unit2, isUTC);
  };
  var isSameYear = function() {
    return isSame("year");
  };
  var isSameMonth = function() {
    return isSameYear() && isSame("month");
  };
  var isSameDay = function() {
    return isSameMonth() && isSame("day");
  };
  var isSameHour = function() {
    return isSameDay() && isSame("hour");
  };
  var isSameMinute = function() {
    return isSameHour() && isSame("minute");
  };
  var isSameSecond = function() {
    return isSameMinute() && isSame("second");
  };
  var isSameMilliSecond = function() {
    return isSameSecond() && isSame("millisecond");
  };
  switch (unit) {
    case "year":
      return isSameYear();
    case "month":
      return isSameMonth();
    case "day":
      return isSameDay();
    case "hour":
      return isSameHour();
    case "minute":
      return isSameMinute();
    case "second":
      return isSameSecond();
    case "millisecond":
      return isSameMilliSecond();
  }
}
function getDateInterval(approxInterval, daysInMonth) {
  approxInterval /= ONE_DAY;
  return approxInterval > 16 ? 16 : approxInterval > 7.5 ? 7 : approxInterval > 3.5 ? 4 : approxInterval > 1.5 ? 2 : 1;
}
function getMonthInterval(approxInterval) {
  var APPROX_ONE_MONTH = 30 * ONE_DAY;
  approxInterval /= APPROX_ONE_MONTH;
  return approxInterval > 6 ? 6 : approxInterval > 3 ? 3 : approxInterval > 2 ? 2 : 1;
}
function getHourInterval(approxInterval) {
  approxInterval /= ONE_HOUR;
  return approxInterval > 12 ? 12 : approxInterval > 6 ? 6 : approxInterval > 3.5 ? 4 : approxInterval > 2 ? 2 : 1;
}
function getMinutesAndSecondsInterval(approxInterval, isMinutes) {
  approxInterval /= isMinutes ? ONE_MINUTE : ONE_SECOND;
  return approxInterval > 30 ? 30 : approxInterval > 20 ? 20 : approxInterval > 15 ? 15 : approxInterval > 10 ? 10 : approxInterval > 5 ? 5 : approxInterval > 2 ? 2 : 1;
}
function getMillisecondsInterval(approxInterval) {
  return nice(approxInterval, true);
}
function getFirstTimestampOfUnit(date4, unitName, isUTC) {
  var outDate = new Date(date4);
  switch (getPrimaryTimeUnit(unitName)) {
    case "year":
    case "month":
      outDate[monthSetterName(isUTC)](0);
    case "day":
      outDate[dateSetterName(isUTC)](1);
    case "hour":
      outDate[hoursSetterName(isUTC)](0);
    case "minute":
      outDate[minutesSetterName(isUTC)](0);
    case "second":
      outDate[secondsSetterName(isUTC)](0);
      outDate[millisecondsSetterName(isUTC)](0);
  }
  return outDate.getTime();
}
function getIntervalTicks(bottomUnitName, approxInterval, isUTC, extent3) {
  var safeLimit = 1e4;
  var unitNames = timeUnits;
  var iter = 0;
  function addTicksInSpan(interval, minTimestamp, maxTimestamp, getMethodName, setMethodName, isDate, out2) {
    var date4 = new Date(minTimestamp);
    var dateTime = minTimestamp;
    var d2 = date4[getMethodName]();
    while (dateTime < maxTimestamp && dateTime <= extent3[1]) {
      out2.push({
        value: dateTime
      });
      d2 += interval;
      date4[setMethodName](d2);
      dateTime = date4.getTime();
    }
    out2.push({
      value: dateTime,
      notAdd: true
    });
  }
  function addLevelTicks(unitName, lastLevelTicks, levelTicks2) {
    var newAddedTicks = [];
    var isFirstLevel = !lastLevelTicks.length;
    if (isUnitValueSame(getPrimaryTimeUnit(unitName), extent3[0], extent3[1], isUTC)) {
      return;
    }
    if (isFirstLevel) {
      lastLevelTicks = [{
        value: getFirstTimestampOfUnit(new Date(extent3[0]), unitName, isUTC)
      }, {
        value: extent3[1]
      }];
    }
    for (var i2 = 0; i2 < lastLevelTicks.length - 1; i2++) {
      var startTick = lastLevelTicks[i2].value;
      var endTick = lastLevelTicks[i2 + 1].value;
      if (startTick === endTick) {
        continue;
      }
      var interval = void 0;
      var getterName = void 0;
      var setterName = void 0;
      var isDate = false;
      switch (unitName) {
        case "year":
          interval = Math.max(1, Math.round(approxInterval / ONE_DAY / 365));
          getterName = fullYearGetterName(isUTC);
          setterName = fullYearSetterName(isUTC);
          break;
        case "half-year":
        case "quarter":
        case "month":
          interval = getMonthInterval(approxInterval);
          getterName = monthGetterName(isUTC);
          setterName = monthSetterName(isUTC);
          break;
        case "week":
        case "half-week":
        case "day":
          interval = getDateInterval(approxInterval);
          getterName = dateGetterName(isUTC);
          setterName = dateSetterName(isUTC);
          isDate = true;
          break;
        case "half-day":
        case "quarter-day":
        case "hour":
          interval = getHourInterval(approxInterval);
          getterName = hoursGetterName(isUTC);
          setterName = hoursSetterName(isUTC);
          break;
        case "minute":
          interval = getMinutesAndSecondsInterval(approxInterval, true);
          getterName = minutesGetterName(isUTC);
          setterName = minutesSetterName(isUTC);
          break;
        case "second":
          interval = getMinutesAndSecondsInterval(approxInterval, false);
          getterName = secondsGetterName(isUTC);
          setterName = secondsSetterName(isUTC);
          break;
        case "millisecond":
          interval = getMillisecondsInterval(approxInterval);
          getterName = millisecondsGetterName(isUTC);
          setterName = millisecondsSetterName(isUTC);
          break;
      }
      addTicksInSpan(interval, startTick, endTick, getterName, setterName, isDate, newAddedTicks);
      if (unitName === "year" && levelTicks2.length > 1 && i2 === 0) {
        levelTicks2.unshift({
          value: levelTicks2[0].value - interval
        });
      }
    }
    for (var i2 = 0; i2 < newAddedTicks.length; i2++) {
      levelTicks2.push(newAddedTicks[i2]);
    }
    return newAddedTicks;
  }
  var levelsTicks = [];
  var currentLevelTicks = [];
  var tickCount = 0;
  var lastLevelTickCount = 0;
  for (var i = 0; i < unitNames.length && iter++ < safeLimit; ++i) {
    var primaryTimeUnit = getPrimaryTimeUnit(unitNames[i]);
    if (!isPrimaryTimeUnit(unitNames[i])) {
      continue;
    }
    addLevelTicks(unitNames[i], levelsTicks[levelsTicks.length - 1] || [], currentLevelTicks);
    var nextPrimaryTimeUnit = unitNames[i + 1] ? getPrimaryTimeUnit(unitNames[i + 1]) : null;
    if (primaryTimeUnit !== nextPrimaryTimeUnit) {
      if (currentLevelTicks.length) {
        lastLevelTickCount = tickCount;
        currentLevelTicks.sort(function(a, b2) {
          return a.value - b2.value;
        });
        var levelTicksRemoveDuplicated = [];
        for (var i_1 = 0; i_1 < currentLevelTicks.length; ++i_1) {
          var tickValue = currentLevelTicks[i_1].value;
          if (i_1 === 0 || currentLevelTicks[i_1 - 1].value !== tickValue) {
            levelTicksRemoveDuplicated.push(currentLevelTicks[i_1]);
            if (tickValue >= extent3[0] && tickValue <= extent3[1]) {
              tickCount++;
            }
          }
        }
        var targetTickNum = (extent3[1] - extent3[0]) / approxInterval;
        if (tickCount > targetTickNum * 1.5 && lastLevelTickCount > targetTickNum / 1.5) {
          break;
        }
        levelsTicks.push(levelTicksRemoveDuplicated);
        if (tickCount > targetTickNum || bottomUnitName === unitNames[i]) {
          break;
        }
      }
      currentLevelTicks = [];
    }
  }
  var levelsTicksInExtent = filter(map$1(levelsTicks, function(levelTicks2) {
    return filter(levelTicks2, function(tick) {
      return tick.value >= extent3[0] && tick.value <= extent3[1] && !tick.notAdd;
    });
  }), function(levelTicks2) {
    return levelTicks2.length > 0;
  });
  var ticks = [];
  var maxLevel = levelsTicksInExtent.length - 1;
  for (var i = 0; i < levelsTicksInExtent.length; ++i) {
    var levelTicks = levelsTicksInExtent[i];
    for (var k2 = 0; k2 < levelTicks.length; ++k2) {
      ticks.push({
        value: levelTicks[k2].value,
        level: maxLevel - i
      });
    }
  }
  ticks.sort(function(a, b2) {
    return a.value - b2.value;
  });
  var result = [];
  for (var i = 0; i < ticks.length; ++i) {
    if (i === 0 || ticks[i].value !== ticks[i - 1].value) {
      result.push(ticks[i]);
    }
  }
  return result;
}
Scale$1.registerClass(TimeScale);
var TimeScale$1 = TimeScale;
var scaleProto = Scale$1.prototype;
var intervalScaleProto = IntervalScale$1.prototype;
var roundingErrorFix = round$3;
var mathFloor$1 = Math.floor;
var mathCeil$1 = Math.ceil;
var mathPow$1 = Math.pow;
var mathLog$1 = Math.log;
var LogScale = function(_super) {
  __extends(LogScale2, _super);
  function LogScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "log";
    _this.base = 10;
    _this._originalScale = new IntervalScale$1();
    _this._interval = 0;
    return _this;
  }
  LogScale2.prototype.getTicks = function(expandToNicedExtent) {
    var originalScale = this._originalScale;
    var extent3 = this._extent;
    var originalExtent = originalScale.getExtent();
    var ticks = intervalScaleProto.getTicks.call(this, expandToNicedExtent);
    return map$1(ticks, function(tick) {
      var val = tick.value;
      var powVal = round$3(mathPow$1(this.base, val));
      powVal = val === extent3[0] && this._fixMin ? fixRoundingError(powVal, originalExtent[0]) : powVal;
      powVal = val === extent3[1] && this._fixMax ? fixRoundingError(powVal, originalExtent[1]) : powVal;
      return {
        value: powVal
      };
    }, this);
  };
  LogScale2.prototype.setExtent = function(start2, end2) {
    var base2 = this.base;
    start2 = mathLog$1(start2) / mathLog$1(base2);
    end2 = mathLog$1(end2) / mathLog$1(base2);
    intervalScaleProto.setExtent.call(this, start2, end2);
  };
  LogScale2.prototype.getExtent = function() {
    var base2 = this.base;
    var extent3 = scaleProto.getExtent.call(this);
    extent3[0] = mathPow$1(base2, extent3[0]);
    extent3[1] = mathPow$1(base2, extent3[1]);
    var originalScale = this._originalScale;
    var originalExtent = originalScale.getExtent();
    this._fixMin && (extent3[0] = fixRoundingError(extent3[0], originalExtent[0]));
    this._fixMax && (extent3[1] = fixRoundingError(extent3[1], originalExtent[1]));
    return extent3;
  };
  LogScale2.prototype.unionExtent = function(extent3) {
    this._originalScale.unionExtent(extent3);
    var base2 = this.base;
    extent3[0] = mathLog$1(extent3[0]) / mathLog$1(base2);
    extent3[1] = mathLog$1(extent3[1]) / mathLog$1(base2);
    scaleProto.unionExtent.call(this, extent3);
  };
  LogScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  LogScale2.prototype.calcNiceTicks = function(approxTickNum) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (span === Infinity || span <= 0) {
      return;
    }
    var interval = quantity(span);
    var err = approxTickNum / span * interval;
    if (err <= 0.5) {
      interval *= 10;
    }
    while (!isNaN(interval) && Math.abs(interval) < 1 && Math.abs(interval) > 0) {
      interval *= 10;
    }
    var niceExtent = [round$3(mathCeil$1(extent3[0] / interval) * interval), round$3(mathFloor$1(extent3[1] / interval) * interval)];
    this._interval = interval;
    this._niceExtent = niceExtent;
  };
  LogScale2.prototype.calcNiceExtent = function(opt) {
    intervalScaleProto.calcNiceExtent.call(this, opt);
    this._fixMin = opt.fixMin;
    this._fixMax = opt.fixMax;
  };
  LogScale2.prototype.parse = function(val) {
    return val;
  };
  LogScale2.prototype.contain = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return contain$1(val, this._extent);
  };
  LogScale2.prototype.normalize = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return normalize$3(val, this._extent);
  };
  LogScale2.prototype.scale = function(val) {
    val = scale(val, this._extent);
    return mathPow$1(this.base, val);
  };
  LogScale2.type = "log";
  return LogScale2;
}(Scale$1);
var proto = LogScale.prototype;
proto.getMinorTicks = intervalScaleProto.getMinorTicks;
proto.getLabel = intervalScaleProto.getLabel;
function fixRoundingError(val, originalVal) {
  return roundingErrorFix(val, getPrecision(originalVal));
}
Scale$1.registerClass(LogScale);
var LogScale$1 = LogScale;
var ScaleRawExtentInfo = function() {
  function ScaleRawExtentInfo2(scale2, model, originalExtent) {
    this._prepareParams(scale2, model, originalExtent);
  }
  ScaleRawExtentInfo2.prototype._prepareParams = function(scale2, model, dataExtent) {
    if (dataExtent[1] < dataExtent[0]) {
      dataExtent = [NaN, NaN];
    }
    this._dataMin = dataExtent[0];
    this._dataMax = dataExtent[1];
    var isOrdinal = this._isOrdinal = scale2.type === "ordinal";
    this._needCrossZero = scale2.type === "interval" && model.getNeedCrossZero && model.getNeedCrossZero();
    var modelMinRaw = this._modelMinRaw = model.get("min", true);
    if (isFunction(modelMinRaw)) {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMinRaw !== "dataMin") {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw);
    }
    var modelMaxRaw = this._modelMaxRaw = model.get("max", true);
    if (isFunction(modelMaxRaw)) {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMaxRaw !== "dataMax") {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw);
    }
    if (isOrdinal) {
      this._axisDataLen = model.getCategories().length;
    } else {
      var boundaryGap = model.get("boundaryGap");
      var boundaryGapArr = isArray$1(boundaryGap) ? boundaryGap : [boundaryGap || 0, boundaryGap || 0];
      if (typeof boundaryGapArr[0] === "boolean" || typeof boundaryGapArr[1] === "boolean") {
        this._boundaryGapInner = [0, 0];
      } else {
        this._boundaryGapInner = [parsePercent$1(boundaryGapArr[0], 1), parsePercent$1(boundaryGapArr[1], 1)];
      }
    }
  };
  ScaleRawExtentInfo2.prototype.calculate = function() {
    var isOrdinal = this._isOrdinal;
    var dataMin = this._dataMin;
    var dataMax = this._dataMax;
    var axisDataLen = this._axisDataLen;
    var boundaryGapInner = this._boundaryGapInner;
    var span = !isOrdinal ? dataMax - dataMin || Math.abs(dataMin) : null;
    var min3 = this._modelMinRaw === "dataMin" ? dataMin : this._modelMinNum;
    var max3 = this._modelMaxRaw === "dataMax" ? dataMax : this._modelMaxNum;
    var minFixed = min3 != null;
    var maxFixed = max3 != null;
    if (min3 == null) {
      min3 = isOrdinal ? axisDataLen ? 0 : NaN : dataMin - boundaryGapInner[0] * span;
    }
    if (max3 == null) {
      max3 = isOrdinal ? axisDataLen ? axisDataLen - 1 : NaN : dataMax + boundaryGapInner[1] * span;
    }
    (min3 == null || !isFinite(min3)) && (min3 = NaN);
    (max3 == null || !isFinite(max3)) && (max3 = NaN);
    var isBlank = eqNaN(min3) || eqNaN(max3) || isOrdinal && !axisDataLen;
    if (this._needCrossZero) {
      if (min3 > 0 && max3 > 0 && !minFixed) {
        min3 = 0;
      }
      if (min3 < 0 && max3 < 0 && !maxFixed) {
        max3 = 0;
      }
    }
    var determinedMin = this._determinedMin;
    var determinedMax = this._determinedMax;
    if (determinedMin != null) {
      min3 = determinedMin;
      minFixed = true;
    }
    if (determinedMax != null) {
      max3 = determinedMax;
      maxFixed = true;
    }
    return {
      min: min3,
      max: max3,
      minFixed,
      maxFixed,
      isBlank
    };
  };
  ScaleRawExtentInfo2.prototype.modifyDataMinMax = function(minMaxName, val) {
    this[DATA_MIN_MAX_ATTR[minMaxName]] = val;
  };
  ScaleRawExtentInfo2.prototype.setDeterminedMinMax = function(minMaxName, val) {
    var attr = DETERMINED_MIN_MAX_ATTR[minMaxName];
    this[attr] = val;
  };
  ScaleRawExtentInfo2.prototype.freeze = function() {
    this.frozen = true;
  };
  return ScaleRawExtentInfo2;
}();
var DETERMINED_MIN_MAX_ATTR = {
  min: "_determinedMin",
  max: "_determinedMax"
};
var DATA_MIN_MAX_ATTR = {
  min: "_dataMin",
  max: "_dataMax"
};
function ensureScaleRawExtentInfo(scale2, model, originalExtent) {
  var rawExtentInfo = scale2.rawExtentInfo;
  if (rawExtentInfo) {
    return rawExtentInfo;
  }
  rawExtentInfo = new ScaleRawExtentInfo(scale2, model, originalExtent);
  scale2.rawExtentInfo = rawExtentInfo;
  return rawExtentInfo;
}
function parseAxisModelMinMax(scale2, minMax) {
  return minMax == null ? null : eqNaN(minMax) ? NaN : scale2.parse(minMax);
}
function getScaleExtent(scale2, model) {
  var scaleType = scale2.type;
  var rawExtentResult = ensureScaleRawExtentInfo(scale2, model, scale2.getExtent()).calculate();
  scale2.setBlank(rawExtentResult.isBlank);
  var min3 = rawExtentResult.min;
  var max3 = rawExtentResult.max;
  var ecModel = model.ecModel;
  if (ecModel && scaleType === "time") {
    var barSeriesModels = prepareLayoutBarSeries("bar", ecModel);
    var isBaseAxisAndHasBarSeries_1 = false;
    each$f(barSeriesModels, function(seriesModel) {
      isBaseAxisAndHasBarSeries_1 = isBaseAxisAndHasBarSeries_1 || seriesModel.getBaseAxis() === model.axis;
    });
    if (isBaseAxisAndHasBarSeries_1) {
      var barWidthAndOffset = makeColumnLayout(barSeriesModels);
      var adjustedScale = adjustScaleForOverflow(min3, max3, model, barWidthAndOffset);
      min3 = adjustedScale.min;
      max3 = adjustedScale.max;
    }
  }
  return {
    extent: [min3, max3],
    fixMin: rawExtentResult.minFixed,
    fixMax: rawExtentResult.maxFixed
  };
}
function adjustScaleForOverflow(min3, max3, model, barWidthAndOffset) {
  var axisExtent = model.axis.getExtent();
  var axisLength = axisExtent[1] - axisExtent[0];
  var barsOnCurrentAxis = retrieveColumnLayout(barWidthAndOffset, model.axis);
  if (barsOnCurrentAxis === void 0) {
    return {
      min: min3,
      max: max3
    };
  }
  var minOverflow = Infinity;
  each$f(barsOnCurrentAxis, function(item) {
    minOverflow = Math.min(item.offset, minOverflow);
  });
  var maxOverflow = -Infinity;
  each$f(barsOnCurrentAxis, function(item) {
    maxOverflow = Math.max(item.offset + item.width, maxOverflow);
  });
  minOverflow = Math.abs(minOverflow);
  maxOverflow = Math.abs(maxOverflow);
  var totalOverFlow = minOverflow + maxOverflow;
  var oldRange = max3 - min3;
  var oldRangePercentOfNew = 1 - (minOverflow + maxOverflow) / axisLength;
  var overflowBuffer = oldRange / oldRangePercentOfNew - oldRange;
  max3 += overflowBuffer * (maxOverflow / totalOverFlow);
  min3 -= overflowBuffer * (minOverflow / totalOverFlow);
  return {
    min: min3,
    max: max3
  };
}
function niceScaleExtent(scale2, inModel) {
  var model = inModel;
  var extentInfo = getScaleExtent(scale2, model);
  var extent3 = extentInfo.extent;
  var splitNumber = model.get("splitNumber");
  if (scale2 instanceof LogScale$1) {
    scale2.base = model.get("logBase");
  }
  var scaleType = scale2.type;
  var interval = model.get("interval");
  var isIntervalOrTime = scaleType === "interval" || scaleType === "time";
  scale2.setExtent(extent3[0], extent3[1]);
  scale2.calcNiceExtent({
    splitNumber,
    fixMin: extentInfo.fixMin,
    fixMax: extentInfo.fixMax,
    minInterval: isIntervalOrTime ? model.get("minInterval") : null,
    maxInterval: isIntervalOrTime ? model.get("maxInterval") : null
  });
  if (interval != null) {
    scale2.setInterval && scale2.setInterval(interval);
  }
}
function createScaleByModel$1(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getOrdinalMeta ? model.getOrdinalMeta() : model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new (Scale$1.getClass(axisType) || IntervalScale$1)();
    }
  }
}
function ifAxisCrossZero(axis) {
  var dataExtent = axis.scale.getExtent();
  var min3 = dataExtent[0];
  var max3 = dataExtent[1];
  return !(min3 > 0 && max3 > 0 || min3 < 0 && max3 < 0);
}
function makeLabelFormatter(axis) {
  var labelFormatter = axis.getLabelModel().get("formatter");
  var categoryTickStart = axis.type === "category" ? axis.scale.getExtent()[0] : null;
  if (axis.scale.type === "time") {
    return function(tpl) {
      return function(tick, idx) {
        return axis.scale.getFormattedLabel(tick, idx, tpl);
      };
    }(labelFormatter);
  } else if (isString(labelFormatter)) {
    return function(tpl) {
      return function(tick) {
        var label = axis.scale.getLabel(tick);
        var text = tpl.replace("{value}", label != null ? label : "");
        return text;
      };
    }(labelFormatter);
  } else if (isFunction(labelFormatter)) {
    return function(cb) {
      return function(tick, idx) {
        if (categoryTickStart != null) {
          idx = tick.value - categoryTickStart;
        }
        return cb(getAxisRawValue(axis, tick), idx, tick.level != null ? {
          level: tick.level
        } : null);
      };
    }(labelFormatter);
  } else {
    return function(tick) {
      return axis.scale.getLabel(tick);
    };
  }
}
function getAxisRawValue(axis, tick) {
  return axis.type === "category" ? axis.scale.getLabel(tick) : tick.value;
}
function estimateLabelUnionRect(axis) {
  var axisModel = axis.model;
  var scale2 = axis.scale;
  if (!axisModel.get(["axisLabel", "show"]) || scale2.isBlank()) {
    return;
  }
  var realNumberScaleTicks;
  var tickCount;
  var categoryScaleExtent = scale2.getExtent();
  if (scale2 instanceof OrdinalScale$1) {
    tickCount = scale2.count();
  } else {
    realNumberScaleTicks = scale2.getTicks();
    tickCount = realNumberScaleTicks.length;
  }
  var axisLabelModel = axis.getLabelModel();
  var labelFormatter = makeLabelFormatter(axis);
  var rect;
  var step = 1;
  if (tickCount > 40) {
    step = Math.ceil(tickCount / 40);
  }
  for (var i = 0; i < tickCount; i += step) {
    var tick = realNumberScaleTicks ? realNumberScaleTicks[i] : {
      value: categoryScaleExtent[0] + i
    };
    var label = labelFormatter(tick, i);
    var unrotatedSingleRect = axisLabelModel.getTextRect(label);
    var singleRect = rotateTextRect(unrotatedSingleRect, axisLabelModel.get("rotate") || 0);
    rect ? rect.union(singleRect) : rect = singleRect;
  }
  return rect;
}
function rotateTextRect(textRect, rotate2) {
  var rotateRadians = rotate2 * Math.PI / 180;
  var beforeWidth = textRect.width;
  var beforeHeight = textRect.height;
  var afterWidth = beforeWidth * Math.abs(Math.cos(rotateRadians)) + Math.abs(beforeHeight * Math.sin(rotateRadians));
  var afterHeight = beforeWidth * Math.abs(Math.sin(rotateRadians)) + Math.abs(beforeHeight * Math.cos(rotateRadians));
  var rotatedRect = new BoundingRect$1(textRect.x, textRect.y, afterWidth, afterHeight);
  return rotatedRect;
}
function getOptionCategoryInterval(model) {
  var interval = model.get("interval");
  return interval == null ? "auto" : interval;
}
function shouldShowAllLabels(axis) {
  return axis.type === "category" && getOptionCategoryInterval(axis.getLabelModel()) === 0;
}
function getDataDimensionsOnAxis(data, axisDim) {
  var dataDimMap = {};
  each$f(data.mapDimensionsAll(axisDim), function(dataDim) {
    dataDimMap[getStackedDimension(data, dataDim)] = true;
  });
  return keys(dataDimMap);
}
function unionAxisExtentFromData(dataExtent, data, axisDim) {
  if (data) {
    each$f(getDataDimensionsOnAxis(data, axisDim), function(dim) {
      var seriesExtent = data.getApproximateExtent(dim);
      seriesExtent[0] < dataExtent[0] && (dataExtent[0] = seriesExtent[0]);
      seriesExtent[1] > dataExtent[1] && (dataExtent[1] = seriesExtent[1]);
    });
  }
}
var AxisModelCommonMixin = function() {
  function AxisModelCommonMixin2() {
  }
  AxisModelCommonMixin2.prototype.getNeedCrossZero = function() {
    var option = this.option;
    return !option.scale;
  };
  AxisModelCommonMixin2.prototype.getCoordSysModel = function() {
    return;
  };
  return AxisModelCommonMixin2;
}();
var EPSILON = 1e-8;
function isAroundEqual(a, b2) {
  return Math.abs(a - b2) < EPSILON;
}
function contain(points2, x2, y2) {
  var w2 = 0;
  var p2 = points2[0];
  if (!p2) {
    return false;
  }
  for (var i = 1; i < points2.length; i++) {
    var p22 = points2[i];
    w2 += windingLine(p2[0], p2[1], p22[0], p22[1], x2, y2);
    p2 = p22;
  }
  var p0 = points2[0];
  if (!isAroundEqual(p2[0], p0[0]) || !isAroundEqual(p2[1], p0[1])) {
    w2 += windingLine(p2[0], p2[1], p0[0], p0[1], x2, y2);
  }
  return w2 !== 0;
}
var TMP_TRANSFORM = [];
function transformPoints(points2, transform2) {
  for (var p2 = 0; p2 < points2.length; p2++) {
    applyTransform$1(points2[p2], points2[p2], transform2);
  }
}
function updateBBoxFromPoints(points2, min3, max3, projection) {
  for (var i = 0; i < points2.length; i++) {
    var p2 = points2[i];
    if (projection) {
      p2 = projection.project(p2);
    }
    if (p2 && isFinite(p2[0]) && isFinite(p2[1])) {
      min$1(min3, min3, p2);
      max$1(max3, max3, p2);
    }
  }
}
function centroid$1(points2) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = points2.length;
  var x0 = points2[len2 - 1][0];
  var y0 = points2[len2 - 1][1];
  for (var i = 0; i < len2; i++) {
    var x1 = points2[i][0];
    var y1 = points2[i][1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
    x0 = x1;
    y0 = y1;
  }
  return signedArea ? [cx / signedArea / 3, cy / signedArea / 3, signedArea] : [points2[0][0] || 0, points2[0][1] || 0];
}
var Region = function() {
  function Region2(name) {
    this.name = name;
  }
  Region2.prototype.setCenter = function(center2) {
    this._center = center2;
  };
  Region2.prototype.getCenter = function() {
    var center2 = this._center;
    if (!center2) {
      center2 = this._center = this.calcCenter();
    }
    return center2;
  };
  return Region2;
}();
var GeoJSONPolygonGeometry = function() {
  function GeoJSONPolygonGeometry2(exterior, interiors) {
    this.type = "polygon";
    this.exterior = exterior;
    this.interiors = interiors;
  }
  return GeoJSONPolygonGeometry2;
}();
var GeoJSONLineStringGeometry = function() {
  function GeoJSONLineStringGeometry2(points2) {
    this.type = "linestring";
    this.points = points2;
  }
  return GeoJSONLineStringGeometry2;
}();
var GeoJSONRegion = function(_super) {
  __extends(GeoJSONRegion2, _super);
  function GeoJSONRegion2(name, geometries, cp) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoJSON";
    _this.geometries = geometries;
    _this._center = cp && [cp[0], cp[1]];
    return _this;
  }
  GeoJSONRegion2.prototype.calcCenter = function() {
    var geometries = this.geometries;
    var largestGeo;
    var largestGeoSize = 0;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      var exterior = geo.exterior;
      var size = exterior && exterior.length;
      if (size > largestGeoSize) {
        largestGeo = geo;
        largestGeoSize = size;
      }
    }
    if (largestGeo) {
      return centroid$1(largestGeo.exterior);
    }
    var rect = this.getBoundingRect();
    return [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.getBoundingRect = function(projection) {
    var rect = this._rect;
    if (rect && !projection) {
      return rect;
    }
    var min3 = [Infinity, Infinity];
    var max3 = [-Infinity, -Infinity];
    var geometries = this.geometries;
    each$f(geometries, function(geo) {
      if (geo.type === "polygon") {
        updateBBoxFromPoints(geo.exterior, min3, max3, projection);
      } else {
        each$f(geo.points, function(points2) {
          updateBBoxFromPoints(points2, min3, max3, projection);
        });
      }
    });
    if (!(isFinite(min3[0]) && isFinite(min3[1]) && isFinite(max3[0]) && isFinite(max3[1]))) {
      min3[0] = min3[1] = max3[0] = max3[1] = 0;
    }
    rect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    if (!projection) {
      this._rect = rect;
    }
    return rect;
  };
  GeoJSONRegion2.prototype.contain = function(coord) {
    var rect = this.getBoundingRect();
    var geometries = this.geometries;
    if (!rect.contain(coord[0], coord[1])) {
      return false;
    }
    loopGeo:
      for (var i = 0, len2 = geometries.length; i < len2; i++) {
        var geo = geometries[i];
        if (geo.type !== "polygon") {
          continue;
        }
        var exterior = geo.exterior;
        var interiors = geo.interiors;
        if (contain(exterior, coord[0], coord[1])) {
          for (var k2 = 0; k2 < (interiors ? interiors.length : 0); k2++) {
            if (contain(interiors[k2], coord[0], coord[1])) {
              continue loopGeo;
            }
          }
          return true;
        }
      }
    return false;
  };
  GeoJSONRegion2.prototype.transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var aspect = rect.width / rect.height;
    if (!width) {
      width = aspect * height;
    } else if (!height) {
      height = width / aspect;
    }
    var target = new BoundingRect$1(x2, y2, width, height);
    var transform2 = rect.calculateTransform(target);
    var geometries = this.geometries;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      if (geo.type === "polygon") {
        transformPoints(geo.exterior, transform2);
        each$f(geo.interiors, function(interior) {
          transformPoints(interior, transform2);
        });
      } else {
        each$f(geo.points, function(points2) {
          transformPoints(points2, transform2);
        });
      }
    }
    rect = this._rect;
    rect.copy(target);
    this._center = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.cloneShallow = function(name) {
    name == null && (name = this.name);
    var newRegion = new GeoJSONRegion2(name, this.geometries, this._center);
    newRegion._rect = this._rect;
    newRegion.transformTo = null;
    return newRegion;
  };
  return GeoJSONRegion2;
}(Region);
var GeoSVGRegion = function(_super) {
  __extends(GeoSVGRegion2, _super);
  function GeoSVGRegion2(name, elOnlyForCalculate) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoSVG";
    _this._elOnlyForCalculate = elOnlyForCalculate;
    return _this;
  }
  GeoSVGRegion2.prototype.calcCenter = function() {
    var el = this._elOnlyForCalculate;
    var rect = el.getBoundingRect();
    var center2 = [rect.x + rect.width / 2, rect.y + rect.height / 2];
    var mat = identity(TMP_TRANSFORM);
    var target = el;
    while (target && !target.isGeoSVGGraphicRoot) {
      mul(mat, target.getLocalTransform(), mat);
      target = target.parent;
    }
    invert(mat, mat);
    applyTransform$1(center2, center2, mat);
    return center2;
  };
  return GeoSVGRegion2;
}(Region);
function decode(json) {
  if (!json.UTF8Encoding) {
    return json;
  }
  var jsonCompressed = json;
  var encodeScale = jsonCompressed.UTF8Scale;
  if (encodeScale == null) {
    encodeScale = 1024;
  }
  var features2 = jsonCompressed.features;
  each$f(features2, function(feature) {
    var geometry = feature.geometry;
    var encodeOffsets = geometry.encodeOffsets;
    var coordinates = geometry.coordinates;
    if (!encodeOffsets) {
      return;
    }
    switch (geometry.type) {
      case "LineString":
        geometry.coordinates = decodeRing(coordinates, encodeOffsets, encodeScale);
        break;
      case "Polygon":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiLineString":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiPolygon":
        each$f(coordinates, function(rings, idx) {
          return decodeRings(rings, encodeOffsets[idx], encodeScale);
        });
    }
  });
  jsonCompressed.UTF8Encoding = false;
  return jsonCompressed;
}
function decodeRings(rings, encodeOffsets, encodeScale) {
  for (var c2 = 0; c2 < rings.length; c2++) {
    rings[c2] = decodeRing(rings[c2], encodeOffsets[c2], encodeScale);
  }
}
function decodeRing(coordinate, encodeOffsets, encodeScale) {
  var result = [];
  var prevX = encodeOffsets[0];
  var prevY = encodeOffsets[1];
  for (var i = 0; i < coordinate.length; i += 2) {
    var x2 = coordinate.charCodeAt(i) - 64;
    var y2 = coordinate.charCodeAt(i + 1) - 64;
    x2 = x2 >> 1 ^ -(x2 & 1);
    y2 = y2 >> 1 ^ -(y2 & 1);
    x2 += prevX;
    y2 += prevY;
    prevX = x2;
    prevY = y2;
    result.push([x2 / encodeScale, y2 / encodeScale]);
  }
  return result;
}
function parseGeoJSON(geoJson, nameProperty) {
  geoJson = decode(geoJson);
  return map$1(filter(geoJson.features, function(featureObj) {
    return featureObj.geometry && featureObj.properties && featureObj.geometry.coordinates.length > 0;
  }), function(featureObj) {
    var properties = featureObj.properties;
    var geo = featureObj.geometry;
    var geometries = [];
    switch (geo.type) {
      case "Polygon":
        var coordinates = geo.coordinates;
        geometries.push(new GeoJSONPolygonGeometry(coordinates[0], coordinates.slice(1)));
        break;
      case "MultiPolygon":
        each$f(geo.coordinates, function(item) {
          if (item[0]) {
            geometries.push(new GeoJSONPolygonGeometry(item[0], item.slice(1)));
          }
        });
        break;
      case "LineString":
        geometries.push(new GeoJSONLineStringGeometry([geo.coordinates]));
        break;
      case "MultiLineString":
        geometries.push(new GeoJSONLineStringGeometry(geo.coordinates));
    }
    var region = new GeoJSONRegion(properties[nameProperty || "name"], geometries, properties.cp);
    region.properties = properties;
    return region;
  });
}
var inner$g = makeInner();
function createAxisLabels(axis) {
  return axis.type === "category" ? makeCategoryLabels(axis) : makeRealNumberLabels(axis);
}
function createAxisTicks(axis, tickModel) {
  return axis.type === "category" ? makeCategoryTicks(axis, tickModel) : {
    ticks: map$1(axis.scale.getTicks(), function(tick) {
      return tick.value;
    })
  };
}
function makeCategoryLabels(axis) {
  var labelModel = axis.getLabelModel();
  var result = makeCategoryLabelsActually(axis, labelModel);
  return !labelModel.get("show") || axis.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: result.labelCategoryInterval
  } : result;
}
function makeCategoryLabelsActually(axis, labelModel) {
  var labelsCache = getListCache(axis, "labels");
  var optionLabelInterval = getOptionCategoryInterval(labelModel);
  var result = listCacheGet(labelsCache, optionLabelInterval);
  if (result) {
    return result;
  }
  var labels;
  var numericLabelInterval;
  if (isFunction(optionLabelInterval)) {
    labels = makeLabelsByCustomizedCategoryInterval(axis, optionLabelInterval);
  } else {
    numericLabelInterval = optionLabelInterval === "auto" ? makeAutoCategoryInterval(axis) : optionLabelInterval;
    labels = makeLabelsByNumericCategoryInterval(axis, numericLabelInterval);
  }
  return listCacheSet(labelsCache, optionLabelInterval, {
    labels,
    labelCategoryInterval: numericLabelInterval
  });
}
function makeCategoryTicks(axis, tickModel) {
  var ticksCache = getListCache(axis, "ticks");
  var optionTickInterval = getOptionCategoryInterval(tickModel);
  var result = listCacheGet(ticksCache, optionTickInterval);
  if (result) {
    return result;
  }
  var ticks;
  var tickCategoryInterval;
  if (!tickModel.get("show") || axis.scale.isBlank()) {
    ticks = [];
  }
  if (isFunction(optionTickInterval)) {
    ticks = makeLabelsByCustomizedCategoryInterval(axis, optionTickInterval, true);
  } else if (optionTickInterval === "auto") {
    var labelsResult = makeCategoryLabelsActually(axis, axis.getLabelModel());
    tickCategoryInterval = labelsResult.labelCategoryInterval;
    ticks = map$1(labelsResult.labels, function(labelItem) {
      return labelItem.tickValue;
    });
  } else {
    tickCategoryInterval = optionTickInterval;
    ticks = makeLabelsByNumericCategoryInterval(axis, tickCategoryInterval, true);
  }
  return listCacheSet(ticksCache, optionTickInterval, {
    ticks,
    tickCategoryInterval
  });
}
function makeRealNumberLabels(axis) {
  var ticks = axis.scale.getTicks();
  var labelFormatter = makeLabelFormatter(axis);
  return {
    labels: map$1(ticks, function(tick, idx) {
      return {
        level: tick.level,
        formattedLabel: labelFormatter(tick, idx),
        rawLabel: axis.scale.getLabel(tick),
        tickValue: tick.value
      };
    })
  };
}
function getListCache(axis, prop) {
  return inner$g(axis)[prop] || (inner$g(axis)[prop] = []);
}
function listCacheGet(cache, key) {
  for (var i = 0; i < cache.length; i++) {
    if (cache[i].key === key) {
      return cache[i].value;
    }
  }
}
function listCacheSet(cache, key, value) {
  cache.push({
    key,
    value
  });
  return value;
}
function makeAutoCategoryInterval(axis) {
  var result = inner$g(axis).autoInterval;
  return result != null ? result : inner$g(axis).autoInterval = axis.calculateCategoryInterval();
}
function calculateCategoryInterval(axis) {
  var params = fetchAutoCategoryIntervalCalculationParams(axis);
  var labelFormatter = makeLabelFormatter(axis);
  var rotation = (params.axisRotate - params.labelRotate) / 180 * Math.PI;
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var tickCount = ordinalScale.count();
  if (ordinalExtent[1] - ordinalExtent[0] < 1) {
    return 0;
  }
  var step = 1;
  if (tickCount > 40) {
    step = Math.max(1, Math.floor(tickCount / 40));
  }
  var tickValue = ordinalExtent[0];
  var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
  var unitW = Math.abs(unitSpan * Math.cos(rotation));
  var unitH = Math.abs(unitSpan * Math.sin(rotation));
  var maxW = 0;
  var maxH = 0;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    var width = 0;
    var height = 0;
    var rect = getBoundingRect(labelFormatter({
      value: tickValue
    }), params.font, "center", "top");
    width = rect.width * 1.3;
    height = rect.height * 1.3;
    maxW = Math.max(maxW, width, 7);
    maxH = Math.max(maxH, height, 7);
  }
  var dw = maxW / unitW;
  var dh = maxH / unitH;
  isNaN(dw) && (dw = Infinity);
  isNaN(dh) && (dh = Infinity);
  var interval = Math.max(0, Math.floor(Math.min(dw, dh)));
  var cache = inner$g(axis.model);
  var axisExtent = axis.getExtent();
  var lastAutoInterval = cache.lastAutoInterval;
  var lastTickCount = cache.lastTickCount;
  if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval && cache.axisExtent0 === axisExtent[0] && cache.axisExtent1 === axisExtent[1]) {
    interval = lastAutoInterval;
  } else {
    cache.lastTickCount = tickCount;
    cache.lastAutoInterval = interval;
    cache.axisExtent0 = axisExtent[0];
    cache.axisExtent1 = axisExtent[1];
  }
  return interval;
}
function fetchAutoCategoryIntervalCalculationParams(axis) {
  var labelModel = axis.getLabelModel();
  return {
    axisRotate: axis.getRotate ? axis.getRotate() : axis.isHorizontal && !axis.isHorizontal() ? 90 : 0,
    labelRotate: labelModel.get("rotate") || 0,
    font: labelModel.getFont()
  };
}
function makeLabelsByNumericCategoryInterval(axis, categoryInterval, onlyTick) {
  var labelFormatter = makeLabelFormatter(axis);
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var labelModel = axis.getLabelModel();
  var result = [];
  var step = Math.max((categoryInterval || 0) + 1, 1);
  var startTick = ordinalExtent[0];
  var tickCount = ordinalScale.count();
  if (startTick !== 0 && step > 1 && tickCount / step > 2) {
    startTick = Math.round(Math.ceil(startTick / step) * step);
  }
  var showAllLabel = shouldShowAllLabels(axis);
  var includeMinLabel = labelModel.get("showMinLabel") || showAllLabel;
  var includeMaxLabel = labelModel.get("showMaxLabel") || showAllLabel;
  if (includeMinLabel && startTick !== ordinalExtent[0]) {
    addItem(ordinalExtent[0]);
  }
  var tickValue = startTick;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    addItem(tickValue);
  }
  if (includeMaxLabel && tickValue - step !== ordinalExtent[1]) {
    addItem(ordinalExtent[1]);
  }
  function addItem(tickValue2) {
    var tickObj = {
      value: tickValue2
    };
    result.push(onlyTick ? tickValue2 : {
      formattedLabel: labelFormatter(tickObj),
      rawLabel: ordinalScale.getLabel(tickObj),
      tickValue: tickValue2
    });
  }
  return result;
}
function makeLabelsByCustomizedCategoryInterval(axis, categoryInterval, onlyTick) {
  var ordinalScale = axis.scale;
  var labelFormatter = makeLabelFormatter(axis);
  var result = [];
  each$f(ordinalScale.getTicks(), function(tick) {
    var rawLabel = ordinalScale.getLabel(tick);
    var tickValue = tick.value;
    if (categoryInterval(tick.value, rawLabel)) {
      result.push(onlyTick ? tickValue : {
        formattedLabel: labelFormatter(tick),
        rawLabel,
        tickValue
      });
    }
  });
  return result;
}
var NORMALIZED_EXTENT = [0, 1];
var Axis = function() {
  function Axis2(dim, scale2, extent3) {
    this.onBand = false;
    this.inverse = false;
    this.dim = dim;
    this.scale = scale2;
    this._extent = extent3 || [0, 0];
  }
  Axis2.prototype.contain = function(coord) {
    var extent3 = this._extent;
    var min3 = Math.min(extent3[0], extent3[1]);
    var max3 = Math.max(extent3[0], extent3[1]);
    return coord >= min3 && coord <= max3;
  };
  Axis2.prototype.containData = function(data) {
    return this.scale.contain(data);
  };
  Axis2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Axis2.prototype.getPixelPrecision = function(dataExtent) {
    return getPixelPrecision(dataExtent || this.scale.getExtent(), this._extent);
  };
  Axis2.prototype.setExtent = function(start2, end2) {
    var extent3 = this._extent;
    extent3[0] = start2;
    extent3[1] = end2;
  };
  Axis2.prototype.dataToCoord = function(data, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    data = scale2.normalize(data);
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    return linearMap$2(data, NORMALIZED_EXTENT, extent3, clamp2);
  };
  Axis2.prototype.coordToData = function(coord, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    var t2 = linearMap$2(coord, extent3, NORMALIZED_EXTENT, clamp2);
    return this.scale.scale(t2);
  };
  Axis2.prototype.pointToData = function(point, clamp2) {
    return;
  };
  Axis2.prototype.getTicksCoords = function(opt) {
    opt = opt || {};
    var tickModel = opt.tickModel || this.getTickModel();
    var result = createAxisTicks(this, tickModel);
    var ticks = result.ticks;
    var ticksCoords = map$1(ticks, function(tickVal) {
      return {
        coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(tickVal) : tickVal),
        tickValue: tickVal
      };
    }, this);
    var alignWithLabel = tickModel.get("alignWithLabel");
    fixOnBandTicksCoords(this, ticksCoords, alignWithLabel, opt.clamp);
    return ticksCoords;
  };
  Axis2.prototype.getMinorTicksCoords = function() {
    if (this.scale.type === "ordinal") {
      return [];
    }
    var minorTickModel = this.model.getModel("minorTick");
    var splitNumber = minorTickModel.get("splitNumber");
    if (!(splitNumber > 0 && splitNumber < 100)) {
      splitNumber = 5;
    }
    var minorTicks = this.scale.getMinorTicks(splitNumber);
    var minorTicksCoords = map$1(minorTicks, function(minorTicksGroup) {
      return map$1(minorTicksGroup, function(minorTick) {
        return {
          coord: this.dataToCoord(minorTick),
          tickValue: minorTick
        };
      }, this);
    }, this);
    return minorTicksCoords;
  };
  Axis2.prototype.getViewLabels = function() {
    return createAxisLabels(this).labels;
  };
  Axis2.prototype.getLabelModel = function() {
    return this.model.getModel("axisLabel");
  };
  Axis2.prototype.getTickModel = function() {
    return this.model.getModel("axisTick");
  };
  Axis2.prototype.getBandWidth = function() {
    var axisExtent = this._extent;
    var dataExtent = this.scale.getExtent();
    var len2 = dataExtent[1] - dataExtent[0] + (this.onBand ? 1 : 0);
    len2 === 0 && (len2 = 1);
    var size = Math.abs(axisExtent[1] - axisExtent[0]);
    return Math.abs(size) / len2;
  };
  Axis2.prototype.calculateCategoryInterval = function() {
    return calculateCategoryInterval(this);
  };
  return Axis2;
}();
function fixExtentWithBands(extent3, nTick) {
  var size = extent3[1] - extent3[0];
  var len2 = nTick;
  var margin = size / len2 / 2;
  extent3[0] += margin;
  extent3[1] -= margin;
}
function fixOnBandTicksCoords(axis, ticksCoords, alignWithLabel, clamp2) {
  var ticksLen = ticksCoords.length;
  if (!axis.onBand || alignWithLabel || !ticksLen) {
    return;
  }
  var axisExtent = axis.getExtent();
  var last;
  var diffSize;
  if (ticksLen === 1) {
    ticksCoords[0].coord = axisExtent[0];
    last = ticksCoords[1] = {
      coord: axisExtent[0]
    };
  } else {
    var crossLen = ticksCoords[ticksLen - 1].tickValue - ticksCoords[0].tickValue;
    var shift_1 = (ticksCoords[ticksLen - 1].coord - ticksCoords[0].coord) / crossLen;
    each$f(ticksCoords, function(ticksItem) {
      ticksItem.coord -= shift_1 / 2;
    });
    var dataExtent = axis.scale.getExtent();
    diffSize = 1 + dataExtent[1] - ticksCoords[ticksLen - 1].tickValue;
    last = {
      coord: ticksCoords[ticksLen - 1].coord + shift_1 * diffSize
    };
    ticksCoords.push(last);
  }
  var inverse = axisExtent[0] > axisExtent[1];
  if (littleThan2(ticksCoords[0].coord, axisExtent[0])) {
    clamp2 ? ticksCoords[0].coord = axisExtent[0] : ticksCoords.shift();
  }
  if (clamp2 && littleThan2(axisExtent[0], ticksCoords[0].coord)) {
    ticksCoords.unshift({
      coord: axisExtent[0]
    });
  }
  if (littleThan2(axisExtent[1], last.coord)) {
    clamp2 ? last.coord = axisExtent[1] : ticksCoords.pop();
  }
  if (clamp2 && littleThan2(last.coord, axisExtent[1])) {
    ticksCoords.push({
      coord: axisExtent[1]
    });
  }
  function littleThan2(a, b2) {
    a = round$3(a);
    b2 = round$3(b2);
    return inverse ? a > b2 : a < b2;
  }
}
var Axis$1 = Axis;
var PI2$3 = Math.PI * 2;
var CMD$1 = PathProxy$1.CMD;
var DEFAULT_SEARCH_SPACE = ["top", "right", "bottom", "left"];
function getCandidateAnchor(pos, distance2, rect, outPt, outDir) {
  var width = rect.width;
  var height = rect.height;
  switch (pos) {
    case "top":
      outPt.set(rect.x + width / 2, rect.y - distance2);
      outDir.set(0, -1);
      break;
    case "bottom":
      outPt.set(rect.x + width / 2, rect.y + height + distance2);
      outDir.set(0, 1);
      break;
    case "left":
      outPt.set(rect.x - distance2, rect.y + height / 2);
      outDir.set(-1, 0);
      break;
    case "right":
      outPt.set(rect.x + width + distance2, rect.y + height / 2);
      outDir.set(1, 0);
      break;
  }
}
function projectPointToArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2, out2) {
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  x2 /= d2;
  y2 /= d2;
  var ox = x2 * r2 + cx;
  var oy = y2 * r2 + cy;
  if (Math.abs(startAngle - endAngle) % PI2$3 < 1e-4) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$3;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$3;
  }
  if (angle >= startAngle && angle <= endAngle || angle + PI2$3 >= startAngle && angle + PI2$3 <= endAngle) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  var x1 = r2 * Math.cos(startAngle) + cx;
  var y1 = r2 * Math.sin(startAngle) + cy;
  var x22 = r2 * Math.cos(endAngle) + cx;
  var y22 = r2 * Math.sin(endAngle) + cy;
  var d1 = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
  var d22 = (x22 - x2) * (x22 - x2) + (y22 - y2) * (y22 - y2);
  if (d1 < d22) {
    out2[0] = x1;
    out2[1] = y1;
    return Math.sqrt(d1);
  } else {
    out2[0] = x22;
    out2[1] = y22;
    return Math.sqrt(d22);
  }
}
function projectPointToLine(x1, y1, x2, y2, x3, y3, out2, limitToEnds) {
  var dx = x3 - x1;
  var dy = y3 - y1;
  var dx1 = x2 - x1;
  var dy1 = y2 - y1;
  var lineLen = Math.sqrt(dx1 * dx1 + dy1 * dy1);
  dx1 /= lineLen;
  dy1 /= lineLen;
  var projectedLen = dx * dx1 + dy * dy1;
  var t2 = projectedLen / lineLen;
  if (limitToEnds) {
    t2 = Math.min(Math.max(t2, 0), 1);
  }
  t2 *= lineLen;
  var ox = out2[0] = x1 + t2 * dx1;
  var oy = out2[1] = y1 + t2 * dy1;
  return Math.sqrt((ox - x3) * (ox - x3) + (oy - y3) * (oy - y3));
}
function projectPointToRect(x1, y1, width, height, x2, y2, out2) {
  if (width < 0) {
    x1 = x1 + width;
    width = -width;
  }
  if (height < 0) {
    y1 = y1 + height;
    height = -height;
  }
  var x22 = x1 + width;
  var y22 = y1 + height;
  var ox = out2[0] = Math.min(Math.max(x2, x1), x22);
  var oy = out2[1] = Math.min(Math.max(y2, y1), y22);
  return Math.sqrt((ox - x2) * (ox - x2) + (oy - y2) * (oy - y2));
}
var tmpPt = [];
function nearestPointOnRect(pt, rect, out2) {
  var dist2 = projectPointToRect(rect.x, rect.y, rect.width, rect.height, pt.x, pt.y, tmpPt);
  out2.set(tmpPt[0], tmpPt[1]);
  return dist2;
}
function nearestPointOnPath(pt, path, out2) {
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  var minDist = Infinity;
  var data = path.data;
  var x2 = pt.x;
  var y2 = pt.y;
  for (var i = 0; i < data.length; ) {
    var cmd = data[i++];
    if (i === 1) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
    }
    var d2 = minDist;
    switch (cmd) {
      case CMD$1.M:
        x0 = data[i++];
        y0 = data[i++];
        xi = x0;
        yi = y0;
        break;
      case CMD$1.L:
        d2 = projectPointToLine(xi, yi, data[i], data[i + 1], x2, y2, tmpPt, true);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.C:
        d2 = cubicProjectPoint(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.Q:
        d2 = quadraticProjectPoint(xi, yi, data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (i <= 1) {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        d2 = projectPointToArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2, tmpPt);
        xi = Math.cos(theta + dTheta) * rx + cx;
        yi = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$1.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        var width = data[i++];
        var height = data[i++];
        d2 = projectPointToRect(x0, y0, width, height, x2, y2, tmpPt);
        break;
      case CMD$1.Z:
        d2 = projectPointToLine(xi, yi, x0, y0, x2, y2, tmpPt, true);
        xi = x0;
        yi = y0;
        break;
    }
    if (d2 < minDist) {
      minDist = d2;
      out2.set(tmpPt[0], tmpPt[1]);
    }
  }
  return minDist;
}
var pt0 = new Point$1();
var pt1 = new Point$1();
var pt2 = new Point$1();
var dir = new Point$1();
var dir2 = new Point$1();
function updateLabelLinePoints(target, labelLineModel) {
  if (!target) {
    return;
  }
  var labelLine = target.getTextGuideLine();
  var label = target.getTextContent();
  if (!(label && labelLine)) {
    return;
  }
  var labelGuideConfig = target.textGuideLineConfig || {};
  var points2 = [[0, 0], [0, 0], [0, 0]];
  var searchSpace = labelGuideConfig.candidates || DEFAULT_SEARCH_SPACE;
  var labelRect = label.getBoundingRect().clone();
  labelRect.applyTransform(label.getComputedTransform());
  var minDist = Infinity;
  var anchorPoint = labelGuideConfig.anchor;
  var targetTransform = target.getComputedTransform();
  var targetInversedTransform = targetTransform && invert([], targetTransform);
  var len2 = labelLineModel.get("length2") || 0;
  if (anchorPoint) {
    pt2.copy(anchorPoint);
  }
  for (var i = 0; i < searchSpace.length; i++) {
    var candidate = searchSpace[i];
    getCandidateAnchor(candidate, 0, labelRect, pt0, dir);
    Point$1.scaleAndAdd(pt1, pt0, dir, len2);
    pt1.transform(targetInversedTransform);
    var boundingRect = target.getBoundingRect();
    var dist2 = anchorPoint ? anchorPoint.distance(pt1) : target instanceof Path$1 ? nearestPointOnPath(pt1, target.path, pt2) : nearestPointOnRect(pt1, boundingRect, pt2);
    if (dist2 < minDist) {
      minDist = dist2;
      pt1.transform(targetTransform);
      pt2.transform(targetTransform);
      pt2.toArray(points2[0]);
      pt1.toArray(points2[1]);
      pt0.toArray(points2[2]);
    }
  }
  limitTurnAngle(points2, labelLineModel.get("minTurnAngle"));
  labelLine.setShape({
    points: points2
  });
}
var tmpArr = [];
var tmpProjPoint = new Point$1();
function limitTurnAngle(linePoints, minTurnAngle) {
  if (!(minTurnAngle <= 180 && minTurnAngle > 0)) {
    return;
  }
  minTurnAngle = minTurnAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt0, pt1);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(dir2);
  var minTurnAngleCos = Math.cos(minTurnAngle);
  if (minTurnAngleCos < angleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI - minTurnAngle));
    var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
    if (isNaN(t2)) {
      return;
    }
    if (t2 < 0) {
      Point$1.copy(tmpProjPoint, pt1);
    } else if (t2 > 1) {
      Point$1.copy(tmpProjPoint, pt2);
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function limitSurfaceAngle(linePoints, surfaceNormal, maxSurfaceAngle) {
  if (!(maxSurfaceAngle <= 180 && maxSurfaceAngle > 0)) {
    return;
  }
  maxSurfaceAngle = maxSurfaceAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt1, pt0);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(surfaceNormal);
  var maxSurfaceAngleCos = Math.cos(maxSurfaceAngle);
  if (angleCos < maxSurfaceAngleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    var HALF_PI = Math.PI / 2;
    var angle2 = Math.acos(dir2.dot(surfaceNormal));
    var newAngle = HALF_PI + angle2 - maxSurfaceAngle;
    if (newAngle >= HALF_PI) {
      Point$1.copy(tmpProjPoint, pt2);
    } else {
      tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI / 2 - newAngle));
      var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
      if (isNaN(t2)) {
        return;
      }
      if (t2 < 0) {
        Point$1.copy(tmpProjPoint, pt1);
      } else if (t2 > 1) {
        Point$1.copy(tmpProjPoint, pt2);
      }
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function setLabelLineState(labelLine, ignore, stateName, stateModel) {
  var isNormal = stateName === "normal";
  var stateObj = isNormal ? labelLine : labelLine.ensureState(stateName);
  stateObj.ignore = ignore;
  var smooth = stateModel.get("smooth");
  if (smooth && smooth === true) {
    smooth = 0.3;
  }
  stateObj.shape = stateObj.shape || {};
  if (smooth > 0) {
    stateObj.shape.smooth = smooth;
  }
  var styleObj = stateModel.getModel("lineStyle").getLineStyle();
  isNormal ? labelLine.useStyle(styleObj) : stateObj.style = styleObj;
}
function buildLabelLinePath(path, shape) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (!points2) {
    return;
  }
  path.moveTo(points2[0][0], points2[0][1]);
  if (smooth > 0 && points2.length >= 3) {
    var len1 = dist$1(points2[0], points2[1]);
    var len2 = dist$1(points2[1], points2[2]);
    if (!len1 || !len2) {
      path.lineTo(points2[1][0], points2[1][1]);
      path.lineTo(points2[2][0], points2[2][1]);
      return;
    }
    var moveLen = Math.min(len1, len2) * smooth;
    var midPoint0 = lerp$1([], points2[1], points2[0], moveLen / len1);
    var midPoint2 = lerp$1([], points2[1], points2[2], moveLen / len2);
    var midPoint1 = lerp$1([], midPoint0, midPoint2, 0.5);
    path.bezierCurveTo(midPoint0[0], midPoint0[1], midPoint0[0], midPoint0[1], midPoint1[0], midPoint1[1]);
    path.bezierCurveTo(midPoint2[0], midPoint2[1], midPoint2[0], midPoint2[1], points2[2][0], points2[2][1]);
  } else {
    for (var i = 1; i < points2.length; i++) {
      path.lineTo(points2[i][0], points2[i][1]);
    }
  }
}
function setLabelLineStyle(targetEl, statesModels, defaultStyle) {
  var labelLine = targetEl.getTextGuideLine();
  var label = targetEl.getTextContent();
  if (!label) {
    if (labelLine) {
      targetEl.removeTextGuideLine();
    }
    return;
  }
  var normalModel = statesModels.normal;
  var showNormal = normalModel.get("show");
  var labelIgnoreNormal = label.ignore;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateName = DISPLAY_STATES[i];
    var stateModel = statesModels[stateName];
    var isNormal = stateName === "normal";
    if (stateModel) {
      var stateShow = stateModel.get("show");
      var isLabelIgnored = isNormal ? labelIgnoreNormal : retrieve2(label.states[stateName] && label.states[stateName].ignore, labelIgnoreNormal);
      if (isLabelIgnored || !retrieve2(stateShow, showNormal)) {
        var stateObj = isNormal ? labelLine : labelLine && labelLine.states.normal;
        if (stateObj) {
          stateObj.ignore = true;
        }
        continue;
      }
      if (!labelLine) {
        labelLine = new Polyline$3();
        targetEl.setTextGuideLine(labelLine);
        if (!isNormal && (labelIgnoreNormal || !showNormal)) {
          setLabelLineState(labelLine, true, "normal", statesModels.normal);
        }
        if (targetEl.stateProxy) {
          labelLine.stateProxy = targetEl.stateProxy;
        }
      }
      setLabelLineState(labelLine, false, stateName, stateModel);
    }
  }
  if (labelLine) {
    defaults(labelLine.style, defaultStyle);
    labelLine.style.fill = null;
    var showAbove = normalModel.get("showAbove");
    var labelLineConfig = targetEl.textGuideLineConfig = targetEl.textGuideLineConfig || {};
    labelLineConfig.showAbove = showAbove || false;
    labelLine.buildPath = buildLabelLinePath;
  }
}
function getLabelLineStatesModels(itemModel, labelLineName) {
  labelLineName = labelLineName || "labelLine";
  var statesModels = {
    normal: itemModel.getModel(labelLineName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelLineName]);
  }
  return statesModels;
}
function prepareLayoutList(input) {
  var list = [];
  for (var i = 0; i < input.length; i++) {
    var rawItem = input[i];
    if (rawItem.defaultAttr.ignore) {
      continue;
    }
    var label = rawItem.label;
    var transform2 = label.getComputedTransform();
    var localRect = label.getBoundingRect();
    var isAxisAligned = !transform2 || transform2[1] < 1e-5 && transform2[2] < 1e-5;
    var minMargin = label.style.margin || 0;
    var globalRect = localRect.clone();
    globalRect.applyTransform(transform2);
    globalRect.x -= minMargin / 2;
    globalRect.y -= minMargin / 2;
    globalRect.width += minMargin;
    globalRect.height += minMargin;
    var obb = isAxisAligned ? new OrientedBoundingRect$1(localRect, transform2) : null;
    list.push({
      label,
      labelLine: rawItem.labelLine,
      rect: globalRect,
      localRect,
      obb,
      priority: rawItem.priority,
      defaultAttr: rawItem.defaultAttr,
      layoutOption: rawItem.computedLayoutOption,
      axisAligned: isAxisAligned,
      transform: transform2
    });
  }
  return list;
}
function shiftLayout(list, xyDim, sizeDim, minBound, maxBound, balanceShift) {
  var len2 = list.length;
  if (len2 < 2) {
    return;
  }
  list.sort(function(a, b2) {
    return a.rect[xyDim] - b2.rect[xyDim];
  });
  var lastPos = 0;
  var delta;
  var adjusted = false;
  var totalShifts = 0;
  for (var i = 0; i < len2; i++) {
    var item = list[i];
    var rect = item.rect;
    delta = rect[xyDim] - lastPos;
    if (delta < 0) {
      rect[xyDim] -= delta;
      item.label[xyDim] -= delta;
      adjusted = true;
    }
    var shift = Math.max(-delta, 0);
    totalShifts += shift;
    lastPos = rect[xyDim] + rect[sizeDim];
  }
  if (totalShifts > 0 && balanceShift) {
    shiftList(-totalShifts / len2, 0, len2);
  }
  var first = list[0];
  var last = list[len2 - 1];
  var minGap;
  var maxGap;
  updateMinMaxGap();
  minGap < 0 && squeezeGaps(-minGap, 0.8);
  maxGap < 0 && squeezeGaps(maxGap, 0.8);
  updateMinMaxGap();
  takeBoundsGap(minGap, maxGap, 1);
  takeBoundsGap(maxGap, minGap, -1);
  updateMinMaxGap();
  if (minGap < 0) {
    squeezeWhenBailout(-minGap);
  }
  if (maxGap < 0) {
    squeezeWhenBailout(maxGap);
  }
  function updateMinMaxGap() {
    minGap = first.rect[xyDim] - minBound;
    maxGap = maxBound - last.rect[xyDim] - last.rect[sizeDim];
  }
  function takeBoundsGap(gapThisBound, gapOtherBound, moveDir) {
    if (gapThisBound < 0) {
      var moveFromMaxGap = Math.min(gapOtherBound, -gapThisBound);
      if (moveFromMaxGap > 0) {
        shiftList(moveFromMaxGap * moveDir, 0, len2);
        var remained = moveFromMaxGap + gapThisBound;
        if (remained < 0) {
          squeezeGaps(-remained * moveDir, 1);
        }
      } else {
        squeezeGaps(-gapThisBound * moveDir, 1);
      }
    }
  }
  function shiftList(delta2, start2, end2) {
    if (delta2 !== 0) {
      adjusted = true;
    }
    for (var i2 = start2; i2 < end2; i2++) {
      var item2 = list[i2];
      var rect2 = item2.rect;
      rect2[xyDim] += delta2;
      item2.label[xyDim] += delta2;
    }
  }
  function squeezeGaps(delta2, maxSqeezePercent) {
    var gaps = [];
    var totalGaps = 0;
    for (var i2 = 1; i2 < len2; i2++) {
      var prevItemRect = list[i2 - 1].rect;
      var gap = Math.max(list[i2].rect[xyDim] - prevItemRect[xyDim] - prevItemRect[sizeDim], 0);
      gaps.push(gap);
      totalGaps += gap;
    }
    if (!totalGaps) {
      return;
    }
    var squeezePercent = Math.min(Math.abs(delta2) / totalGaps, maxSqeezePercent);
    if (delta2 > 0) {
      for (var i2 = 0; i2 < len2 - 1; i2++) {
        var movement = gaps[i2] * squeezePercent;
        shiftList(movement, 0, i2 + 1);
      }
    } else {
      for (var i2 = len2 - 1; i2 > 0; i2--) {
        var movement = gaps[i2 - 1] * squeezePercent;
        shiftList(-movement, i2, len2);
      }
    }
  }
  function squeezeWhenBailout(delta2) {
    var dir3 = delta2 < 0 ? -1 : 1;
    delta2 = Math.abs(delta2);
    var moveForEachLabel = Math.ceil(delta2 / (len2 - 1));
    for (var i2 = 0; i2 < len2 - 1; i2++) {
      if (dir3 > 0) {
        shiftList(moveForEachLabel, 0, i2 + 1);
      } else {
        shiftList(-moveForEachLabel, len2 - i2 - 1, len2);
      }
      delta2 -= moveForEachLabel;
      if (delta2 <= 0) {
        return;
      }
    }
  }
  return adjusted;
}
function shiftLayoutOnX(list, leftBound, rightBound, balanceShift) {
  return shiftLayout(list, "x", "width", leftBound, rightBound, balanceShift);
}
function shiftLayoutOnY(list, topBound, bottomBound, balanceShift) {
  return shiftLayout(list, "y", "height", topBound, bottomBound, balanceShift);
}
function hideOverlap(labelList) {
  var displayedLabels = [];
  labelList.sort(function(a, b2) {
    return b2.priority - a.priority;
  });
  var globalRect = new BoundingRect$1(0, 0, 0, 0);
  function hideEl(el) {
    if (!el.ignore) {
      var emphasisState = el.ensureState("emphasis");
      if (emphasisState.ignore == null) {
        emphasisState.ignore = false;
      }
    }
    el.ignore = true;
  }
  for (var i = 0; i < labelList.length; i++) {
    var labelItem = labelList[i];
    var isAxisAligned = labelItem.axisAligned;
    var localRect = labelItem.localRect;
    var transform2 = labelItem.transform;
    var label = labelItem.label;
    var labelLine = labelItem.labelLine;
    globalRect.copy(labelItem.rect);
    globalRect.width -= 0.1;
    globalRect.height -= 0.1;
    globalRect.x += 0.05;
    globalRect.y += 0.05;
    var obb = labelItem.obb;
    var overlapped = false;
    for (var j = 0; j < displayedLabels.length; j++) {
      var existsTextCfg = displayedLabels[j];
      if (!globalRect.intersect(existsTextCfg.rect)) {
        continue;
      }
      if (isAxisAligned && existsTextCfg.axisAligned) {
        overlapped = true;
        break;
      }
      if (!existsTextCfg.obb) {
        existsTextCfg.obb = new OrientedBoundingRect$1(existsTextCfg.localRect, existsTextCfg.transform);
      }
      if (!obb) {
        obb = new OrientedBoundingRect$1(localRect, transform2);
      }
      if (obb.intersect(existsTextCfg.obb)) {
        overlapped = true;
        break;
      }
    }
    if (overlapped) {
      hideEl(label);
      labelLine && hideEl(labelLine);
    } else {
      label.attr("ignore", labelItem.defaultAttr.ignore);
      labelLine && labelLine.attr("ignore", labelItem.defaultAttr.labelGuideIgnore);
      displayedLabels.push(labelItem);
    }
  }
}
function cloneArr(points2) {
  if (points2) {
    var newPoints = [];
    for (var i = 0; i < points2.length; i++) {
      newPoints.push(points2[i].slice());
    }
    return newPoints;
  }
}
function prepareLayoutCallbackParams(labelItem, hostEl) {
  var label = labelItem.label;
  var labelLine = hostEl && hostEl.getTextGuideLine();
  return {
    dataIndex: labelItem.dataIndex,
    dataType: labelItem.dataType,
    seriesIndex: labelItem.seriesModel.seriesIndex,
    text: labelItem.label.style.text,
    rect: labelItem.hostRect,
    labelRect: labelItem.rect,
    align: label.style.align,
    verticalAlign: label.style.verticalAlign,
    labelLinePoints: cloneArr(labelLine && labelLine.shape.points)
  };
}
var LABEL_OPTION_TO_STYLE_KEYS = ["align", "verticalAlign", "width", "height", "fontSize"];
var dummyTransformable = new Transformable$1();
var labelLayoutInnerStore = makeInner();
var labelLineAnimationStore = makeInner();
function extendWithKeys(target, source, keys2) {
  for (var i = 0; i < keys2.length; i++) {
    var key = keys2[i];
    if (source[key] != null) {
      target[key] = source[key];
    }
  }
}
var LABEL_LAYOUT_PROPS = ["x", "y", "rotation"];
var LabelManager = function() {
  function LabelManager2() {
    this._labelList = [];
    this._chartViewList = [];
  }
  LabelManager2.prototype.clearLabels = function() {
    this._labelList = [];
    this._chartViewList = [];
  };
  LabelManager2.prototype._addLabel = function(dataIndex, dataType, seriesModel, label, layoutOption) {
    var labelStyle = label.style;
    var hostEl = label.__hostTarget;
    var textConfig = hostEl.textConfig || {};
    var labelTransform = label.getComputedTransform();
    var labelRect = label.getBoundingRect().plain();
    BoundingRect$1.applyTransform(labelRect, labelRect, labelTransform);
    if (labelTransform) {
      dummyTransformable.setLocalTransform(labelTransform);
    } else {
      dummyTransformable.x = dummyTransformable.y = dummyTransformable.rotation = dummyTransformable.originX = dummyTransformable.originY = 0;
      dummyTransformable.scaleX = dummyTransformable.scaleY = 1;
    }
    var host = label.__hostTarget;
    var hostRect;
    if (host) {
      hostRect = host.getBoundingRect().plain();
      var transform2 = host.getComputedTransform();
      BoundingRect$1.applyTransform(hostRect, hostRect, transform2);
    }
    var labelGuide = hostRect && host.getTextGuideLine();
    this._labelList.push({
      label,
      labelLine: labelGuide,
      seriesModel,
      dataIndex,
      dataType,
      layoutOption,
      computedLayoutOption: null,
      rect: labelRect,
      hostRect,
      priority: hostRect ? hostRect.width * hostRect.height : 0,
      defaultAttr: {
        ignore: label.ignore,
        labelGuideIgnore: labelGuide && labelGuide.ignore,
        x: dummyTransformable.x,
        y: dummyTransformable.y,
        scaleX: dummyTransformable.scaleX,
        scaleY: dummyTransformable.scaleY,
        rotation: dummyTransformable.rotation,
        style: {
          x: labelStyle.x,
          y: labelStyle.y,
          align: labelStyle.align,
          verticalAlign: labelStyle.verticalAlign,
          width: labelStyle.width,
          height: labelStyle.height,
          fontSize: labelStyle.fontSize
        },
        cursor: label.cursor,
        attachedPos: textConfig.position,
        attachedRot: textConfig.rotation
      }
    });
  };
  LabelManager2.prototype.addLabelsOfSeries = function(chartView) {
    var _this = this;
    this._chartViewList.push(chartView);
    var seriesModel = chartView.__model;
    var layoutOption = seriesModel.get("labelLayout");
    if (!(isFunction(layoutOption) || keys(layoutOption).length)) {
      return;
    }
    chartView.group.traverse(function(child) {
      if (child.ignore) {
        return true;
      }
      var textEl = child.getTextContent();
      var ecData = getECData(child);
      if (textEl && !textEl.disableLabelLayout) {
        _this._addLabel(ecData.dataIndex, ecData.dataType, seriesModel, textEl, layoutOption);
      }
    });
  };
  LabelManager2.prototype.updateLayoutConfig = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    function createDragHandler(el, labelLineModel) {
      return function() {
        updateLabelLinePoints(el, labelLineModel);
      };
    }
    for (var i = 0; i < this._labelList.length; i++) {
      var labelItem = this._labelList[i];
      var label = labelItem.label;
      var hostEl = label.__hostTarget;
      var defaultLabelAttr = labelItem.defaultAttr;
      var layoutOption = void 0;
      if (isFunction(labelItem.layoutOption)) {
        layoutOption = labelItem.layoutOption(prepareLayoutCallbackParams(labelItem, hostEl));
      } else {
        layoutOption = labelItem.layoutOption;
      }
      layoutOption = layoutOption || {};
      labelItem.computedLayoutOption = layoutOption;
      var degreeToRadian = Math.PI / 180;
      if (hostEl) {
        hostEl.setTextConfig({
          local: false,
          position: layoutOption.x != null || layoutOption.y != null ? null : defaultLabelAttr.attachedPos,
          rotation: layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.attachedRot,
          offset: [layoutOption.dx || 0, layoutOption.dy || 0]
        });
      }
      var needsUpdateLabelLine = false;
      if (layoutOption.x != null) {
        label.x = parsePercent(layoutOption.x, width);
        label.setStyle("x", 0);
        needsUpdateLabelLine = true;
      } else {
        label.x = defaultLabelAttr.x;
        label.setStyle("x", defaultLabelAttr.style.x);
      }
      if (layoutOption.y != null) {
        label.y = parsePercent(layoutOption.y, height);
        label.setStyle("y", 0);
        needsUpdateLabelLine = true;
      } else {
        label.y = defaultLabelAttr.y;
        label.setStyle("y", defaultLabelAttr.style.y);
      }
      if (layoutOption.labelLinePoints) {
        var guideLine = hostEl.getTextGuideLine();
        if (guideLine) {
          guideLine.setShape({
            points: layoutOption.labelLinePoints
          });
          needsUpdateLabelLine = false;
        }
      }
      var labelLayoutStore = labelLayoutInnerStore(label);
      labelLayoutStore.needsUpdateLabelLine = needsUpdateLabelLine;
      label.rotation = layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.rotation;
      label.scaleX = defaultLabelAttr.scaleX;
      label.scaleY = defaultLabelAttr.scaleY;
      for (var k2 = 0; k2 < LABEL_OPTION_TO_STYLE_KEYS.length; k2++) {
        var key = LABEL_OPTION_TO_STYLE_KEYS[k2];
        label.setStyle(key, layoutOption[key] != null ? layoutOption[key] : defaultLabelAttr.style[key]);
      }
      if (layoutOption.draggable) {
        label.draggable = true;
        label.cursor = "move";
        if (hostEl) {
          var hostModel = labelItem.seriesModel;
          if (labelItem.dataIndex != null) {
            var data = labelItem.seriesModel.getData(labelItem.dataType);
            hostModel = data.getItemModel(labelItem.dataIndex);
          }
          label.on("drag", createDragHandler(hostEl, hostModel.getModel("labelLine")));
        }
      } else {
        label.off("drag");
        label.cursor = defaultLabelAttr.cursor;
      }
    }
  };
  LabelManager2.prototype.layout = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    var labelList = prepareLayoutList(this._labelList);
    var labelsNeedsAdjustOnX = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftX";
    });
    var labelsNeedsAdjustOnY = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftY";
    });
    shiftLayoutOnX(labelsNeedsAdjustOnX, 0, width);
    shiftLayoutOnY(labelsNeedsAdjustOnY, 0, height);
    var labelsNeedsHideOverlap = filter(labelList, function(item) {
      return item.layoutOption.hideOverlap;
    });
    hideOverlap(labelsNeedsHideOverlap);
  };
  LabelManager2.prototype.processLabelsOverall = function() {
    var _this = this;
    each$f(this._chartViewList, function(chartView) {
      var seriesModel = chartView.__model;
      var ignoreLabelLineUpdate = chartView.ignoreLabelLineUpdate;
      var animationEnabled = seriesModel.isAnimationEnabled();
      chartView.group.traverse(function(child) {
        if (child.ignore && !child.forceLabelAnimation) {
          return true;
        }
        var needsUpdateLabelLine = !ignoreLabelLineUpdate;
        var label = child.getTextContent();
        if (!needsUpdateLabelLine && label) {
          needsUpdateLabelLine = labelLayoutInnerStore(label).needsUpdateLabelLine;
        }
        if (needsUpdateLabelLine) {
          _this._updateLabelLine(child, seriesModel);
        }
        if (animationEnabled) {
          _this._animateLabels(child, seriesModel);
        }
      });
    });
  };
  LabelManager2.prototype._updateLabelLine = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var ecData = getECData(el);
    var dataIndex = ecData.dataIndex;
    if (textEl && dataIndex != null) {
      var data = seriesModel.getData(ecData.dataType);
      var itemModel = data.getItemModel(dataIndex);
      var defaultStyle = {};
      var visualStyle = data.getItemVisual(dataIndex, "style");
      var visualType = data.getVisual("drawType");
      defaultStyle.stroke = visualStyle[visualType];
      var labelLineModel = itemModel.getModel("labelLine");
      setLabelLineStyle(el, getLabelLineStatesModels(itemModel), defaultStyle);
      updateLabelLinePoints(el, labelLineModel);
    }
  };
  LabelManager2.prototype._animateLabels = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var guideLine = el.getTextGuideLine();
    if (textEl && (el.forceLabelAnimation || !textEl.ignore && !textEl.invisible && !el.disableLabelAnimation && !isElementRemoved(el))) {
      var layoutStore = labelLayoutInnerStore(textEl);
      var oldLayout = layoutStore.oldLayout;
      var ecData = getECData(el);
      var dataIndex = ecData.dataIndex;
      var newProps = {
        x: textEl.x,
        y: textEl.y,
        rotation: textEl.rotation
      };
      var data = seriesModel.getData(ecData.dataType);
      if (!oldLayout) {
        textEl.attr(newProps);
        if (!labelInner(textEl).valueAnimation) {
          var oldOpacity = retrieve2(textEl.style.opacity, 1);
          textEl.style.opacity = 0;
          initProps(textEl, {
            style: {
              opacity: oldOpacity
            }
          }, seriesModel, dataIndex);
        }
      } else {
        textEl.attr(oldLayout);
        var prevStates = el.prevStates;
        if (prevStates) {
          if (indexOf(prevStates, "select") >= 0) {
            textEl.attr(layoutStore.oldLayoutSelect);
          }
          if (indexOf(prevStates, "emphasis") >= 0) {
            textEl.attr(layoutStore.oldLayoutEmphasis);
          }
        }
        updateProps$1(textEl, newProps, seriesModel, dataIndex);
      }
      layoutStore.oldLayout = newProps;
      if (textEl.states.select) {
        var layoutSelect = layoutStore.oldLayoutSelect = {};
        extendWithKeys(layoutSelect, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutSelect, textEl.states.select, LABEL_LAYOUT_PROPS);
      }
      if (textEl.states.emphasis) {
        var layoutEmphasis = layoutStore.oldLayoutEmphasis = {};
        extendWithKeys(layoutEmphasis, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutEmphasis, textEl.states.emphasis, LABEL_LAYOUT_PROPS);
      }
      animateLabelValue(textEl, dataIndex, data, seriesModel, seriesModel);
    }
    if (guideLine && !guideLine.ignore && !guideLine.invisible) {
      var layoutStore = labelLineAnimationStore(guideLine);
      var oldLayout = layoutStore.oldLayout;
      var newLayout = {
        points: guideLine.shape.points
      };
      if (!oldLayout) {
        guideLine.setShape(newLayout);
        guideLine.style.strokePercent = 0;
        initProps(guideLine, {
          style: {
            strokePercent: 1
          }
        }, seriesModel);
      } else {
        guideLine.attr({
          shape: oldLayout
        });
        updateProps$1(guideLine, {
          shape: newLayout
        }, seriesModel);
      }
      layoutStore.oldLayout = newLayout;
    }
  };
  return LabelManager2;
}();
var LabelManager$1 = LabelManager;
var getLabelManager = makeInner();
function installLabelLayout(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    if (!labelManager) {
      labelManager = getLabelManager(api).labelManager = new LabelManager$1();
    }
    labelManager.clearLabels();
  });
  registers.registerUpdateLifecycle("series:layoutlabels", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    params.updatedSeries.forEach(function(series) {
      labelManager.addLabelsOfSeries(api.getViewOfSeriesModel(series));
    });
    labelManager.updateLayoutConfig(api);
    labelManager.layout(api);
    labelManager.processLabelsOverall();
  });
}
var mathSin = Math.sin;
var mathCos = Math.cos;
var PI$4 = Math.PI;
var PI2$2 = Math.PI * 2;
var degree = 180 / PI$4;
var SVGPathRebuilder = function() {
  function SVGPathRebuilder2() {
  }
  SVGPathRebuilder2.prototype.reset = function(precision) {
    this._start = true;
    this._d = [];
    this._str = "";
    this._p = Math.pow(10, precision || 4);
  };
  SVGPathRebuilder2.prototype.moveTo = function(x2, y2) {
    this._add("M", x2, y2);
  };
  SVGPathRebuilder2.prototype.lineTo = function(x2, y2) {
    this._add("L", x2, y2);
  };
  SVGPathRebuilder2.prototype.bezierCurveTo = function(x2, y2, x22, y22, x3, y3) {
    this._add("C", x2, y2, x22, y22, x3, y3);
  };
  SVGPathRebuilder2.prototype.quadraticCurveTo = function(x2, y2, x22, y22) {
    this._add("Q", x2, y2, x22, y22);
  };
  SVGPathRebuilder2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this.ellipse(cx, cy, r2, r2, 0, startAngle, endAngle, anticlockwise);
  };
  SVGPathRebuilder2.prototype.ellipse = function(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise) {
    var dTheta = endAngle - startAngle;
    var clockwise = !anticlockwise;
    var dThetaPositive = Math.abs(dTheta);
    var isCircle = isAroundZero(dThetaPositive - PI2$2) || (clockwise ? dTheta >= PI2$2 : -dTheta >= PI2$2);
    var unifiedTheta = dTheta > 0 ? dTheta % PI2$2 : dTheta % PI2$2 + PI2$2;
    var large = false;
    if (isCircle) {
      large = true;
    } else if (isAroundZero(dThetaPositive)) {
      large = false;
    } else {
      large = unifiedTheta >= PI$4 === !!clockwise;
    }
    var x0 = cx + rx * mathCos(startAngle);
    var y0 = cy + ry * mathSin(startAngle);
    if (this._start) {
      this._add("M", x0, y0);
    }
    var xRot = Math.round(psi * degree);
    if (isCircle) {
      var p2 = 1 / this._p;
      var dTheta_1 = (clockwise ? 1 : -1) * (PI2$2 - p2);
      this._add("A", rx, ry, xRot, 1, +clockwise, cx + rx * mathCos(startAngle + dTheta_1), cy + ry * mathSin(startAngle + dTheta_1));
      if (p2 > 0.01) {
        this._add("A", rx, ry, xRot, 0, +clockwise, x0, y0);
      }
    } else {
      var x2 = cx + rx * mathCos(endAngle);
      var y2 = cy + ry * mathSin(endAngle);
      this._add("A", rx, ry, xRot, +large, +clockwise, x2, y2);
    }
  };
  SVGPathRebuilder2.prototype.rect = function(x2, y2, w2, h) {
    this._add("M", x2, y2);
    this._add("l", w2, 0);
    this._add("l", 0, h);
    this._add("l", -w2, 0);
    this._add("Z");
  };
  SVGPathRebuilder2.prototype.closePath = function() {
    if (this._d.length > 0) {
      this._add("Z");
    }
  };
  SVGPathRebuilder2.prototype._add = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    var vals = [];
    var p2 = this._p;
    for (var i = 1; i < arguments.length; i++) {
      var val = arguments[i];
      if (isNaN(val)) {
        this._invalid = true;
        return;
      }
      vals.push(Math.round(val * p2) / p2);
    }
    this._d.push(cmd + vals.join(" "));
    this._start = cmd === "Z";
  };
  SVGPathRebuilder2.prototype.generateStr = function() {
    this._str = this._invalid ? "" : this._d.join("");
    this._d = [];
  };
  SVGPathRebuilder2.prototype.getStr = function() {
    return this._str;
  };
  return SVGPathRebuilder2;
}();
var SVGPathRebuilder$1 = SVGPathRebuilder;
var NONE = "none";
var mathRound = Math.round;
function pathHasFill(style) {
  var fill = style.fill;
  return fill != null && fill !== NONE;
}
function pathHasStroke(style) {
  var stroke = style.stroke;
  return stroke != null && stroke !== NONE;
}
var strokeProps = ["lineCap", "miterLimit", "lineJoin"];
var svgStrokeProps = map$1(strokeProps, function(prop) {
  return "stroke-" + prop.toLowerCase();
});
function mapStyleToAttrs(updateAttr2, style, el, forceUpdate) {
  var opacity = style.opacity == null ? 1 : style.opacity;
  if (el instanceof ZRImage$1) {
    updateAttr2("opacity", opacity);
    return;
  }
  if (pathHasFill(style)) {
    var fill = normalizeColor(style.fill);
    updateAttr2("fill", fill.color);
    var fillOpacity = style.fillOpacity != null ? style.fillOpacity * fill.opacity * opacity : fill.opacity * opacity;
    if (forceUpdate || fillOpacity < 1) {
      updateAttr2("fill-opacity", fillOpacity);
    }
  } else {
    updateAttr2("fill", NONE);
  }
  if (pathHasStroke(style)) {
    var stroke = normalizeColor(style.stroke);
    updateAttr2("stroke", stroke.color);
    var strokeScale = style.strokeNoScale ? el.getLineScale() : 1;
    var strokeWidth = strokeScale ? (style.lineWidth || 0) / strokeScale : 0;
    var strokeOpacity = style.strokeOpacity != null ? style.strokeOpacity * stroke.opacity * opacity : stroke.opacity * opacity;
    var strokeFirst = style.strokeFirst;
    if (forceUpdate || strokeWidth !== 1) {
      updateAttr2("stroke-width", strokeWidth);
    }
    if (forceUpdate || strokeFirst) {
      updateAttr2("paint-order", strokeFirst ? "stroke" : "fill");
    }
    if (forceUpdate || strokeOpacity < 1) {
      updateAttr2("stroke-opacity", strokeOpacity);
    }
    if (style.lineDash) {
      var _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
      if (lineDash) {
        lineDashOffset = mathRound(lineDashOffset || 0);
        updateAttr2("stroke-dasharray", lineDash.join(","));
        if (lineDashOffset || forceUpdate) {
          updateAttr2("stroke-dashoffset", lineDashOffset);
        }
      }
    } else if (forceUpdate) {
      updateAttr2("stroke-dasharray", NONE);
    }
    for (var i = 0; i < strokeProps.length; i++) {
      var propName = strokeProps[i];
      if (forceUpdate || style[propName] !== DEFAULT_PATH_STYLE[propName]) {
        var val = style[propName] || DEFAULT_PATH_STYLE[propName];
        val && updateAttr2(svgStrokeProps[i], val);
      }
    }
  } else if (forceUpdate) {
    updateAttr2("stroke", NONE);
  }
}
var SVGNS = "http://www.w3.org/2000/svg";
var XLINKNS = "http://www.w3.org/1999/xlink";
var XMLNS = "http://www.w3.org/2000/xmlns/";
var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
function createElement(name) {
  return document.createElementNS(SVGNS, name);
}
function createVNode(tag, key, attrs, children, text) {
  return {
    tag,
    attrs: attrs || {},
    children,
    text,
    key
  };
}
function createElementOpen(name, attrs) {
  var attrsStr = [];
  if (attrs) {
    for (var key in attrs) {
      var val = attrs[key];
      var part = key;
      if (val === false) {
        continue;
      } else if (val !== true && val != null) {
        part += '="' + val + '"';
      }
      attrsStr.push(part);
    }
  }
  return "<" + name + " " + attrsStr.join(" ") + ">";
}
function createElementClose(name) {
  return "</" + name + ">";
}
function vNodeToString(el, opts) {
  opts = opts || {};
  var S = opts.newline ? "\n" : "";
  function convertElToString(el2) {
    var children = el2.children, tag = el2.tag, attrs = el2.attrs;
    return createElementOpen(tag, attrs) + (el2.text || "") + (children ? "" + S + map$1(children, function(child) {
      return convertElToString(child);
    }).join(S) + S : "") + createElementClose(tag);
  }
  return convertElToString(el);
}
function getCssString(selectorNodes, animationNodes, opts) {
  opts = opts || {};
  var S = opts.newline ? "\n" : "";
  var bracketBegin = " {" + S;
  var bracketEnd = S + "}";
  var selectors = map$1(keys(selectorNodes), function(className) {
    return className + bracketBegin + map$1(keys(selectorNodes[className]), function(attrName) {
      return attrName + ":" + selectorNodes[className][attrName] + ";";
    }).join(S) + bracketEnd;
  }).join(S);
  var animations = map$1(keys(animationNodes), function(animationName) {
    return "@keyframes " + animationName + bracketBegin + map$1(keys(animationNodes[animationName]), function(percent) {
      return percent + bracketBegin + map$1(keys(animationNodes[animationName][percent]), function(attrName) {
        var val = animationNodes[animationName][percent][attrName];
        if (attrName === "d") {
          val = 'path("' + val + '")';
        }
        return attrName + ":" + val + ";";
      }).join(S) + bracketEnd;
    }).join(S) + bracketEnd;
  }).join(S);
  if (!selectors && !animations) {
    return "";
  }
  return ["<![CDATA[", selectors, animations, "]]>"].join(S);
}
function createBrushScope(zrId) {
  return {
    zrId,
    shadowCache: {},
    patternCache: {},
    gradientCache: {},
    clipPathCache: {},
    defs: {},
    cssNodes: {},
    cssAnims: {},
    cssClassIdx: 0,
    cssAnimIdx: 0,
    shadowIdx: 0,
    gradientIdx: 0,
    patternIdx: 0,
    clipPathIdx: 0
  };
}
function createSVGVNode(width, height, children, useViewBox) {
  return createVNode("svg", "root", {
    "width": width,
    "height": height,
    "xmlns": SVGNS,
    "xmlns:xlink": XLINKNS,
    "version": "1.1",
    "baseProfile": "full",
    "viewBox": useViewBox ? "0 0 " + width + " " + height : false
  }, children);
}
var EASING_MAP = {
  cubicIn: "0.32,0,0.67,0",
  cubicOut: "0.33,1,0.68,1",
  cubicInOut: "0.65,0,0.35,1",
  quadraticIn: "0.11,0,0.5,0",
  quadraticOut: "0.5,1,0.89,1",
  quadraticInOut: "0.45,0,0.55,1",
  quarticIn: "0.5,0,0.75,0",
  quarticOut: "0.25,1,0.5,1",
  quarticInOut: "0.76,0,0.24,1",
  quinticIn: "0.64,0,0.78,0",
  quinticOut: "0.22,1,0.36,1",
  quinticInOut: "0.83,0,0.17,1",
  sinusoidalIn: "0.12,0,0.39,0",
  sinusoidalOut: "0.61,1,0.88,1",
  sinusoidalInOut: "0.37,0,0.63,1",
  exponentialIn: "0.7,0,0.84,0",
  exponentialOut: "0.16,1,0.3,1",
  exponentialInOut: "0.87,0,0.13,1",
  circularIn: "0.55,0,1,0.45",
  circularOut: "0,0.55,0.45,1",
  circularInOut: "0.85,0,0.15,1"
};
var transformOriginKey = "transform-origin";
function buildPathString(el, kfShape, path) {
  var shape = extend({}, el.shape);
  extend(shape, kfShape);
  el.buildPath(path, shape);
  var svgPathBuilder = new SVGPathRebuilder$1();
  svgPathBuilder.reset(getPathPrecision(el));
  path.rebuildPath(svgPathBuilder, 1);
  svgPathBuilder.generateStr();
  return svgPathBuilder.getStr();
}
function setTransformOrigin(target, transform2) {
  var originX = transform2.originX, originY = transform2.originY;
  if (originX || originY) {
    target[transformOriginKey] = originX + "px " + originY + "px";
  }
}
var ANIMATE_STYLE_MAP = {
  fill: "fill",
  opacity: "opacity",
  lineWidth: "stroke-width",
  lineDashOffset: "stroke-dashoffset"
};
function addAnimation(cssAnim, scope) {
  var animationName = scope.zrId + "-ani-" + scope.cssAnimIdx++;
  scope.cssAnims[animationName] = cssAnim;
  return animationName;
}
function createCompoundPathCSSAnimation(el, attrs, scope) {
  var paths = el.shape.paths;
  var composedAnim = {};
  var cssAnimationCfg;
  var cssAnimationName;
  each$f(paths, function(path) {
    var subScope = createBrushScope(scope.zrId);
    subScope.animation = true;
    createCSSAnimation(path, {}, subScope, true);
    var cssAnims = subScope.cssAnims;
    var cssNodes = subScope.cssNodes;
    var animNames = keys(cssAnims);
    var len2 = animNames.length;
    if (!len2) {
      return;
    }
    cssAnimationName = animNames[len2 - 1];
    var lastAnim = cssAnims[cssAnimationName];
    for (var percent in lastAnim) {
      var kf = lastAnim[percent];
      composedAnim[percent] = composedAnim[percent] || { d: "" };
      composedAnim[percent].d += kf.d || "";
    }
    for (var className in cssNodes) {
      var val = cssNodes[className].animation;
      if (val.indexOf(cssAnimationName) >= 0) {
        cssAnimationCfg = val;
      }
    }
  });
  if (!cssAnimationCfg) {
    return;
  }
  attrs.d = false;
  var animationName = addAnimation(composedAnim, scope);
  return cssAnimationCfg.replace(cssAnimationName, animationName);
}
function getEasingFunc(easing) {
  return isString(easing) ? EASING_MAP[easing] ? "cubic-bezier(" + EASING_MAP[easing] + ")" : createCubicEasingFunc(easing) ? easing : "" : "";
}
function createCSSAnimation(el, attrs, scope, onlyShape) {
  var animators = el.animators;
  var len2 = animators.length;
  var cssAnimations = [];
  if (el instanceof CompoundPath$1) {
    var animationCfg = createCompoundPathCSSAnimation(el, attrs, scope);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    } else if (!len2) {
      return;
    }
  } else if (!len2) {
    return;
  }
  var groupAnimators = {};
  for (var i = 0; i < len2; i++) {
    var animator = animators[i];
    var cfgArr = [animator.getMaxTime() / 1e3 + "s"];
    var easing = getEasingFunc(animator.getClip().easing);
    var delay = animator.getDelay();
    if (easing) {
      cfgArr.push(easing);
    } else {
      cfgArr.push("linear");
    }
    if (delay) {
      cfgArr.push(delay / 1e3 + "s");
    }
    if (animator.getLoop()) {
      cfgArr.push("infinite");
    }
    var cfg = cfgArr.join(" ");
    groupAnimators[cfg] = groupAnimators[cfg] || [cfg, []];
    groupAnimators[cfg][1].push(animator);
  }
  function createSingleCSSAnimation(groupAnimator) {
    var animators2 = groupAnimator[1];
    var len3 = animators2.length;
    var transformKfs = {};
    var shapeKfs = {};
    var finalKfs = {};
    var animationTimingFunctionAttrName = "animation-timing-function";
    function saveAnimatorTrackToCssKfs(animator3, cssKfs, toCssAttrName) {
      var tracks = animator3.getTracks();
      var maxTime = animator3.getMaxTime();
      for (var k2 = 0; k2 < tracks.length; k2++) {
        var track = tracks[k2];
        if (track.needsAnimate()) {
          var kfs = track.keyframes;
          var attrName = track.propName;
          toCssAttrName && (attrName = toCssAttrName(attrName));
          if (attrName) {
            for (var i3 = 0; i3 < kfs.length; i3++) {
              var kf = kfs[i3];
              var percent2 = Math.round(kf.time / maxTime * 100) + "%";
              var kfEasing = getEasingFunc(kf.easing);
              var rawValue = kf.rawValue;
              if (isString(rawValue) || isNumber(rawValue)) {
                cssKfs[percent2] = cssKfs[percent2] || {};
                cssKfs[percent2][attrName] = kf.rawValue;
                if (kfEasing) {
                  cssKfs[percent2][animationTimingFunctionAttrName] = kfEasing;
                }
              }
            }
          }
        }
      }
    }
    for (var i2 = 0; i2 < len3; i2++) {
      var animator2 = animators2[i2];
      var targetProp = animator2.targetName;
      if (!targetProp) {
        !onlyShape && saveAnimatorTrackToCssKfs(animator2, transformKfs);
      } else if (targetProp === "shape") {
        saveAnimatorTrackToCssKfs(animator2, shapeKfs);
      }
    }
    for (var percent in transformKfs) {
      var transform2 = {};
      copyTransform(transform2, el);
      extend(transform2, transformKfs[percent]);
      var str = getSRTTransformString(transform2);
      var timingFunction = transformKfs[percent][animationTimingFunctionAttrName];
      finalKfs[percent] = str ? {
        transform: str
      } : {};
      setTransformOrigin(finalKfs[percent], transform2);
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    var path;
    var canAnimateShape = true;
    for (var percent in shapeKfs) {
      finalKfs[percent] = finalKfs[percent] || {};
      var isFirst = !path;
      var timingFunction = shapeKfs[percent][animationTimingFunctionAttrName];
      if (isFirst) {
        path = new PathProxy$1();
      }
      var len_1 = path.len();
      path.reset();
      finalKfs[percent].d = buildPathString(el, shapeKfs[percent], path);
      var newLen = path.len();
      if (!isFirst && len_1 !== newLen) {
        canAnimateShape = false;
        break;
      }
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    if (!canAnimateShape) {
      for (var percent in finalKfs) {
        delete finalKfs[percent].d;
      }
    }
    if (!onlyShape) {
      for (var i2 = 0; i2 < len3; i2++) {
        var animator2 = animators2[i2];
        var targetProp = animator2.targetName;
        if (targetProp === "style") {
          saveAnimatorTrackToCssKfs(animator2, finalKfs, function(propName) {
            return ANIMATE_STYLE_MAP[propName];
          });
        }
      }
    }
    var percents = keys(finalKfs);
    var allTransformOriginSame = true;
    var transformOrigin;
    for (var i2 = 1; i2 < percents.length; i2++) {
      var p0 = percents[i2 - 1];
      var p1 = percents[i2];
      if (finalKfs[p0][transformOriginKey] !== finalKfs[p1][transformOriginKey]) {
        allTransformOriginSame = false;
        break;
      }
      transformOrigin = finalKfs[p0][transformOriginKey];
    }
    if (allTransformOriginSame && transformOrigin) {
      for (var percent in finalKfs) {
        if (finalKfs[percent][transformOriginKey]) {
          delete finalKfs[percent][transformOriginKey];
        }
      }
      attrs[transformOriginKey] = transformOrigin;
    }
    if (filter(percents, function(percent2) {
      return keys(finalKfs[percent2]).length > 0;
    }).length) {
      var animationName = addAnimation(finalKfs, scope);
      return animationName + " " + groupAnimator[0] + " both";
    }
  }
  for (var key in groupAnimators) {
    var animationCfg = createSingleCSSAnimation(groupAnimators[key]);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    }
  }
  if (cssAnimations.length) {
    var className = scope.zrId + "-cls-" + scope.cssClassIdx++;
    scope.cssNodes["." + className] = {
      animation: cssAnimations.join(",")
    };
    attrs["class"] = className;
  }
}
var round$1 = Math.round;
function isImageLike(val) {
  return val && isString(val.src);
}
function isCanvasLike(val) {
  return val && isFunction(val.toDataURL);
}
function setStyleAttrs(attrs, style, el, scope) {
  mapStyleToAttrs(function(key, val) {
    var isFillStroke = key === "fill" || key === "stroke";
    if (isFillStroke && isGradient(val)) {
      setGradient(style, attrs, key, scope);
    } else if (isFillStroke && isPattern(val)) {
      setPattern(el, attrs, key, scope);
    } else {
      attrs[key] = val;
    }
  }, style, el, false);
  setShadow(el, attrs, scope);
}
function noRotateScale(m2) {
  return isAroundZero(m2[0] - 1) && isAroundZero(m2[1]) && isAroundZero(m2[2]) && isAroundZero(m2[3] - 1);
}
function noTranslate(m2) {
  return isAroundZero(m2[4]) && isAroundZero(m2[5]);
}
function setTransform(attrs, m2, compress) {
  if (m2 && !(noTranslate(m2) && noRotateScale(m2))) {
    var mul2 = compress ? 10 : 1e4;
    attrs.transform = noRotateScale(m2) ? "translate(" + round$1(m2[4] * mul2) / mul2 + " " + round$1(m2[5] * mul2) / mul2 + ")" : getMatrixStr(m2);
  }
}
function convertPolyShape(shape, attrs, mul2) {
  var points2 = shape.points;
  var strArr = [];
  for (var i = 0; i < points2.length; i++) {
    strArr.push(round$1(points2[i][0] * mul2) / mul2);
    strArr.push(round$1(points2[i][1] * mul2) / mul2);
  }
  attrs.points = strArr.join(" ");
}
function validatePolyShape(shape) {
  return !shape.smooth;
}
function createAttrsConvert(desc) {
  var normalizedDesc = map$1(desc, function(item) {
    return typeof item === "string" ? [item, item] : item;
  });
  return function(shape, attrs, mul2) {
    for (var i = 0; i < normalizedDesc.length; i++) {
      var item = normalizedDesc[i];
      var val = shape[item[0]];
      if (val != null) {
        attrs[item[1]] = round$1(val * mul2) / mul2;
      }
    }
  };
}
var buitinShapesDef = {
  circle: [createAttrsConvert(["cx", "cy", "r"])],
  polyline: [convertPolyShape, validatePolyShape],
  polygon: [convertPolyShape, validatePolyShape]
};
function hasShapeAnimation(el) {
  var animators = el.animators;
  for (var i = 0; i < animators.length; i++) {
    if (animators[i].targetName === "shape") {
      return true;
    }
  }
  return false;
}
function brushSVGPath(el, scope) {
  var style = el.style;
  var shape = el.shape;
  var builtinShpDef = buitinShapesDef[el.type];
  var attrs = {};
  var needsAnimate = scope.animation;
  var svgElType = "path";
  var strokePercent = el.style.strokePercent;
  var precision = scope.compress && getPathPrecision(el) || 4;
  if (builtinShpDef && !scope.willUpdate && !(builtinShpDef[1] && !builtinShpDef[1](shape)) && !(needsAnimate && hasShapeAnimation(el)) && !(strokePercent < 1)) {
    svgElType = el.type;
    var mul2 = Math.pow(10, precision);
    builtinShpDef[0](shape, attrs, mul2);
  } else {
    if (!el.path) {
      el.createPathProxy();
    }
    var path = el.path;
    if (el.shapeChanged()) {
      path.beginPath();
      el.buildPath(path, el.shape);
      el.pathUpdated();
    }
    var pathVersion = path.getVersion();
    var elExt = el;
    var svgPathBuilder = elExt.__svgPathBuilder;
    if (elExt.__svgPathVersion !== pathVersion || !svgPathBuilder || strokePercent !== elExt.__svgPathStrokePercent) {
      if (!svgPathBuilder) {
        svgPathBuilder = elExt.__svgPathBuilder = new SVGPathRebuilder$1();
      }
      svgPathBuilder.reset(precision);
      path.rebuildPath(svgPathBuilder, strokePercent);
      svgPathBuilder.generateStr();
      elExt.__svgPathVersion = pathVersion;
      elExt.__svgPathStrokePercent = strokePercent;
    }
    attrs.d = svgPathBuilder.getStr();
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode(svgElType, el.id + "", attrs);
}
function brushSVGImage(el, scope) {
  var style = el.style;
  var image = style.image;
  if (image && !isString(image)) {
    if (isImageLike(image)) {
      image = image.src;
    } else if (isCanvasLike(image)) {
      image = image.toDataURL();
    }
  }
  if (!image) {
    return;
  }
  var x2 = style.x || 0;
  var y2 = style.y || 0;
  var dw = style.width;
  var dh = style.height;
  var attrs = {
    href: image,
    width: dw,
    height: dh
  };
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("image", el.id + "", attrs);
}
function brushSVGTSpan(el, scope) {
  var style = el.style;
  var text = style.text;
  text != null && (text += "");
  if (!text || isNaN(style.x) || isNaN(style.y)) {
    return;
  }
  var font = style.font || DEFAULT_FONT;
  var x2 = style.x || 0;
  var y2 = adjustTextY$1(style.y || 0, getLineHeight(font), style.textBaseline);
  var textAlign = TEXT_ALIGN_TO_ANCHOR[style.textAlign] || style.textAlign;
  var attrs = {
    "dominant-baseline": "central",
    "text-anchor": textAlign
  };
  if (hasSeparateFont(style)) {
    var separatedFontStr = "";
    var fontStyle = style.fontStyle;
    var fontSize = parseFontSize(style.fontSize);
    if (!parseFloat(fontSize)) {
      return;
    }
    var fontFamily = style.fontFamily || DEFAULT_FONT_FAMILY;
    var fontWeight = style.fontWeight;
    separatedFontStr += "font-size:" + fontSize + ";font-family:" + fontFamily + ";";
    if (fontStyle && fontStyle !== "normal") {
      separatedFontStr += "font-style:" + fontStyle + ";";
    }
    if (fontWeight && fontWeight !== "normal") {
      separatedFontStr += "font-weight:" + fontWeight + ";";
    }
    attrs.style = separatedFontStr;
  } else {
    attrs.style = "font: " + font;
  }
  if (text.match(/\s/)) {
    attrs["xml:space"] = "preserve";
  }
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("text", el.id + "", attrs, void 0, text);
}
function brush(el, scope) {
  if (el instanceof Path$1) {
    return brushSVGPath(el, scope);
  } else if (el instanceof ZRImage$1) {
    return brushSVGImage(el, scope);
  } else if (el instanceof TSpan$1) {
    return brushSVGTSpan(el, scope);
  }
}
function setShadow(el, attrs, scope) {
  var style = el.style;
  if (hasShadow(style)) {
    var shadowKey = getShadowKey(el);
    var shadowCache = scope.shadowCache;
    var shadowId = shadowCache[shadowKey];
    if (!shadowId) {
      var globalScale = el.getGlobalScale();
      var scaleX = globalScale[0];
      var scaleY = globalScale[1];
      if (!scaleX || !scaleY) {
        return;
      }
      var offsetX = style.shadowOffsetX || 0;
      var offsetY = style.shadowOffsetY || 0;
      var blur_1 = style.shadowBlur;
      var _a2 = normalizeColor(style.shadowColor), opacity = _a2.opacity, color = _a2.color;
      var stdDx = blur_1 / 2 / scaleX;
      var stdDy = blur_1 / 2 / scaleY;
      var stdDeviation = stdDx + " " + stdDy;
      shadowId = scope.zrId + "-s" + scope.shadowIdx++;
      scope.defs[shadowId] = createVNode("filter", shadowId, {
        "id": shadowId,
        "x": "-100%",
        "y": "-100%",
        "width": "300%",
        "height": "300%"
      }, [
        createVNode("feDropShadow", "", {
          "dx": offsetX / scaleX,
          "dy": offsetY / scaleY,
          "stdDeviation": stdDeviation,
          "flood-color": color,
          "flood-opacity": opacity
        })
      ]);
      shadowCache[shadowKey] = shadowId;
    }
    attrs.filter = getIdURL(shadowId);
  }
}
function setGradient(style, attrs, target, scope) {
  var val = style[target];
  var gradientTag;
  var gradientAttrs = {
    "gradientUnits": val.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if (isLinearGradient(val)) {
    gradientTag = "linearGradient";
    gradientAttrs.x1 = val.x;
    gradientAttrs.y1 = val.y;
    gradientAttrs.x2 = val.x2;
    gradientAttrs.y2 = val.y2;
  } else if (isRadialGradient(val)) {
    gradientTag = "radialGradient";
    gradientAttrs.cx = retrieve2(val.x, 0.5);
    gradientAttrs.cy = retrieve2(val.y, 0.5);
    gradientAttrs.r = retrieve2(val.r, 0.5);
  } else {
    return;
  }
  var colors = val.colorStops;
  var colorStops = [];
  for (var i = 0, len2 = colors.length; i < len2; ++i) {
    var offset = round4(colors[i].offset) * 100 + "%";
    var stopColor = colors[i].color;
    var _a2 = normalizeColor(stopColor), color = _a2.color, opacity = _a2.opacity;
    var stopsAttrs = {
      "offset": offset
    };
    stopsAttrs["stop-color"] = color;
    if (opacity < 1) {
      stopsAttrs["stop-opacity"] = opacity;
    }
    colorStops.push(createVNode("stop", i + "", stopsAttrs));
  }
  var gradientVNode = createVNode(gradientTag, "", gradientAttrs, colorStops);
  var gradientKey = vNodeToString(gradientVNode);
  var gradientCache = scope.gradientCache;
  var gradientId = gradientCache[gradientKey];
  if (!gradientId) {
    gradientId = scope.zrId + "-g" + scope.gradientIdx++;
    gradientCache[gradientKey] = gradientId;
    gradientAttrs.id = gradientId;
    scope.defs[gradientId] = createVNode(gradientTag, gradientId, gradientAttrs, colorStops);
  }
  attrs[target] = getIdURL(gradientId);
}
function setPattern(el, attrs, target, scope) {
  var val = el.style[target];
  var patternAttrs = {
    "patternUnits": "userSpaceOnUse"
  };
  var child;
  if (isImagePattern(val)) {
    var imageWidth_1 = val.imageWidth;
    var imageHeight_1 = val.imageHeight;
    var imageSrc = void 0;
    var patternImage = val.image;
    if (isString(patternImage)) {
      imageSrc = patternImage;
    } else if (isImageLike(patternImage)) {
      imageSrc = patternImage.src;
    } else if (isCanvasLike(patternImage)) {
      imageSrc = patternImage.toDataURL();
    }
    if (typeof Image === "undefined") {
      var errMsg = "Image width/height must been given explictly in svg-ssr renderer.";
      assert(imageWidth_1, errMsg);
      assert(imageHeight_1, errMsg);
    } else if (imageWidth_1 == null || imageHeight_1 == null) {
      var setSizeToVNode_1 = function(vNode, img) {
        if (vNode) {
          var svgEl = vNode.elm;
          var width = vNode.attrs.width = imageWidth_1 || img.width;
          var height = vNode.attrs.height = imageHeight_1 || img.height;
          if (svgEl) {
            svgEl.setAttribute("width", width);
            svgEl.setAttribute("height", height);
          }
        }
      };
      var createdImage = createOrUpdateImage(imageSrc, null, el, function(img) {
        setSizeToVNode_1(patternVNode, img);
        setSizeToVNode_1(child, img);
      });
      if (createdImage && createdImage.width && createdImage.height) {
        imageWidth_1 = imageWidth_1 || createdImage.width;
        imageHeight_1 = imageHeight_1 || createdImage.height;
      }
    }
    child = createVNode("image", "img", {
      href: imageSrc,
      width: imageWidth_1,
      height: imageHeight_1
    });
    patternAttrs.width = imageWidth_1;
    patternAttrs.height = imageHeight_1;
  } else if (val.svgElement) {
    child = clone$4(val.svgElement);
    patternAttrs.width = val.svgWidth;
    patternAttrs.height = val.svgHeight;
  }
  if (!child) {
    return;
  }
  patternAttrs.patternTransform = getSRTTransformString(val);
  var patternVNode = createVNode("pattern", "", patternAttrs, [child]);
  var patternKey = vNodeToString(patternVNode);
  var patternCache = scope.patternCache;
  var patternId = patternCache[patternKey];
  if (!patternId) {
    patternId = scope.zrId + "-p" + scope.patternIdx++;
    patternCache[patternKey] = patternId;
    patternAttrs.id = patternId;
    patternVNode = scope.defs[patternId] = createVNode("pattern", patternId, patternAttrs, [child]);
  }
  attrs[target] = getIdURL(patternId);
}
function setClipPath(clipPath, attrs, scope) {
  var clipPathCache = scope.clipPathCache, defs = scope.defs;
  var clipPathId = clipPathCache[clipPath.id];
  if (!clipPathId) {
    clipPathId = scope.zrId + "-c" + scope.clipPathIdx++;
    var clipPathAttrs = {
      id: clipPathId
    };
    clipPathCache[clipPath.id] = clipPathId;
    defs[clipPathId] = createVNode("clipPath", clipPathId, clipPathAttrs, [brushSVGPath(clipPath, scope)]);
  }
  attrs["clip-path"] = getIdURL(clipPathId);
}
function createTextNode(text) {
  return document.createTextNode(text);
}
function insertBefore(parentNode2, newNode, referenceNode) {
  parentNode2.insertBefore(newNode, referenceNode);
}
function removeChild(node, child) {
  node.removeChild(child);
}
function appendChild(node, child) {
  node.appendChild(child);
}
function parentNode(node) {
  return node.parentNode;
}
function nextSibling(node) {
  return node.nextSibling;
}
function setTextContent(node, text) {
  node.textContent = text;
}
var colonChar = 58;
var xChar = 120;
var emptyNode = createVNode("", "");
function isUndef(s) {
  return s === void 0;
}
function isDef(s) {
  return s !== void 0;
}
function createKeyToOldIdx(children, beginIdx, endIdx) {
  var map2 = {};
  for (var i = beginIdx; i <= endIdx; ++i) {
    var key = children[i].key;
    if (key !== void 0) {
      map2[key] = i;
    }
  }
  return map2;
}
function sameVnode(vnode1, vnode2) {
  var isSameKey = vnode1.key === vnode2.key;
  var isSameTag = vnode1.tag === vnode2.tag;
  return isSameTag && isSameKey;
}
function createElm(vnode) {
  var i;
  var children = vnode.children;
  var tag = vnode.tag;
  if (isDef(tag)) {
    var elm = vnode.elm = createElement(tag);
    updateAttrs(emptyNode, vnode);
    if (isArray$1(children)) {
      for (i = 0; i < children.length; ++i) {
        var ch = children[i];
        if (ch != null) {
          appendChild(elm, createElm(ch));
        }
      }
    } else if (isDef(vnode.text) && !isObject$4(vnode.text)) {
      appendChild(elm, createTextNode(vnode.text));
    }
  } else {
    vnode.elm = createTextNode(vnode.text);
  }
  return vnode.elm;
}
function addVnodes(parentElm, before, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch = vnodes[startIdx];
    if (ch != null) {
      insertBefore(parentElm, createElm(ch), before);
    }
  }
}
function removeVnodes(parentElm, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch = vnodes[startIdx];
    if (ch != null) {
      if (isDef(ch.tag)) {
        var parent_1 = parentNode(ch.elm);
        removeChild(parent_1, ch.elm);
      } else {
        removeChild(parentElm, ch.elm);
      }
    }
  }
}
function updateAttrs(oldVnode, vnode) {
  var key;
  var elm = vnode.elm;
  var oldAttrs = oldVnode && oldVnode.attrs || {};
  var attrs = vnode.attrs || {};
  if (oldAttrs === attrs) {
    return;
  }
  for (key in attrs) {
    var cur = attrs[key];
    var old = oldAttrs[key];
    if (old !== cur) {
      if (cur === true) {
        elm.setAttribute(key, "");
      } else if (cur === false) {
        elm.removeAttribute(key);
      } else {
        if (key.charCodeAt(0) !== xChar) {
          elm.setAttribute(key, cur);
        } else if (key === "xmlns:xlink" || key === "xmlns") {
          elm.setAttributeNS(XMLNS, key, cur);
        } else if (key.charCodeAt(3) === colonChar) {
          elm.setAttributeNS(XML_NAMESPACE, key, cur);
        } else if (key.charCodeAt(5) === colonChar) {
          elm.setAttributeNS(XLINKNS, key, cur);
        } else {
          elm.setAttribute(key, cur);
        }
      }
    }
  }
  for (key in oldAttrs) {
    if (!(key in attrs)) {
      elm.removeAttribute(key);
    }
  }
}
function updateChildren(parentElm, oldCh, newCh) {
  var oldStartIdx = 0;
  var newStartIdx = 0;
  var oldEndIdx = oldCh.length - 1;
  var oldStartVnode = oldCh[0];
  var oldEndVnode = oldCh[oldEndIdx];
  var newEndIdx = newCh.length - 1;
  var newStartVnode = newCh[0];
  var newEndVnode = newCh[newEndIdx];
  var oldKeyToIdx;
  var idxInOld;
  var elmToMove;
  var before;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newStartVnode)) {
      patchVnode(oldStartVnode, newStartVnode);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (sameVnode(oldEndVnode, newEndVnode)) {
      patchVnode(oldEndVnode, newEndVnode);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newEndVnode)) {
      patchVnode(oldStartVnode, newEndVnode);
      insertBefore(parentElm, oldStartVnode.elm, nextSibling(oldEndVnode.elm));
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldEndVnode, newStartVnode)) {
      patchVnode(oldEndVnode, newStartVnode);
      insertBefore(parentElm, oldEndVnode.elm, oldStartVnode.elm);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      if (isUndef(oldKeyToIdx)) {
        oldKeyToIdx = createKeyToOldIdx(oldCh, oldStartIdx, oldEndIdx);
      }
      idxInOld = oldKeyToIdx[newStartVnode.key];
      if (isUndef(idxInOld)) {
        insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
      } else {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.tag !== newStartVnode.tag) {
          insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
        } else {
          patchVnode(elmToMove, newStartVnode);
          oldCh[idxInOld] = void 0;
          insertBefore(parentElm, elmToMove.elm, oldStartVnode.elm);
        }
      }
      newStartVnode = newCh[++newStartIdx];
    }
  }
  if (oldStartIdx <= oldEndIdx || newStartIdx <= newEndIdx) {
    if (oldStartIdx > oldEndIdx) {
      before = newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].elm;
      addVnodes(parentElm, before, newCh, newStartIdx, newEndIdx);
    } else {
      removeVnodes(parentElm, oldCh, oldStartIdx, oldEndIdx);
    }
  }
}
function patchVnode(oldVnode, vnode) {
  var elm = vnode.elm = oldVnode.elm;
  var oldCh = oldVnode.children;
  var ch = vnode.children;
  if (oldVnode === vnode) {
    return;
  }
  updateAttrs(oldVnode, vnode);
  if (isUndef(vnode.text)) {
    if (isDef(oldCh) && isDef(ch)) {
      if (oldCh !== ch) {
        updateChildren(elm, oldCh, ch);
      }
    } else if (isDef(ch)) {
      if (isDef(oldVnode.text)) {
        setTextContent(elm, "");
      }
      addVnodes(elm, null, ch, 0, ch.length - 1);
    } else if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    } else if (isDef(oldVnode.text)) {
      setTextContent(elm, "");
    }
  } else if (oldVnode.text !== vnode.text) {
    if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    }
    setTextContent(elm, vnode.text);
  }
}
function patch(oldVnode, vnode) {
  if (sameVnode(oldVnode, vnode)) {
    patchVnode(oldVnode, vnode);
  } else {
    var elm = oldVnode.elm;
    var parent_2 = parentNode(elm);
    createElm(vnode);
    if (parent_2 !== null) {
      insertBefore(parent_2, vnode.elm, nextSibling(elm));
      removeVnodes(parent_2, [oldVnode], 0, 0);
    }
  }
  return vnode;
}
var svgId = 0;
var SVGPainter = function() {
  function SVGPainter2(root2, storage2, opts) {
    this.type = "svg";
    this.refreshHover = createMethodNotSupport();
    this.configLayer = createMethodNotSupport();
    this.storage = storage2;
    this._opts = opts = extend({}, opts);
    this.root = root2;
    this._id = "zr" + svgId++;
    this._oldVNode = createSVGVNode(opts.width, opts.height);
    if (root2 && !opts.ssr) {
      var viewport = this._viewport = document.createElement("div");
      viewport.style.cssText = "position:relative;overflow:hidden";
      var svgDom = this._svgDom = this._oldVNode.elm = createElement("svg");
      updateAttrs(null, this._oldVNode);
      viewport.appendChild(svgDom);
      root2.appendChild(viewport);
    }
    this.resize(opts.width, opts.height);
  }
  SVGPainter2.prototype.getType = function() {
    return this.type;
  };
  SVGPainter2.prototype.getViewportRoot = function() {
    return this._viewport;
  };
  SVGPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  SVGPainter2.prototype.getSvgDom = function() {
    return this._svgDom;
  };
  SVGPainter2.prototype.refresh = function() {
    if (this.root) {
      var vnode = this.renderToVNode({
        willUpdate: true
      });
      vnode.attrs.style = "position:absolute;left:0;top:0;user-select:none";
      patch(this._oldVNode, vnode);
      this._oldVNode = vnode;
    }
  };
  SVGPainter2.prototype.renderOneToVNode = function(el) {
    return brush(el, createBrushScope(this._id));
  };
  SVGPainter2.prototype.renderToVNode = function(opts) {
    opts = opts || {};
    var list = this.storage.getDisplayList(true);
    var bgColor = this._backgroundColor;
    var width = this._width;
    var height = this._height;
    var scope = createBrushScope(this._id);
    scope.animation = opts.animation;
    scope.willUpdate = opts.willUpdate;
    scope.compress = opts.compress;
    var children = [];
    if (bgColor && bgColor !== "none") {
      var _a2 = normalizeColor(bgColor), color = _a2.color, opacity = _a2.opacity;
      this._bgVNode = createVNode("rect", "bg", {
        width,
        height,
        x: "0",
        y: "0",
        id: "0",
        fill: color,
        "fill-opacity": opacity
      });
      children.push(this._bgVNode);
    } else {
      this._bgVNode = null;
    }
    var mainVNode = !opts.compress ? this._mainVNode = createVNode("g", "main", {}, []) : null;
    this._paintList(list, scope, mainVNode ? mainVNode.children : children);
    mainVNode && children.push(mainVNode);
    var defs = map$1(keys(scope.defs), function(id2) {
      return scope.defs[id2];
    });
    if (defs.length) {
      children.push(createVNode("defs", "defs", {}, defs));
    }
    if (opts.animation) {
      var animationCssStr = getCssString(scope.cssNodes, scope.cssAnims, { newline: true });
      if (animationCssStr) {
        var styleNode = createVNode("style", "stl", {}, [], animationCssStr);
        children.push(styleNode);
      }
    }
    return createSVGVNode(width, height, children, opts.useViewBox);
  };
  SVGPainter2.prototype.renderToString = function(opts) {
    opts = opts || {};
    return vNodeToString(this.renderToVNode({
      animation: retrieve2(opts.cssAnimation, true),
      willUpdate: false,
      compress: true,
      useViewBox: retrieve2(opts.useViewBox, true)
    }), { newline: true });
  };
  SVGPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    var bgVNode = this._bgVNode;
    if (bgVNode && bgVNode.elm) {
      var _a2 = normalizeColor(backgroundColor2), color = _a2.color, opacity = _a2.opacity;
      bgVNode.elm.setAttribute("fill", color);
      if (opacity < 1) {
        bgVNode.elm.setAttribute("fill-opacity", opacity);
      }
    }
  };
  SVGPainter2.prototype.getSvgRoot = function() {
    return this._mainVNode && this._mainVNode.elm;
  };
  SVGPainter2.prototype._paintList = function(list, scope, out2) {
    var listLen = list.length;
    var clipPathsGroupsStack = [];
    var clipPathsGroupsStackDepth = 0;
    var currentClipPathGroup;
    var prevClipPaths;
    var clipGroupNodeIdx = 0;
    for (var i = 0; i < listLen; i++) {
      var displayable = list[i];
      if (!displayable.invisible) {
        var clipPaths = displayable.__clipPaths;
        var len2 = clipPaths && clipPaths.length || 0;
        var prevLen = prevClipPaths && prevClipPaths.length || 0;
        var lca = void 0;
        for (lca = Math.max(len2 - 1, prevLen - 1); lca >= 0; lca--) {
          if (clipPaths && prevClipPaths && clipPaths[lca] === prevClipPaths[lca]) {
            break;
          }
        }
        for (var i_1 = prevLen - 1; i_1 > lca; i_1--) {
          clipPathsGroupsStackDepth--;
          currentClipPathGroup = clipPathsGroupsStack[clipPathsGroupsStackDepth - 1];
        }
        for (var i_2 = lca + 1; i_2 < len2; i_2++) {
          var groupAttrs = {};
          setClipPath(clipPaths[i_2], groupAttrs, scope);
          var g2 = createVNode("g", "clip-g-" + clipGroupNodeIdx++, groupAttrs, []);
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(g2);
          clipPathsGroupsStack[clipPathsGroupsStackDepth++] = g2;
          currentClipPathGroup = g2;
        }
        prevClipPaths = clipPaths;
        var ret = brush(displayable, scope);
        if (ret) {
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(ret);
        }
      }
    }
  };
  SVGPainter2.prototype.resize = function(width, height) {
    var opts = this._opts;
    var root2 = this.root;
    var viewport = this._viewport;
    width != null && (opts.width = width);
    height != null && (opts.height = height);
    if (root2 && viewport) {
      viewport.style.display = "none";
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      viewport.style.display = "";
    }
    if (this._width !== width || this._height !== height) {
      this._width = width;
      this._height = height;
      if (viewport) {
        var viewportStyle = viewport.style;
        viewportStyle.width = width + "px";
        viewportStyle.height = height + "px";
      }
      var svgDom = this._svgDom;
      if (svgDom) {
        svgDom.setAttribute("width", width);
        svgDom.setAttribute("height", height);
      }
    }
  };
  SVGPainter2.prototype.getWidth = function() {
    return this._width;
  };
  SVGPainter2.prototype.getHeight = function() {
    return this._height;
  };
  SVGPainter2.prototype.dispose = function() {
    if (this.root) {
      this.root.innerHTML = "";
    }
    this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
  };
  SVGPainter2.prototype.clear = function() {
    if (this._svgDom) {
      this._svgDom.innerHTML = null;
    }
    this._oldVNode = null;
  };
  SVGPainter2.prototype.toDataURL = function(base64) {
    var str = encodeURIComponent(this.renderToString());
    var prefix = "data:image/svg+xml;";
    if (base64) {
      str = encodeBase64(str);
      return str && prefix + "base64," + str;
    }
    return prefix + "charset=UTF-8," + str;
  };
  return SVGPainter2;
}();
function createMethodNotSupport(method4) {
  return function() {
  };
}
var SVGPainter$1 = SVGPainter;
function install$S(registers) {
  registers.registerPainter("svg", SVGPainter$1);
}
function createDom(id2, painter, dpr2) {
  var newDom = platformApi.createCanvas();
  var width = painter.getWidth();
  var height = painter.getHeight();
  var newDomStyle = newDom.style;
  if (newDomStyle) {
    newDomStyle.position = "absolute";
    newDomStyle.left = "0";
    newDomStyle.top = "0";
    newDomStyle.width = width + "px";
    newDomStyle.height = height + "px";
    newDom.setAttribute("data-zr-dom-id", id2);
  }
  newDom.width = width * dpr2;
  newDom.height = height * dpr2;
  return newDom;
}
var Layer = function(_super) {
  __extends(Layer2, _super);
  function Layer2(id2, painter, dpr2) {
    var _this = _super.call(this) || this;
    _this.motionBlur = false;
    _this.lastFrameAlpha = 0.7;
    _this.dpr = 1;
    _this.virtual = false;
    _this.config = {};
    _this.incremental = false;
    _this.zlevel = 0;
    _this.maxRepaintRectCount = 5;
    _this.__dirty = true;
    _this.__firstTimePaint = true;
    _this.__used = false;
    _this.__drawIndex = 0;
    _this.__startIndex = 0;
    _this.__endIndex = 0;
    _this.__prevStartIndex = null;
    _this.__prevEndIndex = null;
    var dom;
    dpr2 = dpr2 || devicePixelRatio;
    if (typeof id2 === "string") {
      dom = createDom(id2, painter, dpr2);
    } else if (isObject$4(id2)) {
      dom = id2;
      id2 = dom.id;
    }
    _this.id = id2;
    _this.dom = dom;
    var domStyle = dom.style;
    if (domStyle) {
      disableUserSelect(dom);
      dom.onselectstart = function() {
        return false;
      };
      domStyle.padding = "0";
      domStyle.margin = "0";
      domStyle.borderWidth = "0";
    }
    _this.painter = painter;
    _this.dpr = dpr2;
    return _this;
  }
  Layer2.prototype.getElementCount = function() {
    return this.__endIndex - this.__startIndex;
  };
  Layer2.prototype.afterBrush = function() {
    this.__prevStartIndex = this.__startIndex;
    this.__prevEndIndex = this.__endIndex;
  };
  Layer2.prototype.initContext = function() {
    this.ctx = this.dom.getContext("2d");
    this.ctx.dpr = this.dpr;
  };
  Layer2.prototype.setUnpainted = function() {
    this.__firstTimePaint = true;
  };
  Layer2.prototype.createBackBuffer = function() {
    var dpr2 = this.dpr;
    this.domBack = createDom("back-" + this.id, this.painter, dpr2);
    this.ctxBack = this.domBack.getContext("2d");
    if (dpr2 !== 1) {
      this.ctxBack.scale(dpr2, dpr2);
    }
  };
  Layer2.prototype.createRepaintRects = function(displayList, prevList, viewWidth, viewHeight) {
    if (this.__firstTimePaint) {
      this.__firstTimePaint = false;
      return null;
    }
    var mergedRepaintRects = [];
    var maxRepaintRectCount = this.maxRepaintRectCount;
    var full = false;
    var pendingRect = new BoundingRect$1(0, 0, 0, 0);
    function addRectToMergePool(rect) {
      if (!rect.isFinite() || rect.isZero()) {
        return;
      }
      if (mergedRepaintRects.length === 0) {
        var boundingRect = new BoundingRect$1(0, 0, 0, 0);
        boundingRect.copy(rect);
        mergedRepaintRects.push(boundingRect);
      } else {
        var isMerged = false;
        var minDeltaArea = Infinity;
        var bestRectToMergeIdx = 0;
        for (var i2 = 0; i2 < mergedRepaintRects.length; ++i2) {
          var mergedRect = mergedRepaintRects[i2];
          if (mergedRect.intersect(rect)) {
            var pendingRect_1 = new BoundingRect$1(0, 0, 0, 0);
            pendingRect_1.copy(mergedRect);
            pendingRect_1.union(rect);
            mergedRepaintRects[i2] = pendingRect_1;
            isMerged = true;
            break;
          } else if (full) {
            pendingRect.copy(rect);
            pendingRect.union(mergedRect);
            var aArea = rect.width * rect.height;
            var bArea = mergedRect.width * mergedRect.height;
            var pendingArea = pendingRect.width * pendingRect.height;
            var deltaArea = pendingArea - aArea - bArea;
            if (deltaArea < minDeltaArea) {
              minDeltaArea = deltaArea;
              bestRectToMergeIdx = i2;
            }
          }
        }
        if (full) {
          mergedRepaintRects[bestRectToMergeIdx].union(rect);
          isMerged = true;
        }
        if (!isMerged) {
          var boundingRect = new BoundingRect$1(0, 0, 0, 0);
          boundingRect.copy(rect);
          mergedRepaintRects.push(boundingRect);
        }
        if (!full) {
          full = mergedRepaintRects.length >= maxRepaintRectCount;
        }
      }
    }
    for (var i = this.__startIndex; i < this.__endIndex; ++i) {
      var el = displayList[i];
      if (el) {
        var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
        var prevRect = el.__isRendered && (el.__dirty & REDRAW_BIT || !shouldPaint) ? el.getPrevPaintRect() : null;
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
        var curRect = shouldPaint && (el.__dirty & REDRAW_BIT || !el.__isRendered) ? el.getPaintRect() : null;
        if (curRect) {
          addRectToMergePool(curRect);
        }
      }
    }
    for (var i = this.__prevStartIndex; i < this.__prevEndIndex; ++i) {
      var el = prevList[i];
      var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
      if (el && (!shouldPaint || !el.__zr) && el.__isRendered) {
        var prevRect = el.getPrevPaintRect();
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
      }
    }
    var hasIntersections;
    do {
      hasIntersections = false;
      for (var i = 0; i < mergedRepaintRects.length; ) {
        if (mergedRepaintRects[i].isZero()) {
          mergedRepaintRects.splice(i, 1);
          continue;
        }
        for (var j = i + 1; j < mergedRepaintRects.length; ) {
          if (mergedRepaintRects[i].intersect(mergedRepaintRects[j])) {
            hasIntersections = true;
            mergedRepaintRects[i].union(mergedRepaintRects[j]);
            mergedRepaintRects.splice(j, 1);
          } else {
            j++;
          }
        }
        i++;
      }
    } while (hasIntersections);
    this._paintRects = mergedRepaintRects;
    return mergedRepaintRects;
  };
  Layer2.prototype.debugGetPaintRects = function() {
    return (this._paintRects || []).slice();
  };
  Layer2.prototype.resize = function(width, height) {
    var dpr2 = this.dpr;
    var dom = this.dom;
    var domStyle = dom.style;
    var domBack = this.domBack;
    if (domStyle) {
      domStyle.width = width + "px";
      domStyle.height = height + "px";
    }
    dom.width = width * dpr2;
    dom.height = height * dpr2;
    if (domBack) {
      domBack.width = width * dpr2;
      domBack.height = height * dpr2;
      if (dpr2 !== 1) {
        this.ctxBack.scale(dpr2, dpr2);
      }
    }
  };
  Layer2.prototype.clear = function(clearAll, clearColor, repaintRects) {
    var dom = this.dom;
    var ctx = this.ctx;
    var width = dom.width;
    var height = dom.height;
    clearColor = clearColor || this.clearColor;
    var haveMotionBLur = this.motionBlur && !clearAll;
    var lastFrameAlpha = this.lastFrameAlpha;
    var dpr2 = this.dpr;
    var self2 = this;
    if (haveMotionBLur) {
      if (!this.domBack) {
        this.createBackBuffer();
      }
      this.ctxBack.globalCompositeOperation = "copy";
      this.ctxBack.drawImage(dom, 0, 0, width / dpr2, height / dpr2);
    }
    var domBack = this.domBack;
    function doClear(x2, y2, width2, height2) {
      ctx.clearRect(x2, y2, width2, height2);
      if (clearColor && clearColor !== "transparent") {
        var clearColorGradientOrPattern = void 0;
        if (isGradientObject(clearColor)) {
          clearColorGradientOrPattern = clearColor.__canvasGradient || getCanvasGradient(ctx, clearColor, {
            x: 0,
            y: 0,
            width: width2,
            height: height2
          });
          clearColor.__canvasGradient = clearColorGradientOrPattern;
        } else if (isImagePatternObject(clearColor)) {
          clearColorGradientOrPattern = createCanvasPattern(ctx, clearColor, {
            dirty: function() {
              self2.setUnpainted();
              self2.__painter.refresh();
            }
          });
        }
        ctx.save();
        ctx.fillStyle = clearColorGradientOrPattern || clearColor;
        ctx.fillRect(x2, y2, width2, height2);
        ctx.restore();
      }
      if (haveMotionBLur) {
        ctx.save();
        ctx.globalAlpha = lastFrameAlpha;
        ctx.drawImage(domBack, x2, y2, width2, height2);
        ctx.restore();
      }
    }
    if (!repaintRects || haveMotionBLur) {
      doClear(0, 0, width, height);
    } else if (repaintRects.length) {
      each$f(repaintRects, function(rect) {
        doClear(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
      });
    }
  };
  return Layer2;
}(Eventful$1);
var Layer$1 = Layer;
var HOVER_LAYER_ZLEVEL = 1e5;
var CANVAS_ZLEVEL = 314159;
var EL_AFTER_INCREMENTAL_INC = 0.01;
var INCREMENTAL_INC = 1e-3;
function isLayerValid(layer) {
  if (!layer) {
    return false;
  }
  if (layer.__builtin__) {
    return true;
  }
  if (typeof layer.resize !== "function" || typeof layer.refresh !== "function") {
    return false;
  }
  return true;
}
function createRoot(width, height) {
  var domRoot = document.createElement("div");
  domRoot.style.cssText = [
    "position:relative",
    "width:" + width + "px",
    "height:" + height + "px",
    "padding:0",
    "margin:0",
    "border-width:0"
  ].join(";") + ";";
  return domRoot;
}
var CanvasPainter = function() {
  function CanvasPainter2(root2, storage2, opts, id2) {
    this.type = "canvas";
    this._zlevelList = [];
    this._prevDisplayList = [];
    this._layers = {};
    this._layerConfig = {};
    this._needsManuallyCompositing = false;
    this.type = "canvas";
    var singleCanvas = !root2.nodeName || root2.nodeName.toUpperCase() === "CANVAS";
    this._opts = opts = extend({}, opts || {});
    this.dpr = opts.devicePixelRatio || devicePixelRatio;
    this._singleCanvas = singleCanvas;
    this.root = root2;
    var rootStyle = root2.style;
    if (rootStyle) {
      disableUserSelect(root2);
      root2.innerHTML = "";
    }
    this.storage = storage2;
    var zlevelList = this._zlevelList;
    this._prevDisplayList = [];
    var layers = this._layers;
    if (!singleCanvas) {
      this._width = getSize$1(root2, 0, opts);
      this._height = getSize$1(root2, 1, opts);
      var domRoot = this._domRoot = createRoot(this._width, this._height);
      root2.appendChild(domRoot);
    } else {
      var rootCanvas = root2;
      var width = rootCanvas.width;
      var height = rootCanvas.height;
      if (opts.width != null) {
        width = opts.width;
      }
      if (opts.height != null) {
        height = opts.height;
      }
      this.dpr = opts.devicePixelRatio || 1;
      rootCanvas.width = width * this.dpr;
      rootCanvas.height = height * this.dpr;
      this._width = width;
      this._height = height;
      var mainLayer = new Layer$1(rootCanvas, this, this.dpr);
      mainLayer.__builtin__ = true;
      mainLayer.initContext();
      layers[CANVAS_ZLEVEL] = mainLayer;
      mainLayer.zlevel = CANVAS_ZLEVEL;
      zlevelList.push(CANVAS_ZLEVEL);
      this._domRoot = root2;
    }
  }
  CanvasPainter2.prototype.getType = function() {
    return "canvas";
  };
  CanvasPainter2.prototype.isSingleCanvas = function() {
    return this._singleCanvas;
  };
  CanvasPainter2.prototype.getViewportRoot = function() {
    return this._domRoot;
  };
  CanvasPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  CanvasPainter2.prototype.refresh = function(paintAll) {
    var list = this.storage.getDisplayList(true);
    var prevList = this._prevDisplayList;
    var zlevelList = this._zlevelList;
    this._redrawId = Math.random();
    this._paintList(list, prevList, paintAll, this._redrawId);
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__ && layer.refresh) {
        var clearColor = i === 0 ? this._backgroundColor : null;
        layer.refresh(clearColor);
      }
    }
    if (this._opts.useDirtyRect) {
      this._prevDisplayList = list.slice();
    }
    return this;
  };
  CanvasPainter2.prototype.refreshHover = function() {
    this._paintHoverList(this.storage.getDisplayList(false));
  };
  CanvasPainter2.prototype._paintHoverList = function(list) {
    var len2 = list.length;
    var hoverLayer = this._hoverlayer;
    hoverLayer && hoverLayer.clear();
    if (!len2) {
      return;
    }
    var scope = {
      inHover: true,
      viewWidth: this._width,
      viewHeight: this._height
    };
    var ctx;
    for (var i = 0; i < len2; i++) {
      var el = list[i];
      if (el.__inHover) {
        if (!hoverLayer) {
          hoverLayer = this._hoverlayer = this.getLayer(HOVER_LAYER_ZLEVEL);
        }
        if (!ctx) {
          ctx = hoverLayer.ctx;
          ctx.save();
        }
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    if (ctx) {
      ctx.restore();
    }
  };
  CanvasPainter2.prototype.getHoverLayer = function() {
    return this.getLayer(HOVER_LAYER_ZLEVEL);
  };
  CanvasPainter2.prototype.paintOne = function(ctx, el) {
    brushSingle(ctx, el);
  };
  CanvasPainter2.prototype._paintList = function(list, prevList, paintAll, redrawId) {
    if (this._redrawId !== redrawId) {
      return;
    }
    paintAll = paintAll || false;
    this._updateLayerStatus(list);
    var _a2 = this._doPaintList(list, prevList, paintAll), finished = _a2.finished, needsRefreshHover = _a2.needsRefreshHover;
    if (this._needsManuallyCompositing) {
      this._compositeManually();
    }
    if (needsRefreshHover) {
      this._paintHoverList(list);
    }
    if (!finished) {
      var self_1 = this;
      requestAnimationFrame$2(function() {
        self_1._paintList(list, prevList, paintAll, redrawId);
      });
    } else {
      this.eachLayer(function(layer) {
        layer.afterBrush && layer.afterBrush();
      });
    }
  };
  CanvasPainter2.prototype._compositeManually = function() {
    var ctx = this.getLayer(CANVAS_ZLEVEL).ctx;
    var width = this._domRoot.width;
    var height = this._domRoot.height;
    ctx.clearRect(0, 0, width, height);
    this.eachBuiltinLayer(function(layer) {
      if (layer.virtual) {
        ctx.drawImage(layer.dom, 0, 0, width, height);
      }
    });
  };
  CanvasPainter2.prototype._doPaintList = function(list, prevList, paintAll) {
    var _this = this;
    var layerList = [];
    var useDirtyRect = this._opts.useDirtyRect;
    for (var zi = 0; zi < this._zlevelList.length; zi++) {
      var zlevel = this._zlevelList[zi];
      var layer = this._layers[zlevel];
      if (layer.__builtin__ && layer !== this._hoverlayer && (layer.__dirty || paintAll)) {
        layerList.push(layer);
      }
    }
    var finished = true;
    var needsRefreshHover = false;
    var _loop_1 = function(k3) {
      var layer2 = layerList[k3];
      var ctx = layer2.ctx;
      var repaintRects = useDirtyRect && layer2.createRepaintRects(list, prevList, this_1._width, this_1._height);
      var start2 = paintAll ? layer2.__startIndex : layer2.__drawIndex;
      var useTimer = !paintAll && layer2.incremental && Date.now;
      var startTime = useTimer && Date.now();
      var clearColor = layer2.zlevel === this_1._zlevelList[0] ? this_1._backgroundColor : null;
      if (layer2.__startIndex === layer2.__endIndex) {
        layer2.clear(false, clearColor, repaintRects);
      } else if (start2 === layer2.__startIndex) {
        var firstEl = list[start2];
        if (!firstEl.incremental || !firstEl.notClear || paintAll) {
          layer2.clear(false, clearColor, repaintRects);
        }
      }
      if (start2 === -1) {
        console.error("For some unknown reason. drawIndex is -1");
        start2 = layer2.__startIndex;
      }
      var i;
      var repaint = function(repaintRect) {
        var scope = {
          inHover: false,
          allClipped: false,
          prevEl: null,
          viewWidth: _this._width,
          viewHeight: _this._height
        };
        for (i = start2; i < layer2.__endIndex; i++) {
          var el = list[i];
          if (el.__inHover) {
            needsRefreshHover = true;
          }
          _this._doPaintEl(el, layer2, useDirtyRect, repaintRect, scope, i === layer2.__endIndex - 1);
          if (useTimer) {
            var dTime = Date.now() - startTime;
            if (dTime > 15) {
              break;
            }
          }
        }
        if (scope.prevElClipPaths) {
          ctx.restore();
        }
      };
      if (repaintRects) {
        if (repaintRects.length === 0) {
          i = layer2.__endIndex;
        } else {
          var dpr2 = this_1.dpr;
          for (var r2 = 0; r2 < repaintRects.length; ++r2) {
            var rect = repaintRects[r2];
            ctx.save();
            ctx.beginPath();
            ctx.rect(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
            ctx.clip();
            repaint(rect);
            ctx.restore();
          }
        }
      } else {
        ctx.save();
        repaint();
        ctx.restore();
      }
      layer2.__drawIndex = i;
      if (layer2.__drawIndex < layer2.__endIndex) {
        finished = false;
      }
    };
    var this_1 = this;
    for (var k2 = 0; k2 < layerList.length; k2++) {
      _loop_1(k2);
    }
    if (env$1.wxa) {
      each$f(this._layers, function(layer2) {
        if (layer2 && layer2.ctx && layer2.ctx.draw) {
          layer2.ctx.draw();
        }
      });
    }
    return {
      finished,
      needsRefreshHover
    };
  };
  CanvasPainter2.prototype._doPaintEl = function(el, currentLayer, useDirtyRect, repaintRect, scope, isLast) {
    var ctx = currentLayer.ctx;
    if (useDirtyRect) {
      var paintRect = el.getPaintRect();
      if (!repaintRect || paintRect && paintRect.intersect(repaintRect)) {
        brush$1(ctx, el, scope, isLast);
        el.setPrevPaintRect(paintRect);
      }
    } else {
      brush$1(ctx, el, scope, isLast);
    }
  };
  CanvasPainter2.prototype.getLayer = function(zlevel, virtual) {
    if (this._singleCanvas && !this._needsManuallyCompositing) {
      zlevel = CANVAS_ZLEVEL;
    }
    var layer = this._layers[zlevel];
    if (!layer) {
      layer = new Layer$1("zr_" + zlevel, this, this.dpr);
      layer.zlevel = zlevel;
      layer.__builtin__ = true;
      if (this._layerConfig[zlevel]) {
        merge(layer, this._layerConfig[zlevel], true);
      } else if (this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC]) {
        merge(layer, this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC], true);
      }
      if (virtual) {
        layer.virtual = virtual;
      }
      this.insertLayer(zlevel, layer);
      layer.initContext();
    }
    return layer;
  };
  CanvasPainter2.prototype.insertLayer = function(zlevel, layer) {
    var layersMap = this._layers;
    var zlevelList = this._zlevelList;
    var len2 = zlevelList.length;
    var domRoot = this._domRoot;
    var prevLayer = null;
    var i = -1;
    if (layersMap[zlevel]) {
      return;
    }
    if (!isLayerValid(layer)) {
      return;
    }
    if (len2 > 0 && zlevel > zlevelList[0]) {
      for (i = 0; i < len2 - 1; i++) {
        if (zlevelList[i] < zlevel && zlevelList[i + 1] > zlevel) {
          break;
        }
      }
      prevLayer = layersMap[zlevelList[i]];
    }
    zlevelList.splice(i + 1, 0, zlevel);
    layersMap[zlevel] = layer;
    if (!layer.virtual) {
      if (prevLayer) {
        var prevDom = prevLayer.dom;
        if (prevDom.nextSibling) {
          domRoot.insertBefore(layer.dom, prevDom.nextSibling);
        } else {
          domRoot.appendChild(layer.dom);
        }
      } else {
        if (domRoot.firstChild) {
          domRoot.insertBefore(layer.dom, domRoot.firstChild);
        } else {
          domRoot.appendChild(layer.dom);
        }
      }
    }
    layer.__painter = this;
  };
  CanvasPainter2.prototype.eachLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      cb.call(context, this._layers[z2], z2);
    }
  };
  CanvasPainter2.prototype.eachBuiltinLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (layer.__builtin__) {
        cb.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.eachOtherLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__) {
        cb.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.getLayers = function() {
    return this._layers;
  };
  CanvasPainter2.prototype._updateLayerStatus = function(list) {
    this.eachBuiltinLayer(function(layer2, z2) {
      layer2.__dirty = layer2.__used = false;
    });
    function updatePrevLayer(idx) {
      if (prevLayer) {
        if (prevLayer.__endIndex !== idx) {
          prevLayer.__dirty = true;
        }
        prevLayer.__endIndex = idx;
      }
    }
    if (this._singleCanvas) {
      for (var i_1 = 1; i_1 < list.length; i_1++) {
        var el = list[i_1];
        if (el.zlevel !== list[i_1 - 1].zlevel || el.incremental) {
          this._needsManuallyCompositing = true;
          break;
        }
      }
    }
    var prevLayer = null;
    var incrementalLayerCount = 0;
    var prevZlevel;
    var i;
    for (i = 0; i < list.length; i++) {
      var el = list[i];
      var zlevel = el.zlevel;
      var layer = void 0;
      if (prevZlevel !== zlevel) {
        prevZlevel = zlevel;
        incrementalLayerCount = 0;
      }
      if (el.incremental) {
        layer = this.getLayer(zlevel + INCREMENTAL_INC, this._needsManuallyCompositing);
        layer.incremental = true;
        incrementalLayerCount = 1;
      } else {
        layer = this.getLayer(zlevel + (incrementalLayerCount > 0 ? EL_AFTER_INCREMENTAL_INC : 0), this._needsManuallyCompositing);
      }
      if (!layer.__builtin__) {
        logError("ZLevel " + zlevel + " has been used by unkown layer " + layer.id);
      }
      if (layer !== prevLayer) {
        layer.__used = true;
        if (layer.__startIndex !== i) {
          layer.__dirty = true;
        }
        layer.__startIndex = i;
        if (!layer.incremental) {
          layer.__drawIndex = i;
        } else {
          layer.__drawIndex = -1;
        }
        updatePrevLayer(i);
        prevLayer = layer;
      }
      if (el.__dirty & REDRAW_BIT && !el.__inHover) {
        layer.__dirty = true;
        if (layer.incremental && layer.__drawIndex < 0) {
          layer.__drawIndex = i;
        }
      }
    }
    updatePrevLayer(i);
    this.eachBuiltinLayer(function(layer2, z2) {
      if (!layer2.__used && layer2.getElementCount() > 0) {
        layer2.__dirty = true;
        layer2.__startIndex = layer2.__endIndex = layer2.__drawIndex = 0;
      }
      if (layer2.__dirty && layer2.__drawIndex < 0) {
        layer2.__drawIndex = layer2.__startIndex;
      }
    });
  };
  CanvasPainter2.prototype.clear = function() {
    this.eachBuiltinLayer(this._clearLayer);
    return this;
  };
  CanvasPainter2.prototype._clearLayer = function(layer) {
    layer.clear();
  };
  CanvasPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    each$f(this._layers, function(layer) {
      layer.setUnpainted();
    });
  };
  CanvasPainter2.prototype.configLayer = function(zlevel, config) {
    if (config) {
      var layerConfig = this._layerConfig;
      if (!layerConfig[zlevel]) {
        layerConfig[zlevel] = config;
      } else {
        merge(layerConfig[zlevel], config, true);
      }
      for (var i = 0; i < this._zlevelList.length; i++) {
        var _zlevel = this._zlevelList[i];
        if (_zlevel === zlevel || _zlevel === zlevel + EL_AFTER_INCREMENTAL_INC) {
          var layer = this._layers[_zlevel];
          merge(layer, layerConfig[zlevel], true);
        }
      }
    }
  };
  CanvasPainter2.prototype.delLayer = function(zlevel) {
    var layers = this._layers;
    var zlevelList = this._zlevelList;
    var layer = layers[zlevel];
    if (!layer) {
      return;
    }
    layer.dom.parentNode.removeChild(layer.dom);
    delete layers[zlevel];
    zlevelList.splice(indexOf(zlevelList, zlevel), 1);
  };
  CanvasPainter2.prototype.resize = function(width, height) {
    if (!this._domRoot.style) {
      if (width == null || height == null) {
        return;
      }
      this._width = width;
      this._height = height;
      this.getLayer(CANVAS_ZLEVEL).resize(width, height);
    } else {
      var domRoot = this._domRoot;
      domRoot.style.display = "none";
      var opts = this._opts;
      var root2 = this.root;
      width != null && (opts.width = width);
      height != null && (opts.height = height);
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      domRoot.style.display = "";
      if (this._width !== width || height !== this._height) {
        domRoot.style.width = width + "px";
        domRoot.style.height = height + "px";
        for (var id2 in this._layers) {
          if (this._layers.hasOwnProperty(id2)) {
            this._layers[id2].resize(width, height);
          }
        }
        this.refresh(true);
      }
      this._width = width;
      this._height = height;
    }
    return this;
  };
  CanvasPainter2.prototype.clearLayer = function(zlevel) {
    var layer = this._layers[zlevel];
    if (layer) {
      layer.clear();
    }
  };
  CanvasPainter2.prototype.dispose = function() {
    this.root.innerHTML = "";
    this.root = this.storage = this._domRoot = this._layers = null;
  };
  CanvasPainter2.prototype.getRenderedCanvas = function(opts) {
    opts = opts || {};
    if (this._singleCanvas && !this._compositeManually) {
      return this._layers[CANVAS_ZLEVEL].dom;
    }
    var imageLayer = new Layer$1("image", this, opts.pixelRatio || this.dpr);
    imageLayer.initContext();
    imageLayer.clear(false, opts.backgroundColor || this._backgroundColor);
    var ctx = imageLayer.ctx;
    if (opts.pixelRatio <= this.dpr) {
      this.refresh();
      var width_1 = imageLayer.dom.width;
      var height_1 = imageLayer.dom.height;
      this.eachLayer(function(layer) {
        if (layer.__builtin__) {
          ctx.drawImage(layer.dom, 0, 0, width_1, height_1);
        } else if (layer.renderToCanvas) {
          ctx.save();
          layer.renderToCanvas(ctx);
          ctx.restore();
        }
      });
    } else {
      var scope = {
        inHover: false,
        viewWidth: this._width,
        viewHeight: this._height
      };
      var displayList = this.storage.getDisplayList(true);
      for (var i = 0, len2 = displayList.length; i < len2; i++) {
        var el = displayList[i];
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    return imageLayer.dom;
  };
  CanvasPainter2.prototype.getWidth = function() {
    return this._width;
  };
  CanvasPainter2.prototype.getHeight = function() {
    return this._height;
  };
  return CanvasPainter2;
}();
var CanvasPainter$1 = CanvasPainter;
function install$R(registers) {
  registers.registerPainter("canvas", CanvasPainter$1);
}
var LineSeriesModel = function(_super) {
  __extends(LineSeriesModel2, _super);
  function LineSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LineSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  LineSeriesModel2.prototype.getInitialData = function(option) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  LineSeriesModel2.prototype.getLegendIcon = function(opt) {
    var group = new Group$4();
    var line = createSymbol$1("line", 0, opt.itemHeight / 2, opt.itemWidth, 0, opt.lineStyle.stroke, false);
    group.add(line);
    line.setStyle(opt.lineStyle);
    var visualType = this.getData().getVisual("symbol");
    var visualRotate = this.getData().getVisual("symbolRotate");
    var symbolType = visualType === "none" ? "circle" : visualType;
    var size = opt.itemHeight * 0.8;
    var symbol = createSymbol$1(symbolType, (opt.itemWidth - size) / 2, (opt.itemHeight - size) / 2, size, size, opt.itemStyle.fill);
    group.add(symbol);
    symbol.setStyle(opt.itemStyle);
    var symbolRotate = opt.iconRotate === "inherit" ? visualRotate : opt.iconRotate || 0;
    symbol.rotation = symbolRotate * Math.PI / 180;
    symbol.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
    if (symbolType.indexOf("empty") > -1) {
      symbol.style.stroke = symbol.style.fill;
      symbol.style.fill = "#fff";
      symbol.style.lineWidth = 2;
    }
    return group;
  };
  LineSeriesModel2.type = "series.line";
  LineSeriesModel2.dependencies = ["grid", "polar"];
  LineSeriesModel2.defaultOption = {
    z: 3,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    clip: true,
    label: {
      position: "top"
    },
    endLabel: {
      show: false,
      valueAnimation: true,
      distance: 8
    },
    lineStyle: {
      width: 2,
      type: "solid"
    },
    emphasis: {
      scale: true
    },
    step: false,
    smooth: false,
    smoothMonotone: null,
    symbol: "emptyCircle",
    symbolSize: 4,
    symbolRotate: null,
    showSymbol: true,
    showAllSymbol: "auto",
    connectNulls: false,
    sampling: "none",
    animationEasing: "linear",
    progressive: 0,
    hoverLayerThreshold: Infinity,
    universalTransition: {
      divideShape: "clone"
    },
    triggerLineEvent: false
  };
  return LineSeriesModel2;
}(SeriesModel$1);
var LineSeries = LineSeriesModel;
function getDefaultLabel(data, dataIndex) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  var len2 = labelDims.length;
  if (len2 === 1) {
    var rawVal = retrieveRawValue(data, dataIndex, labelDims[0]);
    return rawVal != null ? rawVal + "" : null;
  } else if (len2) {
    var vals = [];
    for (var i = 0; i < labelDims.length; i++) {
      vals.push(retrieveRawValue(data, dataIndex, labelDims[i]));
    }
    return vals.join(" ");
  }
}
function getDefaultInterpolatedLabel(data, interpolatedValue) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  if (!isArray$1(interpolatedValue)) {
    return interpolatedValue + "";
  }
  var vals = [];
  for (var i = 0; i < labelDims.length; i++) {
    var dimIndex = data.getDimensionIndex(labelDims[i]);
    if (dimIndex >= 0) {
      vals.push(interpolatedValue[dimIndex]);
    }
  }
  return vals.join(" ");
}
var Symbol$1 = function(_super) {
  __extends(Symbol2, _super);
  function Symbol2(data, idx, seriesScope, opts) {
    var _this = _super.call(this) || this;
    _this.updateData(data, idx, seriesScope, opts);
    return _this;
  }
  Symbol2.prototype._createSymbol = function(symbolType, data, idx, symbolSize, keepAspect) {
    this.removeAll();
    var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2, null, keepAspect);
    symbolPath.attr({
      z2: 100,
      culling: true,
      scaleX: symbolSize[0] / 2,
      scaleY: symbolSize[1] / 2
    });
    symbolPath.drift = driftSymbol;
    this._symbolType = symbolType;
    this.add(symbolPath);
  };
  Symbol2.prototype.stopSymbolAnimation = function(toLastFrame) {
    this.childAt(0).stopAnimation(null, toLastFrame);
  };
  Symbol2.prototype.getSymbolType = function() {
    return this._symbolType;
  };
  Symbol2.prototype.getSymbolPath = function() {
    return this.childAt(0);
  };
  Symbol2.prototype.highlight = function() {
    enterEmphasis(this.childAt(0));
  };
  Symbol2.prototype.downplay = function() {
    leaveEmphasis(this.childAt(0));
  };
  Symbol2.prototype.setZ = function(zlevel, z2) {
    var symbolPath = this.childAt(0);
    symbolPath.zlevel = zlevel;
    symbolPath.z = z2;
  };
  Symbol2.prototype.setDraggable = function(draggable) {
    var symbolPath = this.childAt(0);
    symbolPath.draggable = draggable;
    symbolPath.cursor = draggable ? "move" : symbolPath.cursor;
  };
  Symbol2.prototype.updateData = function(data, idx, seriesScope, opts) {
    this.silent = false;
    var symbolType = data.getItemVisual(idx, "symbol") || "circle";
    var seriesModel = data.hostModel;
    var symbolSize = Symbol2.getSymbolSize(data, idx);
    var isInit = symbolType !== this._symbolType;
    var disableAnimation = opts && opts.disableAnimation;
    if (isInit) {
      var keepAspect = data.getItemVisual(idx, "symbolKeepAspect");
      this._createSymbol(symbolType, data, idx, symbolSize, keepAspect);
    } else {
      var symbolPath = this.childAt(0);
      symbolPath.silent = false;
      var target = {
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2
      };
      disableAnimation ? symbolPath.attr(target) : updateProps$1(symbolPath, target, seriesModel, idx);
      saveOldStyle(symbolPath);
    }
    this._updateCommon(data, idx, symbolSize, seriesScope, opts);
    if (isInit) {
      var symbolPath = this.childAt(0);
      if (!disableAnimation) {
        var target = {
          scaleX: this._sizeX,
          scaleY: this._sizeY,
          style: {
            opacity: symbolPath.style.opacity
          }
        };
        symbolPath.scaleX = symbolPath.scaleY = 0;
        symbolPath.style.opacity = 0;
        initProps(symbolPath, target, seriesModel, idx);
      }
    }
    if (disableAnimation) {
      this.childAt(0).stopAnimation("leave");
    }
  };
  Symbol2.prototype._updateCommon = function(data, idx, symbolSize, seriesScope, opts) {
    var symbolPath = this.childAt(0);
    var seriesModel = data.hostModel;
    var emphasisItemStyle;
    var blurItemStyle;
    var selectItemStyle;
    var focus;
    var blurScope;
    var emphasisDisabled;
    var labelStatesModels;
    var hoverScale;
    var cursorStyle;
    if (seriesScope) {
      emphasisItemStyle = seriesScope.emphasisItemStyle;
      blurItemStyle = seriesScope.blurItemStyle;
      selectItemStyle = seriesScope.selectItemStyle;
      focus = seriesScope.focus;
      blurScope = seriesScope.blurScope;
      labelStatesModels = seriesScope.labelStatesModels;
      hoverScale = seriesScope.hoverScale;
      cursorStyle = seriesScope.cursorStyle;
      emphasisDisabled = seriesScope.emphasisDisabled;
    }
    if (!seriesScope || data.hasItemOption) {
      var itemModel = seriesScope && seriesScope.itemModel ? seriesScope.itemModel : data.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisItemStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      selectItemStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
      blurItemStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      emphasisDisabled = emphasisModel.get("disabled");
      labelStatesModels = getLabelStatesModels(itemModel);
      hoverScale = emphasisModel.getShallow("scale");
      cursorStyle = itemModel.getShallow("cursor");
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    symbolPath.attr("rotation", (symbolRotate || 0) * Math.PI / 180 || 0);
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      symbolPath.x = symbolOffset[0];
      symbolPath.y = symbolOffset[1];
    }
    cursorStyle && symbolPath.attr("cursor", cursorStyle);
    var symbolStyle = data.getItemVisual(idx, "style");
    var visualColor = symbolStyle.fill;
    if (symbolPath instanceof ZRImage$1) {
      var pathStyle = symbolPath.style;
      symbolPath.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolStyle));
    } else {
      if (symbolPath.__isEmptyBrush) {
        symbolPath.useStyle(extend({}, symbolStyle));
      } else {
        symbolPath.useStyle(symbolStyle);
      }
      symbolPath.style.decal = null;
      symbolPath.setColor(visualColor, opts && opts.symbolInnerColor);
      symbolPath.style.strokeNoScale = true;
    }
    var liftZ = data.getItemVisual(idx, "liftZ");
    var z2Origin = this._z2;
    if (liftZ != null) {
      if (z2Origin == null) {
        this._z2 = symbolPath.z2;
        symbolPath.z2 += liftZ;
      }
    } else if (z2Origin != null) {
      symbolPath.z2 = z2Origin;
      this._z2 = null;
    }
    var useNameLabel = opts && opts.useNameLabel;
    setLabelStyle(symbolPath, labelStatesModels, {
      labelFetcher: seriesModel,
      labelDataIndex: idx,
      defaultText: getLabelDefaultText,
      inheritColor: visualColor,
      defaultOpacity: symbolStyle.opacity
    });
    function getLabelDefaultText(idx2) {
      return useNameLabel ? data.getName(idx2) : getDefaultLabel(data, idx2);
    }
    this._sizeX = symbolSize[0] / 2;
    this._sizeY = symbolSize[1] / 2;
    var emphasisState = symbolPath.ensureState("emphasis");
    emphasisState.style = emphasisItemStyle;
    symbolPath.ensureState("select").style = selectItemStyle;
    symbolPath.ensureState("blur").style = blurItemStyle;
    if (hoverScale) {
      var scaleRatio = Math.max(1.1, 3 / this._sizeY);
      emphasisState.scaleX = this._sizeX * scaleRatio;
      emphasisState.scaleY = this._sizeY * scaleRatio;
    }
    this.setSymbolScale(1);
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Symbol2.prototype.setSymbolScale = function(scale2) {
    this.scaleX = this.scaleY = scale2;
  };
  Symbol2.prototype.fadeOut = function(cb, seriesModel, opt) {
    var symbolPath = this.childAt(0);
    var dataIndex = getECData(this).dataIndex;
    var animationOpt = opt && opt.animation;
    this.silent = symbolPath.silent = true;
    if (opt && opt.fadeLabel) {
      var textContent = symbolPath.getTextContent();
      if (textContent) {
        removeElement(textContent, {
          style: {
            opacity: 0
          }
        }, seriesModel, {
          dataIndex,
          removeOpt: animationOpt,
          cb: function() {
            symbolPath.removeTextContent();
          }
        });
      }
    } else {
      symbolPath.removeTextContent();
    }
    removeElement(symbolPath, {
      style: {
        opacity: 0
      },
      scaleX: 0,
      scaleY: 0
    }, seriesModel, {
      dataIndex,
      cb,
      removeOpt: animationOpt
    });
  };
  Symbol2.getSymbolSize = function(data, idx) {
    return normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
  };
  return Symbol2;
}(Group$4);
function driftSymbol(dx, dy) {
  this.parent.drift(dx, dy);
}
var SymbolClz = Symbol$1;
function symbolNeedsDraw$1(data, point, idx, opt) {
  return point && !isNaN(point[0]) && !isNaN(point[1]) && !(opt.isIgnore && opt.isIgnore(idx)) && !(opt.clipShape && !opt.clipShape.contain(point[0], point[1])) && data.getItemVisual(idx, "symbol") !== "none";
}
function normalizeUpdateOpt(opt) {
  if (opt != null && !isObject$4(opt)) {
    opt = {
      isIgnore: opt
    };
  }
  return opt || {};
}
function makeSeriesScope$2(data) {
  var seriesModel = data.hostModel;
  var emphasisModel = seriesModel.getModel("emphasis");
  return {
    emphasisItemStyle: emphasisModel.getModel("itemStyle").getItemStyle(),
    blurItemStyle: seriesModel.getModel(["blur", "itemStyle"]).getItemStyle(),
    selectItemStyle: seriesModel.getModel(["select", "itemStyle"]).getItemStyle(),
    focus: emphasisModel.get("focus"),
    blurScope: emphasisModel.get("blurScope"),
    emphasisDisabled: emphasisModel.get("disabled"),
    hoverScale: emphasisModel.get("scale"),
    labelStatesModels: getLabelStatesModels(seriesModel),
    cursorStyle: seriesModel.get("cursor")
  };
}
var SymbolDraw = function() {
  function SymbolDraw2(SymbolCtor) {
    this.group = new Group$4();
    this._SymbolCtor = SymbolCtor || SymbolClz;
  }
  SymbolDraw2.prototype.updateData = function(data, opt) {
    this._progressiveEls = null;
    opt = normalizeUpdateOpt(opt);
    var group = this.group;
    var seriesModel = data.hostModel;
    var oldData = this._data;
    var SymbolCtor = this._SymbolCtor;
    var disableAnimation = opt.disableAnimation;
    var seriesScope = makeSeriesScope$2(data);
    var symbolUpdateOpt = {
      disableAnimation
    };
    var getSymbolPoint = opt.getSymbolPoint || function(idx) {
      return data.getItemLayout(idx);
    };
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      var point = getSymbolPoint(newIdx);
      if (symbolNeedsDraw$1(data, point, newIdx, opt)) {
        var symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      var point = getSymbolPoint(newIdx);
      if (!symbolNeedsDraw$1(data, point, newIdx, opt)) {
        group.remove(symbolEl);
        return;
      }
      var newSymbolType = data.getItemVisual(newIdx, "symbol") || "circle";
      var oldSymbolType = symbolEl && symbolEl.getSymbolType && symbolEl.getSymbolType();
      if (!symbolEl || oldSymbolType && oldSymbolType !== newSymbolType) {
        group.remove(symbolEl);
        symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
      } else {
        symbolEl.updateData(data, newIdx, seriesScope, symbolUpdateOpt);
        var target = {
          x: point[0],
          y: point[1]
        };
        disableAnimation ? symbolEl.attr(target) : updateProps$1(symbolEl, target, seriesModel);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && el.fadeOut(function() {
        group.remove(el);
      }, seriesModel);
    }).execute();
    this._getSymbolPoint = getSymbolPoint;
    this._data = data;
  };
  SymbolDraw2.prototype.updateLayout = function() {
    var _this = this;
    var data = this._data;
    if (data) {
      data.eachItemGraphicEl(function(el, idx) {
        var point = _this._getSymbolPoint(idx);
        el.setPosition(point);
        el.markRedraw();
      });
    }
  };
  SymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._seriesScope = makeSeriesScope$2(data);
    this._data = null;
    this.group.removeAll();
  };
  SymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    this._progressiveEls = [];
    opt = normalizeUpdateOpt(opt);
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var point = data.getItemLayout(idx);
      if (symbolNeedsDraw$1(data, point, idx, opt)) {
        var el = new this._SymbolCtor(data, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        el.setPosition(point);
        this.group.add(el);
        data.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  SymbolDraw2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  SymbolDraw2.prototype.remove = function(enableAnimation) {
    var group = this.group;
    var data = this._data;
    if (data && enableAnimation) {
      data.eachItemGraphicEl(function(el) {
        el.fadeOut(function() {
          group.remove(el);
        }, data.hostModel);
      });
    } else {
      group.removeAll();
    }
  };
  return SymbolDraw2;
}();
var SymbolDraw$1 = SymbolDraw;
function prepareDataCoordInfo(coordSys, data, valueOrigin) {
  var baseAxis = coordSys.getBaseAxis();
  var valueAxis2 = coordSys.getOtherAxis(baseAxis);
  var valueStart = getValueStart(valueAxis2, valueOrigin);
  var baseAxisDim = baseAxis.dim;
  var valueAxisDim = valueAxis2.dim;
  var valueDim = data.mapDimension(valueAxisDim);
  var baseDim = data.mapDimension(baseAxisDim);
  var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
  var dims = map$1(coordSys.dimensions, function(coordDim) {
    return data.mapDimension(coordDim);
  });
  var stacked = false;
  var stackResultDim = data.getCalculationInfo("stackResultDimension");
  if (isDimensionStacked(data, dims[0])) {
    stacked = true;
    dims[0] = stackResultDim;
  }
  if (isDimensionStacked(data, dims[1])) {
    stacked = true;
    dims[1] = stackResultDim;
  }
  return {
    dataDimsForPoint: dims,
    valueStart,
    valueAxisDim,
    baseAxisDim,
    stacked: !!stacked,
    valueDim,
    baseDim,
    baseDataOffset,
    stackedOverDimension: data.getCalculationInfo("stackedOverDimension")
  };
}
function getValueStart(valueAxis2, valueOrigin) {
  var valueStart = 0;
  var extent3 = valueAxis2.scale.getExtent();
  if (valueOrigin === "start") {
    valueStart = extent3[0];
  } else if (valueOrigin === "end") {
    valueStart = extent3[1];
  } else {
    if (extent3[0] > 0) {
      valueStart = extent3[0];
    } else if (extent3[1] < 0) {
      valueStart = extent3[1];
    }
  }
  return valueStart;
}
function getStackedOnPoint(dataCoordInfo, coordSys, data, idx) {
  var value = NaN;
  if (dataCoordInfo.stacked) {
    value = data.get(data.getCalculationInfo("stackedOverDimension"), idx);
  }
  if (isNaN(value)) {
    value = dataCoordInfo.valueStart;
  }
  var baseDataOffset = dataCoordInfo.baseDataOffset;
  var stackedData = [];
  stackedData[baseDataOffset] = data.get(dataCoordInfo.baseDim, idx);
  stackedData[1 - baseDataOffset] = value;
  return coordSys.dataToPoint(stackedData);
}
function diffData(oldData, newData) {
  var diffResult = [];
  newData.diff(oldData).add(function(idx) {
    diffResult.push({
      cmd: "+",
      idx
    });
  }).update(function(newIdx, oldIdx) {
    diffResult.push({
      cmd: "=",
      idx: oldIdx,
      idx1: newIdx
    });
  }).remove(function(idx) {
    diffResult.push({
      cmd: "-",
      idx
    });
  }).execute();
  return diffResult;
}
function lineAnimationDiff(oldData, newData, oldStackedOnPoints, newStackedOnPoints, oldCoordSys, newCoordSys, oldValueOrigin, newValueOrigin) {
  var diff = diffData(oldData, newData);
  var currPoints = [];
  var nextPoints = [];
  var currStackedPoints = [];
  var nextStackedPoints = [];
  var status = [];
  var sortedIndices = [];
  var rawIndices = [];
  var newDataOldCoordInfo = prepareDataCoordInfo(oldCoordSys, newData, oldValueOrigin);
  var oldPoints = oldData.getLayout("points") || [];
  var newPoints = newData.getLayout("points") || [];
  for (var i = 0; i < diff.length; i++) {
    var diffItem = diff[i];
    var pointAdded = true;
    var oldIdx2 = void 0;
    var newIdx2 = void 0;
    switch (diffItem.cmd) {
      case "=":
        oldIdx2 = diffItem.idx * 2;
        newIdx2 = diffItem.idx1 * 2;
        var currentX = oldPoints[oldIdx2];
        var currentY = oldPoints[oldIdx2 + 1];
        var nextX = newPoints[newIdx2];
        var nextY = newPoints[newIdx2 + 1];
        if (isNaN(currentX) || isNaN(currentY)) {
          currentX = nextX;
          currentY = nextY;
        }
        currPoints.push(currentX, currentY);
        nextPoints.push(nextX, nextY);
        currStackedPoints.push(oldStackedOnPoints[oldIdx2], oldStackedOnPoints[oldIdx2 + 1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(diffItem.idx1));
        break;
      case "+":
        var newIdx = diffItem.idx;
        var newDataDimsForPoint = newDataOldCoordInfo.dataDimsForPoint;
        var oldPt = oldCoordSys.dataToPoint([newData.get(newDataDimsForPoint[0], newIdx), newData.get(newDataDimsForPoint[1], newIdx)]);
        newIdx2 = newIdx * 2;
        currPoints.push(oldPt[0], oldPt[1]);
        nextPoints.push(newPoints[newIdx2], newPoints[newIdx2 + 1]);
        var stackedOnPoint = getStackedOnPoint(newDataOldCoordInfo, oldCoordSys, newData, newIdx);
        currStackedPoints.push(stackedOnPoint[0], stackedOnPoint[1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(newIdx));
        break;
      case "-":
        pointAdded = false;
    }
    if (pointAdded) {
      status.push(diffItem);
      sortedIndices.push(sortedIndices.length);
    }
  }
  sortedIndices.sort(function(a, b2) {
    return rawIndices[a] - rawIndices[b2];
  });
  var len2 = currPoints.length;
  var sortedCurrPoints = createFloat32Array(len2);
  var sortedNextPoints = createFloat32Array(len2);
  var sortedCurrStackedPoints = createFloat32Array(len2);
  var sortedNextStackedPoints = createFloat32Array(len2);
  var sortedStatus = [];
  for (var i = 0; i < sortedIndices.length; i++) {
    var idx = sortedIndices[i];
    var i2 = i * 2;
    var idx2 = idx * 2;
    sortedCurrPoints[i2] = currPoints[idx2];
    sortedCurrPoints[i2 + 1] = currPoints[idx2 + 1];
    sortedNextPoints[i2] = nextPoints[idx2];
    sortedNextPoints[i2 + 1] = nextPoints[idx2 + 1];
    sortedCurrStackedPoints[i2] = currStackedPoints[idx2];
    sortedCurrStackedPoints[i2 + 1] = currStackedPoints[idx2 + 1];
    sortedNextStackedPoints[i2] = nextStackedPoints[idx2];
    sortedNextStackedPoints[i2 + 1] = nextStackedPoints[idx2 + 1];
    sortedStatus[i] = status[idx];
  }
  return {
    current: sortedCurrPoints,
    next: sortedNextPoints,
    stackedOnCurrent: sortedCurrStackedPoints,
    stackedOnNext: sortedNextStackedPoints,
    status: sortedStatus
  };
}
var mathMin$5 = Math.min;
var mathMax$5 = Math.max;
function isPointNull$1(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function drawSegment(ctx, points2, start2, segLen, allLen, dir3, smooth, smoothMonotone, connectNulls) {
  var prevX;
  var prevY;
  var cpx0;
  var cpy0;
  var cpx1;
  var cpy1;
  var idx = start2;
  var k2 = 0;
  for (; k2 < segLen; k2++) {
    var x2 = points2[idx * 2];
    var y2 = points2[idx * 2 + 1];
    if (idx >= allLen || idx < 0) {
      break;
    }
    if (isPointNull$1(x2, y2)) {
      if (connectNulls) {
        idx += dir3;
        continue;
      }
      break;
    }
    if (idx === start2) {
      ctx[dir3 > 0 ? "moveTo" : "lineTo"](x2, y2);
      cpx0 = x2;
      cpy0 = y2;
    } else {
      var dx = x2 - prevX;
      var dy = y2 - prevY;
      if (dx * dx + dy * dy < 0.5) {
        idx += dir3;
        continue;
      }
      if (smooth > 0) {
        var nextIdx = idx + dir3;
        var nextX = points2[nextIdx * 2];
        var nextY = points2[nextIdx * 2 + 1];
        while (nextX === x2 && nextY === y2 && k2 < segLen) {
          k2++;
          nextIdx += dir3;
          idx += dir3;
          nextX = points2[nextIdx * 2];
          nextY = points2[nextIdx * 2 + 1];
          x2 = points2[idx * 2];
          y2 = points2[idx * 2 + 1];
          dx = x2 - prevX;
          dy = y2 - prevY;
        }
        var tmpK = k2 + 1;
        if (connectNulls) {
          while (isPointNull$1(nextX, nextY) && tmpK < segLen) {
            tmpK++;
            nextIdx += dir3;
            nextX = points2[nextIdx * 2];
            nextY = points2[nextIdx * 2 + 1];
          }
        }
        var ratioNextSeg = 0.5;
        var vx = 0;
        var vy = 0;
        var nextCpx0 = void 0;
        var nextCpy0 = void 0;
        if (tmpK >= segLen || isPointNull$1(nextX, nextY)) {
          cpx1 = x2;
          cpy1 = y2;
        } else {
          vx = nextX - prevX;
          vy = nextY - prevY;
          var dx0 = x2 - prevX;
          var dx1 = nextX - x2;
          var dy0 = y2 - prevY;
          var dy1 = nextY - y2;
          var lenPrevSeg = void 0;
          var lenNextSeg = void 0;
          if (smoothMonotone === "x") {
            lenPrevSeg = Math.abs(dx0);
            lenNextSeg = Math.abs(dx1);
            var dir_1 = vx > 0 ? 1 : -1;
            cpx1 = x2 - dir_1 * lenPrevSeg * smooth;
            cpy1 = y2;
            nextCpx0 = x2 + dir_1 * lenNextSeg * smooth;
            nextCpy0 = y2;
          } else if (smoothMonotone === "y") {
            lenPrevSeg = Math.abs(dy0);
            lenNextSeg = Math.abs(dy1);
            var dir_2 = vy > 0 ? 1 : -1;
            cpx1 = x2;
            cpy1 = y2 - dir_2 * lenPrevSeg * smooth;
            nextCpx0 = x2;
            nextCpy0 = y2 + dir_2 * lenNextSeg * smooth;
          } else {
            lenPrevSeg = Math.sqrt(dx0 * dx0 + dy0 * dy0);
            lenNextSeg = Math.sqrt(dx1 * dx1 + dy1 * dy1);
            ratioNextSeg = lenNextSeg / (lenNextSeg + lenPrevSeg);
            cpx1 = x2 - vx * smooth * (1 - ratioNextSeg);
            cpy1 = y2 - vy * smooth * (1 - ratioNextSeg);
            nextCpx0 = x2 + vx * smooth * ratioNextSeg;
            nextCpy0 = y2 + vy * smooth * ratioNextSeg;
            nextCpx0 = mathMin$5(nextCpx0, mathMax$5(nextX, x2));
            nextCpy0 = mathMin$5(nextCpy0, mathMax$5(nextY, y2));
            nextCpx0 = mathMax$5(nextCpx0, mathMin$5(nextX, x2));
            nextCpy0 = mathMax$5(nextCpy0, mathMin$5(nextY, y2));
            vx = nextCpx0 - x2;
            vy = nextCpy0 - y2;
            cpx1 = x2 - vx * lenPrevSeg / lenNextSeg;
            cpy1 = y2 - vy * lenPrevSeg / lenNextSeg;
            cpx1 = mathMin$5(cpx1, mathMax$5(prevX, x2));
            cpy1 = mathMin$5(cpy1, mathMax$5(prevY, y2));
            cpx1 = mathMax$5(cpx1, mathMin$5(prevX, x2));
            cpy1 = mathMax$5(cpy1, mathMin$5(prevY, y2));
            vx = x2 - cpx1;
            vy = y2 - cpy1;
            nextCpx0 = x2 + vx * lenNextSeg / lenPrevSeg;
            nextCpy0 = y2 + vy * lenNextSeg / lenPrevSeg;
          }
        }
        ctx.bezierCurveTo(cpx0, cpy0, cpx1, cpy1, x2, y2);
        cpx0 = nextCpx0;
        cpy0 = nextCpy0;
      } else {
        ctx.lineTo(x2, y2);
      }
    }
    prevX = x2;
    prevY = y2;
    idx += dir3;
  }
  return k2;
}
var ECPolylineShape = function() {
  function ECPolylineShape2() {
    this.smooth = 0;
    this.smoothConstraint = true;
  }
  return ECPolylineShape2;
}();
var ECPolyline = function(_super) {
  __extends(ECPolyline2, _super);
  function ECPolyline2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polyline";
    return _this;
  }
  ECPolyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECPolyline2.prototype.getDefaultShape = function() {
    return new ECPolylineShape();
  };
  ECPolyline2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var i = 0;
    var len2 = points2.length / 2;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      i += drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, shape.smoothMonotone, shape.connectNulls) + 1;
    }
  };
  ECPolyline2.prototype.getPointOn = function(xOrY, dim) {
    if (!this.path) {
      this.createPathProxy();
      this.buildPath(this.path, this.shape);
    }
    var path = this.path;
    var data = path.data;
    var CMD2 = PathProxy$1.CMD;
    var x0;
    var y0;
    var isDimX = dim === "x";
    var roots2 = [];
    for (var i = 0; i < data.length; ) {
      var cmd = data[i++];
      var x2 = void 0;
      var y2 = void 0;
      var x22 = void 0;
      var y22 = void 0;
      var x3 = void 0;
      var y3 = void 0;
      var t2 = void 0;
      switch (cmd) {
        case CMD2.M:
          x0 = data[i++];
          y0 = data[i++];
          break;
        case CMD2.L:
          x2 = data[i++];
          y2 = data[i++];
          t2 = isDimX ? (xOrY - x0) / (x2 - x0) : (xOrY - y0) / (y2 - y0);
          if (t2 <= 1 && t2 >= 0) {
            var val = isDimX ? (y2 - y0) * t2 + y0 : (x2 - x0) * t2 + x0;
            return isDimX ? [xOrY, val] : [val, xOrY];
          }
          x0 = x2;
          y0 = y2;
          break;
        case CMD2.C:
          x2 = data[i++];
          y2 = data[i++];
          x22 = data[i++];
          y22 = data[i++];
          x3 = data[i++];
          y3 = data[i++];
          var nRoot = isDimX ? cubicRootAt(x0, x2, x22, x3, xOrY, roots2) : cubicRootAt(y0, y2, y22, y3, xOrY, roots2);
          if (nRoot > 0) {
            for (var i_1 = 0; i_1 < nRoot; i_1++) {
              var t_1 = roots2[i_1];
              if (t_1 <= 1 && t_1 >= 0) {
                var val = isDimX ? cubicAt(y0, y2, y22, y3, t_1) : cubicAt(x0, x2, x22, x3, t_1);
                return isDimX ? [xOrY, val] : [val, xOrY];
              }
            }
          }
          x0 = x3;
          y0 = y3;
          break;
      }
    }
  };
  return ECPolyline2;
}(Path$1);
var ECPolygonShape = function(_super) {
  __extends(ECPolygonShape2, _super);
  function ECPolygonShape2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return ECPolygonShape2;
}(ECPolylineShape);
var ECPolygon = function(_super) {
  __extends(ECPolygon2, _super);
  function ECPolygon2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polygon";
    return _this;
  }
  ECPolygon2.prototype.getDefaultShape = function() {
    return new ECPolygonShape();
  };
  ECPolygon2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var stackedOnPoints = shape.stackedOnPoints;
    var i = 0;
    var len2 = points2.length / 2;
    var smoothMonotone = shape.smoothMonotone;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      var k2 = drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, smoothMonotone, shape.connectNulls);
      drawSegment(ctx, stackedOnPoints, i + k2 - 1, k2, len2, -1, shape.stackedOnSmooth, smoothMonotone, shape.connectNulls);
      i += k2 + 1;
      ctx.closePath();
    }
  };
  return ECPolygon2;
}(Path$1);
function createGridClipPath(cartesian, hasAnimation, seriesModel, done, during) {
  var rect = cartesian.getArea();
  var x2 = rect.x;
  var y2 = rect.y;
  var width = rect.width;
  var height = rect.height;
  var lineWidth = seriesModel.get(["lineStyle", "width"]) || 2;
  x2 -= lineWidth / 2;
  y2 -= lineWidth / 2;
  width += lineWidth;
  height += lineWidth;
  x2 = Math.floor(x2);
  width = Math.round(width);
  var clipPath = new Rect$3({
    shape: {
      x: x2,
      y: y2,
      width,
      height
    }
  });
  if (hasAnimation) {
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var isAxisInversed = baseAxis.inverse;
    if (isHorizontal) {
      if (isAxisInversed) {
        clipPath.shape.x += width;
      }
      clipPath.shape.width = 0;
    } else {
      if (!isAxisInversed) {
        clipPath.shape.y += height;
      }
      clipPath.shape.height = 0;
    }
    var duringCb = isFunction(during) ? function(percent) {
      during(percent, clipPath);
    } : null;
    initProps(clipPath, {
      shape: {
        width,
        height,
        x: x2,
        y: y2
      }
    }, seriesModel, null, done, duringCb);
  }
  return clipPath;
}
function createPolarClipPath(polar, hasAnimation, seriesModel) {
  var sectorArea = polar.getArea();
  var r0 = round$3(sectorArea.r0, 1);
  var r2 = round$3(sectorArea.r, 1);
  var clipPath = new Sector$1({
    shape: {
      cx: round$3(polar.cx, 1),
      cy: round$3(polar.cy, 1),
      r0,
      r: r2,
      startAngle: sectorArea.startAngle,
      endAngle: sectorArea.endAngle,
      clockwise: sectorArea.clockwise
    }
  });
  if (hasAnimation) {
    var isRadial = polar.getBaseAxis().dim === "angle";
    if (isRadial) {
      clipPath.shape.endAngle = sectorArea.startAngle;
    } else {
      clipPath.shape.r = r0;
    }
    initProps(clipPath, {
      shape: {
        endAngle: sectorArea.endAngle,
        r: r2
      }
    }, seriesModel);
  }
  return clipPath;
}
function createClipPath(coordSys, hasAnimation, seriesModel, done, during) {
  if (!coordSys) {
    return null;
  } else if (coordSys.type === "polar") {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  } else if (coordSys.type === "cartesian2d") {
    return createGridClipPath(coordSys, hasAnimation, seriesModel, done, during);
  }
  return null;
}
function isCoordinateSystemType(coordSys, type4) {
  return coordSys.type === type4;
}
function isPointsSame(points1, points2) {
  if (points1.length !== points2.length) {
    return;
  }
  for (var i = 0; i < points1.length; i++) {
    if (points1[i] !== points2[i]) {
      return;
    }
  }
  return true;
}
function bboxFromPoints(points2) {
  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;
  for (var i = 0; i < points2.length; ) {
    var x2 = points2[i++];
    var y2 = points2[i++];
    if (!isNaN(x2)) {
      minX = Math.min(x2, minX);
      maxX = Math.max(x2, maxX);
    }
    if (!isNaN(y2)) {
      minY = Math.min(y2, minY);
      maxY = Math.max(y2, maxY);
    }
  }
  return [[minX, minY], [maxX, maxY]];
}
function getBoundingDiff(points1, points2) {
  var _a2 = bboxFromPoints(points1), min1 = _a2[0], max1 = _a2[1];
  var _b2 = bboxFromPoints(points2), min22 = _b2[0], max22 = _b2[1];
  return Math.max(Math.abs(min1[0] - min22[0]), Math.abs(min1[1] - min22[1]), Math.abs(max1[0] - max22[0]), Math.abs(max1[1] - max22[1]));
}
function getSmooth(smooth) {
  return isNumber(smooth) ? smooth : smooth ? 0.5 : 0;
}
function getStackedOnPoints(coordSys, data, dataCoordInfo) {
  if (!dataCoordInfo.valueDim) {
    return [];
  }
  var len2 = data.count();
  var points2 = createFloat32Array(len2 * 2);
  for (var idx = 0; idx < len2; idx++) {
    var pt = getStackedOnPoint(dataCoordInfo, coordSys, data, idx);
    points2[idx * 2] = pt[0];
    points2[idx * 2 + 1] = pt[1];
  }
  return points2;
}
function turnPointsIntoStep(points2, coordSys, stepTurnAt, connectNulls) {
  var baseAxis = coordSys.getBaseAxis();
  var baseIndex = baseAxis.dim === "x" || baseAxis.dim === "radius" ? 0 : 1;
  var stepPoints = [];
  var i = 0;
  var stepPt = [];
  var pt = [];
  var nextPt = [];
  var filteredPoints = [];
  if (connectNulls) {
    for (i = 0; i < points2.length; i += 2) {
      if (!isNaN(points2[i]) && !isNaN(points2[i + 1])) {
        filteredPoints.push(points2[i], points2[i + 1]);
      }
    }
    points2 = filteredPoints;
  }
  for (i = 0; i < points2.length - 2; i += 2) {
    nextPt[0] = points2[i + 2];
    nextPt[1] = points2[i + 3];
    pt[0] = points2[i];
    pt[1] = points2[i + 1];
    stepPoints.push(pt[0], pt[1]);
    switch (stepTurnAt) {
      case "end":
        stepPt[baseIndex] = nextPt[baseIndex];
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        break;
      case "middle":
        var middle = (pt[baseIndex] + nextPt[baseIndex]) / 2;
        var stepPt2 = [];
        stepPt[baseIndex] = stepPt2[baseIndex] = middle;
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPt2[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        stepPoints.push(stepPt2[0], stepPt2[1]);
        break;
      default:
        stepPt[baseIndex] = pt[baseIndex];
        stepPt[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
    }
  }
  stepPoints.push(points2[i++], points2[i++]);
  return stepPoints;
}
function clipColorStops(colorStops, maxSize) {
  var newColorStops = [];
  var len2 = colorStops.length;
  var prevOutOfRangeColorStop;
  var prevInRangeColorStop;
  function lerpStop(stop0, stop1, clippedCoord) {
    var coord0 = stop0.coord;
    var p2 = (clippedCoord - coord0) / (stop1.coord - coord0);
    var color = lerp(p2, [stop0.color, stop1.color]);
    return {
      coord: clippedCoord,
      color
    };
  }
  for (var i = 0; i < len2; i++) {
    var stop_1 = colorStops[i];
    var coord = stop_1.coord;
    if (coord < 0) {
      prevOutOfRangeColorStop = stop_1;
    } else if (coord > maxSize) {
      if (prevInRangeColorStop) {
        newColorStops.push(lerpStop(prevInRangeColorStop, stop_1, maxSize));
      } else if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0), lerpStop(prevOutOfRangeColorStop, stop_1, maxSize));
      }
      break;
    } else {
      if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0));
        prevOutOfRangeColorStop = null;
      }
      newColorStops.push(stop_1);
      prevInRangeColorStop = stop_1;
    }
  }
  return newColorStops;
}
function getVisualGradient(data, coordSys, api) {
  var visualMetaList = data.getVisual("visualMeta");
  if (!visualMetaList || !visualMetaList.length || !data.count()) {
    return;
  }
  if (coordSys.type !== "cartesian2d") {
    return;
  }
  var coordDim;
  var visualMeta;
  for (var i = visualMetaList.length - 1; i >= 0; i--) {
    var dimInfo = data.getDimensionInfo(visualMetaList[i].dimension);
    coordDim = dimInfo && dimInfo.coordDim;
    if (coordDim === "x" || coordDim === "y") {
      visualMeta = visualMetaList[i];
      break;
    }
  }
  if (!visualMeta) {
    return;
  }
  var axis = coordSys.getAxis(coordDim);
  var colorStops = map$1(visualMeta.stops, function(stop2) {
    return {
      coord: axis.toGlobalCoord(axis.dataToCoord(stop2.value)),
      color: stop2.color
    };
  });
  var stopLen = colorStops.length;
  var outerColors = visualMeta.outerColors.slice();
  if (stopLen && colorStops[0].coord > colorStops[stopLen - 1].coord) {
    colorStops.reverse();
    outerColors.reverse();
  }
  var colorStopsInRange = clipColorStops(colorStops, coordDim === "x" ? api.getWidth() : api.getHeight());
  var inRangeStopLen = colorStopsInRange.length;
  if (!inRangeStopLen && stopLen) {
    return colorStops[0].coord < 0 ? outerColors[1] ? outerColors[1] : colorStops[stopLen - 1].color : outerColors[0] ? outerColors[0] : colorStops[0].color;
  }
  var tinyExtent = 10;
  var minCoord = colorStopsInRange[0].coord - tinyExtent;
  var maxCoord = colorStopsInRange[inRangeStopLen - 1].coord + tinyExtent;
  var coordSpan = maxCoord - minCoord;
  if (coordSpan < 1e-3) {
    return "transparent";
  }
  each$f(colorStopsInRange, function(stop2) {
    stop2.offset = (stop2.coord - minCoord) / coordSpan;
  });
  colorStopsInRange.push({
    offset: inRangeStopLen ? colorStopsInRange[inRangeStopLen - 1].offset : 0.5,
    color: outerColors[1] || "transparent"
  });
  colorStopsInRange.unshift({
    offset: inRangeStopLen ? colorStopsInRange[0].offset : 0.5,
    color: outerColors[0] || "transparent"
  });
  var gradient = new LinearGradient$1(0, 0, 0, 0, colorStopsInRange, true);
  gradient[coordDim] = minCoord;
  gradient[coordDim + "2"] = maxCoord;
  return gradient;
}
function getIsIgnoreFunc(seriesModel, data, coordSys) {
  var showAllSymbol = seriesModel.get("showAllSymbol");
  var isAuto = showAllSymbol === "auto";
  if (showAllSymbol && !isAuto) {
    return;
  }
  var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
  if (!categoryAxis2) {
    return;
  }
  if (isAuto && canShowAllSymbolForCategory(categoryAxis2, data)) {
    return;
  }
  var categoryDataDim = data.mapDimension(categoryAxis2.dim);
  var labelMap = {};
  each$f(categoryAxis2.getViewLabels(), function(labelItem) {
    var ordinalNumber = categoryAxis2.scale.getRawOrdinalNumber(labelItem.tickValue);
    labelMap[ordinalNumber] = 1;
  });
  return function(dataIndex) {
    return !labelMap.hasOwnProperty(data.get(categoryDataDim, dataIndex));
  };
}
function canShowAllSymbolForCategory(categoryAxis2, data) {
  var axisExtent = categoryAxis2.getExtent();
  var availSize = Math.abs(axisExtent[1] - axisExtent[0]) / categoryAxis2.scale.count();
  isNaN(availSize) && (availSize = 0);
  var dataLen = data.count();
  var step = Math.max(1, Math.round(dataLen / 5));
  for (var dataIndex = 0; dataIndex < dataLen; dataIndex += step) {
    if (SymbolClz.getSymbolSize(data, dataIndex)[categoryAxis2.isHorizontal() ? 1 : 0] * 1.5 > availSize) {
      return false;
    }
  }
  return true;
}
function isPointNull(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function getLastIndexNotNull(points2) {
  var len2 = points2.length / 2;
  for (; len2 > 0; len2--) {
    if (!isPointNull(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
      break;
    }
  }
  return len2 - 1;
}
function getPointAtIndex(points2, idx) {
  return [points2[idx * 2], points2[idx * 2 + 1]];
}
function getIndexRange(points2, xOrY, dim) {
  var len2 = points2.length / 2;
  var dimIdx = dim === "x" ? 0 : 1;
  var a;
  var b2;
  var prevIndex = 0;
  var nextIndex = -1;
  for (var i = 0; i < len2; i++) {
    b2 = points2[i * 2 + dimIdx];
    if (isNaN(b2) || isNaN(points2[i * 2 + 1 - dimIdx])) {
      continue;
    }
    if (i === 0) {
      a = b2;
      continue;
    }
    if (a <= xOrY && b2 >= xOrY || a >= xOrY && b2 <= xOrY) {
      nextIndex = i;
      break;
    }
    prevIndex = i;
    a = b2;
  }
  return {
    range: [prevIndex, nextIndex],
    t: (xOrY - a) / (b2 - a)
  };
}
function anyStateShowEndLabel(seriesModel) {
  if (seriesModel.get(["endLabel", "show"])) {
    return true;
  }
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    if (seriesModel.get([SPECIAL_STATES[i], "endLabel", "show"])) {
      return true;
    }
  }
  return false;
}
function createLineClipPath(lineView, coordSys, hasAnimation, seriesModel) {
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    var endLabelModel_1 = seriesModel.getModel("endLabel");
    var valueAnimation_1 = endLabelModel_1.get("valueAnimation");
    var data_1 = seriesModel.getData();
    var labelAnimationRecord_1 = {
      lastFrameIndex: 0
    };
    var during = anyStateShowEndLabel(seriesModel) ? function(percent, clipRect) {
      lineView._endLabelOnDuring(percent, clipRect, data_1, labelAnimationRecord_1, valueAnimation_1, endLabelModel_1, coordSys);
    } : null;
    var isHorizontal = coordSys.getBaseAxis().isHorizontal();
    var clipPath = createGridClipPath(coordSys, hasAnimation, seriesModel, function() {
      var endLabel = lineView._endLabel;
      if (endLabel && hasAnimation) {
        if (labelAnimationRecord_1.originalX != null) {
          endLabel.attr({
            x: labelAnimationRecord_1.originalX,
            y: labelAnimationRecord_1.originalY
          });
        }
      }
    }, during);
    if (!seriesModel.get("clip", true)) {
      var rectShape = clipPath.shape;
      var expandSize = Math.max(rectShape.width, rectShape.height);
      if (isHorizontal) {
        rectShape.y -= expandSize;
        rectShape.height += expandSize * 2;
      } else {
        rectShape.x -= expandSize;
        rectShape.width += expandSize * 2;
      }
    }
    if (during) {
      during(1, clipPath);
    }
    return clipPath;
  } else {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  }
}
function getEndLabelStateSpecified(endLabelModel, coordSys) {
  var baseAxis = coordSys.getBaseAxis();
  var isHorizontal = baseAxis.isHorizontal();
  var isBaseInversed = baseAxis.inverse;
  var align = isHorizontal ? isBaseInversed ? "right" : "left" : "center";
  var verticalAlign = isHorizontal ? "middle" : isBaseInversed ? "top" : "bottom";
  return {
    normal: {
      align: endLabelModel.get("align") || align,
      verticalAlign: endLabelModel.get("verticalAlign") || verticalAlign
    }
  };
}
var LineView = function(_super) {
  __extends(LineView2, _super);
  function LineView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  LineView2.prototype.init = function() {
    var lineGroup = new Group$4();
    var symbolDraw = new SymbolDraw$1();
    this.group.add(symbolDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineGroup = lineGroup;
  };
  LineView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var lineStyleModel = seriesModel.getModel("lineStyle");
    var areaStyleModel = seriesModel.getModel("areaStyle");
    var points2 = data.getLayout("points") || [];
    var isCoordSysPolar = coordSys.type === "polar";
    var prevCoordSys = this._coordSys;
    var symbolDraw = this._symbolDraw;
    var polyline = this._polyline;
    var polygon = this._polygon;
    var lineGroup = this._lineGroup;
    var hasAnimation = seriesModel.get("animation");
    var isAreaChart = !areaStyleModel.isEmpty();
    var valueOrigin = areaStyleModel.get("origin");
    var dataCoordInfo = prepareDataCoordInfo(coordSys, data, valueOrigin);
    var stackedOnPoints = isAreaChart && getStackedOnPoints(coordSys, data, dataCoordInfo);
    var showSymbol = seriesModel.get("showSymbol");
    var connectNulls = seriesModel.get("connectNulls");
    var isIgnoreFunc = showSymbol && !isCoordSysPolar && getIsIgnoreFunc(seriesModel, data, coordSys);
    var oldData = this._data;
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    if (!showSymbol) {
      symbolDraw.remove();
    }
    group.add(lineGroup);
    var step = !isCoordSysPolar ? seriesModel.get("step") : false;
    var clipShapeForSymbol;
    if (coordSys && coordSys.getArea && seriesModel.get("clip", true)) {
      clipShapeForSymbol = coordSys.getArea();
      if (clipShapeForSymbol.width != null) {
        clipShapeForSymbol.x -= 0.1;
        clipShapeForSymbol.y -= 0.1;
        clipShapeForSymbol.width += 0.2;
        clipShapeForSymbol.height += 0.2;
      } else if (clipShapeForSymbol.r0) {
        clipShapeForSymbol.r0 -= 0.5;
        clipShapeForSymbol.r += 0.5;
      }
    }
    this._clipShapeForSymbol = clipShapeForSymbol;
    var visualColor = getVisualGradient(data, coordSys, api) || data.getVisual("style")[data.getVisual("drawType")];
    if (!(polyline && prevCoordSys.type === coordSys.type && step === this._step)) {
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      hasAnimation && this._initSymbolLabelAnimation(data, coordSys, clipShapeForSymbol);
      if (step) {
        points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
        if (stackedOnPoints) {
          stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
        }
      }
      polyline = this._newPolyline(points2);
      if (isAreaChart) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
    } else {
      if (isAreaChart && !polygon) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      } else if (polygon && !isAreaChart) {
        lineGroup.remove(polygon);
        polygon = this._polygon = null;
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      var oldClipPath = lineGroup.getClipPath();
      if (oldClipPath) {
        var newClipPath = createLineClipPath(this, coordSys, false, seriesModel);
        initProps(oldClipPath, {
          shape: newClipPath.shape
        }, seriesModel);
      } else {
        lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
      }
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      if (!isPointsSame(this._stackedOnPoints, stackedOnPoints) || !isPointsSame(this._points, points2)) {
        if (hasAnimation) {
          this._doUpdateAnimation(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls);
        } else {
          if (step) {
            points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
            if (stackedOnPoints) {
              stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
            }
          }
          polyline.setShape({
            points: points2
          });
          polygon && polygon.setShape({
            points: points2,
            stackedOnPoints
          });
        }
      }
    }
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    polyline.useStyle(defaults(lineStyleModel.getLineStyle(), {
      fill: "none",
      stroke: visualColor,
      lineJoin: "bevel"
    }));
    setStatesStylesFromModel(polyline, seriesModel, "lineStyle");
    if (polyline.style.lineWidth > 0 && seriesModel.get(["emphasis", "lineStyle", "width"]) === "bolder") {
      var emphasisLineStyle = polyline.getState("emphasis").style;
      emphasisLineStyle.lineWidth = +polyline.style.lineWidth + 1;
    }
    getECData(polyline).seriesIndex = seriesModel.seriesIndex;
    toggleHoverEmphasis(polyline, focus, blurScope, emphasisDisabled);
    var smooth = getSmooth(seriesModel.get("smooth"));
    var smoothMonotone = seriesModel.get("smoothMonotone");
    polyline.setShape({
      smooth,
      smoothMonotone,
      connectNulls
    });
    if (polygon) {
      var stackedOnSeries = data.getCalculationInfo("stackedOnSeries");
      var stackedOnSmooth = 0;
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: visualColor,
        opacity: 0.7,
        lineJoin: "bevel",
        decal: data.getVisual("style").decal
      }));
      if (stackedOnSeries) {
        stackedOnSmooth = getSmooth(stackedOnSeries.get("smooth"));
      }
      polygon.setShape({
        smooth,
        stackedOnSmooth,
        smoothMonotone,
        connectNulls
      });
      setStatesStylesFromModel(polygon, seriesModel, "areaStyle");
      getECData(polygon).seriesIndex = seriesModel.seriesIndex;
      toggleHoverEmphasis(polygon, focus, blurScope, emphasisDisabled);
    }
    var changePolyState = function(toState) {
      _this._changePolyState(toState);
    };
    data.eachItemGraphicEl(function(el) {
      el && (el.onHoverStateChange = changePolyState);
    });
    this._polyline.onHoverStateChange = changePolyState;
    this._data = data;
    this._coordSys = coordSys;
    this._stackedOnPoints = stackedOnPoints;
    this._points = points2;
    this._step = step;
    this._valueOrigin = valueOrigin;
    if (seriesModel.get("triggerLineEvent")) {
      this.packEventData(seriesModel, polyline);
      polygon && this.packEventData(seriesModel, polygon);
    }
  };
  LineView2.prototype.packEventData = function(seriesModel, el) {
    getECData(el).eventData = {
      componentType: "series",
      componentSubType: "line",
      componentIndex: seriesModel.componentIndex,
      seriesIndex: seriesModel.seriesIndex,
      seriesName: seriesModel.name,
      seriesType: "line"
    };
  };
  LineView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("emphasis");
    if (!(dataIndex instanceof Array) && dataIndex != null && dataIndex >= 0) {
      var points2 = data.getLayout("points");
      var symbol = data.getItemGraphicEl(dataIndex);
      if (!symbol) {
        var x2 = points2[dataIndex * 2];
        var y2 = points2[dataIndex * 2 + 1];
        if (isNaN(x2) || isNaN(y2)) {
          return;
        }
        if (this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(x2, y2)) {
          return;
        }
        var zlevel = seriesModel.get("zlevel");
        var z2 = seriesModel.get("z");
        symbol = new SymbolClz(data, dataIndex);
        symbol.x = x2;
        symbol.y = y2;
        symbol.setZ(zlevel, z2);
        var symbolLabel = symbol.getSymbolPath().getTextContent();
        if (symbolLabel) {
          symbolLabel.zlevel = zlevel;
          symbolLabel.z = z2;
          symbolLabel.z2 = this._polyline.z2 + 1;
        }
        symbol.__temp = true;
        data.setItemGraphicEl(dataIndex, symbol);
        symbol.stopSymbolAnimation(true);
        this.group.add(symbol);
      }
      symbol.highlight();
    } else {
      ChartView$1.prototype.highlight.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("normal");
    if (dataIndex != null && dataIndex >= 0) {
      var symbol = data.getItemGraphicEl(dataIndex);
      if (symbol) {
        if (symbol.__temp) {
          data.setItemGraphicEl(dataIndex, null);
          this.group.remove(symbol);
        } else {
          symbol.downplay();
        }
      }
    } else {
      ChartView$1.prototype.downplay.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype._changePolyState = function(toState) {
    var polygon = this._polygon;
    setStatesFlag(this._polyline, toState);
    polygon && setStatesFlag(polygon, toState);
  };
  LineView2.prototype._newPolyline = function(points2) {
    var polyline = this._polyline;
    if (polyline) {
      this._lineGroup.remove(polyline);
    }
    polyline = new ECPolyline({
      shape: {
        points: points2
      },
      segmentIgnoreThreshold: 2,
      z2: 10
    });
    this._lineGroup.add(polyline);
    this._polyline = polyline;
    return polyline;
  };
  LineView2.prototype._newPolygon = function(points2, stackedOnPoints) {
    var polygon = this._polygon;
    if (polygon) {
      this._lineGroup.remove(polygon);
    }
    polygon = new ECPolygon({
      shape: {
        points: points2,
        stackedOnPoints
      },
      segmentIgnoreThreshold: 2
    });
    this._lineGroup.add(polygon);
    this._polygon = polygon;
    return polygon;
  };
  LineView2.prototype._initSymbolLabelAnimation = function(data, coordSys, clipShape) {
    var isHorizontalOrRadial;
    var isCoordSysPolar;
    var baseAxis = coordSys.getBaseAxis();
    var isAxisInverse = baseAxis.inverse;
    if (coordSys.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
      isCoordSysPolar = false;
    } else if (coordSys.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
      isCoordSysPolar = true;
    }
    var seriesModel = data.hostModel;
    var seriesDuration = seriesModel.get("animationDuration");
    if (isFunction(seriesDuration)) {
      seriesDuration = seriesDuration(null);
    }
    var seriesDalay = seriesModel.get("animationDelay") || 0;
    var seriesDalayValue = isFunction(seriesDalay) ? seriesDalay(null) : seriesDalay;
    data.eachItemGraphicEl(function(symbol, idx) {
      var el = symbol;
      if (el) {
        var point = [symbol.x, symbol.y];
        var start2 = void 0;
        var end2 = void 0;
        var current = void 0;
        if (clipShape) {
          if (isCoordSysPolar) {
            var polarClip = clipShape;
            var coord = coordSys.pointToCoord(point);
            if (isHorizontalOrRadial) {
              start2 = polarClip.startAngle;
              end2 = polarClip.endAngle;
              current = -coord[1] / 180 * Math.PI;
            } else {
              start2 = polarClip.r0;
              end2 = polarClip.r;
              current = coord[0];
            }
          } else {
            var gridClip = clipShape;
            if (isHorizontalOrRadial) {
              start2 = gridClip.x;
              end2 = gridClip.x + gridClip.width;
              current = symbol.x;
            } else {
              start2 = gridClip.y + gridClip.height;
              end2 = gridClip.y;
              current = symbol.y;
            }
          }
        }
        var ratio = end2 === start2 ? 0 : (current - start2) / (end2 - start2);
        if (isAxisInverse) {
          ratio = 1 - ratio;
        }
        var delay = isFunction(seriesDalay) ? seriesDalay(idx) : seriesDuration * ratio + seriesDalayValue;
        var symbolPath = el.getSymbolPath();
        var text = symbolPath.getTextContent();
        el.attr({
          scaleX: 0,
          scaleY: 0
        });
        el.animateTo({
          scaleX: 1,
          scaleY: 1
        }, {
          duration: 200,
          setToFinal: true,
          delay
        });
        if (text) {
          text.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay
          });
        }
        symbolPath.disableLabelAnimation = true;
      }
    });
  };
  LineView2.prototype._initOrUpdateEndLabel = function(seriesModel, coordSys, inheritColor) {
    var endLabelModel = seriesModel.getModel("endLabel");
    if (anyStateShowEndLabel(seriesModel)) {
      var data_2 = seriesModel.getData();
      var polyline = this._polyline;
      var points2 = data_2.getLayout("points");
      if (!points2) {
        polyline.removeTextContent();
        this._endLabel = null;
        return;
      }
      var endLabel = this._endLabel;
      if (!endLabel) {
        endLabel = this._endLabel = new ZRText$1({
          z2: 200
        });
        endLabel.ignoreClip = true;
        polyline.setTextContent(this._endLabel);
        polyline.disableLabelAnimation = true;
      }
      var dataIndex = getLastIndexNotNull(points2);
      if (dataIndex >= 0) {
        setLabelStyle(polyline, getLabelStatesModels(seriesModel, "endLabel"), {
          inheritColor,
          labelFetcher: seriesModel,
          labelDataIndex: dataIndex,
          defaultText: function(dataIndex2, opt, interpolatedValue) {
            return interpolatedValue != null ? getDefaultInterpolatedLabel(data_2, interpolatedValue) : getDefaultLabel(data_2, dataIndex2);
          },
          enableTextSetter: true
        }, getEndLabelStateSpecified(endLabelModel, coordSys));
        polyline.textConfig.position = null;
      }
    } else if (this._endLabel) {
      this._polyline.removeTextContent();
      this._endLabel = null;
    }
  };
  LineView2.prototype._endLabelOnDuring = function(percent, clipRect, data, animationRecord, valueAnimation, endLabelModel, coordSys) {
    var endLabel = this._endLabel;
    var polyline = this._polyline;
    if (endLabel) {
      if (percent < 1 && animationRecord.originalX == null) {
        animationRecord.originalX = endLabel.x;
        animationRecord.originalY = endLabel.y;
      }
      var points2 = data.getLayout("points");
      var seriesModel = data.hostModel;
      var connectNulls = seriesModel.get("connectNulls");
      var precision = endLabelModel.get("precision");
      var distance2 = endLabelModel.get("distance") || 0;
      var baseAxis = coordSys.getBaseAxis();
      var isHorizontal = baseAxis.isHorizontal();
      var isBaseInversed = baseAxis.inverse;
      var clipShape = clipRect.shape;
      var xOrY = isBaseInversed ? isHorizontal ? clipShape.x : clipShape.y + clipShape.height : isHorizontal ? clipShape.x + clipShape.width : clipShape.y;
      var distanceX = (isHorizontal ? distance2 : 0) * (isBaseInversed ? -1 : 1);
      var distanceY = (isHorizontal ? 0 : -distance2) * (isBaseInversed ? -1 : 1);
      var dim = isHorizontal ? "x" : "y";
      var dataIndexRange = getIndexRange(points2, xOrY, dim);
      var indices = dataIndexRange.range;
      var diff = indices[1] - indices[0];
      var value = void 0;
      if (diff >= 1) {
        if (diff > 1 && !connectNulls) {
          var pt = getPointAtIndex(points2, indices[0]);
          endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          valueAnimation && (value = seriesModel.getRawValue(indices[0]));
        } else {
          var pt = polyline.getPointOn(xOrY, dim);
          pt && endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          var startValue = seriesModel.getRawValue(indices[0]);
          var endValue = seriesModel.getRawValue(indices[1]);
          valueAnimation && (value = interpolateRawValues(data, precision, startValue, endValue, dataIndexRange.t));
        }
        animationRecord.lastFrameIndex = indices[0];
      } else {
        var idx = percent === 1 || animationRecord.lastFrameIndex > 0 ? indices[0] : 0;
        var pt = getPointAtIndex(points2, idx);
        valueAnimation && (value = seriesModel.getRawValue(idx));
        endLabel.attr({
          x: pt[0] + distanceX,
          y: pt[1] + distanceY
        });
      }
      if (valueAnimation) {
        labelInner(endLabel).setLabelText(value);
      }
    }
  };
  LineView2.prototype._doUpdateAnimation = function(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls) {
    var polyline = this._polyline;
    var polygon = this._polygon;
    var seriesModel = data.hostModel;
    var diff = lineAnimationDiff(this._data, data, this._stackedOnPoints, stackedOnPoints, this._coordSys, coordSys, this._valueOrigin);
    var current = diff.current;
    var stackedOnCurrent = diff.stackedOnCurrent;
    var next = diff.next;
    var stackedOnNext = diff.stackedOnNext;
    if (step) {
      current = turnPointsIntoStep(diff.current, coordSys, step, connectNulls);
      stackedOnCurrent = turnPointsIntoStep(diff.stackedOnCurrent, coordSys, step, connectNulls);
      next = turnPointsIntoStep(diff.next, coordSys, step, connectNulls);
      stackedOnNext = turnPointsIntoStep(diff.stackedOnNext, coordSys, step, connectNulls);
    }
    if (getBoundingDiff(current, next) > 3e3 || polygon && getBoundingDiff(stackedOnCurrent, stackedOnNext) > 3e3) {
      polyline.stopAnimation();
      polyline.setShape({
        points: next
      });
      if (polygon) {
        polygon.stopAnimation();
        polygon.setShape({
          points: next,
          stackedOnPoints: stackedOnNext
        });
      }
      return;
    }
    polyline.shape.__points = diff.current;
    polyline.shape.points = current;
    var target = {
      shape: {
        points: next
      }
    };
    if (diff.current !== current) {
      target.shape.__points = diff.next;
    }
    polyline.stopAnimation();
    updateProps$1(polyline, target, seriesModel);
    if (polygon) {
      polygon.setShape({
        points: current,
        stackedOnPoints: stackedOnCurrent
      });
      polygon.stopAnimation();
      updateProps$1(polygon, {
        shape: {
          stackedOnPoints: stackedOnNext
        }
      }, seriesModel);
      if (polyline.shape.points !== polygon.shape.points) {
        polygon.shape.points = polyline.shape.points;
      }
    }
    var updatedDataInfo = [];
    var diffStatus = diff.status;
    for (var i = 0; i < diffStatus.length; i++) {
      var cmd = diffStatus[i].cmd;
      if (cmd === "=") {
        var el = data.getItemGraphicEl(diffStatus[i].idx1);
        if (el) {
          updatedDataInfo.push({
            el,
            ptIdx: i
          });
        }
      }
    }
    if (polyline.animators && polyline.animators.length) {
      polyline.animators[0].during(function() {
        polygon && polygon.dirtyShape();
        var points2 = polyline.shape.__points;
        for (var i2 = 0; i2 < updatedDataInfo.length; i2++) {
          var el2 = updatedDataInfo[i2].el;
          var offset = updatedDataInfo[i2].ptIdx * 2;
          el2.x = points2[offset];
          el2.y = points2[offset + 1];
          el2.markRedraw();
        }
      });
    }
  };
  LineView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var oldData = this._data;
    this._lineGroup.removeAll();
    this._symbolDraw.remove(true);
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
  };
  LineView2.type = "line";
  return LineView2;
}(ChartView$1);
var LineView$1 = LineView;
function pointsLayout(seriesType2, forceStoreInTypedArray) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var coordSys = seriesModel.coordinateSystem;
      var pipelineContext = seriesModel.pipelineContext;
      var useTypedArray = forceStoreInTypedArray || pipelineContext.large;
      if (!coordSys) {
        return;
      }
      var dims = map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }).slice(0, 2);
      var dimLen = dims.length;
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      if (isDimensionStacked(data, dims[0])) {
        dims[0] = stackResultDim;
      }
      if (isDimensionStacked(data, dims[1])) {
        dims[1] = stackResultDim;
      }
      var store = data.getStore();
      var dimIdx0 = data.getDimensionIndex(dims[0]);
      var dimIdx1 = data.getDimensionIndex(dims[1]);
      return dimLen && {
        progress: function(params, data2) {
          var segCount = params.end - params.start;
          var points2 = useTypedArray && createFloat32Array(segCount * dimLen);
          var tmpIn = [];
          var tmpOut = [];
          for (var i = params.start, offset = 0; i < params.end; i++) {
            var point = void 0;
            if (dimLen === 1) {
              var x2 = store.get(dimIdx0, i);
              point = coordSys.dataToPoint(x2, null, tmpOut);
            } else {
              tmpIn[0] = store.get(dimIdx0, i);
              tmpIn[1] = store.get(dimIdx1, i);
              point = coordSys.dataToPoint(tmpIn, null, tmpOut);
            }
            if (useTypedArray) {
              points2[offset++] = point[0];
              points2[offset++] = point[1];
            } else {
              data2.setItemLayout(i, point.slice());
            }
          }
          useTypedArray && data2.setLayout("points", points2);
        }
      };
    }
  };
}
var samplers = {
  average: function(frame) {
    var sum2 = 0;
    var count2 = 0;
    for (var i = 0; i < frame.length; i++) {
      if (!isNaN(frame[i])) {
        sum2 += frame[i];
        count2++;
      }
    }
    return count2 === 0 ? NaN : sum2 / count2;
  },
  sum: function(frame) {
    var sum2 = 0;
    for (var i = 0; i < frame.length; i++) {
      sum2 += frame[i] || 0;
    }
    return sum2;
  },
  max: function(frame) {
    var max3 = -Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] > max3 && (max3 = frame[i]);
    }
    return isFinite(max3) ? max3 : NaN;
  },
  min: function(frame) {
    var min3 = Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] < min3 && (min3 = frame[i]);
    }
    return isFinite(min3) ? min3 : NaN;
  },
  nearest: function(frame) {
    return frame[0];
  }
};
var indexSampler = function(frame) {
  return Math.round(frame.length / 2);
};
function dataSample(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel, api) {
      var data = seriesModel.getData();
      var sampling = seriesModel.get("sampling");
      var coordSys = seriesModel.coordinateSystem;
      var count2 = data.count();
      if (count2 > 10 && coordSys.type === "cartesian2d" && sampling) {
        var baseAxis = coordSys.getBaseAxis();
        var valueAxis2 = coordSys.getOtherAxis(baseAxis);
        var extent3 = baseAxis.getExtent();
        var dpr2 = api.getDevicePixelRatio();
        var size = Math.abs(extent3[1] - extent3[0]) * (dpr2 || 1);
        var rate = Math.round(count2 / size);
        if (isFinite(rate) && rate > 1) {
          if (sampling === "lttb") {
            seriesModel.setData(data.lttbDownSample(data.mapDimension(valueAxis2.dim), 1 / rate));
          }
          var sampler = void 0;
          if (isString(sampling)) {
            sampler = samplers[sampling];
          } else if (isFunction(sampling)) {
            sampler = sampling;
          }
          if (sampler) {
            seriesModel.setData(data.downSample(data.mapDimension(valueAxis2.dim), 1 / rate, sampler, indexSampler));
          }
        }
      }
    }
  };
}
function install$Q(registers) {
  registers.registerChartView(LineView$1);
  registers.registerSeriesModel(LineSeries);
  registers.registerLayout(pointsLayout("line", true));
  registers.registerVisual({
    seriesType: "line",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var lineStyle = seriesModel.getModel("lineStyle").getLineStyle();
      if (lineStyle && !lineStyle.stroke) {
        lineStyle.stroke = data.getVisual("style").fill;
      }
      data.setVisual("legendLineStyle", lineStyle);
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("line"));
}
var BaseBarSeriesModel = function(_super) {
  __extends(BaseBarSeriesModel2, _super);
  function BaseBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BaseBarSeriesModel2.type;
    return _this;
  }
  BaseBarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  BaseBarSeriesModel2.prototype.getMarkerPosition = function(value) {
    var coordSys = this.coordinateSystem;
    if (coordSys && coordSys.clampData) {
      var pt = coordSys.dataToPoint(coordSys.clampData(value));
      var data = this.getData();
      var offset = data.getLayout("offset");
      var size = data.getLayout("size");
      var offsetIndex = coordSys.getBaseAxis().isHorizontal() ? 0 : 1;
      pt[offsetIndex] += offset + size / 2;
      return pt;
    }
    return [NaN, NaN];
  };
  BaseBarSeriesModel2.type = "series.__base_bar__";
  BaseBarSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    barMinHeight: 0,
    barMinAngle: 0,
    large: false,
    largeThreshold: 400,
    progressive: 3e3,
    progressiveChunkMode: "mod"
  };
  return BaseBarSeriesModel2;
}(SeriesModel$1);
SeriesModel$1.registerClass(BaseBarSeriesModel);
var BaseBarSeriesModel$1 = BaseBarSeriesModel;
var BarSeriesModel = function(_super) {
  __extends(BarSeriesModel2, _super);
  function BarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BarSeriesModel2.type;
    return _this;
  }
  BarSeriesModel2.prototype.getInitialData = function() {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true,
      createInvertedIndices: !!this.get("realtimeSort", true) || null
    });
  };
  BarSeriesModel2.prototype.getProgressive = function() {
    return this.get("large") ? this.get("progressive") : false;
  };
  BarSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.get("progressiveThreshold");
    var largeThreshold = this.get("largeThreshold");
    if (largeThreshold > progressiveThreshold) {
      progressiveThreshold = largeThreshold;
    }
    return progressiveThreshold;
  };
  BarSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.rect(data.getItemLayout(dataIndex));
  };
  BarSeriesModel2.type = "series.bar";
  BarSeriesModel2.dependencies = ["grid", "polar"];
  BarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    clip: true,
    roundCap: false,
    showBackground: false,
    backgroundStyle: {
      color: "rgba(180, 180, 180, 0.2)",
      borderColor: null,
      borderWidth: 0,
      borderType: "solid",
      borderRadius: 0,
      shadowBlur: 0,
      shadowColor: null,
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    realtimeSort: false
  });
  return BarSeriesModel2;
}(BaseBarSeriesModel$1);
var BarSeries = BarSeriesModel;
var SausageShape = function() {
  function SausageShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return SausageShape2;
}();
var SausagePath = function(_super) {
  __extends(SausagePath2, _super);
  function SausagePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "sausage";
    return _this;
  }
  SausagePath2.prototype.getDefaultShape = function() {
    return new SausageShape();
  };
  SausagePath2.prototype.buildPath = function(ctx, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var r0 = Math.max(shape.r0 || 0, 0);
    var r2 = Math.max(shape.r, 0);
    var dr = (r2 - r0) * 0.5;
    var rCenter = r0 + dr;
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var PI22 = Math.PI * 2;
    var lessThanCircle = clockwise ? endAngle - startAngle < PI22 : startAngle - endAngle < PI22;
    if (!lessThanCircle) {
      startAngle = endAngle - (clockwise ? PI22 : -PI22);
    }
    var unitStartX = Math.cos(startAngle);
    var unitStartY = Math.sin(startAngle);
    var unitEndX = Math.cos(endAngle);
    var unitEndY = Math.sin(endAngle);
    if (lessThanCircle) {
      ctx.moveTo(unitStartX * r0 + cx, unitStartY * r0 + cy);
      ctx.arc(unitStartX * rCenter + cx, unitStartY * rCenter + cy, dr, -Math.PI + startAngle, startAngle, !clockwise);
    } else {
      ctx.moveTo(unitStartX * r2 + cx, unitStartY * r2 + cy);
    }
    ctx.arc(cx, cy, r2, startAngle, endAngle, !clockwise);
    ctx.arc(unitEndX * rCenter + cx, unitEndY * rCenter + cy, dr, endAngle - Math.PI * 2, endAngle - Math.PI, !clockwise);
    if (r0 !== 0) {
      ctx.arc(cx, cy, r0, endAngle, startAngle, clockwise);
    }
  };
  return SausagePath2;
}(Path$1);
var Sausage = SausagePath;
function createSectorCalculateTextPosition(positionMapping, opts) {
  opts = opts || {};
  var isRoundCap = opts.isRoundCap;
  return function(out2, opts2, boundingRect) {
    var textPosition = opts2.position;
    if (!textPosition || textPosition instanceof Array) {
      return calculateTextPosition(out2, opts2, boundingRect);
    }
    var mappedSectorPosition = positionMapping(textPosition);
    var distance2 = opts2.distance != null ? opts2.distance : 5;
    var sector = this.shape;
    var cx = sector.cx;
    var cy = sector.cy;
    var r2 = sector.r;
    var r0 = sector.r0;
    var middleR = (r2 + r0) / 2;
    var startAngle = sector.startAngle;
    var endAngle = sector.endAngle;
    var middleAngle = (startAngle + endAngle) / 2;
    var extraDist = isRoundCap ? Math.abs(r2 - r0) / 2 : 0;
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var x2 = cx + r2 * mathCos2(startAngle);
    var y2 = cy + r2 * mathSin2(startAngle);
    var textAlign = "left";
    var textVerticalAlign = "top";
    switch (mappedSectorPosition) {
      case "startArc":
        x2 = cx + (r0 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "insideStartArc":
        x2 = cx + (r0 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "startAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, distance2 + extraDist, false);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideStartAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, -distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, -distance2 + extraDist, false);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "middle":
        x2 = cx + middleR * mathCos2(middleAngle);
        y2 = cy + middleR * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "endArc":
        x2 = cx + (r2 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideEndArc":
        x2 = cx + (r2 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "endAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, distance2 + extraDist, true);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "insideEndAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, -distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, -distance2 + extraDist, true);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      default:
        return calculateTextPosition(out2, opts2, boundingRect);
    }
    out2 = out2 || {};
    out2.x = x2;
    out2.y = y2;
    out2.align = textAlign;
    out2.verticalAlign = textVerticalAlign;
    return out2;
  };
}
function setSectorTextRotation(sector, textPosition, positionMapping, rotateType) {
  if (isNumber(rotateType)) {
    sector.setTextConfig({
      rotation: rotateType
    });
    return;
  } else if (isArray$1(textPosition)) {
    sector.setTextConfig({
      rotation: 0
    });
    return;
  }
  var shape = sector.shape;
  var startAngle = shape.clockwise ? shape.startAngle : shape.endAngle;
  var endAngle = shape.clockwise ? shape.endAngle : shape.startAngle;
  var middleAngle = (startAngle + endAngle) / 2;
  var anchorAngle;
  var mappedSectorPosition = positionMapping(textPosition);
  switch (mappedSectorPosition) {
    case "startArc":
    case "insideStartArc":
    case "middle":
    case "insideEndArc":
    case "endArc":
      anchorAngle = middleAngle;
      break;
    case "startAngle":
    case "insideStartAngle":
      anchorAngle = startAngle;
      break;
    case "endAngle":
    case "insideEndAngle":
      anchorAngle = endAngle;
      break;
    default:
      sector.setTextConfig({
        rotation: 0
      });
      return;
  }
  var rotate2 = Math.PI * 1.5 - anchorAngle;
  if (mappedSectorPosition === "middle" && rotate2 > Math.PI / 2 && rotate2 < Math.PI * 1.5) {
    rotate2 -= Math.PI;
  }
  sector.setTextConfig({
    rotation: rotate2
  });
}
function adjustAngleDistanceX(angle, distance2, isEnd) {
  return distance2 * Math.sin(angle) * (isEnd ? -1 : 1);
}
function adjustAngleDistanceY(angle, distance2, isEnd) {
  return distance2 * Math.cos(angle) * (isEnd ? 1 : -1);
}
var mathMax$4 = Math.max;
var mathMin$4 = Math.min;
function getClipArea(coord, data) {
  var coordSysClipArea = coord.getArea && coord.getArea();
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var baseAxis = coord.getBaseAxis();
    if (baseAxis.type !== "category" || !baseAxis.onBand) {
      var expandWidth = data.getLayout("bandWidth");
      if (baseAxis.isHorizontal()) {
        coordSysClipArea.x -= expandWidth;
        coordSysClipArea.width += expandWidth * 2;
      } else {
        coordSysClipArea.y -= expandWidth;
        coordSysClipArea.height += expandWidth * 2;
      }
    }
  }
  return coordSysClipArea;
}
var BarView = function(_super) {
  __extends(BarView2, _super);
  function BarView2() {
    var _this = _super.call(this) || this;
    _this.type = BarView2.type;
    _this._isFirstFrame = true;
    return _this;
  }
  BarView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._model = seriesModel;
    this._removeOnRenderedListener(api);
    this._updateDrawMode(seriesModel);
    var coordinateSystemType = seriesModel.get("coordinateSystem");
    if (coordinateSystemType === "cartesian2d" || coordinateSystemType === "polar") {
      this._progressiveEls = null;
      this._isLargeDraw ? this._renderLarge(seriesModel, ecModel, api) : this._renderNormal(seriesModel, ecModel, api, payload);
    }
  };
  BarView2.prototype.incrementalPrepareRender = function(seriesModel) {
    this._clear();
    this._updateDrawMode(seriesModel);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype.incrementalRender = function(params, seriesModel) {
    this._progressiveEls = [];
    this._incrementalRenderLarge(params, seriesModel);
  };
  BarView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  BarView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  BarView2.prototype._renderNormal = function(seriesModel, ecModel, api, payload) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coord = seriesModel.coordinateSystem;
    var baseAxis = coord.getBaseAxis();
    var isHorizontalOrRadial;
    if (coord.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
    } else if (coord.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
    }
    var animationModel = seriesModel.isAnimationEnabled() ? seriesModel : null;
    var realtimeSortCfg = shouldRealtimeSort(seriesModel, coord);
    if (realtimeSortCfg) {
      this._enableRealtimeSort(realtimeSortCfg, data, api);
    }
    var needsClip = seriesModel.get("clip", true) || realtimeSortCfg;
    var coordSysClipArea = getClipArea(coord, data);
    group.removeClipPath();
    var roundCap = seriesModel.get("roundCap", true);
    var drawBackground = seriesModel.get("showBackground", true);
    var backgroundModel = seriesModel.getModel("backgroundStyle");
    var barBorderRadius = backgroundModel.get("borderRadius") || 0;
    var bgEls = [];
    var oldBgEls = this._backgroundEls;
    var isInitSort = payload && payload.isInitSort;
    var isChangeOrder = payload && payload.type === "changeAxisOrder";
    function createBackground(dataIndex) {
      var bgLayout = getLayout[coord.type](data, dataIndex);
      var bgEl = createBackgroundEl(coord, isHorizontalOrRadial, bgLayout);
      bgEl.useStyle(backgroundModel.getItemStyle());
      if (coord.type === "cartesian2d") {
        bgEl.setShape("r", barBorderRadius);
      }
      bgEls[dataIndex] = bgEl;
      return bgEl;
    }
    data.diff(oldData).add(function(dataIndex) {
      var itemModel = data.getItemModel(dataIndex);
      var layout2 = getLayout[coord.type](data, dataIndex, itemModel);
      if (drawBackground) {
        createBackground(dataIndex);
      }
      if (!data.hasValue(dataIndex) || !isValidLayout[coord.type](layout2)) {
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
      }
      var el = elementCreator[coord.type](seriesModel, data, dataIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, false, roundCap);
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, dataIndex, isHorizontalOrRadial, false, false);
      } else {
        initProps(el, {
          shape: layout2
        }, seriesModel, dataIndex);
      }
      data.setItemGraphicEl(dataIndex, el);
      group.add(el);
      el.ignore = isClipped;
    }).update(function(newIndex, oldIndex) {
      var itemModel = data.getItemModel(newIndex);
      var layout2 = getLayout[coord.type](data, newIndex, itemModel);
      if (drawBackground) {
        var bgEl = void 0;
        if (oldBgEls.length === 0) {
          bgEl = createBackground(oldIndex);
        } else {
          bgEl = oldBgEls[oldIndex];
          bgEl.useStyle(backgroundModel.getItemStyle());
          if (coord.type === "cartesian2d") {
            bgEl.setShape("r", barBorderRadius);
          }
          bgEls[newIndex] = bgEl;
        }
        var bgLayout = getLayout[coord.type](data, newIndex);
        var shape = createBackgroundShape(isHorizontalOrRadial, bgLayout, coord);
        updateProps$1(bgEl, {
          shape
        }, animationModel, newIndex);
      }
      var el = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex) || !isValidLayout[coord.type](layout2)) {
        group.remove(el);
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
        if (isClipped) {
          group.remove(el);
        }
      }
      if (!el) {
        el = elementCreator[coord.type](seriesModel, data, newIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, !!el, roundCap);
      } else {
        saveOldStyle(el);
      }
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      if (isChangeOrder) {
        var textEl = el.getTextContent();
        if (textEl) {
          var labelInnerStore = labelInner(textEl);
          if (labelInnerStore.prevValue != null) {
            labelInnerStore.prevValue = labelInnerStore.value;
          }
        }
      } else {
        updateStyle(el, data, newIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      }
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, newIndex, isHorizontalOrRadial, true, isChangeOrder);
      } else {
        updateProps$1(el, {
          shape: layout2
        }, seriesModel, newIndex, null);
      }
      data.setItemGraphicEl(newIndex, el);
      el.ignore = isClipped;
      group.add(el);
    }).remove(function(dataIndex) {
      var el = oldData.getItemGraphicEl(dataIndex);
      el && removeElementWithFadeOut(el, seriesModel, dataIndex);
    }).execute();
    var bgGroup = this._backgroundGroup || (this._backgroundGroup = new Group$4());
    bgGroup.removeAll();
    for (var i = 0; i < bgEls.length; ++i) {
      bgGroup.add(bgEls[i]);
    }
    group.add(bgGroup);
    this._backgroundEls = bgEls;
    this._data = data;
  };
  BarView2.prototype._renderLarge = function(seriesModel, ecModel, api) {
    this._clear();
    createLarge$1(seriesModel, this.group);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    this._removeBackground();
    createLarge$1(seriesModel, this.group, this._progressiveEls, true);
  };
  BarView2.prototype._updateLargeClip = function(seriesModel) {
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    var group = this.group;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
  };
  BarView2.prototype._enableRealtimeSort = function(realtimeSortCfg, data, api) {
    var _this = this;
    if (!data.count()) {
      return;
    }
    var baseAxis = realtimeSortCfg.baseAxis;
    if (this._isFirstFrame) {
      this._dispatchInitSort(data, realtimeSortCfg, api);
      this._isFirstFrame = false;
    } else {
      var orderMapping_1 = function(idx) {
        var el = data.getItemGraphicEl(idx);
        var shape = el && el.shape;
        return shape && Math.abs(baseAxis.isHorizontal() ? shape.height : shape.width) || 0;
      };
      this._onRendered = function() {
        _this._updateSortWithinSameData(data, orderMapping_1, baseAxis, api);
      };
      api.getZr().on("rendered", this._onRendered);
    }
  };
  BarView2.prototype._dataSort = function(data, baseAxis, orderMapping) {
    var info = [];
    data.each(data.mapDimension(baseAxis.dim), function(ordinalNumber, dataIdx) {
      var mappedValue = orderMapping(dataIdx);
      mappedValue = mappedValue == null ? NaN : mappedValue;
      info.push({
        dataIndex: dataIdx,
        mappedValue,
        ordinalNumber
      });
    });
    info.sort(function(a, b2) {
      return b2.mappedValue - a.mappedValue;
    });
    return {
      ordinalNumbers: map$1(info, function(item) {
        return item.ordinalNumber;
      })
    };
  };
  BarView2.prototype._isOrderChangedWithinSameData = function(data, orderMapping, baseAxis) {
    var scale2 = baseAxis.scale;
    var ordinalDataDim = data.mapDimension(baseAxis.dim);
    var lastValue = Number.MAX_VALUE;
    for (var tickNum = 0, len2 = scale2.getOrdinalMeta().categories.length; tickNum < len2; ++tickNum) {
      var rawIdx = data.rawIndexOf(ordinalDataDim, scale2.getRawOrdinalNumber(tickNum));
      var value = rawIdx < 0 ? Number.MIN_VALUE : orderMapping(data.indexOfRawIndex(rawIdx));
      if (value > lastValue) {
        return true;
      }
      lastValue = value;
    }
    return false;
  };
  BarView2.prototype._isOrderDifferentInView = function(orderInfo, baseAxis) {
    var scale2 = baseAxis.scale;
    var extent3 = scale2.getExtent();
    var tickNum = Math.max(0, extent3[0]);
    var tickMax = Math.min(extent3[1], scale2.getOrdinalMeta().categories.length - 1);
    for (; tickNum <= tickMax; ++tickNum) {
      if (orderInfo.ordinalNumbers[tickNum] !== scale2.getRawOrdinalNumber(tickNum)) {
        return true;
      }
    }
  };
  BarView2.prototype._updateSortWithinSameData = function(data, orderMapping, baseAxis, api) {
    if (!this._isOrderChangedWithinSameData(data, orderMapping, baseAxis)) {
      return;
    }
    var sortInfo = this._dataSort(data, baseAxis, orderMapping);
    if (this._isOrderDifferentInView(sortInfo, baseAxis)) {
      this._removeOnRenderedListener(api);
      api.dispatchAction({
        type: "changeAxisOrder",
        componentType: baseAxis.dim + "Axis",
        axisId: baseAxis.index,
        sortInfo
      });
    }
  };
  BarView2.prototype._dispatchInitSort = function(data, realtimeSortCfg, api) {
    var baseAxis = realtimeSortCfg.baseAxis;
    var sortResult = this._dataSort(data, baseAxis, function(dataIdx) {
      return data.get(data.mapDimension(realtimeSortCfg.otherAxis.dim), dataIdx);
    });
    api.dispatchAction({
      type: "changeAxisOrder",
      componentType: baseAxis.dim + "Axis",
      isInitSort: true,
      axisId: baseAxis.index,
      sortInfo: sortResult
    });
  };
  BarView2.prototype.remove = function(ecModel, api) {
    this._clear(this._model);
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype.dispose = function(ecModel, api) {
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype._removeOnRenderedListener = function(api) {
    if (this._onRendered) {
      api.getZr().off("rendered", this._onRendered);
      this._onRendered = null;
    }
  };
  BarView2.prototype._clear = function(model) {
    var group = this.group;
    var data = this._data;
    if (model && model.isAnimationEnabled() && data && !this._isLargeDraw) {
      this._removeBackground();
      this._backgroundEls = [];
      data.eachItemGraphicEl(function(el) {
        removeElementWithFadeOut(el, model, getECData(el).dataIndex);
      });
    } else {
      group.removeAll();
    }
    this._data = null;
    this._isFirstFrame = true;
  };
  BarView2.prototype._removeBackground = function() {
    this.group.remove(this._backgroundGroup);
    this._backgroundGroup = null;
  };
  BarView2.type = "bar";
  return BarView2;
}(ChartView$1);
var clip = {
  cartesian2d: function(coordSysBoundingRect, layout2) {
    var signWidth = layout2.width < 0 ? -1 : 1;
    var signHeight = layout2.height < 0 ? -1 : 1;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    var coordSysX2 = coordSysBoundingRect.x + coordSysBoundingRect.width;
    var coordSysY2 = coordSysBoundingRect.y + coordSysBoundingRect.height;
    var x2 = mathMax$4(layout2.x, coordSysBoundingRect.x);
    var x22 = mathMin$4(layout2.x + layout2.width, coordSysX2);
    var y2 = mathMax$4(layout2.y, coordSysBoundingRect.y);
    var y22 = mathMin$4(layout2.y + layout2.height, coordSysY2);
    var xClipped = x22 < x2;
    var yClipped = y22 < y2;
    layout2.x = xClipped && x2 > coordSysX2 ? x22 : x2;
    layout2.y = yClipped && y2 > coordSysY2 ? y22 : y2;
    layout2.width = xClipped ? 0 : x22 - x2;
    layout2.height = yClipped ? 0 : y22 - y2;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    return xClipped || yClipped;
  },
  polar: function(coordSysClipArea, layout2) {
    var signR = layout2.r0 <= layout2.r ? 1 : -1;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    var r2 = mathMin$4(layout2.r, coordSysClipArea.r);
    var r0 = mathMax$4(layout2.r0, coordSysClipArea.r0);
    layout2.r = r2;
    layout2.r0 = r0;
    var clipped = r2 - r0 < 0;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    return clipped;
  }
};
var elementCreator = {
  cartesian2d: function(seriesModel, data, newIndex, layout2, isHorizontal, animationModel, axisModel, isUpdate, roundCap) {
    var rect = new Rect$3({
      shape: extend({}, layout2),
      z2: 1
    });
    rect.__dataIndex = newIndex;
    rect.name = "item";
    if (animationModel) {
      var rectShape = rect.shape;
      var animateProperty = isHorizontal ? "height" : "width";
      rectShape[animateProperty] = 0;
    }
    return rect;
  },
  polar: function(seriesModel, data, newIndex, layout2, isRadial, animationModel, axisModel, isUpdate, roundCap) {
    var ShapeClass = !isRadial && roundCap ? Sausage : Sector$1;
    var sector = new ShapeClass({
      shape: layout2,
      z2: 1
    });
    sector.name = "item";
    var positionMap = createPolarPositionMapping(isRadial);
    sector.calculateTextPosition = createSectorCalculateTextPosition(positionMap, {
      isRoundCap: ShapeClass === Sausage
    });
    if (animationModel) {
      var sectorShape = sector.shape;
      var animateProperty = isRadial ? "r" : "endAngle";
      var animateTarget = {};
      sectorShape[animateProperty] = isRadial ? 0 : layout2.startAngle;
      animateTarget[animateProperty] = layout2[animateProperty];
      (isUpdate ? updateProps$1 : initProps)(sector, {
        shape: animateTarget
      }, animationModel);
    }
    return sector;
  }
};
function shouldRealtimeSort(seriesModel, coordSys) {
  var realtimeSortOption = seriesModel.get("realtimeSort", true);
  var baseAxis = coordSys.getBaseAxis();
  if (realtimeSortOption && baseAxis.type === "category" && coordSys.type === "cartesian2d") {
    return {
      baseAxis,
      otherAxis: coordSys.getOtherAxis(baseAxis)
    };
  }
}
function updateRealtimeAnimation(realtimeSortCfg, seriesAnimationModel, el, layout2, newIndex, isHorizontal, isUpdate, isChangeOrder) {
  var seriesTarget;
  var axisTarget;
  if (isHorizontal) {
    axisTarget = {
      x: layout2.x,
      width: layout2.width
    };
    seriesTarget = {
      y: layout2.y,
      height: layout2.height
    };
  } else {
    axisTarget = {
      y: layout2.y,
      height: layout2.height
    };
    seriesTarget = {
      x: layout2.x,
      width: layout2.width
    };
  }
  if (!isChangeOrder) {
    (isUpdate ? updateProps$1 : initProps)(el, {
      shape: seriesTarget
    }, seriesAnimationModel, newIndex, null);
  }
  var axisAnimationModel = seriesAnimationModel ? realtimeSortCfg.baseAxis.model : null;
  (isUpdate ? updateProps$1 : initProps)(el, {
    shape: axisTarget
  }, axisAnimationModel, newIndex);
}
function checkPropertiesNotValid(obj, props) {
  for (var i = 0; i < props.length; i++) {
    if (!isFinite(obj[props[i]])) {
      return true;
    }
  }
  return false;
}
var rectPropties = ["x", "y", "width", "height"];
var polarPropties = ["cx", "cy", "r", "startAngle", "endAngle"];
var isValidLayout = {
  cartesian2d: function(layout2) {
    return !checkPropertiesNotValid(layout2, rectPropties);
  },
  polar: function(layout2) {
    return !checkPropertiesNotValid(layout2, polarPropties);
  }
};
var getLayout = {
  cartesian2d: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    var fixedLineWidth = itemModel ? getLineWidth(itemModel, layout2) : 0;
    var signX = layout2.width > 0 ? 1 : -1;
    var signY = layout2.height > 0 ? 1 : -1;
    return {
      x: layout2.x + signX * fixedLineWidth / 2,
      y: layout2.y + signY * fixedLineWidth / 2,
      width: layout2.width - signX * fixedLineWidth,
      height: layout2.height - signY * fixedLineWidth
    };
  },
  polar: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    return {
      cx: layout2.cx,
      cy: layout2.cy,
      r0: layout2.r0,
      r: layout2.r,
      startAngle: layout2.startAngle,
      endAngle: layout2.endAngle,
      clockwise: layout2.clockwise
    };
  }
};
function isZeroOnPolar(layout2) {
  return layout2.startAngle != null && layout2.endAngle != null && layout2.startAngle === layout2.endAngle;
}
function createPolarPositionMapping(isRadial) {
  return function(isRadial2) {
    var arcOrAngle = isRadial2 ? "Arc" : "Angle";
    return function(position2) {
      switch (position2) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return position2 + arcOrAngle;
        default:
          return position2;
      }
    };
  }(isRadial);
}
function updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, isPolar) {
  var style = data.getItemVisual(dataIndex, "style");
  if (!isPolar) {
    el.setShape("r", itemModel.get(["itemStyle", "borderRadius"]) || 0);
  }
  el.useStyle(style);
  var cursorStyle = itemModel.getShallow("cursor");
  cursorStyle && el.attr("cursor", cursorStyle);
  var labelPositionOutside = isPolar ? isHorizontalOrRadial ? layout2.r >= layout2.r0 ? "endArc" : "startArc" : layout2.endAngle >= layout2.startAngle ? "endAngle" : "startAngle" : isHorizontalOrRadial ? layout2.height >= 0 ? "bottom" : "top" : layout2.width >= 0 ? "right" : "left";
  var labelStatesModels = getLabelStatesModels(itemModel);
  setLabelStyle(el, labelStatesModels, {
    labelFetcher: seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(seriesModel.getData(), dataIndex),
    inheritColor: style.fill,
    defaultOpacity: style.opacity,
    defaultOutsidePosition: labelPositionOutside
  });
  var label = el.getTextContent();
  if (isPolar && label) {
    var position2 = itemModel.get(["label", "position"]);
    el.textConfig.inside = position2 === "middle" ? true : null;
    setSectorTextRotation(el, position2 === "outside" ? labelPositionOutside : position2, createPolarPositionMapping(isHorizontalOrRadial), itemModel.get(["label", "rotate"]));
  }
  setLabelValueAnimation(label, labelStatesModels, seriesModel.getRawValue(dataIndex), function(value) {
    return getDefaultInterpolatedLabel(data, value);
  });
  var emphasisModel = itemModel.getModel(["emphasis"]);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  setStatesStylesFromModel(el, itemModel);
  if (isZeroOnPolar(layout2)) {
    el.style.fill = "none";
    el.style.stroke = "none";
    each$f(el.states, function(state) {
      if (state.style) {
        state.style.fill = state.style.stroke = "none";
      }
    });
  }
}
function getLineWidth(itemModel, rawLayout) {
  var borderColor = itemModel.get(["itemStyle", "borderColor"]);
  if (!borderColor || borderColor === "none") {
    return 0;
  }
  var lineWidth = itemModel.get(["itemStyle", "borderWidth"]) || 0;
  var width = isNaN(rawLayout.width) ? Number.MAX_VALUE : Math.abs(rawLayout.width);
  var height = isNaN(rawLayout.height) ? Number.MAX_VALUE : Math.abs(rawLayout.height);
  return Math.min(lineWidth, width, height);
}
var LagePathShape = function() {
  function LagePathShape2() {
  }
  return LagePathShape2;
}();
var LargePath = function(_super) {
  __extends(LargePath2, _super);
  function LargePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeBar";
    return _this;
  }
  LargePath2.prototype.getDefaultShape = function() {
    return new LagePathShape();
  };
  LargePath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var baseDimIdx = this.baseDimIdx;
    var valueDimIdx = 1 - this.baseDimIdx;
    var startPoint = [];
    var size = [];
    var barWidth = this.barWidth;
    for (var i = 0; i < points2.length; i += 3) {
      size[baseDimIdx] = barWidth;
      size[valueDimIdx] = points2[i + 2];
      startPoint[baseDimIdx] = points2[i + baseDimIdx];
      startPoint[valueDimIdx] = points2[i + valueDimIdx];
      ctx.rect(startPoint[0], startPoint[1], size[0], size[1]);
    }
  };
  return LargePath2;
}(Path$1);
function createLarge$1(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var baseDimIdx = data.getLayout("valueAxisHorizontal") ? 1 : 0;
  var largeDataIndices = data.getLayout("largeDataIndices");
  var barWidth = data.getLayout("size");
  var backgroundModel = seriesModel.getModel("backgroundStyle");
  var bgPoints = data.getLayout("largeBackgroundPoints");
  if (bgPoints) {
    var bgEl = new LargePath({
      shape: {
        points: bgPoints
      },
      incremental: !!incremental,
      silent: true,
      z2: 0
    });
    bgEl.baseDimIdx = baseDimIdx;
    bgEl.largeDataIndices = largeDataIndices;
    bgEl.barWidth = barWidth;
    bgEl.useStyle(backgroundModel.getItemStyle());
    group.add(bgEl);
    progressiveEls && progressiveEls.push(bgEl);
  }
  var el = new LargePath({
    shape: {
      points: data.getLayout("largePoints")
    },
    incremental: !!incremental,
    z2: 1
  });
  el.baseDimIdx = baseDimIdx;
  el.largeDataIndices = largeDataIndices;
  el.barWidth = barWidth;
  group.add(el);
  el.useStyle(data.getVisual("style"));
  getECData(el).seriesIndex = seriesModel.seriesIndex;
  if (!seriesModel.get("silent")) {
    el.on("mousedown", largePathUpdateDataIndex);
    el.on("mousemove", largePathUpdateDataIndex);
  }
  progressiveEls && progressiveEls.push(el);
}
var largePathUpdateDataIndex = throttle(function(event) {
  var largePath = this;
  var dataIndex = largePathFindDataIndex(largePath, event.offsetX, event.offsetY);
  getECData(largePath).dataIndex = dataIndex >= 0 ? dataIndex : null;
}, 30, false);
function largePathFindDataIndex(largePath, x2, y2) {
  var baseDimIdx = largePath.baseDimIdx;
  var valueDimIdx = 1 - baseDimIdx;
  var points2 = largePath.shape.points;
  var largeDataIndices = largePath.largeDataIndices;
  var startPoint = [];
  var size = [];
  var barWidth = largePath.barWidth;
  for (var i = 0, len2 = points2.length / 3; i < len2; i++) {
    var ii = i * 3;
    size[baseDimIdx] = barWidth;
    size[valueDimIdx] = points2[ii + 2];
    startPoint[baseDimIdx] = points2[ii + baseDimIdx];
    startPoint[valueDimIdx] = points2[ii + valueDimIdx];
    if (size[valueDimIdx] < 0) {
      startPoint[valueDimIdx] += size[valueDimIdx];
      size[valueDimIdx] = -size[valueDimIdx];
    }
    if (x2 >= startPoint[0] && x2 <= startPoint[0] + size[0] && y2 >= startPoint[1] && y2 <= startPoint[1] + size[1]) {
      return largeDataIndices[i];
    }
  }
  return -1;
}
function createBackgroundShape(isHorizontalOrRadial, layout2, coord) {
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var rectShape = layout2;
    var coordLayout = coord.getArea();
    return {
      x: isHorizontalOrRadial ? rectShape.x : coordLayout.x,
      y: isHorizontalOrRadial ? coordLayout.y : rectShape.y,
      width: isHorizontalOrRadial ? rectShape.width : coordLayout.width,
      height: isHorizontalOrRadial ? coordLayout.height : rectShape.height
    };
  } else {
    var coordLayout = coord.getArea();
    var sectorShape = layout2;
    return {
      cx: coordLayout.cx,
      cy: coordLayout.cy,
      r0: isHorizontalOrRadial ? coordLayout.r0 : sectorShape.r0,
      r: isHorizontalOrRadial ? coordLayout.r : sectorShape.r,
      startAngle: isHorizontalOrRadial ? sectorShape.startAngle : 0,
      endAngle: isHorizontalOrRadial ? sectorShape.endAngle : Math.PI * 2
    };
  }
}
function createBackgroundEl(coord, isHorizontalOrRadial, layout2) {
  var ElementClz = coord.type === "polar" ? Sector$1 : Rect$3;
  return new ElementClz({
    shape: createBackgroundShape(isHorizontalOrRadial, layout2, coord),
    silent: true,
    z2: 0
  });
}
var BarView$1 = BarView;
function install$P(registers) {
  registers.registerChartView(BarView$1);
  registers.registerSeriesModel(BarSeries);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "bar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("bar"));
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("bar"));
  registers.registerAction({
    type: "changeAxisOrder",
    event: "changeAxisOrder",
    update: "update"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      if (payload.sortInfo) {
        componentModel.axis.setCategorySortInfo(payload.sortInfo);
      }
    });
  });
}
var PI2$1 = Math.PI * 2;
var RADIAN$2 = Math.PI / 180;
function getViewRect$5(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getBasicPieLayout(seriesModel, api) {
  var viewRect2 = getViewRect$5(seriesModel, api);
  var center2 = seriesModel.get("center");
  var radius = seriesModel.get("radius");
  if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  if (!isArray$1(center2)) {
    center2 = [center2, center2];
  }
  var width = parsePercent(viewRect2.width, api.getWidth());
  var height = parsePercent(viewRect2.height, api.getHeight());
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], width) + viewRect2.x;
  var cy = parsePercent(center2[1], height) + viewRect2.y;
  var r0 = parsePercent(radius[0], size / 2);
  var r2 = parsePercent(radius[1], size / 2);
  return {
    cx,
    cy,
    r0,
    r: r2
  };
}
function pieLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var viewRect2 = getViewRect$5(seriesModel, api);
    var _a2 = getBasicPieLayout(seriesModel, api), cx = _a2.cx, cy = _a2.cy, r2 = _a2.r, r0 = _a2.r0;
    var startAngle = -seriesModel.get("startAngle") * RADIAN$2;
    var minAngle = seriesModel.get("minAngle") * RADIAN$2;
    var validDataCount = 0;
    data.each(valueDim, function(value) {
      !isNaN(value) && validDataCount++;
    });
    var sum2 = data.getSum(valueDim);
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var clockwise = seriesModel.get("clockwise");
    var roseType = seriesModel.get("roseType");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var extent3 = data.getDataExtent(valueDim);
    extent3[0] = 0;
    var restAngle = PI2$1;
    var valueSumLargerThanMinAngle = 0;
    var currentAngle = startAngle;
    var dir3 = clockwise ? 1 : -1;
    data.setLayout({
      viewRect: viewRect2,
      r: r2
    });
    data.each(valueDim, function(value, idx) {
      var angle;
      if (isNaN(value)) {
        data.setItemLayout(idx, {
          angle: NaN,
          startAngle: NaN,
          endAngle: NaN,
          clockwise,
          cx,
          cy,
          r0,
          r: roseType ? NaN : r2
        });
        return;
      }
      if (roseType !== "area") {
        angle = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
      } else {
        angle = PI2$1 / validDataCount;
      }
      if (angle < minAngle) {
        angle = minAngle;
        restAngle -= minAngle;
      } else {
        valueSumLargerThanMinAngle += value;
      }
      var endAngle = currentAngle + dir3 * angle;
      data.setItemLayout(idx, {
        angle,
        startAngle: currentAngle,
        endAngle,
        clockwise,
        cx,
        cy,
        r0,
        r: roseType ? linearMap$2(value, extent3, [r0, r2]) : r2
      });
      currentAngle = endAngle;
    });
    if (restAngle < PI2$1 && validDataCount) {
      if (restAngle <= 1e-3) {
        var angle_1 = PI2$1 / validDataCount;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_1 = data.getItemLayout(idx);
            layout_1.angle = angle_1;
            layout_1.startAngle = startAngle + dir3 * idx * angle_1;
            layout_1.endAngle = startAngle + dir3 * (idx + 1) * angle_1;
          }
        });
      } else {
        unitRadian = restAngle / valueSumLargerThanMinAngle;
        currentAngle = startAngle;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_2 = data.getItemLayout(idx);
            var angle = layout_2.angle === minAngle ? minAngle : value * unitRadian;
            layout_2.startAngle = currentAngle;
            layout_2.endAngle = currentAngle + dir3 * angle;
            currentAngle += dir3 * angle;
          }
        });
      }
    }
  });
}
function dataFilter$1(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var legendModels = ecModel.findComponents({
        mainType: "legend"
      });
      if (!legendModels || !legendModels.length) {
        return;
      }
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var name = data.getName(idx);
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(name)) {
            return false;
          }
        }
        return true;
      });
    }
  };
}
var RADIAN$1 = Math.PI / 180;
function adjustSingleSide(list, cx, cy, r2, dir3, viewWidth, viewHeight, viewLeft, viewTop, farthestX) {
  if (list.length < 2) {
    return;
  }
  function recalculateXOnSemiToAlignOnEllipseCurve(semi) {
    var rB = semi.rB;
    var rB2 = rB * rB;
    for (var i2 = 0; i2 < semi.list.length; i2++) {
      var item = semi.list[i2];
      var dy = Math.abs(item.label.y - cy);
      var rA = r2 + item.len;
      var rA2 = rA * rA;
      var dx2 = Math.sqrt((1 - Math.abs(dy * dy / rB2)) * rA2);
      var newX = cx + (dx2 + item.len2) * dir3;
      var deltaX = newX - item.label.x;
      var newTargetWidth = item.targetTextWidth - deltaX * dir3;
      constrainTextWidth(item, newTargetWidth, true);
      item.label.x = newX;
    }
  }
  function recalculateX(items) {
    var topSemi = {
      list: [],
      maxY: 0
    };
    var bottomSemi = {
      list: [],
      maxY: 0
    };
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].labelAlignTo !== "none") {
        continue;
      }
      var item = items[i2];
      var semi = item.label.y > cy ? bottomSemi : topSemi;
      var dy = Math.abs(item.label.y - cy);
      if (dy >= semi.maxY) {
        var dx2 = item.label.x - cx - item.len2 * dir3;
        var rA = r2 + item.len;
        var rB = Math.abs(dx2) < rA ? Math.sqrt(dy * dy / (1 - dx2 * dx2 / rA / rA)) : rA;
        semi.rB = rB;
        semi.maxY = dy;
      }
      semi.list.push(item);
    }
    recalculateXOnSemiToAlignOnEllipseCurve(topSemi);
    recalculateXOnSemiToAlignOnEllipseCurve(bottomSemi);
  }
  var len2 = list.length;
  for (var i = 0; i < len2; i++) {
    if (list[i].position === "outer" && list[i].labelAlignTo === "labelLine") {
      var dx = list[i].label.x - farthestX;
      list[i].linePoints[1][0] += dx;
      list[i].label.x = farthestX;
    }
  }
  if (shiftLayoutOnY(list, viewTop, viewTop + viewHeight)) {
    recalculateX(list);
  }
}
function avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop) {
  var leftList = [];
  var rightList = [];
  var leftmostX = Number.MAX_VALUE;
  var rightmostX = -Number.MAX_VALUE;
  for (var i = 0; i < labelLayoutList.length; i++) {
    var label = labelLayoutList[i].label;
    if (isPositionCenter(labelLayoutList[i])) {
      continue;
    }
    if (label.x < cx) {
      leftmostX = Math.min(leftmostX, label.x);
      leftList.push(labelLayoutList[i]);
    } else {
      rightmostX = Math.max(rightmostX, label.x);
      rightList.push(labelLayoutList[i]);
    }
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      if (layout2.labelStyleWidth != null) {
        continue;
      }
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var targetTextWidth = void 0;
      if (layout2.labelAlignTo === "edge") {
        if (label.x < cx) {
          targetTextWidth = linePoints[2][0] - layout2.labelDistance - viewLeft - layout2.edgeDistance;
        } else {
          targetTextWidth = viewLeft + viewWidth - layout2.edgeDistance - linePoints[2][0] - layout2.labelDistance;
        }
      } else if (layout2.labelAlignTo === "labelLine") {
        if (label.x < cx) {
          targetTextWidth = leftmostX - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - rightmostX - layout2.bleedMargin;
        }
      } else {
        if (label.x < cx) {
          targetTextWidth = label.x - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - label.x - layout2.bleedMargin;
        }
      }
      layout2.targetTextWidth = targetTextWidth;
      constrainTextWidth(layout2, targetTextWidth);
    }
  }
  adjustSingleSide(rightList, cx, cy, r2, 1, viewWidth, viewHeight, viewLeft, viewTop, rightmostX);
  adjustSingleSide(leftList, cx, cy, r2, -1, viewWidth, viewHeight, viewLeft, viewTop, leftmostX);
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var isAlignToEdge = layout2.labelAlignTo === "edge";
      var padding = label.style.padding;
      var paddingH = padding ? padding[1] + padding[3] : 0;
      var extraPaddingH = label.style.backgroundColor ? 0 : paddingH;
      var realTextWidth = layout2.rect.width + extraPaddingH;
      var dist2 = linePoints[1][0] - linePoints[2][0];
      if (isAlignToEdge) {
        if (label.x < cx) {
          linePoints[2][0] = viewLeft + layout2.edgeDistance + realTextWidth + layout2.labelDistance;
        } else {
          linePoints[2][0] = viewLeft + viewWidth - layout2.edgeDistance - realTextWidth - layout2.labelDistance;
        }
      } else {
        if (label.x < cx) {
          linePoints[2][0] = label.x + layout2.labelDistance;
        } else {
          linePoints[2][0] = label.x - layout2.labelDistance;
        }
        linePoints[1][0] = linePoints[2][0] + dist2;
      }
      linePoints[1][1] = linePoints[2][1] = label.y;
    }
  }
}
function constrainTextWidth(layout2, availableWidth, forceRecalculate) {
  if (forceRecalculate === void 0) {
    forceRecalculate = false;
  }
  if (layout2.labelStyleWidth != null) {
    return;
  }
  var label = layout2.label;
  var style = label.style;
  var textRect = layout2.rect;
  var bgColor = style.backgroundColor;
  var padding = style.padding;
  var paddingH = padding ? padding[1] + padding[3] : 0;
  var overflow = style.overflow;
  var oldOuterWidth = textRect.width + (bgColor ? 0 : paddingH);
  if (availableWidth < oldOuterWidth || forceRecalculate) {
    var oldHeight = textRect.height;
    if (overflow && overflow.match("break")) {
      label.setStyle("backgroundColor", null);
      label.setStyle("width", availableWidth - paddingH);
      var innerRect = label.getBoundingRect();
      label.setStyle("width", Math.ceil(innerRect.width));
      label.setStyle("backgroundColor", bgColor);
    } else {
      var availableInnerWidth = availableWidth - paddingH;
      var newWidth = availableWidth < oldOuterWidth ? availableInnerWidth : forceRecalculate ? availableInnerWidth > layout2.unconstrainedWidth ? null : availableInnerWidth : null;
      label.setStyle("width", newWidth);
    }
    var newRect = label.getBoundingRect();
    textRect.width = newRect.width;
    var margin = (label.style.margin || 0) + 2.1;
    textRect.height = newRect.height + margin;
    textRect.y -= (textRect.height - oldHeight) / 2;
  }
}
function isPositionCenter(sectorShape) {
  return sectorShape.position === "center";
}
function pieLabelLayout(seriesModel) {
  var data = seriesModel.getData();
  var labelLayoutList = [];
  var cx;
  var cy;
  var hasLabelRotate = false;
  var minShowLabelRadian = (seriesModel.get("minShowLabelAngle") || 0) * RADIAN$1;
  var viewRect2 = data.getLayout("viewRect");
  var r2 = data.getLayout("r");
  var viewWidth = viewRect2.width;
  var viewLeft = viewRect2.x;
  var viewTop = viewRect2.y;
  var viewHeight = viewRect2.height;
  function setNotShow(el) {
    el.ignore = true;
  }
  function isLabelShown(label2) {
    if (!label2.ignore) {
      return true;
    }
    for (var key in label2.states) {
      if (label2.states[key].ignore === false) {
        return true;
      }
    }
    return false;
  }
  data.each(function(idx) {
    var sector = data.getItemGraphicEl(idx);
    var sectorShape = sector.shape;
    var label2 = sector.getTextContent();
    var labelLine2 = sector.getTextGuideLine();
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position") || itemModel.get(["emphasis", "label", "position"]);
    var labelDistance = labelModel.get("distanceToLabelLine");
    var labelAlignTo = labelModel.get("alignTo");
    var edgeDistance = parsePercent(labelModel.get("edgeDistance"), viewWidth);
    var bleedMargin = labelModel.get("bleedMargin");
    var labelLineModel = itemModel.getModel("labelLine");
    var labelLineLen = labelLineModel.get("length");
    labelLineLen = parsePercent(labelLineLen, viewWidth);
    var labelLineLen2 = labelLineModel.get("length2");
    labelLineLen2 = parsePercent(labelLineLen2, viewWidth);
    if (Math.abs(sectorShape.endAngle - sectorShape.startAngle) < minShowLabelRadian) {
      each$f(label2.states, setNotShow);
      label2.ignore = true;
      return;
    }
    if (!isLabelShown(label2)) {
      return;
    }
    var midAngle = (sectorShape.startAngle + sectorShape.endAngle) / 2;
    var nx = Math.cos(midAngle);
    var ny = Math.sin(midAngle);
    var textX;
    var textY;
    var linePoints2;
    var textAlign;
    cx = sectorShape.cx;
    cy = sectorShape.cy;
    var isLabelInside = labelPosition === "inside" || labelPosition === "inner";
    if (labelPosition === "center") {
      textX = sectorShape.cx;
      textY = sectorShape.cy;
      textAlign = "center";
    } else {
      var x1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * nx : sectorShape.r * nx) + cx;
      var y1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * ny : sectorShape.r * ny) + cy;
      textX = x1 + nx * 3;
      textY = y1 + ny * 3;
      if (!isLabelInside) {
        var x2 = x1 + nx * (labelLineLen + r2 - sectorShape.r);
        var y2 = y1 + ny * (labelLineLen + r2 - sectorShape.r);
        var x3 = x2 + (nx < 0 ? -1 : 1) * labelLineLen2;
        var y3 = y2;
        if (labelAlignTo === "edge") {
          textX = nx < 0 ? viewLeft + edgeDistance : viewLeft + viewWidth - edgeDistance;
        } else {
          textX = x3 + (nx < 0 ? -labelDistance : labelDistance);
        }
        textY = y3;
        linePoints2 = [[x1, y1], [x2, y2], [x3, y3]];
      }
      textAlign = isLabelInside ? "center" : labelAlignTo === "edge" ? nx > 0 ? "right" : "left" : nx > 0 ? "left" : "right";
    }
    var PI3 = Math.PI;
    var labelRotate = 0;
    var rotate2 = labelModel.get("rotate");
    if (isNumber(rotate2)) {
      labelRotate = rotate2 * (PI3 / 180);
    } else if (labelPosition === "center") {
      labelRotate = 0;
    } else if (rotate2 === "radial" || rotate2 === true) {
      var radialAngle = nx < 0 ? -midAngle + PI3 : -midAngle;
      labelRotate = radialAngle;
    } else if (rotate2 === "tangential" && labelPosition !== "outside" && labelPosition !== "outer") {
      var rad = Math.atan2(nx, ny);
      if (rad < 0) {
        rad = PI3 * 2 + rad;
      }
      var isDown = ny > 0;
      if (isDown) {
        rad = PI3 + rad;
      }
      labelRotate = rad - PI3;
    }
    hasLabelRotate = !!labelRotate;
    label2.x = textX;
    label2.y = textY;
    label2.rotation = labelRotate;
    label2.setStyle({
      verticalAlign: "middle"
    });
    if (!isLabelInside) {
      var textRect = label2.getBoundingRect().clone();
      textRect.applyTransform(label2.getComputedTransform());
      var margin = (label2.style.margin || 0) + 2.1;
      textRect.y -= margin / 2;
      textRect.height += margin;
      labelLayoutList.push({
        label: label2,
        labelLine: labelLine2,
        position: labelPosition,
        len: labelLineLen,
        len2: labelLineLen2,
        minTurnAngle: labelLineModel.get("minTurnAngle"),
        maxSurfaceAngle: labelLineModel.get("maxSurfaceAngle"),
        surfaceNormal: new Point$1(nx, ny),
        linePoints: linePoints2,
        textAlign,
        labelDistance,
        labelAlignTo,
        edgeDistance,
        bleedMargin,
        rect: textRect,
        unconstrainedWidth: textRect.width,
        labelStyleWidth: label2.style.width
      });
    } else {
      label2.setStyle({
        align: textAlign
      });
      var selectState2 = label2.states.select;
      if (selectState2) {
        selectState2.x += label2.x;
        selectState2.y += label2.y;
      }
    }
    sector.setTextConfig({
      inside: isLabelInside
    });
  });
  if (!hasLabelRotate && seriesModel.get("avoidLabelOverlap")) {
    avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop);
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    var label = layout2.label;
    var labelLine = layout2.labelLine;
    var notShowLabel = isNaN(label.x) || isNaN(label.y);
    if (label) {
      label.setStyle({
        align: layout2.textAlign
      });
      if (notShowLabel) {
        each$f(label.states, setNotShow);
        label.ignore = true;
      }
      var selectState = label.states.select;
      if (selectState) {
        selectState.x += label.x;
        selectState.y += label.y;
      }
    }
    if (labelLine) {
      var linePoints = layout2.linePoints;
      if (notShowLabel || !linePoints) {
        each$f(labelLine.states, setNotShow);
        labelLine.ignore = true;
      } else {
        limitTurnAngle(linePoints, layout2.minTurnAngle);
        limitSurfaceAngle(linePoints, layout2.surfaceNormal, layout2.maxSurfaceAngle);
        labelLine.setShape({
          points: linePoints
        });
        label.__hostTarget.textGuideLineConfig = {
          anchor: new Point$1(linePoints[0][0], linePoints[0][1])
        };
      }
    }
  }
}
function getSectorCornerRadius(model, shape, zeroIfNull) {
  var cornerRadius = model.get("borderRadius");
  if (cornerRadius == null) {
    return zeroIfNull ? {
      cornerRadius: 0
    } : null;
  }
  if (!isArray$1(cornerRadius)) {
    cornerRadius = [cornerRadius, cornerRadius, cornerRadius, cornerRadius];
  }
  var dr = Math.abs(shape.r || 0 - shape.r0 || 0);
  return {
    cornerRadius: map$1(cornerRadius, function(cr) {
      return parsePercent$1(cr, dr);
    })
  };
}
var PiePiece = function(_super) {
  __extends(PiePiece2, _super);
  function PiePiece2(data, idx, startAngle) {
    var _this = _super.call(this) || this;
    _this.z2 = 2;
    var text = new ZRText$1();
    _this.setTextContent(text);
    _this.updateData(data, idx, startAngle, true);
    return _this;
  }
  PiePiece2.prototype.updateData = function(data, idx, startAngle, firstCreate) {
    var sector = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = data.getItemLayout(idx);
    var sectorShape = extend(getSectorCornerRadius(itemModel.getModel("itemStyle"), layout2, true), layout2);
    if (isNaN(sectorShape.startAngle)) {
      sector.setShape(sectorShape);
      return;
    }
    if (firstCreate) {
      sector.setShape(sectorShape);
      var animationType = seriesModel.getShallow("animationType");
      if (seriesModel.ecModel.ssr) {
        initProps(sector, {
          scaleX: 0,
          scaleY: 0
        }, seriesModel, {
          dataIndex: idx,
          isFrom: true
        });
        sector.originX = sectorShape.cx;
        sector.originY = sectorShape.cy;
      } else if (animationType === "scale") {
        sector.shape.r = layout2.r0;
        initProps(sector, {
          shape: {
            r: layout2.r
          }
        }, seriesModel, idx);
      } else {
        if (startAngle != null) {
          sector.setShape({
            startAngle,
            endAngle: startAngle
          });
          initProps(sector, {
            shape: {
              startAngle: layout2.startAngle,
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        } else {
          sector.shape.endAngle = layout2.startAngle;
          updateProps$1(sector, {
            shape: {
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        }
      }
    } else {
      saveOldStyle(sector);
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel, idx);
    }
    sector.useStyle(data.getItemVisual(idx, "style"));
    setStatesStylesFromModel(sector, itemModel);
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var offset = seriesModel.get("selectedOffset");
    var dx = Math.cos(midAngle) * offset;
    var dy = Math.sin(midAngle) * offset;
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._updateLabel(seriesModel, data, idx);
    sector.ensureState("emphasis").shape = extend({
      r: layout2.r + (emphasisModel.get("scale") ? emphasisModel.get("scaleSize") || 0 : 0)
    }, getSectorCornerRadius(emphasisModel.getModel("itemStyle"), layout2));
    extend(sector.ensureState("select"), {
      x: dx,
      y: dy,
      shape: getSectorCornerRadius(itemModel.getModel(["select", "itemStyle"]), layout2)
    });
    extend(sector.ensureState("blur"), {
      shape: getSectorCornerRadius(itemModel.getModel(["blur", "itemStyle"]), layout2)
    });
    var labelLine = sector.getTextGuideLine();
    var labelText = sector.getTextContent();
    labelLine && extend(labelLine.ensureState("select"), {
      x: dx,
      y: dy
    });
    extend(labelText.ensureState("select"), {
      x: dx,
      y: dy
    });
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  PiePiece2.prototype._updateLabel = function(seriesModel, data, idx) {
    var sector = this;
    var itemModel = data.getItemModel(idx);
    var labelLineModel = itemModel.getModel("labelLine");
    var style = data.getItemVisual(idx, "style");
    var visualColor = style && style.fill;
    var visualOpacity = style && style.opacity;
    setLabelStyle(sector, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      defaultText: seriesModel.getFormattedLabel(idx, "normal") || data.getName(idx)
    });
    var labelText = sector.getTextContent();
    sector.setTextConfig({
      position: null,
      rotation: null
    });
    labelText.attr({
      z2: 10
    });
    var labelPosition = seriesModel.get(["label", "position"]);
    if (labelPosition !== "outside" && labelPosition !== "outer") {
      sector.removeTextGuideLine();
    } else {
      var polyline = this.getTextGuideLine();
      if (!polyline) {
        polyline = new Polyline$3();
        this.setTextGuideLine(polyline);
      }
      setLabelLineStyle(this, getLabelLineStatesModels(itemModel), {
        stroke: visualColor,
        opacity: retrieve3(labelLineModel.get(["lineStyle", "opacity"]), visualOpacity, 1)
      });
    }
  };
  return PiePiece2;
}(Sector$1);
var PieView = function(_super) {
  __extends(PieView2, _super);
  function PieView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  PieView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var startAngle;
    if (!oldData && data.count() > 0) {
      var shape = data.getItemLayout(0);
      for (var s = 1; isNaN(shape && shape.startAngle) && s < data.count(); ++s) {
        shape = data.getItemLayout(s);
      }
      if (shape) {
        startAngle = shape.startAngle;
      }
    }
    if (this._emptyCircleSector) {
      group.remove(this._emptyCircleSector);
    }
    if (data.count() === 0 && seriesModel.get("showEmptyCircle")) {
      var sector = new Sector$1({
        shape: getBasicPieLayout(seriesModel, api)
      });
      sector.useStyle(seriesModel.getModel("emptyCircleStyle").getItemStyle());
      this._emptyCircleSector = sector;
      group.add(sector);
    }
    data.diff(oldData).add(function(idx) {
      var piePiece = new PiePiece(data, idx, startAngle);
      data.setItemGraphicEl(idx, piePiece);
      group.add(piePiece);
    }).update(function(newIdx, oldIdx) {
      var piePiece = oldData.getItemGraphicEl(oldIdx);
      piePiece.updateData(data, newIdx, startAngle);
      piePiece.off("click");
      group.add(piePiece);
      data.setItemGraphicEl(newIdx, piePiece);
    }).remove(function(idx) {
      var piePiece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piePiece, seriesModel, idx);
    }).execute();
    pieLabelLayout(seriesModel);
    if (seriesModel.get("animationTypeUpdate") !== "expansion") {
      this._data = data;
    }
  };
  PieView2.prototype.dispose = function() {
  };
  PieView2.prototype.containPoint = function(point, seriesModel) {
    var data = seriesModel.getData();
    var itemLayout = data.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  PieView2.type = "pie";
  return PieView2;
}(ChartView$1);
var PieView$1 = PieView;
function createSeriesDataSimply(seriesModel, opt, nameList) {
  opt = isArray$1(opt) && {
    coordDimensions: opt
  } || extend({
    encodeDefine: seriesModel.getEncode()
  }, opt);
  var source = seriesModel.getSource();
  var dimensions = prepareSeriesDataSchema(source, opt).dimensions;
  var list = new SeriesData$1(dimensions, seriesModel);
  list.initData(source, nameList);
  return list;
}
var LegendVisualProvider = function() {
  function LegendVisualProvider2(getDataWithEncodedVisual, getRawData2) {
    this._getDataWithEncodedVisual = getDataWithEncodedVisual;
    this._getRawData = getRawData2;
  }
  LegendVisualProvider2.prototype.getAllNames = function() {
    var rawData = this._getRawData();
    return rawData.mapArray(rawData.getName);
  };
  LegendVisualProvider2.prototype.containName = function(name) {
    var rawData = this._getRawData();
    return rawData.indexOfName(name) >= 0;
  };
  LegendVisualProvider2.prototype.indexOfName = function(name) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.indexOfName(name);
  };
  LegendVisualProvider2.prototype.getItemVisual = function(dataIndex, key) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.getItemVisual(dataIndex, key);
  };
  return LegendVisualProvider2;
}();
var LegendVisualProvider$1 = LegendVisualProvider;
var PieSeriesModel = function(_super) {
  __extends(PieSeriesModel2, _super);
  function PieSeriesModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PieSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  PieSeriesModel2.prototype.mergeOption = function() {
    _super.prototype.mergeOption.apply(this, arguments);
  };
  PieSeriesModel2.prototype.getInitialData = function() {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  PieSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueList = [];
    data.each(data.mapDimension("value"), function(value) {
      valueList.push(value);
    });
    params.percent = getPercentWithPrecision(valueList, dataIndex, data.hostModel.get("percentPrecision"));
    params.$vars.push("percent");
    return params;
  };
  PieSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  PieSeriesModel2.type = "series.pie";
  PieSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    minShowLabelAngle: 0,
    selectedOffset: 10,
    percentPrecision: 2,
    stillShowZeroSum: true,
    left: 0,
    top: 0,
    right: 0,
    bottom: 0,
    width: null,
    height: null,
    label: {
      rotate: 0,
      show: true,
      overflow: "truncate",
      position: "outer",
      alignTo: "none",
      edgeDistance: "25%",
      bleedMargin: 10,
      distanceToLabelLine: 5
    },
    labelLine: {
      show: true,
      length: 15,
      length2: 15,
      smooth: false,
      minTurnAngle: 90,
      maxSurfaceAngle: 90,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      borderWidth: 1,
      borderJoin: "round"
    },
    showEmptyCircle: true,
    emptyCircleStyle: {
      color: "lightgray",
      opacity: 1
    },
    labelLayout: {
      hideOverlap: true
    },
    emphasis: {
      scale: true,
      scaleSize: 5
    },
    avoidLabelOverlap: true,
    animationType: "expansion",
    animationDuration: 1e3,
    animationTypeUpdate: "transition",
    animationEasingUpdate: "cubicInOut",
    animationDurationUpdate: 500,
    animationEasing: "cubicInOut"
  };
  return PieSeriesModel2;
}(SeriesModel$1);
var PieSeriesModel$1 = PieSeriesModel;
function negativeDataFilter(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var valueDim = data.mapDimension("value");
        var curValue = data.get(valueDim, idx);
        if (isNumber(curValue) && !isNaN(curValue) && curValue < 0) {
          return false;
        }
        return true;
      });
    }
  };
}
function install$O(registers) {
  registers.registerChartView(PieView$1);
  registers.registerSeriesModel(PieSeriesModel$1);
  createLegacyDataSelectAction("pie", registers.registerAction);
  registers.registerLayout(curry$1(pieLayout, "pie"));
  registers.registerProcessor(dataFilter$1("pie"));
  registers.registerProcessor(negativeDataFilter("pie"));
}
var ScatterSeriesModel = function(_super) {
  __extends(ScatterSeriesModel2, _super);
  function ScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  ScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  ScatterSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 5e3 : this.get("progressive");
    }
    return progressive;
  };
  ScatterSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 1e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  ScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  ScatterSeriesModel2.prototype.getZLevelKey = function() {
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
  };
  ScatterSeriesModel2.type = "series.scatter";
  ScatterSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  ScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    symbolSize: 10,
    large: false,
    largeThreshold: 2e3,
    itemStyle: {
      opacity: 0.8
    },
    emphasis: {
      scale: true
    },
    clip: true,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    universalTransition: {
      divideShape: "clone"
    }
  };
  return ScatterSeriesModel2;
}(SeriesModel$1);
var ScatterSeriesModel$1 = ScatterSeriesModel;
var BOOST_SIZE_THRESHOLD = 4;
var LargeSymbolPathShape = function() {
  function LargeSymbolPathShape2() {
  }
  return LargeSymbolPathShape2;
}();
var LargeSymbolPath = function(_super) {
  __extends(LargeSymbolPath2, _super);
  function LargeSymbolPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeSymbolPath2.prototype.getDefaultShape = function() {
    return new LargeSymbolPathShape();
  };
  LargeSymbolPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeSymbolPath2.prototype.buildPath = function(path, shape) {
    var points2 = shape.points;
    var size = shape.size;
    var symbolProxy = this.symbolProxy;
    var symbolProxyShape = symbolProxy.shape;
    var ctx = path.getContext ? path.getContext() : path;
    var canBoost = ctx && size[0] < BOOST_SIZE_THRESHOLD;
    var softClipShape = this.softClipShape;
    var i;
    if (canBoost) {
      this._ctx = ctx;
      return;
    }
    this._ctx = null;
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      symbolProxyShape.x = x2 - size[0] / 2;
      symbolProxyShape.y = y2 - size[1] / 2;
      symbolProxyShape.width = size[0];
      symbolProxyShape.height = size[1];
      symbolProxy.buildPath(path, symbolProxyShape, true);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.afterBrush = function() {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var ctx = this._ctx;
    var softClipShape = this.softClipShape;
    var i;
    if (!ctx) {
      return;
    }
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      ctx.fillRect(x2 - size[0] / 2, y2 - size[1] / 2, size[0], size[1]);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var w2 = Math.max(size[0], 4);
    var h = Math.max(size[1], 4);
    for (var idx = points2.length / 2 - 1; idx >= 0; idx--) {
      var i = idx * 2;
      var x0 = points2[i] - w2 / 2;
      var y0 = points2[i + 1] - h / 2;
      if (x2 >= x0 && y2 >= y0 && x2 <= x0 + w2 && y2 <= y0 + h) {
        return idx;
      }
    }
    return -1;
  };
  LargeSymbolPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeSymbolPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.points;
      var size = shape.size;
      var w2 = size[0];
      var h = size[1];
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX - w2 / 2, minY - h / 2, maxX - minX + w2, maxY - minY + h);
    }
    return rect;
  };
  return LargeSymbolPath2;
}(Path$1);
var LargeSymbolDraw = function() {
  function LargeSymbolDraw2() {
    this.group = new Group$4();
  }
  LargeSymbolDraw2.prototype.updateData = function(data, opt) {
    this._clear();
    var symbolEl = this._create();
    symbolEl.setShape({
      points: data.getLayout("points")
    });
    this._setCommon(symbolEl, data, opt);
  };
  LargeSymbolDraw2.prototype.updateLayout = function(data) {
    var points2 = data.getLayout("points");
    this.group.eachChild(function(child) {
      if (child.startIndex != null) {
        var len2 = (child.endIndex - child.startIndex) * 2;
        var byteOffset = child.startIndex * 4 * 2;
        points2 = new Float32Array(points2.buffer, byteOffset, len2);
      }
      child.setShape("points", points2);
      child.reset();
    });
  };
  LargeSymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._clear();
  };
  LargeSymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    var lastAdded = this._newAdded[0];
    var points2 = data.getLayout("points");
    var oldPoints = lastAdded && lastAdded.shape.points;
    if (oldPoints && oldPoints.length < 2e4) {
      var oldLen = oldPoints.length;
      var newPoints = new Float32Array(oldLen + points2.length);
      newPoints.set(oldPoints);
      newPoints.set(points2, oldLen);
      lastAdded.endIndex = taskParams.end;
      lastAdded.setShape({
        points: newPoints
      });
    } else {
      this._newAdded = [];
      var symbolEl = this._create();
      symbolEl.startIndex = taskParams.start;
      symbolEl.endIndex = taskParams.end;
      symbolEl.incremental = true;
      symbolEl.setShape({
        points: points2
      });
      this._setCommon(symbolEl, data, opt);
    }
  };
  LargeSymbolDraw2.prototype.eachRendered = function(cb) {
    this._newAdded[0] && cb(this._newAdded[0]);
  };
  LargeSymbolDraw2.prototype._create = function() {
    var symbolEl = new LargeSymbolPath({
      cursor: "default"
    });
    this.group.add(symbolEl);
    this._newAdded.push(symbolEl);
    return symbolEl;
  };
  LargeSymbolDraw2.prototype._setCommon = function(symbolEl, data, opt) {
    var hostModel = data.hostModel;
    opt = opt || {};
    var size = data.getVisual("symbolSize");
    symbolEl.setShape("size", size instanceof Array ? size : [size, size]);
    symbolEl.softClipShape = opt.clipShape || null;
    symbolEl.symbolProxy = createSymbol$1(data.getVisual("symbol"), 0, 0, 0, 0);
    symbolEl.setColor = symbolEl.symbolProxy.setColor;
    var extrudeShadow = symbolEl.shape.size[0] < BOOST_SIZE_THRESHOLD;
    symbolEl.useStyle(hostModel.getModel("itemStyle").getItemStyle(extrudeShadow ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
    var globalStyle = data.getVisual("style");
    var visualColor = globalStyle && globalStyle.fill;
    if (visualColor) {
      symbolEl.setColor(visualColor);
    }
    var ecData = getECData(symbolEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    symbolEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = symbolEl.hoverDataIdx;
      if (dataIndex >= 0) {
        ecData.dataIndex = dataIndex + (symbolEl.startIndex || 0);
      }
    });
  };
  LargeSymbolDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeSymbolDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeSymbolDraw2;
}();
var LargeSymbolDraw$1 = LargeSymbolDraw;
var ScatterView = function(_super) {
  __extends(ScatterView2, _super);
  function ScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterView2.type;
    return _this;
  }
  ScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = true;
  };
  ScatterView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.incrementalPrepareUpdate(data);
    this._finished = false;
  };
  ScatterView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._symbolDraw.incrementalUpdate(taskParams, seriesModel.getData(), {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  ScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    if (!this._finished || data.count() > 1e4) {
      return {
        update: true
      };
    } else {
      var res = pointsLayout("").reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._symbolDraw.updateLayout(data);
    }
  };
  ScatterView2.prototype.eachRendered = function(cb) {
    this._symbolDraw && this._symbolDraw.eachRendered(cb);
  };
  ScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  ScatterView2.prototype._updateSymbolDraw = function(data, seriesModel) {
    var symbolDraw = this._symbolDraw;
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!symbolDraw || isLargeDraw !== this._isLargeDraw) {
      symbolDraw && symbolDraw.remove();
      symbolDraw = this._symbolDraw = isLargeDraw ? new LargeSymbolDraw$1() : new SymbolDraw$1();
      this._isLargeDraw = isLargeDraw;
      this.group.removeAll();
    }
    this.group.add(symbolDraw.group);
    return symbolDraw;
  };
  ScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
    this._symbolDraw = null;
  };
  ScatterView2.prototype.dispose = function() {
  };
  ScatterView2.type = "scatter";
  return ScatterView2;
}(ChartView$1);
var ScatterView$1 = ScatterView;
var GridModel = function(_super) {
  __extends(GridModel2, _super);
  function GridModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GridModel2.type = "grid";
  GridModel2.dependencies = ["xAxis", "yAxis"];
  GridModel2.layoutMode = "box";
  GridModel2.defaultOption = {
    show: false,
    z: 0,
    left: "10%",
    top: 60,
    right: "10%",
    bottom: 70,
    containLabel: false,
    backgroundColor: "rgba(0,0,0,0)",
    borderWidth: 1,
    borderColor: "#ccc"
  };
  return GridModel2;
}(ComponentModel$1);
var GridModel$1 = GridModel;
var CartesianAxisModel = function(_super) {
  __extends(CartesianAxisModel2, _super);
  function CartesianAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("grid", SINGLE_REFERRING).models[0];
  };
  CartesianAxisModel2.type = "cartesian2dAxis";
  return CartesianAxisModel2;
}(ComponentModel$1);
mixin(CartesianAxisModel, AxisModelCommonMixin);
var defaultOption$1 = {
  show: true,
  z: 0,
  inverse: false,
  name: "",
  nameLocation: "end",
  nameRotate: null,
  nameTruncate: {
    maxWidth: null,
    ellipsis: "...",
    placeholder: "."
  },
  nameTextStyle: {},
  nameGap: 15,
  silent: false,
  triggerEvent: false,
  tooltip: {
    show: false
  },
  axisPointer: {},
  axisLine: {
    show: true,
    onZero: true,
    onZeroAxisIndex: null,
    lineStyle: {
      color: "#6E7079",
      width: 1,
      type: "solid"
    },
    symbol: ["none", "none"],
    symbolSize: [10, 15]
  },
  axisTick: {
    show: true,
    inside: false,
    length: 5,
    lineStyle: {
      width: 1
    }
  },
  axisLabel: {
    show: true,
    inside: false,
    rotate: 0,
    showMinLabel: null,
    showMaxLabel: null,
    margin: 8,
    fontSize: 12
  },
  splitLine: {
    show: true,
    lineStyle: {
      color: ["#E0E6F1"],
      width: 1,
      type: "solid"
    }
  },
  splitArea: {
    show: false,
    areaStyle: {
      color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"]
    }
  }
};
var categoryAxis = merge({
  boundaryGap: true,
  deduplication: null,
  splitLine: {
    show: false
  },
  axisTick: {
    alignWithLabel: false,
    interval: "auto"
  },
  axisLabel: {
    interval: "auto"
  }
}, defaultOption$1);
var valueAxis = merge({
  boundaryGap: [0, 0],
  axisLine: {
    show: "auto"
  },
  axisTick: {
    show: "auto"
  },
  splitNumber: 5,
  minorTick: {
    show: false,
    splitNumber: 5,
    length: 3,
    lineStyle: {}
  },
  minorSplitLine: {
    show: false,
    lineStyle: {
      color: "#F4F7FD",
      width: 1
    }
  }
}, defaultOption$1);
var timeAxis = merge({
  splitNumber: 6,
  axisLabel: {
    showMinLabel: false,
    showMaxLabel: false,
    rich: {
      primary: {
        fontWeight: "bold"
      }
    }
  },
  splitLine: {
    show: false
  }
}, valueAxis);
var logAxis = defaults({
  logBase: 10
}, valueAxis);
var axisDefault = {
  category: categoryAxis,
  value: valueAxis,
  time: timeAxis,
  log: logAxis
};
var AXIS_TYPES = {
  value: 1,
  category: 1,
  time: 1,
  log: 1
};
function axisModelCreator(registers, axisName, BaseAxisModelClass, extraDefaultOption) {
  each$f(AXIS_TYPES, function(v4, axisType) {
    var defaultOption2 = merge(merge({}, axisDefault[axisType], true), extraDefaultOption, true);
    var AxisModel = function(_super) {
      __extends(AxisModel2, _super);
      function AxisModel2() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.type = axisName + "Axis." + axisType;
        return _this;
      }
      AxisModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
        var layoutMode = fetchLayoutMode(this);
        var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
        var themeModel = ecModel.getTheme();
        merge(option, themeModel.get(axisType + "Axis"));
        merge(option, this.getDefaultOption());
        option.type = getAxisType(option);
        if (layoutMode) {
          mergeLayoutParam(option, inputPositionParams, layoutMode);
        }
      };
      AxisModel2.prototype.optionUpdated = function() {
        var thisOption = this.option;
        if (thisOption.type === "category") {
          this.__ordinalMeta = OrdinalMeta$1.createByAxisModel(this);
        }
      };
      AxisModel2.prototype.getCategories = function(rawData) {
        var option = this.option;
        if (option.type === "category") {
          if (rawData) {
            return option.data;
          }
          return this.__ordinalMeta.categories;
        }
      };
      AxisModel2.prototype.getOrdinalMeta = function() {
        return this.__ordinalMeta;
      };
      AxisModel2.type = axisName + "Axis." + axisType;
      AxisModel2.defaultOption = defaultOption2;
      return AxisModel2;
    }(BaseAxisModelClass);
    registers.registerComponentModel(AxisModel);
  });
  registers.registerSubTypeDefaulter(axisName + "Axis", getAxisType);
}
function getAxisType(option) {
  return option.type || (option.data ? "category" : "value");
}
var Cartesian = function() {
  function Cartesian2(name) {
    this.type = "cartesian";
    this._dimList = [];
    this._axes = {};
    this.name = name || "";
  }
  Cartesian2.prototype.getAxis = function(dim) {
    return this._axes[dim];
  };
  Cartesian2.prototype.getAxes = function() {
    return map$1(this._dimList, function(dim) {
      return this._axes[dim];
    }, this);
  };
  Cartesian2.prototype.getAxesByScale = function(scaleType) {
    scaleType = scaleType.toLowerCase();
    return filter(this.getAxes(), function(axis) {
      return axis.scale.type === scaleType;
    });
  };
  Cartesian2.prototype.addAxis = function(axis) {
    var dim = axis.dim;
    this._axes[dim] = axis;
    this._dimList.push(dim);
  };
  return Cartesian2;
}();
var Cartesian$1 = Cartesian;
var cartesian2DDimensions = ["x", "y"];
function canCalculateAffineTransform(scale2) {
  return scale2.type === "interval" || scale2.type === "time";
}
var Cartesian2D = function(_super) {
  __extends(Cartesian2D2, _super);
  function Cartesian2D2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "cartesian2d";
    _this.dimensions = cartesian2DDimensions;
    return _this;
  }
  Cartesian2D2.prototype.calcAffineTransform = function() {
    this._transform = this._invTransform = null;
    var xAxisScale = this.getAxis("x").scale;
    var yAxisScale = this.getAxis("y").scale;
    if (!canCalculateAffineTransform(xAxisScale) || !canCalculateAffineTransform(yAxisScale)) {
      return;
    }
    var xScaleExtent = xAxisScale.getExtent();
    var yScaleExtent = yAxisScale.getExtent();
    var start2 = this.dataToPoint([xScaleExtent[0], yScaleExtent[0]]);
    var end2 = this.dataToPoint([xScaleExtent[1], yScaleExtent[1]]);
    var xScaleSpan = xScaleExtent[1] - xScaleExtent[0];
    var yScaleSpan = yScaleExtent[1] - yScaleExtent[0];
    if (!xScaleSpan || !yScaleSpan) {
      return;
    }
    var scaleX = (end2[0] - start2[0]) / xScaleSpan;
    var scaleY = (end2[1] - start2[1]) / yScaleSpan;
    var translateX = start2[0] - xScaleExtent[0] * scaleX;
    var translateY = start2[1] - yScaleExtent[0] * scaleY;
    var m2 = this._transform = [scaleX, 0, 0, scaleY, translateX, translateY];
    this._invTransform = invert([], m2);
  };
  Cartesian2D2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
  };
  Cartesian2D2.prototype.containPoint = function(point) {
    var axisX = this.getAxis("x");
    var axisY = this.getAxis("y");
    return axisX.contain(axisX.toLocalCoord(point[0])) && axisY.contain(axisY.toLocalCoord(point[1]));
  };
  Cartesian2D2.prototype.containData = function(data) {
    return this.getAxis("x").containData(data[0]) && this.getAxis("y").containData(data[1]);
  };
  Cartesian2D2.prototype.dataToPoint = function(data, clamp2, out2) {
    out2 = out2 || [];
    var xVal = data[0];
    var yVal = data[1];
    if (this._transform && xVal != null && isFinite(xVal) && yVal != null && isFinite(yVal)) {
      return applyTransform$1(out2, data, this._transform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.toGlobalCoord(xAxis.dataToCoord(xVal, clamp2));
    out2[1] = yAxis.toGlobalCoord(yAxis.dataToCoord(yVal, clamp2));
    return out2;
  };
  Cartesian2D2.prototype.clampData = function(data, out2) {
    var xScale = this.getAxis("x").scale;
    var yScale = this.getAxis("y").scale;
    var xAxisExtent = xScale.getExtent();
    var yAxisExtent = yScale.getExtent();
    var x2 = xScale.parse(data[0]);
    var y2 = yScale.parse(data[1]);
    out2 = out2 || [];
    out2[0] = Math.min(Math.max(Math.min(xAxisExtent[0], xAxisExtent[1]), x2), Math.max(xAxisExtent[0], xAxisExtent[1]));
    out2[1] = Math.min(Math.max(Math.min(yAxisExtent[0], yAxisExtent[1]), y2), Math.max(yAxisExtent[0], yAxisExtent[1]));
    return out2;
  };
  Cartesian2D2.prototype.pointToData = function(point, clamp2) {
    var out2 = [];
    if (this._invTransform) {
      return applyTransform$1(out2, point, this._invTransform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.coordToData(xAxis.toLocalCoord(point[0]), clamp2);
    out2[1] = yAxis.coordToData(yAxis.toLocalCoord(point[1]), clamp2);
    return out2;
  };
  Cartesian2D2.prototype.getOtherAxis = function(axis) {
    return this.getAxis(axis.dim === "x" ? "y" : "x");
  };
  Cartesian2D2.prototype.getArea = function() {
    var xExtent = this.getAxis("x").getGlobalExtent();
    var yExtent = this.getAxis("y").getGlobalExtent();
    var x2 = Math.min(xExtent[0], xExtent[1]);
    var y2 = Math.min(yExtent[0], yExtent[1]);
    var width = Math.max(xExtent[0], xExtent[1]) - x2;
    var height = Math.max(yExtent[0], yExtent[1]) - y2;
    return new BoundingRect$1(x2, y2, width, height);
  };
  return Cartesian2D2;
}(Cartesian$1);
var Cartesian2D$1 = Cartesian2D;
var Axis2D = function(_super) {
  __extends(Axis2D2, _super);
  function Axis2D2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.index = 0;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  Axis2D2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  Axis2D2.prototype.getGlobalExtent = function(asc2) {
    var ret = this.getExtent();
    ret[0] = this.toGlobalCoord(ret[0]);
    ret[1] = this.toGlobalCoord(ret[1]);
    asc2 && ret[0] > ret[1] && ret.reverse();
    return ret;
  };
  Axis2D2.prototype.pointToData = function(point, clamp2) {
    return this.coordToData(this.toLocalCoord(point[this.dim === "x" ? 0 : 1]), clamp2);
  };
  Axis2D2.prototype.setCategorySortInfo = function(info) {
    if (this.type !== "category") {
      return false;
    }
    this.model.option.categorySortInfo = info;
    this.scale.setSortInfo(info);
  };
  return Axis2D2;
}(Axis$1);
var Axis2D$1 = Axis2D;
function layout$2(gridModel, axisModel, opt) {
  opt = opt || {};
  var grid = gridModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var otherAxisOnZeroOf = axis.getAxesOnZeroOf()[0];
  var rawAxisPosition = axis.position;
  var axisPosition = otherAxisOnZeroOf ? "onZero" : rawAxisPosition;
  var axisDim = axis.dim;
  var rect = grid.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var idx = {
    left: 0,
    right: 1,
    top: 0,
    bottom: 1,
    onZero: 2
  };
  var axisOffset = axisModel.get("offset") || 0;
  var posBound = axisDim === "x" ? [rectBound[2] - axisOffset, rectBound[3] + axisOffset] : [rectBound[0] - axisOffset, rectBound[1] + axisOffset];
  if (otherAxisOnZeroOf) {
    var onZeroCoord = otherAxisOnZeroOf.toGlobalCoord(otherAxisOnZeroOf.dataToCoord(0));
    posBound[idx.onZero] = Math.max(Math.min(onZeroCoord, posBound[1]), posBound[0]);
  }
  layout2.position = [axisDim === "y" ? posBound[idx[axisPosition]] : rectBound[0], axisDim === "x" ? posBound[idx[axisPosition]] : rectBound[3]];
  layout2.rotation = Math.PI / 2 * (axisDim === "x" ? 0 : 1);
  var dirMap = {
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = dirMap[rawAxisPosition];
  layout2.labelOffset = otherAxisOnZeroOf ? posBound[idx[rawAxisPosition]] - posBound[idx.onZero] : 0;
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotate = axisModel.get(["axisLabel", "rotate"]);
  layout2.labelRotate = axisPosition === "top" ? -labelRotate : labelRotate;
  layout2.z2 = 1;
  return layout2;
}
function isCartesian2DSeries(seriesModel) {
  return seriesModel.get("coordinateSystem") === "cartesian2d";
}
function findAxisModels(seriesModel) {
  var axisModelMap = {
    xAxisModel: null,
    yAxisModel: null
  };
  each$f(axisModelMap, function(v4, key) {
    var axisType = key.replace(/Model$/, "");
    var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
    axisModelMap[key] = axisModel;
  });
  return axisModelMap;
}
var mathLog = Math.log;
function alignScaleTicks(scale2, axisModel, alignToScale) {
  var intervalScaleProto2 = IntervalScale$1.prototype;
  var alignToTicks = intervalScaleProto2.getTicks.call(alignToScale);
  var alignToNicedTicks = intervalScaleProto2.getTicks.call(alignToScale, true);
  var alignToSplitNumber = alignToTicks.length - 1;
  var alignToInterval = intervalScaleProto2.getInterval.call(alignToScale);
  var scaleExtent = getScaleExtent(scale2, axisModel);
  var rawExtent = scaleExtent.extent;
  var isMinFixed = scaleExtent.fixMin;
  var isMaxFixed = scaleExtent.fixMax;
  if (scale2.type === "log") {
    var logBase = mathLog(scale2.base);
    rawExtent = [mathLog(rawExtent[0]) / logBase, mathLog(rawExtent[1]) / logBase];
  }
  scale2.setExtent(rawExtent[0], rawExtent[1]);
  scale2.calcNiceExtent({
    splitNumber: alignToSplitNumber,
    fixMin: isMinFixed,
    fixMax: isMaxFixed
  });
  var extent3 = intervalScaleProto2.getExtent.call(scale2);
  if (isMinFixed) {
    rawExtent[0] = extent3[0];
  }
  if (isMaxFixed) {
    rawExtent[1] = extent3[1];
  }
  var interval = intervalScaleProto2.getInterval.call(scale2);
  var min3 = rawExtent[0];
  var max3 = rawExtent[1];
  if (isMinFixed && isMaxFixed) {
    interval = (max3 - min3) / alignToSplitNumber;
  } else if (isMinFixed) {
    max3 = rawExtent[0] + interval * alignToSplitNumber;
    while (max3 < rawExtent[1] && isFinite(max3) && isFinite(rawExtent[1])) {
      interval = increaseInterval(interval);
      max3 = rawExtent[0] + interval * alignToSplitNumber;
    }
  } else if (isMaxFixed) {
    min3 = rawExtent[1] - interval * alignToSplitNumber;
    while (min3 > rawExtent[0] && isFinite(min3) && isFinite(rawExtent[0])) {
      interval = increaseInterval(interval);
      min3 = rawExtent[1] - interval * alignToSplitNumber;
    }
  } else {
    var nicedSplitNumber = scale2.getTicks().length - 1;
    if (nicedSplitNumber > alignToSplitNumber) {
      interval = increaseInterval(interval);
    }
    var range3 = interval * alignToSplitNumber;
    max3 = Math.ceil(rawExtent[1] / interval) * interval;
    min3 = round$3(max3 - range3);
    if (min3 < 0 && rawExtent[0] >= 0) {
      min3 = 0;
      max3 = round$3(range3);
    } else if (max3 > 0 && rawExtent[1] <= 0) {
      max3 = 0;
      min3 = -round$3(range3);
    }
  }
  var t0 = (alignToTicks[0].value - alignToNicedTicks[0].value) / alignToInterval;
  var t1 = (alignToTicks[alignToSplitNumber].value - alignToNicedTicks[alignToSplitNumber].value) / alignToInterval;
  intervalScaleProto2.setExtent.call(scale2, min3 + interval * t0, max3 + interval * t1);
  intervalScaleProto2.setInterval.call(scale2, interval);
  if (t0 || t1) {
    intervalScaleProto2.setNiceExtent.call(scale2, min3 + interval, max3 - interval);
  }
}
var Grid = function() {
  function Grid2(gridModel, ecModel, api) {
    this.type = "grid";
    this._coordsMap = {};
    this._coordsList = [];
    this._axesMap = {};
    this._axesList = [];
    this.axisPointerEnabled = true;
    this.dimensions = cartesian2DDimensions;
    this._initCartesian(gridModel, ecModel, api);
    this.model = gridModel;
  }
  Grid2.prototype.getRect = function() {
    return this._rect;
  };
  Grid2.prototype.update = function(ecModel, api) {
    var axesMap = this._axesMap;
    this._updateScale(ecModel, this.model);
    function updateAxisTicks(axes) {
      var alignTo;
      var axesIndices = keys(axes);
      var len2 = axesIndices.length;
      if (!len2) {
        return;
      }
      var axisNeedsAlign = [];
      for (var i = len2 - 1; i >= 0; i--) {
        var idx = +axesIndices[i];
        var axis = axes[idx];
        var model = axis.model;
        var scale2 = axis.scale;
        if (isIntervalOrLogScale(scale2) && model.get("alignTicks") && model.get("interval") == null) {
          axisNeedsAlign.push(axis);
        } else {
          niceScaleExtent(scale2, model);
          if (isIntervalOrLogScale(scale2)) {
            alignTo = axis;
          }
        }
      }
      if (axisNeedsAlign.length) {
        if (!alignTo) {
          alignTo = axisNeedsAlign.pop();
          niceScaleExtent(alignTo.scale, alignTo.model);
        }
        each$f(axisNeedsAlign, function(axis2) {
          alignScaleTicks(axis2.scale, axis2.model, alignTo.scale);
        });
      }
    }
    updateAxisTicks(axesMap.x);
    updateAxisTicks(axesMap.y);
    var onZeroRecords = {};
    each$f(axesMap.x, function(xAxis) {
      fixAxisOnZero(axesMap, "y", xAxis, onZeroRecords);
    });
    each$f(axesMap.y, function(yAxis) {
      fixAxisOnZero(axesMap, "x", yAxis, onZeroRecords);
    });
    this.resize(this.model, api);
  };
  Grid2.prototype.resize = function(gridModel, api, ignoreContainLabel) {
    var boxLayoutParams = gridModel.getBoxLayoutParams();
    var isContainLabel = !ignoreContainLabel && gridModel.get("containLabel");
    var gridRect = getLayoutRect(boxLayoutParams, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._rect = gridRect;
    var axesList = this._axesList;
    adjustAxes();
    if (isContainLabel) {
      each$f(axesList, function(axis) {
        if (!axis.model.get(["axisLabel", "inside"])) {
          var labelUnionRect = estimateLabelUnionRect(axis);
          if (labelUnionRect) {
            var dim = axis.isHorizontal() ? "height" : "width";
            var margin = axis.model.get(["axisLabel", "margin"]);
            gridRect[dim] -= labelUnionRect[dim] + margin;
            if (axis.position === "top") {
              gridRect.y += labelUnionRect.height + margin;
            } else if (axis.position === "left") {
              gridRect.x += labelUnionRect.width + margin;
            }
          }
        }
      });
      adjustAxes();
    }
    each$f(this._coordsList, function(coord) {
      coord.calcAffineTransform();
    });
    function adjustAxes() {
      each$f(axesList, function(axis) {
        var isHorizontal = axis.isHorizontal();
        var extent3 = isHorizontal ? [0, gridRect.width] : [0, gridRect.height];
        var idx = axis.inverse ? 1 : 0;
        axis.setExtent(extent3[idx], extent3[1 - idx]);
        updateAxisTransform(axis, isHorizontal ? gridRect.x : gridRect.y);
      });
    }
  };
  Grid2.prototype.getAxis = function(dim, axisIndex) {
    var axesMapOnDim = this._axesMap[dim];
    if (axesMapOnDim != null) {
      return axesMapOnDim[axisIndex || 0];
    }
  };
  Grid2.prototype.getAxes = function() {
    return this._axesList.slice();
  };
  Grid2.prototype.getCartesian = function(xAxisIndex, yAxisIndex) {
    if (xAxisIndex != null && yAxisIndex != null) {
      var key = "x" + xAxisIndex + "y" + yAxisIndex;
      return this._coordsMap[key];
    }
    if (isObject$4(xAxisIndex)) {
      yAxisIndex = xAxisIndex.yAxisIndex;
      xAxisIndex = xAxisIndex.xAxisIndex;
    }
    for (var i = 0, coordList = this._coordsList; i < coordList.length; i++) {
      if (coordList[i].getAxis("x").index === xAxisIndex || coordList[i].getAxis("y").index === yAxisIndex) {
        return coordList[i];
      }
    }
  };
  Grid2.prototype.getCartesians = function() {
    return this._coordsList.slice();
  };
  Grid2.prototype.convertToPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.dataToPoint(value) : target.axis ? target.axis.toGlobalCoord(target.axis.dataToCoord(value)) : null;
  };
  Grid2.prototype.convertFromPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.pointToData(value) : target.axis ? target.axis.coordToData(target.axis.toLocalCoord(value)) : null;
  };
  Grid2.prototype._findConvertTarget = function(finder) {
    var seriesModel = finder.seriesModel;
    var xAxisModel = finder.xAxisModel || seriesModel && seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = finder.yAxisModel || seriesModel && seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    var gridModel = finder.gridModel;
    var coordsList = this._coordsList;
    var cartesian;
    var axis;
    if (seriesModel) {
      cartesian = seriesModel.coordinateSystem;
      indexOf(coordsList, cartesian) < 0 && (cartesian = null);
    } else if (xAxisModel && yAxisModel) {
      cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    } else if (xAxisModel) {
      axis = this.getAxis("x", xAxisModel.componentIndex);
    } else if (yAxisModel) {
      axis = this.getAxis("y", yAxisModel.componentIndex);
    } else if (gridModel) {
      var grid = gridModel.coordinateSystem;
      if (grid === this) {
        cartesian = this._coordsList[0];
      }
    }
    return {
      cartesian,
      axis
    };
  };
  Grid2.prototype.containPoint = function(point) {
    var coord = this._coordsList[0];
    if (coord) {
      return coord.containPoint(point);
    }
  };
  Grid2.prototype._initCartesian = function(gridModel, ecModel, api) {
    var _this = this;
    var grid = this;
    var axisPositionUsed = {
      left: false,
      right: false,
      top: false,
      bottom: false
    };
    var axesMap = {
      x: {},
      y: {}
    };
    var axesCount = {
      x: 0,
      y: 0
    };
    ecModel.eachComponent("xAxis", createAxisCreator("x"), this);
    ecModel.eachComponent("yAxis", createAxisCreator("y"), this);
    if (!axesCount.x || !axesCount.y) {
      this._axesMap = {};
      this._axesList = [];
      return;
    }
    this._axesMap = axesMap;
    each$f(axesMap.x, function(xAxis, xAxisIndex) {
      each$f(axesMap.y, function(yAxis, yAxisIndex) {
        var key = "x" + xAxisIndex + "y" + yAxisIndex;
        var cartesian = new Cartesian2D$1(key);
        cartesian.master = _this;
        cartesian.model = gridModel;
        _this._coordsMap[key] = cartesian;
        _this._coordsList.push(cartesian);
        cartesian.addAxis(xAxis);
        cartesian.addAxis(yAxis);
      });
    });
    function createAxisCreator(dimName) {
      return function(axisModel, idx) {
        if (!isAxisUsedInTheGrid(axisModel, gridModel)) {
          return;
        }
        var axisPosition = axisModel.get("position");
        if (dimName === "x") {
          if (axisPosition !== "top" && axisPosition !== "bottom") {
            axisPosition = axisPositionUsed.bottom ? "top" : "bottom";
          }
        } else {
          if (axisPosition !== "left" && axisPosition !== "right") {
            axisPosition = axisPositionUsed.left ? "right" : "left";
          }
        }
        axisPositionUsed[axisPosition] = true;
        var axis = new Axis2D$1(dimName, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisPosition);
        var isCategory2 = axis.type === "category";
        axis.onBand = isCategory2 && axisModel.get("boundaryGap");
        axis.inverse = axisModel.get("inverse");
        axisModel.axis = axis;
        axis.model = axisModel;
        axis.grid = grid;
        axis.index = idx;
        grid._axesList.push(axis);
        axesMap[dimName][idx] = axis;
        axesCount[dimName]++;
      };
    }
  };
  Grid2.prototype._updateScale = function(ecModel, gridModel) {
    each$f(this._axesList, function(axis) {
      axis.scale.setExtent(Infinity, -Infinity);
      if (axis.type === "category") {
        var categorySortInfo = axis.model.get("categorySortInfo");
        axis.scale.setSortInfo(categorySortInfo);
      }
    });
    ecModel.eachSeries(function(seriesModel) {
      if (isCartesian2DSeries(seriesModel)) {
        var axesModelMap = findAxisModels(seriesModel);
        var xAxisModel = axesModelMap.xAxisModel;
        var yAxisModel = axesModelMap.yAxisModel;
        if (!isAxisUsedInTheGrid(xAxisModel, gridModel) || !isAxisUsedInTheGrid(yAxisModel, gridModel)) {
          return;
        }
        var cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
        var data = seriesModel.getData();
        var xAxis = cartesian.getAxis("x");
        var yAxis = cartesian.getAxis("y");
        unionExtent(data, xAxis);
        unionExtent(data, yAxis);
      }
    }, this);
    function unionExtent(data, axis) {
      each$f(getDataDimensionsOnAxis(data, axis.dim), function(dim) {
        axis.scale.unionExtentFromData(data, dim);
      });
    }
  };
  Grid2.prototype.getTooltipAxes = function(dim) {
    var baseAxes = [];
    var otherAxes = [];
    each$f(this.getCartesians(), function(cartesian) {
      var baseAxis = dim != null && dim !== "auto" ? cartesian.getAxis(dim) : cartesian.getBaseAxis();
      var otherAxis = cartesian.getOtherAxis(baseAxis);
      indexOf(baseAxes, baseAxis) < 0 && baseAxes.push(baseAxis);
      indexOf(otherAxes, otherAxis) < 0 && otherAxes.push(otherAxis);
    });
    return {
      baseAxes,
      otherAxes
    };
  };
  Grid2.create = function(ecModel, api) {
    var grids = [];
    ecModel.eachComponent("grid", function(gridModel, idx) {
      var grid = new Grid2(gridModel, ecModel, api);
      grid.name = "grid_" + idx;
      grid.resize(gridModel, api, true);
      gridModel.coordinateSystem = grid;
      grids.push(grid);
    });
    ecModel.eachSeries(function(seriesModel) {
      if (!isCartesian2DSeries(seriesModel)) {
        return;
      }
      var axesModelMap = findAxisModels(seriesModel);
      var xAxisModel = axesModelMap.xAxisModel;
      var yAxisModel = axesModelMap.yAxisModel;
      var gridModel = xAxisModel.getCoordSysModel();
      var grid = gridModel.coordinateSystem;
      seriesModel.coordinateSystem = grid.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    });
    return grids;
  };
  Grid2.dimensions = cartesian2DDimensions;
  return Grid2;
}();
function isAxisUsedInTheGrid(axisModel, gridModel) {
  return axisModel.getCoordSysModel() === gridModel;
}
function fixAxisOnZero(axesMap, otherAxisDim, axis, onZeroRecords) {
  axis.getAxesOnZeroOf = function() {
    return otherAxisOnZeroOf ? [otherAxisOnZeroOf] : [];
  };
  var otherAxes = axesMap[otherAxisDim];
  var otherAxisOnZeroOf;
  var axisModel = axis.model;
  var onZero = axisModel.get(["axisLine", "onZero"]);
  var onZeroAxisIndex = axisModel.get(["axisLine", "onZeroAxisIndex"]);
  if (!onZero) {
    return;
  }
  if (onZeroAxisIndex != null) {
    if (canOnZeroToAxis(otherAxes[onZeroAxisIndex])) {
      otherAxisOnZeroOf = otherAxes[onZeroAxisIndex];
    }
  } else {
    for (var idx in otherAxes) {
      if (otherAxes.hasOwnProperty(idx) && canOnZeroToAxis(otherAxes[idx]) && !onZeroRecords[getOnZeroRecordKey(otherAxes[idx])]) {
        otherAxisOnZeroOf = otherAxes[idx];
        break;
      }
    }
  }
  if (otherAxisOnZeroOf) {
    onZeroRecords[getOnZeroRecordKey(otherAxisOnZeroOf)] = true;
  }
  function getOnZeroRecordKey(axis2) {
    return axis2.dim + "_" + axis2.index;
  }
}
function canOnZeroToAxis(axis) {
  return axis && axis.type !== "category" && axis.type !== "time" && ifAxisCrossZero(axis);
}
function updateAxisTransform(axis, coordBase) {
  var axisExtent = axis.getExtent();
  var axisExtentSum = axisExtent[0] + axisExtent[1];
  axis.toGlobalCoord = axis.dim === "x" ? function(coord) {
    return coord + coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
  axis.toLocalCoord = axis.dim === "x" ? function(coord) {
    return coord - coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
}
var Grid$1 = Grid;
var PI$3 = Math.PI;
var AxisBuilder = function() {
  function AxisBuilder2(axisModel, opt) {
    this.group = new Group$4();
    this.opt = opt;
    this.axisModel = axisModel;
    defaults(opt, {
      labelOffset: 0,
      nameDirection: 1,
      tickDirection: 1,
      labelDirection: 1,
      silent: true,
      handleAutoShown: function() {
        return true;
      }
    });
    var transformGroup = new Group$4({
      x: opt.position[0],
      y: opt.position[1],
      rotation: opt.rotation
    });
    transformGroup.updateTransform();
    this._transformGroup = transformGroup;
  }
  AxisBuilder2.prototype.hasBuilder = function(name) {
    return !!builders[name];
  };
  AxisBuilder2.prototype.add = function(name) {
    builders[name](this.opt, this.axisModel, this.group, this._transformGroup);
  };
  AxisBuilder2.prototype.getGroup = function() {
    return this.group;
  };
  AxisBuilder2.innerTextLayout = function(axisRotation, textRotation, direction) {
    var rotationDiff = remRadian(textRotation - axisRotation);
    var textAlign;
    var textVerticalAlign;
    if (isRadianAroundZero(rotationDiff)) {
      textVerticalAlign = direction > 0 ? "top" : "bottom";
      textAlign = "center";
    } else if (isRadianAroundZero(rotationDiff - PI$3)) {
      textVerticalAlign = direction > 0 ? "bottom" : "top";
      textAlign = "center";
    } else {
      textVerticalAlign = "middle";
      if (rotationDiff > 0 && rotationDiff < PI$3) {
        textAlign = direction > 0 ? "right" : "left";
      } else {
        textAlign = direction > 0 ? "left" : "right";
      }
    }
    return {
      rotation: rotationDiff,
      textAlign,
      textVerticalAlign
    };
  };
  AxisBuilder2.makeAxisEventDataBase = function(axisModel) {
    var eventData = {
      componentType: axisModel.mainType,
      componentIndex: axisModel.componentIndex
    };
    eventData[axisModel.mainType + "Index"] = axisModel.componentIndex;
    return eventData;
  };
  AxisBuilder2.isLabelSilent = function(axisModel) {
    var tooltipOpt = axisModel.get("tooltip");
    return axisModel.get("silent") || !(axisModel.get("triggerEvent") || tooltipOpt && tooltipOpt.show);
  };
  return AxisBuilder2;
}();
var builders = {
  axisLine: function(opt, axisModel, group, transformGroup) {
    var shown = axisModel.get(["axisLine", "show"]);
    if (shown === "auto" && opt.handleAutoShown) {
      shown = opt.handleAutoShown("axisLine");
    }
    if (!shown) {
      return;
    }
    var extent3 = axisModel.axis.getExtent();
    var matrix = transformGroup.transform;
    var pt12 = [extent3[0], 0];
    var pt22 = [extent3[1], 0];
    if (matrix) {
      applyTransform$1(pt12, pt12, matrix);
      applyTransform$1(pt22, pt22, matrix);
    }
    var lineStyle = extend({
      lineCap: "round"
    }, axisModel.getModel(["axisLine", "lineStyle"]).getLineStyle());
    var line = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: lineStyle,
      strokeContainThreshold: opt.strokeContainThreshold || 5,
      silent: true,
      z2: 1
    });
    line.anid = "line";
    group.add(line);
    var arrows = axisModel.get(["axisLine", "symbol"]);
    if (arrows != null) {
      var arrowSize = axisModel.get(["axisLine", "symbolSize"]);
      if (isString(arrows)) {
        arrows = [arrows, arrows];
      }
      if (isString(arrowSize) || isNumber(arrowSize)) {
        arrowSize = [arrowSize, arrowSize];
      }
      var arrowOffset = normalizeSymbolOffset(axisModel.get(["axisLine", "symbolOffset"]) || 0, arrowSize);
      var symbolWidth_1 = arrowSize[0];
      var symbolHeight_1 = arrowSize[1];
      each$f([{
        rotate: opt.rotation + Math.PI / 2,
        offset: arrowOffset[0],
        r: 0
      }, {
        rotate: opt.rotation - Math.PI / 2,
        offset: arrowOffset[1],
        r: Math.sqrt((pt12[0] - pt22[0]) * (pt12[0] - pt22[0]) + (pt12[1] - pt22[1]) * (pt12[1] - pt22[1]))
      }], function(point, index2) {
        if (arrows[index2] !== "none" && arrows[index2] != null) {
          var symbol = createSymbol$1(arrows[index2], -symbolWidth_1 / 2, -symbolHeight_1 / 2, symbolWidth_1, symbolHeight_1, lineStyle.stroke, true);
          var r2 = point.r + point.offset;
          symbol.attr({
            rotation: point.rotate,
            x: pt12[0] + r2 * Math.cos(opt.rotation),
            y: pt12[1] - r2 * Math.sin(opt.rotation),
            silent: true,
            z2: 11
          });
          group.add(symbol);
        }
      });
    }
  },
  axisTickLabel: function(opt, axisModel, group, transformGroup) {
    var ticksEls = buildAxisMajorTicks(group, transformGroup, axisModel, opt);
    var labelEls = buildAxisLabel(group, transformGroup, axisModel, opt);
    fixMinMaxLabelShow(axisModel, labelEls, ticksEls);
    buildAxisMinorTicks(group, transformGroup, axisModel, opt.tickDirection);
    if (axisModel.get(["axisLabel", "hideOverlap"])) {
      var labelList = prepareLayoutList(map$1(labelEls, function(label) {
        return {
          label,
          priority: label.z2,
          defaultAttr: {
            ignore: label.ignore
          }
        };
      }));
      hideOverlap(labelList);
    }
  },
  axisName: function(opt, axisModel, group, transformGroup) {
    var name = retrieve(opt.axisName, axisModel.get("name"));
    if (!name) {
      return;
    }
    var nameLocation = axisModel.get("nameLocation");
    var nameDirection = opt.nameDirection;
    var textStyleModel = axisModel.getModel("nameTextStyle");
    var gap = axisModel.get("nameGap") || 0;
    var extent3 = axisModel.axis.getExtent();
    var gapSignal = extent3[0] > extent3[1] ? -1 : 1;
    var pos = [
      nameLocation === "start" ? extent3[0] - gapSignal * gap : nameLocation === "end" ? extent3[1] + gapSignal * gap : (extent3[0] + extent3[1]) / 2,
      isNameLocationCenter(nameLocation) ? opt.labelOffset + nameDirection * gap : 0
    ];
    var labelLayout2;
    var nameRotation = axisModel.get("nameRotate");
    if (nameRotation != null) {
      nameRotation = nameRotation * PI$3 / 180;
    }
    var axisNameAvailableWidth;
    if (isNameLocationCenter(nameLocation)) {
      labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, nameRotation != null ? nameRotation : opt.rotation, nameDirection);
    } else {
      labelLayout2 = endTextLayout(opt.rotation, nameLocation, nameRotation || 0, extent3);
      axisNameAvailableWidth = opt.axisNameAvailableWidth;
      if (axisNameAvailableWidth != null) {
        axisNameAvailableWidth = Math.abs(axisNameAvailableWidth / Math.sin(labelLayout2.rotation));
        !isFinite(axisNameAvailableWidth) && (axisNameAvailableWidth = null);
      }
    }
    var textFont = textStyleModel.getFont();
    var truncateOpt = axisModel.get("nameTruncate", true) || {};
    var ellipsis = truncateOpt.ellipsis;
    var maxWidth = retrieve(opt.nameTruncateMaxWidth, truncateOpt.maxWidth, axisNameAvailableWidth);
    var textEl = new ZRText$1({
      x: pos[0],
      y: pos[1],
      rotation: labelLayout2.rotation,
      silent: AxisBuilder.isLabelSilent(axisModel),
      style: createTextStyle(textStyleModel, {
        text: name,
        font: textFont,
        overflow: "truncate",
        width: maxWidth,
        ellipsis,
        fill: textStyleModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]),
        align: textStyleModel.get("align") || labelLayout2.textAlign,
        verticalAlign: textStyleModel.get("verticalAlign") || labelLayout2.textVerticalAlign
      }),
      z2: 1
    });
    setTooltipConfig({
      el: textEl,
      componentModel: axisModel,
      itemName: name
    });
    textEl.__fullText = name;
    textEl.anid = "name";
    if (axisModel.get("triggerEvent")) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisName";
      eventData.name = name;
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    group.add(textEl);
    textEl.decomposeTransform();
  }
};
function endTextLayout(rotation, textPosition, textRotate, extent3) {
  var rotationDiff = remRadian(textRotate - rotation);
  var textAlign;
  var textVerticalAlign;
  var inverse = extent3[0] > extent3[1];
  var onLeft = textPosition === "start" && !inverse || textPosition !== "start" && inverse;
  if (isRadianAroundZero(rotationDiff - PI$3 / 2)) {
    textVerticalAlign = onLeft ? "bottom" : "top";
    textAlign = "center";
  } else if (isRadianAroundZero(rotationDiff - PI$3 * 1.5)) {
    textVerticalAlign = onLeft ? "top" : "bottom";
    textAlign = "center";
  } else {
    textVerticalAlign = "middle";
    if (rotationDiff < PI$3 * 1.5 && rotationDiff > PI$3 / 2) {
      textAlign = onLeft ? "left" : "right";
    } else {
      textAlign = onLeft ? "right" : "left";
    }
  }
  return {
    rotation: rotationDiff,
    textAlign,
    textVerticalAlign
  };
}
function fixMinMaxLabelShow(axisModel, labelEls, tickEls) {
  if (shouldShowAllLabels(axisModel.axis)) {
    return;
  }
  var showMinLabel = axisModel.get(["axisLabel", "showMinLabel"]);
  var showMaxLabel = axisModel.get(["axisLabel", "showMaxLabel"]);
  labelEls = labelEls || [];
  tickEls = tickEls || [];
  var firstLabel = labelEls[0];
  var nextLabel = labelEls[1];
  var lastLabel = labelEls[labelEls.length - 1];
  var prevLabel = labelEls[labelEls.length - 2];
  var firstTick = tickEls[0];
  var nextTick = tickEls[1];
  var lastTick = tickEls[tickEls.length - 1];
  var prevTick = tickEls[tickEls.length - 2];
  if (showMinLabel === false) {
    ignoreEl(firstLabel);
    ignoreEl(firstTick);
  } else if (isTwoLabelOverlapped(firstLabel, nextLabel)) {
    if (showMinLabel) {
      ignoreEl(nextLabel);
      ignoreEl(nextTick);
    } else {
      ignoreEl(firstLabel);
      ignoreEl(firstTick);
    }
  }
  if (showMaxLabel === false) {
    ignoreEl(lastLabel);
    ignoreEl(lastTick);
  } else if (isTwoLabelOverlapped(prevLabel, lastLabel)) {
    if (showMaxLabel) {
      ignoreEl(prevLabel);
      ignoreEl(prevTick);
    } else {
      ignoreEl(lastLabel);
      ignoreEl(lastTick);
    }
  }
}
function ignoreEl(el) {
  el && (el.ignore = true);
}
function isTwoLabelOverlapped(current, next) {
  var firstRect = current && current.getBoundingRect().clone();
  var nextRect = next && next.getBoundingRect().clone();
  if (!firstRect || !nextRect) {
    return;
  }
  var mRotationBack = identity([]);
  rotate(mRotationBack, mRotationBack, -current.rotation);
  firstRect.applyTransform(mul([], mRotationBack, current.getLocalTransform()));
  nextRect.applyTransform(mul([], mRotationBack, next.getLocalTransform()));
  return firstRect.intersect(nextRect);
}
function isNameLocationCenter(nameLocation) {
  return nameLocation === "middle" || nameLocation === "center";
}
function createTicks(ticksCoords, tickTransform, tickEndCoord, tickLineStyle, anidPrefix) {
  var tickEls = [];
  var pt12 = [];
  var pt22 = [];
  for (var i = 0; i < ticksCoords.length; i++) {
    var tickCoord = ticksCoords[i].coord;
    pt12[0] = tickCoord;
    pt12[1] = 0;
    pt22[0] = tickCoord;
    pt22[1] = tickEndCoord;
    if (tickTransform) {
      applyTransform$1(pt12, pt12, tickTransform);
      applyTransform$1(pt22, pt22, tickTransform);
    }
    var tickEl = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: tickLineStyle,
      z2: 2,
      autoBatch: true,
      silent: true
    });
    tickEl.anid = anidPrefix + "_" + ticksCoords[i].tickValue;
    tickEls.push(tickEl);
  }
  return tickEls;
}
function buildAxisMajorTicks(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var tickModel = axisModel.getModel("axisTick");
  var shown = tickModel.get("show");
  if (shown === "auto" && opt.handleAutoShown) {
    shown = opt.handleAutoShown("axisTick");
  }
  if (!shown || axis.scale.isBlank()) {
    return;
  }
  var lineStyleModel = tickModel.getModel("lineStyle");
  var tickEndCoord = opt.tickDirection * tickModel.get("length");
  var ticksCoords = axis.getTicksCoords();
  var ticksEls = createTicks(ticksCoords, transformGroup.transform, tickEndCoord, defaults(lineStyleModel.getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }), "ticks");
  for (var i = 0; i < ticksEls.length; i++) {
    group.add(ticksEls[i]);
  }
  return ticksEls;
}
function buildAxisMinorTicks(group, transformGroup, axisModel, tickDirection) {
  var axis = axisModel.axis;
  var minorTickModel = axisModel.getModel("minorTick");
  if (!minorTickModel.get("show") || axis.scale.isBlank()) {
    return;
  }
  var minorTicksCoords = axis.getMinorTicksCoords();
  if (!minorTicksCoords.length) {
    return;
  }
  var lineStyleModel = minorTickModel.getModel("lineStyle");
  var tickEndCoord = tickDirection * minorTickModel.get("length");
  var minorTickLineStyle = defaults(lineStyleModel.getLineStyle(), defaults(axisModel.getModel("axisTick").getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }));
  for (var i = 0; i < minorTicksCoords.length; i++) {
    var minorTicksEls = createTicks(minorTicksCoords[i], transformGroup.transform, tickEndCoord, minorTickLineStyle, "minorticks_" + i);
    for (var k2 = 0; k2 < minorTicksEls.length; k2++) {
      group.add(minorTicksEls[k2]);
    }
  }
}
function buildAxisLabel(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var show = retrieve(opt.axisLabelShow, axisModel.get(["axisLabel", "show"]));
  if (!show || axis.scale.isBlank()) {
    return;
  }
  var labelModel = axisModel.getModel("axisLabel");
  var labelMargin = labelModel.get("margin");
  var labels = axis.getViewLabels();
  var labelRotation = (retrieve(opt.labelRotate, labelModel.get("rotate")) || 0) * PI$3 / 180;
  var labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, labelRotation, opt.labelDirection);
  var rawCategoryData = axisModel.getCategories && axisModel.getCategories(true);
  var labelEls = [];
  var silent = AxisBuilder.isLabelSilent(axisModel);
  var triggerEvent = axisModel.get("triggerEvent");
  each$f(labels, function(labelItem, index2) {
    var tickValue = axis.scale.type === "ordinal" ? axis.scale.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
    var formattedLabel = labelItem.formattedLabel;
    var rawLabel = labelItem.rawLabel;
    var itemLabelModel = labelModel;
    if (rawCategoryData && rawCategoryData[tickValue]) {
      var rawCategoryItem = rawCategoryData[tickValue];
      if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
        itemLabelModel = new Model$1(rawCategoryItem.textStyle, labelModel, axisModel.ecModel);
      }
    }
    var textColor = itemLabelModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]);
    var tickCoord = axis.dataToCoord(tickValue);
    var textEl = new ZRText$1({
      x: tickCoord,
      y: opt.labelOffset + opt.labelDirection * labelMargin,
      rotation: labelLayout2.rotation,
      silent,
      z2: 10 + (labelItem.level || 0),
      style: createTextStyle(itemLabelModel, {
        text: formattedLabel,
        align: itemLabelModel.getShallow("align", true) || labelLayout2.textAlign,
        verticalAlign: itemLabelModel.getShallow("verticalAlign", true) || itemLabelModel.getShallow("baseline", true) || labelLayout2.textVerticalAlign,
        fill: isFunction(textColor) ? textColor(axis.type === "category" ? rawLabel : axis.type === "value" ? tickValue + "" : tickValue, index2) : textColor
      })
    });
    textEl.anid = "label_" + tickValue;
    if (triggerEvent) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisLabel";
      eventData.value = rawLabel;
      eventData.tickIndex = index2;
      if (axis.type === "category") {
        eventData.dataIndex = tickValue;
      }
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    labelEls.push(textEl);
    group.add(textEl);
    textEl.decomposeTransform();
  });
  return labelEls;
}
var AxisBuilder$1 = AxisBuilder;
function collect(ecModel, api) {
  var result = {
    axesInfo: {},
    seriesInvolved: false,
    coordSysAxesInfo: {},
    coordSysMap: {}
  };
  collectAxesInfo(result, ecModel, api);
  result.seriesInvolved && collectSeriesInfo(result, ecModel);
  return result;
}
function collectAxesInfo(result, ecModel, api) {
  var globalTooltipModel = ecModel.getComponent("tooltip");
  var globalAxisPointerModel = ecModel.getComponent("axisPointer");
  var linksOption = globalAxisPointerModel.get("link", true) || [];
  var linkGroups = [];
  each$f(api.getCoordinateSystems(), function(coordSys) {
    if (!coordSys.axisPointerEnabled) {
      return;
    }
    var coordSysKey = makeKey(coordSys.model);
    var axesInfoInCoordSys = result.coordSysAxesInfo[coordSysKey] = {};
    result.coordSysMap[coordSysKey] = coordSys;
    var coordSysModel = coordSys.model;
    var baseTooltipModel = coordSysModel.getModel("tooltip", globalTooltipModel);
    each$f(coordSys.getAxes(), curry$1(saveTooltipAxisInfo, false, null));
    if (coordSys.getTooltipAxes && globalTooltipModel && baseTooltipModel.get("show")) {
      var triggerAxis = baseTooltipModel.get("trigger") === "axis";
      var cross = baseTooltipModel.get(["axisPointer", "type"]) === "cross";
      var tooltipAxes = coordSys.getTooltipAxes(baseTooltipModel.get(["axisPointer", "axis"]));
      if (triggerAxis || cross) {
        each$f(tooltipAxes.baseAxes, curry$1(saveTooltipAxisInfo, cross ? "cross" : true, triggerAxis));
      }
      if (cross) {
        each$f(tooltipAxes.otherAxes, curry$1(saveTooltipAxisInfo, "cross", false));
      }
    }
    function saveTooltipAxisInfo(fromTooltip, triggerTooltip, axis) {
      var axisPointerModel = axis.model.getModel("axisPointer", globalAxisPointerModel);
      var axisPointerShow = axisPointerModel.get("show");
      if (!axisPointerShow || axisPointerShow === "auto" && !fromTooltip && !isHandleTrigger(axisPointerModel)) {
        return;
      }
      if (triggerTooltip == null) {
        triggerTooltip = axisPointerModel.get("triggerTooltip");
      }
      axisPointerModel = fromTooltip ? makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) : axisPointerModel;
      var snap = axisPointerModel.get("snap");
      var axisKey = makeKey(axis.model);
      var involveSeries = triggerTooltip || snap || axis.type === "category";
      var axisInfo = result.axesInfo[axisKey] = {
        key: axisKey,
        axis,
        coordSys,
        axisPointerModel,
        triggerTooltip,
        involveSeries,
        snap,
        useHandle: isHandleTrigger(axisPointerModel),
        seriesModels: [],
        linkGroup: null
      };
      axesInfoInCoordSys[axisKey] = axisInfo;
      result.seriesInvolved = result.seriesInvolved || involveSeries;
      var groupIndex = getLinkGroupIndex(linksOption, axis);
      if (groupIndex != null) {
        var linkGroup = linkGroups[groupIndex] || (linkGroups[groupIndex] = {
          axesInfo: {}
        });
        linkGroup.axesInfo[axisKey] = axisInfo;
        linkGroup.mapper = linksOption[groupIndex].mapper;
        axisInfo.linkGroup = linkGroup;
      }
    }
  });
}
function makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) {
  var tooltipAxisPointerModel = baseTooltipModel.getModel("axisPointer");
  var fields = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"];
  var volatileOption = {};
  each$f(fields, function(field) {
    volatileOption[field] = clone$4(tooltipAxisPointerModel.get(field));
  });
  volatileOption.snap = axis.type !== "category" && !!triggerTooltip;
  if (tooltipAxisPointerModel.get("type") === "cross") {
    volatileOption.type = "line";
  }
  var labelOption = volatileOption.label || (volatileOption.label = {});
  labelOption.show == null && (labelOption.show = false);
  if (fromTooltip === "cross") {
    var tooltipAxisPointerLabelShow = tooltipAxisPointerModel.get(["label", "show"]);
    labelOption.show = tooltipAxisPointerLabelShow != null ? tooltipAxisPointerLabelShow : true;
    if (!triggerTooltip) {
      var crossStyle = volatileOption.lineStyle = tooltipAxisPointerModel.get("crossStyle");
      crossStyle && defaults(labelOption, crossStyle.textStyle);
    }
  }
  return axis.model.getModel("axisPointer", new Model$1(volatileOption, globalAxisPointerModel, ecModel));
}
function collectSeriesInfo(result, ecModel) {
  ecModel.eachSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesTooltipTrigger = seriesModel.get(["tooltip", "trigger"], true);
    var seriesTooltipShow = seriesModel.get(["tooltip", "show"], true);
    if (!coordSys || seriesTooltipTrigger === "none" || seriesTooltipTrigger === false || seriesTooltipTrigger === "item" || seriesTooltipShow === false || seriesModel.get(["axisPointer", "show"], true) === false) {
      return;
    }
    each$f(result.coordSysAxesInfo[makeKey(coordSys.model)], function(axisInfo) {
      var axis = axisInfo.axis;
      if (coordSys.getAxis(axis.dim) === axis) {
        axisInfo.seriesModels.push(seriesModel);
        axisInfo.seriesDataCount == null && (axisInfo.seriesDataCount = 0);
        axisInfo.seriesDataCount += seriesModel.getData().count();
      }
    });
  });
}
function getLinkGroupIndex(linksOption, axis) {
  var axisModel = axis.model;
  var dim = axis.dim;
  for (var i = 0; i < linksOption.length; i++) {
    var linkOption = linksOption[i] || {};
    if (checkPropInLink(linkOption[dim + "AxisId"], axisModel.id) || checkPropInLink(linkOption[dim + "AxisIndex"], axisModel.componentIndex) || checkPropInLink(linkOption[dim + "AxisName"], axisModel.name)) {
      return i;
    }
  }
}
function checkPropInLink(linkPropValue, axisPropValue) {
  return linkPropValue === "all" || isArray$1(linkPropValue) && indexOf(linkPropValue, axisPropValue) >= 0 || linkPropValue === axisPropValue;
}
function fixValue(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  if (!axisInfo) {
    return;
  }
  var axisPointerModel = axisInfo.axisPointerModel;
  var scale2 = axisInfo.axis.scale;
  var option = axisPointerModel.option;
  var status = axisPointerModel.get("status");
  var value = axisPointerModel.get("value");
  if (value != null) {
    value = scale2.parse(value);
  }
  var useHandle = isHandleTrigger(axisPointerModel);
  if (status == null) {
    option.status = useHandle ? "show" : "hide";
  }
  var extent3 = scale2.getExtent().slice();
  extent3[0] > extent3[1] && extent3.reverse();
  if (value == null || value > extent3[1]) {
    value = extent3[1];
  }
  if (value < extent3[0]) {
    value = extent3[0];
  }
  option.value = value;
  if (useHandle) {
    option.status = axisInfo.axis.scale.isBlank() ? "hide" : "show";
  }
}
function getAxisInfo$1(axisModel) {
  var coordSysAxesInfo = (axisModel.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
  return coordSysAxesInfo && coordSysAxesInfo.axesInfo[makeKey(axisModel)];
}
function getAxisPointerModel(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  return axisInfo && axisInfo.axisPointerModel;
}
function isHandleTrigger(axisPointerModel) {
  return !!axisPointerModel.get(["handle", "show"]);
}
function makeKey(model) {
  return model.type + "||" + model.id;
}
var axisPointerClazz = {};
var AxisView = function(_super) {
  __extends(AxisView2, _super);
  function AxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisView2.type;
    return _this;
  }
  AxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.axisPointerClass && fixValue(axisModel);
    _super.prototype.render.apply(this, arguments);
    this._doUpdateAxisPointerClass(axisModel, api, true);
  };
  AxisView2.prototype.updateAxisPointer = function(axisModel, ecModel, api, payload) {
    this._doUpdateAxisPointerClass(axisModel, api, false);
  };
  AxisView2.prototype.remove = function(ecModel, api) {
    var axisPointer = this._axisPointer;
    axisPointer && axisPointer.remove(api);
  };
  AxisView2.prototype.dispose = function(ecModel, api) {
    this._disposeAxisPointer(api);
    _super.prototype.dispose.apply(this, arguments);
  };
  AxisView2.prototype._doUpdateAxisPointerClass = function(axisModel, api, forceRender) {
    var Clazz = AxisView2.getAxisPointerClass(this.axisPointerClass);
    if (!Clazz) {
      return;
    }
    var axisPointerModel = getAxisPointerModel(axisModel);
    axisPointerModel ? (this._axisPointer || (this._axisPointer = new Clazz())).render(axisModel, axisPointerModel, api, forceRender) : this._disposeAxisPointer(api);
  };
  AxisView2.prototype._disposeAxisPointer = function(api) {
    this._axisPointer && this._axisPointer.dispose(api);
    this._axisPointer = null;
  };
  AxisView2.registerAxisPointerClass = function(type4, clazz) {
    axisPointerClazz[type4] = clazz;
  };
  AxisView2.getAxisPointerClass = function(type4) {
    return type4 && axisPointerClazz[type4];
  };
  AxisView2.type = "axis";
  return AxisView2;
}(ComponentView$1);
var AxisView$1 = AxisView;
var inner$f = makeInner();
function rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel) {
  var axis = axisModel.axis;
  if (axis.scale.isBlank()) {
    return;
  }
  var splitAreaModel = axisModel.getModel("splitArea");
  var areaStyleModel = splitAreaModel.getModel("areaStyle");
  var areaColors = areaStyleModel.get("color");
  var gridRect = gridModel.coordinateSystem.getRect();
  var ticksCoords = axis.getTicksCoords({
    tickModel: splitAreaModel,
    clamp: true
  });
  if (!ticksCoords.length) {
    return;
  }
  var areaColorsLen = areaColors.length;
  var lastSplitAreaColors = inner$f(axisView).splitAreaColors;
  var newSplitAreaColors = createHashMap();
  var colorIndex = 0;
  if (lastSplitAreaColors) {
    for (var i = 0; i < ticksCoords.length; i++) {
      var cIndex = lastSplitAreaColors.get(ticksCoords[i].tickValue);
      if (cIndex != null) {
        colorIndex = (cIndex + (areaColorsLen - 1) * i) % areaColorsLen;
        break;
      }
    }
  }
  var prev = axis.toGlobalCoord(ticksCoords[0].coord);
  var areaStyle = areaStyleModel.getAreaStyle();
  areaColors = isArray$1(areaColors) ? areaColors : [areaColors];
  for (var i = 1; i < ticksCoords.length; i++) {
    var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
    var x2 = void 0;
    var y2 = void 0;
    var width = void 0;
    var height = void 0;
    if (axis.isHorizontal()) {
      x2 = prev;
      y2 = gridRect.y;
      width = tickCoord - x2;
      height = gridRect.height;
      prev = x2 + width;
    } else {
      x2 = gridRect.x;
      y2 = prev;
      width = gridRect.width;
      height = tickCoord - y2;
      prev = y2 + height;
    }
    var tickValue = ticksCoords[i - 1].tickValue;
    tickValue != null && newSplitAreaColors.set(tickValue, colorIndex);
    axisGroup.add(new Rect$3({
      anid: tickValue != null ? "area_" + tickValue : null,
      shape: {
        x: x2,
        y: y2,
        width,
        height
      },
      style: defaults({
        fill: areaColors[colorIndex]
      }, areaStyle),
      autoBatch: true,
      silent: true
    }));
    colorIndex = (colorIndex + 1) % areaColorsLen;
  }
  inner$f(axisView).splitAreaColors = newSplitAreaColors;
}
function rectCoordAxisHandleRemove(axisView) {
  inner$f(axisView).splitAreaColors = null;
}
var axisBuilderAttrs$3 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$2 = ["splitArea", "splitLine", "minorSplitLine"];
var CartesianAxisView = function(_super) {
  __extends(CartesianAxisView2, _super);
  function CartesianAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianAxisView2.type;
    _this.axisPointerClass = "CartesianAxisPointer";
    return _this;
  }
  CartesianAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var gridModel = axisModel.getCoordSysModel();
    var layout2 = layout$2(gridModel, axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, extend({
      handleAutoShown: function(elementType) {
        var cartesians = gridModel.coordinateSystem.getCartesians();
        for (var i = 0; i < cartesians.length; i++) {
          if (isIntervalOrLogScale(cartesians[i].getOtherAxis(axisModel.axis).scale)) {
            return true;
          }
        }
        return false;
      }
    }, layout2));
    each$f(axisBuilderAttrs$3, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    each$f(selfBuilderAttrs$2, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders$2[name](this, this._axisGroup, axisModel, gridModel);
      }
    }, this);
    var isInitialSortFromBarRacing = payload && payload.type === "changeAxisOrder" && payload.isInitSort;
    if (!isInitialSortFromBarRacing) {
      groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    }
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  CartesianAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  CartesianAxisView2.type = "cartesianAxis";
  return CartesianAxisView2;
}(AxisView$1);
var axisElementBuilders$2 = {
  splitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = isArray$1(lineColors) ? lineColors : [lineColors];
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < ticksCoords.length; i++) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      var tickValue = ticksCoords[i].tickValue;
      axisGroup.add(new Line$3({
        anid: tickValue != null ? "line_" + ticksCoords[i].tickValue : null,
        subPixelOptimize: true,
        autoBatch: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        style: defaults({
          stroke: lineColors[colorIndex]
        }, lineStyle),
        silent: true
      }));
    }
  },
  minorSplitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    var minorSplitLineModel = axisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var minorTicksCoords = axis.getMinorTicksCoords();
    if (!minorTicksCoords.length) {
      return;
    }
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        var tickCoord = axis.toGlobalCoord(minorTicksCoords[i][k2].coord);
        if (isHorizontal) {
          p1[0] = tickCoord;
          p1[1] = gridRect.y;
          p2[0] = tickCoord;
          p2[1] = gridRect.y + gridRect.height;
        } else {
          p1[0] = gridRect.x;
          p1[1] = tickCoord;
          p2[0] = gridRect.x + gridRect.width;
          p2[1] = tickCoord;
        }
        axisGroup.add(new Line$3({
          anid: "minor_line_" + minorTicksCoords[i][k2].tickValue,
          subPixelOptimize: true,
          autoBatch: true,
          shape: {
            x1: p1[0],
            y1: p1[1],
            x2: p2[0],
            y2: p2[1]
          },
          style: lineStyle,
          silent: true
        }));
      }
    }
  },
  splitArea: function(axisView, axisGroup, axisModel, gridModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel);
  }
};
var CartesianXAxisView = function(_super) {
  __extends(CartesianXAxisView2, _super);
  function CartesianXAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView2.type;
    return _this;
  }
  CartesianXAxisView2.type = "xAxis";
  return CartesianXAxisView2;
}(CartesianAxisView);
var CartesianYAxisView = function(_super) {
  __extends(CartesianYAxisView2, _super);
  function CartesianYAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView.type;
    return _this;
  }
  CartesianYAxisView2.type = "yAxis";
  return CartesianYAxisView2;
}(CartesianAxisView);
var GridView = function(_super) {
  __extends(GridView2, _super);
  function GridView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "grid";
    return _this;
  }
  GridView2.prototype.render = function(gridModel, ecModel) {
    this.group.removeAll();
    if (gridModel.get("show")) {
      this.group.add(new Rect$3({
        shape: gridModel.coordinateSystem.getRect(),
        style: defaults({
          fill: gridModel.get("backgroundColor")
        }, gridModel.getItemStyle()),
        silent: true,
        z2: -1
      }));
    }
  };
  GridView2.type = "grid";
  return GridView2;
}(ComponentView$1);
var extraOption = {
  offset: 0
};
function install$N(registers) {
  registers.registerComponentView(GridView);
  registers.registerComponentModel(GridModel$1);
  registers.registerCoordinateSystem("cartesian2d", Grid$1);
  axisModelCreator(registers, "x", CartesianAxisModel, extraOption);
  axisModelCreator(registers, "y", CartesianAxisModel, extraOption);
  registers.registerComponentView(CartesianXAxisView);
  registers.registerComponentView(CartesianYAxisView);
  registers.registerPreprocessor(function(option) {
    if (option.xAxis && option.yAxis && !option.grid) {
      option.grid = {};
    }
  });
}
function install$M(registers) {
  use(install$N);
  registers.registerSeriesModel(ScatterSeriesModel$1);
  registers.registerChartView(ScatterView$1);
  registers.registerLayout(pointsLayout("scatter"));
}
function radarLayout(ecModel) {
  ecModel.eachSeriesByType("radar", function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var axes = coordSys.getIndicatorAxes();
    each$f(axes, function(axis, axisIndex) {
      data.each(data.mapDimension(axes[axisIndex].dim), function(val, dataIndex) {
        points2[dataIndex] = points2[dataIndex] || [];
        var point = coordSys.dataToPoint(val, axisIndex);
        points2[dataIndex][axisIndex] = isValidPoint(point) ? point : getValueMissingPoint(coordSys);
      });
    });
    data.each(function(idx) {
      var firstPoint = find(points2[idx], function(point) {
        return isValidPoint(point);
      }) || getValueMissingPoint(coordSys);
      points2[idx].push(firstPoint.slice());
      data.setItemLayout(idx, points2[idx]);
    });
  });
}
function isValidPoint(point) {
  return !isNaN(point[0]) && !isNaN(point[1]);
}
function getValueMissingPoint(coordSys) {
  return [coordSys.cx, coordSys.cy];
}
function radarBackwardCompat(option) {
  var polarOptArr = option.polar;
  if (polarOptArr) {
    if (!isArray$1(polarOptArr)) {
      polarOptArr = [polarOptArr];
    }
    var polarNotRadar_1 = [];
    each$f(polarOptArr, function(polarOpt, idx) {
      if (polarOpt.indicator) {
        if (polarOpt.type && !polarOpt.shape) {
          polarOpt.shape = polarOpt.type;
        }
        option.radar = option.radar || [];
        if (!isArray$1(option.radar)) {
          option.radar = [option.radar];
        }
        option.radar.push(polarOpt);
      } else {
        polarNotRadar_1.push(polarOpt);
      }
    });
    option.polar = polarNotRadar_1;
  }
  each$f(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "radar" && seriesOpt.polarIndex) {
      seriesOpt.radarIndex = seriesOpt.polarIndex;
    }
  });
}
var RadarView$2 = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(seriesModel, ecModel, api) {
    var polar = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    function createSymbol2(data2, idx) {
      var symbolType = data2.getItemVisual(idx, "symbol") || "circle";
      if (symbolType === "none") {
        return;
      }
      var symbolSize = normalizeSymbolSize(data2.getItemVisual(idx, "symbolSize"));
      var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2);
      var symbolRotate = data2.getItemVisual(idx, "symbolRotate") || 0;
      symbolPath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 100,
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2,
        rotation: symbolRotate * Math.PI / 180 || 0
      });
      return symbolPath;
    }
    function updateSymbols(oldPoints, newPoints, symbolGroup, data2, idx, isInit) {
      symbolGroup.removeAll();
      for (var i = 0; i < newPoints.length - 1; i++) {
        var symbolPath = createSymbol2(data2, idx);
        if (symbolPath) {
          symbolPath.__dimIdx = i;
          if (oldPoints[i]) {
            symbolPath.setPosition(oldPoints[i]);
            graphic[isInit ? "initProps" : "updateProps"](symbolPath, {
              x: newPoints[i][0],
              y: newPoints[i][1]
            }, seriesModel, idx);
          } else {
            symbolPath.setPosition(newPoints[i]);
          }
          symbolGroup.add(symbolPath);
        }
      }
    }
    function getInitialPoints(points2) {
      return map$1(points2, function(pt) {
        return [polar.cx, polar.cy];
      });
    }
    data.diff(oldData).add(function(idx) {
      var points2 = data.getItemLayout(idx);
      if (!points2) {
        return;
      }
      var polygon = new Polygon$1();
      var polyline = new Polyline$3();
      var target = {
        shape: {
          points: points2
        }
      };
      polygon.shape.points = getInitialPoints(points2);
      polyline.shape.points = getInitialPoints(points2);
      initProps(polygon, target, seriesModel, idx);
      initProps(polyline, target, seriesModel, idx);
      var itemGroup = new Group$4();
      var symbolGroup = new Group$4();
      itemGroup.add(polyline);
      itemGroup.add(polygon);
      itemGroup.add(symbolGroup);
      updateSymbols(polyline.shape.points, points2, symbolGroup, data, idx, true);
      data.setItemGraphicEl(idx, itemGroup);
    }).update(function(newIdx, oldIdx) {
      var itemGroup = oldData.getItemGraphicEl(oldIdx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var target = {
        shape: {
          points: data.getItemLayout(newIdx)
        }
      };
      if (!target.shape.points) {
        return;
      }
      updateSymbols(polyline.shape.points, target.shape.points, symbolGroup, data, newIdx, false);
      saveOldStyle(polygon);
      saveOldStyle(polyline);
      updateProps$1(polyline, target, seriesModel);
      updateProps$1(polygon, target, seriesModel);
      data.setItemGraphicEl(newIdx, itemGroup);
    }).remove(function(idx) {
      group.remove(oldData.getItemGraphicEl(idx));
    }).execute();
    data.eachItemGraphicEl(function(itemGroup, idx) {
      var itemModel = data.getItemModel(idx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var itemStyle = data.getItemVisual(idx, "style");
      var color = itemStyle.fill;
      group.add(itemGroup);
      polyline.useStyle(defaults(itemModel.getModel("lineStyle").getLineStyle(), {
        fill: "none",
        stroke: color
      }));
      setStatesStylesFromModel(polyline, itemModel, "lineStyle");
      setStatesStylesFromModel(polygon, itemModel, "areaStyle");
      var areaStyleModel = itemModel.getModel("areaStyle");
      var polygonIgnore = areaStyleModel.isEmpty() && areaStyleModel.parentModel.isEmpty();
      polygon.ignore = polygonIgnore;
      each$f(["emphasis", "select", "blur"], function(stateName) {
        var stateModel = itemModel.getModel([stateName, "areaStyle"]);
        var stateIgnore = stateModel.isEmpty() && stateModel.parentModel.isEmpty();
        polygon.ensureState(stateName).ignore = stateIgnore && polygonIgnore;
      });
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: color,
        opacity: 0.7,
        decal: itemStyle.decal
      }));
      var emphasisModel = itemModel.getModel("emphasis");
      var itemHoverStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      symbolGroup.eachChild(function(symbolPath) {
        if (symbolPath instanceof ZRImage$1) {
          var pathStyle = symbolPath.style;
          symbolPath.useStyle(extend({
            image: pathStyle.image,
            x: pathStyle.x,
            y: pathStyle.y,
            width: pathStyle.width,
            height: pathStyle.height
          }, itemStyle));
        } else {
          symbolPath.useStyle(itemStyle);
          symbolPath.setColor(color);
          symbolPath.style.strokeNoScale = true;
        }
        var pathEmphasisState = symbolPath.ensureState("emphasis");
        pathEmphasisState.style = clone$4(itemHoverStyle);
        var defaultText = data.getStore().get(data.getDimensionIndex(symbolPath.__dimIdx), idx);
        (defaultText == null || isNaN(defaultText)) && (defaultText = "");
        setLabelStyle(symbolPath, getLabelStatesModels(itemModel), {
          labelFetcher: data.hostModel,
          labelDataIndex: idx,
          labelDimIndex: symbolPath.__dimIdx,
          defaultText,
          inheritColor: color,
          defaultOpacity: itemStyle.opacity
        });
      });
      toggleHoverEmphasis(itemGroup, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    this._data = data;
  };
  RadarView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ChartView$1);
var RadarView$3 = RadarView$2;
var RadarSeriesModel = function(_super) {
  __extends(RadarSeriesModel2, _super);
  function RadarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  RadarSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  RadarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      generateCoord: "indicator_",
      generateCoordCount: Infinity
    });
  };
  RadarSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var coordSys = this.coordinateSystem;
    var indicatorAxes = coordSys.getIndicatorAxes();
    var name = this.getData().getName(dataIndex);
    var nameToDisplay = name === "" ? this.name : name;
    var markerColor = retrieveVisualColorForTooltipMarker(this, dataIndex);
    return createTooltipMarkup("section", {
      header: nameToDisplay,
      sortBlocks: true,
      blocks: map$1(indicatorAxes, function(axis) {
        var val = data.get(data.mapDimension(axis.dim), dataIndex);
        return createTooltipMarkup("nameValue", {
          markerType: "subItem",
          markerColor,
          name: axis.name,
          value: val,
          sortParam: val
        });
      })
    });
  };
  RadarSeriesModel2.prototype.getTooltipPosition = function(dataIndex) {
    if (dataIndex != null) {
      var data_1 = this.getData();
      var coordSys = this.coordinateSystem;
      var values = data_1.getValues(map$1(coordSys.dimensions, function(dim) {
        return data_1.mapDimension(dim);
      }), dataIndex);
      for (var i = 0, len2 = values.length; i < len2; i++) {
        if (!isNaN(values[i])) {
          var indicatorAxes = coordSys.getIndicatorAxes();
          return coordSys.coordToPoint(indicatorAxes[i].dataToCoord(values[i]), i);
        }
      }
    }
  };
  RadarSeriesModel2.type = "series.radar";
  RadarSeriesModel2.dependencies = ["radar"];
  RadarSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "radar",
    legendHoverLink: true,
    radarIndex: 0,
    lineStyle: {
      width: 2,
      type: "solid",
      join: "round"
    },
    label: {
      position: "top"
    },
    symbolSize: 8
  };
  return RadarSeriesModel2;
}(SeriesModel$1);
var RadarSeriesModel$1 = RadarSeriesModel;
var valueAxisDefault = axisDefault.value;
function defaultsShow(opt, show) {
  return defaults({
    show
  }, opt);
}
var RadarModel = function(_super) {
  __extends(RadarModel2, _super);
  function RadarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarModel2.type;
    return _this;
  }
  RadarModel2.prototype.optionUpdated = function() {
    var boundaryGap = this.get("boundaryGap");
    var splitNumber = this.get("splitNumber");
    var scale2 = this.get("scale");
    var axisLine = this.get("axisLine");
    var axisTick = this.get("axisTick");
    var axisLabel = this.get("axisLabel");
    var nameTextStyle = this.get("axisName");
    var showName = this.get(["axisName", "show"]);
    var nameFormatter = this.get(["axisName", "formatter"]);
    var nameGap = this.get("axisNameGap");
    var triggerEvent = this.get("triggerEvent");
    var indicatorModels = map$1(this.get("indicator") || [], function(indicatorOpt) {
      if (indicatorOpt.max != null && indicatorOpt.max > 0 && !indicatorOpt.min) {
        indicatorOpt.min = 0;
      } else if (indicatorOpt.min != null && indicatorOpt.min < 0 && !indicatorOpt.max) {
        indicatorOpt.max = 0;
      }
      var iNameTextStyle = nameTextStyle;
      if (indicatorOpt.color != null) {
        iNameTextStyle = defaults({
          color: indicatorOpt.color
        }, nameTextStyle);
      }
      var innerIndicatorOpt = merge(clone$4(indicatorOpt), {
        boundaryGap,
        splitNumber,
        scale: scale2,
        axisLine,
        axisTick,
        axisLabel,
        name: indicatorOpt.text,
        showName,
        nameLocation: "end",
        nameGap,
        nameTextStyle: iNameTextStyle,
        triggerEvent
      }, false);
      if (!showName) {
        innerIndicatorOpt.name = "";
      }
      if (isString(nameFormatter)) {
        var indName = innerIndicatorOpt.name;
        innerIndicatorOpt.name = nameFormatter.replace("{value}", indName != null ? indName : "");
      } else if (isFunction(nameFormatter)) {
        innerIndicatorOpt.name = nameFormatter(innerIndicatorOpt.name, innerIndicatorOpt);
      }
      var model = new Model$1(innerIndicatorOpt, null, this.ecModel);
      mixin(model, AxisModelCommonMixin.prototype);
      model.mainType = "radar";
      model.componentIndex = this.componentIndex;
      return model;
    }, this);
    this._indicatorModels = indicatorModels;
  };
  RadarModel2.prototype.getIndicatorModels = function() {
    return this._indicatorModels;
  };
  RadarModel2.type = "radar";
  RadarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "75%",
    startAngle: 90,
    axisName: {
      show: true
    },
    boundaryGap: [0, 0],
    splitNumber: 5,
    axisNameGap: 15,
    scale: false,
    shape: "polygon",
    axisLine: merge({
      lineStyle: {
        color: "#bbb"
      }
    }, valueAxisDefault.axisLine),
    axisLabel: defaultsShow(valueAxisDefault.axisLabel, false),
    axisTick: defaultsShow(valueAxisDefault.axisTick, false),
    splitLine: defaultsShow(valueAxisDefault.splitLine, true),
    splitArea: defaultsShow(valueAxisDefault.splitArea, true),
    indicator: []
  };
  return RadarModel2;
}(ComponentModel$1);
var RadarModel$1 = RadarModel;
var axisBuilderAttrs$2 = ["axisLine", "axisTickLabel", "axisName"];
var RadarView = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(radarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    this._buildAxes(radarModel);
    this._buildSplitLineAndArea(radarModel);
  };
  RadarView2.prototype._buildAxes = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    var axisBuilders = map$1(indicatorAxes, function(indicatorAxis) {
      var axisName = indicatorAxis.model.get("showName") ? indicatorAxis.name : "";
      var axisBuilder = new AxisBuilder$1(indicatorAxis.model, {
        axisName,
        position: [radar.cx, radar.cy],
        rotation: indicatorAxis.angle,
        labelDirection: -1,
        tickDirection: -1,
        nameDirection: 1
      });
      return axisBuilder;
    });
    each$f(axisBuilders, function(axisBuilder) {
      each$f(axisBuilderAttrs$2, axisBuilder.add, axisBuilder);
      this.group.add(axisBuilder.getGroup());
    }, this);
  };
  RadarView2.prototype._buildSplitLineAndArea = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    if (!indicatorAxes.length) {
      return;
    }
    var shape = radarModel.get("shape");
    var splitLineModel = radarModel.getModel("splitLine");
    var splitAreaModel = radarModel.getModel("splitArea");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var showSplitLine = splitLineModel.get("show");
    var showSplitArea = splitAreaModel.get("show");
    var splitLineColors = lineStyleModel.get("color");
    var splitAreaColors = areaStyleModel.get("color");
    var splitLineColorsArr = isArray$1(splitLineColors) ? splitLineColors : [splitLineColors];
    var splitAreaColorsArr = isArray$1(splitAreaColors) ? splitAreaColors : [splitAreaColors];
    var splitLines = [];
    var splitAreas = [];
    function getColorIndex(areaOrLine, areaOrLineColorList, idx) {
      var colorIndex2 = idx % areaOrLineColorList.length;
      areaOrLine[colorIndex2] = areaOrLine[colorIndex2] || [];
      return colorIndex2;
    }
    if (shape === "circle") {
      var ticksRadius = indicatorAxes[0].getTicksCoords();
      var cx = radar.cx;
      var cy = radar.cy;
      for (var i = 0; i < ticksRadius.length; i++) {
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Circle$1({
            shape: {
              cx,
              cy,
              r: ticksRadius[i].coord
            }
          }));
        }
        if (showSplitArea && i < ticksRadius.length - 1) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i);
          splitAreas[colorIndex].push(new Ring$1({
            shape: {
              cx,
              cy,
              r0: ticksRadius[i].coord,
              r: ticksRadius[i + 1].coord
            }
          }));
        }
      }
    } else {
      var realSplitNumber_1;
      var axesTicksPoints = map$1(indicatorAxes, function(indicatorAxis, idx) {
        var ticksCoords = indicatorAxis.getTicksCoords();
        realSplitNumber_1 = realSplitNumber_1 == null ? ticksCoords.length - 1 : Math.min(ticksCoords.length - 1, realSplitNumber_1);
        return map$1(ticksCoords, function(tickCoord) {
          return radar.coordToPoint(tickCoord.coord, idx);
        });
      });
      var prevPoints = [];
      for (var i = 0; i <= realSplitNumber_1; i++) {
        var points2 = [];
        for (var j = 0; j < indicatorAxes.length; j++) {
          points2.push(axesTicksPoints[j][i]);
        }
        if (points2[0]) {
          points2.push(points2[0].slice());
        }
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Polyline$3({
            shape: {
              points: points2
            }
          }));
        }
        if (showSplitArea && prevPoints) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i - 1);
          splitAreas[colorIndex].push(new Polygon$1({
            shape: {
              points: points2.concat(prevPoints)
            }
          }));
        }
        prevPoints = points2.slice().reverse();
      }
    }
    var lineStyle = lineStyleModel.getLineStyle();
    var areaStyle = areaStyleModel.getAreaStyle();
    each$f(splitAreas, function(splitAreas2, idx) {
      this.group.add(mergePath(splitAreas2, {
        style: defaults({
          stroke: "none",
          fill: splitAreaColorsArr[idx % splitAreaColorsArr.length]
        }, areaStyle),
        silent: true
      }));
    }, this);
    each$f(splitLines, function(splitLines2, idx) {
      this.group.add(mergePath(splitLines2, {
        style: defaults({
          fill: "none",
          stroke: splitLineColorsArr[idx % splitLineColorsArr.length]
        }, lineStyle),
        silent: true
      }));
    }, this);
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ComponentView$1);
var RadarView$1 = RadarView;
var IndicatorAxis = function(_super) {
  __extends(IndicatorAxis2, _super);
  function IndicatorAxis2(dim, scale2, radiusExtent) {
    var _this = _super.call(this, dim, scale2, radiusExtent) || this;
    _this.type = "value";
    _this.angle = 0;
    _this.name = "";
    return _this;
  }
  return IndicatorAxis2;
}(Axis$1);
var IndicatorAxis$1 = IndicatorAxis;
var Radar = function() {
  function Radar2(radarModel, ecModel, api) {
    this.dimensions = [];
    this._model = radarModel;
    this._indicatorAxes = map$1(radarModel.getIndicatorModels(), function(indicatorModel, idx) {
      var dim = "indicator_" + idx;
      var indicatorAxis = new IndicatorAxis$1(dim, new IntervalScale$1());
      indicatorAxis.name = indicatorModel.get("name");
      indicatorAxis.model = indicatorModel;
      indicatorModel.axis = indicatorAxis;
      this.dimensions.push(dim);
      return indicatorAxis;
    }, this);
    this.resize(radarModel, api);
  }
  Radar2.prototype.getIndicatorAxes = function() {
    return this._indicatorAxes;
  };
  Radar2.prototype.dataToPoint = function(value, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    return this.coordToPoint(indicatorAxis.dataToCoord(value), indicatorIndex);
  };
  Radar2.prototype.coordToPoint = function(coord, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    var angle = indicatorAxis.angle;
    var x2 = this.cx + coord * Math.cos(angle);
    var y2 = this.cy - coord * Math.sin(angle);
    return [x2, y2];
  };
  Radar2.prototype.pointToData = function(pt) {
    var dx = pt[0] - this.cx;
    var dy = pt[1] - this.cy;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx);
    var minRadianDiff = Infinity;
    var closestAxis;
    var closestAxisIdx = -1;
    for (var i = 0; i < this._indicatorAxes.length; i++) {
      var indicatorAxis = this._indicatorAxes[i];
      var diff = Math.abs(radian - indicatorAxis.angle);
      if (diff < minRadianDiff) {
        closestAxis = indicatorAxis;
        closestAxisIdx = i;
        minRadianDiff = diff;
      }
    }
    return [closestAxisIdx, +(closestAxis && closestAxis.coordToData(radius))];
  };
  Radar2.prototype.resize = function(radarModel, api) {
    var center2 = radarModel.get("center");
    var viewWidth = api.getWidth();
    var viewHeight = api.getHeight();
    var viewSize = Math.min(viewWidth, viewHeight) / 2;
    this.cx = parsePercent(center2[0], viewWidth);
    this.cy = parsePercent(center2[1], viewHeight);
    this.startAngle = radarModel.get("startAngle") * Math.PI / 180;
    var radius = radarModel.get("radius");
    if (isString(radius) || isNumber(radius)) {
      radius = [0, radius];
    }
    this.r0 = parsePercent(radius[0], viewSize);
    this.r = parsePercent(radius[1], viewSize);
    each$f(this._indicatorAxes, function(indicatorAxis, idx) {
      indicatorAxis.setExtent(this.r0, this.r);
      var angle = this.startAngle + idx * Math.PI * 2 / this._indicatorAxes.length;
      angle = Math.atan2(Math.sin(angle), Math.cos(angle));
      indicatorAxis.angle = angle;
    }, this);
  };
  Radar2.prototype.update = function(ecModel, api) {
    var indicatorAxes = this._indicatorAxes;
    var radarModel = this._model;
    each$f(indicatorAxes, function(indicatorAxis) {
      indicatorAxis.scale.setExtent(Infinity, -Infinity);
    });
    ecModel.eachSeriesByType("radar", function(radarSeries, idx) {
      if (radarSeries.get("coordinateSystem") !== "radar" || ecModel.getComponent("radar", radarSeries.get("radarIndex")) !== radarModel) {
        return;
      }
      var data = radarSeries.getData();
      each$f(indicatorAxes, function(indicatorAxis) {
        indicatorAxis.scale.unionExtentFromData(data, data.mapDimension(indicatorAxis.dim));
      });
    }, this);
    var splitNumber = radarModel.get("splitNumber");
    var dummyScale = new IntervalScale$1();
    dummyScale.setExtent(0, splitNumber);
    dummyScale.setInterval(1);
    each$f(indicatorAxes, function(indicatorAxis, idx) {
      alignScaleTicks(indicatorAxis.scale, indicatorAxis.model, dummyScale);
    });
  };
  Radar2.prototype.convertToPixel = function(ecModel, finder, value) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Radar2.create = function(ecModel, api) {
    var radarList = [];
    ecModel.eachComponent("radar", function(radarModel) {
      var radar = new Radar2(radarModel, ecModel, api);
      radarList.push(radar);
      radarModel.coordinateSystem = radar;
    });
    ecModel.eachSeriesByType("radar", function(radarSeries) {
      if (radarSeries.get("coordinateSystem") === "radar") {
        radarSeries.coordinateSystem = radarList[radarSeries.get("radarIndex") || 0];
      }
    });
    return radarList;
  };
  Radar2.dimensions = [];
  return Radar2;
}();
var Radar$1 = Radar;
function install$L(registers) {
  registers.registerCoordinateSystem("radar", Radar$1);
  registers.registerComponentModel(RadarModel$1);
  registers.registerComponentView(RadarView$1);
  registers.registerVisual({
    seriesType: "radar",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      data.each(function(idx) {
        data.setItemVisual(idx, "legendIcon", "roundRect");
      });
      data.setVisual("legendIcon", "roundRect");
    }
  });
}
function install$K(registers) {
  use(install$L);
  registers.registerChartView(RadarView$3);
  registers.registerSeriesModel(RadarSeriesModel$1);
  registers.registerLayout(radarLayout);
  registers.registerProcessor(dataFilter$1("radar"));
  registers.registerPreprocessor(radarBackwardCompat);
}
var ATTR = "\0_ec_interaction_mutex";
function take(zr, resourceKey, userKey) {
  var store = getStore(zr);
  store[resourceKey] = userKey;
}
function release(zr, resourceKey, userKey) {
  var store = getStore(zr);
  var uKey = store[resourceKey];
  if (uKey === userKey) {
    store[resourceKey] = null;
  }
}
function isTaken(zr, resourceKey) {
  return !!getStore(zr)[resourceKey];
}
function getStore(zr) {
  return zr[ATTR] || (zr[ATTR] = {});
}
registerAction({
  type: "takeGlobalCursor",
  event: "globalCursorTaken",
  update: "update"
}, noop);
var RoamController = function(_super) {
  __extends(RoamController2, _super);
  function RoamController2(zr) {
    var _this = _super.call(this) || this;
    _this._zr = zr;
    var mousedownHandler = bind$1(_this._mousedownHandler, _this);
    var mousemoveHandler = bind$1(_this._mousemoveHandler, _this);
    var mouseupHandler = bind$1(_this._mouseupHandler, _this);
    var mousewheelHandler = bind$1(_this._mousewheelHandler, _this);
    var pinchHandler = bind$1(_this._pinchHandler, _this);
    _this.enable = function(controlType, opt) {
      this.disable();
      this._opt = defaults(clone$4(opt) || {}, {
        zoomOnMouseWheel: true,
        moveOnMouseMove: true,
        moveOnMouseWheel: false,
        preventDefaultMouseMove: true
      });
      if (controlType == null) {
        controlType = true;
      }
      if (controlType === true || controlType === "move" || controlType === "pan") {
        zr.on("mousedown", mousedownHandler);
        zr.on("mousemove", mousemoveHandler);
        zr.on("mouseup", mouseupHandler);
      }
      if (controlType === true || controlType === "scale" || controlType === "zoom") {
        zr.on("mousewheel", mousewheelHandler);
        zr.on("pinch", pinchHandler);
      }
    };
    _this.disable = function() {
      zr.off("mousedown", mousedownHandler);
      zr.off("mousemove", mousemoveHandler);
      zr.off("mouseup", mouseupHandler);
      zr.off("mousewheel", mousewheelHandler);
      zr.off("pinch", pinchHandler);
    };
    return _this;
  }
  RoamController2.prototype.isDragging = function() {
    return this._dragging;
  };
  RoamController2.prototype.isPinching = function() {
    return this._pinching;
  };
  RoamController2.prototype.setPointerChecker = function(pointerChecker) {
    this.pointerChecker = pointerChecker;
  };
  RoamController2.prototype.dispose = function() {
    this.disable();
  };
  RoamController2.prototype._mousedownHandler = function(e2) {
    if (isMiddleOrRightButtonOnMouseUpDown(e2) || e2.target && e2.target.draggable) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    if (this.pointerChecker && this.pointerChecker(e2, x2, y2)) {
      this._x = x2;
      this._y = y2;
      this._dragging = true;
    }
  };
  RoamController2.prototype._mousemoveHandler = function(e2) {
    if (!this._dragging || !isAvailableBehavior("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || isTaken(this._zr, "globalPan")) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var oldX = this._x;
    var oldY = this._y;
    var dx = x2 - oldX;
    var dy = y2 - oldY;
    this._x = x2;
    this._y = y2;
    this._opt.preventDefaultMouseMove && stop(e2.event);
    trigger$1(this, "pan", "moveOnMouseMove", e2, {
      dx,
      dy,
      oldX,
      oldY,
      newX: x2,
      newY: y2,
      isAvailableBehavior: null
    });
  };
  RoamController2.prototype._mouseupHandler = function(e2) {
    if (!isMiddleOrRightButtonOnMouseUpDown(e2)) {
      this._dragging = false;
    }
  };
  RoamController2.prototype._mousewheelHandler = function(e2) {
    var shouldZoom = isAvailableBehavior("zoomOnMouseWheel", e2, this._opt);
    var shouldMove = isAvailableBehavior("moveOnMouseWheel", e2, this._opt);
    var wheelDelta = e2.wheelDelta;
    var absWheelDeltaDelta = Math.abs(wheelDelta);
    var originX = e2.offsetX;
    var originY = e2.offsetY;
    if (wheelDelta === 0 || !shouldZoom && !shouldMove) {
      return;
    }
    if (shouldZoom) {
      var factor = absWheelDeltaDelta > 3 ? 1.4 : absWheelDeltaDelta > 1 ? 1.2 : 1.1;
      var scale2 = wheelDelta > 0 ? factor : 1 / factor;
      checkPointerAndTrigger(this, "zoom", "zoomOnMouseWheel", e2, {
        scale: scale2,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
    if (shouldMove) {
      var absDelta = Math.abs(wheelDelta);
      var scrollDelta = (wheelDelta > 0 ? 1 : -1) * (absDelta > 3 ? 0.4 : absDelta > 1 ? 0.15 : 0.05);
      checkPointerAndTrigger(this, "scrollMove", "moveOnMouseWheel", e2, {
        scrollDelta,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
  };
  RoamController2.prototype._pinchHandler = function(e2) {
    if (isTaken(this._zr, "globalPan")) {
      return;
    }
    var scale2 = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
    checkPointerAndTrigger(this, "zoom", null, e2, {
      scale: scale2,
      originX: e2.pinchX,
      originY: e2.pinchY,
      isAvailableBehavior: null
    });
  };
  return RoamController2;
}(Eventful$1);
function checkPointerAndTrigger(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  if (controller.pointerChecker && controller.pointerChecker(e2, contollerEvent.originX, contollerEvent.originY)) {
    stop(e2.event);
    trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent);
  }
}
function trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  contollerEvent.isAvailableBehavior = bind$1(isAvailableBehavior, null, behaviorToCheck, e2);
  controller.trigger(eventName, contollerEvent);
}
function isAvailableBehavior(behaviorToCheck, e2, settings) {
  var setting = settings[behaviorToCheck];
  return !behaviorToCheck || setting && (!isString(setting) || e2.event[setting + "Key"]);
}
var RoamController$1 = RoamController;
function updateViewOnPan(controllerHost, dx, dy) {
  var target = controllerHost.target;
  target.x += dx;
  target.y += dy;
  target.dirty();
}
function updateViewOnZoom(controllerHost, zoomDelta, zoomX, zoomY) {
  var target = controllerHost.target;
  var zoomLimit = controllerHost.zoomLimit;
  var newZoom = controllerHost.zoom = controllerHost.zoom || 1;
  newZoom *= zoomDelta;
  if (zoomLimit) {
    var zoomMin = zoomLimit.min || 0;
    var zoomMax = zoomLimit.max || Infinity;
    newZoom = Math.max(Math.min(zoomMax, newZoom), zoomMin);
  }
  var zoomScale = newZoom / controllerHost.zoom;
  controllerHost.zoom = newZoom;
  target.x -= (zoomX - target.x) * (zoomScale - 1);
  target.y -= (zoomY - target.y) * (zoomScale - 1);
  target.scaleX *= zoomScale;
  target.scaleY *= zoomScale;
  target.dirty();
}
var IRRELEVANT_EXCLUDES = {
  "axisPointer": 1,
  "tooltip": 1,
  "brush": 1
};
function onIrrelevantElement(e2, api, targetCoordSysModel) {
  var model = api.getComponentByElement(e2.topTarget);
  var coordSys = model && model.coordinateSystem;
  return model && model !== targetCoordSysModel && !IRRELEVANT_EXCLUDES.hasOwnProperty(model.mainType) && coordSys && coordSys.model !== targetCoordSysModel;
}
function parseXML(svg) {
  if (isString(svg)) {
    var parser = new DOMParser();
    svg = parser.parseFromString(svg, "text/xml");
  }
  var svgNode = svg;
  if (svgNode.nodeType === 9) {
    svgNode = svgNode.firstChild;
  }
  while (svgNode.nodeName.toLowerCase() !== "svg" || svgNode.nodeType !== 1) {
    svgNode = svgNode.nextSibling;
  }
  return svgNode;
}
var nodeParsers;
var INHERITABLE_STYLE_ATTRIBUTES_MAP = {
  "fill": "fill",
  "stroke": "stroke",
  "stroke-width": "lineWidth",
  "opacity": "opacity",
  "fill-opacity": "fillOpacity",
  "stroke-opacity": "strokeOpacity",
  "stroke-dasharray": "lineDash",
  "stroke-dashoffset": "lineDashOffset",
  "stroke-linecap": "lineCap",
  "stroke-linejoin": "lineJoin",
  "stroke-miterlimit": "miterLimit",
  "font-family": "fontFamily",
  "font-size": "fontSize",
  "font-style": "fontStyle",
  "font-weight": "fontWeight",
  "text-anchor": "textAlign",
  "visibility": "visibility",
  "display": "display"
};
var INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS = keys(INHERITABLE_STYLE_ATTRIBUTES_MAP);
var SELF_STYLE_ATTRIBUTES_MAP = {
  "alignment-baseline": "textBaseline",
  "stop-color": "stopColor"
};
var SELF_STYLE_ATTRIBUTES_MAP_KEYS = keys(SELF_STYLE_ATTRIBUTES_MAP);
var SVGParser = function() {
  function SVGParser2() {
    this._defs = {};
    this._root = null;
  }
  SVGParser2.prototype.parse = function(xml, opt) {
    opt = opt || {};
    var svg = parseXML(xml);
    this._defsUsePending = [];
    var root2 = new Group$4();
    this._root = root2;
    var named = [];
    var viewBox = svg.getAttribute("viewBox") || "";
    var width = parseFloat(svg.getAttribute("width") || opt.width);
    var height = parseFloat(svg.getAttribute("height") || opt.height);
    isNaN(width) && (width = null);
    isNaN(height) && (height = null);
    parseAttributes(svg, root2, null, true, false);
    var child = svg.firstChild;
    while (child) {
      this._parseNode(child, root2, named, null, false, false);
      child = child.nextSibling;
    }
    applyDefs(this._defs, this._defsUsePending);
    this._defsUsePending = [];
    var viewBoxRect;
    var viewBoxTransform;
    if (viewBox) {
      var viewBoxArr = splitNumberSequence(viewBox);
      if (viewBoxArr.length >= 4) {
        viewBoxRect = {
          x: parseFloat(viewBoxArr[0] || 0),
          y: parseFloat(viewBoxArr[1] || 0),
          width: parseFloat(viewBoxArr[2]),
          height: parseFloat(viewBoxArr[3])
        };
      }
    }
    if (viewBoxRect && width != null && height != null) {
      viewBoxTransform = makeViewBoxTransform(viewBoxRect, { x: 0, y: 0, width, height });
      if (!opt.ignoreViewBox) {
        var elRoot = root2;
        root2 = new Group$4();
        root2.add(elRoot);
        elRoot.scaleX = elRoot.scaleY = viewBoxTransform.scale;
        elRoot.x = viewBoxTransform.x;
        elRoot.y = viewBoxTransform.y;
      }
    }
    if (!opt.ignoreRootClip && width != null && height != null) {
      root2.setClipPath(new Rect$3({
        shape: { x: 0, y: 0, width, height }
      }));
    }
    return {
      root: root2,
      width,
      height,
      viewBoxRect,
      viewBoxTransform,
      named
    };
  };
  SVGParser2.prototype._parseNode = function(xmlNode, parentGroup, named, namedFrom, isInDefs, isInText) {
    var nodeName = xmlNode.nodeName.toLowerCase();
    var el;
    var namedFromForSub = namedFrom;
    if (nodeName === "defs") {
      isInDefs = true;
    }
    if (nodeName === "text") {
      isInText = true;
    }
    if (nodeName === "defs" || nodeName === "switch") {
      el = parentGroup;
    } else {
      if (!isInDefs) {
        var parser_1 = nodeParsers[nodeName];
        if (parser_1 && hasOwn(nodeParsers, nodeName)) {
          el = parser_1.call(this, xmlNode, parentGroup);
          var nameAttr = xmlNode.getAttribute("name");
          if (nameAttr) {
            var newNamed = {
              name: nameAttr,
              namedFrom: null,
              svgNodeTagLower: nodeName,
              el
            };
            named.push(newNamed);
            if (nodeName === "g") {
              namedFromForSub = newNamed;
            }
          } else if (namedFrom) {
            named.push({
              name: namedFrom.name,
              namedFrom,
              svgNodeTagLower: nodeName,
              el
            });
          }
          parentGroup.add(el);
        }
      }
      var parser = paintServerParsers[nodeName];
      if (parser && hasOwn(paintServerParsers, nodeName)) {
        var def = parser.call(this, xmlNode);
        var id2 = xmlNode.getAttribute("id");
        if (id2) {
          this._defs[id2] = def;
        }
      }
    }
    if (el && el.isGroup) {
      var child = xmlNode.firstChild;
      while (child) {
        if (child.nodeType === 1) {
          this._parseNode(child, el, named, namedFromForSub, isInDefs, isInText);
        } else if (child.nodeType === 3 && isInText) {
          this._parseText(child, el);
        }
        child = child.nextSibling;
      }
    }
  };
  SVGParser2.prototype._parseText = function(xmlNode, parentGroup) {
    var text = new TSpan$1({
      style: {
        text: xmlNode.textContent
      },
      silent: true,
      x: this._textX || 0,
      y: this._textY || 0
    });
    inheritStyle(parentGroup, text);
    parseAttributes(xmlNode, text, this._defsUsePending, false, false);
    applyTextAlignment(text, parentGroup);
    var textStyle = text.style;
    var fontSize = textStyle.fontSize;
    if (fontSize && fontSize < 9) {
      textStyle.fontSize = 9;
      text.scaleX *= fontSize / 9;
      text.scaleY *= fontSize / 9;
    }
    var font = (textStyle.fontSize || textStyle.fontFamily) && [
      textStyle.fontStyle,
      textStyle.fontWeight,
      (textStyle.fontSize || 12) + "px",
      textStyle.fontFamily || "sans-serif"
    ].join(" ");
    textStyle.font = font;
    var rect = text.getBoundingRect();
    this._textX += rect.width;
    parentGroup.add(text);
    return text;
  };
  SVGParser2.internalField = function() {
    nodeParsers = {
      "g": function(xmlNode, parentGroup) {
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, false);
        return g2;
      },
      "rect": function(xmlNode, parentGroup) {
        var rect = new Rect$3();
        inheritStyle(parentGroup, rect);
        parseAttributes(xmlNode, rect, this._defsUsePending, false, false);
        rect.setShape({
          x: parseFloat(xmlNode.getAttribute("x") || "0"),
          y: parseFloat(xmlNode.getAttribute("y") || "0"),
          width: parseFloat(xmlNode.getAttribute("width") || "0"),
          height: parseFloat(xmlNode.getAttribute("height") || "0")
        });
        rect.silent = true;
        return rect;
      },
      "circle": function(xmlNode, parentGroup) {
        var circle = new Circle$1();
        inheritStyle(parentGroup, circle);
        parseAttributes(xmlNode, circle, this._defsUsePending, false, false);
        circle.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          r: parseFloat(xmlNode.getAttribute("r") || "0")
        });
        circle.silent = true;
        return circle;
      },
      "line": function(xmlNode, parentGroup) {
        var line = new Line$3();
        inheritStyle(parentGroup, line);
        parseAttributes(xmlNode, line, this._defsUsePending, false, false);
        line.setShape({
          x1: parseFloat(xmlNode.getAttribute("x1") || "0"),
          y1: parseFloat(xmlNode.getAttribute("y1") || "0"),
          x2: parseFloat(xmlNode.getAttribute("x2") || "0"),
          y2: parseFloat(xmlNode.getAttribute("y2") || "0")
        });
        line.silent = true;
        return line;
      },
      "ellipse": function(xmlNode, parentGroup) {
        var ellipse = new Ellipse$1();
        inheritStyle(parentGroup, ellipse);
        parseAttributes(xmlNode, ellipse, this._defsUsePending, false, false);
        ellipse.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          rx: parseFloat(xmlNode.getAttribute("rx") || "0"),
          ry: parseFloat(xmlNode.getAttribute("ry") || "0")
        });
        ellipse.silent = true;
        return ellipse;
      },
      "polygon": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polygon = new Polygon$1({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polygon);
        parseAttributes(xmlNode, polygon, this._defsUsePending, false, false);
        return polygon;
      },
      "polyline": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polyline = new Polyline$3({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polyline);
        parseAttributes(xmlNode, polyline, this._defsUsePending, false, false);
        return polyline;
      },
      "image": function(xmlNode, parentGroup) {
        var img = new ZRImage$1();
        inheritStyle(parentGroup, img);
        parseAttributes(xmlNode, img, this._defsUsePending, false, false);
        img.setStyle({
          image: xmlNode.getAttribute("xlink:href") || xmlNode.getAttribute("href"),
          x: +xmlNode.getAttribute("x"),
          y: +xmlNode.getAttribute("y"),
          width: +xmlNode.getAttribute("width"),
          height: +xmlNode.getAttribute("height")
        });
        img.silent = true;
        return img;
      },
      "text": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x") || "0";
        var y2 = xmlNode.getAttribute("y") || "0";
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        this._textX = parseFloat(x2) + parseFloat(dx);
        this._textY = parseFloat(y2) + parseFloat(dy);
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        return g2;
      },
      "tspan": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x");
        var y2 = xmlNode.getAttribute("y");
        if (x2 != null) {
          this._textX = parseFloat(x2);
        }
        if (y2 != null) {
          this._textY = parseFloat(y2);
        }
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        this._textX += parseFloat(dx);
        this._textY += parseFloat(dy);
        return g2;
      },
      "path": function(xmlNode, parentGroup) {
        var d2 = xmlNode.getAttribute("d") || "";
        var path = createFromString(d2);
        inheritStyle(parentGroup, path);
        parseAttributes(xmlNode, path, this._defsUsePending, false, false);
        path.silent = true;
        return path;
      }
    };
  }();
  return SVGParser2;
}();
var paintServerParsers = {
  "lineargradient": function(xmlNode) {
    var x1 = parseInt(xmlNode.getAttribute("x1") || "0", 10);
    var y1 = parseInt(xmlNode.getAttribute("y1") || "0", 10);
    var x2 = parseInt(xmlNode.getAttribute("x2") || "10", 10);
    var y2 = parseInt(xmlNode.getAttribute("y2") || "0", 10);
    var gradient = new LinearGradient$1(x1, y1, x2, y2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  },
  "radialgradient": function(xmlNode) {
    var cx = parseInt(xmlNode.getAttribute("cx") || "0", 10);
    var cy = parseInt(xmlNode.getAttribute("cy") || "0", 10);
    var r2 = parseInt(xmlNode.getAttribute("r") || "0", 10);
    var gradient = new RadialGradient$1(cx, cy, r2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  }
};
function parsePaintServerUnit(xmlNode, gradient) {
  var gradientUnits = xmlNode.getAttribute("gradientUnits");
  if (gradientUnits === "userSpaceOnUse") {
    gradient.global = true;
  }
}
function parseGradientColorStops(xmlNode, gradient) {
  var stop2 = xmlNode.firstChild;
  while (stop2) {
    if (stop2.nodeType === 1 && stop2.nodeName.toLocaleLowerCase() === "stop") {
      var offsetStr = stop2.getAttribute("offset");
      var offset = void 0;
      if (offsetStr && offsetStr.indexOf("%") > 0) {
        offset = parseInt(offsetStr, 10) / 100;
      } else if (offsetStr) {
        offset = parseFloat(offsetStr);
      } else {
        offset = 0;
      }
      var styleVals = {};
      parseInlineStyle(stop2, styleVals, styleVals);
      var stopColor = styleVals.stopColor || stop2.getAttribute("stop-color") || "#000000";
      gradient.colorStops.push({
        offset,
        color: stopColor
      });
    }
    stop2 = stop2.nextSibling;
  }
}
function inheritStyle(parent, child) {
  if (parent && parent.__inheritedStyle) {
    if (!child.__inheritedStyle) {
      child.__inheritedStyle = {};
    }
    defaults(child.__inheritedStyle, parent.__inheritedStyle);
  }
}
function parsePoints(pointsString) {
  var list = splitNumberSequence(pointsString);
  var points2 = [];
  for (var i = 0; i < list.length; i += 2) {
    var x2 = parseFloat(list[i]);
    var y2 = parseFloat(list[i + 1]);
    points2.push([x2, y2]);
  }
  return points2;
}
function parseAttributes(xmlNode, el, defsUsePending, onlyInlineStyle, isTextGroup) {
  var disp = el;
  var inheritedStyle = disp.__inheritedStyle = disp.__inheritedStyle || {};
  var selfStyle = {};
  if (xmlNode.nodeType === 1) {
    parseTransformAttribute(xmlNode, el);
    parseInlineStyle(xmlNode, inheritedStyle, selfStyle);
    if (!onlyInlineStyle) {
      parseAttributeStyle(xmlNode, inheritedStyle, selfStyle);
    }
  }
  disp.style = disp.style || {};
  if (inheritedStyle.fill != null) {
    disp.style.fill = getFillStrokeStyle(disp, "fill", inheritedStyle.fill, defsUsePending);
  }
  if (inheritedStyle.stroke != null) {
    disp.style.stroke = getFillStrokeStyle(disp, "stroke", inheritedStyle.stroke, defsUsePending);
  }
  each$f([
    "lineWidth",
    "opacity",
    "fillOpacity",
    "strokeOpacity",
    "miterLimit",
    "fontSize"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = parseFloat(inheritedStyle[propName]);
    }
  });
  each$f([
    "lineDashOffset",
    "lineCap",
    "lineJoin",
    "fontWeight",
    "fontFamily",
    "fontStyle",
    "textAlign"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = inheritedStyle[propName];
    }
  });
  if (isTextGroup) {
    disp.__selfStyle = selfStyle;
  }
  if (inheritedStyle.lineDash) {
    disp.style.lineDash = map$1(splitNumberSequence(inheritedStyle.lineDash), function(str) {
      return parseFloat(str);
    });
  }
  if (inheritedStyle.visibility === "hidden" || inheritedStyle.visibility === "collapse") {
    disp.invisible = true;
  }
  if (inheritedStyle.display === "none") {
    disp.ignore = true;
  }
}
function applyTextAlignment(text, parentGroup) {
  var parentSelfStyle = parentGroup.__selfStyle;
  if (parentSelfStyle) {
    var textBaseline = parentSelfStyle.textBaseline;
    var zrTextBaseline = textBaseline;
    if (!textBaseline || textBaseline === "auto") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "baseline") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "before-edge" || textBaseline === "text-before-edge") {
      zrTextBaseline = "top";
    } else if (textBaseline === "after-edge" || textBaseline === "text-after-edge") {
      zrTextBaseline = "bottom";
    } else if (textBaseline === "central" || textBaseline === "mathematical") {
      zrTextBaseline = "middle";
    }
    text.style.textBaseline = zrTextBaseline;
  }
  var parentInheritedStyle = parentGroup.__inheritedStyle;
  if (parentInheritedStyle) {
    var textAlign = parentInheritedStyle.textAlign;
    var zrTextAlign = textAlign;
    if (textAlign) {
      if (textAlign === "middle") {
        zrTextAlign = "center";
      }
      text.style.textAlign = zrTextAlign;
    }
  }
}
var urlRegex = /^url\(\s*#(.*?)\)/;
function getFillStrokeStyle(el, method4, str, defsUsePending) {
  var urlMatch = str && str.match(urlRegex);
  if (urlMatch) {
    var url2 = trim$1(urlMatch[1]);
    defsUsePending.push([el, method4, url2]);
    return;
  }
  if (str === "none") {
    str = null;
  }
  return str;
}
function applyDefs(defs, defsUsePending) {
  for (var i = 0; i < defsUsePending.length; i++) {
    var item = defsUsePending[i];
    item[0].style[item[1]] = defs[item[2]];
  }
}
var numberReg = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function splitNumberSequence(rawStr) {
  return rawStr.match(numberReg) || [];
}
var transformRegex = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g;
var DEGREE_TO_ANGLE = Math.PI / 180;
function parseTransformAttribute(xmlNode, node) {
  var transform2 = xmlNode.getAttribute("transform");
  if (transform2) {
    transform2 = transform2.replace(/,/g, " ");
    var transformOps_1 = [];
    var mt = null;
    transform2.replace(transformRegex, function(str, type5, value2) {
      transformOps_1.push(type5, value2);
      return "";
    });
    for (var i = transformOps_1.length - 1; i > 0; i -= 2) {
      var value = transformOps_1[i];
      var type4 = transformOps_1[i - 1];
      var valueArr = splitNumberSequence(value);
      mt = mt || create$1();
      switch (type4) {
        case "translate":
          translate(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || "0")]);
          break;
        case "scale":
          scale$1(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || valueArr[0])]);
          break;
        case "rotate":
          rotate(mt, mt, -parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          break;
        case "skewX":
          var sx = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, 0, sx, 1, 0, 0], mt);
          break;
        case "skewY":
          var sy = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, sy, 0, 1, 0, 0], mt);
          break;
        case "matrix":
          mt[0] = parseFloat(valueArr[0]);
          mt[1] = parseFloat(valueArr[1]);
          mt[2] = parseFloat(valueArr[2]);
          mt[3] = parseFloat(valueArr[3]);
          mt[4] = parseFloat(valueArr[4]);
          mt[5] = parseFloat(valueArr[5]);
          break;
      }
    }
    node.setLocalTransform(mt);
  }
}
var styleRegex = /([^\s:;]+)\s*:\s*([^:;]+)/g;
function parseInlineStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  var style = xmlNode.getAttribute("style");
  if (!style) {
    return;
  }
  styleRegex.lastIndex = 0;
  var styleRegResult;
  while ((styleRegResult = styleRegex.exec(style)) != null) {
    var svgStlAttr = styleRegResult[1];
    var zrInheritableStlAttr = hasOwn(INHERITABLE_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? INHERITABLE_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrInheritableStlAttr) {
      inheritableStyleResult[zrInheritableStlAttr] = styleRegResult[2];
    }
    var zrSelfStlAttr = hasOwn(SELF_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? SELF_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrSelfStlAttr) {
      selfStyleResult[zrSelfStlAttr] = styleRegResult[2];
    }
  }
}
function parseAttributeStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  for (var i = 0; i < INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      inheritableStyleResult[INHERITABLE_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
  for (var i = 0; i < SELF_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = SELF_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      selfStyleResult[SELF_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
}
function makeViewBoxTransform(viewBoxRect, boundingRect) {
  var scaleX = boundingRect.width / viewBoxRect.width;
  var scaleY = boundingRect.height / viewBoxRect.height;
  var scale2 = Math.min(scaleX, scaleY);
  return {
    scale: scale2,
    x: -(viewBoxRect.x + viewBoxRect.width / 2) * scale2 + (boundingRect.x + boundingRect.width / 2),
    y: -(viewBoxRect.y + viewBoxRect.height / 2) * scale2 + (boundingRect.y + boundingRect.height / 2)
  };
}
function parseSVG(xml, opt) {
  var parser = new SVGParser();
  return parser.parse(xml, opt);
}
var REGION_AVAILABLE_SVG_TAG_MAP = createHashMap([
  "rect",
  "circle",
  "line",
  "ellipse",
  "polygon",
  "polyline",
  "path",
  "text",
  "tspan",
  "g"
]);
var GeoSVGResource = function() {
  function GeoSVGResource2(mapName, svg) {
    this.type = "geoSVG";
    this._usedGraphicMap = createHashMap();
    this._freedGraphics = [];
    this._mapName = mapName;
    this._parsedXML = parseXML(svg);
  }
  GeoSVGResource2.prototype.load = function() {
    var firstGraphic = this._firstGraphic;
    if (!firstGraphic) {
      firstGraphic = this._firstGraphic = this._buildGraphic(this._parsedXML);
      this._freedGraphics.push(firstGraphic);
      this._boundingRect = this._firstGraphic.boundingRect.clone();
      var _a2 = createRegions(firstGraphic.named), regions = _a2.regions, regionsMap = _a2.regionsMap;
      this._regions = regions;
      this._regionsMap = regionsMap;
    }
    return {
      boundingRect: this._boundingRect,
      regions: this._regions,
      regionsMap: this._regionsMap
    };
  };
  GeoSVGResource2.prototype._buildGraphic = function(svgXML) {
    var result;
    var rootFromParse;
    try {
      result = svgXML && parseSVG(svgXML, {
        ignoreViewBox: true,
        ignoreRootClip: true
      }) || {};
      rootFromParse = result.root;
      assert(rootFromParse != null);
    } catch (e2) {
      throw new Error("Invalid svg format\n" + e2.message);
    }
    var root2 = new Group$4();
    root2.add(rootFromParse);
    root2.isGeoSVGGraphicRoot = true;
    var svgWidth = result.width;
    var svgHeight = result.height;
    var viewBoxRect = result.viewBoxRect;
    var boundingRect = this._boundingRect;
    if (!boundingRect) {
      var bRectX = void 0;
      var bRectY = void 0;
      var bRectWidth = void 0;
      var bRectHeight = void 0;
      if (svgWidth != null) {
        bRectX = 0;
        bRectWidth = svgWidth;
      } else if (viewBoxRect) {
        bRectX = viewBoxRect.x;
        bRectWidth = viewBoxRect.width;
      }
      if (svgHeight != null) {
        bRectY = 0;
        bRectHeight = svgHeight;
      } else if (viewBoxRect) {
        bRectY = viewBoxRect.y;
        bRectHeight = viewBoxRect.height;
      }
      if (bRectX == null || bRectY == null) {
        var calculatedBoundingRect = rootFromParse.getBoundingRect();
        if (bRectX == null) {
          bRectX = calculatedBoundingRect.x;
          bRectWidth = calculatedBoundingRect.width;
        }
        if (bRectY == null) {
          bRectY = calculatedBoundingRect.y;
          bRectHeight = calculatedBoundingRect.height;
        }
      }
      boundingRect = this._boundingRect = new BoundingRect$1(bRectX, bRectY, bRectWidth, bRectHeight);
    }
    if (viewBoxRect) {
      var viewBoxTransform = makeViewBoxTransform(viewBoxRect, boundingRect);
      rootFromParse.scaleX = rootFromParse.scaleY = viewBoxTransform.scale;
      rootFromParse.x = viewBoxTransform.x;
      rootFromParse.y = viewBoxTransform.y;
    }
    root2.setClipPath(new Rect$3({
      shape: boundingRect.plain()
    }));
    var named = [];
    each$f(result.named, function(namedItem) {
      if (REGION_AVAILABLE_SVG_TAG_MAP.get(namedItem.svgNodeTagLower) != null) {
        named.push(namedItem);
        setSilent(namedItem.el);
      }
    });
    return {
      root: root2,
      boundingRect,
      named
    };
  };
  GeoSVGResource2.prototype.useGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      return svgGraphic;
    }
    svgGraphic = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML);
    usedRootMap.set(hostKey, svgGraphic);
    return svgGraphic;
  };
  GeoSVGResource2.prototype.freeGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      usedRootMap.removeKey(hostKey);
      this._freedGraphics.push(svgGraphic);
    }
  };
  return GeoSVGResource2;
}();
function setSilent(el) {
  el.silent = false;
  if (el.isGroup) {
    el.traverse(function(child) {
      child.silent = false;
    });
  }
}
function createRegions(named) {
  var regions = [];
  var regionsMap = createHashMap();
  each$f(named, function(namedItem) {
    if (namedItem.namedFrom != null) {
      return;
    }
    var region = new GeoSVGRegion(namedItem.name, namedItem.el);
    regions.push(region);
    regionsMap.set(namedItem.name, region);
  });
  return {
    regions,
    regionsMap
  };
}
var geoCoord = [126, 25];
var nanhaiName = "\u5357\u6D77\u8BF8\u5C9B";
var points$1 = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
for (var i = 0; i < points$1.length; i++) {
  for (var k$1 = 0; k$1 < points$1[i].length; k$1++) {
    points$1[i][k$1][0] /= 10.5;
    points$1[i][k$1][1] /= -10.5 / 0.75;
    points$1[i][k$1][0] += geoCoord[0];
    points$1[i][k$1][1] += geoCoord[1];
  }
}
function fixNanhai(mapType, regions) {
  if (mapType === "china") {
    for (var i = 0; i < regions.length; i++) {
      if (regions[i].name === nanhaiName) {
        return;
      }
    }
    regions.push(new GeoJSONRegion(nanhaiName, map$1(points$1, function(exterior) {
      return {
        type: "polygon",
        exterior
      };
    }), geoCoord));
  }
}
var coordsOffsetMap = {
  "\u5357\u6D77\u8BF8\u5C9B": [32, 80],
  "\u5E7F\u4E1C": [0, -10],
  "\u9999\u6E2F": [10, 5],
  "\u6FB3\u95E8": [-10, 10],
  "\u5929\u6D25": [5, 5]
};
function fixTextCoords(mapType, region) {
  if (mapType === "china") {
    var coordFix = coordsOffsetMap[region.name];
    if (coordFix) {
      var cp = region.getCenter();
      cp[0] += coordFix[0] / 10.5;
      cp[1] += -coordFix[1] / (10.5 / 0.75);
      region.setCenter(cp);
    }
  }
}
var points = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
function fixDiaoyuIsland(mapType, region) {
  if (mapType === "china" && region.name === "\u53F0\u6E7E") {
    region.geometries.push({
      type: "polygon",
      exterior: points[0]
    });
  }
}
var DEFAULT_NAME_PROPERTY = "name";
var GeoJSONResource = function() {
  function GeoJSONResource2(mapName, geoJSON, specialAreas) {
    this.type = "geoJSON";
    this._parsedMap = createHashMap();
    this._mapName = mapName;
    this._specialAreas = specialAreas;
    this._geoJSON = parseInput(geoJSON);
  }
  GeoJSONResource2.prototype.load = function(nameMap, nameProperty) {
    nameProperty = nameProperty || DEFAULT_NAME_PROPERTY;
    var parsed = this._parsedMap.get(nameProperty);
    if (!parsed) {
      var rawRegions = this._parseToRegions(nameProperty);
      parsed = this._parsedMap.set(nameProperty, {
        regions: rawRegions,
        boundingRect: calculateBoundingRect(rawRegions)
      });
    }
    var regionsMap = createHashMap();
    var finalRegions = [];
    each$f(parsed.regions, function(region) {
      var regionName = region.name;
      if (nameMap && hasOwn(nameMap, regionName)) {
        region = region.cloneShallow(regionName = nameMap[regionName]);
      }
      finalRegions.push(region);
      regionsMap.set(regionName, region);
    });
    return {
      regions: finalRegions,
      boundingRect: parsed.boundingRect || new BoundingRect$1(0, 0, 0, 0),
      regionsMap
    };
  };
  GeoJSONResource2.prototype._parseToRegions = function(nameProperty) {
    var mapName = this._mapName;
    var geoJSON = this._geoJSON;
    var rawRegions;
    try {
      rawRegions = geoJSON ? parseGeoJSON(geoJSON, nameProperty) : [];
    } catch (e2) {
      throw new Error("Invalid geoJson format\n" + e2.message);
    }
    fixNanhai(mapName, rawRegions);
    each$f(rawRegions, function(region) {
      var regionName = region.name;
      fixTextCoords(mapName, region);
      fixDiaoyuIsland(mapName, region);
      var specialArea = this._specialAreas && this._specialAreas[regionName];
      if (specialArea) {
        region.transformTo(specialArea.left, specialArea.top, specialArea.width, specialArea.height);
      }
    }, this);
    return rawRegions;
  };
  GeoJSONResource2.prototype.getMapForUser = function() {
    return {
      geoJson: this._geoJSON,
      geoJSON: this._geoJSON,
      specialAreas: this._specialAreas
    };
  };
  return GeoJSONResource2;
}();
function calculateBoundingRect(regions) {
  var rect;
  for (var i = 0; i < regions.length; i++) {
    var regionRect = regions[i].getBoundingRect();
    rect = rect || regionRect.clone();
    rect.union(regionRect);
  }
  return rect;
}
function parseInput(source) {
  return !isString(source) ? source : typeof JSON !== "undefined" && JSON.parse ? JSON.parse(source) : new Function("return (" + source + ");")();
}
var storage = createHashMap();
var geoSourceManager = {
  registerMap: function(mapName, rawDef, rawSpecialAreas) {
    if (rawDef.svg) {
      var resource = new GeoSVGResource(mapName, rawDef.svg);
      storage.set(mapName, resource);
    } else {
      var geoJSON = rawDef.geoJson || rawDef.geoJSON;
      if (geoJSON && !rawDef.features) {
        rawSpecialAreas = rawDef.specialAreas;
      } else {
        geoJSON = rawDef;
      }
      var resource = new GeoJSONResource(mapName, geoJSON, rawSpecialAreas);
      storage.set(mapName, resource);
    }
  },
  getGeoResource: function(mapName) {
    return storage.get(mapName);
  },
  getMapForUser: function(mapName) {
    var resource = storage.get(mapName);
    return resource && resource.type === "geoJSON" && resource.getMapForUser();
  },
  load: function(mapName, nameMap, nameProperty) {
    var resource = storage.get(mapName);
    if (!resource) {
      return;
    }
    return resource.load(nameMap, nameProperty);
  }
};
var OPTION_STYLE_ENABLED_TAGS = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"];
var OPTION_STYLE_ENABLED_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS);
var STATE_TRIGGER_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var LABEL_HOST_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var mapLabelRaw = makeInner();
function getFixedItemStyle(model) {
  var itemStyle = model.getItemStyle();
  var areaColor = model.get("areaColor");
  if (areaColor != null) {
    itemStyle.fill = areaColor;
  }
  return itemStyle;
}
function fixLineStyle(styleHost) {
  var style = styleHost.style;
  if (style) {
    style.stroke = style.stroke || style.fill;
    style.fill = null;
  }
}
var MapDraw = function() {
  function MapDraw2(api) {
    var group = new Group$4();
    this.uid = getUID("ec_map_draw");
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    this.group = group;
    group.add(this._regionsGroup = new Group$4());
    group.add(this._svgGroup = new Group$4());
  }
  MapDraw2.prototype.draw = function(mapOrGeoModel, ecModel, api, fromView, payload) {
    var isGeo = mapOrGeoModel.mainType === "geo";
    var data = mapOrGeoModel.getData && mapOrGeoModel.getData();
    isGeo && ecModel.eachComponent({
      mainType: "series",
      subType: "map"
    }, function(mapSeries) {
      if (!data && mapSeries.getHostGeoModel() === mapOrGeoModel) {
        data = mapSeries.getData();
      }
    });
    var geo = mapOrGeoModel.coordinateSystem;
    var regionsGroup = this._regionsGroup;
    var group = this.group;
    var transformInfo = geo.getTransformInfo();
    var transformInfoRaw = transformInfo.raw;
    var transformInfoRoam = transformInfo.roam;
    var isFirstDraw = !regionsGroup.childAt(0) || payload;
    if (isFirstDraw) {
      group.x = transformInfoRoam.x;
      group.y = transformInfoRoam.y;
      group.scaleX = transformInfoRoam.scaleX;
      group.scaleY = transformInfoRoam.scaleY;
      group.dirty();
    } else {
      updateProps$1(group, transformInfoRoam, mapOrGeoModel);
    }
    var isVisualEncodedByVisualMap = data && data.getVisual("visualMeta") && data.getVisual("visualMeta").length > 0;
    var viewBuildCtx = {
      api,
      geo,
      mapOrGeoModel,
      data,
      isVisualEncodedByVisualMap,
      isGeo,
      transformInfoRaw
    };
    if (geo.resourceType === "geoJSON") {
      this._buildGeoJSON(viewBuildCtx);
    } else if (geo.resourceType === "geoSVG") {
      this._buildSVG(viewBuildCtx);
    }
    this._updateController(mapOrGeoModel, ecModel, api);
    this._updateMapSelectHandler(mapOrGeoModel, regionsGroup, api, fromView);
  };
  MapDraw2.prototype._buildGeoJSON = function(viewBuildCtx) {
    var regionsGroupByName = this._regionsGroupByName = createHashMap();
    var regionsInfoByName = createHashMap();
    var regionsGroup = this._regionsGroup;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
    var data = viewBuildCtx.data;
    var projection = viewBuildCtx.geo.projection;
    var projectionStream = projection && projection.stream;
    function transformPoint(point, project) {
      if (project) {
        point = project(point);
      }
      return point && [point[0] * transformInfoRaw.scaleX + transformInfoRaw.x, point[1] * transformInfoRaw.scaleY + transformInfoRaw.y];
    }
    function transformPolygonPoints(inPoints) {
      var outPoints = [];
      var project = !projectionStream && projection && projection.project;
      for (var i = 0; i < inPoints.length; ++i) {
        var newPt = transformPoint(inPoints[i], project);
        newPt && outPoints.push(newPt);
      }
      return outPoints;
    }
    function getPolyShape(points2) {
      return {
        shape: {
          points: transformPolygonPoints(points2)
        }
      };
    }
    regionsGroup.removeAll();
    each$f(viewBuildCtx.geo.regions, function(region) {
      var regionName = region.name;
      var regionGroup = regionsGroupByName.get(regionName);
      var _a2 = regionsInfoByName.get(regionName) || {}, dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      if (!regionGroup) {
        regionGroup = regionsGroupByName.set(regionName, new Group$4());
        regionsGroup.add(regionGroup);
        dataIdx = data ? data.indexOfName(regionName) : null;
        regionModel = viewBuildCtx.isGeo ? mapOrGeoModel.getRegionModel(regionName) : data ? data.getItemModel(dataIdx) : null;
        regionsInfoByName.set(regionName, {
          dataIdx,
          regionModel
        });
      }
      var polygonSubpaths = [];
      var polylineSubpaths = [];
      each$f(region.geometries, function(geometry) {
        if (geometry.type === "polygon") {
          var polys = [geometry.exterior].concat(geometry.interiors || []);
          if (projectionStream) {
            polys = projectPolys(polys, projectionStream);
          }
          each$f(polys, function(poly) {
            polygonSubpaths.push(new Polygon$1(getPolyShape(poly)));
          });
        } else {
          var points2 = geometry.points;
          if (projectionStream) {
            points2 = projectPolys(points2, projectionStream, true);
          }
          each$f(points2, function(points3) {
            polylineSubpaths.push(new Polyline$3(getPolyShape(points3)));
          });
        }
      });
      var centerPt = transformPoint(region.getCenter(), projection && projection.project);
      function createCompoundPath(subpaths, isLine) {
        if (!subpaths.length) {
          return;
        }
        var compoundPath = new CompoundPath$1({
          culling: true,
          segmentIgnoreThreshold: 1,
          shape: {
            paths: subpaths
          }
        });
        regionGroup.add(compoundPath);
        applyOptionStyleForRegion(viewBuildCtx, compoundPath, dataIdx, regionModel);
        resetLabelForRegion(viewBuildCtx, compoundPath, regionName, regionModel, mapOrGeoModel, dataIdx, centerPt);
        if (isLine) {
          fixLineStyle(compoundPath);
          each$f(compoundPath.states, fixLineStyle);
        }
      }
      createCompoundPath(polygonSubpaths);
      createCompoundPath(polylineSubpaths, true);
    });
    regionsGroupByName.each(function(regionGroup, regionName) {
      var _a2 = regionsInfoByName.get(regionName), dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      resetEventTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel, dataIdx);
      resetTooltipForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
      resetStateTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
    }, this);
  };
  MapDraw2.prototype._buildSVG = function(viewBuildCtx) {
    var mapName = viewBuildCtx.geo.map;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    this._svgGroup.x = transformInfoRaw.x;
    this._svgGroup.y = transformInfoRaw.y;
    this._svgGroup.scaleX = transformInfoRaw.scaleX;
    this._svgGroup.scaleY = transformInfoRaw.scaleY;
    if (this._svgResourceChanged(mapName)) {
      this._freeSVG();
      this._useSVG(mapName);
    }
    var svgDispatcherMap = this._svgDispatcherMap = createHashMap();
    var focusSelf = false;
    each$f(this._svgGraphicRecord.named, function(namedItem) {
      var regionName = namedItem.name;
      var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
      var data = viewBuildCtx.data;
      var svgNodeTagLower = namedItem.svgNodeTagLower;
      var el = namedItem.el;
      var dataIdx = data ? data.indexOfName(regionName) : null;
      var regionModel = mapOrGeoModel.getRegionModel(regionName);
      if (OPTION_STYLE_ENABLED_TAG_MAP.get(svgNodeTagLower) != null && el instanceof Displayable$1) {
        applyOptionStyleForRegion(viewBuildCtx, el, dataIdx, regionModel);
      }
      if (el instanceof Displayable$1) {
        el.culling = true;
      }
      el.z2EmphasisLift = 0;
      if (!namedItem.namedFrom) {
        if (LABEL_HOST_MAP.get(svgNodeTagLower) != null) {
          resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, null);
        }
        resetEventTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx);
        resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
        if (STATE_TRIGGER_TAG_MAP.get(svgNodeTagLower) != null) {
          var focus_1 = resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
          if (focus_1 === "self") {
            focusSelf = true;
          }
          var els = svgDispatcherMap.get(regionName) || svgDispatcherMap.set(regionName, []);
          els.push(el);
        }
      }
    }, this);
    this._enableBlurEntireSVG(focusSelf, viewBuildCtx);
  };
  MapDraw2.prototype._enableBlurEntireSVG = function(focusSelf, viewBuildCtx) {
    if (focusSelf && viewBuildCtx.isGeo) {
      var blurStyle = viewBuildCtx.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle();
      var opacity_1 = blurStyle.opacity;
      this._svgGraphicRecord.root.traverse(function(el) {
        if (!el.isGroup) {
          setDefaultStateProxy(el);
          var style = el.ensureState("blur").style || {};
          if (style.opacity == null && opacity_1 != null) {
            style.opacity = opacity_1;
          }
          el.ensureState("emphasis");
        }
      });
    }
  };
  MapDraw2.prototype.remove = function() {
    this._regionsGroup.removeAll();
    this._regionsGroupByName = null;
    this._svgGroup.removeAll();
    this._freeSVG();
    this._controller.dispose();
    this._controllerHost = null;
  };
  MapDraw2.prototype.findHighDownDispatchers = function(name, geoModel) {
    if (name == null) {
      return [];
    }
    var geo = geoModel.coordinateSystem;
    if (geo.resourceType === "geoJSON") {
      var regionsGroupByName = this._regionsGroupByName;
      if (regionsGroupByName) {
        var regionGroup = regionsGroupByName.get(name);
        return regionGroup ? [regionGroup] : [];
      }
    } else if (geo.resourceType === "geoSVG") {
      return this._svgDispatcherMap && this._svgDispatcherMap.get(name) || [];
    }
  };
  MapDraw2.prototype._svgResourceChanged = function(mapName) {
    return this._svgMapName !== mapName;
  };
  MapDraw2.prototype._useSVG = function(mapName) {
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      var svgGraphic = resource.useGraphic(this.uid);
      this._svgGroup.add(svgGraphic.root);
      this._svgGraphicRecord = svgGraphic;
      this._svgMapName = mapName;
    }
  };
  MapDraw2.prototype._freeSVG = function() {
    var mapName = this._svgMapName;
    if (mapName == null) {
      return;
    }
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      resource.freeGraphic(this.uid);
    }
    this._svgGraphicRecord = null;
    this._svgDispatcherMap = null;
    this._svgGroup.removeAll();
    this._svgMapName = null;
  };
  MapDraw2.prototype._updateController = function(mapOrGeoModel, ecModel, api) {
    var geo = mapOrGeoModel.coordinateSystem;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    controllerHost.zoomLimit = mapOrGeoModel.get("scaleLimit");
    controllerHost.zoom = geo.getZoom();
    controller.enable(mapOrGeoModel.get("roam") || false);
    var mainType = mapOrGeoModel.mainType;
    function makeActionBase() {
      var action = {
        type: "geoRoam",
        componentType: mainType
      };
      action[mainType + "Id"] = mapOrGeoModel.id;
      return action;
    }
    controller.off("pan").on("pan", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction(extend(makeActionBase(), {
        dx: e2.dx,
        dy: e2.dy,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.off("zoom").on("zoom", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction(extend(makeActionBase(), {
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.setPointerChecker(function(e2, x2, y2) {
      return geo.containPoint([x2, y2]) && !onIrrelevantElement(e2, api, mapOrGeoModel);
    });
  };
  MapDraw2.prototype.resetForLabelLayout = function() {
    this.group.traverse(function(el) {
      var label = el.getTextContent();
      if (label) {
        label.ignore = mapLabelRaw(label).ignore;
      }
    });
  };
  MapDraw2.prototype._updateMapSelectHandler = function(mapOrGeoModel, regionsGroup, api, fromView) {
    var mapDraw = this;
    regionsGroup.off("mousedown");
    regionsGroup.off("click");
    if (mapOrGeoModel.get("selectedMode")) {
      regionsGroup.on("mousedown", function() {
        mapDraw._mouseDownFlag = true;
      });
      regionsGroup.on("click", function(e2) {
        if (!mapDraw._mouseDownFlag) {
          return;
        }
        mapDraw._mouseDownFlag = false;
      });
    }
  };
  return MapDraw2;
}();
function applyOptionStyleForRegion(viewBuildCtx, el, dataIndex, regionModel) {
  var normalStyleModel = regionModel.getModel("itemStyle");
  var emphasisStyleModel = regionModel.getModel(["emphasis", "itemStyle"]);
  var blurStyleModel = regionModel.getModel(["blur", "itemStyle"]);
  var selectStyleModel = regionModel.getModel(["select", "itemStyle"]);
  var normalStyle = getFixedItemStyle(normalStyleModel);
  var emphasisStyle = getFixedItemStyle(emphasisStyleModel);
  var selectStyle = getFixedItemStyle(selectStyleModel);
  var blurStyle = getFixedItemStyle(blurStyleModel);
  var data = viewBuildCtx.data;
  if (data) {
    var style = data.getItemVisual(dataIndex, "style");
    var decal = data.getItemVisual(dataIndex, "decal");
    if (viewBuildCtx.isVisualEncodedByVisualMap && style.fill) {
      normalStyle.fill = style.fill;
    }
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, viewBuildCtx.api);
    }
  }
  el.setStyle(normalStyle);
  el.style.strokeNoScale = true;
  el.ensureState("emphasis").style = emphasisStyle;
  el.ensureState("select").style = selectStyle;
  el.ensureState("blur").style = blurStyle;
  setDefaultStateProxy(el);
}
function resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, labelXY) {
  var data = viewBuildCtx.data;
  var isGeo = viewBuildCtx.isGeo;
  var isDataNaN = data && isNaN(data.get(data.mapDimension("value"), dataIdx));
  var itemLayout = data && data.getItemLayout(dataIdx);
  if (isGeo || isDataNaN || itemLayout && itemLayout.showLabel) {
    var query = !isGeo ? dataIdx : regionName;
    var labelFetcher = void 0;
    if (!data || dataIdx >= 0) {
      labelFetcher = mapOrGeoModel;
    }
    var specifiedTextOpt = labelXY ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    setLabelStyle(el, getLabelStatesModels(regionModel), {
      labelFetcher,
      labelDataIndex: query,
      defaultText: regionName
    }, specifiedTextOpt);
    var textEl = el.getTextContent();
    if (textEl) {
      mapLabelRaw(textEl).ignore = textEl.ignore;
      if (el.textConfig && labelXY) {
        var rect = el.getBoundingRect().clone();
        el.textConfig.layoutRect = rect;
        el.textConfig.position = [(labelXY[0] - rect.x) / rect.width * 100 + "%", (labelXY[1] - rect.y) / rect.height * 100 + "%"];
      }
    }
    el.disableLabelAnimation = true;
  } else {
    el.removeTextContent();
    el.removeTextConfig();
    el.disableLabelAnimation = null;
  }
}
function resetEventTriggerForRegion(viewBuildCtx, eventTrigger, regionName, regionModel, mapOrGeoModel, dataIdx) {
  if (viewBuildCtx.data) {
    viewBuildCtx.data.setItemGraphicEl(dataIdx, eventTrigger);
  } else {
    getECData(eventTrigger).eventData = {
      componentType: "geo",
      componentIndex: mapOrGeoModel.componentIndex,
      geoIndex: mapOrGeoModel.componentIndex,
      name: regionName,
      region: regionModel && regionModel.option || {}
    };
  }
}
function resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  if (!viewBuildCtx.data) {
    setTooltipConfig({
      el,
      componentModel: mapOrGeoModel,
      itemName: regionName,
      itemTooltipOption: regionModel.get("tooltip")
    });
  }
}
function resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  el.highDownSilentOnTouch = !!mapOrGeoModel.get("selectedMode");
  var emphasisModel = regionModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  toggleHoverEmphasis(el, focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  if (viewBuildCtx.isGeo) {
    enableComponentHighDownFeatures(el, mapOrGeoModel, regionName);
  }
  return focus;
}
function projectPolys(rings, createStream, isLine) {
  var polygons = [];
  var curPoly;
  function startPolygon() {
    curPoly = [];
  }
  function endPolygon() {
    if (curPoly.length) {
      polygons.push(curPoly);
      curPoly = [];
    }
  }
  var stream = createStream({
    polygonStart: startPolygon,
    polygonEnd: endPolygon,
    lineStart: startPolygon,
    lineEnd: endPolygon,
    point: function(x2, y2) {
      if (isFinite(x2) && isFinite(y2)) {
        curPoly.push([x2, y2]);
      }
    },
    sphere: function() {
    }
  });
  !isLine && stream.polygonStart();
  each$f(rings, function(ring) {
    stream.lineStart();
    for (var i = 0; i < ring.length; i++) {
      stream.point(ring[i][0], ring[i][1]);
    }
    stream.lineEnd();
  });
  !isLine && stream.polygonEnd();
  return polygons;
}
var MapDraw$1 = MapDraw;
var MapView = function(_super) {
  __extends(MapView2, _super);
  function MapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapView2.type;
    return _this;
  }
  MapView2.prototype.render = function(mapModel, ecModel, api, payload) {
    if (payload && payload.type === "mapToggleSelect" && payload.from === this.uid) {
      return;
    }
    var group = this.group;
    group.removeAll();
    if (mapModel.getHostGeoModel()) {
      return;
    }
    if (this._mapDraw && payload && payload.type === "geoRoam") {
      this._mapDraw.resetForLabelLayout();
    }
    if (!(payload && payload.type === "geoRoam" && payload.componentType === "series" && payload.seriesId === mapModel.id)) {
      if (mapModel.needsDrawMap) {
        var mapDraw = this._mapDraw || new MapDraw$1(api);
        group.add(mapDraw.group);
        mapDraw.draw(mapModel, ecModel, api, this, payload);
        this._mapDraw = mapDraw;
      } else {
        this._mapDraw && this._mapDraw.remove();
        this._mapDraw = null;
      }
    } else {
      var mapDraw = this._mapDraw;
      mapDraw && group.add(mapDraw.group);
    }
    mapModel.get("showLegendSymbol") && ecModel.getComponent("legend") && this._renderSymbols(mapModel, ecModel, api);
  };
  MapView2.prototype.remove = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
    this.group.removeAll();
  };
  MapView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
  };
  MapView2.prototype._renderSymbols = function(mapModel, ecModel, api) {
    var originalData = mapModel.originalData;
    var group = this.group;
    originalData.each(originalData.mapDimension("value"), function(value, originalDataIndex) {
      if (isNaN(value)) {
        return;
      }
      var layout2 = originalData.getItemLayout(originalDataIndex);
      if (!layout2 || !layout2.point) {
        return;
      }
      var point = layout2.point;
      var offset = layout2.offset;
      var circle = new Circle$1({
        style: {
          fill: mapModel.getData().getVisual("style").fill
        },
        shape: {
          cx: point[0] + offset * 9,
          cy: point[1],
          r: 3
        },
        silent: true,
        z2: 8 + (!offset ? Z2_EMPHASIS_LIFT + 1 : 0)
      });
      if (!offset) {
        var fullData = mapModel.mainSeries.getData();
        var name_1 = originalData.getName(originalDataIndex);
        var fullIndex_1 = fullData.indexOfName(name_1);
        var itemModel = originalData.getItemModel(originalDataIndex);
        var labelModel = itemModel.getModel("label");
        var regionGroup = fullData.getItemGraphicEl(fullIndex_1);
        setLabelStyle(circle, getLabelStatesModels(itemModel), {
          labelFetcher: {
            getFormattedLabel: function(idx, state) {
              return mapModel.getFormattedLabel(fullIndex_1, state);
            }
          },
          defaultText: name_1
        });
        circle.disableLabelAnimation = true;
        if (!labelModel.get("position")) {
          circle.setTextConfig({
            position: "bottom"
          });
        }
        regionGroup.onHoverStateChange = function(toState) {
          setStatesFlag(circle, toState);
        };
      }
      group.add(circle);
    });
  };
  MapView2.type = "map";
  return MapView2;
}(ChartView$1);
var MapView$1 = MapView;
var MapSeries = function(_super) {
  __extends(MapSeries2, _super);
  function MapSeries2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapSeries2.type;
    _this.needsDrawMap = false;
    _this.seriesGroup = [];
    _this.getTooltipPosition = function(dataIndex) {
      if (dataIndex != null) {
        var name_1 = this.getData().getName(dataIndex);
        var geo = this.coordinateSystem;
        var region = geo.getRegion(name_1);
        return region && geo.dataToPoint(region.getCenter());
      }
    };
    return _this;
  }
  MapSeries2.prototype.getInitialData = function(option) {
    var data = createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
    var dataNameMap = createHashMap();
    var toAppendNames = [];
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      var name_2 = data.getName(i);
      dataNameMap.set(name_2, true);
    }
    var geoSource = geoSourceManager.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
    each$f(geoSource.regions, function(region) {
      var name = region.name;
      if (!dataNameMap.get(name)) {
        toAppendNames.push(name);
      }
    });
    data.appendValues([], toAppendNames);
    return data;
  };
  MapSeries2.prototype.getHostGeoModel = function() {
    var geoIndex = this.option.geoIndex;
    return geoIndex != null ? this.ecModel.getComponent("geo", geoIndex) : null;
  };
  MapSeries2.prototype.getMapType = function() {
    return (this.getHostGeoModel() || this).option.map;
  };
  MapSeries2.prototype.getRawValue = function(dataIndex) {
    var data = this.getData();
    return data.get(data.mapDimension("value"), dataIndex);
  };
  MapSeries2.prototype.getRegionModel = function(regionName) {
    var data = this.getData();
    return data.getItemModel(data.indexOfName(regionName));
  };
  MapSeries2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    var seriesGroup = this.seriesGroup;
    var seriesNames = [];
    for (var i = 0; i < seriesGroup.length; i++) {
      var otherIndex = seriesGroup[i].originalData.indexOfName(name);
      var valueDim = data.mapDimension("value");
      if (!isNaN(seriesGroup[i].originalData.get(valueDim, otherIndex))) {
        seriesNames.push(seriesGroup[i].name);
      }
    }
    return createTooltipMarkup("section", {
      header: seriesNames.join(", "),
      noHeader: !seriesNames.length,
      blocks: [createTooltipMarkup("nameValue", {
        name,
        value
      })]
    });
  };
  MapSeries2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  MapSeries2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  MapSeries2.prototype.getLegendIcon = function(opt) {
    var iconType = opt.icon || "roundRect";
    var icon = createSymbol$1(iconType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill);
    icon.setStyle(opt.itemStyle);
    icon.style.stroke = "none";
    if (iconType.indexOf("empty") > -1) {
      icon.style.stroke = icon.style.fill;
      icon.style.fill = "#fff";
      icon.style.lineWidth = 2;
    }
    return icon;
  };
  MapSeries2.type = "series.map";
  MapSeries2.dependencies = ["geo"];
  MapSeries2.layoutMode = "box";
  MapSeries2.defaultOption = {
    z: 2,
    coordinateSystem: "geo",
    map: "",
    left: "center",
    top: "center",
    aspectScale: null,
    showLegendSymbol: true,
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    selectedMode: true,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444",
      areaColor: "#eee"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        areaColor: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    nameProperty: "name"
  };
  return MapSeries2;
}(SeriesModel$1);
var MapSeries$1 = MapSeries;
function dataStatistics(datas, statisticType) {
  var dataNameMap = {};
  each$f(datas, function(data) {
    data.each(data.mapDimension("value"), function(value, idx) {
      var mapKey = "ec-" + data.getName(idx);
      dataNameMap[mapKey] = dataNameMap[mapKey] || [];
      if (!isNaN(value)) {
        dataNameMap[mapKey].push(value);
      }
    });
  });
  return datas[0].map(datas[0].mapDimension("value"), function(value, idx) {
    var mapKey = "ec-" + datas[0].getName(idx);
    var sum2 = 0;
    var min3 = Infinity;
    var max3 = -Infinity;
    var len2 = dataNameMap[mapKey].length;
    for (var i = 0; i < len2; i++) {
      min3 = Math.min(min3, dataNameMap[mapKey][i]);
      max3 = Math.max(max3, dataNameMap[mapKey][i]);
      sum2 += dataNameMap[mapKey][i];
    }
    var result;
    if (statisticType === "min") {
      result = min3;
    } else if (statisticType === "max") {
      result = max3;
    } else if (statisticType === "average") {
      result = sum2 / len2;
    } else {
      result = sum2;
    }
    return len2 === 0 ? NaN : result;
  });
}
function mapDataStatistic(ecModel) {
  var seriesGroups = {};
  ecModel.eachSeriesByType("map", function(seriesModel) {
    var hostGeoModel = seriesModel.getHostGeoModel();
    var key = hostGeoModel ? "o" + hostGeoModel.id : "i" + seriesModel.getMapType();
    (seriesGroups[key] = seriesGroups[key] || []).push(seriesModel);
  });
  each$f(seriesGroups, function(seriesList, key) {
    var data = dataStatistics(map$1(seriesList, function(seriesModel) {
      return seriesModel.getData();
    }), seriesList[0].get("mapValueCalculation"));
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].originalData = seriesList[i].getData();
    }
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].seriesGroup = seriesList;
      seriesList[i].needsDrawMap = i === 0 && !seriesList[i].getHostGeoModel();
      seriesList[i].setData(data.cloneShallow());
      seriesList[i].mainSeries = seriesList[0];
    }
  });
}
function mapSymbolLayout(ecModel) {
  var processedMapType = {};
  ecModel.eachSeriesByType("map", function(mapSeries) {
    var mapType = mapSeries.getMapType();
    if (mapSeries.getHostGeoModel() || processedMapType[mapType]) {
      return;
    }
    var mapSymbolOffsets = {};
    each$f(mapSeries.seriesGroup, function(subMapSeries) {
      var geo = subMapSeries.coordinateSystem;
      var data2 = subMapSeries.originalData;
      if (subMapSeries.get("showLegendSymbol") && ecModel.getComponent("legend")) {
        data2.each(data2.mapDimension("value"), function(value, idx) {
          var name = data2.getName(idx);
          var region = geo.getRegion(name);
          if (!region || isNaN(value)) {
            return;
          }
          var offset = mapSymbolOffsets[name] || 0;
          var point = geo.dataToPoint(region.getCenter());
          mapSymbolOffsets[name] = offset + 1;
          data2.setItemLayout(idx, {
            point,
            offset
          });
        });
      }
    });
    var data = mapSeries.getData();
    data.each(function(idx) {
      var name = data.getName(idx);
      var layout2 = data.getItemLayout(idx) || {};
      layout2.showLabel = !mapSymbolOffsets[name];
      data.setItemLayout(idx, layout2);
    });
    processedMapType[mapType] = true;
  });
}
var v2ApplyTransform = applyTransform$1;
var View = function(_super) {
  __extends(View2, _super);
  function View2(name) {
    var _this = _super.call(this) || this;
    _this.type = "view";
    _this.dimensions = ["x", "y"];
    _this._roamTransformable = new Transformable$1();
    _this._rawTransformable = new Transformable$1();
    _this.name = name;
    return _this;
  }
  View2.prototype.setBoundingRect = function(x2, y2, width, height) {
    this._rect = new BoundingRect$1(x2, y2, width, height);
    return this._rect;
  };
  View2.prototype.getBoundingRect = function() {
    return this._rect;
  };
  View2.prototype.setViewRect = function(x2, y2, width, height) {
    this._transformTo(x2, y2, width, height);
    this._viewRect = new BoundingRect$1(x2, y2, width, height);
  };
  View2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var rawTransform = this._rawTransformable;
    rawTransform.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransform.parent;
    rawTransform.parent = null;
    rawTransform.decomposeTransform();
    rawTransform.parent = rawParent;
    this._updateTransform();
  };
  View2.prototype.setCenter = function(centerCoord) {
    if (!centerCoord) {
      return;
    }
    this._center = centerCoord;
    this._updateCenterAndZoom();
  };
  View2.prototype.setZoom = function(zoom) {
    zoom = zoom || 1;
    var zoomLimit = this.zoomLimit;
    if (zoomLimit) {
      if (zoomLimit.max != null) {
        zoom = Math.min(zoomLimit.max, zoom);
      }
      if (zoomLimit.min != null) {
        zoom = Math.max(zoomLimit.min, zoom);
      }
    }
    this._zoom = zoom;
    this._updateCenterAndZoom();
  };
  View2.prototype.getDefaultCenter = function() {
    var rawRect = this.getBoundingRect();
    var cx = rawRect.x + rawRect.width / 2;
    var cy = rawRect.y + rawRect.height / 2;
    return [cx, cy];
  };
  View2.prototype.getCenter = function() {
    return this._center || this.getDefaultCenter();
  };
  View2.prototype.getZoom = function() {
    return this._zoom || 1;
  };
  View2.prototype.getRoamTransform = function() {
    return this._roamTransformable.getLocalTransform();
  };
  View2.prototype._updateCenterAndZoom = function() {
    var rawTransformMatrix = this._rawTransformable.getLocalTransform();
    var roamTransform = this._roamTransformable;
    var defaultCenter = this.getDefaultCenter();
    var center2 = this.getCenter();
    var zoom = this.getZoom();
    center2 = applyTransform$1([], center2, rawTransformMatrix);
    defaultCenter = applyTransform$1([], defaultCenter, rawTransformMatrix);
    roamTransform.originX = center2[0];
    roamTransform.originY = center2[1];
    roamTransform.x = defaultCenter[0] - center2[0];
    roamTransform.y = defaultCenter[1] - center2[1];
    roamTransform.scaleX = roamTransform.scaleY = zoom;
    this._updateTransform();
  };
  View2.prototype._updateTransform = function() {
    var roamTransformable = this._roamTransformable;
    var rawTransformable = this._rawTransformable;
    rawTransformable.parent = roamTransformable;
    roamTransformable.updateTransform();
    rawTransformable.updateTransform();
    copy(this.transform || (this.transform = []), rawTransformable.transform || create$1());
    this._rawTransform = rawTransformable.getLocalTransform();
    this.invTransform = this.invTransform || [];
    invert(this.invTransform, this.transform);
    this.decomposeTransform();
  };
  View2.prototype.getTransformInfo = function() {
    var rawTransformable = this._rawTransformable;
    var roamTransformable = this._roamTransformable;
    var dummyTransformable2 = new Transformable$1();
    dummyTransformable2.transform = roamTransformable.transform;
    dummyTransformable2.decomposeTransform();
    return {
      roam: {
        x: dummyTransformable2.x,
        y: dummyTransformable2.y,
        scaleX: dummyTransformable2.scaleX,
        scaleY: dummyTransformable2.scaleY
      },
      raw: {
        x: rawTransformable.x,
        y: rawTransformable.y,
        scaleX: rawTransformable.scaleX,
        scaleY: rawTransformable.scaleY
      }
    };
  };
  View2.prototype.getViewRect = function() {
    return this._viewRect;
  };
  View2.prototype.getViewRectAfterRoam = function() {
    var rect = this.getBoundingRect().clone();
    rect.applyTransform(this.transform);
    return rect;
  };
  View2.prototype.dataToPoint = function(data, noRoam, out2) {
    var transform2 = noRoam ? this._rawTransform : this.transform;
    out2 = out2 || [];
    return transform2 ? v2ApplyTransform(out2, data, transform2) : copy$1(out2, data);
  };
  View2.prototype.pointToData = function(point) {
    var invTransform = this.invTransform;
    return invTransform ? v2ApplyTransform([], point, invTransform) : [point[0], point[1]];
  };
  View2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  View2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  View2.prototype.containPoint = function(point) {
    return this.getViewRectAfterRoam().contain(point[0], point[1]);
  };
  View2.dimensions = ["x", "y"];
  return View2;
}(Transformable$1);
function getCoordSys$4(finder) {
  var seriesModel = finder.seriesModel;
  return seriesModel ? seriesModel.coordinateSystem : null;
}
var View$1 = View;
var GEO_DEFAULT_PARAMS = {
  "geoJSON": {
    aspectScale: 0.75,
    invertLongitute: true
  },
  "geoSVG": {
    aspectScale: 1,
    invertLongitute: false
  }
};
var geo2DDimensions = ["lng", "lat"];
var Geo = function(_super) {
  __extends(Geo2, _super);
  function Geo2(name, map2, opt) {
    var _this = _super.call(this, name) || this;
    _this.dimensions = geo2DDimensions;
    _this.type = "geo";
    _this._nameCoordMap = createHashMap();
    _this.map = map2;
    var projection = opt.projection;
    var source = geoSourceManager.load(map2, opt.nameMap, opt.nameProperty);
    var resource = geoSourceManager.getGeoResource(map2);
    _this.resourceType = resource ? resource.type : null;
    var regions = _this.regions = source.regions;
    var defaultParams = GEO_DEFAULT_PARAMS[resource.type];
    _this._regionsMap = source.regionsMap;
    _this.regions = source.regions;
    _this.projection = projection;
    var boundingRect;
    if (projection) {
      for (var i = 0; i < regions.length; i++) {
        var regionRect = regions[i].getBoundingRect(projection);
        boundingRect = boundingRect || regionRect.clone();
        boundingRect.union(regionRect);
      }
    } else {
      boundingRect = source.boundingRect;
    }
    _this.setBoundingRect(boundingRect.x, boundingRect.y, boundingRect.width, boundingRect.height);
    _this.aspectScale = projection ? 1 : retrieve2(opt.aspectScale, defaultParams.aspectScale);
    _this._invertLongitute = projection ? false : defaultParams.invertLongitute;
    return _this;
  }
  Geo2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var invertLongitute = this._invertLongitute;
    rect = rect.clone();
    if (invertLongitute) {
      rect.y = -rect.y - rect.height;
    }
    var rawTransformable = this._rawTransformable;
    rawTransformable.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransformable.parent;
    rawTransformable.parent = null;
    rawTransformable.decomposeTransform();
    rawTransformable.parent = rawParent;
    if (invertLongitute) {
      rawTransformable.scaleY = -rawTransformable.scaleY;
    }
    this._updateTransform();
  };
  Geo2.prototype.getRegion = function(name) {
    return this._regionsMap.get(name);
  };
  Geo2.prototype.getRegionByCoord = function(coord) {
    var regions = this.regions;
    for (var i = 0; i < regions.length; i++) {
      var region = regions[i];
      if (region.type === "geoJSON" && region.contain(coord)) {
        return regions[i];
      }
    }
  };
  Geo2.prototype.addGeoCoord = function(name, geoCoord2) {
    this._nameCoordMap.set(name, geoCoord2);
  };
  Geo2.prototype.getGeoCoord = function(name) {
    var region = this._regionsMap.get(name);
    return this._nameCoordMap.get(name) || region && region.getCenter();
  };
  Geo2.prototype.dataToPoint = function(data, noRoam, out2) {
    if (isString(data)) {
      data = this.getGeoCoord(data);
    }
    if (data) {
      var projection = this.projection;
      if (projection) {
        data = projection.project(data);
      }
      return data && this.projectedToPoint(data);
    }
  };
  Geo2.prototype.pointToData = function(point) {
    var projection = this.projection;
    if (projection) {
      point = projection.unproject(point);
    }
    return point && this.pointToProjected(point);
  };
  Geo2.prototype.pointToProjected = function(point) {
    return _super.prototype.pointToData.call(this, point);
  };
  Geo2.prototype.projectedToPoint = function(projected, noRoam, out2) {
    return _super.prototype.dataToPoint.call(this, projected, noRoam, out2);
  };
  Geo2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Geo2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  return Geo2;
}(View$1);
mixin(Geo, View$1);
function getCoordSys$3(finder) {
  var geoModel = finder.geoModel;
  var seriesModel = finder.seriesModel;
  return geoModel ? geoModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem || (seriesModel.getReferringComponents("geo", SINGLE_REFERRING).models[0] || {}).coordinateSystem : null;
}
var Geo$1 = Geo;
function resizeGeo(geoModel, api) {
  var boundingCoords = geoModel.get("boundingCoords");
  if (boundingCoords != null) {
    var leftTop_1 = boundingCoords[0];
    var rightBottom_1 = boundingCoords[1];
    if (!(isFinite(leftTop_1[0]) && isFinite(leftTop_1[1]) && isFinite(rightBottom_1[0]) && isFinite(rightBottom_1[1])))
      ;
    else {
      var projection_1 = this.projection;
      if (projection_1) {
        var xMin = leftTop_1[0];
        var yMin = leftTop_1[1];
        var xMax = rightBottom_1[0];
        var yMax = rightBottom_1[1];
        leftTop_1 = [Infinity, Infinity];
        rightBottom_1 = [-Infinity, -Infinity];
        var sampleLine = function(x0, y0, x1, y1) {
          var dx = x1 - x0;
          var dy = y1 - y0;
          for (var i = 0; i <= 100; i++) {
            var p2 = i / 100;
            var pt = projection_1.project([x0 + dx * p2, y0 + dy * p2]);
            min$1(leftTop_1, leftTop_1, pt);
            max$1(rightBottom_1, rightBottom_1, pt);
          }
        };
        sampleLine(xMin, yMin, xMax, yMin);
        sampleLine(xMax, yMin, xMax, yMax);
        sampleLine(xMax, yMax, xMin, yMax);
        sampleLine(xMin, yMax, xMax, yMin);
      }
      this.setBoundingRect(leftTop_1[0], leftTop_1[1], rightBottom_1[0] - leftTop_1[0], rightBottom_1[1] - leftTop_1[1]);
    }
  }
  var rect = this.getBoundingRect();
  var centerOption = geoModel.get("layoutCenter");
  var sizeOption = geoModel.get("layoutSize");
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  var aspect = rect.width / rect.height * this.aspectScale;
  var useCenterAndSize = false;
  var center2;
  var size;
  if (centerOption && sizeOption) {
    center2 = [parsePercent(centerOption[0], viewWidth), parsePercent(centerOption[1], viewHeight)];
    size = parsePercent(sizeOption, Math.min(viewWidth, viewHeight));
    if (!isNaN(center2[0]) && !isNaN(center2[1]) && !isNaN(size)) {
      useCenterAndSize = true;
    }
  }
  var viewRect2;
  if (useCenterAndSize) {
    viewRect2 = {};
    if (aspect > 1) {
      viewRect2.width = size;
      viewRect2.height = size / aspect;
    } else {
      viewRect2.height = size;
      viewRect2.width = size * aspect;
    }
    viewRect2.y = center2[1] - viewRect2.height / 2;
    viewRect2.x = center2[0] - viewRect2.width / 2;
  } else {
    var boxLayoutOption = geoModel.getBoxLayoutParams();
    boxLayoutOption.aspect = aspect;
    viewRect2 = getLayoutRect(boxLayoutOption, {
      width: viewWidth,
      height: viewHeight
    });
  }
  this.setViewRect(viewRect2.x, viewRect2.y, viewRect2.width, viewRect2.height);
  this.setCenter(geoModel.get("center"));
  this.setZoom(geoModel.get("zoom"));
}
function setGeoCoords(geo, model) {
  each$f(model.get("geoCoord"), function(geoCoord2, name) {
    geo.addGeoCoord(name, geoCoord2);
  });
}
var GeoCreator = function() {
  function GeoCreator2() {
    this.dimensions = geo2DDimensions;
  }
  GeoCreator2.prototype.create = function(ecModel, api) {
    var geoList = [];
    function getCommonGeoProperties(model) {
      return {
        nameProperty: model.get("nameProperty"),
        aspectScale: model.get("aspectScale"),
        projection: model.get("projection")
      };
    }
    ecModel.eachComponent("geo", function(geoModel, idx) {
      var mapName = geoModel.get("map");
      var geo = new Geo$1(mapName + idx, mapName, extend({
        nameMap: geoModel.get("nameMap")
      }, getCommonGeoProperties(geoModel)));
      geo.zoomLimit = geoModel.get("scaleLimit");
      geoList.push(geo);
      geoModel.coordinateSystem = geo;
      geo.model = geoModel;
      geo.resize = resizeGeo;
      geo.resize(geoModel, api);
    });
    ecModel.eachSeries(function(seriesModel) {
      var coordSys = seriesModel.get("coordinateSystem");
      if (coordSys === "geo") {
        var geoIndex = seriesModel.get("geoIndex") || 0;
        seriesModel.coordinateSystem = geoList[geoIndex];
      }
    });
    var mapModelGroupBySeries = {};
    ecModel.eachSeriesByType("map", function(seriesModel) {
      if (!seriesModel.getHostGeoModel()) {
        var mapType = seriesModel.getMapType();
        mapModelGroupBySeries[mapType] = mapModelGroupBySeries[mapType] || [];
        mapModelGroupBySeries[mapType].push(seriesModel);
      }
    });
    each$f(mapModelGroupBySeries, function(mapSeries, mapType) {
      var nameMapList = map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("nameMap");
      });
      var geo = new Geo$1(mapType, mapType, extend({
        nameMap: mergeAll(nameMapList)
      }, getCommonGeoProperties(mapSeries[0])));
      geo.zoomLimit = retrieve.apply(null, map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("scaleLimit");
      }));
      geoList.push(geo);
      geo.resize = resizeGeo;
      geo.resize(mapSeries[0], api);
      each$f(mapSeries, function(singleMapSeries) {
        singleMapSeries.coordinateSystem = geo;
        setGeoCoords(geo, singleMapSeries);
      });
    });
    return geoList;
  };
  GeoCreator2.prototype.getFilledRegions = function(originRegionArr, mapName, nameMap, nameProperty) {
    var regionsArr = (originRegionArr || []).slice();
    var dataNameMap = createHashMap();
    for (var i = 0; i < regionsArr.length; i++) {
      dataNameMap.set(regionsArr[i].name, regionsArr[i]);
    }
    var source = geoSourceManager.load(mapName, nameMap, nameProperty);
    each$f(source.regions, function(region) {
      var name = region.name;
      !dataNameMap.get(name) && regionsArr.push({
        name
      });
    });
    return regionsArr;
  };
  return GeoCreator2;
}();
var geoCreator = new GeoCreator();
var geoCreator$1 = geoCreator;
var GeoModel = function(_super) {
  __extends(GeoModel2, _super);
  function GeoModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoModel2.type;
    return _this;
  }
  GeoModel2.prototype.init = function(option, parentModel, ecModel) {
    var source = geoSourceManager.getGeoResource(option.map);
    if (source && source.type === "geoJSON") {
      var itemStyle = option.itemStyle = option.itemStyle || {};
      if (!("color" in itemStyle)) {
        itemStyle.color = "#eee";
      }
    }
    this.mergeDefaultAndTheme(option, ecModel);
    defaultEmphasis(option, "label", ["show"]);
  };
  GeoModel2.prototype.optionUpdated = function() {
    var _this = this;
    var option = this.option;
    option.regions = geoCreator$1.getFilledRegions(option.regions, option.map, option.nameMap, option.nameProperty);
    var selectedMap = {};
    this._optionModelMap = reduce(option.regions || [], function(optionModelMap, regionOpt) {
      var regionName = regionOpt.name;
      if (regionName) {
        optionModelMap.set(regionName, new Model$1(regionOpt, _this, _this.ecModel));
        if (regionOpt.selected) {
          selectedMap[regionName] = true;
        }
      }
      return optionModelMap;
    }, createHashMap());
    if (!option.selectedMap) {
      option.selectedMap = selectedMap;
    }
  };
  GeoModel2.prototype.getRegionModel = function(name) {
    return this._optionModelMap.get(name) || new Model$1(null, this, this.ecModel);
  };
  GeoModel2.prototype.getFormattedLabel = function(name, status) {
    var regionModel = this.getRegionModel(name);
    var formatter = status === "normal" ? regionModel.get(["label", "formatter"]) : regionModel.get(["emphasis", "label", "formatter"]);
    var params = {
      name
    };
    if (isFunction(formatter)) {
      params.status = status;
      return formatter(params);
    } else if (isString(formatter)) {
      return formatter.replace("{a}", name != null ? name : "");
    }
  };
  GeoModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GeoModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GeoModel2.prototype.select = function(name) {
    var option = this.option;
    var selectedMode = option.selectedMode;
    if (!selectedMode) {
      return;
    }
    if (selectedMode !== "multiple") {
      option.selectedMap = null;
    }
    var selectedMap = option.selectedMap || (option.selectedMap = {});
    selectedMap[name] = true;
  };
  GeoModel2.prototype.unSelect = function(name) {
    var selectedMap = this.option.selectedMap;
    if (selectedMap) {
      selectedMap[name] = false;
    }
  };
  GeoModel2.prototype.toggleSelected = function(name) {
    this[this.isSelected(name) ? "unSelect" : "select"](name);
  };
  GeoModel2.prototype.isSelected = function(name) {
    var selectedMap = this.option.selectedMap;
    return !!(selectedMap && selectedMap[name]);
  };
  GeoModel2.type = "geo";
  GeoModel2.layoutMode = "box";
  GeoModel2.defaultOption = {
    z: 0,
    show: true,
    left: "center",
    top: "center",
    aspectScale: null,
    silent: false,
    map: "",
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    regions: []
  };
  return GeoModel2;
}(ComponentModel$1);
var GeoModel$1 = GeoModel;
function getCenterCoord(view, point) {
  return view.pointToProjected ? view.pointToProjected(point) : view.pointToData(point);
}
function updateCenterAndZoom(view, payload, zoomLimit) {
  var previousZoom = view.getZoom();
  var center2 = view.getCenter();
  var zoom = payload.zoom;
  var point = view.projectedToPoint ? view.projectedToPoint(center2) : view.dataToPoint(center2);
  if (payload.dx != null && payload.dy != null) {
    point[0] -= payload.dx;
    point[1] -= payload.dy;
    view.setCenter(getCenterCoord(view, point));
  }
  if (zoom != null) {
    if (zoomLimit) {
      var zoomMin = zoomLimit.min || 0;
      var zoomMax = zoomLimit.max || Infinity;
      zoom = Math.max(Math.min(previousZoom * zoom, zoomMax), zoomMin) / previousZoom;
    }
    view.scaleX *= zoom;
    view.scaleY *= zoom;
    var fixX = (payload.originX - view.x) * (zoom - 1);
    var fixY = (payload.originY - view.y) * (zoom - 1);
    view.x -= fixX;
    view.y -= fixY;
    view.updateTransform();
    view.setCenter(getCenterCoord(view, point));
    view.setZoom(zoom * previousZoom);
  }
  return {
    center: view.getCenter(),
    zoom: view.getZoom()
  };
}
var GeoView = function(_super) {
  __extends(GeoView2, _super);
  function GeoView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoView2.type;
    _this.focusBlurEnabled = true;
    return _this;
  }
  GeoView2.prototype.init = function(ecModel, api) {
    this._api = api;
  };
  GeoView2.prototype.render = function(geoModel, ecModel, api, payload) {
    this._model = geoModel;
    if (!geoModel.get("show")) {
      this._mapDraw && this._mapDraw.remove();
      this._mapDraw = null;
      return;
    }
    if (!this._mapDraw) {
      this._mapDraw = new MapDraw$1(api);
    }
    var mapDraw = this._mapDraw;
    mapDraw.draw(geoModel, ecModel, api, this, payload);
    mapDraw.group.on("click", this._handleRegionClick, this);
    mapDraw.group.silent = geoModel.get("silent");
    this.group.add(mapDraw.group);
    this.updateSelectStatus(geoModel, ecModel, api);
  };
  GeoView2.prototype._handleRegionClick = function(e2) {
    var eventData;
    findEventDispatcher(e2.target, function(current) {
      return (eventData = getECData(current).eventData) != null;
    }, true);
    if (eventData) {
      this._api.dispatchAction({
        type: "geoToggleSelect",
        geoId: this._model.id,
        name: eventData.name
      });
    }
  };
  GeoView2.prototype.updateSelectStatus = function(model, ecModel, api) {
    var _this = this;
    this._mapDraw.group.traverse(function(node) {
      var eventData = getECData(node).eventData;
      if (eventData) {
        _this._model.isSelected(eventData.name) ? api.enterSelect(node) : api.leaveSelect(node);
        return true;
      }
    });
  };
  GeoView2.prototype.findHighDownDispatchers = function(name) {
    return this._mapDraw && this._mapDraw.findHighDownDispatchers(name, this._model);
  };
  GeoView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
  };
  GeoView2.type = "geo";
  return GeoView2;
}(ComponentView$1);
var GeoView$1 = GeoView;
function registerMap(mapName, geoJson, specialAreas) {
  geoSourceManager.registerMap(mapName, geoJson, specialAreas);
}
function install$J(registers) {
  registers.registerCoordinateSystem("geo", geoCreator$1);
  registers.registerComponentModel(GeoModel$1);
  registers.registerComponentView(GeoView$1);
  registers.registerImpl("registerMap", registerMap);
  registers.registerImpl("getMap", function(mapName) {
    return geoSourceManager.getMapForUser(mapName);
  });
  function makeAction(method4, actionInfo2) {
    actionInfo2.update = "geo:updateSelectStatus";
    registers.registerAction(actionInfo2, function(payload, ecModel) {
      var selected = {};
      var allSelected = [];
      ecModel.eachComponent({
        mainType: "geo",
        query: payload
      }, function(geoModel) {
        geoModel[method4](payload.name);
        var geo = geoModel.coordinateSystem;
        each$f(geo.regions, function(region) {
          selected[region.name] = geoModel.isSelected(region.name) || false;
        });
        var names2 = [];
        each$f(selected, function(v4, name) {
          selected[name] && names2.push(name);
        });
        allSelected.push({
          geoIndex: geoModel.componentIndex,
          name: names2
        });
      });
      return {
        selected,
        allSelected,
        name: payload.name
      };
    });
  }
  makeAction("toggleSelected", {
    type: "geoToggleSelect",
    event: "geoselectchanged"
  });
  makeAction("select", {
    type: "geoSelect",
    event: "geoselected"
  });
  makeAction("unSelect", {
    type: "geoUnSelect",
    event: "geounselected"
  });
  registers.registerAction({
    type: "geoRoam",
    event: "geoRoam",
    update: "updateTransform"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      var geo = componentModel.coordinateSystem;
      if (geo.type !== "geo") {
        return;
      }
      var res = updateCenterAndZoom(geo, payload, componentModel.get("scaleLimit"));
      componentModel.setCenter && componentModel.setCenter(res.center);
      componentModel.setZoom && componentModel.setZoom(res.zoom);
      if (componentType === "series") {
        each$f(componentModel.seriesGroup, function(seriesModel) {
          seriesModel.setCenter(res.center);
          seriesModel.setZoom(res.zoom);
        });
      }
    });
  });
}
function install$I(registers) {
  use(install$J);
  registers.registerChartView(MapView$1);
  registers.registerSeriesModel(MapSeries$1);
  registers.registerLayout(mapSymbolLayout);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, mapDataStatistic);
  createLegacyDataSelectAction("map", registers.registerAction);
}
function init(inRoot) {
  var root2 = inRoot;
  root2.hierNode = {
    defaultAncestor: null,
    ancestor: root2,
    prelim: 0,
    modifier: 0,
    change: 0,
    shift: 0,
    i: 0,
    thread: null
  };
  var nodes = [root2];
  var node;
  var children;
  while (node = nodes.pop()) {
    children = node.children;
    if (node.isExpand && children.length) {
      var n2 = children.length;
      for (var i = n2 - 1; i >= 0; i--) {
        var child = children[i];
        child.hierNode = {
          defaultAncestor: null,
          ancestor: child,
          prelim: 0,
          modifier: 0,
          change: 0,
          shift: 0,
          i,
          thread: null
        };
        nodes.push(child);
      }
    }
  }
}
function firstWalk(node, separation2) {
  var children = node.isExpand ? node.children : [];
  var siblings = node.parentNode.children;
  var subtreeW = node.hierNode.i ? siblings[node.hierNode.i - 1] : null;
  if (children.length) {
    executeShifts(node);
    var midPoint = (children[0].hierNode.prelim + children[children.length - 1].hierNode.prelim) / 2;
    if (subtreeW) {
      node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
      node.hierNode.modifier = node.hierNode.prelim - midPoint;
    } else {
      node.hierNode.prelim = midPoint;
    }
  } else if (subtreeW) {
    node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
  }
  node.parentNode.hierNode.defaultAncestor = apportion(node, subtreeW, node.parentNode.hierNode.defaultAncestor || siblings[0], separation2);
}
function secondWalk(node) {
  var nodeX = node.hierNode.prelim + node.parentNode.hierNode.modifier;
  node.setLayout({
    x: nodeX
  }, true);
  node.hierNode.modifier += node.parentNode.hierNode.modifier;
}
function separation(cb) {
  return arguments.length ? cb : defaultSeparation;
}
function radialCoordinate(rad, r2) {
  rad -= Math.PI / 2;
  return {
    x: r2 * Math.cos(rad),
    y: r2 * Math.sin(rad)
  };
}
function getViewRect$4(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function executeShifts(node) {
  var children = node.children;
  var n2 = children.length;
  var shift = 0;
  var change = 0;
  while (--n2 >= 0) {
    var child = children[n2];
    child.hierNode.prelim += shift;
    child.hierNode.modifier += shift;
    change += child.hierNode.change;
    shift += child.hierNode.shift + change;
  }
}
function apportion(subtreeV, subtreeW, ancestor, separation2) {
  if (subtreeW) {
    var nodeOutRight = subtreeV;
    var nodeInRight = subtreeV;
    var nodeOutLeft = nodeInRight.parentNode.children[0];
    var nodeInLeft = subtreeW;
    var sumOutRight = nodeOutRight.hierNode.modifier;
    var sumInRight = nodeInRight.hierNode.modifier;
    var sumOutLeft = nodeOutLeft.hierNode.modifier;
    var sumInLeft = nodeInLeft.hierNode.modifier;
    while (nodeInLeft = nextRight(nodeInLeft), nodeInRight = nextLeft(nodeInRight), nodeInLeft && nodeInRight) {
      nodeOutRight = nextRight(nodeOutRight);
      nodeOutLeft = nextLeft(nodeOutLeft);
      nodeOutRight.hierNode.ancestor = subtreeV;
      var shift = nodeInLeft.hierNode.prelim + sumInLeft - nodeInRight.hierNode.prelim - sumInRight + separation2(nodeInLeft, nodeInRight);
      if (shift > 0) {
        moveSubtree(nextAncestor(nodeInLeft, subtreeV, ancestor), subtreeV, shift);
        sumInRight += shift;
        sumOutRight += shift;
      }
      sumInLeft += nodeInLeft.hierNode.modifier;
      sumInRight += nodeInRight.hierNode.modifier;
      sumOutRight += nodeOutRight.hierNode.modifier;
      sumOutLeft += nodeOutLeft.hierNode.modifier;
    }
    if (nodeInLeft && !nextRight(nodeOutRight)) {
      nodeOutRight.hierNode.thread = nodeInLeft;
      nodeOutRight.hierNode.modifier += sumInLeft - sumOutRight;
    }
    if (nodeInRight && !nextLeft(nodeOutLeft)) {
      nodeOutLeft.hierNode.thread = nodeInRight;
      nodeOutLeft.hierNode.modifier += sumInRight - sumOutLeft;
      ancestor = subtreeV;
    }
  }
  return ancestor;
}
function nextRight(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[children.length - 1] : node.hierNode.thread;
}
function nextLeft(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[0] : node.hierNode.thread;
}
function nextAncestor(nodeInLeft, node, ancestor) {
  return nodeInLeft.hierNode.ancestor.parentNode === node.parentNode ? nodeInLeft.hierNode.ancestor : ancestor;
}
function moveSubtree(wl, wr, shift) {
  var change = shift / (wr.hierNode.i - wl.hierNode.i);
  wr.hierNode.change -= change;
  wr.hierNode.shift += shift;
  wr.hierNode.modifier += shift;
  wr.hierNode.prelim += shift;
  wl.hierNode.change += change;
}
function defaultSeparation(node1, node2) {
  return node1.parentNode === node2.parentNode ? 1 : 2;
}
var TreeEdgeShape = function() {
  function TreeEdgeShape2() {
    this.parentPoint = [];
    this.childPoints = [];
  }
  return TreeEdgeShape2;
}();
var TreePath = function(_super) {
  __extends(TreePath2, _super);
  function TreePath2(opts) {
    return _super.call(this, opts) || this;
  }
  TreePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  TreePath2.prototype.getDefaultShape = function() {
    return new TreeEdgeShape();
  };
  TreePath2.prototype.buildPath = function(ctx, shape) {
    var childPoints = shape.childPoints;
    var childLen = childPoints.length;
    var parentPoint = shape.parentPoint;
    var firstChildPos = childPoints[0];
    var lastChildPos = childPoints[childLen - 1];
    if (childLen === 1) {
      ctx.moveTo(parentPoint[0], parentPoint[1]);
      ctx.lineTo(firstChildPos[0], firstChildPos[1]);
      return;
    }
    var orient = shape.orient;
    var forkDim = orient === "TB" || orient === "BT" ? 0 : 1;
    var otherDim = 1 - forkDim;
    var forkPosition = parsePercent(shape.forkPosition, 1);
    var tmpPoint = [];
    tmpPoint[forkDim] = parentPoint[forkDim];
    tmpPoint[otherDim] = parentPoint[otherDim] + (lastChildPos[otherDim] - parentPoint[otherDim]) * forkPosition;
    ctx.moveTo(parentPoint[0], parentPoint[1]);
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.moveTo(firstChildPos[0], firstChildPos[1]);
    tmpPoint[forkDim] = firstChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    tmpPoint[forkDim] = lastChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.lineTo(lastChildPos[0], lastChildPos[1]);
    for (var i = 1; i < childLen - 1; i++) {
      var point = childPoints[i];
      ctx.moveTo(point[0], point[1]);
      tmpPoint[forkDim] = point[forkDim];
      ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    }
  };
  return TreePath2;
}(Path$1);
var TreeView = function(_super) {
  __extends(TreeView2, _super);
  function TreeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreeView2.type;
    _this._mainGroup = new Group$4();
    return _this;
  }
  TreeView2.prototype.init = function(ecModel, api) {
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: this.group
    };
    this.group.add(this._mainGroup);
  };
  TreeView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var layoutInfo = seriesModel.layoutInfo;
    var group = this._mainGroup;
    var layout2 = seriesModel.get("layout");
    if (layout2 === "radial") {
      group.x = layoutInfo.x + layoutInfo.width / 2;
      group.y = layoutInfo.y + layoutInfo.height / 2;
    } else {
      group.x = layoutInfo.x;
      group.y = layoutInfo.y;
    }
    this._updateViewCoordSys(seriesModel);
    this._updateController(seriesModel, ecModel, api);
    var oldData = this._data;
    data.diff(oldData).add(function(newIdx) {
      if (symbolNeedsDraw(data, newIdx)) {
        updateNode(data, newIdx, null, group, seriesModel);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!symbolNeedsDraw(data, newIdx)) {
        symbolEl && removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
        return;
      }
      updateNode(data, newIdx, symbolEl, group, seriesModel);
    }).remove(function(oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (symbolEl) {
        removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
      }
    }).execute();
    this._nodeScaleRatio = seriesModel.get("nodeScaleRatio");
    this._updateNodeAndLinkScale(seriesModel);
    if (seriesModel.get("expandAndCollapse") === true) {
      data.eachItemGraphicEl(function(el, dataIndex) {
        el.off("click").on("click", function() {
          api.dispatchAction({
            type: "treeExpandAndCollapse",
            seriesId: seriesModel.id,
            dataIndex
          });
        });
      });
    }
    this._data = data;
  };
  TreeView2.prototype._updateViewCoordSys = function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    data.each(function(idx) {
      var layout2 = data.getItemLayout(idx);
      if (layout2 && !isNaN(layout2.x) && !isNaN(layout2.y)) {
        points2.push([+layout2.x, +layout2.y]);
      }
    });
    var min3 = [];
    var max3 = [];
    fromPoints(points2, min3, max3);
    var oldMin = this._min;
    var oldMax = this._max;
    if (max3[0] - min3[0] === 0) {
      min3[0] = oldMin ? oldMin[0] : min3[0] - 1;
      max3[0] = oldMax ? oldMax[0] : max3[0] + 1;
    }
    if (max3[1] - min3[1] === 0) {
      min3[1] = oldMin ? oldMin[1] : min3[1] - 1;
      max3[1] = oldMax ? oldMax[1] : max3[1] + 1;
    }
    var viewCoordSys = seriesModel.coordinateSystem = new View$1();
    viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
    viewCoordSys.setBoundingRect(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    viewCoordSys.setCenter(seriesModel.get("center"));
    viewCoordSys.setZoom(seriesModel.get("zoom"));
    this.group.attr({
      x: viewCoordSys.x,
      y: viewCoordSys.y,
      scaleX: viewCoordSys.scaleX,
      scaleY: viewCoordSys.scaleY
    });
    this._min = min3;
    this._max = max3;
  };
  TreeView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale(seriesModel);
      api.updateLabelLayout();
    });
  };
  TreeView2.prototype._updateNodeAndLinkScale = function(seriesModel) {
    var data = seriesModel.getData();
    var nodeScale = this._getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el.setSymbolScale(nodeScale);
    });
  };
  TreeView2.prototype._getNodeGlobalScale = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type !== "view") {
      return 1;
    }
    var nodeScaleRatio = this._nodeScaleRatio;
    var groupZoom = coordSys.scaleX || 1;
    var roamZoom = coordSys.getZoom();
    var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
    return nodeScale / groupZoom;
  };
  TreeView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  TreeView2.prototype.remove = function() {
    this._mainGroup.removeAll();
    this._data = null;
  };
  TreeView2.type = "tree";
  return TreeView2;
}(ChartView$1);
function symbolNeedsDraw(data, dataIndex) {
  var layout2 = data.getItemLayout(dataIndex);
  return layout2 && !isNaN(layout2.x) && !isNaN(layout2.y);
}
function updateNode(data, dataIndex, symbolEl, group, seriesModel) {
  var isInit = !symbolEl;
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var itemModel = node.getModel();
  var visualColor = node.getVisual("style").fill;
  var symbolInnerColor = node.isExpand === false && node.children.length !== 0 ? visualColor : "#fff";
  var virtualRoot = data.tree.root;
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceLayout = source.getLayout();
  var sourceOldLayout = sourceSymbolEl ? {
    x: sourceSymbolEl.__oldX,
    y: sourceSymbolEl.__oldY,
    rawX: sourceSymbolEl.__radialOldRawX,
    rawY: sourceSymbolEl.__radialOldRawY
  } : sourceLayout;
  var targetLayout = node.getLayout();
  if (isInit) {
    symbolEl = new SymbolClz(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
    symbolEl.x = sourceOldLayout.x;
    symbolEl.y = sourceOldLayout.y;
  } else {
    symbolEl.updateData(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
  }
  symbolEl.__radialOldRawX = symbolEl.__radialRawX;
  symbolEl.__radialOldRawY = symbolEl.__radialRawY;
  symbolEl.__radialRawX = targetLayout.rawX;
  symbolEl.__radialRawY = targetLayout.rawY;
  group.add(symbolEl);
  data.setItemGraphicEl(dataIndex, symbolEl);
  symbolEl.__oldX = symbolEl.x;
  symbolEl.__oldY = symbolEl.y;
  updateProps$1(symbolEl, {
    x: targetLayout.x,
    y: targetLayout.y
  }, seriesModel);
  var symbolPath = symbolEl.getSymbolPath();
  if (seriesModel.get("layout") === "radial") {
    var realRoot = virtualRoot.children[0];
    var rootLayout = realRoot.getLayout();
    var length_1 = realRoot.children.length;
    var rad = void 0;
    var isLeft = void 0;
    if (targetLayout.x === rootLayout.x && node.isExpand === true) {
      var center2 = {
        x: (realRoot.children[0].getLayout().x + realRoot.children[length_1 - 1].getLayout().x) / 2,
        y: (realRoot.children[0].getLayout().y + realRoot.children[length_1 - 1].getLayout().y) / 2
      };
      rad = Math.atan2(center2.y - rootLayout.y, center2.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      isLeft = center2.x < rootLayout.x;
      if (isLeft) {
        rad = rad - Math.PI;
      }
    } else {
      rad = Math.atan2(targetLayout.y - rootLayout.y, targetLayout.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      if (node.children.length === 0 || node.children.length !== 0 && node.isExpand === false) {
        isLeft = targetLayout.x < rootLayout.x;
        if (isLeft) {
          rad = rad - Math.PI;
        }
      } else {
        isLeft = targetLayout.x > rootLayout.x;
        if (!isLeft) {
          rad = rad - Math.PI;
        }
      }
    }
    var textPosition = isLeft ? "left" : "right";
    var normalLabelModel = itemModel.getModel("label");
    var rotate2 = normalLabelModel.get("rotate");
    var labelRotateRadian = rotate2 * (Math.PI / 180);
    var textContent = symbolPath.getTextContent();
    if (textContent) {
      symbolPath.setTextConfig({
        position: normalLabelModel.get("position") || textPosition,
        rotation: rotate2 == null ? -rad : labelRotateRadian,
        origin: "center"
      });
      textContent.setStyle("verticalAlign", "middle");
    }
  }
  var focus = itemModel.get(["emphasis", "focus"]);
  var focusDataIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : null;
  if (focusDataIndices) {
    getECData(symbolEl).focus = focusDataIndices;
  }
  drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group);
  if (symbolEl.__edge) {
    symbolEl.onHoverStateChange = function(toState) {
      if (toState !== "blur") {
        var parentEl = node.parentNode && data.getItemGraphicEl(node.parentNode.dataIndex);
        if (!(parentEl && parentEl.hoverState === HOVER_STATE_BLUR)) {
          setStatesFlag(symbolEl.__edge, toState);
        }
      }
    };
  }
}
function drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group) {
  var itemModel = node.getModel();
  var edgeShape = seriesModel.get("edgeShape");
  var layout2 = seriesModel.get("layout");
  var orient = seriesModel.getOrient();
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  var edgeForkPosition = seriesModel.get("edgeForkPosition");
  var lineStyle = itemModel.getModel("lineStyle").getLineStyle();
  var edge = symbolEl.__edge;
  if (edgeShape === "curve") {
    if (node.parentNode && node.parentNode !== virtualRoot) {
      if (!edge) {
        edge = symbolEl.__edge = new BezierCurve$1({
          shape: getEdgeShape(layout2, orient, curvature, sourceOldLayout, sourceOldLayout)
        });
      }
      updateProps$1(edge, {
        shape: getEdgeShape(layout2, orient, curvature, sourceLayout, targetLayout)
      }, seriesModel);
    }
  } else if (edgeShape === "polyline") {
    if (layout2 === "orthogonal") {
      if (node !== virtualRoot && node.children && node.children.length !== 0 && node.isExpand === true) {
        var children = node.children;
        var childPoints = [];
        for (var i = 0; i < children.length; i++) {
          var childLayout = children[i].getLayout();
          childPoints.push([childLayout.x, childLayout.y]);
        }
        if (!edge) {
          edge = symbolEl.__edge = new TreePath({
            shape: {
              parentPoint: [targetLayout.x, targetLayout.y],
              childPoints: [[targetLayout.x, targetLayout.y]],
              orient,
              forkPosition: edgeForkPosition
            }
          });
        }
        updateProps$1(edge, {
          shape: {
            parentPoint: [targetLayout.x, targetLayout.y],
            childPoints
          }
        }, seriesModel);
      }
    }
  }
  if (edge) {
    edge.useStyle(defaults({
      strokeNoScale: true,
      fill: null
    }, lineStyle));
    setStatesStylesFromModel(edge, itemModel, "lineStyle");
    setDefaultStateProxy(edge);
    group.add(edge);
  }
}
function removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt) {
  var virtualRoot = data.tree.root;
  var _a2 = getSourceNode(virtualRoot, node), source = _a2.source, sourceLayout = _a2.sourceLayout;
  var symbolEl = data.getItemGraphicEl(node.dataIndex);
  if (!symbolEl) {
    return;
  }
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceEdge = sourceSymbolEl.__edge;
  var edge = symbolEl.__edge || (source.isExpand === false || source.children.length === 1 ? sourceEdge : void 0);
  var edgeShape = seriesModel.get("edgeShape");
  var layoutOpt = seriesModel.get("layout");
  var orient = seriesModel.get("orient");
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  if (edge) {
    if (edgeShape === "curve") {
      removeElement(edge, {
        shape: getEdgeShape(layoutOpt, orient, curvature, sourceLayout, sourceLayout),
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    } else if (edgeShape === "polyline" && seriesModel.get("layout") === "orthogonal") {
      removeElement(edge, {
        shape: {
          parentPoint: [sourceLayout.x, sourceLayout.y],
          childPoints: [[sourceLayout.x, sourceLayout.y]]
        },
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    }
  }
}
function getSourceNode(virtualRoot, node) {
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceLayout;
  while (sourceLayout = source.getLayout(), sourceLayout == null) {
    source = source.parentNode === virtualRoot ? source : source.parentNode || source;
  }
  return {
    source,
    sourceLayout
  };
}
function removeNode(data, dataIndex, symbolEl, group, seriesModel) {
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var virtualRoot = data.tree.root;
  var sourceLayout = getSourceNode(virtualRoot, node).sourceLayout;
  var removeAnimationOpt = {
    duration: seriesModel.get("animationDurationUpdate"),
    easing: seriesModel.get("animationEasingUpdate")
  };
  removeElement(symbolEl, {
    x: sourceLayout.x + 1,
    y: sourceLayout.y + 1
  }, seriesModel, {
    cb: function() {
      group.remove(symbolEl);
      data.setItemGraphicEl(dataIndex, null);
    },
    removeOpt: removeAnimationOpt
  });
  symbolEl.fadeOut(null, data.hostModel, {
    fadeLabel: true,
    animation: removeAnimationOpt
  });
  node.children.forEach(function(childNode) {
    removeNodeEdge(childNode, data, group, seriesModel, removeAnimationOpt);
  });
  removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt);
}
function getEdgeShape(layoutOpt, orient, curvature, sourceLayout, targetLayout) {
  var cpx1;
  var cpy1;
  var cpx2;
  var cpy2;
  var x1;
  var x2;
  var y1;
  var y2;
  if (layoutOpt === "radial") {
    x1 = sourceLayout.rawX;
    y1 = sourceLayout.rawY;
    x2 = targetLayout.rawX;
    y2 = targetLayout.rawY;
    var radialCoor1 = radialCoordinate(x1, y1);
    var radialCoor2 = radialCoordinate(x1, y1 + (y2 - y1) * curvature);
    var radialCoor3 = radialCoordinate(x2, y2 + (y1 - y2) * curvature);
    var radialCoor4 = radialCoordinate(x2, y2);
    return {
      x1: radialCoor1.x || 0,
      y1: radialCoor1.y || 0,
      x2: radialCoor4.x || 0,
      y2: radialCoor4.y || 0,
      cpx1: radialCoor2.x || 0,
      cpy1: radialCoor2.y || 0,
      cpx2: radialCoor3.x || 0,
      cpy2: radialCoor3.y || 0
    };
  } else {
    x1 = sourceLayout.x;
    y1 = sourceLayout.y;
    x2 = targetLayout.x;
    y2 = targetLayout.y;
    if (orient === "LR" || orient === "RL") {
      cpx1 = x1 + (x2 - x1) * curvature;
      cpy1 = y1;
      cpx2 = x2 + (x1 - x2) * curvature;
      cpy2 = y2;
    }
    if (orient === "TB" || orient === "BT") {
      cpx1 = x1;
      cpy1 = y1 + (y2 - y1) * curvature;
      cpx2 = x2;
      cpy2 = y2 + (y1 - y2) * curvature;
    }
  }
  return {
    x1,
    y1,
    x2,
    y2,
    cpx1,
    cpy1,
    cpx2,
    cpy2
  };
}
var TreeView$1 = TreeView;
var inner$e = makeInner();
function linkSeriesData(opt) {
  var mainData = opt.mainData;
  var datas = opt.datas;
  if (!datas) {
    datas = {
      main: mainData
    };
    opt.datasAttr = {
      main: "data"
    };
  }
  opt.datas = opt.mainData = null;
  linkAll(mainData, datas, opt);
  each$f(datas, function(data) {
    each$f(mainData.TRANSFERABLE_METHODS, function(methodName) {
      data.wrapMethod(methodName, curry$1(transferInjection, opt));
    });
  });
  mainData.wrapMethod("cloneShallow", curry$1(cloneShallowInjection, opt));
  each$f(mainData.CHANGABLE_METHODS, function(methodName) {
    mainData.wrapMethod(methodName, curry$1(changeInjection, opt));
  });
  assert(datas[mainData.dataType] === mainData);
}
function transferInjection(opt, res) {
  if (isMainData(this)) {
    var datas = extend({}, inner$e(this).datas);
    datas[this.dataType] = res;
    linkAll(res, datas, opt);
  } else {
    linkSingle(res, this.dataType, inner$e(this).mainData, opt);
  }
  return res;
}
function changeInjection(opt, res) {
  opt.struct && opt.struct.update();
  return res;
}
function cloneShallowInjection(opt, res) {
  each$f(inner$e(res).datas, function(data, dataType) {
    data !== res && linkSingle(data.cloneShallow(), dataType, res, opt);
  });
  return res;
}
function getLinkedData(dataType) {
  var mainData = inner$e(this).mainData;
  return dataType == null || mainData == null ? mainData : inner$e(mainData).datas[dataType];
}
function getLinkedDataAll() {
  var mainData = inner$e(this).mainData;
  return mainData == null ? [{
    data: mainData
  }] : map$1(keys(inner$e(mainData).datas), function(type4) {
    return {
      type: type4,
      data: inner$e(mainData).datas[type4]
    };
  });
}
function isMainData(data) {
  return inner$e(data).mainData === data;
}
function linkAll(mainData, datas, opt) {
  inner$e(mainData).datas = {};
  each$f(datas, function(data, dataType) {
    linkSingle(data, dataType, mainData, opt);
  });
}
function linkSingle(data, dataType, mainData, opt) {
  inner$e(mainData).datas[dataType] = data;
  inner$e(data).mainData = mainData;
  data.dataType = dataType;
  if (opt.struct) {
    data[opt.structAttr] = opt.struct;
    opt.struct[opt.datasAttr[dataType]] = data;
  }
  data.getLinkedData = getLinkedData;
  data.getLinkedDataAll = getLinkedDataAll;
}
var TreeNode = function() {
  function TreeNode2(name, hostTree) {
    this.depth = 0;
    this.height = 0;
    this.dataIndex = -1;
    this.children = [];
    this.viewChildren = [];
    this.isExpand = false;
    this.name = name || "";
    this.hostTree = hostTree;
  }
  TreeNode2.prototype.isRemoved = function() {
    return this.dataIndex < 0;
  };
  TreeNode2.prototype.eachNode = function(options, cb, context) {
    if (isFunction(options)) {
      context = cb;
      cb = options;
      options = null;
    }
    options = options || {};
    if (isString(options)) {
      options = {
        order: options
      };
    }
    var order = options.order || "preorder";
    var children = this[options.attr || "children"];
    var suppressVisitSub;
    order === "preorder" && (suppressVisitSub = cb.call(context, this));
    for (var i = 0; !suppressVisitSub && i < children.length; i++) {
      children[i].eachNode(options, cb, context);
    }
    order === "postorder" && cb.call(context, this);
  };
  TreeNode2.prototype.updateDepthAndHeight = function(depth) {
    var height = 0;
    this.depth = depth;
    for (var i = 0; i < this.children.length; i++) {
      var child = this.children[i];
      child.updateDepthAndHeight(depth + 1);
      if (child.height > height) {
        height = child.height;
      }
    }
    this.height = height + 1;
  };
  TreeNode2.prototype.getNodeById = function(id2) {
    if (this.getId() === id2) {
      return this;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].getNodeById(id2);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.contains = function(node) {
    if (node === this) {
      return true;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].contains(node);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.getAncestors = function(includeSelf) {
    var ancestors = [];
    var node = includeSelf ? this : this.parentNode;
    while (node) {
      ancestors.push(node);
      node = node.parentNode;
    }
    ancestors.reverse();
    return ancestors;
  };
  TreeNode2.prototype.getAncestorsIndices = function() {
    var indices = [];
    var currNode = this;
    while (currNode) {
      indices.push(currNode.dataIndex);
      currNode = currNode.parentNode;
    }
    indices.reverse();
    return indices;
  };
  TreeNode2.prototype.getDescendantIndices = function() {
    var indices = [];
    this.eachNode(function(childNode) {
      indices.push(childNode.dataIndex);
    });
    return indices;
  };
  TreeNode2.prototype.getValue = function(dimension) {
    var data = this.hostTree.data;
    return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
  };
  TreeNode2.prototype.setLayout = function(layout2, merge2) {
    this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, layout2, merge2);
  };
  TreeNode2.prototype.getLayout = function() {
    return this.hostTree.data.getItemLayout(this.dataIndex);
  };
  TreeNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var hostTree = this.hostTree;
    var itemModel = hostTree.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  TreeNode2.prototype.getLevelModel = function() {
    return (this.hostTree.levelModels || [])[this.depth];
  };
  TreeNode2.prototype.setVisual = function(key, value) {
    this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, key, value);
  };
  TreeNode2.prototype.getVisual = function(key) {
    return this.hostTree.data.getItemVisual(this.dataIndex, key);
  };
  TreeNode2.prototype.getRawIndex = function() {
    return this.hostTree.data.getRawIndex(this.dataIndex);
  };
  TreeNode2.prototype.getId = function() {
    return this.hostTree.data.getId(this.dataIndex);
  };
  TreeNode2.prototype.getChildIndex = function() {
    if (this.parentNode) {
      var children = this.parentNode.children;
      for (var i = 0; i < children.length; ++i) {
        if (children[i] === this) {
          return i;
        }
      }
      return -1;
    }
    return -1;
  };
  TreeNode2.prototype.isAncestorOf = function(node) {
    var parent = node.parentNode;
    while (parent) {
      if (parent === this) {
        return true;
      }
      parent = parent.parentNode;
    }
    return false;
  };
  TreeNode2.prototype.isDescendantOf = function(node) {
    return node !== this && node.isAncestorOf(this);
  };
  return TreeNode2;
}();
var Tree = function() {
  function Tree2(hostModel) {
    this.type = "tree";
    this._nodes = [];
    this.hostModel = hostModel;
  }
  Tree2.prototype.eachNode = function(options, cb, context) {
    this.root.eachNode(options, cb, context);
  };
  Tree2.prototype.getNodeByDataIndex = function(dataIndex) {
    var rawIndex = this.data.getRawIndex(dataIndex);
    return this._nodes[rawIndex];
  };
  Tree2.prototype.getNodeById = function(name) {
    return this.root.getNodeById(name);
  };
  Tree2.prototype.update = function() {
    var data = this.data;
    var nodes = this._nodes;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
  };
  Tree2.prototype.clearLayouts = function() {
    this.data.clearItemLayouts();
  };
  Tree2.createTree = function(dataRoot, hostModel, beforeLink) {
    var tree = new Tree2(hostModel);
    var listData = [];
    var dimMax = 1;
    buildHierarchy(dataRoot);
    function buildHierarchy(dataNode, parentNode2) {
      var value = dataNode.value;
      dimMax = Math.max(dimMax, isArray$1(value) ? value.length : 1);
      listData.push(dataNode);
      var node = new TreeNode(convertOptionIdName(dataNode.name, ""), tree);
      parentNode2 ? addChild(node, parentNode2) : tree.root = node;
      tree._nodes.push(node);
      var children = dataNode.children;
      if (children) {
        for (var i = 0; i < children.length; i++) {
          buildHierarchy(children[i], node);
        }
      }
    }
    tree.root.updateDepthAndHeight(0);
    var dimensions = prepareSeriesDataSchema(listData, {
      coordDimensions: ["value"],
      dimensionsCount: dimMax
    }).dimensions;
    var list = new SeriesData$1(dimensions, hostModel);
    list.initData(listData);
    beforeLink && beforeLink(list);
    linkSeriesData({
      mainData: list,
      struct: tree,
      structAttr: "tree"
    });
    tree.update();
    return tree;
  };
  return Tree2;
}();
function addChild(child, node) {
  var children = node.children;
  if (child.parentNode === node) {
    return;
  }
  children.push(child);
  child.parentNode = node;
}
var Tree$1 = Tree;
function retrieveTargetInfo(payload, validPayloadTypes, seriesModel) {
  if (payload && indexOf(validPayloadTypes, payload.type) >= 0) {
    var root2 = seriesModel.getData().tree.root;
    var targetNode = payload.targetNode;
    if (isString(targetNode)) {
      targetNode = root2.getNodeById(targetNode);
    }
    if (targetNode && root2.contains(targetNode)) {
      return {
        node: targetNode
      };
    }
    var targetNodeId = payload.targetNodeId;
    if (targetNodeId != null && (targetNode = root2.getNodeById(targetNodeId))) {
      return {
        node: targetNode
      };
    }
  }
}
function getPathToRoot(node) {
  var path = [];
  while (node) {
    node = node.parentNode;
    node && path.push(node);
  }
  return path.reverse();
}
function aboveViewRoot(viewRoot, node) {
  var viewPath = getPathToRoot(viewRoot);
  return indexOf(viewPath, node) >= 0;
}
function wrapTreePathInfo(node, seriesModel) {
  var treePathInfo = [];
  while (node) {
    var nodeDataIndex = node.dataIndex;
    treePathInfo.push({
      name: node.name,
      dataIndex: nodeDataIndex,
      value: seriesModel.getRawValue(nodeDataIndex)
    });
    node = node.parentNode;
  }
  treePathInfo.reverse();
  return treePathInfo;
}
var TreeSeriesModel = function(_super) {
  __extends(TreeSeriesModel2, _super);
  function TreeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.hasSymbolVisual = true;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  TreeSeriesModel2.prototype.getInitialData = function(option) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    var leaves = option.leaves || {};
    var leavesModel = new Model$1(leaves, this, this.ecModel);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        if (!(node && node.children.length && node.isExpand)) {
          model.parentModel = leavesModel;
        }
        return model;
      });
    }
    var treeDepth = 0;
    tree.eachNode("preorder", function(node) {
      if (node.depth > treeDepth) {
        treeDepth = node.depth;
      }
    });
    var expandAndCollapse = option.expandAndCollapse;
    var expandTreeDepth = expandAndCollapse && option.initialTreeDepth >= 0 ? option.initialTreeDepth : treeDepth;
    tree.root.eachNode("preorder", function(node) {
      var item = node.hostTree.data.getRawDataItem(node.dataIndex);
      node.isExpand = item && item.collapsed != null ? !item.collapsed : node.depth <= expandTreeDepth;
    });
    return tree.data;
  };
  TreeSeriesModel2.prototype.getOrient = function() {
    var orient = this.get("orient");
    if (orient === "horizontal") {
      orient = "LR";
    } else if (orient === "vertical") {
      orient = "TB";
    }
    return orient;
  };
  TreeSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  TreeSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  TreeSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var tree = this.getData().tree;
    var realRoot = tree.root.children[0];
    var node = tree.getNodeByDataIndex(dataIndex);
    var value = node.getValue();
    var name = node.name;
    while (node && node !== realRoot) {
      name = node.parentNode.name + "." + name;
      node = node.parentNode;
    }
    return createTooltipMarkup("nameValue", {
      name,
      value,
      noValue: isNaN(value) || value == null
    });
  };
  TreeSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    return params;
  };
  TreeSeriesModel2.type = "series.tree";
  TreeSeriesModel2.layoutMode = "box";
  TreeSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "12%",
    top: "12%",
    right: "12%",
    bottom: "12%",
    layout: "orthogonal",
    edgeShape: "curve",
    edgeForkPosition: "50%",
    roam: false,
    nodeScaleRatio: 0.4,
    center: null,
    zoom: 1,
    orient: "LR",
    symbol: "emptyCircle",
    symbolSize: 7,
    expandAndCollapse: true,
    initialTreeDepth: 2,
    lineStyle: {
      color: "#ccc",
      width: 1.5,
      curveness: 0.5
    },
    itemStyle: {
      color: "lightsteelblue",
      borderWidth: 1.5
    },
    label: {
      show: true
    },
    animationEasing: "linear",
    animationDuration: 700,
    animationDurationUpdate: 500
  };
  return TreeSeriesModel2;
}(SeriesModel$1);
var TreeSeriesModel$1 = TreeSeriesModel;
function eachAfter(root2, callback, separation2) {
  var nodes = [root2];
  var next = [];
  var node;
  while (node = nodes.pop()) {
    next.push(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = 0; i < children.length; i++) {
          nodes.push(children[i]);
        }
      }
    }
  }
  while (node = next.pop()) {
    callback(node, separation2);
  }
}
function eachBefore(root2, callback) {
  var nodes = [root2];
  var node;
  while (node = nodes.pop()) {
    callback(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = children.length - 1; i >= 0; i--) {
          nodes.push(children[i]);
        }
      }
    }
  }
}
function treeLayout(ecModel, api) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    commonLayout(seriesModel, api);
  });
}
function commonLayout(seriesModel, api) {
  var layoutInfo = getViewRect$4(seriesModel, api);
  seriesModel.layoutInfo = layoutInfo;
  var layout2 = seriesModel.get("layout");
  var width = 0;
  var height = 0;
  var separation$1 = null;
  if (layout2 === "radial") {
    width = 2 * Math.PI;
    height = Math.min(layoutInfo.height, layoutInfo.width) / 2;
    separation$1 = separation(function(node1, node2) {
      return (node1.parentNode === node2.parentNode ? 1 : 2) / node1.depth;
    });
  } else {
    width = layoutInfo.width;
    height = layoutInfo.height;
    separation$1 = separation();
  }
  var virtualRoot = seriesModel.getData().tree.root;
  var realRoot = virtualRoot.children[0];
  if (realRoot) {
    init(virtualRoot);
    eachAfter(realRoot, firstWalk, separation$1);
    virtualRoot.hierNode.modifier = -realRoot.hierNode.prelim;
    eachBefore(realRoot, secondWalk);
    var left_1 = realRoot;
    var right_1 = realRoot;
    var bottom_1 = realRoot;
    eachBefore(realRoot, function(node) {
      var x2 = node.getLayout().x;
      if (x2 < left_1.getLayout().x) {
        left_1 = node;
      }
      if (x2 > right_1.getLayout().x) {
        right_1 = node;
      }
      if (node.depth > bottom_1.depth) {
        bottom_1 = node;
      }
    });
    var delta = left_1 === right_1 ? 1 : separation$1(left_1, right_1) / 2;
    var tx_1 = delta - left_1.getLayout().x;
    var kx_1 = 0;
    var ky_1 = 0;
    var coorX_1 = 0;
    var coorY_1 = 0;
    if (layout2 === "radial") {
      kx_1 = width / (right_1.getLayout().x + delta + tx_1);
      ky_1 = height / (bottom_1.depth - 1 || 1);
      eachBefore(realRoot, function(node) {
        coorX_1 = (node.getLayout().x + tx_1) * kx_1;
        coorY_1 = (node.depth - 1) * ky_1;
        var finalCoor = radialCoordinate(coorX_1, coorY_1);
        node.setLayout({
          x: finalCoor.x,
          y: finalCoor.y,
          rawX: coorX_1,
          rawY: coorY_1
        }, true);
      });
    } else {
      var orient_1 = seriesModel.getOrient();
      if (orient_1 === "RL" || orient_1 === "LR") {
        ky_1 = height / (right_1.getLayout().x + delta + tx_1);
        kx_1 = width / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorY_1 = (node.getLayout().x + tx_1) * ky_1;
          coorX_1 = orient_1 === "LR" ? (node.depth - 1) * kx_1 : width - (node.depth - 1) * kx_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      } else if (orient_1 === "TB" || orient_1 === "BT") {
        kx_1 = width / (right_1.getLayout().x + delta + tx_1);
        ky_1 = height / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorX_1 = (node.getLayout().x + tx_1) * kx_1;
          coorY_1 = orient_1 === "TB" ? (node.depth - 1) * ky_1 : height - (node.depth - 1) * ky_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      }
    }
  }
}
function treeVisual(ecModel) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style = model.getModel("itemStyle").getItemStyle();
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style);
    });
  });
}
function installTreeAction(registers) {
  registers.registerAction({
    type: "treeExpandAndCollapse",
    event: "treeExpandAndCollapse",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var dataIndex = payload.dataIndex;
      var tree = seriesModel.getData().tree;
      var node = tree.getNodeByDataIndex(dataIndex);
      node.isExpand = !node.isExpand;
    });
  });
  registers.registerAction({
    type: "treeRoam",
    event: "treeRoam",
    update: "none"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
function install$H(registers) {
  registers.registerChartView(TreeView$1);
  registers.registerSeriesModel(TreeSeriesModel$1);
  registers.registerLayout(treeLayout);
  registers.registerVisual(treeVisual);
  installTreeAction(registers);
}
var actionTypes = ["treemapZoomToNode", "treemapRender", "treemapMove"];
function installTreemapAction(registers) {
  for (var i = 0; i < actionTypes.length; i++) {
    registers.registerAction({
      type: actionTypes[i],
      update: "updateView"
    }, noop);
  }
  registers.registerAction({
    type: "treemapRootToNode",
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "treemap",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var types2 = ["treemapZoomToNode", "treemapRootToNode"];
      var targetInfo = retrieveTargetInfo(payload, types2, model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
}
function enableAriaDecalForTree(seriesModel) {
  var data = seriesModel.getData();
  var tree = data.tree;
  var decalPaletteScope2 = {};
  tree.eachNode(function(node) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var decal = getDecalFromPalette(seriesModel.ecModel, current.name || current.dataIndex + "", decalPaletteScope2);
    node.setVisual("decal", decal);
  });
}
var TreemapSeriesModel = function(_super) {
  __extends(TreemapSeriesModel2, _super);
  function TreemapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapSeriesModel2.type;
    _this.preventUsingHoverLayer = true;
    return _this;
  }
  TreemapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue$1(root2);
    var levels = option.levels || [];
    var designatedVisualItemStyle = this.designatedVisualItemStyle = {};
    var designatedVisualModel = new Model$1({
      itemStyle: designatedVisualItemStyle
    }, this, ecModel);
    levels = option.levels = setDefault(levels, ecModel);
    var levelModels = map$1(levels || [], function(levelDefine) {
      return new Model$1(levelDefine, designatedVisualModel, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = node ? levelModels[node.depth] : null;
        model.parentModel = levelModel || designatedVisualModel;
        return model;
      });
    }
    return tree.data;
  };
  TreemapSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  TreemapSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  TreemapSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    params.treePathInfo = params.treeAncestors;
    return params;
  };
  TreemapSeriesModel2.prototype.setLayoutInfo = function(layoutInfo) {
    this.layoutInfo = this.layoutInfo || {};
    extend(this.layoutInfo, layoutInfo);
  };
  TreemapSeriesModel2.prototype.mapIdToIndex = function(id2) {
    var idIndexMap = this._idIndexMap;
    if (!idIndexMap) {
      idIndexMap = this._idIndexMap = createHashMap();
      this._idIndexMapCount = 0;
    }
    var index2 = idIndexMap.get(id2);
    if (index2 == null) {
      idIndexMap.set(id2, index2 = this._idIndexMapCount++);
    }
    return index2;
  };
  TreemapSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  TreemapSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  TreemapSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  TreemapSeriesModel2.type = "series.treemap";
  TreemapSeriesModel2.layoutMode = "box";
  TreemapSeriesModel2.defaultOption = {
    progressive: 0,
    left: "center",
    top: "middle",
    width: "80%",
    height: "80%",
    sort: true,
    clipWindow: "origin",
    squareRatio: 0.5 * (1 + Math.sqrt(5)),
    leafDepth: null,
    drillDownIcon: "\u25B6",
    zoomToNodeRatio: 0.32 * 0.32,
    roam: true,
    nodeClick: "zoomToNode",
    animation: true,
    animationDurationUpdate: 900,
    animationEasing: "quinticInOut",
    breadcrumb: {
      show: true,
      height: 22,
      left: "center",
      top: "bottom",
      emptyItemWidth: 25,
      itemStyle: {
        color: "rgba(0,0,0,0.7)",
        textStyle: {
          color: "#fff"
        }
      }
    },
    label: {
      show: true,
      distance: 0,
      padding: 5,
      position: "inside",
      color: "#fff",
      overflow: "truncate"
    },
    upperLabel: {
      show: false,
      position: [0, "50%"],
      height: 20,
      overflow: "truncate",
      verticalAlign: "middle"
    },
    itemStyle: {
      color: null,
      colorAlpha: null,
      colorSaturation: null,
      borderWidth: 0,
      gapWidth: 0,
      borderColor: "#fff",
      borderColorSaturation: null
    },
    emphasis: {
      upperLabel: {
        show: true,
        position: [0, "50%"],
        overflow: "truncate",
        verticalAlign: "middle"
      }
    },
    visualDimension: 0,
    visualMin: null,
    visualMax: null,
    color: [],
    colorAlpha: null,
    colorSaturation: null,
    colorMappingBy: "index",
    visibleMin: 10,
    childrenVisibleMin: null,
    levels: []
  };
  return TreemapSeriesModel2;
}(SeriesModel$1);
function completeTreeValue$1(dataNode) {
  var sum2 = 0;
  each$f(dataNode.children, function(child) {
    completeTreeValue$1(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
function setDefault(levels, ecModel) {
  var globalColorList = normalizeToArray(ecModel.get("color"));
  var globalDecalList = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  if (!globalColorList) {
    return;
  }
  levels = levels || [];
  var hasColorDefine;
  var hasDecalDefine;
  each$f(levels, function(levelDefine) {
    var model = new Model$1(levelDefine);
    var modelColor = model.get("color");
    var modelDecal = model.get("decal");
    if (model.get(["itemStyle", "color"]) || modelColor && modelColor !== "none") {
      hasColorDefine = true;
    }
    if (model.get(["itemStyle", "decal"]) || modelDecal && modelDecal !== "none") {
      hasDecalDefine = true;
    }
  });
  var level0 = levels[0] || (levels[0] = {});
  if (!hasColorDefine) {
    level0.color = globalColorList.slice();
  }
  if (!hasDecalDefine && globalDecalList) {
    level0.decal = globalDecalList.slice();
  }
  return levels;
}
var TreemapSeriesModel$1 = TreemapSeriesModel;
var TEXT_PADDING = 8;
var ITEM_GAP = 8;
var ARRAY_LENGTH = 5;
var Breadcrumb = function() {
  function Breadcrumb2(containerGroup) {
    this.group = new Group$4();
    containerGroup.add(this.group);
  }
  Breadcrumb2.prototype.render = function(seriesModel, api, targetNode, onSelect) {
    var model = seriesModel.getModel("breadcrumb");
    var thisGroup = this.group;
    thisGroup.removeAll();
    if (!model.get("show") || !targetNode) {
      return;
    }
    var normalStyleModel = model.getModel("itemStyle");
    var textStyleModel = normalStyleModel.getModel("textStyle");
    var layoutParam = {
      pos: {
        left: model.get("left"),
        right: model.get("right"),
        top: model.get("top"),
        bottom: model.get("bottom")
      },
      box: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      emptyItemWidth: model.get("emptyItemWidth"),
      totalWidth: 0,
      renderList: []
    };
    this._prepare(targetNode, layoutParam, textStyleModel);
    this._renderContent(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect);
    positionElement(thisGroup, layoutParam.pos, layoutParam.box);
  };
  Breadcrumb2.prototype._prepare = function(targetNode, layoutParam, textStyleModel) {
    for (var node = targetNode; node; node = node.parentNode) {
      var text = convertOptionIdName(node.getModel().get("name"), "");
      var textRect = textStyleModel.getTextRect(text);
      var itemWidth = Math.max(textRect.width + TEXT_PADDING * 2, layoutParam.emptyItemWidth);
      layoutParam.totalWidth += itemWidth + ITEM_GAP;
      layoutParam.renderList.push({
        node,
        text,
        width: itemWidth
      });
    }
  };
  Breadcrumb2.prototype._renderContent = function(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect) {
    var lastX = 0;
    var emptyItemWidth = layoutParam.emptyItemWidth;
    var height = seriesModel.get(["breadcrumb", "height"]);
    var availableSize = getAvailableSize(layoutParam.pos, layoutParam.box);
    var totalWidth = layoutParam.totalWidth;
    var renderList = layoutParam.renderList;
    for (var i = renderList.length - 1; i >= 0; i--) {
      var item = renderList[i];
      var itemNode = item.node;
      var itemWidth = item.width;
      var text = item.text;
      if (totalWidth > availableSize.width) {
        totalWidth -= itemWidth - emptyItemWidth;
        itemWidth = emptyItemWidth;
        text = null;
      }
      var el = new Polygon$1({
        shape: {
          points: makeItemPoints(lastX, 0, itemWidth, height, i === renderList.length - 1, i === 0)
        },
        style: defaults(normalStyleModel.getItemStyle(), {
          lineJoin: "bevel"
        }),
        textContent: new ZRText$1({
          style: {
            text,
            fill: textStyleModel.getTextColor(),
            font: textStyleModel.getFont()
          }
        }),
        textConfig: {
          position: "inside"
        },
        z2: Z2_EMPHASIS_LIFT * 1e4,
        onclick: curry$1(onSelect, itemNode)
      });
      el.disableLabelAnimation = true;
      this.group.add(el);
      packEventData(el, seriesModel, itemNode);
      lastX += itemWidth + ITEM_GAP;
    }
  };
  Breadcrumb2.prototype.remove = function() {
    this.group.removeAll();
  };
  return Breadcrumb2;
}();
function makeItemPoints(x2, y2, itemWidth, itemHeight, head, tail) {
  var points2 = [[head ? x2 : x2 - ARRAY_LENGTH, y2], [x2 + itemWidth, y2], [x2 + itemWidth, y2 + itemHeight], [head ? x2 : x2 - ARRAY_LENGTH, y2 + itemHeight]];
  !tail && points2.splice(2, 0, [x2 + itemWidth + ARRAY_LENGTH, y2 + itemHeight / 2]);
  !head && points2.push([x2, y2 + itemHeight / 2]);
  return points2;
}
function packEventData(el, seriesModel, itemNode) {
  getECData(el).eventData = {
    componentType: "series",
    componentSubType: "treemap",
    componentIndex: seriesModel.componentIndex,
    seriesIndex: seriesModel.seriesIndex,
    seriesName: seriesModel.name,
    seriesType: "treemap",
    selfType: "breadcrumb",
    nodeData: {
      dataIndex: itemNode && itemNode.dataIndex,
      name: itemNode && itemNode.name
    },
    treePathInfo: itemNode && wrapTreePathInfo(itemNode, seriesModel)
  };
}
var Breadcrumb$1 = Breadcrumb;
var AnimationWrap = function() {
  function AnimationWrap2() {
    this._storage = [];
    this._elExistsMap = {};
  }
  AnimationWrap2.prototype.add = function(el, target, duration, delay, easing) {
    if (this._elExistsMap[el.id]) {
      return false;
    }
    this._elExistsMap[el.id] = true;
    this._storage.push({
      el,
      target,
      duration,
      delay,
      easing
    });
    return true;
  };
  AnimationWrap2.prototype.finished = function(callback) {
    this._finishedCallback = callback;
    return this;
  };
  AnimationWrap2.prototype.start = function() {
    var _this = this;
    var count2 = this._storage.length;
    var checkTerminate = function() {
      count2--;
      if (count2 <= 0) {
        _this._storage.length = 0;
        _this._elExistsMap = {};
        _this._finishedCallback && _this._finishedCallback();
      }
    };
    for (var i = 0, len2 = this._storage.length; i < len2; i++) {
      var item = this._storage[i];
      item.el.animateTo(item.target, {
        duration: item.duration,
        delay: item.delay,
        easing: item.easing,
        setToFinal: true,
        done: checkTerminate,
        aborted: checkTerminate
      });
    }
    return this;
  };
  return AnimationWrap2;
}();
function createWrap() {
  return new AnimationWrap();
}
var Group$2 = Group$4;
var Rect$1 = Rect$3;
var DRAG_THRESHOLD = 3;
var PATH_LABEL_NOAMAL = "label";
var PATH_UPPERLABEL_NORMAL = "upperLabel";
var Z2_BASE = Z2_EMPHASIS_LIFT * 10;
var Z2_BG = Z2_EMPHASIS_LIFT * 2;
var Z2_CONTENT = Z2_EMPHASIS_LIFT * 3;
var getStateItemStyle = makeStyleMapper([
  ["fill", "color"],
  ["stroke", "strokeColor"],
  ["lineWidth", "strokeWidth"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"]
]);
var getItemStyleNormal = function(model) {
  var itemStyle = getStateItemStyle(model);
  itemStyle.stroke = itemStyle.fill = itemStyle.lineWidth = null;
  return itemStyle;
};
var inner$d = makeInner();
var TreemapView = function(_super) {
  __extends(TreemapView2, _super);
  function TreemapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapView2.type;
    _this._state = "ready";
    _this._storage = createStorage();
    return _this;
  }
  TreemapView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var models = ecModel.findComponents({
      mainType: "series",
      subType: "treemap",
      query: payload
    });
    if (indexOf(models, seriesModel) < 0) {
      return;
    }
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var payloadType = payload && payload.type;
    var layoutInfo = seriesModel.layoutInfo;
    var isInit = !this._oldTree;
    var thisStorage = this._storage;
    var reRoot = payloadType === "treemapRootToNode" && targetInfo && thisStorage ? {
      rootNodeGroup: thisStorage.nodeGroup[targetInfo.node.getRawIndex()],
      direction: payload.direction
    } : null;
    var containerGroup = this._giveContainerGroup(layoutInfo);
    var hasAnimation = seriesModel.get("animation");
    var renderResult = this._doRender(containerGroup, seriesModel, reRoot);
    hasAnimation && !isInit && (!payloadType || payloadType === "treemapZoomToNode" || payloadType === "treemapRootToNode") ? this._doAnimation(containerGroup, renderResult, seriesModel, reRoot) : renderResult.renderFinally();
    this._resetController(api);
    this._renderBreadcrumb(seriesModel, api, targetInfo);
  };
  TreemapView2.prototype._giveContainerGroup = function(layoutInfo) {
    var containerGroup = this._containerGroup;
    if (!containerGroup) {
      containerGroup = this._containerGroup = new Group$2();
      this._initEvents(containerGroup);
      this.group.add(containerGroup);
    }
    containerGroup.x = layoutInfo.x;
    containerGroup.y = layoutInfo.y;
    return containerGroup;
  };
  TreemapView2.prototype._doRender = function(containerGroup, seriesModel, reRoot) {
    var thisTree = seriesModel.getData().tree;
    var oldTree = this._oldTree;
    var lastsForAnimation = createStorage();
    var thisStorage = createStorage();
    var oldStorage = this._storage;
    var willInvisibleEls = [];
    function doRenderNode(thisNode, oldNode, parentGroup, depth) {
      return renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth);
    }
    dualTravel(thisTree.root ? [thisTree.root] : [], oldTree && oldTree.root ? [oldTree.root] : [], containerGroup, thisTree === oldTree || !oldTree, 0);
    var willDeleteEls = clearStorage(oldStorage);
    this._oldTree = thisTree;
    this._storage = thisStorage;
    return {
      lastsForAnimation,
      willDeleteEls,
      renderFinally
    };
    function dualTravel(thisViewChildren, oldViewChildren, parentGroup, sameTree, depth) {
      if (sameTree) {
        oldViewChildren = thisViewChildren;
        each$f(thisViewChildren, function(child, index2) {
          !child.isRemoved() && processNode(index2, index2);
        });
      } else {
        new DataDiffer$1(oldViewChildren, thisViewChildren, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      }
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIndex, oldIndex) {
        var thisNode = newIndex != null ? thisViewChildren[newIndex] : null;
        var oldNode = oldIndex != null ? oldViewChildren[oldIndex] : null;
        var group = doRenderNode(thisNode, oldNode, parentGroup, depth);
        group && dualTravel(thisNode && thisNode.viewChildren || [], oldNode && oldNode.viewChildren || [], group, sameTree, depth + 1);
      }
    }
    function clearStorage(storage2) {
      var willDeleteEls2 = createStorage();
      storage2 && each$f(storage2, function(store, storageName) {
        var delEls = willDeleteEls2[storageName];
        each$f(store, function(el) {
          el && (delEls.push(el), inner$d(el).willDelete = true);
        });
      });
      return willDeleteEls2;
    }
    function renderFinally() {
      each$f(willDeleteEls, function(els) {
        each$f(els, function(el) {
          el.parent && el.parent.remove(el);
        });
      });
      each$f(willInvisibleEls, function(el) {
        el.invisible = true;
        el.dirty();
      });
    }
  };
  TreemapView2.prototype._doAnimation = function(containerGroup, renderResult, seriesModel, reRoot) {
    var durationOption = seriesModel.get("animationDurationUpdate");
    var easingOption = seriesModel.get("animationEasing");
    var duration = (isFunction(durationOption) ? 0 : durationOption) || 0;
    var easing = (isFunction(easingOption) ? null : easingOption) || "cubicOut";
    var animationWrap = createWrap();
    each$f(renderResult.willDeleteEls, function(store, storageName) {
      each$f(store, function(el, rawIndex) {
        if (el.invisible) {
          return;
        }
        var parent = el.parent;
        var target;
        var innerStore = inner$d(parent);
        if (reRoot && reRoot.direction === "drillDown") {
          target = parent === reRoot.rootNodeGroup ? {
            shape: {
              x: 0,
              y: 0,
              width: innerStore.nodeWidth,
              height: innerStore.nodeHeight
            },
            style: {
              opacity: 0
            }
          } : {
            style: {
              opacity: 0
            }
          };
        } else {
          var targetX = 0;
          var targetY = 0;
          if (!innerStore.willDelete) {
            targetX = innerStore.nodeWidth / 2;
            targetY = innerStore.nodeHeight / 2;
          }
          target = storageName === "nodeGroup" ? {
            x: targetX,
            y: targetY,
            style: {
              opacity: 0
            }
          } : {
            shape: {
              x: targetX,
              y: targetY,
              width: 0,
              height: 0
            },
            style: {
              opacity: 0
            }
          };
        }
        target && animationWrap.add(el, target, duration, 0, easing);
      });
    });
    each$f(this._storage, function(store, storageName) {
      each$f(store, function(el, rawIndex) {
        var last = renderResult.lastsForAnimation[storageName][rawIndex];
        var target = {};
        if (!last) {
          return;
        }
        if (el instanceof Group$4) {
          if (last.oldX != null) {
            target.x = el.x;
            target.y = el.y;
            el.x = last.oldX;
            el.y = last.oldY;
          }
        } else {
          if (last.oldShape) {
            target.shape = extend({}, el.shape);
            el.setShape(last.oldShape);
          }
          if (last.fadein) {
            el.setStyle("opacity", 0);
            target.style = {
              opacity: 1
            };
          } else if (el.style.opacity !== 1) {
            target.style = {
              opacity: 1
            };
          }
        }
        animationWrap.add(el, target, duration, 0, easing);
      });
    }, this);
    this._state = "animating";
    animationWrap.finished(bind$1(function() {
      this._state = "ready";
      renderResult.renderFinally();
    }, this)).start();
  };
  TreemapView2.prototype._resetController = function(api) {
    var controller = this._controller;
    if (!controller) {
      controller = this._controller = new RoamController$1(api.getZr());
      controller.enable(this.seriesModel.get("roam"));
      controller.on("pan", bind$1(this._onPan, this));
      controller.on("zoom", bind$1(this._onZoom, this));
    }
    var rect = new BoundingRect$1(0, 0, api.getWidth(), api.getHeight());
    controller.setPointerChecker(function(e2, x2, y2) {
      return rect.contain(x2, y2);
    });
  };
  TreemapView2.prototype._clearController = function() {
    var controller = this._controller;
    if (controller) {
      controller.dispose();
      controller = null;
    }
  };
  TreemapView2.prototype._onPan = function(e2) {
    if (this._state !== "animating" && (Math.abs(e2.dx) > DRAG_THRESHOLD || Math.abs(e2.dy) > DRAG_THRESHOLD)) {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      this.api.dispatchAction({
        type: "treemapMove",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rootLayout.x + e2.dx,
          y: rootLayout.y + e2.dy,
          width: rootLayout.width,
          height: rootLayout.height
        }
      });
    }
  };
  TreemapView2.prototype._onZoom = function(e2) {
    var mouseX = e2.originX;
    var mouseY = e2.originY;
    if (this._state !== "animating") {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      var rect = new BoundingRect$1(rootLayout.x, rootLayout.y, rootLayout.width, rootLayout.height);
      var layoutInfo = this.seriesModel.layoutInfo;
      mouseX -= layoutInfo.x;
      mouseY -= layoutInfo.y;
      var m2 = create$1();
      translate(m2, m2, [-mouseX, -mouseY]);
      scale$1(m2, m2, [e2.scale, e2.scale]);
      translate(m2, m2, [mouseX, mouseY]);
      rect.applyTransform(m2);
      this.api.dispatchAction({
        type: "treemapRender",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rect.x,
          y: rect.y,
          width: rect.width,
          height: rect.height
        }
      });
    }
  };
  TreemapView2.prototype._initEvents = function(containerGroup) {
    var _this = this;
    containerGroup.on("click", function(e2) {
      if (_this._state !== "ready") {
        return;
      }
      var nodeClick = _this.seriesModel.get("nodeClick", true);
      if (!nodeClick) {
        return;
      }
      var targetInfo = _this.findTarget(e2.offsetX, e2.offsetY);
      if (!targetInfo) {
        return;
      }
      var node = targetInfo.node;
      if (node.getLayout().isLeafRoot) {
        _this._rootToNode(targetInfo);
      } else {
        if (nodeClick === "zoomToNode") {
          _this._zoomToNode(targetInfo);
        } else if (nodeClick === "link") {
          var itemModel = node.hostTree.data.getItemModel(node.dataIndex);
          var link = itemModel.get("link", true);
          var linkTarget = itemModel.get("target", true) || "blank";
          link && windowOpen(link, linkTarget);
        }
      }
    }, this);
  };
  TreemapView2.prototype._renderBreadcrumb = function(seriesModel, api, targetInfo) {
    var _this = this;
    if (!targetInfo) {
      targetInfo = seriesModel.get("leafDepth", true) != null ? {
        node: seriesModel.getViewRoot()
      } : this.findTarget(api.getWidth() / 2, api.getHeight() / 2);
      if (!targetInfo) {
        targetInfo = {
          node: seriesModel.getData().tree.root
        };
      }
    }
    (this._breadcrumb || (this._breadcrumb = new Breadcrumb$1(this.group))).render(seriesModel, api, targetInfo.node, function(node) {
      if (_this._state !== "animating") {
        aboveViewRoot(seriesModel.getViewRoot(), node) ? _this._rootToNode({
          node
        }) : _this._zoomToNode({
          node
        });
      }
    });
  };
  TreemapView2.prototype.remove = function() {
    this._clearController();
    this._containerGroup && this._containerGroup.removeAll();
    this._storage = createStorage();
    this._state = "ready";
    this._breadcrumb && this._breadcrumb.remove();
  };
  TreemapView2.prototype.dispose = function() {
    this._clearController();
  };
  TreemapView2.prototype._zoomToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapZoomToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype._rootToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapRootToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype.findTarget = function(x2, y2) {
    var targetInfo;
    var viewRoot = this.seriesModel.getViewRoot();
    viewRoot.eachNode({
      attr: "viewChildren",
      order: "preorder"
    }, function(node) {
      var bgEl = this._storage.background[node.getRawIndex()];
      if (bgEl) {
        var point = bgEl.transformCoordToLocal(x2, y2);
        var shape = bgEl.shape;
        if (shape.x <= point[0] && point[0] <= shape.x + shape.width && shape.y <= point[1] && point[1] <= shape.y + shape.height) {
          targetInfo = {
            node,
            offsetX: point[0],
            offsetY: point[1]
          };
        } else {
          return false;
        }
      }
    }, this);
    return targetInfo;
  };
  TreemapView2.type = "treemap";
  return TreemapView2;
}(ChartView$1);
function createStorage() {
  return {
    nodeGroup: [],
    background: [],
    content: []
  };
}
function renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth) {
  if (!thisNode) {
    return;
  }
  var thisLayout = thisNode.getLayout();
  var data = seriesModel.getData();
  var nodeModel = thisNode.getModel();
  data.setItemGraphicEl(thisNode.dataIndex, null);
  if (!thisLayout || !thisLayout.isInView) {
    return;
  }
  var thisWidth = thisLayout.width;
  var thisHeight = thisLayout.height;
  var borderWidth = thisLayout.borderWidth;
  var thisInvisible = thisLayout.invisible;
  var thisRawIndex = thisNode.getRawIndex();
  var oldRawIndex = oldNode && oldNode.getRawIndex();
  var thisViewChildren = thisNode.viewChildren;
  var upperHeight = thisLayout.upperHeight;
  var isParent = thisViewChildren && thisViewChildren.length;
  var itemStyleNormalModel = nodeModel.getModel("itemStyle");
  var itemStyleEmphasisModel = nodeModel.getModel(["emphasis", "itemStyle"]);
  var itemStyleBlurModel = nodeModel.getModel(["blur", "itemStyle"]);
  var itemStyleSelectModel = nodeModel.getModel(["select", "itemStyle"]);
  var borderRadius = itemStyleNormalModel.get("borderRadius") || 0;
  var group = giveGraphic("nodeGroup", Group$2);
  if (!group) {
    return;
  }
  parentGroup.add(group);
  group.x = thisLayout.x || 0;
  group.y = thisLayout.y || 0;
  group.markRedraw();
  inner$d(group).nodeWidth = thisWidth;
  inner$d(group).nodeHeight = thisHeight;
  if (thisLayout.isAboveViewRoot) {
    return group;
  }
  var bg = giveGraphic("background", Rect$1, depth, Z2_BG);
  bg && renderBackground(group, bg, isParent && thisLayout.upperLabelHeight);
  var emphasisModel = nodeModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var isDisabled = emphasisModel.get("disabled");
  var focusOrIndices = focus === "ancestor" ? thisNode.getAncestorsIndices() : focus === "descendant" ? thisNode.getDescendantIndices() : focus;
  if (isParent) {
    if (isHighDownDispatcher(group)) {
      setAsHighDownDispatcher(group, false);
    }
    if (bg) {
      setAsHighDownDispatcher(bg, !isDisabled);
      data.setItemGraphicEl(thisNode.dataIndex, bg);
      enableHoverFocus(bg, focusOrIndices, blurScope);
    }
  } else {
    var content = giveGraphic("content", Rect$1, depth, Z2_CONTENT);
    content && renderContent(group, content);
    bg.disableMorphing = true;
    if (bg && isHighDownDispatcher(bg)) {
      setAsHighDownDispatcher(bg, false);
    }
    setAsHighDownDispatcher(group, !isDisabled);
    data.setItemGraphicEl(thisNode.dataIndex, group);
    enableHoverFocus(group, focusOrIndices, blurScope);
  }
  return group;
  function renderBackground(group2, bg2, useUpperLabel) {
    var ecData = getECData(bg2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    bg2.setShape({
      x: 0,
      y: 0,
      width: thisWidth,
      height: thisHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(bg2);
    } else {
      bg2.invisible = false;
      var style = thisNode.getVisual("style");
      var visualBorderColor = style.stroke;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualBorderColor;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      emphasisStyle.fill = itemStyleEmphasisModel.get("borderColor");
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      blurStyle.fill = itemStyleBlurModel.get("borderColor");
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      selectStyle.fill = itemStyleSelectModel.get("borderColor");
      if (useUpperLabel) {
        var upperLabelWidth = thisWidth - 2 * borderWidth;
        prepareText(bg2, visualBorderColor, style.opacity, {
          x: borderWidth,
          y: 0,
          width: upperLabelWidth,
          height: upperHeight
        });
      } else {
        bg2.removeTextContent();
      }
      bg2.setStyle(normalStyle);
      bg2.ensureState("emphasis").style = emphasisStyle;
      bg2.ensureState("blur").style = blurStyle;
      bg2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(bg2);
    }
    group2.add(bg2);
  }
  function renderContent(group2, content2) {
    var ecData = getECData(content2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    var contentWidth = Math.max(thisWidth - 2 * borderWidth, 0);
    var contentHeight = Math.max(thisHeight - 2 * borderWidth, 0);
    content2.culling = true;
    content2.setShape({
      x: borderWidth,
      y: borderWidth,
      width: contentWidth,
      height: contentHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(content2);
    } else {
      content2.invisible = false;
      var nodeStyle = thisNode.getVisual("style");
      var visualColor = nodeStyle.fill;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualColor;
      normalStyle.decal = nodeStyle.decal;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      prepareText(content2, visualColor, nodeStyle.opacity, null);
      content2.setStyle(normalStyle);
      content2.ensureState("emphasis").style = emphasisStyle;
      content2.ensureState("blur").style = blurStyle;
      content2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(content2);
    }
    group2.add(content2);
  }
  function processInvisible(element) {
    !element.invisible && willInvisibleEls.push(element);
  }
  function prepareText(rectEl, visualColor, visualOpacity, upperLabelRect) {
    var normalLabelModel = nodeModel.getModel(upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL);
    var defaultText = convertOptionIdName(nodeModel.get("name"), null);
    var isShow = normalLabelModel.getShallow("show");
    setLabelStyle(rectEl, getLabelStatesModels(nodeModel, upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL), {
      defaultText: isShow ? defaultText : null,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      labelFetcher: seriesModel,
      labelDataIndex: thisNode.dataIndex
    });
    var textEl = rectEl.getTextContent();
    if (!textEl) {
      return;
    }
    var textStyle = textEl.style;
    var textPadding = normalizeCssArray$1(textStyle.padding || 0);
    if (upperLabelRect) {
      rectEl.setTextConfig({
        layoutRect: upperLabelRect
      });
      textEl.disableLabelLayout = true;
    }
    textEl.beforeUpdate = function() {
      var width = Math.max((upperLabelRect ? upperLabelRect.width : rectEl.shape.width) - textPadding[1] - textPadding[3], 0);
      var height = Math.max((upperLabelRect ? upperLabelRect.height : rectEl.shape.height) - textPadding[0] - textPadding[2], 0);
      if (textStyle.width !== width || textStyle.height !== height) {
        textEl.setStyle({
          width,
          height
        });
      }
    };
    textStyle.truncateMinChar = 2;
    textStyle.lineOverflow = "truncate";
    addDrillDownIcon(textStyle, upperLabelRect, thisLayout);
    var textEmphasisState = textEl.getState("emphasis");
    addDrillDownIcon(textEmphasisState ? textEmphasisState.style : null, upperLabelRect, thisLayout);
  }
  function addDrillDownIcon(style, upperLabelRect, thisLayout2) {
    var text = style ? style.text : null;
    if (!upperLabelRect && thisLayout2.isLeafRoot && text != null) {
      var iconChar = seriesModel.get("drillDownIcon", true);
      style.text = iconChar ? iconChar + " " + text : text;
    }
  }
  function giveGraphic(storageName, Ctor, depth2, z2) {
    var element = oldRawIndex != null && oldStorage[storageName][oldRawIndex];
    var lasts = lastsForAnimation[storageName];
    if (element) {
      oldStorage[storageName][oldRawIndex] = null;
      prepareAnimationWhenHasOld(lasts, element);
    } else if (!thisInvisible) {
      element = new Ctor();
      if (element instanceof Displayable$1) {
        element.z2 = calculateZ2(depth2, z2);
      }
      prepareAnimationWhenNoOld(lasts, element);
    }
    return thisStorage[storageName][thisRawIndex] = element;
  }
  function prepareAnimationWhenHasOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    if (element instanceof Group$2) {
      lastCfg.oldX = element.x;
      lastCfg.oldY = element.y;
    } else {
      lastCfg.oldShape = extend({}, element.shape);
    }
  }
  function prepareAnimationWhenNoOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    var parentNode2 = thisNode.parentNode;
    var isGroup = element instanceof Group$4;
    if (parentNode2 && (!reRoot || reRoot.direction === "drillDown")) {
      var parentOldX = 0;
      var parentOldY = 0;
      var parentOldBg = lastsForAnimation.background[parentNode2.getRawIndex()];
      if (!reRoot && parentOldBg && parentOldBg.oldShape) {
        parentOldX = parentOldBg.oldShape.width;
        parentOldY = parentOldBg.oldShape.height;
      }
      if (isGroup) {
        lastCfg.oldX = 0;
        lastCfg.oldY = parentOldY;
      } else {
        lastCfg.oldShape = {
          x: parentOldX,
          y: parentOldY,
          width: 0,
          height: 0
        };
      }
    }
    lastCfg.fadein = !isGroup;
  }
}
function calculateZ2(depth, z2InLevel) {
  return depth * Z2_BASE + z2InLevel;
}
var TreemapView$1 = TreemapView;
var each$c = each$f;
var isObject$1 = isObject$4;
var CATEGORY_DEFAULT_VISUAL_INDEX = -1;
var VisualMapping = function() {
  function VisualMapping2(option) {
    var mappingMethod = option.mappingMethod;
    var visualType = option.type;
    var thisOption = this.option = clone$4(option);
    this.type = visualType;
    this.mappingMethod = mappingMethod;
    this._normalizeData = normalizers[mappingMethod];
    var visualHandler = VisualMapping2.visualHandlers[visualType];
    this.applyVisual = visualHandler.applyVisual;
    this.getColorMapper = visualHandler.getColorMapper;
    this._normalizedToVisual = visualHandler._normalizedToVisual[mappingMethod];
    if (mappingMethod === "piecewise") {
      normalizeVisualRange(thisOption);
      preprocessForPiecewise(thisOption);
    } else if (mappingMethod === "category") {
      thisOption.categories ? preprocessForSpecifiedCategory(thisOption) : normalizeVisualRange(thisOption, true);
    } else {
      assert(mappingMethod !== "linear" || thisOption.dataExtent);
      normalizeVisualRange(thisOption);
    }
  }
  VisualMapping2.prototype.mapValueToVisual = function(value) {
    var normalized = this._normalizeData(value);
    return this._normalizedToVisual(normalized, value);
  };
  VisualMapping2.prototype.getNormalizer = function() {
    return bind$1(this._normalizeData, this);
  };
  VisualMapping2.listVisualTypes = function() {
    return keys(VisualMapping2.visualHandlers);
  };
  VisualMapping2.isValidType = function(visualType) {
    return VisualMapping2.visualHandlers.hasOwnProperty(visualType);
  };
  VisualMapping2.eachVisual = function(visual, callback, context) {
    if (isObject$4(visual)) {
      each$f(visual, callback, context);
    } else {
      callback.call(context, visual);
    }
  };
  VisualMapping2.mapVisual = function(visual, callback, context) {
    var isPrimary;
    var newVisual = isArray$1(visual) ? [] : isObject$4(visual) ? {} : (isPrimary = true, null);
    VisualMapping2.eachVisual(visual, function(v4, key) {
      var newVal = callback.call(context, v4, key);
      isPrimary ? newVisual = newVal : newVisual[key] = newVal;
    });
    return newVisual;
  };
  VisualMapping2.retrieveVisuals = function(obj) {
    var ret = {};
    var hasVisual;
    obj && each$c(VisualMapping2.visualHandlers, function(h, visualType) {
      if (obj.hasOwnProperty(visualType)) {
        ret[visualType] = obj[visualType];
        hasVisual = true;
      }
    });
    return hasVisual ? ret : null;
  };
  VisualMapping2.prepareVisualTypes = function(visualTypes) {
    if (isArray$1(visualTypes)) {
      visualTypes = visualTypes.slice();
    } else if (isObject$1(visualTypes)) {
      var types_1 = [];
      each$c(visualTypes, function(item, type4) {
        types_1.push(type4);
      });
      visualTypes = types_1;
    } else {
      return [];
    }
    visualTypes.sort(function(type1, type22) {
      return type22 === "color" && type1 !== "color" && type1.indexOf("color") === 0 ? 1 : -1;
    });
    return visualTypes;
  };
  VisualMapping2.dependsOn = function(visualType1, visualType2) {
    return visualType2 === "color" ? !!(visualType1 && visualType1.indexOf(visualType2) === 0) : visualType1 === visualType2;
  };
  VisualMapping2.findPieceIndex = function(value, pieceList, findClosestWhenOutside) {
    var possibleI;
    var abs2 = Infinity;
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var pieceValue = pieceList[i].value;
      if (pieceValue != null) {
        if (pieceValue === value || isString(pieceValue) && pieceValue === value + "") {
          return i;
        }
        findClosestWhenOutside && updatePossible(pieceValue, i);
      }
    }
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var piece = pieceList[i];
      var interval = piece.interval;
      var close_1 = piece.close;
      if (interval) {
        if (interval[0] === -Infinity) {
          if (littleThan(close_1[1], value, interval[1])) {
            return i;
          }
        } else if (interval[1] === Infinity) {
          if (littleThan(close_1[0], interval[0], value)) {
            return i;
          }
        } else if (littleThan(close_1[0], interval[0], value) && littleThan(close_1[1], value, interval[1])) {
          return i;
        }
        findClosestWhenOutside && updatePossible(interval[0], i);
        findClosestWhenOutside && updatePossible(interval[1], i);
      }
    }
    if (findClosestWhenOutside) {
      return value === Infinity ? pieceList.length - 1 : value === -Infinity ? 0 : possibleI;
    }
    function updatePossible(val, index2) {
      var newAbs = Math.abs(val - value);
      if (newAbs < abs2) {
        abs2 = newAbs;
        possibleI = index2;
      }
    }
  };
  VisualMapping2.visualHandlers = {
    color: {
      applyVisual: makeApplyVisual("color"),
      getColorMapper: function() {
        var thisOption = this.option;
        return bind$1(thisOption.mappingMethod === "category" ? function(value, isNormalized) {
          !isNormalized && (value = this._normalizeData(value));
          return doMapCategory.call(this, value);
        } : function(value, isNormalized, out2) {
          var returnRGBArray = !!out2;
          !isNormalized && (value = this._normalizeData(value));
          out2 = fastLerp(value, thisOption.parsedVisual, out2);
          return returnRGBArray ? out2 : stringify(out2, "rgba");
        }, this);
      },
      _normalizedToVisual: {
        linear: function(normalized) {
          return stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
        },
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    colorHue: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, value);
    }),
    colorSaturation: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, value);
    }),
    colorLightness: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, null, value);
    }),
    colorAlpha: makePartialColorVisualHandler(function(color, value) {
      return modifyAlpha(color, value);
    }),
    decal: {
      applyVisual: makeApplyVisual("decal"),
      _normalizedToVisual: {
        linear: null,
        category: doMapCategory,
        piecewise: null,
        fixed: null
      }
    },
    opacity: {
      applyVisual: makeApplyVisual("opacity"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    },
    liftZ: {
      applyVisual: makeApplyVisual("liftZ"),
      _normalizedToVisual: {
        linear: doMapFixed,
        category: doMapFixed,
        piecewise: doMapFixed,
        fixed: doMapFixed
      }
    },
    symbol: {
      applyVisual: function(value, getter, setter) {
        var symbolCfg = this.mapValueToVisual(value);
        setter("symbol", symbolCfg);
      },
      _normalizedToVisual: {
        linear: doMapToArray,
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = doMapToArray.call(this, normalized);
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    symbolSize: {
      applyVisual: makeApplyVisual("symbolSize"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    }
  };
  return VisualMapping2;
}();
function preprocessForPiecewise(thisOption) {
  var pieceList = thisOption.pieceList;
  thisOption.hasSpecialVisual = false;
  each$f(pieceList, function(piece, index2) {
    piece.originIndex = index2;
    if (piece.visual != null) {
      thisOption.hasSpecialVisual = true;
    }
  });
}
function preprocessForSpecifiedCategory(thisOption) {
  var categories = thisOption.categories;
  var categoryMap = thisOption.categoryMap = {};
  var visual = thisOption.visual;
  each$c(categories, function(cate, index2) {
    categoryMap[cate] = index2;
  });
  if (!isArray$1(visual)) {
    var visualArr_1 = [];
    if (isObject$4(visual)) {
      each$c(visual, function(v4, cate) {
        var index2 = categoryMap[cate];
        visualArr_1[index2 != null ? index2 : CATEGORY_DEFAULT_VISUAL_INDEX] = v4;
      });
    } else {
      visualArr_1[CATEGORY_DEFAULT_VISUAL_INDEX] = visual;
    }
    visual = setVisualToOption(thisOption, visualArr_1);
  }
  for (var i = categories.length - 1; i >= 0; i--) {
    if (visual[i] == null) {
      delete categoryMap[categories[i]];
      categories.pop();
    }
  }
}
function normalizeVisualRange(thisOption, isCategory2) {
  var visual = thisOption.visual;
  var visualArr = [];
  if (isObject$4(visual)) {
    each$c(visual, function(v4) {
      visualArr.push(v4);
    });
  } else if (visual != null) {
    visualArr.push(visual);
  }
  var doNotNeedPair = {
    color: 1,
    symbol: 1
  };
  if (!isCategory2 && visualArr.length === 1 && !doNotNeedPair.hasOwnProperty(thisOption.type)) {
    visualArr[1] = visualArr[0];
  }
  setVisualToOption(thisOption, visualArr);
}
function makePartialColorVisualHandler(applyValue) {
  return {
    applyVisual: function(value, getter, setter) {
      var colorChannel = this.mapValueToVisual(value);
      setter("color", applyValue(getter("color"), colorChannel));
    },
    _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
  };
}
function doMapToArray(normalized) {
  var visual = this.option.visual;
  return visual[Math.round(linearMap$2(normalized, [0, 1], [0, visual.length - 1], true))] || {};
}
function makeApplyVisual(visualType) {
  return function(value, getter, setter) {
    setter(visualType, this.mapValueToVisual(value));
  };
}
function doMapCategory(normalized) {
  var visual = this.option.visual;
  return visual[this.option.loop && normalized !== CATEGORY_DEFAULT_VISUAL_INDEX ? normalized % visual.length : normalized];
}
function doMapFixed() {
  return this.option.visual[0];
}
function createNormalizedToNumericVisual(sourceExtent) {
  return {
    linear: function(normalized) {
      return linearMap$2(normalized, sourceExtent, this.option.visual, true);
    },
    category: doMapCategory,
    piecewise: function(normalized, value) {
      var result = getSpecifiedVisual.call(this, value);
      if (result == null) {
        result = linearMap$2(normalized, sourceExtent, this.option.visual, true);
      }
      return result;
    },
    fixed: doMapFixed
  };
}
function getSpecifiedVisual(value) {
  var thisOption = this.option;
  var pieceList = thisOption.pieceList;
  if (thisOption.hasSpecialVisual) {
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList);
    var piece = pieceList[pieceIndex];
    if (piece && piece.visual) {
      return piece.visual[this.type];
    }
  }
}
function setVisualToOption(thisOption, visualArr) {
  thisOption.visual = visualArr;
  if (thisOption.type === "color") {
    thisOption.parsedVisual = map$1(visualArr, function(item) {
      return parse(item);
    });
  }
  return visualArr;
}
var normalizers = {
  linear: function(value) {
    return linearMap$2(value, this.option.dataExtent, [0, 1], true);
  },
  piecewise: function(value) {
    var pieceList = this.option.pieceList;
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList, true);
    if (pieceIndex != null) {
      return linearMap$2(pieceIndex, [0, pieceList.length - 1], [0, 1], true);
    }
  },
  category: function(value) {
    var index2 = this.option.categories ? this.option.categoryMap[value] : value;
    return index2 == null ? CATEGORY_DEFAULT_VISUAL_INDEX : index2;
  },
  fixed: noop
};
function littleThan(close, a, b2) {
  return close ? a <= b2 : a < b2;
}
var VisualMapping$1 = VisualMapping;
var ITEM_STYLE_NORMAL = "itemStyle";
var inner$c = makeInner();
var treemapVisual = {
  seriesType: "treemap",
  reset: function(seriesModel) {
    var tree = seriesModel.getData().tree;
    var root2 = tree.root;
    if (root2.isRemoved()) {
      return;
    }
    travelTree(root2, {}, seriesModel.getViewRoot().getAncestors(), seriesModel);
  }
};
function travelTree(node, designatedVisual, viewRootAncestors, seriesModel) {
  var nodeModel = node.getModel();
  var nodeLayout = node.getLayout();
  var data = node.hostTree.data;
  if (!nodeLayout || nodeLayout.invisible || !nodeLayout.isInView) {
    return;
  }
  var nodeItemStyleModel = nodeModel.getModel(ITEM_STYLE_NORMAL);
  var visuals = buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel);
  var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
  var borderColor = nodeItemStyleModel.get("borderColor");
  var borderColorSaturation = nodeItemStyleModel.get("borderColorSaturation");
  var thisNodeColor;
  if (borderColorSaturation != null) {
    thisNodeColor = calculateColor(visuals);
    borderColor = calculateBorderColor(borderColorSaturation, thisNodeColor);
  }
  existsStyle.stroke = borderColor;
  var viewChildren = node.viewChildren;
  if (!viewChildren || !viewChildren.length) {
    thisNodeColor = calculateColor(visuals);
    existsStyle.fill = thisNodeColor;
  } else {
    var mapping_1 = buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren);
    each$f(viewChildren, function(child, index2) {
      if (child.depth >= viewRootAncestors.length || child === viewRootAncestors[child.depth]) {
        var childVisual = mapVisual$1(nodeModel, visuals, child, index2, mapping_1, seriesModel);
        travelTree(child, childVisual, viewRootAncestors, seriesModel);
      }
    });
  }
}
function buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel) {
  var visuals = extend({}, designatedVisual);
  var designatedVisualItemStyle = seriesModel.designatedVisualItemStyle;
  each$f(["color", "colorAlpha", "colorSaturation"], function(visualName) {
    designatedVisualItemStyle[visualName] = designatedVisual[visualName];
    var val = nodeItemStyleModel.get(visualName);
    designatedVisualItemStyle[visualName] = null;
    val != null && (visuals[visualName] = val);
  });
  return visuals;
}
function calculateColor(visuals) {
  var color = getValueVisualDefine(visuals, "color");
  if (color) {
    var colorAlpha = getValueVisualDefine(visuals, "colorAlpha");
    var colorSaturation = getValueVisualDefine(visuals, "colorSaturation");
    if (colorSaturation) {
      color = modifyHSL(color, null, null, colorSaturation);
    }
    if (colorAlpha) {
      color = modifyAlpha(color, colorAlpha);
    }
    return color;
  }
}
function calculateBorderColor(borderColorSaturation, thisNodeColor) {
  return thisNodeColor != null ? modifyHSL(thisNodeColor, null, null, borderColorSaturation) : null;
}
function getValueVisualDefine(visuals, name) {
  var value = visuals[name];
  if (value != null && value !== "none") {
    return value;
  }
}
function buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren) {
  if (!viewChildren || !viewChildren.length) {
    return;
  }
  var rangeVisual = getRangeVisual(nodeModel, "color") || visuals.color != null && visuals.color !== "none" && (getRangeVisual(nodeModel, "colorAlpha") || getRangeVisual(nodeModel, "colorSaturation"));
  if (!rangeVisual) {
    return;
  }
  var visualMin = nodeModel.get("visualMin");
  var visualMax = nodeModel.get("visualMax");
  var dataExtent = nodeLayout.dataExtent.slice();
  visualMin != null && visualMin < dataExtent[0] && (dataExtent[0] = visualMin);
  visualMax != null && visualMax > dataExtent[1] && (dataExtent[1] = visualMax);
  var colorMappingBy = nodeModel.get("colorMappingBy");
  var opt = {
    type: rangeVisual.name,
    dataExtent,
    visual: rangeVisual.range
  };
  if (opt.type === "color" && (colorMappingBy === "index" || colorMappingBy === "id")) {
    opt.mappingMethod = "category";
    opt.loop = true;
  } else {
    opt.mappingMethod = "linear";
  }
  var mapping = new VisualMapping$1(opt);
  inner$c(mapping).drColorMappingBy = colorMappingBy;
  return mapping;
}
function getRangeVisual(nodeModel, name) {
  var range3 = nodeModel.get(name);
  return isArray$1(range3) && range3.length ? {
    name,
    range: range3
  } : null;
}
function mapVisual$1(nodeModel, visuals, child, index2, mapping, seriesModel) {
  var childVisuals = extend({}, visuals);
  if (mapping) {
    var mappingType = mapping.type;
    var colorMappingBy = mappingType === "color" && inner$c(mapping).drColorMappingBy;
    var value = colorMappingBy === "index" ? index2 : colorMappingBy === "id" ? seriesModel.mapIdToIndex(child.getId()) : child.getValue(nodeModel.get("visualDimension"));
    childVisuals[mappingType] = mapping.mapValueToVisual(value);
  }
  return childVisuals;
}
var mathMax$3 = Math.max;
var mathMin$3 = Math.min;
var retrieveValue = retrieve;
var each$b = each$f;
var PATH_BORDER_WIDTH = ["itemStyle", "borderWidth"];
var PATH_GAP_WIDTH = ["itemStyle", "gapWidth"];
var PATH_UPPER_LABEL_SHOW = ["upperLabel", "show"];
var PATH_UPPER_LABEL_HEIGHT = ["upperLabel", "height"];
var treemapLayout = {
  seriesType: "treemap",
  reset: function(seriesModel, ecModel, api, payload) {
    var ecWidth = api.getWidth();
    var ecHeight = api.getHeight();
    var seriesOption = seriesModel.option;
    var layoutInfo = getLayoutRect(seriesModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    var size = seriesOption.size || [];
    var containerWidth = parsePercent(retrieveValue(layoutInfo.width, size[0]), ecWidth);
    var containerHeight = parsePercent(retrieveValue(layoutInfo.height, size[1]), ecHeight);
    var payloadType = payload && payload.type;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var rootRect = payloadType === "treemapRender" || payloadType === "treemapMove" ? payload.rootRect : null;
    var viewRoot = seriesModel.getViewRoot();
    var viewAbovePath = getPathToRoot(viewRoot);
    if (payloadType !== "treemapMove") {
      var rootSize = payloadType === "treemapZoomToNode" ? estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) : rootRect ? [rootRect.width, rootRect.height] : [containerWidth, containerHeight];
      var sort_1 = seriesOption.sort;
      if (sort_1 && sort_1 !== "asc" && sort_1 !== "desc") {
        sort_1 = "desc";
      }
      var options = {
        squareRatio: seriesOption.squareRatio,
        sort: sort_1,
        leafDepth: seriesOption.leafDepth
      };
      viewRoot.hostTree.clearLayouts();
      var viewRootLayout_1 = {
        x: 0,
        y: 0,
        width: rootSize[0],
        height: rootSize[1],
        area: rootSize[0] * rootSize[1]
      };
      viewRoot.setLayout(viewRootLayout_1);
      squarify(viewRoot, options, false, 0);
      viewRootLayout_1 = viewRoot.getLayout();
      each$b(viewAbovePath, function(node, index2) {
        var childValue = (viewAbovePath[index2 + 1] || viewRoot).getValue();
        node.setLayout(extend({
          dataExtent: [childValue, childValue],
          borderWidth: 0,
          upperHeight: 0
        }, viewRootLayout_1));
      });
    }
    var treeRoot = seriesModel.getData().tree.root;
    treeRoot.setLayout(calculateRootPosition(layoutInfo, rootRect, targetInfo), true);
    seriesModel.setLayoutInfo(layoutInfo);
    prunning(treeRoot, new BoundingRect$1(-layoutInfo.x, -layoutInfo.y, ecWidth, ecHeight), viewAbovePath, viewRoot, 0);
  }
};
function squarify(node, options, hideChildren, depth) {
  var width;
  var height;
  if (node.isRemoved()) {
    return;
  }
  var thisLayout = node.getLayout();
  width = thisLayout.width;
  height = thisLayout.height;
  var nodeModel = node.getModel();
  var borderWidth = nodeModel.get(PATH_BORDER_WIDTH);
  var halfGapWidth = nodeModel.get(PATH_GAP_WIDTH) / 2;
  var upperLabelHeight = getUpperLabelHeight(nodeModel);
  var upperHeight = Math.max(borderWidth, upperLabelHeight);
  var layoutOffset = borderWidth - halfGapWidth;
  var layoutOffsetUpper = upperHeight - halfGapWidth;
  node.setLayout({
    borderWidth,
    upperHeight,
    upperLabelHeight
  }, true);
  width = mathMax$3(width - 2 * layoutOffset, 0);
  height = mathMax$3(height - layoutOffset - layoutOffsetUpper, 0);
  var totalArea = width * height;
  var viewChildren = initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth);
  if (!viewChildren.length) {
    return;
  }
  var rect = {
    x: layoutOffset,
    y: layoutOffsetUpper,
    width,
    height
  };
  var rowFixedLength = mathMin$3(width, height);
  var best = Infinity;
  var row = [];
  row.area = 0;
  for (var i = 0, len2 = viewChildren.length; i < len2; ) {
    var child = viewChildren[i];
    row.push(child);
    row.area += child.getLayout().area;
    var score = worst(row, rowFixedLength, options.squareRatio);
    if (score <= best) {
      i++;
      best = score;
    } else {
      row.area -= row.pop().getLayout().area;
      position(row, rowFixedLength, rect, halfGapWidth, false);
      rowFixedLength = mathMin$3(rect.width, rect.height);
      row.length = row.area = 0;
      best = Infinity;
    }
  }
  if (row.length) {
    position(row, rowFixedLength, rect, halfGapWidth, true);
  }
  if (!hideChildren) {
    var childrenVisibleMin = nodeModel.get("childrenVisibleMin");
    if (childrenVisibleMin != null && totalArea < childrenVisibleMin) {
      hideChildren = true;
    }
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    squarify(viewChildren[i], options, hideChildren, depth + 1);
  }
}
function initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth) {
  var viewChildren = node.children || [];
  var orderBy = options.sort;
  orderBy !== "asc" && orderBy !== "desc" && (orderBy = null);
  var overLeafDepth = options.leafDepth != null && options.leafDepth <= depth;
  if (hideChildren && !overLeafDepth) {
    return node.viewChildren = [];
  }
  viewChildren = filter(viewChildren, function(child) {
    return !child.isRemoved();
  });
  sort$1(viewChildren, orderBy);
  var info = statistic(nodeModel, viewChildren, orderBy);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  info.sum = filterByThreshold(nodeModel, totalArea, info.sum, orderBy, viewChildren);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    var area = viewChildren[i].getValue() / info.sum * totalArea;
    viewChildren[i].setLayout({
      area
    });
  }
  if (overLeafDepth) {
    viewChildren.length && node.setLayout({
      isLeafRoot: true
    }, true);
    viewChildren.length = 0;
  }
  node.viewChildren = viewChildren;
  node.setLayout({
    dataExtent: info.dataExtent
  }, true);
  return viewChildren;
}
function filterByThreshold(nodeModel, totalArea, sum2, orderBy, orderedChildren) {
  if (!orderBy) {
    return sum2;
  }
  var visibleMin = nodeModel.get("visibleMin");
  var len2 = orderedChildren.length;
  var deletePoint = len2;
  for (var i = len2 - 1; i >= 0; i--) {
    var value = orderedChildren[orderBy === "asc" ? len2 - i - 1 : i].getValue();
    if (value / sum2 * totalArea < visibleMin) {
      deletePoint = i;
      sum2 -= value;
    }
  }
  orderBy === "asc" ? orderedChildren.splice(0, len2 - deletePoint) : orderedChildren.splice(deletePoint, len2 - deletePoint);
  return sum2;
}
function sort$1(viewChildren, orderBy) {
  if (orderBy) {
    viewChildren.sort(function(a, b2) {
      var diff = orderBy === "asc" ? a.getValue() - b2.getValue() : b2.getValue() - a.getValue();
      return diff === 0 ? orderBy === "asc" ? a.dataIndex - b2.dataIndex : b2.dataIndex - a.dataIndex : diff;
    });
  }
  return viewChildren;
}
function statistic(nodeModel, children, orderBy) {
  var sum2 = 0;
  for (var i = 0, len2 = children.length; i < len2; i++) {
    sum2 += children[i].getValue();
  }
  var dimension = nodeModel.get("visualDimension");
  var dataExtent;
  if (!children || !children.length) {
    dataExtent = [NaN, NaN];
  } else if (dimension === "value" && orderBy) {
    dataExtent = [children[children.length - 1].getValue(), children[0].getValue()];
    orderBy === "asc" && dataExtent.reverse();
  } else {
    dataExtent = [Infinity, -Infinity];
    each$b(children, function(child) {
      var value = child.getValue(dimension);
      value < dataExtent[0] && (dataExtent[0] = value);
      value > dataExtent[1] && (dataExtent[1] = value);
    });
  }
  return {
    sum: sum2,
    dataExtent
  };
}
function worst(row, rowFixedLength, ratio) {
  var areaMax = 0;
  var areaMin = Infinity;
  for (var i = 0, area = void 0, len2 = row.length; i < len2; i++) {
    area = row[i].getLayout().area;
    if (area) {
      area < areaMin && (areaMin = area);
      area > areaMax && (areaMax = area);
    }
  }
  var squareArea = row.area * row.area;
  var f2 = rowFixedLength * rowFixedLength * ratio;
  return squareArea ? mathMax$3(f2 * areaMax / squareArea, squareArea / (f2 * areaMin)) : Infinity;
}
function position(row, rowFixedLength, rect, halfGapWidth, flush) {
  var idx0WhenH = rowFixedLength === rect.width ? 0 : 1;
  var idx1WhenH = 1 - idx0WhenH;
  var xy = ["x", "y"];
  var wh = ["width", "height"];
  var last = rect[xy[idx0WhenH]];
  var rowOtherLength = rowFixedLength ? row.area / rowFixedLength : 0;
  if (flush || rowOtherLength > rect[wh[idx1WhenH]]) {
    rowOtherLength = rect[wh[idx1WhenH]];
  }
  for (var i = 0, rowLen = row.length; i < rowLen; i++) {
    var node = row[i];
    var nodeLayout = {};
    var step = rowOtherLength ? node.getLayout().area / rowOtherLength : 0;
    var wh1 = nodeLayout[wh[idx1WhenH]] = mathMax$3(rowOtherLength - 2 * halfGapWidth, 0);
    var remain = rect[xy[idx0WhenH]] + rect[wh[idx0WhenH]] - last;
    var modWH = i === rowLen - 1 || remain < step ? remain : step;
    var wh0 = nodeLayout[wh[idx0WhenH]] = mathMax$3(modWH - 2 * halfGapWidth, 0);
    nodeLayout[xy[idx1WhenH]] = rect[xy[idx1WhenH]] + mathMin$3(halfGapWidth, wh1 / 2);
    nodeLayout[xy[idx0WhenH]] = last + mathMin$3(halfGapWidth, wh0 / 2);
    last += modWH;
    node.setLayout(nodeLayout, true);
  }
  rect[xy[idx1WhenH]] += rowOtherLength;
  rect[wh[idx1WhenH]] -= rowOtherLength;
}
function estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) {
  var currNode = (targetInfo || {}).node;
  var defaultSize = [containerWidth, containerHeight];
  if (!currNode || currNode === viewRoot) {
    return defaultSize;
  }
  var parent;
  var viewArea = containerWidth * containerHeight;
  var area = viewArea * seriesModel.option.zoomToNodeRatio;
  while (parent = currNode.parentNode) {
    var sum2 = 0;
    var siblings = parent.children;
    for (var i = 0, len2 = siblings.length; i < len2; i++) {
      sum2 += siblings[i].getValue();
    }
    var currNodeValue = currNode.getValue();
    if (currNodeValue === 0) {
      return defaultSize;
    }
    area *= sum2 / currNodeValue;
    var parentModel = parent.getModel();
    var borderWidth = parentModel.get(PATH_BORDER_WIDTH);
    var upperHeight = Math.max(borderWidth, getUpperLabelHeight(parentModel));
    area += 4 * borderWidth * borderWidth + (3 * borderWidth + upperHeight) * Math.pow(area, 0.5);
    area > MAX_SAFE_INTEGER && (area = MAX_SAFE_INTEGER);
    currNode = parent;
  }
  area < viewArea && (area = viewArea);
  var scale2 = Math.pow(area / viewArea, 0.5);
  return [containerWidth * scale2, containerHeight * scale2];
}
function calculateRootPosition(layoutInfo, rootRect, targetInfo) {
  if (rootRect) {
    return {
      x: rootRect.x,
      y: rootRect.y
    };
  }
  var defaultPosition = {
    x: 0,
    y: 0
  };
  if (!targetInfo) {
    return defaultPosition;
  }
  var targetNode = targetInfo.node;
  var layout2 = targetNode.getLayout();
  if (!layout2) {
    return defaultPosition;
  }
  var targetCenter = [layout2.width / 2, layout2.height / 2];
  var node = targetNode;
  while (node) {
    var nodeLayout = node.getLayout();
    targetCenter[0] += nodeLayout.x;
    targetCenter[1] += nodeLayout.y;
    node = node.parentNode;
  }
  return {
    x: layoutInfo.width / 2 - targetCenter[0],
    y: layoutInfo.height / 2 - targetCenter[1]
  };
}
function prunning(node, clipRect, viewAbovePath, viewRoot, depth) {
  var nodeLayout = node.getLayout();
  var nodeInViewAbovePath = viewAbovePath[depth];
  var isAboveViewRoot = nodeInViewAbovePath && nodeInViewAbovePath === node;
  if (nodeInViewAbovePath && !isAboveViewRoot || depth === viewAbovePath.length && node !== viewRoot) {
    return;
  }
  node.setLayout({
    isInView: true,
    invisible: !isAboveViewRoot && !clipRect.intersect(nodeLayout),
    isAboveViewRoot
  }, true);
  var childClipRect = new BoundingRect$1(clipRect.x - nodeLayout.x, clipRect.y - nodeLayout.y, clipRect.width, clipRect.height);
  each$b(node.viewChildren || [], function(child) {
    prunning(child, childClipRect, viewAbovePath, viewRoot, depth + 1);
  });
}
function getUpperLabelHeight(model) {
  return model.get(PATH_UPPER_LABEL_SHOW) ? model.get(PATH_UPPER_LABEL_HEIGHT) : 0;
}
function install$G(registers) {
  registers.registerSeriesModel(TreemapSeriesModel$1);
  registers.registerChartView(TreemapView$1);
  registers.registerVisual(treemapVisual);
  registers.registerLayout(treemapLayout);
  installTreemapAction(registers);
}
function categoryFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (!legendModels || !legendModels.length) {
    return;
  }
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var categoriesData = graphSeries.getCategoriesData();
    var graph = graphSeries.getGraph();
    var data = graph.data;
    var categoryNames = categoriesData.mapArray(categoriesData.getName);
    data.filterSelf(function(idx) {
      var model = data.getItemModel(idx);
      var category = model.getShallow("category");
      if (category != null) {
        if (isNumber(category)) {
          category = categoryNames[category];
        }
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(category)) {
            return false;
          }
        }
      }
      return true;
    });
  });
}
function categoryVisual(ecModel) {
  var paletteScope = {};
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var categoriesData = seriesModel.getCategoriesData();
    var data = seriesModel.getData();
    var categoryNameIdxMap = {};
    categoriesData.each(function(idx) {
      var name = categoriesData.getName(idx);
      categoryNameIdxMap["ec-" + name] = idx;
      var itemModel = categoriesData.getItemModel(idx);
      var style = itemModel.getModel("itemStyle").getItemStyle();
      if (!style.fill) {
        style.fill = seriesModel.getColorFromPalette(name, paletteScope);
      }
      categoriesData.setItemVisual(idx, "style", style);
      var symbolVisualList = ["symbol", "symbolSize", "symbolKeepAspect"];
      for (var i = 0; i < symbolVisualList.length; i++) {
        var symbolVisual = itemModel.getShallow(symbolVisualList[i], true);
        if (symbolVisual != null) {
          categoriesData.setItemVisual(idx, symbolVisualList[i], symbolVisual);
        }
      }
    });
    if (categoriesData.count()) {
      data.each(function(idx) {
        var model = data.getItemModel(idx);
        var categoryIdx = model.getShallow("category");
        if (categoryIdx != null) {
          if (isString(categoryIdx)) {
            categoryIdx = categoryNameIdxMap["ec-" + categoryIdx];
          }
          var categoryStyle = categoriesData.getItemVisual(categoryIdx, "style");
          var style = data.ensureUniqueItemVisual(idx, "style");
          extend(style, categoryStyle);
          var visualList = ["symbol", "symbolSize", "symbolKeepAspect"];
          for (var i = 0; i < visualList.length; i++) {
            data.setItemVisual(idx, visualList[i], categoriesData.getItemVisual(categoryIdx, visualList[i]));
          }
        }
      });
    }
  });
}
function normalize$2(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
function graphEdgeVisual(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var edgeData = seriesModel.getEdgeData();
    var symbolType = normalize$2(seriesModel.get("edgeSymbol"));
    var symbolSize = normalize$2(seriesModel.get("edgeSymbolSize"));
    edgeData.setVisual("fromSymbol", symbolType && symbolType[0]);
    edgeData.setVisual("toSymbol", symbolType && symbolType[1]);
    edgeData.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    edgeData.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    edgeData.setVisual("style", seriesModel.getModel("lineStyle").getLineStyle());
    edgeData.each(function(idx) {
      var itemModel = edgeData.getItemModel(idx);
      var edge = graph.getEdgeByIndex(idx);
      var symbolType2 = normalize$2(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$2(itemModel.getShallow("symbolSize", true));
      var style = itemModel.getModel("lineStyle").getLineStyle();
      var existsStyle = edgeData.ensureUniqueItemVisual(idx, "style");
      extend(existsStyle, style);
      switch (existsStyle.stroke) {
        case "source": {
          var nodeStyle = edge.node1.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
        case "target": {
          var nodeStyle = edge.node2.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
      }
      symbolType2[0] && edge.setVisual("fromSymbol", symbolType2[0]);
      symbolType2[1] && edge.setVisual("toSymbol", symbolType2[1]);
      symbolSize2[0] && edge.setVisual("fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && edge.setVisual("toSymbolSize", symbolSize2[1]);
    });
  });
}
var KEY_DELIMITER = "-->";
var getAutoCurvenessParams = function(seriesModel) {
  return seriesModel.get("autoCurveness") || null;
};
var createCurveness = function(seriesModel, appendLength) {
  var autoCurvenessParmas = getAutoCurvenessParams(seriesModel);
  var length = 20;
  var curvenessList = [];
  if (isNumber(autoCurvenessParmas)) {
    length = autoCurvenessParmas;
  } else if (isArray$1(autoCurvenessParmas)) {
    seriesModel.__curvenessList = autoCurvenessParmas;
    return;
  }
  if (appendLength > length) {
    length = appendLength;
  }
  var len2 = length % 2 ? length + 2 : length + 3;
  curvenessList = [];
  for (var i = 0; i < len2; i++) {
    curvenessList.push((i % 2 ? i + 1 : i) / 10 * (i % 2 ? -1 : 1));
  }
  seriesModel.__curvenessList = curvenessList;
};
var getKeyOfEdges = function(n1, n2, seriesModel) {
  var source = [n1.id, n1.dataIndex].join(".");
  var target = [n2.id, n2.dataIndex].join(".");
  return [seriesModel.uid, source, target].join(KEY_DELIMITER);
};
var getOppositeKey = function(key) {
  var keys2 = key.split(KEY_DELIMITER);
  return [keys2[0], keys2[2], keys2[1]].join(KEY_DELIMITER);
};
var getEdgeFromMap = function(edge, seriesModel) {
  var key = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  return seriesModel.__edgeMap[key];
};
var getTotalLengthBetweenNodes = function(edge, seriesModel) {
  var len2 = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node1, edge.node2, seriesModel), seriesModel);
  var lenV = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node2, edge.node1, seriesModel), seriesModel);
  return len2 + lenV;
};
var getEdgeMapLengthWithKey = function(key, seriesModel) {
  var edgeMap = seriesModel.__edgeMap;
  return edgeMap[key] ? edgeMap[key].length : 0;
};
function initCurvenessList(seriesModel) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  seriesModel.__curvenessList = [];
  seriesModel.__edgeMap = {};
  createCurveness(seriesModel);
}
function createEdgeMapForCurveness(n1, n2, seriesModel, index2) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  var key = getKeyOfEdges(n1, n2, seriesModel);
  var edgeMap = seriesModel.__edgeMap;
  var oppositeEdges = edgeMap[getOppositeKey(key)];
  if (edgeMap[key] && !oppositeEdges) {
    edgeMap[key].isForward = true;
  } else if (oppositeEdges && edgeMap[key]) {
    oppositeEdges.isForward = true;
    edgeMap[key].isForward = false;
  }
  edgeMap[key] = edgeMap[key] || [];
  edgeMap[key].push(index2);
}
function getCurvenessForEdge(edge, seriesModel, index2, needReverse) {
  var autoCurvenessParams = getAutoCurvenessParams(seriesModel);
  var isArrayParam = isArray$1(autoCurvenessParams);
  if (!autoCurvenessParams) {
    return null;
  }
  var edgeArray = getEdgeFromMap(edge, seriesModel);
  if (!edgeArray) {
    return null;
  }
  var edgeIndex = -1;
  for (var i = 0; i < edgeArray.length; i++) {
    if (edgeArray[i] === index2) {
      edgeIndex = i;
      break;
    }
  }
  var totalLen = getTotalLengthBetweenNodes(edge, seriesModel);
  createCurveness(seriesModel, totalLen);
  edge.lineStyle = edge.lineStyle || {};
  var curKey = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  var curvenessList = seriesModel.__curvenessList;
  var parityCorrection = isArrayParam ? 0 : totalLen % 2 ? 0 : 1;
  if (!edgeArray.isForward) {
    var oppositeKey = getOppositeKey(curKey);
    var len2 = getEdgeMapLengthWithKey(oppositeKey, seriesModel);
    var resValue = curvenessList[edgeIndex + len2 + parityCorrection];
    if (needReverse) {
      if (isArrayParam) {
        if (autoCurvenessParams && autoCurvenessParams[0] === 0) {
          return (len2 + parityCorrection) % 2 ? resValue : -resValue;
        } else {
          return ((len2 % 2 ? 0 : 1) + parityCorrection) % 2 ? resValue : -resValue;
        }
      } else {
        return (len2 + parityCorrection) % 2 ? resValue : -resValue;
      }
    } else {
      return curvenessList[edgeIndex + len2 + parityCorrection];
    }
  } else {
    return curvenessList[parityCorrection + edgeIndex];
  }
}
function simpleLayout(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var graph = seriesModel.getGraph();
  graph.eachNode(function(node) {
    var model = node.getModel();
    node.setLayout([+model.get("x"), +model.get("y")]);
  });
  simpleLayoutEdge(graph, seriesModel);
}
function simpleLayoutEdge(graph, seriesModel) {
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, seriesModel, index2, true), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var points2 = [p1, p2];
    if (+curveness) {
      points2.push([(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * curveness]);
    }
    edge.setLayout(points2);
  });
}
function graphSimpleLayout(ecModel, api) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var layout2 = seriesModel.get("layout");
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      var data_1 = seriesModel.getData();
      var dimensions_1 = [];
      each$f(coordSys.dimensions, function(coordDim) {
        dimensions_1 = dimensions_1.concat(data_1.mapDimensionsAll(coordDim));
      });
      for (var dataIndex = 0; dataIndex < data_1.count(); dataIndex++) {
        var value = [];
        var hasValue = false;
        for (var i = 0; i < dimensions_1.length; i++) {
          var val = data_1.get(dimensions_1[i], dataIndex);
          if (!isNaN(val)) {
            hasValue = true;
          }
          value.push(val);
        }
        if (hasValue) {
          data_1.setItemLayout(dataIndex, coordSys.dataToPoint(value));
        } else {
          data_1.setItemLayout(dataIndex, [NaN, NaN]);
        }
      }
      simpleLayoutEdge(data_1.graph, seriesModel);
    } else if (!layout2 || layout2 === "none") {
      simpleLayout(seriesModel);
    }
  });
}
function getNodeGlobalScale(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys.type !== "view") {
    return 1;
  }
  var nodeScaleRatio = seriesModel.option.nodeScaleRatio;
  var groupZoom = coordSys.scaleX;
  var roamZoom = coordSys.getZoom();
  var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
  return nodeScale / groupZoom;
}
function getSymbolSize(node) {
  var symbolSize = node.getVisual("symbolSize");
  if (symbolSize instanceof Array) {
    symbolSize = (symbolSize[0] + symbolSize[1]) / 2;
  }
  return +symbolSize;
}
var PI$2 = Math.PI;
var _symbolRadiansHalf = [];
function circularLayout(seriesModel, basedOn) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var rect = coordSys.getBoundingRect();
  var nodeData = seriesModel.getData();
  var graph = nodeData.graph;
  var cx = rect.width / 2 + rect.x;
  var cy = rect.height / 2 + rect.y;
  var r2 = Math.min(rect.width, rect.height) / 2;
  var count2 = nodeData.count();
  nodeData.setLayout({
    cx,
    cy
  });
  if (!count2) {
    return;
  }
  _layoutNodesBasedOn[basedOn](seriesModel, graph, nodeData, r2, cx, cy, count2);
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), getCurvenessForEdge(edge, seriesModel, index2), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var cp1;
    var x12 = (p1[0] + p2[0]) / 2;
    var y12 = (p1[1] + p2[1]) / 2;
    if (+curveness) {
      curveness *= 3;
      cp1 = [cx * curveness + x12 * (1 - curveness), cy * curveness + y12 * (1 - curveness)];
    }
    edge.setLayout([p1, p2, cp1]);
  });
}
var _layoutNodesBasedOn = {
  value: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var angle = 0;
    var sum2 = nodeData.getSum("value");
    var unitAngle = Math.PI * 2 / (sum2 || count2);
    graph.eachNode(function(node) {
      var value = node.getValue("value");
      var radianHalf = unitAngle * (sum2 ? value : 1) / 2;
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  },
  symbolSize: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var sumRadian = 0;
    _symbolRadiansHalf.length = count2;
    var nodeScale = getNodeGlobalScale(seriesModel);
    graph.eachNode(function(node) {
      var symbolSize = getSymbolSize(node);
      isNaN(symbolSize) && (symbolSize = 2);
      symbolSize < 0 && (symbolSize = 0);
      symbolSize *= nodeScale;
      var symbolRadianHalf = Math.asin(symbolSize / 2 / r2);
      isNaN(symbolRadianHalf) && (symbolRadianHalf = PI$2 / 2);
      _symbolRadiansHalf[node.dataIndex] = symbolRadianHalf;
      sumRadian += symbolRadianHalf * 2;
    });
    var halfRemainRadian = (2 * PI$2 - sumRadian) / count2 / 2;
    var angle = 0;
    graph.eachNode(function(node) {
      var radianHalf = halfRemainRadian + _symbolRadiansHalf[node.dataIndex];
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  }
};
function graphCircularLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    if (seriesModel.get("layout") === "circular") {
      circularLayout(seriesModel, "symbolSize");
    }
  });
}
var scaleAndAdd = scaleAndAdd$1;
function forceLayout(inNodes, inEdges, opts) {
  var nodes = inNodes;
  var edges = inEdges;
  var rect = opts.rect;
  var width = rect.width;
  var height = rect.height;
  var center2 = [rect.x + width / 2, rect.y + height / 2];
  var gravity = opts.gravity == null ? 0.1 : opts.gravity;
  for (var i = 0; i < nodes.length; i++) {
    var n2 = nodes[i];
    if (!n2.p) {
      n2.p = create$2(width * (Math.random() - 0.5) + center2[0], height * (Math.random() - 0.5) + center2[1]);
    }
    n2.pp = clone$3(n2.p);
    n2.edges = null;
  }
  var initialFriction = opts.friction == null ? 0.6 : opts.friction;
  var friction = initialFriction;
  var beforeStepCallback;
  var afterStepCallback;
  return {
    warmUp: function() {
      friction = initialFriction * 0.8;
    },
    setFixed: function(idx) {
      nodes[idx].fixed = true;
    },
    setUnfixed: function(idx) {
      nodes[idx].fixed = false;
    },
    beforeStep: function(cb) {
      beforeStepCallback = cb;
    },
    afterStep: function(cb) {
      afterStepCallback = cb;
    },
    step: function(cb) {
      beforeStepCallback && beforeStepCallback(nodes, edges);
      var v12 = [];
      var nLen = nodes.length;
      for (var i2 = 0; i2 < edges.length; i2++) {
        var e2 = edges[i2];
        if (e2.ignoreForceLayout) {
          continue;
        }
        var n1 = e2.n1;
        var n22 = e2.n2;
        sub(v12, n22.p, n1.p);
        var d2 = len(v12) - e2.d;
        var w2 = n22.w / (n1.w + n22.w);
        if (isNaN(w2)) {
          w2 = 0;
        }
        normalize$4(v12, v12);
        !n1.fixed && scaleAndAdd(n1.p, n1.p, v12, w2 * d2 * friction);
        !n22.fixed && scaleAndAdd(n22.p, n22.p, v12, -(1 - w2) * d2 * friction);
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v12, center2, n3.p);
          scaleAndAdd(n3.p, n3.p, v12, gravity * friction);
        }
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n1 = nodes[i2];
        for (var j = i2 + 1; j < nLen; j++) {
          var n22 = nodes[j];
          sub(v12, n22.p, n1.p);
          var d2 = len(v12);
          if (d2 === 0) {
            set$2(v12, Math.random() - 0.5, Math.random() - 0.5);
            d2 = 1;
          }
          var repFact = (n1.rep + n22.rep) / d2 / d2;
          !n1.fixed && scaleAndAdd(n1.pp, n1.pp, v12, repFact);
          !n22.fixed && scaleAndAdd(n22.pp, n22.pp, v12, -repFact);
        }
      }
      var v4 = [];
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v4, n3.p, n3.pp);
          scaleAndAdd(n3.p, n3.p, v4, friction);
          copy$1(n3.pp, n3.p);
        }
      }
      friction = friction * 0.992;
      var finished = friction < 0.01;
      afterStepCallback && afterStepCallback(nodes, edges, finished);
      cb && cb(finished);
    }
  };
}
function graphForceLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var coordSys = graphSeries.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      return;
    }
    if (graphSeries.get("layout") === "force") {
      var preservedPoints_1 = graphSeries.preservedPoints || {};
      var graph_1 = graphSeries.getGraph();
      var nodeData_1 = graph_1.data;
      var edgeData = graph_1.edgeData;
      var forceModel = graphSeries.getModel("force");
      var initLayout = forceModel.get("initLayout");
      if (graphSeries.preservedPoints) {
        nodeData_1.each(function(idx) {
          var id2 = nodeData_1.getId(idx);
          nodeData_1.setItemLayout(idx, preservedPoints_1[id2] || [NaN, NaN]);
        });
      } else if (!initLayout || initLayout === "none") {
        simpleLayout(graphSeries);
      } else if (initLayout === "circular") {
        circularLayout(graphSeries, "value");
      }
      var nodeDataExtent_1 = nodeData_1.getDataExtent("value");
      var edgeDataExtent_1 = edgeData.getDataExtent("value");
      var repulsion = forceModel.get("repulsion");
      var edgeLength = forceModel.get("edgeLength");
      var repulsionArr_1 = isArray$1(repulsion) ? repulsion : [repulsion, repulsion];
      var edgeLengthArr_1 = isArray$1(edgeLength) ? edgeLength : [edgeLength, edgeLength];
      edgeLengthArr_1 = [edgeLengthArr_1[1], edgeLengthArr_1[0]];
      var nodes_1 = nodeData_1.mapArray("value", function(value, idx) {
        var point = nodeData_1.getItemLayout(idx);
        var rep = linearMap$2(value, nodeDataExtent_1, repulsionArr_1);
        if (isNaN(rep)) {
          rep = (repulsionArr_1[0] + repulsionArr_1[1]) / 2;
        }
        return {
          w: rep,
          rep,
          fixed: nodeData_1.getItemModel(idx).get("fixed"),
          p: !point || isNaN(point[0]) || isNaN(point[1]) ? null : point
        };
      });
      var edges = edgeData.mapArray("value", function(value, idx) {
        var edge = graph_1.getEdgeByIndex(idx);
        var d2 = linearMap$2(value, edgeDataExtent_1, edgeLengthArr_1);
        if (isNaN(d2)) {
          d2 = (edgeLengthArr_1[0] + edgeLengthArr_1[1]) / 2;
        }
        var edgeModel = edge.getModel();
        var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, graphSeries, idx, true), 0);
        return {
          n1: nodes_1[edge.node1.dataIndex],
          n2: nodes_1[edge.node2.dataIndex],
          d: d2,
          curveness,
          ignoreForceLayout: edgeModel.get("ignoreForceLayout")
        };
      });
      var rect = coordSys.getBoundingRect();
      var forceInstance = forceLayout(nodes_1, edges, {
        rect,
        gravity: forceModel.get("gravity"),
        friction: forceModel.get("friction")
      });
      forceInstance.beforeStep(function(nodes, edges2) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (nodes[i].fixed) {
            copy$1(nodes[i].p, graph_1.getNodeByIndex(i).getLayout());
          }
        }
      });
      forceInstance.afterStep(function(nodes, edges2, stopped) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (!nodes[i].fixed) {
            graph_1.getNodeByIndex(i).setLayout(nodes[i].p);
          }
          preservedPoints_1[nodeData_1.getId(i)] = nodes[i].p;
        }
        for (var i = 0, l2 = edges2.length; i < l2; i++) {
          var e2 = edges2[i];
          var edge = graph_1.getEdgeByIndex(i);
          var p1 = e2.n1.p;
          var p2 = e2.n2.p;
          var points2 = edge.getLayout();
          points2 = points2 ? points2.slice() : [];
          points2[0] = points2[0] || [];
          points2[1] = points2[1] || [];
          copy$1(points2[0], p1);
          copy$1(points2[1], p2);
          if (+e2.curveness) {
            points2[2] = [(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * e2.curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * e2.curveness];
          }
          edge.setLayout(points2);
        }
      });
      graphSeries.forceLayout = forceInstance;
      graphSeries.preservedPoints = preservedPoints_1;
      forceInstance.step();
    } else {
      graphSeries.forceLayout = null;
    }
  });
}
function getViewRect$3(seriesModel, api, aspect) {
  var option = extend(seriesModel.getBoxLayoutParams(), {
    aspect
  });
  return getLayoutRect(option, {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function createViewCoordSys(ecModel, api) {
  var viewList = [];
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var coordSysType = seriesModel.get("coordinateSystem");
    if (!coordSysType || coordSysType === "view") {
      var data_1 = seriesModel.getData();
      var positions = data_1.mapArray(function(idx) {
        var itemModel = data_1.getItemModel(idx);
        return [+itemModel.get("x"), +itemModel.get("y")];
      });
      var min3 = [];
      var max3 = [];
      fromPoints(positions, min3, max3);
      if (max3[0] - min3[0] === 0) {
        max3[0] += 1;
        min3[0] -= 1;
      }
      if (max3[1] - min3[1] === 0) {
        max3[1] += 1;
        min3[1] -= 1;
      }
      var aspect = (max3[0] - min3[0]) / (max3[1] - min3[1]);
      var viewRect2 = getViewRect$3(seriesModel, api, aspect);
      if (isNaN(aspect)) {
        min3 = [viewRect2.x, viewRect2.y];
        max3 = [viewRect2.x + viewRect2.width, viewRect2.y + viewRect2.height];
      }
      var bbWidth = max3[0] - min3[0];
      var bbHeight = max3[1] - min3[1];
      var viewWidth = viewRect2.width;
      var viewHeight = viewRect2.height;
      var viewCoordSys = seriesModel.coordinateSystem = new View$1();
      viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
      viewCoordSys.setBoundingRect(min3[0], min3[1], bbWidth, bbHeight);
      viewCoordSys.setViewRect(viewRect2.x, viewRect2.y, viewWidth, viewHeight);
      viewCoordSys.setCenter(seriesModel.get("center"));
      viewCoordSys.setZoom(seriesModel.get("zoom"));
      viewList.push(viewCoordSys);
    }
  });
  return viewList;
}
var straightLineProto = Line$3.prototype;
var bezierCurveProto = BezierCurve$1.prototype;
var StraightLineShape = function() {
  function StraightLineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return StraightLineShape2;
}();
(function(_super) {
  __extends(CurveShape, _super);
  function CurveShape() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return CurveShape;
})(StraightLineShape);
function isStraightLine(shape) {
  return isNaN(+shape.cpx1) || isNaN(+shape.cpy1);
}
var ECLinePath = function(_super) {
  __extends(ECLinePath2, _super);
  function ECLinePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-line";
    return _this;
  }
  ECLinePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECLinePath2.prototype.getDefaultShape = function() {
    return new StraightLineShape();
  };
  ECLinePath2.prototype.buildPath = function(ctx, shape) {
    if (isStraightLine(shape)) {
      straightLineProto.buildPath.call(this, ctx, shape);
    } else {
      bezierCurveProto.buildPath.call(this, ctx, shape);
    }
  };
  ECLinePath2.prototype.pointAt = function(t2) {
    if (isStraightLine(this.shape)) {
      return straightLineProto.pointAt.call(this, t2);
    } else {
      return bezierCurveProto.pointAt.call(this, t2);
    }
  };
  ECLinePath2.prototype.tangentAt = function(t2) {
    var shape = this.shape;
    var p2 = isStraightLine(shape) ? [shape.x2 - shape.x1, shape.y2 - shape.y1] : bezierCurveProto.tangentAt.call(this, t2);
    return normalize$4(p2, p2);
  };
  return ECLinePath2;
}(Path$1);
var ECLinePath$1 = ECLinePath;
var SYMBOL_CATEGORIES = ["fromSymbol", "toSymbol"];
function makeSymbolTypeKey(symbolCategory) {
  return "_" + symbolCategory + "Type";
}
function createSymbol(name, lineData, idx) {
  var symbolType = lineData.getItemVisual(idx, name);
  if (!symbolType || symbolType === "none") {
    return;
  }
  var symbolSize = lineData.getItemVisual(idx, name + "Size");
  var symbolRotate = lineData.getItemVisual(idx, name + "Rotate");
  var symbolOffset = lineData.getItemVisual(idx, name + "Offset");
  var symbolKeepAspect = lineData.getItemVisual(idx, name + "KeepAspect");
  var symbolSizeArr = normalizeSymbolSize(symbolSize);
  var symbolOffsetArr = normalizeSymbolOffset(symbolOffset || 0, symbolSizeArr);
  var symbolPath = createSymbol$1(symbolType, -symbolSizeArr[0] / 2 + symbolOffsetArr[0], -symbolSizeArr[1] / 2 + symbolOffsetArr[1], symbolSizeArr[0], symbolSizeArr[1], null, symbolKeepAspect);
  symbolPath.__specifiedRotation = symbolRotate == null || isNaN(symbolRotate) ? void 0 : +symbolRotate * Math.PI / 180 || 0;
  symbolPath.name = name;
  return symbolPath;
}
function createLine(points2) {
  var line = new ECLinePath$1({
    name: "line",
    subPixelOptimize: true
  });
  setLinePoints(line.shape, points2);
  return line;
}
function setLinePoints(targetShape, points2) {
  targetShape.x1 = points2[0][0];
  targetShape.y1 = points2[0][1];
  targetShape.x2 = points2[1][0];
  targetShape.y2 = points2[1][1];
  targetShape.percent = 1;
  var cp1 = points2[2];
  if (cp1) {
    targetShape.cpx1 = cp1[0];
    targetShape.cpy1 = cp1[1];
  } else {
    targetShape.cpx1 = NaN;
    targetShape.cpy1 = NaN;
  }
}
var Line = function(_super) {
  __extends(Line2, _super);
  function Line2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createLine(lineData, idx, seriesScope);
    return _this;
  }
  Line2.prototype._createLine = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var linePoints = lineData.getItemLayout(idx);
    var line = createLine(linePoints);
    line.shape.percent = 0;
    initProps(line, {
      shape: {
        percent: 1
      }
    }, seriesModel, idx);
    this.add(line);
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = createSymbol(symbolCategory, lineData, idx);
      this.add(symbol);
      this[makeSymbolTypeKey(symbolCategory)] = lineData.getItemVisual(idx, symbolCategory);
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var linePoints = lineData.getItemLayout(idx);
    var target = {
      shape: {}
    };
    setLinePoints(target.shape, linePoints);
    updateProps$1(line, target, seriesModel, idx);
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbolType = lineData.getItemVisual(idx, symbolCategory);
      var key = makeSymbolTypeKey(symbolCategory);
      if (this[key] !== symbolType) {
        this.remove(this.childOfName(symbolCategory));
        var symbol = createSymbol(symbolCategory, lineData, idx);
        this.add(symbol);
      }
      this[key] = symbolType;
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.getLinePath = function() {
    return this.childAt(0);
  };
  Line2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var blurLineStyle = seriesScope && seriesScope.blurLineStyle;
    var selectLineStyle = seriesScope && seriesScope.selectLineStyle;
    var labelStatesModels = seriesScope && seriesScope.labelStatesModels;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    if (!seriesScope || lineData.hasItemOption) {
      var itemModel = lineData.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      blurLineStyle = itemModel.getModel(["blur", "lineStyle"]).getLineStyle();
      selectLineStyle = itemModel.getModel(["select", "lineStyle"]).getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      labelStatesModels = getLabelStatesModels(itemModel);
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var visualColor = lineStyle.stroke;
    line.useStyle(lineStyle);
    line.style.fill = null;
    line.style.strokeNoScale = true;
    line.ensureState("emphasis").style = emphasisLineStyle;
    line.ensureState("blur").style = blurLineStyle;
    line.ensureState("select").style = selectLineStyle;
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = this.childOfName(symbolCategory);
      if (symbol) {
        symbol.setColor(visualColor);
        symbol.style.opacity = lineStyle.opacity;
        for (var i = 0; i < SPECIAL_STATES.length; i++) {
          var stateName = SPECIAL_STATES[i];
          var lineState = line.getState(stateName);
          if (lineState) {
            var lineStateStyle = lineState.style || {};
            var state = symbol.ensureState(stateName);
            var stateStyle = state.style || (state.style = {});
            if (lineStateStyle.stroke != null) {
              stateStyle[symbol.__isEmptyBrush ? "stroke" : "fill"] = lineStateStyle.stroke;
            }
            if (lineStateStyle.opacity != null) {
              stateStyle.opacity = lineStateStyle.opacity;
            }
          }
        }
        symbol.markRedraw();
      }
    }, this);
    var rawVal = seriesModel.getRawValue(idx);
    setLabelStyle(this, labelStatesModels, {
      labelDataIndex: idx,
      labelFetcher: {
        getFormattedLabel: function(dataIndex, stateName) {
          return seriesModel.getFormattedLabel(dataIndex, stateName, lineData.dataType);
        }
      },
      inheritColor: visualColor || "#000",
      defaultOpacity: lineStyle.opacity,
      defaultText: (rawVal == null ? lineData.getName(idx) : isFinite(rawVal) ? round$3(rawVal) : rawVal) + ""
    });
    var label = this.getTextContent();
    if (label) {
      var labelNormalModel = labelStatesModels.normal;
      label.__align = label.style.align;
      label.__verticalAlign = label.style.verticalAlign;
      label.__position = labelNormalModel.get("position") || "middle";
      var distance2 = labelNormalModel.get("distance");
      if (!isArray$1(distance2)) {
        distance2 = [distance2, distance2];
      }
      label.__labelDistance = distance2;
    }
    this.setTextConfig({
      position: null,
      local: true,
      inside: false
    });
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Line2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  Line2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  Line2.prototype.updateLayout = function(lineData, idx) {
    this.setLinePoints(lineData.getItemLayout(idx));
  };
  Line2.prototype.setLinePoints = function(points2) {
    var linePath = this.childOfName("line");
    setLinePoints(linePath.shape, points2);
    linePath.dirty();
  };
  Line2.prototype.beforeUpdate = function() {
    var lineGroup = this;
    var symbolFrom = lineGroup.childOfName("fromSymbol");
    var symbolTo = lineGroup.childOfName("toSymbol");
    var label = lineGroup.getTextContent();
    if (!symbolFrom && !symbolTo && (!label || label.ignore)) {
      return;
    }
    var invScale = 1;
    var parentNode2 = this.parent;
    while (parentNode2) {
      if (parentNode2.scaleX) {
        invScale /= parentNode2.scaleX;
      }
      parentNode2 = parentNode2.parent;
    }
    var line = lineGroup.childOfName("line");
    if (!this.__dirty && !line.__dirty) {
      return;
    }
    var percent = line.shape.percent;
    var fromPos = line.pointAt(0);
    var toPos = line.pointAt(percent);
    var d2 = sub([], toPos, fromPos);
    normalize$4(d2, d2);
    function setSymbolRotation(symbol, percent2) {
      var specifiedRotation = symbol.__specifiedRotation;
      if (specifiedRotation == null) {
        var tangent2 = line.tangentAt(percent2);
        symbol.attr("rotation", (percent2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(tangent2[1], tangent2[0]));
      } else {
        symbol.attr("rotation", specifiedRotation);
      }
    }
    if (symbolFrom) {
      symbolFrom.setPosition(fromPos);
      setSymbolRotation(symbolFrom, 0);
      symbolFrom.scaleX = symbolFrom.scaleY = invScale * percent;
      symbolFrom.markRedraw();
    }
    if (symbolTo) {
      symbolTo.setPosition(toPos);
      setSymbolRotation(symbolTo, 1);
      symbolTo.scaleX = symbolTo.scaleY = invScale * percent;
      symbolTo.markRedraw();
    }
    if (label && !label.ignore) {
      label.x = label.y = 0;
      label.originX = label.originY = 0;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var distance2 = label.__labelDistance;
      var distanceX = distance2[0] * invScale;
      var distanceY = distance2[1] * invScale;
      var halfPercent = percent / 2;
      var tangent = line.tangentAt(halfPercent);
      var n2 = [tangent[1], -tangent[0]];
      var cp = line.pointAt(halfPercent);
      if (n2[1] > 0) {
        n2[0] = -n2[0];
        n2[1] = -n2[1];
      }
      var dir3 = tangent[0] < 0 ? -1 : 1;
      if (label.__position !== "start" && label.__position !== "end") {
        var rotation = -Math.atan2(tangent[1], tangent[0]);
        if (toPos[0] < fromPos[0]) {
          rotation = Math.PI + rotation;
        }
        label.rotation = rotation;
      }
      var dy = void 0;
      switch (label.__position) {
        case "insideStartTop":
        case "insideMiddleTop":
        case "insideEndTop":
        case "middle":
          dy = -distanceY;
          textVerticalAlign = "bottom";
          break;
        case "insideStartBottom":
        case "insideMiddleBottom":
        case "insideEndBottom":
          dy = distanceY;
          textVerticalAlign = "top";
          break;
        default:
          dy = 0;
          textVerticalAlign = "middle";
      }
      switch (label.__position) {
        case "end":
          label.x = d2[0] * distanceX + toPos[0];
          label.y = d2[1] * distanceY + toPos[1];
          textAlign = d2[0] > 0.8 ? "left" : d2[0] < -0.8 ? "right" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "top" : d2[1] < -0.8 ? "bottom" : "middle";
          break;
        case "start":
          label.x = -d2[0] * distanceX + fromPos[0];
          label.y = -d2[1] * distanceY + fromPos[1];
          textAlign = d2[0] > 0.8 ? "right" : d2[0] < -0.8 ? "left" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "bottom" : d2[1] < -0.8 ? "top" : "middle";
          break;
        case "insideStartTop":
        case "insideStart":
        case "insideStartBottom":
          label.x = distanceX * dir3 + fromPos[0];
          label.y = fromPos[1] + dy;
          textAlign = tangent[0] < 0 ? "right" : "left";
          label.originX = -distanceX * dir3;
          label.originY = -dy;
          break;
        case "insideMiddleTop":
        case "insideMiddle":
        case "insideMiddleBottom":
        case "middle":
          label.x = cp[0];
          label.y = cp[1] + dy;
          textAlign = "center";
          label.originY = -dy;
          break;
        case "insideEndTop":
        case "insideEnd":
        case "insideEndBottom":
          label.x = -distanceX * dir3 + toPos[0];
          label.y = toPos[1] + dy;
          textAlign = tangent[0] >= 0 ? "right" : "left";
          label.originX = distanceX * dir3;
          label.originY = -dy;
          break;
      }
      label.scaleX = label.scaleY = invScale;
      label.setStyle({
        verticalAlign: label.__verticalAlign || textVerticalAlign,
        align: label.__align || textAlign
      });
    }
  };
  return Line2;
}(Group$4);
var Line$1 = Line;
var LineDraw = function() {
  function LineDraw2(LineCtor) {
    this.group = new Group$4();
    this._LineCtor = LineCtor || Line$1;
  }
  LineDraw2.prototype.updateData = function(lineData) {
    var _this = this;
    this._progressiveEls = null;
    var lineDraw = this;
    var group = lineDraw.group;
    var oldLineData = lineDraw._lineData;
    lineDraw._lineData = lineData;
    if (!oldLineData) {
      group.removeAll();
    }
    var seriesScope = makeSeriesScope$1(lineData);
    lineData.diff(oldLineData).add(function(idx) {
      _this._doAdd(lineData, idx, seriesScope);
    }).update(function(newIdx, oldIdx) {
      _this._doUpdate(oldLineData, lineData, oldIdx, newIdx, seriesScope);
    }).remove(function(idx) {
      group.remove(oldLineData.getItemGraphicEl(idx));
    }).execute();
  };
  LineDraw2.prototype.updateLayout = function() {
    var lineData = this._lineData;
    if (!lineData) {
      return;
    }
    lineData.eachItemGraphicEl(function(el, idx) {
      el.updateLayout(lineData, idx);
    }, this);
  };
  LineDraw2.prototype.incrementalPrepareUpdate = function(lineData) {
    this._seriesScope = makeSeriesScope$1(lineData);
    this._lineData = null;
    this.group.removeAll();
  };
  LineDraw2.prototype.incrementalUpdate = function(taskParams, lineData) {
    this._progressiveEls = [];
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup && !isEffectObject(el2)) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var itemLayout = lineData.getItemLayout(idx);
      if (lineNeedsDraw(itemLayout)) {
        var el = new this._LineCtor(lineData, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        this.group.add(el);
        lineData.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  LineDraw2.prototype.remove = function() {
    this.group.removeAll();
  };
  LineDraw2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  LineDraw2.prototype._doAdd = function(lineData, idx, seriesScope) {
    var itemLayout = lineData.getItemLayout(idx);
    if (!lineNeedsDraw(itemLayout)) {
      return;
    }
    var el = new this._LineCtor(lineData, idx, seriesScope);
    lineData.setItemGraphicEl(idx, el);
    this.group.add(el);
  };
  LineDraw2.prototype._doUpdate = function(oldLineData, newLineData, oldIdx, newIdx, seriesScope) {
    var itemEl = oldLineData.getItemGraphicEl(oldIdx);
    if (!lineNeedsDraw(newLineData.getItemLayout(newIdx))) {
      this.group.remove(itemEl);
      return;
    }
    if (!itemEl) {
      itemEl = new this._LineCtor(newLineData, newIdx, seriesScope);
    } else {
      itemEl.updateData(newLineData, newIdx, seriesScope);
    }
    newLineData.setItemGraphicEl(newIdx, itemEl);
    this.group.add(itemEl);
  };
  return LineDraw2;
}();
function isEffectObject(el) {
  return el.animators && el.animators.length > 0;
}
function makeSeriesScope$1(lineData) {
  var hostModel = lineData.hostModel;
  var emphasisModel = hostModel.getModel("emphasis");
  return {
    lineStyle: hostModel.getModel("lineStyle").getLineStyle(),
    emphasisLineStyle: emphasisModel.getModel(["lineStyle"]).getLineStyle(),
    blurLineStyle: hostModel.getModel(["blur", "lineStyle"]).getLineStyle(),
    selectLineStyle: hostModel.getModel(["select", "lineStyle"]).getLineStyle(),
    emphasisDisabled: emphasisModel.get("disabled"),
    blurScope: emphasisModel.get("blurScope"),
    focus: emphasisModel.get("focus"),
    labelStatesModels: getLabelStatesModels(hostModel)
  };
}
function isPointNaN(pt) {
  return isNaN(pt[0]) || isNaN(pt[1]);
}
function lineNeedsDraw(pts) {
  return pts && !isPointNaN(pts[0]) && !isPointNaN(pts[1]);
}
var LineDraw$1 = LineDraw;
var v1 = [];
var v2 = [];
var v3 = [];
var quadraticAt = quadraticAt$1;
var v2DistSquare = distSquare;
var mathAbs = Math.abs;
function intersectCurveCircle(curvePoints, center2, radius) {
  var p0 = curvePoints[0];
  var p1 = curvePoints[1];
  var p2 = curvePoints[2];
  var d2 = Infinity;
  var t2;
  var radiusSquare = radius * radius;
  var interval = 0.1;
  for (var _t = 0.1; _t <= 0.9; _t += 0.1) {
    v1[0] = quadraticAt(p0[0], p1[0], p2[0], _t);
    v1[1] = quadraticAt(p0[1], p1[1], p2[1], _t);
    var diff = mathAbs(v2DistSquare(v1, center2) - radiusSquare);
    if (diff < d2) {
      d2 = diff;
      t2 = _t;
    }
  }
  for (var i = 0; i < 32; i++) {
    var next = t2 + interval;
    v2[0] = quadraticAt(p0[0], p1[0], p2[0], t2);
    v2[1] = quadraticAt(p0[1], p1[1], p2[1], t2);
    v3[0] = quadraticAt(p0[0], p1[0], p2[0], next);
    v3[1] = quadraticAt(p0[1], p1[1], p2[1], next);
    var diff = v2DistSquare(v2, center2) - radiusSquare;
    if (mathAbs(diff) < 0.01) {
      break;
    }
    var nextDiff = v2DistSquare(v3, center2) - radiusSquare;
    interval /= 2;
    if (diff < 0) {
      if (nextDiff >= 0) {
        t2 = t2 + interval;
      } else {
        t2 = t2 - interval;
      }
    } else {
      if (nextDiff >= 0) {
        t2 = t2 - interval;
      } else {
        t2 = t2 + interval;
      }
    }
  }
  return t2;
}
function adjustEdge(graph, scale2) {
  var tmp0 = [];
  var quadraticSubdivide$1 = quadraticSubdivide;
  var pts = [[], [], []];
  var pts2 = [[], []];
  var v4 = [];
  scale2 /= 2;
  graph.eachEdge(function(edge, idx) {
    var linePoints = edge.getLayout();
    var fromSymbol = edge.getVisual("fromSymbol");
    var toSymbol = edge.getVisual("toSymbol");
    if (!linePoints.__original) {
      linePoints.__original = [clone$3(linePoints[0]), clone$3(linePoints[1])];
      if (linePoints[2]) {
        linePoints.__original.push(clone$3(linePoints[2]));
      }
    }
    var originalPoints = linePoints.__original;
    if (linePoints[2] != null) {
      copy$1(pts[0], originalPoints[0]);
      copy$1(pts[1], originalPoints[2]);
      copy$1(pts[2], originalPoints[1]);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        var t2 = intersectCurveCircle(pts, originalPoints[0], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[0][0] = tmp0[3];
        pts[1][0] = tmp0[4];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[0][1] = tmp0[3];
        pts[1][1] = tmp0[4];
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        var t2 = intersectCurveCircle(pts, originalPoints[1], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[1][0] = tmp0[1];
        pts[2][0] = tmp0[2];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[1][1] = tmp0[1];
        pts[2][1] = tmp0[2];
      }
      copy$1(linePoints[0], pts[0]);
      copy$1(linePoints[1], pts[2]);
      copy$1(linePoints[2], pts[1]);
    } else {
      copy$1(pts2[0], originalPoints[0]);
      copy$1(pts2[1], originalPoints[1]);
      sub(v4, pts2[1], pts2[0]);
      normalize$4(v4, v4);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        scaleAndAdd$1(pts2[0], pts2[0], v4, symbolSize * scale2);
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        scaleAndAdd$1(pts2[1], pts2[1], v4, -symbolSize * scale2);
      }
      copy$1(linePoints[0], pts2[0]);
      copy$1(linePoints[1], pts2[1]);
    }
  });
}
function isViewCoordSys(coordSys) {
  return coordSys.type === "view";
}
var GraphView = function(_super) {
  __extends(GraphView2, _super);
  function GraphView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphView2.type;
    return _this;
  }
  GraphView2.prototype.init = function(ecModel, api) {
    var symbolDraw = new SymbolDraw$1();
    var lineDraw = new LineDraw$1();
    var group = this.group;
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    group.add(symbolDraw.group);
    group.add(lineDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineDraw = lineDraw;
    this._firstRender = true;
  };
  GraphView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    this._model = seriesModel;
    var symbolDraw = this._symbolDraw;
    var lineDraw = this._lineDraw;
    var group = this.group;
    if (isViewCoordSys(coordSys)) {
      var groupNewProp = {
        x: coordSys.x,
        y: coordSys.y,
        scaleX: coordSys.scaleX,
        scaleY: coordSys.scaleY
      };
      if (this._firstRender) {
        group.attr(groupNewProp);
      } else {
        updateProps$1(group, groupNewProp, seriesModel);
      }
    }
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    var data = seriesModel.getData();
    symbolDraw.updateData(data);
    var edgeData = seriesModel.getEdgeData();
    lineDraw.updateData(edgeData);
    this._updateNodeAndLinkScale();
    this._updateController(seriesModel, ecModel, api);
    clearTimeout(this._layoutTimeout);
    var forceLayout2 = seriesModel.forceLayout;
    var layoutAnimation = seriesModel.get(["force", "layoutAnimation"]);
    if (forceLayout2) {
      this._startForceLayoutIteration(forceLayout2, layoutAnimation);
    }
    data.graph.eachNode(function(node) {
      var idx = node.dataIndex;
      var el = node.getGraphicEl();
      var itemModel = node.getModel();
      if (!el) {
        return;
      }
      el.off("drag").off("dragend");
      var draggable = itemModel.get("draggable");
      if (draggable) {
        el.on("drag", function() {
          if (forceLayout2) {
            forceLayout2.warmUp();
            !_this._layouting && _this._startForceLayoutIteration(forceLayout2, layoutAnimation);
            forceLayout2.setFixed(idx);
            data.setItemLayout(idx, [el.x, el.y]);
          }
        }).on("dragend", function() {
          if (forceLayout2) {
            forceLayout2.setUnfixed(idx);
          }
        });
      }
      el.setDraggable(draggable && !!forceLayout2);
      var focus = itemModel.get(["emphasis", "focus"]);
      if (focus === "adjacency") {
        getECData(el).focus = node.getAdjacentDataIndices();
      }
    });
    data.graph.eachEdge(function(edge) {
      var el = edge.getGraphicEl();
      var focus = edge.getModel().get(["emphasis", "focus"]);
      if (!el) {
        return;
      }
      if (focus === "adjacency") {
        getECData(el).focus = {
          edge: [edge.dataIndex],
          node: [edge.node1.dataIndex, edge.node2.dataIndex]
        };
      }
    });
    var circularRotateLabel = seriesModel.get("layout") === "circular" && seriesModel.get(["circular", "rotateLabel"]);
    var cx = data.getLayout("cx");
    var cy = data.getLayout("cy");
    data.eachItemGraphicEl(function(el, idx) {
      var itemModel = data.getItemModel(idx);
      var labelRotate = itemModel.get(["label", "rotate"]) || 0;
      var symbolPath = el.getSymbolPath();
      if (circularRotateLabel) {
        var pos = data.getItemLayout(idx);
        var rad = Math.atan2(pos[1] - cy, pos[0] - cx);
        if (rad < 0) {
          rad = Math.PI * 2 + rad;
        }
        var isLeft = pos[0] < cx;
        if (isLeft) {
          rad = rad - Math.PI;
        }
        var textPosition = isLeft ? "left" : "right";
        symbolPath.setTextConfig({
          rotation: -rad,
          position: textPosition,
          origin: "center"
        });
        var emphasisState = symbolPath.ensureState("emphasis");
        extend(emphasisState.textConfig || (emphasisState.textConfig = {}), {
          position: textPosition
        });
      } else {
        symbolPath.setTextConfig({
          rotation: labelRotate *= Math.PI / 180
        });
      }
    });
    this._firstRender = false;
  };
  GraphView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  GraphView2.prototype._startForceLayoutIteration = function(forceLayout2, layoutAnimation) {
    var self2 = this;
    (function step() {
      forceLayout2.step(function(stopped) {
        self2.updateLayout(self2._model);
        (self2._layouting = !stopped) && (layoutAnimation ? self2._layoutTimeout = setTimeout(step, 16) : step());
      });
    })();
  };
  GraphView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    if (!isViewCoordSys(seriesModel.coordinateSystem)) {
      controller.disable();
      return;
    }
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale();
      adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
      _this._lineDraw.updateLayout();
      api.updateLabelLayout();
    });
  };
  GraphView2.prototype._updateNodeAndLinkScale = function() {
    var seriesModel = this._model;
    var data = seriesModel.getData();
    var nodeScale = getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el && el.setSymbolScale(nodeScale);
    });
  };
  GraphView2.prototype.updateLayout = function(seriesModel) {
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    this._symbolDraw.updateLayout();
    this._lineDraw.updateLayout();
  };
  GraphView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove();
    this._lineDraw && this._lineDraw.remove();
  };
  GraphView2.type = "graph";
  return GraphView2;
}(ChartView$1);
var GraphView$1 = GraphView;
function generateNodeKey(id2) {
  return "_EC_" + id2;
}
var Graph = function() {
  function Graph2(directed) {
    this.type = "graph";
    this.nodes = [];
    this.edges = [];
    this._nodesMap = {};
    this._edgesMap = {};
    this._directed = directed || false;
  }
  Graph2.prototype.isDirected = function() {
    return this._directed;
  };
  Graph2.prototype.addNode = function(id2, dataIndex) {
    id2 = id2 == null ? "" + dataIndex : "" + id2;
    var nodesMap = this._nodesMap;
    if (nodesMap[generateNodeKey(id2)]) {
      return;
    }
    var node = new GraphNode(id2, dataIndex);
    node.hostGraph = this;
    this.nodes.push(node);
    nodesMap[generateNodeKey(id2)] = node;
    return node;
  };
  Graph2.prototype.getNodeByIndex = function(dataIndex) {
    var rawIdx = this.data.getRawIndex(dataIndex);
    return this.nodes[rawIdx];
  };
  Graph2.prototype.getNodeById = function(id2) {
    return this._nodesMap[generateNodeKey(id2)];
  };
  Graph2.prototype.addEdge = function(n1, n2, dataIndex) {
    var nodesMap = this._nodesMap;
    var edgesMap = this._edgesMap;
    if (isNumber(n1)) {
      n1 = this.nodes[n1];
    }
    if (isNumber(n2)) {
      n2 = this.nodes[n2];
    }
    if (!(n1 instanceof GraphNode)) {
      n1 = nodesMap[generateNodeKey(n1)];
    }
    if (!(n2 instanceof GraphNode)) {
      n2 = nodesMap[generateNodeKey(n2)];
    }
    if (!n1 || !n2) {
      return;
    }
    var key = n1.id + "-" + n2.id;
    var edge = new GraphEdge(n1, n2, dataIndex);
    edge.hostGraph = this;
    if (this._directed) {
      n1.outEdges.push(edge);
      n2.inEdges.push(edge);
    }
    n1.edges.push(edge);
    if (n1 !== n2) {
      n2.edges.push(edge);
    }
    this.edges.push(edge);
    edgesMap[key] = edge;
    return edge;
  };
  Graph2.prototype.getEdgeByIndex = function(dataIndex) {
    var rawIdx = this.edgeData.getRawIndex(dataIndex);
    return this.edges[rawIdx];
  };
  Graph2.prototype.getEdge = function(n1, n2) {
    if (n1 instanceof GraphNode) {
      n1 = n1.id;
    }
    if (n2 instanceof GraphNode) {
      n2 = n2.id;
    }
    var edgesMap = this._edgesMap;
    if (this._directed) {
      return edgesMap[n1 + "-" + n2];
    } else {
      return edgesMap[n1 + "-" + n2] || edgesMap[n2 + "-" + n1];
    }
  };
  Graph2.prototype.eachNode = function(cb, context) {
    var nodes = this.nodes;
    var len2 = nodes.length;
    for (var i = 0; i < len2; i++) {
      if (nodes[i].dataIndex >= 0) {
        cb.call(context, nodes[i], i);
      }
    }
  };
  Graph2.prototype.eachEdge = function(cb, context) {
    var edges = this.edges;
    var len2 = edges.length;
    for (var i = 0; i < len2; i++) {
      if (edges[i].dataIndex >= 0 && edges[i].node1.dataIndex >= 0 && edges[i].node2.dataIndex >= 0) {
        cb.call(context, edges[i], i);
      }
    }
  };
  Graph2.prototype.breadthFirstTraverse = function(cb, startNode, direction, context) {
    if (!(startNode instanceof GraphNode)) {
      startNode = this._nodesMap[generateNodeKey(startNode)];
    }
    if (!startNode) {
      return;
    }
    var edgeType = direction === "out" ? "outEdges" : direction === "in" ? "inEdges" : "edges";
    for (var i = 0; i < this.nodes.length; i++) {
      this.nodes[i].__visited = false;
    }
    if (cb.call(context, startNode, null)) {
      return;
    }
    var queue = [startNode];
    while (queue.length) {
      var currentNode = queue.shift();
      var edges = currentNode[edgeType];
      for (var i = 0; i < edges.length; i++) {
        var e2 = edges[i];
        var otherNode = e2.node1 === currentNode ? e2.node2 : e2.node1;
        if (!otherNode.__visited) {
          if (cb.call(context, otherNode, currentNode)) {
            return;
          }
          queue.push(otherNode);
          otherNode.__visited = true;
        }
      }
    }
  };
  Graph2.prototype.update = function() {
    var data = this.data;
    var edgeData = this.edgeData;
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
    edgeData.filterSelf(function(idx) {
      var edge = edges[edgeData.getRawIndex(idx)];
      return edge.node1.dataIndex >= 0 && edge.node2.dataIndex >= 0;
    });
    for (var i = 0, len2 = edges.length; i < len2; i++) {
      edges[i].dataIndex = -1;
    }
    for (var i = 0, len2 = edgeData.count(); i < len2; i++) {
      edges[edgeData.getRawIndex(i)].dataIndex = i;
    }
  };
  Graph2.prototype.clone = function() {
    var graph = new Graph2(this._directed);
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0; i < nodes.length; i++) {
      graph.addNode(nodes[i].id, nodes[i].dataIndex);
    }
    for (var i = 0; i < edges.length; i++) {
      var e2 = edges[i];
      graph.addEdge(e2.node1.id, e2.node2.id, e2.dataIndex);
    }
    return graph;
  };
  return Graph2;
}();
var GraphNode = function() {
  function GraphNode2(id2, dataIndex) {
    this.inEdges = [];
    this.outEdges = [];
    this.edges = [];
    this.dataIndex = -1;
    this.id = id2 == null ? "" : id2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphNode2.prototype.degree = function() {
    return this.edges.length;
  };
  GraphNode2.prototype.inDegree = function() {
    return this.inEdges.length;
  };
  GraphNode2.prototype.outDegree = function() {
    return this.outEdges.length;
  };
  GraphNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphNode2.prototype.getAdjacentDataIndices = function() {
    var dataIndices = {
      edge: [],
      node: []
    };
    for (var i = 0; i < this.edges.length; i++) {
      var adjacentEdge = this.edges[i];
      if (adjacentEdge.dataIndex < 0) {
        continue;
      }
      dataIndices.edge.push(adjacentEdge.dataIndex);
      dataIndices.node.push(adjacentEdge.node1.dataIndex, adjacentEdge.node2.dataIndex);
    }
    return dataIndices;
  };
  return GraphNode2;
}();
var GraphEdge = function() {
  function GraphEdge2(n1, n2, dataIndex) {
    this.dataIndex = -1;
    this.node1 = n1;
    this.node2 = n2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphEdge2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.edgeData.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphEdge2.prototype.getAdjacentDataIndices = function() {
    return {
      edge: [this.dataIndex],
      node: [this.node1.dataIndex, this.node2.dataIndex]
    };
  };
  return GraphEdge2;
}();
function createGraphDataProxyMixin(hostName, dataName) {
  return {
    getValue: function(dimension) {
      var data = this[hostName][dataName];
      return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
    },
    setVisual: function(key, value) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemVisual(this.dataIndex, key, value);
    },
    getVisual: function(key) {
      return this[hostName][dataName].getItemVisual(this.dataIndex, key);
    },
    setLayout: function(layout2, merge2) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemLayout(this.dataIndex, layout2, merge2);
    },
    getLayout: function() {
      return this[hostName][dataName].getItemLayout(this.dataIndex);
    },
    getGraphicEl: function() {
      return this[hostName][dataName].getItemGraphicEl(this.dataIndex);
    },
    getRawIndex: function() {
      return this[hostName][dataName].getRawIndex(this.dataIndex);
    }
  };
}
mixin(GraphNode, createGraphDataProxyMixin("hostGraph", "data"));
mixin(GraphEdge, createGraphDataProxyMixin("hostGraph", "edgeData"));
var Graph$1 = Graph;
function createGraphFromNodeEdge(nodes, edges, seriesModel, directed, beforeLink) {
  var graph = new Graph$1(directed);
  for (var i = 0; i < nodes.length; i++) {
    graph.addNode(retrieve(nodes[i].id, nodes[i].name, i), i);
  }
  var linkNameList = [];
  var validEdges = [];
  var linkCount = 0;
  for (var i = 0; i < edges.length; i++) {
    var link = edges[i];
    var source = link.source;
    var target = link.target;
    if (graph.addEdge(source, target, linkCount)) {
      validEdges.push(link);
      linkNameList.push(retrieve(convertOptionIdName(link.id, null), source + " > " + target));
      linkCount++;
    }
  }
  var coordSys = seriesModel.get("coordinateSystem");
  var nodeData;
  if (coordSys === "cartesian2d" || coordSys === "polar") {
    nodeData = createSeriesData(nodes, seriesModel);
  } else {
    var coordSysCtor = CoordinateSystem.get(coordSys);
    var coordDimensions = coordSysCtor ? coordSysCtor.dimensions || [] : [];
    if (indexOf(coordDimensions, "value") < 0) {
      coordDimensions.concat(["value"]);
    }
    var dimensions = prepareSeriesDataSchema(nodes, {
      coordDimensions,
      encodeDefine: seriesModel.getEncode()
    }).dimensions;
    nodeData = new SeriesData$1(dimensions, seriesModel);
    nodeData.initData(nodes);
  }
  var edgeData = new SeriesData$1(["value"], seriesModel);
  edgeData.initData(validEdges, linkNameList);
  beforeLink && beforeLink(nodeData, edgeData);
  linkSeriesData({
    mainData: nodeData,
    struct: graph,
    structAttr: "graph",
    datas: {
      node: nodeData,
      edge: edgeData
    },
    datasAttr: {
      node: "data",
      edge: "edgeData"
    }
  });
  graph.update();
  return graph;
}
var GraphSeriesModel = function(_super) {
  __extends(GraphSeriesModel2, _super);
  function GraphSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  GraphSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    var self2 = this;
    function getCategoriesData() {
      return self2._categoriesData;
    }
    this.legendVisualProvider = new LegendVisualProvider$1(getCategoriesData, getCategoriesData);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeDefaultAndTheme = function(option) {
    _super.prototype.mergeDefaultAndTheme.apply(this, arguments);
    defaultEmphasis(option, "edgeLabel", ["show"]);
  };
  GraphSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var edges = option.edges || option.links || [];
    var nodes = option.data || option.nodes || [];
    var self2 = this;
    if (nodes && edges) {
      initCurvenessList(this);
      var graph = createGraphFromNodeEdge(nodes, edges, this, true, beforeLink);
      each$f(graph.edges, function(edge) {
        createEdgeMapForCurveness(edge.node1, edge.node2, this, edge.dataIndex);
      }, this);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model) {
        var categoriesModels = self2._categoriesModels;
        var categoryIdx = model.getShallow("category");
        var categoryModel = categoriesModels[categoryIdx];
        if (categoryModel) {
          categoryModel.parentModel = model.parentModel;
          model.parentModel = categoryModel;
        }
        return model;
      });
      var oldGetModel = Model$1.prototype.getModel;
      function newGetModel(path, parentModel) {
        var model = oldGetModel.call(this, path, parentModel);
        model.resolveParentPath = resolveParentPath;
        return model;
      }
      edgeData.wrapMethod("getItemModel", function(model) {
        model.resolveParentPath = resolveParentPath;
        model.getModel = newGetModel;
        return model;
      });
      function resolveParentPath(pathArr) {
        if (pathArr && (pathArr[0] === "label" || pathArr[1] === "label")) {
          var newPathArr = pathArr.slice();
          if (pathArr[0] === "label") {
            newPathArr[0] = "edgeLabel";
          } else if (pathArr[1] === "label") {
            newPathArr[1] = "edgeLabel";
          }
          return newPathArr;
        }
        return pathArr;
      }
    }
  };
  GraphSeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  GraphSeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  GraphSeriesModel2.prototype.getCategoriesData = function() {
    return this._categoriesData;
  };
  GraphSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    if (dataType === "edge") {
      var nodeData = this.getData();
      var params = this.getDataParams(dataIndex, dataType);
      var edge = nodeData.graph.getEdgeByIndex(dataIndex);
      var sourceName = nodeData.getName(edge.node1.dataIndex);
      var targetName = nodeData.getName(edge.node2.dataIndex);
      var nameArr = [];
      sourceName != null && nameArr.push(sourceName);
      targetName != null && nameArr.push(targetName);
      return createTooltipMarkup("nameValue", {
        name: nameArr.join(" > "),
        value: params.value,
        noValue: params.value == null
      });
    }
    var nodeMarkup = defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
    return nodeMarkup;
  };
  GraphSeriesModel2.prototype._updateCategoriesData = function() {
    var categories = map$1(this.option.categories || [], function(category) {
      return category.value != null ? category : extend({
        value: 0
      }, category);
    });
    var categoriesData = new SeriesData$1(["value"], this);
    categoriesData.initData(categories);
    this._categoriesData = categoriesData;
    this._categoriesModels = categoriesData.mapArray(function(idx) {
      return categoriesData.getItemModel(idx);
    });
  };
  GraphSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GraphSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GraphSeriesModel2.prototype.isAnimationEnabled = function() {
    return _super.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
  };
  GraphSeriesModel2.type = "series.graph";
  GraphSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  GraphSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    legendHoverLink: true,
    layout: null,
    circular: {
      rotateLabel: false
    },
    force: {
      initLayout: null,
      repulsion: [0, 50],
      gravity: 0.1,
      friction: 0.6,
      edgeLength: 30,
      layoutAnimation: true
    },
    left: "center",
    top: "center",
    symbol: "circle",
    symbolSize: 10,
    edgeSymbol: ["none", "none"],
    edgeSymbolSize: 10,
    edgeLabel: {
      position: "middle",
      distance: 5
    },
    draggable: false,
    roam: false,
    center: null,
    zoom: 1,
    nodeScaleRatio: 0.6,
    label: {
      show: false,
      formatter: "{b}"
    },
    itemStyle: {},
    lineStyle: {
      color: "#aaa",
      width: 1,
      opacity: 0.5
    },
    emphasis: {
      scale: true,
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return GraphSeriesModel2;
}(SeriesModel$1);
var GraphSeriesModel$1 = GraphSeriesModel;
var actionInfo$1 = {
  type: "graphRoam",
  event: "graphRoam",
  update: "none"
};
function install$F(registers) {
  registers.registerChartView(GraphView$1);
  registers.registerSeriesModel(GraphSeriesModel$1);
  registers.registerProcessor(categoryFilter);
  registers.registerVisual(categoryVisual);
  registers.registerVisual(graphEdgeVisual);
  registers.registerLayout(graphSimpleLayout);
  registers.registerLayout(registers.PRIORITY.VISUAL.POST_CHART_LAYOUT, graphCircularLayout);
  registers.registerLayout(graphForceLayout);
  registers.registerCoordinateSystem("graphView", {
    dimensions: View$1.dimensions,
    create: createViewCoordSys
  });
  registers.registerAction({
    type: "focusNodeAdjacency",
    event: "focusNodeAdjacency",
    update: "series:focusNodeAdjacency"
  }, noop);
  registers.registerAction({
    type: "unfocusNodeAdjacency",
    event: "unfocusNodeAdjacency",
    update: "series:unfocusNodeAdjacency"
  }, noop);
  registers.registerAction(actionInfo$1, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
var PointerShape = function() {
  function PointerShape2() {
    this.angle = 0;
    this.width = 10;
    this.r = 10;
    this.x = 0;
    this.y = 0;
  }
  return PointerShape2;
}();
var PointerPath = function(_super) {
  __extends(PointerPath2, _super);
  function PointerPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "pointer";
    return _this;
  }
  PointerPath2.prototype.getDefaultShape = function() {
    return new PointerShape();
  };
  PointerPath2.prototype.buildPath = function(ctx, shape) {
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var r2 = shape.r;
    var width = shape.width;
    var angle = shape.angle;
    var x2 = shape.x - mathCos2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    var y2 = shape.y - mathSin2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    angle = shape.angle - Math.PI / 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(shape.x + mathCos2(angle) * width, shape.y + mathSin2(angle) * width);
    ctx.lineTo(shape.x + mathCos2(shape.angle) * r2, shape.y + mathSin2(shape.angle) * r2);
    ctx.lineTo(shape.x - mathCos2(angle) * width, shape.y - mathSin2(angle) * width);
    ctx.lineTo(x2, y2);
  };
  return PointerPath2;
}(Path$1);
var PointerPath$1 = PointerPath;
function parsePosition(seriesModel, api) {
  var center2 = seriesModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], api.getWidth());
  var cy = parsePercent(center2[1], api.getHeight());
  var r2 = parsePercent(seriesModel.get("radius"), size / 2);
  return {
    cx,
    cy,
    r: r2
  };
}
function formatLabel(value, labelFormatter) {
  var label = value == null ? "" : value + "";
  if (labelFormatter) {
    if (isString(labelFormatter)) {
      label = labelFormatter.replace("{value}", label);
    } else if (isFunction(labelFormatter)) {
      label = labelFormatter(value);
    }
  }
  return label;
}
var PI2 = Math.PI * 2;
var GaugeView = function(_super) {
  __extends(GaugeView2, _super);
  function GaugeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeView2.type;
    return _this;
  }
  GaugeView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeAll();
    var colorList = seriesModel.get(["axisLine", "lineStyle", "color"]);
    var posInfo = parsePosition(seriesModel, api);
    this._renderMain(seriesModel, ecModel, api, colorList, posInfo);
    this._data = seriesModel.getData();
  };
  GaugeView2.prototype.dispose = function() {
  };
  GaugeView2.prototype._renderMain = function(seriesModel, ecModel, api, colorList, posInfo) {
    var group = this.group;
    var clockwise = seriesModel.get("clockwise");
    var startAngle = -seriesModel.get("startAngle") / 180 * Math.PI;
    var endAngle = -seriesModel.get("endAngle") / 180 * Math.PI;
    var axisLineModel = seriesModel.getModel("axisLine");
    var roundCap = axisLineModel.get("roundCap");
    var MainPath = roundCap ? Sausage : Sector$1;
    var showAxis = axisLineModel.get("show");
    var lineStyleModel = axisLineModel.getModel("lineStyle");
    var axisLineWidth = lineStyleModel.get("width");
    var angleRangeSpan = !((endAngle - startAngle) % PI2) && endAngle !== startAngle ? PI2 : (endAngle - startAngle) % PI2;
    var prevEndAngle = startAngle;
    for (var i = 0; showAxis && i < colorList.length; i++) {
      var percent = Math.min(Math.max(colorList[i][0], 0), 1);
      endAngle = startAngle + angleRangeSpan * percent;
      var sector = new MainPath({
        shape: {
          startAngle: prevEndAngle,
          endAngle,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0: posInfo.r - axisLineWidth,
          r: posInfo.r
        },
        silent: true
      });
      sector.setStyle({
        fill: colorList[i][1]
      });
      sector.setStyle(lineStyleModel.getLineStyle(["color", "width"]));
      group.add(sector);
      prevEndAngle = endAngle;
    }
    var getColor = function(percent2) {
      if (percent2 <= 0) {
        return colorList[0][1];
      }
      var i2;
      for (i2 = 0; i2 < colorList.length; i2++) {
        if (colorList[i2][0] >= percent2 && (i2 === 0 ? 0 : colorList[i2 - 1][0]) < percent2) {
          return colorList[i2][1];
        }
      }
      return colorList[i2 - 1][1];
    };
    if (!clockwise) {
      var tmp = startAngle;
      startAngle = endAngle;
      endAngle = tmp;
    }
    this._renderTicks(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
    this._renderTitleAndDetail(seriesModel, ecModel, api, getColor, posInfo);
    this._renderAnchor(seriesModel, posInfo);
    this._renderPointer(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
  };
  GaugeView2.prototype._renderTicks = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var cx = posInfo.cx;
    var cy = posInfo.cy;
    var r2 = posInfo.r;
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var splitLineModel = seriesModel.getModel("splitLine");
    var tickModel = seriesModel.getModel("axisTick");
    var labelModel = seriesModel.getModel("axisLabel");
    var splitNumber = seriesModel.get("splitNumber");
    var subSplitNumber = tickModel.get("splitNumber");
    var splitLineLen = parsePercent(splitLineModel.get("length"), r2);
    var tickLen = parsePercent(tickModel.get("length"), r2);
    var angle = startAngle;
    var step = (endAngle - startAngle) / splitNumber;
    var subStep = step / subSplitNumber;
    var splitLineStyle = splitLineModel.getModel("lineStyle").getLineStyle();
    var tickLineStyle = tickModel.getModel("lineStyle").getLineStyle();
    var splitLineDistance = splitLineModel.get("distance");
    var unitX;
    var unitY;
    for (var i = 0; i <= splitNumber; i++) {
      unitX = Math.cos(angle);
      unitY = Math.sin(angle);
      if (splitLineModel.get("show")) {
        var distance2 = splitLineDistance ? splitLineDistance + axisLineWidth : axisLineWidth;
        var splitLine = new Line$3({
          shape: {
            x1: unitX * (r2 - distance2) + cx,
            y1: unitY * (r2 - distance2) + cy,
            x2: unitX * (r2 - splitLineLen - distance2) + cx,
            y2: unitY * (r2 - splitLineLen - distance2) + cy
          },
          style: splitLineStyle,
          silent: true
        });
        if (splitLineStyle.stroke === "auto") {
          splitLine.setStyle({
            stroke: getColor(i / splitNumber)
          });
        }
        group.add(splitLine);
      }
      if (labelModel.get("show")) {
        var distance2 = labelModel.get("distance") + splitLineDistance;
        var label = formatLabel(round$3(i / splitNumber * (maxVal - minVal) + minVal), labelModel.get("formatter"));
        var autoColor = getColor(i / splitNumber);
        group.add(new ZRText$1({
          style: createTextStyle(labelModel, {
            text: label,
            x: unitX * (r2 - splitLineLen - distance2) + cx,
            y: unitY * (r2 - splitLineLen - distance2) + cy,
            verticalAlign: unitY < -0.8 ? "top" : unitY > 0.8 ? "bottom" : "middle",
            align: unitX < -0.4 ? "left" : unitX > 0.4 ? "right" : "center"
          }, {
            inheritColor: autoColor
          }),
          silent: true
        }));
      }
      if (tickModel.get("show") && i !== splitNumber) {
        var distance2 = tickModel.get("distance");
        distance2 = distance2 ? distance2 + axisLineWidth : axisLineWidth;
        for (var j = 0; j <= subSplitNumber; j++) {
          unitX = Math.cos(angle);
          unitY = Math.sin(angle);
          var tickLine = new Line$3({
            shape: {
              x1: unitX * (r2 - distance2) + cx,
              y1: unitY * (r2 - distance2) + cy,
              x2: unitX * (r2 - tickLen - distance2) + cx,
              y2: unitY * (r2 - tickLen - distance2) + cy
            },
            silent: true,
            style: tickLineStyle
          });
          if (tickLineStyle.stroke === "auto") {
            tickLine.setStyle({
              stroke: getColor((i + j / subSplitNumber) / splitNumber)
            });
          }
          group.add(tickLine);
          angle += subStep;
        }
        angle -= subStep;
      } else {
        angle += step;
      }
    }
  };
  GaugeView2.prototype._renderPointer = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var oldData = this._data;
    var oldProgressData = this._progressEls;
    var progressList = [];
    var showPointer2 = seriesModel.get(["pointer", "show"]);
    var progressModel = seriesModel.getModel("progress");
    var showProgress = progressModel.get("show");
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var valueExtent = [minVal, maxVal];
    var angleExtent = [startAngle, endAngle];
    function createPointer(idx, angle) {
      var itemModel = data.getItemModel(idx);
      var pointerModel = itemModel.getModel("pointer");
      var pointerWidth = parsePercent(pointerModel.get("width"), posInfo.r);
      var pointerLength = parsePercent(pointerModel.get("length"), posInfo.r);
      var pointerStr = seriesModel.get(["pointer", "icon"]);
      var pointerOffset = pointerModel.get("offsetCenter");
      var pointerOffsetX = parsePercent(pointerOffset[0], posInfo.r);
      var pointerOffsetY = parsePercent(pointerOffset[1], posInfo.r);
      var pointerKeepAspect = pointerModel.get("keepAspect");
      var pointer;
      if (pointerStr) {
        pointer = createSymbol$1(pointerStr, pointerOffsetX - pointerWidth / 2, pointerOffsetY - pointerLength, pointerWidth, pointerLength, null, pointerKeepAspect);
      } else {
        pointer = new PointerPath$1({
          shape: {
            angle: -Math.PI / 2,
            width: pointerWidth,
            r: pointerLength,
            x: pointerOffsetX,
            y: pointerOffsetY
          }
        });
      }
      pointer.rotation = -(angle + Math.PI / 2);
      pointer.x = posInfo.cx;
      pointer.y = posInfo.cy;
      return pointer;
    }
    function createProgress(idx, endAngle2) {
      var roundCap = progressModel.get("roundCap");
      var ProgressPath = roundCap ? Sausage : Sector$1;
      var isOverlap = progressModel.get("overlap");
      var progressWidth = isOverlap ? progressModel.get("width") : axisLineWidth / data.count();
      var r0 = isOverlap ? posInfo.r - progressWidth : posInfo.r - (idx + 1) * progressWidth;
      var r2 = isOverlap ? posInfo.r : posInfo.r - idx * progressWidth;
      var progress = new ProgressPath({
        shape: {
          startAngle,
          endAngle: endAngle2,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0,
          r: r2
        }
      });
      isOverlap && (progress.z2 = maxVal - data.get(valueDim, idx) % maxVal);
      return progress;
    }
    if (showProgress || showPointer2) {
      data.diff(oldData).add(function(idx) {
        var val = data.get(valueDim, idx);
        if (showPointer2) {
          var pointer = createPointer(idx, startAngle);
          initProps(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(idx, pointer);
        }
        if (showProgress) {
          var progress = createProgress(idx, startAngle);
          var isClip = progressModel.get("clip");
          initProps(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, idx, progress);
          progressList[idx] = progress;
        }
      }).update(function(newIdx, oldIdx) {
        var val = data.get(valueDim, newIdx);
        if (showPointer2) {
          var previousPointer = oldData.getItemGraphicEl(oldIdx);
          var previousRotate = previousPointer ? previousPointer.rotation : startAngle;
          var pointer = createPointer(newIdx, previousRotate);
          pointer.rotation = previousRotate;
          updateProps$1(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(newIdx, pointer);
        }
        if (showProgress) {
          var previousProgress = oldProgressData[oldIdx];
          var previousEndAngle = previousProgress ? previousProgress.shape.endAngle : startAngle;
          var progress = createProgress(newIdx, previousEndAngle);
          var isClip = progressModel.get("clip");
          updateProps$1(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, newIdx, progress);
          progressList[newIdx] = progress;
        }
      }).execute();
      data.each(function(idx) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel = itemModel.getModel("emphasis");
        var focus = emphasisModel.get("focus");
        var blurScope = emphasisModel.get("blurScope");
        var emphasisDisabled = emphasisModel.get("disabled");
        if (showPointer2) {
          var pointer = data.getItemGraphicEl(idx);
          var symbolStyle = data.getItemVisual(idx, "style");
          var visualColor = symbolStyle.fill;
          if (pointer instanceof ZRImage$1) {
            var pathStyle = pointer.style;
            pointer.useStyle(extend({
              image: pathStyle.image,
              x: pathStyle.x,
              y: pathStyle.y,
              width: pathStyle.width,
              height: pathStyle.height
            }, symbolStyle));
          } else {
            pointer.useStyle(symbolStyle);
            pointer.type !== "pointer" && pointer.setColor(visualColor);
          }
          pointer.setStyle(itemModel.getModel(["pointer", "itemStyle"]).getItemStyle());
          if (pointer.style.fill === "auto") {
            pointer.setStyle("fill", getColor(linearMap$2(data.get(valueDim, idx), valueExtent, [0, 1], true)));
          }
          pointer.z2EmphasisLift = 0;
          setStatesStylesFromModel(pointer, itemModel);
          toggleHoverEmphasis(pointer, focus, blurScope, emphasisDisabled);
        }
        if (showProgress) {
          var progress = progressList[idx];
          progress.useStyle(data.getItemVisual(idx, "style"));
          progress.setStyle(itemModel.getModel(["progress", "itemStyle"]).getItemStyle());
          progress.z2EmphasisLift = 0;
          setStatesStylesFromModel(progress, itemModel);
          toggleHoverEmphasis(progress, focus, blurScope, emphasisDisabled);
        }
      });
      this._progressEls = progressList;
    }
  };
  GaugeView2.prototype._renderAnchor = function(seriesModel, posInfo) {
    var anchorModel = seriesModel.getModel("anchor");
    var showAnchor = anchorModel.get("show");
    if (showAnchor) {
      var anchorSize = anchorModel.get("size");
      var anchorType = anchorModel.get("icon");
      var offsetCenter = anchorModel.get("offsetCenter");
      var anchorKeepAspect = anchorModel.get("keepAspect");
      var anchor = createSymbol$1(anchorType, posInfo.cx - anchorSize / 2 + parsePercent(offsetCenter[0], posInfo.r), posInfo.cy - anchorSize / 2 + parsePercent(offsetCenter[1], posInfo.r), anchorSize, anchorSize, null, anchorKeepAspect);
      anchor.z2 = anchorModel.get("showAbove") ? 1 : 0;
      anchor.setStyle(anchorModel.getModel("itemStyle").getItemStyle());
      this.group.add(anchor);
    }
  };
  GaugeView2.prototype._renderTitleAndDetail = function(seriesModel, ecModel, api, getColor, posInfo) {
    var _this = this;
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var contentGroup = new Group$4();
    var newTitleEls = [];
    var newDetailEls = [];
    var hasAnimation = seriesModel.isAnimationEnabled();
    var showPointerAbove = seriesModel.get(["pointer", "showAbove"]);
    data.diff(this._data).add(function(idx) {
      newTitleEls[idx] = new ZRText$1({
        silent: true
      });
      newDetailEls[idx] = new ZRText$1({
        silent: true
      });
    }).update(function(idx, oldIdx) {
      newTitleEls[idx] = _this._titleEls[oldIdx];
      newDetailEls[idx] = _this._detailEls[oldIdx];
    }).execute();
    data.each(function(idx) {
      var itemModel = data.getItemModel(idx);
      var value = data.get(valueDim, idx);
      var itemGroup = new Group$4();
      var autoColor = getColor(linearMap$2(value, [minVal, maxVal], [0, 1], true));
      var itemTitleModel = itemModel.getModel("title");
      if (itemTitleModel.get("show")) {
        var titleOffsetCenter = itemTitleModel.get("offsetCenter");
        var titleX = posInfo.cx + parsePercent(titleOffsetCenter[0], posInfo.r);
        var titleY = posInfo.cy + parsePercent(titleOffsetCenter[1], posInfo.r);
        var labelEl = newTitleEls[idx];
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemTitleModel, {
            x: titleX,
            y: titleY,
            text: data.getName(idx),
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: autoColor
          })
        });
        itemGroup.add(labelEl);
      }
      var itemDetailModel = itemModel.getModel("detail");
      if (itemDetailModel.get("show")) {
        var detailOffsetCenter = itemDetailModel.get("offsetCenter");
        var detailX = posInfo.cx + parsePercent(detailOffsetCenter[0], posInfo.r);
        var detailY = posInfo.cy + parsePercent(detailOffsetCenter[1], posInfo.r);
        var width = parsePercent(itemDetailModel.get("width"), posInfo.r);
        var height = parsePercent(itemDetailModel.get("height"), posInfo.r);
        var detailColor = seriesModel.get(["progress", "show"]) ? data.getItemVisual(idx, "style").fill : autoColor;
        var labelEl = newDetailEls[idx];
        var formatter_1 = itemDetailModel.get("formatter");
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemDetailModel, {
            x: detailX,
            y: detailY,
            text: formatLabel(value, formatter_1),
            width: isNaN(width) ? null : width,
            height: isNaN(height) ? null : height,
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: detailColor
          })
        });
        setLabelValueAnimation(labelEl, {
          normal: itemDetailModel
        }, value, function(value2) {
          return formatLabel(value2, formatter_1);
        });
        hasAnimation && animateLabelValue(labelEl, idx, data, seriesModel, {
          getFormattedLabel: function(labelDataIndex, status, dataType, labelDimIndex, fmt, extendParams) {
            return formatLabel(extendParams ? extendParams.interpolatedValue : value, formatter_1);
          }
        });
        itemGroup.add(labelEl);
      }
      contentGroup.add(itemGroup);
    });
    this.group.add(contentGroup);
    this._titleEls = newTitleEls;
    this._detailEls = newDetailEls;
  };
  GaugeView2.type = "gauge";
  return GaugeView2;
}(ChartView$1);
var GaugeView$1 = GaugeView;
var GaugeSeriesModel = function(_super) {
  __extends(GaugeSeriesModel2, _super);
  function GaugeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeSeriesModel2.type;
    _this.visualStyleAccessPath = "itemStyle";
    return _this;
  }
  GaugeSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, ["value"]);
  };
  GaugeSeriesModel2.type = "series.gauge";
  GaugeSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    center: ["50%", "50%"],
    legendHoverLink: true,
    radius: "75%",
    startAngle: 225,
    endAngle: -45,
    clockwise: true,
    min: 0,
    max: 100,
    splitNumber: 10,
    axisLine: {
      show: true,
      roundCap: false,
      lineStyle: {
        color: [[1, "#E6EBF8"]],
        width: 10
      }
    },
    progress: {
      show: false,
      overlap: true,
      width: 10,
      roundCap: false,
      clip: true
    },
    splitLine: {
      show: true,
      length: 10,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 3,
        type: "solid"
      }
    },
    axisTick: {
      show: true,
      splitNumber: 5,
      length: 6,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 1,
        type: "solid"
      }
    },
    axisLabel: {
      show: true,
      distance: 15,
      color: "#464646",
      fontSize: 12
    },
    pointer: {
      icon: null,
      offsetCenter: [0, 0],
      show: true,
      showAbove: true,
      length: "60%",
      width: 6,
      keepAspect: false
    },
    anchor: {
      show: false,
      showAbove: false,
      size: 6,
      icon: "circle",
      offsetCenter: [0, 0],
      keepAspect: false,
      itemStyle: {
        color: "#fff",
        borderWidth: 0,
        borderColor: "#5470c6"
      }
    },
    title: {
      show: true,
      offsetCenter: [0, "20%"],
      color: "#464646",
      fontSize: 16,
      valueAnimation: false
    },
    detail: {
      show: true,
      backgroundColor: "rgba(0,0,0,0)",
      borderWidth: 0,
      borderColor: "#ccc",
      width: 100,
      height: null,
      padding: [5, 10],
      offsetCenter: [0, "40%"],
      color: "#464646",
      fontSize: 30,
      fontWeight: "bold",
      lineHeight: 30,
      valueAnimation: false
    }
  };
  return GaugeSeriesModel2;
}(SeriesModel$1);
var GaugeSeriesModel$1 = GaugeSeriesModel;
function install$E(registers) {
  registers.registerChartView(GaugeView$1);
  registers.registerSeriesModel(GaugeSeriesModel$1);
}
var opacityAccessPath$1 = ["itemStyle", "opacity"];
var FunnelPiece = function(_super) {
  __extends(FunnelPiece2, _super);
  function FunnelPiece2(data, idx) {
    var _this = _super.call(this) || this;
    var polygon = _this;
    var labelLine = new Polyline$3();
    var text = new ZRText$1();
    polygon.setTextContent(text);
    _this.setTextGuideLine(labelLine);
    _this.updateData(data, idx, true);
    return _this;
  }
  FunnelPiece2.prototype.updateData = function(data, idx, firstCreate) {
    var polygon = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var opacity = itemModel.get(opacityAccessPath$1);
    opacity = opacity == null ? 1 : opacity;
    if (!firstCreate) {
      saveOldStyle(polygon);
    }
    polygon.useStyle(data.getItemVisual(idx, "style"));
    polygon.style.lineJoin = "round";
    if (firstCreate) {
      polygon.setShape({
        points: layout2.points
      });
      polygon.style.opacity = 0;
      initProps(polygon, {
        style: {
          opacity
        }
      }, seriesModel, idx);
    } else {
      updateProps$1(polygon, {
        style: {
          opacity
        },
        shape: {
          points: layout2.points
        }
      }, seriesModel, idx);
    }
    setStatesStylesFromModel(polygon, itemModel);
    this._updateLabel(data, idx);
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  FunnelPiece2.prototype._updateLabel = function(data, idx) {
    var polygon = this;
    var labelLine = this.getTextGuideLine();
    var labelText = polygon.getTextContent();
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var labelLayout2 = layout2.label;
    var style = data.getItemVisual(idx, "style");
    var visualColor = style.fill;
    setLabelStyle(labelText, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      defaultOpacity: style.opacity,
      defaultText: data.getName(idx)
    }, {
      normal: {
        align: labelLayout2.textAlign,
        verticalAlign: labelLayout2.verticalAlign
      }
    });
    polygon.setTextConfig({
      local: true,
      inside: !!labelLayout2.inside,
      insideStroke: visualColor,
      outsideFill: visualColor
    });
    var linePoints = labelLayout2.linePoints;
    labelLine.setShape({
      points: linePoints
    });
    polygon.textGuideLineConfig = {
      anchor: linePoints ? new Point$1(linePoints[0][0], linePoints[0][1]) : null
    };
    updateProps$1(labelText, {
      style: {
        x: labelLayout2.x,
        y: labelLayout2.y
      }
    }, seriesModel, idx);
    labelText.attr({
      rotation: labelLayout2.rotation,
      originX: labelLayout2.x,
      originY: labelLayout2.y,
      z2: 10
    });
    setLabelLineStyle(polygon, getLabelLineStatesModels(itemModel), {
      stroke: visualColor
    });
  };
  return FunnelPiece2;
}(Polygon$1);
var FunnelView = function(_super) {
  __extends(FunnelView2, _super);
  function FunnelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelView2.type;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  FunnelView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    data.diff(oldData).add(function(idx) {
      var funnelPiece = new FunnelPiece(data, idx);
      data.setItemGraphicEl(idx, funnelPiece);
      group.add(funnelPiece);
    }).update(function(newIdx, oldIdx) {
      var piece = oldData.getItemGraphicEl(oldIdx);
      piece.updateData(data, newIdx);
      group.add(piece);
      data.setItemGraphicEl(newIdx, piece);
    }).remove(function(idx) {
      var piece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piece, seriesModel, idx);
    }).execute();
    this._data = data;
  };
  FunnelView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  FunnelView2.prototype.dispose = function() {
  };
  FunnelView2.type = "funnel";
  return FunnelView2;
}(ChartView$1);
var FunnelView$1 = FunnelView;
var FunnelSeriesModel = function(_super) {
  __extends(FunnelSeriesModel2, _super);
  function FunnelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelSeriesModel2.type;
    return _this;
  }
  FunnelSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  FunnelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  FunnelSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  FunnelSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueDim = data.mapDimension("value");
    var sum2 = data.getSum(valueDim);
    params.percent = !sum2 ? 0 : +(data.get(valueDim, dataIndex) / sum2 * 100).toFixed(2);
    params.$vars.push("percent");
    return params;
  };
  FunnelSeriesModel2.type = "series.funnel";
  FunnelSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    minSize: "0%",
    maxSize: "100%",
    sort: "descending",
    orient: "vertical",
    gap: 0,
    funnelAlign: "center",
    label: {
      show: true,
      position: "outer"
    },
    labelLine: {
      show: true,
      length: 20,
      lineStyle: {
        width: 1
      }
    },
    itemStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return FunnelSeriesModel2;
}(SeriesModel$1);
var FunnelSeriesModel$1 = FunnelSeriesModel;
function getViewRect$2(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getSortedIndices(data, sort2) {
  var valueDim = data.mapDimension("value");
  var valueArr = data.mapArray(valueDim, function(val) {
    return val;
  });
  var indices = [];
  var isAscending = sort2 === "ascending";
  for (var i = 0, len2 = data.count(); i < len2; i++) {
    indices[i] = i;
  }
  if (isFunction(sort2)) {
    indices.sort(sort2);
  } else if (sort2 !== "none") {
    indices.sort(function(a, b2) {
      return isAscending ? valueArr[a] - valueArr[b2] : valueArr[b2] - valueArr[a];
    });
  }
  return indices;
}
function labelLayout(data) {
  var seriesModel = data.hostModel;
  var orient = seriesModel.get("orient");
  data.each(function(idx) {
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position");
    var labelLineModel = itemModel.getModel("labelLine");
    var layout2 = data.getItemLayout(idx);
    var points2 = layout2.points;
    var isLabelInside = labelPosition === "inner" || labelPosition === "inside" || labelPosition === "center" || labelPosition === "insideLeft" || labelPosition === "insideRight";
    var textAlign;
    var textX;
    var textY;
    var linePoints;
    if (isLabelInside) {
      if (labelPosition === "insideLeft") {
        textX = (points2[0][0] + points2[3][0]) / 2 + 5;
        textY = (points2[0][1] + points2[3][1]) / 2;
        textAlign = "left";
      } else if (labelPosition === "insideRight") {
        textX = (points2[1][0] + points2[2][0]) / 2 - 5;
        textY = (points2[1][1] + points2[2][1]) / 2;
        textAlign = "right";
      } else {
        textX = (points2[0][0] + points2[1][0] + points2[2][0] + points2[3][0]) / 4;
        textY = (points2[0][1] + points2[1][1] + points2[2][1] + points2[3][1]) / 4;
        textAlign = "center";
      }
      linePoints = [[textX, textY], [textX, textY]];
    } else {
      var x1 = void 0;
      var y1 = void 0;
      var x2 = void 0;
      var y2 = void 0;
      var labelLineLen = labelLineModel.get("length");
      if (labelPosition === "left") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        x2 = x1 - labelLineLen;
        textX = x2 - 5;
        textAlign = "right";
      } else if (labelPosition === "right") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        x2 = x1 + labelLineLen;
        textX = x2 + 5;
        textAlign = "left";
      } else if (labelPosition === "top") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        y2 = y1 - labelLineLen;
        textY = y2 - 5;
        textAlign = "center";
      } else if (labelPosition === "bottom") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        y2 = y1 + labelLineLen;
        textY = y2 + 5;
        textAlign = "center";
      } else if (labelPosition === "rightTop") {
        x1 = orient === "horizontal" ? points2[3][0] : points2[1][0];
        y1 = orient === "horizontal" ? points2[3][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "top";
        }
      } else if (labelPosition === "rightBottom") {
        x1 = points2[2][0];
        y1 = points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "bottom";
        }
      } else if (labelPosition === "leftTop") {
        x1 = points2[0][0];
        y1 = orient === "horizontal" ? points2[0][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else if (labelPosition === "leftBottom") {
        x1 = orient === "horizontal" ? points2[1][0] : points2[3][0];
        y1 = orient === "horizontal" ? points2[1][1] : points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "left";
        }
      }
      if (orient === "horizontal") {
        x2 = x1;
        textX = x2;
      } else {
        y2 = y1;
        textY = y2;
      }
      linePoints = [[x1, y1], [x2, y2]];
    }
    layout2.label = {
      linePoints,
      x: textX,
      y: textY,
      verticalAlign: "middle",
      textAlign,
      inside: isLabelInside
    };
  });
}
function funnelLayout(ecModel, api) {
  ecModel.eachSeriesByType("funnel", function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var sort2 = seriesModel.get("sort");
    var viewRect2 = getViewRect$2(seriesModel, api);
    var orient = seriesModel.get("orient");
    var viewWidth = viewRect2.width;
    var viewHeight = viewRect2.height;
    var indices = getSortedIndices(data, sort2);
    var x2 = viewRect2.x;
    var y2 = viewRect2.y;
    var sizeExtent = orient === "horizontal" ? [parsePercent(seriesModel.get("minSize"), viewHeight), parsePercent(seriesModel.get("maxSize"), viewHeight)] : [parsePercent(seriesModel.get("minSize"), viewWidth), parsePercent(seriesModel.get("maxSize"), viewWidth)];
    var dataExtent = data.getDataExtent(valueDim);
    var min3 = seriesModel.get("min");
    var max3 = seriesModel.get("max");
    if (min3 == null) {
      min3 = Math.min(dataExtent[0], 0);
    }
    if (max3 == null) {
      max3 = dataExtent[1];
    }
    var funnelAlign = seriesModel.get("funnelAlign");
    var gap = seriesModel.get("gap");
    var viewSize = orient === "horizontal" ? viewWidth : viewHeight;
    var itemSize = (viewSize - gap * (data.count() - 1)) / data.count();
    var getLinePoints = function(idx2, offset) {
      if (orient === "horizontal") {
        var val_1 = data.get(valueDim, idx2) || 0;
        var itemHeight = linearMap$2(val_1, [min3, max3], sizeExtent, true);
        var y0 = void 0;
        switch (funnelAlign) {
          case "top":
            y0 = y2;
            break;
          case "center":
            y0 = y2 + (viewHeight - itemHeight) / 2;
            break;
          case "bottom":
            y0 = y2 + (viewHeight - itemHeight);
            break;
        }
        return [[offset, y0], [offset, y0 + itemHeight]];
      }
      var val = data.get(valueDim, idx2) || 0;
      var itemWidth = linearMap$2(val, [min3, max3], sizeExtent, true);
      var x0;
      switch (funnelAlign) {
        case "left":
          x0 = x2;
          break;
        case "center":
          x0 = x2 + (viewWidth - itemWidth) / 2;
          break;
        case "right":
          x0 = x2 + viewWidth - itemWidth;
          break;
      }
      return [[x0, offset], [x0 + itemWidth, offset]];
    };
    if (sort2 === "ascending") {
      itemSize = -itemSize;
      gap = -gap;
      if (orient === "horizontal") {
        x2 += viewWidth;
      } else {
        y2 += viewHeight;
      }
      indices = indices.reverse();
    }
    for (var i = 0; i < indices.length; i++) {
      var idx = indices[i];
      var nextIdx = indices[i + 1];
      var itemModel = data.getItemModel(idx);
      if (orient === "horizontal") {
        var width = itemModel.get(["itemStyle", "width"]);
        if (width == null) {
          width = itemSize;
        } else {
          width = parsePercent(width, viewWidth);
          if (sort2 === "ascending") {
            width = -width;
          }
        }
        var start2 = getLinePoints(idx, x2);
        var end2 = getLinePoints(nextIdx, x2 + width);
        x2 += width + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      } else {
        var height = itemModel.get(["itemStyle", "height"]);
        if (height == null) {
          height = itemSize;
        } else {
          height = parsePercent(height, viewHeight);
          if (sort2 === "ascending") {
            height = -height;
          }
        }
        var start2 = getLinePoints(idx, y2);
        var end2 = getLinePoints(nextIdx, y2 + height);
        y2 += height + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      }
    }
    labelLayout(data);
  });
}
function install$D(registers) {
  registers.registerChartView(FunnelView$1);
  registers.registerSeriesModel(FunnelSeriesModel$1);
  registers.registerLayout(funnelLayout);
  registers.registerProcessor(dataFilter$1("funnel"));
}
var DEFAULT_SMOOTH = 0.3;
var ParallelView$2 = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    _this._dataGroup = new Group$4();
    _this._initialized = false;
    return _this;
  }
  ParallelView2.prototype.init = function() {
    this.group.add(this._dataGroup);
  };
  ParallelView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._progressiveEls = null;
    var dataGroup = this._dataGroup;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    data.diff(oldData).add(add2).update(update).remove(remove).execute();
    function add2(newDataIndex) {
      var line = addEl(data, dataGroup, newDataIndex, dimensions, coordSys);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function update(newDataIndex, oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      var points2 = createLinePoints(data, newDataIndex, dimensions, coordSys);
      data.setItemGraphicEl(newDataIndex, line);
      updateProps$1(line, {
        shape: {
          points: points2
        }
      }, seriesModel, newDataIndex);
      saveOldStyle(line);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function remove(oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      dataGroup.remove(line);
    }
    if (!this._initialized) {
      this._initialized = true;
      var clipPath = createGridClipShape$2(coordSys, seriesModel, function() {
        setTimeout(function() {
          dataGroup.removeClipPath();
        });
      });
      dataGroup.setClipPath(clipPath);
    }
    this._data = data;
  };
  ParallelView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._initialized = true;
    this._data = null;
    this._dataGroup.removeAll();
  };
  ParallelView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    var data = seriesModel.getData();
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    var progressiveEls = this._progressiveEls = [];
    for (var dataIndex = taskParams.start; dataIndex < taskParams.end; dataIndex++) {
      var line = addEl(data, this._dataGroup, dataIndex, dimensions, coordSys);
      line.incremental = true;
      updateElCommon(line, data, dataIndex, seriesScope);
      progressiveEls.push(line);
    }
  };
  ParallelView2.prototype.remove = function() {
    this._dataGroup && this._dataGroup.removeAll();
    this._data = null;
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ChartView$1);
function createGridClipShape$2(coordSys, seriesModel, cb) {
  var parallelModel = coordSys.model;
  var rect = coordSys.getRect();
  var rectEl = new Rect$3({
    shape: {
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    }
  });
  var dim = parallelModel.get("layout") === "horizontal" ? "width" : "height";
  rectEl.setShape(dim, 0);
  initProps(rectEl, {
    shape: {
      width: rect.width,
      height: rect.height
    }
  }, seriesModel, cb);
  return rectEl;
}
function createLinePoints(data, dataIndex, dimensions, coordSys) {
  var points2 = [];
  for (var i = 0; i < dimensions.length; i++) {
    var dimName = dimensions[i];
    var value = data.get(data.mapDimension(dimName), dataIndex);
    if (!isEmptyValue$1(value, coordSys.getAxis(dimName).type)) {
      points2.push(coordSys.dataToPoint(value, dimName));
    }
  }
  return points2;
}
function addEl(data, dataGroup, dataIndex, dimensions, coordSys) {
  var points2 = createLinePoints(data, dataIndex, dimensions, coordSys);
  var line = new Polyline$3({
    shape: {
      points: points2
    },
    z2: 10
  });
  dataGroup.add(line);
  data.setItemGraphicEl(dataIndex, line);
  return line;
}
function makeSeriesScope(seriesModel) {
  var smooth = seriesModel.get("smooth", true);
  smooth === true && (smooth = DEFAULT_SMOOTH);
  smooth = numericToNumber(smooth);
  eqNaN(smooth) && (smooth = 0);
  return {
    smooth
  };
}
function updateElCommon(el, data, dataIndex, seriesScope) {
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.fill = null;
  el.setShape("smooth", seriesScope.smooth);
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel, "lineStyle");
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function isEmptyValue$1(val, axisType) {
  return axisType === "category" ? val == null : val == null || isNaN(val);
}
var ParallelView$3 = ParallelView$2;
var ParallelSeriesModel = function(_super) {
  __extends(ParallelSeriesModel2, _super);
  function ParallelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  ParallelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: bind$1(makeDefaultEncode, null, this)
    });
  };
  ParallelSeriesModel2.prototype.getRawIndicesByActiveState = function(activeState) {
    var coordSys = this.coordinateSystem;
    var data = this.getData();
    var indices = [];
    coordSys.eachActiveState(data, function(theActiveState, dataIndex) {
      if (activeState === theActiveState) {
        indices.push(data.getRawIndex(dataIndex));
      }
    });
    return indices;
  };
  ParallelSeriesModel2.type = "series.parallel";
  ParallelSeriesModel2.dependencies = ["parallel"];
  ParallelSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "parallel",
    parallelIndex: 0,
    label: {
      show: false
    },
    inactiveOpacity: 0.05,
    activeOpacity: 1,
    lineStyle: {
      width: 1,
      opacity: 0.45,
      type: "solid"
    },
    emphasis: {
      label: {
        show: false
      }
    },
    progressive: 500,
    smooth: false,
    animationEasing: "linear"
  };
  return ParallelSeriesModel2;
}(SeriesModel$1);
function makeDefaultEncode(seriesModel) {
  var parallelModel = seriesModel.ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
  if (!parallelModel) {
    return;
  }
  var encodeDefine = {};
  each$f(parallelModel.dimensions, function(axisDim) {
    var dataDimIndex = convertDimNameToNumber(axisDim);
    encodeDefine[axisDim] = dataDimIndex;
  });
  return encodeDefine;
}
function convertDimNameToNumber(dimName) {
  return +dimName.replace("dim", "");
}
var ParallelSeriesModel$1 = ParallelSeriesModel;
var opacityAccessPath = ["lineStyle", "opacity"];
var parallelVisual = {
  seriesType: "parallel",
  reset: function(seriesModel, ecModel) {
    var coordSys = seriesModel.coordinateSystem;
    var opacityMap = {
      normal: seriesModel.get(["lineStyle", "opacity"]),
      active: seriesModel.get("activeOpacity"),
      inactive: seriesModel.get("inactiveOpacity")
    };
    return {
      progress: function(params, data) {
        coordSys.eachActiveState(data, function(activeState, dataIndex) {
          var opacity = opacityMap[activeState];
          if (activeState === "normal" && data.hasItemOption) {
            var itemOpacity = data.getItemModel(dataIndex).get(opacityAccessPath, true);
            itemOpacity != null && (opacity = itemOpacity);
          }
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          existsStyle.opacity = opacity;
        }, params.start, params.end);
      }
    };
  }
};
var parallelVisual$1 = parallelVisual;
function parallelPreprocessor(option) {
  createParallelIfNeeded(option);
  mergeAxisOptionFromParallel(option);
}
function createParallelIfNeeded(option) {
  if (option.parallel) {
    return;
  }
  var hasParallelSeries = false;
  each$f(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "parallel") {
      hasParallelSeries = true;
    }
  });
  if (hasParallelSeries) {
    option.parallel = [{}];
  }
}
function mergeAxisOptionFromParallel(option) {
  var axes = normalizeToArray(option.parallelAxis);
  each$f(axes, function(axisOption) {
    if (!isObject$4(axisOption)) {
      return;
    }
    var parallelIndex = axisOption.parallelIndex || 0;
    var parallelOption = normalizeToArray(option.parallel)[parallelIndex];
    if (parallelOption && parallelOption.parallelAxisDefault) {
      merge(axisOption, parallelOption.parallelAxisDefault, false);
    }
  });
}
var CLICK_THRESHOLD = 5;
var ParallelView = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    return _this;
  }
  ParallelView2.prototype.render = function(parallelModel, ecModel, api) {
    this._model = parallelModel;
    this._api = api;
    if (!this._handlers) {
      this._handlers = {};
      each$f(handlers$1, function(handler, eventName) {
        api.getZr().on(eventName, this._handlers[eventName] = bind$1(handler, this));
      }, this);
    }
    createOrUpdate(this, "_throttledDispatchExpand", parallelModel.get("axisExpandRate"), "fixRate");
  };
  ParallelView2.prototype.dispose = function(ecModel, api) {
    clear$1(this, "_throttledDispatchExpand");
    each$f(this._handlers, function(handler, eventName) {
      api.getZr().off(eventName, handler);
    });
    this._handlers = null;
  };
  ParallelView2.prototype._throttledDispatchExpand = function(opt) {
    this._dispatchExpand(opt);
  };
  ParallelView2.prototype._dispatchExpand = function(opt) {
    opt && this._api.dispatchAction(extend({
      type: "parallelAxisExpand"
    }, opt));
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ComponentView$1);
var handlers$1 = {
  mousedown: function(e2) {
    if (checkTrigger(this, "click")) {
      this._mouseDownPoint = [e2.offsetX, e2.offsetY];
    }
  },
  mouseup: function(e2) {
    var mouseDownPoint = this._mouseDownPoint;
    if (checkTrigger(this, "click") && mouseDownPoint) {
      var point = [e2.offsetX, e2.offsetY];
      var dist2 = Math.pow(mouseDownPoint[0] - point[0], 2) + Math.pow(mouseDownPoint[1] - point[1], 2);
      if (dist2 > CLICK_THRESHOLD) {
        return;
      }
      var result = this._model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
      result.behavior !== "none" && this._dispatchExpand({
        axisExpandWindow: result.axisExpandWindow
      });
    }
    this._mouseDownPoint = null;
  },
  mousemove: function(e2) {
    if (this._mouseDownPoint || !checkTrigger(this, "mousemove")) {
      return;
    }
    var model = this._model;
    var result = model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
    var behavior = result.behavior;
    behavior === "jump" && this._throttledDispatchExpand.debounceNextCall(model.get("axisExpandDebounce"));
    this._throttledDispatchExpand(behavior === "none" ? null : {
      axisExpandWindow: result.axisExpandWindow,
      animation: behavior === "jump" ? null : {
        duration: 0
      }
    });
  }
};
function checkTrigger(view, triggerOn) {
  var model = view._model;
  return model.get("axisExpandable") && model.get("axisExpandTriggerOn") === triggerOn;
}
var ParallelView$1 = ParallelView;
var ParallelModel = function(_super) {
  __extends(ParallelModel2, _super);
  function ParallelModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelModel2.type;
    return _this;
  }
  ParallelModel2.prototype.init = function() {
    _super.prototype.init.apply(this, arguments);
    this.mergeOption({});
  };
  ParallelModel2.prototype.mergeOption = function(newOption) {
    var thisOption = this.option;
    newOption && merge(thisOption, newOption, true);
    this._initDimensions();
  };
  ParallelModel2.prototype.contains = function(model, ecModel) {
    var parallelIndex = model.get("parallelIndex");
    return parallelIndex != null && ecModel.getComponent("parallel", parallelIndex) === this;
  };
  ParallelModel2.prototype.setAxisExpand = function(opt) {
    each$f(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(name) {
      if (opt.hasOwnProperty(name)) {
        this.option[name] = opt[name];
      }
    }, this);
  };
  ParallelModel2.prototype._initDimensions = function() {
    var dimensions = this.dimensions = [];
    var parallelAxisIndex = this.parallelAxisIndex = [];
    var axisModels = filter(this.ecModel.queryComponents({
      mainType: "parallelAxis"
    }), function(axisModel) {
      return (axisModel.get("parallelIndex") || 0) === this.componentIndex;
    }, this);
    each$f(axisModels, function(axisModel) {
      dimensions.push("dim" + axisModel.get("dim"));
      parallelAxisIndex.push(axisModel.componentIndex);
    });
  };
  ParallelModel2.type = "parallel";
  ParallelModel2.dependencies = ["parallelAxis"];
  ParallelModel2.layoutMode = "box";
  ParallelModel2.defaultOption = {
    z: 0,
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    layout: "horizontal",
    axisExpandable: false,
    axisExpandCenter: null,
    axisExpandCount: 0,
    axisExpandWidth: 50,
    axisExpandRate: 17,
    axisExpandDebounce: 50,
    axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4],
    axisExpandTriggerOn: "click",
    parallelAxisDefault: null
  };
  return ParallelModel2;
}(ComponentModel$1);
var ParallelModel$1 = ParallelModel;
var ParallelAxis = function(_super) {
  __extends(ParallelAxis2, _super);
  function ParallelAxis2(dim, scale2, coordExtent, axisType, axisIndex) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.axisIndex = axisIndex;
    return _this;
  }
  ParallelAxis2.prototype.isHorizontal = function() {
    return this.coordinateSystem.getModel().get("layout") !== "horizontal";
  };
  return ParallelAxis2;
}(Axis$1);
var ParallelAxis$1 = ParallelAxis;
function sliderMove(delta, handleEnds, extent3, handleIndex, minSpan, maxSpan) {
  delta = delta || 0;
  var extentSpan = extent3[1] - extent3[0];
  if (minSpan != null) {
    minSpan = restrict$1(minSpan, [0, extentSpan]);
  }
  if (maxSpan != null) {
    maxSpan = Math.max(maxSpan, minSpan != null ? minSpan : 0);
  }
  if (handleIndex === "all") {
    var handleSpan = Math.abs(handleEnds[1] - handleEnds[0]);
    handleSpan = restrict$1(handleSpan, [0, extentSpan]);
    minSpan = maxSpan = restrict$1(handleSpan, [minSpan, maxSpan]);
    handleIndex = 0;
  }
  handleEnds[0] = restrict$1(handleEnds[0], extent3);
  handleEnds[1] = restrict$1(handleEnds[1], extent3);
  var originalDistSign = getSpanSign(handleEnds, handleIndex);
  handleEnds[handleIndex] += delta;
  var extentMinSpan = minSpan || 0;
  var realExtent = extent3.slice();
  originalDistSign.sign < 0 ? realExtent[0] += extentMinSpan : realExtent[1] -= extentMinSpan;
  handleEnds[handleIndex] = restrict$1(handleEnds[handleIndex], realExtent);
  var currDistSign;
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (minSpan != null && (currDistSign.sign !== originalDistSign.sign || currDistSign.span < minSpan)) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + originalDistSign.sign * minSpan;
  }
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (maxSpan != null && currDistSign.span > maxSpan) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + currDistSign.sign * maxSpan;
  }
  return handleEnds;
}
function getSpanSign(handleEnds, handleIndex) {
  var dist2 = handleEnds[handleIndex] - handleEnds[1 - handleIndex];
  return {
    span: Math.abs(dist2),
    sign: dist2 > 0 ? -1 : dist2 < 0 ? 1 : handleIndex ? -1 : 1
  };
}
function restrict$1(value, extend2) {
  return Math.min(extend2[1] != null ? extend2[1] : Infinity, Math.max(extend2[0] != null ? extend2[0] : -Infinity, value));
}
var each$a = each$f;
var mathMin$2 = Math.min;
var mathMax$2 = Math.max;
var mathFloor = Math.floor;
var mathCeil = Math.ceil;
var round = round$3;
var PI$1 = Math.PI;
var Parallel = function() {
  function Parallel2(parallelModel, ecModel, api) {
    this.type = "parallel";
    this._axesMap = createHashMap();
    this._axesLayout = {};
    this.dimensions = parallelModel.dimensions;
    this._model = parallelModel;
    this._init(parallelModel, ecModel, api);
  }
  Parallel2.prototype._init = function(parallelModel, ecModel, api) {
    var dimensions = parallelModel.dimensions;
    var parallelAxisIndex = parallelModel.parallelAxisIndex;
    each$a(dimensions, function(dim, idx) {
      var axisIndex = parallelAxisIndex[idx];
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axis = this._axesMap.set(dim, new ParallelAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisIndex));
      var isCategory2 = axis.type === "category";
      axis.onBand = isCategory2 && axisModel.get("boundaryGap");
      axis.inverse = axisModel.get("inverse");
      axisModel.axis = axis;
      axis.model = axisModel;
      axis.coordinateSystem = axisModel.coordinateSystem = this;
    }, this);
  };
  Parallel2.prototype.update = function(ecModel, api) {
    this._updateAxesFromSeries(this._model, ecModel);
  };
  Parallel2.prototype.containPoint = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var axisBase = layoutInfo.axisBase;
    var layoutBase = layoutInfo.layoutBase;
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var pAxis = point[1 - pixelDimIndex];
    var pLayout = point[pixelDimIndex];
    return pAxis >= axisBase && pAxis <= axisBase + layoutInfo.axisLength && pLayout >= layoutBase && pLayout <= layoutBase + layoutInfo.layoutLength;
  };
  Parallel2.prototype.getModel = function() {
    return this._model;
  };
  Parallel2.prototype._updateAxesFromSeries = function(parallelModel, ecModel) {
    ecModel.eachSeries(function(seriesModel) {
      if (!parallelModel.contains(seriesModel, ecModel)) {
        return;
      }
      var data = seriesModel.getData();
      each$a(this.dimensions, function(dim) {
        var axis = this._axesMap.get(dim);
        axis.scale.unionExtentFromData(data, data.mapDimension(dim));
        niceScaleExtent(axis.scale, axis.model);
      }, this);
    }, this);
  };
  Parallel2.prototype.resize = function(parallelModel, api) {
    this._rect = getLayoutRect(parallelModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._layoutAxes();
  };
  Parallel2.prototype.getRect = function() {
    return this._rect;
  };
  Parallel2.prototype._makeLayoutInfo = function() {
    var parallelModel = this._model;
    var rect = this._rect;
    var xy = ["x", "y"];
    var wh = ["width", "height"];
    var layout2 = parallelModel.get("layout");
    var pixelDimIndex = layout2 === "horizontal" ? 0 : 1;
    var layoutLength = rect[wh[pixelDimIndex]];
    var layoutExtent = [0, layoutLength];
    var axisCount = this.dimensions.length;
    var axisExpandWidth = restrict(parallelModel.get("axisExpandWidth"), layoutExtent);
    var axisExpandCount = restrict(parallelModel.get("axisExpandCount") || 0, [0, axisCount]);
    var axisExpandable = parallelModel.get("axisExpandable") && axisCount > 3 && axisCount > axisExpandCount && axisExpandCount > 1 && axisExpandWidth > 0 && layoutLength > 0;
    var axisExpandWindow = parallelModel.get("axisExpandWindow");
    var winSize;
    if (!axisExpandWindow) {
      winSize = restrict(axisExpandWidth * (axisExpandCount - 1), layoutExtent);
      var axisExpandCenter = parallelModel.get("axisExpandCenter") || mathFloor(axisCount / 2);
      axisExpandWindow = [axisExpandWidth * axisExpandCenter - winSize / 2];
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    } else {
      winSize = restrict(axisExpandWindow[1] - axisExpandWindow[0], layoutExtent);
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    }
    var axisCollapseWidth = (layoutLength - winSize) / (axisCount - axisExpandCount);
    axisCollapseWidth < 3 && (axisCollapseWidth = 0);
    var winInnerIndices = [mathFloor(round(axisExpandWindow[0] / axisExpandWidth, 1)) + 1, mathCeil(round(axisExpandWindow[1] / axisExpandWidth, 1)) - 1];
    var axisExpandWindow0Pos = axisCollapseWidth / axisExpandWidth * axisExpandWindow[0];
    return {
      layout: layout2,
      pixelDimIndex,
      layoutBase: rect[xy[pixelDimIndex]],
      layoutLength,
      axisBase: rect[xy[1 - pixelDimIndex]],
      axisLength: rect[wh[1 - pixelDimIndex]],
      axisExpandable,
      axisExpandWidth,
      axisCollapseWidth,
      axisExpandWindow,
      axisCount,
      winInnerIndices,
      axisExpandWindow0Pos
    };
  };
  Parallel2.prototype._layoutAxes = function() {
    var rect = this._rect;
    var axes = this._axesMap;
    var dimensions = this.dimensions;
    var layoutInfo = this._makeLayoutInfo();
    var layout2 = layoutInfo.layout;
    axes.each(function(axis) {
      var axisExtent = [0, layoutInfo.axisLength];
      var idx = axis.inverse ? 1 : 0;
      axis.setExtent(axisExtent[idx], axisExtent[1 - idx]);
    });
    each$a(dimensions, function(dim, idx) {
      var posInfo = (layoutInfo.axisExpandable ? layoutAxisWithExpand : layoutAxisWithoutExpand)(idx, layoutInfo);
      var positionTable = {
        horizontal: {
          x: posInfo.position,
          y: layoutInfo.axisLength
        },
        vertical: {
          x: 0,
          y: posInfo.position
        }
      };
      var rotationTable = {
        horizontal: PI$1 / 2,
        vertical: 0
      };
      var position2 = [positionTable[layout2].x + rect.x, positionTable[layout2].y + rect.y];
      var rotation = rotationTable[layout2];
      var transform2 = create$1();
      rotate(transform2, transform2, rotation);
      translate(transform2, transform2, position2);
      this._axesLayout[dim] = {
        position: position2,
        rotation,
        transform: transform2,
        axisNameAvailableWidth: posInfo.axisNameAvailableWidth,
        axisLabelShow: posInfo.axisLabelShow,
        nameTruncateMaxWidth: posInfo.nameTruncateMaxWidth,
        tickDirection: 1,
        labelDirection: 1
      };
    }, this);
  };
  Parallel2.prototype.getAxis = function(dim) {
    return this._axesMap.get(dim);
  };
  Parallel2.prototype.dataToPoint = function(value, dim) {
    return this.axisCoordToPoint(this._axesMap.get(dim).dataToCoord(value), dim);
  };
  Parallel2.prototype.eachActiveState = function(data, callback, start2, end2) {
    start2 == null && (start2 = 0);
    end2 == null && (end2 = data.count());
    var axesMap = this._axesMap;
    var dimensions = this.dimensions;
    var dataDimensions = [];
    var axisModels = [];
    each$f(dimensions, function(axisDim) {
      dataDimensions.push(data.mapDimension(axisDim));
      axisModels.push(axesMap.get(axisDim).model);
    });
    var hasActiveSet = this.hasAxisBrushed();
    for (var dataIndex = start2; dataIndex < end2; dataIndex++) {
      var activeState = void 0;
      if (!hasActiveSet) {
        activeState = "normal";
      } else {
        activeState = "active";
        var values = data.getValues(dataDimensions, dataIndex);
        for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
          var state = axisModels[j].getActiveState(values[j]);
          if (state === "inactive") {
            activeState = "inactive";
            break;
          }
        }
      }
      callback(activeState, dataIndex);
    }
  };
  Parallel2.prototype.hasAxisBrushed = function() {
    var dimensions = this.dimensions;
    var axesMap = this._axesMap;
    var hasActiveSet = false;
    for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
      if (axesMap.get(dimensions[j]).model.getActiveState() !== "normal") {
        hasActiveSet = true;
      }
    }
    return hasActiveSet;
  };
  Parallel2.prototype.axisCoordToPoint = function(coord, dim) {
    var axisLayout = this._axesLayout[dim];
    return applyTransform([coord, 0], axisLayout.transform);
  };
  Parallel2.prototype.getAxisLayout = function(dim) {
    return clone$4(this._axesLayout[dim]);
  };
  Parallel2.prototype.getSlidedAxisExpandWindow = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var axisExpandWindow = layoutInfo.axisExpandWindow.slice();
    var winSize = axisExpandWindow[1] - axisExpandWindow[0];
    var extent3 = [0, layoutInfo.axisExpandWidth * (layoutInfo.axisCount - 1)];
    if (!this.containPoint(point)) {
      return {
        behavior: "none",
        axisExpandWindow
      };
    }
    var pointCoord = point[pixelDimIndex] - layoutInfo.layoutBase - layoutInfo.axisExpandWindow0Pos;
    var delta;
    var behavior = "slide";
    var axisCollapseWidth = layoutInfo.axisCollapseWidth;
    var triggerArea = this._model.get("axisExpandSlideTriggerArea");
    var useJump = triggerArea[0] != null;
    if (axisCollapseWidth) {
      if (useJump && axisCollapseWidth && pointCoord < winSize * triggerArea[0]) {
        behavior = "jump";
        delta = pointCoord - winSize * triggerArea[2];
      } else if (useJump && axisCollapseWidth && pointCoord > winSize * (1 - triggerArea[0])) {
        behavior = "jump";
        delta = pointCoord - winSize * (1 - triggerArea[2]);
      } else {
        (delta = pointCoord - winSize * triggerArea[1]) >= 0 && (delta = pointCoord - winSize * (1 - triggerArea[1])) <= 0 && (delta = 0);
      }
      delta *= layoutInfo.axisExpandWidth / axisCollapseWidth;
      delta ? sliderMove(delta, axisExpandWindow, extent3, "all") : behavior = "none";
    } else {
      var winSize2 = axisExpandWindow[1] - axisExpandWindow[0];
      var pos = extent3[1] * pointCoord / winSize2;
      axisExpandWindow = [mathMax$2(0, pos - winSize2 / 2)];
      axisExpandWindow[1] = mathMin$2(extent3[1], axisExpandWindow[0] + winSize2);
      axisExpandWindow[0] = axisExpandWindow[1] - winSize2;
    }
    return {
      axisExpandWindow,
      behavior
    };
  };
  return Parallel2;
}();
function restrict(len2, extent3) {
  return mathMin$2(mathMax$2(len2, extent3[0]), extent3[1]);
}
function layoutAxisWithoutExpand(axisIndex, layoutInfo) {
  var step = layoutInfo.layoutLength / (layoutInfo.axisCount - 1);
  return {
    position: step * axisIndex,
    axisNameAvailableWidth: step,
    axisLabelShow: true
  };
}
function layoutAxisWithExpand(axisIndex, layoutInfo) {
  var layoutLength = layoutInfo.layoutLength;
  var axisExpandWidth = layoutInfo.axisExpandWidth;
  var axisCount = layoutInfo.axisCount;
  var axisCollapseWidth = layoutInfo.axisCollapseWidth;
  var winInnerIndices = layoutInfo.winInnerIndices;
  var position2;
  var axisNameAvailableWidth = axisCollapseWidth;
  var axisLabelShow = false;
  var nameTruncateMaxWidth;
  if (axisIndex < winInnerIndices[0]) {
    position2 = axisIndex * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  } else if (axisIndex <= winInnerIndices[1]) {
    position2 = layoutInfo.axisExpandWindow0Pos + axisIndex * axisExpandWidth - layoutInfo.axisExpandWindow[0];
    axisNameAvailableWidth = axisExpandWidth;
    axisLabelShow = true;
  } else {
    position2 = layoutLength - (axisCount - 1 - axisIndex) * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  }
  return {
    position: position2,
    axisNameAvailableWidth,
    axisLabelShow,
    nameTruncateMaxWidth
  };
}
var Parallel$1 = Parallel;
function createParallelCoordSys(ecModel, api) {
  var coordSysList = [];
  ecModel.eachComponent("parallel", function(parallelModel, idx) {
    var coordSys = new Parallel$1(parallelModel, ecModel, api);
    coordSys.name = "parallel_" + idx;
    coordSys.resize(parallelModel, api);
    parallelModel.coordinateSystem = coordSys;
    coordSys.model = parallelModel;
    coordSysList.push(coordSys);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "parallel") {
      var parallelModel = seriesModel.getReferringComponents("parallel", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = parallelModel.coordinateSystem;
    }
  });
  return coordSysList;
}
var parallelCoordSysCreator = {
  create: createParallelCoordSys
};
var parallelCoordSysCreator$1 = parallelCoordSysCreator;
var ParallelAxisModel = function(_super) {
  __extends(ParallelAxisModel2, _super);
  function ParallelAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisModel2.type;
    _this.activeIntervals = [];
    return _this;
  }
  ParallelAxisModel2.prototype.getAreaSelectStyle = function() {
    return makeStyleMapper([
      ["fill", "color"],
      ["lineWidth", "borderWidth"],
      ["stroke", "borderColor"],
      ["width", "width"],
      ["opacity", "opacity"]
    ])(this.getModel("areaSelectStyle"));
  };
  ParallelAxisModel2.prototype.setActiveIntervals = function(intervals) {
    var activeIntervals = this.activeIntervals = clone$4(intervals);
    if (activeIntervals) {
      for (var i = activeIntervals.length - 1; i >= 0; i--) {
        asc$2(activeIntervals[i]);
      }
    }
  };
  ParallelAxisModel2.prototype.getActiveState = function(value) {
    var activeIntervals = this.activeIntervals;
    if (!activeIntervals.length) {
      return "normal";
    }
    if (value == null || isNaN(+value)) {
      return "inactive";
    }
    if (activeIntervals.length === 1) {
      var interval = activeIntervals[0];
      if (interval[0] <= value && value <= interval[1]) {
        return "active";
      }
    } else {
      for (var i = 0, len2 = activeIntervals.length; i < len2; i++) {
        if (activeIntervals[i][0] <= value && value <= activeIntervals[i][1]) {
          return "active";
        }
      }
    }
    return "inactive";
  };
  return ParallelAxisModel2;
}(ComponentModel$1);
mixin(ParallelAxisModel, AxisModelCommonMixin);
var ParallelAxisModel$1 = ParallelAxisModel;
var BRUSH_PANEL_GLOBAL = true;
var mathMin$1 = Math.min;
var mathMax$1 = Math.max;
var mathPow = Math.pow;
var COVER_Z = 1e4;
var UNSELECT_THRESHOLD = 6;
var MIN_RESIZE_LINE_WIDTH = 6;
var MUTEX_RESOURCE_KEY = "globalPan";
var DIRECTION_MAP = {
  w: [0, 0],
  e: [0, 1],
  n: [1, 0],
  s: [1, 1]
};
var CURSOR_MAP = {
  w: "ew",
  e: "ew",
  n: "ns",
  s: "ns",
  ne: "nesw",
  sw: "nesw",
  nw: "nwse",
  se: "nwse"
};
var DEFAULT_BRUSH_OPT = {
  brushStyle: {
    lineWidth: 2,
    stroke: "rgba(210,219,238,0.3)",
    fill: "#D2DBEE"
  },
  transformable: true,
  brushMode: "single",
  removeOnClick: false
};
var baseUID = 0;
var BrushController = function(_super) {
  __extends(BrushController2, _super);
  function BrushController2(zr) {
    var _this = _super.call(this) || this;
    _this._track = [];
    _this._covers = [];
    _this._handlers = {};
    _this._zr = zr;
    _this.group = new Group$4();
    _this._uid = "brushController_" + baseUID++;
    each$f(pointerHandlers, function(handler, eventName) {
      this._handlers[eventName] = bind$1(handler, this);
    }, _this);
    return _this;
  }
  BrushController2.prototype.enableBrush = function(brushOption) {
    this._brushType && this._doDisableBrush();
    brushOption.brushType && this._doEnableBrush(brushOption);
    return this;
  };
  BrushController2.prototype._doEnableBrush = function(brushOption) {
    var zr = this._zr;
    if (!this._enableGlobalPan) {
      take(zr, MUTEX_RESOURCE_KEY, this._uid);
    }
    each$f(this._handlers, function(handler, eventName) {
      zr.on(eventName, handler);
    });
    this._brushType = brushOption.brushType;
    this._brushOption = merge(clone$4(DEFAULT_BRUSH_OPT), brushOption, true);
  };
  BrushController2.prototype._doDisableBrush = function() {
    var zr = this._zr;
    release(zr, MUTEX_RESOURCE_KEY, this._uid);
    each$f(this._handlers, function(handler, eventName) {
      zr.off(eventName, handler);
    });
    this._brushType = this._brushOption = null;
  };
  BrushController2.prototype.setPanels = function(panelOpts) {
    if (panelOpts && panelOpts.length) {
      var panels_1 = this._panels = {};
      each$f(panelOpts, function(panelOpts2) {
        panels_1[panelOpts2.panelId] = clone$4(panelOpts2);
      });
    } else {
      this._panels = null;
    }
    return this;
  };
  BrushController2.prototype.mount = function(opt) {
    opt = opt || {};
    this._enableGlobalPan = opt.enableGlobalPan;
    var thisGroup = this.group;
    this._zr.add(thisGroup);
    thisGroup.attr({
      x: opt.x || 0,
      y: opt.y || 0,
      rotation: opt.rotation || 0,
      scaleX: opt.scaleX || 1,
      scaleY: opt.scaleY || 1
    });
    this._transform = thisGroup.getLocalTransform();
    return this;
  };
  BrushController2.prototype.updateCovers = function(coverConfigList) {
    coverConfigList = map$1(coverConfigList, function(coverConfig) {
      return merge(clone$4(DEFAULT_BRUSH_OPT), coverConfig, true);
    });
    var tmpIdPrefix = "\0-brush-index-";
    var oldCovers = this._covers;
    var newCovers = this._covers = [];
    var controller = this;
    var creatingCover = this._creatingCover;
    new DataDiffer$1(oldCovers, coverConfigList, oldGetKey, getKey2).add(addOrUpdate).update(addOrUpdate).remove(remove).execute();
    return this;
    function getKey2(brushOption, index2) {
      return (brushOption.id != null ? brushOption.id : tmpIdPrefix + index2) + "-" + brushOption.brushType;
    }
    function oldGetKey(cover, index2) {
      return getKey2(cover.__brushOption, index2);
    }
    function addOrUpdate(newIndex, oldIndex) {
      var newBrushInternal = coverConfigList[newIndex];
      if (oldIndex != null && oldCovers[oldIndex] === creatingCover) {
        newCovers[newIndex] = oldCovers[oldIndex];
      } else {
        var cover = newCovers[newIndex] = oldIndex != null ? (oldCovers[oldIndex].__brushOption = newBrushInternal, oldCovers[oldIndex]) : endCreating(controller, createCover(controller, newBrushInternal));
        updateCoverAfterCreation(controller, cover);
      }
    }
    function remove(oldIndex) {
      if (oldCovers[oldIndex] !== creatingCover) {
        controller.group.remove(oldCovers[oldIndex]);
      }
    }
  };
  BrushController2.prototype.unmount = function() {
    this.enableBrush(false);
    clearCovers(this);
    this._zr.remove(this.group);
    return this;
  };
  BrushController2.prototype.dispose = function() {
    this.unmount();
    this.off();
  };
  return BrushController2;
}(Eventful$1);
function createCover(controller, brushOption) {
  var cover = coverRenderers[brushOption.brushType].createCover(controller, brushOption);
  cover.__brushOption = brushOption;
  updateZ$1(cover, brushOption);
  controller.group.add(cover);
  return cover;
}
function endCreating(controller, creatingCover) {
  var coverRenderer = getCoverRenderer(creatingCover);
  if (coverRenderer.endCreating) {
    coverRenderer.endCreating(controller, creatingCover);
    updateZ$1(creatingCover, creatingCover.__brushOption);
  }
  return creatingCover;
}
function updateCoverShape(controller, cover) {
  var brushOption = cover.__brushOption;
  getCoverRenderer(cover).updateCoverShape(controller, cover, brushOption.range, brushOption);
}
function updateZ$1(cover, brushOption) {
  var z2 = brushOption.z;
  z2 == null && (z2 = COVER_Z);
  cover.traverse(function(el) {
    el.z = z2;
    el.z2 = z2;
  });
}
function updateCoverAfterCreation(controller, cover) {
  getCoverRenderer(cover).updateCommon(controller, cover);
  updateCoverShape(controller, cover);
}
function getCoverRenderer(cover) {
  return coverRenderers[cover.__brushOption.brushType];
}
function getPanelByPoint(controller, e2, localCursorPoint) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panel;
  var transform2 = controller._transform;
  each$f(panels, function(pn) {
    pn.isTargetByCursor(e2, localCursorPoint, transform2) && (panel = pn);
  });
  return panel;
}
function getPanelByCover(controller, cover) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panelId = cover.__brushOption.panelId;
  return panelId != null ? panels[panelId] : BRUSH_PANEL_GLOBAL;
}
function clearCovers(controller) {
  var covers = controller._covers;
  var originalLength = covers.length;
  each$f(covers, function(cover) {
    controller.group.remove(cover);
  }, controller);
  covers.length = 0;
  return !!originalLength;
}
function trigger(controller, opt) {
  var areas = map$1(controller._covers, function(cover) {
    var brushOption = cover.__brushOption;
    var range3 = clone$4(brushOption.range);
    return {
      brushType: brushOption.brushType,
      panelId: brushOption.panelId,
      range: range3
    };
  });
  controller.trigger("brush", {
    areas,
    isEnd: !!opt.isEnd,
    removeOnClick: !!opt.removeOnClick
  });
}
function shouldShowCover(controller) {
  var track = controller._track;
  if (!track.length) {
    return false;
  }
  var p2 = track[track.length - 1];
  var p1 = track[0];
  var dx = p2[0] - p1[0];
  var dy = p2[1] - p1[1];
  var dist2 = mathPow(dx * dx + dy * dy, 0.5);
  return dist2 > UNSELECT_THRESHOLD;
}
function getTrackEnds(track) {
  var tail = track.length - 1;
  tail < 0 && (tail = 0);
  return [track[0], track[tail]];
}
function createBaseRectCover(rectRangeConverter, controller, brushOption, edgeNameSequences) {
  var cover = new Group$4();
  cover.add(new Rect$3({
    name: "main",
    style: makeStyle(brushOption),
    silent: true,
    draggable: true,
    cursor: "move",
    drift: curry$1(driftRect, rectRangeConverter, controller, cover, ["n", "s", "w", "e"]),
    ondragend: curry$1(trigger, controller, {
      isEnd: true
    })
  }));
  each$f(edgeNameSequences, function(nameSequence) {
    cover.add(new Rect$3({
      name: nameSequence.join(""),
      style: {
        opacity: 0
      },
      draggable: true,
      silent: true,
      invisible: true,
      drift: curry$1(driftRect, rectRangeConverter, controller, cover, nameSequence),
      ondragend: curry$1(trigger, controller, {
        isEnd: true
      })
    }));
  });
  return cover;
}
function updateBaseRect(controller, cover, localRange, brushOption) {
  var lineWidth = brushOption.brushStyle.lineWidth || 0;
  var handleSize = mathMax$1(lineWidth, MIN_RESIZE_LINE_WIDTH);
  var x2 = localRange[0][0];
  var y2 = localRange[1][0];
  var xa = x2 - lineWidth / 2;
  var ya = y2 - lineWidth / 2;
  var x22 = localRange[0][1];
  var y22 = localRange[1][1];
  var x2a = x22 - handleSize + lineWidth / 2;
  var y2a = y22 - handleSize + lineWidth / 2;
  var width = x22 - x2;
  var height = y22 - y2;
  var widtha = width + lineWidth;
  var heighta = height + lineWidth;
  updateRectShape(controller, cover, "main", x2, y2, width, height);
  if (brushOption.transformable) {
    updateRectShape(controller, cover, "w", xa, ya, handleSize, heighta);
    updateRectShape(controller, cover, "e", x2a, ya, handleSize, heighta);
    updateRectShape(controller, cover, "n", xa, ya, widtha, handleSize);
    updateRectShape(controller, cover, "s", xa, y2a, widtha, handleSize);
    updateRectShape(controller, cover, "nw", xa, ya, handleSize, handleSize);
    updateRectShape(controller, cover, "ne", x2a, ya, handleSize, handleSize);
    updateRectShape(controller, cover, "sw", xa, y2a, handleSize, handleSize);
    updateRectShape(controller, cover, "se", x2a, y2a, handleSize, handleSize);
  }
}
function updateCommon$1(controller, cover) {
  var brushOption = cover.__brushOption;
  var transformable = brushOption.transformable;
  var mainEl = cover.childAt(0);
  mainEl.useStyle(makeStyle(brushOption));
  mainEl.attr({
    silent: !transformable,
    cursor: transformable ? "move" : "default"
  });
  each$f([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(nameSequence) {
    var el = cover.childOfName(nameSequence.join(""));
    var globalDir = nameSequence.length === 1 ? getGlobalDirection1(controller, nameSequence[0]) : getGlobalDirection2(controller, nameSequence);
    el && el.attr({
      silent: !transformable,
      invisible: !transformable,
      cursor: transformable ? CURSOR_MAP[globalDir] + "-resize" : null
    });
  });
}
function updateRectShape(controller, cover, name, x2, y2, w2, h) {
  var el = cover.childOfName(name);
  el && el.setShape(pointsToRect(clipByPanel(controller, cover, [[x2, y2], [x2 + w2, y2 + h]])));
}
function makeStyle(brushOption) {
  return defaults({
    strokeNoScale: true
  }, brushOption.brushStyle);
}
function formatRectRange(x2, y2, x22, y22) {
  var min3 = [mathMin$1(x2, x22), mathMin$1(y2, y22)];
  var max3 = [mathMax$1(x2, x22), mathMax$1(y2, y22)];
  return [
    [min3[0], max3[0]],
    [min3[1], max3[1]]
  ];
}
function getTransform(controller) {
  return getTransform$1(controller.group);
}
function getGlobalDirection1(controller, localDirName) {
  var map2 = {
    w: "left",
    e: "right",
    n: "top",
    s: "bottom"
  };
  var inverseMap = {
    left: "w",
    right: "e",
    top: "n",
    bottom: "s"
  };
  var dir3 = transformDirection(map2[localDirName], getTransform(controller));
  return inverseMap[dir3];
}
function getGlobalDirection2(controller, localDirNameSeq) {
  var globalDir = [getGlobalDirection1(controller, localDirNameSeq[0]), getGlobalDirection1(controller, localDirNameSeq[1])];
  (globalDir[0] === "e" || globalDir[0] === "w") && globalDir.reverse();
  return globalDir.join("");
}
function driftRect(rectRangeConverter, controller, cover, dirNameSequence, dx, dy) {
  var brushOption = cover.__brushOption;
  var rectRange = rectRangeConverter.toRectRange(brushOption.range);
  var localDelta = toLocalDelta(controller, dx, dy);
  each$f(dirNameSequence, function(dirName) {
    var ind = DIRECTION_MAP[dirName];
    rectRange[ind[0]][ind[1]] += localDelta[ind[0]];
  });
  brushOption.range = rectRangeConverter.fromRectRange(formatRectRange(rectRange[0][0], rectRange[1][0], rectRange[0][1], rectRange[1][1]));
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function driftPolygon(controller, cover, dx, dy) {
  var range3 = cover.__brushOption.range;
  var localDelta = toLocalDelta(controller, dx, dy);
  each$f(range3, function(point) {
    point[0] += localDelta[0];
    point[1] += localDelta[1];
  });
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function toLocalDelta(controller, dx, dy) {
  var thisGroup = controller.group;
  var localD = thisGroup.transformCoordToLocal(dx, dy);
  var localZero = thisGroup.transformCoordToLocal(0, 0);
  return [localD[0] - localZero[0], localD[1] - localZero[1]];
}
function clipByPanel(controller, cover, data) {
  var panel = getPanelByCover(controller, cover);
  return panel && panel !== BRUSH_PANEL_GLOBAL ? panel.clipPath(data, controller._transform) : clone$4(data);
}
function pointsToRect(points2) {
  var xmin = mathMin$1(points2[0][0], points2[1][0]);
  var ymin = mathMin$1(points2[0][1], points2[1][1]);
  var xmax = mathMax$1(points2[0][0], points2[1][0]);
  var ymax = mathMax$1(points2[0][1], points2[1][1]);
  return {
    x: xmin,
    y: ymin,
    width: xmax - xmin,
    height: ymax - ymin
  };
}
function resetCursor(controller, e2, localCursorPoint) {
  if (!controller._brushType || isOutsideZrArea(controller, e2.offsetX, e2.offsetY)) {
    return;
  }
  var zr = controller._zr;
  var covers = controller._covers;
  var currPanel = getPanelByPoint(controller, e2, localCursorPoint);
  if (!controller._dragging) {
    for (var i = 0; i < covers.length; i++) {
      var brushOption = covers[i].__brushOption;
      if (currPanel && (currPanel === BRUSH_PANEL_GLOBAL || brushOption.panelId === currPanel.panelId) && coverRenderers[brushOption.brushType].contain(covers[i], localCursorPoint[0], localCursorPoint[1])) {
        return;
      }
    }
  }
  currPanel && zr.setCursorStyle("crosshair");
}
function preventDefault(e2) {
  var rawE = e2.event;
  rawE.preventDefault && rawE.preventDefault();
}
function mainShapeContain(cover, x2, y2) {
  return cover.childOfName("main").contain(x2, y2);
}
function updateCoverByMouse(controller, e2, localCursorPoint, isEnd) {
  var creatingCover = controller._creatingCover;
  var panel = controller._creatingPanel;
  var thisBrushOption = controller._brushOption;
  var eventParams;
  controller._track.push(localCursorPoint.slice());
  if (shouldShowCover(controller) || creatingCover) {
    if (panel && !creatingCover) {
      thisBrushOption.brushMode === "single" && clearCovers(controller);
      var brushOption = clone$4(thisBrushOption);
      brushOption.brushType = determineBrushType(brushOption.brushType, panel);
      brushOption.panelId = panel === BRUSH_PANEL_GLOBAL ? null : panel.panelId;
      creatingCover = controller._creatingCover = createCover(controller, brushOption);
      controller._covers.push(creatingCover);
    }
    if (creatingCover) {
      var coverRenderer = coverRenderers[determineBrushType(controller._brushType, panel)];
      var coverBrushOption = creatingCover.__brushOption;
      coverBrushOption.range = coverRenderer.getCreatingRange(clipByPanel(controller, creatingCover, controller._track));
      if (isEnd) {
        endCreating(controller, creatingCover);
        coverRenderer.updateCommon(controller, creatingCover);
      }
      updateCoverShape(controller, creatingCover);
      eventParams = {
        isEnd
      };
    }
  } else if (isEnd && thisBrushOption.brushMode === "single" && thisBrushOption.removeOnClick) {
    if (getPanelByPoint(controller, e2, localCursorPoint) && clearCovers(controller)) {
      eventParams = {
        isEnd,
        removeOnClick: true
      };
    }
  }
  return eventParams;
}
function determineBrushType(brushType, panel) {
  if (brushType === "auto") {
    return panel.defaultBrushType;
  }
  return brushType;
}
var pointerHandlers = {
  mousedown: function(e2) {
    if (this._dragging) {
      handleDragEnd(this, e2);
    } else if (!e2.target || !e2.target.draggable) {
      preventDefault(e2);
      var localCursorPoint = this.group.transformCoordToLocal(e2.offsetX, e2.offsetY);
      this._creatingCover = null;
      var panel = this._creatingPanel = getPanelByPoint(this, e2, localCursorPoint);
      if (panel) {
        this._dragging = true;
        this._track = [localCursorPoint.slice()];
      }
    }
  },
  mousemove: function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = this.group.transformCoordToLocal(x2, y2);
    resetCursor(this, e2, localCursorPoint);
    if (this._dragging) {
      preventDefault(e2);
      var eventParams = updateCoverByMouse(this, e2, localCursorPoint, false);
      eventParams && trigger(this, eventParams);
    }
  },
  mouseup: function(e2) {
    handleDragEnd(this, e2);
  }
};
function handleDragEnd(controller, e2) {
  if (controller._dragging) {
    preventDefault(e2);
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = controller.group.transformCoordToLocal(x2, y2);
    var eventParams = updateCoverByMouse(controller, e2, localCursorPoint, true);
    controller._dragging = false;
    controller._track = [];
    controller._creatingCover = null;
    eventParams && trigger(controller, eventParams);
  }
}
function isOutsideZrArea(controller, x2, y2) {
  var zr = controller._zr;
  return x2 < 0 || x2 > zr.getWidth() || y2 < 0 || y2 > zr.getHeight();
}
var coverRenderers = {
  lineX: getLineRenderer(0),
  lineY: getLineRenderer(1),
  rect: {
    createCover: function(controller, brushOption) {
      function returnInput(range3) {
        return range3;
      }
      return createBaseRectCover({
        toRectRange: returnInput,
        fromRectRange: returnInput
      }, controller, brushOption, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      return formatRectRange(ends[1][0], ends[1][1], ends[0][0], ends[0][1]);
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      updateBaseRect(controller, cover, localRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  },
  polygon: {
    createCover: function(controller, brushOption) {
      var cover = new Group$4();
      cover.add(new Polyline$3({
        name: "main",
        style: makeStyle(brushOption),
        silent: true
      }));
      return cover;
    },
    getCreatingRange: function(localTrack) {
      return localTrack;
    },
    endCreating: function(controller, cover) {
      cover.remove(cover.childAt(0));
      cover.add(new Polygon$1({
        name: "main",
        draggable: true,
        drift: curry$1(driftPolygon, controller, cover),
        ondragend: curry$1(trigger, controller, {
          isEnd: true
        })
      }));
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      cover.childAt(0).setShape({
        points: clipByPanel(controller, cover, localRange)
      });
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  }
};
function getLineRenderer(xyIndex) {
  return {
    createCover: function(controller, brushOption) {
      return createBaseRectCover({
        toRectRange: function(range3) {
          var rectRange = [range3, [0, 100]];
          xyIndex && rectRange.reverse();
          return rectRange;
        },
        fromRectRange: function(rectRange) {
          return rectRange[xyIndex];
        }
      }, controller, brushOption, [[["w"], ["e"]], [["n"], ["s"]]][xyIndex]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      var min3 = mathMin$1(ends[0][xyIndex], ends[1][xyIndex]);
      var max3 = mathMax$1(ends[0][xyIndex], ends[1][xyIndex]);
      return [min3, max3];
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      var otherExtent;
      var panel = getPanelByCover(controller, cover);
      if (panel !== BRUSH_PANEL_GLOBAL && panel.getLinearBrushOtherExtent) {
        otherExtent = panel.getLinearBrushOtherExtent(xyIndex);
      } else {
        var zr = controller._zr;
        otherExtent = [0, [zr.getWidth(), zr.getHeight()][1 - xyIndex]];
      }
      var rectRange = [localRange, otherExtent];
      xyIndex && rectRange.reverse();
      updateBaseRect(controller, cover, rectRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  };
}
var BrushController$1 = BrushController;
function makeRectPanelClipPath(rect) {
  rect = normalizeRect(rect);
  return function(localPoints) {
    return clipPointsByRect(localPoints, rect);
  };
}
function makeLinearBrushOtherExtent(rect, specifiedXYIndex) {
  rect = normalizeRect(rect);
  return function(xyIndex) {
    var idx = specifiedXYIndex != null ? specifiedXYIndex : xyIndex;
    var brushWidth = idx ? rect.width : rect.height;
    var base2 = idx ? rect.x : rect.y;
    return [base2, base2 + (brushWidth || 0)];
  };
}
function makeRectIsTargetByCursor(rect, api, targetModel) {
  var boundingRect = normalizeRect(rect);
  return function(e2, localCursorPoint) {
    return boundingRect.contain(localCursorPoint[0], localCursorPoint[1]) && !onIrrelevantElement(e2, api, targetModel);
  };
}
function normalizeRect(rect) {
  return BoundingRect$1.create(rect);
}
var elementList$1 = ["axisLine", "axisTickLabel", "axisName"];
var ParallelAxisView = function(_super) {
  __extends(ParallelAxisView2, _super);
  function ParallelAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisView2.type;
    return _this;
  }
  ParallelAxisView2.prototype.init = function(ecModel, api) {
    _super.prototype.init.apply(this, arguments);
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this));
  };
  ParallelAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    if (fromAxisAreaSelect(axisModel, ecModel, payload)) {
      return;
    }
    this.axisModel = axisModel;
    this.api = api;
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var coordSysModel = getCoordSysModel(axisModel, ecModel);
    var coordSys = coordSysModel.coordinateSystem;
    var areaSelectStyle = axisModel.getAreaSelectStyle();
    var areaWidth = areaSelectStyle.width;
    var dim = axisModel.axis.dim;
    var axisLayout = coordSys.getAxisLayout(dim);
    var builderOpt = extend({
      strokeContainThreshold: areaWidth
    }, axisLayout);
    var axisBuilder = new AxisBuilder$1(axisModel, builderOpt);
    each$f(elementList$1, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    this._refreshBrushController(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
  };
  ParallelAxisView2.prototype._refreshBrushController = function(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api) {
    var extent3 = axisModel.axis.getExtent();
    var extentLen = extent3[1] - extent3[0];
    var extra = Math.min(30, Math.abs(extentLen) * 0.1);
    var rect = BoundingRect$1.create({
      x: extent3[0],
      y: -areaWidth / 2,
      width: extentLen,
      height: areaWidth
    });
    rect.x -= extra;
    rect.width += 2 * extra;
    this._brushController.mount({
      enableGlobalPan: true,
      rotation: builderOpt.rotation,
      x: builderOpt.position[0],
      y: builderOpt.position[1]
    }).setPanels([{
      panelId: "pl",
      clipPath: makeRectPanelClipPath(rect),
      isTargetByCursor: makeRectIsTargetByCursor(rect, api, coordSysModel),
      getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect, 0)
    }]).enableBrush({
      brushType: "lineX",
      brushStyle: areaSelectStyle,
      removeOnClick: true
    }).updateCovers(getCoverInfoList(axisModel));
  };
  ParallelAxisView2.prototype._onBrush = function(eventParam) {
    var coverInfoList = eventParam.areas;
    var axisModel = this.axisModel;
    var axis = axisModel.axis;
    var intervals = map$1(coverInfoList, function(coverInfo) {
      return [axis.coordToData(coverInfo.range[0], true), axis.coordToData(coverInfo.range[1], true)];
    });
    if (!axisModel.option.realtime === eventParam.isEnd || eventParam.removeOnClick) {
      this.api.dispatchAction({
        type: "axisAreaSelect",
        parallelAxisId: axisModel.id,
        intervals
      });
    }
  };
  ParallelAxisView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  ParallelAxisView2.type = "parallelAxis";
  return ParallelAxisView2;
}(ComponentView$1);
function fromAxisAreaSelect(axisModel, ecModel, payload) {
  return payload && payload.type === "axisAreaSelect" && ecModel.findComponents({
    mainType: "parallelAxis",
    query: payload
  })[0] === axisModel;
}
function getCoverInfoList(axisModel) {
  var axis = axisModel.axis;
  return map$1(axisModel.activeIntervals, function(interval) {
    return {
      brushType: "lineX",
      panelId: "pl",
      range: [axis.dataToCoord(interval[0], true), axis.dataToCoord(interval[1], true)]
    };
  });
}
function getCoordSysModel(axisModel, ecModel) {
  return ecModel.getComponent("parallel", axisModel.get("parallelIndex"));
}
var ParallelAxisView$1 = ParallelAxisView;
var actionInfo = {
  type: "axisAreaSelect",
  event: "axisAreaSelected"
};
function installParallelActions(registers) {
  registers.registerAction(actionInfo, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallelAxis",
      query: payload
    }, function(parallelAxisModel) {
      parallelAxisModel.axis.model.setActiveIntervals(payload.intervals);
    });
  });
  registers.registerAction("parallelAxisExpand", function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallel",
      query: payload
    }, function(parallelModel) {
      parallelModel.setAxisExpand(payload);
    });
  });
}
var defaultAxisOption = {
  type: "value",
  areaSelectStyle: {
    width: 20,
    borderWidth: 1,
    borderColor: "rgba(160,197,232)",
    color: "rgba(160,197,232)",
    opacity: 0.3
  },
  realtime: true,
  z: 10
};
function install$C(registers) {
  registers.registerComponentView(ParallelView$1);
  registers.registerComponentModel(ParallelModel$1);
  registers.registerCoordinateSystem("parallel", parallelCoordSysCreator$1);
  registers.registerPreprocessor(parallelPreprocessor);
  registers.registerComponentModel(ParallelAxisModel$1);
  registers.registerComponentView(ParallelAxisView$1);
  axisModelCreator(registers, "parallel", ParallelAxisModel$1, defaultAxisOption);
  installParallelActions(registers);
}
function install$B(registers) {
  use(install$C);
  registers.registerChartView(ParallelView$3);
  registers.registerSeriesModel(ParallelSeriesModel$1);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, parallelVisual$1);
}
var SankeyPathShape = function() {
  function SankeyPathShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.cpx2 = 0;
    this.cpy2 = 0;
    this.extent = 0;
  }
  return SankeyPathShape2;
}();
var SankeyPath = function(_super) {
  __extends(SankeyPath2, _super);
  function SankeyPath2(opts) {
    return _super.call(this, opts) || this;
  }
  SankeyPath2.prototype.getDefaultShape = function() {
    return new SankeyPathShape();
  };
  SankeyPath2.prototype.buildPath = function(ctx, shape) {
    var extent3 = shape.extent;
    ctx.moveTo(shape.x1, shape.y1);
    ctx.bezierCurveTo(shape.cpx1, shape.cpy1, shape.cpx2, shape.cpy2, shape.x2, shape.y2);
    if (shape.orient === "vertical") {
      ctx.lineTo(shape.x2 + extent3, shape.y2);
      ctx.bezierCurveTo(shape.cpx2 + extent3, shape.cpy2, shape.cpx1 + extent3, shape.cpy1, shape.x1 + extent3, shape.y1);
    } else {
      ctx.lineTo(shape.x2, shape.y2 + extent3);
      ctx.bezierCurveTo(shape.cpx2, shape.cpy2 + extent3, shape.cpx1, shape.cpy1 + extent3, shape.x1, shape.y1 + extent3);
    }
    ctx.closePath();
  };
  SankeyPath2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  SankeyPath2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  return SankeyPath2;
}(Path$1);
var SankeyView = function(_super) {
  __extends(SankeyView2, _super);
  function SankeyView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeyView2.type;
    _this._focusAdjacencyDisabled = false;
    return _this;
  }
  SankeyView2.prototype.render = function(seriesModel, ecModel, api) {
    var sankeyView = this;
    var graph = seriesModel.getGraph();
    var group = this.group;
    var layoutInfo = seriesModel.layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var nodeData = seriesModel.getData();
    var edgeData = seriesModel.getData("edge");
    var orient = seriesModel.get("orient");
    this._model = seriesModel;
    group.removeAll();
    group.x = layoutInfo.x;
    group.y = layoutInfo.y;
    graph.eachEdge(function(edge) {
      var curve = new SankeyPath();
      var ecData = getECData(curve);
      ecData.dataIndex = edge.dataIndex;
      ecData.seriesIndex = seriesModel.seriesIndex;
      ecData.dataType = "edge";
      var edgeModel = edge.getModel();
      var lineStyleModel = edgeModel.getModel("lineStyle");
      var curvature = lineStyleModel.get("curveness");
      var n1Layout = edge.node1.getLayout();
      var node1Model = edge.node1.getModel();
      var dragX1 = node1Model.get("localX");
      var dragY1 = node1Model.get("localY");
      var n2Layout = edge.node2.getLayout();
      var node2Model = edge.node2.getModel();
      var dragX2 = node2Model.get("localX");
      var dragY2 = node2Model.get("localY");
      var edgeLayout = edge.getLayout();
      var x1;
      var y1;
      var x2;
      var y2;
      var cpx1;
      var cpy1;
      var cpx2;
      var cpy2;
      curve.shape.extent = Math.max(1, edgeLayout.dy);
      curve.shape.orient = orient;
      if (orient === "vertical") {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + edgeLayout.sy;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + n1Layout.dy;
        x2 = (dragX2 != null ? dragX2 * width : n2Layout.x) + edgeLayout.ty;
        y2 = dragY2 != null ? dragY2 * height : n2Layout.y;
        cpx1 = x1;
        cpy1 = y1 * (1 - curvature) + y2 * curvature;
        cpx2 = x2;
        cpy2 = y1 * curvature + y2 * (1 - curvature);
      } else {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + n1Layout.dx;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + edgeLayout.sy;
        x2 = dragX2 != null ? dragX2 * width : n2Layout.x;
        y2 = (dragY2 != null ? dragY2 * height : n2Layout.y) + edgeLayout.ty;
        cpx1 = x1 * (1 - curvature) + x2 * curvature;
        cpy1 = y1;
        cpx2 = x1 * curvature + x2 * (1 - curvature);
        cpy2 = y2;
      }
      curve.setShape({
        x1,
        y1,
        x2,
        y2,
        cpx1,
        cpy1,
        cpx2,
        cpy2
      });
      curve.useStyle(lineStyleModel.getItemStyle());
      switch (curve.style.fill) {
        case "source":
          curve.style.fill = edge.node1.getVisual("color");
          curve.style.decal = edge.node1.getVisual("style").decal;
          break;
        case "target":
          curve.style.fill = edge.node2.getVisual("color");
          curve.style.decal = edge.node2.getVisual("style").decal;
          break;
        case "gradient":
          var sourceColor = edge.node1.getVisual("color");
          var targetColor = edge.node2.getVisual("color");
          if (isString(sourceColor) && isString(targetColor)) {
            curve.style.fill = new LinearGradient$1(0, 0, +(orient === "horizontal"), +(orient === "vertical"), [{
              color: sourceColor,
              offset: 0
            }, {
              color: targetColor,
              offset: 1
            }]);
          }
      }
      var emphasisModel = edgeModel.getModel("emphasis");
      setStatesStylesFromModel(curve, edgeModel, "lineStyle", function(model) {
        return model.getItemStyle();
      });
      group.add(curve);
      edgeData.setItemGraphicEl(edge.dataIndex, curve);
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(curve, focus === "adjacency" ? edge.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
      getECData(curve).dataType = "edge";
    });
    graph.eachNode(function(node) {
      var layout2 = node.getLayout();
      var itemModel = node.getModel();
      var dragX = itemModel.get("localX");
      var dragY = itemModel.get("localY");
      var emphasisModel = itemModel.getModel("emphasis");
      var rect = new Rect$3({
        shape: {
          x: dragX != null ? dragX * width : layout2.x,
          y: dragY != null ? dragY * height : layout2.y,
          width: layout2.dx,
          height: layout2.dy
        },
        style: itemModel.getModel("itemStyle").getItemStyle(),
        z2: 10
      });
      setLabelStyle(rect, getLabelStatesModels(itemModel), {
        labelFetcher: seriesModel,
        labelDataIndex: node.dataIndex,
        defaultText: node.id
      });
      rect.disableLabelAnimation = true;
      rect.setStyle("fill", node.getVisual("color"));
      rect.setStyle("decal", node.getVisual("style").decal);
      setStatesStylesFromModel(rect, itemModel);
      group.add(rect);
      nodeData.setItemGraphicEl(node.dataIndex, rect);
      getECData(rect).dataType = "node";
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(rect, focus === "adjacency" ? node.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    nodeData.eachItemGraphicEl(function(el, dataIndex) {
      var itemModel = nodeData.getItemModel(dataIndex);
      if (itemModel.get("draggable")) {
        el.drift = function(dx, dy) {
          sankeyView._focusAdjacencyDisabled = true;
          this.shape.x += dx;
          this.shape.y += dy;
          this.dirty();
          api.dispatchAction({
            type: "dragNode",
            seriesId: seriesModel.id,
            dataIndex: nodeData.getRawIndex(dataIndex),
            localX: this.shape.x / width,
            localY: this.shape.y / height
          });
        };
        el.ondragend = function() {
          sankeyView._focusAdjacencyDisabled = false;
        };
        el.draggable = true;
        el.cursor = "move";
      }
    });
    if (!this._data && seriesModel.isAnimationEnabled()) {
      group.setClipPath(createGridClipShape$1(group.getBoundingRect(), seriesModel, function() {
        group.removeClipPath();
      }));
    }
    this._data = seriesModel.getData();
  };
  SankeyView2.prototype.dispose = function() {
  };
  SankeyView2.type = "sankey";
  return SankeyView2;
}(ChartView$1);
function createGridClipShape$1(rect, seriesModel, cb) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      width: rect.width + 20
    }
  }, seriesModel, cb);
  return rectEl;
}
var SankeyView$1 = SankeyView;
var SankeySeriesModel = function(_super) {
  __extends(SankeySeriesModel2, _super);
  function SankeySeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeySeriesModel2.type;
    return _this;
  }
  SankeySeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var links = option.edges || option.links;
    var nodes = option.data || option.nodes;
    var levels = option.levels;
    this.levelModels = [];
    var levelModels = this.levelModels;
    for (var i = 0; i < levels.length; i++) {
      if (levels[i].depth != null && levels[i].depth >= 0) {
        levelModels[levels[i].depth] = new Model$1(levels[i], this, ecModel);
      }
    }
    if (nodes && links) {
      var graph = createGraphFromNodeEdge(nodes, links, this, true, beforeLink);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var layout2 = seriesModel.getData().getItemLayout(idx);
        if (layout2) {
          var nodeDepth = layout2.depth;
          var levelModel = seriesModel.levelModels[nodeDepth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
      edgeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var edge = seriesModel.getGraph().getEdgeByIndex(idx);
        var layout2 = edge.node1.getLayout();
        if (layout2) {
          var depth = layout2.depth;
          var levelModel = seriesModel.levelModels[depth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
    }
  };
  SankeySeriesModel2.prototype.setNodePosition = function(dataIndex, localPosition) {
    var nodes = this.option.data || this.option.nodes;
    var dataItem = nodes[dataIndex];
    dataItem.localX = localPosition[0];
    dataItem.localY = localPosition[1];
  };
  SankeySeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  SankeySeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  SankeySeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    function noValue(val) {
      return isNaN(val) || val == null;
    }
    if (dataType === "edge") {
      var params = this.getDataParams(dataIndex, dataType);
      var rawDataOpt = params.data;
      var edgeValue = params.value;
      var edgeName = rawDataOpt.source + " -- " + rawDataOpt.target;
      return createTooltipMarkup("nameValue", {
        name: edgeName,
        value: edgeValue,
        noValue: noValue(edgeValue)
      });
    } else {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var value = node.getLayout().value;
      var name_1 = this.getDataParams(dataIndex, dataType).data.name;
      return createTooltipMarkup("nameValue", {
        name: name_1 != null ? name_1 + "" : null,
        value,
        noValue: noValue(value)
      });
    }
  };
  SankeySeriesModel2.prototype.optionUpdated = function() {
  };
  SankeySeriesModel2.prototype.getDataParams = function(dataIndex, dataType) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    if (params.value == null && dataType === "node") {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var nodeValue = node.getLayout().value;
      params.value = nodeValue;
    }
    return params;
  };
  SankeySeriesModel2.type = "series.sankey";
  SankeySeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "5%",
    top: "5%",
    right: "20%",
    bottom: "5%",
    orient: "horizontal",
    nodeWidth: 20,
    nodeGap: 8,
    draggable: true,
    layoutIterations: 32,
    label: {
      show: true,
      position: "right",
      fontSize: 12
    },
    levels: [],
    nodeAlign: "justify",
    lineStyle: {
      color: "#314656",
      opacity: 0.2,
      curveness: 0.5
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        opacity: 0.5
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    animationEasing: "linear",
    animationDuration: 1e3
  };
  return SankeySeriesModel2;
}(SeriesModel$1);
var SankeySeriesModel$1 = SankeySeriesModel;
function sankeyLayout(ecModel, api) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var nodeWidth = seriesModel.get("nodeWidth");
    var nodeGap = seriesModel.get("nodeGap");
    var layoutInfo = getViewRect$1(seriesModel, api);
    seriesModel.layoutInfo = layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    var edges = graph.edges;
    computeNodeValues(nodes);
    var filteredNodes = filter(nodes, function(node) {
      return node.getLayout().value === 0;
    });
    var iterations = filteredNodes.length !== 0 ? 0 : seriesModel.get("layoutIterations");
    var orient = seriesModel.get("orient");
    var nodeAlign = seriesModel.get("nodeAlign");
    layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign);
  });
}
function getViewRect$1(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign) {
  computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign);
  computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient);
  computeEdgeDepths(nodes, orient);
}
function computeNodeValues(nodes) {
  each$f(nodes, function(node) {
    var value1 = sum(node.outEdges, getEdgeValue);
    var value2 = sum(node.inEdges, getEdgeValue);
    var nodeRawValue = node.getValue() || 0;
    var value = Math.max(value1, value2, nodeRawValue);
    node.setLayout({
      value
    }, true);
  });
}
function computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign) {
  var remainEdges = [];
  var indegreeArr = [];
  var zeroIndegrees = [];
  var nextTargetNode = [];
  var x2 = 0;
  for (var i = 0; i < edges.length; i++) {
    remainEdges[i] = 1;
  }
  for (var i = 0; i < nodes.length; i++) {
    indegreeArr[i] = nodes[i].inEdges.length;
    if (indegreeArr[i] === 0) {
      zeroIndegrees.push(nodes[i]);
    }
  }
  var maxNodeDepth = -1;
  while (zeroIndegrees.length) {
    for (var idx = 0; idx < zeroIndegrees.length; idx++) {
      var node = zeroIndegrees[idx];
      var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
      var isItemDepth = item.depth != null && item.depth >= 0;
      if (isItemDepth && item.depth > maxNodeDepth) {
        maxNodeDepth = item.depth;
      }
      node.setLayout({
        depth: isItemDepth ? item.depth : x2
      }, true);
      orient === "vertical" ? node.setLayout({
        dy: nodeWidth
      }, true) : node.setLayout({
        dx: nodeWidth
      }, true);
      for (var edgeIdx = 0; edgeIdx < node.outEdges.length; edgeIdx++) {
        var edge = node.outEdges[edgeIdx];
        var indexEdge = edges.indexOf(edge);
        remainEdges[indexEdge] = 0;
        var targetNode = edge.node2;
        var nodeIndex = nodes.indexOf(targetNode);
        if (--indegreeArr[nodeIndex] === 0 && nextTargetNode.indexOf(targetNode) < 0) {
          nextTargetNode.push(targetNode);
        }
      }
    }
    ++x2;
    zeroIndegrees = nextTargetNode;
    nextTargetNode = [];
  }
  for (var i = 0; i < remainEdges.length; i++) {
    if (remainEdges[i] === 1) {
      throw new Error("Sankey is a DAG, the original data has cycle!");
    }
  }
  var maxDepth = maxNodeDepth > x2 - 1 ? maxNodeDepth : x2 - 1;
  if (nodeAlign && nodeAlign !== "left") {
    adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth);
  }
  var kx = orient === "vertical" ? (height - nodeWidth) / maxDepth : (width - nodeWidth) / maxDepth;
  scaleNodeBreadths(nodes, kx, orient);
}
function isNodeDepth(node) {
  var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
  return item.depth != null && item.depth >= 0;
}
function adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth) {
  if (nodeAlign === "right") {
    var nextSourceNode = [];
    var remainNodes = nodes;
    var nodeHeight = 0;
    while (remainNodes.length) {
      for (var i = 0; i < remainNodes.length; i++) {
        var node = remainNodes[i];
        node.setLayout({
          skNodeHeight: nodeHeight
        }, true);
        for (var j = 0; j < node.inEdges.length; j++) {
          var edge = node.inEdges[j];
          if (nextSourceNode.indexOf(edge.node1) < 0) {
            nextSourceNode.push(edge.node1);
          }
        }
      }
      remainNodes = nextSourceNode;
      nextSourceNode = [];
      ++nodeHeight;
    }
    each$f(nodes, function(node2) {
      if (!isNodeDepth(node2)) {
        node2.setLayout({
          depth: Math.max(0, maxDepth - node2.getLayout().skNodeHeight)
        }, true);
      }
    });
  } else if (nodeAlign === "justify") {
    moveSinksRight(nodes, maxDepth);
  }
}
function moveSinksRight(nodes, maxDepth) {
  each$f(nodes, function(node) {
    if (!isNodeDepth(node) && !node.outEdges.length) {
      node.setLayout({
        depth: maxDepth
      }, true);
    }
  });
}
function scaleNodeBreadths(nodes, kx, orient) {
  each$f(nodes, function(node) {
    var nodeDepth = node.getLayout().depth * kx;
    orient === "vertical" ? node.setLayout({
      y: nodeDepth
    }, true) : node.setLayout({
      x: nodeDepth
    }, true);
  });
}
function computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient) {
  var nodesByBreadth = prepareNodesByBreadth(nodes, orient);
  initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient);
  resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  for (var alpha = 1; iterations > 0; iterations--) {
    alpha *= 0.99;
    relaxRightToLeft(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
    relaxLeftToRight(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  }
}
function prepareNodesByBreadth(nodes, orient) {
  var nodesByBreadth = [];
  var keyAttr = orient === "vertical" ? "y" : "x";
  var groupResult = groupData(nodes, function(node) {
    return node.getLayout()[keyAttr];
  });
  groupResult.keys.sort(function(a, b2) {
    return a - b2;
  });
  each$f(groupResult.keys, function(key) {
    nodesByBreadth.push(groupResult.buckets.get(key));
  });
  return nodesByBreadth;
}
function initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient) {
  var minKy = Infinity;
  each$f(nodesByBreadth, function(nodes) {
    var n2 = nodes.length;
    var sum2 = 0;
    each$f(nodes, function(node) {
      sum2 += node.getLayout().value;
    });
    var ky = orient === "vertical" ? (width - (n2 - 1) * nodeGap) / sum2 : (height - (n2 - 1) * nodeGap) / sum2;
    if (ky < minKy) {
      minKy = ky;
    }
  });
  each$f(nodesByBreadth, function(nodes) {
    each$f(nodes, function(node, i) {
      var nodeDy = node.getLayout().value * minKy;
      if (orient === "vertical") {
        node.setLayout({
          x: i
        }, true);
        node.setLayout({
          dx: nodeDy
        }, true);
      } else {
        node.setLayout({
          y: i
        }, true);
        node.setLayout({
          dy: nodeDy
        }, true);
      }
    });
  });
  each$f(edges, function(edge) {
    var edgeDy = +edge.getValue() * minKy;
    edge.setLayout({
      dy: edgeDy
    }, true);
  });
}
function resolveCollisions(nodesByBreadth, nodeGap, height, width, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$f(nodesByBreadth, function(nodes) {
    nodes.sort(function(a, b2) {
      return a.getLayout()[keyAttr] - b2.getLayout()[keyAttr];
    });
    var nodeX;
    var node;
    var dy;
    var y0 = 0;
    var n2 = nodes.length;
    var nodeDyAttr = orient === "vertical" ? "dx" : "dy";
    for (var i = 0; i < n2; i++) {
      node = nodes[i];
      dy = y0 - node.getLayout()[keyAttr];
      if (dy > 0) {
        nodeX = node.getLayout()[keyAttr] + dy;
        orient === "vertical" ? node.setLayout({
          x: nodeX
        }, true) : node.setLayout({
          y: nodeX
        }, true);
      }
      y0 = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap;
    }
    var viewWidth = orient === "vertical" ? width : height;
    dy = y0 - nodeGap - viewWidth;
    if (dy > 0) {
      nodeX = node.getLayout()[keyAttr] - dy;
      orient === "vertical" ? node.setLayout({
        x: nodeX
      }, true) : node.setLayout({
        y: nodeX
      }, true);
      y0 = nodeX;
      for (var i = n2 - 2; i >= 0; --i) {
        node = nodes[i];
        dy = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap - y0;
        if (dy > 0) {
          nodeX = node.getLayout()[keyAttr] - dy;
          orient === "vertical" ? node.setLayout({
            x: nodeX
          }, true) : node.setLayout({
            y: nodeX
          }, true);
        }
        y0 = node.getLayout()[keyAttr];
      }
    }
  });
}
function relaxRightToLeft(nodesByBreadth, alpha, orient) {
  each$f(nodesByBreadth.slice().reverse(), function(nodes) {
    each$f(nodes, function(node) {
      if (node.outEdges.length) {
        var y2 = sum(node.outEdges, weightedTarget, orient) / sum(node.outEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.outEdges.length;
          y2 = len2 ? sum(node.outEdges, centerTarget, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function weightedTarget(edge, orient) {
  return center(edge.node2, orient) * edge.getValue();
}
function centerTarget(edge, orient) {
  return center(edge.node2, orient);
}
function weightedSource(edge, orient) {
  return center(edge.node1, orient) * edge.getValue();
}
function centerSource(edge, orient) {
  return center(edge.node1, orient);
}
function center(node, orient) {
  return orient === "vertical" ? node.getLayout().x + node.getLayout().dx / 2 : node.getLayout().y + node.getLayout().dy / 2;
}
function getEdgeValue(edge) {
  return edge.getValue();
}
function sum(array4, cb, orient) {
  var sum2 = 0;
  var len2 = array4.length;
  var i = -1;
  while (++i < len2) {
    var value = +cb(array4[i], orient);
    if (!isNaN(value)) {
      sum2 += value;
    }
  }
  return sum2;
}
function relaxLeftToRight(nodesByBreadth, alpha, orient) {
  each$f(nodesByBreadth, function(nodes) {
    each$f(nodes, function(node) {
      if (node.inEdges.length) {
        var y2 = sum(node.inEdges, weightedSource, orient) / sum(node.inEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.inEdges.length;
          y2 = len2 ? sum(node.inEdges, centerSource, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function computeEdgeDepths(nodes, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$f(nodes, function(node) {
    node.outEdges.sort(function(a, b2) {
      return a.node2.getLayout()[keyAttr] - b2.node2.getLayout()[keyAttr];
    });
    node.inEdges.sort(function(a, b2) {
      return a.node1.getLayout()[keyAttr] - b2.node1.getLayout()[keyAttr];
    });
  });
  each$f(nodes, function(node) {
    var sy = 0;
    var ty = 0;
    each$f(node.outEdges, function(edge) {
      edge.setLayout({
        sy
      }, true);
      sy += edge.getLayout().dy;
    });
    each$f(node.inEdges, function(edge) {
      edge.setLayout({
        ty
      }, true);
      ty += edge.getLayout().dy;
    });
  });
}
function sankeyVisual(ecModel) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    if (nodes.length) {
      var minValue_1 = Infinity;
      var maxValue_1 = -Infinity;
      each$f(nodes, function(node) {
        var nodeValue = node.getLayout().value;
        if (nodeValue < minValue_1) {
          minValue_1 = nodeValue;
        }
        if (nodeValue > maxValue_1) {
          maxValue_1 = nodeValue;
        }
      });
      each$f(nodes, function(node) {
        var mapping = new VisualMapping$1({
          type: "color",
          mappingMethod: "linear",
          dataExtent: [minValue_1, maxValue_1],
          visual: seriesModel.get("color")
        });
        var mapValueToColor = mapping.mapValueToVisual(node.getLayout().value);
        var customColor = node.getModel().get(["itemStyle", "color"]);
        if (customColor != null) {
          node.setVisual("color", customColor);
          node.setVisual("style", {
            fill: customColor
          });
        } else {
          node.setVisual("color", mapValueToColor);
          node.setVisual("style", {
            fill: mapValueToColor
          });
        }
      });
    }
  });
}
function install$A(registers) {
  registers.registerChartView(SankeyView$1);
  registers.registerSeriesModel(SankeySeriesModel$1);
  registers.registerLayout(sankeyLayout);
  registers.registerVisual(sankeyVisual);
  registers.registerAction({
    type: "dragNode",
    event: "dragnode",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sankey",
      query: payload
    }, function(seriesModel) {
      seriesModel.setNodePosition(payload.dataIndex, [payload.localX, payload.localY]);
    });
  });
}
var WhiskerBoxCommonMixin = function() {
  function WhiskerBoxCommonMixin2() {
  }
  WhiskerBoxCommonMixin2.prototype.getInitialData = function(option, ecModel) {
    var ordinalMeta;
    var xAxisModel = ecModel.getComponent("xAxis", this.get("xAxisIndex"));
    var yAxisModel = ecModel.getComponent("yAxis", this.get("yAxisIndex"));
    var xAxisType = xAxisModel.get("type");
    var yAxisType = yAxisModel.get("type");
    var addOrdinal;
    if (xAxisType === "category") {
      option.layout = "horizontal";
      ordinalMeta = xAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else if (yAxisType === "category") {
      option.layout = "vertical";
      ordinalMeta = yAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else {
      option.layout = option.layout || "horizontal";
    }
    var coordDims = ["x", "y"];
    var baseAxisDimIndex = option.layout === "horizontal" ? 0 : 1;
    var baseAxisDim = this._baseAxisDim = coordDims[baseAxisDimIndex];
    var otherAxisDim = coordDims[1 - baseAxisDimIndex];
    var axisModels = [xAxisModel, yAxisModel];
    var baseAxisType = axisModels[baseAxisDimIndex].get("type");
    var otherAxisType = axisModels[1 - baseAxisDimIndex].get("type");
    var data = option.data;
    if (data && addOrdinal) {
      var newOptionData_1 = [];
      each$f(data, function(item, index2) {
        var newItem;
        if (isArray$1(item)) {
          newItem = item.slice();
          item.unshift(index2);
        } else if (isArray$1(item.value)) {
          newItem = extend({}, item);
          newItem.value = newItem.value.slice();
          item.value.unshift(index2);
        } else {
          newItem = item;
        }
        newOptionData_1.push(newItem);
      });
      option.data = newOptionData_1;
    }
    var defaultValueDimensions = this.defaultValueDimensions;
    var coordDimensions = [{
      name: baseAxisDim,
      type: getDimensionTypeByAxis(baseAxisType),
      ordinalMeta,
      otherDims: {
        tooltip: false,
        itemName: 0
      },
      dimsDef: ["base"]
    }, {
      name: otherAxisDim,
      type: getDimensionTypeByAxis(otherAxisType),
      dimsDef: defaultValueDimensions.slice()
    }];
    return createSeriesDataSimply(this, {
      coordDimensions,
      dimensionsCount: defaultValueDimensions.length + 1,
      encodeDefaulter: curry$1(makeSeriesEncodeForAxisCoordSys, coordDimensions, this)
    });
  };
  WhiskerBoxCommonMixin2.prototype.getBaseAxis = function() {
    var dim = this._baseAxisDim;
    return this.ecModel.getComponent(dim + "Axis", this.get(dim + "AxisIndex")).axis;
  };
  return WhiskerBoxCommonMixin2;
}();
var BoxplotSeriesModel = function(_super) {
  __extends(BoxplotSeriesModel2, _super);
  function BoxplotSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "min",
      defaultTooltip: true
    }, {
      name: "Q1",
      defaultTooltip: true
    }, {
      name: "median",
      defaultTooltip: true
    }, {
      name: "Q3",
      defaultTooltip: true
    }, {
      name: "max",
      defaultTooltip: true
    }];
    _this.visualDrawType = "stroke";
    return _this;
  }
  BoxplotSeriesModel2.type = "series.boxplot";
  BoxplotSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  BoxplotSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    boxWidth: [7, 50],
    itemStyle: {
      color: "#fff",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2,
        shadowBlur: 5,
        shadowOffsetX: 1,
        shadowOffsetY: 1,
        shadowColor: "rgba(0,0,0,0.2)"
      }
    },
    animationDuration: 800
  };
  return BoxplotSeriesModel2;
}(SeriesModel$1);
mixin(BoxplotSeriesModel, WhiskerBoxCommonMixin, true);
var BoxplotSeriesModel$1 = BoxplotSeriesModel;
var BoxplotView = function(_super) {
  __extends(BoxplotView2, _super);
  function BoxplotView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotView2.type;
    return _this;
  }
  BoxplotView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var group = this.group;
    var oldData = this._data;
    if (!this._data) {
      group.removeAll();
    }
    var constDim = seriesModel.get("layout") === "horizontal" ? 1 : 0;
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        var symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim, true);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(symbolEl);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (!symbolEl) {
        symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim);
      } else {
        saveOldStyle(symbolEl);
        updateNormalBoxData(itemLayout, symbolEl, data, newIdx);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  BoxplotView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var data = this._data;
    this._data = null;
    data && data.eachItemGraphicEl(function(el) {
      el && group.remove(el);
    });
  };
  BoxplotView2.type = "boxplot";
  return BoxplotView2;
}(ChartView$1);
var BoxPathShape = function() {
  function BoxPathShape2() {
  }
  return BoxPathShape2;
}();
var BoxPath = function(_super) {
  __extends(BoxPath2, _super);
  function BoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "boxplotBoxPath";
    return _this;
  }
  BoxPath2.prototype.getDefaultShape = function() {
    return new BoxPathShape();
  };
  BoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    var i = 0;
    ctx.moveTo(ends[i][0], ends[i][1]);
    i++;
    for (; i < 4; i++) {
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
    ctx.closePath();
    for (; i < ends.length; i++) {
      ctx.moveTo(ends[i][0], ends[i][1]);
      i++;
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
  };
  return BoxPath2;
}(Path$1);
function createNormalBox$1(itemLayout, data, dataIndex, constDim, isInit) {
  var ends = itemLayout.ends;
  var el = new BoxPath({
    shape: {
      points: isInit ? transInit$1(ends, constDim, itemLayout) : ends
    }
  });
  updateNormalBoxData(itemLayout, el, data, dataIndex, isInit);
  return el;
}
function updateNormalBoxData(itemLayout, el, data, dataIndex, isInit) {
  var seriesModel = data.hostModel;
  var updateMethod = graphic[isInit ? "initProps" : "updateProps"];
  updateMethod(el, {
    shape: {
      points: itemLayout.ends
    }
  }, seriesModel, dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.z2 = 100;
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function transInit$1(points2, dim, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[dim] = itemLayout.initBaseline;
    return point;
  });
}
var BoxplotView$1 = BoxplotView;
function boxplotVisual(ecModel, api) {
}
var each$9 = each$f;
function boxplotLayout(ecModel) {
  var groupResult = groupSeriesByAxis(ecModel);
  each$9(groupResult, function(groupItem) {
    var seriesModels = groupItem.seriesModels;
    if (!seriesModels.length) {
      return;
    }
    calculateBase(groupItem);
    each$9(seriesModels, function(seriesModel, idx) {
      layoutSingleSeries(seriesModel, groupItem.boxOffsetList[idx], groupItem.boxWidthList[idx]);
    });
  });
}
function groupSeriesByAxis(ecModel) {
  var result = [];
  var axisList = [];
  ecModel.eachSeriesByType("boxplot", function(seriesModel) {
    var baseAxis = seriesModel.getBaseAxis();
    var idx = indexOf(axisList, baseAxis);
    if (idx < 0) {
      idx = axisList.length;
      axisList[idx] = baseAxis;
      result[idx] = {
        axis: baseAxis,
        seriesModels: []
      };
    }
    result[idx].seriesModels.push(seriesModel);
  });
  return result;
}
function calculateBase(groupItem) {
  var baseAxis = groupItem.axis;
  var seriesModels = groupItem.seriesModels;
  var seriesCount = seriesModels.length;
  var boxWidthList = groupItem.boxWidthList = [];
  var boxOffsetList = groupItem.boxOffsetList = [];
  var boundList = [];
  var bandWidth;
  if (baseAxis.type === "category") {
    bandWidth = baseAxis.getBandWidth();
  } else {
    var maxDataCount_1 = 0;
    each$9(seriesModels, function(seriesModel) {
      maxDataCount_1 = Math.max(maxDataCount_1, seriesModel.getData().count());
    });
    var extent3 = baseAxis.getExtent();
    bandWidth = Math.abs(extent3[1] - extent3[0]) / maxDataCount_1;
  }
  each$9(seriesModels, function(seriesModel) {
    var boxWidthBound = seriesModel.get("boxWidth");
    if (!isArray$1(boxWidthBound)) {
      boxWidthBound = [boxWidthBound, boxWidthBound];
    }
    boundList.push([parsePercent(boxWidthBound[0], bandWidth) || 0, parsePercent(boxWidthBound[1], bandWidth) || 0]);
  });
  var availableWidth = bandWidth * 0.8 - 2;
  var boxGap = availableWidth / seriesCount * 0.3;
  var boxWidth = (availableWidth - boxGap * (seriesCount - 1)) / seriesCount;
  var base2 = boxWidth / 2 - availableWidth / 2;
  each$9(seriesModels, function(seriesModel, idx) {
    boxOffsetList.push(base2);
    base2 += boxGap + boxWidth;
    boxWidthList.push(Math.min(Math.max(boxWidth, boundList[idx][0]), boundList[idx][1]));
  });
}
function layoutSingleSeries(seriesModel, offset, boxWidth) {
  var coordSys = seriesModel.coordinateSystem;
  var data = seriesModel.getData();
  var halfWidth = boxWidth / 2;
  var cDimIdx = seriesModel.get("layout") === "horizontal" ? 0 : 1;
  var vDimIdx = 1 - cDimIdx;
  var coordDims = ["x", "y"];
  var cDim = data.mapDimension(coordDims[cDimIdx]);
  var vDims = data.mapDimensionsAll(coordDims[vDimIdx]);
  if (cDim == null || vDims.length < 5) {
    return;
  }
  for (var dataIndex = 0; dataIndex < data.count(); dataIndex++) {
    var axisDimVal = data.get(cDim, dataIndex);
    var median = getPoint(axisDimVal, vDims[2], dataIndex);
    var end1 = getPoint(axisDimVal, vDims[0], dataIndex);
    var end2 = getPoint(axisDimVal, vDims[1], dataIndex);
    var end4 = getPoint(axisDimVal, vDims[3], dataIndex);
    var end5 = getPoint(axisDimVal, vDims[4], dataIndex);
    var ends = [];
    addBodyEnd(ends, end2, false);
    addBodyEnd(ends, end4, true);
    ends.push(end1, end2, end5, end4);
    layEndLine(ends, end1);
    layEndLine(ends, end5);
    layEndLine(ends, median);
    data.setItemLayout(dataIndex, {
      initBaseline: median[vDimIdx],
      ends
    });
  }
  function getPoint(axisDimVal2, dim, dataIndex2) {
    var val = data.get(dim, dataIndex2);
    var p2 = [];
    p2[cDimIdx] = axisDimVal2;
    p2[vDimIdx] = val;
    var point;
    if (isNaN(axisDimVal2) || isNaN(val)) {
      point = [NaN, NaN];
    } else {
      point = coordSys.dataToPoint(p2);
      point[cDimIdx] += offset;
    }
    return point;
  }
  function addBodyEnd(ends2, point, start2) {
    var point1 = point.slice();
    var point2 = point.slice();
    point1[cDimIdx] += halfWidth;
    point2[cDimIdx] -= halfWidth;
    start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
  }
  function layEndLine(ends2, endCenter) {
    var from = endCenter.slice();
    var to = endCenter.slice();
    from[cDimIdx] -= halfWidth;
    to[cDimIdx] += halfWidth;
    ends2.push(from, to);
  }
}
function prepareBoxplotData(rawData, opt) {
  opt = opt || {};
  var boxData = [];
  var outliers = [];
  var boundIQR = opt.boundIQR;
  var useExtreme = boundIQR === "none" || boundIQR === 0;
  for (var i = 0; i < rawData.length; i++) {
    var ascList = asc$2(rawData[i].slice());
    var Q1 = quantile(ascList, 0.25);
    var Q2 = quantile(ascList, 0.5);
    var Q3 = quantile(ascList, 0.75);
    var min3 = ascList[0];
    var max3 = ascList[ascList.length - 1];
    var bound = (boundIQR == null ? 1.5 : boundIQR) * (Q3 - Q1);
    var low = useExtreme ? min3 : Math.max(min3, Q1 - bound);
    var high = useExtreme ? max3 : Math.min(max3, Q3 + bound);
    var itemNameFormatter = opt.itemNameFormatter;
    var itemName = isFunction(itemNameFormatter) ? itemNameFormatter({
      value: i
    }) : isString(itemNameFormatter) ? itemNameFormatter.replace("{value}", i + "") : i + "";
    boxData.push([itemName, low, Q1, Q2, Q3, high]);
    for (var j = 0; j < ascList.length; j++) {
      var dataItem = ascList[j];
      if (dataItem < low || dataItem > high) {
        var outlier = [itemName, dataItem];
        outliers.push(outlier);
      }
    }
  }
  return {
    boxData,
    outliers
  };
}
var boxplotTransform = {
  type: "echarts:boxplot",
  transform: function transform(params) {
    var upstream = params.upstream;
    if (upstream.sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS) {
      var errMsg = "";
      throwError(errMsg);
    }
    var result = prepareBoxplotData(upstream.getRawData(), params.config);
    return [{
      dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"],
      data: result.boxData
    }, {
      data: result.outliers
    }];
  }
};
function install$z(registers) {
  registers.registerSeriesModel(BoxplotSeriesModel$1);
  registers.registerChartView(BoxplotView$1);
  registers.registerVisual(boxplotVisual);
  registers.registerLayout(boxplotLayout);
  registers.registerTransform(boxplotTransform);
}
var SKIP_PROPS = ["color", "borderColor"];
var CandlestickView = function(_super) {
  __extends(CandlestickView2, _super);
  function CandlestickView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickView2.type;
    return _this;
  }
  CandlestickView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeClipPath();
    this._progressiveEls = null;
    this._updateDrawMode(seriesModel);
    this._isLargeDraw ? this._renderLarge(seriesModel) : this._renderNormal(seriesModel);
  };
  CandlestickView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._clear();
    this._updateDrawMode(seriesModel);
  };
  CandlestickView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    this._progressiveEls = [];
    this._isLargeDraw ? this._incrementalRenderLarge(params, seriesModel) : this._incrementalRenderNormal(params, seriesModel);
  };
  CandlestickView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  CandlestickView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  CandlestickView2.prototype._renderNormal = function(seriesModel) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var isSimpleBox = data.getLayout("isSimpleBox");
    var needsClip = seriesModel.get("clip", true);
    var coord = seriesModel.coordinateSystem;
    var clipArea = coord.getArea && coord.getArea();
    if (!this._data) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
          return;
        }
        var el = createNormalBox(itemLayout, newIdx, true);
        initProps(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        setBoxCommon(el, data, newIdx, isSimpleBox);
        group.add(el);
        data.setItemGraphicEl(newIdx, el);
      }
    }).update(function(newIdx, oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(el);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
        group.remove(el);
        return;
      }
      if (!el) {
        el = createNormalBox(itemLayout);
      } else {
        updateProps$1(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        saveOldStyle(el);
      }
      setBoxCommon(el, data, newIdx, isSimpleBox);
      group.add(el);
      data.setItemGraphicEl(newIdx, el);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  CandlestickView2.prototype._renderLarge = function(seriesModel) {
    this._clear();
    createLarge(seriesModel, this.group);
    var clipPath = seriesModel.get("clip", true) ? createClipPath(seriesModel.coordinateSystem, false, seriesModel) : null;
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
  };
  CandlestickView2.prototype._incrementalRenderNormal = function(params, seriesModel) {
    var data = seriesModel.getData();
    var isSimpleBox = data.getLayout("isSimpleBox");
    var dataIndex;
    while ((dataIndex = params.next()) != null) {
      var itemLayout = data.getItemLayout(dataIndex);
      var el = createNormalBox(itemLayout);
      setBoxCommon(el, data, dataIndex, isSimpleBox);
      el.incremental = true;
      this.group.add(el);
      this._progressiveEls.push(el);
    }
  };
  CandlestickView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    createLarge(seriesModel, this.group, this._progressiveEls, true);
  };
  CandlestickView2.prototype.remove = function(ecModel) {
    this._clear();
  };
  CandlestickView2.prototype._clear = function() {
    this.group.removeAll();
    this._data = null;
  };
  CandlestickView2.type = "candlestick";
  return CandlestickView2;
}(ChartView$1);
var NormalBoxPathShape = function() {
  function NormalBoxPathShape2() {
  }
  return NormalBoxPathShape2;
}();
var NormalBoxPath = function(_super) {
  __extends(NormalBoxPath2, _super);
  function NormalBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "normalCandlestickBox";
    return _this;
  }
  NormalBoxPath2.prototype.getDefaultShape = function() {
    return new NormalBoxPathShape();
  };
  NormalBoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    if (this.__simpleBox) {
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[6][0], ends[6][1]);
    } else {
      ctx.moveTo(ends[0][0], ends[0][1]);
      ctx.lineTo(ends[1][0], ends[1][1]);
      ctx.lineTo(ends[2][0], ends[2][1]);
      ctx.lineTo(ends[3][0], ends[3][1]);
      ctx.closePath();
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[5][0], ends[5][1]);
      ctx.moveTo(ends[6][0], ends[6][1]);
      ctx.lineTo(ends[7][0], ends[7][1]);
    }
  };
  return NormalBoxPath2;
}(Path$1);
function createNormalBox(itemLayout, dataIndex, isInit) {
  var ends = itemLayout.ends;
  return new NormalBoxPath({
    shape: {
      points: isInit ? transInit(ends, itemLayout) : ends
    },
    z2: 100
  });
}
function isNormalBoxClipped(clipArea, itemLayout) {
  var clipped = true;
  for (var i = 0; i < itemLayout.ends.length; i++) {
    if (clipArea.contain(itemLayout.ends[i][0], itemLayout.ends[i][1])) {
      clipped = false;
      break;
    }
  }
  return clipped;
}
function setBoxCommon(el, data, dataIndex, isSimpleBox) {
  var itemModel = data.getItemModel(dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.__simpleBox = isSimpleBox;
  setStatesStylesFromModel(el, itemModel);
}
function transInit(points2, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[1] = itemLayout.initBaseline;
    return point;
  });
}
var LargeBoxPathShape = function() {
  function LargeBoxPathShape2() {
  }
  return LargeBoxPathShape2;
}();
var LargeBoxPath = function(_super) {
  __extends(LargeBoxPath2, _super);
  function LargeBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeCandlestickBox";
    return _this;
  }
  LargeBoxPath2.prototype.getDefaultShape = function() {
    return new LargeBoxPathShape();
  };
  LargeBoxPath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    for (var i = 0; i < points2.length; ) {
      if (this.__sign === points2[i++]) {
        var x2 = points2[i++];
        ctx.moveTo(x2, points2[i++]);
        ctx.lineTo(x2, points2[i++]);
      } else {
        i += 3;
      }
    }
  };
  return LargeBoxPath2;
}(Path$1);
function createLarge(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var largePoints = data.getLayout("largePoints");
  var elP = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: 1
  });
  group.add(elP);
  var elN = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: -1
  });
  group.add(elN);
  setLargeStyle(1, elP, seriesModel);
  setLargeStyle(-1, elN, seriesModel);
  if (incremental) {
    elP.incremental = true;
    elN.incremental = true;
  }
  if (progressiveEls) {
    progressiveEls.push(elP, elN);
  }
}
function setLargeStyle(sign, el, seriesModel, data) {
  var borderColor = seriesModel.get(["itemStyle", sign > 0 ? "borderColor" : "borderColor0"]) || seriesModel.get(["itemStyle", sign > 0 ? "color" : "color0"]);
  var itemStyle = seriesModel.getModel("itemStyle").getItemStyle(SKIP_PROPS);
  el.useStyle(itemStyle);
  el.style.fill = null;
  el.style.stroke = borderColor;
}
var CandlestickView$1 = CandlestickView;
var CandlestickSeriesModel = function(_super) {
  __extends(CandlestickSeriesModel2, _super);
  function CandlestickSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "open",
      defaultTooltip: true
    }, {
      name: "close",
      defaultTooltip: true
    }, {
      name: "lowest",
      defaultTooltip: true
    }, {
      name: "highest",
      defaultTooltip: true
    }];
    return _this;
  }
  CandlestickSeriesModel2.prototype.getShadowDim = function() {
    return "open";
  };
  CandlestickSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    var itemLayout = data.getItemLayout(dataIndex);
    return itemLayout && selectors.rect(itemLayout.brushRect);
  };
  CandlestickSeriesModel2.type = "series.candlestick";
  CandlestickSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  CandlestickSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    clip: true,
    itemStyle: {
      color: "#eb5454",
      color0: "#47b262",
      borderColor: "#eb5454",
      borderColor0: "#47b262",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2
      }
    },
    barMaxWidth: null,
    barMinWidth: null,
    barWidth: null,
    large: true,
    largeThreshold: 600,
    progressive: 3e3,
    progressiveThreshold: 1e4,
    progressiveChunkMode: "mod",
    animationEasing: "linear",
    animationDuration: 300
  };
  return CandlestickSeriesModel2;
}(SeriesModel$1);
mixin(CandlestickSeriesModel, WhiskerBoxCommonMixin, true);
var CandlestickSeriesModel$1 = CandlestickSeriesModel;
function candlestickPreprocessor(option) {
  if (!option || !isArray$1(option.series)) {
    return;
  }
  each$f(option.series, function(seriesItem) {
    if (isObject$4(seriesItem) && seriesItem.type === "k") {
      seriesItem.type = "candlestick";
    }
  });
}
var positiveBorderColorQuery = ["itemStyle", "borderColor"];
var negativeBorderColorQuery = ["itemStyle", "borderColor0"];
var positiveColorQuery = ["itemStyle", "color"];
var negativeColorQuery = ["itemStyle", "color0"];
var candlestickVisual = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    function getColor(sign, model) {
      return model.get(sign > 0 ? positiveColorQuery : negativeColorQuery);
    }
    function getBorderColor(sign, model) {
      return model.get(sign > 0 ? positiveBorderColorQuery : negativeBorderColorQuery);
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var isLargeRender = seriesModel.pipelineContext.large;
    return !isLargeRender && {
      progress: function(params, data) {
        var dataIndex;
        while ((dataIndex = params.next()) != null) {
          var itemModel = data.getItemModel(dataIndex);
          var sign = data.getItemLayout(dataIndex).sign;
          var style = itemModel.getItemStyle();
          style.fill = getColor(sign, itemModel);
          style.stroke = getBorderColor(sign, itemModel) || style.fill;
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          extend(existsStyle, style);
        }
      }
    };
  }
};
var candlestickVisual$1 = candlestickVisual;
var candlestickLayout = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var data = seriesModel.getData();
    var candleWidth = calculateCandleWidth(seriesModel, data);
    var cDimIdx = 0;
    var vDimIdx = 1;
    var coordDims = ["x", "y"];
    var cDimI = data.getDimensionIndex(data.mapDimension(coordDims[cDimIdx]));
    var vDimsI = map$1(data.mapDimensionsAll(coordDims[vDimIdx]), data.getDimensionIndex, data);
    var openDimI = vDimsI[0];
    var closeDimI = vDimsI[1];
    var lowestDimI = vDimsI[2];
    var highestDimI = vDimsI[3];
    data.setLayout({
      candleWidth,
      isSimpleBox: candleWidth <= 1.3
    });
    if (cDimI < 0 || vDimsI.length < 4) {
      return;
    }
    return {
      progress: seriesModel.pipelineContext.large ? largeProgress : normalProgress
    };
    function normalProgress(params, data2) {
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        var ocLow = Math.min(openVal, closeVal);
        var ocHigh = Math.max(openVal, closeVal);
        var ocLowPoint = getPoint(ocLow, axisDimVal);
        var ocHighPoint = getPoint(ocHigh, axisDimVal);
        var lowestPoint = getPoint(lowestVal, axisDimVal);
        var highestPoint = getPoint(highestVal, axisDimVal);
        var ends = [];
        addBodyEnd(ends, ocHighPoint, 0);
        addBodyEnd(ends, ocLowPoint, 1);
        ends.push(subPixelOptimizePoint(highestPoint), subPixelOptimizePoint(ocHighPoint), subPixelOptimizePoint(lowestPoint), subPixelOptimizePoint(ocLowPoint));
        data2.setItemLayout(dataIndex, {
          sign: getSign(store, dataIndex, openVal, closeVal, closeDimI),
          initBaseline: openVal > closeVal ? ocHighPoint[vDimIdx] : ocLowPoint[vDimIdx],
          ends,
          brushRect: makeBrushRect(lowestVal, highestVal, axisDimVal)
        });
      }
      function getPoint(val, axisDimVal2) {
        var p2 = [];
        p2[cDimIdx] = axisDimVal2;
        p2[vDimIdx] = val;
        return isNaN(axisDimVal2) || isNaN(val) ? [NaN, NaN] : coordSys.dataToPoint(p2);
      }
      function addBodyEnd(ends2, point, start2) {
        var point1 = point.slice();
        var point2 = point.slice();
        point1[cDimIdx] = subPixelOptimize(point1[cDimIdx] + candleWidth / 2, 1, false);
        point2[cDimIdx] = subPixelOptimize(point2[cDimIdx] - candleWidth / 2, 1, true);
        start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
      }
      function makeBrushRect(lowestVal2, highestVal2, axisDimVal2) {
        var pmin = getPoint(lowestVal2, axisDimVal2);
        var pmax = getPoint(highestVal2, axisDimVal2);
        pmin[cDimIdx] -= candleWidth / 2;
        pmax[cDimIdx] -= candleWidth / 2;
        return {
          x: pmin[0],
          y: pmin[1],
          width: candleWidth,
          height: pmax[1] - pmin[1]
        };
      }
      function subPixelOptimizePoint(point) {
        point[cDimIdx] = subPixelOptimize(point[cDimIdx], 1);
        return point;
      }
    }
    function largeProgress(params, data2) {
      var points2 = createFloat32Array(params.count * 4);
      var offset = 0;
      var point;
      var tmpIn = [];
      var tmpOut = [];
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        if (isNaN(axisDimVal) || isNaN(lowestVal) || isNaN(highestVal)) {
          points2[offset++] = NaN;
          offset += 3;
          continue;
        }
        points2[offset++] = getSign(store, dataIndex, openVal, closeVal, closeDimI);
        tmpIn[cDimIdx] = axisDimVal;
        tmpIn[vDimIdx] = lowestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset++] = point ? point[0] : NaN;
        points2[offset++] = point ? point[1] : NaN;
        tmpIn[vDimIdx] = highestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset++] = point ? point[1] : NaN;
      }
      data2.setLayout("largePoints", points2);
    }
  }
};
function getSign(store, dataIndex, openVal, closeVal, closeDimI) {
  var sign;
  if (openVal > closeVal) {
    sign = -1;
  } else if (openVal < closeVal) {
    sign = 1;
  } else {
    sign = dataIndex > 0 ? store.get(closeDimI, dataIndex - 1) <= closeVal ? 1 : -1 : 1;
  }
  return sign;
}
function calculateCandleWidth(seriesModel, data) {
  var baseAxis = seriesModel.getBaseAxis();
  var extent3;
  var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : (extent3 = baseAxis.getExtent(), Math.abs(extent3[1] - extent3[0]) / data.count());
  var barMaxWidth = parsePercent(retrieve2(seriesModel.get("barMaxWidth"), bandWidth), bandWidth);
  var barMinWidth = parsePercent(retrieve2(seriesModel.get("barMinWidth"), 1), bandWidth);
  var barWidth = seriesModel.get("barWidth");
  return barWidth != null ? parsePercent(barWidth, bandWidth) : Math.max(Math.min(bandWidth / 2, barMaxWidth), barMinWidth);
}
var candlestickLayout$1 = candlestickLayout;
function install$y(registers) {
  registers.registerChartView(CandlestickView$1);
  registers.registerSeriesModel(CandlestickSeriesModel$1);
  registers.registerPreprocessor(candlestickPreprocessor);
  registers.registerVisual(candlestickVisual$1);
  registers.registerLayout(candlestickLayout$1);
}
function updateRipplePath(rippleGroup, effectCfg) {
  var color = effectCfg.rippleEffectColor || effectCfg.color;
  rippleGroup.eachChild(function(ripplePath) {
    ripplePath.attr({
      z: effectCfg.z,
      zlevel: effectCfg.zlevel,
      style: {
        stroke: effectCfg.brushType === "stroke" ? color : null,
        fill: effectCfg.brushType === "fill" ? color : null
      }
    });
  });
}
var EffectSymbol = function(_super) {
  __extends(EffectSymbol2, _super);
  function EffectSymbol2(data, idx) {
    var _this = _super.call(this) || this;
    var symbol = new SymbolClz(data, idx);
    var rippleGroup = new Group$4();
    _this.add(symbol);
    _this.add(rippleGroup);
    _this.updateData(data, idx);
    return _this;
  }
  EffectSymbol2.prototype.stopEffectAnimation = function() {
    this.childAt(1).removeAll();
  };
  EffectSymbol2.prototype.startEffectAnimation = function(effectCfg) {
    var symbolType = effectCfg.symbolType;
    var color = effectCfg.color;
    var rippleNumber = effectCfg.rippleNumber;
    var rippleGroup = this.childAt(1);
    for (var i = 0; i < rippleNumber; i++) {
      var ripplePath = createSymbol$1(symbolType, -1, -1, 2, 2, color);
      ripplePath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 99,
        silent: true,
        scaleX: 0.5,
        scaleY: 0.5
      });
      var delay = -i / rippleNumber * effectCfg.period + effectCfg.effectOffset;
      ripplePath.animate("", true).when(effectCfg.period, {
        scaleX: effectCfg.rippleScale / 2,
        scaleY: effectCfg.rippleScale / 2
      }).delay(delay).start();
      ripplePath.animateStyle(true).when(effectCfg.period, {
        opacity: 0
      }).delay(delay).start();
      rippleGroup.add(ripplePath);
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.updateEffectAnimation = function(effectCfg) {
    var oldEffectCfg = this._effectCfg;
    var rippleGroup = this.childAt(1);
    var DIFFICULT_PROPS = ["symbolType", "period", "rippleScale", "rippleNumber"];
    for (var i = 0; i < DIFFICULT_PROPS.length; i++) {
      var propName = DIFFICULT_PROPS[i];
      if (oldEffectCfg[propName] !== effectCfg[propName]) {
        this.stopEffectAnimation();
        this.startEffectAnimation(effectCfg);
        return;
      }
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  EffectSymbol2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  EffectSymbol2.prototype.getSymbolType = function() {
    var symbol = this.childAt(0);
    return symbol && symbol.getSymbolType();
  };
  EffectSymbol2.prototype.updateData = function(data, idx) {
    var _this = this;
    var seriesModel = data.hostModel;
    this.childAt(0).updateData(data, idx);
    var rippleGroup = this.childAt(1);
    var itemModel = data.getItemModel(idx);
    var symbolType = data.getItemVisual(idx, "symbol");
    var symbolSize = normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
    var symbolStyle = data.getItemVisual(idx, "style");
    var color = symbolStyle && symbolStyle.fill;
    var emphasisModel = itemModel.getModel("emphasis");
    rippleGroup.setScale(symbolSize);
    rippleGroup.traverse(function(ripplePath) {
      ripplePath.setStyle("fill", color);
    });
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      rippleGroup.x = symbolOffset[0];
      rippleGroup.y = symbolOffset[1];
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    rippleGroup.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
    var effectCfg = {};
    effectCfg.showEffectOn = seriesModel.get("showEffectOn");
    effectCfg.rippleScale = itemModel.get(["rippleEffect", "scale"]);
    effectCfg.brushType = itemModel.get(["rippleEffect", "brushType"]);
    effectCfg.period = itemModel.get(["rippleEffect", "period"]) * 1e3;
    effectCfg.effectOffset = idx / data.count();
    effectCfg.z = seriesModel.getShallow("z") || 0;
    effectCfg.zlevel = seriesModel.getShallow("zlevel") || 0;
    effectCfg.symbolType = symbolType;
    effectCfg.color = color;
    effectCfg.rippleEffectColor = itemModel.get(["rippleEffect", "color"]);
    effectCfg.rippleNumber = itemModel.get(["rippleEffect", "number"]);
    if (effectCfg.showEffectOn === "render") {
      this._effectCfg ? this.updateEffectAnimation(effectCfg) : this.startEffectAnimation(effectCfg);
      this._effectCfg = effectCfg;
    } else {
      this._effectCfg = null;
      this.stopEffectAnimation();
      this.onHoverStateChange = function(toState) {
        if (toState === "emphasis") {
          if (effectCfg.showEffectOn !== "render") {
            _this.startEffectAnimation(effectCfg);
          }
        } else if (toState === "normal") {
          if (effectCfg.showEffectOn !== "render") {
            _this.stopEffectAnimation();
          }
        }
      };
    }
    this._effectCfg = effectCfg;
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  EffectSymbol2.prototype.fadeOut = function(cb) {
    cb && cb();
  };
  return EffectSymbol2;
}(Group$4);
var EffectSymbol$1 = EffectSymbol;
var EffectScatterView = function(_super) {
  __extends(EffectScatterView2, _super);
  function EffectScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterView2.type;
    return _this;
  }
  EffectScatterView2.prototype.init = function() {
    this._symbolDraw = new SymbolDraw$1(EffectSymbol$1);
  };
  EffectScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var effectSymbolDraw = this._symbolDraw;
    effectSymbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this.group.add(effectSymbolDraw.group);
  };
  EffectScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  EffectScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    var res = pointsLayout("").reset(seriesModel, ecModel, api);
    if (res.progress) {
      res.progress({
        start: 0,
        end: data.count(),
        count: data.count()
      }, data);
    }
    this._symbolDraw.updateLayout();
  };
  EffectScatterView2.prototype._updateGroupTransform = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.getRoamTransform) {
      this.group.transform = clone$2(coordSys.getRoamTransform());
      this.group.decomposeTransform();
    }
  };
  EffectScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
  };
  EffectScatterView2.type = "effectScatter";
  return EffectScatterView2;
}(ChartView$1);
var EffectScatterView$1 = EffectScatterView;
var EffectScatterSeriesModel = function(_super) {
  __extends(EffectScatterSeriesModel2, _super);
  function EffectScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  EffectScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  EffectScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  EffectScatterSeriesModel2.type = "series.effectScatter";
  EffectScatterSeriesModel2.dependencies = ["grid", "polar"];
  EffectScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    effectType: "ripple",
    progressive: 0,
    showEffectOn: "render",
    clip: true,
    rippleEffect: {
      period: 4,
      scale: 2.5,
      brushType: "fill",
      number: 3
    },
    universalTransition: {
      divideShape: "clone"
    },
    symbolSize: 10
  };
  return EffectScatterSeriesModel2;
}(SeriesModel$1);
var EffectScatterSeriesModel$1 = EffectScatterSeriesModel;
function install$x(registers) {
  registers.registerChartView(EffectScatterView$1);
  registers.registerSeriesModel(EffectScatterSeriesModel$1);
  registers.registerLayout(pointsLayout("effectScatter"));
}
var EffectLine = function(_super) {
  __extends(EffectLine2, _super);
  function EffectLine2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this.add(_this.createLine(lineData, idx, seriesScope));
    _this._updateEffectSymbol(lineData, idx);
    return _this;
  }
  EffectLine2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Line$1(lineData, idx, seriesScope);
  };
  EffectLine2.prototype._updateEffectSymbol = function(lineData, idx) {
    var itemModel = lineData.getItemModel(idx);
    var effectModel = itemModel.getModel("effect");
    var size = effectModel.get("symbolSize");
    var symbolType = effectModel.get("symbol");
    if (!isArray$1(size)) {
      size = [size, size];
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var color = effectModel.get("color") || lineStyle && lineStyle.stroke;
    var symbol = this.childAt(1);
    if (this._symbolType !== symbolType) {
      this.remove(symbol);
      symbol = createSymbol$1(symbolType, -0.5, -0.5, 1, 1, color);
      symbol.z2 = 100;
      symbol.culling = true;
      this.add(symbol);
    }
    if (!symbol) {
      return;
    }
    symbol.setStyle("shadowColor", color);
    symbol.setStyle(effectModel.getItemStyle(["color"]));
    symbol.scaleX = size[0];
    symbol.scaleY = size[1];
    symbol.setColor(color);
    this._symbolType = symbolType;
    this._symbolScale = size;
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  EffectLine2.prototype._updateEffectAnimation = function(lineData, effectModel, idx) {
    var symbol = this.childAt(1);
    if (!symbol) {
      return;
    }
    var points2 = lineData.getItemLayout(idx);
    var period = effectModel.get("period") * 1e3;
    var loop = effectModel.get("loop");
    var constantSpeed = effectModel.get("constantSpeed");
    var delayExpr = retrieve(effectModel.get("delay"), function(idx2) {
      return idx2 / lineData.count() * period / 3;
    });
    symbol.ignore = true;
    this._updateAnimationPoints(symbol, points2);
    if (constantSpeed > 0) {
      period = this._getLineLength(symbol) / constantSpeed * 1e3;
    }
    if (period !== this._period || loop !== this._loop) {
      symbol.stopAnimation();
      var delayNum = void 0;
      if (isFunction(delayExpr)) {
        delayNum = delayExpr(idx);
      } else {
        delayNum = delayExpr;
      }
      if (symbol.__t > 0) {
        delayNum = -period * symbol.__t;
      }
      this._animateSymbol(symbol, period, delayNum, loop);
    }
    this._period = period;
    this._loop = loop;
  };
  EffectLine2.prototype._animateSymbol = function(symbol, period, delayNum, loop) {
    if (period > 0) {
      symbol.__t = 0;
      var self_1 = this;
      var animator = symbol.animate("", loop).when(period, {
        __t: 1
      }).delay(delayNum).during(function() {
        self_1._updateSymbolPosition(symbol);
      });
      if (!loop) {
        animator.done(function() {
          self_1.remove(symbol);
        });
      }
      animator.start();
    }
  };
  EffectLine2.prototype._getLineLength = function(symbol) {
    return dist$1(symbol.__p1, symbol.__cp1) + dist$1(symbol.__cp1, symbol.__p2);
  };
  EffectLine2.prototype._updateAnimationPoints = function(symbol, points2) {
    symbol.__p1 = points2[0];
    symbol.__p2 = points2[1];
    symbol.__cp1 = points2[2] || [(points2[0][0] + points2[1][0]) / 2, (points2[0][1] + points2[1][1]) / 2];
  };
  EffectLine2.prototype.updateData = function(lineData, idx, seriesScope) {
    this.childAt(0).updateData(lineData, idx, seriesScope);
    this._updateEffectSymbol(lineData, idx);
  };
  EffectLine2.prototype._updateSymbolPosition = function(symbol) {
    var p1 = symbol.__p1;
    var p2 = symbol.__p2;
    var cp1 = symbol.__cp1;
    var t2 = symbol.__t;
    var pos = [symbol.x, symbol.y];
    var lastPos = pos.slice();
    var quadraticAt2 = quadraticAt$1;
    var quadraticDerivativeAt$1 = quadraticDerivativeAt;
    pos[0] = quadraticAt2(p1[0], cp1[0], p2[0], t2);
    pos[1] = quadraticAt2(p1[1], cp1[1], p2[1], t2);
    var tx = quadraticDerivativeAt$1(p1[0], cp1[0], p2[0], t2);
    var ty = quadraticDerivativeAt$1(p1[1], cp1[1], p2[1], t2);
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    if (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") {
      if (symbol.__lastT !== void 0 && symbol.__lastT < symbol.__t) {
        symbol.scaleY = dist$1(lastPos, pos) * 1.05;
        if (t2 === 1) {
          pos[0] = lastPos[0] + (pos[0] - lastPos[0]) / 2;
          pos[1] = lastPos[1] + (pos[1] - lastPos[1]) / 2;
        }
      } else if (symbol.__lastT === 1) {
        symbol.scaleY = 2 * dist$1(p1, pos);
      } else {
        symbol.scaleY = this._symbolScale[1];
      }
    }
    symbol.__lastT = symbol.__t;
    symbol.ignore = false;
    symbol.x = pos[0];
    symbol.y = pos[1];
  };
  EffectLine2.prototype.updateLayout = function(lineData, idx) {
    this.childAt(0).updateLayout(lineData, idx);
    var effectModel = lineData.getItemModel(idx).getModel("effect");
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  return EffectLine2;
}(Group$4);
var EffectLine$1 = EffectLine;
var Polyline = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createPolyline(lineData, idx, seriesScope);
    return _this;
  }
  Polyline2.prototype._createPolyline = function(lineData, idx, seriesScope) {
    var points2 = lineData.getItemLayout(idx);
    var line = new Polyline$3({
      shape: {
        points: points2
      }
    });
    this.add(line);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childAt(0);
    var target = {
      shape: {
        points: lineData.getItemLayout(idx)
      }
    };
    updateProps$1(line, target, seriesModel, idx);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var line = this.childAt(0);
    var itemModel = lineData.getItemModel(idx);
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    if (!seriesScope || lineData.hasItemOption) {
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
    }
    line.useStyle(lineData.getItemVisual(idx, "style"));
    line.style.fill = null;
    line.style.strokeNoScale = true;
    var lineEmphasisState = line.ensureState("emphasis");
    lineEmphasisState.style = emphasisLineStyle;
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Polyline2.prototype.updateLayout = function(lineData, idx) {
    var polyline = this.childAt(0);
    polyline.setShape("points", lineData.getItemLayout(idx));
  };
  return Polyline2;
}(Group$4);
var Polyline$1 = Polyline;
var EffectPolyline = function(_super) {
  __extends(EffectPolyline2, _super);
  function EffectPolyline2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._lastFrame = 0;
    _this._lastFramePercent = 0;
    return _this;
  }
  EffectPolyline2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Polyline$1(lineData, idx, seriesScope);
  };
  EffectPolyline2.prototype._updateAnimationPoints = function(symbol, points2) {
    this._points = points2;
    var accLenArr = [0];
    var len2 = 0;
    for (var i = 1; i < points2.length; i++) {
      var p1 = points2[i - 1];
      var p2 = points2[i];
      len2 += dist$1(p1, p2);
      accLenArr.push(len2);
    }
    if (len2 === 0) {
      this._length = 0;
      return;
    }
    for (var i = 0; i < accLenArr.length; i++) {
      accLenArr[i] /= len2;
    }
    this._offsets = accLenArr;
    this._length = len2;
  };
  EffectPolyline2.prototype._getLineLength = function() {
    return this._length;
  };
  EffectPolyline2.prototype._updateSymbolPosition = function(symbol) {
    var t2 = symbol.__t;
    var points2 = this._points;
    var offsets = this._offsets;
    var len2 = points2.length;
    if (!offsets) {
      return;
    }
    var lastFrame = this._lastFrame;
    var frame;
    if (t2 < this._lastFramePercent) {
      var start2 = Math.min(lastFrame + 1, len2 - 1);
      for (frame = start2; frame >= 0; frame--) {
        if (offsets[frame] <= t2) {
          break;
        }
      }
      frame = Math.min(frame, len2 - 2);
    } else {
      for (frame = lastFrame; frame < len2; frame++) {
        if (offsets[frame] > t2) {
          break;
        }
      }
      frame = Math.min(frame - 1, len2 - 2);
    }
    var p2 = (t2 - offsets[frame]) / (offsets[frame + 1] - offsets[frame]);
    var p0 = points2[frame];
    var p1 = points2[frame + 1];
    symbol.x = p0[0] * (1 - p2) + p2 * p1[0];
    symbol.y = p0[1] * (1 - p2) + p2 * p1[1];
    var tx = p1[0] - p0[0];
    var ty = p1[1] - p0[1];
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    this._lastFrame = frame;
    this._lastFramePercent = t2;
    symbol.ignore = false;
  };
  return EffectPolyline2;
}(EffectLine$1);
var EffectPolyline$1 = EffectPolyline;
var LargeLinesPathShape = function() {
  function LargeLinesPathShape2() {
    this.polyline = false;
    this.curveness = 0;
    this.segs = [];
  }
  return LargeLinesPathShape2;
}();
var LargeLinesPath = function(_super) {
  __extends(LargeLinesPath2, _super);
  function LargeLinesPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeLinesPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeLinesPath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  LargeLinesPath2.prototype.getDefaultShape = function() {
    return new LargeLinesPathShape();
  };
  LargeLinesPath2.prototype.buildPath = function(ctx, shape) {
    var segs = shape.segs;
    var curveness = shape.curveness;
    var i;
    if (shape.polyline) {
      for (i = this._off; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          ctx.moveTo(segs[i++], segs[i++]);
          for (var k2 = 1; k2 < count2; k2++) {
            ctx.lineTo(segs[i++], segs[i++]);
          }
        }
      }
    } else {
      for (i = this._off; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        ctx.moveTo(x0, y0);
        if (curveness > 0) {
          var x2 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y2 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          ctx.quadraticCurveTo(x2, y2, x1, y1);
        } else {
          ctx.lineTo(x1, y1);
        }
      }
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeLinesPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var segs = shape.segs;
    var curveness = shape.curveness;
    var lineWidth = this.style.lineWidth;
    if (shape.polyline) {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          var x0 = segs[i++];
          var y0 = segs[i++];
          for (var k2 = 1; k2 < count2; k2++) {
            var x1 = segs[i++];
            var y1 = segs[i++];
            if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
              return dataIndex;
            }
          }
        }
        dataIndex++;
      }
    } else {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        if (curveness > 0) {
          var x22 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y22 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          if (containStroke$2(x0, y0, x22, y22, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        } else {
          if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        }
        dataIndex++;
      }
    }
    return -1;
  };
  LargeLinesPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeLinesPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.segs;
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX, minY, maxX, maxY);
    }
    return rect;
  };
  return LargeLinesPath2;
}(Path$1);
var LargeLineDraw = function() {
  function LargeLineDraw2() {
    this.group = new Group$4();
  }
  LargeLineDraw2.prototype.updateData = function(data) {
    this._clear();
    var lineEl = this._create();
    lineEl.setShape({
      segs: data.getLayout("linesPoints")
    });
    this._setCommon(lineEl, data);
  };
  LargeLineDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this.group.removeAll();
    this._clear();
  };
  LargeLineDraw2.prototype.incrementalUpdate = function(taskParams, data) {
    var lastAdded = this._newAdded[0];
    var linePoints = data.getLayout("linesPoints");
    var oldSegs = lastAdded && lastAdded.shape.segs;
    if (oldSegs && oldSegs.length < 2e4) {
      var oldLen = oldSegs.length;
      var newSegs = new Float32Array(oldLen + linePoints.length);
      newSegs.set(oldSegs);
      newSegs.set(linePoints, oldLen);
      lastAdded.setShape({
        segs: newSegs
      });
    } else {
      this._newAdded = [];
      var lineEl = this._create();
      lineEl.incremental = true;
      lineEl.setShape({
        segs: linePoints
      });
      this._setCommon(lineEl, data);
      lineEl.__startIndex = taskParams.start;
    }
  };
  LargeLineDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeLineDraw2.prototype.eachRendered = function(cb) {
    this._newAdded[0] && cb(this._newAdded[0]);
  };
  LargeLineDraw2.prototype._create = function() {
    var lineEl = new LargeLinesPath({
      cursor: "default"
    });
    this._newAdded.push(lineEl);
    this.group.add(lineEl);
    return lineEl;
  };
  LargeLineDraw2.prototype._setCommon = function(lineEl, data, isIncremental) {
    var hostModel = data.hostModel;
    lineEl.setShape({
      polyline: hostModel.get("polyline"),
      curveness: hostModel.get(["lineStyle", "curveness"])
    });
    lineEl.useStyle(hostModel.getModel("lineStyle").getLineStyle());
    lineEl.style.strokeNoScale = true;
    var style = data.getVisual("style");
    if (style && style.stroke) {
      lineEl.setStyle("stroke", style.stroke);
    }
    lineEl.setStyle("fill", null);
    var ecData = getECData(lineEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    lineEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = lineEl.hoverDataIdx;
      if (dataIndex > 0) {
        ecData.dataIndex = dataIndex + lineEl.__startIndex;
      }
    });
  };
  LargeLineDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeLineDraw2;
}();
var LargeLineDraw$1 = LargeLineDraw;
var linesLayout = {
  seriesType: "lines",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var isPolyline = seriesModel.get("polyline");
    var isLarge = seriesModel.pipelineContext.large;
    return {
      progress: function(params, lineData) {
        var lineCoords = [];
        if (isLarge) {
          var points2 = void 0;
          var segCount = params.end - params.start;
          if (isPolyline) {
            var totalCoordsCount = 0;
            for (var i = params.start; i < params.end; i++) {
              totalCoordsCount += seriesModel.getLineCoordsCount(i);
            }
            points2 = new Float32Array(segCount + totalCoordsCount * 2);
          } else {
            points2 = new Float32Array(segCount * 4);
          }
          var offset = 0;
          var pt = [];
          for (var i = params.start; i < params.end; i++) {
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            if (isPolyline) {
              points2[offset++] = len2;
            }
            for (var k2 = 0; k2 < len2; k2++) {
              pt = coordSys.dataToPoint(lineCoords[k2], false, pt);
              points2[offset++] = pt[0];
              points2[offset++] = pt[1];
            }
          }
          lineData.setLayout("linesPoints", points2);
        } else {
          for (var i = params.start; i < params.end; i++) {
            var itemModel = lineData.getItemModel(i);
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            var pts = [];
            if (isPolyline) {
              for (var j = 0; j < len2; j++) {
                pts.push(coordSys.dataToPoint(lineCoords[j]));
              }
            } else {
              pts[0] = coordSys.dataToPoint(lineCoords[0]);
              pts[1] = coordSys.dataToPoint(lineCoords[1]);
              var curveness = itemModel.get(["lineStyle", "curveness"]);
              if (+curveness) {
                pts[2] = [(pts[0][0] + pts[1][0]) / 2 - (pts[0][1] - pts[1][1]) * curveness, (pts[0][1] + pts[1][1]) / 2 - (pts[1][0] - pts[0][0]) * curveness];
              }
            }
            lineData.setItemLayout(i, pts);
          }
        }
      }
    };
  }
};
var linesLayout$1 = linesLayout;
var LinesView = function(_super) {
  __extends(LinesView2, _super);
  function LinesView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesView2.type;
    return _this;
  }
  LinesView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    var zlevel = seriesModel.get("zlevel");
    var trailLength = seriesModel.get(["effect", "trailLength"]);
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg) {
      zr.painter.getLayer(zlevel).clear(true);
    }
    if (this._lastZlevel != null && !isSvg) {
      zr.configLayer(this._lastZlevel, {
        motionBlur: false
      });
    }
    if (this._showEffect(seriesModel) && trailLength > 0) {
      if (!isSvg) {
        zr.configLayer(zlevel, {
          motionBlur: true,
          lastFrameAlpha: Math.max(Math.min(trailLength / 10 + 0.9, 1), 0)
        });
      }
    }
    lineDraw.updateData(data);
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
    this._lastZlevel = zlevel;
    this._finished = true;
  };
  LinesView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    lineDraw.incrementalPrepareUpdate(data);
    this._clearLayer(api);
    this._finished = false;
  };
  LinesView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._lineDraw.incrementalUpdate(taskParams, seriesModel.getData());
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  LinesView2.prototype.eachRendered = function(cb) {
    this._lineDraw && this._lineDraw.eachRendered(cb);
  };
  LinesView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var pipelineContext = seriesModel.pipelineContext;
    if (!this._finished || pipelineContext.large || pipelineContext.progressiveRender) {
      return {
        update: true
      };
    } else {
      var res = linesLayout$1.reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._lineDraw.updateLayout();
      this._clearLayer(api);
    }
  };
  LinesView2.prototype._updateLineDraw = function(data, seriesModel) {
    var lineDraw = this._lineDraw;
    var hasEffect = this._showEffect(seriesModel);
    var isPolyline = !!seriesModel.get("polyline");
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!lineDraw || hasEffect !== this._hasEffet || isPolyline !== this._isPolyline || isLargeDraw !== this._isLargeDraw) {
      if (lineDraw) {
        lineDraw.remove();
      }
      lineDraw = this._lineDraw = isLargeDraw ? new LargeLineDraw$1() : new LineDraw$1(isPolyline ? hasEffect ? EffectPolyline$1 : Polyline$1 : hasEffect ? EffectLine$1 : Line$1);
      this._hasEffet = hasEffect;
      this._isPolyline = isPolyline;
      this._isLargeDraw = isLargeDraw;
    }
    this.group.add(lineDraw.group);
    return lineDraw;
  };
  LinesView2.prototype._showEffect = function(seriesModel) {
    return !!seriesModel.get(["effect", "show"]);
  };
  LinesView2.prototype._clearLayer = function(api) {
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg && this._lastZlevel != null) {
      zr.painter.getLayer(this._lastZlevel).clear(true);
    }
  };
  LinesView2.prototype.remove = function(ecModel, api) {
    this._lineDraw && this._lineDraw.remove();
    this._lineDraw = null;
    this._clearLayer(api);
  };
  LinesView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  LinesView2.type = "lines";
  return LinesView2;
}(ChartView$1);
var LinesView$1 = LinesView;
var Uint32Arr = typeof Uint32Array === "undefined" ? Array : Uint32Array;
var Float64Arr = typeof Float64Array === "undefined" ? Array : Float64Array;
function compatEc2(seriesOpt) {
  var data = seriesOpt.data;
  if (data && data[0] && data[0][0] && data[0][0].coord) {
    seriesOpt.data = map$1(data, function(itemOpt) {
      var coords = [itemOpt[0].coord, itemOpt[1].coord];
      var target = {
        coords
      };
      if (itemOpt[0].name) {
        target.fromName = itemOpt[0].name;
      }
      if (itemOpt[1].name) {
        target.toName = itemOpt[1].name;
      }
      return mergeAll([target, itemOpt[0], itemOpt[1]]);
    });
  }
}
var LinesSeriesModel = function(_super) {
  __extends(LinesSeriesModel2, _super);
  function LinesSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  LinesSeriesModel2.prototype.init = function(option) {
    option.data = option.data || [];
    compatEc2(option);
    var result = this._processFlatCoordsArray(option.data);
    this._flatCoords = result.flatCoords;
    this._flatCoordsOffset = result.flatCoordsOffset;
    if (result.flatCoords) {
      option.data = new Float32Array(result.count);
    }
    _super.prototype.init.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.mergeOption = function(option) {
    compatEc2(option);
    if (option.data) {
      var result = this._processFlatCoordsArray(option.data);
      this._flatCoords = result.flatCoords;
      this._flatCoordsOffset = result.flatCoordsOffset;
      if (result.flatCoords) {
        option.data = new Float32Array(result.count);
      }
    }
    _super.prototype.mergeOption.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.appendData = function(params) {
    var result = this._processFlatCoordsArray(params.data);
    if (result.flatCoords) {
      if (!this._flatCoords) {
        this._flatCoords = result.flatCoords;
        this._flatCoordsOffset = result.flatCoordsOffset;
      } else {
        this._flatCoords = concatArray(this._flatCoords, result.flatCoords);
        this._flatCoordsOffset = concatArray(this._flatCoordsOffset, result.flatCoordsOffset);
      }
      params.data = new Float32Array(result.count);
    }
    this.getRawData().appendData(params.data);
  };
  LinesSeriesModel2.prototype._getCoordsFromItemModel = function(idx) {
    var itemModel = this.getData().getItemModel(idx);
    var coords = itemModel.option instanceof Array ? itemModel.option : itemModel.getShallow("coords");
    return coords;
  };
  LinesSeriesModel2.prototype.getLineCoordsCount = function(idx) {
    if (this._flatCoordsOffset) {
      return this._flatCoordsOffset[idx * 2 + 1];
    } else {
      return this._getCoordsFromItemModel(idx).length;
    }
  };
  LinesSeriesModel2.prototype.getLineCoords = function(idx, out2) {
    if (this._flatCoordsOffset) {
      var offset = this._flatCoordsOffset[idx * 2];
      var len2 = this._flatCoordsOffset[idx * 2 + 1];
      for (var i = 0; i < len2; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = this._flatCoords[offset + i * 2];
        out2[i][1] = this._flatCoords[offset + i * 2 + 1];
      }
      return len2;
    } else {
      var coords = this._getCoordsFromItemModel(idx);
      for (var i = 0; i < coords.length; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = coords[i][0];
        out2[i][1] = coords[i][1];
      }
      return coords.length;
    }
  };
  LinesSeriesModel2.prototype._processFlatCoordsArray = function(data) {
    var startOffset = 0;
    if (this._flatCoords) {
      startOffset = this._flatCoords.length;
    }
    if (isNumber(data[0])) {
      var len2 = data.length;
      var coordsOffsetAndLenStorage = new Uint32Arr(len2);
      var coordsStorage = new Float64Arr(len2);
      var coordsCursor = 0;
      var offsetCursor = 0;
      var dataCount = 0;
      for (var i = 0; i < len2; ) {
        dataCount++;
        var count2 = data[i++];
        coordsOffsetAndLenStorage[offsetCursor++] = coordsCursor + startOffset;
        coordsOffsetAndLenStorage[offsetCursor++] = count2;
        for (var k2 = 0; k2 < count2; k2++) {
          var x2 = data[i++];
          var y2 = data[i++];
          coordsStorage[coordsCursor++] = x2;
          coordsStorage[coordsCursor++] = y2;
        }
      }
      return {
        flatCoordsOffset: new Uint32Array(coordsOffsetAndLenStorage.buffer, 0, offsetCursor),
        flatCoords: coordsStorage,
        count: dataCount
      };
    }
    return {
      flatCoordsOffset: null,
      flatCoords: null,
      count: data.length
    };
  };
  LinesSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var lineData = new SeriesData$1(["value"], this);
    lineData.hasItemOption = false;
    lineData.initData(option.data, [], function(dataItem, dimName, dataIndex, dimIndex) {
      if (dataItem instanceof Array) {
        return NaN;
      } else {
        lineData.hasItemOption = true;
        var value = dataItem.value;
        if (value != null) {
          return value instanceof Array ? value[dimIndex] : value;
        }
      }
    });
    return lineData;
  };
  LinesSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var itemModel = data.getItemModel(dataIndex);
    var name = itemModel.get("name");
    if (name) {
      return name;
    }
    var fromName = itemModel.get("fromName");
    var toName = itemModel.get("toName");
    var nameArr = [];
    fromName != null && nameArr.push(fromName);
    toName != null && nameArr.push(toName);
    return createTooltipMarkup("nameValue", {
      name: nameArr.join(" > ")
    });
  };
  LinesSeriesModel2.prototype.preventIncremental = function() {
    return !!this.get(["effect", "show"]);
  };
  LinesSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 1e4 : this.get("progressive");
    }
    return progressive;
  };
  LinesSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 2e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  LinesSeriesModel2.prototype.getZLevelKey = function() {
    var effectModel = this.getModel("effect");
    var trailLength = effectModel.get("trailLength");
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : effectModel.get("show") && trailLength > 0 ? trailLength + "" : "";
  };
  LinesSeriesModel2.type = "series.lines";
  LinesSeriesModel2.dependencies = ["grid", "polar", "geo", "calendar"];
  LinesSeriesModel2.defaultOption = {
    coordinateSystem: "geo",
    z: 2,
    legendHoverLink: true,
    xAxisIndex: 0,
    yAxisIndex: 0,
    symbol: ["none", "none"],
    symbolSize: [10, 10],
    geoIndex: 0,
    effect: {
      show: false,
      period: 4,
      constantSpeed: 0,
      symbol: "circle",
      symbolSize: 3,
      loop: true,
      trailLength: 0.2
    },
    large: false,
    largeThreshold: 2e3,
    polyline: false,
    clip: true,
    label: {
      show: false,
      position: "end"
    },
    lineStyle: {
      opacity: 0.5
    }
  };
  return LinesSeriesModel2;
}(SeriesModel$1);
var LinesSeriesModel$1 = LinesSeriesModel;
function normalize$1(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
var linesVisual = {
  seriesType: "lines",
  reset: function(seriesModel) {
    var symbolType = normalize$1(seriesModel.get("symbol"));
    var symbolSize = normalize$1(seriesModel.get("symbolSize"));
    var data = seriesModel.getData();
    data.setVisual("fromSymbol", symbolType && symbolType[0]);
    data.setVisual("toSymbol", symbolType && symbolType[1]);
    data.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    data.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      var symbolType2 = normalize$1(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$1(itemModel.getShallow("symbolSize", true));
      symbolType2[0] && data2.setItemVisual(idx, "fromSymbol", symbolType2[0]);
      symbolType2[1] && data2.setItemVisual(idx, "toSymbol", symbolType2[1]);
      symbolSize2[0] && data2.setItemVisual(idx, "fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && data2.setItemVisual(idx, "toSymbolSize", symbolSize2[1]);
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
var linesVisual$1 = linesVisual;
function install$w(registers) {
  registers.registerChartView(LinesView$1);
  registers.registerSeriesModel(LinesSeriesModel$1);
  registers.registerLayout(linesLayout$1);
  registers.registerVisual(linesVisual$1);
}
var GRADIENT_LEVELS = 256;
var HeatmapLayer = function() {
  function HeatmapLayer2() {
    this.blurSize = 30;
    this.pointSize = 20;
    this.maxOpacity = 1;
    this.minOpacity = 0;
    this._gradientPixels = {
      inRange: null,
      outOfRange: null
    };
    var canvas = platformApi.createCanvas();
    this.canvas = canvas;
  }
  HeatmapLayer2.prototype.update = function(data, width, height, normalize2, colorFunc, isInRange) {
    var brush2 = this._getBrush();
    var gradientInRange = this._getGradient(colorFunc, "inRange");
    var gradientOutOfRange = this._getGradient(colorFunc, "outOfRange");
    var r2 = this.pointSize + this.blurSize;
    var canvas = this.canvas;
    var ctx = canvas.getContext("2d");
    var len2 = data.length;
    canvas.width = width;
    canvas.height = height;
    for (var i = 0; i < len2; ++i) {
      var p2 = data[i];
      var x2 = p2[0];
      var y2 = p2[1];
      var value = p2[2];
      var alpha = normalize2(value);
      ctx.globalAlpha = alpha;
      ctx.drawImage(brush2, x2 - r2, y2 - r2);
    }
    if (!canvas.width || !canvas.height) {
      return canvas;
    }
    var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    var pixels = imageData.data;
    var offset = 0;
    var pixelLen = pixels.length;
    var minOpacity = this.minOpacity;
    var maxOpacity = this.maxOpacity;
    var diffOpacity = maxOpacity - minOpacity;
    while (offset < pixelLen) {
      var alpha = pixels[offset + 3] / 256;
      var gradientOffset = Math.floor(alpha * (GRADIENT_LEVELS - 1)) * 4;
      if (alpha > 0) {
        var gradient = isInRange(alpha) ? gradientInRange : gradientOutOfRange;
        alpha > 0 && (alpha = alpha * diffOpacity + minOpacity);
        pixels[offset++] = gradient[gradientOffset];
        pixels[offset++] = gradient[gradientOffset + 1];
        pixels[offset++] = gradient[gradientOffset + 2];
        pixels[offset++] = gradient[gradientOffset + 3] * alpha * 256;
      } else {
        offset += 4;
      }
    }
    ctx.putImageData(imageData, 0, 0);
    return canvas;
  };
  HeatmapLayer2.prototype._getBrush = function() {
    var brushCanvas = this._brushCanvas || (this._brushCanvas = platformApi.createCanvas());
    var r2 = this.pointSize + this.blurSize;
    var d2 = r2 * 2;
    brushCanvas.width = d2;
    brushCanvas.height = d2;
    var ctx = brushCanvas.getContext("2d");
    ctx.clearRect(0, 0, d2, d2);
    ctx.shadowOffsetX = d2;
    ctx.shadowBlur = this.blurSize;
    ctx.shadowColor = "#000";
    ctx.beginPath();
    ctx.arc(-r2, r2, this.pointSize, 0, Math.PI * 2, true);
    ctx.closePath();
    ctx.fill();
    return brushCanvas;
  };
  HeatmapLayer2.prototype._getGradient = function(colorFunc, state) {
    var gradientPixels = this._gradientPixels;
    var pixelsSingleState = gradientPixels[state] || (gradientPixels[state] = new Uint8ClampedArray(256 * 4));
    var color = [0, 0, 0, 0];
    var off = 0;
    for (var i = 0; i < 256; i++) {
      colorFunc[state](i / 255, true, color);
      pixelsSingleState[off++] = color[0];
      pixelsSingleState[off++] = color[1];
      pixelsSingleState[off++] = color[2];
      pixelsSingleState[off++] = color[3];
    }
    return pixelsSingleState;
  };
  return HeatmapLayer2;
}();
var HeatmapLayer$1 = HeatmapLayer;
function getIsInPiecewiseRange(dataExtent, pieceList, selected) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  pieceList = map$1(pieceList, function(piece) {
    return {
      interval: [(piece.interval[0] - dataExtent[0]) / dataSpan, (piece.interval[1] - dataExtent[0]) / dataSpan]
    };
  });
  var len2 = pieceList.length;
  var lastIndex = 0;
  return function(val) {
    var i;
    for (i = lastIndex; i < len2; i++) {
      var interval = pieceList[i].interval;
      if (interval[0] <= val && val <= interval[1]) {
        lastIndex = i;
        break;
      }
    }
    if (i === len2) {
      for (i = lastIndex - 1; i >= 0; i--) {
        var interval = pieceList[i].interval;
        if (interval[0] <= val && val <= interval[1]) {
          lastIndex = i;
          break;
        }
      }
    }
    return i >= 0 && i < len2 && selected[i];
  };
}
function getIsInContinuousRange(dataExtent, range3) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  range3 = [(range3[0] - dataExtent[0]) / dataSpan, (range3[1] - dataExtent[0]) / dataSpan];
  return function(val) {
    return val >= range3[0] && val <= range3[1];
  };
}
function isGeoCoordSys(coordSys) {
  var dimensions = coordSys.dimensions;
  return dimensions[0] === "lng" && dimensions[1] === "lat";
}
var HeatmapView = function(_super) {
  __extends(HeatmapView2, _super);
  function HeatmapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapView2.type;
    return _this;
  }
  HeatmapView2.prototype.render = function(seriesModel, ecModel, api) {
    var visualMapOfThisSeries;
    ecModel.eachComponent("visualMap", function(visualMap) {
      visualMap.eachTargetSeries(function(targetSeries) {
        if (targetSeries === seriesModel) {
          visualMapOfThisSeries = visualMap;
        }
      });
    });
    this._progressiveEls = null;
    this.group.removeAll();
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type === "cartesian2d" || coordSys.type === "calendar") {
      this._renderOnCartesianAndCalendar(seriesModel, api, 0, seriesModel.getData().count());
    } else if (isGeoCoordSys(coordSys)) {
      this._renderOnGeo(coordSys, seriesModel, visualMapOfThisSeries, api);
    }
  };
  HeatmapView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this.group.removeAll();
  };
  HeatmapView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys) {
      if (isGeoCoordSys(coordSys)) {
        this.render(seriesModel, ecModel, api);
      } else {
        this._progressiveEls = [];
        this._renderOnCartesianAndCalendar(seriesModel, api, params.start, params.end, true);
      }
    }
  };
  HeatmapView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  HeatmapView2.prototype._renderOnCartesianAndCalendar = function(seriesModel, api, start2, end2, incremental) {
    var coordSys = seriesModel.coordinateSystem;
    var width;
    var height;
    var xAxisExtent;
    var yAxisExtent;
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      width = xAxis.getBandWidth();
      height = yAxis.getBandWidth();
      xAxisExtent = xAxis.scale.getExtent();
      yAxisExtent = yAxis.scale.getExtent();
    }
    var group = this.group;
    var data = seriesModel.getData();
    var emphasisStyle = seriesModel.getModel(["emphasis", "itemStyle"]).getItemStyle();
    var blurStyle = seriesModel.getModel(["blur", "itemStyle"]).getItemStyle();
    var selectStyle = seriesModel.getModel(["select", "itemStyle"]).getItemStyle();
    var borderRadius = seriesModel.get(["itemStyle", "borderRadius"]);
    var labelStatesModels = getLabelStatesModels(seriesModel);
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    var dataDims = isCoordinateSystemType(coordSys, "cartesian2d") ? [data.mapDimension("x"), data.mapDimension("y"), data.mapDimension("value")] : [data.mapDimension("time"), data.mapDimension("value")];
    for (var idx = start2; idx < end2; idx++) {
      var rect = void 0;
      var style = data.getItemVisual(idx, "style");
      if (isCoordinateSystemType(coordSys, "cartesian2d")) {
        var dataDimX = data.get(dataDims[0], idx);
        var dataDimY = data.get(dataDims[1], idx);
        if (isNaN(data.get(dataDims[2], idx)) || dataDimX < xAxisExtent[0] || dataDimX > xAxisExtent[1] || dataDimY < yAxisExtent[0] || dataDimY > yAxisExtent[1]) {
          continue;
        }
        var point = coordSys.dataToPoint([dataDimX, dataDimY]);
        rect = new Rect$3({
          shape: {
            x: Math.floor(Math.round(point[0]) - width / 2),
            y: Math.floor(Math.round(point[1]) - height / 2),
            width: Math.ceil(width),
            height: Math.ceil(height)
          },
          style
        });
      } else {
        if (isNaN(data.get(dataDims[1], idx))) {
          continue;
        }
        rect = new Rect$3({
          z2: 1,
          shape: coordSys.dataToRect([data.get(dataDims[0], idx)]).contentShape,
          style
        });
      }
      if (data.hasItemOption) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel_1 = itemModel.getModel("emphasis");
        emphasisStyle = emphasisModel_1.getModel("itemStyle").getItemStyle();
        blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
        selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
        borderRadius = itemModel.get(["itemStyle", "borderRadius"]);
        focus = emphasisModel_1.get("focus");
        blurScope = emphasisModel_1.get("blurScope");
        emphasisDisabled = emphasisModel_1.get("disabled");
        labelStatesModels = getLabelStatesModels(itemModel);
      }
      rect.shape.r = borderRadius;
      var rawValue = seriesModel.getRawValue(idx);
      var defaultText = "-";
      if (rawValue && rawValue[2] != null) {
        defaultText = rawValue[2] + "";
      }
      setLabelStyle(rect, labelStatesModels, {
        labelFetcher: seriesModel,
        labelDataIndex: idx,
        defaultOpacity: style.opacity,
        defaultText
      });
      rect.ensureState("emphasis").style = emphasisStyle;
      rect.ensureState("blur").style = blurStyle;
      rect.ensureState("select").style = selectStyle;
      toggleHoverEmphasis(rect, focus, blurScope, emphasisDisabled);
      rect.incremental = incremental;
      if (incremental) {
        rect.states.emphasis.hoverLayer = true;
      }
      group.add(rect);
      data.setItemGraphicEl(idx, rect);
      if (this._progressiveEls) {
        this._progressiveEls.push(rect);
      }
    }
  };
  HeatmapView2.prototype._renderOnGeo = function(geo, seriesModel, visualMapModel, api) {
    var inRangeVisuals = visualMapModel.targetVisuals.inRange;
    var outOfRangeVisuals = visualMapModel.targetVisuals.outOfRange;
    var data = seriesModel.getData();
    var hmLayer = this._hmLayer || this._hmLayer || new HeatmapLayer$1();
    hmLayer.blurSize = seriesModel.get("blurSize");
    hmLayer.pointSize = seriesModel.get("pointSize");
    hmLayer.minOpacity = seriesModel.get("minOpacity");
    hmLayer.maxOpacity = seriesModel.get("maxOpacity");
    var rect = geo.getViewRect().clone();
    var roamTransform = geo.getRoamTransform();
    rect.applyTransform(roamTransform);
    var x2 = Math.max(rect.x, 0);
    var y2 = Math.max(rect.y, 0);
    var x22 = Math.min(rect.width + rect.x, api.getWidth());
    var y22 = Math.min(rect.height + rect.y, api.getHeight());
    var width = x22 - x2;
    var height = y22 - y2;
    var dims = [data.mapDimension("lng"), data.mapDimension("lat"), data.mapDimension("value")];
    var points2 = data.mapArray(dims, function(lng, lat, value) {
      var pt = geo.dataToPoint([lng, lat]);
      pt[0] -= x2;
      pt[1] -= y2;
      pt.push(value);
      return pt;
    });
    var dataExtent = visualMapModel.getExtent();
    var isInRange = visualMapModel.type === "visualMap.continuous" ? getIsInContinuousRange(dataExtent, visualMapModel.option.range) : getIsInPiecewiseRange(dataExtent, visualMapModel.getPieceList(), visualMapModel.option.selected);
    hmLayer.update(points2, width, height, inRangeVisuals.color.getNormalizer(), {
      inRange: inRangeVisuals.color.getColorMapper(),
      outOfRange: outOfRangeVisuals.color.getColorMapper()
    }, isInRange);
    var img = new ZRImage$1({
      style: {
        width,
        height,
        x: x2,
        y: y2,
        image: hmLayer.canvas
      },
      silent: true
    });
    this.group.add(img);
  };
  HeatmapView2.type = "heatmap";
  return HeatmapView2;
}(ChartView$1);
var HeatmapView$1 = HeatmapView;
var HeatmapSeriesModel = function(_super) {
  __extends(HeatmapSeriesModel2, _super);
  function HeatmapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapSeriesModel2.type;
    return _this;
  }
  HeatmapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      generateCoord: "value"
    });
  };
  HeatmapSeriesModel2.prototype.preventIncremental = function() {
    var coordSysCreator = CoordinateSystem.get(this.get("coordinateSystem"));
    if (coordSysCreator && coordSysCreator.dimensions) {
      return coordSysCreator.dimensions[0] === "lng" && coordSysCreator.dimensions[1] === "lat";
    }
  };
  HeatmapSeriesModel2.type = "series.heatmap";
  HeatmapSeriesModel2.dependencies = ["grid", "geo", "calendar"];
  HeatmapSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    geoIndex: 0,
    blurSize: 30,
    pointSize: 20,
    maxOpacity: 1,
    minOpacity: 0,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return HeatmapSeriesModel2;
}(SeriesModel$1);
var HeatmapSeriesModel$1 = HeatmapSeriesModel;
function install$v(registers) {
  registers.registerChartView(HeatmapView$1);
  registers.registerSeriesModel(HeatmapSeriesModel$1);
}
var BAR_BORDER_WIDTH_QUERY = ["itemStyle", "borderWidth"];
var LAYOUT_ATTRS = [{
  xy: "x",
  wh: "width",
  index: 0,
  posDesc: ["left", "right"]
}, {
  xy: "y",
  wh: "height",
  index: 1,
  posDesc: ["top", "bottom"]
}];
var pathForLineWidth = new Circle$1();
var PictorialBarView = function(_super) {
  __extends(PictorialBarView2, _super);
  function PictorialBarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarView2.type;
    return _this;
  }
  PictorialBarView2.prototype.render = function(seriesModel, ecModel, api) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var coordSysRect = cartesian.master.getRect();
    var opt = {
      ecSize: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      seriesModel,
      coordSys: cartesian,
      coordSysExtent: [[coordSysRect.x, coordSysRect.x + coordSysRect.width], [coordSysRect.y, coordSysRect.y + coordSysRect.height]],
      isHorizontal,
      valueDim: LAYOUT_ATTRS[+isHorizontal],
      categoryDim: LAYOUT_ATTRS[1 - +isHorizontal]
    };
    data.diff(oldData).add(function(dataIndex) {
      if (!data.hasValue(dataIndex)) {
        return;
      }
      var itemModel = getItemModel(data, dataIndex);
      var symbolMeta = getSymbolMeta(data, dataIndex, itemModel, opt);
      var bar = createBar(data, opt, symbolMeta);
      data.setItemGraphicEl(dataIndex, bar);
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).update(function(newIndex, oldIndex) {
      var bar = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex)) {
        group.remove(bar);
        return;
      }
      var itemModel = getItemModel(data, newIndex);
      var symbolMeta = getSymbolMeta(data, newIndex, itemModel, opt);
      var pictorialShapeStr = getShapeStr(data, symbolMeta);
      if (bar && pictorialShapeStr !== bar.__pictorialShapeStr) {
        group.remove(bar);
        data.setItemGraphicEl(newIndex, null);
        bar = null;
      }
      if (bar) {
        updateBar(bar, opt, symbolMeta);
      } else {
        bar = createBar(data, opt, symbolMeta, true);
      }
      data.setItemGraphicEl(newIndex, bar);
      bar.__pictorialSymbolMeta = symbolMeta;
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).remove(function(dataIndex) {
      var bar = oldData.getItemGraphicEl(dataIndex);
      bar && removeBar(oldData, dataIndex, bar.__pictorialSymbolMeta.animationModel, bar);
    }).execute();
    this._data = data;
    return this.group;
  };
  PictorialBarView2.prototype.remove = function(ecModel, api) {
    var group = this.group;
    var data = this._data;
    if (ecModel.get("animation")) {
      if (data) {
        data.eachItemGraphicEl(function(bar) {
          removeBar(data, getECData(bar).dataIndex, ecModel, bar);
        });
      }
    } else {
      group.removeAll();
    }
  };
  PictorialBarView2.type = "pictorialBar";
  return PictorialBarView2;
}(ChartView$1);
function getSymbolMeta(data, dataIndex, itemModel, opt) {
  var layout2 = data.getItemLayout(dataIndex);
  var symbolRepeat = itemModel.get("symbolRepeat");
  var symbolClip = itemModel.get("symbolClip");
  var symbolPosition = itemModel.get("symbolPosition") || "start";
  var symbolRotate = itemModel.get("symbolRotate");
  var rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  var symbolPatternSize = itemModel.get("symbolPatternSize") || 2;
  var isAnimationEnabled2 = itemModel.isAnimationEnabled();
  var symbolMeta = {
    dataIndex,
    layout: layout2,
    itemModel,
    symbolType: data.getItemVisual(dataIndex, "symbol") || "circle",
    style: data.getItemVisual(dataIndex, "style"),
    symbolClip,
    symbolRepeat,
    symbolRepeatDirection: itemModel.get("symbolRepeatDirection"),
    symbolPatternSize,
    rotation,
    animationModel: isAnimationEnabled2 ? itemModel : null,
    hoverScale: isAnimationEnabled2 && itemModel.get(["emphasis", "scale"]),
    z2: itemModel.getShallow("z", true) || 0
  };
  prepareBarLength(itemModel, symbolRepeat, layout2, opt, symbolMeta);
  prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, symbolMeta.boundingLength, symbolMeta.pxSign, symbolPatternSize, opt, symbolMeta);
  prepareLineWidth(itemModel, symbolMeta.symbolScale, rotation, opt, symbolMeta);
  var symbolSize = symbolMeta.symbolSize;
  var symbolOffset = normalizeSymbolOffset(itemModel.get("symbolOffset"), symbolSize);
  prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, symbolMeta.valueLineWidth, symbolMeta.boundingLength, symbolMeta.repeatCutLength, opt, symbolMeta);
  return symbolMeta;
}
function prepareBarLength(itemModel, symbolRepeat, layout2, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var symbolBoundingData = itemModel.get("symbolBoundingData");
  var valueAxis2 = opt.coordSys.getOtherAxis(opt.coordSys.getBaseAxis());
  var zeroPx = valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(0));
  var pxSignIdx = 1 - +(layout2[valueDim.wh] <= 0);
  var boundingLength;
  if (isArray$1(symbolBoundingData)) {
    var symbolBoundingExtent = [convertToCoordOnAxis(valueAxis2, symbolBoundingData[0]) - zeroPx, convertToCoordOnAxis(valueAxis2, symbolBoundingData[1]) - zeroPx];
    symbolBoundingExtent[1] < symbolBoundingExtent[0] && symbolBoundingExtent.reverse();
    boundingLength = symbolBoundingExtent[pxSignIdx];
  } else if (symbolBoundingData != null) {
    boundingLength = convertToCoordOnAxis(valueAxis2, symbolBoundingData) - zeroPx;
  } else if (symbolRepeat) {
    boundingLength = opt.coordSysExtent[valueDim.index][pxSignIdx] - zeroPx;
  } else {
    boundingLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.boundingLength = boundingLength;
  if (symbolRepeat) {
    outputSymbolMeta.repeatCutLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.pxSign = boundingLength > 0 ? 1 : -1;
}
function convertToCoordOnAxis(axis, value) {
  return axis.toGlobalCoord(axis.dataToCoord(axis.scale.parse(value)));
}
function prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, boundingLength, pxSign, symbolPatternSize, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var categoryDim = opt.categoryDim;
  var categorySize = Math.abs(layout2[categoryDim.wh]);
  var symbolSize = data.getItemVisual(dataIndex, "symbolSize");
  var parsedSymbolSize;
  if (isArray$1(symbolSize)) {
    parsedSymbolSize = symbolSize.slice();
  } else {
    if (symbolSize == null) {
      parsedSymbolSize = ["100%", "100%"];
    } else {
      parsedSymbolSize = [symbolSize, symbolSize];
    }
  }
  parsedSymbolSize[categoryDim.index] = parsePercent(parsedSymbolSize[categoryDim.index], categorySize);
  parsedSymbolSize[valueDim.index] = parsePercent(parsedSymbolSize[valueDim.index], symbolRepeat ? categorySize : Math.abs(boundingLength));
  outputSymbolMeta.symbolSize = parsedSymbolSize;
  var symbolScale = outputSymbolMeta.symbolScale = [parsedSymbolSize[0] / symbolPatternSize, parsedSymbolSize[1] / symbolPatternSize];
  symbolScale[valueDim.index] *= (opt.isHorizontal ? -1 : 1) * pxSign;
}
function prepareLineWidth(itemModel, symbolScale, rotation, opt, outputSymbolMeta) {
  var valueLineWidth = itemModel.get(BAR_BORDER_WIDTH_QUERY) || 0;
  if (valueLineWidth) {
    pathForLineWidth.attr({
      scaleX: symbolScale[0],
      scaleY: symbolScale[1],
      rotation
    });
    pathForLineWidth.updateTransform();
    valueLineWidth /= pathForLineWidth.getLineScale();
    valueLineWidth *= symbolScale[opt.valueDim.index];
  }
  outputSymbolMeta.valueLineWidth = valueLineWidth || 0;
}
function prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, valueLineWidth, boundingLength, repeatCutLength, opt, outputSymbolMeta) {
  var categoryDim = opt.categoryDim;
  var valueDim = opt.valueDim;
  var pxSign = outputSymbolMeta.pxSign;
  var unitLength = Math.max(symbolSize[valueDim.index] + valueLineWidth, 0);
  var pathLen = unitLength;
  if (symbolRepeat) {
    var absBoundingLength = Math.abs(boundingLength);
    var symbolMargin = retrieve(itemModel.get("symbolMargin"), "15%") + "";
    var hasEndGap = false;
    if (symbolMargin.lastIndexOf("!") === symbolMargin.length - 1) {
      hasEndGap = true;
      symbolMargin = symbolMargin.slice(0, symbolMargin.length - 1);
    }
    var symbolMarginNumeric = parsePercent(symbolMargin, symbolSize[valueDim.index]);
    var uLenWithMargin = Math.max(unitLength + symbolMarginNumeric * 2, 0);
    var endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    var repeatSpecified = isNumeric(symbolRepeat);
    var repeatTimes = repeatSpecified ? symbolRepeat : toIntTimes((absBoundingLength + endFix) / uLenWithMargin);
    var mDiff = absBoundingLength - repeatTimes * unitLength;
    symbolMarginNumeric = mDiff / 2 / (hasEndGap ? repeatTimes : Math.max(repeatTimes - 1, 1));
    uLenWithMargin = unitLength + symbolMarginNumeric * 2;
    endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    if (!repeatSpecified && symbolRepeat !== "fixed") {
      repeatTimes = repeatCutLength ? toIntTimes((Math.abs(repeatCutLength) + endFix) / uLenWithMargin) : 0;
    }
    pathLen = repeatTimes * uLenWithMargin - endFix;
    outputSymbolMeta.repeatTimes = repeatTimes;
    outputSymbolMeta.symbolMargin = symbolMarginNumeric;
  }
  var sizeFix = pxSign * (pathLen / 2);
  var pathPosition = outputSymbolMeta.pathPosition = [];
  pathPosition[categoryDim.index] = layout2[categoryDim.wh] / 2;
  pathPosition[valueDim.index] = symbolPosition === "start" ? sizeFix : symbolPosition === "end" ? boundingLength - sizeFix : boundingLength / 2;
  if (symbolOffset) {
    pathPosition[0] += symbolOffset[0];
    pathPosition[1] += symbolOffset[1];
  }
  var bundlePosition = outputSymbolMeta.bundlePosition = [];
  bundlePosition[categoryDim.index] = layout2[categoryDim.xy];
  bundlePosition[valueDim.index] = layout2[valueDim.xy];
  var barRectShape = outputSymbolMeta.barRectShape = extend({}, layout2);
  barRectShape[valueDim.wh] = pxSign * Math.max(Math.abs(layout2[valueDim.wh]), Math.abs(pathPosition[valueDim.index] + sizeFix));
  barRectShape[categoryDim.wh] = layout2[categoryDim.wh];
  var clipShape = outputSymbolMeta.clipShape = {};
  clipShape[categoryDim.xy] = -layout2[categoryDim.xy];
  clipShape[categoryDim.wh] = opt.ecSize[categoryDim.wh];
  clipShape[valueDim.xy] = 0;
  clipShape[valueDim.wh] = layout2[valueDim.wh];
}
function createPath(symbolMeta) {
  var symbolPatternSize = symbolMeta.symbolPatternSize;
  var path = createSymbol$1(symbolMeta.symbolType, -symbolPatternSize / 2, -symbolPatternSize / 2, symbolPatternSize, symbolPatternSize);
  path.attr({
    culling: true
  });
  path.type !== "image" && path.setStyle({
    strokeNoScale: true
  });
  return path;
}
function createOrUpdateRepeatSymbols(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var symbolSize = symbolMeta.symbolSize;
  var valueLineWidth = symbolMeta.valueLineWidth;
  var pathPosition = symbolMeta.pathPosition;
  var valueDim = opt.valueDim;
  var repeatTimes = symbolMeta.repeatTimes || 0;
  var index2 = 0;
  var unit = symbolSize[opt.valueDim.index] + valueLineWidth + symbolMeta.symbolMargin * 2;
  eachPath(bar, function(path2) {
    path2.__pictorialAnimationIndex = index2;
    path2.__pictorialRepeatTimes = repeatTimes;
    if (index2 < repeatTimes) {
      updateAttr(path2, null, makeTarget(index2), symbolMeta, isUpdate);
    } else {
      updateAttr(path2, null, {
        scaleX: 0,
        scaleY: 0
      }, symbolMeta, isUpdate, function() {
        bundle.remove(path2);
      });
    }
    index2++;
  });
  for (; index2 < repeatTimes; index2++) {
    var path = createPath(symbolMeta);
    path.__pictorialAnimationIndex = index2;
    path.__pictorialRepeatTimes = repeatTimes;
    bundle.add(path);
    var target = makeTarget(index2);
    updateAttr(path, {
      x: target.x,
      y: target.y,
      scaleX: 0,
      scaleY: 0
    }, {
      scaleX: target.scaleX,
      scaleY: target.scaleY,
      rotation: target.rotation
    }, symbolMeta, isUpdate);
  }
  function makeTarget(index3) {
    var position2 = pathPosition.slice();
    var pxSign = symbolMeta.pxSign;
    var i = index3;
    if (symbolMeta.symbolRepeatDirection === "start" ? pxSign > 0 : pxSign < 0) {
      i = repeatTimes - 1 - index3;
    }
    position2[valueDim.index] = unit * (i - repeatTimes / 2 + 0.5) + pathPosition[valueDim.index];
    return {
      x: position2[0],
      y: position2[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    };
  }
}
function createOrUpdateSingleSymbol(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var mainPath = bar.__pictorialMainPath;
  if (!mainPath) {
    mainPath = bar.__pictorialMainPath = createPath(symbolMeta);
    bundle.add(mainPath);
    updateAttr(mainPath, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: 0,
      scaleY: 0,
      rotation: symbolMeta.rotation
    }, {
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1]
    }, symbolMeta, isUpdate);
  } else {
    updateAttr(mainPath, null, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateBarRect(bar, symbolMeta, isUpdate) {
  var rectShape = extend({}, symbolMeta.barRectShape);
  var barRect = bar.__pictorialBarRect;
  if (!barRect) {
    barRect = bar.__pictorialBarRect = new Rect$3({
      z2: 2,
      shape: rectShape,
      silent: true,
      style: {
        stroke: "transparent",
        fill: "transparent",
        lineWidth: 0
      }
    });
    barRect.disableMorphing = true;
    bar.add(barRect);
  } else {
    updateAttr(barRect, null, {
      shape: rectShape
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateClip(bar, opt, symbolMeta, isUpdate) {
  if (symbolMeta.symbolClip) {
    var clipPath = bar.__pictorialClipPath;
    var clipShape = extend({}, symbolMeta.clipShape);
    var valueDim = opt.valueDim;
    var animationModel = symbolMeta.animationModel;
    var dataIndex = symbolMeta.dataIndex;
    if (clipPath) {
      updateProps$1(clipPath, {
        shape: clipShape
      }, animationModel, dataIndex);
    } else {
      clipShape[valueDim.wh] = 0;
      clipPath = new Rect$3({
        shape: clipShape
      });
      bar.__pictorialBundle.setClipPath(clipPath);
      bar.__pictorialClipPath = clipPath;
      var target = {};
      target[valueDim.wh] = symbolMeta.clipShape[valueDim.wh];
      graphic[isUpdate ? "updateProps" : "initProps"](clipPath, {
        shape: target
      }, animationModel, dataIndex);
    }
  }
}
function getItemModel(data, dataIndex) {
  var itemModel = data.getItemModel(dataIndex);
  itemModel.getAnimationDelayParams = getAnimationDelayParams;
  itemModel.isAnimationEnabled = isAnimationEnabled;
  return itemModel;
}
function getAnimationDelayParams(path) {
  return {
    index: path.__pictorialAnimationIndex,
    count: path.__pictorialRepeatTimes
  };
}
function isAnimationEnabled() {
  return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
}
function createBar(data, opt, symbolMeta, isUpdate) {
  var bar = new Group$4();
  var bundle = new Group$4();
  bar.add(bundle);
  bar.__pictorialBundle = bundle;
  bundle.x = symbolMeta.bundlePosition[0];
  bundle.y = symbolMeta.bundlePosition[1];
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta);
  }
  createOrUpdateBarRect(bar, symbolMeta, isUpdate);
  createOrUpdateClip(bar, opt, symbolMeta, isUpdate);
  bar.__pictorialShapeStr = getShapeStr(data, symbolMeta);
  bar.__pictorialSymbolMeta = symbolMeta;
  return bar;
}
function updateBar(bar, opt, symbolMeta) {
  var animationModel = symbolMeta.animationModel;
  var dataIndex = symbolMeta.dataIndex;
  var bundle = bar.__pictorialBundle;
  updateProps$1(bundle, {
    x: symbolMeta.bundlePosition[0],
    y: symbolMeta.bundlePosition[1]
  }, animationModel, dataIndex);
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta, true);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta, true);
  }
  createOrUpdateBarRect(bar, symbolMeta, true);
  createOrUpdateClip(bar, opt, symbolMeta, true);
}
function removeBar(data, dataIndex, animationModel, bar) {
  var labelRect = bar.__pictorialBarRect;
  labelRect && labelRect.removeTextContent();
  var pathes = [];
  eachPath(bar, function(path) {
    pathes.push(path);
  });
  bar.__pictorialMainPath && pathes.push(bar.__pictorialMainPath);
  bar.__pictorialClipPath && (animationModel = null);
  each$f(pathes, function(path) {
    removeElement(path, {
      scaleX: 0,
      scaleY: 0
    }, animationModel, dataIndex, function() {
      bar.parent && bar.parent.remove(bar);
    });
  });
  data.setItemGraphicEl(dataIndex, null);
}
function getShapeStr(data, symbolMeta) {
  return [data.getItemVisual(symbolMeta.dataIndex, "symbol") || "none", !!symbolMeta.symbolRepeat, !!symbolMeta.symbolClip].join(":");
}
function eachPath(bar, cb, context) {
  each$f(bar.__pictorialBundle.children(), function(el) {
    el !== bar.__pictorialBarRect && cb.call(context, el);
  });
}
function updateAttr(el, immediateAttrs, animationAttrs, symbolMeta, isUpdate, cb) {
  immediateAttrs && el.attr(immediateAttrs);
  if (symbolMeta.symbolClip && !isUpdate) {
    animationAttrs && el.attr(animationAttrs);
  } else {
    animationAttrs && graphic[isUpdate ? "updateProps" : "initProps"](el, animationAttrs, symbolMeta.animationModel, symbolMeta.dataIndex, cb);
  }
}
function updateCommon(bar, opt, symbolMeta) {
  var dataIndex = symbolMeta.dataIndex;
  var itemModel = symbolMeta.itemModel;
  var emphasisModel = itemModel.getModel("emphasis");
  var emphasisStyle = emphasisModel.getModel("itemStyle").getItemStyle();
  var blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
  var selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
  var cursorStyle = itemModel.getShallow("cursor");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var hoverScale = emphasisModel.get("scale");
  eachPath(bar, function(path) {
    if (path instanceof ZRImage$1) {
      var pathStyle = path.style;
      path.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolMeta.style));
    } else {
      path.useStyle(symbolMeta.style);
    }
    var emphasisState = path.ensureState("emphasis");
    emphasisState.style = emphasisStyle;
    if (hoverScale) {
      emphasisState.scaleX = path.scaleX * 1.1;
      emphasisState.scaleY = path.scaleY * 1.1;
    }
    path.ensureState("blur").style = blurStyle;
    path.ensureState("select").style = selectStyle;
    cursorStyle && (path.cursor = cursorStyle);
    path.z2 = symbolMeta.z2;
  });
  var barPositionOutside = opt.valueDim.posDesc[+(symbolMeta.boundingLength > 0)];
  var barRect = bar.__pictorialBarRect;
  setLabelStyle(barRect, getLabelStatesModels(itemModel), {
    labelFetcher: opt.seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(opt.seriesModel.getData(), dataIndex),
    inheritColor: symbolMeta.style.fill,
    defaultOpacity: symbolMeta.style.opacity,
    defaultOutsidePosition: barPositionOutside
  });
  toggleHoverEmphasis(bar, focus, blurScope, emphasisModel.get("disabled"));
}
function toIntTimes(times) {
  var roundedTimes = Math.round(times);
  return Math.abs(times - roundedTimes) < 1e-4 ? roundedTimes : Math.ceil(times);
}
var PictorialBarView$1 = PictorialBarView;
var PictorialBarSeriesModel = function(_super) {
  __extends(PictorialBarSeriesModel2, _super);
  function PictorialBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    _this.defaultSymbol = "roundRect";
    return _this;
  }
  PictorialBarSeriesModel2.prototype.getInitialData = function(option) {
    option.stack = null;
    return _super.prototype.getInitialData.apply(this, arguments);
  };
  PictorialBarSeriesModel2.type = "series.pictorialBar";
  PictorialBarSeriesModel2.dependencies = ["grid"];
  PictorialBarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    symbol: "circle",
    symbolSize: null,
    symbolRotate: null,
    symbolPosition: null,
    symbolOffset: null,
    symbolMargin: null,
    symbolRepeat: false,
    symbolRepeatDirection: "end",
    symbolClip: false,
    symbolBoundingData: null,
    symbolPatternSize: 400,
    barGap: "-100%",
    progressive: 0,
    emphasis: {
      scale: false
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  });
  return PictorialBarSeriesModel2;
}(BaseBarSeriesModel$1);
var PictorialBarSeriesModel$1 = PictorialBarSeriesModel;
function install$u(registers) {
  registers.registerChartView(PictorialBarView$1);
  registers.registerSeriesModel(PictorialBarSeriesModel$1);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "pictorialBar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("pictorialBar"));
}
var ThemeRiverView = function(_super) {
  __extends(ThemeRiverView2, _super);
  function ThemeRiverView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverView2.type;
    _this._layers = [];
    return _this;
  }
  ThemeRiverView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var self2 = this;
    var group = this.group;
    var layersSeries = seriesModel.getLayerSeries();
    var layoutInfo = data.getLayout("layoutInfo");
    var rect = layoutInfo.rect;
    var boundaryGap = layoutInfo.boundaryGap;
    group.x = 0;
    group.y = rect.y + boundaryGap[0];
    function keyGetter(item) {
      return item.name;
    }
    var dataDiffer = new DataDiffer$1(this._layersSeries || [], layersSeries, keyGetter, keyGetter);
    var newLayersGroups = [];
    dataDiffer.add(bind$1(process2, this, "add")).update(bind$1(process2, this, "update")).remove(bind$1(process2, this, "remove")).execute();
    function process2(status, idx, oldIdx) {
      var oldLayersGroups = self2._layers;
      if (status === "remove") {
        group.remove(oldLayersGroups[idx]);
        return;
      }
      var points0 = [];
      var points1 = [];
      var style;
      var indices = layersSeries[idx].indices;
      var j = 0;
      for (; j < indices.length; j++) {
        var layout2 = data.getItemLayout(indices[j]);
        var x2 = layout2.x;
        var y0 = layout2.y0;
        var y2 = layout2.y;
        points0.push(x2, y0);
        points1.push(x2, y0 + y2);
        style = data.getItemVisual(indices[j], "style");
      }
      var polygon;
      var textLayout = data.getItemLayout(indices[0]);
      var labelModel = seriesModel.getModel("label");
      var margin = labelModel.get("margin");
      var emphasisModel = seriesModel.getModel("emphasis");
      if (status === "add") {
        var layerGroup = newLayersGroups[idx] = new Group$4();
        polygon = new ECPolygon({
          shape: {
            points: points0,
            stackedOnPoints: points1,
            smooth: 0.4,
            stackedOnSmooth: 0.4,
            smoothConstraint: false
          },
          z2: 0
        });
        layerGroup.add(polygon);
        group.add(layerGroup);
        if (seriesModel.isAnimationEnabled()) {
          polygon.setClipPath(createGridClipShape(polygon.getBoundingRect(), seriesModel, function() {
            polygon.removeClipPath();
          }));
        }
      } else {
        var layerGroup = oldLayersGroups[oldIdx];
        polygon = layerGroup.childAt(0);
        group.add(layerGroup);
        newLayersGroups[idx] = layerGroup;
        updateProps$1(polygon, {
          shape: {
            points: points0,
            stackedOnPoints: points1
          }
        }, seriesModel);
        saveOldStyle(polygon);
      }
      setLabelStyle(polygon, getLabelStatesModels(seriesModel), {
        labelDataIndex: indices[j - 1],
        defaultText: data.getName(indices[j - 1]),
        inheritColor: style.fill
      }, {
        normal: {
          verticalAlign: "middle"
        }
      });
      polygon.setTextConfig({
        position: null,
        local: true
      });
      var labelEl = polygon.getTextContent();
      if (labelEl) {
        labelEl.x = textLayout.x - margin;
        labelEl.y = textLayout.y0 + textLayout.y / 2;
      }
      polygon.useStyle(style);
      data.setItemGraphicEl(idx, polygon);
      setStatesStylesFromModel(polygon, seriesModel);
      toggleHoverEmphasis(polygon, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    }
    this._layersSeries = layersSeries;
    this._layers = newLayersGroups;
  };
  ThemeRiverView2.type = "themeRiver";
  return ThemeRiverView2;
}(ChartView$1);
function createGridClipShape(rect, seriesModel, cb) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      x: rect.x - 50,
      width: rect.width + 100,
      height: rect.height + 20
    }
  }, seriesModel, cb);
  return rectEl;
}
var ThemeRiverView$1 = ThemeRiverView;
var DATA_NAME_INDEX = 2;
var ThemeRiverSeriesModel = function(_super) {
  __extends(ThemeRiverSeriesModel2, _super);
  function ThemeRiverSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverSeriesModel2.type;
    return _this;
  }
  ThemeRiverSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  ThemeRiverSeriesModel2.prototype.fixData = function(data) {
    var rawDataLength = data.length;
    var timeValueKeys = {};
    var groupResult = groupData(data, function(item) {
      if (!timeValueKeys.hasOwnProperty(item[0] + "")) {
        timeValueKeys[item[0] + ""] = -1;
      }
      return item[2];
    });
    var layerData = [];
    groupResult.buckets.each(function(items, key) {
      layerData.push({
        name: key,
        dataList: items
      });
    });
    var layerNum = layerData.length;
    for (var k2 = 0; k2 < layerNum; ++k2) {
      var name_1 = layerData[k2].name;
      for (var j = 0; j < layerData[k2].dataList.length; ++j) {
        var timeValue = layerData[k2].dataList[j][0] + "";
        timeValueKeys[timeValue] = k2;
      }
      for (var timeValue in timeValueKeys) {
        if (timeValueKeys.hasOwnProperty(timeValue) && timeValueKeys[timeValue] !== k2) {
          timeValueKeys[timeValue] = k2;
          data[rawDataLength] = [timeValue, 0, name_1];
          rawDataLength++;
        }
      }
    }
    return data;
  };
  ThemeRiverSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var singleAxisModel = this.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    var axisType = singleAxisModel.get("type");
    var filterData = filter(option.data, function(dataItem) {
      return dataItem[2] !== void 0;
    });
    var data = this.fixData(filterData || []);
    var nameList = [];
    var nameMap = this.nameMap = createHashMap();
    var count2 = 0;
    for (var i = 0; i < data.length; ++i) {
      nameList.push(data[i][DATA_NAME_INDEX]);
      if (!nameMap.get(data[i][DATA_NAME_INDEX])) {
        nameMap.set(data[i][DATA_NAME_INDEX], count2);
        count2++;
      }
    }
    var dimensions = prepareSeriesDataSchema(data, {
      coordDimensions: ["single"],
      dimensionsDefine: [{
        name: "time",
        type: getDimensionTypeByAxis(axisType)
      }, {
        name: "value",
        type: "float"
      }, {
        name: "name",
        type: "ordinal"
      }],
      encodeDefine: {
        single: 0,
        value: 1,
        itemName: 2
      }
    }).dimensions;
    var list = new SeriesData$1(dimensions, this);
    list.initData(data);
    return list;
  };
  ThemeRiverSeriesModel2.prototype.getLayerSeries = function() {
    var data = this.getData();
    var lenCount = data.count();
    var indexArr = [];
    for (var i = 0; i < lenCount; ++i) {
      indexArr[i] = i;
    }
    var timeDim = data.mapDimension("single");
    var groupResult = groupData(indexArr, function(index2) {
      return data.get("name", index2);
    });
    var layerSeries = [];
    groupResult.buckets.each(function(items, key) {
      items.sort(function(index1, index2) {
        return data.get(timeDim, index1) - data.get(timeDim, index2);
      });
      layerSeries.push({
        name: key,
        indices: items
      });
    });
    return layerSeries;
  };
  ThemeRiverSeriesModel2.prototype.getAxisTooltipData = function(dim, value, baseAxis) {
    if (!isArray$1(dim)) {
      dim = dim ? [dim] : [];
    }
    var data = this.getData();
    var layerSeries = this.getLayerSeries();
    var indices = [];
    var layerNum = layerSeries.length;
    var nestestValue;
    for (var i = 0; i < layerNum; ++i) {
      var minDist = Number.MAX_VALUE;
      var nearestIdx = -1;
      var pointNum = layerSeries[i].indices.length;
      for (var j = 0; j < pointNum; ++j) {
        var theValue = data.get(dim[0], layerSeries[i].indices[j]);
        var dist2 = Math.abs(theValue - value);
        if (dist2 <= minDist) {
          nestestValue = theValue;
          minDist = dist2;
          nearestIdx = layerSeries[i].indices[j];
        }
      }
      indices.push(nearestIdx);
    }
    return {
      dataIndices: indices,
      nestestValue
    };
  };
  ThemeRiverSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var name = data.getName(dataIndex);
    var value = data.get(data.mapDimension("value"), dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  ThemeRiverSeriesModel2.type = "series.themeRiver";
  ThemeRiverSeriesModel2.dependencies = ["singleAxis"];
  ThemeRiverSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "singleAxis",
    boundaryGap: ["10%", "10%"],
    singleAxisIndex: 0,
    animationEasing: "linear",
    label: {
      margin: 4,
      show: true,
      position: "left",
      fontSize: 11
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return ThemeRiverSeriesModel2;
}(SeriesModel$1);
var ThemeRiverSeriesModel$1 = ThemeRiverSeriesModel;
function themeRiverLayout(ecModel, api) {
  ecModel.eachSeriesByType("themeRiver", function(seriesModel) {
    var data = seriesModel.getData();
    var single = seriesModel.coordinateSystem;
    var layoutInfo = {};
    var rect = single.getRect();
    layoutInfo.rect = rect;
    var boundaryGap = seriesModel.get("boundaryGap");
    var axis = single.getAxis();
    layoutInfo.boundaryGap = boundaryGap;
    if (axis.orient === "horizontal") {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.height);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.height);
      var height = rect.height - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, height);
    } else {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.width);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.width);
      var width = rect.width - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, width);
    }
    data.setLayout("layoutInfo", layoutInfo);
  });
}
function doThemeRiverLayout(data, seriesModel, height) {
  if (!data.count()) {
    return;
  }
  var coordSys = seriesModel.coordinateSystem;
  var layerSeries = seriesModel.getLayerSeries();
  var timeDim = data.mapDimension("single");
  var valueDim = data.mapDimension("value");
  var layerPoints = map$1(layerSeries, function(singleLayer) {
    return map$1(singleLayer.indices, function(idx) {
      var pt = coordSys.dataToPoint(data.get(timeDim, idx));
      pt[1] = data.get(valueDim, idx);
      return pt;
    });
  });
  var base2 = computeBaseline(layerPoints);
  var baseLine = base2.y0;
  var ky = height / base2.max;
  var n2 = layerSeries.length;
  var m2 = layerSeries[0].indices.length;
  var baseY0;
  for (var j = 0; j < m2; ++j) {
    baseY0 = baseLine[j] * ky;
    data.setItemLayout(layerSeries[0].indices[j], {
      layerIndex: 0,
      x: layerPoints[0][j][0],
      y0: baseY0,
      y: layerPoints[0][j][1] * ky
    });
    for (var i = 1; i < n2; ++i) {
      baseY0 += layerPoints[i - 1][j][1] * ky;
      data.setItemLayout(layerSeries[i].indices[j], {
        layerIndex: i,
        x: layerPoints[i][j][0],
        y0: baseY0,
        y: layerPoints[i][j][1] * ky
      });
    }
  }
}
function computeBaseline(data) {
  var layerNum = data.length;
  var pointNum = data[0].length;
  var sums = [];
  var y0 = [];
  var max3 = 0;
  for (var i = 0; i < pointNum; ++i) {
    var temp = 0;
    for (var j = 0; j < layerNum; ++j) {
      temp += data[j][i][1];
    }
    if (temp > max3) {
      max3 = temp;
    }
    sums.push(temp);
  }
  for (var k2 = 0; k2 < pointNum; ++k2) {
    y0[k2] = (max3 - sums[k2]) / 2;
  }
  max3 = 0;
  for (var l2 = 0; l2 < pointNum; ++l2) {
    var sum2 = sums[l2] + y0[l2];
    if (sum2 > max3) {
      max3 = sum2;
    }
  }
  return {
    y0,
    max: max3
  };
}
function install$t(registers) {
  registers.registerChartView(ThemeRiverView$1);
  registers.registerSeriesModel(ThemeRiverSeriesModel$1);
  registers.registerLayout(themeRiverLayout);
  registers.registerProcessor(dataFilter$1("themeRiver"));
}
var DEFAULT_SECTOR_Z = 2;
var DEFAULT_TEXT_Z = 4;
var SunburstPiece = function(_super) {
  __extends(SunburstPiece2, _super);
  function SunburstPiece2(node, seriesModel, ecModel, api) {
    var _this = _super.call(this) || this;
    _this.z2 = DEFAULT_SECTOR_Z;
    _this.textConfig = {
      inside: true
    };
    getECData(_this).seriesIndex = seriesModel.seriesIndex;
    var text = new ZRText$1({
      z2: DEFAULT_TEXT_Z,
      silent: node.getModel().get(["label", "silent"])
    });
    _this.setTextContent(text);
    _this.updateData(true, node, seriesModel, ecModel, api);
    return _this;
  }
  SunburstPiece2.prototype.updateData = function(firstCreate, node, seriesModel, ecModel, api) {
    this.node = node;
    node.piece = this;
    seriesModel = seriesModel || this._seriesModel;
    ecModel = ecModel || this._ecModel;
    var sector = this;
    getECData(sector).dataIndex = node.dataIndex;
    var itemModel = node.getModel();
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = node.getLayout();
    var sectorShape = extend({}, layout2);
    sectorShape.label = null;
    var normalStyle = node.getVisual("style");
    normalStyle.lineJoin = "bevel";
    var decal = node.getVisual("decal");
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, api);
    }
    var cornerRadius = getSectorCornerRadius(itemModel.getModel("itemStyle"), sectorShape, true);
    extend(sectorShape, cornerRadius);
    each$f(SPECIAL_STATES, function(stateName) {
      var state = sector.ensureState(stateName);
      var itemStyleModel = itemModel.getModel([stateName, "itemStyle"]);
      state.style = itemStyleModel.getItemStyle();
      var cornerRadius2 = getSectorCornerRadius(itemStyleModel, sectorShape);
      if (cornerRadius2) {
        state.shape = cornerRadius2;
      }
    });
    if (firstCreate) {
      sector.setShape(sectorShape);
      sector.shape.r = layout2.r0;
      updateProps$1(sector, {
        shape: {
          r: layout2.r
        }
      }, seriesModel, node.dataIndex);
    } else {
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel);
      saveOldStyle(sector);
    }
    sector.useStyle(normalStyle);
    this._updateLabel(seriesModel);
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._seriesModel = seriesModel || this._seriesModel;
    this._ecModel = ecModel || this._ecModel;
    var focus = emphasisModel.get("focus");
    var focusOrIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : focus;
    toggleHoverEmphasis(this, focusOrIndices, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  SunburstPiece2.prototype._updateLabel = function(seriesModel) {
    var _this = this;
    var itemModel = this.node.getModel();
    var normalLabelModel = itemModel.getModel("label");
    var layout2 = this.node.getLayout();
    var angle = layout2.endAngle - layout2.startAngle;
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var dx = Math.cos(midAngle);
    var dy = Math.sin(midAngle);
    var sector = this;
    var label = sector.getTextContent();
    var dataIndex = this.node.dataIndex;
    var labelMinAngle = normalLabelModel.get("minAngle") / 180 * Math.PI;
    var isNormalShown = normalLabelModel.get("show") && !(labelMinAngle != null && Math.abs(angle) < labelMinAngle);
    label.ignore = !isNormalShown;
    each$f(DISPLAY_STATES, function(stateName) {
      var labelStateModel = stateName === "normal" ? itemModel.getModel("label") : itemModel.getModel([stateName, "label"]);
      var isNormal = stateName === "normal";
      var state = isNormal ? label : label.ensureState(stateName);
      var text = seriesModel.getFormattedLabel(dataIndex, stateName);
      if (isNormal) {
        text = text || _this.node.name;
      }
      state.style = createTextStyle(labelStateModel, {}, null, stateName !== "normal", true);
      if (text) {
        state.style.text = text;
      }
      var isShown = labelStateModel.get("show");
      if (isShown != null && !isNormal) {
        state.ignore = !isShown;
      }
      var labelPosition = getLabelAttr(labelStateModel, "position");
      var sectorState = isNormal ? sector : sector.states[stateName];
      var labelColor = sectorState.style.fill;
      sectorState.textConfig = {
        outsideFill: labelStateModel.get("color") === "inherit" ? labelColor : null,
        inside: labelPosition !== "outside"
      };
      var r2;
      var labelPadding = getLabelAttr(labelStateModel, "distance") || 0;
      var textAlign = getLabelAttr(labelStateModel, "align");
      if (labelPosition === "outside") {
        r2 = layout2.r + labelPadding;
        textAlign = midAngle > Math.PI / 2 ? "right" : "left";
      } else {
        if (!textAlign || textAlign === "center") {
          if (angle === 2 * Math.PI && layout2.r0 === 0) {
            r2 = 0;
          } else {
            r2 = (layout2.r + layout2.r0) / 2;
          }
          textAlign = "center";
        } else if (textAlign === "left") {
          r2 = layout2.r0 + labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "right";
          }
        } else if (textAlign === "right") {
          r2 = layout2.r - labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "left";
          }
        }
      }
      state.style.align = textAlign;
      state.style.verticalAlign = getLabelAttr(labelStateModel, "verticalAlign") || "middle";
      state.x = r2 * dx + layout2.cx;
      state.y = r2 * dy + layout2.cy;
      var rotateType = getLabelAttr(labelStateModel, "rotate");
      var rotate2 = 0;
      if (rotateType === "radial") {
        rotate2 = -midAngle;
        if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (rotateType === "tangential") {
        rotate2 = Math.PI / 2 - midAngle;
        if (rotate2 > Math.PI / 2) {
          rotate2 -= Math.PI;
        } else if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (isNumber(rotateType)) {
        rotate2 = rotateType * Math.PI / 180;
      }
      state.rotation = rotate2;
    });
    function getLabelAttr(model, name) {
      var stateAttr = model.get(name);
      if (stateAttr == null) {
        return normalLabelModel.get(name);
      }
      return stateAttr;
    }
    label.dirtyStyle();
  };
  return SunburstPiece2;
}(Sector$1);
var SunburstPiece$1 = SunburstPiece;
var ROOT_TO_NODE_ACTION = "sunburstRootToNode";
var HIGHLIGHT_ACTION = "sunburstHighlight";
var UNHIGHLIGHT_ACTION = "sunburstUnhighlight";
function installSunburstAction(registers) {
  registers.registerAction({
    type: ROOT_TO_NODE_ACTION,
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var targetInfo = retrieveTargetInfo(payload, [ROOT_TO_NODE_ACTION], model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
  registers.registerAction({
    type: HIGHLIGHT_ACTION,
    update: "none"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleHighlight);
    function handleHighlight(model) {
      var targetInfo = retrieveTargetInfo(payload, [HIGHLIGHT_ACTION], model);
      if (targetInfo) {
        payload.dataIndex = targetInfo.node.dataIndex;
      }
    }
    api.dispatchAction(extend(payload, {
      type: "highlight"
    }));
  });
  registers.registerAction({
    type: UNHIGHLIGHT_ACTION,
    update: "updateView"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    api.dispatchAction(extend(payload, {
      type: "downplay"
    }));
  });
}
var SunburstView = function(_super) {
  __extends(SunburstView2, _super);
  function SunburstView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstView2.type;
    return _this;
  }
  SunburstView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var self2 = this;
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var data = seriesModel.getData();
    var virtualRoot = data.tree.root;
    var newRoot = seriesModel.getViewRoot();
    var group = this.group;
    var renderLabelForZeroData = seriesModel.get("renderLabelForZeroData");
    var newChildren = [];
    newRoot.eachNode(function(node) {
      newChildren.push(node);
    });
    var oldChildren = this._oldChildren || [];
    dualTravel(newChildren, oldChildren);
    renderRollUp(virtualRoot, newRoot);
    this._initEvents();
    this._oldChildren = newChildren;
    function dualTravel(newChildren2, oldChildren2) {
      if (newChildren2.length === 0 && oldChildren2.length === 0) {
        return;
      }
      new DataDiffer$1(oldChildren2, newChildren2, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIdx, oldIdx) {
        var newNode = newIdx == null ? null : newChildren2[newIdx];
        var oldNode = oldIdx == null ? null : oldChildren2[oldIdx];
        doRenderNode(newNode, oldNode);
      }
    }
    function doRenderNode(newNode, oldNode) {
      if (!renderLabelForZeroData && newNode && !newNode.getValue()) {
        newNode = null;
      }
      if (newNode !== virtualRoot && oldNode !== virtualRoot) {
        if (oldNode && oldNode.piece) {
          if (newNode) {
            oldNode.piece.updateData(false, newNode, seriesModel, ecModel, api);
            data.setItemGraphicEl(newNode.dataIndex, oldNode.piece);
          } else {
            removeNode2(oldNode);
          }
        } else if (newNode) {
          var piece = new SunburstPiece$1(newNode, seriesModel, ecModel, api);
          group.add(piece);
          data.setItemGraphicEl(newNode.dataIndex, piece);
        }
      }
    }
    function removeNode2(node) {
      if (!node) {
        return;
      }
      if (node.piece) {
        group.remove(node.piece);
        node.piece = null;
      }
    }
    function renderRollUp(virtualRoot2, viewRoot) {
      if (viewRoot.depth > 0) {
        if (self2.virtualPiece) {
          self2.virtualPiece.updateData(false, virtualRoot2, seriesModel, ecModel, api);
        } else {
          self2.virtualPiece = new SunburstPiece$1(virtualRoot2, seriesModel, ecModel, api);
          group.add(self2.virtualPiece);
        }
        viewRoot.piece.off("click");
        self2.virtualPiece.on("click", function(e2) {
          self2._rootToNode(viewRoot.parentNode);
        });
      } else if (self2.virtualPiece) {
        group.remove(self2.virtualPiece);
        self2.virtualPiece = null;
      }
    }
  };
  SunburstView2.prototype._initEvents = function() {
    var _this = this;
    this.group.off("click");
    this.group.on("click", function(e2) {
      var targetFound = false;
      var viewRoot = _this.seriesModel.getViewRoot();
      viewRoot.eachNode(function(node) {
        if (!targetFound && node.piece && node.piece === e2.target) {
          var nodeClick = node.getModel().get("nodeClick");
          if (nodeClick === "rootToNode") {
            _this._rootToNode(node);
          } else if (nodeClick === "link") {
            var itemModel = node.getModel();
            var link = itemModel.get("link");
            if (link) {
              var linkTarget = itemModel.get("target", true) || "_blank";
              windowOpen(link, linkTarget);
            }
          }
          targetFound = true;
        }
      });
    });
  };
  SunburstView2.prototype._rootToNode = function(node) {
    if (node !== this.seriesModel.getViewRoot()) {
      this.api.dispatchAction({
        type: ROOT_TO_NODE_ACTION,
        from: this.uid,
        seriesId: this.seriesModel.id,
        targetNode: node
      });
    }
  };
  SunburstView2.prototype.containPoint = function(point, seriesModel) {
    var treeRoot = seriesModel.getData();
    var itemLayout = treeRoot.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  SunburstView2.type = "sunburst";
  return SunburstView2;
}(ChartView$1);
var SunburstView$1 = SunburstView;
var SunburstSeriesModel = function(_super) {
  __extends(SunburstSeriesModel2, _super);
  function SunburstSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstSeriesModel2.type;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  SunburstSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue(root2);
    var levelModels = this._levelModels = map$1(option.levels || [], function(levelDefine) {
      return new Model$1(levelDefine, this, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = levelModels[node.depth];
        levelModel && (model.parentModel = levelModel);
        return model;
      });
    }
    return tree.data;
  };
  SunburstSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  SunburstSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treePathInfo = wrapTreePathInfo(node, this);
    return params;
  };
  SunburstSeriesModel2.prototype.getLevelModel = function(node) {
    return this._levelModels && this._levelModels[node.depth];
  };
  SunburstSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  SunburstSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  SunburstSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  SunburstSeriesModel2.type = "series.sunburst";
  SunburstSeriesModel2.defaultOption = {
    z: 2,
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    stillShowZeroSum: true,
    nodeClick: "rootToNode",
    renderLabelForZeroData: false,
    label: {
      rotate: "radial",
      show: true,
      opacity: 1,
      align: "center",
      position: "inside",
      distance: 5,
      silent: true
    },
    itemStyle: {
      borderWidth: 1,
      borderColor: "white",
      borderType: "solid",
      shadowBlur: 0,
      shadowColor: "rgba(0, 0, 0, 0.2)",
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    emphasis: {
      focus: "descendant"
    },
    blur: {
      itemStyle: {
        opacity: 0.2
      },
      label: {
        opacity: 0.1
      }
    },
    animationType: "expansion",
    animationDuration: 1e3,
    animationDurationUpdate: 500,
    data: [],
    sort: "desc"
  };
  return SunburstSeriesModel2;
}(SeriesModel$1);
function completeTreeValue(dataNode) {
  var sum2 = 0;
  each$f(dataNode.children, function(child) {
    completeTreeValue(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
var SunburstSeriesModel$1 = SunburstSeriesModel;
var RADIAN = Math.PI / 180;
function sunburstLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var center2 = seriesModel.get("center");
    var radius = seriesModel.get("radius");
    if (!isArray$1(radius)) {
      radius = [0, radius];
    }
    if (!isArray$1(center2)) {
      center2 = [center2, center2];
    }
    var width = api.getWidth();
    var height = api.getHeight();
    var size = Math.min(width, height);
    var cx = parsePercent(center2[0], width);
    var cy = parsePercent(center2[1], height);
    var r0 = parsePercent(radius[0], size / 2);
    var r2 = parsePercent(radius[1], size / 2);
    var startAngle = -seriesModel.get("startAngle") * RADIAN;
    var minAngle = seriesModel.get("minAngle") * RADIAN;
    var virtualRoot = seriesModel.getData().tree.root;
    var treeRoot = seriesModel.getViewRoot();
    var rootDepth = treeRoot.depth;
    var sort2 = seriesModel.get("sort");
    if (sort2 != null) {
      initChildren(treeRoot, sort2);
    }
    var validDataCount = 0;
    each$f(treeRoot.children, function(child) {
      !isNaN(child.getValue()) && validDataCount++;
    });
    var sum2 = treeRoot.getValue();
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var renderRollupNode = treeRoot.depth > 0;
    var levels = treeRoot.height - (renderRollupNode ? -1 : 1);
    var rPerLevel = (r2 - r0) / (levels || 1);
    var clockwise = seriesModel.get("clockwise");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var dir3 = clockwise ? 1 : -1;
    var renderNode2 = function(node, startAngle2) {
      if (!node) {
        return;
      }
      var endAngle = startAngle2;
      if (node !== virtualRoot) {
        var value = node.getValue();
        var angle2 = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
        if (angle2 < minAngle) {
          angle2 = minAngle;
        }
        endAngle = startAngle2 + dir3 * angle2;
        var depth = node.depth - rootDepth - (renderRollupNode ? -1 : 1);
        var rStart2 = r0 + rPerLevel * depth;
        var rEnd2 = r0 + rPerLevel * (depth + 1);
        var levelModel = seriesModel.getLevelModel(node);
        if (levelModel) {
          var r0_1 = levelModel.get("r0", true);
          var r_1 = levelModel.get("r", true);
          var radius_1 = levelModel.get("radius", true);
          if (radius_1 != null) {
            r0_1 = radius_1[0];
            r_1 = radius_1[1];
          }
          r0_1 != null && (rStart2 = parsePercent(r0_1, size / 2));
          r_1 != null && (rEnd2 = parsePercent(r_1, size / 2));
        }
        node.setLayout({
          angle: angle2,
          startAngle: startAngle2,
          endAngle,
          clockwise,
          cx,
          cy,
          r0: rStart2,
          r: rEnd2
        });
      }
      if (node.children && node.children.length) {
        var siblingAngle_1 = 0;
        each$f(node.children, function(node2) {
          siblingAngle_1 += renderNode2(node2, startAngle2 + siblingAngle_1);
        });
      }
      return endAngle - startAngle2;
    };
    if (renderRollupNode) {
      var rStart = r0;
      var rEnd = r0 + rPerLevel;
      var angle = Math.PI * 2;
      virtualRoot.setLayout({
        angle,
        startAngle,
        endAngle: startAngle + angle,
        clockwise,
        cx,
        cy,
        r0: rStart,
        r: rEnd
      });
    }
    renderNode2(treeRoot, startAngle);
  });
}
function initChildren(node, sortOrder) {
  var children = node.children || [];
  node.children = sort(children, sortOrder);
  if (children.length) {
    each$f(node.children, function(child) {
      initChildren(child, sortOrder);
    });
  }
}
function sort(children, sortOrder) {
  if (isFunction(sortOrder)) {
    var sortTargets = map$1(children, function(child, idx) {
      var value = child.getValue();
      return {
        params: {
          depth: child.depth,
          height: child.height,
          dataIndex: child.dataIndex,
          getValue: function() {
            return value;
          }
        },
        index: idx
      };
    });
    sortTargets.sort(function(a, b2) {
      return sortOrder(a.params, b2.params);
    });
    return map$1(sortTargets, function(target) {
      return children[target.index];
    });
  } else {
    var isAsc_1 = sortOrder === "asc";
    return children.sort(function(a, b2) {
      var diff = (a.getValue() - b2.getValue()) * (isAsc_1 ? 1 : -1);
      return diff === 0 ? (a.dataIndex - b2.dataIndex) * (isAsc_1 ? -1 : 1) : diff;
    });
  }
}
function sunburstVisual(ecModel) {
  var paletteScope = {};
  function pickColor(node, seriesModel, treeHeight) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var color = seriesModel.getColorFromPalette(current.name || current.dataIndex + "", paletteScope);
    if (node.depth > 1 && isString(color)) {
      color = lift(color, (node.depth - 1) / (treeHeight - 1) * 0.5);
    }
    return color;
  }
  ecModel.eachSeriesByType("sunburst", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style = model.getModel("itemStyle").getItemStyle();
      if (!style.fill) {
        style.fill = pickColor(node, seriesModel, tree.root.height);
      }
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style);
    });
  });
}
function install$s(registers) {
  registers.registerChartView(SunburstView$1);
  registers.registerSeriesModel(SunburstSeriesModel$1);
  registers.registerLayout(curry$1(sunburstLayout, "sunburst"));
  registers.registerProcessor(curry$1(dataFilter$1, "sunburst"));
  registers.registerVisual(sunburstVisual);
  installSunburstAction(registers);
}
var STYLE_VISUAL_TYPE = {
  color: "fill",
  borderColor: "stroke"
};
var NON_STYLE_VISUAL_PROPS = {
  symbol: 1,
  symbolSize: 1,
  symbolKeepAspect: 1,
  legendIcon: 1,
  visualMeta: 1,
  liftZ: 1,
  decal: 1
};
var customInnerStore = makeInner();
var CustomSeriesModel = function(_super) {
  __extends(CustomSeriesModel2, _super);
  function CustomSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomSeriesModel2.type;
    return _this;
  }
  CustomSeriesModel2.prototype.optionUpdated = function() {
    this.currentZLevel = this.get("zlevel", true);
    this.currentZ = this.get("z", true);
  };
  CustomSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this);
  };
  CustomSeriesModel2.prototype.getDataParams = function(dataIndex, dataType, el) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    el && (params.info = customInnerStore(el).info);
    return params;
  };
  CustomSeriesModel2.type = "series.custom";
  CustomSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  CustomSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    clip: false
  };
  return CustomSeriesModel2;
}(SeriesModel$1);
var CustomSeriesModel$1 = CustomSeriesModel;
function dataToCoordSize$3(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["x", "y"], function(dim, dimIdx) {
    var axis = this.getAxis(dim);
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
  }, this);
}
function cartesianPrepareCustom(coordSys) {
  var rect = coordSys.master.getRect();
  return {
    coordSys: {
      type: "cartesian2d",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$3, coordSys)
    }
  };
}
function dataToCoordSize$2(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1([0, 1], function(dimIdx) {
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var p1 = [];
    var p2 = [];
    p1[dimIdx] = val - halfSize;
    p2[dimIdx] = val + halfSize;
    p1[1 - dimIdx] = p2[1 - dimIdx] = dataItem[1 - dimIdx];
    return Math.abs(this.dataToPoint(p1)[dimIdx] - this.dataToPoint(p2)[dimIdx]);
  }, this);
}
function geoPrepareCustom(coordSys) {
  var rect = coordSys.getBoundingRect();
  return {
    coordSys: {
      type: "geo",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      zoom: coordSys.getZoom()
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$2, coordSys)
    }
  };
}
function dataToCoordSize$1(dataSize, dataItem) {
  var axis = this.getAxis();
  var val = dataItem instanceof Array ? dataItem[0] : dataItem;
  var halfSize = (dataSize instanceof Array ? dataSize[0] : dataSize) / 2;
  return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
}
function singlePrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  return {
    coordSys: {
      type: "singleAxis",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(val) {
        return coordSys.dataToPoint(val);
      },
      size: bind$1(dataToCoordSize$1, coordSys)
    }
  };
}
function dataToCoordSize(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["Radius", "Angle"], function(dim, dimIdx) {
    var getterName = "get" + dim + "Axis";
    var axis = this[getterName]();
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var result = axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
    if (dim === "Angle") {
      result = result * Math.PI / 180;
    }
    return result;
  }, this);
}
function polarPrepareCustom(coordSys) {
  var radiusAxis = coordSys.getRadiusAxis();
  var angleAxis = coordSys.getAngleAxis();
  var radius = radiusAxis.getExtent();
  radius[0] > radius[1] && radius.reverse();
  return {
    coordSys: {
      type: "polar",
      cx: coordSys.cx,
      cy: coordSys.cy,
      r: radius[1],
      r0: radius[0]
    },
    api: {
      coord: function(data) {
        var radius2 = radiusAxis.dataToRadius(data[0]);
        var angle = angleAxis.dataToAngle(data[1]);
        var coord = coordSys.coordToPoint([radius2, angle]);
        coord.push(radius2, angle * Math.PI / 180);
        return coord;
      },
      size: bind$1(dataToCoordSize, coordSys)
    }
  };
}
function calendarPrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  var rangeInfo = coordSys.getRangeInfo();
  return {
    coordSys: {
      type: "calendar",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      cellWidth: coordSys.getCellWidth(),
      cellHeight: coordSys.getCellHeight(),
      rangeInfo: {
        start: rangeInfo.start,
        end: rangeInfo.end,
        weeks: rangeInfo.weeks,
        dayCount: rangeInfo.allDay
      }
    },
    api: {
      coord: function(data, clamp2) {
        return coordSys.dataToPoint(data, clamp2);
      }
    }
  };
}
function isEC4CompatibleStyle(style, elType, hasOwnTextContentOption, hasOwnTextConfig) {
  return style && (style.legacy || style.legacy !== false && !hasOwnTextContentOption && !hasOwnTextConfig && elType !== "tspan" && (elType === "text" || hasOwn(style, "text")));
}
function convertFromEC4CompatibleStyle(hostStyle, elType, isNormal) {
  var srcStyle = hostStyle;
  var textConfig;
  var textContent;
  var textContentStyle;
  if (elType === "text") {
    textContentStyle = srcStyle;
  } else {
    textContentStyle = {};
    hasOwn(srcStyle, "text") && (textContentStyle.text = srcStyle.text);
    hasOwn(srcStyle, "rich") && (textContentStyle.rich = srcStyle.rich);
    hasOwn(srcStyle, "textFill") && (textContentStyle.fill = srcStyle.textFill);
    hasOwn(srcStyle, "textStroke") && (textContentStyle.stroke = srcStyle.textStroke);
    hasOwn(srcStyle, "fontFamily") && (textContentStyle.fontFamily = srcStyle.fontFamily);
    hasOwn(srcStyle, "fontSize") && (textContentStyle.fontSize = srcStyle.fontSize);
    hasOwn(srcStyle, "fontStyle") && (textContentStyle.fontStyle = srcStyle.fontStyle);
    hasOwn(srcStyle, "fontWeight") && (textContentStyle.fontWeight = srcStyle.fontWeight);
    textContent = {
      type: "text",
      style: textContentStyle,
      silent: true
    };
    textConfig = {};
    var hasOwnPos = hasOwn(srcStyle, "textPosition");
    if (isNormal) {
      textConfig.position = hasOwnPos ? srcStyle.textPosition : "inside";
    } else {
      hasOwnPos && (textConfig.position = srcStyle.textPosition);
    }
    hasOwn(srcStyle, "textPosition") && (textConfig.position = srcStyle.textPosition);
    hasOwn(srcStyle, "textOffset") && (textConfig.offset = srcStyle.textOffset);
    hasOwn(srcStyle, "textRotation") && (textConfig.rotation = srcStyle.textRotation);
    hasOwn(srcStyle, "textDistance") && (textConfig.distance = srcStyle.textDistance);
  }
  convertEC4CompatibleRichItem(textContentStyle, hostStyle);
  each$f(textContentStyle.rich, function(richItem) {
    convertEC4CompatibleRichItem(richItem, richItem);
  });
  return {
    textConfig,
    textContent
  };
}
function convertEC4CompatibleRichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  richItem.font = richItem.textFont || richItem.font;
  hasOwn(richItem, "textStrokeWidth") && (out2.lineWidth = richItem.textStrokeWidth);
  hasOwn(richItem, "textAlign") && (out2.align = richItem.textAlign);
  hasOwn(richItem, "textVerticalAlign") && (out2.verticalAlign = richItem.textVerticalAlign);
  hasOwn(richItem, "textLineHeight") && (out2.lineHeight = richItem.textLineHeight);
  hasOwn(richItem, "textWidth") && (out2.width = richItem.textWidth);
  hasOwn(richItem, "textHeight") && (out2.height = richItem.textHeight);
  hasOwn(richItem, "textBackgroundColor") && (out2.backgroundColor = richItem.textBackgroundColor);
  hasOwn(richItem, "textPadding") && (out2.padding = richItem.textPadding);
  hasOwn(richItem, "textBorderColor") && (out2.borderColor = richItem.textBorderColor);
  hasOwn(richItem, "textBorderWidth") && (out2.borderWidth = richItem.textBorderWidth);
  hasOwn(richItem, "textBorderRadius") && (out2.borderRadius = richItem.textBorderRadius);
  hasOwn(richItem, "textBoxShadowColor") && (out2.shadowColor = richItem.textBoxShadowColor);
  hasOwn(richItem, "textBoxShadowBlur") && (out2.shadowBlur = richItem.textBoxShadowBlur);
  hasOwn(richItem, "textBoxShadowOffsetX") && (out2.shadowOffsetX = richItem.textBoxShadowOffsetX);
  hasOwn(richItem, "textBoxShadowOffsetY") && (out2.shadowOffsetY = richItem.textBoxShadowOffsetY);
}
function convertToEC4StyleForCustomSerise(itemStl, txStl, txCfg) {
  var out2 = itemStl;
  out2.textPosition = out2.textPosition || txCfg.position || "inside";
  txCfg.offset != null && (out2.textOffset = txCfg.offset);
  txCfg.rotation != null && (out2.textRotation = txCfg.rotation);
  txCfg.distance != null && (out2.textDistance = txCfg.distance);
  var isInside = out2.textPosition.indexOf("inside") >= 0;
  var hostFill = itemStl.fill || "#000";
  convertToEC4RichItem(out2, txStl);
  var textFillNotSet = out2.textFill == null;
  if (isInside) {
    if (textFillNotSet) {
      out2.textFill = txCfg.insideFill || "#fff";
      !out2.textStroke && txCfg.insideStroke && (out2.textStroke = txCfg.insideStroke);
      !out2.textStroke && (out2.textStroke = hostFill);
      out2.textStrokeWidth == null && (out2.textStrokeWidth = 2);
    }
  } else {
    if (textFillNotSet) {
      out2.textFill = itemStl.fill || txCfg.outsideFill || "#000";
    }
    !out2.textStroke && txCfg.outsideStroke && (out2.textStroke = txCfg.outsideStroke);
  }
  out2.text = txStl.text;
  out2.rich = txStl.rich;
  each$f(txStl.rich, function(richItem) {
    convertToEC4RichItem(richItem, richItem);
  });
  return out2;
}
function convertToEC4RichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  hasOwn(richItem, "fill") && (out2.textFill = richItem.fill);
  hasOwn(richItem, "stroke") && (out2.textStroke = richItem.fill);
  hasOwn(richItem, "lineWidth") && (out2.textStrokeWidth = richItem.lineWidth);
  hasOwn(richItem, "font") && (out2.font = richItem.font);
  hasOwn(richItem, "fontStyle") && (out2.fontStyle = richItem.fontStyle);
  hasOwn(richItem, "fontWeight") && (out2.fontWeight = richItem.fontWeight);
  hasOwn(richItem, "fontSize") && (out2.fontSize = richItem.fontSize);
  hasOwn(richItem, "fontFamily") && (out2.fontFamily = richItem.fontFamily);
  hasOwn(richItem, "align") && (out2.textAlign = richItem.align);
  hasOwn(richItem, "verticalAlign") && (out2.textVerticalAlign = richItem.verticalAlign);
  hasOwn(richItem, "lineHeight") && (out2.textLineHeight = richItem.lineHeight);
  hasOwn(richItem, "width") && (out2.textWidth = richItem.width);
  hasOwn(richItem, "height") && (out2.textHeight = richItem.height);
  hasOwn(richItem, "backgroundColor") && (out2.textBackgroundColor = richItem.backgroundColor);
  hasOwn(richItem, "padding") && (out2.textPadding = richItem.padding);
  hasOwn(richItem, "borderColor") && (out2.textBorderColor = richItem.borderColor);
  hasOwn(richItem, "borderWidth") && (out2.textBorderWidth = richItem.borderWidth);
  hasOwn(richItem, "borderRadius") && (out2.textBorderRadius = richItem.borderRadius);
  hasOwn(richItem, "shadowColor") && (out2.textBoxShadowColor = richItem.shadowColor);
  hasOwn(richItem, "shadowBlur") && (out2.textBoxShadowBlur = richItem.shadowBlur);
  hasOwn(richItem, "shadowOffsetX") && (out2.textBoxShadowOffsetX = richItem.shadowOffsetX);
  hasOwn(richItem, "shadowOffsetY") && (out2.textBoxShadowOffsetY = richItem.shadowOffsetY);
  hasOwn(richItem, "textShadowColor") && (out2.textShadowColor = richItem.textShadowColor);
  hasOwn(richItem, "textShadowBlur") && (out2.textShadowBlur = richItem.textShadowBlur);
  hasOwn(richItem, "textShadowOffsetX") && (out2.textShadowOffsetX = richItem.textShadowOffsetX);
  hasOwn(richItem, "textShadowOffsetY") && (out2.textShadowOffsetY = richItem.textShadowOffsetY);
}
var LEGACY_TRANSFORM_PROPS_MAP = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
};
var LEGACY_TRANSFORM_PROPS = keys(LEGACY_TRANSFORM_PROPS_MAP);
reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = 1;
  return obj;
}, {});
TRANSFORMABLE_PROPS.join(", ");
var ELEMENT_ANIMATABLE_PROPS = ["", "style", "shape", "extra"];
var transitionInnerStore = makeInner();
function getElementAnimationConfig(animationType, el, elOption, parentModel, dataIndex) {
  var animationProp = animationType + "Animation";
  var config = getAnimationConfig(animationType, parentModel, dataIndex) || {};
  var userDuring = transitionInnerStore(el).userDuring;
  if (config.duration > 0) {
    config.during = userDuring ? bind$1(duringCall, {
      el,
      userDuring
    }) : null;
    config.setToFinal = true;
    config.scope = animationType;
  }
  extend(config, elOption[animationProp]);
  return config;
}
function applyUpdateTransition(el, elOption, animatableModel, opts) {
  opts = opts || {};
  var dataIndex = opts.dataIndex, isInit = opts.isInit, clearStyle = opts.clearStyle;
  var hasAnimation = animatableModel.isAnimationEnabled();
  var store = transitionInnerStore(el);
  var styleOpt = elOption.style;
  store.userDuring = elOption.during;
  var transFromProps = {};
  var propsToSet = {};
  prepareTransformAllPropsFinal(el, elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("shape", elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("extra", elOption, propsToSet);
  if (!isInit && hasAnimation) {
    prepareTransformTransitionFrom(el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("shape", el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("extra", el, elOption, transFromProps);
    prepareStyleTransitionFrom(el, elOption, styleOpt, transFromProps);
  }
  propsToSet.style = styleOpt;
  applyPropsDirectly(el, propsToSet, clearStyle);
  applyMiscProps(el, elOption);
  if (hasAnimation) {
    if (isInit) {
      var enterFromProps_1 = {};
      each$f(ELEMENT_ANIMATABLE_PROPS, function(propName) {
        var prop = propName ? elOption[propName] : elOption;
        if (prop && prop.enterFrom) {
          if (propName) {
            enterFromProps_1[propName] = enterFromProps_1[propName] || {};
          }
          extend(propName ? enterFromProps_1[propName] : enterFromProps_1, prop.enterFrom);
        }
      });
      var config = getElementAnimationConfig("enter", el, elOption, animatableModel, dataIndex);
      if (config.duration > 0) {
        el.animateFrom(enterFromProps_1, config);
      }
    } else {
      applyPropsTransition(el, elOption, dataIndex || 0, animatableModel, transFromProps);
    }
  }
  updateLeaveTo(el, elOption);
  styleOpt ? el.dirty() : el.markRedraw();
}
function updateLeaveTo(el, elOption) {
  var leaveToProps = transitionInnerStore(el).leaveToProps;
  for (var i = 0; i < ELEMENT_ANIMATABLE_PROPS.length; i++) {
    var propName = ELEMENT_ANIMATABLE_PROPS[i];
    var prop = propName ? elOption[propName] : elOption;
    if (prop && prop.leaveTo) {
      if (!leaveToProps) {
        leaveToProps = transitionInnerStore(el).leaveToProps = {};
      }
      if (propName) {
        leaveToProps[propName] = leaveToProps[propName] || {};
      }
      extend(propName ? leaveToProps[propName] : leaveToProps, prop.leaveTo);
    }
  }
}
function applyLeaveTransition(el, elOption, animatableModel, onRemove) {
  if (el) {
    var parent_1 = el.parent;
    var leaveToProps = transitionInnerStore(el).leaveToProps;
    if (leaveToProps) {
      var config = getElementAnimationConfig("update", el, elOption, animatableModel, 0);
      config.done = function() {
        parent_1.remove(el);
        onRemove && onRemove();
      };
      el.animateTo(leaveToProps, config);
    } else {
      parent_1.remove(el);
      onRemove && onRemove();
    }
  }
}
function isTransitionAll(transition) {
  return transition === "all";
}
function applyPropsDirectly(el, allPropsFinal, clearStyle) {
  var styleOpt = allPropsFinal.style;
  if (!el.isGroup && styleOpt) {
    if (clearStyle) {
      el.useStyle({});
      var animators = el.animators;
      for (var i = 0; i < animators.length; i++) {
        var animator = animators[i];
        if (animator.targetName === "style") {
          animator.changeTarget(el.style);
        }
      }
    }
    el.setStyle(styleOpt);
  }
  if (allPropsFinal) {
    allPropsFinal.style = null;
    allPropsFinal && el.attr(allPropsFinal);
    allPropsFinal.style = styleOpt;
  }
}
function applyPropsTransition(el, elOption, dataIndex, model, transFromProps) {
  if (transFromProps) {
    var config = getElementAnimationConfig("update", el, elOption, model, dataIndex);
    if (config.duration > 0) {
      el.animateFrom(transFromProps, config);
    }
  }
}
function applyMiscProps(el, elOption) {
  hasOwn(elOption, "silent") && (el.silent = elOption.silent);
  hasOwn(elOption, "ignore") && (el.ignore = elOption.ignore);
  if (el instanceof Displayable$1) {
    hasOwn(elOption, "invisible") && (el.invisible = elOption.invisible);
  }
  if (el instanceof Path$1) {
    hasOwn(elOption, "autoBatch") && (el.autoBatch = elOption.autoBatch);
  }
}
var tmpDuringScope = {};
var transitionDuringAPI = {
  setTransform: function(key, val) {
    tmpDuringScope.el[key] = val;
    return this;
  },
  getTransform: function(key) {
    return tmpDuringScope.el[key];
  },
  setShape: function(key, val) {
    var el = tmpDuringScope.el;
    var shape = el.shape || (el.shape = {});
    shape[key] = val;
    el.dirtyShape && el.dirtyShape();
    return this;
  },
  getShape: function(key) {
    var shape = tmpDuringScope.el.shape;
    if (shape) {
      return shape[key];
    }
  },
  setStyle: function(key, val) {
    var el = tmpDuringScope.el;
    var style = el.style;
    if (style) {
      style[key] = val;
      el.dirtyStyle && el.dirtyStyle();
    }
    return this;
  },
  getStyle: function(key) {
    var style = tmpDuringScope.el.style;
    if (style) {
      return style[key];
    }
  },
  setExtra: function(key, val) {
    var extra = tmpDuringScope.el.extra || (tmpDuringScope.el.extra = {});
    extra[key] = val;
    return this;
  },
  getExtra: function(key) {
    var extra = tmpDuringScope.el.extra;
    if (extra) {
      return extra[key];
    }
  }
};
function duringCall() {
  var scope = this;
  var el = scope.el;
  if (!el) {
    return;
  }
  var latestUserDuring = transitionInnerStore(el).userDuring;
  var scopeUserDuring = scope.userDuring;
  if (latestUserDuring !== scopeUserDuring) {
    scope.el = scope.userDuring = null;
    return;
  }
  tmpDuringScope.el = el;
  scopeUserDuring(transitionDuringAPI);
}
function prepareShapeOrExtraTransitionFrom(mainAttr, fromEl, elOption, transFromProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var elPropsInAttr = fromEl[mainAttr];
  var transFromPropsInAttr;
  if (elPropsInAttr) {
    var transition = elOption.transition;
    var attrTransition = attrOpt.transition;
    if (attrTransition) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      if (isTransitionAll(attrTransition)) {
        extend(transFromPropsInAttr, elPropsInAttr);
      } else {
        var transitionKeys = normalizeToArray(attrTransition);
        for (var i = 0; i < transitionKeys.length; i++) {
          var key = transitionKeys[i];
          var elVal = elPropsInAttr[key];
          transFromPropsInAttr[key] = elVal;
        }
      }
    } else if (isTransitionAll(transition) || indexOf(transition, mainAttr) >= 0) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      var elPropsInAttrKeys = keys(elPropsInAttr);
      for (var i = 0; i < elPropsInAttrKeys.length; i++) {
        var key = elPropsInAttrKeys[i];
        var elVal = elPropsInAttr[key];
        if (isNonStyleTransitionEnabled(attrOpt[key], elVal)) {
          transFromPropsInAttr[key] = elVal;
        }
      }
    }
  }
}
function prepareShapeOrExtraAllPropsFinal(mainAttr, elOption, allProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var allPropsInAttr = allProps[mainAttr] = {};
  var keysInAttr = keys(attrOpt);
  for (var i = 0; i < keysInAttr.length; i++) {
    var key = keysInAttr[i];
    allPropsInAttr[key] = cloneValue(attrOpt[key]);
  }
}
function prepareTransformTransitionFrom(el, elOption, transFromProps) {
  var transition = elOption.transition;
  var transitionKeys = isTransitionAll(transition) ? TRANSFORMABLE_PROPS : normalizeToArray(transition || []);
  for (var i = 0; i < transitionKeys.length; i++) {
    var key = transitionKeys[i];
    if (key === "style" || key === "shape" || key === "extra") {
      continue;
    }
    var elVal = el[key];
    transFromProps[key] = elVal;
  }
}
function prepareTransformAllPropsFinal(el, elOption, allProps) {
  for (var i = 0; i < LEGACY_TRANSFORM_PROPS.length; i++) {
    var legacyName = LEGACY_TRANSFORM_PROPS[i];
    var xyName = LEGACY_TRANSFORM_PROPS_MAP[legacyName];
    var legacyArr = elOption[legacyName];
    if (legacyArr) {
      allProps[xyName[0]] = legacyArr[0];
      allProps[xyName[1]] = legacyArr[1];
    }
  }
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var key = TRANSFORMABLE_PROPS[i];
    if (elOption[key] != null) {
      allProps[key] = elOption[key];
    }
  }
}
function prepareStyleTransitionFrom(fromEl, elOption, styleOpt, transFromProps) {
  if (!styleOpt) {
    return;
  }
  var fromElStyle = fromEl.style;
  var transFromStyleProps;
  if (fromElStyle) {
    var styleTransition = styleOpt.transition;
    var elTransition = elOption.transition;
    if (styleTransition && !isTransitionAll(styleTransition)) {
      var transitionKeys = normalizeToArray(styleTransition);
      !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
      for (var i = 0; i < transitionKeys.length; i++) {
        var key = transitionKeys[i];
        var elVal = fromElStyle[key];
        transFromStyleProps[key] = elVal;
      }
    } else if (fromEl.getAnimationStyleProps && (isTransitionAll(elTransition) || isTransitionAll(styleTransition) || indexOf(elTransition, "style") >= 0)) {
      var animationProps = fromEl.getAnimationStyleProps();
      var animationStyleProps = animationProps ? animationProps.style : null;
      if (animationStyleProps) {
        !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
        var styleKeys = keys(styleOpt);
        for (var i = 0; i < styleKeys.length; i++) {
          var key = styleKeys[i];
          if (animationStyleProps[key]) {
            var elVal = fromElStyle[key];
            transFromStyleProps[key] = elVal;
          }
        }
      }
    }
  }
}
function isNonStyleTransitionEnabled(optVal, elVal) {
  return !isArrayLike(optVal) ? optVal != null && isFinite(optVal) : optVal !== elVal;
}
var getStateToRestore = makeInner();
var KEYFRAME_EXCLUDE_KEYS = ["percent", "easing", "shape", "style", "extra"];
function stopPreviousKeyframeAnimationAndRestore(el) {
  el.stopAnimation("keyframe");
  el.attr(getStateToRestore(el));
}
function applyKeyframeAnimation(el, animationOpts, animatableModel) {
  if (!animatableModel.isAnimationEnabled() || !animationOpts) {
    return;
  }
  if (isArray$1(animationOpts)) {
    each$f(animationOpts, function(singleAnimationOpts) {
      applyKeyframeAnimation(el, singleAnimationOpts, animatableModel);
    });
    return;
  }
  var keyframes = animationOpts.keyframes;
  var duration = animationOpts.duration;
  if (animatableModel && duration == null) {
    var config = getAnimationConfig("enter", animatableModel, 0);
    duration = config && config.duration;
  }
  if (!keyframes || !duration) {
    return;
  }
  var stateToRestore = getStateToRestore(el);
  each$f(ELEMENT_ANIMATABLE_PROPS, function(targetPropName) {
    if (targetPropName && !el[targetPropName]) {
      return;
    }
    var animator;
    keyframes.sort(function(a, b2) {
      return a.percent - b2.percent;
    });
    each$f(keyframes, function(kf) {
      var animators = el.animators;
      var kfValues = targetPropName ? kf[targetPropName] : kf;
      if (!kfValues) {
        return;
      }
      var propKeys = keys(kfValues);
      if (!targetPropName) {
        propKeys = filter(propKeys, function(key) {
          return indexOf(KEYFRAME_EXCLUDE_KEYS, key) < 0;
        });
      }
      if (!propKeys.length) {
        return;
      }
      if (!animator) {
        animator = el.animate(targetPropName, animationOpts.loop, true);
        animator.scope = "keyframe";
      }
      for (var i = 0; i < animators.length; i++) {
        if (animators[i] !== animator && animators[i].targetName === animator.targetName) {
          animators[i].stopTracks(propKeys);
        }
      }
      targetPropName && (stateToRestore[targetPropName] = stateToRestore[targetPropName] || {});
      var savedTarget = targetPropName ? stateToRestore[targetPropName] : stateToRestore;
      each$f(propKeys, function(key) {
        savedTarget[key] = ((targetPropName ? el[targetPropName] : el) || {})[key];
      });
      animator.whenWithKeys(duration * kf.percent, kfValues, propKeys, kf.easing);
    });
    if (!animator) {
      return;
    }
    animator.delay(animationOpts.delay || 0).duration(duration).start(animationOpts.easing);
  });
}
var EMPHASIS = "emphasis";
var NORMAL = "normal";
var BLUR = "blur";
var SELECT = "select";
var STATES = [NORMAL, EMPHASIS, BLUR, SELECT];
var PATH_ITEM_STYLE = {
  normal: ["itemStyle"],
  emphasis: [EMPHASIS, "itemStyle"],
  blur: [BLUR, "itemStyle"],
  select: [SELECT, "itemStyle"]
};
var PATH_LABEL = {
  normal: ["label"],
  emphasis: [EMPHASIS, "label"],
  blur: [BLUR, "label"],
  select: [SELECT, "label"]
};
var DEFAULT_TRANSITION = ["x", "y"];
var GROUP_DIFF_PREFIX = "e\0\0";
var attachedTxInfoTmp = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
};
var prepareCustoms = {
  cartesian2d: cartesianPrepareCustom,
  geo: geoPrepareCustom,
  singleAxis: singlePrepareCustom,
  polar: polarPrepareCustom,
  calendar: calendarPrepareCustom
};
function isPath(el) {
  return el instanceof Path$1;
}
function isDisplayable(el) {
  return el instanceof Displayable$1;
}
function copyElement(sourceEl, targetEl) {
  targetEl.copyTransform(sourceEl);
  if (isDisplayable(targetEl) && isDisplayable(sourceEl)) {
    targetEl.setStyle(sourceEl.style);
    targetEl.z = sourceEl.z;
    targetEl.z2 = sourceEl.z2;
    targetEl.zlevel = sourceEl.zlevel;
    targetEl.invisible = sourceEl.invisible;
    targetEl.ignore = sourceEl.ignore;
    if (isPath(targetEl) && isPath(sourceEl)) {
      targetEl.setShape(sourceEl.shape);
    }
  }
}
var CustomChartView = function(_super) {
  __extends(CustomChartView2, _super);
  function CustomChartView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomChartView2.type;
    return _this;
  }
  CustomChartView2.prototype.render = function(customSeries, ecModel, api, payload) {
    this._progressiveEls = null;
    var oldData = this._data;
    var data = customSeries.getData();
    var group = this.group;
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      createOrUpdateItem(api, null, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      applyLeaveTransition(el, customInnerStore(el).option, customSeries);
    }).update(function(newIdx, oldIdx) {
      var oldEl = oldData.getItemGraphicEl(oldIdx);
      createOrUpdateItem(api, oldEl, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).execute();
    var clipPath = customSeries.get("clip", true) ? createClipPath(customSeries.coordinateSystem, false, customSeries) : null;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
    this._data = data;
  };
  CustomChartView2.prototype.incrementalPrepareRender = function(customSeries, ecModel, api) {
    this.group.removeAll();
    this._data = null;
  };
  CustomChartView2.prototype.incrementalRender = function(params, customSeries, ecModel, api, payload) {
    var data = customSeries.getData();
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    var progressiveEls = this._progressiveEls = [];
    function setIncrementalAndHoverLayer(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = params.start; idx < params.end; idx++) {
      var el = createOrUpdateItem(null, null, idx, renderItem(idx, payload), customSeries, this.group, data);
      if (el) {
        el.traverse(setIncrementalAndHoverLayer);
        progressiveEls.push(el);
      }
    }
  };
  CustomChartView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  CustomChartView2.prototype.filterForExposedEvent = function(eventType, query, targetEl, packedEvent) {
    var elementName = query.element;
    if (elementName == null || targetEl.name === elementName) {
      return true;
    }
    while ((targetEl = targetEl.__hostTarget || targetEl.parent) && targetEl !== this.group) {
      if (targetEl.name === elementName) {
        return true;
      }
    }
    return false;
  };
  CustomChartView2.type = "custom";
  return CustomChartView2;
}(ChartView$1);
var CustomChartView$1 = CustomChartView;
function createEl$1(elOption) {
  var graphicType = elOption.type;
  var el;
  if (graphicType === "path") {
    var shape = elOption.shape;
    var pathRect = shape.width != null && shape.height != null ? {
      x: shape.x || 0,
      y: shape.y || 0,
      width: shape.width,
      height: shape.height
    } : null;
    var pathData = getPathData(shape);
    el = makePath(pathData, null, pathRect, shape.layout || "center");
    customInnerStore(el).customPathData = pathData;
  } else if (graphicType === "image") {
    el = new ZRImage$1({});
    customInnerStore(el).customImagePath = elOption.style.image;
  } else if (graphicType === "text") {
    el = new ZRText$1({});
  } else if (graphicType === "group") {
    el = new Group$4();
  } else if (graphicType === "compoundPath") {
    throw new Error('"compoundPath" is not supported yet.');
  } else {
    var Clz = getShapeClass(graphicType);
    if (!Clz) {
      var errMsg = "";
      throwError(errMsg);
    }
    el = new Clz();
  }
  customInnerStore(el).customGraphicType = graphicType;
  el.name = elOption.name;
  el.z2EmphasisLift = 1;
  el.z2SelectLift = 1;
  return el;
}
function updateElNormal(api, el, dataIndex, elOption, attachedTxInfo, seriesModel, isInit) {
  stopPreviousKeyframeAnimationAndRestore(el);
  var txCfgOpt = attachedTxInfo && attachedTxInfo.normal.cfg;
  if (txCfgOpt) {
    el.setTextConfig(txCfgOpt);
  }
  if (elOption && elOption.transition == null) {
    elOption.transition = DEFAULT_TRANSITION;
  }
  var styleOpt = elOption && elOption.style;
  if (styleOpt) {
    if (el.type === "text") {
      var textOptionStyle = styleOpt;
      hasOwn(textOptionStyle, "textFill") && (textOptionStyle.fill = textOptionStyle.textFill);
      hasOwn(textOptionStyle, "textStroke") && (textOptionStyle.stroke = textOptionStyle.textStroke);
    }
    var decalPattern = void 0;
    var decalObj = isPath(el) ? styleOpt.decal : null;
    if (api && decalObj) {
      decalObj.dirty = true;
      decalPattern = createOrUpdatePatternFromDecal(decalObj, api);
    }
    styleOpt.__decalPattern = decalPattern;
  }
  if (isDisplayable(el)) {
    if (styleOpt) {
      var decalPattern = styleOpt.__decalPattern;
      if (decalPattern) {
        styleOpt.decal = decalPattern;
      }
    }
  }
  applyUpdateTransition(el, elOption, seriesModel, {
    dataIndex,
    isInit,
    clearStyle: true
  });
  applyKeyframeAnimation(el, elOption.keyframeAnimation, seriesModel);
}
function updateElOnState(state, el, elStateOpt, styleOpt, attachedTxInfo) {
  var elDisplayable = el.isGroup ? null : el;
  var txCfgOpt = attachedTxInfo && attachedTxInfo[state].cfg;
  if (elDisplayable) {
    var stateObj = elDisplayable.ensureState(state);
    if (styleOpt === false) {
      var existingEmphasisState = elDisplayable.getState(state);
      if (existingEmphasisState) {
        existingEmphasisState.style = null;
      }
    } else {
      stateObj.style = styleOpt || null;
    }
    if (txCfgOpt) {
      stateObj.textConfig = txCfgOpt;
    }
    setDefaultStateProxy(elDisplayable);
  }
}
function updateZ(el, elOption, seriesModel) {
  if (el.isGroup) {
    return;
  }
  var elDisplayable = el;
  var currentZ = seriesModel.currentZ;
  var currentZLevel = seriesModel.currentZLevel;
  elDisplayable.z = currentZ;
  elDisplayable.zlevel = currentZLevel;
  var optZ2 = elOption.z2;
  optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  for (var i = 0; i < STATES.length; i++) {
    updateZForEachState(elDisplayable, elOption, STATES[i]);
  }
}
function updateZForEachState(elDisplayable, elOption, state) {
  var isNormal = state === NORMAL;
  var elStateOpt = isNormal ? elOption : retrieveStateOption(elOption, state);
  var optZ2 = elStateOpt ? elStateOpt.z2 : null;
  var stateObj;
  if (optZ2 != null) {
    stateObj = isNormal ? elDisplayable : elDisplayable.ensureState(state);
    stateObj.z2 = optZ2 || 0;
  }
}
function makeRenderItem(customSeries, data, ecModel, api) {
  var renderItem = customSeries.get("renderItem");
  var coordSys = customSeries.coordinateSystem;
  var prepareResult2 = {};
  if (coordSys) {
    prepareResult2 = coordSys.prepareCustoms ? coordSys.prepareCustoms(coordSys) : prepareCustoms[coordSys.type](coordSys);
  }
  var userAPI = defaults({
    getWidth: api.getWidth,
    getHeight: api.getHeight,
    getZr: api.getZr,
    getDevicePixelRatio: api.getDevicePixelRatio,
    value,
    style,
    ordinalRawValue,
    styleEmphasis,
    visual,
    barLayout,
    currentSeriesIndices,
    font
  }, prepareResult2.api || {});
  var userParams = {
    context: {},
    seriesId: customSeries.id,
    seriesName: customSeries.name,
    seriesIndex: customSeries.seriesIndex,
    coordSys: prepareResult2.coordSys,
    dataInsideLength: data.count(),
    encode: wrapEncodeDef(customSeries.getData())
  };
  var currDataIndexInside;
  var currItemModel;
  var currItemStyleModels = {};
  var currLabelModels = {};
  var seriesItemStyleModels = {};
  var seriesLabelModels = {};
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    seriesItemStyleModels[stateName] = customSeries.getModel(PATH_ITEM_STYLE[stateName]);
    seriesLabelModels[stateName] = customSeries.getModel(PATH_LABEL[stateName]);
  }
  function getItemModel2(dataIndexInside) {
    return dataIndexInside === currDataIndexInside ? currItemModel || (currItemModel = data.getItemModel(dataIndexInside)) : data.getItemModel(dataIndexInside);
  }
  function getItemStyleModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesItemStyleModels[state] : dataIndexInside === currDataIndexInside ? currItemStyleModels[state] || (currItemStyleModels[state] = getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state])) : getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state]);
  }
  function getLabelModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesLabelModels[state] : dataIndexInside === currDataIndexInside ? currLabelModels[state] || (currLabelModels[state] = getItemModel2(dataIndexInside).getModel(PATH_LABEL[state])) : getItemModel2(dataIndexInside).getModel(PATH_LABEL[state]);
  }
  return function(dataIndexInside, payload) {
    currDataIndexInside = dataIndexInside;
    currItemModel = null;
    currItemStyleModels = {};
    currLabelModels = {};
    return renderItem && renderItem(defaults({
      dataIndexInside,
      dataIndex: data.getRawIndex(dataIndexInside),
      actionType: payload ? payload.type : null
    }, userParams), userAPI);
  };
  function value(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    return data.getStore().get(data.getDimensionIndex(dim || 0), dataIndexInside);
  }
  function ordinalRawValue(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    dim = dim || 0;
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo) {
      var dimIndex = data.getDimensionIndex(dim);
      return dimIndex >= 0 ? data.getStore().get(dimIndex, dataIndexInside) : void 0;
    }
    var val = data.get(dimInfo.name, dataIndexInside);
    var ordinalMeta = dimInfo && dimInfo.ordinalMeta;
    return ordinalMeta ? ordinalMeta.categories[val] : val;
  }
  function style(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var style2 = data.getItemVisual(dataIndexInside, "style");
    var visualColor = style2 && style2.fill;
    var opacity = style2 && style2.opacity;
    var itemStyle = getItemStyleModel(dataIndexInside, NORMAL).getItemStyle();
    visualColor != null && (itemStyle.fill = visualColor);
    opacity != null && (itemStyle.opacity = opacity);
    var opt = {
      inheritColor: isString(visualColor) ? visualColor : "#000"
    };
    var labelModel = getLabelModel(dataIndexInside, NORMAL);
    var textStyle = createTextStyle(labelModel, null, opt, false, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve2(customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, opt, false);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function styleEmphasis(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var itemStyle = getItemStyleModel(dataIndexInside, EMPHASIS).getItemStyle();
    var labelModel = getLabelModel(dataIndexInside, EMPHASIS);
    var textStyle = createTextStyle(labelModel, null, null, true, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve3(customSeries.getFormattedLabel(dataIndexInside, EMPHASIS), customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, null, true);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function applyUserPropsAfter(itemStyle, extra) {
    for (var key in extra) {
      if (hasOwn(extra, key)) {
        itemStyle[key] = extra[key];
      }
    }
  }
  function preFetchFromExtra(extra, itemStyle) {
    if (extra) {
      extra.textFill && (itemStyle.textFill = extra.textFill);
      extra.textPosition && (itemStyle.textPosition = extra.textPosition);
    }
  }
  function visual(visualType, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    if (hasOwn(STYLE_VISUAL_TYPE, visualType)) {
      var style_1 = data.getItemVisual(dataIndexInside, "style");
      return style_1 ? style_1[STYLE_VISUAL_TYPE[visualType]] : null;
    }
    if (hasOwn(NON_STYLE_VISUAL_PROPS, visualType)) {
      return data.getItemVisual(dataIndexInside, visualType);
    }
  }
  function barLayout(opt) {
    if (coordSys.type === "cartesian2d") {
      var baseAxis = coordSys.getBaseAxis();
      return getLayoutOnAxis(defaults({
        axis: baseAxis
      }, opt));
    }
  }
  function currentSeriesIndices() {
    return ecModel.getCurrentSeriesIndices();
  }
  function font(opt) {
    return getFont(opt, ecModel);
  }
}
function wrapEncodeDef(data) {
  var encodeDef = {};
  each$f(data.dimensions, function(dimName) {
    var dimInfo = data.getDimensionInfo(dimName);
    if (!dimInfo.isExtraCoord) {
      var coordDim = dimInfo.coordDim;
      var dataDims = encodeDef[coordDim] = encodeDef[coordDim] || [];
      dataDims[dimInfo.coordDimIndex] = data.getDimensionIndex(dimName);
    }
  });
  return encodeDef;
}
function createOrUpdateItem(api, existsEl, dataIndex, elOption, seriesModel, group, data) {
  if (!elOption) {
    group.remove(existsEl);
    return;
  }
  var el = doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group);
  el && data.setItemGraphicEl(dataIndex, el);
  el && toggleHoverEmphasis(el, elOption.focus, elOption.blurScope, elOption.emphasisDisabled);
  return el;
}
function doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group) {
  var toBeReplacedIdx = -1;
  var oldEl = existsEl;
  if (existsEl && doesElNeedRecreate(existsEl, elOption, seriesModel)) {
    toBeReplacedIdx = indexOf(group.childrenRef(), existsEl);
    existsEl = null;
  }
  var isInit = !existsEl;
  var el = existsEl;
  if (!el) {
    el = createEl$1(elOption);
    if (oldEl) {
      copyElement(oldEl, el);
    }
  } else {
    el.clearStates();
  }
  if (elOption.morph === false) {
    el.disableMorphing = true;
  } else if (el.disableMorphing) {
    el.disableMorphing = false;
  }
  attachedTxInfoTmp.normal.cfg = attachedTxInfoTmp.normal.conOpt = attachedTxInfoTmp.emphasis.cfg = attachedTxInfoTmp.emphasis.conOpt = attachedTxInfoTmp.blur.cfg = attachedTxInfoTmp.blur.conOpt = attachedTxInfoTmp.select.cfg = attachedTxInfoTmp.select.conOpt = null;
  attachedTxInfoTmp.isLegacy = false;
  doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfoTmp);
  doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit);
  updateElNormal(api, el, dataIndex, elOption, attachedTxInfoTmp, seriesModel, isInit);
  hasOwn(elOption, "info") && (customInnerStore(el).info = elOption.info);
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    if (stateName !== NORMAL) {
      var otherStateOpt = retrieveStateOption(elOption, stateName);
      var otherStyleOpt = retrieveStyleOptionOnState(elOption, otherStateOpt, stateName);
      updateElOnState(stateName, el, otherStateOpt, otherStyleOpt, attachedTxInfoTmp);
    }
  }
  updateZ(el, elOption, seriesModel);
  if (elOption.type === "group") {
    mergeChildren(api, el, dataIndex, elOption, seriesModel);
  }
  if (toBeReplacedIdx >= 0) {
    group.replaceAt(el, toBeReplacedIdx);
  } else {
    group.add(el);
  }
  return el;
}
function doesElNeedRecreate(el, elOption, seriesModel) {
  var elInner = customInnerStore(el);
  var elOptionType = elOption.type;
  var elOptionShape = elOption.shape;
  var elOptionStyle = elOption.style;
  return seriesModel.isUniversalTransitionEnabled() || elOptionType != null && elOptionType !== elInner.customGraphicType || elOptionType === "path" && hasOwnPathData(elOptionShape) && getPathData(elOptionShape) !== elInner.customPathData || elOptionType === "image" && hasOwn(elOptionStyle, "image") && elOptionStyle.image !== elInner.customImagePath;
}
function doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit) {
  var clipPathOpt = elOption.clipPath;
  if (clipPathOpt === false) {
    if (el && el.getClipPath()) {
      el.removeClipPath();
    }
  } else if (clipPathOpt) {
    var clipPath = el.getClipPath();
    if (clipPath && doesElNeedRecreate(clipPath, clipPathOpt, seriesModel)) {
      clipPath = null;
    }
    if (!clipPath) {
      clipPath = createEl$1(clipPathOpt);
      el.setClipPath(clipPath);
    }
    updateElNormal(null, clipPath, dataIndex, clipPathOpt, null, seriesModel, isInit);
  }
}
function doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfo) {
  if (el.isGroup) {
    return;
  }
  processTxInfo(elOption, null, attachedTxInfo);
  processTxInfo(elOption, EMPHASIS, attachedTxInfo);
  var txConOptNormal = attachedTxInfo.normal.conOpt;
  var txConOptEmphasis = attachedTxInfo.emphasis.conOpt;
  var txConOptBlur = attachedTxInfo.blur.conOpt;
  var txConOptSelect = attachedTxInfo.select.conOpt;
  if (txConOptNormal != null || txConOptEmphasis != null || txConOptSelect != null || txConOptBlur != null) {
    var textContent = el.getTextContent();
    if (txConOptNormal === false) {
      textContent && el.removeTextContent();
    } else {
      txConOptNormal = attachedTxInfo.normal.conOpt = txConOptNormal || {
        type: "text"
      };
      if (!textContent) {
        textContent = createEl$1(txConOptNormal);
        el.setTextContent(textContent);
      } else {
        textContent.clearStates();
      }
      updateElNormal(null, textContent, dataIndex, txConOptNormal, null, seriesModel, isInit);
      var txConStlOptNormal = txConOptNormal && txConOptNormal.style;
      for (var i = 0; i < STATES.length; i++) {
        var stateName = STATES[i];
        if (stateName !== NORMAL) {
          var txConOptOtherState = attachedTxInfo[stateName].conOpt;
          updateElOnState(stateName, textContent, txConOptOtherState, retrieveStyleOptionOnState(txConOptNormal, txConOptOtherState, stateName), null);
        }
      }
      txConStlOptNormal ? textContent.dirty() : textContent.markRedraw();
    }
  }
}
function processTxInfo(elOption, state, attachedTxInfo) {
  var stateOpt = !state ? elOption : retrieveStateOption(elOption, state);
  var styleOpt = !state ? elOption.style : retrieveStyleOptionOnState(elOption, stateOpt, EMPHASIS);
  var elType = elOption.type;
  var txCfg = stateOpt ? stateOpt.textConfig : null;
  var txConOptNormal = elOption.textContent;
  var txConOpt = !txConOptNormal ? null : !state ? txConOptNormal : retrieveStateOption(txConOptNormal, state);
  if (styleOpt && (attachedTxInfo.isLegacy || isEC4CompatibleStyle(styleOpt, elType, !!txCfg, !!txConOpt))) {
    attachedTxInfo.isLegacy = true;
    var convertResult = convertFromEC4CompatibleStyle(styleOpt, elType, !state);
    if (!txCfg && convertResult.textConfig) {
      txCfg = convertResult.textConfig;
    }
    if (!txConOpt && convertResult.textContent) {
      txConOpt = convertResult.textContent;
    }
  }
  if (!state && txConOpt) {
    var txConOptNormal_1 = txConOpt;
    !txConOptNormal_1.type && (txConOptNormal_1.type = "text");
  }
  var info = !state ? attachedTxInfo.normal : attachedTxInfo[state];
  info.cfg = txCfg;
  info.conOpt = txConOpt;
}
function retrieveStateOption(elOption, state) {
  return !state ? elOption : elOption ? elOption[state] : null;
}
function retrieveStyleOptionOnState(stateOptionNormal, stateOption, state) {
  var style = stateOption && stateOption.style;
  if (style == null && state === EMPHASIS && stateOptionNormal) {
    style = stateOptionNormal.styleEmphasis;
  }
  return style;
}
function mergeChildren(api, el, dataIndex, elOption, seriesModel) {
  var newChildren = elOption.children;
  var newLen = newChildren ? newChildren.length : 0;
  var mergeChildren2 = elOption.$mergeChildren;
  var byName = mergeChildren2 === "byName" || elOption.diffChildrenByName;
  var notMerge = mergeChildren2 === false;
  if (!newLen && !byName && !notMerge) {
    return;
  }
  if (byName) {
    diffGroupChildren({
      api,
      oldChildren: el.children() || [],
      newChildren: newChildren || [],
      dataIndex,
      seriesModel,
      group: el
    });
    return;
  }
  notMerge && el.removeAll();
  var index2 = 0;
  for (; index2 < newLen; index2++) {
    newChildren[index2] && doCreateOrUpdateEl(api, el.childAt(index2), dataIndex, newChildren[index2], seriesModel, el);
  }
  for (var i = el.childCount() - 1; i >= index2; i--) {
    var child = el.childAt(i);
    applyLeaveTransition(child, customInnerStore(el).option, seriesModel);
  }
}
function diffGroupChildren(context) {
  new DataDiffer$1(context.oldChildren, context.newChildren, getKey, getKey, context).add(processAddUpdate).update(processAddUpdate).remove(processRemove).execute();
}
function getKey(item, idx) {
  var name = item && item.name;
  return name != null ? name : GROUP_DIFF_PREFIX + idx;
}
function processAddUpdate(newIndex, oldIndex) {
  var context = this.context;
  var childOption = newIndex != null ? context.newChildren[newIndex] : null;
  var child = oldIndex != null ? context.oldChildren[oldIndex] : null;
  doCreateOrUpdateEl(context.api, child, context.dataIndex, childOption, context.seriesModel, context.group);
}
function processRemove(oldIndex) {
  var context = this.context;
  var child = context.oldChildren[oldIndex];
  applyLeaveTransition(child, customInnerStore(child).option, context.seriesModel);
}
function getPathData(shape) {
  return shape && (shape.pathData || shape.d);
}
function hasOwnPathData(shape) {
  return shape && (hasOwn(shape, "pathData") || hasOwn(shape, "d"));
}
function install$r(registers) {
  registers.registerChartView(CustomChartView$1);
  registers.registerSeriesModel(CustomSeriesModel$1);
}
var inner$b = makeInner();
var clone$1 = clone$4;
var bind = bind$1;
var BaseAxisPointer = function() {
  function BaseAxisPointer2() {
    this._dragging = false;
    this.animationThreshold = 15;
  }
  BaseAxisPointer2.prototype.render = function(axisModel, axisPointerModel, api, forceRender) {
    var value = axisPointerModel.get("value");
    var status = axisPointerModel.get("status");
    this._axisModel = axisModel;
    this._axisPointerModel = axisPointerModel;
    this._api = api;
    if (!forceRender && this._lastValue === value && this._lastStatus === status) {
      return;
    }
    this._lastValue = value;
    this._lastStatus = status;
    var group = this._group;
    var handle = this._handle;
    if (!status || status === "hide") {
      group && group.hide();
      handle && handle.hide();
      return;
    }
    group && group.show();
    handle && handle.show();
    var elOption = {};
    this.makeElOption(elOption, value, axisModel, axisPointerModel, api);
    var graphicKey = elOption.graphicKey;
    if (graphicKey !== this._lastGraphicKey) {
      this.clear(api);
    }
    this._lastGraphicKey = graphicKey;
    var moveAnimation = this._moveAnimation = this.determineAnimation(axisModel, axisPointerModel);
    if (!group) {
      group = this._group = new Group$4();
      this.createPointerEl(group, elOption, axisModel, axisPointerModel);
      this.createLabelEl(group, elOption, axisModel, axisPointerModel);
      api.getZr().add(group);
    } else {
      var doUpdateProps = curry$1(updateProps, axisPointerModel, moveAnimation);
      this.updatePointerEl(group, elOption, doUpdateProps);
      this.updateLabelEl(group, elOption, doUpdateProps, axisPointerModel);
    }
    updateMandatoryProps(group, axisPointerModel, true);
    this._renderHandle(value);
  };
  BaseAxisPointer2.prototype.remove = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.dispose = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.determineAnimation = function(axisModel, axisPointerModel) {
    var animation = axisPointerModel.get("animation");
    var axis = axisModel.axis;
    var isCategoryAxis = axis.type === "category";
    var useSnap = axisPointerModel.get("snap");
    if (!useSnap && !isCategoryAxis) {
      return false;
    }
    if (animation === "auto" || animation == null) {
      var animationThreshold = this.animationThreshold;
      if (isCategoryAxis && axis.getBandWidth() > animationThreshold) {
        return true;
      }
      if (useSnap) {
        var seriesDataCount = getAxisInfo$1(axisModel).seriesDataCount;
        var axisExtent = axis.getExtent();
        return Math.abs(axisExtent[0] - axisExtent[1]) / seriesDataCount > animationThreshold;
      }
      return false;
    }
    return animation === true;
  };
  BaseAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
  };
  BaseAxisPointer2.prototype.createPointerEl = function(group, elOption, axisModel, axisPointerModel) {
    var pointerOption = elOption.pointer;
    if (pointerOption) {
      var pointerEl = inner$b(group).pointerEl = new graphic[pointerOption.type](clone$1(elOption.pointer));
      group.add(pointerEl);
    }
  };
  BaseAxisPointer2.prototype.createLabelEl = function(group, elOption, axisModel, axisPointerModel) {
    if (elOption.label) {
      var labelEl = inner$b(group).labelEl = new ZRText$1(clone$1(elOption.label));
      group.add(labelEl);
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype.updatePointerEl = function(group, elOption, updateProps2) {
    var pointerEl = inner$b(group).pointerEl;
    if (pointerEl && elOption.pointer) {
      pointerEl.setStyle(elOption.pointer.style);
      updateProps2(pointerEl, {
        shape: elOption.pointer.shape
      });
    }
  };
  BaseAxisPointer2.prototype.updateLabelEl = function(group, elOption, updateProps2, axisPointerModel) {
    var labelEl = inner$b(group).labelEl;
    if (labelEl) {
      labelEl.setStyle(elOption.label.style);
      updateProps2(labelEl, {
        x: elOption.label.x,
        y: elOption.label.y
      });
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype._renderHandle = function(value) {
    if (this._dragging || !this.updateHandleTransform) {
      return;
    }
    var axisPointerModel = this._axisPointerModel;
    var zr = this._api.getZr();
    var handle = this._handle;
    var handleModel = axisPointerModel.getModel("handle");
    var status = axisPointerModel.get("status");
    if (!handleModel.get("show") || !status || status === "hide") {
      handle && zr.remove(handle);
      this._handle = null;
      return;
    }
    var isInit;
    if (!this._handle) {
      isInit = true;
      handle = this._handle = createIcon(handleModel.get("icon"), {
        cursor: "move",
        draggable: true,
        onmousemove: function(e2) {
          stop(e2.event);
        },
        onmousedown: bind(this._onHandleDragMove, this, 0, 0),
        drift: bind(this._onHandleDragMove, this),
        ondragend: bind(this._onHandleDragEnd, this)
      });
      zr.add(handle);
    }
    updateMandatoryProps(handle, axisPointerModel, false);
    handle.setStyle(handleModel.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
    var handleSize = handleModel.get("size");
    if (!isArray$1(handleSize)) {
      handleSize = [handleSize, handleSize];
    }
    handle.scaleX = handleSize[0] / 2;
    handle.scaleY = handleSize[1] / 2;
    createOrUpdate(this, "_doDispatchAxisPointer", handleModel.get("throttle") || 0, "fixRate");
    this._moveHandleToValue(value, isInit);
  };
  BaseAxisPointer2.prototype._moveHandleToValue = function(value, isInit) {
    updateProps(this._axisPointerModel, !isInit && this._moveAnimation, this._handle, getHandleTransProps(this.getHandleTransform(value, this._axisModel, this._axisPointerModel)));
  };
  BaseAxisPointer2.prototype._onHandleDragMove = function(dx, dy) {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    this._dragging = true;
    var trans = this.updateHandleTransform(getHandleTransProps(handle), [dx, dy], this._axisModel, this._axisPointerModel);
    this._payloadInfo = trans;
    handle.stopAnimation();
    handle.attr(getHandleTransProps(trans));
    inner$b(handle).lastProp = null;
    this._doDispatchAxisPointer();
  };
  BaseAxisPointer2.prototype._doDispatchAxisPointer = function() {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var payloadInfo = this._payloadInfo;
    var axisModel = this._axisModel;
    this._api.dispatchAction({
      type: "updateAxisPointer",
      x: payloadInfo.cursorPoint[0],
      y: payloadInfo.cursorPoint[1],
      tooltipOption: payloadInfo.tooltipOption,
      axesInfo: [{
        axisDim: axisModel.axis.dim,
        axisIndex: axisModel.componentIndex
      }]
    });
  };
  BaseAxisPointer2.prototype._onHandleDragEnd = function() {
    this._dragging = false;
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var value = this._axisPointerModel.get("value");
    this._moveHandleToValue(value);
    this._api.dispatchAction({
      type: "hideTip"
    });
  };
  BaseAxisPointer2.prototype.clear = function(api) {
    this._lastValue = null;
    this._lastStatus = null;
    var zr = api.getZr();
    var group = this._group;
    var handle = this._handle;
    if (zr && group) {
      this._lastGraphicKey = null;
      group && zr.remove(group);
      handle && zr.remove(handle);
      this._group = null;
      this._handle = null;
      this._payloadInfo = null;
    }
    clear$1(this, "_doDispatchAxisPointer");
  };
  BaseAxisPointer2.prototype.doClear = function() {
  };
  BaseAxisPointer2.prototype.buildLabel = function(xy, wh, xDimIndex) {
    xDimIndex = xDimIndex || 0;
    return {
      x: xy[xDimIndex],
      y: xy[1 - xDimIndex],
      width: wh[xDimIndex],
      height: wh[1 - xDimIndex]
    };
  };
  return BaseAxisPointer2;
}();
function updateProps(animationModel, moveAnimation, el, props) {
  if (!propsEqual(inner$b(el).lastProp, props)) {
    inner$b(el).lastProp = props;
    moveAnimation ? updateProps$1(el, props, animationModel) : (el.stopAnimation(), el.attr(props));
  }
}
function propsEqual(lastProps, newProps) {
  if (isObject$4(lastProps) && isObject$4(newProps)) {
    var equals_1 = true;
    each$f(newProps, function(item, key) {
      equals_1 = equals_1 && propsEqual(lastProps[key], item);
    });
    return !!equals_1;
  } else {
    return lastProps === newProps;
  }
}
function updateLabelShowHide(labelEl, axisPointerModel) {
  labelEl[axisPointerModel.get(["label", "show"]) ? "show" : "hide"]();
}
function getHandleTransProps(trans) {
  return {
    x: trans.x || 0,
    y: trans.y || 0,
    rotation: trans.rotation || 0
  };
}
function updateMandatoryProps(group, axisPointerModel, silent) {
  var z2 = axisPointerModel.get("z");
  var zlevel = axisPointerModel.get("zlevel");
  group && group.traverse(function(el) {
    if (el.type !== "group") {
      z2 != null && (el.z = z2);
      zlevel != null && (el.zlevel = zlevel);
      el.silent = silent;
    }
  });
}
var BaseAxisPointer$1 = BaseAxisPointer;
function buildElStyle(axisPointerModel) {
  var axisPointerType = axisPointerModel.get("type");
  var styleModel = axisPointerModel.getModel(axisPointerType + "Style");
  var style;
  if (axisPointerType === "line") {
    style = styleModel.getLineStyle();
    style.fill = null;
  } else if (axisPointerType === "shadow") {
    style = styleModel.getAreaStyle();
    style.stroke = null;
  }
  return style;
}
function buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos) {
  var value = axisPointerModel.get("value");
  var text = getValueLabel(value, axisModel.axis, axisModel.ecModel, axisPointerModel.get("seriesDataIndices"), {
    precision: axisPointerModel.get(["label", "precision"]),
    formatter: axisPointerModel.get(["label", "formatter"])
  });
  var labelModel = axisPointerModel.getModel("label");
  var paddings = normalizeCssArray(labelModel.get("padding") || 0);
  var font = labelModel.getFont();
  var textRect = getBoundingRect(text, font);
  var position2 = labelPos.position;
  var width = textRect.width + paddings[1] + paddings[3];
  var height = textRect.height + paddings[0] + paddings[2];
  var align = labelPos.align;
  align === "right" && (position2[0] -= width);
  align === "center" && (position2[0] -= width / 2);
  var verticalAlign = labelPos.verticalAlign;
  verticalAlign === "bottom" && (position2[1] -= height);
  verticalAlign === "middle" && (position2[1] -= height / 2);
  confineInContainer(position2, width, height, api);
  var bgColor = labelModel.get("backgroundColor");
  if (!bgColor || bgColor === "auto") {
    bgColor = axisModel.get(["axisLine", "lineStyle", "color"]);
  }
  elOption.label = {
    x: position2[0],
    y: position2[1],
    style: createTextStyle(labelModel, {
      text,
      font,
      fill: labelModel.getTextColor(),
      padding: paddings,
      backgroundColor: bgColor
    }),
    z2: 10
  };
}
function confineInContainer(position2, width, height, api) {
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  position2[0] = Math.min(position2[0] + width, viewWidth) - width;
  position2[1] = Math.min(position2[1] + height, viewHeight) - height;
  position2[0] = Math.max(position2[0], 0);
  position2[1] = Math.max(position2[1], 0);
}
function getValueLabel(value, axis, ecModel, seriesDataIndices, opt) {
  value = axis.scale.parse(value);
  var text = axis.scale.getLabel({
    value
  }, {
    precision: opt.precision
  });
  var formatter = opt.formatter;
  if (formatter) {
    var params_1 = {
      value: getAxisRawValue(axis, {
        value
      }),
      axisDimension: axis.dim,
      axisIndex: axis.index,
      seriesData: []
    };
    each$f(seriesDataIndices, function(idxItem) {
      var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
      var dataIndex = idxItem.dataIndexInside;
      var dataParams = series && series.getDataParams(dataIndex);
      dataParams && params_1.seriesData.push(dataParams);
    });
    if (isString(formatter)) {
      text = formatter.replace("{value}", text);
    } else if (isFunction(formatter)) {
      text = formatter(params_1);
    }
  }
  return text;
}
function getTransformedPosition(axis, value, layoutInfo) {
  var transform2 = create$1();
  rotate(transform2, transform2, layoutInfo.rotation);
  translate(transform2, transform2, layoutInfo.position);
  return applyTransform([axis.dataToCoord(value), (layoutInfo.labelOffset || 0) + (layoutInfo.labelDirection || 1) * (layoutInfo.labelMargin || 0)], transform2);
}
function buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api) {
  var textLayout = AxisBuilder$1.innerTextLayout(layoutInfo.rotation, 0, layoutInfo.labelDirection);
  layoutInfo.labelMargin = axisPointerModel.get(["label", "margin"]);
  buildLabelElOption(elOption, axisModel, axisPointerModel, api, {
    position: getTransformedPosition(axisModel.axis, value, layoutInfo),
    align: textLayout.textAlign,
    verticalAlign: textLayout.textVerticalAlign
  });
}
function makeLineShape(p1, p2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x1: p1[xDimIndex],
    y1: p1[1 - xDimIndex],
    x2: p2[xDimIndex],
    y2: p2[1 - xDimIndex]
  };
}
function makeRectShape(xy, wh, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x: xy[xDimIndex],
    y: xy[1 - xDimIndex],
    width: wh[xDimIndex],
    height: wh[1 - xDimIndex]
  };
}
function makeSectorShape(cx, cy, r0, r2, startAngle, endAngle) {
  return {
    cx,
    cy,
    r0,
    r: r2,
    startAngle,
    endAngle,
    clockwise: true
  };
}
var CartesianAxisPointer = function(_super) {
  __extends(CartesianAxisPointer2, _super);
  function CartesianAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisPointerType = axisPointerModel.get("type");
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var pixelValue = axis.toGlobalCoord(axis.dataToCoord(value, true));
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$2[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$2(grid.model, axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  CartesianAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$2(axisModel.axis.grid.model, axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var pos = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: pos[0],
      y: pos[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  CartesianAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisExtent = axis.getGlobalExtent(true);
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var dimIndex = axis.dim === "x" ? 0 : 1;
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    var tooltipOptions = [{
      verticalAlign: "middle"
    }, {
      align: "center"
    }];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: tooltipOptions[dimIndex]
    };
  };
  return CartesianAxisPointer2;
}(BaseAxisPointer$1);
function getCartesian(grid, axis) {
  var opt = {};
  opt[axis.dim + "AxisIndex"] = axis.index;
  return grid.getCartesian(opt);
}
var pointerShapeBuilder$2 = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getAxisDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getAxisDimIndex(axis))
    };
  }
};
function getAxisDimIndex(axis) {
  return axis.dim === "x" ? 0 : 1;
}
var CartesianAxisPointer$1 = CartesianAxisPointer;
var AxisPointerModel = function(_super) {
  __extends(AxisPointerModel2, _super);
  function AxisPointerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerModel2.type;
    return _this;
  }
  AxisPointerModel2.type = "axisPointer";
  AxisPointerModel2.defaultOption = {
    show: "auto",
    z: 50,
    type: "line",
    snap: false,
    triggerTooltip: true,
    value: null,
    status: null,
    link: [],
    animation: null,
    animationDurationUpdate: 200,
    lineStyle: {
      color: "#B9BEC9",
      width: 1,
      type: "dashed"
    },
    shadowStyle: {
      color: "rgba(210,219,238,0.2)"
    },
    label: {
      show: true,
      formatter: null,
      precision: "auto",
      margin: 3,
      color: "#fff",
      padding: [5, 7, 5, 7],
      backgroundColor: "auto",
      borderColor: null,
      borderWidth: 0,
      borderRadius: 3
    },
    handle: {
      show: false,
      icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z",
      size: 45,
      margin: 50,
      color: "#333",
      shadowBlur: 3,
      shadowColor: "#aaa",
      shadowOffsetX: 0,
      shadowOffsetY: 2,
      throttle: 40
    }
  };
  return AxisPointerModel2;
}(ComponentModel$1);
var AxisPointerModel$1 = AxisPointerModel;
var inner$a = makeInner();
var each$8 = each$f;
function register(key, api, handler) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  inner$a(zr).records || (inner$a(zr).records = {});
  initGlobalListeners(zr, api);
  var record = inner$a(zr).records[key] || (inner$a(zr).records[key] = {});
  record.handler = handler;
}
function initGlobalListeners(zr, api) {
  if (inner$a(zr).initialized) {
    return;
  }
  inner$a(zr).initialized = true;
  useHandler("click", curry$1(doEnter, "click"));
  useHandler("mousemove", curry$1(doEnter, "mousemove"));
  useHandler("globalout", onLeave);
  function useHandler(eventType, cb) {
    zr.on(eventType, function(e2) {
      var dis = makeDispatchAction$1(api);
      each$8(inner$a(zr).records, function(record) {
        record && cb(record, e2, dis.dispatchAction);
      });
      dispatchTooltipFinally(dis.pendings, api);
    });
  }
}
function dispatchTooltipFinally(pendings, api) {
  var showLen = pendings.showTip.length;
  var hideLen = pendings.hideTip.length;
  var actuallyPayload;
  if (showLen) {
    actuallyPayload = pendings.showTip[showLen - 1];
  } else if (hideLen) {
    actuallyPayload = pendings.hideTip[hideLen - 1];
  }
  if (actuallyPayload) {
    actuallyPayload.dispatchAction = null;
    api.dispatchAction(actuallyPayload);
  }
}
function onLeave(record, e2, dispatchAction2) {
  record.handler("leave", null, dispatchAction2);
}
function doEnter(currTrigger, record, e2, dispatchAction2) {
  record.handler(currTrigger, e2, dispatchAction2);
}
function makeDispatchAction$1(api) {
  var pendings = {
    showTip: [],
    hideTip: []
  };
  var dispatchAction2 = function(payload) {
    var pendingList = pendings[payload.type];
    if (pendingList) {
      pendingList.push(payload);
    } else {
      payload.dispatchAction = dispatchAction2;
      api.dispatchAction(payload);
    }
  };
  return {
    dispatchAction: dispatchAction2,
    pendings
  };
}
function unregister(key, api) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  var record = (inner$a(zr).records || {})[key];
  if (record) {
    inner$a(zr).records[key] = null;
  }
}
var AxisPointerView = function(_super) {
  __extends(AxisPointerView2, _super);
  function AxisPointerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerView2.type;
    return _this;
  }
  AxisPointerView2.prototype.render = function(globalAxisPointerModel, ecModel, api) {
    var globalTooltipModel = ecModel.getComponent("tooltip");
    var triggerOn = globalAxisPointerModel.get("triggerOn") || globalTooltipModel && globalTooltipModel.get("triggerOn") || "mousemove|click";
    register("axisPointer", api, function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none" && (currTrigger === "leave" || triggerOn.indexOf(currTrigger) >= 0)) {
        dispatchAction2({
          type: "updateAxisPointer",
          currTrigger,
          x: e2 && e2.offsetX,
          y: e2 && e2.offsetY
        });
      }
    });
  };
  AxisPointerView2.prototype.remove = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.prototype.dispose = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.type = "axisPointer";
  return AxisPointerView2;
}(ComponentView$1);
var AxisPointerView$1 = AxisPointerView;
function findPointFromSeries(finder, ecModel) {
  var point = [];
  var seriesIndex = finder.seriesIndex;
  var seriesModel;
  if (seriesIndex == null || !(seriesModel = ecModel.getSeriesByIndex(seriesIndex))) {
    return {
      point: []
    };
  }
  var data = seriesModel.getData();
  var dataIndex = queryDataIndex(data, finder);
  if (dataIndex == null || dataIndex < 0 || isArray$1(dataIndex)) {
    return {
      point: []
    };
  }
  var el = data.getItemGraphicEl(dataIndex);
  var coordSys = seriesModel.coordinateSystem;
  if (seriesModel.getTooltipPosition) {
    point = seriesModel.getTooltipPosition(dataIndex) || [];
  } else if (coordSys && coordSys.dataToPoint) {
    if (finder.isStacked) {
      var baseAxis = coordSys.getBaseAxis();
      var valueAxis2 = coordSys.getOtherAxis(baseAxis);
      var valueAxisDim = valueAxis2.dim;
      var baseAxisDim = baseAxis.dim;
      var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
      var baseDim = data.mapDimension(baseAxisDim);
      var stackedData = [];
      stackedData[baseDataOffset] = data.get(baseDim, dataIndex);
      stackedData[1 - baseDataOffset] = data.get(data.getCalculationInfo("stackResultDimension"), dataIndex);
      point = coordSys.dataToPoint(stackedData) || [];
    } else {
      point = coordSys.dataToPoint(data.getValues(map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }), dataIndex)) || [];
    }
  } else if (el) {
    var rect = el.getBoundingRect().clone();
    rect.applyTransform(el.transform);
    point = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  }
  return {
    point,
    el
  };
}
var inner$9 = makeInner();
function axisTrigger(payload, ecModel, api) {
  var currTrigger = payload.currTrigger;
  var point = [payload.x, payload.y];
  var finder = payload;
  var dispatchAction2 = payload.dispatchAction || bind$1(api.dispatchAction, api);
  var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
  if (!coordSysAxesInfo) {
    return;
  }
  if (illegalPoint(point)) {
    point = findPointFromSeries({
      seriesIndex: finder.seriesIndex,
      dataIndex: finder.dataIndex
    }, ecModel).point;
  }
  var isIllegalPoint = illegalPoint(point);
  var inputAxesInfo = finder.axesInfo;
  var axesInfo = coordSysAxesInfo.axesInfo;
  var shouldHide = currTrigger === "leave" || illegalPoint(point);
  var outputPayload = {};
  var showValueMap = {};
  var dataByCoordSys = {
    list: [],
    map: {}
  };
  var updaters = {
    showPointer: curry$1(showPointer, showValueMap),
    showTooltip: curry$1(showTooltip, dataByCoordSys)
  };
  each$f(coordSysAxesInfo.coordSysMap, function(coordSys, coordSysKey) {
    var coordSysContainsPoint = isIllegalPoint || coordSys.containPoint(point);
    each$f(coordSysAxesInfo.coordSysAxesInfo[coordSysKey], function(axisInfo, key) {
      var axis = axisInfo.axis;
      var inputAxisInfo = findInputAxisInfo(inputAxesInfo, axisInfo);
      if (!shouldHide && coordSysContainsPoint && (!inputAxesInfo || inputAxisInfo)) {
        var val = inputAxisInfo && inputAxisInfo.value;
        if (val == null && !isIllegalPoint) {
          val = axis.pointToData(point);
        }
        val != null && processOnAxis(axisInfo, val, updaters, false, outputPayload);
      }
    });
  });
  var linkTriggers = {};
  each$f(axesInfo, function(tarAxisInfo, tarKey) {
    var linkGroup = tarAxisInfo.linkGroup;
    if (linkGroup && !showValueMap[tarKey]) {
      each$f(linkGroup.axesInfo, function(srcAxisInfo, srcKey) {
        var srcValItem = showValueMap[srcKey];
        if (srcAxisInfo !== tarAxisInfo && srcValItem) {
          var val = srcValItem.value;
          linkGroup.mapper && (val = tarAxisInfo.axis.scale.parse(linkGroup.mapper(val, makeMapperParam(srcAxisInfo), makeMapperParam(tarAxisInfo))));
          linkTriggers[tarAxisInfo.key] = val;
        }
      });
    }
  });
  each$f(linkTriggers, function(val, tarKey) {
    processOnAxis(axesInfo[tarKey], val, updaters, true, outputPayload);
  });
  updateModelActually(showValueMap, axesInfo, outputPayload);
  dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2);
  dispatchHighDownActually(axesInfo, dispatchAction2, api);
  return outputPayload;
}
function processOnAxis(axisInfo, newValue, updaters, noSnap, outputFinder) {
  var axis = axisInfo.axis;
  if (axis.scale.isBlank() || !axis.containData(newValue)) {
    return;
  }
  if (!axisInfo.involveSeries) {
    updaters.showPointer(axisInfo, newValue);
    return;
  }
  var payloadInfo = buildPayloadsBySeries(newValue, axisInfo);
  var payloadBatch = payloadInfo.payloadBatch;
  var snapToValue = payloadInfo.snapToValue;
  if (payloadBatch[0] && outputFinder.seriesIndex == null) {
    extend(outputFinder, payloadBatch[0]);
  }
  if (!noSnap && axisInfo.snap) {
    if (axis.containData(snapToValue) && snapToValue != null) {
      newValue = snapToValue;
    }
  }
  updaters.showPointer(axisInfo, newValue, payloadBatch);
  updaters.showTooltip(axisInfo, payloadInfo, snapToValue);
}
function buildPayloadsBySeries(value, axisInfo) {
  var axis = axisInfo.axis;
  var dim = axis.dim;
  var snapToValue = value;
  var payloadBatch = [];
  var minDist = Number.MAX_VALUE;
  var minDiff = -1;
  each$f(axisInfo.seriesModels, function(series, idx) {
    var dataDim = series.getData().mapDimensionsAll(dim);
    var seriesNestestValue;
    var dataIndices;
    if (series.getAxisTooltipData) {
      var result = series.getAxisTooltipData(dataDim, value, axis);
      dataIndices = result.dataIndices;
      seriesNestestValue = result.nestestValue;
    } else {
      dataIndices = series.getData().indicesOfNearest(dataDim[0], value, axis.type === "category" ? 0.5 : null);
      if (!dataIndices.length) {
        return;
      }
      seriesNestestValue = series.getData().get(dataDim[0], dataIndices[0]);
    }
    if (seriesNestestValue == null || !isFinite(seriesNestestValue)) {
      return;
    }
    var diff = value - seriesNestestValue;
    var dist2 = Math.abs(diff);
    if (dist2 <= minDist) {
      if (dist2 < minDist || diff >= 0 && minDiff < 0) {
        minDist = dist2;
        minDiff = diff;
        snapToValue = seriesNestestValue;
        payloadBatch.length = 0;
      }
      each$f(dataIndices, function(dataIndex) {
        payloadBatch.push({
          seriesIndex: series.seriesIndex,
          dataIndexInside: dataIndex,
          dataIndex: series.getData().getRawIndex(dataIndex)
        });
      });
    }
  });
  return {
    payloadBatch,
    snapToValue
  };
}
function showPointer(showValueMap, axisInfo, value, payloadBatch) {
  showValueMap[axisInfo.key] = {
    value,
    payloadBatch
  };
}
function showTooltip(dataByCoordSys, axisInfo, payloadInfo, value) {
  var payloadBatch = payloadInfo.payloadBatch;
  var axis = axisInfo.axis;
  var axisModel = axis.model;
  var axisPointerModel = axisInfo.axisPointerModel;
  if (!axisInfo.triggerTooltip || !payloadBatch.length) {
    return;
  }
  var coordSysModel = axisInfo.coordSys.model;
  var coordSysKey = makeKey(coordSysModel);
  var coordSysItem = dataByCoordSys.map[coordSysKey];
  if (!coordSysItem) {
    coordSysItem = dataByCoordSys.map[coordSysKey] = {
      coordSysId: coordSysModel.id,
      coordSysIndex: coordSysModel.componentIndex,
      coordSysType: coordSysModel.type,
      coordSysMainType: coordSysModel.mainType,
      dataByAxis: []
    };
    dataByCoordSys.list.push(coordSysItem);
  }
  coordSysItem.dataByAxis.push({
    axisDim: axis.dim,
    axisIndex: axisModel.componentIndex,
    axisType: axisModel.type,
    axisId: axisModel.id,
    value,
    valueLabelOpt: {
      precision: axisPointerModel.get(["label", "precision"]),
      formatter: axisPointerModel.get(["label", "formatter"])
    },
    seriesDataIndices: payloadBatch.slice()
  });
}
function updateModelActually(showValueMap, axesInfo, outputPayload) {
  var outputAxesInfo = outputPayload.axesInfo = [];
  each$f(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    var valItem = showValueMap[key];
    if (valItem) {
      !axisInfo.useHandle && (option.status = "show");
      option.value = valItem.value;
      option.seriesDataIndices = (valItem.payloadBatch || []).slice();
    } else {
      !axisInfo.useHandle && (option.status = "hide");
    }
    option.status === "show" && outputAxesInfo.push({
      axisDim: axisInfo.axis.dim,
      axisIndex: axisInfo.axis.model.componentIndex,
      value: option.value
    });
  });
}
function dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2) {
  if (illegalPoint(point) || !dataByCoordSys.list.length) {
    dispatchAction2({
      type: "hideTip"
    });
    return;
  }
  var sampleItem = ((dataByCoordSys.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
  dispatchAction2({
    type: "showTip",
    escapeConnect: true,
    x: point[0],
    y: point[1],
    tooltipOption: payload.tooltipOption,
    position: payload.position,
    dataIndexInside: sampleItem.dataIndexInside,
    dataIndex: sampleItem.dataIndex,
    seriesIndex: sampleItem.seriesIndex,
    dataByCoordSys: dataByCoordSys.list
  });
}
function dispatchHighDownActually(axesInfo, dispatchAction2, api) {
  var zr = api.getZr();
  var highDownKey = "axisPointerLastHighlights";
  var lastHighlights = inner$9(zr)[highDownKey] || {};
  var newHighlights = inner$9(zr)[highDownKey] = {};
  each$f(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    option.status === "show" && each$f(option.seriesDataIndices, function(batchItem) {
      var key2 = batchItem.seriesIndex + " | " + batchItem.dataIndex;
      newHighlights[key2] = batchItem;
    });
  });
  var toHighlight = [];
  var toDownplay = [];
  each$f(lastHighlights, function(batchItem, key) {
    !newHighlights[key] && toDownplay.push(batchItem);
  });
  each$f(newHighlights, function(batchItem, key) {
    !lastHighlights[key] && toHighlight.push(batchItem);
  });
  toDownplay.length && api.dispatchAction({
    type: "downplay",
    escapeConnect: true,
    notBlur: true,
    batch: toDownplay
  });
  toHighlight.length && api.dispatchAction({
    type: "highlight",
    escapeConnect: true,
    notBlur: true,
    batch: toHighlight
  });
}
function findInputAxisInfo(inputAxesInfo, axisInfo) {
  for (var i = 0; i < (inputAxesInfo || []).length; i++) {
    var inputAxisInfo = inputAxesInfo[i];
    if (axisInfo.axis.dim === inputAxisInfo.axisDim && axisInfo.axis.model.componentIndex === inputAxisInfo.axisIndex) {
      return inputAxisInfo;
    }
  }
}
function makeMapperParam(axisInfo) {
  var axisModel = axisInfo.axis.model;
  var item = {};
  var dim = item.axisDim = axisInfo.axis.dim;
  item.axisIndex = item[dim + "AxisIndex"] = axisModel.componentIndex;
  item.axisName = item[dim + "AxisName"] = axisModel.name;
  item.axisId = item[dim + "AxisId"] = axisModel.id;
  return item;
}
function illegalPoint(point) {
  return !point || point[0] == null || isNaN(point[0]) || point[1] == null || isNaN(point[1]);
}
function install$q(registers) {
  AxisView$1.registerAxisPointerClass("CartesianAxisPointer", CartesianAxisPointer$1);
  registers.registerComponentModel(AxisPointerModel$1);
  registers.registerComponentView(AxisPointerView$1);
  registers.registerPreprocessor(function(option) {
    if (option) {
      (!option.axisPointer || option.axisPointer.length === 0) && (option.axisPointer = {});
      var link = option.axisPointer.link;
      if (link && !isArray$1(link)) {
        option.axisPointer.link = [link];
      }
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, function(ecModel, api) {
    ecModel.getComponent("axisPointer").coordSysAxesInfo = collect(ecModel, api);
  });
  registers.registerAction({
    type: "updateAxisPointer",
    event: "updateAxisPointer",
    update: ":updateAxisPointer"
  }, axisTrigger);
}
function install$p(registers) {
  use(install$N);
  use(install$q);
}
var PolarAxisPointer = function(_super) {
  __extends(PolarAxisPointer2, _super);
  function PolarAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    if (axis.dim === "angle") {
      this.animationThreshold = Math.PI / 18;
    }
    var polar = axis.polar;
    var otherAxis = polar.getOtherAxis(axis);
    var otherExtent = otherAxis.getExtent();
    var coordValue = axis.dataToCoord(value);
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$1[axisPointerType](axis, polar, coordValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var labelMargin = axisPointerModel.get(["label", "margin"]);
    var labelPos = getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin);
    buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos);
  };
  return PolarAxisPointer2;
}(BaseAxisPointer$1);
function getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin) {
  var axis = axisModel.axis;
  var coord = axis.dataToCoord(value);
  var axisAngle = polar.getAngleAxis().getExtent()[0];
  axisAngle = axisAngle / 180 * Math.PI;
  var radiusExtent = polar.getRadiusAxis().getExtent();
  var position2;
  var align;
  var verticalAlign;
  if (axis.dim === "radius") {
    var transform2 = create$1();
    rotate(transform2, transform2, axisAngle);
    translate(transform2, transform2, [polar.cx, polar.cy]);
    position2 = applyTransform([coord, -labelMargin], transform2);
    var labelRotation = axisModel.getModel("axisLabel").get("rotate") || 0;
    var labelLayout2 = AxisBuilder$1.innerTextLayout(axisAngle, labelRotation * Math.PI / 180, -1);
    align = labelLayout2.textAlign;
    verticalAlign = labelLayout2.textVerticalAlign;
  } else {
    var r2 = radiusExtent[1];
    position2 = polar.coordToPoint([r2 + labelMargin, coord]);
    var cx = polar.cx;
    var cy = polar.cy;
    align = Math.abs(position2[0] - cx) / r2 < 0.3 ? "center" : position2[0] > cx ? "left" : "right";
    verticalAlign = Math.abs(position2[1] - cy) / r2 < 0.3 ? "middle" : position2[1] > cy ? "top" : "bottom";
  }
  return {
    position: position2,
    align,
    verticalAlign
  };
}
var pointerShapeBuilder$1 = {
  line: function(axis, polar, coordValue, otherExtent) {
    return axis.dim === "angle" ? {
      type: "Line",
      shape: makeLineShape(polar.coordToPoint([otherExtent[0], coordValue]), polar.coordToPoint([otherExtent[1], coordValue]))
    } : {
      type: "Circle",
      shape: {
        cx: polar.cx,
        cy: polar.cy,
        r: coordValue
      }
    };
  },
  shadow: function(axis, polar, coordValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var radian = Math.PI / 180;
    return axis.dim === "angle" ? {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, otherExtent[0], otherExtent[1], (-coordValue - bandWidth / 2) * radian, (-coordValue + bandWidth / 2) * radian)
    } : {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, coordValue - bandWidth / 2, coordValue + bandWidth / 2, 0, Math.PI * 2)
    };
  }
};
var PolarAxisPointer$1 = PolarAxisPointer;
var PolarModel = function(_super) {
  __extends(PolarModel2, _super);
  function PolarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarModel2.type;
    return _this;
  }
  PolarModel2.prototype.findAxisModel = function(axisType) {
    var foundAxisModel;
    var ecModel = this.ecModel;
    ecModel.eachComponent(axisType, function(axisModel) {
      if (axisModel.getCoordSysModel() === this) {
        foundAxisModel = axisModel;
      }
    }, this);
    return foundAxisModel;
  };
  PolarModel2.type = "polar";
  PolarModel2.dependencies = ["radiusAxis", "angleAxis"];
  PolarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "80%"
  };
  return PolarModel2;
}(ComponentModel$1);
var PolarModel$1 = PolarModel;
var PolarAxisModel = function(_super) {
  __extends(PolarAxisModel2, _super);
  function PolarAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("polar", SINGLE_REFERRING).models[0];
  };
  PolarAxisModel2.type = "polarAxis";
  return PolarAxisModel2;
}(ComponentModel$1);
mixin(PolarAxisModel, AxisModelCommonMixin);
var AngleAxisModel = function(_super) {
  __extends(AngleAxisModel2, _super);
  function AngleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisModel2.type;
    return _this;
  }
  AngleAxisModel2.type = "angleAxis";
  return AngleAxisModel2;
}(PolarAxisModel);
var RadiusAxisModel = function(_super) {
  __extends(RadiusAxisModel2, _super);
  function RadiusAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisModel2.type;
    return _this;
  }
  RadiusAxisModel2.type = "radiusAxis";
  return RadiusAxisModel2;
}(PolarAxisModel);
var RadiusAxis = function(_super) {
  __extends(RadiusAxis2, _super);
  function RadiusAxis2(scale2, radiusExtent) {
    return _super.call(this, "radius", scale2, radiusExtent) || this;
  }
  RadiusAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  return RadiusAxis2;
}(Axis$1);
RadiusAxis.prototype.dataToRadius = Axis$1.prototype.dataToCoord;
RadiusAxis.prototype.radiusToData = Axis$1.prototype.coordToData;
var RadiusAxis$1 = RadiusAxis;
var inner$8 = makeInner();
var AngleAxis = function(_super) {
  __extends(AngleAxis2, _super);
  function AngleAxis2(scale2, angleExtent) {
    return _super.call(this, "angle", scale2, angleExtent || [0, 360]) || this;
  }
  AngleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  AngleAxis2.prototype.calculateCategoryInterval = function() {
    var axis = this;
    var labelModel = axis.getLabelModel();
    var ordinalScale = axis.scale;
    var ordinalExtent = ordinalScale.getExtent();
    var tickCount = ordinalScale.count();
    if (ordinalExtent[1] - ordinalExtent[0] < 1) {
      return 0;
    }
    var tickValue = ordinalExtent[0];
    var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
    var unitH = Math.abs(unitSpan);
    var rect = getBoundingRect(tickValue == null ? "" : tickValue + "", labelModel.getFont(), "center", "top");
    var maxH = Math.max(rect.height, 7);
    var dh = maxH / unitH;
    isNaN(dh) && (dh = Infinity);
    var interval = Math.max(0, Math.floor(dh));
    var cache = inner$8(axis.model);
    var lastAutoInterval = cache.lastAutoInterval;
    var lastTickCount = cache.lastTickCount;
    if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval) {
      interval = lastAutoInterval;
    } else {
      cache.lastTickCount = tickCount;
      cache.lastAutoInterval = interval;
    }
    return interval;
  };
  return AngleAxis2;
}(Axis$1);
AngleAxis.prototype.dataToAngle = Axis$1.prototype.dataToCoord;
AngleAxis.prototype.angleToData = Axis$1.prototype.coordToData;
var AngleAxis$1 = AngleAxis;
var polarDimensions = ["radius", "angle"];
var Polar = function() {
  function Polar2(name) {
    this.dimensions = polarDimensions;
    this.type = "polar";
    this.cx = 0;
    this.cy = 0;
    this._radiusAxis = new RadiusAxis$1();
    this._angleAxis = new AngleAxis$1();
    this.axisPointerEnabled = true;
    this.name = name || "";
    this._radiusAxis.polar = this._angleAxis.polar = this;
  }
  Polar2.prototype.containPoint = function(point) {
    var coord = this.pointToCoord(point);
    return this._radiusAxis.contain(coord[0]) && this._angleAxis.contain(coord[1]);
  };
  Polar2.prototype.containData = function(data) {
    return this._radiusAxis.containData(data[0]) && this._angleAxis.containData(data[1]);
  };
  Polar2.prototype.getAxis = function(dim) {
    var key = "_" + dim + "Axis";
    return this[key];
  };
  Polar2.prototype.getAxes = function() {
    return [this._radiusAxis, this._angleAxis];
  };
  Polar2.prototype.getAxesByScale = function(scaleType) {
    var axes = [];
    var angleAxis = this._angleAxis;
    var radiusAxis = this._radiusAxis;
    angleAxis.scale.type === scaleType && axes.push(angleAxis);
    radiusAxis.scale.type === scaleType && axes.push(radiusAxis);
    return axes;
  };
  Polar2.prototype.getAngleAxis = function() {
    return this._angleAxis;
  };
  Polar2.prototype.getRadiusAxis = function() {
    return this._radiusAxis;
  };
  Polar2.prototype.getOtherAxis = function(axis) {
    var angleAxis = this._angleAxis;
    return axis === angleAxis ? this._radiusAxis : angleAxis;
  };
  Polar2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
  };
  Polar2.prototype.getTooltipAxes = function(dim) {
    var baseAxis = dim != null && dim !== "auto" ? this.getAxis(dim) : this.getBaseAxis();
    return {
      baseAxes: [baseAxis],
      otherAxes: [this.getOtherAxis(baseAxis)]
    };
  };
  Polar2.prototype.dataToPoint = function(data, clamp2) {
    return this.coordToPoint([this._radiusAxis.dataToRadius(data[0], clamp2), this._angleAxis.dataToAngle(data[1], clamp2)]);
  };
  Polar2.prototype.pointToData = function(point, clamp2) {
    var coord = this.pointToCoord(point);
    return [this._radiusAxis.radiusToData(coord[0], clamp2), this._angleAxis.angleToData(coord[1], clamp2)];
  };
  Polar2.prototype.pointToCoord = function(point) {
    var dx = point[0] - this.cx;
    var dy = point[1] - this.cy;
    var angleAxis = this.getAngleAxis();
    var extent3 = angleAxis.getExtent();
    var minAngle = Math.min(extent3[0], extent3[1]);
    var maxAngle = Math.max(extent3[0], extent3[1]);
    angleAxis.inverse ? minAngle = maxAngle - 360 : maxAngle = minAngle + 360;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx) / Math.PI * 180;
    var dir3 = radian < minAngle ? 1 : -1;
    while (radian < minAngle || radian > maxAngle) {
      radian += dir3 * 360;
    }
    return [radius, radian];
  };
  Polar2.prototype.coordToPoint = function(coord) {
    var radius = coord[0];
    var radian = coord[1] / 180 * Math.PI;
    var x2 = Math.cos(radian) * radius + this.cx;
    var y2 = -Math.sin(radian) * radius + this.cy;
    return [x2, y2];
  };
  Polar2.prototype.getArea = function() {
    var angleAxis = this.getAngleAxis();
    var radiusAxis = this.getRadiusAxis();
    var radiusExtent = radiusAxis.getExtent().slice();
    radiusExtent[0] > radiusExtent[1] && radiusExtent.reverse();
    var angleExtent = angleAxis.getExtent();
    var RADIAN2 = Math.PI / 180;
    return {
      cx: this.cx,
      cy: this.cy,
      r0: radiusExtent[0],
      r: radiusExtent[1],
      startAngle: -angleExtent[0] * RADIAN2,
      endAngle: -angleExtent[1] * RADIAN2,
      clockwise: angleAxis.inverse,
      contain: function(x2, y2) {
        var dx = x2 - this.cx;
        var dy = y2 - this.cy;
        var d2 = dx * dx + dy * dy - 1e-4;
        var r2 = this.r;
        var r0 = this.r0;
        return d2 <= r2 * r2 && d2 >= r0 * r0;
      }
    };
  };
  Polar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Polar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Polar2;
}();
function getCoordSys$2(finder) {
  var seriesModel = finder.seriesModel;
  var polarModel = finder.polarModel;
  return polarModel && polarModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
var Polar$1 = Polar;
function resizePolar(polar, polarModel, api) {
  var center2 = polarModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  polar.cx = parsePercent(center2[0], width);
  polar.cy = parsePercent(center2[1], height);
  var radiusAxis = polar.getRadiusAxis();
  var size = Math.min(width, height) / 2;
  var radius = polarModel.get("radius");
  if (radius == null) {
    radius = [0, "100%"];
  } else if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  var parsedRadius = [parsePercent(radius[0], size), parsePercent(radius[1], size)];
  radiusAxis.inverse ? radiusAxis.setExtent(parsedRadius[1], parsedRadius[0]) : radiusAxis.setExtent(parsedRadius[0], parsedRadius[1]);
}
function updatePolarScale(ecModel, api) {
  var polar = this;
  var angleAxis = polar.getAngleAxis();
  var radiusAxis = polar.getRadiusAxis();
  angleAxis.scale.setExtent(Infinity, -Infinity);
  radiusAxis.scale.setExtent(Infinity, -Infinity);
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.coordinateSystem === polar) {
      var data_1 = seriesModel.getData();
      each$f(getDataDimensionsOnAxis(data_1, "radius"), function(dim) {
        radiusAxis.scale.unionExtentFromData(data_1, dim);
      });
      each$f(getDataDimensionsOnAxis(data_1, "angle"), function(dim) {
        angleAxis.scale.unionExtentFromData(data_1, dim);
      });
    }
  });
  niceScaleExtent(angleAxis.scale, angleAxis.model);
  niceScaleExtent(radiusAxis.scale, radiusAxis.model);
  if (angleAxis.type === "category" && !angleAxis.onBand) {
    var extent3 = angleAxis.getExtent();
    var diff = 360 / angleAxis.scale.count();
    angleAxis.inverse ? extent3[1] += diff : extent3[1] -= diff;
    angleAxis.setExtent(extent3[0], extent3[1]);
  }
}
function isAngleAxisModel(axisModel) {
  return axisModel.mainType === "angleAxis";
}
function setAxis(axis, axisModel) {
  axis.type = axisModel.get("type");
  axis.scale = createScaleByModel$1(axisModel);
  axis.onBand = axisModel.get("boundaryGap") && axis.type === "category";
  axis.inverse = axisModel.get("inverse");
  if (isAngleAxisModel(axisModel)) {
    axis.inverse = axis.inverse !== axisModel.get("clockwise");
    var startAngle = axisModel.get("startAngle");
    axis.setExtent(startAngle, startAngle + (axis.inverse ? -360 : 360));
  }
  axisModel.axis = axis;
  axis.model = axisModel;
}
var polarCreator = {
  dimensions: polarDimensions,
  create: function(ecModel, api) {
    var polarList = [];
    ecModel.eachComponent("polar", function(polarModel, idx) {
      var polar = new Polar$1(idx + "");
      polar.update = updatePolarScale;
      var radiusAxis = polar.getRadiusAxis();
      var angleAxis = polar.getAngleAxis();
      var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
      var angleAxisModel = polarModel.findAxisModel("angleAxis");
      setAxis(radiusAxis, radiusAxisModel);
      setAxis(angleAxis, angleAxisModel);
      resizePolar(polar, polarModel, api);
      polarList.push(polar);
      polarModel.coordinateSystem = polar;
      polar.model = polarModel;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.get("coordinateSystem") === "polar") {
        var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
        seriesModel.coordinateSystem = polarModel.coordinateSystem;
      }
    });
    return polarList;
  }
};
var polarCreator$1 = polarCreator;
var elementList = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
function getAxisLineShape(polar, rExtent, angle) {
  rExtent[1] > rExtent[0] && (rExtent = rExtent.slice().reverse());
  var start2 = polar.coordToPoint([rExtent[0], angle]);
  var end2 = polar.coordToPoint([rExtent[1], angle]);
  return {
    x1: start2[0],
    y1: start2[1],
    x2: end2[0],
    y2: end2[1]
  };
}
function getRadiusIdx(polar) {
  var radiusAxis = polar.getRadiusAxis();
  return radiusAxis.inverse ? 0 : 1;
}
function fixAngleOverlap(list) {
  var firstItem = list[0];
  var lastItem = list[list.length - 1];
  if (firstItem && lastItem && Math.abs(Math.abs(firstItem.coord - lastItem.coord) - 360) < 1e-4) {
    list.pop();
  }
}
var AngleAxisView = function(_super) {
  __extends(AngleAxisView2, _super);
  function AngleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  AngleAxisView2.prototype.render = function(angleAxisModel, ecModel) {
    this.group.removeAll();
    if (!angleAxisModel.get("show")) {
      return;
    }
    var angleAxis = angleAxisModel.axis;
    var polar = angleAxis.polar;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var ticksAngles = angleAxis.getTicksCoords();
    var minorTickAngles = angleAxis.getMinorTicksCoords();
    var labels = map$1(angleAxis.getViewLabels(), function(labelItem) {
      labelItem = clone$4(labelItem);
      var scale2 = angleAxis.scale;
      var tickValue = scale2.type === "ordinal" ? scale2.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
      labelItem.coord = angleAxis.dataToCoord(tickValue);
      return labelItem;
    });
    fixAngleOverlap(labels);
    fixAngleOverlap(ticksAngles);
    each$f(elementList, function(name) {
      if (angleAxisModel.get([name, "show"]) && (!angleAxis.scale.isBlank() || name === "axisLine")) {
        angelAxisElementsBuilders[name](this.group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels);
      }
    }, this);
  };
  AngleAxisView2.type = "angleAxis";
  return AngleAxisView2;
}(AxisView$1);
var angelAxisElementsBuilders = {
  axisLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var lineStyleModel = angleAxisModel.getModel(["axisLine", "lineStyle"]);
    var rId = getRadiusIdx(polar);
    var r0Id = rId ? 0 : 1;
    var shape;
    if (radiusExtent[r0Id] === 0) {
      shape = new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    } else {
      shape = new Ring$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId],
          r0: radiusExtent[r0Id]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    }
    shape.style.fill = null;
    group.add(shape);
  },
  axisTick: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var tickModel = angleAxisModel.getModel("axisTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * tickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = map$1(ticksAngles, function(tickAngleItem) {
      return new Line$3({
        shape: getAxisLineShape(polar, [radius, radius + tickLen], tickAngleItem.coord)
      });
    });
    group.add(mergePath(lines, {
      style: defaults(tickModel.getModel("lineStyle").getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      })
    }));
  },
  minorTick: function(group, angleAxisModel, polar, tickAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var tickModel = angleAxisModel.getModel("axisTick");
    var minorTickModel = angleAxisModel.getModel("minorTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * minorTickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, [radius, radius + tickLen], minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults(minorTickModel.getModel("lineStyle").getLineStyle(), defaults(tickModel.getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      }))
    }));
  },
  axisLabel: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels) {
    var rawCategoryData = angleAxisModel.getCategories(true);
    var commonLabelModel = angleAxisModel.getModel("axisLabel");
    var labelMargin = commonLabelModel.get("margin");
    var triggerEvent = angleAxisModel.get("triggerEvent");
    each$f(labels, function(labelItem, idx) {
      var labelModel = commonLabelModel;
      var tickValue = labelItem.tickValue;
      var r2 = radiusExtent[getRadiusIdx(polar)];
      var p2 = polar.coordToPoint([r2 + labelMargin, labelItem.coord]);
      var cx = polar.cx;
      var cy = polar.cy;
      var labelTextAlign = Math.abs(p2[0] - cx) / r2 < 0.3 ? "center" : p2[0] > cx ? "left" : "right";
      var labelTextVerticalAlign = Math.abs(p2[1] - cy) / r2 < 0.3 ? "middle" : p2[1] > cy ? "top" : "bottom";
      if (rawCategoryData && rawCategoryData[tickValue]) {
        var rawCategoryItem = rawCategoryData[tickValue];
        if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
          labelModel = new Model$1(rawCategoryItem.textStyle, commonLabelModel, commonLabelModel.ecModel);
        }
      }
      var textEl = new ZRText$1({
        silent: AxisBuilder$1.isLabelSilent(angleAxisModel),
        style: createTextStyle(labelModel, {
          x: p2[0],
          y: p2[1],
          fill: labelModel.getTextColor() || angleAxisModel.get(["axisLine", "lineStyle", "color"]),
          text: labelItem.formattedLabel,
          align: labelTextAlign,
          verticalAlign: labelTextVerticalAlign
        })
      });
      group.add(textEl);
      if (triggerEvent) {
        var eventData = AxisBuilder$1.makeAxisEventDataBase(angleAxisModel);
        eventData.targetType = "axisLabel";
        eventData.value = labelItem.rawLabel;
        getECData(textEl).eventData = eventData;
      }
    }, this);
  },
  splitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var splitLineModel = angleAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksAngles.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        shape: getAxisLineShape(polar, radiusExtent, ticksAngles[i].coord)
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyleModel.getLineStyle()),
        silent: true,
        z: angleAxisModel.get("z")
      }));
    }
  },
  minorSplitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var minorSplitLineModel = angleAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, radiusExtent, minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: lineStyleModel.getLineStyle(),
      silent: true,
      z: angleAxisModel.get("z")
    }));
  },
  splitArea: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!ticksAngles.length) {
      return;
    }
    var splitAreaModel = angleAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var RADIAN2 = Math.PI / 180;
    var prevAngle = -ticksAngles[0].coord * RADIAN2;
    var r0 = Math.min(radiusExtent[0], radiusExtent[1]);
    var r1 = Math.max(radiusExtent[0], radiusExtent[1]);
    var clockwise = angleAxisModel.get("clockwise");
    for (var i = 1, len2 = ticksAngles.length; i <= len2; i++) {
      var coord = i === len2 ? ticksAngles[0].coord : ticksAngles[i].coord;
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0,
          r: r1,
          startAngle: prevAngle,
          endAngle: -coord * RADIAN2,
          clockwise
        },
        silent: true
      }));
      prevAngle = -coord * RADIAN2;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
var AngleAxisView$1 = AngleAxisView;
var axisBuilderAttrs$1 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$1 = ["splitLine", "splitArea", "minorSplitLine"];
var RadiusAxisView = function(_super) {
  __extends(RadiusAxisView2, _super);
  function RadiusAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  RadiusAxisView2.prototype.render = function(radiusAxisModel, ecModel) {
    this.group.removeAll();
    if (!radiusAxisModel.get("show")) {
      return;
    }
    var oldAxisGroup = this._axisGroup;
    var newAxisGroup = this._axisGroup = new Group$4();
    this.group.add(newAxisGroup);
    var radiusAxis = radiusAxisModel.axis;
    var polar = radiusAxis.polar;
    var angleAxis = polar.getAngleAxis();
    var ticksCoords = radiusAxis.getTicksCoords();
    var minorTicksCoords = radiusAxis.getMinorTicksCoords();
    var axisAngle = angleAxis.getExtent()[0];
    var radiusExtent = radiusAxis.getExtent();
    var layout2 = layoutAxis(polar, radiusAxisModel, axisAngle);
    var axisBuilder = new AxisBuilder$1(radiusAxisModel, layout2);
    each$f(axisBuilderAttrs$1, axisBuilder.add, axisBuilder);
    newAxisGroup.add(axisBuilder.getGroup());
    groupTransition(oldAxisGroup, newAxisGroup, radiusAxisModel);
    each$f(selfBuilderAttrs$1, function(name) {
      if (radiusAxisModel.get([name, "show"]) && !radiusAxis.scale.isBlank()) {
        axisElementBuilders$1[name](this.group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords);
      }
    }, this);
  };
  RadiusAxisView2.type = "radiusAxis";
  return RadiusAxisView2;
}(AxisView$1);
var axisElementBuilders$1 = {
  splitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    var splitLineModel = radiusAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: ticksCoords[i].coord
        }
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length],
          fill: null
        }, lineStyleModel.getLineStyle()),
        silent: true
      }));
    }
  },
  minorSplitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords) {
    if (!minorTicksCoords.length) {
      return;
    }
    var minorSplitLineModel = radiusAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        lines.push(new Circle$1({
          shape: {
            cx: polar.cx,
            cy: polar.cy,
            r: minorTicksCoords[i][k2].coord
          }
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults({
        fill: null
      }, lineStyleModel.getLineStyle()),
      silent: true
    }));
  },
  splitArea: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    if (!ticksCoords.length) {
      return;
    }
    var splitAreaModel = radiusAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var prevRadius = ticksCoords[0].coord;
    for (var i = 1; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0: prevRadius,
          r: ticksCoords[i].coord,
          startAngle: 0,
          endAngle: Math.PI * 2
        },
        silent: true
      }));
      prevRadius = ticksCoords[i].coord;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
function layoutAxis(polar, radiusAxisModel, axisAngle) {
  return {
    position: [polar.cx, polar.cy],
    rotation: axisAngle / 180 * Math.PI,
    labelDirection: -1,
    tickDirection: -1,
    nameDirection: 1,
    labelRotate: radiusAxisModel.getModel("axisLabel").get("rotate"),
    z2: 1
  };
}
var RadiusAxisView$1 = RadiusAxisView;
function getSeriesStackId(seriesModel) {
  return seriesModel.get("stack") || "__ec_stack_" + seriesModel.seriesIndex;
}
function getAxisKey(polar, axis) {
  return axis.dim + polar.model.componentIndex;
}
function barLayoutPolar(seriesType2, ecModel, api) {
  var lastStackCoords = {};
  var barWidthAndOffset = calRadialBar(filter(ecModel.getSeriesByType(seriesType2), function(seriesModel) {
    return !ecModel.isSeriesFiltered(seriesModel) && seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "polar";
  }));
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (seriesModel.coordinateSystem.type !== "polar") {
      return;
    }
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var stackId = getSeriesStackId(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[axisKey][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    var valueAxis2 = polar.getOtherAxis(baseAxis);
    var cx = seriesModel.coordinateSystem.cx;
    var cy = seriesModel.coordinateSystem.cy;
    var barMinHeight = seriesModel.get("barMinHeight") || 0;
    var barMinAngle = seriesModel.get("barMinAngle") || 0;
    lastStackCoords[stackId] = lastStackCoords[stackId] || [];
    var valueDim = data.mapDimension(valueAxis2.dim);
    var baseDim = data.mapDimension(baseAxis.dim);
    var stacked = isDimensionStacked(data, valueDim);
    var clampLayout = baseAxis.dim !== "radius" || !seriesModel.get("roundCap", true);
    var valueAxisStart = valueAxis2.dataToCoord(0);
    for (var idx = 0, len2 = data.count(); idx < len2; idx++) {
      var value = data.get(valueDim, idx);
      var baseValue = data.get(baseDim, idx);
      var sign = value >= 0 ? "p" : "n";
      var baseCoord = valueAxisStart;
      if (stacked) {
        if (!lastStackCoords[stackId][baseValue]) {
          lastStackCoords[stackId][baseValue] = {
            p: valueAxisStart,
            n: valueAxisStart
          };
        }
        baseCoord = lastStackCoords[stackId][baseValue][sign];
      }
      var r0 = void 0;
      var r2 = void 0;
      var startAngle = void 0;
      var endAngle = void 0;
      if (valueAxis2.dim === "radius") {
        var radiusSpan = valueAxis2.dataToCoord(value) - valueAxisStart;
        var angle = baseAxis.dataToCoord(baseValue);
        if (Math.abs(radiusSpan) < barMinHeight) {
          radiusSpan = (radiusSpan < 0 ? -1 : 1) * barMinHeight;
        }
        r0 = baseCoord;
        r2 = baseCoord + radiusSpan;
        startAngle = angle - columnOffset;
        endAngle = startAngle - columnWidth;
        stacked && (lastStackCoords[stackId][baseValue][sign] = r2);
      } else {
        var angleSpan = valueAxis2.dataToCoord(value, clampLayout) - valueAxisStart;
        var radius = baseAxis.dataToCoord(baseValue);
        if (Math.abs(angleSpan) < barMinAngle) {
          angleSpan = (angleSpan < 0 ? -1 : 1) * barMinAngle;
        }
        r0 = radius + columnOffset;
        r2 = r0 + columnWidth;
        startAngle = baseCoord;
        endAngle = baseCoord + angleSpan;
        stacked && (lastStackCoords[stackId][baseValue][sign] = endAngle);
      }
      data.setItemLayout(idx, {
        cx,
        cy,
        r0,
        r: r2,
        startAngle: -startAngle * Math.PI / 180,
        endAngle: -endAngle * Math.PI / 180,
        clockwise: startAngle >= endAngle
      });
    }
  });
}
function calRadialBar(barSeries) {
  var columnsMap = {};
  each$f(barSeries, function(seriesModel, idx) {
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var axisExtent = baseAxis.getExtent();
    var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: "20%",
      gap: "30%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = getSeriesStackId(seriesModel);
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    if (barWidth && !stacks[stackId].width) {
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      stacks[stackId].width = barWidth;
      columnsOnAxis.remainedWidth -= barWidth;
    }
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    barGap != null && (columnsOnAxis.gap = barGap);
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$f(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGap = parsePercent(columnsOnAxis.categoryGap, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$f(stacks, function(column, stack) {
      var maxWidth = column.maxWidth;
      if (maxWidth && maxWidth < autoWidth) {
        maxWidth = Math.min(maxWidth, remainedWidth);
        if (column.width) {
          maxWidth = Math.min(maxWidth, column.width);
        }
        remainedWidth -= maxWidth;
        column.width = maxWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$f(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset = -widthSum / 2;
    each$f(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        offset,
        width: column.width
      };
      offset += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
var angleAxisExtraOption = {
  startAngle: 90,
  clockwise: true,
  splitNumber: 12,
  axisLabel: {
    rotate: 0
  }
};
var radiusAxisExtraOption = {
  splitNumber: 5
};
var PolarView = function(_super) {
  __extends(PolarView2, _super);
  function PolarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarView2.type;
    return _this;
  }
  PolarView2.type = "polar";
  return PolarView2;
}(ComponentView$1);
function install$o(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("PolarAxisPointer", PolarAxisPointer$1);
  registers.registerCoordinateSystem("polar", polarCreator$1);
  registers.registerComponentModel(PolarModel$1);
  registers.registerComponentView(PolarView);
  axisModelCreator(registers, "angle", AngleAxisModel, angleAxisExtraOption);
  axisModelCreator(registers, "radius", RadiusAxisModel, radiusAxisExtraOption);
  registers.registerComponentView(AngleAxisView$1);
  registers.registerComponentView(RadiusAxisView$1);
  registers.registerLayout(curry$1(barLayoutPolar, "bar"));
}
function layout$1(axisModel, opt) {
  opt = opt || {};
  var single = axisModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var axisPosition = axis.position;
  var orient = axis.orient;
  var rect = single.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var positionMap = {
    horizontal: {
      top: rectBound[2],
      bottom: rectBound[3]
    },
    vertical: {
      left: rectBound[0],
      right: rectBound[1]
    }
  };
  layout2.position = [orient === "vertical" ? positionMap.vertical[axisPosition] : rectBound[0], orient === "horizontal" ? positionMap.horizontal[axisPosition] : rectBound[3]];
  var r2 = {
    horizontal: 0,
    vertical: 1
  };
  layout2.rotation = Math.PI / 2 * r2[orient];
  var directionMap = {
    top: -1,
    bottom: 1,
    right: 1,
    left: -1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = directionMap[axisPosition];
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotation = opt.rotate;
  labelRotation == null && (labelRotation = axisModel.get(["axisLabel", "rotate"]));
  layout2.labelRotation = axisPosition === "top" ? -labelRotation : labelRotation;
  layout2.z2 = 1;
  return layout2;
}
var axisBuilderAttrs = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs = ["splitArea", "splitLine"];
var SingleAxisView = function(_super) {
  __extends(SingleAxisView2, _super);
  function SingleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisView2.type;
    _this.axisPointerClass = "SingleAxisPointer";
    return _this;
  }
  SingleAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    var layout2 = layout$1(axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, layout2);
    each$f(axisBuilderAttrs, axisBuilder.add, axisBuilder);
    group.add(this._axisGroup);
    group.add(axisBuilder.getGroup());
    each$f(selfBuilderAttrs, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders[name](this, this.group, this._axisGroup, axisModel);
      }
    }, this);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  SingleAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  SingleAxisView2.type = "singleAxis";
  return SingleAxisView2;
}(AxisView$1);
var axisElementBuilders = {
  splitLine: function(axisView, group, axisGroup, axisModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var gridRect = axisModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var splitLines = [];
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    for (var i = 0; i < ticksCoords.length; ++i) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        subPixelOptimize: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        silent: true
      }));
    }
    var lineStyle = lineStyleModel.getLineStyle(["color"]);
    for (var i = 0; i < splitLines.length; ++i) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyle),
        silent: true
      }));
    }
  },
  splitArea: function(axisView, group, axisGroup, axisModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, axisModel);
  }
};
var SingleAxisView$1 = SingleAxisView;
var SingleAxisModel = function(_super) {
  __extends(SingleAxisModel2, _super);
  function SingleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisModel2.type;
    return _this;
  }
  SingleAxisModel2.prototype.getCoordSysModel = function() {
    return this;
  };
  SingleAxisModel2.type = "singleAxis";
  SingleAxisModel2.layoutMode = "box";
  SingleAxisModel2.defaultOption = {
    left: "5%",
    top: "5%",
    right: "5%",
    bottom: "5%",
    type: "value",
    position: "bottom",
    orient: "horizontal",
    axisLine: {
      show: true,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    tooltip: {
      show: true
    },
    axisTick: {
      show: true,
      length: 6,
      lineStyle: {
        width: 1
      }
    },
    axisLabel: {
      show: true,
      interval: "auto"
    },
    splitLine: {
      show: true,
      lineStyle: {
        type: "dashed",
        opacity: 0.2
      }
    }
  };
  return SingleAxisModel2;
}(ComponentModel$1);
mixin(SingleAxisModel, AxisModelCommonMixin.prototype);
var SingleAxisModel$1 = SingleAxisModel;
var SingleAxis = function(_super) {
  __extends(SingleAxis2, _super);
  function SingleAxis2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  SingleAxis2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  SingleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.coordinateSystem.pointToData(point)[0];
  };
  return SingleAxis2;
}(Axis$1);
var SingleAxis$1 = SingleAxis;
var singleDimensions = ["single"];
var Single = function() {
  function Single2(axisModel, ecModel, api) {
    this.type = "single";
    this.dimension = "single";
    this.dimensions = singleDimensions;
    this.axisPointerEnabled = true;
    this.model = axisModel;
    this._init(axisModel, ecModel, api);
  }
  Single2.prototype._init = function(axisModel, ecModel, api) {
    var dim = this.dimension;
    var axis = new SingleAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisModel.get("position"));
    var isCategory2 = axis.type === "category";
    axis.onBand = isCategory2 && axisModel.get("boundaryGap");
    axis.inverse = axisModel.get("inverse");
    axis.orient = axisModel.get("orient");
    axisModel.axis = axis;
    axis.model = axisModel;
    axis.coordinateSystem = this;
    this._axis = axis;
  };
  Single2.prototype.update = function(ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.coordinateSystem === this) {
        var data_1 = seriesModel.getData();
        each$f(data_1.mapDimensionsAll(this.dimension), function(dim) {
          this._axis.scale.unionExtentFromData(data_1, dim);
        }, this);
        niceScaleExtent(this._axis.scale, this._axis.model);
      }
    }, this);
  };
  Single2.prototype.resize = function(axisModel, api) {
    this._rect = getLayoutRect({
      left: axisModel.get("left"),
      top: axisModel.get("top"),
      right: axisModel.get("right"),
      bottom: axisModel.get("bottom"),
      width: axisModel.get("width"),
      height: axisModel.get("height")
    }, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._adjustAxis();
  };
  Single2.prototype.getRect = function() {
    return this._rect;
  };
  Single2.prototype._adjustAxis = function() {
    var rect = this._rect;
    var axis = this._axis;
    var isHorizontal = axis.isHorizontal();
    var extent3 = isHorizontal ? [0, rect.width] : [0, rect.height];
    var idx = axis.reverse ? 1 : 0;
    axis.setExtent(extent3[idx], extent3[1 - idx]);
    this._updateAxisTransform(axis, isHorizontal ? rect.x : rect.y);
  };
  Single2.prototype._updateAxisTransform = function(axis, coordBase) {
    var axisExtent = axis.getExtent();
    var extentSum = axisExtent[0] + axisExtent[1];
    var isHorizontal = axis.isHorizontal();
    axis.toGlobalCoord = isHorizontal ? function(coord) {
      return coord + coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
    axis.toLocalCoord = isHorizontal ? function(coord) {
      return coord - coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
  };
  Single2.prototype.getAxis = function() {
    return this._axis;
  };
  Single2.prototype.getBaseAxis = function() {
    return this._axis;
  };
  Single2.prototype.getAxes = function() {
    return [this._axis];
  };
  Single2.prototype.getTooltipAxes = function() {
    return {
      baseAxes: [this.getAxis()],
      otherAxes: []
    };
  };
  Single2.prototype.containPoint = function(point) {
    var rect = this.getRect();
    var axis = this.getAxis();
    var orient = axis.orient;
    if (orient === "horizontal") {
      return axis.contain(axis.toLocalCoord(point[0])) && point[1] >= rect.y && point[1] <= rect.y + rect.height;
    } else {
      return axis.contain(axis.toLocalCoord(point[1])) && point[0] >= rect.y && point[0] <= rect.y + rect.height;
    }
  };
  Single2.prototype.pointToData = function(point) {
    var axis = this.getAxis();
    return [axis.coordToData(axis.toLocalCoord(point[axis.orient === "horizontal" ? 0 : 1]))];
  };
  Single2.prototype.dataToPoint = function(val) {
    var axis = this.getAxis();
    var rect = this.getRect();
    var pt = [];
    var idx = axis.orient === "horizontal" ? 0 : 1;
    if (val instanceof Array) {
      val = val[0];
    }
    pt[idx] = axis.toGlobalCoord(axis.dataToCoord(+val));
    pt[1 - idx] = idx === 0 ? rect.y + rect.height / 2 : rect.x + rect.width / 2;
    return pt;
  };
  Single2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Single2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Single2;
}();
function getCoordSys$1(finder) {
  var seriesModel = finder.seriesModel;
  var singleModel = finder.singleAxisModel;
  return singleModel && singleModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
function create(ecModel, api) {
  var singles = [];
  ecModel.eachComponent("singleAxis", function(axisModel, idx) {
    var single = new Single(axisModel, ecModel, api);
    single.name = "single_" + idx;
    single.resize(axisModel, api);
    axisModel.coordinateSystem = single;
    singles.push(single);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "singleAxis") {
      var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = singleAxisModel && singleAxisModel.coordinateSystem;
    }
  });
  return singles;
}
var singleCreator = {
  create,
  dimensions: singleDimensions
};
var singleCreator$1 = singleCreator;
var XY$1 = ["x", "y"];
var WH$1 = ["width", "height"];
var SingleAxisPointer = function(_super) {
  __extends(SingleAxisPointer2, _super);
  function SingleAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SingleAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var otherExtent = getGlobalExtent(coordSys, 1 - getPointDimIndex(axis));
    var pixelValue = coordSys.dataToPoint(value)[0];
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$1(axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  SingleAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$1(axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var position2 = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: position2[0],
      y: position2[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  SingleAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var dimIndex = getPointDimIndex(axis);
    var axisExtent = getGlobalExtent(coordSys, dimIndex);
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var otherExtent = getGlobalExtent(coordSys, 1 - dimIndex);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: {
        verticalAlign: "middle"
      }
    };
  };
  return SingleAxisPointer2;
}(BaseAxisPointer$1);
var pointerShapeBuilder = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getPointDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = axis.getBandWidth();
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getPointDimIndex(axis))
    };
  }
};
function getPointDimIndex(axis) {
  return axis.isHorizontal() ? 0 : 1;
}
function getGlobalExtent(coordSys, dimIndex) {
  var rect = coordSys.getRect();
  return [rect[XY$1[dimIndex]], rect[XY$1[dimIndex]] + rect[WH$1[dimIndex]]];
}
var SingleAxisPointer$1 = SingleAxisPointer;
var SingleView = function(_super) {
  __extends(SingleView2, _super);
  function SingleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleView2.type;
    return _this;
  }
  SingleView2.type = "single";
  return SingleView2;
}(ComponentView$1);
function install$n(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("SingleAxisPointer", SingleAxisPointer$1);
  registers.registerComponentView(SingleView);
  registers.registerComponentView(SingleAxisView$1);
  registers.registerComponentModel(SingleAxisModel$1);
  axisModelCreator(registers, "single", SingleAxisModel$1, SingleAxisModel$1.defaultOption);
  registers.registerCoordinateSystem("single", singleCreator$1);
}
var CalendarModel = function(_super) {
  __extends(CalendarModel2, _super);
  function CalendarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarModel2.type;
    return _this;
  }
  CalendarModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(option, inputPositionParams);
  };
  CalendarModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(this.option, option);
  };
  CalendarModel2.prototype.getCellSize = function() {
    return this.option.cellSize;
  };
  CalendarModel2.type = "calendar";
  CalendarModel2.defaultOption = {
    z: 2,
    left: 80,
    top: 60,
    cellSize: 20,
    orient: "horizontal",
    splitLine: {
      show: true,
      lineStyle: {
        color: "#000",
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      color: "#fff",
      borderWidth: 1,
      borderColor: "#ccc"
    },
    dayLabel: {
      show: true,
      firstDay: 0,
      position: "start",
      margin: "50%",
      color: "#000"
    },
    monthLabel: {
      show: true,
      position: "start",
      margin: 5,
      align: "center",
      formatter: null,
      color: "#000"
    },
    yearLabel: {
      show: true,
      position: null,
      margin: 30,
      formatter: null,
      color: "#ccc",
      fontFamily: "sans-serif",
      fontWeight: "bolder",
      fontSize: 20
    }
  };
  return CalendarModel2;
}(ComponentModel$1);
function mergeAndNormalizeLayoutParams$1(target, raw) {
  var cellSize = target.cellSize;
  var cellSizeArr;
  if (!isArray$1(cellSize)) {
    cellSizeArr = target.cellSize = [cellSize, cellSize];
  } else {
    cellSizeArr = cellSize;
  }
  if (cellSizeArr.length === 1) {
    cellSizeArr[1] = cellSizeArr[0];
  }
  var ignoreSize = map$1([0, 1], function(hvIdx) {
    if (sizeCalculable(raw, hvIdx)) {
      cellSizeArr[hvIdx] = "auto";
    }
    return cellSizeArr[hvIdx] != null && cellSizeArr[hvIdx] !== "auto";
  });
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize
  });
}
var CalendarModel$1 = CalendarModel;
var CalendarView = function(_super) {
  __extends(CalendarView2, _super);
  function CalendarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarView2.type;
    return _this;
  }
  CalendarView2.prototype.render = function(calendarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    var coordSys = calendarModel.coordinateSystem;
    var rangeData = coordSys.getRangeInfo();
    var orient = coordSys.getOrient();
    var localeModel = ecModel.getLocaleModel();
    this._renderDayRect(calendarModel, rangeData, group);
    this._renderLines(calendarModel, rangeData, orient, group);
    this._renderYearText(calendarModel, rangeData, orient, group);
    this._renderMonthText(calendarModel, localeModel, orient, group);
    this._renderWeekText(calendarModel, localeModel, rangeData, orient, group);
  };
  CalendarView2.prototype._renderDayRect = function(calendarModel, rangeData, group) {
    var coordSys = calendarModel.coordinateSystem;
    var itemRectStyleModel = calendarModel.getModel("itemStyle").getItemStyle();
    var sw = coordSys.getCellWidth();
    var sh = coordSys.getCellHeight();
    for (var i = rangeData.start.time; i <= rangeData.end.time; i = coordSys.getNextNDay(i, 1).time) {
      var point = coordSys.dataToRect([i], false).tl;
      var rect = new Rect$3({
        shape: {
          x: point[0],
          y: point[1],
          width: sw,
          height: sh
        },
        cursor: "default",
        style: itemRectStyleModel
      });
      group.add(rect);
    }
  };
  CalendarView2.prototype._renderLines = function(calendarModel, rangeData, orient, group) {
    var self2 = this;
    var coordSys = calendarModel.coordinateSystem;
    var lineStyleModel = calendarModel.getModel(["splitLine", "lineStyle"]).getLineStyle();
    var show = calendarModel.get(["splitLine", "show"]);
    var lineWidth = lineStyleModel.lineWidth;
    this._tlpoints = [];
    this._blpoints = [];
    this._firstDayOfMonth = [];
    this._firstDayPoints = [];
    var firstDay = rangeData.start;
    for (var i = 0; firstDay.time <= rangeData.end.time; i++) {
      addPoints(firstDay.formatedDate);
      if (i === 0) {
        firstDay = coordSys.getDateInfo(rangeData.start.y + "-" + rangeData.start.m);
      }
      var date4 = firstDay.date;
      date4.setMonth(date4.getMonth() + 1);
      firstDay = coordSys.getDateInfo(date4);
    }
    addPoints(coordSys.getNextNDay(rangeData.end.time, 1).formatedDate);
    function addPoints(date5) {
      self2._firstDayOfMonth.push(coordSys.getDateInfo(date5));
      self2._firstDayPoints.push(coordSys.dataToRect([date5], false).tl);
      var points2 = self2._getLinePointsOfOneWeek(calendarModel, date5, orient);
      self2._tlpoints.push(points2[0]);
      self2._blpoints.push(points2[points2.length - 1]);
      show && self2._drawSplitline(points2, lineStyleModel, group);
    }
    show && this._drawSplitline(self2._getEdgesPoints(self2._tlpoints, lineWidth, orient), lineStyleModel, group);
    show && this._drawSplitline(self2._getEdgesPoints(self2._blpoints, lineWidth, orient), lineStyleModel, group);
  };
  CalendarView2.prototype._getEdgesPoints = function(points2, lineWidth, orient) {
    var rs = [points2[0].slice(), points2[points2.length - 1].slice()];
    var idx = orient === "horizontal" ? 0 : 1;
    rs[0][idx] = rs[0][idx] - lineWidth / 2;
    rs[1][idx] = rs[1][idx] + lineWidth / 2;
    return rs;
  };
  CalendarView2.prototype._drawSplitline = function(points2, lineStyle, group) {
    var poyline = new Polyline$3({
      z2: 20,
      shape: {
        points: points2
      },
      style: lineStyle
    });
    group.add(poyline);
  };
  CalendarView2.prototype._getLinePointsOfOneWeek = function(calendarModel, date4, orient) {
    var coordSys = calendarModel.coordinateSystem;
    var parsedDate = coordSys.getDateInfo(date4);
    var points2 = [];
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(parsedDate.time, i);
      var point = coordSys.dataToRect([tmpD.time], false);
      points2[2 * tmpD.day] = point.tl;
      points2[2 * tmpD.day + 1] = point[orient === "horizontal" ? "bl" : "tr"];
    }
    return points2;
  };
  CalendarView2.prototype._formatterLabel = function(formatter, params) {
    if (isString(formatter) && formatter) {
      return formatTplSimple(formatter, params);
    }
    if (isFunction(formatter)) {
      return formatter(params);
    }
    return params.nameMap;
  };
  CalendarView2.prototype._yearTextPositionControl = function(textEl, point, orient, position2, margin) {
    var x2 = point[0];
    var y2 = point[1];
    var aligns = ["center", "bottom"];
    if (position2 === "bottom") {
      y2 += margin;
      aligns = ["center", "top"];
    } else if (position2 === "left") {
      x2 -= margin;
    } else if (position2 === "right") {
      x2 += margin;
      aligns = ["center", "top"];
    } else {
      y2 -= margin;
    }
    var rotate2 = 0;
    if (position2 === "left" || position2 === "right") {
      rotate2 = Math.PI / 2;
    }
    return {
      rotation: rotate2,
      x: x2,
      y: y2,
      style: {
        align: aligns[0],
        verticalAlign: aligns[1]
      }
    };
  };
  CalendarView2.prototype._renderYearText = function(calendarModel, rangeData, orient, group) {
    var yearLabel = calendarModel.getModel("yearLabel");
    if (!yearLabel.get("show")) {
      return;
    }
    var margin = yearLabel.get("margin");
    var pos = yearLabel.get("position");
    if (!pos) {
      pos = orient !== "horizontal" ? "top" : "left";
    }
    var points2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]];
    var xc = (points2[0][0] + points2[1][0]) / 2;
    var yc = (points2[0][1] + points2[1][1]) / 2;
    var idx = orient === "horizontal" ? 0 : 1;
    var posPoints = {
      top: [xc, points2[idx][1]],
      bottom: [xc, points2[1 - idx][1]],
      left: [points2[1 - idx][0], yc],
      right: [points2[idx][0], yc]
    };
    var name = rangeData.start.y;
    if (+rangeData.end.y > +rangeData.start.y) {
      name = name + "-" + rangeData.end.y;
    }
    var formatter = yearLabel.get("formatter");
    var params = {
      start: rangeData.start.y,
      end: rangeData.end.y,
      nameMap: name
    };
    var content = this._formatterLabel(formatter, params);
    var yearText = new ZRText$1({
      z2: 30,
      style: createTextStyle(yearLabel, {
        text: content
      })
    });
    yearText.attr(this._yearTextPositionControl(yearText, posPoints[pos], orient, pos, margin));
    group.add(yearText);
  };
  CalendarView2.prototype._monthTextPositionControl = function(point, isCenter, orient, position2, margin) {
    var align = "left";
    var vAlign = "top";
    var x2 = point[0];
    var y2 = point[1];
    if (orient === "horizontal") {
      y2 = y2 + margin;
      if (isCenter) {
        align = "center";
      }
      if (position2 === "start") {
        vAlign = "bottom";
      }
    } else {
      x2 = x2 + margin;
      if (isCenter) {
        vAlign = "middle";
      }
      if (position2 === "start") {
        align = "right";
      }
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderMonthText = function(calendarModel, localeModel, orient, group) {
    var monthLabel = calendarModel.getModel("monthLabel");
    if (!monthLabel.get("show")) {
      return;
    }
    var nameMap = monthLabel.get("nameMap");
    var margin = monthLabel.get("margin");
    var pos = monthLabel.get("position");
    var align = monthLabel.get("align");
    var termPoints = [this._tlpoints, this._blpoints];
    if (!nameMap || isString(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      nameMap = localeModel.get(["time", "monthAbbr"]) || [];
    }
    var idx = pos === "start" ? 0 : 1;
    var axis = orient === "horizontal" ? 0 : 1;
    margin = pos === "start" ? -margin : margin;
    var isCenter = align === "center";
    for (var i = 0; i < termPoints[idx].length - 1; i++) {
      var tmp = termPoints[idx][i].slice();
      var firstDay = this._firstDayOfMonth[i];
      if (isCenter) {
        var firstDayPoints = this._firstDayPoints[i];
        tmp[axis] = (firstDayPoints[axis] + termPoints[0][i + 1][axis]) / 2;
      }
      var formatter = monthLabel.get("formatter");
      var name_1 = nameMap[+firstDay.m - 1];
      var params = {
        yyyy: firstDay.y,
        yy: (firstDay.y + "").slice(2),
        MM: firstDay.m,
        M: +firstDay.m,
        nameMap: name_1
      };
      var content = this._formatterLabel(formatter, params);
      var monthText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(monthLabel, {
          text: content
        }), this._monthTextPositionControl(tmp, isCenter, orient, pos, margin))
      });
      group.add(monthText);
    }
  };
  CalendarView2.prototype._weekTextPositionControl = function(point, orient, position2, margin, cellSize) {
    var align = "center";
    var vAlign = "middle";
    var x2 = point[0];
    var y2 = point[1];
    var isStart = position2 === "start";
    if (orient === "horizontal") {
      x2 = x2 + margin + (isStart ? 1 : -1) * cellSize[0] / 2;
      align = isStart ? "right" : "left";
    } else {
      y2 = y2 + margin + (isStart ? 1 : -1) * cellSize[1] / 2;
      vAlign = isStart ? "bottom" : "top";
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderWeekText = function(calendarModel, localeModel, rangeData, orient, group) {
    var dayLabel = calendarModel.getModel("dayLabel");
    if (!dayLabel.get("show")) {
      return;
    }
    var coordSys = calendarModel.coordinateSystem;
    var pos = dayLabel.get("position");
    var nameMap = dayLabel.get("nameMap");
    var margin = dayLabel.get("margin");
    var firstDayOfWeek = coordSys.getFirstDayOfWeek();
    if (!nameMap || isString(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      var dayOfWeekShort = localeModel.get(["time", "dayOfWeekShort"]);
      nameMap = dayOfWeekShort || map$1(localeModel.get(["time", "dayOfWeekAbbr"]), function(val) {
        return val[0];
      });
    }
    var start2 = coordSys.getNextNDay(rangeData.end.time, 7 - rangeData.lweek).time;
    var cellSize = [coordSys.getCellWidth(), coordSys.getCellHeight()];
    margin = parsePercent(margin, Math.min(cellSize[1], cellSize[0]));
    if (pos === "start") {
      start2 = coordSys.getNextNDay(rangeData.start.time, -(7 + rangeData.fweek)).time;
      margin = -margin;
    }
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(start2, i);
      var point = coordSys.dataToRect([tmpD.time], false).center;
      var day = i;
      day = Math.abs((i + firstDayOfWeek) % 7);
      var weekText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(dayLabel, {
          text: nameMap[day]
        }), this._weekTextPositionControl(point, orient, pos, margin, cellSize))
      });
      group.add(weekText);
    }
  };
  CalendarView2.type = "calendar";
  return CalendarView2;
}(ComponentView$1);
var CalendarView$1 = CalendarView;
var PROXIMATE_ONE_DAY = 864e5;
var Calendar = function() {
  function Calendar2(calendarModel, ecModel, api) {
    this.type = "calendar";
    this.dimensions = Calendar2.dimensions;
    this.getDimensionsInfo = Calendar2.getDimensionsInfo;
    this._model = calendarModel;
  }
  Calendar2.getDimensionsInfo = function() {
    return [{
      name: "time",
      type: "time"
    }, "value"];
  };
  Calendar2.prototype.getRangeInfo = function() {
    return this._rangeInfo;
  };
  Calendar2.prototype.getModel = function() {
    return this._model;
  };
  Calendar2.prototype.getRect = function() {
    return this._rect;
  };
  Calendar2.prototype.getCellWidth = function() {
    return this._sw;
  };
  Calendar2.prototype.getCellHeight = function() {
    return this._sh;
  };
  Calendar2.prototype.getOrient = function() {
    return this._orient;
  };
  Calendar2.prototype.getFirstDayOfWeek = function() {
    return this._firstDayOfWeek;
  };
  Calendar2.prototype.getDateInfo = function(date4) {
    date4 = parseDate(date4);
    var y2 = date4.getFullYear();
    var m2 = date4.getMonth() + 1;
    var mStr = m2 < 10 ? "0" + m2 : "" + m2;
    var d2 = date4.getDate();
    var dStr = d2 < 10 ? "0" + d2 : "" + d2;
    var day = date4.getDay();
    day = Math.abs((day + 7 - this.getFirstDayOfWeek()) % 7);
    return {
      y: y2 + "",
      m: mStr,
      d: dStr,
      day,
      time: date4.getTime(),
      formatedDate: y2 + "-" + mStr + "-" + dStr,
      date: date4
    };
  };
  Calendar2.prototype.getNextNDay = function(date4, n2) {
    n2 = n2 || 0;
    if (n2 === 0) {
      return this.getDateInfo(date4);
    }
    date4 = new Date(this.getDateInfo(date4).time);
    date4.setDate(date4.getDate() + n2);
    return this.getDateInfo(date4);
  };
  Calendar2.prototype.update = function(ecModel, api) {
    this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay");
    this._orient = this._model.get("orient");
    this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0;
    this._rangeInfo = this._getRangeInfo(this._initRangeOption());
    var weeks = this._rangeInfo.weeks || 1;
    var whNames = ["width", "height"];
    var cellSize = this._model.getCellSize().slice();
    var layoutParams = this._model.getBoxLayoutParams();
    var cellNumbers = this._orient === "horizontal" ? [weeks, 7] : [7, weeks];
    each$f([0, 1], function(idx) {
      if (cellSizeSpecified(cellSize, idx)) {
        layoutParams[whNames[idx]] = cellSize[idx] * cellNumbers[idx];
      }
    });
    var whGlobal = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var calendarRect = this._rect = getLayoutRect(layoutParams, whGlobal);
    each$f([0, 1], function(idx) {
      if (!cellSizeSpecified(cellSize, idx)) {
        cellSize[idx] = calendarRect[whNames[idx]] / cellNumbers[idx];
      }
    });
    function cellSizeSpecified(cellSize2, idx) {
      return cellSize2[idx] != null && cellSize2[idx] !== "auto";
    }
    this._sw = cellSize[0];
    this._sh = cellSize[1];
  };
  Calendar2.prototype.dataToPoint = function(data, clamp2) {
    isArray$1(data) && (data = data[0]);
    clamp2 == null && (clamp2 = true);
    var dayInfo = this.getDateInfo(data);
    var range3 = this._rangeInfo;
    var date4 = dayInfo.formatedDate;
    if (clamp2 && !(dayInfo.time >= range3.start.time && dayInfo.time < range3.end.time + PROXIMATE_ONE_DAY)) {
      return [NaN, NaN];
    }
    var week = dayInfo.day;
    var nthWeek = this._getRangeInfo([range3.start.time, date4]).nthWeek;
    if (this._orient === "vertical") {
      return [this._rect.x + week * this._sw + this._sw / 2, this._rect.y + nthWeek * this._sh + this._sh / 2];
    }
    return [this._rect.x + nthWeek * this._sw + this._sw / 2, this._rect.y + week * this._sh + this._sh / 2];
  };
  Calendar2.prototype.pointToData = function(point) {
    var date4 = this.pointToDate(point);
    return date4 && date4.time;
  };
  Calendar2.prototype.dataToRect = function(data, clamp2) {
    var point = this.dataToPoint(data, clamp2);
    return {
      contentShape: {
        x: point[0] - (this._sw - this._lineWidth) / 2,
        y: point[1] - (this._sh - this._lineWidth) / 2,
        width: this._sw - this._lineWidth,
        height: this._sh - this._lineWidth
      },
      center: point,
      tl: [point[0] - this._sw / 2, point[1] - this._sh / 2],
      tr: [point[0] + this._sw / 2, point[1] - this._sh / 2],
      br: [point[0] + this._sw / 2, point[1] + this._sh / 2],
      bl: [point[0] - this._sw / 2, point[1] + this._sh / 2]
    };
  };
  Calendar2.prototype.pointToDate = function(point) {
    var nthX = Math.floor((point[0] - this._rect.x) / this._sw) + 1;
    var nthY = Math.floor((point[1] - this._rect.y) / this._sh) + 1;
    var range3 = this._rangeInfo.range;
    if (this._orient === "vertical") {
      return this._getDateByWeeksAndDay(nthY, nthX - 1, range3);
    }
    return this._getDateByWeeksAndDay(nthX, nthY - 1, range3);
  };
  Calendar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Calendar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  Calendar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Calendar2.prototype._initRangeOption = function() {
    var range3 = this._model.get("range");
    var normalizedRange;
    if (isArray$1(range3) && range3.length === 1) {
      range3 = range3[0];
    }
    if (!isArray$1(range3)) {
      var rangeStr = range3.toString();
      if (/^\d{4}$/.test(rangeStr)) {
        normalizedRange = [rangeStr + "-01-01", rangeStr + "-12-31"];
      }
      if (/^\d{4}[\/|-]\d{1,2}$/.test(rangeStr)) {
        var start2 = this.getDateInfo(rangeStr);
        var firstDay = start2.date;
        firstDay.setMonth(firstDay.getMonth() + 1);
        var end2 = this.getNextNDay(firstDay, -1);
        normalizedRange = [start2.formatedDate, end2.formatedDate];
      }
      if (/^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(rangeStr)) {
        normalizedRange = [rangeStr, rangeStr];
      }
    } else {
      normalizedRange = range3;
    }
    if (!normalizedRange) {
      return range3;
    }
    var tmp = this._getRangeInfo(normalizedRange);
    if (tmp.start.time > tmp.end.time) {
      normalizedRange.reverse();
    }
    return normalizedRange;
  };
  Calendar2.prototype._getRangeInfo = function(range3) {
    var parsedRange = [this.getDateInfo(range3[0]), this.getDateInfo(range3[1])];
    var reversed;
    if (parsedRange[0].time > parsedRange[1].time) {
      reversed = true;
      parsedRange.reverse();
    }
    var allDay = Math.floor(parsedRange[1].time / PROXIMATE_ONE_DAY) - Math.floor(parsedRange[0].time / PROXIMATE_ONE_DAY) + 1;
    var date4 = new Date(parsedRange[0].time);
    var startDateNum = date4.getDate();
    var endDateNum = parsedRange[1].date.getDate();
    date4.setDate(startDateNum + allDay - 1);
    var dateNum = date4.getDate();
    if (dateNum !== endDateNum) {
      var sign = date4.getTime() - parsedRange[1].time > 0 ? 1 : -1;
      while ((dateNum = date4.getDate()) !== endDateNum && (date4.getTime() - parsedRange[1].time) * sign > 0) {
        allDay -= sign;
        date4.setDate(dateNum - sign);
      }
    }
    var weeks = Math.floor((allDay + parsedRange[0].day + 6) / 7);
    var nthWeek = reversed ? -weeks + 1 : weeks - 1;
    reversed && parsedRange.reverse();
    return {
      range: [parsedRange[0].formatedDate, parsedRange[1].formatedDate],
      start: parsedRange[0],
      end: parsedRange[1],
      allDay,
      weeks,
      nthWeek,
      fweek: parsedRange[0].day,
      lweek: parsedRange[1].day
    };
  };
  Calendar2.prototype._getDateByWeeksAndDay = function(nthWeek, day, range3) {
    var rangeInfo = this._getRangeInfo(range3);
    if (nthWeek > rangeInfo.weeks || nthWeek === 0 && day < rangeInfo.fweek || nthWeek === rangeInfo.weeks && day > rangeInfo.lweek) {
      return null;
    }
    var nthDay = (nthWeek - 1) * 7 - rangeInfo.fweek + day;
    var date4 = new Date(rangeInfo.start.time);
    date4.setDate(+rangeInfo.start.d + nthDay);
    return this.getDateInfo(date4);
  };
  Calendar2.create = function(ecModel, api) {
    var calendarList = [];
    ecModel.eachComponent("calendar", function(calendarModel) {
      var calendar = new Calendar2(calendarModel, ecModel, api);
      calendarList.push(calendar);
      calendarModel.coordinateSystem = calendar;
    });
    ecModel.eachSeries(function(calendarSeries) {
      if (calendarSeries.get("coordinateSystem") === "calendar") {
        calendarSeries.coordinateSystem = calendarList[calendarSeries.get("calendarIndex") || 0];
      }
    });
    return calendarList;
  };
  Calendar2.dimensions = ["time", "value"];
  return Calendar2;
}();
function getCoordSys(finder) {
  var calendarModel = finder.calendarModel;
  var seriesModel = finder.seriesModel;
  var coordSys = calendarModel ? calendarModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem : null;
  return coordSys;
}
var Calendar$1 = Calendar;
function install$m(registers) {
  registers.registerComponentModel(CalendarModel$1);
  registers.registerComponentView(CalendarView$1);
  registers.registerCoordinateSystem("calendar", Calendar$1);
}
function setKeyInfoToNewElOption(resultItem, newElOption) {
  var existElOption = resultItem.existing;
  newElOption.id = resultItem.keyInfo.id;
  !newElOption.type && existElOption && (newElOption.type = existElOption.type);
  if (newElOption.parentId == null) {
    var newElParentOption = newElOption.parentOption;
    if (newElParentOption) {
      newElOption.parentId = newElParentOption.id;
    } else if (existElOption) {
      newElOption.parentId = existElOption.parentId;
    }
  }
  newElOption.parentOption = null;
}
function isSetLoc(obj, props) {
  var isSet;
  each$f(props, function(prop) {
    obj[prop] != null && obj[prop] !== "auto" && (isSet = true);
  });
  return isSet;
}
function mergeNewElOptionToExist(existList, index2, newElOption) {
  var newElOptCopy = extend({}, newElOption);
  var existElOption = existList[index2];
  var $action = newElOption.$action || "merge";
  if ($action === "merge") {
    if (existElOption) {
      merge(existElOption, newElOptCopy, true);
      mergeLayoutParam(existElOption, newElOptCopy, {
        ignoreSize: true
      });
      copyLayoutParams(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption, "shape");
      copyTransitionInfo(newElOption, existElOption, "style");
      copyTransitionInfo(newElOption, existElOption, "extra");
      newElOption.clipPath = existElOption.clipPath;
    } else {
      existList[index2] = newElOptCopy;
    }
  } else if ($action === "replace") {
    existList[index2] = newElOptCopy;
  } else if ($action === "remove") {
    existElOption && (existList[index2] = null);
  }
}
var TRANSITION_PROPS_TO_COPY = ["transition", "enterFrom", "leaveTo"];
var ROOT_TRANSITION_PROPS_TO_COPY = TRANSITION_PROPS_TO_COPY.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
function copyTransitionInfo(target, source, targetProp) {
  if (targetProp) {
    if (!target[targetProp] && source[targetProp]) {
      target[targetProp] = {};
    }
    target = target[targetProp];
    source = source[targetProp];
  }
  if (!target || !source) {
    return;
  }
  var props = targetProp ? TRANSITION_PROPS_TO_COPY : ROOT_TRANSITION_PROPS_TO_COPY;
  for (var i = 0; i < props.length; i++) {
    var prop = props[i];
    if (target[prop] == null && source[prop] != null) {
      target[prop] = source[prop];
    }
  }
}
function setLayoutInfoToExist(existItem, newElOption) {
  if (!existItem) {
    return;
  }
  existItem.hv = newElOption.hv = [
    isSetLoc(newElOption, ["left", "right"]),
    isSetLoc(newElOption, ["top", "bottom"])
  ];
  if (existItem.type === "group") {
    var existingGroupOpt = existItem;
    var newGroupOpt = newElOption;
    existingGroupOpt.width == null && (existingGroupOpt.width = newGroupOpt.width = 0);
    existingGroupOpt.height == null && (existingGroupOpt.height = newGroupOpt.height = 0);
  }
}
var GraphicComponentModel = function(_super) {
  __extends(GraphicComponentModel2, _super);
  function GraphicComponentModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentModel2.type;
    _this.preventAutoZ = true;
    return _this;
  }
  GraphicComponentModel2.prototype.mergeOption = function(option, ecModel) {
    var elements = this.option.elements;
    this.option.elements = null;
    _super.prototype.mergeOption.call(this, option, ecModel);
    this.option.elements = elements;
  };
  GraphicComponentModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    var newList = (isInit ? thisOption : newOption).elements;
    var existList = thisOption.elements = isInit ? [] : thisOption.elements;
    var flattenedList = [];
    this._flatten(newList, flattenedList, null);
    var mappingResult = mappingToExists(existList, flattenedList, "normalMerge");
    var elOptionsToUpdate = this._elOptionsToUpdate = [];
    each$f(mappingResult, function(resultItem, index2) {
      var newElOption = resultItem.newOption;
      if (!newElOption) {
        return;
      }
      elOptionsToUpdate.push(newElOption);
      setKeyInfoToNewElOption(resultItem, newElOption);
      mergeNewElOptionToExist(existList, index2, newElOption);
      setLayoutInfoToExist(existList[index2], newElOption);
    }, this);
    thisOption.elements = filter(existList, function(item) {
      item && delete item.$action;
      return item != null;
    });
  };
  GraphicComponentModel2.prototype._flatten = function(optionList, result, parentOption) {
    each$f(optionList, function(option) {
      if (!option) {
        return;
      }
      if (parentOption) {
        option.parentOption = parentOption;
      }
      result.push(option);
      var children = option.children;
      if (option.type === "group" && children) {
        this._flatten(children, result, option);
      }
      delete option.children;
    }, this);
  };
  GraphicComponentModel2.prototype.useElOptionsToUpdate = function() {
    var els = this._elOptionsToUpdate;
    this._elOptionsToUpdate = null;
    return els;
  };
  GraphicComponentModel2.type = "graphic";
  GraphicComponentModel2.defaultOption = {
    elements: []
  };
  return GraphicComponentModel2;
}(ComponentModel$1);
var nonShapeGraphicElements = {
  path: null,
  compoundPath: null,
  group: Group$4,
  image: ZRImage$1,
  text: ZRText$1
};
var inner$7 = makeInner();
var GraphicComponentView = function(_super) {
  __extends(GraphicComponentView2, _super);
  function GraphicComponentView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentView2.type;
    return _this;
  }
  GraphicComponentView2.prototype.init = function() {
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.render = function(graphicModel, ecModel, api) {
    if (graphicModel !== this._lastGraphicModel) {
      this._clear();
    }
    this._lastGraphicModel = graphicModel;
    this._updateElements(graphicModel);
    this._relocate(graphicModel, api);
  };
  GraphicComponentView2.prototype._updateElements = function(graphicModel) {
    var elOptionsToUpdate = graphicModel.useElOptionsToUpdate();
    if (!elOptionsToUpdate) {
      return;
    }
    var elMap = this._elMap;
    var rootGroup = this.group;
    var globalZ = graphicModel.get("z");
    var globalZLevel = graphicModel.get("zlevel");
    each$f(elOptionsToUpdate, function(elOption) {
      var id2 = convertOptionIdName(elOption.id, null);
      var elExisting = id2 != null ? elMap.get(id2) : null;
      var parentId = convertOptionIdName(elOption.parentId, null);
      var targetElParent = parentId != null ? elMap.get(parentId) : rootGroup;
      var elType = elOption.type;
      var elOptionStyle = elOption.style;
      if (elType === "text" && elOptionStyle) {
        if (elOption.hv && elOption.hv[1]) {
          elOptionStyle.textVerticalAlign = elOptionStyle.textBaseline = elOptionStyle.verticalAlign = elOptionStyle.align = null;
        }
      }
      var textContentOption = elOption.textContent;
      var textConfig = elOption.textConfig;
      if (elOptionStyle && isEC4CompatibleStyle(elOptionStyle, elType, !!textConfig, !!textContentOption)) {
        var convertResult = convertFromEC4CompatibleStyle(elOptionStyle, elType, true);
        if (!textConfig && convertResult.textConfig) {
          textConfig = elOption.textConfig = convertResult.textConfig;
        }
        if (!textContentOption && convertResult.textContent) {
          textContentOption = convertResult.textContent;
        }
      }
      var elOptionCleaned = getCleanedElOption(elOption);
      var $action = elOption.$action || "merge";
      var isMerge = $action === "merge";
      var isReplace = $action === "replace";
      if (isMerge) {
        var isInit = !elExisting;
        var el_1 = elExisting;
        if (isInit) {
          el_1 = createEl(id2, targetElParent, elOption.type, elMap);
        } else {
          el_1 && (inner$7(el_1).isNew = false);
          stopPreviousKeyframeAnimationAndRestore(el_1);
        }
        if (el_1) {
          applyUpdateTransition(el_1, elOptionCleaned, graphicModel, {
            isInit
          });
          updateCommonAttrs(el_1, elOption, globalZ, globalZLevel);
        }
      } else if (isReplace) {
        removeEl$1(elExisting, elOption, elMap, graphicModel);
        var el_2 = createEl(id2, targetElParent, elOption.type, elMap);
        if (el_2) {
          applyUpdateTransition(el_2, elOptionCleaned, graphicModel, {
            isInit: true
          });
          updateCommonAttrs(el_2, elOption, globalZ, globalZLevel);
        }
      } else if ($action === "remove") {
        updateLeaveTo(elExisting, elOption);
        removeEl$1(elExisting, elOption, elMap, graphicModel);
      }
      var el = elMap.get(id2);
      if (el && textContentOption) {
        if (isMerge) {
          var textContentExisting = el.getTextContent();
          textContentExisting ? textContentExisting.attr(textContentOption) : el.setTextContent(new ZRText$1(textContentOption));
        } else if (isReplace) {
          el.setTextContent(new ZRText$1(textContentOption));
        }
      }
      if (el) {
        var clipPathOption = elOption.clipPath;
        if (clipPathOption) {
          var clipPathType = clipPathOption.type;
          var clipPath = void 0;
          var isInit = false;
          if (isMerge) {
            var oldClipPath = el.getClipPath();
            isInit = !oldClipPath || inner$7(oldClipPath).type !== clipPathType;
            clipPath = isInit ? newEl(clipPathType) : oldClipPath;
          } else if (isReplace) {
            isInit = true;
            clipPath = newEl(clipPathType);
          }
          el.setClipPath(clipPath);
          applyUpdateTransition(clipPath, clipPathOption, graphicModel, {
            isInit
          });
          applyKeyframeAnimation(clipPath, clipPathOption.keyframeAnimation, graphicModel);
        }
        var elInner = inner$7(el);
        el.setTextConfig(textConfig);
        elInner.option = elOption;
        setEventData(el, graphicModel, elOption);
        setTooltipConfig({
          el,
          componentModel: graphicModel,
          itemName: el.name,
          itemTooltipOption: elOption.tooltip
        });
        applyKeyframeAnimation(el, elOption.keyframeAnimation, graphicModel);
      }
    });
  };
  GraphicComponentView2.prototype._relocate = function(graphicModel, api) {
    var elOptions = graphicModel.option.elements;
    var rootGroup = this.group;
    var elMap = this._elMap;
    var apiWidth = api.getWidth();
    var apiHeight = api.getHeight();
    var xy = ["x", "y"];
    for (var i = 0; i < elOptions.length; i++) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el || !el.isGroup) {
        continue;
      }
      var parentEl = el.parent;
      var isParentRoot = parentEl === rootGroup;
      var elInner = inner$7(el);
      var parentElInner = inner$7(parentEl);
      elInner.width = parsePercent(elInner.option.width, isParentRoot ? apiWidth : parentElInner.width) || 0;
      elInner.height = parsePercent(elInner.option.height, isParentRoot ? apiHeight : parentElInner.height) || 0;
    }
    for (var i = elOptions.length - 1; i >= 0; i--) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el) {
        continue;
      }
      var parentEl = el.parent;
      var parentElInner = inner$7(parentEl);
      var containerInfo = parentEl === rootGroup ? {
        width: apiWidth,
        height: apiHeight
      } : {
        width: parentElInner.width,
        height: parentElInner.height
      };
      var layoutPos = {};
      var layouted = positionElement(el, elOption, containerInfo, null, {
        hv: elOption.hv,
        boundingMode: elOption.bounding
      }, layoutPos);
      if (!inner$7(el).isNew && layouted) {
        var transition = elOption.transition;
        var animatePos = {};
        for (var k2 = 0; k2 < xy.length; k2++) {
          var key = xy[k2];
          var val = layoutPos[key];
          if (transition && (isTransitionAll(transition) || indexOf(transition, key) >= 0)) {
            animatePos[key] = val;
          } else {
            el[key] = val;
          }
        }
        updateProps$1(el, animatePos, graphicModel, 0);
      } else {
        el.attr(layoutPos);
      }
    }
  };
  GraphicComponentView2.prototype._clear = function() {
    var _this = this;
    var elMap = this._elMap;
    elMap.each(function(el) {
      removeEl$1(el, inner$7(el).option, elMap, _this._lastGraphicModel);
    });
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.dispose = function() {
    this._clear();
  };
  GraphicComponentView2.type = "graphic";
  return GraphicComponentView2;
}(ComponentView$1);
function newEl(graphicType) {
  var Clz = hasOwn(nonShapeGraphicElements, graphicType) ? nonShapeGraphicElements[graphicType] : getShapeClass(graphicType);
  var el = new Clz({});
  inner$7(el).type = graphicType;
  return el;
}
function createEl(id2, targetElParent, graphicType, elMap) {
  var el = newEl(graphicType);
  targetElParent.add(el);
  elMap.set(id2, el);
  inner$7(el).id = id2;
  inner$7(el).isNew = true;
  return el;
}
function removeEl$1(elExisting, elOption, elMap, graphicModel) {
  var existElParent = elExisting && elExisting.parent;
  if (existElParent) {
    elExisting.type === "group" && elExisting.traverse(function(el) {
      removeEl$1(el, elOption, elMap, graphicModel);
    });
    applyLeaveTransition(elExisting, elOption, graphicModel);
    elMap.removeKey(inner$7(elExisting).id);
  }
}
function updateCommonAttrs(el, elOption, defaultZ, defaultZlevel) {
  if (!el.isGroup) {
    var elDisplayable = el;
    elDisplayable.cursor = retrieve2(elOption.cursor, Displayable$1.prototype.cursor);
    elDisplayable.z = retrieve2(elOption.z, defaultZ || 0);
    elDisplayable.zlevel = retrieve2(elOption.zlevel, defaultZlevel || 0);
    var optZ2 = elOption.z2;
    optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  }
  each$f(keys(elOption), function(key) {
    var val = elOption[key];
    if (key.indexOf("on") === 0 && isFunction(val)) {
      el[key] = val;
    }
  });
  el.draggable = elOption.draggable;
  elOption.name != null && (el.name = elOption.name);
  elOption.id != null && (el.id = elOption.id);
}
function getCleanedElOption(elOption) {
  elOption = extend({}, elOption);
  each$f(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(LOCATION_PARAMS), function(name) {
    delete elOption[name];
  });
  return elOption;
}
function setEventData(el, graphicModel, elOption) {
  var eventData = getECData(el).eventData;
  if (!el.silent && !el.ignore && !eventData) {
    eventData = getECData(el).eventData = {
      componentType: "graphic",
      componentIndex: graphicModel.componentIndex,
      name: el.name
    };
  }
  if (eventData) {
    eventData.info = elOption.info;
  }
}
function install$l(registers) {
  registers.registerComponentModel(GraphicComponentModel);
  registers.registerComponentView(GraphicComponentView);
  registers.registerPreprocessor(function(option) {
    var graphicOption = option.graphic;
    if (isArray$1(graphicOption)) {
      if (!graphicOption[0] || !graphicOption[0].elements) {
        option.graphic = [{
          elements: graphicOption
        }];
      } else {
        option.graphic = [option.graphic[0]];
      }
    } else if (graphicOption && !graphicOption.elements) {
      option.graphic = [{
        elements: [graphicOption]
      }];
    }
  });
}
var DATA_ZOOM_AXIS_DIMENSIONS = ["x", "y", "radius", "angle", "single"];
var SERIES_COORDS = ["cartesian2d", "polar", "singleAxis"];
function isCoordSupported(seriesModel) {
  var coordType = seriesModel.get("coordinateSystem");
  return indexOf(SERIES_COORDS, coordType) >= 0;
}
function getAxisMainType(axisDim) {
  return axisDim + "Axis";
}
function findEffectedDataZooms(ecModel, payload) {
  var axisRecords = createHashMap();
  var effectedModels = [];
  var effectedModelMap = createHashMap();
  ecModel.eachComponent({
    mainType: "dataZoom",
    query: payload
  }, function(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid)) {
      addToEffected(dataZoomModel);
    }
  });
  var foundNewLink;
  do {
    foundNewLink = false;
    ecModel.eachComponent("dataZoom", processSingle);
  } while (foundNewLink);
  function processSingle(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid) && isLinked(dataZoomModel)) {
      addToEffected(dataZoomModel);
      foundNewLink = true;
    }
  }
  function addToEffected(dataZoom) {
    effectedModelMap.set(dataZoom.uid, true);
    effectedModels.push(dataZoom);
    markAxisControlled(dataZoom);
  }
  function isLinked(dataZoomModel) {
    var isLink = false;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var axisIdxArr = axisRecords.get(axisDim);
      if (axisIdxArr && axisIdxArr[axisIndex]) {
        isLink = true;
      }
    });
    return isLink;
  }
  function markAxisControlled(dataZoomModel) {
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      (axisRecords.get(axisDim) || axisRecords.set(axisDim, []))[axisIndex] = true;
    });
  }
  return effectedModels;
}
function collectReferCoordSysModelInfo(dataZoomModel) {
  var ecModel = dataZoomModel.ecModel;
  var coordSysInfoWrap = {
    infoList: [],
    infoMap: createHashMap()
  };
  dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
    var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    if (!axisModel) {
      return;
    }
    var coordSysModel = axisModel.getCoordSysModel();
    if (!coordSysModel) {
      return;
    }
    var coordSysUid = coordSysModel.uid;
    var coordSysInfo = coordSysInfoWrap.infoMap.get(coordSysUid);
    if (!coordSysInfo) {
      coordSysInfo = {
        model: coordSysModel,
        axisModels: []
      };
      coordSysInfoWrap.infoList.push(coordSysInfo);
      coordSysInfoWrap.infoMap.set(coordSysUid, coordSysInfo);
    }
    coordSysInfo.axisModels.push(axisModel);
  });
  return coordSysInfoWrap;
}
var DataZoomAxisInfo = function() {
  function DataZoomAxisInfo2() {
    this.indexList = [];
    this.indexMap = [];
  }
  DataZoomAxisInfo2.prototype.add = function(axisCmptIdx) {
    if (!this.indexMap[axisCmptIdx]) {
      this.indexList.push(axisCmptIdx);
      this.indexMap[axisCmptIdx] = true;
    }
  };
  return DataZoomAxisInfo2;
}();
var DataZoomModel = function(_super) {
  __extends(DataZoomModel2, _super);
  function DataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomModel2.type;
    _this._autoThrottle = true;
    _this._noTarget = true;
    _this._rangePropMode = ["percent", "percent"];
    return _this;
  }
  DataZoomModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputRawOption = retrieveRawOption(option);
    this.settledOption = inputRawOption;
    this.mergeDefaultAndTheme(option, ecModel);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype.mergeOption = function(newOption) {
    var inputRawOption = retrieveRawOption(newOption);
    merge(this.option, newOption, true);
    merge(this.settledOption, inputRawOption, true);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype._doInit = function(inputRawOption) {
    var thisOption = this.option;
    this._setDefaultThrottle(inputRawOption);
    this._updateRangeUse(inputRawOption);
    var settledOption = this.settledOption;
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      if (this._rangePropMode[index2] === "value") {
        thisOption[names2[0]] = settledOption[names2[0]] = null;
      }
    }, this);
    this._resetTarget();
  };
  DataZoomModel2.prototype._resetTarget = function() {
    var optionOrient = this.get("orient", true);
    var targetAxisIndexMap = this._targetAxisInfoMap = createHashMap();
    var hasAxisSpecified = this._fillSpecifiedTargetAxis(targetAxisIndexMap);
    if (hasAxisSpecified) {
      this._orient = optionOrient || this._makeAutoOrientByTargetAxis();
    } else {
      this._orient = optionOrient || "horizontal";
      this._fillAutoTargetAxisByOrient(targetAxisIndexMap, this._orient);
    }
    this._noTarget = true;
    targetAxisIndexMap.each(function(axisInfo) {
      if (axisInfo.indexList.length) {
        this._noTarget = false;
      }
    }, this);
  };
  DataZoomModel2.prototype._fillSpecifiedTargetAxis = function(targetAxisIndexMap) {
    var hasAxisSpecified = false;
    each$f(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim) {
      var refering = this.getReferringComponents(getAxisMainType(axisDim), MULTIPLE_REFERRING);
      if (!refering.specified) {
        return;
      }
      hasAxisSpecified = true;
      var axisInfo = new DataZoomAxisInfo();
      each$f(refering.models, function(axisModel) {
        axisInfo.add(axisModel.componentIndex);
      });
      targetAxisIndexMap.set(axisDim, axisInfo);
    }, this);
    return hasAxisSpecified;
  };
  DataZoomModel2.prototype._fillAutoTargetAxisByOrient = function(targetAxisIndexMap, orient) {
    var ecModel = this.ecModel;
    var needAuto = true;
    if (needAuto) {
      var axisDim = orient === "vertical" ? "y" : "x";
      var axisModels = ecModel.findComponents({
        mainType: axisDim + "Axis"
      });
      setParallelAxis(axisModels, axisDim);
    }
    if (needAuto) {
      var axisModels = ecModel.findComponents({
        mainType: "singleAxis",
        filter: function(axisModel) {
          return axisModel.get("orient", true) === orient;
        }
      });
      setParallelAxis(axisModels, "single");
    }
    function setParallelAxis(axisModels2, axisDim2) {
      var axisModel = axisModels2[0];
      if (!axisModel) {
        return;
      }
      var axisInfo = new DataZoomAxisInfo();
      axisInfo.add(axisModel.componentIndex);
      targetAxisIndexMap.set(axisDim2, axisInfo);
      needAuto = false;
      if (axisDim2 === "x" || axisDim2 === "y") {
        var gridModel_1 = axisModel.getReferringComponents("grid", SINGLE_REFERRING).models[0];
        gridModel_1 && each$f(axisModels2, function(axModel) {
          if (axisModel.componentIndex !== axModel.componentIndex && gridModel_1 === axModel.getReferringComponents("grid", SINGLE_REFERRING).models[0]) {
            axisInfo.add(axModel.componentIndex);
          }
        });
      }
    }
    if (needAuto) {
      each$f(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim2) {
        if (!needAuto) {
          return;
        }
        var axisModels2 = ecModel.findComponents({
          mainType: getAxisMainType(axisDim2),
          filter: function(axisModel) {
            return axisModel.get("type", true) === "category";
          }
        });
        if (axisModels2[0]) {
          var axisInfo = new DataZoomAxisInfo();
          axisInfo.add(axisModels2[0].componentIndex);
          targetAxisIndexMap.set(axisDim2, axisInfo);
          needAuto = false;
        }
      }, this);
    }
  };
  DataZoomModel2.prototype._makeAutoOrientByTargetAxis = function() {
    var dim;
    this.eachTargetAxis(function(axisDim) {
      !dim && (dim = axisDim);
    }, this);
    return dim === "y" ? "vertical" : "horizontal";
  };
  DataZoomModel2.prototype._setDefaultThrottle = function(inputRawOption) {
    if (inputRawOption.hasOwnProperty("throttle")) {
      this._autoThrottle = false;
    }
    if (this._autoThrottle) {
      var globalOption = this.ecModel.option;
      this.option.throttle = globalOption.animation && globalOption.animationDurationUpdate > 0 ? 100 : 20;
    }
  };
  DataZoomModel2.prototype._updateRangeUse = function(inputRawOption) {
    var rangePropMode = this._rangePropMode;
    var rangeModeInOption = this.get("rangeMode");
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      var percentSpecified = inputRawOption[names2[0]] != null;
      var valueSpecified = inputRawOption[names2[1]] != null;
      if (percentSpecified && !valueSpecified) {
        rangePropMode[index2] = "percent";
      } else if (!percentSpecified && valueSpecified) {
        rangePropMode[index2] = "value";
      } else if (rangeModeInOption) {
        rangePropMode[index2] = rangeModeInOption[index2];
      } else if (percentSpecified) {
        rangePropMode[index2] = "percent";
      }
    });
  };
  DataZoomModel2.prototype.noTarget = function() {
    return this._noTarget;
  };
  DataZoomModel2.prototype.getFirstTargetAxisModel = function() {
    var firstAxisModel;
    this.eachTargetAxis(function(axisDim, axisIndex) {
      if (firstAxisModel == null) {
        firstAxisModel = this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
      }
    }, this);
    return firstAxisModel;
  };
  DataZoomModel2.prototype.eachTargetAxis = function(callback, context) {
    this._targetAxisInfoMap.each(function(axisInfo, axisDim) {
      each$f(axisInfo.indexList, function(axisIndex) {
        callback.call(context, axisDim, axisIndex);
      });
    });
  };
  DataZoomModel2.prototype.getAxisProxy = function(axisDim, axisIndex) {
    var axisModel = this.getAxisModel(axisDim, axisIndex);
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
  };
  DataZoomModel2.prototype.getAxisModel = function(axisDim, axisIndex) {
    var axisInfo = this._targetAxisInfoMap.get(axisDim);
    if (axisInfo && axisInfo.indexMap[axisIndex]) {
      return this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    }
  };
  DataZoomModel2.prototype.setRawRange = function(opt) {
    var thisOption = this.option;
    var settledOption = this.settledOption;
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2) {
      if (opt[names2[0]] != null || opt[names2[1]] != null) {
        thisOption[names2[0]] = settledOption[names2[0]] = opt[names2[0]];
        thisOption[names2[1]] = settledOption[names2[1]] = opt[names2[1]];
      }
    }, this);
    this._updateRangeUse(opt);
  };
  DataZoomModel2.prototype.setCalculatedRange = function(opt) {
    var option = this.option;
    each$f(["start", "startValue", "end", "endValue"], function(name) {
      option[name] = opt[name];
    });
  };
  DataZoomModel2.prototype.getPercentRange = function() {
    var axisProxy = this.findRepresentativeAxisProxy();
    if (axisProxy) {
      return axisProxy.getDataPercentWindow();
    }
  };
  DataZoomModel2.prototype.getValueRange = function(axisDim, axisIndex) {
    if (axisDim == null && axisIndex == null) {
      var axisProxy = this.findRepresentativeAxisProxy();
      if (axisProxy) {
        return axisProxy.getDataValueWindow();
      }
    } else {
      return this.getAxisProxy(axisDim, axisIndex).getDataValueWindow();
    }
  };
  DataZoomModel2.prototype.findRepresentativeAxisProxy = function(axisModel) {
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
    var firstProxy;
    var axisDimList = this._targetAxisInfoMap.keys();
    for (var i = 0; i < axisDimList.length; i++) {
      var axisDim = axisDimList[i];
      var axisInfo = this._targetAxisInfoMap.get(axisDim);
      for (var j = 0; j < axisInfo.indexList.length; j++) {
        var proxy = this.getAxisProxy(axisDim, axisInfo.indexList[j]);
        if (proxy.hostedBy(this)) {
          return proxy;
        }
        if (!firstProxy) {
          firstProxy = proxy;
        }
      }
    }
    return firstProxy;
  };
  DataZoomModel2.prototype.getRangePropMode = function() {
    return this._rangePropMode.slice();
  };
  DataZoomModel2.prototype.getOrient = function() {
    return this._orient;
  };
  DataZoomModel2.type = "dataZoom";
  DataZoomModel2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"];
  DataZoomModel2.defaultOption = {
    z: 4,
    filterMode: "filter",
    start: 0,
    end: 100
  };
  return DataZoomModel2;
}(ComponentModel$1);
function retrieveRawOption(option) {
  var ret = {};
  each$f(["start", "end", "startValue", "endValue", "throttle"], function(name) {
    option.hasOwnProperty(name) && (ret[name] = option[name]);
  });
  return ret;
}
var DataZoomModel$1 = DataZoomModel;
var SelectDataZoomModel = function(_super) {
  __extends(SelectDataZoomModel2, _super);
  function SelectDataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomModel2.type;
    return _this;
  }
  SelectDataZoomModel2.type = "dataZoom.select";
  return SelectDataZoomModel2;
}(DataZoomModel$1);
var SelectZoomModel = SelectDataZoomModel;
var DataZoomView = function(_super) {
  __extends(DataZoomView2, _super);
  function DataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomView2.type;
    return _this;
  }
  DataZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    this.dataZoomModel = dataZoomModel;
    this.ecModel = ecModel;
    this.api = api;
  };
  DataZoomView2.type = "dataZoom";
  return DataZoomView2;
}(ComponentView$1);
var DataZoomView$1 = DataZoomView;
var SelectDataZoomView = function(_super) {
  __extends(SelectDataZoomView2, _super);
  function SelectDataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomView2.type;
    return _this;
  }
  SelectDataZoomView2.type = "dataZoom.select";
  return SelectDataZoomView2;
}(DataZoomView$1);
var SelectZoomView = SelectDataZoomView;
var each$7 = each$f;
var asc$1 = asc$2;
var AxisProxy = function() {
  function AxisProxy2(dimName, axisIndex, dataZoomModel, ecModel) {
    this._dimName = dimName;
    this._axisIndex = axisIndex;
    this.ecModel = ecModel;
    this._dataZoomModel = dataZoomModel;
  }
  AxisProxy2.prototype.hostedBy = function(dataZoomModel) {
    return this._dataZoomModel === dataZoomModel;
  };
  AxisProxy2.prototype.getDataValueWindow = function() {
    return this._valueWindow.slice();
  };
  AxisProxy2.prototype.getDataPercentWindow = function() {
    return this._percentWindow.slice();
  };
  AxisProxy2.prototype.getTargetSeriesModels = function() {
    var seriesModels = [];
    this.ecModel.eachSeries(function(seriesModel) {
      if (isCoordSupported(seriesModel)) {
        var axisMainType = getAxisMainType(this._dimName);
        var axisModel = seriesModel.getReferringComponents(axisMainType, SINGLE_REFERRING).models[0];
        if (axisModel && this._axisIndex === axisModel.componentIndex) {
          seriesModels.push(seriesModel);
        }
      }
    }, this);
    return seriesModels;
  };
  AxisProxy2.prototype.getAxisModel = function() {
    return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
  };
  AxisProxy2.prototype.getMinMaxSpan = function() {
    return clone$4(this._minMaxSpan);
  };
  AxisProxy2.prototype.calculateDataWindow = function(opt) {
    var dataExtent = this._dataExtent;
    var axisModel = this.getAxisModel();
    var scale2 = axisModel.axis.scale;
    var rangePropMode = this._dataZoomModel.getRangePropMode();
    var percentExtent = [0, 100];
    var percentWindow = [];
    var valueWindow = [];
    var hasPropModeValue;
    each$7(["start", "end"], function(prop, idx) {
      var boundPercent = opt[prop];
      var boundValue = opt[prop + "Value"];
      if (rangePropMode[idx] === "percent") {
        boundPercent == null && (boundPercent = percentExtent[idx]);
        boundValue = scale2.parse(linearMap$2(boundPercent, percentExtent, dataExtent));
      } else {
        hasPropModeValue = true;
        boundValue = boundValue == null ? dataExtent[idx] : scale2.parse(boundValue);
        boundPercent = linearMap$2(boundValue, dataExtent, percentExtent);
      }
      valueWindow[idx] = boundValue;
      percentWindow[idx] = boundPercent;
    });
    asc$1(valueWindow);
    asc$1(percentWindow);
    var spans = this._minMaxSpan;
    hasPropModeValue ? restrictSet(valueWindow, percentWindow, dataExtent, percentExtent, false) : restrictSet(percentWindow, valueWindow, percentExtent, dataExtent, true);
    function restrictSet(fromWindow, toWindow, fromExtent, toExtent, toValue) {
      var suffix = toValue ? "Span" : "ValueSpan";
      sliderMove(0, fromWindow, fromExtent, "all", spans["min" + suffix], spans["max" + suffix]);
      for (var i = 0; i < 2; i++) {
        toWindow[i] = linearMap$2(fromWindow[i], fromExtent, toExtent, true);
        toValue && (toWindow[i] = scale2.parse(toWindow[i]));
      }
    }
    return {
      valueWindow,
      percentWindow
    };
  };
  AxisProxy2.prototype.reset = function(dataZoomModel) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var targetSeries = this.getTargetSeriesModels();
    this._dataExtent = calculateDataExtent(this, this._dimName, targetSeries);
    this._updateMinMaxSpan();
    var dataWindow = this.calculateDataWindow(dataZoomModel.settledOption);
    this._valueWindow = dataWindow.valueWindow;
    this._percentWindow = dataWindow.percentWindow;
    this._setAxisModel();
  };
  AxisProxy2.prototype.filterData = function(dataZoomModel, api) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var axisDim = this._dimName;
    var seriesModels = this.getTargetSeriesModels();
    var filterMode = dataZoomModel.get("filterMode");
    var valueWindow = this._valueWindow;
    if (filterMode === "none") {
      return;
    }
    each$7(seriesModels, function(seriesModel) {
      var seriesData = seriesModel.getData();
      var dataDims = seriesData.mapDimensionsAll(axisDim);
      if (!dataDims.length) {
        return;
      }
      if (filterMode === "weakFilter") {
        var store_1 = seriesData.getStore();
        var dataDimIndices_1 = map$1(dataDims, function(dim) {
          return seriesData.getDimensionIndex(dim);
        }, seriesData);
        seriesData.filterSelf(function(dataIndex) {
          var leftOut;
          var rightOut;
          var hasValue;
          for (var i = 0; i < dataDims.length; i++) {
            var value = store_1.get(dataDimIndices_1[i], dataIndex);
            var thisHasValue = !isNaN(value);
            var thisLeftOut = value < valueWindow[0];
            var thisRightOut = value > valueWindow[1];
            if (thisHasValue && !thisLeftOut && !thisRightOut) {
              return true;
            }
            thisHasValue && (hasValue = true);
            thisLeftOut && (leftOut = true);
            thisRightOut && (rightOut = true);
          }
          return hasValue && leftOut && rightOut;
        });
      } else {
        each$7(dataDims, function(dim) {
          if (filterMode === "empty") {
            seriesModel.setData(seriesData = seriesData.map(dim, function(value) {
              return !isInWindow(value) ? NaN : value;
            }));
          } else {
            var range3 = {};
            range3[dim] = valueWindow;
            seriesData.selectRange(range3);
          }
        });
      }
      each$7(dataDims, function(dim) {
        seriesData.setApproximateExtent(valueWindow, dim);
      });
    });
    function isInWindow(value) {
      return value >= valueWindow[0] && value <= valueWindow[1];
    }
  };
  AxisProxy2.prototype._updateMinMaxSpan = function() {
    var minMaxSpan = this._minMaxSpan = {};
    var dataZoomModel = this._dataZoomModel;
    var dataExtent = this._dataExtent;
    each$7(["min", "max"], function(minMax) {
      var percentSpan = dataZoomModel.get(minMax + "Span");
      var valueSpan = dataZoomModel.get(minMax + "ValueSpan");
      valueSpan != null && (valueSpan = this.getAxisModel().axis.scale.parse(valueSpan));
      if (valueSpan != null) {
        percentSpan = linearMap$2(dataExtent[0] + valueSpan, dataExtent, [0, 100], true);
      } else if (percentSpan != null) {
        valueSpan = linearMap$2(percentSpan, [0, 100], dataExtent, true) - dataExtent[0];
      }
      minMaxSpan[minMax + "Span"] = percentSpan;
      minMaxSpan[minMax + "ValueSpan"] = valueSpan;
    }, this);
  };
  AxisProxy2.prototype._setAxisModel = function() {
    var axisModel = this.getAxisModel();
    var percentWindow = this._percentWindow;
    var valueWindow = this._valueWindow;
    if (!percentWindow) {
      return;
    }
    var precision = getPixelPrecision(valueWindow, [0, 500]);
    precision = Math.min(precision, 20);
    var rawExtentInfo = axisModel.axis.scale.rawExtentInfo;
    if (percentWindow[0] !== 0) {
      rawExtentInfo.setDeterminedMinMax("min", +valueWindow[0].toFixed(precision));
    }
    if (percentWindow[1] !== 100) {
      rawExtentInfo.setDeterminedMinMax("max", +valueWindow[1].toFixed(precision));
    }
    rawExtentInfo.freeze();
  };
  return AxisProxy2;
}();
function calculateDataExtent(axisProxy, axisDim, seriesModels) {
  var dataExtent = [Infinity, -Infinity];
  each$7(seriesModels, function(seriesModel) {
    unionAxisExtentFromData(dataExtent, seriesModel.getData(), axisDim);
  });
  var axisModel = axisProxy.getAxisModel();
  var rawExtentResult = ensureScaleRawExtentInfo(axisModel.axis.scale, axisModel, dataExtent).calculate();
  return [rawExtentResult.min, rawExtentResult.max];
}
var AxisProxy$1 = AxisProxy;
var dataZoomProcessor = {
  getTargetSeries: function(ecModel) {
    function eachAxisModel(cb) {
      ecModel.eachComponent("dataZoom", function(dataZoomModel) {
        dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
          var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
          cb(axisDim, axisIndex, axisModel, dataZoomModel);
        });
      });
    }
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      axisModel.__dzAxisProxy = null;
    });
    var proxyList = [];
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      if (!axisModel.__dzAxisProxy) {
        axisModel.__dzAxisProxy = new AxisProxy$1(axisDim, axisIndex, dataZoomModel, ecModel);
        proxyList.push(axisModel.__dzAxisProxy);
      }
    });
    var seriesModelMap = createHashMap();
    each$f(proxyList, function(axisProxy) {
      each$f(axisProxy.getTargetSeriesModels(), function(seriesModel) {
        seriesModelMap.set(seriesModel.uid, seriesModel);
      });
    });
    return seriesModelMap;
  },
  overallReset: function(ecModel, api) {
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).reset(dataZoomModel);
      });
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).filterData(dataZoomModel, api);
      });
    });
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var percentRange = axisProxy.getDataPercentWindow();
        var valueRange = axisProxy.getDataValueWindow();
        dataZoomModel.setCalculatedRange({
          start: percentRange[0],
          end: percentRange[1],
          startValue: valueRange[0],
          endValue: valueRange[1]
        });
      }
    });
  }
};
var dataZoomProcessor$1 = dataZoomProcessor;
function installDataZoomAction(registers) {
  registers.registerAction("dataZoom", function(payload, ecModel) {
    var effectedModels = findEffectedDataZooms(ecModel, payload);
    each$f(effectedModels, function(dataZoomModel) {
      dataZoomModel.setRawRange({
        start: payload.start,
        end: payload.end,
        startValue: payload.startValue,
        endValue: payload.endValue
      });
    });
  });
}
var installed$1 = false;
function installCommon$1(registers) {
  if (installed$1) {
    return;
  }
  installed$1 = true;
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, dataZoomProcessor$1);
  installDataZoomAction(registers);
  registers.registerSubTypeDefaulter("dataZoom", function() {
    return "slider";
  });
}
function install$k(registers) {
  registers.registerComponentModel(SelectZoomModel);
  registers.registerComponentView(SelectZoomView);
  installCommon$1(registers);
}
var ToolboxFeature = function() {
  function ToolboxFeature2() {
  }
  return ToolboxFeature2;
}();
var features = {};
function registerFeature(name, ctor) {
  features[name] = ctor;
}
function getFeature(name) {
  return features[name];
}
var ToolboxModel = function(_super) {
  __extends(ToolboxModel2, _super);
  function ToolboxModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ToolboxModel2.type;
    return _this;
  }
  ToolboxModel2.prototype.optionUpdated = function() {
    _super.prototype.optionUpdated.apply(this, arguments);
    var ecModel = this.ecModel;
    each$f(this.option.feature, function(featureOpt, featureName) {
      var Feature = getFeature(featureName);
      if (Feature) {
        if (Feature.getDefaultOption) {
          Feature.defaultOption = Feature.getDefaultOption(ecModel);
        }
        merge(featureOpt, Feature.defaultOption);
      }
    });
  };
  ToolboxModel2.type = "toolbox";
  ToolboxModel2.layoutMode = {
    type: "box",
    ignoreSize: true
  };
  ToolboxModel2.defaultOption = {
    show: true,
    z: 6,
    orient: "horizontal",
    left: "right",
    top: "top",
    backgroundColor: "transparent",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemSize: 15,
    itemGap: 8,
    showTitle: true,
    iconStyle: {
      borderColor: "#666",
      color: "none"
    },
    emphasis: {
      iconStyle: {
        borderColor: "#3E98C5"
      }
    },
    tooltip: {
      show: false,
      position: "bottom"
    }
  };
  return ToolboxModel2;
}(ComponentModel$1);
var ToolboxModel$1 = ToolboxModel;
function layout(group, componentModel, api) {
  var boxLayoutParams = componentModel.getBoxLayoutParams();
  var padding = componentModel.get("padding");
  var viewportSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var rect = getLayoutRect(boxLayoutParams, viewportSize, padding);
  box(componentModel.get("orient"), group, componentModel.get("itemGap"), rect.width, rect.height);
  positionElement(group, boxLayoutParams, viewportSize, padding);
}
function makeBackground(rect, componentModel) {
  var padding = normalizeCssArray(componentModel.get("padding"));
  var style = componentModel.getItemStyle(["color", "opacity"]);
  style.fill = componentModel.get("backgroundColor");
  rect = new Rect$3({
    shape: {
      x: rect.x - padding[3],
      y: rect.y - padding[0],
      width: rect.width + padding[1] + padding[3],
      height: rect.height + padding[0] + padding[2],
      r: componentModel.get("borderRadius")
    },
    style,
    silent: true,
    z2: -1
  });
  return rect;
}
var ToolboxView = function(_super) {
  __extends(ToolboxView2, _super);
  function ToolboxView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ToolboxView2.prototype.render = function(toolboxModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    if (!toolboxModel.get("show")) {
      return;
    }
    var itemSize = +toolboxModel.get("itemSize");
    var featureOpts = toolboxModel.get("feature") || {};
    var features2 = this._features || (this._features = {});
    var featureNames = [];
    each$f(featureOpts, function(opt, name) {
      featureNames.push(name);
    });
    new DataDiffer$1(this._featureNames || [], featureNames).add(processFeature).update(processFeature).remove(curry$1(processFeature, null)).execute();
    this._featureNames = featureNames;
    function processFeature(newIndex, oldIndex) {
      var featureName = featureNames[newIndex];
      var oldName = featureNames[oldIndex];
      var featureOpt = featureOpts[featureName];
      var featureModel = new Model$1(featureOpt, toolboxModel, toolboxModel.ecModel);
      var feature;
      if (payload && payload.newTitle != null && payload.featureName === featureName) {
        featureOpt.title = payload.newTitle;
      }
      if (featureName && !oldName) {
        if (isUserFeatureName(featureName)) {
          feature = {
            onclick: featureModel.option.onclick,
            featureName
          };
        } else {
          var Feature = getFeature(featureName);
          if (!Feature) {
            return;
          }
          feature = new Feature();
        }
        features2[featureName] = feature;
      } else {
        feature = features2[oldName];
        if (!feature) {
          return;
        }
      }
      feature.uid = getUID("toolbox-feature");
      feature.model = featureModel;
      feature.ecModel = ecModel;
      feature.api = api;
      var isToolboxFeature = feature instanceof ToolboxFeature;
      if (!featureName && oldName) {
        isToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
        return;
      }
      if (!featureModel.get("show") || isToolboxFeature && feature.unusable) {
        isToolboxFeature && feature.remove && feature.remove(ecModel, api);
        return;
      }
      createIconPaths(featureModel, feature, featureName);
      featureModel.setIconStatus = function(iconName, status) {
        var option = this.option;
        var iconPaths = this.iconPaths;
        option.iconStatus = option.iconStatus || {};
        option.iconStatus[iconName] = status;
        if (iconPaths[iconName]) {
          (status === "emphasis" ? enterEmphasis : leaveEmphasis)(iconPaths[iconName]);
        }
      };
      if (feature instanceof ToolboxFeature) {
        if (feature.render) {
          feature.render(featureModel, ecModel, api, payload);
        }
      }
    }
    function createIconPaths(featureModel, feature, featureName) {
      var iconStyleModel = featureModel.getModel("iconStyle");
      var iconStyleEmphasisModel = featureModel.getModel(["emphasis", "iconStyle"]);
      var icons = feature instanceof ToolboxFeature && feature.getIcons ? feature.getIcons() : featureModel.get("icon");
      var titles = featureModel.get("title") || {};
      var iconsMap;
      var titlesMap;
      if (isString(icons)) {
        iconsMap = {};
        iconsMap[featureName] = icons;
      } else {
        iconsMap = icons;
      }
      if (isString(titles)) {
        titlesMap = {};
        titlesMap[featureName] = titles;
      } else {
        titlesMap = titles;
      }
      var iconPaths = featureModel.iconPaths = {};
      each$f(iconsMap, function(iconStr, iconName) {
        var path = createIcon(iconStr, {}, {
          x: -itemSize / 2,
          y: -itemSize / 2,
          width: itemSize,
          height: itemSize
        });
        path.setStyle(iconStyleModel.getItemStyle());
        var pathEmphasisState = path.ensureState("emphasis");
        pathEmphasisState.style = iconStyleEmphasisModel.getItemStyle();
        var textContent = new ZRText$1({
          style: {
            text: titlesMap[iconName],
            align: iconStyleEmphasisModel.get("textAlign"),
            borderRadius: iconStyleEmphasisModel.get("textBorderRadius"),
            padding: iconStyleEmphasisModel.get("textPadding"),
            fill: null
          },
          ignore: true
        });
        path.setTextContent(textContent);
        setTooltipConfig({
          el: path,
          componentModel: toolboxModel,
          itemName: iconName,
          formatterParamsExtra: {
            title: titlesMap[iconName]
          }
        });
        path.__title = titlesMap[iconName];
        path.on("mouseover", function() {
          var hoverStyle = iconStyleEmphasisModel.getItemStyle();
          var defaultTextPosition = toolboxModel.get("orient") === "vertical" ? toolboxModel.get("right") == null ? "right" : "left" : toolboxModel.get("bottom") == null ? "bottom" : "top";
          textContent.setStyle({
            fill: iconStyleEmphasisModel.get("textFill") || hoverStyle.fill || hoverStyle.stroke || "#000",
            backgroundColor: iconStyleEmphasisModel.get("textBackgroundColor")
          });
          path.setTextConfig({
            position: iconStyleEmphasisModel.get("textPosition") || defaultTextPosition
          });
          textContent.ignore = !toolboxModel.get("showTitle");
          enterEmphasis(this);
        }).on("mouseout", function() {
          if (featureModel.get(["iconStatus", iconName]) !== "emphasis") {
            leaveEmphasis(this);
          }
          textContent.hide();
        });
        (featureModel.get(["iconStatus", iconName]) === "emphasis" ? enterEmphasis : leaveEmphasis)(path);
        group.add(path);
        path.on("click", bind$1(feature.onclick, feature, ecModel, api, iconName));
        iconPaths[iconName] = path;
      });
    }
    layout(group, toolboxModel, api);
    group.add(makeBackground(group.getBoundingRect(), toolboxModel));
    group.eachChild(function(icon) {
      var titleText = icon.__title;
      var emphasisState = icon.ensureState("emphasis");
      var emphasisTextConfig = emphasisState.textConfig || (emphasisState.textConfig = {});
      var textContent = icon.getTextContent();
      var emphasisTextState = textContent && textContent.states.emphasis;
      if (emphasisTextState && !isFunction(emphasisTextState) && titleText) {
        var emphasisTextStyle = emphasisTextState.style || (emphasisTextState.style = {});
        var rect = getBoundingRect(titleText, ZRText$1.makeFont(emphasisTextStyle));
        var offsetX = icon.x + group.x;
        var offsetY = icon.y + group.y + itemSize;
        var needPutOnTop = false;
        if (offsetY + rect.height > api.getHeight()) {
          emphasisTextConfig.position = "top";
          needPutOnTop = true;
        }
        var topOffset = needPutOnTop ? -5 - rect.height : itemSize + 8;
        if (offsetX + rect.width / 2 > api.getWidth()) {
          emphasisTextConfig.position = ["100%", topOffset];
          emphasisTextStyle.align = "right";
        } else if (offsetX - rect.width / 2 < 0) {
          emphasisTextConfig.position = [0, topOffset];
          emphasisTextStyle.align = "left";
        }
      }
    });
  };
  ToolboxView2.prototype.updateView = function(toolboxModel, ecModel, api, payload) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.updateView && feature.updateView(feature.model, ecModel, api, payload);
    });
  };
  ToolboxView2.prototype.remove = function(ecModel, api) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.remove && feature.remove(ecModel, api);
    });
    this.group.removeAll();
  };
  ToolboxView2.prototype.dispose = function(ecModel, api) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
    });
  };
  ToolboxView2.type = "toolbox";
  return ToolboxView2;
}(ComponentView$1);
function isUserFeatureName(featureName) {
  return featureName.indexOf("my") === 0;
}
var ToolboxView$1 = ToolboxView;
var SaveAsImage = function(_super) {
  __extends(SaveAsImage2, _super);
  function SaveAsImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SaveAsImage2.prototype.onclick = function(ecModel, api) {
    var model = this.model;
    var title = model.get("name") || ecModel.get("title.0.text") || "echarts";
    var isSvg = api.getZr().painter.getType() === "svg";
    var type4 = isSvg ? "svg" : model.get("type", true) || "png";
    var url2 = api.getConnectedDataURL({
      type: type4,
      backgroundColor: model.get("backgroundColor", true) || ecModel.get("backgroundColor") || "#fff",
      connectedBackgroundColor: model.get("connectedBackgroundColor"),
      excludeComponents: model.get("excludeComponents"),
      pixelRatio: model.get("pixelRatio")
    });
    var browser = env$1.browser;
    if (isFunction(MouseEvent) && (browser.newEdge || !browser.ie && !browser.edge)) {
      var $a = document.createElement("a");
      $a.download = title + "." + type4;
      $a.target = "_blank";
      $a.href = url2;
      var evt = new MouseEvent("click", {
        view: document.defaultView,
        bubbles: true,
        cancelable: false
      });
      $a.dispatchEvent(evt);
    } else {
      if (window.navigator.msSaveOrOpenBlob || isSvg) {
        var parts = url2.split(",");
        var base64Encoded = parts[0].indexOf("base64") > -1;
        var bstr = isSvg ? decodeURIComponent(parts[1]) : parts[1];
        base64Encoded && (bstr = window.atob(bstr));
        var filename = title + "." + type4;
        if (window.navigator.msSaveOrOpenBlob) {
          var n2 = bstr.length;
          var u8arr = new Uint8Array(n2);
          while (n2--) {
            u8arr[n2] = bstr.charCodeAt(n2);
          }
          var blob = new Blob([u8arr]);
          window.navigator.msSaveOrOpenBlob(blob, filename);
        } else {
          var frame = document.createElement("iframe");
          document.body.appendChild(frame);
          var cw = frame.contentWindow;
          var doc = cw.document;
          doc.open("image/svg+xml", "replace");
          doc.write(bstr);
          doc.close();
          cw.focus();
          doc.execCommand("SaveAs", true, filename);
          document.body.removeChild(frame);
        }
      } else {
        var lang = model.get("lang");
        var html = '<body style="margin:0;"><img src="' + url2 + '" style="max-width:100%;" title="' + (lang && lang[0] || "") + '" /></body>';
        var tab = window.open();
        tab.document.write(html);
        tab.document.title = title;
      }
    }
  };
  SaveAsImage2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0",
      title: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "title"]),
      type: "png",
      connectedBackgroundColor: "#fff",
      name: "",
      excludeComponents: ["toolbox"],
      lang: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "lang"])
    };
    return defaultOption2;
  };
  return SaveAsImage2;
}(ToolboxFeature);
var SaveAsImage$1 = SaveAsImage;
var INNER_STACK_KEYWORD = "__ec_magicType_stack__";
var radioTypes = [["line", "bar"], ["stack"]];
var MagicType = function(_super) {
  __extends(MagicType2, _super);
  function MagicType2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  MagicType2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon");
    var icons = {};
    each$f(model.get("type"), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  MagicType2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: [],
      icon: {
        line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4",
        bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7",
        stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "magicType", "title"]),
      option: {},
      seriesIndex: {}
    };
    return defaultOption2;
  };
  MagicType2.prototype.onclick = function(ecModel, api, type4) {
    var model = this.model;
    var seriesIndex = model.get(["seriesIndex", type4]);
    if (!seriesOptGenreator[type4]) {
      return;
    }
    var newOption = {
      series: []
    };
    var generateNewSeriesTypes = function(seriesModel) {
      var seriesType2 = seriesModel.subType;
      var seriesId = seriesModel.id;
      var newSeriesOpt = seriesOptGenreator[type4](seriesType2, seriesId, seriesModel, model);
      if (newSeriesOpt) {
        defaults(newSeriesOpt, seriesModel.option);
        newOption.series.push(newSeriesOpt);
      }
      var coordSys = seriesModel.coordinateSystem;
      if (coordSys && coordSys.type === "cartesian2d" && (type4 === "line" || type4 === "bar")) {
        var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
        if (categoryAxis2) {
          var axisDim = categoryAxis2.dim;
          var axisType = axisDim + "Axis";
          var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
          var axisIndex = axisModel.componentIndex;
          newOption[axisType] = newOption[axisType] || [];
          for (var i = 0; i <= axisIndex; i++) {
            newOption[axisType][axisIndex] = newOption[axisType][axisIndex] || {};
          }
          newOption[axisType][axisIndex].boundaryGap = type4 === "bar";
        }
      }
    };
    each$f(radioTypes, function(radio) {
      if (indexOf(radio, type4) >= 0) {
        each$f(radio, function(item) {
          model.setIconStatus(item, "normal");
        });
      }
    });
    model.setIconStatus(type4, "emphasis");
    ecModel.eachComponent({
      mainType: "series",
      query: seriesIndex == null ? null : {
        seriesIndex
      }
    }, generateNewSeriesTypes);
    var newTitle;
    var currentType = type4;
    if (type4 === "stack") {
      newTitle = merge({
        stack: model.option.title.tiled,
        tiled: model.option.title.stack
      }, model.option.title);
      if (model.get(["iconStatus", type4]) !== "emphasis") {
        currentType = "tiled";
      }
    }
    api.dispatchAction({
      type: "changeMagicType",
      currentType,
      newOption,
      newTitle,
      featureName: "magicType"
    });
  };
  return MagicType2;
}(ToolboxFeature);
var seriesOptGenreator = {
  "line": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "bar") {
      return merge({
        id: seriesId,
        type: "line",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "line"]) || {}, true);
    }
  },
  "bar": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "line") {
      return merge({
        id: seriesId,
        type: "bar",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "bar"]) || {}, true);
    }
  },
  "stack": function(seriesType2, seriesId, seriesModel, model) {
    var isStack = seriesModel.get("stack") === INNER_STACK_KEYWORD;
    if (seriesType2 === "line" || seriesType2 === "bar") {
      model.setIconStatus("stack", isStack ? "normal" : "emphasis");
      return merge({
        id: seriesId,
        stack: isStack ? "" : INNER_STACK_KEYWORD
      }, model.get(["option", "stack"]) || {}, true);
    }
  }
};
registerAction({
  type: "changeMagicType",
  event: "magicTypeChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.mergeOption(payload.newOption);
});
var MagicType$1 = MagicType;
var BLOCK_SPLITER = new Array(60).join("-");
var ITEM_SPLITER = "	";
function groupSeries(ecModel) {
  var seriesGroupByCategoryAxis = {};
  var otherSeries = [];
  var meta = [];
  ecModel.eachRawSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && (coordSys.type === "cartesian2d" || coordSys.type === "polar")) {
      var baseAxis = coordSys.getBaseAxis();
      if (baseAxis.type === "category") {
        var key = baseAxis.dim + "_" + baseAxis.index;
        if (!seriesGroupByCategoryAxis[key]) {
          seriesGroupByCategoryAxis[key] = {
            categoryAxis: baseAxis,
            valueAxis: coordSys.getOtherAxis(baseAxis),
            series: []
          };
          meta.push({
            axisDim: baseAxis.dim,
            axisIndex: baseAxis.index
          });
        }
        seriesGroupByCategoryAxis[key].series.push(seriesModel);
      } else {
        otherSeries.push(seriesModel);
      }
    } else {
      otherSeries.push(seriesModel);
    }
  });
  return {
    seriesGroupByCategoryAxis,
    other: otherSeries,
    meta
  };
}
function assembleSeriesWithCategoryAxis(groups) {
  var tables = [];
  each$f(groups, function(group, key) {
    var categoryAxis2 = group.categoryAxis;
    var valueAxis2 = group.valueAxis;
    var valueAxisDim = valueAxis2.dim;
    var headers = [" "].concat(map$1(group.series, function(series) {
      return series.name;
    }));
    var columns = [categoryAxis2.model.getCategories()];
    each$f(group.series, function(series) {
      var rawData = series.getRawData();
      columns.push(series.getRawData().mapArray(rawData.mapDimension(valueAxisDim), function(val) {
        return val;
      }));
    });
    var lines = [headers.join(ITEM_SPLITER)];
    for (var i = 0; i < columns[0].length; i++) {
      var items = [];
      for (var j = 0; j < columns.length; j++) {
        items.push(columns[j][i]);
      }
      lines.push(items.join(ITEM_SPLITER));
    }
    tables.push(lines.join("\n"));
  });
  return tables.join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function assembleOtherSeries(series) {
  return map$1(series, function(series2) {
    var data = series2.getRawData();
    var lines = [series2.name];
    var vals = [];
    data.each(data.dimensions, function() {
      var argLen = arguments.length;
      var dataIndex = arguments[argLen - 1];
      var name = data.getName(dataIndex);
      for (var i = 0; i < argLen - 1; i++) {
        vals[i] = arguments[i];
      }
      lines.push((name ? name + ITEM_SPLITER : "") + vals.join(ITEM_SPLITER));
    });
    return lines.join("\n");
  }).join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function getContentFromModel(ecModel) {
  var result = groupSeries(ecModel);
  return {
    value: filter([assembleSeriesWithCategoryAxis(result.seriesGroupByCategoryAxis), assembleOtherSeries(result.other)], function(str) {
      return !!str.replace(/[\n\t\s]/g, "");
    }).join("\n\n" + BLOCK_SPLITER + "\n\n"),
    meta: result.meta
  };
}
function trim(str) {
  return str.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function isTSVFormat(block) {
  var firstLine = block.slice(0, block.indexOf("\n"));
  if (firstLine.indexOf(ITEM_SPLITER) >= 0) {
    return true;
  }
}
var itemSplitRegex = new RegExp("[" + ITEM_SPLITER + "]+", "g");
function parseTSVContents(tsv) {
  var tsvLines = tsv.split(/\n+/g);
  var headers = trim(tsvLines.shift()).split(itemSplitRegex);
  var categories = [];
  var series = map$1(headers, function(header) {
    return {
      name: header,
      data: []
    };
  });
  for (var i = 0; i < tsvLines.length; i++) {
    var items = trim(tsvLines[i]).split(itemSplitRegex);
    categories.push(items.shift());
    for (var j = 0; j < items.length; j++) {
      series[j] && (series[j].data[i] = items[j]);
    }
  }
  return {
    series,
    categories
  };
}
function parseListContents(str) {
  var lines = str.split(/\n+/g);
  var seriesName = trim(lines.shift());
  var data = [];
  for (var i = 0; i < lines.length; i++) {
    var line = trim(lines[i]);
    if (!line) {
      continue;
    }
    var items = line.split(itemSplitRegex);
    var name_1 = "";
    var value = void 0;
    var hasName = false;
    if (isNaN(items[0])) {
      hasName = true;
      name_1 = items[0];
      items = items.slice(1);
      data[i] = {
        name: name_1,
        value: []
      };
      value = data[i].value;
    } else {
      value = data[i] = [];
    }
    for (var j = 0; j < items.length; j++) {
      value.push(+items[j]);
    }
    if (value.length === 1) {
      hasName ? data[i].value = value[0] : data[i] = value[0];
    }
  }
  return {
    name: seriesName,
    data
  };
}
function parseContents(str, blockMetaList) {
  var blocks = str.split(new RegExp("\n*" + BLOCK_SPLITER + "\n*", "g"));
  var newOption = {
    series: []
  };
  each$f(blocks, function(block, idx) {
    if (isTSVFormat(block)) {
      var result = parseTSVContents(block);
      var blockMeta = blockMetaList[idx];
      var axisKey = blockMeta.axisDim + "Axis";
      if (blockMeta) {
        newOption[axisKey] = newOption[axisKey] || [];
        newOption[axisKey][blockMeta.axisIndex] = {
          data: result.categories
        };
        newOption.series = newOption.series.concat(result.series);
      }
    } else {
      var result = parseListContents(block);
      newOption.series.push(result);
    }
  });
  return newOption;
}
var DataView = function(_super) {
  __extends(DataView2, _super);
  function DataView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataView2.prototype.onclick = function(ecModel, api) {
    setTimeout(function() {
      api.dispatchAction({
        type: "hideTip"
      });
    });
    var container2 = api.getDom();
    var model = this.model;
    if (this._dom) {
      container2.removeChild(this._dom);
    }
    var root2 = document.createElement("div");
    root2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px";
    root2.style.backgroundColor = model.get("backgroundColor") || "#fff";
    var header = document.createElement("h4");
    var lang = model.get("lang") || [];
    header.innerHTML = lang[0] || model.get("title");
    header.style.cssText = "margin:10px 20px";
    header.style.color = model.get("textColor");
    var viewMain = document.createElement("div");
    var textarea = document.createElement("textarea");
    viewMain.style.cssText = "overflow:auto";
    var optionToContent = model.get("optionToContent");
    var contentToOption = model.get("contentToOption");
    var result = getContentFromModel(ecModel);
    if (isFunction(optionToContent)) {
      var htmlOrDom = optionToContent(api.getOption());
      if (isString(htmlOrDom)) {
        viewMain.innerHTML = htmlOrDom;
      } else if (isDom(htmlOrDom)) {
        viewMain.appendChild(htmlOrDom);
      }
    } else {
      textarea.readOnly = model.get("readOnly");
      var style = textarea.style;
      style.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none";
      style.color = model.get("textColor");
      style.borderColor = model.get("textareaBorderColor");
      style.backgroundColor = model.get("textareaColor");
      textarea.value = result.value;
      viewMain.appendChild(textarea);
    }
    var blockMetaList = result.meta;
    var buttonContainer = document.createElement("div");
    buttonContainer.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
    var buttonStyle = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px";
    var closeButton = document.createElement("div");
    var refreshButton = document.createElement("div");
    buttonStyle += ";background-color:" + model.get("buttonColor");
    buttonStyle += ";color:" + model.get("buttonTextColor");
    var self2 = this;
    function close() {
      container2.removeChild(root2);
      self2._dom = null;
    }
    addEventListener(closeButton, "click", close);
    addEventListener(refreshButton, "click", function() {
      if (contentToOption == null && optionToContent != null || contentToOption != null && optionToContent == null) {
        close();
        return;
      }
      var newOption;
      try {
        if (isFunction(contentToOption)) {
          newOption = contentToOption(viewMain, api.getOption());
        } else {
          newOption = parseContents(textarea.value, blockMetaList);
        }
      } catch (e2) {
        close();
        throw new Error("Data view format error " + e2);
      }
      if (newOption) {
        api.dispatchAction({
          type: "changeDataView",
          newOption
        });
      }
      close();
    });
    closeButton.innerHTML = lang[1];
    refreshButton.innerHTML = lang[2];
    refreshButton.style.cssText = closeButton.style.cssText = buttonStyle;
    !model.get("readOnly") && buttonContainer.appendChild(refreshButton);
    buttonContainer.appendChild(closeButton);
    root2.appendChild(header);
    root2.appendChild(viewMain);
    root2.appendChild(buttonContainer);
    viewMain.style.height = container2.clientHeight - 80 + "px";
    container2.appendChild(root2);
    this._dom = root2;
  };
  DataView2.prototype.remove = function(ecModel, api) {
    this._dom && api.getDom().removeChild(this._dom);
  };
  DataView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  DataView2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      readOnly: false,
      optionToContent: null,
      contentToOption: null,
      icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28",
      title: ecModel.getLocaleModel().get(["toolbox", "dataView", "title"]),
      lang: ecModel.getLocaleModel().get(["toolbox", "dataView", "lang"]),
      backgroundColor: "#fff",
      textColor: "#000",
      textareaColor: "#fff",
      textareaBorderColor: "#333",
      buttonColor: "#c23531",
      buttonTextColor: "#fff"
    };
    return defaultOption2;
  };
  return DataView2;
}(ToolboxFeature);
function tryMergeDataOption(newData, originalData) {
  return map$1(newData, function(newVal, idx) {
    var original = originalData && originalData[idx];
    if (isObject$4(original) && !isArray$1(original)) {
      var newValIsObject = isObject$4(newVal) && !isArray$1(newVal);
      if (!newValIsObject) {
        newVal = {
          value: newVal
        };
      }
      var shouldDeleteName = original.name != null && newVal.name == null;
      newVal = defaults(newVal, original);
      shouldDeleteName && delete newVal.name;
      return newVal;
    } else {
      return newVal;
    }
  });
}
registerAction({
  type: "changeDataView",
  event: "dataViewChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  var newSeriesOptList = [];
  each$f(payload.newOption.series, function(seriesOpt) {
    var seriesModel = ecModel.getSeriesByName(seriesOpt.name)[0];
    if (!seriesModel) {
      newSeriesOptList.push(extend({
        type: "scatter"
      }, seriesOpt));
    } else {
      var originalData = seriesModel.get("data");
      newSeriesOptList.push({
        name: seriesOpt.name,
        data: tryMergeDataOption(seriesOpt.data, originalData)
      });
    }
  });
  ecModel.mergeOption(defaults({
    series: newSeriesOptList
  }, payload.newOption));
});
var DataView$1 = DataView;
var each$6 = each$f;
var inner$6 = makeInner();
function push(ecModel, newSnapshot) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  each$6(newSnapshot, function(batchItem, dataZoomId) {
    var i = storedSnapshots.length - 1;
    for (; i >= 0; i--) {
      var snapshot = storedSnapshots[i];
      if (snapshot[dataZoomId]) {
        break;
      }
    }
    if (i < 0) {
      var dataZoomModel = ecModel.queryComponents({
        mainType: "dataZoom",
        subType: "select",
        id: dataZoomId
      })[0];
      if (dataZoomModel) {
        var percentRange = dataZoomModel.getPercentRange();
        storedSnapshots[0][dataZoomId] = {
          dataZoomId,
          start: percentRange[0],
          end: percentRange[1]
        };
      }
    }
  });
  storedSnapshots.push(newSnapshot);
}
function pop(ecModel) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  var head = storedSnapshots[storedSnapshots.length - 1];
  storedSnapshots.length > 1 && storedSnapshots.pop();
  var snapshot = {};
  each$6(head, function(batchItem, dataZoomId) {
    for (var i = storedSnapshots.length - 1; i >= 0; i--) {
      batchItem = storedSnapshots[i][dataZoomId];
      if (batchItem) {
        snapshot[dataZoomId] = batchItem;
        break;
      }
    }
  });
  return snapshot;
}
function clear(ecModel) {
  inner$6(ecModel).snapshots = null;
}
function count(ecModel) {
  return getStoreSnapshots(ecModel).length;
}
function getStoreSnapshots(ecModel) {
  var store = inner$6(ecModel);
  if (!store.snapshots) {
    store.snapshots = [{}];
  }
  return store.snapshots;
}
var RestoreOption = function(_super) {
  __extends(RestoreOption2, _super);
  function RestoreOption2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  RestoreOption2.prototype.onclick = function(ecModel, api) {
    clear(ecModel);
    api.dispatchAction({
      type: "restore",
      from: this.uid
    });
  };
  RestoreOption2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5",
      title: ecModel.getLocaleModel().get(["toolbox", "restore", "title"])
    };
    return defaultOption2;
  };
  return RestoreOption2;
}(ToolboxFeature);
registerAction({
  type: "restore",
  event: "restore",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.resetOption("recreate");
});
var Restore = RestoreOption;
var INCLUDE_FINDER_MAIN_TYPES = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"];
var BrushTargetManager = function() {
  function BrushTargetManager2(finder, ecModel, opt) {
    var _this = this;
    this._targetInfoList = [];
    var foundCpts = parseFinder(ecModel, finder);
    each$f(targetInfoBuilders, function(builder, type4) {
      if (!opt || !opt.include || indexOf(opt.include, type4) >= 0) {
        builder(foundCpts, _this._targetInfoList);
      }
    });
  }
  BrushTargetManager2.prototype.setOutputRanges = function(areas, ecModel) {
    this.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      (area.coordRanges || (area.coordRanges = [])).push(coordRange);
      if (!area.coordRange) {
        area.coordRange = coordRange;
        var result = coordConvert[area.brushType](0, coordSys, coordRange);
        area.__rangeOffset = {
          offset: diffProcessor[area.brushType](result.values, area.range, [1, 1]),
          xyMinMax: result.xyMinMax
        };
      }
    });
    return areas;
  };
  BrushTargetManager2.prototype.matchOutputRanges = function(areas, ecModel, cb) {
    each$f(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      if (targetInfo && targetInfo !== true) {
        each$f(targetInfo.coordSyses, function(coordSys) {
          var result = coordConvert[area.brushType](1, coordSys, area.range, true);
          cb(area, result.values, coordSys, ecModel);
        });
      }
    }, this);
  };
  BrushTargetManager2.prototype.setInputRanges = function(areas, ecModel) {
    each$f(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      area.range = area.range || [];
      if (targetInfo && targetInfo !== true) {
        area.panelId = targetInfo.panelId;
        var result = coordConvert[area.brushType](0, targetInfo.coordSys, area.coordRange);
        var rangeOffset = area.__rangeOffset;
        area.range = rangeOffset ? diffProcessor[area.brushType](result.values, rangeOffset.offset, getScales(result.xyMinMax, rangeOffset.xyMinMax)) : result.values;
      }
    }, this);
  };
  BrushTargetManager2.prototype.makePanelOpts = function(api, getDefaultBrushType) {
    return map$1(this._targetInfoList, function(targetInfo) {
      var rect = targetInfo.getPanelRect();
      return {
        panelId: targetInfo.panelId,
        defaultBrushType: getDefaultBrushType ? getDefaultBrushType(targetInfo) : null,
        clipPath: makeRectPanelClipPath(rect),
        isTargetByCursor: makeRectIsTargetByCursor(rect, api, targetInfo.coordSysModel),
        getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect)
      };
    });
  };
  BrushTargetManager2.prototype.controlSeries = function(area, seriesModel, ecModel) {
    var targetInfo = this.findTargetInfo(area, ecModel);
    return targetInfo === true || targetInfo && indexOf(targetInfo.coordSyses, seriesModel.coordinateSystem) >= 0;
  };
  BrushTargetManager2.prototype.findTargetInfo = function(area, ecModel) {
    var targetInfoList = this._targetInfoList;
    var foundCpts = parseFinder(ecModel, area);
    for (var i = 0; i < targetInfoList.length; i++) {
      var targetInfo = targetInfoList[i];
      var areaPanelId = area.panelId;
      if (areaPanelId) {
        if (targetInfo.panelId === areaPanelId) {
          return targetInfo;
        }
      } else {
        for (var j = 0; j < targetInfoMatchers.length; j++) {
          if (targetInfoMatchers[j](foundCpts, targetInfo)) {
            return targetInfo;
          }
        }
      }
    }
    return true;
  };
  return BrushTargetManager2;
}();
function formatMinMax(minMax) {
  minMax[0] > minMax[1] && minMax.reverse();
  return minMax;
}
function parseFinder(ecModel, finder) {
  return parseFinder$1(ecModel, finder, {
    includeMainTypes: INCLUDE_FINDER_MAIN_TYPES
  });
}
var targetInfoBuilders = {
  grid: function(foundCpts, targetInfoList) {
    var xAxisModels = foundCpts.xAxisModels;
    var yAxisModels = foundCpts.yAxisModels;
    var gridModels = foundCpts.gridModels;
    var gridModelMap = createHashMap();
    var xAxesHas = {};
    var yAxesHas = {};
    if (!xAxisModels && !yAxisModels && !gridModels) {
      return;
    }
    each$f(xAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
    });
    each$f(yAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      yAxesHas[gridModel.id] = true;
    });
    each$f(gridModels, function(gridModel) {
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
      yAxesHas[gridModel.id] = true;
    });
    gridModelMap.each(function(gridModel) {
      var grid = gridModel.coordinateSystem;
      var cartesians = [];
      each$f(grid.getCartesians(), function(cartesian, index2) {
        if (indexOf(xAxisModels, cartesian.getAxis("x").model) >= 0 || indexOf(yAxisModels, cartesian.getAxis("y").model) >= 0) {
          cartesians.push(cartesian);
        }
      });
      targetInfoList.push({
        panelId: "grid--" + gridModel.id,
        gridModel,
        coordSysModel: gridModel,
        coordSys: cartesians[0],
        coordSyses: cartesians,
        getPanelRect: panelRectBuilders.grid,
        xAxisDeclared: xAxesHas[gridModel.id],
        yAxisDeclared: yAxesHas[gridModel.id]
      });
    });
  },
  geo: function(foundCpts, targetInfoList) {
    each$f(foundCpts.geoModels, function(geoModel) {
      var coordSys = geoModel.coordinateSystem;
      targetInfoList.push({
        panelId: "geo--" + geoModel.id,
        geoModel,
        coordSysModel: geoModel,
        coordSys,
        coordSyses: [coordSys],
        getPanelRect: panelRectBuilders.geo
      });
    });
  }
};
var targetInfoMatchers = [
  function(foundCpts, targetInfo) {
    var xAxisModel = foundCpts.xAxisModel;
    var yAxisModel = foundCpts.yAxisModel;
    var gridModel = foundCpts.gridModel;
    !gridModel && xAxisModel && (gridModel = xAxisModel.axis.grid.model);
    !gridModel && yAxisModel && (gridModel = yAxisModel.axis.grid.model);
    return gridModel && gridModel === targetInfo.gridModel;
  },
  function(foundCpts, targetInfo) {
    var geoModel = foundCpts.geoModel;
    return geoModel && geoModel === targetInfo.geoModel;
  }
];
var panelRectBuilders = {
  grid: function() {
    return this.coordSys.master.getRect().clone();
  },
  geo: function() {
    var coordSys = this.coordSys;
    var rect = coordSys.getBoundingRect().clone();
    rect.applyTransform(getTransform$1(coordSys));
    return rect;
  }
};
var coordConvert = {
  lineX: curry$1(axisConvert, 0),
  lineY: curry$1(axisConvert, 1),
  rect: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xminymin = to ? coordSys.pointToData([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2);
    var xmaxymax = to ? coordSys.pointToData([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2);
    var values = [formatMinMax([xminymin[0], xmaxymax[0]]), formatMinMax([xminymin[1], xmaxymax[1]])];
    return {
      values,
      xyMinMax: values
    };
  },
  polygon: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xyMinMax = [[Infinity, -Infinity], [Infinity, -Infinity]];
    var values = map$1(rangeOrCoordRange, function(item) {
      var p2 = to ? coordSys.pointToData(item, clamp2) : coordSys.dataToPoint(item, clamp2);
      xyMinMax[0][0] = Math.min(xyMinMax[0][0], p2[0]);
      xyMinMax[1][0] = Math.min(xyMinMax[1][0], p2[1]);
      xyMinMax[0][1] = Math.max(xyMinMax[0][1], p2[0]);
      xyMinMax[1][1] = Math.max(xyMinMax[1][1], p2[1]);
      return p2;
    });
    return {
      values,
      xyMinMax
    };
  }
};
function axisConvert(axisNameIndex, to, coordSys, rangeOrCoordRange) {
  var axis = coordSys.getAxis(["x", "y"][axisNameIndex]);
  var values = formatMinMax(map$1([0, 1], function(i) {
    return to ? axis.coordToData(axis.toLocalCoord(rangeOrCoordRange[i]), true) : axis.toGlobalCoord(axis.dataToCoord(rangeOrCoordRange[i]));
  }));
  var xyMinMax = [];
  xyMinMax[axisNameIndex] = values;
  xyMinMax[1 - axisNameIndex] = [NaN, NaN];
  return {
    values,
    xyMinMax
  };
}
var diffProcessor = {
  lineX: curry$1(axisDiffProcessor, 0),
  lineY: curry$1(axisDiffProcessor, 1),
  rect: function(values, refer, scales) {
    return [[values[0][0] - scales[0] * refer[0][0], values[0][1] - scales[0] * refer[0][1]], [values[1][0] - scales[1] * refer[1][0], values[1][1] - scales[1] * refer[1][1]]];
  },
  polygon: function(values, refer, scales) {
    return map$1(values, function(item, idx) {
      return [item[0] - scales[0] * refer[idx][0], item[1] - scales[1] * refer[idx][1]];
    });
  }
};
function axisDiffProcessor(axisNameIndex, values, refer, scales) {
  return [values[0] - scales[axisNameIndex] * refer[0], values[1] - scales[axisNameIndex] * refer[1]];
}
function getScales(xyMinMaxCurr, xyMinMaxOrigin) {
  var sizeCurr = getSize(xyMinMaxCurr);
  var sizeOrigin = getSize(xyMinMaxOrigin);
  var scales = [sizeCurr[0] / sizeOrigin[0], sizeCurr[1] / sizeOrigin[1]];
  isNaN(scales[0]) && (scales[0] = 1);
  isNaN(scales[1]) && (scales[1] = 1);
  return scales;
}
function getSize(xyMinMax) {
  return xyMinMax ? [xyMinMax[0][1] - xyMinMax[0][0], xyMinMax[1][1] - xyMinMax[1][0]] : [NaN, NaN];
}
var BrushTargetManager$1 = BrushTargetManager;
var each$5 = each$f;
var DATA_ZOOM_ID_BASE = makeInternalComponentId("toolbox-dataZoom_");
var DataZoomFeature = function(_super) {
  __extends(DataZoomFeature2, _super);
  function DataZoomFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataZoomFeature2.prototype.render = function(featureModel, ecModel, api, payload) {
    if (!this._brushController) {
      this._brushController = new BrushController$1(api.getZr());
      this._brushController.on("brush", bind$1(this._onBrush, this)).mount();
    }
    updateZoomBtnStatus(featureModel, ecModel, this, payload, api);
    updateBackBtnStatus(featureModel, ecModel);
  };
  DataZoomFeature2.prototype.onclick = function(ecModel, api, type4) {
    handlers[type4].call(this);
  };
  DataZoomFeature2.prototype.remove = function(ecModel, api) {
    this._brushController && this._brushController.unmount();
  };
  DataZoomFeature2.prototype.dispose = function(ecModel, api) {
    this._brushController && this._brushController.dispose();
  };
  DataZoomFeature2.prototype._onBrush = function(eventParam) {
    var areas = eventParam.areas;
    if (!eventParam.isEnd || !areas.length) {
      return;
    }
    var snapshot = {};
    var ecModel = this.ecModel;
    this._brushController.updateCovers([]);
    var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(this.model), ecModel, {
      include: ["grid"]
    });
    brushTargetManager.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      if (coordSys.type !== "cartesian2d") {
        return;
      }
      var brushType = area.brushType;
      if (brushType === "rect") {
        setBatch("x", coordSys, coordRange[0]);
        setBatch("y", coordSys, coordRange[1]);
      } else {
        setBatch({
          lineX: "x",
          lineY: "y"
        }[brushType], coordSys, coordRange);
      }
    });
    push(ecModel, snapshot);
    this._dispatchZoomAction(snapshot);
    function setBatch(dimName, coordSys, minMax) {
      var axis = coordSys.getAxis(dimName);
      var axisModel = axis.model;
      var dataZoomModel = findDataZoom(dimName, axisModel, ecModel);
      var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy(axisModel).getMinMaxSpan();
      if (minMaxSpan.minValueSpan != null || minMaxSpan.maxValueSpan != null) {
        minMax = sliderMove(0, minMax.slice(), axis.scale.getExtent(), 0, minMaxSpan.minValueSpan, minMaxSpan.maxValueSpan);
      }
      dataZoomModel && (snapshot[dataZoomModel.id] = {
        dataZoomId: dataZoomModel.id,
        startValue: minMax[0],
        endValue: minMax[1]
      });
    }
    function findDataZoom(dimName, axisModel, ecModel2) {
      var found;
      ecModel2.eachComponent({
        mainType: "dataZoom",
        subType: "select"
      }, function(dzModel) {
        var has2 = dzModel.getAxisModel(dimName, axisModel.componentIndex);
        has2 && (found = dzModel);
      });
      return found;
    }
  };
  DataZoomFeature2.prototype._dispatchZoomAction = function(snapshot) {
    var batch = [];
    each$5(snapshot, function(batchItem, dataZoomId) {
      batch.push(clone$4(batchItem));
    });
    batch.length && this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      batch
    });
  };
  DataZoomFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      filterMode: "filter",
      icon: {
        zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1",
        back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "dataZoom", "title"]),
      brushStyle: {
        borderWidth: 0,
        color: "rgba(210,219,238,0.2)"
      }
    };
    return defaultOption2;
  };
  return DataZoomFeature2;
}(ToolboxFeature);
var handlers = {
  zoom: function() {
    var nextActive = !this._isZoomActive;
    this.api.dispatchAction({
      type: "takeGlobalCursor",
      key: "dataZoomSelect",
      dataZoomSelectActive: nextActive
    });
  },
  back: function() {
    this._dispatchZoomAction(pop(this.ecModel));
  }
};
function makeAxisFinder(dzFeatureModel) {
  var setting = {
    xAxisIndex: dzFeatureModel.get("xAxisIndex", true),
    yAxisIndex: dzFeatureModel.get("yAxisIndex", true),
    xAxisId: dzFeatureModel.get("xAxisId", true),
    yAxisId: dzFeatureModel.get("yAxisId", true)
  };
  if (setting.xAxisIndex == null && setting.xAxisId == null) {
    setting.xAxisIndex = "all";
  }
  if (setting.yAxisIndex == null && setting.yAxisId == null) {
    setting.yAxisIndex = "all";
  }
  return setting;
}
function updateBackBtnStatus(featureModel, ecModel) {
  featureModel.setIconStatus("back", count(ecModel) > 1 ? "emphasis" : "normal");
}
function updateZoomBtnStatus(featureModel, ecModel, view, payload, api) {
  var zoomActive = view._isZoomActive;
  if (payload && payload.type === "takeGlobalCursor") {
    zoomActive = payload.key === "dataZoomSelect" ? payload.dataZoomSelectActive : false;
  }
  view._isZoomActive = zoomActive;
  featureModel.setIconStatus("zoom", zoomActive ? "emphasis" : "normal");
  var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(featureModel), ecModel, {
    include: ["grid"]
  });
  var panels = brushTargetManager.makePanelOpts(api, function(targetInfo) {
    return targetInfo.xAxisDeclared && !targetInfo.yAxisDeclared ? "lineX" : !targetInfo.xAxisDeclared && targetInfo.yAxisDeclared ? "lineY" : "rect";
  });
  view._brushController.setPanels(panels).enableBrush(zoomActive && panels.length ? {
    brushType: "auto",
    brushStyle: featureModel.getModel("brushStyle").getItemStyle()
  } : false);
}
registerInternalOptionCreator("dataZoom", function(ecModel) {
  var toolboxModel = ecModel.getComponent("toolbox", 0);
  var featureDataZoomPath = ["feature", "dataZoom"];
  if (!toolboxModel || toolboxModel.get(featureDataZoomPath) == null) {
    return;
  }
  var dzFeatureModel = toolboxModel.getModel(featureDataZoomPath);
  var dzOptions = [];
  var finder = makeAxisFinder(dzFeatureModel);
  var finderResult = parseFinder$1(ecModel, finder);
  each$5(finderResult.xAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "xAxis", "xAxisIndex");
  });
  each$5(finderResult.yAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "yAxis", "yAxisIndex");
  });
  function buildInternalOptions(axisModel, axisMainType, axisIndexPropName) {
    var axisIndex = axisModel.componentIndex;
    var newOpt = {
      type: "select",
      $fromToolbox: true,
      filterMode: dzFeatureModel.get("filterMode", true) || "filter",
      id: DATA_ZOOM_ID_BASE + axisMainType + axisIndex
    };
    newOpt[axisIndexPropName] = axisIndex;
    dzOptions.push(newOpt);
  }
  return dzOptions;
});
var DataZoom = DataZoomFeature;
function install$j(registers) {
  registers.registerComponentModel(ToolboxModel$1);
  registers.registerComponentView(ToolboxView$1);
  registerFeature("saveAsImage", SaveAsImage$1);
  registerFeature("magicType", MagicType$1);
  registerFeature("dataView", DataView$1);
  registerFeature("dataZoom", DataZoom);
  registerFeature("restore", Restore);
  use(install$k);
}
var TooltipModel = function(_super) {
  __extends(TooltipModel2, _super);
  function TooltipModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipModel2.type;
    return _this;
  }
  TooltipModel2.type = "tooltip";
  TooltipModel2.dependencies = ["axisPointer"];
  TooltipModel2.defaultOption = {
    z: 60,
    show: true,
    showContent: true,
    trigger: "item",
    triggerOn: "mousemove|click",
    alwaysShowContent: false,
    displayMode: "single",
    renderMode: "auto",
    confine: null,
    showDelay: 0,
    hideDelay: 100,
    transitionDuration: 0.4,
    enterable: false,
    backgroundColor: "#fff",
    shadowBlur: 10,
    shadowColor: "rgba(0, 0, 0, .2)",
    shadowOffsetX: 1,
    shadowOffsetY: 2,
    borderRadius: 4,
    borderWidth: 1,
    padding: null,
    extraCssText: "",
    axisPointer: {
      type: "line",
      axis: "auto",
      animation: "auto",
      animationDurationUpdate: 200,
      animationEasingUpdate: "exponentialOut",
      crossStyle: {
        color: "#999",
        width: 1,
        type: "dashed",
        textStyle: {}
      }
    },
    textStyle: {
      color: "#666",
      fontSize: 14
    }
  };
  return TooltipModel2;
}(ComponentModel$1);
var TooltipModel$1 = TooltipModel;
function shouldTooltipConfine(tooltipModel) {
  var confineOption = tooltipModel.get("confine");
  return confineOption != null ? !!confineOption : tooltipModel.get("renderMode") === "richText";
}
function testStyle(styleProps) {
  if (!env$1.domSupported) {
    return;
  }
  var style = document.documentElement.style;
  for (var i = 0, len2 = styleProps.length; i < len2; i++) {
    if (styleProps[i] in style) {
      return styleProps[i];
    }
  }
}
var TRANSFORM_VENDOR = testStyle(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]);
var TRANSITION_VENDOR = testStyle(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
function toCSSVendorPrefix(styleVendor, styleProp) {
  if (!styleVendor) {
    return styleProp;
  }
  styleProp = toCamelCase(styleProp, true);
  var idx = styleVendor.indexOf(styleProp);
  styleVendor = idx === -1 ? styleProp : "-" + styleVendor.slice(0, idx) + "-" + styleProp;
  return styleVendor.toLowerCase();
}
function getComputedStyle$1(el, style) {
  var stl = el.currentStyle || document.defaultView && document.defaultView.getComputedStyle(el);
  return stl ? style ? stl[style] : stl : null;
}
var CSS_TRANSITION_VENDOR = toCSSVendorPrefix(TRANSITION_VENDOR, "transition");
var CSS_TRANSFORM_VENDOR = toCSSVendorPrefix(TRANSFORM_VENDOR, "transform");
var gCssText = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (env$1.transform3dSupported ? "will-change:transform;" : "");
function mirrorPos(pos) {
  pos = pos === "left" ? "right" : pos === "right" ? "left" : pos === "top" ? "bottom" : "top";
  return pos;
}
function assembleArrow(tooltipModel, borderColor, arrowPosition) {
  if (!isString(arrowPosition) || arrowPosition === "inside") {
    return "";
  }
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var borderWidth = tooltipModel.get("borderWidth");
  borderColor = convertToColorString(borderColor);
  var arrowPos = mirrorPos(arrowPosition);
  var arrowSize = Math.max(Math.round(borderWidth) * 1.5, 6);
  var positionStyle = "";
  var transformStyle = CSS_TRANSFORM_VENDOR + ":";
  var rotateDeg;
  if (indexOf(["left", "right"], arrowPos) > -1) {
    positionStyle += "top:50%";
    transformStyle += "translateY(-50%) rotate(" + (rotateDeg = arrowPos === "left" ? -225 : -45) + "deg)";
  } else {
    positionStyle += "left:50%";
    transformStyle += "translateX(-50%) rotate(" + (rotateDeg = arrowPos === "top" ? 225 : 45) + "deg)";
  }
  var rotateRadian = rotateDeg * Math.PI / 180;
  var arrowWH = arrowSize + borderWidth;
  var rotatedWH = arrowWH * Math.abs(Math.cos(rotateRadian)) + arrowWH * Math.abs(Math.sin(rotateRadian));
  var arrowOffset = Math.round(((rotatedWH - Math.SQRT2 * borderWidth) / 2 + Math.SQRT2 * borderWidth - (rotatedWH - arrowWH) / 2) * 100) / 100;
  positionStyle += ";" + arrowPos + ":-" + arrowOffset + "px";
  var borderStyle = borderColor + " solid " + borderWidth + "px;";
  var styleCss = ["position:absolute;width:" + arrowSize + "px;height:" + arrowSize + "px;", positionStyle + ";" + transformStyle + ";", "border-bottom:" + borderStyle, "border-right:" + borderStyle, "background-color:" + backgroundColor2 + ";"];
  return '<div style="' + styleCss.join("") + '"></div>';
}
function assembleTransition(duration, onlyFade) {
  var transitionCurve = "cubic-bezier(0.23,1,0.32,1)";
  var transitionOption = " " + duration / 2 + "s " + transitionCurve;
  var transitionText = "opacity" + transitionOption + ",visibility" + transitionOption;
  if (!onlyFade) {
    transitionOption = " " + duration + "s " + transitionCurve;
    transitionText += env$1.transformSupported ? "," + CSS_TRANSFORM_VENDOR + transitionOption : ",left" + transitionOption + ",top" + transitionOption;
  }
  return CSS_TRANSITION_VENDOR + ":" + transitionText;
}
function assembleTransform(x2, y2, toString) {
  var x0 = x2.toFixed(0) + "px";
  var y0 = y2.toFixed(0) + "px";
  if (!env$1.transformSupported) {
    return toString ? "top:" + y0 + ";left:" + x0 + ";" : [["top", y0], ["left", x0]];
  }
  var is3d = env$1.transform3dSupported;
  var translate2 = "translate" + (is3d ? "3d" : "") + "(" + x0 + "," + y0 + (is3d ? ",0" : "") + ")";
  return toString ? "top:0;left:0;" + CSS_TRANSFORM_VENDOR + ":" + translate2 + ";" : [["top", 0], ["left", 0], [TRANSFORM_VENDOR, translate2]];
}
function assembleFont(textStyleModel) {
  var cssText = [];
  var fontSize = textStyleModel.get("fontSize");
  var color = textStyleModel.getTextColor();
  color && cssText.push("color:" + color);
  cssText.push("font:" + textStyleModel.getFont());
  fontSize && cssText.push("line-height:" + Math.round(fontSize * 3 / 2) + "px");
  var shadowColor = textStyleModel.get("textShadowColor");
  var shadowBlur = textStyleModel.get("textShadowBlur") || 0;
  var shadowOffsetX = textStyleModel.get("textShadowOffsetX") || 0;
  var shadowOffsetY = textStyleModel.get("textShadowOffsetY") || 0;
  shadowColor && shadowBlur && cssText.push("text-shadow:" + shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor);
  each$f(["decoration", "align"], function(name) {
    var val = textStyleModel.get(name);
    val && cssText.push("text-" + name + ":" + val);
  });
  return cssText.join(";");
}
function assembleCssText(tooltipModel, enableTransition, onlyFade) {
  var cssText = [];
  var transitionDuration = tooltipModel.get("transitionDuration");
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var shadowBlur = tooltipModel.get("shadowBlur");
  var shadowColor = tooltipModel.get("shadowColor");
  var shadowOffsetX = tooltipModel.get("shadowOffsetX");
  var shadowOffsetY = tooltipModel.get("shadowOffsetY");
  var textStyleModel = tooltipModel.getModel("textStyle");
  var padding = getPaddingFromTooltipModel(tooltipModel, "html");
  var boxShadow = shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor;
  cssText.push("box-shadow:" + boxShadow);
  enableTransition && transitionDuration && cssText.push(assembleTransition(transitionDuration, onlyFade));
  if (backgroundColor2) {
    cssText.push("background-color:" + backgroundColor2);
  }
  each$f(["width", "color", "radius"], function(name) {
    var borderName = "border-" + name;
    var camelCase = toCamelCase(borderName);
    var val = tooltipModel.get(camelCase);
    val != null && cssText.push(borderName + ":" + val + (name === "color" ? "" : "px"));
  });
  cssText.push(assembleFont(textStyleModel));
  if (padding != null) {
    cssText.push("padding:" + normalizeCssArray(padding).join("px ") + "px");
  }
  return cssText.join(";") + ";";
}
function makeStyleCoord$1(out2, zr, appendToBody, zrX, zrY) {
  var zrPainter = zr && zr.painter;
  if (appendToBody) {
    var zrViewportRoot = zrPainter && zrPainter.getViewportRoot();
    if (zrViewportRoot) {
      transformLocalCoord(out2, zrViewportRoot, document.body, zrX, zrY);
    }
  } else {
    out2[0] = zrX;
    out2[1] = zrY;
    var viewportRootOffset = zrPainter && zrPainter.getViewportRootOffset();
    if (viewportRootOffset) {
      out2[0] += viewportRootOffset.offsetLeft;
      out2[1] += viewportRootOffset.offsetTop;
    }
  }
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipHTMLContent = function() {
  function TooltipHTMLContent2(container2, api, opt) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._firstShow = true;
    this._longHide = true;
    if (env$1.wxa) {
      return null;
    }
    var el = document.createElement("div");
    el.domBelongToZr = true;
    this.el = el;
    var zr = this._zr = api.getZr();
    var appendToBody = this._appendToBody = opt && opt.appendToBody;
    makeStyleCoord$1(this._styleCoord, zr, appendToBody, api.getWidth() / 2, api.getHeight() / 2);
    if (appendToBody) {
      document.body.appendChild(el);
    } else {
      container2.appendChild(el);
    }
    this._container = container2;
    var self2 = this;
    el.onmouseenter = function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    };
    el.onmousemove = function(e2) {
      e2 = e2 || window.event;
      if (!self2._enterable) {
        var handler = zr.handler;
        var zrViewportRoot = zr.painter.getViewportRoot();
        normalizeEvent(zrViewportRoot, e2, true);
        handler.dispatch("mousemove", e2);
      }
    };
    el.onmouseleave = function() {
      self2._inContent = false;
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
    };
  }
  TooltipHTMLContent2.prototype.update = function(tooltipModel) {
    var container2 = this._container;
    var position2 = getComputedStyle$1(container2, "position");
    var domStyle = container2.style;
    if (domStyle.position !== "absolute" && position2 !== "absolute") {
      domStyle.position = "relative";
    }
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
    this.el.className = tooltipModel.get("className") || "";
  };
  TooltipHTMLContent2.prototype.show = function(tooltipModel, nearPointColor) {
    clearTimeout(this._hideTimeout);
    clearTimeout(this._longHideTimeout);
    var el = this.el;
    var style = el.style;
    var styleCoord = this._styleCoord;
    if (!el.innerHTML) {
      style.display = "none";
    } else {
      style.cssText = gCssText + assembleCssText(tooltipModel, !this._firstShow, this._longHide) + assembleTransform(styleCoord[0], styleCoord[1], true) + ("border-color:" + convertToColorString(nearPointColor) + ";") + (tooltipModel.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none"));
    }
    this._show = true;
    this._firstShow = false;
    this._longHide = false;
  };
  TooltipHTMLContent2.prototype.setContent = function(content, markers, tooltipModel, borderColor, arrowPosition) {
    var el = this.el;
    if (content == null) {
      el.innerHTML = "";
      return;
    }
    var arrow = "";
    if (isString(arrowPosition) && tooltipModel.get("trigger") === "item" && !shouldTooltipConfine(tooltipModel)) {
      arrow = assembleArrow(tooltipModel, borderColor, arrowPosition);
    }
    if (isString(content)) {
      el.innerHTML = content + arrow;
    } else if (content) {
      el.innerHTML = "";
      if (!isArray$1(content)) {
        content = [content];
      }
      for (var i = 0; i < content.length; i++) {
        if (isDom(content[i]) && content[i].parentNode !== el) {
          el.appendChild(content[i]);
        }
      }
      if (arrow && el.childNodes.length) {
        var arrowEl = document.createElement("div");
        arrowEl.innerHTML = arrow;
        el.appendChild(arrowEl);
      }
    }
  };
  TooltipHTMLContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipHTMLContent2.prototype.getSize = function() {
    var el = this.el;
    return [el.offsetWidth, el.offsetHeight];
  };
  TooltipHTMLContent2.prototype.moveTo = function(zrX, zrY) {
    var styleCoord = this._styleCoord;
    makeStyleCoord$1(styleCoord, this._zr, this._appendToBody, zrX, zrY);
    if (styleCoord[0] != null && styleCoord[1] != null) {
      var style_1 = this.el.style;
      var transforms = assembleTransform(styleCoord[0], styleCoord[1]);
      each$f(transforms, function(transform2) {
        style_1[transform2[0]] = transform2[1];
      });
    }
  };
  TooltipHTMLContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipHTMLContent2.prototype.hide = function() {
    var _this = this;
    var style = this.el.style;
    style.visibility = "hidden";
    style.opacity = "0";
    env$1.transform3dSupported && (style.willChange = "");
    this._show = false;
    this._longHideTimeout = setTimeout(function() {
      return _this._longHide = true;
    }, 500);
  };
  TooltipHTMLContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipHTMLContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipHTMLContent2.prototype.dispose = function() {
    this.el.parentNode.removeChild(this.el);
  };
  return TooltipHTMLContent2;
}();
var TooltipHTMLContent$1 = TooltipHTMLContent;
var TooltipRichContent = function() {
  function TooltipRichContent2(api) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._zr = api.getZr();
    makeStyleCoord(this._styleCoord, this._zr, api.getWidth() / 2, api.getHeight() / 2);
  }
  TooltipRichContent2.prototype.update = function(tooltipModel) {
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
  };
  TooltipRichContent2.prototype.show = function() {
    if (this._hideTimeout) {
      clearTimeout(this._hideTimeout);
    }
    this.el.show();
    this._show = true;
  };
  TooltipRichContent2.prototype.setContent = function(content, markupStyleCreator, tooltipModel, borderColor, arrowPosition) {
    var _this = this;
    if (isObject$4(content)) {
      throwError("");
    }
    if (this.el) {
      this._zr.remove(this.el);
    }
    var textStyleModel = tooltipModel.getModel("textStyle");
    this.el = new ZRText$1({
      style: {
        rich: markupStyleCreator.richTextStyles,
        text: content,
        lineHeight: 22,
        borderWidth: 1,
        borderColor,
        textShadowColor: textStyleModel.get("textShadowColor"),
        fill: tooltipModel.get(["textStyle", "color"]),
        padding: getPaddingFromTooltipModel(tooltipModel, "richText"),
        verticalAlign: "top",
        align: "left"
      },
      z: tooltipModel.get("z")
    });
    each$f(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(propName) {
      _this.el.style[propName] = tooltipModel.get(propName);
    });
    each$f(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(propName) {
      _this.el.style[propName] = textStyleModel.get(propName) || 0;
    });
    this._zr.add(this.el);
    var self2 = this;
    this.el.on("mouseover", function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    });
    this.el.on("mouseout", function() {
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
      self2._inContent = false;
    });
  };
  TooltipRichContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipRichContent2.prototype.getSize = function() {
    var el = this.el;
    var bounding = this.el.getBoundingRect();
    var shadowOuterSize = calcShadowOuterSize(el.style);
    return [bounding.width + shadowOuterSize.left + shadowOuterSize.right, bounding.height + shadowOuterSize.top + shadowOuterSize.bottom];
  };
  TooltipRichContent2.prototype.moveTo = function(x2, y2) {
    var el = this.el;
    if (el) {
      var styleCoord = this._styleCoord;
      makeStyleCoord(styleCoord, this._zr, x2, y2);
      x2 = styleCoord[0];
      y2 = styleCoord[1];
      var style = el.style;
      var borderWidth = mathMaxWith0(style.borderWidth || 0);
      var shadowOuterSize = calcShadowOuterSize(style);
      el.x = x2 + borderWidth + shadowOuterSize.left;
      el.y = y2 + borderWidth + shadowOuterSize.top;
      el.markRedraw();
    }
  };
  TooltipRichContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipRichContent2.prototype.hide = function() {
    if (this.el) {
      this.el.hide();
    }
    this._show = false;
  };
  TooltipRichContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipRichContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipRichContent2.prototype.dispose = function() {
    this._zr.remove(this.el);
  };
  return TooltipRichContent2;
}();
function mathMaxWith0(val) {
  return Math.max(0, val);
}
function calcShadowOuterSize(style) {
  var shadowBlur = mathMaxWith0(style.shadowBlur || 0);
  var shadowOffsetX = mathMaxWith0(style.shadowOffsetX || 0);
  var shadowOffsetY = mathMaxWith0(style.shadowOffsetY || 0);
  return {
    left: mathMaxWith0(shadowBlur - shadowOffsetX),
    right: mathMaxWith0(shadowBlur + shadowOffsetX),
    top: mathMaxWith0(shadowBlur - shadowOffsetY),
    bottom: mathMaxWith0(shadowBlur + shadowOffsetY)
  };
}
function makeStyleCoord(out2, zr, zrX, zrY) {
  out2[0] = zrX;
  out2[1] = zrY;
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipRichContent$1 = TooltipRichContent;
var proxyRect = new Rect$3({
  shape: {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  }
});
var TooltipView = function(_super) {
  __extends(TooltipView2, _super);
  function TooltipView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipView2.type;
    return _this;
  }
  TooltipView2.prototype.init = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    var tooltipModel = ecModel.getComponent("tooltip");
    var renderMode = this._renderMode = getTooltipRenderMode(tooltipModel.get("renderMode"));
    this._tooltipContent = renderMode === "richText" ? new TooltipRichContent$1(api) : new TooltipHTMLContent$1(api.getDom(), api, {
      appendToBody: tooltipModel.get("appendToBody", true)
    });
  };
  TooltipView2.prototype.render = function(tooltipModel, ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    this.group.removeAll();
    this._tooltipModel = tooltipModel;
    this._ecModel = ecModel;
    this._api = api;
    this._alwaysShowContent = tooltipModel.get("alwaysShowContent");
    var tooltipContent = this._tooltipContent;
    tooltipContent.update(tooltipModel);
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    this._initGlobalListener();
    this._keepShow();
    if (this._renderMode !== "richText" && tooltipModel.get("transitionDuration")) {
      createOrUpdate(this, "_updatePosition", 50, "fixRate");
    } else {
      clear$1(this, "_updatePosition");
    }
  };
  TooltipView2.prototype._initGlobalListener = function() {
    var tooltipModel = this._tooltipModel;
    var triggerOn = tooltipModel.get("triggerOn");
    register("itemTooltip", this._api, bind$1(function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none") {
        if (triggerOn.indexOf(currTrigger) >= 0) {
          this._tryShow(e2, dispatchAction2);
        } else if (currTrigger === "leave") {
          this._hide(dispatchAction2);
        }
      }
    }, this));
  };
  TooltipView2.prototype._keepShow = function() {
    var tooltipModel = this._tooltipModel;
    var ecModel = this._ecModel;
    var api = this._api;
    if (this._lastX != null && this._lastY != null && tooltipModel.get("triggerOn") !== "none") {
      var self_1 = this;
      clearTimeout(this._refreshUpdateTimeout);
      this._refreshUpdateTimeout = setTimeout(function() {
        !api.isDisposed() && self_1.manuallyShowTip(tooltipModel, ecModel, api, {
          x: self_1._lastX,
          y: self_1._lastY,
          dataByCoordSys: self_1._lastDataByCoordSys
        });
      });
    }
  };
  TooltipView2.prototype.manuallyShowTip = function(tooltipModel, ecModel, api, payload) {
    if (payload.from === this.uid || env$1.node || !api.getDom()) {
      return;
    }
    var dispatchAction2 = makeDispatchAction(payload, api);
    this._ticket = "";
    var dataByCoordSys = payload.dataByCoordSys;
    var cmptRef = findComponentReference(payload, ecModel, api);
    if (cmptRef) {
      var rect = cmptRef.el.getBoundingRect().clone();
      rect.applyTransform(cmptRef.el.transform);
      this._tryShow({
        offsetX: rect.x + rect.width / 2,
        offsetY: rect.y + rect.height / 2,
        target: cmptRef.el,
        position: payload.position,
        positionDefault: "bottom"
      }, dispatchAction2);
    } else if (payload.tooltip && payload.x != null && payload.y != null) {
      var el = proxyRect;
      el.x = payload.x;
      el.y = payload.y;
      el.update();
      getECData(el).tooltipConfig = {
        name: null,
        option: payload.tooltip
      };
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        target: el
      }, dispatchAction2);
    } else if (dataByCoordSys) {
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        dataByCoordSys,
        tooltipOption: payload.tooltipOption
      }, dispatchAction2);
    } else if (payload.seriesIndex != null) {
      if (this._manuallyAxisShowTip(tooltipModel, ecModel, api, payload)) {
        return;
      }
      var pointInfo = findPointFromSeries(payload, ecModel);
      var cx = pointInfo.point[0];
      var cy = pointInfo.point[1];
      if (cx != null && cy != null) {
        this._tryShow({
          offsetX: cx,
          offsetY: cy,
          target: pointInfo.el,
          position: payload.position,
          positionDefault: "bottom"
        }, dispatchAction2);
      }
    } else if (payload.x != null && payload.y != null) {
      api.dispatchAction({
        type: "updateAxisPointer",
        x: payload.x,
        y: payload.y
      });
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        target: api.getZr().findHover(payload.x, payload.y).target
      }, dispatchAction2);
    }
  };
  TooltipView2.prototype.manuallyHideTip = function(tooltipModel, ecModel, api, payload) {
    var tooltipContent = this._tooltipContent;
    if (!this._alwaysShowContent && this._tooltipModel) {
      tooltipContent.hideLater(this._tooltipModel.get("hideDelay"));
    }
    this._lastX = this._lastY = this._lastDataByCoordSys = null;
    if (payload.from !== this.uid) {
      this._hide(makeDispatchAction(payload, api));
    }
  };
  TooltipView2.prototype._manuallyAxisShowTip = function(tooltipModel, ecModel, api, payload) {
    var seriesIndex = payload.seriesIndex;
    var dataIndex = payload.dataIndex;
    var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
    if (seriesIndex == null || dataIndex == null || coordSysAxesInfo == null) {
      return;
    }
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    if (!seriesModel) {
      return;
    }
    var data = seriesModel.getData();
    var tooltipCascadedModel = buildTooltipModel([data.getItemModel(dataIndex), seriesModel, (seriesModel.coordinateSystem || {}).model], this._tooltipModel);
    if (tooltipCascadedModel.get("trigger") !== "axis") {
      return;
    }
    api.dispatchAction({
      type: "updateAxisPointer",
      seriesIndex,
      dataIndex,
      position: payload.position
    });
    return true;
  };
  TooltipView2.prototype._tryShow = function(e2, dispatchAction2) {
    var el = e2.target;
    var tooltipModel = this._tooltipModel;
    if (!tooltipModel) {
      return;
    }
    this._lastX = e2.offsetX;
    this._lastY = e2.offsetY;
    var dataByCoordSys = e2.dataByCoordSys;
    if (dataByCoordSys && dataByCoordSys.length) {
      this._showAxisTooltip(dataByCoordSys, e2);
    } else if (el) {
      this._lastDataByCoordSys = null;
      var seriesDispatcher_1;
      var cmptDispatcher_1;
      findEventDispatcher(el, function(target) {
        if (getECData(target).dataIndex != null) {
          seriesDispatcher_1 = target;
          return true;
        }
        if (getECData(target).tooltipConfig != null) {
          cmptDispatcher_1 = target;
          return true;
        }
      }, true);
      if (seriesDispatcher_1) {
        this._showSeriesItemTooltip(e2, seriesDispatcher_1, dispatchAction2);
      } else if (cmptDispatcher_1) {
        this._showComponentItemTooltip(e2, cmptDispatcher_1, dispatchAction2);
      } else {
        this._hide(dispatchAction2);
      }
    } else {
      this._lastDataByCoordSys = null;
      this._hide(dispatchAction2);
    }
  };
  TooltipView2.prototype._showOrMove = function(tooltipModel, cb) {
    var delay = tooltipModel.get("showDelay");
    cb = bind$1(cb, this);
    clearTimeout(this._showTimout);
    delay > 0 ? this._showTimout = setTimeout(cb, delay) : cb();
  };
  TooltipView2.prototype._showAxisTooltip = function(dataByCoordSys, e2) {
    var ecModel = this._ecModel;
    var globalTooltipModel = this._tooltipModel;
    var point = [e2.offsetX, e2.offsetY];
    var singleTooltipModel = buildTooltipModel([e2.tooltipOption], globalTooltipModel);
    var renderMode = this._renderMode;
    var cbParamsList = [];
    var articleMarkup = createTooltipMarkup("section", {
      blocks: [],
      noHeader: true
    });
    var markupTextArrLegacy = [];
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    each$f(dataByCoordSys, function(itemCoordSys) {
      each$f(itemCoordSys.dataByAxis, function(axisItem) {
        var axisModel = ecModel.getComponent(axisItem.axisDim + "Axis", axisItem.axisIndex);
        var axisValue = axisItem.value;
        if (!axisModel || axisValue == null) {
          return;
        }
        var axisValueLabel = getValueLabel(axisValue, axisModel.axis, ecModel, axisItem.seriesDataIndices, axisItem.valueLabelOpt);
        var axisSectionMarkup = createTooltipMarkup("section", {
          header: axisValueLabel,
          noHeader: !trim$1(axisValueLabel),
          sortBlocks: true,
          blocks: []
        });
        articleMarkup.blocks.push(axisSectionMarkup);
        each$f(axisItem.seriesDataIndices, function(idxItem) {
          var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
          var dataIndex = idxItem.dataIndexInside;
          var cbParams = series.getDataParams(dataIndex);
          if (cbParams.dataIndex < 0) {
            return;
          }
          cbParams.axisDim = axisItem.axisDim;
          cbParams.axisIndex = axisItem.axisIndex;
          cbParams.axisType = axisItem.axisType;
          cbParams.axisId = axisItem.axisId;
          cbParams.axisValue = getAxisRawValue(axisModel.axis, {
            value: axisValue
          });
          cbParams.axisValueLabel = axisValueLabel;
          cbParams.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(cbParams.color), renderMode);
          var seriesTooltipResult = normalizeTooltipFormatResult(series.formatTooltip(dataIndex, true, null));
          var frag = seriesTooltipResult.frag;
          if (frag) {
            var valueFormatter = buildTooltipModel([series], globalTooltipModel).get("valueFormatter");
            axisSectionMarkup.blocks.push(valueFormatter ? extend({
              valueFormatter
            }, frag) : frag);
          }
          if (seriesTooltipResult.text) {
            markupTextArrLegacy.push(seriesTooltipResult.text);
          }
          cbParamsList.push(cbParams);
        });
      });
    });
    articleMarkup.blocks.reverse();
    markupTextArrLegacy.reverse();
    var positionExpr = e2.position;
    var orderMode = singleTooltipModel.get("order");
    var builtMarkupText = buildTooltipMarkup(articleMarkup, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), singleTooltipModel.get("textStyle"));
    builtMarkupText && markupTextArrLegacy.unshift(builtMarkupText);
    var blockBreak = renderMode === "richText" ? "\n\n" : "<br/>";
    var allMarkupText = markupTextArrLegacy.join(blockBreak);
    this._showOrMove(singleTooltipModel, function() {
      if (this._updateContentNotChangedOnAxis(dataByCoordSys, cbParamsList)) {
        this._updatePosition(singleTooltipModel, positionExpr, point[0], point[1], this._tooltipContent, cbParamsList);
      } else {
        this._showTooltipContent(singleTooltipModel, allMarkupText, cbParamsList, Math.random() + "", point[0], point[1], positionExpr, null, markupStyleCreator);
      }
    });
  };
  TooltipView2.prototype._showSeriesItemTooltip = function(e2, dispatcher, dispatchAction2) {
    var ecModel = this._ecModel;
    var ecData = getECData(dispatcher);
    var seriesIndex = ecData.seriesIndex;
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    var dataModel = ecData.dataModel || seriesModel;
    var dataIndex = ecData.dataIndex;
    var dataType = ecData.dataType;
    var data = dataModel.getData(dataType);
    var renderMode = this._renderMode;
    var positionDefault = e2.positionDefault;
    var tooltipModel = buildTooltipModel([data.getItemModel(dataIndex), dataModel, seriesModel && (seriesModel.coordinateSystem || {}).model], this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var tooltipTrigger = tooltipModel.get("trigger");
    if (tooltipTrigger != null && tooltipTrigger !== "item") {
      return;
    }
    var params = dataModel.getDataParams(dataIndex, dataType);
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    params.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(params.color), renderMode);
    var seriesTooltipResult = normalizeTooltipFormatResult(dataModel.formatTooltip(dataIndex, false, dataType));
    var orderMode = tooltipModel.get("order");
    var valueFormatter = tooltipModel.get("valueFormatter");
    var frag = seriesTooltipResult.frag;
    var markupText = frag ? buildTooltipMarkup(valueFormatter ? extend({
      valueFormatter
    }, frag) : frag, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), tooltipModel.get("textStyle")) : seriesTooltipResult.text;
    var asyncTicket = "item_" + dataModel.name + "_" + dataIndex;
    this._showOrMove(tooltipModel, function() {
      this._showTooltipContent(tooltipModel, markupText, params, asyncTicket, e2.offsetX, e2.offsetY, e2.position, e2.target, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      dataIndexInside: dataIndex,
      dataIndex: data.getRawIndex(dataIndex),
      seriesIndex,
      from: this.uid
    });
  };
  TooltipView2.prototype._showComponentItemTooltip = function(e2, el, dispatchAction2) {
    var ecData = getECData(el);
    var tooltipConfig = ecData.tooltipConfig;
    var tooltipOpt = tooltipConfig.option || {};
    if (isString(tooltipOpt)) {
      var content = tooltipOpt;
      tooltipOpt = {
        content,
        formatter: content
      };
    }
    var tooltipModelCascade = [tooltipOpt];
    var cmpt = this._ecModel.getComponent(ecData.componentMainType, ecData.componentIndex);
    if (cmpt) {
      tooltipModelCascade.push(cmpt);
    }
    tooltipModelCascade.push({
      formatter: tooltipOpt.content
    });
    var positionDefault = e2.positionDefault;
    var subTooltipModel = buildTooltipModel(tooltipModelCascade, this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var defaultHtml = subTooltipModel.get("content");
    var asyncTicket = Math.random() + "";
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    this._showOrMove(subTooltipModel, function() {
      var formatterParams = clone$4(subTooltipModel.get("formatterParams") || {});
      this._showTooltipContent(subTooltipModel, defaultHtml, formatterParams, asyncTicket, e2.offsetX, e2.offsetY, e2.position, el, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      from: this.uid
    });
  };
  TooltipView2.prototype._showTooltipContent = function(tooltipModel, defaultHtml, params, asyncTicket, x2, y2, positionExpr, el, markupStyleCreator) {
    this._ticket = "";
    if (!tooltipModel.get("showContent") || !tooltipModel.get("show")) {
      return;
    }
    var tooltipContent = this._tooltipContent;
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    var formatter = tooltipModel.get("formatter");
    positionExpr = positionExpr || tooltipModel.get("position");
    var html = defaultHtml;
    var nearPoint = this._getNearestPoint([x2, y2], params, tooltipModel.get("trigger"), tooltipModel.get("borderColor"));
    var nearPointColor = nearPoint.color;
    if (formatter) {
      if (isString(formatter)) {
        var useUTC = tooltipModel.ecModel.get("useUTC");
        var params0 = isArray$1(params) ? params[0] : params;
        var isTimeAxis = params0 && params0.axisType && params0.axisType.indexOf("time") >= 0;
        html = formatter;
        if (isTimeAxis) {
          html = format$1(params0.axisValue, html, useUTC);
        }
        html = formatTpl(html, params, true);
      } else if (isFunction(formatter)) {
        var callback = bind$1(function(cbTicket, html2) {
          if (cbTicket === this._ticket) {
            tooltipContent.setContent(html2, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
            this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
          }
        }, this);
        this._ticket = asyncTicket;
        html = formatter(params, asyncTicket, callback);
      } else {
        html = formatter;
      }
    }
    tooltipContent.setContent(html, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
    tooltipContent.show(tooltipModel, nearPointColor);
    this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
  };
  TooltipView2.prototype._getNearestPoint = function(point, tooltipDataParams, trigger2, borderColor) {
    if (trigger2 === "axis" || isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || (this._renderMode === "html" ? "#fff" : "none")
      };
    }
    if (!isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || tooltipDataParams.color || tooltipDataParams.borderColor
      };
    }
  };
  TooltipView2.prototype._updatePosition = function(tooltipModel, positionExpr, x2, y2, content, params, el) {
    var viewWidth = this._api.getWidth();
    var viewHeight = this._api.getHeight();
    positionExpr = positionExpr || tooltipModel.get("position");
    var contentSize = content.getSize();
    var align = tooltipModel.get("align");
    var vAlign = tooltipModel.get("verticalAlign");
    var rect = el && el.getBoundingRect().clone();
    el && rect.applyTransform(el.transform);
    if (isFunction(positionExpr)) {
      positionExpr = positionExpr([x2, y2], params, content.el, rect, {
        viewSize: [viewWidth, viewHeight],
        contentSize: contentSize.slice()
      });
    }
    if (isArray$1(positionExpr)) {
      x2 = parsePercent(positionExpr[0], viewWidth);
      y2 = parsePercent(positionExpr[1], viewHeight);
    } else if (isObject$4(positionExpr)) {
      var boxLayoutPosition = positionExpr;
      boxLayoutPosition.width = contentSize[0];
      boxLayoutPosition.height = contentSize[1];
      var layoutRect = getLayoutRect(boxLayoutPosition, {
        width: viewWidth,
        height: viewHeight
      });
      x2 = layoutRect.x;
      y2 = layoutRect.y;
      align = null;
      vAlign = null;
    } else if (isString(positionExpr) && el) {
      var pos = calcTooltipPosition(positionExpr, rect, contentSize, tooltipModel.get("borderWidth"));
      x2 = pos[0];
      y2 = pos[1];
    } else {
      var pos = refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, align ? null : 20, vAlign ? null : 20);
      x2 = pos[0];
      y2 = pos[1];
    }
    align && (x2 -= isCenterAlign(align) ? contentSize[0] / 2 : align === "right" ? contentSize[0] : 0);
    vAlign && (y2 -= isCenterAlign(vAlign) ? contentSize[1] / 2 : vAlign === "bottom" ? contentSize[1] : 0);
    if (shouldTooltipConfine(tooltipModel)) {
      var pos = confineTooltipPosition(x2, y2, content, viewWidth, viewHeight);
      x2 = pos[0];
      y2 = pos[1];
    }
    content.moveTo(x2, y2);
  };
  TooltipView2.prototype._updateContentNotChangedOnAxis = function(dataByCoordSys, cbParamsList) {
    var lastCoordSys = this._lastDataByCoordSys;
    var lastCbParamsList = this._cbParamsList;
    var contentNotChanged = !!lastCoordSys && lastCoordSys.length === dataByCoordSys.length;
    contentNotChanged && each$f(lastCoordSys, function(lastItemCoordSys, indexCoordSys) {
      var lastDataByAxis = lastItemCoordSys.dataByAxis || [];
      var thisItemCoordSys = dataByCoordSys[indexCoordSys] || {};
      var thisDataByAxis = thisItemCoordSys.dataByAxis || [];
      contentNotChanged = contentNotChanged && lastDataByAxis.length === thisDataByAxis.length;
      contentNotChanged && each$f(lastDataByAxis, function(lastItem, indexAxis) {
        var thisItem = thisDataByAxis[indexAxis] || {};
        var lastIndices = lastItem.seriesDataIndices || [];
        var newIndices = thisItem.seriesDataIndices || [];
        contentNotChanged = contentNotChanged && lastItem.value === thisItem.value && lastItem.axisType === thisItem.axisType && lastItem.axisId === thisItem.axisId && lastIndices.length === newIndices.length;
        contentNotChanged && each$f(lastIndices, function(lastIdxItem, j) {
          var newIdxItem = newIndices[j];
          contentNotChanged = contentNotChanged && lastIdxItem.seriesIndex === newIdxItem.seriesIndex && lastIdxItem.dataIndex === newIdxItem.dataIndex;
        });
        lastCbParamsList && each$f(lastItem.seriesDataIndices, function(idxItem) {
          var seriesIdx = idxItem.seriesIndex;
          var cbParams = cbParamsList[seriesIdx];
          var lastCbParams = lastCbParamsList[seriesIdx];
          if (cbParams && lastCbParams && lastCbParams.data !== cbParams.data) {
            contentNotChanged = false;
          }
        });
      });
    });
    this._lastDataByCoordSys = dataByCoordSys;
    this._cbParamsList = cbParamsList;
    return !!contentNotChanged;
  };
  TooltipView2.prototype._hide = function(dispatchAction2) {
    this._lastDataByCoordSys = null;
    dispatchAction2({
      type: "hideTip",
      from: this.uid
    });
  };
  TooltipView2.prototype.dispose = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    clear$1(this, "_updatePosition");
    this._tooltipContent.dispose();
    unregister("itemTooltip", api);
  };
  TooltipView2.type = "tooltip";
  return TooltipView2;
}(ComponentView$1);
function buildTooltipModel(modelCascade, globalTooltipModel, defaultTooltipOption) {
  var ecModel = globalTooltipModel.ecModel;
  var resultModel;
  if (defaultTooltipOption) {
    resultModel = new Model$1(defaultTooltipOption, ecModel, ecModel);
    resultModel = new Model$1(globalTooltipModel.option, resultModel, ecModel);
  } else {
    resultModel = globalTooltipModel;
  }
  for (var i = modelCascade.length - 1; i >= 0; i--) {
    var tooltipOpt = modelCascade[i];
    if (tooltipOpt) {
      if (tooltipOpt instanceof Model$1) {
        tooltipOpt = tooltipOpt.get("tooltip", true);
      }
      if (isString(tooltipOpt)) {
        tooltipOpt = {
          formatter: tooltipOpt
        };
      }
      if (tooltipOpt) {
        resultModel = new Model$1(tooltipOpt, resultModel, ecModel);
      }
    }
  }
  return resultModel;
}
function makeDispatchAction(payload, api) {
  return payload.dispatchAction || bind$1(api.dispatchAction, api);
}
function refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, gapH, gapV) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  if (gapH != null) {
    if (x2 + width + gapH + 2 > viewWidth) {
      x2 -= width + gapH;
    } else {
      x2 += gapH;
    }
  }
  if (gapV != null) {
    if (y2 + height + gapV > viewHeight) {
      y2 -= height + gapV;
    } else {
      y2 += gapV;
    }
  }
  return [x2, y2];
}
function confineTooltipPosition(x2, y2, content, viewWidth, viewHeight) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  x2 = Math.min(x2 + width, viewWidth) - width;
  y2 = Math.min(y2 + height, viewHeight) - height;
  x2 = Math.max(x2, 0);
  y2 = Math.max(y2, 0);
  return [x2, y2];
}
function calcTooltipPosition(position2, rect, contentSize, borderWidth) {
  var domWidth = contentSize[0];
  var domHeight = contentSize[1];
  var offset = Math.ceil(Math.SQRT2 * borderWidth) + 8;
  var x2 = 0;
  var y2 = 0;
  var rectWidth = rect.width;
  var rectHeight = rect.height;
  switch (position2) {
    case "inside":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "top":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y - domHeight - offset;
      break;
    case "bottom":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight + offset;
      break;
    case "left":
      x2 = rect.x - domWidth - offset;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "right":
      x2 = rect.x + rectWidth + offset;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
  }
  return [x2, y2];
}
function isCenterAlign(align) {
  return align === "center" || align === "middle";
}
function findComponentReference(payload, ecModel, api) {
  var queryOptionMap = preParseFinder(payload).queryOptionMap;
  var componentMainType = queryOptionMap.keys()[0];
  if (!componentMainType || componentMainType === "series") {
    return;
  }
  var queryResult = queryReferringComponents(ecModel, componentMainType, queryOptionMap.get(componentMainType), {
    useDefault: false,
    enableAll: false,
    enableNone: false
  });
  var model = queryResult.models[0];
  if (!model) {
    return;
  }
  var view = api.getViewOfComponentModel(model);
  var el;
  view.group.traverse(function(subEl) {
    var tooltipConfig = getECData(subEl).tooltipConfig;
    if (tooltipConfig && tooltipConfig.name === payload.name) {
      el = subEl;
      return true;
    }
  });
  if (el) {
    return {
      componentMainType,
      componentIndex: model.componentIndex,
      el
    };
  }
}
var TooltipView$1 = TooltipView;
function install$i(registers) {
  use(install$q);
  registers.registerComponentModel(TooltipModel$1);
  registers.registerComponentView(TooltipView$1);
  registers.registerAction({
    type: "showTip",
    event: "showTip",
    update: "tooltip:manuallyShowTip"
  }, noop);
  registers.registerAction({
    type: "hideTip",
    event: "hideTip",
    update: "tooltip:manuallyHideTip"
  }, noop);
}
var DEFAULT_TOOLBOX_BTNS = ["rect", "polygon", "keep", "clear"];
function brushPreprocessor(option, isNew) {
  var brushComponents = normalizeToArray(option ? option.brush : []);
  if (!brushComponents.length) {
    return;
  }
  var brushComponentSpecifiedBtns = [];
  each$f(brushComponents, function(brushOpt) {
    var tbs = brushOpt.hasOwnProperty("toolbox") ? brushOpt.toolbox : [];
    if (tbs instanceof Array) {
      brushComponentSpecifiedBtns = brushComponentSpecifiedBtns.concat(tbs);
    }
  });
  var toolbox = option && option.toolbox;
  if (isArray$1(toolbox)) {
    toolbox = toolbox[0];
  }
  if (!toolbox) {
    toolbox = {
      feature: {}
    };
    option.toolbox = [toolbox];
  }
  var toolboxFeature = toolbox.feature || (toolbox.feature = {});
  var toolboxBrush = toolboxFeature.brush || (toolboxFeature.brush = {});
  var brushTypes = toolboxBrush.type || (toolboxBrush.type = []);
  brushTypes.push.apply(brushTypes, brushComponentSpecifiedBtns);
  removeDuplicate(brushTypes);
  if (isNew && !brushTypes.length) {
    brushTypes.push.apply(brushTypes, DEFAULT_TOOLBOX_BTNS);
  }
}
function removeDuplicate(arr) {
  var map2 = {};
  each$f(arr, function(val) {
    map2[val] = 1;
  });
  arr.length = 0;
  each$f(map2, function(flag, val) {
    arr.push(val);
  });
}
var each$4 = each$f;
function hasKeys(obj) {
  if (obj) {
    for (var name_1 in obj) {
      if (obj.hasOwnProperty(name_1)) {
        return true;
      }
    }
  }
}
function createVisualMappings(option, stateList, supplementVisualOption) {
  var visualMappings = {};
  each$4(stateList, function(state) {
    var mappings = visualMappings[state] = createMappings();
    each$4(option[state], function(visualData, visualType) {
      if (!VisualMapping$1.isValidType(visualType)) {
        return;
      }
      var mappingOption = {
        type: visualType,
        visual: visualData
      };
      supplementVisualOption && supplementVisualOption(mappingOption, state);
      mappings[visualType] = new VisualMapping$1(mappingOption);
      if (visualType === "opacity") {
        mappingOption = clone$4(mappingOption);
        mappingOption.type = "colorAlpha";
        mappings.__hidden.__alphaForOpacity = new VisualMapping$1(mappingOption);
      }
    });
  });
  return visualMappings;
  function createMappings() {
    var Creater = function() {
    };
    Creater.prototype.__hidden = Creater.prototype;
    var obj = new Creater();
    return obj;
  }
}
function replaceVisualOption(thisOption, newOption, keys2) {
  var has2;
  each$f(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      has2 = true;
    }
  });
  has2 && each$f(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      thisOption[key] = clone$4(newOption[key]);
    } else {
      delete thisOption[key];
    }
  });
}
function applyVisual(stateList, visualMappings, data, getValueState, scope, dimension) {
  var visualTypesMap = {};
  each$f(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  var dataIndex;
  function getVisual(key) {
    return getItemVisualFromData(data, dataIndex, key);
  }
  function setVisual(key, value) {
    setItemVisualFromData(data, dataIndex, key, value);
  }
  if (dimension == null) {
    data.each(eachItem);
  } else {
    data.each([dimension], eachItem);
  }
  function eachItem(valueOrIndex, index2) {
    dataIndex = dimension == null ? valueOrIndex : index2;
    var rawDataItem = data.getRawDataItem(dataIndex);
    if (rawDataItem && rawDataItem.visualMap === false) {
      return;
    }
    var valueState = getValueState.call(scope, valueOrIndex);
    var mappings = visualMappings[valueState];
    var visualTypes = visualTypesMap[valueState];
    for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
      var type4 = visualTypes[i];
      mappings[type4] && mappings[type4].applyVisual(valueOrIndex, getVisual, setVisual);
    }
  }
}
function incrementalApplyVisual(stateList, visualMappings, getValueState, dim) {
  var visualTypesMap = {};
  each$f(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  return {
    progress: function progress(params, data) {
      var dimIndex;
      if (dim != null) {
        dimIndex = data.getDimensionIndex(dim);
      }
      function getVisual(key) {
        return getItemVisualFromData(data, dataIndex, key);
      }
      function setVisual(key, value2) {
        setItemVisualFromData(data, dataIndex, key, value2);
      }
      var dataIndex;
      var store = data.getStore();
      while ((dataIndex = params.next()) != null) {
        var rawDataItem = data.getRawDataItem(dataIndex);
        if (rawDataItem && rawDataItem.visualMap === false) {
          continue;
        }
        var value = dim != null ? store.get(dimIndex, dataIndex) : dataIndex;
        var valueState = getValueState(value);
        var mappings = visualMappings[valueState];
        var visualTypes = visualTypesMap[valueState];
        for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
          var type4 = visualTypes[i];
          mappings[type4] && mappings[type4].applyVisual(value, getVisual, setVisual);
        }
      }
    }
  };
}
function makeBrushCommonSelectorForSeries(area) {
  var brushType = area.brushType;
  var selectors = {
    point: function(itemLayout) {
      return selector[brushType].point(itemLayout, selectors, area);
    },
    rect: function(itemLayout) {
      return selector[brushType].rect(itemLayout, selectors, area);
    }
  };
  return selectors;
}
var selector = {
  lineX: getLineSelectors(0),
  lineY: getLineSelectors(1),
  rect: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.intersect(itemLayout);
    }
  },
  polygon: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]) && contain(area.range, itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      var points2 = area.range;
      if (!itemLayout || points2.length <= 1) {
        return false;
      }
      var x2 = itemLayout.x;
      var y2 = itemLayout.y;
      var width = itemLayout.width;
      var height = itemLayout.height;
      var p2 = points2[0];
      if (contain(points2, x2, y2) || contain(points2, x2 + width, y2) || contain(points2, x2, y2 + height) || contain(points2, x2 + width, y2 + height) || BoundingRect$1.create(itemLayout).contain(p2[0], p2[1]) || linePolygonIntersect(x2, y2, x2 + width, y2, points2) || linePolygonIntersect(x2, y2, x2, y2 + height, points2) || linePolygonIntersect(x2 + width, y2, x2 + width, y2 + height, points2) || linePolygonIntersect(x2, y2 + height, x2 + width, y2 + height, points2)) {
        return true;
      }
    }
  }
};
function getLineSelectors(xyIndex) {
  var xy = ["x", "y"];
  var wh = ["width", "height"];
  return {
    point: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var p2 = itemLayout[xyIndex];
        return inLineRange(p2, range3);
      }
    },
    rect: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var layoutRange = [itemLayout[xy[xyIndex]], itemLayout[xy[xyIndex]] + itemLayout[wh[xyIndex]]];
        layoutRange[1] < layoutRange[0] && layoutRange.reverse();
        return inLineRange(layoutRange[0], range3) || inLineRange(layoutRange[1], range3) || inLineRange(range3[0], layoutRange) || inLineRange(range3[1], layoutRange);
      }
    }
  };
}
function inLineRange(p2, range3) {
  return range3[0] <= p2 && p2 <= range3[1];
}
var STATE_LIST = ["inBrush", "outOfBrush"];
var DISPATCH_METHOD = "__ecBrushSelect";
var DISPATCH_FLAG = "__ecInBrushSelectEvent";
function layoutCovers(ecModel) {
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    var brushTargetManager = brushModel.brushTargetManager = new BrushTargetManager$1(brushModel.option, ecModel);
    brushTargetManager.setInputRanges(brushModel.areas, ecModel);
  });
}
function brushVisual(ecModel, api, payload) {
  var brushSelected = [];
  var throttleType;
  var throttleDelay;
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    payload && payload.type === "takeGlobalCursor" && brushModel.setBrushOption(payload.key === "brush" ? payload.brushOption : {
      brushType: false
    });
  });
  layoutCovers(ecModel);
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel, brushIndex) {
    var thisBrushSelected = {
      brushId: brushModel.id,
      brushIndex,
      brushName: brushModel.name,
      areas: clone$4(brushModel.areas),
      selected: []
    };
    brushSelected.push(thisBrushSelected);
    var brushOption = brushModel.option;
    var brushLink = brushOption.brushLink;
    var linkedSeriesMap = [];
    var selectedDataIndexForLink = [];
    var rangeInfoBySeries = [];
    var hasBrushExists = false;
    if (!brushIndex) {
      throttleType = brushOption.throttleType;
      throttleDelay = brushOption.throttleDelay;
    }
    var areas = map$1(brushModel.areas, function(area) {
      var builder = boundingRectBuilders[area.brushType];
      var selectableArea = defaults({
        boundingRect: builder ? builder(area) : void 0
      }, area);
      selectableArea.selectors = makeBrushCommonSelectorForSeries(selectableArea);
      return selectableArea;
    });
    var visualMappings = createVisualMappings(brushModel.option, STATE_LIST, function(mappingOption) {
      mappingOption.mappingMethod = "fixed";
    });
    isArray$1(brushLink) && each$f(brushLink, function(seriesIndex) {
      linkedSeriesMap[seriesIndex] = 1;
    });
    function linkOthers(seriesIndex) {
      return brushLink === "all" || !!linkedSeriesMap[seriesIndex];
    }
    function brushed(rangeInfoList) {
      return !!rangeInfoList.length;
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var rangeInfoList = rangeInfoBySeries[seriesIndex] = [];
      seriesModel.subType === "parallel" ? stepAParallel(seriesModel, seriesIndex) : stepAOthers(seriesModel, seriesIndex, rangeInfoList);
    });
    function stepAParallel(seriesModel, seriesIndex) {
      var coordSys = seriesModel.coordinateSystem;
      hasBrushExists = hasBrushExists || coordSys.hasAxisBrushed();
      linkOthers(seriesIndex) && coordSys.eachActiveState(seriesModel.getData(), function(activeState, dataIndex) {
        activeState === "active" && (selectedDataIndexForLink[dataIndex] = 1);
      });
    }
    function stepAOthers(seriesModel, seriesIndex, rangeInfoList) {
      if (!seriesModel.brushSelector || brushModelNotControll(brushModel, seriesIndex)) {
        return;
      }
      each$f(areas, function(area) {
        if (brushModel.brushTargetManager.controlSeries(area, seriesModel, ecModel)) {
          rangeInfoList.push(area);
        }
        hasBrushExists = hasBrushExists || brushed(rangeInfoList);
      });
      if (linkOthers(seriesIndex) && brushed(rangeInfoList)) {
        var data_1 = seriesModel.getData();
        data_1.each(function(dataIndex) {
          if (checkInRange(seriesModel, rangeInfoList, data_1, dataIndex)) {
            selectedDataIndexForLink[dataIndex] = 1;
          }
        });
      }
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var seriesBrushSelected = {
        seriesId: seriesModel.id,
        seriesIndex,
        seriesName: seriesModel.name,
        dataIndex: []
      };
      thisBrushSelected.selected.push(seriesBrushSelected);
      var rangeInfoList = rangeInfoBySeries[seriesIndex];
      var data = seriesModel.getData();
      var getValueState = linkOthers(seriesIndex) ? function(dataIndex) {
        return selectedDataIndexForLink[dataIndex] ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      } : function(dataIndex) {
        return checkInRange(seriesModel, rangeInfoList, data, dataIndex) ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      };
      (linkOthers(seriesIndex) ? hasBrushExists : brushed(rangeInfoList)) && applyVisual(STATE_LIST, visualMappings, data, getValueState);
    });
  });
  dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload);
}
function dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload) {
  if (!payload) {
    return;
  }
  var zr = api.getZr();
  if (zr[DISPATCH_FLAG]) {
    return;
  }
  if (!zr[DISPATCH_METHOD]) {
    zr[DISPATCH_METHOD] = doDispatch;
  }
  var fn = createOrUpdate(zr, DISPATCH_METHOD, throttleDelay, throttleType);
  fn(api, brushSelected);
}
function doDispatch(api, brushSelected) {
  if (!api.isDisposed()) {
    var zr = api.getZr();
    zr[DISPATCH_FLAG] = true;
    api.dispatchAction({
      type: "brushSelect",
      batch: brushSelected
    });
    zr[DISPATCH_FLAG] = false;
  }
}
function checkInRange(seriesModel, rangeInfoList, data, dataIndex) {
  for (var i = 0, len2 = rangeInfoList.length; i < len2; i++) {
    var area = rangeInfoList[i];
    if (seriesModel.brushSelector(dataIndex, data, area.selectors, area)) {
      return true;
    }
  }
}
function brushModelNotControll(brushModel, seriesIndex) {
  var seriesIndices = brushModel.option.seriesIndex;
  return seriesIndices != null && seriesIndices !== "all" && (isArray$1(seriesIndices) ? indexOf(seriesIndices, seriesIndex) < 0 : seriesIndex !== seriesIndices);
}
var boundingRectBuilders = {
  rect: function(area) {
    return getBoundingRectFromMinMax(area.range);
  },
  polygon: function(area) {
    var minMax;
    var range3 = area.range;
    for (var i = 0, len2 = range3.length; i < len2; i++) {
      minMax = minMax || [[Infinity, -Infinity], [Infinity, -Infinity]];
      var rg = range3[i];
      rg[0] < minMax[0][0] && (minMax[0][0] = rg[0]);
      rg[0] > minMax[0][1] && (minMax[0][1] = rg[0]);
      rg[1] < minMax[1][0] && (minMax[1][0] = rg[1]);
      rg[1] > minMax[1][1] && (minMax[1][1] = rg[1]);
    }
    return minMax && getBoundingRectFromMinMax(minMax);
  }
};
function getBoundingRectFromMinMax(minMax) {
  return new BoundingRect$1(minMax[0][0], minMax[1][0], minMax[0][1] - minMax[0][0], minMax[1][1] - minMax[1][0]);
}
var BrushView = function(_super) {
  __extends(BrushView2, _super);
  function BrushView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushView2.type;
    return _this;
  }
  BrushView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
    this.model;
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this)).mount();
  };
  BrushView2.prototype.render = function(brushModel, ecModel, api, payload) {
    this.model = brushModel;
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateTransform = function(brushModel, ecModel, api, payload) {
    layoutCovers(ecModel);
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateVisual = function(brushModel, ecModel, api, payload) {
    this.updateTransform(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateView = function(brushModel, ecModel, api, payload) {
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype._updateController = function(brushModel, ecModel, api, payload) {
    (!payload || payload.$from !== brushModel.id) && this._brushController.setPanels(brushModel.brushTargetManager.makePanelOpts(api)).enableBrush(brushModel.brushOption).updateCovers(brushModel.areas.slice());
  };
  BrushView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  BrushView2.prototype._onBrush = function(eventParam) {
    var modelId = this.model.id;
    var areas = this.model.brushTargetManager.setOutputRanges(eventParam.areas, this.ecModel);
    (!eventParam.isEnd || eventParam.removeOnClick) && this.api.dispatchAction({
      type: "brush",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
    eventParam.isEnd && this.api.dispatchAction({
      type: "brushEnd",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
  };
  BrushView2.type = "brush";
  return BrushView2;
}(ComponentView$1);
var BrushView$1 = BrushView;
var DEFAULT_OUT_OF_BRUSH_COLOR = "#ddd";
var BrushModel = function(_super) {
  __extends(BrushModel2, _super);
  function BrushModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushModel2.type;
    _this.areas = [];
    _this.brushOption = {};
    return _this;
  }
  BrushModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, ["inBrush", "outOfBrush"]);
    var inBrush = thisOption.inBrush = thisOption.inBrush || {};
    thisOption.outOfBrush = thisOption.outOfBrush || {
      color: DEFAULT_OUT_OF_BRUSH_COLOR
    };
    if (!inBrush.hasOwnProperty("liftZ")) {
      inBrush.liftZ = 5;
    }
  };
  BrushModel2.prototype.setAreas = function(areas) {
    if (!areas) {
      return;
    }
    this.areas = map$1(areas, function(area) {
      return generateBrushOption(this.option, area);
    }, this);
  };
  BrushModel2.prototype.setBrushOption = function(brushOption) {
    this.brushOption = generateBrushOption(this.option, brushOption);
    this.brushType = this.brushOption.brushType;
  };
  BrushModel2.type = "brush";
  BrushModel2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"];
  BrushModel2.defaultOption = {
    seriesIndex: "all",
    brushType: "rect",
    brushMode: "single",
    transformable: true,
    brushStyle: {
      borderWidth: 1,
      color: "rgba(210,219,238,0.3)",
      borderColor: "#D2DBEE"
    },
    throttleType: "fixRate",
    throttleDelay: 0,
    removeOnClick: true,
    z: 1e4
  };
  return BrushModel2;
}(ComponentModel$1);
function generateBrushOption(option, brushOption) {
  return merge({
    brushType: option.brushType,
    brushMode: option.brushMode,
    transformable: option.transformable,
    brushStyle: new Model$1(option.brushStyle).getItemStyle(),
    removeOnClick: option.removeOnClick,
    z: option.z
  }, brushOption, true);
}
var BrushModel$1 = BrushModel;
var ICON_TYPES = ["rect", "polygon", "lineX", "lineY", "keep", "clear"];
var BrushFeature = function(_super) {
  __extends(BrushFeature2, _super);
  function BrushFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  BrushFeature2.prototype.render = function(featureModel, ecModel, api) {
    var brushType;
    var brushMode;
    var isBrushed;
    ecModel.eachComponent({
      mainType: "brush"
    }, function(brushModel) {
      brushType = brushModel.brushType;
      brushMode = brushModel.brushOption.brushMode || "single";
      isBrushed = isBrushed || !!brushModel.areas.length;
    });
    this._brushType = brushType;
    this._brushMode = brushMode;
    each$f(featureModel.get("type", true), function(type4) {
      featureModel.setIconStatus(type4, (type4 === "keep" ? brushMode === "multiple" : type4 === "clear" ? isBrushed : type4 === brushType) ? "emphasis" : "normal");
    });
  };
  BrushFeature2.prototype.updateView = function(featureModel, ecModel, api) {
    this.render(featureModel, ecModel, api);
  };
  BrushFeature2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon", true);
    var icons = {};
    each$f(model.get("type", true), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  BrushFeature2.prototype.onclick = function(ecModel, api, type4) {
    var brushType = this._brushType;
    var brushMode = this._brushMode;
    if (type4 === "clear") {
      api.dispatchAction({
        type: "axisAreaSelect",
        intervals: []
      });
      api.dispatchAction({
        type: "brush",
        command: "clear",
        areas: []
      });
    } else {
      api.dispatchAction({
        type: "takeGlobalCursor",
        key: "brush",
        brushOption: {
          brushType: type4 === "keep" ? brushType : brushType === type4 ? false : type4,
          brushMode: type4 === "keep" ? brushMode === "multiple" ? "single" : "multiple" : brushMode
        }
      });
    }
  };
  BrushFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: ICON_TYPES.slice(),
      icon: {
        rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13",
        polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2",
        lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4",
        lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4",
        keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z",
        clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "brush", "title"])
    };
    return defaultOption2;
  };
  return BrushFeature2;
}(ToolboxFeature);
var BrushFeature$1 = BrushFeature;
function install$h(registers) {
  registers.registerComponentView(BrushView$1);
  registers.registerComponentModel(BrushModel$1);
  registers.registerPreprocessor(brushPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, brushVisual);
  registers.registerAction({
    type: "brush",
    event: "brush",
    update: "updateVisual"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "brush",
      query: payload
    }, function(brushModel) {
      brushModel.setAreas(payload.areas);
    });
  });
  registers.registerAction({
    type: "brushSelect",
    event: "brushSelected",
    update: "none"
  }, noop);
  registers.registerAction({
    type: "brushEnd",
    event: "brushEnd",
    update: "none"
  }, noop);
  registerFeature("brush", BrushFeature$1);
}
var TitleModel = function(_super) {
  __extends(TitleModel2, _super);
  function TitleModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  TitleModel2.type = "title";
  TitleModel2.defaultOption = {
    z: 6,
    show: true,
    text: "",
    target: "blank",
    subtext: "",
    subtarget: "blank",
    left: 0,
    top: 0,
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    textStyle: {
      fontSize: 18,
      fontWeight: "bold",
      color: "#464646"
    },
    subtextStyle: {
      fontSize: 12,
      color: "#6E7079"
    }
  };
  return TitleModel2;
}(ComponentModel$1);
var TitleView = function(_super) {
  __extends(TitleView2, _super);
  function TitleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleView2.type;
    return _this;
  }
  TitleView2.prototype.render = function(titleModel, ecModel, api) {
    this.group.removeAll();
    if (!titleModel.get("show")) {
      return;
    }
    var group = this.group;
    var textStyleModel = titleModel.getModel("textStyle");
    var subtextStyleModel = titleModel.getModel("subtextStyle");
    var textAlign = titleModel.get("textAlign");
    var textVerticalAlign = retrieve2(titleModel.get("textBaseline"), titleModel.get("textVerticalAlign"));
    var textEl = new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: titleModel.get("text"),
        fill: textStyleModel.getTextColor()
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var textRect = textEl.getBoundingRect();
    var subText = titleModel.get("subtext");
    var subTextEl = new ZRText$1({
      style: createTextStyle(subtextStyleModel, {
        text: subText,
        fill: subtextStyleModel.getTextColor(),
        y: textRect.height + titleModel.get("itemGap"),
        verticalAlign: "top"
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var link = titleModel.get("link");
    var sublink = titleModel.get("sublink");
    var triggerEvent = titleModel.get("triggerEvent", true);
    textEl.silent = !link && !triggerEvent;
    subTextEl.silent = !sublink && !triggerEvent;
    if (link) {
      textEl.on("click", function() {
        windowOpen(link, "_" + titleModel.get("target"));
      });
    }
    if (sublink) {
      subTextEl.on("click", function() {
        windowOpen(sublink, "_" + titleModel.get("subtarget"));
      });
    }
    getECData(textEl).eventData = getECData(subTextEl).eventData = triggerEvent ? {
      componentType: "title",
      componentIndex: titleModel.componentIndex
    } : null;
    group.add(textEl);
    subText && group.add(subTextEl);
    var groupRect = group.getBoundingRect();
    var layoutOption = titleModel.getBoxLayoutParams();
    layoutOption.width = groupRect.width;
    layoutOption.height = groupRect.height;
    var layoutRect = getLayoutRect(layoutOption, {
      width: api.getWidth(),
      height: api.getHeight()
    }, titleModel.get("padding"));
    if (!textAlign) {
      textAlign = titleModel.get("left") || titleModel.get("right");
      if (textAlign === "middle") {
        textAlign = "center";
      }
      if (textAlign === "right") {
        layoutRect.x += layoutRect.width;
      } else if (textAlign === "center") {
        layoutRect.x += layoutRect.width / 2;
      }
    }
    if (!textVerticalAlign) {
      textVerticalAlign = titleModel.get("top") || titleModel.get("bottom");
      if (textVerticalAlign === "center") {
        textVerticalAlign = "middle";
      }
      if (textVerticalAlign === "bottom") {
        layoutRect.y += layoutRect.height;
      } else if (textVerticalAlign === "middle") {
        layoutRect.y += layoutRect.height / 2;
      }
      textVerticalAlign = textVerticalAlign || "top";
    }
    group.x = layoutRect.x;
    group.y = layoutRect.y;
    group.markRedraw();
    var alignStyle = {
      align: textAlign,
      verticalAlign: textVerticalAlign
    };
    textEl.setStyle(alignStyle);
    subTextEl.setStyle(alignStyle);
    groupRect = group.getBoundingRect();
    var padding = layoutRect.margin;
    var style = titleModel.getItemStyle(["color", "opacity"]);
    style.fill = titleModel.get("backgroundColor");
    var rect = new Rect$3({
      shape: {
        x: groupRect.x - padding[3],
        y: groupRect.y - padding[0],
        width: groupRect.width + padding[1] + padding[3],
        height: groupRect.height + padding[0] + padding[2],
        r: titleModel.get("borderRadius")
      },
      style,
      subPixelOptimize: true,
      silent: true
    });
    group.add(rect);
  };
  TitleView2.type = "title";
  return TitleView2;
}(ComponentView$1);
function install$g(registers) {
  registers.registerComponentModel(TitleModel);
  registers.registerComponentView(TitleView);
}
var TimelineModel = function(_super) {
  __extends(TimelineModel2, _super);
  function TimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineModel2.type;
    _this.layoutMode = "box";
    return _this;
  }
  TimelineModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._initData();
  };
  TimelineModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this._initData();
  };
  TimelineModel2.prototype.setCurrentIndex = function(currentIndex) {
    if (currentIndex == null) {
      currentIndex = this.option.currentIndex;
    }
    var count2 = this._data.count();
    if (this.option.loop) {
      currentIndex = (currentIndex % count2 + count2) % count2;
    } else {
      currentIndex >= count2 && (currentIndex = count2 - 1);
      currentIndex < 0 && (currentIndex = 0);
    }
    this.option.currentIndex = currentIndex;
  };
  TimelineModel2.prototype.getCurrentIndex = function() {
    return this.option.currentIndex;
  };
  TimelineModel2.prototype.isIndexMax = function() {
    return this.getCurrentIndex() >= this._data.count() - 1;
  };
  TimelineModel2.prototype.setPlayState = function(state) {
    this.option.autoPlay = !!state;
  };
  TimelineModel2.prototype.getPlayState = function() {
    return !!this.option.autoPlay;
  };
  TimelineModel2.prototype._initData = function() {
    var thisOption = this.option;
    var dataArr = thisOption.data || [];
    var axisType = thisOption.axisType;
    var names2 = this._names = [];
    var processedDataArr;
    if (axisType === "category") {
      processedDataArr = [];
      each$f(dataArr, function(item, index2) {
        var value = convertOptionIdName(getDataItemValue(item), "");
        var newItem;
        if (isObject$4(item)) {
          newItem = clone$4(item);
          newItem.value = index2;
        } else {
          newItem = index2;
        }
        processedDataArr.push(newItem);
        names2.push(value);
      });
    } else {
      processedDataArr = dataArr;
    }
    var dimType = {
      category: "ordinal",
      time: "time",
      value: "number"
    }[axisType] || "number";
    var data = this._data = new SeriesData$1([{
      name: "value",
      type: dimType
    }], this);
    data.initData(processedDataArr, names2);
  };
  TimelineModel2.prototype.getData = function() {
    return this._data;
  };
  TimelineModel2.prototype.getCategories = function() {
    if (this.get("axisType") === "category") {
      return this._names.slice();
    }
  };
  TimelineModel2.type = "timeline";
  TimelineModel2.defaultOption = {
    z: 4,
    show: true,
    axisType: "time",
    realtime: true,
    left: "20%",
    top: null,
    right: "20%",
    bottom: 0,
    width: null,
    height: 40,
    padding: 5,
    controlPosition: "left",
    autoPlay: false,
    rewind: false,
    loop: true,
    playInterval: 2e3,
    currentIndex: 0,
    itemStyle: {},
    label: {
      color: "#000"
    },
    data: []
  };
  return TimelineModel2;
}(ComponentModel$1);
var TimelineModel$1 = TimelineModel;
var SliderTimelineModel = function(_super) {
  __extends(SliderTimelineModel2, _super);
  function SliderTimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineModel2.type;
    return _this;
  }
  SliderTimelineModel2.type = "timeline.slider";
  SliderTimelineModel2.defaultOption = inheritDefaultOption(TimelineModel$1.defaultOption, {
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    orient: "horizontal",
    inverse: false,
    tooltip: {
      trigger: "item"
    },
    symbol: "circle",
    symbolSize: 12,
    lineStyle: {
      show: true,
      width: 2,
      color: "#DAE1F5"
    },
    label: {
      position: "auto",
      show: true,
      interval: "auto",
      rotate: 0,
      color: "#A4B1D7"
    },
    itemStyle: {
      color: "#A4B1D7",
      borderWidth: 1
    },
    checkpointStyle: {
      symbol: "circle",
      symbolSize: 15,
      color: "#316bf3",
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0, 0, 0, 0.3)",
      animation: true,
      animationDuration: 300,
      animationEasing: "quinticInOut"
    },
    controlStyle: {
      show: true,
      showPlayBtn: true,
      showPrevBtn: true,
      showNextBtn: true,
      itemSize: 24,
      itemGap: 12,
      position: "left",
      playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z",
      stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z",
      nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z",
      prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z",
      prevBtnSize: 18,
      nextBtnSize: 18,
      color: "#A4B1D7",
      borderColor: "#A4B1D7",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true,
        color: "#6f778d"
      },
      itemStyle: {
        color: "#316BF3"
      },
      controlStyle: {
        color: "#316BF3",
        borderColor: "#316BF3",
        borderWidth: 2
      }
    },
    progress: {
      lineStyle: {
        color: "#316BF3"
      },
      itemStyle: {
        color: "#316BF3"
      },
      label: {
        color: "#6f778d"
      }
    },
    data: []
  });
  return SliderTimelineModel2;
}(TimelineModel$1);
mixin(SliderTimelineModel, DataFormatMixin.prototype);
var SliderTimelineModel$1 = SliderTimelineModel;
var TimelineView = function(_super) {
  __extends(TimelineView2, _super);
  function TimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineView2.type;
    return _this;
  }
  TimelineView2.type = "timeline";
  return TimelineView2;
}(ComponentView$1);
var TimelineView$1 = TimelineView;
var TimelineAxis = function(_super) {
  __extends(TimelineAxis2, _super);
  function TimelineAxis2(dim, scale2, coordExtent, axisType) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    return _this;
  }
  TimelineAxis2.prototype.getLabelModel = function() {
    return this.model.getModel("label");
  };
  TimelineAxis2.prototype.isHorizontal = function() {
    return this.model.get("orient") === "horizontal";
  };
  return TimelineAxis2;
}(Axis$1);
var TimelineAxis$1 = TimelineAxis;
var PI = Math.PI;
var labelDataIndexStore = makeInner();
var SliderTimelineView = function(_super) {
  __extends(SliderTimelineView2, _super);
  function SliderTimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineView2.type;
    return _this;
  }
  SliderTimelineView2.prototype.init = function(ecModel, api) {
    this.api = api;
  };
  SliderTimelineView2.prototype.render = function(timelineModel, ecModel, api) {
    this.model = timelineModel;
    this.api = api;
    this.ecModel = ecModel;
    this.group.removeAll();
    if (timelineModel.get("show", true)) {
      var layoutInfo_1 = this._layout(timelineModel, api);
      var mainGroup_1 = this._createGroup("_mainGroup");
      var labelGroup = this._createGroup("_labelGroup");
      var axis_1 = this._axis = this._createAxis(layoutInfo_1, timelineModel);
      timelineModel.formatTooltip = function(dataIndex) {
        var name = axis_1.scale.getLabel({
          value: dataIndex
        });
        return createTooltipMarkup("nameValue", {
          noName: true,
          value: name
        });
      };
      each$f(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(name) {
        this["_render" + name](layoutInfo_1, mainGroup_1, axis_1, timelineModel);
      }, this);
      this._renderAxisLabel(layoutInfo_1, labelGroup, axis_1, timelineModel);
      this._position(layoutInfo_1, timelineModel);
    }
    this._doPlayStop();
    this._updateTicksStatus();
  };
  SliderTimelineView2.prototype.remove = function() {
    this._clearTimer();
    this.group.removeAll();
  };
  SliderTimelineView2.prototype.dispose = function() {
    this._clearTimer();
  };
  SliderTimelineView2.prototype._layout = function(timelineModel, api) {
    var labelPosOpt = timelineModel.get(["label", "position"]);
    var orient = timelineModel.get("orient");
    var viewRect2 = getViewRect(timelineModel, api);
    var parsedLabelPos;
    if (labelPosOpt == null || labelPosOpt === "auto") {
      parsedLabelPos = orient === "horizontal" ? viewRect2.y + viewRect2.height / 2 < api.getHeight() / 2 ? "-" : "+" : viewRect2.x + viewRect2.width / 2 < api.getWidth() / 2 ? "+" : "-";
    } else if (isString(labelPosOpt)) {
      parsedLabelPos = {
        horizontal: {
          top: "-",
          bottom: "+"
        },
        vertical: {
          left: "-",
          right: "+"
        }
      }[orient][labelPosOpt];
    } else {
      parsedLabelPos = labelPosOpt;
    }
    var labelAlignMap = {
      horizontal: "center",
      vertical: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "left" : "right"
    };
    var labelBaselineMap = {
      horizontal: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "top" : "bottom",
      vertical: "middle"
    };
    var rotationMap = {
      horizontal: 0,
      vertical: PI / 2
    };
    var mainLength = orient === "vertical" ? viewRect2.height : viewRect2.width;
    var controlModel = timelineModel.getModel("controlStyle");
    var showControl = controlModel.get("show", true);
    var controlSize = showControl ? controlModel.get("itemSize") : 0;
    var controlGap = showControl ? controlModel.get("itemGap") : 0;
    var sizePlusGap = controlSize + controlGap;
    var labelRotation = timelineModel.get(["label", "rotate"]) || 0;
    labelRotation = labelRotation * PI / 180;
    var playPosition;
    var prevBtnPosition;
    var nextBtnPosition;
    var controlPosition = controlModel.get("position", true);
    var showPlayBtn = showControl && controlModel.get("showPlayBtn", true);
    var showPrevBtn = showControl && controlModel.get("showPrevBtn", true);
    var showNextBtn = showControl && controlModel.get("showNextBtn", true);
    var xLeft = 0;
    var xRight = mainLength;
    if (controlPosition === "left" || controlPosition === "bottom") {
      showPlayBtn && (playPosition = [0, 0], xLeft += sizePlusGap);
      showPrevBtn && (prevBtnPosition = [xLeft, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    } else {
      showPlayBtn && (playPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
      showPrevBtn && (prevBtnPosition = [0, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    }
    var axisExtent = [xLeft, xRight];
    if (timelineModel.get("inverse")) {
      axisExtent.reverse();
    }
    return {
      viewRect: viewRect2,
      mainLength,
      orient,
      rotation: rotationMap[orient],
      labelRotation,
      labelPosOpt: parsedLabelPos,
      labelAlign: timelineModel.get(["label", "align"]) || labelAlignMap[orient],
      labelBaseline: timelineModel.get(["label", "verticalAlign"]) || timelineModel.get(["label", "baseline"]) || labelBaselineMap[orient],
      playPosition,
      prevBtnPosition,
      nextBtnPosition,
      axisExtent,
      controlSize,
      controlGap
    };
  };
  SliderTimelineView2.prototype._position = function(layoutInfo, timelineModel) {
    var mainGroup = this._mainGroup;
    var labelGroup = this._labelGroup;
    var viewRect2 = layoutInfo.viewRect;
    if (layoutInfo.orient === "vertical") {
      var m2 = create$1();
      var rotateOriginX = viewRect2.x;
      var rotateOriginY = viewRect2.y + viewRect2.height;
      translate(m2, m2, [-rotateOriginX, -rotateOriginY]);
      rotate(m2, m2, -PI / 2);
      translate(m2, m2, [rotateOriginX, rotateOriginY]);
      viewRect2 = viewRect2.clone();
      viewRect2.applyTransform(m2);
    }
    var viewBound = getBound(viewRect2);
    var mainBound = getBound(mainGroup.getBoundingRect());
    var labelBound = getBound(labelGroup.getBoundingRect());
    var mainPosition = [mainGroup.x, mainGroup.y];
    var labelsPosition = [labelGroup.x, labelGroup.y];
    labelsPosition[0] = mainPosition[0] = viewBound[0][0];
    var labelPosOpt = layoutInfo.labelPosOpt;
    if (labelPosOpt == null || isString(labelPosOpt)) {
      var mainBoundIdx = labelPosOpt === "+" ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      toBound(labelsPosition, labelBound, viewBound, 1, 1 - mainBoundIdx);
    } else {
      var mainBoundIdx = labelPosOpt >= 0 ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      labelsPosition[1] = mainPosition[1] + labelPosOpt;
    }
    mainGroup.setPosition(mainPosition);
    labelGroup.setPosition(labelsPosition);
    mainGroup.rotation = labelGroup.rotation = layoutInfo.rotation;
    setOrigin(mainGroup);
    setOrigin(labelGroup);
    function setOrigin(targetGroup) {
      targetGroup.originX = viewBound[0][0] - targetGroup.x;
      targetGroup.originY = viewBound[1][0] - targetGroup.y;
    }
    function getBound(rect) {
      return [[rect.x, rect.x + rect.width], [rect.y, rect.y + rect.height]];
    }
    function toBound(fromPos, from, to, dimIdx, boundIdx) {
      fromPos[dimIdx] += to[dimIdx][boundIdx] - from[dimIdx][boundIdx];
    }
  };
  SliderTimelineView2.prototype._createAxis = function(layoutInfo, timelineModel) {
    var data = timelineModel.getData();
    var axisType = timelineModel.get("axisType");
    var scale2 = createScaleByModel(timelineModel, axisType);
    scale2.getTicks = function() {
      return data.mapArray(["value"], function(value) {
        return {
          value
        };
      });
    };
    var dataExtent = data.getDataExtent("value");
    scale2.setExtent(dataExtent[0], dataExtent[1]);
    scale2.calcNiceTicks();
    var axis = new TimelineAxis$1("value", scale2, layoutInfo.axisExtent, axisType);
    axis.model = timelineModel;
    return axis;
  };
  SliderTimelineView2.prototype._createGroup = function(key) {
    var newGroup = this[key] = new Group$4();
    this.group.add(newGroup);
    return newGroup;
  };
  SliderTimelineView2.prototype._renderAxisLine = function(layoutInfo, group, axis, timelineModel) {
    var axisExtent = axis.getExtent();
    if (!timelineModel.get(["lineStyle", "show"])) {
      return;
    }
    var line = new Line$3({
      shape: {
        x1: axisExtent[0],
        y1: 0,
        x2: axisExtent[1],
        y2: 0
      },
      style: extend({
        lineCap: "round"
      }, timelineModel.getModel("lineStyle").getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(line);
    var progressLine = this._progressLine = new Line$3({
      shape: {
        x1: axisExtent[0],
        x2: this._currentPointer ? this._currentPointer.x : axisExtent[0],
        y1: 0,
        y2: 0
      },
      style: defaults({
        lineCap: "round",
        lineWidth: line.style.lineWidth
      }, timelineModel.getModel(["progress", "lineStyle"]).getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(progressLine);
  };
  SliderTimelineView2.prototype._renderAxisTick = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var data = timelineModel.getData();
    var ticks = axis.scale.getTicks();
    this._tickSymbols = [];
    each$f(ticks, function(tick) {
      var tickCoord = axis.dataToCoord(tick.value);
      var itemModel = data.getItemModel(tick.value);
      var itemStyleModel = itemModel.getModel("itemStyle");
      var hoverStyleModel = itemModel.getModel(["emphasis", "itemStyle"]);
      var progressStyleModel = itemModel.getModel(["progress", "itemStyle"]);
      var symbolOpt = {
        x: tickCoord,
        y: 0,
        onclick: bind$1(_this._changeTimeline, _this, tick.value)
      };
      var el = giveSymbol(itemModel, itemStyleModel, group, symbolOpt);
      el.ensureState("emphasis").style = hoverStyleModel.getItemStyle();
      el.ensureState("progress").style = progressStyleModel.getItemStyle();
      enableHoverEmphasis(el);
      var ecData = getECData(el);
      if (itemModel.get("tooltip")) {
        ecData.dataIndex = tick.value;
        ecData.dataModel = timelineModel;
      } else {
        ecData.dataIndex = ecData.dataModel = null;
      }
      _this._tickSymbols.push(el);
    });
  };
  SliderTimelineView2.prototype._renderAxisLabel = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var labelModel = axis.getLabelModel();
    if (!labelModel.get("show")) {
      return;
    }
    var data = timelineModel.getData();
    var labels = axis.getViewLabels();
    this._tickLabels = [];
    each$f(labels, function(labelItem) {
      var dataIndex = labelItem.tickValue;
      var itemModel = data.getItemModel(dataIndex);
      var normalLabelModel = itemModel.getModel("label");
      var hoverLabelModel = itemModel.getModel(["emphasis", "label"]);
      var progressLabelModel = itemModel.getModel(["progress", "label"]);
      var tickCoord = axis.dataToCoord(labelItem.tickValue);
      var textEl = new ZRText$1({
        x: tickCoord,
        y: 0,
        rotation: layoutInfo.labelRotation - layoutInfo.rotation,
        onclick: bind$1(_this._changeTimeline, _this, dataIndex),
        silent: false,
        style: createTextStyle(normalLabelModel, {
          text: labelItem.formattedLabel,
          align: layoutInfo.labelAlign,
          verticalAlign: layoutInfo.labelBaseline
        })
      });
      textEl.ensureState("emphasis").style = createTextStyle(hoverLabelModel);
      textEl.ensureState("progress").style = createTextStyle(progressLabelModel);
      group.add(textEl);
      enableHoverEmphasis(textEl);
      labelDataIndexStore(textEl).dataIndex = dataIndex;
      _this._tickLabels.push(textEl);
    });
  };
  SliderTimelineView2.prototype._renderControl = function(layoutInfo, group, axis, timelineModel) {
    var controlSize = layoutInfo.controlSize;
    var rotation = layoutInfo.rotation;
    var itemStyle = timelineModel.getModel("controlStyle").getItemStyle();
    var hoverStyle = timelineModel.getModel(["emphasis", "controlStyle"]).getItemStyle();
    var playState = timelineModel.getPlayState();
    var inverse = timelineModel.get("inverse", true);
    makeBtn(layoutInfo.nextBtnPosition, "next", bind$1(this._changeTimeline, this, inverse ? "-" : "+"));
    makeBtn(layoutInfo.prevBtnPosition, "prev", bind$1(this._changeTimeline, this, inverse ? "+" : "-"));
    makeBtn(layoutInfo.playPosition, playState ? "stop" : "play", bind$1(this._handlePlayClick, this, !playState), true);
    function makeBtn(position2, iconName, onclick, willRotate) {
      if (!position2) {
        return;
      }
      var iconSize = parsePercent$1(retrieve2(timelineModel.get(["controlStyle", iconName + "BtnSize"]), controlSize), controlSize);
      var rect = [0, -iconSize / 2, iconSize, iconSize];
      var btn = makeControlIcon(timelineModel, iconName + "Icon", rect, {
        x: position2[0],
        y: position2[1],
        originX: controlSize / 2,
        originY: 0,
        rotation: willRotate ? -rotation : 0,
        rectHover: true,
        style: itemStyle,
        onclick
      });
      btn.ensureState("emphasis").style = hoverStyle;
      group.add(btn);
      enableHoverEmphasis(btn);
    }
  };
  SliderTimelineView2.prototype._renderCurrentPointer = function(layoutInfo, group, axis, timelineModel) {
    var data = timelineModel.getData();
    var currentIndex = timelineModel.getCurrentIndex();
    var pointerModel = data.getItemModel(currentIndex).getModel("checkpointStyle");
    var me = this;
    var callback = {
      onCreate: function(pointer) {
        pointer.draggable = true;
        pointer.drift = bind$1(me._handlePointerDrag, me);
        pointer.ondragend = bind$1(me._handlePointerDragend, me);
        pointerMoveTo(pointer, me._progressLine, currentIndex, axis, timelineModel, true);
      },
      onUpdate: function(pointer) {
        pointerMoveTo(pointer, me._progressLine, currentIndex, axis, timelineModel);
      }
    };
    this._currentPointer = giveSymbol(pointerModel, pointerModel, this._mainGroup, {}, this._currentPointer, callback);
  };
  SliderTimelineView2.prototype._handlePlayClick = function(nextState) {
    this._clearTimer();
    this.api.dispatchAction({
      type: "timelinePlayChange",
      playState: nextState,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._handlePointerDrag = function(dx, dy, e2) {
    this._clearTimer();
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY]);
  };
  SliderTimelineView2.prototype._handlePointerDragend = function(e2) {
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
  };
  SliderTimelineView2.prototype._pointerChangeTimeline = function(mousePos, trigger2) {
    var toCoord = this._toAxisCoord(mousePos)[0];
    var axis = this._axis;
    var axisExtent = asc$2(axis.getExtent().slice());
    toCoord > axisExtent[1] && (toCoord = axisExtent[1]);
    toCoord < axisExtent[0] && (toCoord = axisExtent[0]);
    this._currentPointer.x = toCoord;
    this._currentPointer.markRedraw();
    this._progressLine.shape.x2 = toCoord;
    this._progressLine.dirty();
    var targetDataIndex = this._findNearestTick(toCoord);
    var timelineModel = this.model;
    if (trigger2 || targetDataIndex !== timelineModel.getCurrentIndex() && timelineModel.get("realtime")) {
      this._changeTimeline(targetDataIndex);
    }
  };
  SliderTimelineView2.prototype._doPlayStop = function() {
    var _this = this;
    this._clearTimer();
    if (this.model.getPlayState()) {
      this._timer = setTimeout(function() {
        var timelineModel = _this.model;
        _this._changeTimeline(timelineModel.getCurrentIndex() + (timelineModel.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval"));
    }
  };
  SliderTimelineView2.prototype._toAxisCoord = function(vertex) {
    var trans = this._mainGroup.getLocalTransform();
    return applyTransform(vertex, trans, true);
  };
  SliderTimelineView2.prototype._findNearestTick = function(axisCoord) {
    var data = this.model.getData();
    var dist2 = Infinity;
    var targetDataIndex;
    var axis = this._axis;
    data.each(["value"], function(value, dataIndex) {
      var coord = axis.dataToCoord(value);
      var d2 = Math.abs(coord - axisCoord);
      if (d2 < dist2) {
        dist2 = d2;
        targetDataIndex = dataIndex;
      }
    });
    return targetDataIndex;
  };
  SliderTimelineView2.prototype._clearTimer = function() {
    if (this._timer) {
      clearTimeout(this._timer);
      this._timer = null;
    }
  };
  SliderTimelineView2.prototype._changeTimeline = function(nextIndex) {
    var currentIndex = this.model.getCurrentIndex();
    if (nextIndex === "+") {
      nextIndex = currentIndex + 1;
    } else if (nextIndex === "-") {
      nextIndex = currentIndex - 1;
    }
    this.api.dispatchAction({
      type: "timelineChange",
      currentIndex: nextIndex,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._updateTicksStatus = function() {
    var currentIndex = this.model.getCurrentIndex();
    var tickSymbols = this._tickSymbols;
    var tickLabels = this._tickLabels;
    if (tickSymbols) {
      for (var i = 0; i < tickSymbols.length; i++) {
        tickSymbols && tickSymbols[i] && tickSymbols[i].toggleState("progress", i < currentIndex);
      }
    }
    if (tickLabels) {
      for (var i = 0; i < tickLabels.length; i++) {
        tickLabels && tickLabels[i] && tickLabels[i].toggleState("progress", labelDataIndexStore(tickLabels[i]).dataIndex <= currentIndex);
      }
    }
  };
  SliderTimelineView2.type = "timeline.slider";
  return SliderTimelineView2;
}(TimelineView$1);
function createScaleByModel(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new IntervalScale$1();
    }
  }
}
function getViewRect(model, api) {
  return getLayoutRect(model.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  }, model.get("padding"));
}
function makeControlIcon(timelineModel, objPath, rect, opts) {
  var style = opts.style;
  var icon = createIcon(timelineModel.get(["controlStyle", objPath]), opts || {}, new BoundingRect$1(rect[0], rect[1], rect[2], rect[3]));
  if (style) {
    icon.setStyle(style);
  }
  return icon;
}
function giveSymbol(hostModel, itemStyleModel, group, opt, symbol, callback) {
  var color = itemStyleModel.get("color");
  if (!symbol) {
    var symbolType = hostModel.get("symbol");
    symbol = createSymbol$1(symbolType, -1, -1, 2, 2, color);
    symbol.setStyle("strokeNoScale", true);
    group.add(symbol);
    callback && callback.onCreate(symbol);
  } else {
    symbol.setColor(color);
    group.add(symbol);
    callback && callback.onUpdate(symbol);
  }
  var itemStyle = itemStyleModel.getItemStyle(["color"]);
  symbol.setStyle(itemStyle);
  opt = merge({
    rectHover: true,
    z2: 100
  }, opt, true);
  var symbolSize = normalizeSymbolSize(hostModel.get("symbolSize"));
  opt.scaleX = symbolSize[0] / 2;
  opt.scaleY = symbolSize[1] / 2;
  var symbolOffset = normalizeSymbolOffset(hostModel.get("symbolOffset"), symbolSize);
  if (symbolOffset) {
    opt.x = (opt.x || 0) + symbolOffset[0];
    opt.y = (opt.y || 0) + symbolOffset[1];
  }
  var symbolRotate = hostModel.get("symbolRotate");
  opt.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  symbol.attr(opt);
  symbol.updateTransform();
  return symbol;
}
function pointerMoveTo(pointer, progressLine, dataIndex, axis, timelineModel, noAnimation) {
  if (pointer.dragging) {
    return;
  }
  var pointerModel = timelineModel.getModel("checkpointStyle");
  var toCoord = axis.dataToCoord(timelineModel.getData().get("value", dataIndex));
  if (noAnimation || !pointerModel.get("animation", true)) {
    pointer.attr({
      x: toCoord,
      y: 0
    });
    progressLine && progressLine.attr({
      shape: {
        x2: toCoord
      }
    });
  } else {
    var animationCfg = {
      duration: pointerModel.get("animationDuration", true),
      easing: pointerModel.get("animationEasing", true)
    };
    pointer.stopAnimation(null, true);
    pointer.animateTo({
      x: toCoord,
      y: 0
    }, animationCfg);
    progressLine && progressLine.animateTo({
      shape: {
        x2: toCoord
      }
    }, animationCfg);
  }
}
var SliderTimelineView$1 = SliderTimelineView;
function installTimelineAction(registers) {
  registers.registerAction({
    type: "timelineChange",
    event: "timelineChanged",
    update: "prepareAndUpdate"
  }, function(payload, ecModel, api) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.currentIndex != null) {
      timelineModel.setCurrentIndex(payload.currentIndex);
      if (!timelineModel.get("loop", true) && timelineModel.isIndexMax() && timelineModel.getPlayState()) {
        timelineModel.setPlayState(false);
        api.dispatchAction({
          type: "timelinePlayChange",
          playState: false,
          from: payload.from
        });
      }
    }
    ecModel.resetOption("timeline", {
      replaceMerge: timelineModel.get("replaceMerge", true)
    });
    return defaults({
      currentIndex: timelineModel.option.currentIndex
    }, payload);
  });
  registers.registerAction({
    type: "timelinePlayChange",
    event: "timelinePlayChanged",
    update: "update"
  }, function(payload, ecModel) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.playState != null) {
      timelineModel.setPlayState(payload.playState);
    }
  });
}
function timelinePreprocessor(option) {
  var timelineOpt = option && option.timeline;
  if (!isArray$1(timelineOpt)) {
    timelineOpt = timelineOpt ? [timelineOpt] : [];
  }
  each$f(timelineOpt, function(opt) {
    if (!opt) {
      return;
    }
    compatibleEC2(opt);
  });
}
function compatibleEC2(opt) {
  var type4 = opt.type;
  var ec2Types = {
    "number": "value",
    "time": "time"
  };
  if (ec2Types[type4]) {
    opt.axisType = ec2Types[type4];
    delete opt.type;
  }
  transferItem(opt);
  if (has$1(opt, "controlPosition")) {
    var controlStyle = opt.controlStyle || (opt.controlStyle = {});
    if (!has$1(controlStyle, "position")) {
      controlStyle.position = opt.controlPosition;
    }
    if (controlStyle.position === "none" && !has$1(controlStyle, "show")) {
      controlStyle.show = false;
      delete controlStyle.position;
    }
    delete opt.controlPosition;
  }
  each$f(opt.data || [], function(dataItem) {
    if (isObject$4(dataItem) && !isArray$1(dataItem)) {
      if (!has$1(dataItem, "value") && has$1(dataItem, "name")) {
        dataItem.value = dataItem.name;
      }
      transferItem(dataItem);
    }
  });
}
function transferItem(opt) {
  var itemStyle = opt.itemStyle || (opt.itemStyle = {});
  var itemStyleEmphasis = itemStyle.emphasis || (itemStyle.emphasis = {});
  var label = opt.label || opt.label || {};
  var labelNormal = label.normal || (label.normal = {});
  var excludeLabelAttr = {
    normal: 1,
    emphasis: 1
  };
  each$f(label, function(value, name) {
    if (!excludeLabelAttr[name] && !has$1(labelNormal, name)) {
      labelNormal[name] = value;
    }
  });
  if (itemStyleEmphasis.label && !has$1(label, "emphasis")) {
    label.emphasis = itemStyleEmphasis.label;
    delete itemStyleEmphasis.label;
  }
}
function has$1(obj, attr) {
  return obj.hasOwnProperty(attr);
}
function install$f(registers) {
  registers.registerComponentModel(SliderTimelineModel$1);
  registers.registerComponentView(SliderTimelineView$1);
  registers.registerSubTypeDefaulter("timeline", function() {
    return "slider";
  });
  installTimelineAction(registers);
  registers.registerPreprocessor(timelinePreprocessor);
}
function checkMarkerInSeries(seriesOpts, markerType) {
  if (!seriesOpts) {
    return false;
  }
  var seriesOptArr = isArray$1(seriesOpts) ? seriesOpts : [seriesOpts];
  for (var idx = 0; idx < seriesOptArr.length; idx++) {
    if (seriesOptArr[idx] && seriesOptArr[idx][markerType]) {
      return true;
    }
  }
  return false;
}
function fillLabel(opt) {
  defaultEmphasis(opt, "label", ["show"]);
}
var inner$5 = makeInner();
var MarkerModel = function(_super) {
  __extends(MarkerModel2, _super);
  function MarkerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerModel2.type;
    _this.createdBySelf = false;
    return _this;
  }
  MarkerModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._mergeOption(option, ecModel, false, true);
  };
  MarkerModel2.prototype.isAnimationEnabled = function() {
    if (env$1.node) {
      return false;
    }
    var hostSeries = this.__hostSeries;
    return this.getShallow("animation") && hostSeries && hostSeries.isAnimationEnabled();
  };
  MarkerModel2.prototype.mergeOption = function(newOpt, ecModel) {
    this._mergeOption(newOpt, ecModel, false, false);
  };
  MarkerModel2.prototype._mergeOption = function(newOpt, ecModel, createdBySelf, isInit) {
    var componentType = this.mainType;
    if (!createdBySelf) {
      ecModel.eachSeries(function(seriesModel) {
        var markerOpt = seriesModel.get(this.mainType, true);
        var markerModel = inner$5(seriesModel)[componentType];
        if (!markerOpt || !markerOpt.data) {
          inner$5(seriesModel)[componentType] = null;
          return;
        }
        if (!markerModel) {
          if (isInit) {
            fillLabel(markerOpt);
          }
          each$f(markerOpt.data, function(item) {
            if (item instanceof Array) {
              fillLabel(item[0]);
              fillLabel(item[1]);
            } else {
              fillLabel(item);
            }
          });
          markerModel = this.createMarkerModelFromSeries(markerOpt, this, ecModel);
          extend(markerModel, {
            mainType: this.mainType,
            seriesIndex: seriesModel.seriesIndex,
            name: seriesModel.name,
            createdBySelf: true
          });
          markerModel.__hostSeries = seriesModel;
        } else {
          markerModel._mergeOption(markerOpt, ecModel, true);
        }
        inner$5(seriesModel)[componentType] = markerModel;
      }, this);
    }
  };
  MarkerModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var itemName = data.getName(dataIndex);
    return createTooltipMarkup("section", {
      header: this.name,
      blocks: [createTooltipMarkup("nameValue", {
        name: itemName,
        value,
        noName: !itemName,
        noValue: value == null
      })]
    });
  };
  MarkerModel2.prototype.getData = function() {
    return this._data;
  };
  MarkerModel2.prototype.setData = function(data) {
    this._data = data;
  };
  MarkerModel2.getMarkerModelFromSeries = function(seriesModel, componentType) {
    return inner$5(seriesModel)[componentType];
  };
  MarkerModel2.type = "marker";
  MarkerModel2.dependencies = ["series", "grid", "polar", "geo"];
  return MarkerModel2;
}(ComponentModel$1);
mixin(MarkerModel, DataFormatMixin.prototype);
var MarkerModel$1 = MarkerModel;
var MarkPointModel = function(_super) {
  __extends(MarkPointModel2, _super);
  function MarkPointModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointModel2.type;
    return _this;
  }
  MarkPointModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkPointModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkPointModel2.type = "markPoint";
  MarkPointModel2.defaultOption = {
    z: 5,
    symbol: "pin",
    symbolSize: 50,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "inside"
    },
    itemStyle: {
      borderWidth: 2
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return MarkPointModel2;
}(MarkerModel$1);
var MarkPointModel$1 = MarkPointModel;
function hasXOrY(item) {
  return !(isNaN(parseFloat(item.x)) && isNaN(parseFloat(item.y)));
}
function hasXAndY(item) {
  return !isNaN(parseFloat(item.x)) && !isNaN(parseFloat(item.y));
}
function markerTypeCalculatorWithExtent(markerType, data, otherDataDim, targetDataDim, otherCoordIndex, targetCoordIndex) {
  var coordArr = [];
  var stacked = isDimensionStacked(data, targetDataDim);
  var calcDataDim = stacked ? data.getCalculationInfo("stackResultDimension") : targetDataDim;
  var value = numCalculate(data, calcDataDim, markerType);
  var dataIndex = data.indicesOfNearest(calcDataDim, value)[0];
  coordArr[otherCoordIndex] = data.get(otherDataDim, dataIndex);
  coordArr[targetCoordIndex] = data.get(calcDataDim, dataIndex);
  var coordArrValue = data.get(targetDataDim, dataIndex);
  var precision = getPrecision(data.get(targetDataDim, dataIndex));
  precision = Math.min(precision, 20);
  if (precision >= 0) {
    coordArr[targetCoordIndex] = +coordArr[targetCoordIndex].toFixed(precision);
  }
  return [coordArr, coordArrValue];
}
var markerTypeCalculator = {
  min: curry$1(markerTypeCalculatorWithExtent, "min"),
  max: curry$1(markerTypeCalculatorWithExtent, "max"),
  average: curry$1(markerTypeCalculatorWithExtent, "average"),
  median: curry$1(markerTypeCalculatorWithExtent, "median")
};
function dataTransform(seriesModel, item) {
  var data = seriesModel.getData();
  var coordSys = seriesModel.coordinateSystem;
  if (item && !hasXAndY(item) && !isArray$1(item.coord) && coordSys) {
    var dims = coordSys.dimensions;
    var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
    item = clone$4(item);
    if (item.type && markerTypeCalculator[item.type] && axisInfo.baseAxis && axisInfo.valueAxis) {
      var otherCoordIndex = indexOf(dims, axisInfo.baseAxis.dim);
      var targetCoordIndex = indexOf(dims, axisInfo.valueAxis.dim);
      var coordInfo = markerTypeCalculator[item.type](data, axisInfo.baseDataDim, axisInfo.valueDataDim, otherCoordIndex, targetCoordIndex);
      item.coord = coordInfo[0];
      item.value = coordInfo[1];
    } else {
      var coord = [item.xAxis != null ? item.xAxis : item.radiusAxis, item.yAxis != null ? item.yAxis : item.angleAxis];
      for (var i = 0; i < 2; i++) {
        if (markerTypeCalculator[coord[i]]) {
          coord[i] = numCalculate(data, data.mapDimension(dims[i]), coord[i]);
        }
      }
      item.coord = coord;
    }
  }
  return item;
}
function getAxisInfo(item, data, coordSys, seriesModel) {
  var ret = {};
  if (item.valueIndex != null || item.valueDim != null) {
    ret.valueDataDim = item.valueIndex != null ? data.getDimension(item.valueIndex) : item.valueDim;
    ret.valueAxis = coordSys.getAxis(dataDimToCoordDim(seriesModel, ret.valueDataDim));
    ret.baseAxis = coordSys.getOtherAxis(ret.valueAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
  } else {
    ret.baseAxis = seriesModel.getBaseAxis();
    ret.valueAxis = coordSys.getOtherAxis(ret.baseAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
    ret.valueDataDim = data.mapDimension(ret.valueAxis.dim);
  }
  return ret;
}
function dataDimToCoordDim(seriesModel, dataDim) {
  var dimItem = seriesModel.getData().getDimensionInfo(dataDim);
  return dimItem && dimItem.coordDim;
}
function dataFilter(coordSys, item) {
  return coordSys && coordSys.containData && item.coord && !hasXOrY(item) ? coordSys.containData(item.coord) : true;
}
function createMarkerDimValueGetter(inCoordSys, dims) {
  return inCoordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = dimIndex < 2 ? item.coord && item.coord[dimIndex] : item.value;
    return parseDataValue(rawVal, dims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dims[dimIndex]);
  };
}
function numCalculate(data, valueDataDim, type4) {
  if (type4 === "average") {
    var sum_1 = 0;
    var count_1 = 0;
    data.each(valueDataDim, function(val, idx) {
      if (!isNaN(val)) {
        sum_1 += val;
        count_1++;
      }
    });
    return sum_1 / count_1;
  } else if (type4 === "median") {
    return data.getMedian(valueDataDim);
  } else {
    return data.getDataExtent(valueDataDim)[type4 === "max" ? 1 : 0];
  }
}
var inner$4 = makeInner();
var MarkerView = function(_super) {
  __extends(MarkerView2, _super);
  function MarkerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerView2.type;
    return _this;
  }
  MarkerView2.prototype.init = function() {
    this.markerGroupMap = createHashMap();
  };
  MarkerView2.prototype.render = function(markerModel, ecModel, api) {
    var _this = this;
    var markerGroupMap = this.markerGroupMap;
    markerGroupMap.each(function(item) {
      inner$4(item).keep = false;
    });
    ecModel.eachSeries(function(seriesModel) {
      var markerModel2 = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      markerModel2 && _this.renderSeries(seriesModel, markerModel2, ecModel, api);
    });
    markerGroupMap.each(function(item) {
      !inner$4(item).keep && _this.group.remove(item.group);
    });
  };
  MarkerView2.prototype.markKeep = function(drawGroup) {
    inner$4(drawGroup).keep = true;
  };
  MarkerView2.prototype.blurSeries = function(seriesModelList) {
    var _this = this;
    each$f(seriesModelList, function(seriesModel) {
      var markerModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      if (markerModel) {
        var data = markerModel.getData();
        data.eachItemGraphicEl(function(el) {
          if (el) {
            enterBlur(el);
          }
        });
      }
    });
  };
  MarkerView2.type = "marker";
  return MarkerView2;
}(ComponentView$1);
var MarkerView$1 = MarkerView;
function updateMarkerLayout(mpData, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  mpData.each(function(idx) {
    var itemModel = mpData.getItemModel(idx);
    var point;
    var xPx = parsePercent(itemModel.get("x"), api.getWidth());
    var yPx = parsePercent(itemModel.get("y"), api.getHeight());
    if (!isNaN(xPx) && !isNaN(yPx)) {
      point = [xPx, yPx];
    } else if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(mpData.getValues(mpData.dimensions, idx));
    } else if (coordSys) {
      var x2 = mpData.get(coordSys.dimensions[0], idx);
      var y2 = mpData.get(coordSys.dimensions[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
    mpData.setItemLayout(idx, point);
  });
}
var MarkPointView = function(_super) {
  __extends(MarkPointView2, _super);
  function MarkPointView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointView2.type;
    return _this;
  }
  MarkPointView2.prototype.updateTransform = function(markPointModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mpModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markPoint");
      if (mpModel) {
        updateMarkerLayout(mpModel.getData(), seriesModel, api);
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkPointView2.prototype.renderSeries = function(seriesModel, mpModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var symbolDrawMap = this.markerGroupMap;
    var symbolDraw = symbolDrawMap.get(seriesId) || symbolDrawMap.set(seriesId, new SymbolDraw$1());
    var mpData = createData(coordSys, seriesModel, mpModel);
    mpModel.setData(mpData);
    updateMarkerLayout(mpModel.getData(), seriesModel, api);
    mpData.each(function(idx) {
      var itemModel = mpData.getItemModel(idx);
      var symbol = itemModel.getShallow("symbol");
      var symbolSize = itemModel.getShallow("symbolSize");
      var symbolRotate = itemModel.getShallow("symbolRotate");
      var symbolOffset = itemModel.getShallow("symbolOffset");
      var symbolKeepAspect = itemModel.getShallow("symbolKeepAspect");
      if (isFunction(symbol) || isFunction(symbolSize) || isFunction(symbolRotate) || isFunction(symbolOffset)) {
        var rawIdx = mpModel.getRawValue(idx);
        var dataParams = mpModel.getDataParams(idx);
        if (isFunction(symbol)) {
          symbol = symbol(rawIdx, dataParams);
        }
        if (isFunction(symbolSize)) {
          symbolSize = symbolSize(rawIdx, dataParams);
        }
        if (isFunction(symbolRotate)) {
          symbolRotate = symbolRotate(rawIdx, dataParams);
        }
        if (isFunction(symbolOffset)) {
          symbolOffset = symbolOffset(rawIdx, dataParams);
        }
      }
      var style = itemModel.getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style.fill) {
        style.fill = color;
      }
      mpData.setItemVisual(idx, {
        symbol,
        symbolSize,
        symbolRotate,
        symbolOffset,
        symbolKeepAspect,
        style
      });
    });
    symbolDraw.updateData(mpData);
    this.group.add(symbolDraw.group);
    mpData.eachItemGraphicEl(function(el) {
      el.traverse(function(child) {
        getECData(child).dataModel = mpModel;
      });
    });
    this.markKeep(symbolDraw);
    symbolDraw.group.silent = mpModel.get("silent") || seriesModel.get("silent");
  };
  MarkPointView2.type = "markPoint";
  return MarkPointView2;
}(MarkerView$1);
function createData(coordSys, seriesModel, mpModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var mpData = new SeriesData$1(coordDimsInfos, mpModel);
  var dataOpt = map$1(mpModel.get("data"), curry$1(dataTransform, seriesModel));
  if (coordSys) {
    dataOpt = filter(dataOpt, curry$1(dataFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  mpData.initData(dataOpt, null, dimValueGetter);
  return mpData;
}
var MarkPointView$1 = MarkPointView;
function install$e(registers) {
  registers.registerComponentModel(MarkPointModel$1);
  registers.registerComponentView(MarkPointView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markPoint")) {
      opt.markPoint = opt.markPoint || {};
    }
  });
}
var MarkLineModel = function(_super) {
  __extends(MarkLineModel2, _super);
  function MarkLineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineModel2.type;
    return _this;
  }
  MarkLineModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkLineModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkLineModel2.type = "markLine";
  MarkLineModel2.defaultOption = {
    z: 5,
    symbol: ["circle", "arrow"],
    symbolSize: [8, 16],
    symbolOffset: 0,
    precision: 2,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "end",
      distance: 5
    },
    lineStyle: {
      type: "dashed"
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        width: 3
      }
    },
    animationEasing: "linear"
  };
  return MarkLineModel2;
}(MarkerModel$1);
var MarkLineModel$1 = MarkLineModel;
var inner$3 = makeInner();
var markLineTransform = function(seriesModel, coordSys, mlModel, item) {
  var data = seriesModel.getData();
  var itemArray;
  if (!isArray$1(item)) {
    var mlType = item.type;
    if (mlType === "min" || mlType === "max" || mlType === "average" || mlType === "median" || item.xAxis != null || item.yAxis != null) {
      var valueAxis2 = void 0;
      var value = void 0;
      if (item.yAxis != null || item.xAxis != null) {
        valueAxis2 = coordSys.getAxis(item.yAxis != null ? "y" : "x");
        value = retrieve(item.yAxis, item.xAxis);
      } else {
        var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
        valueAxis2 = axisInfo.valueAxis;
        var valueDataDim = getStackedDimension(data, axisInfo.valueDataDim);
        value = numCalculate(data, valueDataDim, mlType);
      }
      var valueIndex = valueAxis2.dim === "x" ? 0 : 1;
      var baseIndex = 1 - valueIndex;
      var mlFrom = clone$4(item);
      var mlTo = {
        coord: []
      };
      mlFrom.type = null;
      mlFrom.coord = [];
      mlFrom.coord[baseIndex] = -Infinity;
      mlTo.coord[baseIndex] = Infinity;
      var precision = mlModel.get("precision");
      if (precision >= 0 && isNumber(value)) {
        value = +value.toFixed(Math.min(precision, 20));
      }
      mlFrom.coord[valueIndex] = mlTo.coord[valueIndex] = value;
      itemArray = [mlFrom, mlTo, {
        type: mlType,
        valueIndex: item.valueIndex,
        value
      }];
    } else {
      itemArray = [];
    }
  } else {
    itemArray = item;
  }
  var normalizedItem = [dataTransform(seriesModel, itemArray[0]), dataTransform(seriesModel, itemArray[1]), extend({}, itemArray[2])];
  normalizedItem[2].type = normalizedItem[2].type || null;
  merge(normalizedItem[2], normalizedItem[0]);
  merge(normalizedItem[2], normalizedItem[1]);
  return normalizedItem;
};
function isInifinity$1(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkLineHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  var dimName = coordSys.dimensions[dimIndex];
  return isInifinity$1(fromCoord[otherDimIndex]) && isInifinity$1(toCoord[otherDimIndex]) && fromCoord[dimIndex] === toCoord[dimIndex] && coordSys.getAxis(dimName).containData(fromCoord[dimIndex]);
}
function markLineFilter(coordSys, item) {
  if (coordSys.type === "cartesian2d") {
    var fromCoord = item[0].coord;
    var toCoord = item[1].coord;
    if (fromCoord && toCoord && (ifMarkLineHasOnlyDim(1, fromCoord, toCoord, coordSys) || ifMarkLineHasOnlyDim(0, fromCoord, toCoord, coordSys))) {
      return true;
    }
  }
  return dataFilter(coordSys, item[0]) && dataFilter(coordSys, item[1]);
}
function updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get("x"), api.getWidth());
  var yPx = parsePercent(itemModel.get("y"), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(data.dimensions, idx));
    } else {
      var dims = coordSys.dimensions;
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var dims = coordSys.dimensions;
      if (isInifinity$1(data.get(dims[0], idx))) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[isFrom ? 0 : 1]);
      } else if (isInifinity$1(data.get(dims[1], idx))) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[isFrom ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  data.setItemLayout(idx, point);
}
var MarkLineView = function(_super) {
  __extends(MarkLineView2, _super);
  function MarkLineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineView2.type;
    return _this;
  }
  MarkLineView2.prototype.updateTransform = function(markLineModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mlModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markLine");
      if (mlModel) {
        var mlData_1 = mlModel.getData();
        var fromData_1 = inner$3(mlModel).from;
        var toData_1 = inner$3(mlModel).to;
        fromData_1.each(function(idx) {
          updateSingleMarkerEndLayout(fromData_1, idx, true, seriesModel, api);
          updateSingleMarkerEndLayout(toData_1, idx, false, seriesModel, api);
        });
        mlData_1.each(function(idx) {
          mlData_1.setItemLayout(idx, [fromData_1.getItemLayout(idx), toData_1.getItemLayout(idx)]);
        });
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkLineView2.prototype.renderSeries = function(seriesModel, mlModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var lineDrawMap = this.markerGroupMap;
    var lineDraw = lineDrawMap.get(seriesId) || lineDrawMap.set(seriesId, new LineDraw$1());
    this.group.add(lineDraw.group);
    var mlData = createList$1(coordSys, seriesModel, mlModel);
    var fromData = mlData.from;
    var toData = mlData.to;
    var lineData = mlData.line;
    inner$3(mlModel).from = fromData;
    inner$3(mlModel).to = toData;
    mlModel.setData(lineData);
    var symbolType = mlModel.get("symbol");
    var symbolSize = mlModel.get("symbolSize");
    var symbolRotate = mlModel.get("symbolRotate");
    var symbolOffset = mlModel.get("symbolOffset");
    if (!isArray$1(symbolType)) {
      symbolType = [symbolType, symbolType];
    }
    if (!isArray$1(symbolSize)) {
      symbolSize = [symbolSize, symbolSize];
    }
    if (!isArray$1(symbolRotate)) {
      symbolRotate = [symbolRotate, symbolRotate];
    }
    if (!isArray$1(symbolOffset)) {
      symbolOffset = [symbolOffset, symbolOffset];
    }
    mlData.from.each(function(idx) {
      updateDataVisualAndLayout(fromData, idx, true);
      updateDataVisualAndLayout(toData, idx, false);
    });
    lineData.each(function(idx) {
      var lineStyle = lineData.getItemModel(idx).getModel("lineStyle").getLineStyle();
      lineData.setItemLayout(idx, [fromData.getItemLayout(idx), toData.getItemLayout(idx)]);
      if (lineStyle.stroke == null) {
        lineStyle.stroke = fromData.getItemVisual(idx, "style").fill;
      }
      lineData.setItemVisual(idx, {
        fromSymbolKeepAspect: fromData.getItemVisual(idx, "symbolKeepAspect"),
        fromSymbolOffset: fromData.getItemVisual(idx, "symbolOffset"),
        fromSymbolRotate: fromData.getItemVisual(idx, "symbolRotate"),
        fromSymbolSize: fromData.getItemVisual(idx, "symbolSize"),
        fromSymbol: fromData.getItemVisual(idx, "symbol"),
        toSymbolKeepAspect: toData.getItemVisual(idx, "symbolKeepAspect"),
        toSymbolOffset: toData.getItemVisual(idx, "symbolOffset"),
        toSymbolRotate: toData.getItemVisual(idx, "symbolRotate"),
        toSymbolSize: toData.getItemVisual(idx, "symbolSize"),
        toSymbol: toData.getItemVisual(idx, "symbol"),
        style: lineStyle
      });
    });
    lineDraw.updateData(lineData);
    mlData.line.eachItemGraphicEl(function(el, idx) {
      el.traverse(function(child) {
        getECData(child).dataModel = mlModel;
      });
    });
    function updateDataVisualAndLayout(data, idx, isFrom) {
      var itemModel = data.getItemModel(idx);
      updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api);
      var style = itemModel.getModel("itemStyle").getItemStyle();
      if (style.fill == null) {
        style.fill = getVisualFromData(seriesData, "color");
      }
      data.setItemVisual(idx, {
        symbolKeepAspect: itemModel.get("symbolKeepAspect"),
        symbolOffset: retrieve2(itemModel.get("symbolOffset", true), symbolOffset[isFrom ? 0 : 1]),
        symbolRotate: retrieve2(itemModel.get("symbolRotate", true), symbolRotate[isFrom ? 0 : 1]),
        symbolSize: retrieve2(itemModel.get("symbolSize"), symbolSize[isFrom ? 0 : 1]),
        symbol: retrieve2(itemModel.get("symbol", true), symbolType[isFrom ? 0 : 1]),
        style
      });
    }
    this.markKeep(lineDraw);
    lineDraw.group.silent = mlModel.get("silent") || seriesModel.get("silent");
  };
  MarkLineView2.type = "markLine";
  return MarkLineView2;
}(MarkerView$1);
function createList$1(coordSys, seriesModel, mlModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var fromData = new SeriesData$1(coordDimsInfos, mlModel);
  var toData = new SeriesData$1(coordDimsInfos, mlModel);
  var lineData = new SeriesData$1([], mlModel);
  var optData = map$1(mlModel.get("data"), curry$1(markLineTransform, seriesModel, coordSys, mlModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markLineFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  fromData.initData(map$1(optData, function(item) {
    return item[0];
  }), null, dimValueGetter);
  toData.initData(map$1(optData, function(item) {
    return item[1];
  }), null, dimValueGetter);
  lineData.initData(map$1(optData, function(item) {
    return item[2];
  }));
  lineData.hasItemOption = true;
  return {
    from: fromData,
    to: toData,
    line: lineData
  };
}
var MarkLineView$1 = MarkLineView;
function install$d(registers) {
  registers.registerComponentModel(MarkLineModel$1);
  registers.registerComponentView(MarkLineView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markLine")) {
      opt.markLine = opt.markLine || {};
    }
  });
}
var MarkAreaModel = function(_super) {
  __extends(MarkAreaModel2, _super);
  function MarkAreaModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaModel2.type;
    return _this;
  }
  MarkAreaModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkAreaModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkAreaModel2.type = "markArea";
  MarkAreaModel2.defaultOption = {
    z: 1,
    tooltip: {
      trigger: "item"
    },
    animation: false,
    label: {
      show: true,
      position: "top"
    },
    itemStyle: {
      borderWidth: 0
    },
    emphasis: {
      label: {
        show: true,
        position: "top"
      }
    }
  };
  return MarkAreaModel2;
}(MarkerModel$1);
var MarkAreaModel$1 = MarkAreaModel;
var inner$2 = makeInner();
var markAreaTransform = function(seriesModel, coordSys, maModel, item) {
  var lt2 = dataTransform(seriesModel, item[0]);
  var rb2 = dataTransform(seriesModel, item[1]);
  var ltCoord = lt2.coord;
  var rbCoord = rb2.coord;
  ltCoord[0] = retrieve(ltCoord[0], -Infinity);
  ltCoord[1] = retrieve(ltCoord[1], -Infinity);
  rbCoord[0] = retrieve(rbCoord[0], Infinity);
  rbCoord[1] = retrieve(rbCoord[1], Infinity);
  var result = mergeAll([{}, lt2, rb2]);
  result.coord = [lt2.coord, rb2.coord];
  result.x0 = lt2.x;
  result.y0 = lt2.y;
  result.x1 = rb2.x;
  result.y1 = rb2.y;
  return result;
};
function isInifinity(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkAreaHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  return isInifinity(fromCoord[otherDimIndex]) && isInifinity(toCoord[otherDimIndex]);
}
function markAreaFilter(coordSys, item) {
  var fromCoord = item.coord[0];
  var toCoord = item.coord[1];
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    if (fromCoord && toCoord && (ifMarkAreaHasOnlyDim(1, fromCoord, toCoord) || ifMarkAreaHasOnlyDim(0, fromCoord, toCoord))) {
      return true;
    }
  }
  return dataFilter(coordSys, {
    coord: fromCoord,
    x: item.x0,
    y: item.y0
  }) || dataFilter(coordSys, {
    coord: toCoord,
    x: item.x1,
    y: item.y1
  });
}
function getSingleMarkerEndPoint(data, idx, dims, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get(dims[0]), api.getWidth());
  var yPx = parsePercent(itemModel.get(dims[1]), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(dims, idx));
    } else {
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      var pt = [x2, y2];
      coordSys.clampData && coordSys.clampData(pt, pt);
      point = coordSys.dataToPoint(pt, true);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      if (isInifinity(x2)) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[dims[0] === "x0" ? 0 : 1]);
      } else if (isInifinity(y2)) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[dims[1] === "y0" ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  return point;
}
var dimPermutations = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]];
var MarkAreaView = function(_super) {
  __extends(MarkAreaView2, _super);
  function MarkAreaView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaView2.type;
    return _this;
  }
  MarkAreaView2.prototype.updateTransform = function(markAreaModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var maModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markArea");
      if (maModel) {
        var areaData_1 = maModel.getData();
        areaData_1.each(function(idx) {
          var points2 = map$1(dimPermutations, function(dim) {
            return getSingleMarkerEndPoint(areaData_1, idx, dim, seriesModel, api);
          });
          areaData_1.setItemLayout(idx, points2);
          var el = areaData_1.getItemGraphicEl(idx);
          el.setShape("points", points2);
        });
      }
    }, this);
  };
  MarkAreaView2.prototype.renderSeries = function(seriesModel, maModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var areaGroupMap = this.markerGroupMap;
    var polygonGroup = areaGroupMap.get(seriesId) || areaGroupMap.set(seriesId, {
      group: new Group$4()
    });
    this.group.add(polygonGroup.group);
    this.markKeep(polygonGroup);
    var areaData = createList(coordSys, seriesModel, maModel);
    maModel.setData(areaData);
    areaData.each(function(idx) {
      var points2 = map$1(dimPermutations, function(dim) {
        return getSingleMarkerEndPoint(areaData, idx, dim, seriesModel, api);
      });
      var xAxisScale = coordSys.getAxis("x").scale;
      var yAxisScale = coordSys.getAxis("y").scale;
      var xAxisExtent = xAxisScale.getExtent();
      var yAxisExtent = yAxisScale.getExtent();
      var xPointExtent = [xAxisScale.parse(areaData.get("x0", idx)), xAxisScale.parse(areaData.get("x1", idx))];
      var yPointExtent = [yAxisScale.parse(areaData.get("y0", idx)), yAxisScale.parse(areaData.get("y1", idx))];
      asc$2(xPointExtent);
      asc$2(yPointExtent);
      var overlapped = !(xAxisExtent[0] > xPointExtent[1] || xAxisExtent[1] < xPointExtent[0] || yAxisExtent[0] > yPointExtent[1] || yAxisExtent[1] < yPointExtent[0]);
      var allClipped = !overlapped;
      areaData.setItemLayout(idx, {
        points: points2,
        allClipped
      });
      var style = areaData.getItemModel(idx).getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style.fill) {
        style.fill = color;
        if (isString(style.fill)) {
          style.fill = modifyAlpha(style.fill, 0.4);
        }
      }
      if (!style.stroke) {
        style.stroke = color;
      }
      areaData.setItemVisual(idx, "style", style);
    });
    areaData.diff(inner$2(polygonGroup).data).add(function(idx) {
      var layout2 = areaData.getItemLayout(idx);
      if (!layout2.allClipped) {
        var polygon = new Polygon$1({
          shape: {
            points: layout2.points
          }
        });
        areaData.setItemGraphicEl(idx, polygon);
        polygonGroup.group.add(polygon);
      }
    }).update(function(newIdx, oldIdx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(oldIdx);
      var layout2 = areaData.getItemLayout(newIdx);
      if (!layout2.allClipped) {
        if (polygon) {
          updateProps$1(polygon, {
            shape: {
              points: layout2.points
            }
          }, maModel, newIdx);
        } else {
          polygon = new Polygon$1({
            shape: {
              points: layout2.points
            }
          });
        }
        areaData.setItemGraphicEl(newIdx, polygon);
        polygonGroup.group.add(polygon);
      } else if (polygon) {
        polygonGroup.group.remove(polygon);
      }
    }).remove(function(idx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(idx);
      polygonGroup.group.remove(polygon);
    }).execute();
    areaData.eachItemGraphicEl(function(polygon, idx) {
      var itemModel = areaData.getItemModel(idx);
      var style = areaData.getItemVisual(idx, "style");
      polygon.useStyle(areaData.getItemVisual(idx, "style"));
      setLabelStyle(polygon, getLabelStatesModels(itemModel), {
        labelFetcher: maModel,
        labelDataIndex: idx,
        defaultText: areaData.getName(idx) || "",
        inheritColor: isString(style.fill) ? modifyAlpha(style.fill, 1) : "#000"
      });
      setStatesStylesFromModel(polygon, itemModel);
      toggleHoverEmphasis(polygon, null, null, itemModel.get(["emphasis", "disabled"]));
      getECData(polygon).dataModel = maModel;
    });
    inner$2(polygonGroup).data = areaData;
    polygonGroup.group.silent = maModel.get("silent") || seriesModel.get("silent");
  };
  MarkAreaView2.type = "markArea";
  return MarkAreaView2;
}(MarkerView$1);
function createList(coordSys, seriesModel, maModel) {
  var areaData;
  var dataDims;
  var dims = ["x0", "y0", "x1", "y1"];
  if (coordSys) {
    var coordDimsInfos_1 = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var data = seriesModel.getData();
      var info = data.getDimensionInfo(data.mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
    dataDims = map$1(dims, function(dim, idx) {
      return {
        name: dim,
        type: coordDimsInfos_1[idx % 2].type
      };
    });
    areaData = new SeriesData$1(dataDims, maModel);
  } else {
    dataDims = [{
      name: "value",
      type: "float"
    }];
    areaData = new SeriesData$1(dataDims, maModel);
  }
  var optData = map$1(maModel.get("data"), curry$1(markAreaTransform, seriesModel, coordSys, maModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markAreaFilter, coordSys));
  }
  var dimValueGetter = coordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = item.coord[Math.floor(dimIndex / 2)][dimIndex % 2];
    return parseDataValue(rawVal, dataDims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dataDims[dimIndex]);
  };
  areaData.initData(optData, null, dimValueGetter);
  areaData.hasItemOption = true;
  return areaData;
}
var MarkAreaView$1 = MarkAreaView;
function install$c(registers) {
  registers.registerComponentModel(MarkAreaModel$1);
  registers.registerComponentView(MarkAreaView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markArea")) {
      opt.markArea = opt.markArea || {};
    }
  });
}
var getDefaultSelectorOptions = function(ecModel, type4) {
  if (type4 === "all") {
    return {
      type: "all",
      title: ecModel.getLocaleModel().get(["legend", "selector", "all"])
    };
  } else if (type4 === "inverse") {
    return {
      type: "inverse",
      title: ecModel.getLocaleModel().get(["legend", "selector", "inverse"])
    };
  }
};
var LegendModel = function(_super) {
  __extends(LegendModel2, _super);
  function LegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  LegendModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    option.selected = option.selected || {};
    this._updateSelector(option);
  };
  LegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    this._updateSelector(option);
  };
  LegendModel2.prototype._updateSelector = function(option) {
    var selector2 = option.selector;
    var ecModel = this.ecModel;
    if (selector2 === true) {
      selector2 = option.selector = ["all", "inverse"];
    }
    if (isArray$1(selector2)) {
      each$f(selector2, function(item, index2) {
        isString(item) && (item = {
          type: item
        });
        selector2[index2] = merge(item, getDefaultSelectorOptions(ecModel, item.type));
      });
    }
  };
  LegendModel2.prototype.optionUpdated = function() {
    this._updateData(this.ecModel);
    var legendData = this._data;
    if (legendData[0] && this.get("selectedMode") === "single") {
      var hasSelected = false;
      for (var i = 0; i < legendData.length; i++) {
        var name_1 = legendData[i].get("name");
        if (this.isSelected(name_1)) {
          this.select(name_1);
          hasSelected = true;
          break;
        }
      }
      !hasSelected && this.select(legendData[0].get("name"));
    }
  };
  LegendModel2.prototype._updateData = function(ecModel) {
    var potentialData = [];
    var availableNames = [];
    ecModel.eachRawSeries(function(seriesModel) {
      var seriesName = seriesModel.name;
      availableNames.push(seriesName);
      var isPotential;
      if (seriesModel.legendVisualProvider) {
        var provider = seriesModel.legendVisualProvider;
        var names2 = provider.getAllNames();
        if (!ecModel.isSeriesFiltered(seriesModel)) {
          availableNames = availableNames.concat(names2);
        }
        if (names2.length) {
          potentialData = potentialData.concat(names2);
        } else {
          isPotential = true;
        }
      } else {
        isPotential = true;
      }
      if (isPotential && isNameSpecified(seriesModel)) {
        potentialData.push(seriesModel.name);
      }
    });
    this._availableNames = availableNames;
    var rawData = this.get("data") || potentialData;
    var legendData = map$1(rawData, function(dataItem) {
      if (isString(dataItem) || isNumber(dataItem)) {
        dataItem = {
          name: dataItem
        };
      }
      return new Model$1(dataItem, this, this.ecModel);
    }, this);
    this._data = legendData;
  };
  LegendModel2.prototype.getData = function() {
    return this._data;
  };
  LegendModel2.prototype.select = function(name) {
    var selected = this.option.selected;
    var selectedMode = this.get("selectedMode");
    if (selectedMode === "single") {
      var data = this._data;
      each$f(data, function(dataItem) {
        selected[dataItem.get("name")] = false;
      });
    }
    selected[name] = true;
  };
  LegendModel2.prototype.unSelect = function(name) {
    if (this.get("selectedMode") !== "single") {
      this.option.selected[name] = false;
    }
  };
  LegendModel2.prototype.toggleSelected = function(name) {
    var selected = this.option.selected;
    if (!selected.hasOwnProperty(name)) {
      selected[name] = true;
    }
    this[selected[name] ? "unSelect" : "select"](name);
  };
  LegendModel2.prototype.allSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$f(data, function(dataItem) {
      selected[dataItem.get("name", true)] = true;
    });
  };
  LegendModel2.prototype.inverseSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$f(data, function(dataItem) {
      var name = dataItem.get("name", true);
      if (!selected.hasOwnProperty(name)) {
        selected[name] = true;
      }
      selected[name] = !selected[name];
    });
  };
  LegendModel2.prototype.isSelected = function(name) {
    var selected = this.option.selected;
    return !(selected.hasOwnProperty(name) && !selected[name]) && indexOf(this._availableNames, name) >= 0;
  };
  LegendModel2.prototype.getOrient = function() {
    return this.get("orient") === "vertical" ? {
      index: 1,
      name: "vertical"
    } : {
      index: 0,
      name: "horizontal"
    };
  };
  LegendModel2.type = "legend.plain";
  LegendModel2.dependencies = ["series"];
  LegendModel2.defaultOption = {
    z: 4,
    show: true,
    orient: "horizontal",
    left: "center",
    top: 0,
    align: "auto",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    itemWidth: 25,
    itemHeight: 14,
    symbolRotate: "inherit",
    symbolKeepAspect: true,
    inactiveColor: "#ccc",
    inactiveBorderColor: "#ccc",
    inactiveBorderWidth: "auto",
    itemStyle: {
      color: "inherit",
      opacity: "inherit",
      borderColor: "inherit",
      borderWidth: "auto",
      borderCap: "inherit",
      borderJoin: "inherit",
      borderDashOffset: "inherit",
      borderMiterLimit: "inherit"
    },
    lineStyle: {
      width: "auto",
      color: "inherit",
      inactiveColor: "#ccc",
      inactiveWidth: 2,
      opacity: "inherit",
      type: "inherit",
      cap: "inherit",
      join: "inherit",
      dashOffset: "inherit",
      miterLimit: "inherit"
    },
    textStyle: {
      color: "#333"
    },
    selectedMode: true,
    selector: false,
    selectorLabel: {
      show: true,
      borderRadius: 10,
      padding: [3, 5, 3, 5],
      fontSize: 12,
      fontFamily: "sans-serif",
      color: "#666",
      borderWidth: 1,
      borderColor: "#666"
    },
    emphasis: {
      selectorLabel: {
        show: true,
        color: "#eee",
        backgroundColor: "#666"
      }
    },
    selectorPosition: "auto",
    selectorItemGap: 7,
    selectorButtonGap: 10,
    tooltip: {
      show: false
    }
  };
  return LegendModel2;
}(ComponentModel$1);
var LegendModel$1 = LegendModel;
var curry = curry$1;
var each$3 = each$f;
var Group$1 = Group$4;
var LegendView = function(_super) {
  __extends(LegendView2, _super);
  function LegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendView2.type;
    _this.newlineDisabled = false;
    return _this;
  }
  LegendView2.prototype.init = function() {
    this.group.add(this._contentGroup = new Group$1());
    this.group.add(this._selectorGroup = new Group$1());
    this._isFirstRender = true;
  };
  LegendView2.prototype.getContentGroup = function() {
    return this._contentGroup;
  };
  LegendView2.prototype.getSelectorGroup = function() {
    return this._selectorGroup;
  };
  LegendView2.prototype.render = function(legendModel, ecModel, api) {
    var isFirstRender = this._isFirstRender;
    this._isFirstRender = false;
    this.resetInner();
    if (!legendModel.get("show", true)) {
      return;
    }
    var itemAlign = legendModel.get("align");
    var orient = legendModel.get("orient");
    if (!itemAlign || itemAlign === "auto") {
      itemAlign = legendModel.get("left") === "right" && orient === "vertical" ? "right" : "left";
    }
    var selector2 = legendModel.get("selector", true);
    var selectorPosition = legendModel.get("selectorPosition", true);
    if (selector2 && (!selectorPosition || selectorPosition === "auto")) {
      selectorPosition = orient === "horizontal" ? "end" : "start";
    }
    this.renderInner(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var positionInfo = legendModel.getBoxLayoutParams();
    var viewportSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var padding = legendModel.get("padding");
    var maxSize = getLayoutRect(positionInfo, viewportSize, padding);
    var mainRect = this.layoutInner(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition);
    var layoutRect = getLayoutRect(defaults({
      width: mainRect.width,
      height: mainRect.height
    }, positionInfo), viewportSize, padding);
    this.group.x = layoutRect.x - mainRect.x;
    this.group.y = layoutRect.y - mainRect.y;
    this.group.markRedraw();
    this.group.add(this._backgroundEl = makeBackground(mainRect, legendModel));
  };
  LegendView2.prototype.resetInner = function() {
    this.getContentGroup().removeAll();
    this._backgroundEl && this.group.remove(this._backgroundEl);
    this.getSelectorGroup().removeAll();
  };
  LegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var legendDrawnMap = createHashMap();
    var selectMode = legendModel.get("selectedMode");
    var excludeSeriesId = [];
    ecModel.eachRawSeries(function(seriesModel) {
      !seriesModel.get("legendHoverLink") && excludeSeriesId.push(seriesModel.id);
    });
    each$3(legendModel.getData(), function(legendItemModel, dataIndex) {
      var name = legendItemModel.get("name");
      if (!this.newlineDisabled && (name === "" || name === "\n")) {
        var g2 = new Group$1();
        g2.newline = true;
        contentGroup.add(g2);
        return;
      }
      var seriesModel = ecModel.getSeriesByName(name)[0];
      if (legendDrawnMap.get(name)) {
        return;
      }
      if (seriesModel) {
        var data = seriesModel.getData();
        var lineVisualStyle = data.getVisual("legendLineStyle") || {};
        var legendIcon = data.getVisual("legendIcon");
        var style = data.getVisual("style");
        var itemGroup = this._createItem(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, style, legendIcon, selectMode);
        itemGroup.on("click", curry(dispatchSelectAction, name, null, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, seriesModel.name, null, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, seriesModel.name, null, api, excludeSeriesId));
        legendDrawnMap.set(name, true);
      } else {
        ecModel.eachRawSeries(function(seriesModel2) {
          if (legendDrawnMap.get(name)) {
            return;
          }
          if (seriesModel2.legendVisualProvider) {
            var provider = seriesModel2.legendVisualProvider;
            if (!provider.containName(name)) {
              return;
            }
            var idx = provider.indexOfName(name);
            var style2 = provider.getItemVisual(idx, "style");
            var legendIcon2 = provider.getItemVisual(idx, "legendIcon");
            var colorArr = parse(style2.fill);
            if (colorArr && colorArr[3] === 0) {
              colorArr[3] = 0.2;
              style2 = extend(extend({}, style2), {
                fill: stringify(colorArr, "rgba")
              });
            }
            var itemGroup2 = this._createItem(seriesModel2, name, dataIndex, legendItemModel, legendModel, itemAlign, {}, style2, legendIcon2, selectMode);
            itemGroup2.on("click", curry(dispatchSelectAction, null, name, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, null, name, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, null, name, api, excludeSeriesId));
            legendDrawnMap.set(name, true);
          }
        }, this);
      }
    }, this);
    if (selector2) {
      this._createSelector(selector2, legendModel, api, orient, selectorPosition);
    }
  };
  LegendView2.prototype._createSelector = function(selector2, legendModel, api, orient, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    each$3(selector2, function createSelectorButton(selectorItem) {
      var type4 = selectorItem.type;
      var labelText = new ZRText$1({
        style: {
          x: 0,
          y: 0,
          align: "center",
          verticalAlign: "middle"
        },
        onclick: function() {
          api.dispatchAction({
            type: type4 === "all" ? "legendAllSelect" : "legendInverseSelect"
          });
        }
      });
      selectorGroup.add(labelText);
      var labelModel = legendModel.getModel("selectorLabel");
      var emphasisLabelModel = legendModel.getModel(["emphasis", "selectorLabel"]);
      setLabelStyle(labelText, {
        normal: labelModel,
        emphasis: emphasisLabelModel
      }, {
        defaultText: selectorItem.title
      });
      enableHoverEmphasis(labelText);
    });
  };
  LegendView2.prototype._createItem = function(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, itemVisualStyle, legendIcon, selectMode) {
    var drawType = seriesModel.visualDrawType;
    var itemWidth = legendModel.get("itemWidth");
    var itemHeight = legendModel.get("itemHeight");
    var isSelected = legendModel.isSelected(name);
    var iconRotate = legendItemModel.get("symbolRotate");
    var symbolKeepAspect = legendItemModel.get("symbolKeepAspect");
    var legendIconType = legendItemModel.get("icon");
    legendIcon = legendIconType || legendIcon || "roundRect";
    var style = getLegendStyle(legendIcon, legendItemModel, lineVisualStyle, itemVisualStyle, drawType, isSelected);
    var itemGroup = new Group$1();
    var textStyleModel = legendItemModel.getModel("textStyle");
    if (isFunction(seriesModel.getLegendIcon) && (!legendIconType || legendIconType === "inherit")) {
      itemGroup.add(seriesModel.getLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate,
        itemStyle: style.itemStyle,
        lineStyle: style.lineStyle,
        symbolKeepAspect
      }));
    } else {
      var rotate2 = legendIconType === "inherit" && seriesModel.getData().getVisual("symbol") ? iconRotate === "inherit" ? seriesModel.getData().getVisual("symbolRotate") : iconRotate : 0;
      itemGroup.add(getDefaultLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate: rotate2,
        itemStyle: style.itemStyle,
        lineStyle: style.lineStyle,
        symbolKeepAspect
      }));
    }
    var textX = itemAlign === "left" ? itemWidth + 5 : -5;
    var textAlign = itemAlign;
    var formatter = legendModel.get("formatter");
    var content = name;
    if (isString(formatter) && formatter) {
      content = formatter.replace("{name}", name != null ? name : "");
    } else if (isFunction(formatter)) {
      content = formatter(name);
    }
    var inactiveColor = legendItemModel.get("inactiveColor");
    itemGroup.add(new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: content,
        x: textX,
        y: itemHeight / 2,
        fill: isSelected ? textStyleModel.getTextColor() : inactiveColor,
        align: textAlign,
        verticalAlign: "middle"
      })
    }));
    var hitRect = new Rect$3({
      shape: itemGroup.getBoundingRect(),
      invisible: true
    });
    var tooltipModel = legendItemModel.getModel("tooltip");
    if (tooltipModel.get("show")) {
      setTooltipConfig({
        el: hitRect,
        componentModel: legendModel,
        itemName: name,
        itemTooltipOption: tooltipModel.option
      });
    }
    itemGroup.add(hitRect);
    itemGroup.eachChild(function(child) {
      child.silent = true;
    });
    hitRect.silent = !selectMode;
    this.getContentGroup().add(itemGroup);
    enableHoverEmphasis(itemGroup);
    itemGroup.__legendDataIndex = dataIndex;
    return itemGroup;
  };
  LegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var selectorGroup = this.getSelectorGroup();
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), maxSize.width, maxSize.height);
    var contentRect = contentGroup.getBoundingRect();
    var contentPos = [-contentRect.x, -contentRect.y];
    selectorGroup.markRedraw();
    contentGroup.markRedraw();
    if (selector2) {
      box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
      var selectorRect = selectorGroup.getBoundingRect();
      var selectorPos = [-selectorRect.x, -selectorRect.y];
      var selectorButtonGap = legendModel.get("selectorButtonGap", true);
      var orientIdx = legendModel.getOrient().index;
      var wh = orientIdx === 0 ? "width" : "height";
      var hw = orientIdx === 0 ? "height" : "width";
      var yx = orientIdx === 0 ? "y" : "x";
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += contentRect[wh] + selectorButtonGap;
      } else {
        contentPos[orientIdx] += selectorRect[wh] + selectorButtonGap;
      }
      selectorPos[1 - orientIdx] += contentRect[hw] / 2 - selectorRect[hw] / 2;
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      var mainRect = {
        x: 0,
        y: 0
      };
      mainRect[wh] = contentRect[wh] + selectorButtonGap + selectorRect[wh];
      mainRect[hw] = Math.max(contentRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(0, selectorRect[yx] + selectorPos[1 - orientIdx]);
      return mainRect;
    } else {
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      return this.group.getBoundingRect();
    }
  };
  LegendView2.prototype.remove = function() {
    this.getContentGroup().removeAll();
    this._isFirstRender = true;
  };
  LegendView2.type = "legend.plain";
  return LegendView2;
}(ComponentView$1);
function getLegendStyle(iconType, legendModel, lineVisualStyle, itemVisualStyle, drawType, isSelected) {
  function handleCommonProps(style, visualStyle) {
    if (style.lineWidth === "auto") {
      style.lineWidth = visualStyle.lineWidth > 0 ? 2 : 0;
    }
    each$3(style, function(propVal, propName) {
      style[propName] === "inherit" && (style[propName] = visualStyle[propName]);
    });
  }
  var legendItemModel = legendModel.getModel("itemStyle");
  var itemStyle = legendItemModel.getItemStyle();
  var iconBrushType = iconType.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
  itemStyle.decal = itemVisualStyle.decal;
  if (itemStyle.fill === "inherit") {
    itemStyle.fill = itemVisualStyle[drawType];
  }
  if (itemStyle.stroke === "inherit") {
    itemStyle.stroke = itemVisualStyle[iconBrushType];
  }
  if (itemStyle.opacity === "inherit") {
    itemStyle.opacity = (drawType === "fill" ? itemVisualStyle : lineVisualStyle).opacity;
  }
  handleCommonProps(itemStyle, itemVisualStyle);
  var legendLineModel = legendModel.getModel("lineStyle");
  var lineStyle = legendLineModel.getLineStyle();
  handleCommonProps(lineStyle, lineVisualStyle);
  itemStyle.fill === "auto" && (itemStyle.fill = itemVisualStyle.fill);
  itemStyle.stroke === "auto" && (itemStyle.stroke = itemVisualStyle.fill);
  lineStyle.stroke === "auto" && (lineStyle.stroke = itemVisualStyle.fill);
  if (!isSelected) {
    var borderWidth = legendModel.get("inactiveBorderWidth");
    var visualHasBorder = itemStyle[iconBrushType];
    itemStyle.lineWidth = borderWidth === "auto" ? itemVisualStyle.lineWidth > 0 && visualHasBorder ? 2 : 0 : itemStyle.lineWidth;
    itemStyle.fill = legendModel.get("inactiveColor");
    itemStyle.stroke = legendModel.get("inactiveBorderColor");
    lineStyle.stroke = legendLineModel.get("inactiveColor");
    lineStyle.lineWidth = legendLineModel.get("inactiveWidth");
  }
  return {
    itemStyle,
    lineStyle
  };
}
function getDefaultLegendIcon(opt) {
  var symboType = opt.icon || "roundRect";
  var icon = createSymbol$1(symboType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill, opt.symbolKeepAspect);
  icon.setStyle(opt.itemStyle);
  icon.rotation = (opt.iconRotate || 0) * Math.PI / 180;
  icon.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
  if (symboType.indexOf("empty") > -1) {
    icon.style.stroke = icon.style.fill;
    icon.style.fill = "#fff";
    icon.style.lineWidth = 2;
  }
  return icon;
}
function dispatchSelectAction(seriesName, dataName, api, excludeSeriesId) {
  dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId);
  api.dispatchAction({
    type: "legendToggleSelect",
    name: seriesName != null ? seriesName : dataName
  });
  dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId);
}
function isUseHoverLayer(api) {
  var list = api.getZr().storage.getDisplayList();
  var emphasisState;
  var i = 0;
  var len2 = list.length;
  while (i < len2 && !(emphasisState = list[i].states.emphasis)) {
    i++;
  }
  return emphasisState && emphasisState.hoverLayer;
}
function dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "highlight",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
function dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "downplay",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
var LegendView$1 = LegendView;
function legendFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (legendModels && legendModels.length) {
    ecModel.filterSeries(function(series) {
      for (var i = 0; i < legendModels.length; i++) {
        if (!legendModels[i].isSelected(series.name)) {
          return false;
        }
      }
      return true;
    });
  }
}
function legendSelectActionHandler(methodName, payload, ecModel) {
  var selectedMap = {};
  var isToggleSelect = methodName === "toggleSelected";
  var isSelected;
  ecModel.eachComponent("legend", function(legendModel) {
    if (isToggleSelect && isSelected != null) {
      legendModel[isSelected ? "select" : "unSelect"](payload.name);
    } else if (methodName === "allSelect" || methodName === "inverseSelect") {
      legendModel[methodName]();
    } else {
      legendModel[methodName](payload.name);
      isSelected = legendModel.isSelected(payload.name);
    }
    var legendData = legendModel.getData();
    each$f(legendData, function(model) {
      var name = model.get("name");
      if (name === "\n" || name === "") {
        return;
      }
      var isItemSelected = legendModel.isSelected(name);
      if (selectedMap.hasOwnProperty(name)) {
        selectedMap[name] = selectedMap[name] && isItemSelected;
      } else {
        selectedMap[name] = isItemSelected;
      }
    });
  });
  return methodName === "allSelect" || methodName === "inverseSelect" ? {
    selected: selectedMap
  } : {
    name: payload.name,
    selected: selectedMap
  };
}
function installLegendAction(registers) {
  registers.registerAction("legendToggleSelect", "legendselectchanged", curry$1(legendSelectActionHandler, "toggleSelected"));
  registers.registerAction("legendAllSelect", "legendselectall", curry$1(legendSelectActionHandler, "allSelect"));
  registers.registerAction("legendInverseSelect", "legendinverseselect", curry$1(legendSelectActionHandler, "inverseSelect"));
  registers.registerAction("legendSelect", "legendselected", curry$1(legendSelectActionHandler, "select"));
  registers.registerAction("legendUnSelect", "legendunselected", curry$1(legendSelectActionHandler, "unSelect"));
}
function install$b(registers) {
  registers.registerComponentModel(LegendModel$1);
  registers.registerComponentView(LegendView$1);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.SERIES_FILTER, legendFilter);
  registers.registerSubTypeDefaulter("legend", function() {
    return "plain";
  });
  installLegendAction(registers);
}
var ScrollableLegendModel = function(_super) {
  __extends(ScrollableLegendModel2, _super);
  function ScrollableLegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendModel2.type;
    return _this;
  }
  ScrollableLegendModel2.prototype.setScrollDataIndex = function(scrollDataIndex) {
    this.option.scrollDataIndex = scrollDataIndex;
  };
  ScrollableLegendModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.call(this, option, parentModel, ecModel);
    mergeAndNormalizeLayoutParams(this, option, inputPositionParams);
  };
  ScrollableLegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    mergeAndNormalizeLayoutParams(this, this.option, option);
  };
  ScrollableLegendModel2.type = "legend.scroll";
  ScrollableLegendModel2.defaultOption = inheritDefaultOption(LegendModel$1.defaultOption, {
    scrollDataIndex: 0,
    pageButtonItemGap: 5,
    pageButtonGap: null,
    pageButtonPosition: "end",
    pageFormatter: "{current}/{total}",
    pageIcons: {
      horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"],
      vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"]
    },
    pageIconColor: "#2f4554",
    pageIconInactiveColor: "#aaa",
    pageIconSize: 15,
    pageTextStyle: {
      color: "#333"
    },
    animationDurationUpdate: 800
  });
  return ScrollableLegendModel2;
}(LegendModel$1);
function mergeAndNormalizeLayoutParams(legendModel, target, raw) {
  var orient = legendModel.getOrient();
  var ignoreSize = [1, 1];
  ignoreSize[orient.index] = 0;
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize: !!ignoreSize
  });
}
var ScrollableLegendModel$1 = ScrollableLegendModel;
var Group = Group$4;
var WH = ["width", "height"];
var XY = ["x", "y"];
var ScrollableLegendView = function(_super) {
  __extends(ScrollableLegendView2, _super);
  function ScrollableLegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendView2.type;
    _this.newlineDisabled = true;
    _this._currentIndex = 0;
    return _this;
  }
  ScrollableLegendView2.prototype.init = function() {
    _super.prototype.init.call(this);
    this.group.add(this._containerGroup = new Group());
    this._containerGroup.add(this.getContentGroup());
    this.group.add(this._controllerGroup = new Group());
  };
  ScrollableLegendView2.prototype.resetInner = function() {
    _super.prototype.resetInner.call(this);
    this._controllerGroup.removeAll();
    this._containerGroup.removeClipPath();
    this._containerGroup.__rectSize = null;
  };
  ScrollableLegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var self2 = this;
    _super.prototype.renderInner.call(this, itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var controllerGroup = this._controllerGroup;
    var pageIconSize = legendModel.get("pageIconSize", true);
    var pageIconSizeArr = isArray$1(pageIconSize) ? pageIconSize : [pageIconSize, pageIconSize];
    createPageButton("pagePrev", 0);
    var pageTextStyleModel = legendModel.getModel("pageTextStyle");
    controllerGroup.add(new ZRText$1({
      name: "pageText",
      style: {
        text: "xx/xx",
        fill: pageTextStyleModel.getTextColor(),
        font: pageTextStyleModel.getFont(),
        verticalAlign: "middle",
        align: "center"
      },
      silent: true
    }));
    createPageButton("pageNext", 1);
    function createPageButton(name, iconIdx) {
      var pageDataIndexName = name + "DataIndex";
      var icon = createIcon(legendModel.get("pageIcons", true)[legendModel.getOrient().name][iconIdx], {
        onclick: bind$1(self2._pageGo, self2, pageDataIndexName, legendModel, api)
      }, {
        x: -pageIconSizeArr[0] / 2,
        y: -pageIconSizeArr[1] / 2,
        width: pageIconSizeArr[0],
        height: pageIconSizeArr[1]
      });
      icon.name = name;
      controllerGroup.add(icon);
    }
  };
  ScrollableLegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    var orientIdx = legendModel.getOrient().index;
    var wh = WH[orientIdx];
    var xy = XY[orientIdx];
    var hw = WH[1 - orientIdx];
    var yx = XY[1 - orientIdx];
    selector2 && box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
    var selectorButtonGap = legendModel.get("selectorButtonGap", true);
    var selectorRect = selectorGroup.getBoundingRect();
    var selectorPos = [-selectorRect.x, -selectorRect.y];
    var processMaxSize = clone$4(maxSize);
    selector2 && (processMaxSize[wh] = maxSize[wh] - selectorRect[wh] - selectorButtonGap);
    var mainRect = this._layoutContentAndController(legendModel, isFirstRender, processMaxSize, orientIdx, wh, hw, yx, xy);
    if (selector2) {
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += mainRect[wh] + selectorButtonGap;
      } else {
        var offset = selectorRect[wh] + selectorButtonGap;
        selectorPos[orientIdx] -= offset;
        mainRect[xy] -= offset;
      }
      mainRect[wh] += selectorRect[wh] + selectorButtonGap;
      selectorPos[1 - orientIdx] += mainRect[yx] + mainRect[hw] / 2 - selectorRect[hw] / 2;
      mainRect[hw] = Math.max(mainRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(mainRect[yx], selectorRect[yx] + selectorPos[1 - orientIdx]);
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      selectorGroup.markRedraw();
    }
    return mainRect;
  };
  ScrollableLegendView2.prototype._layoutContentAndController = function(legendModel, isFirstRender, maxSize, orientIdx, wh, hw, yx, xy) {
    var contentGroup = this.getContentGroup();
    var containerGroup = this._containerGroup;
    var controllerGroup = this._controllerGroup;
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), !orientIdx ? null : maxSize.width, orientIdx ? null : maxSize.height);
    box("horizontal", controllerGroup, legendModel.get("pageButtonItemGap", true));
    var contentRect = contentGroup.getBoundingRect();
    var controllerRect = controllerGroup.getBoundingRect();
    var showController = this._showController = contentRect[wh] > maxSize[wh];
    var contentPos = [-contentRect.x, -contentRect.y];
    if (!isFirstRender) {
      contentPos[orientIdx] = contentGroup[xy];
    }
    var containerPos = [0, 0];
    var controllerPos = [-controllerRect.x, -controllerRect.y];
    var pageButtonGap = retrieve2(legendModel.get("pageButtonGap", true), legendModel.get("itemGap", true));
    if (showController) {
      var pageButtonPosition = legendModel.get("pageButtonPosition", true);
      if (pageButtonPosition === "end") {
        controllerPos[orientIdx] += maxSize[wh] - controllerRect[wh];
      } else {
        containerPos[orientIdx] += controllerRect[wh] + pageButtonGap;
      }
    }
    controllerPos[1 - orientIdx] += contentRect[hw] / 2 - controllerRect[hw] / 2;
    contentGroup.setPosition(contentPos);
    containerGroup.setPosition(containerPos);
    controllerGroup.setPosition(controllerPos);
    var mainRect = {
      x: 0,
      y: 0
    };
    mainRect[wh] = showController ? maxSize[wh] : contentRect[wh];
    mainRect[hw] = Math.max(contentRect[hw], controllerRect[hw]);
    mainRect[yx] = Math.min(0, controllerRect[yx] + controllerPos[1 - orientIdx]);
    containerGroup.__rectSize = maxSize[wh];
    if (showController) {
      var clipShape = {
        x: 0,
        y: 0
      };
      clipShape[wh] = Math.max(maxSize[wh] - controllerRect[wh] - pageButtonGap, 0);
      clipShape[hw] = mainRect[hw];
      containerGroup.setClipPath(new Rect$3({
        shape: clipShape
      }));
      containerGroup.__rectSize = clipShape[wh];
    } else {
      controllerGroup.eachChild(function(child) {
        child.attr({
          invisible: true,
          silent: true
        });
      });
    }
    var pageInfo = this._getPageInfo(legendModel);
    pageInfo.pageIndex != null && updateProps$1(contentGroup, {
      x: pageInfo.contentPosition[0],
      y: pageInfo.contentPosition[1]
    }, showController ? legendModel : null);
    this._updatePageInfoView(legendModel, pageInfo);
    return mainRect;
  };
  ScrollableLegendView2.prototype._pageGo = function(to, legendModel, api) {
    var scrollDataIndex = this._getPageInfo(legendModel)[to];
    scrollDataIndex != null && api.dispatchAction({
      type: "legendScroll",
      scrollDataIndex,
      legendId: legendModel.id
    });
  };
  ScrollableLegendView2.prototype._updatePageInfoView = function(legendModel, pageInfo) {
    var controllerGroup = this._controllerGroup;
    each$f(["pagePrev", "pageNext"], function(name) {
      var key = name + "DataIndex";
      var canJump = pageInfo[key] != null;
      var icon = controllerGroup.childOfName(name);
      if (icon) {
        icon.setStyle("fill", canJump ? legendModel.get("pageIconColor", true) : legendModel.get("pageIconInactiveColor", true));
        icon.cursor = canJump ? "pointer" : "default";
      }
    });
    var pageText = controllerGroup.childOfName("pageText");
    var pageFormatter = legendModel.get("pageFormatter");
    var pageIndex = pageInfo.pageIndex;
    var current = pageIndex != null ? pageIndex + 1 : 0;
    var total = pageInfo.pageCount;
    pageText && pageFormatter && pageText.setStyle("text", isString(pageFormatter) ? pageFormatter.replace("{current}", current == null ? "" : current + "").replace("{total}", total == null ? "" : total + "") : pageFormatter({
      current,
      total
    }));
  };
  ScrollableLegendView2.prototype._getPageInfo = function(legendModel) {
    var scrollDataIndex = legendModel.get("scrollDataIndex", true);
    var contentGroup = this.getContentGroup();
    var containerRectSize = this._containerGroup.__rectSize;
    var orientIdx = legendModel.getOrient().index;
    var wh = WH[orientIdx];
    var xy = XY[orientIdx];
    var targetItemIndex = this._findTargetItemIndex(scrollDataIndex);
    var children = contentGroup.children();
    var targetItem = children[targetItemIndex];
    var itemCount = children.length;
    var pCount = !itemCount ? 0 : 1;
    var result = {
      contentPosition: [contentGroup.x, contentGroup.y],
      pageCount: pCount,
      pageIndex: pCount - 1,
      pagePrevDataIndex: null,
      pageNextDataIndex: null
    };
    if (!targetItem) {
      return result;
    }
    var targetItemInfo = getItemInfo(targetItem);
    result.contentPosition[orientIdx] = -targetItemInfo.s;
    for (var i = targetItemIndex + 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i <= itemCount; ++i) {
      currItemInfo = getItemInfo(children[i]);
      if (!currItemInfo && winEndItemInfo.e > winStartItemInfo.s + containerRectSize || currItemInfo && !intersect2(currItemInfo, winStartItemInfo.s)) {
        if (winEndItemInfo.i > winStartItemInfo.i) {
          winStartItemInfo = winEndItemInfo;
        } else {
          winStartItemInfo = currItemInfo;
        }
        if (winStartItemInfo) {
          if (result.pageNextDataIndex == null) {
            result.pageNextDataIndex = winStartItemInfo.i;
          }
          ++result.pageCount;
        }
      }
      winEndItemInfo = currItemInfo;
    }
    for (var i = targetItemIndex - 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i >= -1; --i) {
      currItemInfo = getItemInfo(children[i]);
      if ((!currItemInfo || !intersect2(winEndItemInfo, currItemInfo.s)) && winStartItemInfo.i < winEndItemInfo.i) {
        winEndItemInfo = winStartItemInfo;
        if (result.pagePrevDataIndex == null) {
          result.pagePrevDataIndex = winStartItemInfo.i;
        }
        ++result.pageCount;
        ++result.pageIndex;
      }
      winStartItemInfo = currItemInfo;
    }
    return result;
    function getItemInfo(el) {
      if (el) {
        var itemRect = el.getBoundingRect();
        var start2 = itemRect[xy] + el[xy];
        return {
          s: start2,
          e: start2 + itemRect[wh],
          i: el.__legendDataIndex
        };
      }
    }
    function intersect2(itemInfo, winStart) {
      return itemInfo.e >= winStart && itemInfo.s <= winStart + containerRectSize;
    }
  };
  ScrollableLegendView2.prototype._findTargetItemIndex = function(targetDataIndex) {
    if (!this._showController) {
      return 0;
    }
    var index2;
    var contentGroup = this.getContentGroup();
    var defaultIndex;
    contentGroup.eachChild(function(child, idx) {
      var legendDataIdx = child.__legendDataIndex;
      if (defaultIndex == null && legendDataIdx != null) {
        defaultIndex = idx;
      }
      if (legendDataIdx === targetDataIndex) {
        index2 = idx;
      }
    });
    return index2 != null ? index2 : defaultIndex;
  };
  ScrollableLegendView2.type = "legend.scroll";
  return ScrollableLegendView2;
}(LegendView$1);
var ScrollableLegendView$1 = ScrollableLegendView;
function installScrollableLegendAction(registers) {
  registers.registerAction("legendScroll", "legendscroll", function(payload, ecModel) {
    var scrollDataIndex = payload.scrollDataIndex;
    scrollDataIndex != null && ecModel.eachComponent({
      mainType: "legend",
      subType: "scroll",
      query: payload
    }, function(legendModel) {
      legendModel.setScrollDataIndex(scrollDataIndex);
    });
  });
}
function install$a(registers) {
  use(install$b);
  registers.registerComponentModel(ScrollableLegendModel$1);
  registers.registerComponentView(ScrollableLegendView$1);
  installScrollableLegendAction(registers);
}
function install$9(registers) {
  use(install$b);
  use(install$a);
}
var InsideZoomModel = function(_super) {
  __extends(InsideZoomModel2, _super);
  function InsideZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = InsideZoomModel2.type;
    return _this;
  }
  InsideZoomModel2.type = "dataZoom.inside";
  InsideZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    disabled: false,
    zoomLock: false,
    zoomOnMouseWheel: true,
    moveOnMouseMove: true,
    moveOnMouseWheel: false,
    preventDefaultMouseMove: true
  });
  return InsideZoomModel2;
}(DataZoomModel$1);
var InsideZoomModel$1 = InsideZoomModel;
var inner$1 = makeInner();
function setViewInfoToCoordSysRecord(api, dataZoomModel, getRange) {
  inner$1(api).coordSysRecordMap.each(function(coordSysRecord) {
    var dzInfo = coordSysRecord.dataZoomInfoMap.get(dataZoomModel.uid);
    if (dzInfo) {
      dzInfo.getRange = getRange;
    }
  });
}
function disposeCoordSysRecordIfNeeded(api, dataZoomModel) {
  var coordSysRecordMap = inner$1(api).coordSysRecordMap;
  var coordSysKeyArr = coordSysRecordMap.keys();
  for (var i = 0; i < coordSysKeyArr.length; i++) {
    var coordSysKey = coordSysKeyArr[i];
    var coordSysRecord = coordSysRecordMap.get(coordSysKey);
    var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
    if (dataZoomInfoMap) {
      var dzUid = dataZoomModel.uid;
      var dzInfo = dataZoomInfoMap.get(dzUid);
      if (dzInfo) {
        dataZoomInfoMap.removeKey(dzUid);
        if (!dataZoomInfoMap.keys().length) {
          disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        }
      }
    }
  }
}
function disposeCoordSysRecord(coordSysRecordMap, coordSysRecord) {
  if (coordSysRecord) {
    coordSysRecordMap.removeKey(coordSysRecord.model.uid);
    var controller = coordSysRecord.controller;
    controller && controller.dispose();
  }
}
function createCoordSysRecord(api, coordSysModel) {
  var coordSysRecord = {
    model: coordSysModel,
    containsPoint: curry$1(containsPoint, coordSysModel),
    dispatchAction: curry$1(dispatchAction, api),
    dataZoomInfoMap: null,
    controller: null
  };
  var controller = coordSysRecord.controller = new RoamController$1(api.getZr());
  each$f(["pan", "zoom", "scrollMove"], function(eventName) {
    controller.on(eventName, function(event) {
      var batch = [];
      coordSysRecord.dataZoomInfoMap.each(function(dzInfo) {
        if (!event.isAvailableBehavior(dzInfo.model.option)) {
          return;
        }
        var method4 = (dzInfo.getRange || {})[eventName];
        var range3 = method4 && method4(dzInfo.dzReferCoordSysInfo, coordSysRecord.model.mainType, coordSysRecord.controller, event);
        !dzInfo.model.get("disabled", true) && range3 && batch.push({
          dataZoomId: dzInfo.model.id,
          start: range3[0],
          end: range3[1]
        });
      });
      batch.length && coordSysRecord.dispatchAction(batch);
    });
  });
  return coordSysRecord;
}
function dispatchAction(api, batch) {
  if (!api.isDisposed()) {
    api.dispatchAction({
      type: "dataZoom",
      animation: {
        easing: "cubicOut",
        duration: 100
      },
      batch
    });
  }
}
function containsPoint(coordSysModel, e2, x2, y2) {
  return coordSysModel.coordinateSystem.containPoint([x2, y2]);
}
function mergeControllerParams(dataZoomInfoMap) {
  var controlType;
  var prefix = "type_";
  var typePriority = {
    "type_true": 2,
    "type_move": 1,
    "type_false": 0,
    "type_undefined": -1
  };
  var preventDefaultMouseMove = true;
  dataZoomInfoMap.each(function(dataZoomInfo) {
    var dataZoomModel = dataZoomInfo.model;
    var oneType = dataZoomModel.get("disabled", true) ? false : dataZoomModel.get("zoomLock", true) ? "move" : true;
    if (typePriority[prefix + oneType] > typePriority[prefix + controlType]) {
      controlType = oneType;
    }
    preventDefaultMouseMove = preventDefaultMouseMove && dataZoomModel.get("preventDefaultMouseMove", true);
  });
  return {
    controlType,
    opt: {
      zoomOnMouseWheel: true,
      moveOnMouseMove: true,
      moveOnMouseWheel: true,
      preventDefaultMouseMove: !!preventDefaultMouseMove
    }
  };
}
function installDataZoomRoamProcessor(registers) {
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, function(ecModel, api) {
    var apiInner = inner$1(api);
    var coordSysRecordMap = apiInner.coordSysRecordMap || (apiInner.coordSysRecordMap = createHashMap());
    coordSysRecordMap.each(function(coordSysRecord) {
      coordSysRecord.dataZoomInfoMap = null;
    });
    ecModel.eachComponent({
      mainType: "dataZoom",
      subType: "inside"
    }, function(dataZoomModel) {
      var dzReferCoordSysWrap = collectReferCoordSysModelInfo(dataZoomModel);
      each$f(dzReferCoordSysWrap.infoList, function(dzCoordSysInfo) {
        var coordSysUid = dzCoordSysInfo.model.uid;
        var coordSysRecord = coordSysRecordMap.get(coordSysUid) || coordSysRecordMap.set(coordSysUid, createCoordSysRecord(api, dzCoordSysInfo.model));
        var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap || (coordSysRecord.dataZoomInfoMap = createHashMap());
        dataZoomInfoMap.set(dataZoomModel.uid, {
          dzReferCoordSysInfo: dzCoordSysInfo,
          model: dataZoomModel,
          getRange: null
        });
      });
    });
    coordSysRecordMap.each(function(coordSysRecord) {
      var controller = coordSysRecord.controller;
      var firstDzInfo;
      var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
      if (dataZoomInfoMap) {
        var firstDzKey = dataZoomInfoMap.keys()[0];
        if (firstDzKey != null) {
          firstDzInfo = dataZoomInfoMap.get(firstDzKey);
        }
      }
      if (!firstDzInfo) {
        disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        return;
      }
      var controllerParams = mergeControllerParams(dataZoomInfoMap);
      controller.enable(controllerParams.controlType, controllerParams.opt);
      controller.setPointerChecker(coordSysRecord.containsPoint);
      createOrUpdate(coordSysRecord, "dispatchAction", firstDzInfo.model.get("throttle", true), "fixRate");
    });
  });
}
var InsideZoomView = function(_super) {
  __extends(InsideZoomView2, _super);
  function InsideZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataZoom.inside";
    return _this;
  }
  InsideZoomView2.prototype.render = function(dataZoomModel, ecModel, api) {
    _super.prototype.render.apply(this, arguments);
    if (dataZoomModel.noTarget()) {
      this._clear();
      return;
    }
    this.range = dataZoomModel.getPercentRange();
    setViewInfoToCoordSysRecord(api, dataZoomModel, {
      pan: bind$1(getRangeHandlers.pan, this),
      zoom: bind$1(getRangeHandlers.zoom, this),
      scrollMove: bind$1(getRangeHandlers.scrollMove, this)
    });
  };
  InsideZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  InsideZoomView2.prototype._clear = function() {
    disposeCoordSysRecordIfNeeded(this.api, this.dataZoomModel);
    this.range = null;
  };
  InsideZoomView2.type = "dataZoom.inside";
  return InsideZoomView2;
}(DataZoomView$1);
var getRangeHandlers = {
  zoom: function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var directionInfo = getDirectionInfo[coordSysMainType](null, [e2.originX, e2.originY], axisModel, controller, coordSysInfo);
    var percentPoint = (directionInfo.signal > 0 ? directionInfo.pixelStart + directionInfo.pixelLength - directionInfo.pixel : directionInfo.pixel - directionInfo.pixelStart) / directionInfo.pixelLength * (range3[1] - range3[0]) + range3[0];
    var scale2 = Math.max(1 / e2.scale, 0);
    range3[0] = (range3[0] - percentPoint) * scale2 + percentPoint;
    range3[1] = (range3[1] - percentPoint) * scale2 + percentPoint;
    var minMaxSpan = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    sliderMove(0, range3, [0, 100], 0, minMaxSpan.minSpan, minMaxSpan.maxSpan);
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  },
  pan: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([e2.oldX, e2.oldY], [e2.newX, e2.newY], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * directionInfo.pixel / directionInfo.pixelLength;
  }),
  scrollMove: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([0, 0], [e2.scrollDelta, e2.scrollDelta], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * e2.scrollDelta;
  })
};
function makeMover(getPercentDelta) {
  return function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var percentDelta = getPercentDelta(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2);
    sliderMove(percentDelta, range3, [0, 100], "all");
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  };
}
var getDirectionInfo = {
  grid: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    oldPoint = oldPoint || [0, 0];
    if (axis.dim === "x") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  polar: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var polar = coordSysInfo.model.coordinateSystem;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var angleExtent = polar.getAngleAxis().getExtent();
    oldPoint = oldPoint ? polar.pointToCoord(oldPoint) : [0, 0];
    newPoint = polar.pointToCoord(newPoint);
    if (axisModel.mainType === "radiusAxis") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = radiusExtent[1] - radiusExtent[0];
      ret.pixelStart = radiusExtent[0];
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = angleExtent[1] - angleExtent[0];
      ret.pixelStart = angleExtent[0];
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  singleAxis: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    var ret = {};
    oldPoint = oldPoint || [0, 0];
    if (axis.orient === "horizontal") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  }
};
var InsideZoomView$1 = InsideZoomView;
function install$8(registers) {
  installCommon$1(registers);
  registers.registerComponentModel(InsideZoomModel$1);
  registers.registerComponentView(InsideZoomView$1);
  installDataZoomRoamProcessor(registers);
}
var SliderZoomModel = function(_super) {
  __extends(SliderZoomModel2, _super);
  function SliderZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomModel2.type;
    return _this;
  }
  SliderZoomModel2.type = "dataZoom.slider";
  SliderZoomModel2.layoutMode = "box";
  SliderZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    show: true,
    right: "ph",
    top: "ph",
    width: "ph",
    height: "ph",
    left: null,
    bottom: null,
    borderColor: "#d2dbee",
    borderRadius: 3,
    backgroundColor: "rgba(47,69,84,0)",
    dataBackground: {
      lineStyle: {
        color: "#d2dbee",
        width: 0.5
      },
      areaStyle: {
        color: "#d2dbee",
        opacity: 0.2
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#8fb0f7",
        width: 0.5
      },
      areaStyle: {
        color: "#8fb0f7",
        opacity: 0.2
      }
    },
    fillerColor: "rgba(135,175,274,0.2)",
    handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z",
    handleSize: "100%",
    handleStyle: {
      color: "#fff",
      borderColor: "#ACB8D1"
    },
    moveHandleSize: 7,
    moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z",
    moveHandleStyle: {
      color: "#D2DBEE",
      opacity: 0.7
    },
    showDetail: true,
    showDataShadow: "auto",
    realtime: true,
    zoomLock: false,
    textStyle: {
      color: "#6E7079"
    },
    brushSelect: true,
    brushStyle: {
      color: "rgba(135,175,274,0.15)"
    },
    emphasis: {
      handleStyle: {
        borderColor: "#8FB0F7"
      },
      moveHandleStyle: {
        color: "#8FB0F7"
      }
    }
  });
  return SliderZoomModel2;
}(DataZoomModel$1);
var SliderZoomModel$1 = SliderZoomModel;
var Rect = Rect$3;
var DEFAULT_LOCATION_EDGE_GAP = 7;
var DEFAULT_FRAME_BORDER_WIDTH = 1;
var DEFAULT_FILLER_SIZE = 30;
var DEFAULT_MOVE_HANDLE_SIZE = 7;
var HORIZONTAL = "horizontal";
var VERTICAL = "vertical";
var LABEL_GAP = 5;
var SHOW_DATA_SHADOW_SERIES_TYPE = ["line", "bar", "candlestick", "scatter"];
var REALTIME_ANIMATION_CONFIG = {
  easing: "cubicOut",
  duration: 100,
  delay: 0
};
var SliderZoomView = function(_super) {
  __extends(SliderZoomView2, _super);
  function SliderZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomView2.type;
    _this._displayables = {};
    return _this;
  }
  SliderZoomView2.prototype.init = function(ecModel, api) {
    this.api = api;
    this._onBrush = bind$1(this._onBrush, this);
    this._onBrushEnd = bind$1(this._onBrushEnd, this);
  };
  SliderZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    _super.prototype.render.apply(this, arguments);
    createOrUpdate(this, "_dispatchZoomAction", dataZoomModel.get("throttle"), "fixRate");
    this._orient = dataZoomModel.getOrient();
    if (dataZoomModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    if (dataZoomModel.noTarget()) {
      this._clear();
      this.group.removeAll();
      return;
    }
    if (!payload || payload.type !== "dataZoom" || payload.from !== this.uid) {
      this._buildView();
    }
    this._updateView();
  };
  SliderZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  SliderZoomView2.prototype._clear = function() {
    clear$1(this, "_dispatchZoomAction");
    var zr = this.api.getZr();
    zr.off("mousemove", this._onBrush);
    zr.off("mouseup", this._onBrushEnd);
  };
  SliderZoomView2.prototype._buildView = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    this._brushing = false;
    this._displayables.brushRect = null;
    this._resetLocation();
    this._resetInterval();
    var barGroup = this._displayables.sliderGroup = new Group$4();
    this._renderBackground();
    this._renderHandle();
    this._renderDataShadow();
    thisGroup.add(barGroup);
    this._positionGroup();
  };
  SliderZoomView2.prototype._resetLocation = function() {
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var showMoveHandle = dataZoomModel.get("brushSelect");
    var moveHandleSize = showMoveHandle ? DEFAULT_MOVE_HANDLE_SIZE : 0;
    var coordRect = this._findCoordRect();
    var ecSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var positionInfo = this._orient === HORIZONTAL ? {
      right: ecSize.width - coordRect.x - coordRect.width,
      top: ecSize.height - DEFAULT_FILLER_SIZE - DEFAULT_LOCATION_EDGE_GAP - moveHandleSize,
      width: coordRect.width,
      height: DEFAULT_FILLER_SIZE
    } : {
      right: DEFAULT_LOCATION_EDGE_GAP,
      top: coordRect.y,
      width: DEFAULT_FILLER_SIZE,
      height: coordRect.height
    };
    var layoutParams = getLayoutParams(dataZoomModel.option);
    each$f(["right", "top", "width", "height"], function(name) {
      if (layoutParams[name] === "ph") {
        layoutParams[name] = positionInfo[name];
      }
    });
    var layoutRect = getLayoutRect(layoutParams, ecSize);
    this._location = {
      x: layoutRect.x,
      y: layoutRect.y
    };
    this._size = [layoutRect.width, layoutRect.height];
    this._orient === VERTICAL && this._size.reverse();
  };
  SliderZoomView2.prototype._positionGroup = function() {
    var thisGroup = this.group;
    var location = this._location;
    var orient = this._orient;
    var targetAxisModel = this.dataZoomModel.getFirstTargetAxisModel();
    var inverse = targetAxisModel && targetAxisModel.get("inverse");
    var sliderGroup = this._displayables.sliderGroup;
    var otherAxisInverse = (this._dataShadowInfo || {}).otherAxisInverse;
    sliderGroup.attr(orient === HORIZONTAL && !inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: 1
    } : orient === HORIZONTAL && inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: -1
    } : orient === VERTICAL && !inverse ? {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: 1,
      rotation: Math.PI / 2
    } : {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: -1,
      rotation: Math.PI / 2
    });
    var rect = thisGroup.getBoundingRect([sliderGroup]);
    thisGroup.x = location.x - rect.x;
    thisGroup.y = location.y - rect.y;
    thisGroup.markRedraw();
  };
  SliderZoomView2.prototype._getViewExtent = function() {
    return [0, this._size[0]];
  };
  SliderZoomView2.prototype._renderBackground = function() {
    var dataZoomModel = this.dataZoomModel;
    var size = this._size;
    var barGroup = this._displayables.sliderGroup;
    var brushSelect = dataZoomModel.get("brushSelect");
    barGroup.add(new Rect({
      silent: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: dataZoomModel.get("backgroundColor")
      },
      z2: -40
    }));
    var clickPanel = new Rect({
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: "transparent"
      },
      z2: 0,
      onclick: bind$1(this._onClickPanel, this)
    });
    var zr = this.api.getZr();
    if (brushSelect) {
      clickPanel.on("mousedown", this._onBrushStart, this);
      clickPanel.cursor = "crosshair";
      zr.on("mousemove", this._onBrush);
      zr.on("mouseup", this._onBrushEnd);
    } else {
      zr.off("mousemove", this._onBrush);
      zr.off("mouseup", this._onBrushEnd);
    }
    barGroup.add(clickPanel);
  };
  SliderZoomView2.prototype._renderDataShadow = function() {
    var info = this._dataShadowInfo = this._prepareDataShadowInfo();
    this._displayables.dataShadowSegs = [];
    if (!info) {
      return;
    }
    var size = this._size;
    var oldSize = this._shadowSize || [];
    var seriesModel = info.series;
    var data = seriesModel.getRawData();
    var otherDim = seriesModel.getShadowDim ? seriesModel.getShadowDim() : info.otherDim;
    if (otherDim == null) {
      return;
    }
    var polygonPts = this._shadowPolygonPts;
    var polylinePts = this._shadowPolylinePts;
    if (data !== this._shadowData || otherDim !== this._shadowDim || size[0] !== oldSize[0] || size[1] !== oldSize[1]) {
      var otherDataExtent_1 = data.getDataExtent(otherDim);
      var otherOffset = (otherDataExtent_1[1] - otherDataExtent_1[0]) * 0.3;
      otherDataExtent_1 = [otherDataExtent_1[0] - otherOffset, otherDataExtent_1[1] + otherOffset];
      var otherShadowExtent_1 = [0, size[1]];
      var thisShadowExtent = [0, size[0]];
      var areaPoints_1 = [[size[0], 0], [0, 0]];
      var linePoints_1 = [];
      var step_1 = thisShadowExtent[1] / (data.count() - 1);
      var thisCoord_1 = 0;
      var stride_1 = Math.round(data.count() / size[0]);
      var lastIsEmpty_1;
      data.each([otherDim], function(value, index2) {
        if (stride_1 > 0 && index2 % stride_1) {
          thisCoord_1 += step_1;
          return;
        }
        var isEmpty = value == null || isNaN(value) || value === "";
        var otherCoord = isEmpty ? 0 : linearMap$2(value, otherDataExtent_1, otherShadowExtent_1, true);
        if (isEmpty && !lastIsEmpty_1 && index2) {
          areaPoints_1.push([areaPoints_1[areaPoints_1.length - 1][0], 0]);
          linePoints_1.push([linePoints_1[linePoints_1.length - 1][0], 0]);
        } else if (!isEmpty && lastIsEmpty_1) {
          areaPoints_1.push([thisCoord_1, 0]);
          linePoints_1.push([thisCoord_1, 0]);
        }
        areaPoints_1.push([thisCoord_1, otherCoord]);
        linePoints_1.push([thisCoord_1, otherCoord]);
        thisCoord_1 += step_1;
        lastIsEmpty_1 = isEmpty;
      });
      polygonPts = this._shadowPolygonPts = areaPoints_1;
      polylinePts = this._shadowPolylinePts = linePoints_1;
    }
    this._shadowData = data;
    this._shadowDim = otherDim;
    this._shadowSize = [size[0], size[1]];
    var dataZoomModel = this.dataZoomModel;
    function createDataShadowGroup(isSelectedArea) {
      var model = dataZoomModel.getModel(isSelectedArea ? "selectedDataBackground" : "dataBackground");
      var group2 = new Group$4();
      var polygon = new Polygon$1({
        shape: {
          points: polygonPts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("areaStyle").getAreaStyle(),
        silent: true,
        z2: -20
      });
      var polyline = new Polyline$3({
        shape: {
          points: polylinePts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("lineStyle").getLineStyle(),
        silent: true,
        z2: -19
      });
      group2.add(polygon);
      group2.add(polyline);
      return group2;
    }
    for (var i = 0; i < 3; i++) {
      var group = createDataShadowGroup(i === 1);
      this._displayables.sliderGroup.add(group);
      this._displayables.dataShadowSegs.push(group);
    }
  };
  SliderZoomView2.prototype._prepareDataShadowInfo = function() {
    var dataZoomModel = this.dataZoomModel;
    var showDataShadow = dataZoomModel.get("showDataShadow");
    if (showDataShadow === false) {
      return;
    }
    var result;
    var ecModel = this.ecModel;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var seriesModels = dataZoomModel.getAxisProxy(axisDim, axisIndex).getTargetSeriesModels();
      each$f(seriesModels, function(seriesModel) {
        if (result) {
          return;
        }
        if (showDataShadow !== true && indexOf(SHOW_DATA_SHADOW_SERIES_TYPE, seriesModel.get("type")) < 0) {
          return;
        }
        var thisAxis = ecModel.getComponent(getAxisMainType(axisDim), axisIndex).axis;
        var otherDim = getOtherDim(axisDim);
        var otherAxisInverse;
        var coordSys = seriesModel.coordinateSystem;
        if (otherDim != null && coordSys.getOtherAxis) {
          otherAxisInverse = coordSys.getOtherAxis(thisAxis).inverse;
        }
        otherDim = seriesModel.getData().mapDimension(otherDim);
        result = {
          thisAxis,
          series: seriesModel,
          thisDim: axisDim,
          otherDim,
          otherAxisInverse
        };
      }, this);
    }, this);
    return result;
  };
  SliderZoomView2.prototype._renderHandle = function() {
    var thisGroup = this.group;
    var displayables = this._displayables;
    var handles = displayables.handles = [null, null];
    var handleLabels = displayables.handleLabels = [null, null];
    var sliderGroup = this._displayables.sliderGroup;
    var size = this._size;
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var borderRadius = dataZoomModel.get("borderRadius") || 0;
    var brushSelect = dataZoomModel.get("brushSelect");
    var filler = displayables.filler = new Rect({
      silent: brushSelect,
      style: {
        fill: dataZoomModel.get("fillerColor")
      },
      textConfig: {
        position: "inside"
      }
    });
    sliderGroup.add(filler);
    sliderGroup.add(new Rect({
      silent: true,
      subPixelOptimize: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1],
        r: borderRadius
      },
      style: {
        stroke: dataZoomModel.get("dataBackgroundColor") || dataZoomModel.get("borderColor"),
        lineWidth: DEFAULT_FRAME_BORDER_WIDTH,
        fill: "rgba(0,0,0,0)"
      }
    }));
    each$f([0, 1], function(handleIndex) {
      var iconStr = dataZoomModel.get("handleIcon");
      if (!symbolBuildProxies[iconStr] && iconStr.indexOf("path://") < 0 && iconStr.indexOf("image://") < 0) {
        iconStr = "path://" + iconStr;
      }
      var path = createSymbol$1(iconStr, -1, 0, 2, 2, null, true);
      path.attr({
        cursor: getCursor$1(this._orient),
        draggable: true,
        drift: bind$1(this._onDragMove, this, handleIndex),
        ondragend: bind$1(this._onDragEnd, this),
        onmouseover: bind$1(this._showDataInfo, this, true),
        onmouseout: bind$1(this._showDataInfo, this, false),
        z2: 5
      });
      var bRect = path.getBoundingRect();
      var handleSize = dataZoomModel.get("handleSize");
      this._handleHeight = parsePercent(handleSize, this._size[1]);
      this._handleWidth = bRect.width / bRect.height * this._handleHeight;
      path.setStyle(dataZoomModel.getModel("handleStyle").getItemStyle());
      path.style.strokeNoScale = true;
      path.rectHover = true;
      path.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
      enableHoverEmphasis(path);
      var handleColor = dataZoomModel.get("handleColor");
      if (handleColor != null) {
        path.style.fill = handleColor;
      }
      sliderGroup.add(handles[handleIndex] = path);
      var textStyleModel = dataZoomModel.getModel("textStyle");
      thisGroup.add(handleLabels[handleIndex] = new ZRText$1({
        silent: true,
        invisible: true,
        style: createTextStyle(textStyleModel, {
          x: 0,
          y: 0,
          text: "",
          verticalAlign: "middle",
          align: "center",
          fill: textStyleModel.getTextColor(),
          font: textStyleModel.getFont()
        }),
        z2: 10
      }));
    }, this);
    var actualMoveZone = filler;
    if (brushSelect) {
      var moveHandleHeight = parsePercent(dataZoomModel.get("moveHandleSize"), size[1]);
      var moveHandle_1 = displayables.moveHandle = new Rect$3({
        style: dataZoomModel.getModel("moveHandleStyle").getItemStyle(),
        silent: true,
        shape: {
          r: [0, 0, 2, 2],
          y: size[1] - 0.5,
          height: moveHandleHeight
        }
      });
      var iconSize = moveHandleHeight * 0.8;
      var moveHandleIcon = displayables.moveHandleIcon = createSymbol$1(dataZoomModel.get("moveHandleIcon"), -iconSize / 2, -iconSize / 2, iconSize, iconSize, "#fff", true);
      moveHandleIcon.silent = true;
      moveHandleIcon.y = size[1] + moveHandleHeight / 2 - 0.5;
      moveHandle_1.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
      var moveZoneExpandSize = Math.min(size[1] / 2, Math.max(moveHandleHeight, 10));
      actualMoveZone = displayables.moveZone = new Rect$3({
        invisible: true,
        shape: {
          y: size[1] - moveZoneExpandSize,
          height: moveHandleHeight + moveZoneExpandSize
        }
      });
      actualMoveZone.on("mouseover", function() {
        api.enterEmphasis(moveHandle_1);
      }).on("mouseout", function() {
        api.leaveEmphasis(moveHandle_1);
      });
      sliderGroup.add(moveHandle_1);
      sliderGroup.add(moveHandleIcon);
      sliderGroup.add(actualMoveZone);
    }
    actualMoveZone.attr({
      draggable: true,
      cursor: getCursor$1(this._orient),
      drift: bind$1(this._onDragMove, this, "all"),
      ondragstart: bind$1(this._showDataInfo, this, true),
      ondragend: bind$1(this._onDragEnd, this),
      onmouseover: bind$1(this._showDataInfo, this, true),
      onmouseout: bind$1(this._showDataInfo, this, false)
    });
  };
  SliderZoomView2.prototype._resetInterval = function() {
    var range3 = this._range = this.dataZoomModel.getPercentRange();
    var viewExtent = this._getViewExtent();
    this._handleEnds = [linearMap$2(range3[0], [0, 100], viewExtent, true), linearMap$2(range3[1], [0, 100], viewExtent, true)];
  };
  SliderZoomView2.prototype._updateInterval = function(handleIndex, delta) {
    var dataZoomModel = this.dataZoomModel;
    var handleEnds = this._handleEnds;
    var viewExtend = this._getViewExtent();
    var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    var percentExtent = [0, 100];
    sliderMove(delta, handleEnds, viewExtend, dataZoomModel.get("zoomLock") ? "all" : handleIndex, minMaxSpan.minSpan != null ? linearMap$2(minMaxSpan.minSpan, percentExtent, viewExtend, true) : null, minMaxSpan.maxSpan != null ? linearMap$2(minMaxSpan.maxSpan, percentExtent, viewExtend, true) : null);
    var lastRange = this._range;
    var range3 = this._range = asc$2([linearMap$2(handleEnds[0], viewExtend, percentExtent, true), linearMap$2(handleEnds[1], viewExtend, percentExtent, true)]);
    return !lastRange || lastRange[0] !== range3[0] || lastRange[1] !== range3[1];
  };
  SliderZoomView2.prototype._updateView = function(nonRealtime) {
    var displaybles = this._displayables;
    var handleEnds = this._handleEnds;
    var handleInterval = asc$2(handleEnds.slice());
    var size = this._size;
    each$f([0, 1], function(handleIndex) {
      var handle = displaybles.handles[handleIndex];
      var handleHeight = this._handleHeight;
      handle.attr({
        scaleX: handleHeight / 2,
        scaleY: handleHeight / 2,
        x: handleEnds[handleIndex] + (handleIndex ? -1 : 1),
        y: size[1] / 2 - handleHeight / 2
      });
    }, this);
    displaybles.filler.setShape({
      x: handleInterval[0],
      y: 0,
      width: handleInterval[1] - handleInterval[0],
      height: size[1]
    });
    var viewExtent = {
      x: handleInterval[0],
      width: handleInterval[1] - handleInterval[0]
    };
    if (displaybles.moveHandle) {
      displaybles.moveHandle.setShape(viewExtent);
      displaybles.moveZone.setShape(viewExtent);
      displaybles.moveZone.getBoundingRect();
      displaybles.moveHandleIcon && displaybles.moveHandleIcon.attr("x", viewExtent.x + viewExtent.width / 2);
    }
    var dataShadowSegs = displaybles.dataShadowSegs;
    var segIntervals = [0, handleInterval[0], handleInterval[1], size[0]];
    for (var i = 0; i < dataShadowSegs.length; i++) {
      var segGroup = dataShadowSegs[i];
      var clipPath = segGroup.getClipPath();
      if (!clipPath) {
        clipPath = new Rect$3();
        segGroup.setClipPath(clipPath);
      }
      clipPath.setShape({
        x: segIntervals[i],
        y: 0,
        width: segIntervals[i + 1] - segIntervals[i],
        height: size[1]
      });
    }
    this._updateDataInfo(nonRealtime);
  };
  SliderZoomView2.prototype._updateDataInfo = function(nonRealtime) {
    var dataZoomModel = this.dataZoomModel;
    var displaybles = this._displayables;
    var handleLabels = displaybles.handleLabels;
    var orient = this._orient;
    var labelTexts = ["", ""];
    if (dataZoomModel.get("showDetail")) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var axis = axisProxy.getAxisModel().axis;
        var range3 = this._range;
        var dataInterval = nonRealtime ? axisProxy.calculateDataWindow({
          start: range3[0],
          end: range3[1]
        }).valueWindow : axisProxy.getDataValueWindow();
        labelTexts = [this._formatLabel(dataInterval[0], axis), this._formatLabel(dataInterval[1], axis)];
      }
    }
    var orderedHandleEnds = asc$2(this._handleEnds.slice());
    setLabel.call(this, 0);
    setLabel.call(this, 1);
    function setLabel(handleIndex) {
      var barTransform = getTransform$1(displaybles.handles[handleIndex].parent, this.group);
      var direction = transformDirection(handleIndex === 0 ? "right" : "left", barTransform);
      var offset = this._handleWidth / 2 + LABEL_GAP;
      var textPoint = applyTransform([orderedHandleEnds[handleIndex] + (handleIndex === 0 ? -offset : offset), this._size[1] / 2], barTransform);
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        verticalAlign: orient === HORIZONTAL ? "middle" : direction,
        align: orient === HORIZONTAL ? direction : "center",
        text: labelTexts[handleIndex]
      });
    }
  };
  SliderZoomView2.prototype._formatLabel = function(value, axis) {
    var dataZoomModel = this.dataZoomModel;
    var labelFormatter = dataZoomModel.get("labelFormatter");
    var labelPrecision = dataZoomModel.get("labelPrecision");
    if (labelPrecision == null || labelPrecision === "auto") {
      labelPrecision = axis.getPixelPrecision();
    }
    var valueStr = value == null || isNaN(value) ? "" : axis.type === "category" || axis.type === "time" ? axis.scale.getLabel({
      value: Math.round(value)
    }) : value.toFixed(Math.min(labelPrecision, 20));
    return isFunction(labelFormatter) ? labelFormatter(value, valueStr) : isString(labelFormatter) ? labelFormatter.replace("{value}", valueStr) : valueStr;
  };
  SliderZoomView2.prototype._showDataInfo = function(showOrHide) {
    showOrHide = this._dragging || showOrHide;
    var displayables = this._displayables;
    var handleLabels = displayables.handleLabels;
    handleLabels[0].attr("invisible", !showOrHide);
    handleLabels[1].attr("invisible", !showOrHide);
    displayables.moveHandle && this.api[showOrHide ? "enterEmphasis" : "leaveEmphasis"](displayables.moveHandle, 1);
  };
  SliderZoomView2.prototype._onDragMove = function(handleIndex, dx, dy, event) {
    this._dragging = true;
    stop(event.event);
    var barTransform = this._displayables.sliderGroup.getLocalTransform();
    var vertex = applyTransform([dx, dy], barTransform, true);
    var changed = this._updateInterval(handleIndex, vertex[0]);
    var realtime = this.dataZoomModel.get("realtime");
    this._updateView(!realtime);
    changed && realtime && this._dispatchZoomAction(true);
  };
  SliderZoomView2.prototype._onDragEnd = function() {
    this._dragging = false;
    this._showDataInfo(false);
    var realtime = this.dataZoomModel.get("realtime");
    !realtime && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onClickPanel = function(e2) {
    var size = this._size;
    var localPoint = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
    if (localPoint[0] < 0 || localPoint[0] > size[0] || localPoint[1] < 0 || localPoint[1] > size[1]) {
      return;
    }
    var handleEnds = this._handleEnds;
    var center2 = (handleEnds[0] + handleEnds[1]) / 2;
    var changed = this._updateInterval("all", localPoint[0] - center2);
    this._updateView();
    changed && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrushStart = function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    this._brushStart = new Point$1(x2, y2);
    this._brushing = true;
    this._brushStartTime = +new Date();
  };
  SliderZoomView2.prototype._onBrushEnd = function(e2) {
    if (!this._brushing) {
      return;
    }
    var brushRect = this._displayables.brushRect;
    this._brushing = false;
    if (!brushRect) {
      return;
    }
    brushRect.attr("ignore", true);
    var brushShape = brushRect.shape;
    var brushEndTime = +new Date();
    if (brushEndTime - this._brushStartTime < 200 && Math.abs(brushShape.width) < 5) {
      return;
    }
    var viewExtend = this._getViewExtent();
    var percentExtent = [0, 100];
    this._range = asc$2([linearMap$2(brushShape.x, viewExtend, percentExtent, true), linearMap$2(brushShape.x + brushShape.width, viewExtend, percentExtent, true)]);
    this._handleEnds = [brushShape.x, brushShape.x + brushShape.width];
    this._updateView();
    this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrush = function(e2) {
    if (this._brushing) {
      stop(e2.event);
      this._updateBrushRect(e2.offsetX, e2.offsetY);
    }
  };
  SliderZoomView2.prototype._updateBrushRect = function(mouseX, mouseY) {
    var displayables = this._displayables;
    var dataZoomModel = this.dataZoomModel;
    var brushRect = displayables.brushRect;
    if (!brushRect) {
      brushRect = displayables.brushRect = new Rect({
        silent: true,
        style: dataZoomModel.getModel("brushStyle").getItemStyle()
      });
      displayables.sliderGroup.add(brushRect);
    }
    brushRect.attr("ignore", false);
    var brushStart = this._brushStart;
    var sliderGroup = this._displayables.sliderGroup;
    var endPoint = sliderGroup.transformCoordToLocal(mouseX, mouseY);
    var startPoint = sliderGroup.transformCoordToLocal(brushStart.x, brushStart.y);
    var size = this._size;
    endPoint[0] = Math.max(Math.min(size[0], endPoint[0]), 0);
    brushRect.setShape({
      x: startPoint[0],
      y: 0,
      width: endPoint[0] - startPoint[0],
      height: size[1]
    });
  };
  SliderZoomView2.prototype._dispatchZoomAction = function(realtime) {
    var range3 = this._range;
    this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      dataZoomId: this.dataZoomModel.id,
      animation: realtime ? REALTIME_ANIMATION_CONFIG : null,
      start: range3[0],
      end: range3[1]
    });
  };
  SliderZoomView2.prototype._findCoordRect = function() {
    var rect;
    var coordSysInfoList = collectReferCoordSysModelInfo(this.dataZoomModel).infoList;
    if (!rect && coordSysInfoList.length) {
      var coordSys = coordSysInfoList[0].model.coordinateSystem;
      rect = coordSys.getRect && coordSys.getRect();
    }
    if (!rect) {
      var width = this.api.getWidth();
      var height = this.api.getHeight();
      rect = {
        x: width * 0.2,
        y: height * 0.2,
        width: width * 0.6,
        height: height * 0.6
      };
    }
    return rect;
  };
  SliderZoomView2.type = "dataZoom.slider";
  return SliderZoomView2;
}(DataZoomView$1);
function getOtherDim(thisDim) {
  var map2 = {
    x: "y",
    y: "x",
    radius: "angle",
    angle: "radius"
  };
  return map2[thisDim];
}
function getCursor$1(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var SliderZoomView$1 = SliderZoomView;
function install$7(registers) {
  registers.registerComponentModel(SliderZoomModel$1);
  registers.registerComponentView(SliderZoomView$1);
  installCommon$1(registers);
}
function install$6(registers) {
  use(install$8);
  use(install$7);
}
var visualDefault = {
  get: function(visualType, key, isCategory2) {
    var value = clone$4((defaultOption[visualType] || {})[key]);
    return isCategory2 ? isArray$1(value) ? value[value.length - 1] : value : value;
  }
};
var defaultOption = {
  color: {
    active: ["#006edd", "#e0ffff"],
    inactive: ["rgba(0,0,0,0)"]
  },
  colorHue: {
    active: [0, 360],
    inactive: [0, 0]
  },
  colorSaturation: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  colorLightness: {
    active: [0.9, 0.5],
    inactive: [0, 0]
  },
  colorAlpha: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  opacity: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  symbol: {
    active: ["circle", "roundRect", "diamond"],
    inactive: ["none"]
  },
  symbolSize: {
    active: [10, 50],
    inactive: [0, 0]
  }
};
var visualDefault$1 = visualDefault;
var mapVisual = VisualMapping$1.mapVisual;
var eachVisual = VisualMapping$1.eachVisual;
var isArray = isArray$1;
var each$2 = each$f;
var asc = asc$2;
var linearMap$1 = linearMap$2;
var VisualMapModel = function(_super) {
  __extends(VisualMapModel2, _super);
  function VisualMapModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapModel2.type;
    _this.stateList = ["inRange", "outOfRange"];
    _this.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"];
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    _this.dataBound = [-Infinity, Infinity];
    _this.targetVisuals = {};
    _this.controllerVisuals = {};
    return _this;
  }
  VisualMapModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  VisualMapModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, this.replacableOptionKeys);
    this.textStyleModel = this.getModel("textStyle");
    this.resetItemSize();
    this.completeVisualOption();
  };
  VisualMapModel2.prototype.resetVisual = function(supplementVisualOption) {
    var stateList = this.stateList;
    supplementVisualOption = bind$1(supplementVisualOption, this);
    this.controllerVisuals = createVisualMappings(this.option.controller, stateList, supplementVisualOption);
    this.targetVisuals = createVisualMappings(this.option.target, stateList, supplementVisualOption);
  };
  VisualMapModel2.prototype.getItemSymbol = function() {
    return null;
  };
  VisualMapModel2.prototype.getTargetSeriesIndices = function() {
    var optionSeriesIndex = this.option.seriesIndex;
    var seriesIndices = [];
    if (optionSeriesIndex == null || optionSeriesIndex === "all") {
      this.ecModel.eachSeries(function(seriesModel, index2) {
        seriesIndices.push(index2);
      });
    } else {
      seriesIndices = normalizeToArray(optionSeriesIndex);
    }
    return seriesIndices;
  };
  VisualMapModel2.prototype.eachTargetSeries = function(callback, context) {
    each$f(this.getTargetSeriesIndices(), function(seriesIndex) {
      var seriesModel = this.ecModel.getSeriesByIndex(seriesIndex);
      if (seriesModel) {
        callback.call(context, seriesModel);
      }
    }, this);
  };
  VisualMapModel2.prototype.isTargetSeries = function(seriesModel) {
    var is = false;
    this.eachTargetSeries(function(model) {
      model === seriesModel && (is = true);
    });
    return is;
  };
  VisualMapModel2.prototype.formatValueText = function(value, isCategory2, edgeSymbols) {
    var option = this.option;
    var precision = option.precision;
    var dataBound = this.dataBound;
    var formatter = option.formatter;
    var isMinMax;
    edgeSymbols = edgeSymbols || ["<", ">"];
    if (isArray$1(value)) {
      value = value.slice();
      isMinMax = true;
    }
    var textValue = isCategory2 ? value : isMinMax ? [toFixed(value[0]), toFixed(value[1])] : toFixed(value);
    if (isString(formatter)) {
      return formatter.replace("{value}", isMinMax ? textValue[0] : textValue).replace("{value2}", isMinMax ? textValue[1] : textValue);
    } else if (isFunction(formatter)) {
      return isMinMax ? formatter(value[0], value[1]) : formatter(value);
    }
    if (isMinMax) {
      if (value[0] === dataBound[0]) {
        return edgeSymbols[0] + " " + textValue[1];
      } else if (value[1] === dataBound[1]) {
        return edgeSymbols[1] + " " + textValue[0];
      } else {
        return textValue[0] + " - " + textValue[1];
      }
    } else {
      return textValue;
    }
    function toFixed(val) {
      return val === dataBound[0] ? "min" : val === dataBound[1] ? "max" : (+val).toFixed(Math.min(precision, 20));
    }
  };
  VisualMapModel2.prototype.resetExtent = function() {
    var thisOption = this.option;
    var extent3 = asc([thisOption.min, thisOption.max]);
    this._dataExtent = extent3;
  };
  VisualMapModel2.prototype.getDataDimensionIndex = function(data) {
    var optDim = this.option.dimension;
    if (optDim != null) {
      return data.getDimensionIndex(optDim);
    }
    var dimNames = data.dimensions;
    for (var i = dimNames.length - 1; i >= 0; i--) {
      var dimName = dimNames[i];
      var dimInfo = data.getDimensionInfo(dimName);
      if (!dimInfo.isCalculationCoord) {
        return dimInfo.storeDimIndex;
      }
    }
  };
  VisualMapModel2.prototype.getExtent = function() {
    return this._dataExtent.slice();
  };
  VisualMapModel2.prototype.completeVisualOption = function() {
    var ecModel = this.ecModel;
    var thisOption = this.option;
    var base2 = {
      inRange: thisOption.inRange,
      outOfRange: thisOption.outOfRange
    };
    var target = thisOption.target || (thisOption.target = {});
    var controller = thisOption.controller || (thisOption.controller = {});
    merge(target, base2);
    merge(controller, base2);
    var isCategory2 = this.isCategory();
    completeSingle.call(this, target);
    completeSingle.call(this, controller);
    completeInactive.call(this, target, "inRange", "outOfRange");
    completeController.call(this, controller);
    function completeSingle(base3) {
      if (isArray(thisOption.color) && !base3.inRange) {
        base3.inRange = {
          color: thisOption.color.slice().reverse()
        };
      }
      base3.inRange = base3.inRange || {
        color: ecModel.get("gradientColor")
      };
    }
    function completeInactive(base3, stateExist, stateAbsent) {
      var optExist = base3[stateExist];
      var optAbsent = base3[stateAbsent];
      if (optExist && !optAbsent) {
        optAbsent = base3[stateAbsent] = {};
        each$2(optExist, function(visualData, visualType) {
          if (!VisualMapping$1.isValidType(visualType)) {
            return;
          }
          var defa = visualDefault$1.get(visualType, "inactive", isCategory2);
          if (defa != null) {
            optAbsent[visualType] = defa;
            if (visualType === "color" && !optAbsent.hasOwnProperty("opacity") && !optAbsent.hasOwnProperty("colorAlpha")) {
              optAbsent.opacity = [0, 0];
            }
          }
        });
      }
    }
    function completeController(controller2) {
      var symbolExists = (controller2.inRange || {}).symbol || (controller2.outOfRange || {}).symbol;
      var symbolSizeExists = (controller2.inRange || {}).symbolSize || (controller2.outOfRange || {}).symbolSize;
      var inactiveColor = this.get("inactiveColor");
      var itemSymbol = this.getItemSymbol();
      var defaultSymbol = itemSymbol || "roundRect";
      each$2(this.stateList, function(state) {
        var itemSize = this.itemSize;
        var visuals = controller2[state];
        if (!visuals) {
          visuals = controller2[state] = {
            color: isCategory2 ? inactiveColor : [inactiveColor]
          };
        }
        if (visuals.symbol == null) {
          visuals.symbol = symbolExists && clone$4(symbolExists) || (isCategory2 ? defaultSymbol : [defaultSymbol]);
        }
        if (visuals.symbolSize == null) {
          visuals.symbolSize = symbolSizeExists && clone$4(symbolSizeExists) || (isCategory2 ? itemSize[0] : [itemSize[0], itemSize[0]]);
        }
        visuals.symbol = mapVisual(visuals.symbol, function(symbol) {
          return symbol === "none" ? defaultSymbol : symbol;
        });
        var symbolSize = visuals.symbolSize;
        if (symbolSize != null) {
          var max_1 = -Infinity;
          eachVisual(symbolSize, function(value) {
            value > max_1 && (max_1 = value);
          });
          visuals.symbolSize = mapVisual(symbolSize, function(value) {
            return linearMap$1(value, [0, max_1], [0, itemSize[0]], true);
          });
        }
      }, this);
    }
  };
  VisualMapModel2.prototype.resetItemSize = function() {
    this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
  };
  VisualMapModel2.prototype.isCategory = function() {
    return !!this.option.categories;
  };
  VisualMapModel2.prototype.setSelected = function(selected) {
  };
  VisualMapModel2.prototype.getSelected = function() {
    return null;
  };
  VisualMapModel2.prototype.getValueState = function(value) {
    return null;
  };
  VisualMapModel2.prototype.getVisualMeta = function(getColorVisual2) {
    return null;
  };
  VisualMapModel2.type = "visualMap";
  VisualMapModel2.dependencies = ["series"];
  VisualMapModel2.defaultOption = {
    show: true,
    z: 4,
    seriesIndex: "all",
    min: 0,
    max: 200,
    left: 0,
    right: null,
    top: null,
    bottom: 0,
    itemWidth: null,
    itemHeight: null,
    inverse: false,
    orient: "vertical",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    contentColor: "#5793f3",
    inactiveColor: "#aaa",
    borderWidth: 0,
    padding: 5,
    textGap: 10,
    precision: 0,
    textStyle: {
      color: "#333"
    }
  };
  return VisualMapModel2;
}(ComponentModel$1);
var VisualMapModel$1 = VisualMapModel;
var DEFAULT_BAR_BOUND = [20, 140];
var ContinuousModel = function(_super) {
  __extends(ContinuousModel2, _super);
  function ContinuousModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousModel2.type;
    return _this;
  }
  ContinuousModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    this.resetVisual(function(mappingOption) {
      mappingOption.mappingMethod = "linear";
      mappingOption.dataExtent = this.getExtent();
    });
    this._resetRange();
  };
  ContinuousModel2.prototype.resetItemSize = function() {
    _super.prototype.resetItemSize.apply(this, arguments);
    var itemSize = this.itemSize;
    (itemSize[0] == null || isNaN(itemSize[0])) && (itemSize[0] = DEFAULT_BAR_BOUND[0]);
    (itemSize[1] == null || isNaN(itemSize[1])) && (itemSize[1] = DEFAULT_BAR_BOUND[1]);
  };
  ContinuousModel2.prototype._resetRange = function() {
    var dataExtent = this.getExtent();
    var range3 = this.option.range;
    if (!range3 || range3.auto) {
      dataExtent.auto = 1;
      this.option.range = dataExtent;
    } else if (isArray$1(range3)) {
      if (range3[0] > range3[1]) {
        range3.reverse();
      }
      range3[0] = Math.max(range3[0], dataExtent[0]);
      range3[1] = Math.min(range3[1], dataExtent[1]);
    }
  };
  ContinuousModel2.prototype.completeVisualOption = function() {
    _super.prototype.completeVisualOption.apply(this, arguments);
    each$f(this.stateList, function(state) {
      var symbolSize = this.option.controller[state].symbolSize;
      if (symbolSize && symbolSize[0] !== symbolSize[1]) {
        symbolSize[0] = symbolSize[1] / 3;
      }
    }, this);
  };
  ContinuousModel2.prototype.setSelected = function(selected) {
    this.option.range = selected.slice();
    this._resetRange();
  };
  ContinuousModel2.prototype.getSelected = function() {
    var dataExtent = this.getExtent();
    var dataInterval = asc$2((this.get("range") || []).slice());
    dataInterval[0] > dataExtent[1] && (dataInterval[0] = dataExtent[1]);
    dataInterval[1] > dataExtent[1] && (dataInterval[1] = dataExtent[1]);
    dataInterval[0] < dataExtent[0] && (dataInterval[0] = dataExtent[0]);
    dataInterval[1] < dataExtent[0] && (dataInterval[1] = dataExtent[0]);
    return dataInterval;
  };
  ContinuousModel2.prototype.getValueState = function(value) {
    var range3 = this.option.range;
    var dataExtent = this.getExtent();
    return (range3[0] <= dataExtent[0] || range3[0] <= value) && (range3[1] >= dataExtent[1] || value <= range3[1]) ? "inRange" : "outOfRange";
  };
  ContinuousModel2.prototype.findTargetDataIndices = function(range3) {
    var result = [];
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        range3[0] <= value && value <= range3[1] && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  ContinuousModel2.prototype.getVisualMeta = function(getColorVisual2) {
    var oVals = getColorStopValues(this, "outOfRange", this.getExtent());
    var iVals = getColorStopValues(this, "inRange", this.option.range.slice());
    var stops = [];
    function setStop(value, valueState) {
      stops.push({
        value,
        color: getColorVisual2(value, valueState)
      });
    }
    var iIdx = 0;
    var oIdx = 0;
    var iLen = iVals.length;
    var oLen = oVals.length;
    for (; oIdx < oLen && (!iVals.length || oVals[oIdx] <= iVals[0]); oIdx++) {
      if (oVals[oIdx] < iVals[iIdx]) {
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    for (var first = 1; iIdx < iLen; iIdx++, first = 0) {
      first && stops.length && setStop(iVals[iIdx], "outOfRange");
      setStop(iVals[iIdx], "inRange");
    }
    for (var first = 1; oIdx < oLen; oIdx++) {
      if (!iVals.length || iVals[iVals.length - 1] < oVals[oIdx]) {
        if (first) {
          stops.length && setStop(stops[stops.length - 1].value, "outOfRange");
          first = 0;
        }
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    var stopsLen = stops.length;
    return {
      stops,
      outerColors: [stopsLen ? stops[0].color : "transparent", stopsLen ? stops[stopsLen - 1].color : "transparent"]
    };
  };
  ContinuousModel2.type = "visualMap.continuous";
  ContinuousModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    align: "auto",
    calculable: false,
    hoverLink: true,
    realtime: true,
    handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z",
    handleSize: "120%",
    handleStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    indicatorIcon: "circle",
    indicatorSize: "50%",
    indicatorStyle: {
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0,0,0,0.2)"
    }
  });
  return ContinuousModel2;
}(VisualMapModel$1);
function getColorStopValues(visualMapModel, valueState, dataExtent) {
  if (dataExtent[0] === dataExtent[1]) {
    return dataExtent.slice();
  }
  var count2 = 200;
  var step = (dataExtent[1] - dataExtent[0]) / count2;
  var value = dataExtent[0];
  var stopValues = [];
  for (var i = 0; i <= count2 && value < dataExtent[1]; i++) {
    stopValues.push(value);
    value += step;
  }
  stopValues.push(dataExtent[1]);
  return stopValues;
}
var ContinuousModel$1 = ContinuousModel;
var VisualMapView = function(_super) {
  __extends(VisualMapView2, _super);
  function VisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapView2.type;
    _this.autoPositionValues = {
      left: 1,
      right: 1,
      top: 1,
      bottom: 1
    };
    return _this;
  }
  VisualMapView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
  };
  VisualMapView2.prototype.render = function(visualMapModel, ecModel, api, payload) {
    this.visualMapModel = visualMapModel;
    if (visualMapModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    this.doRender(visualMapModel, ecModel, api, payload);
  };
  VisualMapView2.prototype.renderBackground = function(group) {
    var visualMapModel = this.visualMapModel;
    var padding = normalizeCssArray(visualMapModel.get("padding") || 0);
    var rect = group.getBoundingRect();
    group.add(new Rect$3({
      z2: -1,
      silent: true,
      shape: {
        x: rect.x - padding[3],
        y: rect.y - padding[0],
        width: rect.width + padding[3] + padding[1],
        height: rect.height + padding[0] + padding[2]
      },
      style: {
        fill: visualMapModel.get("backgroundColor"),
        stroke: visualMapModel.get("borderColor"),
        lineWidth: visualMapModel.get("borderWidth")
      }
    }));
  };
  VisualMapView2.prototype.getControllerVisual = function(targetValue, visualCluster, opts) {
    opts = opts || {};
    var forceState = opts.forceState;
    var visualMapModel = this.visualMapModel;
    var visualObj = {};
    if (visualCluster === "color") {
      var defaultColor = visualMapModel.get("contentColor");
      visualObj.color = defaultColor;
    }
    function getter(key) {
      return visualObj[key];
    }
    function setter(key, value) {
      visualObj[key] = value;
    }
    var mappings = visualMapModel.controllerVisuals[forceState || visualMapModel.getValueState(targetValue)];
    var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
    each$f(visualTypes, function(type4) {
      var visualMapping = mappings[type4];
      if (opts.convertOpacityToAlpha && type4 === "opacity") {
        type4 = "colorAlpha";
        visualMapping = mappings.__alphaForOpacity;
      }
      if (VisualMapping$1.dependsOn(type4, visualCluster)) {
        visualMapping && visualMapping.applyVisual(targetValue, getter, setter);
      }
    });
    return visualObj[visualCluster];
  };
  VisualMapView2.prototype.positionGroup = function(group) {
    var model = this.visualMapModel;
    var api = this.api;
    positionElement(group, model.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  VisualMapView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
  };
  VisualMapView2.type = "visualMap";
  return VisualMapView2;
}(ComponentView$1);
var VisualMapView$1 = VisualMapView;
var paramsSet = [["left", "right", "width"], ["top", "bottom", "height"]];
function getItemAlign(visualMapModel, api, itemSize) {
  var modelOption = visualMapModel.option;
  var itemAlign = modelOption.align;
  if (itemAlign != null && itemAlign !== "auto") {
    return itemAlign;
  }
  var ecSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var realIndex = modelOption.orient === "horizontal" ? 1 : 0;
  var reals = paramsSet[realIndex];
  var fakeValue = [0, null, 10];
  var layoutInput = {};
  for (var i = 0; i < 3; i++) {
    layoutInput[paramsSet[1 - realIndex][i]] = fakeValue[i];
    layoutInput[reals[i]] = i === 2 ? itemSize[0] : modelOption[reals[i]];
  }
  var rParam = [["x", "width", 3], ["y", "height", 0]][realIndex];
  var rect = getLayoutRect(layoutInput, ecSize, modelOption.padding);
  return reals[(rect.margin[rParam[2]] || 0) + rect[rParam[0]] + rect[rParam[1]] * 0.5 < ecSize[rParam[1]] * 0.5 ? 0 : 1];
}
function makeHighDownBatch(batch, visualMapModel) {
  each$f(batch || [], function(batchItem) {
    if (batchItem.dataIndex != null) {
      batchItem.dataIndexInside = batchItem.dataIndex;
      batchItem.dataIndex = null;
    }
    batchItem.highlightKey = "visualMap" + (visualMapModel ? visualMapModel.componentIndex : "");
  });
  return batch;
}
var linearMap = linearMap$2;
var each$1 = each$f;
var mathMin = Math.min;
var mathMax = Math.max;
var HOVER_LINK_SIZE = 12;
var HOVER_LINK_OUT = 6;
var ContinuousView = function(_super) {
  __extends(ContinuousView2, _super);
  function ContinuousView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousView2.type;
    _this._shapes = {};
    _this._dataInterval = [];
    _this._handleEnds = [];
    _this._hoverLinkDataIndices = [];
    return _this;
  }
  ContinuousView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
    this._api = api;
    if (!payload || payload.type !== "selectDataRange" || payload.from !== this.uid) {
      this._buildView();
    }
  };
  ContinuousView2.prototype._buildView = function() {
    this.group.removeAll();
    var visualMapModel = this.visualMapModel;
    var thisGroup = this.group;
    this._orient = visualMapModel.get("orient");
    this._useHandle = visualMapModel.get("calculable");
    this._resetInterval();
    this._renderBar(thisGroup);
    var dataRangeText = visualMapModel.get("text");
    this._renderEndsText(thisGroup, dataRangeText, 0);
    this._renderEndsText(thisGroup, dataRangeText, 1);
    this._updateView(true);
    this.renderBackground(thisGroup);
    this._updateView();
    this._enableHoverLinkToSeries();
    this._enableHoverLinkFromSeries();
    this.positionGroup(thisGroup);
  };
  ContinuousView2.prototype._renderEndsText = function(group, dataRangeText, endsIndex) {
    if (!dataRangeText) {
      return;
    }
    var text = dataRangeText[1 - endsIndex];
    text = text != null ? text + "" : "";
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var itemSize = visualMapModel.itemSize;
    var barGroup = this._shapes.mainGroup;
    var position2 = this._applyTransform([itemSize[0] / 2, endsIndex === 0 ? -textGap : itemSize[1] + textGap], barGroup);
    var align = this._applyTransform(endsIndex === 0 ? "bottom" : "top", barGroup);
    var orient = this._orient;
    var textStyleModel = this.visualMapModel.textStyleModel;
    this.group.add(new ZRText$1({
      style: {
        x: position2[0],
        y: position2[1],
        verticalAlign: orient === "horizontal" ? "middle" : align,
        align: orient === "horizontal" ? align : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
  };
  ContinuousView2.prototype._renderBar = function(targetGroup) {
    var visualMapModel = this.visualMapModel;
    var shapes = this._shapes;
    var itemSize = visualMapModel.itemSize;
    var orient = this._orient;
    var useHandle = this._useHandle;
    var itemAlign = getItemAlign(visualMapModel, this.api, itemSize);
    var mainGroup = shapes.mainGroup = this._createBarGroup(itemAlign);
    var gradientBarGroup = new Group$4();
    mainGroup.add(gradientBarGroup);
    gradientBarGroup.add(shapes.outOfRange = createPolygon());
    gradientBarGroup.add(shapes.inRange = createPolygon(null, useHandle ? getCursor(this._orient) : null, bind$1(this._dragHandle, this, "all", false), bind$1(this._dragHandle, this, "all", true)));
    gradientBarGroup.setClipPath(new Rect$3({
      shape: {
        x: 0,
        y: 0,
        width: itemSize[0],
        height: itemSize[1],
        r: 3
      }
    }));
    var textRect = visualMapModel.textStyleModel.getTextRect("\u56FD");
    var textSize = mathMax(textRect.width, textRect.height);
    if (useHandle) {
      shapes.handleThumbs = [];
      shapes.handleLabels = [];
      shapes.handleLabelPoints = [];
      this._createHandle(visualMapModel, mainGroup, 0, itemSize, textSize, orient);
      this._createHandle(visualMapModel, mainGroup, 1, itemSize, textSize, orient);
    }
    this._createIndicator(visualMapModel, mainGroup, itemSize, textSize, orient);
    targetGroup.add(mainGroup);
  };
  ContinuousView2.prototype._createHandle = function(visualMapModel, mainGroup, handleIndex, itemSize, textSize, orient) {
    var onDrift = bind$1(this._dragHandle, this, handleIndex, false);
    var onDragEnd = bind$1(this._dragHandle, this, handleIndex, true);
    var handleSize = parsePercent$1(visualMapModel.get("handleSize"), itemSize[0]);
    var handleThumb = createSymbol$1(visualMapModel.get("handleIcon"), -handleSize / 2, -handleSize / 2, handleSize, handleSize, null, true);
    var cursor = getCursor(this._orient);
    handleThumb.attr({
      cursor,
      draggable: true,
      drift: onDrift,
      ondragend: onDragEnd,
      onmousemove: function(e2) {
        stop(e2.event);
      }
    });
    handleThumb.x = itemSize[0] / 2;
    handleThumb.useStyle(visualMapModel.getModel("handleStyle").getItemStyle());
    handleThumb.setStyle({
      strokeNoScale: true,
      strokeFirst: true
    });
    handleThumb.style.lineWidth *= 2;
    handleThumb.ensureState("emphasis").style = visualMapModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
    setAsHighDownDispatcher(handleThumb, true);
    mainGroup.add(handleThumb);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var handleLabel = new ZRText$1({
      cursor,
      draggable: true,
      drift: onDrift,
      onmousemove: function(e2) {
        stop(e2.event);
      },
      ondragend: onDragEnd,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    handleLabel.ensureState("blur").style = {
      opacity: 0.1
    };
    handleLabel.stateTransition = {
      duration: 200
    };
    this.group.add(handleLabel);
    var handleLabelPoint = [handleSize, 0];
    var shapes = this._shapes;
    shapes.handleThumbs[handleIndex] = handleThumb;
    shapes.handleLabelPoints[handleIndex] = handleLabelPoint;
    shapes.handleLabels[handleIndex] = handleLabel;
  };
  ContinuousView2.prototype._createIndicator = function(visualMapModel, mainGroup, itemSize, textSize, orient) {
    var scale2 = parsePercent$1(visualMapModel.get("indicatorSize"), itemSize[0]);
    var indicator = createSymbol$1(visualMapModel.get("indicatorIcon"), -scale2 / 2, -scale2 / 2, scale2, scale2, null, true);
    indicator.attr({
      cursor: "move",
      invisible: true,
      silent: true,
      x: itemSize[0] / 2
    });
    var indicatorStyle = visualMapModel.getModel("indicatorStyle").getItemStyle();
    if (indicator instanceof ZRImage$1) {
      var pathStyle = indicator.style;
      indicator.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, indicatorStyle));
    } else {
      indicator.useStyle(indicatorStyle);
    }
    mainGroup.add(indicator);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var indicatorLabel = new ZRText$1({
      silent: true,
      invisible: true,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    this.group.add(indicatorLabel);
    var indicatorLabelPoint = [(orient === "horizontal" ? textSize / 2 : HOVER_LINK_OUT) + itemSize[0] / 2, 0];
    var shapes = this._shapes;
    shapes.indicator = indicator;
    shapes.indicatorLabel = indicatorLabel;
    shapes.indicatorLabelPoint = indicatorLabelPoint;
    this._firstShowIndicator = true;
  };
  ContinuousView2.prototype._dragHandle = function(handleIndex, isEnd, dx, dy) {
    if (!this._useHandle) {
      return;
    }
    this._dragging = !isEnd;
    if (!isEnd) {
      var vertex = this._applyTransform([dx, dy], this._shapes.mainGroup, true);
      this._updateInterval(handleIndex, vertex[1]);
      this._hideIndicator();
      this._updateView();
    }
    if (isEnd === !this.visualMapModel.get("realtime")) {
      this.api.dispatchAction({
        type: "selectDataRange",
        from: this.uid,
        visualMapId: this.visualMapModel.id,
        selected: this._dataInterval.slice()
      });
    }
    if (isEnd) {
      !this._hovering && this._clearHoverLinkToSeries();
    } else if (useHoverLinkOnHandle(this.visualMapModel)) {
      this._doHoverLinkToSeries(this._handleEnds[handleIndex], false);
    }
  };
  ContinuousView2.prototype._resetInterval = function() {
    var visualMapModel = this.visualMapModel;
    var dataInterval = this._dataInterval = visualMapModel.getSelected();
    var dataExtent = visualMapModel.getExtent();
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    this._handleEnds = [linearMap(dataInterval[0], dataExtent, sizeExtent, true), linearMap(dataInterval[1], dataExtent, sizeExtent, true)];
  };
  ContinuousView2.prototype._updateInterval = function(handleIndex, delta) {
    delta = delta || 0;
    var visualMapModel = this.visualMapModel;
    var handleEnds = this._handleEnds;
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    sliderMove(delta, handleEnds, sizeExtent, handleIndex, 0);
    var dataExtent = visualMapModel.getExtent();
    this._dataInterval = [linearMap(handleEnds[0], sizeExtent, dataExtent, true), linearMap(handleEnds[1], sizeExtent, dataExtent, true)];
  };
  ContinuousView2.prototype._updateView = function(forSketch) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var shapes = this._shapes;
    var outOfRangeHandleEnds = [0, visualMapModel.itemSize[1]];
    var inRangeHandleEnds = forSketch ? outOfRangeHandleEnds : this._handleEnds;
    var visualInRange = this._createBarVisual(this._dataInterval, dataExtent, inRangeHandleEnds, "inRange");
    var visualOutOfRange = this._createBarVisual(dataExtent, dataExtent, outOfRangeHandleEnds, "outOfRange");
    shapes.inRange.setStyle({
      fill: visualInRange.barColor
    }).setShape("points", visualInRange.barPoints);
    shapes.outOfRange.setStyle({
      fill: visualOutOfRange.barColor
    }).setShape("points", visualOutOfRange.barPoints);
    this._updateHandle(inRangeHandleEnds, visualInRange);
  };
  ContinuousView2.prototype._createBarVisual = function(dataInterval, dataExtent, handleEnds, forceState) {
    var opts = {
      forceState,
      convertOpacityToAlpha: true
    };
    var colorStops = this._makeColorGradient(dataInterval, opts);
    var symbolSizes = [this.getControllerVisual(dataInterval[0], "symbolSize", opts), this.getControllerVisual(dataInterval[1], "symbolSize", opts)];
    var barPoints = this._createBarPoints(handleEnds, symbolSizes);
    return {
      barColor: new LinearGradient$1(0, 0, 0, 1, colorStops),
      barPoints,
      handlesColor: [colorStops[0].color, colorStops[colorStops.length - 1].color]
    };
  };
  ContinuousView2.prototype._makeColorGradient = function(dataInterval, opts) {
    var sampleNumber = 100;
    var colorStops = [];
    var step = (dataInterval[1] - dataInterval[0]) / sampleNumber;
    colorStops.push({
      color: this.getControllerVisual(dataInterval[0], "color", opts),
      offset: 0
    });
    for (var i = 1; i < sampleNumber; i++) {
      var currValue = dataInterval[0] + step * i;
      if (currValue > dataInterval[1]) {
        break;
      }
      colorStops.push({
        color: this.getControllerVisual(currValue, "color", opts),
        offset: i / sampleNumber
      });
    }
    colorStops.push({
      color: this.getControllerVisual(dataInterval[1], "color", opts),
      offset: 1
    });
    return colorStops;
  };
  ContinuousView2.prototype._createBarPoints = function(handleEnds, symbolSizes) {
    var itemSize = this.visualMapModel.itemSize;
    return [[itemSize[0] - symbolSizes[0], handleEnds[0]], [itemSize[0], handleEnds[0]], [itemSize[0], handleEnds[1]], [itemSize[0] - symbolSizes[1], handleEnds[1]]];
  };
  ContinuousView2.prototype._createBarGroup = function(itemAlign) {
    var orient = this._orient;
    var inverse = this.visualMapModel.get("inverse");
    return new Group$4(orient === "horizontal" && !inverse ? {
      scaleX: itemAlign === "bottom" ? 1 : -1,
      rotation: Math.PI / 2
    } : orient === "horizontal" && inverse ? {
      scaleX: itemAlign === "bottom" ? -1 : 1,
      rotation: -Math.PI / 2
    } : orient === "vertical" && !inverse ? {
      scaleX: itemAlign === "left" ? 1 : -1,
      scaleY: -1
    } : {
      scaleX: itemAlign === "left" ? 1 : -1
    });
  };
  ContinuousView2.prototype._updateHandle = function(handleEnds, visualInRange) {
    if (!this._useHandle) {
      return;
    }
    var shapes = this._shapes;
    var visualMapModel = this.visualMapModel;
    var handleThumbs = shapes.handleThumbs;
    var handleLabels = shapes.handleLabels;
    var itemSize = visualMapModel.itemSize;
    var dataExtent = visualMapModel.getExtent();
    each$1([0, 1], function(handleIndex) {
      var handleThumb = handleThumbs[handleIndex];
      handleThumb.setStyle("fill", visualInRange.handlesColor[handleIndex]);
      handleThumb.y = handleEnds[handleIndex];
      var val = linearMap(handleEnds[handleIndex], [0, itemSize[1]], dataExtent, true);
      var symbolSize = this.getControllerVisual(val, "symbolSize");
      handleThumb.scaleX = handleThumb.scaleY = symbolSize / itemSize[0];
      handleThumb.x = itemSize[0] - symbolSize / 2;
      var textPoint = applyTransform(shapes.handleLabelPoints[handleIndex], getTransform$1(handleThumb, this.group));
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        text: visualMapModel.formatValueText(this._dataInterval[handleIndex]),
        verticalAlign: "middle",
        align: this._orient === "vertical" ? this._applyTransform("left", shapes.mainGroup) : "center"
      });
    }, this);
  };
  ContinuousView2.prototype._showIndicator = function(cursorValue, textValue, rangeSymbol, halfHoverLinkSize) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var itemSize = visualMapModel.itemSize;
    var sizeExtent = [0, itemSize[1]];
    var shapes = this._shapes;
    var indicator = shapes.indicator;
    if (!indicator) {
      return;
    }
    indicator.attr("invisible", false);
    var opts = {
      convertOpacityToAlpha: true
    };
    var color = this.getControllerVisual(cursorValue, "color", opts);
    var symbolSize = this.getControllerVisual(cursorValue, "symbolSize");
    var y2 = linearMap(cursorValue, dataExtent, sizeExtent, true);
    var x2 = itemSize[0] - symbolSize / 2;
    var oldIndicatorPos = {
      x: indicator.x,
      y: indicator.y
    };
    indicator.y = y2;
    indicator.x = x2;
    var textPoint = applyTransform(shapes.indicatorLabelPoint, getTransform$1(indicator, this.group));
    var indicatorLabel = shapes.indicatorLabel;
    indicatorLabel.attr("invisible", false);
    var align = this._applyTransform("left", shapes.mainGroup);
    var orient = this._orient;
    var isHorizontal = orient === "horizontal";
    indicatorLabel.setStyle({
      text: (rangeSymbol ? rangeSymbol : "") + visualMapModel.formatValueText(textValue),
      verticalAlign: isHorizontal ? align : "middle",
      align: isHorizontal ? "center" : align
    });
    var indicatorNewProps = {
      x: x2,
      y: y2,
      style: {
        fill: color
      }
    };
    var labelNewProps = {
      style: {
        x: textPoint[0],
        y: textPoint[1]
      }
    };
    if (visualMapModel.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
      var animationCfg = {
        duration: 100,
        easing: "cubicInOut",
        additive: true
      };
      indicator.x = oldIndicatorPos.x;
      indicator.y = oldIndicatorPos.y;
      indicator.animateTo(indicatorNewProps, animationCfg);
      indicatorLabel.animateTo(labelNewProps, animationCfg);
    } else {
      indicator.attr(indicatorNewProps);
      indicatorLabel.attr(labelNewProps);
    }
    this._firstShowIndicator = false;
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.enterBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._enableHoverLinkToSeries = function() {
    var self2 = this;
    this._shapes.mainGroup.on("mousemove", function(e2) {
      self2._hovering = true;
      if (!self2._dragging) {
        var itemSize = self2.visualMapModel.itemSize;
        var pos = self2._applyTransform([e2.offsetX, e2.offsetY], self2._shapes.mainGroup, true, true);
        pos[1] = mathMin(mathMax(0, pos[1]), itemSize[1]);
        self2._doHoverLinkToSeries(pos[1], 0 <= pos[0] && pos[0] <= itemSize[0]);
      }
    }).on("mouseout", function() {
      self2._hovering = false;
      !self2._dragging && self2._clearHoverLinkToSeries();
    });
  };
  ContinuousView2.prototype._enableHoverLinkFromSeries = function() {
    var zr = this.api.getZr();
    if (this.visualMapModel.option.hoverLink) {
      zr.on("mouseover", this._hoverLinkFromSeriesMouseOver, this);
      zr.on("mouseout", this._hideIndicator, this);
    } else {
      this._clearHoverLinkFromSeries();
    }
  };
  ContinuousView2.prototype._doHoverLinkToSeries = function(cursorPos, hoverOnBar) {
    var visualMapModel = this.visualMapModel;
    var itemSize = visualMapModel.itemSize;
    if (!visualMapModel.option.hoverLink) {
      return;
    }
    var sizeExtent = [0, itemSize[1]];
    var dataExtent = visualMapModel.getExtent();
    cursorPos = mathMin(mathMax(sizeExtent[0], cursorPos), sizeExtent[1]);
    var halfHoverLinkSize = getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent);
    var hoverRange = [cursorPos - halfHoverLinkSize, cursorPos + halfHoverLinkSize];
    var cursorValue = linearMap(cursorPos, sizeExtent, dataExtent, true);
    var valueRange = [linearMap(hoverRange[0], sizeExtent, dataExtent, true), linearMap(hoverRange[1], sizeExtent, dataExtent, true)];
    hoverRange[0] < sizeExtent[0] && (valueRange[0] = -Infinity);
    hoverRange[1] > sizeExtent[1] && (valueRange[1] = Infinity);
    if (hoverOnBar) {
      if (valueRange[0] === -Infinity) {
        this._showIndicator(cursorValue, valueRange[1], "< ", halfHoverLinkSize);
      } else if (valueRange[1] === Infinity) {
        this._showIndicator(cursorValue, valueRange[0], "> ", halfHoverLinkSize);
      } else {
        this._showIndicator(cursorValue, cursorValue, "\u2248 ", halfHoverLinkSize);
      }
    }
    var oldBatch = this._hoverLinkDataIndices;
    var newBatch = [];
    if (hoverOnBar || useHoverLinkOnHandle(visualMapModel)) {
      newBatch = this._hoverLinkDataIndices = visualMapModel.findTargetDataIndices(valueRange);
    }
    var resultBatches = compressBatches(oldBatch, newBatch);
    this._dispatchHighDown("downplay", makeHighDownBatch(resultBatches[0], visualMapModel));
    this._dispatchHighDown("highlight", makeHighDownBatch(resultBatches[1], visualMapModel));
  };
  ContinuousView2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
    var el = e2.target;
    var visualMapModel = this.visualMapModel;
    if (!el || getECData(el).dataIndex == null) {
      return;
    }
    var ecData = getECData(el);
    var dataModel = this.ecModel.getSeriesByIndex(ecData.seriesIndex);
    if (!visualMapModel.isTargetSeries(dataModel)) {
      return;
    }
    var data = dataModel.getData(ecData.dataType);
    var value = data.getStore().get(visualMapModel.getDataDimensionIndex(data), ecData.dataIndex);
    if (!isNaN(value)) {
      this._showIndicator(value, value);
    }
  };
  ContinuousView2.prototype._hideIndicator = function() {
    var shapes = this._shapes;
    shapes.indicator && shapes.indicator.attr("invisible", true);
    shapes.indicatorLabel && shapes.indicatorLabel.attr("invisible", true);
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.leaveBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._clearHoverLinkToSeries = function() {
    this._hideIndicator();
    var indices = this._hoverLinkDataIndices;
    this._dispatchHighDown("downplay", makeHighDownBatch(indices, this.visualMapModel));
    indices.length = 0;
  };
  ContinuousView2.prototype._clearHoverLinkFromSeries = function() {
    this._hideIndicator();
    var zr = this.api.getZr();
    zr.off("mouseover", this._hoverLinkFromSeriesMouseOver);
    zr.off("mouseout", this._hideIndicator);
  };
  ContinuousView2.prototype._applyTransform = function(vertex, element, inverse, global2) {
    var transform2 = getTransform$1(element, global2 ? null : this.group);
    return isArray$1(vertex) ? applyTransform(vertex, transform2, inverse) : transformDirection(vertex, transform2, inverse);
  };
  ContinuousView2.prototype._dispatchHighDown = function(type4, batch) {
    batch && batch.length && this.api.dispatchAction({
      type: type4,
      batch
    });
  };
  ContinuousView2.prototype.dispose = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.prototype.remove = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.type = "visualMap.continuous";
  return ContinuousView2;
}(VisualMapView$1);
function createPolygon(points2, cursor, onDrift, onDragEnd) {
  return new Polygon$1({
    shape: {
      points: points2
    },
    draggable: !!onDrift,
    cursor,
    drift: onDrift,
    onmousemove: function(e2) {
      stop(e2.event);
    },
    ondragend: onDragEnd
  });
}
function getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent) {
  var halfHoverLinkSize = HOVER_LINK_SIZE / 2;
  var hoverLinkDataSize = visualMapModel.get("hoverLinkDataSize");
  if (hoverLinkDataSize) {
    halfHoverLinkSize = linearMap(hoverLinkDataSize, dataExtent, sizeExtent, true) / 2;
  }
  return halfHoverLinkSize;
}
function useHoverLinkOnHandle(visualMapModel) {
  var hoverLinkOnHandle = visualMapModel.get("hoverLinkOnHandle");
  return !!(hoverLinkOnHandle == null ? visualMapModel.get("realtime") : hoverLinkOnHandle);
}
function getCursor(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var ContinuousView$1 = ContinuousView;
var visualMapActionInfo = {
  type: "selectDataRange",
  event: "dataRangeSelected",
  update: "update"
};
var visualMapActionHander = function(payload, ecModel) {
  ecModel.eachComponent({
    mainType: "visualMap",
    query: payload
  }, function(model) {
    model.setSelected(payload.selected);
  });
};
var visualMapEncodingHandlers = [
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var resetDefines = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        var pipelineContext = seriesModel.pipelineContext;
        if (!visualMapModel.isTargetSeries(seriesModel) || pipelineContext && pipelineContext.large) {
          return;
        }
        resetDefines.push(incrementalApplyVisual(visualMapModel.stateList, visualMapModel.targetVisuals, bind$1(visualMapModel.getValueState, visualMapModel), visualMapModel.getDataDimensionIndex(seriesModel.getData())));
      });
      return resetDefines;
    }
  },
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      var visualMetaList = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        if (visualMapModel.isTargetSeries(seriesModel)) {
          var visualMeta = visualMapModel.getVisualMeta(bind$1(getColorVisual, null, seriesModel, visualMapModel)) || {
            stops: [],
            outerColors: []
          };
          var dimIdx = visualMapModel.getDataDimensionIndex(data);
          if (dimIdx >= 0) {
            visualMeta.dimension = dimIdx;
            visualMetaList.push(visualMeta);
          }
        }
      });
      seriesModel.getData().setVisual("visualMeta", visualMetaList);
    }
  }
];
function getColorVisual(seriesModel, visualMapModel, value, valueState) {
  var mappings = visualMapModel.targetVisuals[valueState];
  var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
  var resultVisual = {
    color: getVisualFromData(seriesModel.getData(), "color")
  };
  for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
    var type4 = visualTypes[i];
    var mapping = mappings[type4 === "opacity" ? "__alphaForOpacity" : type4];
    mapping && mapping.applyVisual(value, getVisual, setVisual);
  }
  return resultVisual.color;
  function getVisual(key) {
    return resultVisual[key];
  }
  function setVisual(key, value2) {
    resultVisual[key] = value2;
  }
}
var each = each$f;
function visualMapPreprocessor(option) {
  var visualMap = option && option.visualMap;
  if (!isArray$1(visualMap)) {
    visualMap = visualMap ? [visualMap] : [];
  }
  each(visualMap, function(opt) {
    if (!opt) {
      return;
    }
    if (has(opt, "splitList") && !has(opt, "pieces")) {
      opt.pieces = opt.splitList;
      delete opt.splitList;
    }
    var pieces = opt.pieces;
    if (pieces && isArray$1(pieces)) {
      each(pieces, function(piece) {
        if (isObject$4(piece)) {
          if (has(piece, "start") && !has(piece, "min")) {
            piece.min = piece.start;
          }
          if (has(piece, "end") && !has(piece, "max")) {
            piece.max = piece.end;
          }
        }
      });
    }
  });
}
function has(obj, name) {
  return obj && obj.hasOwnProperty && obj.hasOwnProperty(name);
}
var installed = false;
function installCommon(registers) {
  if (installed) {
    return;
  }
  installed = true;
  registers.registerSubTypeDefaulter("visualMap", function(option) {
    return !option.categories && (!(option.pieces ? option.pieces.length > 0 : option.splitNumber > 0) || option.calculable) ? "continuous" : "piecewise";
  });
  registers.registerAction(visualMapActionInfo, visualMapActionHander);
  each$f(visualMapEncodingHandlers, function(handler) {
    registers.registerVisual(registers.PRIORITY.VISUAL.COMPONENT, handler);
  });
  registers.registerPreprocessor(visualMapPreprocessor);
}
function install$5(registers) {
  registers.registerComponentModel(ContinuousModel$1);
  registers.registerComponentView(ContinuousView$1);
  installCommon(registers);
}
var PiecewiseModel = function(_super) {
  __extends(PiecewiseModel2, _super);
  function PiecewiseModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseModel2.type;
    _this._pieceList = [];
    return _this;
  }
  PiecewiseModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    var mode = this._mode = this._determineMode();
    this._pieceList = [];
    resetMethods[this._mode].call(this, this._pieceList);
    this._resetSelected(newOption, isInit);
    var categories = this.option.categories;
    this.resetVisual(function(mappingOption, state) {
      if (mode === "categories") {
        mappingOption.mappingMethod = "category";
        mappingOption.categories = clone$4(categories);
      } else {
        mappingOption.dataExtent = this.getExtent();
        mappingOption.mappingMethod = "piecewise";
        mappingOption.pieceList = map$1(this._pieceList, function(piece) {
          piece = clone$4(piece);
          if (state !== "inRange") {
            piece.visual = null;
          }
          return piece;
        });
      }
    });
  };
  PiecewiseModel2.prototype.completeVisualOption = function() {
    var option = this.option;
    var visualTypesInPieces = {};
    var visualTypes = VisualMapping$1.listVisualTypes();
    var isCategory2 = this.isCategory();
    each$f(option.pieces, function(piece) {
      each$f(visualTypes, function(visualType) {
        if (piece.hasOwnProperty(visualType)) {
          visualTypesInPieces[visualType] = 1;
        }
      });
    });
    each$f(visualTypesInPieces, function(v4, visualType) {
      var exists = false;
      each$f(this.stateList, function(state) {
        exists = exists || has2(option, state, visualType) || has2(option.target, state, visualType);
      }, this);
      !exists && each$f(this.stateList, function(state) {
        (option[state] || (option[state] = {}))[visualType] = visualDefault$1.get(visualType, state === "inRange" ? "active" : "inactive", isCategory2);
      });
    }, this);
    function has2(obj, state, visualType) {
      return obj && obj[state] && obj[state].hasOwnProperty(visualType);
    }
    _super.prototype.completeVisualOption.apply(this, arguments);
  };
  PiecewiseModel2.prototype._resetSelected = function(newOption, isInit) {
    var thisOption = this.option;
    var pieceList = this._pieceList;
    var selected = (isInit ? thisOption : newOption).selected || {};
    thisOption.selected = selected;
    each$f(pieceList, function(piece, index2) {
      var key = this.getSelectedMapKey(piece);
      if (!selected.hasOwnProperty(key)) {
        selected[key] = true;
      }
    }, this);
    if (thisOption.selectedMode === "single") {
      var hasSel_1 = false;
      each$f(pieceList, function(piece, index2) {
        var key = this.getSelectedMapKey(piece);
        if (selected[key]) {
          hasSel_1 ? selected[key] = false : hasSel_1 = true;
        }
      }, this);
    }
  };
  PiecewiseModel2.prototype.getItemSymbol = function() {
    return this.get("itemSymbol");
  };
  PiecewiseModel2.prototype.getSelectedMapKey = function(piece) {
    return this._mode === "categories" ? piece.value + "" : piece.index + "";
  };
  PiecewiseModel2.prototype.getPieceList = function() {
    return this._pieceList;
  };
  PiecewiseModel2.prototype._determineMode = function() {
    var option = this.option;
    return option.pieces && option.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
  };
  PiecewiseModel2.prototype.setSelected = function(selected) {
    this.option.selected = clone$4(selected);
  };
  PiecewiseModel2.prototype.getValueState = function(value) {
    var index2 = VisualMapping$1.findPieceIndex(value, this._pieceList);
    return index2 != null ? this.option.selected[this.getSelectedMapKey(this._pieceList[index2])] ? "inRange" : "outOfRange" : "outOfRange";
  };
  PiecewiseModel2.prototype.findTargetDataIndices = function(pieceIndex) {
    var result = [];
    var pieceList = this._pieceList;
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        var pIdx = VisualMapping$1.findPieceIndex(value, pieceList);
        pIdx === pieceIndex && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  PiecewiseModel2.prototype.getRepresentValue = function(piece) {
    var representValue;
    if (this.isCategory()) {
      representValue = piece.value;
    } else {
      if (piece.value != null) {
        representValue = piece.value;
      } else {
        var pieceInterval = piece.interval || [];
        representValue = pieceInterval[0] === -Infinity && pieceInterval[1] === Infinity ? 0 : (pieceInterval[0] + pieceInterval[1]) / 2;
      }
    }
    return representValue;
  };
  PiecewiseModel2.prototype.getVisualMeta = function(getColorVisual2) {
    if (this.isCategory()) {
      return;
    }
    var stops = [];
    var outerColors = ["", ""];
    var visualMapModel = this;
    function setStop(interval, valueState) {
      var representValue = visualMapModel.getRepresentValue({
        interval
      });
      if (!valueState) {
        valueState = visualMapModel.getValueState(representValue);
      }
      var color = getColorVisual2(representValue, valueState);
      if (interval[0] === -Infinity) {
        outerColors[0] = color;
      } else if (interval[1] === Infinity) {
        outerColors[1] = color;
      } else {
        stops.push({
          value: interval[0],
          color
        }, {
          value: interval[1],
          color
        });
      }
    }
    var pieceList = this._pieceList.slice();
    if (!pieceList.length) {
      pieceList.push({
        interval: [-Infinity, Infinity]
      });
    } else {
      var edge = pieceList[0].interval[0];
      edge !== -Infinity && pieceList.unshift({
        interval: [-Infinity, edge]
      });
      edge = pieceList[pieceList.length - 1].interval[1];
      edge !== Infinity && pieceList.push({
        interval: [edge, Infinity]
      });
    }
    var curr = -Infinity;
    each$f(pieceList, function(piece) {
      var interval = piece.interval;
      if (interval) {
        interval[0] > curr && setStop([curr, interval[0]], "outOfRange");
        setStop(interval.slice());
        curr = interval[1];
      }
    }, this);
    return {
      stops,
      outerColors
    };
  };
  PiecewiseModel2.type = "visualMap.piecewise";
  PiecewiseModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    selected: null,
    minOpen: false,
    maxOpen: false,
    align: "auto",
    itemWidth: 20,
    itemHeight: 14,
    itemSymbol: "roundRect",
    pieces: null,
    categories: null,
    splitNumber: 5,
    selectedMode: "multiple",
    itemGap: 10,
    hoverLink: true
  });
  return PiecewiseModel2;
}(VisualMapModel$1);
var resetMethods = {
  splitNumber: function(outPieceList) {
    var thisOption = this.option;
    var precision = Math.min(thisOption.precision, 20);
    var dataExtent = this.getExtent();
    var splitNumber = thisOption.splitNumber;
    splitNumber = Math.max(parseInt(splitNumber, 10), 1);
    thisOption.splitNumber = splitNumber;
    var splitStep = (dataExtent[1] - dataExtent[0]) / splitNumber;
    while (+splitStep.toFixed(precision) !== splitStep && precision < 5) {
      precision++;
    }
    thisOption.precision = precision;
    splitStep = +splitStep.toFixed(precision);
    if (thisOption.minOpen) {
      outPieceList.push({
        interval: [-Infinity, dataExtent[0]],
        close: [0, 0]
      });
    }
    for (var index2 = 0, curr = dataExtent[0]; index2 < splitNumber; curr += splitStep, index2++) {
      var max3 = index2 === splitNumber - 1 ? dataExtent[1] : curr + splitStep;
      outPieceList.push({
        interval: [curr, max3],
        close: [1, 1]
      });
    }
    if (thisOption.maxOpen) {
      outPieceList.push({
        interval: [dataExtent[1], Infinity],
        close: [0, 0]
      });
    }
    reformIntervals(outPieceList);
    each$f(outPieceList, function(piece, index3) {
      piece.index = index3;
      piece.text = this.formatValueText(piece.interval);
    }, this);
  },
  categories: function(outPieceList) {
    var thisOption = this.option;
    each$f(thisOption.categories, function(cate) {
      outPieceList.push({
        text: this.formatValueText(cate, true),
        value: cate
      });
    }, this);
    normalizeReverse(thisOption, outPieceList);
  },
  pieces: function(outPieceList) {
    var thisOption = this.option;
    each$f(thisOption.pieces, function(pieceListItem, index2) {
      if (!isObject$4(pieceListItem)) {
        pieceListItem = {
          value: pieceListItem
        };
      }
      var item = {
        text: "",
        index: index2
      };
      if (pieceListItem.label != null) {
        item.text = pieceListItem.label;
      }
      if (pieceListItem.hasOwnProperty("value")) {
        var value = item.value = pieceListItem.value;
        item.interval = [value, value];
        item.close = [1, 1];
      } else {
        var interval = item.interval = [];
        var close_1 = item.close = [0, 0];
        var closeList = [1, 0, 1];
        var infinityList = [-Infinity, Infinity];
        var useMinMax = [];
        for (var lg = 0; lg < 2; lg++) {
          var names2 = [["gte", "gt", "min"], ["lte", "lt", "max"]][lg];
          for (var i = 0; i < 3 && interval[lg] == null; i++) {
            interval[lg] = pieceListItem[names2[i]];
            close_1[lg] = closeList[i];
            useMinMax[lg] = i === 2;
          }
          interval[lg] == null && (interval[lg] = infinityList[lg]);
        }
        useMinMax[0] && interval[1] === Infinity && (close_1[0] = 0);
        useMinMax[1] && interval[0] === -Infinity && (close_1[1] = 0);
        if (interval[0] === interval[1] && close_1[0] && close_1[1]) {
          item.value = interval[0];
        }
      }
      item.visual = VisualMapping$1.retrieveVisuals(pieceListItem);
      outPieceList.push(item);
    }, this);
    normalizeReverse(thisOption, outPieceList);
    reformIntervals(outPieceList);
    each$f(outPieceList, function(piece) {
      var close = piece.close;
      var edgeSymbols = [["<", "\u2264"][close[1]], [">", "\u2265"][close[0]]];
      piece.text = piece.text || this.formatValueText(piece.value != null ? piece.value : piece.interval, false, edgeSymbols);
    }, this);
  }
};
function normalizeReverse(thisOption, pieceList) {
  var inverse = thisOption.inverse;
  if (thisOption.orient === "vertical" ? !inverse : inverse) {
    pieceList.reverse();
  }
}
var PiecewiseModel$1 = PiecewiseModel;
var PiecewiseVisualMapView = function(_super) {
  __extends(PiecewiseVisualMapView2, _super);
  function PiecewiseVisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseVisualMapView2.type;
    return _this;
  }
  PiecewiseVisualMapView2.prototype.doRender = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var textStyleModel = visualMapModel.textStyleModel;
    var textFont = textStyleModel.getFont();
    var textFill = textStyleModel.getTextColor();
    var itemAlign = this._getItemAlign();
    var itemSize = visualMapModel.itemSize;
    var viewData = this._getViewData();
    var endsText = viewData.endsText;
    var showLabel = retrieve(visualMapModel.get("showLabel", true), !endsText);
    endsText && this._renderEndsText(thisGroup, endsText[0], itemSize, showLabel, itemAlign);
    each$f(viewData.viewPieceList, function(item) {
      var piece = item.piece;
      var itemGroup = new Group$4();
      itemGroup.onclick = bind$1(this._onItemClick, this, piece);
      this._enableHoverLink(itemGroup, item.indexInModelPieceList);
      var representValue = visualMapModel.getRepresentValue(piece);
      this._createItemSymbol(itemGroup, representValue, [0, 0, itemSize[0], itemSize[1]]);
      if (showLabel) {
        var visualState = this.visualMapModel.getValueState(representValue);
        itemGroup.add(new ZRText$1({
          style: {
            x: itemAlign === "right" ? -textGap : itemSize[0] + textGap,
            y: itemSize[1] / 2,
            text: piece.text,
            verticalAlign: "middle",
            align: itemAlign,
            font: textFont,
            fill: textFill,
            opacity: visualState === "outOfRange" ? 0.5 : 1
          }
        }));
      }
      thisGroup.add(itemGroup);
    }, this);
    endsText && this._renderEndsText(thisGroup, endsText[1], itemSize, showLabel, itemAlign);
    box(visualMapModel.get("orient"), thisGroup, visualMapModel.get("itemGap"));
    this.renderBackground(thisGroup);
    this.positionGroup(thisGroup);
  };
  PiecewiseVisualMapView2.prototype._enableHoverLink = function(itemGroup, pieceIndex) {
    var _this = this;
    itemGroup.on("mouseover", function() {
      return onHoverLink("highlight");
    }).on("mouseout", function() {
      return onHoverLink("downplay");
    });
    var onHoverLink = function(method4) {
      var visualMapModel = _this.visualMapModel;
      visualMapModel.option.hoverLink && _this.api.dispatchAction({
        type: method4,
        batch: makeHighDownBatch(visualMapModel.findTargetDataIndices(pieceIndex), visualMapModel)
      });
    };
  };
  PiecewiseVisualMapView2.prototype._getItemAlign = function() {
    var visualMapModel = this.visualMapModel;
    var modelOption = visualMapModel.option;
    if (modelOption.orient === "vertical") {
      return getItemAlign(visualMapModel, this.api, visualMapModel.itemSize);
    } else {
      var align = modelOption.align;
      if (!align || align === "auto") {
        align = "left";
      }
      return align;
    }
  };
  PiecewiseVisualMapView2.prototype._renderEndsText = function(group, text, itemSize, showLabel, itemAlign) {
    if (!text) {
      return;
    }
    var itemGroup = new Group$4();
    var textStyleModel = this.visualMapModel.textStyleModel;
    itemGroup.add(new ZRText$1({
      style: {
        x: showLabel ? itemAlign === "right" ? itemSize[0] : 0 : itemSize[0] / 2,
        y: itemSize[1] / 2,
        verticalAlign: "middle",
        align: showLabel ? itemAlign : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
    group.add(itemGroup);
  };
  PiecewiseVisualMapView2.prototype._getViewData = function() {
    var visualMapModel = this.visualMapModel;
    var viewPieceList = map$1(visualMapModel.getPieceList(), function(piece, index2) {
      return {
        piece,
        indexInModelPieceList: index2
      };
    });
    var endsText = visualMapModel.get("text");
    var orient = visualMapModel.get("orient");
    var inverse = visualMapModel.get("inverse");
    if (orient === "horizontal" ? inverse : !inverse) {
      viewPieceList.reverse();
    } else if (endsText) {
      endsText = endsText.slice().reverse();
    }
    return {
      viewPieceList,
      endsText
    };
  };
  PiecewiseVisualMapView2.prototype._createItemSymbol = function(group, representValue, shapeParam) {
    group.add(createSymbol$1(this.getControllerVisual(representValue, "symbol"), shapeParam[0], shapeParam[1], shapeParam[2], shapeParam[3], this.getControllerVisual(representValue, "color")));
  };
  PiecewiseVisualMapView2.prototype._onItemClick = function(piece) {
    var visualMapModel = this.visualMapModel;
    var option = visualMapModel.option;
    var selected = clone$4(option.selected);
    var newKey = visualMapModel.getSelectedMapKey(piece);
    if (option.selectedMode === "single") {
      selected[newKey] = true;
      each$f(selected, function(o, key) {
        selected[key] = key === newKey;
      });
    } else {
      selected[newKey] = !selected[newKey];
    }
    this.api.dispatchAction({
      type: "selectDataRange",
      from: this.uid,
      visualMapId: this.visualMapModel.id,
      selected
    });
  };
  PiecewiseVisualMapView2.type = "visualMap.piecewise";
  return PiecewiseVisualMapView2;
}(VisualMapView$1);
var PiecewiseView = PiecewiseVisualMapView;
function install$4(registers) {
  registers.registerComponentModel(PiecewiseModel$1);
  registers.registerComponentView(PiecewiseView);
  installCommon(registers);
}
function install$3(registers) {
  use(install$5);
  use(install$4);
}
var DEFAULT_OPTION = {
  label: {
    enabled: true
  },
  decal: {
    show: false
  }
};
var inner = makeInner();
var decalPaletteScope = {};
function ariaVisual(ecModel, api) {
  var ariaModel = ecModel.getModel("aria");
  if (!ariaModel.get("enabled")) {
    return;
  }
  var defaultOption2 = clone$4(DEFAULT_OPTION);
  merge(defaultOption2.label, ecModel.getLocaleModel().get("aria"), false);
  merge(ariaModel.option, defaultOption2, false);
  setDecal();
  setLabel();
  function setDecal() {
    var decalModel = ariaModel.getModel("decal");
    var useDecal = decalModel.get("show");
    if (useDecal) {
      var paletteScopeGroupByType_1 = createHashMap();
      ecModel.eachSeries(function(seriesModel) {
        if (seriesModel.isColorBySeries()) {
          return;
        }
        var decalScope = paletteScopeGroupByType_1.get(seriesModel.type);
        if (!decalScope) {
          decalScope = {};
          paletteScopeGroupByType_1.set(seriesModel.type, decalScope);
        }
        inner(seriesModel).scope = decalScope;
      });
      ecModel.eachRawSeries(function(seriesModel) {
        if (ecModel.isSeriesFiltered(seriesModel)) {
          return;
        }
        if (isFunction(seriesModel.enableAriaDecal)) {
          seriesModel.enableAriaDecal();
          return;
        }
        var data = seriesModel.getData();
        if (!seriesModel.isColorBySeries()) {
          var dataAll_1 = seriesModel.getRawData();
          var idxMap_1 = {};
          var decalScope_1 = inner(seriesModel).scope;
          data.each(function(idx) {
            var rawIdx = data.getRawIndex(idx);
            idxMap_1[rawIdx] = idx;
          });
          var dataCount_1 = dataAll_1.count();
          dataAll_1.each(function(rawIdx) {
            var idx = idxMap_1[rawIdx];
            var name = dataAll_1.getName(rawIdx) || rawIdx + "";
            var paletteDecal2 = getDecalFromPalette(seriesModel.ecModel, name, decalScope_1, dataCount_1);
            var specifiedDecal2 = data.getItemVisual(idx, "decal");
            data.setItemVisual(idx, "decal", mergeDecal(specifiedDecal2, paletteDecal2));
          });
        } else {
          var paletteDecal = getDecalFromPalette(seriesModel.ecModel, seriesModel.name, decalPaletteScope, ecModel.getSeriesCount());
          var specifiedDecal = data.getVisual("decal");
          data.setVisual("decal", mergeDecal(specifiedDecal, paletteDecal));
        }
        function mergeDecal(specifiedDecal2, paletteDecal2) {
          var resultDecal = specifiedDecal2 ? extend(extend({}, paletteDecal2), specifiedDecal2) : paletteDecal2;
          resultDecal.dirty = true;
          return resultDecal;
        }
      });
    }
  }
  function setLabel() {
    var labelLocale = ecModel.getLocaleModel().get("aria");
    var labelModel = ariaModel.getModel("label");
    labelModel.option = defaults(labelModel.option, labelLocale);
    if (!labelModel.get("enabled")) {
      return;
    }
    var dom = api.getZr().dom;
    if (labelModel.get("description")) {
      dom.setAttribute("aria-label", labelModel.get("description"));
      return;
    }
    var seriesCnt = ecModel.getSeriesCount();
    var maxDataCnt = labelModel.get(["data", "maxCount"]) || 10;
    var maxSeriesCnt = labelModel.get(["series", "maxCount"]) || 10;
    var displaySeriesCnt = Math.min(seriesCnt, maxSeriesCnt);
    var ariaLabel;
    if (seriesCnt < 1) {
      return;
    } else {
      var title = getTitle();
      if (title) {
        var withTitle = labelModel.get(["general", "withTitle"]);
        ariaLabel = replace(withTitle, {
          title
        });
      } else {
        ariaLabel = labelModel.get(["general", "withoutTitle"]);
      }
      var seriesLabels_1 = [];
      var prefix = seriesCnt > 1 ? labelModel.get(["series", "multiple", "prefix"]) : labelModel.get(["series", "single", "prefix"]);
      ariaLabel += replace(prefix, {
        seriesCount: seriesCnt
      });
      ecModel.eachSeries(function(seriesModel, idx) {
        if (idx < displaySeriesCnt) {
          var seriesLabel = void 0;
          var seriesName = seriesModel.get("name");
          var withName = seriesName ? "withName" : "withoutName";
          seriesLabel = seriesCnt > 1 ? labelModel.get(["series", "multiple", withName]) : labelModel.get(["series", "single", withName]);
          seriesLabel = replace(seriesLabel, {
            seriesId: seriesModel.seriesIndex,
            seriesName: seriesModel.get("name"),
            seriesType: getSeriesTypeName(seriesModel.subType)
          });
          var data = seriesModel.getData();
          if (data.count() > maxDataCnt) {
            var partialLabel = labelModel.get(["data", "partialData"]);
            seriesLabel += replace(partialLabel, {
              displayCnt: maxDataCnt
            });
          } else {
            seriesLabel += labelModel.get(["data", "allData"]);
          }
          var middleSeparator_1 = labelModel.get(["data", "separator", "middle"]);
          var endSeparator_1 = labelModel.get(["data", "separator", "end"]);
          var dataLabels = [];
          for (var i = 0; i < data.count(); i++) {
            if (i < maxDataCnt) {
              var name_1 = data.getName(i);
              var value = data.getValues(i);
              var dataLabel = labelModel.get(["data", name_1 ? "withName" : "withoutName"]);
              dataLabels.push(replace(dataLabel, {
                name: name_1,
                value: value.join(middleSeparator_1)
              }));
            }
          }
          seriesLabel += dataLabels.join(middleSeparator_1) + endSeparator_1;
          seriesLabels_1.push(seriesLabel);
        }
      });
      var separatorModel = labelModel.getModel(["series", "multiple", "separator"]);
      var middleSeparator = separatorModel.get("middle");
      var endSeparator = separatorModel.get("end");
      ariaLabel += seriesLabels_1.join(middleSeparator) + endSeparator;
      dom.setAttribute("aria-label", ariaLabel);
    }
  }
  function replace(str, keyValues) {
    if (!isString(str)) {
      return str;
    }
    var result = str;
    each$f(keyValues, function(value, key) {
      result = result.replace(new RegExp("\\{\\s*" + key + "\\s*\\}", "g"), value);
    });
    return result;
  }
  function getTitle() {
    var title = ecModel.get("title");
    if (title && title.length) {
      title = title[0];
    }
    return title && title.text;
  }
  function getSeriesTypeName(type4) {
    return ecModel.getLocaleModel().get(["series", "typeNames"])[type4] || "\u81EA\u5B9A\u4E49\u56FE";
  }
}
function ariaPreprocessor(option) {
  if (!option || !option.aria) {
    return;
  }
  var aria = option.aria;
  if (aria.show != null) {
    aria.enabled = aria.show;
  }
  aria.label = aria.label || {};
  each$f(["description", "general", "series", "data"], function(name) {
    if (aria[name] != null) {
      aria.label[name] = aria[name];
    }
  });
}
function install$2(registers) {
  registers.registerPreprocessor(ariaPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.ARIA, ariaVisual);
}
var RELATIONAL_EXPRESSION_OP_ALIAS_MAP = {
  value: "eq",
  "<": "lt",
  "<=": "lte",
  ">": "gt",
  ">=": "gte",
  "=": "eq",
  "!=": "ne",
  "<>": "ne"
};
var RegExpEvaluator = function() {
  function RegExpEvaluator2(rVal) {
    var condValue = this._condVal = isString(rVal) ? new RegExp(rVal) : isRegExp(rVal) ? rVal : null;
    if (condValue == null) {
      var errMsg = "";
      throwError(errMsg);
    }
  }
  RegExpEvaluator2.prototype.evaluate = function(lVal) {
    var type4 = typeof lVal;
    return isString(type4) ? this._condVal.test(lVal) : isNumber(type4) ? this._condVal.test(lVal + "") : false;
  };
  return RegExpEvaluator2;
}();
var ConstConditionInternal = function() {
  function ConstConditionInternal2() {
  }
  ConstConditionInternal2.prototype.evaluate = function() {
    return this.value;
  };
  return ConstConditionInternal2;
}();
var AndConditionInternal = function() {
  function AndConditionInternal2() {
  }
  AndConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (!children[i].evaluate()) {
        return false;
      }
    }
    return true;
  };
  return AndConditionInternal2;
}();
var OrConditionInternal = function() {
  function OrConditionInternal2() {
  }
  OrConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].evaluate()) {
        return true;
      }
    }
    return false;
  };
  return OrConditionInternal2;
}();
var NotConditionInternal = function() {
  function NotConditionInternal2() {
  }
  NotConditionInternal2.prototype.evaluate = function() {
    return !this.child.evaluate();
  };
  return NotConditionInternal2;
}();
var RelationalConditionInternal = function() {
  function RelationalConditionInternal2() {
  }
  RelationalConditionInternal2.prototype.evaluate = function() {
    var needParse = !!this.valueParser;
    var getValue2 = this.getValue;
    var tarValRaw = getValue2(this.valueGetterParam);
    var tarValParsed = needParse ? this.valueParser(tarValRaw) : null;
    for (var i = 0; i < this.subCondList.length; i++) {
      if (!this.subCondList[i].evaluate(needParse ? tarValParsed : tarValRaw)) {
        return false;
      }
    }
    return true;
  };
  return RelationalConditionInternal2;
}();
function parseOption(exprOption, getters) {
  if (exprOption === true || exprOption === false) {
    var cond = new ConstConditionInternal();
    cond.value = exprOption;
    return cond;
  }
  var errMsg = "";
  if (!isObjectNotArray(exprOption)) {
    throwError(errMsg);
  }
  if (exprOption.and) {
    return parseAndOrOption("and", exprOption, getters);
  } else if (exprOption.or) {
    return parseAndOrOption("or", exprOption, getters);
  } else if (exprOption.not) {
    return parseNotOption(exprOption, getters);
  }
  return parseRelationalOption(exprOption, getters);
}
function parseAndOrOption(op, exprOption, getters) {
  var subOptionArr = exprOption[op];
  var errMsg = "";
  if (!isArray$1(subOptionArr)) {
    throwError(errMsg);
  }
  if (!subOptionArr.length) {
    throwError(errMsg);
  }
  var cond = op === "and" ? new AndConditionInternal() : new OrConditionInternal();
  cond.children = map$1(subOptionArr, function(subOption) {
    return parseOption(subOption, getters);
  });
  if (!cond.children.length) {
    throwError(errMsg);
  }
  return cond;
}
function parseNotOption(exprOption, getters) {
  var subOption = exprOption.not;
  var errMsg = "";
  if (!isObjectNotArray(subOption)) {
    throwError(errMsg);
  }
  var cond = new NotConditionInternal();
  cond.child = parseOption(subOption, getters);
  if (!cond.child) {
    throwError(errMsg);
  }
  return cond;
}
function parseRelationalOption(exprOption, getters) {
  var errMsg = "";
  var valueGetterParam = getters.prepareGetValue(exprOption);
  var subCondList = [];
  var exprKeys = keys(exprOption);
  var parserName = exprOption.parser;
  var valueParser = parserName ? getRawValueParser(parserName) : null;
  for (var i = 0; i < exprKeys.length; i++) {
    var keyRaw = exprKeys[i];
    if (keyRaw === "parser" || getters.valueGetterAttrMap.get(keyRaw)) {
      continue;
    }
    var op = hasOwn(RELATIONAL_EXPRESSION_OP_ALIAS_MAP, keyRaw) ? RELATIONAL_EXPRESSION_OP_ALIAS_MAP[keyRaw] : keyRaw;
    var condValueRaw = exprOption[keyRaw];
    var condValueParsed = valueParser ? valueParser(condValueRaw) : condValueRaw;
    var evaluator = createFilterComparator(op, condValueParsed) || op === "reg" && new RegExpEvaluator(condValueParsed);
    if (!evaluator) {
      throwError(errMsg);
    }
    subCondList.push(evaluator);
  }
  if (!subCondList.length) {
    throwError(errMsg);
  }
  var cond = new RelationalConditionInternal();
  cond.valueGetterParam = valueGetterParam;
  cond.valueParser = valueParser;
  cond.getValue = getters.getValue;
  cond.subCondList = subCondList;
  return cond;
}
function isObjectNotArray(val) {
  return isObject$4(val) && !isArrayLike(val);
}
var ConditionalExpressionParsed = function() {
  function ConditionalExpressionParsed2(exprOption, getters) {
    this._cond = parseOption(exprOption, getters);
  }
  ConditionalExpressionParsed2.prototype.evaluate = function() {
    return this._cond.evaluate();
  };
  return ConditionalExpressionParsed2;
}();
function parseConditionalExpression(exprOption, getters) {
  return new ConditionalExpressionParsed(exprOption, getters);
}
var filterTransform = {
  type: "echarts:filter",
  transform: function(params) {
    var upstream = params.upstream;
    var rawItem;
    var condition = parseConditionalExpression(params.config, {
      valueGetterAttrMap: createHashMap({
        dimension: true
      }),
      prepareGetValue: function(exprOption) {
        var errMsg = "";
        var dimLoose = exprOption.dimension;
        if (!hasOwn(exprOption, "dimension")) {
          throwError(errMsg);
        }
        var dimInfo = upstream.getDimensionInfo(dimLoose);
        if (!dimInfo) {
          throwError(errMsg);
        }
        return {
          dimIdx: dimInfo.index
        };
      },
      getValue: function(param) {
        return upstream.retrieveValueFromItem(rawItem, param.dimIdx);
      }
    });
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      rawItem = upstream.getRawDataItem(i);
      if (condition.evaluate()) {
        resultData.push(rawItem);
      }
    }
    return {
      data: resultData
    };
  }
};
var sortTransform = {
  type: "echarts:sort",
  transform: function(params) {
    var upstream = params.upstream;
    var config = params.config;
    var errMsg = "";
    var orderExprList = normalizeToArray(config);
    if (!orderExprList.length) {
      throwError(errMsg);
    }
    var orderDefList = [];
    each$f(orderExprList, function(orderExpr) {
      var dimLoose = orderExpr.dimension;
      var order = orderExpr.order;
      var parserName = orderExpr.parser;
      var incomparable = orderExpr.incomparable;
      if (dimLoose == null) {
        throwError(errMsg);
      }
      if (order !== "asc" && order !== "desc") {
        throwError(errMsg);
      }
      if (incomparable && incomparable !== "min" && incomparable !== "max") {
        var errMsg_1 = "";
        throwError(errMsg_1);
      }
      if (order !== "asc" && order !== "desc") {
        var errMsg_2 = "";
        throwError(errMsg_2);
      }
      var dimInfo = upstream.getDimensionInfo(dimLoose);
      if (!dimInfo) {
        throwError(errMsg);
      }
      var parser = parserName ? getRawValueParser(parserName) : null;
      if (parserName && !parser) {
        throwError(errMsg);
      }
      orderDefList.push({
        dimIdx: dimInfo.index,
        parser,
        comparator: new SortOrderComparator(order, incomparable)
      });
    });
    var sourceFormat = upstream.sourceFormat;
    if (sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS && sourceFormat !== SOURCE_FORMAT_OBJECT_ROWS) {
      throwError(errMsg);
    }
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      resultData.push(upstream.getRawDataItem(i));
    }
    resultData.sort(function(item0, item1) {
      for (var i2 = 0; i2 < orderDefList.length; i2++) {
        var orderDef = orderDefList[i2];
        var val0 = upstream.retrieveValueFromItem(item0, orderDef.dimIdx);
        var val1 = upstream.retrieveValueFromItem(item1, orderDef.dimIdx);
        if (orderDef.parser) {
          val0 = orderDef.parser(val0);
          val1 = orderDef.parser(val1);
        }
        var result = orderDef.comparator.evaluate(val0, val1);
        if (result !== 0) {
          return result;
        }
      }
      return 0;
    });
    return {
      data: resultData
    };
  }
};
function install$1(registers) {
  registers.registerTransform(filterTransform);
  registers.registerTransform(sortTransform);
}
var DatasetModel = function(_super) {
  __extends(DatasetModel2, _super);
  function DatasetModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetModel2.prototype.init = function(option, parentModel, ecModel) {
    _super.prototype.init.call(this, option, parentModel, ecModel);
    this._sourceManager = new SourceManager(this);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.mergeOption = function(newOption, ecModel) {
    _super.prototype.mergeOption.call(this, newOption, ecModel);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.optionUpdated = function() {
    this._sourceManager.dirty();
  };
  DatasetModel2.prototype.getSourceManager = function() {
    return this._sourceManager;
  };
  DatasetModel2.type = "dataset";
  DatasetModel2.defaultOption = {
    seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN
  };
  return DatasetModel2;
}(ComponentModel$1);
var DatasetView = function(_super) {
  __extends(DatasetView2, _super);
  function DatasetView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetView2.type = "dataset";
  return DatasetView2;
}(ComponentView$1);
function install(registers) {
  registers.registerComponentModel(DatasetModel);
  registers.registerComponentView(DatasetView);
}
var CMD = PathProxy$1.CMD;
function aroundEqual(a, b2) {
  return Math.abs(a - b2) < 1e-5;
}
function pathToBezierCurves(path) {
  var data = path.data;
  var len2 = path.len();
  var bezierArrayGroups = [];
  var currentSubpath;
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  function createNewSubpath(x3, y3) {
    if (currentSubpath && currentSubpath.length > 2) {
      bezierArrayGroups.push(currentSubpath);
    }
    currentSubpath = [x3, y3];
  }
  function addLine(x02, y02, x12, y12) {
    if (!(aroundEqual(x02, x12) && aroundEqual(y02, y12))) {
      currentSubpath.push(x02, y02, x12, y12, x12, y12);
    }
  }
  function addArc(startAngle2, endAngle2, cx2, cy2, rx2, ry2) {
    var delta = Math.abs(endAngle2 - startAngle2);
    var len3 = Math.tan(delta / 4) * 4 / 3;
    var dir3 = endAngle2 < startAngle2 ? -1 : 1;
    var c1 = Math.cos(startAngle2);
    var s1 = Math.sin(startAngle2);
    var c2 = Math.cos(endAngle2);
    var s2 = Math.sin(endAngle2);
    var x12 = c1 * rx2 + cx2;
    var y12 = s1 * ry2 + cy2;
    var x4 = c2 * rx2 + cx2;
    var y4 = s2 * ry2 + cy2;
    var hx = rx2 * len3 * dir3;
    var hy = ry2 * len3 * dir3;
    currentSubpath.push(x12 - hx * s1, y12 + hy * c1, x4 + hx * s2, y4 - hy * c2, x4, y4);
  }
  var x1;
  var y1;
  var x2;
  var y2;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (isFirst) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
      if (cmd === CMD.L || cmd === CMD.C || cmd === CMD.Q) {
        currentSubpath = [x0, y0];
      }
    }
    switch (cmd) {
      case CMD.M:
        xi = x0 = data[i++];
        yi = y0 = data[i++];
        createNewSubpath(x0, y0);
        break;
      case CMD.L:
        x1 = data[i++];
        y1 = data[i++];
        addLine(xi, yi, x1, y1);
        xi = x1;
        yi = y1;
        break;
      case CMD.C:
        currentSubpath.push(data[i++], data[i++], data[i++], data[i++], xi = data[i++], yi = data[i++]);
        break;
      case CMD.Q:
        x1 = data[i++];
        y1 = data[i++];
        x2 = data[i++];
        y2 = data[i++];
        currentSubpath.push(xi + 2 / 3 * (x1 - xi), yi + 2 / 3 * (y1 - yi), x2 + 2 / 3 * (x1 - x2), y2 + 2 / 3 * (y1 - y2), x2, y2);
        xi = x2;
        yi = y2;
        break;
      case CMD.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var startAngle = data[i++];
        var endAngle = data[i++] + startAngle;
        i += 1;
        var anticlockwise = !data[i++];
        x1 = Math.cos(startAngle) * rx + cx;
        y1 = Math.sin(startAngle) * ry + cy;
        if (isFirst) {
          x0 = x1;
          y0 = y1;
          createNewSubpath(x0, y0);
        } else {
          addLine(xi, yi, x1, y1);
        }
        xi = Math.cos(endAngle) * rx + cx;
        yi = Math.sin(endAngle) * ry + cy;
        var step = (anticlockwise ? -1 : 1) * Math.PI / 2;
        for (var angle = startAngle; anticlockwise ? angle > endAngle : angle < endAngle; angle += step) {
          var nextAngle = anticlockwise ? Math.max(angle + step, endAngle) : Math.min(angle + step, endAngle);
          addArc(angle, nextAngle, cx, cy, rx, ry);
        }
        break;
      case CMD.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        x1 = x0 + data[i++];
        y1 = y0 + data[i++];
        createNewSubpath(x1, y0);
        addLine(x1, y0, x1, y1);
        addLine(x1, y1, x0, y1);
        addLine(x0, y1, x0, y0);
        addLine(x0, y0, x1, y0);
        break;
      case CMD.Z:
        currentSubpath && addLine(xi, yi, x0, y0);
        xi = x0;
        yi = y0;
        break;
    }
  }
  if (currentSubpath && currentSubpath.length > 2) {
    bezierArrayGroups.push(currentSubpath);
  }
  return bezierArrayGroups;
}
function adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, out2, scale2) {
  if (aroundEqual(x0, x1) && aroundEqual(y0, y1) && aroundEqual(x2, x3) && aroundEqual(y2, y3)) {
    out2.push(x3, y3);
    return;
  }
  var PIXEL_DISTANCE = 2 / scale2;
  var PIXEL_DISTANCE_SQR = PIXEL_DISTANCE * PIXEL_DISTANCE;
  var dx = x3 - x0;
  var dy = y3 - y0;
  var d2 = Math.sqrt(dx * dx + dy * dy);
  dx /= d2;
  dy /= d2;
  var dx1 = x1 - x0;
  var dy1 = y1 - y0;
  var dx2 = x2 - x3;
  var dy2 = y2 - y3;
  var cp1LenSqr = dx1 * dx1 + dy1 * dy1;
  var cp2LenSqr = dx2 * dx2 + dy2 * dy2;
  if (cp1LenSqr < PIXEL_DISTANCE_SQR && cp2LenSqr < PIXEL_DISTANCE_SQR) {
    out2.push(x3, y3);
    return;
  }
  var projLen1 = dx * dx1 + dy * dy1;
  var projLen2 = -dx * dx2 - dy * dy2;
  var d1Sqr = cp1LenSqr - projLen1 * projLen1;
  var d2Sqr = cp2LenSqr - projLen2 * projLen2;
  if (d1Sqr < PIXEL_DISTANCE_SQR && projLen1 >= 0 && d2Sqr < PIXEL_DISTANCE_SQR && projLen2 >= 0) {
    out2.push(x3, y3);
    return;
  }
  var tmpSegX = [];
  var tmpSegY = [];
  cubicSubdivide(x0, x1, x2, x3, 0.5, tmpSegX);
  cubicSubdivide(y0, y1, y2, y3, 0.5, tmpSegY);
  adpativeBezier(tmpSegX[0], tmpSegY[0], tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], tmpSegX[3], tmpSegY[3], out2, scale2);
  adpativeBezier(tmpSegX[4], tmpSegY[4], tmpSegX[5], tmpSegY[5], tmpSegX[6], tmpSegY[6], tmpSegX[7], tmpSegY[7], out2, scale2);
}
function pathToPolygons(path, scale2) {
  var bezierArrayGroups = pathToBezierCurves(path);
  var polygons = [];
  scale2 = scale2 || 1;
  for (var i = 0; i < bezierArrayGroups.length; i++) {
    var beziers = bezierArrayGroups[i];
    var polygon = [];
    var x0 = beziers[0];
    var y0 = beziers[1];
    polygon.push(x0, y0);
    for (var k2 = 2; k2 < beziers.length; ) {
      var x1 = beziers[k2++];
      var y1 = beziers[k2++];
      var x2 = beziers[k2++];
      var y2 = beziers[k2++];
      var x3 = beziers[k2++];
      var y3 = beziers[k2++];
      adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, polygon, scale2);
      x0 = x3;
      y0 = y3;
    }
    polygons.push(polygon);
  }
  return polygons;
}
function getDividingGrids(dimSize, rowDim, count2) {
  var rowSize = dimSize[rowDim];
  var columnSize = dimSize[1 - rowDim];
  var ratio = Math.abs(rowSize / columnSize);
  var rowCount = Math.ceil(Math.sqrt(ratio * count2));
  var columnCount = Math.floor(count2 / rowCount);
  if (columnCount === 0) {
    columnCount = 1;
    rowCount = count2;
  }
  var grids = [];
  for (var i = 0; i < rowCount; i++) {
    grids.push(columnCount);
  }
  var currentCount = rowCount * columnCount;
  var remained = count2 - currentCount;
  if (remained > 0) {
    for (var i = 0; i < remained; i++) {
      grids[i % rowCount] += 1;
    }
  }
  return grids;
}
function divideSector(sectorShape, count2, outShapes) {
  var r0 = sectorShape.r0;
  var r2 = sectorShape.r;
  var startAngle = sectorShape.startAngle;
  var endAngle = sectorShape.endAngle;
  var angle = Math.abs(endAngle - startAngle);
  var arcLen = angle * r2;
  var deltaR = r2 - r0;
  var isAngleRow = arcLen > Math.abs(deltaR);
  var grids = getDividingGrids([arcLen, deltaR], isAngleRow ? 0 : 1, count2);
  var rowSize = (isAngleRow ? angle : deltaR) / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = (isAngleRow ? deltaR : angle) / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      if (isAngleRow) {
        newShape.startAngle = startAngle + rowSize * row;
        newShape.endAngle = startAngle + rowSize * (row + 1);
        newShape.r0 = r0 + columnSize * column;
        newShape.r = r0 + columnSize * (column + 1);
      } else {
        newShape.startAngle = startAngle + columnSize * column;
        newShape.endAngle = startAngle + columnSize * (column + 1);
        newShape.r0 = r0 + rowSize * row;
        newShape.r = r0 + rowSize * (row + 1);
      }
      newShape.clockwise = sectorShape.clockwise;
      newShape.cx = sectorShape.cx;
      newShape.cy = sectorShape.cy;
      outShapes.push(newShape);
    }
  }
}
function divideRect(rectShape, count2, outShapes) {
  var width = rectShape.width;
  var height = rectShape.height;
  var isHorizontalRow = width > height;
  var grids = getDividingGrids([width, height], isHorizontalRow ? 0 : 1, count2);
  var rowSizeDim = isHorizontalRow ? "width" : "height";
  var columnSizeDim = isHorizontalRow ? "height" : "width";
  var rowDim = isHorizontalRow ? "x" : "y";
  var columnDim = isHorizontalRow ? "y" : "x";
  var rowSize = rectShape[rowSizeDim] / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = rectShape[columnSizeDim] / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      newShape[rowDim] = row * rowSize;
      newShape[columnDim] = column * columnSize;
      newShape[rowSizeDim] = rowSize;
      newShape[columnSizeDim] = columnSize;
      newShape.x += rectShape.x;
      newShape.y += rectShape.y;
      outShapes.push(newShape);
    }
  }
}
function crossProduct2d(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function lineLineIntersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d(nx, ny, mx, my);
  if (Math.abs(nmCrossProduct) < 1e-6) {
    return null;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var p2 = crossProduct2d(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return null;
  }
  return new Point$1(p2 * mx + a1x, p2 * my + a1y);
}
function projPtOnLine(pt, lineA, lineB) {
  var dir3 = new Point$1();
  Point$1.sub(dir3, lineB, lineA);
  dir3.normalize();
  var dir22 = new Point$1();
  Point$1.sub(dir22, pt, lineA);
  var len2 = dir22.dot(dir3);
  return len2;
}
function addToPoly(poly, pt) {
  var last = poly[poly.length - 1];
  if (last && last[0] === pt[0] && last[1] === pt[1]) {
    return;
  }
  poly.push(pt);
}
function splitPolygonByLine(points2, lineA, lineB) {
  var len2 = points2.length;
  var intersections = [];
  for (var i = 0; i < len2; i++) {
    var p0 = points2[i];
    var p1 = points2[(i + 1) % len2];
    var intersectionPt = lineLineIntersect(p0[0], p0[1], p1[0], p1[1], lineA.x, lineA.y, lineB.x, lineB.y);
    if (intersectionPt) {
      intersections.push({
        projPt: projPtOnLine(intersectionPt, lineA, lineB),
        pt: intersectionPt,
        idx: i
      });
    }
  }
  if (intersections.length < 2) {
    return [{ points: points2 }, { points: points2 }];
  }
  intersections.sort(function(a, b2) {
    return a.projPt - b2.projPt;
  });
  var splitPt0 = intersections[0];
  var splitPt1 = intersections[intersections.length - 1];
  if (splitPt1.idx < splitPt0.idx) {
    var tmp = splitPt0;
    splitPt0 = splitPt1;
    splitPt1 = tmp;
  }
  var splitPt0Arr = [splitPt0.pt.x, splitPt0.pt.y];
  var splitPt1Arr = [splitPt1.pt.x, splitPt1.pt.y];
  var newPolyA = [splitPt0Arr];
  var newPolyB = [splitPt1Arr];
  for (var i = splitPt0.idx + 1; i <= splitPt1.idx; i++) {
    addToPoly(newPolyA, points2[i].slice());
  }
  addToPoly(newPolyA, splitPt1Arr);
  addToPoly(newPolyA, splitPt0Arr);
  for (var i = splitPt1.idx + 1; i <= splitPt0.idx + len2; i++) {
    addToPoly(newPolyB, points2[i % len2].slice());
  }
  addToPoly(newPolyB, splitPt0Arr);
  addToPoly(newPolyB, splitPt1Arr);
  return [{
    points: newPolyA
  }, {
    points: newPolyB
  }];
}
function binaryDividePolygon(polygonShape) {
  var points2 = polygonShape.points;
  var min3 = [];
  var max3 = [];
  fromPoints(points2, min3, max3);
  var boundingRect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
  var width = boundingRect.width;
  var height = boundingRect.height;
  var x2 = boundingRect.x;
  var y2 = boundingRect.y;
  var pt02 = new Point$1();
  var pt12 = new Point$1();
  if (width > height) {
    pt02.x = pt12.x = x2 + width / 2;
    pt02.y = y2;
    pt12.y = y2 + height;
  } else {
    pt02.y = pt12.y = y2 + height / 2;
    pt02.x = x2;
    pt12.x = x2 + width;
  }
  return splitPolygonByLine(points2, pt02, pt12);
}
function binaryDivideRecursive(divider, shape, count2, out2) {
  if (count2 === 1) {
    out2.push(shape);
  } else {
    var mid = Math.floor(count2 / 2);
    var sub2 = divider(shape);
    binaryDivideRecursive(divider, sub2[0], mid, out2);
    binaryDivideRecursive(divider, sub2[1], count2 - mid, out2);
  }
  return out2;
}
function clone(path, count2) {
  var paths = [];
  for (var i = 0; i < count2; i++) {
    paths.push(clonePath(path));
  }
  return paths;
}
function copyPathProps(source, target) {
  target.setStyle(source.style);
  target.z = source.z;
  target.z2 = source.z2;
  target.zlevel = source.zlevel;
}
function polygonConvert(points2) {
  var out2 = [];
  for (var i = 0; i < points2.length; ) {
    out2.push([points2[i++], points2[i++]]);
  }
  return out2;
}
function split(path, count2) {
  var outShapes = [];
  var shape = path.shape;
  var OutShapeCtor;
  switch (path.type) {
    case "rect":
      divideRect(shape, count2, outShapes);
      OutShapeCtor = Rect$3;
      break;
    case "sector":
      divideSector(shape, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    case "circle":
      divideSector({
        r0: 0,
        r: shape.r,
        startAngle: 0,
        endAngle: Math.PI * 2,
        cx: shape.cx,
        cy: shape.cy
      }, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    default:
      var m2 = path.getComputedTransform();
      var scale2 = m2 ? Math.sqrt(Math.max(m2[0] * m2[0] + m2[1] * m2[1], m2[2] * m2[2] + m2[3] * m2[3])) : 1;
      var polygons = map$1(pathToPolygons(path.getUpdatedPathProxy(), scale2), function(poly) {
        return polygonConvert(poly);
      });
      var polygonCount = polygons.length;
      if (polygonCount === 0) {
        binaryDivideRecursive(binaryDividePolygon, {
          points: polygons[0]
        }, count2, outShapes);
      } else if (polygonCount === count2) {
        for (var i = 0; i < polygonCount; i++) {
          outShapes.push({
            points: polygons[i]
          });
        }
      } else {
        var totalArea_1 = 0;
        var items = map$1(polygons, function(poly) {
          var min3 = [];
          var max3 = [];
          fromPoints(poly, min3, max3);
          var area = (max3[1] - min3[1]) * (max3[0] - min3[0]);
          totalArea_1 += area;
          return { poly, area };
        });
        items.sort(function(a, b2) {
          return b2.area - a.area;
        });
        var left = count2;
        for (var i = 0; i < polygonCount; i++) {
          var item = items[i];
          if (left <= 0) {
            break;
          }
          var selfCount = i === polygonCount - 1 ? left : Math.ceil(item.area / totalArea_1 * count2);
          if (selfCount < 0) {
            continue;
          }
          binaryDivideRecursive(binaryDividePolygon, {
            points: item.poly
          }, selfCount, outShapes);
          left -= selfCount;
        }
      }
      OutShapeCtor = Polygon$1;
      break;
  }
  if (!OutShapeCtor) {
    return clone(path, count2);
  }
  var out2 = [];
  for (var i = 0; i < outShapes.length; i++) {
    var subPath = new OutShapeCtor();
    subPath.setShape(outShapes[i]);
    copyPathProps(path, subPath);
    out2.push(subPath);
  }
  return out2;
}
function alignSubpath(subpath1, subpath2) {
  var len1 = subpath1.length;
  var len2 = subpath2.length;
  if (len1 === len2) {
    return [subpath1, subpath2];
  }
  var tmpSegX = [];
  var tmpSegY = [];
  var shorterPath = len1 < len2 ? subpath1 : subpath2;
  var shorterLen = Math.min(len1, len2);
  var diff = Math.abs(len2 - len1) / 6;
  var shorterBezierCount = (shorterLen - 2) / 6;
  var eachCurveSubDivCount = Math.ceil(diff / shorterBezierCount) + 1;
  var newSubpath = [shorterPath[0], shorterPath[1]];
  var remained = diff;
  for (var i = 2; i < shorterLen; ) {
    var x0 = shorterPath[i - 2];
    var y0 = shorterPath[i - 1];
    var x1 = shorterPath[i++];
    var y1 = shorterPath[i++];
    var x2 = shorterPath[i++];
    var y2 = shorterPath[i++];
    var x3 = shorterPath[i++];
    var y3 = shorterPath[i++];
    if (remained <= 0) {
      newSubpath.push(x1, y1, x2, y2, x3, y3);
      continue;
    }
    var actualSubDivCount = Math.min(remained, eachCurveSubDivCount - 1) + 1;
    for (var k2 = 1; k2 <= actualSubDivCount; k2++) {
      var p2 = k2 / actualSubDivCount;
      cubicSubdivide(x0, x1, x2, x3, p2, tmpSegX);
      cubicSubdivide(y0, y1, y2, y3, p2, tmpSegY);
      x0 = tmpSegX[3];
      y0 = tmpSegY[3];
      newSubpath.push(tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], x0, y0);
      x1 = tmpSegX[5];
      y1 = tmpSegY[5];
      x2 = tmpSegX[6];
      y2 = tmpSegY[6];
    }
    remained -= actualSubDivCount - 1;
  }
  return shorterPath === subpath1 ? [newSubpath, subpath2] : [subpath1, newSubpath];
}
function createSubpath(lastSubpathSubpath, otherSubpath) {
  var len2 = lastSubpathSubpath.length;
  var lastX = lastSubpathSubpath[len2 - 2];
  var lastY = lastSubpathSubpath[len2 - 1];
  var newSubpath = [];
  for (var i = 0; i < otherSubpath.length; ) {
    newSubpath[i++] = lastX;
    newSubpath[i++] = lastY;
  }
  return newSubpath;
}
function alignBezierCurves(array1, array22) {
  var _a2;
  var lastSubpath1;
  var lastSubpath2;
  var newArray1 = [];
  var newArray2 = [];
  for (var i = 0; i < Math.max(array1.length, array22.length); i++) {
    var subpath1 = array1[i];
    var subpath2 = array22[i];
    var newSubpath1 = void 0;
    var newSubpath2 = void 0;
    if (!subpath1) {
      newSubpath1 = createSubpath(lastSubpath1 || subpath2, subpath2);
      newSubpath2 = subpath2;
    } else if (!subpath2) {
      newSubpath2 = createSubpath(lastSubpath2 || subpath1, subpath1);
      newSubpath1 = subpath1;
    } else {
      _a2 = alignSubpath(subpath1, subpath2), newSubpath1 = _a2[0], newSubpath2 = _a2[1];
      lastSubpath1 = newSubpath1;
      lastSubpath2 = newSubpath2;
    }
    newArray1.push(newSubpath1);
    newArray2.push(newSubpath2);
  }
  return [newArray1, newArray2];
}
function centroid(array4) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = array4.length;
  for (var i = 0, j = len2 - 2; i < len2; j = i, i += 2) {
    var x0 = array4[j];
    var y0 = array4[j + 1];
    var x1 = array4[i];
    var y1 = array4[i + 1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
  }
  if (signedArea === 0) {
    return [array4[0] || 0, array4[1] || 0];
  }
  return [cx / signedArea / 3, cy / signedArea / 3, signedArea];
}
function findBestRingOffset(fromSubBeziers, toSubBeziers, fromCp, toCp) {
  var bezierCount = (fromSubBeziers.length - 2) / 6;
  var bestScore = Infinity;
  var bestOffset = 0;
  var len2 = fromSubBeziers.length;
  var len22 = len2 - 2;
  for (var offset = 0; offset < bezierCount; offset++) {
    var cursorOffset = offset * 6;
    var score = 0;
    for (var k2 = 0; k2 < len2; k2 += 2) {
      var idx = k2 === 0 ? cursorOffset : (cursorOffset + k2 - 2) % len22 + 2;
      var x0 = fromSubBeziers[idx] - fromCp[0];
      var y0 = fromSubBeziers[idx + 1] - fromCp[1];
      var x1 = toSubBeziers[k2] - toCp[0];
      var y1 = toSubBeziers[k2 + 1] - toCp[1];
      var dx = x1 - x0;
      var dy = y1 - y0;
      score += dx * dx + dy * dy;
    }
    if (score < bestScore) {
      bestScore = score;
      bestOffset = offset;
    }
  }
  return bestOffset;
}
function reverse(array4) {
  var newArr = [];
  var len2 = array4.length;
  for (var i = 0; i < len2; i += 2) {
    newArr[i] = array4[len2 - i - 2];
    newArr[i + 1] = array4[len2 - i - 1];
  }
  return newArr;
}
function findBestMorphingRotation(fromArr, toArr2, searchAngleIteration, searchAngleRange) {
  var result = [];
  var fromNeedsReverse;
  for (var i = 0; i < fromArr.length; i++) {
    var fromSubpathBezier = fromArr[i];
    var toSubpathBezier = toArr2[i];
    var fromCp = centroid(fromSubpathBezier);
    var toCp = centroid(toSubpathBezier);
    if (fromNeedsReverse == null) {
      fromNeedsReverse = fromCp[2] < 0 !== toCp[2] < 0;
    }
    var newFromSubpathBezier = [];
    var newToSubpathBezier = [];
    var bestAngle = 0;
    var bestScore = Infinity;
    var tmpArr2 = [];
    var len2 = fromSubpathBezier.length;
    if (fromNeedsReverse) {
      fromSubpathBezier = reverse(fromSubpathBezier);
    }
    var offset = findBestRingOffset(fromSubpathBezier, toSubpathBezier, fromCp, toCp) * 6;
    var len22 = len2 - 2;
    for (var k2 = 0; k2 < len22; k2 += 2) {
      var idx = (offset + k2) % len22 + 2;
      newFromSubpathBezier[k2 + 2] = fromSubpathBezier[idx] - fromCp[0];
      newFromSubpathBezier[k2 + 3] = fromSubpathBezier[idx + 1] - fromCp[1];
    }
    newFromSubpathBezier[0] = fromSubpathBezier[offset] - fromCp[0];
    newFromSubpathBezier[1] = fromSubpathBezier[offset + 1] - fromCp[1];
    if (searchAngleIteration > 0) {
      var step = searchAngleRange / searchAngleIteration;
      for (var angle = -searchAngleRange / 2; angle <= searchAngleRange / 2; angle += step) {
        var sa = Math.sin(angle);
        var ca = Math.cos(angle);
        var score = 0;
        for (var k2 = 0; k2 < fromSubpathBezier.length; k2 += 2) {
          var x0 = newFromSubpathBezier[k2];
          var y0 = newFromSubpathBezier[k2 + 1];
          var x1 = toSubpathBezier[k2] - toCp[0];
          var y1 = toSubpathBezier[k2 + 1] - toCp[1];
          var newX1 = x1 * ca - y1 * sa;
          var newY1 = x1 * sa + y1 * ca;
          tmpArr2[k2] = newX1;
          tmpArr2[k2 + 1] = newY1;
          var dx = newX1 - x0;
          var dy = newY1 - y0;
          score += dx * dx + dy * dy;
        }
        if (score < bestScore) {
          bestScore = score;
          bestAngle = angle;
          for (var m2 = 0; m2 < tmpArr2.length; m2++) {
            newToSubpathBezier[m2] = tmpArr2[m2];
          }
        }
      }
    } else {
      for (var i_1 = 0; i_1 < len2; i_1 += 2) {
        newToSubpathBezier[i_1] = toSubpathBezier[i_1] - toCp[0];
        newToSubpathBezier[i_1 + 1] = toSubpathBezier[i_1 + 1] - toCp[1];
      }
    }
    result.push({
      from: newFromSubpathBezier,
      to: newToSubpathBezier,
      fromCp,
      toCp,
      rotation: -bestAngle
    });
  }
  return result;
}
function isCombineMorphing(path) {
  return path.__isCombineMorphing;
}
var SAVED_METHOD_PREFIX = "__mOriginal_";
function saveAndModifyMethod(obj, methodName, modifiers) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  var originalMethod = obj[savedMethodName] || obj[methodName];
  if (!obj[savedMethodName]) {
    obj[savedMethodName] = obj[methodName];
  }
  var replace = modifiers.replace;
  var after = modifiers.after;
  var before = modifiers.before;
  obj[methodName] = function() {
    var args = arguments;
    var res;
    before && before.apply(this, args);
    if (replace) {
      res = replace.apply(this, args);
    } else {
      res = originalMethod.apply(this, args);
    }
    after && after.apply(this, args);
    return res;
  };
}
function restoreMethod(obj, methodName) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  if (obj[savedMethodName]) {
    obj[methodName] = obj[savedMethodName];
    obj[savedMethodName] = null;
  }
}
function applyTransformOnBeziers(bezierCurves, mm) {
  for (var i = 0; i < bezierCurves.length; i++) {
    var subBeziers = bezierCurves[i];
    for (var k2 = 0; k2 < subBeziers.length; ) {
      var x2 = subBeziers[k2];
      var y2 = subBeziers[k2 + 1];
      subBeziers[k2++] = mm[0] * x2 + mm[2] * y2 + mm[4];
      subBeziers[k2++] = mm[1] * x2 + mm[3] * y2 + mm[5];
    }
  }
}
function prepareMorphPath(fromPath, toPath) {
  var fromPathProxy = fromPath.getUpdatedPathProxy();
  var toPathProxy = toPath.getUpdatedPathProxy();
  var _a2 = alignBezierCurves(pathToBezierCurves(fromPathProxy), pathToBezierCurves(toPathProxy)), fromBezierCurves = _a2[0], toBezierCurves = _a2[1];
  var fromPathTransform = fromPath.getComputedTransform();
  var toPathTransform = toPath.getComputedTransform();
  function updateIdentityTransform() {
    this.transform = null;
  }
  fromPathTransform && applyTransformOnBeziers(fromBezierCurves, fromPathTransform);
  toPathTransform && applyTransformOnBeziers(toBezierCurves, toPathTransform);
  saveAndModifyMethod(toPath, "updateTransform", { replace: updateIdentityTransform });
  toPath.transform = null;
  var morphingData = findBestMorphingRotation(fromBezierCurves, toBezierCurves, 10, Math.PI);
  var tmpArr2 = [];
  saveAndModifyMethod(toPath, "buildPath", { replace: function(path) {
    var t2 = toPath.__morphT;
    var onet = 1 - t2;
    var newCp = [];
    for (var i = 0; i < morphingData.length; i++) {
      var item = morphingData[i];
      var from = item.from;
      var to = item.to;
      var angle = item.rotation * t2;
      var fromCp = item.fromCp;
      var toCp = item.toCp;
      var sa = Math.sin(angle);
      var ca = Math.cos(angle);
      lerp$1(newCp, fromCp, toCp, t2);
      for (var m2 = 0; m2 < from.length; m2 += 2) {
        var x0_1 = from[m2];
        var y0_1 = from[m2 + 1];
        var x1 = to[m2];
        var y1 = to[m2 + 1];
        var x2 = x0_1 * onet + x1 * t2;
        var y2 = y0_1 * onet + y1 * t2;
        tmpArr2[m2] = x2 * ca - y2 * sa + newCp[0];
        tmpArr2[m2 + 1] = x2 * sa + y2 * ca + newCp[1];
      }
      var x0 = tmpArr2[0];
      var y0 = tmpArr2[1];
      path.moveTo(x0, y0);
      for (var m2 = 2; m2 < from.length; ) {
        var x1 = tmpArr2[m2++];
        var y1 = tmpArr2[m2++];
        var x22 = tmpArr2[m2++];
        var y22 = tmpArr2[m2++];
        var x3 = tmpArr2[m2++];
        var y3 = tmpArr2[m2++];
        if (x0 === x1 && y0 === y1 && x22 === x3 && y22 === y3) {
          path.lineTo(x3, y3);
        } else {
          path.bezierCurveTo(x1, y1, x22, y22, x3, y3);
        }
        x0 = x3;
        y0 = y3;
      }
    }
  } });
}
function morphPath(fromPath, toPath, animationOpts) {
  if (!fromPath || !toPath) {
    return toPath;
  }
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  prepareMorphPath(fromPath, toPath);
  toPath.__morphT = 0;
  function restoreToPath() {
    restoreMethod(toPath, "buildPath");
    restoreMethod(toPath, "updateTransform");
    toPath.__morphT = -1;
    toPath.createPathProxy();
    toPath.dirtyShape();
  }
  toPath.animateTo({
    __morphT: 1
  }, defaults({
    during: function(p2) {
      toPath.dirtyShape();
      oldDuring && oldDuring(p2);
    },
    done: function() {
      restoreToPath();
      oldDone && oldDone();
    }
  }, animationOpts));
  return toPath;
}
function hilbert(x2, y2, minX, minY, maxX, maxY) {
  var bits = 16;
  x2 = maxX === minX ? 0 : Math.round(32767 * (x2 - minX) / (maxX - minX));
  y2 = maxY === minY ? 0 : Math.round(32767 * (y2 - minY) / (maxY - minY));
  var d2 = 0;
  var tmp;
  for (var s = (1 << bits) / 2; s > 0; s /= 2) {
    var rx = 0;
    var ry = 0;
    if ((x2 & s) > 0) {
      rx = 1;
    }
    if ((y2 & s) > 0) {
      ry = 1;
    }
    d2 += s * s * (3 * rx ^ ry);
    if (ry === 0) {
      if (rx === 1) {
        x2 = s - 1 - x2;
        y2 = s - 1 - y2;
      }
      tmp = x2;
      x2 = y2;
      y2 = tmp;
    }
  }
  return d2;
}
function sortPaths(pathList) {
  var xMin = Infinity;
  var yMin = Infinity;
  var xMax = -Infinity;
  var yMax = -Infinity;
  var cps = map$1(pathList, function(path) {
    var rect = path.getBoundingRect();
    var m2 = path.getComputedTransform();
    var x2 = rect.x + rect.width / 2 + (m2 ? m2[4] : 0);
    var y2 = rect.y + rect.height / 2 + (m2 ? m2[5] : 0);
    xMin = Math.min(x2, xMin);
    yMin = Math.min(y2, yMin);
    xMax = Math.max(x2, xMax);
    yMax = Math.max(y2, yMax);
    return [x2, y2];
  });
  var items = map$1(cps, function(cp, idx) {
    return {
      cp,
      z: hilbert(cp[0], cp[1], xMin, yMin, xMax, yMax),
      path: pathList[idx]
    };
  });
  return items.sort(function(a, b2) {
    return a.z - b2.z;
  }).map(function(item) {
    return item.path;
  });
}
function defaultDividePath(param) {
  return split(param.path, param.count);
}
function createEmptyReturn() {
  return {
    fromIndividuals: [],
    toIndividuals: [],
    count: 0
  };
}
function combineMorph(fromList, toPath, animationOpts) {
  var fromPathList = [];
  function addFromPath(fromList2) {
    for (var i2 = 0; i2 < fromList2.length; i2++) {
      var from2 = fromList2[i2];
      if (isCombineMorphing(from2)) {
        addFromPath(from2.childrenRef());
      } else if (from2 instanceof Path$1) {
        fromPathList.push(from2);
      }
    }
  }
  addFromPath(fromList);
  var separateCount = fromPathList.length;
  if (!separateCount) {
    return createEmptyReturn();
  }
  var dividePath = animationOpts.dividePath || defaultDividePath;
  var toSubPathList = dividePath({
    path: toPath,
    count: separateCount
  });
  if (toSubPathList.length !== separateCount) {
    console.error("Invalid morphing: unmatched splitted path");
    return createEmptyReturn();
  }
  fromPathList = sortPaths(fromPathList);
  toSubPathList = sortPaths(toSubPathList);
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  var individualDelay = animationOpts.individualDelay;
  var identityTransform = new Transformable$1();
  for (var i = 0; i < separateCount; i++) {
    var from = fromPathList[i];
    var to = toSubPathList[i];
    to.parent = toPath;
    to.copyTransform(identityTransform);
    if (!individualDelay) {
      prepareMorphPath(from, to);
    }
  }
  toPath.__isCombineMorphing = true;
  toPath.childrenRef = function() {
    return toSubPathList;
  };
  function addToSubPathListToZr(zr) {
    for (var i2 = 0; i2 < toSubPathList.length; i2++) {
      toSubPathList[i2].addSelfToZr(zr);
    }
  }
  saveAndModifyMethod(toPath, "addSelfToZr", {
    after: function(zr) {
      addToSubPathListToZr(zr);
    }
  });
  saveAndModifyMethod(toPath, "removeSelfFromZr", {
    after: function(zr) {
      for (var i2 = 0; i2 < toSubPathList.length; i2++) {
        toSubPathList[i2].removeSelfFromZr(zr);
      }
    }
  });
  function restoreToPath() {
    toPath.__isCombineMorphing = false;
    toPath.__morphT = -1;
    toPath.childrenRef = null;
    restoreMethod(toPath, "addSelfToZr");
    restoreMethod(toPath, "removeSelfFromZr");
  }
  var toLen = toSubPathList.length;
  if (individualDelay) {
    var animating_1 = toLen;
    var eachDone = function() {
      animating_1--;
      if (animating_1 === 0) {
        restoreToPath();
        oldDone && oldDone();
      }
    };
    for (var i = 0; i < toLen; i++) {
      var indivdualAnimationOpts = individualDelay ? defaults({
        delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toSubPathList[i]),
        done: eachDone
      }, animationOpts) : animationOpts;
      morphPath(fromPathList[i], toSubPathList[i], indivdualAnimationOpts);
    }
  } else {
    toPath.__morphT = 0;
    toPath.animateTo({
      __morphT: 1
    }, defaults({
      during: function(p2) {
        for (var i2 = 0; i2 < toLen; i2++) {
          var child = toSubPathList[i2];
          child.__morphT = toPath.__morphT;
          child.dirtyShape();
        }
        oldDuring && oldDuring(p2);
      },
      done: function() {
        restoreToPath();
        for (var i2 = 0; i2 < fromList.length; i2++) {
          restoreMethod(fromList[i2], "updateTransform");
        }
        oldDone && oldDone();
      }
    }, animationOpts));
  }
  if (toPath.__zr) {
    addToSubPathListToZr(toPath.__zr);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toSubPathList,
    count: toLen
  };
}
function separateMorph(fromPath, toPathList, animationOpts) {
  var toLen = toPathList.length;
  var fromPathList = [];
  var dividePath = animationOpts.dividePath || defaultDividePath;
  function addFromPath(fromList) {
    for (var i2 = 0; i2 < fromList.length; i2++) {
      var from = fromList[i2];
      if (isCombineMorphing(from)) {
        addFromPath(from.childrenRef());
      } else if (from instanceof Path$1) {
        fromPathList.push(from);
      }
    }
  }
  if (isCombineMorphing(fromPath)) {
    addFromPath(fromPath.childrenRef());
    var fromLen = fromPathList.length;
    if (fromLen < toLen) {
      var k2 = 0;
      for (var i = fromLen; i < toLen; i++) {
        fromPathList.push(clonePath(fromPathList[k2++ % fromLen]));
      }
    }
    fromPathList.length = toLen;
  } else {
    fromPathList = dividePath({ path: fromPath, count: toLen });
    var fromPathTransform = fromPath.getComputedTransform();
    for (var i = 0; i < fromPathList.length; i++) {
      fromPathList[i].setLocalTransform(fromPathTransform);
    }
    if (fromPathList.length !== toLen) {
      console.error("Invalid morphing: unmatched splitted path");
      return createEmptyReturn();
    }
  }
  fromPathList = sortPaths(fromPathList);
  toPathList = sortPaths(toPathList);
  var individualDelay = animationOpts.individualDelay;
  for (var i = 0; i < toLen; i++) {
    var indivdualAnimationOpts = individualDelay ? defaults({
      delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toPathList[i])
    }, animationOpts) : animationOpts;
    morphPath(fromPathList[i], toPathList[i], indivdualAnimationOpts);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toPathList,
    count: toPathList.length
  };
}
function isMultiple(elements) {
  return isArray$1(elements[0]);
}
function prepareMorphBatches(one, many) {
  var batches = [];
  var batchCount = one.length;
  for (var i = 0; i < batchCount; i++) {
    batches.push({
      one: one[i],
      many: []
    });
  }
  for (var i = 0; i < many.length; i++) {
    var len2 = many[i].length;
    var k2 = void 0;
    for (k2 = 0; k2 < len2; k2++) {
      batches[k2 % batchCount].many.push(many[i][k2]);
    }
  }
  var off = 0;
  for (var i = batchCount - 1; i >= 0; i--) {
    if (!batches[i].many.length) {
      var moveFrom = batches[off].many;
      if (moveFrom.length <= 1) {
        if (off) {
          off = 0;
        } else {
          return batches;
        }
      }
      var len2 = moveFrom.length;
      var mid = Math.ceil(len2 / 2);
      batches[i].many = moveFrom.slice(mid, len2);
      batches[off].many = moveFrom.slice(0, mid);
      off++;
    }
  }
  return batches;
}
var pathDividers = {
  clone: function(params) {
    var ret = [];
    var approxOpacity = 1 - Math.pow(1 - params.path.style.opacity, 1 / params.count);
    for (var i = 0; i < params.count; i++) {
      var cloned = clonePath(params.path);
      cloned.setStyle("opacity", approxOpacity);
      ret.push(cloned);
    }
    return ret;
  },
  split: null
};
function applyMorphAnimation(from, to, divideShape, seriesModel, dataIndex, animateOtherProps) {
  if (!from.length || !to.length) {
    return;
  }
  var updateAnimationCfg = getAnimationConfig("update", seriesModel, dataIndex);
  if (!(updateAnimationCfg && updateAnimationCfg.duration > 0)) {
    return;
  }
  var animationDelay = seriesModel.getModel("universalTransition").get("delay");
  var animationCfg = Object.assign({
    setToFinal: true
  }, updateAnimationCfg);
  var many;
  var one;
  if (isMultiple(from)) {
    many = from;
    one = to;
  }
  if (isMultiple(to)) {
    many = to;
    one = from;
  }
  function morphOneBatch(batch, fromIsMany2, animateIndex2, animateCount2, forceManyOne) {
    var batchMany = batch.many;
    var batchOne = batch.one;
    if (batchMany.length === 1 && !forceManyOne) {
      var batchFrom = fromIsMany2 ? batchMany[0] : batchOne;
      var batchTo = fromIsMany2 ? batchOne : batchMany[0];
      if (isCombineMorphing(batchFrom)) {
        morphOneBatch({
          many: [batchFrom],
          one: batchTo
        }, true, animateIndex2, animateCount2, true);
      } else {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(animateIndex2, animateCount2)
        }, animationCfg) : animationCfg;
        morphPath(batchFrom, batchTo, individualAnimationCfg);
        animateOtherProps(batchFrom, batchTo, batchFrom, batchTo, individualAnimationCfg);
      }
    } else {
      var separateAnimationCfg = defaults({
        dividePath: pathDividers[divideShape],
        individualDelay: animationDelay && function(idx, count3, fromPath, toPath) {
          return animationDelay(idx + animateIndex2, animateCount2);
        }
      }, animationCfg);
      var _a2 = fromIsMany2 ? combineMorph(batchMany, batchOne, separateAnimationCfg) : separateMorph(batchOne, batchMany, separateAnimationCfg), fromIndividuals = _a2.fromIndividuals, toIndividuals = _a2.toIndividuals;
      var count2 = fromIndividuals.length;
      for (var k2 = 0; k2 < count2; k2++) {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(k2, count2)
        }, animationCfg) : animationCfg;
        animateOtherProps(fromIndividuals[k2], toIndividuals[k2], fromIsMany2 ? batchMany[k2] : batch.one, fromIsMany2 ? batch.one : batchMany[k2], individualAnimationCfg);
      }
    }
  }
  var fromIsMany = many ? many === from : from.length > to.length;
  var morphBatches = many ? prepareMorphBatches(one, many) : prepareMorphBatches(fromIsMany ? to : from, [fromIsMany ? from : to]);
  var animateCount = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    animateCount += morphBatches[i].many.length;
  }
  var animateIndex = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    morphOneBatch(morphBatches[i], fromIsMany, animateIndex, animateCount);
    animateIndex += morphBatches[i].many.length;
  }
}
function getPathList(elements) {
  if (!elements) {
    return [];
  }
  if (isArray$1(elements)) {
    var pathList_1 = [];
    for (var i = 0; i < elements.length; i++) {
      pathList_1.push(getPathList(elements[i]));
    }
    return pathList_1;
  }
  var pathList = [];
  elements.traverse(function(el) {
    if (el instanceof Path$1 && !el.disableMorphing && !el.invisible && !el.ignore) {
      pathList.push(el);
    }
  });
  return pathList;
}
var DATA_COUNT_THRESHOLD = 1e4;
var getUniversalTransitionGlobalStore = makeInner();
function getGroupIdDimension(data) {
  var dimensions = data.dimensions;
  for (var i = 0; i < dimensions.length; i++) {
    var dimInfo = data.getDimensionInfo(dimensions[i]);
    if (dimInfo && dimInfo.otherDims.itemGroupId === 0) {
      return dimensions[i];
    }
  }
}
function flattenDataDiffItems(list) {
  var items = [];
  each$f(list, function(seriesInfo) {
    var data = seriesInfo.data;
    if (data.count() > DATA_COUNT_THRESHOLD) {
      return;
    }
    var indices = data.getIndices();
    var groupDim = getGroupIdDimension(data);
    for (var dataIndex = 0; dataIndex < indices.length; dataIndex++) {
      items.push({
        data,
        dim: seriesInfo.dim || groupDim,
        divide: seriesInfo.divide,
        dataIndex
      });
    }
  });
  return items;
}
function fadeInElement(newEl2, newSeries, newIndex) {
  newEl2.traverse(function(el) {
    if (el instanceof Path$1) {
      initProps(el, {
        style: {
          opacity: 0
        }
      }, newSeries, {
        dataIndex: newIndex,
        isFrom: true
      });
    }
  });
}
function removeEl(el) {
  if (el.parent) {
    var computedTransform = el.getComputedTransform();
    el.setLocalTransform(computedTransform);
    el.parent.remove(el);
  }
}
function stopAnimation(el) {
  el.stopAnimation();
  if (el.isGroup) {
    el.traverse(function(child) {
      child.stopAnimation();
    });
  }
}
function animateElementStyles(el, dataIndex, seriesModel) {
  var animationConfig = getAnimationConfig("update", seriesModel, dataIndex);
  animationConfig && el.traverse(function(child) {
    if (child instanceof Displayable$1) {
      var oldStyle = getOldStyle(child);
      if (oldStyle) {
        child.animateFrom({
          style: oldStyle
        }, animationConfig);
      }
    }
  });
}
function isAllIdSame(oldDiffItems, newDiffItems) {
  var len2 = oldDiffItems.length;
  if (len2 !== newDiffItems.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    var oldItem = oldDiffItems[i];
    var newItem = newDiffItems[i];
    if (oldItem.data.getId(oldItem.dataIndex) !== newItem.data.getId(newItem.dataIndex)) {
      return false;
    }
  }
  return true;
}
function transitionBetween(oldList, newList, api) {
  var oldDiffItems = flattenDataDiffItems(oldList);
  var newDiffItems = flattenDataDiffItems(newList);
  function updateMorphingPathProps(from, to, rawFrom, rawTo, animationCfg) {
    if (rawFrom || from) {
      to.animateFrom({
        style: rawFrom && rawFrom !== from ? extend(extend({}, rawFrom.style), from.style) : from.style
      }, animationCfg);
    }
  }
  function findKeyDim(items) {
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].dim) {
        return items[i2].dim;
      }
    }
  }
  var oldKeyDim = findKeyDim(oldDiffItems);
  var newKeyDim = findKeyDim(newDiffItems);
  var hasMorphAnimation = false;
  function createKeyGetter(isOld, onlyGetId) {
    return function(diffItem) {
      var data = diffItem.data;
      var dataIndex = diffItem.dataIndex;
      if (onlyGetId) {
        return data.getId(dataIndex);
      }
      var dataGroupId = data.hostModel && data.hostModel.get("dataGroupId");
      var keyDim = isOld ? oldKeyDim || newKeyDim : newKeyDim || oldKeyDim;
      var dimInfo = keyDim && data.getDimensionInfo(keyDim);
      var dimOrdinalMeta = dimInfo && dimInfo.ordinalMeta;
      if (dimInfo) {
        var key = data.get(dimInfo.name, dataIndex);
        if (dimOrdinalMeta) {
          return dimOrdinalMeta.categories[key] || key + "";
        }
        return key + "";
      }
      var itemVal = data.getRawDataItem(dataIndex);
      if (itemVal && itemVal.groupId) {
        return itemVal.groupId + "";
      }
      return dataGroupId || data.getId(dataIndex);
    };
  }
  var useId = isAllIdSame(oldDiffItems, newDiffItems);
  var isElementStillInChart = {};
  if (!useId) {
    for (var i = 0; i < newDiffItems.length; i++) {
      var newItem = newDiffItems[i];
      var el = newItem.data.getItemGraphicEl(newItem.dataIndex);
      if (el) {
        isElementStillInChart[el.id] = true;
      }
    }
  }
  function updateOneToOne(newIndex, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var newItem2 = newDiffItems[newIndex];
    var newSeries = newItem2.data.hostModel;
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    var newEl2 = newItem2.data.getItemGraphicEl(newItem2.dataIndex);
    if (oldEl === newEl2) {
      newEl2 && animateElementStyles(newEl2, newItem2.dataIndex, newSeries);
      return;
    }
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newIndex);
      }
    }
  }
  new DataDiffer$1(oldDiffItems, newDiffItems, createKeyGetter(true, useId), createKeyGetter(false, useId), null, "multiple").update(updateOneToOne).updateManyToOne(function(newIndex, oldIndices) {
    var newItem2 = newDiffItems[newIndex];
    var newData = newItem2.data;
    var newSeries = newData.hostModel;
    var newEl2 = newData.getItemGraphicEl(newItem2.dataIndex);
    var oldElsList = filter(map$1(oldIndices, function(idx) {
      return oldDiffItems[idx].data.getItemGraphicEl(oldDiffItems[idx].dataIndex);
    }), function(oldEl) {
      return oldEl && oldEl !== newEl2 && !isElementStillInChart[oldEl.id];
    });
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldElsList.length) {
        each$f(oldElsList, function(oldEl) {
          stopAnimation(oldEl);
          removeEl(oldEl);
        });
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldElsList), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newItem2.dataIndex);
      }
    }
  }).updateOneToMany(function(newIndices, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    var newElsList = filter(map$1(newIndices, function(idx) {
      return newDiffItems[idx].data.getItemGraphicEl(newDiffItems[idx].dataIndex);
    }), function(el2) {
      return el2 && el2 !== oldEl;
    });
    var newSeris = newDiffItems[newIndices[0]].data.hostModel;
    if (newElsList.length) {
      each$f(newElsList, function(newEl2) {
        return stopAnimation(newEl2);
      });
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newElsList), oldItem.divide, newSeris, newIndices[0], updateMorphingPathProps);
      } else {
        each$f(newElsList, function(newEl2) {
          return fadeInElement(newEl2, newSeris, newIndices[0]);
        });
      }
    }
  }).updateManyToMany(function(newIndices, oldIndices) {
    new DataDiffer$1(oldIndices, newIndices, function(rawIdx) {
      return oldDiffItems[rawIdx].data.getId(oldDiffItems[rawIdx].dataIndex);
    }, function(rawIdx) {
      return newDiffItems[rawIdx].data.getId(newDiffItems[rawIdx].dataIndex);
    }).update(function(newIndex, oldIndex) {
      updateOneToOne(newIndices[newIndex], oldIndices[oldIndex]);
    }).execute();
  }).execute();
  if (hasMorphAnimation) {
    each$f(newList, function(_a2) {
      var data = _a2.data;
      var seriesModel = data.hostModel;
      var view = seriesModel && api.getViewOfSeriesModel(seriesModel);
      var animationCfg = getAnimationConfig("update", seriesModel, 0);
      if (view && seriesModel.isAnimationEnabled() && animationCfg && animationCfg.duration > 0) {
        view.group.traverse(function(el2) {
          if (el2 instanceof Path$1 && !el2.animators.length) {
            el2.animateFrom({
              style: {
                opacity: 0
              }
            }, animationCfg);
          }
        });
      }
    });
  }
}
function getSeriesTransitionKey(series) {
  var seriesKey = series.getModel("universalTransition").get("seriesKey");
  if (!seriesKey) {
    return series.id;
  }
  return seriesKey;
}
function convertArraySeriesKeyToString(seriesKey) {
  if (isArray$1(seriesKey)) {
    return seriesKey.sort().join(",");
  }
  return seriesKey;
}
function getDivideShapeFromData(data) {
  if (data.hostModel) {
    return data.hostModel.getModel("universalTransition").get("divideShape");
  }
}
function findTransitionSeriesBatches(globalStore, params) {
  var updateBatches = createHashMap();
  var oldDataMap = createHashMap();
  var oldDataMapForSplit = createHashMap();
  each$f(globalStore.oldSeries, function(series, idx) {
    var oldData = globalStore.oldData[idx];
    var transitionKey = getSeriesTransitionKey(series);
    var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
    oldDataMap.set(transitionKeyStr, oldData);
    if (isArray$1(transitionKey)) {
      each$f(transitionKey, function(key) {
        oldDataMapForSplit.set(key, {
          data: oldData,
          key: transitionKeyStr
        });
      });
    }
  });
  each$f(params.updatedSeries, function(series) {
    if (series.isUniversalTransitionEnabled() && series.isAnimationEnabled()) {
      var newData = series.getData();
      var transitionKey = getSeriesTransitionKey(series);
      var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
      var oldData = oldDataMap.get(transitionKeyStr);
      if (oldData) {
        updateBatches.set(transitionKeyStr, {
          oldSeries: [{
            divide: getDivideShapeFromData(oldData),
            data: oldData
          }],
          newSeries: [{
            divide: getDivideShapeFromData(newData),
            data: newData
          }]
        });
      } else {
        if (isArray$1(transitionKey)) {
          var oldSeries_1 = [];
          each$f(transitionKey, function(key) {
            var oldData2 = oldDataMap.get(key);
            if (oldData2) {
              oldSeries_1.push({
                divide: getDivideShapeFromData(oldData2),
                data: oldData2
              });
            }
          });
          if (oldSeries_1.length) {
            updateBatches.set(transitionKeyStr, {
              oldSeries: oldSeries_1,
              newSeries: [{
                data: newData,
                divide: getDivideShapeFromData(newData)
              }]
            });
          }
        } else {
          var oldData_1 = oldDataMapForSplit.get(transitionKey);
          if (oldData_1) {
            var batch = updateBatches.get(oldData_1.key);
            if (!batch) {
              batch = {
                oldSeries: [{
                  data: oldData_1.data,
                  divide: getDivideShapeFromData(oldData_1.data)
                }],
                newSeries: []
              };
              updateBatches.set(oldData_1.key, batch);
            }
            batch.newSeries.push({
              data: newData,
              divide: getDivideShapeFromData(newData)
            });
          }
        }
      }
    }
  });
  return updateBatches;
}
function querySeries(series, finder) {
  for (var i = 0; i < series.length; i++) {
    var found = finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id;
    if (found) {
      return i;
    }
  }
}
function transitionSeriesFromOpt(transitionOpt, globalStore, params, api) {
  var from = [];
  var to = [];
  each$f(normalizeToArray(transitionOpt.from), function(finder) {
    var idx = querySeries(globalStore.oldSeries, finder);
    if (idx >= 0) {
      from.push({
        data: globalStore.oldData[idx],
        divide: getDivideShapeFromData(globalStore.oldData[idx]),
        dim: finder.dimension
      });
    }
  });
  each$f(normalizeToArray(transitionOpt.to), function(finder) {
    var idx = querySeries(params.updatedSeries, finder);
    if (idx >= 0) {
      var data = params.updatedSeries[idx].getData();
      to.push({
        data,
        divide: getDivideShapeFromData(data),
        dim: finder.dimension
      });
    }
  });
  if (from.length > 0 && to.length > 0) {
    transitionBetween(from, to, api);
  }
}
function installUniversalTransition(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecMOdel, api, params) {
    each$f(normalizeToArray(params.seriesTransition), function(transOpt) {
      each$f(normalizeToArray(transOpt.to), function(finder) {
        var series = params.updatedSeries;
        for (var i = 0; i < series.length; i++) {
          if (finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id) {
            series[i][SERIES_UNIVERSAL_TRANSITION_PROP] = true;
          }
        }
      });
    });
  });
  registers.registerUpdateLifecycle("series:transition", function(ecModel, api, params) {
    var globalStore = getUniversalTransitionGlobalStore(api);
    if (globalStore.oldSeries && params.updatedSeries && params.optionChanged) {
      var transitionOpt = params.seriesTransition;
      if (transitionOpt) {
        each$f(normalizeToArray(transitionOpt), function(opt) {
          transitionSeriesFromOpt(opt, globalStore, params, api);
        });
      } else {
        var updateBatches_1 = findTransitionSeriesBatches(globalStore, params);
        each$f(updateBatches_1.keys(), function(key) {
          var batch = updateBatches_1.get(key);
          transitionBetween(batch.oldSeries, batch.newSeries, api);
        });
      }
      each$f(params.updatedSeries, function(series) {
        if (series[SERIES_UNIVERSAL_TRANSITION_PROP]) {
          series[SERIES_UNIVERSAL_TRANSITION_PROP] = false;
        }
      });
    }
    var allSeries = ecModel.getSeries();
    var savedSeries = globalStore.oldSeries = [];
    var savedData = globalStore.oldData = [];
    for (var i = 0; i < allSeries.length; i++) {
      var data = allSeries[i].getData();
      if (data.count() < DATA_COUNT_THRESHOLD) {
        savedSeries.push(allSeries[i]);
        savedData.push(data);
      }
    }
  });
}
use([install$R]);
use([install$S]);
use([install$Q, install$P, install$O, install$M, install$K, install$I, install$H, install$G, install$F, install$E, install$D, install$B, install$A, install$z, install$y, install$x, install$w, install$v, install$u, install$t, install$s, install$r]);
use(install$p);
use(install$o);
use(install$J);
use(install$n);
use(install$C);
use(install$m);
use(install$l);
use(install$j);
use(install$i);
use(install$q);
use(install$h);
use(install$g);
use(install$f);
use(install$e);
use(install$d);
use(install$c);
use(install$9);
use(install$6);
use(install$8);
use(install$7);
use(install$3);
use(install$5);
use(install$4);
use(install$2);
use(install$1);
use(install);
use(installUniversalTransition);
use(installLabelLayout);
function useEcharts(options) {
  const {
    defaultOptions
  } = options != null ? options : {};
  const container2 = useRef(null);
  const chart = useRef();
  const optionsRef = useRef(defaultOptions);
  useEffect(() => {
    if (!container2.current) {
      return;
    }
    const myEcharts = init$1(container2.current);
    chart.current = myEcharts;
    if (optionsRef.current) {
      myEcharts.setOption(optionsRef.current);
    }
  }, []);
  useEffect(() => {
    return () => {
      var _a2, _b2, _c2, _d;
      (_b2 = (_a2 = chart.current) == null ? void 0 : _a2.dispose) == null ? void 0 : _b2.call(_a2);
      (_d = (_c2 = chart.current) == null ? void 0 : _c2.off) == null ? void 0 : _d.call(_c2, "*");
      chart.current = void 0;
    };
  }, []);
  useEventListener("resize", () => {
    requestAnimationFrame(() => {
      var _a2, _b2;
      (_b2 = (_a2 = chart == null ? void 0 : chart.current) == null ? void 0 : _a2.resize) == null ? void 0 : _b2.call(_a2);
    });
  });
  return {
    chart,
    container: container2
  };
}
class Charts {
  constructor() {
    __publicField(this, "chartsEmitters", /* @__PURE__ */ new Map());
    __publicField(this, "add", (id2, chart, option, title) => {
      if (chart && option) {
        this.chartsEmitters.set(id2, {
          chart,
          option,
          title
        });
      } else {
        console.log("\u6DFB\u52A0\u5931\u8D25");
      }
    });
    __publicField(this, "get", (id2) => {
      return this.chartsEmitters.get(id2);
    });
    __publicField(this, "clear", () => {
      this.chartsEmitters.clear();
    });
    __publicField(this, "delete", (id2) => {
      this.chartsEmitters.delete(id2);
    });
    __publicField(this, "list", () => {
      var _a2, _b2, _c2;
      const list = [];
      for (const key of this.chartsEmitters.keys()) {
        list.push({
          id: key,
          chart: (_a2 = this.chartsEmitters.get(key)) == null ? void 0 : _a2.chart,
          option: (_b2 = this.chartsEmitters.get(key)) == null ? void 0 : _b2.option,
          title: (_c2 = this.chartsEmitters.get(key)) == null ? void 0 : _c2.title
        });
      }
      return list;
    });
  }
}
const _Charts = new Charts();
var lodash = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
(function(module, exports) {
  (function() {
    var undefined$1;
    var VERSION = "4.17.21";
    var LARGE_ARRAY_SIZE = 200;
    var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT2 = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    var MAX_MEMOIZE_SIZE = 500;
    var PLACEHOLDER = "__lodash_placeholder__";
    var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
    var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
    var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
    var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
    var HOT_COUNT = 800, HOT_SPAN = 16;
    var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
    var INFINITY = 1 / 0, MAX_SAFE_INTEGER2 = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN2 = 0 / 0;
    var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
    var wrapFlags = [
      ["ary", WRAP_ARY_FLAG],
      ["bind", WRAP_BIND_FLAG],
      ["bindKey", WRAP_BIND_KEY_FLAG],
      ["curry", WRAP_CURRY_FLAG],
      ["curryRight", WRAP_CURRY_RIGHT_FLAG],
      ["flip", WRAP_FLIP_FLAG],
      ["partial", WRAP_PARTIAL_FLAG],
      ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
      ["rearg", WRAP_REARG_FLAG]
    ];
    var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag2 = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag2 = "[object Symbol]", undefinedTag2 = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
    var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
    var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
    var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
    var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
    var reTrimStart2 = /^\s+/;
    var reWhitespace2 = /\s/;
    var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
    var reEscapeChar = /\\(\\)?/g;
    var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
    var reFlags = /\w*$/;
    var reIsBadHex2 = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary2 = /^0b[01]+$/i;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var reIsOctal2 = /^0o[0-7]+$/i;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var reNoMatch = /($^)/;
    var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
    var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reApos = RegExp(rsApos, "g");
    var reComboMark = RegExp(rsCombo, "g");
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    var reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    var contextProps = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ];
    var templateCounter = -1;
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    var cloneableTags = {};
    cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag2] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
    cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
    var deburredLetters = {
      "\xC0": "A",
      "\xC1": "A",
      "\xC2": "A",
      "\xC3": "A",
      "\xC4": "A",
      "\xC5": "A",
      "\xE0": "a",
      "\xE1": "a",
      "\xE2": "a",
      "\xE3": "a",
      "\xE4": "a",
      "\xE5": "a",
      "\xC7": "C",
      "\xE7": "c",
      "\xD0": "D",
      "\xF0": "d",
      "\xC8": "E",
      "\xC9": "E",
      "\xCA": "E",
      "\xCB": "E",
      "\xE8": "e",
      "\xE9": "e",
      "\xEA": "e",
      "\xEB": "e",
      "\xCC": "I",
      "\xCD": "I",
      "\xCE": "I",
      "\xCF": "I",
      "\xEC": "i",
      "\xED": "i",
      "\xEE": "i",
      "\xEF": "i",
      "\xD1": "N",
      "\xF1": "n",
      "\xD2": "O",
      "\xD3": "O",
      "\xD4": "O",
      "\xD5": "O",
      "\xD6": "O",
      "\xD8": "O",
      "\xF2": "o",
      "\xF3": "o",
      "\xF4": "o",
      "\xF5": "o",
      "\xF6": "o",
      "\xF8": "o",
      "\xD9": "U",
      "\xDA": "U",
      "\xDB": "U",
      "\xDC": "U",
      "\xF9": "u",
      "\xFA": "u",
      "\xFB": "u",
      "\xFC": "u",
      "\xDD": "Y",
      "\xFD": "y",
      "\xFF": "y",
      "\xC6": "Ae",
      "\xE6": "ae",
      "\xDE": "Th",
      "\xFE": "th",
      "\xDF": "ss",
      "\u0100": "A",
      "\u0102": "A",
      "\u0104": "A",
      "\u0101": "a",
      "\u0103": "a",
      "\u0105": "a",
      "\u0106": "C",
      "\u0108": "C",
      "\u010A": "C",
      "\u010C": "C",
      "\u0107": "c",
      "\u0109": "c",
      "\u010B": "c",
      "\u010D": "c",
      "\u010E": "D",
      "\u0110": "D",
      "\u010F": "d",
      "\u0111": "d",
      "\u0112": "E",
      "\u0114": "E",
      "\u0116": "E",
      "\u0118": "E",
      "\u011A": "E",
      "\u0113": "e",
      "\u0115": "e",
      "\u0117": "e",
      "\u0119": "e",
      "\u011B": "e",
      "\u011C": "G",
      "\u011E": "G",
      "\u0120": "G",
      "\u0122": "G",
      "\u011D": "g",
      "\u011F": "g",
      "\u0121": "g",
      "\u0123": "g",
      "\u0124": "H",
      "\u0126": "H",
      "\u0125": "h",
      "\u0127": "h",
      "\u0128": "I",
      "\u012A": "I",
      "\u012C": "I",
      "\u012E": "I",
      "\u0130": "I",
      "\u0129": "i",
      "\u012B": "i",
      "\u012D": "i",
      "\u012F": "i",
      "\u0131": "i",
      "\u0134": "J",
      "\u0135": "j",
      "\u0136": "K",
      "\u0137": "k",
      "\u0138": "k",
      "\u0139": "L",
      "\u013B": "L",
      "\u013D": "L",
      "\u013F": "L",
      "\u0141": "L",
      "\u013A": "l",
      "\u013C": "l",
      "\u013E": "l",
      "\u0140": "l",
      "\u0142": "l",
      "\u0143": "N",
      "\u0145": "N",
      "\u0147": "N",
      "\u014A": "N",
      "\u0144": "n",
      "\u0146": "n",
      "\u0148": "n",
      "\u014B": "n",
      "\u014C": "O",
      "\u014E": "O",
      "\u0150": "O",
      "\u014D": "o",
      "\u014F": "o",
      "\u0151": "o",
      "\u0154": "R",
      "\u0156": "R",
      "\u0158": "R",
      "\u0155": "r",
      "\u0157": "r",
      "\u0159": "r",
      "\u015A": "S",
      "\u015C": "S",
      "\u015E": "S",
      "\u0160": "S",
      "\u015B": "s",
      "\u015D": "s",
      "\u015F": "s",
      "\u0161": "s",
      "\u0162": "T",
      "\u0164": "T",
      "\u0166": "T",
      "\u0163": "t",
      "\u0165": "t",
      "\u0167": "t",
      "\u0168": "U",
      "\u016A": "U",
      "\u016C": "U",
      "\u016E": "U",
      "\u0170": "U",
      "\u0172": "U",
      "\u0169": "u",
      "\u016B": "u",
      "\u016D": "u",
      "\u016F": "u",
      "\u0171": "u",
      "\u0173": "u",
      "\u0174": "W",
      "\u0175": "w",
      "\u0176": "Y",
      "\u0177": "y",
      "\u0178": "Y",
      "\u0179": "Z",
      "\u017B": "Z",
      "\u017D": "Z",
      "\u017A": "z",
      "\u017C": "z",
      "\u017E": "z",
      "\u0132": "IJ",
      "\u0133": "ij",
      "\u0152": "Oe",
      "\u0153": "oe",
      "\u0149": "'n",
      "\u017F": "s"
    };
    var htmlEscapes = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    };
    var htmlUnescapes = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    };
    var stringEscapes = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    };
    var freeParseFloat = parseFloat, freeParseInt2 = parseInt;
    var freeGlobal2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule = freeExports && true && module && !module.nodeType && module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal2.process;
    var nodeUtil = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayAggregator(array4, setter, iteratee, accumulator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        var value = array4[index2];
        setter(accumulator, value, iteratee(value), array4);
      }
      return accumulator;
    }
    function arrayEach(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (iteratee(array4[index2], index2, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEachRight(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      while (length--) {
        if (iteratee(array4[length], length, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEvery(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (!predicate(array4[index2], index2, array4)) {
          return false;
        }
      }
      return true;
    }
    function arrayFilter(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (predicate(value, index2, array4)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayIncludes(array4, value) {
      var length = array4 == null ? 0 : array4.length;
      return !!length && baseIndexOf(array4, value, 0) > -1;
    }
    function arrayIncludesWith(array4, value, comparator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (comparator(value, array4[index2])) {
          return true;
        }
      }
      return false;
    }
    function arrayMap(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, result = Array(length);
      while (++index2 < length) {
        result[index2] = iteratee(array4[index2], index2, array4);
      }
      return result;
    }
    function arrayPush(array4, values) {
      var index2 = -1, length = values.length, offset = array4.length;
      while (++index2 < length) {
        array4[offset + index2] = values[index2];
      }
      return array4;
    }
    function arrayReduce(array4, iteratee, accumulator, initAccum) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[++index2];
      }
      while (++index2 < length) {
        accumulator = iteratee(accumulator, array4[index2], index2, array4);
      }
      return accumulator;
    }
    function arrayReduceRight(array4, iteratee, accumulator, initAccum) {
      var length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[--length];
      }
      while (length--) {
        accumulator = iteratee(accumulator, array4[length], length, array4);
      }
      return accumulator;
    }
    function arraySome(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return true;
        }
      }
      return false;
    }
    var asciiSize = baseProperty("length");
    function asciiToArray(string3) {
      return string3.split("");
    }
    function asciiWords(string3) {
      return string3.match(reAsciiWord) || [];
    }
    function baseFindKey(collection, predicate, eachFunc) {
      var result;
      eachFunc(collection, function(value, key, collection2) {
        if (predicate(value, key, collection2)) {
          result = key;
          return false;
        }
      });
      return result;
    }
    function baseFindIndex(array4, predicate, fromIndex, fromRight) {
      var length = array4.length, index2 = fromIndex + (fromRight ? 1 : -1);
      while (fromRight ? index2-- : ++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIndexOf(array4, value, fromIndex) {
      return value === value ? strictIndexOf(array4, value, fromIndex) : baseFindIndex(array4, baseIsNaN, fromIndex);
    }
    function baseIndexOfWith(array4, value, fromIndex, comparator) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (comparator(array4[index2], value)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseMean(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      return length ? baseSum(array4, iteratee) / length : NAN2;
    }
    function baseProperty(key) {
      return function(object4) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function basePropertyOf(object4) {
      return function(key) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
      eachFunc(collection, function(value, index2, collection2) {
        accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index2, collection2);
      });
      return accumulator;
    }
    function baseSortBy(array4, comparer) {
      var length = array4.length;
      array4.sort(comparer);
      while (length--) {
        array4[length] = array4[length].value;
      }
      return array4;
    }
    function baseSum(array4, iteratee) {
      var result, index2 = -1, length = array4.length;
      while (++index2 < length) {
        var current = iteratee(array4[index2]);
        if (current !== undefined$1) {
          result = result === undefined$1 ? current : result + current;
        }
      }
      return result;
    }
    function baseTimes(n2, iteratee) {
      var index2 = -1, result = Array(n2);
      while (++index2 < n2) {
        result[index2] = iteratee(index2);
      }
      return result;
    }
    function baseToPairs(object4, props) {
      return arrayMap(props, function(key) {
        return [key, object4[key]];
      });
    }
    function baseTrim2(string3) {
      return string3 ? string3.slice(0, trimmedEndIndex2(string3) + 1).replace(reTrimStart2, "") : string3;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function baseValues(object4, props) {
      return arrayMap(props, function(key) {
        return object4[key];
      });
    }
    function cacheHas(cache, key) {
      return cache.has(key);
    }
    function charsStartIndex(strSymbols, chrSymbols) {
      var index2 = -1, length = strSymbols.length;
      while (++index2 < length && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function charsEndIndex(strSymbols, chrSymbols) {
      var index2 = strSymbols.length;
      while (index2-- && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function countHolders(array4, placeholder) {
      var length = array4.length, result = 0;
      while (length--) {
        if (array4[length] === placeholder) {
          ++result;
        }
      }
      return result;
    }
    var deburrLetter = basePropertyOf(deburredLetters);
    var escapeHtmlChar = basePropertyOf(htmlEscapes);
    function escapeStringChar(chr) {
      return "\\" + stringEscapes[chr];
    }
    function getValue2(object4, key) {
      return object4 == null ? undefined$1 : object4[key];
    }
    function hasUnicode(string3) {
      return reHasUnicode.test(string3);
    }
    function hasUnicodeWord(string3) {
      return reHasUnicodeWord.test(string3);
    }
    function iteratorToArray(iterator2) {
      var data, result = [];
      while (!(data = iterator2.next()).done) {
        result.push(data.value);
      }
      return result;
    }
    function mapToArray(map2) {
      var index2 = -1, result = Array(map2.size);
      map2.forEach(function(value, key) {
        result[++index2] = [key, value];
      });
      return result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function replaceHolders(array4, placeholder) {
      var index2 = -1, length = array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (value === placeholder || value === PLACEHOLDER) {
          array4[index2] = PLACEHOLDER;
          result[resIndex++] = index2;
        }
      }
      return result;
    }
    function setToArray(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = value;
      });
      return result;
    }
    function setToPairs(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = [value, value];
      });
      return result;
    }
    function strictIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return -1;
    }
    function strictLastIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex + 1;
      while (index2--) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return index2;
    }
    function stringSize(string3) {
      return hasUnicode(string3) ? unicodeSize(string3) : asciiSize(string3);
    }
    function stringToArray(string3) {
      return hasUnicode(string3) ? unicodeToArray(string3) : asciiToArray(string3);
    }
    function trimmedEndIndex2(string3) {
      var index2 = string3.length;
      while (index2-- && reWhitespace2.test(string3.charAt(index2))) {
      }
      return index2;
    }
    var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
    function unicodeSize(string3) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string3)) {
        ++result;
      }
      return result;
    }
    function unicodeToArray(string3) {
      return string3.match(reUnicode) || [];
    }
    function unicodeWords(string3) {
      return string3.match(reUnicodeWord) || [];
    }
    var runInContext = function runInContext2(context) {
      context = context == null ? root2 : _.defaults(root2.Object(), context, _.pick(root2, contextProps));
      var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
      var arrayProto2 = Array2.prototype, funcProto = Function2.prototype, objectProto2 = Object2.prototype;
      var coreJsData = context["__core-js_shared__"];
      var funcToString = funcProto.toString;
      var hasOwnProperty2 = objectProto2.hasOwnProperty;
      var idCounter = 0;
      var maskSrcKey = function() {
        var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
        return uid ? "Symbol(src)_1." + uid : "";
      }();
      var nativeObjectToString2 = objectProto2.toString;
      var objectCtorString = funcToString.call(Object2);
      var oldDash = root2._;
      var reIsNative = RegExp2("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
      var Buffer2 = moduleExports ? context.Buffer : undefined$1, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined$1, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto2.propertyIsEnumerable, splice = arrayProto2.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined$1, symIterator = Symbol2 ? Symbol2.iterator : undefined$1, symToStringTag2 = Symbol2 ? Symbol2.toStringTag : undefined$1;
      var defineProperty = function() {
        try {
          var func = getNative(Object2, "defineProperty");
          func({}, "", {});
          return func;
        } catch (e2) {
        }
      }();
      var ctxClearTimeout = context.clearTimeout !== root2.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root2.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root2.setTimeout && context.setTimeout;
      var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined$1, nativeIsFinite = context.isFinite, nativeJoin = arrayProto2.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax2 = Math2.max, nativeMin2 = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto2.reverse;
      var DataView2 = getNative(context, "DataView"), Map2 = getNative(context, "Map"), Promise2 = getNative(context, "Promise"), Set2 = getNative(context, "Set"), WeakMap3 = getNative(context, "WeakMap"), nativeCreate = getNative(Object2, "create");
      var metaMap = WeakMap3 && new WeakMap3();
      var realNames = {};
      var dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap3);
      var symbolProto = Symbol2 ? Symbol2.prototype : undefined$1, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined$1, symbolToString = symbolProto ? symbolProto.toString : undefined$1;
      function lodash2(value) {
        if (isObjectLike2(value) && !isArray2(value) && !(value instanceof LazyWrapper)) {
          if (value instanceof LodashWrapper) {
            return value;
          }
          if (hasOwnProperty2.call(value, "__wrapped__")) {
            return wrapperClone(value);
          }
        }
        return new LodashWrapper(value);
      }
      var baseCreate = function() {
        function object4() {
        }
        return function(proto2) {
          if (!isObject2(proto2)) {
            return {};
          }
          if (objectCreate) {
            return objectCreate(proto2);
          }
          object4.prototype = proto2;
          var result2 = new object4();
          object4.prototype = undefined$1;
          return result2;
        };
      }();
      function baseLodash() {
      }
      function LodashWrapper(value, chainAll) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__chain__ = !!chainAll;
        this.__index__ = 0;
        this.__values__ = undefined$1;
      }
      lodash2.templateSettings = {
        "escape": reEscape,
        "evaluate": reEvaluate,
        "interpolate": reInterpolate,
        "variable": "",
        "imports": {
          "_": lodash2
        }
      };
      lodash2.prototype = baseLodash.prototype;
      lodash2.prototype.constructor = lodash2;
      LodashWrapper.prototype = baseCreate(baseLodash.prototype);
      LodashWrapper.prototype.constructor = LodashWrapper;
      function LazyWrapper(value) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__dir__ = 1;
        this.__filtered__ = false;
        this.__iteratees__ = [];
        this.__takeCount__ = MAX_ARRAY_LENGTH;
        this.__views__ = [];
      }
      function lazyClone() {
        var result2 = new LazyWrapper(this.__wrapped__);
        result2.__actions__ = copyArray(this.__actions__);
        result2.__dir__ = this.__dir__;
        result2.__filtered__ = this.__filtered__;
        result2.__iteratees__ = copyArray(this.__iteratees__);
        result2.__takeCount__ = this.__takeCount__;
        result2.__views__ = copyArray(this.__views__);
        return result2;
      }
      function lazyReverse() {
        if (this.__filtered__) {
          var result2 = new LazyWrapper(this);
          result2.__dir__ = -1;
          result2.__filtered__ = true;
        } else {
          result2 = this.clone();
          result2.__dir__ *= -1;
        }
        return result2;
      }
      function lazyValue() {
        var array4 = this.__wrapped__.value(), dir3 = this.__dir__, isArr = isArray2(array4), isRight = dir3 < 0, arrLength = isArr ? array4.length : 0, view = getView(0, arrLength, this.__views__), start2 = view.start, end2 = view.end, length = end2 - start2, index2 = isRight ? end2 : start2 - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin2(length, this.__takeCount__);
        if (!isArr || !isRight && arrLength == length && takeCount == length) {
          return baseWrapperValue(array4, this.__actions__);
        }
        var result2 = [];
        outer:
          while (length-- && resIndex < takeCount) {
            index2 += dir3;
            var iterIndex = -1, value = array4[index2];
            while (++iterIndex < iterLength) {
              var data = iteratees[iterIndex], iteratee2 = data.iteratee, type4 = data.type, computed = iteratee2(value);
              if (type4 == LAZY_MAP_FLAG) {
                value = computed;
              } else if (!computed) {
                if (type4 == LAZY_FILTER_FLAG) {
                  continue outer;
                } else {
                  break outer;
                }
              }
            }
            result2[resIndex++] = value;
          }
        return result2;
      }
      LazyWrapper.prototype = baseCreate(baseLodash.prototype);
      LazyWrapper.prototype.constructor = LazyWrapper;
      function Hash(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear() {
        this.__data__ = nativeCreate ? nativeCreate(null) : {};
        this.size = 0;
      }
      function hashDelete(key) {
        var result2 = this.has(key) && delete this.__data__[key];
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function hashGet(key) {
        var data = this.__data__;
        if (nativeCreate) {
          var result2 = data[key];
          return result2 === HASH_UNDEFINED ? undefined$1 : result2;
        }
        return hasOwnProperty2.call(data, key) ? data[key] : undefined$1;
      }
      function hashHas(key) {
        var data = this.__data__;
        return nativeCreate ? data[key] !== undefined$1 : hasOwnProperty2.call(data, key);
      }
      function hashSet(key, value) {
        var data = this.__data__;
        this.size += this.has(key) ? 0 : 1;
        data[key] = nativeCreate && value === undefined$1 ? HASH_UNDEFINED : value;
        return this;
      }
      Hash.prototype.clear = hashClear;
      Hash.prototype["delete"] = hashDelete;
      Hash.prototype.get = hashGet;
      Hash.prototype.has = hashHas;
      Hash.prototype.set = hashSet;
      function ListCache(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear() {
        this.__data__ = [];
        this.size = 0;
      }
      function listCacheDelete(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          return false;
        }
        var lastIndex = data.length - 1;
        if (index2 == lastIndex) {
          data.pop();
        } else {
          splice.call(data, index2, 1);
        }
        --this.size;
        return true;
      }
      function listCacheGet2(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        return index2 < 0 ? undefined$1 : data[index2][1];
      }
      function listCacheHas(key) {
        return assocIndexOf(this.__data__, key) > -1;
      }
      function listCacheSet2(key, value) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          ++this.size;
          data.push([key, value]);
        } else {
          data[index2][1] = value;
        }
        return this;
      }
      ListCache.prototype.clear = listCacheClear;
      ListCache.prototype["delete"] = listCacheDelete;
      ListCache.prototype.get = listCacheGet2;
      ListCache.prototype.has = listCacheHas;
      ListCache.prototype.set = listCacheSet2;
      function MapCache(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear() {
        this.size = 0;
        this.__data__ = {
          "hash": new Hash(),
          "map": new (Map2 || ListCache)(),
          "string": new Hash()
        };
      }
      function mapCacheDelete(key) {
        var result2 = getMapData(this, key)["delete"](key);
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function mapCacheGet(key) {
        return getMapData(this, key).get(key);
      }
      function mapCacheHas(key) {
        return getMapData(this, key).has(key);
      }
      function mapCacheSet(key, value) {
        var data = getMapData(this, key), size2 = data.size;
        data.set(key, value);
        this.size += data.size == size2 ? 0 : 1;
        return this;
      }
      MapCache.prototype.clear = mapCacheClear;
      MapCache.prototype["delete"] = mapCacheDelete;
      MapCache.prototype.get = mapCacheGet;
      MapCache.prototype.has = mapCacheHas;
      MapCache.prototype.set = mapCacheSet;
      function SetCache(values2) {
        var index2 = -1, length = values2 == null ? 0 : values2.length;
        this.__data__ = new MapCache();
        while (++index2 < length) {
          this.add(values2[index2]);
        }
      }
      function setCacheAdd(value) {
        this.__data__.set(value, HASH_UNDEFINED);
        return this;
      }
      function setCacheHas(value) {
        return this.__data__.has(value);
      }
      SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
      SetCache.prototype.has = setCacheHas;
      function Stack(entries) {
        var data = this.__data__ = new ListCache(entries);
        this.size = data.size;
      }
      function stackClear() {
        this.__data__ = new ListCache();
        this.size = 0;
      }
      function stackDelete(key) {
        var data = this.__data__, result2 = data["delete"](key);
        this.size = data.size;
        return result2;
      }
      function stackGet(key) {
        return this.__data__.get(key);
      }
      function stackHas(key) {
        return this.__data__.has(key);
      }
      function stackSet(key, value) {
        var data = this.__data__;
        if (data instanceof ListCache) {
          var pairs = data.__data__;
          if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
          }
          data = this.__data__ = new MapCache(pairs);
        }
        data.set(key, value);
        this.size = data.size;
        return this;
      }
      Stack.prototype.clear = stackClear;
      Stack.prototype["delete"] = stackDelete;
      Stack.prototype.get = stackGet;
      Stack.prototype.has = stackHas;
      Stack.prototype.set = stackSet;
      function arrayLikeKeys(value, inherited) {
        var isArr = isArray2(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String2) : [], length = result2.length;
        for (var key in value) {
          if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function arraySample(array4) {
        var length = array4.length;
        return length ? array4[baseRandom(0, length - 1)] : undefined$1;
      }
      function arraySampleSize(array4, n2) {
        return shuffleSelf(copyArray(array4), baseClamp(n2, 0, array4.length));
      }
      function arrayShuffle(array4) {
        return shuffleSelf(copyArray(array4));
      }
      function assignMergeValue(object4, key, value) {
        if (value !== undefined$1 && !eq(object4[key], value) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assignValue(object4, key, value) {
        var objValue = object4[key];
        if (!(hasOwnProperty2.call(object4, key) && eq(objValue, value)) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assocIndexOf(array4, key) {
        var length = array4.length;
        while (length--) {
          if (eq(array4[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAggregator(collection, setter, iteratee2, accumulator) {
        baseEach(collection, function(value, key, collection2) {
          setter(accumulator, value, iteratee2(value), collection2);
        });
        return accumulator;
      }
      function baseAssign(object4, source) {
        return object4 && copyObject(source, keys2(source), object4);
      }
      function baseAssignIn(object4, source) {
        return object4 && copyObject(source, keysIn(source), object4);
      }
      function baseAssignValue(object4, key, value) {
        if (key == "__proto__" && defineProperty) {
          defineProperty(object4, key, {
            "configurable": true,
            "enumerable": true,
            "value": value,
            "writable": true
          });
        } else {
          object4[key] = value;
        }
      }
      function baseAt(object4, paths) {
        var index2 = -1, length = paths.length, result2 = Array2(length), skip = object4 == null;
        while (++index2 < length) {
          result2[index2] = skip ? undefined$1 : get2(object4, paths[index2]);
        }
        return result2;
      }
      function baseClamp(number4, lower, upper) {
        if (number4 === number4) {
          if (upper !== undefined$1) {
            number4 = number4 <= upper ? number4 : upper;
          }
          if (lower !== undefined$1) {
            number4 = number4 >= lower ? number4 : lower;
          }
        }
        return number4;
      }
      function baseClone(value, bitmask, customizer, key, object4, stack) {
        var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
        if (customizer) {
          result2 = object4 ? customizer(value, key, object4, stack) : customizer(value);
        }
        if (result2 !== undefined$1) {
          return result2;
        }
        if (!isObject2(value)) {
          return value;
        }
        var isArr = isArray2(value);
        if (isArr) {
          result2 = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result2);
          }
        } else {
          var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
          if (isBuffer(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag || tag == argsTag || isFunc && !object4) {
            result2 = isFlat || isFunc ? {} : initCloneObject(value);
            if (!isDeep) {
              return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object4 ? value : {};
            }
            result2 = initCloneByTag(value, tag, isDeep);
          }
        }
        stack || (stack = new Stack());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result2);
        if (isSet(value)) {
          value.forEach(function(subValue) {
            result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
          });
        } else if (isMap(value)) {
          value.forEach(function(subValue, key2) {
            result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
        }
        var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys2;
        var props = isArr ? undefined$1 : keysFunc(value);
        arrayEach(props || value, function(subValue, key2) {
          if (props) {
            key2 = subValue;
            subValue = value[key2];
          }
          assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
        });
        return result2;
      }
      function baseConforms(source) {
        var props = keys2(source);
        return function(object4) {
          return baseConformsTo(object4, source, props);
        };
      }
      function baseConformsTo(object4, source, props) {
        var length = props.length;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (length--) {
          var key = props[length], predicate = source[key], value = object4[key];
          if (value === undefined$1 && !(key in object4) || !predicate(value)) {
            return false;
          }
        }
        return true;
      }
      function baseDelay(func, wait, args) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return setTimeout2(function() {
          func.apply(undefined$1, args);
        }, wait);
      }
      function baseDifference(array4, values2, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, isCommon = true, length = array4.length, result2 = [], valuesLength = values2.length;
        if (!length) {
          return result2;
        }
        if (iteratee2) {
          values2 = arrayMap(values2, baseUnary(iteratee2));
        }
        if (comparator) {
          includes2 = arrayIncludesWith;
          isCommon = false;
        } else if (values2.length >= LARGE_ARRAY_SIZE) {
          includes2 = cacheHas;
          isCommon = false;
          values2 = new SetCache(values2);
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 == null ? value : iteratee2(value);
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var valuesIndex = valuesLength;
              while (valuesIndex--) {
                if (values2[valuesIndex] === computed) {
                  continue outer;
                }
              }
              result2.push(value);
            } else if (!includes2(values2, computed, comparator)) {
              result2.push(value);
            }
          }
        return result2;
      }
      var baseEach = createBaseEach(baseForOwn);
      var baseEachRight = createBaseEach(baseForOwnRight, true);
      function baseEvery(collection, predicate) {
        var result2 = true;
        baseEach(collection, function(value, index2, collection2) {
          result2 = !!predicate(value, index2, collection2);
          return result2;
        });
        return result2;
      }
      function baseExtremum(array4, iteratee2, comparator) {
        var index2 = -1, length = array4.length;
        while (++index2 < length) {
          var value = array4[index2], current = iteratee2(value);
          if (current != null && (computed === undefined$1 ? current === current && !isSymbol2(current) : comparator(current, computed))) {
            var computed = current, result2 = value;
          }
        }
        return result2;
      }
      function baseFill(array4, value, start2, end2) {
        var length = array4.length;
        start2 = toInteger(start2);
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 === undefined$1 || end2 > length ? length : toInteger(end2);
        if (end2 < 0) {
          end2 += length;
        }
        end2 = start2 > end2 ? 0 : toLength(end2);
        while (start2 < end2) {
          array4[start2++] = value;
        }
        return array4;
      }
      function baseFilter(collection, predicate) {
        var result2 = [];
        baseEach(collection, function(value, index2, collection2) {
          if (predicate(value, index2, collection2)) {
            result2.push(value);
          }
        });
        return result2;
      }
      function baseFlatten(array4, depth, predicate, isStrict, result2) {
        var index2 = -1, length = array4.length;
        predicate || (predicate = isFlattenable);
        result2 || (result2 = []);
        while (++index2 < length) {
          var value = array4[index2];
          if (depth > 0 && predicate(value)) {
            if (depth > 1) {
              baseFlatten(value, depth - 1, predicate, isStrict, result2);
            } else {
              arrayPush(result2, value);
            }
          } else if (!isStrict) {
            result2[result2.length] = value;
          }
        }
        return result2;
      }
      var baseFor = createBaseFor();
      var baseForRight = createBaseFor(true);
      function baseForOwn(object4, iteratee2) {
        return object4 && baseFor(object4, iteratee2, keys2);
      }
      function baseForOwnRight(object4, iteratee2) {
        return object4 && baseForRight(object4, iteratee2, keys2);
      }
      function baseFunctions(object4, props) {
        return arrayFilter(props, function(key) {
          return isFunction2(object4[key]);
        });
      }
      function baseGet(object4, path) {
        path = castPath(path, object4);
        var index2 = 0, length = path.length;
        while (object4 != null && index2 < length) {
          object4 = object4[toKey(path[index2++])];
        }
        return index2 && index2 == length ? object4 : undefined$1;
      }
      function baseGetAllKeys(object4, keysFunc, symbolsFunc) {
        var result2 = keysFunc(object4);
        return isArray2(object4) ? result2 : arrayPush(result2, symbolsFunc(object4));
      }
      function baseGetTag2(value) {
        if (value == null) {
          return value === undefined$1 ? undefinedTag2 : nullTag2;
        }
        return symToStringTag2 && symToStringTag2 in Object2(value) ? getRawTag2(value) : objectToString2(value);
      }
      function baseGt(value, other) {
        return value > other;
      }
      function baseHas(object4, key) {
        return object4 != null && hasOwnProperty2.call(object4, key);
      }
      function baseHasIn(object4, key) {
        return object4 != null && key in Object2(object4);
      }
      function baseInRange(number4, start2, end2) {
        return number4 >= nativeMin2(start2, end2) && number4 < nativeMax2(start2, end2);
      }
      function baseIntersection(arrays, iteratee2, comparator) {
        var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
        while (othIndex--) {
          var array4 = arrays[othIndex];
          if (othIndex && iteratee2) {
            array4 = arrayMap(array4, baseUnary(iteratee2));
          }
          maxLength = nativeMin2(array4.length, maxLength);
          caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array4.length >= 120) ? new SetCache(othIndex && array4) : undefined$1;
        }
        array4 = arrays[0];
        var index2 = -1, seen = caches[0];
        outer:
          while (++index2 < length && result2.length < maxLength) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (!(seen ? cacheHas(seen, computed) : includes2(result2, computed, comparator))) {
              othIndex = othLength;
              while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                  continue outer;
                }
              }
              if (seen) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseInverter(object4, setter, iteratee2, accumulator) {
        baseForOwn(object4, function(value, key, object5) {
          setter(accumulator, iteratee2(value), key, object5);
        });
        return accumulator;
      }
      function baseInvoke(object4, path, args) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        var func = object4 == null ? object4 : object4[toKey(last(path))];
        return func == null ? undefined$1 : apply(func, object4, args);
      }
      function baseIsArguments(value) {
        return isObjectLike2(value) && baseGetTag2(value) == argsTag;
      }
      function baseIsArrayBuffer(value) {
        return isObjectLike2(value) && baseGetTag2(value) == arrayBufferTag;
      }
      function baseIsDate(value) {
        return isObjectLike2(value) && baseGetTag2(value) == dateTag;
      }
      function baseIsEqual(value, other, bitmask, customizer, stack) {
        if (value === other) {
          return true;
        }
        if (value == null || other == null || !isObjectLike2(value) && !isObjectLike2(other)) {
          return value !== value && other !== other;
        }
        return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
      }
      function baseIsEqualDeep(object4, other, bitmask, customizer, equalFunc, stack) {
        var objIsArr = isArray2(object4), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag : getTag(object4), othTag = othIsArr ? arrayTag : getTag(other);
        objTag = objTag == argsTag ? objectTag : objTag;
        othTag = othTag == argsTag ? objectTag : othTag;
        var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
        if (isSameTag && isBuffer(object4)) {
          if (!isBuffer(other)) {
            return false;
          }
          objIsArr = true;
          objIsObj = false;
        }
        if (isSameTag && !objIsObj) {
          stack || (stack = new Stack());
          return objIsArr || isTypedArray2(object4) ? equalArrays(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag(object4, other, objTag, bitmask, customizer, equalFunc, stack);
        }
        if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
          var objIsWrapped = objIsObj && hasOwnProperty2.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
          if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
          }
        }
        if (!isSameTag) {
          return false;
        }
        stack || (stack = new Stack());
        return equalObjects(object4, other, bitmask, customizer, equalFunc, stack);
      }
      function baseIsMap(value) {
        return isObjectLike2(value) && getTag(value) == mapTag;
      }
      function baseIsMatch(object4, source, matchData, customizer) {
        var index2 = matchData.length, length = index2, noCustomizer = !customizer;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (index2--) {
          var data = matchData[index2];
          if (noCustomizer && data[2] ? data[1] !== object4[data[0]] : !(data[0] in object4)) {
            return false;
          }
        }
        while (++index2 < length) {
          data = matchData[index2];
          var key = data[0], objValue = object4[key], srcValue = data[1];
          if (noCustomizer && data[2]) {
            if (objValue === undefined$1 && !(key in object4)) {
              return false;
            }
          } else {
            var stack = new Stack();
            if (customizer) {
              var result2 = customizer(objValue, srcValue, key, object4, source, stack);
            }
            if (!(result2 === undefined$1 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result2)) {
              return false;
            }
          }
        }
        return true;
      }
      function baseIsNative(value) {
        if (!isObject2(value) || isMasked(value)) {
          return false;
        }
        var pattern4 = isFunction2(value) ? reIsNative : reIsHostCtor;
        return pattern4.test(toSource(value));
      }
      function baseIsRegExp(value) {
        return isObjectLike2(value) && baseGetTag2(value) == regexpTag;
      }
      function baseIsSet(value) {
        return isObjectLike2(value) && getTag(value) == setTag;
      }
      function baseIsTypedArray(value) {
        return isObjectLike2(value) && isLength(value.length) && !!typedArrayTags[baseGetTag2(value)];
      }
      function baseIteratee(value) {
        if (typeof value == "function") {
          return value;
        }
        if (value == null) {
          return identity2;
        }
        if (typeof value == "object") {
          return isArray2(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
        }
        return property(value);
      }
      function baseKeys(object4) {
        if (!isPrototype(object4)) {
          return nativeKeys(object4);
        }
        var result2 = [];
        for (var key in Object2(object4)) {
          if (hasOwnProperty2.call(object4, key) && key != "constructor") {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseKeysIn(object4) {
        if (!isObject2(object4)) {
          return nativeKeysIn(object4);
        }
        var isProto = isPrototype(object4), result2 = [];
        for (var key in object4) {
          if (!(key == "constructor" && (isProto || !hasOwnProperty2.call(object4, key)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseLt(value, other) {
        return value < other;
      }
      function baseMap(collection, iteratee2) {
        var index2 = -1, result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value, key, collection2) {
          result2[++index2] = iteratee2(value, key, collection2);
        });
        return result2;
      }
      function baseMatches(source) {
        var matchData = getMatchData(source);
        if (matchData.length == 1 && matchData[0][2]) {
          return matchesStrictComparable(matchData[0][0], matchData[0][1]);
        }
        return function(object4) {
          return object4 === source || baseIsMatch(object4, source, matchData);
        };
      }
      function baseMatchesProperty(path, srcValue) {
        if (isKey(path) && isStrictComparable(srcValue)) {
          return matchesStrictComparable(toKey(path), srcValue);
        }
        return function(object4) {
          var objValue = get2(object4, path);
          return objValue === undefined$1 && objValue === srcValue ? hasIn(object4, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
        };
      }
      function baseMerge(object4, source, srcIndex, customizer, stack) {
        if (object4 === source) {
          return;
        }
        baseFor(source, function(srcValue, key) {
          stack || (stack = new Stack());
          if (isObject2(srcValue)) {
            baseMergeDeep(object4, source, key, srcIndex, baseMerge, customizer, stack);
          } else {
            var newValue = customizer ? customizer(safeGet(object4, key), srcValue, key + "", object4, source, stack) : undefined$1;
            if (newValue === undefined$1) {
              newValue = srcValue;
            }
            assignMergeValue(object4, key, newValue);
          }
        }, keysIn);
      }
      function baseMergeDeep(object4, source, key, srcIndex, mergeFunc, customizer, stack) {
        var objValue = safeGet(object4, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
        if (stacked) {
          assignMergeValue(object4, key, stacked);
          return;
        }
        var newValue = customizer ? customizer(objValue, srcValue, key + "", object4, source, stack) : undefined$1;
        var isCommon = newValue === undefined$1;
        if (isCommon) {
          var isArr = isArray2(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray2(srcValue);
          newValue = srcValue;
          if (isArr || isBuff || isTyped) {
            if (isArray2(objValue)) {
              newValue = objValue;
            } else if (isArrayLikeObject(objValue)) {
              newValue = copyArray(objValue);
            } else if (isBuff) {
              isCommon = false;
              newValue = cloneBuffer(srcValue, true);
            } else if (isTyped) {
              isCommon = false;
              newValue = cloneTypedArray(srcValue, true);
            } else {
              newValue = [];
            }
          } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
            newValue = objValue;
            if (isArguments(objValue)) {
              newValue = toPlainObject(objValue);
            } else if (!isObject2(objValue) || isFunction2(objValue)) {
              newValue = initCloneObject(srcValue);
            }
          } else {
            isCommon = false;
          }
        }
        if (isCommon) {
          stack.set(srcValue, newValue);
          mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
          stack["delete"](srcValue);
        }
        assignMergeValue(object4, key, newValue);
      }
      function baseNth(array4, n2) {
        var length = array4.length;
        if (!length) {
          return;
        }
        n2 += n2 < 0 ? length : 0;
        return isIndex(n2, length) ? array4[n2] : undefined$1;
      }
      function baseOrderBy(collection, iteratees, orders) {
        if (iteratees.length) {
          iteratees = arrayMap(iteratees, function(iteratee2) {
            if (isArray2(iteratee2)) {
              return function(value) {
                return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
              };
            }
            return iteratee2;
          });
        } else {
          iteratees = [identity2];
        }
        var index2 = -1;
        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
        var result2 = baseMap(collection, function(value, key, collection2) {
          var criteria = arrayMap(iteratees, function(iteratee2) {
            return iteratee2(value);
          });
          return { "criteria": criteria, "index": ++index2, "value": value };
        });
        return baseSortBy(result2, function(object4, other) {
          return compareMultiple(object4, other, orders);
        });
      }
      function basePick(object4, paths) {
        return basePickBy(object4, paths, function(value, path) {
          return hasIn(object4, path);
        });
      }
      function basePickBy(object4, paths, predicate) {
        var index2 = -1, length = paths.length, result2 = {};
        while (++index2 < length) {
          var path = paths[index2], value = baseGet(object4, path);
          if (predicate(value, path)) {
            baseSet(result2, castPath(path, object4), value);
          }
        }
        return result2;
      }
      function basePropertyDeep(path) {
        return function(object4) {
          return baseGet(object4, path);
        };
      }
      function basePullAll(array4, values2, iteratee2, comparator) {
        var indexOf3 = comparator ? baseIndexOfWith : baseIndexOf, index2 = -1, length = values2.length, seen = array4;
        if (array4 === values2) {
          values2 = copyArray(values2);
        }
        if (iteratee2) {
          seen = arrayMap(array4, baseUnary(iteratee2));
        }
        while (++index2 < length) {
          var fromIndex = 0, value = values2[index2], computed = iteratee2 ? iteratee2(value) : value;
          while ((fromIndex = indexOf3(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array4) {
              splice.call(seen, fromIndex, 1);
            }
            splice.call(array4, fromIndex, 1);
          }
        }
        return array4;
      }
      function basePullAt(array4, indexes) {
        var length = array4 ? indexes.length : 0, lastIndex = length - 1;
        while (length--) {
          var index2 = indexes[length];
          if (length == lastIndex || index2 !== previous) {
            var previous = index2;
            if (isIndex(index2)) {
              splice.call(array4, index2, 1);
            } else {
              baseUnset(array4, index2);
            }
          }
        }
        return array4;
      }
      function baseRandom(lower, upper) {
        return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
      }
      function baseRange(start2, end2, step, fromRight) {
        var index2 = -1, length = nativeMax2(nativeCeil((end2 - start2) / (step || 1)), 0), result2 = Array2(length);
        while (length--) {
          result2[fromRight ? length : ++index2] = start2;
          start2 += step;
        }
        return result2;
      }
      function baseRepeat(string3, n2) {
        var result2 = "";
        if (!string3 || n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return result2;
        }
        do {
          if (n2 % 2) {
            result2 += string3;
          }
          n2 = nativeFloor(n2 / 2);
          if (n2) {
            string3 += string3;
          }
        } while (n2);
        return result2;
      }
      function baseRest(func, start2) {
        return setToString(overRest(func, start2, identity2), func + "");
      }
      function baseSample(collection) {
        return arraySample(values(collection));
      }
      function baseSampleSize(collection, n2) {
        var array4 = values(collection);
        return shuffleSelf(array4, baseClamp(n2, 0, array4.length));
      }
      function baseSet(object4, path, value, customizer) {
        if (!isObject2(object4)) {
          return object4;
        }
        path = castPath(path, object4);
        var index2 = -1, length = path.length, lastIndex = length - 1, nested = object4;
        while (nested != null && ++index2 < length) {
          var key = toKey(path[index2]), newValue = value;
          if (key === "__proto__" || key === "constructor" || key === "prototype") {
            return object4;
          }
          if (index2 != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
            if (newValue === undefined$1) {
              newValue = isObject2(objValue) ? objValue : isIndex(path[index2 + 1]) ? [] : {};
            }
          }
          assignValue(nested, key, newValue);
          nested = nested[key];
        }
        return object4;
      }
      var baseSetData = !metaMap ? identity2 : function(func, data) {
        metaMap.set(func, data);
        return func;
      };
      var baseSetToString = !defineProperty ? identity2 : function(func, string3) {
        return defineProperty(func, "toString", {
          "configurable": true,
          "enumerable": false,
          "value": constant(string3),
          "writable": true
        });
      };
      function baseShuffle(collection) {
        return shuffleSelf(values(collection));
      }
      function baseSlice(array4, start2, end2) {
        var index2 = -1, length = array4.length;
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 > length ? length : end2;
        if (end2 < 0) {
          end2 += length;
        }
        length = start2 > end2 ? 0 : end2 - start2 >>> 0;
        start2 >>>= 0;
        var result2 = Array2(length);
        while (++index2 < length) {
          result2[index2] = array4[index2 + start2];
        }
        return result2;
      }
      function baseSome(collection, predicate) {
        var result2;
        baseEach(collection, function(value, index2, collection2) {
          result2 = predicate(value, index2, collection2);
          return !result2;
        });
        return !!result2;
      }
      function baseSortedIndex(array4, value, retHighest) {
        var low = 0, high = array4 == null ? low : array4.length;
        if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
          while (low < high) {
            var mid = low + high >>> 1, computed = array4[mid];
            if (computed !== null && !isSymbol2(computed) && (retHighest ? computed <= value : computed < value)) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return high;
        }
        return baseSortedIndexBy(array4, value, identity2, retHighest);
      }
      function baseSortedIndexBy(array4, value, iteratee2, retHighest) {
        var low = 0, high = array4 == null ? 0 : array4.length;
        if (high === 0) {
          return 0;
        }
        value = iteratee2(value);
        var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol2(value), valIsUndefined = value === undefined$1;
        while (low < high) {
          var mid = nativeFloor((low + high) / 2), computed = iteratee2(array4[mid]), othIsDefined = computed !== undefined$1, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol2(computed);
          if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
          } else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
          } else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
          } else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
          } else if (othIsNull || othIsSymbol) {
            setLow = false;
          } else {
            setLow = retHighest ? computed <= value : computed < value;
          }
          if (setLow) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return nativeMin2(high, MAX_ARRAY_INDEX);
      }
      function baseSortedUniq(array4, iteratee2) {
        var index2 = -1, length = array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
          if (!index2 || !eq(computed, seen)) {
            var seen = computed;
            result2[resIndex++] = value === 0 ? 0 : value;
          }
        }
        return result2;
      }
      function baseToNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        return +value;
      }
      function baseToString(value) {
        if (typeof value == "string") {
          return value;
        }
        if (isArray2(value)) {
          return arrayMap(value, baseToString) + "";
        }
        if (isSymbol2(value)) {
          return symbolToString ? symbolToString.call(value) : "";
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function baseUniq(array4, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, length = array4.length, isCommon = true, result2 = [], seen = result2;
        if (comparator) {
          isCommon = false;
          includes2 = arrayIncludesWith;
        } else if (length >= LARGE_ARRAY_SIZE) {
          var set3 = iteratee2 ? null : createSet(array4);
          if (set3) {
            return setToArray(set3);
          }
          isCommon = false;
          includes2 = cacheHas;
          seen = new SetCache();
        } else {
          seen = iteratee2 ? [] : result2;
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var seenIndex = seen.length;
              while (seenIndex--) {
                if (seen[seenIndex] === computed) {
                  continue outer;
                }
              }
              if (iteratee2) {
                seen.push(computed);
              }
              result2.push(value);
            } else if (!includes2(seen, computed, comparator)) {
              if (seen !== result2) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseUnset(object4, path) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        return object4 == null || delete object4[toKey(last(path))];
      }
      function baseUpdate(object4, path, updater, customizer) {
        return baseSet(object4, path, updater(baseGet(object4, path)), customizer);
      }
      function baseWhile(array4, predicate, isDrop, fromRight) {
        var length = array4.length, index2 = fromRight ? length : -1;
        while ((fromRight ? index2-- : ++index2 < length) && predicate(array4[index2], index2, array4)) {
        }
        return isDrop ? baseSlice(array4, fromRight ? 0 : index2, fromRight ? index2 + 1 : length) : baseSlice(array4, fromRight ? index2 + 1 : 0, fromRight ? length : index2);
      }
      function baseWrapperValue(value, actions2) {
        var result2 = value;
        if (result2 instanceof LazyWrapper) {
          result2 = result2.value();
        }
        return arrayReduce(actions2, function(result3, action) {
          return action.func.apply(action.thisArg, arrayPush([result3], action.args));
        }, result2);
      }
      function baseXor(arrays, iteratee2, comparator) {
        var length = arrays.length;
        if (length < 2) {
          return length ? baseUniq(arrays[0]) : [];
        }
        var index2 = -1, result2 = Array2(length);
        while (++index2 < length) {
          var array4 = arrays[index2], othIndex = -1;
          while (++othIndex < length) {
            if (othIndex != index2) {
              result2[index2] = baseDifference(result2[index2] || array4, arrays[othIndex], iteratee2, comparator);
            }
          }
        }
        return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
      }
      function baseZipObject(props, values2, assignFunc) {
        var index2 = -1, length = props.length, valsLength = values2.length, result2 = {};
        while (++index2 < length) {
          var value = index2 < valsLength ? values2[index2] : undefined$1;
          assignFunc(result2, props[index2], value);
        }
        return result2;
      }
      function castArrayLikeObject(value) {
        return isArrayLikeObject(value) ? value : [];
      }
      function castFunction(value) {
        return typeof value == "function" ? value : identity2;
      }
      function castPath(value, object4) {
        if (isArray2(value)) {
          return value;
        }
        return isKey(value, object4) ? [value] : stringToPath(toString(value));
      }
      var castRest = baseRest;
      function castSlice(array4, start2, end2) {
        var length = array4.length;
        end2 = end2 === undefined$1 ? length : end2;
        return !start2 && end2 >= length ? array4 : baseSlice(array4, start2, end2);
      }
      var clearTimeout2 = ctxClearTimeout || function(id2) {
        return root2.clearTimeout(id2);
      };
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
        buffer.copy(result2);
        return result2;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
        return result2;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneRegExp(regexp4) {
        var result2 = new regexp4.constructor(regexp4.source, reFlags.exec(regexp4));
        result2.lastIndex = regexp4.lastIndex;
        return result2;
      }
      function cloneSymbol(symbol) {
        return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function compareAscending(value, other) {
        if (value !== other) {
          var valIsDefined = value !== undefined$1, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol2(value);
          var othIsDefined = other !== undefined$1, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol2(other);
          if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
            return 1;
          }
          if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
            return -1;
          }
        }
        return 0;
      }
      function compareMultiple(object4, other, orders) {
        var index2 = -1, objCriteria = object4.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
        while (++index2 < length) {
          var result2 = compareAscending(objCriteria[index2], othCriteria[index2]);
          if (result2) {
            if (index2 >= ordersLength) {
              return result2;
            }
            var order = orders[index2];
            return result2 * (order == "desc" ? -1 : 1);
          }
        }
        return object4.index - other.index;
      }
      function composeArgs(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
        while (++leftIndex < leftLength) {
          result2[leftIndex] = partials[leftIndex];
        }
        while (++argsIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[holders[argsIndex]] = args[argsIndex];
          }
        }
        while (rangeLength--) {
          result2[leftIndex++] = args[argsIndex++];
        }
        return result2;
      }
      function composeArgsRight(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
        while (++argsIndex < rangeLength) {
          result2[argsIndex] = args[argsIndex];
        }
        var offset = argsIndex;
        while (++rightIndex < rightLength) {
          result2[offset + rightIndex] = partials[rightIndex];
        }
        while (++holdersIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[offset + holders[holdersIndex]] = args[argsIndex++];
          }
        }
        return result2;
      }
      function copyArray(source, array4) {
        var index2 = -1, length = source.length;
        array4 || (array4 = Array2(length));
        while (++index2 < length) {
          array4[index2] = source[index2];
        }
        return array4;
      }
      function copyObject(source, props, object4, customizer) {
        var isNew = !object4;
        object4 || (object4 = {});
        var index2 = -1, length = props.length;
        while (++index2 < length) {
          var key = props[index2];
          var newValue = customizer ? customizer(object4[key], source[key], key, object4, source) : undefined$1;
          if (newValue === undefined$1) {
            newValue = source[key];
          }
          if (isNew) {
            baseAssignValue(object4, key, newValue);
          } else {
            assignValue(object4, key, newValue);
          }
        }
        return object4;
      }
      function copySymbols(source, object4) {
        return copyObject(source, getSymbols(source), object4);
      }
      function copySymbolsIn(source, object4) {
        return copyObject(source, getSymbolsIn(source), object4);
      }
      function createAggregator(setter, initializer) {
        return function(collection, iteratee2) {
          var func = isArray2(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
          return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
        };
      }
      function createAssigner(assigner) {
        return baseRest(function(object4, sources) {
          var index2 = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined$1, guard = length > 2 ? sources[2] : undefined$1;
          customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined$1;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            customizer = length < 3 ? undefined$1 : customizer;
            length = 1;
          }
          object4 = Object2(object4);
          while (++index2 < length) {
            var source = sources[index2];
            if (source) {
              assigner(object4, source, index2, customizer);
            }
          }
          return object4;
        });
      }
      function createBaseEach(eachFunc, fromRight) {
        return function(collection, iteratee2) {
          if (collection == null) {
            return collection;
          }
          if (!isArrayLike2(collection)) {
            return eachFunc(collection, iteratee2);
          }
          var length = collection.length, index2 = fromRight ? length : -1, iterable = Object2(collection);
          while (fromRight ? index2-- : ++index2 < length) {
            if (iteratee2(iterable[index2], index2, iterable) === false) {
              break;
            }
          }
          return collection;
        };
      }
      function createBaseFor(fromRight) {
        return function(object4, iteratee2, keysFunc) {
          var index2 = -1, iterable = Object2(object4), props = keysFunc(object4), length = props.length;
          while (length--) {
            var key = props[fromRight ? length : ++index2];
            if (iteratee2(iterable[key], key, iterable) === false) {
              break;
            }
          }
          return object4;
        };
      }
      function createBind(func, bitmask, thisArg) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return fn.apply(isBind ? thisArg : this, arguments);
        }
        return wrapper;
      }
      function createCaseFirst(methodName) {
        return function(string3) {
          string3 = toString(string3);
          var strSymbols = hasUnicode(string3) ? stringToArray(string3) : undefined$1;
          var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
          var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string3.slice(1);
          return chr[methodName]() + trailing;
        };
      }
      function createCompounder(callback) {
        return function(string3) {
          return arrayReduce(words(deburr(string3).replace(reApos, "")), callback, "");
        };
      }
      function createCtor(Ctor) {
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return new Ctor();
            case 1:
              return new Ctor(args[0]);
            case 2:
              return new Ctor(args[0], args[1]);
            case 3:
              return new Ctor(args[0], args[1], args[2]);
            case 4:
              return new Ctor(args[0], args[1], args[2], args[3]);
            case 5:
              return new Ctor(args[0], args[1], args[2], args[3], args[4]);
            case 6:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
            case 7:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
          }
          var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
          return isObject2(result2) ? result2 : thisBinding;
        };
      }
      function createCurry(func, bitmask, arity) {
        var Ctor = createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length, placeholder = getHolder(wrapper);
          while (index2--) {
            args[index2] = arguments[index2];
          }
          var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
          length -= holders.length;
          if (length < arity) {
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, undefined$1, args, holders, undefined$1, undefined$1, arity - length);
          }
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return apply(fn, this, args);
        }
        return wrapper;
      }
      function createFind(findIndexFunc) {
        return function(collection, predicate, fromIndex) {
          var iterable = Object2(collection);
          if (!isArrayLike2(collection)) {
            var iteratee2 = getIteratee(predicate, 3);
            collection = keys2(collection);
            predicate = function(key) {
              return iteratee2(iterable[key], key, iterable);
            };
          }
          var index2 = findIndexFunc(collection, predicate, fromIndex);
          return index2 > -1 ? iterable[iteratee2 ? collection[index2] : index2] : undefined$1;
        };
      }
      function createFlow(fromRight) {
        return flatRest(function(funcs) {
          var length = funcs.length, index2 = length, prereq = LodashWrapper.prototype.thru;
          if (fromRight) {
            funcs.reverse();
          }
          while (index2--) {
            var func = funcs[index2];
            if (typeof func != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT2);
            }
            if (prereq && !wrapper && getFuncName(func) == "wrapper") {
              var wrapper = new LodashWrapper([], true);
            }
          }
          index2 = wrapper ? index2 : length;
          while (++index2 < length) {
            func = funcs[index2];
            var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined$1;
            if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
              wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
            } else {
              wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
            }
          }
          return function() {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray2(value)) {
              return wrapper.plant(value).value();
            }
            var index3 = 0, result2 = length ? funcs[index3].apply(this, args) : value;
            while (++index3 < length) {
              result2 = funcs[index3].call(this, result2);
            }
            return result2;
          };
        });
      }
      function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
        var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined$1 : createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length;
          while (index2--) {
            args[index2] = arguments[index2];
          }
          if (isCurried) {
            var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
          }
          if (partials) {
            args = composeArgs(args, partials, holders, isCurried);
          }
          if (partialsRight) {
            args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
          }
          length -= holdersCount;
          if (isCurried && length < arity) {
            var newHolders = replaceHolders(args, placeholder);
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary2, arity - length);
          }
          var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
          length = args.length;
          if (argPos) {
            args = reorder(args, argPos);
          } else if (isFlip && length > 1) {
            args.reverse();
          }
          if (isAry && ary2 < length) {
            args.length = ary2;
          }
          if (this && this !== root2 && this instanceof wrapper) {
            fn = Ctor || createCtor(fn);
          }
          return fn.apply(thisBinding, args);
        }
        return wrapper;
      }
      function createInverter(setter, toIteratee) {
        return function(object4, iteratee2) {
          return baseInverter(object4, setter, toIteratee(iteratee2), {});
        };
      }
      function createMathOperation(operator, defaultValue) {
        return function(value, other) {
          var result2;
          if (value === undefined$1 && other === undefined$1) {
            return defaultValue;
          }
          if (value !== undefined$1) {
            result2 = value;
          }
          if (other !== undefined$1) {
            if (result2 === undefined$1) {
              return other;
            }
            if (typeof value == "string" || typeof other == "string") {
              value = baseToString(value);
              other = baseToString(other);
            } else {
              value = baseToNumber(value);
              other = baseToNumber(other);
            }
            result2 = operator(value, other);
          }
          return result2;
        };
      }
      function createOver(arrayFunc) {
        return flatRest(function(iteratees) {
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          return baseRest(function(args) {
            var thisArg = this;
            return arrayFunc(iteratees, function(iteratee2) {
              return apply(iteratee2, thisArg, args);
            });
          });
        });
      }
      function createPadding(length, chars) {
        chars = chars === undefined$1 ? " " : baseToString(chars);
        var charsLength = chars.length;
        if (charsLength < 2) {
          return charsLength ? baseRepeat(chars, length) : chars;
        }
        var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
        return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
      }
      function createPartial(func, bitmask, thisArg, partials) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
          }
          while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
          }
          return apply(fn, isBind ? thisArg : this, args);
        }
        return wrapper;
      }
      function createRange(fromRight) {
        return function(start2, end2, step) {
          if (step && typeof step != "number" && isIterateeCall(start2, end2, step)) {
            end2 = step = undefined$1;
          }
          start2 = toFinite(start2);
          if (end2 === undefined$1) {
            end2 = start2;
            start2 = 0;
          } else {
            end2 = toFinite(end2);
          }
          step = step === undefined$1 ? start2 < end2 ? 1 : -1 : toFinite(step);
          return baseRange(start2, end2, step, fromRight);
        };
      }
      function createRelationalOperation(operator) {
        return function(value, other) {
          if (!(typeof value == "string" && typeof other == "string")) {
            value = toNumber2(value);
            other = toNumber2(other);
          }
          return operator(value, other);
        };
      }
      function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
        var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined$1, newHoldersRight = isCurry ? undefined$1 : holders, newPartials = isCurry ? partials : undefined$1, newPartialsRight = isCurry ? undefined$1 : partials;
        bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
        bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
        if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
          bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
        }
        var newData = [
          func,
          bitmask,
          thisArg,
          newPartials,
          newHolders,
          newPartialsRight,
          newHoldersRight,
          argPos,
          ary2,
          arity
        ];
        var result2 = wrapFunc.apply(undefined$1, newData);
        if (isLaziable(func)) {
          setData(result2, newData);
        }
        result2.placeholder = placeholder;
        return setWrapToString(result2, func, bitmask);
      }
      function createRound(methodName) {
        var func = Math2[methodName];
        return function(number4, precision) {
          number4 = toNumber2(number4);
          precision = precision == null ? 0 : nativeMin2(toInteger(precision), 292);
          if (precision && nativeIsFinite(number4)) {
            var pair = (toString(number4) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
            pair = (toString(value) + "e").split("e");
            return +(pair[0] + "e" + (+pair[1] - precision));
          }
          return func(number4);
        };
      }
      var createSet = !(Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
        return new Set2(values2);
      };
      function createToPairs(keysFunc) {
        return function(object4) {
          var tag = getTag(object4);
          if (tag == mapTag) {
            return mapToArray(object4);
          }
          if (tag == setTag) {
            return setToPairs(object4);
          }
          return baseToPairs(object4, keysFunc(object4));
        };
      }
      function createWrap2(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
        var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
        if (!isBindKey && typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var length = partials ? partials.length : 0;
        if (!length) {
          bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
          partials = holders = undefined$1;
        }
        ary2 = ary2 === undefined$1 ? ary2 : nativeMax2(toInteger(ary2), 0);
        arity = arity === undefined$1 ? arity : toInteger(arity);
        length -= holders ? holders.length : 0;
        if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
          var partialsRight = partials, holdersRight = holders;
          partials = holders = undefined$1;
        }
        var data = isBindKey ? undefined$1 : getData(func);
        var newData = [
          func,
          bitmask,
          thisArg,
          partials,
          holders,
          partialsRight,
          holdersRight,
          argPos,
          ary2,
          arity
        ];
        if (data) {
          mergeData(newData, data);
        }
        func = newData[0];
        bitmask = newData[1];
        thisArg = newData[2];
        partials = newData[3];
        holders = newData[4];
        arity = newData[9] = newData[9] === undefined$1 ? isBindKey ? 0 : func.length : nativeMax2(newData[9] - length, 0);
        if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
          bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
        }
        if (!bitmask || bitmask == WRAP_BIND_FLAG) {
          var result2 = createBind(func, bitmask, thisArg);
        } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
          result2 = createCurry(func, bitmask, arity);
        } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
          result2 = createPartial(func, bitmask, thisArg, partials);
        } else {
          result2 = createHybrid.apply(undefined$1, newData);
        }
        var setter = data ? baseSetData : setData;
        return setWrapToString(setter(result2, newData), func, bitmask);
      }
      function customDefaultsAssignIn(objValue, srcValue, key, object4) {
        if (objValue === undefined$1 || eq(objValue, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
          return srcValue;
        }
        return objValue;
      }
      function customDefaultsMerge(objValue, srcValue, key, object4, source, stack) {
        if (isObject2(objValue) && isObject2(srcValue)) {
          stack.set(srcValue, objValue);
          baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
          stack["delete"](srcValue);
        }
        return objValue;
      }
      function customOmitClone(value) {
        return isPlainObject(value) ? undefined$1 : value;
      }
      function equalArrays(array4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array4.length, othLength = other.length;
        if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
          return false;
        }
        var arrStacked = stack.get(array4);
        var othStacked = stack.get(other);
        if (arrStacked && othStacked) {
          return arrStacked == other && othStacked == array4;
        }
        var index2 = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined$1;
        stack.set(array4, other);
        stack.set(other, array4);
        while (++index2 < arrLength) {
          var arrValue = array4[index2], othValue = other[index2];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
          }
          if (compared !== undefined$1) {
            if (compared) {
              continue;
            }
            result2 = false;
            break;
          }
          if (seen) {
            if (!arraySome(other, function(othValue2, othIndex) {
              if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                return seen.push(othIndex);
              }
            })) {
              result2 = false;
              break;
            }
          } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result2 = false;
            break;
          }
        }
        stack["delete"](array4);
        stack["delete"](other);
        return result2;
      }
      function equalByTag(object4, other, tag, bitmask, customizer, equalFunc, stack) {
        switch (tag) {
          case dataViewTag:
            if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
              return false;
            }
            object4 = object4.buffer;
            other = other.buffer;
          case arrayBufferTag:
            if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object4), new Uint8Array2(other))) {
              return false;
            }
            return true;
          case boolTag:
          case dateTag:
          case numberTag:
            return eq(+object4, +other);
          case errorTag:
            return object4.name == other.name && object4.message == other.message;
          case regexpTag:
          case stringTag:
            return object4 == other + "";
          case mapTag:
            var convert = mapToArray;
          case setTag:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
            convert || (convert = setToArray);
            if (object4.size != other.size && !isPartial) {
              return false;
            }
            var stacked = stack.get(object4);
            if (stacked) {
              return stacked == other;
            }
            bitmask |= COMPARE_UNORDERED_FLAG;
            stack.set(object4, other);
            var result2 = equalArrays(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
            stack["delete"](object4);
            return result2;
          case symbolTag2:
            if (symbolValueOf) {
              return symbolValueOf.call(object4) == symbolValueOf.call(other);
            }
        }
        return false;
      }
      function equalObjects(object4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object4), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
        if (objLength != othLength && !isPartial) {
          return false;
        }
        var index2 = objLength;
        while (index2--) {
          var key = objProps[index2];
          if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
            return false;
          }
        }
        var objStacked = stack.get(object4);
        var othStacked = stack.get(other);
        if (objStacked && othStacked) {
          return objStacked == other && othStacked == object4;
        }
        var result2 = true;
        stack.set(object4, other);
        stack.set(other, object4);
        var skipCtor = isPartial;
        while (++index2 < objLength) {
          key = objProps[index2];
          var objValue = object4[key], othValue = other[key];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
          }
          if (!(compared === undefined$1 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result2 = false;
            break;
          }
          skipCtor || (skipCtor = key == "constructor");
        }
        if (result2 && !skipCtor) {
          var objCtor = object4.constructor, othCtor = other.constructor;
          if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
            result2 = false;
          }
        }
        stack["delete"](object4);
        stack["delete"](other);
        return result2;
      }
      function flatRest(func) {
        return setToString(overRest(func, undefined$1, flatten), func + "");
      }
      function getAllKeys(object4) {
        return baseGetAllKeys(object4, keys2, getSymbols);
      }
      function getAllKeysIn(object4) {
        return baseGetAllKeys(object4, keysIn, getSymbolsIn);
      }
      var getData = !metaMap ? noop2 : function(func) {
        return metaMap.get(func);
      };
      function getFuncName(func) {
        var result2 = func.name + "", array4 = realNames[result2], length = hasOwnProperty2.call(realNames, result2) ? array4.length : 0;
        while (length--) {
          var data = array4[length], otherFunc = data.func;
          if (otherFunc == null || otherFunc == func) {
            return data.name;
          }
        }
        return result2;
      }
      function getHolder(func) {
        var object4 = hasOwnProperty2.call(lodash2, "placeholder") ? lodash2 : func;
        return object4.placeholder;
      }
      function getIteratee() {
        var result2 = lodash2.iteratee || iteratee;
        result2 = result2 === iteratee ? baseIteratee : result2;
        return arguments.length ? result2(arguments[0], arguments[1]) : result2;
      }
      function getMapData(map3, key) {
        var data = map3.__data__;
        return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
      }
      function getMatchData(object4) {
        var result2 = keys2(object4), length = result2.length;
        while (length--) {
          var key = result2[length], value = object4[key];
          result2[length] = [key, value, isStrictComparable(value)];
        }
        return result2;
      }
      function getNative(object4, key) {
        var value = getValue2(object4, key);
        return baseIsNative(value) ? value : undefined$1;
      }
      function getRawTag2(value) {
        var isOwn = hasOwnProperty2.call(value, symToStringTag2), tag = value[symToStringTag2];
        try {
          value[symToStringTag2] = undefined$1;
          var unmasked = true;
        } catch (e2) {
        }
        var result2 = nativeObjectToString2.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag2] = tag;
          } else {
            delete value[symToStringTag2];
          }
        }
        return result2;
      }
      var getSymbols = !nativeGetSymbols ? stubArray : function(object4) {
        if (object4 == null) {
          return [];
        }
        object4 = Object2(object4);
        return arrayFilter(nativeGetSymbols(object4), function(symbol) {
          return propertyIsEnumerable.call(object4, symbol);
        });
      };
      var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object4) {
        var result2 = [];
        while (object4) {
          arrayPush(result2, getSymbols(object4));
          object4 = getPrototype(object4);
        }
        return result2;
      };
      var getTag = baseGetTag2;
      if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap3 && getTag(new WeakMap3()) != weakMapTag) {
        getTag = function(value) {
          var result2 = baseGetTag2(value), Ctor = result2 == objectTag ? value.constructor : undefined$1, ctorString = Ctor ? toSource(Ctor) : "";
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString:
                return dataViewTag;
              case mapCtorString:
                return mapTag;
              case promiseCtorString:
                return promiseTag;
              case setCtorString:
                return setTag;
              case weakMapCtorString:
                return weakMapTag;
            }
          }
          return result2;
        };
      }
      function getView(start2, end2, transforms) {
        var index2 = -1, length = transforms.length;
        while (++index2 < length) {
          var data = transforms[index2], size2 = data.size;
          switch (data.type) {
            case "drop":
              start2 += size2;
              break;
            case "dropRight":
              end2 -= size2;
              break;
            case "take":
              end2 = nativeMin2(end2, start2 + size2);
              break;
            case "takeRight":
              start2 = nativeMax2(start2, end2 - size2);
              break;
          }
        }
        return { "start": start2, "end": end2 };
      }
      function getWrapDetails(source) {
        var match = source.match(reWrapDetails);
        return match ? match[1].split(reSplitDetails) : [];
      }
      function hasPath(object4, path, hasFunc) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length, result2 = false;
        while (++index2 < length) {
          var key = toKey(path[index2]);
          if (!(result2 = object4 != null && hasFunc(object4, key))) {
            break;
          }
          object4 = object4[key];
        }
        if (result2 || ++index2 != length) {
          return result2;
        }
        length = object4 == null ? 0 : object4.length;
        return !!length && isLength(length) && isIndex(key, length) && (isArray2(object4) || isArguments(object4));
      }
      function initCloneArray(array4) {
        var length = array4.length, result2 = new array4.constructor(length);
        if (length && typeof array4[0] == "string" && hasOwnProperty2.call(array4, "index")) {
          result2.index = array4.index;
          result2.input = array4.input;
        }
        return result2;
      }
      function initCloneObject(object4) {
        return typeof object4.constructor == "function" && !isPrototype(object4) ? baseCreate(getPrototype(object4)) : {};
      }
      function initCloneByTag(object4, tag, isDeep) {
        var Ctor = object4.constructor;
        switch (tag) {
          case arrayBufferTag:
            return cloneArrayBuffer(object4);
          case boolTag:
          case dateTag:
            return new Ctor(+object4);
          case dataViewTag:
            return cloneDataView(object4, isDeep);
          case float32Tag:
          case float64Tag:
          case int8Tag:
          case int16Tag:
          case int32Tag:
          case uint8Tag:
          case uint8ClampedTag:
          case uint16Tag:
          case uint32Tag:
            return cloneTypedArray(object4, isDeep);
          case mapTag:
            return new Ctor();
          case numberTag:
          case stringTag:
            return new Ctor(object4);
          case regexpTag:
            return cloneRegExp(object4);
          case setTag:
            return new Ctor();
          case symbolTag2:
            return cloneSymbol(object4);
        }
      }
      function insertWrapDetails(source, details) {
        var length = details.length;
        if (!length) {
          return source;
        }
        var lastIndex = length - 1;
        details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
        details = details.join(length > 2 ? ", " : " ");
        return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
      }
      function isFlattenable(value) {
        return isArray2(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
      }
      function isIndex(value, length) {
        var type4 = typeof value;
        length = length == null ? MAX_SAFE_INTEGER2 : length;
        return !!length && (type4 == "number" || type4 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isIterateeCall(value, index2, object4) {
        if (!isObject2(object4)) {
          return false;
        }
        var type4 = typeof index2;
        if (type4 == "number" ? isArrayLike2(object4) && isIndex(index2, object4.length) : type4 == "string" && index2 in object4) {
          return eq(object4[index2], value);
        }
        return false;
      }
      function isKey(value, object4) {
        if (isArray2(value)) {
          return false;
        }
        var type4 = typeof value;
        if (type4 == "number" || type4 == "symbol" || type4 == "boolean" || value == null || isSymbol2(value)) {
          return true;
        }
        return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object4 != null && value in Object2(object4);
      }
      function isKeyable(value) {
        var type4 = typeof value;
        return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
      }
      function isLaziable(func) {
        var funcName = getFuncName(func), other = lodash2[funcName];
        if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
          return false;
        }
        if (func === other) {
          return true;
        }
        var data = getData(other);
        return !!data && func === data[0];
      }
      function isMasked(func) {
        return !!maskSrcKey && maskSrcKey in func;
      }
      var isMaskable = coreJsData ? isFunction2 : stubFalse;
      function isPrototype(value) {
        var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto2;
        return value === proto2;
      }
      function isStrictComparable(value) {
        return value === value && !isObject2(value);
      }
      function matchesStrictComparable(key, srcValue) {
        return function(object4) {
          if (object4 == null) {
            return false;
          }
          return object4[key] === srcValue && (srcValue !== undefined$1 || key in Object2(object4));
        };
      }
      function memoizeCapped(func) {
        var result2 = memoize(func, function(key) {
          if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
          }
          return key;
        });
        var cache = result2.cache;
        return result2;
      }
      function mergeData(data, source) {
        var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
        var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
        if (!(isCommon || isCombo)) {
          return data;
        }
        if (srcBitmask & WRAP_BIND_FLAG) {
          data[2] = source[2];
          newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
        }
        var value = source[3];
        if (value) {
          var partials = data[3];
          data[3] = partials ? composeArgs(partials, value, source[4]) : value;
          data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
        }
        value = source[5];
        if (value) {
          partials = data[5];
          data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
          data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
        }
        value = source[7];
        if (value) {
          data[7] = value;
        }
        if (srcBitmask & WRAP_ARY_FLAG) {
          data[8] = data[8] == null ? source[8] : nativeMin2(data[8], source[8]);
        }
        if (data[9] == null) {
          data[9] = source[9];
        }
        data[0] = source[0];
        data[1] = newBitmask;
        return data;
      }
      function nativeKeysIn(object4) {
        var result2 = [];
        if (object4 != null) {
          for (var key in Object2(object4)) {
            result2.push(key);
          }
        }
        return result2;
      }
      function objectToString2(value) {
        return nativeObjectToString2.call(value);
      }
      function overRest(func, start2, transform3) {
        start2 = nativeMax2(start2 === undefined$1 ? func.length - 1 : start2, 0);
        return function() {
          var args = arguments, index2 = -1, length = nativeMax2(args.length - start2, 0), array4 = Array2(length);
          while (++index2 < length) {
            array4[index2] = args[start2 + index2];
          }
          index2 = -1;
          var otherArgs = Array2(start2 + 1);
          while (++index2 < start2) {
            otherArgs[index2] = args[index2];
          }
          otherArgs[start2] = transform3(array4);
          return apply(func, this, otherArgs);
        };
      }
      function parent(object4, path) {
        return path.length < 2 ? object4 : baseGet(object4, baseSlice(path, 0, -1));
      }
      function reorder(array4, indexes) {
        var arrLength = array4.length, length = nativeMin2(indexes.length, arrLength), oldArray = copyArray(array4);
        while (length--) {
          var index2 = indexes[length];
          array4[length] = isIndex(index2, arrLength) ? oldArray[index2] : undefined$1;
        }
        return array4;
      }
      function safeGet(object4, key) {
        if (key === "constructor" && typeof object4[key] === "function") {
          return;
        }
        if (key == "__proto__") {
          return;
        }
        return object4[key];
      }
      var setData = shortOut(baseSetData);
      var setTimeout2 = ctxSetTimeout || function(func, wait) {
        return root2.setTimeout(func, wait);
      };
      var setToString = shortOut(baseSetToString);
      function setWrapToString(wrapper, reference, bitmask) {
        var source = reference + "";
        return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
      }
      function shortOut(func) {
        var count2 = 0, lastCalled = 0;
        return function() {
          var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
          lastCalled = stamp;
          if (remaining > 0) {
            if (++count2 >= HOT_COUNT) {
              return arguments[0];
            }
          } else {
            count2 = 0;
          }
          return func.apply(undefined$1, arguments);
        };
      }
      function shuffleSelf(array4, size2) {
        var index2 = -1, length = array4.length, lastIndex = length - 1;
        size2 = size2 === undefined$1 ? length : size2;
        while (++index2 < size2) {
          var rand = baseRandom(index2, lastIndex), value = array4[rand];
          array4[rand] = array4[index2];
          array4[index2] = value;
        }
        array4.length = size2;
        return array4;
      }
      var stringToPath = memoizeCapped(function(string3) {
        var result2 = [];
        if (string3.charCodeAt(0) === 46) {
          result2.push("");
        }
        string3.replace(rePropName, function(match, number4, quote, subString) {
          result2.push(quote ? subString.replace(reEscapeChar, "$1") : number4 || match);
        });
        return result2;
      });
      function toKey(value) {
        if (typeof value == "string" || isSymbol2(value)) {
          return value;
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function toSource(func) {
        if (func != null) {
          try {
            return funcToString.call(func);
          } catch (e2) {
          }
          try {
            return func + "";
          } catch (e2) {
          }
        }
        return "";
      }
      function updateWrapDetails(details, bitmask) {
        arrayEach(wrapFlags, function(pair) {
          var value = "_." + pair[0];
          if (bitmask & pair[1] && !arrayIncludes(details, value)) {
            details.push(value);
          }
        });
        return details.sort();
      }
      function wrapperClone(wrapper) {
        if (wrapper instanceof LazyWrapper) {
          return wrapper.clone();
        }
        var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
        result2.__actions__ = copyArray(wrapper.__actions__);
        result2.__index__ = wrapper.__index__;
        result2.__values__ = wrapper.__values__;
        return result2;
      }
      function chunk(array4, size2, guard) {
        if (guard ? isIterateeCall(array4, size2, guard) : size2 === undefined$1) {
          size2 = 1;
        } else {
          size2 = nativeMax2(toInteger(size2), 0);
        }
        var length = array4 == null ? 0 : array4.length;
        if (!length || size2 < 1) {
          return [];
        }
        var index2 = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
        while (index2 < length) {
          result2[resIndex++] = baseSlice(array4, index2, index2 += size2);
        }
        return result2;
      }
      function compact(array4) {
        var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2];
          if (value) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function concat() {
        var length = arguments.length;
        if (!length) {
          return [];
        }
        var args = Array2(length - 1), array4 = arguments[0], index2 = length;
        while (index2--) {
          args[index2 - 1] = arguments[index2];
        }
        return arrayPush(isArray2(array4) ? copyArray(array4) : [array4], baseFlatten(args, 1));
      }
      var difference = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
      });
      var differenceBy = baseRest(function(array4, values2) {
        var iteratee2 = last(values2);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
      });
      var differenceWith = baseRest(function(array4, values2) {
        var comparator = last(values2);
        if (isArrayLikeObject(comparator)) {
          comparator = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), undefined$1, comparator) : [];
      });
      function drop(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function dropRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function dropRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true, true) : [];
      }
      function dropWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true) : [];
      }
      function fill(array4, value, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (start2 && typeof start2 != "number" && isIterateeCall(array4, value, start2)) {
          start2 = 0;
          end2 = length;
        }
        return baseFill(array4, value, start2, end2);
      }
      function findIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2);
      }
      function findLastIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length - 1;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = fromIndex < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2, true);
      }
      function flatten(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, 1) : [];
      }
      function flattenDeep(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, INFINITY) : [];
      }
      function flattenDepth(array4, depth) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(array4, depth);
      }
      function fromPairs(pairs) {
        var index2 = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
        while (++index2 < length) {
          var pair = pairs[index2];
          result2[pair[0]] = pair[1];
        }
        return result2;
      }
      function head(array4) {
        return array4 && array4.length ? array4[0] : undefined$1;
      }
      function indexOf2(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseIndexOf(array4, value, index2);
      }
      function initial(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 0, -1) : [];
      }
      var intersection = baseRest(function(arrays) {
        var mapped = arrayMap(arrays, castArrayLikeObject);
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
      });
      var intersectionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        if (iteratee2 === last(mapped)) {
          iteratee2 = undefined$1;
        } else {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
      });
      var intersectionWith = baseRest(function(arrays) {
        var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        if (comparator) {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined$1, comparator) : [];
      });
      function join(array4, separator) {
        return array4 == null ? "" : nativeJoin.call(array4, separator);
      }
      function last(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? array4[length - 1] : undefined$1;
      }
      function lastIndexOf(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = index2 < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return value === value ? strictLastIndexOf(array4, value, index2) : baseFindIndex(array4, baseIsNaN, index2, true);
      }
      function nth(array4, n2) {
        return array4 && array4.length ? baseNth(array4, toInteger(n2)) : undefined$1;
      }
      var pull = baseRest(pullAll);
      function pullAll(array4, values2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2) : array4;
      }
      function pullAllBy(array4, values2, iteratee2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, getIteratee(iteratee2, 2)) : array4;
      }
      function pullAllWith(array4, values2, comparator) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, undefined$1, comparator) : array4;
      }
      var pullAt = flatRest(function(array4, indexes) {
        var length = array4 == null ? 0 : array4.length, result2 = baseAt(array4, indexes);
        basePullAt(array4, arrayMap(indexes, function(index2) {
          return isIndex(index2, length) ? +index2 : index2;
        }).sort(compareAscending));
        return result2;
      });
      function remove(array4, predicate) {
        var result2 = [];
        if (!(array4 && array4.length)) {
          return result2;
        }
        var index2 = -1, indexes = [], length = array4.length;
        predicate = getIteratee(predicate, 3);
        while (++index2 < length) {
          var value = array4[index2];
          if (predicate(value, index2, array4)) {
            result2.push(value);
            indexes.push(index2);
          }
        }
        basePullAt(array4, indexes);
        return result2;
      }
      function reverse2(array4) {
        return array4 == null ? array4 : nativeReverse.call(array4);
      }
      function slice2(array4, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (end2 && typeof end2 != "number" && isIterateeCall(array4, start2, end2)) {
          start2 = 0;
          end2 = length;
        } else {
          start2 = start2 == null ? 0 : toInteger(start2);
          end2 = end2 === undefined$1 ? length : toInteger(end2);
        }
        return baseSlice(array4, start2, end2);
      }
      function sortedIndex(array4, value) {
        return baseSortedIndex(array4, value);
      }
      function sortedIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2));
      }
      function sortedIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value);
          if (index2 < length && eq(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedLastIndex(array4, value) {
        return baseSortedIndex(array4, value, true);
      }
      function sortedLastIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2), true);
      }
      function sortedLastIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value, true) - 1;
          if (eq(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedUniq(array4) {
        return array4 && array4.length ? baseSortedUniq(array4) : [];
      }
      function sortedUniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseSortedUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function tail(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 1, length) : [];
      }
      function take2(array4, n2, guard) {
        if (!(array4 && array4.length)) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function takeRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function takeRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), false, true) : [];
      }
      function takeWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3)) : [];
      }
      var union = baseRest(function(arrays) {
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
      });
      var unionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
      });
      var unionWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
      });
      function uniq(array4) {
        return array4 && array4.length ? baseUniq(array4) : [];
      }
      function uniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function uniqWith(array4, comparator) {
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return array4 && array4.length ? baseUniq(array4, undefined$1, comparator) : [];
      }
      function unzip(array4) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var length = 0;
        array4 = arrayFilter(array4, function(group) {
          if (isArrayLikeObject(group)) {
            length = nativeMax2(group.length, length);
            return true;
          }
        });
        return baseTimes(length, function(index2) {
          return arrayMap(array4, baseProperty(index2));
        });
      }
      function unzipWith(array4, iteratee2) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var result2 = unzip(array4);
        if (iteratee2 == null) {
          return result2;
        }
        return arrayMap(result2, function(group) {
          return apply(iteratee2, undefined$1, group);
        });
      }
      var without = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, values2) : [];
      });
      var xor = baseRest(function(arrays) {
        return baseXor(arrayFilter(arrays, isArrayLikeObject));
      });
      var xorBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
      });
      var xorWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined$1, comparator);
      });
      var zip = baseRest(unzip);
      function zipObject(props, values2) {
        return baseZipObject(props || [], values2 || [], assignValue);
      }
      function zipObjectDeep(props, values2) {
        return baseZipObject(props || [], values2 || [], baseSet);
      }
      var zipWith = baseRest(function(arrays) {
        var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined$1;
        iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined$1;
        return unzipWith(arrays, iteratee2);
      });
      function chain(value) {
        var result2 = lodash2(value);
        result2.__chain__ = true;
        return result2;
      }
      function tap(value, interceptor) {
        interceptor(value);
        return value;
      }
      function thru(value, interceptor) {
        return interceptor(value);
      }
      var wrapperAt = flatRest(function(paths) {
        var length = paths.length, start2 = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object4) {
          return baseAt(object4, paths);
        };
        if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start2)) {
          return this.thru(interceptor);
        }
        value = value.slice(start2, +start2 + (length ? 1 : 0));
        value.__actions__.push({
          "func": thru,
          "args": [interceptor],
          "thisArg": undefined$1
        });
        return new LodashWrapper(value, this.__chain__).thru(function(array4) {
          if (length && !array4.length) {
            array4.push(undefined$1);
          }
          return array4;
        });
      });
      function wrapperChain() {
        return chain(this);
      }
      function wrapperCommit() {
        return new LodashWrapper(this.value(), this.__chain__);
      }
      function wrapperNext() {
        if (this.__values__ === undefined$1) {
          this.__values__ = toArray2(this.value());
        }
        var done = this.__index__ >= this.__values__.length, value = done ? undefined$1 : this.__values__[this.__index__++];
        return { "done": done, "value": value };
      }
      function wrapperToIterator() {
        return this;
      }
      function wrapperPlant(value) {
        var result2, parent2 = this;
        while (parent2 instanceof baseLodash) {
          var clone3 = wrapperClone(parent2);
          clone3.__index__ = 0;
          clone3.__values__ = undefined$1;
          if (result2) {
            previous.__wrapped__ = clone3;
          } else {
            result2 = clone3;
          }
          var previous = clone3;
          parent2 = parent2.__wrapped__;
        }
        previous.__wrapped__ = value;
        return result2;
      }
      function wrapperReverse() {
        var value = this.__wrapped__;
        if (value instanceof LazyWrapper) {
          var wrapped = value;
          if (this.__actions__.length) {
            wrapped = new LazyWrapper(this);
          }
          wrapped = wrapped.reverse();
          wrapped.__actions__.push({
            "func": thru,
            "args": [reverse2],
            "thisArg": undefined$1
          });
          return new LodashWrapper(wrapped, this.__chain__);
        }
        return this.thru(reverse2);
      }
      function wrapperValue() {
        return baseWrapperValue(this.__wrapped__, this.__actions__);
      }
      var countBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          ++result2[key];
        } else {
          baseAssignValue(result2, key, 1);
        }
      });
      function every(collection, predicate, guard) {
        var func = isArray2(collection) ? arrayEvery : baseEvery;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      function filter2(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter : baseFilter;
        return func(collection, getIteratee(predicate, 3));
      }
      var find2 = createFind(findIndex);
      var findLast = createFind(findLastIndex);
      function flatMap(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), 1);
      }
      function flatMapDeep(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), INFINITY);
      }
      function flatMapDepth(collection, iteratee2, depth) {
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(map2(collection, iteratee2), depth);
      }
      function forEach(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEach : baseEach;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function forEachRight(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEachRight : baseEachRight;
        return func(collection, getIteratee(iteratee2, 3));
      }
      var groupBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          result2[key].push(value);
        } else {
          baseAssignValue(result2, key, [value]);
        }
      });
      function includes(collection, value, fromIndex, guard) {
        collection = isArrayLike2(collection) ? collection : values(collection);
        fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
        var length = collection.length;
        if (fromIndex < 0) {
          fromIndex = nativeMax2(length + fromIndex, 0);
        }
        return isString2(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
      }
      var invokeMap = baseRest(function(collection, path, args) {
        var index2 = -1, isFunc = typeof path == "function", result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value) {
          result2[++index2] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
        });
        return result2;
      });
      var keyBy = createAggregator(function(result2, value, key) {
        baseAssignValue(result2, key, value);
      });
      function map2(collection, iteratee2) {
        var func = isArray2(collection) ? arrayMap : baseMap;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function orderBy(collection, iteratees, orders, guard) {
        if (collection == null) {
          return [];
        }
        if (!isArray2(iteratees)) {
          iteratees = iteratees == null ? [] : [iteratees];
        }
        orders = guard ? undefined$1 : orders;
        if (!isArray2(orders)) {
          orders = orders == null ? [] : [orders];
        }
        return baseOrderBy(collection, iteratees, orders);
      }
      var partition = createAggregator(function(result2, value, key) {
        result2[key ? 0 : 1].push(value);
      }, function() {
        return [[], []];
      });
      function reduce2(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
      }
      function reduceRight(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
      }
      function reject(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter : baseFilter;
        return func(collection, negate(getIteratee(predicate, 3)));
      }
      function sample(collection) {
        var func = isArray2(collection) ? arraySample : baseSample;
        return func(collection);
      }
      function sampleSize(collection, n2, guard) {
        if (guard ? isIterateeCall(collection, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        var func = isArray2(collection) ? arraySampleSize : baseSampleSize;
        return func(collection, n2);
      }
      function shuffle(collection) {
        var func = isArray2(collection) ? arrayShuffle : baseShuffle;
        return func(collection);
      }
      function size(collection) {
        if (collection == null) {
          return 0;
        }
        if (isArrayLike2(collection)) {
          return isString2(collection) ? stringSize(collection) : collection.length;
        }
        var tag = getTag(collection);
        if (tag == mapTag || tag == setTag) {
          return collection.size;
        }
        return baseKeys(collection).length;
      }
      function some(collection, predicate, guard) {
        var func = isArray2(collection) ? arraySome : baseSome;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      var sortBy = baseRest(function(collection, iteratees) {
        if (collection == null) {
          return [];
        }
        var length = iteratees.length;
        if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
          iteratees = [];
        } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
          iteratees = [iteratees[0]];
        }
        return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
      });
      var now2 = ctxNow || function() {
        return root2.Date.now();
      };
      function after(n2, func) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 < 1) {
            return func.apply(this, arguments);
          }
        };
      }
      function ary(func, n2, guard) {
        n2 = guard ? undefined$1 : n2;
        n2 = func && n2 == null ? func.length : n2;
        return createWrap2(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n2);
      }
      function before(n2, func) {
        var result2;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 > 0) {
            result2 = func.apply(this, arguments);
          }
          if (n2 <= 1) {
            func = undefined$1;
          }
          return result2;
        };
      }
      var bind2 = baseRest(function(func, thisArg, partials) {
        var bitmask = WRAP_BIND_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bind2));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(func, bitmask, thisArg, partials, holders);
      });
      var bindKey = baseRest(function(object4, key, partials) {
        var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bindKey));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(key, bitmask, object4, partials, holders);
      });
      function curry2(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curry2.placeholder;
        return result2;
      }
      function curryRight(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curryRight.placeholder;
        return result2;
      }
      function debounce2(func, wait, options) {
        var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        wait = toNumber2(wait) || 0;
        if (isObject2(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax2(toNumber2(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = undefined$1;
          lastInvokeTime = time;
          result2 = func.apply(thisArg, args);
          return result2;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout2(timerExpired, wait);
          return leading ? invokeFunc(time) : result2;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin2(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === undefined$1 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now2();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout2(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = undefined$1;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = undefined$1;
          return result2;
        }
        function cancel2() {
          if (timerId !== undefined$1) {
            clearTimeout2(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = undefined$1;
        }
        function flush() {
          return timerId === undefined$1 ? result2 : trailingEdge(now2());
        }
        function debounced() {
          var time = now2(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === undefined$1) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout2(timerId);
              timerId = setTimeout2(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === undefined$1) {
            timerId = setTimeout2(timerExpired, wait);
          }
          return result2;
        }
        debounced.cancel = cancel2;
        debounced.flush = flush;
        return debounced;
      }
      var defer = baseRest(function(func, args) {
        return baseDelay(func, 1, args);
      });
      var delay = baseRest(function(func, wait, args) {
        return baseDelay(func, toNumber2(wait) || 0, args);
      });
      function flip(func) {
        return createWrap2(func, WRAP_FLIP_FLAG);
      }
      function memoize(func, resolver) {
        if (typeof func != "function" || resolver != null && typeof resolver != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var memoized = function() {
          var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
          if (cache.has(key)) {
            return cache.get(key);
          }
          var result2 = func.apply(this, args);
          memoized.cache = cache.set(key, result2) || cache;
          return result2;
        };
        memoized.cache = new (memoize.Cache || MapCache)();
        return memoized;
      }
      memoize.Cache = MapCache;
      function negate(predicate) {
        if (typeof predicate != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return !predicate.call(this);
            case 1:
              return !predicate.call(this, args[0]);
            case 2:
              return !predicate.call(this, args[0], args[1]);
            case 3:
              return !predicate.call(this, args[0], args[1], args[2]);
          }
          return !predicate.apply(this, args);
        };
      }
      function once(func) {
        return before(2, func);
      }
      var overArgs = castRest(function(func, transforms) {
        transforms = transforms.length == 1 && isArray2(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
        var funcsLength = transforms.length;
        return baseRest(function(args) {
          var index2 = -1, length = nativeMin2(args.length, funcsLength);
          while (++index2 < length) {
            args[index2] = transforms[index2].call(this, args[index2]);
          }
          return apply(func, this, args);
        });
      });
      var partial = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partial));
        return createWrap2(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
      });
      var partialRight = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partialRight));
        return createWrap2(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
      });
      var rearg = flatRest(function(func, indexes) {
        return createWrap2(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
      });
      function rest(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 === undefined$1 ? start2 : toInteger(start2);
        return baseRest(func, start2);
      }
      function spread(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 == null ? 0 : nativeMax2(toInteger(start2), 0);
        return baseRest(function(args) {
          var array4 = args[start2], otherArgs = castSlice(args, 0, start2);
          if (array4) {
            arrayPush(otherArgs, array4);
          }
          return apply(func, this, otherArgs);
        });
      }
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        if (isObject2(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce2(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      function unary(func) {
        return ary(func, 1);
      }
      function wrap(value, wrapper) {
        return partial(castFunction(wrapper), value);
      }
      function castArray() {
        if (!arguments.length) {
          return [];
        }
        var value = arguments[0];
        return isArray2(value) ? value : [value];
      }
      function clone2(value) {
        return baseClone(value, CLONE_SYMBOLS_FLAG);
      }
      function cloneWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
      }
      function cloneDeep(value) {
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
      }
      function cloneDeepWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
      }
      function conformsTo(object4, source) {
        return source == null || baseConformsTo(object4, source, keys2(source));
      }
      function eq(value, other) {
        return value === other || value !== value && other !== other;
      }
      var gt = createRelationalOperation(baseGt);
      var gte = createRelationalOperation(function(value, other) {
        return value >= other;
      });
      var isArguments = baseIsArguments(function() {
        return arguments;
      }()) ? baseIsArguments : function(value) {
        return isObjectLike2(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
      };
      var isArray2 = Array2.isArray;
      var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
      function isArrayLike2(value) {
        return value != null && isLength(value.length) && !isFunction2(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike2(value) && isArrayLike2(value);
      }
      function isBoolean(value) {
        return value === true || value === false || isObjectLike2(value) && baseGetTag2(value) == boolTag;
      }
      var isBuffer = nativeIsBuffer || stubFalse;
      var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
      function isElement(value) {
        return isObjectLike2(value) && value.nodeType === 1 && !isPlainObject(value);
      }
      function isEmpty(value) {
        if (value == null) {
          return true;
        }
        if (isArrayLike2(value) && (isArray2(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray2(value) || isArguments(value))) {
          return !value.length;
        }
        var tag = getTag(value);
        if (tag == mapTag || tag == setTag) {
          return !value.size;
        }
        if (isPrototype(value)) {
          return !baseKeys(value).length;
        }
        for (var key in value) {
          if (hasOwnProperty2.call(value, key)) {
            return false;
          }
        }
        return true;
      }
      function isEqual(value, other) {
        return baseIsEqual(value, other);
      }
      function isEqualWith(value, other, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        var result2 = customizer ? customizer(value, other) : undefined$1;
        return result2 === undefined$1 ? baseIsEqual(value, other, undefined$1, customizer) : !!result2;
      }
      function isError(value) {
        if (!isObjectLike2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
      }
      function isFinite2(value) {
        return typeof value == "number" && nativeIsFinite(value);
      }
      function isFunction2(value) {
        if (!isObject2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
      }
      function isInteger(value) {
        return typeof value == "number" && value == toInteger(value);
      }
      function isLength(value) {
        return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
      }
      function isObject2(value) {
        var type4 = typeof value;
        return value != null && (type4 == "object" || type4 == "function");
      }
      function isObjectLike2(value) {
        return value != null && typeof value == "object";
      }
      var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
      function isMatch(object4, source) {
        return object4 === source || baseIsMatch(object4, source, getMatchData(source));
      }
      function isMatchWith(object4, source, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseIsMatch(object4, source, getMatchData(source), customizer);
      }
      function isNaN2(value) {
        return isNumber2(value) && value != +value;
      }
      function isNative(value) {
        if (isMaskable(value)) {
          throw new Error2(CORE_ERROR_TEXT);
        }
        return baseIsNative(value);
      }
      function isNull(value) {
        return value === null;
      }
      function isNil(value) {
        return value == null;
      }
      function isNumber2(value) {
        return typeof value == "number" || isObjectLike2(value) && baseGetTag2(value) == numberTag;
      }
      function isPlainObject(value) {
        if (!isObjectLike2(value) || baseGetTag2(value) != objectTag) {
          return false;
        }
        var proto2 = getPrototype(value);
        if (proto2 === null) {
          return true;
        }
        var Ctor = hasOwnProperty2.call(proto2, "constructor") && proto2.constructor;
        return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
      }
      var isRegExp2 = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
      function isSafeInteger(value) {
        return isInteger(value) && value >= -MAX_SAFE_INTEGER2 && value <= MAX_SAFE_INTEGER2;
      }
      var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
      function isString2(value) {
        return typeof value == "string" || !isArray2(value) && isObjectLike2(value) && baseGetTag2(value) == stringTag;
      }
      function isSymbol2(value) {
        return typeof value == "symbol" || isObjectLike2(value) && baseGetTag2(value) == symbolTag2;
      }
      var isTypedArray2 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
      function isUndefined(value) {
        return value === undefined$1;
      }
      function isWeakMap(value) {
        return isObjectLike2(value) && getTag(value) == weakMapTag;
      }
      function isWeakSet(value) {
        return isObjectLike2(value) && baseGetTag2(value) == weakSetTag;
      }
      var lt2 = createRelationalOperation(baseLt);
      var lte = createRelationalOperation(function(value, other) {
        return value <= other;
      });
      function toArray2(value) {
        if (!value) {
          return [];
        }
        if (isArrayLike2(value)) {
          return isString2(value) ? stringToArray(value) : copyArray(value);
        }
        if (symIterator && value[symIterator]) {
          return iteratorToArray(value[symIterator]());
        }
        var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
        return func(value);
      }
      function toFinite(value) {
        if (!value) {
          return value === 0 ? value : 0;
        }
        value = toNumber2(value);
        if (value === INFINITY || value === -INFINITY) {
          var sign = value < 0 ? -1 : 1;
          return sign * MAX_INTEGER;
        }
        return value === value ? value : 0;
      }
      function toInteger(value) {
        var result2 = toFinite(value), remainder = result2 % 1;
        return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
      }
      function toLength(value) {
        return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
      }
      function toNumber2(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        if (isObject2(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject2(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim2(value);
        var isBinary = reIsBinary2.test(value);
        return isBinary || reIsOctal2.test(value) ? freeParseInt2(value.slice(2), isBinary ? 2 : 8) : reIsBadHex2.test(value) ? NAN2 : +value;
      }
      function toPlainObject(value) {
        return copyObject(value, keysIn(value));
      }
      function toSafeInteger(value) {
        return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER2, MAX_SAFE_INTEGER2) : value === 0 ? value : 0;
      }
      function toString(value) {
        return value == null ? "" : baseToString(value);
      }
      var assign = createAssigner(function(object4, source) {
        if (isPrototype(source) || isArrayLike2(source)) {
          copyObject(source, keys2(source), object4);
          return;
        }
        for (var key in source) {
          if (hasOwnProperty2.call(source, key)) {
            assignValue(object4, key, source[key]);
          }
        }
      });
      var assignIn = createAssigner(function(object4, source) {
        copyObject(source, keysIn(source), object4);
      });
      var assignInWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keysIn(source), object4, customizer);
      });
      var assignWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keys2(source), object4, customizer);
      });
      var at = flatRest(baseAt);
      function create2(prototype, properties) {
        var result2 = baseCreate(prototype);
        return properties == null ? result2 : baseAssign(result2, properties);
      }
      var defaults2 = baseRest(function(object4, sources) {
        object4 = Object2(object4);
        var index2 = -1;
        var length = sources.length;
        var guard = length > 2 ? sources[2] : undefined$1;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          length = 1;
        }
        while (++index2 < length) {
          var source = sources[index2];
          var props = keysIn(source);
          var propsIndex = -1;
          var propsLength = props.length;
          while (++propsIndex < propsLength) {
            var key = props[propsIndex];
            var value = object4[key];
            if (value === undefined$1 || eq(value, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
              object4[key] = source[key];
            }
          }
        }
        return object4;
      });
      var defaultsDeep = baseRest(function(args) {
        args.push(undefined$1, customDefaultsMerge);
        return apply(mergeWith, undefined$1, args);
      });
      function findKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwn);
      }
      function findLastKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwnRight);
      }
      function forIn(object4, iteratee2) {
        return object4 == null ? object4 : baseFor(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forInRight(object4, iteratee2) {
        return object4 == null ? object4 : baseForRight(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forOwn(object4, iteratee2) {
        return object4 && baseForOwn(object4, getIteratee(iteratee2, 3));
      }
      function forOwnRight(object4, iteratee2) {
        return object4 && baseForOwnRight(object4, getIteratee(iteratee2, 3));
      }
      function functions(object4) {
        return object4 == null ? [] : baseFunctions(object4, keys2(object4));
      }
      function functionsIn(object4) {
        return object4 == null ? [] : baseFunctions(object4, keysIn(object4));
      }
      function get2(object4, path, defaultValue) {
        var result2 = object4 == null ? undefined$1 : baseGet(object4, path);
        return result2 === undefined$1 ? defaultValue : result2;
      }
      function has2(object4, path) {
        return object4 != null && hasPath(object4, path, baseHas);
      }
      function hasIn(object4, path) {
        return object4 != null && hasPath(object4, path, baseHasIn);
      }
      var invert2 = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        result2[value] = key;
      }, constant(identity2));
      var invertBy = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        if (hasOwnProperty2.call(result2, value)) {
          result2[value].push(key);
        } else {
          result2[value] = [key];
        }
      }, getIteratee);
      var invoke = baseRest(baseInvoke);
      function keys2(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys(object4) : baseKeys(object4);
      }
      function keysIn(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys(object4, true) : baseKeysIn(object4);
      }
      function mapKeys(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, iteratee2(value, key, object5), value);
        });
        return result2;
      }
      function mapValues(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, key, iteratee2(value, key, object5));
        });
        return result2;
      }
      var merge2 = createAssigner(function(object4, source, srcIndex) {
        baseMerge(object4, source, srcIndex);
      });
      var mergeWith = createAssigner(function(object4, source, srcIndex, customizer) {
        baseMerge(object4, source, srcIndex, customizer);
      });
      var omit = flatRest(function(object4, paths) {
        var result2 = {};
        if (object4 == null) {
          return result2;
        }
        var isDeep = false;
        paths = arrayMap(paths, function(path) {
          path = castPath(path, object4);
          isDeep || (isDeep = path.length > 1);
          return path;
        });
        copyObject(object4, getAllKeysIn(object4), result2);
        if (isDeep) {
          result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
        }
        var length = paths.length;
        while (length--) {
          baseUnset(result2, paths[length]);
        }
        return result2;
      });
      function omitBy(object4, predicate) {
        return pickBy(object4, negate(getIteratee(predicate)));
      }
      var pick = flatRest(function(object4, paths) {
        return object4 == null ? {} : basePick(object4, paths);
      });
      function pickBy(object4, predicate) {
        if (object4 == null) {
          return {};
        }
        var props = arrayMap(getAllKeysIn(object4), function(prop) {
          return [prop];
        });
        predicate = getIteratee(predicate);
        return basePickBy(object4, props, function(value, path) {
          return predicate(value, path[0]);
        });
      }
      function result(object4, path, defaultValue) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length;
        if (!length) {
          length = 1;
          object4 = undefined$1;
        }
        while (++index2 < length) {
          var value = object4 == null ? undefined$1 : object4[toKey(path[index2])];
          if (value === undefined$1) {
            index2 = length;
            value = defaultValue;
          }
          object4 = isFunction2(value) ? value.call(object4) : value;
        }
        return object4;
      }
      function set2(object4, path, value) {
        return object4 == null ? object4 : baseSet(object4, path, value);
      }
      function setWith(object4, path, value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseSet(object4, path, value, customizer);
      }
      var toPairs = createToPairs(keys2);
      var toPairsIn = createToPairs(keysIn);
      function transform2(object4, iteratee2, accumulator) {
        var isArr = isArray2(object4), isArrLike = isArr || isBuffer(object4) || isTypedArray2(object4);
        iteratee2 = getIteratee(iteratee2, 4);
        if (accumulator == null) {
          var Ctor = object4 && object4.constructor;
          if (isArrLike) {
            accumulator = isArr ? new Ctor() : [];
          } else if (isObject2(object4)) {
            accumulator = isFunction2(Ctor) ? baseCreate(getPrototype(object4)) : {};
          } else {
            accumulator = {};
          }
        }
        (isArrLike ? arrayEach : baseForOwn)(object4, function(value, index2, object5) {
          return iteratee2(accumulator, value, index2, object5);
        });
        return accumulator;
      }
      function unset(object4, path) {
        return object4 == null ? true : baseUnset(object4, path);
      }
      function update(object4, path, updater) {
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater));
      }
      function updateWith(object4, path, updater, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater), customizer);
      }
      function values(object4) {
        return object4 == null ? [] : baseValues(object4, keys2(object4));
      }
      function valuesIn(object4) {
        return object4 == null ? [] : baseValues(object4, keysIn(object4));
      }
      function clamp2(number4, lower, upper) {
        if (upper === undefined$1) {
          upper = lower;
          lower = undefined$1;
        }
        if (upper !== undefined$1) {
          upper = toNumber2(upper);
          upper = upper === upper ? upper : 0;
        }
        if (lower !== undefined$1) {
          lower = toNumber2(lower);
          lower = lower === lower ? lower : 0;
        }
        return baseClamp(toNumber2(number4), lower, upper);
      }
      function inRange(number4, start2, end2) {
        start2 = toFinite(start2);
        if (end2 === undefined$1) {
          end2 = start2;
          start2 = 0;
        } else {
          end2 = toFinite(end2);
        }
        number4 = toNumber2(number4);
        return baseInRange(number4, start2, end2);
      }
      function random(lower, upper, floating) {
        if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
          upper = floating = undefined$1;
        }
        if (floating === undefined$1) {
          if (typeof upper == "boolean") {
            floating = upper;
            upper = undefined$1;
          } else if (typeof lower == "boolean") {
            floating = lower;
            lower = undefined$1;
          }
        }
        if (lower === undefined$1 && upper === undefined$1) {
          lower = 0;
          upper = 1;
        } else {
          lower = toFinite(lower);
          if (upper === undefined$1) {
            upper = lower;
            lower = 0;
          } else {
            upper = toFinite(upper);
          }
        }
        if (lower > upper) {
          var temp = lower;
          lower = upper;
          upper = temp;
        }
        if (floating || lower % 1 || upper % 1) {
          var rand = nativeRandom();
          return nativeMin2(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
        }
        return baseRandom(lower, upper);
      }
      var camelCase = createCompounder(function(result2, word, index2) {
        word = word.toLowerCase();
        return result2 + (index2 ? capitalize(word) : word);
      });
      function capitalize(string3) {
        return upperFirst(toString(string3).toLowerCase());
      }
      function deburr(string3) {
        string3 = toString(string3);
        return string3 && string3.replace(reLatin, deburrLetter).replace(reComboMark, "");
      }
      function endsWith(string3, target, position2) {
        string3 = toString(string3);
        target = baseToString(target);
        var length = string3.length;
        position2 = position2 === undefined$1 ? length : baseClamp(toInteger(position2), 0, length);
        var end2 = position2;
        position2 -= target.length;
        return position2 >= 0 && string3.slice(position2, end2) == target;
      }
      function escape(string3) {
        string3 = toString(string3);
        return string3 && reHasUnescapedHtml.test(string3) ? string3.replace(reUnescapedHtml, escapeHtmlChar) : string3;
      }
      function escapeRegExp(string3) {
        string3 = toString(string3);
        return string3 && reHasRegExpChar.test(string3) ? string3.replace(reRegExpChar, "\\$&") : string3;
      }
      var kebabCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "-" : "") + word.toLowerCase();
      });
      var lowerCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toLowerCase();
      });
      var lowerFirst = createCaseFirst("toLowerCase");
      function pad3(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        if (!length || strLength >= length) {
          return string3;
        }
        var mid = (length - strLength) / 2;
        return createPadding(nativeFloor(mid), chars) + string3 + createPadding(nativeCeil(mid), chars);
      }
      function padEnd(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? string3 + createPadding(length - strLength, chars) : string3;
      }
      function padStart(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? createPadding(length - strLength, chars) + string3 : string3;
      }
      function parseInt2(string3, radix, guard) {
        if (guard || radix == null) {
          radix = 0;
        } else if (radix) {
          radix = +radix;
        }
        return nativeParseInt(toString(string3).replace(reTrimStart2, ""), radix || 0);
      }
      function repeat(string3, n2, guard) {
        if (guard ? isIterateeCall(string3, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        return baseRepeat(toString(string3), n2);
      }
      function replace() {
        var args = arguments, string3 = toString(args[0]);
        return args.length < 3 ? string3 : string3.replace(args[1], args[2]);
      }
      var snakeCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "_" : "") + word.toLowerCase();
      });
      function split2(string3, separator, limit) {
        if (limit && typeof limit != "number" && isIterateeCall(string3, separator, limit)) {
          separator = limit = undefined$1;
        }
        limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
        if (!limit) {
          return [];
        }
        string3 = toString(string3);
        if (string3 && (typeof separator == "string" || separator != null && !isRegExp2(separator))) {
          separator = baseToString(separator);
          if (!separator && hasUnicode(string3)) {
            return castSlice(stringToArray(string3), 0, limit);
          }
        }
        return string3.split(separator, limit);
      }
      var startCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + upperFirst(word);
      });
      function startsWith(string3, target, position2) {
        string3 = toString(string3);
        position2 = position2 == null ? 0 : baseClamp(toInteger(position2), 0, string3.length);
        target = baseToString(target);
        return string3.slice(position2, position2 + target.length) == target;
      }
      function template(string3, options, guard) {
        var settings = lodash2.templateSettings;
        if (guard && isIterateeCall(string3, options, guard)) {
          options = undefined$1;
        }
        string3 = toString(string3);
        options = assignInWith({}, options, settings, customDefaultsAssignIn);
        var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys2(imports), importsValues = baseValues(imports, importsKeys);
        var isEscaping, isEvaluating, index2 = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
        var reDelimiters = RegExp2((options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$", "g");
        var sourceURL = "//# sourceURL=" + (hasOwnProperty2.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
        string3.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
          interpolateValue || (interpolateValue = esTemplateValue);
          source += string3.slice(index2, offset).replace(reUnescapedString, escapeStringChar);
          if (escapeValue) {
            isEscaping = true;
            source += "' +\n__e(" + escapeValue + ") +\n'";
          }
          if (evaluateValue) {
            isEvaluating = true;
            source += "';\n" + evaluateValue + ";\n__p += '";
          }
          if (interpolateValue) {
            source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
          }
          index2 = offset + match.length;
          return match;
        });
        source += "';\n";
        var variable = hasOwnProperty2.call(options, "variable") && options.variable;
        if (!variable) {
          source = "with (obj) {\n" + source + "\n}\n";
        } else if (reForbiddenIdentifierChars.test(variable)) {
          throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
        }
        source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
        source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
        var result2 = attempt(function() {
          return Function2(importsKeys, sourceURL + "return " + source).apply(undefined$1, importsValues);
        });
        result2.source = source;
        if (isError(result2)) {
          throw result2;
        }
        return result2;
      }
      function toLower(value) {
        return toString(value).toLowerCase();
      }
      function toUpper(value) {
        return toString(value).toUpperCase();
      }
      function trim2(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return baseTrim2(string3);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), chrSymbols = stringToArray(chars), start2 = charsStartIndex(strSymbols, chrSymbols), end2 = charsEndIndex(strSymbols, chrSymbols) + 1;
        return castSlice(strSymbols, start2, end2).join("");
      }
      function trimEnd(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.slice(0, trimmedEndIndex2(string3) + 1);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), end2 = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
        return castSlice(strSymbols, 0, end2).join("");
      }
      function trimStart(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.replace(reTrimStart2, "");
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), start2 = charsStartIndex(strSymbols, stringToArray(chars));
        return castSlice(strSymbols, start2).join("");
      }
      function truncate(string3, options) {
        var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
        if (isObject2(options)) {
          var separator = "separator" in options ? options.separator : separator;
          length = "length" in options ? toInteger(options.length) : length;
          omission = "omission" in options ? baseToString(options.omission) : omission;
        }
        string3 = toString(string3);
        var strLength = string3.length;
        if (hasUnicode(string3)) {
          var strSymbols = stringToArray(string3);
          strLength = strSymbols.length;
        }
        if (length >= strLength) {
          return string3;
        }
        var end2 = length - stringSize(omission);
        if (end2 < 1) {
          return omission;
        }
        var result2 = strSymbols ? castSlice(strSymbols, 0, end2).join("") : string3.slice(0, end2);
        if (separator === undefined$1) {
          return result2 + omission;
        }
        if (strSymbols) {
          end2 += result2.length - end2;
        }
        if (isRegExp2(separator)) {
          if (string3.slice(end2).search(separator)) {
            var match, substring = result2;
            if (!separator.global) {
              separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
            }
            separator.lastIndex = 0;
            while (match = separator.exec(substring)) {
              var newEnd = match.index;
            }
            result2 = result2.slice(0, newEnd === undefined$1 ? end2 : newEnd);
          }
        } else if (string3.indexOf(baseToString(separator), end2) != end2) {
          var index2 = result2.lastIndexOf(separator);
          if (index2 > -1) {
            result2 = result2.slice(0, index2);
          }
        }
        return result2 + omission;
      }
      function unescape2(string3) {
        string3 = toString(string3);
        return string3 && reHasEscapedHtml.test(string3) ? string3.replace(reEscapedHtml, unescapeHtmlChar) : string3;
      }
      var upperCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toUpperCase();
      });
      var upperFirst = createCaseFirst("toUpperCase");
      function words(string3, pattern4, guard) {
        string3 = toString(string3);
        pattern4 = guard ? undefined$1 : pattern4;
        if (pattern4 === undefined$1) {
          return hasUnicodeWord(string3) ? unicodeWords(string3) : asciiWords(string3);
        }
        return string3.match(pattern4) || [];
      }
      var attempt = baseRest(function(func, args) {
        try {
          return apply(func, undefined$1, args);
        } catch (e2) {
          return isError(e2) ? e2 : new Error2(e2);
        }
      });
      var bindAll = flatRest(function(object4, methodNames) {
        arrayEach(methodNames, function(key) {
          key = toKey(key);
          baseAssignValue(object4, key, bind2(object4[key], object4));
        });
        return object4;
      });
      function cond(pairs) {
        var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
        pairs = !length ? [] : arrayMap(pairs, function(pair) {
          if (typeof pair[1] != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT2);
          }
          return [toIteratee(pair[0]), pair[1]];
        });
        return baseRest(function(args) {
          var index2 = -1;
          while (++index2 < length) {
            var pair = pairs[index2];
            if (apply(pair[0], this, args)) {
              return apply(pair[1], this, args);
            }
          }
        });
      }
      function conforms(source) {
        return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
      }
      function constant(value) {
        return function() {
          return value;
        };
      }
      function defaultTo(value, defaultValue) {
        return value == null || value !== value ? defaultValue : value;
      }
      var flow = createFlow();
      var flowRight = createFlow(true);
      function identity2(value) {
        return value;
      }
      function iteratee(func) {
        return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
      }
      function matches(source) {
        return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
      }
      function matchesProperty(path, srcValue) {
        return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
      }
      var method4 = baseRest(function(path, args) {
        return function(object4) {
          return baseInvoke(object4, path, args);
        };
      });
      var methodOf = baseRest(function(object4, args) {
        return function(path) {
          return baseInvoke(object4, path, args);
        };
      });
      function mixin2(object4, source, options) {
        var props = keys2(source), methodNames = baseFunctions(source, props);
        if (options == null && !(isObject2(source) && (methodNames.length || !props.length))) {
          options = source;
          source = object4;
          object4 = this;
          methodNames = baseFunctions(source, keys2(source));
        }
        var chain2 = !(isObject2(options) && "chain" in options) || !!options.chain, isFunc = isFunction2(object4);
        arrayEach(methodNames, function(methodName) {
          var func = source[methodName];
          object4[methodName] = func;
          if (isFunc) {
            object4.prototype[methodName] = function() {
              var chainAll = this.__chain__;
              if (chain2 || chainAll) {
                var result2 = object4(this.__wrapped__), actions2 = result2.__actions__ = copyArray(this.__actions__);
                actions2.push({ "func": func, "args": arguments, "thisArg": object4 });
                result2.__chain__ = chainAll;
                return result2;
              }
              return func.apply(object4, arrayPush([this.value()], arguments));
            };
          }
        });
        return object4;
      }
      function noConflict() {
        if (root2._ === this) {
          root2._ = oldDash;
        }
        return this;
      }
      function noop2() {
      }
      function nthArg(n2) {
        n2 = toInteger(n2);
        return baseRest(function(args) {
          return baseNth(args, n2);
        });
      }
      var over = createOver(arrayMap);
      var overEvery = createOver(arrayEvery);
      var overSome = createOver(arraySome);
      function property(path) {
        return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
      }
      function propertyOf(object4) {
        return function(path) {
          return object4 == null ? undefined$1 : baseGet(object4, path);
        };
      }
      var range3 = createRange();
      var rangeRight = createRange(true);
      function stubArray() {
        return [];
      }
      function stubFalse() {
        return false;
      }
      function stubObject() {
        return {};
      }
      function stubString() {
        return "";
      }
      function stubTrue() {
        return true;
      }
      function times(n2, iteratee2) {
        n2 = toInteger(n2);
        if (n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return [];
        }
        var index2 = MAX_ARRAY_LENGTH, length = nativeMin2(n2, MAX_ARRAY_LENGTH);
        iteratee2 = getIteratee(iteratee2);
        n2 -= MAX_ARRAY_LENGTH;
        var result2 = baseTimes(length, iteratee2);
        while (++index2 < n2) {
          iteratee2(index2);
        }
        return result2;
      }
      function toPath(value) {
        if (isArray2(value)) {
          return arrayMap(value, toKey);
        }
        return isSymbol2(value) ? [value] : copyArray(stringToPath(toString(value)));
      }
      function uniqueId(prefix) {
        var id2 = ++idCounter;
        return toString(prefix) + id2;
      }
      var add2 = createMathOperation(function(augend, addend) {
        return augend + addend;
      }, 0);
      var ceil = createRound("ceil");
      var divide = createMathOperation(function(dividend, divisor) {
        return dividend / divisor;
      }, 1);
      var floor = createRound("floor");
      function max3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseGt) : undefined$1;
      }
      function maxBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseGt) : undefined$1;
      }
      function mean(array4) {
        return baseMean(array4, identity2);
      }
      function meanBy(array4, iteratee2) {
        return baseMean(array4, getIteratee(iteratee2, 2));
      }
      function min3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseLt) : undefined$1;
      }
      function minBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseLt) : undefined$1;
      }
      var multiply = createMathOperation(function(multiplier, multiplicand) {
        return multiplier * multiplicand;
      }, 1);
      var round2 = createRound("round");
      var subtract = createMathOperation(function(minuend, subtrahend) {
        return minuend - subtrahend;
      }, 0);
      function sum2(array4) {
        return array4 && array4.length ? baseSum(array4, identity2) : 0;
      }
      function sumBy(array4, iteratee2) {
        return array4 && array4.length ? baseSum(array4, getIteratee(iteratee2, 2)) : 0;
      }
      lodash2.after = after;
      lodash2.ary = ary;
      lodash2.assign = assign;
      lodash2.assignIn = assignIn;
      lodash2.assignInWith = assignInWith;
      lodash2.assignWith = assignWith;
      lodash2.at = at;
      lodash2.before = before;
      lodash2.bind = bind2;
      lodash2.bindAll = bindAll;
      lodash2.bindKey = bindKey;
      lodash2.castArray = castArray;
      lodash2.chain = chain;
      lodash2.chunk = chunk;
      lodash2.compact = compact;
      lodash2.concat = concat;
      lodash2.cond = cond;
      lodash2.conforms = conforms;
      lodash2.constant = constant;
      lodash2.countBy = countBy;
      lodash2.create = create2;
      lodash2.curry = curry2;
      lodash2.curryRight = curryRight;
      lodash2.debounce = debounce2;
      lodash2.defaults = defaults2;
      lodash2.defaultsDeep = defaultsDeep;
      lodash2.defer = defer;
      lodash2.delay = delay;
      lodash2.difference = difference;
      lodash2.differenceBy = differenceBy;
      lodash2.differenceWith = differenceWith;
      lodash2.drop = drop;
      lodash2.dropRight = dropRight;
      lodash2.dropRightWhile = dropRightWhile;
      lodash2.dropWhile = dropWhile;
      lodash2.fill = fill;
      lodash2.filter = filter2;
      lodash2.flatMap = flatMap;
      lodash2.flatMapDeep = flatMapDeep;
      lodash2.flatMapDepth = flatMapDepth;
      lodash2.flatten = flatten;
      lodash2.flattenDeep = flattenDeep;
      lodash2.flattenDepth = flattenDepth;
      lodash2.flip = flip;
      lodash2.flow = flow;
      lodash2.flowRight = flowRight;
      lodash2.fromPairs = fromPairs;
      lodash2.functions = functions;
      lodash2.functionsIn = functionsIn;
      lodash2.groupBy = groupBy;
      lodash2.initial = initial;
      lodash2.intersection = intersection;
      lodash2.intersectionBy = intersectionBy;
      lodash2.intersectionWith = intersectionWith;
      lodash2.invert = invert2;
      lodash2.invertBy = invertBy;
      lodash2.invokeMap = invokeMap;
      lodash2.iteratee = iteratee;
      lodash2.keyBy = keyBy;
      lodash2.keys = keys2;
      lodash2.keysIn = keysIn;
      lodash2.map = map2;
      lodash2.mapKeys = mapKeys;
      lodash2.mapValues = mapValues;
      lodash2.matches = matches;
      lodash2.matchesProperty = matchesProperty;
      lodash2.memoize = memoize;
      lodash2.merge = merge2;
      lodash2.mergeWith = mergeWith;
      lodash2.method = method4;
      lodash2.methodOf = methodOf;
      lodash2.mixin = mixin2;
      lodash2.negate = negate;
      lodash2.nthArg = nthArg;
      lodash2.omit = omit;
      lodash2.omitBy = omitBy;
      lodash2.once = once;
      lodash2.orderBy = orderBy;
      lodash2.over = over;
      lodash2.overArgs = overArgs;
      lodash2.overEvery = overEvery;
      lodash2.overSome = overSome;
      lodash2.partial = partial;
      lodash2.partialRight = partialRight;
      lodash2.partition = partition;
      lodash2.pick = pick;
      lodash2.pickBy = pickBy;
      lodash2.property = property;
      lodash2.propertyOf = propertyOf;
      lodash2.pull = pull;
      lodash2.pullAll = pullAll;
      lodash2.pullAllBy = pullAllBy;
      lodash2.pullAllWith = pullAllWith;
      lodash2.pullAt = pullAt;
      lodash2.range = range3;
      lodash2.rangeRight = rangeRight;
      lodash2.rearg = rearg;
      lodash2.reject = reject;
      lodash2.remove = remove;
      lodash2.rest = rest;
      lodash2.reverse = reverse2;
      lodash2.sampleSize = sampleSize;
      lodash2.set = set2;
      lodash2.setWith = setWith;
      lodash2.shuffle = shuffle;
      lodash2.slice = slice2;
      lodash2.sortBy = sortBy;
      lodash2.sortedUniq = sortedUniq;
      lodash2.sortedUniqBy = sortedUniqBy;
      lodash2.split = split2;
      lodash2.spread = spread;
      lodash2.tail = tail;
      lodash2.take = take2;
      lodash2.takeRight = takeRight;
      lodash2.takeRightWhile = takeRightWhile;
      lodash2.takeWhile = takeWhile;
      lodash2.tap = tap;
      lodash2.throttle = throttle2;
      lodash2.thru = thru;
      lodash2.toArray = toArray2;
      lodash2.toPairs = toPairs;
      lodash2.toPairsIn = toPairsIn;
      lodash2.toPath = toPath;
      lodash2.toPlainObject = toPlainObject;
      lodash2.transform = transform2;
      lodash2.unary = unary;
      lodash2.union = union;
      lodash2.unionBy = unionBy;
      lodash2.unionWith = unionWith;
      lodash2.uniq = uniq;
      lodash2.uniqBy = uniqBy;
      lodash2.uniqWith = uniqWith;
      lodash2.unset = unset;
      lodash2.unzip = unzip;
      lodash2.unzipWith = unzipWith;
      lodash2.update = update;
      lodash2.updateWith = updateWith;
      lodash2.values = values;
      lodash2.valuesIn = valuesIn;
      lodash2.without = without;
      lodash2.words = words;
      lodash2.wrap = wrap;
      lodash2.xor = xor;
      lodash2.xorBy = xorBy;
      lodash2.xorWith = xorWith;
      lodash2.zip = zip;
      lodash2.zipObject = zipObject;
      lodash2.zipObjectDeep = zipObjectDeep;
      lodash2.zipWith = zipWith;
      lodash2.entries = toPairs;
      lodash2.entriesIn = toPairsIn;
      lodash2.extend = assignIn;
      lodash2.extendWith = assignInWith;
      mixin2(lodash2, lodash2);
      lodash2.add = add2;
      lodash2.attempt = attempt;
      lodash2.camelCase = camelCase;
      lodash2.capitalize = capitalize;
      lodash2.ceil = ceil;
      lodash2.clamp = clamp2;
      lodash2.clone = clone2;
      lodash2.cloneDeep = cloneDeep;
      lodash2.cloneDeepWith = cloneDeepWith;
      lodash2.cloneWith = cloneWith;
      lodash2.conformsTo = conformsTo;
      lodash2.deburr = deburr;
      lodash2.defaultTo = defaultTo;
      lodash2.divide = divide;
      lodash2.endsWith = endsWith;
      lodash2.eq = eq;
      lodash2.escape = escape;
      lodash2.escapeRegExp = escapeRegExp;
      lodash2.every = every;
      lodash2.find = find2;
      lodash2.findIndex = findIndex;
      lodash2.findKey = findKey;
      lodash2.findLast = findLast;
      lodash2.findLastIndex = findLastIndex;
      lodash2.findLastKey = findLastKey;
      lodash2.floor = floor;
      lodash2.forEach = forEach;
      lodash2.forEachRight = forEachRight;
      lodash2.forIn = forIn;
      lodash2.forInRight = forInRight;
      lodash2.forOwn = forOwn;
      lodash2.forOwnRight = forOwnRight;
      lodash2.get = get2;
      lodash2.gt = gt;
      lodash2.gte = gte;
      lodash2.has = has2;
      lodash2.hasIn = hasIn;
      lodash2.head = head;
      lodash2.identity = identity2;
      lodash2.includes = includes;
      lodash2.indexOf = indexOf2;
      lodash2.inRange = inRange;
      lodash2.invoke = invoke;
      lodash2.isArguments = isArguments;
      lodash2.isArray = isArray2;
      lodash2.isArrayBuffer = isArrayBuffer;
      lodash2.isArrayLike = isArrayLike2;
      lodash2.isArrayLikeObject = isArrayLikeObject;
      lodash2.isBoolean = isBoolean;
      lodash2.isBuffer = isBuffer;
      lodash2.isDate = isDate;
      lodash2.isElement = isElement;
      lodash2.isEmpty = isEmpty;
      lodash2.isEqual = isEqual;
      lodash2.isEqualWith = isEqualWith;
      lodash2.isError = isError;
      lodash2.isFinite = isFinite2;
      lodash2.isFunction = isFunction2;
      lodash2.isInteger = isInteger;
      lodash2.isLength = isLength;
      lodash2.isMap = isMap;
      lodash2.isMatch = isMatch;
      lodash2.isMatchWith = isMatchWith;
      lodash2.isNaN = isNaN2;
      lodash2.isNative = isNative;
      lodash2.isNil = isNil;
      lodash2.isNull = isNull;
      lodash2.isNumber = isNumber2;
      lodash2.isObject = isObject2;
      lodash2.isObjectLike = isObjectLike2;
      lodash2.isPlainObject = isPlainObject;
      lodash2.isRegExp = isRegExp2;
      lodash2.isSafeInteger = isSafeInteger;
      lodash2.isSet = isSet;
      lodash2.isString = isString2;
      lodash2.isSymbol = isSymbol2;
      lodash2.isTypedArray = isTypedArray2;
      lodash2.isUndefined = isUndefined;
      lodash2.isWeakMap = isWeakMap;
      lodash2.isWeakSet = isWeakSet;
      lodash2.join = join;
      lodash2.kebabCase = kebabCase;
      lodash2.last = last;
      lodash2.lastIndexOf = lastIndexOf;
      lodash2.lowerCase = lowerCase;
      lodash2.lowerFirst = lowerFirst;
      lodash2.lt = lt2;
      lodash2.lte = lte;
      lodash2.max = max3;
      lodash2.maxBy = maxBy;
      lodash2.mean = mean;
      lodash2.meanBy = meanBy;
      lodash2.min = min3;
      lodash2.minBy = minBy;
      lodash2.stubArray = stubArray;
      lodash2.stubFalse = stubFalse;
      lodash2.stubObject = stubObject;
      lodash2.stubString = stubString;
      lodash2.stubTrue = stubTrue;
      lodash2.multiply = multiply;
      lodash2.nth = nth;
      lodash2.noConflict = noConflict;
      lodash2.noop = noop2;
      lodash2.now = now2;
      lodash2.pad = pad3;
      lodash2.padEnd = padEnd;
      lodash2.padStart = padStart;
      lodash2.parseInt = parseInt2;
      lodash2.random = random;
      lodash2.reduce = reduce2;
      lodash2.reduceRight = reduceRight;
      lodash2.repeat = repeat;
      lodash2.replace = replace;
      lodash2.result = result;
      lodash2.round = round2;
      lodash2.runInContext = runInContext2;
      lodash2.sample = sample;
      lodash2.size = size;
      lodash2.snakeCase = snakeCase;
      lodash2.some = some;
      lodash2.sortedIndex = sortedIndex;
      lodash2.sortedIndexBy = sortedIndexBy;
      lodash2.sortedIndexOf = sortedIndexOf;
      lodash2.sortedLastIndex = sortedLastIndex;
      lodash2.sortedLastIndexBy = sortedLastIndexBy;
      lodash2.sortedLastIndexOf = sortedLastIndexOf;
      lodash2.startCase = startCase;
      lodash2.startsWith = startsWith;
      lodash2.subtract = subtract;
      lodash2.sum = sum2;
      lodash2.sumBy = sumBy;
      lodash2.template = template;
      lodash2.times = times;
      lodash2.toFinite = toFinite;
      lodash2.toInteger = toInteger;
      lodash2.toLength = toLength;
      lodash2.toLower = toLower;
      lodash2.toNumber = toNumber2;
      lodash2.toSafeInteger = toSafeInteger;
      lodash2.toString = toString;
      lodash2.toUpper = toUpper;
      lodash2.trim = trim2;
      lodash2.trimEnd = trimEnd;
      lodash2.trimStart = trimStart;
      lodash2.truncate = truncate;
      lodash2.unescape = unescape2;
      lodash2.uniqueId = uniqueId;
      lodash2.upperCase = upperCase;
      lodash2.upperFirst = upperFirst;
      lodash2.each = forEach;
      lodash2.eachRight = forEachRight;
      lodash2.first = head;
      mixin2(lodash2, function() {
        var source = {};
        baseForOwn(lodash2, function(func, methodName) {
          if (!hasOwnProperty2.call(lodash2.prototype, methodName)) {
            source[methodName] = func;
          }
        });
        return source;
      }(), { "chain": false });
      lodash2.VERSION = VERSION;
      arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
        lodash2[methodName].placeholder = lodash2;
      });
      arrayEach(["drop", "take"], function(methodName, index2) {
        LazyWrapper.prototype[methodName] = function(n2) {
          n2 = n2 === undefined$1 ? 1 : nativeMax2(toInteger(n2), 0);
          var result2 = this.__filtered__ && !index2 ? new LazyWrapper(this) : this.clone();
          if (result2.__filtered__) {
            result2.__takeCount__ = nativeMin2(n2, result2.__takeCount__);
          } else {
            result2.__views__.push({
              "size": nativeMin2(n2, MAX_ARRAY_LENGTH),
              "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
            });
          }
          return result2;
        };
        LazyWrapper.prototype[methodName + "Right"] = function(n2) {
          return this.reverse()[methodName](n2).reverse();
        };
      });
      arrayEach(["filter", "map", "takeWhile"], function(methodName, index2) {
        var type4 = index2 + 1, isFilter = type4 == LAZY_FILTER_FLAG || type4 == LAZY_WHILE_FLAG;
        LazyWrapper.prototype[methodName] = function(iteratee2) {
          var result2 = this.clone();
          result2.__iteratees__.push({
            "iteratee": getIteratee(iteratee2, 3),
            "type": type4
          });
          result2.__filtered__ = result2.__filtered__ || isFilter;
          return result2;
        };
      });
      arrayEach(["head", "last"], function(methodName, index2) {
        var takeName = "take" + (index2 ? "Right" : "");
        LazyWrapper.prototype[methodName] = function() {
          return this[takeName](1).value()[0];
        };
      });
      arrayEach(["initial", "tail"], function(methodName, index2) {
        var dropName = "drop" + (index2 ? "" : "Right");
        LazyWrapper.prototype[methodName] = function() {
          return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
        };
      });
      LazyWrapper.prototype.compact = function() {
        return this.filter(identity2);
      };
      LazyWrapper.prototype.find = function(predicate) {
        return this.filter(predicate).head();
      };
      LazyWrapper.prototype.findLast = function(predicate) {
        return this.reverse().find(predicate);
      };
      LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
        if (typeof path == "function") {
          return new LazyWrapper(this);
        }
        return this.map(function(value) {
          return baseInvoke(value, path, args);
        });
      });
      LazyWrapper.prototype.reject = function(predicate) {
        return this.filter(negate(getIteratee(predicate)));
      };
      LazyWrapper.prototype.slice = function(start2, end2) {
        start2 = toInteger(start2);
        var result2 = this;
        if (result2.__filtered__ && (start2 > 0 || end2 < 0)) {
          return new LazyWrapper(result2);
        }
        if (start2 < 0) {
          result2 = result2.takeRight(-start2);
        } else if (start2) {
          result2 = result2.drop(start2);
        }
        if (end2 !== undefined$1) {
          end2 = toInteger(end2);
          result2 = end2 < 0 ? result2.dropRight(-end2) : result2.take(end2 - start2);
        }
        return result2;
      };
      LazyWrapper.prototype.takeRightWhile = function(predicate) {
        return this.reverse().takeWhile(predicate).reverse();
      };
      LazyWrapper.prototype.toArray = function() {
        return this.take(MAX_ARRAY_LENGTH);
      };
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash2[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
        if (!lodashFunc) {
          return;
        }
        lodash2.prototype[methodName] = function() {
          var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray2(value);
          var interceptor = function(value2) {
            var result3 = lodashFunc.apply(lodash2, arrayPush([value2], args));
            return isTaker && chainAll ? result3[0] : result3;
          };
          if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
            isLazy = useLazy = false;
          }
          var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
          if (!retUnwrapped && useLazy) {
            value = onlyLazy ? value : new LazyWrapper(this);
            var result2 = func.apply(value, args);
            result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined$1 });
            return new LodashWrapper(result2, chainAll);
          }
          if (isUnwrapped && onlyLazy) {
            return func.apply(this, args);
          }
          result2 = this.thru(interceptor);
          return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
        };
      });
      arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
        var func = arrayProto2[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
        lodash2.prototype[methodName] = function() {
          var args = arguments;
          if (retUnwrapped && !this.__chain__) {
            var value = this.value();
            return func.apply(isArray2(value) ? value : [], args);
          }
          return this[chainName](function(value2) {
            return func.apply(isArray2(value2) ? value2 : [], args);
          });
        };
      });
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var lodashFunc = lodash2[methodName];
        if (lodashFunc) {
          var key = lodashFunc.name + "";
          if (!hasOwnProperty2.call(realNames, key)) {
            realNames[key] = [];
          }
          realNames[key].push({ "name": methodName, "func": lodashFunc });
        }
      });
      realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
        "name": "wrapper",
        "func": undefined$1
      }];
      LazyWrapper.prototype.clone = lazyClone;
      LazyWrapper.prototype.reverse = lazyReverse;
      LazyWrapper.prototype.value = lazyValue;
      lodash2.prototype.at = wrapperAt;
      lodash2.prototype.chain = wrapperChain;
      lodash2.prototype.commit = wrapperCommit;
      lodash2.prototype.next = wrapperNext;
      lodash2.prototype.plant = wrapperPlant;
      lodash2.prototype.reverse = wrapperReverse;
      lodash2.prototype.toJSON = lodash2.prototype.valueOf = lodash2.prototype.value = wrapperValue;
      lodash2.prototype.first = lodash2.prototype.head;
      if (symIterator) {
        lodash2.prototype[symIterator] = wrapperToIterator;
      }
      return lodash2;
    };
    var _ = runInContext();
    if (freeModule) {
      (freeModule.exports = _)._ = _;
      freeExports._ = _;
    } else {
      root2._ = _;
    }
  }).call(commonjsGlobal);
})(lodash, lodash.exports);
class EventEmitter {
  constructor() {
    __publicField(this, "subscriptions", /* @__PURE__ */ new Map());
    __publicField(this, "emitEffectCache", /* @__PURE__ */ new Map());
    __publicField(this, "useSubscription", (event, listener) => {
      const callbackRef = useRef();
      useEffect(() => {
        var _a2, _b2;
        callbackRef.current = listener;
        function subscription(val) {
          if (callbackRef.current) {
            callbackRef.current(val);
          }
        }
        const subscriptions = (_b2 = (_a2 = this.subscriptions) == null ? void 0 : _a2.get(event)) != null ? _b2 : [];
        subscriptions.push(subscription);
        this.subscriptions.set(event, subscriptions);
        this.emitEffect(event);
        return () => {
          this.subscriptions.delete(event);
        };
      }, []);
    });
    __publicField(this, "emit", (event, ...args) => {
      if (typeof event === "string" || typeof event === "number") {
        const subscriptionValuesCallback = this.subscriptions.get(event);
        subscriptionValuesCallback == null ? void 0 : subscriptionValuesCallback.forEach((callback) => {
          callback == null ? void 0 : callback({
            params: lodash.exports.cloneDeep(args),
            event
          });
        });
        this.emitEffectCache.set(event, {
          params: lodash.exports.cloneDeep(args),
          event
        });
      } else
        throw new TypeError("event must be string or number !");
    });
    __publicField(this, "emitEffect", (event) => {
      const emitEffectCache = this.emitEffectCache.get(event);
      const listeners = this.subscriptions.get(event);
      if (emitEffectCache)
        listeners == null ? void 0 : listeners.forEach((listener) => {
          listener == null ? void 0 : listener(__spreadValues({}, emitEffectCache));
        });
    });
    __publicField(this, "removeListener", (event) => {
      this.subscriptions.delete(event);
    });
    __publicField(this, "clear", () => {
      this.subscriptions.clear();
    });
    this.clear();
  }
}
const eventEmitterOverall = new EventEmitter();
function useEventEmitter(options) {
  const ref = useRef();
  const eventEmitterOptions = useMemo(() => options != null ? options : { global: false }, [options]);
  if (!ref.current) {
    ref.current = eventEmitterOptions.global ? ref.current = eventEmitterOverall : ref.current = new EventEmitter();
  }
  useEffect(() => {
    return () => {
      var _a2;
      return (_a2 = ref.current) == null ? void 0 : _a2.clear();
    };
  }, []);
  return ref.current;
}
const useEchartsTool = ({
  id: id2,
  title,
  chart,
  option
}, deps) => {
  const ref = useRef(_Charts);
  const event = useEventEmitter({ global: true });
  useDebounceEffect(() => {
    console.log("id", id2);
    console.log("chart", chart == null ? void 0 : chart.current);
    if (ref.current && (chart == null ? void 0 : chart.current) && id2 && option) {
      ref.current.add(id2, chart == null ? void 0 : chart.current, option, title);
      event.emit("list");
    }
  }, deps != null ? deps : [], {
    wait: 100
  });
  return { tool: ref.current };
};
var IconContext = /* @__PURE__ */ createContext({});
var IconContext$1 = IconContext;
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
    })), keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null)
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _arrayLikeToArray(arr, len2) {
  if (len2 == null || len2 > arr.length)
    len2 = arr.length;
  for (var i = 0, arr2 = new Array(len2); i < len2; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray(o, minLen);
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
var classnames = { exports: {} };
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
(function(module) {
  (function() {
    var hasOwn2 = {}.hasOwnProperty;
    function classNames2() {
      var classes = [];
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (!arg)
          continue;
        var argType = typeof arg;
        if (argType === "string" || argType === "number") {
          classes.push(arg);
        } else if (Array.isArray(arg)) {
          if (arg.length) {
            var inner2 = classNames2.apply(null, arg);
            if (inner2) {
              classes.push(inner2);
            }
          }
        } else if (argType === "object") {
          if (arg.toString === Object.prototype.toString) {
            for (var key in arg) {
              if (hasOwn2.call(arg, key) && arg[key]) {
                classes.push(key);
              }
            }
          } else {
            classes.push(arg.toString());
          }
        }
      }
      return classes.join(" ");
    }
    if (module.exports) {
      classNames2.default = classNames2;
      module.exports = classNames2;
    } else {
      window.classNames = classNames2;
    }
  })();
})(classnames);
var classNames = classnames.exports;
function _typeof(obj) {
  "@babel/helpers - typeof";
  return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && typeof Symbol == "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
function bound01(n2, max3) {
  if (isOnePointZero(n2)) {
    n2 = "100%";
  }
  var isPercent = isPercentage(n2);
  n2 = max3 === 360 ? n2 : Math.min(max3, Math.max(0, parseFloat(n2)));
  if (isPercent) {
    n2 = parseInt(String(n2 * max3), 10) / 100;
  }
  if (Math.abs(n2 - max3) < 1e-6) {
    return 1;
  }
  if (max3 === 360) {
    n2 = (n2 < 0 ? n2 % max3 + max3 : n2 % max3) / parseFloat(String(max3));
  } else {
    n2 = n2 % max3 / parseFloat(String(max3));
  }
  return n2;
}
function isOnePointZero(n2) {
  return typeof n2 === "string" && n2.indexOf(".") !== -1 && parseFloat(n2) === 1;
}
function isPercentage(n2) {
  return typeof n2 === "string" && n2.indexOf("%") !== -1;
}
function boundAlpha(a) {
  a = parseFloat(a);
  if (isNaN(a) || a < 0 || a > 1) {
    a = 1;
  }
  return a;
}
function convertToPercentage(n2) {
  if (n2 <= 1) {
    return Number(n2) * 100 + "%";
  }
  return n2;
}
function pad2(c2) {
  return c2.length === 1 ? "0" + c2 : String(c2);
}
function rgbToRgb(r2, g2, b2) {
  return {
    r: bound01(r2, 255) * 255,
    g: bound01(g2, 255) * 255,
    b: bound01(b2, 255) * 255
  };
}
function hue2rgb(p2, q2, t2) {
  if (t2 < 0) {
    t2 += 1;
  }
  if (t2 > 1) {
    t2 -= 1;
  }
  if (t2 < 1 / 6) {
    return p2 + (q2 - p2) * (6 * t2);
  }
  if (t2 < 1 / 2) {
    return q2;
  }
  if (t2 < 2 / 3) {
    return p2 + (q2 - p2) * (2 / 3 - t2) * 6;
  }
  return p2;
}
function hslToRgb(h, s, l2) {
  var r2;
  var g2;
  var b2;
  h = bound01(h, 360);
  s = bound01(s, 100);
  l2 = bound01(l2, 100);
  if (s === 0) {
    g2 = l2;
    b2 = l2;
    r2 = l2;
  } else {
    var q2 = l2 < 0.5 ? l2 * (1 + s) : l2 + s - l2 * s;
    var p2 = 2 * l2 - q2;
    r2 = hue2rgb(p2, q2, h + 1 / 3);
    g2 = hue2rgb(p2, q2, h);
    b2 = hue2rgb(p2, q2, h - 1 / 3);
  }
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHsv(r2, g2, b2) {
  r2 = bound01(r2, 255);
  g2 = bound01(g2, 255);
  b2 = bound01(b2, 255);
  var max3 = Math.max(r2, g2, b2);
  var min3 = Math.min(r2, g2, b2);
  var h = 0;
  var v4 = max3;
  var d2 = max3 - min3;
  var s = max3 === 0 ? 0 : d2 / max3;
  if (max3 === min3) {
    h = 0;
  } else {
    switch (max3) {
      case r2:
        h = (g2 - b2) / d2 + (g2 < b2 ? 6 : 0);
        break;
      case g2:
        h = (b2 - r2) / d2 + 2;
        break;
      case b2:
        h = (r2 - g2) / d2 + 4;
        break;
    }
    h /= 6;
  }
  return { h, s, v: v4 };
}
function hsvToRgb(h, s, v4) {
  h = bound01(h, 360) * 6;
  s = bound01(s, 100);
  v4 = bound01(v4, 100);
  var i = Math.floor(h);
  var f2 = h - i;
  var p2 = v4 * (1 - s);
  var q2 = v4 * (1 - f2 * s);
  var t2 = v4 * (1 - (1 - f2) * s);
  var mod = i % 6;
  var r2 = [v4, q2, p2, p2, t2, v4][mod];
  var g2 = [t2, v4, v4, q2, p2, p2][mod];
  var b2 = [p2, p2, t2, v4, v4, q2][mod];
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHex(r2, g2, b2, allow3Char) {
  var hex2 = [
    pad2(Math.round(r2).toString(16)),
    pad2(Math.round(g2).toString(16)),
    pad2(Math.round(b2).toString(16))
  ];
  if (allow3Char && hex2[0].startsWith(hex2[0].charAt(1)) && hex2[1].startsWith(hex2[1].charAt(1)) && hex2[2].startsWith(hex2[2].charAt(1))) {
    return hex2[0].charAt(0) + hex2[1].charAt(0) + hex2[2].charAt(0);
  }
  return hex2.join("");
}
function convertHexToDecimal(h) {
  return parseIntFromHex(h) / 255;
}
function parseIntFromHex(val) {
  return parseInt(val, 16);
}
var names = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function inputToRGB(color) {
  var rgb = { r: 0, g: 0, b: 0 };
  var a = 1;
  var s = null;
  var v4 = null;
  var l2 = null;
  var ok = false;
  var format2 = false;
  if (typeof color === "string") {
    color = stringInputToObject(color);
  }
  if (typeof color === "object") {
    if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
      rgb = rgbToRgb(color.r, color.g, color.b);
      ok = true;
      format2 = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
      s = convertToPercentage(color.s);
      v4 = convertToPercentage(color.v);
      rgb = hsvToRgb(color.h, s, v4);
      ok = true;
      format2 = "hsv";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
      s = convertToPercentage(color.s);
      l2 = convertToPercentage(color.l);
      rgb = hslToRgb(color.h, s, l2);
      ok = true;
      format2 = "hsl";
    }
    if (Object.prototype.hasOwnProperty.call(color, "a")) {
      a = color.a;
    }
  }
  a = boundAlpha(a);
  return {
    ok,
    format: color.format || format2,
    r: Math.min(255, Math.max(rgb.r, 0)),
    g: Math.min(255, Math.max(rgb.g, 0)),
    b: Math.min(255, Math.max(rgb.b, 0)),
    a
  };
}
var CSS_INTEGER = "[-\\+]?\\d+%?";
var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
  CSS_UNIT: new RegExp(CSS_UNIT),
  rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
  rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
  hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
  hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
  hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
  hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
  hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
  hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
};
function stringInputToObject(color) {
  color = color.trim().toLowerCase();
  if (color.length === 0) {
    return false;
  }
  var named = false;
  if (names[color]) {
    color = names[color];
    named = true;
  } else if (color === "transparent") {
    return { r: 0, g: 0, b: 0, a: 0, format: "name" };
  }
  var match = matchers.rgb.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3] };
  }
  match = matchers.rgba.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3], a: match[4] };
  }
  match = matchers.hsl.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3] };
  }
  match = matchers.hsla.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3], a: match[4] };
  }
  match = matchers.hsv.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3] };
  }
  match = matchers.hsva.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3], a: match[4] };
  }
  match = matchers.hex8.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      a: convertHexToDecimal(match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex6.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      format: named ? "name" : "hex"
    };
  }
  match = matchers.hex4.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      a: convertHexToDecimal(match[4] + match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex3.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      format: named ? "name" : "hex"
    };
  }
  return false;
}
function isValidCSSUnit(color) {
  return Boolean(matchers.CSS_UNIT.exec(String(color)));
}
var hueStep = 2;
var saturationStep = 0.16;
var saturationStep2 = 0.05;
var brightnessStep1 = 0.05;
var brightnessStep2 = 0.15;
var lightColorCount = 5;
var darkColorCount = 4;
var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];
function toHsv(_ref) {
  var r2 = _ref.r, g2 = _ref.g, b2 = _ref.b;
  var hsv = rgbToHsv(r2, g2, b2);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
}
function toHex(_ref2) {
  var r2 = _ref2.r, g2 = _ref2.g, b2 = _ref2.b;
  return "#".concat(rgbToHex(r2, g2, b2, false));
}
function mix(rgb1, rgb2, amount) {
  var p2 = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p2 + rgb1.r,
    g: (rgb2.g - rgb1.g) * p2 + rgb1.g,
    b: (rgb2.b - rgb1.b) * p2 + rgb1.b
  };
  return rgb;
}
function getHue(hsv, i, light) {
  var hue;
  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }
  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }
  return hue;
}
function getSaturation(hsv, i, light) {
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }
  var saturation;
  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  }
  if (saturation > 1) {
    saturation = 1;
  }
  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }
  if (saturation < 0.06) {
    saturation = 0.06;
  }
  return Number(saturation.toFixed(2));
}
function getValue$2(hsv, i, light) {
  var value;
  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }
  if (value > 1) {
    value = 1;
  }
  return Number(value.toFixed(2));
}
function generate$1(color) {
  var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);
  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue$2(hsv, i, true)
    }));
    patterns.push(colorString);
  }
  patterns.push(toHex(pColor));
  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);
    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue$2(_hsv, _i)
    }));
    patterns.push(_colorString);
  }
  if (opts.theme === "dark") {
    return darkColorMap.map(function(_ref3) {
      var index2 = _ref3.index, opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || "#141414"), inputToRGB(patterns[index2]), opacity * 100));
      return darkColorString;
    });
  }
  return patterns;
}
var presetPrimaryColors = {
  red: "#F5222D",
  volcano: "#FA541C",
  orange: "#FA8C16",
  gold: "#FAAD14",
  yellow: "#FADB14",
  lime: "#A0D911",
  green: "#52C41A",
  cyan: "#13C2C2",
  blue: "#1890FF",
  geekblue: "#2F54EB",
  purple: "#722ED1",
  magenta: "#EB2F96",
  grey: "#666666"
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function(key) {
  presetPalettes[key] = generate$1(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5];
  presetDarkPalettes[key] = generate$1(presetPrimaryColors[key], {
    theme: "dark",
    backgroundColor: "#141414"
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
presetPalettes.red;
presetPalettes.volcano;
presetPalettes.gold;
presetPalettes.orange;
presetPalettes.yellow;
presetPalettes.lime;
presetPalettes.green;
presetPalettes.cyan;
presetPalettes.blue;
presetPalettes.geekblue;
presetPalettes.purple;
presetPalettes.magenta;
presetPalettes.grey;
var warned = {};
function warning$2(valid, message) {
}
function call(method4, valid, message) {
  if (!valid && !warned[message]) {
    method4(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning$2, valid, message);
}
function canUseDom() {
  return !!(typeof window !== "undefined" && window.document && window.document.createElement);
}
var MARK_KEY = "rc-util-key";
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, mark = _ref.mark;
  if (mark) {
    return mark.startsWith("data-") ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector("head");
  return head || document.body;
}
function injectCSS(css) {
  var _option$csp;
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var styleNode = document.createElement("style");
  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;
    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }
  styleNode.innerHTML = css;
  var container2 = getContainer(option);
  var firstChild = container2.firstChild;
  if (option.prepend && container2.prepend) {
    container2.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    container2.insertBefore(styleNode, firstChild);
  } else {
    container2.appendChild(styleNode);
  }
  return styleNode;
}
var containerCache = /* @__PURE__ */ new Map();
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var container2 = getContainer(option);
  return Array.from(containerCache.get(container2).children).find(function(node) {
    return node.tagName === "STYLE" && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var container2 = getContainer(option);
  if (!containerCache.has(container2)) {
    var placeholderStyle = injectCSS("", option);
    var parentNode2 = placeholderStyle.parentNode;
    containerCache.set(container2, parentNode2);
    parentNode2.removeChild(placeholderStyle);
  }
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp3, _option$csp4;
    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;
      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }
    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }
    return existNode;
  }
  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}
function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof(target) === "object" && typeof target.name === "string" && typeof target.theme === "string" && (_typeof(target.icon) === "object" || typeof target.icon === "function");
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return Object.keys(attrs).reduce(function(acc, key) {
    var val = attrs[key];
    switch (key) {
      case "class":
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate(node, key, rootProps) {
  if (!rootProps) {
    return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2({
      key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function(child, index2) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
    }));
  }
  return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2(_objectSpread2({
    key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function(child, index2) {
    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
  }));
}
function getSecondaryColor(primaryColor) {
  return generate$1(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles2() {
  var styleStr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : iconStyles;
  var _useContext = useContext(IconContext$1), csp = _useContext.csp;
  useEffect(function() {
    updateCSS(styleStr, "@ant-design-icons", {
      prepend: true,
      csp
    });
  }, []);
};
var _excluded$4 = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: "#333",
  secondaryColor: "#E6E6E6",
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor, secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2({}, twoToneColorPalette);
}
var IconBase = function IconBase2(props) {
  var icon = props.icon, className = props.className, onClick = props.onClick, style = props.style, primaryColor = props.primaryColor, secondaryColor = props.secondaryColor, restProps = _objectWithoutProperties(props, _excluded$4);
  var colors = twoToneColorPalette;
  if (primaryColor) {
    colors = {
      primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles();
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === "function") {
    target = _objectSpread2(_objectSpread2({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }
  return generate(target.icon, "svg-".concat(target.name), _objectSpread2({
    className,
    onClick,
    style,
    "data-icon": target.name,
    width: "1em",
    height: "1em",
    fill: "currentColor",
    "aria-hidden": "true"
  }, restProps));
};
IconBase.displayName = "IconReact";
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;
var ReactIcon = IconBase;
function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return ReactIcon.setTwoToneColors({
    primaryColor,
    secondaryColor
  });
}
function getTwoToneColor() {
  var colors = ReactIcon.getTwoToneColors();
  if (!colors.calculated) {
    return colors.primaryColor;
  }
  return [colors.primaryColor, colors.secondaryColor];
}
var _excluded$3 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
setTwoToneColor("#1890ff");
var Icon = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var className = props.className, icon = props.icon, spin = props.spin, rotate2 = props.rotate, tabIndex = props.tabIndex, onClick = props.onClick, twoToneColor = props.twoToneColor, restProps = _objectWithoutProperties(props, _excluded$3);
  var _React$useContext = React.useContext(IconContext$1), _React$useContext$pre = _React$useContext.prefixCls, prefixCls = _React$useContext$pre === void 0 ? "anticon" : _React$useContext$pre;
  var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === "loading"), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === void 0 && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate2 ? {
    msTransform: "rotate(".concat(rotate2, "deg)"),
    transform: "rotate(".concat(rotate2, "deg)")
  } : void 0;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return /* @__PURE__ */ React.createElement("span", _objectSpread2(_objectSpread2({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref,
    tabIndex: iconTabIndex,
    onClick,
    className: classString
  }), /* @__PURE__ */ React.createElement(ReactIcon, {
    icon,
    primaryColor,
    secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = "AntdIcon";
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;
var AntdIcon = Icon;
var LoadingOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, "name": "loading", "theme": "outlined" };
var LoadingOutlinedSvg = LoadingOutlined$2;
var LoadingOutlined = function LoadingOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref,
    icon: LoadingOutlinedSvg
  }));
};
LoadingOutlined.displayName = "LoadingOutlined";
var LoadingOutlined$1 = /* @__PURE__ */ React.forwardRef(LoadingOutlined);
function _extends$1() {
  _extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _setPrototypeOf$1(o, p2) {
  _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf$1(o, p2);
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass)
    _setPrototypeOf$1(subClass, superClass);
}
function _getPrototypeOf$1(o) {
  _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf$1(o);
}
function _isNativeReflectConstruct$1() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _assertThisInitialized(self2) {
  if (self2 === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self2;
}
function _possibleConstructorReturn(self2, call2) {
  if (call2 && (_typeof(call2) === "object" || typeof call2 === "function")) {
    return call2;
  } else if (call2 !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self2);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf$1(Derived), result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
var reactIs = { exports: {} };
var reactIs_production_min = {};
/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b = typeof Symbol === "function" && Symbol.for, c = b ? Symbol.for("react.element") : 60103, d = b ? Symbol.for("react.portal") : 60106, e = b ? Symbol.for("react.fragment") : 60107, f$1 = b ? Symbol.for("react.strict_mode") : 60108, g$1 = b ? Symbol.for("react.profiler") : 60114, h$1 = b ? Symbol.for("react.provider") : 60109, k = b ? Symbol.for("react.context") : 60110, l = b ? Symbol.for("react.async_mode") : 60111, m$1 = b ? Symbol.for("react.concurrent_mode") : 60111, n$1 = b ? Symbol.for("react.forward_ref") : 60112, p$1 = b ? Symbol.for("react.suspense") : 60113, q$1 = b ? Symbol.for("react.suspense_list") : 60120, r = b ? Symbol.for("react.memo") : 60115, t = b ? Symbol.for("react.lazy") : 60116, v = b ? Symbol.for("react.block") : 60121, w = b ? Symbol.for("react.fundamental") : 60117, x = b ? Symbol.for("react.responder") : 60118, y = b ? Symbol.for("react.scope") : 60119;
function z(a) {
  if (typeof a === "object" && a !== null) {
    var u = a.$$typeof;
    switch (u) {
      case c:
        switch (a = a.type, a) {
          case l:
          case m$1:
          case e:
          case g$1:
          case f$1:
          case p$1:
            return a;
          default:
            switch (a = a && a.$$typeof, a) {
              case k:
              case n$1:
              case t:
              case r:
              case h$1:
                return a;
              default:
                return u;
            }
        }
      case d:
        return u;
    }
  }
}
function A(a) {
  return z(a) === m$1;
}
reactIs_production_min.AsyncMode = l;
reactIs_production_min.ConcurrentMode = m$1;
reactIs_production_min.ContextConsumer = k;
reactIs_production_min.ContextProvider = h$1;
reactIs_production_min.Element = c;
reactIs_production_min.ForwardRef = n$1;
reactIs_production_min.Fragment = e;
reactIs_production_min.Lazy = t;
reactIs_production_min.Memo = r;
reactIs_production_min.Portal = d;
reactIs_production_min.Profiler = g$1;
reactIs_production_min.StrictMode = f$1;
reactIs_production_min.Suspense = p$1;
reactIs_production_min.isAsyncMode = function(a) {
  return A(a) || z(a) === l;
};
reactIs_production_min.isConcurrentMode = A;
reactIs_production_min.isContextConsumer = function(a) {
  return z(a) === k;
};
reactIs_production_min.isContextProvider = function(a) {
  return z(a) === h$1;
};
reactIs_production_min.isElement = function(a) {
  return typeof a === "object" && a !== null && a.$$typeof === c;
};
reactIs_production_min.isForwardRef = function(a) {
  return z(a) === n$1;
};
reactIs_production_min.isFragment = function(a) {
  return z(a) === e;
};
reactIs_production_min.isLazy = function(a) {
  return z(a) === t;
};
reactIs_production_min.isMemo = function(a) {
  return z(a) === r;
};
reactIs_production_min.isPortal = function(a) {
  return z(a) === d;
};
reactIs_production_min.isProfiler = function(a) {
  return z(a) === g$1;
};
reactIs_production_min.isStrictMode = function(a) {
  return z(a) === f$1;
};
reactIs_production_min.isSuspense = function(a) {
  return z(a) === p$1;
};
reactIs_production_min.isValidElementType = function(a) {
  return typeof a === "string" || typeof a === "function" || a === e || a === m$1 || a === g$1 || a === f$1 || a === p$1 || a === q$1 || typeof a === "object" && a !== null && (a.$$typeof === t || a.$$typeof === r || a.$$typeof === h$1 || a.$$typeof === k || a.$$typeof === n$1 || a.$$typeof === w || a.$$typeof === x || a.$$typeof === y || a.$$typeof === v);
};
reactIs_production_min.typeOf = z;
{
  reactIs.exports = reactIs_production_min;
}
function toArray$1(children) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var ret = [];
  React__default.Children.forEach(children, function(child) {
    if ((child === void 0 || child === null) && !option.keepEmpty) {
      return;
    }
    if (Array.isArray(child)) {
      ret = ret.concat(toArray$1(child));
    } else if (reactIs.exports.isFragment(child) && child.props) {
      ret = ret.concat(toArray$1(child.props.children, option));
    } else {
      ret.push(child);
    }
  });
  return ret;
}
function fillRef(ref, node) {
  if (typeof ref === "function") {
    ref(node);
  } else if (_typeof(ref) === "object" && ref && "current" in ref) {
    ref.current = node;
  }
}
function composeRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  var refList = refs.filter(function(ref) {
    return ref;
  });
  if (refList.length <= 1) {
    return refList[0];
  }
  return function(node) {
    refs.forEach(function(ref) {
      fillRef(ref, node);
    });
  };
}
function supportRef(nodeOrComponent) {
  var _type$prototype, _nodeOrComponent$prot;
  var type4 = reactIs.exports.isMemo(nodeOrComponent) ? nodeOrComponent.type.type : nodeOrComponent.type;
  if (typeof type4 === "function" && !((_type$prototype = type4.prototype) === null || _type$prototype === void 0 ? void 0 : _type$prototype.render)) {
    return false;
  }
  if (typeof nodeOrComponent === "function" && !((_nodeOrComponent$prot = nodeOrComponent.prototype) === null || _nodeOrComponent$prot === void 0 ? void 0 : _nodeOrComponent$prot.render)) {
    return false;
  }
  return true;
}
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
var HOOK_MARK = "RC_FORM_INTERNAL_HOOKS";
var warningFunc = function warningFunc2() {
  warningOnce(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
};
var Context = /* @__PURE__ */ React.createContext({
  getFieldValue: warningFunc,
  getFieldsValue: warningFunc,
  getFieldError: warningFunc,
  getFieldWarning: warningFunc,
  getFieldsError: warningFunc,
  isFieldsTouched: warningFunc,
  isFieldTouched: warningFunc,
  isFieldValidating: warningFunc,
  isFieldsValidating: warningFunc,
  resetFields: warningFunc,
  setFields: warningFunc,
  setFieldsValue: warningFunc,
  validateFields: warningFunc,
  submit: warningFunc,
  getInternalHooks: function getInternalHooks() {
    warningFunc();
    return {
      dispatch: warningFunc,
      initEntityValue: warningFunc,
      registerField: warningFunc,
      useSubscribe: warningFunc,
      setInitialValues: warningFunc,
      setCallbacks: warningFunc,
      getFields: warningFunc,
      setValidateMessages: warningFunc,
      setPreserve: warningFunc,
      getInitialValue: warningFunc
    };
  }
});
function toArray(value) {
  if (value === void 0 || value === null) {
    return [];
  }
  return Array.isArray(value) ? value : [value];
}
var runtime = { exports: {} };
(function(module) {
  var runtime2 = function(exports) {
    var Op = Object.prototype;
    var hasOwn2 = Op.hasOwnProperty;
    var undefined$1;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self2, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context2(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self2, context);
      return generator;
    }
    exports.wrap = wrap;
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }
    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};
    function Generator() {
    }
    function GeneratorFunction() {
    }
    function GeneratorFunctionPrototype() {
    }
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function() {
      return this;
    });
    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn2.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction");
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method4) {
        define(prototype, method4, function(arg) {
          return this._invoke(method4, arg);
        });
      });
    }
    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };
    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };
    exports.awrap = function(arg) {
      return { __await: arg };
    };
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method4, arg, resolve, reject) {
        var record = tryCatch(generator[method4], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value && typeof value === "object" && hasOwn2.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value2) {
              invoke("next", value2, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }
          return PromiseImpl.resolve(value).then(function(unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }
      var previousPromise;
      function enqueue(method4, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method4, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
      this._invoke = enqueue;
    }
    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function() {
      return this;
    });
    exports.AsyncIterator = AsyncIterator;
    exports.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0)
        PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
        return result.done ? result.value : iter.next();
      });
    };
    function makeInvokeMethod(innerFn, self2, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method4, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }
        if (state === GenStateCompleted) {
          if (method4 === "throw") {
            throw arg;
          }
          return doneResult();
        }
        context.method = method4;
        context.arg = arg;
        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel)
                continue;
              return delegateResult;
            }
          }
          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }
            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }
          state = GenStateExecuting;
          var record = tryCatch(innerFn, self2, context);
          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;
            if (record.arg === ContinueSentinel) {
              continue;
            }
            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var method4 = delegate.iterator[context.method];
      if (method4 === undefined$1) {
        context.delegate = null;
        if (context.method === "throw") {
          if (delegate.iterator["return"]) {
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);
            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }
          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }
        return ContinueSentinel;
      }
      var record = tryCatch(method4, delegate.iterator, context.arg);
      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }
      var info = record.arg;
      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }
      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        return info;
      }
      context.delegate = null;
      return ContinueSentinel;
    }
    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator");
    define(Gp, iteratorSymbol, function() {
      return this;
    });
    define(Gp, "toString", function() {
      return "[object Generator]";
    });
    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };
      if (1 in locs) {
        entry.catchLoc = locs[1];
      }
      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }
      this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }
    function Context2(tryLocsList) {
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }
    exports.keys = function(object4) {
      var keys2 = [];
      for (var key in object4) {
        keys2.push(key);
      }
      keys2.reverse();
      return function next() {
        while (keys2.length) {
          var key2 = keys2.pop();
          if (key2 in object4) {
            next.value = key2;
            next.done = false;
            return next;
          }
        }
        next.done = true;
        return next;
      };
    };
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }
        if (typeof iterable.next === "function") {
          return iterable;
        }
        if (!isNaN(iterable.length)) {
          var i = -1, next = function next2() {
            while (++i < iterable.length) {
              if (hasOwn2.call(iterable, i)) {
                next2.value = iterable[i];
                next2.done = false;
                return next2;
              }
            }
            next2.value = undefined$1;
            next2.done = true;
            return next2;
          };
          return next.next = next;
        }
      }
      return { next: doneResult };
    }
    exports.values = values;
    function doneResult() {
      return { value: undefined$1, done: true };
    }
    Context2.prototype = {
      constructor: Context2,
      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);
        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn2.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },
      stop: function() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }
        return this.rval;
      },
      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }
        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;
          if (caught) {
            context.method = "next";
            context.arg = undefined$1;
          }
          return !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;
          if (entry.tryLoc === "root") {
            return handle("end");
          }
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn2.call(entry, "catchLoc");
            var hasFinally = hasOwn2.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function(type4, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn2.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        if (finallyEntry && (type4 === "break" || type4 === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }
        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type4;
        record.arg = arg;
        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }
        return this.complete(record);
      },
      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }
        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }
        return ContinueSentinel;
      },
      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName,
          nextLoc
        };
        if (this.method === "next") {
          this.arg = undefined$1;
        }
        return ContinueSentinel;
      }
    };
    return exports;
  }(module.exports);
  try {
    regeneratorRuntime = runtime2;
  } catch (accidentalStrictMode) {
    if (typeof globalThis === "object") {
      globalThis.regeneratorRuntime = runtime2;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime2);
    }
  }
})(runtime);
var regenerator = runtime.exports;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p2) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf(o, p2);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct2(Parent2, args2, Class2) {
      var a = [null];
      a.push.apply(a, args2);
      var Constructor = Function.bind.apply(Parent2, a);
      var instance = new Constructor();
      if (Class2)
        _setPrototypeOf(instance, Class2.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
  _wrapNativeSuper = function _wrapNativeSuper2(Class2) {
    if (Class2 === null || !_isNativeFunction(Class2))
      return Class2;
    if (typeof Class2 !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class2))
        return _cache.get(Class2);
      _cache.set(Class2, Wrapper);
    }
    function Wrapper() {
      return _construct(Class2, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class2.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class2);
  };
  return _wrapNativeSuper(Class);
}
var formatRegExp = /%[sdj%]/g;
var warning = function warning2() {
};
if (typeof process !== "undefined" && process.env && false) {
  warning = function warning3(type4, errors) {
    if (typeof console !== "undefined" && console.warn && typeof ASYNC_VALIDATOR_NO_WARNING === "undefined") {
      if (errors.every(function(e2) {
        return typeof e2 === "string";
      })) {
        console.warn(type4, errors);
      }
    }
  };
}
function convertFieldsError(errors) {
  if (!errors || !errors.length)
    return null;
  var fields = {};
  errors.forEach(function(error) {
    var field = error.field;
    fields[field] = fields[field] || [];
    fields[field].push(error);
  });
  return fields;
}
function format(template) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var i = 0;
  var len2 = args.length;
  if (typeof template === "function") {
    return template.apply(null, args);
  }
  if (typeof template === "string") {
    var str = template.replace(formatRegExp, function(x2) {
      if (x2 === "%%") {
        return "%";
      }
      if (i >= len2) {
        return x2;
      }
      switch (x2) {
        case "%s":
          return String(args[i++]);
        case "%d":
          return Number(args[i++]);
        case "%j":
          try {
            return JSON.stringify(args[i++]);
          } catch (_) {
            return "[Circular]";
          }
          break;
        default:
          return x2;
      }
    });
    return str;
  }
  return template;
}
function isNativeStringType(type4) {
  return type4 === "string" || type4 === "url" || type4 === "hex" || type4 === "email" || type4 === "date" || type4 === "pattern";
}
function isEmptyValue(value, type4) {
  if (value === void 0 || value === null) {
    return true;
  }
  if (type4 === "array" && Array.isArray(value) && !value.length) {
    return true;
  }
  if (isNativeStringType(type4) && typeof value === "string" && !value) {
    return true;
  }
  return false;
}
function asyncParallelArray(arr, func, callback) {
  var results = [];
  var total = 0;
  var arrLength = arr.length;
  function count2(errors) {
    results.push.apply(results, errors || []);
    total++;
    if (total === arrLength) {
      callback(results);
    }
  }
  arr.forEach(function(a) {
    func(a, count2);
  });
}
function asyncSerialArray(arr, func, callback) {
  var index2 = 0;
  var arrLength = arr.length;
  function next(errors) {
    if (errors && errors.length) {
      callback(errors);
      return;
    }
    var original = index2;
    index2 = index2 + 1;
    if (original < arrLength) {
      func(arr[original], next);
    } else {
      callback([]);
    }
  }
  next([]);
}
function flattenObjArr(objArr) {
  var ret = [];
  Object.keys(objArr).forEach(function(k2) {
    ret.push.apply(ret, objArr[k2] || []);
  });
  return ret;
}
var AsyncValidationError = /* @__PURE__ */ function(_Error) {
  _inheritsLoose(AsyncValidationError2, _Error);
  function AsyncValidationError2(errors, fields) {
    var _this;
    _this = _Error.call(this, "Async Validation Error") || this;
    _this.errors = errors;
    _this.fields = fields;
    return _this;
  }
  return AsyncValidationError2;
}(/* @__PURE__ */ _wrapNativeSuper(Error));
function asyncMap(objArr, option, func, callback, source) {
  if (option.first) {
    var _pending = new Promise(function(resolve, reject) {
      var next = function next2(errors) {
        callback(errors);
        return errors.length ? reject(new AsyncValidationError(errors, convertFieldsError(errors))) : resolve(source);
      };
      var flattenArr = flattenObjArr(objArr);
      asyncSerialArray(flattenArr, func, next);
    });
    _pending["catch"](function(e2) {
      return e2;
    });
    return _pending;
  }
  var firstFields = option.firstFields === true ? Object.keys(objArr) : option.firstFields || [];
  var objArrKeys = Object.keys(objArr);
  var objArrLength = objArrKeys.length;
  var total = 0;
  var results = [];
  var pending = new Promise(function(resolve, reject) {
    var next = function next2(errors) {
      results.push.apply(results, errors);
      total++;
      if (total === objArrLength) {
        callback(results);
        return results.length ? reject(new AsyncValidationError(results, convertFieldsError(results))) : resolve(source);
      }
    };
    if (!objArrKeys.length) {
      callback(results);
      resolve(source);
    }
    objArrKeys.forEach(function(key) {
      var arr = objArr[key];
      if (firstFields.indexOf(key) !== -1) {
        asyncSerialArray(arr, func, next);
      } else {
        asyncParallelArray(arr, func, next);
      }
    });
  });
  pending["catch"](function(e2) {
    return e2;
  });
  return pending;
}
function isErrorObj(obj) {
  return !!(obj && obj.message !== void 0);
}
function getValue$1(value, path) {
  var v4 = value;
  for (var i = 0; i < path.length; i++) {
    if (v4 == void 0) {
      return v4;
    }
    v4 = v4[path[i]];
  }
  return v4;
}
function complementError(rule, source) {
  return function(oe) {
    var fieldValue;
    if (rule.fullFields) {
      fieldValue = getValue$1(source, rule.fullFields);
    } else {
      fieldValue = source[oe.field || rule.fullField];
    }
    if (isErrorObj(oe)) {
      oe.field = oe.field || rule.fullField;
      oe.fieldValue = fieldValue;
      return oe;
    }
    return {
      message: typeof oe === "function" ? oe() : oe,
      fieldValue,
      field: oe.field || rule.fullField
    };
  };
}
function deepMerge(target, source) {
  if (source) {
    for (var s in source) {
      if (source.hasOwnProperty(s)) {
        var value = source[s];
        if (typeof value === "object" && typeof target[s] === "object") {
          target[s] = _extends({}, target[s], value);
        } else {
          target[s] = value;
        }
      }
    }
  }
  return target;
}
var required$1 = function required(rule, value, source, errors, options, type4) {
  if (rule.required && (!source.hasOwnProperty(rule.field) || isEmptyValue(value, type4 || rule.type))) {
    errors.push(format(options.messages.required, rule.fullField));
  }
};
var whitespace = function whitespace2(rule, value, source, errors, options) {
  if (/^\s+$/.test(value) || value === "") {
    errors.push(format(options.messages.whitespace, rule.fullField));
  }
};
var pattern$2 = {
  email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/,
  url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"),
  hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i
};
var types = {
  integer: function integer(value) {
    return types.number(value) && parseInt(value, 10) === value;
  },
  "float": function float(value) {
    return types.number(value) && !types.integer(value);
  },
  array: function array(value) {
    return Array.isArray(value);
  },
  regexp: function regexp(value) {
    if (value instanceof RegExp) {
      return true;
    }
    try {
      return !!new RegExp(value);
    } catch (e2) {
      return false;
    }
  },
  date: function date(value) {
    return typeof value.getTime === "function" && typeof value.getMonth === "function" && typeof value.getYear === "function" && !isNaN(value.getTime());
  },
  number: function number(value) {
    if (isNaN(value)) {
      return false;
    }
    return typeof value === "number";
  },
  object: function object(value) {
    return typeof value === "object" && !types.array(value);
  },
  method: function method(value) {
    return typeof value === "function";
  },
  email: function email(value) {
    return typeof value === "string" && value.length <= 320 && !!value.match(pattern$2.email);
  },
  url: function url(value) {
    return typeof value === "string" && value.length <= 2048 && !!value.match(pattern$2.url);
  },
  hex: function hex(value) {
    return typeof value === "string" && !!value.match(pattern$2.hex);
  }
};
var type$1 = function type(rule, value, source, errors, options) {
  if (rule.required && value === void 0) {
    required$1(rule, value, source, errors, options);
    return;
  }
  var custom = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"];
  var ruleType = rule.type;
  if (custom.indexOf(ruleType) > -1) {
    if (!types[ruleType](value)) {
      errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
    }
  } else if (ruleType && typeof value !== rule.type) {
    errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
  }
};
var range = function range2(rule, value, source, errors, options) {
  var len2 = typeof rule.len === "number";
  var min3 = typeof rule.min === "number";
  var max3 = typeof rule.max === "number";
  var spRegexp = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
  var val = value;
  var key = null;
  var num = typeof value === "number";
  var str = typeof value === "string";
  var arr = Array.isArray(value);
  if (num) {
    key = "number";
  } else if (str) {
    key = "string";
  } else if (arr) {
    key = "array";
  }
  if (!key) {
    return false;
  }
  if (arr) {
    val = value.length;
  }
  if (str) {
    val = value.replace(spRegexp, "_").length;
  }
  if (len2) {
    if (val !== rule.len) {
      errors.push(format(options.messages[key].len, rule.fullField, rule.len));
    }
  } else if (min3 && !max3 && val < rule.min) {
    errors.push(format(options.messages[key].min, rule.fullField, rule.min));
  } else if (max3 && !min3 && val > rule.max) {
    errors.push(format(options.messages[key].max, rule.fullField, rule.max));
  } else if (min3 && max3 && (val < rule.min || val > rule.max)) {
    errors.push(format(options.messages[key].range, rule.fullField, rule.min, rule.max));
  }
};
var ENUM$1 = "enum";
var enumerable$1 = function enumerable(rule, value, source, errors, options) {
  rule[ENUM$1] = Array.isArray(rule[ENUM$1]) ? rule[ENUM$1] : [];
  if (rule[ENUM$1].indexOf(value) === -1) {
    errors.push(format(options.messages[ENUM$1], rule.fullField, rule[ENUM$1].join(", ")));
  }
};
var pattern$1 = function pattern(rule, value, source, errors, options) {
  if (rule.pattern) {
    if (rule.pattern instanceof RegExp) {
      rule.pattern.lastIndex = 0;
      if (!rule.pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    } else if (typeof rule.pattern === "string") {
      var _pattern = new RegExp(rule.pattern);
      if (!_pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    }
  }
};
var rules = {
  required: required$1,
  whitespace,
  type: type$1,
  range,
  "enum": enumerable$1,
  pattern: pattern$1
};
var string = function string2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "string");
    if (!isEmptyValue(value, "string")) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
      rules.pattern(rule, value, source, errors, options);
      if (rule.whitespace === true) {
        rules.whitespace(rule, value, source, errors, options);
      }
    }
  }
  callback(errors);
};
var method2 = function method3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var number2 = function number3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (value === "") {
      value = void 0;
    }
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var _boolean = function _boolean2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var regexp2 = function regexp3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var integer2 = function integer3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var floatFn = function floatFn2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var array2 = function array3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if ((value === void 0 || value === null) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "array");
    if (value !== void 0 && value !== null) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var object2 = function object3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var ENUM = "enum";
var enumerable2 = function enumerable3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules[ENUM](rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var pattern2 = function pattern3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "string")) {
      rules.pattern(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var date2 = function date3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "date") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "date")) {
      var dateObject;
      if (value instanceof Date) {
        dateObject = value;
      } else {
        dateObject = new Date(value);
      }
      rules.type(rule, dateObject, source, errors, options);
      if (dateObject) {
        rules.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
};
var required2 = function required3(rule, value, callback, source, options) {
  var errors = [];
  var type4 = Array.isArray(value) ? "array" : typeof value;
  rules.required(rule, value, source, errors, options, type4);
  callback(errors);
};
var type2 = function type3(rule, value, callback, source, options) {
  var ruleType = rule.type;
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, ruleType) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, ruleType);
    if (!isEmptyValue(value, ruleType)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var any = function any2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
  }
  callback(errors);
};
var validators = {
  string,
  method: method2,
  number: number2,
  "boolean": _boolean,
  regexp: regexp2,
  integer: integer2,
  "float": floatFn,
  array: array2,
  object: object2,
  "enum": enumerable2,
  pattern: pattern2,
  date: date2,
  url: type2,
  hex: type2,
  email: type2,
  required: required2,
  any
};
function newMessages() {
  return {
    "default": "Validation error on field %s",
    required: "%s is required",
    "enum": "%s must be one of %s",
    whitespace: "%s cannot be empty",
    date: {
      format: "%s date %s is invalid for format %s",
      parse: "%s date could not be parsed, %s is invalid ",
      invalid: "%s date %s is invalid"
    },
    types: {
      string: "%s is not a %s",
      method: "%s is not a %s (function)",
      array: "%s is not an %s",
      object: "%s is not an %s",
      number: "%s is not a %s",
      date: "%s is not a %s",
      "boolean": "%s is not a %s",
      integer: "%s is not an %s",
      "float": "%s is not a %s",
      regexp: "%s is not a valid %s",
      email: "%s is not a valid %s",
      url: "%s is not a valid %s",
      hex: "%s is not a valid %s"
    },
    string: {
      len: "%s must be exactly %s characters",
      min: "%s must be at least %s characters",
      max: "%s cannot be longer than %s characters",
      range: "%s must be between %s and %s characters"
    },
    number: {
      len: "%s must equal %s",
      min: "%s cannot be less than %s",
      max: "%s cannot be greater than %s",
      range: "%s must be between %s and %s"
    },
    array: {
      len: "%s must be exactly %s in length",
      min: "%s cannot be less than %s in length",
      max: "%s cannot be greater than %s in length",
      range: "%s must be between %s and %s in length"
    },
    pattern: {
      mismatch: "%s value %s does not match pattern %s"
    },
    clone: function clone2() {
      var cloned = JSON.parse(JSON.stringify(this));
      cloned.clone = this.clone;
      return cloned;
    }
  };
}
var messages = newMessages();
var Schema = /* @__PURE__ */ function() {
  function Schema2(descriptor) {
    this.rules = null;
    this._messages = messages;
    this.define(descriptor);
  }
  var _proto = Schema2.prototype;
  _proto.define = function define(rules2) {
    var _this = this;
    if (!rules2) {
      throw new Error("Cannot configure a schema with no rules");
    }
    if (typeof rules2 !== "object" || Array.isArray(rules2)) {
      throw new Error("Rules must be an object");
    }
    this.rules = {};
    Object.keys(rules2).forEach(function(name) {
      var item = rules2[name];
      _this.rules[name] = Array.isArray(item) ? item : [item];
    });
  };
  _proto.messages = function messages2(_messages) {
    if (_messages) {
      this._messages = deepMerge(newMessages(), _messages);
    }
    return this._messages;
  };
  _proto.validate = function validate(source_, o, oc) {
    var _this2 = this;
    if (o === void 0) {
      o = {};
    }
    if (oc === void 0) {
      oc = function oc2() {
      };
    }
    var source = source_;
    var options = o;
    var callback = oc;
    if (typeof options === "function") {
      callback = options;
      options = {};
    }
    if (!this.rules || Object.keys(this.rules).length === 0) {
      if (callback) {
        callback(null, source);
      }
      return Promise.resolve(source);
    }
    function complete(results) {
      var errors = [];
      var fields = {};
      function add2(e2) {
        if (Array.isArray(e2)) {
          var _errors;
          errors = (_errors = errors).concat.apply(_errors, e2);
        } else {
          errors.push(e2);
        }
      }
      for (var i = 0; i < results.length; i++) {
        add2(results[i]);
      }
      if (!errors.length) {
        callback(null, source);
      } else {
        fields = convertFieldsError(errors);
        callback(errors, fields);
      }
    }
    if (options.messages) {
      var messages$1 = this.messages();
      if (messages$1 === messages) {
        messages$1 = newMessages();
      }
      deepMerge(messages$1, options.messages);
      options.messages = messages$1;
    } else {
      options.messages = this.messages();
    }
    var series = {};
    var keys2 = options.keys || Object.keys(this.rules);
    keys2.forEach(function(z2) {
      var arr = _this2.rules[z2];
      var value = source[z2];
      arr.forEach(function(r2) {
        var rule = r2;
        if (typeof rule.transform === "function") {
          if (source === source_) {
            source = _extends({}, source);
          }
          value = source[z2] = rule.transform(value);
        }
        if (typeof rule === "function") {
          rule = {
            validator: rule
          };
        } else {
          rule = _extends({}, rule);
        }
        rule.validator = _this2.getValidationMethod(rule);
        if (!rule.validator) {
          return;
        }
        rule.field = z2;
        rule.fullField = rule.fullField || z2;
        rule.type = _this2.getType(rule);
        series[z2] = series[z2] || [];
        series[z2].push({
          rule,
          value,
          source,
          field: z2
        });
      });
    });
    var errorFields = {};
    return asyncMap(series, options, function(data, doIt) {
      var rule = data.rule;
      var deep = (rule.type === "object" || rule.type === "array") && (typeof rule.fields === "object" || typeof rule.defaultField === "object");
      deep = deep && (rule.required || !rule.required && data.value);
      rule.field = data.field;
      function addFullField(key, schema) {
        return _extends({}, schema, {
          fullField: rule.fullField + "." + key,
          fullFields: rule.fullFields ? [].concat(rule.fullFields, [key]) : [key]
        });
      }
      function cb(e2) {
        if (e2 === void 0) {
          e2 = [];
        }
        var errorList = Array.isArray(e2) ? e2 : [e2];
        if (!options.suppressWarning && errorList.length) {
          Schema2.warning("async-validator:", errorList);
        }
        if (errorList.length && rule.message !== void 0) {
          errorList = [].concat(rule.message);
        }
        var filledErrors = errorList.map(complementError(rule, source));
        if (options.first && filledErrors.length) {
          errorFields[rule.field] = 1;
          return doIt(filledErrors);
        }
        if (!deep) {
          doIt(filledErrors);
        } else {
          if (rule.required && !data.value) {
            if (rule.message !== void 0) {
              filledErrors = [].concat(rule.message).map(complementError(rule, source));
            } else if (options.error) {
              filledErrors = [options.error(rule, format(options.messages.required, rule.field))];
            }
            return doIt(filledErrors);
          }
          var fieldsSchema = {};
          if (rule.defaultField) {
            Object.keys(data.value).map(function(key) {
              fieldsSchema[key] = rule.defaultField;
            });
          }
          fieldsSchema = _extends({}, fieldsSchema, data.rule.fields);
          var paredFieldsSchema = {};
          Object.keys(fieldsSchema).forEach(function(field) {
            var fieldSchema = fieldsSchema[field];
            var fieldSchemaList = Array.isArray(fieldSchema) ? fieldSchema : [fieldSchema];
            paredFieldsSchema[field] = fieldSchemaList.map(addFullField.bind(null, field));
          });
          var schema = new Schema2(paredFieldsSchema);
          schema.messages(options.messages);
          if (data.rule.options) {
            data.rule.options.messages = options.messages;
            data.rule.options.error = options.error;
          }
          schema.validate(data.value, data.rule.options || options, function(errs) {
            var finalErrors = [];
            if (filledErrors && filledErrors.length) {
              finalErrors.push.apply(finalErrors, filledErrors);
            }
            if (errs && errs.length) {
              finalErrors.push.apply(finalErrors, errs);
            }
            doIt(finalErrors.length ? finalErrors : null);
          });
        }
      }
      var res;
      if (rule.asyncValidator) {
        res = rule.asyncValidator(rule, data.value, cb, data.source, options);
      } else if (rule.validator) {
        res = rule.validator(rule, data.value, cb, data.source, options);
        if (res === true) {
          cb();
        } else if (res === false) {
          cb(typeof rule.message === "function" ? rule.message(rule.fullField || rule.field) : rule.message || (rule.fullField || rule.field) + " fails");
        } else if (res instanceof Array) {
          cb(res);
        } else if (res instanceof Error) {
          cb(res.message);
        }
      }
      if (res && res.then) {
        res.then(function() {
          return cb();
        }, function(e2) {
          return cb(e2);
        });
      }
    }, function(results) {
      complete(results);
    }, source);
  };
  _proto.getType = function getType(rule) {
    if (rule.type === void 0 && rule.pattern instanceof RegExp) {
      rule.type = "pattern";
    }
    if (typeof rule.validator !== "function" && rule.type && !validators.hasOwnProperty(rule.type)) {
      throw new Error(format("Unknown rule type %s", rule.type));
    }
    return rule.type || "string";
  };
  _proto.getValidationMethod = function getValidationMethod(rule) {
    if (typeof rule.validator === "function") {
      return rule.validator;
    }
    var keys2 = Object.keys(rule);
    var messageIndex = keys2.indexOf("message");
    if (messageIndex !== -1) {
      keys2.splice(messageIndex, 1);
    }
    if (keys2.length === 1 && keys2[0] === "required") {
      return validators.required;
    }
    return validators[this.getType(rule)] || void 0;
  };
  return Schema2;
}();
Schema.register = function register2(type4, validator) {
  if (typeof validator !== "function") {
    throw new Error("Cannot register a validator by type, validator is not a function");
  }
  validators[type4] = validator;
};
Schema.warning = warning;
Schema.messages = messages;
Schema.validators = validators;
var typeTemplate$1 = "'${name}' is not a valid ${type}";
var defaultValidateMessages = {
  default: "Validation error on field '${name}'",
  required: "'${name}' is required",
  enum: "'${name}' must be one of [${enum}]",
  whitespace: "'${name}' cannot be empty",
  date: {
    format: "'${name}' is invalid for format date",
    parse: "'${name}' could not be parsed as date",
    invalid: "'${name}' is invalid date"
  },
  types: {
    string: typeTemplate$1,
    method: typeTemplate$1,
    array: typeTemplate$1,
    object: typeTemplate$1,
    number: typeTemplate$1,
    date: typeTemplate$1,
    boolean: typeTemplate$1,
    integer: typeTemplate$1,
    float: typeTemplate$1,
    regexp: typeTemplate$1,
    email: typeTemplate$1,
    url: typeTemplate$1,
    hex: typeTemplate$1
  },
  string: {
    len: "'${name}' must be exactly ${len} characters",
    min: "'${name}' must be at least ${min} characters",
    max: "'${name}' cannot be longer than ${max} characters",
    range: "'${name}' must be between ${min} and ${max} characters"
  },
  number: {
    len: "'${name}' must equal ${len}",
    min: "'${name}' cannot be less than ${min}",
    max: "'${name}' cannot be greater than ${max}",
    range: "'${name}' must be between ${min} and ${max}"
  },
  array: {
    len: "'${name}' must be exactly ${len} in length",
    min: "'${name}' cannot be less than ${min} in length",
    max: "'${name}' cannot be greater than ${max} in length",
    range: "'${name}' must be between ${min} and ${max} in length"
  },
  pattern: {
    mismatch: "'${name}' does not match pattern ${pattern}"
  }
};
function get(entity, path) {
  var current = entity;
  for (var i = 0; i < path.length; i += 1) {
    if (current === null || current === void 0) {
      return void 0;
    }
    current = current[path[i]];
  }
  return current;
}
function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}
function internalSet(entity, paths, value, removeIfUndefined) {
  if (!paths.length) {
    return value;
  }
  var _paths = _toArray(paths), path = _paths[0], restPath = _paths.slice(1);
  var clone2;
  if (!entity && typeof path === "number") {
    clone2 = [];
  } else if (Array.isArray(entity)) {
    clone2 = _toConsumableArray(entity);
  } else {
    clone2 = _objectSpread2({}, entity);
  }
  if (removeIfUndefined && value === void 0 && restPath.length === 1) {
    delete clone2[path][restPath[0]];
  } else {
    clone2[path] = internalSet(clone2[path], restPath, value, removeIfUndefined);
  }
  return clone2;
}
function set(entity, paths, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  if (paths.length && removeIfUndefined && value === void 0 && !get(entity, paths.slice(0, -1))) {
    return entity;
  }
  return internalSet(entity, paths, value, removeIfUndefined);
}
function getNamePath(path) {
  return toArray(path);
}
function getValue(store, namePath) {
  var value = get(store, namePath);
  return value;
}
function setValue(store, namePath, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  var newStore = set(store, namePath, value, removeIfUndefined);
  return newStore;
}
function cloneByNamePathList(store, namePathList) {
  var newStore = {};
  namePathList.forEach(function(namePath) {
    var value = getValue(store, namePath);
    newStore = setValue(newStore, namePath, value);
  });
  return newStore;
}
function containsNamePath(namePathList, namePath) {
  return namePathList && namePathList.some(function(path) {
    return matchNamePath(path, namePath);
  });
}
function isObject(obj) {
  return _typeof(obj) === "object" && obj !== null && Object.getPrototypeOf(obj) === Object.prototype;
}
function internalSetValues(store, values) {
  var newStore = Array.isArray(store) ? _toConsumableArray(store) : _objectSpread2({}, store);
  if (!values) {
    return newStore;
  }
  Object.keys(values).forEach(function(key) {
    var prevValue = newStore[key];
    var value = values[key];
    var recursive = isObject(prevValue) && isObject(value);
    newStore[key] = recursive ? internalSetValues(prevValue, value || {}) : value;
  });
  return newStore;
}
function setValues(store) {
  for (var _len = arguments.length, restValues = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    restValues[_key - 1] = arguments[_key];
  }
  return restValues.reduce(function(current, newStore) {
    return internalSetValues(current, newStore);
  }, store);
}
function matchNamePath(namePath, changedNamePath) {
  if (!namePath || !changedNamePath || namePath.length !== changedNamePath.length) {
    return false;
  }
  return namePath.every(function(nameUnit, i) {
    return changedNamePath[i] === nameUnit;
  });
}
function isSimilar(source, target) {
  if (source === target) {
    return true;
  }
  if (!source && target || source && !target) {
    return false;
  }
  if (!source || !target || _typeof(source) !== "object" || _typeof(target) !== "object") {
    return false;
  }
  var sourceKeys = Object.keys(source);
  var targetKeys = Object.keys(target);
  var keys2 = new Set([].concat(_toConsumableArray(sourceKeys), _toConsumableArray(targetKeys)));
  return _toConsumableArray(keys2).every(function(key) {
    var sourceValue = source[key];
    var targetValue = target[key];
    if (typeof sourceValue === "function" && typeof targetValue === "function") {
      return true;
    }
    return sourceValue === targetValue;
  });
}
function defaultGetValueFromEvent(valuePropName) {
  var event = arguments.length <= 1 ? void 0 : arguments[1];
  if (event && event.target && _typeof(event.target) === "object" && valuePropName in event.target) {
    return event.target[valuePropName];
  }
  return event;
}
function move(array4, moveIndex, toIndex) {
  var length = array4.length;
  if (moveIndex < 0 || moveIndex >= length || toIndex < 0 || toIndex >= length) {
    return array4;
  }
  var item = array4[moveIndex];
  var diff = moveIndex - toIndex;
  if (diff > 0) {
    return [].concat(_toConsumableArray(array4.slice(0, toIndex)), [item], _toConsumableArray(array4.slice(toIndex, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, length)));
  }
  if (diff < 0) {
    return [].concat(_toConsumableArray(array4.slice(0, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, toIndex + 1)), [item], _toConsumableArray(array4.slice(toIndex + 1, length)));
  }
  return array4;
}
var AsyncValidator = Schema;
function replaceMessage(template, kv) {
  return template.replace(/\$\{\w+\}/g, function(str) {
    var key = str.slice(2, -1);
    return kv[key];
  });
}
function validateRule(_x, _x2, _x3, _x4, _x5) {
  return _validateRule.apply(this, arguments);
}
function _validateRule() {
  _validateRule = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee2(name, value, rule, options, messageVariables) {
    var cloneRule, subRuleField, validator, messages2, result, subResults, kv, fillVariableResult;
    return regenerator.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cloneRule = _objectSpread2({}, rule);
            delete cloneRule.ruleIndex;
            subRuleField = null;
            if (cloneRule && cloneRule.type === "array" && cloneRule.defaultField) {
              subRuleField = cloneRule.defaultField;
              delete cloneRule.defaultField;
            }
            validator = new AsyncValidator(_defineProperty({}, name, [cloneRule]));
            messages2 = setValues({}, defaultValidateMessages, options.validateMessages);
            validator.messages(messages2);
            result = [];
            _context2.prev = 8;
            _context2.next = 11;
            return Promise.resolve(validator.validate(_defineProperty({}, name, value), _objectSpread2({}, options)));
          case 11:
            _context2.next = 16;
            break;
          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](8);
            if (_context2.t0.errors) {
              result = _context2.t0.errors.map(function(_ref4, index2) {
                var message = _ref4.message;
                return /* @__PURE__ */ React.isValidElement(message) ? /* @__PURE__ */ React.cloneElement(message, {
                  key: "error_".concat(index2)
                }) : message;
              });
            } else {
              console.error(_context2.t0);
              result = [messages2.default];
            }
          case 16:
            if (!(!result.length && subRuleField)) {
              _context2.next = 21;
              break;
            }
            _context2.next = 19;
            return Promise.all(value.map(function(subValue, i) {
              return validateRule("".concat(name, ".").concat(i), subValue, subRuleField, options, messageVariables);
            }));
          case 19:
            subResults = _context2.sent;
            return _context2.abrupt("return", subResults.reduce(function(prev, errors) {
              return [].concat(_toConsumableArray(prev), _toConsumableArray(errors));
            }, []));
          case 21:
            kv = _objectSpread2(_objectSpread2({}, rule), {}, {
              name,
              enum: (rule.enum || []).join(", ")
            }, messageVariables);
            fillVariableResult = result.map(function(error) {
              if (typeof error === "string") {
                return replaceMessage(error, kv);
              }
              return error;
            });
            return _context2.abrupt("return", fillVariableResult);
          case 24:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[8, 13]]);
  }));
  return _validateRule.apply(this, arguments);
}
function validateRules(namePath, value, rules2, options, validateFirst, messageVariables) {
  var name = namePath.join(".");
  var filledRules = rules2.map(function(currentRule, ruleIndex) {
    var originValidatorFunc = currentRule.validator;
    var cloneRule = _objectSpread2(_objectSpread2({}, currentRule), {}, {
      ruleIndex
    });
    if (originValidatorFunc) {
      cloneRule.validator = function(rule, val, callback) {
        var hasPromise = false;
        var wrappedCallback = function wrappedCallback2() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          Promise.resolve().then(function() {
            warningOnce(!hasPromise, "Your validator function has already return a promise. `callback` will be ignored.");
            if (!hasPromise) {
              callback.apply(void 0, args);
            }
          });
        };
        var promise = originValidatorFunc(rule, val, wrappedCallback);
        hasPromise = promise && typeof promise.then === "function" && typeof promise.catch === "function";
        warningOnce(hasPromise, "`callback` is deprecated. Please return a promise instead.");
        if (hasPromise) {
          promise.then(function() {
            callback();
          }).catch(function(err) {
            callback(err || " ");
          });
        }
      };
    }
    return cloneRule;
  }).sort(function(_ref, _ref2) {
    var w1 = _ref.warningOnly, i1 = _ref.ruleIndex;
    var w2 = _ref2.warningOnly, i2 = _ref2.ruleIndex;
    if (!!w1 === !!w2) {
      return i1 - i2;
    }
    if (w1) {
      return 1;
    }
    return -1;
  });
  var summaryPromise;
  if (validateFirst === true) {
    summaryPromise = new Promise(/* @__PURE__ */ function() {
      var _ref3 = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee(resolve, reject) {
        var i, rule, errors;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                i = 0;
              case 1:
                if (!(i < filledRules.length)) {
                  _context.next = 12;
                  break;
                }
                rule = filledRules[i];
                _context.next = 5;
                return validateRule(name, value, rule, options, messageVariables);
              case 5:
                errors = _context.sent;
                if (!errors.length) {
                  _context.next = 9;
                  break;
                }
                reject([{
                  errors,
                  rule
                }]);
                return _context.abrupt("return");
              case 9:
                i += 1;
                _context.next = 1;
                break;
              case 12:
                resolve([]);
              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return function(_x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }());
  } else {
    var rulePromises = filledRules.map(function(rule) {
      return validateRule(name, value, rule, options, messageVariables).then(function(errors) {
        return {
          errors,
          rule
        };
      });
    });
    summaryPromise = (validateFirst ? finishOnFirstFailed(rulePromises) : finishOnAllFailed(rulePromises)).then(function(errors) {
      return Promise.reject(errors);
    });
  }
  summaryPromise.catch(function(e2) {
    return e2;
  });
  return summaryPromise;
}
function finishOnAllFailed(_x8) {
  return _finishOnAllFailed.apply(this, arguments);
}
function _finishOnAllFailed() {
  _finishOnAllFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee3(rulePromises) {
    return regenerator.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", Promise.all(rulePromises).then(function(errorsList) {
              var _ref5;
              var errors = (_ref5 = []).concat.apply(_ref5, _toConsumableArray(errorsList));
              return errors;
            }));
          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _finishOnAllFailed.apply(this, arguments);
}
function finishOnFirstFailed(_x9) {
  return _finishOnFirstFailed.apply(this, arguments);
}
function _finishOnFirstFailed() {
  _finishOnFirstFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee4(rulePromises) {
    var count2;
    return regenerator.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            count2 = 0;
            return _context4.abrupt("return", new Promise(function(resolve) {
              rulePromises.forEach(function(promise) {
                promise.then(function(ruleError) {
                  if (ruleError.errors.length) {
                    resolve([ruleError]);
                  }
                  count2 += 1;
                  if (count2 === rulePromises.length) {
                    resolve([]);
                  }
                });
              });
            }));
          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _finishOnFirstFailed.apply(this, arguments);
}
var _excluded$2 = ["name"];
var EMPTY_ERRORS = [];
function requireUpdate(shouldUpdate, prev, next, prevValue, nextValue, info) {
  if (typeof shouldUpdate === "function") {
    return shouldUpdate(prev, next, "source" in info ? {
      source: info.source
    } : {});
  }
  return prevValue !== nextValue;
}
var Field = /* @__PURE__ */ function(_React$Component) {
  _inherits(Field2, _React$Component);
  var _super = _createSuper(Field2);
  function Field2(props) {
    var _this;
    _classCallCheck(this, Field2);
    _this = _super.call(this, props);
    _this.state = {
      resetCount: 0
    };
    _this.cancelRegisterFunc = null;
    _this.mounted = false;
    _this.touched = false;
    _this.dirty = false;
    _this.validatePromise = null;
    _this.prevValidating = void 0;
    _this.errors = EMPTY_ERRORS;
    _this.warnings = EMPTY_ERRORS;
    _this.cancelRegister = function() {
      var _this$props = _this.props, preserve = _this$props.preserve, isListField = _this$props.isListField, name = _this$props.name;
      if (_this.cancelRegisterFunc) {
        _this.cancelRegisterFunc(isListField, preserve, getNamePath(name));
      }
      _this.cancelRegisterFunc = null;
    };
    _this.getNamePath = function() {
      var _this$props2 = _this.props, name = _this$props2.name, fieldContext = _this$props2.fieldContext;
      var _fieldContext$prefixN = fieldContext.prefixName, prefixName = _fieldContext$prefixN === void 0 ? [] : _fieldContext$prefixN;
      return name !== void 0 ? [].concat(_toConsumableArray(prefixName), _toConsumableArray(name)) : [];
    };
    _this.getRules = function() {
      var _this$props3 = _this.props, _this$props3$rules = _this$props3.rules, rules2 = _this$props3$rules === void 0 ? [] : _this$props3$rules, fieldContext = _this$props3.fieldContext;
      return rules2.map(function(rule) {
        if (typeof rule === "function") {
          return rule(fieldContext);
        }
        return rule;
      });
    };
    _this.refresh = function() {
      if (!_this.mounted)
        return;
      _this.setState(function(_ref) {
        var resetCount = _ref.resetCount;
        return {
          resetCount: resetCount + 1
        };
      });
    };
    _this.triggerMetaEvent = function(destroy) {
      var onMetaChange = _this.props.onMetaChange;
      onMetaChange === null || onMetaChange === void 0 ? void 0 : onMetaChange(_objectSpread2(_objectSpread2({}, _this.getMeta()), {}, {
        destroy
      }));
    };
    _this.onStoreChange = function(prevStore, namePathList, info) {
      var _this$props4 = _this.props, shouldUpdate = _this$props4.shouldUpdate, _this$props4$dependen = _this$props4.dependencies, dependencies = _this$props4$dependen === void 0 ? [] : _this$props4$dependen, onReset = _this$props4.onReset;
      var store = info.store;
      var namePath = _this.getNamePath();
      var prevValue = _this.getValue(prevStore);
      var curValue = _this.getValue(store);
      var namePathMatch = namePathList && containsNamePath(namePathList, namePath);
      if (info.type === "valueUpdate" && info.source === "external" && prevValue !== curValue) {
        _this.touched = true;
        _this.dirty = true;
        _this.validatePromise = null;
        _this.errors = EMPTY_ERRORS;
        _this.warnings = EMPTY_ERRORS;
        _this.triggerMetaEvent();
      }
      switch (info.type) {
        case "reset":
          if (!namePathList || namePathMatch) {
            _this.touched = false;
            _this.dirty = false;
            _this.validatePromise = null;
            _this.errors = EMPTY_ERRORS;
            _this.warnings = EMPTY_ERRORS;
            _this.triggerMetaEvent();
            onReset === null || onReset === void 0 ? void 0 : onReset();
            _this.refresh();
            return;
          }
          break;
        case "remove": {
          if (shouldUpdate) {
            _this.reRender();
            return;
          }
          break;
        }
        case "setField": {
          if (namePathMatch) {
            var data = info.data;
            if ("touched" in data) {
              _this.touched = data.touched;
            }
            if ("validating" in data && !("originRCField" in data)) {
              _this.validatePromise = data.validating ? Promise.resolve([]) : null;
            }
            if ("errors" in data) {
              _this.errors = data.errors || EMPTY_ERRORS;
            }
            if ("warnings" in data) {
              _this.warnings = data.warnings || EMPTY_ERRORS;
            }
            _this.dirty = true;
            _this.triggerMetaEvent();
            _this.reRender();
            return;
          }
          if (shouldUpdate && !namePath.length && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
        }
        case "dependenciesUpdate": {
          var dependencyList = dependencies.map(getNamePath);
          if (dependencyList.some(function(dependency) {
            return containsNamePath(info.relatedFields, dependency);
          })) {
            _this.reRender();
            return;
          }
          break;
        }
        default:
          if (namePathMatch || (!dependencies.length || namePath.length || shouldUpdate) && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
      }
      if (shouldUpdate === true) {
        _this.reRender();
      }
    };
    _this.validateRules = function(options) {
      var namePath = _this.getNamePath();
      var currentValue = _this.getValue();
      var rootPromise = Promise.resolve().then(function() {
        if (!_this.mounted) {
          return [];
        }
        var _this$props5 = _this.props, _this$props5$validate = _this$props5.validateFirst, validateFirst = _this$props5$validate === void 0 ? false : _this$props5$validate, messageVariables = _this$props5.messageVariables;
        var _ref2 = options || {}, triggerName = _ref2.triggerName;
        var filteredRules = _this.getRules();
        if (triggerName) {
          filteredRules = filteredRules.filter(function(rule) {
            var validateTrigger = rule.validateTrigger;
            if (!validateTrigger) {
              return true;
            }
            var triggerList = toArray(validateTrigger);
            return triggerList.includes(triggerName);
          });
        }
        var promise = validateRules(namePath, currentValue, filteredRules, options, validateFirst, messageVariables);
        promise.catch(function(e2) {
          return e2;
        }).then(function() {
          var ruleErrors = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : EMPTY_ERRORS;
          if (_this.validatePromise === rootPromise) {
            _this.validatePromise = null;
            var nextErrors = [];
            var nextWarnings = [];
            ruleErrors.forEach(function(_ref3) {
              var warningOnly = _ref3.rule.warningOnly, _ref3$errors = _ref3.errors, errors = _ref3$errors === void 0 ? EMPTY_ERRORS : _ref3$errors;
              if (warningOnly) {
                nextWarnings.push.apply(nextWarnings, _toConsumableArray(errors));
              } else {
                nextErrors.push.apply(nextErrors, _toConsumableArray(errors));
              }
            });
            _this.errors = nextErrors;
            _this.warnings = nextWarnings;
            _this.triggerMetaEvent();
            _this.reRender();
          }
        });
        return promise;
      });
      _this.validatePromise = rootPromise;
      _this.dirty = true;
      _this.errors = EMPTY_ERRORS;
      _this.warnings = EMPTY_ERRORS;
      _this.triggerMetaEvent();
      _this.reRender();
      return rootPromise;
    };
    _this.isFieldValidating = function() {
      return !!_this.validatePromise;
    };
    _this.isFieldTouched = function() {
      return _this.touched;
    };
    _this.isFieldDirty = function() {
      if (_this.dirty || _this.props.initialValue !== void 0) {
        return true;
      }
      var fieldContext = _this.props.fieldContext;
      var _fieldContext$getInte = fieldContext.getInternalHooks(HOOK_MARK), getInitialValue = _fieldContext$getInte.getInitialValue;
      if (getInitialValue(_this.getNamePath()) !== void 0) {
        return true;
      }
      return false;
    };
    _this.getErrors = function() {
      return _this.errors;
    };
    _this.getWarnings = function() {
      return _this.warnings;
    };
    _this.isListField = function() {
      return _this.props.isListField;
    };
    _this.isList = function() {
      return _this.props.isList;
    };
    _this.isPreserve = function() {
      return _this.props.preserve;
    };
    _this.getMeta = function() {
      _this.prevValidating = _this.isFieldValidating();
      var meta = {
        touched: _this.isFieldTouched(),
        validating: _this.prevValidating,
        errors: _this.errors,
        warnings: _this.warnings,
        name: _this.getNamePath()
      };
      return meta;
    };
    _this.getOnlyChild = function(children) {
      if (typeof children === "function") {
        var meta = _this.getMeta();
        return _objectSpread2(_objectSpread2({}, _this.getOnlyChild(children(_this.getControlled(), meta, _this.props.fieldContext))), {}, {
          isFunction: true
        });
      }
      var childList = toArray$1(children);
      if (childList.length !== 1 || !/* @__PURE__ */ React.isValidElement(childList[0])) {
        return {
          child: childList,
          isFunction: false
        };
      }
      return {
        child: childList[0],
        isFunction: false
      };
    };
    _this.getValue = function(store) {
      var getFieldsValue = _this.props.fieldContext.getFieldsValue;
      var namePath = _this.getNamePath();
      return getValue(store || getFieldsValue(true), namePath);
    };
    _this.getControlled = function() {
      var childProps = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      var _this$props6 = _this.props, trigger2 = _this$props6.trigger, validateTrigger = _this$props6.validateTrigger, getValueFromEvent = _this$props6.getValueFromEvent, normalize2 = _this$props6.normalize, valuePropName = _this$props6.valuePropName, getValueProps = _this$props6.getValueProps, fieldContext = _this$props6.fieldContext;
      var mergedValidateTrigger = validateTrigger !== void 0 ? validateTrigger : fieldContext.validateTrigger;
      var namePath = _this.getNamePath();
      var getInternalHooks3 = fieldContext.getInternalHooks, getFieldsValue = fieldContext.getFieldsValue;
      var _getInternalHooks = getInternalHooks3(HOOK_MARK), dispatch2 = _getInternalHooks.dispatch;
      var value = _this.getValue();
      var mergedGetValueProps = getValueProps || function(val) {
        return _defineProperty({}, valuePropName, val);
      };
      var originTriggerFunc = childProps[trigger2];
      var control = _objectSpread2(_objectSpread2({}, childProps), mergedGetValueProps(value));
      control[trigger2] = function() {
        _this.touched = true;
        _this.dirty = true;
        _this.triggerMetaEvent();
        var newValue;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        if (getValueFromEvent) {
          newValue = getValueFromEvent.apply(void 0, args);
        } else {
          newValue = defaultGetValueFromEvent.apply(void 0, [valuePropName].concat(args));
        }
        if (normalize2) {
          newValue = normalize2(newValue, value, getFieldsValue(true));
        }
        dispatch2({
          type: "updateValue",
          namePath,
          value: newValue
        });
        if (originTriggerFunc) {
          originTriggerFunc.apply(void 0, args);
        }
      };
      var validateTriggerList = toArray(mergedValidateTrigger || []);
      validateTriggerList.forEach(function(triggerName) {
        var originTrigger = control[triggerName];
        control[triggerName] = function() {
          if (originTrigger) {
            originTrigger.apply(void 0, arguments);
          }
          var rules2 = _this.props.rules;
          if (rules2 && rules2.length) {
            dispatch2({
              type: "validateField",
              namePath,
              triggerName
            });
          }
        };
      });
      return control;
    };
    if (props.fieldContext) {
      var getInternalHooks2 = props.fieldContext.getInternalHooks;
      var _getInternalHooks2 = getInternalHooks2(HOOK_MARK), initEntityValue = _getInternalHooks2.initEntityValue;
      initEntityValue(_assertThisInitialized(_this));
    }
    return _this;
  }
  _createClass(Field2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props7 = this.props, shouldUpdate = _this$props7.shouldUpdate, fieldContext = _this$props7.fieldContext;
      this.mounted = true;
      if (fieldContext) {
        var getInternalHooks2 = fieldContext.getInternalHooks;
        var _getInternalHooks3 = getInternalHooks2(HOOK_MARK), registerField = _getInternalHooks3.registerField;
        this.cancelRegisterFunc = registerField(this);
      }
      if (shouldUpdate === true) {
        this.reRender();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cancelRegister();
      this.triggerMetaEvent(true);
      this.mounted = false;
    }
  }, {
    key: "reRender",
    value: function reRender() {
      if (!this.mounted)
        return;
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render2() {
      var resetCount = this.state.resetCount;
      var children = this.props.children;
      var _this$getOnlyChild = this.getOnlyChild(children), child = _this$getOnlyChild.child, isFunction2 = _this$getOnlyChild.isFunction;
      var returnChildNode;
      if (isFunction2) {
        returnChildNode = child;
      } else if (/* @__PURE__ */ React.isValidElement(child)) {
        returnChildNode = /* @__PURE__ */ React.cloneElement(child, this.getControlled(child.props));
      } else {
        warningOnce(!child, "`children` of Field is not validate ReactElement.");
        returnChildNode = child;
      }
      return /* @__PURE__ */ React.createElement(React.Fragment, {
        key: resetCount
      }, returnChildNode);
    }
  }]);
  return Field2;
}(React.Component);
Field.contextType = Context;
Field.defaultProps = {
  trigger: "onChange",
  valuePropName: "value"
};
function WrapperField(_ref5) {
  var name = _ref5.name, restProps = _objectWithoutProperties(_ref5, _excluded$2);
  var fieldContext = React.useContext(Context);
  var namePath = name !== void 0 ? getNamePath(name) : void 0;
  var key = "keep";
  if (!restProps.isListField) {
    key = "_".concat((namePath || []).join("_"));
  }
  return /* @__PURE__ */ React.createElement(Field, _extends$1({
    key,
    name: namePath
  }, restProps, {
    fieldContext
  }));
}
var ListContext = /* @__PURE__ */ React.createContext(null);
var List = function List2(_ref) {
  var name = _ref.name, initialValue = _ref.initialValue, children = _ref.children, rules2 = _ref.rules, validateTrigger = _ref.validateTrigger;
  var context = React.useContext(Context);
  var keyRef = React.useRef({
    keys: [],
    id: 0
  });
  var keyManager = keyRef.current;
  var prefixName = React.useMemo(function() {
    var parentPrefixName = getNamePath(context.prefixName) || [];
    return [].concat(_toConsumableArray(parentPrefixName), _toConsumableArray(getNamePath(name)));
  }, [context.prefixName, name]);
  var fieldContext = React.useMemo(function() {
    return _objectSpread2(_objectSpread2({}, context), {}, {
      prefixName
    });
  }, [context, prefixName]);
  var listContext = React.useMemo(function() {
    return {
      getKey: function getKey2(namePath) {
        var len2 = prefixName.length;
        var pathName = namePath[len2];
        return [keyManager.keys[pathName], namePath.slice(len2 + 1)];
      }
    };
  }, [prefixName]);
  if (typeof children !== "function") {
    warningOnce(false, "Form.List only accepts function as children.");
    return null;
  }
  var shouldUpdate = function shouldUpdate2(prevValue, nextValue, _ref2) {
    var source = _ref2.source;
    if (source === "internal") {
      return false;
    }
    return prevValue !== nextValue;
  };
  return /* @__PURE__ */ React.createElement(ListContext.Provider, {
    value: listContext
  }, /* @__PURE__ */ React.createElement(Context.Provider, {
    value: fieldContext
  }, /* @__PURE__ */ React.createElement(WrapperField, {
    name: [],
    shouldUpdate,
    rules: rules2,
    validateTrigger,
    initialValue,
    isList: true
  }, function(_ref3, meta) {
    var _ref3$value = _ref3.value, value = _ref3$value === void 0 ? [] : _ref3$value, onChange = _ref3.onChange;
    var getFieldValue = context.getFieldValue;
    var getNewValue = function getNewValue2() {
      var values = getFieldValue(prefixName || []);
      return values || [];
    };
    var operations = {
      add: function add2(defaultValue, index2) {
        var newValue = getNewValue();
        if (index2 >= 0 && index2 <= newValue.length) {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys.slice(0, index2)), [keyManager.id], _toConsumableArray(keyManager.keys.slice(index2)));
          onChange([].concat(_toConsumableArray(newValue.slice(0, index2)), [defaultValue], _toConsumableArray(newValue.slice(index2))));
        } else {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys), [keyManager.id]);
          onChange([].concat(_toConsumableArray(newValue), [defaultValue]));
        }
        keyManager.id += 1;
      },
      remove: function remove(index2) {
        var newValue = getNewValue();
        var indexSet = new Set(Array.isArray(index2) ? index2 : [index2]);
        if (indexSet.size <= 0) {
          return;
        }
        keyManager.keys = keyManager.keys.filter(function(_, keysIndex) {
          return !indexSet.has(keysIndex);
        });
        onChange(newValue.filter(function(_, valueIndex) {
          return !indexSet.has(valueIndex);
        }));
      },
      move: function move$1(from, to) {
        if (from === to) {
          return;
        }
        var newValue = getNewValue();
        if (from < 0 || from >= newValue.length || to < 0 || to >= newValue.length) {
          return;
        }
        keyManager.keys = move(keyManager.keys, from, to);
        onChange(move(newValue, from, to));
      }
    };
    var listValue = value || [];
    if (!Array.isArray(listValue)) {
      listValue = [];
    }
    return children(listValue.map(function(__, index2) {
      var key = keyManager.keys[index2];
      if (key === void 0) {
        keyManager.keys[index2] = keyManager.id;
        key = keyManager.keys[index2];
        keyManager.id += 1;
      }
      return {
        name: index2,
        key,
        isListField: true
      };
    }), operations, meta);
  })));
};
function allPromiseFinish(promiseList) {
  var hasError = false;
  var count2 = promiseList.length;
  var results = [];
  if (!promiseList.length) {
    return Promise.resolve([]);
  }
  return new Promise(function(resolve, reject) {
    promiseList.forEach(function(promise, index2) {
      promise.catch(function(e2) {
        hasError = true;
        return e2;
      }).then(function(result) {
        count2 -= 1;
        results[index2] = result;
        if (count2 > 0) {
          return;
        }
        if (hasError) {
          reject(results);
        }
        resolve(results);
      });
    });
  });
}
var SPLIT = "__@field_split__";
function normalize(namePath) {
  return namePath.map(function(cell) {
    return "".concat(_typeof(cell), ":").concat(cell);
  }).join(SPLIT);
}
var NameMap = /* @__PURE__ */ function() {
  function NameMap2() {
    _classCallCheck(this, NameMap2);
    this.kvs = /* @__PURE__ */ new Map();
  }
  _createClass(NameMap2, [{
    key: "set",
    value: function set2(key, value) {
      this.kvs.set(normalize(key), value);
    }
  }, {
    key: "get",
    value: function get2(key) {
      return this.kvs.get(normalize(key));
    }
  }, {
    key: "update",
    value: function update(key, updater) {
      var origin = this.get(key);
      var next = updater(origin);
      if (!next) {
        this.delete(key);
      } else {
        this.set(key, next);
      }
    }
  }, {
    key: "delete",
    value: function _delete(key) {
      this.kvs.delete(normalize(key));
    }
  }, {
    key: "map",
    value: function map2(callback) {
      return _toConsumableArray(this.kvs.entries()).map(function(_ref) {
        var _ref2 = _slicedToArray(_ref, 2), key = _ref2[0], value = _ref2[1];
        var cells = key.split(SPLIT);
        return callback({
          key: cells.map(function(cell) {
            var _cell$match = cell.match(/^([^:]*):(.*)$/), _cell$match2 = _slicedToArray(_cell$match, 3), type4 = _cell$match2[1], unit = _cell$match2[2];
            return type4 === "number" ? Number(unit) : unit;
          }),
          value
        });
      });
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = {};
      this.map(function(_ref3) {
        var key = _ref3.key, value = _ref3.value;
        json[key.join(".")] = value;
        return null;
      });
      return json;
    }
  }]);
  return NameMap2;
}();
var _excluded$1 = ["name", "errors"];
var FormStore = /* @__PURE__ */ _createClass(function FormStore2(forceRootUpdate) {
  var _this = this;
  _classCallCheck(this, FormStore2);
  this.formHooked = false;
  this.forceRootUpdate = void 0;
  this.subscribable = true;
  this.store = {};
  this.fieldEntities = [];
  this.initialValues = {};
  this.callbacks = {};
  this.validateMessages = null;
  this.preserve = null;
  this.lastValidatePromise = null;
  this.getForm = function() {
    return {
      getFieldValue: _this.getFieldValue,
      getFieldsValue: _this.getFieldsValue,
      getFieldError: _this.getFieldError,
      getFieldWarning: _this.getFieldWarning,
      getFieldsError: _this.getFieldsError,
      isFieldsTouched: _this.isFieldsTouched,
      isFieldTouched: _this.isFieldTouched,
      isFieldValidating: _this.isFieldValidating,
      isFieldsValidating: _this.isFieldsValidating,
      resetFields: _this.resetFields,
      setFields: _this.setFields,
      setFieldsValue: _this.setFieldsValue,
      validateFields: _this.validateFields,
      submit: _this.submit,
      getInternalHooks: _this.getInternalHooks
    };
  };
  this.getInternalHooks = function(key) {
    if (key === HOOK_MARK) {
      _this.formHooked = true;
      return {
        dispatch: _this.dispatch,
        initEntityValue: _this.initEntityValue,
        registerField: _this.registerField,
        useSubscribe: _this.useSubscribe,
        setInitialValues: _this.setInitialValues,
        setCallbacks: _this.setCallbacks,
        setValidateMessages: _this.setValidateMessages,
        getFields: _this.getFields,
        setPreserve: _this.setPreserve,
        getInitialValue: _this.getInitialValue
      };
    }
    warningOnce(false, "`getInternalHooks` is internal usage. Should not call directly.");
    return null;
  };
  this.useSubscribe = function(subscribable) {
    _this.subscribable = subscribable;
  };
  this.setInitialValues = function(initialValues, init2) {
    _this.initialValues = initialValues || {};
    if (init2) {
      _this.store = setValues({}, initialValues, _this.store);
    }
  };
  this.getInitialValue = function(namePath) {
    return getValue(_this.initialValues, namePath);
  };
  this.setCallbacks = function(callbacks) {
    _this.callbacks = callbacks;
  };
  this.setValidateMessages = function(validateMessages) {
    _this.validateMessages = validateMessages;
  };
  this.setPreserve = function(preserve) {
    _this.preserve = preserve;
  };
  this.timeoutId = null;
  this.warningUnhooked = function() {
  };
  this.getFieldEntities = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    if (!pure) {
      return _this.fieldEntities;
    }
    return _this.fieldEntities.filter(function(field) {
      return field.getNamePath().length;
    });
  };
  this.getFieldsMap = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    var cache = new NameMap();
    _this.getFieldEntities(pure).forEach(function(field) {
      var namePath = field.getNamePath();
      cache.set(namePath, field);
    });
    return cache;
  };
  this.getFieldEntitiesForNamePathList = function(nameList) {
    if (!nameList) {
      return _this.getFieldEntities(true);
    }
    var cache = _this.getFieldsMap(true);
    return nameList.map(function(name) {
      var namePath = getNamePath(name);
      return cache.get(namePath) || {
        INVALIDATE_NAME_PATH: getNamePath(name)
      };
    });
  };
  this.getFieldsValue = function(nameList, filterFunc) {
    _this.warningUnhooked();
    if (nameList === true && !filterFunc) {
      return _this.store;
    }
    var fieldEntities = _this.getFieldEntitiesForNamePathList(Array.isArray(nameList) ? nameList : null);
    var filteredNameList = [];
    fieldEntities.forEach(function(entity) {
      var _entity$isListField;
      var namePath = "INVALIDATE_NAME_PATH" in entity ? entity.INVALIDATE_NAME_PATH : entity.getNamePath();
      if (!nameList && ((_entity$isListField = entity.isListField) === null || _entity$isListField === void 0 ? void 0 : _entity$isListField.call(entity))) {
        return;
      }
      if (!filterFunc) {
        filteredNameList.push(namePath);
      } else {
        var meta = "getMeta" in entity ? entity.getMeta() : null;
        if (filterFunc(meta)) {
          filteredNameList.push(namePath);
        }
      }
    });
    return cloneByNamePathList(_this.store, filteredNameList.map(getNamePath));
  };
  this.getFieldValue = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    return getValue(_this.store, namePath);
  };
  this.getFieldsError = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntitiesForNamePathList(nameList);
    return fieldEntities.map(function(entity, index2) {
      if (entity && !("INVALIDATE_NAME_PATH" in entity)) {
        return {
          name: entity.getNamePath(),
          errors: entity.getErrors(),
          warnings: entity.getWarnings()
        };
      }
      return {
        name: getNamePath(nameList[index2]),
        errors: [],
        warnings: []
      };
    });
  };
  this.getFieldError = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.errors;
  };
  this.getFieldWarning = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.warnings;
  };
  this.isFieldsTouched = function() {
    _this.warningUnhooked();
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var arg0 = args[0], arg1 = args[1];
    var namePathList;
    var isAllFieldsTouched = false;
    if (args.length === 0) {
      namePathList = null;
    } else if (args.length === 1) {
      if (Array.isArray(arg0)) {
        namePathList = arg0.map(getNamePath);
        isAllFieldsTouched = false;
      } else {
        namePathList = null;
        isAllFieldsTouched = arg0;
      }
    } else {
      namePathList = arg0.map(getNamePath);
      isAllFieldsTouched = arg1;
    }
    var fieldEntities = _this.getFieldEntities(true);
    var isFieldTouched = function isFieldTouched2(field) {
      return field.isFieldTouched();
    };
    if (!namePathList) {
      return isAllFieldsTouched ? fieldEntities.every(isFieldTouched) : fieldEntities.some(isFieldTouched);
    }
    var map2 = new NameMap();
    namePathList.forEach(function(shortNamePath) {
      map2.set(shortNamePath, []);
    });
    fieldEntities.forEach(function(field) {
      var fieldNamePath = field.getNamePath();
      namePathList.forEach(function(shortNamePath) {
        if (shortNamePath.every(function(nameUnit, i) {
          return fieldNamePath[i] === nameUnit;
        })) {
          map2.update(shortNamePath, function(list) {
            return [].concat(_toConsumableArray(list), [field]);
          });
        }
      });
    });
    var isNamePathListTouched = function isNamePathListTouched2(entities) {
      return entities.some(isFieldTouched);
    };
    var namePathListEntities = map2.map(function(_ref) {
      var value = _ref.value;
      return value;
    });
    return isAllFieldsTouched ? namePathListEntities.every(isNamePathListTouched) : namePathListEntities.some(isNamePathListTouched);
  };
  this.isFieldTouched = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsTouched([name]);
  };
  this.isFieldsValidating = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntities();
    if (!nameList) {
      return fieldEntities.some(function(testField) {
        return testField.isFieldValidating();
      });
    }
    var namePathList = nameList.map(getNamePath);
    return fieldEntities.some(function(testField) {
      var fieldNamePath = testField.getNamePath();
      return containsNamePath(namePathList, fieldNamePath) && testField.isFieldValidating();
    });
  };
  this.isFieldValidating = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsValidating([name]);
  };
  this.resetWithFieldInitialValue = function() {
    var info = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var cache = new NameMap();
    var fieldEntities = _this.getFieldEntities(true);
    fieldEntities.forEach(function(field) {
      var initialValue = field.props.initialValue;
      var namePath = field.getNamePath();
      if (initialValue !== void 0) {
        var records = cache.get(namePath) || /* @__PURE__ */ new Set();
        records.add({
          entity: field,
          value: initialValue
        });
        cache.set(namePath, records);
      }
    });
    var resetWithFields = function resetWithFields2(entities) {
      entities.forEach(function(field) {
        var initialValue = field.props.initialValue;
        if (initialValue !== void 0) {
          var namePath = field.getNamePath();
          var formInitialValue = _this.getInitialValue(namePath);
          if (formInitialValue !== void 0) {
            warningOnce(false, "Form already set 'initialValues' with path '".concat(namePath.join("."), "'. Field can not overwrite it."));
          } else {
            var records = cache.get(namePath);
            if (records && records.size > 1) {
              warningOnce(false, "Multiple Field with path '".concat(namePath.join("."), "' set 'initialValue'. Can not decide which one to pick."));
            } else if (records) {
              var originValue = _this.getFieldValue(namePath);
              if (!info.skipExist || originValue === void 0) {
                _this.store = setValue(_this.store, namePath, _toConsumableArray(records)[0].value);
              }
            }
          }
        }
      });
    };
    var requiredFieldEntities;
    if (info.entities) {
      requiredFieldEntities = info.entities;
    } else if (info.namePathList) {
      requiredFieldEntities = [];
      info.namePathList.forEach(function(namePath) {
        var records = cache.get(namePath);
        if (records) {
          var _requiredFieldEntitie;
          (_requiredFieldEntitie = requiredFieldEntities).push.apply(_requiredFieldEntitie, _toConsumableArray(_toConsumableArray(records).map(function(r2) {
            return r2.entity;
          })));
        }
      });
    } else {
      requiredFieldEntities = fieldEntities;
    }
    resetWithFields(requiredFieldEntities);
  };
  this.resetFields = function(nameList) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (!nameList) {
      _this.store = setValues({}, _this.initialValues);
      _this.resetWithFieldInitialValue();
      _this.notifyObservers(prevStore, null, {
        type: "reset"
      });
      return;
    }
    var namePathList = nameList.map(getNamePath);
    namePathList.forEach(function(namePath) {
      var initialValue = _this.getInitialValue(namePath);
      _this.store = setValue(_this.store, namePath, initialValue);
    });
    _this.resetWithFieldInitialValue({
      namePathList
    });
    _this.notifyObservers(prevStore, namePathList, {
      type: "reset"
    });
  };
  this.setFields = function(fields) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    fields.forEach(function(fieldData) {
      var name = fieldData.name;
      fieldData.errors;
      var data = _objectWithoutProperties(fieldData, _excluded$1);
      var namePath = getNamePath(name);
      if ("value" in data) {
        _this.store = setValue(_this.store, namePath, data.value);
      }
      _this.notifyObservers(prevStore, [namePath], {
        type: "setField",
        data: fieldData
      });
    });
  };
  this.getFields = function() {
    var entities = _this.getFieldEntities(true);
    var fields = entities.map(function(field) {
      var namePath = field.getNamePath();
      var meta = field.getMeta();
      var fieldData = _objectSpread2(_objectSpread2({}, meta), {}, {
        name: namePath,
        value: _this.getFieldValue(namePath)
      });
      Object.defineProperty(fieldData, "originRCField", {
        value: true
      });
      return fieldData;
    });
    return fields;
  };
  this.initEntityValue = function(entity) {
    var initialValue = entity.props.initialValue;
    if (initialValue !== void 0) {
      var namePath = entity.getNamePath();
      var prevValue = getValue(_this.store, namePath);
      if (prevValue === void 0) {
        _this.store = setValue(_this.store, namePath, initialValue);
      }
    }
  };
  this.registerField = function(entity) {
    _this.fieldEntities.push(entity);
    if (entity.props.initialValue !== void 0) {
      var prevStore = _this.store;
      _this.resetWithFieldInitialValue({
        entities: [entity],
        skipExist: true
      });
      _this.notifyObservers(prevStore, [entity.getNamePath()], {
        type: "valueUpdate",
        source: "internal"
      });
    }
    return function(isListField, preserve) {
      var subNamePath = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
      _this.fieldEntities = _this.fieldEntities.filter(function(item) {
        return item !== entity;
      });
      var mergedPreserve = preserve !== void 0 ? preserve : _this.preserve;
      if (mergedPreserve === false && (!isListField || subNamePath.length > 1)) {
        var namePath = entity.getNamePath();
        var defaultValue = isListField ? void 0 : getValue(_this.initialValues, namePath);
        if (namePath.length && _this.getFieldValue(namePath) !== defaultValue && _this.fieldEntities.every(function(field) {
          return !matchNamePath(field.getNamePath(), namePath);
        })) {
          var _prevStore = _this.store;
          _this.store = setValue(_prevStore, namePath, defaultValue, true);
          _this.notifyObservers(_prevStore, [namePath], {
            type: "remove"
          });
          _this.triggerDependenciesUpdate(_prevStore, namePath);
        }
      }
    };
  };
  this.dispatch = function(action) {
    switch (action.type) {
      case "updateValue": {
        var namePath = action.namePath, value = action.value;
        _this.updateValue(namePath, value);
        break;
      }
      case "validateField": {
        var _namePath = action.namePath, triggerName = action.triggerName;
        _this.validateFields([_namePath], {
          triggerName
        });
        break;
      }
    }
  };
  this.notifyObservers = function(prevStore, namePathList, info) {
    if (_this.subscribable) {
      var mergedInfo = _objectSpread2(_objectSpread2({}, info), {}, {
        store: _this.getFieldsValue(true)
      });
      _this.getFieldEntities().forEach(function(_ref2) {
        var onStoreChange = _ref2.onStoreChange;
        onStoreChange(prevStore, namePathList, mergedInfo);
      });
    } else {
      _this.forceRootUpdate();
    }
  };
  this.triggerDependenciesUpdate = function(prevStore, namePath) {
    var childrenFields = _this.getDependencyChildrenFields(namePath);
    if (childrenFields.length) {
      _this.validateFields(childrenFields);
    }
    _this.notifyObservers(prevStore, childrenFields, {
      type: "dependenciesUpdate",
      relatedFields: [namePath].concat(_toConsumableArray(childrenFields))
    });
    return childrenFields;
  };
  this.updateValue = function(name, value) {
    var namePath = getNamePath(name);
    var prevStore = _this.store;
    _this.store = setValue(_this.store, namePath, value);
    _this.notifyObservers(prevStore, [namePath], {
      type: "valueUpdate",
      source: "internal"
    });
    var childrenFields = _this.triggerDependenciesUpdate(prevStore, namePath);
    var onValuesChange = _this.callbacks.onValuesChange;
    if (onValuesChange) {
      var changedValues = cloneByNamePathList(_this.store, [namePath]);
      onValuesChange(changedValues, _this.getFieldsValue());
    }
    _this.triggerOnFieldsChange([namePath].concat(_toConsumableArray(childrenFields)));
  };
  this.setFieldsValue = function(store) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (store) {
      _this.store = setValues(_this.store, store);
    }
    _this.notifyObservers(prevStore, null, {
      type: "valueUpdate",
      source: "external"
    });
  };
  this.getDependencyChildrenFields = function(rootNamePath) {
    var children = /* @__PURE__ */ new Set();
    var childrenFields = [];
    var dependencies2fields = new NameMap();
    _this.getFieldEntities().forEach(function(field) {
      var dependencies = field.props.dependencies;
      (dependencies || []).forEach(function(dependency) {
        var dependencyNamePath = getNamePath(dependency);
        dependencies2fields.update(dependencyNamePath, function() {
          var fields = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
          fields.add(field);
          return fields;
        });
      });
    });
    var fillChildren = function fillChildren2(namePath) {
      var fields = dependencies2fields.get(namePath) || /* @__PURE__ */ new Set();
      fields.forEach(function(field) {
        if (!children.has(field)) {
          children.add(field);
          var fieldNamePath = field.getNamePath();
          if (field.isFieldDirty() && fieldNamePath.length) {
            childrenFields.push(fieldNamePath);
            fillChildren2(fieldNamePath);
          }
        }
      });
    };
    fillChildren(rootNamePath);
    return childrenFields;
  };
  this.triggerOnFieldsChange = function(namePathList, filedErrors) {
    var onFieldsChange = _this.callbacks.onFieldsChange;
    if (onFieldsChange) {
      var fields = _this.getFields();
      if (filedErrors) {
        var cache = new NameMap();
        filedErrors.forEach(function(_ref3) {
          var name = _ref3.name, errors = _ref3.errors;
          cache.set(name, errors);
        });
        fields.forEach(function(field) {
          field.errors = cache.get(field.name) || field.errors;
        });
      }
      var changedFields = fields.filter(function(_ref4) {
        var fieldName = _ref4.name;
        return containsNamePath(namePathList, fieldName);
      });
      onFieldsChange(changedFields, fields);
    }
  };
  this.validateFields = function(nameList, options) {
    _this.warningUnhooked();
    var provideNameList = !!nameList;
    var namePathList = provideNameList ? nameList.map(getNamePath) : [];
    var promiseList = [];
    _this.getFieldEntities(true).forEach(function(field) {
      if (!provideNameList) {
        namePathList.push(field.getNamePath());
      }
      if ((options === null || options === void 0 ? void 0 : options.recursive) && provideNameList) {
        var namePath = field.getNamePath();
        if (namePath.every(function(nameUnit, i) {
          return nameList[i] === nameUnit || nameList[i] === void 0;
        })) {
          namePathList.push(namePath);
        }
      }
      if (!field.props.rules || !field.props.rules.length) {
        return;
      }
      var fieldNamePath = field.getNamePath();
      if (!provideNameList || containsNamePath(namePathList, fieldNamePath)) {
        var promise = field.validateRules(_objectSpread2({
          validateMessages: _objectSpread2(_objectSpread2({}, defaultValidateMessages), _this.validateMessages)
        }, options));
        promiseList.push(promise.then(function() {
          return {
            name: fieldNamePath,
            errors: [],
            warnings: []
          };
        }).catch(function(ruleErrors) {
          var mergedErrors = [];
          var mergedWarnings = [];
          ruleErrors.forEach(function(_ref5) {
            var warningOnly = _ref5.rule.warningOnly, errors = _ref5.errors;
            if (warningOnly) {
              mergedWarnings.push.apply(mergedWarnings, _toConsumableArray(errors));
            } else {
              mergedErrors.push.apply(mergedErrors, _toConsumableArray(errors));
            }
          });
          if (mergedErrors.length) {
            return Promise.reject({
              name: fieldNamePath,
              errors: mergedErrors,
              warnings: mergedWarnings
            });
          }
          return {
            name: fieldNamePath,
            errors: mergedErrors,
            warnings: mergedWarnings
          };
        }));
      }
    });
    var summaryPromise = allPromiseFinish(promiseList);
    _this.lastValidatePromise = summaryPromise;
    summaryPromise.catch(function(results) {
      return results;
    }).then(function(results) {
      var resultNamePathList = results.map(function(_ref6) {
        var name = _ref6.name;
        return name;
      });
      _this.notifyObservers(_this.store, resultNamePathList, {
        type: "validateFinish"
      });
      _this.triggerOnFieldsChange(resultNamePathList, results);
    });
    var returnPromise = summaryPromise.then(function() {
      if (_this.lastValidatePromise === summaryPromise) {
        return Promise.resolve(_this.getFieldsValue(namePathList));
      }
      return Promise.reject([]);
    }).catch(function(results) {
      var errorList = results.filter(function(result) {
        return result && result.errors.length;
      });
      return Promise.reject({
        values: _this.getFieldsValue(namePathList),
        errorFields: errorList,
        outOfDate: _this.lastValidatePromise !== summaryPromise
      });
    });
    returnPromise.catch(function(e2) {
      return e2;
    });
    return returnPromise;
  };
  this.submit = function() {
    _this.warningUnhooked();
    _this.validateFields().then(function(values) {
      var onFinish = _this.callbacks.onFinish;
      if (onFinish) {
        try {
          onFinish(values);
        } catch (err) {
          console.error(err);
        }
      }
    }).catch(function(e2) {
      var onFinishFailed = _this.callbacks.onFinishFailed;
      if (onFinishFailed) {
        onFinishFailed(e2);
      }
    });
  };
  this.forceRootUpdate = forceRootUpdate;
});
function useForm(form) {
  var formRef = React.useRef();
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray(_React$useState, 2), forceUpdate = _React$useState2[1];
  if (!formRef.current) {
    if (form) {
      formRef.current = form;
    } else {
      var forceReRender = function forceReRender2() {
        forceUpdate({});
      };
      var formStore = new FormStore(forceReRender);
      formRef.current = formStore.getForm();
    }
  }
  return [formRef.current];
}
var FormContext = /* @__PURE__ */ React.createContext({
  triggerFormChange: function triggerFormChange() {
  },
  triggerFormFinish: function triggerFormFinish() {
  },
  registerForm: function registerForm() {
  },
  unregisterForm: function unregisterForm() {
  }
});
var FormProvider = function FormProvider2(_ref) {
  var validateMessages = _ref.validateMessages, onFormChange = _ref.onFormChange, onFormFinish = _ref.onFormFinish, children = _ref.children;
  var formContext = React.useContext(FormContext);
  var formsRef = React.useRef({});
  return /* @__PURE__ */ React.createElement(FormContext.Provider, {
    value: _objectSpread2(_objectSpread2({}, formContext), {}, {
      validateMessages: _objectSpread2(_objectSpread2({}, formContext.validateMessages), validateMessages),
      triggerFormChange: function triggerFormChange2(name, changedFields) {
        if (onFormChange) {
          onFormChange(name, {
            changedFields,
            forms: formsRef.current
          });
        }
        formContext.triggerFormChange(name, changedFields);
      },
      triggerFormFinish: function triggerFormFinish2(name, values) {
        if (onFormFinish) {
          onFormFinish(name, {
            values,
            forms: formsRef.current
          });
        }
        formContext.triggerFormFinish(name, values);
      },
      registerForm: function registerForm2(name, form) {
        if (name) {
          formsRef.current = _objectSpread2(_objectSpread2({}, formsRef.current), {}, _defineProperty({}, name, form));
        }
        formContext.registerForm(name, form);
      },
      unregisterForm: function unregisterForm2(name) {
        var newForms = _objectSpread2({}, formsRef.current);
        delete newForms[name];
        formsRef.current = newForms;
        formContext.unregisterForm(name);
      }
    })
  }, children);
};
var _excluded = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"];
var Form = function Form2(_ref, ref) {
  var name = _ref.name, initialValues = _ref.initialValues, fields = _ref.fields, form = _ref.form, preserve = _ref.preserve, children = _ref.children, _ref$component = _ref.component, Component = _ref$component === void 0 ? "form" : _ref$component, validateMessages = _ref.validateMessages, _ref$validateTrigger = _ref.validateTrigger, validateTrigger = _ref$validateTrigger === void 0 ? "onChange" : _ref$validateTrigger, onValuesChange = _ref.onValuesChange, _onFieldsChange = _ref.onFieldsChange, _onFinish = _ref.onFinish, onFinishFailed = _ref.onFinishFailed, restProps = _objectWithoutProperties(_ref, _excluded);
  var formContext = React.useContext(FormContext);
  var _useForm = useForm(form), _useForm2 = _slicedToArray(_useForm, 1), formInstance = _useForm2[0];
  var _formInstance$getInte = formInstance.getInternalHooks(HOOK_MARK), useSubscribe = _formInstance$getInte.useSubscribe, setInitialValues = _formInstance$getInte.setInitialValues, setCallbacks = _formInstance$getInte.setCallbacks, setValidateMessages = _formInstance$getInte.setValidateMessages, setPreserve = _formInstance$getInte.setPreserve;
  React.useImperativeHandle(ref, function() {
    return formInstance;
  });
  React.useEffect(function() {
    formContext.registerForm(name, formInstance);
    return function() {
      formContext.unregisterForm(name);
    };
  }, [formContext, formInstance, name]);
  setValidateMessages(_objectSpread2(_objectSpread2({}, formContext.validateMessages), validateMessages));
  setCallbacks({
    onValuesChange,
    onFieldsChange: function onFieldsChange(changedFields) {
      formContext.triggerFormChange(name, changedFields);
      if (_onFieldsChange) {
        for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          rest[_key - 1] = arguments[_key];
        }
        _onFieldsChange.apply(void 0, [changedFields].concat(rest));
      }
    },
    onFinish: function onFinish(values2) {
      formContext.triggerFormFinish(name, values2);
      if (_onFinish) {
        _onFinish(values2);
      }
    },
    onFinishFailed
  });
  setPreserve(preserve);
  var mountRef = React.useRef(null);
  setInitialValues(initialValues, !mountRef.current);
  if (!mountRef.current) {
    mountRef.current = true;
  }
  var childrenNode = children;
  var childrenRenderProps = typeof children === "function";
  if (childrenRenderProps) {
    var values = formInstance.getFieldsValue(true);
    childrenNode = children(values, formInstance);
  }
  useSubscribe(!childrenRenderProps);
  var prevFieldsRef = React.useRef();
  React.useEffect(function() {
    if (!isSimilar(prevFieldsRef.current || [], fields || [])) {
      formInstance.setFields(fields || []);
    }
    prevFieldsRef.current = fields;
  }, [fields, formInstance]);
  var formContextValue = React.useMemo(function() {
    return _objectSpread2(_objectSpread2({}, formInstance), {}, {
      validateTrigger
    });
  }, [formInstance, validateTrigger]);
  var wrapperNode = /* @__PURE__ */ React.createElement(Context.Provider, {
    value: formContextValue
  }, childrenNode);
  if (Component === false) {
    return wrapperNode;
  }
  return /* @__PURE__ */ React.createElement(Component, _extends$1({}, restProps, {
    onSubmit: function onSubmit(event) {
      event.preventDefault();
      event.stopPropagation();
      formInstance.submit();
    },
    onReset: function onReset(event) {
      var _restProps$onReset;
      event.preventDefault();
      formInstance.resetFields();
      (_restProps$onReset = restProps.onReset) === null || _restProps$onReset === void 0 ? void 0 : _restProps$onReset.call(restProps, event);
    }
  }), wrapperNode);
};
var InternalForm = /* @__PURE__ */ React.forwardRef(Form);
var RefForm = InternalForm;
RefForm.FormProvider = FormProvider;
RefForm.Field = WrapperField;
RefForm.List = List;
RefForm.useForm = useForm;
var devWarning = function(valid, component, message) {
  warningOnce(valid, "[antd: ".concat(component, "] ").concat(message));
};
var enUS$1 = {
  items_per_page: "/ page",
  jump_to: "Go to",
  jump_to_confirm: "confirm",
  page: "Page",
  prev_page: "Previous Page",
  next_page: "Next Page",
  prev_5: "Previous 5 Pages",
  next_5: "Next 5 Pages",
  prev_3: "Previous 3 Pages",
  next_3: "Next 3 Pages",
  page_size: "Page Size"
};
var locale$2 = {
  locale: "en_US",
  today: "Today",
  now: "Now",
  backToToday: "Back to today",
  ok: "Ok",
  clear: "Clear",
  month: "Month",
  year: "Year",
  timeSelect: "select time",
  dateSelect: "select date",
  weekSelect: "Choose a week",
  monthSelect: "Choose a month",
  yearSelect: "Choose a year",
  decadeSelect: "Choose a decade",
  yearFormat: "YYYY",
  dateFormat: "M/D/YYYY",
  dayFormat: "D",
  dateTimeFormat: "M/D/YYYY HH:mm:ss",
  monthBeforeYear: true,
  previousMonth: "Previous month (PageUp)",
  nextMonth: "Next month (PageDown)",
  previousYear: "Last year (Control + left)",
  nextYear: "Next year (Control + right)",
  previousDecade: "Last decade",
  nextDecade: "Next decade",
  previousCentury: "Last century",
  nextCentury: "Next century"
};
var locale$1 = {
  placeholder: "Select time",
  rangePlaceholder: ["Start time", "End time"]
};
var TimePicker = locale$1;
var locale = {
  lang: _extends$1({
    placeholder: "Select date",
    yearPlaceholder: "Select year",
    quarterPlaceholder: "Select quarter",
    monthPlaceholder: "Select month",
    weekPlaceholder: "Select week",
    rangePlaceholder: ["Start date", "End date"],
    rangeYearPlaceholder: ["Start year", "End year"],
    rangeQuarterPlaceholder: ["Start quarter", "End quarter"],
    rangeMonthPlaceholder: ["Start month", "End month"],
    rangeWeekPlaceholder: ["Start week", "End week"]
  }, locale$2),
  timePickerLocale: _extends$1({}, TimePicker)
};
var enUS = locale;
var typeTemplate = "${label} is not a valid ${type}";
var localeValues = {
  locale: "en",
  Pagination: enUS$1,
  DatePicker: enUS,
  TimePicker,
  Calendar: enUS,
  global: {
    placeholder: "Please select"
  },
  Table: {
    filterTitle: "Filter menu",
    filterConfirm: "OK",
    filterReset: "Reset",
    filterEmptyText: "No filters",
    filterCheckall: "Select all items",
    filterSearchPlaceholder: "Search in filters",
    emptyText: "No data",
    selectAll: "Select current page",
    selectInvert: "Invert current page",
    selectNone: "Clear all data",
    selectionAll: "Select all data",
    sortTitle: "Sort",
    expand: "Expand row",
    collapse: "Collapse row",
    triggerDesc: "Click to sort descending",
    triggerAsc: "Click to sort ascending",
    cancelSort: "Click to cancel sorting"
  },
  Modal: {
    okText: "OK",
    cancelText: "Cancel",
    justOkText: "OK"
  },
  Popconfirm: {
    okText: "OK",
    cancelText: "Cancel"
  },
  Transfer: {
    titles: ["", ""],
    searchPlaceholder: "Search here",
    itemUnit: "item",
    itemsUnit: "items",
    remove: "Remove",
    selectCurrent: "Select current page",
    removeCurrent: "Remove current page",
    selectAll: "Select all data",
    removeAll: "Remove all data",
    selectInvert: "Invert current page"
  },
  Upload: {
    uploading: "Uploading...",
    removeFile: "Remove file",
    uploadError: "Upload error",
    previewFile: "Preview file",
    downloadFile: "Download file"
  },
  Empty: {
    description: "No Data"
  },
  Icon: {
    icon: "icon"
  },
  Text: {
    edit: "Edit",
    copy: "Copy",
    copied: "Copied",
    expand: "Expand"
  },
  PageHeader: {
    back: "Back"
  },
  Form: {
    optional: "(optional)",
    defaultValidateMessages: {
      "default": "Field validation error for ${label}",
      required: "Please enter ${label}",
      "enum": "${label} must be one of [${enum}]",
      whitespace: "${label} cannot be a blank character",
      date: {
        format: "${label} date format is invalid",
        parse: "${label} cannot be converted to a date",
        invalid: "${label} is an invalid date"
      },
      types: {
        string: typeTemplate,
        method: typeTemplate,
        array: typeTemplate,
        object: typeTemplate,
        number: typeTemplate,
        date: typeTemplate,
        "boolean": typeTemplate,
        integer: typeTemplate,
        "float": typeTemplate,
        regexp: typeTemplate,
        email: typeTemplate,
        url: typeTemplate,
        hex: typeTemplate
      },
      string: {
        len: "${label} must be ${len} characters",
        min: "${label} must be at least ${min} characters",
        max: "${label} must be up to ${max} characters",
        range: "${label} must be between ${min}-${max} characters"
      },
      number: {
        len: "${label} must be equal to ${len}",
        min: "${label} must be minimum ${min}",
        max: "${label} must be maximum ${max}",
        range: "${label} must be between ${min}-${max}"
      },
      array: {
        len: "Must be ${len} ${label}",
        min: "At least ${min} ${label}",
        max: "At most ${max} ${label}",
        range: "The amount of ${label} must be between ${min}-${max}"
      },
      pattern: {
        mismatch: "${label} does not match the pattern ${pattern}"
      }
    }
  },
  Image: {
    preview: "Preview"
  }
};
var defaultLocale = localeValues;
var LocaleContext = /* @__PURE__ */ createContext(void 0);
var LocaleContext$1 = LocaleContext;
var LocaleReceiver = /* @__PURE__ */ function(_React$Component) {
  _inherits(LocaleReceiver2, _React$Component);
  var _super = _createSuper(LocaleReceiver2);
  function LocaleReceiver2() {
    _classCallCheck(this, LocaleReceiver2);
    return _super.apply(this, arguments);
  }
  _createClass(LocaleReceiver2, [{
    key: "getLocale",
    value: function getLocale() {
      var _this$props = this.props, componentName = _this$props.componentName, defaultLocale$1 = _this$props.defaultLocale;
      var locale2 = defaultLocale$1 || defaultLocale[componentName !== null && componentName !== void 0 ? componentName : "global"];
      var antLocale = this.context;
      var localeFromContext = componentName && antLocale ? antLocale[componentName] : {};
      return _extends$1(_extends$1({}, locale2 instanceof Function ? locale2() : locale2), localeFromContext || {});
    }
  }, {
    key: "getLocaleCode",
    value: function getLocaleCode() {
      var antLocale = this.context;
      var localeCode = antLocale && antLocale.locale;
      if (antLocale && antLocale.exist && !localeCode) {
        return defaultLocale.locale;
      }
      return localeCode;
    }
  }, {
    key: "render",
    value: function render2() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    }
  }]);
  return LocaleReceiver2;
}(React.Component);
LocaleReceiver.defaultProps = {
  componentName: "global"
};
LocaleReceiver.contextType = LocaleContext$1;
var Empty$2 = function Empty() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-default");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "184",
    height: "152",
    viewBox: "0 0 184 152",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(24 31.67)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "67.797",
    cy: "106.89",
    rx: "67.797",
    ry: "12.668"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-1"),
    d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-2"),
    d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z",
    transform: "translate(13.56)"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-3"),
    d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-4"),
    d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z"
  })), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-5"),
    d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    transform: "translate(149.65 15.383)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    cx: "20.654",
    cy: "3.167",
    rx: "2.849",
    ry: "2.815"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z"
  }))));
};
var DefaultEmptyImg = Empty$2;
var Simple = function Simple2() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-simple");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "64",
    height: "41",
    viewBox: "0 0 64 41",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(0 1)",
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "32",
    cy: "33",
    rx: "32",
    ry: "7"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    fillRule: "nonzero"
  }, /* @__PURE__ */ React.createElement("path", {
    d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z",
    className: "".concat(prefixCls, "-path")
  }))));
};
var SimpleEmptyImg = Simple;
var __rest$3 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var defaultEmptyImg = /* @__PURE__ */ React.createElement(DefaultEmptyImg, null);
var simpleEmptyImg = /* @__PURE__ */ React.createElement(SimpleEmptyImg, null);
var Empty2 = function Empty3(_a2) {
  var className = _a2.className, customizePrefixCls = _a2.prefixCls, _a$image = _a2.image, image = _a$image === void 0 ? defaultEmptyImg : _a$image, description = _a2.description, children = _a2.children, imageStyle = _a2.imageStyle, restProps = __rest$3(_a2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  return /* @__PURE__ */ React.createElement(LocaleReceiver, {
    componentName: "Empty"
  }, function(locale2) {
    var _classNames;
    var prefixCls = getPrefixCls("empty", customizePrefixCls);
    var des = typeof description !== "undefined" ? description : locale2.description;
    var alt = typeof des === "string" ? des : "empty";
    var imageNode = null;
    if (typeof image === "string") {
      imageNode = /* @__PURE__ */ React.createElement("img", {
        alt,
        src: image
      });
    } else {
      imageNode = image;
    }
    return /* @__PURE__ */ React.createElement("div", _extends$1({
      className: classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-normal"), image === simpleEmptyImg), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className)
    }, restProps), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-image"),
      style: imageStyle
    }, imageNode), des && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-description")
    }, des), children && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, children));
  });
};
Empty2.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty2.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
var Empty$1 = Empty2;
var renderEmpty = function renderEmpty2(componentName) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var getPrefixCls = _ref.getPrefixCls;
    var prefix = getPrefixCls("empty");
    switch (componentName) {
      case "Table":
      case "List":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE
        });
      case "Select":
      case "TreeSelect":
      case "Cascader":
      case "Transfer":
      case "Mentions":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE,
          className: "".concat(prefix, "-small")
        });
      default:
        return /* @__PURE__ */ React.createElement(Empty$1, null);
    }
  });
};
var defaultRenderEmpty = renderEmpty;
var defaultGetPrefixCls = function defaultGetPrefixCls2(suffixCls, customizePrefixCls) {
  if (customizePrefixCls)
    return customizePrefixCls;
  return suffixCls ? "ant-".concat(suffixCls) : "ant";
};
var ConfigContext = /* @__PURE__ */ React.createContext({
  getPrefixCls: defaultGetPrefixCls,
  renderEmpty: defaultRenderEmpty
});
var ConfigConsumer = ConfigContext.Consumer;
var SizeContext = /* @__PURE__ */ React.createContext(void 0);
var SizeContext$1 = SizeContext;
var raf = function raf2(callback) {
  return +setTimeout(callback, 16);
};
var caf = function caf2(num) {
  return clearTimeout(num);
};
if (typeof window !== "undefined" && "requestAnimationFrame" in window) {
  raf = function raf3(callback) {
    return window.requestAnimationFrame(callback);
  };
  caf = function caf3(handle) {
    return window.cancelAnimationFrame(handle);
  };
}
var rafUUID = 0;
var rafIds = /* @__PURE__ */ new Map();
function cleanup(id2) {
  rafIds.delete(id2);
}
function wrapperRaf$1(callback) {
  var times = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  rafUUID += 1;
  var id2 = rafUUID;
  function callRef(leftTimes) {
    if (leftTimes === 0) {
      cleanup(id2);
      callback();
    } else {
      var realId = raf(function() {
        callRef(leftTimes - 1);
      });
      rafIds.set(id2, realId);
    }
  }
  callRef(times);
  return id2;
}
wrapperRaf$1.cancel = function(id2) {
  var realId = rafIds.get(id2);
  cleanup(realId);
  return caf(realId);
};
function useControlledState(defaultStateValue, option) {
  var _ref = option || {}, defaultValue = _ref.defaultValue, value = _ref.value, onChange = _ref.onChange, postState = _ref.postState;
  var _React$useState = React.useState(function() {
    if (value !== void 0) {
      return value;
    }
    if (defaultValue !== void 0) {
      return typeof defaultValue === "function" ? defaultValue() : defaultValue;
    }
    return typeof defaultStateValue === "function" ? defaultStateValue() : defaultStateValue;
  }), _React$useState2 = _slicedToArray(_React$useState, 2), innerValue = _React$useState2[0], setInnerValue = _React$useState2[1];
  var mergedValue = value !== void 0 ? value : innerValue;
  if (postState) {
    mergedValue = postState(mergedValue);
  }
  var onChangeRef = React.useRef(onChange);
  onChangeRef.current = onChange;
  var triggerChange = React.useCallback(function(newValue) {
    setInnerValue(newValue);
    if (mergedValue !== newValue && onChangeRef.current) {
      onChangeRef.current(newValue, mergedValue);
    }
  }, [mergedValue, onChangeRef]);
  var firstRenderRef = React.useRef(true);
  React.useEffect(function() {
    if (firstRenderRef.current) {
      firstRenderRef.current = false;
      return;
    }
    if (value === void 0) {
      setInnerValue(value);
    }
  }, [value]);
  return [mergedValue, triggerChange];
}
var KeyCode = {
  MAC_ENTER: 3,
  BACKSPACE: 8,
  TAB: 9,
  NUM_CENTER: 12,
  ENTER: 13,
  SHIFT: 16,
  CTRL: 17,
  ALT: 18,
  PAUSE: 19,
  CAPS_LOCK: 20,
  ESC: 27,
  SPACE: 32,
  PAGE_UP: 33,
  PAGE_DOWN: 34,
  END: 35,
  HOME: 36,
  LEFT: 37,
  UP: 38,
  RIGHT: 39,
  DOWN: 40,
  PRINT_SCREEN: 44,
  INSERT: 45,
  DELETE: 46,
  ZERO: 48,
  ONE: 49,
  TWO: 50,
  THREE: 51,
  FOUR: 52,
  FIVE: 53,
  SIX: 54,
  SEVEN: 55,
  EIGHT: 56,
  NINE: 57,
  QUESTION_MARK: 63,
  A: 65,
  B: 66,
  C: 67,
  D: 68,
  E: 69,
  F: 70,
  G: 71,
  H: 72,
  I: 73,
  J: 74,
  K: 75,
  L: 76,
  M: 77,
  N: 78,
  O: 79,
  P: 80,
  Q: 81,
  R: 82,
  S: 83,
  T: 84,
  U: 85,
  V: 86,
  W: 87,
  X: 88,
  Y: 89,
  Z: 90,
  META: 91,
  WIN_KEY_RIGHT: 92,
  CONTEXT_MENU: 93,
  NUM_ZERO: 96,
  NUM_ONE: 97,
  NUM_TWO: 98,
  NUM_THREE: 99,
  NUM_FOUR: 100,
  NUM_FIVE: 101,
  NUM_SIX: 102,
  NUM_SEVEN: 103,
  NUM_EIGHT: 104,
  NUM_NINE: 105,
  NUM_MULTIPLY: 106,
  NUM_PLUS: 107,
  NUM_MINUS: 109,
  NUM_PERIOD: 110,
  NUM_DIVISION: 111,
  F1: 112,
  F2: 113,
  F3: 114,
  F4: 115,
  F5: 116,
  F6: 117,
  F7: 118,
  F8: 119,
  F9: 120,
  F10: 121,
  F11: 122,
  F12: 123,
  NUMLOCK: 144,
  SEMICOLON: 186,
  DASH: 189,
  EQUALS: 187,
  COMMA: 188,
  PERIOD: 190,
  SLASH: 191,
  APOSTROPHE: 192,
  SINGLE_QUOTE: 222,
  OPEN_SQUARE_BRACKET: 219,
  BACKSLASH: 220,
  CLOSE_SQUARE_BRACKET: 221,
  WIN_KEY: 224,
  MAC_FF_META: 224,
  WIN_IME: 229,
  isTextModifyingKeyEvent: function isTextModifyingKeyEvent(e2) {
    var keyCode = e2.keyCode;
    if (e2.altKey && !e2.ctrlKey || e2.metaKey || keyCode >= KeyCode.F1 && keyCode <= KeyCode.F12) {
      return false;
    }
    switch (keyCode) {
      case KeyCode.ALT:
      case KeyCode.CAPS_LOCK:
      case KeyCode.CONTEXT_MENU:
      case KeyCode.CTRL:
      case KeyCode.DOWN:
      case KeyCode.END:
      case KeyCode.ESC:
      case KeyCode.HOME:
      case KeyCode.INSERT:
      case KeyCode.LEFT:
      case KeyCode.MAC_FF_META:
      case KeyCode.META:
      case KeyCode.NUMLOCK:
      case KeyCode.NUM_CENTER:
      case KeyCode.PAGE_DOWN:
      case KeyCode.PAGE_UP:
      case KeyCode.PAUSE:
      case KeyCode.PRINT_SCREEN:
      case KeyCode.RIGHT:
      case KeyCode.SHIFT:
      case KeyCode.UP:
      case KeyCode.WIN_KEY:
      case KeyCode.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  },
  isCharacterKey: function isCharacterKey(keyCode) {
    if (keyCode >= KeyCode.ZERO && keyCode <= KeyCode.NINE) {
      return true;
    }
    if (keyCode >= KeyCode.NUM_ZERO && keyCode <= KeyCode.NUM_MULTIPLY) {
      return true;
    }
    if (keyCode >= KeyCode.A && keyCode <= KeyCode.Z) {
      return true;
    }
    if (window.navigator.userAgent.indexOf("WebKit") !== -1 && keyCode === 0) {
      return true;
    }
    switch (keyCode) {
      case KeyCode.SPACE:
      case KeyCode.QUESTION_MARK:
      case KeyCode.NUM_PLUS:
      case KeyCode.NUM_MINUS:
      case KeyCode.NUM_PERIOD:
      case KeyCode.NUM_DIVISION:
      case KeyCode.SEMICOLON:
      case KeyCode.DASH:
      case KeyCode.EQUALS:
      case KeyCode.COMMA:
      case KeyCode.PERIOD:
      case KeyCode.SLASH:
      case KeyCode.APOSTROPHE:
      case KeyCode.SINGLE_QUOTE:
      case KeyCode.OPEN_SQUARE_BRACKET:
      case KeyCode.BACKSLASH:
      case KeyCode.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  }
};
var tuple = function tuple2() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return args;
};
var isValidElement = React.isValidElement;
function replaceElement(element, replacement, props) {
  if (!isValidElement(element))
    return replacement;
  return /* @__PURE__ */ React.cloneElement(element, typeof props === "function" ? props(element.props || {}) : props);
}
function cloneElement(element, props) {
  return replaceElement(element, element, props);
}
var responsiveArray = ["xxl", "xl", "lg", "md", "sm", "xs"];
var responsiveMap = {
  xs: "(max-width: 575px)",
  sm: "(min-width: 576px)",
  md: "(min-width: 768px)",
  lg: "(min-width: 992px)",
  xl: "(min-width: 1200px)",
  xxl: "(min-width: 1600px)"
};
var subscribers = /* @__PURE__ */ new Map();
var subUid = -1;
var screens = {};
var responsiveObserve = {
  matchHandlers: {},
  dispatch: function dispatch(pointMap) {
    screens = pointMap;
    subscribers.forEach(function(func) {
      return func(screens);
    });
    return subscribers.size >= 1;
  },
  subscribe: function subscribe(func) {
    if (!subscribers.size)
      this.register();
    subUid += 1;
    subscribers.set(subUid, func);
    func(screens);
    return subUid;
  },
  unsubscribe: function unsubscribe(token) {
    subscribers["delete"](token);
    if (!subscribers.size)
      this.unregister();
  },
  unregister: function unregister2() {
    var _this = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var handler = _this.matchHandlers[matchMediaQuery];
      handler === null || handler === void 0 ? void 0 : handler.mql.removeListener(handler === null || handler === void 0 ? void 0 : handler.listener);
    });
    subscribers.clear();
  },
  register: function register3() {
    var _this2 = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var listener = function listener2(_ref) {
        var matches = _ref.matches;
        _this2.dispatch(_extends$1(_extends$1({}, screens), _defineProperty({}, screen, matches)));
      };
      var mql = window.matchMedia(matchMediaQuery);
      mql.addListener(listener);
      _this2.matchHandlers[matchMediaQuery] = {
        mql,
        listener
      };
      listener(mql);
    });
  }
};
var ResponsiveObserve = responsiveObserve;
var id = 0;
var ids = {};
function wrapperRaf(callback) {
  var delayFrames = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  var myId = id++;
  var restFrames = delayFrames;
  function internalCallback() {
    restFrames -= 1;
    if (restFrames <= 0) {
      callback();
      delete ids[myId];
    } else {
      ids[myId] = wrapperRaf$1(internalCallback);
    }
  }
  ids[myId] = wrapperRaf$1(internalCallback);
  return myId;
}
wrapperRaf.cancel = function cancel(pid) {
  if (pid === void 0)
    return;
  wrapperRaf$1.cancel(ids[pid]);
  delete ids[pid];
};
wrapperRaf.ids = ids;
var styleForPseudo;
function isHidden(element) {
  return !element || element.offsetParent === null || element.hidden;
}
function isNotGrey(color) {
  var match = (color || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
  if (match && match[1] && match[2] && match[3]) {
    return !(match[1] === match[2] && match[2] === match[3]);
  }
  return true;
}
var Wave = /* @__PURE__ */ function(_React$Component) {
  _inherits(Wave2, _React$Component);
  var _super = _createSuper(Wave2);
  function Wave2() {
    var _this;
    _classCallCheck(this, Wave2);
    _this = _super.apply(this, arguments);
    _this.containerRef = /* @__PURE__ */ React.createRef();
    _this.animationStart = false;
    _this.destroyed = false;
    _this.onClick = function(node, waveColor) {
      var _a2, _b2;
      var _this$props = _this.props, insertExtraNode = _this$props.insertExtraNode, disabled = _this$props.disabled;
      if (disabled || !node || isHidden(node) || node.className.indexOf("-leave") >= 0) {
        return;
      }
      _this.extraNode = document.createElement("div");
      var _assertThisInitialize = _assertThisInitialized(_this), extraNode = _assertThisInitialize.extraNode;
      var getPrefixCls = _this.context.getPrefixCls;
      extraNode.className = "".concat(getPrefixCls(""), "-click-animating-node");
      var attributeName = _this.getAttributeName();
      node.setAttribute(attributeName, "true");
      if (waveColor && waveColor !== "#ffffff" && waveColor !== "rgb(255, 255, 255)" && isNotGrey(waveColor) && !/rgba\((?:\d*, ){3}0\)/.test(waveColor) && waveColor !== "transparent") {
        extraNode.style.borderColor = waveColor;
        var nodeRoot = ((_a2 = node.getRootNode) === null || _a2 === void 0 ? void 0 : _a2.call(node)) || node.ownerDocument;
        var nodeBody = nodeRoot instanceof Document ? nodeRoot.body : (_b2 = nodeRoot.firstChild) !== null && _b2 !== void 0 ? _b2 : nodeRoot;
        styleForPseudo = updateCSS("\n      [".concat(getPrefixCls(""), "-click-animating-without-extra-node='true']::after, .").concat(getPrefixCls(""), "-click-animating-node {\n        --antd-wave-shadow-color: ").concat(waveColor, ";\n      }"), "antd-wave", {
          csp: _this.csp,
          attachTo: nodeBody
        });
      }
      if (insertExtraNode) {
        node.appendChild(extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.addEventListener("".concat(name, "start"), _this.onTransitionStart);
        node.addEventListener("".concat(name, "end"), _this.onTransitionEnd);
      });
    };
    _this.onTransitionStart = function(e2) {
      if (_this.destroyed) {
        return;
      }
      var node = _this.containerRef.current;
      if (!e2 || e2.target !== node || _this.animationStart) {
        return;
      }
      _this.resetEffect(node);
    };
    _this.onTransitionEnd = function(e2) {
      if (!e2 || e2.animationName !== "fadeEffect") {
        return;
      }
      _this.resetEffect(e2.target);
    };
    _this.bindAnimationEvent = function(node) {
      if (!node || !node.getAttribute || node.getAttribute("disabled") || node.className.indexOf("disabled") >= 0) {
        return;
      }
      var onClick = function onClick2(e2) {
        if (e2.target.tagName === "INPUT" || isHidden(e2.target)) {
          return;
        }
        _this.resetEffect(node);
        var waveColor = getComputedStyle(node).getPropertyValue("border-top-color") || getComputedStyle(node).getPropertyValue("border-color") || getComputedStyle(node).getPropertyValue("background-color");
        _this.clickWaveTimeoutId = window.setTimeout(function() {
          return _this.onClick(node, waveColor);
        }, 0);
        wrapperRaf.cancel(_this.animationStartId);
        _this.animationStart = true;
        _this.animationStartId = wrapperRaf(function() {
          _this.animationStart = false;
        }, 10);
      };
      node.addEventListener("click", onClick, true);
      return {
        cancel: function cancel2() {
          node.removeEventListener("click", onClick, true);
        }
      };
    };
    _this.renderWave = function(_ref) {
      var csp = _ref.csp;
      var children = _this.props.children;
      _this.csp = csp;
      if (!/* @__PURE__ */ React.isValidElement(children))
        return children;
      var ref = _this.containerRef;
      if (supportRef(children)) {
        ref = composeRef(children.ref, _this.containerRef);
      }
      return cloneElement(children, {
        ref
      });
    };
    return _this;
  }
  _createClass(Wave2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = this.containerRef.current;
      if (!node || node.nodeType !== 1) {
        return;
      }
      this.instance = this.bindAnimationEvent(node);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.instance) {
        this.instance.cancel();
      }
      if (this.clickWaveTimeoutId) {
        clearTimeout(this.clickWaveTimeoutId);
      }
      this.destroyed = true;
    }
  }, {
    key: "getAttributeName",
    value: function getAttributeName() {
      var getPrefixCls = this.context.getPrefixCls;
      var insertExtraNode = this.props.insertExtraNode;
      return insertExtraNode ? "".concat(getPrefixCls(""), "-click-animating") : "".concat(getPrefixCls(""), "-click-animating-without-extra-node");
    }
  }, {
    key: "resetEffect",
    value: function resetEffect(node) {
      var _this2 = this;
      if (!node || node === this.extraNode || !(node instanceof Element)) {
        return;
      }
      var insertExtraNode = this.props.insertExtraNode;
      var attributeName = this.getAttributeName();
      node.setAttribute(attributeName, "false");
      if (styleForPseudo) {
        styleForPseudo.innerHTML = "";
      }
      if (insertExtraNode && this.extraNode && node.contains(this.extraNode)) {
        node.removeChild(this.extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.removeEventListener("".concat(name, "start"), _this2.onTransitionStart);
        node.removeEventListener("".concat(name, "end"), _this2.onTransitionEnd);
      });
    }
  }, {
    key: "render",
    value: function render2() {
      return /* @__PURE__ */ React.createElement(ConfigConsumer, null, this.renderWave);
    }
  }]);
  return Wave2;
}(React.Component);
Wave.contextType = ConfigContext;
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React__default, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c2, a, k2) {
  var b2, d2 = {}, e2 = null, l2 = null;
  k2 !== void 0 && (e2 = "" + k2);
  a.key !== void 0 && (e2 = "" + a.key);
  a.ref !== void 0 && (l2 = a.ref);
  for (b2 in a)
    n.call(a, b2) && !p.hasOwnProperty(b2) && (d2[b2] = a[b2]);
  if (c2 && c2.defaultProps)
    for (b2 in a = c2.defaultProps, a)
      d2[b2] === void 0 && (d2[b2] = a[b2]);
  return { $$typeof: g, type: c2, key: e2, ref: l2, props: d2, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const jsxs = jsxRuntime.exports.jsxs;
var RowContext = /* @__PURE__ */ createContext({});
var RowContext$1 = RowContext;
var canUseDocElement = function canUseDocElement2() {
  return canUseDom() && window.document.documentElement;
};
var flexGapSupported;
var detectFlexGapSupported = function detectFlexGapSupported2() {
  if (!canUseDocElement()) {
    return false;
  }
  if (flexGapSupported !== void 0) {
    return flexGapSupported;
  }
  var flex = document.createElement("div");
  flex.style.display = "flex";
  flex.style.flexDirection = "column";
  flex.style.rowGap = "1px";
  flex.appendChild(document.createElement("div"));
  flex.appendChild(document.createElement("div"));
  document.body.appendChild(flex);
  flexGapSupported = flex.scrollHeight === 1;
  document.body.removeChild(flex);
  return flexGapSupported;
};
var useFlexGapSupport = function() {
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), flexible = _React$useState2[0], setFlexible = _React$useState2[1];
  React.useEffect(function() {
    setFlexible(detectFlexGapSupported());
  }, []);
  return flexible;
};
var __rest$2 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
tuple("top", "middle", "bottom", "stretch");
tuple("start", "end", "center", "space-around", "space-between");
var Row = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var customizePrefixCls = props.prefixCls, justify = props.justify, align = props.align, className = props.className, style = props.style, children = props.children, _props$gutter = props.gutter, gutter = _props$gutter === void 0 ? 0 : _props$gutter, wrap = props.wrap, others = __rest$2(props, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useState = React.useState({
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
    xxl: true
  }), _React$useState2 = _slicedToArray(_React$useState, 2), screens2 = _React$useState2[0], setScreens = _React$useState2[1];
  var supportFlexGap = useFlexGapSupport();
  var gutterRef = React.useRef(gutter);
  React.useEffect(function() {
    var token = ResponsiveObserve.subscribe(function(screen) {
      var currentGutter = gutterRef.current || 0;
      if (!Array.isArray(currentGutter) && _typeof(currentGutter) === "object" || Array.isArray(currentGutter) && (_typeof(currentGutter[0]) === "object" || _typeof(currentGutter[1]) === "object")) {
        setScreens(screen);
      }
    });
    return function() {
      return ResponsiveObserve.unsubscribe(token);
    };
  }, []);
  var getGutter = function getGutter2() {
    var results = [0, 0];
    var normalizedGutter = Array.isArray(gutter) ? gutter : [gutter, 0];
    normalizedGutter.forEach(function(g2, index2) {
      if (_typeof(g2) === "object") {
        for (var i = 0; i < responsiveArray.length; i++) {
          var breakpoint = responsiveArray[i];
          if (screens2[breakpoint] && g2[breakpoint] !== void 0) {
            results[index2] = g2[breakpoint];
            break;
          }
        }
      } else {
        results[index2] = g2 || 0;
      }
    });
    return results;
  };
  var prefixCls = getPrefixCls("row", customizePrefixCls);
  var gutters = getGutter();
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-no-wrap"), wrap === false), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(justify), justify), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(align), align), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var rowStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / -2 : void 0;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / -2 : void 0;
  if (horizontalGutter) {
    rowStyle.marginLeft = horizontalGutter;
    rowStyle.marginRight = horizontalGutter;
  }
  if (supportFlexGap) {
    var _gutters = _slicedToArray(gutters, 2);
    rowStyle.rowGap = _gutters[1];
  } else if (verticalGutter) {
    rowStyle.marginTop = verticalGutter;
    rowStyle.marginBottom = verticalGutter;
  }
  var _gutters2 = _slicedToArray(gutters, 2), gutterH = _gutters2[0], gutterV = _gutters2[1];
  var rowContext = React.useMemo(function() {
    return {
      gutter: [gutterH, gutterV],
      wrap,
      supportFlexGap
    };
  }, [gutterH, gutterV, wrap, supportFlexGap]);
  return /* @__PURE__ */ React.createElement(RowContext$1.Provider, {
    value: rowContext
  }, /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    className: classes,
    style: _extends$1(_extends$1({}, rowStyle), style),
    ref
  }), children));
});
Row.displayName = "Row";
var Row$1 = Row;
var __rest$1 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function parseFlex(flex) {
  if (typeof flex === "number") {
    return "".concat(flex, " ").concat(flex, " auto");
  }
  if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(flex)) {
    return "0 0 ".concat(flex);
  }
  return flex;
}
var sizes = ["xs", "sm", "md", "lg", "xl", "xxl"];
var Col = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useContext2 = React.useContext(RowContext$1), gutter = _React$useContext2.gutter, wrap = _React$useContext2.wrap, supportFlexGap = _React$useContext2.supportFlexGap;
  var customizePrefixCls = props.prefixCls, span = props.span, order = props.order, offset = props.offset, push2 = props.push, pull = props.pull, className = props.className, children = props.children, flex = props.flex, style = props.style, others = __rest$1(props, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]);
  var prefixCls = getPrefixCls("col", customizePrefixCls);
  var sizeClassObj = {};
  sizes.forEach(function(size) {
    var _extends2;
    var sizeProps = {};
    var propSize = props[size];
    if (typeof propSize === "number") {
      sizeProps.span = propSize;
    } else if (_typeof(propSize) === "object") {
      sizeProps = propSize || {};
    }
    delete others[size];
    sizeClassObj = _extends$1(_extends$1({}, sizeClassObj), (_extends2 = {}, _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-").concat(sizeProps.span), sizeProps.span !== void 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-order-").concat(sizeProps.order), sizeProps.order || sizeProps.order === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-offset-").concat(sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-push-").concat(sizeProps.push), sizeProps.push || sizeProps.push === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-pull-").concat(sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _defineProperty(_extends2, "".concat(prefixCls, "-rtl"), direction === "rtl"), _extends2));
  });
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(span), span !== void 0), _defineProperty(_classNames, "".concat(prefixCls, "-order-").concat(order), order), _defineProperty(_classNames, "".concat(prefixCls, "-offset-").concat(offset), offset), _defineProperty(_classNames, "".concat(prefixCls, "-push-").concat(push2), push2), _defineProperty(_classNames, "".concat(prefixCls, "-pull-").concat(pull), pull), _classNames), className, sizeClassObj);
  var mergedStyle = {};
  if (gutter && gutter[0] > 0) {
    var horizontalGutter = gutter[0] / 2;
    mergedStyle.paddingLeft = horizontalGutter;
    mergedStyle.paddingRight = horizontalGutter;
  }
  if (gutter && gutter[1] > 0 && !supportFlexGap) {
    var verticalGutter = gutter[1] / 2;
    mergedStyle.paddingTop = verticalGutter;
    mergedStyle.paddingBottom = verticalGutter;
  }
  if (flex) {
    mergedStyle.flex = parseFlex(flex);
    if (wrap === false && !mergedStyle.minWidth) {
      mergedStyle.minWidth = 0;
    }
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    style: _extends$1(_extends$1({}, mergedStyle), style),
    className: classes,
    ref
  }), children);
});
Col.displayName = "Col";
var Col$1 = Col;
var Switch$2 = React.forwardRef(function(_ref, ref) {
  var _classNames;
  var _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-switch" : _ref$prefixCls, className = _ref.className, checked = _ref.checked, defaultChecked = _ref.defaultChecked, disabled = _ref.disabled, loadingIcon = _ref.loadingIcon, checkedChildren = _ref.checkedChildren, unCheckedChildren = _ref.unCheckedChildren, onClick = _ref.onClick, onChange = _ref.onChange, onKeyDown = _ref.onKeyDown, restProps = _objectWithoutProperties(_ref, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]);
  var _useMergedState = useControlledState(false, {
    value: checked,
    defaultValue: defaultChecked
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), innerChecked = _useMergedState2[0], setInnerChecked = _useMergedState2[1];
  function triggerChange(newChecked, event) {
    var mergedChecked = innerChecked;
    if (!disabled) {
      mergedChecked = newChecked;
      setInnerChecked(mergedChecked);
      onChange === null || onChange === void 0 ? void 0 : onChange(mergedChecked, event);
    }
    return mergedChecked;
  }
  function onInternalKeyDown(e2) {
    if (e2.which === KeyCode.LEFT) {
      triggerChange(false, e2);
    } else if (e2.which === KeyCode.RIGHT) {
      triggerChange(true, e2);
    }
    onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(e2);
  }
  function onInternalClick(e2) {
    var ret = triggerChange(!innerChecked, e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(ret, e2);
  }
  var switchClassName = classNames(prefixCls, className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-checked"), innerChecked), _defineProperty(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
  return React.createElement("button", Object.assign({}, restProps, {
    type: "button",
    role: "switch",
    "aria-checked": innerChecked,
    disabled,
    className: switchClassName,
    ref,
    onKeyDown: onInternalKeyDown,
    onClick: onInternalClick
  }), loadingIcon, React.createElement("span", {
    className: "".concat(prefixCls, "-inner")
  }, innerChecked ? checkedChildren : unCheckedChildren));
});
Switch$2.displayName = "Switch";
var __rest = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Switch = /* @__PURE__ */ React.forwardRef(function(_a2, ref) {
  var _classNames;
  var customizePrefixCls = _a2.prefixCls, customizeSize = _a2.size, loading = _a2.loading, _a$className = _a2.className, className = _a$className === void 0 ? "" : _a$className, disabled = _a2.disabled, props = __rest(_a2, ["prefixCls", "size", "loading", "className", "disabled"]);
  devWarning("checked" in props || !("value" in props), "Switch", "`value` is not a valid prop, do you mean `checked`?");
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var prefixCls = getPrefixCls("switch", customizePrefixCls);
  var loadingIcon = /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-handle")
  }, loading && /* @__PURE__ */ React.createElement(LoadingOutlined$1, {
    className: "".concat(prefixCls, "-loading-icon")
  }));
  var classes = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-small"), (customizeSize || size) === "small"), _defineProperty(_classNames, "".concat(prefixCls, "-loading"), loading), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement(Wave, {
    insertExtraNode: true
  }, /* @__PURE__ */ React.createElement(Switch$2, _extends$1({}, props, {
    prefixCls,
    className: classes,
    disabled: disabled || loading,
    ref,
    loadingIcon
  })));
});
Switch.__ANT_SWITCH = true;
Switch.displayName = "Switch";
var Switch$1 = Switch;
var _default = "";
var index$7 = "";
var index$6 = "";
var index$5 = "";
var index$4 = "";
var index$3 = "";
var index$2 = "";
var index$1 = "";
const container = "_container_oi76t_1";
var styles = {
  container,
  "function": "_function_oi76t_10"
};
var reactEchartsJson_cjs = {};
(function(exports) {
  var Qrt = Object.defineProperty;
  var Cxe = Object.getOwnPropertySymbols;
  var eat = Object.prototype.hasOwnProperty, tat = Object.prototype.propertyIsEnumerable;
  var Bne = (i, n2, e2) => n2 in i ? Qrt(i, n2, { enumerable: true, configurable: true, writable: true, value: e2 }) : i[n2] = e2, Mxe = (i, n2) => {
    for (var e2 in n2 || (n2 = {}))
      eat.call(n2, e2) && Bne(i, e2, n2[e2]);
    if (Cxe)
      for (var e2 of Cxe(n2))
        tat.call(n2, e2) && Bne(i, e2, n2[e2]);
    return i;
  };
  var Vg = (i, n2, e2) => (Bne(i, typeof n2 != "symbol" ? n2 + "" : n2, e2), e2);
  Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
  var il = React__default;
  function nat(i) {
    return i && typeof i == "object" && "default" in i ? i : { default: i };
  }
  function rat(i) {
    if (i && i.__esModule)
      return i;
    var n2 = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
    return i && Object.keys(i).forEach(function(e2) {
      if (e2 !== "default") {
        var o = Object.getOwnPropertyDescriptor(i, e2);
        Object.defineProperty(n2, e2, o.get ? o : { enumerable: true, get: function() {
          return i[e2];
        } });
      }
    }), n2.default = i, Object.freeze(n2);
  }
  var P3 = nat(il), Qr = rat(il), aat = globalThis && globalThis.__read || function(i, n2) {
    var e2 = typeof Symbol == "function" && i[Symbol.iterator];
    if (!e2)
      return i;
    var o = e2.call(i), l4, c4 = [], h;
    try {
      for (; (n2 === void 0 || n2-- > 0) && !(l4 = o.next()).done; )
        c4.push(l4.value);
    } catch (p4) {
      h = { error: p4 };
    } finally {
      try {
        l4 && !l4.done && (e2 = o.return) && e2.call(o);
      } finally {
        if (h)
          throw h.error;
      }
    }
    return c4;
  };
  function iat(i, n2) {
    i === void 0 && (i = false);
    var e2 = aat(il.useState(i), 2), o = e2[0], l4 = e2[1], c4 = il.useMemo(function() {
      var h = n2 === void 0 ? !i : n2, p4 = function() {
        return l4(function(C) {
          return C === i ? h : i;
        });
      }, g4 = function(C) {
        return l4(C);
      }, y4 = function() {
        return l4(i);
      }, _ = function() {
        return l4(h);
      };
      return { toggle: p4, set: g4, setLeft: y4, setRight: _ };
    }, []);
    return [o, c4];
  }
  var oat = globalThis && globalThis.__read || function(i, n2) {
    var e2 = typeof Symbol == "function" && i[Symbol.iterator];
    if (!e2)
      return i;
    var o = e2.call(i), l4, c4 = [], h;
    try {
      for (; (n2 === void 0 || n2-- > 0) && !(l4 = o.next()).done; )
        c4.push(l4.value);
    } catch (p4) {
      h = { error: p4 };
    } finally {
      try {
        l4 && !l4.done && (e2 = o.return) && e2.call(o);
      } finally {
        if (h)
          throw h.error;
      }
    }
    return c4;
  };
  function sat(i) {
    i === void 0 && (i = false);
    var n2 = oat(iat(i), 2), e2 = n2[0], o = n2[1], l4 = o.toggle, c4 = o.set, h = il.useMemo(function() {
      var p4 = function() {
        return c4(true);
      }, g4 = function() {
        return c4(false);
      };
      return { toggle: l4, set: function(_) {
        return c4(!!_);
      }, setTrue: p4, setFalse: g4 };
    }, []);
    return [e2, h];
  }
  function Cse(i) {
    var n2 = il.useRef(i);
    return n2.current = i, n2;
  }
  var lat = !!(typeof window != "undefined" && window.document && window.document.createElement), uat = lat;
  function uIe(i, n2) {
    if (!!uat) {
      if (!i)
        return n2;
      var e2;
      return typeof i == "function" ? e2 = i() : "current" in i ? e2 = i.current : e2 = i, e2;
    }
  }
  var cat = function(n2) {
    var e2 = Cse(n2);
    il.useEffect(function() {
      return function() {
        e2.current();
      };
    }, []);
  }, Mse = cat;
  function Axe(i, n2) {
    if (i === n2)
      return true;
    for (var e2 = 0; e2 < i.length; e2++)
      if (!Object.is(i[e2], n2[e2]))
        return false;
    return true;
  }
  var fat = function(n2) {
    var e2 = function(l4, c4, h) {
      var p4 = il.useRef(false), g4 = il.useRef([]), y4 = il.useRef([]), _ = il.useRef();
      n2(function() {
        var w4, C = Array.isArray(h) ? h : [h], E = C.map(function(T) {
          return uIe(T);
        });
        if (!p4.current) {
          p4.current = true, g4.current = E, y4.current = c4, _.current = l4();
          return;
        }
        (E.length !== g4.current.length || !Axe(E, g4.current) || !Axe(c4, y4.current)) && ((w4 = _.current) === null || w4 === void 0 || w4.call(_), g4.current = E, y4.current = c4, _.current = l4());
      }), Mse(function() {
        var w4;
        (w4 = _.current) === null || w4 === void 0 || w4.call(_), p4.current = false;
      });
    };
    return e2;
  }, hat = fat, dat = hat(il.useEffect), pat = dat, Dy = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof commonjsGlobal != "undefined" ? commonjsGlobal : typeof self != "undefined" ? self : {};
  function vat(i) {
    return i && i.__esModule && Object.prototype.hasOwnProperty.call(i, "default") ? i.default : i;
  }
  function gat(i) {
    var n2 = typeof i;
    return i != null && (n2 == "object" || n2 == "function");
  }
  var cIe = gat, mat = typeof Dy == "object" && Dy && Dy.Object === Object && Dy, yat = mat, bat = yat, _at = typeof self == "object" && self && self.Object === Object && self, xat = bat || _at || Function("return this")(), fIe = xat, wat = fIe, Sat = function() {
    return wat.Date.now();
  }, Cat = Sat, Mat = /\s/;
  function Aat(i) {
    for (var n2 = i.length; n2-- && Mat.test(i.charAt(n2)); )
      ;
    return n2;
  }
  var Eat = Aat, Iat = Eat, Tat = /^\s+/;
  function Dat(i) {
    return i && i.slice(0, Iat(i) + 1).replace(Tat, "");
  }
  var kat = Dat, Pat = fIe, Lat = Pat.Symbol, hIe = Lat, Exe = hIe, dIe = Object.prototype, Oat = dIe.hasOwnProperty, Rat = dIe.toString, qF = Exe ? Exe.toStringTag : void 0;
  function Fat(i) {
    var n2 = Oat.call(i, qF), e2 = i[qF];
    try {
      i[qF] = void 0;
      var o = true;
    } catch {
    }
    var l4 = Rat.call(i);
    return o && (n2 ? i[qF] = e2 : delete i[qF]), l4;
  }
  var Nat = Fat, Vat = Object.prototype, zat = Vat.toString;
  function Bat(i) {
    return zat.call(i);
  }
  var jat = Bat, Ixe = hIe, Gat = Nat, Wat = jat, Hat = "[object Null]", $at = "[object Undefined]", Txe = Ixe ? Ixe.toStringTag : void 0;
  function Uat(i) {
    return i == null ? i === void 0 ? $at : Hat : Txe && Txe in Object(i) ? Gat(i) : Wat(i);
  }
  var qat = Uat;
  function Yat(i) {
    return i != null && typeof i == "object";
  }
  var Zat = Yat, Xat = qat, Kat = Zat, Jat = "[object Symbol]";
  function Qat(i) {
    return typeof i == "symbol" || Kat(i) && Xat(i) == Jat;
  }
  var eit = Qat, tit = kat, Dxe = cIe, nit = eit, kxe = 0 / 0, rit = /^[-+]0x[0-9a-f]+$/i, ait = /^0b[01]+$/i, iit = /^0o[0-7]+$/i, oit = parseInt;
  function sit(i) {
    if (typeof i == "number")
      return i;
    if (nit(i))
      return kxe;
    if (Dxe(i)) {
      var n2 = typeof i.valueOf == "function" ? i.valueOf() : i;
      i = Dxe(n2) ? n2 + "" : n2;
    }
    if (typeof i != "string")
      return i === 0 ? i : +i;
    i = tit(i);
    var e2 = ait.test(i);
    return e2 || iit.test(i) ? oit(i.slice(2), e2 ? 2 : 8) : rit.test(i) ? kxe : +i;
  }
  var lit = sit, uit = cIe, jne = Cat, Pxe = lit, cit = "Expected a function", fit = Math.max, hit = Math.min;
  function dit(i, n2, e2) {
    var o, l4, c4, h, p4, g4, y4 = 0, _ = false, w4 = false, C = true;
    if (typeof i != "function")
      throw new TypeError(cit);
    n2 = Pxe(n2) || 0, uit(e2) && (_ = !!e2.leading, w4 = "maxWait" in e2, c4 = w4 ? fit(Pxe(e2.maxWait) || 0, n2) : c4, C = "trailing" in e2 ? !!e2.trailing : C);
    function E(le) {
      var me = o, ye = l4;
      return o = l4 = void 0, y4 = le, h = i.apply(ye, me), h;
    }
    function T(le) {
      return y4 = le, p4 = setTimeout(V, n2), _ ? E(le) : h;
    }
    function O(le) {
      var me = le - g4, ye = le - y4, be = n2 - me;
      return w4 ? hit(be, c4 - ye) : be;
    }
    function N(le) {
      var me = le - g4, ye = le - y4;
      return g4 === void 0 || me >= n2 || me < 0 || w4 && ye >= c4;
    }
    function V() {
      var le = jne();
      if (N(le))
        return H(le);
      p4 = setTimeout(V, O(le));
    }
    function H(le) {
      return p4 = void 0, C && o ? E(le) : (o = l4 = void 0, h);
    }
    function X() {
      p4 !== void 0 && clearTimeout(p4), y4 = 0, o = g4 = l4 = p4 = void 0;
    }
    function q2() {
      return p4 === void 0 ? h : H(jne());
    }
    function de() {
      var le = jne(), me = N(le);
      if (o = arguments, l4 = this, g4 = le, me) {
        if (p4 === void 0)
          return T(g4);
        if (w4)
          return clearTimeout(p4), p4 = setTimeout(V, n2), E(g4);
      }
      return p4 === void 0 && (p4 = setTimeout(V, n2)), h;
    }
    return de.cancel = X, de.flush = q2, de;
  }
  var pit = dit, vit = globalThis && globalThis.__read || function(i, n2) {
    var e2 = typeof Symbol == "function" && i[Symbol.iterator];
    if (!e2)
      return i;
    var o = e2.call(i), l4, c4 = [], h;
    try {
      for (; (n2 === void 0 || n2-- > 0) && !(l4 = o.next()).done; )
        c4.push(l4.value);
    } catch (p4) {
      h = { error: p4 };
    } finally {
      try {
        l4 && !l4.done && (e2 = o.return) && e2.call(o);
      } finally {
        if (h)
          throw h.error;
      }
    }
    return c4;
  }, git = globalThis && globalThis.__spread || function() {
    for (var i = [], n2 = 0; n2 < arguments.length; n2++)
      i = i.concat(vit(arguments[n2]));
    return i;
  };
  function mit(i, n2) {
    var e2, o = Cse(i), l4 = (e2 = n2 == null ? void 0 : n2.wait) !== null && e2 !== void 0 ? e2 : 1e3, c4 = il.useMemo(function() {
      return pit(function() {
        for (var h = [], p4 = 0; p4 < arguments.length; p4++)
          h[p4] = arguments[p4];
        return o.current.apply(o, git(h));
      }, l4, n2);
    }, []);
    return Mse(function() {
      c4.cancel();
    }), { run: c4, cancel: c4.cancel, flush: c4.flush };
  }
  var yit = function(n2) {
    return function(e2, o) {
      var l4 = il.useRef(false);
      n2(function() {
        return function() {
          l4.current = false;
        };
      }, []), n2(function() {
        if (!l4.current)
          l4.current = true;
        else
          return e2();
      }, o);
    };
  }, bit = yit(il.useEffect), _it = globalThis && globalThis.__read || function(i, n2) {
    var e2 = typeof Symbol == "function" && i[Symbol.iterator];
    if (!e2)
      return i;
    var o = e2.call(i), l4, c4 = [], h;
    try {
      for (; (n2 === void 0 || n2-- > 0) && !(l4 = o.next()).done; )
        c4.push(l4.value);
    } catch (p4) {
      h = { error: p4 };
    } finally {
      try {
        l4 && !l4.done && (e2 = o.return) && e2.call(o);
      } finally {
        if (h)
          throw h.error;
      }
    }
    return c4;
  };
  function xit(i, n2, e2) {
    var o = _it(il.useState({}), 2), l4 = o[0], c4 = o[1], h = mit(function() {
      c4({});
    }, e2), p4 = h.run, g4 = h.cancel;
    il.useEffect(function() {
      return p4();
    }, n2), Mse(g4), bit(i, [l4]);
  }
  function wit(i, n2, e2) {
    e2 === void 0 && (e2 = {});
    var o = Cse(n2);
    pat(function() {
      var l4 = uIe(e2.target, window);
      if (!!(l4 != null && l4.addEventListener)) {
        var c4 = function(p4) {
          return o.current(p4);
        };
        return l4.addEventListener(i, c4, { capture: e2.capture, once: e2.once, passive: e2.passive }), function() {
          l4.removeEventListener(i, c4, { capture: e2.capture });
        };
      }
    }, [i, e2.capture, e2.once, e2.passive], e2.target);
  }
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.
  
  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  var xie = function(i, n2) {
    return xie = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(e2, o) {
      e2.__proto__ = o;
    } || function(e2, o) {
      for (var l4 in o)
        Object.prototype.hasOwnProperty.call(o, l4) && (e2[l4] = o[l4]);
    }, xie(i, n2);
  };
  function on(i, n2) {
    if (typeof n2 != "function" && n2 !== null)
      throw new TypeError("Class extends value " + String(n2) + " is not a constructor or null");
    xie(i, n2);
    function e2() {
      this.constructor = i;
    }
    i.prototype = n2 === null ? Object.create(n2) : (e2.prototype = n2.prototype, new e2());
  }
  var Sit = function() {
    function i() {
      this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
    }
    return i;
  }(), Cit = function() {
    function i() {
      this.browser = new Sit(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
    }
    return i;
  }(), HI = new Cit();
  typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (HI.wxa = true, HI.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? HI.worker = true : typeof navigator == "undefined" ? (HI.node = true, HI.svgSupported = true) : Mit(navigator.userAgent, HI);
  function Mit(i, n2) {
    var e2 = n2.browser, o = i.match(/Firefox\/([\d.]+)/), l4 = i.match(/MSIE\s([\d.]+)/) || i.match(/Trident\/.+?rv:(([\d.]+))/), c4 = i.match(/Edge?\/([\d.]+)/), h = /micromessenger/i.test(i);
    o && (e2.firefox = true, e2.version = o[1]), l4 && (e2.ie = true, e2.version = l4[1]), c4 && (e2.edge = true, e2.version = c4[1], e2.newEdge = +c4[1].split(".")[0] > 18), h && (e2.weChat = true), n2.svgSupported = typeof SVGRect != "undefined", n2.touchEventsSupported = "ontouchstart" in window && !e2.ie && !e2.edge, n2.pointerEventsSupported = "onpointerdown" in window && (e2.edge || e2.ie && +e2.version >= 11), n2.domSupported = typeof document != "undefined";
    var p4 = document.documentElement.style;
    n2.transform3dSupported = (e2.ie && "transition" in p4 || e2.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in p4) && !("OTransition" in p4), n2.transformSupported = n2.transform3dSupported || e2.ie && +e2.version >= 9;
  }
  var ol = HI, Ase = 12, pIe = "sans-serif", XC = Ase + "px " + pIe, Ait = 20, Eit = 100, Iit = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
  function Tit(i) {
    var n2 = {};
    if (typeof JSON == "undefined")
      return n2;
    for (var e2 = 0; e2 < i.length; e2++) {
      var o = String.fromCharCode(e2 + 32), l4 = (i.charCodeAt(e2) - Ait) / Eit;
      n2[o] = l4;
    }
    return n2;
  }
  var Dit = Tit(Iit), y2 = { createCanvas: function() {
    return typeof document != "undefined" && document.createElement("canvas");
  }, measureText: function() {
    var i, n2;
    return function(e2, o) {
      if (!i) {
        var l4 = y2.createCanvas();
        i = l4 && l4.getContext("2d");
      }
      if (i)
        return n2 !== o && (n2 = i.font = o || XC), i.measureText(e2);
      e2 = e2 || "", o = o || XC;
      var c4 = /^([0-9]*?)px$/.exec(o), h = +(c4 && c4[1]) || Ase, p4 = 0;
      if (o.indexOf("mono") >= 0)
        p4 = h * e2.length;
      else
        for (var g4 = 0; g4 < e2.length; g4++) {
          var y4 = Dit[e2[g4]];
          p4 += y4 == null ? h : y4 * h;
        }
      return { width: p4 };
    };
  }(), loadImage: function(i, n2, e2) {
    var o = new Image();
    return o.onload = n2, o.onerror = e2, o.src = i, o;
  } }, vIe = q_(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(i, n2) {
    return i["[object " + n2 + "]"] = true, i;
  }, {}), gIe = q_(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(i, n2) {
    return i["[object " + n2 + "Array]"] = true, i;
  }, {}), G3 = Object.prototype.toString, v$ = Array.prototype, kit = v$.forEach, Pit = v$.filter, Ese = v$.slice, Lit = v$.map, Lxe = function() {
  }.constructor, zG = Lxe ? Lxe.prototype : null, Ise = "__proto__", Oit = 2311;
  function mIe() {
    return Oit++;
  }
  function Tse() {
    for (var i = [], n2 = 0; n2 < arguments.length; n2++)
      i[n2] = arguments[n2];
    typeof console != "undefined" && console.error.apply(console, i);
  }
  function Ci(i) {
    if (i == null || typeof i != "object")
      return i;
    var n2 = i, e2 = G3.call(i);
    if (e2 === "[object Array]") {
      if (!zN(i)) {
        n2 = [];
        for (var o = 0, l4 = i.length; o < l4; o++)
          n2[o] = Ci(i[o]);
      }
    } else if (gIe[e2]) {
      if (!zN(i)) {
        var c4 = i.constructor;
        if (c4.from)
          n2 = c4.from(i);
        else {
          n2 = new c4(i.length);
          for (var o = 0, l4 = i.length; o < l4; o++)
            n2[o] = i[o];
        }
      }
    } else if (!vIe[e2] && !zN(i) && !a8(i)) {
      n2 = {};
      for (var h in i)
        i.hasOwnProperty(h) && h !== Ise && (n2[h] = Ci(i[h]));
    }
    return n2;
  }
  function to(i, n2, e2) {
    if (!mi(n2) || !mi(i))
      return e2 ? Ci(n2) : i;
    for (var o in n2)
      if (n2.hasOwnProperty(o) && o !== Ise) {
        var l4 = i[o], c4 = n2[o];
        mi(c4) && mi(l4) && !Mr(c4) && !Mr(l4) && !a8(c4) && !a8(l4) && !Oxe(c4) && !Oxe(l4) && !zN(c4) && !zN(l4) ? to(l4, c4, e2) : (e2 || !(o in i)) && (i[o] = Ci(n2[o]));
      }
    return i;
  }
  function Dse(i, n2) {
    for (var e2 = i[0], o = 1, l4 = i.length; o < l4; o++)
      e2 = to(e2, i[o], n2);
    return e2;
  }
  function rr(i, n2) {
    if (Object.assign)
      Object.assign(i, n2);
    else
      for (var e2 in n2)
        n2.hasOwnProperty(e2) && e2 !== Ise && (i[e2] = n2[e2]);
    return i;
  }
  function hi(i, n2, e2) {
    for (var o = ts(n2), l4 = 0; l4 < o.length; l4++) {
      var c4 = o[l4];
      (e2 ? n2[c4] != null : i[c4] == null) && (i[c4] = n2[c4]);
    }
    return i;
  }
  function go(i, n2) {
    if (i) {
      if (i.indexOf)
        return i.indexOf(n2);
      for (var e2 = 0, o = i.length; e2 < o; e2++)
        if (i[e2] === n2)
          return e2;
    }
    return -1;
  }
  function Rit(i, n2) {
    var e2 = i.prototype;
    function o() {
    }
    o.prototype = n2.prototype, i.prototype = new o();
    for (var l4 in e2)
      e2.hasOwnProperty(l4) && (i.prototype[l4] = e2[l4]);
    i.prototype.constructor = i, i.superClass = n2;
  }
  function Kf(i, n2, e2) {
    if (i = "prototype" in i ? i.prototype : i, n2 = "prototype" in n2 ? n2.prototype : n2, Object.getOwnPropertyNames)
      for (var o = Object.getOwnPropertyNames(n2), l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        c4 !== "constructor" && (e2 ? n2[c4] != null : i[c4] == null) && (i[c4] = n2[c4]);
      }
    else
      hi(i, n2, e2);
  }
  function gv(i) {
    return !i || typeof i == "string" ? false : typeof i.length == "number";
  }
  function Ve(i, n2, e2) {
    if (!!(i && n2))
      if (i.forEach && i.forEach === kit)
        i.forEach(n2, e2);
      else if (i.length === +i.length)
        for (var o = 0, l4 = i.length; o < l4; o++)
          n2.call(e2, i[o], o, i);
      else
        for (var c4 in i)
          i.hasOwnProperty(c4) && n2.call(e2, i[c4], c4, i);
  }
  function Er(i, n2, e2) {
    if (!i)
      return [];
    if (!n2)
      return kse(i);
    if (i.map && i.map === Lit)
      return i.map(n2, e2);
    for (var o = [], l4 = 0, c4 = i.length; l4 < c4; l4++)
      o.push(n2.call(e2, i[l4], l4, i));
    return o;
  }
  function q_(i, n2, e2, o) {
    if (!!(i && n2)) {
      for (var l4 = 0, c4 = i.length; l4 < c4; l4++)
        e2 = n2.call(o, e2, i[l4], l4, i);
      return e2;
    }
  }
  function Yl(i, n2, e2) {
    if (!i)
      return [];
    if (!n2)
      return kse(i);
    if (i.filter && i.filter === Pit)
      return i.filter(n2, e2);
    for (var o = [], l4 = 0, c4 = i.length; l4 < c4; l4++)
      n2.call(e2, i[l4], l4, i) && o.push(i[l4]);
    return o;
  }
  function Fit(i, n2, e2) {
    if (!!(i && n2)) {
      for (var o = 0, l4 = i.length; o < l4; o++)
        if (n2.call(e2, i[o], o, i))
          return i[o];
    }
  }
  function ts(i) {
    if (!i)
      return [];
    if (Object.keys)
      return Object.keys(i);
    var n2 = [];
    for (var e2 in i)
      i.hasOwnProperty(e2) && n2.push(e2);
    return n2;
  }
  function Nit(i, n2) {
    for (var e2 = [], o = 2; o < arguments.length; o++)
      e2[o - 2] = arguments[o];
    return function() {
      return i.apply(n2, e2.concat(Ese.call(arguments)));
    };
  }
  var Ia = zG && si(zG.bind) ? zG.call.bind(zG.bind) : Nit;
  function zi(i) {
    for (var n2 = [], e2 = 1; e2 < arguments.length; e2++)
      n2[e2 - 1] = arguments[e2];
    return function() {
      return i.apply(this, n2.concat(Ese.call(arguments)));
    };
  }
  function Mr(i) {
    return Array.isArray ? Array.isArray(i) : G3.call(i) === "[object Array]";
  }
  function si(i) {
    return typeof i == "function";
  }
  function xa(i) {
    return typeof i == "string";
  }
  function wie(i) {
    return G3.call(i) === "[object String]";
  }
  function sl(i) {
    return typeof i == "number";
  }
  function mi(i) {
    var n2 = typeof i;
    return n2 === "function" || !!i && n2 === "object";
  }
  function Oxe(i) {
    return !!vIe[G3.call(i)];
  }
  function am(i) {
    return !!gIe[G3.call(i)];
  }
  function a8(i) {
    return typeof i == "object" && typeof i.nodeType == "number" && typeof i.ownerDocument == "object";
  }
  function g$(i) {
    return i.colorStops != null;
  }
  function Vit(i) {
    return i.image != null;
  }
  function zit(i) {
    return G3.call(i) === "[object RegExp]";
  }
  function i8(i) {
    return i !== i;
  }
  function Nd() {
    for (var i = [], n2 = 0; n2 < arguments.length; n2++)
      i[n2] = arguments[n2];
    for (var e2 = 0, o = i.length; e2 < o; e2++)
      if (i[e2] != null)
        return i[e2];
  }
  function so(i, n2) {
    return i != null ? i : n2;
  }
  function f2(i, n2, e2) {
    return i != null ? i : n2 != null ? n2 : e2;
  }
  function kse(i) {
    for (var n2 = [], e2 = 1; e2 < arguments.length; e2++)
      n2[e2 - 1] = arguments[e2];
    return Ese.apply(i, n2);
  }
  function Pse(i) {
    if (typeof i == "number")
      return [i, i, i, i];
    var n2 = i.length;
    return n2 === 2 ? [i[0], i[1], i[0], i[1]] : n2 === 3 ? [i[0], i[1], i[2], i[1]] : i;
  }
  function Kv(i, n2) {
    if (!i)
      throw new Error(n2);
  }
  function tb(i) {
    return i == null ? null : typeof i.trim == "function" ? i.trim() : i.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
  var yIe = "__ec_primitive__";
  function gH(i) {
    i[yIe] = true;
  }
  function zN(i) {
    return i[yIe];
  }
  var Bit = function() {
    function i(n2) {
      this.data = {};
      var e2 = Mr(n2);
      this.data = {};
      var o = this;
      n2 instanceof i ? n2.each(l4) : n2 && Ve(n2, l4);
      function l4(c4, h) {
        e2 ? o.set(c4, h) : o.set(h, c4);
      }
    }
    return i.prototype.get = function(n2) {
      return this.data.hasOwnProperty(n2) ? this.data[n2] : null;
    }, i.prototype.set = function(n2, e2) {
      return this.data[n2] = e2;
    }, i.prototype.each = function(n2, e2) {
      for (var o in this.data)
        this.data.hasOwnProperty(o) && n2.call(e2, this.data[o], o);
    }, i.prototype.keys = function() {
      return ts(this.data);
    }, i.prototype.removeKey = function(n2) {
      delete this.data[n2];
    }, i;
  }();
  function ri(i) {
    return new Bit(i);
  }
  function Sie(i, n2) {
    for (var e2 = new i.constructor(i.length + n2.length), o = 0; o < i.length; o++)
      e2[o] = i[o];
    for (var l4 = i.length, o = 0; o < n2.length; o++)
      e2[o + l4] = n2[o];
    return e2;
  }
  function m$(i, n2) {
    var e2;
    if (Object.create)
      e2 = Object.create(i);
    else {
      var o = function() {
      };
      o.prototype = i, e2 = new o();
    }
    return n2 && rr(e2, n2), e2;
  }
  function bIe(i) {
    var n2 = i.style;
    n2.webkitUserSelect = "none", n2.userSelect = "none", n2.webkitTapHighlightColor = "rgba(0,0,0,0)", n2["-webkit-touch-callout"] = "none";
  }
  function Na(i, n2) {
    return i.hasOwnProperty(n2);
  }
  function Zf() {
  }
  var YW = 180 / Math.PI;
  function CT(i, n2) {
    return i == null && (i = 0), n2 == null && (n2 = 0), [i, n2];
  }
  function qv(i, n2) {
    return i[0] = n2[0], i[1] = n2[1], i;
  }
  function h2(i) {
    return [i[0], i[1]];
  }
  function jit(i, n2, e2) {
    return i[0] = n2, i[1] = e2, i;
  }
  function Rxe(i, n2, e2) {
    return i[0] = n2[0] + e2[0], i[1] = n2[1] + e2[1], i;
  }
  function Cie(i, n2, e2, o) {
    return i[0] = n2[0] + e2[0] * o, i[1] = n2[1] + e2[1] * o, i;
  }
  function nT(i, n2, e2) {
    return i[0] = n2[0] - e2[0], i[1] = n2[1] - e2[1], i;
  }
  function Mie(i) {
    return Math.sqrt(Git(i));
  }
  function Git(i) {
    return i[0] * i[0] + i[1] * i[1];
  }
  function Gne(i, n2, e2) {
    return i[0] = n2[0] * e2, i[1] = n2[1] * e2, i;
  }
  function R8(i, n2) {
    var e2 = Mie(n2);
    return e2 === 0 ? (i[0] = 0, i[1] = 0) : (i[0] = n2[0] / e2, i[1] = n2[1] / e2), i;
  }
  function Aie(i, n2) {
    return Math.sqrt((i[0] - n2[0]) * (i[0] - n2[0]) + (i[1] - n2[1]) * (i[1] - n2[1]));
  }
  var RC = Aie;
  function Wit(i, n2) {
    return (i[0] - n2[0]) * (i[0] - n2[0]) + (i[1] - n2[1]) * (i[1] - n2[1]);
  }
  var lT = Wit;
  function ZW(i, n2, e2, o) {
    return i[0] = n2[0] + o * (e2[0] - n2[0]), i[1] = n2[1] + o * (e2[1] - n2[1]), i;
  }
  function Sp(i, n2, e2) {
    var o = n2[0], l4 = n2[1];
    return i[0] = e2[0] * o + e2[2] * l4 + e2[4], i[1] = e2[1] * o + e2[3] * l4 + e2[5], i;
  }
  function FC(i, n2, e2) {
    return i[0] = Math.min(n2[0], e2[0]), i[1] = Math.min(n2[1], e2[1]), i;
  }
  function NC(i, n2, e2) {
    return i[0] = Math.max(n2[0], e2[0]), i[1] = Math.max(n2[1], e2[1]), i;
  }
  var HP = function() {
    function i(n2, e2) {
      this.target = n2, this.topTarget = e2 && e2.topTarget;
    }
    return i;
  }(), Hit = function() {
    function i(n2) {
      this.handler = n2, n2.on("mousedown", this._dragStart, this), n2.on("mousemove", this._drag, this), n2.on("mouseup", this._dragEnd, this);
    }
    return i.prototype._dragStart = function(n2) {
      for (var e2 = n2.target; e2 && !e2.draggable; )
        e2 = e2.parent || e2.__hostTarget;
      e2 && (this._draggingTarget = e2, e2.dragging = true, this._x = n2.offsetX, this._y = n2.offsetY, this.handler.dispatchToElement(new HP(e2, n2), "dragstart", n2.event));
    }, i.prototype._drag = function(n2) {
      var e2 = this._draggingTarget;
      if (e2) {
        var o = n2.offsetX, l4 = n2.offsetY, c4 = o - this._x, h = l4 - this._y;
        this._x = o, this._y = l4, e2.drift(c4, h, n2), this.handler.dispatchToElement(new HP(e2, n2), "drag", n2.event);
        var p4 = this.handler.findHover(o, l4, e2).target, g4 = this._dropTarget;
        this._dropTarget = p4, e2 !== p4 && (g4 && p4 !== g4 && this.handler.dispatchToElement(new HP(g4, n2), "dragleave", n2.event), p4 && p4 !== g4 && this.handler.dispatchToElement(new HP(p4, n2), "dragenter", n2.event));
      }
    }, i.prototype._dragEnd = function(n2) {
      var e2 = this._draggingTarget;
      e2 && (e2.dragging = false), this.handler.dispatchToElement(new HP(e2, n2), "dragend", n2.event), this._dropTarget && this.handler.dispatchToElement(new HP(this._dropTarget, n2), "drop", n2.event), this._draggingTarget = null, this._dropTarget = null;
    }, i;
  }(), $it = Hit, Uit = function() {
    function i(n2) {
      n2 && (this._$eventProcessor = n2);
    }
    return i.prototype.on = function(n2, e2, o, l4) {
      this._$handlers || (this._$handlers = {});
      var c4 = this._$handlers;
      if (typeof e2 == "function" && (l4 = o, o = e2, e2 = null), !o || !n2)
        return this;
      var h = this._$eventProcessor;
      e2 != null && h && h.normalizeQuery && (e2 = h.normalizeQuery(e2)), c4[n2] || (c4[n2] = []);
      for (var p4 = 0; p4 < c4[n2].length; p4++)
        if (c4[n2][p4].h === o)
          return this;
      var g4 = { h: o, query: e2, ctx: l4 || this, callAtLast: o.zrEventfulCallAtLast }, y4 = c4[n2].length - 1, _ = c4[n2][y4];
      return _ && _.callAtLast ? c4[n2].splice(y4, 0, g4) : c4[n2].push(g4), this;
    }, i.prototype.isSilent = function(n2) {
      var e2 = this._$handlers;
      return !e2 || !e2[n2] || !e2[n2].length;
    }, i.prototype.off = function(n2, e2) {
      var o = this._$handlers;
      if (!o)
        return this;
      if (!n2)
        return this._$handlers = {}, this;
      if (e2) {
        if (o[n2]) {
          for (var l4 = [], c4 = 0, h = o[n2].length; c4 < h; c4++)
            o[n2][c4].h !== e2 && l4.push(o[n2][c4]);
          o[n2] = l4;
        }
        o[n2] && o[n2].length === 0 && delete o[n2];
      } else
        delete o[n2];
      return this;
    }, i.prototype.trigger = function(n2) {
      for (var e2 = [], o = 1; o < arguments.length; o++)
        e2[o - 1] = arguments[o];
      if (!this._$handlers)
        return this;
      var l4 = this._$handlers[n2], c4 = this._$eventProcessor;
      if (l4)
        for (var h = e2.length, p4 = l4.length, g4 = 0; g4 < p4; g4++) {
          var y4 = l4[g4];
          if (!(c4 && c4.filter && y4.query != null && !c4.filter(n2, y4.query)))
            switch (h) {
              case 0:
                y4.h.call(y4.ctx);
                break;
              case 1:
                y4.h.call(y4.ctx, e2[0]);
                break;
              case 2:
                y4.h.call(y4.ctx, e2[0], e2[1]);
                break;
              default:
                y4.h.apply(y4.ctx, e2);
                break;
            }
        }
      return c4 && c4.afterTrigger && c4.afterTrigger(n2), this;
    }, i.prototype.triggerWithContext = function(n2) {
      for (var e2 = [], o = 1; o < arguments.length; o++)
        e2[o - 1] = arguments[o];
      if (!this._$handlers)
        return this;
      var l4 = this._$handlers[n2], c4 = this._$eventProcessor;
      if (l4)
        for (var h = e2.length, p4 = e2[h - 1], g4 = l4.length, y4 = 0; y4 < g4; y4++) {
          var _ = l4[y4];
          if (!(c4 && c4.filter && _.query != null && !c4.filter(n2, _.query)))
            switch (h) {
              case 0:
                _.h.call(p4);
                break;
              case 1:
                _.h.call(p4, e2[0]);
                break;
              case 2:
                _.h.call(p4, e2[0], e2[1]);
                break;
              default:
                _.h.apply(p4, e2.slice(1, h - 1));
                break;
            }
        }
      return c4 && c4.afterTrigger && c4.afterTrigger(n2), this;
    }, i;
  }(), zy = Uit, qit = Math.log(2);
  function Eie(i, n2, e2, o, l4, c4) {
    var h = o + "-" + l4, p4 = i.length;
    if (c4.hasOwnProperty(h))
      return c4[h];
    if (n2 === 1) {
      var g4 = Math.round(Math.log((1 << p4) - 1 & ~l4) / qit);
      return i[e2][g4];
    }
    for (var y4 = o | 1 << e2, _ = e2 + 1; o & 1 << _; )
      _++;
    for (var w4 = 0, C = 0, E = 0; C < p4; C++) {
      var T = 1 << C;
      T & l4 || (w4 += (E % 2 ? -1 : 1) * i[e2][C] * Eie(i, n2 - 1, _, y4, l4 | T, c4), E++);
    }
    return c4[h] = w4, w4;
  }
  function Fxe(i, n2) {
    var e2 = [[i[0], i[1], 1, 0, 0, 0, -n2[0] * i[0], -n2[0] * i[1]], [0, 0, 0, i[0], i[1], 1, -n2[1] * i[0], -n2[1] * i[1]], [i[2], i[3], 1, 0, 0, 0, -n2[2] * i[2], -n2[2] * i[3]], [0, 0, 0, i[2], i[3], 1, -n2[3] * i[2], -n2[3] * i[3]], [i[4], i[5], 1, 0, 0, 0, -n2[4] * i[4], -n2[4] * i[5]], [0, 0, 0, i[4], i[5], 1, -n2[5] * i[4], -n2[5] * i[5]], [i[6], i[7], 1, 0, 0, 0, -n2[6] * i[6], -n2[6] * i[7]], [0, 0, 0, i[6], i[7], 1, -n2[7] * i[6], -n2[7] * i[7]]], o = {}, l4 = Eie(e2, 8, 0, 0, 0, o);
    if (l4 !== 0) {
      for (var c4 = [], h = 0; h < 8; h++)
        for (var p4 = 0; p4 < 8; p4++)
          c4[p4] == null && (c4[p4] = 0), c4[p4] += ((h + p4) % 2 ? -1 : 1) * Eie(e2, 7, h === 0 ? 1 : 0, 1 << h, 1 << p4, o) / l4 * n2[h];
      return function(g4, y4, _) {
        var w4 = y4 * c4[6] + _ * c4[7] + 1;
        g4[0] = (y4 * c4[0] + _ * c4[1] + c4[2]) / w4, g4[1] = (y4 * c4[3] + _ * c4[4] + c4[5]) / w4;
      };
    }
  }
  var Nxe = "___zrEVENTSAVED", Wne = [];
  function Yit(i, n2, e2, o, l4) {
    return Iie(Wne, n2, o, l4, true) && Iie(i, e2, Wne[0], Wne[1]);
  }
  function Iie(i, n2, e2, o, l4) {
    if (n2.getBoundingClientRect && ol.domSupported && !_Ie(n2)) {
      var c4 = n2[Nxe] || (n2[Nxe] = {}), h = Zit(n2, c4), p4 = Xit(h, c4, l4);
      if (p4)
        return p4(i, e2, o), true;
    }
    return false;
  }
  function Zit(i, n2) {
    var e2 = n2.markers;
    if (e2)
      return e2;
    e2 = n2.markers = [];
    for (var o = ["left", "right"], l4 = ["top", "bottom"], c4 = 0; c4 < 4; c4++) {
      var h = document.createElement("div"), p4 = h.style, g4 = c4 % 2, y4 = (c4 >> 1) % 2;
      p4.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", o[g4] + ":0", l4[y4] + ":0", o[1 - g4] + ":auto", l4[1 - y4] + ":auto", ""].join("!important;"), i.appendChild(h), e2.push(h);
    }
    return e2;
  }
  function Xit(i, n2, e2) {
    for (var o = e2 ? "invTrans" : "trans", l4 = n2[o], c4 = n2.srcCoords, h = [], p4 = [], g4 = true, y4 = 0; y4 < 4; y4++) {
      var _ = i[y4].getBoundingClientRect(), w4 = 2 * y4, C = _.left, E = _.top;
      h.push(C, E), g4 = g4 && c4 && C === c4[w4] && E === c4[w4 + 1], p4.push(i[y4].offsetLeft, i[y4].offsetTop);
    }
    return g4 && l4 ? l4 : (n2.srcCoords = h, n2[o] = e2 ? Fxe(p4, h) : Fxe(h, p4));
  }
  function _Ie(i) {
    return i.nodeName.toUpperCase() === "CANVAS";
  }
  var Kit = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, Hne = [], Jit = ol.browser.firefox && +ol.browser.version.split(".")[0] < 39;
  function Tie(i, n2, e2, o) {
    return e2 = e2 || {}, o ? Vxe(i, n2, e2) : Jit && n2.layerX != null && n2.layerX !== n2.offsetX ? (e2.zrX = n2.layerX, e2.zrY = n2.layerY) : n2.offsetX != null ? (e2.zrX = n2.offsetX, e2.zrY = n2.offsetY) : Vxe(i, n2, e2), e2;
  }
  function Vxe(i, n2, e2) {
    if (ol.domSupported && i.getBoundingClientRect) {
      var o = n2.clientX, l4 = n2.clientY;
      if (_Ie(i)) {
        var c4 = i.getBoundingClientRect();
        e2.zrX = o - c4.left, e2.zrY = l4 - c4.top;
        return;
      } else if (Iie(Hne, i, o, l4)) {
        e2.zrX = Hne[0], e2.zrY = Hne[1];
        return;
      }
    }
    e2.zrX = e2.zrY = 0;
  }
  function Lse(i) {
    return i || window.event;
  }
  function Cy(i, n2, e2) {
    if (n2 = Lse(n2), n2.zrX != null)
      return n2;
    var o = n2.type, l4 = o && o.indexOf("touch") >= 0;
    if (l4) {
      var h = o !== "touchend" ? n2.targetTouches[0] : n2.changedTouches[0];
      h && Tie(i, h, n2, e2);
    } else {
      Tie(i, n2, n2, e2);
      var c4 = Qit(n2);
      n2.zrDelta = c4 ? c4 / 120 : -(n2.detail || 0) / 3;
    }
    var p4 = n2.button;
    return n2.which == null && p4 !== void 0 && Kit.test(n2.type) && (n2.which = p4 & 1 ? 1 : p4 & 2 ? 3 : p4 & 4 ? 2 : 0), n2;
  }
  function Qit(i) {
    var n2 = i.wheelDelta;
    if (n2)
      return n2;
    var e2 = i.deltaX, o = i.deltaY;
    if (e2 == null || o == null)
      return n2;
    var l4 = Math.abs(o !== 0 ? o : e2), c4 = o > 0 ? -1 : o < 0 ? 1 : e2 > 0 ? -1 : 1;
    return 3 * l4 * c4;
  }
  function Die(i, n2, e2, o) {
    i.addEventListener(n2, e2, o);
  }
  function eot(i, n2, e2, o) {
    i.removeEventListener(n2, e2, o);
  }
  var b2 = function(i) {
    i.preventDefault(), i.stopPropagation(), i.cancelBubble = true;
  };
  function zxe(i) {
    return i.which === 2 || i.which === 3;
  }
  var tot = function() {
    function i() {
      this._track = [];
    }
    return i.prototype.recognize = function(n2, e2, o) {
      return this._doTrack(n2, e2, o), this._recognize(n2);
    }, i.prototype.clear = function() {
      return this._track.length = 0, this;
    }, i.prototype._doTrack = function(n2, e2, o) {
      var l4 = n2.touches;
      if (!!l4) {
        for (var c4 = { points: [], touches: [], target: e2, event: n2 }, h = 0, p4 = l4.length; h < p4; h++) {
          var g4 = l4[h], y4 = Tie(o, g4, {});
          c4.points.push([y4.zrX, y4.zrY]), c4.touches.push(g4);
        }
        this._track.push(c4);
      }
    }, i.prototype._recognize = function(n2) {
      for (var e2 in $ne)
        if ($ne.hasOwnProperty(e2)) {
          var o = $ne[e2](this._track, n2);
          if (o)
            return o;
        }
    }, i;
  }();
  function Bxe(i) {
    var n2 = i[1][0] - i[0][0], e2 = i[1][1] - i[0][1];
    return Math.sqrt(n2 * n2 + e2 * e2);
  }
  function not(i) {
    return [(i[0][0] + i[1][0]) / 2, (i[0][1] + i[1][1]) / 2];
  }
  var $ne = { pinch: function(i, n2) {
    var e2 = i.length;
    if (!!e2) {
      var o = (i[e2 - 1] || {}).points, l4 = (i[e2 - 2] || {}).points || o;
      if (l4 && l4.length > 1 && o && o.length > 1) {
        var c4 = Bxe(o) / Bxe(l4);
        !isFinite(c4) && (c4 = 1), n2.pinchScale = c4;
        var h = not(o);
        return n2.pinchX = h[0], n2.pinchY = h[1], { type: "pinch", target: i[0].target, event: n2 };
      }
    }
  } }, xIe = "silent";
  function rot(i, n2, e2) {
    return { type: i, event: e2, target: n2.target, topTarget: n2.topTarget, cancelBubble: false, offsetX: e2.zrX, offsetY: e2.zrY, gestureEvent: e2.gestureEvent, pinchX: e2.pinchX, pinchY: e2.pinchY, pinchScale: e2.pinchScale, wheelDelta: e2.zrDelta, zrByTouch: e2.zrByTouch, which: e2.which, stop: aot };
  }
  function aot() {
    b2(this.event);
  }
  var iot = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.handler = null, e2;
    }
    return n2.prototype.dispose = function() {
    }, n2.prototype.setCursor = function() {
    }, n2;
  }(zy), YF = function() {
    function i(n2, e2) {
      this.x = n2, this.y = e2;
    }
    return i;
  }(), oot = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], wIe = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4) {
      var h = i.call(this) || this;
      return h._hovered = new YF(0, 0), h.storage = e2, h.painter = o, h.painterRoot = c4, l4 = l4 || new iot(), h.proxy = null, h.setHandlerProxy(l4), h._draggingMgr = new $it(h), h;
    }
    return n2.prototype.setHandlerProxy = function(e2) {
      this.proxy && this.proxy.dispose(), e2 && (Ve(oot, function(o) {
        e2.on && e2.on(o, this[o], this);
      }, this), e2.handler = this), this.proxy = e2;
    }, n2.prototype.mousemove = function(e2) {
      var o = e2.zrX, l4 = e2.zrY, c4 = SIe(this, o, l4), h = this._hovered, p4 = h.target;
      p4 && !p4.__zr && (h = this.findHover(h.x, h.y), p4 = h.target);
      var g4 = this._hovered = c4 ? new YF(o, l4) : this.findHover(o, l4), y4 = g4.target, _ = this.proxy;
      _.setCursor && _.setCursor(y4 ? y4.cursor : "default"), p4 && y4 !== p4 && this.dispatchToElement(h, "mouseout", e2), this.dispatchToElement(g4, "mousemove", e2), y4 && y4 !== p4 && this.dispatchToElement(g4, "mouseover", e2);
    }, n2.prototype.mouseout = function(e2) {
      var o = e2.zrEventControl;
      o !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", e2), o !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: e2 });
    }, n2.prototype.resize = function() {
      this._hovered = new YF(0, 0);
    }, n2.prototype.dispatch = function(e2, o) {
      var l4 = this[e2];
      l4 && l4.call(this, o);
    }, n2.prototype.dispose = function() {
      this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
    }, n2.prototype.setCursorStyle = function(e2) {
      var o = this.proxy;
      o.setCursor && o.setCursor(e2);
    }, n2.prototype.dispatchToElement = function(e2, o, l4) {
      e2 = e2 || {};
      var c4 = e2.target;
      if (!(c4 && c4.silent)) {
        for (var h = "on" + o, p4 = rot(o, e2, l4); c4 && (c4[h] && (p4.cancelBubble = !!c4[h].call(c4, p4)), c4.trigger(o, p4), c4 = c4.__hostTarget ? c4.__hostTarget : c4.parent, !p4.cancelBubble); )
          ;
        p4.cancelBubble || (this.trigger(o, p4), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(g4) {
          typeof g4[h] == "function" && g4[h].call(g4, p4), g4.trigger && g4.trigger(o, p4);
        }));
      }
    }, n2.prototype.findHover = function(e2, o, l4) {
      for (var c4 = this.storage.getDisplayList(), h = new YF(e2, o), p4 = c4.length - 1; p4 >= 0; p4--) {
        var g4 = void 0;
        if (c4[p4] !== l4 && !c4[p4].ignore && (g4 = sot(c4[p4], e2, o)) && (!h.topTarget && (h.topTarget = c4[p4]), g4 !== xIe)) {
          h.target = c4[p4];
          break;
        }
      }
      return h;
    }, n2.prototype.processGesture = function(e2, o) {
      this._gestureMgr || (this._gestureMgr = new tot());
      var l4 = this._gestureMgr;
      o === "start" && l4.clear();
      var c4 = l4.recognize(e2, this.findHover(e2.zrX, e2.zrY, null).target, this.proxy.dom);
      if (o === "end" && l4.clear(), c4) {
        var h = c4.type;
        e2.gestureEvent = h;
        var p4 = new YF();
        p4.target = c4.target, this.dispatchToElement(p4, h, c4.event);
      }
    }, n2;
  }(zy);
  Ve(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(i) {
    wIe.prototype[i] = function(n2) {
      var e2 = n2.zrX, o = n2.zrY, l4 = SIe(this, e2, o), c4, h;
      if ((i !== "mouseup" || !l4) && (c4 = this.findHover(e2, o), h = c4.target), i === "mousedown")
        this._downEl = h, this._downPoint = [n2.zrX, n2.zrY], this._upEl = h;
      else if (i === "mouseup")
        this._upEl = h;
      else if (i === "click") {
        if (this._downEl !== this._upEl || !this._downPoint || RC(this._downPoint, [n2.zrX, n2.zrY]) > 4)
          return;
        this._downPoint = null;
      }
      this.dispatchToElement(c4, i, n2);
    };
  });
  function sot(i, n2, e2) {
    if (i[i.rectHover ? "rectContain" : "contain"](n2, e2)) {
      for (var o = i, l4 = void 0, c4 = false; o; ) {
        if (o.ignoreClip && (c4 = true), !c4) {
          var h = o.getClipPath();
          if (h && !h.contain(n2, e2))
            return false;
          o.silent && (l4 = true);
        }
        var p4 = o.__hostTarget;
        o = p4 || o.parent;
      }
      return l4 ? xIe : true;
    }
    return false;
  }
  function SIe(i, n2, e2) {
    var o = i.painter;
    return n2 < 0 || n2 > o.getWidth() || e2 < 0 || e2 > o.getHeight();
  }
  var lot = wIe, CIe = 32, ZF = 7;
  function uot(i) {
    for (var n2 = 0; i >= CIe; )
      n2 |= i & 1, i >>= 1;
    return i + n2;
  }
  function jxe(i, n2, e2, o) {
    var l4 = n2 + 1;
    if (l4 === e2)
      return 1;
    if (o(i[l4++], i[n2]) < 0) {
      for (; l4 < e2 && o(i[l4], i[l4 - 1]) < 0; )
        l4++;
      cot(i, n2, l4);
    } else
      for (; l4 < e2 && o(i[l4], i[l4 - 1]) >= 0; )
        l4++;
    return l4 - n2;
  }
  function cot(i, n2, e2) {
    for (e2--; n2 < e2; ) {
      var o = i[n2];
      i[n2++] = i[e2], i[e2--] = o;
    }
  }
  function Gxe(i, n2, e2, o, l4) {
    for (o === n2 && o++; o < e2; o++) {
      for (var c4 = i[o], h = n2, p4 = o, g4; h < p4; )
        g4 = h + p4 >>> 1, l4(c4, i[g4]) < 0 ? p4 = g4 : h = g4 + 1;
      var y4 = o - h;
      switch (y4) {
        case 3:
          i[h + 3] = i[h + 2];
        case 2:
          i[h + 2] = i[h + 1];
        case 1:
          i[h + 1] = i[h];
          break;
        default:
          for (; y4 > 0; )
            i[h + y4] = i[h + y4 - 1], y4--;
      }
      i[h] = c4;
    }
  }
  function Une(i, n2, e2, o, l4, c4) {
    var h = 0, p4 = 0, g4 = 1;
    if (c4(i, n2[e2 + l4]) > 0) {
      for (p4 = o - l4; g4 < p4 && c4(i, n2[e2 + l4 + g4]) > 0; )
        h = g4, g4 = (g4 << 1) + 1, g4 <= 0 && (g4 = p4);
      g4 > p4 && (g4 = p4), h += l4, g4 += l4;
    } else {
      for (p4 = l4 + 1; g4 < p4 && c4(i, n2[e2 + l4 - g4]) <= 0; )
        h = g4, g4 = (g4 << 1) + 1, g4 <= 0 && (g4 = p4);
      g4 > p4 && (g4 = p4);
      var y4 = h;
      h = l4 - g4, g4 = l4 - y4;
    }
    for (h++; h < g4; ) {
      var _ = h + (g4 - h >>> 1);
      c4(i, n2[e2 + _]) > 0 ? h = _ + 1 : g4 = _;
    }
    return g4;
  }
  function qne(i, n2, e2, o, l4, c4) {
    var h = 0, p4 = 0, g4 = 1;
    if (c4(i, n2[e2 + l4]) < 0) {
      for (p4 = l4 + 1; g4 < p4 && c4(i, n2[e2 + l4 - g4]) < 0; )
        h = g4, g4 = (g4 << 1) + 1, g4 <= 0 && (g4 = p4);
      g4 > p4 && (g4 = p4);
      var y4 = h;
      h = l4 - g4, g4 = l4 - y4;
    } else {
      for (p4 = o - l4; g4 < p4 && c4(i, n2[e2 + l4 + g4]) >= 0; )
        h = g4, g4 = (g4 << 1) + 1, g4 <= 0 && (g4 = p4);
      g4 > p4 && (g4 = p4), h += l4, g4 += l4;
    }
    for (h++; h < g4; ) {
      var _ = h + (g4 - h >>> 1);
      c4(i, n2[e2 + _]) < 0 ? g4 = _ : h = _ + 1;
    }
    return g4;
  }
  function fot(i, n2) {
    var e2 = ZF, o, l4, c4 = 0, h = [];
    o = [], l4 = [];
    function p4(E, T) {
      o[c4] = E, l4[c4] = T, c4 += 1;
    }
    function g4() {
      for (; c4 > 1; ) {
        var E = c4 - 2;
        if (E >= 1 && l4[E - 1] <= l4[E] + l4[E + 1] || E >= 2 && l4[E - 2] <= l4[E] + l4[E - 1])
          l4[E - 1] < l4[E + 1] && E--;
        else if (l4[E] > l4[E + 1])
          break;
        _(E);
      }
    }
    function y4() {
      for (; c4 > 1; ) {
        var E = c4 - 2;
        E > 0 && l4[E - 1] < l4[E + 1] && E--, _(E);
      }
    }
    function _(E) {
      var T = o[E], O = l4[E], N = o[E + 1], V = l4[E + 1];
      l4[E] = O + V, E === c4 - 3 && (o[E + 1] = o[E + 2], l4[E + 1] = l4[E + 2]), c4--;
      var H = qne(i[N], i, T, O, 0, n2);
      T += H, O -= H, O !== 0 && (V = Une(i[T + O - 1], i, N, V, V - 1, n2), V !== 0 && (O <= V ? w4(T, O, N, V) : C(T, O, N, V)));
    }
    function w4(E, T, O, N) {
      var V = 0;
      for (V = 0; V < T; V++)
        h[V] = i[E + V];
      var H = 0, X = O, q2 = E;
      if (i[q2++] = i[X++], --N === 0) {
        for (V = 0; V < T; V++)
          i[q2 + V] = h[H + V];
        return;
      }
      if (T === 1) {
        for (V = 0; V < N; V++)
          i[q2 + V] = i[X + V];
        i[q2 + N] = h[H];
        return;
      }
      for (var de = e2, le, me, ye; ; ) {
        le = 0, me = 0, ye = false;
        do
          if (n2(i[X], h[H]) < 0) {
            if (i[q2++] = i[X++], me++, le = 0, --N === 0) {
              ye = true;
              break;
            }
          } else if (i[q2++] = h[H++], le++, me = 0, --T === 1) {
            ye = true;
            break;
          }
        while ((le | me) < de);
        if (ye)
          break;
        do {
          if (le = qne(i[X], h, H, T, 0, n2), le !== 0) {
            for (V = 0; V < le; V++)
              i[q2 + V] = h[H + V];
            if (q2 += le, H += le, T -= le, T <= 1) {
              ye = true;
              break;
            }
          }
          if (i[q2++] = i[X++], --N === 0) {
            ye = true;
            break;
          }
          if (me = Une(h[H], i, X, N, 0, n2), me !== 0) {
            for (V = 0; V < me; V++)
              i[q2 + V] = i[X + V];
            if (q2 += me, X += me, N -= me, N === 0) {
              ye = true;
              break;
            }
          }
          if (i[q2++] = h[H++], --T === 1) {
            ye = true;
            break;
          }
          de--;
        } while (le >= ZF || me >= ZF);
        if (ye)
          break;
        de < 0 && (de = 0), de += 2;
      }
      if (e2 = de, e2 < 1 && (e2 = 1), T === 1) {
        for (V = 0; V < N; V++)
          i[q2 + V] = i[X + V];
        i[q2 + N] = h[H];
      } else {
        if (T === 0)
          throw new Error();
        for (V = 0; V < T; V++)
          i[q2 + V] = h[H + V];
      }
    }
    function C(E, T, O, N) {
      var V = 0;
      for (V = 0; V < N; V++)
        h[V] = i[O + V];
      var H = E + T - 1, X = N - 1, q2 = O + N - 1, de = 0, le = 0;
      if (i[q2--] = i[H--], --T === 0) {
        for (de = q2 - (N - 1), V = 0; V < N; V++)
          i[de + V] = h[V];
        return;
      }
      if (N === 1) {
        for (q2 -= T, H -= T, le = q2 + 1, de = H + 1, V = T - 1; V >= 0; V--)
          i[le + V] = i[de + V];
        i[q2] = h[X];
        return;
      }
      for (var me = e2; ; ) {
        var ye = 0, be = 0, we = false;
        do
          if (n2(h[X], i[H]) < 0) {
            if (i[q2--] = i[H--], ye++, be = 0, --T === 0) {
              we = true;
              break;
            }
          } else if (i[q2--] = h[X--], be++, ye = 0, --N === 1) {
            we = true;
            break;
          }
        while ((ye | be) < me);
        if (we)
          break;
        do {
          if (ye = T - qne(h[X], i, E, T, T - 1, n2), ye !== 0) {
            for (q2 -= ye, H -= ye, T -= ye, le = q2 + 1, de = H + 1, V = ye - 1; V >= 0; V--)
              i[le + V] = i[de + V];
            if (T === 0) {
              we = true;
              break;
            }
          }
          if (i[q2--] = h[X--], --N === 1) {
            we = true;
            break;
          }
          if (be = N - Une(i[H], h, 0, N, N - 1, n2), be !== 0) {
            for (q2 -= be, X -= be, N -= be, le = q2 + 1, de = X + 1, V = 0; V < be; V++)
              i[le + V] = h[de + V];
            if (N <= 1) {
              we = true;
              break;
            }
          }
          if (i[q2--] = i[H--], --T === 0) {
            we = true;
            break;
          }
          me--;
        } while (ye >= ZF || be >= ZF);
        if (we)
          break;
        me < 0 && (me = 0), me += 2;
      }
      if (e2 = me, e2 < 1 && (e2 = 1), N === 1) {
        for (q2 -= T, H -= T, le = q2 + 1, de = H + 1, V = T - 1; V >= 0; V--)
          i[le + V] = i[de + V];
        i[q2] = h[X];
      } else {
        if (N === 0)
          throw new Error();
        for (de = q2 - (N - 1), V = 0; V < N; V++)
          i[de + V] = h[V];
      }
    }
    return { mergeRuns: g4, forceMergeRuns: y4, pushRun: p4 };
  }
  function XW(i, n2, e2, o) {
    e2 || (e2 = 0), o || (o = i.length);
    var l4 = o - e2;
    if (!(l4 < 2)) {
      var c4 = 0;
      if (l4 < CIe) {
        c4 = jxe(i, e2, o, n2), Gxe(i, e2, o, e2 + c4, n2);
        return;
      }
      var h = fot(i, n2), p4 = uot(l4);
      do {
        if (c4 = jxe(i, e2, o, n2), c4 < p4) {
          var g4 = l4;
          g4 > p4 && (g4 = p4), Gxe(i, e2, e2 + g4, e2 + c4, n2), c4 = g4;
        }
        h.pushRun(e2, c4), h.mergeRuns(), l4 -= c4, e2 += c4;
      } while (l4 !== 0);
      h.forceMergeRuns();
    }
  }
  var em = 1, AN = 2, h3 = 4, Wxe = false;
  function Yne() {
    Wxe || (Wxe = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
  }
  function Hxe(i, n2) {
    return i.zlevel === n2.zlevel ? i.z === n2.z ? i.z2 - n2.z2 : i.z - n2.z : i.zlevel - n2.zlevel;
  }
  var hot = function() {
    function i() {
      this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = Hxe;
    }
    return i.prototype.traverse = function(n2, e2) {
      for (var o = 0; o < this._roots.length; o++)
        this._roots[o].traverse(n2, e2);
    }, i.prototype.getDisplayList = function(n2, e2) {
      e2 = e2 || false;
      var o = this._displayList;
      return (n2 || !o.length) && this.updateDisplayList(e2), o;
    }, i.prototype.updateDisplayList = function(n2) {
      this._displayListLen = 0;
      for (var e2 = this._roots, o = this._displayList, l4 = 0, c4 = e2.length; l4 < c4; l4++)
        this._updateAndAddDisplayable(e2[l4], null, n2);
      o.length = this._displayListLen, XW(o, Hxe);
    }, i.prototype._updateAndAddDisplayable = function(n2, e2, o) {
      if (!(n2.ignore && !o)) {
        n2.beforeUpdate(), n2.update(), n2.afterUpdate();
        var l4 = n2.getClipPath();
        if (n2.ignoreClip)
          e2 = null;
        else if (l4) {
          e2 ? e2 = e2.slice() : e2 = [];
          for (var c4 = l4, h = n2; c4; )
            c4.parent = h, c4.updateTransform(), e2.push(c4), h = c4, c4 = c4.getClipPath();
        }
        if (n2.childrenRef) {
          for (var p4 = n2.childrenRef(), g4 = 0; g4 < p4.length; g4++) {
            var y4 = p4[g4];
            n2.__dirty && (y4.__dirty |= em), this._updateAndAddDisplayable(y4, e2, o);
          }
          n2.__dirty = 0;
        } else {
          var _ = n2;
          e2 && e2.length ? _.__clipPaths = e2 : _.__clipPaths && _.__clipPaths.length > 0 && (_.__clipPaths = []), isNaN(_.z) && (Yne(), _.z = 0), isNaN(_.z2) && (Yne(), _.z2 = 0), isNaN(_.zlevel) && (Yne(), _.zlevel = 0), this._displayList[this._displayListLen++] = _;
        }
        var w4 = n2.getDecalElement && n2.getDecalElement();
        w4 && this._updateAndAddDisplayable(w4, e2, o);
        var C = n2.getTextGuideLine();
        C && this._updateAndAddDisplayable(C, e2, o);
        var E = n2.getTextContent();
        E && this._updateAndAddDisplayable(E, e2, o);
      }
    }, i.prototype.addRoot = function(n2) {
      n2.__zr && n2.__zr.storage === this || this._roots.push(n2);
    }, i.prototype.delRoot = function(n2) {
      if (n2 instanceof Array) {
        for (var e2 = 0, o = n2.length; e2 < o; e2++)
          this.delRoot(n2[e2]);
        return;
      }
      var l4 = go(this._roots, n2);
      l4 >= 0 && this._roots.splice(l4, 1);
    }, i.prototype.delAllRoots = function() {
      this._roots = [], this._displayList = [], this._displayListLen = 0;
    }, i.prototype.getRoots = function() {
      return this._roots;
    }, i.prototype.dispose = function() {
      this._displayList = null, this._roots = null;
    }, i;
  }(), dot = hot, MIe;
  MIe = ol.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(i) {
    return setTimeout(i, 16);
  };
  var kie = MIe, KW = { linear: function(i) {
    return i;
  }, quadraticIn: function(i) {
    return i * i;
  }, quadraticOut: function(i) {
    return i * (2 - i);
  }, quadraticInOut: function(i) {
    return (i *= 2) < 1 ? 0.5 * i * i : -0.5 * (--i * (i - 2) - 1);
  }, cubicIn: function(i) {
    return i * i * i;
  }, cubicOut: function(i) {
    return --i * i * i + 1;
  }, cubicInOut: function(i) {
    return (i *= 2) < 1 ? 0.5 * i * i * i : 0.5 * ((i -= 2) * i * i + 2);
  }, quarticIn: function(i) {
    return i * i * i * i;
  }, quarticOut: function(i) {
    return 1 - --i * i * i * i;
  }, quarticInOut: function(i) {
    return (i *= 2) < 1 ? 0.5 * i * i * i * i : -0.5 * ((i -= 2) * i * i * i - 2);
  }, quinticIn: function(i) {
    return i * i * i * i * i;
  }, quinticOut: function(i) {
    return --i * i * i * i * i + 1;
  }, quinticInOut: function(i) {
    return (i *= 2) < 1 ? 0.5 * i * i * i * i * i : 0.5 * ((i -= 2) * i * i * i * i + 2);
  }, sinusoidalIn: function(i) {
    return 1 - Math.cos(i * Math.PI / 2);
  }, sinusoidalOut: function(i) {
    return Math.sin(i * Math.PI / 2);
  }, sinusoidalInOut: function(i) {
    return 0.5 * (1 - Math.cos(Math.PI * i));
  }, exponentialIn: function(i) {
    return i === 0 ? 0 : Math.pow(1024, i - 1);
  }, exponentialOut: function(i) {
    return i === 1 ? 1 : 1 - Math.pow(2, -10 * i);
  }, exponentialInOut: function(i) {
    return i === 0 ? 0 : i === 1 ? 1 : (i *= 2) < 1 ? 0.5 * Math.pow(1024, i - 1) : 0.5 * (-Math.pow(2, -10 * (i - 1)) + 2);
  }, circularIn: function(i) {
    return 1 - Math.sqrt(1 - i * i);
  }, circularOut: function(i) {
    return Math.sqrt(1 - --i * i);
  }, circularInOut: function(i) {
    return (i *= 2) < 1 ? -0.5 * (Math.sqrt(1 - i * i) - 1) : 0.5 * (Math.sqrt(1 - (i -= 2) * i) + 1);
  }, elasticIn: function(i) {
    var n2, e2 = 0.1, o = 0.4;
    return i === 0 ? 0 : i === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, n2 = o / 4) : n2 = o * Math.asin(1 / e2) / (2 * Math.PI), -(e2 * Math.pow(2, 10 * (i -= 1)) * Math.sin((i - n2) * (2 * Math.PI) / o)));
  }, elasticOut: function(i) {
    var n2, e2 = 0.1, o = 0.4;
    return i === 0 ? 0 : i === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, n2 = o / 4) : n2 = o * Math.asin(1 / e2) / (2 * Math.PI), e2 * Math.pow(2, -10 * i) * Math.sin((i - n2) * (2 * Math.PI) / o) + 1);
  }, elasticInOut: function(i) {
    var n2, e2 = 0.1, o = 0.4;
    return i === 0 ? 0 : i === 1 ? 1 : (!e2 || e2 < 1 ? (e2 = 1, n2 = o / 4) : n2 = o * Math.asin(1 / e2) / (2 * Math.PI), (i *= 2) < 1 ? -0.5 * (e2 * Math.pow(2, 10 * (i -= 1)) * Math.sin((i - n2) * (2 * Math.PI) / o)) : e2 * Math.pow(2, -10 * (i -= 1)) * Math.sin((i - n2) * (2 * Math.PI) / o) * 0.5 + 1);
  }, backIn: function(i) {
    var n2 = 1.70158;
    return i * i * ((n2 + 1) * i - n2);
  }, backOut: function(i) {
    var n2 = 1.70158;
    return --i * i * ((n2 + 1) * i + n2) + 1;
  }, backInOut: function(i) {
    var n2 = 2.5949095;
    return (i *= 2) < 1 ? 0.5 * (i * i * ((n2 + 1) * i - n2)) : 0.5 * ((i -= 2) * i * ((n2 + 1) * i + n2) + 2);
  }, bounceIn: function(i) {
    return 1 - KW.bounceOut(1 - i);
  }, bounceOut: function(i) {
    return i < 1 / 2.75 ? 7.5625 * i * i : i < 2 / 2.75 ? 7.5625 * (i -= 1.5 / 2.75) * i + 0.75 : i < 2.5 / 2.75 ? 7.5625 * (i -= 2.25 / 2.75) * i + 0.9375 : 7.5625 * (i -= 2.625 / 2.75) * i + 0.984375;
  }, bounceInOut: function(i) {
    return i < 0.5 ? KW.bounceIn(i * 2) * 0.5 : KW.bounceOut(i * 2 - 1) * 0.5 + 0.5;
  } }, AIe = KW, BG = Math.pow, UC = Math.sqrt, mH = 1e-8, EIe = 1e-4, $xe = UC(3), jG = 1 / 3, N_ = CT(), Iy = CT(), A3 = CT();
  function VC(i) {
    return i > -mH && i < mH;
  }
  function IIe(i) {
    return i > mH || i < -mH;
  }
  function Kh(i, n2, e2, o, l4) {
    var c4 = 1 - l4;
    return c4 * c4 * (c4 * i + 3 * l4 * n2) + l4 * l4 * (l4 * o + 3 * c4 * e2);
  }
  function Uxe(i, n2, e2, o, l4) {
    var c4 = 1 - l4;
    return 3 * (((n2 - i) * c4 + 2 * (e2 - n2) * l4) * c4 + (o - e2) * l4 * l4);
  }
  function yH(i, n2, e2, o, l4, c4) {
    var h = o + 3 * (n2 - e2) - i, p4 = 3 * (e2 - n2 * 2 + i), g4 = 3 * (n2 - i), y4 = i - l4, _ = p4 * p4 - 3 * h * g4, w4 = p4 * g4 - 9 * h * y4, C = g4 * g4 - 3 * p4 * y4, E = 0;
    if (VC(_) && VC(w4))
      if (VC(p4))
        c4[0] = 0;
      else {
        var T = -g4 / p4;
        T >= 0 && T <= 1 && (c4[E++] = T);
      }
    else {
      var O = w4 * w4 - 4 * _ * C;
      if (VC(O)) {
        var N = w4 / _, T = -p4 / h + N, V = -N / 2;
        T >= 0 && T <= 1 && (c4[E++] = T), V >= 0 && V <= 1 && (c4[E++] = V);
      } else if (O > 0) {
        var H = UC(O), X = _ * p4 + 1.5 * h * (-w4 + H), q2 = _ * p4 + 1.5 * h * (-w4 - H);
        X < 0 ? X = -BG(-X, jG) : X = BG(X, jG), q2 < 0 ? q2 = -BG(-q2, jG) : q2 = BG(q2, jG);
        var T = (-p4 - (X + q2)) / (3 * h);
        T >= 0 && T <= 1 && (c4[E++] = T);
      } else {
        var de = (2 * _ * p4 - 3 * h * w4) / (2 * UC(_ * _ * _)), le = Math.acos(de) / 3, me = UC(_), ye = Math.cos(le), T = (-p4 - 2 * me * ye) / (3 * h), V = (-p4 + me * (ye + $xe * Math.sin(le))) / (3 * h), be = (-p4 + me * (ye - $xe * Math.sin(le))) / (3 * h);
        T >= 0 && T <= 1 && (c4[E++] = T), V >= 0 && V <= 1 && (c4[E++] = V), be >= 0 && be <= 1 && (c4[E++] = be);
      }
    }
    return E;
  }
  function TIe(i, n2, e2, o, l4) {
    var c4 = 6 * e2 - 12 * n2 + 6 * i, h = 9 * n2 + 3 * o - 3 * i - 9 * e2, p4 = 3 * n2 - 3 * i, g4 = 0;
    if (VC(h)) {
      if (IIe(c4)) {
        var y4 = -p4 / c4;
        y4 >= 0 && y4 <= 1 && (l4[g4++] = y4);
      }
    } else {
      var _ = c4 * c4 - 4 * h * p4;
      if (VC(_))
        l4[0] = -c4 / (2 * h);
      else if (_ > 0) {
        var w4 = UC(_), y4 = (-c4 + w4) / (2 * h), C = (-c4 - w4) / (2 * h);
        y4 >= 0 && y4 <= 1 && (l4[g4++] = y4), C >= 0 && C <= 1 && (l4[g4++] = C);
      }
    }
    return g4;
  }
  function KC(i, n2, e2, o, l4, c4) {
    var h = (n2 - i) * l4 + i, p4 = (e2 - n2) * l4 + n2, g4 = (o - e2) * l4 + e2, y4 = (p4 - h) * l4 + h, _ = (g4 - p4) * l4 + p4, w4 = (_ - y4) * l4 + y4;
    c4[0] = i, c4[1] = h, c4[2] = y4, c4[3] = w4, c4[4] = w4, c4[5] = _, c4[6] = g4, c4[7] = o;
  }
  function DIe(i, n2, e2, o, l4, c4, h, p4, g4, y4, _) {
    var w4, C = 5e-3, E = 1 / 0, T, O, N, V;
    N_[0] = g4, N_[1] = y4;
    for (var H = 0; H < 1; H += 0.05)
      Iy[0] = Kh(i, e2, l4, h, H), Iy[1] = Kh(n2, o, c4, p4, H), N = lT(N_, Iy), N < E && (w4 = H, E = N);
    E = 1 / 0;
    for (var X = 0; X < 32 && !(C < EIe); X++)
      T = w4 - C, O = w4 + C, Iy[0] = Kh(i, e2, l4, h, T), Iy[1] = Kh(n2, o, c4, p4, T), N = lT(Iy, N_), T >= 0 && N < E ? (w4 = T, E = N) : (A3[0] = Kh(i, e2, l4, h, O), A3[1] = Kh(n2, o, c4, p4, O), V = lT(A3, N_), O <= 1 && V < E ? (w4 = O, E = V) : C *= 0.5);
    return _ && (_[0] = Kh(i, e2, l4, h, w4), _[1] = Kh(n2, o, c4, p4, w4)), UC(E);
  }
  function pot(i, n2, e2, o, l4, c4, h, p4, g4) {
    for (var y4 = i, _ = n2, w4 = 0, C = 1 / g4, E = 1; E <= g4; E++) {
      var T = E * C, O = Kh(i, e2, l4, h, T), N = Kh(n2, o, c4, p4, T), V = O - y4, H = N - _;
      w4 += Math.sqrt(V * V + H * H), y4 = O, _ = N;
    }
    return w4;
  }
  function Fd(i, n2, e2, o) {
    var l4 = 1 - o;
    return l4 * (l4 * i + 2 * o * n2) + o * o * e2;
  }
  function Pie(i, n2, e2, o) {
    return 2 * ((1 - o) * (n2 - i) + o * (e2 - n2));
  }
  function vot(i, n2, e2, o, l4) {
    var c4 = i - 2 * n2 + e2, h = 2 * (n2 - i), p4 = i - o, g4 = 0;
    if (VC(c4)) {
      if (IIe(h)) {
        var y4 = -p4 / h;
        y4 >= 0 && y4 <= 1 && (l4[g4++] = y4);
      }
    } else {
      var _ = h * h - 4 * c4 * p4;
      if (VC(_)) {
        var y4 = -h / (2 * c4);
        y4 >= 0 && y4 <= 1 && (l4[g4++] = y4);
      } else if (_ > 0) {
        var w4 = UC(_), y4 = (-h + w4) / (2 * c4), C = (-h - w4) / (2 * c4);
        y4 >= 0 && y4 <= 1 && (l4[g4++] = y4), C >= 0 && C <= 1 && (l4[g4++] = C);
      }
    }
    return g4;
  }
  function kIe(i, n2, e2) {
    var o = i + e2 - 2 * n2;
    return o === 0 ? 0.5 : (i - n2) / o;
  }
  function o8(i, n2, e2, o, l4) {
    var c4 = (n2 - i) * o + i, h = (e2 - n2) * o + n2, p4 = (h - c4) * o + c4;
    l4[0] = i, l4[1] = c4, l4[2] = p4, l4[3] = p4, l4[4] = h, l4[5] = e2;
  }
  function PIe(i, n2, e2, o, l4, c4, h, p4, g4) {
    var y4, _ = 5e-3, w4 = 1 / 0;
    N_[0] = h, N_[1] = p4;
    for (var C = 0; C < 1; C += 0.05) {
      Iy[0] = Fd(i, e2, l4, C), Iy[1] = Fd(n2, o, c4, C);
      var E = lT(N_, Iy);
      E < w4 && (y4 = C, w4 = E);
    }
    w4 = 1 / 0;
    for (var T = 0; T < 32 && !(_ < EIe); T++) {
      var O = y4 - _, N = y4 + _;
      Iy[0] = Fd(i, e2, l4, O), Iy[1] = Fd(n2, o, c4, O);
      var E = lT(Iy, N_);
      if (O >= 0 && E < w4)
        y4 = O, w4 = E;
      else {
        A3[0] = Fd(i, e2, l4, N), A3[1] = Fd(n2, o, c4, N);
        var V = lT(A3, N_);
        N <= 1 && V < w4 ? (y4 = N, w4 = V) : _ *= 0.5;
      }
    }
    return g4 && (g4[0] = Fd(i, e2, l4, y4), g4[1] = Fd(n2, o, c4, y4)), UC(w4);
  }
  function got(i, n2, e2, o, l4, c4, h) {
    for (var p4 = i, g4 = n2, y4 = 0, _ = 1 / h, w4 = 1; w4 <= h; w4++) {
      var C = w4 * _, E = Fd(i, e2, l4, C), T = Fd(n2, o, c4, C), O = E - p4, N = T - g4;
      y4 += Math.sqrt(O * O + N * N), p4 = E, g4 = T;
    }
    return y4;
  }
  var mot = /cubic-bezier\(([0-9,\.e ]+)\)/;
  function Ose(i) {
    var n2 = i && mot.exec(i);
    if (n2) {
      var e2 = n2[1].split(","), o = +tb(e2[0]), l4 = +tb(e2[1]), c4 = +tb(e2[2]), h = +tb(e2[3]);
      if (isNaN(o + l4 + c4 + h))
        return;
      var p4 = [];
      return function(g4) {
        return g4 <= 0 ? 0 : g4 >= 1 ? 1 : yH(0, o, c4, 1, g4, p4) && Kh(0, l4, h, 1, p4[0]);
      };
    }
  }
  var yot = function() {
    function i(n2) {
      this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = n2.life || 1e3, this._delay = n2.delay || 0, this.loop = n2.loop || false, this.onframe = n2.onframe || Zf, this.ondestroy = n2.ondestroy || Zf, this.onrestart = n2.onrestart || Zf, n2.easing && this.setEasing(n2.easing);
    }
    return i.prototype.step = function(n2, e2) {
      if (this._inited || (this._startTime = n2 + this._delay, this._inited = true), this._paused) {
        this._pausedTime += e2;
        return;
      }
      var o = this._life, l4 = n2 - this._startTime - this._pausedTime, c4 = l4 / o;
      c4 < 0 && (c4 = 0), c4 = Math.min(c4, 1);
      var h = this.easingFunc, p4 = h ? h(c4) : c4;
      if (this.onframe(p4), c4 === 1)
        if (this.loop) {
          var g4 = l4 % o;
          this._startTime = n2 - g4, this._pausedTime = 0, this.onrestart();
        } else
          return true;
      return false;
    }, i.prototype.pause = function() {
      this._paused = true;
    }, i.prototype.resume = function() {
      this._paused = false;
    }, i.prototype.setEasing = function(n2) {
      this.easing = n2, this.easingFunc = si(n2) ? n2 : AIe[n2] || Ose(n2);
    }, i;
  }(), bot = yot, LIe = function() {
    function i(n2) {
      this.value = n2;
    }
    return i;
  }(), _ot = function() {
    function i() {
      this._len = 0;
    }
    return i.prototype.insert = function(n2) {
      var e2 = new LIe(n2);
      return this.insertEntry(e2), e2;
    }, i.prototype.insertEntry = function(n2) {
      this.head ? (this.tail.next = n2, n2.prev = this.tail, n2.next = null, this.tail = n2) : this.head = this.tail = n2, this._len++;
    }, i.prototype.remove = function(n2) {
      var e2 = n2.prev, o = n2.next;
      e2 ? e2.next = o : this.head = o, o ? o.prev = e2 : this.tail = e2, n2.next = n2.prev = null, this._len--;
    }, i.prototype.len = function() {
      return this._len;
    }, i.prototype.clear = function() {
      this.head = this.tail = null, this._len = 0;
    }, i;
  }(), xot = function() {
    function i(n2) {
      this._list = new _ot(), this._maxSize = 10, this._map = {}, this._maxSize = n2;
    }
    return i.prototype.put = function(n2, e2) {
      var o = this._list, l4 = this._map, c4 = null;
      if (l4[n2] == null) {
        var h = o.len(), p4 = this._lastRemovedEntry;
        if (h >= this._maxSize && h > 0) {
          var g4 = o.head;
          o.remove(g4), delete l4[g4.key], c4 = g4.value, this._lastRemovedEntry = g4;
        }
        p4 ? p4.value = e2 : p4 = new LIe(e2), p4.key = n2, o.insertEntry(p4), l4[n2] = p4;
      }
      return c4;
    }, i.prototype.get = function(n2) {
      var e2 = this._map[n2], o = this._list;
      if (e2 != null)
        return e2 !== o.tail && (o.remove(e2), o.insertEntry(e2)), e2.value;
    }, i.prototype.clear = function() {
      this._list.clear(), this._map = {};
    }, i.prototype.len = function() {
      return this._list.len();
    }, i;
  }(), F8 = xot, qxe = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
  function rb2(i) {
    return i = Math.round(i), i < 0 ? 0 : i > 255 ? 255 : i;
  }
  function wot(i) {
    return i = Math.round(i), i < 0 ? 0 : i > 360 ? 360 : i;
  }
  function s8(i) {
    return i < 0 ? 0 : i > 1 ? 1 : i;
  }
  function Zne(i) {
    var n2 = i;
    return n2.length && n2.charAt(n2.length - 1) === "%" ? rb2(parseFloat(n2) / 100 * 255) : rb2(parseInt(n2, 10));
  }
  function L3(i) {
    var n2 = i;
    return n2.length && n2.charAt(n2.length - 1) === "%" ? s8(parseFloat(n2) / 100) : s8(parseFloat(n2));
  }
  function Xne(i, n2, e2) {
    return e2 < 0 ? e2 += 1 : e2 > 1 && (e2 -= 1), e2 * 6 < 1 ? i + (n2 - i) * e2 * 6 : e2 * 2 < 1 ? n2 : e2 * 3 < 2 ? i + (n2 - i) * (2 / 3 - e2) * 6 : i;
  }
  function zC(i, n2, e2) {
    return i + (n2 - i) * e2;
  }
  function Sy(i, n2, e2, o, l4) {
    return i[0] = n2, i[1] = e2, i[2] = o, i[3] = l4, i;
  }
  function Lie(i, n2) {
    return i[0] = n2[0], i[1] = n2[1], i[2] = n2[2], i[3] = n2[3], i;
  }
  var OIe = new F8(20), GG = null;
  function $P(i, n2) {
    GG && Lie(GG, n2), GG = OIe.put(i, GG || n2.slice());
  }
  function nm(i, n2) {
    if (!!i) {
      n2 = n2 || [];
      var e2 = OIe.get(i);
      if (e2)
        return Lie(n2, e2);
      i = i + "";
      var o = i.replace(/ /g, "").toLowerCase();
      if (o in qxe)
        return Lie(n2, qxe[o]), $P(i, n2), n2;
      var l4 = o.length;
      if (o.charAt(0) === "#") {
        if (l4 === 4 || l4 === 5) {
          var c4 = parseInt(o.slice(1, 4), 16);
          if (!(c4 >= 0 && c4 <= 4095)) {
            Sy(n2, 0, 0, 0, 1);
            return;
          }
          return Sy(n2, (c4 & 3840) >> 4 | (c4 & 3840) >> 8, c4 & 240 | (c4 & 240) >> 4, c4 & 15 | (c4 & 15) << 4, l4 === 5 ? parseInt(o.slice(4), 16) / 15 : 1), $P(i, n2), n2;
        } else if (l4 === 7 || l4 === 9) {
          var c4 = parseInt(o.slice(1, 7), 16);
          if (!(c4 >= 0 && c4 <= 16777215)) {
            Sy(n2, 0, 0, 0, 1);
            return;
          }
          return Sy(n2, (c4 & 16711680) >> 16, (c4 & 65280) >> 8, c4 & 255, l4 === 9 ? parseInt(o.slice(7), 16) / 255 : 1), $P(i, n2), n2;
        }
        return;
      }
      var h = o.indexOf("("), p4 = o.indexOf(")");
      if (h !== -1 && p4 + 1 === l4) {
        var g4 = o.substr(0, h), y4 = o.substr(h + 1, p4 - (h + 1)).split(","), _ = 1;
        switch (g4) {
          case "rgba":
            if (y4.length !== 4)
              return y4.length === 3 ? Sy(n2, +y4[0], +y4[1], +y4[2], 1) : Sy(n2, 0, 0, 0, 1);
            _ = L3(y4.pop());
          case "rgb":
            if (y4.length !== 3) {
              Sy(n2, 0, 0, 0, 1);
              return;
            }
            return Sy(n2, Zne(y4[0]), Zne(y4[1]), Zne(y4[2]), _), $P(i, n2), n2;
          case "hsla":
            if (y4.length !== 4) {
              Sy(n2, 0, 0, 0, 1);
              return;
            }
            return y4[3] = L3(y4[3]), Oie(y4, n2), $P(i, n2), n2;
          case "hsl":
            if (y4.length !== 3) {
              Sy(n2, 0, 0, 0, 1);
              return;
            }
            return Oie(y4, n2), $P(i, n2), n2;
          default:
            return;
        }
      }
      Sy(n2, 0, 0, 0, 1);
    }
  }
  function Oie(i, n2) {
    var e2 = (parseFloat(i[0]) % 360 + 360) % 360 / 360, o = L3(i[1]), l4 = L3(i[2]), c4 = l4 <= 0.5 ? l4 * (o + 1) : l4 + o - l4 * o, h = l4 * 2 - c4;
    return n2 = n2 || [], Sy(n2, rb2(Xne(h, c4, e2 + 1 / 3) * 255), rb2(Xne(h, c4, e2) * 255), rb2(Xne(h, c4, e2 - 1 / 3) * 255), 1), i.length === 4 && (n2[3] = i[3]), n2;
  }
  function Sot(i) {
    if (!!i) {
      var n2 = i[0] / 255, e2 = i[1] / 255, o = i[2] / 255, l4 = Math.min(n2, e2, o), c4 = Math.max(n2, e2, o), h = c4 - l4, p4 = (c4 + l4) / 2, g4, y4;
      if (h === 0)
        g4 = 0, y4 = 0;
      else {
        p4 < 0.5 ? y4 = h / (c4 + l4) : y4 = h / (2 - c4 - l4);
        var _ = ((c4 - n2) / 6 + h / 2) / h, w4 = ((c4 - e2) / 6 + h / 2) / h, C = ((c4 - o) / 6 + h / 2) / h;
        n2 === c4 ? g4 = C - w4 : e2 === c4 ? g4 = 1 / 3 + _ - C : o === c4 && (g4 = 2 / 3 + w4 - _), g4 < 0 && (g4 += 1), g4 > 1 && (g4 -= 1);
      }
      var E = [g4 * 360, y4, p4];
      return i[3] != null && E.push(i[3]), E;
    }
  }
  function Rie(i, n2) {
    var e2 = nm(i);
    if (e2) {
      for (var o = 0; o < 3; o++)
        n2 < 0 ? e2[o] = e2[o] * (1 - n2) | 0 : e2[o] = (255 - e2[o]) * n2 + e2[o] | 0, e2[o] > 255 ? e2[o] = 255 : e2[o] < 0 && (e2[o] = 0);
      return d2(e2, e2.length === 4 ? "rgba" : "rgb");
    }
  }
  function Kne(i, n2, e2) {
    if (!(!(n2 && n2.length) || !(i >= 0 && i <= 1))) {
      e2 = e2 || [];
      var o = i * (n2.length - 1), l4 = Math.floor(o), c4 = Math.ceil(o), h = n2[l4], p4 = n2[c4], g4 = o - l4;
      return e2[0] = rb2(zC(h[0], p4[0], g4)), e2[1] = rb2(zC(h[1], p4[1], g4)), e2[2] = rb2(zC(h[2], p4[2], g4)), e2[3] = s8(zC(h[3], p4[3], g4)), e2;
    }
  }
  function Cot(i, n2, e2) {
    if (!(!(n2 && n2.length) || !(i >= 0 && i <= 1))) {
      var o = i * (n2.length - 1), l4 = Math.floor(o), c4 = Math.ceil(o), h = nm(n2[l4]), p4 = nm(n2[c4]), g4 = o - l4, y4 = d2([rb2(zC(h[0], p4[0], g4)), rb2(zC(h[1], p4[1], g4)), rb2(zC(h[2], p4[2], g4)), s8(zC(h[3], p4[3], g4))], "rgba");
      return e2 ? { color: y4, leftIndex: l4, rightIndex: c4, value: o } : y4;
    }
  }
  function BN(i, n2, e2, o) {
    var l4 = nm(i);
    if (i)
      return l4 = Sot(l4), n2 != null && (l4[0] = wot(n2)), e2 != null && (l4[1] = L3(e2)), o != null && (l4[2] = L3(o)), d2(Oie(l4), "rgba");
  }
  function bH(i, n2) {
    var e2 = nm(i);
    if (e2 && n2 != null)
      return e2[3] = s8(n2), d2(e2, "rgba");
  }
  function d2(i, n2) {
    if (!(!i || !i.length)) {
      var e2 = i[0] + "," + i[1] + "," + i[2];
      return (n2 === "rgba" || n2 === "hsva" || n2 === "hsla") && (e2 += "," + i[3]), n2 + "(" + e2 + ")";
    }
  }
  function _H(i, n2) {
    var e2 = nm(i);
    return e2 ? (0.299 * e2[0] + 0.587 * e2[1] + 0.114 * e2[2]) * e2[3] / 255 + (1 - e2[3]) * n2 : 0;
  }
  var xH = Math.round;
  function O3(i) {
    var n2;
    if (!i || i === "transparent")
      i = "none";
    else if (typeof i == "string" && i.indexOf("rgba") > -1) {
      var e2 = nm(i);
      e2 && (i = "rgb(" + e2[0] + "," + e2[1] + "," + e2[2] + ")", n2 = e2[3]);
    }
    return { color: i, opacity: n2 == null ? 1 : n2 };
  }
  var Yxe = 1e-4;
  function BC(i) {
    return i < Yxe && i > -Yxe;
  }
  function WG(i) {
    return xH(i * 1e3) / 1e3;
  }
  function Fie(i) {
    return xH(i * 1e4) / 1e4;
  }
  function Mot(i) {
    return "matrix(" + WG(i[0]) + "," + WG(i[1]) + "," + WG(i[2]) + "," + WG(i[3]) + "," + Fie(i[4]) + "," + Fie(i[5]) + ")";
  }
  var Aot = { left: "start", right: "end", center: "middle", middle: "middle" };
  function Eot(i, n2, e2) {
    return e2 === "top" ? i += n2 / 2 : e2 === "bottom" && (i -= n2 / 2), i;
  }
  function Iot(i) {
    return i && (i.shadowBlur || i.shadowOffsetX || i.shadowOffsetY);
  }
  function Tot(i) {
    var n2 = i.style, e2 = i.getGlobalScale();
    return [n2.shadowColor, (n2.shadowBlur || 0).toFixed(2), (n2.shadowOffsetX || 0).toFixed(2), (n2.shadowOffsetY || 0).toFixed(2), e2[0], e2[1]].join(",");
  }
  function RIe(i) {
    return i && !!i.image;
  }
  function Dot(i) {
    return i && !!i.svgElement;
  }
  function kot(i) {
    return RIe(i) || Dot(i);
  }
  function FIe(i) {
    return i.type === "linear";
  }
  function NIe(i) {
    return i.type === "radial";
  }
  function Pot(i) {
    return i && (i.type === "linear" || i.type === "radial");
  }
  function y$(i) {
    return "url(#" + i + ")";
  }
  function VIe(i) {
    var n2 = i.getGlobalScale(), e2 = Math.max(n2[0], n2[1]);
    return Math.max(Math.ceil(Math.log(e2) / Math.log(10)), 1);
  }
  function zIe(i) {
    var n2 = i.x || 0, e2 = i.y || 0, o = (i.rotation || 0) * YW, l4 = so(i.scaleX, 1), c4 = so(i.scaleY, 1), h = i.skewX || 0, p4 = i.skewY || 0, g4 = [];
    return (n2 || e2) && g4.push("translate(" + n2 + "px," + e2 + "px)"), o && g4.push("rotate(" + o + ")"), (l4 !== 1 || c4 !== 1) && g4.push("scale(" + l4 + "," + c4 + ")"), (h || p4) && g4.push("skew(" + xH(h * YW) + "deg, " + xH(p4 * YW) + "deg)"), g4.join(" ");
  }
  var Lot = function() {
    return ol.hasGlobalWindow && si(window.btoa) ? function(i) {
      return window.btoa(unescape(i));
    } : typeof Buffer != "undefined" ? function(i) {
      return Buffer.from(i).toString("base64");
    } : function(i) {
      return null;
    };
  }(), Nie = Array.prototype.slice;
  function s2(i, n2, e2) {
    return (n2 - i) * e2 + i;
  }
  function Jne(i, n2, e2, o) {
    for (var l4 = n2.length, c4 = 0; c4 < l4; c4++)
      i[c4] = s2(n2[c4], e2[c4], o);
    return i;
  }
  function Oot(i, n2, e2, o) {
    for (var l4 = n2.length, c4 = l4 && n2[0].length, h = 0; h < l4; h++) {
      i[h] || (i[h] = []);
      for (var p4 = 0; p4 < c4; p4++)
        i[h][p4] = s2(n2[h][p4], e2[h][p4], o);
    }
    return i;
  }
  function HG(i, n2, e2, o) {
    for (var l4 = n2.length, c4 = 0; c4 < l4; c4++)
      i[c4] = n2[c4] + e2[c4] * o;
    return i;
  }
  function Zxe(i, n2, e2, o) {
    for (var l4 = n2.length, c4 = l4 && n2[0].length, h = 0; h < l4; h++) {
      i[h] || (i[h] = []);
      for (var p4 = 0; p4 < c4; p4++)
        i[h][p4] = n2[h][p4] + e2[h][p4] * o;
    }
    return i;
  }
  function Rot(i, n2) {
    for (var e2 = i.length, o = n2.length, l4 = e2 > o ? n2 : i, c4 = Math.min(e2, o), h = l4[c4 - 1] || { color: [0, 0, 0, 0], offset: 0 }, p4 = c4; p4 < Math.max(e2, o); p4++)
      l4.push({ offset: h.offset, color: h.color.slice() });
  }
  function Fot(i, n2, e2) {
    var o = i, l4 = n2;
    if (!(!o.push || !l4.push)) {
      var c4 = o.length, h = l4.length;
      if (c4 !== h) {
        var p4 = c4 > h;
        if (p4)
          o.length = h;
        else
          for (var g4 = c4; g4 < h; g4++)
            o.push(e2 === 1 ? l4[g4] : Nie.call(l4[g4]));
      }
      for (var y4 = o[0] && o[0].length, g4 = 0; g4 < o.length; g4++)
        if (e2 === 1)
          isNaN(o[g4]) && (o[g4] = l4[g4]);
        else
          for (var _ = 0; _ < y4; _++)
            isNaN(o[g4][_]) && (o[g4][_] = l4[g4][_]);
    }
  }
  function jN(i) {
    if (gv(i)) {
      var n2 = i.length;
      if (gv(i[0])) {
        for (var e2 = [], o = 0; o < n2; o++)
          e2.push(Nie.call(i[o]));
        return e2;
      }
      return Nie.call(i);
    }
    return i;
  }
  function JW(i) {
    return i[0] = Math.floor(i[0]) || 0, i[1] = Math.floor(i[1]) || 0, i[2] = Math.floor(i[2]) || 0, i[3] = i[3] == null ? 1 : i[3], "rgba(" + i.join(",") + ")";
  }
  function Not(i) {
    return gv(i && i[0]) ? 2 : 1;
  }
  var $G = 0, QW = 1, BIe = 2, EN = 3, Vie = 4, zie = 5, Xxe = 6;
  function Kxe(i) {
    return i === Vie || i === zie;
  }
  function UG(i) {
    return i === QW || i === BIe;
  }
  var XF = [0, 0, 0, 0], Vot = function() {
    function i(n2) {
      this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = n2;
    }
    return i.prototype.isFinished = function() {
      return this._finished;
    }, i.prototype.setFinished = function() {
      this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
    }, i.prototype.needsAnimate = function() {
      return this.keyframes.length >= 1;
    }, i.prototype.getAdditiveTrack = function() {
      return this._additiveTrack;
    }, i.prototype.addKeyframe = function(n2, e2, o) {
      this._needsSort = true;
      var l4 = this.keyframes, c4 = l4.length, h = false, p4 = Xxe, g4 = e2;
      if (gv(e2)) {
        var y4 = Not(e2);
        p4 = y4, (y4 === 1 && !sl(e2[0]) || y4 === 2 && !sl(e2[0][0])) && (h = true);
      } else if (sl(e2) && !i8(e2))
        p4 = $G;
      else if (xa(e2))
        if (!isNaN(+e2))
          p4 = $G;
        else {
          var _ = nm(e2);
          _ && (g4 = _, p4 = EN);
        }
      else if (g$(e2)) {
        var w4 = rr({}, g4);
        w4.colorStops = Er(e2.colorStops, function(E) {
          return { offset: E.offset, color: nm(E.color) };
        }), FIe(e2) ? p4 = Vie : NIe(e2) && (p4 = zie), g4 = w4;
      }
      c4 === 0 ? this.valType = p4 : (p4 !== this.valType || p4 === Xxe) && (h = true), this.discrete = this.discrete || h;
      var C = { time: n2, value: g4, rawValue: e2, percent: 0 };
      return o && (C.easing = o, C.easingFunc = si(o) ? o : AIe[o] || Ose(o)), l4.push(C), C;
    }, i.prototype.prepare = function(n2, e2) {
      var o = this.keyframes;
      this._needsSort && o.sort(function(O, N) {
        return O.time - N.time;
      });
      for (var l4 = this.valType, c4 = o.length, h = o[c4 - 1], p4 = this.discrete, g4 = UG(l4), y4 = Kxe(l4), _ = 0; _ < c4; _++) {
        var w4 = o[_], C = w4.value, E = h.value;
        w4.percent = w4.time / n2, p4 || (g4 && _ !== c4 - 1 ? Fot(C, E, l4) : y4 && Rot(C.colorStops, E.colorStops));
      }
      if (!p4 && l4 !== zie && e2 && this.needsAnimate() && e2.needsAnimate() && l4 === e2.valType && !e2._finished) {
        this._additiveTrack = e2;
        for (var T = o[0].value, _ = 0; _ < c4; _++)
          l4 === $G ? o[_].additiveValue = o[_].value - T : l4 === EN ? o[_].additiveValue = HG([], o[_].value, T, -1) : UG(l4) && (o[_].additiveValue = l4 === QW ? HG([], o[_].value, T, -1) : Zxe([], o[_].value, T, -1));
      }
    }, i.prototype.step = function(n2, e2) {
      if (!this._finished) {
        this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
        var o = this._additiveTrack != null, l4 = o ? "additiveValue" : "value", c4 = this.valType, h = this.keyframes, p4 = h.length, g4 = this.propName, y4 = c4 === EN, _, w4 = this._lastFr, C = Math.min, E, T;
        if (p4 === 1)
          E = T = h[0];
        else {
          if (e2 < 0)
            _ = 0;
          else if (e2 < this._lastFrP) {
            var O = C(w4 + 1, p4 - 1);
            for (_ = O; _ >= 0 && !(h[_].percent <= e2); _--)
              ;
            _ = C(_, p4 - 2);
          } else {
            for (_ = w4; _ < p4 && !(h[_].percent > e2); _++)
              ;
            _ = C(_ - 1, p4 - 2);
          }
          T = h[_ + 1], E = h[_];
        }
        if (!!(E && T)) {
          this._lastFr = _, this._lastFrP = e2;
          var N = T.percent - E.percent, V = N === 0 ? 1 : C((e2 - E.percent) / N, 1);
          T.easingFunc && (V = T.easingFunc(V));
          var H = o ? this._additiveValue : y4 ? XF : n2[g4];
          if ((UG(c4) || y4) && !H && (H = this._additiveValue = []), this.discrete)
            n2[g4] = V < 1 ? E.rawValue : T.rawValue;
          else if (UG(c4))
            c4 === QW ? Jne(H, E[l4], T[l4], V) : Oot(H, E[l4], T[l4], V);
          else if (Kxe(c4)) {
            var X = E[l4], q2 = T[l4], de = c4 === Vie;
            n2[g4] = { type: de ? "linear" : "radial", x: s2(X.x, q2.x, V), y: s2(X.y, q2.y, V), colorStops: Er(X.colorStops, function(me, ye) {
              var be = q2.colorStops[ye];
              return { offset: s2(me.offset, be.offset, V), color: JW(Jne([], me.color, be.color, V)) };
            }), global: q2.global }, de ? (n2[g4].x2 = s2(X.x2, q2.x2, V), n2[g4].y2 = s2(X.y2, q2.y2, V)) : n2[g4].r = s2(X.r, q2.r, V);
          } else if (y4)
            Jne(H, E[l4], T[l4], V), o || (n2[g4] = JW(H));
          else {
            var le = s2(E[l4], T[l4], V);
            o ? this._additiveValue = le : n2[g4] = le;
          }
          o && this._addToTarget(n2);
        }
      }
    }, i.prototype._addToTarget = function(n2) {
      var e2 = this.valType, o = this.propName, l4 = this._additiveValue;
      e2 === $G ? n2[o] = n2[o] + l4 : e2 === EN ? (nm(n2[o], XF), HG(XF, XF, l4, 1), n2[o] = JW(XF)) : e2 === QW ? HG(n2[o], n2[o], l4, 1) : e2 === BIe && Zxe(n2[o], n2[o], l4, 1);
    }, i;
  }(), Rse = function() {
    function i(n2, e2, o, l4) {
      if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = n2, this._loop = e2, e2 && l4) {
        Tse("Can' use additive animation on looped animation.");
        return;
      }
      this._additiveAnimators = l4, this._allowDiscrete = o;
    }
    return i.prototype.getMaxTime = function() {
      return this._maxTime;
    }, i.prototype.getDelay = function() {
      return this._delay;
    }, i.prototype.getLoop = function() {
      return this._loop;
    }, i.prototype.getTarget = function() {
      return this._target;
    }, i.prototype.changeTarget = function(n2) {
      this._target = n2;
    }, i.prototype.when = function(n2, e2, o) {
      return this.whenWithKeys(n2, e2, ts(e2), o);
    }, i.prototype.whenWithKeys = function(n2, e2, o, l4) {
      for (var c4 = this._tracks, h = 0; h < o.length; h++) {
        var p4 = o[h], g4 = c4[p4];
        if (!g4) {
          g4 = c4[p4] = new Vot(p4);
          var y4 = void 0, _ = this._getAdditiveTrack(p4);
          if (_) {
            var w4 = _.keyframes, C = w4[w4.length - 1];
            y4 = C && C.value, _.valType === EN && y4 && (y4 = JW(y4));
          } else
            y4 = this._target[p4];
          if (y4 == null)
            continue;
          n2 > 0 && g4.addKeyframe(0, jN(y4), l4), this._trackKeys.push(p4);
        }
        g4.addKeyframe(n2, jN(e2[p4]), l4);
      }
      return this._maxTime = Math.max(this._maxTime, n2), this;
    }, i.prototype.pause = function() {
      this._clip.pause(), this._paused = true;
    }, i.prototype.resume = function() {
      this._clip.resume(), this._paused = false;
    }, i.prototype.isPaused = function() {
      return !!this._paused;
    }, i.prototype.duration = function(n2) {
      return this._maxTime = n2, this._force = true, this;
    }, i.prototype._doneCallback = function() {
      this._setTracksFinished(), this._clip = null;
      var n2 = this._doneCbs;
      if (n2)
        for (var e2 = n2.length, o = 0; o < e2; o++)
          n2[o].call(this);
    }, i.prototype._abortedCallback = function() {
      this._setTracksFinished();
      var n2 = this.animation, e2 = this._abortedCbs;
      if (n2 && n2.removeClip(this._clip), this._clip = null, e2)
        for (var o = 0; o < e2.length; o++)
          e2[o].call(this);
    }, i.prototype._setTracksFinished = function() {
      for (var n2 = this._tracks, e2 = this._trackKeys, o = 0; o < e2.length; o++)
        n2[e2[o]].setFinished();
    }, i.prototype._getAdditiveTrack = function(n2) {
      var e2, o = this._additiveAnimators;
      if (o)
        for (var l4 = 0; l4 < o.length; l4++) {
          var c4 = o[l4].getTrack(n2);
          c4 && (e2 = c4);
        }
      return e2;
    }, i.prototype.start = function(n2) {
      if (!(this._started > 0)) {
        this._started = 1;
        for (var e2 = this, o = [], l4 = this._maxTime || 0, c4 = 0; c4 < this._trackKeys.length; c4++) {
          var h = this._trackKeys[c4], p4 = this._tracks[h], g4 = this._getAdditiveTrack(h), y4 = p4.keyframes, _ = y4.length;
          if (p4.prepare(l4, g4), p4.needsAnimate())
            if (!this._allowDiscrete && p4.discrete) {
              var w4 = y4[_ - 1];
              w4 && (e2._target[p4.propName] = w4.rawValue), p4.setFinished();
            } else
              o.push(p4);
        }
        if (o.length || this._force) {
          var C = new bot({ life: l4, loop: this._loop, delay: this._delay || 0, onframe: function(E) {
            e2._started = 2;
            var T = e2._additiveAnimators;
            if (T) {
              for (var O = false, N = 0; N < T.length; N++)
                if (T[N]._clip) {
                  O = true;
                  break;
                }
              O || (e2._additiveAnimators = null);
            }
            for (var N = 0; N < o.length; N++)
              o[N].step(e2._target, E);
            var V = e2._onframeCbs;
            if (V)
              for (var N = 0; N < V.length; N++)
                V[N](e2._target, E);
          }, ondestroy: function() {
            e2._doneCallback();
          } });
          this._clip = C, this.animation && this.animation.addClip(C), n2 && C.setEasing(n2);
        } else
          this._doneCallback();
        return this;
      }
    }, i.prototype.stop = function(n2) {
      if (!!this._clip) {
        var e2 = this._clip;
        n2 && e2.onframe(1), this._abortedCallback();
      }
    }, i.prototype.delay = function(n2) {
      return this._delay = n2, this;
    }, i.prototype.during = function(n2) {
      return n2 && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(n2)), this;
    }, i.prototype.done = function(n2) {
      return n2 && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(n2)), this;
    }, i.prototype.aborted = function(n2) {
      return n2 && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(n2)), this;
    }, i.prototype.getClip = function() {
      return this._clip;
    }, i.prototype.getTrack = function(n2) {
      return this._tracks[n2];
    }, i.prototype.getTracks = function() {
      var n2 = this;
      return Er(this._trackKeys, function(e2) {
        return n2._tracks[e2];
      });
    }, i.prototype.stopTracks = function(n2, e2) {
      if (!n2.length || !this._clip)
        return true;
      for (var o = this._tracks, l4 = this._trackKeys, c4 = 0; c4 < n2.length; c4++) {
        var h = o[n2[c4]];
        h && !h.isFinished() && (e2 ? h.step(this._target, 1) : this._started === 1 && h.step(this._target, 0), h.setFinished());
      }
      for (var p4 = true, c4 = 0; c4 < l4.length; c4++)
        if (!o[l4[c4]].isFinished()) {
          p4 = false;
          break;
        }
      return p4 && this._abortedCallback(), p4;
    }, i.prototype.saveTo = function(n2, e2, o) {
      if (!!n2) {
        e2 = e2 || this._trackKeys;
        for (var l4 = 0; l4 < e2.length; l4++) {
          var c4 = e2[l4], h = this._tracks[c4];
          if (!(!h || h.isFinished())) {
            var p4 = h.keyframes, g4 = p4[o ? 0 : p4.length - 1];
            g4 && (n2[c4] = jN(g4.rawValue));
          }
        }
      }
    }, i.prototype.__changeFinalValue = function(n2, e2) {
      e2 = e2 || ts(n2);
      for (var o = 0; o < e2.length; o++) {
        var l4 = e2[o], c4 = this._tracks[l4];
        if (!!c4) {
          var h = c4.keyframes;
          if (h.length > 1) {
            var p4 = h.pop();
            c4.addKeyframe(p4.time, n2[l4]), c4.prepare(this._maxTime, c4.getAdditiveTrack());
          }
        }
      }
    }, i;
  }();
  function y3() {
    return new Date().getTime();
  }
  var zot = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this) || this;
      return o._running = false, o._time = 0, o._pausedTime = 0, o._pauseStart = 0, o._paused = false, e2 = e2 || {}, o.stage = e2.stage || {}, o;
    }
    return n2.prototype.addClip = function(e2) {
      e2.animation && this.removeClip(e2), this._head ? (this._tail.next = e2, e2.prev = this._tail, e2.next = null, this._tail = e2) : this._head = this._tail = e2, e2.animation = this;
    }, n2.prototype.addAnimator = function(e2) {
      e2.animation = this;
      var o = e2.getClip();
      o && this.addClip(o);
    }, n2.prototype.removeClip = function(e2) {
      if (!!e2.animation) {
        var o = e2.prev, l4 = e2.next;
        o ? o.next = l4 : this._head = l4, l4 ? l4.prev = o : this._tail = o, e2.next = e2.prev = e2.animation = null;
      }
    }, n2.prototype.removeAnimator = function(e2) {
      var o = e2.getClip();
      o && this.removeClip(o), e2.animation = null;
    }, n2.prototype.update = function(e2) {
      for (var o = y3() - this._pausedTime, l4 = o - this._time, c4 = this._head; c4; ) {
        var h = c4.next, p4 = c4.step(o, l4);
        p4 && (c4.ondestroy(), this.removeClip(c4)), c4 = h;
      }
      this._time = o, e2 || (this.trigger("frame", l4), this.stage.update && this.stage.update());
    }, n2.prototype._startLoop = function() {
      var e2 = this;
      this._running = true;
      function o() {
        e2._running && (kie(o), !e2._paused && e2.update());
      }
      kie(o);
    }, n2.prototype.start = function() {
      this._running || (this._time = y3(), this._pausedTime = 0, this._startLoop());
    }, n2.prototype.stop = function() {
      this._running = false;
    }, n2.prototype.pause = function() {
      this._paused || (this._pauseStart = y3(), this._paused = true);
    }, n2.prototype.resume = function() {
      this._paused && (this._pausedTime += y3() - this._pauseStart, this._paused = false);
    }, n2.prototype.clear = function() {
      for (var e2 = this._head; e2; ) {
        var o = e2.next;
        e2.prev = e2.next = e2.animation = null, e2 = o;
      }
      this._head = this._tail = null;
    }, n2.prototype.isFinished = function() {
      return this._head == null;
    }, n2.prototype.animate = function(e2, o) {
      o = o || {}, this.start();
      var l4 = new Rse(e2, o.loop);
      return this.addAnimator(l4), l4;
    }, n2;
  }(zy), Bot = zot, jot = 300, Qne = ol.domSupported, ere = function() {
    var i = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], n2 = ["touchstart", "touchend", "touchmove"], e2 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, o = Er(i, function(l4) {
      var c4 = l4.replace("mouse", "pointer");
      return e2.hasOwnProperty(c4) ? c4 : l4;
    });
    return { mouse: i, touch: n2, pointer: o };
  }(), Jxe = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, Qxe = false;
  function Bie(i) {
    var n2 = i.pointerType;
    return n2 === "pen" || n2 === "touch";
  }
  function Got(i) {
    i.touching = true, i.touchTimer != null && (clearTimeout(i.touchTimer), i.touchTimer = null), i.touchTimer = setTimeout(function() {
      i.touching = false, i.touchTimer = null;
    }, 700);
  }
  function tre(i) {
    i && (i.zrByTouch = true);
  }
  function Wot(i, n2) {
    return Cy(i.dom, new Hot(i, n2), true);
  }
  function jIe(i, n2) {
    for (var e2 = n2, o = false; e2 && e2.nodeType !== 9 && !(o = e2.domBelongToZr || e2 !== n2 && e2 === i.painterRoot); )
      e2 = e2.parentNode;
    return o;
  }
  var Hot = function() {
    function i(n2, e2) {
      this.stopPropagation = Zf, this.stopImmediatePropagation = Zf, this.preventDefault = Zf, this.type = e2.type, this.target = this.currentTarget = n2.dom, this.pointerType = e2.pointerType, this.clientX = e2.clientX, this.clientY = e2.clientY;
    }
    return i;
  }(), J1 = { mousedown: function(i) {
    i = Cy(this.dom, i), this.__mayPointerCapture = [i.zrX, i.zrY], this.trigger("mousedown", i);
  }, mousemove: function(i) {
    i = Cy(this.dom, i);
    var n2 = this.__mayPointerCapture;
    n2 && (i.zrX !== n2[0] || i.zrY !== n2[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", i);
  }, mouseup: function(i) {
    i = Cy(this.dom, i), this.__togglePointerCapture(false), this.trigger("mouseup", i);
  }, mouseout: function(i) {
    i = Cy(this.dom, i);
    var n2 = i.toElement || i.relatedTarget;
    jIe(this, n2) || (this.__pointerCapturing && (i.zrEventControl = "no_globalout"), this.trigger("mouseout", i));
  }, wheel: function(i) {
    Qxe = true, i = Cy(this.dom, i), this.trigger("mousewheel", i);
  }, mousewheel: function(i) {
    Qxe || (i = Cy(this.dom, i), this.trigger("mousewheel", i));
  }, touchstart: function(i) {
    i = Cy(this.dom, i), tre(i), this.__lastTouchMoment = new Date(), this.handler.processGesture(i, "start"), J1.mousemove.call(this, i), J1.mousedown.call(this, i);
  }, touchmove: function(i) {
    i = Cy(this.dom, i), tre(i), this.handler.processGesture(i, "change"), J1.mousemove.call(this, i);
  }, touchend: function(i) {
    i = Cy(this.dom, i), tre(i), this.handler.processGesture(i, "end"), J1.mouseup.call(this, i), +new Date() - +this.__lastTouchMoment < jot && J1.click.call(this, i);
  }, pointerdown: function(i) {
    J1.mousedown.call(this, i);
  }, pointermove: function(i) {
    Bie(i) || J1.mousemove.call(this, i);
  }, pointerup: function(i) {
    J1.mouseup.call(this, i);
  }, pointerout: function(i) {
    Bie(i) || J1.mouseout.call(this, i);
  } };
  Ve(["click", "dblclick", "contextmenu"], function(i) {
    J1[i] = function(n2) {
      n2 = Cy(this.dom, n2), this.trigger(i, n2);
    };
  });
  var jie = { pointermove: function(i) {
    Bie(i) || jie.mousemove.call(this, i);
  }, pointerup: function(i) {
    jie.mouseup.call(this, i);
  }, mousemove: function(i) {
    this.trigger("mousemove", i);
  }, mouseup: function(i) {
    var n2 = this.__pointerCapturing;
    this.__togglePointerCapture(false), this.trigger("mouseup", i), n2 && (i.zrEventControl = "only_globalout", this.trigger("mouseout", i));
  } };
  function $ot(i, n2) {
    var e2 = n2.domHandlers;
    ol.pointerEventsSupported ? Ve(ere.pointer, function(o) {
      eH(n2, o, function(l4) {
        e2[o].call(i, l4);
      });
    }) : (ol.touchEventsSupported && Ve(ere.touch, function(o) {
      eH(n2, o, function(l4) {
        e2[o].call(i, l4), Got(n2);
      });
    }), Ve(ere.mouse, function(o) {
      eH(n2, o, function(l4) {
        l4 = Lse(l4), n2.touching || e2[o].call(i, l4);
      });
    }));
  }
  function Uot(i, n2) {
    ol.pointerEventsSupported ? Ve(Jxe.pointer, e2) : ol.touchEventsSupported || Ve(Jxe.mouse, e2);
    function e2(o) {
      function l4(c4) {
        c4 = Lse(c4), jIe(i, c4.target) || (c4 = Wot(i, c4), n2.domHandlers[o].call(i, c4));
      }
      eH(n2, o, l4, { capture: true });
    }
  }
  function eH(i, n2, e2, o) {
    i.mounted[n2] = e2, i.listenerOpts[n2] = o, Die(i.domTarget, n2, e2, o);
  }
  function nre(i) {
    var n2 = i.mounted;
    for (var e2 in n2)
      n2.hasOwnProperty(e2) && eot(i.domTarget, e2, n2[e2], i.listenerOpts[e2]);
    i.mounted = {};
  }
  var ewe = function() {
    function i(n2, e2) {
      this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = n2, this.domHandlers = e2;
    }
    return i;
  }(), qot = function(i) {
    on(n2, i);
    function n2(e2, o) {
      var l4 = i.call(this) || this;
      return l4.__pointerCapturing = false, l4.dom = e2, l4.painterRoot = o, l4._localHandlerScope = new ewe(e2, J1), Qne && (l4._globalHandlerScope = new ewe(document, jie)), $ot(l4, l4._localHandlerScope), l4;
    }
    return n2.prototype.dispose = function() {
      nre(this._localHandlerScope), Qne && nre(this._globalHandlerScope);
    }, n2.prototype.setCursor = function(e2) {
      this.dom.style && (this.dom.style.cursor = e2 || "default");
    }, n2.prototype.__togglePointerCapture = function(e2) {
      if (this.__mayPointerCapture = null, Qne && +this.__pointerCapturing ^ +e2) {
        this.__pointerCapturing = e2;
        var o = this._globalHandlerScope;
        e2 ? Uot(this, o) : nre(o);
      }
    }, n2;
  }(zy), Yot = qot, GIe = 1;
  ol.hasGlobalWindow && (GIe = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
  var wH = GIe, Gie = 0.4, Wie = "#333", Hie = "#ccc", Zot = "#eee";
  function Ny() {
    return [1, 0, 0, 1, 0, 0];
  }
  function b$(i) {
    return i[0] = 1, i[1] = 0, i[2] = 0, i[3] = 1, i[4] = 0, i[5] = 0, i;
  }
  function Fse(i, n2) {
    return i[0] = n2[0], i[1] = n2[1], i[2] = n2[2], i[3] = n2[3], i[4] = n2[4], i[5] = n2[5], i;
  }
  function p2(i, n2, e2) {
    var o = n2[0] * e2[0] + n2[2] * e2[1], l4 = n2[1] * e2[0] + n2[3] * e2[1], c4 = n2[0] * e2[2] + n2[2] * e2[3], h = n2[1] * e2[2] + n2[3] * e2[3], p4 = n2[0] * e2[4] + n2[2] * e2[5] + n2[4], g4 = n2[1] * e2[4] + n2[3] * e2[5] + n2[5];
    return i[0] = o, i[1] = l4, i[2] = c4, i[3] = h, i[4] = p4, i[5] = g4, i;
  }
  function Y_(i, n2, e2) {
    return i[0] = n2[0], i[1] = n2[1], i[2] = n2[2], i[3] = n2[3], i[4] = n2[4] + e2[0], i[5] = n2[5] + e2[1], i;
  }
  function MT(i, n2, e2) {
    var o = n2[0], l4 = n2[2], c4 = n2[4], h = n2[1], p4 = n2[3], g4 = n2[5], y4 = Math.sin(e2), _ = Math.cos(e2);
    return i[0] = o * _ + h * y4, i[1] = -o * y4 + h * _, i[2] = l4 * _ + p4 * y4, i[3] = -l4 * y4 + _ * p4, i[4] = _ * c4 + y4 * g4, i[5] = _ * g4 - y4 * c4, i;
  }
  function Nse(i, n2, e2) {
    var o = e2[0], l4 = e2[1];
    return i[0] = n2[0] * o, i[1] = n2[1] * l4, i[2] = n2[2] * o, i[3] = n2[3] * l4, i[4] = n2[4] * o, i[5] = n2[5] * l4, i;
  }
  function W3(i, n2) {
    var e2 = n2[0], o = n2[2], l4 = n2[4], c4 = n2[1], h = n2[3], p4 = n2[5], g4 = e2 * h - c4 * o;
    return g4 ? (g4 = 1 / g4, i[0] = h * g4, i[1] = -c4 * g4, i[2] = -o * g4, i[3] = e2 * g4, i[4] = (o * p4 - h * l4) * g4, i[5] = (c4 * l4 - e2 * p4) * g4, i) : null;
  }
  function Xot(i) {
    var n2 = Ny();
    return Fse(n2, i), n2;
  }
  var twe = b$, nwe = 5e-5;
  function yI(i) {
    return i > nwe || i < -nwe;
  }
  var bI = [], UP = [], rre = Ny(), are = Math.abs, Kot = function() {
    function i() {
    }
    return i.prototype.getLocalTransform = function(n2) {
      return i.getLocalTransform(this, n2);
    }, i.prototype.setPosition = function(n2) {
      this.x = n2[0], this.y = n2[1];
    }, i.prototype.setScale = function(n2) {
      this.scaleX = n2[0], this.scaleY = n2[1];
    }, i.prototype.setSkew = function(n2) {
      this.skewX = n2[0], this.skewY = n2[1];
    }, i.prototype.setOrigin = function(n2) {
      this.originX = n2[0], this.originY = n2[1];
    }, i.prototype.needLocalTransform = function() {
      return yI(this.rotation) || yI(this.x) || yI(this.y) || yI(this.scaleX - 1) || yI(this.scaleY - 1) || yI(this.skewX) || yI(this.skewY);
    }, i.prototype.updateTransform = function() {
      var n2 = this.parent && this.parent.transform, e2 = this.needLocalTransform(), o = this.transform;
      if (!(e2 || n2)) {
        o && twe(o);
        return;
      }
      o = o || Ny(), e2 ? this.getLocalTransform(o) : twe(o), n2 && (e2 ? p2(o, n2, o) : Fse(o, n2)), this.transform = o, this._resolveGlobalScaleRatio(o);
    }, i.prototype._resolveGlobalScaleRatio = function(n2) {
      var e2 = this.globalScaleRatio;
      if (e2 != null && e2 !== 1) {
        this.getGlobalScale(bI);
        var o = bI[0] < 0 ? -1 : 1, l4 = bI[1] < 0 ? -1 : 1, c4 = ((bI[0] - o) * e2 + o) / bI[0] || 0, h = ((bI[1] - l4) * e2 + l4) / bI[1] || 0;
        n2[0] *= c4, n2[1] *= c4, n2[2] *= h, n2[3] *= h;
      }
      this.invTransform = this.invTransform || Ny(), W3(this.invTransform, n2);
    }, i.prototype.getComputedTransform = function() {
      for (var n2 = this, e2 = []; n2; )
        e2.push(n2), n2 = n2.parent;
      for (; n2 = e2.pop(); )
        n2.updateTransform();
      return this.transform;
    }, i.prototype.setLocalTransform = function(n2) {
      if (!!n2) {
        var e2 = n2[0] * n2[0] + n2[1] * n2[1], o = n2[2] * n2[2] + n2[3] * n2[3], l4 = Math.atan2(n2[1], n2[0]), c4 = Math.PI / 2 + l4 - Math.atan2(n2[3], n2[2]);
        o = Math.sqrt(o) * Math.cos(c4), e2 = Math.sqrt(e2), this.skewX = c4, this.skewY = 0, this.rotation = -l4, this.x = +n2[4], this.y = +n2[5], this.scaleX = e2, this.scaleY = o, this.originX = 0, this.originY = 0;
      }
    }, i.prototype.decomposeTransform = function() {
      if (!!this.transform) {
        var n2 = this.parent, e2 = this.transform;
        n2 && n2.transform && (p2(UP, n2.invTransform, e2), e2 = UP);
        var o = this.originX, l4 = this.originY;
        (o || l4) && (rre[4] = o, rre[5] = l4, p2(UP, e2, rre), UP[4] -= o, UP[5] -= l4, e2 = UP), this.setLocalTransform(e2);
      }
    }, i.prototype.getGlobalScale = function(n2) {
      var e2 = this.transform;
      return n2 = n2 || [], e2 ? (n2[0] = Math.sqrt(e2[0] * e2[0] + e2[1] * e2[1]), n2[1] = Math.sqrt(e2[2] * e2[2] + e2[3] * e2[3]), e2[0] < 0 && (n2[0] = -n2[0]), e2[3] < 0 && (n2[1] = -n2[1]), n2) : (n2[0] = 1, n2[1] = 1, n2);
    }, i.prototype.transformCoordToLocal = function(n2, e2) {
      var o = [n2, e2], l4 = this.invTransform;
      return l4 && Sp(o, o, l4), o;
    }, i.prototype.transformCoordToGlobal = function(n2, e2) {
      var o = [n2, e2], l4 = this.transform;
      return l4 && Sp(o, o, l4), o;
    }, i.prototype.getLineScale = function() {
      var n2 = this.transform;
      return n2 && are(n2[0] - 1) > 1e-10 && are(n2[3] - 1) > 1e-10 ? Math.sqrt(are(n2[0] * n2[3] - n2[2] * n2[1])) : 1;
    }, i.prototype.copyTransform = function(n2) {
      WIe(this, n2);
    }, i.getLocalTransform = function(n2, e2) {
      e2 = e2 || [];
      var o = n2.originX || 0, l4 = n2.originY || 0, c4 = n2.scaleX, h = n2.scaleY, p4 = n2.anchorX, g4 = n2.anchorY, y4 = n2.rotation || 0, _ = n2.x, w4 = n2.y, C = n2.skewX ? Math.tan(n2.skewX) : 0, E = n2.skewY ? Math.tan(-n2.skewY) : 0;
      if (o || l4 || p4 || g4) {
        var T = o + p4, O = l4 + g4;
        e2[4] = -T * c4 - C * O * h, e2[5] = -O * h - E * T * c4;
      } else
        e2[4] = e2[5] = 0;
      return e2[0] = c4, e2[3] = h, e2[1] = E * c4, e2[2] = C * h, y4 && MT(e2, e2, y4), e2[4] += o + _, e2[5] += l4 + w4, e2;
    }, i.initDefaultProps = function() {
      var n2 = i.prototype;
      n2.scaleX = n2.scaleY = n2.globalScaleRatio = 1, n2.x = n2.y = n2.originX = n2.originY = n2.skewX = n2.skewY = n2.rotation = n2.anchorX = n2.anchorY = 0;
    }(), i;
  }(), Z_ = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
  function WIe(i, n2) {
    for (var e2 = 0; e2 < Z_.length; e2++) {
      var o = Z_[e2];
      i[o] = n2[o];
    }
  }
  var u2 = Kot, Jot = function() {
    function i(n2, e2) {
      this.x = n2 || 0, this.y = e2 || 0;
    }
    return i.prototype.copy = function(n2) {
      return this.x = n2.x, this.y = n2.y, this;
    }, i.prototype.clone = function() {
      return new i(this.x, this.y);
    }, i.prototype.set = function(n2, e2) {
      return this.x = n2, this.y = e2, this;
    }, i.prototype.equal = function(n2) {
      return n2.x === this.x && n2.y === this.y;
    }, i.prototype.add = function(n2) {
      return this.x += n2.x, this.y += n2.y, this;
    }, i.prototype.scale = function(n2) {
      this.x *= n2, this.y *= n2;
    }, i.prototype.scaleAndAdd = function(n2, e2) {
      this.x += n2.x * e2, this.y += n2.y * e2;
    }, i.prototype.sub = function(n2) {
      return this.x -= n2.x, this.y -= n2.y, this;
    }, i.prototype.dot = function(n2) {
      return this.x * n2.x + this.y * n2.y;
    }, i.prototype.len = function() {
      return Math.sqrt(this.x * this.x + this.y * this.y);
    }, i.prototype.lenSquare = function() {
      return this.x * this.x + this.y * this.y;
    }, i.prototype.normalize = function() {
      var n2 = this.len();
      return this.x /= n2, this.y /= n2, this;
    }, i.prototype.distance = function(n2) {
      var e2 = this.x - n2.x, o = this.y - n2.y;
      return Math.sqrt(e2 * e2 + o * o);
    }, i.prototype.distanceSquare = function(n2) {
      var e2 = this.x - n2.x, o = this.y - n2.y;
      return e2 * e2 + o * o;
    }, i.prototype.negate = function() {
      return this.x = -this.x, this.y = -this.y, this;
    }, i.prototype.transform = function(n2) {
      if (!!n2) {
        var e2 = this.x, o = this.y;
        return this.x = n2[0] * e2 + n2[2] * o + n2[4], this.y = n2[1] * e2 + n2[3] * o + n2[5], this;
      }
    }, i.prototype.toArray = function(n2) {
      return n2[0] = this.x, n2[1] = this.y, n2;
    }, i.prototype.fromArray = function(n2) {
      this.x = n2[0], this.y = n2[1];
    }, i.set = function(n2, e2, o) {
      n2.x = e2, n2.y = o;
    }, i.copy = function(n2, e2) {
      n2.x = e2.x, n2.y = e2.y;
    }, i.len = function(n2) {
      return Math.sqrt(n2.x * n2.x + n2.y * n2.y);
    }, i.lenSquare = function(n2) {
      return n2.x * n2.x + n2.y * n2.y;
    }, i.dot = function(n2, e2) {
      return n2.x * e2.x + n2.y * e2.y;
    }, i.add = function(n2, e2, o) {
      n2.x = e2.x + o.x, n2.y = e2.y + o.y;
    }, i.sub = function(n2, e2, o) {
      n2.x = e2.x - o.x, n2.y = e2.y - o.y;
    }, i.scale = function(n2, e2, o) {
      n2.x = e2.x * o, n2.y = e2.y * o;
    }, i.scaleAndAdd = function(n2, e2, o, l4) {
      n2.x = e2.x + o.x * l4, n2.y = e2.y + o.y * l4;
    }, i.lerp = function(n2, e2, o, l4) {
      var c4 = 1 - l4;
      n2.x = c4 * e2.x + l4 * o.x, n2.y = c4 * e2.y + l4 * o.y;
    }, i;
  }(), Ji = Jot, qG = Math.min, YG = Math.max, _I = new Ji(), xI = new Ji(), wI = new Ji(), SI = new Ji(), KF = new Ji(), JF = new Ji(), Qot = function() {
    function i(n2, e2, o, l4) {
      o < 0 && (n2 = n2 + o, o = -o), l4 < 0 && (e2 = e2 + l4, l4 = -l4), this.x = n2, this.y = e2, this.width = o, this.height = l4;
    }
    return i.prototype.union = function(n2) {
      var e2 = qG(n2.x, this.x), o = qG(n2.y, this.y);
      isFinite(this.x) && isFinite(this.width) ? this.width = YG(n2.x + n2.width, this.x + this.width) - e2 : this.width = n2.width, isFinite(this.y) && isFinite(this.height) ? this.height = YG(n2.y + n2.height, this.y + this.height) - o : this.height = n2.height, this.x = e2, this.y = o;
    }, i.prototype.applyTransform = function(n2) {
      i.applyTransform(this, this, n2);
    }, i.prototype.calculateTransform = function(n2) {
      var e2 = this, o = n2.width / e2.width, l4 = n2.height / e2.height, c4 = Ny();
      return Y_(c4, c4, [-e2.x, -e2.y]), Nse(c4, c4, [o, l4]), Y_(c4, c4, [n2.x, n2.y]), c4;
    }, i.prototype.intersect = function(n2, e2) {
      if (!n2)
        return false;
      n2 instanceof i || (n2 = i.create(n2));
      var o = this, l4 = o.x, c4 = o.x + o.width, h = o.y, p4 = o.y + o.height, g4 = n2.x, y4 = n2.x + n2.width, _ = n2.y, w4 = n2.y + n2.height, C = !(c4 < g4 || y4 < l4 || p4 < _ || w4 < h);
      if (e2) {
        var E = 1 / 0, T = 0, O = Math.abs(c4 - g4), N = Math.abs(y4 - l4), V = Math.abs(p4 - _), H = Math.abs(w4 - h), X = Math.min(O, N), q2 = Math.min(V, H);
        c4 < g4 || y4 < l4 ? X > T && (T = X, O < N ? Ji.set(JF, -O, 0) : Ji.set(JF, N, 0)) : X < E && (E = X, O < N ? Ji.set(KF, O, 0) : Ji.set(KF, -N, 0)), p4 < _ || w4 < h ? q2 > T && (T = q2, V < H ? Ji.set(JF, 0, -V) : Ji.set(JF, 0, H)) : X < E && (E = X, V < H ? Ji.set(KF, 0, V) : Ji.set(KF, 0, -H));
      }
      return e2 && Ji.copy(e2, C ? KF : JF), C;
    }, i.prototype.contain = function(n2, e2) {
      var o = this;
      return n2 >= o.x && n2 <= o.x + o.width && e2 >= o.y && e2 <= o.y + o.height;
    }, i.prototype.clone = function() {
      return new i(this.x, this.y, this.width, this.height);
    }, i.prototype.copy = function(n2) {
      i.copy(this, n2);
    }, i.prototype.plain = function() {
      return { x: this.x, y: this.y, width: this.width, height: this.height };
    }, i.prototype.isFinite = function() {
      return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
    }, i.prototype.isZero = function() {
      return this.width === 0 || this.height === 0;
    }, i.create = function(n2) {
      return new i(n2.x, n2.y, n2.width, n2.height);
    }, i.copy = function(n2, e2) {
      n2.x = e2.x, n2.y = e2.y, n2.width = e2.width, n2.height = e2.height;
    }, i.applyTransform = function(n2, e2, o) {
      if (!o) {
        n2 !== e2 && i.copy(n2, e2);
        return;
      }
      if (o[1] < 1e-5 && o[1] > -1e-5 && o[2] < 1e-5 && o[2] > -1e-5) {
        var l4 = o[0], c4 = o[3], h = o[4], p4 = o[5];
        n2.x = e2.x * l4 + h, n2.y = e2.y * c4 + p4, n2.width = e2.width * l4, n2.height = e2.height * c4, n2.width < 0 && (n2.x += n2.width, n2.width = -n2.width), n2.height < 0 && (n2.y += n2.height, n2.height = -n2.height);
        return;
      }
      _I.x = wI.x = e2.x, _I.y = SI.y = e2.y, xI.x = SI.x = e2.x + e2.width, xI.y = wI.y = e2.y + e2.height, _I.transform(o), SI.transform(o), xI.transform(o), wI.transform(o), n2.x = qG(_I.x, xI.x, wI.x, SI.x), n2.y = qG(_I.y, xI.y, wI.y, SI.y);
      var g4 = YG(_I.x, xI.x, wI.x, SI.x), y4 = YG(_I.y, xI.y, wI.y, SI.y);
      n2.width = g4 - n2.x, n2.height = y4 - n2.y;
    }, i;
  }(), mo = Qot, rwe = {};
  function rm(i, n2) {
    n2 = n2 || XC;
    var e2 = rwe[n2];
    e2 || (e2 = rwe[n2] = new F8(500));
    var o = e2.get(i);
    return o == null && (o = y2.measureText(i, n2).width, e2.put(i, o)), o;
  }
  function awe(i, n2, e2, o) {
    var l4 = rm(i, n2), c4 = _$(n2), h = IN(0, l4, e2), p4 = d3(0, c4, o), g4 = new mo(h, p4, l4, c4);
    return g4;
  }
  function N8(i, n2, e2, o) {
    var l4 = ((i || "") + "").split(`
`), c4 = l4.length;
    if (c4 === 1)
      return awe(l4[0], n2, e2, o);
    for (var h = new mo(0, 0, 0, 0), p4 = 0; p4 < l4.length; p4++) {
      var g4 = awe(l4[p4], n2, e2, o);
      p4 === 0 ? h.copy(g4) : h.union(g4);
    }
    return h;
  }
  function IN(i, n2, e2) {
    return e2 === "right" ? i -= n2 : e2 === "center" && (i -= n2 / 2), i;
  }
  function d3(i, n2, e2) {
    return e2 === "middle" ? i -= n2 / 2 : e2 === "bottom" && (i -= n2), i;
  }
  function _$(i) {
    return rm("\u56FD", i);
  }
  function ib(i, n2) {
    return typeof i == "string" ? i.lastIndexOf("%") >= 0 ? parseFloat(i) / 100 * n2 : parseFloat(i) : i;
  }
  function SH(i, n2, e2) {
    var o = n2.position || "inside", l4 = n2.distance != null ? n2.distance : 5, c4 = e2.height, h = e2.width, p4 = c4 / 2, g4 = e2.x, y4 = e2.y, _ = "left", w4 = "top";
    if (o instanceof Array)
      g4 += ib(o[0], e2.width), y4 += ib(o[1], e2.height), _ = null, w4 = null;
    else
      switch (o) {
        case "left":
          g4 -= l4, y4 += p4, _ = "right", w4 = "middle";
          break;
        case "right":
          g4 += l4 + h, y4 += p4, w4 = "middle";
          break;
        case "top":
          g4 += h / 2, y4 -= l4, _ = "center", w4 = "bottom";
          break;
        case "bottom":
          g4 += h / 2, y4 += c4 + l4, _ = "center";
          break;
        case "inside":
          g4 += h / 2, y4 += p4, _ = "center", w4 = "middle";
          break;
        case "insideLeft":
          g4 += l4, y4 += p4, w4 = "middle";
          break;
        case "insideRight":
          g4 += h - l4, y4 += p4, _ = "right", w4 = "middle";
          break;
        case "insideTop":
          g4 += h / 2, y4 += l4, _ = "center";
          break;
        case "insideBottom":
          g4 += h / 2, y4 += c4 - l4, _ = "center", w4 = "bottom";
          break;
        case "insideTopLeft":
          g4 += l4, y4 += l4;
          break;
        case "insideTopRight":
          g4 += h - l4, y4 += l4, _ = "right";
          break;
        case "insideBottomLeft":
          g4 += l4, y4 += c4 - l4, w4 = "bottom";
          break;
        case "insideBottomRight":
          g4 += h - l4, y4 += c4 - l4, _ = "right", w4 = "bottom";
          break;
      }
    return i = i || {}, i.x = g4, i.y = y4, i.align = _, i.verticalAlign = w4, i;
  }
  var ire = "__zr_normal__", ore = Z_.concat(["ignore"]), est = q_(Z_, function(i, n2) {
    return i[n2] = true, i;
  }, { ignore: false }), qP = {}, tst = new mo(0, 0, 0, 0), Vse = function() {
    function i(n2) {
      this.id = mIe(), this.animators = [], this.currentStates = [], this.states = {}, this._init(n2);
    }
    return i.prototype._init = function(n2) {
      this.attr(n2);
    }, i.prototype.drift = function(n2, e2, o) {
      switch (this.draggable) {
        case "horizontal":
          e2 = 0;
          break;
        case "vertical":
          n2 = 0;
          break;
      }
      var l4 = this.transform;
      l4 || (l4 = this.transform = [1, 0, 0, 1, 0, 0]), l4[4] += n2, l4[5] += e2, this.decomposeTransform(), this.markRedraw();
    }, i.prototype.beforeUpdate = function() {
    }, i.prototype.afterUpdate = function() {
    }, i.prototype.update = function() {
      this.updateTransform(), this.__dirty && this.updateInnerText();
    }, i.prototype.updateInnerText = function(n2) {
      var e2 = this._textContent;
      if (e2 && (!e2.ignore || n2)) {
        this.textConfig || (this.textConfig = {});
        var o = this.textConfig, l4 = o.local, c4 = e2.innerTransformable, h = void 0, p4 = void 0, g4 = false;
        c4.parent = l4 ? this : null;
        var y4 = false;
        if (c4.copyTransform(e2), o.position != null) {
          var _ = tst;
          o.layoutRect ? _.copy(o.layoutRect) : _.copy(this.getBoundingRect()), l4 || _.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(qP, o, _) : SH(qP, o, _), c4.x = qP.x, c4.y = qP.y, h = qP.align, p4 = qP.verticalAlign;
          var w4 = o.origin;
          if (w4 && o.rotation != null) {
            var C = void 0, E = void 0;
            w4 === "center" ? (C = _.width * 0.5, E = _.height * 0.5) : (C = ib(w4[0], _.width), E = ib(w4[1], _.height)), y4 = true, c4.originX = -c4.x + C + (l4 ? 0 : _.x), c4.originY = -c4.y + E + (l4 ? 0 : _.y);
          }
        }
        o.rotation != null && (c4.rotation = o.rotation);
        var T = o.offset;
        T && (c4.x += T[0], c4.y += T[1], y4 || (c4.originX = -T[0], c4.originY = -T[1]));
        var O = o.inside == null ? typeof o.position == "string" && o.position.indexOf("inside") >= 0 : o.inside, N = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), V = void 0, H = void 0, X = void 0;
        O && this.canBeInsideText() ? (V = o.insideFill, H = o.insideStroke, (V == null || V === "auto") && (V = this.getInsideTextFill()), (H == null || H === "auto") && (H = this.getInsideTextStroke(V), X = true)) : (V = o.outsideFill, H = o.outsideStroke, (V == null || V === "auto") && (V = this.getOutsideFill()), (H == null || H === "auto") && (H = this.getOutsideStroke(V), X = true)), V = V || "#000", (V !== N.fill || H !== N.stroke || X !== N.autoStroke || h !== N.align || p4 !== N.verticalAlign) && (g4 = true, N.fill = V, N.stroke = H, N.autoStroke = X, N.align = h, N.verticalAlign = p4, e2.setDefaultTextStyle(N)), e2.__dirty |= em, g4 && e2.dirtyStyle(true);
      }
    }, i.prototype.canBeInsideText = function() {
      return true;
    }, i.prototype.getInsideTextFill = function() {
      return "#fff";
    }, i.prototype.getInsideTextStroke = function(n2) {
      return "#000";
    }, i.prototype.getOutsideFill = function() {
      return this.__zr && this.__zr.isDarkMode() ? Hie : Wie;
    }, i.prototype.getOutsideStroke = function(n2) {
      var e2 = this.__zr && this.__zr.getBackgroundColor(), o = typeof e2 == "string" && nm(e2);
      o || (o = [255, 255, 255, 1]);
      for (var l4 = o[3], c4 = this.__zr.isDarkMode(), h = 0; h < 3; h++)
        o[h] = o[h] * l4 + (c4 ? 0 : 255) * (1 - l4);
      return o[3] = 1, d2(o, "rgba");
    }, i.prototype.traverse = function(n2, e2) {
    }, i.prototype.attrKV = function(n2, e2) {
      n2 === "textConfig" ? this.setTextConfig(e2) : n2 === "textContent" ? this.setTextContent(e2) : n2 === "clipPath" ? this.setClipPath(e2) : n2 === "extra" ? (this.extra = this.extra || {}, rr(this.extra, e2)) : this[n2] = e2;
    }, i.prototype.hide = function() {
      this.ignore = true, this.markRedraw();
    }, i.prototype.show = function() {
      this.ignore = false, this.markRedraw();
    }, i.prototype.attr = function(n2, e2) {
      if (typeof n2 == "string")
        this.attrKV(n2, e2);
      else if (mi(n2))
        for (var o = n2, l4 = ts(o), c4 = 0; c4 < l4.length; c4++) {
          var h = l4[c4];
          this.attrKV(h, n2[h]);
        }
      return this.markRedraw(), this;
    }, i.prototype.saveCurrentToNormalState = function(n2) {
      this._innerSaveToNormal(n2);
      for (var e2 = this._normalState, o = 0; o < this.animators.length; o++) {
        var l4 = this.animators[o], c4 = l4.__fromStateTransition;
        if (!(l4.getLoop() || c4 && c4 !== ire)) {
          var h = l4.targetName, p4 = h ? e2[h] : e2;
          l4.saveTo(p4);
        }
      }
    }, i.prototype._innerSaveToNormal = function(n2) {
      var e2 = this._normalState;
      e2 || (e2 = this._normalState = {}), n2.textConfig && !e2.textConfig && (e2.textConfig = this.textConfig), this._savePrimaryToNormal(n2, e2, ore);
    }, i.prototype._savePrimaryToNormal = function(n2, e2, o) {
      for (var l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        n2[c4] != null && !(c4 in e2) && (e2[c4] = this[c4]);
      }
    }, i.prototype.hasState = function() {
      return this.currentStates.length > 0;
    }, i.prototype.getState = function(n2) {
      return this.states[n2];
    }, i.prototype.ensureState = function(n2) {
      var e2 = this.states;
      return e2[n2] || (e2[n2] = {}), e2[n2];
    }, i.prototype.clearStates = function(n2) {
      this.useState(ire, false, n2);
    }, i.prototype.useState = function(n2, e2, o, l4) {
      var c4 = n2 === ire, h = this.hasState();
      if (!(!h && c4)) {
        var p4 = this.currentStates, g4 = this.stateTransition;
        if (!(go(p4, n2) >= 0 && (e2 || p4.length === 1))) {
          var y4;
          if (this.stateProxy && !c4 && (y4 = this.stateProxy(n2)), y4 || (y4 = this.states && this.states[n2]), !y4 && !c4) {
            Tse("State " + n2 + " not exists.");
            return;
          }
          c4 || this.saveCurrentToNormalState(y4);
          var _ = !!(y4 && y4.hoverLayer || l4);
          _ && this._toggleHoverLayerFlag(true), this._applyStateObj(n2, y4, this._normalState, e2, !o && !this.__inHover && g4 && g4.duration > 0, g4);
          var w4 = this._textContent, C = this._textGuide;
          return w4 && w4.useState(n2, e2, o, _), C && C.useState(n2, e2, o, _), c4 ? (this.currentStates = [], this._normalState = {}) : e2 ? this.currentStates.push(n2) : this.currentStates = [n2], this._updateAnimationTargets(), this.markRedraw(), !_ && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~em), y4;
        }
      }
    }, i.prototype.useStates = function(n2, e2, o) {
      if (!n2.length)
        this.clearStates();
      else {
        var l4 = [], c4 = this.currentStates, h = n2.length, p4 = h === c4.length;
        if (p4) {
          for (var g4 = 0; g4 < h; g4++)
            if (n2[g4] !== c4[g4]) {
              p4 = false;
              break;
            }
        }
        if (p4)
          return;
        for (var g4 = 0; g4 < h; g4++) {
          var y4 = n2[g4], _ = void 0;
          this.stateProxy && (_ = this.stateProxy(y4, n2)), _ || (_ = this.states[y4]), _ && l4.push(_);
        }
        var w4 = l4[h - 1], C = !!(w4 && w4.hoverLayer || o);
        C && this._toggleHoverLayerFlag(true);
        var E = this._mergeStates(l4), T = this.stateTransition;
        this.saveCurrentToNormalState(E), this._applyStateObj(n2.join(","), E, this._normalState, false, !e2 && !this.__inHover && T && T.duration > 0, T);
        var O = this._textContent, N = this._textGuide;
        O && O.useStates(n2, e2, C), N && N.useStates(n2, e2, C), this._updateAnimationTargets(), this.currentStates = n2.slice(), this.markRedraw(), !C && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~em);
      }
    }, i.prototype._updateAnimationTargets = function() {
      for (var n2 = 0; n2 < this.animators.length; n2++) {
        var e2 = this.animators[n2];
        e2.targetName && e2.changeTarget(this[e2.targetName]);
      }
    }, i.prototype.removeState = function(n2) {
      var e2 = go(this.currentStates, n2);
      if (e2 >= 0) {
        var o = this.currentStates.slice();
        o.splice(e2, 1), this.useStates(o);
      }
    }, i.prototype.replaceState = function(n2, e2, o) {
      var l4 = this.currentStates.slice(), c4 = go(l4, n2), h = go(l4, e2) >= 0;
      c4 >= 0 ? h ? l4.splice(c4, 1) : l4[c4] = e2 : o && !h && l4.push(e2), this.useStates(l4);
    }, i.prototype.toggleState = function(n2, e2) {
      e2 ? this.useState(n2, true) : this.removeState(n2);
    }, i.prototype._mergeStates = function(n2) {
      for (var e2 = {}, o, l4 = 0; l4 < n2.length; l4++) {
        var c4 = n2[l4];
        rr(e2, c4), c4.textConfig && (o = o || {}, rr(o, c4.textConfig));
      }
      return o && (e2.textConfig = o), e2;
    }, i.prototype._applyStateObj = function(n2, e2, o, l4, c4, h) {
      var p4 = !(e2 && l4);
      e2 && e2.textConfig ? (this.textConfig = rr({}, l4 ? this.textConfig : o.textConfig), rr(this.textConfig, e2.textConfig)) : p4 && o.textConfig && (this.textConfig = o.textConfig);
      for (var g4 = {}, y4 = false, _ = 0; _ < ore.length; _++) {
        var w4 = ore[_], C = c4 && est[w4];
        e2 && e2[w4] != null ? C ? (y4 = true, g4[w4] = e2[w4]) : this[w4] = e2[w4] : p4 && o[w4] != null && (C ? (y4 = true, g4[w4] = o[w4]) : this[w4] = o[w4]);
      }
      if (!c4)
        for (var _ = 0; _ < this.animators.length; _++) {
          var E = this.animators[_], T = E.targetName;
          E.getLoop() || E.__changeFinalValue(T ? (e2 || o)[T] : e2 || o);
        }
      y4 && this._transitionState(n2, g4, h);
    }, i.prototype._attachComponent = function(n2) {
      if (!(n2.__zr && !n2.__hostTarget) && n2 !== this) {
        var e2 = this.__zr;
        e2 && n2.addSelfToZr(e2), n2.__zr = e2, n2.__hostTarget = this;
      }
    }, i.prototype._detachComponent = function(n2) {
      n2.__zr && n2.removeSelfFromZr(n2.__zr), n2.__zr = null, n2.__hostTarget = null;
    }, i.prototype.getClipPath = function() {
      return this._clipPath;
    }, i.prototype.setClipPath = function(n2) {
      this._clipPath && this._clipPath !== n2 && this.removeClipPath(), this._attachComponent(n2), this._clipPath = n2, this.markRedraw();
    }, i.prototype.removeClipPath = function() {
      var n2 = this._clipPath;
      n2 && (this._detachComponent(n2), this._clipPath = null, this.markRedraw());
    }, i.prototype.getTextContent = function() {
      return this._textContent;
    }, i.prototype.setTextContent = function(n2) {
      var e2 = this._textContent;
      e2 !== n2 && (e2 && e2 !== n2 && this.removeTextContent(), n2.innerTransformable = new u2(), this._attachComponent(n2), this._textContent = n2, this.markRedraw());
    }, i.prototype.setTextConfig = function(n2) {
      this.textConfig || (this.textConfig = {}), rr(this.textConfig, n2), this.markRedraw();
    }, i.prototype.removeTextConfig = function() {
      this.textConfig = null, this.markRedraw();
    }, i.prototype.removeTextContent = function() {
      var n2 = this._textContent;
      n2 && (n2.innerTransformable = null, this._detachComponent(n2), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
    }, i.prototype.getTextGuideLine = function() {
      return this._textGuide;
    }, i.prototype.setTextGuideLine = function(n2) {
      this._textGuide && this._textGuide !== n2 && this.removeTextGuideLine(), this._attachComponent(n2), this._textGuide = n2, this.markRedraw();
    }, i.prototype.removeTextGuideLine = function() {
      var n2 = this._textGuide;
      n2 && (this._detachComponent(n2), this._textGuide = null, this.markRedraw());
    }, i.prototype.markRedraw = function() {
      this.__dirty |= em;
      var n2 = this.__zr;
      n2 && (this.__inHover ? n2.refreshHover() : n2.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
    }, i.prototype.dirty = function() {
      this.markRedraw();
    }, i.prototype._toggleHoverLayerFlag = function(n2) {
      this.__inHover = n2;
      var e2 = this._textContent, o = this._textGuide;
      e2 && (e2.__inHover = n2), o && (o.__inHover = n2);
    }, i.prototype.addSelfToZr = function(n2) {
      if (this.__zr !== n2) {
        this.__zr = n2;
        var e2 = this.animators;
        if (e2)
          for (var o = 0; o < e2.length; o++)
            n2.animation.addAnimator(e2[o]);
        this._clipPath && this._clipPath.addSelfToZr(n2), this._textContent && this._textContent.addSelfToZr(n2), this._textGuide && this._textGuide.addSelfToZr(n2);
      }
    }, i.prototype.removeSelfFromZr = function(n2) {
      if (!!this.__zr) {
        this.__zr = null;
        var e2 = this.animators;
        if (e2)
          for (var o = 0; o < e2.length; o++)
            n2.animation.removeAnimator(e2[o]);
        this._clipPath && this._clipPath.removeSelfFromZr(n2), this._textContent && this._textContent.removeSelfFromZr(n2), this._textGuide && this._textGuide.removeSelfFromZr(n2);
      }
    }, i.prototype.animate = function(n2, e2, o) {
      var l4 = n2 ? this[n2] : this, c4 = new Rse(l4, e2, o);
      return n2 && (c4.targetName = n2), this.addAnimator(c4, n2), c4;
    }, i.prototype.addAnimator = function(n2, e2) {
      var o = this.__zr, l4 = this;
      n2.during(function() {
        l4.updateDuringAnimation(e2);
      }).done(function() {
        var c4 = l4.animators, h = go(c4, n2);
        h >= 0 && c4.splice(h, 1);
      }), this.animators.push(n2), o && o.animation.addAnimator(n2), o && o.wakeUp();
    }, i.prototype.updateDuringAnimation = function(n2) {
      this.markRedraw();
    }, i.prototype.stopAnimation = function(n2, e2) {
      for (var o = this.animators, l4 = o.length, c4 = [], h = 0; h < l4; h++) {
        var p4 = o[h];
        !n2 || n2 === p4.scope ? p4.stop(e2) : c4.push(p4);
      }
      return this.animators = c4, this;
    }, i.prototype.animateTo = function(n2, e2, o) {
      sre(this, n2, e2, o);
    }, i.prototype.animateFrom = function(n2, e2, o) {
      sre(this, n2, e2, o, true);
    }, i.prototype._transitionState = function(n2, e2, o, l4) {
      for (var c4 = sre(this, e2, o, l4), h = 0; h < c4.length; h++)
        c4[h].__fromStateTransition = n2;
    }, i.prototype.getBoundingRect = function() {
      return null;
    }, i.prototype.getPaintRect = function() {
      return null;
    }, i.initDefaultProps = function() {
      var n2 = i.prototype;
      n2.type = "element", n2.name = "", n2.ignore = n2.silent = n2.isGroup = n2.draggable = n2.dragging = n2.ignoreClip = n2.__inHover = false, n2.__dirty = em;
      function e2(o, l4, c4, h) {
        Object.defineProperty(n2, o, { get: function() {
          if (!this[l4]) {
            var g4 = this[l4] = [];
            p4(this, g4);
          }
          return this[l4];
        }, set: function(g4) {
          this[c4] = g4[0], this[h] = g4[1], this[l4] = g4, p4(this, g4);
        } });
        function p4(g4, y4) {
          Object.defineProperty(y4, 0, { get: function() {
            return g4[c4];
          }, set: function(_) {
            g4[c4] = _;
          } }), Object.defineProperty(y4, 1, { get: function() {
            return g4[h];
          }, set: function(_) {
            g4[h] = _;
          } });
        }
      }
      Object.defineProperty && (e2("position", "_legacyPos", "x", "y"), e2("scale", "_legacyScale", "scaleX", "scaleY"), e2("origin", "_legacyOrigin", "originX", "originY"));
    }(), i;
  }();
  Kf(Vse, zy);
  Kf(Vse, u2);
  function sre(i, n2, e2, o, l4) {
    e2 = e2 || {};
    var c4 = [];
    HIe(i, "", i, n2, e2, o, c4, l4);
    var h = c4.length, p4 = false, g4 = e2.done, y4 = e2.aborted, _ = function() {
      p4 = true, h--, h <= 0 && (p4 ? g4 && g4() : y4 && y4());
    }, w4 = function() {
      h--, h <= 0 && (p4 ? g4 && g4() : y4 && y4());
    };
    h || g4 && g4(), c4.length > 0 && e2.during && c4[0].during(function(T, O) {
      e2.during(O);
    });
    for (var C = 0; C < c4.length; C++) {
      var E = c4[C];
      _ && E.done(_), w4 && E.aborted(w4), e2.force && E.duration(e2.duration), E.start(e2.easing);
    }
    return c4;
  }
  function lre(i, n2, e2) {
    for (var o = 0; o < e2; o++)
      i[o] = n2[o];
  }
  function nst(i) {
    return gv(i[0]);
  }
  function rst(i, n2, e2) {
    if (gv(n2[e2]))
      if (gv(i[e2]) || (i[e2] = []), am(n2[e2])) {
        var o = n2[e2].length;
        i[e2].length !== o && (i[e2] = new n2[e2].constructor(o), lre(i[e2], n2[e2], o));
      } else {
        var l4 = n2[e2], c4 = i[e2], h = l4.length;
        if (nst(l4))
          for (var p4 = l4[0].length, g4 = 0; g4 < h; g4++)
            c4[g4] ? lre(c4[g4], l4[g4], p4) : c4[g4] = Array.prototype.slice.call(l4[g4]);
        else
          lre(c4, l4, h);
        c4.length = l4.length;
      }
    else
      i[e2] = n2[e2];
  }
  function ast(i, n2) {
    return i === n2 || gv(i) && gv(n2) && ist(i, n2);
  }
  function ist(i, n2) {
    var e2 = i.length;
    if (e2 !== n2.length)
      return false;
    for (var o = 0; o < e2; o++)
      if (i[o] !== n2[o])
        return false;
    return true;
  }
  function HIe(i, n2, e2, o, l4, c4, h, p4) {
    for (var g4 = ts(o), y4 = l4.duration, _ = l4.delay, w4 = l4.additive, C = l4.setToFinal, E = !mi(c4), T = i.animators, O = [], N = 0; N < g4.length; N++) {
      var V = g4[N], H = o[V];
      if (H != null && e2[V] != null && (E || c4[V]))
        if (mi(H) && !gv(H) && !g$(H)) {
          if (n2) {
            p4 || (e2[V] = H, i.updateDuringAnimation(n2));
            continue;
          }
          HIe(i, V, e2[V], H, l4, c4 && c4[V], h, p4);
        } else
          O.push(V);
      else
        p4 || (e2[V] = H, i.updateDuringAnimation(n2), O.push(V));
    }
    var X = O.length;
    if (!w4 && X)
      for (var q2 = 0; q2 < T.length; q2++) {
        var de = T[q2];
        if (de.targetName === n2) {
          var le = de.stopTracks(O);
          if (le) {
            var me = go(T, de);
            T.splice(me, 1);
          }
        }
      }
    if (l4.force || (O = Yl(O, function(Pe) {
      return !ast(o[Pe], e2[Pe]);
    }), X = O.length), X > 0 || l4.force && !h.length) {
      var ye = void 0, be = void 0, we = void 0;
      if (p4) {
        be = {}, C && (ye = {});
        for (var q2 = 0; q2 < X; q2++) {
          var V = O[q2];
          be[V] = e2[V], C ? ye[V] = o[V] : e2[V] = o[V];
        }
      } else if (C) {
        we = {};
        for (var q2 = 0; q2 < X; q2++) {
          var V = O[q2];
          we[V] = jN(e2[V]), rst(e2, o, V);
        }
      }
      var de = new Rse(e2, false, false, w4 ? Yl(T, function(ze) {
        return ze.targetName === n2;
      }) : null);
      de.targetName = n2, l4.scope && (de.scope = l4.scope), C && ye && de.whenWithKeys(0, ye, O), we && de.whenWithKeys(0, we, O), de.whenWithKeys(y4 == null ? 500 : y4, p4 ? be : o, O).delay(_ || 0), i.addAnimator(de, n2), h.push(de);
    }
  }
  var $Ie = Vse, UIe = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this) || this;
      return o.isGroup = true, o._children = [], o.attr(e2), o;
    }
    return n2.prototype.childrenRef = function() {
      return this._children;
    }, n2.prototype.children = function() {
      return this._children.slice();
    }, n2.prototype.childAt = function(e2) {
      return this._children[e2];
    }, n2.prototype.childOfName = function(e2) {
      for (var o = this._children, l4 = 0; l4 < o.length; l4++)
        if (o[l4].name === e2)
          return o[l4];
    }, n2.prototype.childCount = function() {
      return this._children.length;
    }, n2.prototype.add = function(e2) {
      return e2 && e2 !== this && e2.parent !== this && (this._children.push(e2), this._doAdd(e2)), this;
    }, n2.prototype.addBefore = function(e2, o) {
      if (e2 && e2 !== this && e2.parent !== this && o && o.parent === this) {
        var l4 = this._children, c4 = l4.indexOf(o);
        c4 >= 0 && (l4.splice(c4, 0, e2), this._doAdd(e2));
      }
      return this;
    }, n2.prototype.replace = function(e2, o) {
      var l4 = go(this._children, e2);
      return l4 >= 0 && this.replaceAt(o, l4), this;
    }, n2.prototype.replaceAt = function(e2, o) {
      var l4 = this._children, c4 = l4[o];
      if (e2 && e2 !== this && e2.parent !== this && e2 !== c4) {
        l4[o] = e2, c4.parent = null;
        var h = this.__zr;
        h && c4.removeSelfFromZr(h), this._doAdd(e2);
      }
      return this;
    }, n2.prototype._doAdd = function(e2) {
      e2.parent && e2.parent.remove(e2), e2.parent = this;
      var o = this.__zr;
      o && o !== e2.__zr && e2.addSelfToZr(o), o && o.refresh();
    }, n2.prototype.remove = function(e2) {
      var o = this.__zr, l4 = this._children, c4 = go(l4, e2);
      return c4 < 0 ? this : (l4.splice(c4, 1), e2.parent = null, o && e2.removeSelfFromZr(o), o && o.refresh(), this);
    }, n2.prototype.removeAll = function() {
      for (var e2 = this._children, o = this.__zr, l4 = 0; l4 < e2.length; l4++) {
        var c4 = e2[l4];
        o && c4.removeSelfFromZr(o), c4.parent = null;
      }
      return e2.length = 0, this;
    }, n2.prototype.eachChild = function(e2, o) {
      for (var l4 = this._children, c4 = 0; c4 < l4.length; c4++) {
        var h = l4[c4];
        e2.call(o, h, c4);
      }
      return this;
    }, n2.prototype.traverse = function(e2, o) {
      for (var l4 = 0; l4 < this._children.length; l4++) {
        var c4 = this._children[l4], h = e2.call(o, c4);
        c4.isGroup && !h && c4.traverse(e2, o);
      }
      return this;
    }, n2.prototype.addSelfToZr = function(e2) {
      i.prototype.addSelfToZr.call(this, e2);
      for (var o = 0; o < this._children.length; o++) {
        var l4 = this._children[o];
        l4.addSelfToZr(e2);
      }
    }, n2.prototype.removeSelfFromZr = function(e2) {
      i.prototype.removeSelfFromZr.call(this, e2);
      for (var o = 0; o < this._children.length; o++) {
        var l4 = this._children[o];
        l4.removeSelfFromZr(e2);
      }
    }, n2.prototype.getBoundingRect = function(e2) {
      for (var o = new mo(0, 0, 0, 0), l4 = e2 || this._children, c4 = [], h = null, p4 = 0; p4 < l4.length; p4++) {
        var g4 = l4[p4];
        if (!(g4.ignore || g4.invisible)) {
          var y4 = g4.getBoundingRect(), _ = g4.getLocalTransform(c4);
          _ ? (mo.applyTransform(o, y4, _), h = h || o.clone(), h.union(o)) : (h = h || y4.clone(), h.union(y4));
        }
      }
      return h || o;
    }, n2;
  }($Ie);
  UIe.prototype.type = "group";
  var Ti = UIe;
  /*!
  * ZRender, a high performance 2d drawing library.
  *
  * Copyright (c) 2013, Baidu Inc.
  * All rights reserved.
  *
  * LICENSE
  * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
  */
  var tH = {}, qIe = {};
  function ost(i) {
    delete qIe[i];
  }
  function sst(i) {
    if (!i)
      return false;
    if (typeof i == "string")
      return _H(i, 1) < Gie;
    if (i.colorStops) {
      for (var n2 = i.colorStops, e2 = 0, o = n2.length, l4 = 0; l4 < o; l4++)
        e2 += _H(n2[l4].color, 1);
      return e2 /= o, e2 < Gie;
    }
    return false;
  }
  var lst = function() {
    function i(n2, e2, o) {
      var l4 = this;
      this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, o = o || {}, this.dom = e2, this.id = n2;
      var c4 = new dot(), h = o.renderer || "canvas";
      tH[h] || (h = ts(tH)[0]), o.useDirtyRect = o.useDirtyRect == null ? false : o.useDirtyRect;
      var p4 = new tH[h](e2, c4, o, n2), g4 = o.ssr || p4.ssrOnly;
      this.storage = c4, this.painter = p4;
      var y4 = !ol.node && !ol.worker && !g4 ? new Yot(p4.getViewportRoot(), p4.root) : null;
      this.handler = new lot(c4, p4, y4, p4.root), this.animation = new Bot({ stage: { update: g4 ? null : function() {
        return l4._flush(true);
      } } }), g4 || this.animation.start();
    }
    return i.prototype.add = function(n2) {
      !n2 || (this.storage.addRoot(n2), n2.addSelfToZr(this), this.refresh());
    }, i.prototype.remove = function(n2) {
      !n2 || (this.storage.delRoot(n2), n2.removeSelfFromZr(this), this.refresh());
    }, i.prototype.configLayer = function(n2, e2) {
      this.painter.configLayer && this.painter.configLayer(n2, e2), this.refresh();
    }, i.prototype.setBackgroundColor = function(n2) {
      this.painter.setBackgroundColor && this.painter.setBackgroundColor(n2), this.refresh(), this._backgroundColor = n2, this._darkMode = sst(n2);
    }, i.prototype.getBackgroundColor = function() {
      return this._backgroundColor;
    }, i.prototype.setDarkMode = function(n2) {
      this._darkMode = n2;
    }, i.prototype.isDarkMode = function() {
      return this._darkMode;
    }, i.prototype.refreshImmediately = function(n2) {
      n2 || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
    }, i.prototype.refresh = function() {
      this._needsRefresh = true, this.animation.start();
    }, i.prototype.flush = function() {
      this._flush(false);
    }, i.prototype._flush = function(n2) {
      var e2, o = y3();
      this._needsRefresh && (e2 = true, this.refreshImmediately(n2)), this._needsRefreshHover && (e2 = true, this.refreshHoverImmediately());
      var l4 = y3();
      e2 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: l4 - o })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
    }, i.prototype.setSleepAfterStill = function(n2) {
      this._sleepAfterStill = n2;
    }, i.prototype.wakeUp = function() {
      this.animation.start(), this._stillFrameAccum = 0;
    }, i.prototype.refreshHover = function() {
      this._needsRefreshHover = true;
    }, i.prototype.refreshHoverImmediately = function() {
      this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
    }, i.prototype.resize = function(n2) {
      n2 = n2 || {}, this.painter.resize(n2.width, n2.height), this.handler.resize();
    }, i.prototype.clearAnimation = function() {
      this.animation.clear();
    }, i.prototype.getWidth = function() {
      return this.painter.getWidth();
    }, i.prototype.getHeight = function() {
      return this.painter.getHeight();
    }, i.prototype.setCursorStyle = function(n2) {
      this.handler.setCursorStyle(n2);
    }, i.prototype.findHover = function(n2, e2) {
      return this.handler.findHover(n2, e2);
    }, i.prototype.on = function(n2, e2, o) {
      return this.handler.on(n2, e2, o), this;
    }, i.prototype.off = function(n2, e2) {
      this.handler.off(n2, e2);
    }, i.prototype.trigger = function(n2, e2) {
      this.handler.trigger(n2, e2);
    }, i.prototype.clear = function() {
      for (var n2 = this.storage.getRoots(), e2 = 0; e2 < n2.length; e2++)
        n2[e2] instanceof Ti && n2[e2].removeSelfFromZr(this);
      this.storage.delAllRoots(), this.painter.clear();
    }, i.prototype.dispose = function() {
      this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, ost(this.id);
    }, i;
  }();
  function iwe(i, n2) {
    var e2 = new lst(mIe(), i, n2);
    return qIe[e2.id] = e2, e2;
  }
  function ust(i, n2) {
    tH[i] = n2;
  }
  var owe = 1e-4, YIe = 20;
  function cst(i) {
    return i.replace(/^\s+|\s+$/g, "");
  }
  function Tl(i, n2, e2, o) {
    var l4 = n2[0], c4 = n2[1], h = e2[0], p4 = e2[1], g4 = c4 - l4, y4 = p4 - h;
    if (g4 === 0)
      return y4 === 0 ? h : (h + p4) / 2;
    if (o)
      if (g4 > 0) {
        if (i <= l4)
          return h;
        if (i >= c4)
          return p4;
      } else {
        if (i >= l4)
          return h;
        if (i <= c4)
          return p4;
      }
    else {
      if (i === l4)
        return h;
      if (i === c4)
        return p4;
    }
    return (i - l4) / g4 * y4 + h;
  }
  function ma(i, n2) {
    switch (i) {
      case "center":
      case "middle":
        i = "50%";
        break;
      case "left":
      case "top":
        i = "0%";
        break;
      case "right":
      case "bottom":
        i = "100%";
        break;
    }
    return xa(i) ? cst(i).match(/%$/) ? parseFloat(i) / 100 * n2 : parseFloat(i) : i == null ? NaN : +i;
  }
  function df(i, n2, e2) {
    return n2 == null && (n2 = 10), n2 = Math.min(Math.max(0, n2), YIe), i = (+i).toFixed(n2), e2 ? i : +i;
  }
  function Ly(i) {
    return i.sort(function(n2, e2) {
      return n2 - e2;
    }), i;
  }
  function z_(i) {
    if (i = +i, isNaN(i))
      return 0;
    if (i > 1e-14) {
      for (var n2 = 1, e2 = 0; e2 < 15; e2++, n2 *= 10)
        if (Math.round(i * n2) / n2 === i)
          return e2;
    }
    return fst(i);
  }
  function fst(i) {
    var n2 = i.toString().toLowerCase(), e2 = n2.indexOf("e"), o = e2 > 0 ? +n2.slice(e2 + 1) : 0, l4 = e2 > 0 ? e2 : n2.length, c4 = n2.indexOf("."), h = c4 < 0 ? 0 : l4 - 1 - c4;
    return Math.max(0, h - o);
  }
  function ZIe(i, n2) {
    var e2 = Math.log, o = Math.LN10, l4 = Math.floor(e2(i[1] - i[0]) / o), c4 = Math.round(e2(Math.abs(n2[1] - n2[0])) / o), h = Math.min(Math.max(-l4 + c4, 0), 20);
    return isFinite(h) ? h : 20;
  }
  function hst(i, n2, e2) {
    if (!i[n2])
      return 0;
    var o = q_(i, function(T, O) {
      return T + (isNaN(O) ? 0 : O);
    }, 0);
    if (o === 0)
      return 0;
    for (var l4 = Math.pow(10, e2), c4 = Er(i, function(T) {
      return (isNaN(T) ? 0 : T) / o * l4 * 100;
    }), h = l4 * 100, p4 = Er(c4, function(T) {
      return Math.floor(T);
    }), g4 = q_(p4, function(T, O) {
      return T + O;
    }, 0), y4 = Er(c4, function(T, O) {
      return T - p4[O];
    }); g4 < h; ) {
      for (var _ = Number.NEGATIVE_INFINITY, w4 = null, C = 0, E = y4.length; C < E; ++C)
        y4[C] > _ && (_ = y4[C], w4 = C);
      ++p4[w4], y4[w4] = 0, ++g4;
    }
    return p4[n2] / l4;
  }
  function dst(i, n2) {
    var e2 = Math.max(z_(i), z_(n2)), o = i + n2;
    return e2 > YIe ? o : df(o, e2);
  }
  var swe = 9007199254740991;
  function XIe(i) {
    var n2 = Math.PI * 2;
    return (i % n2 + n2) % n2;
  }
  function CH(i) {
    return i > -owe && i < owe;
  }
  var pst = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
  function X_(i) {
    if (i instanceof Date)
      return i;
    if (xa(i)) {
      var n2 = pst.exec(i);
      if (!n2)
        return new Date(NaN);
      if (n2[8]) {
        var e2 = +n2[4] || 0;
        return n2[8].toUpperCase() !== "Z" && (e2 -= +n2[8].slice(0, 3)), new Date(Date.UTC(+n2[1], +(n2[2] || 1) - 1, +n2[3] || 1, e2, +(n2[5] || 0), +n2[6] || 0, n2[7] ? +n2[7].substring(0, 3) : 0));
      } else
        return new Date(+n2[1], +(n2[2] || 1) - 1, +n2[3] || 1, +n2[4] || 0, +(n2[5] || 0), +n2[6] || 0, n2[7] ? +n2[7].substring(0, 3) : 0);
    } else if (i == null)
      return new Date(NaN);
    return new Date(Math.round(i));
  }
  function vst(i) {
    return Math.pow(10, zse(i));
  }
  function zse(i) {
    if (i === 0)
      return 0;
    var n2 = Math.floor(Math.log(i) / Math.LN10);
    return i / Math.pow(10, n2) >= 10 && n2++, n2;
  }
  function KIe(i, n2) {
    var e2 = zse(i), o = Math.pow(10, e2), l4 = i / o, c4;
    return n2 ? l4 < 1.5 ? c4 = 1 : l4 < 2.5 ? c4 = 2 : l4 < 4 ? c4 = 3 : l4 < 7 ? c4 = 5 : c4 = 10 : l4 < 1 ? c4 = 1 : l4 < 2 ? c4 = 2 : l4 < 3 ? c4 = 3 : l4 < 5 ? c4 = 5 : c4 = 10, i = c4 * o, e2 >= -20 ? +i.toFixed(e2 < 0 ? -e2 : 0) : i;
  }
  function ure(i, n2) {
    var e2 = (i.length - 1) * n2 + 1, o = Math.floor(e2), l4 = +i[o - 1], c4 = e2 - o;
    return c4 ? l4 + c4 * (i[o] - l4) : l4;
  }
  function lwe(i) {
    i.sort(function(g4, y4) {
      return p4(g4, y4, 0) ? -1 : 1;
    });
    for (var n2 = -1 / 0, e2 = 1, o = 0; o < i.length; ) {
      for (var l4 = i[o].interval, c4 = i[o].close, h = 0; h < 2; h++)
        l4[h] <= n2 && (l4[h] = n2, c4[h] = h ? 1 : 1 - e2), n2 = l4[h], e2 = c4[h];
      l4[0] === l4[1] && c4[0] * c4[1] !== 1 ? i.splice(o, 1) : o++;
    }
    return i;
    function p4(g4, y4, _) {
      return g4.interval[_] < y4.interval[_] || g4.interval[_] === y4.interval[_] && (g4.close[_] - y4.close[_] === (_ ? -1 : 1) || !_ && p4(g4, y4, 1));
    }
  }
  function _2(i) {
    var n2 = parseFloat(i);
    return n2 == i && (n2 !== 0 || !xa(i) || i.indexOf("x") <= 0) ? n2 : NaN;
  }
  function JIe(i) {
    return !isNaN(_2(i));
  }
  function QIe() {
    return Math.round(Math.random() * 9);
  }
  function eTe(i, n2) {
    return n2 === 0 ? i : eTe(n2, i % n2);
  }
  function uwe(i, n2) {
    return i == null ? n2 : n2 == null ? i : i * n2 / eTe(i, n2);
  }
  function dl(i) {
    throw new Error(i);
  }
  function cwe(i, n2, e2) {
    return (n2 - i) * e2 + i;
  }
  var tTe = "series\0", nTe = "\0_ec_\0";
  function Zl(i) {
    return i instanceof Array ? i : i == null ? [] : [i];
  }
  function mT(i, n2, e2) {
    if (i) {
      i[n2] = i[n2] || {}, i.emphasis = i.emphasis || {}, i.emphasis[n2] = i.emphasis[n2] || {};
      for (var o = 0, l4 = e2.length; o < l4; o++) {
        var c4 = e2[o];
        !i.emphasis[n2].hasOwnProperty(c4) && i[n2].hasOwnProperty(c4) && (i.emphasis[n2][c4] = i[n2][c4]);
      }
    }
  }
  var fwe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
  function H3(i) {
    return mi(i) && !Mr(i) && !(i instanceof Date) ? i.value : i;
  }
  function gst(i) {
    return mi(i) && !(i instanceof Array);
  }
  function rTe(i, n2, e2) {
    var o = e2 === "normalMerge", l4 = e2 === "replaceMerge", c4 = e2 === "replaceAll";
    i = i || [], n2 = (n2 || []).slice();
    var h = ri();
    Ve(n2, function(g4, y4) {
      if (!mi(g4)) {
        n2[y4] = null;
        return;
      }
    });
    var p4 = mst(i, h, e2);
    return (o || l4) && yst(p4, i, h, n2), o && bst(p4, n2), o || l4 ? _st(p4, n2, l4) : c4 && xst(p4, n2), wst(p4), p4;
  }
  function mst(i, n2, e2) {
    var o = [];
    if (e2 === "replaceAll")
      return o;
    for (var l4 = 0; l4 < i.length; l4++) {
      var c4 = i[l4];
      c4 && c4.id != null && n2.set(c4.id, l4), o.push({ existing: e2 === "replaceMerge" || l8(c4) ? null : c4, newOption: null, keyInfo: null, brandNew: null });
    }
    return o;
  }
  function yst(i, n2, e2, o) {
    Ve(o, function(l4, c4) {
      if (!(!l4 || l4.id == null)) {
        var h = GN(l4.id), p4 = e2.get(h);
        if (p4 != null) {
          var g4 = i[p4];
          Kv(!g4.newOption, 'Duplicated option on id "' + h + '".'), g4.newOption = l4, g4.existing = n2[p4], o[c4] = null;
        }
      }
    });
  }
  function bst(i, n2) {
    Ve(n2, function(e2, o) {
      if (!(!e2 || e2.name == null))
        for (var l4 = 0; l4 < i.length; l4++) {
          var c4 = i[l4].existing;
          if (!i[l4].newOption && c4 && (c4.id == null || e2.id == null) && !l8(e2) && !l8(c4) && aTe("name", c4, e2)) {
            i[l4].newOption = e2, n2[o] = null;
            return;
          }
        }
    });
  }
  function _st(i, n2, e2) {
    Ve(n2, function(o) {
      if (!!o) {
        for (var l4, c4 = 0; (l4 = i[c4]) && (l4.newOption || l8(l4.existing) || l4.existing && o.id != null && !aTe("id", o, l4.existing)); )
          c4++;
        l4 ? (l4.newOption = o, l4.brandNew = e2) : i.push({ newOption: o, brandNew: e2, existing: null, keyInfo: null }), c4++;
      }
    });
  }
  function xst(i, n2) {
    Ve(n2, function(e2) {
      i.push({ newOption: e2, brandNew: true, existing: null, keyInfo: null });
    });
  }
  function wst(i) {
    var n2 = ri();
    Ve(i, function(e2) {
      var o = e2.existing;
      o && n2.set(o.id, e2);
    }), Ve(i, function(e2) {
      var o = e2.newOption;
      Kv(!o || o.id == null || !n2.get(o.id) || n2.get(o.id) === e2, "id duplicates: " + (o && o.id)), o && o.id != null && n2.set(o.id, e2), !e2.keyInfo && (e2.keyInfo = {});
    }), Ve(i, function(e2, o) {
      var l4 = e2.existing, c4 = e2.newOption, h = e2.keyInfo;
      if (!!mi(c4)) {
        if (h.name = c4.name != null ? GN(c4.name) : l4 ? l4.name : tTe + o, l4)
          h.id = GN(l4.id);
        else if (c4.id != null)
          h.id = GN(c4.id);
        else {
          var p4 = 0;
          do
            h.id = "\0" + h.name + "\0" + p4++;
          while (n2.get(h.id));
        }
        n2.set(h.id, e2);
      }
    });
  }
  function aTe(i, n2, e2) {
    var o = yh(n2[i], null), l4 = yh(e2[i], null);
    return o != null && l4 != null && o === l4;
  }
  function GN(i) {
    return yh(i, "");
  }
  function yh(i, n2) {
    return i == null ? n2 : xa(i) ? i : sl(i) || wie(i) ? i + "" : n2;
  }
  function Bse(i) {
    var n2 = i.name;
    return !!(n2 && n2.indexOf(tTe));
  }
  function l8(i) {
    return i && i.id != null && GN(i.id).indexOf(nTe) === 0;
  }
  function Sst(i) {
    return nTe + i;
  }
  function Cst(i, n2, e2) {
    Ve(i, function(o) {
      var l4 = o.newOption;
      mi(l4) && (o.keyInfo.mainType = n2, o.keyInfo.subType = Mst(n2, l4, o.existing, e2));
    });
  }
  function Mst(i, n2, e2, o) {
    var l4 = n2.type ? n2.type : e2 ? e2.subType : o.determineSubType(i, n2);
    return l4;
  }
  function Ast(i, n2) {
    var e2 = {}, o = {};
    return l4(i || [], e2), l4(n2 || [], o, e2), [c4(e2), c4(o)];
    function l4(h, p4, g4) {
      for (var y4 = 0, _ = h.length; y4 < _; y4++) {
        var w4 = yh(h[y4].seriesId, null);
        if (w4 == null)
          return;
        for (var C = Zl(h[y4].dataIndex), E = g4 && g4[w4], T = 0, O = C.length; T < O; T++) {
          var N = C[T];
          E && E[N] ? E[N] = null : (p4[w4] || (p4[w4] = {}))[N] = 1;
        }
      }
    }
    function c4(h, p4) {
      var g4 = [];
      for (var y4 in h)
        if (h.hasOwnProperty(y4) && h[y4] != null)
          if (p4)
            g4.push(+y4);
          else {
            var _ = c4(h[y4], true);
            _.length && g4.push({ seriesId: y4, dataIndex: _ });
          }
      return g4;
    }
  }
  function yT(i, n2) {
    if (n2.dataIndexInside != null)
      return n2.dataIndexInside;
    if (n2.dataIndex != null)
      return Mr(n2.dataIndex) ? Er(n2.dataIndex, function(e2) {
        return i.indexOfRawIndex(e2);
      }) : i.indexOfRawIndex(n2.dataIndex);
    if (n2.name != null)
      return Mr(n2.name) ? Er(n2.name, function(e2) {
        return i.indexOfName(e2);
      }) : i.indexOfName(n2.name);
  }
  function zs() {
    var i = "__ec_inner_" + Est++;
    return function(n2) {
      return n2[i] || (n2[i] = {});
    };
  }
  var Est = QIe();
  function WN(i, n2, e2) {
    var o = jse(n2, e2), l4 = o.mainTypeSpecified, c4 = o.queryOptionMap, h = o.others, p4 = h, g4 = e2 ? e2.defaultMainType : null;
    return !l4 && g4 && c4.set(g4, {}), c4.each(function(y4, _) {
      var w4 = V8(i, _, y4, { useDefault: g4 === _, enableAll: e2 && e2.enableAll != null ? e2.enableAll : true, enableNone: e2 && e2.enableNone != null ? e2.enableNone : true });
      p4[_ + "Models"] = w4.models, p4[_ + "Model"] = w4.models[0];
    }), p4;
  }
  function jse(i, n2) {
    var e2;
    if (xa(i)) {
      var o = {};
      o[i + "Index"] = 0, e2 = o;
    } else
      e2 = i;
    var l4 = ri(), c4 = {}, h = false;
    return Ve(e2, function(p4, g4) {
      if (g4 === "dataIndex" || g4 === "dataIndexInside") {
        c4[g4] = p4;
        return;
      }
      var y4 = g4.match(/^(\w+)(Index|Id|Name)$/) || [], _ = y4[1], w4 = (y4[2] || "").toLowerCase();
      if (!(!_ || !w4 || n2 && n2.includeMainTypes && go(n2.includeMainTypes, _) < 0)) {
        h = h || !!_;
        var C = l4.get(_) || l4.set(_, {});
        C[w4] = p4;
      }
    }), { mainTypeSpecified: h, queryOptionMap: l4, others: c4 };
  }
  var Yf = { useDefault: true, enableAll: false, enableNone: false }, Ist = { useDefault: false, enableAll: true, enableNone: true };
  function V8(i, n2, e2, o) {
    o = o || Yf;
    var l4 = e2.index, c4 = e2.id, h = e2.name, p4 = { models: null, specified: l4 != null || c4 != null || h != null };
    if (!p4.specified) {
      var g4 = void 0;
      return p4.models = o.useDefault && (g4 = i.getComponent(n2)) ? [g4] : [], p4;
    }
    return l4 === "none" || l4 === false ? (Kv(o.enableNone, '`"none"` or `false` is not a valid value on index option.'), p4.models = [], p4) : (l4 === "all" && (Kv(o.enableAll, '`"all"` is not a valid value on index option.'), l4 = c4 = h = null), p4.models = i.queryComponents({ mainType: n2, index: l4, id: c4, name: h }), p4);
  }
  function iTe(i, n2, e2) {
    i.setAttribute ? i.setAttribute(n2, e2) : i[n2] = e2;
  }
  function Tst(i, n2) {
    return i.getAttribute ? i.getAttribute(n2) : i[n2];
  }
  function Dst(i) {
    return i === "auto" ? ol.domSupported ? "html" : "richText" : i || "html";
  }
  function $ie(i, n2) {
    var e2 = ri(), o = [];
    return Ve(i, function(l4) {
      var c4 = n2(l4);
      (e2.get(c4) || (o.push(c4), e2.set(c4, []))).push(l4);
    }), { keys: o, buckets: e2 };
  }
  function oTe(i, n2, e2, o, l4) {
    var c4 = n2 == null || n2 === "auto";
    if (o == null)
      return o;
    if (sl(o)) {
      var h = cwe(e2 || 0, o, l4);
      return df(h, c4 ? Math.max(z_(e2 || 0), z_(o)) : n2);
    } else {
      if (xa(o))
        return l4 < 1 ? e2 : o;
      for (var p4 = [], g4 = e2, y4 = o, _ = Math.max(g4 ? g4.length : 0, y4.length), w4 = 0; w4 < _; ++w4) {
        var C = i.getDimensionInfo(w4);
        if (C && C.type === "ordinal")
          p4[w4] = (l4 < 1 && g4 ? g4 : y4)[w4];
        else {
          var E = g4 && g4[w4] ? g4[w4] : 0, T = y4[w4], h = cwe(E, T, l4);
          p4[w4] = df(h, c4 ? Math.max(z_(E), z_(T)) : n2);
        }
      }
      return p4;
    }
  }
  var kst = ".", CI = "___EC__COMPONENT__CONTAINER___", sTe = "___EC__EXTENDED_CLASS___";
  function B_(i) {
    var n2 = { main: "", sub: "" };
    if (i) {
      var e2 = i.split(kst);
      n2.main = e2[0] || "", n2.sub = e2[1] || "";
    }
    return n2;
  }
  function Pst(i) {
    Kv(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(i), 'componentType "' + i + '" illegal');
  }
  function Lst(i) {
    return !!(i && i[sTe]);
  }
  function Gse(i, n2) {
    i.$constructor = i, i.extend = function(e2) {
      var o = this, l4;
      return Ost(o) ? l4 = function(c4) {
        on(h, c4);
        function h() {
          return c4.apply(this, arguments) || this;
        }
        return h;
      }(o) : (l4 = function() {
        (e2.$constructor || o).apply(this, arguments);
      }, Rit(l4, this)), rr(l4.prototype, e2), l4[sTe] = true, l4.extend = this.extend, l4.superCall = Nst, l4.superApply = Vst, l4.superClass = o, l4;
    };
  }
  function Ost(i) {
    return si(i) && /^class\s/.test(Function.prototype.toString.call(i));
  }
  function lTe(i, n2) {
    i.extend = n2.extend;
  }
  var Rst = Math.round(Math.random() * 10);
  function Fst(i) {
    var n2 = ["__\0is_clz", Rst++].join("_");
    i.prototype[n2] = true, i.isInstance = function(e2) {
      return !!(e2 && e2[n2]);
    };
  }
  function Nst(i, n2) {
    for (var e2 = [], o = 2; o < arguments.length; o++)
      e2[o - 2] = arguments[o];
    return this.superClass.prototype[n2].apply(i, e2);
  }
  function Vst(i, n2, e2) {
    return this.superClass.prototype[n2].apply(i, e2);
  }
  function x$(i) {
    var n2 = {};
    i.registerClass = function(o) {
      var l4 = o.type || o.prototype.type;
      if (l4) {
        Pst(l4), o.prototype.type = l4;
        var c4 = B_(l4);
        if (!c4.sub)
          n2[c4.main] = o;
        else if (c4.sub !== CI) {
          var h = e2(c4);
          h[c4.sub] = o;
        }
      }
      return o;
    }, i.getClass = function(o, l4, c4) {
      var h = n2[o];
      if (h && h[CI] && (h = l4 ? h[l4] : null), c4 && !h)
        throw new Error(l4 ? "Component " + o + "." + (l4 || "") + " is used but not imported." : o + ".type should be specified.");
      return h;
    }, i.getClassesByMainType = function(o) {
      var l4 = B_(o), c4 = [], h = n2[l4.main];
      return h && h[CI] ? Ve(h, function(p4, g4) {
        g4 !== CI && c4.push(p4);
      }) : c4.push(h), c4;
    }, i.hasClass = function(o) {
      var l4 = B_(o);
      return !!n2[l4.main];
    }, i.getAllClassMainTypes = function() {
      var o = [];
      return Ve(n2, function(l4, c4) {
        o.push(c4);
      }), o;
    }, i.hasSubTypes = function(o) {
      var l4 = B_(o), c4 = n2[l4.main];
      return c4 && c4[CI];
    };
    function e2(o) {
      var l4 = n2[o.main];
      return (!l4 || !l4[CI]) && (l4 = n2[o.main] = {}, l4[CI] = true), l4;
    }
  }
  function bT(i, n2) {
    for (var e2 = 0; e2 < i.length; e2++)
      i[e2][1] || (i[e2][1] = i[e2][0]);
    return n2 = n2 || false, function(o, l4, c4) {
      for (var h = {}, p4 = 0; p4 < i.length; p4++) {
        var g4 = i[p4][1];
        if (!(l4 && go(l4, g4) >= 0 || c4 && go(c4, g4) < 0)) {
          var y4 = o.getShallow(g4, n2);
          y4 != null && (h[i[p4][0]] = y4);
        }
      }
      return h;
    };
  }
  var zst = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], Bst = bT(zst), jst = function() {
    function i() {
    }
    return i.prototype.getAreaStyle = function(n2, e2) {
      return Bst(this, n2, e2);
    }, i;
  }(), Uie = new F8(50);
  function Gst(i) {
    if (typeof i == "string") {
      var n2 = Uie.get(i);
      return n2 && n2.image;
    } else
      return i;
  }
  function Wse(i, n2, e2, o, l4) {
    if (i)
      if (typeof i == "string") {
        if (n2 && n2.__zrImageSrc === i || !e2)
          return n2;
        var c4 = Uie.get(i), h = { hostEl: e2, cb: o, cbPayload: l4 };
        if (c4)
          n2 = c4.image, !w$(n2) && c4.pending.push(h);
        else {
          var p4 = y2.loadImage(i, hwe, hwe);
          p4.__zrImageSrc = i, Uie.put(i, p4.__cachedImgObj = { image: p4, pending: [h] });
        }
        return n2;
      } else
        return i;
    else
      return n2;
  }
  function hwe() {
    var i = this.__cachedImgObj;
    this.onload = this.onerror = this.__cachedImgObj = null;
    for (var n2 = 0; n2 < i.pending.length; n2++) {
      var e2 = i.pending[n2], o = e2.cb;
      o && o(this, e2.cbPayload), e2.hostEl.dirty();
    }
    i.pending.length = 0;
  }
  function w$(i) {
    return i && i.width && i.height;
  }
  var cre = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
  function Wst(i, n2, e2, o, l4) {
    if (!n2)
      return "";
    var c4 = (i + "").split(`
`);
    l4 = uTe(n2, e2, o, l4);
    for (var h = 0, p4 = c4.length; h < p4; h++)
      c4[h] = cTe(c4[h], l4);
    return c4.join(`
`);
  }
  function uTe(i, n2, e2, o) {
    o = o || {};
    var l4 = rr({}, o);
    l4.font = n2, e2 = so(e2, "..."), l4.maxIterations = so(o.maxIterations, 2);
    var c4 = l4.minChar = so(o.minChar, 0);
    l4.cnCharWidth = rm("\u56FD", n2);
    var h = l4.ascCharWidth = rm("a", n2);
    l4.placeholder = so(o.placeholder, "");
    for (var p4 = i = Math.max(0, i - 1), g4 = 0; g4 < c4 && p4 >= h; g4++)
      p4 -= h;
    var y4 = rm(e2, n2);
    return y4 > p4 && (e2 = "", y4 = 0), p4 = i - y4, l4.ellipsis = e2, l4.ellipsisWidth = y4, l4.contentWidth = p4, l4.containerWidth = i, l4;
  }
  function cTe(i, n2) {
    var e2 = n2.containerWidth, o = n2.font, l4 = n2.contentWidth;
    if (!e2)
      return "";
    var c4 = rm(i, o);
    if (c4 <= e2)
      return i;
    for (var h = 0; ; h++) {
      if (c4 <= l4 || h >= n2.maxIterations) {
        i += n2.ellipsis;
        break;
      }
      var p4 = h === 0 ? Hst(i, l4, n2.ascCharWidth, n2.cnCharWidth) : c4 > 0 ? Math.floor(i.length * l4 / c4) : 0;
      i = i.substr(0, p4), c4 = rm(i, o);
    }
    return i === "" && (i = n2.placeholder), i;
  }
  function Hst(i, n2, e2, o) {
    for (var l4 = 0, c4 = 0, h = i.length; c4 < h && l4 < n2; c4++) {
      var p4 = i.charCodeAt(c4);
      l4 += 0 <= p4 && p4 <= 127 ? e2 : o;
    }
    return c4;
  }
  function $st(i, n2) {
    i != null && (i += "");
    var e2 = n2.overflow, o = n2.padding, l4 = n2.font, c4 = e2 === "truncate", h = _$(l4), p4 = so(n2.lineHeight, h), g4 = !!n2.backgroundColor, y4 = n2.lineOverflow === "truncate", _ = n2.width, w4;
    _ != null && (e2 === "break" || e2 === "breakAll") ? w4 = i ? fTe(i, n2.font, _, e2 === "breakAll", 0).lines : [] : w4 = i ? i.split(`
`) : [];
    var C = w4.length * p4, E = so(n2.height, C);
    if (C > E && y4) {
      var T = Math.floor(E / p4);
      w4 = w4.slice(0, T);
    }
    if (i && c4 && _ != null)
      for (var O = uTe(_, l4, n2.ellipsis, { minChar: n2.truncateMinChar, placeholder: n2.placeholder }), N = 0; N < w4.length; N++)
        w4[N] = cTe(w4[N], O);
    for (var V = E, H = 0, N = 0; N < w4.length; N++)
      H = Math.max(rm(w4[N], l4), H);
    _ == null && (_ = H);
    var X = H;
    return o && (V += o[0] + o[2], X += o[1] + o[3], _ += o[1] + o[3]), g4 && (X = _), { lines: w4, height: E, outerWidth: X, outerHeight: V, lineHeight: p4, calculatedLineHeight: h, contentWidth: H, contentHeight: C, width: _ };
  }
  var Ust = function() {
    function i() {
    }
    return i;
  }(), dwe = function() {
    function i(n2) {
      this.tokens = [], n2 && (this.tokens = n2);
    }
    return i;
  }(), qst = function() {
    function i() {
      this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
    }
    return i;
  }();
  function Yst(i, n2) {
    var e2 = new qst();
    if (i != null && (i += ""), !i)
      return e2;
    for (var o = n2.width, l4 = n2.height, c4 = n2.overflow, h = (c4 === "break" || c4 === "breakAll") && o != null ? { width: o, accumWidth: 0, breakAll: c4 === "breakAll" } : null, p4 = cre.lastIndex = 0, g4; (g4 = cre.exec(i)) != null; ) {
      var y4 = g4.index;
      y4 > p4 && fre(e2, i.substring(p4, y4), n2, h), fre(e2, g4[2], n2, h, g4[1]), p4 = cre.lastIndex;
    }
    p4 < i.length && fre(e2, i.substring(p4, i.length), n2, h);
    var _ = [], w4 = 0, C = 0, E = n2.padding, T = c4 === "truncate", O = n2.lineOverflow === "truncate";
    function N(xt, It, Wt) {
      xt.width = It, xt.lineHeight = Wt, w4 += Wt, C = Math.max(C, It);
    }
    e:
      for (var V = 0; V < e2.lines.length; V++) {
        for (var H = e2.lines[V], X = 0, q2 = 0, de = 0; de < H.tokens.length; de++) {
          var le = H.tokens[de], me = le.styleName && n2.rich[le.styleName] || {}, ye = le.textPadding = me.padding, be = ye ? ye[1] + ye[3] : 0, we = le.font = me.font || n2.font;
          le.contentHeight = _$(we);
          var Pe = so(me.height, le.contentHeight);
          if (le.innerHeight = Pe, ye && (Pe += ye[0] + ye[2]), le.height = Pe, le.lineHeight = f2(me.lineHeight, n2.lineHeight, Pe), le.align = me && me.align || n2.align, le.verticalAlign = me && me.verticalAlign || "middle", O && l4 != null && w4 + le.lineHeight > l4) {
            de > 0 ? (H.tokens = H.tokens.slice(0, de), N(H, q2, X), e2.lines = e2.lines.slice(0, V + 1)) : e2.lines = e2.lines.slice(0, V);
            break e;
          }
          var ze = me.width, Re = ze == null || ze === "auto";
          if (typeof ze == "string" && ze.charAt(ze.length - 1) === "%")
            le.percentWidth = ze, _.push(le), le.contentWidth = rm(le.text, we);
          else {
            if (Re) {
              var rt2 = me.backgroundColor, ft = rt2 && rt2.image;
              ft && (ft = Gst(ft), w$(ft) && (le.width = Math.max(le.width, ft.width * Pe / ft.height)));
            }
            var et = T && o != null ? o - q2 : null;
            et != null && et < le.width ? !Re || et < be ? (le.text = "", le.width = le.contentWidth = 0) : (le.text = Wst(le.text, et - be, we, n2.ellipsis, { minChar: n2.truncateMinChar }), le.width = le.contentWidth = rm(le.text, we)) : le.contentWidth = rm(le.text, we);
          }
          le.width += be, q2 += le.width, me && (X = Math.max(X, le.lineHeight));
        }
        N(H, q2, X);
      }
    e2.outerWidth = e2.width = so(o, C), e2.outerHeight = e2.height = so(l4, w4), e2.contentHeight = w4, e2.contentWidth = C, E && (e2.outerWidth += E[1] + E[3], e2.outerHeight += E[0] + E[2]);
    for (var V = 0; V < _.length; V++) {
      var le = _[V], Jt = le.percentWidth;
      le.width = parseInt(Jt, 10) / 100 * e2.width;
    }
    return e2;
  }
  function fre(i, n2, e2, o, l4) {
    var c4 = n2 === "", h = l4 && e2.rich[l4] || {}, p4 = i.lines, g4 = h.font || e2.font, y4 = false, _, w4;
    if (o) {
      var C = h.padding, E = C ? C[1] + C[3] : 0;
      if (h.width != null && h.width !== "auto") {
        var T = ib(h.width, o.width) + E;
        p4.length > 0 && T + o.accumWidth > o.width && (_ = n2.split(`
`), y4 = true), o.accumWidth = T;
      } else {
        var O = fTe(n2, g4, o.width, o.breakAll, o.accumWidth);
        o.accumWidth = O.accumWidth + E, w4 = O.linesWidths, _ = O.lines;
      }
    } else
      _ = n2.split(`
`);
    for (var N = 0; N < _.length; N++) {
      var V = _[N], H = new Ust();
      if (H.styleName = l4, H.text = V, H.isLineHolder = !V && !c4, typeof h.width == "number" ? H.width = h.width : H.width = w4 ? w4[N] : rm(V, g4), !N && !y4) {
        var X = (p4[p4.length - 1] || (p4[0] = new dwe())).tokens, q2 = X.length;
        q2 === 1 && X[0].isLineHolder ? X[0] = H : (V || !q2 || c4) && X.push(H);
      } else
        p4.push(new dwe([H]));
    }
  }
  function Zst(i) {
    var n2 = i.charCodeAt(0);
    return n2 >= 33 && n2 <= 383;
  }
  var Xst = q_(",&?/;] ".split(""), function(i, n2) {
    return i[n2] = true, i;
  }, {});
  function Kst(i) {
    return Zst(i) ? !!Xst[i] : true;
  }
  function fTe(i, n2, e2, o, l4) {
    for (var c4 = [], h = [], p4 = "", g4 = "", y4 = 0, _ = 0, w4 = 0; w4 < i.length; w4++) {
      var C = i.charAt(w4);
      if (C === `
`) {
        g4 && (p4 += g4, _ += y4), c4.push(p4), h.push(_), p4 = "", g4 = "", y4 = 0, _ = 0;
        continue;
      }
      var E = rm(C, n2), T = o ? false : !Kst(C);
      if (c4.length ? _ + E > e2 : l4 + _ + E > e2) {
        _ ? (p4 || g4) && (T ? (p4 || (p4 = g4, g4 = "", y4 = 0, _ = y4), c4.push(p4), h.push(_ - y4), g4 += C, y4 += E, p4 = "", _ = y4) : (g4 && (p4 += g4, g4 = "", y4 = 0), c4.push(p4), h.push(_), p4 = C, _ = E)) : T ? (c4.push(g4), h.push(y4), g4 = C, y4 = E) : (c4.push(C), h.push(E));
        continue;
      }
      _ += E, T ? (g4 += C, y4 += E) : (g4 && (p4 += g4, g4 = "", y4 = 0), p4 += C);
    }
    return !c4.length && !p4 && (p4 = i, g4 = "", y4 = 0), g4 && (p4 += g4), p4 && (c4.push(p4), h.push(_)), c4.length === 1 && (_ += l4), { accumWidth: _, lines: c4, linesWidths: h };
  }
  var qie = "__zr_style_" + Math.round(Math.random() * 10), uT = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, S$ = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
  uT[qie] = true;
  var pwe = ["z", "z2", "invisible"], Jst = ["invisible"], Qst = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype._init = function(e2) {
      for (var o = ts(e2), l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        c4 === "style" ? this.useStyle(e2[c4]) : i.prototype.attrKV.call(this, c4, e2[c4]);
      }
      this.style || this.useStyle({});
    }, n2.prototype.beforeBrush = function() {
    }, n2.prototype.afterBrush = function() {
    }, n2.prototype.innerBeforeBrush = function() {
    }, n2.prototype.innerAfterBrush = function() {
    }, n2.prototype.shouldBePainted = function(e2, o, l4, c4) {
      var h = this.transform;
      if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && elt(this, e2, o) || h && !h[0] && !h[3])
        return false;
      if (l4 && this.__clipPaths) {
        for (var p4 = 0; p4 < this.__clipPaths.length; ++p4)
          if (this.__clipPaths[p4].isZeroArea())
            return false;
      }
      if (c4 && this.parent)
        for (var g4 = this.parent; g4; ) {
          if (g4.ignore)
            return false;
          g4 = g4.parent;
        }
      return true;
    }, n2.prototype.contain = function(e2, o) {
      return this.rectContain(e2, o);
    }, n2.prototype.traverse = function(e2, o) {
      e2.call(o, this);
    }, n2.prototype.rectContain = function(e2, o) {
      var l4 = this.transformCoordToLocal(e2, o), c4 = this.getBoundingRect();
      return c4.contain(l4[0], l4[1]);
    }, n2.prototype.getPaintRect = function() {
      var e2 = this._paintRect;
      if (!this._paintRect || this.__dirty) {
        var o = this.transform, l4 = this.getBoundingRect(), c4 = this.style, h = c4.shadowBlur || 0, p4 = c4.shadowOffsetX || 0, g4 = c4.shadowOffsetY || 0;
        e2 = this._paintRect || (this._paintRect = new mo(0, 0, 0, 0)), o ? mo.applyTransform(e2, l4, o) : e2.copy(l4), (h || p4 || g4) && (e2.width += h * 2 + Math.abs(p4), e2.height += h * 2 + Math.abs(g4), e2.x = Math.min(e2.x, e2.x + p4 - h), e2.y = Math.min(e2.y, e2.y + g4 - h));
        var y4 = this.dirtyRectTolerance;
        e2.isZero() || (e2.x = Math.floor(e2.x - y4), e2.y = Math.floor(e2.y - y4), e2.width = Math.ceil(e2.width + 1 + y4 * 2), e2.height = Math.ceil(e2.height + 1 + y4 * 2));
      }
      return e2;
    }, n2.prototype.setPrevPaintRect = function(e2) {
      e2 ? (this._prevPaintRect = this._prevPaintRect || new mo(0, 0, 0, 0), this._prevPaintRect.copy(e2)) : this._prevPaintRect = null;
    }, n2.prototype.getPrevPaintRect = function() {
      return this._prevPaintRect;
    }, n2.prototype.animateStyle = function(e2) {
      return this.animate("style", e2);
    }, n2.prototype.updateDuringAnimation = function(e2) {
      e2 === "style" ? this.dirtyStyle() : this.markRedraw();
    }, n2.prototype.attrKV = function(e2, o) {
      e2 !== "style" ? i.prototype.attrKV.call(this, e2, o) : this.style ? this.setStyle(o) : this.useStyle(o);
    }, n2.prototype.setStyle = function(e2, o) {
      return typeof e2 == "string" ? this.style[e2] = o : rr(this.style, e2), this.dirtyStyle(), this;
    }, n2.prototype.dirtyStyle = function(e2) {
      e2 || this.markRedraw(), this.__dirty |= AN, this._rect && (this._rect = null);
    }, n2.prototype.dirty = function() {
      this.dirtyStyle();
    }, n2.prototype.styleChanged = function() {
      return !!(this.__dirty & AN);
    }, n2.prototype.styleUpdated = function() {
      this.__dirty &= ~AN;
    }, n2.prototype.createStyle = function(e2) {
      return m$(uT, e2);
    }, n2.prototype.useStyle = function(e2) {
      e2[qie] || (e2 = this.createStyle(e2)), this.__inHover ? this.__hoverStyle = e2 : this.style = e2, this.dirtyStyle();
    }, n2.prototype.isStyleObject = function(e2) {
      return e2[qie];
    }, n2.prototype._innerSaveToNormal = function(e2) {
      i.prototype._innerSaveToNormal.call(this, e2);
      var o = this._normalState;
      e2.style && !o.style && (o.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(e2, o, pwe);
    }, n2.prototype._applyStateObj = function(e2, o, l4, c4, h, p4) {
      i.prototype._applyStateObj.call(this, e2, o, l4, c4, h, p4);
      var g4 = !(o && c4), y4;
      if (o && o.style ? h ? c4 ? y4 = o.style : (y4 = this._mergeStyle(this.createStyle(), l4.style), this._mergeStyle(y4, o.style)) : (y4 = this._mergeStyle(this.createStyle(), c4 ? this.style : l4.style), this._mergeStyle(y4, o.style)) : g4 && (y4 = l4.style), y4)
        if (h) {
          var _ = this.style;
          if (this.style = this.createStyle(g4 ? {} : _), g4)
            for (var w4 = ts(_), C = 0; C < w4.length; C++) {
              var E = w4[C];
              E in y4 && (y4[E] = y4[E], this.style[E] = _[E]);
            }
          for (var T = ts(y4), C = 0; C < T.length; C++) {
            var E = T[C];
            this.style[E] = this.style[E];
          }
          this._transitionState(e2, { style: y4 }, p4, this.getAnimationStyleProps());
        } else
          this.useStyle(y4);
      for (var O = this.__inHover ? Jst : pwe, C = 0; C < O.length; C++) {
        var E = O[C];
        o && o[E] != null ? this[E] = o[E] : g4 && l4[E] != null && (this[E] = l4[E]);
      }
    }, n2.prototype._mergeStates = function(e2) {
      for (var o = i.prototype._mergeStates.call(this, e2), l4, c4 = 0; c4 < e2.length; c4++) {
        var h = e2[c4];
        h.style && (l4 = l4 || {}, this._mergeStyle(l4, h.style));
      }
      return l4 && (o.style = l4), o;
    }, n2.prototype._mergeStyle = function(e2, o) {
      return rr(e2, o), e2;
    }, n2.prototype.getAnimationStyleProps = function() {
      return S$;
    }, n2.initDefaultProps = function() {
      var e2 = n2.prototype;
      e2.type = "displayable", e2.invisible = false, e2.z = 0, e2.z2 = 0, e2.zlevel = 0, e2.culling = false, e2.cursor = "pointer", e2.rectHover = false, e2.incremental = false, e2._rect = null, e2.dirtyRectTolerance = 0, e2.__dirty = em | AN;
    }(), n2;
  }($Ie), hre = new mo(0, 0, 0, 0), dre = new mo(0, 0, 0, 0);
  function elt(i, n2, e2) {
    return hre.copy(i.getBoundingRect()), i.transform && hre.applyTransform(i.transform), dre.width = n2, dre.height = e2, !hre.intersect(dre);
  }
  var Vy = Qst, jg = Math.min, Gg = Math.max, pre = Math.sin, vre = Math.cos, MI = Math.PI * 2, ZG = CT(), XG = CT(), KG = CT();
  function C$(i, n2, e2) {
    if (i.length !== 0) {
      for (var o = i[0], l4 = o[0], c4 = o[0], h = o[1], p4 = o[1], g4 = 1; g4 < i.length; g4++)
        o = i[g4], l4 = jg(l4, o[0]), c4 = Gg(c4, o[0]), h = jg(h, o[1]), p4 = Gg(p4, o[1]);
      n2[0] = l4, n2[1] = h, e2[0] = c4, e2[1] = p4;
    }
  }
  function vwe(i, n2, e2, o, l4, c4) {
    l4[0] = jg(i, e2), l4[1] = jg(n2, o), c4[0] = Gg(i, e2), c4[1] = Gg(n2, o);
  }
  var gwe = [], mwe = [];
  function tlt(i, n2, e2, o, l4, c4, h, p4, g4, y4) {
    var _ = TIe, w4 = Kh, C = _(i, e2, l4, h, gwe);
    g4[0] = 1 / 0, g4[1] = 1 / 0, y4[0] = -1 / 0, y4[1] = -1 / 0;
    for (var E = 0; E < C; E++) {
      var T = w4(i, e2, l4, h, gwe[E]);
      g4[0] = jg(T, g4[0]), y4[0] = Gg(T, y4[0]);
    }
    C = _(n2, o, c4, p4, mwe);
    for (var E = 0; E < C; E++) {
      var O = w4(n2, o, c4, p4, mwe[E]);
      g4[1] = jg(O, g4[1]), y4[1] = Gg(O, y4[1]);
    }
    g4[0] = jg(i, g4[0]), y4[0] = Gg(i, y4[0]), g4[0] = jg(h, g4[0]), y4[0] = Gg(h, y4[0]), g4[1] = jg(n2, g4[1]), y4[1] = Gg(n2, y4[1]), g4[1] = jg(p4, g4[1]), y4[1] = Gg(p4, y4[1]);
  }
  function nlt(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = kIe, y4 = Fd, _ = Gg(jg(g4(i, e2, l4), 1), 0), w4 = Gg(jg(g4(n2, o, c4), 1), 0), C = y4(i, e2, l4, _), E = y4(n2, o, c4, w4);
    h[0] = jg(i, l4, C), h[1] = jg(n2, c4, E), p4[0] = Gg(i, l4, C), p4[1] = Gg(n2, c4, E);
  }
  function rlt(i, n2, e2, o, l4, c4, h, p4, g4) {
    var y4 = FC, _ = NC, w4 = Math.abs(l4 - c4);
    if (w4 % MI < 1e-4 && w4 > 1e-4) {
      p4[0] = i - e2, p4[1] = n2 - o, g4[0] = i + e2, g4[1] = n2 + o;
      return;
    }
    if (ZG[0] = vre(l4) * e2 + i, ZG[1] = pre(l4) * o + n2, XG[0] = vre(c4) * e2 + i, XG[1] = pre(c4) * o + n2, y4(p4, ZG, XG), _(g4, ZG, XG), l4 = l4 % MI, l4 < 0 && (l4 = l4 + MI), c4 = c4 % MI, c4 < 0 && (c4 = c4 + MI), l4 > c4 && !h ? c4 += MI : l4 < c4 && h && (l4 += MI), h) {
      var C = c4;
      c4 = l4, l4 = C;
    }
    for (var E = 0; E < c4; E += Math.PI / 2)
      E > l4 && (KG[0] = vre(E) * e2 + i, KG[1] = pre(E) * o + n2, y4(p4, KG, p4), _(g4, KG, g4));
  }
  var du = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, AI = [], EI = [], T_ = [], SC = [], D_ = [], k_ = [], gre = Math.min, mre = Math.max, II = Math.cos, TI = Math.sin, r2 = Math.abs, Yie = Math.PI, kC = Yie * 2, yre = typeof Float32Array != "undefined", QF = [];
  function bre(i) {
    var n2 = Math.round(i / Yie * 1e8) / 1e8;
    return n2 % 2 * Yie;
  }
  function alt(i, n2) {
    var e2 = bre(i[0]);
    e2 < 0 && (e2 += kC);
    var o = e2 - i[0], l4 = i[1];
    l4 += o, !n2 && l4 - e2 >= kC ? l4 = e2 + kC : n2 && e2 - l4 >= kC ? l4 = e2 - kC : !n2 && e2 > l4 ? l4 = e2 + (kC - bre(e2 - l4)) : n2 && e2 < l4 && (l4 = e2 - (kC - bre(l4 - e2))), i[0] = e2, i[1] = l4;
  }
  var ilt = function() {
    function i(n2) {
      this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, n2 && (this._saveData = false), this._saveData && (this.data = []);
    }
    return i.prototype.increaseVersion = function() {
      this._version++;
    }, i.prototype.getVersion = function() {
      return this._version;
    }, i.prototype.setScale = function(n2, e2, o) {
      o = o || 0, o > 0 && (this._ux = r2(o / wH / n2) || 0, this._uy = r2(o / wH / e2) || 0);
    }, i.prototype.setDPR = function(n2) {
      this.dpr = n2;
    }, i.prototype.setContext = function(n2) {
      this._ctx = n2;
    }, i.prototype.getContext = function() {
      return this._ctx;
    }, i.prototype.beginPath = function() {
      return this._ctx && this._ctx.beginPath(), this.reset(), this;
    }, i.prototype.reset = function() {
      this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
    }, i.prototype.moveTo = function(n2, e2) {
      return this._drawPendingPt(), this.addData(du.M, n2, e2), this._ctx && this._ctx.moveTo(n2, e2), this._x0 = n2, this._y0 = e2, this._xi = n2, this._yi = e2, this;
    }, i.prototype.lineTo = function(n2, e2) {
      var o = r2(n2 - this._xi), l4 = r2(e2 - this._yi), c4 = o > this._ux || l4 > this._uy;
      if (this.addData(du.L, n2, e2), this._ctx && c4 && this._ctx.lineTo(n2, e2), c4)
        this._xi = n2, this._yi = e2, this._pendingPtDist = 0;
      else {
        var h = o * o + l4 * l4;
        h > this._pendingPtDist && (this._pendingPtX = n2, this._pendingPtY = e2, this._pendingPtDist = h);
      }
      return this;
    }, i.prototype.bezierCurveTo = function(n2, e2, o, l4, c4, h) {
      return this._drawPendingPt(), this.addData(du.C, n2, e2, o, l4, c4, h), this._ctx && this._ctx.bezierCurveTo(n2, e2, o, l4, c4, h), this._xi = c4, this._yi = h, this;
    }, i.prototype.quadraticCurveTo = function(n2, e2, o, l4) {
      return this._drawPendingPt(), this.addData(du.Q, n2, e2, o, l4), this._ctx && this._ctx.quadraticCurveTo(n2, e2, o, l4), this._xi = o, this._yi = l4, this;
    }, i.prototype.arc = function(n2, e2, o, l4, c4, h) {
      this._drawPendingPt(), QF[0] = l4, QF[1] = c4, alt(QF, h), l4 = QF[0], c4 = QF[1];
      var p4 = c4 - l4;
      return this.addData(du.A, n2, e2, o, o, l4, p4, 0, h ? 0 : 1), this._ctx && this._ctx.arc(n2, e2, o, l4, c4, h), this._xi = II(c4) * o + n2, this._yi = TI(c4) * o + e2, this;
    }, i.prototype.arcTo = function(n2, e2, o, l4, c4) {
      return this._drawPendingPt(), this._ctx && this._ctx.arcTo(n2, e2, o, l4, c4), this;
    }, i.prototype.rect = function(n2, e2, o, l4) {
      return this._drawPendingPt(), this._ctx && this._ctx.rect(n2, e2, o, l4), this.addData(du.R, n2, e2, o, l4), this;
    }, i.prototype.closePath = function() {
      this._drawPendingPt(), this.addData(du.Z);
      var n2 = this._ctx, e2 = this._x0, o = this._y0;
      return n2 && n2.closePath(), this._xi = e2, this._yi = o, this;
    }, i.prototype.fill = function(n2) {
      n2 && n2.fill(), this.toStatic();
    }, i.prototype.stroke = function(n2) {
      n2 && n2.stroke(), this.toStatic();
    }, i.prototype.len = function() {
      return this._len;
    }, i.prototype.setData = function(n2) {
      var e2 = n2.length;
      !(this.data && this.data.length === e2) && yre && (this.data = new Float32Array(e2));
      for (var o = 0; o < e2; o++)
        this.data[o] = n2[o];
      this._len = e2;
    }, i.prototype.appendPath = function(n2) {
      n2 instanceof Array || (n2 = [n2]);
      for (var e2 = n2.length, o = 0, l4 = this._len, c4 = 0; c4 < e2; c4++)
        o += n2[c4].len();
      yre && this.data instanceof Float32Array && (this.data = new Float32Array(l4 + o));
      for (var c4 = 0; c4 < e2; c4++)
        for (var h = n2[c4].data, p4 = 0; p4 < h.length; p4++)
          this.data[l4++] = h[p4];
      this._len = l4;
    }, i.prototype.addData = function(n2, e2, o, l4, c4, h, p4, g4, y4) {
      if (!!this._saveData) {
        var _ = this.data;
        this._len + arguments.length > _.length && (this._expandData(), _ = this.data);
        for (var w4 = 0; w4 < arguments.length; w4++)
          _[this._len++] = arguments[w4];
      }
    }, i.prototype._drawPendingPt = function() {
      this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
    }, i.prototype._expandData = function() {
      if (!(this.data instanceof Array)) {
        for (var n2 = [], e2 = 0; e2 < this._len; e2++)
          n2[e2] = this.data[e2];
        this.data = n2;
      }
    }, i.prototype.toStatic = function() {
      if (!!this._saveData) {
        this._drawPendingPt();
        var n2 = this.data;
        n2 instanceof Array && (n2.length = this._len, yre && this._len > 11 && (this.data = new Float32Array(n2)));
      }
    }, i.prototype.getBoundingRect = function() {
      T_[0] = T_[1] = D_[0] = D_[1] = Number.MAX_VALUE, SC[0] = SC[1] = k_[0] = k_[1] = -Number.MAX_VALUE;
      var n2 = this.data, e2 = 0, o = 0, l4 = 0, c4 = 0, h;
      for (h = 0; h < this._len; ) {
        var p4 = n2[h++], g4 = h === 1;
        switch (g4 && (e2 = n2[h], o = n2[h + 1], l4 = e2, c4 = o), p4) {
          case du.M:
            e2 = l4 = n2[h++], o = c4 = n2[h++], D_[0] = l4, D_[1] = c4, k_[0] = l4, k_[1] = c4;
            break;
          case du.L:
            vwe(e2, o, n2[h], n2[h + 1], D_, k_), e2 = n2[h++], o = n2[h++];
            break;
          case du.C:
            tlt(e2, o, n2[h++], n2[h++], n2[h++], n2[h++], n2[h], n2[h + 1], D_, k_), e2 = n2[h++], o = n2[h++];
            break;
          case du.Q:
            nlt(e2, o, n2[h++], n2[h++], n2[h], n2[h + 1], D_, k_), e2 = n2[h++], o = n2[h++];
            break;
          case du.A:
            var y4 = n2[h++], _ = n2[h++], w4 = n2[h++], C = n2[h++], E = n2[h++], T = n2[h++] + E;
            h += 1;
            var O = !n2[h++];
            g4 && (l4 = II(E) * w4 + y4, c4 = TI(E) * C + _), rlt(y4, _, w4, C, E, T, O, D_, k_), e2 = II(T) * w4 + y4, o = TI(T) * C + _;
            break;
          case du.R:
            l4 = e2 = n2[h++], c4 = o = n2[h++];
            var N = n2[h++], V = n2[h++];
            vwe(l4, c4, l4 + N, c4 + V, D_, k_);
            break;
          case du.Z:
            e2 = l4, o = c4;
            break;
        }
        FC(T_, T_, D_), NC(SC, SC, k_);
      }
      return h === 0 && (T_[0] = T_[1] = SC[0] = SC[1] = 0), new mo(T_[0], T_[1], SC[0] - T_[0], SC[1] - T_[1]);
    }, i.prototype._calculateLength = function() {
      var n2 = this.data, e2 = this._len, o = this._ux, l4 = this._uy, c4 = 0, h = 0, p4 = 0, g4 = 0;
      this._pathSegLen || (this._pathSegLen = []);
      for (var y4 = this._pathSegLen, _ = 0, w4 = 0, C = 0; C < e2; ) {
        var E = n2[C++], T = C === 1;
        T && (c4 = n2[C], h = n2[C + 1], p4 = c4, g4 = h);
        var O = -1;
        switch (E) {
          case du.M:
            c4 = p4 = n2[C++], h = g4 = n2[C++];
            break;
          case du.L: {
            var N = n2[C++], V = n2[C++], H = N - c4, X = V - h;
            (r2(H) > o || r2(X) > l4 || C === e2 - 1) && (O = Math.sqrt(H * H + X * X), c4 = N, h = V);
            break;
          }
          case du.C: {
            var q2 = n2[C++], de = n2[C++], N = n2[C++], V = n2[C++], le = n2[C++], me = n2[C++];
            O = pot(c4, h, q2, de, N, V, le, me, 10), c4 = le, h = me;
            break;
          }
          case du.Q: {
            var q2 = n2[C++], de = n2[C++], N = n2[C++], V = n2[C++];
            O = got(c4, h, q2, de, N, V, 10), c4 = N, h = V;
            break;
          }
          case du.A:
            var ye = n2[C++], be = n2[C++], we = n2[C++], Pe = n2[C++], ze = n2[C++], Re = n2[C++], rt2 = Re + ze;
            C += 1, n2[C++], T && (p4 = II(ze) * we + ye, g4 = TI(ze) * Pe + be), O = mre(we, Pe) * gre(kC, Math.abs(Re)), c4 = II(rt2) * we + ye, h = TI(rt2) * Pe + be;
            break;
          case du.R: {
            p4 = c4 = n2[C++], g4 = h = n2[C++];
            var ft = n2[C++], et = n2[C++];
            O = ft * 2 + et * 2;
            break;
          }
          case du.Z: {
            var H = p4 - c4, X = g4 - h;
            O = Math.sqrt(H * H + X * X), c4 = p4, h = g4;
            break;
          }
        }
        O >= 0 && (y4[w4++] = O, _ += O);
      }
      return this._pathLen = _, _;
    }, i.prototype.rebuildPath = function(n2, e2) {
      var o = this.data, l4 = this._ux, c4 = this._uy, h = this._len, p4, g4, y4, _, w4, C, E = e2 < 1, T, O, N = 0, V = 0, H, X = 0, q2, de;
      if (E && (this._pathSegLen || this._calculateLength(), T = this._pathSegLen, O = this._pathLen, H = e2 * O, !H))
        return;
      e:
        for (var le = 0; le < h; ) {
          var me = o[le++], ye = le === 1;
          switch (ye && (y4 = o[le], _ = o[le + 1], p4 = y4, g4 = _), me !== du.L && X > 0 && (n2.lineTo(q2, de), X = 0), me) {
            case du.M:
              p4 = y4 = o[le++], g4 = _ = o[le++], n2.moveTo(y4, _);
              break;
            case du.L: {
              w4 = o[le++], C = o[le++];
              var be = r2(w4 - y4), we = r2(C - _);
              if (be > l4 || we > c4) {
                if (E) {
                  var Pe = T[V++];
                  if (N + Pe > H) {
                    var ze = (H - N) / Pe;
                    n2.lineTo(y4 * (1 - ze) + w4 * ze, _ * (1 - ze) + C * ze);
                    break e;
                  }
                  N += Pe;
                }
                n2.lineTo(w4, C), y4 = w4, _ = C, X = 0;
              } else {
                var Re = be * be + we * we;
                Re > X && (q2 = w4, de = C, X = Re);
              }
              break;
            }
            case du.C: {
              var rt2 = o[le++], ft = o[le++], et = o[le++], Jt = o[le++], xt = o[le++], It = o[le++];
              if (E) {
                var Pe = T[V++];
                if (N + Pe > H) {
                  var ze = (H - N) / Pe;
                  KC(y4, rt2, et, xt, ze, AI), KC(_, ft, Jt, It, ze, EI), n2.bezierCurveTo(AI[1], EI[1], AI[2], EI[2], AI[3], EI[3]);
                  break e;
                }
                N += Pe;
              }
              n2.bezierCurveTo(rt2, ft, et, Jt, xt, It), y4 = xt, _ = It;
              break;
            }
            case du.Q: {
              var rt2 = o[le++], ft = o[le++], et = o[le++], Jt = o[le++];
              if (E) {
                var Pe = T[V++];
                if (N + Pe > H) {
                  var ze = (H - N) / Pe;
                  o8(y4, rt2, et, ze, AI), o8(_, ft, Jt, ze, EI), n2.quadraticCurveTo(AI[1], EI[1], AI[2], EI[2]);
                  break e;
                }
                N += Pe;
              }
              n2.quadraticCurveTo(rt2, ft, et, Jt), y4 = et, _ = Jt;
              break;
            }
            case du.A:
              var Wt = o[le++], sn = o[le++], vn = o[le++], $r = o[le++], ga = o[le++], Za = o[le++], $a = o[le++], Pa = !o[le++], da = vn > $r ? vn : $r, Ra = r2(vn - $r) > 1e-3, Wa = ga + Za, wa = false;
              if (E) {
                var Pe = T[V++];
                N + Pe > H && (Wa = ga + Za * (H - N) / Pe, wa = true), N += Pe;
              }
              if (Ra && n2.ellipse ? n2.ellipse(Wt, sn, vn, $r, $a, ga, Wa, Pa) : n2.arc(Wt, sn, da, ga, Wa, Pa), wa)
                break e;
              ye && (p4 = II(ga) * vn + Wt, g4 = TI(ga) * $r + sn), y4 = II(Wa) * vn + Wt, _ = TI(Wa) * $r + sn;
              break;
            case du.R:
              p4 = y4 = o[le], g4 = _ = o[le + 1], w4 = o[le++], C = o[le++];
              var li = o[le++], Ts = o[le++];
              if (E) {
                var Pe = T[V++];
                if (N + Pe > H) {
                  var wi = H - N;
                  n2.moveTo(w4, C), n2.lineTo(w4 + gre(wi, li), C), wi -= li, wi > 0 && n2.lineTo(w4 + li, C + gre(wi, Ts)), wi -= Ts, wi > 0 && n2.lineTo(w4 + mre(li - wi, 0), C + Ts), wi -= li, wi > 0 && n2.lineTo(w4, C + mre(Ts - wi, 0));
                  break e;
                }
                N += Pe;
              }
              n2.rect(w4, C, li, Ts);
              break;
            case du.Z:
              if (E) {
                var Pe = T[V++];
                if (N + Pe > H) {
                  var ze = (H - N) / Pe;
                  n2.lineTo(y4 * (1 - ze) + p4 * ze, _ * (1 - ze) + g4 * ze);
                  break e;
                }
                N += Pe;
              }
              n2.closePath(), y4 = p4, _ = g4;
          }
        }
    }, i.prototype.clone = function() {
      var n2 = new i(), e2 = this.data;
      return n2.data = e2.slice ? e2.slice() : Array.prototype.slice.call(e2), n2._len = this._len, n2;
    }, i.CMD = du, i.initDefaultProps = function() {
      var n2 = i.prototype;
      n2._saveData = true, n2._ux = 0, n2._uy = 0, n2._pendingPtDist = 0, n2._version = 0;
    }(), i;
  }(), K_ = ilt;
  function LC(i, n2, e2, o, l4, c4, h) {
    if (l4 === 0)
      return false;
    var p4 = l4, g4 = 0, y4 = i;
    if (h > n2 + p4 && h > o + p4 || h < n2 - p4 && h < o - p4 || c4 > i + p4 && c4 > e2 + p4 || c4 < i - p4 && c4 < e2 - p4)
      return false;
    if (i !== e2)
      g4 = (n2 - o) / (i - e2), y4 = (i * o - e2 * n2) / (i - e2);
    else
      return Math.abs(c4 - i) <= p4 / 2;
    var _ = g4 * c4 - h + y4, w4 = _ * _ / (g4 * g4 + 1);
    return w4 <= p4 / 2 * p4 / 2;
  }
  function olt(i, n2, e2, o, l4, c4, h, p4, g4, y4, _) {
    if (g4 === 0)
      return false;
    var w4 = g4;
    if (_ > n2 + w4 && _ > o + w4 && _ > c4 + w4 && _ > p4 + w4 || _ < n2 - w4 && _ < o - w4 && _ < c4 - w4 && _ < p4 - w4 || y4 > i + w4 && y4 > e2 + w4 && y4 > l4 + w4 && y4 > h + w4 || y4 < i - w4 && y4 < e2 - w4 && y4 < l4 - w4 && y4 < h - w4)
      return false;
    var C = DIe(i, n2, e2, o, l4, c4, h, p4, y4, _, null);
    return C <= w4 / 2;
  }
  function hTe(i, n2, e2, o, l4, c4, h, p4, g4) {
    if (h === 0)
      return false;
    var y4 = h;
    if (g4 > n2 + y4 && g4 > o + y4 && g4 > c4 + y4 || g4 < n2 - y4 && g4 < o - y4 && g4 < c4 - y4 || p4 > i + y4 && p4 > e2 + y4 && p4 > l4 + y4 || p4 < i - y4 && p4 < e2 - y4 && p4 < l4 - y4)
      return false;
    var _ = PIe(i, n2, e2, o, l4, c4, p4, g4, null);
    return _ <= y4 / 2;
  }
  var ywe = Math.PI * 2;
  function jC(i) {
    return i %= ywe, i < 0 && (i += ywe), i;
  }
  var eN = Math.PI * 2;
  function slt(i, n2, e2, o, l4, c4, h, p4, g4) {
    if (h === 0)
      return false;
    var y4 = h;
    p4 -= i, g4 -= n2;
    var _ = Math.sqrt(p4 * p4 + g4 * g4);
    if (_ - y4 > e2 || _ + y4 < e2)
      return false;
    if (Math.abs(o - l4) % eN < 1e-4)
      return true;
    if (c4) {
      var w4 = o;
      o = jC(l4), l4 = jC(w4);
    } else
      o = jC(o), l4 = jC(l4);
    o > l4 && (l4 += eN);
    var C = Math.atan2(g4, p4);
    return C < 0 && (C += eN), C >= o && C <= l4 || C + eN >= o && C + eN <= l4;
  }
  function l2(i, n2, e2, o, l4, c4) {
    if (c4 > n2 && c4 > o || c4 < n2 && c4 < o || o === n2)
      return 0;
    var h = (c4 - n2) / (o - n2), p4 = o < n2 ? 1 : -1;
    (h === 1 || h === 0) && (p4 = o < n2 ? 0.5 : -0.5);
    var g4 = h * (e2 - i) + i;
    return g4 === l4 ? 1 / 0 : g4 > l4 ? p4 : 0;
  }
  var CC = K_.CMD, DI = Math.PI * 2, llt = 1e-4;
  function ult(i, n2) {
    return Math.abs(i - n2) < llt;
  }
  var Yv = [-1, -1, -1], Ay = [-1, -1];
  function clt() {
    var i = Ay[0];
    Ay[0] = Ay[1], Ay[1] = i;
  }
  function flt(i, n2, e2, o, l4, c4, h, p4, g4, y4) {
    if (y4 > n2 && y4 > o && y4 > c4 && y4 > p4 || y4 < n2 && y4 < o && y4 < c4 && y4 < p4)
      return 0;
    var _ = yH(n2, o, c4, p4, y4, Yv);
    if (_ === 0)
      return 0;
    for (var w4 = 0, C = -1, E = void 0, T = void 0, O = 0; O < _; O++) {
      var N = Yv[O], V = N === 0 || N === 1 ? 0.5 : 1, H = Kh(i, e2, l4, h, N);
      H < g4 || (C < 0 && (C = TIe(n2, o, c4, p4, Ay), Ay[1] < Ay[0] && C > 1 && clt(), E = Kh(n2, o, c4, p4, Ay[0]), C > 1 && (T = Kh(n2, o, c4, p4, Ay[1]))), C === 2 ? N < Ay[0] ? w4 += E < n2 ? V : -V : N < Ay[1] ? w4 += T < E ? V : -V : w4 += p4 < T ? V : -V : N < Ay[0] ? w4 += E < n2 ? V : -V : w4 += p4 < E ? V : -V);
    }
    return w4;
  }
  function hlt(i, n2, e2, o, l4, c4, h, p4) {
    if (p4 > n2 && p4 > o && p4 > c4 || p4 < n2 && p4 < o && p4 < c4)
      return 0;
    var g4 = vot(n2, o, c4, p4, Yv);
    if (g4 === 0)
      return 0;
    var y4 = kIe(n2, o, c4);
    if (y4 >= 0 && y4 <= 1) {
      for (var _ = 0, w4 = Fd(n2, o, c4, y4), C = 0; C < g4; C++) {
        var E = Yv[C] === 0 || Yv[C] === 1 ? 0.5 : 1, T = Fd(i, e2, l4, Yv[C]);
        T < h || (Yv[C] < y4 ? _ += w4 < n2 ? E : -E : _ += c4 < w4 ? E : -E);
      }
      return _;
    } else {
      var E = Yv[0] === 0 || Yv[0] === 1 ? 0.5 : 1, T = Fd(i, e2, l4, Yv[0]);
      return T < h ? 0 : c4 < n2 ? E : -E;
    }
  }
  function dlt(i, n2, e2, o, l4, c4, h, p4) {
    if (p4 -= n2, p4 > e2 || p4 < -e2)
      return 0;
    var g4 = Math.sqrt(e2 * e2 - p4 * p4);
    Yv[0] = -g4, Yv[1] = g4;
    var y4 = Math.abs(o - l4);
    if (y4 < 1e-4)
      return 0;
    if (y4 >= DI - 1e-4) {
      o = 0, l4 = DI;
      var _ = c4 ? 1 : -1;
      return h >= Yv[0] + i && h <= Yv[1] + i ? _ : 0;
    }
    if (o > l4) {
      var w4 = o;
      o = l4, l4 = w4;
    }
    o < 0 && (o += DI, l4 += DI);
    for (var C = 0, E = 0; E < 2; E++) {
      var T = Yv[E];
      if (T + i > h) {
        var O = Math.atan2(p4, T), _ = c4 ? 1 : -1;
        O < 0 && (O = DI + O), (O >= o && O <= l4 || O + DI >= o && O + DI <= l4) && (O > Math.PI / 2 && O < Math.PI * 1.5 && (_ = -_), C += _);
      }
    }
    return C;
  }
  function dTe(i, n2, e2, o, l4) {
    for (var c4 = i.data, h = i.len(), p4 = 0, g4 = 0, y4 = 0, _ = 0, w4 = 0, C, E, T = 0; T < h; ) {
      var O = c4[T++], N = T === 1;
      switch (O === CC.M && T > 1 && (e2 || (p4 += l2(g4, y4, _, w4, o, l4))), N && (g4 = c4[T], y4 = c4[T + 1], _ = g4, w4 = y4), O) {
        case CC.M:
          _ = c4[T++], w4 = c4[T++], g4 = _, y4 = w4;
          break;
        case CC.L:
          if (e2) {
            if (LC(g4, y4, c4[T], c4[T + 1], n2, o, l4))
              return true;
          } else
            p4 += l2(g4, y4, c4[T], c4[T + 1], o, l4) || 0;
          g4 = c4[T++], y4 = c4[T++];
          break;
        case CC.C:
          if (e2) {
            if (olt(g4, y4, c4[T++], c4[T++], c4[T++], c4[T++], c4[T], c4[T + 1], n2, o, l4))
              return true;
          } else
            p4 += flt(g4, y4, c4[T++], c4[T++], c4[T++], c4[T++], c4[T], c4[T + 1], o, l4) || 0;
          g4 = c4[T++], y4 = c4[T++];
          break;
        case CC.Q:
          if (e2) {
            if (hTe(g4, y4, c4[T++], c4[T++], c4[T], c4[T + 1], n2, o, l4))
              return true;
          } else
            p4 += hlt(g4, y4, c4[T++], c4[T++], c4[T], c4[T + 1], o, l4) || 0;
          g4 = c4[T++], y4 = c4[T++];
          break;
        case CC.A:
          var V = c4[T++], H = c4[T++], X = c4[T++], q2 = c4[T++], de = c4[T++], le = c4[T++];
          T += 1;
          var me = !!(1 - c4[T++]);
          C = Math.cos(de) * X + V, E = Math.sin(de) * q2 + H, N ? (_ = C, w4 = E) : p4 += l2(g4, y4, C, E, o, l4);
          var ye = (o - V) * q2 / X + V;
          if (e2) {
            if (slt(V, H, q2, de, de + le, me, n2, ye, l4))
              return true;
          } else
            p4 += dlt(V, H, q2, de, de + le, me, ye, l4);
          g4 = Math.cos(de + le) * X + V, y4 = Math.sin(de + le) * q2 + H;
          break;
        case CC.R:
          _ = g4 = c4[T++], w4 = y4 = c4[T++];
          var be = c4[T++], we = c4[T++];
          if (C = _ + be, E = w4 + we, e2) {
            if (LC(_, w4, C, w4, n2, o, l4) || LC(C, w4, C, E, n2, o, l4) || LC(C, E, _, E, n2, o, l4) || LC(_, E, _, w4, n2, o, l4))
              return true;
          } else
            p4 += l2(C, w4, C, E, o, l4), p4 += l2(_, E, _, w4, o, l4);
          break;
        case CC.Z:
          if (e2) {
            if (LC(g4, y4, _, w4, n2, o, l4))
              return true;
          } else
            p4 += l2(g4, y4, _, w4, o, l4);
          g4 = _, y4 = w4;
          break;
      }
    }
    return !e2 && !ult(y4, w4) && (p4 += l2(g4, y4, _, w4, o, l4) || 0), p4 !== 0;
  }
  function plt(i, n2, e2) {
    return dTe(i, 0, false, n2, e2);
  }
  function vlt(i, n2, e2, o) {
    return dTe(i, n2, true, e2, o);
  }
  var MH = hi({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, uT), glt = { style: hi({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, S$.style) }, _re = Z_.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), mlt = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.update = function() {
      var e2 = this;
      i.prototype.update.call(this);
      var o = this.style;
      if (o.decal) {
        var l4 = this._decalEl = this._decalEl || new n2();
        l4.buildPath === n2.prototype.buildPath && (l4.buildPath = function(g4) {
          e2.buildPath(g4, e2.shape);
        }), l4.silent = true;
        var c4 = l4.style;
        for (var h in o)
          c4[h] !== o[h] && (c4[h] = o[h]);
        c4.fill = o.fill ? o.decal : null, c4.decal = null, c4.shadowColor = null, o.strokeFirst && (c4.stroke = null);
        for (var p4 = 0; p4 < _re.length; ++p4)
          l4[_re[p4]] = this[_re[p4]];
        l4.__dirty |= em;
      } else
        this._decalEl && (this._decalEl = null);
    }, n2.prototype.getDecalElement = function() {
      return this._decalEl;
    }, n2.prototype._init = function(e2) {
      var o = ts(e2);
      this.shape = this.getDefaultShape();
      var l4 = this.getDefaultStyle();
      l4 && this.useStyle(l4);
      for (var c4 = 0; c4 < o.length; c4++) {
        var h = o[c4], p4 = e2[h];
        h === "style" ? this.style ? rr(this.style, p4) : this.useStyle(p4) : h === "shape" ? rr(this.shape, p4) : i.prototype.attrKV.call(this, h, p4);
      }
      this.style || this.useStyle({});
    }, n2.prototype.getDefaultStyle = function() {
      return null;
    }, n2.prototype.getDefaultShape = function() {
      return {};
    }, n2.prototype.canBeInsideText = function() {
      return this.hasFill();
    }, n2.prototype.getInsideTextFill = function() {
      var e2 = this.style.fill;
      if (e2 !== "none") {
        if (xa(e2)) {
          var o = _H(e2, 0);
          return o > 0.5 ? Wie : o > 0.2 ? Zot : Hie;
        } else if (e2)
          return Hie;
      }
      return Wie;
    }, n2.prototype.getInsideTextStroke = function(e2) {
      var o = this.style.fill;
      if (xa(o)) {
        var l4 = this.__zr, c4 = !!(l4 && l4.isDarkMode()), h = _H(e2, 0) < Gie;
        if (c4 === h)
          return o;
      }
    }, n2.prototype.buildPath = function(e2, o, l4) {
    }, n2.prototype.pathUpdated = function() {
      this.__dirty &= ~h3;
    }, n2.prototype.getUpdatedPathProxy = function(e2) {
      return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, e2), this.path;
    }, n2.prototype.createPathProxy = function() {
      this.path = new K_(false);
    }, n2.prototype.hasStroke = function() {
      var e2 = this.style, o = e2.stroke;
      return !(o == null || o === "none" || !(e2.lineWidth > 0));
    }, n2.prototype.hasFill = function() {
      var e2 = this.style, o = e2.fill;
      return o != null && o !== "none";
    }, n2.prototype.getBoundingRect = function() {
      var e2 = this._rect, o = this.style, l4 = !e2;
      if (l4) {
        var c4 = false;
        this.path || (c4 = true, this.createPathProxy());
        var h = this.path;
        (c4 || this.__dirty & h3) && (h.beginPath(), this.buildPath(h, this.shape, false), this.pathUpdated()), e2 = h.getBoundingRect();
      }
      if (this._rect = e2, this.hasStroke() && this.path && this.path.len() > 0) {
        var p4 = this._rectStroke || (this._rectStroke = e2.clone());
        if (this.__dirty || l4) {
          p4.copy(e2);
          var g4 = o.strokeNoScale ? this.getLineScale() : 1, y4 = o.lineWidth;
          if (!this.hasFill()) {
            var _ = this.strokeContainThreshold;
            y4 = Math.max(y4, _ == null ? 4 : _);
          }
          g4 > 1e-10 && (p4.width += y4 / g4, p4.height += y4 / g4, p4.x -= y4 / g4 / 2, p4.y -= y4 / g4 / 2);
        }
        return p4;
      }
      return e2;
    }, n2.prototype.contain = function(e2, o) {
      var l4 = this.transformCoordToLocal(e2, o), c4 = this.getBoundingRect(), h = this.style;
      if (e2 = l4[0], o = l4[1], c4.contain(e2, o)) {
        var p4 = this.path;
        if (this.hasStroke()) {
          var g4 = h.lineWidth, y4 = h.strokeNoScale ? this.getLineScale() : 1;
          if (y4 > 1e-10 && (this.hasFill() || (g4 = Math.max(g4, this.strokeContainThreshold)), vlt(p4, g4 / y4, e2, o)))
            return true;
        }
        if (this.hasFill())
          return plt(p4, e2, o);
      }
      return false;
    }, n2.prototype.dirtyShape = function() {
      this.__dirty |= h3, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
    }, n2.prototype.dirty = function() {
      this.dirtyStyle(), this.dirtyShape();
    }, n2.prototype.animateShape = function(e2) {
      return this.animate("shape", e2);
    }, n2.prototype.updateDuringAnimation = function(e2) {
      e2 === "style" ? this.dirtyStyle() : e2 === "shape" ? this.dirtyShape() : this.markRedraw();
    }, n2.prototype.attrKV = function(e2, o) {
      e2 === "shape" ? this.setShape(o) : i.prototype.attrKV.call(this, e2, o);
    }, n2.prototype.setShape = function(e2, o) {
      var l4 = this.shape;
      return l4 || (l4 = this.shape = {}), typeof e2 == "string" ? l4[e2] = o : rr(l4, e2), this.dirtyShape(), this;
    }, n2.prototype.shapeChanged = function() {
      return !!(this.__dirty & h3);
    }, n2.prototype.createStyle = function(e2) {
      return m$(MH, e2);
    }, n2.prototype._innerSaveToNormal = function(e2) {
      i.prototype._innerSaveToNormal.call(this, e2);
      var o = this._normalState;
      e2.shape && !o.shape && (o.shape = rr({}, this.shape));
    }, n2.prototype._applyStateObj = function(e2, o, l4, c4, h, p4) {
      i.prototype._applyStateObj.call(this, e2, o, l4, c4, h, p4);
      var g4 = !(o && c4), y4;
      if (o && o.shape ? h ? c4 ? y4 = o.shape : (y4 = rr({}, l4.shape), rr(y4, o.shape)) : (y4 = rr({}, c4 ? this.shape : l4.shape), rr(y4, o.shape)) : g4 && (y4 = l4.shape), y4)
        if (h) {
          this.shape = rr({}, this.shape);
          for (var _ = {}, w4 = ts(y4), C = 0; C < w4.length; C++) {
            var E = w4[C];
            typeof y4[E] == "object" ? this.shape[E] = y4[E] : _[E] = y4[E];
          }
          this._transitionState(e2, { shape: _ }, p4);
        } else
          this.shape = y4, this.dirtyShape();
    }, n2.prototype._mergeStates = function(e2) {
      for (var o = i.prototype._mergeStates.call(this, e2), l4, c4 = 0; c4 < e2.length; c4++) {
        var h = e2[c4];
        h.shape && (l4 = l4 || {}, this._mergeStyle(l4, h.shape));
      }
      return l4 && (o.shape = l4), o;
    }, n2.prototype.getAnimationStyleProps = function() {
      return glt;
    }, n2.prototype.isZeroArea = function() {
      return false;
    }, n2.extend = function(e2) {
      var o = function(c4) {
        on(h, c4);
        function h(p4) {
          var g4 = c4.call(this, p4) || this;
          return e2.init && e2.init.call(g4, p4), g4;
        }
        return h.prototype.getDefaultStyle = function() {
          return Ci(e2.style);
        }, h.prototype.getDefaultShape = function() {
          return Ci(e2.shape);
        }, h;
      }(n2);
      for (var l4 in e2)
        typeof e2[l4] == "function" && (o.prototype[l4] = e2[l4]);
      return o;
    }, n2.initDefaultProps = function() {
      var e2 = n2.prototype;
      e2.type = "path", e2.strokeContainThreshold = 5, e2.segmentIgnoreThreshold = 0, e2.subPixelOptimize = false, e2.autoBatch = false, e2.__dirty = em | AN | h3;
    }(), n2;
  }(Vy), Eo = mlt, ylt = hi({ strokeFirst: true, font: XC, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, MH), pTe = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.hasStroke = function() {
      var e2 = this.style, o = e2.stroke;
      return o != null && o !== "none" && e2.lineWidth > 0;
    }, n2.prototype.hasFill = function() {
      var e2 = this.style, o = e2.fill;
      return o != null && o !== "none";
    }, n2.prototype.createStyle = function(e2) {
      return m$(ylt, e2);
    }, n2.prototype.setBoundingRect = function(e2) {
      this._rect = e2;
    }, n2.prototype.getBoundingRect = function() {
      var e2 = this.style;
      if (!this._rect) {
        var o = e2.text;
        o != null ? o += "" : o = "";
        var l4 = N8(o, e2.font, e2.textAlign, e2.textBaseline);
        if (l4.x += e2.x || 0, l4.y += e2.y || 0, this.hasStroke()) {
          var c4 = e2.lineWidth;
          l4.x -= c4 / 2, l4.y -= c4 / 2, l4.width += c4, l4.height += c4;
        }
        this._rect = l4;
      }
      return this._rect;
    }, n2.initDefaultProps = function() {
      var e2 = n2.prototype;
      e2.dirtyRectTolerance = 10;
    }(), n2;
  }(Vy);
  pTe.prototype.type = "tspan";
  var u8 = pTe, blt = hi({ x: 0, y: 0 }, uT), _lt = { style: hi({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, S$.style) };
  function xlt(i) {
    return !!(i && typeof i != "string" && i.width && i.height);
  }
  var vTe = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.createStyle = function(e2) {
      return m$(blt, e2);
    }, n2.prototype._getSize = function(e2) {
      var o = this.style, l4 = o[e2];
      if (l4 != null)
        return l4;
      var c4 = xlt(o.image) ? o.image : this.__image;
      if (!c4)
        return 0;
      var h = e2 === "width" ? "height" : "width", p4 = o[h];
      return p4 == null ? c4[e2] : c4[e2] / c4[h] * p4;
    }, n2.prototype.getWidth = function() {
      return this._getSize("width");
    }, n2.prototype.getHeight = function() {
      return this._getSize("height");
    }, n2.prototype.getAnimationStyleProps = function() {
      return _lt;
    }, n2.prototype.getBoundingRect = function() {
      var e2 = this.style;
      return this._rect || (this._rect = new mo(e2.x || 0, e2.y || 0, this.getWidth(), this.getHeight())), this._rect;
    }, n2;
  }(Vy);
  vTe.prototype.type = "image";
  var Ap = vTe;
  function wlt(i, n2) {
    var e2 = n2.x, o = n2.y, l4 = n2.width, c4 = n2.height, h = n2.r, p4, g4, y4, _;
    l4 < 0 && (e2 = e2 + l4, l4 = -l4), c4 < 0 && (o = o + c4, c4 = -c4), typeof h == "number" ? p4 = g4 = y4 = _ = h : h instanceof Array ? h.length === 1 ? p4 = g4 = y4 = _ = h[0] : h.length === 2 ? (p4 = y4 = h[0], g4 = _ = h[1]) : h.length === 3 ? (p4 = h[0], g4 = _ = h[1], y4 = h[2]) : (p4 = h[0], g4 = h[1], y4 = h[2], _ = h[3]) : p4 = g4 = y4 = _ = 0;
    var w4;
    p4 + g4 > l4 && (w4 = p4 + g4, p4 *= l4 / w4, g4 *= l4 / w4), y4 + _ > l4 && (w4 = y4 + _, y4 *= l4 / w4, _ *= l4 / w4), g4 + y4 > c4 && (w4 = g4 + y4, g4 *= c4 / w4, y4 *= c4 / w4), p4 + _ > c4 && (w4 = p4 + _, p4 *= c4 / w4, _ *= c4 / w4), i.moveTo(e2 + p4, o), i.lineTo(e2 + l4 - g4, o), g4 !== 0 && i.arc(e2 + l4 - g4, o + g4, g4, -Math.PI / 2, 0), i.lineTo(e2 + l4, o + c4 - y4), y4 !== 0 && i.arc(e2 + l4 - y4, o + c4 - y4, y4, 0, Math.PI / 2), i.lineTo(e2 + _, o + c4), _ !== 0 && i.arc(e2 + _, o + c4 - _, _, Math.PI / 2, Math.PI), i.lineTo(e2, o + p4), p4 !== 0 && i.arc(e2 + p4, o + p4, p4, Math.PI, Math.PI * 1.5);
  }
  var b3 = Math.round;
  function gTe(i, n2, e2) {
    if (!!n2) {
      var o = n2.x1, l4 = n2.x2, c4 = n2.y1, h = n2.y2;
      i.x1 = o, i.x2 = l4, i.y1 = c4, i.y2 = h;
      var p4 = e2 && e2.lineWidth;
      return p4 && (b3(o * 2) === b3(l4 * 2) && (i.x1 = i.x2 = rT(o, p4, true)), b3(c4 * 2) === b3(h * 2) && (i.y1 = i.y2 = rT(c4, p4, true))), i;
    }
  }
  function mTe(i, n2, e2) {
    if (!!n2) {
      var o = n2.x, l4 = n2.y, c4 = n2.width, h = n2.height;
      i.x = o, i.y = l4, i.width = c4, i.height = h;
      var p4 = e2 && e2.lineWidth;
      return p4 && (i.x = rT(o, p4, true), i.y = rT(l4, p4, true), i.width = Math.max(rT(o + c4, p4, false) - i.x, c4 === 0 ? 0 : 1), i.height = Math.max(rT(l4 + h, p4, false) - i.y, h === 0 ? 0 : 1)), i;
    }
  }
  function rT(i, n2, e2) {
    if (!n2)
      return i;
    var o = b3(i * 2);
    return (o + b3(n2)) % 2 === 0 ? o / 2 : (o + (e2 ? 1 : -1)) / 2;
  }
  var Slt = function() {
    function i() {
      this.x = 0, this.y = 0, this.width = 0, this.height = 0;
    }
    return i;
  }(), Clt = {}, yTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new Slt();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4, c4, h, p4;
      if (this.subPixelOptimize) {
        var g4 = mTe(Clt, o, this.style);
        l4 = g4.x, c4 = g4.y, h = g4.width, p4 = g4.height, g4.r = o.r, o = g4;
      } else
        l4 = o.x, c4 = o.y, h = o.width, p4 = o.height;
      o.r ? wlt(e2, o) : e2.rect(l4, c4, h, p4);
    }, n2.prototype.isZeroArea = function() {
      return !this.shape.width || !this.shape.height;
    }, n2;
  }(Eo);
  yTe.prototype.type = "rect";
  var Is = yTe, bwe = { fill: "#000" }, _we = 2, Mlt = { style: hi({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, S$.style) }, bTe = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this) || this;
      return o.type = "text", o._children = [], o._defaultStyle = bwe, o.attr(e2), o;
    }
    return n2.prototype.childrenRef = function() {
      return this._children;
    }, n2.prototype.update = function() {
      i.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
      for (var e2 = 0; e2 < this._children.length; e2++) {
        var o = this._children[e2];
        o.zlevel = this.zlevel, o.z = this.z, o.z2 = this.z2, o.culling = this.culling, o.cursor = this.cursor, o.invisible = this.invisible;
      }
    }, n2.prototype.updateTransform = function() {
      var e2 = this.innerTransformable;
      e2 ? (e2.updateTransform(), e2.transform && (this.transform = e2.transform)) : i.prototype.updateTransform.call(this);
    }, n2.prototype.getLocalTransform = function(e2) {
      var o = this.innerTransformable;
      return o ? o.getLocalTransform(e2) : i.prototype.getLocalTransform.call(this, e2);
    }, n2.prototype.getComputedTransform = function() {
      return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), i.prototype.getComputedTransform.call(this);
    }, n2.prototype._updateSubTexts = function() {
      this._childCursor = 0, Ilt(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
    }, n2.prototype.addSelfToZr = function(e2) {
      i.prototype.addSelfToZr.call(this, e2);
      for (var o = 0; o < this._children.length; o++)
        this._children[o].__zr = e2;
    }, n2.prototype.removeSelfFromZr = function(e2) {
      i.prototype.removeSelfFromZr.call(this, e2);
      for (var o = 0; o < this._children.length; o++)
        this._children[o].__zr = null;
    }, n2.prototype.getBoundingRect = function() {
      if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
        for (var e2 = new mo(0, 0, 0, 0), o = this._children, l4 = [], c4 = null, h = 0; h < o.length; h++) {
          var p4 = o[h], g4 = p4.getBoundingRect(), y4 = p4.getLocalTransform(l4);
          y4 ? (e2.copy(g4), e2.applyTransform(y4), c4 = c4 || e2.clone(), c4.union(e2)) : (c4 = c4 || g4.clone(), c4.union(g4));
        }
        this._rect = c4 || e2;
      }
      return this._rect;
    }, n2.prototype.setDefaultTextStyle = function(e2) {
      this._defaultStyle = e2 || bwe;
    }, n2.prototype.setTextContent = function(e2) {
    }, n2.prototype._mergeStyle = function(e2, o) {
      if (!o)
        return e2;
      var l4 = o.rich, c4 = e2.rich || l4 && {};
      return rr(e2, o), l4 && c4 ? (this._mergeRich(c4, l4), e2.rich = c4) : c4 && (e2.rich = c4), e2;
    }, n2.prototype._mergeRich = function(e2, o) {
      for (var l4 = ts(o), c4 = 0; c4 < l4.length; c4++) {
        var h = l4[c4];
        e2[h] = e2[h] || {}, rr(e2[h], o[h]);
      }
    }, n2.prototype.getAnimationStyleProps = function() {
      return Mlt;
    }, n2.prototype._getOrCreateChild = function(e2) {
      var o = this._children[this._childCursor];
      return (!o || !(o instanceof e2)) && (o = new e2()), this._children[this._childCursor++] = o, o.__zr = this.__zr, o.parent = this, o;
    }, n2.prototype._updatePlainTexts = function() {
      var e2 = this.style, o = e2.font || XC, l4 = e2.padding, c4 = Ewe(e2), h = $st(c4, e2), p4 = xre(e2), g4 = !!e2.backgroundColor, y4 = h.outerHeight, _ = h.outerWidth, w4 = h.contentWidth, C = h.lines, E = h.lineHeight, T = this._defaultStyle, O = e2.x || 0, N = e2.y || 0, V = e2.align || T.align || "left", H = e2.verticalAlign || T.verticalAlign || "top", X = O, q2 = d3(N, h.contentHeight, H);
      if (p4 || l4) {
        var de = IN(O, _, V), le = d3(N, y4, H);
        p4 && this._renderBackground(e2, e2, de, le, _, y4);
      }
      q2 += E / 2, l4 && (X = Awe(O, V, l4), H === "top" ? q2 += l4[0] : H === "bottom" && (q2 -= l4[2]));
      for (var me = 0, ye = false, be = Mwe("fill" in e2 ? e2.fill : (ye = true, T.fill)), we = Cwe("stroke" in e2 ? e2.stroke : !g4 && (!T.autoStroke || ye) ? (me = _we, T.stroke) : null), Pe = e2.textShadowBlur > 0, ze = e2.width != null && (e2.overflow === "truncate" || e2.overflow === "break" || e2.overflow === "breakAll"), Re = h.calculatedLineHeight, rt2 = 0; rt2 < C.length; rt2++) {
        var ft = this._getOrCreateChild(u8), et = ft.createStyle();
        ft.useStyle(et), et.text = C[rt2], et.x = X, et.y = q2, V && (et.textAlign = V), et.textBaseline = "middle", et.opacity = e2.opacity, et.strokeFirst = true, Pe && (et.shadowBlur = e2.textShadowBlur || 0, et.shadowColor = e2.textShadowColor || "transparent", et.shadowOffsetX = e2.textShadowOffsetX || 0, et.shadowOffsetY = e2.textShadowOffsetY || 0), et.stroke = we, et.fill = be, we && (et.lineWidth = e2.lineWidth || me, et.lineDash = e2.lineDash, et.lineDashOffset = e2.lineDashOffset || 0), et.font = o, wwe(et, e2), q2 += E, ze && ft.setBoundingRect(new mo(IN(et.x, e2.width, et.textAlign), d3(et.y, Re, et.textBaseline), w4, Re));
      }
    }, n2.prototype._updateRichTexts = function() {
      var e2 = this.style, o = Ewe(e2), l4 = Yst(o, e2), c4 = l4.width, h = l4.outerWidth, p4 = l4.outerHeight, g4 = e2.padding, y4 = e2.x || 0, _ = e2.y || 0, w4 = this._defaultStyle, C = e2.align || w4.align, E = e2.verticalAlign || w4.verticalAlign, T = IN(y4, h, C), O = d3(_, p4, E), N = T, V = O;
      g4 && (N += g4[3], V += g4[0]);
      var H = N + c4;
      xre(e2) && this._renderBackground(e2, e2, T, O, h, p4);
      for (var X = !!e2.backgroundColor, q2 = 0; q2 < l4.lines.length; q2++) {
        for (var de = l4.lines[q2], le = de.tokens, me = le.length, ye = de.lineHeight, be = de.width, we = 0, Pe = N, ze = H, Re = me - 1, rt2 = void 0; we < me && (rt2 = le[we], !rt2.align || rt2.align === "left"); )
          this._placeToken(rt2, e2, ye, V, Pe, "left", X), be -= rt2.width, Pe += rt2.width, we++;
        for (; Re >= 0 && (rt2 = le[Re], rt2.align === "right"); )
          this._placeToken(rt2, e2, ye, V, ze, "right", X), be -= rt2.width, ze -= rt2.width, Re--;
        for (Pe += (c4 - (Pe - N) - (H - ze) - be) / 2; we <= Re; )
          rt2 = le[we], this._placeToken(rt2, e2, ye, V, Pe + rt2.width / 2, "center", X), Pe += rt2.width, we++;
        V += ye;
      }
    }, n2.prototype._placeToken = function(e2, o, l4, c4, h, p4, g4) {
      var y4 = o.rich[e2.styleName] || {};
      y4.text = e2.text;
      var _ = e2.verticalAlign, w4 = c4 + l4 / 2;
      _ === "top" ? w4 = c4 + e2.height / 2 : _ === "bottom" && (w4 = c4 + l4 - e2.height / 2);
      var C = !e2.isLineHolder && xre(y4);
      C && this._renderBackground(y4, o, p4 === "right" ? h - e2.width : p4 === "center" ? h - e2.width / 2 : h, w4 - e2.height / 2, e2.width, e2.height);
      var E = !!y4.backgroundColor, T = e2.textPadding;
      T && (h = Awe(h, p4, T), w4 -= e2.height / 2 - T[0] - e2.innerHeight / 2);
      var O = this._getOrCreateChild(u8), N = O.createStyle();
      O.useStyle(N);
      var V = this._defaultStyle, H = false, X = 0, q2 = Mwe("fill" in y4 ? y4.fill : "fill" in o ? o.fill : (H = true, V.fill)), de = Cwe("stroke" in y4 ? y4.stroke : "stroke" in o ? o.stroke : !E && !g4 && (!V.autoStroke || H) ? (X = _we, V.stroke) : null), le = y4.textShadowBlur > 0 || o.textShadowBlur > 0;
      N.text = e2.text, N.x = h, N.y = w4, le && (N.shadowBlur = y4.textShadowBlur || o.textShadowBlur || 0, N.shadowColor = y4.textShadowColor || o.textShadowColor || "transparent", N.shadowOffsetX = y4.textShadowOffsetX || o.textShadowOffsetX || 0, N.shadowOffsetY = y4.textShadowOffsetY || o.textShadowOffsetY || 0), N.textAlign = p4, N.textBaseline = "middle", N.font = e2.font || XC, N.opacity = f2(y4.opacity, o.opacity, 1), wwe(N, y4), de && (N.lineWidth = f2(y4.lineWidth, o.lineWidth, X), N.lineDash = so(y4.lineDash, o.lineDash), N.lineDashOffset = o.lineDashOffset || 0, N.stroke = de), q2 && (N.fill = q2);
      var me = e2.contentWidth, ye = e2.contentHeight;
      O.setBoundingRect(new mo(IN(N.x, me, N.textAlign), d3(N.y, ye, N.textBaseline), me, ye));
    }, n2.prototype._renderBackground = function(e2, o, l4, c4, h, p4) {
      var g4 = e2.backgroundColor, y4 = e2.borderWidth, _ = e2.borderColor, w4 = g4 && g4.image, C = g4 && !w4, E = e2.borderRadius, T = this, O, N;
      if (C || e2.lineHeight || y4 && _) {
        O = this._getOrCreateChild(Is), O.useStyle(O.createStyle()), O.style.fill = null;
        var V = O.shape;
        V.x = l4, V.y = c4, V.width = h, V.height = p4, V.r = E, O.dirtyShape();
      }
      if (C) {
        var H = O.style;
        H.fill = g4 || null, H.fillOpacity = so(e2.fillOpacity, 1);
      } else if (w4) {
        N = this._getOrCreateChild(Ap), N.onload = function() {
          T.dirtyStyle();
        };
        var X = N.style;
        X.image = g4.image, X.x = l4, X.y = c4, X.width = h, X.height = p4;
      }
      if (y4 && _) {
        var H = O.style;
        H.lineWidth = y4, H.stroke = _, H.strokeOpacity = so(e2.strokeOpacity, 1), H.lineDash = e2.borderDash, H.lineDashOffset = e2.borderDashOffset || 0, O.strokeContainThreshold = 0, O.hasFill() && O.hasStroke() && (H.strokeFirst = true, H.lineWidth *= 2);
      }
      var q2 = (O || N).style;
      q2.shadowBlur = e2.shadowBlur || 0, q2.shadowColor = e2.shadowColor || "transparent", q2.shadowOffsetX = e2.shadowOffsetX || 0, q2.shadowOffsetY = e2.shadowOffsetY || 0, q2.opacity = f2(e2.opacity, o.opacity, 1);
    }, n2.makeFont = function(e2) {
      var o = "";
      return xTe(e2) && (o = [e2.fontStyle, e2.fontWeight, _Te(e2.fontSize), e2.fontFamily || "sans-serif"].join(" ")), o && tb(o) || e2.textFont || e2.font;
    }, n2;
  }(Vy), Alt = { left: true, right: 1, center: 1 }, Elt = { top: 1, bottom: 1, middle: 1 }, xwe = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
  function _Te(i) {
    return typeof i == "string" && (i.indexOf("px") !== -1 || i.indexOf("rem") !== -1 || i.indexOf("em") !== -1) ? i : isNaN(+i) ? Ase + "px" : i + "px";
  }
  function wwe(i, n2) {
    for (var e2 = 0; e2 < xwe.length; e2++) {
      var o = xwe[e2], l4 = n2[o];
      l4 != null && (i[o] = l4);
    }
  }
  function xTe(i) {
    return i.fontSize != null || i.fontFamily || i.fontWeight;
  }
  function Ilt(i) {
    return Swe(i), Ve(i.rich, Swe), i;
  }
  function Swe(i) {
    if (i) {
      i.font = bTe.makeFont(i);
      var n2 = i.align;
      n2 === "middle" && (n2 = "center"), i.align = n2 == null || Alt[n2] ? n2 : "left";
      var e2 = i.verticalAlign;
      e2 === "center" && (e2 = "middle"), i.verticalAlign = e2 == null || Elt[e2] ? e2 : "top";
      var o = i.padding;
      o && (i.padding = Pse(i.padding));
    }
  }
  function Cwe(i, n2) {
    return i == null || n2 <= 0 || i === "transparent" || i === "none" ? null : i.image || i.colorStops ? "#000" : i;
  }
  function Mwe(i) {
    return i == null || i === "none" ? null : i.image || i.colorStops ? "#000" : i;
  }
  function Awe(i, n2, e2) {
    return n2 === "right" ? i - e2[1] : n2 === "center" ? i + e2[3] / 2 - e2[1] / 2 : i + e2[3];
  }
  function Ewe(i) {
    var n2 = i.text;
    return n2 != null && (n2 += ""), n2;
  }
  function xre(i) {
    return !!(i.backgroundColor || i.lineHeight || i.borderWidth && i.borderColor);
  }
  var Qs = bTe, Fi = zs(), Zie = function(i, n2, e2, o) {
    if (o) {
      var l4 = Fi(o);
      l4.dataIndex = e2, l4.dataType = n2, l4.seriesIndex = i, o.type === "group" && o.traverse(function(c4) {
        var h = Fi(c4);
        h.seriesIndex = i, h.dataIndex = e2, h.dataType = n2;
      });
    }
  }, Iwe = 1, Twe = {}, wTe = zs(), Hse = zs(), $se = 0, z8 = 1, M$ = 2, Jv = ["emphasis", "blur", "select"], c8 = ["normal", "emphasis", "blur", "select"], $3 = 10, Tlt = 9, cT = "highlight", nH = "downplay", HN = "select", rH = "unselect", $N = "toggleSelect";
  function YP(i) {
    return i != null && i !== "none";
  }
  var Dwe = new F8(100);
  function kwe(i) {
    if (xa(i)) {
      var n2 = Dwe.get(i);
      return n2 || (n2 = Rie(i, -0.1), Dwe.put(i, n2)), n2;
    } else if (g$(i)) {
      var e2 = rr({}, i);
      return e2.colorStops = Er(i.colorStops, function(o) {
        return { offset: o.offset, color: Rie(o.color, -0.1) };
      }), e2;
    }
    return i;
  }
  function A$(i, n2, e2) {
    i.onHoverStateChange && (i.hoverState || 0) !== e2 && i.onHoverStateChange(n2), i.hoverState = e2;
  }
  function STe(i) {
    A$(i, "emphasis", M$);
  }
  function CTe(i) {
    i.hoverState === M$ && A$(i, "normal", $se);
  }
  function Use(i) {
    A$(i, "blur", z8);
  }
  function MTe(i) {
    i.hoverState === z8 && A$(i, "normal", $se);
  }
  function Dlt(i) {
    i.selected = true;
  }
  function klt(i) {
    i.selected = false;
  }
  function Pwe(i, n2, e2) {
    n2(i, e2);
  }
  function C2(i, n2, e2) {
    Pwe(i, n2, e2), i.isGroup && i.traverse(function(o) {
      Pwe(o, n2, e2);
    });
  }
  function AH(i, n2) {
    switch (n2) {
      case "emphasis":
        i.hoverState = M$;
        break;
      case "normal":
        i.hoverState = $se;
        break;
      case "blur":
        i.hoverState = z8;
        break;
      case "select":
        i.selected = true;
    }
  }
  function Plt(i, n2, e2, o) {
    for (var l4 = i.style, c4 = {}, h = 0; h < n2.length; h++) {
      var p4 = n2[h], g4 = l4[p4];
      c4[p4] = g4 == null ? o && o[p4] : g4;
    }
    for (var h = 0; h < i.animators.length; h++) {
      var y4 = i.animators[h];
      y4.__fromStateTransition && y4.__fromStateTransition.indexOf(e2) < 0 && y4.targetName === "style" && y4.saveTo(c4, n2);
    }
    return c4;
  }
  function Llt(i, n2, e2, o) {
    var l4 = e2 && go(e2, "select") >= 0, c4 = false;
    if (i instanceof Eo) {
      var h = wTe(i), p4 = l4 && h.selectFill || h.normalFill, g4 = l4 && h.selectStroke || h.normalStroke;
      if (YP(p4) || YP(g4)) {
        o = o || {};
        var y4 = o.style || {};
        y4.fill === "inherit" ? (c4 = true, o = rr({}, o), y4 = rr({}, y4), y4.fill = p4) : !YP(y4.fill) && YP(p4) ? (c4 = true, o = rr({}, o), y4 = rr({}, y4), y4.fill = kwe(p4)) : !YP(y4.stroke) && YP(g4) && (c4 || (o = rr({}, o), y4 = rr({}, y4)), y4.stroke = kwe(g4)), o.style = y4;
      }
    }
    if (o && o.z2 == null) {
      c4 || (o = rr({}, o));
      var _ = i.z2EmphasisLift;
      o.z2 = i.z2 + (_ != null ? _ : $3);
    }
    return o;
  }
  function Olt(i, n2, e2) {
    if (e2 && e2.z2 == null) {
      e2 = rr({}, e2);
      var o = i.z2SelectLift;
      e2.z2 = i.z2 + (o != null ? o : Tlt);
    }
    return e2;
  }
  function Rlt(i, n2, e2) {
    var o = go(i.currentStates, n2) >= 0, l4 = i.style.opacity, c4 = o ? null : Plt(i, ["opacity"], n2, { opacity: 1 });
    e2 = e2 || {};
    var h = e2.style || {};
    return h.opacity == null && (e2 = rr({}, e2), h = rr({ opacity: o ? l4 : c4.opacity * 0.1 }, h), e2.style = h), e2;
  }
  function wre(i, n2) {
    var e2 = this.states[i];
    if (this.style) {
      if (i === "emphasis")
        return Llt(this, i, n2, e2);
      if (i === "blur")
        return Rlt(this, i, e2);
      if (i === "select")
        return Olt(this, i, e2);
    }
    return e2;
  }
  function _T(i) {
    i.stateProxy = wre;
    var n2 = i.getTextContent(), e2 = i.getTextGuideLine();
    n2 && (n2.stateProxy = wre), e2 && (e2.stateProxy = wre);
  }
  function Lwe(i, n2) {
    !DTe(i, n2) && !i.__highByOuter && C2(i, STe);
  }
  function Owe(i, n2) {
    !DTe(i, n2) && !i.__highByOuter && C2(i, CTe);
  }
  function W_(i, n2) {
    i.__highByOuter |= 1 << (n2 || 0), C2(i, STe);
  }
  function H_(i, n2) {
    !(i.__highByOuter &= ~(1 << (n2 || 0))) && C2(i, CTe);
  }
  function ATe(i) {
    C2(i, Use);
  }
  function ETe(i) {
    C2(i, MTe);
  }
  function ITe(i) {
    C2(i, Dlt);
  }
  function TTe(i) {
    C2(i, klt);
  }
  function DTe(i, n2) {
    return i.__highDownSilentOnTouch && n2.zrByTouch;
  }
  function kTe(i) {
    var n2 = i.getModel();
    n2.eachComponent(function(e2, o) {
      var l4 = Hse(o);
      if (l4.isBlured) {
        var c4 = e2 === "series" ? i.getViewOfSeriesModel(o) : i.getViewOfComponentModel(o);
        c4.group.traverse(function(h) {
          MTe(h);
        });
      }
      l4.isBlured = false;
    });
  }
  function Xie(i, n2, e2, o) {
    var l4 = o.getModel();
    e2 = e2 || "coordinateSystem";
    function c4(y4, _) {
      for (var w4 = 0; w4 < _.length; w4++) {
        var C = y4.getItemGraphicEl(_[w4]);
        C && ETe(C);
      }
    }
    if (i != null && !(!n2 || n2 === "none")) {
      var h = l4.getSeriesByIndex(i), p4 = h.coordinateSystem;
      p4 && p4.master && (p4 = p4.master);
      var g4 = [];
      l4.eachSeries(function(y4) {
        var _ = h === y4, w4 = y4.coordinateSystem;
        w4 && w4.master && (w4 = w4.master);
        var C = w4 && p4 ? w4 === p4 : _;
        if (!(e2 === "series" && !_ || e2 === "coordinateSystem" && !C || n2 === "series" && _)) {
          var E = o.getViewOfSeriesModel(y4);
          if (E.group.traverse(function(N) {
            Use(N);
          }), gv(n2))
            c4(y4.getData(), n2);
          else if (mi(n2))
            for (var T = ts(n2), O = 0; O < T.length; O++)
              c4(y4.getData(T[O]), n2[T[O]]);
          g4.push(y4), Hse(y4).isBlured = true;
        }
      }), l4.eachComponent(function(y4, _) {
        if (y4 !== "series") {
          var w4 = o.getViewOfComponentModel(_);
          w4 && w4.blurSeries && w4.blurSeries(g4, l4);
        }
      });
    }
  }
  function Kie(i, n2, e2) {
    if (!(i == null || n2 == null)) {
      var o = e2.getModel().getComponent(i, n2);
      if (!!o) {
        Hse(o).isBlured = true;
        var l4 = e2.getViewOfComponentModel(o);
        !l4 || !l4.focusBlurEnabled || l4.group.traverse(function(c4) {
          Use(c4);
        });
      }
    }
  }
  function Flt(i, n2, e2) {
    var o = i.seriesIndex, l4 = i.getData(n2.dataType);
    if (!!l4) {
      var c4 = yT(l4, n2);
      c4 = (Mr(c4) ? c4[0] : c4) || 0;
      var h = l4.getItemGraphicEl(c4);
      if (!h)
        for (var p4 = l4.count(), g4 = 0; !h && g4 < p4; )
          h = l4.getItemGraphicEl(g4++);
      if (h) {
        var y4 = Fi(h);
        Xie(o, y4.focus, y4.blurScope, e2);
      } else {
        var _ = i.get(["emphasis", "focus"]), w4 = i.get(["emphasis", "blurScope"]);
        _ != null && Xie(o, _, w4, e2);
      }
    }
  }
  function qse(i, n2, e2, o) {
    var l4 = { focusSelf: false, dispatchers: null };
    if (i == null || i === "series" || n2 == null || e2 == null)
      return l4;
    var c4 = o.getModel().getComponent(i, n2);
    if (!c4)
      return l4;
    var h = o.getViewOfComponentModel(c4);
    if (!h || !h.findHighDownDispatchers)
      return l4;
    for (var p4 = h.findHighDownDispatchers(e2), g4, y4 = 0; y4 < p4.length; y4++)
      if (Fi(p4[y4]).focus === "self") {
        g4 = true;
        break;
      }
    return { focusSelf: g4, dispatchers: p4 };
  }
  function Nlt(i, n2, e2) {
    var o = Fi(i), l4 = qse(o.componentMainType, o.componentIndex, o.componentHighDownName, e2), c4 = l4.dispatchers, h = l4.focusSelf;
    c4 ? (h && Kie(o.componentMainType, o.componentIndex, e2), Ve(c4, function(p4) {
      return Lwe(p4, n2);
    })) : (Xie(o.seriesIndex, o.focus, o.blurScope, e2), o.focus === "self" && Kie(o.componentMainType, o.componentIndex, e2), Lwe(i, n2));
  }
  function Vlt(i, n2, e2) {
    kTe(e2);
    var o = Fi(i), l4 = qse(o.componentMainType, o.componentIndex, o.componentHighDownName, e2).dispatchers;
    l4 ? Ve(l4, function(c4) {
      return Owe(c4, n2);
    }) : Owe(i, n2);
  }
  function zlt(i, n2, e2) {
    if (!!Qie(n2)) {
      var o = n2.dataType, l4 = i.getData(o), c4 = yT(l4, n2);
      Mr(c4) || (c4 = [c4]), i[n2.type === $N ? "toggleSelect" : n2.type === HN ? "select" : "unselect"](c4, o);
    }
  }
  function Rwe(i) {
    var n2 = i.getAllData();
    Ve(n2, function(e2) {
      var o = e2.data, l4 = e2.type;
      o.eachItemGraphicEl(function(c4, h) {
        i.isSelected(h, l4) ? ITe(c4) : TTe(c4);
      });
    });
  }
  function Blt(i) {
    var n2 = [];
    return i.eachSeries(function(e2) {
      var o = e2.getAllData();
      Ve(o, function(l4) {
        l4.data;
        var c4 = l4.type, h = e2.getSelectedDataIndices();
        if (h.length > 0) {
          var p4 = { dataIndex: h, seriesIndex: e2.seriesIndex };
          c4 != null && (p4.dataType = c4), n2.push(p4);
        }
      });
    }), n2;
  }
  function fT(i, n2, e2) {
    aT(i, true), C2(i, _T), Jie(i, n2, e2);
  }
  function jlt(i) {
    aT(i, false);
  }
  function pf(i, n2, e2, o) {
    o ? jlt(i) : fT(i, n2, e2);
  }
  function Jie(i, n2, e2) {
    var o = Fi(i);
    n2 != null ? (o.focus = n2, o.blurScope = e2) : o.focus && (o.focus = null);
  }
  var Fwe = ["emphasis", "blur", "select"], Glt = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
  function Mp(i, n2, e2, o) {
    e2 = e2 || "itemStyle";
    for (var l4 = 0; l4 < Fwe.length; l4++) {
      var c4 = Fwe[l4], h = n2.getModel([c4, e2]), p4 = i.ensureState(c4);
      p4.style = o ? o(h) : h[Glt[e2]]();
    }
  }
  function aT(i, n2) {
    var e2 = n2 === false, o = i;
    i.highDownSilentOnTouch && (o.__highDownSilentOnTouch = i.highDownSilentOnTouch), (!e2 || o.__highDownDispatcher) && (o.__highByOuter = o.__highByOuter || 0, o.__highDownDispatcher = !e2);
  }
  function f8(i) {
    return !!(i && i.__highDownDispatcher);
  }
  function Wlt(i, n2, e2) {
    var o = Fi(i);
    o.componentMainType = n2.mainType, o.componentIndex = n2.componentIndex, o.componentHighDownName = e2;
  }
  function Hlt(i) {
    var n2 = Twe[i];
    return n2 == null && Iwe <= 32 && (n2 = Twe[i] = Iwe++), n2;
  }
  function Qie(i) {
    var n2 = i.type;
    return n2 === HN || n2 === rH || n2 === $N;
  }
  function Nwe(i) {
    var n2 = i.type;
    return n2 === cT || n2 === nH;
  }
  function $lt(i) {
    var n2 = wTe(i);
    n2.normalFill = i.style.fill, n2.normalStroke = i.style.stroke;
    var e2 = i.states.select || {};
    n2.selectFill = e2.style && e2.style.fill || null, n2.selectStroke = e2.style && e2.style.stroke || null;
  }
  var ZP = K_.CMD, Ult = [[], [], []], Vwe = Math.sqrt, qlt = Math.atan2;
  function PTe(i, n2) {
    if (!!n2) {
      var e2 = i.data, o = i.len(), l4, c4, h, p4, g4, y4, _ = ZP.M, w4 = ZP.C, C = ZP.L, E = ZP.R, T = ZP.A, O = ZP.Q;
      for (h = 0, p4 = 0; h < o; ) {
        switch (l4 = e2[h++], p4 = h, c4 = 0, l4) {
          case _:
            c4 = 1;
            break;
          case C:
            c4 = 1;
            break;
          case w4:
            c4 = 3;
            break;
          case O:
            c4 = 2;
            break;
          case T:
            var N = n2[4], V = n2[5], H = Vwe(n2[0] * n2[0] + n2[1] * n2[1]), X = Vwe(n2[2] * n2[2] + n2[3] * n2[3]), q2 = qlt(-n2[1] / X, n2[0] / H);
            e2[h] *= H, e2[h++] += N, e2[h] *= X, e2[h++] += V, e2[h++] *= H, e2[h++] *= X, e2[h++] += q2, e2[h++] += q2, h += 2, p4 = h;
            break;
          case E:
            y4[0] = e2[h++], y4[1] = e2[h++], Sp(y4, y4, n2), e2[p4++] = y4[0], e2[p4++] = y4[1], y4[0] += e2[h++], y4[1] += e2[h++], Sp(y4, y4, n2), e2[p4++] = y4[0], e2[p4++] = y4[1];
        }
        for (g4 = 0; g4 < c4; g4++) {
          var de = Ult[g4];
          de[0] = e2[h++], de[1] = e2[h++], Sp(de, de, n2), e2[p4++] = de[0], e2[p4++] = de[1];
        }
      }
      i.increaseVersion();
    }
  }
  var Sre = Math.sqrt, JG = Math.sin, QG = Math.cos, tN = Math.PI;
  function zwe(i) {
    return Math.sqrt(i[0] * i[0] + i[1] * i[1]);
  }
  function eoe(i, n2) {
    return (i[0] * n2[0] + i[1] * n2[1]) / (zwe(i) * zwe(n2));
  }
  function Bwe(i, n2) {
    return (i[0] * n2[1] < i[1] * n2[0] ? -1 : 1) * Math.acos(eoe(i, n2));
  }
  function jwe(i, n2, e2, o, l4, c4, h, p4, g4, y4, _) {
    var w4 = g4 * (tN / 180), C = QG(w4) * (i - e2) / 2 + JG(w4) * (n2 - o) / 2, E = -1 * JG(w4) * (i - e2) / 2 + QG(w4) * (n2 - o) / 2, T = C * C / (h * h) + E * E / (p4 * p4);
    T > 1 && (h *= Sre(T), p4 *= Sre(T));
    var O = (l4 === c4 ? -1 : 1) * Sre((h * h * (p4 * p4) - h * h * (E * E) - p4 * p4 * (C * C)) / (h * h * (E * E) + p4 * p4 * (C * C))) || 0, N = O * h * E / p4, V = O * -p4 * C / h, H = (i + e2) / 2 + QG(w4) * N - JG(w4) * V, X = (n2 + o) / 2 + JG(w4) * N + QG(w4) * V, q2 = Bwe([1, 0], [(C - N) / h, (E - V) / p4]), de = [(C - N) / h, (E - V) / p4], le = [(-1 * C - N) / h, (-1 * E - V) / p4], me = Bwe(de, le);
    if (eoe(de, le) <= -1 && (me = tN), eoe(de, le) >= 1 && (me = 0), me < 0) {
      var ye = Math.round(me / tN * 1e6) / 1e6;
      me = tN * 2 + ye % 2 * tN;
    }
    _.addData(y4, H, X, h, p4, q2, me, w4, c4);
  }
  var Ylt = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, Zlt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function Xlt(i) {
    var n2 = new K_();
    if (!i)
      return n2;
    var e2 = 0, o = 0, l4 = e2, c4 = o, h, p4 = K_.CMD, g4 = i.match(Ylt);
    if (!g4)
      return n2;
    for (var y4 = 0; y4 < g4.length; y4++) {
      for (var _ = g4[y4], w4 = _.charAt(0), C = void 0, E = _.match(Zlt) || [], T = E.length, O = 0; O < T; O++)
        E[O] = parseFloat(E[O]);
      for (var N = 0; N < T; ) {
        var V = void 0, H = void 0, X = void 0, q2 = void 0, de = void 0, le = void 0, me = void 0, ye = e2, be = o, we = void 0, Pe = void 0;
        switch (w4) {
          case "l":
            e2 += E[N++], o += E[N++], C = p4.L, n2.addData(C, e2, o);
            break;
          case "L":
            e2 = E[N++], o = E[N++], C = p4.L, n2.addData(C, e2, o);
            break;
          case "m":
            e2 += E[N++], o += E[N++], C = p4.M, n2.addData(C, e2, o), l4 = e2, c4 = o, w4 = "l";
            break;
          case "M":
            e2 = E[N++], o = E[N++], C = p4.M, n2.addData(C, e2, o), l4 = e2, c4 = o, w4 = "L";
            break;
          case "h":
            e2 += E[N++], C = p4.L, n2.addData(C, e2, o);
            break;
          case "H":
            e2 = E[N++], C = p4.L, n2.addData(C, e2, o);
            break;
          case "v":
            o += E[N++], C = p4.L, n2.addData(C, e2, o);
            break;
          case "V":
            o = E[N++], C = p4.L, n2.addData(C, e2, o);
            break;
          case "C":
            C = p4.C, n2.addData(C, E[N++], E[N++], E[N++], E[N++], E[N++], E[N++]), e2 = E[N - 2], o = E[N - 1];
            break;
          case "c":
            C = p4.C, n2.addData(C, E[N++] + e2, E[N++] + o, E[N++] + e2, E[N++] + o, E[N++] + e2, E[N++] + o), e2 += E[N - 2], o += E[N - 1];
            break;
          case "S":
            V = e2, H = o, we = n2.len(), Pe = n2.data, h === p4.C && (V += e2 - Pe[we - 4], H += o - Pe[we - 3]), C = p4.C, ye = E[N++], be = E[N++], e2 = E[N++], o = E[N++], n2.addData(C, V, H, ye, be, e2, o);
            break;
          case "s":
            V = e2, H = o, we = n2.len(), Pe = n2.data, h === p4.C && (V += e2 - Pe[we - 4], H += o - Pe[we - 3]), C = p4.C, ye = e2 + E[N++], be = o + E[N++], e2 += E[N++], o += E[N++], n2.addData(C, V, H, ye, be, e2, o);
            break;
          case "Q":
            ye = E[N++], be = E[N++], e2 = E[N++], o = E[N++], C = p4.Q, n2.addData(C, ye, be, e2, o);
            break;
          case "q":
            ye = E[N++] + e2, be = E[N++] + o, e2 += E[N++], o += E[N++], C = p4.Q, n2.addData(C, ye, be, e2, o);
            break;
          case "T":
            V = e2, H = o, we = n2.len(), Pe = n2.data, h === p4.Q && (V += e2 - Pe[we - 4], H += o - Pe[we - 3]), e2 = E[N++], o = E[N++], C = p4.Q, n2.addData(C, V, H, e2, o);
            break;
          case "t":
            V = e2, H = o, we = n2.len(), Pe = n2.data, h === p4.Q && (V += e2 - Pe[we - 4], H += o - Pe[we - 3]), e2 += E[N++], o += E[N++], C = p4.Q, n2.addData(C, V, H, e2, o);
            break;
          case "A":
            X = E[N++], q2 = E[N++], de = E[N++], le = E[N++], me = E[N++], ye = e2, be = o, e2 = E[N++], o = E[N++], C = p4.A, jwe(ye, be, e2, o, le, me, X, q2, de, C, n2);
            break;
          case "a":
            X = E[N++], q2 = E[N++], de = E[N++], le = E[N++], me = E[N++], ye = e2, be = o, e2 += E[N++], o += E[N++], C = p4.A, jwe(ye, be, e2, o, le, me, X, q2, de, C, n2);
            break;
        }
      }
      (w4 === "z" || w4 === "Z") && (C = p4.Z, n2.addData(C), e2 = l4, o = c4), h = C;
    }
    return n2.toStatic(), n2;
  }
  var LTe = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.applyTransform = function(e2) {
    }, n2;
  }(Eo);
  function OTe(i) {
    return i.setData != null;
  }
  function RTe(i, n2) {
    var e2 = Xlt(i), o = rr({}, n2);
    return o.buildPath = function(l4) {
      if (OTe(l4)) {
        l4.setData(e2.data);
        var c4 = l4.getContext();
        c4 && l4.rebuildPath(c4, 1);
      } else {
        var c4 = l4;
        e2.rebuildPath(c4, 1);
      }
    }, o.applyTransform = function(l4) {
      PTe(e2, l4), this.dirtyShape();
    }, o;
  }
  function FTe(i, n2) {
    return new LTe(RTe(i, n2));
  }
  function Klt(i, n2) {
    var e2 = RTe(i, n2), o = function(l4) {
      on(c4, l4);
      function c4(h) {
        var p4 = l4.call(this, h) || this;
        return p4.applyTransform = e2.applyTransform, p4.buildPath = e2.buildPath, p4;
      }
      return c4;
    }(LTe);
    return o;
  }
  function Jlt(i, n2) {
    for (var e2 = [], o = i.length, l4 = 0; l4 < o; l4++) {
      var c4 = i[l4];
      e2.push(c4.getUpdatedPathProxy(true));
    }
    var h = new Eo(n2);
    return h.createPathProxy(), h.buildPath = function(p4) {
      if (OTe(p4)) {
        p4.appendPath(e2);
        var g4 = p4.getContext();
        g4 && p4.rebuildPath(g4, 1);
      }
    }, h;
  }
  function Yse(i, n2) {
    n2 = n2 || {};
    var e2 = new Eo();
    return i.shape && e2.setShape(i.shape), e2.setStyle(i.style), n2.bakeTransform ? PTe(e2.path, i.getComputedTransform()) : n2.toLocal ? e2.setLocalTransform(i.getComputedTransform()) : e2.copyTransform(i), e2.buildPath = i.buildPath, e2.applyTransform = e2.applyTransform, e2.z = i.z, e2.z2 = i.z2, e2.zlevel = i.zlevel, e2;
  }
  var Qlt = function() {
    function i() {
      this.cx = 0, this.cy = 0, this.r = 0;
    }
    return i;
  }(), NTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new Qlt();
    }, n2.prototype.buildPath = function(e2, o) {
      e2.moveTo(o.cx + o.r, o.cy), e2.arc(o.cx, o.cy, o.r, 0, Math.PI * 2);
    }, n2;
  }(Eo);
  NTe.prototype.type = "circle";
  var J_ = NTe, eut = function() {
    function i() {
      this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
    }
    return i;
  }(), VTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new eut();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = 0.5522848, c4 = o.cx, h = o.cy, p4 = o.rx, g4 = o.ry, y4 = p4 * l4, _ = g4 * l4;
      e2.moveTo(c4 - p4, h), e2.bezierCurveTo(c4 - p4, h - _, c4 - y4, h - g4, c4, h - g4), e2.bezierCurveTo(c4 + y4, h - g4, c4 + p4, h - _, c4 + p4, h), e2.bezierCurveTo(c4 + p4, h + _, c4 + y4, h + g4, c4, h + g4), e2.bezierCurveTo(c4 - y4, h + g4, c4 - p4, h + _, c4 - p4, h), e2.closePath();
    }, n2;
  }(Eo);
  VTe.prototype.type = "ellipse";
  var Zse = VTe, zTe = Math.PI, Cre = zTe * 2, kI = Math.sin, XP = Math.cos, tut = Math.acos, fv = Math.atan2, Gwe = Math.abs, UN = Math.sqrt, TN = Math.max, P_ = Math.min, X1 = 1e-4;
  function nut(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = e2 - i, y4 = o - n2, _ = h - l4, w4 = p4 - c4, C = w4 * g4 - _ * y4;
    if (!(C * C < X1))
      return C = (_ * (n2 - c4) - w4 * (i - l4)) / C, [i + C * g4, n2 + C * y4];
  }
  function eW(i, n2, e2, o, l4, c4, h) {
    var p4 = i - e2, g4 = n2 - o, y4 = (h ? c4 : -c4) / UN(p4 * p4 + g4 * g4), _ = y4 * g4, w4 = -y4 * p4, C = i + _, E = n2 + w4, T = e2 + _, O = o + w4, N = (C + T) / 2, V = (E + O) / 2, H = T - C, X = O - E, q2 = H * H + X * X, de = l4 - c4, le = C * O - T * E, me = (X < 0 ? -1 : 1) * UN(TN(0, de * de * q2 - le * le)), ye = (le * X - H * me) / q2, be = (-le * H - X * me) / q2, we = (le * X + H * me) / q2, Pe = (-le * H + X * me) / q2, ze = ye - N, Re = be - V, rt2 = we - N, ft = Pe - V;
    return ze * ze + Re * Re > rt2 * rt2 + ft * ft && (ye = we, be = Pe), { cx: ye, cy: be, x0: -_, y0: -w4, x1: ye * (l4 / de - 1), y1: be * (l4 / de - 1) };
  }
  function rut(i) {
    var n2;
    if (Mr(i)) {
      var e2 = i.length;
      if (!e2)
        return i;
      e2 === 1 ? n2 = [i[0], i[0], 0, 0] : e2 === 2 ? n2 = [i[0], i[0], i[1], i[1]] : e2 === 3 ? n2 = i.concat(i[2]) : n2 = i;
    } else
      n2 = [i, i, i, i];
    return n2;
  }
  function aut(i, n2) {
    var e2, o = TN(n2.r, 0), l4 = TN(n2.r0 || 0, 0), c4 = o > 0, h = l4 > 0;
    if (!(!c4 && !h)) {
      if (c4 || (o = l4, l4 = 0), l4 > o) {
        var p4 = o;
        o = l4, l4 = p4;
      }
      var g4 = n2.startAngle, y4 = n2.endAngle;
      if (!(isNaN(g4) || isNaN(y4))) {
        var _ = n2.cx, w4 = n2.cy, C = !!n2.clockwise, E = Gwe(y4 - g4), T = E > Cre && E % Cre;
        if (T > X1 && (E = T), !(o > X1))
          i.moveTo(_, w4);
        else if (E > Cre - X1)
          i.moveTo(_ + o * XP(g4), w4 + o * kI(g4)), i.arc(_, w4, o, g4, y4, !C), l4 > X1 && (i.moveTo(_ + l4 * XP(y4), w4 + l4 * kI(y4)), i.arc(_, w4, l4, y4, g4, C));
        else {
          var O = void 0, N = void 0, V = void 0, H = void 0, X = void 0, q2 = void 0, de = void 0, le = void 0, me = void 0, ye = void 0, be = void 0, we = void 0, Pe = void 0, ze = void 0, Re = void 0, rt2 = void 0, ft = o * XP(g4), et = o * kI(g4), Jt = l4 * XP(y4), xt = l4 * kI(y4), It = E > X1;
          if (It) {
            var Wt = n2.cornerRadius;
            Wt && (e2 = rut(Wt), O = e2[0], N = e2[1], V = e2[2], H = e2[3]);
            var sn = Gwe(o - l4) / 2;
            if (X = P_(sn, V), q2 = P_(sn, H), de = P_(sn, O), le = P_(sn, N), be = me = TN(X, q2), we = ye = TN(de, le), (me > X1 || ye > X1) && (Pe = o * XP(y4), ze = o * kI(y4), Re = l4 * XP(g4), rt2 = l4 * kI(g4), E < zTe)) {
              var vn = nut(ft, et, Re, rt2, Pe, ze, Jt, xt);
              if (vn) {
                var $r = ft - vn[0], ga = et - vn[1], Za = Pe - vn[0], $a = ze - vn[1], Pa = 1 / kI(tut(($r * Za + ga * $a) / (UN($r * $r + ga * ga) * UN(Za * Za + $a * $a))) / 2), da = UN(vn[0] * vn[0] + vn[1] * vn[1]);
                be = P_(me, (o - da) / (Pa + 1)), we = P_(ye, (l4 - da) / (Pa - 1));
              }
            }
          }
          if (!It)
            i.moveTo(_ + ft, w4 + et);
          else if (be > X1) {
            var Ra = P_(V, be), Wa = P_(H, be), wa = eW(Re, rt2, ft, et, o, Ra, C), li = eW(Pe, ze, Jt, xt, o, Wa, C);
            i.moveTo(_ + wa.cx + wa.x0, w4 + wa.cy + wa.y0), be < me && Ra === Wa ? i.arc(_ + wa.cx, w4 + wa.cy, be, fv(wa.y0, wa.x0), fv(li.y0, li.x0), !C) : (Ra > 0 && i.arc(_ + wa.cx, w4 + wa.cy, Ra, fv(wa.y0, wa.x0), fv(wa.y1, wa.x1), !C), i.arc(_, w4, o, fv(wa.cy + wa.y1, wa.cx + wa.x1), fv(li.cy + li.y1, li.cx + li.x1), !C), Wa > 0 && i.arc(_ + li.cx, w4 + li.cy, Wa, fv(li.y1, li.x1), fv(li.y0, li.x0), !C));
          } else
            i.moveTo(_ + ft, w4 + et), i.arc(_, w4, o, g4, y4, !C);
          if (!(l4 > X1) || !It)
            i.lineTo(_ + Jt, w4 + xt);
          else if (we > X1) {
            var Ra = P_(O, we), Wa = P_(N, we), wa = eW(Jt, xt, Pe, ze, l4, -Wa, C), li = eW(ft, et, Re, rt2, l4, -Ra, C);
            i.lineTo(_ + wa.cx + wa.x0, w4 + wa.cy + wa.y0), we < ye && Ra === Wa ? i.arc(_ + wa.cx, w4 + wa.cy, we, fv(wa.y0, wa.x0), fv(li.y0, li.x0), !C) : (Wa > 0 && i.arc(_ + wa.cx, w4 + wa.cy, Wa, fv(wa.y0, wa.x0), fv(wa.y1, wa.x1), !C), i.arc(_, w4, l4, fv(wa.cy + wa.y1, wa.cx + wa.x1), fv(li.cy + li.y1, li.cx + li.x1), C), Ra > 0 && i.arc(_ + li.cx, w4 + li.cy, Ra, fv(li.y1, li.x1), fv(li.y0, li.x0), !C));
          } else
            i.lineTo(_ + Jt, w4 + xt), i.arc(_, w4, l4, y4, g4, C);
        }
        i.closePath();
      }
    }
  }
  var iut = function() {
    function i() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
    }
    return i;
  }(), BTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new iut();
    }, n2.prototype.buildPath = function(e2, o) {
      aut(e2, o);
    }, n2.prototype.isZeroArea = function() {
      return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
    }, n2;
  }(Eo);
  BTe.prototype.type = "sector";
  var Hg = BTe, out2 = function() {
    function i() {
      this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
    }
    return i;
  }(), jTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new out2();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.cx, c4 = o.cy, h = Math.PI * 2;
      e2.moveTo(l4 + o.r, c4), e2.arc(l4, c4, o.r, 0, h, false), e2.moveTo(l4 + o.r0, c4), e2.arc(l4, c4, o.r0, 0, h, true);
    }, n2;
  }(Eo);
  jTe.prototype.type = "ring";
  var E$ = jTe;
  function sut(i, n2, e2, o) {
    var l4 = [], c4 = [], h = [], p4 = [], g4, y4, _, w4;
    if (o) {
      _ = [1 / 0, 1 / 0], w4 = [-1 / 0, -1 / 0];
      for (var C = 0, E = i.length; C < E; C++)
        FC(_, _, i[C]), NC(w4, w4, i[C]);
      FC(_, _, o[0]), NC(w4, w4, o[1]);
    }
    for (var C = 0, E = i.length; C < E; C++) {
      var T = i[C];
      if (e2)
        g4 = i[C ? C - 1 : E - 1], y4 = i[(C + 1) % E];
      else if (C === 0 || C === E - 1) {
        l4.push(h2(i[C]));
        continue;
      } else
        g4 = i[C - 1], y4 = i[C + 1];
      nT(c4, y4, g4), Gne(c4, c4, n2);
      var O = Aie(T, g4), N = Aie(T, y4), V = O + N;
      V !== 0 && (O /= V, N /= V), Gne(h, c4, -O), Gne(p4, c4, N);
      var H = Rxe([], T, h), X = Rxe([], T, p4);
      o && (NC(H, H, _), FC(H, H, w4), NC(X, X, _), FC(X, X, w4)), l4.push(H), l4.push(X);
    }
    return e2 && l4.push(l4.shift()), l4;
  }
  function GTe(i, n2, e2) {
    var o = n2.smooth, l4 = n2.points;
    if (l4 && l4.length >= 2) {
      if (o) {
        var c4 = sut(l4, o, e2, n2.smoothConstraint);
        i.moveTo(l4[0][0], l4[0][1]);
        for (var h = l4.length, p4 = 0; p4 < (e2 ? h : h - 1); p4++) {
          var g4 = c4[p4 * 2], y4 = c4[p4 * 2 + 1], _ = l4[(p4 + 1) % h];
          i.bezierCurveTo(g4[0], g4[1], y4[0], y4[1], _[0], _[1]);
        }
      } else {
        i.moveTo(l4[0][0], l4[0][1]);
        for (var p4 = 1, w4 = l4.length; p4 < w4; p4++)
          i.lineTo(l4[p4][0], l4[p4][1]);
      }
      e2 && i.closePath();
    }
  }
  var lut = function() {
    function i() {
      this.points = null, this.smooth = 0, this.smoothConstraint = null;
    }
    return i;
  }(), WTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new lut();
    }, n2.prototype.buildPath = function(e2, o) {
      GTe(e2, o, true);
    }, n2;
  }(Eo);
  WTe.prototype.type = "polygon";
  var $g = WTe, uut = function() {
    function i() {
      this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
    }
    return i;
  }(), HTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new uut();
    }, n2.prototype.buildPath = function(e2, o) {
      GTe(e2, o, false);
    }, n2;
  }(Eo);
  HTe.prototype.type = "polyline";
  var Ug = HTe, cut = {}, fut = function() {
    function i() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return i;
  }(), $Te = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new fut();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4, c4, h, p4;
      if (this.subPixelOptimize) {
        var g4 = gTe(cut, o, this.style);
        l4 = g4.x1, c4 = g4.y1, h = g4.x2, p4 = g4.y2;
      } else
        l4 = o.x1, c4 = o.y1, h = o.x2, p4 = o.y2;
      var y4 = o.percent;
      y4 !== 0 && (e2.moveTo(l4, c4), y4 < 1 && (h = l4 * (1 - y4) + h * y4, p4 = c4 * (1 - y4) + p4 * y4), e2.lineTo(h, p4));
    }, n2.prototype.pointAt = function(e2) {
      var o = this.shape;
      return [o.x1 * (1 - e2) + o.x2 * e2, o.y1 * (1 - e2) + o.y2 * e2];
    }, n2;
  }(Eo);
  $Te.prototype.type = "line";
  var Vd = $Te, zg = [], hut = function() {
    function i() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
    }
    return i;
  }();
  function Wwe(i, n2, e2) {
    var o = i.cpx2, l4 = i.cpy2;
    return o != null || l4 != null ? [(e2 ? Uxe : Kh)(i.x1, i.cpx1, i.cpx2, i.x2, n2), (e2 ? Uxe : Kh)(i.y1, i.cpy1, i.cpy2, i.y2, n2)] : [(e2 ? Pie : Fd)(i.x1, i.cpx1, i.x2, n2), (e2 ? Pie : Fd)(i.y1, i.cpy1, i.y2, n2)];
  }
  var UTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new hut();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.x1, c4 = o.y1, h = o.x2, p4 = o.y2, g4 = o.cpx1, y4 = o.cpy1, _ = o.cpx2, w4 = o.cpy2, C = o.percent;
      C !== 0 && (e2.moveTo(l4, c4), _ == null || w4 == null ? (C < 1 && (o8(l4, g4, h, C, zg), g4 = zg[1], h = zg[2], o8(c4, y4, p4, C, zg), y4 = zg[1], p4 = zg[2]), e2.quadraticCurveTo(g4, y4, h, p4)) : (C < 1 && (KC(l4, g4, _, h, C, zg), g4 = zg[1], _ = zg[2], h = zg[3], KC(c4, y4, w4, p4, C, zg), y4 = zg[1], w4 = zg[2], p4 = zg[3]), e2.bezierCurveTo(g4, y4, _, w4, h, p4)));
    }, n2.prototype.pointAt = function(e2) {
      return Wwe(this.shape, e2, false);
    }, n2.prototype.tangentAt = function(e2) {
      var o = Wwe(this.shape, e2, true);
      return R8(o, o);
    }, n2;
  }(Eo);
  UTe.prototype.type = "bezier-curve";
  var I$ = UTe, dut = function() {
    function i() {
      this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return i;
  }(), qTe = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new dut();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.cx, c4 = o.cy, h = Math.max(o.r, 0), p4 = o.startAngle, g4 = o.endAngle, y4 = o.clockwise, _ = Math.cos(p4), w4 = Math.sin(p4);
      e2.moveTo(_ * h + l4, w4 * h + c4), e2.arc(l4, c4, h, p4, g4, !y4);
    }, n2;
  }(Eo);
  qTe.prototype.type = "arc";
  var Xse = qTe, put = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "compound", e2;
    }
    return n2.prototype._updatePathDirty = function() {
      for (var e2 = this.shape.paths, o = this.shapeChanged(), l4 = 0; l4 < e2.length; l4++)
        o = o || e2[l4].shapeChanged();
      o && this.dirtyShape();
    }, n2.prototype.beforeBrush = function() {
      this._updatePathDirty();
      for (var e2 = this.shape.paths || [], o = this.getGlobalScale(), l4 = 0; l4 < e2.length; l4++)
        e2[l4].path || e2[l4].createPathProxy(), e2[l4].path.setScale(o[0], o[1], e2[l4].segmentIgnoreThreshold);
    }, n2.prototype.buildPath = function(e2, o) {
      for (var l4 = o.paths || [], c4 = 0; c4 < l4.length; c4++)
        l4[c4].buildPath(e2, l4[c4].shape, true);
    }, n2.prototype.afterBrush = function() {
      for (var e2 = this.shape.paths || [], o = 0; o < e2.length; o++)
        e2[o].pathUpdated();
    }, n2.prototype.getBoundingRect = function() {
      return this._updatePathDirty.call(this), Eo.prototype.getBoundingRect.call(this);
    }, n2;
  }(Eo), Kse = put, vut = function() {
    function i(n2) {
      this.colorStops = n2 || [];
    }
    return i.prototype.addColorStop = function(n2, e2) {
      this.colorStops.push({ offset: n2, color: e2 });
    }, i;
  }(), YTe = vut, gut = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4, h, p4) {
      var g4 = i.call(this, h) || this;
      return g4.x = e2 == null ? 0 : e2, g4.y = o == null ? 0 : o, g4.x2 = l4 == null ? 1 : l4, g4.y2 = c4 == null ? 0 : c4, g4.type = "linear", g4.global = p4 || false, g4;
    }
    return n2;
  }(YTe), B8 = gut, mut = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4, h) {
      var p4 = i.call(this, c4) || this;
      return p4.x = e2 == null ? 0.5 : e2, p4.y = o == null ? 0.5 : o, p4.r = l4 == null ? 0.5 : l4, p4.type = "radial", p4.global = h || false, p4;
    }
    return n2;
  }(YTe), ZTe = mut, PI3 = [0, 0], LI = [0, 0], tW = new Ji(), nW = new Ji(), yut = function() {
    function i(n2, e2) {
      this._corners = [], this._axes = [], this._origin = [0, 0];
      for (var o = 0; o < 4; o++)
        this._corners[o] = new Ji();
      for (var o = 0; o < 2; o++)
        this._axes[o] = new Ji();
      n2 && this.fromBoundingRect(n2, e2);
    }
    return i.prototype.fromBoundingRect = function(n2, e2) {
      var o = this._corners, l4 = this._axes, c4 = n2.x, h = n2.y, p4 = c4 + n2.width, g4 = h + n2.height;
      if (o[0].set(c4, h), o[1].set(p4, h), o[2].set(p4, g4), o[3].set(c4, g4), e2)
        for (var y4 = 0; y4 < 4; y4++)
          o[y4].transform(e2);
      Ji.sub(l4[0], o[1], o[0]), Ji.sub(l4[1], o[3], o[0]), l4[0].normalize(), l4[1].normalize();
      for (var y4 = 0; y4 < 2; y4++)
        this._origin[y4] = l4[y4].dot(o[0]);
    }, i.prototype.intersect = function(n2, e2) {
      var o = true, l4 = !e2;
      return tW.set(1 / 0, 1 / 0), nW.set(0, 0), !this._intersectCheckOneSide(this, n2, tW, nW, l4, 1) && (o = false, l4) || !this._intersectCheckOneSide(n2, this, tW, nW, l4, -1) && (o = false, l4) || l4 || Ji.copy(e2, o ? tW : nW), o;
    }, i.prototype._intersectCheckOneSide = function(n2, e2, o, l4, c4, h) {
      for (var p4 = true, g4 = 0; g4 < 2; g4++) {
        var y4 = this._axes[g4];
        if (this._getProjMinMaxOnAxis(g4, n2._corners, PI3), this._getProjMinMaxOnAxis(g4, e2._corners, LI), PI3[1] < LI[0] || PI3[0] > LI[1]) {
          if (p4 = false, c4)
            return p4;
          var _ = Math.abs(LI[0] - PI3[1]), w4 = Math.abs(PI3[0] - LI[1]);
          Math.min(_, w4) > l4.len() && (_ < w4 ? Ji.scale(l4, y4, -_ * h) : Ji.scale(l4, y4, w4 * h));
        } else if (o) {
          var _ = Math.abs(LI[0] - PI3[1]), w4 = Math.abs(PI3[0] - LI[1]);
          Math.min(_, w4) < o.len() && (_ < w4 ? Ji.scale(o, y4, _ * h) : Ji.scale(o, y4, -w4 * h));
        }
      }
      return p4;
    }, i.prototype._getProjMinMaxOnAxis = function(n2, e2, o) {
      for (var l4 = this._axes[n2], c4 = this._origin, h = e2[0].dot(l4) + c4[n2], p4 = h, g4 = h, y4 = 1; y4 < e2.length; y4++) {
        var _ = e2[y4].dot(l4) + c4[n2];
        p4 = Math.min(_, p4), g4 = Math.max(_, g4);
      }
      o[0] = p4, o[1] = g4;
    }, i;
  }(), EH = yut, but = [], _ut = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.notClear = true, e2.incremental = true, e2._displayables = [], e2._temporaryDisplayables = [], e2._cursor = 0, e2;
    }
    return n2.prototype.traverse = function(e2, o) {
      e2.call(o, this);
    }, n2.prototype.useStyle = function() {
      this.style = {};
    }, n2.prototype.getCursor = function() {
      return this._cursor;
    }, n2.prototype.innerAfterBrush = function() {
      this._cursor = this._displayables.length;
    }, n2.prototype.clearDisplaybles = function() {
      this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
    }, n2.prototype.clearTemporalDisplayables = function() {
      this._temporaryDisplayables = [];
    }, n2.prototype.addDisplayable = function(e2, o) {
      o ? this._temporaryDisplayables.push(e2) : this._displayables.push(e2), this.markRedraw();
    }, n2.prototype.addDisplayables = function(e2, o) {
      o = o || false;
      for (var l4 = 0; l4 < e2.length; l4++)
        this.addDisplayable(e2[l4], o);
    }, n2.prototype.getDisplayables = function() {
      return this._displayables;
    }, n2.prototype.getTemporalDisplayables = function() {
      return this._temporaryDisplayables;
    }, n2.prototype.eachPendingDisplayable = function(e2) {
      for (var o = this._cursor; o < this._displayables.length; o++)
        e2 && e2(this._displayables[o]);
      for (var o = 0; o < this._temporaryDisplayables.length; o++)
        e2 && e2(this._temporaryDisplayables[o]);
    }, n2.prototype.update = function() {
      this.updateTransform();
      for (var e2 = this._cursor; e2 < this._displayables.length; e2++) {
        var o = this._displayables[e2];
        o.parent = this, o.update(), o.parent = null;
      }
      for (var e2 = 0; e2 < this._temporaryDisplayables.length; e2++) {
        var o = this._temporaryDisplayables[e2];
        o.parent = this, o.update(), o.parent = null;
      }
    }, n2.prototype.getBoundingRect = function() {
      if (!this._rect) {
        for (var e2 = new mo(1 / 0, 1 / 0, -1 / 0, -1 / 0), o = 0; o < this._displayables.length; o++) {
          var l4 = this._displayables[o], c4 = l4.getBoundingRect().clone();
          l4.needLocalTransform() && c4.applyTransform(l4.getLocalTransform(but)), e2.union(c4);
        }
        this._rect = e2;
      }
      return this._rect;
    }, n2.prototype.contain = function(e2, o) {
      var l4 = this.transformCoordToLocal(e2, o), c4 = this.getBoundingRect();
      if (c4.contain(l4[0], l4[1]))
        for (var h = 0; h < this._displayables.length; h++) {
          var p4 = this._displayables[h];
          if (p4.contain(e2, o))
            return true;
        }
      return false;
    }, n2;
  }(Vy), xut = _ut, XTe = zs();
  function U3(i, n2, e2, o, l4) {
    var c4;
    if (n2 && n2.ecModel) {
      var h = n2.ecModel.getUpdatePayload();
      c4 = h && h.animation;
    }
    var p4 = n2 && n2.isAnimationEnabled(), g4 = i === "update";
    if (p4) {
      var y4 = void 0, _ = void 0, w4 = void 0;
      o ? (y4 = so(o.duration, 200), _ = so(o.easing, "cubicOut"), w4 = 0) : (y4 = n2.getShallow(g4 ? "animationDurationUpdate" : "animationDuration"), _ = n2.getShallow(g4 ? "animationEasingUpdate" : "animationEasing"), w4 = n2.getShallow(g4 ? "animationDelayUpdate" : "animationDelay")), c4 && (c4.duration != null && (y4 = c4.duration), c4.easing != null && (_ = c4.easing), c4.delay != null && (w4 = c4.delay)), si(w4) && (w4 = w4(e2, l4)), si(y4) && (y4 = y4(e2));
      var C = { duration: y4 || 0, delay: w4, easing: _ };
      return C;
    } else
      return null;
  }
  function Jse(i, n2, e2, o, l4, c4, h) {
    var p4 = false, g4;
    si(l4) ? (h = c4, c4 = l4, l4 = null) : mi(l4) && (c4 = l4.cb, h = l4.during, p4 = l4.isFrom, g4 = l4.removeOpt, l4 = l4.dataIndex);
    var y4 = i === "leave";
    y4 || n2.stopAnimation("leave");
    var _ = U3(i, o, l4, y4 ? g4 || {} : null, o && o.getAnimationDelayParams ? o.getAnimationDelayParams(n2, l4) : null);
    if (_ && _.duration > 0) {
      var w4 = _.duration, C = _.delay, E = _.easing, T = { duration: w4, delay: C || 0, easing: E, done: c4, force: !!c4 || !!h, setToFinal: !y4, scope: i, during: h };
      p4 ? n2.animateFrom(e2, T) : n2.animateTo(e2, T);
    } else
      n2.stopAnimation(), !p4 && n2.attr(e2), h && h(1), c4 && c4();
  }
  function Vs(i, n2, e2, o, l4, c4) {
    Jse("update", i, n2, e2, o, l4, c4);
  }
  function bc(i, n2, e2, o, l4, c4) {
    Jse("enter", i, n2, e2, o, l4, c4);
  }
  function E3(i) {
    if (!i.__zr)
      return true;
    for (var n2 = 0; n2 < i.animators.length; n2++) {
      var e2 = i.animators[n2];
      if (e2.scope === "leave")
        return true;
    }
    return false;
  }
  function JC(i, n2, e2, o, l4, c4) {
    E3(i) || Jse("leave", i, n2, e2, o, l4, c4);
  }
  function Hwe(i, n2, e2, o) {
    i.removeTextContent(), i.removeTextGuideLine(), JC(i, { style: { opacity: 0 } }, n2, e2, o);
  }
  function h8(i, n2, e2) {
    function o() {
      i.parent && i.parent.remove(i);
    }
    i.isGroup ? i.traverse(function(l4) {
      l4.isGroup || Hwe(l4, n2, e2, o);
    }) : Hwe(i, n2, e2, o);
  }
  function ob(i) {
    XTe(i).oldStyle = i.style;
  }
  function wut(i) {
    return XTe(i).oldStyle;
  }
  var IH = Math.max, TH = Math.min, toe = {};
  function Sut(i) {
    return Eo.extend(i);
  }
  var Cut = Klt;
  function Mut(i, n2) {
    return Cut(i, n2);
  }
  function sb(i, n2) {
    toe[i] = n2;
  }
  function Qse(i) {
    if (toe.hasOwnProperty(i))
      return toe[i];
  }
  function T$(i, n2, e2, o) {
    var l4 = FTe(i, n2);
    return e2 && (o === "center" && (e2 = JTe(e2, l4.getBoundingRect())), QTe(l4, e2)), l4;
  }
  function KTe(i, n2, e2) {
    var o = new Ap({ style: { image: i, x: n2.x, y: n2.y, width: n2.width, height: n2.height }, onload: function(l4) {
      if (e2 === "center") {
        var c4 = { width: l4.width, height: l4.height };
        o.setStyle(JTe(n2, c4));
      }
    } });
    return o;
  }
  function JTe(i, n2) {
    var e2 = n2.width / n2.height, o = i.height * e2, l4;
    o <= i.width ? l4 = i.height : (o = i.width, l4 = o / e2);
    var c4 = i.x + i.width / 2, h = i.y + i.height / 2;
    return { x: c4 - o / 2, y: h - l4 / 2, width: o, height: l4 };
  }
  var ky = Jlt;
  function QTe(i, n2) {
    if (!!i.applyTransform) {
      var e2 = i.getBoundingRect(), o = e2.calculateTransform(n2);
      i.applyTransform(o);
    }
  }
  function Aut(i) {
    return gTe(i.shape, i.shape, i.style), i;
  }
  function Eut(i) {
    return mTe(i.shape, i.shape, i.style), i;
  }
  var aH = rT;
  function hT(i, n2) {
    for (var e2 = b$([]); i && i !== n2; )
      p2(e2, i.getLocalTransform(), e2), i = i.parent;
    return e2;
  }
  function ab(i, n2, e2) {
    return n2 && !gv(n2) && (n2 = u2.getLocalTransform(n2)), e2 && (n2 = W3([], n2)), Sp([], i, n2);
  }
  function D$(i, n2, e2) {
    var o = n2[4] === 0 || n2[5] === 0 || n2[0] === 0 ? 1 : Math.abs(2 * n2[4] / n2[0]), l4 = n2[4] === 0 || n2[5] === 0 || n2[2] === 0 ? 1 : Math.abs(2 * n2[4] / n2[2]), c4 = [i === "left" ? -o : i === "right" ? o : 0, i === "top" ? -l4 : i === "bottom" ? l4 : 0];
    return c4 = ab(c4, n2, e2), Math.abs(c4[0]) > Math.abs(c4[1]) ? c4[0] > 0 ? "right" : "left" : c4[1] > 0 ? "bottom" : "top";
  }
  function $we(i) {
    return !i.isGroup;
  }
  function Iut(i) {
    return i.shape != null;
  }
  function j8(i, n2, e2) {
    if (!i || !n2)
      return;
    function o(h) {
      var p4 = {};
      return h.traverse(function(g4) {
        $we(g4) && g4.anid && (p4[g4.anid] = g4);
      }), p4;
    }
    function l4(h) {
      var p4 = { x: h.x, y: h.y, rotation: h.rotation };
      return Iut(h) && (p4.shape = rr({}, h.shape)), p4;
    }
    var c4 = o(i);
    n2.traverse(function(h) {
      if ($we(h) && h.anid) {
        var p4 = c4[h.anid];
        if (p4) {
          var g4 = l4(h);
          h.attr(l4(p4)), Vs(h, g4, e2, Fi(h).dataIndex);
        }
      }
    });
  }
  function eDe(i, n2) {
    return Er(i, function(e2) {
      var o = e2[0];
      o = IH(o, n2.x), o = TH(o, n2.x + n2.width);
      var l4 = e2[1];
      return l4 = IH(l4, n2.y), l4 = TH(l4, n2.y + n2.height), [o, l4];
    });
  }
  function Tut(i, n2) {
    var e2 = IH(i.x, n2.x), o = TH(i.x + i.width, n2.x + n2.width), l4 = IH(i.y, n2.y), c4 = TH(i.y + i.height, n2.y + n2.height);
    if (o >= e2 && c4 >= l4)
      return { x: e2, y: l4, width: o - e2, height: c4 - l4 };
  }
  function G8(i, n2, e2) {
    var o = rr({ rectHover: true }, n2), l4 = o.style = { strokeNoScale: true };
    if (e2 = e2 || { x: -1, y: -1, width: 2, height: 2 }, i)
      return i.indexOf("image://") === 0 ? (l4.image = i.slice(8), hi(l4, e2), new Ap(o)) : T$(i.replace("path://", ""), o, e2, "center");
  }
  function DN(i, n2, e2, o, l4) {
    for (var c4 = 0, h = l4[l4.length - 1]; c4 < l4.length; c4++) {
      var p4 = l4[c4];
      if (tDe(i, n2, e2, o, p4[0], p4[1], h[0], h[1]))
        return true;
      h = p4;
    }
  }
  function tDe(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = e2 - i, y4 = o - n2, _ = h - l4, w4 = p4 - c4, C = Mre(_, w4, g4, y4);
    if (Dut(C))
      return false;
    var E = i - l4, T = n2 - c4, O = Mre(E, T, g4, y4) / C;
    if (O < 0 || O > 1)
      return false;
    var N = Mre(E, T, _, w4) / C;
    return !(N < 0 || N > 1);
  }
  function Mre(i, n2, e2, o) {
    return i * o - e2 * n2;
  }
  function Dut(i) {
    return i <= 1e-6 && i >= -1e-6;
  }
  function q3(i) {
    var n2 = i.itemTooltipOption, e2 = i.componentModel, o = i.itemName, l4 = xa(n2) ? { formatter: n2 } : n2, c4 = e2.mainType, h = e2.componentIndex, p4 = { componentType: c4, name: o, $vars: ["name"] };
    p4[c4 + "Index"] = h;
    var g4 = i.formatterParamsExtra;
    g4 && Ve(ts(g4), function(_) {
      Na(p4, _) || (p4[_] = g4[_], p4.$vars.push(_));
    });
    var y4 = Fi(i.el);
    y4.componentMainType = c4, y4.componentIndex = h, y4.tooltipConfig = { name: o, option: hi({ content: o, formatterParams: p4 }, l4) };
  }
  function Uwe(i, n2) {
    var e2;
    i.isGroup && (e2 = n2(i)), e2 || i.traverse(n2);
  }
  function oM(i, n2) {
    if (i)
      if (Mr(i))
        for (var e2 = 0; e2 < i.length; e2++)
          Uwe(i[e2], n2);
      else
        Uwe(i, n2);
  }
  sb("circle", J_);
  sb("ellipse", Zse);
  sb("sector", Hg);
  sb("ring", E$);
  sb("polygon", $g);
  sb("polyline", Ug);
  sb("rect", Is);
  sb("line", Vd);
  sb("bezierCurve", I$);
  sb("arc", Xse);
  var W8 = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: Vs, initProps: bc, removeElement: JC, removeElementWithFadeOut: h8, isElementRemoved: E3, extendShape: Sut, extendPath: Mut, registerShape: sb, getShapeClass: Qse, makePath: T$, makeImage: KTe, mergePath: ky, resizePath: QTe, subPixelOptimizeLine: Aut, subPixelOptimizeRect: Eut, subPixelOptimize: aH, getTransform: hT, applyTransform: ab, transformDirection: D$, groupTransition: j8, clipPointsByRect: eDe, clipRectByRect: Tut, createIcon: G8, linePolygonIntersect: DN, lineLineIntersect: tDe, setTooltipConfig: q3, traverseElements: oM, Group: Ti, Image: Ap, Text: Qs, Circle: J_, Ellipse: Zse, Sector: Hg, Ring: E$, Polygon: $g, Polyline: Ug, Rect: Is, Line: Vd, BezierCurve: I$, Arc: Xse, IncrementalDisplayable: xut, CompoundPath: Kse, LinearGradient: B8, RadialGradient: ZTe, BoundingRect: mo, OrientedBoundingRect: EH, Point: Ji, Path: Eo }, Symbol.toStringTag, { value: "Module" })), k$ = {};
  function nDe(i, n2) {
    for (var e2 = 0; e2 < Jv.length; e2++) {
      var o = Jv[e2], l4 = n2[o], c4 = i.ensureState(o);
      c4.style = c4.style || {}, c4.style.text = l4;
    }
    var h = i.currentStates.slice();
    i.clearStates(true), i.setStyle({ text: n2.normal }), i.useStates(h, true);
  }
  function noe(i, n2, e2) {
    var o = i.labelFetcher, l4 = i.labelDataIndex, c4 = i.labelDimIndex, h = n2.normal, p4;
    o && (p4 = o.getFormattedLabel(l4, "normal", null, c4, h && h.get("formatter"), e2 != null ? { interpolatedValue: e2 } : null)), p4 == null && (p4 = si(i.defaultText) ? i.defaultText(l4, i, e2) : i.defaultText);
    for (var g4 = { normal: p4 }, y4 = 0; y4 < Jv.length; y4++) {
      var _ = Jv[y4], w4 = n2[_];
      g4[_] = so(o ? o.getFormattedLabel(l4, _, null, c4, w4 && w4.get("formatter")) : null, p4);
    }
    return g4;
  }
  function yv(i, n2, e2, o) {
    e2 = e2 || k$;
    for (var l4 = i instanceof Qs, c4 = false, h = 0; h < c8.length; h++) {
      var p4 = n2[c8[h]];
      if (p4 && p4.getShallow("show")) {
        c4 = true;
        break;
      }
    }
    var g4 = l4 ? i : i.getTextContent();
    if (c4) {
      l4 || (g4 || (g4 = new Qs(), i.setTextContent(g4)), i.stateProxy && (g4.stateProxy = i.stateProxy));
      var y4 = noe(e2, n2), _ = n2.normal, w4 = !!_.getShallow("show"), C = Ef(_, o && o.normal, e2, false, !l4);
      C.text = y4.normal, l4 || i.setTextConfig(DH(_, e2, false));
      for (var h = 0; h < Jv.length; h++) {
        var E = Jv[h], p4 = n2[E];
        if (p4) {
          var T = g4.ensureState(E), O = !!so(p4.getShallow("show"), w4);
          if (O !== w4 && (T.ignore = !O), T.style = Ef(p4, o && o[E], e2, true, !l4), T.style.text = y4[E], !l4) {
            var N = i.ensureState(E);
            N.textConfig = DH(p4, e2, true);
          }
        }
      }
      g4.silent = !!_.getShallow("silent"), g4.style.x != null && (C.x = g4.style.x), g4.style.y != null && (C.y = g4.style.y), g4.ignore = !w4, g4.useStyle(C), g4.dirty(), e2.enableTextSetter && (Y3(g4).setLabelText = function(V) {
        var H = noe(e2, n2, V);
        nDe(g4, H);
      });
    } else
      g4 && (g4.ignore = true);
    i.dirty();
  }
  function zd(i, n2) {
    n2 = n2 || "label";
    for (var e2 = { normal: i.getModel(n2) }, o = 0; o < Jv.length; o++) {
      var l4 = Jv[o];
      e2[l4] = i.getModel([l4, n2]);
    }
    return e2;
  }
  function Ef(i, n2, e2, o, l4) {
    var c4 = {};
    return kut(c4, i, e2, o, l4), n2 && rr(c4, n2), c4;
  }
  function DH(i, n2, e2) {
    n2 = n2 || {};
    var o = {}, l4, c4 = i.getShallow("rotate"), h = so(i.getShallow("distance"), e2 ? null : 5), p4 = i.getShallow("offset");
    return l4 = i.getShallow("position") || (e2 ? null : "inside"), l4 === "outside" && (l4 = n2.defaultOutsidePosition || "top"), l4 != null && (o.position = l4), p4 != null && (o.offset = p4), c4 != null && (c4 *= Math.PI / 180, o.rotation = c4), h != null && (o.distance = h), o.outsideFill = i.get("color") === "inherit" ? n2.inheritColor || null : "auto", o;
  }
  function kut(i, n2, e2, o, l4) {
    e2 = e2 || k$;
    var c4 = n2.ecModel, h = c4 && c4.option.textStyle, p4 = Put(n2), g4;
    if (p4) {
      g4 = {};
      for (var y4 in p4)
        if (p4.hasOwnProperty(y4)) {
          var _ = n2.getModel(["rich", y4]);
          Xwe(g4[y4] = {}, _, h, e2, o, l4, false, true);
        }
    }
    g4 && (i.rich = g4);
    var w4 = n2.get("overflow");
    w4 && (i.overflow = w4);
    var C = n2.get("minMargin");
    C != null && (i.margin = C), Xwe(i, n2, h, e2, o, l4, true, false);
  }
  function Put(i) {
    for (var n2; i && i !== i.ecModel; ) {
      var e2 = (i.option || k$).rich;
      if (e2) {
        n2 = n2 || {};
        for (var o = ts(e2), l4 = 0; l4 < o.length; l4++) {
          var c4 = o[l4];
          n2[c4] = 1;
        }
      }
      i = i.parentModel;
    }
    return n2;
  }
  var qwe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], Ywe = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], Zwe = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
  function Xwe(i, n2, e2, o, l4, c4, h, p4) {
    e2 = !l4 && e2 || k$;
    var g4 = o && o.inheritColor, y4 = n2.getShallow("color"), _ = n2.getShallow("textBorderColor"), w4 = so(n2.getShallow("opacity"), e2.opacity);
    (y4 === "inherit" || y4 === "auto") && (g4 ? y4 = g4 : y4 = null), (_ === "inherit" || _ === "auto") && (g4 ? _ = g4 : _ = null), c4 || (y4 = y4 || e2.color, _ = _ || e2.textBorderColor), y4 != null && (i.fill = y4), _ != null && (i.stroke = _);
    var C = so(n2.getShallow("textBorderWidth"), e2.textBorderWidth);
    C != null && (i.lineWidth = C);
    var E = so(n2.getShallow("textBorderType"), e2.textBorderType);
    E != null && (i.lineDash = E);
    var T = so(n2.getShallow("textBorderDashOffset"), e2.textBorderDashOffset);
    T != null && (i.lineDashOffset = T), !l4 && w4 == null && !p4 && (w4 = o && o.defaultOpacity), w4 != null && (i.opacity = w4), !l4 && !c4 && i.fill == null && o.inheritColor && (i.fill = o.inheritColor);
    for (var O = 0; O < qwe.length; O++) {
      var N = qwe[O], V = so(n2.getShallow(N), e2[N]);
      V != null && (i[N] = V);
    }
    for (var O = 0; O < Ywe.length; O++) {
      var N = Ywe[O], V = n2.getShallow(N);
      V != null && (i[N] = V);
    }
    if (i.verticalAlign == null) {
      var H = n2.getShallow("baseline");
      H != null && (i.verticalAlign = H);
    }
    if (!h || !o.disableBox) {
      for (var O = 0; O < Zwe.length; O++) {
        var N = Zwe[O], V = n2.getShallow(N);
        V != null && (i[N] = V);
      }
      var X = n2.getShallow("borderType");
      X != null && (i.borderDash = X), (i.backgroundColor === "auto" || i.backgroundColor === "inherit") && g4 && (i.backgroundColor = g4), (i.borderColor === "auto" || i.borderColor === "inherit") && g4 && (i.borderColor = g4);
    }
  }
  function rDe(i, n2) {
    var e2 = n2 && n2.getModel("textStyle");
    return tb([i.fontStyle || e2 && e2.getShallow("fontStyle") || "", i.fontWeight || e2 && e2.getShallow("fontWeight") || "", (i.fontSize || e2 && e2.getShallow("fontSize") || 12) + "px", i.fontFamily || e2 && e2.getShallow("fontFamily") || "sans-serif"].join(" "));
  }
  var Y3 = zs();
  function aDe(i, n2, e2, o) {
    if (!!i) {
      var l4 = Y3(i);
      l4.prevValue = l4.value, l4.value = e2;
      var c4 = n2.normal;
      l4.valueAnimation = c4.get("valueAnimation"), l4.valueAnimation && (l4.precision = c4.get("precision"), l4.defaultInterpolatedText = o, l4.statesModels = n2);
    }
  }
  function iDe(i, n2, e2, o, l4) {
    var c4 = Y3(i);
    if (!c4.valueAnimation || c4.prevValue === c4.value)
      return;
    var h = c4.defaultInterpolatedText, p4 = so(c4.interpolatedValue, c4.prevValue), g4 = c4.value;
    function y4(_) {
      var w4 = oTe(e2, c4.precision, p4, g4, _);
      c4.interpolatedValue = _ === 1 ? null : w4;
      var C = noe({ labelDataIndex: n2, labelFetcher: l4, defaultText: h ? h(w4) : w4 + "" }, c4.statesModels, w4);
      nDe(i, C);
    }
    i.percent = 0, (c4.prevValue == null ? bc : Vs)(i, { percent: 1 }, o, n2, null, y4);
  }
  var Lut = ["textStyle", "color"], Are = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], Ere = new Qs(), Out = function() {
    function i() {
    }
    return i.prototype.getTextColor = function(n2) {
      var e2 = this.ecModel;
      return this.getShallow("color") || (!n2 && e2 ? e2.get(Lut) : null);
    }, i.prototype.getFont = function() {
      return rDe({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
    }, i.prototype.getTextRect = function(n2) {
      for (var e2 = { text: n2, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, o = 0; o < Are.length; o++)
        e2[Are[o]] = this.getShallow(Are[o]);
      return Ere.useStyle(e2), Ere.update(), Ere.getBoundingRect();
    }, i;
  }(), Rut = Out, oDe = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], Fut = bT(oDe), Nut = function() {
    function i() {
    }
    return i.prototype.getLineStyle = function(n2) {
      return Fut(this, n2);
    }, i;
  }(), sDe = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], Vut = bT(sDe), zut = function() {
    function i() {
    }
    return i.prototype.getItemStyle = function(n2, e2) {
      return Vut(this, n2, e2);
    }, i;
  }(), AT = function() {
    function i(n2, e2, o) {
      this.parentModel = e2, this.ecModel = o, this.option = n2;
    }
    return i.prototype.init = function(n2, e2, o) {
      for (var l4 = [], c4 = 3; c4 < arguments.length; c4++)
        l4[c4 - 3] = arguments[c4];
    }, i.prototype.mergeOption = function(n2, e2) {
      to(this.option, n2, true);
    }, i.prototype.get = function(n2, e2) {
      return n2 == null ? this.option : this._doGet(this.parsePath(n2), !e2 && this.parentModel);
    }, i.prototype.getShallow = function(n2, e2) {
      var o = this.option, l4 = o == null ? o : o[n2];
      if (l4 == null && !e2) {
        var c4 = this.parentModel;
        c4 && (l4 = c4.getShallow(n2));
      }
      return l4;
    }, i.prototype.getModel = function(n2, e2) {
      var o = n2 != null, l4 = o ? this.parsePath(n2) : null, c4 = o ? this._doGet(l4) : this.option;
      return e2 = e2 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(l4)), new i(c4, e2, this.ecModel);
    }, i.prototype.isEmpty = function() {
      return this.option == null;
    }, i.prototype.restoreData = function() {
    }, i.prototype.clone = function() {
      var n2 = this.constructor;
      return new n2(Ci(this.option));
    }, i.prototype.parsePath = function(n2) {
      return typeof n2 == "string" ? n2.split(".") : n2;
    }, i.prototype.resolveParentPath = function(n2) {
      return n2;
    }, i.prototype.isAnimationEnabled = function() {
      if (!ol.node && this.option) {
        if (this.option.animation != null)
          return !!this.option.animation;
        if (this.parentModel)
          return this.parentModel.isAnimationEnabled();
      }
    }, i.prototype._doGet = function(n2, e2) {
      var o = this.option;
      if (!n2)
        return o;
      for (var l4 = 0; l4 < n2.length && !(!!n2[l4] && (o = o && typeof o == "object" ? o[n2[l4]] : null, o == null)); l4++)
        ;
      return o == null && e2 && (o = e2._doGet(this.resolveParentPath(n2), e2.parentModel)), o;
    }, i;
  }();
  Gse(AT);
  Fst(AT);
  Kf(AT, Nut);
  Kf(AT, zut);
  Kf(AT, jst);
  Kf(AT, Rut);
  var Ou = AT, But = Math.round(Math.random() * 10);
  function Z3(i) {
    return [i || "", But++].join("_");
  }
  function jut(i) {
    var n2 = {};
    i.registerSubTypeDefaulter = function(e2, o) {
      var l4 = B_(e2);
      n2[l4.main] = o;
    }, i.determineSubType = function(e2, o) {
      var l4 = o.type;
      if (!l4) {
        var c4 = B_(e2).main;
        i.hasSubTypes(e2) && n2[c4] && (l4 = n2[c4](o));
      }
      return l4;
    };
  }
  function Gut(i, n2) {
    i.topologicalTravel = function(c4, h, p4, g4) {
      if (!c4.length)
        return;
      var y4 = e2(h), _ = y4.graph, w4 = y4.noEntryList, C = {};
      for (Ve(c4, function(H) {
        C[H] = true;
      }); w4.length; ) {
        var E = w4.pop(), T = _[E], O = !!C[E];
        O && (p4.call(g4, E, T.originalDeps.slice()), delete C[E]), Ve(T.successor, O ? V : N);
      }
      Ve(C, function() {
        var H = "";
        throw new Error(H);
      });
      function N(H) {
        _[H].entryCount--, _[H].entryCount === 0 && w4.push(H);
      }
      function V(H) {
        C[H] = true, N(H);
      }
    };
    function e2(c4) {
      var h = {}, p4 = [];
      return Ve(c4, function(g4) {
        var y4 = o(h, g4), _ = y4.originalDeps = n2(g4), w4 = l4(_, c4);
        y4.entryCount = w4.length, y4.entryCount === 0 && p4.push(g4), Ve(w4, function(C) {
          go(y4.predecessor, C) < 0 && y4.predecessor.push(C);
          var E = o(h, C);
          go(E.successor, C) < 0 && E.successor.push(g4);
        });
      }), { graph: h, noEntryList: p4 };
    }
    function o(c4, h) {
      return c4[h] || (c4[h] = { predecessor: [], successor: [] }), c4[h];
    }
    function l4(c4, h) {
      var p4 = [];
      return Ve(c4, function(g4) {
        go(h, g4) >= 0 && p4.push(g4);
      }), p4;
    }
  }
  function sM(i, n2) {
    return to(to({}, i, true), n2, true);
  }
  var Wut = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, Hut = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, kH = "ZH", ele = "EN", d8 = ele, iH = {}, tle = {}, lDe = ol.domSupported ? function() {
    var i = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
    return i.indexOf(kH) > -1 ? kH : d8;
  }() : d8;
  function uDe(i, n2) {
    i = i.toUpperCase(), tle[i] = new Ou(n2), iH[i] = n2;
  }
  function $ut(i) {
    if (xa(i)) {
      var n2 = iH[i.toUpperCase()] || {};
      return i === kH || i === ele ? Ci(n2) : to(Ci(n2), Ci(iH[d8]), false);
    } else
      return to(Ci(i), Ci(iH[d8]), false);
  }
  function roe(i) {
    return tle[i];
  }
  function Uut() {
    return tle[d8];
  }
  uDe(ele, Wut);
  uDe(kH, Hut);
  var nle = 1e3, rle = nle * 60, qN = rle * 60, Py = qN * 24, Kwe = Py * 365, kN = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, rW = "{yyyy}-{MM}-{dd}", Jwe = { year: "{yyyy}", month: "{yyyy}-{MM}", day: rW, hour: rW + " " + kN.hour, minute: rW + " " + kN.minute, second: rW + " " + kN.second, millisecond: kN.none }, Ire = ["year", "month", "day", "hour", "minute", "second", "millisecond"], cDe = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
  function OI(i, n2) {
    return i += "", "0000".substr(0, n2 - i.length) + i;
  }
  function I3(i) {
    switch (i) {
      case "half-year":
      case "quarter":
        return "month";
      case "week":
      case "half-week":
        return "day";
      case "half-day":
      case "quarter-day":
        return "hour";
      default:
        return i;
    }
  }
  function qut(i) {
    return i === I3(i);
  }
  function Yut(i) {
    switch (i) {
      case "year":
      case "month":
        return "day";
      case "millisecond":
        return "millisecond";
      default:
        return "second";
    }
  }
  function P$(i, n2, e2, o) {
    var l4 = X_(i), c4 = l4[ale(e2)](), h = l4[T3(e2)]() + 1, p4 = Math.floor((h - 1) / 4) + 1, g4 = l4[L$(e2)](), y4 = l4["get" + (e2 ? "UTC" : "") + "Day"](), _ = l4[p8(e2)](), w4 = (_ - 1) % 12 + 1, C = l4[O$(e2)](), E = l4[R$(e2)](), T = l4[F$(e2)](), O = o instanceof Ou ? o : roe(o || lDe) || Uut(), N = O.getModel("time"), V = N.get("month"), H = N.get("monthAbbr"), X = N.get("dayOfWeek"), q2 = N.get("dayOfWeekAbbr");
    return (n2 || "").replace(/{yyyy}/g, c4 + "").replace(/{yy}/g, c4 % 100 + "").replace(/{Q}/g, p4 + "").replace(/{MMMM}/g, V[h - 1]).replace(/{MMM}/g, H[h - 1]).replace(/{MM}/g, OI(h, 2)).replace(/{M}/g, h + "").replace(/{dd}/g, OI(g4, 2)).replace(/{d}/g, g4 + "").replace(/{eeee}/g, X[y4]).replace(/{ee}/g, q2[y4]).replace(/{e}/g, y4 + "").replace(/{HH}/g, OI(_, 2)).replace(/{H}/g, _ + "").replace(/{hh}/g, OI(w4 + "", 2)).replace(/{h}/g, w4 + "").replace(/{mm}/g, OI(C, 2)).replace(/{m}/g, C + "").replace(/{ss}/g, OI(E, 2)).replace(/{s}/g, E + "").replace(/{SSS}/g, OI(T, 3)).replace(/{S}/g, T + "");
  }
  function Zut(i, n2, e2, o, l4) {
    var c4 = null;
    if (xa(e2))
      c4 = e2;
    else if (si(e2))
      c4 = e2(i.value, n2, { level: i.level });
    else {
      var h = rr({}, kN);
      if (i.level > 0)
        for (var p4 = 0; p4 < Ire.length; ++p4)
          h[Ire[p4]] = "{primary|" + h[Ire[p4]] + "}";
      var g4 = e2 ? e2.inherit === false ? e2 : hi(e2, h) : h, y4 = fDe(i.value, l4);
      if (g4[y4])
        c4 = g4[y4];
      else if (g4.inherit) {
        for (var _ = cDe.indexOf(y4), p4 = _ - 1; p4 >= 0; --p4)
          if (g4[y4]) {
            c4 = g4[y4];
            break;
          }
        c4 = c4 || h.none;
      }
      if (Mr(c4)) {
        var w4 = i.level == null ? 0 : i.level >= 0 ? i.level : c4.length + i.level;
        w4 = Math.min(w4, c4.length - 1), c4 = c4[w4];
      }
    }
    return P$(new Date(i.value), c4, l4, o);
  }
  function fDe(i, n2) {
    var e2 = X_(i), o = e2[T3(n2)]() + 1, l4 = e2[L$(n2)](), c4 = e2[p8(n2)](), h = e2[O$(n2)](), p4 = e2[R$(n2)](), g4 = e2[F$(n2)](), y4 = g4 === 0, _ = y4 && p4 === 0, w4 = _ && h === 0, C = w4 && c4 === 0, E = C && l4 === 1, T = E && o === 1;
    return T ? "year" : E ? "month" : C ? "day" : w4 ? "hour" : _ ? "minute" : y4 ? "second" : "millisecond";
  }
  function Qwe(i, n2, e2) {
    var o = sl(i) ? X_(i) : i;
    switch (n2 = n2 || fDe(i, e2), n2) {
      case "year":
        return o[ale(e2)]();
      case "half-year":
        return o[T3(e2)]() >= 6 ? 1 : 0;
      case "quarter":
        return Math.floor((o[T3(e2)]() + 1) / 4);
      case "month":
        return o[T3(e2)]();
      case "day":
        return o[L$(e2)]();
      case "half-day":
        return o[p8(e2)]() / 24;
      case "hour":
        return o[p8(e2)]();
      case "minute":
        return o[O$(e2)]();
      case "second":
        return o[R$(e2)]();
      case "millisecond":
        return o[F$(e2)]();
    }
  }
  function ale(i) {
    return i ? "getUTCFullYear" : "getFullYear";
  }
  function T3(i) {
    return i ? "getUTCMonth" : "getMonth";
  }
  function L$(i) {
    return i ? "getUTCDate" : "getDate";
  }
  function p8(i) {
    return i ? "getUTCHours" : "getHours";
  }
  function O$(i) {
    return i ? "getUTCMinutes" : "getMinutes";
  }
  function R$(i) {
    return i ? "getUTCSeconds" : "getSeconds";
  }
  function F$(i) {
    return i ? "getUTCMilliseconds" : "getMilliseconds";
  }
  function Xut(i) {
    return i ? "setUTCFullYear" : "setFullYear";
  }
  function hDe(i) {
    return i ? "setUTCMonth" : "setMonth";
  }
  function dDe(i) {
    return i ? "setUTCDate" : "setDate";
  }
  function pDe(i) {
    return i ? "setUTCHours" : "setHours";
  }
  function vDe(i) {
    return i ? "setUTCMinutes" : "setMinutes";
  }
  function gDe(i) {
    return i ? "setUTCSeconds" : "setSeconds";
  }
  function mDe(i) {
    return i ? "setUTCMilliseconds" : "setMilliseconds";
  }
  function yDe(i) {
    if (!JIe(i))
      return xa(i) ? i : "-";
    var n2 = (i + "").split(".");
    return n2[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (n2.length > 1 ? "." + n2[1] : "");
  }
  function bDe(i, n2) {
    return i = (i || "").toLowerCase().replace(/-(.)/g, function(e2, o) {
      return o.toUpperCase();
    }), n2 && i && (i = i.charAt(0).toUpperCase() + i.slice(1)), i;
  }
  var X3 = Pse, Kut = /([&<>"'])/g, Jut = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
  function Q0(i) {
    return i == null ? "" : (i + "").replace(Kut, function(n2, e2) {
      return Jut[e2];
    });
  }
  function aoe(i, n2, e2) {
    var o = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
    function l4(_) {
      return _ && tb(_) ? _ : "-";
    }
    function c4(_) {
      return !!(_ != null && !isNaN(_) && isFinite(_));
    }
    var h = n2 === "time", p4 = i instanceof Date;
    if (h || p4) {
      var g4 = h ? X_(i) : i;
      if (isNaN(+g4)) {
        if (p4)
          return "-";
      } else
        return P$(g4, o, e2);
    }
    if (n2 === "ordinal")
      return wie(i) ? l4(i) : sl(i) && c4(i) ? i + "" : "-";
    var y4 = _2(i);
    return c4(y4) ? yDe(y4) : wie(i) ? l4(i) : typeof i == "boolean" ? i + "" : "-";
  }
  var e2e = ["a", "b", "c", "d", "e", "f", "g"], Tre = function(i, n2) {
    return "{" + i + (n2 == null ? "" : n2) + "}";
  };
  function _De(i, n2, e2) {
    Mr(n2) || (n2 = [n2]);
    var o = n2.length;
    if (!o)
      return "";
    for (var l4 = n2[0].$vars || [], c4 = 0; c4 < l4.length; c4++) {
      var h = e2e[c4];
      i = i.replace(Tre(h), Tre(h, 0));
    }
    for (var p4 = 0; p4 < o; p4++)
      for (var g4 = 0; g4 < l4.length; g4++) {
        var y4 = n2[p4][l4[g4]];
        i = i.replace(Tre(e2e[g4], p4), e2 ? Q0(y4) : y4);
      }
    return i;
  }
  function Qut(i, n2, e2) {
    return Ve(n2, function(o, l4) {
      i = i.replace("{" + l4 + "}", e2 ? Q0(o) : o);
    }), i;
  }
  function ect(i, n2) {
    var e2 = xa(i) ? { color: i, extraCssText: n2 } : i || {}, o = e2.color, l4 = e2.type;
    n2 = e2.extraCssText;
    var c4 = e2.renderMode || "html";
    if (!o)
      return "";
    if (c4 === "html")
      return l4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + Q0(o) + ";" + (n2 || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + Q0(o) + ";" + (n2 || "") + '"></span>';
    var h = e2.markerId || "markerX";
    return { renderMode: c4, content: "{" + h + "|}  ", style: l4 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: o } : { width: 10, height: 10, borderRadius: 5, backgroundColor: o } };
  }
  function xT(i, n2) {
    return n2 = n2 || "transparent", xa(i) ? i : mi(i) && i.colorStops && (i.colorStops[0] || {}).color || n2;
  }
  function PH(i, n2) {
    if (n2 === "_blank" || n2 === "blank") {
      var e2 = window.open();
      e2.opener = null, e2.location.href = i;
    } else
      window.open(i, n2);
  }
  var oH = Ve, xDe = ["left", "right", "top", "bottom", "width", "height"], iT = [["width", "left", "right"], ["height", "top", "bottom"]];
  function ile(i, n2, e2, o, l4) {
    var c4 = 0, h = 0;
    o == null && (o = 1 / 0), l4 == null && (l4 = 1 / 0);
    var p4 = 0;
    n2.eachChild(function(g4, y4) {
      var _ = g4.getBoundingRect(), w4 = n2.childAt(y4 + 1), C = w4 && w4.getBoundingRect(), E, T;
      if (i === "horizontal") {
        var O = _.width + (C ? -C.x + _.x : 0);
        E = c4 + O, E > o || g4.newline ? (c4 = 0, E = O, h += p4 + e2, p4 = _.height) : p4 = Math.max(p4, _.height);
      } else {
        var N = _.height + (C ? -C.y + _.y : 0);
        T = h + N, T > l4 || g4.newline ? (c4 += p4 + e2, h = 0, T = N, p4 = _.width) : p4 = Math.max(p4, _.width);
      }
      g4.newline || (g4.x = c4, g4.y = h, g4.markRedraw(), i === "horizontal" ? c4 = E + e2 : h = T + e2);
    });
  }
  var dT = ile;
  zi(ile, "vertical");
  zi(ile, "horizontal");
  function tct(i, n2, e2) {
    var o = n2.width, l4 = n2.height, c4 = ma(i.left, o), h = ma(i.top, l4), p4 = ma(i.right, o), g4 = ma(i.bottom, l4);
    return (isNaN(c4) || isNaN(parseFloat(i.left))) && (c4 = 0), (isNaN(p4) || isNaN(parseFloat(i.right))) && (p4 = o), (isNaN(h) || isNaN(parseFloat(i.top))) && (h = 0), (isNaN(g4) || isNaN(parseFloat(i.bottom))) && (g4 = l4), e2 = X3(e2 || 0), { width: Math.max(p4 - c4 - e2[1] - e2[3], 0), height: Math.max(g4 - h - e2[0] - e2[2], 0) };
  }
  function bh(i, n2, e2) {
    e2 = X3(e2 || 0);
    var o = n2.width, l4 = n2.height, c4 = ma(i.left, o), h = ma(i.top, l4), p4 = ma(i.right, o), g4 = ma(i.bottom, l4), y4 = ma(i.width, o), _ = ma(i.height, l4), w4 = e2[2] + e2[0], C = e2[1] + e2[3], E = i.aspect;
    switch (isNaN(y4) && (y4 = o - p4 - C - c4), isNaN(_) && (_ = l4 - g4 - w4 - h), E != null && (isNaN(y4) && isNaN(_) && (E > o / l4 ? y4 = o * 0.8 : _ = l4 * 0.8), isNaN(y4) && (y4 = E * _), isNaN(_) && (_ = y4 / E)), isNaN(c4) && (c4 = o - p4 - y4 - C), isNaN(h) && (h = l4 - g4 - _ - w4), i.left || i.right) {
      case "center":
        c4 = o / 2 - y4 / 2 - e2[3];
        break;
      case "right":
        c4 = o - y4 - C;
        break;
    }
    switch (i.top || i.bottom) {
      case "middle":
      case "center":
        h = l4 / 2 - _ / 2 - e2[0];
        break;
      case "bottom":
        h = l4 - _ - w4;
        break;
    }
    c4 = c4 || 0, h = h || 0, isNaN(y4) && (y4 = o - C - c4 - (p4 || 0)), isNaN(_) && (_ = l4 - w4 - h - (g4 || 0));
    var T = new mo(c4 + e2[3], h + e2[0], y4, _);
    return T.margin = e2, T;
  }
  function N$(i, n2, e2, o, l4, c4) {
    var h = !l4 || !l4.hv || l4.hv[0], p4 = !l4 || !l4.hv || l4.hv[1], g4 = l4 && l4.boundingMode || "all";
    if (c4 = c4 || i, c4.x = i.x, c4.y = i.y, !h && !p4)
      return false;
    var y4;
    if (g4 === "raw")
      y4 = i.type === "group" ? new mo(0, 0, +n2.width || 0, +n2.height || 0) : i.getBoundingRect();
    else if (y4 = i.getBoundingRect(), i.needLocalTransform()) {
      var _ = i.getLocalTransform();
      y4 = y4.clone(), y4.applyTransform(_);
    }
    var w4 = bh(hi({ width: y4.width, height: y4.height }, n2), e2, o), C = h ? w4.x - y4.x : 0, E = p4 ? w4.y - y4.y : 0;
    return g4 === "raw" ? (c4.x = C, c4.y = E) : (c4.x += C, c4.y += E), c4 === i && i.markRedraw(), true;
  }
  function nct(i, n2) {
    return i[iT[n2][0]] != null || i[iT[n2][1]] != null && i[iT[n2][2]] != null;
  }
  function v8(i) {
    var n2 = i.layoutMode || i.constructor.layoutMode;
    return mi(n2) ? n2 : n2 ? { type: n2 } : null;
  }
  function QC(i, n2, e2) {
    var o = e2 && e2.ignoreSize;
    !Mr(o) && (o = [o, o]);
    var l4 = h(iT[0], 0), c4 = h(iT[1], 1);
    y4(iT[0], i, l4), y4(iT[1], i, c4);
    function h(_, w4) {
      var C = {}, E = 0, T = {}, O = 0, N = 2;
      if (oH(_, function(X) {
        T[X] = i[X];
      }), oH(_, function(X) {
        p4(n2, X) && (C[X] = T[X] = n2[X]), g4(C, X) && E++, g4(T, X) && O++;
      }), o[w4])
        return g4(n2, _[1]) ? T[_[2]] = null : g4(n2, _[2]) && (T[_[1]] = null), T;
      if (O === N || !E)
        return T;
      if (E >= N)
        return C;
      for (var V = 0; V < _.length; V++) {
        var H = _[V];
        if (!p4(C, H) && p4(i, H)) {
          C[H] = i[H];
          break;
        }
      }
      return C;
    }
    function p4(_, w4) {
      return _.hasOwnProperty(w4);
    }
    function g4(_, w4) {
      return _[w4] != null && _[w4] !== "auto";
    }
    function y4(_, w4, C) {
      oH(_, function(E) {
        w4[E] = C[E];
      });
    }
  }
  function K3(i) {
    return wDe({}, i);
  }
  function wDe(i, n2) {
    return n2 && i && oH(xDe, function(e2) {
      n2.hasOwnProperty(e2) && (i[e2] = n2[e2]);
    }), i;
  }
  var rct = zs(), J3 = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this, e2, o, l4) || this;
      return c4.uid = Z3("ec_cpt_model"), c4;
    }
    return n2.prototype.init = function(e2, o, l4) {
      this.mergeDefaultAndTheme(e2, l4);
    }, n2.prototype.mergeDefaultAndTheme = function(e2, o) {
      var l4 = v8(this), c4 = l4 ? K3(e2) : {}, h = o.getTheme();
      to(e2, h.get(this.mainType)), to(e2, this.getDefaultOption()), l4 && QC(e2, c4, l4);
    }, n2.prototype.mergeOption = function(e2, o) {
      to(this.option, e2, true);
      var l4 = v8(this);
      l4 && QC(this.option, e2, l4);
    }, n2.prototype.optionUpdated = function(e2, o) {
    }, n2.prototype.getDefaultOption = function() {
      var e2 = this.constructor;
      if (!Lst(e2))
        return e2.defaultOption;
      var o = rct(this);
      if (!o.defaultOption) {
        for (var l4 = [], c4 = e2; c4; ) {
          var h = c4.prototype.defaultOption;
          h && l4.push(h), c4 = c4.superClass;
        }
        for (var p4 = {}, g4 = l4.length - 1; g4 >= 0; g4--)
          p4 = to(p4, l4[g4], true);
        o.defaultOption = p4;
      }
      return o.defaultOption;
    }, n2.prototype.getReferringComponents = function(e2, o) {
      var l4 = e2 + "Index", c4 = e2 + "Id";
      return V8(this.ecModel, e2, { index: this.get(l4, true), id: this.get(c4, true) }, o);
    }, n2.prototype.getBoxLayoutParams = function() {
      var e2 = this;
      return { left: e2.get("left"), top: e2.get("top"), right: e2.get("right"), bottom: e2.get("bottom"), width: e2.get("width"), height: e2.get("height") };
    }, n2.prototype.getZLevelKey = function() {
      return "";
    }, n2.prototype.setZLevel = function(e2) {
      this.option.zlevel = e2;
    }, n2.protoInitialize = function() {
      var e2 = n2.prototype;
      e2.type = "component", e2.id = "", e2.name = "", e2.mainType = "", e2.subType = "", e2.componentIndex = 0;
    }(), n2;
  }(Ou);
  lTe(J3, Ou);
  x$(J3);
  jut(J3);
  Gut(J3, act);
  function act(i) {
    var n2 = [];
    return Ve(J3.getClassesByMainType(i), function(e2) {
      n2 = n2.concat(e2.dependencies || e2.prototype.dependencies || []);
    }), n2 = Er(n2, function(e2) {
      return B_(e2).main;
    }), i !== "dataset" && go(n2, "dataset") <= 0 && n2.unshift("dataset"), n2;
  }
  var Ns = J3, SDe = "";
  typeof navigator != "undefined" && (SDe = navigator.platform || "");
  var KP = "rgba(0, 0, 0, 0.2)", ict = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: KP, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: KP, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: KP, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: KP, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: KP, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: KP, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: SDe.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, CDe = ri(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), By = "original", mv = "arrayRows", jy = "objectRows", Q_ = "keyedColumns", qC = "typedArray", MDe = "unknown", $_ = "column", Q3 = "row", wp = { Must: 1, Might: 2, Not: 3 }, ADe = zs();
  function oct(i) {
    ADe(i).datasetMap = ri();
  }
  function EDe(i, n2, e2) {
    var o = {}, l4 = sle(n2);
    if (!l4 || !i)
      return o;
    var c4 = [], h = [], p4 = n2.ecModel, g4 = ADe(p4).datasetMap, y4 = l4.uid + "_" + e2.seriesLayoutBy, _, w4;
    i = i.slice(), Ve(i, function(O, N) {
      var V = mi(O) ? O : i[N] = { name: O };
      V.type === "ordinal" && _ == null && (_ = N, w4 = T(V)), o[V.name] = [];
    });
    var C = g4.get(y4) || g4.set(y4, { categoryWayDim: w4, valueWayDim: 0 });
    Ve(i, function(O, N) {
      var V = O.name, H = T(O);
      if (_ == null) {
        var X = C.valueWayDim;
        E(o[V], X, H), E(h, X, H), C.valueWayDim += H;
      } else if (_ === N)
        E(o[V], 0, H), E(c4, 0, H);
      else {
        var X = C.categoryWayDim;
        E(o[V], X, H), E(h, X, H), C.categoryWayDim += H;
      }
    });
    function E(O, N, V) {
      for (var H = 0; H < V; H++)
        O.push(N + H);
    }
    function T(O) {
      var N = O.dimsDef;
      return N ? N.length : 1;
    }
    return c4.length && (o.itemName = c4), h.length && (o.seriesName = h), o;
  }
  function ole(i, n2, e2) {
    var o = {}, l4 = sle(i);
    if (!l4)
      return o;
    var c4 = n2.sourceFormat, h = n2.dimensionsDefine, p4;
    (c4 === jy || c4 === Q_) && Ve(h, function(_, w4) {
      (mi(_) ? _.name : _) === "name" && (p4 = w4);
    });
    var g4 = function() {
      for (var _ = {}, w4 = {}, C = [], E = 0, T = Math.min(5, e2); E < T; E++) {
        var O = TDe(n2.data, c4, n2.seriesLayoutBy, h, n2.startIndex, E);
        C.push(O);
        var N = O === wp.Not;
        if (N && _.v == null && E !== p4 && (_.v = E), (_.n == null || _.n === _.v || !N && C[_.n] === wp.Not) && (_.n = E), V(_) && C[_.n] !== wp.Not)
          return _;
        N || (O === wp.Might && w4.v == null && E !== p4 && (w4.v = E), (w4.n == null || w4.n === w4.v) && (w4.n = E));
      }
      function V(H) {
        return H.v != null && H.n != null;
      }
      return V(_) ? _ : V(w4) ? w4 : null;
    }();
    if (g4) {
      o.value = [g4.v];
      var y4 = p4 != null ? p4 : g4.n;
      o.itemName = [y4], o.seriesName = [y4];
    }
    return o;
  }
  function sle(i) {
    var n2 = i.get("data", true);
    if (!n2)
      return V8(i.ecModel, "dataset", { index: i.get("datasetIndex", true), id: i.get("datasetId", true) }, Yf).models[0];
  }
  function sct(i) {
    return !i.get("transform", true) && !i.get("fromTransformResult", true) ? [] : V8(i.ecModel, "dataset", { index: i.get("fromDatasetIndex", true), id: i.get("fromDatasetId", true) }, Yf).models;
  }
  function IDe(i, n2) {
    return TDe(i.data, i.sourceFormat, i.seriesLayoutBy, i.dimensionsDefine, i.startIndex, n2);
  }
  function TDe(i, n2, e2, o, l4, c4) {
    var h, p4 = 5;
    if (am(i))
      return wp.Not;
    var g4, y4;
    if (o) {
      var _ = o[c4];
      mi(_) ? (g4 = _.name, y4 = _.type) : xa(_) && (g4 = _);
    }
    if (y4 != null)
      return y4 === "ordinal" ? wp.Must : wp.Not;
    if (n2 === mv) {
      var w4 = i;
      if (e2 === Q3) {
        for (var C = w4[c4], E = 0; E < (C || []).length && E < p4; E++)
          if ((h = q2(C[l4 + E])) != null)
            return h;
      } else
        for (var E = 0; E < w4.length && E < p4; E++) {
          var T = w4[l4 + E];
          if (T && (h = q2(T[c4])) != null)
            return h;
        }
    } else if (n2 === jy) {
      var O = i;
      if (!g4)
        return wp.Not;
      for (var E = 0; E < O.length && E < p4; E++) {
        var N = O[E];
        if (N && (h = q2(N[g4])) != null)
          return h;
      }
    } else if (n2 === Q_) {
      var V = i;
      if (!g4)
        return wp.Not;
      var C = V[g4];
      if (!C || am(C))
        return wp.Not;
      for (var E = 0; E < C.length && E < p4; E++)
        if ((h = q2(C[E])) != null)
          return h;
    } else if (n2 === By)
      for (var H = i, E = 0; E < H.length && E < p4; E++) {
        var N = H[E], X = H3(N);
        if (!Mr(X))
          return wp.Not;
        if ((h = q2(X[c4])) != null)
          return h;
      }
    function q2(de) {
      var le = xa(de);
      if (de != null && isFinite(de) && de !== "")
        return le ? wp.Might : wp.Not;
      if (le && de !== "-")
        return wp.Must;
    }
    return wp.Not;
  }
  var ioe = ri();
  function lct(i, n2) {
    Kv(ioe.get(i) == null && n2), ioe.set(i, n2);
  }
  function uct(i, n2, e2) {
    var o = ioe.get(n2);
    if (!o)
      return e2;
    var l4 = o(i);
    return l4 ? e2.concat(l4) : e2;
  }
  var t2e = zs(), cct = zs(), lle = function() {
    function i() {
    }
    return i.prototype.getColorFromPalette = function(n2, e2, o) {
      var l4 = Zl(this.get("color", true)), c4 = this.get("colorLayer", true);
      return DDe(this, t2e, l4, c4, n2, e2, o);
    }, i.prototype.clearColorPalette = function() {
      hct(this, t2e);
    }, i;
  }();
  function ooe(i, n2, e2, o) {
    var l4 = Zl(i.get(["aria", "decal", "decals"]));
    return DDe(i, cct, l4, null, n2, e2, o);
  }
  function fct(i, n2) {
    for (var e2 = i.length, o = 0; o < e2; o++)
      if (i[o].length > n2)
        return i[o];
    return i[e2 - 1];
  }
  function DDe(i, n2, e2, o, l4, c4, h) {
    c4 = c4 || i;
    var p4 = n2(c4), g4 = p4.paletteIdx || 0, y4 = p4.paletteNameMap = p4.paletteNameMap || {};
    if (y4.hasOwnProperty(l4))
      return y4[l4];
    var _ = h == null || !o ? e2 : fct(o, h);
    if (_ = _ || e2, !(!_ || !_.length)) {
      var w4 = _[g4];
      return l4 && (y4[l4] = w4), p4.paletteIdx = (g4 + 1) % _.length, w4;
    }
  }
  function hct(i, n2) {
    n2(i).paletteIdx = 0, n2(i).paletteNameMap = {};
  }
  var aW, nN, n2e, r2e = "\0_ec_inner", dct = 1, kDe = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.init = function(e2, o, l4, c4, h, p4) {
      c4 = c4 || {}, this.option = null, this._theme = new Ou(c4), this._locale = new Ou(h), this._optionManager = p4;
    }, n2.prototype.setOption = function(e2, o, l4) {
      var c4 = o2e(o);
      this._optionManager.setOption(e2, l4, c4), this._resetOption(null, c4);
    }, n2.prototype.resetOption = function(e2, o) {
      return this._resetOption(e2, o2e(o));
    }, n2.prototype._resetOption = function(e2, o) {
      var l4 = false, c4 = this._optionManager;
      if (!e2 || e2 === "recreate") {
        var h = c4.mountOption(e2 === "recreate");
        !this.option || e2 === "recreate" ? n2e(this, h) : (this.restoreData(), this._mergeOption(h, o)), l4 = true;
      }
      if ((e2 === "timeline" || e2 === "media") && this.restoreData(), !e2 || e2 === "recreate" || e2 === "timeline") {
        var p4 = c4.getTimelineOption(this);
        p4 && (l4 = true, this._mergeOption(p4, o));
      }
      if (!e2 || e2 === "recreate" || e2 === "media") {
        var g4 = c4.getMediaOption(this);
        g4.length && Ve(g4, function(y4) {
          l4 = true, this._mergeOption(y4, o);
        }, this);
      }
      return l4;
    }, n2.prototype.mergeOption = function(e2) {
      this._mergeOption(e2, null);
    }, n2.prototype._mergeOption = function(e2, o) {
      var l4 = this.option, c4 = this._componentsMap, h = this._componentsCount, p4 = [], g4 = ri(), y4 = o && o.replaceMergeMainTypeMap;
      oct(this), Ve(e2, function(w4, C) {
        w4 != null && (Ns.hasClass(C) ? C && (p4.push(C), g4.set(C, true)) : l4[C] = l4[C] == null ? Ci(w4) : to(l4[C], w4, true));
      }), y4 && y4.each(function(w4, C) {
        Ns.hasClass(C) && !g4.get(C) && (p4.push(C), g4.set(C, true));
      }), Ns.topologicalTravel(p4, Ns.getAllClassMainTypes(), _, this);
      function _(w4) {
        var C = uct(this, w4, Zl(e2[w4])), E = c4.get(w4), T = E ? y4 && y4.get(w4) ? "replaceMerge" : "normalMerge" : "replaceAll", O = rTe(E, C, T);
        Cst(O, w4, Ns), l4[w4] = null, c4.set(w4, null), h.set(w4, 0);
        var N = [], V = [], H = 0, X;
        Ve(O, function(q2, de) {
          var le = q2.existing, me = q2.newOption;
          if (!me)
            le && (le.mergeOption({}, this), le.optionUpdated({}, false));
          else {
            var ye = w4 === "series", be = Ns.getClass(w4, q2.keyInfo.subType, !ye);
            if (!be)
              return;
            if (w4 === "tooltip") {
              if (X)
                return;
              X = true;
            }
            if (le && le.constructor === be)
              le.name = q2.keyInfo.name, le.mergeOption(me, this), le.optionUpdated(me, false);
            else {
              var we = rr({ componentIndex: de }, q2.keyInfo);
              le = new be(me, this, this, we), rr(le, we), q2.brandNew && (le.__requireNewView = true), le.init(me, this, this), le.optionUpdated(null, true);
            }
          }
          le ? (N.push(le.option), V.push(le), H++) : (N.push(void 0), V.push(void 0));
        }, this), l4[w4] = N, c4.set(w4, V), h.set(w4, H), w4 === "series" && aW(this);
      }
      this._seriesIndices || aW(this);
    }, n2.prototype.getOption = function() {
      var e2 = Ci(this.option);
      return Ve(e2, function(o, l4) {
        if (Ns.hasClass(l4)) {
          for (var c4 = Zl(o), h = c4.length, p4 = false, g4 = h - 1; g4 >= 0; g4--)
            c4[g4] && !l8(c4[g4]) ? p4 = true : (c4[g4] = null, !p4 && h--);
          c4.length = h, e2[l4] = c4;
        }
      }), delete e2[r2e], e2;
    }, n2.prototype.getTheme = function() {
      return this._theme;
    }, n2.prototype.getLocaleModel = function() {
      return this._locale;
    }, n2.prototype.setUpdatePayload = function(e2) {
      this._payload = e2;
    }, n2.prototype.getUpdatePayload = function() {
      return this._payload;
    }, n2.prototype.getComponent = function(e2, o) {
      var l4 = this._componentsMap.get(e2);
      if (l4) {
        var c4 = l4[o || 0];
        if (c4)
          return c4;
        if (o == null) {
          for (var h = 0; h < l4.length; h++)
            if (l4[h])
              return l4[h];
        }
      }
    }, n2.prototype.queryComponents = function(e2) {
      var o = e2.mainType;
      if (!o)
        return [];
      var l4 = e2.index, c4 = e2.id, h = e2.name, p4 = this._componentsMap.get(o);
      if (!p4 || !p4.length)
        return [];
      var g4;
      return l4 != null ? (g4 = [], Ve(Zl(l4), function(y4) {
        p4[y4] && g4.push(p4[y4]);
      })) : c4 != null ? g4 = a2e("id", c4, p4) : h != null ? g4 = a2e("name", h, p4) : g4 = Yl(p4, function(y4) {
        return !!y4;
      }), i2e(g4, e2);
    }, n2.prototype.findComponents = function(e2) {
      var o = e2.query, l4 = e2.mainType, c4 = p4(o), h = c4 ? this.queryComponents(c4) : Yl(this._componentsMap.get(l4), function(y4) {
        return !!y4;
      });
      return g4(i2e(h, e2));
      function p4(y4) {
        var _ = l4 + "Index", w4 = l4 + "Id", C = l4 + "Name";
        return y4 && (y4[_] != null || y4[w4] != null || y4[C] != null) ? { mainType: l4, index: y4[_], id: y4[w4], name: y4[C] } : null;
      }
      function g4(y4) {
        return e2.filter ? Yl(y4, e2.filter) : y4;
      }
    }, n2.prototype.eachComponent = function(e2, o, l4) {
      var c4 = this._componentsMap;
      if (si(e2)) {
        var h = o, p4 = e2;
        c4.each(function(w4, C) {
          for (var E = 0; w4 && E < w4.length; E++) {
            var T = w4[E];
            T && p4.call(h, C, T, T.componentIndex);
          }
        });
      } else
        for (var g4 = xa(e2) ? c4.get(e2) : mi(e2) ? this.findComponents(e2) : null, y4 = 0; g4 && y4 < g4.length; y4++) {
          var _ = g4[y4];
          _ && o.call(l4, _, _.componentIndex);
        }
    }, n2.prototype.getSeriesByName = function(e2) {
      var o = yh(e2, null);
      return Yl(this._componentsMap.get("series"), function(l4) {
        return !!l4 && o != null && l4.name === o;
      });
    }, n2.prototype.getSeriesByIndex = function(e2) {
      return this._componentsMap.get("series")[e2];
    }, n2.prototype.getSeriesByType = function(e2) {
      return Yl(this._componentsMap.get("series"), function(o) {
        return !!o && o.subType === e2;
      });
    }, n2.prototype.getSeries = function() {
      return Yl(this._componentsMap.get("series"), function(e2) {
        return !!e2;
      });
    }, n2.prototype.getSeriesCount = function() {
      return this._componentsCount.get("series");
    }, n2.prototype.eachSeries = function(e2, o) {
      nN(this), Ve(this._seriesIndices, function(l4) {
        var c4 = this._componentsMap.get("series")[l4];
        e2.call(o, c4, l4);
      }, this);
    }, n2.prototype.eachRawSeries = function(e2, o) {
      Ve(this._componentsMap.get("series"), function(l4) {
        l4 && e2.call(o, l4, l4.componentIndex);
      });
    }, n2.prototype.eachSeriesByType = function(e2, o, l4) {
      nN(this), Ve(this._seriesIndices, function(c4) {
        var h = this._componentsMap.get("series")[c4];
        h.subType === e2 && o.call(l4, h, c4);
      }, this);
    }, n2.prototype.eachRawSeriesByType = function(e2, o, l4) {
      return Ve(this.getSeriesByType(e2), o, l4);
    }, n2.prototype.isSeriesFiltered = function(e2) {
      return nN(this), this._seriesIndicesMap.get(e2.componentIndex) == null;
    }, n2.prototype.getCurrentSeriesIndices = function() {
      return (this._seriesIndices || []).slice();
    }, n2.prototype.filterSeries = function(e2, o) {
      nN(this);
      var l4 = [];
      Ve(this._seriesIndices, function(c4) {
        var h = this._componentsMap.get("series")[c4];
        e2.call(o, h, c4) && l4.push(c4);
      }, this), this._seriesIndices = l4, this._seriesIndicesMap = ri(l4);
    }, n2.prototype.restoreData = function(e2) {
      aW(this);
      var o = this._componentsMap, l4 = [];
      o.each(function(c4, h) {
        Ns.hasClass(h) && l4.push(h);
      }), Ns.topologicalTravel(l4, Ns.getAllClassMainTypes(), function(c4) {
        Ve(o.get(c4), function(h) {
          h && (c4 !== "series" || !pct(h, e2)) && h.restoreData();
        });
      });
    }, n2.internalField = function() {
      aW = function(e2) {
        var o = e2._seriesIndices = [];
        Ve(e2._componentsMap.get("series"), function(l4) {
          l4 && o.push(l4.componentIndex);
        }), e2._seriesIndicesMap = ri(o);
      }, nN = function(e2) {
      }, n2e = function(e2, o) {
        e2.option = {}, e2.option[r2e] = dct, e2._componentsMap = ri({ series: [] }), e2._componentsCount = ri();
        var l4 = o.aria;
        mi(l4) && l4.enabled == null && (l4.enabled = true), vct(o, e2._theme.option), to(o, ict, false), e2._mergeOption(o, null);
      };
    }(), n2;
  }(Ou);
  function pct(i, n2) {
    if (n2) {
      var e2 = n2.seriesIndex, o = n2.seriesId, l4 = n2.seriesName;
      return e2 != null && i.componentIndex !== e2 || o != null && i.id !== o || l4 != null && i.name !== l4;
    }
  }
  function vct(i, n2) {
    var e2 = i.color && !i.colorLayer;
    Ve(n2, function(o, l4) {
      l4 === "colorLayer" && e2 || Ns.hasClass(l4) || (typeof o == "object" ? i[l4] = i[l4] ? to(i[l4], o, false) : Ci(o) : i[l4] == null && (i[l4] = o));
    });
  }
  function a2e(i, n2, e2) {
    if (Mr(n2)) {
      var o = ri();
      return Ve(n2, function(c4) {
        if (c4 != null) {
          var h = yh(c4, null);
          h != null && o.set(c4, true);
        }
      }), Yl(e2, function(c4) {
        return c4 && o.get(c4[i]);
      });
    } else {
      var l4 = yh(n2, null);
      return Yl(e2, function(c4) {
        return c4 && l4 != null && c4[i] === l4;
      });
    }
  }
  function i2e(i, n2) {
    return n2.hasOwnProperty("subType") ? Yl(i, function(e2) {
      return e2 && e2.subType === n2.subType;
    }) : i;
  }
  function o2e(i) {
    var n2 = ri();
    return i && Ve(Zl(i.replaceMerge), function(e2) {
      n2.set(e2, true);
    }), { replaceMergeMainTypeMap: n2 };
  }
  Kf(kDe, lle);
  var PDe = kDe, gct = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], mct = function() {
    function i(n2) {
      Ve(gct, function(e2) {
        this[e2] = Ia(n2[e2], n2);
      }, this);
    }
    return i;
  }(), LDe = mct, Dre = {}, yct = function() {
    function i() {
      this._coordinateSystems = [];
    }
    return i.prototype.create = function(n2, e2) {
      var o = [];
      Ve(Dre, function(l4, c4) {
        var h = l4.create(n2, e2);
        o = o.concat(h || []);
      }), this._coordinateSystems = o;
    }, i.prototype.update = function(n2, e2) {
      Ve(this._coordinateSystems, function(o) {
        o.update && o.update(n2, e2);
      });
    }, i.prototype.getCoordinateSystems = function() {
      return this._coordinateSystems.slice();
    }, i.register = function(n2, e2) {
      Dre[n2] = e2;
    }, i.get = function(n2) {
      return Dre[n2];
    }, i;
  }(), H8 = yct, bct = /^(min|max)?(.+)$/, _ct = function() {
    function i(n2) {
      this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = n2;
    }
    return i.prototype.setOption = function(n2, e2, o) {
      n2 && (Ve(Zl(n2.series), function(h) {
        h && h.data && am(h.data) && gH(h.data);
      }), Ve(Zl(n2.dataset), function(h) {
        h && h.source && am(h.source) && gH(h.source);
      })), n2 = Ci(n2);
      var l4 = this._optionBackup, c4 = xct(n2, e2, !l4);
      this._newBaseOption = c4.baseOption, l4 ? (c4.timelineOptions.length && (l4.timelineOptions = c4.timelineOptions), c4.mediaList.length && (l4.mediaList = c4.mediaList), c4.mediaDefault && (l4.mediaDefault = c4.mediaDefault)) : this._optionBackup = c4;
    }, i.prototype.mountOption = function(n2) {
      var e2 = this._optionBackup;
      return this._timelineOptions = e2.timelineOptions, this._mediaList = e2.mediaList, this._mediaDefault = e2.mediaDefault, this._currentMediaIndices = [], Ci(n2 ? e2.baseOption : this._newBaseOption);
    }, i.prototype.getTimelineOption = function(n2) {
      var e2, o = this._timelineOptions;
      if (o.length) {
        var l4 = n2.getComponent("timeline");
        l4 && (e2 = Ci(o[l4.getCurrentIndex()]));
      }
      return e2;
    }, i.prototype.getMediaOption = function(n2) {
      var e2 = this._api.getWidth(), o = this._api.getHeight(), l4 = this._mediaList, c4 = this._mediaDefault, h = [], p4 = [];
      if (!l4.length && !c4)
        return p4;
      for (var g4 = 0, y4 = l4.length; g4 < y4; g4++)
        wct(l4[g4].query, e2, o) && h.push(g4);
      return !h.length && c4 && (h = [-1]), h.length && !Cct(h, this._currentMediaIndices) && (p4 = Er(h, function(_) {
        return Ci(_ === -1 ? c4.option : l4[_].option);
      })), this._currentMediaIndices = h, p4;
    }, i;
  }();
  function xct(i, n2, e2) {
    var o = [], l4, c4, h = i.baseOption, p4 = i.timeline, g4 = i.options, y4 = i.media, _ = !!i.media, w4 = !!(g4 || p4 || h && h.timeline);
    h ? (c4 = h, c4.timeline || (c4.timeline = p4)) : ((w4 || _) && (i.options = i.media = null), c4 = i), _ && Mr(y4) && Ve(y4, function(E) {
      E && E.option && (E.query ? o.push(E) : l4 || (l4 = E));
    }), C(c4), Ve(g4, function(E) {
      return C(E);
    }), Ve(o, function(E) {
      return C(E.option);
    });
    function C(E) {
      Ve(n2, function(T) {
        T(E, e2);
      });
    }
    return { baseOption: c4, timelineOptions: g4 || [], mediaDefault: l4, mediaList: o };
  }
  function wct(i, n2, e2) {
    var o = { width: n2, height: e2, aspectratio: n2 / e2 }, l4 = true;
    return Ve(i, function(c4, h) {
      var p4 = h.match(bct);
      if (!(!p4 || !p4[1] || !p4[2])) {
        var g4 = p4[1], y4 = p4[2].toLowerCase();
        Sct(o[y4], c4, g4) || (l4 = false);
      }
    }), l4;
  }
  function Sct(i, n2, e2) {
    return e2 === "min" ? i >= n2 : e2 === "max" ? i <= n2 : i === n2;
  }
  function Cct(i, n2) {
    return i.join(",") === n2.join(",");
  }
  var Mct = _ct, Z1 = Ve, g8 = mi, s2e = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
  function kre(i) {
    var n2 = i && i.itemStyle;
    if (!!n2)
      for (var e2 = 0, o = s2e.length; e2 < o; e2++) {
        var l4 = s2e[e2], c4 = n2.normal, h = n2.emphasis;
        c4 && c4[l4] && (i[l4] = i[l4] || {}, i[l4].normal ? to(i[l4].normal, c4[l4]) : i[l4].normal = c4[l4], c4[l4] = null), h && h[l4] && (i[l4] = i[l4] || {}, i[l4].emphasis ? to(i[l4].emphasis, h[l4]) : i[l4].emphasis = h[l4], h[l4] = null);
      }
  }
  function dv(i, n2, e2) {
    if (i && i[n2] && (i[n2].normal || i[n2].emphasis)) {
      var o = i[n2].normal, l4 = i[n2].emphasis;
      o && (e2 ? (i[n2].normal = i[n2].emphasis = null, hi(i[n2], o)) : i[n2] = o), l4 && (i.emphasis = i.emphasis || {}, i.emphasis[n2] = l4, l4.focus && (i.emphasis.focus = l4.focus), l4.blurScope && (i.emphasis.blurScope = l4.blurScope));
    }
  }
  function PN(i) {
    dv(i, "itemStyle"), dv(i, "lineStyle"), dv(i, "areaStyle"), dv(i, "label"), dv(i, "labelLine"), dv(i, "upperLabel"), dv(i, "edgeLabel");
  }
  function qf(i, n2) {
    var e2 = g8(i) && i[n2], o = g8(e2) && e2.textStyle;
    if (o)
      for (var l4 = 0, c4 = fwe.length; l4 < c4; l4++) {
        var h = fwe[l4];
        o.hasOwnProperty(h) && (e2[h] = o[h]);
      }
  }
  function My(i) {
    i && (PN(i), qf(i, "label"), i.emphasis && qf(i.emphasis, "label"));
  }
  function Act(i) {
    if (!!g8(i)) {
      kre(i), PN(i), qf(i, "label"), qf(i, "upperLabel"), qf(i, "edgeLabel"), i.emphasis && (qf(i.emphasis, "label"), qf(i.emphasis, "upperLabel"), qf(i.emphasis, "edgeLabel"));
      var n2 = i.markPoint;
      n2 && (kre(n2), My(n2));
      var e2 = i.markLine;
      e2 && (kre(e2), My(e2));
      var o = i.markArea;
      o && My(o);
      var l4 = i.data;
      if (i.type === "graph") {
        l4 = l4 || i.nodes;
        var c4 = i.links || i.edges;
        if (c4 && !am(c4))
          for (var h = 0; h < c4.length; h++)
            My(c4[h]);
        Ve(i.categories, function(y4) {
          PN(y4);
        });
      }
      if (l4 && !am(l4))
        for (var h = 0; h < l4.length; h++)
          My(l4[h]);
      if (n2 = i.markPoint, n2 && n2.data)
        for (var p4 = n2.data, h = 0; h < p4.length; h++)
          My(p4[h]);
      if (e2 = i.markLine, e2 && e2.data)
        for (var g4 = e2.data, h = 0; h < g4.length; h++)
          Mr(g4[h]) ? (My(g4[h][0]), My(g4[h][1])) : My(g4[h]);
      i.type === "gauge" ? (qf(i, "axisLabel"), qf(i, "title"), qf(i, "detail")) : i.type === "treemap" ? (dv(i.breadcrumb, "itemStyle"), Ve(i.levels, function(y4) {
        PN(y4);
      })) : i.type === "tree" && PN(i.leaves);
    }
  }
  function a2(i) {
    return Mr(i) ? i : i ? [i] : [];
  }
  function l2e(i) {
    return (Mr(i) ? i[0] : i) || {};
  }
  function Ect(i, n2) {
    Z1(a2(i.series), function(o) {
      g8(o) && Act(o);
    });
    var e2 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
    n2 && e2.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), Z1(e2, function(o) {
      Z1(a2(i[o]), function(l4) {
        l4 && (qf(l4, "axisLabel"), qf(l4.axisPointer, "label"));
      });
    }), Z1(a2(i.parallel), function(o) {
      var l4 = o && o.parallelAxisDefault;
      qf(l4, "axisLabel"), qf(l4 && l4.axisPointer, "label");
    }), Z1(a2(i.calendar), function(o) {
      dv(o, "itemStyle"), qf(o, "dayLabel"), qf(o, "monthLabel"), qf(o, "yearLabel");
    }), Z1(a2(i.radar), function(o) {
      qf(o, "name"), o.name && o.axisName == null && (o.axisName = o.name, delete o.name), o.nameGap != null && o.axisNameGap == null && (o.axisNameGap = o.nameGap, delete o.nameGap);
    }), Z1(a2(i.geo), function(o) {
      g8(o) && (My(o), Z1(a2(o.regions), function(l4) {
        My(l4);
      }));
    }), Z1(a2(i.timeline), function(o) {
      My(o), dv(o, "label"), dv(o, "itemStyle"), dv(o, "controlStyle", true);
      var l4 = o.data;
      Mr(l4) && Ve(l4, function(c4) {
        mi(c4) && (dv(c4, "label"), dv(c4, "itemStyle"));
      });
    }), Z1(a2(i.toolbox), function(o) {
      dv(o, "iconStyle"), Z1(o.feature, function(l4) {
        dv(l4, "iconStyle");
      });
    }), qf(l2e(i.axisPointer), "label"), qf(l2e(i.tooltip).axisPointer, "label");
  }
  function Ict(i, n2) {
    for (var e2 = n2.split(","), o = i, l4 = 0; l4 < e2.length && (o = o && o[e2[l4]], o != null); l4++)
      ;
    return o;
  }
  function Tct(i, n2, e2, o) {
    for (var l4 = n2.split(","), c4 = i, h, p4 = 0; p4 < l4.length - 1; p4++)
      h = l4[p4], c4[h] == null && (c4[h] = {}), c4 = c4[h];
    (o || c4[l4[p4]] == null) && (c4[l4[p4]] = e2);
  }
  function u2e(i) {
    i && Ve(Dct, function(n2) {
      n2[0] in i && !(n2[1] in i) && (i[n2[1]] = i[n2[0]]);
    });
  }
  var Dct = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], kct = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], Pre = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
  function rN(i) {
    var n2 = i && i.itemStyle;
    if (n2)
      for (var e2 = 0; e2 < Pre.length; e2++) {
        var o = Pre[e2][1], l4 = Pre[e2][0];
        n2[o] != null && (n2[l4] = n2[o]);
      }
  }
  function c2e(i) {
    !i || i.alignTo === "edge" && i.margin != null && i.edgeDistance == null && (i.edgeDistance = i.margin);
  }
  function f2e(i) {
    !i || i.downplay && !i.blur && (i.blur = i.downplay);
  }
  function Pct(i) {
    !i || i.focusNodeAdjacency != null && (i.emphasis = i.emphasis || {}, i.emphasis.focus == null && (i.emphasis.focus = "adjacency"));
  }
  function ODe(i, n2) {
    if (i)
      for (var e2 = 0; e2 < i.length; e2++)
        n2(i[e2]), i[e2] && ODe(i[e2].children, n2);
  }
  function RDe(i, n2) {
    Ect(i, n2), i.series = Zl(i.series), Ve(i.series, function(e2) {
      if (!!mi(e2)) {
        var o = e2.type;
        if (o === "line")
          e2.clipOverflow != null && (e2.clip = e2.clipOverflow);
        else if (o === "pie" || o === "gauge") {
          e2.clockWise != null && (e2.clockwise = e2.clockWise), c2e(e2.label);
          var l4 = e2.data;
          if (l4 && !am(l4))
            for (var c4 = 0; c4 < l4.length; c4++)
              c2e(l4[c4]);
          e2.hoverOffset != null && (e2.emphasis = e2.emphasis || {}, (e2.emphasis.scaleSize = null) && (e2.emphasis.scaleSize = e2.hoverOffset));
        } else if (o === "gauge") {
          var h = Ict(e2, "pointer.color");
          h != null && Tct(e2, "itemStyle.color", h);
        } else if (o === "bar") {
          rN(e2), rN(e2.backgroundStyle), rN(e2.emphasis);
          var l4 = e2.data;
          if (l4 && !am(l4))
            for (var c4 = 0; c4 < l4.length; c4++)
              typeof l4[c4] == "object" && (rN(l4[c4]), rN(l4[c4] && l4[c4].emphasis));
        } else if (o === "sunburst") {
          var p4 = e2.highlightPolicy;
          p4 && (e2.emphasis = e2.emphasis || {}, e2.emphasis.focus || (e2.emphasis.focus = p4)), f2e(e2), ODe(e2.data, f2e);
        } else
          o === "graph" || o === "sankey" ? Pct(e2) : o === "map" && (e2.mapType && !e2.map && (e2.map = e2.mapType), e2.mapLocation && hi(e2, e2.mapLocation));
        e2.hoverAnimation != null && (e2.emphasis = e2.emphasis || {}, e2.emphasis && e2.emphasis.scale == null && (e2.emphasis.scale = e2.hoverAnimation)), u2e(e2);
      }
    }), i.dataRange && (i.visualMap = i.dataRange), Ve(kct, function(e2) {
      var o = i[e2];
      o && (Mr(o) || (o = [o]), Ve(o, function(l4) {
        u2e(l4);
      }));
    });
  }
  function Lct(i) {
    var n2 = ri();
    i.eachSeries(function(e2) {
      var o = e2.get("stack");
      if (o) {
        var l4 = n2.get(o) || n2.set(o, []), c4 = e2.getData(), h = { stackResultDimension: c4.getCalculationInfo("stackResultDimension"), stackedOverDimension: c4.getCalculationInfo("stackedOverDimension"), stackedDimension: c4.getCalculationInfo("stackedDimension"), stackedByDimension: c4.getCalculationInfo("stackedByDimension"), isStackedByIndex: c4.getCalculationInfo("isStackedByIndex"), data: c4, seriesModel: e2 };
        if (!h.stackedDimension || !(h.isStackedByIndex || h.stackedByDimension))
          return;
        l4.length && c4.setCalculationInfo("stackedOnSeries", l4[l4.length - 1].seriesModel), l4.push(h);
      }
    }), n2.each(Oct);
  }
  function Oct(i) {
    Ve(i, function(n2, e2) {
      var o = [], l4 = [NaN, NaN], c4 = [n2.stackResultDimension, n2.stackedOverDimension], h = n2.data, p4 = n2.isStackedByIndex;
      h.modify(c4, function(g4, y4, _) {
        var w4 = h.get(n2.stackedDimension, _);
        if (isNaN(w4))
          return l4;
        var C, E;
        p4 ? E = h.getRawIndex(_) : C = h.get(n2.stackedByDimension, _);
        for (var T = NaN, O = e2 - 1; O >= 0; O--) {
          var N = i[O];
          if (p4 || (E = N.data.rawIndexOf(N.stackedByDimension, C)), E >= 0) {
            var V = N.data.getByRawIndex(N.stackResultDimension, E);
            if (w4 >= 0 && V > 0 || w4 <= 0 && V < 0) {
              w4 = dst(w4, V), T = V;
              break;
            }
          }
        }
        return o[0] = w4, o[1] = T, o;
      });
    });
  }
  var V$ = function() {
    function i(n2) {
      this.data = n2.data || (n2.sourceFormat === Q_ ? {} : []), this.sourceFormat = n2.sourceFormat || MDe, this.seriesLayoutBy = n2.seriesLayoutBy || $_, this.startIndex = n2.startIndex || 0, this.dimensionsDetectedCount = n2.dimensionsDetectedCount, this.metaRawOption = n2.metaRawOption;
      var e2 = this.dimensionsDefine = n2.dimensionsDefine;
      if (e2)
        for (var o = 0; o < e2.length; o++) {
          var l4 = e2[o];
          l4.type == null && IDe(this, o) === wp.Must && (l4.type = "ordinal");
        }
    }
    return i;
  }();
  function ule(i) {
    return i instanceof V$;
  }
  function soe(i, n2, e2) {
    e2 = e2 || FDe(i);
    var o = n2.seriesLayoutBy, l4 = Fct(i, e2, o, n2.sourceHeader, n2.dimensions), c4 = new V$({ data: i, sourceFormat: e2, seriesLayoutBy: o, dimensionsDefine: l4.dimensionsDefine, startIndex: l4.startIndex, dimensionsDetectedCount: l4.dimensionsDetectedCount, metaRawOption: Ci(n2) });
    return c4;
  }
  function cle(i) {
    return new V$({ data: i, sourceFormat: am(i) ? qC : By });
  }
  function Rct(i) {
    return new V$({ data: i.data, sourceFormat: i.sourceFormat, seriesLayoutBy: i.seriesLayoutBy, dimensionsDefine: Ci(i.dimensionsDefine), startIndex: i.startIndex, dimensionsDetectedCount: i.dimensionsDetectedCount });
  }
  function FDe(i) {
    var n2 = MDe;
    if (am(i))
      n2 = qC;
    else if (Mr(i)) {
      i.length === 0 && (n2 = mv);
      for (var e2 = 0, o = i.length; e2 < o; e2++) {
        var l4 = i[e2];
        if (l4 != null) {
          if (Mr(l4)) {
            n2 = mv;
            break;
          } else if (mi(l4)) {
            n2 = jy;
            break;
          }
        }
      }
    } else if (mi(i)) {
      for (var c4 in i)
        if (Na(i, c4) && gv(i[c4])) {
          n2 = Q_;
          break;
        }
    }
    return n2;
  }
  function Fct(i, n2, e2, o, l4) {
    var c4, h;
    if (!i)
      return { dimensionsDefine: h2e(l4), startIndex: h, dimensionsDetectedCount: c4 };
    if (n2 === mv) {
      var p4 = i;
      o === "auto" || o == null ? d2e(function(y4) {
        y4 != null && y4 !== "-" && (xa(y4) ? h == null && (h = 1) : h = 0);
      }, e2, p4, 10) : h = sl(o) ? o : o ? 1 : 0, !l4 && h === 1 && (l4 = [], d2e(function(y4, _) {
        l4[_] = y4 != null ? y4 + "" : "";
      }, e2, p4, 1 / 0)), c4 = l4 ? l4.length : e2 === Q3 ? p4.length : p4[0] ? p4[0].length : null;
    } else if (n2 === jy)
      l4 || (l4 = Nct(i));
    else if (n2 === Q_)
      l4 || (l4 = [], Ve(i, function(y4, _) {
        l4.push(_);
      }));
    else if (n2 === By) {
      var g4 = H3(i[0]);
      c4 = Mr(g4) && g4.length || 1;
    }
    return { startIndex: h, dimensionsDefine: h2e(l4), dimensionsDetectedCount: c4 };
  }
  function Nct(i) {
    for (var n2 = 0, e2; n2 < i.length && !(e2 = i[n2++]); )
      ;
    if (e2) {
      var o = [];
      return Ve(e2, function(l4, c4) {
        o.push(c4);
      }), o;
    }
  }
  function h2e(i) {
    if (!!i) {
      var n2 = ri();
      return Er(i, function(e2, o) {
        e2 = mi(e2) ? e2 : { name: e2 };
        var l4 = { name: e2.name, displayName: e2.displayName, type: e2.type };
        if (l4.name == null)
          return l4;
        l4.name += "", l4.displayName == null && (l4.displayName = l4.name);
        var c4 = n2.get(l4.name);
        return c4 ? l4.name += "-" + c4.count++ : n2.set(l4.name, { count: 1 }), l4;
      });
    }
  }
  function d2e(i, n2, e2, o) {
    if (n2 === Q3)
      for (var l4 = 0; l4 < e2.length && l4 < o; l4++)
        i(e2[l4] ? e2[l4][0] : null, l4);
    else
      for (var c4 = e2[0] || [], l4 = 0; l4 < c4.length && l4 < o; l4++)
        i(c4[l4], l4);
  }
  function NDe(i) {
    var n2 = i.sourceFormat;
    return n2 === jy || n2 === Q_;
  }
  var RI, FI, NI, p2e, v2e, VDe = function() {
    function i(n2, e2) {
      var o = ule(n2) ? n2 : cle(n2);
      this._source = o;
      var l4 = this._data = o.data;
      o.sourceFormat === qC && (this._offset = 0, this._dimSize = e2, this._data = l4), v2e(this, l4, o);
    }
    return i.prototype.getSource = function() {
      return this._source;
    }, i.prototype.count = function() {
      return 0;
    }, i.prototype.getItem = function(n2, e2) {
    }, i.prototype.appendData = function(n2) {
    }, i.prototype.clean = function() {
    }, i.protoInitialize = function() {
      var n2 = i.prototype;
      n2.pure = false, n2.persistent = true;
    }(), i.internalField = function() {
      var n2;
      v2e = function(h, p4, g4) {
        var y4 = g4.sourceFormat, _ = g4.seriesLayoutBy, w4 = g4.startIndex, C = g4.dimensionsDefine, E = p2e[fle(y4, _)];
        if (rr(h, E), y4 === qC)
          h.getItem = e2, h.count = l4, h.fillStorage = o;
        else {
          var T = zDe(y4, _);
          h.getItem = Ia(T, null, p4, w4, C);
          var O = BDe(y4, _);
          h.count = Ia(O, null, p4, w4, C);
        }
      };
      var e2 = function(h, p4) {
        h = h - this._offset, p4 = p4 || [];
        for (var g4 = this._data, y4 = this._dimSize, _ = y4 * h, w4 = 0; w4 < y4; w4++)
          p4[w4] = g4[_ + w4];
        return p4;
      }, o = function(h, p4, g4, y4) {
        for (var _ = this._data, w4 = this._dimSize, C = 0; C < w4; C++) {
          for (var E = y4[C], T = E[0] == null ? 1 / 0 : E[0], O = E[1] == null ? -1 / 0 : E[1], N = p4 - h, V = g4[C], H = 0; H < N; H++) {
            var X = _[H * w4 + C];
            V[h + H] = X, X < T && (T = X), X > O && (O = X);
          }
          E[0] = T, E[1] = O;
        }
      }, l4 = function() {
        return this._data ? this._data.length / this._dimSize : 0;
      };
      p2e = (n2 = {}, n2[mv + "_" + $_] = { pure: true, appendData: c4 }, n2[mv + "_" + Q3] = { pure: true, appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      } }, n2[jy] = { pure: true, appendData: c4 }, n2[Q_] = { pure: true, appendData: function(h) {
        var p4 = this._data;
        Ve(h, function(g4, y4) {
          for (var _ = p4[y4] || (p4[y4] = []), w4 = 0; w4 < (g4 || []).length; w4++)
            _.push(g4[w4]);
        });
      } }, n2[By] = { appendData: c4 }, n2[qC] = { persistent: false, pure: true, appendData: function(h) {
        this._data = h;
      }, clean: function() {
        this._offset += this.count(), this._data = null;
      } }, n2);
      function c4(h) {
        for (var p4 = 0; p4 < h.length; p4++)
          this._data.push(h[p4]);
      }
    }(), i;
  }(), g2e = function(i, n2, e2, o) {
    return i[o];
  }, Vct = (RI = {}, RI[mv + "_" + $_] = function(i, n2, e2, o) {
    return i[o + n2];
  }, RI[mv + "_" + Q3] = function(i, n2, e2, o, l4) {
    o += n2;
    for (var c4 = l4 || [], h = i, p4 = 0; p4 < h.length; p4++) {
      var g4 = h[p4];
      c4[p4] = g4 ? g4[o] : null;
    }
    return c4;
  }, RI[jy] = g2e, RI[Q_] = function(i, n2, e2, o, l4) {
    for (var c4 = l4 || [], h = 0; h < e2.length; h++) {
      var p4 = e2[h].name, g4 = i[p4];
      c4[h] = g4 ? g4[o] : null;
    }
    return c4;
  }, RI[By] = g2e, RI);
  function zDe(i, n2) {
    var e2 = Vct[fle(i, n2)];
    return e2;
  }
  var m2e = function(i, n2, e2) {
    return i.length;
  }, zct = (FI = {}, FI[mv + "_" + $_] = function(i, n2, e2) {
    return Math.max(0, i.length - n2);
  }, FI[mv + "_" + Q3] = function(i, n2, e2) {
    var o = i[0];
    return o ? Math.max(0, o.length - n2) : 0;
  }, FI[jy] = m2e, FI[Q_] = function(i, n2, e2) {
    var o = e2[0].name, l4 = i[o];
    return l4 ? l4.length : 0;
  }, FI[By] = m2e, FI);
  function BDe(i, n2) {
    var e2 = zct[fle(i, n2)];
    return e2;
  }
  var Lre = function(i, n2, e2) {
    return i[n2];
  }, Bct = (NI = {}, NI[mv] = Lre, NI[jy] = function(i, n2, e2) {
    return i[e2];
  }, NI[Q_] = Lre, NI[By] = function(i, n2, e2) {
    var o = H3(i);
    return o instanceof Array ? o[n2] : o;
  }, NI[qC] = Lre, NI);
  function jDe(i) {
    var n2 = Bct[i];
    return n2;
  }
  function fle(i, n2) {
    return i === mv ? i + "_" + n2 : i;
  }
  function R3(i, n2, e2) {
    if (!!i) {
      var o = i.getRawDataItem(n2);
      if (o != null) {
        var l4 = i.getStore(), c4 = l4.getSource().sourceFormat;
        if (e2 != null) {
          var h = i.getDimensionIndex(e2), p4 = l4.getDimensionProperty(h);
          return jDe(c4)(o, h, p4);
        } else {
          var g4 = o;
          return c4 === By && (g4 = H3(o)), g4;
        }
      }
    }
  }
  var jct = /\{@(.+?)\}/g, hle = function() {
    function i() {
    }
    return i.prototype.getDataParams = function(n2, e2) {
      var o = this.getData(e2), l4 = this.getRawValue(n2, e2), c4 = o.getRawIndex(n2), h = o.getName(n2), p4 = o.getRawDataItem(n2), g4 = o.getItemVisual(n2, "style"), y4 = g4 && g4[o.getItemVisual(n2, "drawType") || "fill"], _ = g4 && g4.stroke, w4 = this.mainType, C = w4 === "series", E = o.userOutput && o.userOutput.get();
      return { componentType: w4, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: C ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: C ? this.id : null, seriesName: C ? this.name : null, name: h, dataIndex: c4, data: p4, dataType: e2, value: l4, color: y4, borderColor: _, dimensionNames: E ? E.fullDimensions : null, encode: E ? E.encode : null, $vars: ["seriesName", "name", "value"] };
    }, i.prototype.getFormattedLabel = function(n2, e2, o, l4, c4, h) {
      e2 = e2 || "normal";
      var p4 = this.getData(o), g4 = this.getDataParams(n2, o);
      if (h && (g4.value = h.interpolatedValue), l4 != null && Mr(g4.value) && (g4.value = g4.value[l4]), !c4) {
        var y4 = p4.getItemModel(n2);
        c4 = y4.get(e2 === "normal" ? ["label", "formatter"] : [e2, "label", "formatter"]);
      }
      if (si(c4))
        return g4.status = e2, g4.dimensionIndex = l4, c4(g4);
      if (xa(c4)) {
        var _ = _De(c4, g4);
        return _.replace(jct, function(w4, C) {
          var E = C.length, T = C;
          T.charAt(0) === "[" && T.charAt(E - 1) === "]" && (T = +T.slice(1, E - 1));
          var O = R3(p4, n2, T);
          if (h && Mr(h.interpolatedValue)) {
            var N = p4.getDimensionIndex(T);
            N >= 0 && (O = h.interpolatedValue[N]);
          }
          return O != null ? O + "" : "";
        });
      }
    }, i.prototype.getRawValue = function(n2, e2) {
      return R3(this.getData(e2), n2);
    }, i.prototype.formatTooltip = function(n2, e2, o) {
    }, i;
  }();
  function y2e(i) {
    var n2, e2;
    return mi(i) ? i.type && (e2 = i) : n2 = i, { text: n2, frag: e2 };
  }
  function YN(i) {
    return new Gct(i);
  }
  var Gct = function() {
    function i(n2) {
      n2 = n2 || {}, this._reset = n2.reset, this._plan = n2.plan, this._count = n2.count, this._onDirty = n2.onDirty, this._dirty = true;
    }
    return i.prototype.perform = function(n2) {
      var e2 = this._upstream, o = n2 && n2.skip;
      if (this._dirty && e2) {
        var l4 = this.context;
        l4.data = l4.outputData = e2.context.outputData;
      }
      this.__pipeline && (this.__pipeline.currentTask = this);
      var c4;
      this._plan && !o && (c4 = this._plan(this.context));
      var h = _(this._modBy), p4 = this._modDataCount || 0, g4 = _(n2 && n2.modBy), y4 = n2 && n2.modDataCount || 0;
      (h !== g4 || p4 !== y4) && (c4 = "reset");
      function _(H) {
        return !(H >= 1) && (H = 1), H;
      }
      var w4;
      (this._dirty || c4 === "reset") && (this._dirty = false, w4 = this._doReset(o)), this._modBy = g4, this._modDataCount = y4;
      var C = n2 && n2.step;
      if (e2 ? this._dueEnd = e2._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
        var E = this._dueIndex, T = Math.min(C != null ? this._dueIndex + C : 1 / 0, this._dueEnd);
        if (!o && (w4 || E < T)) {
          var O = this._progress;
          if (Mr(O))
            for (var N = 0; N < O.length; N++)
              this._doProgress(O[N], E, T, g4, y4);
          else
            this._doProgress(O, E, T, g4, y4);
        }
        this._dueIndex = T;
        var V = this._settedOutputEnd != null ? this._settedOutputEnd : T;
        this._outputDueEnd = V;
      } else
        this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
      return this.unfinished();
    }, i.prototype.dirty = function() {
      this._dirty = true, this._onDirty && this._onDirty(this.context);
    }, i.prototype._doProgress = function(n2, e2, o, l4, c4) {
      b2e.reset(e2, o, l4, c4), this._callingProgress = n2, this._callingProgress({ start: e2, end: o, count: o - e2, next: b2e.next }, this.context);
    }, i.prototype._doReset = function(n2) {
      this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
      var e2, o;
      !n2 && this._reset && (e2 = this._reset(this.context), e2 && e2.progress && (o = e2.forceFirstProgress, e2 = e2.progress), Mr(e2) && !e2.length && (e2 = null)), this._progress = e2, this._modBy = this._modDataCount = null;
      var l4 = this._downstream;
      return l4 && l4.dirty(), o;
    }, i.prototype.unfinished = function() {
      return this._progress && this._dueIndex < this._dueEnd;
    }, i.prototype.pipe = function(n2) {
      (this._downstream !== n2 || this._dirty) && (this._downstream = n2, n2._upstream = this, n2.dirty());
    }, i.prototype.dispose = function() {
      this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
    }, i.prototype.getUpstream = function() {
      return this._upstream;
    }, i.prototype.getDownstream = function() {
      return this._downstream;
    }, i.prototype.setOutputEnd = function(n2) {
      this._outputDueEnd = this._settedOutputEnd = n2;
    }, i;
  }(), b2e = function() {
    var i, n2, e2, o, l4, c4 = { reset: function(g4, y4, _, w4) {
      n2 = g4, i = y4, e2 = _, o = w4, l4 = Math.ceil(o / e2), c4.next = e2 > 1 && o > 0 ? p4 : h;
    } };
    return c4;
    function h() {
      return n2 < i ? n2++ : null;
    }
    function p4() {
      var g4 = n2 % l4 * e2 + Math.ceil(n2 / l4), y4 = n2 >= i ? null : g4 < o ? g4 : n2;
      return n2++, y4;
    }
  }();
  function YC(i, n2) {
    var e2 = n2 && n2.type;
    return e2 === "ordinal" ? i : (e2 === "time" && !sl(i) && i != null && i !== "-" && (i = +X_(i)), i == null || i === "" ? NaN : +i);
  }
  var Wct = ri({ number: function(i) {
    return parseFloat(i);
  }, time: function(i) {
    return +X_(i);
  }, trim: function(i) {
    return xa(i) ? tb(i) : i;
  } });
  function GDe(i) {
    return Wct.get(i);
  }
  var WDe = { lt: function(i, n2) {
    return i < n2;
  }, lte: function(i, n2) {
    return i <= n2;
  }, gt: function(i, n2) {
    return i > n2;
  }, gte: function(i, n2) {
    return i >= n2;
  } }, Hct = function() {
    function i(n2, e2) {
      if (!sl(e2)) {
        var o = "";
        dl(o);
      }
      this._opFn = WDe[n2], this._rvalFloat = _2(e2);
    }
    return i.prototype.evaluate = function(n2) {
      return sl(n2) ? this._opFn(n2, this._rvalFloat) : this._opFn(_2(n2), this._rvalFloat);
    }, i;
  }(), HDe = function() {
    function i(n2, e2) {
      var o = n2 === "desc";
      this._resultLT = o ? 1 : -1, e2 == null && (e2 = o ? "min" : "max"), this._incomparable = e2 === "min" ? -1 / 0 : 1 / 0;
    }
    return i.prototype.evaluate = function(n2, e2) {
      var o = sl(n2) ? n2 : _2(n2), l4 = sl(e2) ? e2 : _2(e2), c4 = isNaN(o), h = isNaN(l4);
      if (c4 && (o = this._incomparable), h && (l4 = this._incomparable), c4 && h) {
        var p4 = xa(n2), g4 = xa(e2);
        p4 && (o = g4 ? n2 : 0), g4 && (l4 = p4 ? e2 : 0);
      }
      return o < l4 ? this._resultLT : o > l4 ? -this._resultLT : 0;
    }, i;
  }(), $ct = function() {
    function i(n2, e2) {
      this._rval = e2, this._isEQ = n2, this._rvalTypeof = typeof e2, this._rvalFloat = _2(e2);
    }
    return i.prototype.evaluate = function(n2) {
      var e2 = n2 === this._rval;
      if (!e2) {
        var o = typeof n2;
        o !== this._rvalTypeof && (o === "number" || this._rvalTypeof === "number") && (e2 = _2(n2) === this._rvalFloat);
      }
      return this._isEQ ? e2 : !e2;
    }, i;
  }();
  function Uct(i, n2) {
    return i === "eq" || i === "ne" ? new $ct(i === "eq", n2) : Na(WDe, i) ? new Hct(i, n2) : null;
  }
  var qct = function() {
    function i() {
    }
    return i.prototype.getRawData = function() {
      throw new Error("not supported");
    }, i.prototype.getRawDataItem = function(n2) {
      throw new Error("not supported");
    }, i.prototype.cloneRawData = function() {
    }, i.prototype.getDimensionInfo = function(n2) {
    }, i.prototype.cloneAllDimensionInfo = function() {
    }, i.prototype.count = function() {
    }, i.prototype.retrieveValue = function(n2, e2) {
    }, i.prototype.retrieveValueFromItem = function(n2, e2) {
    }, i.prototype.convertValue = function(n2, e2) {
      return YC(n2, e2);
    }, i;
  }();
  function Yct(i, n2) {
    var e2 = new qct(), o = i.data, l4 = e2.sourceFormat = i.sourceFormat, c4 = i.startIndex, h = "";
    i.seriesLayoutBy !== $_ && dl(h);
    var p4 = [], g4 = {}, y4 = i.dimensionsDefine;
    if (y4)
      Ve(y4, function(O, N) {
        var V = O.name, H = { index: N, name: V, displayName: O.displayName };
        if (p4.push(H), V != null) {
          var X = "";
          Na(g4, V) && dl(X), g4[V] = H;
        }
      });
    else
      for (var _ = 0; _ < i.dimensionsDetectedCount; _++)
        p4.push({ index: _ });
    var w4 = zDe(l4, $_);
    n2.__isBuiltIn && (e2.getRawDataItem = function(O) {
      return w4(o, c4, p4, O);
    }, e2.getRawData = Ia(Zct, null, i)), e2.cloneRawData = Ia(Xct, null, i);
    var C = BDe(l4, $_);
    e2.count = Ia(C, null, o, c4, p4);
    var E = jDe(l4);
    e2.retrieveValue = function(O, N) {
      var V = w4(o, c4, p4, O);
      return T(V, N);
    };
    var T = e2.retrieveValueFromItem = function(O, N) {
      if (O != null) {
        var V = p4[N];
        if (V)
          return E(O, N, V.name);
      }
    };
    return e2.getDimensionInfo = Ia(Kct, null, p4, g4), e2.cloneAllDimensionInfo = Ia(Jct, null, p4), e2;
  }
  function Zct(i) {
    var n2 = i.sourceFormat;
    if (!dle(n2)) {
      var e2 = "";
      dl(e2);
    }
    return i.data;
  }
  function Xct(i) {
    var n2 = i.sourceFormat, e2 = i.data;
    if (!dle(n2)) {
      var o = "";
      dl(o);
    }
    if (n2 === mv) {
      for (var l4 = [], c4 = 0, h = e2.length; c4 < h; c4++)
        l4.push(e2[c4].slice());
      return l4;
    } else if (n2 === jy) {
      for (var l4 = [], c4 = 0, h = e2.length; c4 < h; c4++)
        l4.push(rr({}, e2[c4]));
      return l4;
    }
  }
  function Kct(i, n2, e2) {
    if (e2 != null) {
      if (sl(e2) || !isNaN(e2) && !Na(n2, e2))
        return i[e2];
      if (Na(n2, e2))
        return n2[e2];
    }
  }
  function Jct(i) {
    return Ci(i);
  }
  var $De = ri();
  function Qct(i) {
    i = Ci(i);
    var n2 = i.type, e2 = "";
    n2 || dl(e2);
    var o = n2.split(":");
    o.length !== 2 && dl(e2);
    var l4 = false;
    o[0] === "echarts" && (n2 = o[1], l4 = true), i.__isBuiltIn = l4, $De.set(n2, i);
  }
  function eft(i, n2, e2) {
    var o = Zl(i), l4 = o.length, c4 = "";
    l4 || dl(c4);
    for (var h = 0, p4 = l4; h < p4; h++) {
      var g4 = o[h];
      n2 = tft(g4, n2), h !== p4 - 1 && (n2.length = Math.max(n2.length, 1));
    }
    return n2;
  }
  function tft(i, n2, e2, o) {
    var l4 = "";
    n2.length || dl(l4), mi(i) || dl(l4);
    var c4 = i.type, h = $De.get(c4);
    h || dl(l4);
    var p4 = Er(n2, function(y4) {
      return Yct(y4, h);
    }), g4 = Zl(h.transform({ upstream: p4[0], upstreamList: p4, config: Ci(i.config) }));
    return Er(g4, function(y4, _) {
      var w4 = "";
      mi(y4) || dl(w4), y4.data || dl(w4);
      var C = FDe(y4.data);
      dle(C) || dl(w4);
      var E, T = n2[0];
      if (T && _ === 0 && !y4.dimensions) {
        var O = T.startIndex;
        O && (y4.data = T.data.slice(0, O).concat(y4.data)), E = { seriesLayoutBy: $_, sourceHeader: O, dimensions: T.metaRawOption.dimensions };
      } else
        E = { seriesLayoutBy: $_, sourceHeader: 0, dimensions: y4.dimensions };
      return soe(y4.data, E, null);
    });
  }
  function dle(i) {
    return i === mv || i === jy;
  }
  var z$ = "undefined", nft = typeof Uint32Array === z$ ? Array : Uint32Array, rft = typeof Uint16Array === z$ ? Array : Uint16Array, UDe = typeof Int32Array === z$ ? Array : Int32Array, _2e = typeof Float64Array === z$ ? Array : Float64Array, qDe = { float: _2e, int: UDe, ordinal: Array, number: Array, time: _2e }, Ore;
  function aN(i) {
    return i > 65535 ? nft : rft;
  }
  function JP() {
    return [1 / 0, -1 / 0];
  }
  function aft(i) {
    var n2 = i.constructor;
    return n2 === Array ? i.slice() : new n2(i);
  }
  function x2e(i, n2, e2, o, l4) {
    var c4 = qDe[e2 || "float"];
    if (l4) {
      var h = i[n2], p4 = h && h.length;
      if (p4 !== o) {
        for (var g4 = new c4(o), y4 = 0; y4 < p4; y4++)
          g4[y4] = h[y4];
        i[n2] = g4;
      }
    } else
      i[n2] = new c4(o);
  }
  var loe = function() {
    function i() {
      this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = ri();
    }
    return i.prototype.initData = function(n2, e2, o) {
      this._provider = n2, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
      var l4 = n2.getSource(), c4 = this.defaultDimValueGetter = Ore[l4.sourceFormat];
      this._dimValueGetter = o || c4, this._rawExtent = [], NDe(l4), this._dimensions = Er(e2, function(h) {
        return { type: h.type, property: h.property };
      }), this._initDataFromProvider(0, n2.count());
    }, i.prototype.getProvider = function() {
      return this._provider;
    }, i.prototype.getSource = function() {
      return this._provider.getSource();
    }, i.prototype.ensureCalculationDimension = function(n2, e2) {
      var o = this._calcDimNameToIdx, l4 = this._dimensions, c4 = o.get(n2);
      if (c4 != null) {
        if (l4[c4].type === e2)
          return c4;
      } else
        c4 = l4.length;
      return l4[c4] = { type: e2 }, o.set(n2, c4), this._chunks[c4] = new qDe[e2 || "float"](this._rawCount), this._rawExtent[c4] = JP(), c4;
    }, i.prototype.collectOrdinalMeta = function(n2, e2) {
      var o = this._chunks[n2], l4 = this._dimensions[n2], c4 = this._rawExtent, h = l4.ordinalOffset || 0, p4 = o.length;
      h === 0 && (c4[n2] = JP());
      for (var g4 = c4[n2], y4 = h; y4 < p4; y4++) {
        var _ = o[y4] = e2.parseAndCollect(o[y4]);
        g4[0] = Math.min(_, g4[0]), g4[1] = Math.max(_, g4[1]);
      }
      l4.ordinalMeta = e2, l4.ordinalOffset = p4, l4.type = "ordinal";
    }, i.prototype.getOrdinalMeta = function(n2) {
      var e2 = this._dimensions[n2], o = e2.ordinalMeta;
      return o;
    }, i.prototype.getDimensionProperty = function(n2) {
      var e2 = this._dimensions[n2];
      return e2 && e2.property;
    }, i.prototype.appendData = function(n2) {
      var e2 = this._provider, o = this.count();
      e2.appendData(n2);
      var l4 = e2.count();
      return e2.persistent || (l4 += o), o < l4 && this._initDataFromProvider(o, l4, true), [o, l4];
    }, i.prototype.appendValues = function(n2, e2) {
      for (var o = this._chunks, l4 = this._dimensions, c4 = l4.length, h = this._rawExtent, p4 = this.count(), g4 = p4 + Math.max(n2.length, e2 || 0), y4 = 0; y4 < c4; y4++) {
        var _ = l4[y4];
        x2e(o, y4, _.type, g4, true);
      }
      for (var w4 = [], C = p4; C < g4; C++)
        for (var E = C - p4, T = 0; T < c4; T++) {
          var _ = l4[T], O = Ore.arrayRows.call(this, n2[E] || w4, _.property, E, T);
          o[T][C] = O;
          var N = h[T];
          O < N[0] && (N[0] = O), O > N[1] && (N[1] = O);
        }
      return this._rawCount = this._count = g4, { start: p4, end: g4 };
    }, i.prototype._initDataFromProvider = function(n2, e2, o) {
      for (var l4 = this._provider, c4 = this._chunks, h = this._dimensions, p4 = h.length, g4 = this._rawExtent, y4 = Er(h, function(H) {
        return H.property;
      }), _ = 0; _ < p4; _++) {
        var w4 = h[_];
        g4[_] || (g4[_] = JP()), x2e(c4, _, w4.type, e2, o);
      }
      if (l4.fillStorage)
        l4.fillStorage(n2, e2, c4, g4);
      else
        for (var C = [], E = n2; E < e2; E++) {
          C = l4.getItem(E, C);
          for (var T = 0; T < p4; T++) {
            var O = c4[T], N = this._dimValueGetter(C, y4[T], E, T);
            O[E] = N;
            var V = g4[T];
            N < V[0] && (V[0] = N), N > V[1] && (V[1] = N);
          }
        }
      !l4.persistent && l4.clean && l4.clean(), this._rawCount = this._count = e2, this._extent = [];
    }, i.prototype.count = function() {
      return this._count;
    }, i.prototype.get = function(n2, e2) {
      if (!(e2 >= 0 && e2 < this._count))
        return NaN;
      var o = this._chunks[n2];
      return o ? o[this.getRawIndex(e2)] : NaN;
    }, i.prototype.getValues = function(n2, e2) {
      var o = [], l4 = [];
      if (e2 == null) {
        e2 = n2, n2 = [];
        for (var c4 = 0; c4 < this._dimensions.length; c4++)
          l4.push(c4);
      } else
        l4 = n2;
      for (var c4 = 0, h = l4.length; c4 < h; c4++)
        o.push(this.get(l4[c4], e2));
      return o;
    }, i.prototype.getByRawIndex = function(n2, e2) {
      if (!(e2 >= 0 && e2 < this._rawCount))
        return NaN;
      var o = this._chunks[n2];
      return o ? o[e2] : NaN;
    }, i.prototype.getSum = function(n2) {
      var e2 = this._chunks[n2], o = 0;
      if (e2)
        for (var l4 = 0, c4 = this.count(); l4 < c4; l4++) {
          var h = this.get(n2, l4);
          isNaN(h) || (o += h);
        }
      return o;
    }, i.prototype.getMedian = function(n2) {
      var e2 = [];
      this.each([n2], function(c4) {
        isNaN(c4) || e2.push(c4);
      });
      var o = e2.sort(function(c4, h) {
        return c4 - h;
      }), l4 = this.count();
      return l4 === 0 ? 0 : l4 % 2 === 1 ? o[(l4 - 1) / 2] : (o[l4 / 2] + o[l4 / 2 - 1]) / 2;
    }, i.prototype.indexOfRawIndex = function(n2) {
      if (n2 >= this._rawCount || n2 < 0)
        return -1;
      if (!this._indices)
        return n2;
      var e2 = this._indices, o = e2[n2];
      if (o != null && o < this._count && o === n2)
        return n2;
      for (var l4 = 0, c4 = this._count - 1; l4 <= c4; ) {
        var h = (l4 + c4) / 2 | 0;
        if (e2[h] < n2)
          l4 = h + 1;
        else if (e2[h] > n2)
          c4 = h - 1;
        else
          return h;
      }
      return -1;
    }, i.prototype.indicesOfNearest = function(n2, e2, o) {
      var l4 = this._chunks, c4 = l4[n2], h = [];
      if (!c4)
        return h;
      o == null && (o = 1 / 0);
      for (var p4 = 1 / 0, g4 = -1, y4 = 0, _ = 0, w4 = this.count(); _ < w4; _++) {
        var C = this.getRawIndex(_), E = e2 - c4[C], T = Math.abs(E);
        T <= o && ((T < p4 || T === p4 && E >= 0 && g4 < 0) && (p4 = T, g4 = E, y4 = 0), E === g4 && (h[y4++] = _));
      }
      return h.length = y4, h;
    }, i.prototype.getIndices = function() {
      var n2, e2 = this._indices;
      if (e2) {
        var o = e2.constructor, l4 = this._count;
        if (o === Array) {
          n2 = new o(l4);
          for (var c4 = 0; c4 < l4; c4++)
            n2[c4] = e2[c4];
        } else
          n2 = new o(e2.buffer, 0, l4);
      } else {
        var o = aN(this._rawCount);
        n2 = new o(this.count());
        for (var c4 = 0; c4 < n2.length; c4++)
          n2[c4] = c4;
      }
      return n2;
    }, i.prototype.filter = function(n2, e2) {
      if (!this._count)
        return this;
      for (var o = this.clone(), l4 = o.count(), c4 = aN(o._rawCount), h = new c4(l4), p4 = [], g4 = n2.length, y4 = 0, _ = n2[0], w4 = o._chunks, C = 0; C < l4; C++) {
        var E = void 0, T = o.getRawIndex(C);
        if (g4 === 0)
          E = e2(C);
        else if (g4 === 1) {
          var O = w4[_][T];
          E = e2(O, C);
        } else {
          for (var N = 0; N < g4; N++)
            p4[N] = w4[n2[N]][T];
          p4[N] = C, E = e2.apply(null, p4);
        }
        E && (h[y4++] = T);
      }
      return y4 < l4 && (o._indices = h), o._count = y4, o._extent = [], o._updateGetRawIdx(), o;
    }, i.prototype.selectRange = function(n2) {
      var e2 = this.clone(), o = e2._count;
      if (!o)
        return this;
      var l4 = ts(n2), c4 = l4.length;
      if (!c4)
        return this;
      var h = e2.count(), p4 = aN(e2._rawCount), g4 = new p4(h), y4 = 0, _ = l4[0], w4 = n2[_][0], C = n2[_][1], E = e2._chunks, T = false;
      if (!e2._indices) {
        var O = 0;
        if (c4 === 1) {
          for (var N = E[l4[0]], V = 0; V < o; V++) {
            var H = N[V];
            (H >= w4 && H <= C || isNaN(H)) && (g4[y4++] = O), O++;
          }
          T = true;
        } else if (c4 === 2) {
          for (var N = E[l4[0]], X = E[l4[1]], q2 = n2[l4[1]][0], de = n2[l4[1]][1], V = 0; V < o; V++) {
            var H = N[V], le = X[V];
            (H >= w4 && H <= C || isNaN(H)) && (le >= q2 && le <= de || isNaN(le)) && (g4[y4++] = O), O++;
          }
          T = true;
        }
      }
      if (!T)
        if (c4 === 1)
          for (var V = 0; V < h; V++) {
            var me = e2.getRawIndex(V), H = E[l4[0]][me];
            (H >= w4 && H <= C || isNaN(H)) && (g4[y4++] = me);
          }
        else
          for (var V = 0; V < h; V++) {
            for (var ye = true, me = e2.getRawIndex(V), be = 0; be < c4; be++) {
              var we = l4[be], H = E[we][me];
              (H < n2[we][0] || H > n2[we][1]) && (ye = false);
            }
            ye && (g4[y4++] = e2.getRawIndex(V));
          }
      return y4 < h && (e2._indices = g4), e2._count = y4, e2._extent = [], e2._updateGetRawIdx(), e2;
    }, i.prototype.map = function(n2, e2) {
      var o = this.clone(n2);
      return this._updateDims(o, n2, e2), o;
    }, i.prototype.modify = function(n2, e2) {
      this._updateDims(this, n2, e2);
    }, i.prototype._updateDims = function(n2, e2, o) {
      for (var l4 = n2._chunks, c4 = [], h = e2.length, p4 = n2.count(), g4 = [], y4 = n2._rawExtent, _ = 0; _ < e2.length; _++)
        y4[e2[_]] = JP();
      for (var w4 = 0; w4 < p4; w4++) {
        for (var C = n2.getRawIndex(w4), E = 0; E < h; E++)
          g4[E] = l4[e2[E]][C];
        g4[h] = w4;
        var T = o && o.apply(null, g4);
        if (T != null) {
          typeof T != "object" && (c4[0] = T, T = c4);
          for (var _ = 0; _ < T.length; _++) {
            var O = e2[_], N = T[_], V = y4[O], H = l4[O];
            H && (H[C] = N), N < V[0] && (V[0] = N), N > V[1] && (V[1] = N);
          }
        }
      }
    }, i.prototype.lttbDownSample = function(n2, e2) {
      var o = this.clone([n2], true), l4 = o._chunks, c4 = l4[n2], h = this.count(), p4 = 0, g4 = Math.floor(1 / e2), y4 = this.getRawIndex(0), _, w4, C, E = new (aN(this._rawCount))(Math.min((Math.ceil(h / g4) + 2) * 2, h));
      E[p4++] = y4;
      for (var T = 1; T < h - 1; T += g4) {
        for (var O = Math.min(T + g4, h - 1), N = Math.min(T + g4 * 2, h), V = (N + O) / 2, H = 0, X = O; X < N; X++) {
          var q2 = this.getRawIndex(X), de = c4[q2];
          isNaN(de) || (H += de);
        }
        H /= N - O;
        var le = T, me = Math.min(T + g4, h), ye = T - 1, be = c4[y4];
        _ = -1, C = le;
        for (var we = -1, Pe = 0, X = le; X < me; X++) {
          var q2 = this.getRawIndex(X), de = c4[q2];
          if (isNaN(de)) {
            Pe++, we < 0 && (we = q2);
            continue;
          }
          w4 = Math.abs((ye - V) * (de - be) - (ye - X) * (H - be)), w4 > _ && (_ = w4, C = q2);
        }
        Pe > 0 && Pe < me - le && (E[p4++] = Math.min(we, C), C = Math.max(we, C)), E[p4++] = C, y4 = C;
      }
      return E[p4++] = this.getRawIndex(h - 1), o._count = p4, o._indices = E, o.getRawIndex = this._getRawIdx, o;
    }, i.prototype.downSample = function(n2, e2, o, l4) {
      for (var c4 = this.clone([n2], true), h = c4._chunks, p4 = [], g4 = Math.floor(1 / e2), y4 = h[n2], _ = this.count(), w4 = c4._rawExtent[n2] = JP(), C = new (aN(this._rawCount))(Math.ceil(_ / g4)), E = 0, T = 0; T < _; T += g4) {
        g4 > _ - T && (g4 = _ - T, p4.length = g4);
        for (var O = 0; O < g4; O++) {
          var N = this.getRawIndex(T + O);
          p4[O] = y4[N];
        }
        var V = o(p4), H = this.getRawIndex(Math.min(T + l4(p4, V) || 0, _ - 1));
        y4[H] = V, V < w4[0] && (w4[0] = V), V > w4[1] && (w4[1] = V), C[E++] = H;
      }
      return c4._count = E, c4._indices = C, c4._updateGetRawIdx(), c4;
    }, i.prototype.each = function(n2, e2) {
      if (!!this._count)
        for (var o = n2.length, l4 = this._chunks, c4 = 0, h = this.count(); c4 < h; c4++) {
          var p4 = this.getRawIndex(c4);
          switch (o) {
            case 0:
              e2(c4);
              break;
            case 1:
              e2(l4[n2[0]][p4], c4);
              break;
            case 2:
              e2(l4[n2[0]][p4], l4[n2[1]][p4], c4);
              break;
            default:
              for (var g4 = 0, y4 = []; g4 < o; g4++)
                y4[g4] = l4[n2[g4]][p4];
              y4[g4] = c4, e2.apply(null, y4);
          }
        }
    }, i.prototype.getDataExtent = function(n2) {
      var e2 = this._chunks[n2], o = JP();
      if (!e2)
        return o;
      var l4 = this.count(), c4 = !this._indices, h;
      if (c4)
        return this._rawExtent[n2].slice();
      if (h = this._extent[n2], h)
        return h.slice();
      h = o;
      for (var p4 = h[0], g4 = h[1], y4 = 0; y4 < l4; y4++) {
        var _ = this.getRawIndex(y4), w4 = e2[_];
        w4 < p4 && (p4 = w4), w4 > g4 && (g4 = w4);
      }
      return h = [p4, g4], this._extent[n2] = h, h;
    }, i.prototype.getRawDataItem = function(n2) {
      var e2 = this.getRawIndex(n2);
      if (this._provider.persistent)
        return this._provider.getItem(e2);
      for (var o = [], l4 = this._chunks, c4 = 0; c4 < l4.length; c4++)
        o.push(l4[c4][e2]);
      return o;
    }, i.prototype.clone = function(n2, e2) {
      var o = new i(), l4 = this._chunks, c4 = n2 && q_(n2, function(p4, g4) {
        return p4[g4] = true, p4;
      }, {});
      if (c4)
        for (var h = 0; h < l4.length; h++)
          o._chunks[h] = c4[h] ? aft(l4[h]) : l4[h];
      else
        o._chunks = l4;
      return this._copyCommonProps(o), e2 || (o._indices = this._cloneIndices()), o._updateGetRawIdx(), o;
    }, i.prototype._copyCommonProps = function(n2) {
      n2._count = this._count, n2._rawCount = this._rawCount, n2._provider = this._provider, n2._dimensions = this._dimensions, n2._extent = Ci(this._extent), n2._rawExtent = Ci(this._rawExtent);
    }, i.prototype._cloneIndices = function() {
      if (this._indices) {
        var n2 = this._indices.constructor, e2 = void 0;
        if (n2 === Array) {
          var o = this._indices.length;
          e2 = new n2(o);
          for (var l4 = 0; l4 < o; l4++)
            e2[l4] = this._indices[l4];
        } else
          e2 = new n2(this._indices);
        return e2;
      }
      return null;
    }, i.prototype._getRawIdxIdentity = function(n2) {
      return n2;
    }, i.prototype._getRawIdx = function(n2) {
      return n2 < this._count && n2 >= 0 ? this._indices[n2] : -1;
    }, i.prototype._updateGetRawIdx = function() {
      this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
    }, i.internalField = function() {
      function n2(e2, o, l4, c4) {
        return YC(e2[c4], this._dimensions[c4]);
      }
      Ore = { arrayRows: n2, objectRows: function(e2, o, l4, c4) {
        return YC(e2[o], this._dimensions[c4]);
      }, keyedColumns: n2, original: function(e2, o, l4, c4) {
        var h = e2 && (e2.value == null ? e2 : e2.value);
        return YC(h instanceof Array ? h[c4] : h, this._dimensions[c4]);
      }, typedArray: function(e2, o, l4, c4) {
        return e2[c4];
      } };
    }(), i;
  }(), YDe = function() {
    function i(n2) {
      this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = n2;
    }
    return i.prototype.dirty = function() {
      this._setLocalSource([], []), this._storeList = [], this._dirty = true;
    }, i.prototype._setLocalSource = function(n2, e2) {
      this._sourceList = n2, this._upstreamSignList = e2, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
    }, i.prototype._getVersionSign = function() {
      return this._sourceHost.uid + "_" + this._versionSignBase;
    }, i.prototype.prepareSource = function() {
      this._isDirty() && (this._createSource(), this._dirty = false);
    }, i.prototype._createSource = function() {
      this._setLocalSource([], []);
      var n2 = this._sourceHost, e2 = this._getUpstreamSourceManagers(), o = !!e2.length, l4, c4;
      if (iW(n2)) {
        var h = n2, p4 = void 0, g4 = void 0, y4 = void 0;
        if (o) {
          var _ = e2[0];
          _.prepareSource(), y4 = _.getSource(), p4 = y4.data, g4 = y4.sourceFormat, c4 = [_._getVersionSign()];
        } else
          p4 = h.get("data", true), g4 = am(p4) ? qC : By, c4 = [];
        var w4 = this._getSourceMetaRawOption() || {}, C = y4 && y4.metaRawOption || {}, E = so(w4.seriesLayoutBy, C.seriesLayoutBy) || null, T = so(w4.sourceHeader, C.sourceHeader), O = so(w4.dimensions, C.dimensions), N = E !== C.seriesLayoutBy || !!T != !!C.sourceHeader || O;
        l4 = N ? [soe(p4, { seriesLayoutBy: E, sourceHeader: T, dimensions: O }, g4)] : [];
      } else {
        var V = n2;
        if (o) {
          var H = this._applyTransform(e2);
          l4 = H.sourceList, c4 = H.upstreamSignList;
        } else {
          var X = V.get("source", true);
          l4 = [soe(X, this._getSourceMetaRawOption(), null)], c4 = [];
        }
      }
      this._setLocalSource(l4, c4);
    }, i.prototype._applyTransform = function(n2) {
      var e2 = this._sourceHost, o = e2.get("transform", true), l4 = e2.get("fromTransformResult", true);
      if (l4 != null) {
        var c4 = "";
        n2.length !== 1 && S2e(c4);
      }
      var h, p4 = [], g4 = [];
      return Ve(n2, function(y4) {
        y4.prepareSource();
        var _ = y4.getSource(l4 || 0), w4 = "";
        l4 != null && !_ && S2e(w4), p4.push(_), g4.push(y4._getVersionSign());
      }), o ? h = eft(o, p4, { datasetIndex: e2.componentIndex }) : l4 != null && (h = [Rct(p4[0])]), { sourceList: h, upstreamSignList: g4 };
    }, i.prototype._isDirty = function() {
      if (this._dirty)
        return true;
      for (var n2 = this._getUpstreamSourceManagers(), e2 = 0; e2 < n2.length; e2++) {
        var o = n2[e2];
        if (o._isDirty() || this._upstreamSignList[e2] !== o._getVersionSign())
          return true;
      }
    }, i.prototype.getSource = function(n2) {
      n2 = n2 || 0;
      var e2 = this._sourceList[n2];
      if (!e2) {
        var o = this._getUpstreamSourceManagers();
        return o[0] && o[0].getSource(n2);
      }
      return e2;
    }, i.prototype.getSharedDataStore = function(n2) {
      var e2 = n2.makeStoreSchema();
      return this._innerGetDataStore(e2.dimensions, n2.source, e2.hash);
    }, i.prototype._innerGetDataStore = function(n2, e2, o) {
      var l4 = 0, c4 = this._storeList, h = c4[l4];
      h || (h = c4[l4] = {});
      var p4 = h[o];
      if (!p4) {
        var g4 = this._getUpstreamSourceManagers()[0];
        iW(this._sourceHost) && g4 ? p4 = g4._innerGetDataStore(n2, e2, o) : (p4 = new loe(), p4.initData(new VDe(e2, n2.length), n2)), h[o] = p4;
      }
      return p4;
    }, i.prototype._getUpstreamSourceManagers = function() {
      var n2 = this._sourceHost;
      if (iW(n2)) {
        var e2 = sle(n2);
        return e2 ? [e2.getSourceManager()] : [];
      } else
        return Er(sct(n2), function(o) {
          return o.getSourceManager();
        });
    }, i.prototype._getSourceMetaRawOption = function() {
      var n2 = this._sourceHost, e2, o, l4;
      if (iW(n2))
        e2 = n2.get("seriesLayoutBy", true), o = n2.get("sourceHeader", true), l4 = n2.get("dimensions", true);
      else if (!this._getUpstreamSourceManagers().length) {
        var c4 = n2;
        e2 = c4.get("seriesLayoutBy", true), o = c4.get("sourceHeader", true), l4 = c4.get("dimensions", true);
      }
      return { seriesLayoutBy: e2, sourceHeader: o, dimensions: l4 };
    }, i;
  }();
  function w2e(i) {
    var n2 = i.option.transform;
    n2 && gH(i.option.transform);
  }
  function iW(i) {
    return i.mainType === "series";
  }
  function S2e(i) {
    throw new Error(i);
  }
  var ZDe = "line-height:1";
  function XDe(i, n2) {
    var e2 = i.color || "#6e7079", o = i.fontSize || 12, l4 = i.fontWeight || "400", c4 = i.color || "#464646", h = i.fontSize || 14, p4 = i.fontWeight || "900";
    return n2 === "html" ? { nameStyle: "font-size:" + Q0(o + "") + "px;color:" + Q0(e2) + ";font-weight:" + Q0(l4 + ""), valueStyle: "font-size:" + Q0(h + "") + "px;color:" + Q0(c4) + ";font-weight:" + Q0(p4 + "") } : { nameStyle: { fontSize: o, fill: e2, fontWeight: l4 }, valueStyle: { fontSize: h, fill: c4, fontWeight: p4 } };
  }
  var ift = [0, 10, 20, 30], oft = ["", `
`, `

`, `


`];
  function Qh(i, n2) {
    return n2.type = i, n2;
  }
  function uoe(i) {
    return i.type === "section";
  }
  function KDe(i) {
    return uoe(i) ? sft : lft;
  }
  function JDe(i) {
    if (uoe(i)) {
      var n2 = 0, e2 = i.blocks.length, o = e2 > 1 || e2 > 0 && !i.noHeader;
      return Ve(i.blocks, function(l4) {
        var c4 = JDe(l4);
        c4 >= n2 && (n2 = c4 + +(o && (!c4 || uoe(l4) && !l4.noHeader)));
      }), n2;
    }
    return 0;
  }
  function sft(i, n2, e2, o) {
    var l4 = n2.noHeader, c4 = uft(JDe(n2)), h = [], p4 = n2.blocks || [];
    Kv(!p4 || Mr(p4)), p4 = p4 || [];
    var g4 = i.orderMode;
    if (n2.sortBlocks && g4) {
      p4 = p4.slice();
      var y4 = { valueAsc: "asc", valueDesc: "desc" };
      if (Na(y4, g4)) {
        var _ = new HDe(y4[g4], null);
        p4.sort(function(T, O) {
          return _.evaluate(T.sortParam, O.sortParam);
        });
      } else
        g4 === "seriesDesc" && p4.reverse();
    }
    Ve(p4, function(T, O) {
      var N = n2.valueFormatter, V = KDe(T)(N ? rr(rr({}, i), { valueFormatter: N }) : i, T, O > 0 ? c4.html : 0, o);
      V != null && h.push(V);
    });
    var w4 = i.renderMode === "richText" ? h.join(c4.richText) : coe(h.join(""), l4 ? e2 : c4.html);
    if (l4)
      return w4;
    var C = aoe(n2.header, "ordinal", i.useUTC), E = XDe(o, i.renderMode).nameStyle;
    return i.renderMode === "richText" ? QDe(i, C, E) + c4.richText + w4 : coe('<div style="' + E + ";" + ZDe + ';">' + Q0(C) + "</div>" + w4, e2);
  }
  function lft(i, n2, e2, o) {
    var l4 = i.renderMode, c4 = n2.noName, h = n2.noValue, p4 = !n2.markerType, g4 = n2.name, y4 = i.useUTC, _ = n2.valueFormatter || i.valueFormatter || function(q2) {
      return q2 = Mr(q2) ? q2 : [q2], Er(q2, function(de, le) {
        return aoe(de, Mr(E) ? E[le] : E, y4);
      });
    };
    if (!(c4 && h)) {
      var w4 = p4 ? "" : i.markupStyleCreator.makeTooltipMarker(n2.markerType, n2.markerColor || "#333", l4), C = c4 ? "" : aoe(g4, "ordinal", y4), E = n2.valueType, T = h ? [] : _(n2.value), O = !p4 || !c4, N = !p4 && c4, V = XDe(o, l4), H = V.nameStyle, X = V.valueStyle;
      return l4 === "richText" ? (p4 ? "" : w4) + (c4 ? "" : QDe(i, C, H)) + (h ? "" : hft(i, T, O, N, X)) : coe((p4 ? "" : w4) + (c4 ? "" : cft(C, !p4, H)) + (h ? "" : fft(T, O, N, X)), e2);
    }
  }
  function C2e(i, n2, e2, o, l4, c4) {
    if (!!i) {
      var h = KDe(i), p4 = { useUTC: l4, renderMode: e2, orderMode: o, markupStyleCreator: n2, valueFormatter: i.valueFormatter };
      return h(p4, i, 0, c4);
    }
  }
  function uft(i) {
    return { html: ift[i], richText: oft[i] };
  }
  function coe(i, n2) {
    var e2 = '<div style="clear:both"></div>', o = "margin: " + n2 + "px 0 0";
    return '<div style="' + o + ";" + ZDe + ';">' + i + e2 + "</div>";
  }
  function cft(i, n2, e2) {
    var o = n2 ? "margin-left:2px" : "";
    return '<span style="' + e2 + ";" + o + '">' + Q0(i) + "</span>";
  }
  function fft(i, n2, e2, o) {
    var l4 = e2 ? "10px" : "20px", c4 = n2 ? "float:right;margin-left:" + l4 : "";
    return i = Mr(i) ? i : [i], '<span style="' + c4 + ";" + o + '">' + Er(i, function(h) {
      return Q0(h);
    }).join("&nbsp;&nbsp;") + "</span>";
  }
  function QDe(i, n2, e2) {
    return i.markupStyleCreator.wrapRichTextStyle(n2, e2);
  }
  function hft(i, n2, e2, o, l4) {
    var c4 = [l4], h = o ? 10 : 20;
    return e2 && c4.push({ padding: [0, 0, 0, h], align: "right" }), i.markupStyleCreator.wrapRichTextStyle(Mr(n2) ? n2.join("  ") : n2, c4);
  }
  function e5e(i, n2) {
    var e2 = i.getData().getItemVisual(n2, "style"), o = e2[i.visualDrawType];
    return xT(o);
  }
  function t5e(i, n2) {
    var e2 = i.get("padding");
    return e2 != null ? e2 : n2 === "richText" ? [8, 10] : 10;
  }
  var Rre = function() {
    function i() {
      this.richTextStyles = {}, this._nextStyleNameId = QIe();
    }
    return i.prototype._generateStyleName = function() {
      return "__EC_aUTo_" + this._nextStyleNameId++;
    }, i.prototype.makeTooltipMarker = function(n2, e2, o) {
      var l4 = o === "richText" ? this._generateStyleName() : null, c4 = ect({ color: e2, type: n2, renderMode: o, markerId: l4 });
      return xa(c4) ? c4 : (this.richTextStyles[l4] = c4.style, c4.content);
    }, i.prototype.wrapRichTextStyle = function(n2, e2) {
      var o = {};
      Mr(e2) ? Ve(e2, function(c4) {
        return rr(o, c4);
      }) : rr(o, e2);
      var l4 = this._generateStyleName();
      return this.richTextStyles[l4] = o, "{" + l4 + "|" + n2 + "}";
    }, i;
  }();
  function n5e(i) {
    var n2 = i.series, e2 = i.dataIndex, o = i.multipleSeries, l4 = n2.getData(), c4 = l4.mapDimensionsAll("defaultedTooltip"), h = c4.length, p4 = n2.getRawValue(e2), g4 = Mr(p4), y4 = e5e(n2, e2), _, w4, C, E;
    if (h > 1 || g4 && !h) {
      var T = dft(p4, n2, e2, c4, y4);
      _ = T.inlineValues, w4 = T.inlineValueTypes, C = T.blocks, E = T.inlineValues[0];
    } else if (h) {
      var O = l4.getDimensionInfo(c4[0]);
      E = _ = R3(l4, e2, c4[0]), w4 = O.type;
    } else
      E = _ = g4 ? p4[0] : p4;
    var N = Bse(n2), V = N && n2.name || "", H = l4.getName(e2), X = o ? V : H;
    return Qh("section", { header: V, noHeader: o || !N, sortParam: E, blocks: [Qh("nameValue", { markerType: "item", markerColor: y4, name: X, noName: !tb(X), value: _, valueType: w4 })].concat(C || []) });
  }
  function dft(i, n2, e2, o, l4) {
    var c4 = n2.getData(), h = q_(i, function(w4, C, E) {
      var T = c4.getDimensionInfo(E);
      return w4 = w4 || T && T.tooltip !== false && T.displayName != null;
    }, false), p4 = [], g4 = [], y4 = [];
    o.length ? Ve(o, function(w4) {
      _(R3(c4, e2, w4), w4);
    }) : Ve(i, _);
    function _(w4, C) {
      var E = c4.getDimensionInfo(C);
      !E || E.otherDims.tooltip === false || (h ? y4.push(Qh("nameValue", { markerType: "subItem", markerColor: l4, name: E.displayName, value: w4, valueType: E.type })) : (p4.push(w4), g4.push(E.type)));
    }
    return { inlineValues: p4, inlineValueTypes: g4, blocks: y4 };
  }
  var MC = zs();
  function oW(i, n2) {
    return i.getName(n2) || i.getId(n2);
  }
  var sH = "__universalTransitionEnabled", B$ = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2._selectedDataIndicesMap = {}, e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      this.seriesIndex = this.componentIndex, this.dataTask = YN({ count: vft, reset: gft }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(e2, l4);
      var c4 = MC(this).sourceManager = new YDe(this);
      c4.prepareSource();
      var h = this.getInitialData(e2, l4);
      A2e(h, this), this.dataTask.context.data = h, MC(this).dataBeforeProcessed = h, M2e(this), this._initSelectedMapFromData(h);
    }, n2.prototype.mergeDefaultAndTheme = function(e2, o) {
      var l4 = v8(this), c4 = l4 ? K3(e2) : {}, h = this.subType;
      Ns.hasClass(h) && (h += "Series"), to(e2, o.getTheme().get(this.subType)), to(e2, this.getDefaultOption()), mT(e2, "label", ["show"]), this.fillDataTextStyle(e2.data), l4 && QC(e2, c4, l4);
    }, n2.prototype.mergeOption = function(e2, o) {
      e2 = to(this.option, e2, true), this.fillDataTextStyle(e2.data);
      var l4 = v8(this);
      l4 && QC(this.option, e2, l4);
      var c4 = MC(this).sourceManager;
      c4.dirty(), c4.prepareSource();
      var h = this.getInitialData(e2, o);
      A2e(h, this), this.dataTask.dirty(), this.dataTask.context.data = h, MC(this).dataBeforeProcessed = h, M2e(this), this._initSelectedMapFromData(h);
    }, n2.prototype.fillDataTextStyle = function(e2) {
      if (e2 && !am(e2))
        for (var o = ["show"], l4 = 0; l4 < e2.length; l4++)
          e2[l4] && e2[l4].label && mT(e2[l4], "label", o);
    }, n2.prototype.getInitialData = function(e2, o) {
    }, n2.prototype.appendData = function(e2) {
      var o = this.getRawData();
      o.appendData(e2.data);
    }, n2.prototype.getData = function(e2) {
      var o = foe(this);
      if (o) {
        var l4 = o.context.data;
        return e2 == null ? l4 : l4.getLinkedData(e2);
      } else
        return MC(this).data;
    }, n2.prototype.getAllData = function() {
      var e2 = this.getData();
      return e2 && e2.getLinkedDataAll ? e2.getLinkedDataAll() : [{ data: e2 }];
    }, n2.prototype.setData = function(e2) {
      var o = foe(this);
      if (o) {
        var l4 = o.context;
        l4.outputData = e2, o !== this.dataTask && (l4.data = e2);
      }
      MC(this).data = e2;
    }, n2.prototype.getEncode = function() {
      var e2 = this.get("encode", true);
      if (e2)
        return ri(e2);
    }, n2.prototype.getSourceManager = function() {
      return MC(this).sourceManager;
    }, n2.prototype.getSource = function() {
      return this.getSourceManager().getSource();
    }, n2.prototype.getRawData = function() {
      return MC(this).dataBeforeProcessed;
    }, n2.prototype.getColorBy = function() {
      var e2 = this.get("colorBy");
      return e2 || "series";
    }, n2.prototype.isColorBySeries = function() {
      return this.getColorBy() === "series";
    }, n2.prototype.getBaseAxis = function() {
      var e2 = this.coordinateSystem;
      return e2 && e2.getBaseAxis && e2.getBaseAxis();
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      return n5e({ series: this, dataIndex: e2, multipleSeries: o });
    }, n2.prototype.isAnimationEnabled = function() {
      var e2 = this.ecModel;
      if (ol.node && !(e2 && e2.ssr))
        return false;
      var o = this.getShallow("animation");
      return o && this.getData().count() > this.getShallow("animationThreshold") && (o = false), !!o;
    }, n2.prototype.restoreData = function() {
      this.dataTask.dirty();
    }, n2.prototype.getColorFromPalette = function(e2, o, l4) {
      var c4 = this.ecModel, h = lle.prototype.getColorFromPalette.call(this, e2, o, l4);
      return h || (h = c4.getColorFromPalette(e2, o, l4)), h;
    }, n2.prototype.coordDimToDataDim = function(e2) {
      return this.getRawData().mapDimensionsAll(e2);
    }, n2.prototype.getProgressive = function() {
      return this.get("progressive");
    }, n2.prototype.getProgressiveThreshold = function() {
      return this.get("progressiveThreshold");
    }, n2.prototype.select = function(e2, o) {
      this._innerSelect(this.getData(o), e2);
    }, n2.prototype.unselect = function(e2, o) {
      var l4 = this.option.selectedMap;
      if (!!l4) {
        var c4 = this.option.selectedMode, h = this.getData(o);
        if (c4 === "series" || l4 === "all") {
          this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
          return;
        }
        for (var p4 = 0; p4 < e2.length; p4++) {
          var g4 = e2[p4], y4 = oW(h, g4);
          l4[y4] = false, this._selectedDataIndicesMap[y4] = -1;
        }
      }
    }, n2.prototype.toggleSelect = function(e2, o) {
      for (var l4 = [], c4 = 0; c4 < e2.length; c4++)
        l4[0] = e2[c4], this.isSelected(e2[c4], o) ? this.unselect(l4, o) : this.select(l4, o);
    }, n2.prototype.getSelectedDataIndices = function() {
      if (this.option.selectedMap === "all")
        return [].slice.call(this.getData().getIndices());
      for (var e2 = this._selectedDataIndicesMap, o = ts(e2), l4 = [], c4 = 0; c4 < o.length; c4++) {
        var h = e2[o[c4]];
        h >= 0 && l4.push(h);
      }
      return l4;
    }, n2.prototype.isSelected = function(e2, o) {
      var l4 = this.option.selectedMap;
      if (!l4)
        return false;
      var c4 = this.getData(o);
      return (l4 === "all" || l4[oW(c4, e2)]) && !c4.getItemModel(e2).get(["select", "disabled"]);
    }, n2.prototype.isUniversalTransitionEnabled = function() {
      if (this[sH])
        return true;
      var e2 = this.option.universalTransition;
      return e2 ? e2 === true ? true : e2 && e2.enabled : false;
    }, n2.prototype._innerSelect = function(e2, o) {
      var l4, c4, h = this.option, p4 = h.selectedMode, g4 = o.length;
      if (!(!p4 || !g4)) {
        if (p4 === "series")
          h.selectedMap = "all";
        else if (p4 === "multiple") {
          mi(h.selectedMap) || (h.selectedMap = {});
          for (var y4 = h.selectedMap, _ = 0; _ < g4; _++) {
            var w4 = o[_], C = oW(e2, w4);
            y4[C] = true, this._selectedDataIndicesMap[C] = e2.getRawIndex(w4);
          }
        } else if (p4 === "single" || p4 === true) {
          var E = o[g4 - 1], C = oW(e2, E);
          h.selectedMap = (l4 = {}, l4[C] = true, l4), this._selectedDataIndicesMap = (c4 = {}, c4[C] = e2.getRawIndex(E), c4);
        }
      }
    }, n2.prototype._initSelectedMapFromData = function(e2) {
      if (!this.option.selectedMap) {
        var o = [];
        e2.hasItemOption && e2.each(function(l4) {
          var c4 = e2.getRawDataItem(l4);
          c4 && c4.selected && o.push(l4);
        }), o.length > 0 && this._innerSelect(e2, o);
      }
    }, n2.registerClass = function(e2) {
      return Ns.registerClass(e2);
    }, n2.protoInitialize = function() {
      var e2 = n2.prototype;
      e2.type = "series.__base__", e2.seriesIndex = 0, e2.ignoreStyleOnData = false, e2.hasSymbolVisual = false, e2.defaultSymbol = "circle", e2.visualStyleAccessPath = "itemStyle", e2.visualDrawType = "fill";
    }(), n2;
  }(Ns);
  Kf(B$, hle);
  Kf(B$, lle);
  lTe(B$, Ns);
  function M2e(i) {
    var n2 = i.name;
    Bse(i) || (i.name = pft(i) || n2);
  }
  function pft(i) {
    var n2 = i.getRawData(), e2 = n2.mapDimensionsAll("seriesName"), o = [];
    return Ve(e2, function(l4) {
      var c4 = n2.getDimensionInfo(l4);
      c4.displayName && o.push(c4.displayName);
    }), o.join(" ");
  }
  function vft(i) {
    return i.model.getRawData().count();
  }
  function gft(i) {
    var n2 = i.model;
    return n2.setData(n2.getRawData().cloneShallow()), mft;
  }
  function mft(i, n2) {
    n2.outputData && i.end > n2.outputData.count() && n2.model.getRawData().cloneShallow(n2.outputData);
  }
  function A2e(i, n2) {
    Ve(Sie(i.CHANGABLE_METHODS, i.DOWNSAMPLE_METHODS), function(e2) {
      i.wrapMethod(e2, zi(yft, n2));
    });
  }
  function yft(i, n2) {
    var e2 = foe(i);
    return e2 && e2.setOutputEnd((n2 || this).count()), n2;
  }
  function foe(i) {
    var n2 = (i.ecModel || {}).scheduler, e2 = n2 && n2.getPipeline(i.uid);
    if (e2) {
      var o = e2.currentTask;
      if (o) {
        var l4 = o.agentStubMap;
        l4 && (o = l4.get(i.uid));
      }
      return o;
    }
  }
  var _c2 = B$, ple = function() {
    function i() {
      this.group = new Ti(), this.uid = Z3("viewComponent");
    }
    return i.prototype.init = function(n2, e2) {
    }, i.prototype.render = function(n2, e2, o, l4) {
    }, i.prototype.dispose = function(n2, e2) {
    }, i.prototype.updateView = function(n2, e2, o, l4) {
    }, i.prototype.updateLayout = function(n2, e2, o, l4) {
    }, i.prototype.updateVisual = function(n2, e2, o, l4) {
    }, i.prototype.blurSeries = function(n2, e2) {
    }, i.prototype.eachRendered = function(n2) {
      var e2 = this.group;
      e2 && e2.traverse(n2);
    }, i;
  }();
  Gse(ple);
  x$(ple);
  var $c = ple;
  function eL() {
    var i = zs();
    return function(n2) {
      var e2 = i(n2), o = n2.pipelineContext, l4 = !!e2.large, c4 = !!e2.progressiveRender, h = e2.large = !!(o && o.large), p4 = e2.progressiveRender = !!(o && o.progressiveRender);
      return (l4 !== h || c4 !== p4) && "reset";
    };
  }
  var r5e = zs(), bft = eL(), vle = function() {
    function i() {
      this.group = new Ti(), this.uid = Z3("viewChart"), this.renderTask = YN({ plan: _ft, reset: xft }), this.renderTask.context = { view: this };
    }
    return i.prototype.init = function(n2, e2) {
    }, i.prototype.render = function(n2, e2, o, l4) {
    }, i.prototype.highlight = function(n2, e2, o, l4) {
      var c4 = n2.getData(l4 && l4.dataType);
      !c4 || I2e(c4, l4, "emphasis");
    }, i.prototype.downplay = function(n2, e2, o, l4) {
      var c4 = n2.getData(l4 && l4.dataType);
      !c4 || I2e(c4, l4, "normal");
    }, i.prototype.remove = function(n2, e2) {
      this.group.removeAll();
    }, i.prototype.dispose = function(n2, e2) {
    }, i.prototype.updateView = function(n2, e2, o, l4) {
      this.render(n2, e2, o, l4);
    }, i.prototype.updateLayout = function(n2, e2, o, l4) {
      this.render(n2, e2, o, l4);
    }, i.prototype.updateVisual = function(n2, e2, o, l4) {
      this.render(n2, e2, o, l4);
    }, i.prototype.eachRendered = function(n2) {
      oM(this.group, n2);
    }, i.markUpdateMethod = function(n2, e2) {
      r5e(n2).updateMethod = e2;
    }, i.protoInitialize = function() {
      var n2 = i.prototype;
      n2.type = "chart";
    }(), i;
  }();
  function E2e(i, n2, e2) {
    i && f8(i) && (n2 === "emphasis" ? W_ : H_)(i, e2);
  }
  function I2e(i, n2, e2) {
    var o = yT(i, n2), l4 = n2 && n2.highlightKey != null ? Hlt(n2.highlightKey) : null;
    o != null ? Ve(Zl(o), function(c4) {
      E2e(i.getItemGraphicEl(c4), e2, l4);
    }) : i.eachItemGraphicEl(function(c4) {
      E2e(c4, e2, l4);
    });
  }
  Gse(vle);
  x$(vle);
  function _ft(i) {
    return bft(i.model);
  }
  function xft(i) {
    var n2 = i.model, e2 = i.ecModel, o = i.api, l4 = i.payload, c4 = n2.pipelineContext.progressiveRender, h = i.view, p4 = l4 && r5e(l4).updateMethod, g4 = c4 ? "incrementalPrepareRender" : p4 && h[p4] ? p4 : "render";
    return g4 !== "render" && h[g4](n2, e2, o, l4), wft[g4];
  }
  var wft = { incrementalPrepareRender: { progress: function(i, n2) {
    n2.view.incrementalRender(i, n2.model, n2.ecModel, n2.api, n2.payload);
  } }, render: { forceFirstProgress: true, progress: function(i, n2) {
    n2.view.render(n2.model, n2.ecModel, n2.api, n2.payload);
  } } }, Ru = vle, LH = "\0__throttleOriginMethod", T2e = "\0__throttleRate", D2e = "\0__throttleType";
  function gle(i, n2, e2) {
    var o, l4 = 0, c4 = 0, h = null, p4, g4, y4, _;
    n2 = n2 || 0;
    function w4() {
      c4 = new Date().getTime(), h = null, i.apply(g4, y4 || []);
    }
    var C = function() {
      for (var E = [], T = 0; T < arguments.length; T++)
        E[T] = arguments[T];
      o = new Date().getTime(), g4 = this, y4 = E;
      var O = _ || n2, N = _ || e2;
      _ = null, p4 = o - (N ? l4 : c4) - O, clearTimeout(h), N ? h = setTimeout(w4, O) : p4 >= 0 ? w4() : h = setTimeout(w4, -p4), l4 = o;
    };
    return C.clear = function() {
      h && (clearTimeout(h), h = null);
    }, C.debounceNextCall = function(E) {
      _ = E;
    }, C;
  }
  function tL(i, n2, e2, o) {
    var l4 = i[n2];
    if (!!l4) {
      var c4 = l4[LH] || l4, h = l4[D2e], p4 = l4[T2e];
      if (p4 !== e2 || h !== o) {
        if (e2 == null || !o)
          return i[n2] = c4;
        l4 = i[n2] = gle(c4, e2, o === "debounce"), l4[LH] = c4, l4[D2e] = o, l4[T2e] = e2;
      }
      return l4;
    }
  }
  function m8(i, n2) {
    var e2 = i[n2];
    e2 && e2[LH] && (e2.clear && e2.clear(), i[n2] = e2[LH]);
  }
  var k2e = zs(), P2e = { itemStyle: bT(sDe, true), lineStyle: bT(oDe, true) }, Sft = { lineStyle: "stroke", itemStyle: "fill" };
  function a5e(i, n2) {
    var e2 = i.visualStyleMapper || P2e[n2];
    return e2 || (console.warn("Unkown style type '" + n2 + "'."), P2e.itemStyle);
  }
  function i5e(i, n2) {
    var e2 = i.visualDrawType || Sft[n2];
    return e2 || (console.warn("Unkown style type '" + n2 + "'."), "fill");
  }
  var Cft = { createOnAllSeries: true, performRawSeries: true, reset: function(i, n2) {
    var e2 = i.getData(), o = i.visualStyleAccessPath || "itemStyle", l4 = i.getModel(o), c4 = a5e(i, o), h = c4(l4), p4 = l4.getShallow("decal");
    p4 && (e2.setVisual("decal", p4), p4.dirty = true);
    var g4 = i5e(i, o), y4 = h[g4], _ = si(y4) ? y4 : null, w4 = h.fill === "auto" || h.stroke === "auto";
    if (!h[g4] || _ || w4) {
      var C = i.getColorFromPalette(i.name, null, n2.getSeriesCount());
      h[g4] || (h[g4] = C, e2.setVisual("colorFromPalette", true)), h.fill = h.fill === "auto" || si(h.fill) ? C : h.fill, h.stroke = h.stroke === "auto" || si(h.stroke) ? C : h.stroke;
    }
    if (e2.setVisual("style", h), e2.setVisual("drawType", g4), !n2.isSeriesFiltered(i) && _)
      return e2.setVisual("colorFromPalette", false), { dataEach: function(E, T) {
        var O = i.getDataParams(T), N = rr({}, h);
        N[g4] = _(O), E.setItemVisual(T, "style", N);
      } };
  } }, iN = new Ou(), Mft = { createOnAllSeries: true, performRawSeries: true, reset: function(i, n2) {
    if (!(i.ignoreStyleOnData || n2.isSeriesFiltered(i))) {
      var e2 = i.getData(), o = i.visualStyleAccessPath || "itemStyle", l4 = a5e(i, o), c4 = e2.getVisual("drawType");
      return { dataEach: e2.hasItemOption ? function(h, p4) {
        var g4 = h.getRawDataItem(p4);
        if (g4 && g4[o]) {
          iN.option = g4[o];
          var y4 = l4(iN), _ = h.ensureUniqueItemVisual(p4, "style");
          rr(_, y4), iN.option.decal && (h.setItemVisual(p4, "decal", iN.option.decal), iN.option.decal.dirty = true), c4 in y4 && h.setItemVisual(p4, "colorFromPalette", false);
        }
      } : null };
    }
  } }, Aft = { performRawSeries: true, overallReset: function(i) {
    var n2 = ri();
    i.eachSeries(function(e2) {
      var o = e2.getColorBy();
      if (!e2.isColorBySeries()) {
        var l4 = e2.type + "-" + o, c4 = n2.get(l4);
        c4 || (c4 = {}, n2.set(l4, c4)), k2e(e2).scope = c4;
      }
    }), i.eachSeries(function(e2) {
      if (!(e2.isColorBySeries() || i.isSeriesFiltered(e2))) {
        var o = e2.getRawData(), l4 = {}, c4 = e2.getData(), h = k2e(e2).scope, p4 = e2.visualStyleAccessPath || "itemStyle", g4 = i5e(e2, p4);
        c4.each(function(y4) {
          var _ = c4.getRawIndex(y4);
          l4[_] = y4;
        }), o.each(function(y4) {
          var _ = l4[y4], w4 = c4.getItemVisual(_, "colorFromPalette");
          if (w4) {
            var C = c4.ensureUniqueItemVisual(_, "style"), E = o.getName(y4) || y4 + "", T = o.count();
            C[g4] = e2.getColorFromPalette(E, h, T);
          }
        });
      }
    });
  } }, sW = Math.PI;
  function Eft(i, n2) {
    n2 = n2 || {}, hi(n2, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
    var e2 = new Ti(), o = new Is({ style: { fill: n2.maskColor }, zlevel: n2.zlevel, z: 1e4 });
    e2.add(o);
    var l4 = new Qs({ style: { text: n2.text, fill: n2.textColor, fontSize: n2.fontSize, fontWeight: n2.fontWeight, fontStyle: n2.fontStyle, fontFamily: n2.fontFamily }, zlevel: n2.zlevel, z: 10001 }), c4 = new Is({ style: { fill: "none" }, textContent: l4, textConfig: { position: "right", distance: 10 }, zlevel: n2.zlevel, z: 10001 });
    e2.add(c4);
    var h;
    return n2.showSpinner && (h = new Xse({ shape: { startAngle: -sW / 2, endAngle: -sW / 2 + 0.1, r: n2.spinnerRadius }, style: { stroke: n2.color, lineCap: "round", lineWidth: n2.lineWidth }, zlevel: n2.zlevel, z: 10001 }), h.animateShape(true).when(1e3, { endAngle: sW * 3 / 2 }).start("circularInOut"), h.animateShape(true).when(1e3, { startAngle: sW * 3 / 2 }).delay(300).start("circularInOut"), e2.add(h)), e2.resize = function() {
      var p4 = l4.getBoundingRect().width, g4 = n2.showSpinner ? n2.spinnerRadius : 0, y4 = (i.getWidth() - g4 * 2 - (n2.showSpinner && p4 ? 10 : 0) - p4) / 2 - (n2.showSpinner && p4 ? 0 : 5 + p4 / 2) + (n2.showSpinner ? 0 : p4 / 2) + (p4 ? 0 : g4), _ = i.getHeight() / 2;
      n2.showSpinner && h.setShape({ cx: y4, cy: _ }), c4.setShape({ x: y4 - g4, y: _ - g4, width: g4 * 2, height: g4 * 2 }), o.setShape({ x: 0, y: 0, width: i.getWidth(), height: i.getHeight() });
    }, e2.resize(), e2;
  }
  var Ift = function() {
    function i(n2, e2, o, l4) {
      this._stageTaskMap = ri(), this.ecInstance = n2, this.api = e2, o = this._dataProcessorHandlers = o.slice(), l4 = this._visualHandlers = l4.slice(), this._allHandlers = o.concat(l4);
    }
    return i.prototype.restoreData = function(n2, e2) {
      n2.restoreData(e2), this._stageTaskMap.each(function(o) {
        var l4 = o.overallTask;
        l4 && l4.dirty();
      });
    }, i.prototype.getPerformArgs = function(n2, e2) {
      if (!!n2.__pipeline) {
        var o = this._pipelineMap.get(n2.__pipeline.id), l4 = o.context, c4 = !e2 && o.progressiveEnabled && (!l4 || l4.progressiveRender) && n2.__idxInPipeline > o.blockIndex, h = c4 ? o.step : null, p4 = l4 && l4.modDataCount, g4 = p4 != null ? Math.ceil(p4 / h) : null;
        return { step: h, modBy: g4, modDataCount: p4 };
      }
    }, i.prototype.getPipeline = function(n2) {
      return this._pipelineMap.get(n2);
    }, i.prototype.updateStreamModes = function(n2, e2) {
      var o = this._pipelineMap.get(n2.uid), l4 = n2.getData(), c4 = l4.count(), h = o.progressiveEnabled && e2.incrementalPrepareRender && c4 >= o.threshold, p4 = n2.get("large") && c4 >= n2.get("largeThreshold"), g4 = n2.get("progressiveChunkMode") === "mod" ? c4 : null;
      n2.pipelineContext = o.context = { progressiveRender: h, modDataCount: g4, large: p4 };
    }, i.prototype.restorePipelines = function(n2) {
      var e2 = this, o = e2._pipelineMap = ri();
      n2.eachSeries(function(l4) {
        var c4 = l4.getProgressive(), h = l4.uid;
        o.set(h, { id: h, head: null, tail: null, threshold: l4.getProgressiveThreshold(), progressiveEnabled: c4 && !(l4.preventIncremental && l4.preventIncremental()), blockIndex: -1, step: Math.round(c4 || 700), count: 0 }), e2._pipe(l4, l4.dataTask);
      });
    }, i.prototype.prepareStageTasks = function() {
      var n2 = this._stageTaskMap, e2 = this.api.getModel(), o = this.api;
      Ve(this._allHandlers, function(l4) {
        var c4 = n2.get(l4.uid) || n2.set(l4.uid, {}), h = "";
        Kv(!(l4.reset && l4.overallReset), h), l4.reset && this._createSeriesStageTask(l4, c4, e2, o), l4.overallReset && this._createOverallStageTask(l4, c4, e2, o);
      }, this);
    }, i.prototype.prepareView = function(n2, e2, o, l4) {
      var c4 = n2.renderTask, h = c4.context;
      h.model = e2, h.ecModel = o, h.api = l4, c4.__block = !n2.incrementalPrepareRender, this._pipe(e2, c4);
    }, i.prototype.performDataProcessorTasks = function(n2, e2) {
      this._performStageTasks(this._dataProcessorHandlers, n2, e2, { block: true });
    }, i.prototype.performVisualTasks = function(n2, e2, o) {
      this._performStageTasks(this._visualHandlers, n2, e2, o);
    }, i.prototype._performStageTasks = function(n2, e2, o, l4) {
      l4 = l4 || {};
      var c4 = false, h = this;
      Ve(n2, function(g4, y4) {
        if (!(l4.visualType && l4.visualType !== g4.visualType)) {
          var _ = h._stageTaskMap.get(g4.uid), w4 = _.seriesTaskMap, C = _.overallTask;
          if (C) {
            var E, T = C.agentStubMap;
            T.each(function(N) {
              p4(l4, N) && (N.dirty(), E = true);
            }), E && C.dirty(), h.updatePayload(C, o);
            var O = h.getPerformArgs(C, l4.block);
            T.each(function(N) {
              N.perform(O);
            }), C.perform(O) && (c4 = true);
          } else
            w4 && w4.each(function(N, V) {
              p4(l4, N) && N.dirty();
              var H = h.getPerformArgs(N, l4.block);
              H.skip = !g4.performRawSeries && e2.isSeriesFiltered(N.context.model), h.updatePayload(N, o), N.perform(H) && (c4 = true);
            });
        }
      });
      function p4(g4, y4) {
        return g4.setDirty && (!g4.dirtyMap || g4.dirtyMap.get(y4.__pipeline.id));
      }
      this.unfinished = c4 || this.unfinished;
    }, i.prototype.performSeriesTasks = function(n2) {
      var e2;
      n2.eachSeries(function(o) {
        e2 = o.dataTask.perform() || e2;
      }), this.unfinished = e2 || this.unfinished;
    }, i.prototype.plan = function() {
      this._pipelineMap.each(function(n2) {
        var e2 = n2.tail;
        do {
          if (e2.__block) {
            n2.blockIndex = e2.__idxInPipeline;
            break;
          }
          e2 = e2.getUpstream();
        } while (e2);
      });
    }, i.prototype.updatePayload = function(n2, e2) {
      e2 !== "remain" && (n2.context.payload = e2);
    }, i.prototype._createSeriesStageTask = function(n2, e2, o, l4) {
      var c4 = this, h = e2.seriesTaskMap, p4 = e2.seriesTaskMap = ri(), g4 = n2.seriesType, y4 = n2.getTargetSeries;
      n2.createOnAllSeries ? o.eachRawSeries(_) : g4 ? o.eachRawSeriesByType(g4, _) : y4 && y4(o, l4).each(_);
      function _(w4) {
        var C = w4.uid, E = p4.set(C, h && h.get(C) || YN({ plan: Lft, reset: Oft, count: Fft }));
        E.context = { model: w4, ecModel: o, api: l4, useClearVisual: n2.isVisual && !n2.isLayout, plan: n2.plan, reset: n2.reset, scheduler: c4 }, c4._pipe(w4, E);
      }
    }, i.prototype._createOverallStageTask = function(n2, e2, o, l4) {
      var c4 = this, h = e2.overallTask = e2.overallTask || YN({ reset: Tft });
      h.context = { ecModel: o, api: l4, overallReset: n2.overallReset, scheduler: c4 };
      var p4 = h.agentStubMap, g4 = h.agentStubMap = ri(), y4 = n2.seriesType, _ = n2.getTargetSeries, w4 = true, C = false, E = "";
      Kv(!n2.createOnAllSeries, E), y4 ? o.eachRawSeriesByType(y4, T) : _ ? _(o, l4).each(T) : (w4 = false, Ve(o.getSeries(), T));
      function T(O) {
        var N = O.uid, V = g4.set(N, p4 && p4.get(N) || (C = true, YN({ reset: Dft, onDirty: Pft })));
        V.context = { model: O, overallProgress: w4 }, V.agent = h, V.__block = w4, c4._pipe(O, V);
      }
      C && h.dirty();
    }, i.prototype._pipe = function(n2, e2) {
      var o = n2.uid, l4 = this._pipelineMap.get(o);
      !l4.head && (l4.head = e2), l4.tail && l4.tail.pipe(e2), l4.tail = e2, e2.__idxInPipeline = l4.count++, e2.__pipeline = l4;
    }, i.wrapStageHandler = function(n2, e2) {
      return si(n2) && (n2 = { overallReset: n2, seriesType: Nft(n2) }), n2.uid = Z3("stageHandler"), e2 && (n2.visualType = e2), n2;
    }, i;
  }();
  function Tft(i) {
    i.overallReset(i.ecModel, i.api, i.payload);
  }
  function Dft(i) {
    return i.overallProgress && kft;
  }
  function kft() {
    this.agent.dirty(), this.getDownstream().dirty();
  }
  function Pft() {
    this.agent && this.agent.dirty();
  }
  function Lft(i) {
    return i.plan ? i.plan(i.model, i.ecModel, i.api, i.payload) : null;
  }
  function Oft(i) {
    i.useClearVisual && i.data.clearAllVisual();
    var n2 = i.resetDefines = Zl(i.reset(i.model, i.ecModel, i.api, i.payload));
    return n2.length > 1 ? Er(n2, function(e2, o) {
      return o5e(o);
    }) : Rft;
  }
  var Rft = o5e(0);
  function o5e(i) {
    return function(n2, e2) {
      var o = e2.data, l4 = e2.resetDefines[i];
      if (l4 && l4.dataEach)
        for (var c4 = n2.start; c4 < n2.end; c4++)
          l4.dataEach(o, c4);
      else
        l4 && l4.progress && l4.progress(n2, o);
    };
  }
  function Fft(i) {
    return i.data.count();
  }
  function Nft(i) {
    OH = null;
    try {
      i(y8, s5e);
    } catch {
    }
    return OH;
  }
  var y8 = {}, s5e = {}, OH;
  l5e(y8, PDe);
  l5e(s5e, LDe);
  y8.eachSeriesByType = y8.eachRawSeriesByType = function(i) {
    OH = i;
  };
  y8.eachComponent = function(i) {
    i.mainType === "series" && i.subType && (OH = i.subType);
  };
  function l5e(i, n2) {
    for (var e2 in n2.prototype)
      i[e2] = Zf;
  }
  var u5e = Ift, L2e = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], Vft = { color: L2e, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], L2e] }, Uv = "#B9B8CE", O2e = "#100C2A", lW = function() {
    return { axisLine: { lineStyle: { color: Uv } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
  }, R2e = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], c5e = { darkMode: true, color: R2e, backgroundColor: O2e, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: Uv } }, textStyle: { color: Uv }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: Uv } }, dataZoom: { borderColor: "#71708A", textStyle: { color: Uv }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: Uv } }, timeline: { lineStyle: { color: Uv }, label: { color: Uv }, controlStyle: { color: Uv, borderColor: Uv } }, calendar: { itemStyle: { color: O2e }, dayLabel: { color: Uv }, monthLabel: { color: Uv }, yearLabel: { color: Uv } }, timeAxis: lW(), logAxis: lW(), valueAxis: lW(), categoryAxis: lW(), line: { symbol: "circle" }, graph: { color: R2e }, gauge: { title: { color: Uv }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: Uv }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
  c5e.categoryAxis.splitLine.show = false;
  var zft = c5e, Bft = function() {
    function i() {
    }
    return i.prototype.normalizeQuery = function(n2) {
      var e2 = {}, o = {}, l4 = {};
      if (xa(n2)) {
        var c4 = B_(n2);
        e2.mainType = c4.main || null, e2.subType = c4.sub || null;
      } else {
        var h = ["Index", "Name", "Id"], p4 = { name: 1, dataIndex: 1, dataType: 1 };
        Ve(n2, function(g4, y4) {
          for (var _ = false, w4 = 0; w4 < h.length; w4++) {
            var C = h[w4], E = y4.lastIndexOf(C);
            if (E > 0 && E === y4.length - C.length) {
              var T = y4.slice(0, E);
              T !== "data" && (e2.mainType = T, e2[C.toLowerCase()] = g4, _ = true);
            }
          }
          p4.hasOwnProperty(y4) && (o[y4] = g4, _ = true), _ || (l4[y4] = g4);
        });
      }
      return { cptQuery: e2, dataQuery: o, otherQuery: l4 };
    }, i.prototype.filter = function(n2, e2) {
      var o = this.eventInfo;
      if (!o)
        return true;
      var l4 = o.targetEl, c4 = o.packedEvent, h = o.model, p4 = o.view;
      if (!h || !p4)
        return true;
      var g4 = e2.cptQuery, y4 = e2.dataQuery;
      return _(g4, h, "mainType") && _(g4, h, "subType") && _(g4, h, "index", "componentIndex") && _(g4, h, "name") && _(g4, h, "id") && _(y4, c4, "name") && _(y4, c4, "dataIndex") && _(y4, c4, "dataType") && (!p4.filterForExposedEvent || p4.filterForExposedEvent(n2, e2.otherQuery, l4, c4));
      function _(w4, C, E, T) {
        return w4[E] == null || C[T || E] === w4[E];
      }
    }, i.prototype.afterTrigger = function() {
      this.eventInfo = null;
    }, i;
  }(), hoe = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], F2e = hoe.concat(["symbolKeepAspect"]), jft = { createOnAllSeries: true, performRawSeries: true, reset: function(i, n2) {
    var e2 = i.getData();
    if (i.legendIcon && e2.setVisual("legendIcon", i.legendIcon), !i.hasSymbolVisual)
      return;
    for (var o = {}, l4 = {}, c4 = false, h = 0; h < hoe.length; h++) {
      var p4 = hoe[h], g4 = i.get(p4);
      si(g4) ? (c4 = true, l4[p4] = g4) : o[p4] = g4;
    }
    if (o.symbol = o.symbol || i.defaultSymbol, e2.setVisual(rr({ legendIcon: i.legendIcon || o.symbol, symbolKeepAspect: i.get("symbolKeepAspect") }, o)), n2.isSeriesFiltered(i))
      return;
    var y4 = ts(l4);
    function _(w4, C) {
      for (var E = i.getRawValue(C), T = i.getDataParams(C), O = 0; O < y4.length; O++) {
        var N = y4[O];
        w4.setItemVisual(C, N, l4[N](E, T));
      }
    }
    return { dataEach: c4 ? _ : null };
  } }, Gft = { createOnAllSeries: true, performRawSeries: true, reset: function(i, n2) {
    if (!i.hasSymbolVisual || n2.isSeriesFiltered(i))
      return;
    var e2 = i.getData();
    function o(l4, c4) {
      for (var h = l4.getItemModel(c4), p4 = 0; p4 < F2e.length; p4++) {
        var g4 = F2e[p4], y4 = h.getShallow(g4, true);
        y4 != null && l4.setItemVisual(c4, g4, y4);
      }
    }
    return { dataEach: e2.hasItemOption ? o : null };
  } };
  function mle(i, n2, e2) {
    switch (e2) {
      case "color":
        var o = i.getItemVisual(n2, "style");
        return o[i.getVisual("drawType")];
      case "opacity":
        return i.getItemVisual(n2, "style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return i.getItemVisual(n2, e2);
    }
  }
  function $8(i, n2) {
    switch (n2) {
      case "color":
        var e2 = i.getVisual("style");
        return e2[i.getVisual("drawType")];
      case "opacity":
        return i.getVisual("style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return i.getVisual(n2);
    }
  }
  function f5e(i, n2, e2, o) {
    switch (e2) {
      case "color":
        var l4 = i.ensureUniqueItemVisual(n2, "style");
        l4[i.getVisual("drawType")] = o, i.setItemVisual(n2, "colorFromPalette", false);
        break;
      case "opacity":
        i.ensureUniqueItemVisual(n2, "style").opacity = o;
        break;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        i.setItemVisual(n2, e2, o);
        break;
    }
  }
  function h5e(i, n2) {
    function e2(o, l4) {
      var c4 = [];
      return o.eachComponent({ mainType: "series", subType: i, query: l4 }, function(h) {
        c4.push(h.seriesIndex);
      }), c4;
    }
    Ve([[i + "ToggleSelect", "toggleSelect"], [i + "Select", "select"], [i + "UnSelect", "unselect"]], function(o) {
      n2(o[0], function(l4, c4, h) {
        l4 = rr({}, l4), h.dispatchAction(rr(l4, { type: o[1], seriesIndex: e2(c4, l4) }));
      });
    });
  }
  function QP(i, n2, e2, o, l4) {
    var c4 = i + n2;
    e2.isSilent(c4) || o.eachComponent({ mainType: "series", subType: "pie" }, function(h) {
      for (var p4 = h.seriesIndex, g4 = h.option.selectedMap, y4 = l4.selected, _ = 0; _ < y4.length; _++)
        if (y4[_].seriesIndex === p4) {
          var w4 = h.getData(), C = yT(w4, l4.fromActionPayload);
          e2.trigger(c4, { type: c4, seriesId: h.id, name: Mr(C) ? w4.getName(C[0]) : w4.getName(C), selected: xa(g4) ? g4 : rr({}, g4) });
        }
    });
  }
  function Wft(i, n2, e2) {
    i.on("selectchanged", function(o) {
      var l4 = e2.getModel();
      o.isFromClick ? (QP("map", "selectchanged", n2, l4, o), QP("pie", "selectchanged", n2, l4, o)) : o.fromAction === "select" ? (QP("map", "selected", n2, l4, o), QP("pie", "selected", n2, l4, o)) : o.fromAction === "unselect" && (QP("map", "unselected", n2, l4, o), QP("pie", "unselected", n2, l4, o));
    });
  }
  function _3(i, n2, e2) {
    for (var o; i && !(n2(i) && (o = i, e2)); )
      i = i.__hostTarget || i.parent;
    return o;
  }
  var Hft = Math.round(Math.random() * 9), $ft = typeof Object.defineProperty == "function", Uft = function() {
    function i() {
      this._id = "__ec_inner_" + Hft++;
    }
    return i.prototype.get = function(n2) {
      return this._guard(n2)[this._id];
    }, i.prototype.set = function(n2, e2) {
      var o = this._guard(n2);
      return $ft ? Object.defineProperty(o, this._id, { value: e2, enumerable: false, configurable: true }) : o[this._id] = e2, this;
    }, i.prototype.delete = function(n2) {
      return this.has(n2) ? (delete this._guard(n2)[this._id], true) : false;
    }, i.prototype.has = function(n2) {
      return !!this._guard(n2)[this._id];
    }, i.prototype._guard = function(n2) {
      if (n2 !== Object(n2))
        throw TypeError("Value of WeakMap is not a non-null object.");
      return n2;
    }, i;
  }(), qft = Uft, Yft = Eo.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(i, n2) {
    var e2 = n2.cx, o = n2.cy, l4 = n2.width / 2, c4 = n2.height / 2;
    i.moveTo(e2, o - c4), i.lineTo(e2 + l4, o + c4), i.lineTo(e2 - l4, o + c4), i.closePath();
  } }), Zft = Eo.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(i, n2) {
    var e2 = n2.cx, o = n2.cy, l4 = n2.width / 2, c4 = n2.height / 2;
    i.moveTo(e2, o - c4), i.lineTo(e2 + l4, o), i.lineTo(e2, o + c4), i.lineTo(e2 - l4, o), i.closePath();
  } }), Xft = Eo.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(i, n2) {
    var e2 = n2.x, o = n2.y, l4 = n2.width / 5 * 3, c4 = Math.max(l4, n2.height), h = l4 / 2, p4 = h * h / (c4 - h), g4 = o - c4 + h + p4, y4 = Math.asin(p4 / h), _ = Math.cos(y4) * h, w4 = Math.sin(y4), C = Math.cos(y4), E = h * 0.6, T = h * 0.7;
    i.moveTo(e2 - _, g4 + p4), i.arc(e2, g4, h, Math.PI - y4, Math.PI * 2 + y4), i.bezierCurveTo(e2 + _ - w4 * E, g4 + p4 + C * E, e2, o - T, e2, o), i.bezierCurveTo(e2, o - T, e2 - _ + w4 * E, g4 + p4 + C * E, e2 - _, g4 + p4), i.closePath();
  } }), Kft = Eo.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(i, n2) {
    var e2 = n2.height, o = n2.width, l4 = n2.x, c4 = n2.y, h = o / 3 * 2;
    i.moveTo(l4, c4), i.lineTo(l4 + h, c4 + e2), i.lineTo(l4, c4 + e2 / 4 * 3), i.lineTo(l4 - h, c4 + e2), i.lineTo(l4, c4), i.closePath();
  } }), Jft = { line: Vd, rect: Is, roundRect: Is, square: Is, circle: J_, diamond: Zft, pin: Xft, arrow: Kft, triangle: Yft }, Qft = { line: function(i, n2, e2, o, l4) {
    l4.x1 = i, l4.y1 = n2 + o / 2, l4.x2 = i + e2, l4.y2 = n2 + o / 2;
  }, rect: function(i, n2, e2, o, l4) {
    l4.x = i, l4.y = n2, l4.width = e2, l4.height = o;
  }, roundRect: function(i, n2, e2, o, l4) {
    l4.x = i, l4.y = n2, l4.width = e2, l4.height = o, l4.r = Math.min(e2, o) / 4;
  }, square: function(i, n2, e2, o, l4) {
    var c4 = Math.min(e2, o);
    l4.x = i, l4.y = n2, l4.width = c4, l4.height = c4;
  }, circle: function(i, n2, e2, o, l4) {
    l4.cx = i + e2 / 2, l4.cy = n2 + o / 2, l4.r = Math.min(e2, o) / 2;
  }, diamond: function(i, n2, e2, o, l4) {
    l4.cx = i + e2 / 2, l4.cy = n2 + o / 2, l4.width = e2, l4.height = o;
  }, pin: function(i, n2, e2, o, l4) {
    l4.x = i + e2 / 2, l4.y = n2 + o / 2, l4.width = e2, l4.height = o;
  }, arrow: function(i, n2, e2, o, l4) {
    l4.x = i + e2 / 2, l4.y = n2 + o / 2, l4.width = e2, l4.height = o;
  }, triangle: function(i, n2, e2, o, l4) {
    l4.cx = i + e2 / 2, l4.cy = n2 + o / 2, l4.width = e2, l4.height = o;
  } }, RH = {};
  Ve(Jft, function(i, n2) {
    RH[n2] = new i();
  });
  var eht = Eo.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(i, n2, e2) {
    var o = SH(i, n2, e2), l4 = this.shape;
    return l4 && l4.symbolType === "pin" && n2.position === "inside" && (o.y = e2.y + e2.height * 0.4), o;
  }, buildPath: function(i, n2, e2) {
    var o = n2.symbolType;
    if (o !== "none") {
      var l4 = RH[o];
      l4 || (o = "rect", l4 = RH[o]), Qft[o](n2.x, n2.y, n2.width, n2.height, l4.shape), l4.buildPath(i, l4.shape, e2);
    }
  } });
  function tht(i, n2) {
    if (this.type !== "image") {
      var e2 = this.style;
      this.__isEmptyBrush ? (e2.stroke = i, e2.fill = n2 || "#fff", e2.lineWidth = 2) : this.shape.symbolType === "line" ? e2.stroke = i : e2.fill = i, this.markRedraw();
    }
  }
  function Xf(i, n2, e2, o, l4, c4, h) {
    var p4 = i.indexOf("empty") === 0;
    p4 && (i = i.substr(5, 1).toLowerCase() + i.substr(6));
    var g4;
    return i.indexOf("image://") === 0 ? g4 = KTe(i.slice(8), new mo(n2, e2, o, l4), h ? "center" : "cover") : i.indexOf("path://") === 0 ? g4 = T$(i.slice(7), {}, new mo(n2, e2, o, l4), h ? "center" : "cover") : g4 = new eht({ shape: { symbolType: i, x: n2, y: e2, width: o, height: l4 } }), g4.__isEmptyBrush = p4, g4.setColor = tht, c4 && g4.setColor(c4), g4;
  }
  function U8(i) {
    return Mr(i) || (i = [+i, +i]), [i[0] || 0, i[1] || 0];
  }
  function nL(i, n2) {
    if (i != null)
      return Mr(i) || (i = [i, i]), [ma(i[0], n2[0]) || 0, ma(so(i[1], i[0]), n2[1]) || 0];
  }
  function nht(i, n2, e2) {
    var o = n2.x == null ? 0 : n2.x, l4 = n2.x2 == null ? 1 : n2.x2, c4 = n2.y == null ? 0 : n2.y, h = n2.y2 == null ? 0 : n2.y2;
    n2.global || (o = o * e2.width + e2.x, l4 = l4 * e2.width + e2.x, c4 = c4 * e2.height + e2.y, h = h * e2.height + e2.y), o = isNaN(o) ? 0 : o, l4 = isNaN(l4) ? 1 : l4, c4 = isNaN(c4) ? 0 : c4, h = isNaN(h) ? 0 : h;
    var p4 = i.createLinearGradient(o, c4, l4, h);
    return p4;
  }
  function rht(i, n2, e2) {
    var o = e2.width, l4 = e2.height, c4 = Math.min(o, l4), h = n2.x == null ? 0.5 : n2.x, p4 = n2.y == null ? 0.5 : n2.y, g4 = n2.r == null ? 0.5 : n2.r;
    n2.global || (h = h * o + e2.x, p4 = p4 * l4 + e2.y, g4 = g4 * c4);
    var y4 = i.createRadialGradient(h, p4, 0, h, p4, g4);
    return y4;
  }
  function doe(i, n2, e2) {
    for (var o = n2.type === "radial" ? rht(i, n2, e2) : nht(i, n2, e2), l4 = n2.colorStops, c4 = 0; c4 < l4.length; c4++)
      o.addColorStop(l4[c4].offset, l4[c4].color);
    return o;
  }
  function aht(i, n2) {
    if (i === n2 || !i && !n2)
      return false;
    if (!i || !n2 || i.length !== n2.length)
      return true;
    for (var e2 = 0; e2 < i.length; e2++)
      if (i[e2] !== n2[e2])
        return true;
    return false;
  }
  function uW(i) {
    return parseInt(i, 10);
  }
  function x3(i, n2, e2) {
    var o = ["width", "height"][n2], l4 = ["clientWidth", "clientHeight"][n2], c4 = ["paddingLeft", "paddingTop"][n2], h = ["paddingRight", "paddingBottom"][n2];
    if (e2[o] != null && e2[o] !== "auto")
      return parseFloat(e2[o]);
    var p4 = document.defaultView.getComputedStyle(i);
    return (i[l4] || uW(p4[o]) || uW(i.style[o])) - (uW(p4[c4]) || 0) - (uW(p4[h]) || 0) | 0;
  }
  function iht(i, n2) {
    return !i || i === "solid" || !(n2 > 0) ? null : i === "dashed" ? [4 * n2, 2 * n2] : i === "dotted" ? [n2] : sl(i) ? [i] : Mr(i) ? i : null;
  }
  function yle(i) {
    var n2 = i.style, e2 = n2.lineDash && n2.lineWidth > 0 && iht(n2.lineDash, n2.lineWidth), o = n2.lineDashOffset;
    if (e2) {
      var l4 = n2.strokeNoScale && i.getLineScale ? i.getLineScale() : 1;
      l4 && l4 !== 1 && (e2 = Er(e2, function(c4) {
        return c4 / l4;
      }), o /= l4);
    }
    return [e2, o];
  }
  var oht = new K_(true);
  function FH(i) {
    var n2 = i.stroke;
    return !(n2 == null || n2 === "none" || !(i.lineWidth > 0));
  }
  function N2e(i) {
    return typeof i == "string" && i !== "none";
  }
  function NH(i) {
    var n2 = i.fill;
    return n2 != null && n2 !== "none";
  }
  function V2e(i, n2) {
    if (n2.fillOpacity != null && n2.fillOpacity !== 1) {
      var e2 = i.globalAlpha;
      i.globalAlpha = n2.fillOpacity * n2.opacity, i.fill(), i.globalAlpha = e2;
    } else
      i.fill();
  }
  function z2e(i, n2) {
    if (n2.strokeOpacity != null && n2.strokeOpacity !== 1) {
      var e2 = i.globalAlpha;
      i.globalAlpha = n2.strokeOpacity * n2.opacity, i.stroke(), i.globalAlpha = e2;
    } else
      i.stroke();
  }
  function poe(i, n2, e2) {
    var o = Wse(n2.image, n2.__image, e2);
    if (w$(o)) {
      var l4 = i.createPattern(o, n2.repeat || "repeat");
      if (typeof DOMMatrix == "function" && l4 && l4.setTransform) {
        var c4 = new DOMMatrix();
        c4.translateSelf(n2.x || 0, n2.y || 0), c4.rotateSelf(0, 0, (n2.rotation || 0) * YW), c4.scaleSelf(n2.scaleX || 1, n2.scaleY || 1), l4.setTransform(c4);
      }
      return l4;
    }
  }
  function sht(i, n2, e2, o) {
    var l4, c4 = FH(e2), h = NH(e2), p4 = e2.strokePercent, g4 = p4 < 1, y4 = !n2.path;
    (!n2.silent || g4) && y4 && n2.createPathProxy();
    var _ = n2.path || oht, w4 = n2.__dirty;
    if (!o) {
      var C = e2.fill, E = e2.stroke, T = h && !!C.colorStops, O = c4 && !!E.colorStops, N = h && !!C.image, V = c4 && !!E.image, H = void 0, X = void 0, q2 = void 0, de = void 0, le = void 0;
      (T || O) && (le = n2.getBoundingRect()), T && (H = w4 ? doe(i, C, le) : n2.__canvasFillGradient, n2.__canvasFillGradient = H), O && (X = w4 ? doe(i, E, le) : n2.__canvasStrokeGradient, n2.__canvasStrokeGradient = X), N && (q2 = w4 || !n2.__canvasFillPattern ? poe(i, C, n2) : n2.__canvasFillPattern, n2.__canvasFillPattern = q2), V && (de = w4 || !n2.__canvasStrokePattern ? poe(i, E, n2) : n2.__canvasStrokePattern, n2.__canvasStrokePattern = q2), T ? i.fillStyle = H : N && (q2 ? i.fillStyle = q2 : h = false), O ? i.strokeStyle = X : V && (de ? i.strokeStyle = de : c4 = false);
    }
    var me = n2.getGlobalScale();
    _.setScale(me[0], me[1], n2.segmentIgnoreThreshold);
    var ye, be;
    i.setLineDash && e2.lineDash && (l4 = yle(n2), ye = l4[0], be = l4[1]);
    var we = true;
    (y4 || w4 & h3) && (_.setDPR(i.dpr), g4 ? _.setContext(null) : (_.setContext(i), we = false), _.reset(), n2.buildPath(_, n2.shape, o), _.toStatic(), n2.pathUpdated()), we && _.rebuildPath(i, g4 ? p4 : 1), ye && (i.setLineDash(ye), i.lineDashOffset = be), o || (e2.strokeFirst ? (c4 && z2e(i, e2), h && V2e(i, e2)) : (h && V2e(i, e2), c4 && z2e(i, e2))), ye && i.setLineDash([]);
  }
  function lht(i, n2, e2) {
    var o = n2.__image = Wse(e2.image, n2.__image, n2, n2.onload);
    if (!(!o || !w$(o))) {
      var l4 = e2.x || 0, c4 = e2.y || 0, h = n2.getWidth(), p4 = n2.getHeight(), g4 = o.width / o.height;
      if (h == null && p4 != null ? h = p4 * g4 : p4 == null && h != null ? p4 = h / g4 : h == null && p4 == null && (h = o.width, p4 = o.height), e2.sWidth && e2.sHeight) {
        var y4 = e2.sx || 0, _ = e2.sy || 0;
        i.drawImage(o, y4, _, e2.sWidth, e2.sHeight, l4, c4, h, p4);
      } else if (e2.sx && e2.sy) {
        var y4 = e2.sx, _ = e2.sy, w4 = h - y4, C = p4 - _;
        i.drawImage(o, y4, _, w4, C, l4, c4, h, p4);
      } else
        i.drawImage(o, l4, c4, h, p4);
    }
  }
  function uht(i, n2, e2) {
    var o, l4 = e2.text;
    if (l4 != null && (l4 += ""), l4) {
      i.font = e2.font || XC, i.textAlign = e2.textAlign, i.textBaseline = e2.textBaseline;
      var c4 = void 0, h = void 0;
      i.setLineDash && e2.lineDash && (o = yle(n2), c4 = o[0], h = o[1]), c4 && (i.setLineDash(c4), i.lineDashOffset = h), e2.strokeFirst ? (FH(e2) && i.strokeText(l4, e2.x, e2.y), NH(e2) && i.fillText(l4, e2.x, e2.y)) : (NH(e2) && i.fillText(l4, e2.x, e2.y), FH(e2) && i.strokeText(l4, e2.x, e2.y)), c4 && i.setLineDash([]);
    }
  }
  var B2e = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], j2e = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
  function d5e(i, n2, e2, o, l4) {
    var c4 = false;
    if (!o && (e2 = e2 || {}, n2 === e2))
      return false;
    if (o || n2.opacity !== e2.opacity) {
      Wg(i, l4), c4 = true;
      var h = Math.max(Math.min(n2.opacity, 1), 0);
      i.globalAlpha = isNaN(h) ? uT.opacity : h;
    }
    (o || n2.blend !== e2.blend) && (c4 || (Wg(i, l4), c4 = true), i.globalCompositeOperation = n2.blend || uT.blend);
    for (var p4 = 0; p4 < B2e.length; p4++) {
      var g4 = B2e[p4];
      (o || n2[g4] !== e2[g4]) && (c4 || (Wg(i, l4), c4 = true), i[g4] = i.dpr * (n2[g4] || 0));
    }
    return (o || n2.shadowColor !== e2.shadowColor) && (c4 || (Wg(i, l4), c4 = true), i.shadowColor = n2.shadowColor || uT.shadowColor), c4;
  }
  function G2e(i, n2, e2, o, l4) {
    var c4 = b8(n2, l4.inHover), h = o ? null : e2 && b8(e2, l4.inHover) || {};
    if (c4 === h)
      return false;
    var p4 = d5e(i, c4, h, o, l4);
    if ((o || c4.fill !== h.fill) && (p4 || (Wg(i, l4), p4 = true), N2e(c4.fill) && (i.fillStyle = c4.fill)), (o || c4.stroke !== h.stroke) && (p4 || (Wg(i, l4), p4 = true), N2e(c4.stroke) && (i.strokeStyle = c4.stroke)), (o || c4.opacity !== h.opacity) && (p4 || (Wg(i, l4), p4 = true), i.globalAlpha = c4.opacity == null ? 1 : c4.opacity), n2.hasStroke()) {
      var g4 = c4.lineWidth, y4 = g4 / (c4.strokeNoScale && n2.getLineScale ? n2.getLineScale() : 1);
      i.lineWidth !== y4 && (p4 || (Wg(i, l4), p4 = true), i.lineWidth = y4);
    }
    for (var _ = 0; _ < j2e.length; _++) {
      var w4 = j2e[_], C = w4[0];
      (o || c4[C] !== h[C]) && (p4 || (Wg(i, l4), p4 = true), i[C] = c4[C] || w4[1]);
    }
    return p4;
  }
  function cht(i, n2, e2, o, l4) {
    return d5e(i, b8(n2, l4.inHover), e2 && b8(e2, l4.inHover), o, l4);
  }
  function p5e(i, n2) {
    var e2 = n2.transform, o = i.dpr || 1;
    e2 ? i.setTransform(o * e2[0], o * e2[1], o * e2[2], o * e2[3], o * e2[4], o * e2[5]) : i.setTransform(o, 0, 0, o, 0, 0);
  }
  function fht(i, n2, e2) {
    for (var o = false, l4 = 0; l4 < i.length; l4++) {
      var c4 = i[l4];
      o = o || c4.isZeroArea(), p5e(n2, c4), n2.beginPath(), c4.buildPath(n2, c4.shape), n2.clip();
    }
    e2.allClipped = o;
  }
  function hht(i, n2) {
    return i && n2 ? i[0] !== n2[0] || i[1] !== n2[1] || i[2] !== n2[2] || i[3] !== n2[3] || i[4] !== n2[4] || i[5] !== n2[5] : !(!i && !n2);
  }
  var W2e = 1, H2e = 2, $2e = 3, U2e = 4;
  function dht(i) {
    var n2 = NH(i), e2 = FH(i);
    return !(i.lineDash || !(+n2 ^ +e2) || n2 && typeof i.fill != "string" || e2 && typeof i.stroke != "string" || i.strokePercent < 1 || i.strokeOpacity < 1 || i.fillOpacity < 1);
  }
  function Wg(i, n2) {
    n2.batchFill && i.fill(), n2.batchStroke && i.stroke(), n2.batchFill = "", n2.batchStroke = "";
  }
  function b8(i, n2) {
    return n2 && i.__hoverStyle || i.style;
  }
  function v5e(i, n2) {
    oT(i, n2, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
  }
  function oT(i, n2, e2, o) {
    var l4 = n2.transform;
    if (!n2.shouldBePainted(e2.viewWidth, e2.viewHeight, false, false)) {
      n2.__dirty &= ~em, n2.__isRendered = false;
      return;
    }
    var c4 = n2.__clipPaths, h = e2.prevElClipPaths, p4 = false, g4 = false;
    if ((!h || aht(c4, h)) && (h && h.length && (Wg(i, e2), i.restore(), g4 = p4 = true, e2.prevElClipPaths = null, e2.allClipped = false, e2.prevEl = null), c4 && c4.length && (Wg(i, e2), i.save(), fht(c4, i, e2), p4 = true), e2.prevElClipPaths = c4), e2.allClipped) {
      n2.__isRendered = false;
      return;
    }
    n2.beforeBrush && n2.beforeBrush(), n2.innerBeforeBrush();
    var y4 = e2.prevEl;
    y4 || (g4 = p4 = true);
    var _ = n2 instanceof Eo && n2.autoBatch && dht(n2.style);
    p4 || hht(l4, y4.transform) ? (Wg(i, e2), p5e(i, n2)) : _ || Wg(i, e2);
    var w4 = b8(n2, e2.inHover);
    n2 instanceof Eo ? (e2.lastDrawType !== W2e && (g4 = true, e2.lastDrawType = W2e), G2e(i, n2, y4, g4, e2), (!_ || !e2.batchFill && !e2.batchStroke) && i.beginPath(), sht(i, n2, w4, _), _ && (e2.batchFill = w4.fill || "", e2.batchStroke = w4.stroke || "")) : n2 instanceof u8 ? (e2.lastDrawType !== $2e && (g4 = true, e2.lastDrawType = $2e), G2e(i, n2, y4, g4, e2), uht(i, n2, w4)) : n2 instanceof Ap ? (e2.lastDrawType !== H2e && (g4 = true, e2.lastDrawType = H2e), cht(i, n2, y4, g4, e2), lht(i, n2, w4)) : n2.getTemporalDisplayables && (e2.lastDrawType !== U2e && (g4 = true, e2.lastDrawType = U2e), pht(i, n2, e2)), _ && o && Wg(i, e2), n2.innerAfterBrush(), n2.afterBrush && n2.afterBrush(), e2.prevEl = n2, n2.__dirty = 0, n2.__isRendered = true;
  }
  function pht(i, n2, e2) {
    var o = n2.getDisplayables(), l4 = n2.getTemporalDisplayables();
    i.save();
    var c4 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: e2.viewWidth, viewHeight: e2.viewHeight, inHover: e2.inHover }, h, p4;
    for (h = n2.getCursor(), p4 = o.length; h < p4; h++) {
      var g4 = o[h];
      g4.beforeBrush && g4.beforeBrush(), g4.innerBeforeBrush(), oT(i, g4, c4, h === p4 - 1), g4.innerAfterBrush(), g4.afterBrush && g4.afterBrush(), c4.prevEl = g4;
    }
    for (var y4 = 0, _ = l4.length; y4 < _; y4++) {
      var g4 = l4[y4];
      g4.beforeBrush && g4.beforeBrush(), g4.innerBeforeBrush(), oT(i, g4, c4, y4 === _ - 1), g4.innerAfterBrush(), g4.afterBrush && g4.afterBrush(), c4.prevEl = g4;
    }
    n2.clearTemporalDisplayables(), n2.notClear = true, i.restore();
  }
  var Fre = new qft(), q2e = new F8(100), Y2e = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
  function _8(i, n2) {
    if (i === "none")
      return null;
    var e2 = n2.getDevicePixelRatio(), o = n2.getZr(), l4 = o.painter.type === "svg";
    i.dirty && Fre.delete(i);
    var c4 = Fre.get(i);
    if (c4)
      return c4;
    var h = hi(i, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
    h.backgroundColor === "none" && (h.backgroundColor = null);
    var p4 = { repeat: "repeat" };
    return g4(p4), p4.rotation = h.rotation, p4.scaleX = p4.scaleY = l4 ? 1 : 1 / e2, Fre.set(i, p4), i.dirty = false, p4;
    function g4(y4) {
      for (var _ = [e2], w4 = true, C = 0; C < Y2e.length; ++C) {
        var E = h[Y2e[C]];
        if (E != null && !Mr(E) && !xa(E) && !sl(E) && typeof E != "boolean") {
          w4 = false;
          break;
        }
        _.push(E);
      }
      var T;
      if (w4) {
        T = _.join(",") + (l4 ? "-svg" : "");
        var O = q2e.get(T);
        O && (l4 ? y4.svgElement = O : y4.image = O);
      }
      var N = m5e(h.dashArrayX), V = vht(h.dashArrayY), H = g5e(h.symbol), X = ght(N), q2 = y5e(V), de = !l4 && y2.createCanvas(), le = l4 && { tag: "g", attrs: {}, key: "dcl", children: [] }, me = be(), ye;
      de && (de.width = me.width * e2, de.height = me.height * e2, ye = de.getContext("2d")), we(), w4 && q2e.put(T, de || le), y4.image = de, y4.svgElement = le, y4.svgWidth = me.width, y4.svgHeight = me.height;
      function be() {
        for (var Pe = 1, ze = 0, Re = X.length; ze < Re; ++ze)
          Pe = uwe(Pe, X[ze]);
        for (var rt2 = 1, ze = 0, Re = H.length; ze < Re; ++ze)
          rt2 = uwe(rt2, H[ze].length);
        Pe *= rt2;
        var ft = q2 * X.length * H.length;
        return { width: Math.max(1, Math.min(Pe, h.maxTileWidth)), height: Math.max(1, Math.min(ft, h.maxTileHeight)) };
      }
      function we() {
        ye && (ye.clearRect(0, 0, de.width, de.height), h.backgroundColor && (ye.fillStyle = h.backgroundColor, ye.fillRect(0, 0, de.width, de.height)));
        for (var Pe = 0, ze = 0; ze < V.length; ++ze)
          Pe += V[ze];
        if (Pe <= 0)
          return;
        for (var Re = -q2, rt2 = 0, ft = 0, et = 0; Re < me.height; ) {
          if (rt2 % 2 === 0) {
            for (var Jt = ft / 2 % H.length, xt = 0, It = 0, Wt = 0; xt < me.width * 2; ) {
              for (var sn = 0, ze = 0; ze < N[et].length; ++ze)
                sn += N[et][ze];
              if (sn <= 0)
                break;
              if (It % 2 === 0) {
                var vn = (1 - h.symbolSize) * 0.5, $r = xt + N[et][It] * vn, ga = Re + V[rt2] * vn, Za = N[et][It] * h.symbolSize, $a = V[rt2] * h.symbolSize, Pa = Wt / 2 % H[Jt].length;
                da($r, ga, Za, $a, H[Jt][Pa]);
              }
              xt += N[et][It], ++Wt, ++It, It === N[et].length && (It = 0);
            }
            ++et, et === N.length && (et = 0);
          }
          Re += V[rt2], ++ft, ++rt2, rt2 === V.length && (rt2 = 0);
        }
        function da(Ra, Wa, wa, li, Ts) {
          var wi = l4 ? 1 : e2, ps = Xf(Ts, Ra * wi, Wa * wi, wa * wi, li * wi, h.color, h.symbolKeepAspect);
          if (l4) {
            var Bs = o.painter.renderOneToVNode(ps);
            Bs && le.children.push(Bs);
          } else
            v5e(ye, ps);
        }
      }
    }
  }
  function g5e(i) {
    if (!i || i.length === 0)
      return [["rect"]];
    if (xa(i))
      return [[i]];
    for (var n2 = true, e2 = 0; e2 < i.length; ++e2)
      if (!xa(i[e2])) {
        n2 = false;
        break;
      }
    if (n2)
      return g5e([i]);
    for (var o = [], e2 = 0; e2 < i.length; ++e2)
      xa(i[e2]) ? o.push([i[e2]]) : o.push(i[e2]);
    return o;
  }
  function m5e(i) {
    if (!i || i.length === 0)
      return [[0, 0]];
    if (sl(i)) {
      var n2 = Math.ceil(i);
      return [[n2, n2]];
    }
    for (var e2 = true, o = 0; o < i.length; ++o)
      if (!sl(i[o])) {
        e2 = false;
        break;
      }
    if (e2)
      return m5e([i]);
    for (var l4 = [], o = 0; o < i.length; ++o)
      if (sl(i[o])) {
        var n2 = Math.ceil(i[o]);
        l4.push([n2, n2]);
      } else {
        var n2 = Er(i[o], function(p4) {
          return Math.ceil(p4);
        });
        n2.length % 2 === 1 ? l4.push(n2.concat(n2)) : l4.push(n2);
      }
    return l4;
  }
  function vht(i) {
    if (!i || typeof i == "object" && i.length === 0)
      return [0, 0];
    if (sl(i)) {
      var n2 = Math.ceil(i);
      return [n2, n2];
    }
    var e2 = Er(i, function(o) {
      return Math.ceil(o);
    });
    return i.length % 2 ? e2.concat(e2) : e2;
  }
  function ght(i) {
    return Er(i, function(n2) {
      return y5e(n2);
    });
  }
  function y5e(i) {
    for (var n2 = 0, e2 = 0; e2 < i.length; ++e2)
      n2 += i[e2];
    return i.length % 2 === 1 ? n2 * 2 : n2;
  }
  function mht(i, n2) {
    i.eachRawSeries(function(e2) {
      if (!i.isSeriesFiltered(e2)) {
        var o = e2.getData();
        o.hasItemVisual() && o.each(function(h) {
          var p4 = o.getItemVisual(h, "decal");
          if (p4) {
            var g4 = o.ensureUniqueItemVisual(h, "style");
            g4.decal = _8(p4, n2);
          }
        });
        var l4 = o.getVisual("decal");
        if (l4) {
          var c4 = o.getVisual("style");
          c4.decal = _8(l4, n2);
        }
      }
    });
  }
  var yht = new zy(), Q1 = yht, b5e = {};
  function bht(i, n2) {
    b5e[i] = n2;
  }
  function _ht(i) {
    return b5e[i];
  }
  var xht = typeof window != "undefined", wht = 1, Sht = 800, Cht = 900, Mht = 1e3, Aht = 2e3, Eht = 5e3, _5e = 1e3, Iht = 1100, ble = 2e3, x5e = 3e3, Tht = 4e3, j$ = 4500, Dht = 4600, kht = 5e3, Pht = 6e3, w5e = 7e3, Lht = { PROCESSOR: { FILTER: Mht, SERIES_FILTER: Sht, STATISTIC: Eht }, VISUAL: { LAYOUT: _5e, PROGRESSIVE_LAYOUT: Iht, GLOBAL: ble, CHART: x5e, POST_CHART_LAYOUT: Dht, COMPONENT: Tht, BRUSH: kht, CHART_ITEM: j$, ARIA: Pht, DECAL: w5e } }, hv = "__flagInMainProcess", Bg = "__pendingUpdate", Nre = "__needsUpdateStatus", Z2e = /^[a-zA-Z0-9_]+$/, Vre = "__connectUpdateStatus", X2e = 0, Oht = 1, Rht = 2;
  function S5e(i) {
    return function() {
      for (var n2 = [], e2 = 0; e2 < arguments.length; e2++)
        n2[e2] = arguments[e2];
      if (this.isDisposed()) {
        this.id;
        return;
      }
      return M5e(this, i, n2);
    };
  }
  function C5e(i) {
    return function() {
      for (var n2 = [], e2 = 0; e2 < arguments.length; e2++)
        n2[e2] = arguments[e2];
      return M5e(this, i, n2);
    };
  }
  function M5e(i, n2, e2) {
    return e2[0] = e2[0] && e2[0].toLowerCase(), zy.prototype[n2].apply(i, e2);
  }
  var A5e = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2;
  }(zy), E5e = A5e.prototype;
  E5e.on = C5e("on");
  E5e.off = C5e("off");
  var e3, zre, cW, AC, Bre, jre, Gre, oN, sN, K2e, J2e, Wre, Q2e, fW, eSe, I5e, my, tSe, T5e = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this, new Bft()) || this;
      c4._chartsViews = [], c4._chartsMap = {}, c4._componentsViews = [], c4._componentsMap = {}, c4._pendingActions = [], l4 = l4 || {}, xa(o) && (o = D5e[o]), c4._dom = e2;
      var h = "canvas", p4 = false, g4 = c4._zr = iwe(e2, { renderer: l4.renderer || h, devicePixelRatio: l4.devicePixelRatio, width: l4.width, height: l4.height, ssr: l4.ssr, useDirtyRect: l4.useDirtyRect == null ? p4 : l4.useDirtyRect });
      c4._ssr = l4.ssr, c4._throttledZrFlush = gle(Ia(g4.flush, g4), 17), o = Ci(o), o && RDe(o, true), c4._theme = o, c4._locale = $ut(l4.locale || lDe), c4._coordSysMgr = new H8();
      var y4 = c4._api = eSe(c4);
      function _(w4, C) {
        return w4.__prio - C.__prio;
      }
      return XW(zH, _), XW(voe, _), c4._scheduler = new u5e(c4, y4, voe, zH), c4._messageCenter = new A5e(), c4._initEvents(), c4.resize = Ia(c4.resize, c4), g4.animation.on("frame", c4._onframe, c4), K2e(g4, c4), J2e(g4, c4), gH(c4), c4;
    }
    return n2.prototype._onframe = function() {
      if (!this._disposed) {
        tSe(this);
        var e2 = this._scheduler;
        if (this[Bg]) {
          var o = this[Bg].silent;
          this[hv] = true;
          try {
            e3(this), AC.update.call(this, null, this[Bg].updateParams);
          } catch (g4) {
            throw this[hv] = false, this[Bg] = null, g4;
          }
          this._zr.flush(), this[hv] = false, this[Bg] = null, oN.call(this, o), sN.call(this, o);
        } else if (e2.unfinished) {
          var l4 = wht, c4 = this._model, h = this._api;
          e2.unfinished = false;
          do {
            var p4 = +new Date();
            e2.performSeriesTasks(c4), e2.performDataProcessorTasks(c4), jre(this, c4), e2.performVisualTasks(c4), fW(this, this._model, h, "remain", {}), l4 -= +new Date() - p4;
          } while (l4 > 0 && e2.unfinished);
          e2.unfinished || this._zr.flush();
        }
      }
    }, n2.prototype.getDom = function() {
      return this._dom;
    }, n2.prototype.getId = function() {
      return this.id;
    }, n2.prototype.getZr = function() {
      return this._zr;
    }, n2.prototype.isSSR = function() {
      return this._ssr;
    }, n2.prototype.setOption = function(e2, o, l4) {
      if (!this[hv]) {
        if (this._disposed) {
          this.id;
          return;
        }
        var c4, h, p4;
        if (mi(o) && (l4 = o.lazyUpdate, c4 = o.silent, h = o.replaceMerge, p4 = o.transition, o = o.notMerge), this[hv] = true, !this._model || o) {
          var g4 = new Mct(this._api), y4 = this._theme, _ = this._model = new PDe();
          _.scheduler = this._scheduler, _.ssr = this._ssr, _.init(null, null, null, y4, this._locale, g4);
        }
        this._model.setOption(e2, { replaceMerge: h }, goe);
        var w4 = { seriesTransition: p4, optionChanged: true };
        if (l4)
          this[Bg] = { silent: c4, updateParams: w4 }, this[hv] = false, this.getZr().wakeUp();
        else {
          try {
            e3(this), AC.update.call(this, null, w4);
          } catch (C) {
            throw this[Bg] = null, this[hv] = false, C;
          }
          this._ssr || this._zr.flush(), this[Bg] = null, this[hv] = false, oN.call(this, c4), sN.call(this, c4);
        }
      }
    }, n2.prototype.setTheme = function() {
    }, n2.prototype.getModel = function() {
      return this._model;
    }, n2.prototype.getOption = function() {
      return this._model && this._model.getOption();
    }, n2.prototype.getWidth = function() {
      return this._zr.getWidth();
    }, n2.prototype.getHeight = function() {
      return this._zr.getHeight();
    }, n2.prototype.getDevicePixelRatio = function() {
      return this._zr.painter.dpr || xht && window.devicePixelRatio || 1;
    }, n2.prototype.getRenderedCanvas = function(e2) {
      return this.renderToCanvas(e2);
    }, n2.prototype.renderToCanvas = function(e2) {
      e2 = e2 || {};
      var o = this._zr.painter;
      return o.getRenderedCanvas({ backgroundColor: e2.backgroundColor || this._model.get("backgroundColor"), pixelRatio: e2.pixelRatio || this.getDevicePixelRatio() });
    }, n2.prototype.renderToSVGString = function(e2) {
      e2 = e2 || {};
      var o = this._zr.painter;
      return o.renderToString({ useViewBox: e2.useViewBox });
    }, n2.prototype.getSvgDataURL = function() {
      if (!!ol.svgSupported) {
        var e2 = this._zr, o = e2.storage.getDisplayList();
        return Ve(o, function(l4) {
          l4.stopAnimation(null, true);
        }), e2.painter.toDataURL();
      }
    }, n2.prototype.getDataURL = function(e2) {
      if (this._disposed) {
        this.id;
        return;
      }
      e2 = e2 || {};
      var o = e2.excludeComponents, l4 = this._model, c4 = [], h = this;
      Ve(o, function(g4) {
        l4.eachComponent({ mainType: g4 }, function(y4) {
          var _ = h._componentsMap[y4.__viewId];
          _.group.ignore || (c4.push(_), _.group.ignore = true);
        });
      });
      var p4 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(e2).toDataURL("image/" + (e2 && e2.type || "png"));
      return Ve(c4, function(g4) {
        g4.group.ignore = false;
      }), p4;
    }, n2.prototype.getConnectedDataURL = function(e2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var o = e2.type === "svg", l4 = this.group, c4 = Math.min, h = Math.max, p4 = 1 / 0;
      if (nSe[l4]) {
        var g4 = p4, y4 = p4, _ = -p4, w4 = -p4, C = [], E = e2 && e2.pixelRatio || this.getDevicePixelRatio();
        Ve(XN, function(X, q2) {
          if (X.group === l4) {
            var de = o ? X.getZr().painter.getSvgDom().innerHTML : X.renderToCanvas(Ci(e2)), le = X.getDom().getBoundingClientRect();
            g4 = c4(le.left, g4), y4 = c4(le.top, y4), _ = h(le.right, _), w4 = h(le.bottom, w4), C.push({ dom: de, left: le.left, top: le.top });
          }
        }), g4 *= E, y4 *= E, _ *= E, w4 *= E;
        var T = _ - g4, O = w4 - y4, N = y2.createCanvas(), V = iwe(N, { renderer: o ? "svg" : "canvas" });
        if (V.resize({ width: T, height: O }), o) {
          var H = "";
          return Ve(C, function(X) {
            var q2 = X.left - g4, de = X.top - y4;
            H += '<g transform="translate(' + q2 + "," + de + ')">' + X.dom + "</g>";
          }), V.painter.getSvgRoot().innerHTML = H, e2.connectedBackgroundColor && V.painter.setBackgroundColor(e2.connectedBackgroundColor), V.refreshImmediately(), V.painter.toDataURL();
        } else
          return e2.connectedBackgroundColor && V.add(new Is({ shape: { x: 0, y: 0, width: T, height: O }, style: { fill: e2.connectedBackgroundColor } })), Ve(C, function(X) {
            var q2 = new Ap({ style: { x: X.left * E - g4, y: X.top * E - y4, image: X.dom } });
            V.add(q2);
          }), V.refreshImmediately(), N.toDataURL("image/" + (e2 && e2.type || "png"));
      } else
        return this.getDataURL(e2);
    }, n2.prototype.convertToPixel = function(e2, o) {
      return Bre(this, "convertToPixel", e2, o);
    }, n2.prototype.convertFromPixel = function(e2, o) {
      return Bre(this, "convertFromPixel", e2, o);
    }, n2.prototype.containPixel = function(e2, o) {
      if (this._disposed) {
        this.id;
        return;
      }
      var l4 = this._model, c4, h = WN(l4, e2);
      return Ve(h, function(p4, g4) {
        g4.indexOf("Models") >= 0 && Ve(p4, function(y4) {
          var _ = y4.coordinateSystem;
          if (_ && _.containPoint)
            c4 = c4 || !!_.containPoint(o);
          else if (g4 === "seriesModels") {
            var w4 = this._chartsMap[y4.__viewId];
            w4 && w4.containPoint && (c4 = c4 || w4.containPoint(o, y4));
          }
        }, this);
      }, this), !!c4;
    }, n2.prototype.getVisual = function(e2, o) {
      var l4 = this._model, c4 = WN(l4, e2, { defaultMainType: "series" }), h = c4.seriesModel, p4 = h.getData(), g4 = c4.hasOwnProperty("dataIndexInside") ? c4.dataIndexInside : c4.hasOwnProperty("dataIndex") ? p4.indexOfRawIndex(c4.dataIndex) : null;
      return g4 != null ? mle(p4, g4, o) : $8(p4, o);
    }, n2.prototype.getViewOfComponentModel = function(e2) {
      return this._componentsMap[e2.__viewId];
    }, n2.prototype.getViewOfSeriesModel = function(e2) {
      return this._chartsMap[e2.__viewId];
    }, n2.prototype._initEvents = function() {
      var e2 = this;
      Ve(Fht, function(o) {
        var l4 = function(c4) {
          var h = e2.getModel(), p4 = c4.target, g4, y4 = o === "globalout";
          if (y4 ? g4 = {} : p4 && _3(p4, function(T) {
            var O = Fi(T);
            if (O && O.dataIndex != null) {
              var N = O.dataModel || h.getSeriesByIndex(O.seriesIndex);
              return g4 = N && N.getDataParams(O.dataIndex, O.dataType) || {}, true;
            } else if (O.eventData)
              return g4 = rr({}, O.eventData), true;
          }, true), g4) {
            var _ = g4.componentType, w4 = g4.componentIndex;
            (_ === "markLine" || _ === "markPoint" || _ === "markArea") && (_ = "series", w4 = g4.seriesIndex);
            var C = _ && w4 != null && h.getComponent(_, w4), E = C && e2[C.mainType === "series" ? "_chartsMap" : "_componentsMap"][C.__viewId];
            g4.event = c4, g4.type = o, e2._$eventProcessor.eventInfo = { targetEl: p4, packedEvent: g4, model: C, view: E }, e2.trigger(o, g4);
          }
        };
        l4.zrEventfulCallAtLast = true, e2._zr.on(o, l4, e2);
      }), Ve(ZN, function(o, l4) {
        e2._messageCenter.on(l4, function(c4) {
          this.trigger(l4, c4);
        }, e2);
      }), Ve(["selectchanged"], function(o) {
        e2._messageCenter.on(o, function(l4) {
          this.trigger(o, l4);
        }, e2);
      }), Wft(this._messageCenter, this, this._api);
    }, n2.prototype.isDisposed = function() {
      return this._disposed;
    }, n2.prototype.clear = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this.setOption({ series: [] }, true);
    }, n2.prototype.dispose = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._disposed = true;
      var e2 = this.getDom();
      e2 && iTe(this.getDom(), xle, "");
      var o = this, l4 = o._api, c4 = o._model;
      Ve(o._componentsViews, function(h) {
        h.dispose(c4, l4);
      }), Ve(o._chartsViews, function(h) {
        h.dispose(c4, l4);
      }), o._zr.dispose(), o._dom = o._model = o._chartsMap = o._componentsMap = o._chartsViews = o._componentsViews = o._scheduler = o._api = o._zr = o._throttledZrFlush = o._theme = o._coordSysMgr = o._messageCenter = null, delete XN[o.id];
    }, n2.prototype.resize = function(e2) {
      if (!this[hv]) {
        if (this._disposed) {
          this.id;
          return;
        }
        this._zr.resize(e2);
        var o = this._model;
        if (this._loadingFX && this._loadingFX.resize(), !!o) {
          var l4 = o.resetOption("media"), c4 = e2 && e2.silent;
          this[Bg] && (c4 == null && (c4 = this[Bg].silent), l4 = true, this[Bg] = null), this[hv] = true;
          try {
            l4 && e3(this), AC.update.call(this, { type: "resize", animation: rr({ duration: 0 }, e2 && e2.animation) });
          } catch (h) {
            throw this[hv] = false, h;
          }
          this[hv] = false, oN.call(this, c4), sN.call(this, c4);
        }
      }
    }, n2.prototype.showLoading = function(e2, o) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (mi(e2) && (o = e2, e2 = ""), e2 = e2 || "default", this.hideLoading(), !!moe[e2]) {
        var l4 = moe[e2](this._api, o), c4 = this._zr;
        this._loadingFX = l4, c4.add(l4);
      }
    }, n2.prototype.hideLoading = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
    }, n2.prototype.makeActionFromEvent = function(e2) {
      var o = rr({}, e2);
      return o.type = ZN[e2.type], o;
    }, n2.prototype.dispatchAction = function(e2, o) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (mi(o) || (o = { silent: !!o }), !!VH[e2.type] && !!this._model) {
        if (this[hv]) {
          this._pendingActions.push(e2);
          return;
        }
        var l4 = o.silent;
        Gre.call(this, e2, l4);
        var c4 = o.flush;
        c4 ? this._zr.flush() : c4 !== false && ol.browser.weChat && this._throttledZrFlush(), oN.call(this, l4), sN.call(this, l4);
      }
    }, n2.prototype.updateLabelLayout = function() {
      Q1.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
    }, n2.prototype.appendData = function(e2) {
      if (this._disposed) {
        this.id;
        return;
      }
      var o = e2.seriesIndex, l4 = this.getModel(), c4 = l4.getSeriesByIndex(o);
      c4.appendData(e2), this._scheduler.unfinished = true, this.getZr().wakeUp();
    }, n2.internalField = function() {
      e3 = function(w4) {
        var C = w4._scheduler;
        C.restorePipelines(w4._model), C.prepareStageTasks(), zre(w4, true), zre(w4, false), C.plan();
      }, zre = function(w4, C) {
        for (var E = w4._model, T = w4._scheduler, O = C ? w4._componentsViews : w4._chartsViews, N = C ? w4._componentsMap : w4._chartsMap, V = w4._zr, H = w4._api, X = 0; X < O.length; X++)
          O[X].__alive = false;
        C ? E.eachComponent(function(le, me) {
          le !== "series" && q2(me);
        }) : E.eachSeries(q2);
        function q2(le) {
          var me = le.__requireNewView;
          le.__requireNewView = false;
          var ye = "_ec_" + le.id + "_" + le.type, be = !me && N[ye];
          if (!be) {
            var we = B_(le.type), Pe = C ? $c.getClass(we.main, we.sub) : Ru.getClass(we.sub);
            be = new Pe(), be.init(E, H), N[ye] = be, O.push(be), V.add(be.group);
          }
          le.__viewId = be.__id = ye, be.__alive = true, be.__model = le, be.group.__ecComponentInfo = { mainType: le.mainType, index: le.componentIndex }, !C && T.prepareView(be, le, E, H);
        }
        for (var X = 0; X < O.length; ) {
          var de = O[X];
          de.__alive ? X++ : (!C && de.renderTask.dispose(), V.remove(de.group), de.dispose(E, H), O.splice(X, 1), N[de.__id] === de && delete N[de.__id], de.__id = de.group.__ecComponentInfo = null);
        }
      }, cW = function(w4, C, E, T, O) {
        var N = w4._model;
        if (N.setUpdatePayload(E), !T) {
          Ve([].concat(w4._componentsViews).concat(w4._chartsViews), de);
          return;
        }
        var V = {};
        V[T + "Id"] = E[T + "Id"], V[T + "Index"] = E[T + "Index"], V[T + "Name"] = E[T + "Name"];
        var H = { mainType: T, query: V };
        O && (H.subType = O);
        var X = E.excludeSeriesId, q2;
        X != null && (q2 = ri(), Ve(Zl(X), function(le) {
          var me = yh(le, null);
          me != null && q2.set(me, true);
        })), N && N.eachComponent(H, function(le) {
          var me = q2 && q2.get(le.id) !== null;
          if (!me)
            if (Nwe(E))
              if (le instanceof _c2)
                E.type === cT && !E.notBlur && !le.get(["emphasis", "disabled"]) && Flt(le, E, w4._api);
              else {
                var ye = qse(le.mainType, le.componentIndex, E.name, w4._api), be = ye.focusSelf, we = ye.dispatchers;
                E.type === cT && be && !E.notBlur && Kie(le.mainType, le.componentIndex, w4._api), we && Ve(we, function(Pe) {
                  E.type === cT ? W_(Pe) : H_(Pe);
                });
              }
            else
              Qie(E) && le instanceof _c2 && (zlt(le, E, w4._api), Rwe(le), my(w4));
        }, w4), N && N.eachComponent(H, function(le) {
          var me = q2 && q2.get(le.id) !== null;
          me || de(w4[T === "series" ? "_chartsMap" : "_componentsMap"][le.__viewId]);
        }, w4);
        function de(le) {
          le && le.__alive && le[C] && le[C](le.__model, N, w4._api, E);
        }
      }, AC = { prepareAndUpdate: function(w4) {
        e3(this), AC.update.call(this, w4, { optionChanged: w4.newOption != null });
      }, update: function(w4, C) {
        var E = this._model, T = this._api, O = this._zr, N = this._coordSysMgr, V = this._scheduler;
        if (!!E) {
          E.setUpdatePayload(w4), V.restoreData(E, w4), V.performSeriesTasks(E), N.create(E, T), V.performDataProcessorTasks(E, w4), jre(this, E), N.update(E, T), e2(E), V.performVisualTasks(E, w4), Wre(this, E, T, w4, C);
          var H = E.get("backgroundColor") || "transparent", X = E.get("darkMode");
          O.setBackgroundColor(H), X != null && X !== "auto" && O.setDarkMode(X), Q1.trigger("afterupdate", E, T);
        }
      }, updateTransform: function(w4) {
        var C = this, E = this._model, T = this._api;
        if (!!E) {
          E.setUpdatePayload(w4);
          var O = [];
          E.eachComponent(function(V, H) {
            if (V !== "series") {
              var X = C.getViewOfComponentModel(H);
              if (X && X.__alive)
                if (X.updateTransform) {
                  var q2 = X.updateTransform(H, E, T, w4);
                  q2 && q2.update && O.push(X);
                } else
                  O.push(X);
            }
          });
          var N = ri();
          E.eachSeries(function(V) {
            var H = C._chartsMap[V.__viewId];
            if (H.updateTransform) {
              var X = H.updateTransform(V, E, T, w4);
              X && X.update && N.set(V.uid, 1);
            } else
              N.set(V.uid, 1);
          }), e2(E), this._scheduler.performVisualTasks(E, w4, { setDirty: true, dirtyMap: N }), fW(this, E, T, w4, {}, N), Q1.trigger("afterupdate", E, T);
        }
      }, updateView: function(w4) {
        var C = this._model;
        !C || (C.setUpdatePayload(w4), Ru.markUpdateMethod(w4, "updateView"), e2(C), this._scheduler.performVisualTasks(C, w4, { setDirty: true }), Wre(this, C, this._api, w4, {}), Q1.trigger("afterupdate", C, this._api));
      }, updateVisual: function(w4) {
        var C = this, E = this._model;
        !E || (E.setUpdatePayload(w4), E.eachSeries(function(T) {
          T.getData().clearAllVisual();
        }), Ru.markUpdateMethod(w4, "updateVisual"), e2(E), this._scheduler.performVisualTasks(E, w4, { visualType: "visual", setDirty: true }), E.eachComponent(function(T, O) {
          if (T !== "series") {
            var N = C.getViewOfComponentModel(O);
            N && N.__alive && N.updateVisual(O, E, C._api, w4);
          }
        }), E.eachSeries(function(T) {
          var O = C._chartsMap[T.__viewId];
          O.updateVisual(T, E, C._api, w4);
        }), Q1.trigger("afterupdate", E, this._api));
      }, updateLayout: function(w4) {
        AC.update.call(this, w4);
      } }, Bre = function(w4, C, E, T) {
        if (w4._disposed) {
          w4.id;
          return;
        }
        for (var O = w4._model, N = w4._coordSysMgr.getCoordinateSystems(), V, H = WN(O, E), X = 0; X < N.length; X++) {
          var q2 = N[X];
          if (q2[C] && (V = q2[C](O, H, T)) != null)
            return V;
        }
      }, jre = function(w4, C) {
        var E = w4._chartsMap, T = w4._scheduler;
        C.eachSeries(function(O) {
          T.updateStreamModes(O, E[O.__viewId]);
        });
      }, Gre = function(w4, C) {
        var E = this, T = this.getModel(), O = w4.type, N = w4.escapeConnect, V = VH[O], H = V.actionInfo, X = (H.update || "update").split(":"), q2 = X.pop(), de = X[0] != null && B_(X[0]);
        this[hv] = true;
        var le = [w4], me = false;
        w4.batch && (me = true, le = Er(w4.batch, function(rt2) {
          return rt2 = hi(rr({}, rt2), w4), rt2.batch = null, rt2;
        }));
        var ye = [], be, we = Qie(w4), Pe = Nwe(w4);
        if (Pe && kTe(this._api), Ve(le, function(rt2) {
          if (be = V.action(rt2, E._model, E._api), be = be || rr({}, rt2), be.type = H.event || be.type, ye.push(be), Pe) {
            var ft = jse(w4), et = ft.queryOptionMap, Jt = ft.mainTypeSpecified, xt = Jt ? et.keys()[0] : "series";
            cW(E, q2, rt2, xt), my(E);
          } else
            we ? (cW(E, q2, rt2, "series"), my(E)) : de && cW(E, q2, rt2, de.main, de.sub);
        }), q2 !== "none" && !Pe && !we && !de)
          try {
            this[Bg] ? (e3(this), AC.update.call(this, w4), this[Bg] = null) : AC[q2].call(this, w4);
          } catch (rt2) {
            throw this[hv] = false, rt2;
          }
        if (me ? be = { type: H.event || O, escapeConnect: N, batch: ye } : be = ye[0], this[hv] = false, !C) {
          var ze = this._messageCenter;
          if (ze.trigger(be.type, be), we) {
            var Re = { type: "selectchanged", escapeConnect: N, selected: Blt(T), isFromClick: w4.isFromClick || false, fromAction: w4.type, fromActionPayload: w4 };
            ze.trigger(Re.type, Re);
          }
        }
      }, oN = function(w4) {
        for (var C = this._pendingActions; C.length; ) {
          var E = C.shift();
          Gre.call(this, E, w4);
        }
      }, sN = function(w4) {
        !w4 && this.trigger("updated");
      }, K2e = function(w4, C) {
        w4.on("rendered", function(E) {
          C.trigger("rendered", E), w4.animation.isFinished() && !C[Bg] && !C._scheduler.unfinished && !C._pendingActions.length && C.trigger("finished");
        });
      }, J2e = function(w4, C) {
        w4.on("mouseover", function(E) {
          var T = E.target, O = _3(T, f8);
          O && (Nlt(O, E, C._api), my(C));
        }).on("mouseout", function(E) {
          var T = E.target, O = _3(T, f8);
          O && (Vlt(O, E, C._api), my(C));
        }).on("click", function(E) {
          var T = E.target, O = _3(T, function(H) {
            return Fi(H).dataIndex != null;
          }, true);
          if (O) {
            var N = O.selected ? "unselect" : "select", V = Fi(O);
            C._api.dispatchAction({ type: N, dataType: V.dataType, dataIndexInside: V.dataIndex, seriesIndex: V.seriesIndex, isFromClick: true });
          }
        });
      };
      function e2(w4) {
        w4.clearColorPalette(), w4.eachSeries(function(C) {
          C.clearColorPalette();
        });
      }
      function o(w4) {
        var C = [], E = [], T = false;
        if (w4.eachComponent(function(H, X) {
          var q2 = X.get("zlevel") || 0, de = X.get("z") || 0, le = X.getZLevelKey();
          T = T || !!le, (H === "series" ? E : C).push({ zlevel: q2, z: de, idx: X.componentIndex, type: H, key: le });
        }), T) {
          var O = C.concat(E), N, V;
          XW(O, function(H, X) {
            return H.zlevel === X.zlevel ? H.z - X.z : H.zlevel - X.zlevel;
          }), Ve(O, function(H) {
            var X = w4.getComponent(H.type, H.idx), q2 = H.zlevel, de = H.key;
            N != null && (q2 = Math.max(N, q2)), de ? (q2 === N && de !== V && q2++, V = de) : V && (q2 === N && q2++, V = ""), N = q2, X.setZLevel(q2);
          });
        }
      }
      Wre = function(w4, C, E, T, O) {
        o(C), Q2e(w4, C, E, T, O), Ve(w4._chartsViews, function(N) {
          N.__alive = false;
        }), fW(w4, C, E, T, O), Ve(w4._chartsViews, function(N) {
          N.__alive || N.remove(C, E);
        });
      }, Q2e = function(w4, C, E, T, O, N) {
        Ve(N || w4._componentsViews, function(V) {
          var H = V.__model;
          y4(H, V), V.render(H, C, E, T), p4(H, V), _(H, V);
        });
      }, fW = function(w4, C, E, T, O, N) {
        var V = w4._scheduler;
        O = rr(O || {}, { updatedSeries: C.getSeries() }), Q1.trigger("series:beforeupdate", C, E, O);
        var H = false;
        C.eachSeries(function(X) {
          var q2 = w4._chartsMap[X.__viewId];
          q2.__alive = true;
          var de = q2.renderTask;
          V.updatePayload(de, T), y4(X, q2), N && N.get(X.uid) && de.dirty(), de.perform(V.getPerformArgs(de)) && (H = true), q2.group.silent = !!X.get("silent"), h(X, q2), Rwe(X);
        }), V.unfinished = H || V.unfinished, Q1.trigger("series:layoutlabels", C, E, O), Q1.trigger("series:transition", C, E, O), C.eachSeries(function(X) {
          var q2 = w4._chartsMap[X.__viewId];
          p4(X, q2), _(X, q2);
        }), c4(w4, C), Q1.trigger("series:afterupdate", C, E, O);
      }, my = function(w4) {
        w4[Nre] = true, w4.getZr().wakeUp();
      }, tSe = function(w4) {
        !w4[Nre] || (w4.getZr().storage.traverse(function(C) {
          E3(C) || l4(C);
        }), w4[Nre] = false);
      };
      function l4(w4) {
        for (var C = [], E = w4.currentStates, T = 0; T < E.length; T++) {
          var O = E[T];
          O === "emphasis" || O === "blur" || O === "select" || C.push(O);
        }
        w4.selected && w4.states.select && C.push("select"), w4.hoverState === M$ && w4.states.emphasis ? C.push("emphasis") : w4.hoverState === z8 && w4.states.blur && C.push("blur"), w4.useStates(C);
      }
      function c4(w4, C) {
        var E = w4._zr, T = E.storage, O = 0;
        T.traverse(function(N) {
          N.isGroup || O++;
        }), O > C.get("hoverLayerThreshold") && !ol.node && !ol.worker && C.eachSeries(function(N) {
          if (!N.preventUsingHoverLayer) {
            var V = w4._chartsMap[N.__viewId];
            V.__alive && V.eachRendered(function(H) {
              H.states.emphasis && (H.states.emphasis.hoverLayer = true);
            });
          }
        });
      }
      function h(w4, C) {
        var E = w4.get("blendMode") || null;
        C.eachRendered(function(T) {
          T.isGroup || (T.style.blend = E);
        });
      }
      function p4(w4, C) {
        if (!w4.preventAutoZ) {
          var E = w4.get("z") || 0, T = w4.get("zlevel") || 0;
          C.eachRendered(function(O) {
            return g4(O, E, T, -1 / 0), true;
          });
        }
      }
      function g4(w4, C, E, T) {
        var O = w4.getTextContent(), N = w4.getTextGuideLine(), V = w4.isGroup;
        if (V)
          for (var H = w4.childrenRef(), X = 0; X < H.length; X++)
            T = Math.max(g4(H[X], C, E, T), T);
        else
          w4.z = C, w4.zlevel = E, T = Math.max(w4.z2, T);
        if (O && (O.z = C, O.zlevel = E, isFinite(T) && (O.z2 = T + 2)), N) {
          var q2 = w4.textGuideLineConfig;
          N.z = C, N.zlevel = E, isFinite(T) && (N.z2 = T + (q2 && q2.showAbove ? 1 : -1));
        }
        return T;
      }
      function y4(w4, C) {
        C.eachRendered(function(E) {
          if (!E3(E)) {
            var T = E.getTextContent(), O = E.getTextGuideLine();
            E.stateTransition && (E.stateTransition = null), T && T.stateTransition && (T.stateTransition = null), O && O.stateTransition && (O.stateTransition = null), E.hasState() ? (E.prevStates = E.currentStates, E.clearStates()) : E.prevStates && (E.prevStates = null);
          }
        });
      }
      function _(w4, C) {
        var E = w4.getModel("stateAnimation"), T = w4.isAnimationEnabled(), O = E.get("duration"), N = O > 0 ? { duration: O, delay: E.get("delay"), easing: E.get("easing") } : null;
        C.eachRendered(function(V) {
          if (V.states && V.states.emphasis) {
            if (E3(V))
              return;
            if (V instanceof Eo && $lt(V), V.__dirty) {
              var H = V.prevStates;
              H && V.useStates(H);
            }
            if (T) {
              V.stateTransition = N;
              var X = V.getTextContent(), q2 = V.getTextGuideLine();
              X && (X.stateTransition = N), q2 && (q2.stateTransition = N);
            }
            V.__dirty && l4(V);
          }
        });
      }
      eSe = function(w4) {
        return new (function(C) {
          on(E, C);
          function E() {
            return C !== null && C.apply(this, arguments) || this;
          }
          return E.prototype.getCoordinateSystems = function() {
            return w4._coordSysMgr.getCoordinateSystems();
          }, E.prototype.getComponentByElement = function(T) {
            for (; T; ) {
              var O = T.__ecComponentInfo;
              if (O != null)
                return w4._model.getComponent(O.mainType, O.index);
              T = T.parent;
            }
          }, E.prototype.enterEmphasis = function(T, O) {
            W_(T, O), my(w4);
          }, E.prototype.leaveEmphasis = function(T, O) {
            H_(T, O), my(w4);
          }, E.prototype.enterBlur = function(T) {
            ATe(T), my(w4);
          }, E.prototype.leaveBlur = function(T) {
            ETe(T), my(w4);
          }, E.prototype.enterSelect = function(T) {
            ITe(T), my(w4);
          }, E.prototype.leaveSelect = function(T) {
            TTe(T), my(w4);
          }, E.prototype.getModel = function() {
            return w4.getModel();
          }, E.prototype.getViewOfComponentModel = function(T) {
            return w4.getViewOfComponentModel(T);
          }, E.prototype.getViewOfSeriesModel = function(T) {
            return w4.getViewOfSeriesModel(T);
          }, E;
        }(LDe))(w4);
      }, I5e = function(w4) {
        function C(E, T) {
          for (var O = 0; O < E.length; O++) {
            var N = E[O];
            N[Vre] = T;
          }
        }
        Ve(ZN, function(E, T) {
          w4._messageCenter.on(T, function(O) {
            if (nSe[w4.group] && w4[Vre] !== X2e) {
              if (O && O.escapeConnect)
                return;
              var N = w4.makeActionFromEvent(O), V = [];
              Ve(XN, function(H) {
                H !== w4 && H.group === w4.group && V.push(H);
              }), C(V, X2e), Ve(V, function(H) {
                H[Vre] !== Oht && H.dispatchAction(N);
              }), C(V, Rht);
            }
          });
        });
      };
    }(), n2;
  }(zy), _le = T5e.prototype;
  _le.on = S5e("on");
  _le.off = S5e("off");
  _le.one = function(i, n2, e2) {
    var o = this;
    function l4() {
      for (var c4 = [], h = 0; h < arguments.length; h++)
        c4[h] = arguments[h];
      n2 && n2.apply && n2.apply(this, c4), o.off(i, l4);
    }
    this.on.call(this, i, l4, e2);
  };
  var Fht = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
  var VH = {}, ZN = {}, voe = [], goe = [], zH = [], D5e = {}, moe = {}, XN = {}, nSe = {}, Nht = +new Date() - 0, xle = "_echarts_instance_";
  function Vht(i, n2, e2) {
    var o = !(e2 && e2.ssr);
    if (o) {
      var l4 = zht(i);
      if (l4)
        return l4;
    }
    var c4 = new T5e(i, n2, e2);
    return c4.id = "ec_" + Nht++, XN[c4.id] = c4, o && iTe(i, xle, c4.id), I5e(c4), Q1.trigger("afterinit", c4), c4;
  }
  function zht(i) {
    return XN[Tst(i, xle)];
  }
  function k5e(i, n2) {
    D5e[i] = n2;
  }
  function P5e(i) {
    go(goe, i) < 0 && goe.push(i);
  }
  function L5e(i, n2) {
    Sle(voe, i, n2, Aht);
  }
  function Bht(i) {
    wle("afterinit", i);
  }
  function jht(i) {
    wle("afterupdate", i);
  }
  function wle(i, n2) {
    Q1.on(i, n2);
  }
  function ex(i, n2, e2) {
    si(n2) && (e2 = n2, n2 = "");
    var o = mi(i) ? i.type : [i, i = { event: n2 }][0];
    i.event = (i.event || o).toLowerCase(), n2 = i.event, !ZN[n2] && (Kv(Z2e.test(o) && Z2e.test(n2)), VH[o] || (VH[o] = { action: e2, actionInfo: i }), ZN[n2] = o);
  }
  function Ght(i, n2) {
    H8.register(i, n2);
  }
  function Wht(i, n2) {
    Sle(zH, i, n2, _5e, "layout");
  }
  function ET(i, n2) {
    Sle(zH, i, n2, x5e, "visual");
  }
  var rSe = [];
  function Sle(i, n2, e2, o, l4) {
    if ((si(n2) || mi(n2)) && (e2 = n2, n2 = o), !(go(rSe, e2) >= 0)) {
      rSe.push(e2);
      var c4 = u5e.wrapStageHandler(e2, l4);
      c4.__prio = n2, c4.__raw = e2, i.push(c4);
    }
  }
  function O5e(i, n2) {
    moe[i] = n2;
  }
  function Hht(i, n2, e2) {
    var o = _ht("registerMap");
    o && o(i, n2, e2);
  }
  var $ht = Qct;
  ET(ble, Cft);
  ET(j$, Mft);
  ET(j$, Aft);
  ET(ble, jft);
  ET(j$, Gft);
  ET(w5e, mht);
  P5e(RDe);
  L5e(Cht, Lct);
  O5e("default", Eft);
  ex({ type: cT, event: cT, update: cT }, Zf);
  ex({ type: nH, event: nH, update: nH }, Zf);
  ex({ type: HN, event: HN, update: HN }, Zf);
  ex({ type: rH, event: rH, update: rH }, Zf);
  ex({ type: $N, event: $N, update: $N }, Zf);
  k5e("light", Vft);
  k5e("dark", zft);
  var aSe = [], Uht = { registerPreprocessor: P5e, registerProcessor: L5e, registerPostInit: Bht, registerPostUpdate: jht, registerUpdateLifecycle: wle, registerAction: ex, registerCoordinateSystem: Ght, registerLayout: Wht, registerVisual: ET, registerTransform: $ht, registerLoading: O5e, registerMap: Hht, registerImpl: bht, PRIORITY: Lht, ComponentModel: Ns, ComponentView: $c, SeriesModel: _c2, ChartView: Ru, registerComponentModel: function(i) {
    Ns.registerClass(i);
  }, registerComponentView: function(i) {
    $c.registerClass(i);
  }, registerSeriesModel: function(i) {
    _c2.registerClass(i);
  }, registerChartView: function(i) {
    Ru.registerClass(i);
  }, registerSubTypeDefaulter: function(i, n2) {
    Ns.registerSubTypeDefaulter(i, n2);
  }, registerPainter: function(i, n2) {
    ust(i, n2);
  } };
  function wo(i) {
    if (Mr(i)) {
      Ve(i, function(n2) {
        wo(n2);
      });
      return;
    }
    go(aSe, i) >= 0 || (aSe.push(i), si(i) && (i = { install: i }), i.install(Uht));
  }
  function lN(i) {
    return i == null ? 0 : i.length || 1;
  }
  function iSe(i) {
    return i;
  }
  var qht = function() {
    function i(n2, e2, o, l4, c4, h) {
      this._old = n2, this._new = e2, this._oldKeyGetter = o || iSe, this._newKeyGetter = l4 || iSe, this.context = c4, this._diffModeMultiple = h === "multiple";
    }
    return i.prototype.add = function(n2) {
      return this._add = n2, this;
    }, i.prototype.update = function(n2) {
      return this._update = n2, this;
    }, i.prototype.updateManyToOne = function(n2) {
      return this._updateManyToOne = n2, this;
    }, i.prototype.updateOneToMany = function(n2) {
      return this._updateOneToMany = n2, this;
    }, i.prototype.updateManyToMany = function(n2) {
      return this._updateManyToMany = n2, this;
    }, i.prototype.remove = function(n2) {
      return this._remove = n2, this;
    }, i.prototype.execute = function() {
      this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
    }, i.prototype._executeOneToOne = function() {
      var n2 = this._old, e2 = this._new, o = {}, l4 = new Array(n2.length), c4 = new Array(e2.length);
      this._initIndexMap(n2, null, l4, "_oldKeyGetter"), this._initIndexMap(e2, o, c4, "_newKeyGetter");
      for (var h = 0; h < n2.length; h++) {
        var p4 = l4[h], g4 = o[p4], y4 = lN(g4);
        if (y4 > 1) {
          var _ = g4.shift();
          g4.length === 1 && (o[p4] = g4[0]), this._update && this._update(_, h);
        } else
          y4 === 1 ? (o[p4] = null, this._update && this._update(g4, h)) : this._remove && this._remove(h);
      }
      this._performRestAdd(c4, o);
    }, i.prototype._executeMultiple = function() {
      var n2 = this._old, e2 = this._new, o = {}, l4 = {}, c4 = [], h = [];
      this._initIndexMap(n2, o, c4, "_oldKeyGetter"), this._initIndexMap(e2, l4, h, "_newKeyGetter");
      for (var p4 = 0; p4 < c4.length; p4++) {
        var g4 = c4[p4], y4 = o[g4], _ = l4[g4], w4 = lN(y4), C = lN(_);
        if (w4 > 1 && C === 1)
          this._updateManyToOne && this._updateManyToOne(_, y4), l4[g4] = null;
        else if (w4 === 1 && C > 1)
          this._updateOneToMany && this._updateOneToMany(_, y4), l4[g4] = null;
        else if (w4 === 1 && C === 1)
          this._update && this._update(_, y4), l4[g4] = null;
        else if (w4 > 1 && C > 1)
          this._updateManyToMany && this._updateManyToMany(_, y4), l4[g4] = null;
        else if (w4 > 1)
          for (var E = 0; E < w4; E++)
            this._remove && this._remove(y4[E]);
        else
          this._remove && this._remove(y4);
      }
      this._performRestAdd(h, l4);
    }, i.prototype._performRestAdd = function(n2, e2) {
      for (var o = 0; o < n2.length; o++) {
        var l4 = n2[o], c4 = e2[l4], h = lN(c4);
        if (h > 1)
          for (var p4 = 0; p4 < h; p4++)
            this._add && this._add(c4[p4]);
        else
          h === 1 && this._add && this._add(c4);
        e2[l4] = null;
      }
    }, i.prototype._initIndexMap = function(n2, e2, o, l4) {
      for (var c4 = this._diffModeMultiple, h = 0; h < n2.length; h++) {
        var p4 = "_ec_" + this[l4](n2[h], h);
        if (c4 || (o[h] = p4), !!e2) {
          var g4 = e2[p4], y4 = lN(g4);
          y4 === 0 ? (e2[p4] = h, c4 && o.push(p4)) : y4 === 1 ? e2[p4] = [g4, h] : g4.push(h);
        }
      }
    }, i;
  }(), x2 = qht, Yht = function() {
    function i(n2, e2) {
      this._encode = n2, this._schema = e2;
    }
    return i.prototype.get = function() {
      return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
    }, i.prototype._getFullDimensionNames = function() {
      return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
    }, i;
  }();
  function Zht(i, n2) {
    var e2 = {}, o = e2.encode = {}, l4 = ri(), c4 = [], h = [], p4 = {};
    Ve(i.dimensions, function(C) {
      var E = i.getDimensionInfo(C), T = E.coordDim;
      if (T) {
        var O = E.coordDimIndex;
        Hre(o, T)[O] = C, E.isExtraCoord || (l4.set(T, 1), Xht(E.type) && (c4[0] = C), Hre(p4, T)[O] = i.getDimensionIndex(E.name)), E.defaultTooltip && h.push(C);
      }
      CDe.each(function(N, V) {
        var H = Hre(o, V), X = E.otherDims[V];
        X != null && X !== false && (H[X] = E.name);
      });
    });
    var g4 = [], y4 = {};
    l4.each(function(C, E) {
      var T = o[E];
      y4[E] = T[0], g4 = g4.concat(T);
    }), e2.dataDimsOnCoord = g4, e2.dataDimIndicesOnCoord = Er(g4, function(C) {
      return i.getDimensionInfo(C).storeDimIndex;
    }), e2.encodeFirstDimNotExtra = y4;
    var _ = o.label;
    _ && _.length && (c4 = _.slice());
    var w4 = o.tooltip;
    return w4 && w4.length ? h = w4.slice() : h.length || (h = c4.slice()), o.defaultedLabel = c4, o.defaultedTooltip = h, e2.userOutput = new Yht(p4, n2), e2;
  }
  function Hre(i, n2) {
    return i.hasOwnProperty(n2) || (i[n2] = []), i[n2];
  }
  function BH(i) {
    return i === "category" ? "ordinal" : i === "time" ? "time" : "float";
  }
  function Xht(i) {
    return !(i === "ordinal" || i === "time");
  }
  var Kht = function() {
    function i(n2) {
      this.otherDims = {}, n2 != null && rr(this, n2);
    }
    return i;
  }(), lH = Kht, Jht = zs(), Qht = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, R5e = function() {
    function i(n2) {
      this.dimensions = n2.dimensions, this._dimOmitted = n2.dimensionOmitted, this.source = n2.source, this._fullDimCount = n2.fullDimensionCount, this._updateDimOmitted(n2.dimensionOmitted);
    }
    return i.prototype.isDimensionOmitted = function() {
      return this._dimOmitted;
    }, i.prototype._updateDimOmitted = function(n2) {
      this._dimOmitted = n2, n2 && (this._dimNameMap || (this._dimNameMap = V5e(this.source)));
    }, i.prototype.getSourceDimensionIndex = function(n2) {
      return so(this._dimNameMap.get(n2), -1);
    }, i.prototype.getSourceDimension = function(n2) {
      var e2 = this.source.dimensionsDefine;
      if (e2)
        return e2[n2];
    }, i.prototype.makeStoreSchema = function() {
      for (var n2 = this._fullDimCount, e2 = NDe(this.source), o = !z5e(n2), l4 = "", c4 = [], h = 0, p4 = 0; h < n2; h++) {
        var g4 = void 0, y4 = void 0, _ = void 0, w4 = this.dimensions[p4];
        if (w4 && w4.storeDimIndex === h)
          g4 = e2 ? w4.name : null, y4 = w4.type, _ = w4.ordinalMeta, p4++;
        else {
          var C = this.getSourceDimension(h);
          C && (g4 = e2 ? C.name : null, y4 = C.type);
        }
        c4.push({ property: g4, type: y4, ordinalMeta: _ }), e2 && g4 != null && (!w4 || !w4.isCalculationCoord) && (l4 += o ? g4.replace(/\`/g, "`1").replace(/\$/g, "`2") : g4), l4 += "$", l4 += Qht[y4] || "f", _ && (l4 += _.uid), l4 += "$";
      }
      var E = this.source, T = [E.seriesLayoutBy, E.startIndex, l4].join("$$");
      return { dimensions: c4, hash: T };
    }, i.prototype.makeOutputDimensionNames = function() {
      for (var n2 = [], e2 = 0, o = 0; e2 < this._fullDimCount; e2++) {
        var l4 = void 0, c4 = this.dimensions[o];
        if (c4 && c4.storeDimIndex === e2)
          c4.isCalculationCoord || (l4 = c4.name), o++;
        else {
          var h = this.getSourceDimension(e2);
          h && (l4 = h.name);
        }
        n2.push(l4);
      }
      return n2;
    }, i.prototype.appendCalculationDimension = function(n2) {
      this.dimensions.push(n2), n2.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
    }, i;
  }();
  function F5e(i) {
    return i instanceof R5e;
  }
  function N5e(i) {
    for (var n2 = ri(), e2 = 0; e2 < (i || []).length; e2++) {
      var o = i[e2], l4 = mi(o) ? o.name : o;
      l4 != null && n2.get(l4) == null && n2.set(l4, e2);
    }
    return n2;
  }
  function V5e(i) {
    var n2 = Jht(i);
    return n2.dimNameMap || (n2.dimNameMap = N5e(i.dimensionsDefine));
  }
  function z5e(i) {
    return i > 30;
  }
  var uN = mi, EC = Er, edt = typeof Int32Array == "undefined" ? Array : Int32Array, tdt = "e\0\0", oSe = -1, ndt = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], rdt = ["_approximateExtent"], sSe, hW, cN, fN, $re, dW, Ure, adt = function() {
    function i(n2, e2) {
      this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
      var o, l4 = false;
      F5e(n2) ? (o = n2.dimensions, this._dimOmitted = n2.isDimensionOmitted(), this._schema = n2) : (l4 = true, o = n2), o = o || ["x", "y"];
      for (var c4 = {}, h = [], p4 = {}, g4 = false, y4 = {}, _ = 0; _ < o.length; _++) {
        var w4 = o[_], C = xa(w4) ? new lH({ name: w4 }) : w4 instanceof lH ? w4 : new lH(w4), E = C.name;
        C.type = C.type || "float", C.coordDim || (C.coordDim = E, C.coordDimIndex = 0);
        var T = C.otherDims = C.otherDims || {};
        h.push(E), c4[E] = C, y4[E] != null && (g4 = true), C.createInvertedIndices && (p4[E] = []), T.itemName === 0 && (this._nameDimIdx = _), T.itemId === 0 && (this._idDimIdx = _), l4 && (C.storeDimIndex = _);
      }
      if (this.dimensions = h, this._dimInfos = c4, this._initGetDimensionInfo(g4), this.hostModel = e2, this._invertedIndicesMap = p4, this._dimOmitted) {
        var O = this._dimIdxToName = ri();
        Ve(h, function(N) {
          O.set(c4[N].storeDimIndex, N);
        });
      }
    }
    return i.prototype.getDimension = function(n2) {
      var e2 = this._recognizeDimIndex(n2);
      if (e2 == null)
        return n2;
      if (e2 = n2, !this._dimOmitted)
        return this.dimensions[e2];
      var o = this._dimIdxToName.get(e2);
      if (o != null)
        return o;
      var l4 = this._schema.getSourceDimension(e2);
      if (l4)
        return l4.name;
    }, i.prototype.getDimensionIndex = function(n2) {
      var e2 = this._recognizeDimIndex(n2);
      if (e2 != null)
        return e2;
      if (n2 == null)
        return -1;
      var o = this._getDimInfo(n2);
      return o ? o.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(n2) : -1;
    }, i.prototype._recognizeDimIndex = function(n2) {
      if (sl(n2) || n2 != null && !isNaN(n2) && !this._getDimInfo(n2) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(n2) < 0))
        return +n2;
    }, i.prototype._getStoreDimIndex = function(n2) {
      var e2 = this.getDimensionIndex(n2);
      return e2;
    }, i.prototype.getDimensionInfo = function(n2) {
      return this._getDimInfo(this.getDimension(n2));
    }, i.prototype._initGetDimensionInfo = function(n2) {
      var e2 = this._dimInfos;
      this._getDimInfo = n2 ? function(o) {
        return e2.hasOwnProperty(o) ? e2[o] : void 0;
      } : function(o) {
        return e2[o];
      };
    }, i.prototype.getDimensionsOnCoord = function() {
      return this._dimSummary.dataDimsOnCoord.slice();
    }, i.prototype.mapDimension = function(n2, e2) {
      var o = this._dimSummary;
      if (e2 == null)
        return o.encodeFirstDimNotExtra[n2];
      var l4 = o.encode[n2];
      return l4 ? l4[e2] : null;
    }, i.prototype.mapDimensionsAll = function(n2) {
      var e2 = this._dimSummary, o = e2.encode[n2];
      return (o || []).slice();
    }, i.prototype.getStore = function() {
      return this._store;
    }, i.prototype.initData = function(n2, e2, o) {
      var l4 = this, c4;
      if (n2 instanceof loe && (c4 = n2), !c4) {
        var h = this.dimensions, p4 = ule(n2) || gv(n2) ? new VDe(n2, h.length) : n2;
        c4 = new loe();
        var g4 = EC(h, function(y4) {
          return { type: l4._dimInfos[y4].type, property: y4 };
        });
        c4.initData(p4, g4, o);
      }
      this._store = c4, this._nameList = (e2 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, c4.count()), this._dimSummary = Zht(this, this._schema), this.userOutput = this._dimSummary.userOutput;
    }, i.prototype.appendData = function(n2) {
      var e2 = this._store.appendData(n2);
      this._doInit(e2[0], e2[1]);
    }, i.prototype.appendValues = function(n2, e2) {
      var o = this._store.appendValues(n2, e2.length), l4 = o.start, c4 = o.end, h = this._shouldMakeIdFromName();
      if (this._updateOrdinalMeta(), e2)
        for (var p4 = l4; p4 < c4; p4++) {
          var g4 = p4 - l4;
          this._nameList[p4] = e2[g4], h && Ure(this, p4);
        }
    }, i.prototype._updateOrdinalMeta = function() {
      for (var n2 = this._store, e2 = this.dimensions, o = 0; o < e2.length; o++) {
        var l4 = this._dimInfos[e2[o]];
        l4.ordinalMeta && n2.collectOrdinalMeta(l4.storeDimIndex, l4.ordinalMeta);
      }
    }, i.prototype._shouldMakeIdFromName = function() {
      var n2 = this._store.getProvider();
      return this._idDimIdx == null && n2.getSource().sourceFormat !== qC && !n2.fillStorage;
    }, i.prototype._doInit = function(n2, e2) {
      if (!(n2 >= e2)) {
        var o = this._store, l4 = o.getProvider();
        this._updateOrdinalMeta();
        var c4 = this._nameList, h = this._idList, p4 = l4.getSource().sourceFormat, g4 = p4 === By;
        if (g4 && !l4.pure)
          for (var y4 = [], _ = n2; _ < e2; _++) {
            var w4 = l4.getItem(_, y4);
            if (!this.hasItemOption && gst(w4) && (this.hasItemOption = true), w4) {
              var C = w4.name;
              c4[_] == null && C != null && (c4[_] = yh(C, null));
              var E = w4.id;
              h[_] == null && E != null && (h[_] = yh(E, null));
            }
          }
        if (this._shouldMakeIdFromName())
          for (var _ = n2; _ < e2; _++)
            Ure(this, _);
        sSe(this);
      }
    }, i.prototype.getApproximateExtent = function(n2) {
      return this._approximateExtent[n2] || this._store.getDataExtent(this._getStoreDimIndex(n2));
    }, i.prototype.setApproximateExtent = function(n2, e2) {
      e2 = this.getDimension(e2), this._approximateExtent[e2] = n2.slice();
    }, i.prototype.getCalculationInfo = function(n2) {
      return this._calculationInfo[n2];
    }, i.prototype.setCalculationInfo = function(n2, e2) {
      uN(n2) ? rr(this._calculationInfo, n2) : this._calculationInfo[n2] = e2;
    }, i.prototype.getName = function(n2) {
      var e2 = this.getRawIndex(n2), o = this._nameList[e2];
      return o == null && this._nameDimIdx != null && (o = cN(this, this._nameDimIdx, e2)), o == null && (o = ""), o;
    }, i.prototype._getCategory = function(n2, e2) {
      var o = this._store.get(n2, e2), l4 = this._store.getOrdinalMeta(n2);
      return l4 ? l4.categories[o] : o;
    }, i.prototype.getId = function(n2) {
      return hW(this, this.getRawIndex(n2));
    }, i.prototype.count = function() {
      return this._store.count();
    }, i.prototype.get = function(n2, e2) {
      var o = this._store, l4 = this._dimInfos[n2];
      if (l4)
        return o.get(l4.storeDimIndex, e2);
    }, i.prototype.getByRawIndex = function(n2, e2) {
      var o = this._store, l4 = this._dimInfos[n2];
      if (l4)
        return o.getByRawIndex(l4.storeDimIndex, e2);
    }, i.prototype.getIndices = function() {
      return this._store.getIndices();
    }, i.prototype.getDataExtent = function(n2) {
      return this._store.getDataExtent(this._getStoreDimIndex(n2));
    }, i.prototype.getSum = function(n2) {
      return this._store.getSum(this._getStoreDimIndex(n2));
    }, i.prototype.getMedian = function(n2) {
      return this._store.getMedian(this._getStoreDimIndex(n2));
    }, i.prototype.getValues = function(n2, e2) {
      var o = this, l4 = this._store;
      return Mr(n2) ? l4.getValues(EC(n2, function(c4) {
        return o._getStoreDimIndex(c4);
      }), e2) : l4.getValues(n2);
    }, i.prototype.hasValue = function(n2) {
      for (var e2 = this._dimSummary.dataDimIndicesOnCoord, o = 0, l4 = e2.length; o < l4; o++)
        if (isNaN(this._store.get(e2[o], n2)))
          return false;
      return true;
    }, i.prototype.indexOfName = function(n2) {
      for (var e2 = 0, o = this._store.count(); e2 < o; e2++)
        if (this.getName(e2) === n2)
          return e2;
      return -1;
    }, i.prototype.getRawIndex = function(n2) {
      return this._store.getRawIndex(n2);
    }, i.prototype.indexOfRawIndex = function(n2) {
      return this._store.indexOfRawIndex(n2);
    }, i.prototype.rawIndexOf = function(n2, e2) {
      var o = n2 && this._invertedIndicesMap[n2], l4 = o[e2];
      return l4 == null || isNaN(l4) ? oSe : l4;
    }, i.prototype.indicesOfNearest = function(n2, e2, o) {
      return this._store.indicesOfNearest(this._getStoreDimIndex(n2), e2, o);
    }, i.prototype.each = function(n2, e2, o) {
      si(n2) && (o = e2, e2 = n2, n2 = []);
      var l4 = o || this, c4 = EC(fN(n2), this._getStoreDimIndex, this);
      this._store.each(c4, l4 ? Ia(e2, l4) : e2);
    }, i.prototype.filterSelf = function(n2, e2, o) {
      si(n2) && (o = e2, e2 = n2, n2 = []);
      var l4 = o || this, c4 = EC(fN(n2), this._getStoreDimIndex, this);
      return this._store = this._store.filter(c4, l4 ? Ia(e2, l4) : e2), this;
    }, i.prototype.selectRange = function(n2) {
      var e2 = this, o = {}, l4 = ts(n2);
      return Ve(l4, function(c4) {
        var h = e2._getStoreDimIndex(c4);
        o[h] = n2[c4];
      }), this._store = this._store.selectRange(o), this;
    }, i.prototype.mapArray = function(n2, e2, o) {
      si(n2) && (o = e2, e2 = n2, n2 = []), o = o || this;
      var l4 = [];
      return this.each(n2, function() {
        l4.push(e2 && e2.apply(this, arguments));
      }, o), l4;
    }, i.prototype.map = function(n2, e2, o, l4) {
      var c4 = o || l4 || this, h = EC(fN(n2), this._getStoreDimIndex, this), p4 = dW(this);
      return p4._store = this._store.map(h, c4 ? Ia(e2, c4) : e2), p4;
    }, i.prototype.modify = function(n2, e2, o, l4) {
      var c4 = o || l4 || this, h = EC(fN(n2), this._getStoreDimIndex, this);
      this._store.modify(h, c4 ? Ia(e2, c4) : e2);
    }, i.prototype.downSample = function(n2, e2, o, l4) {
      var c4 = dW(this);
      return c4._store = this._store.downSample(this._getStoreDimIndex(n2), e2, o, l4), c4;
    }, i.prototype.lttbDownSample = function(n2, e2) {
      var o = dW(this);
      return o._store = this._store.lttbDownSample(this._getStoreDimIndex(n2), e2), o;
    }, i.prototype.getRawDataItem = function(n2) {
      return this._store.getRawDataItem(n2);
    }, i.prototype.getItemModel = function(n2) {
      var e2 = this.hostModel, o = this.getRawDataItem(n2);
      return new Ou(o, e2, e2 && e2.ecModel);
    }, i.prototype.diff = function(n2) {
      var e2 = this;
      return new x2(n2 ? n2.getStore().getIndices() : [], this.getStore().getIndices(), function(o) {
        return hW(n2, o);
      }, function(o) {
        return hW(e2, o);
      });
    }, i.prototype.getVisual = function(n2) {
      var e2 = this._visual;
      return e2 && e2[n2];
    }, i.prototype.setVisual = function(n2, e2) {
      this._visual = this._visual || {}, uN(n2) ? rr(this._visual, n2) : this._visual[n2] = e2;
    }, i.prototype.getItemVisual = function(n2, e2) {
      var o = this._itemVisuals[n2], l4 = o && o[e2];
      return l4 == null ? this.getVisual(e2) : l4;
    }, i.prototype.hasItemVisual = function() {
      return this._itemVisuals.length > 0;
    }, i.prototype.ensureUniqueItemVisual = function(n2, e2) {
      var o = this._itemVisuals, l4 = o[n2];
      l4 || (l4 = o[n2] = {});
      var c4 = l4[e2];
      return c4 == null && (c4 = this.getVisual(e2), Mr(c4) ? c4 = c4.slice() : uN(c4) && (c4 = rr({}, c4)), l4[e2] = c4), c4;
    }, i.prototype.setItemVisual = function(n2, e2, o) {
      var l4 = this._itemVisuals[n2] || {};
      this._itemVisuals[n2] = l4, uN(e2) ? rr(l4, e2) : l4[e2] = o;
    }, i.prototype.clearAllVisual = function() {
      this._visual = {}, this._itemVisuals = [];
    }, i.prototype.setLayout = function(n2, e2) {
      uN(n2) ? rr(this._layout, n2) : this._layout[n2] = e2;
    }, i.prototype.getLayout = function(n2) {
      return this._layout[n2];
    }, i.prototype.getItemLayout = function(n2) {
      return this._itemLayouts[n2];
    }, i.prototype.setItemLayout = function(n2, e2, o) {
      this._itemLayouts[n2] = o ? rr(this._itemLayouts[n2] || {}, e2) : e2;
    }, i.prototype.clearItemLayouts = function() {
      this._itemLayouts.length = 0;
    }, i.prototype.setItemGraphicEl = function(n2, e2) {
      var o = this.hostModel && this.hostModel.seriesIndex;
      Zie(o, this.dataType, n2, e2), this._graphicEls[n2] = e2;
    }, i.prototype.getItemGraphicEl = function(n2) {
      return this._graphicEls[n2];
    }, i.prototype.eachItemGraphicEl = function(n2, e2) {
      Ve(this._graphicEls, function(o, l4) {
        o && n2 && n2.call(e2, o, l4);
      });
    }, i.prototype.cloneShallow = function(n2) {
      return n2 || (n2 = new i(this._schema ? this._schema : EC(this.dimensions, this._getDimInfo, this), this.hostModel)), $re(n2, this), n2._store = this._store, n2;
    }, i.prototype.wrapMethod = function(n2, e2) {
      var o = this[n2];
      !si(o) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(n2), this[n2] = function() {
        var l4 = o.apply(this, arguments);
        return e2.apply(this, [l4].concat(kse(arguments)));
      });
    }, i.internalField = function() {
      sSe = function(n2) {
        var e2 = n2._invertedIndicesMap;
        Ve(e2, function(o, l4) {
          var c4 = n2._dimInfos[l4], h = c4.ordinalMeta, p4 = n2._store;
          if (h) {
            o = e2[l4] = new edt(h.categories.length);
            for (var g4 = 0; g4 < o.length; g4++)
              o[g4] = oSe;
            for (var g4 = 0; g4 < p4.count(); g4++)
              o[p4.get(c4.storeDimIndex, g4)] = g4;
          }
        });
      }, cN = function(n2, e2, o) {
        return yh(n2._getCategory(e2, o), null);
      }, hW = function(n2, e2) {
        var o = n2._idList[e2];
        return o == null && n2._idDimIdx != null && (o = cN(n2, n2._idDimIdx, e2)), o == null && (o = tdt + e2), o;
      }, fN = function(n2) {
        return Mr(n2) || (n2 = n2 != null ? [n2] : []), n2;
      }, dW = function(n2) {
        var e2 = new i(n2._schema ? n2._schema : EC(n2.dimensions, n2._getDimInfo, n2), n2.hostModel);
        return $re(e2, n2), e2;
      }, $re = function(n2, e2) {
        Ve(ndt.concat(e2.__wrappedMethods || []), function(o) {
          e2.hasOwnProperty(o) && (n2[o] = e2[o]);
        }), n2.__wrappedMethods = e2.__wrappedMethods, Ve(rdt, function(o) {
          n2[o] = Ci(e2[o]);
        }), n2._calculationInfo = rr({}, e2._calculationInfo);
      }, Ure = function(n2, e2) {
        var o = n2._nameList, l4 = n2._idList, c4 = n2._nameDimIdx, h = n2._idDimIdx, p4 = o[e2], g4 = l4[e2];
        if (p4 == null && c4 != null && (o[e2] = p4 = cN(n2, c4, e2)), g4 == null && h != null && (l4[e2] = g4 = cN(n2, h, e2)), g4 == null && p4 != null) {
          var y4 = n2._nameRepeatCount, _ = y4[p4] = (y4[p4] || 0) + 1;
          g4 = p4, _ > 1 && (g4 += "__ec__" + _), l4[e2] = g4;
        }
      };
    }(), i;
  }(), Xv = adt;
  function q8(i, n2) {
    ule(i) || (i = cle(i)), n2 = n2 || {};
    var e2 = n2.coordDimensions || [], o = n2.dimensionsDefine || i.dimensionsDefine || [], l4 = ri(), c4 = [], h = odt(i, e2, o, n2.dimensionsCount), p4 = n2.canOmitUnusedDimensions && z5e(h), g4 = o === i.dimensionsDefine, y4 = g4 ? V5e(i) : N5e(o), _ = n2.encodeDefine;
    !_ && n2.encodeDefaulter && (_ = n2.encodeDefaulter(i, h));
    for (var w4 = ri(_), C = new UDe(h), E = 0; E < C.length; E++)
      C[E] = -1;
    function T(be) {
      var we = C[be];
      if (we < 0) {
        var Pe = o[be], ze = mi(Pe) ? Pe : { name: Pe }, Re = new lH(), rt2 = ze.name;
        rt2 != null && y4.get(rt2) != null && (Re.name = Re.displayName = rt2), ze.type != null && (Re.type = ze.type), ze.displayName != null && (Re.displayName = ze.displayName);
        var ft = c4.length;
        return C[be] = ft, Re.storeDimIndex = be, c4.push(Re), Re;
      }
      return c4[we];
    }
    if (!p4)
      for (var E = 0; E < h; E++)
        T(E);
    w4.each(function(be, we) {
      var Pe = Zl(be).slice();
      if (Pe.length === 1 && !xa(Pe[0]) && Pe[0] < 0) {
        w4.set(we, false);
        return;
      }
      var ze = w4.set(we, []);
      Ve(Pe, function(Re, rt2) {
        var ft = xa(Re) ? y4.get(Re) : Re;
        ft != null && ft < h && (ze[rt2] = ft, N(T(ft), we, rt2));
      });
    });
    var O = 0;
    Ve(e2, function(be) {
      var we, Pe, ze, Re;
      if (xa(be))
        we = be, Re = {};
      else {
        Re = be, we = Re.name;
        var rt2 = Re.ordinalMeta;
        Re.ordinalMeta = null, Re = rr({}, Re), Re.ordinalMeta = rt2, Pe = Re.dimsDef, ze = Re.otherDims, Re.name = Re.coordDim = Re.coordDimIndex = Re.dimsDef = Re.otherDims = null;
      }
      var ft = w4.get(we);
      if (ft !== false) {
        if (ft = Zl(ft), !ft.length)
          for (var et = 0; et < (Pe && Pe.length || 1); et++) {
            for (; O < h && T(O).coordDim != null; )
              O++;
            O < h && ft.push(O++);
          }
        Ve(ft, function(Jt, xt) {
          var It = T(Jt);
          if (g4 && Re.type != null && (It.type = Re.type), N(hi(It, Re), we, xt), It.name == null && Pe) {
            var Wt = Pe[xt];
            !mi(Wt) && (Wt = { name: Wt }), It.name = It.displayName = Wt.name, It.defaultTooltip = Wt.defaultTooltip;
          }
          ze && hi(It.otherDims, ze);
        });
      }
    });
    function N(be, we, Pe) {
      CDe.get(we) != null ? be.otherDims[we] = Pe : (be.coordDim = we, be.coordDimIndex = Pe, l4.set(we, true));
    }
    var V = n2.generateCoord, H = n2.generateCoordCount, X = H != null;
    H = V ? H || 1 : 0;
    var q2 = V || "value";
    function de(be) {
      be.name == null && (be.name = be.coordDim);
    }
    if (p4)
      Ve(c4, function(be) {
        de(be);
      }), c4.sort(function(be, we) {
        return be.storeDimIndex - we.storeDimIndex;
      });
    else
      for (var le = 0; le < h; le++) {
        var me = T(le), ye = me.coordDim;
        ye == null && (me.coordDim = sdt(q2, l4, X), me.coordDimIndex = 0, (!V || H <= 0) && (me.isExtraCoord = true), H--), de(me), me.type == null && (IDe(i, le) === wp.Must || me.isExtraCoord && (me.otherDims.itemName != null || me.otherDims.seriesName != null)) && (me.type = "ordinal");
      }
    return idt(c4), new R5e({ source: i, dimensions: c4, fullDimensionCount: h, dimensionOmitted: p4 });
  }
  function idt(i) {
    for (var n2 = ri(), e2 = 0; e2 < i.length; e2++) {
      var o = i[e2], l4 = o.name, c4 = n2.get(l4) || 0;
      c4 > 0 && (o.name = l4 + (c4 - 1)), c4++, n2.set(l4, c4);
    }
  }
  function odt(i, n2, e2, o) {
    var l4 = Math.max(i.dimensionsDetectedCount || 1, n2.length, e2.length, o || 0);
    return Ve(n2, function(c4) {
      var h;
      mi(c4) && (h = c4.dimsDef) && (l4 = Math.max(l4, h.length));
    }), l4;
  }
  function sdt(i, n2, e2) {
    var o = n2.data;
    if (e2 || o.hasOwnProperty(i)) {
      for (var l4 = 0; o.hasOwnProperty(i + l4); )
        l4++;
      i += l4;
    }
    return n2.set(i, true), i;
  }
  var ldt = function() {
    function i(n2) {
      this.coordSysDims = [], this.axisMap = ri(), this.categoryAxisMap = ri(), this.coordSysName = n2;
    }
    return i;
  }();
  function udt(i) {
    var n2 = i.get("coordinateSystem"), e2 = new ldt(n2), o = cdt[n2];
    if (o)
      return o(i, e2, e2.axisMap, e2.categoryAxisMap), e2;
  }
  var cdt = { cartesian2d: function(i, n2, e2, o) {
    var l4 = i.getReferringComponents("xAxis", Yf).models[0], c4 = i.getReferringComponents("yAxis", Yf).models[0];
    n2.coordSysDims = ["x", "y"], e2.set("x", l4), e2.set("y", c4), t3(l4) && (o.set("x", l4), n2.firstCategoryDimIndex = 0), t3(c4) && (o.set("y", c4), n2.firstCategoryDimIndex == null && (n2.firstCategoryDimIndex = 1));
  }, singleAxis: function(i, n2, e2, o) {
    var l4 = i.getReferringComponents("singleAxis", Yf).models[0];
    n2.coordSysDims = ["single"], e2.set("single", l4), t3(l4) && (o.set("single", l4), n2.firstCategoryDimIndex = 0);
  }, polar: function(i, n2, e2, o) {
    var l4 = i.getReferringComponents("polar", Yf).models[0], c4 = l4.findAxisModel("radiusAxis"), h = l4.findAxisModel("angleAxis");
    n2.coordSysDims = ["radius", "angle"], e2.set("radius", c4), e2.set("angle", h), t3(c4) && (o.set("radius", c4), n2.firstCategoryDimIndex = 0), t3(h) && (o.set("angle", h), n2.firstCategoryDimIndex == null && (n2.firstCategoryDimIndex = 1));
  }, geo: function(i, n2, e2, o) {
    n2.coordSysDims = ["lng", "lat"];
  }, parallel: function(i, n2, e2, o) {
    var l4 = i.ecModel, c4 = l4.getComponent("parallel", i.get("parallelIndex")), h = n2.coordSysDims = c4.dimensions.slice();
    Ve(c4.parallelAxisIndex, function(p4, g4) {
      var y4 = l4.getComponent("parallelAxis", p4), _ = h[g4];
      e2.set(_, y4), t3(y4) && (o.set(_, y4), n2.firstCategoryDimIndex == null && (n2.firstCategoryDimIndex = g4));
    });
  } };
  function t3(i) {
    return i.get("type") === "category";
  }
  function fdt(i, n2, e2) {
    e2 = e2 || {};
    var o = e2.byIndex, l4 = e2.stackedCoordDimension, c4, h, p4;
    hdt(n2) ? c4 = n2 : (h = n2.schema, c4 = h.dimensions, p4 = n2.store);
    var g4 = !!(i && i.get("stack")), y4, _, w4, C;
    if (Ve(c4, function(H, X) {
      xa(H) && (c4[X] = H = { name: H }), g4 && !H.isExtraCoord && (!o && !y4 && H.ordinalMeta && (y4 = H), !_ && H.type !== "ordinal" && H.type !== "time" && (!l4 || l4 === H.coordDim) && (_ = H));
    }), _ && !o && !y4 && (o = true), _) {
      w4 = "__\0ecstackresult_" + i.id, C = "__\0ecstackedover_" + i.id, y4 && (y4.createInvertedIndices = true);
      var E = _.coordDim, T = _.type, O = 0;
      Ve(c4, function(H) {
        H.coordDim === E && O++;
      });
      var N = { name: w4, coordDim: E, coordDimIndex: O, type: T, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: c4.length }, V = { name: C, coordDim: C, coordDimIndex: O + 1, type: T, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: c4.length + 1 };
      h ? (p4 && (N.storeDimIndex = p4.ensureCalculationDimension(C, T), V.storeDimIndex = p4.ensureCalculationDimension(w4, T)), h.appendCalculationDimension(N), h.appendCalculationDimension(V)) : (c4.push(N), c4.push(V));
    }
    return { stackedDimension: _ && _.name, stackedByDimension: y4 && y4.name, isStackedByIndex: o, stackedOverDimension: C, stackResultDimension: w4 };
  }
  function hdt(i) {
    return !F5e(i.schema);
  }
  function eM(i, n2) {
    return !!n2 && n2 === i.getCalculationInfo("stackedDimension");
  }
  function B5e(i, n2) {
    return eM(i, n2) ? i.getCalculationInfo("stackResultDimension") : n2;
  }
  function ddt(i, n2) {
    var e2 = i.get("coordinateSystem"), o = H8.get(e2), l4;
    return n2 && n2.coordSysDims && (l4 = Er(n2.coordSysDims, function(c4) {
      var h = { name: c4 }, p4 = n2.axisMap.get(c4);
      if (p4) {
        var g4 = p4.get("type");
        h.type = BH(g4);
      }
      return h;
    })), l4 || (l4 = o && (o.getDimensionsInfo ? o.getDimensionsInfo() : o.dimensions.slice()) || ["x", "y"]), l4;
  }
  function pdt(i, n2, e2) {
    var o, l4;
    return e2 && Ve(i, function(c4, h) {
      var p4 = c4.coordDim, g4 = e2.categoryAxisMap.get(p4);
      g4 && (o == null && (o = h), c4.ordinalMeta = g4.getOrdinalMeta(), n2 && (c4.createInvertedIndices = true)), c4.otherDims.itemName != null && (l4 = true);
    }), !l4 && o != null && (i[o].otherDims.itemName = 0), o;
  }
  function M2(i, n2, e2) {
    e2 = e2 || {};
    var o = n2.getSourceManager(), l4, c4 = false;
    i ? (c4 = true, l4 = cle(i)) : (l4 = o.getSource(), c4 = l4.sourceFormat === By);
    var h = udt(n2), p4 = ddt(n2, h), g4 = e2.useEncodeDefaulter, y4 = si(g4) ? g4 : g4 ? zi(EDe, p4, n2) : null, _ = { coordDimensions: p4, generateCoord: e2.generateCoord, encodeDefine: n2.getEncode(), encodeDefaulter: y4, canOmitUnusedDimensions: !c4 }, w4 = q8(l4, _), C = pdt(w4.dimensions, e2.createInvertedIndices, h), E = c4 ? null : o.getSharedDataStore(w4), T = fdt(n2, { schema: w4, store: E }), O = new Xv(w4, n2);
    O.setCalculationInfo(T);
    var N = C != null && vdt(l4) ? function(V, H, X, q2) {
      return q2 === C ? X : this.defaultDimValueGetter(V, H, X, q2);
    } : null;
    return O.hasItemOption = false, O.initData(c4 ? l4 : E, null, N), O;
  }
  function vdt(i) {
    if (i.sourceFormat === By) {
      var n2 = gdt(i.data || []);
      return !Mr(H3(n2));
    }
  }
  function gdt(i) {
    for (var n2 = 0; n2 < i.length && i[n2] == null; )
      n2++;
    return i[n2];
  }
  var j5e = function() {
    function i(n2) {
      this._setting = n2 || {}, this._extent = [1 / 0, -1 / 0];
    }
    return i.prototype.getSetting = function(n2) {
      return this._setting[n2];
    }, i.prototype.unionExtent = function(n2) {
      var e2 = this._extent;
      n2[0] < e2[0] && (e2[0] = n2[0]), n2[1] > e2[1] && (e2[1] = n2[1]);
    }, i.prototype.unionExtentFromData = function(n2, e2) {
      this.unionExtent(n2.getApproximateExtent(e2));
    }, i.prototype.getExtent = function() {
      return this._extent.slice();
    }, i.prototype.setExtent = function(n2, e2) {
      var o = this._extent;
      isNaN(n2) || (o[0] = n2), isNaN(e2) || (o[1] = e2);
    }, i.prototype.isInExtentRange = function(n2) {
      return this._extent[0] <= n2 && this._extent[1] >= n2;
    }, i.prototype.isBlank = function() {
      return this._isBlank;
    }, i.prototype.setBlank = function(n2) {
      this._isBlank = n2;
    }, i;
  }();
  x$(j5e);
  var A2 = j5e, mdt = 0, ydt = function() {
    function i(n2) {
      this.categories = n2.categories || [], this._needCollect = n2.needCollect, this._deduplication = n2.deduplication, this.uid = ++mdt;
    }
    return i.createByAxisModel = function(n2) {
      var e2 = n2.option, o = e2.data, l4 = o && Er(o, bdt);
      return new i({ categories: l4, needCollect: !l4, deduplication: e2.dedplication !== false });
    }, i.prototype.getOrdinal = function(n2) {
      return this._getOrCreateMap().get(n2);
    }, i.prototype.parseAndCollect = function(n2) {
      var e2, o = this._needCollect;
      if (!xa(n2) && !o)
        return n2;
      if (o && !this._deduplication)
        return e2 = this.categories.length, this.categories[e2] = n2, e2;
      var l4 = this._getOrCreateMap();
      return e2 = l4.get(n2), e2 == null && (o ? (e2 = this.categories.length, this.categories[e2] = n2, l4.set(n2, e2)) : e2 = NaN), e2;
    }, i.prototype._getOrCreateMap = function() {
      return this._map || (this._map = ri(this.categories));
    }, i;
  }();
  function bdt(i) {
    return mi(i) && i.value != null ? i.value : i + "";
  }
  var yoe = ydt;
  function boe(i) {
    return i.type === "interval" || i.type === "log";
  }
  function _dt(i, n2, e2, o) {
    var l4 = {}, c4 = i[1] - i[0], h = l4.interval = KIe(c4 / n2, true);
    e2 != null && h < e2 && (h = l4.interval = e2), o != null && h > o && (h = l4.interval = o);
    var p4 = l4.intervalPrecision = G5e(h), g4 = l4.niceTickExtent = [df(Math.ceil(i[0] / h) * h, p4), df(Math.floor(i[1] / h) * h, p4)];
    return xdt(g4, i), l4;
  }
  function qre(i) {
    var n2 = Math.pow(10, zse(i)), e2 = i / n2;
    return e2 ? e2 === 2 ? e2 = 3 : e2 === 3 ? e2 = 5 : e2 *= 2 : e2 = 1, df(e2 * n2);
  }
  function G5e(i) {
    return z_(i) + 2;
  }
  function lSe(i, n2, e2) {
    i[n2] = Math.max(Math.min(i[n2], e2[1]), e2[0]);
  }
  function xdt(i, n2) {
    !isFinite(i[0]) && (i[0] = n2[0]), !isFinite(i[1]) && (i[1] = n2[1]), lSe(i, 0, n2), lSe(i, 1, n2), i[0] > i[1] && (i[0] = i[1]);
  }
  function G$(i, n2) {
    return i >= n2[0] && i <= n2[1];
  }
  function W$(i, n2) {
    return n2[1] === n2[0] ? 0.5 : (i - n2[0]) / (n2[1] - n2[0]);
  }
  function H$(i, n2) {
    return i * (n2[1] - n2[0]) + n2[0];
  }
  var W5e = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      o.type = "ordinal";
      var l4 = o.getSetting("ordinalMeta");
      return l4 || (l4 = new yoe({})), Mr(l4) && (l4 = new yoe({ categories: Er(l4, function(c4) {
        return mi(c4) ? c4.value : c4;
      }) })), o._ordinalMeta = l4, o._extent = o.getSetting("extent") || [0, l4.categories.length - 1], o;
    }
    return n2.prototype.parse = function(e2) {
      return xa(e2) ? this._ordinalMeta.getOrdinal(e2) : Math.round(e2);
    }, n2.prototype.contain = function(e2) {
      return e2 = this.parse(e2), G$(e2, this._extent) && this._ordinalMeta.categories[e2] != null;
    }, n2.prototype.normalize = function(e2) {
      return e2 = this._getTickNumber(this.parse(e2)), W$(e2, this._extent);
    }, n2.prototype.scale = function(e2) {
      return e2 = Math.round(H$(e2, this._extent)), this.getRawOrdinalNumber(e2);
    }, n2.prototype.getTicks = function() {
      for (var e2 = [], o = this._extent, l4 = o[0]; l4 <= o[1]; )
        e2.push({ value: l4 }), l4++;
      return e2;
    }, n2.prototype.getMinorTicks = function(e2) {
    }, n2.prototype.setSortInfo = function(e2) {
      if (e2 == null) {
        this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
        return;
      }
      for (var o = e2.ordinalNumbers, l4 = this._ordinalNumbersByTick = [], c4 = this._ticksByOrdinalNumber = [], h = 0, p4 = this._ordinalMeta.categories.length, g4 = Math.min(p4, o.length); h < g4; ++h) {
        var y4 = o[h];
        l4[h] = y4, c4[y4] = h;
      }
      for (var _ = 0; h < p4; ++h) {
        for (; c4[_] != null; )
          _++;
        l4.push(_), c4[_] = h;
      }
    }, n2.prototype._getTickNumber = function(e2) {
      var o = this._ticksByOrdinalNumber;
      return o && e2 >= 0 && e2 < o.length ? o[e2] : e2;
    }, n2.prototype.getRawOrdinalNumber = function(e2) {
      var o = this._ordinalNumbersByTick;
      return o && e2 >= 0 && e2 < o.length ? o[e2] : e2;
    }, n2.prototype.getLabel = function(e2) {
      if (!this.isBlank()) {
        var o = this.getRawOrdinalNumber(e2.value), l4 = this._ordinalMeta.categories[o];
        return l4 == null ? "" : l4 + "";
      }
    }, n2.prototype.count = function() {
      return this._extent[1] - this._extent[0] + 1;
    }, n2.prototype.unionExtentFromData = function(e2, o) {
      this.unionExtent(e2.getApproximateExtent(o));
    }, n2.prototype.isInExtentRange = function(e2) {
      return e2 = this._getTickNumber(e2), this._extent[0] <= e2 && this._extent[1] >= e2;
    }, n2.prototype.getOrdinalMeta = function() {
      return this._ordinalMeta;
    }, n2.prototype.calcNiceTicks = function() {
    }, n2.prototype.calcNiceExtent = function() {
    }, n2.type = "ordinal", n2;
  }(A2);
  A2.registerClass(W5e);
  var Cle = W5e, VI = df, H5e = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "interval", e2._interval = 0, e2._intervalPrecision = 2, e2;
    }
    return n2.prototype.parse = function(e2) {
      return e2;
    }, n2.prototype.contain = function(e2) {
      return G$(e2, this._extent);
    }, n2.prototype.normalize = function(e2) {
      return W$(e2, this._extent);
    }, n2.prototype.scale = function(e2) {
      return H$(e2, this._extent);
    }, n2.prototype.setExtent = function(e2, o) {
      var l4 = this._extent;
      isNaN(e2) || (l4[0] = parseFloat(e2)), isNaN(o) || (l4[1] = parseFloat(o));
    }, n2.prototype.unionExtent = function(e2) {
      var o = this._extent;
      e2[0] < o[0] && (o[0] = e2[0]), e2[1] > o[1] && (o[1] = e2[1]), this.setExtent(o[0], o[1]);
    }, n2.prototype.getInterval = function() {
      return this._interval;
    }, n2.prototype.setInterval = function(e2) {
      this._interval = e2, this._niceExtent = this._extent.slice(), this._intervalPrecision = G5e(e2);
    }, n2.prototype.getTicks = function(e2) {
      var o = this._interval, l4 = this._extent, c4 = this._niceExtent, h = this._intervalPrecision, p4 = [];
      if (!o)
        return p4;
      var g4 = 1e4;
      l4[0] < c4[0] && (e2 ? p4.push({ value: VI(c4[0] - o, h) }) : p4.push({ value: l4[0] }));
      for (var y4 = c4[0]; y4 <= c4[1] && (p4.push({ value: y4 }), y4 = VI(y4 + o, h), y4 !== p4[p4.length - 1].value); )
        if (p4.length > g4)
          return [];
      var _ = p4.length ? p4[p4.length - 1].value : c4[1];
      return l4[1] > _ && (e2 ? p4.push({ value: VI(_ + o, h) }) : p4.push({ value: l4[1] })), p4;
    }, n2.prototype.getMinorTicks = function(e2) {
      for (var o = this.getTicks(true), l4 = [], c4 = this.getExtent(), h = 1; h < o.length; h++) {
        for (var p4 = o[h], g4 = o[h - 1], y4 = 0, _ = [], w4 = p4.value - g4.value, C = w4 / e2; y4 < e2 - 1; ) {
          var E = VI(g4.value + (y4 + 1) * C);
          E > c4[0] && E < c4[1] && _.push(E), y4++;
        }
        l4.push(_);
      }
      return l4;
    }, n2.prototype.getLabel = function(e2, o) {
      if (e2 == null)
        return "";
      var l4 = o && o.precision;
      l4 == null ? l4 = z_(e2.value) || 0 : l4 === "auto" && (l4 = this._intervalPrecision);
      var c4 = VI(e2.value, l4, true);
      return yDe(c4);
    }, n2.prototype.calcNiceTicks = function(e2, o, l4) {
      e2 = e2 || 5;
      var c4 = this._extent, h = c4[1] - c4[0];
      if (!!isFinite(h)) {
        h < 0 && (h = -h, c4.reverse());
        var p4 = _dt(c4, e2, o, l4);
        this._intervalPrecision = p4.intervalPrecision, this._interval = p4.interval, this._niceExtent = p4.niceTickExtent;
      }
    }, n2.prototype.calcNiceExtent = function(e2) {
      var o = this._extent;
      if (o[0] === o[1])
        if (o[0] !== 0) {
          var l4 = o[0];
          e2.fixMax || (o[1] += l4 / 2), o[0] -= l4 / 2;
        } else
          o[1] = 1;
      var c4 = o[1] - o[0];
      isFinite(c4) || (o[0] = 0, o[1] = 1), this.calcNiceTicks(e2.splitNumber, e2.minInterval, e2.maxInterval);
      var h = this._interval;
      e2.fixMin || (o[0] = VI(Math.floor(o[0] / h) * h)), e2.fixMax || (o[1] = VI(Math.ceil(o[1] / h) * h));
    }, n2.prototype.setNiceExtent = function(e2, o) {
      this._niceExtent = [e2, o];
    }, n2.type = "interval", n2;
  }(A2);
  A2.registerClass(H5e);
  var tM = H5e, $5e = typeof Float32Array != "undefined", wdt = $5e ? Float32Array : Array;
  function j_(i) {
    return Mr(i) ? $5e ? new Float32Array(i) : i : new wdt(i);
  }
  var _oe = "__ec_stack_";
  function Mle(i) {
    return i.get("stack") || _oe + i.seriesIndex;
  }
  function Ale(i) {
    return i.dim + i.index;
  }
  function Sdt(i) {
    var n2 = [], e2 = i.axis, o = "axis0";
    if (e2.type === "category") {
      for (var l4 = e2.getBandWidth(), c4 = 0; c4 < i.count; c4++)
        n2.push(hi({ bandWidth: l4, axisKey: o, stackId: _oe + c4 }, i));
      for (var h = Y5e(n2), p4 = [], c4 = 0; c4 < i.count; c4++) {
        var g4 = h[o][_oe + c4];
        g4.offsetCenter = g4.offset + g4.width / 2, p4.push(g4);
      }
      return p4;
    }
  }
  function U5e(i, n2) {
    var e2 = [];
    return n2.eachSeriesByType(i, function(o) {
      K5e(o) && e2.push(o);
    }), e2;
  }
  function Cdt(i) {
    var n2 = {};
    Ve(i, function(g4) {
      var y4 = g4.coordinateSystem, _ = y4.getBaseAxis();
      if (!(_.type !== "time" && _.type !== "value"))
        for (var w4 = g4.getData(), C = _.dim + "_" + _.index, E = w4.getDimensionIndex(w4.mapDimension(_.dim)), T = w4.getStore(), O = 0, N = T.count(); O < N; ++O) {
          var V = T.get(E, O);
          n2[C] ? n2[C].push(V) : n2[C] = [V];
        }
    });
    var e2 = {};
    for (var o in n2)
      if (n2.hasOwnProperty(o)) {
        var l4 = n2[o];
        if (l4) {
          l4.sort(function(g4, y4) {
            return g4 - y4;
          });
          for (var c4 = null, h = 1; h < l4.length; ++h) {
            var p4 = l4[h] - l4[h - 1];
            p4 > 0 && (c4 = c4 === null ? p4 : Math.min(c4, p4));
          }
          e2[o] = c4;
        }
      }
    return e2;
  }
  function q5e(i) {
    var n2 = Cdt(i), e2 = [];
    return Ve(i, function(o) {
      var l4 = o.coordinateSystem, c4 = l4.getBaseAxis(), h = c4.getExtent(), p4;
      if (c4.type === "category")
        p4 = c4.getBandWidth();
      else if (c4.type === "value" || c4.type === "time") {
        var g4 = c4.dim + "_" + c4.index, y4 = n2[g4], _ = Math.abs(h[1] - h[0]), w4 = c4.scale.getExtent(), C = Math.abs(w4[1] - w4[0]);
        p4 = y4 ? _ / C * y4 : _;
      } else {
        var E = o.getData();
        p4 = Math.abs(h[1] - h[0]) / E.count();
      }
      var T = ma(o.get("barWidth"), p4), O = ma(o.get("barMaxWidth"), p4), N = ma(o.get("barMinWidth") || (J5e(o) ? 0.5 : 1), p4), V = o.get("barGap"), H = o.get("barCategoryGap");
      e2.push({ bandWidth: p4, barWidth: T, barMaxWidth: O, barMinWidth: N, barGap: V, barCategoryGap: H, axisKey: Ale(c4), stackId: Mle(o) });
    }), Y5e(e2);
  }
  function Y5e(i) {
    var n2 = {};
    Ve(i, function(o, l4) {
      var c4 = o.axisKey, h = o.bandWidth, p4 = n2[c4] || { bandWidth: h, remainedWidth: h, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, g4 = p4.stacks;
      n2[c4] = p4;
      var y4 = o.stackId;
      g4[y4] || p4.autoWidthCount++, g4[y4] = g4[y4] || { width: 0, maxWidth: 0 };
      var _ = o.barWidth;
      _ && !g4[y4].width && (g4[y4].width = _, _ = Math.min(p4.remainedWidth, _), p4.remainedWidth -= _);
      var w4 = o.barMaxWidth;
      w4 && (g4[y4].maxWidth = w4);
      var C = o.barMinWidth;
      C && (g4[y4].minWidth = C);
      var E = o.barGap;
      E != null && (p4.gap = E);
      var T = o.barCategoryGap;
      T != null && (p4.categoryGap = T);
    });
    var e2 = {};
    return Ve(n2, function(o, l4) {
      e2[l4] = {};
      var c4 = o.stacks, h = o.bandWidth, p4 = o.categoryGap;
      if (p4 == null) {
        var g4 = ts(c4).length;
        p4 = Math.max(35 - g4 * 4, 15) + "%";
      }
      var y4 = ma(p4, h), _ = ma(o.gap, 1), w4 = o.remainedWidth, C = o.autoWidthCount, E = (w4 - y4) / (C + (C - 1) * _);
      E = Math.max(E, 0), Ve(c4, function(V) {
        var H = V.maxWidth, X = V.minWidth;
        if (V.width) {
          var q2 = V.width;
          H && (q2 = Math.min(q2, H)), X && (q2 = Math.max(q2, X)), V.width = q2, w4 -= q2 + _ * q2, C--;
        } else {
          var q2 = E;
          H && H < q2 && (q2 = Math.min(H, w4)), X && X > q2 && (q2 = X), q2 !== E && (V.width = q2, w4 -= q2 + _ * q2, C--);
        }
      }), E = (w4 - y4) / (C + (C - 1) * _), E = Math.max(E, 0);
      var T = 0, O;
      Ve(c4, function(V, H) {
        V.width || (V.width = E), O = V, T += V.width * (1 + _);
      }), O && (T -= O.width * _);
      var N = -T / 2;
      Ve(c4, function(V, H) {
        e2[l4][H] = e2[l4][H] || { bandWidth: h, offset: N, width: V.width }, N += V.width * (1 + _);
      });
    }), e2;
  }
  function Mdt(i, n2, e2) {
    if (i && n2) {
      var o = i[Ale(n2)];
      return o != null && e2 != null ? o[Mle(e2)] : o;
    }
  }
  function Z5e(i, n2) {
    var e2 = U5e(i, n2), o = q5e(e2);
    Ve(e2, function(l4) {
      var c4 = l4.getData(), h = l4.coordinateSystem, p4 = h.getBaseAxis(), g4 = Mle(l4), y4 = o[Ale(p4)][g4], _ = y4.offset, w4 = y4.width;
      c4.setLayout({ bandWidth: y4.bandWidth, offset: _, size: w4 });
    });
  }
  function X5e(i) {
    return { seriesType: i, plan: eL(), reset: function(n2) {
      if (!!K5e(n2)) {
        var e2 = n2.getData(), o = n2.coordinateSystem, l4 = o.getBaseAxis(), c4 = o.getOtherAxis(l4), h = e2.getDimensionIndex(e2.mapDimension(c4.dim)), p4 = e2.getDimensionIndex(e2.mapDimension(l4.dim)), g4 = n2.get("showBackground", true), y4 = e2.mapDimension(c4.dim), _ = e2.getCalculationInfo("stackResultDimension"), w4 = eM(e2, y4) && !!e2.getCalculationInfo("stackedOnSeries"), C = c4.isHorizontal(), E = Adt(l4, c4), T = J5e(n2), O = n2.get("barMinHeight") || 0, N = _ && e2.getDimensionIndex(_), V = e2.getLayout("size"), H = e2.getLayout("offset");
        return { progress: function(X, q2) {
          for (var de = X.count, le = T && j_(de * 3), me = T && g4 && j_(de * 3), ye = T && j_(de), be = o.master.getRect(), we = C ? be.width : be.height, Pe, ze = q2.getStore(), Re = 0; (Pe = X.next()) != null; ) {
            var rt2 = ze.get(w4 ? N : h, Pe), ft = ze.get(p4, Pe), et = E, Jt = void 0;
            w4 && (Jt = +rt2 - ze.get(h, Pe));
            var xt = void 0, It = void 0, Wt = void 0, sn = void 0;
            if (C) {
              var vn = o.dataToPoint([rt2, ft]);
              if (w4) {
                var $r = o.dataToPoint([Jt, ft]);
                et = $r[0];
              }
              xt = et, It = vn[1] + H, Wt = vn[0] - et, sn = V, Math.abs(Wt) < O && (Wt = (Wt < 0 ? -1 : 1) * O);
            } else {
              var vn = o.dataToPoint([ft, rt2]);
              if (w4) {
                var $r = o.dataToPoint([ft, Jt]);
                et = $r[1];
              }
              xt = vn[0] + H, It = et, Wt = V, sn = vn[1] - et, Math.abs(sn) < O && (sn = (sn <= 0 ? -1 : 1) * O);
            }
            T ? (le[Re] = xt, le[Re + 1] = It, le[Re + 2] = C ? Wt : sn, me && (me[Re] = C ? be.x : xt, me[Re + 1] = C ? It : be.y, me[Re + 2] = we), ye[Pe] = Pe) : q2.setItemLayout(Pe, { x: xt, y: It, width: Wt, height: sn }), Re += 3;
          }
          T && q2.setLayout({ largePoints: le, largeDataIndices: ye, largeBackgroundPoints: me, valueAxisHorizontal: C });
        } };
      }
    } };
  }
  function K5e(i) {
    return i.coordinateSystem && i.coordinateSystem.type === "cartesian2d";
  }
  function J5e(i) {
    return i.pipelineContext && i.pipelineContext.large;
  }
  function Adt(i, n2) {
    return n2.toGlobalCoord(n2.dataToCoord(n2.type === "log" ? 1 : 0));
  }
  var Edt = function(i, n2, e2, o) {
    for (; e2 < o; ) {
      var l4 = e2 + o >>> 1;
      i[l4][1] < n2 ? e2 = l4 + 1 : o = l4;
    }
    return e2;
  }, Q5e = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "time", o;
    }
    return n2.prototype.getLabel = function(e2) {
      var o = this.getSetting("useUTC");
      return P$(e2.value, Jwe[Yut(I3(this._minLevelUnit))] || Jwe.second, o, this.getSetting("locale"));
    }, n2.prototype.getFormattedLabel = function(e2, o, l4) {
      var c4 = this.getSetting("useUTC"), h = this.getSetting("locale");
      return Zut(e2, o, l4, h, c4);
    }, n2.prototype.getTicks = function() {
      var e2 = this._interval, o = this._extent, l4 = [];
      if (!e2)
        return l4;
      l4.push({ value: o[0], level: 0 });
      var c4 = this.getSetting("useUTC"), h = Odt(this._minLevelUnit, this._approxInterval, c4, o);
      return l4 = l4.concat(h), l4.push({ value: o[1], level: 0 }), l4;
    }, n2.prototype.calcNiceExtent = function(e2) {
      var o = this._extent;
      if (o[0] === o[1] && (o[0] -= Py, o[1] += Py), o[1] === -1 / 0 && o[0] === 1 / 0) {
        var l4 = new Date();
        o[1] = +new Date(l4.getFullYear(), l4.getMonth(), l4.getDate()), o[0] = o[1] - Py;
      }
      this.calcNiceTicks(e2.splitNumber, e2.minInterval, e2.maxInterval);
    }, n2.prototype.calcNiceTicks = function(e2, o, l4) {
      e2 = e2 || 10;
      var c4 = this._extent, h = c4[1] - c4[0];
      this._approxInterval = h / e2, o != null && this._approxInterval < o && (this._approxInterval = o), l4 != null && this._approxInterval > l4 && (this._approxInterval = l4);
      var p4 = pW.length, g4 = Math.min(Edt(pW, this._approxInterval, 0, p4), p4 - 1);
      this._interval = pW[g4][1], this._minLevelUnit = pW[Math.max(g4 - 1, 0)][0];
    }, n2.prototype.parse = function(e2) {
      return sl(e2) ? e2 : +X_(e2);
    }, n2.prototype.contain = function(e2) {
      return G$(this.parse(e2), this._extent);
    }, n2.prototype.normalize = function(e2) {
      return W$(this.parse(e2), this._extent);
    }, n2.prototype.scale = function(e2) {
      return H$(e2, this._extent);
    }, n2.type = "time", n2;
  }(tM), pW = [["second", nle], ["minute", rle], ["hour", qN], ["quarter-day", qN * 6], ["half-day", qN * 12], ["day", Py * 1.2], ["half-week", Py * 3.5], ["week", Py * 7], ["month", Py * 31], ["quarter", Py * 95], ["half-year", Kwe / 2], ["year", Kwe]];
  function Idt(i, n2, e2, o) {
    var l4 = X_(n2), c4 = X_(e2), h = function(T) {
      return Qwe(l4, T, o) === Qwe(c4, T, o);
    }, p4 = function() {
      return h("year");
    }, g4 = function() {
      return p4() && h("month");
    }, y4 = function() {
      return g4() && h("day");
    }, _ = function() {
      return y4() && h("hour");
    }, w4 = function() {
      return _() && h("minute");
    }, C = function() {
      return w4() && h("second");
    }, E = function() {
      return C() && h("millisecond");
    };
    switch (i) {
      case "year":
        return p4();
      case "month":
        return g4();
      case "day":
        return y4();
      case "hour":
        return _();
      case "minute":
        return w4();
      case "second":
        return C();
      case "millisecond":
        return E();
    }
  }
  function Tdt(i, n2) {
    return i /= Py, i > 16 ? 16 : i > 7.5 ? 7 : i > 3.5 ? 4 : i > 1.5 ? 2 : 1;
  }
  function Ddt(i) {
    var n2 = 30 * Py;
    return i /= n2, i > 6 ? 6 : i > 3 ? 3 : i > 2 ? 2 : 1;
  }
  function kdt(i) {
    return i /= qN, i > 12 ? 12 : i > 6 ? 6 : i > 3.5 ? 4 : i > 2 ? 2 : 1;
  }
  function uSe(i, n2) {
    return i /= n2 ? rle : nle, i > 30 ? 30 : i > 20 ? 20 : i > 15 ? 15 : i > 10 ? 10 : i > 5 ? 5 : i > 2 ? 2 : 1;
  }
  function Pdt(i) {
    return KIe(i, true);
  }
  function Ldt(i, n2, e2) {
    var o = new Date(i);
    switch (I3(n2)) {
      case "year":
      case "month":
        o[hDe(e2)](0);
      case "day":
        o[dDe(e2)](1);
      case "hour":
        o[pDe(e2)](0);
      case "minute":
        o[vDe(e2)](0);
      case "second":
        o[gDe(e2)](0), o[mDe(e2)](0);
    }
    return o.getTime();
  }
  function Odt(i, n2, e2, o) {
    var l4 = 1e4, c4 = cDe, h = 0;
    function p4(we, Pe, ze, Re, rt2, ft, et) {
      for (var Jt = new Date(Pe), xt = Pe, It = Jt[Re](); xt < ze && xt <= o[1]; )
        et.push({ value: xt }), It += we, Jt[rt2](It), xt = Jt.getTime();
      et.push({ value: xt, notAdd: true });
    }
    function g4(we, Pe, ze) {
      var Re = [], rt2 = !Pe.length;
      if (!Idt(I3(we), o[0], o[1], e2)) {
        rt2 && (Pe = [{ value: Ldt(new Date(o[0]), we, e2) }, { value: o[1] }]);
        for (var ft = 0; ft < Pe.length - 1; ft++) {
          var et = Pe[ft].value, Jt = Pe[ft + 1].value;
          if (et !== Jt) {
            var xt = void 0, It = void 0, Wt = void 0, sn = false;
            switch (we) {
              case "year":
                xt = Math.max(1, Math.round(n2 / Py / 365)), It = ale(e2), Wt = Xut(e2);
                break;
              case "half-year":
              case "quarter":
              case "month":
                xt = Ddt(n2), It = T3(e2), Wt = hDe(e2);
                break;
              case "week":
              case "half-week":
              case "day":
                xt = Tdt(n2), It = L$(e2), Wt = dDe(e2), sn = true;
                break;
              case "half-day":
              case "quarter-day":
              case "hour":
                xt = kdt(n2), It = p8(e2), Wt = pDe(e2);
                break;
              case "minute":
                xt = uSe(n2, true), It = O$(e2), Wt = vDe(e2);
                break;
              case "second":
                xt = uSe(n2, false), It = R$(e2), Wt = gDe(e2);
                break;
              case "millisecond":
                xt = Pdt(n2), It = F$(e2), Wt = mDe(e2);
                break;
            }
            p4(xt, et, Jt, It, Wt, sn, Re), we === "year" && ze.length > 1 && ft === 0 && ze.unshift({ value: ze[0].value - xt });
          }
        }
        for (var ft = 0; ft < Re.length; ft++)
          ze.push(Re[ft]);
        return Re;
      }
    }
    for (var y4 = [], _ = [], w4 = 0, C = 0, E = 0; E < c4.length && h++ < l4; ++E) {
      var T = I3(c4[E]);
      if (!!qut(c4[E])) {
        g4(c4[E], y4[y4.length - 1] || [], _);
        var O = c4[E + 1] ? I3(c4[E + 1]) : null;
        if (T !== O) {
          if (_.length) {
            C = w4, _.sort(function(we, Pe) {
              return we.value - Pe.value;
            });
            for (var N = [], V = 0; V < _.length; ++V) {
              var H = _[V].value;
              (V === 0 || _[V - 1].value !== H) && (N.push(_[V]), H >= o[0] && H <= o[1] && w4++);
            }
            var X = (o[1] - o[0]) / n2;
            if (w4 > X * 1.5 && C > X / 1.5 || (y4.push(N), w4 > X || i === c4[E]))
              break;
          }
          _ = [];
        }
      }
    }
    for (var q2 = Yl(Er(y4, function(we) {
      return Yl(we, function(Pe) {
        return Pe.value >= o[0] && Pe.value <= o[1] && !Pe.notAdd;
      });
    }), function(we) {
      return we.length > 0;
    }), de = [], le = q2.length - 1, E = 0; E < q2.length; ++E)
      for (var me = q2[E], ye = 0; ye < me.length; ++ye)
        de.push({ value: me[ye].value, level: le - E });
    de.sort(function(we, Pe) {
      return we.value - Pe.value;
    });
    for (var be = [], E = 0; E < de.length; ++E)
      (E === 0 || de[E].value !== de[E - 1].value) && be.push(de[E]);
    return be;
  }
  A2.registerClass(Q5e);
  var eke = Q5e, cSe = A2.prototype, KN = tM.prototype, Rdt = df, Fdt = Math.floor, Ndt = Math.ceil, vW = Math.pow, yy = Math.log, Ele = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "log", e2.base = 10, e2._originalScale = new tM(), e2._interval = 0, e2;
    }
    return n2.prototype.getTicks = function(e2) {
      var o = this._originalScale, l4 = this._extent, c4 = o.getExtent(), h = KN.getTicks.call(this, e2);
      return Er(h, function(p4) {
        var g4 = p4.value, y4 = df(vW(this.base, g4));
        return y4 = g4 === l4[0] && this._fixMin ? gW(y4, c4[0]) : y4, y4 = g4 === l4[1] && this._fixMax ? gW(y4, c4[1]) : y4, { value: y4 };
      }, this);
    }, n2.prototype.setExtent = function(e2, o) {
      var l4 = this.base;
      e2 = yy(e2) / yy(l4), o = yy(o) / yy(l4), KN.setExtent.call(this, e2, o);
    }, n2.prototype.getExtent = function() {
      var e2 = this.base, o = cSe.getExtent.call(this);
      o[0] = vW(e2, o[0]), o[1] = vW(e2, o[1]);
      var l4 = this._originalScale, c4 = l4.getExtent();
      return this._fixMin && (o[0] = gW(o[0], c4[0])), this._fixMax && (o[1] = gW(o[1], c4[1])), o;
    }, n2.prototype.unionExtent = function(e2) {
      this._originalScale.unionExtent(e2);
      var o = this.base;
      e2[0] = yy(e2[0]) / yy(o), e2[1] = yy(e2[1]) / yy(o), cSe.unionExtent.call(this, e2);
    }, n2.prototype.unionExtentFromData = function(e2, o) {
      this.unionExtent(e2.getApproximateExtent(o));
    }, n2.prototype.calcNiceTicks = function(e2) {
      e2 = e2 || 10;
      var o = this._extent, l4 = o[1] - o[0];
      if (!(l4 === 1 / 0 || l4 <= 0)) {
        var c4 = vst(l4), h = e2 / l4 * c4;
        for (h <= 0.5 && (c4 *= 10); !isNaN(c4) && Math.abs(c4) < 1 && Math.abs(c4) > 0; )
          c4 *= 10;
        var p4 = [df(Ndt(o[0] / c4) * c4), df(Fdt(o[1] / c4) * c4)];
        this._interval = c4, this._niceExtent = p4;
      }
    }, n2.prototype.calcNiceExtent = function(e2) {
      KN.calcNiceExtent.call(this, e2), this._fixMin = e2.fixMin, this._fixMax = e2.fixMax;
    }, n2.prototype.parse = function(e2) {
      return e2;
    }, n2.prototype.contain = function(e2) {
      return e2 = yy(e2) / yy(this.base), G$(e2, this._extent);
    }, n2.prototype.normalize = function(e2) {
      return e2 = yy(e2) / yy(this.base), W$(e2, this._extent);
    }, n2.prototype.scale = function(e2) {
      return e2 = H$(e2, this._extent), vW(this.base, e2);
    }, n2.type = "log", n2;
  }(A2), tke = Ele.prototype;
  tke.getMinorTicks = KN.getMinorTicks;
  tke.getLabel = KN.getLabel;
  function gW(i, n2) {
    return Rdt(i, z_(n2));
  }
  A2.registerClass(Ele);
  var Vdt = Ele, zdt = function() {
    function i(n2, e2, o) {
      this._prepareParams(n2, e2, o);
    }
    return i.prototype._prepareParams = function(n2, e2, o) {
      o[1] < o[0] && (o = [NaN, NaN]), this._dataMin = o[0], this._dataMax = o[1];
      var l4 = this._isOrdinal = n2.type === "ordinal";
      this._needCrossZero = n2.type === "interval" && e2.getNeedCrossZero && e2.getNeedCrossZero();
      var c4 = this._modelMinRaw = e2.get("min", true);
      si(c4) ? this._modelMinNum = mW(n2, c4({ min: o[0], max: o[1] })) : c4 !== "dataMin" && (this._modelMinNum = mW(n2, c4));
      var h = this._modelMaxRaw = e2.get("max", true);
      if (si(h) ? this._modelMaxNum = mW(n2, h({ min: o[0], max: o[1] })) : h !== "dataMax" && (this._modelMaxNum = mW(n2, h)), l4)
        this._axisDataLen = e2.getCategories().length;
      else {
        var p4 = e2.get("boundaryGap"), g4 = Mr(p4) ? p4 : [p4 || 0, p4 || 0];
        typeof g4[0] == "boolean" || typeof g4[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [ib(g4[0], 1), ib(g4[1], 1)];
      }
    }, i.prototype.calculate = function() {
      var n2 = this._isOrdinal, e2 = this._dataMin, o = this._dataMax, l4 = this._axisDataLen, c4 = this._boundaryGapInner, h = n2 ? null : o - e2 || Math.abs(e2), p4 = this._modelMinRaw === "dataMin" ? e2 : this._modelMinNum, g4 = this._modelMaxRaw === "dataMax" ? o : this._modelMaxNum, y4 = p4 != null, _ = g4 != null;
      p4 == null && (p4 = n2 ? l4 ? 0 : NaN : e2 - c4[0] * h), g4 == null && (g4 = n2 ? l4 ? l4 - 1 : NaN : o + c4[1] * h), (p4 == null || !isFinite(p4)) && (p4 = NaN), (g4 == null || !isFinite(g4)) && (g4 = NaN);
      var w4 = i8(p4) || i8(g4) || n2 && !l4;
      this._needCrossZero && (p4 > 0 && g4 > 0 && !y4 && (p4 = 0), p4 < 0 && g4 < 0 && !_ && (g4 = 0));
      var C = this._determinedMin, E = this._determinedMax;
      return C != null && (p4 = C, y4 = true), E != null && (g4 = E, _ = true), { min: p4, max: g4, minFixed: y4, maxFixed: _, isBlank: w4 };
    }, i.prototype.modifyDataMinMax = function(n2, e2) {
      this[jdt[n2]] = e2;
    }, i.prototype.setDeterminedMinMax = function(n2, e2) {
      var o = Bdt[n2];
      this[o] = e2;
    }, i.prototype.freeze = function() {
      this.frozen = true;
    }, i;
  }(), Bdt = { min: "_determinedMin", max: "_determinedMax" }, jdt = { min: "_dataMin", max: "_dataMax" };
  function nke(i, n2, e2) {
    var o = i.rawExtentInfo;
    return o || (o = new zdt(i, n2, e2), i.rawExtentInfo = o, o);
  }
  function mW(i, n2) {
    return n2 == null ? null : i8(n2) ? NaN : i.parse(n2);
  }
  function rke(i, n2) {
    var e2 = i.type, o = nke(i, n2, i.getExtent()).calculate();
    i.setBlank(o.isBlank);
    var l4 = o.min, c4 = o.max, h = n2.ecModel;
    if (h && e2 === "time") {
      var p4 = U5e("bar", h), g4 = false;
      if (Ve(p4, function(w4) {
        g4 = g4 || w4.getBaseAxis() === n2.axis;
      }), g4) {
        var y4 = q5e(p4), _ = Gdt(l4, c4, n2, y4);
        l4 = _.min, c4 = _.max;
      }
    }
    return { extent: [l4, c4], fixMin: o.minFixed, fixMax: o.maxFixed };
  }
  function Gdt(i, n2, e2, o) {
    var l4 = e2.axis.getExtent(), c4 = l4[1] - l4[0], h = Mdt(o, e2.axis);
    if (h === void 0)
      return { min: i, max: n2 };
    var p4 = 1 / 0;
    Ve(h, function(E) {
      p4 = Math.min(E.offset, p4);
    });
    var g4 = -1 / 0;
    Ve(h, function(E) {
      g4 = Math.max(E.offset + E.width, g4);
    }), p4 = Math.abs(p4), g4 = Math.abs(g4);
    var y4 = p4 + g4, _ = n2 - i, w4 = 1 - (p4 + g4) / c4, C = _ / w4 - _;
    return n2 += C * (g4 / y4), i -= C * (p4 / y4), { min: i, max: n2 };
  }
  function F3(i, n2) {
    var e2 = n2, o = rke(i, e2), l4 = o.extent, c4 = e2.get("splitNumber");
    i instanceof Vdt && (i.base = e2.get("logBase"));
    var h = i.type, p4 = e2.get("interval"), g4 = h === "interval" || h === "time";
    i.setExtent(l4[0], l4[1]), i.calcNiceExtent({ splitNumber: c4, fixMin: o.fixMin, fixMax: o.fixMax, minInterval: g4 ? e2.get("minInterval") : null, maxInterval: g4 ? e2.get("maxInterval") : null }), p4 != null && i.setInterval && i.setInterval(p4);
  }
  function $$(i, n2) {
    if (n2 = n2 || i.get("type"), n2)
      switch (n2) {
        case "category":
          return new Cle({ ordinalMeta: i.getOrdinalMeta ? i.getOrdinalMeta() : i.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new eke({ locale: i.ecModel.getLocaleModel(), useUTC: i.ecModel.get("useUTC") });
        default:
          return new (A2.getClass(n2) || tM)();
      }
  }
  function Wdt(i) {
    var n2 = i.scale.getExtent(), e2 = n2[0], o = n2[1];
    return !(e2 > 0 && o > 0 || e2 < 0 && o < 0);
  }
  function Y8(i) {
    var n2 = i.getLabelModel().get("formatter"), e2 = i.type === "category" ? i.scale.getExtent()[0] : null;
    return i.scale.type === "time" ? function(o) {
      return function(l4, c4) {
        return i.scale.getFormattedLabel(l4, c4, o);
      };
    }(n2) : xa(n2) ? function(o) {
      return function(l4) {
        var c4 = i.scale.getLabel(l4), h = o.replace("{value}", c4 != null ? c4 : "");
        return h;
      };
    }(n2) : si(n2) ? function(o) {
      return function(l4, c4) {
        return e2 != null && (c4 = l4.value - e2), o(Ile(i, l4), c4, l4.level != null ? { level: l4.level } : null);
      };
    }(n2) : function(o) {
      return i.scale.getLabel(o);
    };
  }
  function Ile(i, n2) {
    return i.type === "category" ? i.scale.getLabel(n2) : n2.value;
  }
  function Hdt(i) {
    var n2 = i.model, e2 = i.scale;
    if (!(!n2.get(["axisLabel", "show"]) || e2.isBlank())) {
      var o, l4, c4 = e2.getExtent();
      e2 instanceof Cle ? l4 = e2.count() : (o = e2.getTicks(), l4 = o.length);
      var h = i.getLabelModel(), p4 = Y8(i), g4, y4 = 1;
      l4 > 40 && (y4 = Math.ceil(l4 / 40));
      for (var _ = 0; _ < l4; _ += y4) {
        var w4 = o ? o[_] : { value: c4[0] + _ }, C = p4(w4, _), E = h.getTextRect(C), T = $dt(E, h.get("rotate") || 0);
        g4 ? g4.union(T) : g4 = T;
      }
      return g4;
    }
  }
  function $dt(i, n2) {
    var e2 = n2 * Math.PI / 180, o = i.width, l4 = i.height, c4 = o * Math.abs(Math.cos(e2)) + Math.abs(l4 * Math.sin(e2)), h = o * Math.abs(Math.sin(e2)) + Math.abs(l4 * Math.cos(e2)), p4 = new mo(i.x, i.y, c4, h);
    return p4;
  }
  function Tle(i) {
    var n2 = i.get("interval");
    return n2 == null ? "auto" : n2;
  }
  function ake(i) {
    return i.type === "category" && Tle(i.getLabelModel()) === 0;
  }
  function jH(i, n2) {
    var e2 = {};
    return Ve(i.mapDimensionsAll(n2), function(o) {
      e2[B5e(i, o)] = true;
    }), ts(e2);
  }
  function Udt(i, n2, e2) {
    n2 && Ve(jH(n2, e2), function(o) {
      var l4 = n2.getApproximateExtent(o);
      l4[0] < i[0] && (i[0] = l4[0]), l4[1] > i[1] && (i[1] = l4[1]);
    });
  }
  var Z8 = function() {
    function i() {
    }
    return i.prototype.getNeedCrossZero = function() {
      var n2 = this.option;
      return !n2.scale;
    }, i.prototype.getCoordSysModel = function() {
    }, i;
  }(), qdt = 1e-8;
  function fSe(i, n2) {
    return Math.abs(i - n2) < qdt;
  }
  function JI(i, n2, e2) {
    var o = 0, l4 = i[0];
    if (!l4)
      return false;
    for (var c4 = 1; c4 < i.length; c4++) {
      var h = i[c4];
      o += l2(l4[0], l4[1], h[0], h[1], n2, e2), l4 = h;
    }
    var p4 = i[0];
    return (!fSe(l4[0], p4[0]) || !fSe(l4[1], p4[1])) && (o += l2(l4[0], l4[1], p4[0], p4[1], n2, e2)), o !== 0;
  }
  var Ydt = [];
  function Yre(i, n2) {
    for (var e2 = 0; e2 < i.length; e2++)
      Sp(i[e2], i[e2], n2);
  }
  function hSe(i, n2, e2, o) {
    for (var l4 = 0; l4 < i.length; l4++) {
      var c4 = i[l4];
      o && (c4 = o.project(c4)), c4 && isFinite(c4[0]) && isFinite(c4[1]) && (FC(n2, n2, c4), NC(e2, e2, c4));
    }
  }
  function Zdt(i) {
    for (var n2 = 0, e2 = 0, o = 0, l4 = i.length, c4 = i[l4 - 1][0], h = i[l4 - 1][1], p4 = 0; p4 < l4; p4++) {
      var g4 = i[p4][0], y4 = i[p4][1], _ = c4 * y4 - g4 * h;
      n2 += _, e2 += (c4 + g4) * _, o += (h + y4) * _, c4 = g4, h = y4;
    }
    return n2 ? [e2 / n2 / 3, o / n2 / 3, n2] : [i[0][0] || 0, i[0][1] || 0];
  }
  var ike = function() {
    function i(n2) {
      this.name = n2;
    }
    return i.prototype.setCenter = function(n2) {
      this._center = n2;
    }, i.prototype.getCenter = function() {
      var n2 = this._center;
      return n2 || (n2 = this._center = this.calcCenter()), n2;
    }, i;
  }(), dSe = function() {
    function i(n2, e2) {
      this.type = "polygon", this.exterior = n2, this.interiors = e2;
    }
    return i;
  }(), pSe = function() {
    function i(n2) {
      this.type = "linestring", this.points = n2;
    }
    return i;
  }(), oke = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this, e2) || this;
      return c4.type = "geoJSON", c4.geometries = o, c4._center = l4 && [l4[0], l4[1]], c4;
    }
    return n2.prototype.calcCenter = function() {
      for (var e2 = this.geometries, o, l4 = 0, c4 = 0; c4 < e2.length; c4++) {
        var h = e2[c4], p4 = h.exterior, g4 = p4 && p4.length;
        g4 > l4 && (o = h, l4 = g4);
      }
      if (o)
        return Zdt(o.exterior);
      var y4 = this.getBoundingRect();
      return [y4.x + y4.width / 2, y4.y + y4.height / 2];
    }, n2.prototype.getBoundingRect = function(e2) {
      var o = this._rect;
      if (o && !e2)
        return o;
      var l4 = [1 / 0, 1 / 0], c4 = [-1 / 0, -1 / 0], h = this.geometries;
      return Ve(h, function(p4) {
        p4.type === "polygon" ? hSe(p4.exterior, l4, c4, e2) : Ve(p4.points, function(g4) {
          hSe(g4, l4, c4, e2);
        });
      }), isFinite(l4[0]) && isFinite(l4[1]) && isFinite(c4[0]) && isFinite(c4[1]) || (l4[0] = l4[1] = c4[0] = c4[1] = 0), o = new mo(l4[0], l4[1], c4[0] - l4[0], c4[1] - l4[1]), e2 || (this._rect = o), o;
    }, n2.prototype.contain = function(e2) {
      var o = this.getBoundingRect(), l4 = this.geometries;
      if (!o.contain(e2[0], e2[1]))
        return false;
      e:
        for (var c4 = 0, h = l4.length; c4 < h; c4++) {
          var p4 = l4[c4];
          if (p4.type === "polygon") {
            var g4 = p4.exterior, y4 = p4.interiors;
            if (JI(g4, e2[0], e2[1])) {
              for (var _ = 0; _ < (y4 ? y4.length : 0); _++)
                if (JI(y4[_], e2[0], e2[1]))
                  continue e;
              return true;
            }
          }
        }
      return false;
    }, n2.prototype.transformTo = function(e2, o, l4, c4) {
      var h = this.getBoundingRect(), p4 = h.width / h.height;
      l4 ? c4 || (c4 = l4 / p4) : l4 = p4 * c4;
      for (var g4 = new mo(e2, o, l4, c4), y4 = h.calculateTransform(g4), _ = this.geometries, w4 = 0; w4 < _.length; w4++) {
        var C = _[w4];
        C.type === "polygon" ? (Yre(C.exterior, y4), Ve(C.interiors, function(E) {
          Yre(E, y4);
        })) : Ve(C.points, function(E) {
          Yre(E, y4);
        });
      }
      h = this._rect, h.copy(g4), this._center = [h.x + h.width / 2, h.y + h.height / 2];
    }, n2.prototype.cloneShallow = function(e2) {
      e2 == null && (e2 = this.name);
      var o = new n2(e2, this.geometries, this._center);
      return o._rect = this._rect, o.transformTo = null, o;
    }, n2;
  }(ike), Xdt = function(i) {
    on(n2, i);
    function n2(e2, o) {
      var l4 = i.call(this, e2) || this;
      return l4.type = "geoSVG", l4._elOnlyForCalculate = o, l4;
    }
    return n2.prototype.calcCenter = function() {
      for (var e2 = this._elOnlyForCalculate, o = e2.getBoundingRect(), l4 = [o.x + o.width / 2, o.y + o.height / 2], c4 = b$(Ydt), h = e2; h && !h.isGeoSVGGraphicRoot; )
        p2(c4, h.getLocalTransform(), c4), h = h.parent;
      return W3(c4, c4), Sp(l4, l4, c4), l4;
    }, n2;
  }(ike);
  function Kdt(i) {
    if (!i.UTF8Encoding)
      return i;
    var n2 = i, e2 = n2.UTF8Scale;
    e2 == null && (e2 = 1024);
    var o = n2.features;
    return Ve(o, function(l4) {
      var c4 = l4.geometry, h = c4.encodeOffsets, p4 = c4.coordinates;
      if (!!h)
        switch (c4.type) {
          case "LineString":
            c4.coordinates = ske(p4, h, e2);
            break;
          case "Polygon":
            Zre(p4, h, e2);
            break;
          case "MultiLineString":
            Zre(p4, h, e2);
            break;
          case "MultiPolygon":
            Ve(p4, function(g4, y4) {
              return Zre(g4, h[y4], e2);
            });
        }
    }), n2.UTF8Encoding = false, n2;
  }
  function Zre(i, n2, e2) {
    for (var o = 0; o < i.length; o++)
      i[o] = ske(i[o], n2[o], e2);
  }
  function ske(i, n2, e2) {
    for (var o = [], l4 = n2[0], c4 = n2[1], h = 0; h < i.length; h += 2) {
      var p4 = i.charCodeAt(h) - 64, g4 = i.charCodeAt(h + 1) - 64;
      p4 = p4 >> 1 ^ -(p4 & 1), g4 = g4 >> 1 ^ -(g4 & 1), p4 += l4, g4 += c4, l4 = p4, c4 = g4, o.push([p4 / e2, g4 / e2]);
    }
    return o;
  }
  function Jdt(i, n2) {
    return i = Kdt(i), Er(Yl(i.features, function(e2) {
      return e2.geometry && e2.properties && e2.geometry.coordinates.length > 0;
    }), function(e2) {
      var o = e2.properties, l4 = e2.geometry, c4 = [];
      switch (l4.type) {
        case "Polygon":
          var h = l4.coordinates;
          c4.push(new dSe(h[0], h.slice(1)));
          break;
        case "MultiPolygon":
          Ve(l4.coordinates, function(g4) {
            g4[0] && c4.push(new dSe(g4[0], g4.slice(1)));
          });
          break;
        case "LineString":
          c4.push(new pSe([l4.coordinates]));
          break;
        case "MultiLineString":
          c4.push(new pSe(l4.coordinates));
      }
      var p4 = new oke(o[n2 || "name"], c4, o.cp);
      return p4.properties = o, p4;
    });
  }
  var x8 = zs();
  function Qdt(i) {
    return i.type === "category" ? tpt(i) : rpt(i);
  }
  function ept(i, n2) {
    return i.type === "category" ? npt(i, n2) : { ticks: Er(i.scale.getTicks(), function(e2) {
      return e2.value;
    }) };
  }
  function tpt(i) {
    var n2 = i.getLabelModel(), e2 = lke(i, n2);
    return !n2.get("show") || i.scale.isBlank() ? { labels: [], labelCategoryInterval: e2.labelCategoryInterval } : e2;
  }
  function lke(i, n2) {
    var e2 = uke(i, "labels"), o = Tle(n2), l4 = cke(e2, o);
    if (l4)
      return l4;
    var c4, h;
    return si(o) ? c4 = dke(i, o) : (h = o === "auto" ? apt(i) : o, c4 = hke(i, h)), fke(e2, o, { labels: c4, labelCategoryInterval: h });
  }
  function npt(i, n2) {
    var e2 = uke(i, "ticks"), o = Tle(n2), l4 = cke(e2, o);
    if (l4)
      return l4;
    var c4, h;
    if ((!n2.get("show") || i.scale.isBlank()) && (c4 = []), si(o))
      c4 = dke(i, o, true);
    else if (o === "auto") {
      var p4 = lke(i, i.getLabelModel());
      h = p4.labelCategoryInterval, c4 = Er(p4.labels, function(g4) {
        return g4.tickValue;
      });
    } else
      h = o, c4 = hke(i, h, true);
    return fke(e2, o, { ticks: c4, tickCategoryInterval: h });
  }
  function rpt(i) {
    var n2 = i.scale.getTicks(), e2 = Y8(i);
    return { labels: Er(n2, function(o, l4) {
      return { level: o.level, formattedLabel: e2(o, l4), rawLabel: i.scale.getLabel(o), tickValue: o.value };
    }) };
  }
  function uke(i, n2) {
    return x8(i)[n2] || (x8(i)[n2] = []);
  }
  function cke(i, n2) {
    for (var e2 = 0; e2 < i.length; e2++)
      if (i[e2].key === n2)
        return i[e2].value;
  }
  function fke(i, n2, e2) {
    return i.push({ key: n2, value: e2 }), e2;
  }
  function apt(i) {
    var n2 = x8(i).autoInterval;
    return n2 != null ? n2 : x8(i).autoInterval = i.calculateCategoryInterval();
  }
  function ipt(i) {
    var n2 = opt(i), e2 = Y8(i), o = (n2.axisRotate - n2.labelRotate) / 180 * Math.PI, l4 = i.scale, c4 = l4.getExtent(), h = l4.count();
    if (c4[1] - c4[0] < 1)
      return 0;
    var p4 = 1;
    h > 40 && (p4 = Math.max(1, Math.floor(h / 40)));
    for (var g4 = c4[0], y4 = i.dataToCoord(g4 + 1) - i.dataToCoord(g4), _ = Math.abs(y4 * Math.cos(o)), w4 = Math.abs(y4 * Math.sin(o)), C = 0, E = 0; g4 <= c4[1]; g4 += p4) {
      var T = 0, O = 0, N = N8(e2({ value: g4 }), n2.font, "center", "top");
      T = N.width * 1.3, O = N.height * 1.3, C = Math.max(C, T, 7), E = Math.max(E, O, 7);
    }
    var V = C / _, H = E / w4;
    isNaN(V) && (V = 1 / 0), isNaN(H) && (H = 1 / 0);
    var X = Math.max(0, Math.floor(Math.min(V, H))), q2 = x8(i.model), de = i.getExtent(), le = q2.lastAutoInterval, me = q2.lastTickCount;
    return le != null && me != null && Math.abs(le - X) <= 1 && Math.abs(me - h) <= 1 && le > X && q2.axisExtent0 === de[0] && q2.axisExtent1 === de[1] ? X = le : (q2.lastTickCount = h, q2.lastAutoInterval = X, q2.axisExtent0 = de[0], q2.axisExtent1 = de[1]), X;
  }
  function opt(i) {
    var n2 = i.getLabelModel();
    return { axisRotate: i.getRotate ? i.getRotate() : i.isHorizontal && !i.isHorizontal() ? 90 : 0, labelRotate: n2.get("rotate") || 0, font: n2.getFont() };
  }
  function hke(i, n2, e2) {
    var o = Y8(i), l4 = i.scale, c4 = l4.getExtent(), h = i.getLabelModel(), p4 = [], g4 = Math.max((n2 || 0) + 1, 1), y4 = c4[0], _ = l4.count();
    y4 !== 0 && g4 > 1 && _ / g4 > 2 && (y4 = Math.round(Math.ceil(y4 / g4) * g4));
    var w4 = ake(i), C = h.get("showMinLabel") || w4, E = h.get("showMaxLabel") || w4;
    C && y4 !== c4[0] && O(c4[0]);
    for (var T = y4; T <= c4[1]; T += g4)
      O(T);
    E && T - g4 !== c4[1] && O(c4[1]);
    function O(N) {
      var V = { value: N };
      p4.push(e2 ? N : { formattedLabel: o(V), rawLabel: l4.getLabel(V), tickValue: N });
    }
    return p4;
  }
  function dke(i, n2, e2) {
    var o = i.scale, l4 = Y8(i), c4 = [];
    return Ve(o.getTicks(), function(h) {
      var p4 = o.getLabel(h), g4 = h.value;
      n2(h.value, p4) && c4.push(e2 ? g4 : { formattedLabel: l4(h), rawLabel: p4, tickValue: g4 });
    }), c4;
  }
  var vSe = [0, 1], spt = function() {
    function i(n2, e2, o) {
      this.onBand = false, this.inverse = false, this.dim = n2, this.scale = e2, this._extent = o || [0, 0];
    }
    return i.prototype.contain = function(n2) {
      var e2 = this._extent, o = Math.min(e2[0], e2[1]), l4 = Math.max(e2[0], e2[1]);
      return n2 >= o && n2 <= l4;
    }, i.prototype.containData = function(n2) {
      return this.scale.contain(n2);
    }, i.prototype.getExtent = function() {
      return this._extent.slice();
    }, i.prototype.getPixelPrecision = function(n2) {
      return ZIe(n2 || this.scale.getExtent(), this._extent);
    }, i.prototype.setExtent = function(n2, e2) {
      var o = this._extent;
      o[0] = n2, o[1] = e2;
    }, i.prototype.dataToCoord = function(n2, e2) {
      var o = this._extent, l4 = this.scale;
      return n2 = l4.normalize(n2), this.onBand && l4.type === "ordinal" && (o = o.slice(), gSe(o, l4.count())), Tl(n2, vSe, o, e2);
    }, i.prototype.coordToData = function(n2, e2) {
      var o = this._extent, l4 = this.scale;
      this.onBand && l4.type === "ordinal" && (o = o.slice(), gSe(o, l4.count()));
      var c4 = Tl(n2, o, vSe, e2);
      return this.scale.scale(c4);
    }, i.prototype.pointToData = function(n2, e2) {
    }, i.prototype.getTicksCoords = function(n2) {
      n2 = n2 || {};
      var e2 = n2.tickModel || this.getTickModel(), o = ept(this, e2), l4 = o.ticks, c4 = Er(l4, function(p4) {
        return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(p4) : p4), tickValue: p4 };
      }, this), h = e2.get("alignWithLabel");
      return lpt(this, c4, h, n2.clamp), c4;
    }, i.prototype.getMinorTicksCoords = function() {
      if (this.scale.type === "ordinal")
        return [];
      var n2 = this.model.getModel("minorTick"), e2 = n2.get("splitNumber");
      e2 > 0 && e2 < 100 || (e2 = 5);
      var o = this.scale.getMinorTicks(e2), l4 = Er(o, function(c4) {
        return Er(c4, function(h) {
          return { coord: this.dataToCoord(h), tickValue: h };
        }, this);
      }, this);
      return l4;
    }, i.prototype.getViewLabels = function() {
      return Qdt(this).labels;
    }, i.prototype.getLabelModel = function() {
      return this.model.getModel("axisLabel");
    }, i.prototype.getTickModel = function() {
      return this.model.getModel("axisTick");
    }, i.prototype.getBandWidth = function() {
      var n2 = this._extent, e2 = this.scale.getExtent(), o = e2[1] - e2[0] + (this.onBand ? 1 : 0);
      o === 0 && (o = 1);
      var l4 = Math.abs(n2[1] - n2[0]);
      return Math.abs(l4) / o;
    }, i.prototype.calculateCategoryInterval = function() {
      return ipt(this);
    }, i;
  }();
  function gSe(i, n2) {
    var e2 = i[1] - i[0], o = n2, l4 = e2 / o / 2;
    i[0] += l4, i[1] -= l4;
  }
  function lpt(i, n2, e2, o) {
    var l4 = n2.length;
    if (!i.onBand || e2 || !l4)
      return;
    var c4 = i.getExtent(), h, p4;
    if (l4 === 1)
      n2[0].coord = c4[0], h = n2[1] = { coord: c4[0] };
    else {
      var g4 = n2[l4 - 1].tickValue - n2[0].tickValue, y4 = (n2[l4 - 1].coord - n2[0].coord) / g4;
      Ve(n2, function(E) {
        E.coord -= y4 / 2;
      });
      var _ = i.scale.getExtent();
      p4 = 1 + _[1] - n2[l4 - 1].tickValue, h = { coord: n2[l4 - 1].coord + y4 * p4 }, n2.push(h);
    }
    var w4 = c4[0] > c4[1];
    C(n2[0].coord, c4[0]) && (o ? n2[0].coord = c4[0] : n2.shift()), o && C(c4[0], n2[0].coord) && n2.unshift({ coord: c4[0] }), C(c4[1], h.coord) && (o ? h.coord = c4[1] : n2.pop()), o && C(h.coord, c4[1]) && n2.push({ coord: c4[1] });
    function C(E, T) {
      return E = df(E), T = df(T), w4 ? E > T : E < T;
    }
  }
  var lb2 = spt, hN = Math.PI * 2, zI = K_.CMD, upt = ["top", "right", "bottom", "left"];
  function cpt(i, n2, e2, o, l4) {
    var c4 = e2.width, h = e2.height;
    switch (i) {
      case "top":
        o.set(e2.x + c4 / 2, e2.y - n2), l4.set(0, -1);
        break;
      case "bottom":
        o.set(e2.x + c4 / 2, e2.y + h + n2), l4.set(0, 1);
        break;
      case "left":
        o.set(e2.x - n2, e2.y + h / 2), l4.set(-1, 0);
        break;
      case "right":
        o.set(e2.x + c4 + n2, e2.y + h / 2), l4.set(1, 0);
        break;
    }
  }
  function fpt(i, n2, e2, o, l4, c4, h, p4, g4) {
    h -= i, p4 -= n2;
    var y4 = Math.sqrt(h * h + p4 * p4);
    h /= y4, p4 /= y4;
    var _ = h * e2 + i, w4 = p4 * e2 + n2;
    if (Math.abs(o - l4) % hN < 1e-4)
      return g4[0] = _, g4[1] = w4, y4 - e2;
    if (c4) {
      var C = o;
      o = jC(l4), l4 = jC(C);
    } else
      o = jC(o), l4 = jC(l4);
    o > l4 && (l4 += hN);
    var E = Math.atan2(p4, h);
    if (E < 0 && (E += hN), E >= o && E <= l4 || E + hN >= o && E + hN <= l4)
      return g4[0] = _, g4[1] = w4, y4 - e2;
    var T = e2 * Math.cos(o) + i, O = e2 * Math.sin(o) + n2, N = e2 * Math.cos(l4) + i, V = e2 * Math.sin(l4) + n2, H = (T - h) * (T - h) + (O - p4) * (O - p4), X = (N - h) * (N - h) + (V - p4) * (V - p4);
    return H < X ? (g4[0] = T, g4[1] = O, Math.sqrt(H)) : (g4[0] = N, g4[1] = V, Math.sqrt(X));
  }
  function GH(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = l4 - i, y4 = c4 - n2, _ = e2 - i, w4 = o - n2, C = Math.sqrt(_ * _ + w4 * w4);
    _ /= C, w4 /= C;
    var E = g4 * _ + y4 * w4, T = E / C;
    p4 && (T = Math.min(Math.max(T, 0), 1)), T *= C;
    var O = h[0] = i + T * _, N = h[1] = n2 + T * w4;
    return Math.sqrt((O - l4) * (O - l4) + (N - c4) * (N - c4));
  }
  function pke(i, n2, e2, o, l4, c4, h) {
    e2 < 0 && (i = i + e2, e2 = -e2), o < 0 && (n2 = n2 + o, o = -o);
    var p4 = i + e2, g4 = n2 + o, y4 = h[0] = Math.min(Math.max(l4, i), p4), _ = h[1] = Math.min(Math.max(c4, n2), g4);
    return Math.sqrt((y4 - l4) * (y4 - l4) + (_ - c4) * (_ - c4));
  }
  var eb = [];
  function hpt(i, n2, e2) {
    var o = pke(n2.x, n2.y, n2.width, n2.height, i.x, i.y, eb);
    return e2.set(eb[0], eb[1]), o;
  }
  function dpt(i, n2, e2) {
    for (var o = 0, l4 = 0, c4 = 0, h = 0, p4, g4, y4 = 1 / 0, _ = n2.data, w4 = i.x, C = i.y, E = 0; E < _.length; ) {
      var T = _[E++];
      E === 1 && (o = _[E], l4 = _[E + 1], c4 = o, h = l4);
      var O = y4;
      switch (T) {
        case zI.M:
          c4 = _[E++], h = _[E++], o = c4, l4 = h;
          break;
        case zI.L:
          O = GH(o, l4, _[E], _[E + 1], w4, C, eb, true), o = _[E++], l4 = _[E++];
          break;
        case zI.C:
          O = DIe(o, l4, _[E++], _[E++], _[E++], _[E++], _[E], _[E + 1], w4, C, eb), o = _[E++], l4 = _[E++];
          break;
        case zI.Q:
          O = PIe(o, l4, _[E++], _[E++], _[E], _[E + 1], w4, C, eb), o = _[E++], l4 = _[E++];
          break;
        case zI.A:
          var N = _[E++], V = _[E++], H = _[E++], X = _[E++], q2 = _[E++], de = _[E++];
          E += 1;
          var le = !!(1 - _[E++]);
          p4 = Math.cos(q2) * H + N, g4 = Math.sin(q2) * X + V, E <= 1 && (c4 = p4, h = g4);
          var me = (w4 - N) * X / H + N;
          O = fpt(N, V, X, q2, q2 + de, le, me, C, eb), o = Math.cos(q2 + de) * H + N, l4 = Math.sin(q2 + de) * X + V;
          break;
        case zI.R:
          c4 = o = _[E++], h = l4 = _[E++];
          var ye = _[E++], be = _[E++];
          O = pke(c4, h, ye, be, w4, C, eb);
          break;
        case zI.Z:
          O = GH(o, l4, c4, h, w4, C, eb, true), o = c4, l4 = h;
          break;
      }
      O < y4 && (y4 = O, e2.set(eb[0], eb[1]));
    }
    return y4;
  }
  var nb = new Ji(), Lu = new Ji(), Af = new Ji(), G_ = new Ji(), V_ = new Ji();
  function mSe(i, n2) {
    if (!!i) {
      var e2 = i.getTextGuideLine(), o = i.getTextContent();
      if (!!(o && e2)) {
        var l4 = i.textGuideLineConfig || {}, c4 = [[0, 0], [0, 0], [0, 0]], h = l4.candidates || upt, p4 = o.getBoundingRect().clone();
        p4.applyTransform(o.getComputedTransform());
        var g4 = 1 / 0, y4 = l4.anchor, _ = i.getComputedTransform(), w4 = _ && W3([], _), C = n2.get("length2") || 0;
        y4 && Af.copy(y4);
        for (var E = 0; E < h.length; E++) {
          var T = h[E];
          cpt(T, 0, p4, nb, G_), Ji.scaleAndAdd(Lu, nb, G_, C), Lu.transform(w4);
          var O = i.getBoundingRect(), N = y4 ? y4.distance(Lu) : i instanceof Eo ? dpt(Lu, i.path, Af) : hpt(Lu, O, Af);
          N < g4 && (g4 = N, Lu.transform(_), Af.transform(_), Af.toArray(c4[0]), Lu.toArray(c4[1]), nb.toArray(c4[2]));
        }
        vke(c4, n2.get("minTurnAngle")), e2.setShape({ points: c4 });
      }
    }
  }
  var WH2 = [], Zv = new Ji();
  function vke(i, n2) {
    if (n2 <= 180 && n2 > 0) {
      n2 = n2 / 180 * Math.PI, nb.fromArray(i[0]), Lu.fromArray(i[1]), Af.fromArray(i[2]), Ji.sub(G_, nb, Lu), Ji.sub(V_, Af, Lu);
      var e2 = G_.len(), o = V_.len();
      if (!(e2 < 1e-3 || o < 1e-3)) {
        G_.scale(1 / e2), V_.scale(1 / o);
        var l4 = G_.dot(V_), c4 = Math.cos(n2);
        if (c4 < l4) {
          var h = GH(Lu.x, Lu.y, Af.x, Af.y, nb.x, nb.y, WH2, false);
          Zv.fromArray(WH2), Zv.scaleAndAdd(V_, h / Math.tan(Math.PI - n2));
          var p4 = Af.x !== Lu.x ? (Zv.x - Lu.x) / (Af.x - Lu.x) : (Zv.y - Lu.y) / (Af.y - Lu.y);
          if (isNaN(p4))
            return;
          p4 < 0 ? Ji.copy(Zv, Lu) : p4 > 1 && Ji.copy(Zv, Af), Zv.toArray(i[1]);
        }
      }
    }
  }
  function ppt(i, n2, e2) {
    if (e2 <= 180 && e2 > 0) {
      e2 = e2 / 180 * Math.PI, nb.fromArray(i[0]), Lu.fromArray(i[1]), Af.fromArray(i[2]), Ji.sub(G_, Lu, nb), Ji.sub(V_, Af, Lu);
      var o = G_.len(), l4 = V_.len();
      if (!(o < 1e-3 || l4 < 1e-3)) {
        G_.scale(1 / o), V_.scale(1 / l4);
        var c4 = G_.dot(n2), h = Math.cos(e2);
        if (c4 < h) {
          var p4 = GH(Lu.x, Lu.y, Af.x, Af.y, nb.x, nb.y, WH2, false);
          Zv.fromArray(WH2);
          var g4 = Math.PI / 2, y4 = Math.acos(V_.dot(n2)), _ = g4 + y4 - e2;
          if (_ >= g4)
            Ji.copy(Zv, Af);
          else {
            Zv.scaleAndAdd(V_, p4 / Math.tan(Math.PI / 2 - _));
            var w4 = Af.x !== Lu.x ? (Zv.x - Lu.x) / (Af.x - Lu.x) : (Zv.y - Lu.y) / (Af.y - Lu.y);
            if (isNaN(w4))
              return;
            w4 < 0 ? Ji.copy(Zv, Lu) : w4 > 1 && Ji.copy(Zv, Af);
          }
          Zv.toArray(i[1]);
        }
      }
    }
  }
  function ySe(i, n2, e2, o) {
    var l4 = e2 === "normal", c4 = l4 ? i : i.ensureState(e2);
    c4.ignore = n2;
    var h = o.get("smooth");
    h && h === true && (h = 0.3), c4.shape = c4.shape || {}, h > 0 && (c4.shape.smooth = h);
    var p4 = o.getModel("lineStyle").getLineStyle();
    l4 ? i.useStyle(p4) : c4.style = p4;
  }
  function vpt(i, n2) {
    var e2 = n2.smooth, o = n2.points;
    if (!!o)
      if (i.moveTo(o[0][0], o[0][1]), e2 > 0 && o.length >= 3) {
        var l4 = RC(o[0], o[1]), c4 = RC(o[1], o[2]);
        if (!l4 || !c4) {
          i.lineTo(o[1][0], o[1][1]), i.lineTo(o[2][0], o[2][1]);
          return;
        }
        var h = Math.min(l4, c4) * e2, p4 = ZW([], o[1], o[0], h / l4), g4 = ZW([], o[1], o[2], h / c4), y4 = ZW([], p4, g4, 0.5);
        i.bezierCurveTo(p4[0], p4[1], p4[0], p4[1], y4[0], y4[1]), i.bezierCurveTo(g4[0], g4[1], g4[0], g4[1], o[2][0], o[2][1]);
      } else
        for (var _ = 1; _ < o.length; _++)
          i.lineTo(o[_][0], o[_][1]);
  }
  function Dle(i, n2, e2) {
    var o = i.getTextGuideLine(), l4 = i.getTextContent();
    if (!l4) {
      o && i.removeTextGuideLine();
      return;
    }
    for (var c4 = n2.normal, h = c4.get("show"), p4 = l4.ignore, g4 = 0; g4 < c8.length; g4++) {
      var y4 = c8[g4], _ = n2[y4], w4 = y4 === "normal";
      if (_) {
        var C = _.get("show"), E = w4 ? p4 : so(l4.states[y4] && l4.states[y4].ignore, p4);
        if (E || !so(C, h)) {
          var T = w4 ? o : o && o.states.normal;
          T && (T.ignore = true);
          continue;
        }
        o || (o = new Ug(), i.setTextGuideLine(o), !w4 && (p4 || !h) && ySe(o, true, "normal", n2.normal), i.stateProxy && (o.stateProxy = i.stateProxy)), ySe(o, false, y4, _);
      }
    }
    if (o) {
      hi(o.style, e2), o.style.fill = null;
      var O = c4.get("showAbove"), N = i.textGuideLineConfig = i.textGuideLineConfig || {};
      N.showAbove = O || false, o.buildPath = vpt;
    }
  }
  function kle(i, n2) {
    n2 = n2 || "labelLine";
    for (var e2 = { normal: i.getModel(n2) }, o = 0; o < Jv.length; o++) {
      var l4 = Jv[o];
      e2[l4] = i.getModel([l4, n2]);
    }
    return e2;
  }
  function gke(i) {
    for (var n2 = [], e2 = 0; e2 < i.length; e2++) {
      var o = i[e2];
      if (!o.defaultAttr.ignore) {
        var l4 = o.label, c4 = l4.getComputedTransform(), h = l4.getBoundingRect(), p4 = !c4 || c4[1] < 1e-5 && c4[2] < 1e-5, g4 = l4.style.margin || 0, y4 = h.clone();
        y4.applyTransform(c4), y4.x -= g4 / 2, y4.y -= g4 / 2, y4.width += g4, y4.height += g4;
        var _ = p4 ? new EH(h, c4) : null;
        n2.push({ label: l4, labelLine: o.labelLine, rect: y4, localRect: h, obb: _, priority: o.priority, defaultAttr: o.defaultAttr, layoutOption: o.computedLayoutOption, axisAligned: p4, transform: c4 });
      }
    }
    return n2;
  }
  function mke(i, n2, e2, o, l4, c4) {
    var h = i.length;
    if (h < 2)
      return;
    i.sort(function(ye, be) {
      return ye.rect[n2] - be.rect[n2];
    });
    for (var p4 = 0, g4, y4 = false, _ = 0, w4 = 0; w4 < h; w4++) {
      var C = i[w4], E = C.rect;
      g4 = E[n2] - p4, g4 < 0 && (E[n2] -= g4, C.label[n2] -= g4, y4 = true);
      var T = Math.max(-g4, 0);
      _ += T, p4 = E[n2] + E[e2];
    }
    _ > 0 && c4 && de(-_ / h, 0, h);
    var O = i[0], N = i[h - 1], V, H;
    X(), V < 0 && le(-V, 0.8), H < 0 && le(H, 0.8), X(), q2(V, H, 1), q2(H, V, -1), X(), V < 0 && me(-V), H < 0 && me(H);
    function X() {
      V = O.rect[n2] - o, H = l4 - N.rect[n2] - N.rect[e2];
    }
    function q2(ye, be, we) {
      if (ye < 0) {
        var Pe = Math.min(be, -ye);
        if (Pe > 0) {
          de(Pe * we, 0, h);
          var ze = Pe + ye;
          ze < 0 && le(-ze * we, 1);
        } else
          le(-ye * we, 1);
      }
    }
    function de(ye, be, we) {
      ye !== 0 && (y4 = true);
      for (var Pe = be; Pe < we; Pe++) {
        var ze = i[Pe], Re = ze.rect;
        Re[n2] += ye, ze.label[n2] += ye;
      }
    }
    function le(ye, be) {
      for (var we = [], Pe = 0, ze = 1; ze < h; ze++) {
        var Re = i[ze - 1].rect, rt2 = Math.max(i[ze].rect[n2] - Re[n2] - Re[e2], 0);
        we.push(rt2), Pe += rt2;
      }
      if (!!Pe) {
        var ft = Math.min(Math.abs(ye) / Pe, be);
        if (ye > 0)
          for (var ze = 0; ze < h - 1; ze++) {
            var et = we[ze] * ft;
            de(et, 0, ze + 1);
          }
        else
          for (var ze = h - 1; ze > 0; ze--) {
            var et = we[ze - 1] * ft;
            de(-et, ze, h);
          }
      }
    }
    function me(ye) {
      var be = ye < 0 ? -1 : 1;
      ye = Math.abs(ye);
      for (var we = Math.ceil(ye / (h - 1)), Pe = 0; Pe < h - 1; Pe++)
        if (be > 0 ? de(we, 0, Pe + 1) : de(-we, h - Pe - 1, h), ye -= we, ye <= 0)
          return;
    }
    return y4;
  }
  function gpt(i, n2, e2, o) {
    return mke(i, "x", "width", n2, e2, o);
  }
  function yke(i, n2, e2, o) {
    return mke(i, "y", "height", n2, e2, o);
  }
  function bke(i) {
    var n2 = [];
    i.sort(function(O, N) {
      return N.priority - O.priority;
    });
    var e2 = new mo(0, 0, 0, 0);
    function o(O) {
      if (!O.ignore) {
        var N = O.ensureState("emphasis");
        N.ignore == null && (N.ignore = false);
      }
      O.ignore = true;
    }
    for (var l4 = 0; l4 < i.length; l4++) {
      var c4 = i[l4], h = c4.axisAligned, p4 = c4.localRect, g4 = c4.transform, y4 = c4.label, _ = c4.labelLine;
      e2.copy(c4.rect), e2.width -= 0.1, e2.height -= 0.1, e2.x += 0.05, e2.y += 0.05;
      for (var w4 = c4.obb, C = false, E = 0; E < n2.length; E++) {
        var T = n2[E];
        if (!!e2.intersect(T.rect)) {
          if (h && T.axisAligned) {
            C = true;
            break;
          }
          if (T.obb || (T.obb = new EH(T.localRect, T.transform)), w4 || (w4 = new EH(p4, g4)), w4.intersect(T.obb)) {
            C = true;
            break;
          }
        }
      }
      C ? (o(y4), _ && o(_)) : (y4.attr("ignore", c4.defaultAttr.ignore), _ && _.attr("ignore", c4.defaultAttr.labelGuideIgnore), n2.push(c4));
    }
  }
  function mpt(i) {
    if (i) {
      for (var n2 = [], e2 = 0; e2 < i.length; e2++)
        n2.push(i[e2].slice());
      return n2;
    }
  }
  function ypt(i, n2) {
    var e2 = i.label, o = n2 && n2.getTextGuideLine();
    return { dataIndex: i.dataIndex, dataType: i.dataType, seriesIndex: i.seriesModel.seriesIndex, text: i.label.style.text, rect: i.hostRect, labelRect: i.rect, align: e2.style.align, verticalAlign: e2.style.verticalAlign, labelLinePoints: mpt(o && o.shape.points) };
  }
  var bSe = ["align", "verticalAlign", "width", "height", "fontSize"], Y0 = new u2(), Xre = zs(), bpt = zs();
  function yW(i, n2, e2) {
    for (var o = 0; o < e2.length; o++) {
      var l4 = e2[o];
      n2[l4] != null && (i[l4] = n2[l4]);
    }
  }
  var bW = ["x", "y", "rotation"], _pt = function() {
    function i() {
      this._labelList = [], this._chartViewList = [];
    }
    return i.prototype.clearLabels = function() {
      this._labelList = [], this._chartViewList = [];
    }, i.prototype._addLabel = function(n2, e2, o, l4, c4) {
      var h = l4.style, p4 = l4.__hostTarget, g4 = p4.textConfig || {}, y4 = l4.getComputedTransform(), _ = l4.getBoundingRect().plain();
      mo.applyTransform(_, _, y4), y4 ? Y0.setLocalTransform(y4) : (Y0.x = Y0.y = Y0.rotation = Y0.originX = Y0.originY = 0, Y0.scaleX = Y0.scaleY = 1);
      var w4 = l4.__hostTarget, C;
      if (w4) {
        C = w4.getBoundingRect().plain();
        var E = w4.getComputedTransform();
        mo.applyTransform(C, C, E);
      }
      var T = C && w4.getTextGuideLine();
      this._labelList.push({ label: l4, labelLine: T, seriesModel: o, dataIndex: n2, dataType: e2, layoutOption: c4, computedLayoutOption: null, rect: _, hostRect: C, priority: C ? C.width * C.height : 0, defaultAttr: { ignore: l4.ignore, labelGuideIgnore: T && T.ignore, x: Y0.x, y: Y0.y, scaleX: Y0.scaleX, scaleY: Y0.scaleY, rotation: Y0.rotation, style: { x: h.x, y: h.y, align: h.align, verticalAlign: h.verticalAlign, width: h.width, height: h.height, fontSize: h.fontSize }, cursor: l4.cursor, attachedPos: g4.position, attachedRot: g4.rotation } });
    }, i.prototype.addLabelsOfSeries = function(n2) {
      var e2 = this;
      this._chartViewList.push(n2);
      var o = n2.__model, l4 = o.get("labelLayout");
      !(si(l4) || ts(l4).length) || n2.group.traverse(function(c4) {
        if (c4.ignore)
          return true;
        var h = c4.getTextContent(), p4 = Fi(c4);
        h && !h.disableLabelLayout && e2._addLabel(p4.dataIndex, p4.dataType, o, h, l4);
      });
    }, i.prototype.updateLayoutConfig = function(n2) {
      var e2 = n2.getWidth(), o = n2.getHeight();
      function l4(X, q2) {
        return function() {
          mSe(X, q2);
        };
      }
      for (var c4 = 0; c4 < this._labelList.length; c4++) {
        var h = this._labelList[c4], p4 = h.label, g4 = p4.__hostTarget, y4 = h.defaultAttr, _ = void 0;
        si(h.layoutOption) ? _ = h.layoutOption(ypt(h, g4)) : _ = h.layoutOption, _ = _ || {}, h.computedLayoutOption = _;
        var w4 = Math.PI / 180;
        g4 && g4.setTextConfig({ local: false, position: _.x != null || _.y != null ? null : y4.attachedPos, rotation: _.rotate != null ? _.rotate * w4 : y4.attachedRot, offset: [_.dx || 0, _.dy || 0] });
        var C = false;
        if (_.x != null ? (p4.x = ma(_.x, e2), p4.setStyle("x", 0), C = true) : (p4.x = y4.x, p4.setStyle("x", y4.style.x)), _.y != null ? (p4.y = ma(_.y, o), p4.setStyle("y", 0), C = true) : (p4.y = y4.y, p4.setStyle("y", y4.style.y)), _.labelLinePoints) {
          var E = g4.getTextGuideLine();
          E && (E.setShape({ points: _.labelLinePoints }), C = false);
        }
        var T = Xre(p4);
        T.needsUpdateLabelLine = C, p4.rotation = _.rotate != null ? _.rotate * w4 : y4.rotation, p4.scaleX = y4.scaleX, p4.scaleY = y4.scaleY;
        for (var O = 0; O < bSe.length; O++) {
          var N = bSe[O];
          p4.setStyle(N, _[N] != null ? _[N] : y4.style[N]);
        }
        if (_.draggable) {
          if (p4.draggable = true, p4.cursor = "move", g4) {
            var V = h.seriesModel;
            if (h.dataIndex != null) {
              var H = h.seriesModel.getData(h.dataType);
              V = H.getItemModel(h.dataIndex);
            }
            p4.on("drag", l4(g4, V.getModel("labelLine")));
          }
        } else
          p4.off("drag"), p4.cursor = y4.cursor;
      }
    }, i.prototype.layout = function(n2) {
      var e2 = n2.getWidth(), o = n2.getHeight(), l4 = gke(this._labelList), c4 = Yl(l4, function(g4) {
        return g4.layoutOption.moveOverlap === "shiftX";
      }), h = Yl(l4, function(g4) {
        return g4.layoutOption.moveOverlap === "shiftY";
      });
      gpt(c4, 0, e2), yke(h, 0, o);
      var p4 = Yl(l4, function(g4) {
        return g4.layoutOption.hideOverlap;
      });
      bke(p4);
    }, i.prototype.processLabelsOverall = function() {
      var n2 = this;
      Ve(this._chartViewList, function(e2) {
        var o = e2.__model, l4 = e2.ignoreLabelLineUpdate, c4 = o.isAnimationEnabled();
        e2.group.traverse(function(h) {
          if (h.ignore && !h.forceLabelAnimation)
            return true;
          var p4 = !l4, g4 = h.getTextContent();
          !p4 && g4 && (p4 = Xre(g4).needsUpdateLabelLine), p4 && n2._updateLabelLine(h, o), c4 && n2._animateLabels(h, o);
        });
      });
    }, i.prototype._updateLabelLine = function(n2, e2) {
      var o = n2.getTextContent(), l4 = Fi(n2), c4 = l4.dataIndex;
      if (o && c4 != null) {
        var h = e2.getData(l4.dataType), p4 = h.getItemModel(c4), g4 = {}, y4 = h.getItemVisual(c4, "style"), _ = h.getVisual("drawType");
        g4.stroke = y4[_];
        var w4 = p4.getModel("labelLine");
        Dle(n2, kle(p4), g4), mSe(n2, w4);
      }
    }, i.prototype._animateLabels = function(n2, e2) {
      var o = n2.getTextContent(), l4 = n2.getTextGuideLine();
      if (o && (n2.forceLabelAnimation || !o.ignore && !o.invisible && !n2.disableLabelAnimation && !E3(n2))) {
        var c4 = Xre(o), h = c4.oldLayout, p4 = Fi(n2), g4 = p4.dataIndex, y4 = { x: o.x, y: o.y, rotation: o.rotation }, _ = e2.getData(p4.dataType);
        if (h) {
          o.attr(h);
          var C = n2.prevStates;
          C && (go(C, "select") >= 0 && o.attr(c4.oldLayoutSelect), go(C, "emphasis") >= 0 && o.attr(c4.oldLayoutEmphasis)), Vs(o, y4, e2, g4);
        } else if (o.attr(y4), !Y3(o).valueAnimation) {
          var w4 = so(o.style.opacity, 1);
          o.style.opacity = 0, bc(o, { style: { opacity: w4 } }, e2, g4);
        }
        if (c4.oldLayout = y4, o.states.select) {
          var E = c4.oldLayoutSelect = {};
          yW(E, y4, bW), yW(E, o.states.select, bW);
        }
        if (o.states.emphasis) {
          var T = c4.oldLayoutEmphasis = {};
          yW(T, y4, bW), yW(T, o.states.emphasis, bW);
        }
        iDe(o, g4, _, e2, e2);
      }
      if (l4 && !l4.ignore && !l4.invisible) {
        var c4 = bpt(l4), h = c4.oldLayout, O = { points: l4.shape.points };
        h ? (l4.attr({ shape: h }), Vs(l4, { shape: O }, e2)) : (l4.setShape(O), l4.style.strokePercent = 0, bc(l4, { style: { strokePercent: 1 } }, e2)), c4.oldLayout = O;
      }
    }, i;
  }(), xpt = _pt, Kre = zs();
  function wpt(i) {
    i.registerUpdateLifecycle("series:beforeupdate", function(n2, e2, o) {
      var l4 = Kre(e2).labelManager;
      l4 || (l4 = Kre(e2).labelManager = new xpt()), l4.clearLabels();
    }), i.registerUpdateLifecycle("series:layoutlabels", function(n2, e2, o) {
      var l4 = Kre(e2).labelManager;
      o.updatedSeries.forEach(function(c4) {
        l4.addLabelsOfSeries(e2.getViewOfSeriesModel(c4));
      }), l4.updateLayoutConfig(e2), l4.layout(e2), l4.processLabelsOverall();
    });
  }
  var Jre = Math.sin, Qre = Math.cos, _ke = Math.PI, BI = Math.PI * 2, Spt = 180 / _ke, Cpt = function() {
    function i() {
    }
    return i.prototype.reset = function(n2) {
      this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, n2 || 4);
    }, i.prototype.moveTo = function(n2, e2) {
      this._add("M", n2, e2);
    }, i.prototype.lineTo = function(n2, e2) {
      this._add("L", n2, e2);
    }, i.prototype.bezierCurveTo = function(n2, e2, o, l4, c4, h) {
      this._add("C", n2, e2, o, l4, c4, h);
    }, i.prototype.quadraticCurveTo = function(n2, e2, o, l4) {
      this._add("Q", n2, e2, o, l4);
    }, i.prototype.arc = function(n2, e2, o, l4, c4, h) {
      this.ellipse(n2, e2, o, o, 0, l4, c4, h);
    }, i.prototype.ellipse = function(n2, e2, o, l4, c4, h, p4, g4) {
      var y4 = p4 - h, _ = !g4, w4 = Math.abs(y4), C = BC(w4 - BI) || (_ ? y4 >= BI : -y4 >= BI), E = y4 > 0 ? y4 % BI : y4 % BI + BI, T = false;
      C ? T = true : BC(w4) ? T = false : T = E >= _ke == !!_;
      var O = n2 + o * Qre(h), N = e2 + l4 * Jre(h);
      this._start && this._add("M", O, N);
      var V = Math.round(c4 * Spt);
      if (C) {
        var H = 1 / this._p, X = (_ ? 1 : -1) * (BI - H);
        this._add("A", o, l4, V, 1, +_, n2 + o * Qre(h + X), e2 + l4 * Jre(h + X)), H > 0.01 && this._add("A", o, l4, V, 0, +_, O, N);
      } else {
        var q2 = n2 + o * Qre(p4), de = e2 + l4 * Jre(p4);
        this._add("A", o, l4, V, +T, +_, q2, de);
      }
    }, i.prototype.rect = function(n2, e2, o, l4) {
      this._add("M", n2, e2), this._add("l", o, 0), this._add("l", 0, l4), this._add("l", -o, 0), this._add("Z");
    }, i.prototype.closePath = function() {
      this._d.length > 0 && this._add("Z");
    }, i.prototype._add = function(n2, e2, o, l4, c4, h, p4, g4, y4) {
      for (var _ = [], w4 = this._p, C = 1; C < arguments.length; C++) {
        var E = arguments[C];
        if (isNaN(E)) {
          this._invalid = true;
          return;
        }
        _.push(Math.round(E * w4) / w4);
      }
      this._d.push(n2 + _.join(" ")), this._start = n2 === "Z";
    }, i.prototype.generateStr = function() {
      this._str = this._invalid ? "" : this._d.join(""), this._d = [];
    }, i.prototype.getStr = function() {
      return this._str;
    }, i;
  }(), xke = Cpt, JN = "none", Mpt = Math.round;
  function Apt(i) {
    var n2 = i.fill;
    return n2 != null && n2 !== JN;
  }
  function Ept(i) {
    var n2 = i.stroke;
    return n2 != null && n2 !== JN;
  }
  var xoe = ["lineCap", "miterLimit", "lineJoin"], Ipt = Er(xoe, function(i) {
    return "stroke-" + i.toLowerCase();
  });
  function Tpt(i, n2, e2, o) {
    var l4 = n2.opacity == null ? 1 : n2.opacity;
    if (e2 instanceof Ap) {
      i("opacity", l4);
      return;
    }
    if (Apt(n2)) {
      var c4 = O3(n2.fill);
      i("fill", c4.color);
      var h = n2.fillOpacity != null ? n2.fillOpacity * c4.opacity * l4 : c4.opacity * l4;
      (o || h < 1) && i("fill-opacity", h);
    } else
      i("fill", JN);
    if (Ept(n2)) {
      var p4 = O3(n2.stroke);
      i("stroke", p4.color);
      var g4 = n2.strokeNoScale ? e2.getLineScale() : 1, y4 = g4 ? (n2.lineWidth || 0) / g4 : 0, _ = n2.strokeOpacity != null ? n2.strokeOpacity * p4.opacity * l4 : p4.opacity * l4, w4 = n2.strokeFirst;
      if ((o || y4 !== 1) && i("stroke-width", y4), (o || w4) && i("paint-order", w4 ? "stroke" : "fill"), (o || _ < 1) && i("stroke-opacity", _), n2.lineDash) {
        var C = yle(e2), E = C[0], T = C[1];
        E && (T = Mpt(T || 0), i("stroke-dasharray", E.join(",")), (T || o) && i("stroke-dashoffset", T));
      } else
        o && i("stroke-dasharray", JN);
      for (var O = 0; O < xoe.length; O++) {
        var N = xoe[O];
        if (o || n2[N] !== MH[N]) {
          var V = n2[N] || MH[N];
          V && i(Ipt[O], V);
        }
      }
    } else
      o && i("stroke", JN);
  }
  var wke = "http://www.w3.org/2000/svg", Ske = "http://www.w3.org/1999/xlink", Dpt = "http://www.w3.org/2000/xmlns/", kpt = "http://www.w3.org/XML/1998/namespace";
  function Cke(i) {
    return document.createElementNS(wke, i);
  }
  function Jh(i, n2, e2, o, l4) {
    return { tag: i, attrs: e2 || {}, children: o, text: l4, key: n2 };
  }
  function Ppt(i, n2) {
    var e2 = [];
    if (n2)
      for (var o in n2) {
        var l4 = n2[o], c4 = o;
        l4 !== false && (l4 !== true && l4 != null && (c4 += '="' + l4 + '"'), e2.push(c4));
      }
    return "<" + i + " " + e2.join(" ") + ">";
  }
  function Lpt(i) {
    return "</" + i + ">";
  }
  function Ple(i, n2) {
    n2 = n2 || {};
    var e2 = n2.newline ? `
` : "";
    function o(l4) {
      var c4 = l4.children, h = l4.tag, p4 = l4.attrs;
      return Ppt(h, p4) + (l4.text || "") + (c4 ? "" + e2 + Er(c4, function(g4) {
        return o(g4);
      }).join(e2) + e2 : "") + Lpt(h);
    }
    return o(i);
  }
  function Opt(i, n2, e2) {
    e2 = e2 || {};
    var o = e2.newline ? `
` : "", l4 = " {" + o, c4 = o + "}", h = Er(ts(i), function(g4) {
      return g4 + l4 + Er(ts(i[g4]), function(y4) {
        return y4 + ":" + i[g4][y4] + ";";
      }).join(o) + c4;
    }).join(o), p4 = Er(ts(n2), function(g4) {
      return "@keyframes " + g4 + l4 + Er(ts(n2[g4]), function(y4) {
        return y4 + l4 + Er(ts(n2[g4][y4]), function(_) {
          var w4 = n2[g4][y4][_];
          return _ === "d" && (w4 = 'path("' + w4 + '")'), _ + ":" + w4 + ";";
        }).join(o) + c4;
      }).join(o) + c4;
    }).join(o);
    return !h && !p4 ? "" : ["<![CDATA[", h, p4, "]]>"].join(o);
  }
  function woe(i) {
    return { zrId: i, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
  }
  function _Se(i, n2, e2, o) {
    return Jh("svg", "root", { width: i, height: n2, xmlns: wke, "xmlns:xlink": Ske, version: "1.1", baseProfile: "full", viewBox: o ? "0 0 " + i + " " + n2 : false }, e2);
  }
  var xSe = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, $I = "transform-origin";
  function Rpt(i, n2, e2) {
    var o = rr({}, i.shape);
    rr(o, n2), i.buildPath(e2, o);
    var l4 = new xke();
    return l4.reset(VIe(i)), e2.rebuildPath(l4, 1), l4.generateStr(), l4.getStr();
  }
  function Fpt(i, n2) {
    var e2 = n2.originX, o = n2.originY;
    (e2 || o) && (i[$I] = e2 + "px " + o + "px");
  }
  var Npt = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
  function Mke(i, n2) {
    var e2 = n2.zrId + "-ani-" + n2.cssAnimIdx++;
    return n2.cssAnims[e2] = i, e2;
  }
  function Vpt(i, n2, e2) {
    var o = i.shape.paths, l4 = {}, c4, h;
    if (Ve(o, function(g4) {
      var y4 = woe(e2.zrId);
      y4.animation = true, U$(g4, {}, y4, true);
      var _ = y4.cssAnims, w4 = y4.cssNodes, C = ts(_), E = C.length;
      if (!!E) {
        h = C[E - 1];
        var T = _[h];
        for (var O in T) {
          var N = T[O];
          l4[O] = l4[O] || { d: "" }, l4[O].d += N.d || "";
        }
        for (var V in w4) {
          var H = w4[V].animation;
          H.indexOf(h) >= 0 && (c4 = H);
        }
      }
    }), !!c4) {
      n2.d = false;
      var p4 = Mke(l4, e2);
      return c4.replace(h, p4);
    }
  }
  function wSe(i) {
    return xa(i) ? xSe[i] ? "cubic-bezier(" + xSe[i] + ")" : Ose(i) ? i : "" : "";
  }
  function U$(i, n2, e2, o) {
    var l4 = i.animators, c4 = l4.length, h = [];
    if (i instanceof Kse) {
      var p4 = Vpt(i, n2, e2);
      if (p4)
        h.push(p4);
      else if (!c4)
        return;
    } else if (!c4)
      return;
    for (var g4 = {}, y4 = 0; y4 < c4; y4++) {
      var _ = l4[y4], w4 = [_.getMaxTime() / 1e3 + "s"], C = wSe(_.getClip().easing), E = _.getDelay();
      C ? w4.push(C) : w4.push("linear"), E && w4.push(E / 1e3 + "s"), _.getLoop() && w4.push("infinite");
      var T = w4.join(" ");
      g4[T] = g4[T] || [T, []], g4[T][1].push(_);
    }
    function O(H) {
      var X = H[1], q2 = X.length, de = {}, le = {}, me = {}, ye = "animation-timing-function";
      function be(da, Ra, Wa) {
        for (var wa = da.getTracks(), li = da.getMaxTime(), Ts = 0; Ts < wa.length; Ts++) {
          var wi = wa[Ts];
          if (wi.needsAnimate()) {
            var ps = wi.keyframes, Bs = wi.propName;
            if (Wa && (Bs = Wa(Bs)), Bs)
              for (var vl = 0; vl < ps.length; vl++) {
                var If = ps[vl], Xl = Math.round(If.time / li * 100) + "%", _h = wSe(If.easing), Nl = If.rawValue;
                (xa(Nl) || sl(Nl)) && (Ra[Xl] = Ra[Xl] || {}, Ra[Xl][Bs] = If.rawValue, _h && (Ra[Xl][ye] = _h));
              }
          }
        }
      }
      for (var we = 0; we < q2; we++) {
        var Pe = X[we], ze = Pe.targetName;
        ze ? ze === "shape" && be(Pe, le) : !o && be(Pe, de);
      }
      for (var Re in de) {
        var rt2 = {};
        WIe(rt2, i), rr(rt2, de[Re]);
        var ft = zIe(rt2), et = de[Re][ye];
        me[Re] = ft ? { transform: ft } : {}, Fpt(me[Re], rt2), et && (me[Re][ye] = et);
      }
      var Jt, xt = true;
      for (var Re in le) {
        me[Re] = me[Re] || {};
        var It = !Jt, et = le[Re][ye];
        It && (Jt = new K_());
        var Wt = Jt.len();
        Jt.reset(), me[Re].d = Rpt(i, le[Re], Jt);
        var sn = Jt.len();
        if (!It && Wt !== sn) {
          xt = false;
          break;
        }
        et && (me[Re][ye] = et);
      }
      if (!xt)
        for (var Re in me)
          delete me[Re].d;
      if (!o)
        for (var we = 0; we < q2; we++) {
          var Pe = X[we], ze = Pe.targetName;
          ze === "style" && be(Pe, me, function(wa) {
            return Npt[wa];
          });
        }
      for (var vn = ts(me), $r = true, ga, we = 1; we < vn.length; we++) {
        var Za = vn[we - 1], $a = vn[we];
        if (me[Za][$I] !== me[$a][$I]) {
          $r = false;
          break;
        }
        ga = me[Za][$I];
      }
      if ($r && ga) {
        for (var Re in me)
          me[Re][$I] && delete me[Re][$I];
        n2[$I] = ga;
      }
      if (Yl(vn, function(da) {
        return ts(me[da]).length > 0;
      }).length) {
        var Pa = Mke(me, e2);
        return Pa + " " + H[0] + " both";
      }
    }
    for (var N in g4) {
      var p4 = O(g4[N]);
      p4 && h.push(p4);
    }
    if (h.length) {
      var V = e2.zrId + "-cls-" + e2.cssClassIdx++;
      e2.cssNodes["." + V] = { animation: h.join(",") }, n2.class = V;
    }
  }
  var w8 = Math.round;
  function Ake(i) {
    return i && xa(i.src);
  }
  function Eke(i) {
    return i && si(i.toDataURL);
  }
  function Lle(i, n2, e2, o) {
    Tpt(function(l4, c4) {
      var h = l4 === "fill" || l4 === "stroke";
      h && Pot(c4) ? Upt(n2, i, l4, o) : h && kot(c4) ? qpt(e2, i, l4, o) : i[l4] = c4;
    }, n2, e2, false), $pt(e2, i, o);
  }
  function SSe(i) {
    return BC(i[0] - 1) && BC(i[1]) && BC(i[2]) && BC(i[3] - 1);
  }
  function zpt(i) {
    return BC(i[4]) && BC(i[5]);
  }
  function Ole(i, n2, e2) {
    if (n2 && !(zpt(n2) && SSe(n2))) {
      var o = e2 ? 10 : 1e4;
      i.transform = SSe(n2) ? "translate(" + w8(n2[4] * o) / o + " " + w8(n2[5] * o) / o + ")" : Mot(n2);
    }
  }
  function CSe(i, n2, e2) {
    for (var o = i.points, l4 = [], c4 = 0; c4 < o.length; c4++)
      l4.push(w8(o[c4][0] * e2) / e2), l4.push(w8(o[c4][1] * e2) / e2);
    n2.points = l4.join(" ");
  }
  function MSe(i) {
    return !i.smooth;
  }
  function Bpt(i) {
    var n2 = Er(i, function(e2) {
      return typeof e2 == "string" ? [e2, e2] : e2;
    });
    return function(e2, o, l4) {
      for (var c4 = 0; c4 < n2.length; c4++) {
        var h = n2[c4], p4 = e2[h[0]];
        p4 != null && (o[h[1]] = w8(p4 * l4) / l4);
      }
    };
  }
  var jpt = { circle: [Bpt(["cx", "cy", "r"])], polyline: [CSe, MSe], polygon: [CSe, MSe] };
  function Gpt(i) {
    for (var n2 = i.animators, e2 = 0; e2 < n2.length; e2++)
      if (n2[e2].targetName === "shape")
        return true;
    return false;
  }
  function Ike(i, n2) {
    var e2 = i.style, o = i.shape, l4 = jpt[i.type], c4 = {}, h = n2.animation, p4 = "path", g4 = i.style.strokePercent, y4 = n2.compress && VIe(i) || 4;
    if (l4 && !n2.willUpdate && !(l4[1] && !l4[1](o)) && !(h && Gpt(i)) && !(g4 < 1)) {
      p4 = i.type;
      var _ = Math.pow(10, y4);
      l4[0](o, c4, _);
    } else {
      i.path || i.createPathProxy();
      var w4 = i.path;
      i.shapeChanged() && (w4.beginPath(), i.buildPath(w4, i.shape), i.pathUpdated());
      var C = w4.getVersion(), E = i, T = E.__svgPathBuilder;
      (E.__svgPathVersion !== C || !T || g4 !== E.__svgPathStrokePercent) && (T || (T = E.__svgPathBuilder = new xke()), T.reset(y4), w4.rebuildPath(T, g4), T.generateStr(), E.__svgPathVersion = C, E.__svgPathStrokePercent = g4), c4.d = T.getStr();
    }
    return Ole(c4, i.transform), Lle(c4, e2, i, n2), n2.animation && U$(i, c4, n2), Jh(p4, i.id + "", c4);
  }
  function Wpt(i, n2) {
    var e2 = i.style, o = e2.image;
    if (o && !xa(o) && (Ake(o) ? o = o.src : Eke(o) && (o = o.toDataURL())), !!o) {
      var l4 = e2.x || 0, c4 = e2.y || 0, h = e2.width, p4 = e2.height, g4 = { href: o, width: h, height: p4 };
      return l4 && (g4.x = l4), c4 && (g4.y = c4), Ole(g4, i.transform), Lle(g4, e2, i, n2), n2.animation && U$(i, g4, n2), Jh("image", i.id + "", g4);
    }
  }
  function Hpt(i, n2) {
    var e2 = i.style, o = e2.text;
    if (o != null && (o += ""), !(!o || isNaN(e2.x) || isNaN(e2.y))) {
      var l4 = e2.font || XC, c4 = e2.x || 0, h = Eot(e2.y || 0, _$(l4), e2.textBaseline), p4 = Aot[e2.textAlign] || e2.textAlign, g4 = { "dominant-baseline": "central", "text-anchor": p4 };
      if (xTe(e2)) {
        var y4 = "", _ = e2.fontStyle, w4 = _Te(e2.fontSize);
        if (!parseFloat(w4))
          return;
        var C = e2.fontFamily || pIe, E = e2.fontWeight;
        y4 += "font-size:" + w4 + ";font-family:" + C + ";", _ && _ !== "normal" && (y4 += "font-style:" + _ + ";"), E && E !== "normal" && (y4 += "font-weight:" + E + ";"), g4.style = y4;
      } else
        g4.style = "font: " + l4;
      return o.match(/\s/) && (g4["xml:space"] = "preserve"), c4 && (g4.x = c4), h && (g4.y = h), Ole(g4, i.transform), Lle(g4, e2, i, n2), n2.animation && U$(i, g4, n2), Jh("text", i.id + "", g4, void 0, o);
    }
  }
  function ASe(i, n2) {
    if (i instanceof Eo)
      return Ike(i, n2);
    if (i instanceof Ap)
      return Wpt(i, n2);
    if (i instanceof u8)
      return Hpt(i, n2);
  }
  function $pt(i, n2, e2) {
    var o = i.style;
    if (Iot(o)) {
      var l4 = Tot(i), c4 = e2.shadowCache, h = c4[l4];
      if (!h) {
        var p4 = i.getGlobalScale(), g4 = p4[0], y4 = p4[1];
        if (!g4 || !y4)
          return;
        var _ = o.shadowOffsetX || 0, w4 = o.shadowOffsetY || 0, C = o.shadowBlur, E = O3(o.shadowColor), T = E.opacity, O = E.color, N = C / 2 / g4, V = C / 2 / y4, H = N + " " + V;
        h = e2.zrId + "-s" + e2.shadowIdx++, e2.defs[h] = Jh("filter", h, { id: h, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [Jh("feDropShadow", "", { dx: _ / g4, dy: w4 / y4, stdDeviation: H, "flood-color": O, "flood-opacity": T })]), c4[l4] = h;
      }
      n2.filter = y$(h);
    }
  }
  function Upt(i, n2, e2, o) {
    var l4 = i[e2], c4, h = { gradientUnits: l4.global ? "userSpaceOnUse" : "objectBoundingBox" };
    if (FIe(l4))
      c4 = "linearGradient", h.x1 = l4.x, h.y1 = l4.y, h.x2 = l4.x2, h.y2 = l4.y2;
    else if (NIe(l4))
      c4 = "radialGradient", h.cx = so(l4.x, 0.5), h.cy = so(l4.y, 0.5), h.r = so(l4.r, 0.5);
    else
      return;
    for (var p4 = l4.colorStops, g4 = [], y4 = 0, _ = p4.length; y4 < _; ++y4) {
      var w4 = Fie(p4[y4].offset) * 100 + "%", C = p4[y4].color, E = O3(C), T = E.color, O = E.opacity, N = { offset: w4 };
      N["stop-color"] = T, O < 1 && (N["stop-opacity"] = O), g4.push(Jh("stop", y4 + "", N));
    }
    var V = Jh(c4, "", h, g4), H = Ple(V), X = o.gradientCache, q2 = X[H];
    q2 || (q2 = o.zrId + "-g" + o.gradientIdx++, X[H] = q2, h.id = q2, o.defs[q2] = Jh(c4, q2, h, g4)), n2[e2] = y$(q2);
  }
  function qpt(i, n2, e2, o) {
    var l4 = i.style[e2], c4 = { patternUnits: "userSpaceOnUse" }, h;
    if (RIe(l4)) {
      var p4 = l4.imageWidth, g4 = l4.imageHeight, y4 = void 0, _ = l4.image;
      if (xa(_) ? y4 = _ : Ake(_) ? y4 = _.src : Eke(_) && (y4 = _.toDataURL()), typeof Image == "undefined") {
        var w4 = "Image width/height must been given explictly in svg-ssr renderer.";
        Kv(p4, w4), Kv(g4, w4);
      } else if (p4 == null || g4 == null) {
        var C = function(H, X) {
          if (H) {
            var q2 = H.elm, de = H.attrs.width = p4 || X.width, le = H.attrs.height = g4 || X.height;
            q2 && (q2.setAttribute("width", de), q2.setAttribute("height", le));
          }
        }, E = Wse(y4, null, i, function(H) {
          C(T, H), C(h, H);
        });
        E && E.width && E.height && (p4 = p4 || E.width, g4 = g4 || E.height);
      }
      h = Jh("image", "img", { href: y4, width: p4, height: g4 }), c4.width = p4, c4.height = g4;
    } else
      l4.svgElement && (h = Ci(l4.svgElement), c4.width = l4.svgWidth, c4.height = l4.svgHeight);
    if (!!h) {
      c4.patternTransform = zIe(l4);
      var T = Jh("pattern", "", c4, [h]), O = Ple(T), N = o.patternCache, V = N[O];
      V || (V = o.zrId + "-p" + o.patternIdx++, N[O] = V, c4.id = V, T = o.defs[V] = Jh("pattern", V, c4, [h])), n2[e2] = y$(V);
    }
  }
  function Ypt(i, n2, e2) {
    var o = e2.clipPathCache, l4 = e2.defs, c4 = o[i.id];
    if (!c4) {
      c4 = e2.zrId + "-c" + e2.clipPathIdx++;
      var h = { id: c4 };
      o[i.id] = c4, l4[c4] = Jh("clipPath", c4, h, [Ike(i, e2)]);
    }
    n2["clip-path"] = y$(c4);
  }
  function ESe(i) {
    return document.createTextNode(i);
  }
  function QI(i, n2, e2) {
    i.insertBefore(n2, e2);
  }
  function ISe(i, n2) {
    i.removeChild(n2);
  }
  function TSe(i, n2) {
    i.appendChild(n2);
  }
  function Tke(i) {
    return i.parentNode;
  }
  function Dke(i) {
    return i.nextSibling;
  }
  function eae(i, n2) {
    i.textContent = n2;
  }
  var DSe = 58, Zpt = 120, Xpt = Jh("", "");
  function Soe(i) {
    return i === void 0;
  }
  function F_(i) {
    return i !== void 0;
  }
  function Kpt(i, n2, e2) {
    for (var o = {}, l4 = n2; l4 <= e2; ++l4) {
      var c4 = i[l4].key;
      c4 !== void 0 && (o[c4] = l4);
    }
    return o;
  }
  function LN(i, n2) {
    var e2 = i.key === n2.key, o = i.tag === n2.tag;
    return o && e2;
  }
  function S8(i) {
    var n2, e2 = i.children, o = i.tag;
    if (F_(o)) {
      var l4 = i.elm = Cke(o);
      if (Rle(Xpt, i), Mr(e2))
        for (n2 = 0; n2 < e2.length; ++n2) {
          var c4 = e2[n2];
          c4 != null && TSe(l4, S8(c4));
        }
      else
        F_(i.text) && !mi(i.text) && TSe(l4, ESe(i.text));
    } else
      i.elm = ESe(i.text);
    return i.elm;
  }
  function kke(i, n2, e2, o, l4) {
    for (; o <= l4; ++o) {
      var c4 = e2[o];
      c4 != null && QI(i, S8(c4), n2);
    }
  }
  function HH(i, n2, e2, o) {
    for (; e2 <= o; ++e2) {
      var l4 = n2[e2];
      if (l4 != null)
        if (F_(l4.tag)) {
          var c4 = Tke(l4.elm);
          ISe(c4, l4.elm);
        } else
          ISe(i, l4.elm);
    }
  }
  function Rle(i, n2) {
    var e2, o = n2.elm, l4 = i && i.attrs || {}, c4 = n2.attrs || {};
    if (l4 !== c4) {
      for (e2 in c4) {
        var h = c4[e2], p4 = l4[e2];
        p4 !== h && (h === true ? o.setAttribute(e2, "") : h === false ? o.removeAttribute(e2) : e2.charCodeAt(0) !== Zpt ? o.setAttribute(e2, h) : e2 === "xmlns:xlink" || e2 === "xmlns" ? o.setAttributeNS(Dpt, e2, h) : e2.charCodeAt(3) === DSe ? o.setAttributeNS(kpt, e2, h) : e2.charCodeAt(5) === DSe ? o.setAttributeNS(Ske, e2, h) : o.setAttribute(e2, h));
      }
      for (e2 in l4)
        e2 in c4 || o.removeAttribute(e2);
    }
  }
  function Jpt(i, n2, e2) {
    for (var o = 0, l4 = 0, c4 = n2.length - 1, h = n2[0], p4 = n2[c4], g4 = e2.length - 1, y4 = e2[0], _ = e2[g4], w4, C, E, T; o <= c4 && l4 <= g4; )
      h == null ? h = n2[++o] : p4 == null ? p4 = n2[--c4] : y4 == null ? y4 = e2[++l4] : _ == null ? _ = e2[--g4] : LN(h, y4) ? (p3(h, y4), h = n2[++o], y4 = e2[++l4]) : LN(p4, _) ? (p3(p4, _), p4 = n2[--c4], _ = e2[--g4]) : LN(h, _) ? (p3(h, _), QI(i, h.elm, Dke(p4.elm)), h = n2[++o], _ = e2[--g4]) : LN(p4, y4) ? (p3(p4, y4), QI(i, p4.elm, h.elm), p4 = n2[--c4], y4 = e2[++l4]) : (Soe(w4) && (w4 = Kpt(n2, o, c4)), C = w4[y4.key], Soe(C) ? QI(i, S8(y4), h.elm) : (E = n2[C], E.tag !== y4.tag ? QI(i, S8(y4), h.elm) : (p3(E, y4), n2[C] = void 0, QI(i, E.elm, h.elm))), y4 = e2[++l4]);
    (o <= c4 || l4 <= g4) && (o > c4 ? (T = e2[g4 + 1] == null ? null : e2[g4 + 1].elm, kke(i, T, e2, l4, g4)) : HH(i, n2, o, c4));
  }
  function p3(i, n2) {
    var e2 = n2.elm = i.elm, o = i.children, l4 = n2.children;
    i !== n2 && (Rle(i, n2), Soe(n2.text) ? F_(o) && F_(l4) ? o !== l4 && Jpt(e2, o, l4) : F_(l4) ? (F_(i.text) && eae(e2, ""), kke(e2, null, l4, 0, l4.length - 1)) : F_(o) ? HH(e2, o, 0, o.length - 1) : F_(i.text) && eae(e2, "") : i.text !== n2.text && (F_(o) && HH(e2, o, 0, o.length - 1), eae(e2, n2.text)));
  }
  function Qpt(i, n2) {
    if (LN(i, n2))
      p3(i, n2);
    else {
      var e2 = i.elm, o = Tke(e2);
      S8(n2), o !== null && (QI(o, n2.elm, Dke(e2)), HH(o, [i], 0, 0));
    }
    return n2;
  }
  var evt = 0, tvt = function() {
    function i(n2, e2, o) {
      if (this.type = "svg", this.refreshHover = kSe(), this.configLayer = kSe(), this.storage = e2, this._opts = o = rr({}, o), this.root = n2, this._id = "zr" + evt++, this._oldVNode = _Se(o.width, o.height), n2 && !o.ssr) {
        var l4 = this._viewport = document.createElement("div");
        l4.style.cssText = "position:relative;overflow:hidden";
        var c4 = this._svgDom = this._oldVNode.elm = Cke("svg");
        Rle(null, this._oldVNode), l4.appendChild(c4), n2.appendChild(l4);
      }
      this.resize(o.width, o.height);
    }
    return i.prototype.getType = function() {
      return this.type;
    }, i.prototype.getViewportRoot = function() {
      return this._viewport;
    }, i.prototype.getViewportRootOffset = function() {
      var n2 = this.getViewportRoot();
      if (n2)
        return { offsetLeft: n2.offsetLeft || 0, offsetTop: n2.offsetTop || 0 };
    }, i.prototype.getSvgDom = function() {
      return this._svgDom;
    }, i.prototype.refresh = function() {
      if (this.root) {
        var n2 = this.renderToVNode({ willUpdate: true });
        n2.attrs.style = "position:absolute;left:0;top:0;user-select:none", Qpt(this._oldVNode, n2), this._oldVNode = n2;
      }
    }, i.prototype.renderOneToVNode = function(n2) {
      return ASe(n2, woe(this._id));
    }, i.prototype.renderToVNode = function(n2) {
      n2 = n2 || {};
      var e2 = this.storage.getDisplayList(true), o = this._backgroundColor, l4 = this._width, c4 = this._height, h = woe(this._id);
      h.animation = n2.animation, h.willUpdate = n2.willUpdate, h.compress = n2.compress;
      var p4 = [];
      if (o && o !== "none") {
        var g4 = O3(o), y4 = g4.color, _ = g4.opacity;
        this._bgVNode = Jh("rect", "bg", { width: l4, height: c4, x: "0", y: "0", id: "0", fill: y4, "fill-opacity": _ }), p4.push(this._bgVNode);
      } else
        this._bgVNode = null;
      var w4 = n2.compress ? null : this._mainVNode = Jh("g", "main", {}, []);
      this._paintList(e2, h, w4 ? w4.children : p4), w4 && p4.push(w4);
      var C = Er(ts(h.defs), function(O) {
        return h.defs[O];
      });
      if (C.length && p4.push(Jh("defs", "defs", {}, C)), n2.animation) {
        var E = Opt(h.cssNodes, h.cssAnims, { newline: true });
        if (E) {
          var T = Jh("style", "stl", {}, [], E);
          p4.push(T);
        }
      }
      return _Se(l4, c4, p4, n2.useViewBox);
    }, i.prototype.renderToString = function(n2) {
      return n2 = n2 || {}, Ple(this.renderToVNode({ animation: so(n2.cssAnimation, true), willUpdate: false, compress: true, useViewBox: so(n2.useViewBox, true) }), { newline: true });
    }, i.prototype.setBackgroundColor = function(n2) {
      this._backgroundColor = n2;
      var e2 = this._bgVNode;
      if (e2 && e2.elm) {
        var o = O3(n2), l4 = o.color, c4 = o.opacity;
        e2.elm.setAttribute("fill", l4), c4 < 1 && e2.elm.setAttribute("fill-opacity", c4);
      }
    }, i.prototype.getSvgRoot = function() {
      return this._mainVNode && this._mainVNode.elm;
    }, i.prototype._paintList = function(n2, e2, o) {
      for (var l4 = n2.length, c4 = [], h = 0, p4, g4, y4 = 0, _ = 0; _ < l4; _++) {
        var w4 = n2[_];
        if (!w4.invisible) {
          var C = w4.__clipPaths, E = C && C.length || 0, T = g4 && g4.length || 0, O = void 0;
          for (O = Math.max(E - 1, T - 1); O >= 0 && !(C && g4 && C[O] === g4[O]); O--)
            ;
          for (var N = T - 1; N > O; N--)
            h--, p4 = c4[h - 1];
          for (var V = O + 1; V < E; V++) {
            var H = {};
            Ypt(C[V], H, e2);
            var X = Jh("g", "clip-g-" + y4++, H, []);
            (p4 ? p4.children : o).push(X), c4[h++] = X, p4 = X;
          }
          g4 = C;
          var q2 = ASe(w4, e2);
          q2 && (p4 ? p4.children : o).push(q2);
        }
      }
    }, i.prototype.resize = function(n2, e2) {
      var o = this._opts, l4 = this.root, c4 = this._viewport;
      if (n2 != null && (o.width = n2), e2 != null && (o.height = e2), l4 && c4 && (c4.style.display = "none", n2 = x3(l4, 0, o), e2 = x3(l4, 1, o), c4.style.display = ""), this._width !== n2 || this._height !== e2) {
        if (this._width = n2, this._height = e2, c4) {
          var h = c4.style;
          h.width = n2 + "px", h.height = e2 + "px";
        }
        var p4 = this._svgDom;
        p4 && (p4.setAttribute("width", n2), p4.setAttribute("height", e2));
      }
    }, i.prototype.getWidth = function() {
      return this._width;
    }, i.prototype.getHeight = function() {
      return this._height;
    }, i.prototype.dispose = function() {
      this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
    }, i.prototype.clear = function() {
      this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
    }, i.prototype.toDataURL = function(n2) {
      var e2 = encodeURIComponent(this.renderToString()), o = "data:image/svg+xml;";
      return n2 ? (e2 = Lot(e2), e2 && o + "base64," + e2) : o + "charset=UTF-8," + e2;
    }, i;
  }();
  function kSe(i) {
    return function() {
    };
  }
  var nvt = tvt;
  function rvt(i) {
    i.registerPainter("svg", nvt);
  }
  function PSe(i, n2, e2) {
    var o = y2.createCanvas(), l4 = n2.getWidth(), c4 = n2.getHeight(), h = o.style;
    return h && (h.position = "absolute", h.left = "0", h.top = "0", h.width = l4 + "px", h.height = c4 + "px", o.setAttribute("data-zr-dom-id", i)), o.width = l4 * e2, o.height = c4 * e2, o;
  }
  var avt = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this) || this;
      c4.motionBlur = false, c4.lastFrameAlpha = 0.7, c4.dpr = 1, c4.virtual = false, c4.config = {}, c4.incremental = false, c4.zlevel = 0, c4.maxRepaintRectCount = 5, c4.__dirty = true, c4.__firstTimePaint = true, c4.__used = false, c4.__drawIndex = 0, c4.__startIndex = 0, c4.__endIndex = 0, c4.__prevStartIndex = null, c4.__prevEndIndex = null;
      var h;
      l4 = l4 || wH, typeof e2 == "string" ? h = PSe(e2, o, l4) : mi(e2) && (h = e2, e2 = h.id), c4.id = e2, c4.dom = h;
      var p4 = h.style;
      return p4 && (bIe(h), h.onselectstart = function() {
        return false;
      }, p4.padding = "0", p4.margin = "0", p4.borderWidth = "0"), c4.painter = o, c4.dpr = l4, c4;
    }
    return n2.prototype.getElementCount = function() {
      return this.__endIndex - this.__startIndex;
    }, n2.prototype.afterBrush = function() {
      this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
    }, n2.prototype.initContext = function() {
      this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
    }, n2.prototype.setUnpainted = function() {
      this.__firstTimePaint = true;
    }, n2.prototype.createBackBuffer = function() {
      var e2 = this.dpr;
      this.domBack = PSe("back-" + this.id, this.painter, e2), this.ctxBack = this.domBack.getContext("2d"), e2 !== 1 && this.ctxBack.scale(e2, e2);
    }, n2.prototype.createRepaintRects = function(e2, o, l4, c4) {
      if (this.__firstTimePaint)
        return this.__firstTimePaint = false, null;
      var h = [], p4 = this.maxRepaintRectCount, g4 = false, y4 = new mo(0, 0, 0, 0);
      function _(H) {
        if (!(!H.isFinite() || H.isZero()))
          if (h.length === 0) {
            var X = new mo(0, 0, 0, 0);
            X.copy(H), h.push(X);
          } else {
            for (var q2 = false, de = 1 / 0, le = 0, me = 0; me < h.length; ++me) {
              var ye = h[me];
              if (ye.intersect(H)) {
                var be = new mo(0, 0, 0, 0);
                be.copy(ye), be.union(H), h[me] = be, q2 = true;
                break;
              } else if (g4) {
                y4.copy(H), y4.union(ye);
                var we = H.width * H.height, Pe = ye.width * ye.height, ze = y4.width * y4.height, Re = ze - we - Pe;
                Re < de && (de = Re, le = me);
              }
            }
            if (g4 && (h[le].union(H), q2 = true), !q2) {
              var X = new mo(0, 0, 0, 0);
              X.copy(H), h.push(X);
            }
            g4 || (g4 = h.length >= p4);
          }
      }
      for (var w4 = this.__startIndex; w4 < this.__endIndex; ++w4) {
        var C = e2[w4];
        if (C) {
          var E = C.shouldBePainted(l4, c4, true, true), T = C.__isRendered && (C.__dirty & em || !E) ? C.getPrevPaintRect() : null;
          T && _(T);
          var O = E && (C.__dirty & em || !C.__isRendered) ? C.getPaintRect() : null;
          O && _(O);
        }
      }
      for (var w4 = this.__prevStartIndex; w4 < this.__prevEndIndex; ++w4) {
        var C = o[w4], E = C.shouldBePainted(l4, c4, true, true);
        if (C && (!E || !C.__zr) && C.__isRendered) {
          var T = C.getPrevPaintRect();
          T && _(T);
        }
      }
      var N;
      do {
        N = false;
        for (var w4 = 0; w4 < h.length; ) {
          if (h[w4].isZero()) {
            h.splice(w4, 1);
            continue;
          }
          for (var V = w4 + 1; V < h.length; )
            h[w4].intersect(h[V]) ? (N = true, h[w4].union(h[V]), h.splice(V, 1)) : V++;
          w4++;
        }
      } while (N);
      return this._paintRects = h, h;
    }, n2.prototype.debugGetPaintRects = function() {
      return (this._paintRects || []).slice();
    }, n2.prototype.resize = function(e2, o) {
      var l4 = this.dpr, c4 = this.dom, h = c4.style, p4 = this.domBack;
      h && (h.width = e2 + "px", h.height = o + "px"), c4.width = e2 * l4, c4.height = o * l4, p4 && (p4.width = e2 * l4, p4.height = o * l4, l4 !== 1 && this.ctxBack.scale(l4, l4));
    }, n2.prototype.clear = function(e2, o, l4) {
      var c4 = this.dom, h = this.ctx, p4 = c4.width, g4 = c4.height;
      o = o || this.clearColor;
      var y4 = this.motionBlur && !e2, _ = this.lastFrameAlpha, w4 = this.dpr, C = this;
      y4 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(c4, 0, 0, p4 / w4, g4 / w4));
      var E = this.domBack;
      function T(O, N, V, H) {
        if (h.clearRect(O, N, V, H), o && o !== "transparent") {
          var X = void 0;
          g$(o) ? (X = o.__canvasGradient || doe(h, o, { x: 0, y: 0, width: V, height: H }), o.__canvasGradient = X) : Vit(o) && (X = poe(h, o, { dirty: function() {
            C.setUnpainted(), C.__painter.refresh();
          } })), h.save(), h.fillStyle = X || o, h.fillRect(O, N, V, H), h.restore();
        }
        y4 && (h.save(), h.globalAlpha = _, h.drawImage(E, O, N, V, H), h.restore());
      }
      !l4 || y4 ? T(0, 0, p4, g4) : l4.length && Ve(l4, function(O) {
        T(O.x * w4, O.y * w4, O.width * w4, O.height * w4);
      });
    }, n2;
  }(zy), tae = avt, LSe = 1e5, jI = 314159, _W = 0.01, ivt = 1e-3;
  function ovt(i) {
    return i ? i.__builtin__ ? true : !(typeof i.resize != "function" || typeof i.refresh != "function") : false;
  }
  function svt(i, n2) {
    var e2 = document.createElement("div");
    return e2.style.cssText = ["position:relative", "width:" + i + "px", "height:" + n2 + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", e2;
  }
  var lvt = function() {
    function i(n2, e2, o, l4) {
      this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
      var c4 = !n2.nodeName || n2.nodeName.toUpperCase() === "CANVAS";
      this._opts = o = rr({}, o || {}), this.dpr = o.devicePixelRatio || wH, this._singleCanvas = c4, this.root = n2;
      var h = n2.style;
      h && (bIe(n2), n2.innerHTML = ""), this.storage = e2;
      var p4 = this._zlevelList;
      this._prevDisplayList = [];
      var g4 = this._layers;
      if (c4) {
        var _ = n2, w4 = _.width, C = _.height;
        o.width != null && (w4 = o.width), o.height != null && (C = o.height), this.dpr = o.devicePixelRatio || 1, _.width = w4 * this.dpr, _.height = C * this.dpr, this._width = w4, this._height = C;
        var E = new tae(_, this, this.dpr);
        E.__builtin__ = true, E.initContext(), g4[jI] = E, E.zlevel = jI, p4.push(jI), this._domRoot = n2;
      } else {
        this._width = x3(n2, 0, o), this._height = x3(n2, 1, o);
        var y4 = this._domRoot = svt(this._width, this._height);
        n2.appendChild(y4);
      }
    }
    return i.prototype.getType = function() {
      return "canvas";
    }, i.prototype.isSingleCanvas = function() {
      return this._singleCanvas;
    }, i.prototype.getViewportRoot = function() {
      return this._domRoot;
    }, i.prototype.getViewportRootOffset = function() {
      var n2 = this.getViewportRoot();
      if (n2)
        return { offsetLeft: n2.offsetLeft || 0, offsetTop: n2.offsetTop || 0 };
    }, i.prototype.refresh = function(n2) {
      var e2 = this.storage.getDisplayList(true), o = this._prevDisplayList, l4 = this._zlevelList;
      this._redrawId = Math.random(), this._paintList(e2, o, n2, this._redrawId);
      for (var c4 = 0; c4 < l4.length; c4++) {
        var h = l4[c4], p4 = this._layers[h];
        if (!p4.__builtin__ && p4.refresh) {
          var g4 = c4 === 0 ? this._backgroundColor : null;
          p4.refresh(g4);
        }
      }
      return this._opts.useDirtyRect && (this._prevDisplayList = e2.slice()), this;
    }, i.prototype.refreshHover = function() {
      this._paintHoverList(this.storage.getDisplayList(false));
    }, i.prototype._paintHoverList = function(n2) {
      var e2 = n2.length, o = this._hoverlayer;
      if (o && o.clear(), !!e2) {
        for (var l4 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, c4, h = 0; h < e2; h++) {
          var p4 = n2[h];
          p4.__inHover && (o || (o = this._hoverlayer = this.getLayer(LSe)), c4 || (c4 = o.ctx, c4.save()), oT(c4, p4, l4, h === e2 - 1));
        }
        c4 && c4.restore();
      }
    }, i.prototype.getHoverLayer = function() {
      return this.getLayer(LSe);
    }, i.prototype.paintOne = function(n2, e2) {
      v5e(n2, e2);
    }, i.prototype._paintList = function(n2, e2, o, l4) {
      if (this._redrawId === l4) {
        o = o || false, this._updateLayerStatus(n2);
        var c4 = this._doPaintList(n2, e2, o), h = c4.finished, p4 = c4.needsRefreshHover;
        if (this._needsManuallyCompositing && this._compositeManually(), p4 && this._paintHoverList(n2), h)
          this.eachLayer(function(y4) {
            y4.afterBrush && y4.afterBrush();
          });
        else {
          var g4 = this;
          kie(function() {
            g4._paintList(n2, e2, o, l4);
          });
        }
      }
    }, i.prototype._compositeManually = function() {
      var n2 = this.getLayer(jI).ctx, e2 = this._domRoot.width, o = this._domRoot.height;
      n2.clearRect(0, 0, e2, o), this.eachBuiltinLayer(function(l4) {
        l4.virtual && n2.drawImage(l4.dom, 0, 0, e2, o);
      });
    }, i.prototype._doPaintList = function(n2, e2, o) {
      for (var l4 = this, c4 = [], h = this._opts.useDirtyRect, p4 = 0; p4 < this._zlevelList.length; p4++) {
        var g4 = this._zlevelList[p4], y4 = this._layers[g4];
        y4.__builtin__ && y4 !== this._hoverlayer && (y4.__dirty || o) && c4.push(y4);
      }
      for (var _ = true, w4 = false, C = function(O) {
        var N = c4[O], V = N.ctx, H = h && N.createRepaintRects(n2, e2, E._width, E._height), X = o ? N.__startIndex : N.__drawIndex, q2 = !o && N.incremental && Date.now, de = q2 && Date.now(), le = N.zlevel === E._zlevelList[0] ? E._backgroundColor : null;
        if (N.__startIndex === N.__endIndex)
          N.clear(false, le, H);
        else if (X === N.__startIndex) {
          var me = n2[X];
          (!me.incremental || !me.notClear || o) && N.clear(false, le, H);
        }
        X === -1 && (console.error("For some unknown reason. drawIndex is -1"), X = N.__startIndex);
        var ye, be = function(Re) {
          var rt2 = { inHover: false, allClipped: false, prevEl: null, viewWidth: l4._width, viewHeight: l4._height };
          for (ye = X; ye < N.__endIndex; ye++) {
            var ft = n2[ye];
            if (ft.__inHover && (w4 = true), l4._doPaintEl(ft, N, h, Re, rt2, ye === N.__endIndex - 1), q2) {
              var et = Date.now() - de;
              if (et > 15)
                break;
            }
          }
          rt2.prevElClipPaths && V.restore();
        };
        if (H)
          if (H.length === 0)
            ye = N.__endIndex;
          else
            for (var we = E.dpr, Pe = 0; Pe < H.length; ++Pe) {
              var ze = H[Pe];
              V.save(), V.beginPath(), V.rect(ze.x * we, ze.y * we, ze.width * we, ze.height * we), V.clip(), be(ze), V.restore();
            }
        else
          V.save(), be(), V.restore();
        N.__drawIndex = ye, N.__drawIndex < N.__endIndex && (_ = false);
      }, E = this, T = 0; T < c4.length; T++)
        C(T);
      return ol.wxa && Ve(this._layers, function(O) {
        O && O.ctx && O.ctx.draw && O.ctx.draw();
      }), { finished: _, needsRefreshHover: w4 };
    }, i.prototype._doPaintEl = function(n2, e2, o, l4, c4, h) {
      var p4 = e2.ctx;
      if (o) {
        var g4 = n2.getPaintRect();
        (!l4 || g4 && g4.intersect(l4)) && (oT(p4, n2, c4, h), n2.setPrevPaintRect(g4));
      } else
        oT(p4, n2, c4, h);
    }, i.prototype.getLayer = function(n2, e2) {
      this._singleCanvas && !this._needsManuallyCompositing && (n2 = jI);
      var o = this._layers[n2];
      return o || (o = new tae("zr_" + n2, this, this.dpr), o.zlevel = n2, o.__builtin__ = true, this._layerConfig[n2] ? to(o, this._layerConfig[n2], true) : this._layerConfig[n2 - _W] && to(o, this._layerConfig[n2 - _W], true), e2 && (o.virtual = e2), this.insertLayer(n2, o), o.initContext()), o;
    }, i.prototype.insertLayer = function(n2, e2) {
      var o = this._layers, l4 = this._zlevelList, c4 = l4.length, h = this._domRoot, p4 = null, g4 = -1;
      if (!o[n2] && !!ovt(e2)) {
        if (c4 > 0 && n2 > l4[0]) {
          for (g4 = 0; g4 < c4 - 1 && !(l4[g4] < n2 && l4[g4 + 1] > n2); g4++)
            ;
          p4 = o[l4[g4]];
        }
        if (l4.splice(g4 + 1, 0, n2), o[n2] = e2, !e2.virtual)
          if (p4) {
            var y4 = p4.dom;
            y4.nextSibling ? h.insertBefore(e2.dom, y4.nextSibling) : h.appendChild(e2.dom);
          } else
            h.firstChild ? h.insertBefore(e2.dom, h.firstChild) : h.appendChild(e2.dom);
        e2.__painter = this;
      }
    }, i.prototype.eachLayer = function(n2, e2) {
      for (var o = this._zlevelList, l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        n2.call(e2, this._layers[c4], c4);
      }
    }, i.prototype.eachBuiltinLayer = function(n2, e2) {
      for (var o = this._zlevelList, l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4], h = this._layers[c4];
        h.__builtin__ && n2.call(e2, h, c4);
      }
    }, i.prototype.eachOtherLayer = function(n2, e2) {
      for (var o = this._zlevelList, l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4], h = this._layers[c4];
        h.__builtin__ || n2.call(e2, h, c4);
      }
    }, i.prototype.getLayers = function() {
      return this._layers;
    }, i.prototype._updateLayerStatus = function(n2) {
      this.eachBuiltinLayer(function(w4, C) {
        w4.__dirty = w4.__used = false;
      });
      function e2(w4) {
        c4 && (c4.__endIndex !== w4 && (c4.__dirty = true), c4.__endIndex = w4);
      }
      if (this._singleCanvas)
        for (var o = 1; o < n2.length; o++) {
          var l4 = n2[o];
          if (l4.zlevel !== n2[o - 1].zlevel || l4.incremental) {
            this._needsManuallyCompositing = true;
            break;
          }
        }
      var c4 = null, h = 0, p4, g4;
      for (g4 = 0; g4 < n2.length; g4++) {
        var l4 = n2[g4], y4 = l4.zlevel, _ = void 0;
        p4 !== y4 && (p4 = y4, h = 0), l4.incremental ? (_ = this.getLayer(y4 + ivt, this._needsManuallyCompositing), _.incremental = true, h = 1) : _ = this.getLayer(y4 + (h > 0 ? _W : 0), this._needsManuallyCompositing), _.__builtin__ || Tse("ZLevel " + y4 + " has been used by unkown layer " + _.id), _ !== c4 && (_.__used = true, _.__startIndex !== g4 && (_.__dirty = true), _.__startIndex = g4, _.incremental ? _.__drawIndex = -1 : _.__drawIndex = g4, e2(g4), c4 = _), l4.__dirty & em && !l4.__inHover && (_.__dirty = true, _.incremental && _.__drawIndex < 0 && (_.__drawIndex = g4));
      }
      e2(g4), this.eachBuiltinLayer(function(w4, C) {
        !w4.__used && w4.getElementCount() > 0 && (w4.__dirty = true, w4.__startIndex = w4.__endIndex = w4.__drawIndex = 0), w4.__dirty && w4.__drawIndex < 0 && (w4.__drawIndex = w4.__startIndex);
      });
    }, i.prototype.clear = function() {
      return this.eachBuiltinLayer(this._clearLayer), this;
    }, i.prototype._clearLayer = function(n2) {
      n2.clear();
    }, i.prototype.setBackgroundColor = function(n2) {
      this._backgroundColor = n2, Ve(this._layers, function(e2) {
        e2.setUnpainted();
      });
    }, i.prototype.configLayer = function(n2, e2) {
      if (e2) {
        var o = this._layerConfig;
        o[n2] ? to(o[n2], e2, true) : o[n2] = e2;
        for (var l4 = 0; l4 < this._zlevelList.length; l4++) {
          var c4 = this._zlevelList[l4];
          if (c4 === n2 || c4 === n2 + _W) {
            var h = this._layers[c4];
            to(h, o[n2], true);
          }
        }
      }
    }, i.prototype.delLayer = function(n2) {
      var e2 = this._layers, o = this._zlevelList, l4 = e2[n2];
      !l4 || (l4.dom.parentNode.removeChild(l4.dom), delete e2[n2], o.splice(go(o, n2), 1));
    }, i.prototype.resize = function(n2, e2) {
      if (this._domRoot.style) {
        var o = this._domRoot;
        o.style.display = "none";
        var l4 = this._opts, c4 = this.root;
        if (n2 != null && (l4.width = n2), e2 != null && (l4.height = e2), n2 = x3(c4, 0, l4), e2 = x3(c4, 1, l4), o.style.display = "", this._width !== n2 || e2 !== this._height) {
          o.style.width = n2 + "px", o.style.height = e2 + "px";
          for (var h in this._layers)
            this._layers.hasOwnProperty(h) && this._layers[h].resize(n2, e2);
          this.refresh(true);
        }
        this._width = n2, this._height = e2;
      } else {
        if (n2 == null || e2 == null)
          return;
        this._width = n2, this._height = e2, this.getLayer(jI).resize(n2, e2);
      }
      return this;
    }, i.prototype.clearLayer = function(n2) {
      var e2 = this._layers[n2];
      e2 && e2.clear();
    }, i.prototype.dispose = function() {
      this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
    }, i.prototype.getRenderedCanvas = function(n2) {
      if (n2 = n2 || {}, this._singleCanvas && !this._compositeManually)
        return this._layers[jI].dom;
      var e2 = new tae("image", this, n2.pixelRatio || this.dpr);
      e2.initContext(), e2.clear(false, n2.backgroundColor || this._backgroundColor);
      var o = e2.ctx;
      if (n2.pixelRatio <= this.dpr) {
        this.refresh();
        var l4 = e2.dom.width, c4 = e2.dom.height;
        this.eachLayer(function(w4) {
          w4.__builtin__ ? o.drawImage(w4.dom, 0, 0, l4, c4) : w4.renderToCanvas && (o.save(), w4.renderToCanvas(o), o.restore());
        });
      } else
        for (var h = { inHover: false, viewWidth: this._width, viewHeight: this._height }, p4 = this.storage.getDisplayList(true), g4 = 0, y4 = p4.length; g4 < y4; g4++) {
          var _ = p4[g4];
          oT(o, _, h, g4 === y4 - 1);
        }
      return e2.dom;
    }, i.prototype.getWidth = function() {
      return this._width;
    }, i.prototype.getHeight = function() {
      return this._height;
    }, i;
  }(), uvt = lvt;
  function cvt(i) {
    i.registerPainter("canvas", uvt);
  }
  var fvt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.hasSymbolVisual = true, e2;
    }
    return n2.prototype.getInitialData = function(e2) {
      return M2(null, this, { useEncodeDefaulter: true });
    }, n2.prototype.getLegendIcon = function(e2) {
      var o = new Ti(), l4 = Xf("line", 0, e2.itemHeight / 2, e2.itemWidth, 0, e2.lineStyle.stroke, false);
      o.add(l4), l4.setStyle(e2.lineStyle);
      var c4 = this.getData().getVisual("symbol"), h = this.getData().getVisual("symbolRotate"), p4 = c4 === "none" ? "circle" : c4, g4 = e2.itemHeight * 0.8, y4 = Xf(p4, (e2.itemWidth - g4) / 2, (e2.itemHeight - g4) / 2, g4, g4, e2.itemStyle.fill);
      o.add(y4), y4.setStyle(e2.itemStyle);
      var _ = e2.iconRotate === "inherit" ? h : e2.iconRotate || 0;
      return y4.rotation = _ * Math.PI / 180, y4.setOrigin([e2.itemWidth / 2, e2.itemHeight / 2]), p4.indexOf("empty") > -1 && (y4.style.stroke = y4.style.fill, y4.style.fill = "#fff", y4.style.lineWidth = 2), o;
    }, n2.type = "series.line", n2.dependencies = ["grid", "polar"], n2.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, n2;
  }(_c2), hvt = fvt;
  function N3(i, n2) {
    var e2 = i.mapDimensionsAll("defaultedLabel"), o = e2.length;
    if (o === 1) {
      var l4 = R3(i, n2, e2[0]);
      return l4 != null ? l4 + "" : null;
    } else if (o) {
      for (var c4 = [], h = 0; h < e2.length; h++)
        c4.push(R3(i, n2, e2[h]));
      return c4.join(" ");
    }
  }
  function Pke(i, n2) {
    var e2 = i.mapDimensionsAll("defaultedLabel");
    if (!Mr(n2))
      return n2 + "";
    for (var o = [], l4 = 0; l4 < e2.length; l4++) {
      var c4 = i.getDimensionIndex(e2[l4]);
      c4 >= 0 && o.push(n2[c4]);
    }
    return o.join(" ");
  }
  var dvt = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4) {
      var h = i.call(this) || this;
      return h.updateData(e2, o, l4, c4), h;
    }
    return n2.prototype._createSymbol = function(e2, o, l4, c4, h) {
      this.removeAll();
      var p4 = Xf(e2, -1, -1, 2, 2, null, h);
      p4.attr({ z2: 100, culling: true, scaleX: c4[0] / 2, scaleY: c4[1] / 2 }), p4.drift = pvt, this._symbolType = e2, this.add(p4);
    }, n2.prototype.stopSymbolAnimation = function(e2) {
      this.childAt(0).stopAnimation(null, e2);
    }, n2.prototype.getSymbolType = function() {
      return this._symbolType;
    }, n2.prototype.getSymbolPath = function() {
      return this.childAt(0);
    }, n2.prototype.highlight = function() {
      W_(this.childAt(0));
    }, n2.prototype.downplay = function() {
      H_(this.childAt(0));
    }, n2.prototype.setZ = function(e2, o) {
      var l4 = this.childAt(0);
      l4.zlevel = e2, l4.z = o;
    }, n2.prototype.setDraggable = function(e2) {
      var o = this.childAt(0);
      o.draggable = e2, o.cursor = e2 ? "move" : o.cursor;
    }, n2.prototype.updateData = function(e2, o, l4, c4) {
      this.silent = false;
      var h = e2.getItemVisual(o, "symbol") || "circle", p4 = e2.hostModel, g4 = n2.getSymbolSize(e2, o), y4 = h !== this._symbolType, _ = c4 && c4.disableAnimation;
      if (y4) {
        var w4 = e2.getItemVisual(o, "symbolKeepAspect");
        this._createSymbol(h, e2, o, g4, w4);
      } else {
        var C = this.childAt(0);
        C.silent = false;
        var E = { scaleX: g4[0] / 2, scaleY: g4[1] / 2 };
        _ ? C.attr(E) : Vs(C, E, p4, o), ob(C);
      }
      if (this._updateCommon(e2, o, g4, l4, c4), y4) {
        var C = this.childAt(0);
        if (!_) {
          var E = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: C.style.opacity } };
          C.scaleX = C.scaleY = 0, C.style.opacity = 0, bc(C, E, p4, o);
        }
      }
      _ && this.childAt(0).stopAnimation("leave");
    }, n2.prototype._updateCommon = function(e2, o, l4, c4, h) {
      var p4 = this.childAt(0), g4 = e2.hostModel, y4, _, w4, C, E, T, O, N, V;
      if (c4 && (y4 = c4.emphasisItemStyle, _ = c4.blurItemStyle, w4 = c4.selectItemStyle, C = c4.focus, E = c4.blurScope, O = c4.labelStatesModels, N = c4.hoverScale, V = c4.cursorStyle, T = c4.emphasisDisabled), !c4 || e2.hasItemOption) {
        var H = c4 && c4.itemModel ? c4.itemModel : e2.getItemModel(o), X = H.getModel("emphasis");
        y4 = X.getModel("itemStyle").getItemStyle(), w4 = H.getModel(["select", "itemStyle"]).getItemStyle(), _ = H.getModel(["blur", "itemStyle"]).getItemStyle(), C = X.get("focus"), E = X.get("blurScope"), T = X.get("disabled"), O = zd(H), N = X.getShallow("scale"), V = H.getShallow("cursor");
      }
      var q2 = e2.getItemVisual(o, "symbolRotate");
      p4.attr("rotation", (q2 || 0) * Math.PI / 180 || 0);
      var de = nL(e2.getItemVisual(o, "symbolOffset"), l4);
      de && (p4.x = de[0], p4.y = de[1]), V && p4.attr("cursor", V);
      var le = e2.getItemVisual(o, "style"), me = le.fill;
      if (p4 instanceof Ap) {
        var ye = p4.style;
        p4.useStyle(rr({ image: ye.image, x: ye.x, y: ye.y, width: ye.width, height: ye.height }, le));
      } else
        p4.__isEmptyBrush ? p4.useStyle(rr({}, le)) : p4.useStyle(le), p4.style.decal = null, p4.setColor(me, h && h.symbolInnerColor), p4.style.strokeNoScale = true;
      var be = e2.getItemVisual(o, "liftZ"), we = this._z2;
      be != null ? we == null && (this._z2 = p4.z2, p4.z2 += be) : we != null && (p4.z2 = we, this._z2 = null);
      var Pe = h && h.useNameLabel;
      yv(p4, O, { labelFetcher: g4, labelDataIndex: o, defaultText: ze, inheritColor: me, defaultOpacity: le.opacity });
      function ze(ft) {
        return Pe ? e2.getName(ft) : N3(e2, ft);
      }
      this._sizeX = l4[0] / 2, this._sizeY = l4[1] / 2;
      var Re = p4.ensureState("emphasis");
      if (Re.style = y4, p4.ensureState("select").style = w4, p4.ensureState("blur").style = _, N) {
        var rt2 = Math.max(1.1, 3 / this._sizeY);
        Re.scaleX = this._sizeX * rt2, Re.scaleY = this._sizeY * rt2;
      }
      this.setSymbolScale(1), pf(this, C, E, T);
    }, n2.prototype.setSymbolScale = function(e2) {
      this.scaleX = this.scaleY = e2;
    }, n2.prototype.fadeOut = function(e2, o, l4) {
      var c4 = this.childAt(0), h = Fi(this).dataIndex, p4 = l4 && l4.animation;
      if (this.silent = c4.silent = true, l4 && l4.fadeLabel) {
        var g4 = c4.getTextContent();
        g4 && JC(g4, { style: { opacity: 0 } }, o, { dataIndex: h, removeOpt: p4, cb: function() {
          c4.removeTextContent();
        } });
      } else
        c4.removeTextContent();
      JC(c4, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, o, { dataIndex: h, cb: e2, removeOpt: p4 });
    }, n2.getSymbolSize = function(e2, o) {
      return U8(e2.getItemVisual(o, "symbolSize"));
    }, n2;
  }(Ti);
  function pvt(i, n2) {
    this.parent.drift(i, n2);
  }
  var X8 = dvt;
  function nae(i, n2, e2, o) {
    return n2 && !isNaN(n2[0]) && !isNaN(n2[1]) && !(o.isIgnore && o.isIgnore(e2)) && !(o.clipShape && !o.clipShape.contain(n2[0], n2[1])) && i.getItemVisual(e2, "symbol") !== "none";
  }
  function OSe(i) {
    return i != null && !mi(i) && (i = { isIgnore: i }), i || {};
  }
  function RSe(i) {
    var n2 = i.hostModel, e2 = n2.getModel("emphasis");
    return { emphasisItemStyle: e2.getModel("itemStyle").getItemStyle(), blurItemStyle: n2.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: n2.getModel(["select", "itemStyle"]).getItemStyle(), focus: e2.get("focus"), blurScope: e2.get("blurScope"), emphasisDisabled: e2.get("disabled"), hoverScale: e2.get("scale"), labelStatesModels: zd(n2), cursorStyle: n2.get("cursor") };
  }
  var vvt = function() {
    function i(n2) {
      this.group = new Ti(), this._SymbolCtor = n2 || X8;
    }
    return i.prototype.updateData = function(n2, e2) {
      this._progressiveEls = null, e2 = OSe(e2);
      var o = this.group, l4 = n2.hostModel, c4 = this._data, h = this._SymbolCtor, p4 = e2.disableAnimation, g4 = RSe(n2), y4 = { disableAnimation: p4 }, _ = e2.getSymbolPoint || function(w4) {
        return n2.getItemLayout(w4);
      };
      c4 || o.removeAll(), n2.diff(c4).add(function(w4) {
        var C = _(w4);
        if (nae(n2, C, w4, e2)) {
          var E = new h(n2, w4, g4, y4);
          E.setPosition(C), n2.setItemGraphicEl(w4, E), o.add(E);
        }
      }).update(function(w4, C) {
        var E = c4.getItemGraphicEl(C), T = _(w4);
        if (!nae(n2, T, w4, e2)) {
          o.remove(E);
          return;
        }
        var O = n2.getItemVisual(w4, "symbol") || "circle", N = E && E.getSymbolType && E.getSymbolType();
        if (!E || N && N !== O)
          o.remove(E), E = new h(n2, w4, g4, y4), E.setPosition(T);
        else {
          E.updateData(n2, w4, g4, y4);
          var V = { x: T[0], y: T[1] };
          p4 ? E.attr(V) : Vs(E, V, l4);
        }
        o.add(E), n2.setItemGraphicEl(w4, E);
      }).remove(function(w4) {
        var C = c4.getItemGraphicEl(w4);
        C && C.fadeOut(function() {
          o.remove(C);
        }, l4);
      }).execute(), this._getSymbolPoint = _, this._data = n2;
    }, i.prototype.updateLayout = function() {
      var n2 = this, e2 = this._data;
      e2 && e2.eachItemGraphicEl(function(o, l4) {
        var c4 = n2._getSymbolPoint(l4);
        o.setPosition(c4), o.markRedraw();
      });
    }, i.prototype.incrementalPrepareUpdate = function(n2) {
      this._seriesScope = RSe(n2), this._data = null, this.group.removeAll();
    }, i.prototype.incrementalUpdate = function(n2, e2, o) {
      this._progressiveEls = [], o = OSe(o);
      function l4(g4) {
        g4.isGroup || (g4.incremental = true, g4.ensureState("emphasis").hoverLayer = true);
      }
      for (var c4 = n2.start; c4 < n2.end; c4++) {
        var h = e2.getItemLayout(c4);
        if (nae(e2, h, c4, o)) {
          var p4 = new this._SymbolCtor(e2, c4, this._seriesScope);
          p4.traverse(l4), p4.setPosition(h), this.group.add(p4), e2.setItemGraphicEl(c4, p4), this._progressiveEls.push(p4);
        }
      }
    }, i.prototype.eachRendered = function(n2) {
      oM(this._progressiveEls || this.group, n2);
    }, i.prototype.remove = function(n2) {
      var e2 = this.group, o = this._data;
      o && n2 ? o.eachItemGraphicEl(function(l4) {
        l4.fadeOut(function() {
          e2.remove(l4);
        }, o.hostModel);
      }) : e2.removeAll();
    }, i;
  }(), K8 = vvt;
  function Lke(i, n2, e2) {
    var o = i.getBaseAxis(), l4 = i.getOtherAxis(o), c4 = gvt(l4, e2), h = o.dim, p4 = l4.dim, g4 = n2.mapDimension(p4), y4 = n2.mapDimension(h), _ = p4 === "x" || p4 === "radius" ? 1 : 0, w4 = Er(i.dimensions, function(T) {
      return n2.mapDimension(T);
    }), C = false, E = n2.getCalculationInfo("stackResultDimension");
    return eM(n2, w4[0]) && (C = true, w4[0] = E), eM(n2, w4[1]) && (C = true, w4[1] = E), { dataDimsForPoint: w4, valueStart: c4, valueAxisDim: p4, baseAxisDim: h, stacked: !!C, valueDim: g4, baseDim: y4, baseDataOffset: _, stackedOverDimension: n2.getCalculationInfo("stackedOverDimension") };
  }
  function gvt(i, n2) {
    var e2 = 0, o = i.scale.getExtent();
    return n2 === "start" ? e2 = o[0] : n2 === "end" ? e2 = o[1] : o[0] > 0 ? e2 = o[0] : o[1] < 0 && (e2 = o[1]), e2;
  }
  function Oke(i, n2, e2, o) {
    var l4 = NaN;
    i.stacked && (l4 = e2.get(e2.getCalculationInfo("stackedOverDimension"), o)), isNaN(l4) && (l4 = i.valueStart);
    var c4 = i.baseDataOffset, h = [];
    return h[c4] = e2.get(i.baseDim, o), h[1 - c4] = l4, n2.dataToPoint(h);
  }
  function mvt(i, n2) {
    var e2 = [];
    return n2.diff(i).add(function(o) {
      e2.push({ cmd: "+", idx: o });
    }).update(function(o, l4) {
      e2.push({ cmd: "=", idx: l4, idx1: o });
    }).remove(function(o) {
      e2.push({ cmd: "-", idx: o });
    }).execute(), e2;
  }
  function yvt(i, n2, e2, o, l4, c4, h, p4) {
    for (var g4 = mvt(i, n2), y4 = [], _ = [], w4 = [], C = [], E = [], T = [], O = [], N = Lke(l4, n2, h), V = i.getLayout("points") || [], H = n2.getLayout("points") || [], X = 0; X < g4.length; X++) {
      var q2 = g4[X], de = true, le = void 0, me = void 0;
      switch (q2.cmd) {
        case "=":
          le = q2.idx * 2, me = q2.idx1 * 2;
          var ye = V[le], be = V[le + 1], we = H[me], Pe = H[me + 1];
          (isNaN(ye) || isNaN(be)) && (ye = we, be = Pe), y4.push(ye, be), _.push(we, Pe), w4.push(e2[le], e2[le + 1]), C.push(o[me], o[me + 1]), O.push(n2.getRawIndex(q2.idx1));
          break;
        case "+":
          var ze = q2.idx, Re = N.dataDimsForPoint, rt2 = l4.dataToPoint([n2.get(Re[0], ze), n2.get(Re[1], ze)]);
          me = ze * 2, y4.push(rt2[0], rt2[1]), _.push(H[me], H[me + 1]);
          var ft = Oke(N, l4, n2, ze);
          w4.push(ft[0], ft[1]), C.push(o[me], o[me + 1]), O.push(n2.getRawIndex(ze));
          break;
        case "-":
          de = false;
      }
      de && (E.push(q2), T.push(T.length));
    }
    T.sort(function(Za, $a) {
      return O[Za] - O[$a];
    });
    for (var et = y4.length, Jt = j_(et), xt = j_(et), It = j_(et), Wt = j_(et), sn = [], X = 0; X < T.length; X++) {
      var vn = T[X], $r = X * 2, ga = vn * 2;
      Jt[$r] = y4[ga], Jt[$r + 1] = y4[ga + 1], xt[$r] = _[ga], xt[$r + 1] = _[ga + 1], It[$r] = w4[ga], It[$r + 1] = w4[ga + 1], Wt[$r] = C[ga], Wt[$r + 1] = C[ga + 1], sn[X] = E[vn];
    }
    return { current: Jt, next: xt, stackedOnCurrent: It, stackedOnNext: Wt, status: sn };
  }
  var IC = Math.min, TC = Math.max;
  function pT(i, n2) {
    return isNaN(i) || isNaN(n2);
  }
  function Coe(i, n2, e2, o, l4, c4, h, p4, g4) {
    for (var y4, _, w4, C, E, T, O = e2, N = 0; N < o; N++) {
      var V = n2[O * 2], H = n2[O * 2 + 1];
      if (O >= l4 || O < 0)
        break;
      if (pT(V, H)) {
        if (g4) {
          O += c4;
          continue;
        }
        break;
      }
      if (O === e2)
        i[c4 > 0 ? "moveTo" : "lineTo"](V, H), w4 = V, C = H;
      else {
        var X = V - y4, q2 = H - _;
        if (X * X + q2 * q2 < 0.5) {
          O += c4;
          continue;
        }
        if (h > 0) {
          for (var de = O + c4, le = n2[de * 2], me = n2[de * 2 + 1]; le === V && me === H && N < o; )
            N++, de += c4, O += c4, le = n2[de * 2], me = n2[de * 2 + 1], V = n2[O * 2], H = n2[O * 2 + 1], X = V - y4, q2 = H - _;
          var ye = N + 1;
          if (g4)
            for (; pT(le, me) && ye < o; )
              ye++, de += c4, le = n2[de * 2], me = n2[de * 2 + 1];
          var be = 0.5, we = 0, Pe = 0, ze = void 0, Re = void 0;
          if (ye >= o || pT(le, me))
            E = V, T = H;
          else {
            we = le - y4, Pe = me - _;
            var rt2 = V - y4, ft = le - V, et = H - _, Jt = me - H, xt = void 0, It = void 0;
            if (p4 === "x") {
              xt = Math.abs(rt2), It = Math.abs(ft);
              var Wt = we > 0 ? 1 : -1;
              E = V - Wt * xt * h, T = H, ze = V + Wt * It * h, Re = H;
            } else if (p4 === "y") {
              xt = Math.abs(et), It = Math.abs(Jt);
              var sn = Pe > 0 ? 1 : -1;
              E = V, T = H - sn * xt * h, ze = V, Re = H + sn * It * h;
            } else
              xt = Math.sqrt(rt2 * rt2 + et * et), It = Math.sqrt(ft * ft + Jt * Jt), be = It / (It + xt), E = V - we * h * (1 - be), T = H - Pe * h * (1 - be), ze = V + we * h * be, Re = H + Pe * h * be, ze = IC(ze, TC(le, V)), Re = IC(Re, TC(me, H)), ze = TC(ze, IC(le, V)), Re = TC(Re, IC(me, H)), we = ze - V, Pe = Re - H, E = V - we * xt / It, T = H - Pe * xt / It, E = IC(E, TC(y4, V)), T = IC(T, TC(_, H)), E = TC(E, IC(y4, V)), T = TC(T, IC(_, H)), we = V - E, Pe = H - T, ze = V + we * It / xt, Re = H + Pe * It / xt;
          }
          i.bezierCurveTo(w4, C, E, T, V, H), w4 = ze, C = Re;
        } else
          i.lineTo(V, H);
      }
      y4 = V, _ = H, O += c4;
    }
    return N;
  }
  var Rke = function() {
    function i() {
      this.smooth = 0, this.smoothConstraint = true;
    }
    return i;
  }(), bvt = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "ec-polyline", o;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new Rke();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.points, c4 = 0, h = l4.length / 2;
      if (o.connectNulls) {
        for (; h > 0 && pT(l4[h * 2 - 2], l4[h * 2 - 1]); h--)
          ;
        for (; c4 < h && pT(l4[c4 * 2], l4[c4 * 2 + 1]); c4++)
          ;
      }
      for (; c4 < h; )
        c4 += Coe(e2, l4, c4, h, h, 1, o.smooth, o.smoothMonotone, o.connectNulls) + 1;
    }, n2.prototype.getPointOn = function(e2, o) {
      this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
      for (var l4 = this.path, c4 = l4.data, h = K_.CMD, p4, g4, y4 = o === "x", _ = [], w4 = 0; w4 < c4.length; ) {
        var C = c4[w4++], E = void 0, T = void 0, O = void 0, N = void 0, V = void 0, H = void 0, X = void 0;
        switch (C) {
          case h.M:
            p4 = c4[w4++], g4 = c4[w4++];
            break;
          case h.L:
            if (E = c4[w4++], T = c4[w4++], X = y4 ? (e2 - p4) / (E - p4) : (e2 - g4) / (T - g4), X <= 1 && X >= 0) {
              var q2 = y4 ? (T - g4) * X + g4 : (E - p4) * X + p4;
              return y4 ? [e2, q2] : [q2, e2];
            }
            p4 = E, g4 = T;
            break;
          case h.C:
            E = c4[w4++], T = c4[w4++], O = c4[w4++], N = c4[w4++], V = c4[w4++], H = c4[w4++];
            var de = y4 ? yH(p4, E, O, V, e2, _) : yH(g4, T, N, H, e2, _);
            if (de > 0)
              for (var le = 0; le < de; le++) {
                var me = _[le];
                if (me <= 1 && me >= 0) {
                  var q2 = y4 ? Kh(g4, T, N, H, me) : Kh(p4, E, O, V, me);
                  return y4 ? [e2, q2] : [q2, e2];
                }
              }
            p4 = V, g4 = H;
            break;
        }
      }
    }, n2;
  }(Eo), _vt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2;
  }(Rke), Fke = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "ec-polygon", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new _vt();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.points, c4 = o.stackedOnPoints, h = 0, p4 = l4.length / 2, g4 = o.smoothMonotone;
      if (o.connectNulls) {
        for (; p4 > 0 && pT(l4[p4 * 2 - 2], l4[p4 * 2 - 1]); p4--)
          ;
        for (; h < p4 && pT(l4[h * 2], l4[h * 2 + 1]); h++)
          ;
      }
      for (; h < p4; ) {
        var y4 = Coe(e2, l4, h, p4, p4, 1, o.smooth, g4, o.connectNulls);
        Coe(e2, c4, h + y4 - 1, y4, p4, -1, o.stackedOnSmooth, g4, o.connectNulls), h += y4 + 1, e2.closePath();
      }
    }, n2;
  }(Eo);
  function Nke(i, n2, e2, o, l4) {
    var c4 = i.getArea(), h = c4.x, p4 = c4.y, g4 = c4.width, y4 = c4.height, _ = e2.get(["lineStyle", "width"]) || 2;
    h -= _ / 2, p4 -= _ / 2, g4 += _, y4 += _, h = Math.floor(h), g4 = Math.round(g4);
    var w4 = new Is({ shape: { x: h, y: p4, width: g4, height: y4 } });
    if (n2) {
      var C = i.getBaseAxis(), E = C.isHorizontal(), T = C.inverse;
      E ? (T && (w4.shape.x += g4), w4.shape.width = 0) : (T || (w4.shape.y += y4), w4.shape.height = 0);
      var O = si(l4) ? function(N) {
        l4(N, w4);
      } : null;
      bc(w4, { shape: { width: g4, height: y4, x: h, y: p4 } }, e2, null, o, O);
    }
    return w4;
  }
  function Vke(i, n2, e2) {
    var o = i.getArea(), l4 = df(o.r0, 1), c4 = df(o.r, 1), h = new Hg({ shape: { cx: df(i.cx, 1), cy: df(i.cy, 1), r0: l4, r: c4, startAngle: o.startAngle, endAngle: o.endAngle, clockwise: o.clockwise } });
    if (n2) {
      var p4 = i.getBaseAxis().dim === "angle";
      p4 ? h.shape.endAngle = o.startAngle : h.shape.r = l4, bc(h, { shape: { endAngle: o.endAngle, r: c4 } }, e2);
    }
    return h;
  }
  function q$(i, n2, e2, o, l4) {
    if (i) {
      if (i.type === "polar")
        return Vke(i, n2, e2);
      if (i.type === "cartesian2d")
        return Nke(i, n2, e2, o, l4);
    } else
      return null;
    return null;
  }
  function v22(i, n2) {
    return i.type === n2;
  }
  function FSe(i, n2) {
    if (i.length === n2.length) {
      for (var e2 = 0; e2 < i.length; e2++)
        if (i[e2] !== n2[e2])
          return;
      return true;
    }
  }
  function NSe(i) {
    for (var n2 = 1 / 0, e2 = 1 / 0, o = -1 / 0, l4 = -1 / 0, c4 = 0; c4 < i.length; ) {
      var h = i[c4++], p4 = i[c4++];
      isNaN(h) || (n2 = Math.min(h, n2), o = Math.max(h, o)), isNaN(p4) || (e2 = Math.min(p4, e2), l4 = Math.max(p4, l4));
    }
    return [[n2, e2], [o, l4]];
  }
  function VSe(i, n2) {
    var e2 = NSe(i), o = e2[0], l4 = e2[1], c4 = NSe(n2), h = c4[0], p4 = c4[1];
    return Math.max(Math.abs(o[0] - h[0]), Math.abs(o[1] - h[1]), Math.abs(l4[0] - p4[0]), Math.abs(l4[1] - p4[1]));
  }
  function zSe(i) {
    return sl(i) ? i : i ? 0.5 : 0;
  }
  function xvt(i, n2, e2) {
    if (!e2.valueDim)
      return [];
    for (var o = n2.count(), l4 = j_(o * 2), c4 = 0; c4 < o; c4++) {
      var h = Oke(e2, i, n2, c4);
      l4[c4 * 2] = h[0], l4[c4 * 2 + 1] = h[1];
    }
    return l4;
  }
  function DC(i, n2, e2, o) {
    var l4 = n2.getBaseAxis(), c4 = l4.dim === "x" || l4.dim === "radius" ? 0 : 1, h = [], p4 = 0, g4 = [], y4 = [], _ = [], w4 = [];
    if (o) {
      for (p4 = 0; p4 < i.length; p4 += 2)
        !isNaN(i[p4]) && !isNaN(i[p4 + 1]) && w4.push(i[p4], i[p4 + 1]);
      i = w4;
    }
    for (p4 = 0; p4 < i.length - 2; p4 += 2)
      switch (_[0] = i[p4 + 2], _[1] = i[p4 + 3], y4[0] = i[p4], y4[1] = i[p4 + 1], h.push(y4[0], y4[1]), e2) {
        case "end":
          g4[c4] = _[c4], g4[1 - c4] = y4[1 - c4], h.push(g4[0], g4[1]);
          break;
        case "middle":
          var C = (y4[c4] + _[c4]) / 2, E = [];
          g4[c4] = E[c4] = C, g4[1 - c4] = y4[1 - c4], E[1 - c4] = _[1 - c4], h.push(g4[0], g4[1]), h.push(E[0], E[1]);
          break;
        default:
          g4[c4] = y4[c4], g4[1 - c4] = _[1 - c4], h.push(g4[0], g4[1]);
      }
    return h.push(i[p4++], i[p4++]), h;
  }
  function wvt(i, n2) {
    var e2 = [], o = i.length, l4, c4;
    function h(_, w4, C) {
      var E = _.coord, T = (C - E) / (w4.coord - E), O = Cot(T, [_.color, w4.color]);
      return { coord: C, color: O };
    }
    for (var p4 = 0; p4 < o; p4++) {
      var g4 = i[p4], y4 = g4.coord;
      if (y4 < 0)
        l4 = g4;
      else if (y4 > n2) {
        c4 ? e2.push(h(c4, g4, n2)) : l4 && e2.push(h(l4, g4, 0), h(l4, g4, n2));
        break;
      } else
        l4 && (e2.push(h(l4, g4, 0)), l4 = null), e2.push(g4), c4 = g4;
    }
    return e2;
  }
  function Svt(i, n2, e2) {
    var o = i.getVisual("visualMeta");
    if (!(!o || !o.length || !i.count()) && n2.type === "cartesian2d") {
      for (var l4, c4, h = o.length - 1; h >= 0; h--) {
        var p4 = i.getDimensionInfo(o[h].dimension);
        if (l4 = p4 && p4.coordDim, l4 === "x" || l4 === "y") {
          c4 = o[h];
          break;
        }
      }
      if (!!c4) {
        var g4 = n2.getAxis(l4), y4 = Er(c4.stops, function(X) {
          return { coord: g4.toGlobalCoord(g4.dataToCoord(X.value)), color: X.color };
        }), _ = y4.length, w4 = c4.outerColors.slice();
        _ && y4[0].coord > y4[_ - 1].coord && (y4.reverse(), w4.reverse());
        var C = wvt(y4, l4 === "x" ? e2.getWidth() : e2.getHeight()), E = C.length;
        if (!E && _)
          return y4[0].coord < 0 ? w4[1] ? w4[1] : y4[_ - 1].color : w4[0] ? w4[0] : y4[0].color;
        var T = 10, O = C[0].coord - T, N = C[E - 1].coord + T, V = N - O;
        if (V < 1e-3)
          return "transparent";
        Ve(C, function(X) {
          X.offset = (X.coord - O) / V;
        }), C.push({ offset: E ? C[E - 1].offset : 0.5, color: w4[1] || "transparent" }), C.unshift({ offset: E ? C[0].offset : 0.5, color: w4[0] || "transparent" });
        var H = new B8(0, 0, 0, 0, C, true);
        return H[l4] = O, H[l4 + "2"] = N, H;
      }
    }
  }
  function Cvt(i, n2, e2) {
    var o = i.get("showAllSymbol"), l4 = o === "auto";
    if (!(o && !l4)) {
      var c4 = e2.getAxesByScale("ordinal")[0];
      if (!!c4 && !(l4 && Mvt(c4, n2))) {
        var h = n2.mapDimension(c4.dim), p4 = {};
        return Ve(c4.getViewLabels(), function(g4) {
          var y4 = c4.scale.getRawOrdinalNumber(g4.tickValue);
          p4[y4] = 1;
        }), function(g4) {
          return !p4.hasOwnProperty(n2.get(h, g4));
        };
      }
    }
  }
  function Mvt(i, n2) {
    var e2 = i.getExtent(), o = Math.abs(e2[1] - e2[0]) / i.scale.count();
    isNaN(o) && (o = 0);
    for (var l4 = n2.count(), c4 = Math.max(1, Math.round(l4 / 5)), h = 0; h < l4; h += c4)
      if (X8.getSymbolSize(n2, h)[i.isHorizontal() ? 1 : 0] * 1.5 > o)
        return false;
    return true;
  }
  function Avt(i, n2) {
    return isNaN(i) || isNaN(n2);
  }
  function Evt(i) {
    for (var n2 = i.length / 2; n2 > 0 && Avt(i[n2 * 2 - 2], i[n2 * 2 - 1]); n2--)
      ;
    return n2 - 1;
  }
  function BSe(i, n2) {
    return [i[n2 * 2], i[n2 * 2 + 1]];
  }
  function Ivt(i, n2, e2) {
    for (var o = i.length / 2, l4 = e2 === "x" ? 0 : 1, c4, h, p4 = 0, g4 = -1, y4 = 0; y4 < o; y4++)
      if (h = i[y4 * 2 + l4], !(isNaN(h) || isNaN(i[y4 * 2 + 1 - l4]))) {
        if (y4 === 0) {
          c4 = h;
          continue;
        }
        if (c4 <= n2 && h >= n2 || c4 >= n2 && h <= n2) {
          g4 = y4;
          break;
        }
        p4 = y4, c4 = h;
      }
    return { range: [p4, g4], t: (n2 - c4) / (h - c4) };
  }
  function zke(i) {
    if (i.get(["endLabel", "show"]))
      return true;
    for (var n2 = 0; n2 < Jv.length; n2++)
      if (i.get([Jv[n2], "endLabel", "show"]))
        return true;
    return false;
  }
  function rae(i, n2, e2, o) {
    if (v22(n2, "cartesian2d")) {
      var l4 = o.getModel("endLabel"), c4 = l4.get("valueAnimation"), h = o.getData(), p4 = { lastFrameIndex: 0 }, g4 = zke(o) ? function(E, T) {
        i._endLabelOnDuring(E, T, h, p4, c4, l4, n2);
      } : null, y4 = n2.getBaseAxis().isHorizontal(), _ = Nke(n2, e2, o, function() {
        var E = i._endLabel;
        E && e2 && p4.originalX != null && E.attr({ x: p4.originalX, y: p4.originalY });
      }, g4);
      if (!o.get("clip", true)) {
        var w4 = _.shape, C = Math.max(w4.width, w4.height);
        y4 ? (w4.y -= C, w4.height += C * 2) : (w4.x -= C, w4.width += C * 2);
      }
      return g4 && g4(1, _), _;
    } else
      return Vke(n2, e2, o);
  }
  function Tvt(i, n2) {
    var e2 = n2.getBaseAxis(), o = e2.isHorizontal(), l4 = e2.inverse, c4 = o ? l4 ? "right" : "left" : "center", h = o ? "middle" : l4 ? "top" : "bottom";
    return { normal: { align: i.get("align") || c4, verticalAlign: i.get("verticalAlign") || h } };
  }
  var Dvt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.init = function() {
      var e2 = new Ti(), o = new K8();
      this.group.add(o.group), this._symbolDraw = o, this._lineGroup = e2;
    }, n2.prototype.render = function(e2, o, l4) {
      var c4 = this, h = e2.coordinateSystem, p4 = this.group, g4 = e2.getData(), y4 = e2.getModel("lineStyle"), _ = e2.getModel("areaStyle"), w4 = g4.getLayout("points") || [], C = h.type === "polar", E = this._coordSys, T = this._symbolDraw, O = this._polyline, N = this._polygon, V = this._lineGroup, H = e2.get("animation"), X = !_.isEmpty(), q2 = _.get("origin"), de = Lke(h, g4, q2), le = X && xvt(h, g4, de), me = e2.get("showSymbol"), ye = e2.get("connectNulls"), be = me && !C && Cvt(e2, g4, h), we = this._data;
      we && we.eachItemGraphicEl(function($a, Pa) {
        $a.__temp && (p4.remove($a), we.setItemGraphicEl(Pa, null));
      }), me || T.remove(), p4.add(V);
      var Pe = C ? false : e2.get("step"), ze;
      h && h.getArea && e2.get("clip", true) && (ze = h.getArea(), ze.width != null ? (ze.x -= 0.1, ze.y -= 0.1, ze.width += 0.2, ze.height += 0.2) : ze.r0 && (ze.r0 -= 0.5, ze.r += 0.5)), this._clipShapeForSymbol = ze;
      var Re = Svt(g4, h, l4) || g4.getVisual("style")[g4.getVisual("drawType")];
      if (!(O && E.type === h.type && Pe === this._step))
        me && T.updateData(g4, { isIgnore: be, clipShape: ze, disableAnimation: true, getSymbolPoint: function($a) {
          return [w4[$a * 2], w4[$a * 2 + 1]];
        } }), H && this._initSymbolLabelAnimation(g4, h, ze), Pe && (w4 = DC(w4, h, Pe, ye), le && (le = DC(le, h, Pe, ye))), O = this._newPolyline(w4), X && (N = this._newPolygon(w4, le)), C || this._initOrUpdateEndLabel(e2, h, xT(Re)), V.setClipPath(rae(this, h, true, e2));
      else {
        X && !N ? N = this._newPolygon(w4, le) : N && !X && (V.remove(N), N = this._polygon = null), C || this._initOrUpdateEndLabel(e2, h, xT(Re));
        var rt2 = V.getClipPath();
        if (rt2) {
          var ft = rae(this, h, false, e2);
          bc(rt2, { shape: ft.shape }, e2);
        } else
          V.setClipPath(rae(this, h, true, e2));
        me && T.updateData(g4, { isIgnore: be, clipShape: ze, disableAnimation: true, getSymbolPoint: function($a) {
          return [w4[$a * 2], w4[$a * 2 + 1]];
        } }), (!FSe(this._stackedOnPoints, le) || !FSe(this._points, w4)) && (H ? this._doUpdateAnimation(g4, le, h, l4, Pe, q2, ye) : (Pe && (w4 = DC(w4, h, Pe, ye), le && (le = DC(le, h, Pe, ye))), O.setShape({ points: w4 }), N && N.setShape({ points: w4, stackedOnPoints: le })));
      }
      var et = e2.getModel("emphasis"), Jt = et.get("focus"), xt = et.get("blurScope"), It = et.get("disabled");
      if (O.useStyle(hi(y4.getLineStyle(), { fill: "none", stroke: Re, lineJoin: "bevel" })), Mp(O, e2, "lineStyle"), O.style.lineWidth > 0 && e2.get(["emphasis", "lineStyle", "width"]) === "bolder") {
        var Wt = O.getState("emphasis").style;
        Wt.lineWidth = +O.style.lineWidth + 1;
      }
      Fi(O).seriesIndex = e2.seriesIndex, pf(O, Jt, xt, It);
      var sn = zSe(e2.get("smooth")), vn = e2.get("smoothMonotone");
      if (O.setShape({ smooth: sn, smoothMonotone: vn, connectNulls: ye }), N) {
        var $r = g4.getCalculationInfo("stackedOnSeries"), ga = 0;
        N.useStyle(hi(_.getAreaStyle(), { fill: Re, opacity: 0.7, lineJoin: "bevel", decal: g4.getVisual("style").decal })), $r && (ga = zSe($r.get("smooth"))), N.setShape({ smooth: sn, stackedOnSmooth: ga, smoothMonotone: vn, connectNulls: ye }), Mp(N, e2, "areaStyle"), Fi(N).seriesIndex = e2.seriesIndex, pf(N, Jt, xt, It);
      }
      var Za = function($a) {
        c4._changePolyState($a);
      };
      g4.eachItemGraphicEl(function($a) {
        $a && ($a.onHoverStateChange = Za);
      }), this._polyline.onHoverStateChange = Za, this._data = g4, this._coordSys = h, this._stackedOnPoints = le, this._points = w4, this._step = Pe, this._valueOrigin = q2, e2.get("triggerLineEvent") && (this.packEventData(e2, O), N && this.packEventData(e2, N));
    }, n2.prototype.packEventData = function(e2, o) {
      Fi(o).eventData = { componentType: "series", componentSubType: "line", componentIndex: e2.componentIndex, seriesIndex: e2.seriesIndex, seriesName: e2.name, seriesType: "line" };
    }, n2.prototype.highlight = function(e2, o, l4, c4) {
      var h = e2.getData(), p4 = yT(h, c4);
      if (this._changePolyState("emphasis"), !(p4 instanceof Array) && p4 != null && p4 >= 0) {
        var g4 = h.getLayout("points"), y4 = h.getItemGraphicEl(p4);
        if (!y4) {
          var _ = g4[p4 * 2], w4 = g4[p4 * 2 + 1];
          if (isNaN(_) || isNaN(w4) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(_, w4))
            return;
          var C = e2.get("zlevel"), E = e2.get("z");
          y4 = new X8(h, p4), y4.x = _, y4.y = w4, y4.setZ(C, E);
          var T = y4.getSymbolPath().getTextContent();
          T && (T.zlevel = C, T.z = E, T.z2 = this._polyline.z2 + 1), y4.__temp = true, h.setItemGraphicEl(p4, y4), y4.stopSymbolAnimation(true), this.group.add(y4);
        }
        y4.highlight();
      } else
        Ru.prototype.highlight.call(this, e2, o, l4, c4);
    }, n2.prototype.downplay = function(e2, o, l4, c4) {
      var h = e2.getData(), p4 = yT(h, c4);
      if (this._changePolyState("normal"), p4 != null && p4 >= 0) {
        var g4 = h.getItemGraphicEl(p4);
        g4 && (g4.__temp ? (h.setItemGraphicEl(p4, null), this.group.remove(g4)) : g4.downplay());
      } else
        Ru.prototype.downplay.call(this, e2, o, l4, c4);
    }, n2.prototype._changePolyState = function(e2) {
      var o = this._polygon;
      AH(this._polyline, e2), o && AH(o, e2);
    }, n2.prototype._newPolyline = function(e2) {
      var o = this._polyline;
      return o && this._lineGroup.remove(o), o = new bvt({ shape: { points: e2 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(o), this._polyline = o, o;
    }, n2.prototype._newPolygon = function(e2, o) {
      var l4 = this._polygon;
      return l4 && this._lineGroup.remove(l4), l4 = new Fke({ shape: { points: e2, stackedOnPoints: o }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(l4), this._polygon = l4, l4;
    }, n2.prototype._initSymbolLabelAnimation = function(e2, o, l4) {
      var c4, h, p4 = o.getBaseAxis(), g4 = p4.inverse;
      o.type === "cartesian2d" ? (c4 = p4.isHorizontal(), h = false) : o.type === "polar" && (c4 = p4.dim === "angle", h = true);
      var y4 = e2.hostModel, _ = y4.get("animationDuration");
      si(_) && (_ = _(null));
      var w4 = y4.get("animationDelay") || 0, C = si(w4) ? w4(null) : w4;
      e2.eachItemGraphicEl(function(E, T) {
        var O = E;
        if (O) {
          var N = [E.x, E.y], V = void 0, H = void 0, X = void 0;
          if (l4)
            if (h) {
              var q2 = l4, de = o.pointToCoord(N);
              c4 ? (V = q2.startAngle, H = q2.endAngle, X = -de[1] / 180 * Math.PI) : (V = q2.r0, H = q2.r, X = de[0]);
            } else {
              var le = l4;
              c4 ? (V = le.x, H = le.x + le.width, X = E.x) : (V = le.y + le.height, H = le.y, X = E.y);
            }
          var me = H === V ? 0 : (X - V) / (H - V);
          g4 && (me = 1 - me);
          var ye = si(w4) ? w4(T) : _ * me + C, be = O.getSymbolPath(), we = be.getTextContent();
          O.attr({ scaleX: 0, scaleY: 0 }), O.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: ye }), we && we.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: ye }), be.disableLabelAnimation = true;
        }
      });
    }, n2.prototype._initOrUpdateEndLabel = function(e2, o, l4) {
      var c4 = e2.getModel("endLabel");
      if (zke(e2)) {
        var h = e2.getData(), p4 = this._polyline, g4 = h.getLayout("points");
        if (!g4) {
          p4.removeTextContent(), this._endLabel = null;
          return;
        }
        var y4 = this._endLabel;
        y4 || (y4 = this._endLabel = new Qs({ z2: 200 }), y4.ignoreClip = true, p4.setTextContent(this._endLabel), p4.disableLabelAnimation = true);
        var _ = Evt(g4);
        _ >= 0 && (yv(p4, zd(e2, "endLabel"), { inheritColor: l4, labelFetcher: e2, labelDataIndex: _, defaultText: function(w4, C, E) {
          return E != null ? Pke(h, E) : N3(h, w4);
        }, enableTextSetter: true }, Tvt(c4, o)), p4.textConfig.position = null);
      } else
        this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
    }, n2.prototype._endLabelOnDuring = function(e2, o, l4, c4, h, p4, g4) {
      var y4 = this._endLabel, _ = this._polyline;
      if (y4) {
        e2 < 1 && c4.originalX == null && (c4.originalX = y4.x, c4.originalY = y4.y);
        var w4 = l4.getLayout("points"), C = l4.hostModel, E = C.get("connectNulls"), T = p4.get("precision"), O = p4.get("distance") || 0, N = g4.getBaseAxis(), V = N.isHorizontal(), H = N.inverse, X = o.shape, q2 = H ? V ? X.x : X.y + X.height : V ? X.x + X.width : X.y, de = (V ? O : 0) * (H ? -1 : 1), le = (V ? 0 : -O) * (H ? -1 : 1), me = V ? "x" : "y", ye = Ivt(w4, q2, me), be = ye.range, we = be[1] - be[0], Pe = void 0;
        if (we >= 1) {
          if (we > 1 && !E) {
            var ze = BSe(w4, be[0]);
            y4.attr({ x: ze[0] + de, y: ze[1] + le }), h && (Pe = C.getRawValue(be[0]));
          } else {
            var ze = _.getPointOn(q2, me);
            ze && y4.attr({ x: ze[0] + de, y: ze[1] + le });
            var Re = C.getRawValue(be[0]), rt2 = C.getRawValue(be[1]);
            h && (Pe = oTe(l4, T, Re, rt2, ye.t));
          }
          c4.lastFrameIndex = be[0];
        } else {
          var ft = e2 === 1 || c4.lastFrameIndex > 0 ? be[0] : 0, ze = BSe(w4, ft);
          h && (Pe = C.getRawValue(ft)), y4.attr({ x: ze[0] + de, y: ze[1] + le });
        }
        h && Y3(y4).setLabelText(Pe);
      }
    }, n2.prototype._doUpdateAnimation = function(e2, o, l4, c4, h, p4, g4) {
      var y4 = this._polyline, _ = this._polygon, w4 = e2.hostModel, C = yvt(this._data, e2, this._stackedOnPoints, o, this._coordSys, l4, this._valueOrigin), E = C.current, T = C.stackedOnCurrent, O = C.next, N = C.stackedOnNext;
      if (h && (E = DC(C.current, l4, h, g4), T = DC(C.stackedOnCurrent, l4, h, g4), O = DC(C.next, l4, h, g4), N = DC(C.stackedOnNext, l4, h, g4)), VSe(E, O) > 3e3 || _ && VSe(T, N) > 3e3) {
        y4.stopAnimation(), y4.setShape({ points: O }), _ && (_.stopAnimation(), _.setShape({ points: O, stackedOnPoints: N }));
        return;
      }
      y4.shape.__points = C.current, y4.shape.points = E;
      var V = { shape: { points: O } };
      C.current !== E && (V.shape.__points = C.next), y4.stopAnimation(), Vs(y4, V, w4), _ && (_.setShape({ points: E, stackedOnPoints: T }), _.stopAnimation(), Vs(_, { shape: { stackedOnPoints: N } }, w4), y4.shape.points !== _.shape.points && (_.shape.points = y4.shape.points));
      for (var H = [], X = C.status, q2 = 0; q2 < X.length; q2++) {
        var de = X[q2].cmd;
        if (de === "=") {
          var le = e2.getItemGraphicEl(X[q2].idx1);
          le && H.push({ el: le, ptIdx: q2 });
        }
      }
      y4.animators && y4.animators.length && y4.animators[0].during(function() {
        _ && _.dirtyShape();
        for (var me = y4.shape.__points, ye = 0; ye < H.length; ye++) {
          var be = H[ye].el, we = H[ye].ptIdx * 2;
          be.x = me[we], be.y = me[we + 1], be.markRedraw();
        }
      });
    }, n2.prototype.remove = function(e2) {
      var o = this.group, l4 = this._data;
      this._lineGroup.removeAll(), this._symbolDraw.remove(true), l4 && l4.eachItemGraphicEl(function(c4, h) {
        c4.__temp && (o.remove(c4), l4.setItemGraphicEl(h, null));
      }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
    }, n2.type = "line", n2;
  }(Ru), kvt = Dvt;
  function J8(i, n2) {
    return { seriesType: i, plan: eL(), reset: function(e2) {
      var o = e2.getData(), l4 = e2.coordinateSystem, c4 = e2.pipelineContext, h = n2 || c4.large;
      if (!!l4) {
        var p4 = Er(l4.dimensions, function(E) {
          return o.mapDimension(E);
        }).slice(0, 2), g4 = p4.length, y4 = o.getCalculationInfo("stackResultDimension");
        eM(o, p4[0]) && (p4[0] = y4), eM(o, p4[1]) && (p4[1] = y4);
        var _ = o.getStore(), w4 = o.getDimensionIndex(p4[0]), C = o.getDimensionIndex(p4[1]);
        return g4 && { progress: function(E, T) {
          for (var O = E.end - E.start, N = h && j_(O * g4), V = [], H = [], X = E.start, q2 = 0; X < E.end; X++) {
            var de = void 0;
            if (g4 === 1) {
              var le = _.get(w4, X);
              de = l4.dataToPoint(le, null, H);
            } else
              V[0] = _.get(w4, X), V[1] = _.get(C, X), de = l4.dataToPoint(V, null, H);
            h ? (N[q2++] = de[0], N[q2++] = de[1]) : T.setItemLayout(X, de.slice());
          }
          h && T.setLayout("points", N);
        } };
      }
    } };
  }
  var Pvt = { average: function(i) {
    for (var n2 = 0, e2 = 0, o = 0; o < i.length; o++)
      isNaN(i[o]) || (n2 += i[o], e2++);
    return e2 === 0 ? NaN : n2 / e2;
  }, sum: function(i) {
    for (var n2 = 0, e2 = 0; e2 < i.length; e2++)
      n2 += i[e2] || 0;
    return n2;
  }, max: function(i) {
    for (var n2 = -1 / 0, e2 = 0; e2 < i.length; e2++)
      i[e2] > n2 && (n2 = i[e2]);
    return isFinite(n2) ? n2 : NaN;
  }, min: function(i) {
    for (var n2 = 1 / 0, e2 = 0; e2 < i.length; e2++)
      i[e2] < n2 && (n2 = i[e2]);
    return isFinite(n2) ? n2 : NaN;
  }, nearest: function(i) {
    return i[0];
  } }, Lvt = function(i) {
    return Math.round(i.length / 2);
  };
  function Bke(i) {
    return { seriesType: i, reset: function(n2, e2, o) {
      var l4 = n2.getData(), c4 = n2.get("sampling"), h = n2.coordinateSystem, p4 = l4.count();
      if (p4 > 10 && h.type === "cartesian2d" && c4) {
        var g4 = h.getBaseAxis(), y4 = h.getOtherAxis(g4), _ = g4.getExtent(), w4 = o.getDevicePixelRatio(), C = Math.abs(_[1] - _[0]) * (w4 || 1), E = Math.round(p4 / C);
        if (isFinite(E) && E > 1) {
          c4 === "lttb" && n2.setData(l4.lttbDownSample(l4.mapDimension(y4.dim), 1 / E));
          var T = void 0;
          xa(c4) ? T = Pvt[c4] : si(c4) && (T = c4), T && n2.setData(l4.downSample(l4.mapDimension(y4.dim), 1 / E, T, Lvt));
        }
      }
    } };
  }
  function Ovt(i) {
    i.registerChartView(kvt), i.registerSeriesModel(hvt), i.registerLayout(J8("line", true)), i.registerVisual({ seriesType: "line", reset: function(n2) {
      var e2 = n2.getData(), o = n2.getModel("lineStyle").getLineStyle();
      o && !o.stroke && (o.stroke = e2.getVisual("style").fill), e2.setVisual("legendLineStyle", o);
    } }), i.registerProcessor(i.PRIORITY.PROCESSOR.STATISTIC, Bke("line"));
  }
  var jke = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      return M2(null, this, { useEncodeDefaulter: true });
    }, n2.prototype.getMarkerPosition = function(e2) {
      var o = this.coordinateSystem;
      if (o && o.clampData) {
        var l4 = o.dataToPoint(o.clampData(e2)), c4 = this.getData(), h = c4.getLayout("offset"), p4 = c4.getLayout("size"), g4 = o.getBaseAxis().isHorizontal() ? 0 : 1;
        return l4[g4] += h + p4 / 2, l4;
      }
      return [NaN, NaN];
    }, n2.type = "series.__base_bar__", n2.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, n2;
  }(_c2);
  _c2.registerClass(jke);
  var $H = jke, Rvt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.getInitialData = function() {
      return M2(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
    }, n2.prototype.getProgressive = function() {
      return this.get("large") ? this.get("progressive") : false;
    }, n2.prototype.getProgressiveThreshold = function() {
      var e2 = this.get("progressiveThreshold"), o = this.get("largeThreshold");
      return o > e2 && (e2 = o), e2;
    }, n2.prototype.brushSelector = function(e2, o, l4) {
      return l4.rect(o.getItemLayout(e2));
    }, n2.type = "series.bar", n2.dependencies = ["grid", "polar"], n2.defaultOption = sM($H.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), n2;
  }($H), Fvt = Rvt, Nvt = function() {
    function i() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return i;
  }(), Vvt = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "sausage", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new Nvt();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.cx, c4 = o.cy, h = Math.max(o.r0 || 0, 0), p4 = Math.max(o.r, 0), g4 = (p4 - h) * 0.5, y4 = h + g4, _ = o.startAngle, w4 = o.endAngle, C = o.clockwise, E = Math.PI * 2, T = C ? w4 - _ < E : _ - w4 < E;
      T || (_ = w4 - (C ? E : -E));
      var O = Math.cos(_), N = Math.sin(_), V = Math.cos(w4), H = Math.sin(w4);
      T ? (e2.moveTo(O * h + l4, N * h + c4), e2.arc(O * y4 + l4, N * y4 + c4, g4, -Math.PI + _, _, !C)) : e2.moveTo(O * p4 + l4, N * p4 + c4), e2.arc(l4, c4, p4, _, w4, !C), e2.arc(V * y4 + l4, H * y4 + c4, g4, w4 - Math.PI * 2, w4 - Math.PI, !C), h !== 0 && e2.arc(l4, c4, h, w4, _, C);
    }, n2;
  }(Eo), UH = Vvt;
  function zvt(i, n2) {
    n2 = n2 || {};
    var e2 = n2.isRoundCap;
    return function(o, l4, c4) {
      var h = l4.position;
      if (!h || h instanceof Array)
        return SH(o, l4, c4);
      var p4 = i(h), g4 = l4.distance != null ? l4.distance : 5, y4 = this.shape, _ = y4.cx, w4 = y4.cy, C = y4.r, E = y4.r0, T = (C + E) / 2, O = y4.startAngle, N = y4.endAngle, V = (O + N) / 2, H = e2 ? Math.abs(C - E) / 2 : 0, X = Math.cos, q2 = Math.sin, de = _ + C * X(O), le = w4 + C * q2(O), me = "left", ye = "top";
      switch (p4) {
        case "startArc":
          de = _ + (E - g4) * X(V), le = w4 + (E - g4) * q2(V), me = "center", ye = "top";
          break;
        case "insideStartArc":
          de = _ + (E + g4) * X(V), le = w4 + (E + g4) * q2(V), me = "center", ye = "bottom";
          break;
        case "startAngle":
          de = _ + T * X(O) + xW(O, g4 + H, false), le = w4 + T * q2(O) + wW(O, g4 + H, false), me = "right", ye = "middle";
          break;
        case "insideStartAngle":
          de = _ + T * X(O) + xW(O, -g4 + H, false), le = w4 + T * q2(O) + wW(O, -g4 + H, false), me = "left", ye = "middle";
          break;
        case "middle":
          de = _ + T * X(V), le = w4 + T * q2(V), me = "center", ye = "middle";
          break;
        case "endArc":
          de = _ + (C + g4) * X(V), le = w4 + (C + g4) * q2(V), me = "center", ye = "bottom";
          break;
        case "insideEndArc":
          de = _ + (C - g4) * X(V), le = w4 + (C - g4) * q2(V), me = "center", ye = "top";
          break;
        case "endAngle":
          de = _ + T * X(N) + xW(N, g4 + H, true), le = w4 + T * q2(N) + wW(N, g4 + H, true), me = "left", ye = "middle";
          break;
        case "insideEndAngle":
          de = _ + T * X(N) + xW(N, -g4 + H, true), le = w4 + T * q2(N) + wW(N, -g4 + H, true), me = "right", ye = "middle";
          break;
        default:
          return SH(o, l4, c4);
      }
      return o = o || {}, o.x = de, o.y = le, o.align = me, o.verticalAlign = ye, o;
    };
  }
  function Bvt(i, n2, e2, o) {
    if (sl(o)) {
      i.setTextConfig({ rotation: o });
      return;
    } else if (Mr(n2)) {
      i.setTextConfig({ rotation: 0 });
      return;
    }
    var l4 = i.shape, c4 = l4.clockwise ? l4.startAngle : l4.endAngle, h = l4.clockwise ? l4.endAngle : l4.startAngle, p4 = (c4 + h) / 2, g4, y4 = e2(n2);
    switch (y4) {
      case "startArc":
      case "insideStartArc":
      case "middle":
      case "insideEndArc":
      case "endArc":
        g4 = p4;
        break;
      case "startAngle":
      case "insideStartAngle":
        g4 = c4;
        break;
      case "endAngle":
      case "insideEndAngle":
        g4 = h;
        break;
      default:
        i.setTextConfig({ rotation: 0 });
        return;
    }
    var _ = Math.PI * 1.5 - g4;
    y4 === "middle" && _ > Math.PI / 2 && _ < Math.PI * 1.5 && (_ -= Math.PI), i.setTextConfig({ rotation: _ });
  }
  function xW(i, n2, e2) {
    return n2 * Math.sin(i) * (e2 ? -1 : 1);
  }
  function wW(i, n2, e2) {
    return n2 * Math.cos(i) * (e2 ? 1 : -1);
  }
  var aae = Math.max, iae = Math.min;
  function jvt(i, n2) {
    var e2 = i.getArea && i.getArea();
    if (v22(i, "cartesian2d")) {
      var o = i.getBaseAxis();
      if (o.type !== "category" || !o.onBand) {
        var l4 = n2.getLayout("bandWidth");
        o.isHorizontal() ? (e2.x -= l4, e2.width += l4 * 2) : (e2.y -= l4, e2.height += l4 * 2);
      }
    }
    return e2;
  }
  var Gvt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i.call(this) || this;
      return e2.type = n2.type, e2._isFirstFrame = true, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      this._model = e2, this._removeOnRenderedListener(l4), this._updateDrawMode(e2);
      var h = e2.get("coordinateSystem");
      (h === "cartesian2d" || h === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(e2, o, l4) : this._renderNormal(e2, o, l4, c4));
    }, n2.prototype.incrementalPrepareRender = function(e2) {
      this._clear(), this._updateDrawMode(e2), this._updateLargeClip(e2);
    }, n2.prototype.incrementalRender = function(e2, o) {
      this._progressiveEls = [], this._incrementalRenderLarge(e2, o);
    }, n2.prototype.eachRendered = function(e2) {
      oM(this._progressiveEls || this.group, e2);
    }, n2.prototype._updateDrawMode = function(e2) {
      var o = e2.pipelineContext.large;
      (this._isLargeDraw == null || o !== this._isLargeDraw) && (this._isLargeDraw = o, this._clear());
    }, n2.prototype._renderNormal = function(e2, o, l4, c4) {
      var h = this.group, p4 = e2.getData(), g4 = this._data, y4 = e2.coordinateSystem, _ = y4.getBaseAxis(), w4;
      y4.type === "cartesian2d" ? w4 = _.isHorizontal() : y4.type === "polar" && (w4 = _.dim === "angle");
      var C = e2.isAnimationEnabled() ? e2 : null, E = Wvt(e2, y4);
      E && this._enableRealtimeSort(E, p4, l4);
      var T = e2.get("clip", true) || E, O = jvt(y4, p4);
      h.removeClipPath();
      var N = e2.get("roundCap", true), V = e2.get("showBackground", true), H = e2.getModel("backgroundStyle"), X = H.get("borderRadius") || 0, q2 = [], de = this._backgroundEls, le = c4 && c4.isInitSort, me = c4 && c4.type === "changeAxisOrder";
      function ye(Pe) {
        var ze = SW[y4.type](p4, Pe), Re = Xvt(y4, w4, ze);
        return Re.useStyle(H.getItemStyle()), y4.type === "cartesian2d" && Re.setShape("r", X), q2[Pe] = Re, Re;
      }
      p4.diff(g4).add(function(Pe) {
        var ze = p4.getItemModel(Pe), Re = SW[y4.type](p4, Pe, ze);
        if (V && ye(Pe), !(!p4.hasValue(Pe) || !$Se[y4.type](Re))) {
          var rt2 = false;
          T && (rt2 = jSe[y4.type](O, Re));
          var ft = GSe[y4.type](e2, p4, Pe, Re, w4, C, _.model, false, N);
          E && (ft.forceLabelAnimation = true), USe(ft, p4, Pe, ze, Re, e2, w4, y4.type === "polar"), le ? ft.attr({ shape: Re }) : E ? WSe(E, C, ft, Re, Pe, w4, false, false) : bc(ft, { shape: Re }, e2, Pe), p4.setItemGraphicEl(Pe, ft), h.add(ft), ft.ignore = rt2;
        }
      }).update(function(Pe, ze) {
        var Re = p4.getItemModel(Pe), rt2 = SW[y4.type](p4, Pe, Re);
        if (V) {
          var ft = void 0;
          de.length === 0 ? ft = ye(ze) : (ft = de[ze], ft.useStyle(H.getItemStyle()), y4.type === "cartesian2d" && ft.setShape("r", X), q2[Pe] = ft);
          var et = SW[y4.type](p4, Pe), Jt = Wke(w4, et, y4);
          Vs(ft, { shape: Jt }, C, Pe);
        }
        var xt = g4.getItemGraphicEl(ze);
        if (!p4.hasValue(Pe) || !$Se[y4.type](rt2)) {
          h.remove(xt);
          return;
        }
        var It = false;
        if (T && (It = jSe[y4.type](O, rt2), It && h.remove(xt)), xt ? ob(xt) : xt = GSe[y4.type](e2, p4, Pe, rt2, w4, C, _.model, !!xt, N), E && (xt.forceLabelAnimation = true), me) {
          var Wt = xt.getTextContent();
          if (Wt) {
            var sn = Y3(Wt);
            sn.prevValue != null && (sn.prevValue = sn.value);
          }
        } else
          USe(xt, p4, Pe, Re, rt2, e2, w4, y4.type === "polar");
        le ? xt.attr({ shape: rt2 }) : E ? WSe(E, C, xt, rt2, Pe, w4, true, me) : Vs(xt, { shape: rt2 }, e2, Pe, null), p4.setItemGraphicEl(Pe, xt), xt.ignore = It, h.add(xt);
      }).remove(function(Pe) {
        var ze = g4.getItemGraphicEl(Pe);
        ze && h8(ze, e2, Pe);
      }).execute();
      var be = this._backgroundGroup || (this._backgroundGroup = new Ti());
      be.removeAll();
      for (var we = 0; we < q2.length; ++we)
        be.add(q2[we]);
      h.add(be), this._backgroundEls = q2, this._data = p4;
    }, n2.prototype._renderLarge = function(e2, o, l4) {
      this._clear(), YSe(e2, this.group), this._updateLargeClip(e2);
    }, n2.prototype._incrementalRenderLarge = function(e2, o) {
      this._removeBackground(), YSe(o, this.group, this._progressiveEls, true);
    }, n2.prototype._updateLargeClip = function(e2) {
      var o = e2.get("clip", true) && q$(e2.coordinateSystem, false, e2), l4 = this.group;
      o ? l4.setClipPath(o) : l4.removeClipPath();
    }, n2.prototype._enableRealtimeSort = function(e2, o, l4) {
      var c4 = this;
      if (!!o.count()) {
        var h = e2.baseAxis;
        if (this._isFirstFrame)
          this._dispatchInitSort(o, e2, l4), this._isFirstFrame = false;
        else {
          var p4 = function(g4) {
            var y4 = o.getItemGraphicEl(g4), _ = y4 && y4.shape;
            return _ && Math.abs(h.isHorizontal() ? _.height : _.width) || 0;
          };
          this._onRendered = function() {
            c4._updateSortWithinSameData(o, p4, h, l4);
          }, l4.getZr().on("rendered", this._onRendered);
        }
      }
    }, n2.prototype._dataSort = function(e2, o, l4) {
      var c4 = [];
      return e2.each(e2.mapDimension(o.dim), function(h, p4) {
        var g4 = l4(p4);
        g4 = g4 == null ? NaN : g4, c4.push({ dataIndex: p4, mappedValue: g4, ordinalNumber: h });
      }), c4.sort(function(h, p4) {
        return p4.mappedValue - h.mappedValue;
      }), { ordinalNumbers: Er(c4, function(h) {
        return h.ordinalNumber;
      }) };
    }, n2.prototype._isOrderChangedWithinSameData = function(e2, o, l4) {
      for (var c4 = l4.scale, h = e2.mapDimension(l4.dim), p4 = Number.MAX_VALUE, g4 = 0, y4 = c4.getOrdinalMeta().categories.length; g4 < y4; ++g4) {
        var _ = e2.rawIndexOf(h, c4.getRawOrdinalNumber(g4)), w4 = _ < 0 ? Number.MIN_VALUE : o(e2.indexOfRawIndex(_));
        if (w4 > p4)
          return true;
        p4 = w4;
      }
      return false;
    }, n2.prototype._isOrderDifferentInView = function(e2, o) {
      for (var l4 = o.scale, c4 = l4.getExtent(), h = Math.max(0, c4[0]), p4 = Math.min(c4[1], l4.getOrdinalMeta().categories.length - 1); h <= p4; ++h)
        if (e2.ordinalNumbers[h] !== l4.getRawOrdinalNumber(h))
          return true;
    }, n2.prototype._updateSortWithinSameData = function(e2, o, l4, c4) {
      if (!!this._isOrderChangedWithinSameData(e2, o, l4)) {
        var h = this._dataSort(e2, l4, o);
        this._isOrderDifferentInView(h, l4) && (this._removeOnRenderedListener(c4), c4.dispatchAction({ type: "changeAxisOrder", componentType: l4.dim + "Axis", axisId: l4.index, sortInfo: h }));
      }
    }, n2.prototype._dispatchInitSort = function(e2, o, l4) {
      var c4 = o.baseAxis, h = this._dataSort(e2, c4, function(p4) {
        return e2.get(e2.mapDimension(o.otherAxis.dim), p4);
      });
      l4.dispatchAction({ type: "changeAxisOrder", componentType: c4.dim + "Axis", isInitSort: true, axisId: c4.index, sortInfo: h });
    }, n2.prototype.remove = function(e2, o) {
      this._clear(this._model), this._removeOnRenderedListener(o);
    }, n2.prototype.dispose = function(e2, o) {
      this._removeOnRenderedListener(o);
    }, n2.prototype._removeOnRenderedListener = function(e2) {
      this._onRendered && (e2.getZr().off("rendered", this._onRendered), this._onRendered = null);
    }, n2.prototype._clear = function(e2) {
      var o = this.group, l4 = this._data;
      e2 && e2.isAnimationEnabled() && l4 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], l4.eachItemGraphicEl(function(c4) {
        h8(c4, e2, Fi(c4).dataIndex);
      })) : o.removeAll(), this._data = null, this._isFirstFrame = true;
    }, n2.prototype._removeBackground = function() {
      this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
    }, n2.type = "bar", n2;
  }(Ru), jSe = { cartesian2d: function(i, n2) {
    var e2 = n2.width < 0 ? -1 : 1, o = n2.height < 0 ? -1 : 1;
    e2 < 0 && (n2.x += n2.width, n2.width = -n2.width), o < 0 && (n2.y += n2.height, n2.height = -n2.height);
    var l4 = i.x + i.width, c4 = i.y + i.height, h = aae(n2.x, i.x), p4 = iae(n2.x + n2.width, l4), g4 = aae(n2.y, i.y), y4 = iae(n2.y + n2.height, c4), _ = p4 < h, w4 = y4 < g4;
    return n2.x = _ && h > l4 ? p4 : h, n2.y = w4 && g4 > c4 ? y4 : g4, n2.width = _ ? 0 : p4 - h, n2.height = w4 ? 0 : y4 - g4, e2 < 0 && (n2.x += n2.width, n2.width = -n2.width), o < 0 && (n2.y += n2.height, n2.height = -n2.height), _ || w4;
  }, polar: function(i, n2) {
    var e2 = n2.r0 <= n2.r ? 1 : -1;
    if (e2 < 0) {
      var o = n2.r;
      n2.r = n2.r0, n2.r0 = o;
    }
    var l4 = iae(n2.r, i.r), c4 = aae(n2.r0, i.r0);
    n2.r = l4, n2.r0 = c4;
    var h = l4 - c4 < 0;
    if (e2 < 0) {
      var o = n2.r;
      n2.r = n2.r0, n2.r0 = o;
    }
    return h;
  } }, GSe = { cartesian2d: function(i, n2, e2, o, l4, c4, h, p4, g4) {
    var y4 = new Is({ shape: rr({}, o), z2: 1 });
    if (y4.__dataIndex = e2, y4.name = "item", c4) {
      var _ = y4.shape, w4 = l4 ? "height" : "width";
      _[w4] = 0;
    }
    return y4;
  }, polar: function(i, n2, e2, o, l4, c4, h, p4, g4) {
    var y4 = !l4 && g4 ? UH : Hg, _ = new y4({ shape: o, z2: 1 });
    _.name = "item";
    var w4 = Gke(l4);
    if (_.calculateTextPosition = zvt(w4, { isRoundCap: y4 === UH }), c4) {
      var C = _.shape, E = l4 ? "r" : "endAngle", T = {};
      C[E] = l4 ? 0 : o.startAngle, T[E] = o[E], (p4 ? Vs : bc)(_, { shape: T }, c4);
    }
    return _;
  } };
  function Wvt(i, n2) {
    var e2 = i.get("realtimeSort", true), o = n2.getBaseAxis();
    if (e2 && o.type === "category" && n2.type === "cartesian2d")
      return { baseAxis: o, otherAxis: n2.getOtherAxis(o) };
  }
  function WSe(i, n2, e2, o, l4, c4, h, p4) {
    var g4, y4;
    c4 ? (y4 = { x: o.x, width: o.width }, g4 = { y: o.y, height: o.height }) : (y4 = { y: o.y, height: o.height }, g4 = { x: o.x, width: o.width }), p4 || (h ? Vs : bc)(e2, { shape: g4 }, n2, l4, null);
    var _ = n2 ? i.baseAxis.model : null;
    (h ? Vs : bc)(e2, { shape: y4 }, _, l4);
  }
  function HSe(i, n2) {
    for (var e2 = 0; e2 < n2.length; e2++)
      if (!isFinite(i[n2[e2]]))
        return true;
    return false;
  }
  var Hvt = ["x", "y", "width", "height"], $vt = ["cx", "cy", "r", "startAngle", "endAngle"], $Se = { cartesian2d: function(i) {
    return !HSe(i, Hvt);
  }, polar: function(i) {
    return !HSe(i, $vt);
  } }, SW = { cartesian2d: function(i, n2, e2) {
    var o = i.getItemLayout(n2), l4 = e2 ? qvt(e2, o) : 0, c4 = o.width > 0 ? 1 : -1, h = o.height > 0 ? 1 : -1;
    return { x: o.x + c4 * l4 / 2, y: o.y + h * l4 / 2, width: o.width - c4 * l4, height: o.height - h * l4 };
  }, polar: function(i, n2, e2) {
    var o = i.getItemLayout(n2);
    return { cx: o.cx, cy: o.cy, r0: o.r0, r: o.r, startAngle: o.startAngle, endAngle: o.endAngle, clockwise: o.clockwise };
  } };
  function Uvt(i) {
    return i.startAngle != null && i.endAngle != null && i.startAngle === i.endAngle;
  }
  function Gke(i) {
    return function(n2) {
      var e2 = n2 ? "Arc" : "Angle";
      return function(o) {
        switch (o) {
          case "start":
          case "insideStart":
          case "end":
          case "insideEnd":
            return o + e2;
          default:
            return o;
        }
      };
    }(i);
  }
  function USe(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = n2.getItemVisual(e2, "style");
    p4 || i.setShape("r", o.get(["itemStyle", "borderRadius"]) || 0), i.useStyle(g4);
    var y4 = o.getShallow("cursor");
    y4 && i.attr("cursor", y4);
    var _ = p4 ? h ? l4.r >= l4.r0 ? "endArc" : "startArc" : l4.endAngle >= l4.startAngle ? "endAngle" : "startAngle" : h ? l4.height >= 0 ? "bottom" : "top" : l4.width >= 0 ? "right" : "left", w4 = zd(o);
    yv(i, w4, { labelFetcher: c4, labelDataIndex: e2, defaultText: N3(c4.getData(), e2), inheritColor: g4.fill, defaultOpacity: g4.opacity, defaultOutsidePosition: _ });
    var C = i.getTextContent();
    if (p4 && C) {
      var E = o.get(["label", "position"]);
      i.textConfig.inside = E === "middle" ? true : null, Bvt(i, E === "outside" ? _ : E, Gke(h), o.get(["label", "rotate"]));
    }
    aDe(C, w4, c4.getRawValue(e2), function(O) {
      return Pke(n2, O);
    });
    var T = o.getModel(["emphasis"]);
    pf(i, T.get("focus"), T.get("blurScope"), T.get("disabled")), Mp(i, o), Uvt(l4) && (i.style.fill = "none", i.style.stroke = "none", Ve(i.states, function(O) {
      O.style && (O.style.fill = O.style.stroke = "none");
    }));
  }
  function qvt(i, n2) {
    var e2 = i.get(["itemStyle", "borderColor"]);
    if (!e2 || e2 === "none")
      return 0;
    var o = i.get(["itemStyle", "borderWidth"]) || 0, l4 = isNaN(n2.width) ? Number.MAX_VALUE : Math.abs(n2.width), c4 = isNaN(n2.height) ? Number.MAX_VALUE : Math.abs(n2.height);
    return Math.min(o, l4, c4);
  }
  var Yvt = function() {
    function i() {
    }
    return i;
  }(), qSe = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "largeBar", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new Yvt();
    }, n2.prototype.buildPath = function(e2, o) {
      for (var l4 = o.points, c4 = this.baseDimIdx, h = 1 - this.baseDimIdx, p4 = [], g4 = [], y4 = this.barWidth, _ = 0; _ < l4.length; _ += 3)
        g4[c4] = y4, g4[h] = l4[_ + 2], p4[c4] = l4[_ + c4], p4[h] = l4[_ + h], e2.rect(p4[0], p4[1], g4[0], g4[1]);
    }, n2;
  }(Eo);
  function YSe(i, n2, e2, o) {
    var l4 = i.getData(), c4 = l4.getLayout("valueAxisHorizontal") ? 1 : 0, h = l4.getLayout("largeDataIndices"), p4 = l4.getLayout("size"), g4 = i.getModel("backgroundStyle"), y4 = l4.getLayout("largeBackgroundPoints");
    if (y4) {
      var _ = new qSe({ shape: { points: y4 }, incremental: !!o, silent: true, z2: 0 });
      _.baseDimIdx = c4, _.largeDataIndices = h, _.barWidth = p4, _.useStyle(g4.getItemStyle()), n2.add(_), e2 && e2.push(_);
    }
    var w4 = new qSe({ shape: { points: l4.getLayout("largePoints") }, incremental: !!o, z2: 1 });
    w4.baseDimIdx = c4, w4.largeDataIndices = h, w4.barWidth = p4, n2.add(w4), w4.useStyle(l4.getVisual("style")), Fi(w4).seriesIndex = i.seriesIndex, i.get("silent") || (w4.on("mousedown", ZSe), w4.on("mousemove", ZSe)), e2 && e2.push(w4);
  }
  var ZSe = gle(function(i) {
    var n2 = this, e2 = Zvt(n2, i.offsetX, i.offsetY);
    Fi(n2).dataIndex = e2 >= 0 ? e2 : null;
  }, 30, false);
  function Zvt(i, n2, e2) {
    for (var o = i.baseDimIdx, l4 = 1 - o, c4 = i.shape.points, h = i.largeDataIndices, p4 = [], g4 = [], y4 = i.barWidth, _ = 0, w4 = c4.length / 3; _ < w4; _++) {
      var C = _ * 3;
      if (g4[o] = y4, g4[l4] = c4[C + 2], p4[o] = c4[C + o], p4[l4] = c4[C + l4], g4[l4] < 0 && (p4[l4] += g4[l4], g4[l4] = -g4[l4]), n2 >= p4[0] && n2 <= p4[0] + g4[0] && e2 >= p4[1] && e2 <= p4[1] + g4[1])
        return h[_];
    }
    return -1;
  }
  function Wke(i, n2, e2) {
    if (v22(e2, "cartesian2d")) {
      var o = n2, l4 = e2.getArea();
      return { x: i ? o.x : l4.x, y: i ? l4.y : o.y, width: i ? o.width : l4.width, height: i ? l4.height : o.height };
    } else {
      var l4 = e2.getArea(), c4 = n2;
      return { cx: l4.cx, cy: l4.cy, r0: i ? l4.r0 : c4.r0, r: i ? l4.r : c4.r, startAngle: i ? c4.startAngle : 0, endAngle: i ? c4.endAngle : Math.PI * 2 };
    }
  }
  function Xvt(i, n2, e2) {
    var o = i.type === "polar" ? Hg : Is;
    return new o({ shape: Wke(n2, e2, i), silent: true, z2: 0 });
  }
  var Kvt = Gvt;
  function Jvt(i) {
    i.registerChartView(Kvt), i.registerSeriesModel(Fvt), i.registerLayout(i.PRIORITY.VISUAL.LAYOUT, zi(Z5e, "bar")), i.registerLayout(i.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, X5e("bar")), i.registerProcessor(i.PRIORITY.PROCESSOR.STATISTIC, Bke("bar")), i.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(n2, e2) {
      var o = n2.componentType || "series";
      e2.eachComponent({ mainType: o, query: n2 }, function(l4) {
        n2.sortInfo && l4.axis.setCategorySortInfo(n2.sortInfo);
      });
    });
  }
  var CW = Math.PI * 2, XSe = Math.PI / 180;
  function Hke(i, n2) {
    return bh(i.getBoxLayoutParams(), { width: n2.getWidth(), height: n2.getHeight() });
  }
  function $ke(i, n2) {
    var e2 = Hke(i, n2), o = i.get("center"), l4 = i.get("radius");
    Mr(l4) || (l4 = [0, l4]), Mr(o) || (o = [o, o]);
    var c4 = ma(e2.width, n2.getWidth()), h = ma(e2.height, n2.getHeight()), p4 = Math.min(c4, h), g4 = ma(o[0], c4) + e2.x, y4 = ma(o[1], h) + e2.y, _ = ma(l4[0], p4 / 2), w4 = ma(l4[1], p4 / 2);
    return { cx: g4, cy: y4, r0: _, r: w4 };
  }
  function Qvt(i, n2, e2) {
    n2.eachSeriesByType(i, function(o) {
      var l4 = o.getData(), c4 = l4.mapDimension("value"), h = Hke(o, e2), p4 = $ke(o, e2), g4 = p4.cx, y4 = p4.cy, _ = p4.r, w4 = p4.r0, C = -o.get("startAngle") * XSe, E = o.get("minAngle") * XSe, T = 0;
      l4.each(c4, function(we) {
        !isNaN(we) && T++;
      });
      var O = l4.getSum(c4), N = Math.PI / (O || T) * 2, V = o.get("clockwise"), H = o.get("roseType"), X = o.get("stillShowZeroSum"), q2 = l4.getDataExtent(c4);
      q2[0] = 0;
      var de = CW, le = 0, me = C, ye = V ? 1 : -1;
      if (l4.setLayout({ viewRect: h, r: _ }), l4.each(c4, function(we, Pe) {
        var ze;
        if (isNaN(we)) {
          l4.setItemLayout(Pe, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: V, cx: g4, cy: y4, r0: w4, r: H ? NaN : _ });
          return;
        }
        H !== "area" ? ze = O === 0 && X ? N : we * N : ze = CW / T, ze < E ? (ze = E, de -= E) : le += we;
        var Re = me + ye * ze;
        l4.setItemLayout(Pe, { angle: ze, startAngle: me, endAngle: Re, clockwise: V, cx: g4, cy: y4, r0: w4, r: H ? Tl(we, q2, [w4, _]) : _ }), me = Re;
      }), de < CW && T)
        if (de <= 1e-3) {
          var be = CW / T;
          l4.each(c4, function(we, Pe) {
            if (!isNaN(we)) {
              var ze = l4.getItemLayout(Pe);
              ze.angle = be, ze.startAngle = C + ye * Pe * be, ze.endAngle = C + ye * (Pe + 1) * be;
            }
          });
        } else
          N = de / le, me = C, l4.each(c4, function(we, Pe) {
            if (!isNaN(we)) {
              var ze = l4.getItemLayout(Pe), Re = ze.angle === E ? E : we * N;
              ze.startAngle = me, ze.endAngle = me + ye * Re, me += ye * Re;
            }
          });
    });
  }
  function Q8(i) {
    return { seriesType: i, reset: function(n2, e2) {
      var o = e2.findComponents({ mainType: "legend" });
      if (!(!o || !o.length)) {
        var l4 = n2.getData();
        l4.filterSelf(function(c4) {
          for (var h = l4.getName(c4), p4 = 0; p4 < o.length; p4++)
            if (!o[p4].isSelected(h))
              return false;
          return true;
        });
      }
    } };
  }
  var egt = Math.PI / 180;
  function KSe(i, n2, e2, o, l4, c4, h, p4, g4, y4) {
    if (i.length < 2)
      return;
    function _(O) {
      for (var N = O.rB, V = N * N, H = 0; H < O.list.length; H++) {
        var X = O.list[H], q2 = Math.abs(X.label.y - e2), de = o + X.len, le = de * de, me = Math.sqrt((1 - Math.abs(q2 * q2 / V)) * le), ye = n2 + (me + X.len2) * l4, be = ye - X.label.x, we = X.targetTextWidth - be * l4;
        Uke(X, we, true), X.label.x = ye;
      }
    }
    function w4(O) {
      for (var N = { list: [], maxY: 0 }, V = { list: [], maxY: 0 }, H = 0; H < O.length; H++)
        if (O[H].labelAlignTo === "none") {
          var X = O[H], q2 = X.label.y > e2 ? V : N, de = Math.abs(X.label.y - e2);
          if (de >= q2.maxY) {
            var le = X.label.x - n2 - X.len2 * l4, me = o + X.len, ye = Math.abs(le) < me ? Math.sqrt(de * de / (1 - le * le / me / me)) : me;
            q2.rB = ye, q2.maxY = de;
          }
          q2.list.push(X);
        }
      _(N), _(V);
    }
    for (var C = i.length, E = 0; E < C; E++)
      if (i[E].position === "outer" && i[E].labelAlignTo === "labelLine") {
        var T = i[E].label.x - y4;
        i[E].linePoints[1][0] += T, i[E].label.x = y4;
      }
    yke(i, g4, g4 + h) && w4(i);
  }
  function tgt(i, n2, e2, o, l4, c4, h, p4) {
    for (var g4 = [], y4 = [], _ = Number.MAX_VALUE, w4 = -Number.MAX_VALUE, C = 0; C < i.length; C++) {
      var E = i[C].label;
      oae(i[C]) || (E.x < n2 ? (_ = Math.min(_, E.x), g4.push(i[C])) : (w4 = Math.max(w4, E.x), y4.push(i[C])));
    }
    for (var C = 0; C < i.length; C++) {
      var T = i[C];
      if (!oae(T) && T.linePoints) {
        if (T.labelStyleWidth != null)
          continue;
        var E = T.label, O = T.linePoints, N = void 0;
        T.labelAlignTo === "edge" ? E.x < n2 ? N = O[2][0] - T.labelDistance - h - T.edgeDistance : N = h + l4 - T.edgeDistance - O[2][0] - T.labelDistance : T.labelAlignTo === "labelLine" ? E.x < n2 ? N = _ - h - T.bleedMargin : N = h + l4 - w4 - T.bleedMargin : E.x < n2 ? N = E.x - h - T.bleedMargin : N = h + l4 - E.x - T.bleedMargin, T.targetTextWidth = N, Uke(T, N);
      }
    }
    KSe(y4, n2, e2, o, 1, l4, c4, h, p4, w4), KSe(g4, n2, e2, o, -1, l4, c4, h, p4, _);
    for (var C = 0; C < i.length; C++) {
      var T = i[C];
      if (!oae(T) && T.linePoints) {
        var E = T.label, O = T.linePoints, V = T.labelAlignTo === "edge", H = E.style.padding, X = H ? H[1] + H[3] : 0, q2 = E.style.backgroundColor ? 0 : X, de = T.rect.width + q2, le = O[1][0] - O[2][0];
        V ? E.x < n2 ? O[2][0] = h + T.edgeDistance + de + T.labelDistance : O[2][0] = h + l4 - T.edgeDistance - de - T.labelDistance : (E.x < n2 ? O[2][0] = E.x + T.labelDistance : O[2][0] = E.x - T.labelDistance, O[1][0] = O[2][0] + le), O[1][1] = O[2][1] = E.y;
      }
    }
  }
  function Uke(i, n2, e2) {
    if (e2 === void 0 && (e2 = false), i.labelStyleWidth == null) {
      var o = i.label, l4 = o.style, c4 = i.rect, h = l4.backgroundColor, p4 = l4.padding, g4 = p4 ? p4[1] + p4[3] : 0, y4 = l4.overflow, _ = c4.width + (h ? 0 : g4);
      if (n2 < _ || e2) {
        var w4 = c4.height;
        if (y4 && y4.match("break")) {
          o.setStyle("backgroundColor", null), o.setStyle("width", n2 - g4);
          var C = o.getBoundingRect();
          o.setStyle("width", Math.ceil(C.width)), o.setStyle("backgroundColor", h);
        } else {
          var E = n2 - g4, T = n2 < _ ? E : e2 ? E > i.unconstrainedWidth ? null : E : null;
          o.setStyle("width", T);
        }
        var O = o.getBoundingRect();
        c4.width = O.width;
        var N = (o.style.margin || 0) + 2.1;
        c4.height = O.height + N, c4.y -= (c4.height - w4) / 2;
      }
    }
  }
  function oae(i) {
    return i.position === "center";
  }
  function ngt(i) {
    var n2 = i.getData(), e2 = [], o, l4, c4 = false, h = (i.get("minShowLabelAngle") || 0) * egt, p4 = n2.getLayout("viewRect"), g4 = n2.getLayout("r"), y4 = p4.width, _ = p4.x, w4 = p4.y, C = p4.height;
    function E(le) {
      le.ignore = true;
    }
    function T(le) {
      if (!le.ignore)
        return true;
      for (var me in le.states)
        if (le.states[me].ignore === false)
          return true;
      return false;
    }
    n2.each(function(le) {
      var me = n2.getItemGraphicEl(le), ye = me.shape, be = me.getTextContent(), we = me.getTextGuideLine(), Pe = n2.getItemModel(le), ze = Pe.getModel("label"), Re = ze.get("position") || Pe.get(["emphasis", "label", "position"]), rt2 = ze.get("distanceToLabelLine"), ft = ze.get("alignTo"), et = ma(ze.get("edgeDistance"), y4), Jt = ze.get("bleedMargin"), xt = Pe.getModel("labelLine"), It = xt.get("length");
      It = ma(It, y4);
      var Wt = xt.get("length2");
      if (Wt = ma(Wt, y4), Math.abs(ye.endAngle - ye.startAngle) < h) {
        Ve(be.states, E), be.ignore = true;
        return;
      }
      if (!!T(be)) {
        var sn = (ye.startAngle + ye.endAngle) / 2, vn = Math.cos(sn), $r = Math.sin(sn), ga, Za, $a, Pa;
        o = ye.cx, l4 = ye.cy;
        var da = Re === "inside" || Re === "inner";
        if (Re === "center")
          ga = ye.cx, Za = ye.cy, Pa = "center";
        else {
          var Ra = (da ? (ye.r + ye.r0) / 2 * vn : ye.r * vn) + o, Wa = (da ? (ye.r + ye.r0) / 2 * $r : ye.r * $r) + l4;
          if (ga = Ra + vn * 3, Za = Wa + $r * 3, !da) {
            var wa = Ra + vn * (It + g4 - ye.r), li = Wa + $r * (It + g4 - ye.r), Ts = wa + (vn < 0 ? -1 : 1) * Wt, wi = li;
            ft === "edge" ? ga = vn < 0 ? _ + et : _ + y4 - et : ga = Ts + (vn < 0 ? -rt2 : rt2), Za = wi, $a = [[Ra, Wa], [wa, li], [Ts, wi]];
          }
          Pa = da ? "center" : ft === "edge" ? vn > 0 ? "right" : "left" : vn > 0 ? "left" : "right";
        }
        var ps = Math.PI, Bs = 0, vl = ze.get("rotate");
        if (sl(vl))
          Bs = vl * (ps / 180);
        else if (Re === "center")
          Bs = 0;
        else if (vl === "radial" || vl === true) {
          var If = vn < 0 ? -sn + ps : -sn;
          Bs = If;
        } else if (vl === "tangential" && Re !== "outside" && Re !== "outer") {
          var Xl = Math.atan2(vn, $r);
          Xl < 0 && (Xl = ps * 2 + Xl);
          var _h = $r > 0;
          _h && (Xl = ps + Xl), Bs = Xl - ps;
        }
        if (c4 = !!Bs, be.x = ga, be.y = Za, be.rotation = Bs, be.setStyle({ verticalAlign: "middle" }), da) {
          be.setStyle({ align: Pa });
          var Nu = be.states.select;
          Nu && (Nu.x += be.x, Nu.y += be.y);
        } else {
          var Nl = be.getBoundingRect().clone();
          Nl.applyTransform(be.getComputedTransform());
          var Uc = (be.style.margin || 0) + 2.1;
          Nl.y -= Uc / 2, Nl.height += Uc, e2.push({ label: be, labelLine: we, position: Re, len: It, len2: Wt, minTurnAngle: xt.get("minTurnAngle"), maxSurfaceAngle: xt.get("maxSurfaceAngle"), surfaceNormal: new Ji(vn, $r), linePoints: $a, textAlign: Pa, labelDistance: rt2, labelAlignTo: ft, edgeDistance: et, bleedMargin: Jt, rect: Nl, unconstrainedWidth: Nl.width, labelStyleWidth: be.style.width });
        }
        me.setTextConfig({ inside: da });
      }
    }), !c4 && i.get("avoidLabelOverlap") && tgt(e2, o, l4, g4, y4, C, _, w4);
    for (var O = 0; O < e2.length; O++) {
      var N = e2[O], V = N.label, H = N.labelLine, X = isNaN(V.x) || isNaN(V.y);
      if (V) {
        V.setStyle({ align: N.textAlign }), X && (Ve(V.states, E), V.ignore = true);
        var q2 = V.states.select;
        q2 && (q2.x += V.x, q2.y += V.y);
      }
      if (H) {
        var de = N.linePoints;
        X || !de ? (Ve(H.states, E), H.ignore = true) : (vke(de, N.minTurnAngle), ppt(de, N.surfaceNormal, N.maxSurfaceAngle), H.setShape({ points: de }), V.__hostTarget.textGuideLineConfig = { anchor: new Ji(de[0][0], de[0][1]) });
      }
    }
  }
  function w3(i, n2, e2) {
    var o = i.get("borderRadius");
    if (o == null)
      return e2 ? { cornerRadius: 0 } : null;
    Mr(o) || (o = [o, o, o, o]);
    var l4 = Math.abs(n2.r || 0 - n2.r0 || 0);
    return { cornerRadius: Er(o, function(c4) {
      return ib(c4, l4);
    }) };
  }
  var rgt = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this) || this;
      c4.z2 = 2;
      var h = new Qs();
      return c4.setTextContent(h), c4.updateData(e2, o, l4, true), c4;
    }
    return n2.prototype.updateData = function(e2, o, l4, c4) {
      var h = this, p4 = e2.hostModel, g4 = e2.getItemModel(o), y4 = g4.getModel("emphasis"), _ = e2.getItemLayout(o), w4 = rr(w3(g4.getModel("itemStyle"), _, true), _);
      if (isNaN(w4.startAngle)) {
        h.setShape(w4);
        return;
      }
      if (c4) {
        h.setShape(w4);
        var C = p4.getShallow("animationType");
        p4.ecModel.ssr ? (bc(h, { scaleX: 0, scaleY: 0 }, p4, { dataIndex: o, isFrom: true }), h.originX = w4.cx, h.originY = w4.cy) : C === "scale" ? (h.shape.r = _.r0, bc(h, { shape: { r: _.r } }, p4, o)) : l4 != null ? (h.setShape({ startAngle: l4, endAngle: l4 }), bc(h, { shape: { startAngle: _.startAngle, endAngle: _.endAngle } }, p4, o)) : (h.shape.endAngle = _.startAngle, Vs(h, { shape: { endAngle: _.endAngle } }, p4, o));
      } else
        ob(h), Vs(h, { shape: w4 }, p4, o);
      h.useStyle(e2.getItemVisual(o, "style")), Mp(h, g4);
      var E = (_.startAngle + _.endAngle) / 2, T = p4.get("selectedOffset"), O = Math.cos(E) * T, N = Math.sin(E) * T, V = g4.getShallow("cursor");
      V && h.attr("cursor", V), this._updateLabel(p4, e2, o), h.ensureState("emphasis").shape = rr({ r: _.r + (y4.get("scale") && y4.get("scaleSize") || 0) }, w3(y4.getModel("itemStyle"), _)), rr(h.ensureState("select"), { x: O, y: N, shape: w3(g4.getModel(["select", "itemStyle"]), _) }), rr(h.ensureState("blur"), { shape: w3(g4.getModel(["blur", "itemStyle"]), _) });
      var H = h.getTextGuideLine(), X = h.getTextContent();
      H && rr(H.ensureState("select"), { x: O, y: N }), rr(X.ensureState("select"), { x: O, y: N }), pf(this, y4.get("focus"), y4.get("blurScope"), y4.get("disabled"));
    }, n2.prototype._updateLabel = function(e2, o, l4) {
      var c4 = this, h = o.getItemModel(l4), p4 = h.getModel("labelLine"), g4 = o.getItemVisual(l4, "style"), y4 = g4 && g4.fill, _ = g4 && g4.opacity;
      yv(c4, zd(h), { labelFetcher: o.hostModel, labelDataIndex: l4, inheritColor: y4, defaultOpacity: _, defaultText: e2.getFormattedLabel(l4, "normal") || o.getName(l4) });
      var w4 = c4.getTextContent();
      c4.setTextConfig({ position: null, rotation: null }), w4.attr({ z2: 10 });
      var C = e2.get(["label", "position"]);
      if (C !== "outside" && C !== "outer")
        c4.removeTextGuideLine();
      else {
        var E = this.getTextGuideLine();
        E || (E = new Ug(), this.setTextGuideLine(E)), Dle(this, kle(h), { stroke: y4, opacity: f2(p4.get(["lineStyle", "opacity"]), _, 1) });
      }
    }, n2;
  }(Hg), agt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.ignoreLabelLineUpdate = true, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      var h = e2.getData(), p4 = this._data, g4 = this.group, y4;
      if (!p4 && h.count() > 0) {
        for (var _ = h.getItemLayout(0), w4 = 1; isNaN(_ && _.startAngle) && w4 < h.count(); ++w4)
          _ = h.getItemLayout(w4);
        _ && (y4 = _.startAngle);
      }
      if (this._emptyCircleSector && g4.remove(this._emptyCircleSector), h.count() === 0 && e2.get("showEmptyCircle")) {
        var C = new Hg({ shape: $ke(e2, l4) });
        C.useStyle(e2.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = C, g4.add(C);
      }
      h.diff(p4).add(function(E) {
        var T = new rgt(h, E, y4);
        h.setItemGraphicEl(E, T), g4.add(T);
      }).update(function(E, T) {
        var O = p4.getItemGraphicEl(T);
        O.updateData(h, E, y4), O.off("click"), g4.add(O), h.setItemGraphicEl(E, O);
      }).remove(function(E) {
        var T = p4.getItemGraphicEl(E);
        h8(T, e2, E);
      }).execute(), ngt(e2), e2.get("animationTypeUpdate") !== "expansion" && (this._data = h);
    }, n2.prototype.dispose = function() {
    }, n2.prototype.containPoint = function(e2, o) {
      var l4 = o.getData(), c4 = l4.getItemLayout(0);
      if (c4) {
        var h = e2[0] - c4.cx, p4 = e2[1] - c4.cy, g4 = Math.sqrt(h * h + p4 * p4);
        return g4 <= c4.r && g4 >= c4.r0;
      }
    }, n2.type = "pie", n2;
  }(Ru), igt = agt;
  function rL(i, n2, e2) {
    n2 = Mr(n2) && { coordDimensions: n2 } || rr({ encodeDefine: i.getEncode() }, n2);
    var o = i.getSource(), l4 = q8(o, n2).dimensions, c4 = new Xv(l4, i);
    return c4.initData(o, e2), c4;
  }
  var ogt = function() {
    function i(n2, e2) {
      this._getDataWithEncodedVisual = n2, this._getRawData = e2;
    }
    return i.prototype.getAllNames = function() {
      var n2 = this._getRawData();
      return n2.mapArray(n2.getName);
    }, i.prototype.containName = function(n2) {
      var e2 = this._getRawData();
      return e2.indexOfName(n2) >= 0;
    }, i.prototype.indexOfName = function(n2) {
      var e2 = this._getDataWithEncodedVisual();
      return e2.indexOfName(n2);
    }, i.prototype.getItemVisual = function(n2, e2) {
      var o = this._getDataWithEncodedVisual();
      return o.getItemVisual(n2, e2);
    }, i;
  }(), e9 = ogt, sgt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.init = function(e2) {
      i.prototype.init.apply(this, arguments), this.legendVisualProvider = new e9(Ia(this.getData, this), Ia(this.getRawData, this)), this._defaultLabelLine(e2);
    }, n2.prototype.mergeOption = function() {
      i.prototype.mergeOption.apply(this, arguments);
    }, n2.prototype.getInitialData = function() {
      return rL(this, { coordDimensions: ["value"], encodeDefaulter: zi(ole, this) });
    }, n2.prototype.getDataParams = function(e2) {
      var o = this.getData(), l4 = i.prototype.getDataParams.call(this, e2), c4 = [];
      return o.each(o.mapDimension("value"), function(h) {
        c4.push(h);
      }), l4.percent = hst(c4, e2, o.hostModel.get("percentPrecision")), l4.$vars.push("percent"), l4;
    }, n2.prototype._defaultLabelLine = function(e2) {
      mT(e2, "labelLine", ["show"]);
      var o = e2.labelLine, l4 = e2.emphasis.labelLine;
      o.show = o.show && e2.label.show, l4.show = l4.show && e2.emphasis.label.show;
    }, n2.type = "series.pie", n2.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, n2;
  }(_c2), lgt = sgt;
  function ugt(i) {
    return { seriesType: i, reset: function(n2, e2) {
      var o = n2.getData();
      o.filterSelf(function(l4) {
        var c4 = o.mapDimension("value"), h = o.get(c4, l4);
        return !(sl(h) && !isNaN(h) && h < 0);
      });
    } };
  }
  function cgt(i) {
    i.registerChartView(igt), i.registerSeriesModel(lgt), h5e("pie", i.registerAction), i.registerLayout(zi(Qvt, "pie")), i.registerProcessor(Q8("pie")), i.registerProcessor(ugt("pie"));
  }
  var fgt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.hasSymbolVisual = true, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      return M2(null, this, { useEncodeDefaulter: true });
    }, n2.prototype.getProgressive = function() {
      var e2 = this.option.progressive;
      return e2 == null ? this.option.large ? 5e3 : this.get("progressive") : e2;
    }, n2.prototype.getProgressiveThreshold = function() {
      var e2 = this.option.progressiveThreshold;
      return e2 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : e2;
    }, n2.prototype.brushSelector = function(e2, o, l4) {
      return l4.point(o.getItemLayout(e2));
    }, n2.prototype.getZLevelKey = function() {
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
    }, n2.type = "series.scatter", n2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], n2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, n2;
  }(_c2), hgt = fgt, qke = 4, dgt = function() {
    function i() {
    }
    return i;
  }(), pgt = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o._off = 0, o.hoverDataIdx = -1, o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new dgt();
    }, n2.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.points, c4 = o.size, h = this.symbolProxy, p4 = h.shape, g4 = e2.getContext ? e2.getContext() : e2, y4 = g4 && c4[0] < qke, _ = this.softClipShape, w4;
      if (y4) {
        this._ctx = g4;
        return;
      }
      for (this._ctx = null, w4 = this._off; w4 < l4.length; ) {
        var C = l4[w4++], E = l4[w4++];
        isNaN(C) || isNaN(E) || _ && !_.contain(C, E) || (p4.x = C - c4[0] / 2, p4.y = E - c4[1] / 2, p4.width = c4[0], p4.height = c4[1], h.buildPath(e2, p4, true));
      }
      this.incremental && (this._off = w4, this.notClear = true);
    }, n2.prototype.afterBrush = function() {
      var e2 = this.shape, o = e2.points, l4 = e2.size, c4 = this._ctx, h = this.softClipShape, p4;
      if (!!c4) {
        for (p4 = this._off; p4 < o.length; ) {
          var g4 = o[p4++], y4 = o[p4++];
          isNaN(g4) || isNaN(y4) || h && !h.contain(g4, y4) || c4.fillRect(g4 - l4[0] / 2, y4 - l4[1] / 2, l4[0], l4[1]);
        }
        this.incremental && (this._off = p4, this.notClear = true);
      }
    }, n2.prototype.findDataIndex = function(e2, o) {
      for (var l4 = this.shape, c4 = l4.points, h = l4.size, p4 = Math.max(h[0], 4), g4 = Math.max(h[1], 4), y4 = c4.length / 2 - 1; y4 >= 0; y4--) {
        var _ = y4 * 2, w4 = c4[_] - p4 / 2, C = c4[_ + 1] - g4 / 2;
        if (e2 >= w4 && o >= C && e2 <= w4 + p4 && o <= C + g4)
          return y4;
      }
      return -1;
    }, n2.prototype.contain = function(e2, o) {
      var l4 = this.transformCoordToLocal(e2, o), c4 = this.getBoundingRect();
      if (e2 = l4[0], o = l4[1], c4.contain(e2, o)) {
        var h = this.hoverDataIdx = this.findDataIndex(e2, o);
        return h >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, n2.prototype.getBoundingRect = function() {
      var e2 = this._rect;
      if (!e2) {
        for (var o = this.shape, l4 = o.points, c4 = o.size, h = c4[0], p4 = c4[1], g4 = 1 / 0, y4 = 1 / 0, _ = -1 / 0, w4 = -1 / 0, C = 0; C < l4.length; ) {
          var E = l4[C++], T = l4[C++];
          g4 = Math.min(E, g4), _ = Math.max(E, _), y4 = Math.min(T, y4), w4 = Math.max(T, w4);
        }
        e2 = this._rect = new mo(g4 - h / 2, y4 - p4 / 2, _ - g4 + h, w4 - y4 + p4);
      }
      return e2;
    }, n2;
  }(Eo), vgt = function() {
    function i() {
      this.group = new Ti();
    }
    return i.prototype.updateData = function(n2, e2) {
      this._clear();
      var o = this._create();
      o.setShape({ points: n2.getLayout("points") }), this._setCommon(o, n2, e2);
    }, i.prototype.updateLayout = function(n2) {
      var e2 = n2.getLayout("points");
      this.group.eachChild(function(o) {
        if (o.startIndex != null) {
          var l4 = (o.endIndex - o.startIndex) * 2, c4 = o.startIndex * 4 * 2;
          e2 = new Float32Array(e2.buffer, c4, l4);
        }
        o.setShape("points", e2), o.reset();
      });
    }, i.prototype.incrementalPrepareUpdate = function(n2) {
      this._clear();
    }, i.prototype.incrementalUpdate = function(n2, e2, o) {
      var l4 = this._newAdded[0], c4 = e2.getLayout("points"), h = l4 && l4.shape.points;
      if (h && h.length < 2e4) {
        var p4 = h.length, g4 = new Float32Array(p4 + c4.length);
        g4.set(h), g4.set(c4, p4), l4.endIndex = n2.end, l4.setShape({ points: g4 });
      } else {
        this._newAdded = [];
        var y4 = this._create();
        y4.startIndex = n2.start, y4.endIndex = n2.end, y4.incremental = true, y4.setShape({ points: c4 }), this._setCommon(y4, e2, o);
      }
    }, i.prototype.eachRendered = function(n2) {
      this._newAdded[0] && n2(this._newAdded[0]);
    }, i.prototype._create = function() {
      var n2 = new pgt({ cursor: "default" });
      return this.group.add(n2), this._newAdded.push(n2), n2;
    }, i.prototype._setCommon = function(n2, e2, o) {
      var l4 = e2.hostModel;
      o = o || {};
      var c4 = e2.getVisual("symbolSize");
      n2.setShape("size", c4 instanceof Array ? c4 : [c4, c4]), n2.softClipShape = o.clipShape || null, n2.symbolProxy = Xf(e2.getVisual("symbol"), 0, 0, 0, 0), n2.setColor = n2.symbolProxy.setColor;
      var h = n2.shape.size[0] < qke;
      n2.useStyle(l4.getModel("itemStyle").getItemStyle(h ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
      var p4 = e2.getVisual("style"), g4 = p4 && p4.fill;
      g4 && n2.setColor(g4);
      var y4 = Fi(n2);
      y4.seriesIndex = l4.seriesIndex, n2.on("mousemove", function(_) {
        y4.dataIndex = null;
        var w4 = n2.hoverDataIdx;
        w4 >= 0 && (y4.dataIndex = w4 + (n2.startIndex || 0));
      });
    }, i.prototype.remove = function() {
      this._clear();
    }, i.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, i;
  }(), ggt = vgt, mgt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = this._updateSymbolDraw(c4, e2);
      h.updateData(c4, { clipShape: this._getClipShape(e2) }), this._finished = true;
    }, n2.prototype.incrementalPrepareRender = function(e2, o, l4) {
      var c4 = e2.getData(), h = this._updateSymbolDraw(c4, e2);
      h.incrementalPrepareUpdate(c4), this._finished = false;
    }, n2.prototype.incrementalRender = function(e2, o, l4) {
      this._symbolDraw.incrementalUpdate(e2, o.getData(), { clipShape: this._getClipShape(o) }), this._finished = e2.end === o.getData().count();
    }, n2.prototype.updateTransform = function(e2, o, l4) {
      var c4 = e2.getData();
      if (this.group.dirty(), !this._finished || c4.count() > 1e4)
        return { update: true };
      var h = J8("").reset(e2, o, l4);
      h.progress && h.progress({ start: 0, end: c4.count(), count: c4.count() }, c4), this._symbolDraw.updateLayout(c4);
    }, n2.prototype.eachRendered = function(e2) {
      this._symbolDraw && this._symbolDraw.eachRendered(e2);
    }, n2.prototype._getClipShape = function(e2) {
      var o = e2.coordinateSystem, l4 = o && o.getArea && o.getArea();
      return e2.get("clip", true) ? l4 : null;
    }, n2.prototype._updateSymbolDraw = function(e2, o) {
      var l4 = this._symbolDraw, c4 = o.pipelineContext, h = c4.large;
      return (!l4 || h !== this._isLargeDraw) && (l4 && l4.remove(), l4 = this._symbolDraw = h ? new ggt() : new K8(), this._isLargeDraw = h, this.group.removeAll()), this.group.add(l4.group), l4;
    }, n2.prototype.remove = function(e2, o) {
      this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
    }, n2.prototype.dispose = function() {
    }, n2.type = "scatter", n2;
  }(Ru), ygt = mgt, bgt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.type = "grid", n2.dependencies = ["xAxis", "yAxis"], n2.layoutMode = "box", n2.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, n2;
  }(Ns), _gt = bgt, Moe = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("grid", Yf).models[0];
    }, n2.type = "cartesian2dAxis", n2;
  }(Ns);
  Kf(Moe, Z8);
  var Yke = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, xgt = to({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, Yke), Fle = to({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, Yke), wgt = to({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, Fle), Sgt = hi({ logBase: 10 }, Fle), Zke = { category: xgt, value: Fle, time: wgt, log: Sgt }, Cgt = { value: 1, category: 1, time: 1, log: 1 };
  function V3(i, n2, e2, o) {
    Ve(Cgt, function(l4, c4) {
      var h = to(to({}, Zke[c4], true), o, true), p4 = function(g4) {
        on(y4, g4);
        function y4() {
          var _ = g4 !== null && g4.apply(this, arguments) || this;
          return _.type = n2 + "Axis." + c4, _;
        }
        return y4.prototype.mergeDefaultAndTheme = function(_, w4) {
          var C = v8(this), E = C ? K3(_) : {}, T = w4.getTheme();
          to(_, T.get(c4 + "Axis")), to(_, this.getDefaultOption()), _.type = JSe(_), C && QC(_, E, C);
        }, y4.prototype.optionUpdated = function() {
          var _ = this.option;
          _.type === "category" && (this.__ordinalMeta = yoe.createByAxisModel(this));
        }, y4.prototype.getCategories = function(_) {
          var w4 = this.option;
          if (w4.type === "category")
            return _ ? w4.data : this.__ordinalMeta.categories;
        }, y4.prototype.getOrdinalMeta = function() {
          return this.__ordinalMeta;
        }, y4.type = n2 + "Axis." + c4, y4.defaultOption = h, y4;
      }(e2);
      i.registerComponentModel(p4);
    }), i.registerSubTypeDefaulter(n2 + "Axis", JSe);
  }
  function JSe(i) {
    return i.type || (i.data ? "category" : "value");
  }
  var Mgt = function() {
    function i(n2) {
      this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = n2 || "";
    }
    return i.prototype.getAxis = function(n2) {
      return this._axes[n2];
    }, i.prototype.getAxes = function() {
      return Er(this._dimList, function(n2) {
        return this._axes[n2];
      }, this);
    }, i.prototype.getAxesByScale = function(n2) {
      return n2 = n2.toLowerCase(), Yl(this.getAxes(), function(e2) {
        return e2.scale.type === n2;
      });
    }, i.prototype.addAxis = function(n2) {
      var e2 = n2.dim;
      this._axes[e2] = n2, this._dimList.push(e2);
    }, i;
  }(), Agt = Mgt, Aoe = ["x", "y"];
  function QSe(i) {
    return i.type === "interval" || i.type === "time";
  }
  var Egt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "cartesian2d", e2.dimensions = Aoe, e2;
    }
    return n2.prototype.calcAffineTransform = function() {
      this._transform = this._invTransform = null;
      var e2 = this.getAxis("x").scale, o = this.getAxis("y").scale;
      if (!(!QSe(e2) || !QSe(o))) {
        var l4 = e2.getExtent(), c4 = o.getExtent(), h = this.dataToPoint([l4[0], c4[0]]), p4 = this.dataToPoint([l4[1], c4[1]]), g4 = l4[1] - l4[0], y4 = c4[1] - c4[0];
        if (!(!g4 || !y4)) {
          var _ = (p4[0] - h[0]) / g4, w4 = (p4[1] - h[1]) / y4, C = h[0] - l4[0] * _, E = h[1] - c4[0] * w4, T = this._transform = [_, 0, 0, w4, C, E];
          this._invTransform = W3([], T);
        }
      }
    }, n2.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
    }, n2.prototype.containPoint = function(e2) {
      var o = this.getAxis("x"), l4 = this.getAxis("y");
      return o.contain(o.toLocalCoord(e2[0])) && l4.contain(l4.toLocalCoord(e2[1]));
    }, n2.prototype.containData = function(e2) {
      return this.getAxis("x").containData(e2[0]) && this.getAxis("y").containData(e2[1]);
    }, n2.prototype.dataToPoint = function(e2, o, l4) {
      l4 = l4 || [];
      var c4 = e2[0], h = e2[1];
      if (this._transform && c4 != null && isFinite(c4) && h != null && isFinite(h))
        return Sp(l4, e2, this._transform);
      var p4 = this.getAxis("x"), g4 = this.getAxis("y");
      return l4[0] = p4.toGlobalCoord(p4.dataToCoord(c4, o)), l4[1] = g4.toGlobalCoord(g4.dataToCoord(h, o)), l4;
    }, n2.prototype.clampData = function(e2, o) {
      var l4 = this.getAxis("x").scale, c4 = this.getAxis("y").scale, h = l4.getExtent(), p4 = c4.getExtent(), g4 = l4.parse(e2[0]), y4 = c4.parse(e2[1]);
      return o = o || [], o[0] = Math.min(Math.max(Math.min(h[0], h[1]), g4), Math.max(h[0], h[1])), o[1] = Math.min(Math.max(Math.min(p4[0], p4[1]), y4), Math.max(p4[0], p4[1])), o;
    }, n2.prototype.pointToData = function(e2, o) {
      var l4 = [];
      if (this._invTransform)
        return Sp(l4, e2, this._invTransform);
      var c4 = this.getAxis("x"), h = this.getAxis("y");
      return l4[0] = c4.coordToData(c4.toLocalCoord(e2[0]), o), l4[1] = h.coordToData(h.toLocalCoord(e2[1]), o), l4;
    }, n2.prototype.getOtherAxis = function(e2) {
      return this.getAxis(e2.dim === "x" ? "y" : "x");
    }, n2.prototype.getArea = function() {
      var e2 = this.getAxis("x").getGlobalExtent(), o = this.getAxis("y").getGlobalExtent(), l4 = Math.min(e2[0], e2[1]), c4 = Math.min(o[0], o[1]), h = Math.max(e2[0], e2[1]) - l4, p4 = Math.max(o[0], o[1]) - c4;
      return new mo(l4, c4, h, p4);
    }, n2;
  }(Agt), Igt = Egt, Tgt = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4, h) {
      var p4 = i.call(this, e2, o, l4) || this;
      return p4.index = 0, p4.type = c4 || "value", p4.position = h || "bottom", p4;
    }
    return n2.prototype.isHorizontal = function() {
      var e2 = this.position;
      return e2 === "top" || e2 === "bottom";
    }, n2.prototype.getGlobalExtent = function(e2) {
      var o = this.getExtent();
      return o[0] = this.toGlobalCoord(o[0]), o[1] = this.toGlobalCoord(o[1]), e2 && o[0] > o[1] && o.reverse(), o;
    }, n2.prototype.pointToData = function(e2, o) {
      return this.coordToData(this.toLocalCoord(e2[this.dim === "x" ? 0 : 1]), o);
    }, n2.prototype.setCategorySortInfo = function(e2) {
      if (this.type !== "category")
        return false;
      this.model.option.categorySortInfo = e2, this.scale.setSortInfo(e2);
    }, n2;
  }(lb2), Dgt = Tgt;
  function Eoe(i, n2, e2) {
    e2 = e2 || {};
    var o = i.coordinateSystem, l4 = n2.axis, c4 = {}, h = l4.getAxesOnZeroOf()[0], p4 = l4.position, g4 = h ? "onZero" : p4, y4 = l4.dim, _ = o.getRect(), w4 = [_.x, _.x + _.width, _.y, _.y + _.height], C = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, E = n2.get("offset") || 0, T = y4 === "x" ? [w4[2] - E, w4[3] + E] : [w4[0] - E, w4[1] + E];
    if (h) {
      var O = h.toGlobalCoord(h.dataToCoord(0));
      T[C.onZero] = Math.max(Math.min(O, T[1]), T[0]);
    }
    c4.position = [y4 === "y" ? T[C[g4]] : w4[0], y4 === "x" ? T[C[g4]] : w4[3]], c4.rotation = Math.PI / 2 * (y4 === "x" ? 0 : 1);
    var N = { top: -1, bottom: 1, left: -1, right: 1 };
    c4.labelDirection = c4.tickDirection = c4.nameDirection = N[p4], c4.labelOffset = h ? T[C[p4]] - T[C.onZero] : 0, n2.get(["axisTick", "inside"]) && (c4.tickDirection = -c4.tickDirection), Nd(e2.labelInside, n2.get(["axisLabel", "inside"])) && (c4.labelDirection = -c4.labelDirection);
    var V = n2.get(["axisLabel", "rotate"]);
    return c4.labelRotate = g4 === "top" ? -V : V, c4.z2 = 1, c4;
  }
  function eCe(i) {
    return i.get("coordinateSystem") === "cartesian2d";
  }
  function tCe(i) {
    var n2 = { xAxisModel: null, yAxisModel: null };
    return Ve(n2, function(e2, o) {
      var l4 = o.replace(/Model$/, ""), c4 = i.getReferringComponents(l4, Yf).models[0];
      n2[o] = c4;
    }), n2;
  }
  var sae = Math.log;
  function Xke(i, n2, e2) {
    var o = tM.prototype, l4 = o.getTicks.call(e2), c4 = o.getTicks.call(e2, true), h = l4.length - 1, p4 = o.getInterval.call(e2), g4 = rke(i, n2), y4 = g4.extent, _ = g4.fixMin, w4 = g4.fixMax;
    if (i.type === "log") {
      var C = sae(i.base);
      y4 = [sae(y4[0]) / C, sae(y4[1]) / C];
    }
    i.setExtent(y4[0], y4[1]), i.calcNiceExtent({ splitNumber: h, fixMin: _, fixMax: w4 });
    var E = o.getExtent.call(i);
    _ && (y4[0] = E[0]), w4 && (y4[1] = E[1]);
    var T = o.getInterval.call(i), O = y4[0], N = y4[1];
    if (_ && w4)
      T = (N - O) / h;
    else if (_)
      for (N = y4[0] + T * h; N < y4[1] && isFinite(N) && isFinite(y4[1]); )
        T = qre(T), N = y4[0] + T * h;
    else if (w4)
      for (O = y4[1] - T * h; O > y4[0] && isFinite(O) && isFinite(y4[0]); )
        T = qre(T), O = y4[1] - T * h;
    else {
      var V = i.getTicks().length - 1;
      V > h && (T = qre(T));
      var H = T * h;
      N = Math.ceil(y4[1] / T) * T, O = df(N - H), O < 0 && y4[0] >= 0 ? (O = 0, N = df(H)) : N > 0 && y4[1] <= 0 && (N = 0, O = -df(H));
    }
    var X = (l4[0].value - c4[0].value) / p4, q2 = (l4[h].value - c4[h].value) / p4;
    o.setExtent.call(i, O + T * X, N + T * q2), o.setInterval.call(i, T), (X || q2) && o.setNiceExtent.call(i, O + T, N - T);
  }
  var kgt = function() {
    function i(n2, e2, o) {
      this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = Aoe, this._initCartesian(n2, e2, o), this.model = n2;
    }
    return i.prototype.getRect = function() {
      return this._rect;
    }, i.prototype.update = function(n2, e2) {
      var o = this._axesMap;
      this._updateScale(n2, this.model);
      function l4(h) {
        var p4, g4 = ts(h), y4 = g4.length;
        if (!!y4) {
          for (var _ = [], w4 = y4 - 1; w4 >= 0; w4--) {
            var C = +g4[w4], E = h[C], T = E.model, O = E.scale;
            boe(O) && T.get("alignTicks") && T.get("interval") == null ? _.push(E) : (F3(O, T), boe(O) && (p4 = E));
          }
          _.length && (p4 || (p4 = _.pop(), F3(p4.scale, p4.model)), Ve(_, function(N) {
            Xke(N.scale, N.model, p4.scale);
          }));
        }
      }
      l4(o.x), l4(o.y);
      var c4 = {};
      Ve(o.x, function(h) {
        nCe(o, "y", h, c4);
      }), Ve(o.y, function(h) {
        nCe(o, "x", h, c4);
      }), this.resize(this.model, e2);
    }, i.prototype.resize = function(n2, e2, o) {
      var l4 = n2.getBoxLayoutParams(), c4 = !o && n2.get("containLabel"), h = bh(l4, { width: e2.getWidth(), height: e2.getHeight() });
      this._rect = h;
      var p4 = this._axesList;
      g4(), c4 && (Ve(p4, function(y4) {
        if (!y4.model.get(["axisLabel", "inside"])) {
          var _ = Hdt(y4);
          if (_) {
            var w4 = y4.isHorizontal() ? "height" : "width", C = y4.model.get(["axisLabel", "margin"]);
            h[w4] -= _[w4] + C, y4.position === "top" ? h.y += _.height + C : y4.position === "left" && (h.x += _.width + C);
          }
        }
      }), g4()), Ve(this._coordsList, function(y4) {
        y4.calcAffineTransform();
      });
      function g4() {
        Ve(p4, function(y4) {
          var _ = y4.isHorizontal(), w4 = _ ? [0, h.width] : [0, h.height], C = y4.inverse ? 1 : 0;
          y4.setExtent(w4[C], w4[1 - C]), Pgt(y4, _ ? h.x : h.y);
        });
      }
    }, i.prototype.getAxis = function(n2, e2) {
      var o = this._axesMap[n2];
      if (o != null)
        return o[e2 || 0];
    }, i.prototype.getAxes = function() {
      return this._axesList.slice();
    }, i.prototype.getCartesian = function(n2, e2) {
      if (n2 != null && e2 != null) {
        var o = "x" + n2 + "y" + e2;
        return this._coordsMap[o];
      }
      mi(n2) && (e2 = n2.yAxisIndex, n2 = n2.xAxisIndex);
      for (var l4 = 0, c4 = this._coordsList; l4 < c4.length; l4++)
        if (c4[l4].getAxis("x").index === n2 || c4[l4].getAxis("y").index === e2)
          return c4[l4];
    }, i.prototype.getCartesians = function() {
      return this._coordsList.slice();
    }, i.prototype.convertToPixel = function(n2, e2, o) {
      var l4 = this._findConvertTarget(e2);
      return l4.cartesian ? l4.cartesian.dataToPoint(o) : l4.axis ? l4.axis.toGlobalCoord(l4.axis.dataToCoord(o)) : null;
    }, i.prototype.convertFromPixel = function(n2, e2, o) {
      var l4 = this._findConvertTarget(e2);
      return l4.cartesian ? l4.cartesian.pointToData(o) : l4.axis ? l4.axis.coordToData(l4.axis.toLocalCoord(o)) : null;
    }, i.prototype._findConvertTarget = function(n2) {
      var e2 = n2.seriesModel, o = n2.xAxisModel || e2 && e2.getReferringComponents("xAxis", Yf).models[0], l4 = n2.yAxisModel || e2 && e2.getReferringComponents("yAxis", Yf).models[0], c4 = n2.gridModel, h = this._coordsList, p4, g4;
      if (e2)
        p4 = e2.coordinateSystem, go(h, p4) < 0 && (p4 = null);
      else if (o && l4)
        p4 = this.getCartesian(o.componentIndex, l4.componentIndex);
      else if (o)
        g4 = this.getAxis("x", o.componentIndex);
      else if (l4)
        g4 = this.getAxis("y", l4.componentIndex);
      else if (c4) {
        var y4 = c4.coordinateSystem;
        y4 === this && (p4 = this._coordsList[0]);
      }
      return { cartesian: p4, axis: g4 };
    }, i.prototype.containPoint = function(n2) {
      var e2 = this._coordsList[0];
      if (e2)
        return e2.containPoint(n2);
    }, i.prototype._initCartesian = function(n2, e2, o) {
      var l4 = this, c4 = this, h = { left: false, right: false, top: false, bottom: false }, p4 = { x: {}, y: {} }, g4 = { x: 0, y: 0 };
      if (e2.eachComponent("xAxis", y4("x"), this), e2.eachComponent("yAxis", y4("y"), this), !g4.x || !g4.y) {
        this._axesMap = {}, this._axesList = [];
        return;
      }
      this._axesMap = p4, Ve(p4.x, function(_, w4) {
        Ve(p4.y, function(C, E) {
          var T = "x" + w4 + "y" + E, O = new Igt(T);
          O.master = l4, O.model = n2, l4._coordsMap[T] = O, l4._coordsList.push(O), O.addAxis(_), O.addAxis(C);
        });
      });
      function y4(_) {
        return function(w4, C) {
          if (!!lae(w4, n2)) {
            var E = w4.get("position");
            _ === "x" ? E !== "top" && E !== "bottom" && (E = h.bottom ? "top" : "bottom") : E !== "left" && E !== "right" && (E = h.left ? "right" : "left"), h[E] = true;
            var T = new Dgt(_, $$(w4), [0, 0], w4.get("type"), E), O = T.type === "category";
            T.onBand = O && w4.get("boundaryGap"), T.inverse = w4.get("inverse"), w4.axis = T, T.model = w4, T.grid = c4, T.index = C, c4._axesList.push(T), p4[_][C] = T, g4[_]++;
          }
        };
      }
    }, i.prototype._updateScale = function(n2, e2) {
      Ve(this._axesList, function(l4) {
        if (l4.scale.setExtent(1 / 0, -1 / 0), l4.type === "category") {
          var c4 = l4.model.get("categorySortInfo");
          l4.scale.setSortInfo(c4);
        }
      }), n2.eachSeries(function(l4) {
        if (eCe(l4)) {
          var c4 = tCe(l4), h = c4.xAxisModel, p4 = c4.yAxisModel;
          if (!lae(h, e2) || !lae(p4, e2))
            return;
          var g4 = this.getCartesian(h.componentIndex, p4.componentIndex), y4 = l4.getData(), _ = g4.getAxis("x"), w4 = g4.getAxis("y");
          o(y4, _), o(y4, w4);
        }
      }, this);
      function o(l4, c4) {
        Ve(jH(l4, c4.dim), function(h) {
          c4.scale.unionExtentFromData(l4, h);
        });
      }
    }, i.prototype.getTooltipAxes = function(n2) {
      var e2 = [], o = [];
      return Ve(this.getCartesians(), function(l4) {
        var c4 = n2 != null && n2 !== "auto" ? l4.getAxis(n2) : l4.getBaseAxis(), h = l4.getOtherAxis(c4);
        go(e2, c4) < 0 && e2.push(c4), go(o, h) < 0 && o.push(h);
      }), { baseAxes: e2, otherAxes: o };
    }, i.create = function(n2, e2) {
      var o = [];
      return n2.eachComponent("grid", function(l4, c4) {
        var h = new i(l4, n2, e2);
        h.name = "grid_" + c4, h.resize(l4, e2, true), l4.coordinateSystem = h, o.push(h);
      }), n2.eachSeries(function(l4) {
        if (!!eCe(l4)) {
          var c4 = tCe(l4), h = c4.xAxisModel, p4 = c4.yAxisModel, g4 = h.getCoordSysModel(), y4 = g4.coordinateSystem;
          l4.coordinateSystem = y4.getCartesian(h.componentIndex, p4.componentIndex);
        }
      }), o;
    }, i.dimensions = Aoe, i;
  }();
  function lae(i, n2) {
    return i.getCoordSysModel() === n2;
  }
  function nCe(i, n2, e2, o) {
    e2.getAxesOnZeroOf = function() {
      return c4 ? [c4] : [];
    };
    var l4 = i[n2], c4, h = e2.model, p4 = h.get(["axisLine", "onZero"]), g4 = h.get(["axisLine", "onZeroAxisIndex"]);
    if (!p4)
      return;
    if (g4 != null)
      rCe(l4[g4]) && (c4 = l4[g4]);
    else
      for (var y4 in l4)
        if (l4.hasOwnProperty(y4) && rCe(l4[y4]) && !o[_(l4[y4])]) {
          c4 = l4[y4];
          break;
        }
    c4 && (o[_(c4)] = true);
    function _(w4) {
      return w4.dim + "_" + w4.index;
    }
  }
  function rCe(i) {
    return i && i.type !== "category" && i.type !== "time" && Wdt(i);
  }
  function Pgt(i, n2) {
    var e2 = i.getExtent(), o = e2[0] + e2[1];
    i.toGlobalCoord = i.dim === "x" ? function(l4) {
      return l4 + n2;
    } : function(l4) {
      return o - l4 + n2;
    }, i.toLocalCoord = i.dim === "x" ? function(l4) {
      return l4 - n2;
    } : function(l4) {
      return o - l4 + n2;
    };
  }
  var Lgt = kgt, GC = Math.PI, vT = function() {
    function i(n2, e2) {
      this.group = new Ti(), this.opt = e2, this.axisModel = n2, hi(e2, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
        return true;
      } });
      var o = new Ti({ x: e2.position[0], y: e2.position[1], rotation: e2.rotation });
      o.updateTransform(), this._transformGroup = o;
    }
    return i.prototype.hasBuilder = function(n2) {
      return !!aCe[n2];
    }, i.prototype.add = function(n2) {
      aCe[n2](this.opt, this.axisModel, this.group, this._transformGroup);
    }, i.prototype.getGroup = function() {
      return this.group;
    }, i.innerTextLayout = function(n2, e2, o) {
      var l4 = XIe(e2 - n2), c4, h;
      return CH(l4) ? (h = o > 0 ? "top" : "bottom", c4 = "center") : CH(l4 - GC) ? (h = o > 0 ? "bottom" : "top", c4 = "center") : (h = "middle", l4 > 0 && l4 < GC ? c4 = o > 0 ? "right" : "left" : c4 = o > 0 ? "left" : "right"), { rotation: l4, textAlign: c4, textVerticalAlign: h };
    }, i.makeAxisEventDataBase = function(n2) {
      var e2 = { componentType: n2.mainType, componentIndex: n2.componentIndex };
      return e2[n2.mainType + "Index"] = n2.componentIndex, e2;
    }, i.isLabelSilent = function(n2) {
      var e2 = n2.get("tooltip");
      return n2.get("silent") || !(n2.get("triggerEvent") || e2 && e2.show);
    }, i;
  }(), aCe = { axisLine: function(i, n2, e2, o) {
    var l4 = n2.get(["axisLine", "show"]);
    if (l4 === "auto" && i.handleAutoShown && (l4 = i.handleAutoShown("axisLine")), !!l4) {
      var c4 = n2.axis.getExtent(), h = o.transform, p4 = [c4[0], 0], g4 = [c4[1], 0];
      h && (Sp(p4, p4, h), Sp(g4, g4, h));
      var y4 = rr({ lineCap: "round" }, n2.getModel(["axisLine", "lineStyle"]).getLineStyle()), _ = new Vd({ subPixelOptimize: true, shape: { x1: p4[0], y1: p4[1], x2: g4[0], y2: g4[1] }, style: y4, strokeContainThreshold: i.strokeContainThreshold || 5, silent: true, z2: 1 });
      _.anid = "line", e2.add(_);
      var w4 = n2.get(["axisLine", "symbol"]);
      if (w4 != null) {
        var C = n2.get(["axisLine", "symbolSize"]);
        xa(w4) && (w4 = [w4, w4]), (xa(C) || sl(C)) && (C = [C, C]);
        var E = nL(n2.get(["axisLine", "symbolOffset"]) || 0, C), T = C[0], O = C[1];
        Ve([{ rotate: i.rotation + Math.PI / 2, offset: E[0], r: 0 }, { rotate: i.rotation - Math.PI / 2, offset: E[1], r: Math.sqrt((p4[0] - g4[0]) * (p4[0] - g4[0]) + (p4[1] - g4[1]) * (p4[1] - g4[1])) }], function(N, V) {
          if (w4[V] !== "none" && w4[V] != null) {
            var H = Xf(w4[V], -T / 2, -O / 2, T, O, y4.stroke, true), X = N.r + N.offset;
            H.attr({ rotation: N.rotate, x: p4[0] + X * Math.cos(i.rotation), y: p4[1] - X * Math.sin(i.rotation), silent: true, z2: 11 }), e2.add(H);
          }
        });
      }
    }
  }, axisTickLabel: function(i, n2, e2, o) {
    var l4 = Fgt(e2, o, n2, i), c4 = Vgt(e2, o, n2, i);
    if (Rgt(n2, c4, l4), Ngt(e2, o, n2, i.tickDirection), n2.get(["axisLabel", "hideOverlap"])) {
      var h = gke(Er(c4, function(p4) {
        return { label: p4, priority: p4.z2, defaultAttr: { ignore: p4.ignore } };
      }));
      bke(h);
    }
  }, axisName: function(i, n2, e2, o) {
    var l4 = Nd(i.axisName, n2.get("name"));
    if (!!l4) {
      var c4 = n2.get("nameLocation"), h = i.nameDirection, p4 = n2.getModel("nameTextStyle"), g4 = n2.get("nameGap") || 0, y4 = n2.axis.getExtent(), _ = y4[0] > y4[1] ? -1 : 1, w4 = [c4 === "start" ? y4[0] - _ * g4 : c4 === "end" ? y4[1] + _ * g4 : (y4[0] + y4[1]) / 2, oCe(c4) ? i.labelOffset + h * g4 : 0], C, E = n2.get("nameRotate");
      E != null && (E = E * GC / 180);
      var T;
      oCe(c4) ? C = vT.innerTextLayout(i.rotation, E != null ? E : i.rotation, h) : (C = Ogt(i.rotation, c4, E || 0, y4), T = i.axisNameAvailableWidth, T != null && (T = Math.abs(T / Math.sin(C.rotation)), !isFinite(T) && (T = null)));
      var O = p4.getFont(), N = n2.get("nameTruncate", true) || {}, V = N.ellipsis, H = Nd(i.nameTruncateMaxWidth, N.maxWidth, T), X = new Qs({ x: w4[0], y: w4[1], rotation: C.rotation, silent: vT.isLabelSilent(n2), style: Ef(p4, { text: l4, font: O, overflow: "truncate", width: H, ellipsis: V, fill: p4.getTextColor() || n2.get(["axisLine", "lineStyle", "color"]), align: p4.get("align") || C.textAlign, verticalAlign: p4.get("verticalAlign") || C.textVerticalAlign }), z2: 1 });
      if (q3({ el: X, componentModel: n2, itemName: l4 }), X.__fullText = l4, X.anid = "name", n2.get("triggerEvent")) {
        var q2 = vT.makeAxisEventDataBase(n2);
        q2.targetType = "axisName", q2.name = l4, Fi(X).eventData = q2;
      }
      o.add(X), X.updateTransform(), e2.add(X), X.decomposeTransform();
    }
  } };
  function Ogt(i, n2, e2, o) {
    var l4 = XIe(e2 - i), c4, h, p4 = o[0] > o[1], g4 = n2 === "start" && !p4 || n2 !== "start" && p4;
    return CH(l4 - GC / 2) ? (h = g4 ? "bottom" : "top", c4 = "center") : CH(l4 - GC * 1.5) ? (h = g4 ? "top" : "bottom", c4 = "center") : (h = "middle", l4 < GC * 1.5 && l4 > GC / 2 ? c4 = g4 ? "left" : "right" : c4 = g4 ? "right" : "left"), { rotation: l4, textAlign: c4, textVerticalAlign: h };
  }
  function Rgt(i, n2, e2) {
    if (!ake(i.axis)) {
      var o = i.get(["axisLabel", "showMinLabel"]), l4 = i.get(["axisLabel", "showMaxLabel"]);
      n2 = n2 || [], e2 = e2 || [];
      var c4 = n2[0], h = n2[1], p4 = n2[n2.length - 1], g4 = n2[n2.length - 2], y4 = e2[0], _ = e2[1], w4 = e2[e2.length - 1], C = e2[e2.length - 2];
      o === false ? (by(c4), by(y4)) : iCe(c4, h) && (o ? (by(h), by(_)) : (by(c4), by(y4))), l4 === false ? (by(p4), by(w4)) : iCe(g4, p4) && (l4 ? (by(g4), by(C)) : (by(p4), by(w4)));
    }
  }
  function by(i) {
    i && (i.ignore = true);
  }
  function iCe(i, n2) {
    var e2 = i && i.getBoundingRect().clone(), o = n2 && n2.getBoundingRect().clone();
    if (!(!e2 || !o)) {
      var l4 = b$([]);
      return MT(l4, l4, -i.rotation), e2.applyTransform(p2([], l4, i.getLocalTransform())), o.applyTransform(p2([], l4, n2.getLocalTransform())), e2.intersect(o);
    }
  }
  function oCe(i) {
    return i === "middle" || i === "center";
  }
  function Kke(i, n2, e2, o, l4) {
    for (var c4 = [], h = [], p4 = [], g4 = 0; g4 < i.length; g4++) {
      var y4 = i[g4].coord;
      h[0] = y4, h[1] = 0, p4[0] = y4, p4[1] = e2, n2 && (Sp(h, h, n2), Sp(p4, p4, n2));
      var _ = new Vd({ subPixelOptimize: true, shape: { x1: h[0], y1: h[1], x2: p4[0], y2: p4[1] }, style: o, z2: 2, autoBatch: true, silent: true });
      _.anid = l4 + "_" + i[g4].tickValue, c4.push(_);
    }
    return c4;
  }
  function Fgt(i, n2, e2, o) {
    var l4 = e2.axis, c4 = e2.getModel("axisTick"), h = c4.get("show");
    if (h === "auto" && o.handleAutoShown && (h = o.handleAutoShown("axisTick")), !(!h || l4.scale.isBlank())) {
      for (var p4 = c4.getModel("lineStyle"), g4 = o.tickDirection * c4.get("length"), y4 = l4.getTicksCoords(), _ = Kke(y4, n2.transform, g4, hi(p4.getLineStyle(), { stroke: e2.get(["axisLine", "lineStyle", "color"]) }), "ticks"), w4 = 0; w4 < _.length; w4++)
        i.add(_[w4]);
      return _;
    }
  }
  function Ngt(i, n2, e2, o) {
    var l4 = e2.axis, c4 = e2.getModel("minorTick");
    if (!(!c4.get("show") || l4.scale.isBlank())) {
      var h = l4.getMinorTicksCoords();
      if (!!h.length)
        for (var p4 = c4.getModel("lineStyle"), g4 = o * c4.get("length"), y4 = hi(p4.getLineStyle(), hi(e2.getModel("axisTick").getLineStyle(), { stroke: e2.get(["axisLine", "lineStyle", "color"]) })), _ = 0; _ < h.length; _++)
          for (var w4 = Kke(h[_], n2.transform, g4, y4, "minorticks_" + _), C = 0; C < w4.length; C++)
            i.add(w4[C]);
    }
  }
  function Vgt(i, n2, e2, o) {
    var l4 = e2.axis, c4 = Nd(o.axisLabelShow, e2.get(["axisLabel", "show"]));
    if (!(!c4 || l4.scale.isBlank())) {
      var h = e2.getModel("axisLabel"), p4 = h.get("margin"), g4 = l4.getViewLabels(), y4 = (Nd(o.labelRotate, h.get("rotate")) || 0) * GC / 180, _ = vT.innerTextLayout(o.rotation, y4, o.labelDirection), w4 = e2.getCategories && e2.getCategories(true), C = [], E = vT.isLabelSilent(e2), T = e2.get("triggerEvent");
      return Ve(g4, function(O, N) {
        var V = l4.scale.type === "ordinal" ? l4.scale.getRawOrdinalNumber(O.tickValue) : O.tickValue, H = O.formattedLabel, X = O.rawLabel, q2 = h;
        if (w4 && w4[V]) {
          var de = w4[V];
          mi(de) && de.textStyle && (q2 = new Ou(de.textStyle, h, e2.ecModel));
        }
        var le = q2.getTextColor() || e2.get(["axisLine", "lineStyle", "color"]), me = l4.dataToCoord(V), ye = new Qs({ x: me, y: o.labelOffset + o.labelDirection * p4, rotation: _.rotation, silent: E, z2: 10 + (O.level || 0), style: Ef(q2, { text: H, align: q2.getShallow("align", true) || _.textAlign, verticalAlign: q2.getShallow("verticalAlign", true) || q2.getShallow("baseline", true) || _.textVerticalAlign, fill: si(le) ? le(l4.type === "category" ? X : l4.type === "value" ? V + "" : V, N) : le }) });
        if (ye.anid = "label_" + V, T) {
          var be = vT.makeAxisEventDataBase(e2);
          be.targetType = "axisLabel", be.value = X, be.tickIndex = N, l4.type === "category" && (be.dataIndex = V), Fi(ye).eventData = be;
        }
        n2.add(ye), ye.updateTransform(), C.push(ye), i.add(ye), ye.decomposeTransform();
      }), C;
    }
  }
  var w2 = vT;
  function zgt(i, n2) {
    var e2 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
    return Bgt(e2, i, n2), e2.seriesInvolved && Ggt(e2, i), e2;
  }
  function Bgt(i, n2, e2) {
    var o = n2.getComponent("tooltip"), l4 = n2.getComponent("axisPointer"), c4 = l4.get("link", true) || [], h = [];
    Ve(e2.getCoordinateSystems(), function(p4) {
      if (!p4.axisPointerEnabled)
        return;
      var g4 = C8(p4.model), y4 = i.coordSysAxesInfo[g4] = {};
      i.coordSysMap[g4] = p4;
      var _ = p4.model, w4 = _.getModel("tooltip", o);
      if (Ve(p4.getAxes(), zi(O, false, null)), p4.getTooltipAxes && o && w4.get("show")) {
        var C = w4.get("trigger") === "axis", E = w4.get(["axisPointer", "type"]) === "cross", T = p4.getTooltipAxes(w4.get(["axisPointer", "axis"]));
        (C || E) && Ve(T.baseAxes, zi(O, E ? "cross" : true, C)), E && Ve(T.otherAxes, zi(O, "cross", false));
      }
      function O(N, V, H) {
        var X = H.model.getModel("axisPointer", l4), q2 = X.get("show");
        if (!(!q2 || q2 === "auto" && !N && !Ioe(X))) {
          V == null && (V = X.get("triggerTooltip")), X = N ? jgt(H, w4, l4, n2, N, V) : X;
          var de = X.get("snap"), le = C8(H.model), me = V || de || H.type === "category", ye = i.axesInfo[le] = { key: le, axis: H, coordSys: p4, axisPointerModel: X, triggerTooltip: V, involveSeries: me, snap: de, useHandle: Ioe(X), seriesModels: [], linkGroup: null };
          y4[le] = ye, i.seriesInvolved = i.seriesInvolved || me;
          var be = Wgt(c4, H);
          if (be != null) {
            var we = h[be] || (h[be] = { axesInfo: {} });
            we.axesInfo[le] = ye, we.mapper = c4[be].mapper, ye.linkGroup = we;
          }
        }
      }
    });
  }
  function jgt(i, n2, e2, o, l4, c4) {
    var h = n2.getModel("axisPointer"), p4 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], g4 = {};
    Ve(p4, function(C) {
      g4[C] = Ci(h.get(C));
    }), g4.snap = i.type !== "category" && !!c4, h.get("type") === "cross" && (g4.type = "line");
    var y4 = g4.label || (g4.label = {});
    if (y4.show == null && (y4.show = false), l4 === "cross") {
      var _ = h.get(["label", "show"]);
      if (y4.show = _ != null ? _ : true, !c4) {
        var w4 = g4.lineStyle = h.get("crossStyle");
        w4 && hi(y4, w4.textStyle);
      }
    }
    return i.model.getModel("axisPointer", new Ou(g4, e2, o));
  }
  function Ggt(i, n2) {
    n2.eachSeries(function(e2) {
      var o = e2.coordinateSystem, l4 = e2.get(["tooltip", "trigger"], true), c4 = e2.get(["tooltip", "show"], true);
      !o || l4 === "none" || l4 === false || l4 === "item" || c4 === false || e2.get(["axisPointer", "show"], true) === false || Ve(i.coordSysAxesInfo[C8(o.model)], function(h) {
        var p4 = h.axis;
        o.getAxis(p4.dim) === p4 && (h.seriesModels.push(e2), h.seriesDataCount == null && (h.seriesDataCount = 0), h.seriesDataCount += e2.getData().count());
      });
    });
  }
  function Wgt(i, n2) {
    for (var e2 = n2.model, o = n2.dim, l4 = 0; l4 < i.length; l4++) {
      var c4 = i[l4] || {};
      if (uae(c4[o + "AxisId"], e2.id) || uae(c4[o + "AxisIndex"], e2.componentIndex) || uae(c4[o + "AxisName"], e2.name))
        return l4;
    }
  }
  function uae(i, n2) {
    return i === "all" || Mr(i) && go(i, n2) >= 0 || i === n2;
  }
  function Hgt(i) {
    var n2 = Nle(i);
    if (!!n2) {
      var e2 = n2.axisPointerModel, o = n2.axis.scale, l4 = e2.option, c4 = e2.get("status"), h = e2.get("value");
      h != null && (h = o.parse(h));
      var p4 = Ioe(e2);
      c4 == null && (l4.status = p4 ? "show" : "hide");
      var g4 = o.getExtent().slice();
      g4[0] > g4[1] && g4.reverse(), (h == null || h > g4[1]) && (h = g4[1]), h < g4[0] && (h = g4[0]), l4.value = h, p4 && (l4.status = n2.axis.scale.isBlank() ? "hide" : "show");
    }
  }
  function Nle(i) {
    var n2 = (i.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
    return n2 && n2.axesInfo[C8(i)];
  }
  function $gt(i) {
    var n2 = Nle(i);
    return n2 && n2.axisPointerModel;
  }
  function Ioe(i) {
    return !!i.get(["handle", "show"]);
  }
  function C8(i) {
    return i.type + "||" + i.id;
  }
  var sCe = {}, Ugt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      this.axisPointerClass && Hgt(e2), i.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(e2, l4, true);
    }, n2.prototype.updateAxisPointer = function(e2, o, l4, c4) {
      this._doUpdateAxisPointerClass(e2, l4, false);
    }, n2.prototype.remove = function(e2, o) {
      var l4 = this._axisPointer;
      l4 && l4.remove(o);
    }, n2.prototype.dispose = function(e2, o) {
      this._disposeAxisPointer(o), i.prototype.dispose.apply(this, arguments);
    }, n2.prototype._doUpdateAxisPointerClass = function(e2, o, l4) {
      var c4 = n2.getAxisPointerClass(this.axisPointerClass);
      if (!!c4) {
        var h = $gt(e2);
        h ? (this._axisPointer || (this._axisPointer = new c4())).render(e2, h, o, l4) : this._disposeAxisPointer(o);
      }
    }, n2.prototype._disposeAxisPointer = function(e2) {
      this._axisPointer && this._axisPointer.dispose(e2), this._axisPointer = null;
    }, n2.registerAxisPointerClass = function(e2, o) {
      sCe[e2] = o;
    }, n2.getAxisPointerClass = function(e2) {
      return e2 && sCe[e2];
    }, n2.type = "axis", n2;
  }($c), IT = Ugt, Toe = zs();
  function Jke(i, n2, e2, o) {
    var l4 = e2.axis;
    if (!l4.scale.isBlank()) {
      var c4 = e2.getModel("splitArea"), h = c4.getModel("areaStyle"), p4 = h.get("color"), g4 = o.coordinateSystem.getRect(), y4 = l4.getTicksCoords({ tickModel: c4, clamp: true });
      if (!!y4.length) {
        var _ = p4.length, w4 = Toe(i).splitAreaColors, C = ri(), E = 0;
        if (w4)
          for (var T = 0; T < y4.length; T++) {
            var O = w4.get(y4[T].tickValue);
            if (O != null) {
              E = (O + (_ - 1) * T) % _;
              break;
            }
          }
        var N = l4.toGlobalCoord(y4[0].coord), V = h.getAreaStyle();
        p4 = Mr(p4) ? p4 : [p4];
        for (var T = 1; T < y4.length; T++) {
          var H = l4.toGlobalCoord(y4[T].coord), X = void 0, q2 = void 0, de = void 0, le = void 0;
          l4.isHorizontal() ? (X = N, q2 = g4.y, de = H - X, le = g4.height, N = X + de) : (X = g4.x, q2 = N, de = g4.width, le = H - q2, N = q2 + le);
          var me = y4[T - 1].tickValue;
          me != null && C.set(me, E), n2.add(new Is({ anid: me != null ? "area_" + me : null, shape: { x: X, y: q2, width: de, height: le }, style: hi({ fill: p4[E] }, V), autoBatch: true, silent: true })), E = (E + 1) % _;
        }
        Toe(i).splitAreaColors = C;
      }
    }
  }
  function Qke(i) {
    Toe(i).splitAreaColors = null;
  }
  var qgt = ["axisLine", "axisTickLabel", "axisName"], Ygt = ["splitArea", "splitLine", "minorSplitLine"], ePe = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.axisPointerClass = "CartesianAxisPointer", e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      this.group.removeAll();
      var h = this._axisGroup;
      if (this._axisGroup = new Ti(), this.group.add(this._axisGroup), !!e2.get("show")) {
        var p4 = e2.getCoordSysModel(), g4 = Eoe(p4, e2), y4 = new w2(e2, rr({ handleAutoShown: function(w4) {
          for (var C = p4.coordinateSystem.getCartesians(), E = 0; E < C.length; E++)
            if (boe(C[E].getOtherAxis(e2.axis).scale))
              return true;
          return false;
        } }, g4));
        Ve(qgt, y4.add, y4), this._axisGroup.add(y4.getGroup()), Ve(Ygt, function(w4) {
          e2.get([w4, "show"]) && Zgt[w4](this, this._axisGroup, e2, p4);
        }, this);
        var _ = c4 && c4.type === "changeAxisOrder" && c4.isInitSort;
        _ || j8(h, this._axisGroup, e2), i.prototype.render.call(this, e2, o, l4, c4);
      }
    }, n2.prototype.remove = function() {
      Qke(this);
    }, n2.type = "cartesianAxis", n2;
  }(IT), Zgt = { splitLine: function(i, n2, e2, o) {
    var l4 = e2.axis;
    if (!l4.scale.isBlank()) {
      var c4 = e2.getModel("splitLine"), h = c4.getModel("lineStyle"), p4 = h.get("color");
      p4 = Mr(p4) ? p4 : [p4];
      for (var g4 = o.coordinateSystem.getRect(), y4 = l4.isHorizontal(), _ = 0, w4 = l4.getTicksCoords({ tickModel: c4 }), C = [], E = [], T = h.getLineStyle(), O = 0; O < w4.length; O++) {
        var N = l4.toGlobalCoord(w4[O].coord);
        y4 ? (C[0] = N, C[1] = g4.y, E[0] = N, E[1] = g4.y + g4.height) : (C[0] = g4.x, C[1] = N, E[0] = g4.x + g4.width, E[1] = N);
        var V = _++ % p4.length, H = w4[O].tickValue;
        n2.add(new Vd({ anid: H != null ? "line_" + w4[O].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: C[0], y1: C[1], x2: E[0], y2: E[1] }, style: hi({ stroke: p4[V] }, T), silent: true }));
      }
    }
  }, minorSplitLine: function(i, n2, e2, o) {
    var l4 = e2.axis, c4 = e2.getModel("minorSplitLine"), h = c4.getModel("lineStyle"), p4 = o.coordinateSystem.getRect(), g4 = l4.isHorizontal(), y4 = l4.getMinorTicksCoords();
    if (!!y4.length)
      for (var _ = [], w4 = [], C = h.getLineStyle(), E = 0; E < y4.length; E++)
        for (var T = 0; T < y4[E].length; T++) {
          var O = l4.toGlobalCoord(y4[E][T].coord);
          g4 ? (_[0] = O, _[1] = p4.y, w4[0] = O, w4[1] = p4.y + p4.height) : (_[0] = p4.x, _[1] = O, w4[0] = p4.x + p4.width, w4[1] = O), n2.add(new Vd({ anid: "minor_line_" + y4[E][T].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: _[0], y1: _[1], x2: w4[0], y2: w4[1] }, style: C, silent: true }));
        }
  }, splitArea: function(i, n2, e2, o) {
    Jke(i, n2, e2, o);
  } }, tPe = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "xAxis", n2;
  }(ePe), Xgt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = tPe.type, e2;
    }
    return n2.type = "yAxis", n2;
  }(ePe), Kgt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "grid", e2;
    }
    return n2.prototype.render = function(e2, o) {
      this.group.removeAll(), e2.get("show") && this.group.add(new Is({ shape: e2.coordinateSystem.getRect(), style: hi({ fill: e2.get("backgroundColor") }, e2.getItemStyle()), silent: true, z2: -1 }));
    }, n2.type = "grid", n2;
  }($c), lCe = { offset: 0 };
  function nPe(i) {
    i.registerComponentView(Kgt), i.registerComponentModel(_gt), i.registerCoordinateSystem("cartesian2d", Lgt), V3(i, "x", Moe, lCe), V3(i, "y", Moe, lCe), i.registerComponentView(tPe), i.registerComponentView(Xgt), i.registerPreprocessor(function(n2) {
      n2.xAxis && n2.yAxis && !n2.grid && (n2.grid = {});
    });
  }
  function Jgt(i) {
    wo(nPe), i.registerSeriesModel(hgt), i.registerChartView(ygt), i.registerLayout(J8("scatter"));
  }
  function Qgt(i) {
    i.eachSeriesByType("radar", function(n2) {
      var e2 = n2.getData(), o = [], l4 = n2.coordinateSystem;
      if (!!l4) {
        var c4 = l4.getIndicatorAxes();
        Ve(c4, function(h, p4) {
          e2.each(e2.mapDimension(c4[p4].dim), function(g4, y4) {
            o[y4] = o[y4] || [];
            var _ = l4.dataToPoint(g4, p4);
            o[y4][p4] = uCe(_) ? _ : cCe(l4);
          });
        }), e2.each(function(h) {
          var p4 = Fit(o[h], function(g4) {
            return uCe(g4);
          }) || cCe(l4);
          o[h].push(p4.slice()), e2.setItemLayout(h, o[h]);
        });
      }
    });
  }
  function uCe(i) {
    return !isNaN(i[0]) && !isNaN(i[1]);
  }
  function cCe(i) {
    return [i.cx, i.cy];
  }
  function e0t(i) {
    var n2 = i.polar;
    if (n2) {
      Mr(n2) || (n2 = [n2]);
      var e2 = [];
      Ve(n2, function(o, l4) {
        o.indicator ? (o.type && !o.shape && (o.shape = o.type), i.radar = i.radar || [], Mr(i.radar) || (i.radar = [i.radar]), i.radar.push(o)) : e2.push(o);
      }), i.polar = e2;
    }
    Ve(i.series, function(o) {
      o && o.type === "radar" && o.polarIndex && (o.radarIndex = o.polarIndex);
    });
  }
  var t0t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.coordinateSystem, h = this.group, p4 = e2.getData(), g4 = this._data;
      function y4(C, E) {
        var T = C.getItemVisual(E, "symbol") || "circle";
        if (T !== "none") {
          var O = U8(C.getItemVisual(E, "symbolSize")), N = Xf(T, -1, -1, 2, 2), V = C.getItemVisual(E, "symbolRotate") || 0;
          return N.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: O[0] / 2, scaleY: O[1] / 2, rotation: V * Math.PI / 180 || 0 }), N;
        }
      }
      function _(C, E, T, O, N, V) {
        T.removeAll();
        for (var H = 0; H < E.length - 1; H++) {
          var X = y4(O, N);
          X && (X.__dimIdx = H, C[H] ? (X.setPosition(C[H]), W8[V ? "initProps" : "updateProps"](X, { x: E[H][0], y: E[H][1] }, e2, N)) : X.setPosition(E[H]), T.add(X));
        }
      }
      function w4(C) {
        return Er(C, function(E) {
          return [c4.cx, c4.cy];
        });
      }
      p4.diff(g4).add(function(C) {
        var E = p4.getItemLayout(C);
        if (!!E) {
          var T = new $g(), O = new Ug(), N = { shape: { points: E } };
          T.shape.points = w4(E), O.shape.points = w4(E), bc(T, N, e2, C), bc(O, N, e2, C);
          var V = new Ti(), H = new Ti();
          V.add(O), V.add(T), V.add(H), _(O.shape.points, E, H, p4, C, true), p4.setItemGraphicEl(C, V);
        }
      }).update(function(C, E) {
        var T = g4.getItemGraphicEl(E), O = T.childAt(0), N = T.childAt(1), V = T.childAt(2), H = { shape: { points: p4.getItemLayout(C) } };
        !H.shape.points || (_(O.shape.points, H.shape.points, V, p4, C, false), ob(N), ob(O), Vs(O, H, e2), Vs(N, H, e2), p4.setItemGraphicEl(C, T));
      }).remove(function(C) {
        h.remove(g4.getItemGraphicEl(C));
      }).execute(), p4.eachItemGraphicEl(function(C, E) {
        var T = p4.getItemModel(E), O = C.childAt(0), N = C.childAt(1), V = C.childAt(2), H = p4.getItemVisual(E, "style"), X = H.fill;
        h.add(C), O.useStyle(hi(T.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: X })), Mp(O, T, "lineStyle"), Mp(N, T, "areaStyle");
        var q2 = T.getModel("areaStyle"), de = q2.isEmpty() && q2.parentModel.isEmpty();
        N.ignore = de, Ve(["emphasis", "select", "blur"], function(ye) {
          var be = T.getModel([ye, "areaStyle"]), we = be.isEmpty() && be.parentModel.isEmpty();
          N.ensureState(ye).ignore = we && de;
        }), N.useStyle(hi(q2.getAreaStyle(), { fill: X, opacity: 0.7, decal: H.decal }));
        var le = T.getModel("emphasis"), me = le.getModel("itemStyle").getItemStyle();
        V.eachChild(function(ye) {
          if (ye instanceof Ap) {
            var be = ye.style;
            ye.useStyle(rr({ image: be.image, x: be.x, y: be.y, width: be.width, height: be.height }, H));
          } else
            ye.useStyle(H), ye.setColor(X), ye.style.strokeNoScale = true;
          var we = ye.ensureState("emphasis");
          we.style = Ci(me);
          var Pe = p4.getStore().get(p4.getDimensionIndex(ye.__dimIdx), E);
          (Pe == null || isNaN(Pe)) && (Pe = ""), yv(ye, zd(T), { labelFetcher: p4.hostModel, labelDataIndex: E, labelDimIndex: ye.__dimIdx, defaultText: Pe, inheritColor: X, defaultOpacity: H.opacity });
        }), pf(C, le.get("focus"), le.get("blurScope"), le.get("disabled"));
      }), this._data = p4;
    }, n2.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, n2.type = "radar", n2;
  }(Ru), n0t = t0t, r0t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.hasSymbolVisual = true, e2;
    }
    return n2.prototype.init = function(e2) {
      i.prototype.init.apply(this, arguments), this.legendVisualProvider = new e9(Ia(this.getData, this), Ia(this.getRawData, this));
    }, n2.prototype.getInitialData = function(e2, o) {
      return rL(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      var c4 = this.getData(), h = this.coordinateSystem, p4 = h.getIndicatorAxes(), g4 = this.getData().getName(e2), y4 = g4 === "" ? this.name : g4, _ = e5e(this, e2);
      return Qh("section", { header: y4, sortBlocks: true, blocks: Er(p4, function(w4) {
        var C = c4.get(c4.mapDimension(w4.dim), e2);
        return Qh("nameValue", { markerType: "subItem", markerColor: _, name: w4.name, value: C, sortParam: C });
      }) });
    }, n2.prototype.getTooltipPosition = function(e2) {
      if (e2 != null) {
        for (var o = this.getData(), l4 = this.coordinateSystem, c4 = o.getValues(Er(l4.dimensions, function(y4) {
          return o.mapDimension(y4);
        }), e2), h = 0, p4 = c4.length; h < p4; h++)
          if (!isNaN(c4[h])) {
            var g4 = l4.getIndicatorAxes();
            return l4.coordToPoint(g4[h].dataToCoord(c4[h]), h);
          }
      }
    }, n2.type = "series.radar", n2.dependencies = ["radar"], n2.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, n2;
  }(_c2), a0t = r0t, dN = Zke.value;
  function MW(i, n2) {
    return hi({ show: n2 }, i);
  }
  var i0t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.optionUpdated = function() {
      var e2 = this.get("boundaryGap"), o = this.get("splitNumber"), l4 = this.get("scale"), c4 = this.get("axisLine"), h = this.get("axisTick"), p4 = this.get("axisLabel"), g4 = this.get("axisName"), y4 = this.get(["axisName", "show"]), _ = this.get(["axisName", "formatter"]), w4 = this.get("axisNameGap"), C = this.get("triggerEvent"), E = Er(this.get("indicator") || [], function(T) {
        T.max != null && T.max > 0 && !T.min ? T.min = 0 : T.min != null && T.min < 0 && !T.max && (T.max = 0);
        var O = g4;
        T.color != null && (O = hi({ color: T.color }, g4));
        var N = to(Ci(T), { boundaryGap: e2, splitNumber: o, scale: l4, axisLine: c4, axisTick: h, axisLabel: p4, name: T.text, showName: y4, nameLocation: "end", nameGap: w4, nameTextStyle: O, triggerEvent: C }, false);
        if (y4 || (N.name = ""), xa(_)) {
          var V = N.name;
          N.name = _.replace("{value}", V != null ? V : "");
        } else
          si(_) && (N.name = _(N.name, N));
        var H = new Ou(N, null, this.ecModel);
        return Kf(H, Z8.prototype), H.mainType = "radar", H.componentIndex = this.componentIndex, H;
      }, this);
      this._indicatorModels = E;
    }, n2.prototype.getIndicatorModels = function() {
      return this._indicatorModels;
    }, n2.type = "radar", n2.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: to({ lineStyle: { color: "#bbb" } }, dN.axisLine), axisLabel: MW(dN.axisLabel, false), axisTick: MW(dN.axisTick, false), splitLine: MW(dN.splitLine, true), splitArea: MW(dN.splitArea, true), indicator: [] }, n2;
  }(Ns), o0t = i0t, s0t = ["axisLine", "axisTickLabel", "axisName"], l0t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = this.group;
      c4.removeAll(), this._buildAxes(e2), this._buildSplitLineAndArea(e2);
    }, n2.prototype._buildAxes = function(e2) {
      var o = e2.coordinateSystem, l4 = o.getIndicatorAxes(), c4 = Er(l4, function(h) {
        var p4 = h.model.get("showName") ? h.name : "", g4 = new w2(h.model, { axisName: p4, position: [o.cx, o.cy], rotation: h.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
        return g4;
      });
      Ve(c4, function(h) {
        Ve(s0t, h.add, h), this.group.add(h.getGroup());
      }, this);
    }, n2.prototype._buildSplitLineAndArea = function(e2) {
      var o = e2.coordinateSystem, l4 = o.getIndicatorAxes();
      if (!l4.length)
        return;
      var c4 = e2.get("shape"), h = e2.getModel("splitLine"), p4 = e2.getModel("splitArea"), g4 = h.getModel("lineStyle"), y4 = p4.getModel("areaStyle"), _ = h.get("show"), w4 = p4.get("show"), C = g4.get("color"), E = y4.get("color"), T = Mr(C) ? C : [C], O = Mr(E) ? E : [E], N = [], V = [];
      function H(ft, et, Jt) {
        var xt = Jt % et.length;
        return ft[xt] = ft[xt] || [], xt;
      }
      if (c4 === "circle")
        for (var X = l4[0].getTicksCoords(), q2 = o.cx, de = o.cy, le = 0; le < X.length; le++) {
          if (_) {
            var me = H(N, T, le);
            N[me].push(new J_({ shape: { cx: q2, cy: de, r: X[le].coord } }));
          }
          if (w4 && le < X.length - 1) {
            var me = H(V, O, le);
            V[me].push(new E$({ shape: { cx: q2, cy: de, r0: X[le].coord, r: X[le + 1].coord } }));
          }
        }
      else
        for (var ye, be = Er(l4, function(ft, et) {
          var Jt = ft.getTicksCoords();
          return ye = ye == null ? Jt.length - 1 : Math.min(Jt.length - 1, ye), Er(Jt, function(xt) {
            return o.coordToPoint(xt.coord, et);
          });
        }), we = [], le = 0; le <= ye; le++) {
          for (var Pe = [], ze = 0; ze < l4.length; ze++)
            Pe.push(be[ze][le]);
          if (Pe[0] && Pe.push(Pe[0].slice()), _) {
            var me = H(N, T, le);
            N[me].push(new Ug({ shape: { points: Pe } }));
          }
          if (w4 && we) {
            var me = H(V, O, le - 1);
            V[me].push(new $g({ shape: { points: Pe.concat(we) } }));
          }
          we = Pe.slice().reverse();
        }
      var Re = g4.getLineStyle(), rt2 = y4.getAreaStyle();
      Ve(V, function(ft, et) {
        this.group.add(ky(ft, { style: hi({ stroke: "none", fill: O[et % O.length] }, rt2), silent: true }));
      }, this), Ve(N, function(ft, et) {
        this.group.add(ky(ft, { style: hi({ fill: "none", stroke: T[et % T.length] }, Re), silent: true }));
      }, this);
    }, n2.type = "radar", n2;
  }($c), u0t = l0t, c0t = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this, e2, o, l4) || this;
      return c4.type = "value", c4.angle = 0, c4.name = "", c4;
    }
    return n2;
  }(lb2), f0t = c0t, h0t = function() {
    function i(n2, e2, o) {
      this.dimensions = [], this._model = n2, this._indicatorAxes = Er(n2.getIndicatorModels(), function(l4, c4) {
        var h = "indicator_" + c4, p4 = new f0t(h, new tM());
        return p4.name = l4.get("name"), p4.model = l4, l4.axis = p4, this.dimensions.push(h), p4;
      }, this), this.resize(n2, o);
    }
    return i.prototype.getIndicatorAxes = function() {
      return this._indicatorAxes;
    }, i.prototype.dataToPoint = function(n2, e2) {
      var o = this._indicatorAxes[e2];
      return this.coordToPoint(o.dataToCoord(n2), e2);
    }, i.prototype.coordToPoint = function(n2, e2) {
      var o = this._indicatorAxes[e2], l4 = o.angle, c4 = this.cx + n2 * Math.cos(l4), h = this.cy - n2 * Math.sin(l4);
      return [c4, h];
    }, i.prototype.pointToData = function(n2) {
      var e2 = n2[0] - this.cx, o = n2[1] - this.cy, l4 = Math.sqrt(e2 * e2 + o * o);
      e2 /= l4, o /= l4;
      for (var c4 = Math.atan2(-o, e2), h = 1 / 0, p4, g4 = -1, y4 = 0; y4 < this._indicatorAxes.length; y4++) {
        var _ = this._indicatorAxes[y4], w4 = Math.abs(c4 - _.angle);
        w4 < h && (p4 = _, g4 = y4, h = w4);
      }
      return [g4, +(p4 && p4.coordToData(l4))];
    }, i.prototype.resize = function(n2, e2) {
      var o = n2.get("center"), l4 = e2.getWidth(), c4 = e2.getHeight(), h = Math.min(l4, c4) / 2;
      this.cx = ma(o[0], l4), this.cy = ma(o[1], c4), this.startAngle = n2.get("startAngle") * Math.PI / 180;
      var p4 = n2.get("radius");
      (xa(p4) || sl(p4)) && (p4 = [0, p4]), this.r0 = ma(p4[0], h), this.r = ma(p4[1], h), Ve(this._indicatorAxes, function(g4, y4) {
        g4.setExtent(this.r0, this.r);
        var _ = this.startAngle + y4 * Math.PI * 2 / this._indicatorAxes.length;
        _ = Math.atan2(Math.sin(_), Math.cos(_)), g4.angle = _;
      }, this);
    }, i.prototype.update = function(n2, e2) {
      var o = this._indicatorAxes, l4 = this._model;
      Ve(o, function(p4) {
        p4.scale.setExtent(1 / 0, -1 / 0);
      }), n2.eachSeriesByType("radar", function(p4, g4) {
        if (!(p4.get("coordinateSystem") !== "radar" || n2.getComponent("radar", p4.get("radarIndex")) !== l4)) {
          var y4 = p4.getData();
          Ve(o, function(_) {
            _.scale.unionExtentFromData(y4, y4.mapDimension(_.dim));
          });
        }
      }, this);
      var c4 = l4.get("splitNumber"), h = new tM();
      h.setExtent(0, c4), h.setInterval(1), Ve(o, function(p4, g4) {
        Xke(p4.scale, p4.model, h);
      });
    }, i.prototype.convertToPixel = function(n2, e2, o) {
      return console.warn("Not implemented."), null;
    }, i.prototype.convertFromPixel = function(n2, e2, o) {
      return console.warn("Not implemented."), null;
    }, i.prototype.containPoint = function(n2) {
      return console.warn("Not implemented."), false;
    }, i.create = function(n2, e2) {
      var o = [];
      return n2.eachComponent("radar", function(l4) {
        var c4 = new i(l4, n2, e2);
        o.push(c4), l4.coordinateSystem = c4;
      }), n2.eachSeriesByType("radar", function(l4) {
        l4.get("coordinateSystem") === "radar" && (l4.coordinateSystem = o[l4.get("radarIndex") || 0]);
      }), o;
    }, i.dimensions = [], i;
  }(), d0t = h0t;
  function p0t(i) {
    i.registerCoordinateSystem("radar", d0t), i.registerComponentModel(o0t), i.registerComponentView(u0t), i.registerVisual({ seriesType: "radar", reset: function(n2) {
      var e2 = n2.getData();
      e2.each(function(o) {
        e2.setItemVisual(o, "legendIcon", "roundRect");
      }), e2.setVisual("legendIcon", "roundRect");
    } });
  }
  function v0t(i) {
    wo(p0t), i.registerChartView(n0t), i.registerSeriesModel(a0t), i.registerLayout(Qgt), i.registerProcessor(Q8("radar")), i.registerPreprocessor(e0t);
  }
  var fCe = "\0_ec_interaction_mutex";
  function g0t(i, n2, e2) {
    var o = Vle(i);
    o[n2] = e2;
  }
  function m0t(i, n2, e2) {
    var o = Vle(i), l4 = o[n2];
    l4 === e2 && (o[n2] = null);
  }
  function hCe(i, n2) {
    return !!Vle(i)[n2];
  }
  function Vle(i) {
    return i[fCe] || (i[fCe] = {});
  }
  ex({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, Zf);
  var y0t = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this) || this;
      o._zr = e2;
      var l4 = Ia(o._mousedownHandler, o), c4 = Ia(o._mousemoveHandler, o), h = Ia(o._mouseupHandler, o), p4 = Ia(o._mousewheelHandler, o), g4 = Ia(o._pinchHandler, o);
      return o.enable = function(y4, _) {
        this.disable(), this._opt = hi(Ci(_) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), y4 == null && (y4 = true), (y4 === true || y4 === "move" || y4 === "pan") && (e2.on("mousedown", l4), e2.on("mousemove", c4), e2.on("mouseup", h)), (y4 === true || y4 === "scale" || y4 === "zoom") && (e2.on("mousewheel", p4), e2.on("pinch", g4));
      }, o.disable = function() {
        e2.off("mousedown", l4), e2.off("mousemove", c4), e2.off("mouseup", h), e2.off("mousewheel", p4), e2.off("pinch", g4);
      }, o;
    }
    return n2.prototype.isDragging = function() {
      return this._dragging;
    }, n2.prototype.isPinching = function() {
      return this._pinching;
    }, n2.prototype.setPointerChecker = function(e2) {
      this.pointerChecker = e2;
    }, n2.prototype.dispose = function() {
      this.disable();
    }, n2.prototype._mousedownHandler = function(e2) {
      if (!(zxe(e2) || e2.target && e2.target.draggable)) {
        var o = e2.offsetX, l4 = e2.offsetY;
        this.pointerChecker && this.pointerChecker(e2, o, l4) && (this._x = o, this._y = l4, this._dragging = true);
      }
    }, n2.prototype._mousemoveHandler = function(e2) {
      if (!(!this._dragging || !uH("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || hCe(this._zr, "globalPan"))) {
        var o = e2.offsetX, l4 = e2.offsetY, c4 = this._x, h = this._y, p4 = o - c4, g4 = l4 - h;
        this._x = o, this._y = l4, this._opt.preventDefaultMouseMove && b2(e2.event), rPe(this, "pan", "moveOnMouseMove", e2, { dx: p4, dy: g4, oldX: c4, oldY: h, newX: o, newY: l4, isAvailableBehavior: null });
      }
    }, n2.prototype._mouseupHandler = function(e2) {
      zxe(e2) || (this._dragging = false);
    }, n2.prototype._mousewheelHandler = function(e2) {
      var o = uH("zoomOnMouseWheel", e2, this._opt), l4 = uH("moveOnMouseWheel", e2, this._opt), c4 = e2.wheelDelta, h = Math.abs(c4), p4 = e2.offsetX, g4 = e2.offsetY;
      if (!(c4 === 0 || !o && !l4)) {
        if (o) {
          var y4 = h > 3 ? 1.4 : h > 1 ? 1.2 : 1.1, _ = c4 > 0 ? y4 : 1 / y4;
          cae(this, "zoom", "zoomOnMouseWheel", e2, { scale: _, originX: p4, originY: g4, isAvailableBehavior: null });
        }
        if (l4) {
          var w4 = Math.abs(c4), C = (c4 > 0 ? 1 : -1) * (w4 > 3 ? 0.4 : w4 > 1 ? 0.15 : 0.05);
          cae(this, "scrollMove", "moveOnMouseWheel", e2, { scrollDelta: C, originX: p4, originY: g4, isAvailableBehavior: null });
        }
      }
    }, n2.prototype._pinchHandler = function(e2) {
      if (!hCe(this._zr, "globalPan")) {
        var o = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
        cae(this, "zoom", null, e2, { scale: o, originX: e2.pinchX, originY: e2.pinchY, isAvailableBehavior: null });
      }
    }, n2;
  }(zy);
  function cae(i, n2, e2, o, l4) {
    i.pointerChecker && i.pointerChecker(o, l4.originX, l4.originY) && (b2(o.event), rPe(i, n2, e2, o, l4));
  }
  function rPe(i, n2, e2, o, l4) {
    l4.isAvailableBehavior = Ia(uH, null, e2, o), i.trigger(n2, l4);
  }
  function uH(i, n2, e2) {
    var o = e2[i];
    return !i || o && (!xa(o) || n2.event[o + "Key"]);
  }
  var t9 = y0t;
  function zle(i, n2, e2) {
    var o = i.target;
    o.x += n2, o.y += e2, o.dirty();
  }
  function Ble(i, n2, e2, o) {
    var l4 = i.target, c4 = i.zoomLimit, h = i.zoom = i.zoom || 1;
    if (h *= n2, c4) {
      var p4 = c4.min || 0, g4 = c4.max || 1 / 0;
      h = Math.max(Math.min(g4, h), p4);
    }
    var y4 = h / i.zoom;
    i.zoom = h, l4.x -= (e2 - l4.x) * (y4 - 1), l4.y -= (o - l4.y) * (y4 - 1), l4.scaleX *= y4, l4.scaleY *= y4, l4.dirty();
  }
  var b0t = { axisPointer: 1, tooltip: 1, brush: 1 };
  function Y$(i, n2, e2) {
    var o = n2.getComponentByElement(i.topTarget), l4 = o && o.coordinateSystem;
    return o && o !== e2 && !b0t.hasOwnProperty(o.mainType) && l4 && l4.model !== e2;
  }
  function aPe(i) {
    if (xa(i)) {
      var n2 = new DOMParser();
      i = n2.parseFromString(i, "text/xml");
    }
    var e2 = i;
    for (e2.nodeType === 9 && (e2 = e2.firstChild); e2.nodeName.toLowerCase() !== "svg" || e2.nodeType !== 1; )
      e2 = e2.nextSibling;
    return e2;
  }
  var fae, qH = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, dCe = ts(qH), YH = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, pCe = ts(YH), _0t = function() {
    function i() {
      this._defs = {}, this._root = null;
    }
    return i.prototype.parse = function(n2, e2) {
      e2 = e2 || {};
      var o = aPe(n2);
      this._defsUsePending = [];
      var l4 = new Ti();
      this._root = l4;
      var c4 = [], h = o.getAttribute("viewBox") || "", p4 = parseFloat(o.getAttribute("width") || e2.width), g4 = parseFloat(o.getAttribute("height") || e2.height);
      isNaN(p4) && (p4 = null), isNaN(g4) && (g4 = null), Z0(o, l4, null, true, false);
      for (var y4 = o.firstChild; y4; )
        this._parseNode(y4, l4, c4, null, false, false), y4 = y4.nextSibling;
      S0t(this._defs, this._defsUsePending), this._defsUsePending = [];
      var _, w4;
      if (h) {
        var C = Z$(h);
        C.length >= 4 && (_ = { x: parseFloat(C[0] || 0), y: parseFloat(C[1] || 0), width: parseFloat(C[2]), height: parseFloat(C[3]) });
      }
      if (_ && p4 != null && g4 != null && (w4 = oPe(_, { x: 0, y: 0, width: p4, height: g4 }), !e2.ignoreViewBox)) {
        var E = l4;
        l4 = new Ti(), l4.add(E), E.scaleX = E.scaleY = w4.scale, E.x = w4.x, E.y = w4.y;
      }
      return !e2.ignoreRootClip && p4 != null && g4 != null && l4.setClipPath(new Is({ shape: { x: 0, y: 0, width: p4, height: g4 } })), { root: l4, width: p4, height: g4, viewBoxRect: _, viewBoxTransform: w4, named: c4 };
    }, i.prototype._parseNode = function(n2, e2, o, l4, c4, h) {
      var p4 = n2.nodeName.toLowerCase(), g4, y4 = l4;
      if (p4 === "defs" && (c4 = true), p4 === "text" && (h = true), p4 === "defs" || p4 === "switch")
        g4 = e2;
      else {
        if (!c4) {
          var _ = fae[p4];
          if (_ && Na(fae, p4)) {
            g4 = _.call(this, n2, e2);
            var w4 = n2.getAttribute("name");
            if (w4) {
              var C = { name: w4, namedFrom: null, svgNodeTagLower: p4, el: g4 };
              o.push(C), p4 === "g" && (y4 = C);
            } else
              l4 && o.push({ name: l4.name, namedFrom: l4, svgNodeTagLower: p4, el: g4 });
            e2.add(g4);
          }
        }
        var E = vCe[p4];
        if (E && Na(vCe, p4)) {
          var T = E.call(this, n2), O = n2.getAttribute("id");
          O && (this._defs[O] = T);
        }
      }
      if (g4 && g4.isGroup)
        for (var N = n2.firstChild; N; )
          N.nodeType === 1 ? this._parseNode(N, g4, o, y4, c4, h) : N.nodeType === 3 && h && this._parseText(N, g4), N = N.nextSibling;
    }, i.prototype._parseText = function(n2, e2) {
      var o = new u8({ style: { text: n2.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
      _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), x0t(o, e2);
      var l4 = o.style, c4 = l4.fontSize;
      c4 && c4 < 9 && (l4.fontSize = 9, o.scaleX *= c4 / 9, o.scaleY *= c4 / 9);
      var h = (l4.fontSize || l4.fontFamily) && [l4.fontStyle, l4.fontWeight, (l4.fontSize || 12) + "px", l4.fontFamily || "sans-serif"].join(" ");
      l4.font = h;
      var p4 = o.getBoundingRect();
      return this._textX += p4.width, e2.add(o), o;
    }, i.internalField = function() {
      fae = { g: function(n2, e2) {
        var o = new Ti();
        return _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), o;
      }, rect: function(n2, e2) {
        var o = new Is();
        return _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), o.setShape({ x: parseFloat(n2.getAttribute("x") || "0"), y: parseFloat(n2.getAttribute("y") || "0"), width: parseFloat(n2.getAttribute("width") || "0"), height: parseFloat(n2.getAttribute("height") || "0") }), o.silent = true, o;
      }, circle: function(n2, e2) {
        var o = new J_();
        return _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), o.setShape({ cx: parseFloat(n2.getAttribute("cx") || "0"), cy: parseFloat(n2.getAttribute("cy") || "0"), r: parseFloat(n2.getAttribute("r") || "0") }), o.silent = true, o;
      }, line: function(n2, e2) {
        var o = new Vd();
        return _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), o.setShape({ x1: parseFloat(n2.getAttribute("x1") || "0"), y1: parseFloat(n2.getAttribute("y1") || "0"), x2: parseFloat(n2.getAttribute("x2") || "0"), y2: parseFloat(n2.getAttribute("y2") || "0") }), o.silent = true, o;
      }, ellipse: function(n2, e2) {
        var o = new Zse();
        return _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), o.setShape({ cx: parseFloat(n2.getAttribute("cx") || "0"), cy: parseFloat(n2.getAttribute("cy") || "0"), rx: parseFloat(n2.getAttribute("rx") || "0"), ry: parseFloat(n2.getAttribute("ry") || "0") }), o.silent = true, o;
      }, polygon: function(n2, e2) {
        var o = n2.getAttribute("points"), l4;
        o && (l4 = yCe(o));
        var c4 = new $g({ shape: { points: l4 || [] }, silent: true });
        return _y(e2, c4), Z0(n2, c4, this._defsUsePending, false, false), c4;
      }, polyline: function(n2, e2) {
        var o = n2.getAttribute("points"), l4;
        o && (l4 = yCe(o));
        var c4 = new Ug({ shape: { points: l4 || [] }, silent: true });
        return _y(e2, c4), Z0(n2, c4, this._defsUsePending, false, false), c4;
      }, image: function(n2, e2) {
        var o = new Ap();
        return _y(e2, o), Z0(n2, o, this._defsUsePending, false, false), o.setStyle({ image: n2.getAttribute("xlink:href") || n2.getAttribute("href"), x: +n2.getAttribute("x"), y: +n2.getAttribute("y"), width: +n2.getAttribute("width"), height: +n2.getAttribute("height") }), o.silent = true, o;
      }, text: function(n2, e2) {
        var o = n2.getAttribute("x") || "0", l4 = n2.getAttribute("y") || "0", c4 = n2.getAttribute("dx") || "0", h = n2.getAttribute("dy") || "0";
        this._textX = parseFloat(o) + parseFloat(c4), this._textY = parseFloat(l4) + parseFloat(h);
        var p4 = new Ti();
        return _y(e2, p4), Z0(n2, p4, this._defsUsePending, false, true), p4;
      }, tspan: function(n2, e2) {
        var o = n2.getAttribute("x"), l4 = n2.getAttribute("y");
        o != null && (this._textX = parseFloat(o)), l4 != null && (this._textY = parseFloat(l4));
        var c4 = n2.getAttribute("dx") || "0", h = n2.getAttribute("dy") || "0", p4 = new Ti();
        return _y(e2, p4), Z0(n2, p4, this._defsUsePending, false, true), this._textX += parseFloat(c4), this._textY += parseFloat(h), p4;
      }, path: function(n2, e2) {
        var o = n2.getAttribute("d") || "", l4 = FTe(o);
        return _y(e2, l4), Z0(n2, l4, this._defsUsePending, false, false), l4.silent = true, l4;
      } };
    }(), i;
  }(), vCe = { lineargradient: function(i) {
    var n2 = parseInt(i.getAttribute("x1") || "0", 10), e2 = parseInt(i.getAttribute("y1") || "0", 10), o = parseInt(i.getAttribute("x2") || "10", 10), l4 = parseInt(i.getAttribute("y2") || "0", 10), c4 = new B8(n2, e2, o, l4);
    return gCe(i, c4), mCe(i, c4), c4;
  }, radialgradient: function(i) {
    var n2 = parseInt(i.getAttribute("cx") || "0", 10), e2 = parseInt(i.getAttribute("cy") || "0", 10), o = parseInt(i.getAttribute("r") || "0", 10), l4 = new ZTe(n2, e2, o);
    return gCe(i, l4), mCe(i, l4), l4;
  } };
  function gCe(i, n2) {
    var e2 = i.getAttribute("gradientUnits");
    e2 === "userSpaceOnUse" && (n2.global = true);
  }
  function mCe(i, n2) {
    for (var e2 = i.firstChild; e2; ) {
      if (e2.nodeType === 1 && e2.nodeName.toLocaleLowerCase() === "stop") {
        var o = e2.getAttribute("offset"), l4 = void 0;
        o && o.indexOf("%") > 0 ? l4 = parseInt(o, 10) / 100 : o ? l4 = parseFloat(o) : l4 = 0;
        var c4 = {};
        iPe(e2, c4, c4);
        var h = c4.stopColor || e2.getAttribute("stop-color") || "#000000";
        n2.colorStops.push({ offset: l4, color: h });
      }
      e2 = e2.nextSibling;
    }
  }
  function _y(i, n2) {
    i && i.__inheritedStyle && (n2.__inheritedStyle || (n2.__inheritedStyle = {}), hi(n2.__inheritedStyle, i.__inheritedStyle));
  }
  function yCe(i) {
    for (var n2 = Z$(i), e2 = [], o = 0; o < n2.length; o += 2) {
      var l4 = parseFloat(n2[o]), c4 = parseFloat(n2[o + 1]);
      e2.push([l4, c4]);
    }
    return e2;
  }
  function Z0(i, n2, e2, o, l4) {
    var c4 = n2, h = c4.__inheritedStyle = c4.__inheritedStyle || {}, p4 = {};
    i.nodeType === 1 && (A0t(i, n2), iPe(i, h, p4), o || E0t(i, h, p4)), c4.style = c4.style || {}, h.fill != null && (c4.style.fill = bCe(c4, "fill", h.fill, e2)), h.stroke != null && (c4.style.stroke = bCe(c4, "stroke", h.stroke, e2)), Ve(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(g4) {
      h[g4] != null && (c4.style[g4] = parseFloat(h[g4]));
    }), Ve(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(g4) {
      h[g4] != null && (c4.style[g4] = h[g4]);
    }), l4 && (c4.__selfStyle = p4), h.lineDash && (c4.style.lineDash = Er(Z$(h.lineDash), function(g4) {
      return parseFloat(g4);
    })), (h.visibility === "hidden" || h.visibility === "collapse") && (c4.invisible = true), h.display === "none" && (c4.ignore = true);
  }
  function x0t(i, n2) {
    var e2 = n2.__selfStyle;
    if (e2) {
      var o = e2.textBaseline, l4 = o;
      !o || o === "auto" || o === "baseline" ? l4 = "alphabetic" : o === "before-edge" || o === "text-before-edge" ? l4 = "top" : o === "after-edge" || o === "text-after-edge" ? l4 = "bottom" : (o === "central" || o === "mathematical") && (l4 = "middle"), i.style.textBaseline = l4;
    }
    var c4 = n2.__inheritedStyle;
    if (c4) {
      var h = c4.textAlign, p4 = h;
      h && (h === "middle" && (p4 = "center"), i.style.textAlign = p4);
    }
  }
  var w0t = /^url\(\s*#(.*?)\)/;
  function bCe(i, n2, e2, o) {
    var l4 = e2 && e2.match(w0t);
    if (l4) {
      var c4 = tb(l4[1]);
      o.push([i, n2, c4]);
      return;
    }
    return e2 === "none" && (e2 = null), e2;
  }
  function S0t(i, n2) {
    for (var e2 = 0; e2 < n2.length; e2++) {
      var o = n2[e2];
      o[0].style[o[1]] = i[o[2]];
    }
  }
  var C0t = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function Z$(i) {
    return i.match(C0t) || [];
  }
  var M0t = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, hae = Math.PI / 180;
  function A0t(i, n2) {
    var e2 = i.getAttribute("transform");
    if (e2) {
      e2 = e2.replace(/,/g, " ");
      var o = [], l4 = null;
      e2.replace(M0t, function(w4, C, E) {
        return o.push(C, E), "";
      });
      for (var c4 = o.length - 1; c4 > 0; c4 -= 2) {
        var h = o[c4], p4 = o[c4 - 1], g4 = Z$(h);
        switch (l4 = l4 || Ny(), p4) {
          case "translate":
            Y_(l4, l4, [parseFloat(g4[0]), parseFloat(g4[1] || "0")]);
            break;
          case "scale":
            Nse(l4, l4, [parseFloat(g4[0]), parseFloat(g4[1] || g4[0])]);
            break;
          case "rotate":
            MT(l4, l4, -parseFloat(g4[0]) * hae);
            break;
          case "skewX":
            var y4 = Math.tan(parseFloat(g4[0]) * hae);
            p2(l4, [1, 0, y4, 1, 0, 0], l4);
            break;
          case "skewY":
            var _ = Math.tan(parseFloat(g4[0]) * hae);
            p2(l4, [1, _, 0, 1, 0, 0], l4);
            break;
          case "matrix":
            l4[0] = parseFloat(g4[0]), l4[1] = parseFloat(g4[1]), l4[2] = parseFloat(g4[2]), l4[3] = parseFloat(g4[3]), l4[4] = parseFloat(g4[4]), l4[5] = parseFloat(g4[5]);
            break;
        }
      }
      n2.setLocalTransform(l4);
    }
  }
  var _Ce = /([^\s:;]+)\s*:\s*([^:;]+)/g;
  function iPe(i, n2, e2) {
    var o = i.getAttribute("style");
    if (!!o) {
      _Ce.lastIndex = 0;
      for (var l4; (l4 = _Ce.exec(o)) != null; ) {
        var c4 = l4[1], h = Na(qH, c4) ? qH[c4] : null;
        h && (n2[h] = l4[2]);
        var p4 = Na(YH, c4) ? YH[c4] : null;
        p4 && (e2[p4] = l4[2]);
      }
    }
  }
  function E0t(i, n2, e2) {
    for (var o = 0; o < dCe.length; o++) {
      var l4 = dCe[o], c4 = i.getAttribute(l4);
      c4 != null && (n2[qH[l4]] = c4);
    }
    for (var o = 0; o < pCe.length; o++) {
      var l4 = pCe[o], c4 = i.getAttribute(l4);
      c4 != null && (e2[YH[l4]] = c4);
    }
  }
  function oPe(i, n2) {
    var e2 = n2.width / i.width, o = n2.height / i.height, l4 = Math.min(e2, o);
    return { scale: l4, x: -(i.x + i.width / 2) * l4 + (n2.x + n2.width / 2), y: -(i.y + i.height / 2) * l4 + (n2.y + n2.height / 2) };
  }
  function I0t(i, n2) {
    var e2 = new _0t();
    return e2.parse(i, n2);
  }
  var T0t = ri(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), D0t = function() {
    function i(n2, e2) {
      this.type = "geoSVG", this._usedGraphicMap = ri(), this._freedGraphics = [], this._mapName = n2, this._parsedXML = aPe(e2);
    }
    return i.prototype.load = function() {
      var n2 = this._firstGraphic;
      if (!n2) {
        n2 = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(n2), this._boundingRect = this._firstGraphic.boundingRect.clone();
        var e2 = P0t(n2.named), o = e2.regions, l4 = e2.regionsMap;
        this._regions = o, this._regionsMap = l4;
      }
      return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
    }, i.prototype._buildGraphic = function(n2) {
      var e2, o;
      try {
        e2 = n2 && I0t(n2, { ignoreViewBox: true, ignoreRootClip: true }) || {}, o = e2.root, Kv(o != null);
      } catch (N) {
        throw new Error(`Invalid svg format
` + N.message);
      }
      var l4 = new Ti();
      l4.add(o), l4.isGeoSVGGraphicRoot = true;
      var c4 = e2.width, h = e2.height, p4 = e2.viewBoxRect, g4 = this._boundingRect;
      if (!g4) {
        var y4 = void 0, _ = void 0, w4 = void 0, C = void 0;
        if (c4 != null ? (y4 = 0, w4 = c4) : p4 && (y4 = p4.x, w4 = p4.width), h != null ? (_ = 0, C = h) : p4 && (_ = p4.y, C = p4.height), y4 == null || _ == null) {
          var E = o.getBoundingRect();
          y4 == null && (y4 = E.x, w4 = E.width), _ == null && (_ = E.y, C = E.height);
        }
        g4 = this._boundingRect = new mo(y4, _, w4, C);
      }
      if (p4) {
        var T = oPe(p4, g4);
        o.scaleX = o.scaleY = T.scale, o.x = T.x, o.y = T.y;
      }
      l4.setClipPath(new Is({ shape: g4.plain() }));
      var O = [];
      return Ve(e2.named, function(N) {
        T0t.get(N.svgNodeTagLower) != null && (O.push(N), k0t(N.el));
      }), { root: l4, boundingRect: g4, named: O };
    }, i.prototype.useGraphic = function(n2) {
      var e2 = this._usedGraphicMap, o = e2.get(n2);
      return o || (o = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), e2.set(n2, o), o);
    }, i.prototype.freeGraphic = function(n2) {
      var e2 = this._usedGraphicMap, o = e2.get(n2);
      o && (e2.removeKey(n2), this._freedGraphics.push(o));
    }, i;
  }();
  function k0t(i) {
    i.silent = false, i.isGroup && i.traverse(function(n2) {
      n2.silent = false;
    });
  }
  function P0t(i) {
    var n2 = [], e2 = ri();
    return Ve(i, function(o) {
      if (o.namedFrom == null) {
        var l4 = new Xdt(o.name, o.el);
        n2.push(l4), e2.set(o.name, l4);
      }
    }), { regions: n2, regionsMap: e2 };
  }
  var Doe = [126, 25], xCe = "\u5357\u6D77\u8BF8\u5C9B", UI = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
  for (var GI = 0; GI < UI.length; GI++)
    for (var n3 = 0; n3 < UI[GI].length; n3++)
      UI[GI][n3][0] /= 10.5, UI[GI][n3][1] /= -10.5 / 0.75, UI[GI][n3][0] += Doe[0], UI[GI][n3][1] += Doe[1];
  function L0t(i, n2) {
    if (i === "china") {
      for (var e2 = 0; e2 < n2.length; e2++)
        if (n2[e2].name === xCe)
          return;
      n2.push(new oke(xCe, Er(UI, function(o) {
        return { type: "polygon", exterior: o };
      }), Doe));
    }
  }
  var O0t = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
  function R0t(i, n2) {
    if (i === "china") {
      var e2 = O0t[n2.name];
      if (e2) {
        var o = n2.getCenter();
        o[0] += e2[0] / 10.5, o[1] += -e2[1] / (10.5 / 0.75), n2.setCenter(o);
      }
    }
  }
  var F0t = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
  function N0t(i, n2) {
    i === "china" && n2.name === "\u53F0\u6E7E" && n2.geometries.push({ type: "polygon", exterior: F0t[0] });
  }
  var V0t = "name", z0t = function() {
    function i(n2, e2, o) {
      this.type = "geoJSON", this._parsedMap = ri(), this._mapName = n2, this._specialAreas = o, this._geoJSON = j0t(e2);
    }
    return i.prototype.load = function(n2, e2) {
      e2 = e2 || V0t;
      var o = this._parsedMap.get(e2);
      if (!o) {
        var l4 = this._parseToRegions(e2);
        o = this._parsedMap.set(e2, { regions: l4, boundingRect: B0t(l4) });
      }
      var c4 = ri(), h = [];
      return Ve(o.regions, function(p4) {
        var g4 = p4.name;
        n2 && Na(n2, g4) && (p4 = p4.cloneShallow(g4 = n2[g4])), h.push(p4), c4.set(g4, p4);
      }), { regions: h, boundingRect: o.boundingRect || new mo(0, 0, 0, 0), regionsMap: c4 };
    }, i.prototype._parseToRegions = function(n2) {
      var e2 = this._mapName, o = this._geoJSON, l4;
      try {
        l4 = o ? Jdt(o, n2) : [];
      } catch (c4) {
        throw new Error(`Invalid geoJson format
` + c4.message);
      }
      return L0t(e2, l4), Ve(l4, function(c4) {
        var h = c4.name;
        R0t(e2, c4), N0t(e2, c4);
        var p4 = this._specialAreas && this._specialAreas[h];
        p4 && c4.transformTo(p4.left, p4.top, p4.width, p4.height);
      }, this), l4;
    }, i.prototype.getMapForUser = function() {
      return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
    }, i;
  }();
  function B0t(i) {
    for (var n2, e2 = 0; e2 < i.length; e2++) {
      var o = i[e2].getBoundingRect();
      n2 = n2 || o.clone(), n2.union(o);
    }
    return n2;
  }
  function j0t(i) {
    return xa(i) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(i) : new Function("return (" + i + ");")() : i;
  }
  var pN = ri(), S2 = { registerMap: function(i, n2, e2) {
    if (n2.svg) {
      var o = new D0t(i, n2.svg);
      pN.set(i, o);
    } else {
      var l4 = n2.geoJson || n2.geoJSON;
      l4 && !n2.features ? e2 = n2.specialAreas : l4 = n2;
      var o = new z0t(i, l4, e2);
      pN.set(i, o);
    }
  }, getGeoResource: function(i) {
    return pN.get(i);
  }, getMapForUser: function(i) {
    var n2 = pN.get(i);
    return n2 && n2.type === "geoJSON" && n2.getMapForUser();
  }, load: function(i, n2, e2) {
    var o = pN.get(i);
    if (!!o)
      return o.load(n2, e2);
  } }, jle = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], G0t = ri(jle), W0t = ri(jle.concat(["g"])), H0t = ri(jle.concat(["g"])), sPe = zs();
  function AW(i) {
    var n2 = i.getItemStyle(), e2 = i.get("areaColor");
    return e2 != null && (n2.fill = e2), n2;
  }
  function wCe(i) {
    var n2 = i.style;
    n2 && (n2.stroke = n2.stroke || n2.fill, n2.fill = null);
  }
  var $0t = function() {
    function i(n2) {
      var e2 = new Ti();
      this.uid = Z3("ec_map_draw"), this._controller = new t9(n2.getZr()), this._controllerHost = { target: e2 }, this.group = e2, e2.add(this._regionsGroup = new Ti()), e2.add(this._svgGroup = new Ti());
    }
    return i.prototype.draw = function(n2, e2, o, l4, c4) {
      var h = n2.mainType === "geo", p4 = n2.getData && n2.getData();
      h && e2.eachComponent({ mainType: "series", subType: "map" }, function(V) {
        !p4 && V.getHostGeoModel() === n2 && (p4 = V.getData());
      });
      var g4 = n2.coordinateSystem, y4 = this._regionsGroup, _ = this.group, w4 = g4.getTransformInfo(), C = w4.raw, E = w4.roam, T = !y4.childAt(0) || c4;
      T ? (_.x = E.x, _.y = E.y, _.scaleX = E.scaleX, _.scaleY = E.scaleY, _.dirty()) : Vs(_, E, n2);
      var O = p4 && p4.getVisual("visualMeta") && p4.getVisual("visualMeta").length > 0, N = { api: o, geo: g4, mapOrGeoModel: n2, data: p4, isVisualEncodedByVisualMap: O, isGeo: h, transformInfoRaw: C };
      g4.resourceType === "geoJSON" ? this._buildGeoJSON(N) : g4.resourceType === "geoSVG" && this._buildSVG(N), this._updateController(n2, e2, o), this._updateMapSelectHandler(n2, y4, o, l4);
    }, i.prototype._buildGeoJSON = function(n2) {
      var e2 = this._regionsGroupByName = ri(), o = ri(), l4 = this._regionsGroup, c4 = n2.transformInfoRaw, h = n2.mapOrGeoModel, p4 = n2.data, g4 = n2.geo.projection, y4 = g4 && g4.stream;
      function _(E, T) {
        return T && (E = T(E)), E && [E[0] * c4.scaleX + c4.x, E[1] * c4.scaleY + c4.y];
      }
      function w4(E) {
        for (var T = [], O = !y4 && g4 && g4.project, N = 0; N < E.length; ++N) {
          var V = _(E[N], O);
          V && T.push(V);
        }
        return T;
      }
      function C(E) {
        return { shape: { points: w4(E) } };
      }
      l4.removeAll(), Ve(n2.geo.regions, function(E) {
        var T = E.name, O = e2.get(T), N = o.get(T) || {}, V = N.dataIdx, H = N.regionModel;
        O || (O = e2.set(T, new Ti()), l4.add(O), V = p4 ? p4.indexOfName(T) : null, H = n2.isGeo ? h.getRegionModel(T) : p4 ? p4.getItemModel(V) : null, o.set(T, { dataIdx: V, regionModel: H }));
        var X = [], q2 = [];
        Ve(E.geometries, function(me) {
          if (me.type === "polygon") {
            var ye = [me.exterior].concat(me.interiors || []);
            y4 && (ye = ICe(ye, y4)), Ve(ye, function(we) {
              X.push(new $g(C(we)));
            });
          } else {
            var be = me.points;
            y4 && (be = ICe(be, y4, true)), Ve(be, function(we) {
              q2.push(new Ug(C(we)));
            });
          }
        });
        var de = _(E.getCenter(), g4 && g4.project);
        function le(me, ye) {
          if (!!me.length) {
            var be = new Kse({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: me } });
            O.add(be), SCe(n2, be, V, H), CCe(n2, be, T, H, h, V, de), ye && (wCe(be), Ve(be.states, wCe));
          }
        }
        le(X), le(q2, true);
      }), e2.each(function(E, T) {
        var O = o.get(T), N = O.dataIdx, V = O.regionModel;
        MCe(n2, E, T, V, h, N), ACe(n2, E, T, V, h), ECe(n2, E, T, V, h);
      }, this);
    }, i.prototype._buildSVG = function(n2) {
      var e2 = n2.geo.map, o = n2.transformInfoRaw;
      this._svgGroup.x = o.x, this._svgGroup.y = o.y, this._svgGroup.scaleX = o.scaleX, this._svgGroup.scaleY = o.scaleY, this._svgResourceChanged(e2) && (this._freeSVG(), this._useSVG(e2));
      var l4 = this._svgDispatcherMap = ri(), c4 = false;
      Ve(this._svgGraphicRecord.named, function(h) {
        var p4 = h.name, g4 = n2.mapOrGeoModel, y4 = n2.data, _ = h.svgNodeTagLower, w4 = h.el, C = y4 ? y4.indexOfName(p4) : null, E = g4.getRegionModel(p4);
        if (G0t.get(_) != null && w4 instanceof Vy && SCe(n2, w4, C, E), w4 instanceof Vy && (w4.culling = true), w4.z2EmphasisLift = 0, !h.namedFrom && (H0t.get(_) != null && CCe(n2, w4, p4, E, g4, C, null), MCe(n2, w4, p4, E, g4, C), ACe(n2, w4, p4, E, g4), W0t.get(_) != null)) {
          var T = ECe(n2, w4, p4, E, g4);
          T === "self" && (c4 = true);
          var O = l4.get(p4) || l4.set(p4, []);
          O.push(w4);
        }
      }, this), this._enableBlurEntireSVG(c4, n2);
    }, i.prototype._enableBlurEntireSVG = function(n2, e2) {
      if (n2 && e2.isGeo) {
        var o = e2.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), l4 = o.opacity;
        this._svgGraphicRecord.root.traverse(function(c4) {
          if (!c4.isGroup) {
            _T(c4);
            var h = c4.ensureState("blur").style || {};
            h.opacity == null && l4 != null && (h.opacity = l4), c4.ensureState("emphasis");
          }
        });
      }
    }, i.prototype.remove = function() {
      this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
    }, i.prototype.findHighDownDispatchers = function(n2, e2) {
      if (n2 == null)
        return [];
      var o = e2.coordinateSystem;
      if (o.resourceType === "geoJSON") {
        var l4 = this._regionsGroupByName;
        if (l4) {
          var c4 = l4.get(n2);
          return c4 ? [c4] : [];
        }
      } else if (o.resourceType === "geoSVG")
        return this._svgDispatcherMap && this._svgDispatcherMap.get(n2) || [];
    }, i.prototype._svgResourceChanged = function(n2) {
      return this._svgMapName !== n2;
    }, i.prototype._useSVG = function(n2) {
      var e2 = S2.getGeoResource(n2);
      if (e2 && e2.type === "geoSVG") {
        var o = e2.useGraphic(this.uid);
        this._svgGroup.add(o.root), this._svgGraphicRecord = o, this._svgMapName = n2;
      }
    }, i.prototype._freeSVG = function() {
      var n2 = this._svgMapName;
      if (n2 != null) {
        var e2 = S2.getGeoResource(n2);
        e2 && e2.type === "geoSVG" && e2.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
      }
    }, i.prototype._updateController = function(n2, e2, o) {
      var l4 = n2.coordinateSystem, c4 = this._controller, h = this._controllerHost;
      h.zoomLimit = n2.get("scaleLimit"), h.zoom = l4.getZoom(), c4.enable(n2.get("roam") || false);
      var p4 = n2.mainType;
      function g4() {
        var y4 = { type: "geoRoam", componentType: p4 };
        return y4[p4 + "Id"] = n2.id, y4;
      }
      c4.off("pan").on("pan", function(y4) {
        this._mouseDownFlag = false, zle(h, y4.dx, y4.dy), o.dispatchAction(rr(g4(), { dx: y4.dx, dy: y4.dy, animation: { duration: 0 } }));
      }, this), c4.off("zoom").on("zoom", function(y4) {
        this._mouseDownFlag = false, Ble(h, y4.scale, y4.originX, y4.originY), o.dispatchAction(rr(g4(), { zoom: y4.scale, originX: y4.originX, originY: y4.originY, animation: { duration: 0 } }));
      }, this), c4.setPointerChecker(function(y4, _, w4) {
        return l4.containPoint([_, w4]) && !Y$(y4, o, n2);
      });
    }, i.prototype.resetForLabelLayout = function() {
      this.group.traverse(function(n2) {
        var e2 = n2.getTextContent();
        e2 && (e2.ignore = sPe(e2).ignore);
      });
    }, i.prototype._updateMapSelectHandler = function(n2, e2, o, l4) {
      var c4 = this;
      e2.off("mousedown"), e2.off("click"), n2.get("selectedMode") && (e2.on("mousedown", function() {
        c4._mouseDownFlag = true;
      }), e2.on("click", function(h) {
        !c4._mouseDownFlag || (c4._mouseDownFlag = false);
      }));
    }, i;
  }();
  function SCe(i, n2, e2, o) {
    var l4 = o.getModel("itemStyle"), c4 = o.getModel(["emphasis", "itemStyle"]), h = o.getModel(["blur", "itemStyle"]), p4 = o.getModel(["select", "itemStyle"]), g4 = AW(l4), y4 = AW(c4), _ = AW(p4), w4 = AW(h), C = i.data;
    if (C) {
      var E = C.getItemVisual(e2, "style"), T = C.getItemVisual(e2, "decal");
      i.isVisualEncodedByVisualMap && E.fill && (g4.fill = E.fill), T && (g4.decal = _8(T, i.api));
    }
    n2.setStyle(g4), n2.style.strokeNoScale = true, n2.ensureState("emphasis").style = y4, n2.ensureState("select").style = _, n2.ensureState("blur").style = w4, _T(n2);
  }
  function CCe(i, n2, e2, o, l4, c4, h) {
    var p4 = i.data, g4 = i.isGeo, y4 = p4 && isNaN(p4.get(p4.mapDimension("value"), c4)), _ = p4 && p4.getItemLayout(c4);
    if (g4 || y4 || _ && _.showLabel) {
      var w4 = g4 ? e2 : c4, C = void 0;
      (!p4 || c4 >= 0) && (C = l4);
      var E = h ? { normal: { align: "center", verticalAlign: "middle" } } : null;
      yv(n2, zd(o), { labelFetcher: C, labelDataIndex: w4, defaultText: e2 }, E);
      var T = n2.getTextContent();
      if (T && (sPe(T).ignore = T.ignore, n2.textConfig && h)) {
        var O = n2.getBoundingRect().clone();
        n2.textConfig.layoutRect = O, n2.textConfig.position = [(h[0] - O.x) / O.width * 100 + "%", (h[1] - O.y) / O.height * 100 + "%"];
      }
      n2.disableLabelAnimation = true;
    } else
      n2.removeTextContent(), n2.removeTextConfig(), n2.disableLabelAnimation = null;
  }
  function MCe(i, n2, e2, o, l4, c4) {
    i.data ? i.data.setItemGraphicEl(c4, n2) : Fi(n2).eventData = { componentType: "geo", componentIndex: l4.componentIndex, geoIndex: l4.componentIndex, name: e2, region: o && o.option || {} };
  }
  function ACe(i, n2, e2, o, l4) {
    i.data || q3({ el: n2, componentModel: l4, itemName: e2, itemTooltipOption: o.get("tooltip") });
  }
  function ECe(i, n2, e2, o, l4) {
    n2.highDownSilentOnTouch = !!l4.get("selectedMode");
    var c4 = o.getModel("emphasis"), h = c4.get("focus");
    return pf(n2, h, c4.get("blurScope"), c4.get("disabled")), i.isGeo && Wlt(n2, l4, e2), h;
  }
  function ICe(i, n2, e2) {
    var o = [], l4;
    function c4() {
      l4 = [];
    }
    function h() {
      l4.length && (o.push(l4), l4 = []);
    }
    var p4 = n2({ polygonStart: c4, polygonEnd: h, lineStart: c4, lineEnd: h, point: function(g4, y4) {
      isFinite(g4) && isFinite(y4) && l4.push([g4, y4]);
    }, sphere: function() {
    } });
    return !e2 && p4.polygonStart(), Ve(i, function(g4) {
      p4.lineStart();
      for (var y4 = 0; y4 < g4.length; y4++)
        p4.point(g4[y4][0], g4[y4][1]);
      p4.lineEnd();
    }), !e2 && p4.polygonEnd(), o;
  }
  var lPe = $0t, U0t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      if (!(c4 && c4.type === "mapToggleSelect" && c4.from === this.uid)) {
        var h = this.group;
        if (h.removeAll(), !e2.getHostGeoModel()) {
          if (this._mapDraw && c4 && c4.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), c4 && c4.type === "geoRoam" && c4.componentType === "series" && c4.seriesId === e2.id) {
            var p4 = this._mapDraw;
            p4 && h.add(p4.group);
          } else if (e2.needsDrawMap) {
            var p4 = this._mapDraw || new lPe(l4);
            h.add(p4.group), p4.draw(e2, o, l4, this, c4), this._mapDraw = p4;
          } else
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          e2.get("showLegendSymbol") && o.getComponent("legend") && this._renderSymbols(e2, o, l4);
        }
      }
    }, n2.prototype.remove = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
    }, n2.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
    }, n2.prototype._renderSymbols = function(e2, o, l4) {
      var c4 = e2.originalData, h = this.group;
      c4.each(c4.mapDimension("value"), function(p4, g4) {
        if (!isNaN(p4)) {
          var y4 = c4.getItemLayout(g4);
          if (!(!y4 || !y4.point)) {
            var _ = y4.point, w4 = y4.offset, C = new J_({ style: { fill: e2.getData().getVisual("style").fill }, shape: { cx: _[0] + w4 * 9, cy: _[1], r: 3 }, silent: true, z2: 8 + (w4 ? 0 : $3 + 1) });
            if (!w4) {
              var E = e2.mainSeries.getData(), T = c4.getName(g4), O = E.indexOfName(T), N = c4.getItemModel(g4), V = N.getModel("label"), H = E.getItemGraphicEl(O);
              yv(C, zd(N), { labelFetcher: { getFormattedLabel: function(X, q2) {
                return e2.getFormattedLabel(O, q2);
              } }, defaultText: T }), C.disableLabelAnimation = true, V.get("position") || C.setTextConfig({ position: "bottom" }), H.onHoverStateChange = function(X) {
                AH(C, X);
              };
            }
            h.add(C);
          }
        }
      });
    }, n2.type = "map", n2;
  }(Ru), q0t = U0t, Y0t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.needsDrawMap = false, e2.seriesGroup = [], e2.getTooltipPosition = function(o) {
        if (o != null) {
          var l4 = this.getData().getName(o), c4 = this.coordinateSystem, h = c4.getRegion(l4);
          return h && c4.dataToPoint(h.getCenter());
        }
      }, e2;
    }
    return n2.prototype.getInitialData = function(e2) {
      for (var o = rL(this, { coordDimensions: ["value"], encodeDefaulter: zi(ole, this) }), l4 = ri(), c4 = [], h = 0, p4 = o.count(); h < p4; h++) {
        var g4 = o.getName(h);
        l4.set(g4, true);
      }
      var y4 = S2.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
      return Ve(y4.regions, function(_) {
        var w4 = _.name;
        l4.get(w4) || c4.push(w4);
      }), o.appendValues([], c4), o;
    }, n2.prototype.getHostGeoModel = function() {
      var e2 = this.option.geoIndex;
      return e2 != null ? this.ecModel.getComponent("geo", e2) : null;
    }, n2.prototype.getMapType = function() {
      return (this.getHostGeoModel() || this).option.map;
    }, n2.prototype.getRawValue = function(e2) {
      var o = this.getData();
      return o.get(o.mapDimension("value"), e2);
    }, n2.prototype.getRegionModel = function(e2) {
      var o = this.getData();
      return o.getItemModel(o.indexOfName(e2));
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      for (var c4 = this.getData(), h = this.getRawValue(e2), p4 = c4.getName(e2), g4 = this.seriesGroup, y4 = [], _ = 0; _ < g4.length; _++) {
        var w4 = g4[_].originalData.indexOfName(p4), C = c4.mapDimension("value");
        isNaN(g4[_].originalData.get(C, w4)) || y4.push(g4[_].name);
      }
      return Qh("section", { header: y4.join(", "), noHeader: !y4.length, blocks: [Qh("nameValue", { name: p4, value: h })] });
    }, n2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, n2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, n2.prototype.getLegendIcon = function(e2) {
      var o = e2.icon || "roundRect", l4 = Xf(o, 0, 0, e2.itemWidth, e2.itemHeight, e2.itemStyle.fill);
      return l4.setStyle(e2.itemStyle), l4.style.stroke = "none", o.indexOf("empty") > -1 && (l4.style.stroke = l4.style.fill, l4.style.fill = "#fff", l4.style.lineWidth = 2), l4;
    }, n2.type = "series.map", n2.dependencies = ["geo"], n2.layoutMode = "box", n2.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, n2;
  }(_c2), Z0t = Y0t;
  function X0t(i, n2) {
    var e2 = {};
    return Ve(i, function(o) {
      o.each(o.mapDimension("value"), function(l4, c4) {
        var h = "ec-" + o.getName(c4);
        e2[h] = e2[h] || [], isNaN(l4) || e2[h].push(l4);
      });
    }), i[0].map(i[0].mapDimension("value"), function(o, l4) {
      for (var c4 = "ec-" + i[0].getName(l4), h = 0, p4 = 1 / 0, g4 = -1 / 0, y4 = e2[c4].length, _ = 0; _ < y4; _++)
        p4 = Math.min(p4, e2[c4][_]), g4 = Math.max(g4, e2[c4][_]), h += e2[c4][_];
      var w4;
      return n2 === "min" ? w4 = p4 : n2 === "max" ? w4 = g4 : n2 === "average" ? w4 = h / y4 : w4 = h, y4 === 0 ? NaN : w4;
    });
  }
  function K0t(i) {
    var n2 = {};
    i.eachSeriesByType("map", function(e2) {
      var o = e2.getHostGeoModel(), l4 = o ? "o" + o.id : "i" + e2.getMapType();
      (n2[l4] = n2[l4] || []).push(e2);
    }), Ve(n2, function(e2, o) {
      for (var l4 = X0t(Er(e2, function(h) {
        return h.getData();
      }), e2[0].get("mapValueCalculation")), c4 = 0; c4 < e2.length; c4++)
        e2[c4].originalData = e2[c4].getData();
      for (var c4 = 0; c4 < e2.length; c4++)
        e2[c4].seriesGroup = e2, e2[c4].needsDrawMap = c4 === 0 && !e2[c4].getHostGeoModel(), e2[c4].setData(l4.cloneShallow()), e2[c4].mainSeries = e2[0];
    });
  }
  function J0t(i) {
    var n2 = {};
    i.eachSeriesByType("map", function(e2) {
      var o = e2.getMapType();
      if (!(e2.getHostGeoModel() || n2[o])) {
        var l4 = {};
        Ve(e2.seriesGroup, function(h) {
          var p4 = h.coordinateSystem, g4 = h.originalData;
          h.get("showLegendSymbol") && i.getComponent("legend") && g4.each(g4.mapDimension("value"), function(y4, _) {
            var w4 = g4.getName(_), C = p4.getRegion(w4);
            if (!(!C || isNaN(y4))) {
              var E = l4[w4] || 0, T = p4.dataToPoint(C.getCenter());
              l4[w4] = E + 1, g4.setItemLayout(_, { point: T, offset: E });
            }
          });
        });
        var c4 = e2.getData();
        c4.each(function(h) {
          var p4 = c4.getName(h), g4 = c4.getItemLayout(h) || {};
          g4.showLabel = !l4[p4], c4.setItemLayout(h, g4);
        }), n2[o] = true;
      }
    });
  }
  var TCe = Sp, Q0t = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this) || this;
      return o.type = "view", o.dimensions = ["x", "y"], o._roamTransformable = new u2(), o._rawTransformable = new u2(), o.name = e2, o;
    }
    return n2.prototype.setBoundingRect = function(e2, o, l4, c4) {
      return this._rect = new mo(e2, o, l4, c4), this._rect;
    }, n2.prototype.getBoundingRect = function() {
      return this._rect;
    }, n2.prototype.setViewRect = function(e2, o, l4, c4) {
      this._transformTo(e2, o, l4, c4), this._viewRect = new mo(e2, o, l4, c4);
    }, n2.prototype._transformTo = function(e2, o, l4, c4) {
      var h = this.getBoundingRect(), p4 = this._rawTransformable;
      p4.transform = h.calculateTransform(new mo(e2, o, l4, c4));
      var g4 = p4.parent;
      p4.parent = null, p4.decomposeTransform(), p4.parent = g4, this._updateTransform();
    }, n2.prototype.setCenter = function(e2) {
      !e2 || (this._center = e2, this._updateCenterAndZoom());
    }, n2.prototype.setZoom = function(e2) {
      e2 = e2 || 1;
      var o = this.zoomLimit;
      o && (o.max != null && (e2 = Math.min(o.max, e2)), o.min != null && (e2 = Math.max(o.min, e2))), this._zoom = e2, this._updateCenterAndZoom();
    }, n2.prototype.getDefaultCenter = function() {
      var e2 = this.getBoundingRect(), o = e2.x + e2.width / 2, l4 = e2.y + e2.height / 2;
      return [o, l4];
    }, n2.prototype.getCenter = function() {
      return this._center || this.getDefaultCenter();
    }, n2.prototype.getZoom = function() {
      return this._zoom || 1;
    }, n2.prototype.getRoamTransform = function() {
      return this._roamTransformable.getLocalTransform();
    }, n2.prototype._updateCenterAndZoom = function() {
      var e2 = this._rawTransformable.getLocalTransform(), o = this._roamTransformable, l4 = this.getDefaultCenter(), c4 = this.getCenter(), h = this.getZoom();
      c4 = Sp([], c4, e2), l4 = Sp([], l4, e2), o.originX = c4[0], o.originY = c4[1], o.x = l4[0] - c4[0], o.y = l4[1] - c4[1], o.scaleX = o.scaleY = h, this._updateTransform();
    }, n2.prototype._updateTransform = function() {
      var e2 = this._roamTransformable, o = this._rawTransformable;
      o.parent = e2, e2.updateTransform(), o.updateTransform(), Fse(this.transform || (this.transform = []), o.transform || Ny()), this._rawTransform = o.getLocalTransform(), this.invTransform = this.invTransform || [], W3(this.invTransform, this.transform), this.decomposeTransform();
    }, n2.prototype.getTransformInfo = function() {
      var e2 = this._rawTransformable, o = this._roamTransformable, l4 = new u2();
      return l4.transform = o.transform, l4.decomposeTransform(), { roam: { x: l4.x, y: l4.y, scaleX: l4.scaleX, scaleY: l4.scaleY }, raw: { x: e2.x, y: e2.y, scaleX: e2.scaleX, scaleY: e2.scaleY } };
    }, n2.prototype.getViewRect = function() {
      return this._viewRect;
    }, n2.prototype.getViewRectAfterRoam = function() {
      var e2 = this.getBoundingRect().clone();
      return e2.applyTransform(this.transform), e2;
    }, n2.prototype.dataToPoint = function(e2, o, l4) {
      var c4 = o ? this._rawTransform : this.transform;
      return l4 = l4 || [], c4 ? TCe(l4, e2, c4) : qv(l4, e2);
    }, n2.prototype.pointToData = function(e2) {
      var o = this.invTransform;
      return o ? TCe([], e2, o) : [e2[0], e2[1]];
    }, n2.prototype.convertToPixel = function(e2, o, l4) {
      var c4 = DCe(o);
      return c4 === this ? c4.dataToPoint(l4) : null;
    }, n2.prototype.convertFromPixel = function(e2, o, l4) {
      var c4 = DCe(o);
      return c4 === this ? c4.pointToData(l4) : null;
    }, n2.prototype.containPoint = function(e2) {
      return this.getViewRectAfterRoam().contain(e2[0], e2[1]);
    }, n2.dimensions = ["x", "y"], n2;
  }(u2);
  function DCe(i) {
    var n2 = i.seriesModel;
    return n2 ? n2.coordinateSystem : null;
  }
  var n9 = Q0t, emt = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, uPe = ["lng", "lat"], cPe = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this, e2) || this;
      c4.dimensions = uPe, c4.type = "geo", c4._nameCoordMap = ri(), c4.map = o;
      var h = l4.projection, p4 = S2.load(o, l4.nameMap, l4.nameProperty), g4 = S2.getGeoResource(o);
      c4.resourceType = g4 ? g4.type : null;
      var y4 = c4.regions = p4.regions, _ = emt[g4.type];
      c4._regionsMap = p4.regionsMap, c4.regions = p4.regions, c4.projection = h;
      var w4;
      if (h)
        for (var C = 0; C < y4.length; C++) {
          var E = y4[C].getBoundingRect(h);
          w4 = w4 || E.clone(), w4.union(E);
        }
      else
        w4 = p4.boundingRect;
      return c4.setBoundingRect(w4.x, w4.y, w4.width, w4.height), c4.aspectScale = h ? 1 : so(l4.aspectScale, _.aspectScale), c4._invertLongitute = h ? false : _.invertLongitute, c4;
    }
    return n2.prototype._transformTo = function(e2, o, l4, c4) {
      var h = this.getBoundingRect(), p4 = this._invertLongitute;
      h = h.clone(), p4 && (h.y = -h.y - h.height);
      var g4 = this._rawTransformable;
      g4.transform = h.calculateTransform(new mo(e2, o, l4, c4));
      var y4 = g4.parent;
      g4.parent = null, g4.decomposeTransform(), g4.parent = y4, p4 && (g4.scaleY = -g4.scaleY), this._updateTransform();
    }, n2.prototype.getRegion = function(e2) {
      return this._regionsMap.get(e2);
    }, n2.prototype.getRegionByCoord = function(e2) {
      for (var o = this.regions, l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        if (c4.type === "geoJSON" && c4.contain(e2))
          return o[l4];
      }
    }, n2.prototype.addGeoCoord = function(e2, o) {
      this._nameCoordMap.set(e2, o);
    }, n2.prototype.getGeoCoord = function(e2) {
      var o = this._regionsMap.get(e2);
      return this._nameCoordMap.get(e2) || o && o.getCenter();
    }, n2.prototype.dataToPoint = function(e2, o, l4) {
      if (xa(e2) && (e2 = this.getGeoCoord(e2)), e2) {
        var c4 = this.projection;
        return c4 && (e2 = c4.project(e2)), e2 && this.projectedToPoint(e2);
      }
    }, n2.prototype.pointToData = function(e2) {
      var o = this.projection;
      return o && (e2 = o.unproject(e2)), e2 && this.pointToProjected(e2);
    }, n2.prototype.pointToProjected = function(e2) {
      return i.prototype.pointToData.call(this, e2);
    }, n2.prototype.projectedToPoint = function(e2, o, l4) {
      return i.prototype.dataToPoint.call(this, e2, o, l4);
    }, n2.prototype.convertToPixel = function(e2, o, l4) {
      var c4 = kCe(o);
      return c4 === this ? c4.dataToPoint(l4) : null;
    }, n2.prototype.convertFromPixel = function(e2, o, l4) {
      var c4 = kCe(o);
      return c4 === this ? c4.pointToData(l4) : null;
    }, n2;
  }(n9);
  Kf(cPe, n9);
  function kCe(i) {
    var n2 = i.geoModel, e2 = i.seriesModel;
    return n2 ? n2.coordinateSystem : e2 ? e2.coordinateSystem || (e2.getReferringComponents("geo", Yf).models[0] || {}).coordinateSystem : null;
  }
  var PCe = cPe;
  function LCe(i, n2) {
    var e2 = i.get("boundingCoords");
    if (e2 != null) {
      var o = e2[0], l4 = e2[1];
      if (isFinite(o[0]) && isFinite(o[1]) && isFinite(l4[0]) && isFinite(l4[1])) {
        var c4 = this.projection;
        if (c4) {
          var h = o[0], p4 = o[1], g4 = l4[0], y4 = l4[1];
          o = [1 / 0, 1 / 0], l4 = [-1 / 0, -1 / 0];
          var _ = function(le, me, ye, be) {
            for (var we = ye - le, Pe = be - me, ze = 0; ze <= 100; ze++) {
              var Re = ze / 100, rt2 = c4.project([le + we * Re, me + Pe * Re]);
              FC(o, o, rt2), NC(l4, l4, rt2);
            }
          };
          _(h, p4, g4, p4), _(g4, p4, g4, y4), _(g4, y4, h, y4), _(h, y4, g4, p4);
        }
        this.setBoundingRect(o[0], o[1], l4[0] - o[0], l4[1] - o[1]);
      }
    }
    var w4 = this.getBoundingRect(), C = i.get("layoutCenter"), E = i.get("layoutSize"), T = n2.getWidth(), O = n2.getHeight(), N = w4.width / w4.height * this.aspectScale, V = false, H, X;
    C && E && (H = [ma(C[0], T), ma(C[1], O)], X = ma(E, Math.min(T, O)), !isNaN(H[0]) && !isNaN(H[1]) && !isNaN(X) && (V = true));
    var q2;
    if (V)
      q2 = {}, N > 1 ? (q2.width = X, q2.height = X / N) : (q2.height = X, q2.width = X * N), q2.y = H[1] - q2.height / 2, q2.x = H[0] - q2.width / 2;
    else {
      var de = i.getBoxLayoutParams();
      de.aspect = N, q2 = bh(de, { width: T, height: O });
    }
    this.setViewRect(q2.x, q2.y, q2.width, q2.height), this.setCenter(i.get("center")), this.setZoom(i.get("zoom"));
  }
  function tmt(i, n2) {
    Ve(n2.get("geoCoord"), function(e2, o) {
      i.addGeoCoord(o, e2);
    });
  }
  var nmt = function() {
    function i() {
      this.dimensions = uPe;
    }
    return i.prototype.create = function(n2, e2) {
      var o = [];
      function l4(h) {
        return { nameProperty: h.get("nameProperty"), aspectScale: h.get("aspectScale"), projection: h.get("projection") };
      }
      n2.eachComponent("geo", function(h, p4) {
        var g4 = h.get("map"), y4 = new PCe(g4 + p4, g4, rr({ nameMap: h.get("nameMap") }, l4(h)));
        y4.zoomLimit = h.get("scaleLimit"), o.push(y4), h.coordinateSystem = y4, y4.model = h, y4.resize = LCe, y4.resize(h, e2);
      }), n2.eachSeries(function(h) {
        var p4 = h.get("coordinateSystem");
        if (p4 === "geo") {
          var g4 = h.get("geoIndex") || 0;
          h.coordinateSystem = o[g4];
        }
      });
      var c4 = {};
      return n2.eachSeriesByType("map", function(h) {
        if (!h.getHostGeoModel()) {
          var p4 = h.getMapType();
          c4[p4] = c4[p4] || [], c4[p4].push(h);
        }
      }), Ve(c4, function(h, p4) {
        var g4 = Er(h, function(_) {
          return _.get("nameMap");
        }), y4 = new PCe(p4, p4, rr({ nameMap: Dse(g4) }, l4(h[0])));
        y4.zoomLimit = Nd.apply(null, Er(h, function(_) {
          return _.get("scaleLimit");
        })), o.push(y4), y4.resize = LCe, y4.resize(h[0], e2), Ve(h, function(_) {
          _.coordinateSystem = y4, tmt(y4, _);
        });
      }), o;
    }, i.prototype.getFilledRegions = function(n2, e2, o, l4) {
      for (var c4 = (n2 || []).slice(), h = ri(), p4 = 0; p4 < c4.length; p4++)
        h.set(c4[p4].name, c4[p4]);
      var g4 = S2.load(e2, o, l4);
      return Ve(g4.regions, function(y4) {
        var _ = y4.name;
        !h.get(_) && c4.push({ name: _ });
      }), c4;
    }, i;
  }(), rmt = new nmt(), fPe = rmt, amt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      var c4 = S2.getGeoResource(e2.map);
      if (c4 && c4.type === "geoJSON") {
        var h = e2.itemStyle = e2.itemStyle || {};
        "color" in h || (h.color = "#eee");
      }
      this.mergeDefaultAndTheme(e2, l4), mT(e2, "label", ["show"]);
    }, n2.prototype.optionUpdated = function() {
      var e2 = this, o = this.option;
      o.regions = fPe.getFilledRegions(o.regions, o.map, o.nameMap, o.nameProperty);
      var l4 = {};
      this._optionModelMap = q_(o.regions || [], function(c4, h) {
        var p4 = h.name;
        return p4 && (c4.set(p4, new Ou(h, e2, e2.ecModel)), h.selected && (l4[p4] = true)), c4;
      }, ri()), o.selectedMap || (o.selectedMap = l4);
    }, n2.prototype.getRegionModel = function(e2) {
      return this._optionModelMap.get(e2) || new Ou(null, this, this.ecModel);
    }, n2.prototype.getFormattedLabel = function(e2, o) {
      var l4 = this.getRegionModel(e2), c4 = o === "normal" ? l4.get(["label", "formatter"]) : l4.get(["emphasis", "label", "formatter"]), h = { name: e2 };
      if (si(c4))
        return h.status = o, c4(h);
      if (xa(c4))
        return c4.replace("{a}", e2 != null ? e2 : "");
    }, n2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, n2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, n2.prototype.select = function(e2) {
      var o = this.option, l4 = o.selectedMode;
      if (!!l4) {
        l4 !== "multiple" && (o.selectedMap = null);
        var c4 = o.selectedMap || (o.selectedMap = {});
        c4[e2] = true;
      }
    }, n2.prototype.unSelect = function(e2) {
      var o = this.option.selectedMap;
      o && (o[e2] = false);
    }, n2.prototype.toggleSelected = function(e2) {
      this[this.isSelected(e2) ? "unSelect" : "select"](e2);
    }, n2.prototype.isSelected = function(e2) {
      var o = this.option.selectedMap;
      return !!(o && o[e2]);
    }, n2.type = "geo", n2.layoutMode = "box", n2.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, n2;
  }(Ns), imt = amt;
  function OCe(i, n2) {
    return i.pointToProjected ? i.pointToProjected(n2) : i.pointToData(n2);
  }
  function Gle(i, n2, e2) {
    var o = i.getZoom(), l4 = i.getCenter(), c4 = n2.zoom, h = i.projectedToPoint ? i.projectedToPoint(l4) : i.dataToPoint(l4);
    if (n2.dx != null && n2.dy != null && (h[0] -= n2.dx, h[1] -= n2.dy, i.setCenter(OCe(i, h))), c4 != null) {
      if (e2) {
        var p4 = e2.min || 0, g4 = e2.max || 1 / 0;
        c4 = Math.max(Math.min(o * c4, g4), p4) / o;
      }
      i.scaleX *= c4, i.scaleY *= c4;
      var y4 = (n2.originX - i.x) * (c4 - 1), _ = (n2.originY - i.y) * (c4 - 1);
      i.x -= y4, i.y -= _, i.updateTransform(), i.setCenter(OCe(i, h)), i.setZoom(c4 * o);
    }
    return { center: i.getCenter(), zoom: i.getZoom() };
  }
  var omt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.focusBlurEnabled = true, e2;
    }
    return n2.prototype.init = function(e2, o) {
      this._api = o;
    }, n2.prototype.render = function(e2, o, l4, c4) {
      if (this._model = e2, !e2.get("show")) {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
        return;
      }
      this._mapDraw || (this._mapDraw = new lPe(l4));
      var h = this._mapDraw;
      h.draw(e2, o, l4, this, c4), h.group.on("click", this._handleRegionClick, this), h.group.silent = e2.get("silent"), this.group.add(h.group), this.updateSelectStatus(e2, o, l4);
    }, n2.prototype._handleRegionClick = function(e2) {
      var o;
      _3(e2.target, function(l4) {
        return (o = Fi(l4).eventData) != null;
      }, true), o && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: o.name });
    }, n2.prototype.updateSelectStatus = function(e2, o, l4) {
      var c4 = this;
      this._mapDraw.group.traverse(function(h) {
        var p4 = Fi(h).eventData;
        if (p4)
          return c4._model.isSelected(p4.name) ? l4.enterSelect(h) : l4.leaveSelect(h), true;
      });
    }, n2.prototype.findHighDownDispatchers = function(e2) {
      return this._mapDraw && this._mapDraw.findHighDownDispatchers(e2, this._model);
    }, n2.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove();
    }, n2.type = "geo", n2;
  }($c), smt = omt;
  function lmt(i, n2, e2) {
    S2.registerMap(i, n2, e2);
  }
  function hPe(i) {
    i.registerCoordinateSystem("geo", fPe), i.registerComponentModel(imt), i.registerComponentView(smt), i.registerImpl("registerMap", lmt), i.registerImpl("getMap", function(e2) {
      return S2.getMapForUser(e2);
    });
    function n2(e2, o) {
      o.update = "geo:updateSelectStatus", i.registerAction(o, function(l4, c4) {
        var h = {}, p4 = [];
        return c4.eachComponent({ mainType: "geo", query: l4 }, function(g4) {
          g4[e2](l4.name);
          var y4 = g4.coordinateSystem;
          Ve(y4.regions, function(w4) {
            h[w4.name] = g4.isSelected(w4.name) || false;
          });
          var _ = [];
          Ve(h, function(w4, C) {
            h[C] && _.push(C);
          }), p4.push({ geoIndex: g4.componentIndex, name: _ });
        }), { selected: h, allSelected: p4, name: l4.name };
      });
    }
    n2("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), n2("select", { type: "geoSelect", event: "geoselected" }), n2("unSelect", { type: "geoUnSelect", event: "geounselected" }), i.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(e2, o) {
      var l4 = e2.componentType || "series";
      o.eachComponent({ mainType: l4, query: e2 }, function(c4) {
        var h = c4.coordinateSystem;
        if (h.type === "geo") {
          var p4 = Gle(h, e2, c4.get("scaleLimit"));
          c4.setCenter && c4.setCenter(p4.center), c4.setZoom && c4.setZoom(p4.zoom), l4 === "series" && Ve(c4.seriesGroup, function(g4) {
            g4.setCenter(p4.center), g4.setZoom(p4.zoom);
          });
        }
      });
    });
  }
  function umt(i) {
    wo(hPe), i.registerChartView(q0t), i.registerSeriesModel(Z0t), i.registerLayout(J0t), i.registerProcessor(i.PRIORITY.PROCESSOR.STATISTIC, K0t), h5e("map", i.registerAction);
  }
  function cmt(i) {
    var n2 = i;
    n2.hierNode = { defaultAncestor: null, ancestor: n2, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
    for (var e2 = [n2], o, l4; o = e2.pop(); )
      if (l4 = o.children, o.isExpand && l4.length)
        for (var c4 = l4.length, h = c4 - 1; h >= 0; h--) {
          var p4 = l4[h];
          p4.hierNode = { defaultAncestor: null, ancestor: p4, prelim: 0, modifier: 0, change: 0, shift: 0, i: h, thread: null }, e2.push(p4);
        }
  }
  function fmt(i, n2) {
    var e2 = i.isExpand ? i.children : [], o = i.parentNode.children, l4 = i.hierNode.i ? o[i.hierNode.i - 1] : null;
    if (e2.length) {
      pmt(i);
      var c4 = (e2[0].hierNode.prelim + e2[e2.length - 1].hierNode.prelim) / 2;
      l4 ? (i.hierNode.prelim = l4.hierNode.prelim + n2(i, l4), i.hierNode.modifier = i.hierNode.prelim - c4) : i.hierNode.prelim = c4;
    } else
      l4 && (i.hierNode.prelim = l4.hierNode.prelim + n2(i, l4));
    i.parentNode.hierNode.defaultAncestor = vmt(i, l4, i.parentNode.hierNode.defaultAncestor || o[0], n2);
  }
  function hmt(i) {
    var n2 = i.hierNode.prelim + i.parentNode.hierNode.modifier;
    i.setLayout({ x: n2 }, true), i.hierNode.modifier += i.parentNode.hierNode.modifier;
  }
  function RCe(i) {
    return arguments.length ? i : ymt;
  }
  function ON(i, n2) {
    return i -= Math.PI / 2, { x: n2 * Math.cos(i), y: n2 * Math.sin(i) };
  }
  function dmt(i, n2) {
    return bh(i.getBoxLayoutParams(), { width: n2.getWidth(), height: n2.getHeight() });
  }
  function pmt(i) {
    for (var n2 = i.children, e2 = n2.length, o = 0, l4 = 0; --e2 >= 0; ) {
      var c4 = n2[e2];
      c4.hierNode.prelim += o, c4.hierNode.modifier += o, l4 += c4.hierNode.change, o += c4.hierNode.shift + l4;
    }
  }
  function vmt(i, n2, e2, o) {
    if (n2) {
      for (var l4 = i, c4 = i, h = c4.parentNode.children[0], p4 = n2, g4 = l4.hierNode.modifier, y4 = c4.hierNode.modifier, _ = h.hierNode.modifier, w4 = p4.hierNode.modifier; p4 = dae(p4), c4 = pae(c4), p4 && c4; ) {
        l4 = dae(l4), h = pae(h), l4.hierNode.ancestor = i;
        var C = p4.hierNode.prelim + w4 - c4.hierNode.prelim - y4 + o(p4, c4);
        C > 0 && (mmt(gmt(p4, i, e2), i, C), y4 += C, g4 += C), w4 += p4.hierNode.modifier, y4 += c4.hierNode.modifier, g4 += l4.hierNode.modifier, _ += h.hierNode.modifier;
      }
      p4 && !dae(l4) && (l4.hierNode.thread = p4, l4.hierNode.modifier += w4 - g4), c4 && !pae(h) && (h.hierNode.thread = c4, h.hierNode.modifier += y4 - _, e2 = i);
    }
    return e2;
  }
  function dae(i) {
    var n2 = i.children;
    return n2.length && i.isExpand ? n2[n2.length - 1] : i.hierNode.thread;
  }
  function pae(i) {
    var n2 = i.children;
    return n2.length && i.isExpand ? n2[0] : i.hierNode.thread;
  }
  function gmt(i, n2, e2) {
    return i.hierNode.ancestor.parentNode === n2.parentNode ? i.hierNode.ancestor : e2;
  }
  function mmt(i, n2, e2) {
    var o = e2 / (n2.hierNode.i - i.hierNode.i);
    n2.hierNode.change -= o, n2.hierNode.shift += e2, n2.hierNode.modifier += e2, n2.hierNode.prelim += e2, i.hierNode.change += o;
  }
  function ymt(i, n2) {
    return i.parentNode === n2.parentNode ? 1 : 2;
  }
  var bmt = function() {
    function i() {
      this.parentPoint = [], this.childPoints = [];
    }
    return i;
  }(), _mt = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new bmt();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.childPoints, c4 = l4.length, h = o.parentPoint, p4 = l4[0], g4 = l4[c4 - 1];
      if (c4 === 1) {
        e2.moveTo(h[0], h[1]), e2.lineTo(p4[0], p4[1]);
        return;
      }
      var y4 = o.orient, _ = y4 === "TB" || y4 === "BT" ? 0 : 1, w4 = 1 - _, C = ma(o.forkPosition, 1), E = [];
      E[_] = h[_], E[w4] = h[w4] + (g4[w4] - h[w4]) * C, e2.moveTo(h[0], h[1]), e2.lineTo(E[0], E[1]), e2.moveTo(p4[0], p4[1]), E[_] = p4[_], e2.lineTo(E[0], E[1]), E[_] = g4[_], e2.lineTo(E[0], E[1]), e2.lineTo(g4[0], g4[1]);
      for (var T = 1; T < c4 - 1; T++) {
        var O = l4[T];
        e2.moveTo(O[0], O[1]), E[_] = O[_], e2.lineTo(E[0], E[1]);
      }
    }, n2;
  }(Eo), xmt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._mainGroup = new Ti(), e2;
    }
    return n2.prototype.init = function(e2, o) {
      this._controller = new t9(o.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
    }, n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = e2.layoutInfo, p4 = this._mainGroup, g4 = e2.get("layout");
      g4 === "radial" ? (p4.x = h.x + h.width / 2, p4.y = h.y + h.height / 2) : (p4.x = h.x, p4.y = h.y), this._updateViewCoordSys(e2), this._updateController(e2, o, l4);
      var y4 = this._data;
      c4.diff(y4).add(function(_) {
        FCe(c4, _) && NCe(c4, _, null, p4, e2);
      }).update(function(_, w4) {
        var C = y4.getItemGraphicEl(w4);
        if (!FCe(c4, _)) {
          C && zCe(y4, w4, C, p4, e2);
          return;
        }
        NCe(c4, _, C, p4, e2);
      }).remove(function(_) {
        var w4 = y4.getItemGraphicEl(_);
        w4 && zCe(y4, _, w4, p4, e2);
      }).execute(), this._nodeScaleRatio = e2.get("nodeScaleRatio"), this._updateNodeAndLinkScale(e2), e2.get("expandAndCollapse") === true && c4.eachItemGraphicEl(function(_, w4) {
        _.off("click").on("click", function() {
          l4.dispatchAction({ type: "treeExpandAndCollapse", seriesId: e2.id, dataIndex: w4 });
        });
      }), this._data = c4;
    }, n2.prototype._updateViewCoordSys = function(e2) {
      var o = e2.getData(), l4 = [];
      o.each(function(_) {
        var w4 = o.getItemLayout(_);
        w4 && !isNaN(w4.x) && !isNaN(w4.y) && l4.push([+w4.x, +w4.y]);
      });
      var c4 = [], h = [];
      C$(l4, c4, h);
      var p4 = this._min, g4 = this._max;
      h[0] - c4[0] === 0 && (c4[0] = p4 ? p4[0] : c4[0] - 1, h[0] = g4 ? g4[0] : h[0] + 1), h[1] - c4[1] === 0 && (c4[1] = p4 ? p4[1] : c4[1] - 1, h[1] = g4 ? g4[1] : h[1] + 1);
      var y4 = e2.coordinateSystem = new n9();
      y4.zoomLimit = e2.get("scaleLimit"), y4.setBoundingRect(c4[0], c4[1], h[0] - c4[0], h[1] - c4[1]), y4.setCenter(e2.get("center")), y4.setZoom(e2.get("zoom")), this.group.attr({ x: y4.x, y: y4.y, scaleX: y4.scaleX, scaleY: y4.scaleY }), this._min = c4, this._max = h;
    }, n2.prototype._updateController = function(e2, o, l4) {
      var c4 = this, h = this._controller, p4 = this._controllerHost, g4 = this.group;
      h.setPointerChecker(function(y4, _, w4) {
        var C = g4.getBoundingRect();
        return C.applyTransform(g4.transform), C.contain(_, w4) && !Y$(y4, l4, e2);
      }), h.enable(e2.get("roam")), p4.zoomLimit = e2.get("scaleLimit"), p4.zoom = e2.coordinateSystem.getZoom(), h.off("pan").off("zoom").on("pan", function(y4) {
        zle(p4, y4.dx, y4.dy), l4.dispatchAction({ seriesId: e2.id, type: "treeRoam", dx: y4.dx, dy: y4.dy });
      }).on("zoom", function(y4) {
        Ble(p4, y4.scale, y4.originX, y4.originY), l4.dispatchAction({ seriesId: e2.id, type: "treeRoam", zoom: y4.scale, originX: y4.originX, originY: y4.originY }), c4._updateNodeAndLinkScale(e2), l4.updateLabelLayout();
      });
    }, n2.prototype._updateNodeAndLinkScale = function(e2) {
      var o = e2.getData(), l4 = this._getNodeGlobalScale(e2);
      o.eachItemGraphicEl(function(c4, h) {
        c4.setSymbolScale(l4);
      });
    }, n2.prototype._getNodeGlobalScale = function(e2) {
      var o = e2.coordinateSystem;
      if (o.type !== "view")
        return 1;
      var l4 = this._nodeScaleRatio, c4 = o.scaleX || 1, h = o.getZoom(), p4 = (h - 1) * l4 + 1;
      return p4 / c4;
    }, n2.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, n2.prototype.remove = function() {
      this._mainGroup.removeAll(), this._data = null;
    }, n2.type = "tree", n2;
  }(Ru);
  function FCe(i, n2) {
    var e2 = i.getItemLayout(n2);
    return e2 && !isNaN(e2.x) && !isNaN(e2.y);
  }
  function NCe(i, n2, e2, o, l4) {
    var c4 = !e2, h = i.tree.getNodeByDataIndex(n2), p4 = h.getModel(), g4 = h.getVisual("style").fill, y4 = h.isExpand === false && h.children.length !== 0 ? g4 : "#fff", _ = i.tree.root, w4 = h.parentNode === _ ? h : h.parentNode || h, C = i.getItemGraphicEl(w4.dataIndex), E = w4.getLayout(), T = C ? { x: C.__oldX, y: C.__oldY, rawX: C.__radialOldRawX, rawY: C.__radialOldRawY } : E, O = h.getLayout();
    c4 ? (e2 = new X8(i, n2, null, { symbolInnerColor: y4, useNameLabel: true }), e2.x = T.x, e2.y = T.y) : e2.updateData(i, n2, null, { symbolInnerColor: y4, useNameLabel: true }), e2.__radialOldRawX = e2.__radialRawX, e2.__radialOldRawY = e2.__radialRawY, e2.__radialRawX = O.rawX, e2.__radialRawY = O.rawY, o.add(e2), i.setItemGraphicEl(n2, e2), e2.__oldX = e2.x, e2.__oldY = e2.y, Vs(e2, { x: O.x, y: O.y }, l4);
    var N = e2.getSymbolPath();
    if (l4.get("layout") === "radial") {
      var V = _.children[0], H = V.getLayout(), X = V.children.length, q2 = void 0, de = void 0;
      if (O.x === H.x && h.isExpand === true) {
        var le = { x: (V.children[0].getLayout().x + V.children[X - 1].getLayout().x) / 2, y: (V.children[0].getLayout().y + V.children[X - 1].getLayout().y) / 2 };
        q2 = Math.atan2(le.y - H.y, le.x - H.x), q2 < 0 && (q2 = Math.PI * 2 + q2), de = le.x < H.x, de && (q2 = q2 - Math.PI);
      } else
        q2 = Math.atan2(O.y - H.y, O.x - H.x), q2 < 0 && (q2 = Math.PI * 2 + q2), h.children.length === 0 || h.children.length !== 0 && h.isExpand === false ? (de = O.x < H.x, de && (q2 = q2 - Math.PI)) : (de = O.x > H.x, de || (q2 = q2 - Math.PI));
      var me = de ? "left" : "right", ye = p4.getModel("label"), be = ye.get("rotate"), we = be * (Math.PI / 180), Pe = N.getTextContent();
      Pe && (N.setTextConfig({ position: ye.get("position") || me, rotation: be == null ? -q2 : we, origin: "center" }), Pe.setStyle("verticalAlign", "middle"));
    }
    var ze = p4.get(["emphasis", "focus"]), Re = ze === "ancestor" ? h.getAncestorsIndices() : ze === "descendant" ? h.getDescendantIndices() : null;
    Re && (Fi(e2).focus = Re), wmt(l4, h, _, e2, T, E, O, o), e2.__edge && (e2.onHoverStateChange = function(rt2) {
      if (rt2 !== "blur") {
        var ft = h.parentNode && i.getItemGraphicEl(h.parentNode.dataIndex);
        ft && ft.hoverState === z8 || AH(e2.__edge, rt2);
      }
    });
  }
  function wmt(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = n2.getModel(), y4 = i.get("edgeShape"), _ = i.get("layout"), w4 = i.getOrient(), C = i.get(["lineStyle", "curveness"]), E = i.get("edgeForkPosition"), T = g4.getModel("lineStyle").getLineStyle(), O = o.__edge;
    if (y4 === "curve")
      n2.parentNode && n2.parentNode !== e2 && (O || (O = o.__edge = new I$({ shape: koe(_, w4, C, l4, l4) })), Vs(O, { shape: koe(_, w4, C, c4, h) }, i));
    else if (y4 === "polyline" && _ === "orthogonal" && n2 !== e2 && n2.children && n2.children.length !== 0 && n2.isExpand === true) {
      for (var N = n2.children, V = [], H = 0; H < N.length; H++) {
        var X = N[H].getLayout();
        V.push([X.x, X.y]);
      }
      O || (O = o.__edge = new _mt({ shape: { parentPoint: [h.x, h.y], childPoints: [[h.x, h.y]], orient: w4, forkPosition: E } })), Vs(O, { shape: { parentPoint: [h.x, h.y], childPoints: V } }, i);
    }
    O && (O.useStyle(hi({ strokeNoScale: true, fill: null }, T)), Mp(O, g4, "lineStyle"), _T(O), p4.add(O));
  }
  function VCe(i, n2, e2, o, l4) {
    var c4 = n2.tree.root, h = dPe(c4, i), p4 = h.source, g4 = h.sourceLayout, y4 = n2.getItemGraphicEl(i.dataIndex);
    if (!!y4) {
      var _ = n2.getItemGraphicEl(p4.dataIndex), w4 = _.__edge, C = y4.__edge || (p4.isExpand === false || p4.children.length === 1 ? w4 : void 0), E = o.get("edgeShape"), T = o.get("layout"), O = o.get("orient"), N = o.get(["lineStyle", "curveness"]);
      C && (E === "curve" ? JC(C, { shape: koe(T, O, N, g4, g4), style: { opacity: 0 } }, o, { cb: function() {
        e2.remove(C);
      }, removeOpt: l4 }) : E === "polyline" && o.get("layout") === "orthogonal" && JC(C, { shape: { parentPoint: [g4.x, g4.y], childPoints: [[g4.x, g4.y]] }, style: { opacity: 0 } }, o, { cb: function() {
        e2.remove(C);
      }, removeOpt: l4 }));
    }
  }
  function dPe(i, n2) {
    for (var e2 = n2.parentNode === i ? n2 : n2.parentNode || n2, o; o = e2.getLayout(), o == null; )
      e2 = e2.parentNode === i ? e2 : e2.parentNode || e2;
    return { source: e2, sourceLayout: o };
  }
  function zCe(i, n2, e2, o, l4) {
    var c4 = i.tree.getNodeByDataIndex(n2), h = i.tree.root, p4 = dPe(h, c4).sourceLayout, g4 = { duration: l4.get("animationDurationUpdate"), easing: l4.get("animationEasingUpdate") };
    JC(e2, { x: p4.x + 1, y: p4.y + 1 }, l4, { cb: function() {
      o.remove(e2), i.setItemGraphicEl(n2, null);
    }, removeOpt: g4 }), e2.fadeOut(null, i.hostModel, { fadeLabel: true, animation: g4 }), c4.children.forEach(function(y4) {
      VCe(y4, i, o, l4, g4);
    }), VCe(c4, i, o, l4, g4);
  }
  function koe(i, n2, e2, o, l4) {
    var c4, h, p4, g4, y4, _, w4, C;
    if (i === "radial") {
      y4 = o.rawX, w4 = o.rawY, _ = l4.rawX, C = l4.rawY;
      var E = ON(y4, w4), T = ON(y4, w4 + (C - w4) * e2), O = ON(_, C + (w4 - C) * e2), N = ON(_, C);
      return { x1: E.x || 0, y1: E.y || 0, x2: N.x || 0, y2: N.y || 0, cpx1: T.x || 0, cpy1: T.y || 0, cpx2: O.x || 0, cpy2: O.y || 0 };
    } else
      y4 = o.x, w4 = o.y, _ = l4.x, C = l4.y, (n2 === "LR" || n2 === "RL") && (c4 = y4 + (_ - y4) * e2, h = w4, p4 = _ + (y4 - _) * e2, g4 = C), (n2 === "TB" || n2 === "BT") && (c4 = y4, h = w4 + (C - w4) * e2, p4 = _, g4 = C + (w4 - C) * e2);
    return { x1: y4, y1: w4, x2: _, y2: C, cpx1: c4, cpy1: h, cpx2: p4, cpy2: g4 };
  }
  var Smt = xmt, Oy = zs();
  function pPe(i) {
    var n2 = i.mainData, e2 = i.datas;
    e2 || (e2 = { main: n2 }, i.datasAttr = { main: "data" }), i.datas = i.mainData = null, vPe(n2, e2, i), Ve(e2, function(o) {
      Ve(n2.TRANSFERABLE_METHODS, function(l4) {
        o.wrapMethod(l4, zi(Cmt, i));
      });
    }), n2.wrapMethod("cloneShallow", zi(Amt, i)), Ve(n2.CHANGABLE_METHODS, function(o) {
      n2.wrapMethod(o, zi(Mmt, i));
    }), Kv(e2[n2.dataType] === n2);
  }
  function Cmt(i, n2) {
    if (Tmt(this)) {
      var e2 = rr({}, Oy(this).datas);
      e2[this.dataType] = n2, vPe(n2, e2, i);
    } else
      Wle(n2, this.dataType, Oy(this).mainData, i);
    return n2;
  }
  function Mmt(i, n2) {
    return i.struct && i.struct.update(), n2;
  }
  function Amt(i, n2) {
    return Ve(Oy(n2).datas, function(e2, o) {
      e2 !== n2 && Wle(e2.cloneShallow(), o, n2, i);
    }), n2;
  }
  function Emt(i) {
    var n2 = Oy(this).mainData;
    return i == null || n2 == null ? n2 : Oy(n2).datas[i];
  }
  function Imt() {
    var i = Oy(this).mainData;
    return i == null ? [{ data: i }] : Er(ts(Oy(i).datas), function(n2) {
      return { type: n2, data: Oy(i).datas[n2] };
    });
  }
  function Tmt(i) {
    return Oy(i).mainData === i;
  }
  function vPe(i, n2, e2) {
    Oy(i).datas = {}, Ve(n2, function(o, l4) {
      Wle(o, l4, i, e2);
    });
  }
  function Wle(i, n2, e2, o) {
    Oy(e2).datas[n2] = i, Oy(i).mainData = e2, i.dataType = n2, o.struct && (i[o.structAttr] = o.struct, o.struct[o.datasAttr[n2]] = i), i.getLinkedData = Emt, i.getLinkedDataAll = Imt;
  }
  var Dmt = function() {
    function i(n2, e2) {
      this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = n2 || "", this.hostTree = e2;
    }
    return i.prototype.isRemoved = function() {
      return this.dataIndex < 0;
    }, i.prototype.eachNode = function(n2, e2, o) {
      si(n2) && (o = e2, e2 = n2, n2 = null), n2 = n2 || {}, xa(n2) && (n2 = { order: n2 });
      var l4 = n2.order || "preorder", c4 = this[n2.attr || "children"], h;
      l4 === "preorder" && (h = e2.call(o, this));
      for (var p4 = 0; !h && p4 < c4.length; p4++)
        c4[p4].eachNode(n2, e2, o);
      l4 === "postorder" && e2.call(o, this);
    }, i.prototype.updateDepthAndHeight = function(n2) {
      var e2 = 0;
      this.depth = n2;
      for (var o = 0; o < this.children.length; o++) {
        var l4 = this.children[o];
        l4.updateDepthAndHeight(n2 + 1), l4.height > e2 && (e2 = l4.height);
      }
      this.height = e2 + 1;
    }, i.prototype.getNodeById = function(n2) {
      if (this.getId() === n2)
        return this;
      for (var e2 = 0, o = this.children, l4 = o.length; e2 < l4; e2++) {
        var c4 = o[e2].getNodeById(n2);
        if (c4)
          return c4;
      }
    }, i.prototype.contains = function(n2) {
      if (n2 === this)
        return true;
      for (var e2 = 0, o = this.children, l4 = o.length; e2 < l4; e2++) {
        var c4 = o[e2].contains(n2);
        if (c4)
          return c4;
      }
    }, i.prototype.getAncestors = function(n2) {
      for (var e2 = [], o = n2 ? this : this.parentNode; o; )
        e2.push(o), o = o.parentNode;
      return e2.reverse(), e2;
    }, i.prototype.getAncestorsIndices = function() {
      for (var n2 = [], e2 = this; e2; )
        n2.push(e2.dataIndex), e2 = e2.parentNode;
      return n2.reverse(), n2;
    }, i.prototype.getDescendantIndices = function() {
      var n2 = [];
      return this.eachNode(function(e2) {
        n2.push(e2.dataIndex);
      }), n2;
    }, i.prototype.getValue = function(n2) {
      var e2 = this.hostTree.data;
      return e2.getStore().get(e2.getDimensionIndex(n2 || "value"), this.dataIndex);
    }, i.prototype.setLayout = function(n2, e2) {
      this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, n2, e2);
    }, i.prototype.getLayout = function() {
      return this.hostTree.data.getItemLayout(this.dataIndex);
    }, i.prototype.getModel = function(n2) {
      if (!(this.dataIndex < 0)) {
        var e2 = this.hostTree, o = e2.data.getItemModel(this.dataIndex);
        return o.getModel(n2);
      }
    }, i.prototype.getLevelModel = function() {
      return (this.hostTree.levelModels || [])[this.depth];
    }, i.prototype.setVisual = function(n2, e2) {
      this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, n2, e2);
    }, i.prototype.getVisual = function(n2) {
      return this.hostTree.data.getItemVisual(this.dataIndex, n2);
    }, i.prototype.getRawIndex = function() {
      return this.hostTree.data.getRawIndex(this.dataIndex);
    }, i.prototype.getId = function() {
      return this.hostTree.data.getId(this.dataIndex);
    }, i.prototype.getChildIndex = function() {
      if (this.parentNode) {
        for (var n2 = this.parentNode.children, e2 = 0; e2 < n2.length; ++e2)
          if (n2[e2] === this)
            return e2;
        return -1;
      }
      return -1;
    }, i.prototype.isAncestorOf = function(n2) {
      for (var e2 = n2.parentNode; e2; ) {
        if (e2 === this)
          return true;
        e2 = e2.parentNode;
      }
      return false;
    }, i.prototype.isDescendantOf = function(n2) {
      return n2 !== this && n2.isAncestorOf(this);
    }, i;
  }(), kmt = function() {
    function i(n2) {
      this.type = "tree", this._nodes = [], this.hostModel = n2;
    }
    return i.prototype.eachNode = function(n2, e2, o) {
      this.root.eachNode(n2, e2, o);
    }, i.prototype.getNodeByDataIndex = function(n2) {
      var e2 = this.data.getRawIndex(n2);
      return this._nodes[e2];
    }, i.prototype.getNodeById = function(n2) {
      return this.root.getNodeById(n2);
    }, i.prototype.update = function() {
      for (var n2 = this.data, e2 = this._nodes, o = 0, l4 = e2.length; o < l4; o++)
        e2[o].dataIndex = -1;
      for (var o = 0, l4 = n2.count(); o < l4; o++)
        e2[n2.getRawIndex(o)].dataIndex = o;
    }, i.prototype.clearLayouts = function() {
      this.data.clearItemLayouts();
    }, i.createTree = function(n2, e2, o) {
      var l4 = new i(e2), c4 = [], h = 1;
      p4(n2);
      function p4(_, w4) {
        var C = _.value;
        h = Math.max(h, Mr(C) ? C.length : 1), c4.push(_);
        var E = new Dmt(yh(_.name, ""), l4);
        w4 ? Pmt(E, w4) : l4.root = E, l4._nodes.push(E);
        var T = _.children;
        if (T)
          for (var O = 0; O < T.length; O++)
            p4(T[O], E);
      }
      l4.root.updateDepthAndHeight(0);
      var g4 = q8(c4, { coordDimensions: ["value"], dimensionsCount: h }).dimensions, y4 = new Xv(g4, e2);
      return y4.initData(c4), o && o(y4), pPe({ mainData: y4, struct: l4, structAttr: "tree" }), l4.update(), l4;
    }, i;
  }();
  function Pmt(i, n2) {
    var e2 = n2.children;
    i.parentNode !== n2 && (e2.push(i), i.parentNode = n2);
  }
  var Hle = kmt;
  function M8(i, n2, e2) {
    if (i && go(n2, i.type) >= 0) {
      var o = e2.getData().tree.root, l4 = i.targetNode;
      if (xa(l4) && (l4 = o.getNodeById(l4)), l4 && o.contains(l4))
        return { node: l4 };
      var c4 = i.targetNodeId;
      if (c4 != null && (l4 = o.getNodeById(c4)))
        return { node: l4 };
    }
  }
  function gPe(i) {
    for (var n2 = []; i; )
      i = i.parentNode, i && n2.push(i);
    return n2.reverse();
  }
  function $le(i, n2) {
    var e2 = gPe(i);
    return go(e2, n2) >= 0;
  }
  function X$(i, n2) {
    for (var e2 = []; i; ) {
      var o = i.dataIndex;
      e2.push({ name: i.name, dataIndex: o, value: n2.getRawValue(o) }), i = i.parentNode;
    }
    return e2.reverse(), e2;
  }
  var Lmt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.hasSymbolVisual = true, e2.ignoreStyleOnData = true, e2;
    }
    return n2.prototype.getInitialData = function(e2) {
      var o = { name: e2.name, children: e2.data }, l4 = e2.leaves || {}, c4 = new Ou(l4, this, this.ecModel), h = Hle.createTree(o, this, p4);
      function p4(w4) {
        w4.wrapMethod("getItemModel", function(C, E) {
          var T = h.getNodeByDataIndex(E);
          return T && T.children.length && T.isExpand || (C.parentModel = c4), C;
        });
      }
      var g4 = 0;
      h.eachNode("preorder", function(w4) {
        w4.depth > g4 && (g4 = w4.depth);
      });
      var y4 = e2.expandAndCollapse, _ = y4 && e2.initialTreeDepth >= 0 ? e2.initialTreeDepth : g4;
      return h.root.eachNode("preorder", function(w4) {
        var C = w4.hostTree.data.getRawDataItem(w4.dataIndex);
        w4.isExpand = C && C.collapsed != null ? !C.collapsed : w4.depth <= _;
      }), h.data;
    }, n2.prototype.getOrient = function() {
      var e2 = this.get("orient");
      return e2 === "horizontal" ? e2 = "LR" : e2 === "vertical" && (e2 = "TB"), e2;
    }, n2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, n2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      for (var c4 = this.getData().tree, h = c4.root.children[0], p4 = c4.getNodeByDataIndex(e2), g4 = p4.getValue(), y4 = p4.name; p4 && p4 !== h; )
        y4 = p4.parentNode.name + "." + y4, p4 = p4.parentNode;
      return Qh("nameValue", { name: y4, value: g4, noValue: isNaN(g4) || g4 == null });
    }, n2.prototype.getDataParams = function(e2) {
      var o = i.prototype.getDataParams.apply(this, arguments), l4 = this.getData().tree.getNodeByDataIndex(e2);
      return o.treeAncestors = X$(l4, this), o;
    }, n2.type = "series.tree", n2.layoutMode = "box", n2.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, n2;
  }(_c2), Omt = Lmt;
  function Rmt(i, n2, e2) {
    for (var o = [i], l4 = [], c4; c4 = o.pop(); )
      if (l4.push(c4), c4.isExpand) {
        var h = c4.children;
        if (h.length)
          for (var p4 = 0; p4 < h.length; p4++)
            o.push(h[p4]);
      }
    for (; c4 = l4.pop(); )
      n2(c4, e2);
  }
  function vN(i, n2) {
    for (var e2 = [i], o; o = e2.pop(); )
      if (n2(o), o.isExpand) {
        var l4 = o.children;
        if (l4.length)
          for (var c4 = l4.length - 1; c4 >= 0; c4--)
            e2.push(l4[c4]);
      }
  }
  function Fmt(i, n2) {
    i.eachSeriesByType("tree", function(e2) {
      Nmt(e2, n2);
    });
  }
  function Nmt(i, n2) {
    var e2 = dmt(i, n2);
    i.layoutInfo = e2;
    var o = i.get("layout"), l4 = 0, c4 = 0, h = null;
    o === "radial" ? (l4 = 2 * Math.PI, c4 = Math.min(e2.height, e2.width) / 2, h = RCe(function(X, q2) {
      return (X.parentNode === q2.parentNode ? 1 : 2) / X.depth;
    })) : (l4 = e2.width, c4 = e2.height, h = RCe());
    var p4 = i.getData().tree.root, g4 = p4.children[0];
    if (g4) {
      cmt(p4), Rmt(g4, fmt, h), p4.hierNode.modifier = -g4.hierNode.prelim, vN(g4, hmt);
      var y4 = g4, _ = g4, w4 = g4;
      vN(g4, function(X) {
        var q2 = X.getLayout().x;
        q2 < y4.getLayout().x && (y4 = X), q2 > _.getLayout().x && (_ = X), X.depth > w4.depth && (w4 = X);
      });
      var C = y4 === _ ? 1 : h(y4, _) / 2, E = C - y4.getLayout().x, T = 0, O = 0, N = 0, V = 0;
      if (o === "radial")
        T = l4 / (_.getLayout().x + C + E), O = c4 / (w4.depth - 1 || 1), vN(g4, function(X) {
          N = (X.getLayout().x + E) * T, V = (X.depth - 1) * O;
          var q2 = ON(N, V);
          X.setLayout({ x: q2.x, y: q2.y, rawX: N, rawY: V }, true);
        });
      else {
        var H = i.getOrient();
        H === "RL" || H === "LR" ? (O = c4 / (_.getLayout().x + C + E), T = l4 / (w4.depth - 1 || 1), vN(g4, function(X) {
          V = (X.getLayout().x + E) * O, N = H === "LR" ? (X.depth - 1) * T : l4 - (X.depth - 1) * T, X.setLayout({ x: N, y: V }, true);
        })) : (H === "TB" || H === "BT") && (T = l4 / (_.getLayout().x + C + E), O = c4 / (w4.depth - 1 || 1), vN(g4, function(X) {
          N = (X.getLayout().x + E) * T, V = H === "TB" ? (X.depth - 1) * O : c4 - (X.depth - 1) * O, X.setLayout({ x: N, y: V }, true);
        }));
      }
    }
  }
  function Vmt(i) {
    i.eachSeriesByType("tree", function(n2) {
      var e2 = n2.getData(), o = e2.tree;
      o.eachNode(function(l4) {
        var c4 = l4.getModel(), h = c4.getModel("itemStyle").getItemStyle(), p4 = e2.ensureUniqueItemVisual(l4.dataIndex, "style");
        rr(p4, h);
      });
    });
  }
  function zmt(i) {
    i.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(n2, e2) {
      e2.eachComponent({ mainType: "series", subType: "tree", query: n2 }, function(o) {
        var l4 = n2.dataIndex, c4 = o.getData().tree, h = c4.getNodeByDataIndex(l4);
        h.isExpand = !h.isExpand;
      });
    }), i.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(n2, e2) {
      e2.eachComponent({ mainType: "series", subType: "tree", query: n2 }, function(o) {
        var l4 = o.coordinateSystem, c4 = Gle(l4, n2);
        o.setCenter && o.setCenter(c4.center), o.setZoom && o.setZoom(c4.zoom);
      });
    });
  }
  function Bmt(i) {
    i.registerChartView(Smt), i.registerSeriesModel(Omt), i.registerLayout(Fmt), i.registerVisual(Vmt), zmt(i);
  }
  var BCe = ["treemapZoomToNode", "treemapRender", "treemapMove"];
  function jmt(i) {
    for (var n2 = 0; n2 < BCe.length; n2++)
      i.registerAction({ type: BCe[n2], update: "updateView" }, Zf);
    i.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(e2, o) {
      o.eachComponent({ mainType: "series", subType: "treemap", query: e2 }, l4);
      function l4(c4, h) {
        var p4 = ["treemapZoomToNode", "treemapRootToNode"], g4 = M8(e2, p4, c4);
        if (g4) {
          var y4 = c4.getViewRoot();
          y4 && (e2.direction = $le(y4, g4.node) ? "rollUp" : "drillDown"), c4.resetViewRoot(g4.node);
        }
      }
    });
  }
  function mPe(i) {
    var n2 = i.getData(), e2 = n2.tree, o = {};
    e2.eachNode(function(l4) {
      for (var c4 = l4; c4 && c4.depth > 1; )
        c4 = c4.parentNode;
      var h = ooe(i.ecModel, c4.name || c4.dataIndex + "", o);
      l4.setVisual("decal", h);
    });
  }
  var Gmt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.preventUsingHoverLayer = true, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      var l4 = { name: e2.name, children: e2.data };
      yPe(l4);
      var c4 = e2.levels || [], h = this.designatedVisualItemStyle = {}, p4 = new Ou({ itemStyle: h }, this, o);
      c4 = e2.levels = Wmt(c4, o);
      var g4 = Er(c4 || [], function(w4) {
        return new Ou(w4, p4, o);
      }, this), y4 = Hle.createTree(l4, this, _);
      function _(w4) {
        w4.wrapMethod("getItemModel", function(C, E) {
          var T = y4.getNodeByDataIndex(E), O = T ? g4[T.depth] : null;
          return C.parentModel = O || p4, C;
        });
      }
      return y4.data;
    }, n2.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      var c4 = this.getData(), h = this.getRawValue(e2), p4 = c4.getName(e2);
      return Qh("nameValue", { name: p4, value: h });
    }, n2.prototype.getDataParams = function(e2) {
      var o = i.prototype.getDataParams.apply(this, arguments), l4 = this.getData().tree.getNodeByDataIndex(e2);
      return o.treeAncestors = X$(l4, this), o.treePathInfo = o.treeAncestors, o;
    }, n2.prototype.setLayoutInfo = function(e2) {
      this.layoutInfo = this.layoutInfo || {}, rr(this.layoutInfo, e2);
    }, n2.prototype.mapIdToIndex = function(e2) {
      var o = this._idIndexMap;
      o || (o = this._idIndexMap = ri(), this._idIndexMapCount = 0);
      var l4 = o.get(e2);
      return l4 == null && o.set(e2, l4 = this._idIndexMapCount++), l4;
    }, n2.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, n2.prototype.resetViewRoot = function(e2) {
      e2 ? this._viewRoot = e2 : e2 = this._viewRoot;
      var o = this.getRawData().tree.root;
      (!e2 || e2 !== o && !o.contains(e2)) && (this._viewRoot = o);
    }, n2.prototype.enableAriaDecal = function() {
      mPe(this);
    }, n2.type = "series.treemap", n2.layoutMode = "box", n2.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, n2;
  }(_c2);
  function yPe(i) {
    var n2 = 0;
    Ve(i.children, function(o) {
      yPe(o);
      var l4 = o.value;
      Mr(l4) && (l4 = l4[0]), n2 += l4;
    });
    var e2 = i.value;
    Mr(e2) && (e2 = e2[0]), (e2 == null || isNaN(e2)) && (e2 = n2), e2 < 0 && (e2 = 0), Mr(i.value) ? i.value[0] = e2 : i.value = e2;
  }
  function Wmt(i, n2) {
    var e2 = Zl(n2.get("color")), o = Zl(n2.get(["aria", "decal", "decals"]));
    if (!!e2) {
      i = i || [];
      var l4, c4;
      Ve(i, function(p4) {
        var g4 = new Ou(p4), y4 = g4.get("color"), _ = g4.get("decal");
        (g4.get(["itemStyle", "color"]) || y4 && y4 !== "none") && (l4 = true), (g4.get(["itemStyle", "decal"]) || _ && _ !== "none") && (c4 = true);
      });
      var h = i[0] || (i[0] = {});
      return l4 || (h.color = e2.slice()), !c4 && o && (h.decal = o.slice()), i;
    }
  }
  var Hmt = Gmt, $mt = 8, jCe = 8, vae = 5, Umt = function() {
    function i(n2) {
      this.group = new Ti(), n2.add(this.group);
    }
    return i.prototype.render = function(n2, e2, o, l4) {
      var c4 = n2.getModel("breadcrumb"), h = this.group;
      if (h.removeAll(), !(!c4.get("show") || !o)) {
        var p4 = c4.getModel("itemStyle"), g4 = p4.getModel("textStyle"), y4 = { pos: { left: c4.get("left"), right: c4.get("right"), top: c4.get("top"), bottom: c4.get("bottom") }, box: { width: e2.getWidth(), height: e2.getHeight() }, emptyItemWidth: c4.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
        this._prepare(o, y4, g4), this._renderContent(n2, y4, p4, g4, l4), N$(h, y4.pos, y4.box);
      }
    }, i.prototype._prepare = function(n2, e2, o) {
      for (var l4 = n2; l4; l4 = l4.parentNode) {
        var c4 = yh(l4.getModel().get("name"), ""), h = o.getTextRect(c4), p4 = Math.max(h.width + $mt * 2, e2.emptyItemWidth);
        e2.totalWidth += p4 + jCe, e2.renderList.push({ node: l4, text: c4, width: p4 });
      }
    }, i.prototype._renderContent = function(n2, e2, o, l4, c4) {
      for (var h = 0, p4 = e2.emptyItemWidth, g4 = n2.get(["breadcrumb", "height"]), y4 = tct(e2.pos, e2.box), _ = e2.totalWidth, w4 = e2.renderList, C = w4.length - 1; C >= 0; C--) {
        var E = w4[C], T = E.node, O = E.width, N = E.text;
        _ > y4.width && (_ -= O - p4, O = p4, N = null);
        var V = new $g({ shape: { points: qmt(h, 0, O, g4, C === w4.length - 1, C === 0) }, style: hi(o.getItemStyle(), { lineJoin: "bevel" }), textContent: new Qs({ style: { text: N, fill: l4.getTextColor(), font: l4.getFont() } }), textConfig: { position: "inside" }, z2: $3 * 1e4, onclick: zi(c4, T) });
        V.disableLabelAnimation = true, this.group.add(V), Ymt(V, n2, T), h += O + jCe;
      }
    }, i.prototype.remove = function() {
      this.group.removeAll();
    }, i;
  }();
  function qmt(i, n2, e2, o, l4, c4) {
    var h = [[l4 ? i : i - vae, n2], [i + e2, n2], [i + e2, n2 + o], [l4 ? i : i - vae, n2 + o]];
    return !c4 && h.splice(2, 0, [i + e2 + vae, n2 + o / 2]), !l4 && h.push([i, n2 + o / 2]), h;
  }
  function Ymt(i, n2, e2) {
    Fi(i).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: n2.componentIndex, seriesIndex: n2.seriesIndex, seriesName: n2.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: e2 && e2.dataIndex, name: e2 && e2.name }, treePathInfo: e2 && X$(e2, n2) };
  }
  var Zmt = Umt, Xmt = function() {
    function i() {
      this._storage = [], this._elExistsMap = {};
    }
    return i.prototype.add = function(n2, e2, o, l4, c4) {
      return this._elExistsMap[n2.id] ? false : (this._elExistsMap[n2.id] = true, this._storage.push({ el: n2, target: e2, duration: o, delay: l4, easing: c4 }), true);
    }, i.prototype.finished = function(n2) {
      return this._finishedCallback = n2, this;
    }, i.prototype.start = function() {
      for (var n2 = this, e2 = this._storage.length, o = function() {
        e2--, e2 <= 0 && (n2._storage.length = 0, n2._elExistsMap = {}, n2._finishedCallback && n2._finishedCallback());
      }, l4 = 0, c4 = this._storage.length; l4 < c4; l4++) {
        var h = this._storage[l4];
        h.el.animateTo(h.target, { duration: h.duration, delay: h.delay, easing: h.easing, setToFinal: true, done: o, aborted: o });
      }
      return this;
    }, i;
  }();
  function Kmt() {
    return new Xmt();
  }
  var Poe = Ti, GCe = Is, WCe = 3, HCe = "label", $Ce = "upperLabel", Jmt = $3 * 10, Qmt = $3 * 2, eyt = $3 * 3, qI = bT([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), UCe = function(i) {
    var n2 = qI(i);
    return n2.stroke = n2.fill = n2.lineWidth = null, n2;
  }, ZH = zs(), tyt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._state = "ready", e2._storage = gN(), e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      var h = o.findComponents({ mainType: "series", subType: "treemap", query: c4 });
      if (!(go(h, e2) < 0)) {
        this.seriesModel = e2, this.api = l4, this.ecModel = o;
        var p4 = ["treemapZoomToNode", "treemapRootToNode"], g4 = M8(c4, p4, e2), y4 = c4 && c4.type, _ = e2.layoutInfo, w4 = !this._oldTree, C = this._storage, E = y4 === "treemapRootToNode" && g4 && C ? { rootNodeGroup: C.nodeGroup[g4.node.getRawIndex()], direction: c4.direction } : null, T = this._giveContainerGroup(_), O = e2.get("animation"), N = this._doRender(T, e2, E);
        O && !w4 && (!y4 || y4 === "treemapZoomToNode" || y4 === "treemapRootToNode") ? this._doAnimation(T, N, e2, E) : N.renderFinally(), this._resetController(l4), this._renderBreadcrumb(e2, l4, g4);
      }
    }, n2.prototype._giveContainerGroup = function(e2) {
      var o = this._containerGroup;
      return o || (o = this._containerGroup = new Poe(), this._initEvents(o), this.group.add(o)), o.x = e2.x, o.y = e2.y, o;
    }, n2.prototype._doRender = function(e2, o, l4) {
      var c4 = o.getData().tree, h = this._oldTree, p4 = gN(), g4 = gN(), y4 = this._storage, _ = [];
      function w4(N, V, H, X) {
        return nyt(o, g4, y4, l4, p4, _, N, V, H, X);
      }
      E(c4.root ? [c4.root] : [], h && h.root ? [h.root] : [], e2, c4 === h || !h, 0);
      var C = T(y4);
      return this._oldTree = c4, this._storage = g4, { lastsForAnimation: p4, willDeleteEls: C, renderFinally: O };
      function E(N, V, H, X, q2) {
        X ? (V = N, Ve(N, function(me, ye) {
          !me.isRemoved() && le(ye, ye);
        })) : new x2(V, N, de, de).add(le).update(le).remove(zi(le, null)).execute();
        function de(me) {
          return me.getId();
        }
        function le(me, ye) {
          var be = me != null ? N[me] : null, we = ye != null ? V[ye] : null, Pe = w4(be, we, H, q2);
          Pe && E(be && be.viewChildren || [], we && we.viewChildren || [], Pe, X, q2 + 1);
        }
      }
      function T(N) {
        var V = gN();
        return N && Ve(N, function(H, X) {
          var q2 = V[X];
          Ve(H, function(de) {
            de && (q2.push(de), ZH(de).willDelete = true);
          });
        }), V;
      }
      function O() {
        Ve(C, function(N) {
          Ve(N, function(V) {
            V.parent && V.parent.remove(V);
          });
        }), Ve(_, function(N) {
          N.invisible = true, N.dirty();
        });
      }
    }, n2.prototype._doAnimation = function(e2, o, l4, c4) {
      var h = l4.get("animationDurationUpdate"), p4 = l4.get("animationEasing"), g4 = (si(h) ? 0 : h) || 0, y4 = (si(p4) ? null : p4) || "cubicOut", _ = Kmt();
      Ve(o.willDeleteEls, function(w4, C) {
        Ve(w4, function(E, T) {
          if (!E.invisible) {
            var O = E.parent, N, V = ZH(O);
            if (c4 && c4.direction === "drillDown")
              N = O === c4.rootNodeGroup ? { shape: { x: 0, y: 0, width: V.nodeWidth, height: V.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
            else {
              var H = 0, X = 0;
              V.willDelete || (H = V.nodeWidth / 2, X = V.nodeHeight / 2), N = C === "nodeGroup" ? { x: H, y: X, style: { opacity: 0 } } : { shape: { x: H, y: X, width: 0, height: 0 }, style: { opacity: 0 } };
            }
            N && _.add(E, N, g4, 0, y4);
          }
        });
      }), Ve(this._storage, function(w4, C) {
        Ve(w4, function(E, T) {
          var O = o.lastsForAnimation[C][T], N = {};
          !O || (E instanceof Ti ? O.oldX != null && (N.x = E.x, N.y = E.y, E.x = O.oldX, E.y = O.oldY) : (O.oldShape && (N.shape = rr({}, E.shape), E.setShape(O.oldShape)), O.fadein ? (E.setStyle("opacity", 0), N.style = { opacity: 1 }) : E.style.opacity !== 1 && (N.style = { opacity: 1 })), _.add(E, N, g4, 0, y4));
        });
      }, this), this._state = "animating", _.finished(Ia(function() {
        this._state = "ready", o.renderFinally();
      }, this)).start();
    }, n2.prototype._resetController = function(e2) {
      var o = this._controller;
      o || (o = this._controller = new t9(e2.getZr()), o.enable(this.seriesModel.get("roam")), o.on("pan", Ia(this._onPan, this)), o.on("zoom", Ia(this._onZoom, this)));
      var l4 = new mo(0, 0, e2.getWidth(), e2.getHeight());
      o.setPointerChecker(function(c4, h, p4) {
        return l4.contain(h, p4);
      });
    }, n2.prototype._clearController = function() {
      var e2 = this._controller;
      e2 && (e2.dispose(), e2 = null);
    }, n2.prototype._onPan = function(e2) {
      if (this._state !== "animating" && (Math.abs(e2.dx) > WCe || Math.abs(e2.dy) > WCe)) {
        var o = this.seriesModel.getData().tree.root;
        if (!o)
          return;
        var l4 = o.getLayout();
        if (!l4)
          return;
        this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: l4.x + e2.dx, y: l4.y + e2.dy, width: l4.width, height: l4.height } });
      }
    }, n2.prototype._onZoom = function(e2) {
      var o = e2.originX, l4 = e2.originY;
      if (this._state !== "animating") {
        var c4 = this.seriesModel.getData().tree.root;
        if (!c4)
          return;
        var h = c4.getLayout();
        if (!h)
          return;
        var p4 = new mo(h.x, h.y, h.width, h.height), g4 = this.seriesModel.layoutInfo;
        o -= g4.x, l4 -= g4.y;
        var y4 = Ny();
        Y_(y4, y4, [-o, -l4]), Nse(y4, y4, [e2.scale, e2.scale]), Y_(y4, y4, [o, l4]), p4.applyTransform(y4), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: p4.x, y: p4.y, width: p4.width, height: p4.height } });
      }
    }, n2.prototype._initEvents = function(e2) {
      var o = this;
      e2.on("click", function(l4) {
        if (o._state === "ready") {
          var c4 = o.seriesModel.get("nodeClick", true);
          if (!!c4) {
            var h = o.findTarget(l4.offsetX, l4.offsetY);
            if (!!h) {
              var p4 = h.node;
              if (p4.getLayout().isLeafRoot)
                o._rootToNode(h);
              else if (c4 === "zoomToNode")
                o._zoomToNode(h);
              else if (c4 === "link") {
                var g4 = p4.hostTree.data.getItemModel(p4.dataIndex), y4 = g4.get("link", true), _ = g4.get("target", true) || "blank";
                y4 && PH(y4, _);
              }
            }
          }
        }
      }, this);
    }, n2.prototype._renderBreadcrumb = function(e2, o, l4) {
      var c4 = this;
      l4 || (l4 = e2.get("leafDepth", true) != null ? { node: e2.getViewRoot() } : this.findTarget(o.getWidth() / 2, o.getHeight() / 2), l4 || (l4 = { node: e2.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new Zmt(this.group))).render(e2, o, l4.node, function(h) {
        c4._state !== "animating" && ($le(e2.getViewRoot(), h) ? c4._rootToNode({ node: h }) : c4._zoomToNode({ node: h }));
      });
    }, n2.prototype.remove = function() {
      this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = gN(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
    }, n2.prototype.dispose = function() {
      this._clearController();
    }, n2.prototype._zoomToNode = function(e2) {
      this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e2.node });
    }, n2.prototype._rootToNode = function(e2) {
      this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e2.node });
    }, n2.prototype.findTarget = function(e2, o) {
      var l4, c4 = this.seriesModel.getViewRoot();
      return c4.eachNode({ attr: "viewChildren", order: "preorder" }, function(h) {
        var p4 = this._storage.background[h.getRawIndex()];
        if (p4) {
          var g4 = p4.transformCoordToLocal(e2, o), y4 = p4.shape;
          if (y4.x <= g4[0] && g4[0] <= y4.x + y4.width && y4.y <= g4[1] && g4[1] <= y4.y + y4.height)
            l4 = { node: h, offsetX: g4[0], offsetY: g4[1] };
          else
            return false;
        }
      }, this), l4;
    }, n2.type = "treemap", n2;
  }(Ru);
  function gN() {
    return { nodeGroup: [], background: [], content: [] };
  }
  function nyt(i, n2, e2, o, l4, c4, h, p4, g4, y4) {
    if (!h)
      return;
    var _ = h.getLayout(), w4 = i.getData(), C = h.getModel();
    if (w4.setItemGraphicEl(h.dataIndex, null), !_ || !_.isInView)
      return;
    var E = _.width, T = _.height, O = _.borderWidth, N = _.invisible, V = h.getRawIndex(), H = p4 && p4.getRawIndex(), X = h.viewChildren, q2 = _.upperHeight, de = X && X.length, le = C.getModel("itemStyle"), me = C.getModel(["emphasis", "itemStyle"]), ye = C.getModel(["blur", "itemStyle"]), be = C.getModel(["select", "itemStyle"]), we = le.get("borderRadius") || 0, Pe = ga("nodeGroup", Poe);
    if (!Pe)
      return;
    if (g4.add(Pe), Pe.x = _.x || 0, Pe.y = _.y || 0, Pe.markRedraw(), ZH(Pe).nodeWidth = E, ZH(Pe).nodeHeight = T, _.isAboveViewRoot)
      return Pe;
    var ze = ga("background", GCe, y4, Qmt);
    ze && It(Pe, ze, de && _.upperLabelHeight);
    var Re = C.getModel("emphasis"), rt2 = Re.get("focus"), ft = Re.get("blurScope"), et = Re.get("disabled"), Jt = rt2 === "ancestor" ? h.getAncestorsIndices() : rt2 === "descendant" ? h.getDescendantIndices() : rt2;
    if (de)
      f8(Pe) && aT(Pe, false), ze && (aT(ze, !et), w4.setItemGraphicEl(h.dataIndex, ze), Jie(ze, Jt, ft));
    else {
      var xt = ga("content", GCe, y4, eyt);
      xt && Wt(Pe, xt), ze.disableMorphing = true, ze && f8(ze) && aT(ze, false), aT(Pe, !et), w4.setItemGraphicEl(h.dataIndex, Pe), Jie(Pe, Jt, ft);
    }
    return Pe;
    function It(Pa, da, Ra) {
      var Wa = Fi(da);
      if (Wa.dataIndex = h.dataIndex, Wa.seriesIndex = i.seriesIndex, da.setShape({ x: 0, y: 0, width: E, height: T, r: we }), N)
        sn(da);
      else {
        da.invisible = false;
        var wa = h.getVisual("style"), li = wa.stroke, Ts = UCe(le);
        Ts.fill = li;
        var wi = qI(me);
        wi.fill = me.get("borderColor");
        var ps = qI(ye);
        ps.fill = ye.get("borderColor");
        var Bs = qI(be);
        if (Bs.fill = be.get("borderColor"), Ra) {
          var vl = E - 2 * O;
          vn(da, li, wa.opacity, { x: O, y: 0, width: vl, height: q2 });
        } else
          da.removeTextContent();
        da.setStyle(Ts), da.ensureState("emphasis").style = wi, da.ensureState("blur").style = ps, da.ensureState("select").style = Bs, _T(da);
      }
      Pa.add(da);
    }
    function Wt(Pa, da) {
      var Ra = Fi(da);
      Ra.dataIndex = h.dataIndex, Ra.seriesIndex = i.seriesIndex;
      var Wa = Math.max(E - 2 * O, 0), wa = Math.max(T - 2 * O, 0);
      if (da.culling = true, da.setShape({ x: O, y: O, width: Wa, height: wa, r: we }), N)
        sn(da);
      else {
        da.invisible = false;
        var li = h.getVisual("style"), Ts = li.fill, wi = UCe(le);
        wi.fill = Ts, wi.decal = li.decal;
        var ps = qI(me), Bs = qI(ye), vl = qI(be);
        vn(da, Ts, li.opacity, null), da.setStyle(wi), da.ensureState("emphasis").style = ps, da.ensureState("blur").style = Bs, da.ensureState("select").style = vl, _T(da);
      }
      Pa.add(da);
    }
    function sn(Pa) {
      !Pa.invisible && c4.push(Pa);
    }
    function vn(Pa, da, Ra, Wa) {
      var wa = C.getModel(Wa ? $Ce : HCe), li = yh(C.get("name"), null), Ts = wa.getShallow("show");
      yv(Pa, zd(C, Wa ? $Ce : HCe), { defaultText: Ts ? li : null, inheritColor: da, defaultOpacity: Ra, labelFetcher: i, labelDataIndex: h.dataIndex });
      var wi = Pa.getTextContent();
      if (!!wi) {
        var ps = wi.style, Bs = Pse(ps.padding || 0);
        Wa && (Pa.setTextConfig({ layoutRect: Wa }), wi.disableLabelLayout = true), wi.beforeUpdate = function() {
          var If = Math.max((Wa ? Wa.width : Pa.shape.width) - Bs[1] - Bs[3], 0), Xl = Math.max((Wa ? Wa.height : Pa.shape.height) - Bs[0] - Bs[2], 0);
          (ps.width !== If || ps.height !== Xl) && wi.setStyle({ width: If, height: Xl });
        }, ps.truncateMinChar = 2, ps.lineOverflow = "truncate", $r(ps, Wa, _);
        var vl = wi.getState("emphasis");
        $r(vl ? vl.style : null, Wa, _);
      }
    }
    function $r(Pa, da, Ra) {
      var Wa = Pa ? Pa.text : null;
      if (!da && Ra.isLeafRoot && Wa != null) {
        var wa = i.get("drillDownIcon", true);
        Pa.text = wa ? wa + " " + Wa : Wa;
      }
    }
    function ga(Pa, da, Ra, Wa) {
      var wa = H != null && e2[Pa][H], li = l4[Pa];
      return wa ? (e2[Pa][H] = null, Za(li, wa)) : N || (wa = new da(), wa instanceof Vy && (wa.z2 = ryt(Ra, Wa)), $a(li, wa)), n2[Pa][V] = wa;
    }
    function Za(Pa, da) {
      var Ra = Pa[V] = {};
      da instanceof Poe ? (Ra.oldX = da.x, Ra.oldY = da.y) : Ra.oldShape = rr({}, da.shape);
    }
    function $a(Pa, da) {
      var Ra = Pa[V] = {}, Wa = h.parentNode, wa = da instanceof Ti;
      if (Wa && (!o || o.direction === "drillDown")) {
        var li = 0, Ts = 0, wi = l4.background[Wa.getRawIndex()];
        !o && wi && wi.oldShape && (li = wi.oldShape.width, Ts = wi.oldShape.height), wa ? (Ra.oldX = 0, Ra.oldY = Ts) : Ra.oldShape = { x: li, y: Ts, width: 0, height: 0 };
      }
      Ra.fadein = !wa;
    }
  }
  function ryt(i, n2) {
    return i * Jmt + n2;
  }
  var ayt = tyt, A8 = Ve, iyt = mi, XH = -1, Ule = function() {
    function i(n2) {
      var e2 = n2.mappingMethod, o = n2.type, l4 = this.option = Ci(n2);
      this.type = o, this.mappingMethod = e2, this._normalizeData = lyt[e2];
      var c4 = i.visualHandlers[o];
      this.applyVisual = c4.applyVisual, this.getColorMapper = c4.getColorMapper, this._normalizedToVisual = c4._normalizedToVisual[e2], e2 === "piecewise" ? (gae(l4), oyt(l4)) : e2 === "category" ? l4.categories ? syt(l4) : gae(l4, true) : (Kv(e2 !== "linear" || l4.dataExtent), gae(l4));
    }
    return i.prototype.mapValueToVisual = function(n2) {
      var e2 = this._normalizeData(n2);
      return this._normalizedToVisual(e2, n2);
    }, i.prototype.getNormalizer = function() {
      return Ia(this._normalizeData, this);
    }, i.listVisualTypes = function() {
      return ts(i.visualHandlers);
    }, i.isValidType = function(n2) {
      return i.visualHandlers.hasOwnProperty(n2);
    }, i.eachVisual = function(n2, e2, o) {
      mi(n2) ? Ve(n2, e2, o) : e2.call(o, n2);
    }, i.mapVisual = function(n2, e2, o) {
      var l4, c4 = Mr(n2) ? [] : mi(n2) ? {} : (l4 = true, null);
      return i.eachVisual(n2, function(h, p4) {
        var g4 = e2.call(o, h, p4);
        l4 ? c4 = g4 : c4[p4] = g4;
      }), c4;
    }, i.retrieveVisuals = function(n2) {
      var e2 = {}, o;
      return n2 && A8(i.visualHandlers, function(l4, c4) {
        n2.hasOwnProperty(c4) && (e2[c4] = n2[c4], o = true);
      }), o ? e2 : null;
    }, i.prepareVisualTypes = function(n2) {
      if (Mr(n2))
        n2 = n2.slice();
      else if (iyt(n2)) {
        var e2 = [];
        A8(n2, function(o, l4) {
          e2.push(l4);
        }), n2 = e2;
      } else
        return [];
      return n2.sort(function(o, l4) {
        return l4 === "color" && o !== "color" && o.indexOf("color") === 0 ? 1 : -1;
      }), n2;
    }, i.dependsOn = function(n2, e2) {
      return e2 === "color" ? !!(n2 && n2.indexOf(e2) === 0) : n2 === e2;
    }, i.findPieceIndex = function(n2, e2, o) {
      for (var l4, c4 = 1 / 0, h = 0, p4 = e2.length; h < p4; h++) {
        var g4 = e2[h].value;
        if (g4 != null) {
          if (g4 === n2 || xa(g4) && g4 === n2 + "")
            return h;
          o && C(g4, h);
        }
      }
      for (var h = 0, p4 = e2.length; h < p4; h++) {
        var y4 = e2[h], _ = y4.interval, w4 = y4.close;
        if (_) {
          if (_[0] === -1 / 0) {
            if (IW(w4[1], n2, _[1]))
              return h;
          } else if (_[1] === 1 / 0) {
            if (IW(w4[0], _[0], n2))
              return h;
          } else if (IW(w4[0], _[0], n2) && IW(w4[1], n2, _[1]))
            return h;
          o && C(_[0], h), o && C(_[1], h);
        }
      }
      if (o)
        return n2 === 1 / 0 ? e2.length - 1 : n2 === -1 / 0 ? 0 : l4;
      function C(E, T) {
        var O = Math.abs(E - n2);
        O < c4 && (c4 = O, l4 = T);
      }
    }, i.visualHandlers = { color: { applyVisual: mN("color"), getColorMapper: function() {
      var n2 = this.option;
      return Ia(n2.mappingMethod === "category" ? function(e2, o) {
        return !o && (e2 = this._normalizeData(e2)), RN.call(this, e2);
      } : function(e2, o, l4) {
        var c4 = !!l4;
        return !o && (e2 = this._normalizeData(e2)), l4 = Kne(e2, n2.parsedVisual, l4), c4 ? l4 : d2(l4, "rgba");
      }, this);
    }, _normalizedToVisual: { linear: function(n2) {
      return d2(Kne(n2, this.option.parsedVisual), "rgba");
    }, category: RN, piecewise: function(n2, e2) {
      var o = Ooe.call(this, e2);
      return o == null && (o = d2(Kne(n2, this.option.parsedVisual), "rgba")), o;
    }, fixed: YI } }, colorHue: EW(function(n2, e2) {
      return BN(n2, e2);
    }), colorSaturation: EW(function(n2, e2) {
      return BN(n2, null, e2);
    }), colorLightness: EW(function(n2, e2) {
      return BN(n2, null, null, e2);
    }), colorAlpha: EW(function(n2, e2) {
      return bH(n2, e2);
    }), decal: { applyVisual: mN("decal"), _normalizedToVisual: { linear: null, category: RN, piecewise: null, fixed: null } }, opacity: { applyVisual: mN("opacity"), _normalizedToVisual: Loe([0, 1]) }, liftZ: { applyVisual: mN("liftZ"), _normalizedToVisual: { linear: YI, category: YI, piecewise: YI, fixed: YI } }, symbol: { applyVisual: function(n2, e2, o) {
      var l4 = this.mapValueToVisual(n2);
      o("symbol", l4);
    }, _normalizedToVisual: { linear: qCe, category: RN, piecewise: function(n2, e2) {
      var o = Ooe.call(this, e2);
      return o == null && (o = qCe.call(this, n2)), o;
    }, fixed: YI } }, symbolSize: { applyVisual: mN("symbolSize"), _normalizedToVisual: Loe([0, 1]) } }, i;
  }();
  function oyt(i) {
    var n2 = i.pieceList;
    i.hasSpecialVisual = false, Ve(n2, function(e2, o) {
      e2.originIndex = o, e2.visual != null && (i.hasSpecialVisual = true);
    });
  }
  function syt(i) {
    var n2 = i.categories, e2 = i.categoryMap = {}, o = i.visual;
    if (A8(n2, function(h, p4) {
      e2[h] = p4;
    }), !Mr(o)) {
      var l4 = [];
      mi(o) ? A8(o, function(h, p4) {
        var g4 = e2[p4];
        l4[g4 != null ? g4 : XH] = h;
      }) : l4[XH] = o, o = bPe(i, l4);
    }
    for (var c4 = n2.length - 1; c4 >= 0; c4--)
      o[c4] == null && (delete e2[n2[c4]], n2.pop());
  }
  function gae(i, n2) {
    var e2 = i.visual, o = [];
    mi(e2) ? A8(e2, function(c4) {
      o.push(c4);
    }) : e2 != null && o.push(e2);
    var l4 = { color: 1, symbol: 1 };
    !n2 && o.length === 1 && !l4.hasOwnProperty(i.type) && (o[1] = o[0]), bPe(i, o);
  }
  function EW(i) {
    return { applyVisual: function(n2, e2, o) {
      var l4 = this.mapValueToVisual(n2);
      o("color", i(e2("color"), l4));
    }, _normalizedToVisual: Loe([0, 1]) };
  }
  function qCe(i) {
    var n2 = this.option.visual;
    return n2[Math.round(Tl(i, [0, 1], [0, n2.length - 1], true))] || {};
  }
  function mN(i) {
    return function(n2, e2, o) {
      o(i, this.mapValueToVisual(n2));
    };
  }
  function RN(i) {
    var n2 = this.option.visual;
    return n2[this.option.loop && i !== XH ? i % n2.length : i];
  }
  function YI() {
    return this.option.visual[0];
  }
  function Loe(i) {
    return { linear: function(n2) {
      return Tl(n2, i, this.option.visual, true);
    }, category: RN, piecewise: function(n2, e2) {
      var o = Ooe.call(this, e2);
      return o == null && (o = Tl(n2, i, this.option.visual, true)), o;
    }, fixed: YI };
  }
  function Ooe(i) {
    var n2 = this.option, e2 = n2.pieceList;
    if (n2.hasSpecialVisual) {
      var o = Ule.findPieceIndex(i, e2), l4 = e2[o];
      if (l4 && l4.visual)
        return l4.visual[this.type];
    }
  }
  function bPe(i, n2) {
    return i.visual = n2, i.type === "color" && (i.parsedVisual = Er(n2, function(e2) {
      return nm(e2);
    })), n2;
  }
  var lyt = { linear: function(i) {
    return Tl(i, this.option.dataExtent, [0, 1], true);
  }, piecewise: function(i) {
    var n2 = this.option.pieceList, e2 = Ule.findPieceIndex(i, n2, true);
    if (e2 != null)
      return Tl(e2, [0, n2.length - 1], [0, 1], true);
  }, category: function(i) {
    var n2 = this.option.categories ? this.option.categoryMap[i] : i;
    return n2 == null ? XH : n2;
  }, fixed: Zf };
  function IW(i, n2, e2) {
    return i ? n2 <= e2 : n2 < e2;
  }
  var Cp = Ule, uyt = "itemStyle", _Pe = zs(), cyt = { seriesType: "treemap", reset: function(i) {
    var n2 = i.getData().tree, e2 = n2.root;
    e2.isRemoved() || xPe(e2, {}, i.getViewRoot().getAncestors(), i);
  } };
  function xPe(i, n2, e2, o) {
    var l4 = i.getModel(), c4 = i.getLayout(), h = i.hostTree.data;
    if (!(!c4 || c4.invisible || !c4.isInView)) {
      var p4 = l4.getModel(uyt), g4 = fyt(p4, n2, o), y4 = h.ensureUniqueItemVisual(i.dataIndex, "style"), _ = p4.get("borderColor"), w4 = p4.get("borderColorSaturation"), C;
      w4 != null && (C = YCe(g4), _ = hyt(w4, C)), y4.stroke = _;
      var E = i.viewChildren;
      if (!E || !E.length)
        C = YCe(g4), y4.fill = C;
      else {
        var T = dyt(i, l4, c4, p4, g4, E);
        Ve(E, function(O, N) {
          if (O.depth >= e2.length || O === e2[O.depth]) {
            var V = pyt(l4, g4, O, N, T, o);
            xPe(O, V, e2, o);
          }
        });
      }
    }
  }
  function fyt(i, n2, e2) {
    var o = rr({}, n2), l4 = e2.designatedVisualItemStyle;
    return Ve(["color", "colorAlpha", "colorSaturation"], function(c4) {
      l4[c4] = n2[c4];
      var h = i.get(c4);
      l4[c4] = null, h != null && (o[c4] = h);
    }), o;
  }
  function YCe(i) {
    var n2 = mae(i, "color");
    if (n2) {
      var e2 = mae(i, "colorAlpha"), o = mae(i, "colorSaturation");
      return o && (n2 = BN(n2, null, null, o)), e2 && (n2 = bH(n2, e2)), n2;
    }
  }
  function hyt(i, n2) {
    return n2 != null ? BN(n2, null, null, i) : null;
  }
  function mae(i, n2) {
    var e2 = i[n2];
    if (e2 != null && e2 !== "none")
      return e2;
  }
  function dyt(i, n2, e2, o, l4, c4) {
    if (!(!c4 || !c4.length)) {
      var h = yae(n2, "color") || l4.color != null && l4.color !== "none" && (yae(n2, "colorAlpha") || yae(n2, "colorSaturation"));
      if (!!h) {
        var p4 = n2.get("visualMin"), g4 = n2.get("visualMax"), y4 = e2.dataExtent.slice();
        p4 != null && p4 < y4[0] && (y4[0] = p4), g4 != null && g4 > y4[1] && (y4[1] = g4);
        var _ = n2.get("colorMappingBy"), w4 = { type: h.name, dataExtent: y4, visual: h.range };
        w4.type === "color" && (_ === "index" || _ === "id") ? (w4.mappingMethod = "category", w4.loop = true) : w4.mappingMethod = "linear";
        var C = new Cp(w4);
        return _Pe(C).drColorMappingBy = _, C;
      }
    }
  }
  function yae(i, n2) {
    var e2 = i.get(n2);
    return Mr(e2) && e2.length ? { name: n2, range: e2 } : null;
  }
  function pyt(i, n2, e2, o, l4, c4) {
    var h = rr({}, n2);
    if (l4) {
      var p4 = l4.type, g4 = p4 === "color" && _Pe(l4).drColorMappingBy, y4 = g4 === "index" ? o : g4 === "id" ? c4.mapIdToIndex(e2.getId()) : e2.getValue(i.get("visualDimension"));
      h[p4] = l4.mapValueToVisual(y4);
    }
    return h;
  }
  var E8 = Math.max, KH = Math.min, ZCe = Nd, qle = Ve, wPe = ["itemStyle", "borderWidth"], vyt = ["itemStyle", "gapWidth"], gyt = ["upperLabel", "show"], myt = ["upperLabel", "height"], yyt = { seriesType: "treemap", reset: function(i, n2, e2, o) {
    var l4 = e2.getWidth(), c4 = e2.getHeight(), h = i.option, p4 = bh(i.getBoxLayoutParams(), { width: e2.getWidth(), height: e2.getHeight() }), g4 = h.size || [], y4 = ma(ZCe(p4.width, g4[0]), l4), _ = ma(ZCe(p4.height, g4[1]), c4), w4 = o && o.type, C = ["treemapZoomToNode", "treemapRootToNode"], E = M8(o, C, i), T = w4 === "treemapRender" || w4 === "treemapMove" ? o.rootRect : null, O = i.getViewRoot(), N = gPe(O);
    if (w4 !== "treemapMove") {
      var V = w4 === "treemapZoomToNode" ? Cyt(i, E, O, y4, _) : T ? [T.width, T.height] : [y4, _], H = h.sort;
      H && H !== "asc" && H !== "desc" && (H = "desc");
      var X = { squareRatio: h.squareRatio, sort: H, leafDepth: h.leafDepth };
      O.hostTree.clearLayouts();
      var q2 = { x: 0, y: 0, width: V[0], height: V[1], area: V[0] * V[1] };
      O.setLayout(q2), SPe(O, X, false, 0), q2 = O.getLayout(), qle(N, function(le, me) {
        var ye = (N[me + 1] || O).getValue();
        le.setLayout(rr({ dataExtent: [ye, ye], borderWidth: 0, upperHeight: 0 }, q2));
      });
    }
    var de = i.getData().tree.root;
    de.setLayout(Myt(p4, T, E), true), i.setLayoutInfo(p4), CPe(de, new mo(-p4.x, -p4.y, l4, c4), N, O, 0);
  } };
  function SPe(i, n2, e2, o) {
    var l4, c4;
    if (!i.isRemoved()) {
      var h = i.getLayout();
      l4 = h.width, c4 = h.height;
      var p4 = i.getModel(), g4 = p4.get(wPe), y4 = p4.get(vyt) / 2, _ = MPe(p4), w4 = Math.max(g4, _), C = g4 - y4, E = w4 - y4;
      i.setLayout({ borderWidth: g4, upperHeight: w4, upperLabelHeight: _ }, true), l4 = E8(l4 - 2 * C, 0), c4 = E8(c4 - C - E, 0);
      var T = l4 * c4, O = byt(i, p4, T, n2, e2, o);
      if (!!O.length) {
        var N = { x: C, y: E, width: l4, height: c4 }, V = KH(l4, c4), H = 1 / 0, X = [];
        X.area = 0;
        for (var q2 = 0, de = O.length; q2 < de; ) {
          var le = O[q2];
          X.push(le), X.area += le.getLayout().area;
          var me = Syt(X, V, n2.squareRatio);
          me <= H ? (q2++, H = me) : (X.area -= X.pop().getLayout().area, XCe(X, V, N, y4, false), V = KH(N.width, N.height), X.length = X.area = 0, H = 1 / 0);
        }
        if (X.length && XCe(X, V, N, y4, true), !e2) {
          var ye = p4.get("childrenVisibleMin");
          ye != null && T < ye && (e2 = true);
        }
        for (var q2 = 0, de = O.length; q2 < de; q2++)
          SPe(O[q2], n2, e2, o + 1);
      }
    }
  }
  function byt(i, n2, e2, o, l4, c4) {
    var h = i.children || [], p4 = o.sort;
    p4 !== "asc" && p4 !== "desc" && (p4 = null);
    var g4 = o.leafDepth != null && o.leafDepth <= c4;
    if (l4 && !g4)
      return i.viewChildren = [];
    h = Yl(h, function(E) {
      return !E.isRemoved();
    }), xyt(h, p4);
    var y4 = wyt(n2, h, p4);
    if (y4.sum === 0)
      return i.viewChildren = [];
    if (y4.sum = _yt(n2, e2, y4.sum, p4, h), y4.sum === 0)
      return i.viewChildren = [];
    for (var _ = 0, w4 = h.length; _ < w4; _++) {
      var C = h[_].getValue() / y4.sum * e2;
      h[_].setLayout({ area: C });
    }
    return g4 && (h.length && i.setLayout({ isLeafRoot: true }, true), h.length = 0), i.viewChildren = h, i.setLayout({ dataExtent: y4.dataExtent }, true), h;
  }
  function _yt(i, n2, e2, o, l4) {
    if (!o)
      return e2;
    for (var c4 = i.get("visibleMin"), h = l4.length, p4 = h, g4 = h - 1; g4 >= 0; g4--) {
      var y4 = l4[o === "asc" ? h - g4 - 1 : g4].getValue();
      y4 / e2 * n2 < c4 && (p4 = g4, e2 -= y4);
    }
    return o === "asc" ? l4.splice(0, h - p4) : l4.splice(p4, h - p4), e2;
  }
  function xyt(i, n2) {
    return n2 && i.sort(function(e2, o) {
      var l4 = n2 === "asc" ? e2.getValue() - o.getValue() : o.getValue() - e2.getValue();
      return l4 === 0 ? n2 === "asc" ? e2.dataIndex - o.dataIndex : o.dataIndex - e2.dataIndex : l4;
    }), i;
  }
  function wyt(i, n2, e2) {
    for (var o = 0, l4 = 0, c4 = n2.length; l4 < c4; l4++)
      o += n2[l4].getValue();
    var h = i.get("visualDimension"), p4;
    return !n2 || !n2.length ? p4 = [NaN, NaN] : h === "value" && e2 ? (p4 = [n2[n2.length - 1].getValue(), n2[0].getValue()], e2 === "asc" && p4.reverse()) : (p4 = [1 / 0, -1 / 0], qle(n2, function(g4) {
      var y4 = g4.getValue(h);
      y4 < p4[0] && (p4[0] = y4), y4 > p4[1] && (p4[1] = y4);
    })), { sum: o, dataExtent: p4 };
  }
  function Syt(i, n2, e2) {
    for (var o = 0, l4 = 1 / 0, c4 = 0, h = void 0, p4 = i.length; c4 < p4; c4++)
      h = i[c4].getLayout().area, h && (h < l4 && (l4 = h), h > o && (o = h));
    var g4 = i.area * i.area, y4 = n2 * n2 * e2;
    return g4 ? E8(y4 * o / g4, g4 / (y4 * l4)) : 1 / 0;
  }
  function XCe(i, n2, e2, o, l4) {
    var c4 = n2 === e2.width ? 0 : 1, h = 1 - c4, p4 = ["x", "y"], g4 = ["width", "height"], y4 = e2[p4[c4]], _ = n2 ? i.area / n2 : 0;
    (l4 || _ > e2[g4[h]]) && (_ = e2[g4[h]]);
    for (var w4 = 0, C = i.length; w4 < C; w4++) {
      var E = i[w4], T = {}, O = _ ? E.getLayout().area / _ : 0, N = T[g4[h]] = E8(_ - 2 * o, 0), V = e2[p4[c4]] + e2[g4[c4]] - y4, H = w4 === C - 1 || V < O ? V : O, X = T[g4[c4]] = E8(H - 2 * o, 0);
      T[p4[h]] = e2[p4[h]] + KH(o, N / 2), T[p4[c4]] = y4 + KH(o, X / 2), y4 += H, E.setLayout(T, true);
    }
    e2[p4[h]] += _, e2[g4[h]] -= _;
  }
  function Cyt(i, n2, e2, o, l4) {
    var c4 = (n2 || {}).node, h = [o, l4];
    if (!c4 || c4 === e2)
      return h;
    for (var p4, g4 = o * l4, y4 = g4 * i.option.zoomToNodeRatio; p4 = c4.parentNode; ) {
      for (var _ = 0, w4 = p4.children, C = 0, E = w4.length; C < E; C++)
        _ += w4[C].getValue();
      var T = c4.getValue();
      if (T === 0)
        return h;
      y4 *= _ / T;
      var O = p4.getModel(), N = O.get(wPe), V = Math.max(N, MPe(O));
      y4 += 4 * N * N + (3 * N + V) * Math.pow(y4, 0.5), y4 > swe && (y4 = swe), c4 = p4;
    }
    y4 < g4 && (y4 = g4);
    var H = Math.pow(y4 / g4, 0.5);
    return [o * H, l4 * H];
  }
  function Myt(i, n2, e2) {
    if (n2)
      return { x: n2.x, y: n2.y };
    var o = { x: 0, y: 0 };
    if (!e2)
      return o;
    var l4 = e2.node, c4 = l4.getLayout();
    if (!c4)
      return o;
    for (var h = [c4.width / 2, c4.height / 2], p4 = l4; p4; ) {
      var g4 = p4.getLayout();
      h[0] += g4.x, h[1] += g4.y, p4 = p4.parentNode;
    }
    return { x: i.width / 2 - h[0], y: i.height / 2 - h[1] };
  }
  function CPe(i, n2, e2, o, l4) {
    var c4 = i.getLayout(), h = e2[l4], p4 = h && h === i;
    if (!(h && !p4 || l4 === e2.length && i !== o)) {
      i.setLayout({ isInView: true, invisible: !p4 && !n2.intersect(c4), isAboveViewRoot: p4 }, true);
      var g4 = new mo(n2.x - c4.x, n2.y - c4.y, n2.width, n2.height);
      qle(i.viewChildren || [], function(y4) {
        CPe(y4, g4, e2, o, l4 + 1);
      });
    }
  }
  function MPe(i) {
    return i.get(gyt) ? i.get(myt) : 0;
  }
  function Ayt(i) {
    i.registerSeriesModel(Hmt), i.registerChartView(ayt), i.registerVisual(cyt), i.registerLayout(yyt), jmt(i);
  }
  function Eyt(i) {
    var n2 = i.findComponents({ mainType: "legend" });
    !n2 || !n2.length || i.eachSeriesByType("graph", function(e2) {
      var o = e2.getCategoriesData(), l4 = e2.getGraph(), c4 = l4.data, h = o.mapArray(o.getName);
      c4.filterSelf(function(p4) {
        var g4 = c4.getItemModel(p4), y4 = g4.getShallow("category");
        if (y4 != null) {
          sl(y4) && (y4 = h[y4]);
          for (var _ = 0; _ < n2.length; _++)
            if (!n2[_].isSelected(y4))
              return false;
        }
        return true;
      });
    });
  }
  function Iyt(i) {
    var n2 = {};
    i.eachSeriesByType("graph", function(e2) {
      var o = e2.getCategoriesData(), l4 = e2.getData(), c4 = {};
      o.each(function(h) {
        var p4 = o.getName(h);
        c4["ec-" + p4] = h;
        var g4 = o.getItemModel(h), y4 = g4.getModel("itemStyle").getItemStyle();
        y4.fill || (y4.fill = e2.getColorFromPalette(p4, n2)), o.setItemVisual(h, "style", y4);
        for (var _ = ["symbol", "symbolSize", "symbolKeepAspect"], w4 = 0; w4 < _.length; w4++) {
          var C = g4.getShallow(_[w4], true);
          C != null && o.setItemVisual(h, _[w4], C);
        }
      }), o.count() && l4.each(function(h) {
        var p4 = l4.getItemModel(h), g4 = p4.getShallow("category");
        if (g4 != null) {
          xa(g4) && (g4 = c4["ec-" + g4]);
          var y4 = o.getItemVisual(g4, "style"), _ = l4.ensureUniqueItemVisual(h, "style");
          rr(_, y4);
          for (var w4 = ["symbol", "symbolSize", "symbolKeepAspect"], C = 0; C < w4.length; C++)
            l4.setItemVisual(h, w4[C], o.getItemVisual(g4, w4[C]));
        }
      });
    });
  }
  function TW(i) {
    return i instanceof Array || (i = [i, i]), i;
  }
  function Tyt(i) {
    i.eachSeriesByType("graph", function(n2) {
      var e2 = n2.getGraph(), o = n2.getEdgeData(), l4 = TW(n2.get("edgeSymbol")), c4 = TW(n2.get("edgeSymbolSize"));
      o.setVisual("fromSymbol", l4 && l4[0]), o.setVisual("toSymbol", l4 && l4[1]), o.setVisual("fromSymbolSize", c4 && c4[0]), o.setVisual("toSymbolSize", c4 && c4[1]), o.setVisual("style", n2.getModel("lineStyle").getLineStyle()), o.each(function(h) {
        var p4 = o.getItemModel(h), g4 = e2.getEdgeByIndex(h), y4 = TW(p4.getShallow("symbol", true)), _ = TW(p4.getShallow("symbolSize", true)), w4 = p4.getModel("lineStyle").getLineStyle(), C = o.ensureUniqueItemVisual(h, "style");
        switch (rr(C, w4), C.stroke) {
          case "source": {
            var E = g4.node1.getVisual("style");
            C.stroke = E && E.fill;
            break;
          }
          case "target": {
            var E = g4.node2.getVisual("style");
            C.stroke = E && E.fill;
            break;
          }
        }
        y4[0] && g4.setVisual("fromSymbol", y4[0]), y4[1] && g4.setVisual("toSymbol", y4[1]), _[0] && g4.setVisual("fromSymbolSize", _[0]), _[1] && g4.setVisual("toSymbolSize", _[1]);
      });
    });
  }
  var Roe = "-->", K$ = function(i) {
    return i.get("autoCurveness") || null;
  }, APe = function(i, n2) {
    var e2 = K$(i), o = 20, l4 = [];
    if (sl(e2))
      o = e2;
    else if (Mr(e2)) {
      i.__curvenessList = e2;
      return;
    }
    n2 > o && (o = n2);
    var c4 = o % 2 ? o + 2 : o + 3;
    l4 = [];
    for (var h = 0; h < c4; h++)
      l4.push((h % 2 ? h + 1 : h) / 10 * (h % 2 ? -1 : 1));
    i.__curvenessList = l4;
  }, I8 = function(i, n2, e2) {
    var o = [i.id, i.dataIndex].join("."), l4 = [n2.id, n2.dataIndex].join(".");
    return [e2.uid, o, l4].join(Roe);
  }, EPe = function(i) {
    var n2 = i.split(Roe);
    return [n2[0], n2[2], n2[1]].join(Roe);
  }, Dyt = function(i, n2) {
    var e2 = I8(i.node1, i.node2, n2);
    return n2.__edgeMap[e2];
  }, kyt = function(i, n2) {
    var e2 = Foe(I8(i.node1, i.node2, n2), n2), o = Foe(I8(i.node2, i.node1, n2), n2);
    return e2 + o;
  }, Foe = function(i, n2) {
    var e2 = n2.__edgeMap;
    return e2[i] ? e2[i].length : 0;
  };
  function Pyt(i) {
    !K$(i) || (i.__curvenessList = [], i.__edgeMap = {}, APe(i));
  }
  function Lyt(i, n2, e2, o) {
    if (!!K$(e2)) {
      var l4 = I8(i, n2, e2), c4 = e2.__edgeMap, h = c4[EPe(l4)];
      c4[l4] && !h ? c4[l4].isForward = true : h && c4[l4] && (h.isForward = true, c4[l4].isForward = false), c4[l4] = c4[l4] || [], c4[l4].push(o);
    }
  }
  function Yle(i, n2, e2, o) {
    var l4 = K$(n2), c4 = Mr(l4);
    if (!l4)
      return null;
    var h = Dyt(i, n2);
    if (!h)
      return null;
    for (var p4 = -1, g4 = 0; g4 < h.length; g4++)
      if (h[g4] === e2) {
        p4 = g4;
        break;
      }
    var y4 = kyt(i, n2);
    APe(n2, y4), i.lineStyle = i.lineStyle || {};
    var _ = I8(i.node1, i.node2, n2), w4 = n2.__curvenessList, C = c4 || y4 % 2 ? 0 : 1;
    if (h.isForward)
      return w4[C + p4];
    var E = EPe(_), T = Foe(E, n2), O = w4[p4 + T + C];
    return o ? c4 ? l4 && l4[0] === 0 ? (T + C) % 2 ? O : -O : ((T % 2 ? 0 : 1) + C) % 2 ? O : -O : (T + C) % 2 ? O : -O : w4[p4 + T + C];
  }
  function IPe(i) {
    var n2 = i.coordinateSystem;
    if (!(n2 && n2.type !== "view")) {
      var e2 = i.getGraph();
      e2.eachNode(function(o) {
        var l4 = o.getModel();
        o.setLayout([+l4.get("x"), +l4.get("y")]);
      }), TPe(e2, i);
    }
  }
  function TPe(i, n2) {
    i.eachEdge(function(e2, o) {
      var l4 = f2(e2.getModel().get(["lineStyle", "curveness"]), -Yle(e2, n2, o, true), 0), c4 = h2(e2.node1.getLayout()), h = h2(e2.node2.getLayout()), p4 = [c4, h];
      +l4 && p4.push([(c4[0] + h[0]) / 2 - (c4[1] - h[1]) * l4, (c4[1] + h[1]) / 2 - (h[0] - c4[0]) * l4]), e2.setLayout(p4);
    });
  }
  function Oyt(i, n2) {
    i.eachSeriesByType("graph", function(e2) {
      var o = e2.get("layout"), l4 = e2.coordinateSystem;
      if (l4 && l4.type !== "view") {
        var c4 = e2.getData(), h = [];
        Ve(l4.dimensions, function(C) {
          h = h.concat(c4.mapDimensionsAll(C));
        });
        for (var p4 = 0; p4 < c4.count(); p4++) {
          for (var g4 = [], y4 = false, _ = 0; _ < h.length; _++) {
            var w4 = c4.get(h[_], p4);
            isNaN(w4) || (y4 = true), g4.push(w4);
          }
          y4 ? c4.setItemLayout(p4, l4.dataToPoint(g4)) : c4.setItemLayout(p4, [NaN, NaN]);
        }
        TPe(c4.graph, e2);
      } else
        (!o || o === "none") && IPe(e2);
    });
  }
  function FN(i) {
    var n2 = i.coordinateSystem;
    if (n2.type !== "view")
      return 1;
    var e2 = i.option.nodeScaleRatio, o = n2.scaleX, l4 = n2.getZoom(), c4 = (l4 - 1) * e2 + 1;
    return c4 / o;
  }
  function NN(i) {
    var n2 = i.getVisual("symbolSize");
    return n2 instanceof Array && (n2 = (n2[0] + n2[1]) / 2), +n2;
  }
  var KCe = Math.PI, bae = [];
  function DPe(i, n2) {
    var e2 = i.coordinateSystem;
    if (!(e2 && e2.type !== "view")) {
      var o = e2.getBoundingRect(), l4 = i.getData(), c4 = l4.graph, h = o.width / 2 + o.x, p4 = o.height / 2 + o.y, g4 = Math.min(o.width, o.height) / 2, y4 = l4.count();
      l4.setLayout({ cx: h, cy: p4 }), y4 && (Ryt[n2](i, c4, l4, g4, h, p4, y4), c4.eachEdge(function(_, w4) {
        var C = f2(_.getModel().get(["lineStyle", "curveness"]), Yle(_, i, w4), 0), E = h2(_.node1.getLayout()), T = h2(_.node2.getLayout()), O, N = (E[0] + T[0]) / 2, V = (E[1] + T[1]) / 2;
        +C && (C *= 3, O = [h * C + N * (1 - C), p4 * C + V * (1 - C)]), _.setLayout([E, T, O]);
      }));
    }
  }
  var Ryt = { value: function(i, n2, e2, o, l4, c4, h) {
    var p4 = 0, g4 = e2.getSum("value"), y4 = Math.PI * 2 / (g4 || h);
    n2.eachNode(function(_) {
      var w4 = _.getValue("value"), C = y4 * (g4 ? w4 : 1) / 2;
      p4 += C, _.setLayout([o * Math.cos(p4) + l4, o * Math.sin(p4) + c4]), p4 += C;
    });
  }, symbolSize: function(i, n2, e2, o, l4, c4, h) {
    var p4 = 0;
    bae.length = h;
    var g4 = FN(i);
    n2.eachNode(function(w4) {
      var C = NN(w4);
      isNaN(C) && (C = 2), C < 0 && (C = 0), C *= g4;
      var E = Math.asin(C / 2 / o);
      isNaN(E) && (E = KCe / 2), bae[w4.dataIndex] = E, p4 += E * 2;
    });
    var y4 = (2 * KCe - p4) / h / 2, _ = 0;
    n2.eachNode(function(w4) {
      var C = y4 + bae[w4.dataIndex];
      _ += C, w4.setLayout([o * Math.cos(_) + l4, o * Math.sin(_) + c4]), _ += C;
    });
  } };
  function Fyt(i) {
    i.eachSeriesByType("graph", function(n2) {
      n2.get("layout") === "circular" && DPe(n2, "symbolSize");
    });
  }
  var r3 = Cie;
  function Nyt(i, n2, e2) {
    for (var o = i, l4 = n2, c4 = e2.rect, h = c4.width, p4 = c4.height, g4 = [c4.x + h / 2, c4.y + p4 / 2], y4 = e2.gravity == null ? 0.1 : e2.gravity, _ = 0; _ < o.length; _++) {
      var w4 = o[_];
      w4.p || (w4.p = CT(h * (Math.random() - 0.5) + g4[0], p4 * (Math.random() - 0.5) + g4[1])), w4.pp = h2(w4.p), w4.edges = null;
    }
    var C = e2.friction == null ? 0.6 : e2.friction, E = C, T, O;
    return { warmUp: function() {
      E = C * 0.8;
    }, setFixed: function(N) {
      o[N].fixed = true;
    }, setUnfixed: function(N) {
      o[N].fixed = false;
    }, beforeStep: function(N) {
      T = N;
    }, afterStep: function(N) {
      O = N;
    }, step: function(N) {
      T && T(o, l4);
      for (var V = [], H = o.length, X = 0; X < l4.length; X++) {
        var q2 = l4[X];
        if (!q2.ignoreForceLayout) {
          var de = q2.n1, le = q2.n2;
          nT(V, le.p, de.p);
          var me = Mie(V) - q2.d, ye = le.w / (de.w + le.w);
          isNaN(ye) && (ye = 0), R8(V, V), !de.fixed && r3(de.p, de.p, V, ye * me * E), !le.fixed && r3(le.p, le.p, V, -(1 - ye) * me * E);
        }
      }
      for (var X = 0; X < H; X++) {
        var be = o[X];
        be.fixed || (nT(V, g4, be.p), r3(be.p, be.p, V, y4 * E));
      }
      for (var X = 0; X < H; X++)
        for (var de = o[X], we = X + 1; we < H; we++) {
          var le = o[we];
          nT(V, le.p, de.p);
          var me = Mie(V);
          me === 0 && (jit(V, Math.random() - 0.5, Math.random() - 0.5), me = 1);
          var Pe = (de.rep + le.rep) / me / me;
          !de.fixed && r3(de.pp, de.pp, V, Pe), !le.fixed && r3(le.pp, le.pp, V, -Pe);
        }
      for (var ze = [], X = 0; X < H; X++) {
        var be = o[X];
        be.fixed || (nT(ze, be.p, be.pp), r3(be.p, be.p, ze, E), qv(be.pp, be.p));
      }
      E = E * 0.992;
      var Re = E < 0.01;
      O && O(o, l4, Re), N && N(Re);
    } };
  }
  function Vyt(i) {
    i.eachSeriesByType("graph", function(n2) {
      var e2 = n2.coordinateSystem;
      if (!(e2 && e2.type !== "view"))
        if (n2.get("layout") === "force") {
          var o = n2.preservedPoints || {}, l4 = n2.getGraph(), c4 = l4.data, h = l4.edgeData, p4 = n2.getModel("force"), g4 = p4.get("initLayout");
          n2.preservedPoints ? c4.each(function(X) {
            var q2 = c4.getId(X);
            c4.setItemLayout(X, o[q2] || [NaN, NaN]);
          }) : !g4 || g4 === "none" ? IPe(n2) : g4 === "circular" && DPe(n2, "value");
          var y4 = c4.getDataExtent("value"), _ = h.getDataExtent("value"), w4 = p4.get("repulsion"), C = p4.get("edgeLength"), E = Mr(w4) ? w4 : [w4, w4], T = Mr(C) ? C : [C, C];
          T = [T[1], T[0]];
          var O = c4.mapArray("value", function(X, q2) {
            var de = c4.getItemLayout(q2), le = Tl(X, y4, E);
            return isNaN(le) && (le = (E[0] + E[1]) / 2), { w: le, rep: le, fixed: c4.getItemModel(q2).get("fixed"), p: !de || isNaN(de[0]) || isNaN(de[1]) ? null : de };
          }), N = h.mapArray("value", function(X, q2) {
            var de = l4.getEdgeByIndex(q2), le = Tl(X, _, T);
            isNaN(le) && (le = (T[0] + T[1]) / 2);
            var me = de.getModel(), ye = f2(de.getModel().get(["lineStyle", "curveness"]), -Yle(de, n2, q2, true), 0);
            return { n1: O[de.node1.dataIndex], n2: O[de.node2.dataIndex], d: le, curveness: ye, ignoreForceLayout: me.get("ignoreForceLayout") };
          }), V = e2.getBoundingRect(), H = Nyt(O, N, { rect: V, gravity: p4.get("gravity"), friction: p4.get("friction") });
          H.beforeStep(function(X, q2) {
            for (var de = 0, le = X.length; de < le; de++)
              X[de].fixed && qv(X[de].p, l4.getNodeByIndex(de).getLayout());
          }), H.afterStep(function(X, q2, de) {
            for (var le = 0, me = X.length; le < me; le++)
              X[le].fixed || l4.getNodeByIndex(le).setLayout(X[le].p), o[c4.getId(le)] = X[le].p;
            for (var le = 0, me = q2.length; le < me; le++) {
              var ye = q2[le], be = l4.getEdgeByIndex(le), we = ye.n1.p, Pe = ye.n2.p, ze = be.getLayout();
              ze = ze ? ze.slice() : [], ze[0] = ze[0] || [], ze[1] = ze[1] || [], qv(ze[0], we), qv(ze[1], Pe), +ye.curveness && (ze[2] = [(we[0] + Pe[0]) / 2 - (we[1] - Pe[1]) * ye.curveness, (we[1] + Pe[1]) / 2 - (Pe[0] - we[0]) * ye.curveness]), be.setLayout(ze);
            }
          }), n2.forceLayout = H, n2.preservedPoints = o, H.step();
        } else
          n2.forceLayout = null;
    });
  }
  function zyt(i, n2, e2) {
    var o = rr(i.getBoxLayoutParams(), { aspect: e2 });
    return bh(o, { width: n2.getWidth(), height: n2.getHeight() });
  }
  function Byt(i, n2) {
    var e2 = [];
    return i.eachSeriesByType("graph", function(o) {
      var l4 = o.get("coordinateSystem");
      if (!l4 || l4 === "view") {
        var c4 = o.getData(), h = c4.mapArray(function(N) {
          var V = c4.getItemModel(N);
          return [+V.get("x"), +V.get("y")];
        }), p4 = [], g4 = [];
        C$(h, p4, g4), g4[0] - p4[0] === 0 && (g4[0] += 1, p4[0] -= 1), g4[1] - p4[1] === 0 && (g4[1] += 1, p4[1] -= 1);
        var y4 = (g4[0] - p4[0]) / (g4[1] - p4[1]), _ = zyt(o, n2, y4);
        isNaN(y4) && (p4 = [_.x, _.y], g4 = [_.x + _.width, _.y + _.height]);
        var w4 = g4[0] - p4[0], C = g4[1] - p4[1], E = _.width, T = _.height, O = o.coordinateSystem = new n9();
        O.zoomLimit = o.get("scaleLimit"), O.setBoundingRect(p4[0], p4[1], w4, C), O.setViewRect(_.x, _.y, E, T), O.setCenter(o.get("center")), O.setZoom(o.get("zoom")), e2.push(O);
      }
    }), e2;
  }
  var JCe = Vd.prototype, _ae = I$.prototype, kPe = function() {
    function i() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return i;
  }();
  (function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2;
  })(kPe);
  function xae(i) {
    return isNaN(+i.cpx1) || isNaN(+i.cpy1);
  }
  var jyt = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "ec-line", o;
    }
    return n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new kPe();
    }, n2.prototype.buildPath = function(e2, o) {
      xae(o) ? JCe.buildPath.call(this, e2, o) : _ae.buildPath.call(this, e2, o);
    }, n2.prototype.pointAt = function(e2) {
      return xae(this.shape) ? JCe.pointAt.call(this, e2) : _ae.pointAt.call(this, e2);
    }, n2.prototype.tangentAt = function(e2) {
      var o = this.shape, l4 = xae(o) ? [o.x2 - o.x1, o.y2 - o.y1] : _ae.tangentAt.call(this, e2);
      return R8(l4, l4);
    }, n2;
  }(Eo), Gyt = jyt, wae = ["fromSymbol", "toSymbol"];
  function QCe(i) {
    return "_" + i + "Type";
  }
  function eMe(i, n2, e2) {
    var o = n2.getItemVisual(e2, i);
    if (!(!o || o === "none")) {
      var l4 = n2.getItemVisual(e2, i + "Size"), c4 = n2.getItemVisual(e2, i + "Rotate"), h = n2.getItemVisual(e2, i + "Offset"), p4 = n2.getItemVisual(e2, i + "KeepAspect"), g4 = U8(l4), y4 = nL(h || 0, g4), _ = Xf(o, -g4[0] / 2 + y4[0], -g4[1] / 2 + y4[1], g4[0], g4[1], null, p4);
      return _.__specifiedRotation = c4 == null || isNaN(c4) ? void 0 : +c4 * Math.PI / 180 || 0, _.name = i, _;
    }
  }
  function Wyt(i) {
    var n2 = new Gyt({ name: "line", subPixelOptimize: true });
    return Noe(n2.shape, i), n2;
  }
  function Noe(i, n2) {
    i.x1 = n2[0][0], i.y1 = n2[0][1], i.x2 = n2[1][0], i.y2 = n2[1][1], i.percent = 1;
    var e2 = n2[2];
    e2 ? (i.cpx1 = e2[0], i.cpy1 = e2[1]) : (i.cpx1 = NaN, i.cpy1 = NaN);
  }
  var Hyt = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this) || this;
      return c4._createLine(e2, o, l4), c4;
    }
    return n2.prototype._createLine = function(e2, o, l4) {
      var c4 = e2.hostModel, h = e2.getItemLayout(o), p4 = Wyt(h);
      p4.shape.percent = 0, bc(p4, { shape: { percent: 1 } }, c4, o), this.add(p4), Ve(wae, function(g4) {
        var y4 = eMe(g4, e2, o);
        this.add(y4), this[QCe(g4)] = e2.getItemVisual(o, g4);
      }, this), this._updateCommonStl(e2, o, l4);
    }, n2.prototype.updateData = function(e2, o, l4) {
      var c4 = e2.hostModel, h = this.childOfName("line"), p4 = e2.getItemLayout(o), g4 = { shape: {} };
      Noe(g4.shape, p4), Vs(h, g4, c4, o), Ve(wae, function(y4) {
        var _ = e2.getItemVisual(o, y4), w4 = QCe(y4);
        if (this[w4] !== _) {
          this.remove(this.childOfName(y4));
          var C = eMe(y4, e2, o);
          this.add(C);
        }
        this[w4] = _;
      }, this), this._updateCommonStl(e2, o, l4);
    }, n2.prototype.getLinePath = function() {
      return this.childAt(0);
    }, n2.prototype._updateCommonStl = function(e2, o, l4) {
      var c4 = e2.hostModel, h = this.childOfName("line"), p4 = l4 && l4.emphasisLineStyle, g4 = l4 && l4.blurLineStyle, y4 = l4 && l4.selectLineStyle, _ = l4 && l4.labelStatesModels, w4 = l4 && l4.emphasisDisabled, C = l4 && l4.focus, E = l4 && l4.blurScope;
      if (!l4 || e2.hasItemOption) {
        var T = e2.getItemModel(o), O = T.getModel("emphasis");
        p4 = O.getModel("lineStyle").getLineStyle(), g4 = T.getModel(["blur", "lineStyle"]).getLineStyle(), y4 = T.getModel(["select", "lineStyle"]).getLineStyle(), w4 = O.get("disabled"), C = O.get("focus"), E = O.get("blurScope"), _ = zd(T);
      }
      var N = e2.getItemVisual(o, "style"), V = N.stroke;
      h.useStyle(N), h.style.fill = null, h.style.strokeNoScale = true, h.ensureState("emphasis").style = p4, h.ensureState("blur").style = g4, h.ensureState("select").style = y4, Ve(wae, function(le) {
        var me = this.childOfName(le);
        if (me) {
          me.setColor(V), me.style.opacity = N.opacity;
          for (var ye = 0; ye < Jv.length; ye++) {
            var be = Jv[ye], we = h.getState(be);
            if (we) {
              var Pe = we.style || {}, ze = me.ensureState(be), Re = ze.style || (ze.style = {});
              Pe.stroke != null && (Re[me.__isEmptyBrush ? "stroke" : "fill"] = Pe.stroke), Pe.opacity != null && (Re.opacity = Pe.opacity);
            }
          }
          me.markRedraw();
        }
      }, this);
      var H = c4.getRawValue(o);
      yv(this, _, { labelDataIndex: o, labelFetcher: { getFormattedLabel: function(le, me) {
        return c4.getFormattedLabel(le, me, e2.dataType);
      } }, inheritColor: V || "#000", defaultOpacity: N.opacity, defaultText: (H == null ? e2.getName(o) : isFinite(H) ? df(H) : H) + "" });
      var X = this.getTextContent();
      if (X) {
        var q2 = _.normal;
        X.__align = X.style.align, X.__verticalAlign = X.style.verticalAlign, X.__position = q2.get("position") || "middle";
        var de = q2.get("distance");
        Mr(de) || (de = [de, de]), X.__labelDistance = de;
      }
      this.setTextConfig({ position: null, local: true, inside: false }), pf(this, C, E, w4);
    }, n2.prototype.highlight = function() {
      W_(this);
    }, n2.prototype.downplay = function() {
      H_(this);
    }, n2.prototype.updateLayout = function(e2, o) {
      this.setLinePoints(e2.getItemLayout(o));
    }, n2.prototype.setLinePoints = function(e2) {
      var o = this.childOfName("line");
      Noe(o.shape, e2), o.dirty();
    }, n2.prototype.beforeUpdate = function() {
      var e2 = this, o = e2.childOfName("fromSymbol"), l4 = e2.childOfName("toSymbol"), c4 = e2.getTextContent();
      if (!o && !l4 && (!c4 || c4.ignore))
        return;
      for (var h = 1, p4 = this.parent; p4; )
        p4.scaleX && (h /= p4.scaleX), p4 = p4.parent;
      var g4 = e2.childOfName("line");
      if (!this.__dirty && !g4.__dirty)
        return;
      var y4 = g4.shape.percent, _ = g4.pointAt(0), w4 = g4.pointAt(y4), C = nT([], w4, _);
      R8(C, C);
      function E(we, Pe) {
        var ze = we.__specifiedRotation;
        if (ze == null) {
          var Re = g4.tangentAt(Pe);
          we.attr("rotation", (Pe === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(Re[1], Re[0]));
        } else
          we.attr("rotation", ze);
      }
      if (o && (o.setPosition(_), E(o, 0), o.scaleX = o.scaleY = h * y4, o.markRedraw()), l4 && (l4.setPosition(w4), E(l4, 1), l4.scaleX = l4.scaleY = h * y4, l4.markRedraw()), c4 && !c4.ignore) {
        c4.x = c4.y = 0, c4.originX = c4.originY = 0;
        var T = void 0, O = void 0, N = c4.__labelDistance, V = N[0] * h, H = N[1] * h, X = y4 / 2, q2 = g4.tangentAt(X), de = [q2[1], -q2[0]], le = g4.pointAt(X);
        de[1] > 0 && (de[0] = -de[0], de[1] = -de[1]);
        var me = q2[0] < 0 ? -1 : 1;
        if (c4.__position !== "start" && c4.__position !== "end") {
          var ye = -Math.atan2(q2[1], q2[0]);
          w4[0] < _[0] && (ye = Math.PI + ye), c4.rotation = ye;
        }
        var be = void 0;
        switch (c4.__position) {
          case "insideStartTop":
          case "insideMiddleTop":
          case "insideEndTop":
          case "middle":
            be = -H, O = "bottom";
            break;
          case "insideStartBottom":
          case "insideMiddleBottom":
          case "insideEndBottom":
            be = H, O = "top";
            break;
          default:
            be = 0, O = "middle";
        }
        switch (c4.__position) {
          case "end":
            c4.x = C[0] * V + w4[0], c4.y = C[1] * H + w4[1], T = C[0] > 0.8 ? "left" : C[0] < -0.8 ? "right" : "center", O = C[1] > 0.8 ? "top" : C[1] < -0.8 ? "bottom" : "middle";
            break;
          case "start":
            c4.x = -C[0] * V + _[0], c4.y = -C[1] * H + _[1], T = C[0] > 0.8 ? "right" : C[0] < -0.8 ? "left" : "center", O = C[1] > 0.8 ? "bottom" : C[1] < -0.8 ? "top" : "middle";
            break;
          case "insideStartTop":
          case "insideStart":
          case "insideStartBottom":
            c4.x = V * me + _[0], c4.y = _[1] + be, T = q2[0] < 0 ? "right" : "left", c4.originX = -V * me, c4.originY = -be;
            break;
          case "insideMiddleTop":
          case "insideMiddle":
          case "insideMiddleBottom":
          case "middle":
            c4.x = le[0], c4.y = le[1] + be, T = "center", c4.originY = -be;
            break;
          case "insideEndTop":
          case "insideEnd":
          case "insideEndBottom":
            c4.x = -V * me + w4[0], c4.y = w4[1] + be, T = q2[0] >= 0 ? "right" : "left", c4.originX = V * me, c4.originY = -be;
            break;
        }
        c4.scaleX = c4.scaleY = h, c4.setStyle({ verticalAlign: c4.__verticalAlign || O, align: c4.__align || T });
      }
    }, n2;
  }(Ti), Zle = Hyt, $yt = function() {
    function i(n2) {
      this.group = new Ti(), this._LineCtor = n2 || Zle;
    }
    return i.prototype.updateData = function(n2) {
      var e2 = this;
      this._progressiveEls = null;
      var o = this, l4 = o.group, c4 = o._lineData;
      o._lineData = n2, c4 || l4.removeAll();
      var h = tMe(n2);
      n2.diff(c4).add(function(p4) {
        e2._doAdd(n2, p4, h);
      }).update(function(p4, g4) {
        e2._doUpdate(c4, n2, g4, p4, h);
      }).remove(function(p4) {
        l4.remove(c4.getItemGraphicEl(p4));
      }).execute();
    }, i.prototype.updateLayout = function() {
      var n2 = this._lineData;
      !n2 || n2.eachItemGraphicEl(function(e2, o) {
        e2.updateLayout(n2, o);
      }, this);
    }, i.prototype.incrementalPrepareUpdate = function(n2) {
      this._seriesScope = tMe(n2), this._lineData = null, this.group.removeAll();
    }, i.prototype.incrementalUpdate = function(n2, e2) {
      this._progressiveEls = [];
      function o(p4) {
        !p4.isGroup && !Uyt(p4) && (p4.incremental = true, p4.ensureState("emphasis").hoverLayer = true);
      }
      for (var l4 = n2.start; l4 < n2.end; l4++) {
        var c4 = e2.getItemLayout(l4);
        if (Sae(c4)) {
          var h = new this._LineCtor(e2, l4, this._seriesScope);
          h.traverse(o), this.group.add(h), e2.setItemGraphicEl(l4, h), this._progressiveEls.push(h);
        }
      }
    }, i.prototype.remove = function() {
      this.group.removeAll();
    }, i.prototype.eachRendered = function(n2) {
      oM(this._progressiveEls || this.group, n2);
    }, i.prototype._doAdd = function(n2, e2, o) {
      var l4 = n2.getItemLayout(e2);
      if (!!Sae(l4)) {
        var c4 = new this._LineCtor(n2, e2, o);
        n2.setItemGraphicEl(e2, c4), this.group.add(c4);
      }
    }, i.prototype._doUpdate = function(n2, e2, o, l4, c4) {
      var h = n2.getItemGraphicEl(o);
      if (!Sae(e2.getItemLayout(l4))) {
        this.group.remove(h);
        return;
      }
      h ? h.updateData(e2, l4, c4) : h = new this._LineCtor(e2, l4, c4), e2.setItemGraphicEl(l4, h), this.group.add(h);
    }, i;
  }();
  function Uyt(i) {
    return i.animators && i.animators.length > 0;
  }
  function tMe(i) {
    var n2 = i.hostModel, e2 = n2.getModel("emphasis");
    return { lineStyle: n2.getModel("lineStyle").getLineStyle(), emphasisLineStyle: e2.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: n2.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: n2.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: e2.get("disabled"), blurScope: e2.get("blurScope"), focus: e2.get("focus"), labelStatesModels: zd(n2) };
  }
  function nMe(i) {
    return isNaN(i[0]) || isNaN(i[1]);
  }
  function Sae(i) {
    return i && !nMe(i[0]) && !nMe(i[1]);
  }
  var Xle = $yt, Cae = [], Mae = [], Aae = [], a3 = Fd, Eae = lT, rMe = Math.abs;
  function aMe(i, n2, e2) {
    for (var o = i[0], l4 = i[1], c4 = i[2], h = 1 / 0, p4, g4 = e2 * e2, y4 = 0.1, _ = 0.1; _ <= 0.9; _ += 0.1) {
      Cae[0] = a3(o[0], l4[0], c4[0], _), Cae[1] = a3(o[1], l4[1], c4[1], _);
      var w4 = rMe(Eae(Cae, n2) - g4);
      w4 < h && (h = w4, p4 = _);
    }
    for (var C = 0; C < 32; C++) {
      var E = p4 + y4;
      Mae[0] = a3(o[0], l4[0], c4[0], p4), Mae[1] = a3(o[1], l4[1], c4[1], p4), Aae[0] = a3(o[0], l4[0], c4[0], E), Aae[1] = a3(o[1], l4[1], c4[1], E);
      var w4 = Eae(Mae, n2) - g4;
      if (rMe(w4) < 0.01)
        break;
      var T = Eae(Aae, n2) - g4;
      y4 /= 2, w4 < 0 ? T >= 0 ? p4 = p4 + y4 : p4 = p4 - y4 : T >= 0 ? p4 = p4 - y4 : p4 = p4 + y4;
    }
    return p4;
  }
  function Iae(i, n2) {
    var e2 = [], o = o8, l4 = [[], [], []], c4 = [[], []], h = [];
    n2 /= 2, i.eachEdge(function(p4, g4) {
      var y4 = p4.getLayout(), _ = p4.getVisual("fromSymbol"), w4 = p4.getVisual("toSymbol");
      y4.__original || (y4.__original = [h2(y4[0]), h2(y4[1])], y4[2] && y4.__original.push(h2(y4[2])));
      var C = y4.__original;
      if (y4[2] != null) {
        if (qv(l4[0], C[0]), qv(l4[1], C[2]), qv(l4[2], C[1]), _ && _ !== "none") {
          var E = NN(p4.node1), T = aMe(l4, C[0], E * n2);
          o(l4[0][0], l4[1][0], l4[2][0], T, e2), l4[0][0] = e2[3], l4[1][0] = e2[4], o(l4[0][1], l4[1][1], l4[2][1], T, e2), l4[0][1] = e2[3], l4[1][1] = e2[4];
        }
        if (w4 && w4 !== "none") {
          var E = NN(p4.node2), T = aMe(l4, C[1], E * n2);
          o(l4[0][0], l4[1][0], l4[2][0], T, e2), l4[1][0] = e2[1], l4[2][0] = e2[2], o(l4[0][1], l4[1][1], l4[2][1], T, e2), l4[1][1] = e2[1], l4[2][1] = e2[2];
        }
        qv(y4[0], l4[0]), qv(y4[1], l4[2]), qv(y4[2], l4[1]);
      } else {
        if (qv(c4[0], C[0]), qv(c4[1], C[1]), nT(h, c4[1], c4[0]), R8(h, h), _ && _ !== "none") {
          var E = NN(p4.node1);
          Cie(c4[0], c4[0], h, E * n2);
        }
        if (w4 && w4 !== "none") {
          var E = NN(p4.node2);
          Cie(c4[1], c4[1], h, -E * n2);
        }
        qv(y4[0], c4[0]), qv(y4[1], c4[1]);
      }
    });
  }
  function iMe(i) {
    return i.type === "view";
  }
  var qyt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o) {
      var l4 = new K8(), c4 = new Xle(), h = this.group;
      this._controller = new t9(o.getZr()), this._controllerHost = { target: h }, h.add(l4.group), h.add(c4.group), this._symbolDraw = l4, this._lineDraw = c4, this._firstRender = true;
    }, n2.prototype.render = function(e2, o, l4) {
      var c4 = this, h = e2.coordinateSystem;
      this._model = e2;
      var p4 = this._symbolDraw, g4 = this._lineDraw, y4 = this.group;
      if (iMe(h)) {
        var _ = { x: h.x, y: h.y, scaleX: h.scaleX, scaleY: h.scaleY };
        this._firstRender ? y4.attr(_) : Vs(y4, _, e2);
      }
      Iae(e2.getGraph(), FN(e2));
      var w4 = e2.getData();
      p4.updateData(w4);
      var C = e2.getEdgeData();
      g4.updateData(C), this._updateNodeAndLinkScale(), this._updateController(e2, o, l4), clearTimeout(this._layoutTimeout);
      var E = e2.forceLayout, T = e2.get(["force", "layoutAnimation"]);
      E && this._startForceLayoutIteration(E, T), w4.graph.eachNode(function(H) {
        var X = H.dataIndex, q2 = H.getGraphicEl(), de = H.getModel();
        if (!!q2) {
          q2.off("drag").off("dragend");
          var le = de.get("draggable");
          le && q2.on("drag", function() {
            E && (E.warmUp(), !c4._layouting && c4._startForceLayoutIteration(E, T), E.setFixed(X), w4.setItemLayout(X, [q2.x, q2.y]));
          }).on("dragend", function() {
            E && E.setUnfixed(X);
          }), q2.setDraggable(le && !!E);
          var me = de.get(["emphasis", "focus"]);
          me === "adjacency" && (Fi(q2).focus = H.getAdjacentDataIndices());
        }
      }), w4.graph.eachEdge(function(H) {
        var X = H.getGraphicEl(), q2 = H.getModel().get(["emphasis", "focus"]);
        !X || q2 === "adjacency" && (Fi(X).focus = { edge: [H.dataIndex], node: [H.node1.dataIndex, H.node2.dataIndex] });
      });
      var O = e2.get("layout") === "circular" && e2.get(["circular", "rotateLabel"]), N = w4.getLayout("cx"), V = w4.getLayout("cy");
      w4.eachItemGraphicEl(function(H, X) {
        var q2 = w4.getItemModel(X), de = q2.get(["label", "rotate"]) || 0, le = H.getSymbolPath();
        if (O) {
          var me = w4.getItemLayout(X), ye = Math.atan2(me[1] - V, me[0] - N);
          ye < 0 && (ye = Math.PI * 2 + ye);
          var be = me[0] < N;
          be && (ye = ye - Math.PI);
          var we = be ? "left" : "right";
          le.setTextConfig({ rotation: -ye, position: we, origin: "center" });
          var Pe = le.ensureState("emphasis");
          rr(Pe.textConfig || (Pe.textConfig = {}), { position: we });
        } else
          le.setTextConfig({ rotation: de *= Math.PI / 180 });
      }), this._firstRender = false;
    }, n2.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, n2.prototype._startForceLayoutIteration = function(e2, o) {
      var l4 = this;
      (function c4() {
        e2.step(function(h) {
          l4.updateLayout(l4._model), (l4._layouting = !h) && (o ? l4._layoutTimeout = setTimeout(c4, 16) : c4());
        });
      })();
    }, n2.prototype._updateController = function(e2, o, l4) {
      var c4 = this, h = this._controller, p4 = this._controllerHost, g4 = this.group;
      if (h.setPointerChecker(function(y4, _, w4) {
        var C = g4.getBoundingRect();
        return C.applyTransform(g4.transform), C.contain(_, w4) && !Y$(y4, l4, e2);
      }), !iMe(e2.coordinateSystem)) {
        h.disable();
        return;
      }
      h.enable(e2.get("roam")), p4.zoomLimit = e2.get("scaleLimit"), p4.zoom = e2.coordinateSystem.getZoom(), h.off("pan").off("zoom").on("pan", function(y4) {
        zle(p4, y4.dx, y4.dy), l4.dispatchAction({ seriesId: e2.id, type: "graphRoam", dx: y4.dx, dy: y4.dy });
      }).on("zoom", function(y4) {
        Ble(p4, y4.scale, y4.originX, y4.originY), l4.dispatchAction({ seriesId: e2.id, type: "graphRoam", zoom: y4.scale, originX: y4.originX, originY: y4.originY }), c4._updateNodeAndLinkScale(), Iae(e2.getGraph(), FN(e2)), c4._lineDraw.updateLayout(), l4.updateLabelLayout();
      });
    }, n2.prototype._updateNodeAndLinkScale = function() {
      var e2 = this._model, o = e2.getData(), l4 = FN(e2);
      o.eachItemGraphicEl(function(c4, h) {
        c4 && c4.setSymbolScale(l4);
      });
    }, n2.prototype.updateLayout = function(e2) {
      Iae(e2.getGraph(), FN(e2)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
    }, n2.prototype.remove = function(e2, o) {
      this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
    }, n2.type = "graph", n2;
  }(Ru), Yyt = qyt;
  function i3(i) {
    return "_EC_" + i;
  }
  var Zyt = function() {
    function i(n2) {
      this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = n2 || false;
    }
    return i.prototype.isDirected = function() {
      return this._directed;
    }, i.prototype.addNode = function(n2, e2) {
      n2 = n2 == null ? "" + e2 : "" + n2;
      var o = this._nodesMap;
      if (!o[i3(n2)]) {
        var l4 = new ZI(n2, e2);
        return l4.hostGraph = this, this.nodes.push(l4), o[i3(n2)] = l4, l4;
      }
    }, i.prototype.getNodeByIndex = function(n2) {
      var e2 = this.data.getRawIndex(n2);
      return this.nodes[e2];
    }, i.prototype.getNodeById = function(n2) {
      return this._nodesMap[i3(n2)];
    }, i.prototype.addEdge = function(n2, e2, o) {
      var l4 = this._nodesMap, c4 = this._edgesMap;
      if (sl(n2) && (n2 = this.nodes[n2]), sl(e2) && (e2 = this.nodes[e2]), n2 instanceof ZI || (n2 = l4[i3(n2)]), e2 instanceof ZI || (e2 = l4[i3(e2)]), !(!n2 || !e2)) {
        var h = n2.id + "-" + e2.id, p4 = new PPe(n2, e2, o);
        return p4.hostGraph = this, this._directed && (n2.outEdges.push(p4), e2.inEdges.push(p4)), n2.edges.push(p4), n2 !== e2 && e2.edges.push(p4), this.edges.push(p4), c4[h] = p4, p4;
      }
    }, i.prototype.getEdgeByIndex = function(n2) {
      var e2 = this.edgeData.getRawIndex(n2);
      return this.edges[e2];
    }, i.prototype.getEdge = function(n2, e2) {
      n2 instanceof ZI && (n2 = n2.id), e2 instanceof ZI && (e2 = e2.id);
      var o = this._edgesMap;
      return this._directed ? o[n2 + "-" + e2] : o[n2 + "-" + e2] || o[e2 + "-" + n2];
    }, i.prototype.eachNode = function(n2, e2) {
      for (var o = this.nodes, l4 = o.length, c4 = 0; c4 < l4; c4++)
        o[c4].dataIndex >= 0 && n2.call(e2, o[c4], c4);
    }, i.prototype.eachEdge = function(n2, e2) {
      for (var o = this.edges, l4 = o.length, c4 = 0; c4 < l4; c4++)
        o[c4].dataIndex >= 0 && o[c4].node1.dataIndex >= 0 && o[c4].node2.dataIndex >= 0 && n2.call(e2, o[c4], c4);
    }, i.prototype.breadthFirstTraverse = function(n2, e2, o, l4) {
      if (e2 instanceof ZI || (e2 = this._nodesMap[i3(e2)]), !!e2) {
        for (var c4 = o === "out" ? "outEdges" : o === "in" ? "inEdges" : "edges", h = 0; h < this.nodes.length; h++)
          this.nodes[h].__visited = false;
        if (!n2.call(l4, e2, null))
          for (var p4 = [e2]; p4.length; )
            for (var g4 = p4.shift(), y4 = g4[c4], h = 0; h < y4.length; h++) {
              var _ = y4[h], w4 = _.node1 === g4 ? _.node2 : _.node1;
              if (!w4.__visited) {
                if (n2.call(l4, w4, g4))
                  return;
                p4.push(w4), w4.__visited = true;
              }
            }
      }
    }, i.prototype.update = function() {
      for (var n2 = this.data, e2 = this.edgeData, o = this.nodes, l4 = this.edges, c4 = 0, h = o.length; c4 < h; c4++)
        o[c4].dataIndex = -1;
      for (var c4 = 0, h = n2.count(); c4 < h; c4++)
        o[n2.getRawIndex(c4)].dataIndex = c4;
      e2.filterSelf(function(p4) {
        var g4 = l4[e2.getRawIndex(p4)];
        return g4.node1.dataIndex >= 0 && g4.node2.dataIndex >= 0;
      });
      for (var c4 = 0, h = l4.length; c4 < h; c4++)
        l4[c4].dataIndex = -1;
      for (var c4 = 0, h = e2.count(); c4 < h; c4++)
        l4[e2.getRawIndex(c4)].dataIndex = c4;
    }, i.prototype.clone = function() {
      for (var n2 = new i(this._directed), e2 = this.nodes, o = this.edges, l4 = 0; l4 < e2.length; l4++)
        n2.addNode(e2[l4].id, e2[l4].dataIndex);
      for (var l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        n2.addEdge(c4.node1.id, c4.node2.id, c4.dataIndex);
      }
      return n2;
    }, i;
  }(), ZI = function() {
    function i(n2, e2) {
      this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = n2 == null ? "" : n2, this.dataIndex = e2 == null ? -1 : e2;
    }
    return i.prototype.degree = function() {
      return this.edges.length;
    }, i.prototype.inDegree = function() {
      return this.inEdges.length;
    }, i.prototype.outDegree = function() {
      return this.outEdges.length;
    }, i.prototype.getModel = function(n2) {
      if (!(this.dataIndex < 0)) {
        var e2 = this.hostGraph, o = e2.data.getItemModel(this.dataIndex);
        return o.getModel(n2);
      }
    }, i.prototype.getAdjacentDataIndices = function() {
      for (var n2 = { edge: [], node: [] }, e2 = 0; e2 < this.edges.length; e2++) {
        var o = this.edges[e2];
        o.dataIndex < 0 || (n2.edge.push(o.dataIndex), n2.node.push(o.node1.dataIndex, o.node2.dataIndex));
      }
      return n2;
    }, i;
  }(), PPe = function() {
    function i(n2, e2, o) {
      this.dataIndex = -1, this.node1 = n2, this.node2 = e2, this.dataIndex = o == null ? -1 : o;
    }
    return i.prototype.getModel = function(n2) {
      if (!(this.dataIndex < 0)) {
        var e2 = this.hostGraph, o = e2.edgeData.getItemModel(this.dataIndex);
        return o.getModel(n2);
      }
    }, i.prototype.getAdjacentDataIndices = function() {
      return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
    }, i;
  }();
  function LPe(i, n2) {
    return { getValue: function(e2) {
      var o = this[i][n2];
      return o.getStore().get(o.getDimensionIndex(e2 || "value"), this.dataIndex);
    }, setVisual: function(e2, o) {
      this.dataIndex >= 0 && this[i][n2].setItemVisual(this.dataIndex, e2, o);
    }, getVisual: function(e2) {
      return this[i][n2].getItemVisual(this.dataIndex, e2);
    }, setLayout: function(e2, o) {
      this.dataIndex >= 0 && this[i][n2].setItemLayout(this.dataIndex, e2, o);
    }, getLayout: function() {
      return this[i][n2].getItemLayout(this.dataIndex);
    }, getGraphicEl: function() {
      return this[i][n2].getItemGraphicEl(this.dataIndex);
    }, getRawIndex: function() {
      return this[i][n2].getRawIndex(this.dataIndex);
    } };
  }
  Kf(ZI, LPe("hostGraph", "data"));
  Kf(PPe, LPe("hostGraph", "edgeData"));
  var Xyt = Zyt;
  function OPe(i, n2, e2, o, l4) {
    for (var c4 = new Xyt(o), h = 0; h < i.length; h++)
      c4.addNode(Nd(i[h].id, i[h].name, h), h);
    for (var p4 = [], g4 = [], y4 = 0, h = 0; h < n2.length; h++) {
      var _ = n2[h], w4 = _.source, C = _.target;
      c4.addEdge(w4, C, y4) && (g4.push(_), p4.push(Nd(yh(_.id, null), w4 + " > " + C)), y4++);
    }
    var E = e2.get("coordinateSystem"), T;
    if (E === "cartesian2d" || E === "polar")
      T = M2(i, e2);
    else {
      var O = H8.get(E), N = O ? O.dimensions || [] : [];
      go(N, "value") < 0 && N.concat(["value"]);
      var V = q8(i, { coordDimensions: N, encodeDefine: e2.getEncode() }).dimensions;
      T = new Xv(V, e2), T.initData(i);
    }
    var H = new Xv(["value"], e2);
    return H.initData(g4, p4), l4 && l4(T, H), pPe({ mainData: T, struct: c4, structAttr: "graph", datas: { node: T, edge: H }, datasAttr: { node: "data", edge: "edgeData" } }), c4.update(), c4;
  }
  var Kyt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.hasSymbolVisual = true, e2;
    }
    return n2.prototype.init = function(e2) {
      i.prototype.init.apply(this, arguments);
      var o = this;
      function l4() {
        return o._categoriesData;
      }
      this.legendVisualProvider = new e9(l4, l4), this.fillDataTextStyle(e2.edges || e2.links), this._updateCategoriesData();
    }, n2.prototype.mergeOption = function(e2) {
      i.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(e2.edges || e2.links), this._updateCategoriesData();
    }, n2.prototype.mergeDefaultAndTheme = function(e2) {
      i.prototype.mergeDefaultAndTheme.apply(this, arguments), mT(e2, "edgeLabel", ["show"]);
    }, n2.prototype.getInitialData = function(e2, o) {
      var l4 = e2.edges || e2.links || [], c4 = e2.data || e2.nodes || [], h = this;
      if (c4 && l4) {
        Pyt(this);
        var p4 = OPe(c4, l4, this, true, g4);
        return Ve(p4.edges, function(y4) {
          Lyt(y4.node1, y4.node2, this, y4.dataIndex);
        }, this), p4.data;
      }
      function g4(y4, _) {
        y4.wrapMethod("getItemModel", function(T) {
          var O = h._categoriesModels, N = T.getShallow("category"), V = O[N];
          return V && (V.parentModel = T.parentModel, T.parentModel = V), T;
        });
        var w4 = Ou.prototype.getModel;
        function C(T, O) {
          var N = w4.call(this, T, O);
          return N.resolveParentPath = E, N;
        }
        _.wrapMethod("getItemModel", function(T) {
          return T.resolveParentPath = E, T.getModel = C, T;
        });
        function E(T) {
          if (T && (T[0] === "label" || T[1] === "label")) {
            var O = T.slice();
            return T[0] === "label" ? O[0] = "edgeLabel" : T[1] === "label" && (O[1] = "edgeLabel"), O;
          }
          return T;
        }
      }
    }, n2.prototype.getGraph = function() {
      return this.getData().graph;
    }, n2.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, n2.prototype.getCategoriesData = function() {
      return this._categoriesData;
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      if (l4 === "edge") {
        var c4 = this.getData(), h = this.getDataParams(e2, l4), p4 = c4.graph.getEdgeByIndex(e2), g4 = c4.getName(p4.node1.dataIndex), y4 = c4.getName(p4.node2.dataIndex), _ = [];
        return g4 != null && _.push(g4), y4 != null && _.push(y4), Qh("nameValue", { name: _.join(" > "), value: h.value, noValue: h.value == null });
      }
      var w4 = n5e({ series: this, dataIndex: e2, multipleSeries: o });
      return w4;
    }, n2.prototype._updateCategoriesData = function() {
      var e2 = Er(this.option.categories || [], function(l4) {
        return l4.value != null ? l4 : rr({ value: 0 }, l4);
      }), o = new Xv(["value"], this);
      o.initData(e2), this._categoriesData = o, this._categoriesModels = o.mapArray(function(l4) {
        return o.getItemModel(l4);
      });
    }, n2.prototype.setZoom = function(e2) {
      this.option.zoom = e2;
    }, n2.prototype.setCenter = function(e2) {
      this.option.center = e2;
    }, n2.prototype.isAnimationEnabled = function() {
      return i.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
    }, n2.type = "series.graph", n2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], n2.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, n2;
  }(_c2), Jyt = Kyt, Qyt = { type: "graphRoam", event: "graphRoam", update: "none" };
  function e1t(i) {
    i.registerChartView(Yyt), i.registerSeriesModel(Jyt), i.registerProcessor(Eyt), i.registerVisual(Iyt), i.registerVisual(Tyt), i.registerLayout(Oyt), i.registerLayout(i.PRIORITY.VISUAL.POST_CHART_LAYOUT, Fyt), i.registerLayout(Vyt), i.registerCoordinateSystem("graphView", { dimensions: n9.dimensions, create: Byt }), i.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, Zf), i.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, Zf), i.registerAction(Qyt, function(n2, e2) {
      e2.eachComponent({ mainType: "series", query: n2 }, function(o) {
        var l4 = o.coordinateSystem, c4 = Gle(l4, n2);
        o.setCenter && o.setCenter(c4.center), o.setZoom && o.setZoom(c4.zoom);
      });
    });
  }
  var t1t = function() {
    function i() {
      this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
    }
    return i;
  }(), n1t = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "pointer", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new t1t();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = Math.cos, c4 = Math.sin, h = o.r, p4 = o.width, g4 = o.angle, y4 = o.x - l4(g4) * p4 * (p4 >= h / 3 ? 1 : 2), _ = o.y - c4(g4) * p4 * (p4 >= h / 3 ? 1 : 2);
      g4 = o.angle - Math.PI / 2, e2.moveTo(y4, _), e2.lineTo(o.x + l4(g4) * p4, o.y + c4(g4) * p4), e2.lineTo(o.x + l4(o.angle) * h, o.y + c4(o.angle) * h), e2.lineTo(o.x - l4(g4) * p4, o.y - c4(g4) * p4), e2.lineTo(y4, _);
    }, n2;
  }(Eo), r1t = n1t;
  function a1t(i, n2) {
    var e2 = i.get("center"), o = n2.getWidth(), l4 = n2.getHeight(), c4 = Math.min(o, l4), h = ma(e2[0], n2.getWidth()), p4 = ma(e2[1], n2.getHeight()), g4 = ma(i.get("radius"), c4 / 2);
    return { cx: h, cy: p4, r: g4 };
  }
  function DW(i, n2) {
    var e2 = i == null ? "" : i + "";
    return n2 && (xa(n2) ? e2 = n2.replace("{value}", e2) : si(n2) && (e2 = n2(i))), e2;
  }
  var Tae = Math.PI * 2, i1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      this.group.removeAll();
      var c4 = e2.get(["axisLine", "lineStyle", "color"]), h = a1t(e2, l4);
      this._renderMain(e2, o, l4, c4, h), this._data = e2.getData();
    }, n2.prototype.dispose = function() {
    }, n2.prototype._renderMain = function(e2, o, l4, c4, h) {
      for (var p4 = this.group, g4 = e2.get("clockwise"), y4 = -e2.get("startAngle") / 180 * Math.PI, _ = -e2.get("endAngle") / 180 * Math.PI, w4 = e2.getModel("axisLine"), C = w4.get("roundCap"), E = C ? UH : Hg, T = w4.get("show"), O = w4.getModel("lineStyle"), N = O.get("width"), V = !((_ - y4) % Tae) && _ !== y4 ? Tae : (_ - y4) % Tae, H = y4, X = 0; T && X < c4.length; X++) {
        var q2 = Math.min(Math.max(c4[X][0], 0), 1);
        _ = y4 + V * q2;
        var de = new E({ shape: { startAngle: H, endAngle: _, cx: h.cx, cy: h.cy, clockwise: g4, r0: h.r - N, r: h.r }, silent: true });
        de.setStyle({ fill: c4[X][1] }), de.setStyle(O.getLineStyle(["color", "width"])), p4.add(de), H = _;
      }
      var le = function(ye) {
        if (ye <= 0)
          return c4[0][1];
        var be;
        for (be = 0; be < c4.length; be++)
          if (c4[be][0] >= ye && (be === 0 ? 0 : c4[be - 1][0]) < ye)
            return c4[be][1];
        return c4[be - 1][1];
      };
      if (!g4) {
        var me = y4;
        y4 = _, _ = me;
      }
      this._renderTicks(e2, o, l4, le, h, y4, _, g4, N), this._renderTitleAndDetail(e2, o, l4, le, h), this._renderAnchor(e2, h), this._renderPointer(e2, o, l4, le, h, y4, _, g4, N);
    }, n2.prototype._renderTicks = function(e2, o, l4, c4, h, p4, g4, y4, _) {
      for (var w4 = this.group, C = h.cx, E = h.cy, T = h.r, O = +e2.get("min"), N = +e2.get("max"), V = e2.getModel("splitLine"), H = e2.getModel("axisTick"), X = e2.getModel("axisLabel"), q2 = e2.get("splitNumber"), de = H.get("splitNumber"), le = ma(V.get("length"), T), me = ma(H.get("length"), T), ye = p4, be = (g4 - p4) / q2, we = be / de, Pe = V.getModel("lineStyle").getLineStyle(), ze = H.getModel("lineStyle").getLineStyle(), Re = V.get("distance"), rt2, ft, et = 0; et <= q2; et++) {
        if (rt2 = Math.cos(ye), ft = Math.sin(ye), V.get("show")) {
          var Jt = Re ? Re + _ : _, xt = new Vd({ shape: { x1: rt2 * (T - Jt) + C, y1: ft * (T - Jt) + E, x2: rt2 * (T - le - Jt) + C, y2: ft * (T - le - Jt) + E }, style: Pe, silent: true });
          Pe.stroke === "auto" && xt.setStyle({ stroke: c4(et / q2) }), w4.add(xt);
        }
        if (X.get("show")) {
          var Jt = X.get("distance") + Re, It = DW(df(et / q2 * (N - O) + O), X.get("formatter")), Wt = c4(et / q2);
          w4.add(new Qs({ style: Ef(X, { text: It, x: rt2 * (T - le - Jt) + C, y: ft * (T - le - Jt) + E, verticalAlign: ft < -0.8 ? "top" : ft > 0.8 ? "bottom" : "middle", align: rt2 < -0.4 ? "left" : rt2 > 0.4 ? "right" : "center" }, { inheritColor: Wt }), silent: true }));
        }
        if (H.get("show") && et !== q2) {
          var Jt = H.get("distance");
          Jt = Jt ? Jt + _ : _;
          for (var sn = 0; sn <= de; sn++) {
            rt2 = Math.cos(ye), ft = Math.sin(ye);
            var vn = new Vd({ shape: { x1: rt2 * (T - Jt) + C, y1: ft * (T - Jt) + E, x2: rt2 * (T - me - Jt) + C, y2: ft * (T - me - Jt) + E }, silent: true, style: ze });
            ze.stroke === "auto" && vn.setStyle({ stroke: c4((et + sn / de) / q2) }), w4.add(vn), ye += we;
          }
          ye -= we;
        } else
          ye += be;
      }
    }, n2.prototype._renderPointer = function(e2, o, l4, c4, h, p4, g4, y4, _) {
      var w4 = this.group, C = this._data, E = this._progressEls, T = [], O = e2.get(["pointer", "show"]), N = e2.getModel("progress"), V = N.get("show"), H = e2.getData(), X = H.mapDimension("value"), q2 = +e2.get("min"), de = +e2.get("max"), le = [q2, de], me = [p4, g4];
      function ye(we, Pe) {
        var ze = H.getItemModel(we), Re = ze.getModel("pointer"), rt2 = ma(Re.get("width"), h.r), ft = ma(Re.get("length"), h.r), et = e2.get(["pointer", "icon"]), Jt = Re.get("offsetCenter"), xt = ma(Jt[0], h.r), It = ma(Jt[1], h.r), Wt = Re.get("keepAspect"), sn;
        return et ? sn = Xf(et, xt - rt2 / 2, It - ft, rt2, ft, null, Wt) : sn = new r1t({ shape: { angle: -Math.PI / 2, width: rt2, r: ft, x: xt, y: It } }), sn.rotation = -(Pe + Math.PI / 2), sn.x = h.cx, sn.y = h.cy, sn;
      }
      function be(we, Pe) {
        var ze = N.get("roundCap"), Re = ze ? UH : Hg, rt2 = N.get("overlap"), ft = rt2 ? N.get("width") : _ / H.count(), et = rt2 ? h.r - ft : h.r - (we + 1) * ft, Jt = rt2 ? h.r : h.r - we * ft, xt = new Re({ shape: { startAngle: p4, endAngle: Pe, cx: h.cx, cy: h.cy, clockwise: y4, r0: et, r: Jt } });
        return rt2 && (xt.z2 = de - H.get(X, we) % de), xt;
      }
      (V || O) && (H.diff(C).add(function(we) {
        var Pe = H.get(X, we);
        if (O) {
          var ze = ye(we, p4);
          bc(ze, { rotation: -((isNaN(+Pe) ? me[0] : Tl(Pe, le, me, true)) + Math.PI / 2) }, e2), w4.add(ze), H.setItemGraphicEl(we, ze);
        }
        if (V) {
          var Re = be(we, p4), rt2 = N.get("clip");
          bc(Re, { shape: { endAngle: Tl(Pe, le, me, rt2) } }, e2), w4.add(Re), Zie(e2.seriesIndex, H.dataType, we, Re), T[we] = Re;
        }
      }).update(function(we, Pe) {
        var ze = H.get(X, we);
        if (O) {
          var Re = C.getItemGraphicEl(Pe), rt2 = Re ? Re.rotation : p4, ft = ye(we, rt2);
          ft.rotation = rt2, Vs(ft, { rotation: -((isNaN(+ze) ? me[0] : Tl(ze, le, me, true)) + Math.PI / 2) }, e2), w4.add(ft), H.setItemGraphicEl(we, ft);
        }
        if (V) {
          var et = E[Pe], Jt = et ? et.shape.endAngle : p4, xt = be(we, Jt), It = N.get("clip");
          Vs(xt, { shape: { endAngle: Tl(ze, le, me, It) } }, e2), w4.add(xt), Zie(e2.seriesIndex, H.dataType, we, xt), T[we] = xt;
        }
      }).execute(), H.each(function(we) {
        var Pe = H.getItemModel(we), ze = Pe.getModel("emphasis"), Re = ze.get("focus"), rt2 = ze.get("blurScope"), ft = ze.get("disabled");
        if (O) {
          var et = H.getItemGraphicEl(we), Jt = H.getItemVisual(we, "style"), xt = Jt.fill;
          if (et instanceof Ap) {
            var It = et.style;
            et.useStyle(rr({ image: It.image, x: It.x, y: It.y, width: It.width, height: It.height }, Jt));
          } else
            et.useStyle(Jt), et.type !== "pointer" && et.setColor(xt);
          et.setStyle(Pe.getModel(["pointer", "itemStyle"]).getItemStyle()), et.style.fill === "auto" && et.setStyle("fill", c4(Tl(H.get(X, we), le, [0, 1], true))), et.z2EmphasisLift = 0, Mp(et, Pe), pf(et, Re, rt2, ft);
        }
        if (V) {
          var Wt = T[we];
          Wt.useStyle(H.getItemVisual(we, "style")), Wt.setStyle(Pe.getModel(["progress", "itemStyle"]).getItemStyle()), Wt.z2EmphasisLift = 0, Mp(Wt, Pe), pf(Wt, Re, rt2, ft);
        }
      }), this._progressEls = T);
    }, n2.prototype._renderAnchor = function(e2, o) {
      var l4 = e2.getModel("anchor"), c4 = l4.get("show");
      if (c4) {
        var h = l4.get("size"), p4 = l4.get("icon"), g4 = l4.get("offsetCenter"), y4 = l4.get("keepAspect"), _ = Xf(p4, o.cx - h / 2 + ma(g4[0], o.r), o.cy - h / 2 + ma(g4[1], o.r), h, h, null, y4);
        _.z2 = l4.get("showAbove") ? 1 : 0, _.setStyle(l4.getModel("itemStyle").getItemStyle()), this.group.add(_);
      }
    }, n2.prototype._renderTitleAndDetail = function(e2, o, l4, c4, h) {
      var p4 = this, g4 = e2.getData(), y4 = g4.mapDimension("value"), _ = +e2.get("min"), w4 = +e2.get("max"), C = new Ti(), E = [], T = [], O = e2.isAnimationEnabled(), N = e2.get(["pointer", "showAbove"]);
      g4.diff(this._data).add(function(V) {
        E[V] = new Qs({ silent: true }), T[V] = new Qs({ silent: true });
      }).update(function(V, H) {
        E[V] = p4._titleEls[H], T[V] = p4._detailEls[H];
      }).execute(), g4.each(function(V) {
        var H = g4.getItemModel(V), X = g4.get(y4, V), q2 = new Ti(), de = c4(Tl(X, [_, w4], [0, 1], true)), le = H.getModel("title");
        if (le.get("show")) {
          var me = le.get("offsetCenter"), ye = h.cx + ma(me[0], h.r), be = h.cy + ma(me[1], h.r), we = E[V];
          we.attr({ z2: N ? 0 : 2, style: Ef(le, { x: ye, y: be, text: g4.getName(V), align: "center", verticalAlign: "middle" }, { inheritColor: de }) }), q2.add(we);
        }
        var Pe = H.getModel("detail");
        if (Pe.get("show")) {
          var ze = Pe.get("offsetCenter"), Re = h.cx + ma(ze[0], h.r), rt2 = h.cy + ma(ze[1], h.r), ft = ma(Pe.get("width"), h.r), et = ma(Pe.get("height"), h.r), Jt = e2.get(["progress", "show"]) ? g4.getItemVisual(V, "style").fill : de, we = T[V], xt = Pe.get("formatter");
          we.attr({ z2: N ? 0 : 2, style: Ef(Pe, { x: Re, y: rt2, text: DW(X, xt), width: isNaN(ft) ? null : ft, height: isNaN(et) ? null : et, align: "center", verticalAlign: "middle" }, { inheritColor: Jt }) }), aDe(we, { normal: Pe }, X, function(Wt) {
            return DW(Wt, xt);
          }), O && iDe(we, V, g4, e2, { getFormattedLabel: function(Wt, sn, vn, $r, ga, Za) {
            return DW(Za ? Za.interpolatedValue : X, xt);
          } }), q2.add(we);
        }
        C.add(q2);
      }), this.group.add(C), this._titleEls = E, this._detailEls = T;
    }, n2.type = "gauge", n2;
  }(Ru), o1t = i1t, s1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.visualStyleAccessPath = "itemStyle", e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      return rL(this, ["value"]);
    }, n2.type = "series.gauge", n2.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, n2;
  }(_c2), l1t = s1t;
  function u1t(i) {
    i.registerChartView(o1t), i.registerSeriesModel(l1t);
  }
  var c1t = ["itemStyle", "opacity"], f1t = function(i) {
    on(n2, i);
    function n2(e2, o) {
      var l4 = i.call(this) || this, c4 = l4, h = new Ug(), p4 = new Qs();
      return c4.setTextContent(p4), l4.setTextGuideLine(h), l4.updateData(e2, o, true), l4;
    }
    return n2.prototype.updateData = function(e2, o, l4) {
      var c4 = this, h = e2.hostModel, p4 = e2.getItemModel(o), g4 = e2.getItemLayout(o), y4 = p4.getModel("emphasis"), _ = p4.get(c1t);
      _ = _ == null ? 1 : _, l4 || ob(c4), c4.useStyle(e2.getItemVisual(o, "style")), c4.style.lineJoin = "round", l4 ? (c4.setShape({ points: g4.points }), c4.style.opacity = 0, bc(c4, { style: { opacity: _ } }, h, o)) : Vs(c4, { style: { opacity: _ }, shape: { points: g4.points } }, h, o), Mp(c4, p4), this._updateLabel(e2, o), pf(this, y4.get("focus"), y4.get("blurScope"), y4.get("disabled"));
    }, n2.prototype._updateLabel = function(e2, o) {
      var l4 = this, c4 = this.getTextGuideLine(), h = l4.getTextContent(), p4 = e2.hostModel, g4 = e2.getItemModel(o), y4 = e2.getItemLayout(o), _ = y4.label, w4 = e2.getItemVisual(o, "style"), C = w4.fill;
      yv(h, zd(g4), { labelFetcher: e2.hostModel, labelDataIndex: o, defaultOpacity: w4.opacity, defaultText: e2.getName(o) }, { normal: { align: _.textAlign, verticalAlign: _.verticalAlign } }), l4.setTextConfig({ local: true, inside: !!_.inside, insideStroke: C, outsideFill: C });
      var E = _.linePoints;
      c4.setShape({ points: E }), l4.textGuideLineConfig = { anchor: E ? new Ji(E[0][0], E[0][1]) : null }, Vs(h, { style: { x: _.x, y: _.y } }, p4, o), h.attr({ rotation: _.rotation, originX: _.x, originY: _.y, z2: 10 }), Dle(l4, kle(g4), { stroke: C });
    }, n2;
  }($g), h1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.ignoreLabelLineUpdate = true, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = this._data, p4 = this.group;
      c4.diff(h).add(function(g4) {
        var y4 = new f1t(c4, g4);
        c4.setItemGraphicEl(g4, y4), p4.add(y4);
      }).update(function(g4, y4) {
        var _ = h.getItemGraphicEl(y4);
        _.updateData(c4, g4), p4.add(_), c4.setItemGraphicEl(g4, _);
      }).remove(function(g4) {
        var y4 = h.getItemGraphicEl(g4);
        h8(y4, e2, g4);
      }).execute(), this._data = c4;
    }, n2.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, n2.prototype.dispose = function() {
    }, n2.type = "funnel", n2;
  }(Ru), d1t = h1t, p1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2) {
      i.prototype.init.apply(this, arguments), this.legendVisualProvider = new e9(Ia(this.getData, this), Ia(this.getRawData, this)), this._defaultLabelLine(e2);
    }, n2.prototype.getInitialData = function(e2, o) {
      return rL(this, { coordDimensions: ["value"], encodeDefaulter: zi(ole, this) });
    }, n2.prototype._defaultLabelLine = function(e2) {
      mT(e2, "labelLine", ["show"]);
      var o = e2.labelLine, l4 = e2.emphasis.labelLine;
      o.show = o.show && e2.label.show, l4.show = l4.show && e2.emphasis.label.show;
    }, n2.prototype.getDataParams = function(e2) {
      var o = this.getData(), l4 = i.prototype.getDataParams.call(this, e2), c4 = o.mapDimension("value"), h = o.getSum(c4);
      return l4.percent = h ? +(o.get(c4, e2) / h * 100).toFixed(2) : 0, l4.$vars.push("percent"), l4;
    }, n2.type = "series.funnel", n2.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, n2;
  }(_c2), v1t = p1t;
  function g1t(i, n2) {
    return bh(i.getBoxLayoutParams(), { width: n2.getWidth(), height: n2.getHeight() });
  }
  function m1t(i, n2) {
    for (var e2 = i.mapDimension("value"), o = i.mapArray(e2, function(g4) {
      return g4;
    }), l4 = [], c4 = n2 === "ascending", h = 0, p4 = i.count(); h < p4; h++)
      l4[h] = h;
    return si(n2) ? l4.sort(n2) : n2 !== "none" && l4.sort(function(g4, y4) {
      return c4 ? o[g4] - o[y4] : o[y4] - o[g4];
    }), l4;
  }
  function y1t(i) {
    var n2 = i.hostModel, e2 = n2.get("orient");
    i.each(function(o) {
      var l4 = i.getItemModel(o), c4 = l4.getModel("label"), h = c4.get("position"), p4 = l4.getModel("labelLine"), g4 = i.getItemLayout(o), y4 = g4.points, _ = h === "inner" || h === "inside" || h === "center" || h === "insideLeft" || h === "insideRight", w4, C, E, T;
      if (_)
        h === "insideLeft" ? (C = (y4[0][0] + y4[3][0]) / 2 + 5, E = (y4[0][1] + y4[3][1]) / 2, w4 = "left") : h === "insideRight" ? (C = (y4[1][0] + y4[2][0]) / 2 - 5, E = (y4[1][1] + y4[2][1]) / 2, w4 = "right") : (C = (y4[0][0] + y4[1][0] + y4[2][0] + y4[3][0]) / 4, E = (y4[0][1] + y4[1][1] + y4[2][1] + y4[3][1]) / 4, w4 = "center"), T = [[C, E], [C, E]];
      else {
        var O = void 0, N = void 0, V = void 0, H = void 0, X = p4.get("length");
        h === "left" ? (O = (y4[3][0] + y4[0][0]) / 2, N = (y4[3][1] + y4[0][1]) / 2, V = O - X, C = V - 5, w4 = "right") : h === "right" ? (O = (y4[1][0] + y4[2][0]) / 2, N = (y4[1][1] + y4[2][1]) / 2, V = O + X, C = V + 5, w4 = "left") : h === "top" ? (O = (y4[3][0] + y4[0][0]) / 2, N = (y4[3][1] + y4[0][1]) / 2, H = N - X, E = H - 5, w4 = "center") : h === "bottom" ? (O = (y4[1][0] + y4[2][0]) / 2, N = (y4[1][1] + y4[2][1]) / 2, H = N + X, E = H + 5, w4 = "center") : h === "rightTop" ? (O = e2 === "horizontal" ? y4[3][0] : y4[1][0], N = e2 === "horizontal" ? y4[3][1] : y4[1][1], e2 === "horizontal" ? (H = N - X, E = H - 5, w4 = "center") : (V = O + X, C = V + 5, w4 = "top")) : h === "rightBottom" ? (O = y4[2][0], N = y4[2][1], e2 === "horizontal" ? (H = N + X, E = H + 5, w4 = "center") : (V = O + X, C = V + 5, w4 = "bottom")) : h === "leftTop" ? (O = y4[0][0], N = e2 === "horizontal" ? y4[0][1] : y4[1][1], e2 === "horizontal" ? (H = N - X, E = H - 5, w4 = "center") : (V = O - X, C = V - 5, w4 = "right")) : h === "leftBottom" ? (O = e2 === "horizontal" ? y4[1][0] : y4[3][0], N = e2 === "horizontal" ? y4[1][1] : y4[2][1], e2 === "horizontal" ? (H = N + X, E = H + 5, w4 = "center") : (V = O - X, C = V - 5, w4 = "right")) : (O = (y4[1][0] + y4[2][0]) / 2, N = (y4[1][1] + y4[2][1]) / 2, e2 === "horizontal" ? (H = N + X, E = H + 5, w4 = "center") : (V = O + X, C = V + 5, w4 = "left")), e2 === "horizontal" ? (V = O, C = V) : (H = N, E = H), T = [[O, N], [V, H]];
      }
      g4.label = { linePoints: T, x: C, y: E, verticalAlign: "middle", textAlign: w4, inside: _ };
    });
  }
  function b1t(i, n2) {
    i.eachSeriesByType("funnel", function(e2) {
      var o = e2.getData(), l4 = o.mapDimension("value"), c4 = e2.get("sort"), h = g1t(e2, n2), p4 = e2.get("orient"), g4 = h.width, y4 = h.height, _ = m1t(o, c4), w4 = h.x, C = h.y, E = p4 === "horizontal" ? [ma(e2.get("minSize"), y4), ma(e2.get("maxSize"), y4)] : [ma(e2.get("minSize"), g4), ma(e2.get("maxSize"), g4)], T = o.getDataExtent(l4), O = e2.get("min"), N = e2.get("max");
      O == null && (O = Math.min(T[0], 0)), N == null && (N = T[1]);
      var V = e2.get("funnelAlign"), H = e2.get("gap"), X = p4 === "horizontal" ? g4 : y4, q2 = (X - H * (o.count() - 1)) / o.count(), de = function(rt2, ft) {
        if (p4 === "horizontal") {
          var et = o.get(l4, rt2) || 0, Jt = Tl(et, [O, N], E, true), xt = void 0;
          switch (V) {
            case "top":
              xt = C;
              break;
            case "center":
              xt = C + (y4 - Jt) / 2;
              break;
            case "bottom":
              xt = C + (y4 - Jt);
              break;
          }
          return [[ft, xt], [ft, xt + Jt]];
        }
        var It = o.get(l4, rt2) || 0, Wt = Tl(It, [O, N], E, true), sn;
        switch (V) {
          case "left":
            sn = w4;
            break;
          case "center":
            sn = w4 + (g4 - Wt) / 2;
            break;
          case "right":
            sn = w4 + g4 - Wt;
            break;
        }
        return [[sn, ft], [sn + Wt, ft]];
      };
      c4 === "ascending" && (q2 = -q2, H = -H, p4 === "horizontal" ? w4 += g4 : C += y4, _ = _.reverse());
      for (var le = 0; le < _.length; le++) {
        var me = _[le], ye = _[le + 1], be = o.getItemModel(me);
        if (p4 === "horizontal") {
          var we = be.get(["itemStyle", "width"]);
          we == null ? we = q2 : (we = ma(we, g4), c4 === "ascending" && (we = -we));
          var Pe = de(me, w4), ze = de(ye, w4 + we);
          w4 += we + H, o.setItemLayout(me, { points: Pe.concat(ze.slice().reverse()) });
        } else {
          var Re = be.get(["itemStyle", "height"]);
          Re == null ? Re = q2 : (Re = ma(Re, y4), c4 === "ascending" && (Re = -Re));
          var Pe = de(me, C), ze = de(ye, C + Re);
          C += Re + H, o.setItemLayout(me, { points: Pe.concat(ze.slice().reverse()) });
        }
      }
      y1t(o);
    });
  }
  function _1t(i) {
    i.registerChartView(d1t), i.registerSeriesModel(v1t), i.registerLayout(b1t), i.registerProcessor(Q8("funnel"));
  }
  var x1t = 0.3, w1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._dataGroup = new Ti(), e2._initialized = false, e2;
    }
    return n2.prototype.init = function() {
      this.group.add(this._dataGroup);
    }, n2.prototype.render = function(e2, o, l4, c4) {
      this._progressiveEls = null;
      var h = this._dataGroup, p4 = e2.getData(), g4 = this._data, y4 = e2.coordinateSystem, _ = y4.dimensions, w4 = sMe(e2);
      p4.diff(g4).add(C).update(E).remove(T).execute();
      function C(N) {
        var V = oMe(p4, h, N, _, y4);
        Dae(V, p4, N, w4);
      }
      function E(N, V) {
        var H = g4.getItemGraphicEl(V), X = RPe(p4, N, _, y4);
        p4.setItemGraphicEl(N, H), Vs(H, { shape: { points: X } }, e2, N), ob(H), Dae(H, p4, N, w4);
      }
      function T(N) {
        var V = g4.getItemGraphicEl(N);
        h.remove(V);
      }
      if (!this._initialized) {
        this._initialized = true;
        var O = S1t(y4, e2, function() {
          setTimeout(function() {
            h.removeClipPath();
          });
        });
        h.setClipPath(O);
      }
      this._data = p4;
    }, n2.prototype.incrementalPrepareRender = function(e2, o, l4) {
      this._initialized = true, this._data = null, this._dataGroup.removeAll();
    }, n2.prototype.incrementalRender = function(e2, o, l4) {
      for (var c4 = o.getData(), h = o.coordinateSystem, p4 = h.dimensions, g4 = sMe(o), y4 = this._progressiveEls = [], _ = e2.start; _ < e2.end; _++) {
        var w4 = oMe(c4, this._dataGroup, _, p4, h);
        w4.incremental = true, Dae(w4, c4, _, g4), y4.push(w4);
      }
    }, n2.prototype.remove = function() {
      this._dataGroup && this._dataGroup.removeAll(), this._data = null;
    }, n2.type = "parallel", n2;
  }(Ru);
  function S1t(i, n2, e2) {
    var o = i.model, l4 = i.getRect(), c4 = new Is({ shape: { x: l4.x, y: l4.y, width: l4.width, height: l4.height } }), h = o.get("layout") === "horizontal" ? "width" : "height";
    return c4.setShape(h, 0), bc(c4, { shape: { width: l4.width, height: l4.height } }, n2, e2), c4;
  }
  function RPe(i, n2, e2, o) {
    for (var l4 = [], c4 = 0; c4 < e2.length; c4++) {
      var h = e2[c4], p4 = i.get(i.mapDimension(h), n2);
      C1t(p4, o.getAxis(h).type) || l4.push(o.dataToPoint(p4, h));
    }
    return l4;
  }
  function oMe(i, n2, e2, o, l4) {
    var c4 = RPe(i, e2, o, l4), h = new Ug({ shape: { points: c4 }, z2: 10 });
    return n2.add(h), i.setItemGraphicEl(e2, h), h;
  }
  function sMe(i) {
    var n2 = i.get("smooth", true);
    return n2 === true && (n2 = x1t), n2 = _2(n2), i8(n2) && (n2 = 0), { smooth: n2 };
  }
  function Dae(i, n2, e2, o) {
    i.useStyle(n2.getItemVisual(e2, "style")), i.style.fill = null, i.setShape("smooth", o.smooth);
    var l4 = n2.getItemModel(e2), c4 = l4.getModel("emphasis");
    Mp(i, l4, "lineStyle"), pf(i, c4.get("focus"), c4.get("blurScope"), c4.get("disabled"));
  }
  function C1t(i, n2) {
    return n2 === "category" ? i == null : i == null || isNaN(i);
  }
  var M1t = w1t, A1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.visualStyleAccessPath = "lineStyle", e2.visualDrawType = "stroke", e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      return M2(null, this, { useEncodeDefaulter: Ia(E1t, null, this) });
    }, n2.prototype.getRawIndicesByActiveState = function(e2) {
      var o = this.coordinateSystem, l4 = this.getData(), c4 = [];
      return o.eachActiveState(l4, function(h, p4) {
        e2 === h && c4.push(l4.getRawIndex(p4));
      }), c4;
    }, n2.type = "series.parallel", n2.dependencies = ["parallel"], n2.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, n2;
  }(_c2);
  function E1t(i) {
    var n2 = i.ecModel.getComponent("parallel", i.get("parallelIndex"));
    if (!!n2) {
      var e2 = {};
      return Ve(n2.dimensions, function(o) {
        var l4 = I1t(o);
        e2[o] = l4;
      }), e2;
    }
  }
  function I1t(i) {
    return +i.replace("dim", "");
  }
  var T1t = A1t, D1t = ["lineStyle", "opacity"], k1t = { seriesType: "parallel", reset: function(i, n2) {
    var e2 = i.coordinateSystem, o = { normal: i.get(["lineStyle", "opacity"]), active: i.get("activeOpacity"), inactive: i.get("inactiveOpacity") };
    return { progress: function(l4, c4) {
      e2.eachActiveState(c4, function(h, p4) {
        var g4 = o[h];
        if (h === "normal" && c4.hasItemOption) {
          var y4 = c4.getItemModel(p4).get(D1t, true);
          y4 != null && (g4 = y4);
        }
        var _ = c4.ensureUniqueItemVisual(p4, "style");
        _.opacity = g4;
      }, l4.start, l4.end);
    } };
  } }, P1t = k1t;
  function L1t(i) {
    O1t(i), R1t(i);
  }
  function O1t(i) {
    if (!i.parallel) {
      var n2 = false;
      Ve(i.series, function(e2) {
        e2 && e2.type === "parallel" && (n2 = true);
      }), n2 && (i.parallel = [{}]);
    }
  }
  function R1t(i) {
    var n2 = Zl(i.parallelAxis);
    Ve(n2, function(e2) {
      if (!!mi(e2)) {
        var o = e2.parallelIndex || 0, l4 = Zl(i.parallel)[o];
        l4 && l4.parallelAxisDefault && to(e2, l4.parallelAxisDefault, false);
      }
    });
  }
  var F1t = 5, N1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      this._model = e2, this._api = l4, this._handlers || (this._handlers = {}, Ve(V1t, function(c4, h) {
        l4.getZr().on(h, this._handlers[h] = Ia(c4, this));
      }, this)), tL(this, "_throttledDispatchExpand", e2.get("axisExpandRate"), "fixRate");
    }, n2.prototype.dispose = function(e2, o) {
      m8(this, "_throttledDispatchExpand"), Ve(this._handlers, function(l4, c4) {
        o.getZr().off(c4, l4);
      }), this._handlers = null;
    }, n2.prototype._throttledDispatchExpand = function(e2) {
      this._dispatchExpand(e2);
    }, n2.prototype._dispatchExpand = function(e2) {
      e2 && this._api.dispatchAction(rr({ type: "parallelAxisExpand" }, e2));
    }, n2.type = "parallel", n2;
  }($c), V1t = { mousedown: function(i) {
    kae(this, "click") && (this._mouseDownPoint = [i.offsetX, i.offsetY]);
  }, mouseup: function(i) {
    var n2 = this._mouseDownPoint;
    if (kae(this, "click") && n2) {
      var e2 = [i.offsetX, i.offsetY], o = Math.pow(n2[0] - e2[0], 2) + Math.pow(n2[1] - e2[1], 2);
      if (o > F1t)
        return;
      var l4 = this._model.coordinateSystem.getSlidedAxisExpandWindow([i.offsetX, i.offsetY]);
      l4.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: l4.axisExpandWindow });
    }
    this._mouseDownPoint = null;
  }, mousemove: function(i) {
    if (!(this._mouseDownPoint || !kae(this, "mousemove"))) {
      var n2 = this._model, e2 = n2.coordinateSystem.getSlidedAxisExpandWindow([i.offsetX, i.offsetY]), o = e2.behavior;
      o === "jump" && this._throttledDispatchExpand.debounceNextCall(n2.get("axisExpandDebounce")), this._throttledDispatchExpand(o === "none" ? null : { axisExpandWindow: e2.axisExpandWindow, animation: o === "jump" ? null : { duration: 0 } });
    }
  } };
  function kae(i, n2) {
    var e2 = i._model;
    return e2.get("axisExpandable") && e2.get("axisExpandTriggerOn") === n2;
  }
  var z1t = N1t, B1t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function() {
      i.prototype.init.apply(this, arguments), this.mergeOption({});
    }, n2.prototype.mergeOption = function(e2) {
      var o = this.option;
      e2 && to(o, e2, true), this._initDimensions();
    }, n2.prototype.contains = function(e2, o) {
      var l4 = e2.get("parallelIndex");
      return l4 != null && o.getComponent("parallel", l4) === this;
    }, n2.prototype.setAxisExpand = function(e2) {
      Ve(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(o) {
        e2.hasOwnProperty(o) && (this.option[o] = e2[o]);
      }, this);
    }, n2.prototype._initDimensions = function() {
      var e2 = this.dimensions = [], o = this.parallelAxisIndex = [], l4 = Yl(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(c4) {
        return (c4.get("parallelIndex") || 0) === this.componentIndex;
      }, this);
      Ve(l4, function(c4) {
        e2.push("dim" + c4.get("dim")), o.push(c4.componentIndex);
      });
    }, n2.type = "parallel", n2.dependencies = ["parallelAxis"], n2.layoutMode = "box", n2.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, n2;
  }(Ns), j1t = B1t, G1t = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4, h) {
      var p4 = i.call(this, e2, o, l4) || this;
      return p4.type = c4 || "value", p4.axisIndex = h, p4;
    }
    return n2.prototype.isHorizontal = function() {
      return this.coordinateSystem.getModel().get("layout") !== "horizontal";
    }, n2;
  }(lb2), W1t = G1t;
  function TT(i, n2, e2, o, l4, c4) {
    i = i || 0;
    var h = e2[1] - e2[0];
    if (l4 != null && (l4 = o3(l4, [0, h])), c4 != null && (c4 = Math.max(c4, l4 != null ? l4 : 0)), o === "all") {
      var p4 = Math.abs(n2[1] - n2[0]);
      p4 = o3(p4, [0, h]), l4 = c4 = o3(p4, [l4, c4]), o = 0;
    }
    n2[0] = o3(n2[0], e2), n2[1] = o3(n2[1], e2);
    var g4 = Pae(n2, o);
    n2[o] += i;
    var y4 = l4 || 0, _ = e2.slice();
    g4.sign < 0 ? _[0] += y4 : _[1] -= y4, n2[o] = o3(n2[o], _);
    var w4;
    return w4 = Pae(n2, o), l4 != null && (w4.sign !== g4.sign || w4.span < l4) && (n2[1 - o] = n2[o] + g4.sign * l4), w4 = Pae(n2, o), c4 != null && w4.span > c4 && (n2[1 - o] = n2[o] + w4.sign * c4), n2;
  }
  function Pae(i, n2) {
    var e2 = i[n2] - i[1 - n2];
    return { span: Math.abs(e2), sign: e2 > 0 ? -1 : e2 < 0 ? 1 : n2 ? -1 : 1 };
  }
  function o3(i, n2) {
    return Math.min(n2[1] != null ? n2[1] : 1 / 0, Math.max(n2[0] != null ? n2[0] : -1 / 0, i));
  }
  var Lae = Ve, FPe = Math.min, NPe = Math.max, lMe = Math.floor, H1t = Math.ceil, uMe = df, $1t = Math.PI, U1t = function() {
    function i(n2, e2, o) {
      this.type = "parallel", this._axesMap = ri(), this._axesLayout = {}, this.dimensions = n2.dimensions, this._model = n2, this._init(n2, e2, o);
    }
    return i.prototype._init = function(n2, e2, o) {
      var l4 = n2.dimensions, c4 = n2.parallelAxisIndex;
      Lae(l4, function(h, p4) {
        var g4 = c4[p4], y4 = e2.getComponent("parallelAxis", g4), _ = this._axesMap.set(h, new W1t(h, $$(y4), [0, 0], y4.get("type"), g4)), w4 = _.type === "category";
        _.onBand = w4 && y4.get("boundaryGap"), _.inverse = y4.get("inverse"), y4.axis = _, _.model = y4, _.coordinateSystem = y4.coordinateSystem = this;
      }, this);
    }, i.prototype.update = function(n2, e2) {
      this._updateAxesFromSeries(this._model, n2);
    }, i.prototype.containPoint = function(n2) {
      var e2 = this._makeLayoutInfo(), o = e2.axisBase, l4 = e2.layoutBase, c4 = e2.pixelDimIndex, h = n2[1 - c4], p4 = n2[c4];
      return h >= o && h <= o + e2.axisLength && p4 >= l4 && p4 <= l4 + e2.layoutLength;
    }, i.prototype.getModel = function() {
      return this._model;
    }, i.prototype._updateAxesFromSeries = function(n2, e2) {
      e2.eachSeries(function(o) {
        if (!!n2.contains(o, e2)) {
          var l4 = o.getData();
          Lae(this.dimensions, function(c4) {
            var h = this._axesMap.get(c4);
            h.scale.unionExtentFromData(l4, l4.mapDimension(c4)), F3(h.scale, h.model);
          }, this);
        }
      }, this);
    }, i.prototype.resize = function(n2, e2) {
      this._rect = bh(n2.getBoxLayoutParams(), { width: e2.getWidth(), height: e2.getHeight() }), this._layoutAxes();
    }, i.prototype.getRect = function() {
      return this._rect;
    }, i.prototype._makeLayoutInfo = function() {
      var n2 = this._model, e2 = this._rect, o = ["x", "y"], l4 = ["width", "height"], c4 = n2.get("layout"), h = c4 === "horizontal" ? 0 : 1, p4 = e2[l4[h]], g4 = [0, p4], y4 = this.dimensions.length, _ = kW(n2.get("axisExpandWidth"), g4), w4 = kW(n2.get("axisExpandCount") || 0, [0, y4]), C = n2.get("axisExpandable") && y4 > 3 && y4 > w4 && w4 > 1 && _ > 0 && p4 > 0, E = n2.get("axisExpandWindow"), T;
      if (E)
        T = kW(E[1] - E[0], g4), E[1] = E[0] + T;
      else {
        T = kW(_ * (w4 - 1), g4);
        var O = n2.get("axisExpandCenter") || lMe(y4 / 2);
        E = [_ * O - T / 2], E[1] = E[0] + T;
      }
      var N = (p4 - T) / (y4 - w4);
      N < 3 && (N = 0);
      var V = [lMe(uMe(E[0] / _, 1)) + 1, H1t(uMe(E[1] / _, 1)) - 1], H = N / _ * E[0];
      return { layout: c4, pixelDimIndex: h, layoutBase: e2[o[h]], layoutLength: p4, axisBase: e2[o[1 - h]], axisLength: e2[l4[1 - h]], axisExpandable: C, axisExpandWidth: _, axisCollapseWidth: N, axisExpandWindow: E, axisCount: y4, winInnerIndices: V, axisExpandWindow0Pos: H };
    }, i.prototype._layoutAxes = function() {
      var n2 = this._rect, e2 = this._axesMap, o = this.dimensions, l4 = this._makeLayoutInfo(), c4 = l4.layout;
      e2.each(function(h) {
        var p4 = [0, l4.axisLength], g4 = h.inverse ? 1 : 0;
        h.setExtent(p4[g4], p4[1 - g4]);
      }), Lae(o, function(h, p4) {
        var g4 = (l4.axisExpandable ? Y1t : q1t)(p4, l4), y4 = { horizontal: { x: g4.position, y: l4.axisLength }, vertical: { x: 0, y: g4.position } }, _ = { horizontal: $1t / 2, vertical: 0 }, w4 = [y4[c4].x + n2.x, y4[c4].y + n2.y], C = _[c4], E = Ny();
        MT(E, E, C), Y_(E, E, w4), this._axesLayout[h] = { position: w4, rotation: C, transform: E, axisNameAvailableWidth: g4.axisNameAvailableWidth, axisLabelShow: g4.axisLabelShow, nameTruncateMaxWidth: g4.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
      }, this);
    }, i.prototype.getAxis = function(n2) {
      return this._axesMap.get(n2);
    }, i.prototype.dataToPoint = function(n2, e2) {
      return this.axisCoordToPoint(this._axesMap.get(e2).dataToCoord(n2), e2);
    }, i.prototype.eachActiveState = function(n2, e2, o, l4) {
      o == null && (o = 0), l4 == null && (l4 = n2.count());
      var c4 = this._axesMap, h = this.dimensions, p4 = [], g4 = [];
      Ve(h, function(N) {
        p4.push(n2.mapDimension(N)), g4.push(c4.get(N).model);
      });
      for (var y4 = this.hasAxisBrushed(), _ = o; _ < l4; _++) {
        var w4 = void 0;
        if (!y4)
          w4 = "normal";
        else {
          w4 = "active";
          for (var C = n2.getValues(p4, _), E = 0, T = h.length; E < T; E++) {
            var O = g4[E].getActiveState(C[E]);
            if (O === "inactive") {
              w4 = "inactive";
              break;
            }
          }
        }
        e2(w4, _);
      }
    }, i.prototype.hasAxisBrushed = function() {
      for (var n2 = this.dimensions, e2 = this._axesMap, o = false, l4 = 0, c4 = n2.length; l4 < c4; l4++)
        e2.get(n2[l4]).model.getActiveState() !== "normal" && (o = true);
      return o;
    }, i.prototype.axisCoordToPoint = function(n2, e2) {
      var o = this._axesLayout[e2];
      return ab([n2, 0], o.transform);
    }, i.prototype.getAxisLayout = function(n2) {
      return Ci(this._axesLayout[n2]);
    }, i.prototype.getSlidedAxisExpandWindow = function(n2) {
      var e2 = this._makeLayoutInfo(), o = e2.pixelDimIndex, l4 = e2.axisExpandWindow.slice(), c4 = l4[1] - l4[0], h = [0, e2.axisExpandWidth * (e2.axisCount - 1)];
      if (!this.containPoint(n2))
        return { behavior: "none", axisExpandWindow: l4 };
      var p4 = n2[o] - e2.layoutBase - e2.axisExpandWindow0Pos, g4, y4 = "slide", _ = e2.axisCollapseWidth, w4 = this._model.get("axisExpandSlideTriggerArea"), C = w4[0] != null;
      if (_)
        C && _ && p4 < c4 * w4[0] ? (y4 = "jump", g4 = p4 - c4 * w4[2]) : C && _ && p4 > c4 * (1 - w4[0]) ? (y4 = "jump", g4 = p4 - c4 * (1 - w4[2])) : (g4 = p4 - c4 * w4[1]) >= 0 && (g4 = p4 - c4 * (1 - w4[1])) <= 0 && (g4 = 0), g4 *= e2.axisExpandWidth / _, g4 ? TT(g4, l4, h, "all") : y4 = "none";
      else {
        var E = l4[1] - l4[0], T = h[1] * p4 / E;
        l4 = [NPe(0, T - E / 2)], l4[1] = FPe(h[1], l4[0] + E), l4[0] = l4[1] - E;
      }
      return { axisExpandWindow: l4, behavior: y4 };
    }, i;
  }();
  function kW(i, n2) {
    return FPe(NPe(i, n2[0]), n2[1]);
  }
  function q1t(i, n2) {
    var e2 = n2.layoutLength / (n2.axisCount - 1);
    return { position: e2 * i, axisNameAvailableWidth: e2, axisLabelShow: true };
  }
  function Y1t(i, n2) {
    var e2 = n2.layoutLength, o = n2.axisExpandWidth, l4 = n2.axisCount, c4 = n2.axisCollapseWidth, h = n2.winInnerIndices, p4, g4 = c4, y4 = false, _;
    return i < h[0] ? (p4 = i * c4, _ = c4) : i <= h[1] ? (p4 = n2.axisExpandWindow0Pos + i * o - n2.axisExpandWindow[0], g4 = o, y4 = true) : (p4 = e2 - (l4 - 1 - i) * c4, _ = c4), { position: p4, axisNameAvailableWidth: g4, axisLabelShow: y4, nameTruncateMaxWidth: _ };
  }
  var Z1t = U1t;
  function X1t(i, n2) {
    var e2 = [];
    return i.eachComponent("parallel", function(o, l4) {
      var c4 = new Z1t(o, i, n2);
      c4.name = "parallel_" + l4, c4.resize(o, n2), o.coordinateSystem = c4, c4.model = o, e2.push(c4);
    }), i.eachSeries(function(o) {
      if (o.get("coordinateSystem") === "parallel") {
        var l4 = o.getReferringComponents("parallel", Yf).models[0];
        o.coordinateSystem = l4.coordinateSystem;
      }
    }), e2;
  }
  var K1t = { create: X1t }, J1t = K1t, VPe = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.activeIntervals = [], e2;
    }
    return n2.prototype.getAreaSelectStyle = function() {
      return bT([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
    }, n2.prototype.setActiveIntervals = function(e2) {
      var o = this.activeIntervals = Ci(e2);
      if (o)
        for (var l4 = o.length - 1; l4 >= 0; l4--)
          Ly(o[l4]);
    }, n2.prototype.getActiveState = function(e2) {
      var o = this.activeIntervals;
      if (!o.length)
        return "normal";
      if (e2 == null || isNaN(+e2))
        return "inactive";
      if (o.length === 1) {
        var l4 = o[0];
        if (l4[0] <= e2 && e2 <= l4[1])
          return "active";
      } else
        for (var c4 = 0, h = o.length; c4 < h; c4++)
          if (o[c4][0] <= e2 && e2 <= o[c4][1])
            return "active";
      return "inactive";
    }, n2;
  }(Ns);
  Kf(VPe, Z8);
  var cMe = VPe, wT = true, T8 = Math.min, z3 = Math.max, Q1t = Math.pow, ebt = 1e4, tbt = 6, nbt = 6, fMe = "globalPan", rbt = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, abt = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, hMe = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, ibt = 0, obt = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this) || this;
      return o._track = [], o._covers = [], o._handlers = {}, o._zr = e2, o.group = new Ti(), o._uid = "brushController_" + ibt++, Ve(dbt, function(l4, c4) {
        this._handlers[c4] = Ia(l4, this);
      }, o), o;
    }
    return n2.prototype.enableBrush = function(e2) {
      return this._brushType && this._doDisableBrush(), e2.brushType && this._doEnableBrush(e2), this;
    }, n2.prototype._doEnableBrush = function(e2) {
      var o = this._zr;
      this._enableGlobalPan || g0t(o, fMe, this._uid), Ve(this._handlers, function(l4, c4) {
        o.on(c4, l4);
      }), this._brushType = e2.brushType, this._brushOption = to(Ci(hMe), e2, true);
    }, n2.prototype._doDisableBrush = function() {
      var e2 = this._zr;
      m0t(e2, fMe, this._uid), Ve(this._handlers, function(o, l4) {
        e2.off(l4, o);
      }), this._brushType = this._brushOption = null;
    }, n2.prototype.setPanels = function(e2) {
      if (e2 && e2.length) {
        var o = this._panels = {};
        Ve(e2, function(l4) {
          o[l4.panelId] = Ci(l4);
        });
      } else
        this._panels = null;
      return this;
    }, n2.prototype.mount = function(e2) {
      e2 = e2 || {}, this._enableGlobalPan = e2.enableGlobalPan;
      var o = this.group;
      return this._zr.add(o), o.attr({ x: e2.x || 0, y: e2.y || 0, rotation: e2.rotation || 0, scaleX: e2.scaleX || 1, scaleY: e2.scaleY || 1 }), this._transform = o.getLocalTransform(), this;
    }, n2.prototype.updateCovers = function(e2) {
      e2 = Er(e2, function(C) {
        return to(Ci(hMe), C, true);
      });
      var o = "\0-brush-index-", l4 = this._covers, c4 = this._covers = [], h = this, p4 = this._creatingCover;
      return new x2(l4, e2, y4, g4).add(_).update(_).remove(w4).execute(), this;
      function g4(C, E) {
        return (C.id != null ? C.id : o + E) + "-" + C.brushType;
      }
      function y4(C, E) {
        return g4(C.__brushOption, E);
      }
      function _(C, E) {
        var T = e2[C];
        if (E != null && l4[E] === p4)
          c4[C] = l4[E];
        else {
          var O = c4[C] = E != null ? (l4[E].__brushOption = T, l4[E]) : BPe(h, zPe(h, T));
          Kle(h, O);
        }
      }
      function w4(C) {
        l4[C] !== p4 && h.group.remove(l4[C]);
      }
    }, n2.prototype.unmount = function() {
      return this.enableBrush(false), Voe(this), this._zr.remove(this.group), this;
    }, n2.prototype.dispose = function() {
      this.unmount(), this.off();
    }, n2;
  }(zy);
  function zPe(i, n2) {
    var e2 = J$[n2.brushType].createCover(i, n2);
    return e2.__brushOption = n2, GPe(e2, n2), i.group.add(e2), e2;
  }
  function BPe(i, n2) {
    var e2 = Jle(n2);
    return e2.endCreating && (e2.endCreating(i, n2), GPe(n2, n2.__brushOption)), n2;
  }
  function jPe(i, n2) {
    var e2 = n2.__brushOption;
    Jle(n2).updateCoverShape(i, n2, e2.range, e2);
  }
  function GPe(i, n2) {
    var e2 = n2.z;
    e2 == null && (e2 = ebt), i.traverse(function(o) {
      o.z = e2, o.z2 = e2;
    });
  }
  function Kle(i, n2) {
    Jle(n2).updateCommon(i, n2), jPe(i, n2);
  }
  function Jle(i) {
    return J$[i.__brushOption.brushType];
  }
  function Qle(i, n2, e2) {
    var o = i._panels;
    if (!o)
      return wT;
    var l4, c4 = i._transform;
    return Ve(o, function(h) {
      h.isTargetByCursor(n2, e2, c4) && (l4 = h);
    }), l4;
  }
  function WPe(i, n2) {
    var e2 = i._panels;
    if (!e2)
      return wT;
    var o = n2.__brushOption.panelId;
    return o != null ? e2[o] : wT;
  }
  function Voe(i) {
    var n2 = i._covers, e2 = n2.length;
    return Ve(n2, function(o) {
      i.group.remove(o);
    }, i), n2.length = 0, !!e2;
  }
  function ST(i, n2) {
    var e2 = Er(i._covers, function(o) {
      var l4 = o.__brushOption, c4 = Ci(l4.range);
      return { brushType: l4.brushType, panelId: l4.panelId, range: c4 };
    });
    i.trigger("brush", { areas: e2, isEnd: !!n2.isEnd, removeOnClick: !!n2.removeOnClick });
  }
  function sbt(i) {
    var n2 = i._track;
    if (!n2.length)
      return false;
    var e2 = n2[n2.length - 1], o = n2[0], l4 = e2[0] - o[0], c4 = e2[1] - o[1], h = Q1t(l4 * l4 + c4 * c4, 0.5);
    return h > tbt;
  }
  function HPe(i) {
    var n2 = i.length - 1;
    return n2 < 0 && (n2 = 0), [i[0], i[n2]];
  }
  function $Pe(i, n2, e2, o) {
    var l4 = new Ti();
    return l4.add(new Is({ name: "main", style: eue(e2), silent: true, draggable: true, cursor: "move", drift: zi(dMe, i, n2, l4, ["n", "s", "w", "e"]), ondragend: zi(ST, n2, { isEnd: true }) })), Ve(o, function(c4) {
      l4.add(new Is({ name: c4.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: zi(dMe, i, n2, l4, c4), ondragend: zi(ST, n2, { isEnd: true }) }));
    }), l4;
  }
  function UPe(i, n2, e2, o) {
    var l4 = o.brushStyle.lineWidth || 0, c4 = z3(l4, nbt), h = e2[0][0], p4 = e2[1][0], g4 = h - l4 / 2, y4 = p4 - l4 / 2, _ = e2[0][1], w4 = e2[1][1], C = _ - c4 + l4 / 2, E = w4 - c4 + l4 / 2, T = _ - h, O = w4 - p4, N = T + l4, V = O + l4;
    i2(i, n2, "main", h, p4, T, O), o.transformable && (i2(i, n2, "w", g4, y4, c4, V), i2(i, n2, "e", C, y4, c4, V), i2(i, n2, "n", g4, y4, N, c4), i2(i, n2, "s", g4, E, N, c4), i2(i, n2, "nw", g4, y4, c4, c4), i2(i, n2, "ne", C, y4, c4, c4), i2(i, n2, "sw", g4, E, c4, c4), i2(i, n2, "se", C, E, c4, c4));
  }
  function zoe(i, n2) {
    var e2 = n2.__brushOption, o = e2.transformable, l4 = n2.childAt(0);
    l4.useStyle(eue(e2)), l4.attr({ silent: !o, cursor: o ? "move" : "default" }), Ve([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(c4) {
      var h = n2.childOfName(c4.join("")), p4 = c4.length === 1 ? Boe(i, c4[0]) : ubt(i, c4);
      h && h.attr({ silent: !o, invisible: !o, cursor: o ? abt[p4] + "-resize" : null });
    });
  }
  function i2(i, n2, e2, o, l4, c4, h) {
    var p4 = n2.childOfName(e2);
    p4 && p4.setShape(fbt(tue(i, n2, [[o, l4], [o + c4, l4 + h]])));
  }
  function eue(i) {
    return hi({ strokeNoScale: true }, i.brushStyle);
  }
  function qPe(i, n2, e2, o) {
    var l4 = [T8(i, e2), T8(n2, o)], c4 = [z3(i, e2), z3(n2, o)];
    return [[l4[0], c4[0]], [l4[1], c4[1]]];
  }
  function lbt(i) {
    return hT(i.group);
  }
  function Boe(i, n2) {
    var e2 = { w: "left", e: "right", n: "top", s: "bottom" }, o = { left: "w", right: "e", top: "n", bottom: "s" }, l4 = D$(e2[n2], lbt(i));
    return o[l4];
  }
  function ubt(i, n2) {
    var e2 = [Boe(i, n2[0]), Boe(i, n2[1])];
    return (e2[0] === "e" || e2[0] === "w") && e2.reverse(), e2.join("");
  }
  function dMe(i, n2, e2, o, l4, c4) {
    var h = e2.__brushOption, p4 = i.toRectRange(h.range), g4 = YPe(n2, l4, c4);
    Ve(o, function(y4) {
      var _ = rbt[y4];
      p4[_[0]][_[1]] += g4[_[0]];
    }), h.range = i.fromRectRange(qPe(p4[0][0], p4[1][0], p4[0][1], p4[1][1])), Kle(n2, e2), ST(n2, { isEnd: false });
  }
  function cbt(i, n2, e2, o) {
    var l4 = n2.__brushOption.range, c4 = YPe(i, e2, o);
    Ve(l4, function(h) {
      h[0] += c4[0], h[1] += c4[1];
    }), Kle(i, n2), ST(i, { isEnd: false });
  }
  function YPe(i, n2, e2) {
    var o = i.group, l4 = o.transformCoordToLocal(n2, e2), c4 = o.transformCoordToLocal(0, 0);
    return [l4[0] - c4[0], l4[1] - c4[1]];
  }
  function tue(i, n2, e2) {
    var o = WPe(i, n2);
    return o && o !== wT ? o.clipPath(e2, i._transform) : Ci(e2);
  }
  function fbt(i) {
    var n2 = T8(i[0][0], i[1][0]), e2 = T8(i[0][1], i[1][1]), o = z3(i[0][0], i[1][0]), l4 = z3(i[0][1], i[1][1]);
    return { x: n2, y: e2, width: o - n2, height: l4 - e2 };
  }
  function hbt(i, n2, e2) {
    if (!(!i._brushType || pbt(i, n2.offsetX, n2.offsetY))) {
      var o = i._zr, l4 = i._covers, c4 = Qle(i, n2, e2);
      if (!i._dragging)
        for (var h = 0; h < l4.length; h++) {
          var p4 = l4[h].__brushOption;
          if (c4 && (c4 === wT || p4.panelId === c4.panelId) && J$[p4.brushType].contain(l4[h], e2[0], e2[1]))
            return;
        }
      c4 && o.setCursorStyle("crosshair");
    }
  }
  function joe(i) {
    var n2 = i.event;
    n2.preventDefault && n2.preventDefault();
  }
  function Goe(i, n2, e2) {
    return i.childOfName("main").contain(n2, e2);
  }
  function ZPe(i, n2, e2, o) {
    var l4 = i._creatingCover, c4 = i._creatingPanel, h = i._brushOption, p4;
    if (i._track.push(e2.slice()), sbt(i) || l4) {
      if (c4 && !l4) {
        h.brushMode === "single" && Voe(i);
        var g4 = Ci(h);
        g4.brushType = pMe(g4.brushType, c4), g4.panelId = c4 === wT ? null : c4.panelId, l4 = i._creatingCover = zPe(i, g4), i._covers.push(l4);
      }
      if (l4) {
        var y4 = J$[pMe(i._brushType, c4)], _ = l4.__brushOption;
        _.range = y4.getCreatingRange(tue(i, l4, i._track)), o && (BPe(i, l4), y4.updateCommon(i, l4)), jPe(i, l4), p4 = { isEnd: o };
      }
    } else
      o && h.brushMode === "single" && h.removeOnClick && Qle(i, n2, e2) && Voe(i) && (p4 = { isEnd: o, removeOnClick: true });
    return p4;
  }
  function pMe(i, n2) {
    return i === "auto" ? n2.defaultBrushType : i;
  }
  var dbt = { mousedown: function(i) {
    if (this._dragging)
      vMe(this, i);
    else if (!i.target || !i.target.draggable) {
      joe(i);
      var n2 = this.group.transformCoordToLocal(i.offsetX, i.offsetY);
      this._creatingCover = null;
      var e2 = this._creatingPanel = Qle(this, i, n2);
      e2 && (this._dragging = true, this._track = [n2.slice()]);
    }
  }, mousemove: function(i) {
    var n2 = i.offsetX, e2 = i.offsetY, o = this.group.transformCoordToLocal(n2, e2);
    if (hbt(this, i, o), this._dragging) {
      joe(i);
      var l4 = ZPe(this, i, o, false);
      l4 && ST(this, l4);
    }
  }, mouseup: function(i) {
    vMe(this, i);
  } };
  function vMe(i, n2) {
    if (i._dragging) {
      joe(n2);
      var e2 = n2.offsetX, o = n2.offsetY, l4 = i.group.transformCoordToLocal(e2, o), c4 = ZPe(i, n2, l4, true);
      i._dragging = false, i._track = [], i._creatingCover = null, c4 && ST(i, c4);
    }
  }
  function pbt(i, n2, e2) {
    var o = i._zr;
    return n2 < 0 || n2 > o.getWidth() || e2 < 0 || e2 > o.getHeight();
  }
  var J$ = { lineX: gMe(0), lineY: gMe(1), rect: { createCover: function(i, n2) {
    function e2(o) {
      return o;
    }
    return $Pe({ toRectRange: e2, fromRectRange: e2 }, i, n2, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
  }, getCreatingRange: function(i) {
    var n2 = HPe(i);
    return qPe(n2[1][0], n2[1][1], n2[0][0], n2[0][1]);
  }, updateCoverShape: function(i, n2, e2, o) {
    UPe(i, n2, e2, o);
  }, updateCommon: zoe, contain: Goe }, polygon: { createCover: function(i, n2) {
    var e2 = new Ti();
    return e2.add(new Ug({ name: "main", style: eue(n2), silent: true })), e2;
  }, getCreatingRange: function(i) {
    return i;
  }, endCreating: function(i, n2) {
    n2.remove(n2.childAt(0)), n2.add(new $g({ name: "main", draggable: true, drift: zi(cbt, i, n2), ondragend: zi(ST, i, { isEnd: true }) }));
  }, updateCoverShape: function(i, n2, e2, o) {
    n2.childAt(0).setShape({ points: tue(i, n2, e2) });
  }, updateCommon: zoe, contain: Goe } };
  function gMe(i) {
    return { createCover: function(n2, e2) {
      return $Pe({ toRectRange: function(o) {
        var l4 = [o, [0, 100]];
        return i && l4.reverse(), l4;
      }, fromRectRange: function(o) {
        return o[i];
      } }, n2, e2, [[["w"], ["e"]], [["n"], ["s"]]][i]);
    }, getCreatingRange: function(n2) {
      var e2 = HPe(n2), o = T8(e2[0][i], e2[1][i]), l4 = z3(e2[0][i], e2[1][i]);
      return [o, l4];
    }, updateCoverShape: function(n2, e2, o, l4) {
      var c4, h = WPe(n2, e2);
      if (h !== wT && h.getLinearBrushOtherExtent)
        c4 = h.getLinearBrushOtherExtent(i);
      else {
        var p4 = n2._zr;
        c4 = [0, [p4.getWidth(), p4.getHeight()][1 - i]];
      }
      var g4 = [o, c4];
      i && g4.reverse(), UPe(n2, e2, g4, l4);
    }, updateCommon: zoe, contain: Goe };
  }
  var nue = obt;
  function XPe(i) {
    return i = rue(i), function(n2) {
      return eDe(n2, i);
    };
  }
  function KPe(i, n2) {
    return i = rue(i), function(e2) {
      var o = n2 != null ? n2 : e2, l4 = o ? i.width : i.height, c4 = o ? i.x : i.y;
      return [c4, c4 + (l4 || 0)];
    };
  }
  function JPe(i, n2, e2) {
    var o = rue(i);
    return function(l4, c4) {
      return o.contain(c4[0], c4[1]) && !Y$(l4, n2, e2);
    };
  }
  function rue(i) {
    return mo.create(i);
  }
  var vbt = ["axisLine", "axisTickLabel", "axisName"], gbt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o) {
      i.prototype.init.apply(this, arguments), (this._brushController = new nue(o.getZr())).on("brush", Ia(this._onBrush, this));
    }, n2.prototype.render = function(e2, o, l4, c4) {
      if (!mbt(e2, o, c4)) {
        this.axisModel = e2, this.api = l4, this.group.removeAll();
        var h = this._axisGroup;
        if (this._axisGroup = new Ti(), this.group.add(this._axisGroup), !!e2.get("show")) {
          var p4 = bbt(e2, o), g4 = p4.coordinateSystem, y4 = e2.getAreaSelectStyle(), _ = y4.width, w4 = e2.axis.dim, C = g4.getAxisLayout(w4), E = rr({ strokeContainThreshold: _ }, C), T = new w2(e2, E);
          Ve(vbt, T.add, T), this._axisGroup.add(T.getGroup()), this._refreshBrushController(E, y4, e2, p4, _, l4), j8(h, this._axisGroup, e2);
        }
      }
    }, n2.prototype._refreshBrushController = function(e2, o, l4, c4, h, p4) {
      var g4 = l4.axis.getExtent(), y4 = g4[1] - g4[0], _ = Math.min(30, Math.abs(y4) * 0.1), w4 = mo.create({ x: g4[0], y: -h / 2, width: y4, height: h });
      w4.x -= _, w4.width += 2 * _, this._brushController.mount({ enableGlobalPan: true, rotation: e2.rotation, x: e2.position[0], y: e2.position[1] }).setPanels([{ panelId: "pl", clipPath: XPe(w4), isTargetByCursor: JPe(w4, p4, c4), getLinearBrushOtherExtent: KPe(w4, 0) }]).enableBrush({ brushType: "lineX", brushStyle: o, removeOnClick: true }).updateCovers(ybt(l4));
    }, n2.prototype._onBrush = function(e2) {
      var o = e2.areas, l4 = this.axisModel, c4 = l4.axis, h = Er(o, function(p4) {
        return [c4.coordToData(p4.range[0], true), c4.coordToData(p4.range[1], true)];
      });
      (!l4.option.realtime === e2.isEnd || e2.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: l4.id, intervals: h });
    }, n2.prototype.dispose = function() {
      this._brushController.dispose();
    }, n2.type = "parallelAxis", n2;
  }($c);
  function mbt(i, n2, e2) {
    return e2 && e2.type === "axisAreaSelect" && n2.findComponents({ mainType: "parallelAxis", query: e2 })[0] === i;
  }
  function ybt(i) {
    var n2 = i.axis;
    return Er(i.activeIntervals, function(e2) {
      return { brushType: "lineX", panelId: "pl", range: [n2.dataToCoord(e2[0], true), n2.dataToCoord(e2[1], true)] };
    });
  }
  function bbt(i, n2) {
    return n2.getComponent("parallel", i.get("parallelIndex"));
  }
  var _bt = gbt, xbt = { type: "axisAreaSelect", event: "axisAreaSelected" };
  function wbt(i) {
    i.registerAction(xbt, function(n2, e2) {
      e2.eachComponent({ mainType: "parallelAxis", query: n2 }, function(o) {
        o.axis.model.setActiveIntervals(n2.intervals);
      });
    }), i.registerAction("parallelAxisExpand", function(n2, e2) {
      e2.eachComponent({ mainType: "parallel", query: n2 }, function(o) {
        o.setAxisExpand(n2);
      });
    });
  }
  var Sbt = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
  function QPe(i) {
    i.registerComponentView(z1t), i.registerComponentModel(j1t), i.registerCoordinateSystem("parallel", J1t), i.registerPreprocessor(L1t), i.registerComponentModel(cMe), i.registerComponentView(_bt), V3(i, "parallel", cMe, Sbt), wbt(i);
  }
  function Cbt(i) {
    wo(QPe), i.registerChartView(M1t), i.registerSeriesModel(T1t), i.registerVisual(i.PRIORITY.VISUAL.BRUSH, P1t);
  }
  var Mbt = function() {
    function i() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
    }
    return i;
  }(), Abt = function(i) {
    on(n2, i);
    function n2(e2) {
      return i.call(this, e2) || this;
    }
    return n2.prototype.getDefaultShape = function() {
      return new Mbt();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.extent;
      e2.moveTo(o.x1, o.y1), e2.bezierCurveTo(o.cpx1, o.cpy1, o.cpx2, o.cpy2, o.x2, o.y2), o.orient === "vertical" ? (e2.lineTo(o.x2 + l4, o.y2), e2.bezierCurveTo(o.cpx2 + l4, o.cpy2, o.cpx1 + l4, o.cpy1, o.x1 + l4, o.y1)) : (e2.lineTo(o.x2, o.y2 + l4), e2.bezierCurveTo(o.cpx2, o.cpy2 + l4, o.cpx1, o.cpy1 + l4, o.x1, o.y1 + l4)), e2.closePath();
    }, n2.prototype.highlight = function() {
      W_(this);
    }, n2.prototype.downplay = function() {
      H_(this);
    }, n2;
  }(Eo), Ebt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._focusAdjacencyDisabled = false, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = this, h = e2.getGraph(), p4 = this.group, g4 = e2.layoutInfo, y4 = g4.width, _ = g4.height, w4 = e2.getData(), C = e2.getData("edge"), E = e2.get("orient");
      this._model = e2, p4.removeAll(), p4.x = g4.x, p4.y = g4.y, h.eachEdge(function(T) {
        var O = new Abt(), N = Fi(O);
        N.dataIndex = T.dataIndex, N.seriesIndex = e2.seriesIndex, N.dataType = "edge";
        var V = T.getModel(), H = V.getModel("lineStyle"), X = H.get("curveness"), q2 = T.node1.getLayout(), de = T.node1.getModel(), le = de.get("localX"), me = de.get("localY"), ye = T.node2.getLayout(), be = T.node2.getModel(), we = be.get("localX"), Pe = be.get("localY"), ze = T.getLayout(), Re, rt2, ft, et, Jt, xt, It, Wt;
        switch (O.shape.extent = Math.max(1, ze.dy), O.shape.orient = E, E === "vertical" ? (Re = (le != null ? le * y4 : q2.x) + ze.sy, rt2 = (me != null ? me * _ : q2.y) + q2.dy, ft = (we != null ? we * y4 : ye.x) + ze.ty, et = Pe != null ? Pe * _ : ye.y, Jt = Re, xt = rt2 * (1 - X) + et * X, It = ft, Wt = rt2 * X + et * (1 - X)) : (Re = (le != null ? le * y4 : q2.x) + q2.dx, rt2 = (me != null ? me * _ : q2.y) + ze.sy, ft = we != null ? we * y4 : ye.x, et = (Pe != null ? Pe * _ : ye.y) + ze.ty, Jt = Re * (1 - X) + ft * X, xt = rt2, It = Re * X + ft * (1 - X), Wt = et), O.setShape({ x1: Re, y1: rt2, x2: ft, y2: et, cpx1: Jt, cpy1: xt, cpx2: It, cpy2: Wt }), O.useStyle(H.getItemStyle()), O.style.fill) {
          case "source":
            O.style.fill = T.node1.getVisual("color"), O.style.decal = T.node1.getVisual("style").decal;
            break;
          case "target":
            O.style.fill = T.node2.getVisual("color"), O.style.decal = T.node2.getVisual("style").decal;
            break;
          case "gradient":
            var sn = T.node1.getVisual("color"), vn = T.node2.getVisual("color");
            xa(sn) && xa(vn) && (O.style.fill = new B8(0, 0, +(E === "horizontal"), +(E === "vertical"), [{ color: sn, offset: 0 }, { color: vn, offset: 1 }]));
        }
        var $r = V.getModel("emphasis");
        Mp(O, V, "lineStyle", function(Za) {
          return Za.getItemStyle();
        }), p4.add(O), C.setItemGraphicEl(T.dataIndex, O);
        var ga = $r.get("focus");
        pf(O, ga === "adjacency" ? T.getAdjacentDataIndices() : ga, $r.get("blurScope"), $r.get("disabled")), Fi(O).dataType = "edge";
      }), h.eachNode(function(T) {
        var O = T.getLayout(), N = T.getModel(), V = N.get("localX"), H = N.get("localY"), X = N.getModel("emphasis"), q2 = new Is({ shape: { x: V != null ? V * y4 : O.x, y: H != null ? H * _ : O.y, width: O.dx, height: O.dy }, style: N.getModel("itemStyle").getItemStyle(), z2: 10 });
        yv(q2, zd(N), { labelFetcher: e2, labelDataIndex: T.dataIndex, defaultText: T.id }), q2.disableLabelAnimation = true, q2.setStyle("fill", T.getVisual("color")), q2.setStyle("decal", T.getVisual("style").decal), Mp(q2, N), p4.add(q2), w4.setItemGraphicEl(T.dataIndex, q2), Fi(q2).dataType = "node";
        var de = X.get("focus");
        pf(q2, de === "adjacency" ? T.getAdjacentDataIndices() : de, X.get("blurScope"), X.get("disabled"));
      }), w4.eachItemGraphicEl(function(T, O) {
        var N = w4.getItemModel(O);
        N.get("draggable") && (T.drift = function(V, H) {
          c4._focusAdjacencyDisabled = true, this.shape.x += V, this.shape.y += H, this.dirty(), l4.dispatchAction({ type: "dragNode", seriesId: e2.id, dataIndex: w4.getRawIndex(O), localX: this.shape.x / y4, localY: this.shape.y / _ });
        }, T.ondragend = function() {
          c4._focusAdjacencyDisabled = false;
        }, T.draggable = true, T.cursor = "move");
      }), !this._data && e2.isAnimationEnabled() && p4.setClipPath(Ibt(p4.getBoundingRect(), e2, function() {
        p4.removeClipPath();
      })), this._data = e2.getData();
    }, n2.prototype.dispose = function() {
    }, n2.type = "sankey", n2;
  }(Ru);
  function Ibt(i, n2, e2) {
    var o = new Is({ shape: { x: i.x - 10, y: i.y - 10, width: 0, height: i.height + 20 } });
    return bc(o, { shape: { width: i.width + 20 } }, n2, e2), o;
  }
  var Tbt = Ebt, Dbt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      var l4 = e2.edges || e2.links, c4 = e2.data || e2.nodes, h = e2.levels;
      this.levelModels = [];
      for (var p4 = this.levelModels, g4 = 0; g4 < h.length; g4++)
        h[g4].depth != null && h[g4].depth >= 0 && (p4[h[g4].depth] = new Ou(h[g4], this, o));
      if (c4 && l4) {
        var y4 = OPe(c4, l4, this, true, _);
        return y4.data;
      }
      function _(w4, C) {
        w4.wrapMethod("getItemModel", function(E, T) {
          var O = E.parentModel, N = O.getData().getItemLayout(T);
          if (N) {
            var V = N.depth, H = O.levelModels[V];
            H && (E.parentModel = H);
          }
          return E;
        }), C.wrapMethod("getItemModel", function(E, T) {
          var O = E.parentModel, N = O.getGraph().getEdgeByIndex(T), V = N.node1.getLayout();
          if (V) {
            var H = V.depth, X = O.levelModels[H];
            X && (E.parentModel = X);
          }
          return E;
        });
      }
    }, n2.prototype.setNodePosition = function(e2, o) {
      var l4 = this.option.data || this.option.nodes, c4 = l4[e2];
      c4.localX = o[0], c4.localY = o[1];
    }, n2.prototype.getGraph = function() {
      return this.getData().graph;
    }, n2.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      function c4(E) {
        return isNaN(E) || E == null;
      }
      if (l4 === "edge") {
        var h = this.getDataParams(e2, l4), p4 = h.data, g4 = h.value, y4 = p4.source + " -- " + p4.target;
        return Qh("nameValue", { name: y4, value: g4, noValue: c4(g4) });
      } else {
        var _ = this.getGraph().getNodeByIndex(e2), w4 = _.getLayout().value, C = this.getDataParams(e2, l4).data.name;
        return Qh("nameValue", { name: C != null ? C + "" : null, value: w4, noValue: c4(w4) });
      }
    }, n2.prototype.optionUpdated = function() {
    }, n2.prototype.getDataParams = function(e2, o) {
      var l4 = i.prototype.getDataParams.call(this, e2, o);
      if (l4.value == null && o === "node") {
        var c4 = this.getGraph().getNodeByIndex(e2), h = c4.getLayout().value;
        l4.value = h;
      }
      return l4;
    }, n2.type = "series.sankey", n2.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, n2;
  }(_c2), kbt = Dbt;
  function Pbt(i, n2) {
    i.eachSeriesByType("sankey", function(e2) {
      var o = e2.get("nodeWidth"), l4 = e2.get("nodeGap"), c4 = Lbt(e2, n2);
      e2.layoutInfo = c4;
      var h = c4.width, p4 = c4.height, g4 = e2.getGraph(), y4 = g4.nodes, _ = g4.edges;
      Rbt(y4);
      var w4 = Yl(y4, function(O) {
        return O.getLayout().value === 0;
      }), C = w4.length !== 0 ? 0 : e2.get("layoutIterations"), E = e2.get("orient"), T = e2.get("nodeAlign");
      Obt(y4, _, o, l4, h, p4, C, E, T);
    });
  }
  function Lbt(i, n2) {
    return bh(i.getBoxLayoutParams(), { width: n2.getWidth(), height: n2.getHeight() });
  }
  function Obt(i, n2, e2, o, l4, c4, h, p4, g4) {
    Fbt(i, n2, e2, l4, c4, p4, g4), Bbt(i, n2, c4, l4, o, h, p4), Zbt(i, p4);
  }
  function Rbt(i) {
    Ve(i, function(n2) {
      var e2 = ZC(n2.outEdges, JH), o = ZC(n2.inEdges, JH), l4 = n2.getValue() || 0, c4 = Math.max(e2, o, l4);
      n2.setLayout({ value: c4 }, true);
    });
  }
  function Fbt(i, n2, e2, o, l4, c4, h) {
    for (var p4 = [], g4 = [], y4 = [], _ = [], w4 = 0, C = 0; C < n2.length; C++)
      p4[C] = 1;
    for (var C = 0; C < i.length; C++)
      g4[C] = i[C].inEdges.length, g4[C] === 0 && y4.push(i[C]);
    for (var E = -1; y4.length; ) {
      for (var T = 0; T < y4.length; T++) {
        var O = y4[T], N = O.hostGraph.data.getRawDataItem(O.dataIndex), V = N.depth != null && N.depth >= 0;
        V && N.depth > E && (E = N.depth), O.setLayout({ depth: V ? N.depth : w4 }, true), c4 === "vertical" ? O.setLayout({ dy: e2 }, true) : O.setLayout({ dx: e2 }, true);
        for (var H = 0; H < O.outEdges.length; H++) {
          var X = O.outEdges[H], q2 = n2.indexOf(X);
          p4[q2] = 0;
          var de = X.node2, le = i.indexOf(de);
          --g4[le] === 0 && _.indexOf(de) < 0 && _.push(de);
        }
      }
      ++w4, y4 = _, _ = [];
    }
    for (var C = 0; C < p4.length; C++)
      if (p4[C] === 1)
        throw new Error("Sankey is a DAG, the original data has cycle!");
    var me = E > w4 - 1 ? E : w4 - 1;
    h && h !== "left" && Nbt(i, h, c4, me);
    var ye = c4 === "vertical" ? (l4 - e2) / me : (o - e2) / me;
    zbt(i, ye, c4);
  }
  function e3e(i) {
    var n2 = i.hostGraph.data.getRawDataItem(i.dataIndex);
    return n2.depth != null && n2.depth >= 0;
  }
  function Nbt(i, n2, e2, o) {
    if (n2 === "right") {
      for (var l4 = [], c4 = i, h = 0; c4.length; ) {
        for (var p4 = 0; p4 < c4.length; p4++) {
          var g4 = c4[p4];
          g4.setLayout({ skNodeHeight: h }, true);
          for (var y4 = 0; y4 < g4.inEdges.length; y4++) {
            var _ = g4.inEdges[y4];
            l4.indexOf(_.node1) < 0 && l4.push(_.node1);
          }
        }
        c4 = l4, l4 = [], ++h;
      }
      Ve(i, function(w4) {
        e3e(w4) || w4.setLayout({ depth: Math.max(0, o - w4.getLayout().skNodeHeight) }, true);
      });
    } else
      n2 === "justify" && Vbt(i, o);
  }
  function Vbt(i, n2) {
    Ve(i, function(e2) {
      !e3e(e2) && !e2.outEdges.length && e2.setLayout({ depth: n2 }, true);
    });
  }
  function zbt(i, n2, e2) {
    Ve(i, function(o) {
      var l4 = o.getLayout().depth * n2;
      e2 === "vertical" ? o.setLayout({ y: l4 }, true) : o.setLayout({ x: l4 }, true);
    });
  }
  function Bbt(i, n2, e2, o, l4, c4, h) {
    var p4 = jbt(i, h);
    Gbt(p4, n2, e2, o, l4, h), Oae(p4, l4, e2, o, h);
    for (var g4 = 1; c4 > 0; c4--)
      g4 *= 0.99, Wbt(p4, g4, h), Oae(p4, l4, e2, o, h), Ybt(p4, g4, h), Oae(p4, l4, e2, o, h);
  }
  function jbt(i, n2) {
    var e2 = [], o = n2 === "vertical" ? "y" : "x", l4 = $ie(i, function(c4) {
      return c4.getLayout()[o];
    });
    return l4.keys.sort(function(c4, h) {
      return c4 - h;
    }), Ve(l4.keys, function(c4) {
      e2.push(l4.buckets.get(c4));
    }), e2;
  }
  function Gbt(i, n2, e2, o, l4, c4) {
    var h = 1 / 0;
    Ve(i, function(p4) {
      var g4 = p4.length, y4 = 0;
      Ve(p4, function(w4) {
        y4 += w4.getLayout().value;
      });
      var _ = c4 === "vertical" ? (o - (g4 - 1) * l4) / y4 : (e2 - (g4 - 1) * l4) / y4;
      _ < h && (h = _);
    }), Ve(i, function(p4) {
      Ve(p4, function(g4, y4) {
        var _ = g4.getLayout().value * h;
        c4 === "vertical" ? (g4.setLayout({ x: y4 }, true), g4.setLayout({ dx: _ }, true)) : (g4.setLayout({ y: y4 }, true), g4.setLayout({ dy: _ }, true));
      });
    }), Ve(n2, function(p4) {
      var g4 = +p4.getValue() * h;
      p4.setLayout({ dy: g4 }, true);
    });
  }
  function Oae(i, n2, e2, o, l4) {
    var c4 = l4 === "vertical" ? "x" : "y";
    Ve(i, function(h) {
      h.sort(function(O, N) {
        return O.getLayout()[c4] - N.getLayout()[c4];
      });
      for (var p4, g4, y4, _ = 0, w4 = h.length, C = l4 === "vertical" ? "dx" : "dy", E = 0; E < w4; E++)
        g4 = h[E], y4 = _ - g4.getLayout()[c4], y4 > 0 && (p4 = g4.getLayout()[c4] + y4, l4 === "vertical" ? g4.setLayout({ x: p4 }, true) : g4.setLayout({ y: p4 }, true)), _ = g4.getLayout()[c4] + g4.getLayout()[C] + n2;
      var T = l4 === "vertical" ? o : e2;
      if (y4 = _ - n2 - T, y4 > 0) {
        p4 = g4.getLayout()[c4] - y4, l4 === "vertical" ? g4.setLayout({ x: p4 }, true) : g4.setLayout({ y: p4 }, true), _ = p4;
        for (var E = w4 - 2; E >= 0; --E)
          g4 = h[E], y4 = g4.getLayout()[c4] + g4.getLayout()[C] + n2 - _, y4 > 0 && (p4 = g4.getLayout()[c4] - y4, l4 === "vertical" ? g4.setLayout({ x: p4 }, true) : g4.setLayout({ y: p4 }, true)), _ = g4.getLayout()[c4];
      }
    });
  }
  function Wbt(i, n2, e2) {
    Ve(i.slice().reverse(), function(o) {
      Ve(o, function(l4) {
        if (l4.outEdges.length) {
          var c4 = ZC(l4.outEdges, Hbt, e2) / ZC(l4.outEdges, JH);
          if (isNaN(c4)) {
            var h = l4.outEdges.length;
            c4 = h ? ZC(l4.outEdges, $bt, e2) / h : 0;
          }
          if (e2 === "vertical") {
            var p4 = l4.getLayout().x + (c4 - nM(l4, e2)) * n2;
            l4.setLayout({ x: p4 }, true);
          } else {
            var g4 = l4.getLayout().y + (c4 - nM(l4, e2)) * n2;
            l4.setLayout({ y: g4 }, true);
          }
        }
      });
    });
  }
  function Hbt(i, n2) {
    return nM(i.node2, n2) * i.getValue();
  }
  function $bt(i, n2) {
    return nM(i.node2, n2);
  }
  function Ubt(i, n2) {
    return nM(i.node1, n2) * i.getValue();
  }
  function qbt(i, n2) {
    return nM(i.node1, n2);
  }
  function nM(i, n2) {
    return n2 === "vertical" ? i.getLayout().x + i.getLayout().dx / 2 : i.getLayout().y + i.getLayout().dy / 2;
  }
  function JH(i) {
    return i.getValue();
  }
  function ZC(i, n2, e2) {
    for (var o = 0, l4 = i.length, c4 = -1; ++c4 < l4; ) {
      var h = +n2(i[c4], e2);
      isNaN(h) || (o += h);
    }
    return o;
  }
  function Ybt(i, n2, e2) {
    Ve(i, function(o) {
      Ve(o, function(l4) {
        if (l4.inEdges.length) {
          var c4 = ZC(l4.inEdges, Ubt, e2) / ZC(l4.inEdges, JH);
          if (isNaN(c4)) {
            var h = l4.inEdges.length;
            c4 = h ? ZC(l4.inEdges, qbt, e2) / h : 0;
          }
          if (e2 === "vertical") {
            var p4 = l4.getLayout().x + (c4 - nM(l4, e2)) * n2;
            l4.setLayout({ x: p4 }, true);
          } else {
            var g4 = l4.getLayout().y + (c4 - nM(l4, e2)) * n2;
            l4.setLayout({ y: g4 }, true);
          }
        }
      });
    });
  }
  function Zbt(i, n2) {
    var e2 = n2 === "vertical" ? "x" : "y";
    Ve(i, function(o) {
      o.outEdges.sort(function(l4, c4) {
        return l4.node2.getLayout()[e2] - c4.node2.getLayout()[e2];
      }), o.inEdges.sort(function(l4, c4) {
        return l4.node1.getLayout()[e2] - c4.node1.getLayout()[e2];
      });
    }), Ve(i, function(o) {
      var l4 = 0, c4 = 0;
      Ve(o.outEdges, function(h) {
        h.setLayout({ sy: l4 }, true), l4 += h.getLayout().dy;
      }), Ve(o.inEdges, function(h) {
        h.setLayout({ ty: c4 }, true), c4 += h.getLayout().dy;
      });
    });
  }
  function Xbt(i) {
    i.eachSeriesByType("sankey", function(n2) {
      var e2 = n2.getGraph(), o = e2.nodes;
      if (o.length) {
        var l4 = 1 / 0, c4 = -1 / 0;
        Ve(o, function(h) {
          var p4 = h.getLayout().value;
          p4 < l4 && (l4 = p4), p4 > c4 && (c4 = p4);
        }), Ve(o, function(h) {
          var p4 = new Cp({ type: "color", mappingMethod: "linear", dataExtent: [l4, c4], visual: n2.get("color") }), g4 = p4.mapValueToVisual(h.getLayout().value), y4 = h.getModel().get(["itemStyle", "color"]);
          y4 != null ? (h.setVisual("color", y4), h.setVisual("style", { fill: y4 })) : (h.setVisual("color", g4), h.setVisual("style", { fill: g4 }));
        });
      }
    });
  }
  function Kbt(i) {
    i.registerChartView(Tbt), i.registerSeriesModel(kbt), i.registerLayout(Pbt), i.registerVisual(Xbt), i.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(n2, e2) {
      e2.eachComponent({ mainType: "series", subType: "sankey", query: n2 }, function(o) {
        o.setNodePosition(n2.dataIndex, [n2.localX, n2.localY]);
      });
    });
  }
  var t3e = function() {
    function i() {
    }
    return i.prototype.getInitialData = function(n2, e2) {
      var o, l4 = e2.getComponent("xAxis", this.get("xAxisIndex")), c4 = e2.getComponent("yAxis", this.get("yAxisIndex")), h = l4.get("type"), p4 = c4.get("type"), g4;
      h === "category" ? (n2.layout = "horizontal", o = l4.getOrdinalMeta(), g4 = true) : p4 === "category" ? (n2.layout = "vertical", o = c4.getOrdinalMeta(), g4 = true) : n2.layout = n2.layout || "horizontal";
      var y4 = ["x", "y"], _ = n2.layout === "horizontal" ? 0 : 1, w4 = this._baseAxisDim = y4[_], C = y4[1 - _], E = [l4, c4], T = E[_].get("type"), O = E[1 - _].get("type"), N = n2.data;
      if (N && g4) {
        var V = [];
        Ve(N, function(q2, de) {
          var le;
          Mr(q2) ? (le = q2.slice(), q2.unshift(de)) : Mr(q2.value) ? (le = rr({}, q2), le.value = le.value.slice(), q2.value.unshift(de)) : le = q2, V.push(le);
        }), n2.data = V;
      }
      var H = this.defaultValueDimensions, X = [{ name: w4, type: BH(T), ordinalMeta: o, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: C, type: BH(O), dimsDef: H.slice() }];
      return rL(this, { coordDimensions: X, dimensionsCount: H.length + 1, encodeDefaulter: zi(EDe, X, this) });
    }, i.prototype.getBaseAxis = function() {
      var n2 = this._baseAxisDim;
      return this.ecModel.getComponent(n2 + "Axis", this.get(n2 + "AxisIndex")).axis;
    }, i;
  }(), n3e = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], e2.visualDrawType = "stroke", e2;
    }
    return n2.type = "series.boxplot", n2.dependencies = ["xAxis", "yAxis", "grid"], n2.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, n2;
  }(_c2);
  Kf(n3e, t3e, true);
  var Jbt = n3e, Qbt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = this.group, p4 = this._data;
      this._data || h.removeAll();
      var g4 = e2.get("layout") === "horizontal" ? 1 : 0;
      c4.diff(p4).add(function(y4) {
        if (c4.hasValue(y4)) {
          var _ = c4.getItemLayout(y4), w4 = mMe(_, c4, y4, g4, true);
          c4.setItemGraphicEl(y4, w4), h.add(w4);
        }
      }).update(function(y4, _) {
        var w4 = p4.getItemGraphicEl(_);
        if (!c4.hasValue(y4)) {
          h.remove(w4);
          return;
        }
        var C = c4.getItemLayout(y4);
        w4 ? (ob(w4), r3e(C, w4, c4, y4)) : w4 = mMe(C, c4, y4, g4), h.add(w4), c4.setItemGraphicEl(y4, w4);
      }).remove(function(y4) {
        var _ = p4.getItemGraphicEl(y4);
        _ && h.remove(_);
      }).execute(), this._data = c4;
    }, n2.prototype.remove = function(e2) {
      var o = this.group, l4 = this._data;
      this._data = null, l4 && l4.eachItemGraphicEl(function(c4) {
        c4 && o.remove(c4);
      });
    }, n2.type = "boxplot", n2;
  }(Ru), e_t = function() {
    function i() {
    }
    return i;
  }(), t_t = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "boxplotBoxPath", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new e_t();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.points, c4 = 0;
      for (e2.moveTo(l4[c4][0], l4[c4][1]), c4++; c4 < 4; c4++)
        e2.lineTo(l4[c4][0], l4[c4][1]);
      for (e2.closePath(); c4 < l4.length; c4++)
        e2.moveTo(l4[c4][0], l4[c4][1]), c4++, e2.lineTo(l4[c4][0], l4[c4][1]);
    }, n2;
  }(Eo);
  function mMe(i, n2, e2, o, l4) {
    var c4 = i.ends, h = new t_t({ shape: { points: l4 ? n_t(c4, o, i) : c4 } });
    return r3e(i, h, n2, e2, l4), h;
  }
  function r3e(i, n2, e2, o, l4) {
    var c4 = e2.hostModel, h = W8[l4 ? "initProps" : "updateProps"];
    h(n2, { shape: { points: i.ends } }, c4, o), n2.useStyle(e2.getItemVisual(o, "style")), n2.style.strokeNoScale = true, n2.z2 = 100;
    var p4 = e2.getItemModel(o), g4 = p4.getModel("emphasis");
    Mp(n2, p4), pf(n2, g4.get("focus"), g4.get("blurScope"), g4.get("disabled"));
  }
  function n_t(i, n2, e2) {
    return Er(i, function(o) {
      return o = o.slice(), o[n2] = e2.initBaseline, o;
    });
  }
  var r_t = Qbt;
  function a_t(i, n2) {
  }
  var QN = Ve;
  function i_t(i) {
    var n2 = o_t(i);
    QN(n2, function(e2) {
      var o = e2.seriesModels;
      !o.length || (s_t(e2), QN(o, function(l4, c4) {
        l_t(l4, e2.boxOffsetList[c4], e2.boxWidthList[c4]);
      }));
    });
  }
  function o_t(i) {
    var n2 = [], e2 = [];
    return i.eachSeriesByType("boxplot", function(o) {
      var l4 = o.getBaseAxis(), c4 = go(e2, l4);
      c4 < 0 && (c4 = e2.length, e2[c4] = l4, n2[c4] = { axis: l4, seriesModels: [] }), n2[c4].seriesModels.push(o);
    }), n2;
  }
  function s_t(i) {
    var n2 = i.axis, e2 = i.seriesModels, o = e2.length, l4 = i.boxWidthList = [], c4 = i.boxOffsetList = [], h = [], p4;
    if (n2.type === "category")
      p4 = n2.getBandWidth();
    else {
      var g4 = 0;
      QN(e2, function(T) {
        g4 = Math.max(g4, T.getData().count());
      });
      var y4 = n2.getExtent();
      p4 = Math.abs(y4[1] - y4[0]) / g4;
    }
    QN(e2, function(T) {
      var O = T.get("boxWidth");
      Mr(O) || (O = [O, O]), h.push([ma(O[0], p4) || 0, ma(O[1], p4) || 0]);
    });
    var _ = p4 * 0.8 - 2, w4 = _ / o * 0.3, C = (_ - w4 * (o - 1)) / o, E = C / 2 - _ / 2;
    QN(e2, function(T, O) {
      c4.push(E), E += w4 + C, l4.push(Math.min(Math.max(C, h[O][0]), h[O][1]));
    });
  }
  function l_t(i, n2, e2) {
    var o = i.coordinateSystem, l4 = i.getData(), c4 = e2 / 2, h = i.get("layout") === "horizontal" ? 0 : 1, p4 = 1 - h, g4 = ["x", "y"], y4 = l4.mapDimension(g4[h]), _ = l4.mapDimensionsAll(g4[p4]);
    if (y4 == null || _.length < 5)
      return;
    for (var w4 = 0; w4 < l4.count(); w4++) {
      var C = l4.get(y4, w4), E = X(C, _[2], w4), T = X(C, _[0], w4), O = X(C, _[1], w4), N = X(C, _[3], w4), V = X(C, _[4], w4), H = [];
      q2(H, O, false), q2(H, N, true), H.push(T, O, V, N), de(H, T), de(H, V), de(H, E), l4.setItemLayout(w4, { initBaseline: E[p4], ends: H });
    }
    function X(le, me, ye) {
      var be = l4.get(me, ye), we = [];
      we[h] = le, we[p4] = be;
      var Pe;
      return isNaN(le) || isNaN(be) ? Pe = [NaN, NaN] : (Pe = o.dataToPoint(we), Pe[h] += n2), Pe;
    }
    function q2(le, me, ye) {
      var be = me.slice(), we = me.slice();
      be[h] += c4, we[h] -= c4, ye ? le.push(be, we) : le.push(we, be);
    }
    function de(le, me) {
      var ye = me.slice(), be = me.slice();
      ye[h] -= c4, be[h] += c4, le.push(ye, be);
    }
  }
  function u_t(i, n2) {
    n2 = n2 || {};
    for (var e2 = [], o = [], l4 = n2.boundIQR, c4 = l4 === "none" || l4 === 0, h = 0; h < i.length; h++) {
      var p4 = Ly(i[h].slice()), g4 = ure(p4, 0.25), y4 = ure(p4, 0.5), _ = ure(p4, 0.75), w4 = p4[0], C = p4[p4.length - 1], E = (l4 == null ? 1.5 : l4) * (_ - g4), T = c4 ? w4 : Math.max(w4, g4 - E), O = c4 ? C : Math.min(C, _ + E), N = n2.itemNameFormatter, V = si(N) ? N({ value: h }) : xa(N) ? N.replace("{value}", h + "") : h + "";
      e2.push([V, T, g4, y4, _, O]);
      for (var H = 0; H < p4.length; H++) {
        var X = p4[H];
        if (X < T || X > O) {
          var q2 = [V, X];
          o.push(q2);
        }
      }
    }
    return { boxData: e2, outliers: o };
  }
  var c_t = { type: "echarts:boxplot", transform: function(n2) {
    var e2 = n2.upstream;
    if (e2.sourceFormat !== mv) {
      var o = "";
      dl(o);
    }
    var l4 = u_t(e2.getRawData(), n2.config);
    return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: l4.boxData }, { data: l4.outliers }];
  } };
  function f_t(i) {
    i.registerSeriesModel(Jbt), i.registerChartView(r_t), i.registerVisual(a_t), i.registerLayout(i_t), i.registerTransform(c_t);
  }
  var h_t = ["color", "borderColor"], d_t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(e2), this._isLargeDraw ? this._renderLarge(e2) : this._renderNormal(e2);
    }, n2.prototype.incrementalPrepareRender = function(e2, o, l4) {
      this._clear(), this._updateDrawMode(e2);
    }, n2.prototype.incrementalRender = function(e2, o, l4, c4) {
      this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(e2, o) : this._incrementalRenderNormal(e2, o);
    }, n2.prototype.eachRendered = function(e2) {
      oM(this._progressiveEls || this.group, e2);
    }, n2.prototype._updateDrawMode = function(e2) {
      var o = e2.pipelineContext.large;
      (this._isLargeDraw == null || o !== this._isLargeDraw) && (this._isLargeDraw = o, this._clear());
    }, n2.prototype._renderNormal = function(e2) {
      var o = e2.getData(), l4 = this._data, c4 = this.group, h = o.getLayout("isSimpleBox"), p4 = e2.get("clip", true), g4 = e2.coordinateSystem, y4 = g4.getArea && g4.getArea();
      this._data || c4.removeAll(), o.diff(l4).add(function(_) {
        if (o.hasValue(_)) {
          var w4 = o.getItemLayout(_);
          if (p4 && yMe(y4, w4))
            return;
          var C = Rae(w4, _, true);
          bc(C, { shape: { points: w4.ends } }, e2, _), Fae(C, o, _, h), c4.add(C), o.setItemGraphicEl(_, C);
        }
      }).update(function(_, w4) {
        var C = l4.getItemGraphicEl(w4);
        if (!o.hasValue(_)) {
          c4.remove(C);
          return;
        }
        var E = o.getItemLayout(_);
        if (p4 && yMe(y4, E)) {
          c4.remove(C);
          return;
        }
        C ? (Vs(C, { shape: { points: E.ends } }, e2, _), ob(C)) : C = Rae(E), Fae(C, o, _, h), c4.add(C), o.setItemGraphicEl(_, C);
      }).remove(function(_) {
        var w4 = l4.getItemGraphicEl(_);
        w4 && c4.remove(w4);
      }).execute(), this._data = o;
    }, n2.prototype._renderLarge = function(e2) {
      this._clear(), _Me(e2, this.group);
      var o = e2.get("clip", true) ? q$(e2.coordinateSystem, false, e2) : null;
      o ? this.group.setClipPath(o) : this.group.removeClipPath();
    }, n2.prototype._incrementalRenderNormal = function(e2, o) {
      for (var l4 = o.getData(), c4 = l4.getLayout("isSimpleBox"), h; (h = e2.next()) != null; ) {
        var p4 = l4.getItemLayout(h), g4 = Rae(p4);
        Fae(g4, l4, h, c4), g4.incremental = true, this.group.add(g4), this._progressiveEls.push(g4);
      }
    }, n2.prototype._incrementalRenderLarge = function(e2, o) {
      _Me(o, this.group, this._progressiveEls, true);
    }, n2.prototype.remove = function(e2) {
      this._clear();
    }, n2.prototype._clear = function() {
      this.group.removeAll(), this._data = null;
    }, n2.type = "candlestick", n2;
  }(Ru), p_t = function() {
    function i() {
    }
    return i;
  }(), v_t = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "normalCandlestickBox", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new p_t();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.points;
      this.__simpleBox ? (e2.moveTo(l4[4][0], l4[4][1]), e2.lineTo(l4[6][0], l4[6][1])) : (e2.moveTo(l4[0][0], l4[0][1]), e2.lineTo(l4[1][0], l4[1][1]), e2.lineTo(l4[2][0], l4[2][1]), e2.lineTo(l4[3][0], l4[3][1]), e2.closePath(), e2.moveTo(l4[4][0], l4[4][1]), e2.lineTo(l4[5][0], l4[5][1]), e2.moveTo(l4[6][0], l4[6][1]), e2.lineTo(l4[7][0], l4[7][1]));
    }, n2;
  }(Eo);
  function Rae(i, n2, e2) {
    var o = i.ends;
    return new v_t({ shape: { points: e2 ? g_t(o, i) : o }, z2: 100 });
  }
  function yMe(i, n2) {
    for (var e2 = true, o = 0; o < n2.ends.length; o++)
      if (i.contain(n2.ends[o][0], n2.ends[o][1])) {
        e2 = false;
        break;
      }
    return e2;
  }
  function Fae(i, n2, e2, o) {
    var l4 = n2.getItemModel(e2);
    i.useStyle(n2.getItemVisual(e2, "style")), i.style.strokeNoScale = true, i.__simpleBox = o, Mp(i, l4);
  }
  function g_t(i, n2) {
    return Er(i, function(e2) {
      return e2 = e2.slice(), e2[1] = n2.initBaseline, e2;
    });
  }
  var m_t = function() {
    function i() {
    }
    return i;
  }(), bMe = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o.type = "largeCandlestickBox", o;
    }
    return n2.prototype.getDefaultShape = function() {
      return new m_t();
    }, n2.prototype.buildPath = function(e2, o) {
      for (var l4 = o.points, c4 = 0; c4 < l4.length; )
        if (this.__sign === l4[c4++]) {
          var h = l4[c4++];
          e2.moveTo(h, l4[c4++]), e2.lineTo(h, l4[c4++]);
        } else
          c4 += 3;
    }, n2;
  }(Eo);
  function _Me(i, n2, e2, o) {
    var l4 = i.getData(), c4 = l4.getLayout("largePoints"), h = new bMe({ shape: { points: c4 }, __sign: 1 });
    n2.add(h);
    var p4 = new bMe({ shape: { points: c4 }, __sign: -1 });
    n2.add(p4), xMe(1, h, i), xMe(-1, p4, i), o && (h.incremental = true, p4.incremental = true), e2 && e2.push(h, p4);
  }
  function xMe(i, n2, e2, o) {
    var l4 = e2.get(["itemStyle", i > 0 ? "borderColor" : "borderColor0"]) || e2.get(["itemStyle", i > 0 ? "color" : "color0"]), c4 = e2.getModel("itemStyle").getItemStyle(h_t);
    n2.useStyle(c4), n2.style.fill = null, n2.style.stroke = l4;
  }
  var y_t = d_t, a3e = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], e2;
    }
    return n2.prototype.getShadowDim = function() {
      return "open";
    }, n2.prototype.brushSelector = function(e2, o, l4) {
      var c4 = o.getItemLayout(e2);
      return c4 && l4.rect(c4.brushRect);
    }, n2.type = "series.candlestick", n2.dependencies = ["xAxis", "yAxis", "grid"], n2.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, n2;
  }(_c2);
  Kf(a3e, t3e, true);
  var b_t = a3e;
  function __t(i) {
    !i || !Mr(i.series) || Ve(i.series, function(n2) {
      mi(n2) && n2.type === "k" && (n2.type = "candlestick");
    });
  }
  var x_t = ["itemStyle", "borderColor"], w_t = ["itemStyle", "borderColor0"], S_t = ["itemStyle", "color"], C_t = ["itemStyle", "color0"], M_t = { seriesType: "candlestick", plan: eL(), performRawSeries: true, reset: function(i, n2) {
    function e2(c4, h) {
      return h.get(c4 > 0 ? S_t : C_t);
    }
    function o(c4, h) {
      return h.get(c4 > 0 ? x_t : w_t);
    }
    if (!n2.isSeriesFiltered(i)) {
      var l4 = i.pipelineContext.large;
      return !l4 && { progress: function(c4, h) {
        for (var p4; (p4 = c4.next()) != null; ) {
          var g4 = h.getItemModel(p4), y4 = h.getItemLayout(p4).sign, _ = g4.getItemStyle();
          _.fill = e2(y4, g4), _.stroke = o(y4, g4) || _.fill;
          var w4 = h.ensureUniqueItemVisual(p4, "style");
          rr(w4, _);
        }
      } };
    }
  } }, A_t = M_t, E_t = { seriesType: "candlestick", plan: eL(), reset: function(i) {
    var n2 = i.coordinateSystem, e2 = i.getData(), o = I_t(i, e2), l4 = 0, c4 = 1, h = ["x", "y"], p4 = e2.getDimensionIndex(e2.mapDimension(h[l4])), g4 = Er(e2.mapDimensionsAll(h[c4]), e2.getDimensionIndex, e2), y4 = g4[0], _ = g4[1], w4 = g4[2], C = g4[3];
    if (e2.setLayout({ candleWidth: o, isSimpleBox: o <= 1.3 }), p4 < 0 || g4.length < 4)
      return;
    return { progress: i.pipelineContext.large ? T : E };
    function E(O, N) {
      for (var V, H = N.getStore(); (V = O.next()) != null; ) {
        var X = H.get(p4, V), q2 = H.get(y4, V), de = H.get(_, V), le = H.get(w4, V), me = H.get(C, V), ye = Math.min(q2, de), be = Math.max(q2, de), we = ft(ye, X), Pe = ft(be, X), ze = ft(le, X), Re = ft(me, X), rt2 = [];
        et(rt2, Pe, 0), et(rt2, we, 1), rt2.push(xt(Re), xt(Pe), xt(ze), xt(we)), N.setItemLayout(V, { sign: wMe(H, V, q2, de, _), initBaseline: q2 > de ? Pe[c4] : we[c4], ends: rt2, brushRect: Jt(le, me, X) });
      }
      function ft(It, Wt) {
        var sn = [];
        return sn[l4] = Wt, sn[c4] = It, isNaN(Wt) || isNaN(It) ? [NaN, NaN] : n2.dataToPoint(sn);
      }
      function et(It, Wt, sn) {
        var vn = Wt.slice(), $r = Wt.slice();
        vn[l4] = aH(vn[l4] + o / 2, 1, false), $r[l4] = aH($r[l4] - o / 2, 1, true), sn ? It.push(vn, $r) : It.push($r, vn);
      }
      function Jt(It, Wt, sn) {
        var vn = ft(It, sn), $r = ft(Wt, sn);
        return vn[l4] -= o / 2, $r[l4] -= o / 2, { x: vn[0], y: vn[1], width: o, height: $r[1] - vn[1] };
      }
      function xt(It) {
        return It[l4] = aH(It[l4], 1), It;
      }
    }
    function T(O, N) {
      for (var V = j_(O.count * 4), H = 0, X, q2 = [], de = [], le, me = N.getStore(); (le = O.next()) != null; ) {
        var ye = me.get(p4, le), be = me.get(y4, le), we = me.get(_, le), Pe = me.get(w4, le), ze = me.get(C, le);
        if (isNaN(ye) || isNaN(Pe) || isNaN(ze)) {
          V[H++] = NaN, H += 3;
          continue;
        }
        V[H++] = wMe(me, le, be, we, _), q2[l4] = ye, q2[c4] = Pe, X = n2.dataToPoint(q2, null, de), V[H++] = X ? X[0] : NaN, V[H++] = X ? X[1] : NaN, q2[c4] = ze, X = n2.dataToPoint(q2, null, de), V[H++] = X ? X[1] : NaN;
      }
      N.setLayout("largePoints", V);
    }
  } };
  function wMe(i, n2, e2, o, l4) {
    var c4;
    return e2 > o ? c4 = -1 : e2 < o ? c4 = 1 : c4 = n2 > 0 ? i.get(l4, n2 - 1) <= o ? 1 : -1 : 1, c4;
  }
  function I_t(i, n2) {
    var e2 = i.getBaseAxis(), o, l4 = e2.type === "category" ? e2.getBandWidth() : (o = e2.getExtent(), Math.abs(o[1] - o[0]) / n2.count()), c4 = ma(so(i.get("barMaxWidth"), l4), l4), h = ma(so(i.get("barMinWidth"), 1), l4), p4 = i.get("barWidth");
    return p4 != null ? ma(p4, l4) : Math.max(Math.min(l4 / 2, c4), h);
  }
  var T_t = E_t;
  function D_t(i) {
    i.registerChartView(y_t), i.registerSeriesModel(b_t), i.registerPreprocessor(__t), i.registerVisual(A_t), i.registerLayout(T_t);
  }
  function SMe(i, n2) {
    var e2 = n2.rippleEffectColor || n2.color;
    i.eachChild(function(o) {
      o.attr({ z: n2.z, zlevel: n2.zlevel, style: { stroke: n2.brushType === "stroke" ? e2 : null, fill: n2.brushType === "fill" ? e2 : null } });
    });
  }
  var k_t = function(i) {
    on(n2, i);
    function n2(e2, o) {
      var l4 = i.call(this) || this, c4 = new X8(e2, o), h = new Ti();
      return l4.add(c4), l4.add(h), l4.updateData(e2, o), l4;
    }
    return n2.prototype.stopEffectAnimation = function() {
      this.childAt(1).removeAll();
    }, n2.prototype.startEffectAnimation = function(e2) {
      for (var o = e2.symbolType, l4 = e2.color, c4 = e2.rippleNumber, h = this.childAt(1), p4 = 0; p4 < c4; p4++) {
        var g4 = Xf(o, -1, -1, 2, 2, l4);
        g4.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
        var y4 = -p4 / c4 * e2.period + e2.effectOffset;
        g4.animate("", true).when(e2.period, { scaleX: e2.rippleScale / 2, scaleY: e2.rippleScale / 2 }).delay(y4).start(), g4.animateStyle(true).when(e2.period, { opacity: 0 }).delay(y4).start(), h.add(g4);
      }
      SMe(h, e2);
    }, n2.prototype.updateEffectAnimation = function(e2) {
      for (var o = this._effectCfg, l4 = this.childAt(1), c4 = ["symbolType", "period", "rippleScale", "rippleNumber"], h = 0; h < c4.length; h++) {
        var p4 = c4[h];
        if (o[p4] !== e2[p4]) {
          this.stopEffectAnimation(), this.startEffectAnimation(e2);
          return;
        }
      }
      SMe(l4, e2);
    }, n2.prototype.highlight = function() {
      W_(this);
    }, n2.prototype.downplay = function() {
      H_(this);
    }, n2.prototype.getSymbolType = function() {
      var e2 = this.childAt(0);
      return e2 && e2.getSymbolType();
    }, n2.prototype.updateData = function(e2, o) {
      var l4 = this, c4 = e2.hostModel;
      this.childAt(0).updateData(e2, o);
      var h = this.childAt(1), p4 = e2.getItemModel(o), g4 = e2.getItemVisual(o, "symbol"), y4 = U8(e2.getItemVisual(o, "symbolSize")), _ = e2.getItemVisual(o, "style"), w4 = _ && _.fill, C = p4.getModel("emphasis");
      h.setScale(y4), h.traverse(function(N) {
        N.setStyle("fill", w4);
      });
      var E = nL(e2.getItemVisual(o, "symbolOffset"), y4);
      E && (h.x = E[0], h.y = E[1]);
      var T = e2.getItemVisual(o, "symbolRotate");
      h.rotation = (T || 0) * Math.PI / 180 || 0;
      var O = {};
      O.showEffectOn = c4.get("showEffectOn"), O.rippleScale = p4.get(["rippleEffect", "scale"]), O.brushType = p4.get(["rippleEffect", "brushType"]), O.period = p4.get(["rippleEffect", "period"]) * 1e3, O.effectOffset = o / e2.count(), O.z = c4.getShallow("z") || 0, O.zlevel = c4.getShallow("zlevel") || 0, O.symbolType = g4, O.color = w4, O.rippleEffectColor = p4.get(["rippleEffect", "color"]), O.rippleNumber = p4.get(["rippleEffect", "number"]), O.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(O) : this.startEffectAnimation(O), this._effectCfg = O) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(N) {
        N === "emphasis" ? O.showEffectOn !== "render" && l4.startEffectAnimation(O) : N === "normal" && O.showEffectOn !== "render" && l4.stopEffectAnimation();
      }), this._effectCfg = O, pf(this, C.get("focus"), C.get("blurScope"), C.get("disabled"));
    }, n2.prototype.fadeOut = function(e2) {
      e2 && e2();
    }, n2;
  }(Ti), P_t = k_t, L_t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function() {
      this._symbolDraw = new K8(P_t);
    }, n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = this._symbolDraw;
      h.updateData(c4, { clipShape: this._getClipShape(e2) }), this.group.add(h.group);
    }, n2.prototype._getClipShape = function(e2) {
      var o = e2.coordinateSystem, l4 = o && o.getArea && o.getArea();
      return e2.get("clip", true) ? l4 : null;
    }, n2.prototype.updateTransform = function(e2, o, l4) {
      var c4 = e2.getData();
      this.group.dirty();
      var h = J8("").reset(e2, o, l4);
      h.progress && h.progress({ start: 0, end: c4.count(), count: c4.count() }, c4), this._symbolDraw.updateLayout();
    }, n2.prototype._updateGroupTransform = function(e2) {
      var o = e2.coordinateSystem;
      o && o.getRoamTransform && (this.group.transform = Xot(o.getRoamTransform()), this.group.decomposeTransform());
    }, n2.prototype.remove = function(e2, o) {
      this._symbolDraw && this._symbolDraw.remove(true);
    }, n2.type = "effectScatter", n2;
  }(Ru), O_t = L_t, R_t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.hasSymbolVisual = true, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      return M2(null, this, { useEncodeDefaulter: true });
    }, n2.prototype.brushSelector = function(e2, o, l4) {
      return l4.point(o.getItemLayout(e2));
    }, n2.type = "series.effectScatter", n2.dependencies = ["grid", "polar"], n2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, n2;
  }(_c2), F_t = R_t;
  function N_t(i) {
    i.registerChartView(O_t), i.registerSeriesModel(F_t), i.registerLayout(J8("effectScatter"));
  }
  var V_t = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this) || this;
      return c4.add(c4.createLine(e2, o, l4)), c4._updateEffectSymbol(e2, o), c4;
    }
    return n2.prototype.createLine = function(e2, o, l4) {
      return new Zle(e2, o, l4);
    }, n2.prototype._updateEffectSymbol = function(e2, o) {
      var l4 = e2.getItemModel(o), c4 = l4.getModel("effect"), h = c4.get("symbolSize"), p4 = c4.get("symbol");
      Mr(h) || (h = [h, h]);
      var g4 = e2.getItemVisual(o, "style"), y4 = c4.get("color") || g4 && g4.stroke, _ = this.childAt(1);
      this._symbolType !== p4 && (this.remove(_), _ = Xf(p4, -0.5, -0.5, 1, 1, y4), _.z2 = 100, _.culling = true, this.add(_)), _ && (_.setStyle("shadowColor", y4), _.setStyle(c4.getItemStyle(["color"])), _.scaleX = h[0], _.scaleY = h[1], _.setColor(y4), this._symbolType = p4, this._symbolScale = h, this._updateEffectAnimation(e2, c4, o));
    }, n2.prototype._updateEffectAnimation = function(e2, o, l4) {
      var c4 = this.childAt(1);
      if (!!c4) {
        var h = e2.getItemLayout(l4), p4 = o.get("period") * 1e3, g4 = o.get("loop"), y4 = o.get("constantSpeed"), _ = Nd(o.get("delay"), function(C) {
          return C / e2.count() * p4 / 3;
        });
        if (c4.ignore = true, this._updateAnimationPoints(c4, h), y4 > 0 && (p4 = this._getLineLength(c4) / y4 * 1e3), p4 !== this._period || g4 !== this._loop) {
          c4.stopAnimation();
          var w4 = void 0;
          si(_) ? w4 = _(l4) : w4 = _, c4.__t > 0 && (w4 = -p4 * c4.__t), this._animateSymbol(c4, p4, w4, g4);
        }
        this._period = p4, this._loop = g4;
      }
    }, n2.prototype._animateSymbol = function(e2, o, l4, c4) {
      if (o > 0) {
        e2.__t = 0;
        var h = this, p4 = e2.animate("", c4).when(o, { __t: 1 }).delay(l4).during(function() {
          h._updateSymbolPosition(e2);
        });
        c4 || p4.done(function() {
          h.remove(e2);
        }), p4.start();
      }
    }, n2.prototype._getLineLength = function(e2) {
      return RC(e2.__p1, e2.__cp1) + RC(e2.__cp1, e2.__p2);
    }, n2.prototype._updateAnimationPoints = function(e2, o) {
      e2.__p1 = o[0], e2.__p2 = o[1], e2.__cp1 = o[2] || [(o[0][0] + o[1][0]) / 2, (o[0][1] + o[1][1]) / 2];
    }, n2.prototype.updateData = function(e2, o, l4) {
      this.childAt(0).updateData(e2, o, l4), this._updateEffectSymbol(e2, o);
    }, n2.prototype._updateSymbolPosition = function(e2) {
      var o = e2.__p1, l4 = e2.__p2, c4 = e2.__cp1, h = e2.__t, p4 = [e2.x, e2.y], g4 = p4.slice(), y4 = Fd, _ = Pie;
      p4[0] = y4(o[0], c4[0], l4[0], h), p4[1] = y4(o[1], c4[1], l4[1], h);
      var w4 = _(o[0], c4[0], l4[0], h), C = _(o[1], c4[1], l4[1], h);
      e2.rotation = -Math.atan2(C, w4) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (e2.__lastT !== void 0 && e2.__lastT < e2.__t ? (e2.scaleY = RC(g4, p4) * 1.05, h === 1 && (p4[0] = g4[0] + (p4[0] - g4[0]) / 2, p4[1] = g4[1] + (p4[1] - g4[1]) / 2)) : e2.__lastT === 1 ? e2.scaleY = 2 * RC(o, p4) : e2.scaleY = this._symbolScale[1]), e2.__lastT = e2.__t, e2.ignore = false, e2.x = p4[0], e2.y = p4[1];
    }, n2.prototype.updateLayout = function(e2, o) {
      this.childAt(0).updateLayout(e2, o);
      var l4 = e2.getItemModel(o).getModel("effect");
      this._updateEffectAnimation(e2, l4, o);
    }, n2;
  }(Ti), i3e = V_t, z_t = function(i) {
    on(n2, i);
    function n2(e2, o, l4) {
      var c4 = i.call(this) || this;
      return c4._createPolyline(e2, o, l4), c4;
    }
    return n2.prototype._createPolyline = function(e2, o, l4) {
      var c4 = e2.getItemLayout(o), h = new Ug({ shape: { points: c4 } });
      this.add(h), this._updateCommonStl(e2, o, l4);
    }, n2.prototype.updateData = function(e2, o, l4) {
      var c4 = e2.hostModel, h = this.childAt(0), p4 = { shape: { points: e2.getItemLayout(o) } };
      Vs(h, p4, c4, o), this._updateCommonStl(e2, o, l4);
    }, n2.prototype._updateCommonStl = function(e2, o, l4) {
      var c4 = this.childAt(0), h = e2.getItemModel(o), p4 = l4 && l4.emphasisLineStyle, g4 = l4 && l4.focus, y4 = l4 && l4.blurScope, _ = l4 && l4.emphasisDisabled;
      if (!l4 || e2.hasItemOption) {
        var w4 = h.getModel("emphasis");
        p4 = w4.getModel("lineStyle").getLineStyle(), _ = w4.get("disabled"), g4 = w4.get("focus"), y4 = w4.get("blurScope");
      }
      c4.useStyle(e2.getItemVisual(o, "style")), c4.style.fill = null, c4.style.strokeNoScale = true;
      var C = c4.ensureState("emphasis");
      C.style = p4, pf(this, g4, y4, _);
    }, n2.prototype.updateLayout = function(e2, o) {
      var l4 = this.childAt(0);
      l4.setShape("points", e2.getItemLayout(o));
    }, n2;
  }(Ti), o3e = z_t, B_t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2._lastFrame = 0, e2._lastFramePercent = 0, e2;
    }
    return n2.prototype.createLine = function(e2, o, l4) {
      return new o3e(e2, o, l4);
    }, n2.prototype._updateAnimationPoints = function(e2, o) {
      this._points = o;
      for (var l4 = [0], c4 = 0, h = 1; h < o.length; h++) {
        var p4 = o[h - 1], g4 = o[h];
        c4 += RC(p4, g4), l4.push(c4);
      }
      if (c4 === 0) {
        this._length = 0;
        return;
      }
      for (var h = 0; h < l4.length; h++)
        l4[h] /= c4;
      this._offsets = l4, this._length = c4;
    }, n2.prototype._getLineLength = function() {
      return this._length;
    }, n2.prototype._updateSymbolPosition = function(e2) {
      var o = e2.__t, l4 = this._points, c4 = this._offsets, h = l4.length;
      if (!!c4) {
        var p4 = this._lastFrame, g4;
        if (o < this._lastFramePercent) {
          var y4 = Math.min(p4 + 1, h - 1);
          for (g4 = y4; g4 >= 0 && !(c4[g4] <= o); g4--)
            ;
          g4 = Math.min(g4, h - 2);
        } else {
          for (g4 = p4; g4 < h && !(c4[g4] > o); g4++)
            ;
          g4 = Math.min(g4 - 1, h - 2);
        }
        var _ = (o - c4[g4]) / (c4[g4 + 1] - c4[g4]), w4 = l4[g4], C = l4[g4 + 1];
        e2.x = w4[0] * (1 - _) + _ * C[0], e2.y = w4[1] * (1 - _) + _ * C[1];
        var E = C[0] - w4[0], T = C[1] - w4[1];
        e2.rotation = -Math.atan2(T, E) - Math.PI / 2, this._lastFrame = g4, this._lastFramePercent = o, e2.ignore = false;
      }
    }, n2;
  }(i3e), j_t = B_t, G_t = function() {
    function i() {
      this.polyline = false, this.curveness = 0, this.segs = [];
    }
    return i;
  }(), W_t = function(i) {
    on(n2, i);
    function n2(e2) {
      var o = i.call(this, e2) || this;
      return o._off = 0, o.hoverDataIdx = -1, o;
    }
    return n2.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, n2.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, n2.prototype.getDefaultShape = function() {
      return new G_t();
    }, n2.prototype.buildPath = function(e2, o) {
      var l4 = o.segs, c4 = o.curveness, h;
      if (o.polyline)
        for (h = this._off; h < l4.length; ) {
          var p4 = l4[h++];
          if (p4 > 0) {
            e2.moveTo(l4[h++], l4[h++]);
            for (var g4 = 1; g4 < p4; g4++)
              e2.lineTo(l4[h++], l4[h++]);
          }
        }
      else
        for (h = this._off; h < l4.length; ) {
          var y4 = l4[h++], _ = l4[h++], w4 = l4[h++], C = l4[h++];
          if (e2.moveTo(y4, _), c4 > 0) {
            var E = (y4 + w4) / 2 - (_ - C) * c4, T = (_ + C) / 2 - (w4 - y4) * c4;
            e2.quadraticCurveTo(E, T, w4, C);
          } else
            e2.lineTo(w4, C);
        }
      this.incremental && (this._off = h, this.notClear = true);
    }, n2.prototype.findDataIndex = function(e2, o) {
      var l4 = this.shape, c4 = l4.segs, h = l4.curveness, p4 = this.style.lineWidth;
      if (l4.polyline)
        for (var g4 = 0, y4 = 0; y4 < c4.length; ) {
          var _ = c4[y4++];
          if (_ > 0)
            for (var w4 = c4[y4++], C = c4[y4++], E = 1; E < _; E++) {
              var T = c4[y4++], O = c4[y4++];
              if (LC(w4, C, T, O, p4, e2, o))
                return g4;
            }
          g4++;
        }
      else
        for (var g4 = 0, y4 = 0; y4 < c4.length; ) {
          var w4 = c4[y4++], C = c4[y4++], T = c4[y4++], O = c4[y4++];
          if (h > 0) {
            var N = (w4 + T) / 2 - (C - O) * h, V = (C + O) / 2 - (T - w4) * h;
            if (hTe(w4, C, N, V, T, O, p4, e2, o))
              return g4;
          } else if (LC(w4, C, T, O, p4, e2, o))
            return g4;
          g4++;
        }
      return -1;
    }, n2.prototype.contain = function(e2, o) {
      var l4 = this.transformCoordToLocal(e2, o), c4 = this.getBoundingRect();
      if (e2 = l4[0], o = l4[1], c4.contain(e2, o)) {
        var h = this.hoverDataIdx = this.findDataIndex(e2, o);
        return h >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, n2.prototype.getBoundingRect = function() {
      var e2 = this._rect;
      if (!e2) {
        for (var o = this.shape, l4 = o.segs, c4 = 1 / 0, h = 1 / 0, p4 = -1 / 0, g4 = -1 / 0, y4 = 0; y4 < l4.length; ) {
          var _ = l4[y4++], w4 = l4[y4++];
          c4 = Math.min(_, c4), p4 = Math.max(_, p4), h = Math.min(w4, h), g4 = Math.max(w4, g4);
        }
        e2 = this._rect = new mo(c4, h, p4, g4);
      }
      return e2;
    }, n2;
  }(Eo), H_t = function() {
    function i() {
      this.group = new Ti();
    }
    return i.prototype.updateData = function(n2) {
      this._clear();
      var e2 = this._create();
      e2.setShape({ segs: n2.getLayout("linesPoints") }), this._setCommon(e2, n2);
    }, i.prototype.incrementalPrepareUpdate = function(n2) {
      this.group.removeAll(), this._clear();
    }, i.prototype.incrementalUpdate = function(n2, e2) {
      var o = this._newAdded[0], l4 = e2.getLayout("linesPoints"), c4 = o && o.shape.segs;
      if (c4 && c4.length < 2e4) {
        var h = c4.length, p4 = new Float32Array(h + l4.length);
        p4.set(c4), p4.set(l4, h), o.setShape({ segs: p4 });
      } else {
        this._newAdded = [];
        var g4 = this._create();
        g4.incremental = true, g4.setShape({ segs: l4 }), this._setCommon(g4, e2), g4.__startIndex = n2.start;
      }
    }, i.prototype.remove = function() {
      this._clear();
    }, i.prototype.eachRendered = function(n2) {
      this._newAdded[0] && n2(this._newAdded[0]);
    }, i.prototype._create = function() {
      var n2 = new W_t({ cursor: "default" });
      return this._newAdded.push(n2), this.group.add(n2), n2;
    }, i.prototype._setCommon = function(n2, e2, o) {
      var l4 = e2.hostModel;
      n2.setShape({ polyline: l4.get("polyline"), curveness: l4.get(["lineStyle", "curveness"]) }), n2.useStyle(l4.getModel("lineStyle").getLineStyle()), n2.style.strokeNoScale = true;
      var c4 = e2.getVisual("style");
      c4 && c4.stroke && n2.setStyle("stroke", c4.stroke), n2.setStyle("fill", null);
      var h = Fi(n2);
      h.seriesIndex = l4.seriesIndex, n2.on("mousemove", function(p4) {
        h.dataIndex = null;
        var g4 = n2.hoverDataIdx;
        g4 > 0 && (h.dataIndex = g4 + n2.__startIndex);
      });
    }, i.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, i;
  }(), $_t = H_t, U_t = { seriesType: "lines", plan: eL(), reset: function(i) {
    var n2 = i.coordinateSystem;
    if (!!n2) {
      var e2 = i.get("polyline"), o = i.pipelineContext.large;
      return { progress: function(l4, c4) {
        var h = [];
        if (o) {
          var p4 = void 0, g4 = l4.end - l4.start;
          if (e2) {
            for (var y4 = 0, _ = l4.start; _ < l4.end; _++)
              y4 += i.getLineCoordsCount(_);
            p4 = new Float32Array(g4 + y4 * 2);
          } else
            p4 = new Float32Array(g4 * 4);
          for (var w4 = 0, C = [], _ = l4.start; _ < l4.end; _++) {
            var E = i.getLineCoords(_, h);
            e2 && (p4[w4++] = E);
            for (var T = 0; T < E; T++)
              C = n2.dataToPoint(h[T], false, C), p4[w4++] = C[0], p4[w4++] = C[1];
          }
          c4.setLayout("linesPoints", p4);
        } else
          for (var _ = l4.start; _ < l4.end; _++) {
            var O = c4.getItemModel(_), E = i.getLineCoords(_, h), N = [];
            if (e2)
              for (var V = 0; V < E; V++)
                N.push(n2.dataToPoint(h[V]));
            else {
              N[0] = n2.dataToPoint(h[0]), N[1] = n2.dataToPoint(h[1]);
              var H = O.get(["lineStyle", "curveness"]);
              +H && (N[2] = [(N[0][0] + N[1][0]) / 2 - (N[0][1] - N[1][1]) * H, (N[0][1] + N[1][1]) / 2 - (N[1][0] - N[0][0]) * H]);
            }
            c4.setItemLayout(_, N);
          }
      } };
    }
  } }, s3e = U_t, q_t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = this._updateLineDraw(c4, e2), p4 = e2.get("zlevel"), g4 = e2.get(["effect", "trailLength"]), y4 = l4.getZr(), _ = y4.painter.getType() === "svg";
      _ || y4.painter.getLayer(p4).clear(true), this._lastZlevel != null && !_ && y4.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(e2) && g4 > 0 && (_ || y4.configLayer(p4, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(g4 / 10 + 0.9, 1), 0) })), h.updateData(c4);
      var w4 = e2.get("clip", true) && q$(e2.coordinateSystem, false, e2);
      w4 ? this.group.setClipPath(w4) : this.group.removeClipPath(), this._lastZlevel = p4, this._finished = true;
    }, n2.prototype.incrementalPrepareRender = function(e2, o, l4) {
      var c4 = e2.getData(), h = this._updateLineDraw(c4, e2);
      h.incrementalPrepareUpdate(c4), this._clearLayer(l4), this._finished = false;
    }, n2.prototype.incrementalRender = function(e2, o, l4) {
      this._lineDraw.incrementalUpdate(e2, o.getData()), this._finished = e2.end === o.getData().count();
    }, n2.prototype.eachRendered = function(e2) {
      this._lineDraw && this._lineDraw.eachRendered(e2);
    }, n2.prototype.updateTransform = function(e2, o, l4) {
      var c4 = e2.getData(), h = e2.pipelineContext;
      if (!this._finished || h.large || h.progressiveRender)
        return { update: true };
      var p4 = s3e.reset(e2, o, l4);
      p4.progress && p4.progress({ start: 0, end: c4.count(), count: c4.count() }, c4), this._lineDraw.updateLayout(), this._clearLayer(l4);
    }, n2.prototype._updateLineDraw = function(e2, o) {
      var l4 = this._lineDraw, c4 = this._showEffect(o), h = !!o.get("polyline"), p4 = o.pipelineContext, g4 = p4.large;
      return (!l4 || c4 !== this._hasEffet || h !== this._isPolyline || g4 !== this._isLargeDraw) && (l4 && l4.remove(), l4 = this._lineDraw = g4 ? new $_t() : new Xle(h ? c4 ? j_t : o3e : c4 ? i3e : Zle), this._hasEffet = c4, this._isPolyline = h, this._isLargeDraw = g4), this.group.add(l4.group), l4;
    }, n2.prototype._showEffect = function(e2) {
      return !!e2.get(["effect", "show"]);
    }, n2.prototype._clearLayer = function(e2) {
      var o = e2.getZr(), l4 = o.painter.getType() === "svg";
      !l4 && this._lastZlevel != null && o.painter.getLayer(this._lastZlevel).clear(true);
    }, n2.prototype.remove = function(e2, o) {
      this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(o);
    }, n2.prototype.dispose = function(e2, o) {
      this.remove(e2, o);
    }, n2.type = "lines", n2;
  }(Ru), Y_t = q_t, Z_t = typeof Uint32Array == "undefined" ? Array : Uint32Array, X_t = typeof Float64Array == "undefined" ? Array : Float64Array;
  function CMe(i) {
    var n2 = i.data;
    n2 && n2[0] && n2[0][0] && n2[0][0].coord && (i.data = Er(n2, function(e2) {
      var o = [e2[0].coord, e2[1].coord], l4 = { coords: o };
      return e2[0].name && (l4.fromName = e2[0].name), e2[1].name && (l4.toName = e2[1].name), Dse([l4, e2[0], e2[1]]);
    }));
  }
  var K_t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.visualStyleAccessPath = "lineStyle", e2.visualDrawType = "stroke", e2;
    }
    return n2.prototype.init = function(e2) {
      e2.data = e2.data || [], CMe(e2);
      var o = this._processFlatCoordsArray(e2.data);
      this._flatCoords = o.flatCoords, this._flatCoordsOffset = o.flatCoordsOffset, o.flatCoords && (e2.data = new Float32Array(o.count)), i.prototype.init.apply(this, arguments);
    }, n2.prototype.mergeOption = function(e2) {
      if (CMe(e2), e2.data) {
        var o = this._processFlatCoordsArray(e2.data);
        this._flatCoords = o.flatCoords, this._flatCoordsOffset = o.flatCoordsOffset, o.flatCoords && (e2.data = new Float32Array(o.count));
      }
      i.prototype.mergeOption.apply(this, arguments);
    }, n2.prototype.appendData = function(e2) {
      var o = this._processFlatCoordsArray(e2.data);
      o.flatCoords && (this._flatCoords ? (this._flatCoords = Sie(this._flatCoords, o.flatCoords), this._flatCoordsOffset = Sie(this._flatCoordsOffset, o.flatCoordsOffset)) : (this._flatCoords = o.flatCoords, this._flatCoordsOffset = o.flatCoordsOffset), e2.data = new Float32Array(o.count)), this.getRawData().appendData(e2.data);
    }, n2.prototype._getCoordsFromItemModel = function(e2) {
      var o = this.getData().getItemModel(e2), l4 = o.option instanceof Array ? o.option : o.getShallow("coords");
      return l4;
    }, n2.prototype.getLineCoordsCount = function(e2) {
      return this._flatCoordsOffset ? this._flatCoordsOffset[e2 * 2 + 1] : this._getCoordsFromItemModel(e2).length;
    }, n2.prototype.getLineCoords = function(e2, o) {
      if (this._flatCoordsOffset) {
        for (var l4 = this._flatCoordsOffset[e2 * 2], c4 = this._flatCoordsOffset[e2 * 2 + 1], h = 0; h < c4; h++)
          o[h] = o[h] || [], o[h][0] = this._flatCoords[l4 + h * 2], o[h][1] = this._flatCoords[l4 + h * 2 + 1];
        return c4;
      } else {
        for (var p4 = this._getCoordsFromItemModel(e2), h = 0; h < p4.length; h++)
          o[h] = o[h] || [], o[h][0] = p4[h][0], o[h][1] = p4[h][1];
        return p4.length;
      }
    }, n2.prototype._processFlatCoordsArray = function(e2) {
      var o = 0;
      if (this._flatCoords && (o = this._flatCoords.length), sl(e2[0])) {
        for (var l4 = e2.length, c4 = new Z_t(l4), h = new X_t(l4), p4 = 0, g4 = 0, y4 = 0, _ = 0; _ < l4; ) {
          y4++;
          var w4 = e2[_++];
          c4[g4++] = p4 + o, c4[g4++] = w4;
          for (var C = 0; C < w4; C++) {
            var E = e2[_++], T = e2[_++];
            h[p4++] = E, h[p4++] = T;
          }
        }
        return { flatCoordsOffset: new Uint32Array(c4.buffer, 0, g4), flatCoords: h, count: y4 };
      }
      return { flatCoordsOffset: null, flatCoords: null, count: e2.length };
    }, n2.prototype.getInitialData = function(e2, o) {
      var l4 = new Xv(["value"], this);
      return l4.hasItemOption = false, l4.initData(e2.data, [], function(c4, h, p4, g4) {
        if (c4 instanceof Array)
          return NaN;
        l4.hasItemOption = true;
        var y4 = c4.value;
        if (y4 != null)
          return y4 instanceof Array ? y4[g4] : y4;
      }), l4;
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      var c4 = this.getData(), h = c4.getItemModel(e2), p4 = h.get("name");
      if (p4)
        return p4;
      var g4 = h.get("fromName"), y4 = h.get("toName"), _ = [];
      return g4 != null && _.push(g4), y4 != null && _.push(y4), Qh("nameValue", { name: _.join(" > ") });
    }, n2.prototype.preventIncremental = function() {
      return !!this.get(["effect", "show"]);
    }, n2.prototype.getProgressive = function() {
      var e2 = this.option.progressive;
      return e2 == null ? this.option.large ? 1e4 : this.get("progressive") : e2;
    }, n2.prototype.getProgressiveThreshold = function() {
      var e2 = this.option.progressiveThreshold;
      return e2 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : e2;
    }, n2.prototype.getZLevelKey = function() {
      var e2 = this.getModel("effect"), o = e2.get("trailLength");
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : e2.get("show") && o > 0 ? o + "" : "";
    }, n2.type = "series.lines", n2.dependencies = ["grid", "polar", "geo", "calendar"], n2.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, n2;
  }(_c2), J_t = K_t;
  function PW(i) {
    return i instanceof Array || (i = [i, i]), i;
  }
  var Q_t = { seriesType: "lines", reset: function(i) {
    var n2 = PW(i.get("symbol")), e2 = PW(i.get("symbolSize")), o = i.getData();
    o.setVisual("fromSymbol", n2 && n2[0]), o.setVisual("toSymbol", n2 && n2[1]), o.setVisual("fromSymbolSize", e2 && e2[0]), o.setVisual("toSymbolSize", e2 && e2[1]);
    function l4(c4, h) {
      var p4 = c4.getItemModel(h), g4 = PW(p4.getShallow("symbol", true)), y4 = PW(p4.getShallow("symbolSize", true));
      g4[0] && c4.setItemVisual(h, "fromSymbol", g4[0]), g4[1] && c4.setItemVisual(h, "toSymbol", g4[1]), y4[0] && c4.setItemVisual(h, "fromSymbolSize", y4[0]), y4[1] && c4.setItemVisual(h, "toSymbolSize", y4[1]);
    }
    return { dataEach: o.hasItemOption ? l4 : null };
  } }, ext = Q_t;
  function txt(i) {
    i.registerChartView(Y_t), i.registerSeriesModel(J_t), i.registerLayout(s3e), i.registerVisual(ext);
  }
  var nxt = 256, rxt = function() {
    function i() {
      this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
      var n2 = y2.createCanvas();
      this.canvas = n2;
    }
    return i.prototype.update = function(n2, e2, o, l4, c4, h) {
      var p4 = this._getBrush(), g4 = this._getGradient(c4, "inRange"), y4 = this._getGradient(c4, "outOfRange"), _ = this.pointSize + this.blurSize, w4 = this.canvas, C = w4.getContext("2d"), E = n2.length;
      w4.width = e2, w4.height = o;
      for (var T = 0; T < E; ++T) {
        var O = n2[T], N = O[0], V = O[1], H = O[2], X = l4(H);
        C.globalAlpha = X, C.drawImage(p4, N - _, V - _);
      }
      if (!w4.width || !w4.height)
        return w4;
      for (var q2 = C.getImageData(0, 0, w4.width, w4.height), de = q2.data, le = 0, me = de.length, ye = this.minOpacity, be = this.maxOpacity, we = be - ye; le < me; ) {
        var X = de[le + 3] / 256, Pe = Math.floor(X * (nxt - 1)) * 4;
        if (X > 0) {
          var ze = h(X) ? g4 : y4;
          X > 0 && (X = X * we + ye), de[le++] = ze[Pe], de[le++] = ze[Pe + 1], de[le++] = ze[Pe + 2], de[le++] = ze[Pe + 3] * X * 256;
        } else
          le += 4;
      }
      return C.putImageData(q2, 0, 0), w4;
    }, i.prototype._getBrush = function() {
      var n2 = this._brushCanvas || (this._brushCanvas = y2.createCanvas()), e2 = this.pointSize + this.blurSize, o = e2 * 2;
      n2.width = o, n2.height = o;
      var l4 = n2.getContext("2d");
      return l4.clearRect(0, 0, o, o), l4.shadowOffsetX = o, l4.shadowBlur = this.blurSize, l4.shadowColor = "#000", l4.beginPath(), l4.arc(-e2, e2, this.pointSize, 0, Math.PI * 2, true), l4.closePath(), l4.fill(), n2;
    }, i.prototype._getGradient = function(n2, e2) {
      for (var o = this._gradientPixels, l4 = o[e2] || (o[e2] = new Uint8ClampedArray(256 * 4)), c4 = [0, 0, 0, 0], h = 0, p4 = 0; p4 < 256; p4++)
        n2[e2](p4 / 255, true, c4), l4[h++] = c4[0], l4[h++] = c4[1], l4[h++] = c4[2], l4[h++] = c4[3];
      return l4;
    }, i;
  }(), axt = rxt;
  function ixt(i, n2, e2) {
    var o = i[1] - i[0];
    n2 = Er(n2, function(h) {
      return { interval: [(h.interval[0] - i[0]) / o, (h.interval[1] - i[0]) / o] };
    });
    var l4 = n2.length, c4 = 0;
    return function(h) {
      var p4;
      for (p4 = c4; p4 < l4; p4++) {
        var g4 = n2[p4].interval;
        if (g4[0] <= h && h <= g4[1]) {
          c4 = p4;
          break;
        }
      }
      if (p4 === l4)
        for (p4 = c4 - 1; p4 >= 0; p4--) {
          var g4 = n2[p4].interval;
          if (g4[0] <= h && h <= g4[1]) {
            c4 = p4;
            break;
          }
        }
      return p4 >= 0 && p4 < l4 && e2[p4];
    };
  }
  function oxt(i, n2) {
    var e2 = i[1] - i[0];
    return n2 = [(n2[0] - i[0]) / e2, (n2[1] - i[0]) / e2], function(o) {
      return o >= n2[0] && o <= n2[1];
    };
  }
  function MMe(i) {
    var n2 = i.dimensions;
    return n2[0] === "lng" && n2[1] === "lat";
  }
  var sxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4;
      o.eachComponent("visualMap", function(p4) {
        p4.eachTargetSeries(function(g4) {
          g4 === e2 && (c4 = p4);
        });
      }), this._progressiveEls = null, this.group.removeAll();
      var h = e2.coordinateSystem;
      h.type === "cartesian2d" || h.type === "calendar" ? this._renderOnCartesianAndCalendar(e2, l4, 0, e2.getData().count()) : MMe(h) && this._renderOnGeo(h, e2, c4, l4);
    }, n2.prototype.incrementalPrepareRender = function(e2, o, l4) {
      this.group.removeAll();
    }, n2.prototype.incrementalRender = function(e2, o, l4, c4) {
      var h = o.coordinateSystem;
      h && (MMe(h) ? this.render(o, l4, c4) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(o, c4, e2.start, e2.end, true)));
    }, n2.prototype.eachRendered = function(e2) {
      oM(this._progressiveEls || this.group, e2);
    }, n2.prototype._renderOnCartesianAndCalendar = function(e2, o, l4, c4, h) {
      var p4 = e2.coordinateSystem, g4, y4, _, w4;
      if (v22(p4, "cartesian2d")) {
        var C = p4.getAxis("x"), E = p4.getAxis("y");
        g4 = C.getBandWidth(), y4 = E.getBandWidth(), _ = C.scale.getExtent(), w4 = E.scale.getExtent();
      }
      for (var T = this.group, O = e2.getData(), N = e2.getModel(["emphasis", "itemStyle"]).getItemStyle(), V = e2.getModel(["blur", "itemStyle"]).getItemStyle(), H = e2.getModel(["select", "itemStyle"]).getItemStyle(), X = e2.get(["itemStyle", "borderRadius"]), q2 = zd(e2), de = e2.getModel("emphasis"), le = de.get("focus"), me = de.get("blurScope"), ye = de.get("disabled"), be = v22(p4, "cartesian2d") ? [O.mapDimension("x"), O.mapDimension("y"), O.mapDimension("value")] : [O.mapDimension("time"), O.mapDimension("value")], we = l4; we < c4; we++) {
        var Pe = void 0, ze = O.getItemVisual(we, "style");
        if (v22(p4, "cartesian2d")) {
          var Re = O.get(be[0], we), rt2 = O.get(be[1], we);
          if (isNaN(O.get(be[2], we)) || Re < _[0] || Re > _[1] || rt2 < w4[0] || rt2 > w4[1])
            continue;
          var ft = p4.dataToPoint([Re, rt2]);
          Pe = new Is({ shape: { x: Math.floor(Math.round(ft[0]) - g4 / 2), y: Math.floor(Math.round(ft[1]) - y4 / 2), width: Math.ceil(g4), height: Math.ceil(y4) }, style: ze });
        } else {
          if (isNaN(O.get(be[1], we)))
            continue;
          Pe = new Is({ z2: 1, shape: p4.dataToRect([O.get(be[0], we)]).contentShape, style: ze });
        }
        if (O.hasItemOption) {
          var et = O.getItemModel(we), Jt = et.getModel("emphasis");
          N = Jt.getModel("itemStyle").getItemStyle(), V = et.getModel(["blur", "itemStyle"]).getItemStyle(), H = et.getModel(["select", "itemStyle"]).getItemStyle(), X = et.get(["itemStyle", "borderRadius"]), le = Jt.get("focus"), me = Jt.get("blurScope"), ye = Jt.get("disabled"), q2 = zd(et);
        }
        Pe.shape.r = X;
        var xt = e2.getRawValue(we), It = "-";
        xt && xt[2] != null && (It = xt[2] + ""), yv(Pe, q2, { labelFetcher: e2, labelDataIndex: we, defaultOpacity: ze.opacity, defaultText: It }), Pe.ensureState("emphasis").style = N, Pe.ensureState("blur").style = V, Pe.ensureState("select").style = H, pf(Pe, le, me, ye), Pe.incremental = h, h && (Pe.states.emphasis.hoverLayer = true), T.add(Pe), O.setItemGraphicEl(we, Pe), this._progressiveEls && this._progressiveEls.push(Pe);
      }
    }, n2.prototype._renderOnGeo = function(e2, o, l4, c4) {
      var h = l4.targetVisuals.inRange, p4 = l4.targetVisuals.outOfRange, g4 = o.getData(), y4 = this._hmLayer || this._hmLayer || new axt();
      y4.blurSize = o.get("blurSize"), y4.pointSize = o.get("pointSize"), y4.minOpacity = o.get("minOpacity"), y4.maxOpacity = o.get("maxOpacity");
      var _ = e2.getViewRect().clone(), w4 = e2.getRoamTransform();
      _.applyTransform(w4);
      var C = Math.max(_.x, 0), E = Math.max(_.y, 0), T = Math.min(_.width + _.x, c4.getWidth()), O = Math.min(_.height + _.y, c4.getHeight()), N = T - C, V = O - E, H = [g4.mapDimension("lng"), g4.mapDimension("lat"), g4.mapDimension("value")], X = g4.mapArray(H, function(me, ye, be) {
        var we = e2.dataToPoint([me, ye]);
        return we[0] -= C, we[1] -= E, we.push(be), we;
      }), q2 = l4.getExtent(), de = l4.type === "visualMap.continuous" ? oxt(q2, l4.option.range) : ixt(q2, l4.getPieceList(), l4.option.selected);
      y4.update(X, N, V, h.color.getNormalizer(), { inRange: h.color.getColorMapper(), outOfRange: p4.color.getColorMapper() }, de);
      var le = new Ap({ style: { width: N, height: V, x: C, y: E, image: y4.canvas }, silent: true });
      this.group.add(le);
    }, n2.type = "heatmap", n2;
  }(Ru), lxt = sxt, uxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      return M2(null, this, { generateCoord: "value" });
    }, n2.prototype.preventIncremental = function() {
      var e2 = H8.get(this.get("coordinateSystem"));
      if (e2 && e2.dimensions)
        return e2.dimensions[0] === "lng" && e2.dimensions[1] === "lat";
    }, n2.type = "series.heatmap", n2.dependencies = ["grid", "geo", "calendar"], n2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, n2;
  }(_c2), cxt = uxt;
  function fxt(i) {
    i.registerChartView(lxt), i.registerSeriesModel(cxt);
  }
  var hxt = ["itemStyle", "borderWidth"], AMe = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], Nae = new J_(), dxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = this.group, h = e2.getData(), p4 = this._data, g4 = e2.coordinateSystem, y4 = g4.getBaseAxis(), _ = y4.isHorizontal(), w4 = g4.master.getRect(), C = { ecSize: { width: l4.getWidth(), height: l4.getHeight() }, seriesModel: e2, coordSys: g4, coordSysExtent: [[w4.x, w4.x + w4.width], [w4.y, w4.y + w4.height]], isHorizontal: _, valueDim: AMe[+_], categoryDim: AMe[1 - +_] };
      return h.diff(p4).add(function(E) {
        if (!!h.hasValue(E)) {
          var T = IMe(h, E), O = EMe(h, E, T, C), N = TMe(h, C, O);
          h.setItemGraphicEl(E, N), c4.add(N), kMe(N, C, O);
        }
      }).update(function(E, T) {
        var O = p4.getItemGraphicEl(T);
        if (!h.hasValue(E)) {
          c4.remove(O);
          return;
        }
        var N = IMe(h, E), V = EMe(h, E, N, C), H = d3e(h, V);
        O && H !== O.__pictorialShapeStr && (c4.remove(O), h.setItemGraphicEl(E, null), O = null), O ? _xt(O, C, V) : O = TMe(h, C, V, true), h.setItemGraphicEl(E, O), O.__pictorialSymbolMeta = V, c4.add(O), kMe(O, C, V);
      }).remove(function(E) {
        var T = p4.getItemGraphicEl(E);
        T && DMe(p4, E, T.__pictorialSymbolMeta.animationModel, T);
      }).execute(), this._data = h, this.group;
    }, n2.prototype.remove = function(e2, o) {
      var l4 = this.group, c4 = this._data;
      e2.get("animation") ? c4 && c4.eachItemGraphicEl(function(h) {
        DMe(c4, Fi(h).dataIndex, e2, h);
      }) : l4.removeAll();
    }, n2.type = "pictorialBar", n2;
  }(Ru);
  function EMe(i, n2, e2, o) {
    var l4 = i.getItemLayout(n2), c4 = e2.get("symbolRepeat"), h = e2.get("symbolClip"), p4 = e2.get("symbolPosition") || "start", g4 = e2.get("symbolRotate"), y4 = (g4 || 0) * Math.PI / 180 || 0, _ = e2.get("symbolPatternSize") || 2, w4 = e2.isAnimationEnabled(), C = { dataIndex: n2, layout: l4, itemModel: e2, symbolType: i.getItemVisual(n2, "symbol") || "circle", style: i.getItemVisual(n2, "style"), symbolClip: h, symbolRepeat: c4, symbolRepeatDirection: e2.get("symbolRepeatDirection"), symbolPatternSize: _, rotation: y4, animationModel: w4 ? e2 : null, hoverScale: w4 && e2.get(["emphasis", "scale"]), z2: e2.getShallow("z", true) || 0 };
    pxt(e2, c4, l4, o, C), vxt(i, n2, l4, c4, h, C.boundingLength, C.pxSign, _, o, C), gxt(e2, C.symbolScale, y4, o, C);
    var E = C.symbolSize, T = nL(e2.get("symbolOffset"), E);
    return mxt(e2, E, l4, c4, h, T, p4, C.valueLineWidth, C.boundingLength, C.repeatCutLength, o, C), C;
  }
  function pxt(i, n2, e2, o, l4) {
    var c4 = o.valueDim, h = i.get("symbolBoundingData"), p4 = o.coordSys.getOtherAxis(o.coordSys.getBaseAxis()), g4 = p4.toGlobalCoord(p4.dataToCoord(0)), y4 = 1 - +(e2[c4.wh] <= 0), _;
    if (Mr(h)) {
      var w4 = [Vae(p4, h[0]) - g4, Vae(p4, h[1]) - g4];
      w4[1] < w4[0] && w4.reverse(), _ = w4[y4];
    } else
      h != null ? _ = Vae(p4, h) - g4 : n2 ? _ = o.coordSysExtent[c4.index][y4] - g4 : _ = e2[c4.wh];
    l4.boundingLength = _, n2 && (l4.repeatCutLength = e2[c4.wh]), l4.pxSign = _ > 0 ? 1 : -1;
  }
  function Vae(i, n2) {
    return i.toGlobalCoord(i.dataToCoord(i.scale.parse(n2)));
  }
  function vxt(i, n2, e2, o, l4, c4, h, p4, g4, y4) {
    var _ = g4.valueDim, w4 = g4.categoryDim, C = Math.abs(e2[w4.wh]), E = i.getItemVisual(n2, "symbolSize"), T;
    Mr(E) ? T = E.slice() : E == null ? T = ["100%", "100%"] : T = [E, E], T[w4.index] = ma(T[w4.index], C), T[_.index] = ma(T[_.index], o ? C : Math.abs(c4)), y4.symbolSize = T;
    var O = y4.symbolScale = [T[0] / p4, T[1] / p4];
    O[_.index] *= (g4.isHorizontal ? -1 : 1) * h;
  }
  function gxt(i, n2, e2, o, l4) {
    var c4 = i.get(hxt) || 0;
    c4 && (Nae.attr({ scaleX: n2[0], scaleY: n2[1], rotation: e2 }), Nae.updateTransform(), c4 /= Nae.getLineScale(), c4 *= n2[o.valueDim.index]), l4.valueLineWidth = c4 || 0;
  }
  function mxt(i, n2, e2, o, l4, c4, h, p4, g4, y4, _, w4) {
    var C = _.categoryDim, E = _.valueDim, T = w4.pxSign, O = Math.max(n2[E.index] + p4, 0), N = O;
    if (o) {
      var V = Math.abs(g4), H = Nd(i.get("symbolMargin"), "15%") + "", X = false;
      H.lastIndexOf("!") === H.length - 1 && (X = true, H = H.slice(0, H.length - 1));
      var q2 = ma(H, n2[E.index]), de = Math.max(O + q2 * 2, 0), le = X ? 0 : q2 * 2, me = JIe(o), ye = me ? o : PMe((V + le) / de), be = V - ye * O;
      q2 = be / 2 / (X ? ye : Math.max(ye - 1, 1)), de = O + q2 * 2, le = X ? 0 : q2 * 2, !me && o !== "fixed" && (ye = y4 ? PMe((Math.abs(y4) + le) / de) : 0), N = ye * de - le, w4.repeatTimes = ye, w4.symbolMargin = q2;
    }
    var we = T * (N / 2), Pe = w4.pathPosition = [];
    Pe[C.index] = e2[C.wh] / 2, Pe[E.index] = h === "start" ? we : h === "end" ? g4 - we : g4 / 2, c4 && (Pe[0] += c4[0], Pe[1] += c4[1]);
    var ze = w4.bundlePosition = [];
    ze[C.index] = e2[C.xy], ze[E.index] = e2[E.xy];
    var Re = w4.barRectShape = rr({}, e2);
    Re[E.wh] = T * Math.max(Math.abs(e2[E.wh]), Math.abs(Pe[E.index] + we)), Re[C.wh] = e2[C.wh];
    var rt2 = w4.clipShape = {};
    rt2[C.xy] = -e2[C.xy], rt2[C.wh] = _.ecSize[C.wh], rt2[E.xy] = 0, rt2[E.wh] = e2[E.wh];
  }
  function l3e(i) {
    var n2 = i.symbolPatternSize, e2 = Xf(i.symbolType, -n2 / 2, -n2 / 2, n2, n2);
    return e2.attr({ culling: true }), e2.type !== "image" && e2.setStyle({ strokeNoScale: true }), e2;
  }
  function u3e(i, n2, e2, o) {
    var l4 = i.__pictorialBundle, c4 = e2.symbolSize, h = e2.valueLineWidth, p4 = e2.pathPosition, g4 = n2.valueDim, y4 = e2.repeatTimes || 0, _ = 0, w4 = c4[n2.valueDim.index] + h + e2.symbolMargin * 2;
    for (aue(i, function(O) {
      O.__pictorialAnimationIndex = _, O.__pictorialRepeatTimes = y4, _ < y4 ? D3(O, null, T(_), e2, o) : D3(O, null, { scaleX: 0, scaleY: 0 }, e2, o, function() {
        l4.remove(O);
      }), _++;
    }); _ < y4; _++) {
      var C = l3e(e2);
      C.__pictorialAnimationIndex = _, C.__pictorialRepeatTimes = y4, l4.add(C);
      var E = T(_);
      D3(C, { x: E.x, y: E.y, scaleX: 0, scaleY: 0 }, { scaleX: E.scaleX, scaleY: E.scaleY, rotation: E.rotation }, e2, o);
    }
    function T(O) {
      var N = p4.slice(), V = e2.pxSign, H = O;
      return (e2.symbolRepeatDirection === "start" ? V > 0 : V < 0) && (H = y4 - 1 - O), N[g4.index] = w4 * (H - y4 / 2 + 0.5) + p4[g4.index], { x: N[0], y: N[1], scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1], rotation: e2.rotation };
    }
  }
  function c3e(i, n2, e2, o) {
    var l4 = i.__pictorialBundle, c4 = i.__pictorialMainPath;
    c4 ? D3(c4, null, { x: e2.pathPosition[0], y: e2.pathPosition[1], scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1], rotation: e2.rotation }, e2, o) : (c4 = i.__pictorialMainPath = l3e(e2), l4.add(c4), D3(c4, { x: e2.pathPosition[0], y: e2.pathPosition[1], scaleX: 0, scaleY: 0, rotation: e2.rotation }, { scaleX: e2.symbolScale[0], scaleY: e2.symbolScale[1] }, e2, o));
  }
  function f3e(i, n2, e2) {
    var o = rr({}, n2.barRectShape), l4 = i.__pictorialBarRect;
    l4 ? D3(l4, null, { shape: o }, n2, e2) : (l4 = i.__pictorialBarRect = new Is({ z2: 2, shape: o, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), l4.disableMorphing = true, i.add(l4));
  }
  function h3e(i, n2, e2, o) {
    if (e2.symbolClip) {
      var l4 = i.__pictorialClipPath, c4 = rr({}, e2.clipShape), h = n2.valueDim, p4 = e2.animationModel, g4 = e2.dataIndex;
      if (l4)
        Vs(l4, { shape: c4 }, p4, g4);
      else {
        c4[h.wh] = 0, l4 = new Is({ shape: c4 }), i.__pictorialBundle.setClipPath(l4), i.__pictorialClipPath = l4;
        var y4 = {};
        y4[h.wh] = e2.clipShape[h.wh], W8[o ? "updateProps" : "initProps"](l4, { shape: y4 }, p4, g4);
      }
    }
  }
  function IMe(i, n2) {
    var e2 = i.getItemModel(n2);
    return e2.getAnimationDelayParams = yxt, e2.isAnimationEnabled = bxt, e2;
  }
  function yxt(i) {
    return { index: i.__pictorialAnimationIndex, count: i.__pictorialRepeatTimes };
  }
  function bxt() {
    return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
  }
  function TMe(i, n2, e2, o) {
    var l4 = new Ti(), c4 = new Ti();
    return l4.add(c4), l4.__pictorialBundle = c4, c4.x = e2.bundlePosition[0], c4.y = e2.bundlePosition[1], e2.symbolRepeat ? u3e(l4, n2, e2) : c3e(l4, n2, e2), f3e(l4, e2, o), h3e(l4, n2, e2, o), l4.__pictorialShapeStr = d3e(i, e2), l4.__pictorialSymbolMeta = e2, l4;
  }
  function _xt(i, n2, e2) {
    var o = e2.animationModel, l4 = e2.dataIndex, c4 = i.__pictorialBundle;
    Vs(c4, { x: e2.bundlePosition[0], y: e2.bundlePosition[1] }, o, l4), e2.symbolRepeat ? u3e(i, n2, e2, true) : c3e(i, n2, e2, true), f3e(i, e2, true), h3e(i, n2, e2, true);
  }
  function DMe(i, n2, e2, o) {
    var l4 = o.__pictorialBarRect;
    l4 && l4.removeTextContent();
    var c4 = [];
    aue(o, function(h) {
      c4.push(h);
    }), o.__pictorialMainPath && c4.push(o.__pictorialMainPath), o.__pictorialClipPath && (e2 = null), Ve(c4, function(h) {
      JC(h, { scaleX: 0, scaleY: 0 }, e2, n2, function() {
        o.parent && o.parent.remove(o);
      });
    }), i.setItemGraphicEl(n2, null);
  }
  function d3e(i, n2) {
    return [i.getItemVisual(n2.dataIndex, "symbol") || "none", !!n2.symbolRepeat, !!n2.symbolClip].join(":");
  }
  function aue(i, n2, e2) {
    Ve(i.__pictorialBundle.children(), function(o) {
      o !== i.__pictorialBarRect && n2.call(e2, o);
    });
  }
  function D3(i, n2, e2, o, l4, c4) {
    n2 && i.attr(n2), o.symbolClip && !l4 ? e2 && i.attr(e2) : e2 && W8[l4 ? "updateProps" : "initProps"](i, e2, o.animationModel, o.dataIndex, c4);
  }
  function kMe(i, n2, e2) {
    var o = e2.dataIndex, l4 = e2.itemModel, c4 = l4.getModel("emphasis"), h = c4.getModel("itemStyle").getItemStyle(), p4 = l4.getModel(["blur", "itemStyle"]).getItemStyle(), g4 = l4.getModel(["select", "itemStyle"]).getItemStyle(), y4 = l4.getShallow("cursor"), _ = c4.get("focus"), w4 = c4.get("blurScope"), C = c4.get("scale");
    aue(i, function(O) {
      if (O instanceof Ap) {
        var N = O.style;
        O.useStyle(rr({ image: N.image, x: N.x, y: N.y, width: N.width, height: N.height }, e2.style));
      } else
        O.useStyle(e2.style);
      var V = O.ensureState("emphasis");
      V.style = h, C && (V.scaleX = O.scaleX * 1.1, V.scaleY = O.scaleY * 1.1), O.ensureState("blur").style = p4, O.ensureState("select").style = g4, y4 && (O.cursor = y4), O.z2 = e2.z2;
    });
    var E = n2.valueDim.posDesc[+(e2.boundingLength > 0)], T = i.__pictorialBarRect;
    yv(T, zd(l4), { labelFetcher: n2.seriesModel, labelDataIndex: o, defaultText: N3(n2.seriesModel.getData(), o), inheritColor: e2.style.fill, defaultOpacity: e2.style.opacity, defaultOutsidePosition: E }), pf(i, _, w4, c4.get("disabled"));
  }
  function PMe(i) {
    var n2 = Math.round(i);
    return Math.abs(i - n2) < 1e-4 ? n2 : Math.ceil(i);
  }
  var xxt = dxt, wxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.hasSymbolVisual = true, e2.defaultSymbol = "roundRect", e2;
    }
    return n2.prototype.getInitialData = function(e2) {
      return e2.stack = null, i.prototype.getInitialData.apply(this, arguments);
    }, n2.type = "series.pictorialBar", n2.dependencies = ["grid"], n2.defaultOption = sM($H.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), n2;
  }($H), Sxt = wxt;
  function Cxt(i) {
    i.registerChartView(xxt), i.registerSeriesModel(Sxt), i.registerLayout(i.PRIORITY.VISUAL.LAYOUT, zi(Z5e, "pictorialBar")), i.registerLayout(i.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, X5e("pictorialBar"));
  }
  var Mxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._layers = [], e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = e2.getData(), h = this, p4 = this.group, g4 = e2.getLayerSeries(), y4 = c4.getLayout("layoutInfo"), _ = y4.rect, w4 = y4.boundaryGap;
      p4.x = 0, p4.y = _.y + w4[0];
      function C(N) {
        return N.name;
      }
      var E = new x2(this._layersSeries || [], g4, C, C), T = [];
      E.add(Ia(O, this, "add")).update(Ia(O, this, "update")).remove(Ia(O, this, "remove")).execute();
      function O(N, V, H) {
        var X = h._layers;
        if (N === "remove") {
          p4.remove(X[V]);
          return;
        }
        for (var q2 = [], de = [], le, me = g4[V].indices, ye = 0; ye < me.length; ye++) {
          var be = c4.getItemLayout(me[ye]), we = be.x, Pe = be.y0, ze = be.y;
          q2.push(we, Pe), de.push(we, Pe + ze), le = c4.getItemVisual(me[ye], "style");
        }
        var Re, rt2 = c4.getItemLayout(me[0]), ft = e2.getModel("label"), et = ft.get("margin"), Jt = e2.getModel("emphasis");
        if (N === "add") {
          var xt = T[V] = new Ti();
          Re = new Fke({ shape: { points: q2, stackedOnPoints: de, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), xt.add(Re), p4.add(xt), e2.isAnimationEnabled() && Re.setClipPath(Axt(Re.getBoundingRect(), e2, function() {
            Re.removeClipPath();
          }));
        } else {
          var xt = X[H];
          Re = xt.childAt(0), p4.add(xt), T[V] = xt, Vs(Re, { shape: { points: q2, stackedOnPoints: de } }, e2), ob(Re);
        }
        yv(Re, zd(e2), { labelDataIndex: me[ye - 1], defaultText: c4.getName(me[ye - 1]), inheritColor: le.fill }, { normal: { verticalAlign: "middle" } }), Re.setTextConfig({ position: null, local: true });
        var It = Re.getTextContent();
        It && (It.x = rt2.x - et, It.y = rt2.y0 + rt2.y / 2), Re.useStyle(le), c4.setItemGraphicEl(V, Re), Mp(Re, e2), pf(Re, Jt.get("focus"), Jt.get("blurScope"), Jt.get("disabled"));
      }
      this._layersSeries = g4, this._layers = T;
    }, n2.type = "themeRiver", n2;
  }(Ru);
  function Axt(i, n2, e2) {
    var o = new Is({ shape: { x: i.x - 10, y: i.y - 10, width: 0, height: i.height + 20 } });
    return bc(o, { shape: { x: i.x - 50, width: i.width + 100, height: i.height + 20 } }, n2, e2), o;
  }
  var Ext = Mxt, zae = 2, Ixt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2) {
      i.prototype.init.apply(this, arguments), this.legendVisualProvider = new e9(Ia(this.getData, this), Ia(this.getRawData, this));
    }, n2.prototype.fixData = function(e2) {
      var o = e2.length, l4 = {}, c4 = $ie(e2, function(C) {
        return l4.hasOwnProperty(C[0] + "") || (l4[C[0] + ""] = -1), C[2];
      }), h = [];
      c4.buckets.each(function(C, E) {
        h.push({ name: E, dataList: C });
      });
      for (var p4 = h.length, g4 = 0; g4 < p4; ++g4) {
        for (var y4 = h[g4].name, _ = 0; _ < h[g4].dataList.length; ++_) {
          var w4 = h[g4].dataList[_][0] + "";
          l4[w4] = g4;
        }
        for (var w4 in l4)
          l4.hasOwnProperty(w4) && l4[w4] !== g4 && (l4[w4] = g4, e2[o] = [w4, 0, y4], o++);
      }
      return e2;
    }, n2.prototype.getInitialData = function(e2, o) {
      for (var l4 = this.getReferringComponents("singleAxis", Yf).models[0], c4 = l4.get("type"), h = Yl(e2.data, function(T) {
        return T[2] !== void 0;
      }), p4 = this.fixData(h || []), g4 = [], y4 = this.nameMap = ri(), _ = 0, w4 = 0; w4 < p4.length; ++w4)
        g4.push(p4[w4][zae]), y4.get(p4[w4][zae]) || (y4.set(p4[w4][zae], _), _++);
      var C = q8(p4, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: BH(c4) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, E = new Xv(C, this);
      return E.initData(p4), E;
    }, n2.prototype.getLayerSeries = function() {
      for (var e2 = this.getData(), o = e2.count(), l4 = [], c4 = 0; c4 < o; ++c4)
        l4[c4] = c4;
      var h = e2.mapDimension("single"), p4 = $ie(l4, function(y4) {
        return e2.get("name", y4);
      }), g4 = [];
      return p4.buckets.each(function(y4, _) {
        y4.sort(function(w4, C) {
          return e2.get(h, w4) - e2.get(h, C);
        }), g4.push({ name: _, indices: y4 });
      }), g4;
    }, n2.prototype.getAxisTooltipData = function(e2, o, l4) {
      Mr(e2) || (e2 = e2 ? [e2] : []);
      for (var c4 = this.getData(), h = this.getLayerSeries(), p4 = [], g4 = h.length, y4, _ = 0; _ < g4; ++_) {
        for (var w4 = Number.MAX_VALUE, C = -1, E = h[_].indices.length, T = 0; T < E; ++T) {
          var O = c4.get(e2[0], h[_].indices[T]), N = Math.abs(O - o);
          N <= w4 && (y4 = O, w4 = N, C = h[_].indices[T]);
        }
        p4.push(C);
      }
      return { dataIndices: p4, nestestValue: y4 };
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      var c4 = this.getData(), h = c4.getName(e2), p4 = c4.get(c4.mapDimension("value"), e2);
      return Qh("nameValue", { name: h, value: p4 });
    }, n2.type = "series.themeRiver", n2.dependencies = ["singleAxis"], n2.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, n2;
  }(_c2), Txt = Ixt;
  function Dxt(i, n2) {
    i.eachSeriesByType("themeRiver", function(e2) {
      var o = e2.getData(), l4 = e2.coordinateSystem, c4 = {}, h = l4.getRect();
      c4.rect = h;
      var p4 = e2.get("boundaryGap"), g4 = l4.getAxis();
      if (c4.boundaryGap = p4, g4.orient === "horizontal") {
        p4[0] = ma(p4[0], h.height), p4[1] = ma(p4[1], h.height);
        var y4 = h.height - p4[0] - p4[1];
        LMe(o, e2, y4);
      } else {
        p4[0] = ma(p4[0], h.width), p4[1] = ma(p4[1], h.width);
        var _ = h.width - p4[0] - p4[1];
        LMe(o, e2, _);
      }
      o.setLayout("layoutInfo", c4);
    });
  }
  function LMe(i, n2, e2) {
    if (!!i.count())
      for (var o = n2.coordinateSystem, l4 = n2.getLayerSeries(), c4 = i.mapDimension("single"), h = i.mapDimension("value"), p4 = Er(l4, function(N) {
        return Er(N.indices, function(V) {
          var H = o.dataToPoint(i.get(c4, V));
          return H[1] = i.get(h, V), H;
        });
      }), g4 = kxt(p4), y4 = g4.y0, _ = e2 / g4.max, w4 = l4.length, C = l4[0].indices.length, E, T = 0; T < C; ++T) {
        E = y4[T] * _, i.setItemLayout(l4[0].indices[T], { layerIndex: 0, x: p4[0][T][0], y0: E, y: p4[0][T][1] * _ });
        for (var O = 1; O < w4; ++O)
          E += p4[O - 1][T][1] * _, i.setItemLayout(l4[O].indices[T], { layerIndex: O, x: p4[O][T][0], y0: E, y: p4[O][T][1] * _ });
      }
  }
  function kxt(i) {
    for (var n2 = i.length, e2 = i[0].length, o = [], l4 = [], c4 = 0, h = 0; h < e2; ++h) {
      for (var p4 = 0, g4 = 0; g4 < n2; ++g4)
        p4 += i[g4][h][1];
      p4 > c4 && (c4 = p4), o.push(p4);
    }
    for (var y4 = 0; y4 < e2; ++y4)
      l4[y4] = (c4 - o[y4]) / 2;
    c4 = 0;
    for (var _ = 0; _ < e2; ++_) {
      var w4 = o[_] + l4[_];
      w4 > c4 && (c4 = w4);
    }
    return { y0: l4, max: c4 };
  }
  function Pxt(i) {
    i.registerChartView(Ext), i.registerSeriesModel(Txt), i.registerLayout(Dxt), i.registerProcessor(Q8("themeRiver"));
  }
  var Lxt = 2, Oxt = 4, Rxt = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4) {
      var h = i.call(this) || this;
      h.z2 = Lxt, h.textConfig = { inside: true }, Fi(h).seriesIndex = o.seriesIndex;
      var p4 = new Qs({ z2: Oxt, silent: e2.getModel().get(["label", "silent"]) });
      return h.setTextContent(p4), h.updateData(true, e2, o, l4, c4), h;
    }
    return n2.prototype.updateData = function(e2, o, l4, c4, h) {
      this.node = o, o.piece = this, l4 = l4 || this._seriesModel, c4 = c4 || this._ecModel;
      var p4 = this;
      Fi(p4).dataIndex = o.dataIndex;
      var g4 = o.getModel(), y4 = g4.getModel("emphasis"), _ = o.getLayout(), w4 = rr({}, _);
      w4.label = null;
      var C = o.getVisual("style");
      C.lineJoin = "bevel";
      var E = o.getVisual("decal");
      E && (C.decal = _8(E, h));
      var T = w3(g4.getModel("itemStyle"), w4, true);
      rr(w4, T), Ve(Jv, function(H) {
        var X = p4.ensureState(H), q2 = g4.getModel([H, "itemStyle"]);
        X.style = q2.getItemStyle();
        var de = w3(q2, w4);
        de && (X.shape = de);
      }), e2 ? (p4.setShape(w4), p4.shape.r = _.r0, Vs(p4, { shape: { r: _.r } }, l4, o.dataIndex)) : (Vs(p4, { shape: w4 }, l4), ob(p4)), p4.useStyle(C), this._updateLabel(l4);
      var O = g4.getShallow("cursor");
      O && p4.attr("cursor", O), this._seriesModel = l4 || this._seriesModel, this._ecModel = c4 || this._ecModel;
      var N = y4.get("focus"), V = N === "ancestor" ? o.getAncestorsIndices() : N === "descendant" ? o.getDescendantIndices() : N;
      pf(this, V, y4.get("blurScope"), y4.get("disabled"));
    }, n2.prototype._updateLabel = function(e2) {
      var o = this, l4 = this.node.getModel(), c4 = l4.getModel("label"), h = this.node.getLayout(), p4 = h.endAngle - h.startAngle, g4 = (h.startAngle + h.endAngle) / 2, y4 = Math.cos(g4), _ = Math.sin(g4), w4 = this, C = w4.getTextContent(), E = this.node.dataIndex, T = c4.get("minAngle") / 180 * Math.PI, O = c4.get("show") && !(T != null && Math.abs(p4) < T);
      C.ignore = !O, Ve(c8, function(V) {
        var H = V === "normal" ? l4.getModel("label") : l4.getModel([V, "label"]), X = V === "normal", q2 = X ? C : C.ensureState(V), de = e2.getFormattedLabel(E, V);
        X && (de = de || o.node.name), q2.style = Ef(H, {}, null, V !== "normal", true), de && (q2.style.text = de);
        var le = H.get("show");
        le != null && !X && (q2.ignore = !le);
        var me = N(H, "position"), ye = X ? w4 : w4.states[V], be = ye.style.fill;
        ye.textConfig = { outsideFill: H.get("color") === "inherit" ? be : null, inside: me !== "outside" };
        var we, Pe = N(H, "distance") || 0, ze = N(H, "align");
        me === "outside" ? (we = h.r + Pe, ze = g4 > Math.PI / 2 ? "right" : "left") : !ze || ze === "center" ? (p4 === 2 * Math.PI && h.r0 === 0 ? we = 0 : we = (h.r + h.r0) / 2, ze = "center") : ze === "left" ? (we = h.r0 + Pe, g4 > Math.PI / 2 && (ze = "right")) : ze === "right" && (we = h.r - Pe, g4 > Math.PI / 2 && (ze = "left")), q2.style.align = ze, q2.style.verticalAlign = N(H, "verticalAlign") || "middle", q2.x = we * y4 + h.cx, q2.y = we * _ + h.cy;
        var Re = N(H, "rotate"), rt2 = 0;
        Re === "radial" ? (rt2 = -g4, rt2 < -Math.PI / 2 && (rt2 += Math.PI)) : Re === "tangential" ? (rt2 = Math.PI / 2 - g4, rt2 > Math.PI / 2 ? rt2 -= Math.PI : rt2 < -Math.PI / 2 && (rt2 += Math.PI)) : sl(Re) && (rt2 = Re * Math.PI / 180), q2.rotation = rt2;
      });
      function N(V, H) {
        var X = V.get(H);
        return X == null ? c4.get(H) : X;
      }
      C.dirtyStyle();
    }, n2;
  }(Hg), OMe = Rxt, Woe = "sunburstRootToNode", RMe = "sunburstHighlight", Fxt = "sunburstUnhighlight";
  function Nxt(i) {
    i.registerAction({ type: Woe, update: "updateView" }, function(n2, e2) {
      e2.eachComponent({ mainType: "series", subType: "sunburst", query: n2 }, o);
      function o(l4, c4) {
        var h = M8(n2, [Woe], l4);
        if (h) {
          var p4 = l4.getViewRoot();
          p4 && (n2.direction = $le(p4, h.node) ? "rollUp" : "drillDown"), l4.resetViewRoot(h.node);
        }
      }
    }), i.registerAction({ type: RMe, update: "none" }, function(n2, e2, o) {
      n2 = rr({}, n2), e2.eachComponent({ mainType: "series", subType: "sunburst", query: n2 }, l4);
      function l4(c4) {
        var h = M8(n2, [RMe], c4);
        h && (n2.dataIndex = h.node.dataIndex);
      }
      o.dispatchAction(rr(n2, { type: "highlight" }));
    }), i.registerAction({ type: Fxt, update: "updateView" }, function(n2, e2, o) {
      n2 = rr({}, n2), o.dispatchAction(rr(n2, { type: "downplay" }));
    });
  }
  var Vxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      var h = this;
      this.seriesModel = e2, this.api = l4, this.ecModel = o;
      var p4 = e2.getData(), g4 = p4.tree.root, y4 = e2.getViewRoot(), _ = this.group, w4 = e2.get("renderLabelForZeroData"), C = [];
      y4.eachNode(function(H) {
        C.push(H);
      });
      var E = this._oldChildren || [];
      T(C, E), V(g4, y4), this._initEvents(), this._oldChildren = C;
      function T(H, X) {
        if (H.length === 0 && X.length === 0)
          return;
        new x2(X, H, q2, q2).add(de).update(de).remove(zi(de, null)).execute();
        function q2(le) {
          return le.getId();
        }
        function de(le, me) {
          var ye = le == null ? null : H[le], be = me == null ? null : X[me];
          O(ye, be);
        }
      }
      function O(H, X) {
        if (!w4 && H && !H.getValue() && (H = null), H !== g4 && X !== g4) {
          if (X && X.piece)
            H ? (X.piece.updateData(false, H, e2, o, l4), p4.setItemGraphicEl(H.dataIndex, X.piece)) : N(X);
          else if (H) {
            var q2 = new OMe(H, e2, o, l4);
            _.add(q2), p4.setItemGraphicEl(H.dataIndex, q2);
          }
        }
      }
      function N(H) {
        !H || H.piece && (_.remove(H.piece), H.piece = null);
      }
      function V(H, X) {
        X.depth > 0 ? (h.virtualPiece ? h.virtualPiece.updateData(false, H, e2, o, l4) : (h.virtualPiece = new OMe(H, e2, o, l4), _.add(h.virtualPiece)), X.piece.off("click"), h.virtualPiece.on("click", function(q2) {
          h._rootToNode(X.parentNode);
        })) : h.virtualPiece && (_.remove(h.virtualPiece), h.virtualPiece = null);
      }
    }, n2.prototype._initEvents = function() {
      var e2 = this;
      this.group.off("click"), this.group.on("click", function(o) {
        var l4 = false, c4 = e2.seriesModel.getViewRoot();
        c4.eachNode(function(h) {
          if (!l4 && h.piece && h.piece === o.target) {
            var p4 = h.getModel().get("nodeClick");
            if (p4 === "rootToNode")
              e2._rootToNode(h);
            else if (p4 === "link") {
              var g4 = h.getModel(), y4 = g4.get("link");
              if (y4) {
                var _ = g4.get("target", true) || "_blank";
                PH(y4, _);
              }
            }
            l4 = true;
          }
        });
      });
    }, n2.prototype._rootToNode = function(e2) {
      e2 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: Woe, from: this.uid, seriesId: this.seriesModel.id, targetNode: e2 });
    }, n2.prototype.containPoint = function(e2, o) {
      var l4 = o.getData(), c4 = l4.getItemLayout(0);
      if (c4) {
        var h = e2[0] - c4.cx, p4 = e2[1] - c4.cy, g4 = Math.sqrt(h * h + p4 * p4);
        return g4 <= c4.r && g4 >= c4.r0;
      }
    }, n2.type = "sunburst", n2;
  }(Ru), zxt = Vxt, Bxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.ignoreStyleOnData = true, e2;
    }
    return n2.prototype.getInitialData = function(e2, o) {
      var l4 = { name: e2.name, children: e2.data };
      p3e(l4);
      var c4 = this._levelModels = Er(e2.levels || [], function(g4) {
        return new Ou(g4, this, o);
      }, this), h = Hle.createTree(l4, this, p4);
      function p4(g4) {
        g4.wrapMethod("getItemModel", function(y4, _) {
          var w4 = h.getNodeByDataIndex(_), C = c4[w4.depth];
          return C && (y4.parentModel = C), y4;
        });
      }
      return h.data;
    }, n2.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, n2.prototype.getDataParams = function(e2) {
      var o = i.prototype.getDataParams.apply(this, arguments), l4 = this.getData().tree.getNodeByDataIndex(e2);
      return o.treePathInfo = X$(l4, this), o;
    }, n2.prototype.getLevelModel = function(e2) {
      return this._levelModels && this._levelModels[e2.depth];
    }, n2.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, n2.prototype.resetViewRoot = function(e2) {
      e2 ? this._viewRoot = e2 : e2 = this._viewRoot;
      var o = this.getRawData().tree.root;
      (!e2 || e2 !== o && !o.contains(e2)) && (this._viewRoot = o);
    }, n2.prototype.enableAriaDecal = function() {
      mPe(this);
    }, n2.type = "series.sunburst", n2.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, n2;
  }(_c2);
  function p3e(i) {
    var n2 = 0;
    Ve(i.children, function(o) {
      p3e(o);
      var l4 = o.value;
      Mr(l4) && (l4 = l4[0]), n2 += l4;
    });
    var e2 = i.value;
    Mr(e2) && (e2 = e2[0]), (e2 == null || isNaN(e2)) && (e2 = n2), e2 < 0 && (e2 = 0), Mr(i.value) ? i.value[0] = e2 : i.value = e2;
  }
  var jxt = Bxt, FMe = Math.PI / 180;
  function Gxt(i, n2, e2) {
    n2.eachSeriesByType(i, function(o) {
      var l4 = o.get("center"), c4 = o.get("radius");
      Mr(c4) || (c4 = [0, c4]), Mr(l4) || (l4 = [l4, l4]);
      var h = e2.getWidth(), p4 = e2.getHeight(), g4 = Math.min(h, p4), y4 = ma(l4[0], h), _ = ma(l4[1], p4), w4 = ma(c4[0], g4 / 2), C = ma(c4[1], g4 / 2), E = -o.get("startAngle") * FMe, T = o.get("minAngle") * FMe, O = o.getData().tree.root, N = o.getViewRoot(), V = N.depth, H = o.get("sort");
      H != null && v3e(N, H);
      var X = 0;
      Ve(N.children, function(et) {
        !isNaN(et.getValue()) && X++;
      });
      var q2 = N.getValue(), de = Math.PI / (q2 || X) * 2, le = N.depth > 0, me = N.height - (le ? -1 : 1), ye = (C - w4) / (me || 1), be = o.get("clockwise"), we = o.get("stillShowZeroSum"), Pe = be ? 1 : -1, ze = function(et, Jt) {
        if (!!et) {
          var xt = Jt;
          if (et !== O) {
            var It = et.getValue(), Wt = q2 === 0 && we ? de : It * de;
            Wt < T && (Wt = T), xt = Jt + Pe * Wt;
            var sn = et.depth - V - (le ? -1 : 1), vn = w4 + ye * sn, $r = w4 + ye * (sn + 1), ga = o.getLevelModel(et);
            if (ga) {
              var Za = ga.get("r0", true), $a = ga.get("r", true), Pa = ga.get("radius", true);
              Pa != null && (Za = Pa[0], $a = Pa[1]), Za != null && (vn = ma(Za, g4 / 2)), $a != null && ($r = ma($a, g4 / 2));
            }
            et.setLayout({ angle: Wt, startAngle: Jt, endAngle: xt, clockwise: be, cx: y4, cy: _, r0: vn, r: $r });
          }
          if (et.children && et.children.length) {
            var da = 0;
            Ve(et.children, function(Ra) {
              da += ze(Ra, Jt + da);
            });
          }
          return xt - Jt;
        }
      };
      if (le) {
        var Re = w4, rt2 = w4 + ye, ft = Math.PI * 2;
        O.setLayout({ angle: ft, startAngle: E, endAngle: E + ft, clockwise: be, cx: y4, cy: _, r0: Re, r: rt2 });
      }
      ze(N, E);
    });
  }
  function v3e(i, n2) {
    var e2 = i.children || [];
    i.children = Wxt(e2, n2), e2.length && Ve(i.children, function(o) {
      v3e(o, n2);
    });
  }
  function Wxt(i, n2) {
    if (si(n2)) {
      var e2 = Er(i, function(l4, c4) {
        var h = l4.getValue();
        return { params: { depth: l4.depth, height: l4.height, dataIndex: l4.dataIndex, getValue: function() {
          return h;
        } }, index: c4 };
      });
      return e2.sort(function(l4, c4) {
        return n2(l4.params, c4.params);
      }), Er(e2, function(l4) {
        return i[l4.index];
      });
    } else {
      var o = n2 === "asc";
      return i.sort(function(l4, c4) {
        var h = (l4.getValue() - c4.getValue()) * (o ? 1 : -1);
        return h === 0 ? (l4.dataIndex - c4.dataIndex) * (o ? -1 : 1) : h;
      });
    }
  }
  function Hxt(i) {
    var n2 = {};
    function e2(o, l4, c4) {
      for (var h = o; h && h.depth > 1; )
        h = h.parentNode;
      var p4 = l4.getColorFromPalette(h.name || h.dataIndex + "", n2);
      return o.depth > 1 && xa(p4) && (p4 = Rie(p4, (o.depth - 1) / (c4 - 1) * 0.5)), p4;
    }
    i.eachSeriesByType("sunburst", function(o) {
      var l4 = o.getData(), c4 = l4.tree;
      c4.eachNode(function(h) {
        var p4 = h.getModel(), g4 = p4.getModel("itemStyle").getItemStyle();
        g4.fill || (g4.fill = e2(h, o, c4.root.height));
        var y4 = l4.ensureUniqueItemVisual(h.dataIndex, "style");
        rr(y4, g4);
      });
    });
  }
  function $xt(i) {
    i.registerChartView(zxt), i.registerSeriesModel(jxt), i.registerLayout(zi(Gxt, "sunburst")), i.registerProcessor(zi(Q8, "sunburst")), i.registerVisual(Hxt), Nxt(i);
  }
  var NMe = { color: "fill", borderColor: "stroke" }, Uxt = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, g2 = zs(), qxt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.optionUpdated = function() {
      this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
    }, n2.prototype.getInitialData = function(e2, o) {
      return M2(null, this);
    }, n2.prototype.getDataParams = function(e2, o, l4) {
      var c4 = i.prototype.getDataParams.call(this, e2, o);
      return l4 && (c4.info = g2(l4).info), c4;
    }, n2.type = "series.custom", n2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], n2.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, n2;
  }(_c2), Yxt = qxt;
  function Zxt(i, n2) {
    return n2 = n2 || [0, 0], Er(["x", "y"], function(e2, o) {
      var l4 = this.getAxis(e2), c4 = n2[o], h = i[o] / 2;
      return l4.type === "category" ? l4.getBandWidth() : Math.abs(l4.dataToCoord(c4 - h) - l4.dataToCoord(c4 + h));
    }, this);
  }
  function Xxt(i) {
    var n2 = i.master.getRect();
    return { coordSys: { type: "cartesian2d", x: n2.x, y: n2.y, width: n2.width, height: n2.height }, api: { coord: function(e2) {
      return i.dataToPoint(e2);
    }, size: Ia(Zxt, i) } };
  }
  function Kxt(i, n2) {
    return n2 = n2 || [0, 0], Er([0, 1], function(e2) {
      var o = n2[e2], l4 = i[e2] / 2, c4 = [], h = [];
      return c4[e2] = o - l4, h[e2] = o + l4, c4[1 - e2] = h[1 - e2] = n2[1 - e2], Math.abs(this.dataToPoint(c4)[e2] - this.dataToPoint(h)[e2]);
    }, this);
  }
  function Jxt(i) {
    var n2 = i.getBoundingRect();
    return { coordSys: { type: "geo", x: n2.x, y: n2.y, width: n2.width, height: n2.height, zoom: i.getZoom() }, api: { coord: function(e2) {
      return i.dataToPoint(e2);
    }, size: Ia(Kxt, i) } };
  }
  function Qxt(i, n2) {
    var e2 = this.getAxis(), o = n2 instanceof Array ? n2[0] : n2, l4 = (i instanceof Array ? i[0] : i) / 2;
    return e2.type === "category" ? e2.getBandWidth() : Math.abs(e2.dataToCoord(o - l4) - e2.dataToCoord(o + l4));
  }
  function ewt(i) {
    var n2 = i.getRect();
    return { coordSys: { type: "singleAxis", x: n2.x, y: n2.y, width: n2.width, height: n2.height }, api: { coord: function(e2) {
      return i.dataToPoint(e2);
    }, size: Ia(Qxt, i) } };
  }
  function twt(i, n2) {
    return n2 = n2 || [0, 0], Er(["Radius", "Angle"], function(e2, o) {
      var l4 = "get" + e2 + "Axis", c4 = this[l4](), h = n2[o], p4 = i[o] / 2, g4 = c4.type === "category" ? c4.getBandWidth() : Math.abs(c4.dataToCoord(h - p4) - c4.dataToCoord(h + p4));
      return e2 === "Angle" && (g4 = g4 * Math.PI / 180), g4;
    }, this);
  }
  function nwt(i) {
    var n2 = i.getRadiusAxis(), e2 = i.getAngleAxis(), o = n2.getExtent();
    return o[0] > o[1] && o.reverse(), { coordSys: { type: "polar", cx: i.cx, cy: i.cy, r: o[1], r0: o[0] }, api: { coord: function(l4) {
      var c4 = n2.dataToRadius(l4[0]), h = e2.dataToAngle(l4[1]), p4 = i.coordToPoint([c4, h]);
      return p4.push(c4, h * Math.PI / 180), p4;
    }, size: Ia(twt, i) } };
  }
  function rwt(i) {
    var n2 = i.getRect(), e2 = i.getRangeInfo();
    return { coordSys: { type: "calendar", x: n2.x, y: n2.y, width: n2.width, height: n2.height, cellWidth: i.getCellWidth(), cellHeight: i.getCellHeight(), rangeInfo: { start: e2.start, end: e2.end, weeks: e2.weeks, dayCount: e2.allDay } }, api: { coord: function(o, l4) {
      return i.dataToPoint(o, l4);
    } } };
  }
  function g3e(i, n2, e2, o) {
    return i && (i.legacy || i.legacy !== false && !e2 && !o && n2 !== "tspan" && (n2 === "text" || Na(i, "text")));
  }
  function m3e(i, n2, e2) {
    var o = i, l4, c4, h;
    if (n2 === "text")
      h = o;
    else {
      h = {}, Na(o, "text") && (h.text = o.text), Na(o, "rich") && (h.rich = o.rich), Na(o, "textFill") && (h.fill = o.textFill), Na(o, "textStroke") && (h.stroke = o.textStroke), Na(o, "fontFamily") && (h.fontFamily = o.fontFamily), Na(o, "fontSize") && (h.fontSize = o.fontSize), Na(o, "fontStyle") && (h.fontStyle = o.fontStyle), Na(o, "fontWeight") && (h.fontWeight = o.fontWeight), c4 = { type: "text", style: h, silent: true }, l4 = {};
      var p4 = Na(o, "textPosition");
      e2 ? l4.position = p4 ? o.textPosition : "inside" : p4 && (l4.position = o.textPosition), Na(o, "textPosition") && (l4.position = o.textPosition), Na(o, "textOffset") && (l4.offset = o.textOffset), Na(o, "textRotation") && (l4.rotation = o.textRotation), Na(o, "textDistance") && (l4.distance = o.textDistance);
    }
    return VMe(h, i), Ve(h.rich, function(g4) {
      VMe(g4, g4);
    }), { textConfig: l4, textContent: c4 };
  }
  function VMe(i, n2) {
    !n2 || (n2.font = n2.textFont || n2.font, Na(n2, "textStrokeWidth") && (i.lineWidth = n2.textStrokeWidth), Na(n2, "textAlign") && (i.align = n2.textAlign), Na(n2, "textVerticalAlign") && (i.verticalAlign = n2.textVerticalAlign), Na(n2, "textLineHeight") && (i.lineHeight = n2.textLineHeight), Na(n2, "textWidth") && (i.width = n2.textWidth), Na(n2, "textHeight") && (i.height = n2.textHeight), Na(n2, "textBackgroundColor") && (i.backgroundColor = n2.textBackgroundColor), Na(n2, "textPadding") && (i.padding = n2.textPadding), Na(n2, "textBorderColor") && (i.borderColor = n2.textBorderColor), Na(n2, "textBorderWidth") && (i.borderWidth = n2.textBorderWidth), Na(n2, "textBorderRadius") && (i.borderRadius = n2.textBorderRadius), Na(n2, "textBoxShadowColor") && (i.shadowColor = n2.textBoxShadowColor), Na(n2, "textBoxShadowBlur") && (i.shadowBlur = n2.textBoxShadowBlur), Na(n2, "textBoxShadowOffsetX") && (i.shadowOffsetX = n2.textBoxShadowOffsetX), Na(n2, "textBoxShadowOffsetY") && (i.shadowOffsetY = n2.textBoxShadowOffsetY));
  }
  function zMe(i, n2, e2) {
    var o = i;
    o.textPosition = o.textPosition || e2.position || "inside", e2.offset != null && (o.textOffset = e2.offset), e2.rotation != null && (o.textRotation = e2.rotation), e2.distance != null && (o.textDistance = e2.distance);
    var l4 = o.textPosition.indexOf("inside") >= 0, c4 = i.fill || "#000";
    BMe(o, n2);
    var h = o.textFill == null;
    return l4 ? h && (o.textFill = e2.insideFill || "#fff", !o.textStroke && e2.insideStroke && (o.textStroke = e2.insideStroke), !o.textStroke && (o.textStroke = c4), o.textStrokeWidth == null && (o.textStrokeWidth = 2)) : (h && (o.textFill = i.fill || e2.outsideFill || "#000"), !o.textStroke && e2.outsideStroke && (o.textStroke = e2.outsideStroke)), o.text = n2.text, o.rich = n2.rich, Ve(n2.rich, function(p4) {
      BMe(p4, p4);
    }), o;
  }
  function BMe(i, n2) {
    !n2 || (Na(n2, "fill") && (i.textFill = n2.fill), Na(n2, "stroke") && (i.textStroke = n2.fill), Na(n2, "lineWidth") && (i.textStrokeWidth = n2.lineWidth), Na(n2, "font") && (i.font = n2.font), Na(n2, "fontStyle") && (i.fontStyle = n2.fontStyle), Na(n2, "fontWeight") && (i.fontWeight = n2.fontWeight), Na(n2, "fontSize") && (i.fontSize = n2.fontSize), Na(n2, "fontFamily") && (i.fontFamily = n2.fontFamily), Na(n2, "align") && (i.textAlign = n2.align), Na(n2, "verticalAlign") && (i.textVerticalAlign = n2.verticalAlign), Na(n2, "lineHeight") && (i.textLineHeight = n2.lineHeight), Na(n2, "width") && (i.textWidth = n2.width), Na(n2, "height") && (i.textHeight = n2.height), Na(n2, "backgroundColor") && (i.textBackgroundColor = n2.backgroundColor), Na(n2, "padding") && (i.textPadding = n2.padding), Na(n2, "borderColor") && (i.textBorderColor = n2.borderColor), Na(n2, "borderWidth") && (i.textBorderWidth = n2.borderWidth), Na(n2, "borderRadius") && (i.textBorderRadius = n2.borderRadius), Na(n2, "shadowColor") && (i.textBoxShadowColor = n2.shadowColor), Na(n2, "shadowBlur") && (i.textBoxShadowBlur = n2.shadowBlur), Na(n2, "shadowOffsetX") && (i.textBoxShadowOffsetX = n2.shadowOffsetX), Na(n2, "shadowOffsetY") && (i.textBoxShadowOffsetY = n2.shadowOffsetY), Na(n2, "textShadowColor") && (i.textShadowColor = n2.textShadowColor), Na(n2, "textShadowBlur") && (i.textShadowBlur = n2.textShadowBlur), Na(n2, "textShadowOffsetX") && (i.textShadowOffsetX = n2.textShadowOffsetX), Na(n2, "textShadowOffsetY") && (i.textShadowOffsetY = n2.textShadowOffsetY));
  }
  var y3e = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, jMe = ts(y3e);
  q_(Z_, function(i, n2) {
    return i[n2] = 1, i;
  }, {});
  Z_.join(", ");
  var QH = ["", "style", "shape", "extra"], B3 = zs();
  function iue(i, n2, e2, o, l4) {
    var c4 = i + "Animation", h = U3(i, o, l4) || {}, p4 = B3(n2).userDuring;
    return h.duration > 0 && (h.during = p4 ? Ia(lwt, { el: n2, userDuring: p4 }) : null, h.setToFinal = true, h.scope = i), rr(h, e2[c4]), h;
  }
  function cH(i, n2, e2, o) {
    o = o || {};
    var l4 = o.dataIndex, c4 = o.isInit, h = o.clearStyle, p4 = e2.isAnimationEnabled(), g4 = B3(i), y4 = n2.style;
    g4.userDuring = n2.during;
    var _ = {}, w4 = {};
    if (cwt(i, n2, w4), WMe("shape", n2, w4), WMe("extra", n2, w4), !c4 && p4 && (uwt(i, n2, _), GMe("shape", i, n2, _), GMe("extra", i, n2, _), fwt(i, n2, y4, _)), w4.style = y4, awt(i, w4, h), owt(i, n2), p4)
      if (c4) {
        var C = {};
        Ve(QH, function(T) {
          var O = T ? n2[T] : n2;
          O && O.enterFrom && (T && (C[T] = C[T] || {}), rr(T ? C[T] : C, O.enterFrom));
        });
        var E = iue("enter", i, n2, e2, l4);
        E.duration > 0 && i.animateFrom(C, E);
      } else
        iwt(i, n2, l4 || 0, e2, _);
    b3e(i, n2), y4 ? i.dirty() : i.markRedraw();
  }
  function b3e(i, n2) {
    for (var e2 = B3(i).leaveToProps, o = 0; o < QH.length; o++) {
      var l4 = QH[o], c4 = l4 ? n2[l4] : n2;
      c4 && c4.leaveTo && (e2 || (e2 = B3(i).leaveToProps = {}), l4 && (e2[l4] = e2[l4] || {}), rr(l4 ? e2[l4] : e2, c4.leaveTo));
    }
  }
  function Q$(i, n2, e2, o) {
    if (i) {
      var l4 = i.parent, c4 = B3(i).leaveToProps;
      if (c4) {
        var h = iue("update", i, n2, e2, 0);
        h.done = function() {
          l4.remove(i), o && o();
        }, i.animateTo(c4, h);
      } else
        l4.remove(i), o && o();
    }
  }
  function gT(i) {
    return i === "all";
  }
  function awt(i, n2, e2) {
    var o = n2.style;
    if (!i.isGroup && o) {
      if (e2) {
        i.useStyle({});
        for (var l4 = i.animators, c4 = 0; c4 < l4.length; c4++) {
          var h = l4[c4];
          h.targetName === "style" && h.changeTarget(i.style);
        }
      }
      i.setStyle(o);
    }
    n2 && (n2.style = null, n2 && i.attr(n2), n2.style = o);
  }
  function iwt(i, n2, e2, o, l4) {
    if (l4) {
      var c4 = iue("update", i, n2, o, e2);
      c4.duration > 0 && i.animateFrom(l4, c4);
    }
  }
  function owt(i, n2) {
    Na(n2, "silent") && (i.silent = n2.silent), Na(n2, "ignore") && (i.ignore = n2.ignore), i instanceof Vy && Na(n2, "invisible") && (i.invisible = n2.invisible), i instanceof Eo && Na(n2, "autoBatch") && (i.autoBatch = n2.autoBatch);
  }
  var O_ = {}, swt = { setTransform: function(i, n2) {
    return O_.el[i] = n2, this;
  }, getTransform: function(i) {
    return O_.el[i];
  }, setShape: function(i, n2) {
    var e2 = O_.el, o = e2.shape || (e2.shape = {});
    return o[i] = n2, e2.dirtyShape && e2.dirtyShape(), this;
  }, getShape: function(i) {
    var n2 = O_.el.shape;
    if (n2)
      return n2[i];
  }, setStyle: function(i, n2) {
    var e2 = O_.el, o = e2.style;
    return o && (o[i] = n2, e2.dirtyStyle && e2.dirtyStyle()), this;
  }, getStyle: function(i) {
    var n2 = O_.el.style;
    if (n2)
      return n2[i];
  }, setExtra: function(i, n2) {
    var e2 = O_.el.extra || (O_.el.extra = {});
    return e2[i] = n2, this;
  }, getExtra: function(i) {
    var n2 = O_.el.extra;
    if (n2)
      return n2[i];
  } };
  function lwt() {
    var i = this, n2 = i.el;
    if (!!n2) {
      var e2 = B3(n2).userDuring, o = i.userDuring;
      if (e2 !== o) {
        i.el = i.userDuring = null;
        return;
      }
      O_.el = n2, o(swt);
    }
  }
  function GMe(i, n2, e2, o) {
    var l4 = e2[i];
    if (!!l4) {
      var c4 = n2[i], h;
      if (c4) {
        var p4 = e2.transition, g4 = l4.transition;
        if (g4)
          if (!h && (h = o[i] = {}), gT(g4))
            rr(h, c4);
          else
            for (var y4 = Zl(g4), _ = 0; _ < y4.length; _++) {
              var w4 = y4[_], C = c4[w4];
              h[w4] = C;
            }
        else if (gT(p4) || go(p4, i) >= 0) {
          !h && (h = o[i] = {});
          for (var E = ts(c4), _ = 0; _ < E.length; _++) {
            var w4 = E[_], C = c4[w4];
            hwt(l4[w4], C) && (h[w4] = C);
          }
        }
      }
    }
  }
  function WMe(i, n2, e2) {
    var o = n2[i];
    if (!!o)
      for (var l4 = e2[i] = {}, c4 = ts(o), h = 0; h < c4.length; h++) {
        var p4 = c4[h];
        l4[p4] = jN(o[p4]);
      }
  }
  function uwt(i, n2, e2) {
    for (var o = n2.transition, l4 = gT(o) ? Z_ : Zl(o || []), c4 = 0; c4 < l4.length; c4++) {
      var h = l4[c4];
      if (!(h === "style" || h === "shape" || h === "extra")) {
        var p4 = i[h];
        e2[h] = p4;
      }
    }
  }
  function cwt(i, n2, e2) {
    for (var o = 0; o < jMe.length; o++) {
      var l4 = jMe[o], c4 = y3e[l4], h = n2[l4];
      h && (e2[c4[0]] = h[0], e2[c4[1]] = h[1]);
    }
    for (var o = 0; o < Z_.length; o++) {
      var p4 = Z_[o];
      n2[p4] != null && (e2[p4] = n2[p4]);
    }
  }
  function fwt(i, n2, e2, o) {
    if (!!e2) {
      var l4 = i.style, c4;
      if (l4) {
        var h = e2.transition, p4 = n2.transition;
        if (h && !gT(h)) {
          var g4 = Zl(h);
          !c4 && (c4 = o.style = {});
          for (var y4 = 0; y4 < g4.length; y4++) {
            var _ = g4[y4], w4 = l4[_];
            c4[_] = w4;
          }
        } else if (i.getAnimationStyleProps && (gT(p4) || gT(h) || go(p4, "style") >= 0)) {
          var C = i.getAnimationStyleProps(), E = C ? C.style : null;
          if (E) {
            !c4 && (c4 = o.style = {});
            for (var T = ts(e2), y4 = 0; y4 < T.length; y4++) {
              var _ = T[y4];
              if (E[_]) {
                var w4 = l4[_];
                c4[_] = w4;
              }
            }
          }
        }
      }
    }
  }
  function hwt(i, n2) {
    return gv(i) ? i !== n2 : i != null && isFinite(i);
  }
  var _3e = zs(), dwt = ["percent", "easing", "shape", "style", "extra"];
  function x3e(i) {
    i.stopAnimation("keyframe"), i.attr(_3e(i));
  }
  function e$(i, n2, e2) {
    if (!(!e2.isAnimationEnabled() || !n2)) {
      if (Mr(n2)) {
        Ve(n2, function(p4) {
          e$(i, p4, e2);
        });
        return;
      }
      var o = n2.keyframes, l4 = n2.duration;
      if (e2 && l4 == null) {
        var c4 = U3("enter", e2, 0);
        l4 = c4 && c4.duration;
      }
      if (!(!o || !l4)) {
        var h = _3e(i);
        Ve(QH, function(p4) {
          if (!(p4 && !i[p4])) {
            var g4;
            o.sort(function(y4, _) {
              return y4.percent - _.percent;
            }), Ve(o, function(y4) {
              var _ = i.animators, w4 = p4 ? y4[p4] : y4;
              if (!!w4) {
                var C = ts(w4);
                if (p4 || (C = Yl(C, function(O) {
                  return go(dwt, O) < 0;
                })), !!C.length) {
                  g4 || (g4 = i.animate(p4, n2.loop, true), g4.scope = "keyframe");
                  for (var E = 0; E < _.length; E++)
                    _[E] !== g4 && _[E].targetName === g4.targetName && _[E].stopTracks(C);
                  p4 && (h[p4] = h[p4] || {});
                  var T = p4 ? h[p4] : h;
                  Ve(C, function(O) {
                    T[O] = ((p4 ? i[p4] : i) || {})[O];
                  }), g4.whenWithKeys(l4 * y4.percent, w4, C, y4.easing);
                }
              }
            }), g4 && g4.delay(n2.delay || 0).duration(l4).start(n2.easing);
          }
        });
      }
    }
  }
  var m2 = "emphasis", WC = "normal", oue = "blur", sue = "select", rM = [WC, m2, oue, sue], Bae = { normal: ["itemStyle"], emphasis: [m2, "itemStyle"], blur: [oue, "itemStyle"], select: [sue, "itemStyle"] }, jae = { normal: ["label"], emphasis: [m2, "label"], blur: [oue, "label"], select: [sue, "label"] }, pwt = ["x", "y"], vwt = "e\0\0", xy = { normal: {}, emphasis: {}, blur: {}, select: {} }, gwt = { cartesian2d: Xxt, geo: Jxt, singleAxis: ewt, polar: nwt, calendar: rwt };
  function Hoe(i) {
    return i instanceof Eo;
  }
  function $oe(i) {
    return i instanceof Vy;
  }
  function mwt(i, n2) {
    n2.copyTransform(i), $oe(n2) && $oe(i) && (n2.setStyle(i.style), n2.z = i.z, n2.z2 = i.z2, n2.zlevel = i.zlevel, n2.invisible = i.invisible, n2.ignore = i.ignore, Hoe(n2) && Hoe(i) && n2.setShape(i.shape));
  }
  var ywt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      this._progressiveEls = null;
      var h = this._data, p4 = e2.getData(), g4 = this.group, y4 = HMe(e2, p4, o, l4);
      h || g4.removeAll(), p4.diff(h).add(function(w4) {
        Gae(l4, null, w4, y4(w4, c4), e2, g4, p4);
      }).remove(function(w4) {
        var C = h.getItemGraphicEl(w4);
        Q$(C, g2(C).option, e2);
      }).update(function(w4, C) {
        var E = h.getItemGraphicEl(C);
        Gae(l4, E, w4, y4(w4, c4), e2, g4, p4);
      }).execute();
      var _ = e2.get("clip", true) ? q$(e2.coordinateSystem, false, e2) : null;
      _ ? g4.setClipPath(_) : g4.removeClipPath(), this._data = p4;
    }, n2.prototype.incrementalPrepareRender = function(e2, o, l4) {
      this.group.removeAll(), this._data = null;
    }, n2.prototype.incrementalRender = function(e2, o, l4, c4, h) {
      var p4 = o.getData(), g4 = HMe(o, p4, l4, c4), y4 = this._progressiveEls = [];
      function _(E) {
        E.isGroup || (E.incremental = true, E.ensureState("emphasis").hoverLayer = true);
      }
      for (var w4 = e2.start; w4 < e2.end; w4++) {
        var C = Gae(null, null, w4, g4(w4, h), o, this.group, p4);
        C && (C.traverse(_), y4.push(C));
      }
    }, n2.prototype.eachRendered = function(e2) {
      oM(this._progressiveEls || this.group, e2);
    }, n2.prototype.filterForExposedEvent = function(e2, o, l4, c4) {
      var h = o.element;
      if (h == null || l4.name === h)
        return true;
      for (; (l4 = l4.__hostTarget || l4.parent) && l4 !== this.group; )
        if (l4.name === h)
          return true;
      return false;
    }, n2.type = "custom", n2;
  }(Ru), bwt = ywt;
  function lue(i) {
    var n2 = i.type, e2;
    if (n2 === "path") {
      var o = i.shape, l4 = o.width != null && o.height != null ? { x: o.x || 0, y: o.y || 0, width: o.width, height: o.height } : null, c4 = C3e(o);
      e2 = T$(c4, null, l4, o.layout || "center"), g2(e2).customPathData = c4;
    } else if (n2 === "image")
      e2 = new Ap({}), g2(e2).customImagePath = i.style.image;
    else if (n2 === "text")
      e2 = new Qs({});
    else if (n2 === "group")
      e2 = new Ti();
    else {
      if (n2 === "compoundPath")
        throw new Error('"compoundPath" is not supported yet.');
      var h = Qse(n2);
      if (!h) {
        var p4 = "";
        dl(p4);
      }
      e2 = new h();
    }
    return g2(e2).customGraphicType = n2, e2.name = i.name, e2.z2EmphasisLift = 1, e2.z2SelectLift = 1, e2;
  }
  function uue(i, n2, e2, o, l4, c4, h) {
    x3e(n2);
    var p4 = l4 && l4.normal.cfg;
    p4 && n2.setTextConfig(p4), o && o.transition == null && (o.transition = pwt);
    var g4 = o && o.style;
    if (g4) {
      if (n2.type === "text") {
        var y4 = g4;
        Na(y4, "textFill") && (y4.fill = y4.textFill), Na(y4, "textStroke") && (y4.stroke = y4.textStroke);
      }
      var _ = void 0, w4 = Hoe(n2) ? g4.decal : null;
      i && w4 && (w4.dirty = true, _ = _8(w4, i)), g4.__decalPattern = _;
    }
    if ($oe(n2) && g4) {
      var _ = g4.__decalPattern;
      _ && (g4.decal = _);
    }
    cH(n2, o, c4, { dataIndex: e2, isInit: h, clearStyle: true }), e$(n2, o.keyframeAnimation, c4);
  }
  function w3e(i, n2, e2, o, l4) {
    var c4 = n2.isGroup ? null : n2, h = l4 && l4[i].cfg;
    if (c4) {
      var p4 = c4.ensureState(i);
      if (o === false) {
        var g4 = c4.getState(i);
        g4 && (g4.style = null);
      } else
        p4.style = o || null;
      h && (p4.textConfig = h), _T(c4);
    }
  }
  function _wt(i, n2, e2) {
    if (!i.isGroup) {
      var o = i, l4 = e2.currentZ, c4 = e2.currentZLevel;
      o.z = l4, o.zlevel = c4;
      var h = n2.z2;
      h != null && (o.z2 = h || 0);
      for (var p4 = 0; p4 < rM.length; p4++)
        xwt(o, n2, rM[p4]);
    }
  }
  function xwt(i, n2, e2) {
    var o = e2 === WC, l4 = o ? n2 : t$(n2, e2), c4 = l4 ? l4.z2 : null, h;
    c4 != null && (h = o ? i : i.ensureState(e2), h.z2 = c4 || 0);
  }
  function HMe(i, n2, e2, o) {
    var l4 = i.get("renderItem"), c4 = i.coordinateSystem, h = {};
    c4 && (h = c4.prepareCustoms ? c4.prepareCustoms(c4) : gwt[c4.type](c4));
    for (var p4 = hi({ getWidth: o.getWidth, getHeight: o.getHeight, getZr: o.getZr, getDevicePixelRatio: o.getDevicePixelRatio, value: q2, style: le, ordinalRawValue: de, styleEmphasis: me, visual: we, barLayout: Pe, currentSeriesIndices: ze, font: Re }, h.api || {}), g4 = { context: {}, seriesId: i.id, seriesName: i.name, seriesIndex: i.seriesIndex, coordSys: h.coordSys, dataInsideLength: n2.count(), encode: wwt(i.getData()) }, y4, _, w4 = {}, C = {}, E = {}, T = {}, O = 0; O < rM.length; O++) {
      var N = rM[O];
      E[N] = i.getModel(Bae[N]), T[N] = i.getModel(jae[N]);
    }
    function V(rt2) {
      return rt2 === y4 ? _ || (_ = n2.getItemModel(rt2)) : n2.getItemModel(rt2);
    }
    function H(rt2, ft) {
      return n2.hasItemOption ? rt2 === y4 ? w4[ft] || (w4[ft] = V(rt2).getModel(Bae[ft])) : V(rt2).getModel(Bae[ft]) : E[ft];
    }
    function X(rt2, ft) {
      return n2.hasItemOption ? rt2 === y4 ? C[ft] || (C[ft] = V(rt2).getModel(jae[ft])) : V(rt2).getModel(jae[ft]) : T[ft];
    }
    return function(rt2, ft) {
      return y4 = rt2, _ = null, w4 = {}, C = {}, l4 && l4(hi({ dataIndexInside: rt2, dataIndex: n2.getRawIndex(rt2), actionType: ft ? ft.type : null }, g4), p4);
    };
    function q2(rt2, ft) {
      return ft == null && (ft = y4), n2.getStore().get(n2.getDimensionIndex(rt2 || 0), ft);
    }
    function de(rt2, ft) {
      ft == null && (ft = y4), rt2 = rt2 || 0;
      var et = n2.getDimensionInfo(rt2);
      if (!et) {
        var Jt = n2.getDimensionIndex(rt2);
        return Jt >= 0 ? n2.getStore().get(Jt, ft) : void 0;
      }
      var xt = n2.get(et.name, ft), It = et && et.ordinalMeta;
      return It ? It.categories[xt] : xt;
    }
    function le(rt2, ft) {
      ft == null && (ft = y4);
      var et = n2.getItemVisual(ft, "style"), Jt = et && et.fill, xt = et && et.opacity, It = H(ft, WC).getItemStyle();
      Jt != null && (It.fill = Jt), xt != null && (It.opacity = xt);
      var Wt = { inheritColor: xa(Jt) ? Jt : "#000" }, sn = X(ft, WC), vn = Ef(sn, null, Wt, false, true);
      vn.text = sn.getShallow("show") ? so(i.getFormattedLabel(ft, WC), N3(n2, ft)) : null;
      var $r = DH(sn, Wt, false);
      return be(rt2, It), It = zMe(It, vn, $r), rt2 && ye(It, rt2), It.legacy = true, It;
    }
    function me(rt2, ft) {
      ft == null && (ft = y4);
      var et = H(ft, m2).getItemStyle(), Jt = X(ft, m2), xt = Ef(Jt, null, null, true, true);
      xt.text = Jt.getShallow("show") ? f2(i.getFormattedLabel(ft, m2), i.getFormattedLabel(ft, WC), N3(n2, ft)) : null;
      var It = DH(Jt, null, true);
      return be(rt2, et), et = zMe(et, xt, It), rt2 && ye(et, rt2), et.legacy = true, et;
    }
    function ye(rt2, ft) {
      for (var et in ft)
        Na(ft, et) && (rt2[et] = ft[et]);
    }
    function be(rt2, ft) {
      rt2 && (rt2.textFill && (ft.textFill = rt2.textFill), rt2.textPosition && (ft.textPosition = rt2.textPosition));
    }
    function we(rt2, ft) {
      if (ft == null && (ft = y4), Na(NMe, rt2)) {
        var et = n2.getItemVisual(ft, "style");
        return et ? et[NMe[rt2]] : null;
      }
      if (Na(Uxt, rt2))
        return n2.getItemVisual(ft, rt2);
    }
    function Pe(rt2) {
      if (c4.type === "cartesian2d") {
        var ft = c4.getBaseAxis();
        return Sdt(hi({ axis: ft }, rt2));
      }
    }
    function ze() {
      return e2.getCurrentSeriesIndices();
    }
    function Re(rt2) {
      return rDe(rt2, e2);
    }
  }
  function wwt(i) {
    var n2 = {};
    return Ve(i.dimensions, function(e2) {
      var o = i.getDimensionInfo(e2);
      if (!o.isExtraCoord) {
        var l4 = o.coordDim, c4 = n2[l4] = n2[l4] || [];
        c4[o.coordDimIndex] = i.getDimensionIndex(e2);
      }
    }), n2;
  }
  function Gae(i, n2, e2, o, l4, c4, h) {
    if (!o) {
      c4.remove(n2);
      return;
    }
    var p4 = cue(i, n2, e2, o, l4, c4);
    return p4 && h.setItemGraphicEl(e2, p4), p4 && pf(p4, o.focus, o.blurScope, o.emphasisDisabled), p4;
  }
  function cue(i, n2, e2, o, l4, c4) {
    var h = -1, p4 = n2;
    n2 && S3e(n2, o, l4) && (h = go(c4.childrenRef(), n2), n2 = null);
    var g4 = !n2, y4 = n2;
    y4 ? y4.clearStates() : (y4 = lue(o), p4 && mwt(p4, y4)), o.morph === false ? y4.disableMorphing = true : y4.disableMorphing && (y4.disableMorphing = false), xy.normal.cfg = xy.normal.conOpt = xy.emphasis.cfg = xy.emphasis.conOpt = xy.blur.cfg = xy.blur.conOpt = xy.select.cfg = xy.select.conOpt = null, xy.isLegacy = false, Cwt(y4, e2, o, l4, g4, xy), Swt(y4, e2, o, l4, g4), uue(i, y4, e2, o, xy, l4, g4), Na(o, "info") && (g2(y4).info = o.info);
    for (var _ = 0; _ < rM.length; _++) {
      var w4 = rM[_];
      if (w4 !== WC) {
        var C = t$(o, w4), E = fue(o, C, w4);
        w3e(w4, y4, C, E, xy);
      }
    }
    return _wt(y4, o, l4), o.type === "group" && Mwt(i, y4, e2, o, l4), h >= 0 ? c4.replaceAt(y4, h) : c4.add(y4), y4;
  }
  function S3e(i, n2, e2) {
    var o = g2(i), l4 = n2.type, c4 = n2.shape, h = n2.style;
    return e2.isUniversalTransitionEnabled() || l4 != null && l4 !== o.customGraphicType || l4 === "path" && Iwt(c4) && C3e(c4) !== o.customPathData || l4 === "image" && Na(h, "image") && h.image !== o.customImagePath;
  }
  function Swt(i, n2, e2, o, l4) {
    var c4 = e2.clipPath;
    if (c4 === false)
      i && i.getClipPath() && i.removeClipPath();
    else if (c4) {
      var h = i.getClipPath();
      h && S3e(h, c4, o) && (h = null), h || (h = lue(c4), i.setClipPath(h)), uue(null, h, n2, c4, null, o, l4);
    }
  }
  function Cwt(i, n2, e2, o, l4, c4) {
    if (!i.isGroup) {
      $Me(e2, null, c4), $Me(e2, m2, c4);
      var h = c4.normal.conOpt, p4 = c4.emphasis.conOpt, g4 = c4.blur.conOpt, y4 = c4.select.conOpt;
      if (h != null || p4 != null || y4 != null || g4 != null) {
        var _ = i.getTextContent();
        if (h === false)
          _ && i.removeTextContent();
        else {
          h = c4.normal.conOpt = h || { type: "text" }, _ ? _.clearStates() : (_ = lue(h), i.setTextContent(_)), uue(null, _, n2, h, null, o, l4);
          for (var w4 = h && h.style, C = 0; C < rM.length; C++) {
            var E = rM[C];
            if (E !== WC) {
              var T = c4[E].conOpt;
              w3e(E, _, T, fue(h, T, E), null);
            }
          }
          w4 ? _.dirty() : _.markRedraw();
        }
      }
    }
  }
  function $Me(i, n2, e2) {
    var o = n2 ? t$(i, n2) : i, l4 = n2 ? fue(i, o, m2) : i.style, c4 = i.type, h = o ? o.textConfig : null, p4 = i.textContent, g4 = p4 ? n2 ? t$(p4, n2) : p4 : null;
    if (l4 && (e2.isLegacy || g3e(l4, c4, !!h, !!g4))) {
      e2.isLegacy = true;
      var y4 = m3e(l4, c4, !n2);
      !h && y4.textConfig && (h = y4.textConfig), !g4 && y4.textContent && (g4 = y4.textContent);
    }
    if (!n2 && g4) {
      var _ = g4;
      !_.type && (_.type = "text");
    }
    var w4 = n2 ? e2[n2] : e2.normal;
    w4.cfg = h, w4.conOpt = g4;
  }
  function t$(i, n2) {
    return n2 ? i ? i[n2] : null : i;
  }
  function fue(i, n2, e2) {
    var o = n2 && n2.style;
    return o == null && e2 === m2 && i && (o = i.styleEmphasis), o;
  }
  function Mwt(i, n2, e2, o, l4) {
    var c4 = o.children, h = c4 ? c4.length : 0, p4 = o.$mergeChildren, g4 = p4 === "byName" || o.diffChildrenByName, y4 = p4 === false;
    if (!(!h && !g4 && !y4)) {
      if (g4) {
        Awt({ api: i, oldChildren: n2.children() || [], newChildren: c4 || [], dataIndex: e2, seriesModel: l4, group: n2 });
        return;
      }
      y4 && n2.removeAll();
      for (var _ = 0; _ < h; _++)
        c4[_] && cue(i, n2.childAt(_), e2, c4[_], l4, n2);
      for (var w4 = n2.childCount() - 1; w4 >= _; w4--) {
        var C = n2.childAt(w4);
        Q$(C, g2(n2).option, l4);
      }
    }
  }
  function Awt(i) {
    new x2(i.oldChildren, i.newChildren, UMe, UMe, i).add(qMe).update(qMe).remove(Ewt).execute();
  }
  function UMe(i, n2) {
    var e2 = i && i.name;
    return e2 != null ? e2 : vwt + n2;
  }
  function qMe(i, n2) {
    var e2 = this.context, o = i != null ? e2.newChildren[i] : null, l4 = n2 != null ? e2.oldChildren[n2] : null;
    cue(e2.api, l4, e2.dataIndex, o, e2.seriesModel, e2.group);
  }
  function Ewt(i) {
    var n2 = this.context, e2 = n2.oldChildren[i];
    Q$(e2, g2(e2).option, n2.seriesModel);
  }
  function C3e(i) {
    return i && (i.pathData || i.d);
  }
  function Iwt(i) {
    return i && (Na(i, "pathData") || Na(i, "d"));
  }
  function Twt(i) {
    i.registerChartView(bwt), i.registerSeriesModel(Yxt);
  }
  var eT = zs(), YMe = Ci, Wae = Ia, Dwt = function() {
    function i() {
      this._dragging = false, this.animationThreshold = 15;
    }
    return i.prototype.render = function(n2, e2, o, l4) {
      var c4 = e2.get("value"), h = e2.get("status");
      if (this._axisModel = n2, this._axisPointerModel = e2, this._api = o, !(!l4 && this._lastValue === c4 && this._lastStatus === h)) {
        this._lastValue = c4, this._lastStatus = h;
        var p4 = this._group, g4 = this._handle;
        if (!h || h === "hide") {
          p4 && p4.hide(), g4 && g4.hide();
          return;
        }
        p4 && p4.show(), g4 && g4.show();
        var y4 = {};
        this.makeElOption(y4, c4, n2, e2, o);
        var _ = y4.graphicKey;
        _ !== this._lastGraphicKey && this.clear(o), this._lastGraphicKey = _;
        var w4 = this._moveAnimation = this.determineAnimation(n2, e2);
        if (!p4)
          p4 = this._group = new Ti(), this.createPointerEl(p4, y4, n2, e2), this.createLabelEl(p4, y4, n2, e2), o.getZr().add(p4);
        else {
          var C = zi(ZMe, e2, w4);
          this.updatePointerEl(p4, y4, C), this.updateLabelEl(p4, y4, C, e2);
        }
        KMe(p4, e2, true), this._renderHandle(c4);
      }
    }, i.prototype.remove = function(n2) {
      this.clear(n2);
    }, i.prototype.dispose = function(n2) {
      this.clear(n2);
    }, i.prototype.determineAnimation = function(n2, e2) {
      var o = e2.get("animation"), l4 = n2.axis, c4 = l4.type === "category", h = e2.get("snap");
      if (!h && !c4)
        return false;
      if (o === "auto" || o == null) {
        var p4 = this.animationThreshold;
        if (c4 && l4.getBandWidth() > p4)
          return true;
        if (h) {
          var g4 = Nle(n2).seriesDataCount, y4 = l4.getExtent();
          return Math.abs(y4[0] - y4[1]) / g4 > p4;
        }
        return false;
      }
      return o === true;
    }, i.prototype.makeElOption = function(n2, e2, o, l4, c4) {
    }, i.prototype.createPointerEl = function(n2, e2, o, l4) {
      var c4 = e2.pointer;
      if (c4) {
        var h = eT(n2).pointerEl = new W8[c4.type](YMe(e2.pointer));
        n2.add(h);
      }
    }, i.prototype.createLabelEl = function(n2, e2, o, l4) {
      if (e2.label) {
        var c4 = eT(n2).labelEl = new Qs(YMe(e2.label));
        n2.add(c4), XMe(c4, l4);
      }
    }, i.prototype.updatePointerEl = function(n2, e2, o) {
      var l4 = eT(n2).pointerEl;
      l4 && e2.pointer && (l4.setStyle(e2.pointer.style), o(l4, { shape: e2.pointer.shape }));
    }, i.prototype.updateLabelEl = function(n2, e2, o, l4) {
      var c4 = eT(n2).labelEl;
      c4 && (c4.setStyle(e2.label.style), o(c4, { x: e2.label.x, y: e2.label.y }), XMe(c4, l4));
    }, i.prototype._renderHandle = function(n2) {
      if (!(this._dragging || !this.updateHandleTransform)) {
        var e2 = this._axisPointerModel, o = this._api.getZr(), l4 = this._handle, c4 = e2.getModel("handle"), h = e2.get("status");
        if (!c4.get("show") || !h || h === "hide") {
          l4 && o.remove(l4), this._handle = null;
          return;
        }
        var p4;
        this._handle || (p4 = true, l4 = this._handle = G8(c4.get("icon"), { cursor: "move", draggable: true, onmousemove: function(y4) {
          b2(y4.event);
        }, onmousedown: Wae(this._onHandleDragMove, this, 0, 0), drift: Wae(this._onHandleDragMove, this), ondragend: Wae(this._onHandleDragEnd, this) }), o.add(l4)), KMe(l4, e2, false), l4.setStyle(c4.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
        var g4 = c4.get("size");
        Mr(g4) || (g4 = [g4, g4]), l4.scaleX = g4[0] / 2, l4.scaleY = g4[1] / 2, tL(this, "_doDispatchAxisPointer", c4.get("throttle") || 0, "fixRate"), this._moveHandleToValue(n2, p4);
      }
    }, i.prototype._moveHandleToValue = function(n2, e2) {
      ZMe(this._axisPointerModel, !e2 && this._moveAnimation, this._handle, Hae(this.getHandleTransform(n2, this._axisModel, this._axisPointerModel)));
    }, i.prototype._onHandleDragMove = function(n2, e2) {
      var o = this._handle;
      if (!!o) {
        this._dragging = true;
        var l4 = this.updateHandleTransform(Hae(o), [n2, e2], this._axisModel, this._axisPointerModel);
        this._payloadInfo = l4, o.stopAnimation(), o.attr(Hae(l4)), eT(o).lastProp = null, this._doDispatchAxisPointer();
      }
    }, i.prototype._doDispatchAxisPointer = function() {
      var n2 = this._handle;
      if (!!n2) {
        var e2 = this._payloadInfo, o = this._axisModel;
        this._api.dispatchAction({ type: "updateAxisPointer", x: e2.cursorPoint[0], y: e2.cursorPoint[1], tooltipOption: e2.tooltipOption, axesInfo: [{ axisDim: o.axis.dim, axisIndex: o.componentIndex }] });
      }
    }, i.prototype._onHandleDragEnd = function() {
      this._dragging = false;
      var n2 = this._handle;
      if (!!n2) {
        var e2 = this._axisPointerModel.get("value");
        this._moveHandleToValue(e2), this._api.dispatchAction({ type: "hideTip" });
      }
    }, i.prototype.clear = function(n2) {
      this._lastValue = null, this._lastStatus = null;
      var e2 = n2.getZr(), o = this._group, l4 = this._handle;
      e2 && o && (this._lastGraphicKey = null, o && e2.remove(o), l4 && e2.remove(l4), this._group = null, this._handle = null, this._payloadInfo = null), m8(this, "_doDispatchAxisPointer");
    }, i.prototype.doClear = function() {
    }, i.prototype.buildLabel = function(n2, e2, o) {
      return o = o || 0, { x: n2[o], y: n2[1 - o], width: e2[o], height: e2[1 - o] };
    }, i;
  }();
  function ZMe(i, n2, e2, o) {
    M3e(eT(e2).lastProp, o) || (eT(e2).lastProp = o, n2 ? Vs(e2, o, i) : (e2.stopAnimation(), e2.attr(o)));
  }
  function M3e(i, n2) {
    if (mi(i) && mi(n2)) {
      var e2 = true;
      return Ve(n2, function(o, l4) {
        e2 = e2 && M3e(i[l4], o);
      }), !!e2;
    } else
      return i === n2;
  }
  function XMe(i, n2) {
    i[n2.get(["label", "show"]) ? "show" : "hide"]();
  }
  function Hae(i) {
    return { x: i.x || 0, y: i.y || 0, rotation: i.rotation || 0 };
  }
  function KMe(i, n2, e2) {
    var o = n2.get("z"), l4 = n2.get("zlevel");
    i && i.traverse(function(c4) {
      c4.type !== "group" && (o != null && (c4.z = o), l4 != null && (c4.zlevel = l4), c4.silent = e2);
    });
  }
  var hue = Dwt;
  function due(i) {
    var n2 = i.get("type"), e2 = i.getModel(n2 + "Style"), o;
    return n2 === "line" ? (o = e2.getLineStyle(), o.fill = null) : n2 === "shadow" && (o = e2.getAreaStyle(), o.stroke = null), o;
  }
  function A3e(i, n2, e2, o, l4) {
    var c4 = e2.get("value"), h = E3e(c4, n2.axis, n2.ecModel, e2.get("seriesDataIndices"), { precision: e2.get(["label", "precision"]), formatter: e2.get(["label", "formatter"]) }), p4 = e2.getModel("label"), g4 = X3(p4.get("padding") || 0), y4 = p4.getFont(), _ = N8(h, y4), w4 = l4.position, C = _.width + g4[1] + g4[3], E = _.height + g4[0] + g4[2], T = l4.align;
    T === "right" && (w4[0] -= C), T === "center" && (w4[0] -= C / 2);
    var O = l4.verticalAlign;
    O === "bottom" && (w4[1] -= E), O === "middle" && (w4[1] -= E / 2), kwt(w4, C, E, o);
    var N = p4.get("backgroundColor");
    (!N || N === "auto") && (N = n2.get(["axisLine", "lineStyle", "color"])), i.label = { x: w4[0], y: w4[1], style: Ef(p4, { text: h, font: y4, fill: p4.getTextColor(), padding: g4, backgroundColor: N }), z2: 10 };
  }
  function kwt(i, n2, e2, o) {
    var l4 = o.getWidth(), c4 = o.getHeight();
    i[0] = Math.min(i[0] + n2, l4) - n2, i[1] = Math.min(i[1] + e2, c4) - e2, i[0] = Math.max(i[0], 0), i[1] = Math.max(i[1], 0);
  }
  function E3e(i, n2, e2, o, l4) {
    i = n2.scale.parse(i);
    var c4 = n2.scale.getLabel({ value: i }, { precision: l4.precision }), h = l4.formatter;
    if (h) {
      var p4 = { value: Ile(n2, { value: i }), axisDimension: n2.dim, axisIndex: n2.index, seriesData: [] };
      Ve(o, function(g4) {
        var y4 = e2.getSeriesByIndex(g4.seriesIndex), _ = g4.dataIndexInside, w4 = y4 && y4.getDataParams(_);
        w4 && p4.seriesData.push(w4);
      }), xa(h) ? c4 = h.replace("{value}", c4) : si(h) && (c4 = h(p4));
    }
    return c4;
  }
  function pue(i, n2, e2) {
    var o = Ny();
    return MT(o, o, e2.rotation), Y_(o, o, e2.position), ab([i.dataToCoord(n2), (e2.labelOffset || 0) + (e2.labelDirection || 1) * (e2.labelMargin || 0)], o);
  }
  function I3e(i, n2, e2, o, l4, c4) {
    var h = w2.innerTextLayout(e2.rotation, 0, e2.labelDirection);
    e2.labelMargin = l4.get(["label", "margin"]), A3e(n2, o, l4, c4, { position: pue(o.axis, i, e2), align: h.textAlign, verticalAlign: h.textVerticalAlign });
  }
  function vue(i, n2, e2) {
    return e2 = e2 || 0, { x1: i[e2], y1: i[1 - e2], x2: n2[e2], y2: n2[1 - e2] };
  }
  function T3e(i, n2, e2) {
    return e2 = e2 || 0, { x: i[e2], y: i[1 - e2], width: n2[e2], height: n2[1 - e2] };
  }
  function JMe(i, n2, e2, o, l4, c4) {
    return { cx: i, cy: n2, r0: e2, r: o, startAngle: l4, endAngle: c4, clockwise: true };
  }
  var Pwt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.makeElOption = function(e2, o, l4, c4, h) {
      var p4 = l4.axis, g4 = p4.grid, y4 = c4.get("type"), _ = QMe(g4, p4).getOtherAxis(p4).getGlobalExtent(), w4 = p4.toGlobalCoord(p4.dataToCoord(o, true));
      if (y4 && y4 !== "none") {
        var C = due(c4), E = Lwt[y4](p4, w4, _);
        E.style = C, e2.graphicKey = E.type, e2.pointer = E;
      }
      var T = Eoe(g4.model, l4);
      I3e(o, e2, T, l4, c4, h);
    }, n2.prototype.getHandleTransform = function(e2, o, l4) {
      var c4 = Eoe(o.axis.grid.model, o, { labelInside: false });
      c4.labelMargin = l4.get(["handle", "margin"]);
      var h = pue(o.axis, e2, c4);
      return { x: h[0], y: h[1], rotation: c4.rotation + (c4.labelDirection < 0 ? Math.PI : 0) };
    }, n2.prototype.updateHandleTransform = function(e2, o, l4, c4) {
      var h = l4.axis, p4 = h.grid, g4 = h.getGlobalExtent(true), y4 = QMe(p4, h).getOtherAxis(h).getGlobalExtent(), _ = h.dim === "x" ? 0 : 1, w4 = [e2.x, e2.y];
      w4[_] += o[_], w4[_] = Math.min(g4[1], w4[_]), w4[_] = Math.max(g4[0], w4[_]);
      var C = (y4[1] + y4[0]) / 2, E = [C, C];
      E[_] = w4[_];
      var T = [{ verticalAlign: "middle" }, { align: "center" }];
      return { x: w4[0], y: w4[1], rotation: e2.rotation, cursorPoint: E, tooltipOption: T[_] };
    }, n2;
  }(hue);
  function QMe(i, n2) {
    var e2 = {};
    return e2[n2.dim + "AxisIndex"] = n2.index, i.getCartesian(e2);
  }
  var Lwt = { line: function(i, n2, e2) {
    var o = vue([n2, e2[0]], [n2, e2[1]], eAe(i));
    return { type: "Line", subPixelOptimize: true, shape: o };
  }, shadow: function(i, n2, e2) {
    var o = Math.max(1, i.getBandWidth()), l4 = e2[1] - e2[0];
    return { type: "Rect", shape: T3e([n2 - o / 2, e2[0]], [o, l4], eAe(i)) };
  } };
  function eAe(i) {
    return i.dim === "x" ? 0 : 1;
  }
  var Owt = Pwt, Rwt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "axisPointer", n2.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, n2;
  }(Ns), Fwt = Rwt, c2 = zs(), Nwt = Ve;
  function D3e(i, n2, e2) {
    if (!ol.node) {
      var o = n2.getZr();
      c2(o).records || (c2(o).records = {}), Vwt(o, n2);
      var l4 = c2(o).records[i] || (c2(o).records[i] = {});
      l4.handler = e2;
    }
  }
  function Vwt(i, n2) {
    if (c2(i).initialized)
      return;
    c2(i).initialized = true, e2("click", zi(tAe, "click")), e2("mousemove", zi(tAe, "mousemove")), e2("globalout", Bwt);
    function e2(o, l4) {
      i.on(o, function(c4) {
        var h = jwt(n2);
        Nwt(c2(i).records, function(p4) {
          p4 && l4(p4, c4, h.dispatchAction);
        }), zwt(h.pendings, n2);
      });
    }
  }
  function zwt(i, n2) {
    var e2 = i.showTip.length, o = i.hideTip.length, l4;
    e2 ? l4 = i.showTip[e2 - 1] : o && (l4 = i.hideTip[o - 1]), l4 && (l4.dispatchAction = null, n2.dispatchAction(l4));
  }
  function Bwt(i, n2, e2) {
    i.handler("leave", null, e2);
  }
  function tAe(i, n2, e2, o) {
    n2.handler(i, e2, o);
  }
  function jwt(i) {
    var n2 = { showTip: [], hideTip: [] }, e2 = function(o) {
      var l4 = n2[o.type];
      l4 ? l4.push(o) : (o.dispatchAction = e2, i.dispatchAction(o));
    };
    return { dispatchAction: e2, pendings: n2 };
  }
  function Uoe(i, n2) {
    if (!ol.node) {
      var e2 = n2.getZr(), o = (c2(e2).records || {})[i];
      o && (c2(e2).records[i] = null);
    }
  }
  var Gwt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = o.getComponent("tooltip"), h = e2.get("triggerOn") || c4 && c4.get("triggerOn") || "mousemove|click";
      D3e("axisPointer", l4, function(p4, g4, y4) {
        h !== "none" && (p4 === "leave" || h.indexOf(p4) >= 0) && y4({ type: "updateAxisPointer", currTrigger: p4, x: g4 && g4.offsetX, y: g4 && g4.offsetY });
      });
    }, n2.prototype.remove = function(e2, o) {
      Uoe("axisPointer", o);
    }, n2.prototype.dispose = function(e2, o) {
      Uoe("axisPointer", o);
    }, n2.type = "axisPointer", n2;
  }($c), Wwt = Gwt;
  function k3e(i, n2) {
    var e2 = [], o = i.seriesIndex, l4;
    if (o == null || !(l4 = n2.getSeriesByIndex(o)))
      return { point: [] };
    var c4 = l4.getData(), h = yT(c4, i);
    if (h == null || h < 0 || Mr(h))
      return { point: [] };
    var p4 = c4.getItemGraphicEl(h), g4 = l4.coordinateSystem;
    if (l4.getTooltipPosition)
      e2 = l4.getTooltipPosition(h) || [];
    else if (g4 && g4.dataToPoint)
      if (i.isStacked) {
        var y4 = g4.getBaseAxis(), _ = g4.getOtherAxis(y4), w4 = _.dim, C = y4.dim, E = w4 === "x" || w4 === "radius" ? 1 : 0, T = c4.mapDimension(C), O = [];
        O[E] = c4.get(T, h), O[1 - E] = c4.get(c4.getCalculationInfo("stackResultDimension"), h), e2 = g4.dataToPoint(O) || [];
      } else
        e2 = g4.dataToPoint(c4.getValues(Er(g4.dimensions, function(V) {
          return c4.mapDimension(V);
        }), h)) || [];
    else if (p4) {
      var N = p4.getBoundingRect().clone();
      N.applyTransform(p4.transform), e2 = [N.x + N.width / 2, N.y + N.height / 2];
    }
    return { point: e2, el: p4 };
  }
  var nAe = zs();
  function Hwt(i, n2, e2) {
    var o = i.currTrigger, l4 = [i.x, i.y], c4 = i, h = i.dispatchAction || Ia(e2.dispatchAction, e2), p4 = n2.getComponent("axisPointer").coordSysAxesInfo;
    if (!!p4) {
      fH(l4) && (l4 = k3e({ seriesIndex: c4.seriesIndex, dataIndex: c4.dataIndex }, n2).point);
      var g4 = fH(l4), y4 = c4.axesInfo, _ = p4.axesInfo, w4 = o === "leave" || fH(l4), C = {}, E = {}, T = { list: [], map: {} }, O = { showPointer: zi(Uwt, E), showTooltip: zi(qwt, T) };
      Ve(p4.coordSysMap, function(V, H) {
        var X = g4 || V.containPoint(l4);
        Ve(p4.coordSysAxesInfo[H], function(q2, de) {
          var le = q2.axis, me = Kwt(y4, q2);
          if (!w4 && X && (!y4 || me)) {
            var ye = me && me.value;
            ye == null && !g4 && (ye = le.pointToData(l4)), ye != null && rAe(q2, ye, O, false, C);
          }
        });
      });
      var N = {};
      return Ve(_, function(V, H) {
        var X = V.linkGroup;
        X && !E[H] && Ve(X.axesInfo, function(q2, de) {
          var le = E[de];
          if (q2 !== V && le) {
            var me = le.value;
            X.mapper && (me = V.axis.scale.parse(X.mapper(me, aAe(q2), aAe(V)))), N[V.key] = me;
          }
        });
      }), Ve(N, function(V, H) {
        rAe(_[H], V, O, true, C);
      }), Ywt(E, _, C), Zwt(T, l4, i, h), Xwt(_, h, e2), C;
    }
  }
  function rAe(i, n2, e2, o, l4) {
    var c4 = i.axis;
    if (!(c4.scale.isBlank() || !c4.containData(n2))) {
      if (!i.involveSeries) {
        e2.showPointer(i, n2);
        return;
      }
      var h = $wt(n2, i), p4 = h.payloadBatch, g4 = h.snapToValue;
      p4[0] && l4.seriesIndex == null && rr(l4, p4[0]), !o && i.snap && c4.containData(g4) && g4 != null && (n2 = g4), e2.showPointer(i, n2, p4), e2.showTooltip(i, h, g4);
    }
  }
  function $wt(i, n2) {
    var e2 = n2.axis, o = e2.dim, l4 = i, c4 = [], h = Number.MAX_VALUE, p4 = -1;
    return Ve(n2.seriesModels, function(g4, y4) {
      var _ = g4.getData().mapDimensionsAll(o), w4, C;
      if (g4.getAxisTooltipData) {
        var E = g4.getAxisTooltipData(_, i, e2);
        C = E.dataIndices, w4 = E.nestestValue;
      } else {
        if (C = g4.getData().indicesOfNearest(_[0], i, e2.type === "category" ? 0.5 : null), !C.length)
          return;
        w4 = g4.getData().get(_[0], C[0]);
      }
      if (!(w4 == null || !isFinite(w4))) {
        var T = i - w4, O = Math.abs(T);
        O <= h && ((O < h || T >= 0 && p4 < 0) && (h = O, p4 = T, l4 = w4, c4.length = 0), Ve(C, function(N) {
          c4.push({ seriesIndex: g4.seriesIndex, dataIndexInside: N, dataIndex: g4.getData().getRawIndex(N) });
        }));
      }
    }), { payloadBatch: c4, snapToValue: l4 };
  }
  function Uwt(i, n2, e2, o) {
    i[n2.key] = { value: e2, payloadBatch: o };
  }
  function qwt(i, n2, e2, o) {
    var l4 = e2.payloadBatch, c4 = n2.axis, h = c4.model, p4 = n2.axisPointerModel;
    if (!(!n2.triggerTooltip || !l4.length)) {
      var g4 = n2.coordSys.model, y4 = C8(g4), _ = i.map[y4];
      _ || (_ = i.map[y4] = { coordSysId: g4.id, coordSysIndex: g4.componentIndex, coordSysType: g4.type, coordSysMainType: g4.mainType, dataByAxis: [] }, i.list.push(_)), _.dataByAxis.push({ axisDim: c4.dim, axisIndex: h.componentIndex, axisType: h.type, axisId: h.id, value: o, valueLabelOpt: { precision: p4.get(["label", "precision"]), formatter: p4.get(["label", "formatter"]) }, seriesDataIndices: l4.slice() });
    }
  }
  function Ywt(i, n2, e2) {
    var o = e2.axesInfo = [];
    Ve(n2, function(l4, c4) {
      var h = l4.axisPointerModel.option, p4 = i[c4];
      p4 ? (!l4.useHandle && (h.status = "show"), h.value = p4.value, h.seriesDataIndices = (p4.payloadBatch || []).slice()) : !l4.useHandle && (h.status = "hide"), h.status === "show" && o.push({ axisDim: l4.axis.dim, axisIndex: l4.axis.model.componentIndex, value: h.value });
    });
  }
  function Zwt(i, n2, e2, o) {
    if (fH(n2) || !i.list.length) {
      o({ type: "hideTip" });
      return;
    }
    var l4 = ((i.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
    o({ type: "showTip", escapeConnect: true, x: n2[0], y: n2[1], tooltipOption: e2.tooltipOption, position: e2.position, dataIndexInside: l4.dataIndexInside, dataIndex: l4.dataIndex, seriesIndex: l4.seriesIndex, dataByCoordSys: i.list });
  }
  function Xwt(i, n2, e2) {
    var o = e2.getZr(), l4 = "axisPointerLastHighlights", c4 = nAe(o)[l4] || {}, h = nAe(o)[l4] = {};
    Ve(i, function(y4, _) {
      var w4 = y4.axisPointerModel.option;
      w4.status === "show" && Ve(w4.seriesDataIndices, function(C) {
        var E = C.seriesIndex + " | " + C.dataIndex;
        h[E] = C;
      });
    });
    var p4 = [], g4 = [];
    Ve(c4, function(y4, _) {
      !h[_] && g4.push(y4);
    }), Ve(h, function(y4, _) {
      !c4[_] && p4.push(y4);
    }), g4.length && e2.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: g4 }), p4.length && e2.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: p4 });
  }
  function Kwt(i, n2) {
    for (var e2 = 0; e2 < (i || []).length; e2++) {
      var o = i[e2];
      if (n2.axis.dim === o.axisDim && n2.axis.model.componentIndex === o.axisIndex)
        return o;
    }
  }
  function aAe(i) {
    var n2 = i.axis.model, e2 = {}, o = e2.axisDim = i.axis.dim;
    return e2.axisIndex = e2[o + "AxisIndex"] = n2.componentIndex, e2.axisName = e2[o + "AxisName"] = n2.name, e2.axisId = e2[o + "AxisId"] = n2.id, e2;
  }
  function fH(i) {
    return !i || i[0] == null || isNaN(i[0]) || i[1] == null || isNaN(i[1]);
  }
  function r9(i) {
    IT.registerAxisPointerClass("CartesianAxisPointer", Owt), i.registerComponentModel(Fwt), i.registerComponentView(Wwt), i.registerPreprocessor(function(n2) {
      if (n2) {
        (!n2.axisPointer || n2.axisPointer.length === 0) && (n2.axisPointer = {});
        var e2 = n2.axisPointer.link;
        e2 && !Mr(e2) && (n2.axisPointer.link = [e2]);
      }
    }), i.registerProcessor(i.PRIORITY.PROCESSOR.STATISTIC, function(n2, e2) {
      n2.getComponent("axisPointer").coordSysAxesInfo = zgt(n2, e2);
    }), i.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, Hwt);
  }
  function Jwt(i) {
    wo(nPe), wo(r9);
  }
  var Qwt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.makeElOption = function(e2, o, l4, c4, h) {
      var p4 = l4.axis;
      p4.dim === "angle" && (this.animationThreshold = Math.PI / 18);
      var g4 = p4.polar, y4 = g4.getOtherAxis(p4), _ = y4.getExtent(), w4 = p4.dataToCoord(o), C = c4.get("type");
      if (C && C !== "none") {
        var E = due(c4), T = t2t[C](p4, g4, w4, _);
        T.style = E, e2.graphicKey = T.type, e2.pointer = T;
      }
      var O = c4.get(["label", "margin"]), N = e2t(o, l4, c4, g4, O);
      A3e(e2, l4, c4, h, N);
    }, n2;
  }(hue);
  function e2t(i, n2, e2, o, l4) {
    var c4 = n2.axis, h = c4.dataToCoord(i), p4 = o.getAngleAxis().getExtent()[0];
    p4 = p4 / 180 * Math.PI;
    var g4 = o.getRadiusAxis().getExtent(), y4, _, w4;
    if (c4.dim === "radius") {
      var C = Ny();
      MT(C, C, p4), Y_(C, C, [o.cx, o.cy]), y4 = ab([h, -l4], C);
      var E = n2.getModel("axisLabel").get("rotate") || 0, T = w2.innerTextLayout(p4, E * Math.PI / 180, -1);
      _ = T.textAlign, w4 = T.textVerticalAlign;
    } else {
      var O = g4[1];
      y4 = o.coordToPoint([O + l4, h]);
      var N = o.cx, V = o.cy;
      _ = Math.abs(y4[0] - N) / O < 0.3 ? "center" : y4[0] > N ? "left" : "right", w4 = Math.abs(y4[1] - V) / O < 0.3 ? "middle" : y4[1] > V ? "top" : "bottom";
    }
    return { position: y4, align: _, verticalAlign: w4 };
  }
  var t2t = { line: function(i, n2, e2, o) {
    return i.dim === "angle" ? { type: "Line", shape: vue(n2.coordToPoint([o[0], e2]), n2.coordToPoint([o[1], e2])) } : { type: "Circle", shape: { cx: n2.cx, cy: n2.cy, r: e2 } };
  }, shadow: function(i, n2, e2, o) {
    var l4 = Math.max(1, i.getBandWidth()), c4 = Math.PI / 180;
    return i.dim === "angle" ? { type: "Sector", shape: JMe(n2.cx, n2.cy, o[0], o[1], (-e2 - l4 / 2) * c4, (-e2 + l4 / 2) * c4) } : { type: "Sector", shape: JMe(n2.cx, n2.cy, e2 - l4 / 2, e2 + l4 / 2, 0, Math.PI * 2) };
  } }, n2t = Qwt, r2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.findAxisModel = function(e2) {
      var o, l4 = this.ecModel;
      return l4.eachComponent(e2, function(c4) {
        c4.getCoordSysModel() === this && (o = c4);
      }, this), o;
    }, n2.type = "polar", n2.dependencies = ["radiusAxis", "angleAxis"], n2.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, n2;
  }(Ns), a2t = r2t, gue = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("polar", Yf).models[0];
    }, n2.type = "polarAxis", n2;
  }(Ns);
  Kf(gue, Z8);
  var i2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "angleAxis", n2;
  }(gue), o2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "radiusAxis", n2;
  }(gue), mue = function(i) {
    on(n2, i);
    function n2(e2, o) {
      return i.call(this, "radius", e2, o) || this;
    }
    return n2.prototype.pointToData = function(e2, o) {
      return this.polar.pointToData(e2, o)[this.dim === "radius" ? 0 : 1];
    }, n2;
  }(lb2);
  mue.prototype.dataToRadius = lb2.prototype.dataToCoord;
  mue.prototype.radiusToData = lb2.prototype.coordToData;
  var s2t = mue, l2t = zs(), yue = function(i) {
    on(n2, i);
    function n2(e2, o) {
      return i.call(this, "angle", e2, o || [0, 360]) || this;
    }
    return n2.prototype.pointToData = function(e2, o) {
      return this.polar.pointToData(e2, o)[this.dim === "radius" ? 0 : 1];
    }, n2.prototype.calculateCategoryInterval = function() {
      var e2 = this, o = e2.getLabelModel(), l4 = e2.scale, c4 = l4.getExtent(), h = l4.count();
      if (c4[1] - c4[0] < 1)
        return 0;
      var p4 = c4[0], g4 = e2.dataToCoord(p4 + 1) - e2.dataToCoord(p4), y4 = Math.abs(g4), _ = N8(p4 == null ? "" : p4 + "", o.getFont(), "center", "top"), w4 = Math.max(_.height, 7), C = w4 / y4;
      isNaN(C) && (C = 1 / 0);
      var E = Math.max(0, Math.floor(C)), T = l2t(e2.model), O = T.lastAutoInterval, N = T.lastTickCount;
      return O != null && N != null && Math.abs(O - E) <= 1 && Math.abs(N - h) <= 1 && O > E ? E = O : (T.lastTickCount = h, T.lastAutoInterval = E), E;
    }, n2;
  }(lb2);
  yue.prototype.dataToAngle = lb2.prototype.dataToCoord;
  yue.prototype.angleToData = lb2.prototype.coordToData;
  var u2t = yue, P3e = ["radius", "angle"], c2t = function() {
    function i(n2) {
      this.dimensions = P3e, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new s2t(), this._angleAxis = new u2t(), this.axisPointerEnabled = true, this.name = n2 || "", this._radiusAxis.polar = this._angleAxis.polar = this;
    }
    return i.prototype.containPoint = function(n2) {
      var e2 = this.pointToCoord(n2);
      return this._radiusAxis.contain(e2[0]) && this._angleAxis.contain(e2[1]);
    }, i.prototype.containData = function(n2) {
      return this._radiusAxis.containData(n2[0]) && this._angleAxis.containData(n2[1]);
    }, i.prototype.getAxis = function(n2) {
      var e2 = "_" + n2 + "Axis";
      return this[e2];
    }, i.prototype.getAxes = function() {
      return [this._radiusAxis, this._angleAxis];
    }, i.prototype.getAxesByScale = function(n2) {
      var e2 = [], o = this._angleAxis, l4 = this._radiusAxis;
      return o.scale.type === n2 && e2.push(o), l4.scale.type === n2 && e2.push(l4), e2;
    }, i.prototype.getAngleAxis = function() {
      return this._angleAxis;
    }, i.prototype.getRadiusAxis = function() {
      return this._radiusAxis;
    }, i.prototype.getOtherAxis = function(n2) {
      var e2 = this._angleAxis;
      return n2 === e2 ? this._radiusAxis : e2;
    }, i.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
    }, i.prototype.getTooltipAxes = function(n2) {
      var e2 = n2 != null && n2 !== "auto" ? this.getAxis(n2) : this.getBaseAxis();
      return { baseAxes: [e2], otherAxes: [this.getOtherAxis(e2)] };
    }, i.prototype.dataToPoint = function(n2, e2) {
      return this.coordToPoint([this._radiusAxis.dataToRadius(n2[0], e2), this._angleAxis.dataToAngle(n2[1], e2)]);
    }, i.prototype.pointToData = function(n2, e2) {
      var o = this.pointToCoord(n2);
      return [this._radiusAxis.radiusToData(o[0], e2), this._angleAxis.angleToData(o[1], e2)];
    }, i.prototype.pointToCoord = function(n2) {
      var e2 = n2[0] - this.cx, o = n2[1] - this.cy, l4 = this.getAngleAxis(), c4 = l4.getExtent(), h = Math.min(c4[0], c4[1]), p4 = Math.max(c4[0], c4[1]);
      l4.inverse ? h = p4 - 360 : p4 = h + 360;
      var g4 = Math.sqrt(e2 * e2 + o * o);
      e2 /= g4, o /= g4;
      for (var y4 = Math.atan2(-o, e2) / Math.PI * 180, _ = y4 < h ? 1 : -1; y4 < h || y4 > p4; )
        y4 += _ * 360;
      return [g4, y4];
    }, i.prototype.coordToPoint = function(n2) {
      var e2 = n2[0], o = n2[1] / 180 * Math.PI, l4 = Math.cos(o) * e2 + this.cx, c4 = -Math.sin(o) * e2 + this.cy;
      return [l4, c4];
    }, i.prototype.getArea = function() {
      var n2 = this.getAngleAxis(), e2 = this.getRadiusAxis(), o = e2.getExtent().slice();
      o[0] > o[1] && o.reverse();
      var l4 = n2.getExtent(), c4 = Math.PI / 180;
      return { cx: this.cx, cy: this.cy, r0: o[0], r: o[1], startAngle: -l4[0] * c4, endAngle: -l4[1] * c4, clockwise: n2.inverse, contain: function(h, p4) {
        var g4 = h - this.cx, y4 = p4 - this.cy, _ = g4 * g4 + y4 * y4 - 1e-4, w4 = this.r, C = this.r0;
        return _ <= w4 * w4 && _ >= C * C;
      } };
    }, i.prototype.convertToPixel = function(n2, e2, o) {
      var l4 = iAe(e2);
      return l4 === this ? this.dataToPoint(o) : null;
    }, i.prototype.convertFromPixel = function(n2, e2, o) {
      var l4 = iAe(e2);
      return l4 === this ? this.pointToData(o) : null;
    }, i;
  }();
  function iAe(i) {
    var n2 = i.seriesModel, e2 = i.polarModel;
    return e2 && e2.coordinateSystem || n2 && n2.coordinateSystem;
  }
  var f2t = c2t;
  function h2t(i, n2, e2) {
    var o = n2.get("center"), l4 = e2.getWidth(), c4 = e2.getHeight();
    i.cx = ma(o[0], l4), i.cy = ma(o[1], c4);
    var h = i.getRadiusAxis(), p4 = Math.min(l4, c4) / 2, g4 = n2.get("radius");
    g4 == null ? g4 = [0, "100%"] : Mr(g4) || (g4 = [0, g4]);
    var y4 = [ma(g4[0], p4), ma(g4[1], p4)];
    h.inverse ? h.setExtent(y4[1], y4[0]) : h.setExtent(y4[0], y4[1]);
  }
  function d2t(i, n2) {
    var e2 = this, o = e2.getAngleAxis(), l4 = e2.getRadiusAxis();
    if (o.scale.setExtent(1 / 0, -1 / 0), l4.scale.setExtent(1 / 0, -1 / 0), i.eachSeries(function(p4) {
      if (p4.coordinateSystem === e2) {
        var g4 = p4.getData();
        Ve(jH(g4, "radius"), function(y4) {
          l4.scale.unionExtentFromData(g4, y4);
        }), Ve(jH(g4, "angle"), function(y4) {
          o.scale.unionExtentFromData(g4, y4);
        });
      }
    }), F3(o.scale, o.model), F3(l4.scale, l4.model), o.type === "category" && !o.onBand) {
      var c4 = o.getExtent(), h = 360 / o.scale.count();
      o.inverse ? c4[1] += h : c4[1] -= h, o.setExtent(c4[0], c4[1]);
    }
  }
  function p2t(i) {
    return i.mainType === "angleAxis";
  }
  function oAe(i, n2) {
    if (i.type = n2.get("type"), i.scale = $$(n2), i.onBand = n2.get("boundaryGap") && i.type === "category", i.inverse = n2.get("inverse"), p2t(n2)) {
      i.inverse = i.inverse !== n2.get("clockwise");
      var e2 = n2.get("startAngle");
      i.setExtent(e2, e2 + (i.inverse ? -360 : 360));
    }
    n2.axis = i, i.model = n2;
  }
  var v2t = { dimensions: P3e, create: function(i, n2) {
    var e2 = [];
    return i.eachComponent("polar", function(o, l4) {
      var c4 = new f2t(l4 + "");
      c4.update = d2t;
      var h = c4.getRadiusAxis(), p4 = c4.getAngleAxis(), g4 = o.findAxisModel("radiusAxis"), y4 = o.findAxisModel("angleAxis");
      oAe(h, g4), oAe(p4, y4), h2t(c4, o, n2), e2.push(c4), o.coordinateSystem = c4, c4.model = o;
    }), i.eachSeries(function(o) {
      if (o.get("coordinateSystem") === "polar") {
        var l4 = o.getReferringComponents("polar", Yf).models[0];
        o.coordinateSystem = l4.coordinateSystem;
      }
    }), e2;
  } }, g2t = v2t, m2t = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
  function LW(i, n2, e2) {
    n2[1] > n2[0] && (n2 = n2.slice().reverse());
    var o = i.coordToPoint([n2[0], e2]), l4 = i.coordToPoint([n2[1], e2]);
    return { x1: o[0], y1: o[1], x2: l4[0], y2: l4[1] };
  }
  function OW(i) {
    var n2 = i.getRadiusAxis();
    return n2.inverse ? 0 : 1;
  }
  function sAe(i) {
    var n2 = i[0], e2 = i[i.length - 1];
    n2 && e2 && Math.abs(Math.abs(n2.coord - e2.coord) - 360) < 1e-4 && i.pop();
  }
  var y2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.axisPointerClass = "PolarAxisPointer", e2;
    }
    return n2.prototype.render = function(e2, o) {
      if (this.group.removeAll(), !!e2.get("show")) {
        var l4 = e2.axis, c4 = l4.polar, h = c4.getRadiusAxis().getExtent(), p4 = l4.getTicksCoords(), g4 = l4.getMinorTicksCoords(), y4 = Er(l4.getViewLabels(), function(_) {
          _ = Ci(_);
          var w4 = l4.scale, C = w4.type === "ordinal" ? w4.getRawOrdinalNumber(_.tickValue) : _.tickValue;
          return _.coord = l4.dataToCoord(C), _;
        });
        sAe(y4), sAe(p4), Ve(m2t, function(_) {
          e2.get([_, "show"]) && (!l4.scale.isBlank() || _ === "axisLine") && b2t[_](this.group, e2, c4, p4, g4, h, y4);
        }, this);
      }
    }, n2.type = "angleAxis", n2;
  }(IT), b2t = { axisLine: function(i, n2, e2, o, l4, c4) {
    var h = n2.getModel(["axisLine", "lineStyle"]), p4 = OW(e2), g4 = p4 ? 0 : 1, y4;
    c4[g4] === 0 ? y4 = new J_({ shape: { cx: e2.cx, cy: e2.cy, r: c4[p4] }, style: h.getLineStyle(), z2: 1, silent: true }) : y4 = new E$({ shape: { cx: e2.cx, cy: e2.cy, r: c4[p4], r0: c4[g4] }, style: h.getLineStyle(), z2: 1, silent: true }), y4.style.fill = null, i.add(y4);
  }, axisTick: function(i, n2, e2, o, l4, c4) {
    var h = n2.getModel("axisTick"), p4 = (h.get("inside") ? -1 : 1) * h.get("length"), g4 = c4[OW(e2)], y4 = Er(o, function(_) {
      return new Vd({ shape: LW(e2, [g4, g4 + p4], _.coord) });
    });
    i.add(ky(y4, { style: hi(h.getModel("lineStyle").getLineStyle(), { stroke: n2.get(["axisLine", "lineStyle", "color"]) }) }));
  }, minorTick: function(i, n2, e2, o, l4, c4) {
    if (!!l4.length) {
      for (var h = n2.getModel("axisTick"), p4 = n2.getModel("minorTick"), g4 = (h.get("inside") ? -1 : 1) * p4.get("length"), y4 = c4[OW(e2)], _ = [], w4 = 0; w4 < l4.length; w4++)
        for (var C = 0; C < l4[w4].length; C++)
          _.push(new Vd({ shape: LW(e2, [y4, y4 + g4], l4[w4][C].coord) }));
      i.add(ky(_, { style: hi(p4.getModel("lineStyle").getLineStyle(), hi(h.getLineStyle(), { stroke: n2.get(["axisLine", "lineStyle", "color"]) })) }));
    }
  }, axisLabel: function(i, n2, e2, o, l4, c4, h) {
    var p4 = n2.getCategories(true), g4 = n2.getModel("axisLabel"), y4 = g4.get("margin"), _ = n2.get("triggerEvent");
    Ve(h, function(w4, C) {
      var E = g4, T = w4.tickValue, O = c4[OW(e2)], N = e2.coordToPoint([O + y4, w4.coord]), V = e2.cx, H = e2.cy, X = Math.abs(N[0] - V) / O < 0.3 ? "center" : N[0] > V ? "left" : "right", q2 = Math.abs(N[1] - H) / O < 0.3 ? "middle" : N[1] > H ? "top" : "bottom";
      if (p4 && p4[T]) {
        var de = p4[T];
        mi(de) && de.textStyle && (E = new Ou(de.textStyle, g4, g4.ecModel));
      }
      var le = new Qs({ silent: w2.isLabelSilent(n2), style: Ef(E, { x: N[0], y: N[1], fill: E.getTextColor() || n2.get(["axisLine", "lineStyle", "color"]), text: w4.formattedLabel, align: X, verticalAlign: q2 }) });
      if (i.add(le), _) {
        var me = w2.makeAxisEventDataBase(n2);
        me.targetType = "axisLabel", me.value = w4.rawLabel, Fi(le).eventData = me;
      }
    }, this);
  }, splitLine: function(i, n2, e2, o, l4, c4) {
    var h = n2.getModel("splitLine"), p4 = h.getModel("lineStyle"), g4 = p4.get("color"), y4 = 0;
    g4 = g4 instanceof Array ? g4 : [g4];
    for (var _ = [], w4 = 0; w4 < o.length; w4++) {
      var C = y4++ % g4.length;
      _[C] = _[C] || [], _[C].push(new Vd({ shape: LW(e2, c4, o[w4].coord) }));
    }
    for (var w4 = 0; w4 < _.length; w4++)
      i.add(ky(_[w4], { style: hi({ stroke: g4[w4 % g4.length] }, p4.getLineStyle()), silent: true, z: n2.get("z") }));
  }, minorSplitLine: function(i, n2, e2, o, l4, c4) {
    if (!!l4.length) {
      for (var h = n2.getModel("minorSplitLine"), p4 = h.getModel("lineStyle"), g4 = [], y4 = 0; y4 < l4.length; y4++)
        for (var _ = 0; _ < l4[y4].length; _++)
          g4.push(new Vd({ shape: LW(e2, c4, l4[y4][_].coord) }));
      i.add(ky(g4, { style: p4.getLineStyle(), silent: true, z: n2.get("z") }));
    }
  }, splitArea: function(i, n2, e2, o, l4, c4) {
    if (!!o.length) {
      var h = n2.getModel("splitArea"), p4 = h.getModel("areaStyle"), g4 = p4.get("color"), y4 = 0;
      g4 = g4 instanceof Array ? g4 : [g4];
      for (var _ = [], w4 = Math.PI / 180, C = -o[0].coord * w4, E = Math.min(c4[0], c4[1]), T = Math.max(c4[0], c4[1]), O = n2.get("clockwise"), N = 1, V = o.length; N <= V; N++) {
        var H = N === V ? o[0].coord : o[N].coord, X = y4++ % g4.length;
        _[X] = _[X] || [], _[X].push(new Hg({ shape: { cx: e2.cx, cy: e2.cy, r0: E, r: T, startAngle: C, endAngle: -H * w4, clockwise: O }, silent: true })), C = -H * w4;
      }
      for (var N = 0; N < _.length; N++)
        i.add(ky(_[N], { style: hi({ fill: g4[N % g4.length] }, p4.getAreaStyle()), silent: true }));
    }
  } }, _2t = y2t, x2t = ["axisLine", "axisTickLabel", "axisName"], w2t = ["splitLine", "splitArea", "minorSplitLine"], S2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.axisPointerClass = "PolarAxisPointer", e2;
    }
    return n2.prototype.render = function(e2, o) {
      if (this.group.removeAll(), !!e2.get("show")) {
        var l4 = this._axisGroup, c4 = this._axisGroup = new Ti();
        this.group.add(c4);
        var h = e2.axis, p4 = h.polar, g4 = p4.getAngleAxis(), y4 = h.getTicksCoords(), _ = h.getMinorTicksCoords(), w4 = g4.getExtent()[0], C = h.getExtent(), E = M2t(p4, e2, w4), T = new w2(e2, E);
        Ve(x2t, T.add, T), c4.add(T.getGroup()), j8(l4, c4, e2), Ve(w2t, function(O) {
          e2.get([O, "show"]) && !h.scale.isBlank() && C2t[O](this.group, e2, p4, w4, C, y4, _);
        }, this);
      }
    }, n2.type = "radiusAxis", n2;
  }(IT), C2t = { splitLine: function(i, n2, e2, o, l4, c4) {
    var h = n2.getModel("splitLine"), p4 = h.getModel("lineStyle"), g4 = p4.get("color"), y4 = 0;
    g4 = g4 instanceof Array ? g4 : [g4];
    for (var _ = [], w4 = 0; w4 < c4.length; w4++) {
      var C = y4++ % g4.length;
      _[C] = _[C] || [], _[C].push(new J_({ shape: { cx: e2.cx, cy: e2.cy, r: c4[w4].coord } }));
    }
    for (var w4 = 0; w4 < _.length; w4++)
      i.add(ky(_[w4], { style: hi({ stroke: g4[w4 % g4.length], fill: null }, p4.getLineStyle()), silent: true }));
  }, minorSplitLine: function(i, n2, e2, o, l4, c4, h) {
    if (!!h.length) {
      for (var p4 = n2.getModel("minorSplitLine"), g4 = p4.getModel("lineStyle"), y4 = [], _ = 0; _ < h.length; _++)
        for (var w4 = 0; w4 < h[_].length; w4++)
          y4.push(new J_({ shape: { cx: e2.cx, cy: e2.cy, r: h[_][w4].coord } }));
      i.add(ky(y4, { style: hi({ fill: null }, g4.getLineStyle()), silent: true }));
    }
  }, splitArea: function(i, n2, e2, o, l4, c4) {
    if (!!c4.length) {
      var h = n2.getModel("splitArea"), p4 = h.getModel("areaStyle"), g4 = p4.get("color"), y4 = 0;
      g4 = g4 instanceof Array ? g4 : [g4];
      for (var _ = [], w4 = c4[0].coord, C = 1; C < c4.length; C++) {
        var E = y4++ % g4.length;
        _[E] = _[E] || [], _[E].push(new Hg({ shape: { cx: e2.cx, cy: e2.cy, r0: w4, r: c4[C].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), w4 = c4[C].coord;
      }
      for (var C = 0; C < _.length; C++)
        i.add(ky(_[C], { style: hi({ fill: g4[C % g4.length] }, p4.getAreaStyle()), silent: true }));
    }
  } };
  function M2t(i, n2, e2) {
    return { position: [i.cx, i.cy], rotation: e2 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: n2.getModel("axisLabel").get("rotate"), z2: 1 };
  }
  var A2t = S2t;
  function L3e(i) {
    return i.get("stack") || "__ec_stack_" + i.seriesIndex;
  }
  function O3e(i, n2) {
    return n2.dim + i.model.componentIndex;
  }
  function E2t(i, n2, e2) {
    var o = {}, l4 = I2t(Yl(n2.getSeriesByType(i), function(c4) {
      return !n2.isSeriesFiltered(c4) && c4.coordinateSystem && c4.coordinateSystem.type === "polar";
    }));
    n2.eachSeriesByType(i, function(c4) {
      if (c4.coordinateSystem.type === "polar") {
        var h = c4.getData(), p4 = c4.coordinateSystem, g4 = p4.getBaseAxis(), y4 = O3e(p4, g4), _ = L3e(c4), w4 = l4[y4][_], C = w4.offset, E = w4.width, T = p4.getOtherAxis(g4), O = c4.coordinateSystem.cx, N = c4.coordinateSystem.cy, V = c4.get("barMinHeight") || 0, H = c4.get("barMinAngle") || 0;
        o[_] = o[_] || [];
        for (var X = h.mapDimension(T.dim), q2 = h.mapDimension(g4.dim), de = eM(h, X), le = g4.dim !== "radius" || !c4.get("roundCap", true), me = T.dataToCoord(0), ye = 0, be = h.count(); ye < be; ye++) {
          var we = h.get(X, ye), Pe = h.get(q2, ye), ze = we >= 0 ? "p" : "n", Re = me;
          de && (o[_][Pe] || (o[_][Pe] = { p: me, n: me }), Re = o[_][Pe][ze]);
          var rt2 = void 0, ft = void 0, et = void 0, Jt = void 0;
          if (T.dim === "radius") {
            var xt = T.dataToCoord(we) - me, It = g4.dataToCoord(Pe);
            Math.abs(xt) < V && (xt = (xt < 0 ? -1 : 1) * V), rt2 = Re, ft = Re + xt, et = It - C, Jt = et - E, de && (o[_][Pe][ze] = ft);
          } else {
            var Wt = T.dataToCoord(we, le) - me, sn = g4.dataToCoord(Pe);
            Math.abs(Wt) < H && (Wt = (Wt < 0 ? -1 : 1) * H), rt2 = sn + C, ft = rt2 + E, et = Re, Jt = Re + Wt, de && (o[_][Pe][ze] = Jt);
          }
          h.setItemLayout(ye, { cx: O, cy: N, r0: rt2, r: ft, startAngle: -et * Math.PI / 180, endAngle: -Jt * Math.PI / 180, clockwise: et >= Jt });
        }
      }
    });
  }
  function I2t(i) {
    var n2 = {};
    Ve(i, function(o, l4) {
      var c4 = o.getData(), h = o.coordinateSystem, p4 = h.getBaseAxis(), g4 = O3e(h, p4), y4 = p4.getExtent(), _ = p4.type === "category" ? p4.getBandWidth() : Math.abs(y4[1] - y4[0]) / c4.count(), w4 = n2[g4] || { bandWidth: _, remainedWidth: _, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, C = w4.stacks;
      n2[g4] = w4;
      var E = L3e(o);
      C[E] || w4.autoWidthCount++, C[E] = C[E] || { width: 0, maxWidth: 0 };
      var T = ma(o.get("barWidth"), _), O = ma(o.get("barMaxWidth"), _), N = o.get("barGap"), V = o.get("barCategoryGap");
      T && !C[E].width && (T = Math.min(w4.remainedWidth, T), C[E].width = T, w4.remainedWidth -= T), O && (C[E].maxWidth = O), N != null && (w4.gap = N), V != null && (w4.categoryGap = V);
    });
    var e2 = {};
    return Ve(n2, function(o, l4) {
      e2[l4] = {};
      var c4 = o.stacks, h = o.bandWidth, p4 = ma(o.categoryGap, h), g4 = ma(o.gap, 1), y4 = o.remainedWidth, _ = o.autoWidthCount, w4 = (y4 - p4) / (_ + (_ - 1) * g4);
      w4 = Math.max(w4, 0), Ve(c4, function(O, N) {
        var V = O.maxWidth;
        V && V < w4 && (V = Math.min(V, y4), O.width && (V = Math.min(V, O.width)), y4 -= V, O.width = V, _--);
      }), w4 = (y4 - p4) / (_ + (_ - 1) * g4), w4 = Math.max(w4, 0);
      var C = 0, E;
      Ve(c4, function(O, N) {
        O.width || (O.width = w4), E = O, C += O.width * (1 + g4);
      }), E && (C -= E.width * g4);
      var T = -C / 2;
      Ve(c4, function(O, N) {
        e2[l4][N] = e2[l4][N] || { offset: T, width: O.width }, T += O.width * (1 + g4);
      });
    }), e2;
  }
  var T2t = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, D2t = { splitNumber: 5 }, k2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "polar", n2;
  }($c);
  function P2t(i) {
    wo(r9), IT.registerAxisPointerClass("PolarAxisPointer", n2t), i.registerCoordinateSystem("polar", g2t), i.registerComponentModel(a2t), i.registerComponentView(k2t), V3(i, "angle", i2t, T2t), V3(i, "radius", o2t, D2t), i.registerComponentView(_2t), i.registerComponentView(A2t), i.registerLayout(zi(E2t, "bar"));
  }
  function qoe(i, n2) {
    n2 = n2 || {};
    var e2 = i.coordinateSystem, o = i.axis, l4 = {}, c4 = o.position, h = o.orient, p4 = e2.getRect(), g4 = [p4.x, p4.x + p4.width, p4.y, p4.y + p4.height], y4 = { horizontal: { top: g4[2], bottom: g4[3] }, vertical: { left: g4[0], right: g4[1] } };
    l4.position = [h === "vertical" ? y4.vertical[c4] : g4[0], h === "horizontal" ? y4.horizontal[c4] : g4[3]];
    var _ = { horizontal: 0, vertical: 1 };
    l4.rotation = Math.PI / 2 * _[h];
    var w4 = { top: -1, bottom: 1, right: 1, left: -1 };
    l4.labelDirection = l4.tickDirection = l4.nameDirection = w4[c4], i.get(["axisTick", "inside"]) && (l4.tickDirection = -l4.tickDirection), Nd(n2.labelInside, i.get(["axisLabel", "inside"])) && (l4.labelDirection = -l4.labelDirection);
    var C = n2.rotate;
    return C == null && (C = i.get(["axisLabel", "rotate"])), l4.labelRotation = c4 === "top" ? -C : C, l4.z2 = 1, l4;
  }
  var L2t = ["axisLine", "axisTickLabel", "axisName"], O2t = ["splitArea", "splitLine"], R2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.axisPointerClass = "SingleAxisPointer", e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      var h = this.group;
      h.removeAll();
      var p4 = this._axisGroup;
      this._axisGroup = new Ti();
      var g4 = qoe(e2), y4 = new w2(e2, g4);
      Ve(L2t, y4.add, y4), h.add(this._axisGroup), h.add(y4.getGroup()), Ve(O2t, function(_) {
        e2.get([_, "show"]) && F2t[_](this, this.group, this._axisGroup, e2);
      }, this), j8(p4, this._axisGroup, e2), i.prototype.render.call(this, e2, o, l4, c4);
    }, n2.prototype.remove = function() {
      Qke(this);
    }, n2.type = "singleAxis", n2;
  }(IT), F2t = { splitLine: function(i, n2, e2, o) {
    var l4 = o.axis;
    if (!l4.scale.isBlank()) {
      var c4 = o.getModel("splitLine"), h = c4.getModel("lineStyle"), p4 = h.get("color");
      p4 = p4 instanceof Array ? p4 : [p4];
      for (var g4 = o.coordinateSystem.getRect(), y4 = l4.isHorizontal(), _ = [], w4 = 0, C = l4.getTicksCoords({ tickModel: c4 }), E = [], T = [], O = 0; O < C.length; ++O) {
        var N = l4.toGlobalCoord(C[O].coord);
        y4 ? (E[0] = N, E[1] = g4.y, T[0] = N, T[1] = g4.y + g4.height) : (E[0] = g4.x, E[1] = N, T[0] = g4.x + g4.width, T[1] = N);
        var V = w4++ % p4.length;
        _[V] = _[V] || [], _[V].push(new Vd({ subPixelOptimize: true, shape: { x1: E[0], y1: E[1], x2: T[0], y2: T[1] }, silent: true }));
      }
      for (var H = h.getLineStyle(["color"]), O = 0; O < _.length; ++O)
        n2.add(ky(_[O], { style: hi({ stroke: p4[O % p4.length] }, H), silent: true }));
    }
  }, splitArea: function(i, n2, e2, o) {
    Jke(i, e2, o, o);
  } }, N2t = R2t, R3e = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.getCoordSysModel = function() {
      return this;
    }, n2.type = "singleAxis", n2.layoutMode = "box", n2.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, n2;
  }(Ns);
  Kf(R3e, Z8.prototype);
  var $ae = R3e, V2t = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4, h) {
      var p4 = i.call(this, e2, o, l4) || this;
      return p4.type = c4 || "value", p4.position = h || "bottom", p4;
    }
    return n2.prototype.isHorizontal = function() {
      var e2 = this.position;
      return e2 === "top" || e2 === "bottom";
    }, n2.prototype.pointToData = function(e2, o) {
      return this.coordinateSystem.pointToData(e2)[0];
    }, n2;
  }(lb2), z2t = V2t, F3e = ["single"], B2t = function() {
    function i(n2, e2, o) {
      this.type = "single", this.dimension = "single", this.dimensions = F3e, this.axisPointerEnabled = true, this.model = n2, this._init(n2, e2, o);
    }
    return i.prototype._init = function(n2, e2, o) {
      var l4 = this.dimension, c4 = new z2t(l4, $$(n2), [0, 0], n2.get("type"), n2.get("position")), h = c4.type === "category";
      c4.onBand = h && n2.get("boundaryGap"), c4.inverse = n2.get("inverse"), c4.orient = n2.get("orient"), n2.axis = c4, c4.model = n2, c4.coordinateSystem = this, this._axis = c4;
    }, i.prototype.update = function(n2, e2) {
      n2.eachSeries(function(o) {
        if (o.coordinateSystem === this) {
          var l4 = o.getData();
          Ve(l4.mapDimensionsAll(this.dimension), function(c4) {
            this._axis.scale.unionExtentFromData(l4, c4);
          }, this), F3(this._axis.scale, this._axis.model);
        }
      }, this);
    }, i.prototype.resize = function(n2, e2) {
      this._rect = bh({ left: n2.get("left"), top: n2.get("top"), right: n2.get("right"), bottom: n2.get("bottom"), width: n2.get("width"), height: n2.get("height") }, { width: e2.getWidth(), height: e2.getHeight() }), this._adjustAxis();
    }, i.prototype.getRect = function() {
      return this._rect;
    }, i.prototype._adjustAxis = function() {
      var n2 = this._rect, e2 = this._axis, o = e2.isHorizontal(), l4 = o ? [0, n2.width] : [0, n2.height], c4 = e2.reverse ? 1 : 0;
      e2.setExtent(l4[c4], l4[1 - c4]), this._updateAxisTransform(e2, o ? n2.x : n2.y);
    }, i.prototype._updateAxisTransform = function(n2, e2) {
      var o = n2.getExtent(), l4 = o[0] + o[1], c4 = n2.isHorizontal();
      n2.toGlobalCoord = c4 ? function(h) {
        return h + e2;
      } : function(h) {
        return l4 - h + e2;
      }, n2.toLocalCoord = c4 ? function(h) {
        return h - e2;
      } : function(h) {
        return l4 - h + e2;
      };
    }, i.prototype.getAxis = function() {
      return this._axis;
    }, i.prototype.getBaseAxis = function() {
      return this._axis;
    }, i.prototype.getAxes = function() {
      return [this._axis];
    }, i.prototype.getTooltipAxes = function() {
      return { baseAxes: [this.getAxis()], otherAxes: [] };
    }, i.prototype.containPoint = function(n2) {
      var e2 = this.getRect(), o = this.getAxis(), l4 = o.orient;
      return l4 === "horizontal" ? o.contain(o.toLocalCoord(n2[0])) && n2[1] >= e2.y && n2[1] <= e2.y + e2.height : o.contain(o.toLocalCoord(n2[1])) && n2[0] >= e2.y && n2[0] <= e2.y + e2.height;
    }, i.prototype.pointToData = function(n2) {
      var e2 = this.getAxis();
      return [e2.coordToData(e2.toLocalCoord(n2[e2.orient === "horizontal" ? 0 : 1]))];
    }, i.prototype.dataToPoint = function(n2) {
      var e2 = this.getAxis(), o = this.getRect(), l4 = [], c4 = e2.orient === "horizontal" ? 0 : 1;
      return n2 instanceof Array && (n2 = n2[0]), l4[c4] = e2.toGlobalCoord(e2.dataToCoord(+n2)), l4[1 - c4] = c4 === 0 ? o.y + o.height / 2 : o.x + o.width / 2, l4;
    }, i.prototype.convertToPixel = function(n2, e2, o) {
      var l4 = lAe(e2);
      return l4 === this ? this.dataToPoint(o) : null;
    }, i.prototype.convertFromPixel = function(n2, e2, o) {
      var l4 = lAe(e2);
      return l4 === this ? this.pointToData(o) : null;
    }, i;
  }();
  function lAe(i) {
    var n2 = i.seriesModel, e2 = i.singleAxisModel;
    return e2 && e2.coordinateSystem || n2 && n2.coordinateSystem;
  }
  function j2t(i, n2) {
    var e2 = [];
    return i.eachComponent("singleAxis", function(o, l4) {
      var c4 = new B2t(o, i, n2);
      c4.name = "single_" + l4, c4.resize(o, n2), o.coordinateSystem = c4, e2.push(c4);
    }), i.eachSeries(function(o) {
      if (o.get("coordinateSystem") === "singleAxis") {
        var l4 = o.getReferringComponents("singleAxis", Yf).models[0];
        o.coordinateSystem = l4 && l4.coordinateSystem;
      }
    }), e2;
  }
  var G2t = { create: j2t, dimensions: F3e }, W2t = G2t, uAe = ["x", "y"], H2t = ["width", "height"], $2t = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.makeElOption = function(e2, o, l4, c4, h) {
      var p4 = l4.axis, g4 = p4.coordinateSystem, y4 = Uae(g4, 1 - n$(p4)), _ = g4.dataToPoint(o)[0], w4 = c4.get("type");
      if (w4 && w4 !== "none") {
        var C = due(c4), E = U2t[w4](p4, _, y4);
        E.style = C, e2.graphicKey = E.type, e2.pointer = E;
      }
      var T = qoe(l4);
      I3e(o, e2, T, l4, c4, h);
    }, n2.prototype.getHandleTransform = function(e2, o, l4) {
      var c4 = qoe(o, { labelInside: false });
      c4.labelMargin = l4.get(["handle", "margin"]);
      var h = pue(o.axis, e2, c4);
      return { x: h[0], y: h[1], rotation: c4.rotation + (c4.labelDirection < 0 ? Math.PI : 0) };
    }, n2.prototype.updateHandleTransform = function(e2, o, l4, c4) {
      var h = l4.axis, p4 = h.coordinateSystem, g4 = n$(h), y4 = Uae(p4, g4), _ = [e2.x, e2.y];
      _[g4] += o[g4], _[g4] = Math.min(y4[1], _[g4]), _[g4] = Math.max(y4[0], _[g4]);
      var w4 = Uae(p4, 1 - g4), C = (w4[1] + w4[0]) / 2, E = [C, C];
      return E[g4] = _[g4], { x: _[0], y: _[1], rotation: e2.rotation, cursorPoint: E, tooltipOption: { verticalAlign: "middle" } };
    }, n2;
  }(hue), U2t = { line: function(i, n2, e2) {
    var o = vue([n2, e2[0]], [n2, e2[1]], n$(i));
    return { type: "Line", subPixelOptimize: true, shape: o };
  }, shadow: function(i, n2, e2) {
    var o = i.getBandWidth(), l4 = e2[1] - e2[0];
    return { type: "Rect", shape: T3e([n2 - o / 2, e2[0]], [o, l4], n$(i)) };
  } };
  function n$(i) {
    return i.isHorizontal() ? 0 : 1;
  }
  function Uae(i, n2) {
    var e2 = i.getRect();
    return [e2[uAe[n2]], e2[uAe[n2]] + e2[H2t[n2]]];
  }
  var q2t = $2t, Y2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "single", n2;
  }($c);
  function Z2t(i) {
    wo(r9), IT.registerAxisPointerClass("SingleAxisPointer", q2t), i.registerComponentView(Y2t), i.registerComponentView(N2t), i.registerComponentModel($ae), V3(i, "single", $ae, $ae.defaultOption), i.registerCoordinateSystem("single", W2t);
  }
  var X2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      var c4 = K3(e2);
      i.prototype.init.apply(this, arguments), cAe(e2, c4);
    }, n2.prototype.mergeOption = function(e2) {
      i.prototype.mergeOption.apply(this, arguments), cAe(this.option, e2);
    }, n2.prototype.getCellSize = function() {
      return this.option.cellSize;
    }, n2.type = "calendar", n2.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, n2;
  }(Ns);
  function cAe(i, n2) {
    var e2 = i.cellSize, o;
    Mr(e2) ? o = e2 : o = i.cellSize = [e2, e2], o.length === 1 && (o[1] = o[0]);
    var l4 = Er([0, 1], function(c4) {
      return nct(n2, c4) && (o[c4] = "auto"), o[c4] != null && o[c4] !== "auto";
    });
    QC(i, n2, { type: "box", ignoreSize: l4 });
  }
  var K2t = X2t, J2t = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4 = this.group;
      c4.removeAll();
      var h = e2.coordinateSystem, p4 = h.getRangeInfo(), g4 = h.getOrient(), y4 = o.getLocaleModel();
      this._renderDayRect(e2, p4, c4), this._renderLines(e2, p4, g4, c4), this._renderYearText(e2, p4, g4, c4), this._renderMonthText(e2, y4, g4, c4), this._renderWeekText(e2, y4, p4, g4, c4);
    }, n2.prototype._renderDayRect = function(e2, o, l4) {
      for (var c4 = e2.coordinateSystem, h = e2.getModel("itemStyle").getItemStyle(), p4 = c4.getCellWidth(), g4 = c4.getCellHeight(), y4 = o.start.time; y4 <= o.end.time; y4 = c4.getNextNDay(y4, 1).time) {
        var _ = c4.dataToRect([y4], false).tl, w4 = new Is({ shape: { x: _[0], y: _[1], width: p4, height: g4 }, cursor: "default", style: h });
        l4.add(w4);
      }
    }, n2.prototype._renderLines = function(e2, o, l4, c4) {
      var h = this, p4 = e2.coordinateSystem, g4 = e2.getModel(["splitLine", "lineStyle"]).getLineStyle(), y4 = e2.get(["splitLine", "show"]), _ = g4.lineWidth;
      this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
      for (var w4 = o.start, C = 0; w4.time <= o.end.time; C++) {
        T(w4.formatedDate), C === 0 && (w4 = p4.getDateInfo(o.start.y + "-" + o.start.m));
        var E = w4.date;
        E.setMonth(E.getMonth() + 1), w4 = p4.getDateInfo(E);
      }
      T(p4.getNextNDay(o.end.time, 1).formatedDate);
      function T(O) {
        h._firstDayOfMonth.push(p4.getDateInfo(O)), h._firstDayPoints.push(p4.dataToRect([O], false).tl);
        var N = h._getLinePointsOfOneWeek(e2, O, l4);
        h._tlpoints.push(N[0]), h._blpoints.push(N[N.length - 1]), y4 && h._drawSplitline(N, g4, c4);
      }
      y4 && this._drawSplitline(h._getEdgesPoints(h._tlpoints, _, l4), g4, c4), y4 && this._drawSplitline(h._getEdgesPoints(h._blpoints, _, l4), g4, c4);
    }, n2.prototype._getEdgesPoints = function(e2, o, l4) {
      var c4 = [e2[0].slice(), e2[e2.length - 1].slice()], h = l4 === "horizontal" ? 0 : 1;
      return c4[0][h] = c4[0][h] - o / 2, c4[1][h] = c4[1][h] + o / 2, c4;
    }, n2.prototype._drawSplitline = function(e2, o, l4) {
      var c4 = new Ug({ z2: 20, shape: { points: e2 }, style: o });
      l4.add(c4);
    }, n2.prototype._getLinePointsOfOneWeek = function(e2, o, l4) {
      for (var c4 = e2.coordinateSystem, h = c4.getDateInfo(o), p4 = [], g4 = 0; g4 < 7; g4++) {
        var y4 = c4.getNextNDay(h.time, g4), _ = c4.dataToRect([y4.time], false);
        p4[2 * y4.day] = _.tl, p4[2 * y4.day + 1] = _[l4 === "horizontal" ? "bl" : "tr"];
      }
      return p4;
    }, n2.prototype._formatterLabel = function(e2, o) {
      return xa(e2) && e2 ? Qut(e2, o) : si(e2) ? e2(o) : o.nameMap;
    }, n2.prototype._yearTextPositionControl = function(e2, o, l4, c4, h) {
      var p4 = o[0], g4 = o[1], y4 = ["center", "bottom"];
      c4 === "bottom" ? (g4 += h, y4 = ["center", "top"]) : c4 === "left" ? p4 -= h : c4 === "right" ? (p4 += h, y4 = ["center", "top"]) : g4 -= h;
      var _ = 0;
      return (c4 === "left" || c4 === "right") && (_ = Math.PI / 2), { rotation: _, x: p4, y: g4, style: { align: y4[0], verticalAlign: y4[1] } };
    }, n2.prototype._renderYearText = function(e2, o, l4, c4) {
      var h = e2.getModel("yearLabel");
      if (!!h.get("show")) {
        var p4 = h.get("margin"), g4 = h.get("position");
        g4 || (g4 = l4 !== "horizontal" ? "top" : "left");
        var y4 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], _ = (y4[0][0] + y4[1][0]) / 2, w4 = (y4[0][1] + y4[1][1]) / 2, C = l4 === "horizontal" ? 0 : 1, E = { top: [_, y4[C][1]], bottom: [_, y4[1 - C][1]], left: [y4[1 - C][0], w4], right: [y4[C][0], w4] }, T = o.start.y;
        +o.end.y > +o.start.y && (T = T + "-" + o.end.y);
        var O = h.get("formatter"), N = { start: o.start.y, end: o.end.y, nameMap: T }, V = this._formatterLabel(O, N), H = new Qs({ z2: 30, style: Ef(h, { text: V }) });
        H.attr(this._yearTextPositionControl(H, E[g4], l4, g4, p4)), c4.add(H);
      }
    }, n2.prototype._monthTextPositionControl = function(e2, o, l4, c4, h) {
      var p4 = "left", g4 = "top", y4 = e2[0], _ = e2[1];
      return l4 === "horizontal" ? (_ = _ + h, o && (p4 = "center"), c4 === "start" && (g4 = "bottom")) : (y4 = y4 + h, o && (g4 = "middle"), c4 === "start" && (p4 = "right")), { x: y4, y: _, align: p4, verticalAlign: g4 };
    }, n2.prototype._renderMonthText = function(e2, o, l4, c4) {
      var h = e2.getModel("monthLabel");
      if (!!h.get("show")) {
        var p4 = h.get("nameMap"), g4 = h.get("margin"), y4 = h.get("position"), _ = h.get("align"), w4 = [this._tlpoints, this._blpoints];
        (!p4 || xa(p4)) && (p4 && (o = roe(p4) || o), p4 = o.get(["time", "monthAbbr"]) || []);
        var C = y4 === "start" ? 0 : 1, E = l4 === "horizontal" ? 0 : 1;
        g4 = y4 === "start" ? -g4 : g4;
        for (var T = _ === "center", O = 0; O < w4[C].length - 1; O++) {
          var N = w4[C][O].slice(), V = this._firstDayOfMonth[O];
          if (T) {
            var H = this._firstDayPoints[O];
            N[E] = (H[E] + w4[0][O + 1][E]) / 2;
          }
          var X = h.get("formatter"), q2 = p4[+V.m - 1], de = { yyyy: V.y, yy: (V.y + "").slice(2), MM: V.m, M: +V.m, nameMap: q2 }, le = this._formatterLabel(X, de), me = new Qs({ z2: 30, style: rr(Ef(h, { text: le }), this._monthTextPositionControl(N, T, l4, y4, g4)) });
          c4.add(me);
        }
      }
    }, n2.prototype._weekTextPositionControl = function(e2, o, l4, c4, h) {
      var p4 = "center", g4 = "middle", y4 = e2[0], _ = e2[1], w4 = l4 === "start";
      return o === "horizontal" ? (y4 = y4 + c4 + (w4 ? 1 : -1) * h[0] / 2, p4 = w4 ? "right" : "left") : (_ = _ + c4 + (w4 ? 1 : -1) * h[1] / 2, g4 = w4 ? "bottom" : "top"), { x: y4, y: _, align: p4, verticalAlign: g4 };
    }, n2.prototype._renderWeekText = function(e2, o, l4, c4, h) {
      var p4 = e2.getModel("dayLabel");
      if (!!p4.get("show")) {
        var g4 = e2.coordinateSystem, y4 = p4.get("position"), _ = p4.get("nameMap"), w4 = p4.get("margin"), C = g4.getFirstDayOfWeek();
        if (!_ || xa(_)) {
          _ && (o = roe(_) || o);
          var E = o.get(["time", "dayOfWeekShort"]);
          _ = E || Er(o.get(["time", "dayOfWeekAbbr"]), function(de) {
            return de[0];
          });
        }
        var T = g4.getNextNDay(l4.end.time, 7 - l4.lweek).time, O = [g4.getCellWidth(), g4.getCellHeight()];
        w4 = ma(w4, Math.min(O[1], O[0])), y4 === "start" && (T = g4.getNextNDay(l4.start.time, -(7 + l4.fweek)).time, w4 = -w4);
        for (var N = 0; N < 7; N++) {
          var V = g4.getNextNDay(T, N), H = g4.dataToRect([V.time], false).center, X = N;
          X = Math.abs((N + C) % 7);
          var q2 = new Qs({ z2: 30, style: rr(Ef(p4, { text: _[X] }), this._weekTextPositionControl(H, c4, y4, w4, O)) });
          h.add(q2);
        }
      }
    }, n2.type = "calendar", n2;
  }($c), Q2t = J2t, qae = 864e5, eSt = function() {
    function i(n2, e2, o) {
      this.type = "calendar", this.dimensions = i.dimensions, this.getDimensionsInfo = i.getDimensionsInfo, this._model = n2;
    }
    return i.getDimensionsInfo = function() {
      return [{ name: "time", type: "time" }, "value"];
    }, i.prototype.getRangeInfo = function() {
      return this._rangeInfo;
    }, i.prototype.getModel = function() {
      return this._model;
    }, i.prototype.getRect = function() {
      return this._rect;
    }, i.prototype.getCellWidth = function() {
      return this._sw;
    }, i.prototype.getCellHeight = function() {
      return this._sh;
    }, i.prototype.getOrient = function() {
      return this._orient;
    }, i.prototype.getFirstDayOfWeek = function() {
      return this._firstDayOfWeek;
    }, i.prototype.getDateInfo = function(n2) {
      n2 = X_(n2);
      var e2 = n2.getFullYear(), o = n2.getMonth() + 1, l4 = o < 10 ? "0" + o : "" + o, c4 = n2.getDate(), h = c4 < 10 ? "0" + c4 : "" + c4, p4 = n2.getDay();
      return p4 = Math.abs((p4 + 7 - this.getFirstDayOfWeek()) % 7), { y: e2 + "", m: l4, d: h, day: p4, time: n2.getTime(), formatedDate: e2 + "-" + l4 + "-" + h, date: n2 };
    }, i.prototype.getNextNDay = function(n2, e2) {
      return e2 = e2 || 0, e2 === 0 ? this.getDateInfo(n2) : (n2 = new Date(this.getDateInfo(n2).time), n2.setDate(n2.getDate() + e2), this.getDateInfo(n2));
    }, i.prototype.update = function(n2, e2) {
      this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
      var o = this._rangeInfo.weeks || 1, l4 = ["width", "height"], c4 = this._model.getCellSize().slice(), h = this._model.getBoxLayoutParams(), p4 = this._orient === "horizontal" ? [o, 7] : [7, o];
      Ve([0, 1], function(w4) {
        _(c4, w4) && (h[l4[w4]] = c4[w4] * p4[w4]);
      });
      var g4 = { width: e2.getWidth(), height: e2.getHeight() }, y4 = this._rect = bh(h, g4);
      Ve([0, 1], function(w4) {
        _(c4, w4) || (c4[w4] = y4[l4[w4]] / p4[w4]);
      });
      function _(w4, C) {
        return w4[C] != null && w4[C] !== "auto";
      }
      this._sw = c4[0], this._sh = c4[1];
    }, i.prototype.dataToPoint = function(n2, e2) {
      Mr(n2) && (n2 = n2[0]), e2 == null && (e2 = true);
      var o = this.getDateInfo(n2), l4 = this._rangeInfo, c4 = o.formatedDate;
      if (e2 && !(o.time >= l4.start.time && o.time < l4.end.time + qae))
        return [NaN, NaN];
      var h = o.day, p4 = this._getRangeInfo([l4.start.time, c4]).nthWeek;
      return this._orient === "vertical" ? [this._rect.x + h * this._sw + this._sw / 2, this._rect.y + p4 * this._sh + this._sh / 2] : [this._rect.x + p4 * this._sw + this._sw / 2, this._rect.y + h * this._sh + this._sh / 2];
    }, i.prototype.pointToData = function(n2) {
      var e2 = this.pointToDate(n2);
      return e2 && e2.time;
    }, i.prototype.dataToRect = function(n2, e2) {
      var o = this.dataToPoint(n2, e2);
      return { contentShape: { x: o[0] - (this._sw - this._lineWidth) / 2, y: o[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: o, tl: [o[0] - this._sw / 2, o[1] - this._sh / 2], tr: [o[0] + this._sw / 2, o[1] - this._sh / 2], br: [o[0] + this._sw / 2, o[1] + this._sh / 2], bl: [o[0] - this._sw / 2, o[1] + this._sh / 2] };
    }, i.prototype.pointToDate = function(n2) {
      var e2 = Math.floor((n2[0] - this._rect.x) / this._sw) + 1, o = Math.floor((n2[1] - this._rect.y) / this._sh) + 1, l4 = this._rangeInfo.range;
      return this._orient === "vertical" ? this._getDateByWeeksAndDay(o, e2 - 1, l4) : this._getDateByWeeksAndDay(e2, o - 1, l4);
    }, i.prototype.convertToPixel = function(n2, e2, o) {
      var l4 = fAe(e2);
      return l4 === this ? l4.dataToPoint(o) : null;
    }, i.prototype.convertFromPixel = function(n2, e2, o) {
      var l4 = fAe(e2);
      return l4 === this ? l4.pointToData(o) : null;
    }, i.prototype.containPoint = function(n2) {
      return console.warn("Not implemented."), false;
    }, i.prototype._initRangeOption = function() {
      var n2 = this._model.get("range"), e2;
      if (Mr(n2) && n2.length === 1 && (n2 = n2[0]), Mr(n2))
        e2 = n2;
      else {
        var o = n2.toString();
        if (/^\d{4}$/.test(o) && (e2 = [o + "-01-01", o + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(o)) {
          var l4 = this.getDateInfo(o), c4 = l4.date;
          c4.setMonth(c4.getMonth() + 1);
          var h = this.getNextNDay(c4, -1);
          e2 = [l4.formatedDate, h.formatedDate];
        }
        /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(o) && (e2 = [o, o]);
      }
      if (!e2)
        return n2;
      var p4 = this._getRangeInfo(e2);
      return p4.start.time > p4.end.time && e2.reverse(), e2;
    }, i.prototype._getRangeInfo = function(n2) {
      var e2 = [this.getDateInfo(n2[0]), this.getDateInfo(n2[1])], o;
      e2[0].time > e2[1].time && (o = true, e2.reverse());
      var l4 = Math.floor(e2[1].time / qae) - Math.floor(e2[0].time / qae) + 1, c4 = new Date(e2[0].time), h = c4.getDate(), p4 = e2[1].date.getDate();
      c4.setDate(h + l4 - 1);
      var g4 = c4.getDate();
      if (g4 !== p4)
        for (var y4 = c4.getTime() - e2[1].time > 0 ? 1 : -1; (g4 = c4.getDate()) !== p4 && (c4.getTime() - e2[1].time) * y4 > 0; )
          l4 -= y4, c4.setDate(g4 - y4);
      var _ = Math.floor((l4 + e2[0].day + 6) / 7), w4 = o ? -_ + 1 : _ - 1;
      return o && e2.reverse(), { range: [e2[0].formatedDate, e2[1].formatedDate], start: e2[0], end: e2[1], allDay: l4, weeks: _, nthWeek: w4, fweek: e2[0].day, lweek: e2[1].day };
    }, i.prototype._getDateByWeeksAndDay = function(n2, e2, o) {
      var l4 = this._getRangeInfo(o);
      if (n2 > l4.weeks || n2 === 0 && e2 < l4.fweek || n2 === l4.weeks && e2 > l4.lweek)
        return null;
      var c4 = (n2 - 1) * 7 - l4.fweek + e2, h = new Date(l4.start.time);
      return h.setDate(+l4.start.d + c4), this.getDateInfo(h);
    }, i.create = function(n2, e2) {
      var o = [];
      return n2.eachComponent("calendar", function(l4) {
        var c4 = new i(l4, n2, e2);
        o.push(c4), l4.coordinateSystem = c4;
      }), n2.eachSeries(function(l4) {
        l4.get("coordinateSystem") === "calendar" && (l4.coordinateSystem = o[l4.get("calendarIndex") || 0]);
      }), o;
    }, i.dimensions = ["time", "value"], i;
  }();
  function fAe(i) {
    var n2 = i.calendarModel, e2 = i.seriesModel, o = n2 ? n2.coordinateSystem : e2 ? e2.coordinateSystem : null;
    return o;
  }
  var tSt = eSt;
  function nSt(i) {
    i.registerComponentModel(K2t), i.registerComponentView(Q2t), i.registerCoordinateSystem("calendar", tSt);
  }
  function rSt(i, n2) {
    var e2 = i.existing;
    if (n2.id = i.keyInfo.id, !n2.type && e2 && (n2.type = e2.type), n2.parentId == null) {
      var o = n2.parentOption;
      o ? n2.parentId = o.id : e2 && (n2.parentId = e2.parentId);
    }
    n2.parentOption = null;
  }
  function hAe(i, n2) {
    var e2;
    return Ve(n2, function(o) {
      i[o] != null && i[o] !== "auto" && (e2 = true);
    }), e2;
  }
  function aSt(i, n2, e2) {
    var o = rr({}, e2), l4 = i[n2], c4 = e2.$action || "merge";
    c4 === "merge" ? l4 ? (to(l4, o, true), QC(l4, o, { ignoreSize: true }), wDe(e2, l4), RW(e2, l4), RW(e2, l4, "shape"), RW(e2, l4, "style"), RW(e2, l4, "extra"), e2.clipPath = l4.clipPath) : i[n2] = o : c4 === "replace" ? i[n2] = o : c4 === "remove" && l4 && (i[n2] = null);
  }
  var N3e = ["transition", "enterFrom", "leaveTo"], iSt = N3e.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
  function RW(i, n2, e2) {
    if (e2 && (!i[e2] && n2[e2] && (i[e2] = {}), i = i[e2], n2 = n2[e2]), !(!i || !n2))
      for (var o = e2 ? N3e : iSt, l4 = 0; l4 < o.length; l4++) {
        var c4 = o[l4];
        i[c4] == null && n2[c4] != null && (i[c4] = n2[c4]);
      }
  }
  function oSt(i, n2) {
    if (!!i && (i.hv = n2.hv = [hAe(n2, ["left", "right"]), hAe(n2, ["top", "bottom"])], i.type === "group")) {
      var e2 = i, o = n2;
      e2.width == null && (e2.width = o.width = 0), e2.height == null && (e2.height = o.height = 0);
    }
  }
  var sSt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.preventAutoZ = true, e2;
    }
    return n2.prototype.mergeOption = function(e2, o) {
      var l4 = this.option.elements;
      this.option.elements = null, i.prototype.mergeOption.call(this, e2, o), this.option.elements = l4;
    }, n2.prototype.optionUpdated = function(e2, o) {
      var l4 = this.option, c4 = (o ? l4 : e2).elements, h = l4.elements = o ? [] : l4.elements, p4 = [];
      this._flatten(c4, p4, null);
      var g4 = rTe(h, p4, "normalMerge"), y4 = this._elOptionsToUpdate = [];
      Ve(g4, function(_, w4) {
        var C = _.newOption;
        !C || (y4.push(C), rSt(_, C), aSt(h, w4, C), oSt(h[w4], C));
      }, this), l4.elements = Yl(h, function(_) {
        return _ && delete _.$action, _ != null;
      });
    }, n2.prototype._flatten = function(e2, o, l4) {
      Ve(e2, function(c4) {
        if (!!c4) {
          l4 && (c4.parentOption = l4), o.push(c4);
          var h = c4.children;
          c4.type === "group" && h && this._flatten(h, o, c4), delete c4.children;
        }
      }, this);
    }, n2.prototype.useElOptionsToUpdate = function() {
      var e2 = this._elOptionsToUpdate;
      return this._elOptionsToUpdate = null, e2;
    }, n2.type = "graphic", n2.defaultOption = { elements: [] }, n2;
  }(Ns), dAe = { path: null, compoundPath: null, group: Ti, image: Ap, text: Qs }, Ey = zs(), lSt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function() {
      this._elMap = ri();
    }, n2.prototype.render = function(e2, o, l4) {
      e2 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = e2, this._updateElements(e2), this._relocate(e2, l4);
    }, n2.prototype._updateElements = function(e2) {
      var o = e2.useElOptionsToUpdate();
      if (!!o) {
        var l4 = this._elMap, c4 = this.group, h = e2.get("z"), p4 = e2.get("zlevel");
        Ve(o, function(g4) {
          var y4 = yh(g4.id, null), _ = y4 != null ? l4.get(y4) : null, w4 = yh(g4.parentId, null), C = w4 != null ? l4.get(w4) : c4, E = g4.type, T = g4.style;
          E === "text" && T && g4.hv && g4.hv[1] && (T.textVerticalAlign = T.textBaseline = T.verticalAlign = T.align = null);
          var O = g4.textContent, N = g4.textConfig;
          if (T && g3e(T, E, !!N, !!O)) {
            var V = m3e(T, E, true);
            !N && V.textConfig && (N = g4.textConfig = V.textConfig), !O && V.textContent && (O = V.textContent);
          }
          var H = uSt(g4), X = g4.$action || "merge", q2 = X === "merge", de = X === "replace";
          if (q2) {
            var le = !_, me = _;
            le ? me = pAe(y4, C, g4.type, l4) : (me && (Ey(me).isNew = false), x3e(me)), me && (cH(me, H, e2, { isInit: le }), vAe(me, g4, h, p4));
          } else if (de) {
            hH(_, g4, l4, e2);
            var ye = pAe(y4, C, g4.type, l4);
            ye && (cH(ye, H, e2, { isInit: true }), vAe(ye, g4, h, p4));
          } else
            X === "remove" && (b3e(_, g4), hH(_, g4, l4, e2));
          var be = l4.get(y4);
          if (be && O)
            if (q2) {
              var we = be.getTextContent();
              we ? we.attr(O) : be.setTextContent(new Qs(O));
            } else
              de && be.setTextContent(new Qs(O));
          if (be) {
            var Pe = g4.clipPath;
            if (Pe) {
              var ze = Pe.type, Re = void 0, le = false;
              if (q2) {
                var rt2 = be.getClipPath();
                le = !rt2 || Ey(rt2).type !== ze, Re = le ? Yoe(ze) : rt2;
              } else
                de && (le = true, Re = Yoe(ze));
              be.setClipPath(Re), cH(Re, Pe, e2, { isInit: le }), e$(Re, Pe.keyframeAnimation, e2);
            }
            var ft = Ey(be);
            be.setTextConfig(N), ft.option = g4, cSt(be, e2, g4), q3({ el: be, componentModel: e2, itemName: be.name, itemTooltipOption: g4.tooltip }), e$(be, g4.keyframeAnimation, e2);
          }
        });
      }
    }, n2.prototype._relocate = function(e2, o) {
      for (var l4 = e2.option.elements, c4 = this.group, h = this._elMap, p4 = o.getWidth(), g4 = o.getHeight(), y4 = ["x", "y"], _ = 0; _ < l4.length; _++) {
        var w4 = l4[_], C = yh(w4.id, null), E = C != null ? h.get(C) : null;
        if (!(!E || !E.isGroup)) {
          var T = E.parent, O = T === c4, N = Ey(E), V = Ey(T);
          N.width = ma(N.option.width, O ? p4 : V.width) || 0, N.height = ma(N.option.height, O ? g4 : V.height) || 0;
        }
      }
      for (var _ = l4.length - 1; _ >= 0; _--) {
        var w4 = l4[_], C = yh(w4.id, null), E = C != null ? h.get(C) : null;
        if (!!E) {
          var T = E.parent, V = Ey(T), H = T === c4 ? { width: p4, height: g4 } : { width: V.width, height: V.height }, X = {}, q2 = N$(E, w4, H, null, { hv: w4.hv, boundingMode: w4.bounding }, X);
          if (!Ey(E).isNew && q2) {
            for (var de = w4.transition, le = {}, me = 0; me < y4.length; me++) {
              var ye = y4[me], be = X[ye];
              de && (gT(de) || go(de, ye) >= 0) ? le[ye] = be : E[ye] = be;
            }
            Vs(E, le, e2, 0);
          } else
            E.attr(X);
        }
      }
    }, n2.prototype._clear = function() {
      var e2 = this, o = this._elMap;
      o.each(function(l4) {
        hH(l4, Ey(l4).option, o, e2._lastGraphicModel);
      }), this._elMap = ri();
    }, n2.prototype.dispose = function() {
      this._clear();
    }, n2.type = "graphic", n2;
  }($c);
  function Yoe(i) {
    var n2 = Na(dAe, i) ? dAe[i] : Qse(i), e2 = new n2({});
    return Ey(e2).type = i, e2;
  }
  function pAe(i, n2, e2, o) {
    var l4 = Yoe(e2);
    return n2.add(l4), o.set(i, l4), Ey(l4).id = i, Ey(l4).isNew = true, l4;
  }
  function hH(i, n2, e2, o) {
    var l4 = i && i.parent;
    l4 && (i.type === "group" && i.traverse(function(c4) {
      hH(c4, n2, e2, o);
    }), Q$(i, n2, o), e2.removeKey(Ey(i).id));
  }
  function vAe(i, n2, e2, o) {
    if (!i.isGroup) {
      var l4 = i;
      l4.cursor = so(n2.cursor, Vy.prototype.cursor), l4.z = so(n2.z, e2 || 0), l4.zlevel = so(n2.zlevel, o || 0);
      var c4 = n2.z2;
      c4 != null && (l4.z2 = c4 || 0);
    }
    Ve(ts(n2), function(h) {
      var p4 = n2[h];
      h.indexOf("on") === 0 && si(p4) && (i[h] = p4);
    }), i.draggable = n2.draggable, n2.name != null && (i.name = n2.name), n2.id != null && (i.id = n2.id);
  }
  function uSt(i) {
    return i = rr({}, i), Ve(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(xDe), function(n2) {
      delete i[n2];
    }), i;
  }
  function cSt(i, n2, e2) {
    var o = Fi(i).eventData;
    !i.silent && !i.ignore && !o && (o = Fi(i).eventData = { componentType: "graphic", componentIndex: n2.componentIndex, name: i.name }), o && (o.info = e2.info);
  }
  function fSt(i) {
    i.registerComponentModel(sSt), i.registerComponentView(lSt), i.registerPreprocessor(function(n2) {
      var e2 = n2.graphic;
      Mr(e2) ? !e2[0] || !e2[0].elements ? n2.graphic = [{ elements: e2 }] : n2.graphic = [n2.graphic[0]] : e2 && !e2.elements && (n2.graphic = [{ elements: [e2] }]);
    });
  }
  var gAe = ["x", "y", "radius", "angle", "single"], hSt = ["cartesian2d", "polar", "singleAxis"];
  function dSt(i) {
    var n2 = i.get("coordinateSystem");
    return go(hSt, n2) >= 0;
  }
  function HC(i) {
    return i + "Axis";
  }
  function pSt(i, n2) {
    var e2 = ri(), o = [], l4 = ri();
    i.eachComponent({ mainType: "dataZoom", query: n2 }, function(_) {
      l4.get(_.uid) || p4(_);
    });
    var c4;
    do
      c4 = false, i.eachComponent("dataZoom", h);
    while (c4);
    function h(_) {
      !l4.get(_.uid) && g4(_) && (p4(_), c4 = true);
    }
    function p4(_) {
      l4.set(_.uid, true), o.push(_), y4(_);
    }
    function g4(_) {
      var w4 = false;
      return _.eachTargetAxis(function(C, E) {
        var T = e2.get(C);
        T && T[E] && (w4 = true);
      }), w4;
    }
    function y4(_) {
      _.eachTargetAxis(function(w4, C) {
        (e2.get(w4) || e2.set(w4, []))[C] = true;
      });
    }
    return o;
  }
  function V3e(i) {
    var n2 = i.ecModel, e2 = { infoList: [], infoMap: ri() };
    return i.eachTargetAxis(function(o, l4) {
      var c4 = n2.getComponent(HC(o), l4);
      if (!!c4) {
        var h = c4.getCoordSysModel();
        if (!!h) {
          var p4 = h.uid, g4 = e2.infoMap.get(p4);
          g4 || (g4 = { model: h, axisModels: [] }, e2.infoList.push(g4), e2.infoMap.set(p4, g4)), g4.axisModels.push(c4);
        }
      }
    }), e2;
  }
  var Yae = function() {
    function i() {
      this.indexList = [], this.indexMap = [];
    }
    return i.prototype.add = function(n2) {
      this.indexMap[n2] || (this.indexList.push(n2), this.indexMap[n2] = true);
    }, i;
  }(), vSt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._autoThrottle = true, e2._noTarget = true, e2._rangePropMode = ["percent", "percent"], e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      var c4 = mAe(e2);
      this.settledOption = c4, this.mergeDefaultAndTheme(e2, l4), this._doInit(c4);
    }, n2.prototype.mergeOption = function(e2) {
      var o = mAe(e2);
      to(this.option, e2, true), to(this.settledOption, o, true), this._doInit(o);
    }, n2.prototype._doInit = function(e2) {
      var o = this.option;
      this._setDefaultThrottle(e2), this._updateRangeUse(e2);
      var l4 = this.settledOption;
      Ve([["start", "startValue"], ["end", "endValue"]], function(c4, h) {
        this._rangePropMode[h] === "value" && (o[c4[0]] = l4[c4[0]] = null);
      }, this), this._resetTarget();
    }, n2.prototype._resetTarget = function() {
      var e2 = this.get("orient", true), o = this._targetAxisInfoMap = ri(), l4 = this._fillSpecifiedTargetAxis(o);
      l4 ? this._orient = e2 || this._makeAutoOrientByTargetAxis() : (this._orient = e2 || "horizontal", this._fillAutoTargetAxisByOrient(o, this._orient)), this._noTarget = true, o.each(function(c4) {
        c4.indexList.length && (this._noTarget = false);
      }, this);
    }, n2.prototype._fillSpecifiedTargetAxis = function(e2) {
      var o = false;
      return Ve(gAe, function(l4) {
        var c4 = this.getReferringComponents(HC(l4), Ist);
        if (!!c4.specified) {
          o = true;
          var h = new Yae();
          Ve(c4.models, function(p4) {
            h.add(p4.componentIndex);
          }), e2.set(l4, h);
        }
      }, this), o;
    }, n2.prototype._fillAutoTargetAxisByOrient = function(e2, o) {
      var l4 = this.ecModel, c4 = true;
      if (c4) {
        var h = o === "vertical" ? "y" : "x", p4 = l4.findComponents({ mainType: h + "Axis" });
        g4(p4, h);
      }
      if (c4) {
        var p4 = l4.findComponents({ mainType: "singleAxis", filter: function(_) {
          return _.get("orient", true) === o;
        } });
        g4(p4, "single");
      }
      function g4(y4, _) {
        var w4 = y4[0];
        if (!!w4) {
          var C = new Yae();
          if (C.add(w4.componentIndex), e2.set(_, C), c4 = false, _ === "x" || _ === "y") {
            var E = w4.getReferringComponents("grid", Yf).models[0];
            E && Ve(y4, function(T) {
              w4.componentIndex !== T.componentIndex && E === T.getReferringComponents("grid", Yf).models[0] && C.add(T.componentIndex);
            });
          }
        }
      }
      c4 && Ve(gAe, function(y4) {
        if (!!c4) {
          var _ = l4.findComponents({ mainType: HC(y4), filter: function(C) {
            return C.get("type", true) === "category";
          } });
          if (_[0]) {
            var w4 = new Yae();
            w4.add(_[0].componentIndex), e2.set(y4, w4), c4 = false;
          }
        }
      }, this);
    }, n2.prototype._makeAutoOrientByTargetAxis = function() {
      var e2;
      return this.eachTargetAxis(function(o) {
        !e2 && (e2 = o);
      }, this), e2 === "y" ? "vertical" : "horizontal";
    }, n2.prototype._setDefaultThrottle = function(e2) {
      if (e2.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
        var o = this.ecModel.option;
        this.option.throttle = o.animation && o.animationDurationUpdate > 0 ? 100 : 20;
      }
    }, n2.prototype._updateRangeUse = function(e2) {
      var o = this._rangePropMode, l4 = this.get("rangeMode");
      Ve([["start", "startValue"], ["end", "endValue"]], function(c4, h) {
        var p4 = e2[c4[0]] != null, g4 = e2[c4[1]] != null;
        p4 && !g4 ? o[h] = "percent" : !p4 && g4 ? o[h] = "value" : l4 ? o[h] = l4[h] : p4 && (o[h] = "percent");
      });
    }, n2.prototype.noTarget = function() {
      return this._noTarget;
    }, n2.prototype.getFirstTargetAxisModel = function() {
      var e2;
      return this.eachTargetAxis(function(o, l4) {
        e2 == null && (e2 = this.ecModel.getComponent(HC(o), l4));
      }, this), e2;
    }, n2.prototype.eachTargetAxis = function(e2, o) {
      this._targetAxisInfoMap.each(function(l4, c4) {
        Ve(l4.indexList, function(h) {
          e2.call(o, c4, h);
        });
      });
    }, n2.prototype.getAxisProxy = function(e2, o) {
      var l4 = this.getAxisModel(e2, o);
      if (l4)
        return l4.__dzAxisProxy;
    }, n2.prototype.getAxisModel = function(e2, o) {
      var l4 = this._targetAxisInfoMap.get(e2);
      if (l4 && l4.indexMap[o])
        return this.ecModel.getComponent(HC(e2), o);
    }, n2.prototype.setRawRange = function(e2) {
      var o = this.option, l4 = this.settledOption;
      Ve([["start", "startValue"], ["end", "endValue"]], function(c4) {
        (e2[c4[0]] != null || e2[c4[1]] != null) && (o[c4[0]] = l4[c4[0]] = e2[c4[0]], o[c4[1]] = l4[c4[1]] = e2[c4[1]]);
      }, this), this._updateRangeUse(e2);
    }, n2.prototype.setCalculatedRange = function(e2) {
      var o = this.option;
      Ve(["start", "startValue", "end", "endValue"], function(l4) {
        o[l4] = e2[l4];
      });
    }, n2.prototype.getPercentRange = function() {
      var e2 = this.findRepresentativeAxisProxy();
      if (e2)
        return e2.getDataPercentWindow();
    }, n2.prototype.getValueRange = function(e2, o) {
      if (e2 == null && o == null) {
        var l4 = this.findRepresentativeAxisProxy();
        if (l4)
          return l4.getDataValueWindow();
      } else
        return this.getAxisProxy(e2, o).getDataValueWindow();
    }, n2.prototype.findRepresentativeAxisProxy = function(e2) {
      if (e2)
        return e2.__dzAxisProxy;
      for (var o, l4 = this._targetAxisInfoMap.keys(), c4 = 0; c4 < l4.length; c4++)
        for (var h = l4[c4], p4 = this._targetAxisInfoMap.get(h), g4 = 0; g4 < p4.indexList.length; g4++) {
          var y4 = this.getAxisProxy(h, p4.indexList[g4]);
          if (y4.hostedBy(this))
            return y4;
          o || (o = y4);
        }
      return o;
    }, n2.prototype.getRangePropMode = function() {
      return this._rangePropMode.slice();
    }, n2.prototype.getOrient = function() {
      return this._orient;
    }, n2.type = "dataZoom", n2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], n2.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, n2;
  }(Ns);
  function mAe(i) {
    var n2 = {};
    return Ve(["start", "end", "startValue", "endValue", "throttle"], function(e2) {
      i.hasOwnProperty(e2) && (n2[e2] = i[e2]);
    }), n2;
  }
  var D8 = vSt, gSt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "dataZoom.select", n2;
  }(D8), mSt = gSt, ySt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      this.dataZoomModel = e2, this.ecModel = o, this.api = l4;
    }, n2.type = "dataZoom", n2;
  }($c), bue = ySt, bSt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "dataZoom.select", n2;
  }(bue), _St = bSt, v32 = Ve, yAe = Ly, xSt = function() {
    function i(n2, e2, o, l4) {
      this._dimName = n2, this._axisIndex = e2, this.ecModel = l4, this._dataZoomModel = o;
    }
    return i.prototype.hostedBy = function(n2) {
      return this._dataZoomModel === n2;
    }, i.prototype.getDataValueWindow = function() {
      return this._valueWindow.slice();
    }, i.prototype.getDataPercentWindow = function() {
      return this._percentWindow.slice();
    }, i.prototype.getTargetSeriesModels = function() {
      var n2 = [];
      return this.ecModel.eachSeries(function(e2) {
        if (dSt(e2)) {
          var o = HC(this._dimName), l4 = e2.getReferringComponents(o, Yf).models[0];
          l4 && this._axisIndex === l4.componentIndex && n2.push(e2);
        }
      }, this), n2;
    }, i.prototype.getAxisModel = function() {
      return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
    }, i.prototype.getMinMaxSpan = function() {
      return Ci(this._minMaxSpan);
    }, i.prototype.calculateDataWindow = function(n2) {
      var e2 = this._dataExtent, o = this.getAxisModel(), l4 = o.axis.scale, c4 = this._dataZoomModel.getRangePropMode(), h = [0, 100], p4 = [], g4 = [], y4;
      v32(["start", "end"], function(C, E) {
        var T = n2[C], O = n2[C + "Value"];
        c4[E] === "percent" ? (T == null && (T = h[E]), O = l4.parse(Tl(T, h, e2))) : (y4 = true, O = O == null ? e2[E] : l4.parse(O), T = Tl(O, e2, h)), g4[E] = O, p4[E] = T;
      }), yAe(g4), yAe(p4);
      var _ = this._minMaxSpan;
      y4 ? w4(g4, p4, e2, h, false) : w4(p4, g4, h, e2, true);
      function w4(C, E, T, O, N) {
        var V = N ? "Span" : "ValueSpan";
        TT(0, C, T, "all", _["min" + V], _["max" + V]);
        for (var H = 0; H < 2; H++)
          E[H] = Tl(C[H], T, O, true), N && (E[H] = l4.parse(E[H]));
      }
      return { valueWindow: g4, percentWindow: p4 };
    }, i.prototype.reset = function(n2) {
      if (n2 === this._dataZoomModel) {
        var e2 = this.getTargetSeriesModels();
        this._dataExtent = wSt(this, this._dimName, e2), this._updateMinMaxSpan();
        var o = this.calculateDataWindow(n2.settledOption);
        this._valueWindow = o.valueWindow, this._percentWindow = o.percentWindow, this._setAxisModel();
      }
    }, i.prototype.filterData = function(n2, e2) {
      if (n2 !== this._dataZoomModel)
        return;
      var o = this._dimName, l4 = this.getTargetSeriesModels(), c4 = n2.get("filterMode"), h = this._valueWindow;
      if (c4 === "none")
        return;
      v32(l4, function(g4) {
        var y4 = g4.getData(), _ = y4.mapDimensionsAll(o);
        if (!!_.length) {
          if (c4 === "weakFilter") {
            var w4 = y4.getStore(), C = Er(_, function(E) {
              return y4.getDimensionIndex(E);
            }, y4);
            y4.filterSelf(function(E) {
              for (var T, O, N, V = 0; V < _.length; V++) {
                var H = w4.get(C[V], E), X = !isNaN(H), q2 = H < h[0], de = H > h[1];
                if (X && !q2 && !de)
                  return true;
                X && (N = true), q2 && (T = true), de && (O = true);
              }
              return N && T && O;
            });
          } else
            v32(_, function(E) {
              if (c4 === "empty")
                g4.setData(y4 = y4.map(E, function(O) {
                  return p4(O) ? O : NaN;
                }));
              else {
                var T = {};
                T[E] = h, y4.selectRange(T);
              }
            });
          v32(_, function(E) {
            y4.setApproximateExtent(h, E);
          });
        }
      });
      function p4(g4) {
        return g4 >= h[0] && g4 <= h[1];
      }
    }, i.prototype._updateMinMaxSpan = function() {
      var n2 = this._minMaxSpan = {}, e2 = this._dataZoomModel, o = this._dataExtent;
      v32(["min", "max"], function(l4) {
        var c4 = e2.get(l4 + "Span"), h = e2.get(l4 + "ValueSpan");
        h != null && (h = this.getAxisModel().axis.scale.parse(h)), h != null ? c4 = Tl(o[0] + h, o, [0, 100], true) : c4 != null && (h = Tl(c4, [0, 100], o, true) - o[0]), n2[l4 + "Span"] = c4, n2[l4 + "ValueSpan"] = h;
      }, this);
    }, i.prototype._setAxisModel = function() {
      var n2 = this.getAxisModel(), e2 = this._percentWindow, o = this._valueWindow;
      if (!!e2) {
        var l4 = ZIe(o, [0, 500]);
        l4 = Math.min(l4, 20);
        var c4 = n2.axis.scale.rawExtentInfo;
        e2[0] !== 0 && c4.setDeterminedMinMax("min", +o[0].toFixed(l4)), e2[1] !== 100 && c4.setDeterminedMinMax("max", +o[1].toFixed(l4)), c4.freeze();
      }
    }, i;
  }();
  function wSt(i, n2, e2) {
    var o = [1 / 0, -1 / 0];
    v32(e2, function(h) {
      Udt(o, h.getData(), n2);
    });
    var l4 = i.getAxisModel(), c4 = nke(l4.axis.scale, l4, o).calculate();
    return [c4.min, c4.max];
  }
  var SSt = xSt, CSt = { getTargetSeries: function(i) {
    function n2(l4) {
      i.eachComponent("dataZoom", function(c4) {
        c4.eachTargetAxis(function(h, p4) {
          var g4 = i.getComponent(HC(h), p4);
          l4(h, p4, g4, c4);
        });
      });
    }
    n2(function(l4, c4, h, p4) {
      h.__dzAxisProxy = null;
    });
    var e2 = [];
    n2(function(l4, c4, h, p4) {
      h.__dzAxisProxy || (h.__dzAxisProxy = new SSt(l4, c4, p4, i), e2.push(h.__dzAxisProxy));
    });
    var o = ri();
    return Ve(e2, function(l4) {
      Ve(l4.getTargetSeriesModels(), function(c4) {
        o.set(c4.uid, c4);
      });
    }), o;
  }, overallReset: function(i, n2) {
    i.eachComponent("dataZoom", function(e2) {
      e2.eachTargetAxis(function(o, l4) {
        e2.getAxisProxy(o, l4).reset(e2);
      }), e2.eachTargetAxis(function(o, l4) {
        e2.getAxisProxy(o, l4).filterData(e2, n2);
      });
    }), i.eachComponent("dataZoom", function(e2) {
      var o = e2.findRepresentativeAxisProxy();
      if (o) {
        var l4 = o.getDataPercentWindow(), c4 = o.getDataValueWindow();
        e2.setCalculatedRange({ start: l4[0], end: l4[1], startValue: c4[0], endValue: c4[1] });
      }
    });
  } }, MSt = CSt;
  function ASt(i) {
    i.registerAction("dataZoom", function(n2, e2) {
      var o = pSt(e2, n2);
      Ve(o, function(l4) {
        l4.setRawRange({ start: n2.start, end: n2.end, startValue: n2.startValue, endValue: n2.endValue });
      });
    });
  }
  var bAe = false;
  function _ue(i) {
    bAe || (bAe = true, i.registerProcessor(i.PRIORITY.PROCESSOR.FILTER, MSt), ASt(i), i.registerSubTypeDefaulter("dataZoom", function() {
      return "slider";
    }));
  }
  function ESt(i) {
    i.registerComponentModel(mSt), i.registerComponentView(_St), _ue(i);
  }
  var Ty = function() {
    function i() {
    }
    return i;
  }(), z3e = {};
  function g3(i, n2) {
    z3e[i] = n2;
  }
  function B3e(i) {
    return z3e[i];
  }
  var ISt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.optionUpdated = function() {
      i.prototype.optionUpdated.apply(this, arguments);
      var e2 = this.ecModel;
      Ve(this.option.feature, function(o, l4) {
        var c4 = B3e(l4);
        c4 && (c4.getDefaultOption && (c4.defaultOption = c4.getDefaultOption(e2)), to(o, c4.defaultOption));
      });
    }, n2.type = "toolbox", n2.layoutMode = { type: "box", ignoreSize: true }, n2.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, n2;
  }(Ns), TSt = ISt;
  function DSt(i, n2, e2) {
    var o = n2.getBoxLayoutParams(), l4 = n2.get("padding"), c4 = { width: e2.getWidth(), height: e2.getHeight() }, h = bh(o, c4, l4);
    dT(n2.get("orient"), i, n2.get("itemGap"), h.width, h.height), N$(i, o, c4, l4);
  }
  function j3e(i, n2) {
    var e2 = X3(n2.get("padding")), o = n2.getItemStyle(["color", "opacity"]);
    return o.fill = n2.get("backgroundColor"), i = new Is({ shape: { x: i.x - e2[3], y: i.y - e2[0], width: i.width + e2[1] + e2[3], height: i.height + e2[0] + e2[2], r: n2.get("borderRadius") }, style: o, silent: true, z2: -1 }), i;
  }
  var kSt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      var h = this.group;
      if (h.removeAll(), !e2.get("show"))
        return;
      var p4 = +e2.get("itemSize"), g4 = e2.get("feature") || {}, y4 = this._features || (this._features = {}), _ = [];
      Ve(g4, function(E, T) {
        _.push(T);
      }), new x2(this._featureNames || [], _).add(w4).update(w4).remove(zi(w4, null)).execute(), this._featureNames = _;
      function w4(E, T) {
        var O = _[E], N = _[T], V = g4[O], H = new Ou(V, e2, e2.ecModel), X;
        if (c4 && c4.newTitle != null && c4.featureName === O && (V.title = c4.newTitle), O && !N) {
          if (PSt(O))
            X = { onclick: H.option.onclick, featureName: O };
          else {
            var q2 = B3e(O);
            if (!q2)
              return;
            X = new q2();
          }
          y4[O] = X;
        } else if (X = y4[N], !X)
          return;
        X.uid = Z3("toolbox-feature"), X.model = H, X.ecModel = o, X.api = l4;
        var de = X instanceof Ty;
        if (!O && N) {
          de && X.dispose && X.dispose(o, l4);
          return;
        }
        if (!H.get("show") || de && X.unusable) {
          de && X.remove && X.remove(o, l4);
          return;
        }
        C(H, X, O), H.setIconStatus = function(le, me) {
          var ye = this.option, be = this.iconPaths;
          ye.iconStatus = ye.iconStatus || {}, ye.iconStatus[le] = me, be[le] && (me === "emphasis" ? W_ : H_)(be[le]);
        }, X instanceof Ty && X.render && X.render(H, o, l4, c4);
      }
      function C(E, T, O) {
        var N = E.getModel("iconStyle"), V = E.getModel(["emphasis", "iconStyle"]), H = T instanceof Ty && T.getIcons ? T.getIcons() : E.get("icon"), X = E.get("title") || {}, q2, de;
        xa(H) ? (q2 = {}, q2[O] = H) : q2 = H, xa(X) ? (de = {}, de[O] = X) : de = X;
        var le = E.iconPaths = {};
        Ve(q2, function(me, ye) {
          var be = G8(me, {}, { x: -p4 / 2, y: -p4 / 2, width: p4, height: p4 });
          be.setStyle(N.getItemStyle());
          var we = be.ensureState("emphasis");
          we.style = V.getItemStyle();
          var Pe = new Qs({ style: { text: de[ye], align: V.get("textAlign"), borderRadius: V.get("textBorderRadius"), padding: V.get("textPadding"), fill: null }, ignore: true });
          be.setTextContent(Pe), q3({ el: be, componentModel: e2, itemName: ye, formatterParamsExtra: { title: de[ye] } }), be.__title = de[ye], be.on("mouseover", function() {
            var ze = V.getItemStyle(), Re = e2.get("orient") === "vertical" ? e2.get("right") == null ? "right" : "left" : e2.get("bottom") == null ? "bottom" : "top";
            Pe.setStyle({ fill: V.get("textFill") || ze.fill || ze.stroke || "#000", backgroundColor: V.get("textBackgroundColor") }), be.setTextConfig({ position: V.get("textPosition") || Re }), Pe.ignore = !e2.get("showTitle"), W_(this);
          }).on("mouseout", function() {
            E.get(["iconStatus", ye]) !== "emphasis" && H_(this), Pe.hide();
          }), (E.get(["iconStatus", ye]) === "emphasis" ? W_ : H_)(be), h.add(be), be.on("click", Ia(T.onclick, T, o, l4, ye)), le[ye] = be;
        });
      }
      DSt(h, e2, l4), h.add(j3e(h.getBoundingRect(), e2)), h.eachChild(function(E) {
        var T = E.__title, O = E.ensureState("emphasis"), N = O.textConfig || (O.textConfig = {}), V = E.getTextContent(), H = V && V.states.emphasis;
        if (H && !si(H) && T) {
          var X = H.style || (H.style = {}), q2 = N8(T, Qs.makeFont(X)), de = E.x + h.x, le = E.y + h.y + p4, me = false;
          le + q2.height > l4.getHeight() && (N.position = "top", me = true);
          var ye = me ? -5 - q2.height : p4 + 8;
          de + q2.width / 2 > l4.getWidth() ? (N.position = ["100%", ye], X.align = "right") : de - q2.width / 2 < 0 && (N.position = [0, ye], X.align = "left");
        }
      });
    }, n2.prototype.updateView = function(e2, o, l4, c4) {
      Ve(this._features, function(h) {
        h instanceof Ty && h.updateView && h.updateView(h.model, o, l4, c4);
      });
    }, n2.prototype.remove = function(e2, o) {
      Ve(this._features, function(l4) {
        l4 instanceof Ty && l4.remove && l4.remove(e2, o);
      }), this.group.removeAll();
    }, n2.prototype.dispose = function(e2, o) {
      Ve(this._features, function(l4) {
        l4 instanceof Ty && l4.dispose && l4.dispose(e2, o);
      });
    }, n2.type = "toolbox", n2;
  }($c);
  function PSt(i) {
    return i.indexOf("my") === 0;
  }
  var LSt = kSt, OSt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.onclick = function(e2, o) {
      var l4 = this.model, c4 = l4.get("name") || e2.get("title.0.text") || "echarts", h = o.getZr().painter.getType() === "svg", p4 = h ? "svg" : l4.get("type", true) || "png", g4 = o.getConnectedDataURL({ type: p4, backgroundColor: l4.get("backgroundColor", true) || e2.get("backgroundColor") || "#fff", connectedBackgroundColor: l4.get("connectedBackgroundColor"), excludeComponents: l4.get("excludeComponents"), pixelRatio: l4.get("pixelRatio") }), y4 = ol.browser;
      if (si(MouseEvent) && (y4.newEdge || !y4.ie && !y4.edge)) {
        var _ = document.createElement("a");
        _.download = c4 + "." + p4, _.target = "_blank", _.href = g4;
        var w4 = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
        _.dispatchEvent(w4);
      } else if (window.navigator.msSaveOrOpenBlob || h) {
        var C = g4.split(","), E = C[0].indexOf("base64") > -1, T = h ? decodeURIComponent(C[1]) : C[1];
        E && (T = window.atob(T));
        var O = c4 + "." + p4;
        if (window.navigator.msSaveOrOpenBlob) {
          for (var N = T.length, V = new Uint8Array(N); N--; )
            V[N] = T.charCodeAt(N);
          var H = new Blob([V]);
          window.navigator.msSaveOrOpenBlob(H, O);
        } else {
          var X = document.createElement("iframe");
          document.body.appendChild(X);
          var q2 = X.contentWindow, de = q2.document;
          de.open("image/svg+xml", "replace"), de.write(T), de.close(), q2.focus(), de.execCommand("SaveAs", true, O), document.body.removeChild(X);
        }
      } else {
        var le = l4.get("lang"), me = '<body style="margin:0;"><img src="' + g4 + '" style="max-width:100%;" title="' + (le && le[0] || "") + '" /></body>', ye = window.open();
        ye.document.write(me), ye.document.title = c4;
      }
    }, n2.getDefaultOption = function(e2) {
      var o = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: e2.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: e2.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
      return o;
    }, n2;
  }(Ty), RSt = OSt, _Ae = "__ec_magicType_stack__", FSt = [["line", "bar"], ["stack"]], NSt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.getIcons = function() {
      var e2 = this.model, o = e2.get("icon"), l4 = {};
      return Ve(e2.get("type"), function(c4) {
        o[c4] && (l4[c4] = o[c4]);
      }), l4;
    }, n2.getDefaultOption = function(e2) {
      var o = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: e2.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
      return o;
    }, n2.prototype.onclick = function(e2, o, l4) {
      var c4 = this.model, h = c4.get(["seriesIndex", l4]);
      if (!!xAe[l4]) {
        var p4 = { series: [] }, g4 = function(w4) {
          var C = w4.subType, E = w4.id, T = xAe[l4](C, E, w4, c4);
          T && (hi(T, w4.option), p4.series.push(T));
          var O = w4.coordinateSystem;
          if (O && O.type === "cartesian2d" && (l4 === "line" || l4 === "bar")) {
            var N = O.getAxesByScale("ordinal")[0];
            if (N) {
              var V = N.dim, H = V + "Axis", X = w4.getReferringComponents(H, Yf).models[0], q2 = X.componentIndex;
              p4[H] = p4[H] || [];
              for (var de = 0; de <= q2; de++)
                p4[H][q2] = p4[H][q2] || {};
              p4[H][q2].boundaryGap = l4 === "bar";
            }
          }
        };
        Ve(FSt, function(w4) {
          go(w4, l4) >= 0 && Ve(w4, function(C) {
            c4.setIconStatus(C, "normal");
          });
        }), c4.setIconStatus(l4, "emphasis"), e2.eachComponent({ mainType: "series", query: h == null ? null : { seriesIndex: h } }, g4);
        var y4, _ = l4;
        l4 === "stack" && (y4 = to({ stack: c4.option.title.tiled, tiled: c4.option.title.stack }, c4.option.title), c4.get(["iconStatus", l4]) !== "emphasis" && (_ = "tiled")), o.dispatchAction({ type: "changeMagicType", currentType: _, newOption: p4, newTitle: y4, featureName: "magicType" });
      }
    }, n2;
  }(Ty), xAe = { line: function(i, n2, e2, o) {
    if (i === "bar")
      return to({ id: n2, type: "line", data: e2.get("data"), stack: e2.get("stack"), markPoint: e2.get("markPoint"), markLine: e2.get("markLine") }, o.get(["option", "line"]) || {}, true);
  }, bar: function(i, n2, e2, o) {
    if (i === "line")
      return to({ id: n2, type: "bar", data: e2.get("data"), stack: e2.get("stack"), markPoint: e2.get("markPoint"), markLine: e2.get("markLine") }, o.get(["option", "bar"]) || {}, true);
  }, stack: function(i, n2, e2, o) {
    var l4 = e2.get("stack") === _Ae;
    if (i === "line" || i === "bar")
      return o.setIconStatus("stack", l4 ? "normal" : "emphasis"), to({ id: n2, stack: l4 ? "" : _Ae }, o.get(["option", "stack"]) || {}, true);
  } };
  ex({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(i, n2) {
    n2.mergeOption(i.newOption);
  });
  var VSt = NSt, eU = new Array(60).join("-"), j3 = "	";
  function zSt(i) {
    var n2 = {}, e2 = [], o = [];
    return i.eachRawSeries(function(l4) {
      var c4 = l4.coordinateSystem;
      if (c4 && (c4.type === "cartesian2d" || c4.type === "polar")) {
        var h = c4.getBaseAxis();
        if (h.type === "category") {
          var p4 = h.dim + "_" + h.index;
          n2[p4] || (n2[p4] = { categoryAxis: h, valueAxis: c4.getOtherAxis(h), series: [] }, o.push({ axisDim: h.dim, axisIndex: h.index })), n2[p4].series.push(l4);
        } else
          e2.push(l4);
      } else
        e2.push(l4);
    }), { seriesGroupByCategoryAxis: n2, other: e2, meta: o };
  }
  function BSt(i) {
    var n2 = [];
    return Ve(i, function(e2, o) {
      var l4 = e2.categoryAxis, c4 = e2.valueAxis, h = c4.dim, p4 = [" "].concat(Er(e2.series, function(E) {
        return E.name;
      })), g4 = [l4.model.getCategories()];
      Ve(e2.series, function(E) {
        var T = E.getRawData();
        g4.push(E.getRawData().mapArray(T.mapDimension(h), function(O) {
          return O;
        }));
      });
      for (var y4 = [p4.join(j3)], _ = 0; _ < g4[0].length; _++) {
        for (var w4 = [], C = 0; C < g4.length; C++)
          w4.push(g4[C][_]);
        y4.push(w4.join(j3));
      }
      n2.push(y4.join(`
`));
    }), n2.join(`

` + eU + `

`);
  }
  function jSt(i) {
    return Er(i, function(n2) {
      var e2 = n2.getRawData(), o = [n2.name], l4 = [];
      return e2.each(e2.dimensions, function() {
        for (var c4 = arguments.length, h = arguments[c4 - 1], p4 = e2.getName(h), g4 = 0; g4 < c4 - 1; g4++)
          l4[g4] = arguments[g4];
        o.push((p4 ? p4 + j3 : "") + l4.join(j3));
      }), o.join(`
`);
    }).join(`

` + eU + `

`);
  }
  function GSt(i) {
    var n2 = zSt(i);
    return { value: Yl([BSt(n2.seriesGroupByCategoryAxis), jSt(n2.other)], function(e2) {
      return !!e2.replace(/[\n\t\s]/g, "");
    }).join(`

` + eU + `

`), meta: n2.meta };
  }
  function r$(i) {
    return i.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
  }
  function WSt(i) {
    var n2 = i.slice(0, i.indexOf(`
`));
    if (n2.indexOf(j3) >= 0)
      return true;
  }
  var Zoe = new RegExp("[" + j3 + "]+", "g");
  function HSt(i) {
    for (var n2 = i.split(/\n+/g), e2 = r$(n2.shift()).split(Zoe), o = [], l4 = Er(e2, function(g4) {
      return { name: g4, data: [] };
    }), c4 = 0; c4 < n2.length; c4++) {
      var h = r$(n2[c4]).split(Zoe);
      o.push(h.shift());
      for (var p4 = 0; p4 < h.length; p4++)
        l4[p4] && (l4[p4].data[c4] = h[p4]);
    }
    return { series: l4, categories: o };
  }
  function $St(i) {
    for (var n2 = i.split(/\n+/g), e2 = r$(n2.shift()), o = [], l4 = 0; l4 < n2.length; l4++) {
      var c4 = r$(n2[l4]);
      if (!!c4) {
        var h = c4.split(Zoe), p4 = "", g4 = void 0, y4 = false;
        isNaN(h[0]) ? (y4 = true, p4 = h[0], h = h.slice(1), o[l4] = { name: p4, value: [] }, g4 = o[l4].value) : g4 = o[l4] = [];
        for (var _ = 0; _ < h.length; _++)
          g4.push(+h[_]);
        g4.length === 1 && (y4 ? o[l4].value = g4[0] : o[l4] = g4[0]);
      }
    }
    return { name: e2, data: o };
  }
  function USt(i, n2) {
    var e2 = i.split(new RegExp(`
*` + eU + `
*`, "g")), o = { series: [] };
    return Ve(e2, function(l4, c4) {
      if (WSt(l4)) {
        var h = HSt(l4), p4 = n2[c4], g4 = p4.axisDim + "Axis";
        p4 && (o[g4] = o[g4] || [], o[g4][p4.axisIndex] = { data: h.categories }, o.series = o.series.concat(h.series));
      } else {
        var h = $St(l4);
        o.series.push(h);
      }
    }), o;
  }
  var qSt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.onclick = function(e2, o) {
      setTimeout(function() {
        o.dispatchAction({ type: "hideTip" });
      });
      var l4 = o.getDom(), c4 = this.model;
      this._dom && l4.removeChild(this._dom);
      var h = document.createElement("div");
      h.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", h.style.backgroundColor = c4.get("backgroundColor") || "#fff";
      var p4 = document.createElement("h4"), g4 = c4.get("lang") || [];
      p4.innerHTML = g4[0] || c4.get("title"), p4.style.cssText = "margin:10px 20px", p4.style.color = c4.get("textColor");
      var y4 = document.createElement("div"), _ = document.createElement("textarea");
      y4.style.cssText = "overflow:auto";
      var w4 = c4.get("optionToContent"), C = c4.get("contentToOption"), E = GSt(e2);
      if (si(w4)) {
        var T = w4(o.getOption());
        xa(T) ? y4.innerHTML = T : a8(T) && y4.appendChild(T);
      } else {
        _.readOnly = c4.get("readOnly");
        var O = _.style;
        O.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", O.color = c4.get("textColor"), O.borderColor = c4.get("textareaBorderColor"), O.backgroundColor = c4.get("textareaColor"), _.value = E.value, y4.appendChild(_);
      }
      var N = E.meta, V = document.createElement("div");
      V.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
      var H = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", X = document.createElement("div"), q2 = document.createElement("div");
      H += ";background-color:" + c4.get("buttonColor"), H += ";color:" + c4.get("buttonTextColor");
      var de = this;
      function le() {
        l4.removeChild(h), de._dom = null;
      }
      Die(X, "click", le), Die(q2, "click", function() {
        if (C == null && w4 != null || C != null && w4 == null) {
          le();
          return;
        }
        var me;
        try {
          si(C) ? me = C(y4, o.getOption()) : me = USt(_.value, N);
        } catch (ye) {
          throw le(), new Error("Data view format error " + ye);
        }
        me && o.dispatchAction({ type: "changeDataView", newOption: me }), le();
      }), X.innerHTML = g4[1], q2.innerHTML = g4[2], q2.style.cssText = X.style.cssText = H, !c4.get("readOnly") && V.appendChild(q2), V.appendChild(X), h.appendChild(p4), h.appendChild(y4), h.appendChild(V), y4.style.height = l4.clientHeight - 80 + "px", l4.appendChild(h), this._dom = h;
    }, n2.prototype.remove = function(e2, o) {
      this._dom && o.getDom().removeChild(this._dom);
    }, n2.prototype.dispose = function(e2, o) {
      this.remove(e2, o);
    }, n2.getDefaultOption = function(e2) {
      var o = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: e2.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: e2.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
      return o;
    }, n2;
  }(Ty);
  function YSt(i, n2) {
    return Er(i, function(e2, o) {
      var l4 = n2 && n2[o];
      if (mi(l4) && !Mr(l4)) {
        var c4 = mi(e2) && !Mr(e2);
        c4 || (e2 = { value: e2 });
        var h = l4.name != null && e2.name == null;
        return e2 = hi(e2, l4), h && delete e2.name, e2;
      } else
        return e2;
    });
  }
  ex({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(i, n2) {
    var e2 = [];
    Ve(i.newOption.series, function(o) {
      var l4 = n2.getSeriesByName(o.name)[0];
      if (!l4)
        e2.push(rr({ type: "scatter" }, o));
      else {
        var c4 = l4.get("data");
        e2.push({ name: o.name, data: YSt(o.data, c4) });
      }
    }), n2.mergeOption(hi({ series: e2 }, i.newOption));
  });
  var ZSt = qSt, G3e = Ve, W3e = zs();
  function XSt(i, n2) {
    var e2 = xue(i);
    G3e(n2, function(o, l4) {
      for (var c4 = e2.length - 1; c4 >= 0; c4--) {
        var h = e2[c4];
        if (h[l4])
          break;
      }
      if (c4 < 0) {
        var p4 = i.queryComponents({ mainType: "dataZoom", subType: "select", id: l4 })[0];
        if (p4) {
          var g4 = p4.getPercentRange();
          e2[0][l4] = { dataZoomId: l4, start: g4[0], end: g4[1] };
        }
      }
    }), e2.push(n2);
  }
  function KSt(i) {
    var n2 = xue(i), e2 = n2[n2.length - 1];
    n2.length > 1 && n2.pop();
    var o = {};
    return G3e(e2, function(l4, c4) {
      for (var h = n2.length - 1; h >= 0; h--)
        if (l4 = n2[h][c4], l4) {
          o[c4] = l4;
          break;
        }
    }), o;
  }
  function JSt(i) {
    W3e(i).snapshots = null;
  }
  function QSt(i) {
    return xue(i).length;
  }
  function xue(i) {
    var n2 = W3e(i);
    return n2.snapshots || (n2.snapshots = [{}]), n2.snapshots;
  }
  var eCt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.onclick = function(e2, o) {
      JSt(e2), o.dispatchAction({ type: "restore", from: this.uid });
    }, n2.getDefaultOption = function(e2) {
      var o = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: e2.getLocaleModel().get(["toolbox", "restore", "title"]) };
      return o;
    }, n2;
  }(Ty);
  ex({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(i, n2) {
    n2.resetOption("recreate");
  });
  var tCt = eCt, nCt = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], rCt = function() {
    function i(n2, e2, o) {
      var l4 = this;
      this._targetInfoList = [];
      var c4 = wAe(e2, n2);
      Ve(aCt, function(h, p4) {
        (!o || !o.include || go(o.include, p4) >= 0) && h(c4, l4._targetInfoList);
      });
    }
    return i.prototype.setOutputRanges = function(n2, e2) {
      return this.matchOutputRanges(n2, e2, function(o, l4, c4) {
        if ((o.coordRanges || (o.coordRanges = [])).push(l4), !o.coordRange) {
          o.coordRange = l4;
          var h = Zae[o.brushType](0, c4, l4);
          o.__rangeOffset = { offset: AAe[o.brushType](h.values, o.range, [1, 1]), xyMinMax: h.xyMinMax };
        }
      }), n2;
    }, i.prototype.matchOutputRanges = function(n2, e2, o) {
      Ve(n2, function(l4) {
        var c4 = this.findTargetInfo(l4, e2);
        c4 && c4 !== true && Ve(c4.coordSyses, function(h) {
          var p4 = Zae[l4.brushType](1, h, l4.range, true);
          o(l4, p4.values, h, e2);
        });
      }, this);
    }, i.prototype.setInputRanges = function(n2, e2) {
      Ve(n2, function(o) {
        var l4 = this.findTargetInfo(o, e2);
        if (o.range = o.range || [], l4 && l4 !== true) {
          o.panelId = l4.panelId;
          var c4 = Zae[o.brushType](0, l4.coordSys, o.coordRange), h = o.__rangeOffset;
          o.range = h ? AAe[o.brushType](c4.values, h.offset, iCt(c4.xyMinMax, h.xyMinMax)) : c4.values;
        }
      }, this);
    }, i.prototype.makePanelOpts = function(n2, e2) {
      return Er(this._targetInfoList, function(o) {
        var l4 = o.getPanelRect();
        return { panelId: o.panelId, defaultBrushType: e2 ? e2(o) : null, clipPath: XPe(l4), isTargetByCursor: JPe(l4, n2, o.coordSysModel), getLinearBrushOtherExtent: KPe(l4) };
      });
    }, i.prototype.controlSeries = function(n2, e2, o) {
      var l4 = this.findTargetInfo(n2, o);
      return l4 === true || l4 && go(l4.coordSyses, e2.coordinateSystem) >= 0;
    }, i.prototype.findTargetInfo = function(n2, e2) {
      for (var o = this._targetInfoList, l4 = wAe(e2, n2), c4 = 0; c4 < o.length; c4++) {
        var h = o[c4], p4 = n2.panelId;
        if (p4) {
          if (h.panelId === p4)
            return h;
        } else
          for (var g4 = 0; g4 < SAe.length; g4++)
            if (SAe[g4](l4, h))
              return h;
      }
      return true;
    }, i;
  }();
  function Xoe(i) {
    return i[0] > i[1] && i.reverse(), i;
  }
  function wAe(i, n2) {
    return WN(i, n2, { includeMainTypes: nCt });
  }
  var aCt = { grid: function(i, n2) {
    var e2 = i.xAxisModels, o = i.yAxisModels, l4 = i.gridModels, c4 = ri(), h = {}, p4 = {};
    !e2 && !o && !l4 || (Ve(e2, function(g4) {
      var y4 = g4.axis.grid.model;
      c4.set(y4.id, y4), h[y4.id] = true;
    }), Ve(o, function(g4) {
      var y4 = g4.axis.grid.model;
      c4.set(y4.id, y4), p4[y4.id] = true;
    }), Ve(l4, function(g4) {
      c4.set(g4.id, g4), h[g4.id] = true, p4[g4.id] = true;
    }), c4.each(function(g4) {
      var y4 = g4.coordinateSystem, _ = [];
      Ve(y4.getCartesians(), function(w4, C) {
        (go(e2, w4.getAxis("x").model) >= 0 || go(o, w4.getAxis("y").model) >= 0) && _.push(w4);
      }), n2.push({ panelId: "grid--" + g4.id, gridModel: g4, coordSysModel: g4, coordSys: _[0], coordSyses: _, getPanelRect: CAe.grid, xAxisDeclared: h[g4.id], yAxisDeclared: p4[g4.id] });
    }));
  }, geo: function(i, n2) {
    Ve(i.geoModels, function(e2) {
      var o = e2.coordinateSystem;
      n2.push({ panelId: "geo--" + e2.id, geoModel: e2, coordSysModel: e2, coordSys: o, coordSyses: [o], getPanelRect: CAe.geo });
    });
  } }, SAe = [function(i, n2) {
    var e2 = i.xAxisModel, o = i.yAxisModel, l4 = i.gridModel;
    return !l4 && e2 && (l4 = e2.axis.grid.model), !l4 && o && (l4 = o.axis.grid.model), l4 && l4 === n2.gridModel;
  }, function(i, n2) {
    var e2 = i.geoModel;
    return e2 && e2 === n2.geoModel;
  }], CAe = { grid: function() {
    return this.coordSys.master.getRect().clone();
  }, geo: function() {
    var i = this.coordSys, n2 = i.getBoundingRect().clone();
    return n2.applyTransform(hT(i)), n2;
  } }, Zae = { lineX: zi(MAe, 0), lineY: zi(MAe, 1), rect: function(i, n2, e2, o) {
    var l4 = i ? n2.pointToData([e2[0][0], e2[1][0]], o) : n2.dataToPoint([e2[0][0], e2[1][0]], o), c4 = i ? n2.pointToData([e2[0][1], e2[1][1]], o) : n2.dataToPoint([e2[0][1], e2[1][1]], o), h = [Xoe([l4[0], c4[0]]), Xoe([l4[1], c4[1]])];
    return { values: h, xyMinMax: h };
  }, polygon: function(i, n2, e2, o) {
    var l4 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], c4 = Er(e2, function(h) {
      var p4 = i ? n2.pointToData(h, o) : n2.dataToPoint(h, o);
      return l4[0][0] = Math.min(l4[0][0], p4[0]), l4[1][0] = Math.min(l4[1][0], p4[1]), l4[0][1] = Math.max(l4[0][1], p4[0]), l4[1][1] = Math.max(l4[1][1], p4[1]), p4;
    });
    return { values: c4, xyMinMax: l4 };
  } };
  function MAe(i, n2, e2, o) {
    var l4 = e2.getAxis(["x", "y"][i]), c4 = Xoe(Er([0, 1], function(p4) {
      return n2 ? l4.coordToData(l4.toLocalCoord(o[p4]), true) : l4.toGlobalCoord(l4.dataToCoord(o[p4]));
    })), h = [];
    return h[i] = c4, h[1 - i] = [NaN, NaN], { values: c4, xyMinMax: h };
  }
  var AAe = { lineX: zi(EAe, 0), lineY: zi(EAe, 1), rect: function(i, n2, e2) {
    return [[i[0][0] - e2[0] * n2[0][0], i[0][1] - e2[0] * n2[0][1]], [i[1][0] - e2[1] * n2[1][0], i[1][1] - e2[1] * n2[1][1]]];
  }, polygon: function(i, n2, e2) {
    return Er(i, function(o, l4) {
      return [o[0] - e2[0] * n2[l4][0], o[1] - e2[1] * n2[l4][1]];
    });
  } };
  function EAe(i, n2, e2, o) {
    return [n2[0] - o[i] * e2[0], n2[1] - o[i] * e2[1]];
  }
  function iCt(i, n2) {
    var e2 = IAe(i), o = IAe(n2), l4 = [e2[0] / o[0], e2[1] / o[1]];
    return isNaN(l4[0]) && (l4[0] = 1), isNaN(l4[1]) && (l4[1] = 1), l4;
  }
  function IAe(i) {
    return i ? [i[0][1] - i[0][0], i[1][1] - i[1][0]] : [NaN, NaN];
  }
  var wue = rCt, Koe = Ve, oCt = Sst("toolbox-dataZoom_"), sCt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.render = function(e2, o, l4, c4) {
      this._brushController || (this._brushController = new nue(l4.getZr()), this._brushController.on("brush", Ia(this._onBrush, this)).mount()), cCt(e2, o, this, c4, l4), uCt(e2, o);
    }, n2.prototype.onclick = function(e2, o, l4) {
      lCt[l4].call(this);
    }, n2.prototype.remove = function(e2, o) {
      this._brushController && this._brushController.unmount();
    }, n2.prototype.dispose = function(e2, o) {
      this._brushController && this._brushController.dispose();
    }, n2.prototype._onBrush = function(e2) {
      var o = e2.areas;
      if (!e2.isEnd || !o.length)
        return;
      var l4 = {}, c4 = this.ecModel;
      this._brushController.updateCovers([]);
      var h = new wue(Sue(this.model), c4, { include: ["grid"] });
      h.matchOutputRanges(o, c4, function(y4, _, w4) {
        if (w4.type === "cartesian2d") {
          var C = y4.brushType;
          C === "rect" ? (p4("x", w4, _[0]), p4("y", w4, _[1])) : p4({ lineX: "x", lineY: "y" }[C], w4, _);
        }
      }), XSt(c4, l4), this._dispatchZoomAction(l4);
      function p4(y4, _, w4) {
        var C = _.getAxis(y4), E = C.model, T = g4(y4, E, c4), O = T.findRepresentativeAxisProxy(E).getMinMaxSpan();
        (O.minValueSpan != null || O.maxValueSpan != null) && (w4 = TT(0, w4.slice(), C.scale.getExtent(), 0, O.minValueSpan, O.maxValueSpan)), T && (l4[T.id] = { dataZoomId: T.id, startValue: w4[0], endValue: w4[1] });
      }
      function g4(y4, _, w4) {
        var C;
        return w4.eachComponent({ mainType: "dataZoom", subType: "select" }, function(E) {
          var T = E.getAxisModel(y4, _.componentIndex);
          T && (C = E);
        }), C;
      }
    }, n2.prototype._dispatchZoomAction = function(e2) {
      var o = [];
      Koe(e2, function(l4, c4) {
        o.push(Ci(l4));
      }), o.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: o });
    }, n2.getDefaultOption = function(e2) {
      var o = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: e2.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
      return o;
    }, n2;
  }(Ty), lCt = { zoom: function() {
    var i = !this._isZoomActive;
    this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: i });
  }, back: function() {
    this._dispatchZoomAction(KSt(this.ecModel));
  } };
  function Sue(i) {
    var n2 = { xAxisIndex: i.get("xAxisIndex", true), yAxisIndex: i.get("yAxisIndex", true), xAxisId: i.get("xAxisId", true), yAxisId: i.get("yAxisId", true) };
    return n2.xAxisIndex == null && n2.xAxisId == null && (n2.xAxisIndex = "all"), n2.yAxisIndex == null && n2.yAxisId == null && (n2.yAxisIndex = "all"), n2;
  }
  function uCt(i, n2) {
    i.setIconStatus("back", QSt(n2) > 1 ? "emphasis" : "normal");
  }
  function cCt(i, n2, e2, o, l4) {
    var c4 = e2._isZoomActive;
    o && o.type === "takeGlobalCursor" && (c4 = o.key === "dataZoomSelect" ? o.dataZoomSelectActive : false), e2._isZoomActive = c4, i.setIconStatus("zoom", c4 ? "emphasis" : "normal");
    var h = new wue(Sue(i), n2, { include: ["grid"] }), p4 = h.makePanelOpts(l4, function(g4) {
      return g4.xAxisDeclared && !g4.yAxisDeclared ? "lineX" : !g4.xAxisDeclared && g4.yAxisDeclared ? "lineY" : "rect";
    });
    e2._brushController.setPanels(p4).enableBrush(c4 && p4.length ? { brushType: "auto", brushStyle: i.getModel("brushStyle").getItemStyle() } : false);
  }
  lct("dataZoom", function(i) {
    var n2 = i.getComponent("toolbox", 0), e2 = ["feature", "dataZoom"];
    if (!n2 || n2.get(e2) == null)
      return;
    var o = n2.getModel(e2), l4 = [], c4 = Sue(o), h = WN(i, c4);
    Koe(h.xAxisModels, function(g4) {
      return p4(g4, "xAxis", "xAxisIndex");
    }), Koe(h.yAxisModels, function(g4) {
      return p4(g4, "yAxis", "yAxisIndex");
    });
    function p4(g4, y4, _) {
      var w4 = g4.componentIndex, C = { type: "select", $fromToolbox: true, filterMode: o.get("filterMode", true) || "filter", id: oCt + y4 + w4 };
      C[_] = w4, l4.push(C);
    }
    return l4;
  });
  var fCt = sCt;
  function hCt(i) {
    i.registerComponentModel(TSt), i.registerComponentView(LSt), g3("saveAsImage", RSt), g3("magicType", VSt), g3("dataView", ZSt), g3("dataZoom", fCt), g3("restore", tCt), wo(ESt);
  }
  var dCt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "tooltip", n2.dependencies = ["axisPointer"], n2.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, n2;
  }(Ns), pCt = dCt;
  function H3e(i) {
    var n2 = i.get("confine");
    return n2 != null ? !!n2 : i.get("renderMode") === "richText";
  }
  function $3e(i) {
    if (!!ol.domSupported) {
      for (var n2 = document.documentElement.style, e2 = 0, o = i.length; e2 < o; e2++)
        if (i[e2] in n2)
          return i[e2];
    }
  }
  var U3e = $3e(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), vCt = $3e(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
  function q3e(i, n2) {
    if (!i)
      return n2;
    n2 = bDe(n2, true);
    var e2 = i.indexOf(n2);
    return i = e2 === -1 ? n2 : "-" + i.slice(0, e2) + "-" + n2, i.toLowerCase();
  }
  function gCt(i, n2) {
    var e2 = i.currentStyle || document.defaultView && document.defaultView.getComputedStyle(i);
    return e2 ? n2 ? e2[n2] : e2 : null;
  }
  var mCt = q3e(vCt, "transition"), Cue = q3e(U3e, "transform"), yCt = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (ol.transform3dSupported ? "will-change:transform;" : "");
  function bCt(i) {
    return i = i === "left" ? "right" : i === "right" ? "left" : i === "top" ? "bottom" : "top", i;
  }
  function _Ct(i, n2, e2) {
    if (!xa(e2) || e2 === "inside")
      return "";
    var o = i.get("backgroundColor"), l4 = i.get("borderWidth");
    n2 = xT(n2);
    var c4 = bCt(e2), h = Math.max(Math.round(l4) * 1.5, 6), p4 = "", g4 = Cue + ":", y4;
    go(["left", "right"], c4) > -1 ? (p4 += "top:50%", g4 += "translateY(-50%) rotate(" + (y4 = c4 === "left" ? -225 : -45) + "deg)") : (p4 += "left:50%", g4 += "translateX(-50%) rotate(" + (y4 = c4 === "top" ? 225 : 45) + "deg)");
    var _ = y4 * Math.PI / 180, w4 = h + l4, C = w4 * Math.abs(Math.cos(_)) + w4 * Math.abs(Math.sin(_)), E = Math.round(((C - Math.SQRT2 * l4) / 2 + Math.SQRT2 * l4 - (C - w4) / 2) * 100) / 100;
    p4 += ";" + c4 + ":-" + E + "px";
    var T = n2 + " solid " + l4 + "px;", O = ["position:absolute;width:" + h + "px;height:" + h + "px;", p4 + ";" + g4 + ";", "border-bottom:" + T, "border-right:" + T, "background-color:" + o + ";"];
    return '<div style="' + O.join("") + '"></div>';
  }
  function xCt(i, n2) {
    var e2 = "cubic-bezier(0.23,1,0.32,1)", o = " " + i / 2 + "s " + e2, l4 = "opacity" + o + ",visibility" + o;
    return n2 || (o = " " + i + "s " + e2, l4 += ol.transformSupported ? "," + Cue + o : ",left" + o + ",top" + o), mCt + ":" + l4;
  }
  function TAe(i, n2, e2) {
    var o = i.toFixed(0) + "px", l4 = n2.toFixed(0) + "px";
    if (!ol.transformSupported)
      return e2 ? "top:" + l4 + ";left:" + o + ";" : [["top", l4], ["left", o]];
    var c4 = ol.transform3dSupported, h = "translate" + (c4 ? "3d" : "") + "(" + o + "," + l4 + (c4 ? ",0" : "") + ")";
    return e2 ? "top:0;left:0;" + Cue + ":" + h + ";" : [["top", 0], ["left", 0], [U3e, h]];
  }
  function wCt(i) {
    var n2 = [], e2 = i.get("fontSize"), o = i.getTextColor();
    o && n2.push("color:" + o), n2.push("font:" + i.getFont()), e2 && n2.push("line-height:" + Math.round(e2 * 3 / 2) + "px");
    var l4 = i.get("textShadowColor"), c4 = i.get("textShadowBlur") || 0, h = i.get("textShadowOffsetX") || 0, p4 = i.get("textShadowOffsetY") || 0;
    return l4 && c4 && n2.push("text-shadow:" + h + "px " + p4 + "px " + c4 + "px " + l4), Ve(["decoration", "align"], function(g4) {
      var y4 = i.get(g4);
      y4 && n2.push("text-" + g4 + ":" + y4);
    }), n2.join(";");
  }
  function SCt(i, n2, e2) {
    var o = [], l4 = i.get("transitionDuration"), c4 = i.get("backgroundColor"), h = i.get("shadowBlur"), p4 = i.get("shadowColor"), g4 = i.get("shadowOffsetX"), y4 = i.get("shadowOffsetY"), _ = i.getModel("textStyle"), w4 = t5e(i, "html"), C = g4 + "px " + y4 + "px " + h + "px " + p4;
    return o.push("box-shadow:" + C), n2 && l4 && o.push(xCt(l4, e2)), c4 && o.push("background-color:" + c4), Ve(["width", "color", "radius"], function(E) {
      var T = "border-" + E, O = bDe(T), N = i.get(O);
      N != null && o.push(T + ":" + N + (E === "color" ? "" : "px"));
    }), o.push(wCt(_)), w4 != null && o.push("padding:" + X3(w4).join("px ") + "px"), o.join(";") + ";";
  }
  function DAe(i, n2, e2, o, l4) {
    var c4 = n2 && n2.painter;
    if (e2) {
      var h = c4 && c4.getViewportRoot();
      h && Yit(i, h, document.body, o, l4);
    } else {
      i[0] = o, i[1] = l4;
      var p4 = c4 && c4.getViewportRootOffset();
      p4 && (i[0] += p4.offsetLeft, i[1] += p4.offsetTop);
    }
    i[2] = i[0] / n2.getWidth(), i[3] = i[1] / n2.getHeight();
  }
  var CCt = function() {
    function i(n2, e2, o) {
      if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, ol.wxa)
        return null;
      var l4 = document.createElement("div");
      l4.domBelongToZr = true, this.el = l4;
      var c4 = this._zr = e2.getZr(), h = this._appendToBody = o && o.appendToBody;
      DAe(this._styleCoord, c4, h, e2.getWidth() / 2, e2.getHeight() / 2), h ? document.body.appendChild(l4) : n2.appendChild(l4), this._container = n2;
      var p4 = this;
      l4.onmouseenter = function() {
        p4._enterable && (clearTimeout(p4._hideTimeout), p4._show = true), p4._inContent = true;
      }, l4.onmousemove = function(g4) {
        if (g4 = g4 || window.event, !p4._enterable) {
          var y4 = c4.handler, _ = c4.painter.getViewportRoot();
          Cy(_, g4, true), y4.dispatch("mousemove", g4);
        }
      }, l4.onmouseleave = function() {
        p4._inContent = false, p4._enterable && p4._show && p4.hideLater(p4._hideDelay);
      };
    }
    return i.prototype.update = function(n2) {
      var e2 = this._container, o = gCt(e2, "position"), l4 = e2.style;
      l4.position !== "absolute" && o !== "absolute" && (l4.position = "relative");
      var c4 = n2.get("alwaysShowContent");
      c4 && this._moveIfResized(), this.el.className = n2.get("className") || "";
    }, i.prototype.show = function(n2, e2) {
      clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
      var o = this.el, l4 = o.style, c4 = this._styleCoord;
      o.innerHTML ? l4.cssText = yCt + SCt(n2, !this._firstShow, this._longHide) + TAe(c4[0], c4[1], true) + ("border-color:" + xT(e2) + ";") + (n2.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : l4.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
    }, i.prototype.setContent = function(n2, e2, o, l4, c4) {
      var h = this.el;
      if (n2 == null) {
        h.innerHTML = "";
        return;
      }
      var p4 = "";
      if (xa(c4) && o.get("trigger") === "item" && !H3e(o) && (p4 = _Ct(o, l4, c4)), xa(n2))
        h.innerHTML = n2 + p4;
      else if (n2) {
        h.innerHTML = "", Mr(n2) || (n2 = [n2]);
        for (var g4 = 0; g4 < n2.length; g4++)
          a8(n2[g4]) && n2[g4].parentNode !== h && h.appendChild(n2[g4]);
        if (p4 && h.childNodes.length) {
          var y4 = document.createElement("div");
          y4.innerHTML = p4, h.appendChild(y4);
        }
      }
    }, i.prototype.setEnterable = function(n2) {
      this._enterable = n2;
    }, i.prototype.getSize = function() {
      var n2 = this.el;
      return [n2.offsetWidth, n2.offsetHeight];
    }, i.prototype.moveTo = function(n2, e2) {
      var o = this._styleCoord;
      if (DAe(o, this._zr, this._appendToBody, n2, e2), o[0] != null && o[1] != null) {
        var l4 = this.el.style, c4 = TAe(o[0], o[1]);
        Ve(c4, function(h) {
          l4[h[0]] = h[1];
        });
      }
    }, i.prototype._moveIfResized = function() {
      var n2 = this._styleCoord[2], e2 = this._styleCoord[3];
      this.moveTo(n2 * this._zr.getWidth(), e2 * this._zr.getHeight());
    }, i.prototype.hide = function() {
      var n2 = this, e2 = this.el.style;
      e2.visibility = "hidden", e2.opacity = "0", ol.transform3dSupported && (e2.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
        return n2._longHide = true;
      }, 500);
    }, i.prototype.hideLater = function(n2) {
      this._show && !(this._inContent && this._enterable) && (n2 ? (this._hideDelay = n2, this._show = false, this._hideTimeout = setTimeout(Ia(this.hide, this), n2)) : this.hide());
    }, i.prototype.isShow = function() {
      return this._show;
    }, i.prototype.dispose = function() {
      this.el.parentNode.removeChild(this.el);
    }, i;
  }(), MCt = CCt, ACt = function() {
    function i(n2) {
      this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = n2.getZr(), PAe(this._styleCoord, this._zr, n2.getWidth() / 2, n2.getHeight() / 2);
    }
    return i.prototype.update = function(n2) {
      var e2 = n2.get("alwaysShowContent");
      e2 && this._moveIfResized();
    }, i.prototype.show = function() {
      this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
    }, i.prototype.setContent = function(n2, e2, o, l4, c4) {
      var h = this;
      mi(n2) && dl(""), this.el && this._zr.remove(this.el);
      var p4 = o.getModel("textStyle");
      this.el = new Qs({ style: { rich: e2.richTextStyles, text: n2, lineHeight: 22, borderWidth: 1, borderColor: l4, textShadowColor: p4.get("textShadowColor"), fill: o.get(["textStyle", "color"]), padding: t5e(o, "richText"), verticalAlign: "top", align: "left" }, z: o.get("z") }), Ve(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(y4) {
        h.el.style[y4] = o.get(y4);
      }), Ve(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(y4) {
        h.el.style[y4] = p4.get(y4) || 0;
      }), this._zr.add(this.el);
      var g4 = this;
      this.el.on("mouseover", function() {
        g4._enterable && (clearTimeout(g4._hideTimeout), g4._show = true), g4._inContent = true;
      }), this.el.on("mouseout", function() {
        g4._enterable && g4._show && g4.hideLater(g4._hideDelay), g4._inContent = false;
      });
    }, i.prototype.setEnterable = function(n2) {
      this._enterable = n2;
    }, i.prototype.getSize = function() {
      var n2 = this.el, e2 = this.el.getBoundingRect(), o = kAe(n2.style);
      return [e2.width + o.left + o.right, e2.height + o.top + o.bottom];
    }, i.prototype.moveTo = function(n2, e2) {
      var o = this.el;
      if (o) {
        var l4 = this._styleCoord;
        PAe(l4, this._zr, n2, e2), n2 = l4[0], e2 = l4[1];
        var c4 = o.style, h = PC(c4.borderWidth || 0), p4 = kAe(c4);
        o.x = n2 + h + p4.left, o.y = e2 + h + p4.top, o.markRedraw();
      }
    }, i.prototype._moveIfResized = function() {
      var n2 = this._styleCoord[2], e2 = this._styleCoord[3];
      this.moveTo(n2 * this._zr.getWidth(), e2 * this._zr.getHeight());
    }, i.prototype.hide = function() {
      this.el && this.el.hide(), this._show = false;
    }, i.prototype.hideLater = function(n2) {
      this._show && !(this._inContent && this._enterable) && (n2 ? (this._hideDelay = n2, this._show = false, this._hideTimeout = setTimeout(Ia(this.hide, this), n2)) : this.hide());
    }, i.prototype.isShow = function() {
      return this._show;
    }, i.prototype.dispose = function() {
      this._zr.remove(this.el);
    }, i;
  }();
  function PC(i) {
    return Math.max(0, i);
  }
  function kAe(i) {
    var n2 = PC(i.shadowBlur || 0), e2 = PC(i.shadowOffsetX || 0), o = PC(i.shadowOffsetY || 0);
    return { left: PC(n2 - e2), right: PC(n2 + e2), top: PC(n2 - o), bottom: PC(n2 + o) };
  }
  function PAe(i, n2, e2, o) {
    i[0] = e2, i[1] = o, i[2] = i[0] / n2.getWidth(), i[3] = i[1] / n2.getHeight();
  }
  var ECt = ACt, ICt = new Is({ shape: { x: -1, y: -1, width: 2, height: 2 } }), TCt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o) {
      if (!(ol.node || !o.getDom())) {
        var l4 = e2.getComponent("tooltip"), c4 = this._renderMode = Dst(l4.get("renderMode"));
        this._tooltipContent = c4 === "richText" ? new ECt(o) : new MCt(o.getDom(), o, { appendToBody: l4.get("appendToBody", true) });
      }
    }, n2.prototype.render = function(e2, o, l4) {
      if (!(ol.node || !l4.getDom())) {
        this.group.removeAll(), this._tooltipModel = e2, this._ecModel = o, this._api = l4, this._alwaysShowContent = e2.get("alwaysShowContent");
        var c4 = this._tooltipContent;
        c4.update(e2), c4.setEnterable(e2.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && e2.get("transitionDuration") ? tL(this, "_updatePosition", 50, "fixRate") : m8(this, "_updatePosition");
      }
    }, n2.prototype._initGlobalListener = function() {
      var e2 = this._tooltipModel, o = e2.get("triggerOn");
      D3e("itemTooltip", this._api, Ia(function(l4, c4, h) {
        o !== "none" && (o.indexOf(l4) >= 0 ? this._tryShow(c4, h) : l4 === "leave" && this._hide(h));
      }, this));
    }, n2.prototype._keepShow = function() {
      var e2 = this._tooltipModel, o = this._ecModel, l4 = this._api;
      if (this._lastX != null && this._lastY != null && e2.get("triggerOn") !== "none") {
        var c4 = this;
        clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
          !l4.isDisposed() && c4.manuallyShowTip(e2, o, l4, { x: c4._lastX, y: c4._lastY, dataByCoordSys: c4._lastDataByCoordSys });
        });
      }
    }, n2.prototype.manuallyShowTip = function(e2, o, l4, c4) {
      if (!(c4.from === this.uid || ol.node || !l4.getDom())) {
        var h = LAe(c4, l4);
        this._ticket = "";
        var p4 = c4.dataByCoordSys, g4 = LCt(c4, o, l4);
        if (g4) {
          var y4 = g4.el.getBoundingRect().clone();
          y4.applyTransform(g4.el.transform), this._tryShow({ offsetX: y4.x + y4.width / 2, offsetY: y4.y + y4.height / 2, target: g4.el, position: c4.position, positionDefault: "bottom" }, h);
        } else if (c4.tooltip && c4.x != null && c4.y != null) {
          var _ = ICt;
          _.x = c4.x, _.y = c4.y, _.update(), Fi(_).tooltipConfig = { name: null, option: c4.tooltip }, this._tryShow({ offsetX: c4.x, offsetY: c4.y, target: _ }, h);
        } else if (p4)
          this._tryShow({ offsetX: c4.x, offsetY: c4.y, position: c4.position, dataByCoordSys: p4, tooltipOption: c4.tooltipOption }, h);
        else if (c4.seriesIndex != null) {
          if (this._manuallyAxisShowTip(e2, o, l4, c4))
            return;
          var w4 = k3e(c4, o), C = w4.point[0], E = w4.point[1];
          C != null && E != null && this._tryShow({ offsetX: C, offsetY: E, target: w4.el, position: c4.position, positionDefault: "bottom" }, h);
        } else
          c4.x != null && c4.y != null && (l4.dispatchAction({ type: "updateAxisPointer", x: c4.x, y: c4.y }), this._tryShow({ offsetX: c4.x, offsetY: c4.y, position: c4.position, target: l4.getZr().findHover(c4.x, c4.y).target }, h));
      }
    }, n2.prototype.manuallyHideTip = function(e2, o, l4, c4) {
      var h = this._tooltipContent;
      !this._alwaysShowContent && this._tooltipModel && h.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, c4.from !== this.uid && this._hide(LAe(c4, l4));
    }, n2.prototype._manuallyAxisShowTip = function(e2, o, l4, c4) {
      var h = c4.seriesIndex, p4 = c4.dataIndex, g4 = o.getComponent("axisPointer").coordSysAxesInfo;
      if (!(h == null || p4 == null || g4 == null)) {
        var y4 = o.getSeriesByIndex(h);
        if (!!y4) {
          var _ = y4.getData(), w4 = yN([_.getItemModel(p4), y4, (y4.coordinateSystem || {}).model], this._tooltipModel);
          if (w4.get("trigger") === "axis")
            return l4.dispatchAction({ type: "updateAxisPointer", seriesIndex: h, dataIndex: p4, position: c4.position }), true;
        }
      }
    }, n2.prototype._tryShow = function(e2, o) {
      var l4 = e2.target, c4 = this._tooltipModel;
      if (!!c4) {
        this._lastX = e2.offsetX, this._lastY = e2.offsetY;
        var h = e2.dataByCoordSys;
        if (h && h.length)
          this._showAxisTooltip(h, e2);
        else if (l4) {
          this._lastDataByCoordSys = null;
          var p4, g4;
          _3(l4, function(y4) {
            if (Fi(y4).dataIndex != null)
              return p4 = y4, true;
            if (Fi(y4).tooltipConfig != null)
              return g4 = y4, true;
          }, true), p4 ? this._showSeriesItemTooltip(e2, p4, o) : g4 ? this._showComponentItemTooltip(e2, g4, o) : this._hide(o);
        } else
          this._lastDataByCoordSys = null, this._hide(o);
      }
    }, n2.prototype._showOrMove = function(e2, o) {
      var l4 = e2.get("showDelay");
      o = Ia(o, this), clearTimeout(this._showTimout), l4 > 0 ? this._showTimout = setTimeout(o, l4) : o();
    }, n2.prototype._showAxisTooltip = function(e2, o) {
      var l4 = this._ecModel, c4 = this._tooltipModel, h = [o.offsetX, o.offsetY], p4 = yN([o.tooltipOption], c4), g4 = this._renderMode, y4 = [], _ = Qh("section", { blocks: [], noHeader: true }), w4 = [], C = new Rre();
      Ve(e2, function(H) {
        Ve(H.dataByAxis, function(X) {
          var q2 = l4.getComponent(X.axisDim + "Axis", X.axisIndex), de = X.value;
          if (!(!q2 || de == null)) {
            var le = E3e(de, q2.axis, l4, X.seriesDataIndices, X.valueLabelOpt), me = Qh("section", { header: le, noHeader: !tb(le), sortBlocks: true, blocks: [] });
            _.blocks.push(me), Ve(X.seriesDataIndices, function(ye) {
              var be = l4.getSeriesByIndex(ye.seriesIndex), we = ye.dataIndexInside, Pe = be.getDataParams(we);
              if (!(Pe.dataIndex < 0)) {
                Pe.axisDim = X.axisDim, Pe.axisIndex = X.axisIndex, Pe.axisType = X.axisType, Pe.axisId = X.axisId, Pe.axisValue = Ile(q2.axis, { value: de }), Pe.axisValueLabel = le, Pe.marker = C.makeTooltipMarker("item", xT(Pe.color), g4);
                var ze = y2e(be.formatTooltip(we, true, null)), Re = ze.frag;
                if (Re) {
                  var rt2 = yN([be], c4).get("valueFormatter");
                  me.blocks.push(rt2 ? rr({ valueFormatter: rt2 }, Re) : Re);
                }
                ze.text && w4.push(ze.text), y4.push(Pe);
              }
            });
          }
        });
      }), _.blocks.reverse(), w4.reverse();
      var E = o.position, T = p4.get("order"), O = C2e(_, C, g4, T, l4.get("useUTC"), p4.get("textStyle"));
      O && w4.unshift(O);
      var N = g4 === "richText" ? `

` : "<br/>", V = w4.join(N);
      this._showOrMove(p4, function() {
        this._updateContentNotChangedOnAxis(e2, y4) ? this._updatePosition(p4, E, h[0], h[1], this._tooltipContent, y4) : this._showTooltipContent(p4, V, y4, Math.random() + "", h[0], h[1], E, null, C);
      });
    }, n2.prototype._showSeriesItemTooltip = function(e2, o, l4) {
      var c4 = this._ecModel, h = Fi(o), p4 = h.seriesIndex, g4 = c4.getSeriesByIndex(p4), y4 = h.dataModel || g4, _ = h.dataIndex, w4 = h.dataType, C = y4.getData(w4), E = this._renderMode, T = e2.positionDefault, O = yN([C.getItemModel(_), y4, g4 && (g4.coordinateSystem || {}).model], this._tooltipModel, T ? { position: T } : null), N = O.get("trigger");
      if (!(N != null && N !== "item")) {
        var V = y4.getDataParams(_, w4), H = new Rre();
        V.marker = H.makeTooltipMarker("item", xT(V.color), E);
        var X = y2e(y4.formatTooltip(_, false, w4)), q2 = O.get("order"), de = O.get("valueFormatter"), le = X.frag, me = le ? C2e(de ? rr({ valueFormatter: de }, le) : le, H, E, q2, c4.get("useUTC"), O.get("textStyle")) : X.text, ye = "item_" + y4.name + "_" + _;
        this._showOrMove(O, function() {
          this._showTooltipContent(O, me, V, ye, e2.offsetX, e2.offsetY, e2.position, e2.target, H);
        }), l4({ type: "showTip", dataIndexInside: _, dataIndex: C.getRawIndex(_), seriesIndex: p4, from: this.uid });
      }
    }, n2.prototype._showComponentItemTooltip = function(e2, o, l4) {
      var c4 = Fi(o), h = c4.tooltipConfig, p4 = h.option || {};
      if (xa(p4)) {
        var g4 = p4;
        p4 = { content: g4, formatter: g4 };
      }
      var y4 = [p4], _ = this._ecModel.getComponent(c4.componentMainType, c4.componentIndex);
      _ && y4.push(_), y4.push({ formatter: p4.content });
      var w4 = e2.positionDefault, C = yN(y4, this._tooltipModel, w4 ? { position: w4 } : null), E = C.get("content"), T = Math.random() + "", O = new Rre();
      this._showOrMove(C, function() {
        var N = Ci(C.get("formatterParams") || {});
        this._showTooltipContent(C, E, N, T, e2.offsetX, e2.offsetY, e2.position, o, O);
      }), l4({ type: "showTip", from: this.uid });
    }, n2.prototype._showTooltipContent = function(e2, o, l4, c4, h, p4, g4, y4, _) {
      if (this._ticket = "", !(!e2.get("showContent") || !e2.get("show"))) {
        var w4 = this._tooltipContent;
        w4.setEnterable(e2.get("enterable"));
        var C = e2.get("formatter");
        g4 = g4 || e2.get("position");
        var E = o, T = this._getNearestPoint([h, p4], l4, e2.get("trigger"), e2.get("borderColor")), O = T.color;
        if (C)
          if (xa(C)) {
            var N = e2.ecModel.get("useUTC"), V = Mr(l4) ? l4[0] : l4, H = V && V.axisType && V.axisType.indexOf("time") >= 0;
            E = C, H && (E = P$(V.axisValue, E, N)), E = _De(E, l4, true);
          } else if (si(C)) {
            var X = Ia(function(q2, de) {
              q2 === this._ticket && (w4.setContent(de, _, e2, O, g4), this._updatePosition(e2, g4, h, p4, w4, l4, y4));
            }, this);
            this._ticket = c4, E = C(l4, c4, X);
          } else
            E = C;
        w4.setContent(E, _, e2, O, g4), w4.show(e2, O), this._updatePosition(e2, g4, h, p4, w4, l4, y4);
      }
    }, n2.prototype._getNearestPoint = function(e2, o, l4, c4) {
      if (l4 === "axis" || Mr(o))
        return { color: c4 || (this._renderMode === "html" ? "#fff" : "none") };
      if (!Mr(o))
        return { color: c4 || o.color || o.borderColor };
    }, n2.prototype._updatePosition = function(e2, o, l4, c4, h, p4, g4) {
      var y4 = this._api.getWidth(), _ = this._api.getHeight();
      o = o || e2.get("position");
      var w4 = h.getSize(), C = e2.get("align"), E = e2.get("verticalAlign"), T = g4 && g4.getBoundingRect().clone();
      if (g4 && T.applyTransform(g4.transform), si(o) && (o = o([l4, c4], p4, h.el, T, { viewSize: [y4, _], contentSize: w4.slice() })), Mr(o))
        l4 = ma(o[0], y4), c4 = ma(o[1], _);
      else if (mi(o)) {
        var O = o;
        O.width = w4[0], O.height = w4[1];
        var N = bh(O, { width: y4, height: _ });
        l4 = N.x, c4 = N.y, C = null, E = null;
      } else if (xa(o) && g4) {
        var V = PCt(o, T, w4, e2.get("borderWidth"));
        l4 = V[0], c4 = V[1];
      } else {
        var V = DCt(l4, c4, h, y4, _, C ? null : 20, E ? null : 20);
        l4 = V[0], c4 = V[1];
      }
      if (C && (l4 -= OAe(C) ? w4[0] / 2 : C === "right" ? w4[0] : 0), E && (c4 -= OAe(E) ? w4[1] / 2 : E === "bottom" ? w4[1] : 0), H3e(e2)) {
        var V = kCt(l4, c4, h, y4, _);
        l4 = V[0], c4 = V[1];
      }
      h.moveTo(l4, c4);
    }, n2.prototype._updateContentNotChangedOnAxis = function(e2, o) {
      var l4 = this._lastDataByCoordSys, c4 = this._cbParamsList, h = !!l4 && l4.length === e2.length;
      return h && Ve(l4, function(p4, g4) {
        var y4 = p4.dataByAxis || [], _ = e2[g4] || {}, w4 = _.dataByAxis || [];
        h = h && y4.length === w4.length, h && Ve(y4, function(C, E) {
          var T = w4[E] || {}, O = C.seriesDataIndices || [], N = T.seriesDataIndices || [];
          h = h && C.value === T.value && C.axisType === T.axisType && C.axisId === T.axisId && O.length === N.length, h && Ve(O, function(V, H) {
            var X = N[H];
            h = h && V.seriesIndex === X.seriesIndex && V.dataIndex === X.dataIndex;
          }), c4 && Ve(C.seriesDataIndices, function(V) {
            var H = V.seriesIndex, X = o[H], q2 = c4[H];
            X && q2 && q2.data !== X.data && (h = false);
          });
        });
      }), this._lastDataByCoordSys = e2, this._cbParamsList = o, !!h;
    }, n2.prototype._hide = function(e2) {
      this._lastDataByCoordSys = null, e2({ type: "hideTip", from: this.uid });
    }, n2.prototype.dispose = function(e2, o) {
      ol.node || !o.getDom() || (m8(this, "_updatePosition"), this._tooltipContent.dispose(), Uoe("itemTooltip", o));
    }, n2.type = "tooltip", n2;
  }($c);
  function yN(i, n2, e2) {
    var o = n2.ecModel, l4;
    e2 ? (l4 = new Ou(e2, o, o), l4 = new Ou(n2.option, l4, o)) : l4 = n2;
    for (var c4 = i.length - 1; c4 >= 0; c4--) {
      var h = i[c4];
      h && (h instanceof Ou && (h = h.get("tooltip", true)), xa(h) && (h = { formatter: h }), h && (l4 = new Ou(h, l4, o)));
    }
    return l4;
  }
  function LAe(i, n2) {
    return i.dispatchAction || Ia(n2.dispatchAction, n2);
  }
  function DCt(i, n2, e2, o, l4, c4, h) {
    var p4 = e2.getSize(), g4 = p4[0], y4 = p4[1];
    return c4 != null && (i + g4 + c4 + 2 > o ? i -= g4 + c4 : i += c4), h != null && (n2 + y4 + h > l4 ? n2 -= y4 + h : n2 += h), [i, n2];
  }
  function kCt(i, n2, e2, o, l4) {
    var c4 = e2.getSize(), h = c4[0], p4 = c4[1];
    return i = Math.min(i + h, o) - h, n2 = Math.min(n2 + p4, l4) - p4, i = Math.max(i, 0), n2 = Math.max(n2, 0), [i, n2];
  }
  function PCt(i, n2, e2, o) {
    var l4 = e2[0], c4 = e2[1], h = Math.ceil(Math.SQRT2 * o) + 8, p4 = 0, g4 = 0, y4 = n2.width, _ = n2.height;
    switch (i) {
      case "inside":
        p4 = n2.x + y4 / 2 - l4 / 2, g4 = n2.y + _ / 2 - c4 / 2;
        break;
      case "top":
        p4 = n2.x + y4 / 2 - l4 / 2, g4 = n2.y - c4 - h;
        break;
      case "bottom":
        p4 = n2.x + y4 / 2 - l4 / 2, g4 = n2.y + _ + h;
        break;
      case "left":
        p4 = n2.x - l4 - h, g4 = n2.y + _ / 2 - c4 / 2;
        break;
      case "right":
        p4 = n2.x + y4 + h, g4 = n2.y + _ / 2 - c4 / 2;
    }
    return [p4, g4];
  }
  function OAe(i) {
    return i === "center" || i === "middle";
  }
  function LCt(i, n2, e2) {
    var o = jse(i).queryOptionMap, l4 = o.keys()[0];
    if (!(!l4 || l4 === "series")) {
      var c4 = V8(n2, l4, o.get(l4), { useDefault: false, enableAll: false, enableNone: false }), h = c4.models[0];
      if (!!h) {
        var p4 = e2.getViewOfComponentModel(h), g4;
        if (p4.group.traverse(function(y4) {
          var _ = Fi(y4).tooltipConfig;
          if (_ && _.name === i.name)
            return g4 = y4, true;
        }), g4)
          return { componentMainType: l4, componentIndex: h.componentIndex, el: g4 };
      }
    }
  }
  var OCt = TCt;
  function RCt(i) {
    wo(r9), i.registerComponentModel(pCt), i.registerComponentView(OCt), i.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, Zf), i.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, Zf);
  }
  var FCt = ["rect", "polygon", "keep", "clear"];
  function NCt(i, n2) {
    var e2 = Zl(i ? i.brush : []);
    if (!!e2.length) {
      var o = [];
      Ve(e2, function(g4) {
        var y4 = g4.hasOwnProperty("toolbox") ? g4.toolbox : [];
        y4 instanceof Array && (o = o.concat(y4));
      });
      var l4 = i && i.toolbox;
      Mr(l4) && (l4 = l4[0]), l4 || (l4 = { feature: {} }, i.toolbox = [l4]);
      var c4 = l4.feature || (l4.feature = {}), h = c4.brush || (c4.brush = {}), p4 = h.type || (h.type = []);
      p4.push.apply(p4, o), VCt(p4), n2 && !p4.length && p4.push.apply(p4, FCt);
    }
  }
  function VCt(i) {
    var n2 = {};
    Ve(i, function(e2) {
      n2[e2] = 1;
    }), i.length = 0, Ve(n2, function(e2, o) {
      i.push(o);
    });
  }
  var RAe = Ve;
  function FAe(i) {
    if (i) {
      for (var n2 in i)
        if (i.hasOwnProperty(n2))
          return true;
    }
  }
  function Joe(i, n2, e2) {
    var o = {};
    return RAe(n2, function(c4) {
      var h = o[c4] = l4();
      RAe(i[c4], function(p4, g4) {
        if (!!Cp.isValidType(g4)) {
          var y4 = { type: g4, visual: p4 };
          e2 && e2(y4, c4), h[g4] = new Cp(y4), g4 === "opacity" && (y4 = Ci(y4), y4.type = "colorAlpha", h.__hidden.__alphaForOpacity = new Cp(y4));
        }
      });
    }), o;
    function l4() {
      var c4 = function() {
      };
      c4.prototype.__hidden = c4.prototype;
      var h = new c4();
      return h;
    }
  }
  function Y3e(i, n2, e2) {
    var o;
    Ve(e2, function(l4) {
      n2.hasOwnProperty(l4) && FAe(n2[l4]) && (o = true);
    }), o && Ve(e2, function(l4) {
      n2.hasOwnProperty(l4) && FAe(n2[l4]) ? i[l4] = Ci(n2[l4]) : delete i[l4];
    });
  }
  function zCt(i, n2, e2, o, l4, c4) {
    var h = {};
    Ve(i, function(w4) {
      var C = Cp.prepareVisualTypes(n2[w4]);
      h[w4] = C;
    });
    var p4;
    function g4(w4) {
      return mle(e2, p4, w4);
    }
    function y4(w4, C) {
      f5e(e2, p4, w4, C);
    }
    c4 == null ? e2.each(_) : e2.each([c4], _);
    function _(w4, C) {
      p4 = c4 == null ? w4 : C;
      var E = e2.getRawDataItem(p4);
      if (!(E && E.visualMap === false))
        for (var T = o.call(l4, w4), O = n2[T], N = h[T], V = 0, H = N.length; V < H; V++) {
          var X = N[V];
          O[X] && O[X].applyVisual(w4, g4, y4);
        }
    }
  }
  function BCt(i, n2, e2, o) {
    var l4 = {};
    return Ve(i, function(c4) {
      var h = Cp.prepareVisualTypes(n2[c4]);
      l4[c4] = h;
    }), { progress: function(h, p4) {
      var g4;
      o != null && (g4 = p4.getDimensionIndex(o));
      function y4(de) {
        return mle(p4, w4, de);
      }
      function _(de, le) {
        f5e(p4, w4, de, le);
      }
      for (var w4, C = p4.getStore(); (w4 = h.next()) != null; ) {
        var E = p4.getRawDataItem(w4);
        if (!(E && E.visualMap === false))
          for (var T = o != null ? C.get(g4, w4) : w4, O = e2(T), N = n2[O], V = l4[O], H = 0, X = V.length; H < X; H++) {
            var q2 = V[H];
            N[q2] && N[q2].applyVisual(T, y4, _);
          }
      }
    } };
  }
  function jCt(i) {
    var n2 = i.brushType, e2 = { point: function(o) {
      return NAe[n2].point(o, e2, i);
    }, rect: function(o) {
      return NAe[n2].rect(o, e2, i);
    } };
    return e2;
  }
  var NAe = { lineX: VAe(0), lineY: VAe(1), rect: { point: function(i, n2, e2) {
    return i && e2.boundingRect.contain(i[0], i[1]);
  }, rect: function(i, n2, e2) {
    return i && e2.boundingRect.intersect(i);
  } }, polygon: { point: function(i, n2, e2) {
    return i && e2.boundingRect.contain(i[0], i[1]) && JI(e2.range, i[0], i[1]);
  }, rect: function(i, n2, e2) {
    var o = e2.range;
    if (!i || o.length <= 1)
      return false;
    var l4 = i.x, c4 = i.y, h = i.width, p4 = i.height, g4 = o[0];
    if (JI(o, l4, c4) || JI(o, l4 + h, c4) || JI(o, l4, c4 + p4) || JI(o, l4 + h, c4 + p4) || mo.create(i).contain(g4[0], g4[1]) || DN(l4, c4, l4 + h, c4, o) || DN(l4, c4, l4, c4 + p4, o) || DN(l4 + h, c4, l4 + h, c4 + p4, o) || DN(l4, c4 + p4, l4 + h, c4 + p4, o))
      return true;
  } } };
  function VAe(i) {
    var n2 = ["x", "y"], e2 = ["width", "height"];
    return { point: function(o, l4, c4) {
      if (o) {
        var h = c4.range, p4 = o[i];
        return bN(p4, h);
      }
    }, rect: function(o, l4, c4) {
      if (o) {
        var h = c4.range, p4 = [o[n2[i]], o[n2[i]] + o[e2[i]]];
        return p4[1] < p4[0] && p4.reverse(), bN(p4[0], h) || bN(p4[1], h) || bN(h[0], p4) || bN(h[1], p4);
      }
    } };
  }
  function bN(i, n2) {
    return n2[0] <= i && i <= n2[1];
  }
  var zAe = ["inBrush", "outOfBrush"], Xae = "__ecBrushSelect", Qoe = "__ecInBrushSelectEvent";
  function Z3e(i) {
    i.eachComponent({ mainType: "brush" }, function(n2) {
      var e2 = n2.brushTargetManager = new wue(n2.option, i);
      e2.setInputRanges(n2.areas, i);
    });
  }
  function GCt(i, n2, e2) {
    var o = [], l4, c4;
    i.eachComponent({ mainType: "brush" }, function(h) {
      e2 && e2.type === "takeGlobalCursor" && h.setBrushOption(e2.key === "brush" ? e2.brushOption : { brushType: false });
    }), Z3e(i), i.eachComponent({ mainType: "brush" }, function(h, p4) {
      var g4 = { brushId: h.id, brushIndex: p4, brushName: h.name, areas: Ci(h.areas), selected: [] };
      o.push(g4);
      var y4 = h.option, _ = y4.brushLink, w4 = [], C = [], E = [], T = false;
      p4 || (l4 = y4.throttleType, c4 = y4.throttleDelay);
      var O = Er(h.areas, function(de) {
        var le = UCt[de.brushType], me = hi({ boundingRect: le ? le(de) : void 0 }, de);
        return me.selectors = jCt(me), me;
      }), N = Joe(h.option, zAe, function(de) {
        de.mappingMethod = "fixed";
      });
      Mr(_) && Ve(_, function(de) {
        w4[de] = 1;
      });
      function V(de) {
        return _ === "all" || !!w4[de];
      }
      function H(de) {
        return !!de.length;
      }
      i.eachSeries(function(de, le) {
        var me = E[le] = [];
        de.subType === "parallel" ? X(de, le) : q2(de, le, me);
      });
      function X(de, le) {
        var me = de.coordinateSystem;
        T = T || me.hasAxisBrushed(), V(le) && me.eachActiveState(de.getData(), function(ye, be) {
          ye === "active" && (C[be] = 1);
        });
      }
      function q2(de, le, me) {
        if (!(!de.brushSelector || $Ct(h, le)) && (Ve(O, function(be) {
          h.brushTargetManager.controlSeries(be, de, i) && me.push(be), T = T || H(me);
        }), V(le) && H(me))) {
          var ye = de.getData();
          ye.each(function(be) {
            BAe(de, me, ye, be) && (C[be] = 1);
          });
        }
      }
      i.eachSeries(function(de, le) {
        var me = { seriesId: de.id, seriesIndex: le, seriesName: de.name, dataIndex: [] };
        g4.selected.push(me);
        var ye = E[le], be = de.getData(), we = V(le) ? function(Pe) {
          return C[Pe] ? (me.dataIndex.push(be.getRawIndex(Pe)), "inBrush") : "outOfBrush";
        } : function(Pe) {
          return BAe(de, ye, be, Pe) ? (me.dataIndex.push(be.getRawIndex(Pe)), "inBrush") : "outOfBrush";
        };
        (V(le) ? T : H(ye)) && zCt(zAe, N, be, we);
      });
    }), WCt(n2, l4, c4, o, e2);
  }
  function WCt(i, n2, e2, o, l4) {
    if (!!l4) {
      var c4 = i.getZr();
      if (!c4[Qoe]) {
        c4[Xae] || (c4[Xae] = HCt);
        var h = tL(c4, Xae, e2, n2);
        h(i, o);
      }
    }
  }
  function HCt(i, n2) {
    if (!i.isDisposed()) {
      var e2 = i.getZr();
      e2[Qoe] = true, i.dispatchAction({ type: "brushSelect", batch: n2 }), e2[Qoe] = false;
    }
  }
  function BAe(i, n2, e2, o) {
    for (var l4 = 0, c4 = n2.length; l4 < c4; l4++) {
      var h = n2[l4];
      if (i.brushSelector(o, e2, h.selectors, h))
        return true;
    }
  }
  function $Ct(i, n2) {
    var e2 = i.option.seriesIndex;
    return e2 != null && e2 !== "all" && (Mr(e2) ? go(e2, n2) < 0 : n2 !== e2);
  }
  var UCt = { rect: function(i) {
    return jAe(i.range);
  }, polygon: function(i) {
    for (var n2, e2 = i.range, o = 0, l4 = e2.length; o < l4; o++) {
      n2 = n2 || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
      var c4 = e2[o];
      c4[0] < n2[0][0] && (n2[0][0] = c4[0]), c4[0] > n2[0][1] && (n2[0][1] = c4[0]), c4[1] < n2[1][0] && (n2[1][0] = c4[1]), c4[1] > n2[1][1] && (n2[1][1] = c4[1]);
    }
    return n2 && jAe(n2);
  } };
  function jAe(i) {
    return new mo(i[0][0], i[1][0], i[0][1] - i[0][0], i[1][1] - i[1][0]);
  }
  var qCt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o) {
      this.ecModel = e2, this.api = o, this.model, (this._brushController = new nue(o.getZr())).on("brush", Ia(this._onBrush, this)).mount();
    }, n2.prototype.render = function(e2, o, l4, c4) {
      this.model = e2, this._updateController(e2, o, l4, c4);
    }, n2.prototype.updateTransform = function(e2, o, l4, c4) {
      Z3e(o), this._updateController(e2, o, l4, c4);
    }, n2.prototype.updateVisual = function(e2, o, l4, c4) {
      this.updateTransform(e2, o, l4, c4);
    }, n2.prototype.updateView = function(e2, o, l4, c4) {
      this._updateController(e2, o, l4, c4);
    }, n2.prototype._updateController = function(e2, o, l4, c4) {
      (!c4 || c4.$from !== e2.id) && this._brushController.setPanels(e2.brushTargetManager.makePanelOpts(l4)).enableBrush(e2.brushOption).updateCovers(e2.areas.slice());
    }, n2.prototype.dispose = function() {
      this._brushController.dispose();
    }, n2.prototype._onBrush = function(e2) {
      var o = this.model.id, l4 = this.model.brushTargetManager.setOutputRanges(e2.areas, this.ecModel);
      (!e2.isEnd || e2.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: o, areas: Ci(l4), $from: o }), e2.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: o, areas: Ci(l4), $from: o });
    }, n2.type = "brush", n2;
  }($c), YCt = qCt, ZCt = "#ddd", XCt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.areas = [], e2.brushOption = {}, e2;
    }
    return n2.prototype.optionUpdated = function(e2, o) {
      var l4 = this.option;
      !o && Y3e(l4, e2, ["inBrush", "outOfBrush"]);
      var c4 = l4.inBrush = l4.inBrush || {};
      l4.outOfBrush = l4.outOfBrush || { color: ZCt }, c4.hasOwnProperty("liftZ") || (c4.liftZ = 5);
    }, n2.prototype.setAreas = function(e2) {
      !e2 || (this.areas = Er(e2, function(o) {
        return GAe(this.option, o);
      }, this));
    }, n2.prototype.setBrushOption = function(e2) {
      this.brushOption = GAe(this.option, e2), this.brushType = this.brushOption.brushType;
    }, n2.type = "brush", n2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], n2.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, n2;
  }(Ns);
  function GAe(i, n2) {
    return to({ brushType: i.brushType, brushMode: i.brushMode, transformable: i.transformable, brushStyle: new Ou(i.brushStyle).getItemStyle(), removeOnClick: i.removeOnClick, z: i.z }, n2, true);
  }
  var KCt = XCt, JCt = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], QCt = function(i) {
    on(n2, i);
    function n2() {
      return i !== null && i.apply(this, arguments) || this;
    }
    return n2.prototype.render = function(e2, o, l4) {
      var c4, h, p4;
      o.eachComponent({ mainType: "brush" }, function(g4) {
        c4 = g4.brushType, h = g4.brushOption.brushMode || "single", p4 = p4 || !!g4.areas.length;
      }), this._brushType = c4, this._brushMode = h, Ve(e2.get("type", true), function(g4) {
        e2.setIconStatus(g4, (g4 === "keep" ? h === "multiple" : g4 === "clear" ? p4 : g4 === c4) ? "emphasis" : "normal");
      });
    }, n2.prototype.updateView = function(e2, o, l4) {
      this.render(e2, o, l4);
    }, n2.prototype.getIcons = function() {
      var e2 = this.model, o = e2.get("icon", true), l4 = {};
      return Ve(e2.get("type", true), function(c4) {
        o[c4] && (l4[c4] = o[c4]);
      }), l4;
    }, n2.prototype.onclick = function(e2, o, l4) {
      var c4 = this._brushType, h = this._brushMode;
      l4 === "clear" ? (o.dispatchAction({ type: "axisAreaSelect", intervals: [] }), o.dispatchAction({ type: "brush", command: "clear", areas: [] })) : o.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: l4 === "keep" ? c4 : c4 === l4 ? false : l4, brushMode: l4 === "keep" ? h === "multiple" ? "single" : "multiple" : h } });
    }, n2.getDefaultOption = function(e2) {
      var o = { show: true, type: JCt.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: e2.getLocaleModel().get(["toolbox", "brush", "title"]) };
      return o;
    }, n2;
  }(Ty), eMt = QCt;
  function tMt(i) {
    i.registerComponentView(YCt), i.registerComponentModel(KCt), i.registerPreprocessor(NCt), i.registerVisual(i.PRIORITY.VISUAL.BRUSH, GCt), i.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(n2, e2) {
      e2.eachComponent({ mainType: "brush", query: n2 }, function(o) {
        o.setAreas(n2.areas);
      });
    }), i.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, Zf), i.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, Zf), g3("brush", eMt);
  }
  var nMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.layoutMode = { type: "box", ignoreSize: true }, e2;
    }
    return n2.type = "title", n2.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, n2;
  }(Ns), rMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      if (this.group.removeAll(), !!e2.get("show")) {
        var c4 = this.group, h = e2.getModel("textStyle"), p4 = e2.getModel("subtextStyle"), g4 = e2.get("textAlign"), y4 = so(e2.get("textBaseline"), e2.get("textVerticalAlign")), _ = new Qs({ style: Ef(h, { text: e2.get("text"), fill: h.getTextColor() }, { disableBox: true }), z2: 10 }), w4 = _.getBoundingRect(), C = e2.get("subtext"), E = new Qs({ style: Ef(p4, { text: C, fill: p4.getTextColor(), y: w4.height + e2.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), T = e2.get("link"), O = e2.get("sublink"), N = e2.get("triggerEvent", true);
        _.silent = !T && !N, E.silent = !O && !N, T && _.on("click", function() {
          PH(T, "_" + e2.get("target"));
        }), O && E.on("click", function() {
          PH(O, "_" + e2.get("subtarget"));
        }), Fi(_).eventData = Fi(E).eventData = N ? { componentType: "title", componentIndex: e2.componentIndex } : null, c4.add(_), C && c4.add(E);
        var V = c4.getBoundingRect(), H = e2.getBoxLayoutParams();
        H.width = V.width, H.height = V.height;
        var X = bh(H, { width: l4.getWidth(), height: l4.getHeight() }, e2.get("padding"));
        g4 || (g4 = e2.get("left") || e2.get("right"), g4 === "middle" && (g4 = "center"), g4 === "right" ? X.x += X.width : g4 === "center" && (X.x += X.width / 2)), y4 || (y4 = e2.get("top") || e2.get("bottom"), y4 === "center" && (y4 = "middle"), y4 === "bottom" ? X.y += X.height : y4 === "middle" && (X.y += X.height / 2), y4 = y4 || "top"), c4.x = X.x, c4.y = X.y, c4.markRedraw();
        var q2 = { align: g4, verticalAlign: y4 };
        _.setStyle(q2), E.setStyle(q2), V = c4.getBoundingRect();
        var de = X.margin, le = e2.getItemStyle(["color", "opacity"]);
        le.fill = e2.get("backgroundColor");
        var me = new Is({ shape: { x: V.x - de[3], y: V.y - de[0], width: V.width + de[1] + de[3], height: V.height + de[0] + de[2], r: e2.get("borderRadius") }, style: le, subPixelOptimize: true, silent: true });
        c4.add(me);
      }
    }, n2.type = "title", n2;
  }($c);
  function aMt(i) {
    i.registerComponentModel(nMt), i.registerComponentView(rMt);
  }
  var iMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.layoutMode = "box", e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      this.mergeDefaultAndTheme(e2, l4), this._initData();
    }, n2.prototype.mergeOption = function(e2) {
      i.prototype.mergeOption.apply(this, arguments), this._initData();
    }, n2.prototype.setCurrentIndex = function(e2) {
      e2 == null && (e2 = this.option.currentIndex);
      var o = this._data.count();
      this.option.loop ? e2 = (e2 % o + o) % o : (e2 >= o && (e2 = o - 1), e2 < 0 && (e2 = 0)), this.option.currentIndex = e2;
    }, n2.prototype.getCurrentIndex = function() {
      return this.option.currentIndex;
    }, n2.prototype.isIndexMax = function() {
      return this.getCurrentIndex() >= this._data.count() - 1;
    }, n2.prototype.setPlayState = function(e2) {
      this.option.autoPlay = !!e2;
    }, n2.prototype.getPlayState = function() {
      return !!this.option.autoPlay;
    }, n2.prototype._initData = function() {
      var e2 = this.option, o = e2.data || [], l4 = e2.axisType, c4 = this._names = [], h;
      l4 === "category" ? (h = [], Ve(o, function(y4, _) {
        var w4 = yh(H3(y4), ""), C;
        mi(y4) ? (C = Ci(y4), C.value = _) : C = _, h.push(C), c4.push(w4);
      })) : h = o;
      var p4 = { category: "ordinal", time: "time", value: "number" }[l4] || "number", g4 = this._data = new Xv([{ name: "value", type: p4 }], this);
      g4.initData(h, c4);
    }, n2.prototype.getData = function() {
      return this._data;
    }, n2.prototype.getCategories = function() {
      if (this.get("axisType") === "category")
        return this._names.slice();
    }, n2.type = "timeline", n2.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, n2;
  }(Ns), WAe = iMt, X3e = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "timeline.slider", n2.defaultOption = sM(WAe.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), n2;
  }(WAe);
  Kf(X3e, hle.prototype);
  var oMt = X3e, sMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "timeline", n2;
  }($c), lMt = sMt, uMt = function(i) {
    on(n2, i);
    function n2(e2, o, l4, c4) {
      var h = i.call(this, e2, o, l4) || this;
      return h.type = c4 || "value", h;
    }
    return n2.prototype.getLabelModel = function() {
      return this.model.getModel("label");
    }, n2.prototype.isHorizontal = function() {
      return this.model.get("orient") === "horizontal";
    }, n2;
  }(lb2), cMt = uMt, Kae = Math.PI, HAe = zs(), fMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function(e2, o) {
      this.api = o;
    }, n2.prototype.render = function(e2, o, l4) {
      if (this.model = e2, this.api = l4, this.ecModel = o, this.group.removeAll(), e2.get("show", true)) {
        var c4 = this._layout(e2, l4), h = this._createGroup("_mainGroup"), p4 = this._createGroup("_labelGroup"), g4 = this._axis = this._createAxis(c4, e2);
        e2.formatTooltip = function(y4) {
          var _ = g4.scale.getLabel({ value: y4 });
          return Qh("nameValue", { noName: true, value: _ });
        }, Ve(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(y4) {
          this["_render" + y4](c4, h, g4, e2);
        }, this), this._renderAxisLabel(c4, p4, g4, e2), this._position(c4, e2);
      }
      this._doPlayStop(), this._updateTicksStatus();
    }, n2.prototype.remove = function() {
      this._clearTimer(), this.group.removeAll();
    }, n2.prototype.dispose = function() {
      this._clearTimer();
    }, n2.prototype._layout = function(e2, o) {
      var l4 = e2.get(["label", "position"]), c4 = e2.get("orient"), h = dMt(e2, o), p4;
      l4 == null || l4 === "auto" ? p4 = c4 === "horizontal" ? h.y + h.height / 2 < o.getHeight() / 2 ? "-" : "+" : h.x + h.width / 2 < o.getWidth() / 2 ? "+" : "-" : xa(l4) ? p4 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[c4][l4] : p4 = l4;
      var g4 = { horizontal: "center", vertical: p4 >= 0 || p4 === "+" ? "left" : "right" }, y4 = { horizontal: p4 >= 0 || p4 === "+" ? "top" : "bottom", vertical: "middle" }, _ = { horizontal: 0, vertical: Kae / 2 }, w4 = c4 === "vertical" ? h.height : h.width, C = e2.getModel("controlStyle"), E = C.get("show", true), T = E ? C.get("itemSize") : 0, O = E ? C.get("itemGap") : 0, N = T + O, V = e2.get(["label", "rotate"]) || 0;
      V = V * Kae / 180;
      var H, X, q2, de = C.get("position", true), le = E && C.get("showPlayBtn", true), me = E && C.get("showPrevBtn", true), ye = E && C.get("showNextBtn", true), be = 0, we = w4;
      de === "left" || de === "bottom" ? (le && (H = [0, 0], be += N), me && (X = [be, 0], be += N), ye && (q2 = [we - T, 0], we -= N)) : (le && (H = [we - T, 0], we -= N), me && (X = [0, 0], be += N), ye && (q2 = [we - T, 0], we -= N));
      var Pe = [be, we];
      return e2.get("inverse") && Pe.reverse(), { viewRect: h, mainLength: w4, orient: c4, rotation: _[c4], labelRotation: V, labelPosOpt: p4, labelAlign: e2.get(["label", "align"]) || g4[c4], labelBaseline: e2.get(["label", "verticalAlign"]) || e2.get(["label", "baseline"]) || y4[c4], playPosition: H, prevBtnPosition: X, nextBtnPosition: q2, axisExtent: Pe, controlSize: T, controlGap: O };
    }, n2.prototype._position = function(e2, o) {
      var l4 = this._mainGroup, c4 = this._labelGroup, h = e2.viewRect;
      if (e2.orient === "vertical") {
        var p4 = Ny(), g4 = h.x, y4 = h.y + h.height;
        Y_(p4, p4, [-g4, -y4]), MT(p4, p4, -Kae / 2), Y_(p4, p4, [g4, y4]), h = h.clone(), h.applyTransform(p4);
      }
      var _ = H(h), w4 = H(l4.getBoundingRect()), C = H(c4.getBoundingRect()), E = [l4.x, l4.y], T = [c4.x, c4.y];
      T[0] = E[0] = _[0][0];
      var O = e2.labelPosOpt;
      if (O == null || xa(O)) {
        var N = O === "+" ? 0 : 1;
        X(E, w4, _, 1, N), X(T, C, _, 1, 1 - N);
      } else {
        var N = O >= 0 ? 0 : 1;
        X(E, w4, _, 1, N), T[1] = E[1] + O;
      }
      l4.setPosition(E), c4.setPosition(T), l4.rotation = c4.rotation = e2.rotation, V(l4), V(c4);
      function V(q2) {
        q2.originX = _[0][0] - q2.x, q2.originY = _[1][0] - q2.y;
      }
      function H(q2) {
        return [[q2.x, q2.x + q2.width], [q2.y, q2.y + q2.height]];
      }
      function X(q2, de, le, me, ye) {
        q2[me] += le[me][ye] - de[me][ye];
      }
    }, n2.prototype._createAxis = function(e2, o) {
      var l4 = o.getData(), c4 = o.get("axisType"), h = hMt(o, c4);
      h.getTicks = function() {
        return l4.mapArray(["value"], function(y4) {
          return { value: y4 };
        });
      };
      var p4 = l4.getDataExtent("value");
      h.setExtent(p4[0], p4[1]), h.calcNiceTicks();
      var g4 = new cMt("value", h, e2.axisExtent, c4);
      return g4.model = o, g4;
    }, n2.prototype._createGroup = function(e2) {
      var o = this[e2] = new Ti();
      return this.group.add(o), o;
    }, n2.prototype._renderAxisLine = function(e2, o, l4, c4) {
      var h = l4.getExtent();
      if (!!c4.get(["lineStyle", "show"])) {
        var p4 = new Vd({ shape: { x1: h[0], y1: 0, x2: h[1], y2: 0 }, style: rr({ lineCap: "round" }, c4.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
        o.add(p4);
        var g4 = this._progressLine = new Vd({ shape: { x1: h[0], x2: this._currentPointer ? this._currentPointer.x : h[0], y1: 0, y2: 0 }, style: hi({ lineCap: "round", lineWidth: p4.style.lineWidth }, c4.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
        o.add(g4);
      }
    }, n2.prototype._renderAxisTick = function(e2, o, l4, c4) {
      var h = this, p4 = c4.getData(), g4 = l4.scale.getTicks();
      this._tickSymbols = [], Ve(g4, function(y4) {
        var _ = l4.dataToCoord(y4.value), w4 = p4.getItemModel(y4.value), C = w4.getModel("itemStyle"), E = w4.getModel(["emphasis", "itemStyle"]), T = w4.getModel(["progress", "itemStyle"]), O = { x: _, y: 0, onclick: Ia(h._changeTimeline, h, y4.value) }, N = $Ae(w4, C, o, O);
        N.ensureState("emphasis").style = E.getItemStyle(), N.ensureState("progress").style = T.getItemStyle(), fT(N);
        var V = Fi(N);
        w4.get("tooltip") ? (V.dataIndex = y4.value, V.dataModel = c4) : V.dataIndex = V.dataModel = null, h._tickSymbols.push(N);
      });
    }, n2.prototype._renderAxisLabel = function(e2, o, l4, c4) {
      var h = this, p4 = l4.getLabelModel();
      if (!!p4.get("show")) {
        var g4 = c4.getData(), y4 = l4.getViewLabels();
        this._tickLabels = [], Ve(y4, function(_) {
          var w4 = _.tickValue, C = g4.getItemModel(w4), E = C.getModel("label"), T = C.getModel(["emphasis", "label"]), O = C.getModel(["progress", "label"]), N = l4.dataToCoord(_.tickValue), V = new Qs({ x: N, y: 0, rotation: e2.labelRotation - e2.rotation, onclick: Ia(h._changeTimeline, h, w4), silent: false, style: Ef(E, { text: _.formattedLabel, align: e2.labelAlign, verticalAlign: e2.labelBaseline }) });
          V.ensureState("emphasis").style = Ef(T), V.ensureState("progress").style = Ef(O), o.add(V), fT(V), HAe(V).dataIndex = w4, h._tickLabels.push(V);
        });
      }
    }, n2.prototype._renderControl = function(e2, o, l4, c4) {
      var h = e2.controlSize, p4 = e2.rotation, g4 = c4.getModel("controlStyle").getItemStyle(), y4 = c4.getModel(["emphasis", "controlStyle"]).getItemStyle(), _ = c4.getPlayState(), w4 = c4.get("inverse", true);
      C(e2.nextBtnPosition, "next", Ia(this._changeTimeline, this, w4 ? "-" : "+")), C(e2.prevBtnPosition, "prev", Ia(this._changeTimeline, this, w4 ? "+" : "-")), C(e2.playPosition, _ ? "stop" : "play", Ia(this._handlePlayClick, this, !_), true);
      function C(E, T, O, N) {
        if (!!E) {
          var V = ib(so(c4.get(["controlStyle", T + "BtnSize"]), h), h), H = [0, -V / 2, V, V], X = pMt(c4, T + "Icon", H, { x: E[0], y: E[1], originX: h / 2, originY: 0, rotation: N ? -p4 : 0, rectHover: true, style: g4, onclick: O });
          X.ensureState("emphasis").style = y4, o.add(X), fT(X);
        }
      }
    }, n2.prototype._renderCurrentPointer = function(e2, o, l4, c4) {
      var h = c4.getData(), p4 = c4.getCurrentIndex(), g4 = h.getItemModel(p4).getModel("checkpointStyle"), y4 = this, _ = { onCreate: function(w4) {
        w4.draggable = true, w4.drift = Ia(y4._handlePointerDrag, y4), w4.ondragend = Ia(y4._handlePointerDragend, y4), UAe(w4, y4._progressLine, p4, l4, c4, true);
      }, onUpdate: function(w4) {
        UAe(w4, y4._progressLine, p4, l4, c4);
      } };
      this._currentPointer = $Ae(g4, g4, this._mainGroup, {}, this._currentPointer, _);
    }, n2.prototype._handlePlayClick = function(e2) {
      this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: e2, from: this.uid });
    }, n2.prototype._handlePointerDrag = function(e2, o, l4) {
      this._clearTimer(), this._pointerChangeTimeline([l4.offsetX, l4.offsetY]);
    }, n2.prototype._handlePointerDragend = function(e2) {
      this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
    }, n2.prototype._pointerChangeTimeline = function(e2, o) {
      var l4 = this._toAxisCoord(e2)[0], c4 = this._axis, h = Ly(c4.getExtent().slice());
      l4 > h[1] && (l4 = h[1]), l4 < h[0] && (l4 = h[0]), this._currentPointer.x = l4, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = l4, this._progressLine.dirty();
      var p4 = this._findNearestTick(l4), g4 = this.model;
      (o || p4 !== g4.getCurrentIndex() && g4.get("realtime")) && this._changeTimeline(p4);
    }, n2.prototype._doPlayStop = function() {
      var e2 = this;
      this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
        var o = e2.model;
        e2._changeTimeline(o.getCurrentIndex() + (o.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval")));
    }, n2.prototype._toAxisCoord = function(e2) {
      var o = this._mainGroup.getLocalTransform();
      return ab(e2, o, true);
    }, n2.prototype._findNearestTick = function(e2) {
      var o = this.model.getData(), l4 = 1 / 0, c4, h = this._axis;
      return o.each(["value"], function(p4, g4) {
        var y4 = h.dataToCoord(p4), _ = Math.abs(y4 - e2);
        _ < l4 && (l4 = _, c4 = g4);
      }), c4;
    }, n2.prototype._clearTimer = function() {
      this._timer && (clearTimeout(this._timer), this._timer = null);
    }, n2.prototype._changeTimeline = function(e2) {
      var o = this.model.getCurrentIndex();
      e2 === "+" ? e2 = o + 1 : e2 === "-" && (e2 = o - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: e2, from: this.uid });
    }, n2.prototype._updateTicksStatus = function() {
      var e2 = this.model.getCurrentIndex(), o = this._tickSymbols, l4 = this._tickLabels;
      if (o)
        for (var c4 = 0; c4 < o.length; c4++)
          o && o[c4] && o[c4].toggleState("progress", c4 < e2);
      if (l4)
        for (var c4 = 0; c4 < l4.length; c4++)
          l4 && l4[c4] && l4[c4].toggleState("progress", HAe(l4[c4]).dataIndex <= e2);
    }, n2.type = "timeline.slider", n2;
  }(lMt);
  function hMt(i, n2) {
    if (n2 = n2 || i.get("type"), n2)
      switch (n2) {
        case "category":
          return new Cle({ ordinalMeta: i.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new eke({ locale: i.ecModel.getLocaleModel(), useUTC: i.ecModel.get("useUTC") });
        default:
          return new tM();
      }
  }
  function dMt(i, n2) {
    return bh(i.getBoxLayoutParams(), { width: n2.getWidth(), height: n2.getHeight() }, i.get("padding"));
  }
  function pMt(i, n2, e2, o) {
    var l4 = o.style, c4 = G8(i.get(["controlStyle", n2]), o || {}, new mo(e2[0], e2[1], e2[2], e2[3]));
    return l4 && c4.setStyle(l4), c4;
  }
  function $Ae(i, n2, e2, o, l4, c4) {
    var h = n2.get("color");
    if (l4)
      l4.setColor(h), e2.add(l4), c4 && c4.onUpdate(l4);
    else {
      var p4 = i.get("symbol");
      l4 = Xf(p4, -1, -1, 2, 2, h), l4.setStyle("strokeNoScale", true), e2.add(l4), c4 && c4.onCreate(l4);
    }
    var g4 = n2.getItemStyle(["color"]);
    l4.setStyle(g4), o = to({ rectHover: true, z2: 100 }, o, true);
    var y4 = U8(i.get("symbolSize"));
    o.scaleX = y4[0] / 2, o.scaleY = y4[1] / 2;
    var _ = nL(i.get("symbolOffset"), y4);
    _ && (o.x = (o.x || 0) + _[0], o.y = (o.y || 0) + _[1]);
    var w4 = i.get("symbolRotate");
    return o.rotation = (w4 || 0) * Math.PI / 180 || 0, l4.attr(o), l4.updateTransform(), l4;
  }
  function UAe(i, n2, e2, o, l4, c4) {
    if (!i.dragging) {
      var h = l4.getModel("checkpointStyle"), p4 = o.dataToCoord(l4.getData().get("value", e2));
      if (c4 || !h.get("animation", true))
        i.attr({ x: p4, y: 0 }), n2 && n2.attr({ shape: { x2: p4 } });
      else {
        var g4 = { duration: h.get("animationDuration", true), easing: h.get("animationEasing", true) };
        i.stopAnimation(null, true), i.animateTo({ x: p4, y: 0 }, g4), n2 && n2.animateTo({ shape: { x2: p4 } }, g4);
      }
    }
  }
  var vMt = fMt;
  function gMt(i) {
    i.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(n2, e2, o) {
      var l4 = e2.getComponent("timeline");
      return l4 && n2.currentIndex != null && (l4.setCurrentIndex(n2.currentIndex), !l4.get("loop", true) && l4.isIndexMax() && l4.getPlayState() && (l4.setPlayState(false), o.dispatchAction({ type: "timelinePlayChange", playState: false, from: n2.from }))), e2.resetOption("timeline", { replaceMerge: l4.get("replaceMerge", true) }), hi({ currentIndex: l4.option.currentIndex }, n2);
    }), i.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(n2, e2) {
      var o = e2.getComponent("timeline");
      o && n2.playState != null && o.setPlayState(n2.playState);
    });
  }
  function mMt(i) {
    var n2 = i && i.timeline;
    Mr(n2) || (n2 = n2 ? [n2] : []), Ve(n2, function(e2) {
      !e2 || yMt(e2);
    });
  }
  function yMt(i) {
    var n2 = i.type, e2 = { number: "value", time: "time" };
    if (e2[n2] && (i.axisType = e2[n2], delete i.type), qAe(i), tT(i, "controlPosition")) {
      var o = i.controlStyle || (i.controlStyle = {});
      tT(o, "position") || (o.position = i.controlPosition), o.position === "none" && !tT(o, "show") && (o.show = false, delete o.position), delete i.controlPosition;
    }
    Ve(i.data || [], function(l4) {
      mi(l4) && !Mr(l4) && (!tT(l4, "value") && tT(l4, "name") && (l4.value = l4.name), qAe(l4));
    });
  }
  function qAe(i) {
    var n2 = i.itemStyle || (i.itemStyle = {}), e2 = n2.emphasis || (n2.emphasis = {}), o = i.label || i.label || {}, l4 = o.normal || (o.normal = {}), c4 = { normal: 1, emphasis: 1 };
    Ve(o, function(h, p4) {
      !c4[p4] && !tT(l4, p4) && (l4[p4] = h);
    }), e2.label && !tT(o, "emphasis") && (o.emphasis = e2.label, delete e2.label);
  }
  function tT(i, n2) {
    return i.hasOwnProperty(n2);
  }
  function bMt(i) {
    i.registerComponentModel(oMt), i.registerComponentView(vMt), i.registerSubTypeDefaulter("timeline", function() {
      return "slider";
    }), gMt(i), i.registerPreprocessor(mMt);
  }
  function Mue(i, n2) {
    if (!i)
      return false;
    for (var e2 = Mr(i) ? i : [i], o = 0; o < e2.length; o++)
      if (e2[o] && e2[o][n2])
        return true;
    return false;
  }
  function FW(i) {
    mT(i, "label", ["show"]);
  }
  var NW = zs(), K3e = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.createdBySelf = false, e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      this.mergeDefaultAndTheme(e2, l4), this._mergeOption(e2, l4, false, true);
    }, n2.prototype.isAnimationEnabled = function() {
      if (ol.node)
        return false;
      var e2 = this.__hostSeries;
      return this.getShallow("animation") && e2 && e2.isAnimationEnabled();
    }, n2.prototype.mergeOption = function(e2, o) {
      this._mergeOption(e2, o, false, false);
    }, n2.prototype._mergeOption = function(e2, o, l4, c4) {
      var h = this.mainType;
      l4 || o.eachSeries(function(p4) {
        var g4 = p4.get(this.mainType, true), y4 = NW(p4)[h];
        if (!g4 || !g4.data) {
          NW(p4)[h] = null;
          return;
        }
        y4 ? y4._mergeOption(g4, o, true) : (c4 && FW(g4), Ve(g4.data, function(_) {
          _ instanceof Array ? (FW(_[0]), FW(_[1])) : FW(_);
        }), y4 = this.createMarkerModelFromSeries(g4, this, o), rr(y4, { mainType: this.mainType, seriesIndex: p4.seriesIndex, name: p4.name, createdBySelf: true }), y4.__hostSeries = p4), NW(p4)[h] = y4;
      }, this);
    }, n2.prototype.formatTooltip = function(e2, o, l4) {
      var c4 = this.getData(), h = this.getRawValue(e2), p4 = c4.getName(e2);
      return Qh("section", { header: this.name, blocks: [Qh("nameValue", { name: p4, value: h, noName: !p4, noValue: h == null })] });
    }, n2.prototype.getData = function() {
      return this._data;
    }, n2.prototype.setData = function(e2) {
      this._data = e2;
    }, n2.getMarkerModelFromSeries = function(e2, o) {
      return NW(e2)[o];
    }, n2.type = "marker", n2.dependencies = ["series", "grid", "polar", "geo"], n2;
  }(Ns);
  Kf(K3e, hle.prototype);
  var aM = K3e, _Mt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.createMarkerModelFromSeries = function(e2, o, l4) {
      return new n2(e2, o, l4);
    }, n2.type = "markPoint", n2.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, n2;
  }(aM), xMt = _Mt;
  function wMt(i) {
    return !(isNaN(parseFloat(i.x)) && isNaN(parseFloat(i.y)));
  }
  function SMt(i) {
    return !isNaN(parseFloat(i.x)) && !isNaN(parseFloat(i.y));
  }
  function VW(i, n2, e2, o, l4, c4) {
    var h = [], p4 = eM(n2, o), g4 = p4 ? n2.getCalculationInfo("stackResultDimension") : o, y4 = Aue(n2, g4, i), _ = n2.indicesOfNearest(g4, y4)[0];
    h[l4] = n2.get(e2, _), h[c4] = n2.get(g4, _);
    var w4 = n2.get(o, _), C = z_(n2.get(o, _));
    return C = Math.min(C, 20), C >= 0 && (h[c4] = +h[c4].toFixed(C)), [h, w4];
  }
  var Jae = { min: zi(VW, "min"), max: zi(VW, "max"), average: zi(VW, "average"), median: zi(VW, "median") };
  function k8(i, n2) {
    var e2 = i.getData(), o = i.coordinateSystem;
    if (n2 && !SMt(n2) && !Mr(n2.coord) && o) {
      var l4 = o.dimensions, c4 = J3e(n2, e2, o, i);
      if (n2 = Ci(n2), n2.type && Jae[n2.type] && c4.baseAxis && c4.valueAxis) {
        var h = go(l4, c4.baseAxis.dim), p4 = go(l4, c4.valueAxis.dim), g4 = Jae[n2.type](e2, c4.baseDataDim, c4.valueDataDim, h, p4);
        n2.coord = g4[0], n2.value = g4[1];
      } else {
        for (var y4 = [n2.xAxis != null ? n2.xAxis : n2.radiusAxis, n2.yAxis != null ? n2.yAxis : n2.angleAxis], _ = 0; _ < 2; _++)
          Jae[y4[_]] && (y4[_] = Aue(e2, e2.mapDimension(l4[_]), y4[_]));
        n2.coord = y4;
      }
    }
    return n2;
  }
  function J3e(i, n2, e2, o) {
    var l4 = {};
    return i.valueIndex != null || i.valueDim != null ? (l4.valueDataDim = i.valueIndex != null ? n2.getDimension(i.valueIndex) : i.valueDim, l4.valueAxis = e2.getAxis(CMt(o, l4.valueDataDim)), l4.baseAxis = e2.getOtherAxis(l4.valueAxis), l4.baseDataDim = n2.mapDimension(l4.baseAxis.dim)) : (l4.baseAxis = o.getBaseAxis(), l4.valueAxis = e2.getOtherAxis(l4.baseAxis), l4.baseDataDim = n2.mapDimension(l4.baseAxis.dim), l4.valueDataDim = n2.mapDimension(l4.valueAxis.dim)), l4;
  }
  function CMt(i, n2) {
    var e2 = i.getData().getDimensionInfo(n2);
    return e2 && e2.coordDim;
  }
  function P8(i, n2) {
    return i && i.containData && n2.coord && !wMt(n2) ? i.containData(n2.coord) : true;
  }
  function Q3e(i, n2) {
    return i ? function(e2, o, l4, c4) {
      var h = c4 < 2 ? e2.coord && e2.coord[c4] : e2.value;
      return YC(h, n2[c4]);
    } : function(e2, o, l4, c4) {
      return YC(e2.value, n2[c4]);
    };
  }
  function Aue(i, n2, e2) {
    if (e2 === "average") {
      var o = 0, l4 = 0;
      return i.each(n2, function(c4, h) {
        isNaN(c4) || (o += c4, l4++);
      }), o / l4;
    } else
      return e2 === "median" ? i.getMedian(n2) : i.getDataExtent(n2)[e2 === "max" ? 1 : 0];
  }
  var Qae = zs(), MMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.init = function() {
      this.markerGroupMap = ri();
    }, n2.prototype.render = function(e2, o, l4) {
      var c4 = this, h = this.markerGroupMap;
      h.each(function(p4) {
        Qae(p4).keep = false;
      }), o.eachSeries(function(p4) {
        var g4 = aM.getMarkerModelFromSeries(p4, c4.type);
        g4 && c4.renderSeries(p4, g4, o, l4);
      }), h.each(function(p4) {
        !Qae(p4).keep && c4.group.remove(p4.group);
      });
    }, n2.prototype.markKeep = function(e2) {
      Qae(e2).keep = true;
    }, n2.prototype.blurSeries = function(e2) {
      var o = this;
      Ve(e2, function(l4) {
        var c4 = aM.getMarkerModelFromSeries(l4, o.type);
        if (c4) {
          var h = c4.getData();
          h.eachItemGraphicEl(function(p4) {
            p4 && ATe(p4);
          });
        }
      });
    }, n2.type = "marker", n2;
  }($c), Eue = MMt;
  function YAe(i, n2, e2) {
    var o = n2.coordinateSystem;
    i.each(function(l4) {
      var c4 = i.getItemModel(l4), h, p4 = ma(c4.get("x"), e2.getWidth()), g4 = ma(c4.get("y"), e2.getHeight());
      if (!isNaN(p4) && !isNaN(g4))
        h = [p4, g4];
      else if (n2.getMarkerPosition)
        h = n2.getMarkerPosition(i.getValues(i.dimensions, l4));
      else if (o) {
        var y4 = i.get(o.dimensions[0], l4), _ = i.get(o.dimensions[1], l4);
        h = o.dataToPoint([y4, _]);
      }
      isNaN(p4) || (h[0] = p4), isNaN(g4) || (h[1] = g4), i.setItemLayout(l4, h);
    });
  }
  var AMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.updateTransform = function(e2, o, l4) {
      o.eachSeries(function(c4) {
        var h = aM.getMarkerModelFromSeries(c4, "markPoint");
        h && (YAe(h.getData(), c4, l4), this.markerGroupMap.get(c4.id).updateLayout());
      }, this);
    }, n2.prototype.renderSeries = function(e2, o, l4, c4) {
      var h = e2.coordinateSystem, p4 = e2.id, g4 = e2.getData(), y4 = this.markerGroupMap, _ = y4.get(p4) || y4.set(p4, new K8()), w4 = EMt(h, e2, o);
      o.setData(w4), YAe(o.getData(), e2, c4), w4.each(function(C) {
        var E = w4.getItemModel(C), T = E.getShallow("symbol"), O = E.getShallow("symbolSize"), N = E.getShallow("symbolRotate"), V = E.getShallow("symbolOffset"), H = E.getShallow("symbolKeepAspect");
        if (si(T) || si(O) || si(N) || si(V)) {
          var X = o.getRawValue(C), q2 = o.getDataParams(C);
          si(T) && (T = T(X, q2)), si(O) && (O = O(X, q2)), si(N) && (N = N(X, q2)), si(V) && (V = V(X, q2));
        }
        var de = E.getModel("itemStyle").getItemStyle(), le = $8(g4, "color");
        de.fill || (de.fill = le), w4.setItemVisual(C, { symbol: T, symbolSize: O, symbolRotate: N, symbolOffset: V, symbolKeepAspect: H, style: de });
      }), _.updateData(w4), this.group.add(_.group), w4.eachItemGraphicEl(function(C) {
        C.traverse(function(E) {
          Fi(E).dataModel = o;
        });
      }), this.markKeep(_), _.group.silent = o.get("silent") || e2.get("silent");
    }, n2.type = "markPoint", n2;
  }(Eue);
  function EMt(i, n2, e2) {
    var o;
    i ? o = Er(i && i.dimensions, function(p4) {
      var g4 = n2.getData().getDimensionInfo(n2.getData().mapDimension(p4)) || {};
      return rr(rr({}, g4), { name: p4, ordinalMeta: null });
    }) : o = [{ name: "value", type: "float" }];
    var l4 = new Xv(o, e2), c4 = Er(e2.get("data"), zi(k8, n2));
    i && (c4 = Yl(c4, zi(P8, i)));
    var h = Q3e(!!i, o);
    return l4.initData(c4, null, h), l4;
  }
  var IMt = AMt;
  function TMt(i) {
    i.registerComponentModel(xMt), i.registerComponentView(IMt), i.registerPreprocessor(function(n2) {
      Mue(n2.series, "markPoint") && (n2.markPoint = n2.markPoint || {});
    });
  }
  var DMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.createMarkerModelFromSeries = function(e2, o, l4) {
      return new n2(e2, o, l4);
    }, n2.type = "markLine", n2.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, n2;
  }(aM), kMt = DMt, zW = zs(), PMt = function(i, n2, e2, o) {
    var l4 = i.getData(), c4;
    if (Mr(o))
      c4 = o;
    else {
      var h = o.type;
      if (h === "min" || h === "max" || h === "average" || h === "median" || o.xAxis != null || o.yAxis != null) {
        var p4 = void 0, g4 = void 0;
        if (o.yAxis != null || o.xAxis != null)
          p4 = n2.getAxis(o.yAxis != null ? "y" : "x"), g4 = Nd(o.yAxis, o.xAxis);
        else {
          var y4 = J3e(o, l4, n2, i);
          p4 = y4.valueAxis;
          var _ = B5e(l4, y4.valueDataDim);
          g4 = Aue(l4, _, h);
        }
        var w4 = p4.dim === "x" ? 0 : 1, C = 1 - w4, E = Ci(o), T = { coord: [] };
        E.type = null, E.coord = [], E.coord[C] = -1 / 0, T.coord[C] = 1 / 0;
        var O = e2.get("precision");
        O >= 0 && sl(g4) && (g4 = +g4.toFixed(Math.min(O, 20))), E.coord[w4] = T.coord[w4] = g4, c4 = [E, T, { type: h, valueIndex: o.valueIndex, value: g4 }];
      } else
        c4 = [];
    }
    var N = [k8(i, c4[0]), k8(i, c4[1]), rr({}, c4[2])];
    return N[2].type = N[2].type || null, to(N[2], N[0]), to(N[2], N[1]), N;
  };
  function a$(i) {
    return !isNaN(i) && !isFinite(i);
  }
  function ZAe(i, n2, e2, o) {
    var l4 = 1 - i, c4 = o.dimensions[i];
    return a$(n2[l4]) && a$(e2[l4]) && n2[i] === e2[i] && o.getAxis(c4).containData(n2[i]);
  }
  function LMt(i, n2) {
    if (i.type === "cartesian2d") {
      var e2 = n2[0].coord, o = n2[1].coord;
      if (e2 && o && (ZAe(1, e2, o, i) || ZAe(0, e2, o, i)))
        return true;
    }
    return P8(i, n2[0]) && P8(i, n2[1]);
  }
  function eie(i, n2, e2, o, l4) {
    var c4 = o.coordinateSystem, h = i.getItemModel(n2), p4, g4 = ma(h.get("x"), l4.getWidth()), y4 = ma(h.get("y"), l4.getHeight());
    if (!isNaN(g4) && !isNaN(y4))
      p4 = [g4, y4];
    else {
      if (o.getMarkerPosition)
        p4 = o.getMarkerPosition(i.getValues(i.dimensions, n2));
      else {
        var _ = c4.dimensions, w4 = i.get(_[0], n2), C = i.get(_[1], n2);
        p4 = c4.dataToPoint([w4, C]);
      }
      if (v22(c4, "cartesian2d")) {
        var E = c4.getAxis("x"), T = c4.getAxis("y"), _ = c4.dimensions;
        a$(i.get(_[0], n2)) ? p4[0] = E.toGlobalCoord(E.getExtent()[e2 ? 0 : 1]) : a$(i.get(_[1], n2)) && (p4[1] = T.toGlobalCoord(T.getExtent()[e2 ? 0 : 1]));
      }
      isNaN(g4) || (p4[0] = g4), isNaN(y4) || (p4[1] = y4);
    }
    i.setItemLayout(n2, p4);
  }
  var OMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.updateTransform = function(e2, o, l4) {
      o.eachSeries(function(c4) {
        var h = aM.getMarkerModelFromSeries(c4, "markLine");
        if (h) {
          var p4 = h.getData(), g4 = zW(h).from, y4 = zW(h).to;
          g4.each(function(_) {
            eie(g4, _, true, c4, l4), eie(y4, _, false, c4, l4);
          }), p4.each(function(_) {
            p4.setItemLayout(_, [g4.getItemLayout(_), y4.getItemLayout(_)]);
          }), this.markerGroupMap.get(c4.id).updateLayout();
        }
      }, this);
    }, n2.prototype.renderSeries = function(e2, o, l4, c4) {
      var h = e2.coordinateSystem, p4 = e2.id, g4 = e2.getData(), y4 = this.markerGroupMap, _ = y4.get(p4) || y4.set(p4, new Xle());
      this.group.add(_.group);
      var w4 = RMt(h, e2, o), C = w4.from, E = w4.to, T = w4.line;
      zW(o).from = C, zW(o).to = E, o.setData(T);
      var O = o.get("symbol"), N = o.get("symbolSize"), V = o.get("symbolRotate"), H = o.get("symbolOffset");
      Mr(O) || (O = [O, O]), Mr(N) || (N = [N, N]), Mr(V) || (V = [V, V]), Mr(H) || (H = [H, H]), w4.from.each(function(q2) {
        X(C, q2, true), X(E, q2, false);
      }), T.each(function(q2) {
        var de = T.getItemModel(q2).getModel("lineStyle").getLineStyle();
        T.setItemLayout(q2, [C.getItemLayout(q2), E.getItemLayout(q2)]), de.stroke == null && (de.stroke = C.getItemVisual(q2, "style").fill), T.setItemVisual(q2, { fromSymbolKeepAspect: C.getItemVisual(q2, "symbolKeepAspect"), fromSymbolOffset: C.getItemVisual(q2, "symbolOffset"), fromSymbolRotate: C.getItemVisual(q2, "symbolRotate"), fromSymbolSize: C.getItemVisual(q2, "symbolSize"), fromSymbol: C.getItemVisual(q2, "symbol"), toSymbolKeepAspect: E.getItemVisual(q2, "symbolKeepAspect"), toSymbolOffset: E.getItemVisual(q2, "symbolOffset"), toSymbolRotate: E.getItemVisual(q2, "symbolRotate"), toSymbolSize: E.getItemVisual(q2, "symbolSize"), toSymbol: E.getItemVisual(q2, "symbol"), style: de });
      }), _.updateData(T), w4.line.eachItemGraphicEl(function(q2, de) {
        q2.traverse(function(le) {
          Fi(le).dataModel = o;
        });
      });
      function X(q2, de, le) {
        var me = q2.getItemModel(de);
        eie(q2, de, le, e2, c4);
        var ye = me.getModel("itemStyle").getItemStyle();
        ye.fill == null && (ye.fill = $8(g4, "color")), q2.setItemVisual(de, { symbolKeepAspect: me.get("symbolKeepAspect"), symbolOffset: so(me.get("symbolOffset", true), H[le ? 0 : 1]), symbolRotate: so(me.get("symbolRotate", true), V[le ? 0 : 1]), symbolSize: so(me.get("symbolSize"), N[le ? 0 : 1]), symbol: so(me.get("symbol", true), O[le ? 0 : 1]), style: ye });
      }
      this.markKeep(_), _.group.silent = o.get("silent") || e2.get("silent");
    }, n2.type = "markLine", n2;
  }(Eue);
  function RMt(i, n2, e2) {
    var o;
    i ? o = Er(i && i.dimensions, function(y4) {
      var _ = n2.getData().getDimensionInfo(n2.getData().mapDimension(y4)) || {};
      return rr(rr({}, _), { name: y4, ordinalMeta: null });
    }) : o = [{ name: "value", type: "float" }];
    var l4 = new Xv(o, e2), c4 = new Xv(o, e2), h = new Xv([], e2), p4 = Er(e2.get("data"), zi(PMt, n2, i, e2));
    i && (p4 = Yl(p4, zi(LMt, i)));
    var g4 = Q3e(!!i, o);
    return l4.initData(Er(p4, function(y4) {
      return y4[0];
    }), null, g4), c4.initData(Er(p4, function(y4) {
      return y4[1];
    }), null, g4), h.initData(Er(p4, function(y4) {
      return y4[2];
    })), h.hasItemOption = true, { from: l4, to: c4, line: h };
  }
  var FMt = OMt;
  function NMt(i) {
    i.registerComponentModel(kMt), i.registerComponentView(FMt), i.registerPreprocessor(function(n2) {
      Mue(n2.series, "markLine") && (n2.markLine = n2.markLine || {});
    });
  }
  var VMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.createMarkerModelFromSeries = function(e2, o, l4) {
      return new n2(e2, o, l4);
    }, n2.type = "markArea", n2.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, n2;
  }(aM), zMt = VMt, BW = zs(), BMt = function(i, n2, e2, o) {
    var l4 = k8(i, o[0]), c4 = k8(i, o[1]), h = l4.coord, p4 = c4.coord;
    h[0] = Nd(h[0], -1 / 0), h[1] = Nd(h[1], -1 / 0), p4[0] = Nd(p4[0], 1 / 0), p4[1] = Nd(p4[1], 1 / 0);
    var g4 = Dse([{}, l4, c4]);
    return g4.coord = [l4.coord, c4.coord], g4.x0 = l4.x, g4.y0 = l4.y, g4.x1 = c4.x, g4.y1 = c4.y, g4;
  };
  function i$(i) {
    return !isNaN(i) && !isFinite(i);
  }
  function XAe(i, n2, e2, o) {
    var l4 = 1 - i;
    return i$(n2[l4]) && i$(e2[l4]);
  }
  function jMt(i, n2) {
    var e2 = n2.coord[0], o = n2.coord[1];
    return v22(i, "cartesian2d") && e2 && o && (XAe(1, e2, o) || XAe(0, e2, o)) ? true : P8(i, { coord: e2, x: n2.x0, y: n2.y0 }) || P8(i, { coord: o, x: n2.x1, y: n2.y1 });
  }
  function KAe(i, n2, e2, o, l4) {
    var c4 = o.coordinateSystem, h = i.getItemModel(n2), p4, g4 = ma(h.get(e2[0]), l4.getWidth()), y4 = ma(h.get(e2[1]), l4.getHeight());
    if (!isNaN(g4) && !isNaN(y4))
      p4 = [g4, y4];
    else {
      if (o.getMarkerPosition)
        p4 = o.getMarkerPosition(i.getValues(e2, n2));
      else {
        var _ = i.get(e2[0], n2), w4 = i.get(e2[1], n2), C = [_, w4];
        c4.clampData && c4.clampData(C, C), p4 = c4.dataToPoint(C, true);
      }
      if (v22(c4, "cartesian2d")) {
        var E = c4.getAxis("x"), T = c4.getAxis("y"), _ = i.get(e2[0], n2), w4 = i.get(e2[1], n2);
        i$(_) ? p4[0] = E.toGlobalCoord(E.getExtent()[e2[0] === "x0" ? 0 : 1]) : i$(w4) && (p4[1] = T.toGlobalCoord(T.getExtent()[e2[1] === "y0" ? 0 : 1]));
      }
      isNaN(g4) || (p4[0] = g4), isNaN(y4) || (p4[1] = y4);
    }
    return p4;
  }
  var JAe = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], GMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.updateTransform = function(e2, o, l4) {
      o.eachSeries(function(c4) {
        var h = aM.getMarkerModelFromSeries(c4, "markArea");
        if (h) {
          var p4 = h.getData();
          p4.each(function(g4) {
            var y4 = Er(JAe, function(w4) {
              return KAe(p4, g4, w4, c4, l4);
            });
            p4.setItemLayout(g4, y4);
            var _ = p4.getItemGraphicEl(g4);
            _.setShape("points", y4);
          });
        }
      }, this);
    }, n2.prototype.renderSeries = function(e2, o, l4, c4) {
      var h = e2.coordinateSystem, p4 = e2.id, g4 = e2.getData(), y4 = this.markerGroupMap, _ = y4.get(p4) || y4.set(p4, { group: new Ti() });
      this.group.add(_.group), this.markKeep(_);
      var w4 = WMt(h, e2, o);
      o.setData(w4), w4.each(function(C) {
        var E = Er(JAe, function(ye) {
          return KAe(w4, C, ye, e2, c4);
        }), T = h.getAxis("x").scale, O = h.getAxis("y").scale, N = T.getExtent(), V = O.getExtent(), H = [T.parse(w4.get("x0", C)), T.parse(w4.get("x1", C))], X = [O.parse(w4.get("y0", C)), O.parse(w4.get("y1", C))];
        Ly(H), Ly(X);
        var q2 = !(N[0] > H[1] || N[1] < H[0] || V[0] > X[1] || V[1] < X[0]), de = !q2;
        w4.setItemLayout(C, { points: E, allClipped: de });
        var le = w4.getItemModel(C).getModel("itemStyle").getItemStyle(), me = $8(g4, "color");
        le.fill || (le.fill = me, xa(le.fill) && (le.fill = bH(le.fill, 0.4))), le.stroke || (le.stroke = me), w4.setItemVisual(C, "style", le);
      }), w4.diff(BW(_).data).add(function(C) {
        var E = w4.getItemLayout(C);
        if (!E.allClipped) {
          var T = new $g({ shape: { points: E.points } });
          w4.setItemGraphicEl(C, T), _.group.add(T);
        }
      }).update(function(C, E) {
        var T = BW(_).data.getItemGraphicEl(E), O = w4.getItemLayout(C);
        O.allClipped ? T && _.group.remove(T) : (T ? Vs(T, { shape: { points: O.points } }, o, C) : T = new $g({ shape: { points: O.points } }), w4.setItemGraphicEl(C, T), _.group.add(T));
      }).remove(function(C) {
        var E = BW(_).data.getItemGraphicEl(C);
        _.group.remove(E);
      }).execute(), w4.eachItemGraphicEl(function(C, E) {
        var T = w4.getItemModel(E), O = w4.getItemVisual(E, "style");
        C.useStyle(w4.getItemVisual(E, "style")), yv(C, zd(T), { labelFetcher: o, labelDataIndex: E, defaultText: w4.getName(E) || "", inheritColor: xa(O.fill) ? bH(O.fill, 1) : "#000" }), Mp(C, T), pf(C, null, null, T.get(["emphasis", "disabled"])), Fi(C).dataModel = o;
      }), BW(_).data = w4, _.group.silent = o.get("silent") || e2.get("silent");
    }, n2.type = "markArea", n2;
  }(Eue);
  function WMt(i, n2, e2) {
    var o, l4, c4 = ["x0", "y0", "x1", "y1"];
    if (i) {
      var h = Er(i && i.dimensions, function(y4) {
        var _ = n2.getData(), w4 = _.getDimensionInfo(_.mapDimension(y4)) || {};
        return rr(rr({}, w4), { name: y4, ordinalMeta: null });
      });
      l4 = Er(c4, function(y4, _) {
        return { name: y4, type: h[_ % 2].type };
      }), o = new Xv(l4, e2);
    } else
      l4 = [{ name: "value", type: "float" }], o = new Xv(l4, e2);
    var p4 = Er(e2.get("data"), zi(BMt, n2, i, e2));
    i && (p4 = Yl(p4, zi(jMt, i)));
    var g4 = i ? function(y4, _, w4, C) {
      var E = y4.coord[Math.floor(C / 2)][C % 2];
      return YC(E, l4[C]);
    } : function(y4, _, w4, C) {
      return YC(y4.value, l4[C]);
    };
    return o.initData(p4, null, g4), o.hasItemOption = true, o;
  }
  var HMt = GMt;
  function $Mt(i) {
    i.registerComponentModel(zMt), i.registerComponentView(HMt), i.registerPreprocessor(function(n2) {
      Mue(n2.series, "markArea") && (n2.markArea = n2.markArea || {});
    });
  }
  var UMt = function(i, n2) {
    if (n2 === "all")
      return { type: "all", title: i.getLocaleModel().get(["legend", "selector", "all"]) };
    if (n2 === "inverse")
      return { type: "inverse", title: i.getLocaleModel().get(["legend", "selector", "inverse"]) };
  }, qMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.layoutMode = { type: "box", ignoreSize: true }, e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      this.mergeDefaultAndTheme(e2, l4), e2.selected = e2.selected || {}, this._updateSelector(e2);
    }, n2.prototype.mergeOption = function(e2, o) {
      i.prototype.mergeOption.call(this, e2, o), this._updateSelector(e2);
    }, n2.prototype._updateSelector = function(e2) {
      var o = e2.selector, l4 = this.ecModel;
      o === true && (o = e2.selector = ["all", "inverse"]), Mr(o) && Ve(o, function(c4, h) {
        xa(c4) && (c4 = { type: c4 }), o[h] = to(c4, UMt(l4, c4.type));
      });
    }, n2.prototype.optionUpdated = function() {
      this._updateData(this.ecModel);
      var e2 = this._data;
      if (e2[0] && this.get("selectedMode") === "single") {
        for (var o = false, l4 = 0; l4 < e2.length; l4++) {
          var c4 = e2[l4].get("name");
          if (this.isSelected(c4)) {
            this.select(c4), o = true;
            break;
          }
        }
        !o && this.select(e2[0].get("name"));
      }
    }, n2.prototype._updateData = function(e2) {
      var o = [], l4 = [];
      e2.eachRawSeries(function(p4) {
        var g4 = p4.name;
        l4.push(g4);
        var y4;
        if (p4.legendVisualProvider) {
          var _ = p4.legendVisualProvider, w4 = _.getAllNames();
          e2.isSeriesFiltered(p4) || (l4 = l4.concat(w4)), w4.length ? o = o.concat(w4) : y4 = true;
        } else
          y4 = true;
        y4 && Bse(p4) && o.push(p4.name);
      }), this._availableNames = l4;
      var c4 = this.get("data") || o, h = Er(c4, function(p4) {
        return (xa(p4) || sl(p4)) && (p4 = { name: p4 }), new Ou(p4, this, this.ecModel);
      }, this);
      this._data = h;
    }, n2.prototype.getData = function() {
      return this._data;
    }, n2.prototype.select = function(e2) {
      var o = this.option.selected, l4 = this.get("selectedMode");
      if (l4 === "single") {
        var c4 = this._data;
        Ve(c4, function(h) {
          o[h.get("name")] = false;
        });
      }
      o[e2] = true;
    }, n2.prototype.unSelect = function(e2) {
      this.get("selectedMode") !== "single" && (this.option.selected[e2] = false);
    }, n2.prototype.toggleSelected = function(e2) {
      var o = this.option.selected;
      o.hasOwnProperty(e2) || (o[e2] = true), this[o[e2] ? "unSelect" : "select"](e2);
    }, n2.prototype.allSelect = function() {
      var e2 = this._data, o = this.option.selected;
      Ve(e2, function(l4) {
        o[l4.get("name", true)] = true;
      });
    }, n2.prototype.inverseSelect = function() {
      var e2 = this._data, o = this.option.selected;
      Ve(e2, function(l4) {
        var c4 = l4.get("name", true);
        o.hasOwnProperty(c4) || (o[c4] = true), o[c4] = !o[c4];
      });
    }, n2.prototype.isSelected = function(e2) {
      var o = this.option.selected;
      return !(o.hasOwnProperty(e2) && !o[e2]) && go(this._availableNames, e2) >= 0;
    }, n2.prototype.getOrient = function() {
      return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
    }, n2.type = "legend.plain", n2.dependencies = ["series"], n2.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, n2;
  }(Ns), ese = qMt, s3 = zi, tse = Ve, jW = Ti, YMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.newlineDisabled = false, e2;
    }
    return n2.prototype.init = function() {
      this.group.add(this._contentGroup = new jW()), this.group.add(this._selectorGroup = new jW()), this._isFirstRender = true;
    }, n2.prototype.getContentGroup = function() {
      return this._contentGroup;
    }, n2.prototype.getSelectorGroup = function() {
      return this._selectorGroup;
    }, n2.prototype.render = function(e2, o, l4) {
      var c4 = this._isFirstRender;
      if (this._isFirstRender = false, this.resetInner(), !!e2.get("show", true)) {
        var h = e2.get("align"), p4 = e2.get("orient");
        (!h || h === "auto") && (h = e2.get("left") === "right" && p4 === "vertical" ? "right" : "left");
        var g4 = e2.get("selector", true), y4 = e2.get("selectorPosition", true);
        g4 && (!y4 || y4 === "auto") && (y4 = p4 === "horizontal" ? "end" : "start"), this.renderInner(h, e2, o, l4, g4, p4, y4);
        var _ = e2.getBoxLayoutParams(), w4 = { width: l4.getWidth(), height: l4.getHeight() }, C = e2.get("padding"), E = bh(_, w4, C), T = this.layoutInner(e2, h, E, c4, g4, y4), O = bh(hi({ width: T.width, height: T.height }, _), w4, C);
        this.group.x = O.x - T.x, this.group.y = O.y - T.y, this.group.markRedraw(), this.group.add(this._backgroundEl = j3e(T, e2));
      }
    }, n2.prototype.resetInner = function() {
      this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
    }, n2.prototype.renderInner = function(e2, o, l4, c4, h, p4, g4) {
      var y4 = this.getContentGroup(), _ = ri(), w4 = o.get("selectedMode"), C = [];
      l4.eachRawSeries(function(E) {
        !E.get("legendHoverLink") && C.push(E.id);
      }), tse(o.getData(), function(E, T) {
        var O = E.get("name");
        if (!this.newlineDisabled && (O === "" || O === `
`)) {
          var N = new jW();
          N.newline = true, y4.add(N);
          return;
        }
        var V = l4.getSeriesByName(O)[0];
        if (!_.get(O))
          if (V) {
            var H = V.getData(), X = H.getVisual("legendLineStyle") || {}, q2 = H.getVisual("legendIcon"), de = H.getVisual("style"), le = this._createItem(V, O, T, E, o, e2, X, de, q2, w4);
            le.on("click", s3(QAe, O, null, c4, C)).on("mouseover", s3(nse, V.name, null, c4, C)).on("mouseout", s3(rse, V.name, null, c4, C)), _.set(O, true);
          } else
            l4.eachRawSeries(function(me) {
              if (!_.get(O) && me.legendVisualProvider) {
                var ye = me.legendVisualProvider;
                if (!ye.containName(O))
                  return;
                var be = ye.indexOfName(O), we = ye.getItemVisual(be, "style"), Pe = ye.getItemVisual(be, "legendIcon"), ze = nm(we.fill);
                ze && ze[3] === 0 && (ze[3] = 0.2, we = rr(rr({}, we), { fill: d2(ze, "rgba") }));
                var Re = this._createItem(me, O, T, E, o, e2, {}, we, Pe, w4);
                Re.on("click", s3(QAe, null, O, c4, C)).on("mouseover", s3(nse, null, O, c4, C)).on("mouseout", s3(rse, null, O, c4, C)), _.set(O, true);
              }
            }, this);
      }, this), h && this._createSelector(h, o, c4, p4, g4);
    }, n2.prototype._createSelector = function(e2, o, l4, c4, h) {
      var p4 = this.getSelectorGroup();
      tse(e2, function(y4) {
        var _ = y4.type, w4 = new Qs({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
          l4.dispatchAction({ type: _ === "all" ? "legendAllSelect" : "legendInverseSelect" });
        } });
        p4.add(w4);
        var C = o.getModel("selectorLabel"), E = o.getModel(["emphasis", "selectorLabel"]);
        yv(w4, { normal: C, emphasis: E }, { defaultText: y4.title }), fT(w4);
      });
    }, n2.prototype._createItem = function(e2, o, l4, c4, h, p4, g4, y4, _, w4) {
      var C = e2.visualDrawType, E = h.get("itemWidth"), T = h.get("itemHeight"), O = h.isSelected(o), N = c4.get("symbolRotate"), V = c4.get("symbolKeepAspect"), H = c4.get("icon");
      _ = H || _ || "roundRect";
      var X = ZMt(_, c4, g4, y4, C, O), q2 = new jW(), de = c4.getModel("textStyle");
      if (si(e2.getLegendIcon) && (!H || H === "inherit"))
        q2.add(e2.getLegendIcon({ itemWidth: E, itemHeight: T, icon: _, iconRotate: N, itemStyle: X.itemStyle, lineStyle: X.lineStyle, symbolKeepAspect: V }));
      else {
        var le = H === "inherit" && e2.getData().getVisual("symbol") ? N === "inherit" ? e2.getData().getVisual("symbolRotate") : N : 0;
        q2.add(XMt({ itemWidth: E, itemHeight: T, icon: _, iconRotate: le, itemStyle: X.itemStyle, lineStyle: X.lineStyle, symbolKeepAspect: V }));
      }
      var me = p4 === "left" ? E + 5 : -5, ye = p4, be = h.get("formatter"), we = o;
      xa(be) && be ? we = be.replace("{name}", o != null ? o : "") : si(be) && (we = be(o));
      var Pe = c4.get("inactiveColor");
      q2.add(new Qs({ style: Ef(de, { text: we, x: me, y: T / 2, fill: O ? de.getTextColor() : Pe, align: ye, verticalAlign: "middle" }) }));
      var ze = new Is({ shape: q2.getBoundingRect(), invisible: true }), Re = c4.getModel("tooltip");
      return Re.get("show") && q3({ el: ze, componentModel: h, itemName: o, itemTooltipOption: Re.option }), q2.add(ze), q2.eachChild(function(rt2) {
        rt2.silent = true;
      }), ze.silent = !w4, this.getContentGroup().add(q2), fT(q2), q2.__legendDataIndex = l4, q2;
    }, n2.prototype.layoutInner = function(e2, o, l4, c4, h, p4) {
      var g4 = this.getContentGroup(), y4 = this.getSelectorGroup();
      dT(e2.get("orient"), g4, e2.get("itemGap"), l4.width, l4.height);
      var _ = g4.getBoundingRect(), w4 = [-_.x, -_.y];
      if (y4.markRedraw(), g4.markRedraw(), h) {
        dT("horizontal", y4, e2.get("selectorItemGap", true));
        var C = y4.getBoundingRect(), E = [-C.x, -C.y], T = e2.get("selectorButtonGap", true), O = e2.getOrient().index, N = O === 0 ? "width" : "height", V = O === 0 ? "height" : "width", H = O === 0 ? "y" : "x";
        p4 === "end" ? E[O] += _[N] + T : w4[O] += C[N] + T, E[1 - O] += _[V] / 2 - C[V] / 2, y4.x = E[0], y4.y = E[1], g4.x = w4[0], g4.y = w4[1];
        var X = { x: 0, y: 0 };
        return X[N] = _[N] + T + C[N], X[V] = Math.max(_[V], C[V]), X[H] = Math.min(0, C[H] + E[1 - O]), X;
      } else
        return g4.x = w4[0], g4.y = w4[1], this.group.getBoundingRect();
    }, n2.prototype.remove = function() {
      this.getContentGroup().removeAll(), this._isFirstRender = true;
    }, n2.type = "legend.plain", n2;
  }($c);
  function ZMt(i, n2, e2, o, l4, c4) {
    function h(T, O) {
      T.lineWidth === "auto" && (T.lineWidth = O.lineWidth > 0 ? 2 : 0), tse(T, function(N, V) {
        T[V] === "inherit" && (T[V] = O[V]);
      });
    }
    var p4 = n2.getModel("itemStyle"), g4 = p4.getItemStyle(), y4 = i.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
    g4.decal = o.decal, g4.fill === "inherit" && (g4.fill = o[l4]), g4.stroke === "inherit" && (g4.stroke = o[y4]), g4.opacity === "inherit" && (g4.opacity = (l4 === "fill" ? o : e2).opacity), h(g4, o);
    var _ = n2.getModel("lineStyle"), w4 = _.getLineStyle();
    if (h(w4, e2), g4.fill === "auto" && (g4.fill = o.fill), g4.stroke === "auto" && (g4.stroke = o.fill), w4.stroke === "auto" && (w4.stroke = o.fill), !c4) {
      var C = n2.get("inactiveBorderWidth"), E = g4[y4];
      g4.lineWidth = C === "auto" ? o.lineWidth > 0 && E ? 2 : 0 : g4.lineWidth, g4.fill = n2.get("inactiveColor"), g4.stroke = n2.get("inactiveBorderColor"), w4.stroke = _.get("inactiveColor"), w4.lineWidth = _.get("inactiveWidth");
    }
    return { itemStyle: g4, lineStyle: w4 };
  }
  function XMt(i) {
    var n2 = i.icon || "roundRect", e2 = Xf(n2, 0, 0, i.itemWidth, i.itemHeight, i.itemStyle.fill, i.symbolKeepAspect);
    return e2.setStyle(i.itemStyle), e2.rotation = (i.iconRotate || 0) * Math.PI / 180, e2.setOrigin([i.itemWidth / 2, i.itemHeight / 2]), n2.indexOf("empty") > -1 && (e2.style.stroke = e2.style.fill, e2.style.fill = "#fff", e2.style.lineWidth = 2), e2;
  }
  function QAe(i, n2, e2, o) {
    rse(i, n2, e2, o), e2.dispatchAction({ type: "legendToggleSelect", name: i != null ? i : n2 }), nse(i, n2, e2, o);
  }
  function eLe(i) {
    for (var n2 = i.getZr().storage.getDisplayList(), e2, o = 0, l4 = n2.length; o < l4 && !(e2 = n2[o].states.emphasis); )
      o++;
    return e2 && e2.hoverLayer;
  }
  function nse(i, n2, e2, o) {
    eLe(e2) || e2.dispatchAction({ type: "highlight", seriesName: i, name: n2, excludeSeriesId: o });
  }
  function rse(i, n2, e2, o) {
    eLe(e2) || e2.dispatchAction({ type: "downplay", seriesName: i, name: n2, excludeSeriesId: o });
  }
  var tLe = YMt;
  function KMt(i) {
    var n2 = i.findComponents({ mainType: "legend" });
    n2 && n2.length && i.filterSeries(function(e2) {
      for (var o = 0; o < n2.length; o++)
        if (!n2[o].isSelected(e2.name))
          return false;
      return true;
    });
  }
  function _N(i, n2, e2) {
    var o = {}, l4 = i === "toggleSelected", c4;
    return e2.eachComponent("legend", function(h) {
      l4 && c4 != null ? h[c4 ? "select" : "unSelect"](n2.name) : i === "allSelect" || i === "inverseSelect" ? h[i]() : (h[i](n2.name), c4 = h.isSelected(n2.name));
      var p4 = h.getData();
      Ve(p4, function(g4) {
        var y4 = g4.get("name");
        if (!(y4 === `
` || y4 === "")) {
          var _ = h.isSelected(y4);
          o.hasOwnProperty(y4) ? o[y4] = o[y4] && _ : o[y4] = _;
        }
      });
    }), i === "allSelect" || i === "inverseSelect" ? { selected: o } : { name: n2.name, selected: o };
  }
  function JMt(i) {
    i.registerAction("legendToggleSelect", "legendselectchanged", zi(_N, "toggleSelected")), i.registerAction("legendAllSelect", "legendselectall", zi(_N, "allSelect")), i.registerAction("legendInverseSelect", "legendinverseselect", zi(_N, "inverseSelect")), i.registerAction("legendSelect", "legendselected", zi(_N, "select")), i.registerAction("legendUnSelect", "legendunselected", zi(_N, "unSelect"));
  }
  function nLe(i) {
    i.registerComponentModel(ese), i.registerComponentView(tLe), i.registerProcessor(i.PRIORITY.PROCESSOR.SERIES_FILTER, KMt), i.registerSubTypeDefaulter("legend", function() {
      return "plain";
    }), JMt(i);
  }
  var QMt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.setScrollDataIndex = function(e2) {
      this.option.scrollDataIndex = e2;
    }, n2.prototype.init = function(e2, o, l4) {
      var c4 = K3(e2);
      i.prototype.init.call(this, e2, o, l4), eEe(this, e2, c4);
    }, n2.prototype.mergeOption = function(e2, o) {
      i.prototype.mergeOption.call(this, e2, o), eEe(this, this.option, e2);
    }, n2.type = "legend.scroll", n2.defaultOption = sM(ese.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), n2;
  }(ese);
  function eEe(i, n2, e2) {
    var o = i.getOrient(), l4 = [1, 1];
    l4[o.index] = 0, QC(n2, e2, { type: "box", ignoreSize: !!l4 });
  }
  var eAt = QMt, tEe = Ti, tie = ["width", "height"], nie = ["x", "y"], tAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.newlineDisabled = true, e2._currentIndex = 0, e2;
    }
    return n2.prototype.init = function() {
      i.prototype.init.call(this), this.group.add(this._containerGroup = new tEe()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new tEe());
    }, n2.prototype.resetInner = function() {
      i.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
    }, n2.prototype.renderInner = function(e2, o, l4, c4, h, p4, g4) {
      var y4 = this;
      i.prototype.renderInner.call(this, e2, o, l4, c4, h, p4, g4);
      var _ = this._controllerGroup, w4 = o.get("pageIconSize", true), C = Mr(w4) ? w4 : [w4, w4];
      T("pagePrev", 0);
      var E = o.getModel("pageTextStyle");
      _.add(new Qs({ name: "pageText", style: { text: "xx/xx", fill: E.getTextColor(), font: E.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), T("pageNext", 1);
      function T(O, N) {
        var V = O + "DataIndex", H = G8(o.get("pageIcons", true)[o.getOrient().name][N], { onclick: Ia(y4._pageGo, y4, V, o, c4) }, { x: -C[0] / 2, y: -C[1] / 2, width: C[0], height: C[1] });
        H.name = O, _.add(H);
      }
    }, n2.prototype.layoutInner = function(e2, o, l4, c4, h, p4) {
      var g4 = this.getSelectorGroup(), y4 = e2.getOrient().index, _ = tie[y4], w4 = nie[y4], C = tie[1 - y4], E = nie[1 - y4];
      h && dT("horizontal", g4, e2.get("selectorItemGap", true));
      var T = e2.get("selectorButtonGap", true), O = g4.getBoundingRect(), N = [-O.x, -O.y], V = Ci(l4);
      h && (V[_] = l4[_] - O[_] - T);
      var H = this._layoutContentAndController(e2, c4, V, y4, _, C, E, w4);
      if (h) {
        if (p4 === "end")
          N[y4] += H[_] + T;
        else {
          var X = O[_] + T;
          N[y4] -= X, H[w4] -= X;
        }
        H[_] += O[_] + T, N[1 - y4] += H[E] + H[C] / 2 - O[C] / 2, H[C] = Math.max(H[C], O[C]), H[E] = Math.min(H[E], O[E] + N[1 - y4]), g4.x = N[0], g4.y = N[1], g4.markRedraw();
      }
      return H;
    }, n2.prototype._layoutContentAndController = function(e2, o, l4, c4, h, p4, g4, y4) {
      var _ = this.getContentGroup(), w4 = this._containerGroup, C = this._controllerGroup;
      dT(e2.get("orient"), _, e2.get("itemGap"), c4 ? l4.width : null, c4 ? null : l4.height), dT("horizontal", C, e2.get("pageButtonItemGap", true));
      var E = _.getBoundingRect(), T = C.getBoundingRect(), O = this._showController = E[h] > l4[h], N = [-E.x, -E.y];
      o || (N[c4] = _[y4]);
      var V = [0, 0], H = [-T.x, -T.y], X = so(e2.get("pageButtonGap", true), e2.get("itemGap", true));
      if (O) {
        var q2 = e2.get("pageButtonPosition", true);
        q2 === "end" ? H[c4] += l4[h] - T[h] : V[c4] += T[h] + X;
      }
      H[1 - c4] += E[p4] / 2 - T[p4] / 2, _.setPosition(N), w4.setPosition(V), C.setPosition(H);
      var de = { x: 0, y: 0 };
      if (de[h] = O ? l4[h] : E[h], de[p4] = Math.max(E[p4], T[p4]), de[g4] = Math.min(0, T[g4] + H[1 - c4]), w4.__rectSize = l4[h], O) {
        var le = { x: 0, y: 0 };
        le[h] = Math.max(l4[h] - T[h] - X, 0), le[p4] = de[p4], w4.setClipPath(new Is({ shape: le })), w4.__rectSize = le[h];
      } else
        C.eachChild(function(ye) {
          ye.attr({ invisible: true, silent: true });
        });
      var me = this._getPageInfo(e2);
      return me.pageIndex != null && Vs(_, { x: me.contentPosition[0], y: me.contentPosition[1] }, O ? e2 : null), this._updatePageInfoView(e2, me), de;
    }, n2.prototype._pageGo = function(e2, o, l4) {
      var c4 = this._getPageInfo(o)[e2];
      c4 != null && l4.dispatchAction({ type: "legendScroll", scrollDataIndex: c4, legendId: o.id });
    }, n2.prototype._updatePageInfoView = function(e2, o) {
      var l4 = this._controllerGroup;
      Ve(["pagePrev", "pageNext"], function(_) {
        var w4 = _ + "DataIndex", C = o[w4] != null, E = l4.childOfName(_);
        E && (E.setStyle("fill", C ? e2.get("pageIconColor", true) : e2.get("pageIconInactiveColor", true)), E.cursor = C ? "pointer" : "default");
      });
      var c4 = l4.childOfName("pageText"), h = e2.get("pageFormatter"), p4 = o.pageIndex, g4 = p4 != null ? p4 + 1 : 0, y4 = o.pageCount;
      c4 && h && c4.setStyle("text", xa(h) ? h.replace("{current}", g4 == null ? "" : g4 + "").replace("{total}", y4 == null ? "" : y4 + "") : h({ current: g4, total: y4 }));
    }, n2.prototype._getPageInfo = function(e2) {
      var o = e2.get("scrollDataIndex", true), l4 = this.getContentGroup(), c4 = this._containerGroup.__rectSize, h = e2.getOrient().index, p4 = tie[h], g4 = nie[h], y4 = this._findTargetItemIndex(o), _ = l4.children(), w4 = _[y4], C = _.length, E = C ? 1 : 0, T = { contentPosition: [l4.x, l4.y], pageCount: E, pageIndex: E - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
      if (!w4)
        return T;
      var O = q2(w4);
      T.contentPosition[h] = -O.s;
      for (var N = y4 + 1, V = O, H = O, X = null; N <= C; ++N)
        X = q2(_[N]), (!X && H.e > V.s + c4 || X && !de(X, V.s)) && (H.i > V.i ? V = H : V = X, V && (T.pageNextDataIndex == null && (T.pageNextDataIndex = V.i), ++T.pageCount)), H = X;
      for (var N = y4 - 1, V = O, H = O, X = null; N >= -1; --N)
        X = q2(_[N]), (!X || !de(H, X.s)) && V.i < H.i && (H = V, T.pagePrevDataIndex == null && (T.pagePrevDataIndex = V.i), ++T.pageCount, ++T.pageIndex), V = X;
      return T;
      function q2(le) {
        if (le) {
          var me = le.getBoundingRect(), ye = me[g4] + le[g4];
          return { s: ye, e: ye + me[p4], i: le.__legendDataIndex };
        }
      }
      function de(le, me) {
        return le.e >= me && le.s <= me + c4;
      }
    }, n2.prototype._findTargetItemIndex = function(e2) {
      if (!this._showController)
        return 0;
      var o, l4 = this.getContentGroup(), c4;
      return l4.eachChild(function(h, p4) {
        var g4 = h.__legendDataIndex;
        c4 == null && g4 != null && (c4 = p4), g4 === e2 && (o = p4);
      }), o != null ? o : c4;
    }, n2.type = "legend.scroll", n2;
  }(tLe), nAt = tAt;
  function rAt(i) {
    i.registerAction("legendScroll", "legendscroll", function(n2, e2) {
      var o = n2.scrollDataIndex;
      o != null && e2.eachComponent({ mainType: "legend", subType: "scroll", query: n2 }, function(l4) {
        l4.setScrollDataIndex(o);
      });
    });
  }
  function aAt(i) {
    wo(nLe), i.registerComponentModel(eAt), i.registerComponentView(nAt), rAt(i);
  }
  function iAt(i) {
    wo(nLe), wo(aAt);
  }
  var oAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "dataZoom.inside", n2.defaultOption = sM(D8.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), n2;
  }(D8), sAt = oAt, Iue = zs();
  function lAt(i, n2, e2) {
    Iue(i).coordSysRecordMap.each(function(o) {
      var l4 = o.dataZoomInfoMap.get(n2.uid);
      l4 && (l4.getRange = e2);
    });
  }
  function uAt(i, n2) {
    for (var e2 = Iue(i).coordSysRecordMap, o = e2.keys(), l4 = 0; l4 < o.length; l4++) {
      var c4 = o[l4], h = e2.get(c4), p4 = h.dataZoomInfoMap;
      if (p4) {
        var g4 = n2.uid, y4 = p4.get(g4);
        y4 && (p4.removeKey(g4), p4.keys().length || rLe(e2, h));
      }
    }
  }
  function rLe(i, n2) {
    if (n2) {
      i.removeKey(n2.model.uid);
      var e2 = n2.controller;
      e2 && e2.dispose();
    }
  }
  function cAt(i, n2) {
    var e2 = { model: n2, containsPoint: zi(hAt, n2), dispatchAction: zi(fAt, i), dataZoomInfoMap: null, controller: null }, o = e2.controller = new t9(i.getZr());
    return Ve(["pan", "zoom", "scrollMove"], function(l4) {
      o.on(l4, function(c4) {
        var h = [];
        e2.dataZoomInfoMap.each(function(p4) {
          if (!!c4.isAvailableBehavior(p4.model.option)) {
            var g4 = (p4.getRange || {})[l4], y4 = g4 && g4(p4.dzReferCoordSysInfo, e2.model.mainType, e2.controller, c4);
            !p4.model.get("disabled", true) && y4 && h.push({ dataZoomId: p4.model.id, start: y4[0], end: y4[1] });
          }
        }), h.length && e2.dispatchAction(h);
      });
    }), e2;
  }
  function fAt(i, n2) {
    i.isDisposed() || i.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: n2 });
  }
  function hAt(i, n2, e2, o) {
    return i.coordinateSystem.containPoint([e2, o]);
  }
  function dAt(i) {
    var n2, e2 = "type_", o = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, l4 = true;
    return i.each(function(c4) {
      var h = c4.model, p4 = h.get("disabled", true) ? false : h.get("zoomLock", true) ? "move" : true;
      o[e2 + p4] > o[e2 + n2] && (n2 = p4), l4 = l4 && h.get("preventDefaultMouseMove", true);
    }), { controlType: n2, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!l4 } };
  }
  function pAt(i) {
    i.registerProcessor(i.PRIORITY.PROCESSOR.FILTER, function(n2, e2) {
      var o = Iue(e2), l4 = o.coordSysRecordMap || (o.coordSysRecordMap = ri());
      l4.each(function(c4) {
        c4.dataZoomInfoMap = null;
      }), n2.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(c4) {
        var h = V3e(c4);
        Ve(h.infoList, function(p4) {
          var g4 = p4.model.uid, y4 = l4.get(g4) || l4.set(g4, cAt(e2, p4.model)), _ = y4.dataZoomInfoMap || (y4.dataZoomInfoMap = ri());
          _.set(c4.uid, { dzReferCoordSysInfo: p4, model: c4, getRange: null });
        });
      }), l4.each(function(c4) {
        var h = c4.controller, p4, g4 = c4.dataZoomInfoMap;
        if (g4) {
          var y4 = g4.keys()[0];
          y4 != null && (p4 = g4.get(y4));
        }
        if (!p4) {
          rLe(l4, c4);
          return;
        }
        var _ = dAt(g4);
        h.enable(_.controlType, _.opt), h.setPointerChecker(c4.containsPoint), tL(c4, "dispatchAction", p4.model.get("throttle", true), "fixRate");
      });
    });
  }
  var vAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "dataZoom.inside", e2;
    }
    return n2.prototype.render = function(e2, o, l4) {
      if (i.prototype.render.apply(this, arguments), e2.noTarget()) {
        this._clear();
        return;
      }
      this.range = e2.getPercentRange(), lAt(l4, e2, { pan: Ia(rie.pan, this), zoom: Ia(rie.zoom, this), scrollMove: Ia(rie.scrollMove, this) });
    }, n2.prototype.dispose = function() {
      this._clear(), i.prototype.dispose.apply(this, arguments);
    }, n2.prototype._clear = function() {
      uAt(this.api, this.dataZoomModel), this.range = null;
    }, n2.type = "dataZoom.inside", n2;
  }(bue), rie = { zoom: function(i, n2, e2, o) {
    var l4 = this.range, c4 = l4.slice(), h = i.axisModels[0];
    if (!!h) {
      var p4 = aie[n2](null, [o.originX, o.originY], h, e2, i), g4 = (p4.signal > 0 ? p4.pixelStart + p4.pixelLength - p4.pixel : p4.pixel - p4.pixelStart) / p4.pixelLength * (c4[1] - c4[0]) + c4[0], y4 = Math.max(1 / o.scale, 0);
      c4[0] = (c4[0] - g4) * y4 + g4, c4[1] = (c4[1] - g4) * y4 + g4;
      var _ = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
      if (TT(0, c4, [0, 100], 0, _.minSpan, _.maxSpan), this.range = c4, l4[0] !== c4[0] || l4[1] !== c4[1])
        return c4;
    }
  }, pan: nEe(function(i, n2, e2, o, l4, c4) {
    var h = aie[o]([c4.oldX, c4.oldY], [c4.newX, c4.newY], n2, l4, e2);
    return h.signal * (i[1] - i[0]) * h.pixel / h.pixelLength;
  }), scrollMove: nEe(function(i, n2, e2, o, l4, c4) {
    var h = aie[o]([0, 0], [c4.scrollDelta, c4.scrollDelta], n2, l4, e2);
    return h.signal * (i[1] - i[0]) * c4.scrollDelta;
  }) };
  function nEe(i) {
    return function(n2, e2, o, l4) {
      var c4 = this.range, h = c4.slice(), p4 = n2.axisModels[0];
      if (!!p4) {
        var g4 = i(h, p4, n2, e2, o, l4);
        if (TT(g4, h, [0, 100], "all"), this.range = h, c4[0] !== h[0] || c4[1] !== h[1])
          return h;
      }
    };
  }
  var aie = { grid: function(i, n2, e2, o, l4) {
    var c4 = e2.axis, h = {}, p4 = l4.model.coordinateSystem.getRect();
    return i = i || [0, 0], c4.dim === "x" ? (h.pixel = n2[0] - i[0], h.pixelLength = p4.width, h.pixelStart = p4.x, h.signal = c4.inverse ? 1 : -1) : (h.pixel = n2[1] - i[1], h.pixelLength = p4.height, h.pixelStart = p4.y, h.signal = c4.inverse ? -1 : 1), h;
  }, polar: function(i, n2, e2, o, l4) {
    var c4 = e2.axis, h = {}, p4 = l4.model.coordinateSystem, g4 = p4.getRadiusAxis().getExtent(), y4 = p4.getAngleAxis().getExtent();
    return i = i ? p4.pointToCoord(i) : [0, 0], n2 = p4.pointToCoord(n2), e2.mainType === "radiusAxis" ? (h.pixel = n2[0] - i[0], h.pixelLength = g4[1] - g4[0], h.pixelStart = g4[0], h.signal = c4.inverse ? 1 : -1) : (h.pixel = n2[1] - i[1], h.pixelLength = y4[1] - y4[0], h.pixelStart = y4[0], h.signal = c4.inverse ? -1 : 1), h;
  }, singleAxis: function(i, n2, e2, o, l4) {
    var c4 = e2.axis, h = l4.model.coordinateSystem.getRect(), p4 = {};
    return i = i || [0, 0], c4.orient === "horizontal" ? (p4.pixel = n2[0] - i[0], p4.pixelLength = h.width, p4.pixelStart = h.x, p4.signal = c4.inverse ? 1 : -1) : (p4.pixel = n2[1] - i[1], p4.pixelLength = h.height, p4.pixelStart = h.y, p4.signal = c4.inverse ? -1 : 1), p4;
  } }, gAt = vAt;
  function aLe(i) {
    _ue(i), i.registerComponentModel(sAt), i.registerComponentView(gAt), pAt(i);
  }
  var mAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.type = "dataZoom.slider", n2.layoutMode = "box", n2.defaultOption = sM(D8.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), n2;
  }(D8), yAt = mAt, xN = Is, rEe = 7, bAt = 1, iie = 30, _At = 7, wN = "horizontal", aEe = "vertical", xAt = 5, wAt = ["line", "bar", "candlestick", "scatter"], SAt = { easing: "cubicOut", duration: 100, delay: 0 }, CAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._displayables = {}, e2;
    }
    return n2.prototype.init = function(e2, o) {
      this.api = o, this._onBrush = Ia(this._onBrush, this), this._onBrushEnd = Ia(this._onBrushEnd, this);
    }, n2.prototype.render = function(e2, o, l4, c4) {
      if (i.prototype.render.apply(this, arguments), tL(this, "_dispatchZoomAction", e2.get("throttle"), "fixRate"), this._orient = e2.getOrient(), e2.get("show") === false) {
        this.group.removeAll();
        return;
      }
      if (e2.noTarget()) {
        this._clear(), this.group.removeAll();
        return;
      }
      (!c4 || c4.type !== "dataZoom" || c4.from !== this.uid) && this._buildView(), this._updateView();
    }, n2.prototype.dispose = function() {
      this._clear(), i.prototype.dispose.apply(this, arguments);
    }, n2.prototype._clear = function() {
      m8(this, "_dispatchZoomAction");
      var e2 = this.api.getZr();
      e2.off("mousemove", this._onBrush), e2.off("mouseup", this._onBrushEnd);
    }, n2.prototype._buildView = function() {
      var e2 = this.group;
      e2.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
      var o = this._displayables.sliderGroup = new Ti();
      this._renderBackground(), this._renderHandle(), this._renderDataShadow(), e2.add(o), this._positionGroup();
    }, n2.prototype._resetLocation = function() {
      var e2 = this.dataZoomModel, o = this.api, l4 = e2.get("brushSelect"), c4 = l4 ? _At : 0, h = this._findCoordRect(), p4 = { width: o.getWidth(), height: o.getHeight() }, g4 = this._orient === wN ? { right: p4.width - h.x - h.width, top: p4.height - iie - rEe - c4, width: h.width, height: iie } : { right: rEe, top: h.y, width: iie, height: h.height }, y4 = K3(e2.option);
      Ve(["right", "top", "width", "height"], function(w4) {
        y4[w4] === "ph" && (y4[w4] = g4[w4]);
      });
      var _ = bh(y4, p4);
      this._location = { x: _.x, y: _.y }, this._size = [_.width, _.height], this._orient === aEe && this._size.reverse();
    }, n2.prototype._positionGroup = function() {
      var e2 = this.group, o = this._location, l4 = this._orient, c4 = this.dataZoomModel.getFirstTargetAxisModel(), h = c4 && c4.get("inverse"), p4 = this._displayables.sliderGroup, g4 = (this._dataShadowInfo || {}).otherAxisInverse;
      p4.attr(l4 === wN && !h ? { scaleY: g4 ? 1 : -1, scaleX: 1 } : l4 === wN && h ? { scaleY: g4 ? 1 : -1, scaleX: -1 } : l4 === aEe && !h ? { scaleY: g4 ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: g4 ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
      var y4 = e2.getBoundingRect([p4]);
      e2.x = o.x - y4.x, e2.y = o.y - y4.y, e2.markRedraw();
    }, n2.prototype._getViewExtent = function() {
      return [0, this._size[0]];
    }, n2.prototype._renderBackground = function() {
      var e2 = this.dataZoomModel, o = this._size, l4 = this._displayables.sliderGroup, c4 = e2.get("brushSelect");
      l4.add(new xN({ silent: true, shape: { x: 0, y: 0, width: o[0], height: o[1] }, style: { fill: e2.get("backgroundColor") }, z2: -40 }));
      var h = new xN({ shape: { x: 0, y: 0, width: o[0], height: o[1] }, style: { fill: "transparent" }, z2: 0, onclick: Ia(this._onClickPanel, this) }), p4 = this.api.getZr();
      c4 ? (h.on("mousedown", this._onBrushStart, this), h.cursor = "crosshair", p4.on("mousemove", this._onBrush), p4.on("mouseup", this._onBrushEnd)) : (p4.off("mousemove", this._onBrush), p4.off("mouseup", this._onBrushEnd)), l4.add(h);
    }, n2.prototype._renderDataShadow = function() {
      var e2 = this._dataShadowInfo = this._prepareDataShadowInfo();
      if (this._displayables.dataShadowSegs = [], !e2)
        return;
      var o = this._size, l4 = this._shadowSize || [], c4 = e2.series, h = c4.getRawData(), p4 = c4.getShadowDim ? c4.getShadowDim() : e2.otherDim;
      if (p4 == null)
        return;
      var g4 = this._shadowPolygonPts, y4 = this._shadowPolylinePts;
      if (h !== this._shadowData || p4 !== this._shadowDim || o[0] !== l4[0] || o[1] !== l4[1]) {
        var _ = h.getDataExtent(p4), w4 = (_[1] - _[0]) * 0.3;
        _ = [_[0] - w4, _[1] + w4];
        var C = [0, o[1]], E = [0, o[0]], T = [[o[0], 0], [0, 0]], O = [], N = E[1] / (h.count() - 1), V = 0, H = Math.round(h.count() / o[0]), X;
        h.each([p4], function(ye, be) {
          if (H > 0 && be % H) {
            V += N;
            return;
          }
          var we = ye == null || isNaN(ye) || ye === "", Pe = we ? 0 : Tl(ye, _, C, true);
          we && !X && be ? (T.push([T[T.length - 1][0], 0]), O.push([O[O.length - 1][0], 0])) : !we && X && (T.push([V, 0]), O.push([V, 0])), T.push([V, Pe]), O.push([V, Pe]), V += N, X = we;
        }), g4 = this._shadowPolygonPts = T, y4 = this._shadowPolylinePts = O;
      }
      this._shadowData = h, this._shadowDim = p4, this._shadowSize = [o[0], o[1]];
      var q2 = this.dataZoomModel;
      function de(ye) {
        var be = q2.getModel(ye ? "selectedDataBackground" : "dataBackground"), we = new Ti(), Pe = new $g({ shape: { points: g4 }, segmentIgnoreThreshold: 1, style: be.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), ze = new Ug({ shape: { points: y4 }, segmentIgnoreThreshold: 1, style: be.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
        return we.add(Pe), we.add(ze), we;
      }
      for (var le = 0; le < 3; le++) {
        var me = de(le === 1);
        this._displayables.sliderGroup.add(me), this._displayables.dataShadowSegs.push(me);
      }
    }, n2.prototype._prepareDataShadowInfo = function() {
      var e2 = this.dataZoomModel, o = e2.get("showDataShadow");
      if (o !== false) {
        var l4, c4 = this.ecModel;
        return e2.eachTargetAxis(function(h, p4) {
          var g4 = e2.getAxisProxy(h, p4).getTargetSeriesModels();
          Ve(g4, function(y4) {
            if (!l4 && !(o !== true && go(wAt, y4.get("type")) < 0)) {
              var _ = c4.getComponent(HC(h), p4).axis, w4 = MAt(h), C, E = y4.coordinateSystem;
              w4 != null && E.getOtherAxis && (C = E.getOtherAxis(_).inverse), w4 = y4.getData().mapDimension(w4), l4 = { thisAxis: _, series: y4, thisDim: h, otherDim: w4, otherAxisInverse: C };
            }
          }, this);
        }, this), l4;
      }
    }, n2.prototype._renderHandle = function() {
      var e2 = this.group, o = this._displayables, l4 = o.handles = [null, null], c4 = o.handleLabels = [null, null], h = this._displayables.sliderGroup, p4 = this._size, g4 = this.dataZoomModel, y4 = this.api, _ = g4.get("borderRadius") || 0, w4 = g4.get("brushSelect"), C = o.filler = new xN({ silent: w4, style: { fill: g4.get("fillerColor") }, textConfig: { position: "inside" } });
      h.add(C), h.add(new xN({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: p4[0], height: p4[1], r: _ }, style: { stroke: g4.get("dataBackgroundColor") || g4.get("borderColor"), lineWidth: bAt, fill: "rgba(0,0,0,0)" } })), Ve([0, 1], function(X) {
        var q2 = g4.get("handleIcon");
        !RH[q2] && q2.indexOf("path://") < 0 && q2.indexOf("image://") < 0 && (q2 = "path://" + q2);
        var de = Xf(q2, -1, 0, 2, 2, null, true);
        de.attr({ cursor: iEe(this._orient), draggable: true, drift: Ia(this._onDragMove, this, X), ondragend: Ia(this._onDragEnd, this), onmouseover: Ia(this._showDataInfo, this, true), onmouseout: Ia(this._showDataInfo, this, false), z2: 5 });
        var le = de.getBoundingRect(), me = g4.get("handleSize");
        this._handleHeight = ma(me, this._size[1]), this._handleWidth = le.width / le.height * this._handleHeight, de.setStyle(g4.getModel("handleStyle").getItemStyle()), de.style.strokeNoScale = true, de.rectHover = true, de.ensureState("emphasis").style = g4.getModel(["emphasis", "handleStyle"]).getItemStyle(), fT(de);
        var ye = g4.get("handleColor");
        ye != null && (de.style.fill = ye), h.add(l4[X] = de);
        var be = g4.getModel("textStyle");
        e2.add(c4[X] = new Qs({ silent: true, invisible: true, style: Ef(be, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: be.getTextColor(), font: be.getFont() }), z2: 10 }));
      }, this);
      var E = C;
      if (w4) {
        var T = ma(g4.get("moveHandleSize"), p4[1]), O = o.moveHandle = new Is({ style: g4.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: p4[1] - 0.5, height: T } }), N = T * 0.8, V = o.moveHandleIcon = Xf(g4.get("moveHandleIcon"), -N / 2, -N / 2, N, N, "#fff", true);
        V.silent = true, V.y = p4[1] + T / 2 - 0.5, O.ensureState("emphasis").style = g4.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
        var H = Math.min(p4[1] / 2, Math.max(T, 10));
        E = o.moveZone = new Is({ invisible: true, shape: { y: p4[1] - H, height: T + H } }), E.on("mouseover", function() {
          y4.enterEmphasis(O);
        }).on("mouseout", function() {
          y4.leaveEmphasis(O);
        }), h.add(O), h.add(V), h.add(E);
      }
      E.attr({ draggable: true, cursor: iEe(this._orient), drift: Ia(this._onDragMove, this, "all"), ondragstart: Ia(this._showDataInfo, this, true), ondragend: Ia(this._onDragEnd, this), onmouseover: Ia(this._showDataInfo, this, true), onmouseout: Ia(this._showDataInfo, this, false) });
    }, n2.prototype._resetInterval = function() {
      var e2 = this._range = this.dataZoomModel.getPercentRange(), o = this._getViewExtent();
      this._handleEnds = [Tl(e2[0], [0, 100], o, true), Tl(e2[1], [0, 100], o, true)];
    }, n2.prototype._updateInterval = function(e2, o) {
      var l4 = this.dataZoomModel, c4 = this._handleEnds, h = this._getViewExtent(), p4 = l4.findRepresentativeAxisProxy().getMinMaxSpan(), g4 = [0, 100];
      TT(o, c4, h, l4.get("zoomLock") ? "all" : e2, p4.minSpan != null ? Tl(p4.minSpan, g4, h, true) : null, p4.maxSpan != null ? Tl(p4.maxSpan, g4, h, true) : null);
      var y4 = this._range, _ = this._range = Ly([Tl(c4[0], h, g4, true), Tl(c4[1], h, g4, true)]);
      return !y4 || y4[0] !== _[0] || y4[1] !== _[1];
    }, n2.prototype._updateView = function(e2) {
      var o = this._displayables, l4 = this._handleEnds, c4 = Ly(l4.slice()), h = this._size;
      Ve([0, 1], function(E) {
        var T = o.handles[E], O = this._handleHeight;
        T.attr({ scaleX: O / 2, scaleY: O / 2, x: l4[E] + (E ? -1 : 1), y: h[1] / 2 - O / 2 });
      }, this), o.filler.setShape({ x: c4[0], y: 0, width: c4[1] - c4[0], height: h[1] });
      var p4 = { x: c4[0], width: c4[1] - c4[0] };
      o.moveHandle && (o.moveHandle.setShape(p4), o.moveZone.setShape(p4), o.moveZone.getBoundingRect(), o.moveHandleIcon && o.moveHandleIcon.attr("x", p4.x + p4.width / 2));
      for (var g4 = o.dataShadowSegs, y4 = [0, c4[0], c4[1], h[0]], _ = 0; _ < g4.length; _++) {
        var w4 = g4[_], C = w4.getClipPath();
        C || (C = new Is(), w4.setClipPath(C)), C.setShape({ x: y4[_], y: 0, width: y4[_ + 1] - y4[_], height: h[1] });
      }
      this._updateDataInfo(e2);
    }, n2.prototype._updateDataInfo = function(e2) {
      var o = this.dataZoomModel, l4 = this._displayables, c4 = l4.handleLabels, h = this._orient, p4 = ["", ""];
      if (o.get("showDetail")) {
        var g4 = o.findRepresentativeAxisProxy();
        if (g4) {
          var y4 = g4.getAxisModel().axis, _ = this._range, w4 = e2 ? g4.calculateDataWindow({ start: _[0], end: _[1] }).valueWindow : g4.getDataValueWindow();
          p4 = [this._formatLabel(w4[0], y4), this._formatLabel(w4[1], y4)];
        }
      }
      var C = Ly(this._handleEnds.slice());
      E.call(this, 0), E.call(this, 1);
      function E(T) {
        var O = hT(l4.handles[T].parent, this.group), N = D$(T === 0 ? "right" : "left", O), V = this._handleWidth / 2 + xAt, H = ab([C[T] + (T === 0 ? -V : V), this._size[1] / 2], O);
        c4[T].setStyle({ x: H[0], y: H[1], verticalAlign: h === wN ? "middle" : N, align: h === wN ? N : "center", text: p4[T] });
      }
    }, n2.prototype._formatLabel = function(e2, o) {
      var l4 = this.dataZoomModel, c4 = l4.get("labelFormatter"), h = l4.get("labelPrecision");
      (h == null || h === "auto") && (h = o.getPixelPrecision());
      var p4 = e2 == null || isNaN(e2) ? "" : o.type === "category" || o.type === "time" ? o.scale.getLabel({ value: Math.round(e2) }) : e2.toFixed(Math.min(h, 20));
      return si(c4) ? c4(e2, p4) : xa(c4) ? c4.replace("{value}", p4) : p4;
    }, n2.prototype._showDataInfo = function(e2) {
      e2 = this._dragging || e2;
      var o = this._displayables, l4 = o.handleLabels;
      l4[0].attr("invisible", !e2), l4[1].attr("invisible", !e2), o.moveHandle && this.api[e2 ? "enterEmphasis" : "leaveEmphasis"](o.moveHandle, 1);
    }, n2.prototype._onDragMove = function(e2, o, l4, c4) {
      this._dragging = true, b2(c4.event);
      var h = this._displayables.sliderGroup.getLocalTransform(), p4 = ab([o, l4], h, true), g4 = this._updateInterval(e2, p4[0]), y4 = this.dataZoomModel.get("realtime");
      this._updateView(!y4), g4 && y4 && this._dispatchZoomAction(true);
    }, n2.prototype._onDragEnd = function() {
      this._dragging = false, this._showDataInfo(false);
      var e2 = this.dataZoomModel.get("realtime");
      !e2 && this._dispatchZoomAction(false);
    }, n2.prototype._onClickPanel = function(e2) {
      var o = this._size, l4 = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
      if (!(l4[0] < 0 || l4[0] > o[0] || l4[1] < 0 || l4[1] > o[1])) {
        var c4 = this._handleEnds, h = (c4[0] + c4[1]) / 2, p4 = this._updateInterval("all", l4[0] - h);
        this._updateView(), p4 && this._dispatchZoomAction(false);
      }
    }, n2.prototype._onBrushStart = function(e2) {
      var o = e2.offsetX, l4 = e2.offsetY;
      this._brushStart = new Ji(o, l4), this._brushing = true, this._brushStartTime = +new Date();
    }, n2.prototype._onBrushEnd = function(e2) {
      if (!!this._brushing) {
        var o = this._displayables.brushRect;
        if (this._brushing = false, !!o) {
          o.attr("ignore", true);
          var l4 = o.shape, c4 = +new Date();
          if (!(c4 - this._brushStartTime < 200 && Math.abs(l4.width) < 5)) {
            var h = this._getViewExtent(), p4 = [0, 100];
            this._range = Ly([Tl(l4.x, h, p4, true), Tl(l4.x + l4.width, h, p4, true)]), this._handleEnds = [l4.x, l4.x + l4.width], this._updateView(), this._dispatchZoomAction(false);
          }
        }
      }
    }, n2.prototype._onBrush = function(e2) {
      this._brushing && (b2(e2.event), this._updateBrushRect(e2.offsetX, e2.offsetY));
    }, n2.prototype._updateBrushRect = function(e2, o) {
      var l4 = this._displayables, c4 = this.dataZoomModel, h = l4.brushRect;
      h || (h = l4.brushRect = new xN({ silent: true, style: c4.getModel("brushStyle").getItemStyle() }), l4.sliderGroup.add(h)), h.attr("ignore", false);
      var p4 = this._brushStart, g4 = this._displayables.sliderGroup, y4 = g4.transformCoordToLocal(e2, o), _ = g4.transformCoordToLocal(p4.x, p4.y), w4 = this._size;
      y4[0] = Math.max(Math.min(w4[0], y4[0]), 0), h.setShape({ x: _[0], y: 0, width: y4[0] - _[0], height: w4[1] });
    }, n2.prototype._dispatchZoomAction = function(e2) {
      var o = this._range;
      this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: e2 ? SAt : null, start: o[0], end: o[1] });
    }, n2.prototype._findCoordRect = function() {
      var e2, o = V3e(this.dataZoomModel).infoList;
      if (!e2 && o.length) {
        var l4 = o[0].model.coordinateSystem;
        e2 = l4.getRect && l4.getRect();
      }
      if (!e2) {
        var c4 = this.api.getWidth(), h = this.api.getHeight();
        e2 = { x: c4 * 0.2, y: h * 0.2, width: c4 * 0.6, height: h * 0.6 };
      }
      return e2;
    }, n2.type = "dataZoom.slider", n2;
  }(bue);
  function MAt(i) {
    var n2 = { x: "y", y: "x", radius: "angle", angle: "radius" };
    return n2[i];
  }
  function iEe(i) {
    return i === "vertical" ? "ns-resize" : "ew-resize";
  }
  var AAt = CAt;
  function iLe(i) {
    i.registerComponentModel(yAt), i.registerComponentView(AAt), _ue(i);
  }
  function EAt(i) {
    wo(aLe), wo(iLe);
  }
  var IAt = { get: function(i, n2, e2) {
    var o = Ci((TAt[i] || {})[n2]);
    return e2 && Mr(o) ? o[o.length - 1] : o;
  } }, TAt = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, oLe = IAt, oEe = Cp.mapVisual, DAt = Cp.eachVisual, kAt = Mr, sEe = Ve, PAt = Ly, LAt = Tl, OAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.stateList = ["inRange", "outOfRange"], e2.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], e2.layoutMode = { type: "box", ignoreSize: true }, e2.dataBound = [-1 / 0, 1 / 0], e2.targetVisuals = {}, e2.controllerVisuals = {}, e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      this.mergeDefaultAndTheme(e2, l4);
    }, n2.prototype.optionUpdated = function(e2, o) {
      var l4 = this.option;
      !o && Y3e(l4, e2, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
    }, n2.prototype.resetVisual = function(e2) {
      var o = this.stateList;
      e2 = Ia(e2, this), this.controllerVisuals = Joe(this.option.controller, o, e2), this.targetVisuals = Joe(this.option.target, o, e2);
    }, n2.prototype.getItemSymbol = function() {
      return null;
    }, n2.prototype.getTargetSeriesIndices = function() {
      var e2 = this.option.seriesIndex, o = [];
      return e2 == null || e2 === "all" ? this.ecModel.eachSeries(function(l4, c4) {
        o.push(c4);
      }) : o = Zl(e2), o;
    }, n2.prototype.eachTargetSeries = function(e2, o) {
      Ve(this.getTargetSeriesIndices(), function(l4) {
        var c4 = this.ecModel.getSeriesByIndex(l4);
        c4 && e2.call(o, c4);
      }, this);
    }, n2.prototype.isTargetSeries = function(e2) {
      var o = false;
      return this.eachTargetSeries(function(l4) {
        l4 === e2 && (o = true);
      }), o;
    }, n2.prototype.formatValueText = function(e2, o, l4) {
      var c4 = this.option, h = c4.precision, p4 = this.dataBound, g4 = c4.formatter, y4;
      l4 = l4 || ["<", ">"], Mr(e2) && (e2 = e2.slice(), y4 = true);
      var _ = o ? e2 : y4 ? [w4(e2[0]), w4(e2[1])] : w4(e2);
      if (xa(g4))
        return g4.replace("{value}", y4 ? _[0] : _).replace("{value2}", y4 ? _[1] : _);
      if (si(g4))
        return y4 ? g4(e2[0], e2[1]) : g4(e2);
      if (y4)
        return e2[0] === p4[0] ? l4[0] + " " + _[1] : e2[1] === p4[1] ? l4[1] + " " + _[0] : _[0] + " - " + _[1];
      return _;
      function w4(C) {
        return C === p4[0] ? "min" : C === p4[1] ? "max" : (+C).toFixed(Math.min(h, 20));
      }
    }, n2.prototype.resetExtent = function() {
      var e2 = this.option, o = PAt([e2.min, e2.max]);
      this._dataExtent = o;
    }, n2.prototype.getDataDimensionIndex = function(e2) {
      var o = this.option.dimension;
      if (o != null)
        return e2.getDimensionIndex(o);
      for (var l4 = e2.dimensions, c4 = l4.length - 1; c4 >= 0; c4--) {
        var h = l4[c4], p4 = e2.getDimensionInfo(h);
        if (!p4.isCalculationCoord)
          return p4.storeDimIndex;
      }
    }, n2.prototype.getExtent = function() {
      return this._dataExtent.slice();
    }, n2.prototype.completeVisualOption = function() {
      var e2 = this.ecModel, o = this.option, l4 = { inRange: o.inRange, outOfRange: o.outOfRange }, c4 = o.target || (o.target = {}), h = o.controller || (o.controller = {});
      to(c4, l4), to(h, l4);
      var p4 = this.isCategory();
      g4.call(this, c4), g4.call(this, h), y4.call(this, c4, "inRange", "outOfRange"), _.call(this, h);
      function g4(w4) {
        kAt(o.color) && !w4.inRange && (w4.inRange = { color: o.color.slice().reverse() }), w4.inRange = w4.inRange || { color: e2.get("gradientColor") };
      }
      function y4(w4, C, E) {
        var T = w4[C], O = w4[E];
        T && !O && (O = w4[E] = {}, sEe(T, function(N, V) {
          if (!!Cp.isValidType(V)) {
            var H = oLe.get(V, "inactive", p4);
            H != null && (O[V] = H, V === "color" && !O.hasOwnProperty("opacity") && !O.hasOwnProperty("colorAlpha") && (O.opacity = [0, 0]));
          }
        }));
      }
      function _(w4) {
        var C = (w4.inRange || {}).symbol || (w4.outOfRange || {}).symbol, E = (w4.inRange || {}).symbolSize || (w4.outOfRange || {}).symbolSize, T = this.get("inactiveColor"), O = this.getItemSymbol(), N = O || "roundRect";
        sEe(this.stateList, function(V) {
          var H = this.itemSize, X = w4[V];
          X || (X = w4[V] = { color: p4 ? T : [T] }), X.symbol == null && (X.symbol = C && Ci(C) || (p4 ? N : [N])), X.symbolSize == null && (X.symbolSize = E && Ci(E) || (p4 ? H[0] : [H[0], H[0]])), X.symbol = oEe(X.symbol, function(le) {
            return le === "none" ? N : le;
          });
          var q2 = X.symbolSize;
          if (q2 != null) {
            var de = -1 / 0;
            DAt(q2, function(le) {
              le > de && (de = le);
            }), X.symbolSize = oEe(q2, function(le) {
              return LAt(le, [0, de], [0, H[0]], true);
            });
          }
        }, this);
      }
    }, n2.prototype.resetItemSize = function() {
      this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
    }, n2.prototype.isCategory = function() {
      return !!this.option.categories;
    }, n2.prototype.setSelected = function(e2) {
    }, n2.prototype.getSelected = function() {
      return null;
    }, n2.prototype.getValueState = function(e2) {
      return null;
    }, n2.prototype.getVisualMeta = function(e2) {
      return null;
    }, n2.type = "visualMap", n2.dependencies = ["series"], n2.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, n2;
  }(Ns), o$ = OAt, lEe = [20, 140], RAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.optionUpdated = function(e2, o) {
      i.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(l4) {
        l4.mappingMethod = "linear", l4.dataExtent = this.getExtent();
      }), this._resetRange();
    }, n2.prototype.resetItemSize = function() {
      i.prototype.resetItemSize.apply(this, arguments);
      var e2 = this.itemSize;
      (e2[0] == null || isNaN(e2[0])) && (e2[0] = lEe[0]), (e2[1] == null || isNaN(e2[1])) && (e2[1] = lEe[1]);
    }, n2.prototype._resetRange = function() {
      var e2 = this.getExtent(), o = this.option.range;
      !o || o.auto ? (e2.auto = 1, this.option.range = e2) : Mr(o) && (o[0] > o[1] && o.reverse(), o[0] = Math.max(o[0], e2[0]), o[1] = Math.min(o[1], e2[1]));
    }, n2.prototype.completeVisualOption = function() {
      i.prototype.completeVisualOption.apply(this, arguments), Ve(this.stateList, function(e2) {
        var o = this.option.controller[e2].symbolSize;
        o && o[0] !== o[1] && (o[0] = o[1] / 3);
      }, this);
    }, n2.prototype.setSelected = function(e2) {
      this.option.range = e2.slice(), this._resetRange();
    }, n2.prototype.getSelected = function() {
      var e2 = this.getExtent(), o = Ly((this.get("range") || []).slice());
      return o[0] > e2[1] && (o[0] = e2[1]), o[1] > e2[1] && (o[1] = e2[1]), o[0] < e2[0] && (o[0] = e2[0]), o[1] < e2[0] && (o[1] = e2[0]), o;
    }, n2.prototype.getValueState = function(e2) {
      var o = this.option.range, l4 = this.getExtent();
      return (o[0] <= l4[0] || o[0] <= e2) && (o[1] >= l4[1] || e2 <= o[1]) ? "inRange" : "outOfRange";
    }, n2.prototype.findTargetDataIndices = function(e2) {
      var o = [];
      return this.eachTargetSeries(function(l4) {
        var c4 = [], h = l4.getData();
        h.each(this.getDataDimensionIndex(h), function(p4, g4) {
          e2[0] <= p4 && p4 <= e2[1] && c4.push(g4);
        }, this), o.push({ seriesId: l4.id, dataIndex: c4 });
      }, this), o;
    }, n2.prototype.getVisualMeta = function(e2) {
      var o = uEe(this, "outOfRange", this.getExtent()), l4 = uEe(this, "inRange", this.option.range.slice()), c4 = [];
      function h(E, T) {
        c4.push({ value: E, color: e2(E, T) });
      }
      for (var p4 = 0, g4 = 0, y4 = l4.length, _ = o.length; g4 < _ && (!l4.length || o[g4] <= l4[0]); g4++)
        o[g4] < l4[p4] && h(o[g4], "outOfRange");
      for (var w4 = 1; p4 < y4; p4++, w4 = 0)
        w4 && c4.length && h(l4[p4], "outOfRange"), h(l4[p4], "inRange");
      for (var w4 = 1; g4 < _; g4++)
        (!l4.length || l4[l4.length - 1] < o[g4]) && (w4 && (c4.length && h(c4[c4.length - 1].value, "outOfRange"), w4 = 0), h(o[g4], "outOfRange"));
      var C = c4.length;
      return { stops: c4, outerColors: [C ? c4[0].color : "transparent", C ? c4[C - 1].color : "transparent"] };
    }, n2.type = "visualMap.continuous", n2.defaultOption = sM(o$.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), n2;
  }(o$);
  function uEe(i, n2, e2) {
    if (e2[0] === e2[1])
      return e2.slice();
    for (var o = 200, l4 = (e2[1] - e2[0]) / o, c4 = e2[0], h = [], p4 = 0; p4 <= o && c4 < e2[1]; p4++)
      h.push(c4), c4 += l4;
    return h.push(e2[1]), h;
  }
  var FAt = RAt, NAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, e2;
    }
    return n2.prototype.init = function(e2, o) {
      this.ecModel = e2, this.api = o;
    }, n2.prototype.render = function(e2, o, l4, c4) {
      if (this.visualMapModel = e2, e2.get("show") === false) {
        this.group.removeAll();
        return;
      }
      this.doRender(e2, o, l4, c4);
    }, n2.prototype.renderBackground = function(e2) {
      var o = this.visualMapModel, l4 = X3(o.get("padding") || 0), c4 = e2.getBoundingRect();
      e2.add(new Is({ z2: -1, silent: true, shape: { x: c4.x - l4[3], y: c4.y - l4[0], width: c4.width + l4[3] + l4[1], height: c4.height + l4[0] + l4[2] }, style: { fill: o.get("backgroundColor"), stroke: o.get("borderColor"), lineWidth: o.get("borderWidth") } }));
    }, n2.prototype.getControllerVisual = function(e2, o, l4) {
      l4 = l4 || {};
      var c4 = l4.forceState, h = this.visualMapModel, p4 = {};
      if (o === "color") {
        var g4 = h.get("contentColor");
        p4.color = g4;
      }
      function y4(E) {
        return p4[E];
      }
      function _(E, T) {
        p4[E] = T;
      }
      var w4 = h.controllerVisuals[c4 || h.getValueState(e2)], C = Cp.prepareVisualTypes(w4);
      return Ve(C, function(E) {
        var T = w4[E];
        l4.convertOpacityToAlpha && E === "opacity" && (E = "colorAlpha", T = w4.__alphaForOpacity), Cp.dependsOn(E, o) && T && T.applyVisual(e2, y4, _);
      }), p4[o];
    }, n2.prototype.positionGroup = function(e2) {
      var o = this.visualMapModel, l4 = this.api;
      N$(e2, o.getBoxLayoutParams(), { width: l4.getWidth(), height: l4.getHeight() });
    }, n2.prototype.doRender = function(e2, o, l4, c4) {
    }, n2.type = "visualMap", n2;
  }($c), sLe = NAt, cEe = [["left", "right", "width"], ["top", "bottom", "height"]];
  function lLe(i, n2, e2) {
    var o = i.option, l4 = o.align;
    if (l4 != null && l4 !== "auto")
      return l4;
    for (var c4 = { width: n2.getWidth(), height: n2.getHeight() }, h = o.orient === "horizontal" ? 1 : 0, p4 = cEe[h], g4 = [0, null, 10], y4 = {}, _ = 0; _ < 3; _++)
      y4[cEe[1 - h][_]] = g4[_], y4[p4[_]] = _ === 2 ? e2[0] : o[p4[_]];
    var w4 = [["x", "width", 3], ["y", "height", 0]][h], C = bh(y4, c4, o.padding);
    return p4[(C.margin[w4[2]] || 0) + C[w4[0]] + C[w4[1]] * 0.5 < c4[w4[1]] * 0.5 ? 0 : 1];
  }
  function dH(i, n2) {
    return Ve(i || [], function(e2) {
      e2.dataIndex != null && (e2.dataIndexInside = e2.dataIndex, e2.dataIndex = null), e2.highlightKey = "visualMap" + (n2 ? n2.componentIndex : "");
    }), i;
  }
  var R_ = Tl, VAt = Ve, fEe = Math.min, oie = Math.max, zAt = 12, BAt = 6, jAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._shapes = {}, e2._dataInterval = [], e2._handleEnds = [], e2._hoverLinkDataIndices = [], e2;
    }
    return n2.prototype.doRender = function(e2, o, l4, c4) {
      this._api = l4, (!c4 || c4.type !== "selectDataRange" || c4.from !== this.uid) && this._buildView();
    }, n2.prototype._buildView = function() {
      this.group.removeAll();
      var e2 = this.visualMapModel, o = this.group;
      this._orient = e2.get("orient"), this._useHandle = e2.get("calculable"), this._resetInterval(), this._renderBar(o);
      var l4 = e2.get("text");
      this._renderEndsText(o, l4, 0), this._renderEndsText(o, l4, 1), this._updateView(true), this.renderBackground(o), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(o);
    }, n2.prototype._renderEndsText = function(e2, o, l4) {
      if (!!o) {
        var c4 = o[1 - l4];
        c4 = c4 != null ? c4 + "" : "";
        var h = this.visualMapModel, p4 = h.get("textGap"), g4 = h.itemSize, y4 = this._shapes.mainGroup, _ = this._applyTransform([g4[0] / 2, l4 === 0 ? -p4 : g4[1] + p4], y4), w4 = this._applyTransform(l4 === 0 ? "bottom" : "top", y4), C = this._orient, E = this.visualMapModel.textStyleModel;
        this.group.add(new Qs({ style: { x: _[0], y: _[1], verticalAlign: C === "horizontal" ? "middle" : w4, align: C === "horizontal" ? w4 : "center", text: c4, font: E.getFont(), fill: E.getTextColor() } }));
      }
    }, n2.prototype._renderBar = function(e2) {
      var o = this.visualMapModel, l4 = this._shapes, c4 = o.itemSize, h = this._orient, p4 = this._useHandle, g4 = lLe(o, this.api, c4), y4 = l4.mainGroup = this._createBarGroup(g4), _ = new Ti();
      y4.add(_), _.add(l4.outOfRange = hEe()), _.add(l4.inRange = hEe(null, p4 ? pEe(this._orient) : null, Ia(this._dragHandle, this, "all", false), Ia(this._dragHandle, this, "all", true))), _.setClipPath(new Is({ shape: { x: 0, y: 0, width: c4[0], height: c4[1], r: 3 } }));
      var w4 = o.textStyleModel.getTextRect("\u56FD"), C = oie(w4.width, w4.height);
      p4 && (l4.handleThumbs = [], l4.handleLabels = [], l4.handleLabelPoints = [], this._createHandle(o, y4, 0, c4, C, h), this._createHandle(o, y4, 1, c4, C, h)), this._createIndicator(o, y4, c4, C, h), e2.add(y4);
    }, n2.prototype._createHandle = function(e2, o, l4, c4, h, p4) {
      var g4 = Ia(this._dragHandle, this, l4, false), y4 = Ia(this._dragHandle, this, l4, true), _ = ib(e2.get("handleSize"), c4[0]), w4 = Xf(e2.get("handleIcon"), -_ / 2, -_ / 2, _, _, null, true), C = pEe(this._orient);
      w4.attr({ cursor: C, draggable: true, drift: g4, ondragend: y4, onmousemove: function(V) {
        b2(V.event);
      } }), w4.x = c4[0] / 2, w4.useStyle(e2.getModel("handleStyle").getItemStyle()), w4.setStyle({ strokeNoScale: true, strokeFirst: true }), w4.style.lineWidth *= 2, w4.ensureState("emphasis").style = e2.getModel(["emphasis", "handleStyle"]).getItemStyle(), aT(w4, true), o.add(w4);
      var E = this.visualMapModel.textStyleModel, T = new Qs({ cursor: C, draggable: true, drift: g4, onmousemove: function(V) {
        b2(V.event);
      }, ondragend: y4, style: { x: 0, y: 0, text: "", font: E.getFont(), fill: E.getTextColor() } });
      T.ensureState("blur").style = { opacity: 0.1 }, T.stateTransition = { duration: 200 }, this.group.add(T);
      var O = [_, 0], N = this._shapes;
      N.handleThumbs[l4] = w4, N.handleLabelPoints[l4] = O, N.handleLabels[l4] = T;
    }, n2.prototype._createIndicator = function(e2, o, l4, c4, h) {
      var p4 = ib(e2.get("indicatorSize"), l4[0]), g4 = Xf(e2.get("indicatorIcon"), -p4 / 2, -p4 / 2, p4, p4, null, true);
      g4.attr({ cursor: "move", invisible: true, silent: true, x: l4[0] / 2 });
      var y4 = e2.getModel("indicatorStyle").getItemStyle();
      if (g4 instanceof Ap) {
        var _ = g4.style;
        g4.useStyle(rr({ image: _.image, x: _.x, y: _.y, width: _.width, height: _.height }, y4));
      } else
        g4.useStyle(y4);
      o.add(g4);
      var w4 = this.visualMapModel.textStyleModel, C = new Qs({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: w4.getFont(), fill: w4.getTextColor() } });
      this.group.add(C);
      var E = [(h === "horizontal" ? c4 / 2 : BAt) + l4[0] / 2, 0], T = this._shapes;
      T.indicator = g4, T.indicatorLabel = C, T.indicatorLabelPoint = E, this._firstShowIndicator = true;
    }, n2.prototype._dragHandle = function(e2, o, l4, c4) {
      if (!!this._useHandle) {
        if (this._dragging = !o, !o) {
          var h = this._applyTransform([l4, c4], this._shapes.mainGroup, true);
          this._updateInterval(e2, h[1]), this._hideIndicator(), this._updateView();
        }
        o === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), o ? !this._hovering && this._clearHoverLinkToSeries() : dEe(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[e2], false);
      }
    }, n2.prototype._resetInterval = function() {
      var e2 = this.visualMapModel, o = this._dataInterval = e2.getSelected(), l4 = e2.getExtent(), c4 = [0, e2.itemSize[1]];
      this._handleEnds = [R_(o[0], l4, c4, true), R_(o[1], l4, c4, true)];
    }, n2.prototype._updateInterval = function(e2, o) {
      o = o || 0;
      var l4 = this.visualMapModel, c4 = this._handleEnds, h = [0, l4.itemSize[1]];
      TT(o, c4, h, e2, 0);
      var p4 = l4.getExtent();
      this._dataInterval = [R_(c4[0], h, p4, true), R_(c4[1], h, p4, true)];
    }, n2.prototype._updateView = function(e2) {
      var o = this.visualMapModel, l4 = o.getExtent(), c4 = this._shapes, h = [0, o.itemSize[1]], p4 = e2 ? h : this._handleEnds, g4 = this._createBarVisual(this._dataInterval, l4, p4, "inRange"), y4 = this._createBarVisual(l4, l4, h, "outOfRange");
      c4.inRange.setStyle({ fill: g4.barColor }).setShape("points", g4.barPoints), c4.outOfRange.setStyle({ fill: y4.barColor }).setShape("points", y4.barPoints), this._updateHandle(p4, g4);
    }, n2.prototype._createBarVisual = function(e2, o, l4, c4) {
      var h = { forceState: c4, convertOpacityToAlpha: true }, p4 = this._makeColorGradient(e2, h), g4 = [this.getControllerVisual(e2[0], "symbolSize", h), this.getControllerVisual(e2[1], "symbolSize", h)], y4 = this._createBarPoints(l4, g4);
      return { barColor: new B8(0, 0, 0, 1, p4), barPoints: y4, handlesColor: [p4[0].color, p4[p4.length - 1].color] };
    }, n2.prototype._makeColorGradient = function(e2, o) {
      var l4 = 100, c4 = [], h = (e2[1] - e2[0]) / l4;
      c4.push({ color: this.getControllerVisual(e2[0], "color", o), offset: 0 });
      for (var p4 = 1; p4 < l4; p4++) {
        var g4 = e2[0] + h * p4;
        if (g4 > e2[1])
          break;
        c4.push({ color: this.getControllerVisual(g4, "color", o), offset: p4 / l4 });
      }
      return c4.push({ color: this.getControllerVisual(e2[1], "color", o), offset: 1 }), c4;
    }, n2.prototype._createBarPoints = function(e2, o) {
      var l4 = this.visualMapModel.itemSize;
      return [[l4[0] - o[0], e2[0]], [l4[0], e2[0]], [l4[0], e2[1]], [l4[0] - o[1], e2[1]]];
    }, n2.prototype._createBarGroup = function(e2) {
      var o = this._orient, l4 = this.visualMapModel.get("inverse");
      return new Ti(o === "horizontal" && !l4 ? { scaleX: e2 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : o === "horizontal" && l4 ? { scaleX: e2 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : o === "vertical" && !l4 ? { scaleX: e2 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: e2 === "left" ? 1 : -1 });
    }, n2.prototype._updateHandle = function(e2, o) {
      if (!!this._useHandle) {
        var l4 = this._shapes, c4 = this.visualMapModel, h = l4.handleThumbs, p4 = l4.handleLabels, g4 = c4.itemSize, y4 = c4.getExtent();
        VAt([0, 1], function(_) {
          var w4 = h[_];
          w4.setStyle("fill", o.handlesColor[_]), w4.y = e2[_];
          var C = R_(e2[_], [0, g4[1]], y4, true), E = this.getControllerVisual(C, "symbolSize");
          w4.scaleX = w4.scaleY = E / g4[0], w4.x = g4[0] - E / 2;
          var T = ab(l4.handleLabelPoints[_], hT(w4, this.group));
          p4[_].setStyle({ x: T[0], y: T[1], text: c4.formatValueText(this._dataInterval[_]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", l4.mainGroup) : "center" });
        }, this);
      }
    }, n2.prototype._showIndicator = function(e2, o, l4, c4) {
      var h = this.visualMapModel, p4 = h.getExtent(), g4 = h.itemSize, y4 = [0, g4[1]], _ = this._shapes, w4 = _.indicator;
      if (!!w4) {
        w4.attr("invisible", false);
        var C = { convertOpacityToAlpha: true }, E = this.getControllerVisual(e2, "color", C), T = this.getControllerVisual(e2, "symbolSize"), O = R_(e2, p4, y4, true), N = g4[0] - T / 2, V = { x: w4.x, y: w4.y };
        w4.y = O, w4.x = N;
        var H = ab(_.indicatorLabelPoint, hT(w4, this.group)), X = _.indicatorLabel;
        X.attr("invisible", false);
        var q2 = this._applyTransform("left", _.mainGroup), de = this._orient, le = de === "horizontal";
        X.setStyle({ text: (l4 || "") + h.formatValueText(o), verticalAlign: le ? q2 : "middle", align: le ? "center" : q2 });
        var me = { x: N, y: O, style: { fill: E } }, ye = { style: { x: H[0], y: H[1] } };
        if (h.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
          var be = { duration: 100, easing: "cubicInOut", additive: true };
          w4.x = V.x, w4.y = V.y, w4.animateTo(me, be), X.animateTo(ye, be);
        } else
          w4.attr(me), X.attr(ye);
        this._firstShowIndicator = false;
        var we = this._shapes.handleLabels;
        if (we)
          for (var Pe = 0; Pe < we.length; Pe++)
            this._api.enterBlur(we[Pe]);
      }
    }, n2.prototype._enableHoverLinkToSeries = function() {
      var e2 = this;
      this._shapes.mainGroup.on("mousemove", function(o) {
        if (e2._hovering = true, !e2._dragging) {
          var l4 = e2.visualMapModel.itemSize, c4 = e2._applyTransform([o.offsetX, o.offsetY], e2._shapes.mainGroup, true, true);
          c4[1] = fEe(oie(0, c4[1]), l4[1]), e2._doHoverLinkToSeries(c4[1], 0 <= c4[0] && c4[0] <= l4[0]);
        }
      }).on("mouseout", function() {
        e2._hovering = false, !e2._dragging && e2._clearHoverLinkToSeries();
      });
    }, n2.prototype._enableHoverLinkFromSeries = function() {
      var e2 = this.api.getZr();
      this.visualMapModel.option.hoverLink ? (e2.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), e2.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
    }, n2.prototype._doHoverLinkToSeries = function(e2, o) {
      var l4 = this.visualMapModel, c4 = l4.itemSize;
      if (!!l4.option.hoverLink) {
        var h = [0, c4[1]], p4 = l4.getExtent();
        e2 = fEe(oie(h[0], e2), h[1]);
        var g4 = GAt(l4, p4, h), y4 = [e2 - g4, e2 + g4], _ = R_(e2, h, p4, true), w4 = [R_(y4[0], h, p4, true), R_(y4[1], h, p4, true)];
        y4[0] < h[0] && (w4[0] = -1 / 0), y4[1] > h[1] && (w4[1] = 1 / 0), o && (w4[0] === -1 / 0 ? this._showIndicator(_, w4[1], "< ", g4) : w4[1] === 1 / 0 ? this._showIndicator(_, w4[0], "> ", g4) : this._showIndicator(_, _, "\u2248 ", g4));
        var C = this._hoverLinkDataIndices, E = [];
        (o || dEe(l4)) && (E = this._hoverLinkDataIndices = l4.findTargetDataIndices(w4));
        var T = Ast(C, E);
        this._dispatchHighDown("downplay", dH(T[0], l4)), this._dispatchHighDown("highlight", dH(T[1], l4));
      }
    }, n2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
      var o = e2.target, l4 = this.visualMapModel;
      if (!(!o || Fi(o).dataIndex == null)) {
        var c4 = Fi(o), h = this.ecModel.getSeriesByIndex(c4.seriesIndex);
        if (!!l4.isTargetSeries(h)) {
          var p4 = h.getData(c4.dataType), g4 = p4.getStore().get(l4.getDataDimensionIndex(p4), c4.dataIndex);
          isNaN(g4) || this._showIndicator(g4, g4);
        }
      }
    }, n2.prototype._hideIndicator = function() {
      var e2 = this._shapes;
      e2.indicator && e2.indicator.attr("invisible", true), e2.indicatorLabel && e2.indicatorLabel.attr("invisible", true);
      var o = this._shapes.handleLabels;
      if (o)
        for (var l4 = 0; l4 < o.length; l4++)
          this._api.leaveBlur(o[l4]);
    }, n2.prototype._clearHoverLinkToSeries = function() {
      this._hideIndicator();
      var e2 = this._hoverLinkDataIndices;
      this._dispatchHighDown("downplay", dH(e2, this.visualMapModel)), e2.length = 0;
    }, n2.prototype._clearHoverLinkFromSeries = function() {
      this._hideIndicator();
      var e2 = this.api.getZr();
      e2.off("mouseover", this._hoverLinkFromSeriesMouseOver), e2.off("mouseout", this._hideIndicator);
    }, n2.prototype._applyTransform = function(e2, o, l4, c4) {
      var h = hT(o, c4 ? null : this.group);
      return Mr(e2) ? ab(e2, h, l4) : D$(e2, h, l4);
    }, n2.prototype._dispatchHighDown = function(e2, o) {
      o && o.length && this.api.dispatchAction({ type: e2, batch: o });
    }, n2.prototype.dispose = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, n2.prototype.remove = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, n2.type = "visualMap.continuous", n2;
  }(sLe);
  function hEe(i, n2, e2, o) {
    return new $g({ shape: { points: i }, draggable: !!e2, cursor: n2, drift: e2, onmousemove: function(l4) {
      b2(l4.event);
    }, ondragend: o });
  }
  function GAt(i, n2, e2) {
    var o = zAt / 2, l4 = i.get("hoverLinkDataSize");
    return l4 && (o = R_(l4, n2, e2, true) / 2), o;
  }
  function dEe(i) {
    var n2 = i.get("hoverLinkOnHandle");
    return !!(n2 == null ? i.get("realtime") : n2);
  }
  function pEe(i) {
    return i === "vertical" ? "ns-resize" : "ew-resize";
  }
  var WAt = jAt, HAt = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, $At = function(i, n2) {
    n2.eachComponent({ mainType: "visualMap", query: i }, function(e2) {
      e2.setSelected(i.selected);
    });
  }, UAt = [{ createOnAllSeries: true, reset: function(i, n2) {
    var e2 = [];
    return n2.eachComponent("visualMap", function(o) {
      var l4 = i.pipelineContext;
      !o.isTargetSeries(i) || l4 && l4.large || e2.push(BCt(o.stateList, o.targetVisuals, Ia(o.getValueState, o), o.getDataDimensionIndex(i.getData())));
    }), e2;
  } }, { createOnAllSeries: true, reset: function(i, n2) {
    var e2 = i.getData(), o = [];
    n2.eachComponent("visualMap", function(l4) {
      if (l4.isTargetSeries(i)) {
        var c4 = l4.getVisualMeta(Ia(qAt, null, i, l4)) || { stops: [], outerColors: [] }, h = l4.getDataDimensionIndex(e2);
        h >= 0 && (c4.dimension = h, o.push(c4));
      }
    }), i.getData().setVisual("visualMeta", o);
  } }];
  function qAt(i, n2, e2, o) {
    for (var l4 = n2.targetVisuals[o], c4 = Cp.prepareVisualTypes(l4), h = { color: $8(i.getData(), "color") }, p4 = 0, g4 = c4.length; p4 < g4; p4++) {
      var y4 = c4[p4], _ = l4[y4 === "opacity" ? "__alphaForOpacity" : y4];
      _ && _.applyVisual(e2, w4, C);
    }
    return h.color;
    function w4(E) {
      return h[E];
    }
    function C(E, T) {
      h[E] = T;
    }
  }
  var vEe = Ve;
  function YAt(i) {
    var n2 = i && i.visualMap;
    Mr(n2) || (n2 = n2 ? [n2] : []), vEe(n2, function(e2) {
      if (!!e2) {
        l3(e2, "splitList") && !l3(e2, "pieces") && (e2.pieces = e2.splitList, delete e2.splitList);
        var o = e2.pieces;
        o && Mr(o) && vEe(o, function(l4) {
          mi(l4) && (l3(l4, "start") && !l3(l4, "min") && (l4.min = l4.start), l3(l4, "end") && !l3(l4, "max") && (l4.max = l4.end));
        });
      }
    });
  }
  function l3(i, n2) {
    return i && i.hasOwnProperty && i.hasOwnProperty(n2);
  }
  var gEe = false;
  function uLe(i) {
    gEe || (gEe = true, i.registerSubTypeDefaulter("visualMap", function(n2) {
      return !n2.categories && (!(n2.pieces ? n2.pieces.length > 0 : n2.splitNumber > 0) || n2.calculable) ? "continuous" : "piecewise";
    }), i.registerAction(HAt, $At), Ve(UAt, function(n2) {
      i.registerVisual(i.PRIORITY.VISUAL.COMPONENT, n2);
    }), i.registerPreprocessor(YAt));
  }
  function cLe(i) {
    i.registerComponentModel(FAt), i.registerComponentView(WAt), uLe(i);
  }
  var ZAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2._pieceList = [], e2;
    }
    return n2.prototype.optionUpdated = function(e2, o) {
      i.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
      var l4 = this._mode = this._determineMode();
      this._pieceList = [], XAt[this._mode].call(this, this._pieceList), this._resetSelected(e2, o);
      var c4 = this.option.categories;
      this.resetVisual(function(h, p4) {
        l4 === "categories" ? (h.mappingMethod = "category", h.categories = Ci(c4)) : (h.dataExtent = this.getExtent(), h.mappingMethod = "piecewise", h.pieceList = Er(this._pieceList, function(g4) {
          return g4 = Ci(g4), p4 !== "inRange" && (g4.visual = null), g4;
        }));
      });
    }, n2.prototype.completeVisualOption = function() {
      var e2 = this.option, o = {}, l4 = Cp.listVisualTypes(), c4 = this.isCategory();
      Ve(e2.pieces, function(p4) {
        Ve(l4, function(g4) {
          p4.hasOwnProperty(g4) && (o[g4] = 1);
        });
      }), Ve(o, function(p4, g4) {
        var y4 = false;
        Ve(this.stateList, function(_) {
          y4 = y4 || h(e2, _, g4) || h(e2.target, _, g4);
        }, this), !y4 && Ve(this.stateList, function(_) {
          (e2[_] || (e2[_] = {}))[g4] = oLe.get(g4, _ === "inRange" ? "active" : "inactive", c4);
        });
      }, this);
      function h(p4, g4, y4) {
        return p4 && p4[g4] && p4[g4].hasOwnProperty(y4);
      }
      i.prototype.completeVisualOption.apply(this, arguments);
    }, n2.prototype._resetSelected = function(e2, o) {
      var l4 = this.option, c4 = this._pieceList, h = (o ? l4 : e2).selected || {};
      if (l4.selected = h, Ve(c4, function(g4, y4) {
        var _ = this.getSelectedMapKey(g4);
        h.hasOwnProperty(_) || (h[_] = true);
      }, this), l4.selectedMode === "single") {
        var p4 = false;
        Ve(c4, function(g4, y4) {
          var _ = this.getSelectedMapKey(g4);
          h[_] && (p4 ? h[_] = false : p4 = true);
        }, this);
      }
    }, n2.prototype.getItemSymbol = function() {
      return this.get("itemSymbol");
    }, n2.prototype.getSelectedMapKey = function(e2) {
      return this._mode === "categories" ? e2.value + "" : e2.index + "";
    }, n2.prototype.getPieceList = function() {
      return this._pieceList;
    }, n2.prototype._determineMode = function() {
      var e2 = this.option;
      return e2.pieces && e2.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
    }, n2.prototype.setSelected = function(e2) {
      this.option.selected = Ci(e2);
    }, n2.prototype.getValueState = function(e2) {
      var o = Cp.findPieceIndex(e2, this._pieceList);
      return o != null && this.option.selected[this.getSelectedMapKey(this._pieceList[o])] ? "inRange" : "outOfRange";
    }, n2.prototype.findTargetDataIndices = function(e2) {
      var o = [], l4 = this._pieceList;
      return this.eachTargetSeries(function(c4) {
        var h = [], p4 = c4.getData();
        p4.each(this.getDataDimensionIndex(p4), function(g4, y4) {
          var _ = Cp.findPieceIndex(g4, l4);
          _ === e2 && h.push(y4);
        }, this), o.push({ seriesId: c4.id, dataIndex: h });
      }, this), o;
    }, n2.prototype.getRepresentValue = function(e2) {
      var o;
      if (this.isCategory())
        o = e2.value;
      else if (e2.value != null)
        o = e2.value;
      else {
        var l4 = e2.interval || [];
        o = l4[0] === -1 / 0 && l4[1] === 1 / 0 ? 0 : (l4[0] + l4[1]) / 2;
      }
      return o;
    }, n2.prototype.getVisualMeta = function(e2) {
      if (this.isCategory())
        return;
      var o = [], l4 = ["", ""], c4 = this;
      function h(_, w4) {
        var C = c4.getRepresentValue({ interval: _ });
        w4 || (w4 = c4.getValueState(C));
        var E = e2(C, w4);
        _[0] === -1 / 0 ? l4[0] = E : _[1] === 1 / 0 ? l4[1] = E : o.push({ value: _[0], color: E }, { value: _[1], color: E });
      }
      var p4 = this._pieceList.slice();
      if (!p4.length)
        p4.push({ interval: [-1 / 0, 1 / 0] });
      else {
        var g4 = p4[0].interval[0];
        g4 !== -1 / 0 && p4.unshift({ interval: [-1 / 0, g4] }), g4 = p4[p4.length - 1].interval[1], g4 !== 1 / 0 && p4.push({ interval: [g4, 1 / 0] });
      }
      var y4 = -1 / 0;
      return Ve(p4, function(_) {
        var w4 = _.interval;
        w4 && (w4[0] > y4 && h([y4, w4[0]], "outOfRange"), h(w4.slice()), y4 = w4[1]);
      }, this), { stops: o, outerColors: l4 };
    }, n2.type = "visualMap.piecewise", n2.defaultOption = sM(o$.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), n2;
  }(o$), XAt = { splitNumber: function(i) {
    var n2 = this.option, e2 = Math.min(n2.precision, 20), o = this.getExtent(), l4 = n2.splitNumber;
    l4 = Math.max(parseInt(l4, 10), 1), n2.splitNumber = l4;
    for (var c4 = (o[1] - o[0]) / l4; +c4.toFixed(e2) !== c4 && e2 < 5; )
      e2++;
    n2.precision = e2, c4 = +c4.toFixed(e2), n2.minOpen && i.push({ interval: [-1 / 0, o[0]], close: [0, 0] });
    for (var h = 0, p4 = o[0]; h < l4; p4 += c4, h++) {
      var g4 = h === l4 - 1 ? o[1] : p4 + c4;
      i.push({ interval: [p4, g4], close: [1, 1] });
    }
    n2.maxOpen && i.push({ interval: [o[1], 1 / 0], close: [0, 0] }), lwe(i), Ve(i, function(y4, _) {
      y4.index = _, y4.text = this.formatValueText(y4.interval);
    }, this);
  }, categories: function(i) {
    var n2 = this.option;
    Ve(n2.categories, function(e2) {
      i.push({ text: this.formatValueText(e2, true), value: e2 });
    }, this), mEe(n2, i);
  }, pieces: function(i) {
    var n2 = this.option;
    Ve(n2.pieces, function(e2, o) {
      mi(e2) || (e2 = { value: e2 });
      var l4 = { text: "", index: o };
      if (e2.label != null && (l4.text = e2.label), e2.hasOwnProperty("value")) {
        var c4 = l4.value = e2.value;
        l4.interval = [c4, c4], l4.close = [1, 1];
      } else {
        for (var h = l4.interval = [], p4 = l4.close = [0, 0], g4 = [1, 0, 1], y4 = [-1 / 0, 1 / 0], _ = [], w4 = 0; w4 < 2; w4++) {
          for (var C = [["gte", "gt", "min"], ["lte", "lt", "max"]][w4], E = 0; E < 3 && h[w4] == null; E++)
            h[w4] = e2[C[E]], p4[w4] = g4[E], _[w4] = E === 2;
          h[w4] == null && (h[w4] = y4[w4]);
        }
        _[0] && h[1] === 1 / 0 && (p4[0] = 0), _[1] && h[0] === -1 / 0 && (p4[1] = 0), h[0] === h[1] && p4[0] && p4[1] && (l4.value = h[0]);
      }
      l4.visual = Cp.retrieveVisuals(e2), i.push(l4);
    }, this), mEe(n2, i), lwe(i), Ve(i, function(e2) {
      var o = e2.close, l4 = [["<", "\u2264"][o[1]], [">", "\u2265"][o[0]]];
      e2.text = e2.text || this.formatValueText(e2.value != null ? e2.value : e2.interval, false, l4);
    }, this);
  } };
  function mEe(i, n2) {
    var e2 = i.inverse;
    (i.orient === "vertical" ? !e2 : e2) && n2.reverse();
  }
  var KAt = ZAt, JAt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = n2.type, e2;
    }
    return n2.prototype.doRender = function() {
      var e2 = this.group;
      e2.removeAll();
      var o = this.visualMapModel, l4 = o.get("textGap"), c4 = o.textStyleModel, h = c4.getFont(), p4 = c4.getTextColor(), g4 = this._getItemAlign(), y4 = o.itemSize, _ = this._getViewData(), w4 = _.endsText, C = Nd(o.get("showLabel", true), !w4);
      w4 && this._renderEndsText(e2, w4[0], y4, C, g4), Ve(_.viewPieceList, function(E) {
        var T = E.piece, O = new Ti();
        O.onclick = Ia(this._onItemClick, this, T), this._enableHoverLink(O, E.indexInModelPieceList);
        var N = o.getRepresentValue(T);
        if (this._createItemSymbol(O, N, [0, 0, y4[0], y4[1]]), C) {
          var V = this.visualMapModel.getValueState(N);
          O.add(new Qs({ style: { x: g4 === "right" ? -l4 : y4[0] + l4, y: y4[1] / 2, text: T.text, verticalAlign: "middle", align: g4, font: h, fill: p4, opacity: V === "outOfRange" ? 0.5 : 1 } }));
        }
        e2.add(O);
      }, this), w4 && this._renderEndsText(e2, w4[1], y4, C, g4), dT(o.get("orient"), e2, o.get("itemGap")), this.renderBackground(e2), this.positionGroup(e2);
    }, n2.prototype._enableHoverLink = function(e2, o) {
      var l4 = this;
      e2.on("mouseover", function() {
        return c4("highlight");
      }).on("mouseout", function() {
        return c4("downplay");
      });
      var c4 = function(h) {
        var p4 = l4.visualMapModel;
        p4.option.hoverLink && l4.api.dispatchAction({ type: h, batch: dH(p4.findTargetDataIndices(o), p4) });
      };
    }, n2.prototype._getItemAlign = function() {
      var e2 = this.visualMapModel, o = e2.option;
      if (o.orient === "vertical")
        return lLe(e2, this.api, e2.itemSize);
      var l4 = o.align;
      return (!l4 || l4 === "auto") && (l4 = "left"), l4;
    }, n2.prototype._renderEndsText = function(e2, o, l4, c4, h) {
      if (!!o) {
        var p4 = new Ti(), g4 = this.visualMapModel.textStyleModel;
        p4.add(new Qs({ style: { x: c4 ? h === "right" ? l4[0] : 0 : l4[0] / 2, y: l4[1] / 2, verticalAlign: "middle", align: c4 ? h : "center", text: o, font: g4.getFont(), fill: g4.getTextColor() } })), e2.add(p4);
      }
    }, n2.prototype._getViewData = function() {
      var e2 = this.visualMapModel, o = Er(e2.getPieceList(), function(p4, g4) {
        return { piece: p4, indexInModelPieceList: g4 };
      }), l4 = e2.get("text"), c4 = e2.get("orient"), h = e2.get("inverse");
      return (c4 === "horizontal" ? h : !h) ? o.reverse() : l4 && (l4 = l4.slice().reverse()), { viewPieceList: o, endsText: l4 };
    }, n2.prototype._createItemSymbol = function(e2, o, l4) {
      e2.add(Xf(this.getControllerVisual(o, "symbol"), l4[0], l4[1], l4[2], l4[3], this.getControllerVisual(o, "color")));
    }, n2.prototype._onItemClick = function(e2) {
      var o = this.visualMapModel, l4 = o.option, c4 = Ci(l4.selected), h = o.getSelectedMapKey(e2);
      l4.selectedMode === "single" ? (c4[h] = true, Ve(c4, function(p4, g4) {
        c4[g4] = g4 === h;
      })) : c4[h] = !c4[h], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: c4 });
    }, n2.type = "visualMap.piecewise", n2;
  }(sLe), QAt = JAt;
  function fLe(i) {
    i.registerComponentModel(KAt), i.registerComponentView(QAt), uLe(i);
  }
  function eEt(i) {
    wo(cLe), wo(fLe);
  }
  var tEt = { label: { enabled: true }, decal: { show: false } }, yEe = zs(), nEt = {};
  function rEt(i, n2) {
    var e2 = i.getModel("aria");
    if (!e2.get("enabled"))
      return;
    var o = Ci(tEt);
    to(o.label, i.getLocaleModel().get("aria"), false), to(e2.option, o, false), l4(), c4();
    function l4() {
      var y4 = e2.getModel("decal"), _ = y4.get("show");
      if (_) {
        var w4 = ri();
        i.eachSeries(function(C) {
          if (!C.isColorBySeries()) {
            var E = w4.get(C.type);
            E || (E = {}, w4.set(C.type, E)), yEe(C).scope = E;
          }
        }), i.eachRawSeries(function(C) {
          if (i.isSeriesFiltered(C))
            return;
          if (si(C.enableAriaDecal)) {
            C.enableAriaDecal();
            return;
          }
          var E = C.getData();
          if (C.isColorBySeries()) {
            var H = ooe(C.ecModel, C.name, nEt, i.getSeriesCount()), X = E.getVisual("decal");
            E.setVisual("decal", q2(X, H));
          } else {
            var T = C.getRawData(), O = {}, N = yEe(C).scope;
            E.each(function(de) {
              var le = E.getRawIndex(de);
              O[le] = de;
            });
            var V = T.count();
            T.each(function(de) {
              var le = O[de], me = T.getName(de) || de + "", ye = ooe(C.ecModel, me, N, V), be = E.getItemVisual(le, "decal");
              E.setItemVisual(le, "decal", q2(be, ye));
            });
          }
          function q2(de, le) {
            var me = de ? rr(rr({}, le), de) : le;
            return me.dirty = true, me;
          }
        });
      }
    }
    function c4() {
      var y4 = i.getLocaleModel().get("aria"), _ = e2.getModel("label");
      if (_.option = hi(_.option, y4), !!_.get("enabled")) {
        var w4 = n2.getZr().dom;
        if (_.get("description")) {
          w4.setAttribute("aria-label", _.get("description"));
          return;
        }
        var C = i.getSeriesCount(), E = _.get(["data", "maxCount"]) || 10, T = _.get(["series", "maxCount"]) || 10, O = Math.min(C, T), N;
        if (!(C < 1)) {
          var V = p4();
          if (V) {
            var H = _.get(["general", "withTitle"]);
            N = h(H, { title: V });
          } else
            N = _.get(["general", "withoutTitle"]);
          var X = [], q2 = C > 1 ? _.get(["series", "multiple", "prefix"]) : _.get(["series", "single", "prefix"]);
          N += h(q2, { seriesCount: C }), i.eachSeries(function(ye, be) {
            if (be < O) {
              var we = void 0, Pe = ye.get("name"), ze = Pe ? "withName" : "withoutName";
              we = C > 1 ? _.get(["series", "multiple", ze]) : _.get(["series", "single", ze]), we = h(we, { seriesId: ye.seriesIndex, seriesName: ye.get("name"), seriesType: g4(ye.subType) });
              var Re = ye.getData();
              if (Re.count() > E) {
                var rt2 = _.get(["data", "partialData"]);
                we += h(rt2, { displayCnt: E });
              } else
                we += _.get(["data", "allData"]);
              for (var ft = _.get(["data", "separator", "middle"]), et = _.get(["data", "separator", "end"]), Jt = [], xt = 0; xt < Re.count(); xt++)
                if (xt < E) {
                  var It = Re.getName(xt), Wt = Re.getValues(xt), sn = _.get(["data", It ? "withName" : "withoutName"]);
                  Jt.push(h(sn, { name: It, value: Wt.join(ft) }));
                }
              we += Jt.join(ft) + et, X.push(we);
            }
          });
          var de = _.getModel(["series", "multiple", "separator"]), le = de.get("middle"), me = de.get("end");
          N += X.join(le) + me, w4.setAttribute("aria-label", N);
        }
      }
    }
    function h(y4, _) {
      if (!xa(y4))
        return y4;
      var w4 = y4;
      return Ve(_, function(C, E) {
        w4 = w4.replace(new RegExp("\\{\\s*" + E + "\\s*\\}", "g"), C);
      }), w4;
    }
    function p4() {
      var y4 = i.get("title");
      return y4 && y4.length && (y4 = y4[0]), y4 && y4.text;
    }
    function g4(y4) {
      return i.getLocaleModel().get(["series", "typeNames"])[y4] || "\u81EA\u5B9A\u4E49\u56FE";
    }
  }
  function aEt(i) {
    if (!(!i || !i.aria)) {
      var n2 = i.aria;
      n2.show != null && (n2.enabled = n2.show), n2.label = n2.label || {}, Ve(["description", "general", "series", "data"], function(e2) {
        n2[e2] != null && (n2.label[e2] = n2[e2]);
      });
    }
  }
  function iEt(i) {
    i.registerPreprocessor(aEt), i.registerVisual(i.PRIORITY.VISUAL.ARIA, rEt);
  }
  var bEe = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, oEt = function() {
    function i(n2) {
      var e2 = this._condVal = xa(n2) ? new RegExp(n2) : zit(n2) ? n2 : null;
      if (e2 == null) {
        var o = "";
        dl(o);
      }
    }
    return i.prototype.evaluate = function(n2) {
      var e2 = typeof n2;
      return xa(e2) ? this._condVal.test(n2) : sl(e2) ? this._condVal.test(n2 + "") : false;
    }, i;
  }(), sEt = function() {
    function i() {
    }
    return i.prototype.evaluate = function() {
      return this.value;
    }, i;
  }(), lEt = function() {
    function i() {
    }
    return i.prototype.evaluate = function() {
      for (var n2 = this.children, e2 = 0; e2 < n2.length; e2++)
        if (!n2[e2].evaluate())
          return false;
      return true;
    }, i;
  }(), uEt = function() {
    function i() {
    }
    return i.prototype.evaluate = function() {
      for (var n2 = this.children, e2 = 0; e2 < n2.length; e2++)
        if (n2[e2].evaluate())
          return true;
      return false;
    }, i;
  }(), cEt = function() {
    function i() {
    }
    return i.prototype.evaluate = function() {
      return !this.child.evaluate();
    }, i;
  }(), fEt = function() {
    function i() {
    }
    return i.prototype.evaluate = function() {
      for (var n2 = !!this.valueParser, e2 = this.getValue, o = e2(this.valueGetterParam), l4 = n2 ? this.valueParser(o) : null, c4 = 0; c4 < this.subCondList.length; c4++)
        if (!this.subCondList[c4].evaluate(n2 ? l4 : o))
          return false;
      return true;
    }, i;
  }();
  function Tue(i, n2) {
    if (i === true || i === false) {
      var e2 = new sEt();
      return e2.value = i, e2;
    }
    var o = "";
    return hLe(i) || dl(o), i.and ? _Ee("and", i, n2) : i.or ? _Ee("or", i, n2) : i.not ? hEt(i, n2) : dEt(i, n2);
  }
  function _Ee(i, n2, e2) {
    var o = n2[i], l4 = "";
    Mr(o) || dl(l4), o.length || dl(l4);
    var c4 = i === "and" ? new lEt() : new uEt();
    return c4.children = Er(o, function(h) {
      return Tue(h, e2);
    }), c4.children.length || dl(l4), c4;
  }
  function hEt(i, n2) {
    var e2 = i.not, o = "";
    hLe(e2) || dl(o);
    var l4 = new cEt();
    return l4.child = Tue(e2, n2), l4.child || dl(o), l4;
  }
  function dEt(i, n2) {
    for (var e2 = "", o = n2.prepareGetValue(i), l4 = [], c4 = ts(i), h = i.parser, p4 = h ? GDe(h) : null, g4 = 0; g4 < c4.length; g4++) {
      var y4 = c4[g4];
      if (!(y4 === "parser" || n2.valueGetterAttrMap.get(y4))) {
        var _ = Na(bEe, y4) ? bEe[y4] : y4, w4 = i[y4], C = p4 ? p4(w4) : w4, E = Uct(_, C) || _ === "reg" && new oEt(C);
        E || dl(e2), l4.push(E);
      }
    }
    l4.length || dl(e2);
    var T = new fEt();
    return T.valueGetterParam = o, T.valueParser = p4, T.getValue = n2.getValue, T.subCondList = l4, T;
  }
  function hLe(i) {
    return mi(i) && !gv(i);
  }
  var pEt = function() {
    function i(n2, e2) {
      this._cond = Tue(n2, e2);
    }
    return i.prototype.evaluate = function() {
      return this._cond.evaluate();
    }, i;
  }();
  function vEt(i, n2) {
    return new pEt(i, n2);
  }
  var gEt = { type: "echarts:filter", transform: function(i) {
    for (var n2 = i.upstream, e2, o = vEt(i.config, { valueGetterAttrMap: ri({ dimension: true }), prepareGetValue: function(p4) {
      var g4 = "", y4 = p4.dimension;
      Na(p4, "dimension") || dl(g4);
      var _ = n2.getDimensionInfo(y4);
      return _ || dl(g4), { dimIdx: _.index };
    }, getValue: function(p4) {
      return n2.retrieveValueFromItem(e2, p4.dimIdx);
    } }), l4 = [], c4 = 0, h = n2.count(); c4 < h; c4++)
      e2 = n2.getRawDataItem(c4), o.evaluate() && l4.push(e2);
    return { data: l4 };
  } }, mEt = { type: "echarts:sort", transform: function(i) {
    var n2 = i.upstream, e2 = i.config, o = "", l4 = Zl(e2);
    l4.length || dl(o);
    var c4 = [];
    Ve(l4, function(_) {
      var w4 = _.dimension, C = _.order, E = _.parser, T = _.incomparable;
      if (w4 == null && dl(o), C !== "asc" && C !== "desc" && dl(o), T && T !== "min" && T !== "max") {
        var O = "";
        dl(O);
      }
      if (C !== "asc" && C !== "desc") {
        var N = "";
        dl(N);
      }
      var V = n2.getDimensionInfo(w4);
      V || dl(o);
      var H = E ? GDe(E) : null;
      E && !H && dl(o), c4.push({ dimIdx: V.index, parser: H, comparator: new HDe(C, T) });
    });
    var h = n2.sourceFormat;
    h !== mv && h !== jy && dl(o);
    for (var p4 = [], g4 = 0, y4 = n2.count(); g4 < y4; g4++)
      p4.push(n2.getRawDataItem(g4));
    return p4.sort(function(_, w4) {
      for (var C = 0; C < c4.length; C++) {
        var E = c4[C], T = n2.retrieveValueFromItem(_, E.dimIdx), O = n2.retrieveValueFromItem(w4, E.dimIdx);
        E.parser && (T = E.parser(T), O = E.parser(O));
        var N = E.comparator.evaluate(T, O);
        if (N !== 0)
          return N;
      }
      return 0;
    }), { data: p4 };
  } };
  function yEt(i) {
    i.registerTransform(gEt), i.registerTransform(mEt);
  }
  var bEt = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "dataset", e2;
    }
    return n2.prototype.init = function(e2, o, l4) {
      i.prototype.init.call(this, e2, o, l4), this._sourceManager = new YDe(this), w2e(this);
    }, n2.prototype.mergeOption = function(e2, o) {
      i.prototype.mergeOption.call(this, e2, o), w2e(this);
    }, n2.prototype.optionUpdated = function() {
      this._sourceManager.dirty();
    }, n2.prototype.getSourceManager = function() {
      return this._sourceManager;
    }, n2.type = "dataset", n2.defaultOption = { seriesLayoutBy: $_ }, n2;
  }(Ns), _Et = function(i) {
    on(n2, i);
    function n2() {
      var e2 = i !== null && i.apply(this, arguments) || this;
      return e2.type = "dataset", e2;
    }
    return n2.type = "dataset", n2;
  }($c);
  function xEt(i) {
    i.registerComponentModel(bEt), i.registerComponentView(_Et);
  }
  var L_ = K_.CMD;
  function S3(i, n2) {
    return Math.abs(i - n2) < 1e-5;
  }
  function ase(i) {
    var n2 = i.data, e2 = i.len(), o = [], l4, c4 = 0, h = 0, p4 = 0, g4 = 0;
    function y4(Re, rt2) {
      l4 && l4.length > 2 && o.push(l4), l4 = [Re, rt2];
    }
    function _(Re, rt2, ft, et) {
      S3(Re, ft) && S3(rt2, et) || l4.push(Re, rt2, ft, et, ft, et);
    }
    function w4(Re, rt2, ft, et, Jt, xt) {
      var It = Math.abs(rt2 - Re), Wt = Math.tan(It / 4) * 4 / 3, sn = rt2 < Re ? -1 : 1, vn = Math.cos(Re), $r = Math.sin(Re), ga = Math.cos(rt2), Za = Math.sin(rt2), $a = vn * Jt + ft, Pa = $r * xt + et, da = ga * Jt + ft, Ra = Za * xt + et, Wa = Jt * Wt * sn, wa = xt * Wt * sn;
      l4.push($a - Wa * $r, Pa + wa * vn, da + Wa * Za, Ra - wa * ga, da, Ra);
    }
    for (var C, E, T, O, N = 0; N < e2; ) {
      var V = n2[N++], H = N === 1;
      switch (H && (c4 = n2[N], h = n2[N + 1], p4 = c4, g4 = h, (V === L_.L || V === L_.C || V === L_.Q) && (l4 = [p4, g4])), V) {
        case L_.M:
          c4 = p4 = n2[N++], h = g4 = n2[N++], y4(p4, g4);
          break;
        case L_.L:
          C = n2[N++], E = n2[N++], _(c4, h, C, E), c4 = C, h = E;
          break;
        case L_.C:
          l4.push(n2[N++], n2[N++], n2[N++], n2[N++], c4 = n2[N++], h = n2[N++]);
          break;
        case L_.Q:
          C = n2[N++], E = n2[N++], T = n2[N++], O = n2[N++], l4.push(c4 + 2 / 3 * (C - c4), h + 2 / 3 * (E - h), T + 2 / 3 * (C - T), O + 2 / 3 * (E - O), T, O), c4 = T, h = O;
          break;
        case L_.A:
          var X = n2[N++], q2 = n2[N++], de = n2[N++], le = n2[N++], me = n2[N++], ye = n2[N++] + me;
          N += 1;
          var be = !n2[N++];
          C = Math.cos(me) * de + X, E = Math.sin(me) * le + q2, H ? (p4 = C, g4 = E, y4(p4, g4)) : _(c4, h, C, E), c4 = Math.cos(ye) * de + X, h = Math.sin(ye) * le + q2;
          for (var we = (be ? -1 : 1) * Math.PI / 2, Pe = me; be ? Pe > ye : Pe < ye; Pe += we) {
            var ze = be ? Math.max(Pe + we, ye) : Math.min(Pe + we, ye);
            w4(Pe, ze, X, q2, de, le);
          }
          break;
        case L_.R:
          p4 = c4 = n2[N++], g4 = h = n2[N++], C = p4 + n2[N++], E = g4 + n2[N++], y4(C, g4), _(C, g4, C, E), _(C, E, p4, E), _(p4, E, p4, g4), _(p4, g4, C, g4);
          break;
        case L_.Z:
          l4 && _(c4, h, p4, g4), c4 = p4, h = g4;
          break;
      }
    }
    return l4 && l4.length > 2 && o.push(l4), o;
  }
  function ise(i, n2, e2, o, l4, c4, h, p4, g4, y4) {
    if (S3(i, e2) && S3(n2, o) && S3(l4, h) && S3(c4, p4)) {
      g4.push(h, p4);
      return;
    }
    var _ = 2 / y4, w4 = _ * _, C = h - i, E = p4 - n2, T = Math.sqrt(C * C + E * E);
    C /= T, E /= T;
    var O = e2 - i, N = o - n2, V = l4 - h, H = c4 - p4, X = O * O + N * N, q2 = V * V + H * H;
    if (X < w4 && q2 < w4) {
      g4.push(h, p4);
      return;
    }
    var de = C * O + E * N, le = -C * V - E * H, me = X - de * de, ye = q2 - le * le;
    if (me < w4 && de >= 0 && ye < w4 && le >= 0) {
      g4.push(h, p4);
      return;
    }
    var be = [], we = [];
    KC(i, e2, l4, h, 0.5, be), KC(n2, o, c4, p4, 0.5, we), ise(be[0], we[0], be[1], we[1], be[2], we[2], be[3], we[3], g4, y4), ise(be[4], we[4], be[5], we[5], be[6], we[6], be[7], we[7], g4, y4);
  }
  function wEt(i, n2) {
    var e2 = ase(i), o = [];
    n2 = n2 || 1;
    for (var l4 = 0; l4 < e2.length; l4++) {
      var c4 = e2[l4], h = [], p4 = c4[0], g4 = c4[1];
      h.push(p4, g4);
      for (var y4 = 2; y4 < c4.length; ) {
        var _ = c4[y4++], w4 = c4[y4++], C = c4[y4++], E = c4[y4++], T = c4[y4++], O = c4[y4++];
        ise(p4, g4, _, w4, C, E, T, O, h, n2), p4 = T, g4 = O;
      }
      o.push(h);
    }
    return o;
  }
  function dLe(i, n2, e2) {
    var o = i[n2], l4 = i[1 - n2], c4 = Math.abs(o / l4), h = Math.ceil(Math.sqrt(c4 * e2)), p4 = Math.floor(e2 / h);
    p4 === 0 && (p4 = 1, h = e2);
    for (var g4 = [], y4 = 0; y4 < h; y4++)
      g4.push(p4);
    var _ = h * p4, w4 = e2 - _;
    if (w4 > 0)
      for (var y4 = 0; y4 < w4; y4++)
        g4[y4 % h] += 1;
    return g4;
  }
  function xEe(i, n2, e2) {
    for (var o = i.r0, l4 = i.r, c4 = i.startAngle, h = i.endAngle, p4 = Math.abs(h - c4), g4 = p4 * l4, y4 = l4 - o, _ = g4 > Math.abs(y4), w4 = dLe([g4, y4], _ ? 0 : 1, n2), C = (_ ? p4 : y4) / w4.length, E = 0; E < w4.length; E++)
      for (var T = (_ ? y4 : p4) / w4[E], O = 0; O < w4[E]; O++) {
        var N = {};
        _ ? (N.startAngle = c4 + C * E, N.endAngle = c4 + C * (E + 1), N.r0 = o + T * O, N.r = o + T * (O + 1)) : (N.startAngle = c4 + T * O, N.endAngle = c4 + T * (O + 1), N.r0 = o + C * E, N.r = o + C * (E + 1)), N.clockwise = i.clockwise, N.cx = i.cx, N.cy = i.cy, e2.push(N);
      }
  }
  function SEt(i, n2, e2) {
    for (var o = i.width, l4 = i.height, c4 = o > l4, h = dLe([o, l4], c4 ? 0 : 1, n2), p4 = c4 ? "width" : "height", g4 = c4 ? "height" : "width", y4 = c4 ? "x" : "y", _ = c4 ? "y" : "x", w4 = i[p4] / h.length, C = 0; C < h.length; C++)
      for (var E = i[g4] / h[C], T = 0; T < h[C]; T++) {
        var O = {};
        O[y4] = C * w4, O[_] = T * E, O[p4] = w4, O[g4] = E, O.x += i.x, O.y += i.y, e2.push(O);
      }
  }
  function wEe(i, n2, e2, o) {
    return i * o - e2 * n2;
  }
  function CEt(i, n2, e2, o, l4, c4, h, p4) {
    var g4 = e2 - i, y4 = o - n2, _ = h - l4, w4 = p4 - c4, C = wEe(_, w4, g4, y4);
    if (Math.abs(C) < 1e-6)
      return null;
    var E = i - l4, T = n2 - c4, O = wEe(E, T, _, w4) / C;
    return O < 0 || O > 1 ? null : new Ji(O * g4 + i, O * y4 + n2);
  }
  function MEt(i, n2, e2) {
    var o = new Ji();
    Ji.sub(o, e2, n2), o.normalize();
    var l4 = new Ji();
    Ji.sub(l4, i, n2);
    var c4 = l4.dot(o);
    return c4;
  }
  function u3(i, n2) {
    var e2 = i[i.length - 1];
    e2 && e2[0] === n2[0] && e2[1] === n2[1] || i.push(n2);
  }
  function AEt(i, n2, e2) {
    for (var o = i.length, l4 = [], c4 = 0; c4 < o; c4++) {
      var h = i[c4], p4 = i[(c4 + 1) % o], g4 = CEt(h[0], h[1], p4[0], p4[1], n2.x, n2.y, e2.x, e2.y);
      g4 && l4.push({ projPt: MEt(g4, n2, e2), pt: g4, idx: c4 });
    }
    if (l4.length < 2)
      return [{ points: i }, { points: i }];
    l4.sort(function(N, V) {
      return N.projPt - V.projPt;
    });
    var y4 = l4[0], _ = l4[l4.length - 1];
    if (_.idx < y4.idx) {
      var w4 = y4;
      y4 = _, _ = w4;
    }
    for (var C = [y4.pt.x, y4.pt.y], E = [_.pt.x, _.pt.y], T = [C], O = [E], c4 = y4.idx + 1; c4 <= _.idx; c4++)
      u3(T, i[c4].slice());
    u3(T, E), u3(T, C);
    for (var c4 = _.idx + 1; c4 <= y4.idx + o; c4++)
      u3(O, i[c4 % o].slice());
    return u3(O, C), u3(O, E), [{ points: T }, { points: O }];
  }
  function SEe(i) {
    var n2 = i.points, e2 = [], o = [];
    C$(n2, e2, o);
    var l4 = new mo(e2[0], e2[1], o[0] - e2[0], o[1] - e2[1]), c4 = l4.width, h = l4.height, p4 = l4.x, g4 = l4.y, y4 = new Ji(), _ = new Ji();
    return c4 > h ? (y4.x = _.x = p4 + c4 / 2, y4.y = g4, _.y = g4 + h) : (y4.y = _.y = g4 + h / 2, y4.x = p4, _.x = p4 + c4), AEt(n2, y4, _);
  }
  function s$(i, n2, e2, o) {
    if (e2 === 1)
      o.push(n2);
    else {
      var l4 = Math.floor(e2 / 2), c4 = i(n2);
      s$(i, c4[0], l4, o), s$(i, c4[1], e2 - l4, o);
    }
    return o;
  }
  function EEt(i, n2) {
    for (var e2 = [], o = 0; o < n2; o++)
      e2.push(Yse(i));
    return e2;
  }
  function IEt(i, n2) {
    n2.setStyle(i.style), n2.z = i.z, n2.z2 = i.z2, n2.zlevel = i.zlevel;
  }
  function TEt(i) {
    for (var n2 = [], e2 = 0; e2 < i.length; )
      n2.push([i[e2++], i[e2++]]);
    return n2;
  }
  function DEt(i, n2) {
    var e2 = [], o = i.shape, l4;
    switch (i.type) {
      case "rect":
        SEt(o, n2, e2), l4 = Is;
        break;
      case "sector":
        xEe(o, n2, e2), l4 = Hg;
        break;
      case "circle":
        xEe({ r0: 0, r: o.r, startAngle: 0, endAngle: Math.PI * 2, cx: o.cx, cy: o.cy }, n2, e2), l4 = Hg;
        break;
      default:
        var c4 = i.getComputedTransform(), h = c4 ? Math.sqrt(Math.max(c4[0] * c4[0] + c4[1] * c4[1], c4[2] * c4[2] + c4[3] * c4[3])) : 1, p4 = Er(wEt(i.getUpdatedPathProxy(), h), function(V) {
          return TEt(V);
        }), g4 = p4.length;
        if (g4 === 0)
          s$(SEe, { points: p4[0] }, n2, e2);
        else if (g4 === n2)
          for (var y4 = 0; y4 < g4; y4++)
            e2.push({ points: p4[y4] });
        else {
          var _ = 0, w4 = Er(p4, function(V) {
            var H = [], X = [];
            C$(V, H, X);
            var q2 = (X[1] - H[1]) * (X[0] - H[0]);
            return _ += q2, { poly: V, area: q2 };
          });
          w4.sort(function(V, H) {
            return H.area - V.area;
          });
          for (var C = n2, y4 = 0; y4 < g4; y4++) {
            var E = w4[y4];
            if (C <= 0)
              break;
            var T = y4 === g4 - 1 ? C : Math.ceil(E.area / _ * n2);
            T < 0 || (s$(SEe, { points: E.poly }, T, e2), C -= T);
          }
        }
        l4 = $g;
        break;
    }
    if (!l4)
      return EEt(i, n2);
    for (var O = [], y4 = 0; y4 < e2.length; y4++) {
      var N = new l4();
      N.setShape(e2[y4]), IEt(i, N), O.push(N);
    }
    return O;
  }
  function kEt(i, n2) {
    var e2 = i.length, o = n2.length;
    if (e2 === o)
      return [i, n2];
    for (var l4 = [], c4 = [], h = e2 < o ? i : n2, p4 = Math.min(e2, o), g4 = Math.abs(o - e2) / 6, y4 = (p4 - 2) / 6, _ = Math.ceil(g4 / y4) + 1, w4 = [h[0], h[1]], C = g4, E = 2; E < p4; ) {
      var T = h[E - 2], O = h[E - 1], N = h[E++], V = h[E++], H = h[E++], X = h[E++], q2 = h[E++], de = h[E++];
      if (C <= 0) {
        w4.push(N, V, H, X, q2, de);
        continue;
      }
      for (var le = Math.min(C, _ - 1) + 1, me = 1; me <= le; me++) {
        var ye = me / le;
        KC(T, N, H, q2, ye, l4), KC(O, V, X, de, ye, c4), T = l4[3], O = c4[3], w4.push(l4[1], c4[1], l4[2], c4[2], T, O), N = l4[5], V = c4[5], H = l4[6], X = c4[6];
      }
      C -= le - 1;
    }
    return h === i ? [w4, n2] : [i, w4];
  }
  function CEe(i, n2) {
    for (var e2 = i.length, o = i[e2 - 2], l4 = i[e2 - 1], c4 = [], h = 0; h < n2.length; )
      c4[h++] = o, c4[h++] = l4;
    return c4;
  }
  function PEt(i, n2) {
    for (var e2, o, l4, c4 = [], h = [], p4 = 0; p4 < Math.max(i.length, n2.length); p4++) {
      var g4 = i[p4], y4 = n2[p4], _ = void 0, w4 = void 0;
      g4 ? y4 ? (e2 = kEt(g4, y4), _ = e2[0], w4 = e2[1], o = _, l4 = w4) : (w4 = CEe(l4 || g4, g4), _ = g4) : (_ = CEe(o || y4, y4), w4 = y4), c4.push(_), h.push(w4);
    }
    return [c4, h];
  }
  function MEe(i) {
    for (var n2 = 0, e2 = 0, o = 0, l4 = i.length, c4 = 0, h = l4 - 2; c4 < l4; h = c4, c4 += 2) {
      var p4 = i[h], g4 = i[h + 1], y4 = i[c4], _ = i[c4 + 1], w4 = p4 * _ - y4 * g4;
      n2 += w4, e2 += (p4 + y4) * w4, o += (g4 + _) * w4;
    }
    return n2 === 0 ? [i[0] || 0, i[1] || 0] : [e2 / n2 / 3, o / n2 / 3, n2];
  }
  function LEt(i, n2, e2, o) {
    for (var l4 = (i.length - 2) / 6, c4 = 1 / 0, h = 0, p4 = i.length, g4 = p4 - 2, y4 = 0; y4 < l4; y4++) {
      for (var _ = y4 * 6, w4 = 0, C = 0; C < p4; C += 2) {
        var E = C === 0 ? _ : (_ + C - 2) % g4 + 2, T = i[E] - e2[0], O = i[E + 1] - e2[1], N = n2[C] - o[0], V = n2[C + 1] - o[1], H = N - T, X = V - O;
        w4 += H * H + X * X;
      }
      w4 < c4 && (c4 = w4, h = y4);
    }
    return h;
  }
  function OEt(i) {
    for (var n2 = [], e2 = i.length, o = 0; o < e2; o += 2)
      n2[o] = i[e2 - o - 2], n2[o + 1] = i[e2 - o - 1];
    return n2;
  }
  function REt(i, n2, e2, o) {
    for (var l4 = [], c4, h = 0; h < i.length; h++) {
      var p4 = i[h], g4 = n2[h], y4 = MEe(p4), _ = MEe(g4);
      c4 == null && (c4 = y4[2] < 0 != _[2] < 0);
      var w4 = [], C = [], E = 0, T = 1 / 0, O = [], N = p4.length;
      c4 && (p4 = OEt(p4));
      for (var V = LEt(p4, g4, y4, _) * 6, H = N - 2, X = 0; X < H; X += 2) {
        var q2 = (V + X) % H + 2;
        w4[X + 2] = p4[q2] - y4[0], w4[X + 3] = p4[q2 + 1] - y4[1];
      }
      if (w4[0] = p4[V] - y4[0], w4[1] = p4[V + 1] - y4[1], e2 > 0)
        for (var de = o / e2, le = -o / 2; le <= o / 2; le += de) {
          for (var me = Math.sin(le), ye = Math.cos(le), be = 0, X = 0; X < p4.length; X += 2) {
            var we = w4[X], Pe = w4[X + 1], ze = g4[X] - _[0], Re = g4[X + 1] - _[1], rt2 = ze * ye - Re * me, ft = ze * me + Re * ye;
            O[X] = rt2, O[X + 1] = ft;
            var et = rt2 - we, Jt = ft - Pe;
            be += et * et + Jt * Jt;
          }
          if (be < T) {
            T = be, E = le;
            for (var xt = 0; xt < O.length; xt++)
              C[xt] = O[xt];
          }
        }
      else
        for (var It = 0; It < N; It += 2)
          C[It] = g4[It] - _[0], C[It + 1] = g4[It + 1] - _[1];
      l4.push({ from: w4, to: C, fromCp: y4, toCp: _, rotation: -E });
    }
    return l4;
  }
  function l$(i) {
    return i.__isCombineMorphing;
  }
  var pLe = "__mOriginal_";
  function u$(i, n2, e2) {
    var o = pLe + n2, l4 = i[o] || i[n2];
    i[o] || (i[o] = i[n2]);
    var c4 = e2.replace, h = e2.after, p4 = e2.before;
    i[n2] = function() {
      var g4 = arguments, y4;
      return p4 && p4.apply(this, g4), c4 ? y4 = c4.apply(this, g4) : y4 = l4.apply(this, g4), h && h.apply(this, g4), y4;
    };
  }
  function e8(i, n2) {
    var e2 = pLe + n2;
    i[e2] && (i[n2] = i[e2], i[e2] = null);
  }
  function AEe(i, n2) {
    for (var e2 = 0; e2 < i.length; e2++)
      for (var o = i[e2], l4 = 0; l4 < o.length; ) {
        var c4 = o[l4], h = o[l4 + 1];
        o[l4++] = n2[0] * c4 + n2[2] * h + n2[4], o[l4++] = n2[1] * c4 + n2[3] * h + n2[5];
      }
  }
  function vLe(i, n2) {
    var e2 = i.getUpdatedPathProxy(), o = n2.getUpdatedPathProxy(), l4 = PEt(ase(e2), ase(o)), c4 = l4[0], h = l4[1], p4 = i.getComputedTransform(), g4 = n2.getComputedTransform();
    function y4() {
      this.transform = null;
    }
    p4 && AEe(c4, p4), g4 && AEe(h, g4), u$(n2, "updateTransform", { replace: y4 }), n2.transform = null;
    var _ = REt(c4, h, 10, Math.PI), w4 = [];
    u$(n2, "buildPath", { replace: function(C) {
      for (var E = n2.__morphT, T = 1 - E, O = [], N = 0; N < _.length; N++) {
        var V = _[N], H = V.from, X = V.to, q2 = V.rotation * E, de = V.fromCp, le = V.toCp, me = Math.sin(q2), ye = Math.cos(q2);
        ZW(O, de, le, E);
        for (var be = 0; be < H.length; be += 2) {
          var we = H[be], Pe = H[be + 1], ze = X[be], Re = X[be + 1], rt2 = we * T + ze * E, ft = Pe * T + Re * E;
          w4[be] = rt2 * ye - ft * me + O[0], w4[be + 1] = rt2 * me + ft * ye + O[1];
        }
        var et = w4[0], Jt = w4[1];
        C.moveTo(et, Jt);
        for (var be = 2; be < H.length; ) {
          var ze = w4[be++], Re = w4[be++], xt = w4[be++], It = w4[be++], Wt = w4[be++], sn = w4[be++];
          et === ze && Jt === Re && xt === Wt && It === sn ? C.lineTo(Wt, sn) : C.bezierCurveTo(ze, Re, xt, It, Wt, sn), et = Wt, Jt = sn;
        }
      }
    } });
  }
  function Due(i, n2, e2) {
    if (!i || !n2)
      return n2;
    var o = e2.done, l4 = e2.during;
    vLe(i, n2), n2.__morphT = 0;
    function c4() {
      e8(n2, "buildPath"), e8(n2, "updateTransform"), n2.__morphT = -1, n2.createPathProxy(), n2.dirtyShape();
    }
    return n2.animateTo({ __morphT: 1 }, hi({ during: function(h) {
      n2.dirtyShape(), l4 && l4(h);
    }, done: function() {
      c4(), o && o();
    } }, e2)), n2;
  }
  function FEt(i, n2, e2, o, l4, c4) {
    var h = 16;
    i = l4 === e2 ? 0 : Math.round(32767 * (i - e2) / (l4 - e2)), n2 = c4 === o ? 0 : Math.round(32767 * (n2 - o) / (c4 - o));
    for (var p4 = 0, g4, y4 = (1 << h) / 2; y4 > 0; y4 /= 2) {
      var _ = 0, w4 = 0;
      (i & y4) > 0 && (_ = 1), (n2 & y4) > 0 && (w4 = 1), p4 += y4 * y4 * (3 * _ ^ w4), w4 === 0 && (_ === 1 && (i = y4 - 1 - i, n2 = y4 - 1 - n2), g4 = i, i = n2, n2 = g4);
    }
    return p4;
  }
  function c$(i) {
    var n2 = 1 / 0, e2 = 1 / 0, o = -1 / 0, l4 = -1 / 0, c4 = Er(i, function(p4) {
      var g4 = p4.getBoundingRect(), y4 = p4.getComputedTransform(), _ = g4.x + g4.width / 2 + (y4 ? y4[4] : 0), w4 = g4.y + g4.height / 2 + (y4 ? y4[5] : 0);
      return n2 = Math.min(_, n2), e2 = Math.min(w4, e2), o = Math.max(_, o), l4 = Math.max(w4, l4), [_, w4];
    }), h = Er(c4, function(p4, g4) {
      return { cp: p4, z: FEt(p4[0], p4[1], n2, e2, o, l4), path: i[g4] };
    });
    return h.sort(function(p4, g4) {
      return p4.z - g4.z;
    }).map(function(p4) {
      return p4.path;
    });
  }
  function gLe(i) {
    return DEt(i.path, i.count);
  }
  function ose() {
    return { fromIndividuals: [], toIndividuals: [], count: 0 };
  }
  function NEt(i, n2, e2) {
    var o = [];
    function l4(de) {
      for (var le = 0; le < de.length; le++) {
        var me = de[le];
        l$(me) ? l4(me.childrenRef()) : me instanceof Eo && o.push(me);
      }
    }
    l4(i);
    var c4 = o.length;
    if (!c4)
      return ose();
    var h = e2.dividePath || gLe, p4 = h({ path: n2, count: c4 });
    if (p4.length !== c4)
      return console.error("Invalid morphing: unmatched splitted path"), ose();
    o = c$(o), p4 = c$(p4);
    for (var g4 = e2.done, y4 = e2.during, _ = e2.individualDelay, w4 = new u2(), C = 0; C < c4; C++) {
      var E = o[C], T = p4[C];
      T.parent = n2, T.copyTransform(w4), _ || vLe(E, T);
    }
    n2.__isCombineMorphing = true, n2.childrenRef = function() {
      return p4;
    };
    function O(de) {
      for (var le = 0; le < p4.length; le++)
        p4[le].addSelfToZr(de);
    }
    u$(n2, "addSelfToZr", { after: function(de) {
      O(de);
    } }), u$(n2, "removeSelfFromZr", { after: function(de) {
      for (var le = 0; le < p4.length; le++)
        p4[le].removeSelfFromZr(de);
    } });
    function N() {
      n2.__isCombineMorphing = false, n2.__morphT = -1, n2.childrenRef = null, e8(n2, "addSelfToZr"), e8(n2, "removeSelfFromZr");
    }
    var V = p4.length;
    if (_)
      for (var H = V, X = function() {
        H--, H === 0 && (N(), g4 && g4());
      }, C = 0; C < V; C++) {
        var q2 = _ ? hi({ delay: (e2.delay || 0) + _(C, V, o[C], p4[C]), done: X }, e2) : e2;
        Due(o[C], p4[C], q2);
      }
    else
      n2.__morphT = 0, n2.animateTo({ __morphT: 1 }, hi({ during: function(de) {
        for (var le = 0; le < V; le++) {
          var me = p4[le];
          me.__morphT = n2.__morphT, me.dirtyShape();
        }
        y4 && y4(de);
      }, done: function() {
        N();
        for (var de = 0; de < i.length; de++)
          e8(i[de], "updateTransform");
        g4 && g4();
      } }, e2));
    return n2.__zr && O(n2.__zr), { fromIndividuals: o, toIndividuals: p4, count: V };
  }
  function VEt(i, n2, e2) {
    var o = n2.length, l4 = [], c4 = e2.dividePath || gLe;
    function h(E) {
      for (var T = 0; T < E.length; T++) {
        var O = E[T];
        l$(O) ? h(O.childrenRef()) : O instanceof Eo && l4.push(O);
      }
    }
    if (l$(i)) {
      h(i.childrenRef());
      var p4 = l4.length;
      if (p4 < o)
        for (var g4 = 0, y4 = p4; y4 < o; y4++)
          l4.push(Yse(l4[g4++ % p4]));
      l4.length = o;
    } else {
      l4 = c4({ path: i, count: o });
      for (var _ = i.getComputedTransform(), y4 = 0; y4 < l4.length; y4++)
        l4[y4].setLocalTransform(_);
      if (l4.length !== o)
        return console.error("Invalid morphing: unmatched splitted path"), ose();
    }
    l4 = c$(l4), n2 = c$(n2);
    for (var w4 = e2.individualDelay, y4 = 0; y4 < o; y4++) {
      var C = w4 ? hi({ delay: (e2.delay || 0) + w4(y4, o, l4[y4], n2[y4]) }, e2) : e2;
      Due(l4[y4], n2[y4], C);
    }
    return { fromIndividuals: l4, toIndividuals: n2, count: n2.length };
  }
  function EEe(i) {
    return Mr(i[0]);
  }
  function IEe(i, n2) {
    for (var e2 = [], o = i.length, l4 = 0; l4 < o; l4++)
      e2.push({ one: i[l4], many: [] });
    for (var l4 = 0; l4 < n2.length; l4++) {
      var c4 = n2[l4].length, h = void 0;
      for (h = 0; h < c4; h++)
        e2[h % o].many.push(n2[l4][h]);
    }
    for (var p4 = 0, l4 = o - 1; l4 >= 0; l4--)
      if (!e2[l4].many.length) {
        var g4 = e2[p4].many;
        if (g4.length <= 1)
          if (p4)
            p4 = 0;
          else
            return e2;
        var c4 = g4.length, y4 = Math.ceil(c4 / 2);
        e2[l4].many = g4.slice(y4, c4), e2[p4].many = g4.slice(0, y4), p4++;
      }
    return e2;
  }
  var zEt = { clone: function(i) {
    for (var n2 = [], e2 = 1 - Math.pow(1 - i.path.style.opacity, 1 / i.count), o = 0; o < i.count; o++) {
      var l4 = Yse(i.path);
      l4.setStyle("opacity", e2), n2.push(l4);
    }
    return n2;
  }, split: null };
  function sie(i, n2, e2, o, l4, c4) {
    if (!i.length || !n2.length)
      return;
    var h = U3("update", o, l4);
    if (!(h && h.duration > 0))
      return;
    var p4 = o.getModel("universalTransition").get("delay"), g4 = Object.assign({ setToFinal: true }, h), y4, _;
    EEe(i) && (y4 = i, _ = n2), EEe(n2) && (y4 = n2, _ = i);
    function w4(V, H, X, q2, de) {
      var le = V.many, me = V.one;
      if (le.length === 1 && !de) {
        var ye = H ? le[0] : me, be = H ? me : le[0];
        if (l$(ye))
          w4({ many: [ye], one: be }, true, X, q2, true);
        else {
          var we = p4 ? hi({ delay: p4(X, q2) }, g4) : g4;
          Due(ye, be, we), c4(ye, be, ye, be, we);
        }
      } else
        for (var Pe = hi({ dividePath: zEt[e2], individualDelay: p4 && function(Jt, xt, It, Wt) {
          return p4(Jt + X, q2);
        } }, g4), ze = H ? NEt(le, me, Pe) : VEt(me, le, Pe), Re = ze.fromIndividuals, rt2 = ze.toIndividuals, ft = Re.length, et = 0; et < ft; et++) {
          var we = p4 ? hi({ delay: p4(et, ft) }, g4) : g4;
          c4(Re[et], rt2[et], H ? le[et] : V.one, H ? V.one : le[et], we);
        }
    }
    for (var C = y4 ? y4 === i : i.length > n2.length, E = y4 ? IEe(_, y4) : IEe(C ? n2 : i, [C ? i : n2]), T = 0, O = 0; O < E.length; O++)
      T += E[O].many.length;
    for (var N = 0, O = 0; O < E.length; O++)
      w4(E[O], C, N, T), N += E[O].many.length;
  }
  function XI(i) {
    if (!i)
      return [];
    if (Mr(i)) {
      for (var n2 = [], e2 = 0; e2 < i.length; e2++)
        n2.push(XI(i[e2]));
      return n2;
    }
    var o = [];
    return i.traverse(function(l4) {
      l4 instanceof Eo && !l4.disableMorphing && !l4.invisible && !l4.ignore && o.push(l4);
    }), o;
  }
  var mLe = 1e4, BEt = zs();
  function jEt(i) {
    for (var n2 = i.dimensions, e2 = 0; e2 < n2.length; e2++) {
      var o = i.getDimensionInfo(n2[e2]);
      if (o && o.otherDims.itemGroupId === 0)
        return n2[e2];
    }
  }
  function TEe(i) {
    var n2 = [];
    return Ve(i, function(e2) {
      var o = e2.data;
      if (!(o.count() > mLe))
        for (var l4 = o.getIndices(), c4 = jEt(o), h = 0; h < l4.length; h++)
          n2.push({ data: o, dim: e2.dim || c4, divide: e2.divide, dataIndex: h });
    }), n2;
  }
  function lie(i, n2, e2) {
    i.traverse(function(o) {
      o instanceof Eo && bc(o, { style: { opacity: 0 } }, n2, { dataIndex: e2, isFrom: true });
    });
  }
  function uie(i) {
    if (i.parent) {
      var n2 = i.getComputedTransform();
      i.setLocalTransform(n2), i.parent.remove(i);
    }
  }
  function c3(i) {
    i.stopAnimation(), i.isGroup && i.traverse(function(n2) {
      n2.stopAnimation();
    });
  }
  function GEt(i, n2, e2) {
    var o = U3("update", e2, n2);
    o && i.traverse(function(l4) {
      if (l4 instanceof Vy) {
        var c4 = wut(l4);
        c4 && l4.animateFrom({ style: c4 }, o);
      }
    });
  }
  function WEt(i, n2) {
    var e2 = i.length;
    if (e2 !== n2.length)
      return false;
    for (var o = 0; o < e2; o++) {
      var l4 = i[o], c4 = n2[o];
      if (l4.data.getId(l4.dataIndex) !== c4.data.getId(c4.dataIndex))
        return false;
    }
    return true;
  }
  function yLe(i, n2, e2) {
    var o = TEe(i), l4 = TEe(n2);
    function c4(V, H, X, q2, de) {
      (X || V) && H.animateFrom({ style: X && X !== V ? rr(rr({}, X.style), V.style) : V.style }, de);
    }
    function h(V) {
      for (var H = 0; H < V.length; H++)
        if (V[H].dim)
          return V[H].dim;
    }
    var p4 = h(o), g4 = h(l4), y4 = false;
    function _(V, H) {
      return function(X) {
        var q2 = X.data, de = X.dataIndex;
        if (H)
          return q2.getId(de);
        var le = q2.hostModel && q2.hostModel.get("dataGroupId"), me = V ? p4 || g4 : g4 || p4, ye = me && q2.getDimensionInfo(me), be = ye && ye.ordinalMeta;
        if (ye) {
          var we = q2.get(ye.name, de);
          return be && be.categories[we] || we + "";
        }
        var Pe = q2.getRawDataItem(de);
        return Pe && Pe.groupId ? Pe.groupId + "" : le || q2.getId(de);
      };
    }
    var w4 = WEt(o, l4), C = {};
    if (!w4)
      for (var E = 0; E < l4.length; E++) {
        var T = l4[E], O = T.data.getItemGraphicEl(T.dataIndex);
        O && (C[O.id] = true);
      }
    function N(V, H) {
      var X = o[H], q2 = l4[V], de = q2.data.hostModel, le = X.data.getItemGraphicEl(X.dataIndex), me = q2.data.getItemGraphicEl(q2.dataIndex);
      if (le === me) {
        me && GEt(me, q2.dataIndex, de);
        return;
      }
      le && C[le.id] || me && (c3(me), le ? (c3(le), uie(le), y4 = true, sie(XI(le), XI(me), q2.divide, de, V, c4)) : lie(me, de, V));
    }
    new x2(o, l4, _(true, w4), _(false, w4), null, "multiple").update(N).updateManyToOne(function(V, H) {
      var X = l4[V], q2 = X.data, de = q2.hostModel, le = q2.getItemGraphicEl(X.dataIndex), me = Yl(Er(H, function(ye) {
        return o[ye].data.getItemGraphicEl(o[ye].dataIndex);
      }), function(ye) {
        return ye && ye !== le && !C[ye.id];
      });
      le && (c3(le), me.length ? (Ve(me, function(ye) {
        c3(ye), uie(ye);
      }), y4 = true, sie(XI(me), XI(le), X.divide, de, V, c4)) : lie(le, de, X.dataIndex));
    }).updateOneToMany(function(V, H) {
      var X = o[H], q2 = X.data.getItemGraphicEl(X.dataIndex);
      if (!(q2 && C[q2.id])) {
        var de = Yl(Er(V, function(me) {
          return l4[me].data.getItemGraphicEl(l4[me].dataIndex);
        }), function(me) {
          return me && me !== q2;
        }), le = l4[V[0]].data.hostModel;
        de.length && (Ve(de, function(me) {
          return c3(me);
        }), q2 ? (c3(q2), uie(q2), y4 = true, sie(XI(q2), XI(de), X.divide, le, V[0], c4)) : Ve(de, function(me) {
          return lie(me, le, V[0]);
        }));
      }
    }).updateManyToMany(function(V, H) {
      new x2(H, V, function(X) {
        return o[X].data.getId(o[X].dataIndex);
      }, function(X) {
        return l4[X].data.getId(l4[X].dataIndex);
      }).update(function(X, q2) {
        N(V[X], H[q2]);
      }).execute();
    }).execute(), y4 && Ve(n2, function(V) {
      var H = V.data, X = H.hostModel, q2 = X && e2.getViewOfSeriesModel(X), de = U3("update", X, 0);
      q2 && X.isAnimationEnabled() && de && de.duration > 0 && q2.group.traverse(function(le) {
        le instanceof Eo && !le.animators.length && le.animateFrom({ style: { opacity: 0 } }, de);
      });
    });
  }
  function DEe(i) {
    var n2 = i.getModel("universalTransition").get("seriesKey");
    return n2 || i.id;
  }
  function kEe(i) {
    return Mr(i) ? i.sort().join(",") : i;
  }
  function OC(i) {
    if (i.hostModel)
      return i.hostModel.getModel("universalTransition").get("divideShape");
  }
  function HEt(i, n2) {
    var e2 = ri(), o = ri(), l4 = ri();
    return Ve(i.oldSeries, function(c4, h) {
      var p4 = i.oldData[h], g4 = DEe(c4), y4 = kEe(g4);
      o.set(y4, p4), Mr(g4) && Ve(g4, function(_) {
        l4.set(_, { data: p4, key: y4 });
      });
    }), Ve(n2.updatedSeries, function(c4) {
      if (c4.isUniversalTransitionEnabled() && c4.isAnimationEnabled()) {
        var h = c4.getData(), p4 = DEe(c4), g4 = kEe(p4), y4 = o.get(g4);
        if (y4)
          e2.set(g4, { oldSeries: [{ divide: OC(y4), data: y4 }], newSeries: [{ divide: OC(h), data: h }] });
        else if (Mr(p4)) {
          var _ = [];
          Ve(p4, function(E) {
            var T = o.get(E);
            T && _.push({ divide: OC(T), data: T });
          }), _.length && e2.set(g4, { oldSeries: _, newSeries: [{ data: h, divide: OC(h) }] });
        } else {
          var w4 = l4.get(p4);
          if (w4) {
            var C = e2.get(w4.key);
            C || (C = { oldSeries: [{ data: w4.data, divide: OC(w4.data) }], newSeries: [] }, e2.set(w4.key, C)), C.newSeries.push({ data: h, divide: OC(h) });
          }
        }
      }
    }), e2;
  }
  function PEe(i, n2) {
    for (var e2 = 0; e2 < i.length; e2++) {
      var o = n2.seriesIndex != null && n2.seriesIndex === i[e2].seriesIndex || n2.seriesId != null && n2.seriesId === i[e2].id;
      if (o)
        return e2;
    }
  }
  function $Et(i, n2, e2, o) {
    var l4 = [], c4 = [];
    Ve(Zl(i.from), function(h) {
      var p4 = PEe(n2.oldSeries, h);
      p4 >= 0 && l4.push({ data: n2.oldData[p4], divide: OC(n2.oldData[p4]), dim: h.dimension });
    }), Ve(Zl(i.to), function(h) {
      var p4 = PEe(e2.updatedSeries, h);
      if (p4 >= 0) {
        var g4 = e2.updatedSeries[p4].getData();
        c4.push({ data: g4, divide: OC(g4), dim: h.dimension });
      }
    }), l4.length > 0 && c4.length > 0 && yLe(l4, c4, o);
  }
  function UEt(i) {
    i.registerUpdateLifecycle("series:beforeupdate", function(n2, e2, o) {
      Ve(Zl(o.seriesTransition), function(l4) {
        Ve(Zl(l4.to), function(c4) {
          for (var h = o.updatedSeries, p4 = 0; p4 < h.length; p4++)
            (c4.seriesIndex != null && c4.seriesIndex === h[p4].seriesIndex || c4.seriesId != null && c4.seriesId === h[p4].id) && (h[p4][sH] = true);
        });
      });
    }), i.registerUpdateLifecycle("series:transition", function(n2, e2, o) {
      var l4 = BEt(e2);
      if (l4.oldSeries && o.updatedSeries && o.optionChanged) {
        var c4 = o.seriesTransition;
        if (c4)
          Ve(Zl(c4), function(C) {
            $Et(C, l4, o, e2);
          });
        else {
          var h = HEt(l4, o);
          Ve(h.keys(), function(C) {
            var E = h.get(C);
            yLe(E.oldSeries, E.newSeries, e2);
          });
        }
        Ve(o.updatedSeries, function(C) {
          C[sH] && (C[sH] = false);
        });
      }
      for (var p4 = n2.getSeries(), g4 = l4.oldSeries = [], y4 = l4.oldData = [], _ = 0; _ < p4.length; _++) {
        var w4 = p4[_].getData();
        w4.count() < mLe && (g4.push(p4[_]), y4.push(w4));
      }
    });
  }
  wo([cvt]);
  wo([rvt]);
  wo([Ovt, Jvt, cgt, Jgt, v0t, umt, Bmt, Ayt, e1t, u1t, _1t, Cbt, Kbt, f_t, D_t, N_t, txt, fxt, Cxt, Pxt, $xt, Twt]);
  wo(Jwt);
  wo(P2t);
  wo(hPe);
  wo(Z2t);
  wo(QPe);
  wo(nSt);
  wo(fSt);
  wo(hCt);
  wo(RCt);
  wo(r9);
  wo(tMt);
  wo(aMt);
  wo(bMt);
  wo(TMt);
  wo(NMt);
  wo($Mt);
  wo(iAt);
  wo(EAt);
  wo(aLe);
  wo(iLe);
  wo(eEt);
  wo(cLe);
  wo(fLe);
  wo(iEt);
  wo(yEt);
  wo(xEt);
  wo(UEt);
  wo(wpt);
  function qEt(i) {
    const { defaultOptions: n2 } = i != null ? i : {}, e2 = il.useRef(null), o = il.useRef(), l4 = il.useRef(n2);
    return il.useEffect(() => {
      if (!e2.current)
        return;
      const c4 = Vht(e2.current);
      o.current = c4, l4.current && c4.setOption(l4.current);
    }, []), il.useEffect(() => () => {
      var c4, h, p4, g4;
      (h = (c4 = o.current) == null ? void 0 : c4.dispose) == null || h.call(c4), (g4 = (p4 = o.current) == null ? void 0 : p4.off) == null || g4.call(p4, "*"), o.current = void 0;
    }, []), wit("resize", () => {
      requestAnimationFrame(() => {
        var c4, h;
        (h = (c4 = o == null ? void 0 : o.current) == null ? void 0 : c4.resize) == null || h.call(c4);
      });
    }), { chart: o, container: e2 };
  }
  class YEt {
    constructor() {
      Vg(this, "chartsEmitters", /* @__PURE__ */ new Map());
      Vg(this, "add", (n2, e2, o, l4) => {
        e2 && o ? this.chartsEmitters.set(n2, { chart: e2, option: o, title: l4 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
      });
      Vg(this, "get", (n2) => this.chartsEmitters.get(n2));
      Vg(this, "clear", () => {
        this.chartsEmitters.clear();
      });
      Vg(this, "delete", (n2) => {
        this.chartsEmitters.delete(n2);
      });
      Vg(this, "list", () => {
        var e2, o, l4;
        const n2 = [];
        for (const c4 of this.chartsEmitters.keys())
          n2.push({ id: c4, chart: (e2 = this.chartsEmitters.get(c4)) == null ? void 0 : e2.chart, option: (o = this.chartsEmitters.get(c4)) == null ? void 0 : o.option, title: (l4 = this.chartsEmitters.get(c4)) == null ? void 0 : l4.title });
        return n2;
      });
    }
  }
  const ZEt = new YEt();
  var f$ = { exports: {} };
  /**
  * @license
  * Lodash <https://lodash.com/>
  * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
  * Released under MIT license <https://lodash.com/license>
  * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
  * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
  */
  (function(i, n2) {
    (function() {
      var e2, o = "4.17.21", l4 = 200, c4 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", h = "Expected a function", p4 = "Invalid `variable` option passed into `_.template`", g4 = "__lodash_hash_undefined__", y4 = 500, _ = "__lodash_placeholder__", w4 = 1, C = 2, E = 4, T = 1, O = 2, N = 1, V = 2, H = 4, X = 8, q2 = 16, de = 32, le = 64, me = 128, ye = 256, be = 512, we = 30, Pe = "...", ze = 800, Re = 16, rt2 = 1, ft = 2, et = 3, Jt = 1 / 0, xt = 9007199254740991, It = 17976931348623157e292, Wt = 0 / 0, sn = 4294967295, vn = sn - 1, $r = sn >>> 1, ga = [["ary", me], ["bind", N], ["bindKey", V], ["curry", X], ["curryRight", q2], ["flip", be], ["partial", de], ["partialRight", le], ["rearg", ye]], Za = "[object Arguments]", $a = "[object Array]", Pa = "[object AsyncFunction]", da = "[object Boolean]", Ra = "[object Date]", Wa = "[object DOMException]", wa = "[object Error]", li = "[object Function]", Ts = "[object GeneratorFunction]", wi = "[object Map]", ps = "[object Number]", Bs = "[object Null]", vl = "[object Object]", If = "[object Promise]", Xl = "[object Proxy]", _h = "[object RegExp]", Nl = "[object Set]", Uc = "[object String]", Nu = "[object Symbol]", om = "[object Undefined]", Rr = "[object WeakMap]", $n = "[object WeakSet]", Bn = "[object ArrayBuffer]", Fr = "[object DataView]", Oa = "[object Float32Array]", yi = "[object Float64Array]", Bo = "[object Int8Array]", jo = "[object Int16Array]", xl = "[object Int32Array]", Uu = "[object Uint8Array]", vu = "[object Uint8ClampedArray]", qc = "[object Uint16Array]", gu = "[object Uint32Array]", td = /\b__p \+= '';/g, jd = /\b(__p \+=) '' \+/g, Qv = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Gd = /&(?:amp|lt|gt|quot|#39);/g, xc = /[&<>"']/g, js = RegExp(Gd.source), vf = RegExp(xc.source), xh = /<%-([\s\S]+?)%>/g, eg = /<%([\s\S]+?)%>/g, Ep = /<%=([\s\S]+?)%>/g, Wd = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, bv = /^\w*$/, ub = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, Gy = /[\\^$.*+?()[\]{}|]/g, uM = RegExp(Gy.source), Wy = /^\s+/, oL = /\s/, sL = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, lL = /\{\n\/\* \[wrapped with (.+)\] \*/, uL = /,? & /, E2 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Lt = /[()=,{}\[\]\/\s]/, zt = /\\(\\)?/g, lt2 = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, Et = /\w*$/, kt = /^[-+]0x[0-9a-f]+$/i, tt = /^0b[01]+$/i, Ir = /^\[object .+?Constructor\]$/, hr = /^0o[0-7]+$/i, hn = /^(?:0|[1-9]\d*)$/, oa = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, ha = /($^)/, Zo = /['\n\r\u2028\u2029\\]/g, Ds = "\\ud800-\\udfff", Gs = "\\u0300-\\u036f", ns = "\\ufe20-\\ufe2f", Vl = "\\u20d0-\\u20ff", ac = Gs + ns + Vl, yo = "\\u2700-\\u27bf", Yc = "a-z\\xdf-\\xf6\\xf8-\\xff", Tc = "\\xac\\xb1\\xd7\\xf7", tg = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", tx = "\\u2000-\\u206f", nd = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", sm = "A-Z\\xc0-\\xd6\\xd8-\\xde", Hy = "\\ufe0e\\ufe0f", Tf = Tc + tg + tx + nd, ng = "['\u2019]", nx = "[" + Ds + "]", lm = "[" + Tf + "]", um = "[" + ac + "]", $y = "\\d+", cM = "[" + yo + "]", rx = "[" + Yc + "]", cb = "[^" + Ds + Tf + $y + yo + Yc + sm + "]", Qa = "\\ud83c[\\udffb-\\udfff]", Di = "(?:" + um + "|" + Qa + ")", ax = "[^" + Ds + "]", qn = "(?:\\ud83c[\\udde6-\\uddff]){2}", ei = "[\\ud800-\\udbff][\\udc00-\\udfff]", Vi = "[" + sm + "]", l9 = "\\u200d", Dc = "(?:" + rx + "|" + cb + ")", rd = "(?:" + Vi + "|" + cb + ")", Ne = "(?:" + ng + "(?:d|ll|m|re|s|t|ve))?", wr = "(?:" + ng + "(?:D|LL|M|RE|S|T|VE))?", qg = Di + "?", gl = "[" + Hy + "]?", gU = "(?:" + l9 + "(?:" + [ax, qn, ei].join("|") + ")" + gl + qg + ")*", Po = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", mU = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Ca = gl + qg + gU, Oi = "(?:" + [cM, qn, ei].join("|") + ")" + Ca, br = "(?:" + [ax + um + "?", um, qn, ei, nx].join("|") + ")", ti = RegExp(ng, "g"), _a2 = RegExp(um, "g"), fM = RegExp(Qa + "(?=" + Qa + ")|" + br + Ca, "g"), ks = RegExp([Vi + "?" + rx + "+" + Ne + "(?=" + [lm, Vi, "$"].join("|") + ")", rd + "+" + wr + "(?=" + [lm, Vi + Dc, "$"].join("|") + ")", Vi + "?" + Dc + "+" + Ne, Vi + "+" + wr, mU, Po, $y, Oi].join("|"), "g"), ui = RegExp("[" + l9 + Ds + ac + Hy + "]"), u9 = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, _v = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], hM = -1, au = {};
      au[Oa] = au[yi] = au[Bo] = au[jo] = au[xl] = au[Uu] = au[vu] = au[qc] = au[gu] = true, au[Za] = au[$a] = au[Bn] = au[da] = au[Fr] = au[Ra] = au[wa] = au[li] = au[wi] = au[ps] = au[vl] = au[_h] = au[Nl] = au[Uc] = au[Rr] = false;
      var Vu = {};
      Vu[Za] = Vu[$a] = Vu[Bn] = Vu[Fr] = Vu[da] = Vu[Ra] = Vu[Oa] = Vu[yi] = Vu[Bo] = Vu[jo] = Vu[xl] = Vu[wi] = Vu[ps] = Vu[vl] = Vu[_h] = Vu[Nl] = Vu[Uc] = Vu[Nu] = Vu[Uu] = Vu[vu] = Vu[qc] = Vu[gu] = true, Vu[wa] = Vu[li] = Vu[Rr] = false;
      var yU = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, dM = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, Jf = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, qi = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, Uy = parseFloat, cL = parseInt, DT = typeof Dy == "object" && Dy && Dy.Object === Object && Dy, Hd = typeof self == "object" && self && self.Object === Object && self, mu = DT || Hd || Function("return this")(), kT = n2 && !n2.nodeType && n2, cm = kT && true && i && !i.nodeType && i, I2 = cm && cm.exports === kT, fL = I2 && DT.process, Ta = function() {
        try {
          var dn = cm && cm.require && cm.require("util").types;
          return dn || fL && fL.binding && fL.binding("util");
        } catch {
        }
      }(), PT = Ta && Ta.isArrayBuffer, pM = Ta && Ta.isDate, hL = Ta && Ta.isMap, Da = Ta && Ta.isRegExp, kc = Ta && Ta.isSet, vM = Ta && Ta.isTypedArray;
      function Df(dn, Dr, Jn) {
        switch (Jn.length) {
          case 0:
            return dn.call(Dr);
          case 1:
            return dn.call(Dr, Jn[0]);
          case 2:
            return dn.call(Dr, Jn[0], Jn[1]);
          case 3:
            return dn.call(Dr, Jn[0], Jn[1], Jn[2]);
        }
        return dn.apply(Dr, Jn);
      }
      function $d(dn, Dr, Jn, ci) {
        for (var Io = -1, Dl = dn == null ? 0 : dn.length; ++Io < Dl; ) {
          var mf = dn[Io];
          Dr(ci, mf, Jn(mf), dn);
        }
        return ci;
      }
      function gf(dn, Dr) {
        for (var Jn = -1, ci = dn == null ? 0 : dn.length; ++Jn < ci && Dr(dn[Jn], Jn, dn) !== false; )
          ;
        return dn;
      }
      function bU(dn, Dr) {
        for (var Jn = dn == null ? 0 : dn.length; Jn-- && Dr(dn[Jn], Jn, dn) !== false; )
          ;
        return dn;
      }
      function dL(dn, Dr) {
        for (var Jn = -1, ci = dn == null ? 0 : dn.length; ++Jn < ci; )
          if (!Dr(dn[Jn], Jn, dn))
            return false;
        return true;
      }
      function fm(dn, Dr) {
        for (var Jn = -1, ci = dn == null ? 0 : dn.length, Io = 0, Dl = []; ++Jn < ci; ) {
          var mf = dn[Jn];
          Dr(mf, Jn, dn) && (Dl[Io++] = mf);
        }
        return Dl;
      }
      function hm(dn, Dr) {
        var Jn = dn == null ? 0 : dn.length;
        return !!Jn && xv(dn, Dr, 0) > -1;
      }
      function gM(dn, Dr, Jn) {
        for (var ci = -1, Io = dn == null ? 0 : dn.length; ++ci < Io; )
          if (Jn(Dr, dn[ci]))
            return true;
        return false;
      }
      function ic(dn, Dr) {
        for (var Jn = -1, ci = dn == null ? 0 : dn.length, Io = Array(ci); ++Jn < ci; )
          Io[Jn] = Dr(dn[Jn], Jn, dn);
        return Io;
      }
      function dm(dn, Dr) {
        for (var Jn = -1, ci = Dr.length, Io = dn.length; ++Jn < ci; )
          dn[Io + Jn] = Dr[Jn];
        return dn;
      }
      function ix(dn, Dr, Jn, ci) {
        var Io = -1, Dl = dn == null ? 0 : dn.length;
        for (ci && Dl && (Jn = dn[++Io]); ++Io < Dl; )
          Jn = Dr(Jn, dn[Io], Io, dn);
        return Jn;
      }
      function pL(dn, Dr, Jn, ci) {
        var Io = dn == null ? 0 : dn.length;
        for (ci && Io && (Jn = dn[--Io]); Io--; )
          Jn = Dr(Jn, dn[Io], Io, dn);
        return Jn;
      }
      function pm(dn, Dr) {
        for (var Jn = -1, ci = dn == null ? 0 : dn.length; ++Jn < ci; )
          if (Dr(dn[Jn], Jn, dn))
            return true;
        return false;
      }
      var _U = vL("length");
      function ox(dn) {
        return dn.split("");
      }
      function LT(dn) {
        return dn.match(E2) || [];
      }
      function Qf(dn, Dr, Jn) {
        var ci;
        return Jn(dn, function(Io, Dl, mf) {
          if (Dr(Io, Dl, mf))
            return ci = Dl, false;
        }), ci;
      }
      function Yg(dn, Dr, Jn, ci) {
        for (var Io = dn.length, Dl = Jn + (ci ? 1 : -1); ci ? Dl-- : ++Dl < Io; )
          if (Dr(dn[Dl], Dl, dn))
            return Dl;
        return -1;
      }
      function xv(dn, Dr, Jn) {
        return Dr === Dr ? SU(dn, Dr, Jn) : Yg(dn, c9, Jn);
      }
      function T2(dn, Dr, Jn, ci) {
        for (var Io = Jn - 1, Dl = dn.length; ++Io < Dl; )
          if (ci(dn[Io], Dr))
            return Io;
        return -1;
      }
      function c9(dn) {
        return dn !== dn;
      }
      function f9(dn, Dr) {
        var Jn = dn == null ? 0 : dn.length;
        return Jn ? OT(dn, Dr) / Jn : Wt;
      }
      function vL(dn) {
        return function(Dr) {
          return Dr == null ? e2 : Dr[dn];
        };
      }
      function Ip(dn) {
        return function(Dr) {
          return dn == null ? e2 : dn[Dr];
        };
      }
      function h9(dn, Dr, Jn, ci, Io) {
        return Io(dn, function(Dl, mf, Kl) {
          Jn = ci ? (ci = false, Dl) : Dr(Jn, Dl, mf, Kl);
        }), Jn;
      }
      function gL(dn, Dr) {
        var Jn = dn.length;
        for (dn.sort(Dr); Jn--; )
          dn[Jn] = dn[Jn].value;
        return dn;
      }
      function OT(dn, Dr) {
        for (var Jn, ci = -1, Io = dn.length; ++ci < Io; ) {
          var Dl = Dr(dn[ci]);
          Dl !== e2 && (Jn = Jn === e2 ? Dl : Jn + Dl);
        }
        return Jn;
      }
      function RT(dn, Dr) {
        for (var Jn = -1, ci = Array(dn); ++Jn < dn; )
          ci[Jn] = Dr(Jn);
        return ci;
      }
      function mL(dn, Dr) {
        return ic(Dr, function(Jn) {
          return [Jn, dn[Jn]];
        });
      }
      function d9(dn) {
        return dn && dn.slice(0, m9(dn) + 1).replace(Wy, "");
      }
      function Ud(dn) {
        return function(Dr) {
          return dn(Dr);
        };
      }
      function yL(dn, Dr) {
        return ic(Dr, function(Jn) {
          return dn[Jn];
        });
      }
      function mM(dn, Dr) {
        return dn.has(Dr);
      }
      function bL(dn, Dr) {
        for (var Jn = -1, ci = dn.length; ++Jn < ci && xv(Dr, dn[Jn], 0) > -1; )
          ;
        return Jn;
      }
      function p9(dn, Dr) {
        for (var Jn = dn.length; Jn-- && xv(Dr, dn[Jn], 0) > -1; )
          ;
        return Jn;
      }
      function _L(dn, Dr) {
        for (var Jn = dn.length, ci = 0; Jn--; )
          dn[Jn] === Dr && ++ci;
        return ci;
      }
      var xU = Ip(yU), xL = Ip(dM);
      function v9(dn) {
        return "\\" + qi[dn];
      }
      function wL(dn, Dr) {
        return dn == null ? e2 : dn[Dr];
      }
      function wh(dn) {
        return ui.test(dn);
      }
      function wU(dn) {
        return u9.test(dn);
      }
      function SL(dn) {
        for (var Dr, Jn = []; !(Dr = dn.next()).done; )
          Jn.push(Dr.value);
        return Jn;
      }
      function CL(dn) {
        var Dr = -1, Jn = Array(dn.size);
        return dn.forEach(function(ci, Io) {
          Jn[++Dr] = [Io, ci];
        }), Jn;
      }
      function vm(dn, Dr) {
        return function(Jn) {
          return dn(Dr(Jn));
        };
      }
      function qy(dn, Dr) {
        for (var Jn = -1, ci = dn.length, Io = 0, Dl = []; ++Jn < ci; ) {
          var mf = dn[Jn];
          (mf === Dr || mf === _) && (dn[Jn] = _, Dl[Io++] = Jn);
        }
        return Dl;
      }
      function FT(dn) {
        var Dr = -1, Jn = Array(dn.size);
        return dn.forEach(function(ci) {
          Jn[++Dr] = ci;
        }), Jn;
      }
      function g9(dn) {
        var Dr = -1, Jn = Array(dn.size);
        return dn.forEach(function(ci) {
          Jn[++Dr] = [ci, ci];
        }), Jn;
      }
      function SU(dn, Dr, Jn) {
        for (var ci = Jn - 1, Io = dn.length; ++ci < Io; )
          if (dn[ci] === Dr)
            return ci;
        return -1;
      }
      function ML(dn, Dr, Jn) {
        for (var ci = Jn + 1; ci--; )
          if (dn[ci] === Dr)
            return ci;
        return ci;
      }
      function sx(dn) {
        return wh(dn) ? yM(dn) : _U(dn);
      }
      function Zg(dn) {
        return wh(dn) ? MU(dn) : ox(dn);
      }
      function m9(dn) {
        for (var Dr = dn.length; Dr-- && oL.test(dn.charAt(Dr)); )
          ;
        return Dr;
      }
      var CU = Ip(Jf);
      function yM(dn) {
        for (var Dr = fM.lastIndex = 0; fM.test(dn); )
          ++Dr;
        return Dr;
      }
      function MU(dn) {
        return dn.match(fM) || [];
      }
      function y9(dn) {
        return dn.match(ks) || [];
      }
      var AU = function dn(Dr) {
        Dr = Dr == null ? mu : lx.defaults(mu.Object(), Dr, lx.pick(mu, _v));
        var Jn = Dr.Array, ci = Dr.Date, Io = Dr.Error, Dl = Dr.Function, mf = Dr.Math, Kl = Dr.Object, bM = Dr.RegExp, EU = Dr.String, qd = Dr.TypeError, ad = Jn.prototype, _M = Dl.prototype, Xg = Kl.prototype, xM = Dr["__core-js_shared__"], D2 = _M.toString, zl = Xg.hasOwnProperty, IU = 0, b9 = function() {
          var D = /[^.]+$/.exec(xM && xM.keys && xM.keys.IE_PROTO || "");
          return D ? "Symbol(src)_1." + D : "";
        }(), wM = Xg.toString, AL = D2.call(Kl), NT = mu._, _9 = bM("^" + D2.call(zl).replace(Gy, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ux = I2 ? Dr.Buffer : e2, Yd = Dr.Symbol, cx = Dr.Uint8Array, EL = ux ? ux.allocUnsafe : e2, SM = vm(Kl.getPrototypeOf, Kl), CM = Kl.create, Kg = Xg.propertyIsEnumerable, Zd = ad.splice, fx = Yd ? Yd.isConcatSpreadable : e2, rg = Yd ? Yd.iterator : e2, fb = Yd ? Yd.toStringTag : e2, Pc = function() {
          try {
            var D = Mb(Kl, "defineProperty");
            return D({}, "", {}), D;
          } catch {
          }
        }(), x9 = Dr.clearTimeout !== mu.clearTimeout && Dr.clearTimeout, VT = ci && ci.now !== mu.Date.now && ci.now, w9 = Dr.setTimeout !== mu.setTimeout && Dr.setTimeout, Jg = mf.ceil, MM = mf.floor, IL = Kl.getOwnPropertySymbols, eh = ux ? ux.isBuffer : e2, zT = Dr.isFinite, TU = ad.join, S9 = vm(Kl.keys, Kl), wc = mf.max, Sh = mf.min, DU = ci.now, kU = Dr.parseInt, BT = mf.random, PU = ad.reverse, TL = Mb(Dr, "DataView"), k2 = Mb(Dr, "Map"), DL = Mb(Dr, "Promise"), P2 = Mb(Dr, "Set"), Yy = Mb(Dr, "WeakMap"), L2 = Mb(Kl, "create"), Tp = Yy && new Yy(), O2 = {}, AM = Cx(TL), kL = Cx(k2), R2 = Cx(DL), PL = Cx(P2), hb = Cx(Yy), Xd = Yd ? Yd.prototype : e2, hx = Xd ? Xd.valueOf : e2, LL = Xd ? Xd.toString : e2;
        function ot(D) {
          if (Zu(D) && !Oo(D) && !(D instanceof el)) {
            if (D instanceof Dp)
              return D;
            if (zl.call(D, "__wrapped__"))
              return K9(D);
          }
          return new Dp(D);
        }
        var Qg = function() {
          function D() {
          }
          return function(B) {
            if (!oc(B))
              return {};
            if (CM)
              return CM(B);
            D.prototype = B;
            var ie = new D();
            return D.prototype = e2, ie;
          };
        }();
        function id2() {
        }
        function Dp(D, B) {
          this.__wrapped__ = D, this.__actions__ = [], this.__chain__ = !!B, this.__index__ = 0, this.__values__ = e2;
        }
        ot.templateSettings = { escape: xh, evaluate: eg, interpolate: Ep, variable: "", imports: { _: ot } }, ot.prototype = id2.prototype, ot.prototype.constructor = ot, Dp.prototype = Qg(id2.prototype), Dp.prototype.constructor = Dp;
        function el(D) {
          this.__wrapped__ = D, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = sn, this.__views__ = [];
        }
        function OL() {
          var D = new el(this.__wrapped__);
          return D.__actions__ = Mh(this.__actions__), D.__dir__ = this.__dir__, D.__filtered__ = this.__filtered__, D.__iteratees__ = Mh(this.__iteratees__), D.__takeCount__ = this.__takeCount__, D.__views__ = Mh(this.__views__), D;
        }
        function RL() {
          if (this.__filtered__) {
            var D = new el(this);
            D.__dir__ = -1, D.__filtered__ = true;
          } else
            D = this.clone(), D.__dir__ *= -1;
          return D;
        }
        function LU() {
          var D = this.__wrapped__.value(), B = this.__dir__, ie = Oo(D), Ce = B < 0, $e = ie ? D.length : 0, dt = QU(0, $e, this.__views__), $t = dt.start, Qt = dt.end, In = Qt - $t, jr = Ce ? Qt : $t - 1, Nr = this.__iteratees__, Yr = Nr.length, za = 0, Ii = Sh(In, this.__takeCount__);
          if (!ie || !Ce && $e == In && Ii == In)
            return RM(D, this.__actions__);
          var no = [];
          e:
            for (; In-- && za < Ii; ) {
              jr += B;
              for (var Ro = -1, eo = D[jr]; ++Ro < Yr; ) {
                var Ws = Nr[Ro], ys = Ws.iteratee, Eh = Ws.type, cd = ys(eo);
                if (Eh == ft)
                  eo = cd;
                else if (!cd) {
                  if (Eh == rt2)
                    continue e;
                  break e;
                }
              }
              no[za++] = eo;
            }
          return no;
        }
        el.prototype = Qg(id2.prototype), el.prototype.constructor = el;
        function e0(D) {
          var B = -1, ie = D == null ? 0 : D.length;
          for (this.clear(); ++B < ie; ) {
            var Ce = D[B];
            this.set(Ce[0], Ce[1]);
          }
        }
        function jT() {
          this.__data__ = L2 ? L2(null) : {}, this.size = 0;
        }
        function Zy(D) {
          var B = this.has(D) && delete this.__data__[D];
          return this.size -= B ? 1 : 0, B;
        }
        function GT(D) {
          var B = this.__data__;
          if (L2) {
            var ie = B[D];
            return ie === g4 ? e2 : ie;
          }
          return zl.call(B, D) ? B[D] : e2;
        }
        function WT(D) {
          var B = this.__data__;
          return L2 ? B[D] !== e2 : zl.call(B, D);
        }
        function F2(D, B) {
          var ie = this.__data__;
          return this.size += this.has(D) ? 0 : 1, ie[D] = L2 && B === e2 ? g4 : B, this;
        }
        e0.prototype.clear = jT, e0.prototype.delete = Zy, e0.prototype.get = GT, e0.prototype.has = WT, e0.prototype.set = F2;
        function gm(D) {
          var B = -1, ie = D == null ? 0 : D.length;
          for (this.clear(); ++B < ie; ) {
            var Ce = D[B];
            this.set(Ce[0], Ce[1]);
          }
        }
        function db() {
          this.__data__ = [], this.size = 0;
        }
        function HT(D) {
          var B = this.__data__, ie = vb(B, D);
          if (ie < 0)
            return false;
          var Ce = B.length - 1;
          return ie == Ce ? B.pop() : Zd.call(B, ie, 1), --this.size, true;
        }
        function FL(D) {
          var B = this.__data__, ie = vb(B, D);
          return ie < 0 ? e2 : B[ie][1];
        }
        function OU(D) {
          return vb(this.__data__, D) > -1;
        }
        function RU(D, B) {
          var ie = this.__data__, Ce = vb(ie, D);
          return Ce < 0 ? (++this.size, ie.push([D, B])) : ie[Ce][1] = B, this;
        }
        gm.prototype.clear = db, gm.prototype.delete = HT, gm.prototype.get = FL, gm.prototype.has = OU, gm.prototype.set = RU;
        function Xy(D) {
          var B = -1, ie = D == null ? 0 : D.length;
          for (this.clear(); ++B < ie; ) {
            var Ce = D[B];
            this.set(Ce[0], Ce[1]);
          }
        }
        function FU() {
          this.size = 0, this.__data__ = { hash: new e0(), map: new (k2 || gm)(), string: new e0() };
        }
        function NU(D) {
          var B = n1(this, D).delete(D);
          return this.size -= B ? 1 : 0, B;
        }
        function C9(D) {
          return n1(this, D).get(D);
        }
        function VU(D) {
          return n1(this, D).has(D);
        }
        function zU(D, B) {
          var ie = n1(this, D), Ce = ie.size;
          return ie.set(D, B), this.size += ie.size == Ce ? 0 : 1, this;
        }
        Xy.prototype.clear = FU, Xy.prototype.delete = NU, Xy.prototype.get = C9, Xy.prototype.has = VU, Xy.prototype.set = zU;
        function pb(D) {
          var B = -1, ie = D == null ? 0 : D.length;
          for (this.__data__ = new Xy(); ++B < ie; )
            this.add(D[B]);
        }
        function M9(D) {
          return this.__data__.set(D, g4), this;
        }
        function BU(D) {
          return this.__data__.has(D);
        }
        pb.prototype.add = pb.prototype.push = M9, pb.prototype.has = BU;
        function kp(D) {
          var B = this.__data__ = new gm(D);
          this.size = B.size;
        }
        function A9() {
          this.__data__ = new gm(), this.size = 0;
        }
        function E9(D) {
          var B = this.__data__, ie = B.delete(D);
          return this.size = B.size, ie;
        }
        function jU(D) {
          return this.__data__.get(D);
        }
        function NL(D) {
          return this.__data__.has(D);
        }
        function Ky(D, B) {
          var ie = this.__data__;
          if (ie instanceof gm) {
            var Ce = ie.__data__;
            if (!k2 || Ce.length < l4 - 1)
              return Ce.push([D, B]), this.size = ++ie.size, this;
            ie = this.__data__ = new Xy(Ce);
          }
          return ie.set(D, B), this.size = ie.size, this;
        }
        kp.prototype.clear = A9, kp.prototype.delete = E9, kp.prototype.get = jU, kp.prototype.has = NL, kp.prototype.set = Ky;
        function $T(D, B) {
          var ie = Oo(D), Ce = !ie && Pb(D), $e = !ie && !Ce && Oc(D), dt = !ie && !Ce && !$e && fg(D), $t = ie || Ce || $e || dt, Qt = $t ? RT(D.length, EU) : [], In = Qt.length;
          for (var jr in D)
            (B || zl.call(D, jr)) && !($t && (jr == "length" || $e && (jr == "offset" || jr == "parent") || dt && (jr == "buffer" || jr == "byteLength" || jr == "byteOffset") || r1(jr, In))) && Qt.push(jr);
          return Qt;
        }
        function I9(D) {
          var B = D.length;
          return B ? D[lg(0, B - 1)] : e2;
        }
        function UT(D, B) {
          return mD(Mh(D), t0(B, 0, D.length));
        }
        function T9(D) {
          return mD(Mh(D));
        }
        function VL(D, B, ie) {
          (ie !== e2 && !ii(D[B], ie) || ie === e2 && !(B in D)) && ag(D, B, ie);
        }
        function EM(D, B, ie) {
          var Ce = D[B];
          (!(zl.call(D, B) && ii(Ce, ie)) || ie === e2 && !(B in D)) && ag(D, B, ie);
        }
        function vb(D, B) {
          for (var ie = D.length; ie--; )
            if (ii(D[ie][0], B))
              return ie;
          return -1;
        }
        function qT(D, B, ie, Ce) {
          return ig(D, function($e, dt, $t) {
            B(Ce, $e, ie($e), $t);
          }), Ce;
        }
        function D9(D, B) {
          return D && i0(B, kf(B), D);
        }
        function YT(D, B) {
          return D && i0(B, Fp(B), D);
        }
        function ag(D, B, ie) {
          B == "__proto__" && Pc ? Pc(D, B, { configurable: true, enumerable: true, value: ie, writable: true }) : D[B] = ie;
        }
        function ZT(D, B) {
          for (var ie = -1, Ce = B.length, $e = Jn(Ce), dt = D == null; ++ie < Ce; )
            $e[ie] = dt ? e2 : qO(D, B[ie]);
          return $e;
        }
        function t0(D, B, ie) {
          return D === D && (ie !== e2 && (D = D <= ie ? D : ie), B !== e2 && (D = D >= B ? D : B)), D;
        }
        function Pp(D, B, ie, Ce, $e, dt) {
          var $t, Qt = B & w4, In = B & C, jr = B & E;
          if (ie && ($t = $e ? ie(D, Ce, $e, dt) : ie(D)), $t !== e2)
            return $t;
          if (!oc(D))
            return D;
          var Nr = Oo(D);
          if (Nr) {
            if ($t = GM(D), !Qt)
              return Mh(D, $t);
          } else {
            var Yr = od(D), za = Yr == li || Yr == Ts;
            if (Oc(D))
              return sD(D, Qt);
            if (Yr == vl || Yr == Za || za && !$e) {
              if ($t = In || za ? {} : Zc(D), !Qt)
                return In ? KU(D, YT($t, D)) : XU(D, D9($t, D));
            } else {
              if (!Vu[Yr])
                return $e ? D : {};
              $t = uO(D, Yr, Qt);
            }
          }
          dt || (dt = new kp());
          var Ii = dt.get(D);
          if (Ii)
            return Ii;
          dt.set(D, $t), E7(D) ? D.forEach(function(eo) {
            $t.add(Pp(eo, B, ie, eo, D, dt));
          }) : zO(D) && D.forEach(function(eo, Ws) {
            $t.set(Ws, Pp(eo, B, ie, Ws, D, dt));
          });
          var no = jr ? In ? dD : hD : In ? Fp : kf, Ro = Nr ? e2 : no(D);
          return gf(Ro || D, function(eo, Ws) {
            Ro && (Ws = eo, eo = D[Ws]), EM($t, Ws, Pp(eo, B, ie, Ws, D, dt));
          }), $t;
        }
        function zL(D) {
          var B = kf(D);
          return function(ie) {
            return BL(ie, D, B);
          };
        }
        function BL(D, B, ie) {
          var Ce = ie.length;
          if (D == null)
            return !Ce;
          for (D = Kl(D); Ce--; ) {
            var $e = ie[Ce], dt = B[$e], $t = D[$e];
            if ($t === e2 && !($e in D) || !dt($t))
              return false;
          }
          return true;
        }
        function jL(D, B, ie) {
          if (typeof D != "function")
            throw new qd(h);
          return Lp(function() {
            D.apply(e2, ie);
          }, B);
        }
        function gb(D, B, ie, Ce) {
          var $e = -1, dt = hm, $t = true, Qt = D.length, In = [], jr = B.length;
          if (!Qt)
            return In;
          ie && (B = ic(B, Ud(ie))), Ce ? (dt = gM, $t = false) : B.length >= l4 && (dt = mM, $t = false, B = new pb(B));
          e:
            for (; ++$e < Qt; ) {
              var Nr = D[$e], Yr = ie == null ? Nr : ie(Nr);
              if (Nr = Ce || Nr !== 0 ? Nr : 0, $t && Yr === Yr) {
                for (var za = jr; za--; )
                  if (B[za] === Yr)
                    continue e;
                In.push(Nr);
              } else
                dt(B, Yr, Ce) || In.push(Nr);
            }
          return In;
        }
        var ig = B9(n0), k9 = B9(KT, true);
        function GL(D, B) {
          var ie = true;
          return ig(D, function(Ce, $e, dt) {
            return ie = !!B(Ce, $e, dt), ie;
          }), ie;
        }
        function Jy(D, B, ie) {
          for (var Ce = -1, $e = D.length; ++Ce < $e; ) {
            var dt = D[Ce], $t = B(dt);
            if ($t != null && (Qt === e2 ? $t === $t && !ep($t) : ie($t, Qt)))
              var Qt = $t, In = dt;
          }
          return In;
        }
        function GU(D, B, ie, Ce) {
          var $e = D.length;
          for (ie = Ko(ie), ie < 0 && (ie = -ie > $e ? 0 : $e + ie), Ce = Ce === e2 || Ce > $e ? $e : Ko(Ce), Ce < 0 && (Ce += $e), Ce = ie > Ce ? 0 : WO(Ce); ie < Ce; )
            D[ie++] = B;
          return D;
        }
        function P9(D, B) {
          var ie = [];
          return ig(D, function(Ce, $e, dt) {
            B(Ce, $e, dt) && ie.push(Ce);
          }), ie;
        }
        function Ch(D, B, ie, Ce, $e) {
          var dt = -1, $t = D.length;
          for (ie || (ie = tq), $e || ($e = []); ++dt < $t; ) {
            var Qt = D[dt];
            B > 0 && ie(Qt) ? B > 1 ? Ch(Qt, B - 1, ie, Ce, $e) : dm($e, Qt) : Ce || ($e[$e.length] = Qt);
          }
          return $e;
        }
        var IM = JL(), XT = JL(true);
        function n0(D, B) {
          return D && IM(D, B, kf);
        }
        function KT(D, B) {
          return D && XT(D, B, kf);
        }
        function N2(D, B) {
          return fm(B, function(ie) {
            return Av(D[ie]);
          });
        }
        function dx(D, B) {
          B = Sb(B, D);
          for (var ie = 0, Ce = B.length; D != null && ie < Ce; )
            D = D[ym(B[ie++])];
          return ie && ie == Ce ? D : e2;
        }
        function JT(D, B, ie) {
          var Ce = B(D);
          return Oo(D) ? Ce : dm(Ce, ie(D));
        }
        function Kd(D) {
          return D == null ? D === e2 ? om : Bs : fb && fb in Kl(D) ? JU(D) : aq(D);
        }
        function QT(D, B) {
          return D > B;
        }
        function WU(D, B) {
          return D != null && zl.call(D, B);
        }
        function r0(D, B) {
          return D != null && B in Kl(D);
        }
        function WL(D, B, ie) {
          return D >= Sh(B, ie) && D < wc(B, ie);
        }
        function HL(D, B, ie) {
          for (var Ce = ie ? gM : hm, $e = D[0].length, dt = D.length, $t = dt, Qt = Jn(dt), In = 1 / 0, jr = []; $t--; ) {
            var Nr = D[$t];
            $t && B && (Nr = ic(Nr, Ud(B))), In = Sh(Nr.length, In), Qt[$t] = !ie && (B || $e >= 120 && Nr.length >= 120) ? new pb($t && Nr) : e2;
          }
          Nr = D[0];
          var Yr = -1, za = Qt[0];
          e:
            for (; ++Yr < $e && jr.length < In; ) {
              var Ii = Nr[Yr], no = B ? B(Ii) : Ii;
              if (Ii = ie || Ii !== 0 ? Ii : 0, !(za ? mM(za, no) : Ce(jr, no, ie))) {
                for ($t = dt; --$t; ) {
                  var Ro = Qt[$t];
                  if (!(Ro ? mM(Ro, no) : Ce(D[$t], no, ie)))
                    continue e;
                }
                za && za.push(no), jr.push(Ii);
              }
            }
          return jr;
        }
        function HU(D, B, ie, Ce) {
          return n0(D, function($e, dt, $t) {
            B(Ce, ie($e), dt, $t);
          }), Ce;
        }
        function mb(D, B, ie) {
          B = Sb(B, D), D = fO(D, B);
          var Ce = D == null ? D : D[ym(Cv(B))];
          return Ce == null ? e2 : Df(Ce, D, ie);
        }
        function eD(D) {
          return Zu(D) && Kd(D) == Za;
        }
        function L9(D) {
          return Zu(D) && Kd(D) == Bn;
        }
        function $U(D) {
          return Zu(D) && Kd(D) == Ra;
        }
        function TM(D, B, ie, Ce, $e) {
          return D === B ? true : D == null || B == null || !Zu(D) && !Zu(B) ? D !== D && B !== B : O9(D, B, ie, Ce, TM, $e);
        }
        function O9(D, B, ie, Ce, $e, dt) {
          var $t = Oo(D), Qt = Oo(B), In = $t ? $a : od(D), jr = Qt ? $a : od(B);
          In = In == Za ? vl : In, jr = jr == Za ? vl : jr;
          var Nr = In == vl, Yr = jr == vl, za = In == jr;
          if (za && Oc(D)) {
            if (!Oc(B))
              return false;
            $t = true, Nr = false;
          }
          if (za && !Nr)
            return dt || (dt = new kp()), $t || fg(D) ? iO(D, B, ie, Ce, $e, dt) : $9(D, B, In, ie, Ce, $e, dt);
          if (!(ie & T)) {
            var Ii = Nr && zl.call(D, "__wrapped__"), no = Yr && zl.call(B, "__wrapped__");
            if (Ii || no) {
              var Ro = Ii ? D.value() : D, eo = no ? B.value() : B;
              return dt || (dt = new kp()), $e(Ro, eo, ie, Ce, dt);
            }
          }
          return za ? (dt || (dt = new kp()), U9(D, B, ie, Ce, $e, dt)) : false;
        }
        function tD(D) {
          return Zu(D) && od(D) == wi;
        }
        function DM(D, B, ie, Ce) {
          var $e = ie.length, dt = $e, $t = !Ce;
          if (D == null)
            return !dt;
          for (D = Kl(D); $e--; ) {
            var Qt = ie[$e];
            if ($t && Qt[2] ? Qt[1] !== D[Qt[0]] : !(Qt[0] in D))
              return false;
          }
          for (; ++$e < dt; ) {
            Qt = ie[$e];
            var In = Qt[0], jr = D[In], Nr = Qt[1];
            if ($t && Qt[2]) {
              if (jr === e2 && !(In in D))
                return false;
            } else {
              var Yr = new kp();
              if (Ce)
                var za = Ce(jr, Nr, In, D, B, Yr);
              if (!(za === e2 ? TM(Nr, jr, T | O, Ce, Yr) : za))
                return false;
            }
          }
          return true;
        }
        function nD(D) {
          if (!oc(D) || nq(D))
            return false;
          var B = Av(D) ? _9 : Ir;
          return B.test(Cx(D));
        }
        function $L(D) {
          return Zu(D) && Kd(D) == _h;
        }
        function UU(D) {
          return Zu(D) && od(D) == Nl;
        }
        function og(D) {
          return Zu(D) && JM(D.length) && !!au[Kd(D)];
        }
        function kM(D) {
          return typeof D == "function" ? D : D == null ? tp : typeof D == "object" ? Oo(D) ? px(D[0], D[1]) : rD(D) : sR(D);
        }
        function PM(D) {
          if (!Sx(D))
            return S9(D);
          var B = [];
          for (var ie in Kl(D))
            zl.call(D, ie) && ie != "constructor" && B.push(ie);
          return B;
        }
        function Qy(D) {
          if (!oc(D))
            return rq(D);
          var B = Sx(D), ie = [];
          for (var Ce in D)
            Ce == "constructor" && (B || !zl.call(D, Ce)) || ie.push(Ce);
          return ie;
        }
        function sg(D, B) {
          return D < B;
        }
        function yb(D, B) {
          var ie = -1, Ce = sd(D) ? Jn(D.length) : [];
          return ig(D, function($e, dt, $t) {
            Ce[++ie] = B($e, dt, $t);
          }), Ce;
        }
        function rD(D) {
          var B = oO(D);
          return B.length == 1 && B[0][2] ? Y9(B[0][0], B[0][1]) : function(ie) {
            return ie === D || DM(ie, D, B);
          };
        }
        function px(D, B) {
          return cO(D) && Lc(B) ? Y9(ym(D), B) : function(ie) {
            var Ce = qO(ie, D);
            return Ce === e2 && Ce === B ? RD(ie, D) : TM(B, Ce, T | O);
          };
        }
        function aD(D, B, ie, Ce, $e) {
          D !== B && IM(B, function(dt, $t) {
            if ($e || ($e = new kp()), oc(dt))
              R9(D, B, $t, ie, aD, Ce, $e);
            else {
              var Qt = Ce ? Ce(a1(D, $t), dt, $t + "", D, B, $e) : e2;
              Qt === e2 && (Qt = dt), VL(D, $t, Qt);
            }
          }, Fp);
        }
        function R9(D, B, ie, Ce, $e, dt, $t) {
          var Qt = a1(D, ie), In = a1(B, ie), jr = $t.get(In);
          if (jr) {
            VL(D, ie, jr);
            return;
          }
          var Nr = dt ? dt(Qt, In, ie + "", D, B, $t) : e2, Yr = Nr === e2;
          if (Yr) {
            var za = Oo(In), Ii = !za && Oc(In), no = !za && !Ii && fg(In);
            Nr = In, za || Ii || no ? Oo(Qt) ? Nr = Qt : Yu(Qt) ? Nr = Mh(Qt) : Ii ? (Yr = false, Nr = sD(In, true)) : no ? (Yr = false, Nr = V9(In, true)) : Nr = [] : Lb(In) || Pb(In) ? (Nr = Qt, Pb(Qt) ? Nr = LD(Qt) : (!oc(Qt) || Av(Qt)) && (Nr = Zc(In))) : Yr = false;
          }
          Yr && ($t.set(In, Nr), $e(Nr, In, Ce, dt, $t), $t.delete(In)), VL(D, ie, Nr);
        }
        function UL(D, B) {
          var ie = D.length;
          if (!!ie)
            return B += B < 0 ? ie : 0, r1(B, ie) ? D[B] : e2;
        }
        function bb(D, B, ie) {
          B.length ? B = ic(B, function(dt) {
            return Oo(dt) ? function($t) {
              return dx($t, dt.length === 1 ? dt[0] : dt);
            } : dt;
          }) : B = [tp];
          var Ce = -1;
          B = ic(B, Ud(Yi()));
          var $e = yb(D, function(dt, $t, Qt) {
            var In = ic(B, function(jr) {
              return jr(dt);
            });
            return { criteria: In, index: ++Ce, value: dt };
          });
          return gL($e, function(dt, $t) {
            return z9(dt, $t, ie);
          });
        }
        function vx(D, B) {
          return gx(D, B, function(ie, Ce) {
            return RD(D, Ce);
          });
        }
        function gx(D, B, ie) {
          for (var Ce = -1, $e = B.length, dt = {}; ++Ce < $e; ) {
            var $t = B[Ce], Qt = dx(D, $t);
            ie(Qt, $t) && _b2(dt, Sb($t, D), Qt);
          }
          return dt;
        }
        function qL(D) {
          return function(B) {
            return dx(B, D);
          };
        }
        function LM(D, B, ie, Ce) {
          var $e = Ce ? T2 : xv, dt = -1, $t = B.length, Qt = D;
          for (D === B && (B = Mh(B)), ie && (Qt = ic(D, Ud(ie))); ++dt < $t; )
            for (var In = 0, jr = B[dt], Nr = ie ? ie(jr) : jr; (In = $e(Qt, Nr, In, Ce)) > -1; )
              Qt !== D && Zd.call(Qt, In, 1), Zd.call(D, In, 1);
          return D;
        }
        function F9(D, B) {
          for (var ie = D ? B.length : 0, Ce = ie - 1; ie--; ) {
            var $e = B[ie];
            if (ie == Ce || $e !== dt) {
              var dt = $e;
              r1($e) ? Zd.call(D, $e, 1) : bx(D, $e);
            }
          }
          return D;
        }
        function lg(D, B) {
          return D + MM(BT() * (B - D + 1));
        }
        function N9(D, B, ie, Ce) {
          for (var $e = -1, dt = wc(Jg((B - D) / (ie || 1)), 0), $t = Jn(dt); dt--; )
            $t[Ce ? dt : ++$e] = D, D += ie;
          return $t;
        }
        function a0(D, B) {
          var ie = "";
          if (!D || B < 1 || B > xt)
            return ie;
          do
            B % 2 && (ie += D), B = MM(B / 2), B && (D += D);
          while (B);
          return ie;
        }
        function vs(D, B) {
          return dO(vD(D, B, tp), D + "");
        }
        function Bi(D) {
          return I9(W2(D));
        }
        function iD(D, B) {
          var ie = W2(D);
          return mD(ie, t0(B, 0, ie.length));
        }
        function _b2(D, B, ie, Ce) {
          if (!oc(D))
            return D;
          B = Sb(B, D);
          for (var $e = -1, dt = B.length, $t = dt - 1, Qt = D; Qt != null && ++$e < dt; ) {
            var In = ym(B[$e]), jr = ie;
            if (In === "__proto__" || In === "constructor" || In === "prototype")
              return D;
            if ($e != $t) {
              var Nr = Qt[In];
              jr = Ce ? Ce(Nr, In, Qt) : e2, jr === e2 && (jr = oc(Nr) ? Nr : r1(B[$e + 1]) ? [] : {});
            }
            EM(Qt, In, jr), Qt = Qt[In];
          }
          return D;
        }
        var xb = Tp ? function(D, B) {
          return Tp.set(D, B), D;
        } : tp, mx = Pc ? function(D, B) {
          return Pc(D, "toString", { configurable: true, enumerable: false, value: BD(B), writable: true });
        } : tp;
        function yx(D) {
          return mD(W2(D));
        }
        function th(D, B, ie) {
          var Ce = -1, $e = D.length;
          B < 0 && (B = -B > $e ? 0 : $e + B), ie = ie > $e ? $e : ie, ie < 0 && (ie += $e), $e = B > ie ? 0 : ie - B >>> 0, B >>>= 0;
          for (var dt = Jn($e); ++Ce < $e; )
            dt[Ce] = D[Ce + B];
          return dt;
        }
        function OM(D, B) {
          var ie;
          return ig(D, function(Ce, $e, dt) {
            return ie = B(Ce, $e, dt), !ie;
          }), !!ie;
        }
        function wb(D, B, ie) {
          var Ce = 0, $e = D == null ? Ce : D.length;
          if (typeof B == "number" && B === B && $e <= $r) {
            for (; Ce < $e; ) {
              var dt = Ce + $e >>> 1, $t = D[dt];
              $t !== null && !ep($t) && (ie ? $t <= B : $t < B) ? Ce = dt + 1 : $e = dt;
            }
            return $e;
          }
          return YL(D, B, tp, ie);
        }
        function YL(D, B, ie, Ce) {
          var $e = 0, dt = D == null ? 0 : D.length;
          if (dt === 0)
            return 0;
          B = ie(B);
          for (var $t = B !== B, Qt = B === null, In = ep(B), jr = B === e2; $e < dt; ) {
            var Nr = MM(($e + dt) / 2), Yr = ie(D[Nr]), za = Yr !== e2, Ii = Yr === null, no = Yr === Yr, Ro = ep(Yr);
            if ($t)
              var eo = Ce || no;
            else
              jr ? eo = no && (Ce || za) : Qt ? eo = no && za && (Ce || !Ii) : In ? eo = no && za && !Ii && (Ce || !Ro) : Ii || Ro ? eo = false : eo = Ce ? Yr <= B : Yr < B;
            eo ? $e = Nr + 1 : dt = Nr;
          }
          return Sh(dt, vn);
        }
        function Qi(D, B) {
          for (var ie = -1, Ce = D.length, $e = 0, dt = []; ++ie < Ce; ) {
            var $t = D[ie], Qt = B ? B($t) : $t;
            if (!ie || !ii(Qt, In)) {
              var In = Qt;
              dt[$e++] = $t === 0 ? 0 : $t;
            }
          }
          return dt;
        }
        function ZL(D) {
          return typeof D == "number" ? D : ep(D) ? Wt : +D;
        }
        function qu(D) {
          if (typeof D == "string")
            return D;
          if (Oo(D))
            return ic(D, qu) + "";
          if (ep(D))
            return LL ? LL.call(D) : "";
          var B = D + "";
          return B == "0" && 1 / D == -Jt ? "-0" : B;
        }
        function e1(D, B, ie) {
          var Ce = -1, $e = hm, dt = D.length, $t = true, Qt = [], In = Qt;
          if (ie)
            $t = false, $e = gM;
          else if (dt >= l4) {
            var jr = B ? null : nO(D);
            if (jr)
              return FT(jr);
            $t = false, $e = mM, In = new pb();
          } else
            In = B ? [] : Qt;
          e:
            for (; ++Ce < dt; ) {
              var Nr = D[Ce], Yr = B ? B(Nr) : Nr;
              if (Nr = ie || Nr !== 0 ? Nr : 0, $t && Yr === Yr) {
                for (var za = In.length; za--; )
                  if (In[za] === Yr)
                    continue e;
                B && In.push(Yr), Qt.push(Nr);
              } else
                $e(In, Yr, ie) || (In !== Qt && In.push(Yr), Qt.push(Nr));
            }
          return Qt;
        }
        function bx(D, B) {
          return B = Sb(B, D), D = fO(D, B), D == null || delete D[ym(Cv(B))];
        }
        function V2(D, B, ie, Ce) {
          return _b2(D, B, ie(dx(D, B)), Ce);
        }
        function t1(D, B, ie, Ce) {
          for (var $e = D.length, dt = Ce ? $e : -1; (Ce ? dt-- : ++dt < $e) && B(D[dt], dt, D); )
            ;
          return ie ? th(D, Ce ? 0 : dt, Ce ? dt + 1 : $e) : th(D, Ce ? dt + 1 : 0, Ce ? $e : dt);
        }
        function RM(D, B) {
          var ie = D;
          return ie instanceof el && (ie = ie.value()), ix(B, function(Ce, $e) {
            return $e.func.apply($e.thisArg, dm([Ce], $e.args));
          }, ie);
        }
        function wv(D, B, ie) {
          var Ce = D.length;
          if (Ce < 2)
            return Ce ? e1(D[0]) : [];
          for (var $e = -1, dt = Jn(Ce); ++$e < Ce; )
            for (var $t = D[$e], Qt = -1; ++Qt < Ce; )
              Qt != $e && (dt[$e] = gb(dt[$e] || $t, D[Qt], B, ie));
          return e1(Ch(dt, 1), B, ie);
        }
        function FM(D, B, ie) {
          for (var Ce = -1, $e = D.length, dt = B.length, $t = {}; ++Ce < $e; ) {
            var Qt = Ce < dt ? B[Ce] : e2;
            ie($t, D[Ce], Qt);
          }
          return $t;
        }
        function NM(D) {
          return Yu(D) ? D : [];
        }
        function VM(D) {
          return typeof D == "function" ? D : tp;
        }
        function Sb(D, B) {
          return Oo(D) ? D : cO(D, B) ? [D] : pO(jl(D));
        }
        var z2 = vs;
        function Cb(D, B, ie) {
          var Ce = D.length;
          return ie = ie === e2 ? Ce : ie, !B && ie >= Ce ? D : th(D, B, ie);
        }
        var oD = x9 || function(D) {
          return mu.clearTimeout(D);
        };
        function sD(D, B) {
          if (B)
            return D.slice();
          var ie = D.length, Ce = EL ? EL(ie) : new D.constructor(ie);
          return D.copy(Ce), Ce;
        }
        function zM(D) {
          var B = new D.constructor(D.byteLength);
          return new cx(B).set(new cx(D)), B;
        }
        function qU(D, B) {
          var ie = B ? zM(D.buffer) : D.buffer;
          return new D.constructor(ie, D.byteOffset, D.byteLength);
        }
        function YU(D) {
          var B = new D.constructor(D.source, Et.exec(D));
          return B.lastIndex = D.lastIndex, B;
        }
        function ZU(D) {
          return hx ? Kl(hx.call(D)) : {};
        }
        function V9(D, B) {
          var ie = B ? zM(D.buffer) : D.buffer;
          return new D.constructor(ie, D.byteOffset, D.length);
        }
        function XL(D, B) {
          if (D !== B) {
            var ie = D !== e2, Ce = D === null, $e = D === D, dt = ep(D), $t = B !== e2, Qt = B === null, In = B === B, jr = ep(B);
            if (!Qt && !jr && !dt && D > B || dt && $t && In && !Qt && !jr || Ce && $t && In || !ie && In || !$e)
              return 1;
            if (!Ce && !dt && !jr && D < B || jr && ie && $e && !Ce && !dt || Qt && ie && $e || !$t && $e || !In)
              return -1;
          }
          return 0;
        }
        function z9(D, B, ie) {
          for (var Ce = -1, $e = D.criteria, dt = B.criteria, $t = $e.length, Qt = ie.length; ++Ce < $t; ) {
            var In = XL($e[Ce], dt[Ce]);
            if (In) {
              if (Ce >= Qt)
                return In;
              var jr = ie[Ce];
              return In * (jr == "desc" ? -1 : 1);
            }
          }
          return D.index - B.index;
        }
        function KL(D, B, ie, Ce) {
          for (var $e = -1, dt = D.length, $t = ie.length, Qt = -1, In = B.length, jr = wc(dt - $t, 0), Nr = Jn(In + jr), Yr = !Ce; ++Qt < In; )
            Nr[Qt] = B[Qt];
          for (; ++$e < $t; )
            (Yr || $e < dt) && (Nr[ie[$e]] = D[$e]);
          for (; jr--; )
            Nr[Qt++] = D[$e++];
          return Nr;
        }
        function bi(D, B, ie, Ce) {
          for (var $e = -1, dt = D.length, $t = -1, Qt = ie.length, In = -1, jr = B.length, Nr = wc(dt - Qt, 0), Yr = Jn(Nr + jr), za = !Ce; ++$e < Nr; )
            Yr[$e] = D[$e];
          for (var Ii = $e; ++In < jr; )
            Yr[Ii + In] = B[In];
          for (; ++$t < Qt; )
            (za || $e < dt) && (Yr[Ii + ie[$t]] = D[$e++]);
          return Yr;
        }
        function Mh(D, B) {
          var ie = -1, Ce = D.length;
          for (B || (B = Jn(Ce)); ++ie < Ce; )
            B[ie] = D[ie];
          return B;
        }
        function i0(D, B, ie, Ce) {
          var $e = !ie;
          ie || (ie = {});
          for (var dt = -1, $t = B.length; ++dt < $t; ) {
            var Qt = B[dt], In = Ce ? Ce(ie[Qt], D[Qt], Qt, ie, D) : e2;
            In === e2 && (In = D[Qt]), $e ? ag(ie, Qt, In) : EM(ie, Qt, In);
          }
          return ie;
        }
        function XU(D, B) {
          return i0(D, sO(D), B);
        }
        function KU(D, B) {
          return i0(D, q9(D), B);
        }
        function lD(D, B) {
          return function(ie, Ce) {
            var $e = Oo(ie) ? $d : qT, dt = B ? B() : {};
            return $e(ie, D, Yi(Ce, 2), dt);
          };
        }
        function _x(D) {
          return vs(function(B, ie) {
            var Ce = -1, $e = ie.length, dt = $e > 1 ? ie[$e - 1] : e2, $t = $e > 2 ? ie[2] : e2;
            for (dt = D.length > 3 && typeof dt == "function" ? ($e--, dt) : e2, $t && Jd(ie[0], ie[1], $t) && (dt = $e < 3 ? e2 : dt, $e = 1), B = Kl(B); ++Ce < $e; ) {
              var Qt = ie[Ce];
              Qt && D(B, Qt, Ce, dt);
            }
            return B;
          });
        }
        function B9(D, B) {
          return function(ie, Ce) {
            if (ie == null)
              return ie;
            if (!sd(ie))
              return D(ie, Ce);
            for (var $e = ie.length, dt = B ? $e : -1, $t = Kl(ie); (B ? dt-- : ++dt < $e) && Ce($t[dt], dt, $t) !== false; )
              ;
            return ie;
          };
        }
        function JL(D) {
          return function(B, ie, Ce) {
            for (var $e = -1, dt = Kl(B), $t = Ce(B), Qt = $t.length; Qt--; ) {
              var In = $t[D ? Qt : ++$e];
              if (ie(dt[In], In, dt) === false)
                break;
            }
            return B;
          };
        }
        function j9(D, B, ie) {
          var Ce = B & N, $e = ua(D);
          function dt() {
            var $t = this && this !== mu && this instanceof dt ? $e : D;
            return $t.apply(Ce ? ie : this, arguments);
          }
          return dt;
        }
        function G9(D) {
          return function(B) {
            B = jl(B);
            var ie = wh(B) ? Zg(B) : e2, Ce = ie ? ie[0] : B.charAt(0), $e = ie ? Cb(ie, 1).join("") : B.slice(1);
            return Ce[D]() + $e;
          };
        }
        function gs(D) {
          return function(B) {
            return ix(Y7(ND(B).replace(ti, "")), D, "");
          };
        }
        function ua(D) {
          return function() {
            var B = arguments;
            switch (B.length) {
              case 0:
                return new D();
              case 1:
                return new D(B[0]);
              case 2:
                return new D(B[0], B[1]);
              case 3:
                return new D(B[0], B[1], B[2]);
              case 4:
                return new D(B[0], B[1], B[2], B[3]);
              case 5:
                return new D(B[0], B[1], B[2], B[3], B[4]);
              case 6:
                return new D(B[0], B[1], B[2], B[3], B[4], B[5]);
              case 7:
                return new D(B[0], B[1], B[2], B[3], B[4], B[5], B[6]);
            }
            var ie = Qg(D.prototype), Ce = D.apply(ie, B);
            return oc(Ce) ? Ce : ie;
          };
        }
        function Sc(D, B, ie) {
          var Ce = ua(D);
          function $e() {
            for (var dt = arguments.length, $t = Jn(dt), Qt = dt, In = ug($e); Qt--; )
              $t[Qt] = arguments[Qt];
            var jr = dt < 3 && $t[0] !== In && $t[dt - 1] !== In ? [] : qy($t, In);
            if (dt -= jr.length, dt < ie)
              return s0(D, B, uD, $e.placeholder, e2, $t, jr, e2, e2, ie - dt);
            var Nr = this && this !== mu && this instanceof $e ? Ce : D;
            return Df(Nr, this, $t);
          }
          return $e;
        }
        function Sv(D) {
          return function(B, ie, Ce) {
            var $e = Kl(B);
            if (!sd(B)) {
              var dt = Yi(ie, 3);
              B = kf(B), ie = function(Qt) {
                return dt($e[Qt], Qt, $e);
              };
            }
            var $t = D(B, ie, Ce);
            return $t > -1 ? $e[dt ? B[$t] : $t] : e2;
          };
        }
        function o0(D) {
          return Lo(function(B) {
            var ie = B.length, Ce = ie, $e = Dp.prototype.thru;
            for (D && B.reverse(); Ce--; ) {
              var dt = B[Ce];
              if (typeof dt != "function")
                throw new qd(h);
              if ($e && !$t && ll(dt) == "wrapper")
                var $t = new Dp([], true);
            }
            for (Ce = $t ? Ce : ie; ++Ce < ie; ) {
              dt = B[Ce];
              var Qt = ll(dt), In = Qt == "wrapper" ? pD(dt) : e2;
              In && Xo(In[0]) && In[1] == (me | X | de | ye) && !In[4].length && In[9] == 1 ? $t = $t[ll(In[0])].apply($t, In[3]) : $t = dt.length == 1 && Xo(dt) ? $t[Qt]() : $t.thru(dt);
            }
            return function() {
              var jr = arguments, Nr = jr[0];
              if ($t && jr.length == 1 && Oo(Nr))
                return $t.plant(Nr).value();
              for (var Yr = 0, za = ie ? B[Yr].apply(this, jr) : Nr; ++Yr < ie; )
                za = B[Yr].call(this, za);
              return za;
            };
          });
        }
        function uD(D, B, ie, Ce, $e, dt, $t, Qt, In, jr) {
          var Nr = B & me, Yr = B & N, za = B & V, Ii = B & (X | q2), no = B & be, Ro = za ? e2 : ua(D);
          function eo() {
            for (var Ws = arguments.length, ys = Jn(Ws), Eh = Ws; Eh--; )
              ys[Eh] = arguments[Eh];
            if (Ii)
              var cd = ug(eo), np = _L(ys, cd);
            if (Ce && (ys = KL(ys, Ce, $e, Ii)), dt && (ys = bi(ys, dt, $t, Ii)), Ws -= np, Ii && Ws < jr) {
              var Xc = qy(ys, cd);
              return s0(D, B, uD, eo.placeholder, ie, ys, Xc, Qt, In, jr - Ws);
            }
            var fd = Yr ? ie : this, Tm = za ? fd[D] : D;
            return Ws = ys.length, Qt ? ys = iq(ys, Qt) : no && Ws > 1 && ys.reverse(), Nr && In < Ws && (ys.length = In), this && this !== mu && this instanceof eo && (Tm = Ro || ua(Tm)), Tm.apply(fd, ys);
          }
          return eo;
        }
        function QL(D, B) {
          return function(ie, Ce) {
            return HU(ie, D, B(Ce), {});
          };
        }
        function cD(D, B) {
          return function(ie, Ce) {
            var $e;
            if (ie === e2 && Ce === e2)
              return B;
            if (ie !== e2 && ($e = ie), Ce !== e2) {
              if ($e === e2)
                return Ce;
              typeof ie == "string" || typeof Ce == "string" ? (ie = qu(ie), Ce = qu(Ce)) : (ie = ZL(ie), Ce = ZL(Ce)), $e = D(ie, Ce);
            }
            return $e;
          };
        }
        function eO(D) {
          return Lo(function(B) {
            return B = ic(B, Ud(Yi())), vs(function(ie) {
              var Ce = this;
              return D(B, function($e) {
                return Df($e, Ce, ie);
              });
            });
          });
        }
        function BM(D, B) {
          B = B === e2 ? " " : qu(B);
          var ie = B.length;
          if (ie < 2)
            return ie ? a0(B, D) : B;
          var Ce = a0(B, Jg(D / sx(B)));
          return wh(B) ? Cb(Zg(Ce), 0, D).join("") : Ce.slice(0, D);
        }
        function W9(D, B, ie, Ce) {
          var $e = B & N, dt = ua(D);
          function $t() {
            for (var Qt = -1, In = arguments.length, jr = -1, Nr = Ce.length, Yr = Jn(Nr + In), za = this && this !== mu && this instanceof $t ? dt : D; ++jr < Nr; )
              Yr[jr] = Ce[jr];
            for (; In--; )
              Yr[jr++] = arguments[++Qt];
            return Df(za, $e ? ie : this, Yr);
          }
          return $t;
        }
        function jM(D) {
          return function(B, ie, Ce) {
            return Ce && typeof Ce != "number" && Jd(B, ie, Ce) && (ie = Ce = e2), B = Am(B), ie === e2 ? (ie = B, B = 0) : ie = Am(ie), Ce = Ce === e2 ? B < ie ? 1 : -1 : Am(Ce), N9(B, ie, Ce, D);
          };
        }
        function fD(D) {
          return function(B, ie) {
            return typeof B == "string" && typeof ie == "string" || (B = Ev(B), ie = Ev(ie)), D(B, ie);
          };
        }
        function s0(D, B, ie, Ce, $e, dt, $t, Qt, In, jr) {
          var Nr = B & X, Yr = Nr ? $t : e2, za = Nr ? e2 : $t, Ii = Nr ? dt : e2, no = Nr ? e2 : dt;
          B |= Nr ? de : le, B &= ~(Nr ? le : de), B & H || (B &= ~(N | V));
          var Ro = [D, B, $e, Ii, Yr, no, za, Qt, In, jr], eo = ie.apply(e2, Ro);
          return Xo(D) && hO(eo, Ro), eo.placeholder = Ce, X9(eo, D, B);
        }
        function tO(D) {
          var B = mf[D];
          return function(ie, Ce) {
            if (ie = Ev(ie), Ce = Ce == null ? 0 : Sh(Ko(Ce), 292), Ce && zT(ie)) {
              var $e = (jl(ie) + "e").split("e"), dt = B($e[0] + "e" + (+$e[1] + Ce));
              return $e = (jl(dt) + "e").split("e"), +($e[0] + "e" + (+$e[1] - Ce));
            }
            return B(ie);
          };
        }
        var nO = P2 && 1 / FT(new P2([, -0]))[1] == Jt ? function(D) {
          return new P2(D);
        } : oR;
        function rO(D) {
          return function(B) {
            var ie = od(B);
            return ie == wi ? CL(B) : ie == Nl ? g9(B) : mL(B, D(B));
          };
        }
        function l0(D, B, ie, Ce, $e, dt, $t, Qt) {
          var In = B & V;
          if (!In && typeof D != "function")
            throw new qd(h);
          var jr = Ce ? Ce.length : 0;
          if (jr || (B &= ~(de | le), Ce = $e = e2), $t = $t === e2 ? $t : wc(Ko($t), 0), Qt = Qt === e2 ? Qt : Ko(Qt), jr -= $e ? $e.length : 0, B & le) {
            var Nr = Ce, Yr = $e;
            Ce = $e = e2;
          }
          var za = In ? e2 : pD(D), Ii = [D, B, ie, Ce, $e, Nr, Yr, dt, $t, Qt];
          if (za && Z9(Ii, za), D = Ii[0], B = Ii[1], ie = Ii[2], Ce = Ii[3], $e = Ii[4], Qt = Ii[9] = Ii[9] === e2 ? In ? 0 : D.length : wc(Ii[9] - jr, 0), !Qt && B & (X | q2) && (B &= ~(X | q2)), !B || B == N)
            var no = j9(D, B, ie);
          else
            B == X || B == q2 ? no = Sc(D, B, Qt) : (B == de || B == (N | de)) && !$e.length ? no = W9(D, B, ie, Ce) : no = uD.apply(e2, Ii);
          var Ro = za ? xb : hO;
          return X9(Ro(no, Ii), D, B);
        }
        function aO(D, B, ie, Ce) {
          return D === e2 || ii(D, Xg[ie]) && !zl.call(Ce, ie) ? B : D;
        }
        function mm(D, B, ie, Ce, $e, dt) {
          return oc(D) && oc(B) && (dt.set(B, D), aD(D, B, e2, mm, dt), dt.delete(B)), D;
        }
        function H9(D) {
          return Lb(D) ? e2 : D;
        }
        function iO(D, B, ie, Ce, $e, dt) {
          var $t = ie & T, Qt = D.length, In = B.length;
          if (Qt != In && !($t && In > Qt))
            return false;
          var jr = dt.get(D), Nr = dt.get(B);
          if (jr && Nr)
            return jr == B && Nr == D;
          var Yr = -1, za = true, Ii = ie & O ? new pb() : e2;
          for (dt.set(D, B), dt.set(B, D); ++Yr < Qt; ) {
            var no = D[Yr], Ro = B[Yr];
            if (Ce)
              var eo = $t ? Ce(Ro, no, Yr, B, D, dt) : Ce(no, Ro, Yr, D, B, dt);
            if (eo !== e2) {
              if (eo)
                continue;
              za = false;
              break;
            }
            if (Ii) {
              if (!pm(B, function(Ws, ys) {
                if (!mM(Ii, ys) && (no === Ws || $e(no, Ws, ie, Ce, dt)))
                  return Ii.push(ys);
              })) {
                za = false;
                break;
              }
            } else if (!(no === Ro || $e(no, Ro, ie, Ce, dt))) {
              za = false;
              break;
            }
          }
          return dt.delete(D), dt.delete(B), za;
        }
        function $9(D, B, ie, Ce, $e, dt, $t) {
          switch (ie) {
            case Fr:
              if (D.byteLength != B.byteLength || D.byteOffset != B.byteOffset)
                return false;
              D = D.buffer, B = B.buffer;
            case Bn:
              return !(D.byteLength != B.byteLength || !dt(new cx(D), new cx(B)));
            case da:
            case Ra:
            case ps:
              return ii(+D, +B);
            case wa:
              return D.name == B.name && D.message == B.message;
            case _h:
            case Uc:
              return D == B + "";
            case wi:
              var Qt = CL;
            case Nl:
              var In = Ce & T;
              if (Qt || (Qt = FT), D.size != B.size && !In)
                return false;
              var jr = $t.get(D);
              if (jr)
                return jr == B;
              Ce |= O, $t.set(D, B);
              var Nr = iO(Qt(D), Qt(B), Ce, $e, dt, $t);
              return $t.delete(D), Nr;
            case Nu:
              if (hx)
                return hx.call(D) == hx.call(B);
          }
          return false;
        }
        function U9(D, B, ie, Ce, $e, dt) {
          var $t = ie & T, Qt = hD(D), In = Qt.length, jr = hD(B), Nr = jr.length;
          if (In != Nr && !$t)
            return false;
          for (var Yr = In; Yr--; ) {
            var za = Qt[Yr];
            if (!($t ? za in B : zl.call(B, za)))
              return false;
          }
          var Ii = dt.get(D), no = dt.get(B);
          if (Ii && no)
            return Ii == B && no == D;
          var Ro = true;
          dt.set(D, B), dt.set(B, D);
          for (var eo = $t; ++Yr < In; ) {
            za = Qt[Yr];
            var Ws = D[za], ys = B[za];
            if (Ce)
              var Eh = $t ? Ce(ys, Ws, za, B, D, dt) : Ce(Ws, ys, za, D, B, dt);
            if (!(Eh === e2 ? Ws === ys || $e(Ws, ys, ie, Ce, dt) : Eh)) {
              Ro = false;
              break;
            }
            eo || (eo = za == "constructor");
          }
          if (Ro && !eo) {
            var cd = D.constructor, np = B.constructor;
            cd != np && "constructor" in D && "constructor" in B && !(typeof cd == "function" && cd instanceof cd && typeof np == "function" && np instanceof np) && (Ro = false);
          }
          return dt.delete(D), dt.delete(B), Ro;
        }
        function Lo(D) {
          return dO(vD(D, e2, bO), D + "");
        }
        function hD(D) {
          return JT(D, kf, sO);
        }
        function dD(D) {
          return JT(D, Fp, q9);
        }
        var pD = Tp ? function(D) {
          return Tp.get(D);
        } : oR;
        function ll(D) {
          for (var B = D.name + "", ie = O2[B], Ce = zl.call(O2, B) ? ie.length : 0; Ce--; ) {
            var $e = ie[Ce], dt = $e.func;
            if (dt == null || dt == D)
              return $e.name;
          }
          return B;
        }
        function ug(D) {
          var B = zl.call(ot, "placeholder") ? ot : D;
          return B.placeholder;
        }
        function Yi() {
          var D = ot.iteratee || jD;
          return D = D === jD ? kM : D, arguments.length ? D(arguments[0], arguments[1]) : D;
        }
        function n1(D, B) {
          var ie = D.__data__;
          return xx(B) ? ie[typeof B == "string" ? "string" : "hash"] : ie.map;
        }
        function oO(D) {
          for (var B = kf(D), ie = B.length; ie--; ) {
            var Ce = B[ie], $e = D[Ce];
            B[ie] = [Ce, $e, Lc($e)];
          }
          return B;
        }
        function Mb(D, B) {
          var ie = wL(D, B);
          return nD(ie) ? ie : e2;
        }
        function JU(D) {
          var B = zl.call(D, fb), ie = D[fb];
          try {
            D[fb] = e2;
            var Ce = true;
          } catch {
          }
          var $e = wM.call(D);
          return Ce && (B ? D[fb] = ie : delete D[fb]), $e;
        }
        var sO = IL ? function(D) {
          return D == null ? [] : (D = Kl(D), fm(IL(D), function(B) {
            return Kg.call(D, B);
          }));
        } : $2, q9 = IL ? function(D) {
          for (var B = []; D; )
            dm(B, sO(D)), D = SM(D);
          return B;
        } : $2, od = Kd;
        (TL && od(new TL(new ArrayBuffer(1))) != Fr || k2 && od(new k2()) != wi || DL && od(DL.resolve()) != If || P2 && od(new P2()) != Nl || Yy && od(new Yy()) != Rr) && (od = function(D) {
          var B = Kd(D), ie = B == vl ? D.constructor : e2, Ce = ie ? Cx(ie) : "";
          if (Ce)
            switch (Ce) {
              case AM:
                return Fr;
              case kL:
                return wi;
              case R2:
                return If;
              case PL:
                return Nl;
              case hb:
                return Rr;
            }
          return B;
        });
        function QU(D, B, ie) {
          for (var Ce = -1, $e = ie.length; ++Ce < $e; ) {
            var dt = ie[Ce], $t = dt.size;
            switch (dt.type) {
              case "drop":
                D += $t;
                break;
              case "dropRight":
                B -= $t;
                break;
              case "take":
                B = Sh(B, D + $t);
                break;
              case "takeRight":
                D = wc(D, B - $t);
                break;
            }
          }
          return { start: D, end: B };
        }
        function eq(D) {
          var B = D.match(lL);
          return B ? B[1].split(uL) : [];
        }
        function lO(D, B, ie) {
          B = Sb(B, D);
          for (var Ce = -1, $e = B.length, dt = false; ++Ce < $e; ) {
            var $t = ym(B[Ce]);
            if (!(dt = D != null && ie(D, $t)))
              break;
            D = D[$t];
          }
          return dt || ++Ce != $e ? dt : ($e = D == null ? 0 : D.length, !!$e && JM($e) && r1($t, $e) && (Oo(D) || Pb(D)));
        }
        function GM(D) {
          var B = D.length, ie = new D.constructor(B);
          return B && typeof D[0] == "string" && zl.call(D, "index") && (ie.index = D.index, ie.input = D.input), ie;
        }
        function Zc(D) {
          return typeof D.constructor == "function" && !Sx(D) ? Qg(SM(D)) : {};
        }
        function uO(D, B, ie) {
          var Ce = D.constructor;
          switch (B) {
            case Bn:
              return zM(D);
            case da:
            case Ra:
              return new Ce(+D);
            case Fr:
              return qU(D, ie);
            case Oa:
            case yi:
            case Bo:
            case jo:
            case xl:
            case Uu:
            case vu:
            case qc:
            case gu:
              return V9(D, ie);
            case wi:
              return new Ce();
            case ps:
            case Uc:
              return new Ce(D);
            case _h:
              return YU(D);
            case Nl:
              return new Ce();
            case Nu:
              return ZU(D);
          }
        }
        function WM(D, B) {
          var ie = B.length;
          if (!ie)
            return D;
          var Ce = ie - 1;
          return B[Ce] = (ie > 1 ? "& " : "") + B[Ce], B = B.join(ie > 2 ? ", " : " "), D.replace(sL, `{
/* [wrapped with ` + B + `] */
`);
        }
        function tq(D) {
          return Oo(D) || Pb(D) || !!(fx && D && D[fx]);
        }
        function r1(D, B) {
          var ie = typeof D;
          return B = B == null ? xt : B, !!B && (ie == "number" || ie != "symbol" && hn.test(D)) && D > -1 && D % 1 == 0 && D < B;
        }
        function Jd(D, B, ie) {
          if (!oc(ie))
            return false;
          var Ce = typeof B;
          return (Ce == "number" ? sd(ie) && r1(B, ie.length) : Ce == "string" && B in ie) ? ii(ie[B], D) : false;
        }
        function cO(D, B) {
          if (Oo(D))
            return false;
          var ie = typeof D;
          return ie == "number" || ie == "symbol" || ie == "boolean" || D == null || ep(D) ? true : bv.test(D) || !Wd.test(D) || B != null && D in Kl(B);
        }
        function xx(D) {
          var B = typeof D;
          return B == "string" || B == "number" || B == "symbol" || B == "boolean" ? D !== "__proto__" : D === null;
        }
        function Xo(D) {
          var B = ll(D), ie = ot[B];
          if (typeof ie != "function" || !(B in el.prototype))
            return false;
          if (D === ie)
            return true;
          var Ce = pD(ie);
          return !!Ce && D === Ce[0];
        }
        function nq(D) {
          return !!b9 && b9 in D;
        }
        var HM = xM ? Av : lR;
        function Sx(D) {
          var B = D && D.constructor, ie = typeof B == "function" && B.prototype || Xg;
          return D === ie;
        }
        function Lc(D) {
          return D === D && !oc(D);
        }
        function Y9(D, B) {
          return function(ie) {
            return ie == null ? false : ie[D] === B && (B !== e2 || D in Kl(ie));
          };
        }
        function $M(D) {
          var B = ZM(D, function(Ce) {
            return ie.size === y4 && ie.clear(), Ce;
          }), ie = B.cache;
          return B;
        }
        function Z9(D, B) {
          var ie = D[1], Ce = B[1], $e = ie | Ce, dt = $e < (N | V | me), $t = Ce == me && ie == X || Ce == me && ie == ye && D[7].length <= B[8] || Ce == (me | ye) && B[7].length <= B[8] && ie == X;
          if (!(dt || $t))
            return D;
          Ce & N && (D[2] = B[2], $e |= ie & N ? 0 : H);
          var Qt = B[3];
          if (Qt) {
            var In = D[3];
            D[3] = In ? KL(In, Qt, B[4]) : Qt, D[4] = In ? qy(D[3], _) : B[4];
          }
          return Qt = B[5], Qt && (In = D[5], D[5] = In ? bi(In, Qt, B[6]) : Qt, D[6] = In ? qy(D[5], _) : B[6]), Qt = B[7], Qt && (D[7] = Qt), Ce & me && (D[8] = D[8] == null ? B[8] : Sh(D[8], B[8])), D[9] == null && (D[9] = B[9]), D[0] = B[0], D[1] = $e, D;
        }
        function rq(D) {
          var B = [];
          if (D != null)
            for (var ie in Kl(D))
              B.push(ie);
          return B;
        }
        function aq(D) {
          return wM.call(D);
        }
        function vD(D, B, ie) {
          return B = wc(B === e2 ? D.length - 1 : B, 0), function() {
            for (var Ce = arguments, $e = -1, dt = wc(Ce.length - B, 0), $t = Jn(dt); ++$e < dt; )
              $t[$e] = Ce[B + $e];
            $e = -1;
            for (var Qt = Jn(B + 1); ++$e < B; )
              Qt[$e] = Ce[$e];
            return Qt[B] = ie($t), Df(D, this, Qt);
          };
        }
        function fO(D, B) {
          return B.length < 2 ? D : dx(D, th(B, 0, -1));
        }
        function iq(D, B) {
          for (var ie = D.length, Ce = Sh(B.length, ie), $e = Mh(D); Ce--; ) {
            var dt = B[Ce];
            D[Ce] = r1(dt, ie) ? $e[dt] : e2;
          }
          return D;
        }
        function a1(D, B) {
          if (!(B === "constructor" && typeof D[B] == "function") && B != "__proto__")
            return D[B];
        }
        var hO = gD(xb), Lp = w9 || function(D, B) {
          return mu.setTimeout(D, B);
        }, dO = gD(mx);
        function X9(D, B, ie) {
          var Ce = B + "";
          return dO(D, WM(Ce, oq(eq(Ce), ie)));
        }
        function gD(D) {
          var B = 0, ie = 0;
          return function() {
            var Ce = DU(), $e = Re - (Ce - ie);
            if (ie = Ce, $e > 0) {
              if (++B >= ze)
                return arguments[0];
            } else
              B = 0;
            return D.apply(e2, arguments);
          };
        }
        function mD(D, B) {
          var ie = -1, Ce = D.length, $e = Ce - 1;
          for (B = B === e2 ? Ce : B; ++ie < B; ) {
            var dt = lg(ie, $e), $t = D[dt];
            D[dt] = D[ie], D[ie] = $t;
          }
          return D.length = B, D;
        }
        var pO = $M(function(D) {
          var B = [];
          return D.charCodeAt(0) === 46 && B.push(""), D.replace(ub, function(ie, Ce, $e, dt) {
            B.push($e ? dt.replace(zt, "$1") : Ce || ie);
          }), B;
        });
        function ym(D) {
          if (typeof D == "string" || ep(D))
            return D;
          var B = D + "";
          return B == "0" && 1 / D == -Jt ? "-0" : B;
        }
        function Cx(D) {
          if (D != null) {
            try {
              return D2.call(D);
            } catch {
            }
            try {
              return D + "";
            } catch {
            }
          }
          return "";
        }
        function oq(D, B) {
          return gf(ga, function(ie) {
            var Ce = "_." + ie[0];
            B & ie[1] && !hm(D, Ce) && D.push(Ce);
          }), D.sort();
        }
        function K9(D) {
          if (D instanceof el)
            return D.clone();
          var B = new Dp(D.__wrapped__, D.__chain__);
          return B.__actions__ = Mh(D.__actions__), B.__index__ = D.__index__, B.__values__ = D.__values__, B;
        }
        function yD(D, B, ie) {
          (ie ? Jd(D, B, ie) : B === e2) ? B = 1 : B = wc(Ko(B), 0);
          var Ce = D == null ? 0 : D.length;
          if (!Ce || B < 1)
            return [];
          for (var $e = 0, dt = 0, $t = Jn(Jg(Ce / B)); $e < Ce; )
            $t[dt++] = th(D, $e, $e += B);
          return $t;
        }
        function Mx(D) {
          for (var B = -1, ie = D == null ? 0 : D.length, Ce = 0, $e = []; ++B < ie; ) {
            var dt = D[B];
            dt && ($e[Ce++] = dt);
          }
          return $e;
        }
        function sq() {
          var D = arguments.length;
          if (!D)
            return [];
          for (var B = Jn(D - 1), ie = arguments[0], Ce = D; Ce--; )
            B[Ce - 1] = arguments[Ce];
          return dm(Oo(ie) ? Mh(ie) : [ie], Ch(B, 1));
        }
        var lq = vs(function(D, B) {
          return Yu(D) ? gb(D, Ch(B, 1, Yu, true)) : [];
        }), uq = vs(function(D, B) {
          var ie = Cv(B);
          return Yu(ie) && (ie = e2), Yu(D) ? gb(D, Ch(B, 1, Yu, true), Yi(ie, 2)) : [];
        }), vO = vs(function(D, B) {
          var ie = Cv(B);
          return Yu(ie) && (ie = e2), Yu(D) ? gb(D, Ch(B, 1, Yu, true), e2, ie) : [];
        });
        function cq(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          return Ce ? (B = ie || B === e2 ? 1 : Ko(B), th(D, B < 0 ? 0 : B, Ce)) : [];
        }
        function gO(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          return Ce ? (B = ie || B === e2 ? 1 : Ko(B), B = Ce - B, th(D, 0, B < 0 ? 0 : B)) : [];
        }
        function J9(D, B) {
          return D && D.length ? t1(D, Yi(B, 3), true, true) : [];
        }
        function bD(D, B) {
          return D && D.length ? t1(D, Yi(B, 3), true) : [];
        }
        function mO(D, B, ie, Ce) {
          var $e = D == null ? 0 : D.length;
          return $e ? (ie && typeof ie != "number" && Jd(D, B, ie) && (ie = 0, Ce = $e), GU(D, B, ie, Ce)) : [];
        }
        function Q9(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          if (!Ce)
            return -1;
          var $e = ie == null ? 0 : Ko(ie);
          return $e < 0 && ($e = wc(Ce + $e, 0)), Yg(D, Yi(B, 3), $e);
        }
        function yO(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          if (!Ce)
            return -1;
          var $e = Ce - 1;
          return ie !== e2 && ($e = Ko(ie), $e = ie < 0 ? wc(Ce + $e, 0) : Sh($e, Ce - 1)), Yg(D, Yi(B, 3), $e, true);
        }
        function bO(D) {
          var B = D == null ? 0 : D.length;
          return B ? Ch(D, 1) : [];
        }
        function fq(D) {
          var B = D == null ? 0 : D.length;
          return B ? Ch(D, Jt) : [];
        }
        function hq(D, B) {
          var ie = D == null ? 0 : D.length;
          return ie ? (B = B === e2 ? 1 : Ko(B), Ch(D, B)) : [];
        }
        function dq(D) {
          for (var B = -1, ie = D == null ? 0 : D.length, Ce = {}; ++B < ie; ) {
            var $e = D[B];
            Ce[$e[0]] = $e[1];
          }
          return Ce;
        }
        function _O(D) {
          return D && D.length ? D[0] : e2;
        }
        function pq(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          if (!Ce)
            return -1;
          var $e = ie == null ? 0 : Ko(ie);
          return $e < 0 && ($e = wc(Ce + $e, 0)), xv(D, B, $e);
        }
        function vq(D) {
          var B = D == null ? 0 : D.length;
          return B ? th(D, 0, -1) : [];
        }
        var xO = vs(function(D) {
          var B = ic(D, NM);
          return B.length && B[0] === D[0] ? HL(B) : [];
        }), gq = vs(function(D) {
          var B = Cv(D), ie = ic(D, NM);
          return B === Cv(ie) ? B = e2 : ie.pop(), ie.length && ie[0] === D[0] ? HL(ie, Yi(B, 2)) : [];
        }), mq = vs(function(D) {
          var B = Cv(D), ie = ic(D, NM);
          return B = typeof B == "function" ? B : e2, B && ie.pop(), ie.length && ie[0] === D[0] ? HL(ie, e2, B) : [];
        });
        function yq(D, B) {
          return D == null ? "" : TU.call(D, B);
        }
        function Cv(D) {
          var B = D == null ? 0 : D.length;
          return B ? D[B - 1] : e2;
        }
        function wO(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          if (!Ce)
            return -1;
          var $e = Ce;
          return ie !== e2 && ($e = Ko(ie), $e = $e < 0 ? wc(Ce + $e, 0) : Sh($e, Ce - 1)), B === B ? ML(D, B, $e) : Yg(D, c9, $e, true);
        }
        function Ax(D, B) {
          return D && D.length ? UL(D, Ko(B)) : e2;
        }
        var _D = vs(SO);
        function SO(D, B) {
          return D && D.length && B && B.length ? LM(D, B) : D;
        }
        function bq(D, B, ie) {
          return D && D.length && B && B.length ? LM(D, B, Yi(ie, 2)) : D;
        }
        function _q(D, B, ie) {
          return D && D.length && B && B.length ? LM(D, B, e2, ie) : D;
        }
        var CO = Lo(function(D, B) {
          var ie = D == null ? 0 : D.length, Ce = ZT(D, B);
          return F9(D, ic(B, function($e) {
            return r1($e, ie) ? +$e : $e;
          }).sort(XL)), Ce;
        });
        function MO(D, B) {
          var ie = [];
          if (!(D && D.length))
            return ie;
          var Ce = -1, $e = [], dt = D.length;
          for (B = Yi(B, 3); ++Ce < dt; ) {
            var $t = D[Ce];
            B($t, Ce, D) && (ie.push($t), $e.push(Ce));
          }
          return F9(D, $e), ie;
        }
        function AO(D) {
          return D == null ? D : PU.call(D);
        }
        function cg(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          return Ce ? (ie && typeof ie != "number" && Jd(D, B, ie) ? (B = 0, ie = Ce) : (B = B == null ? 0 : Ko(B), ie = ie === e2 ? Ce : Ko(ie)), th(D, B, ie)) : [];
        }
        function Op(D, B) {
          return wb(D, B);
        }
        function Rp(D, B, ie) {
          return YL(D, B, Yi(ie, 2));
        }
        function EO(D, B) {
          var ie = D == null ? 0 : D.length;
          if (ie) {
            var Ce = wb(D, B);
            if (Ce < ie && ii(D[Ce], B))
              return Ce;
          }
          return -1;
        }
        function IO(D, B) {
          return wb(D, B, true);
        }
        function Ex(D, B, ie) {
          return YL(D, B, Yi(ie, 2), true);
        }
        function xD(D, B) {
          var ie = D == null ? 0 : D.length;
          if (ie) {
            var Ce = wb(D, B, true) - 1;
            if (ii(D[Ce], B))
              return Ce;
          }
          return -1;
        }
        function wD(D) {
          return D && D.length ? Qi(D) : [];
        }
        function SD(D, B) {
          return D && D.length ? Qi(D, Yi(B, 2)) : [];
        }
        function CD(D) {
          var B = D == null ? 0 : D.length;
          return B ? th(D, 1, B) : [];
        }
        function e7(D, B, ie) {
          return D && D.length ? (B = ie || B === e2 ? 1 : Ko(B), th(D, 0, B < 0 ? 0 : B)) : [];
        }
        function t7(D, B, ie) {
          var Ce = D == null ? 0 : D.length;
          return Ce ? (B = ie || B === e2 ? 1 : Ko(B), B = Ce - B, th(D, B < 0 ? 0 : B, Ce)) : [];
        }
        function n7(D, B) {
          return D && D.length ? t1(D, Yi(B, 3), false, true) : [];
        }
        function xq(D, B) {
          return D && D.length ? t1(D, Yi(B, 3)) : [];
        }
        var wq = vs(function(D) {
          return e1(Ch(D, 1, Yu, true));
        }), Sq = vs(function(D) {
          var B = Cv(D);
          return Yu(B) && (B = e2), e1(Ch(D, 1, Yu, true), Yi(B, 2));
        }), Bl = vs(function(D) {
          var B = Cv(D);
          return B = typeof B == "function" ? B : e2, e1(Ch(D, 1, Yu, true), e2, B);
        });
        function Ix(D) {
          return D && D.length ? e1(D) : [];
        }
        function Tx(D, B) {
          return D && D.length ? e1(D, Yi(B, 2)) : [];
        }
        function bm(D, B) {
          return B = typeof B == "function" ? B : e2, D && D.length ? e1(D, e2, B) : [];
        }
        function _m(D) {
          if (!(D && D.length))
            return [];
          var B = 0;
          return D = fm(D, function(ie) {
            if (Yu(ie))
              return B = wc(ie.length, B), true;
          }), RT(B, function(ie) {
            return ic(D, vL(ie));
          });
        }
        function u0(D, B) {
          if (!(D && D.length))
            return [];
          var ie = _m(D);
          return B == null ? ie : ic(ie, function(Ce) {
            return Df(B, e2, Ce);
          });
        }
        var xm = vs(function(D, B) {
          return Yu(D) ? gb(D, B) : [];
        }), TO = vs(function(D) {
          return wv(fm(D, Yu));
        }), DO = vs(function(D) {
          var B = Cv(D);
          return Yu(B) && (B = e2), wv(fm(D, Yu), Yi(B, 2));
        }), Dx = vs(function(D) {
          var B = Cv(D);
          return B = typeof B == "function" ? B : e2, wv(fm(D, Yu), e2, B);
        }), kx = vs(_m);
        function i1(D, B) {
          return FM(D || [], B || [], EM);
        }
        function kO(D, B) {
          return FM(D || [], B || [], _b2);
        }
        var Ab = vs(function(D) {
          var B = D.length, ie = B > 1 ? D[B - 1] : e2;
          return ie = typeof ie == "function" ? (D.pop(), ie) : e2, u0(D, ie);
        });
        function MD(D) {
          var B = ot(D);
          return B.__chain__ = true, B;
        }
        function UM(D, B) {
          return B(D), D;
        }
        function B2(D, B) {
          return B(D);
        }
        var Cq = Lo(function(D) {
          var B = D.length, ie = B ? D[0] : 0, Ce = this.__wrapped__, $e = function(dt) {
            return ZT(dt, D);
          };
          return B > 1 || this.__actions__.length || !(Ce instanceof el) || !r1(ie) ? this.thru($e) : (Ce = Ce.slice(ie, +ie + (B ? 1 : 0)), Ce.__actions__.push({ func: B2, args: [$e], thisArg: e2 }), new Dp(Ce, this.__chain__).thru(function(dt) {
            return B && !dt.length && dt.push(e2), dt;
          }));
        });
        function Mq() {
          return MD(this);
        }
        function wm() {
          return new Dp(this.value(), this.__chain__);
        }
        function Eb() {
          this.__values__ === e2 && (this.__values__ = GO(this.value()));
          var D = this.__index__ >= this.__values__.length, B = D ? e2 : this.__values__[this.__index__++];
          return { done: D, value: B };
        }
        function Aq() {
          return this;
        }
        function r7(D) {
          for (var B, ie = this; ie instanceof id2; ) {
            var Ce = K9(ie);
            Ce.__index__ = 0, Ce.__values__ = e2, B ? $e.__wrapped__ = Ce : B = Ce;
            var $e = Ce;
            ie = ie.__wrapped__;
          }
          return $e.__wrapped__ = D, B;
        }
        function a7() {
          var D = this.__wrapped__;
          if (D instanceof el) {
            var B = D;
            return this.__actions__.length && (B = new el(this)), B = B.reverse(), B.__actions__.push({ func: B2, args: [AO], thisArg: e2 }), new Dp(B, this.__chain__);
          }
          return this.thru(AO);
        }
        function Ib() {
          return RM(this.__wrapped__, this.__actions__);
        }
        var qM = lD(function(D, B, ie) {
          zl.call(D, ie) ? ++D[ie] : ag(D, ie, 1);
        });
        function Eq(D, B, ie) {
          var Ce = Oo(D) ? dL : GL;
          return ie && Jd(D, B, ie) && (B = e2), Ce(D, Yi(B, 3));
        }
        function o1(D, B) {
          var ie = Oo(D) ? fm : P9;
          return ie(D, Yi(B, 3));
        }
        var Tb = Sv(Q9), Px = Sv(yO);
        function Iq(D, B) {
          return Ch(AD(D, B), 1);
        }
        function Tq(D, B) {
          return Ch(AD(D, B), Jt);
        }
        function Qd(D, B, ie) {
          return ie = ie === e2 ? 1 : Ko(ie), Ch(AD(D, B), ie);
        }
        function Mv(D, B) {
          var ie = Oo(D) ? gf : ig;
          return ie(D, Yi(B, 3));
        }
        function i7(D, B) {
          var ie = Oo(D) ? bU : k9;
          return ie(D, Yi(B, 3));
        }
        var Dq = lD(function(D, B, ie) {
          zl.call(D, ie) ? D[ie].push(B) : ag(D, ie, [B]);
        });
        function kq(D, B, ie, Ce) {
          D = sd(D) ? D : W2(D), ie = ie && !Ce ? Ko(ie) : 0;
          var $e = D.length;
          return ie < 0 && (ie = wc($e + ie, 0)), PD(D) ? ie <= $e && D.indexOf(B, ie) > -1 : !!$e && xv(D, B, ie) > -1;
        }
        var Pq = vs(function(D, B, ie) {
          var Ce = -1, $e = typeof B == "function", dt = sd(D) ? Jn(D.length) : [];
          return ig(D, function($t) {
            dt[++Ce] = $e ? Df(B, $t, ie) : mb($t, B, ie);
          }), dt;
        }), o7 = lD(function(D, B, ie) {
          ag(D, ie, B);
        });
        function AD(D, B) {
          var ie = Oo(D) ? ic : yb;
          return ie(D, Yi(B, 3));
        }
        function Lq(D, B, ie, Ce) {
          return D == null ? [] : (Oo(B) || (B = B == null ? [] : [B]), ie = Ce ? e2 : ie, Oo(ie) || (ie = ie == null ? [] : [ie]), bb(D, B, ie));
        }
        var ED = lD(function(D, B, ie) {
          D[ie ? 0 : 1].push(B);
        }, function() {
          return [[], []];
        });
        function Oq(D, B, ie) {
          var Ce = Oo(D) ? ix : h9, $e = arguments.length < 3;
          return Ce(D, Yi(B, 4), ie, $e, ig);
        }
        function PO(D, B, ie) {
          var Ce = Oo(D) ? pL : h9, $e = arguments.length < 3;
          return Ce(D, Yi(B, 4), ie, $e, k9);
        }
        function Rq(D, B) {
          var ie = Oo(D) ? fm : P9;
          return ie(D, XM(Yi(B, 3)));
        }
        function uo(D) {
          var B = Oo(D) ? I9 : Bi;
          return B(D);
        }
        function Fq(D, B, ie) {
          (ie ? Jd(D, B, ie) : B === e2) ? B = 1 : B = Ko(B);
          var Ce = Oo(D) ? UT : iD;
          return Ce(D, B);
        }
        function s7(D) {
          var B = Oo(D) ? T9 : yx;
          return B(D);
        }
        function YM(D) {
          if (D == null)
            return 0;
          if (sd(D))
            return PD(D) ? sx(D) : D.length;
          var B = od(D);
          return B == wi || B == Nl ? D.size : PM(D).length;
        }
        function Nq(D, B, ie) {
          var Ce = Oo(D) ? pm : OM;
          return ie && Jd(D, B, ie) && (B = e2), Ce(D, Yi(B, 3));
        }
        var Vq = vs(function(D, B) {
          if (D == null)
            return [];
          var ie = B.length;
          return ie > 1 && Jd(D, B[0], B[1]) ? B = [] : ie > 2 && Jd(B[0], B[1], B[2]) && (B = [B[0]]), bb(D, Ch(B, 1), []);
        }), ID = VT || function() {
          return mu.Date.now();
        };
        function l7(D, B) {
          if (typeof B != "function")
            throw new qd(h);
          return D = Ko(D), function() {
            if (--D < 1)
              return B.apply(this, arguments);
          };
        }
        function nh(D, B, ie) {
          return B = ie ? e2 : B, B = D && B == null ? D.length : B, l0(D, me, e2, e2, e2, e2, B);
        }
        function u7(D, B) {
          var ie;
          if (typeof B != "function")
            throw new qd(h);
          return D = Ko(D), function() {
            return --D > 0 && (ie = B.apply(this, arguments)), D <= 1 && (B = e2), ie;
          };
        }
        var Db = vs(function(D, B, ie) {
          var Ce = N;
          if (ie.length) {
            var $e = qy(ie, ug(Db));
            Ce |= de;
          }
          return l0(D, Ce, B, ie, $e);
        }), LO = vs(function(D, B, ie) {
          var Ce = N | V;
          if (ie.length) {
            var $e = qy(ie, ug(LO));
            Ce |= de;
          }
          return l0(B, Ce, D, ie, $e);
        });
        function OO(D, B, ie) {
          B = ie ? e2 : B;
          var Ce = l0(D, X, e2, e2, e2, e2, e2, B);
          return Ce.placeholder = OO.placeholder, Ce;
        }
        function kb(D, B, ie) {
          B = ie ? e2 : B;
          var Ce = l0(D, q2, e2, e2, e2, e2, e2, B);
          return Ce.placeholder = kb.placeholder, Ce;
        }
        function c7(D, B, ie) {
          var Ce, $e, dt, $t, Qt, In, jr = 0, Nr = false, Yr = false, za = true;
          if (typeof D != "function")
            throw new qd(h);
          B = Ev(B) || 0, oc(ie) && (Nr = !!ie.leading, Yr = "maxWait" in ie, dt = Yr ? wc(Ev(ie.maxWait) || 0, B) : dt, za = "trailing" in ie ? !!ie.trailing : za);
          function Ii(Xc) {
            var fd = Ce, Tm = $e;
            return Ce = $e = e2, jr = Xc, $t = D.apply(Tm, fd), $t;
          }
          function no(Xc) {
            return jr = Xc, Qt = Lp(Ws, B), Nr ? Ii(Xc) : $t;
          }
          function Ro(Xc) {
            var fd = Xc - In, Tm = Xc - jr, s1 = B - fd;
            return Yr ? Sh(s1, dt - Tm) : s1;
          }
          function eo(Xc) {
            var fd = Xc - In, Tm = Xc - jr;
            return In === e2 || fd >= B || fd < 0 || Yr && Tm >= dt;
          }
          function Ws() {
            var Xc = ID();
            if (eo(Xc))
              return ys(Xc);
            Qt = Lp(Ws, Ro(Xc));
          }
          function ys(Xc) {
            return Qt = e2, za && Ce ? Ii(Xc) : (Ce = $e = e2, $t);
          }
          function Eh() {
            Qt !== e2 && oD(Qt), jr = 0, Ce = In = $e = Qt = e2;
          }
          function cd() {
            return Qt === e2 ? $t : ys(ID());
          }
          function np() {
            var Xc = ID(), fd = eo(Xc);
            if (Ce = arguments, $e = this, In = Xc, fd) {
              if (Qt === e2)
                return no(In);
              if (Yr)
                return oD(Qt), Qt = Lp(Ws, B), Ii(In);
            }
            return Qt === e2 && (Qt = Lp(Ws, B)), $t;
          }
          return np.cancel = Eh, np.flush = cd, np;
        }
        var zq = vs(function(D, B) {
          return jL(D, 1, B);
        }), f7 = vs(function(D, B, ie) {
          return jL(D, Ev(B) || 0, ie);
        });
        function rs(D) {
          return l0(D, be);
        }
        function ZM(D, B) {
          if (typeof D != "function" || B != null && typeof B != "function")
            throw new qd(h);
          var ie = function() {
            var Ce = arguments, $e = B ? B.apply(this, Ce) : Ce[0], dt = ie.cache;
            if (dt.has($e))
              return dt.get($e);
            var $t = D.apply(this, Ce);
            return ie.cache = dt.set($e, $t) || dt, $t;
          };
          return ie.cache = new (ZM.Cache || Xy)(), ie;
        }
        ZM.Cache = Xy;
        function XM(D) {
          if (typeof D != "function")
            throw new qd(h);
          return function() {
            var B = arguments;
            switch (B.length) {
              case 0:
                return !D.call(this);
              case 1:
                return !D.call(this, B[0]);
              case 2:
                return !D.call(this, B[0], B[1]);
              case 3:
                return !D.call(this, B[0], B[1], B[2]);
            }
            return !D.apply(this, B);
          };
        }
        function Bq(D) {
          return u7(2, D);
        }
        var h7 = z2(function(D, B) {
          B = B.length == 1 && Oo(B[0]) ? ic(B[0], Ud(Yi())) : ic(Ch(B, 1), Ud(Yi()));
          var ie = B.length;
          return vs(function(Ce) {
            for (var $e = -1, dt = Sh(Ce.length, ie); ++$e < dt; )
              Ce[$e] = B[$e].call(this, Ce[$e]);
            return Df(D, this, Ce);
          });
        }), RO = vs(function(D, B) {
          var ie = qy(B, ug(RO));
          return l0(D, de, e2, B, ie);
        }), d7 = vs(function(D, B) {
          var ie = qy(B, ug(d7));
          return l0(D, le, e2, B, ie);
        }), p7 = Lo(function(D, B) {
          return l0(D, ye, e2, e2, e2, B);
        });
        function v7(D, B) {
          if (typeof D != "function")
            throw new qd(h);
          return B = B === e2 ? B : Ko(B), vs(D, B);
        }
        function g7(D, B) {
          if (typeof D != "function")
            throw new qd(h);
          return B = B == null ? 0 : wc(Ko(B), 0), vs(function(ie) {
            var Ce = ie[B], $e = Cb(ie, 0, B);
            return Ce && dm($e, Ce), Df(D, this, $e);
          });
        }
        function m7(D, B, ie) {
          var Ce = true, $e = true;
          if (typeof D != "function")
            throw new qd(h);
          return oc(ie) && (Ce = "leading" in ie ? !!ie.leading : Ce, $e = "trailing" in ie ? !!ie.trailing : $e), c7(D, B, { leading: Ce, maxWait: B, trailing: $e });
        }
        function jq(D) {
          return nh(D, 1);
        }
        function y7(D, B) {
          return RO(VM(B), D);
        }
        function b7() {
          if (!arguments.length)
            return [];
          var D = arguments[0];
          return Oo(D) ? D : [D];
        }
        function _7(D) {
          return Pp(D, E);
        }
        function x7(D, B) {
          return B = typeof B == "function" ? B : e2, Pp(D, E, B);
        }
        function w7(D) {
          return Pp(D, w4 | E);
        }
        function FO(D, B) {
          return B = typeof B == "function" ? B : e2, Pp(D, w4 | E, B);
        }
        function ms(D, B) {
          return B == null || BL(D, B, kf(B));
        }
        function ii(D, B) {
          return D === B || D !== D && B !== B;
        }
        var NO = fD(QT), S7 = fD(function(D, B) {
          return D >= B;
        }), Pb = eD(function() {
          return arguments;
        }()) ? eD : function(D) {
          return Zu(D) && zl.call(D, "callee") && !Kg.call(D, "callee");
        }, Oo = Jn.isArray, VO = PT ? Ud(PT) : L9;
        function sd(D) {
          return D != null && JM(D.length) && !Av(D);
        }
        function Yu(D) {
          return Zu(D) && sd(D);
        }
        function TD(D) {
          return D === true || D === false || Zu(D) && Kd(D) == da;
        }
        var Oc = eh || lR, KM = pM ? Ud(pM) : $U;
        function j2(D) {
          return Zu(D) && D.nodeType === 1 && !Lb(D);
        }
        function Gq(D) {
          if (D == null)
            return true;
          if (sd(D) && (Oo(D) || typeof D == "string" || typeof D.splice == "function" || Oc(D) || fg(D) || Pb(D)))
            return !D.length;
          var B = od(D);
          if (B == wi || B == Nl)
            return !D.size;
          if (Sx(D))
            return !PM(D).length;
          for (var ie in D)
            if (zl.call(D, ie))
              return false;
          return true;
        }
        function Lx(D, B) {
          return TM(D, B);
        }
        function DD(D, B, ie) {
          ie = typeof ie == "function" ? ie : e2;
          var Ce = ie ? ie(D, B) : e2;
          return Ce === e2 ? TM(D, B, e2, ie) : !!Ce;
        }
        function Ox(D) {
          if (!Zu(D))
            return false;
          var B = Kd(D);
          return B == wa || B == Wa || typeof D.message == "string" && typeof D.name == "string" && !Lb(D);
        }
        function kD(D) {
          return typeof D == "number" && zT(D);
        }
        function Av(D) {
          if (!oc(D))
            return false;
          var B = Kd(D);
          return B == li || B == Ts || B == Pa || B == Xl;
        }
        function Rx(D) {
          return typeof D == "number" && D == Ko(D);
        }
        function JM(D) {
          return typeof D == "number" && D > -1 && D % 1 == 0 && D <= xt;
        }
        function oc(D) {
          var B = typeof D;
          return D != null && (B == "object" || B == "function");
        }
        function Zu(D) {
          return D != null && typeof D == "object";
        }
        var zO = hL ? Ud(hL) : tD;
        function C7(D, B) {
          return D === B || DM(D, B, oO(B));
        }
        function BO(D, B, ie) {
          return ie = typeof ie == "function" ? ie : e2, DM(D, B, oO(B), ie);
        }
        function M7(D) {
          return Sm(D) && D != +D;
        }
        function Wq(D) {
          if (HM(D))
            throw new Io(c4);
          return nD(D);
        }
        function Hq(D) {
          return D === null;
        }
        function A7(D) {
          return D == null;
        }
        function Sm(D) {
          return typeof D == "number" || Zu(D) && Kd(D) == ps;
        }
        function Lb(D) {
          if (!Zu(D) || Kd(D) != vl)
            return false;
          var B = SM(D);
          if (B === null)
            return true;
          var ie = zl.call(B, "constructor") && B.constructor;
          return typeof ie == "function" && ie instanceof ie && D2.call(ie) == AL;
        }
        var jO = Da ? Ud(Da) : $L;
        function $q(D) {
          return Rx(D) && D >= -xt && D <= xt;
        }
        var E7 = kc ? Ud(kc) : UU;
        function PD(D) {
          return typeof D == "string" || !Oo(D) && Zu(D) && Kd(D) == Uc;
        }
        function ep(D) {
          return typeof D == "symbol" || Zu(D) && Kd(D) == Nu;
        }
        var fg = vM ? Ud(vM) : og;
        function I7(D) {
          return D === e2;
        }
        function T7(D) {
          return Zu(D) && od(D) == Rr;
        }
        function Cm(D) {
          return Zu(D) && Kd(D) == $n;
        }
        var Mm = fD(sg), D7 = fD(function(D, B) {
          return D <= B;
        });
        function GO(D) {
          if (!D)
            return [];
          if (sd(D))
            return PD(D) ? Zg(D) : Mh(D);
          if (rg && D[rg])
            return SL(D[rg]());
          var B = od(D), ie = B == wi ? CL : B == Nl ? FT : W2;
          return ie(D);
        }
        function Am(D) {
          if (!D)
            return D === 0 ? D : 0;
          if (D = Ev(D), D === Jt || D === -Jt) {
            var B = D < 0 ? -1 : 1;
            return B * It;
          }
          return D === D ? D : 0;
        }
        function Ko(D) {
          var B = Am(D), ie = B % 1;
          return B === B ? ie ? B - ie : B : 0;
        }
        function WO(D) {
          return D ? t0(Ko(D), 0, sn) : 0;
        }
        function Ev(D) {
          if (typeof D == "number")
            return D;
          if (ep(D))
            return Wt;
          if (oc(D)) {
            var B = typeof D.valueOf == "function" ? D.valueOf() : D;
            D = oc(B) ? B + "" : B;
          }
          if (typeof D != "string")
            return D === 0 ? D : +D;
          D = d9(D);
          var ie = tt.test(D);
          return ie || hr.test(D) ? cL(D.slice(2), ie ? 2 : 8) : kt.test(D) ? Wt : +D;
        }
        function LD(D) {
          return i0(D, Fp(D));
        }
        function HO(D) {
          return D ? t0(Ko(D), -xt, xt) : D === 0 ? D : 0;
        }
        function jl(D) {
          return D == null ? "" : qu(D);
        }
        var $O = _x(function(D, B) {
          if (Sx(B) || sd(B)) {
            i0(B, kf(B), D);
            return;
          }
          for (var ie in B)
            zl.call(B, ie) && EM(D, ie, B[ie]);
        }), k7 = _x(function(D, B) {
          i0(B, Fp(B), D);
        }), OD = _x(function(D, B, ie, Ce) {
          i0(B, Fp(B), D, Ce);
        }), Uq = _x(function(D, B, ie, Ce) {
          i0(B, kf(B), D, Ce);
        }), P7 = Lo(ZT);
        function qq(D, B) {
          var ie = Qg(D);
          return B == null ? ie : D9(ie, B);
        }
        var Fx = vs(function(D, B) {
          D = Kl(D);
          var ie = -1, Ce = B.length, $e = Ce > 2 ? B[2] : e2;
          for ($e && Jd(B[0], B[1], $e) && (Ce = 1); ++ie < Ce; )
            for (var dt = B[ie], $t = Fp(dt), Qt = -1, In = $t.length; ++Qt < In; ) {
              var jr = $t[Qt], Nr = D[jr];
              (Nr === e2 || ii(Nr, Xg[jr]) && !zl.call(D, jr)) && (D[jr] = dt[jr]);
            }
          return D;
        }), Yq = vs(function(D) {
          return D.push(e2, mm), Df(eA, e2, D);
        });
        function Cc(D, B) {
          return Qf(D, Yi(B, 3), n0);
        }
        function UO(D, B) {
          return Qf(D, Yi(B, 3), KT);
        }
        function L7(D, B) {
          return D == null ? D : IM(D, Yi(B, 3), Fp);
        }
        function Zq(D, B) {
          return D == null ? D : XT(D, Yi(B, 3), Fp);
        }
        function Ah(D, B) {
          return D && n0(D, Yi(B, 3));
        }
        function Nx(D, B) {
          return D && KT(D, Yi(B, 3));
        }
        function QM(D) {
          return D == null ? [] : N2(D, kf(D));
        }
        function Xq(D) {
          return D == null ? [] : N2(D, Fp(D));
        }
        function qO(D, B, ie) {
          var Ce = D == null ? e2 : dx(D, B);
          return Ce === e2 ? ie : Ce;
        }
        function YO(D, B) {
          return D != null && lO(D, B, WU);
        }
        function RD(D, B) {
          return D != null && lO(D, B, r0);
        }
        var Kq = QL(function(D, B, ie) {
          B != null && typeof B.toString != "function" && (B = wM.call(B)), D[B] = ie;
        }, BD(tp)), G2 = QL(function(D, B, ie) {
          B != null && typeof B.toString != "function" && (B = wM.call(B)), zl.call(D, B) ? D[B].push(ie) : D[B] = [ie];
        }, Yi), Jq = vs(mb);
        function kf(D) {
          return sd(D) ? $T(D) : PM(D);
        }
        function Fp(D) {
          return sd(D) ? $T(D, true) : Qy(D);
        }
        function O7(D, B) {
          var ie = {};
          return B = Yi(B, 3), n0(D, function(Ce, $e, dt) {
            ag(ie, B(Ce, $e, dt), Ce);
          }), ie;
        }
        function ZO(D, B) {
          var ie = {};
          return B = Yi(B, 3), n0(D, function(Ce, $e, dt) {
            ag(ie, $e, B(Ce, $e, dt));
          }), ie;
        }
        var FD = _x(function(D, B, ie) {
          aD(D, B, ie);
        }), eA = _x(function(D, B, ie, Ce) {
          aD(D, B, ie, Ce);
        }), tA = Lo(function(D, B) {
          var ie = {};
          if (D == null)
            return ie;
          var Ce = false;
          B = ic(B, function(dt) {
            return dt = Sb(dt, D), Ce || (Ce = dt.length > 1), dt;
          }), i0(D, dD(D), ie), Ce && (ie = Pp(ie, w4 | C | E, H9));
          for (var $e = B.length; $e--; )
            bx(ie, B[$e]);
          return ie;
        });
        function R7(D, B) {
          return KO(D, XM(Yi(B)));
        }
        var XO = Lo(function(D, B) {
          return D == null ? {} : vx(D, B);
        });
        function KO(D, B) {
          if (D == null)
            return {};
          var ie = ic(dD(D), function(Ce) {
            return [Ce];
          });
          return B = Yi(B), gx(D, ie, function(Ce, $e) {
            return B(Ce, $e[0]);
          });
        }
        function F7(D, B, ie) {
          B = Sb(B, D);
          var Ce = -1, $e = B.length;
          for ($e || ($e = 1, D = e2); ++Ce < $e; ) {
            var dt = D == null ? e2 : D[ym(B[Ce])];
            dt === e2 && (Ce = $e, dt = ie), D = Av(dt) ? dt.call(D) : dt;
          }
          return D;
        }
        function Qq(D, B, ie) {
          return D == null ? D : _b2(D, B, ie);
        }
        function eY(D, B, ie, Ce) {
          return Ce = typeof Ce == "function" ? Ce : e2, D == null ? D : _b2(D, B, ie, Ce);
        }
        var N7 = rO(kf), JO = rO(Fp);
        function V7(D, B, ie) {
          var Ce = Oo(D), $e = Ce || Oc(D) || fg(D);
          if (B = Yi(B, 4), ie == null) {
            var dt = D && D.constructor;
            $e ? ie = Ce ? new dt() : [] : oc(D) ? ie = Av(dt) ? Qg(SM(D)) : {} : ie = {};
          }
          return ($e ? gf : n0)(D, function($t, Qt, In) {
            return B(ie, $t, Qt, In);
          }), ie;
        }
        function z7(D, B) {
          return D == null ? true : bx(D, B);
        }
        function B7(D, B, ie) {
          return D == null ? D : V2(D, B, VM(ie));
        }
        function tY(D, B, ie, Ce) {
          return Ce = typeof Ce == "function" ? Ce : e2, D == null ? D : V2(D, B, VM(ie), Ce);
        }
        function W2(D) {
          return D == null ? [] : yL(D, kf(D));
        }
        function QO(D) {
          return D == null ? [] : yL(D, Fp(D));
        }
        function nY(D, B, ie) {
          return ie === e2 && (ie = B, B = e2), ie !== e2 && (ie = Ev(ie), ie = ie === ie ? ie : 0), B !== e2 && (B = Ev(B), B = B === B ? B : 0), t0(Ev(D), B, ie);
        }
        function j7(D, B, ie) {
          return B = Am(B), ie === e2 ? (ie = B, B = 0) : ie = Am(ie), D = Ev(D), WL(D, B, ie);
        }
        function Em(D, B, ie) {
          if (ie && typeof ie != "boolean" && Jd(D, B, ie) && (B = ie = e2), ie === e2 && (typeof B == "boolean" ? (ie = B, B = e2) : typeof D == "boolean" && (ie = D, D = e2)), D === e2 && B === e2 ? (D = 0, B = 1) : (D = Am(D), B === e2 ? (B = D, D = 0) : B = Am(B)), D > B) {
            var Ce = D;
            D = B, B = Ce;
          }
          if (ie || D % 1 || B % 1) {
            var $e = BT();
            return Sh(D + $e * (B - D + Uy("1e-" + (($e + "").length - 1))), B);
          }
          return lg(D, B);
        }
        var rY = gs(function(D, B, ie) {
          return B = B.toLowerCase(), D + (ie ? eR(B) : B);
        });
        function eR(D) {
          return ud(jl(D).toLowerCase());
        }
        function ND(D) {
          return D = jl(D), D && D.replace(oa, xU).replace(_a2, "");
        }
        function G7(D, B, ie) {
          D = jl(D), B = qu(B);
          var Ce = D.length;
          ie = ie === e2 ? Ce : t0(Ko(ie), 0, Ce);
          var $e = ie;
          return ie -= B.length, ie >= 0 && D.slice(ie, $e) == B;
        }
        function tR(D) {
          return D = jl(D), D && vf.test(D) ? D.replace(xc, xL) : D;
        }
        function Vx(D) {
          return D = jl(D), D && uM.test(D) ? D.replace(Gy, "\\$&") : D;
        }
        var H2 = gs(function(D, B, ie) {
          return D + (ie ? "-" : "") + B.toLowerCase();
        }), aY = gs(function(D, B, ie) {
          return D + (ie ? " " : "") + B.toLowerCase();
        }), ld = G9("toLowerCase");
        function W7(D, B, ie) {
          D = jl(D), B = Ko(B);
          var Ce = B ? sx(D) : 0;
          if (!B || Ce >= B)
            return D;
          var $e = (B - Ce) / 2;
          return BM(MM($e), ie) + D + BM(Jg($e), ie);
        }
        function nA(D, B, ie) {
          D = jl(D), B = Ko(B);
          var Ce = B ? sx(D) : 0;
          return B && Ce < B ? D + BM(B - Ce, ie) : D;
        }
        function rA(D, B, ie) {
          D = jl(D), B = Ko(B);
          var Ce = B ? sx(D) : 0;
          return B && Ce < B ? BM(B - Ce, ie) + D : D;
        }
        function Im(D, B, ie) {
          return ie || B == null ? B = 0 : B && (B = +B), kU(jl(D).replace(Wy, ""), B || 0);
        }
        function c0(D, B, ie) {
          return (ie ? Jd(D, B, ie) : B === e2) ? B = 1 : B = Ko(B), a0(jl(D), B);
        }
        function iY() {
          var D = arguments, B = jl(D[0]);
          return D.length < 3 ? B : B.replace(D[1], D[2]);
        }
        var VD = gs(function(D, B, ie) {
          return D + (ie ? "_" : "") + B.toLowerCase();
        });
        function oY(D, B, ie) {
          return ie && typeof ie != "number" && Jd(D, B, ie) && (B = ie = e2), ie = ie === e2 ? sn : ie >>> 0, ie ? (D = jl(D), D && (typeof B == "string" || B != null && !jO(B)) && (B = qu(B), !B && wh(D)) ? Cb(Zg(D), 0, ie) : D.split(B, ie)) : [];
        }
        var sY = gs(function(D, B, ie) {
          return D + (ie ? " " : "") + ud(B);
        });
        function lY(D, B, ie) {
          return D = jl(D), ie = ie == null ? 0 : t0(Ko(ie), 0, D.length), B = qu(B), D.slice(ie, ie + B.length) == B;
        }
        function H7(D, B, ie) {
          var Ce = ot.templateSettings;
          ie && Jd(D, B, ie) && (B = e2), D = jl(D), B = OD({}, B, Ce, aO);
          var $e = OD({}, B.imports, Ce.imports, aO), dt = kf($e), $t = yL($e, dt), Qt, In, jr = 0, Nr = B.interpolate || ha, Yr = "__p += '", za = bM((B.escape || ha).source + "|" + Nr.source + "|" + (Nr === Ep ? lt2 : ha).source + "|" + (B.evaluate || ha).source + "|$", "g"), Ii = "//# sourceURL=" + (zl.call(B, "sourceURL") ? (B.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++hM + "]") + `
`;
          D.replace(za, function(eo, Ws, ys, Eh, cd, np) {
            return ys || (ys = Eh), Yr += D.slice(jr, np).replace(Zo, v9), Ws && (Qt = true, Yr += `' +
__e(` + Ws + `) +
'`), cd && (In = true, Yr += `';
` + cd + `;
__p += '`), ys && (Yr += `' +
((__t = (` + ys + `)) == null ? '' : __t) +
'`), jr = np + eo.length, eo;
          }), Yr += `';
`;
          var no = zl.call(B, "variable") && B.variable;
          if (!no)
            Yr = `with (obj) {
` + Yr + `
}
`;
          else if (Lt.test(no))
            throw new Io(p4);
          Yr = (In ? Yr.replace(td, "") : Yr).replace(jd, "$1").replace(Qv, "$1;"), Yr = "function(" + (no || "obj") + `) {
` + (no ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Qt ? ", __e = _.escape" : "") + (In ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Yr + `return __p
}`;
          var Ro = nR(function() {
            return Dl(dt, Ii + "return " + Yr).apply(e2, $t);
          });
          if (Ro.source = Yr, Ox(Ro))
            throw Ro;
          return Ro;
        }
        function Np(D) {
          return jl(D).toLowerCase();
        }
        function uY(D) {
          return jl(D).toUpperCase();
        }
        function $7(D, B, ie) {
          if (D = jl(D), D && (ie || B === e2))
            return d9(D);
          if (!D || !(B = qu(B)))
            return D;
          var Ce = Zg(D), $e = Zg(B), dt = bL(Ce, $e), $t = p9(Ce, $e) + 1;
          return Cb(Ce, dt, $t).join("");
        }
        function zD(D, B, ie) {
          if (D = jl(D), D && (ie || B === e2))
            return D.slice(0, m9(D) + 1);
          if (!D || !(B = qu(B)))
            return D;
          var Ce = Zg(D), $e = p9(Ce, Zg(B)) + 1;
          return Cb(Ce, 0, $e).join("");
        }
        function cY(D, B, ie) {
          if (D = jl(D), D && (ie || B === e2))
            return D.replace(Wy, "");
          if (!D || !(B = qu(B)))
            return D;
          var Ce = Zg(D), $e = bL(Ce, Zg(B));
          return Cb(Ce, $e).join("");
        }
        function U7(D, B) {
          var ie = we, Ce = Pe;
          if (oc(B)) {
            var $e = "separator" in B ? B.separator : $e;
            ie = "length" in B ? Ko(B.length) : ie, Ce = "omission" in B ? qu(B.omission) : Ce;
          }
          D = jl(D);
          var dt = D.length;
          if (wh(D)) {
            var $t = Zg(D);
            dt = $t.length;
          }
          if (ie >= dt)
            return D;
          var Qt = ie - sx(Ce);
          if (Qt < 1)
            return Ce;
          var In = $t ? Cb($t, 0, Qt).join("") : D.slice(0, Qt);
          if ($e === e2)
            return In + Ce;
          if ($t && (Qt += In.length - Qt), jO($e)) {
            if (D.slice(Qt).search($e)) {
              var jr, Nr = In;
              for ($e.global || ($e = bM($e.source, jl(Et.exec($e)) + "g")), $e.lastIndex = 0; jr = $e.exec(Nr); )
                var Yr = jr.index;
              In = In.slice(0, Yr === e2 ? Qt : Yr);
            }
          } else if (D.indexOf(qu($e), Qt) != Qt) {
            var za = In.lastIndexOf($e);
            za > -1 && (In = In.slice(0, za));
          }
          return In + Ce;
        }
        function fY(D) {
          return D = jl(D), D && js.test(D) ? D.replace(Gd, CU) : D;
        }
        var q7 = gs(function(D, B, ie) {
          return D + (ie ? " " : "") + B.toUpperCase();
        }), ud = G9("toUpperCase");
        function Y7(D, B, ie) {
          return D = jl(D), B = ie ? e2 : B, B === e2 ? wU(D) ? y9(D) : LT(D) : D.match(B) || [];
        }
        var nR = vs(function(D, B) {
          try {
            return Df(D, e2, B);
          } catch (ie) {
            return Ox(ie) ? ie : new Io(ie);
          }
        }), Vp = Lo(function(D, B) {
          return gf(B, function(ie) {
            ie = ym(ie), ag(D, ie, Db(D[ie], D));
          }), D;
        });
        function hY(D) {
          var B = D == null ? 0 : D.length, ie = Yi();
          return D = B ? ic(D, function(Ce) {
            if (typeof Ce[1] != "function")
              throw new qd(h);
            return [ie(Ce[0]), Ce[1]];
          }) : [], vs(function(Ce) {
            for (var $e = -1; ++$e < B; ) {
              var dt = D[$e];
              if (Df(dt[0], this, Ce))
                return Df(dt[1], this, Ce);
            }
          });
        }
        function dY(D) {
          return zL(Pp(D, w4));
        }
        function BD(D) {
          return function() {
            return D;
          };
        }
        function rh(D, B) {
          return D == null || D !== D ? B : D;
        }
        var zp = o0(), pY = o0(true);
        function tp(D) {
          return D;
        }
        function jD(D) {
          return kM(typeof D == "function" ? D : Pp(D, w4));
        }
        function GD(D) {
          return rD(Pp(D, w4));
        }
        function vY(D, B) {
          return px(D, Pp(B, w4));
        }
        var Z7 = vs(function(D, B) {
          return function(ie) {
            return mb(ie, D, B);
          };
        }), rR = vs(function(D, B) {
          return function(ie) {
            return mb(D, ie, B);
          };
        });
        function aR(D, B, ie) {
          var Ce = kf(B), $e = N2(B, Ce);
          ie == null && !(oc(B) && ($e.length || !Ce.length)) && (ie = B, B = D, D = this, $e = N2(B, kf(B)));
          var dt = !(oc(ie) && "chain" in ie) || !!ie.chain, $t = Av(D);
          return gf($e, function(Qt) {
            var In = B[Qt];
            D[Qt] = In, $t && (D.prototype[Qt] = function() {
              var jr = this.__chain__;
              if (dt || jr) {
                var Nr = D(this.__wrapped__), Yr = Nr.__actions__ = Mh(this.__actions__);
                return Yr.push({ func: In, args: arguments, thisArg: D }), Nr.__chain__ = jr, Nr;
              }
              return In.apply(D, dm([this.value()], arguments));
            });
          }), D;
        }
        function iR() {
          return mu._ === this && (mu._ = NT), this;
        }
        function oR() {
        }
        function X7(D) {
          return D = Ko(D), vs(function(B) {
            return UL(B, D);
          });
        }
        var gY = eO(ic), aA = eO(dL), mY = eO(pm);
        function sR(D) {
          return cO(D) ? vL(ym(D)) : qL(D);
        }
        function zx(D) {
          return function(B) {
            return D == null ? e2 : dx(D, B);
          };
        }
        var Bx = jM(), WD = jM(true);
        function $2() {
          return [];
        }
        function lR() {
          return false;
        }
        function HD() {
          return {};
        }
        function yY() {
          return "";
        }
        function bY() {
          return true;
        }
        function _Y(D, B) {
          if (D = Ko(D), D < 1 || D > xt)
            return [];
          var ie = sn, Ce = Sh(D, sn);
          B = Yi(B), D -= sn;
          for (var $e = RT(Ce, B); ++ie < D; )
            B(ie);
          return $e;
        }
        function K7(D) {
          return Oo(D) ? ic(D, ym) : ep(D) ? [D] : Mh(pO(jl(D)));
        }
        function U2(D) {
          var B = ++IU;
          return jl(D) + B;
        }
        var uR = cD(function(D, B) {
          return D + B;
        }, 0), fs = tO("ceil"), zu = cD(function(D, B) {
          return D / B;
        }, 1), q22 = tO("floor");
        function Ob(D) {
          return D && D.length ? Jy(D, tp, QT) : e2;
        }
        function J7(D, B) {
          return D && D.length ? Jy(D, Yi(B, 2), QT) : e2;
        }
        function iA(D) {
          return f9(D, tp);
        }
        function f0(D, B) {
          return f9(D, Yi(B, 2));
        }
        function xY(D) {
          return D && D.length ? Jy(D, tp, sg) : e2;
        }
        function $D(D, B) {
          return D && D.length ? Jy(D, Yi(B, 2), sg) : e2;
        }
        var UD = cD(function(D, B) {
          return D * B;
        }, 1), cR = tO("round"), wY = cD(function(D, B) {
          return D - B;
        }, 0);
        function SY(D) {
          return D && D.length ? OT(D, tp) : 0;
        }
        function CY(D, B) {
          return D && D.length ? OT(D, Yi(B, 2)) : 0;
        }
        return ot.after = l7, ot.ary = nh, ot.assign = $O, ot.assignIn = k7, ot.assignInWith = OD, ot.assignWith = Uq, ot.at = P7, ot.before = u7, ot.bind = Db, ot.bindAll = Vp, ot.bindKey = LO, ot.castArray = b7, ot.chain = MD, ot.chunk = yD, ot.compact = Mx, ot.concat = sq, ot.cond = hY, ot.conforms = dY, ot.constant = BD, ot.countBy = qM, ot.create = qq, ot.curry = OO, ot.curryRight = kb, ot.debounce = c7, ot.defaults = Fx, ot.defaultsDeep = Yq, ot.defer = zq, ot.delay = f7, ot.difference = lq, ot.differenceBy = uq, ot.differenceWith = vO, ot.drop = cq, ot.dropRight = gO, ot.dropRightWhile = J9, ot.dropWhile = bD, ot.fill = mO, ot.filter = o1, ot.flatMap = Iq, ot.flatMapDeep = Tq, ot.flatMapDepth = Qd, ot.flatten = bO, ot.flattenDeep = fq, ot.flattenDepth = hq, ot.flip = rs, ot.flow = zp, ot.flowRight = pY, ot.fromPairs = dq, ot.functions = QM, ot.functionsIn = Xq, ot.groupBy = Dq, ot.initial = vq, ot.intersection = xO, ot.intersectionBy = gq, ot.intersectionWith = mq, ot.invert = Kq, ot.invertBy = G2, ot.invokeMap = Pq, ot.iteratee = jD, ot.keyBy = o7, ot.keys = kf, ot.keysIn = Fp, ot.map = AD, ot.mapKeys = O7, ot.mapValues = ZO, ot.matches = GD, ot.matchesProperty = vY, ot.memoize = ZM, ot.merge = FD, ot.mergeWith = eA, ot.method = Z7, ot.methodOf = rR, ot.mixin = aR, ot.negate = XM, ot.nthArg = X7, ot.omit = tA, ot.omitBy = R7, ot.once = Bq, ot.orderBy = Lq, ot.over = gY, ot.overArgs = h7, ot.overEvery = aA, ot.overSome = mY, ot.partial = RO, ot.partialRight = d7, ot.partition = ED, ot.pick = XO, ot.pickBy = KO, ot.property = sR, ot.propertyOf = zx, ot.pull = _D, ot.pullAll = SO, ot.pullAllBy = bq, ot.pullAllWith = _q, ot.pullAt = CO, ot.range = Bx, ot.rangeRight = WD, ot.rearg = p7, ot.reject = Rq, ot.remove = MO, ot.rest = v7, ot.reverse = AO, ot.sampleSize = Fq, ot.set = Qq, ot.setWith = eY, ot.shuffle = s7, ot.slice = cg, ot.sortBy = Vq, ot.sortedUniq = wD, ot.sortedUniqBy = SD, ot.split = oY, ot.spread = g7, ot.tail = CD, ot.take = e7, ot.takeRight = t7, ot.takeRightWhile = n7, ot.takeWhile = xq, ot.tap = UM, ot.throttle = m7, ot.thru = B2, ot.toArray = GO, ot.toPairs = N7, ot.toPairsIn = JO, ot.toPath = K7, ot.toPlainObject = LD, ot.transform = V7, ot.unary = jq, ot.union = wq, ot.unionBy = Sq, ot.unionWith = Bl, ot.uniq = Ix, ot.uniqBy = Tx, ot.uniqWith = bm, ot.unset = z7, ot.unzip = _m, ot.unzipWith = u0, ot.update = B7, ot.updateWith = tY, ot.values = W2, ot.valuesIn = QO, ot.without = xm, ot.words = Y7, ot.wrap = y7, ot.xor = TO, ot.xorBy = DO, ot.xorWith = Dx, ot.zip = kx, ot.zipObject = i1, ot.zipObjectDeep = kO, ot.zipWith = Ab, ot.entries = N7, ot.entriesIn = JO, ot.extend = k7, ot.extendWith = OD, aR(ot, ot), ot.add = uR, ot.attempt = nR, ot.camelCase = rY, ot.capitalize = eR, ot.ceil = fs, ot.clamp = nY, ot.clone = _7, ot.cloneDeep = w7, ot.cloneDeepWith = FO, ot.cloneWith = x7, ot.conformsTo = ms, ot.deburr = ND, ot.defaultTo = rh, ot.divide = zu, ot.endsWith = G7, ot.eq = ii, ot.escape = tR, ot.escapeRegExp = Vx, ot.every = Eq, ot.find = Tb, ot.findIndex = Q9, ot.findKey = Cc, ot.findLast = Px, ot.findLastIndex = yO, ot.findLastKey = UO, ot.floor = q22, ot.forEach = Mv, ot.forEachRight = i7, ot.forIn = L7, ot.forInRight = Zq, ot.forOwn = Ah, ot.forOwnRight = Nx, ot.get = qO, ot.gt = NO, ot.gte = S7, ot.has = YO, ot.hasIn = RD, ot.head = _O, ot.identity = tp, ot.includes = kq, ot.indexOf = pq, ot.inRange = j7, ot.invoke = Jq, ot.isArguments = Pb, ot.isArray = Oo, ot.isArrayBuffer = VO, ot.isArrayLike = sd, ot.isArrayLikeObject = Yu, ot.isBoolean = TD, ot.isBuffer = Oc, ot.isDate = KM, ot.isElement = j2, ot.isEmpty = Gq, ot.isEqual = Lx, ot.isEqualWith = DD, ot.isError = Ox, ot.isFinite = kD, ot.isFunction = Av, ot.isInteger = Rx, ot.isLength = JM, ot.isMap = zO, ot.isMatch = C7, ot.isMatchWith = BO, ot.isNaN = M7, ot.isNative = Wq, ot.isNil = A7, ot.isNull = Hq, ot.isNumber = Sm, ot.isObject = oc, ot.isObjectLike = Zu, ot.isPlainObject = Lb, ot.isRegExp = jO, ot.isSafeInteger = $q, ot.isSet = E7, ot.isString = PD, ot.isSymbol = ep, ot.isTypedArray = fg, ot.isUndefined = I7, ot.isWeakMap = T7, ot.isWeakSet = Cm, ot.join = yq, ot.kebabCase = H2, ot.last = Cv, ot.lastIndexOf = wO, ot.lowerCase = aY, ot.lowerFirst = ld, ot.lt = Mm, ot.lte = D7, ot.max = Ob, ot.maxBy = J7, ot.mean = iA, ot.meanBy = f0, ot.min = xY, ot.minBy = $D, ot.stubArray = $2, ot.stubFalse = lR, ot.stubObject = HD, ot.stubString = yY, ot.stubTrue = bY, ot.multiply = UD, ot.nth = Ax, ot.noConflict = iR, ot.noop = oR, ot.now = ID, ot.pad = W7, ot.padEnd = nA, ot.padStart = rA, ot.parseInt = Im, ot.random = Em, ot.reduce = Oq, ot.reduceRight = PO, ot.repeat = c0, ot.replace = iY, ot.result = F7, ot.round = cR, ot.runInContext = dn, ot.sample = uo, ot.size = YM, ot.snakeCase = VD, ot.some = Nq, ot.sortedIndex = Op, ot.sortedIndexBy = Rp, ot.sortedIndexOf = EO, ot.sortedLastIndex = IO, ot.sortedLastIndexBy = Ex, ot.sortedLastIndexOf = xD, ot.startCase = sY, ot.startsWith = lY, ot.subtract = wY, ot.sum = SY, ot.sumBy = CY, ot.template = H7, ot.times = _Y, ot.toFinite = Am, ot.toInteger = Ko, ot.toLength = WO, ot.toLower = Np, ot.toNumber = Ev, ot.toSafeInteger = HO, ot.toString = jl, ot.toUpper = uY, ot.trim = $7, ot.trimEnd = zD, ot.trimStart = cY, ot.truncate = U7, ot.unescape = fY, ot.uniqueId = U2, ot.upperCase = q7, ot.upperFirst = ud, ot.each = Mv, ot.eachRight = i7, ot.first = _O, aR(ot, function() {
          var D = {};
          return n0(ot, function(B, ie) {
            zl.call(ot.prototype, ie) || (D[ie] = B);
          }), D;
        }(), { chain: false }), ot.VERSION = o, gf(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(D) {
          ot[D].placeholder = ot;
        }), gf(["drop", "take"], function(D, B) {
          el.prototype[D] = function(ie) {
            ie = ie === e2 ? 1 : wc(Ko(ie), 0);
            var Ce = this.__filtered__ && !B ? new el(this) : this.clone();
            return Ce.__filtered__ ? Ce.__takeCount__ = Sh(ie, Ce.__takeCount__) : Ce.__views__.push({ size: Sh(ie, sn), type: D + (Ce.__dir__ < 0 ? "Right" : "") }), Ce;
          }, el.prototype[D + "Right"] = function(ie) {
            return this.reverse()[D](ie).reverse();
          };
        }), gf(["filter", "map", "takeWhile"], function(D, B) {
          var ie = B + 1, Ce = ie == rt2 || ie == et;
          el.prototype[D] = function($e) {
            var dt = this.clone();
            return dt.__iteratees__.push({ iteratee: Yi($e, 3), type: ie }), dt.__filtered__ = dt.__filtered__ || Ce, dt;
          };
        }), gf(["head", "last"], function(D, B) {
          var ie = "take" + (B ? "Right" : "");
          el.prototype[D] = function() {
            return this[ie](1).value()[0];
          };
        }), gf(["initial", "tail"], function(D, B) {
          var ie = "drop" + (B ? "" : "Right");
          el.prototype[D] = function() {
            return this.__filtered__ ? new el(this) : this[ie](1);
          };
        }), el.prototype.compact = function() {
          return this.filter(tp);
        }, el.prototype.find = function(D) {
          return this.filter(D).head();
        }, el.prototype.findLast = function(D) {
          return this.reverse().find(D);
        }, el.prototype.invokeMap = vs(function(D, B) {
          return typeof D == "function" ? new el(this) : this.map(function(ie) {
            return mb(ie, D, B);
          });
        }), el.prototype.reject = function(D) {
          return this.filter(XM(Yi(D)));
        }, el.prototype.slice = function(D, B) {
          D = Ko(D);
          var ie = this;
          return ie.__filtered__ && (D > 0 || B < 0) ? new el(ie) : (D < 0 ? ie = ie.takeRight(-D) : D && (ie = ie.drop(D)), B !== e2 && (B = Ko(B), ie = B < 0 ? ie.dropRight(-B) : ie.take(B - D)), ie);
        }, el.prototype.takeRightWhile = function(D) {
          return this.reverse().takeWhile(D).reverse();
        }, el.prototype.toArray = function() {
          return this.take(sn);
        }, n0(el.prototype, function(D, B) {
          var ie = /^(?:filter|find|map|reject)|While$/.test(B), Ce = /^(?:head|last)$/.test(B), $e = ot[Ce ? "take" + (B == "last" ? "Right" : "") : B], dt = Ce || /^find/.test(B);
          !$e || (ot.prototype[B] = function() {
            var $t = this.__wrapped__, Qt = Ce ? [1] : arguments, In = $t instanceof el, jr = Qt[0], Nr = In || Oo($t), Yr = function(Ws) {
              var ys = $e.apply(ot, dm([Ws], Qt));
              return Ce && za ? ys[0] : ys;
            };
            Nr && ie && typeof jr == "function" && jr.length != 1 && (In = Nr = false);
            var za = this.__chain__, Ii = !!this.__actions__.length, no = dt && !za, Ro = In && !Ii;
            if (!dt && Nr) {
              $t = Ro ? $t : new el(this);
              var eo = D.apply($t, Qt);
              return eo.__actions__.push({ func: B2, args: [Yr], thisArg: e2 }), new Dp(eo, za);
            }
            return no && Ro ? D.apply(this, Qt) : (eo = this.thru(Yr), no ? Ce ? eo.value()[0] : eo.value() : eo);
          });
        }), gf(["pop", "push", "shift", "sort", "splice", "unshift"], function(D) {
          var B = ad[D], ie = /^(?:push|sort|unshift)$/.test(D) ? "tap" : "thru", Ce = /^(?:pop|shift)$/.test(D);
          ot.prototype[D] = function() {
            var $e = arguments;
            if (Ce && !this.__chain__) {
              var dt = this.value();
              return B.apply(Oo(dt) ? dt : [], $e);
            }
            return this[ie](function($t) {
              return B.apply(Oo($t) ? $t : [], $e);
            });
          };
        }), n0(el.prototype, function(D, B) {
          var ie = ot[B];
          if (ie) {
            var Ce = ie.name + "";
            zl.call(O2, Ce) || (O2[Ce] = []), O2[Ce].push({ name: B, func: ie });
          }
        }), O2[uD(e2, V).name] = [{ name: "wrapper", func: e2 }], el.prototype.clone = OL, el.prototype.reverse = RL, el.prototype.value = LU, ot.prototype.at = Cq, ot.prototype.chain = Mq, ot.prototype.commit = wm, ot.prototype.next = Eb, ot.prototype.plant = r7, ot.prototype.reverse = a7, ot.prototype.toJSON = ot.prototype.valueOf = ot.prototype.value = Ib, ot.prototype.first = ot.prototype.head, rg && (ot.prototype[rg] = Aq), ot;
      }, lx = AU();
      cm ? ((cm.exports = lx)._ = lx, kT._ = lx) : mu._ = lx;
    }).call(Dy);
  })(f$, f$.exports);
  class bLe {
    constructor() {
      Vg(this, "subscriptions", /* @__PURE__ */ new Map());
      Vg(this, "emitEffectCache", /* @__PURE__ */ new Map());
      Vg(this, "useSubscription", (n2, e2) => {
        const o = il.useRef();
        il.useEffect(() => {
          var h, p4;
          o.current = e2;
          function l4(g4) {
            o.current && o.current(g4);
          }
          const c4 = (p4 = (h = this.subscriptions) == null ? void 0 : h.get(n2)) != null ? p4 : [];
          return c4.push(l4), this.subscriptions.set(n2, c4), this.emitEffect(n2), () => {
            this.subscriptions.delete(n2);
          };
        });
      });
      Vg(this, "emit", (n2, ...e2) => {
        if (typeof n2 == "string" || typeof n2 == "number") {
          const o = this.subscriptions.get(n2);
          o == null || o.forEach((l4) => {
            l4 == null || l4({ params: f$.exports.cloneDeep(e2), event: n2 });
          }), this.emitEffectCache.set(n2, { params: f$.exports.cloneDeep(e2), event: n2 });
        } else
          throw new TypeError("event must be string or number !");
      });
      Vg(this, "emitEffect", (n2) => {
        const e2 = this.emitEffectCache.get(n2), o = this.subscriptions.get(n2);
        e2 && (o == null || o.forEach((l4) => {
          l4 == null || l4(Mxe({}, e2));
        }));
      });
      Vg(this, "removeListener", (n2) => {
        this.subscriptions.delete(n2);
      });
      Vg(this, "clear", () => {
        this.subscriptions.clear();
      });
      this.clear();
    }
  }
  const XEt = new bLe();
  function tU(i) {
    const n2 = il.useRef(), e2 = il.useMemo(() => i != null ? i : { global: false }, [i]);
    return n2.current || (n2.current = e2.global ? n2.current = XEt : n2.current = new bLe()), il.useEffect(() => () => {
      var o;
      return (o = n2.current) == null ? void 0 : o.clear();
    }, []), n2.current;
  }
  const kue = ({ id: i, title: n2, chart: e2, option: o }, l4) => {
    const c4 = il.useRef(ZEt), h = tU({ global: true });
    return xit(() => {
      console.log("id", i), console.log("chart", e2 == null ? void 0 : e2.current), c4.current && (e2 == null ? void 0 : e2.current) && i && o && (c4.current.add(i, e2 == null ? void 0 : e2.current, o, n2), h.emit("list"));
    }, l4 != null ? l4 : [], { wait: 100 }), { tool: c4.current };
  };
  var KEt = il.createContext({}), _Le = KEt;
  function pu(i, n2, e2) {
    return n2 in i ? Object.defineProperty(i, n2, { value: e2, enumerable: true, configurable: true, writable: true }) : i[n2] = e2, i;
  }
  function LEe(i, n2) {
    var e2 = Object.keys(i);
    if (Object.getOwnPropertySymbols) {
      var o = Object.getOwnPropertySymbols(i);
      n2 && (o = o.filter(function(l4) {
        return Object.getOwnPropertyDescriptor(i, l4).enumerable;
      })), e2.push.apply(e2, o);
    }
    return e2;
  }
  function Yo(i) {
    for (var n2 = 1; n2 < arguments.length; n2++) {
      var e2 = arguments[n2] != null ? arguments[n2] : {};
      n2 % 2 ? LEe(Object(e2), true).forEach(function(o) {
        pu(i, o, e2[o]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(i, Object.getOwnPropertyDescriptors(e2)) : LEe(Object(e2)).forEach(function(o) {
        Object.defineProperty(i, o, Object.getOwnPropertyDescriptor(e2, o));
      });
    }
    return i;
  }
  function xLe(i) {
    if (Array.isArray(i))
      return i;
  }
  function JEt(i, n2) {
    var e2 = i == null ? null : typeof Symbol != "undefined" && i[Symbol.iterator] || i["@@iterator"];
    if (e2 != null) {
      var o = [], l4 = true, c4 = false, h, p4;
      try {
        for (e2 = e2.call(i); !(l4 = (h = e2.next()).done) && (o.push(h.value), !(n2 && o.length === n2)); l4 = true)
          ;
      } catch (g4) {
        c4 = true, p4 = g4;
      } finally {
        try {
          !l4 && e2.return != null && e2.return();
        } finally {
          if (c4)
            throw p4;
        }
      }
      return o;
    }
  }
  function sse(i, n2) {
    (n2 == null || n2 > i.length) && (n2 = i.length);
    for (var e2 = 0, o = new Array(n2); e2 < n2; e2++)
      o[e2] = i[e2];
    return o;
  }
  function Pue(i, n2) {
    if (!!i) {
      if (typeof i == "string")
        return sse(i, n2);
      var e2 = Object.prototype.toString.call(i).slice(8, -1);
      if (e2 === "Object" && i.constructor && (e2 = i.constructor.name), e2 === "Map" || e2 === "Set")
        return Array.from(i);
      if (e2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(e2))
        return sse(i, n2);
    }
  }
  function wLe() {
    throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function Ry(i, n2) {
    return xLe(i) || JEt(i, n2) || Pue(i, n2) || wLe();
  }
  function QEt(i, n2) {
    if (i == null)
      return {};
    var e2 = {}, o = Object.keys(i), l4, c4;
    for (c4 = 0; c4 < o.length; c4++)
      l4 = o[c4], !(n2.indexOf(l4) >= 0) && (e2[l4] = i[l4]);
    return e2;
  }
  function aL(i, n2) {
    if (i == null)
      return {};
    var e2 = QEt(i, n2), o, l4;
    if (Object.getOwnPropertySymbols) {
      var c4 = Object.getOwnPropertySymbols(i);
      for (l4 = 0; l4 < c4.length; l4++)
        o = c4[l4], !(n2.indexOf(o) >= 0) && (!Object.prototype.propertyIsEnumerable.call(i, o) || (e2[o] = i[o]));
    }
    return e2;
  }
  var SLe = { exports: {} };
  /*!
    Copyright (c) 2018 Jed Watson.
    Licensed under the MIT License (MIT), see
    http://jedwatson.github.io/classnames
  */
  (function(i) {
    (function() {
      var n2 = {}.hasOwnProperty;
      function e2() {
        for (var o = [], l4 = 0; l4 < arguments.length; l4++) {
          var c4 = arguments[l4];
          if (!!c4) {
            var h = typeof c4;
            if (h === "string" || h === "number")
              o.push(c4);
            else if (Array.isArray(c4)) {
              if (c4.length) {
                var p4 = e2.apply(null, c4);
                p4 && o.push(p4);
              }
            } else if (h === "object")
              if (c4.toString === Object.prototype.toString)
                for (var g4 in c4)
                  n2.call(c4, g4) && c4[g4] && o.push(g4);
              else
                o.push(c4.toString());
          }
        }
        return o.join(" ");
      }
      i.exports ? (e2.default = e2, i.exports = e2) : window.classNames = e2;
    })();
  })(SLe);
  var iL = SLe.exports;
  function pv(i) {
    return pv = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(n2) {
      return typeof n2;
    } : function(n2) {
      return n2 && typeof Symbol == "function" && n2.constructor === Symbol && n2 !== Symbol.prototype ? "symbol" : typeof n2;
    }, pv(i);
  }
  function Fy(i, n2) {
    eIt(i) && (i = "100%");
    var e2 = tIt(i);
    return i = n2 === 360 ? i : Math.min(n2, Math.max(0, parseFloat(i))), e2 && (i = parseInt(String(i * n2), 10) / 100), Math.abs(i - n2) < 1e-6 ? 1 : (n2 === 360 ? i = (i < 0 ? i % n2 + n2 : i % n2) / parseFloat(String(n2)) : i = i % n2 / parseFloat(String(n2)), i);
  }
  function eIt(i) {
    return typeof i == "string" && i.indexOf(".") !== -1 && parseFloat(i) === 1;
  }
  function tIt(i) {
    return typeof i == "string" && i.indexOf("%") !== -1;
  }
  function nIt(i) {
    return i = parseFloat(i), (isNaN(i) || i < 0 || i > 1) && (i = 1), i;
  }
  function GW(i) {
    return i <= 1 ? Number(i) * 100 + "%" : i;
  }
  function cie(i) {
    return i.length === 1 ? "0" + i : String(i);
  }
  function rIt(i, n2, e2) {
    return { r: Fy(i, 255) * 255, g: Fy(n2, 255) * 255, b: Fy(e2, 255) * 255 };
  }
  function fie(i, n2, e2) {
    return e2 < 0 && (e2 += 1), e2 > 1 && (e2 -= 1), e2 < 1 / 6 ? i + (n2 - i) * (6 * e2) : e2 < 1 / 2 ? n2 : e2 < 2 / 3 ? i + (n2 - i) * (2 / 3 - e2) * 6 : i;
  }
  function aIt(i, n2, e2) {
    var o, l4, c4;
    if (i = Fy(i, 360), n2 = Fy(n2, 100), e2 = Fy(e2, 100), n2 === 0)
      l4 = e2, c4 = e2, o = e2;
    else {
      var h = e2 < 0.5 ? e2 * (1 + n2) : e2 + n2 - e2 * n2, p4 = 2 * e2 - h;
      o = fie(p4, h, i + 1 / 3), l4 = fie(p4, h, i), c4 = fie(p4, h, i - 1 / 3);
    }
    return { r: o * 255, g: l4 * 255, b: c4 * 255 };
  }
  function iIt(i, n2, e2) {
    i = Fy(i, 255), n2 = Fy(n2, 255), e2 = Fy(e2, 255);
    var o = Math.max(i, n2, e2), l4 = Math.min(i, n2, e2), c4 = 0, h = o, p4 = o - l4, g4 = o === 0 ? 0 : p4 / o;
    if (o === l4)
      c4 = 0;
    else {
      switch (o) {
        case i:
          c4 = (n2 - e2) / p4 + (n2 < e2 ? 6 : 0);
          break;
        case n2:
          c4 = (e2 - i) / p4 + 2;
          break;
        case e2:
          c4 = (i - n2) / p4 + 4;
          break;
      }
      c4 /= 6;
    }
    return { h: c4, s: g4, v: h };
  }
  function oIt(i, n2, e2) {
    i = Fy(i, 360) * 6, n2 = Fy(n2, 100), e2 = Fy(e2, 100);
    var o = Math.floor(i), l4 = i - o, c4 = e2 * (1 - n2), h = e2 * (1 - l4 * n2), p4 = e2 * (1 - (1 - l4) * n2), g4 = o % 6, y4 = [e2, h, c4, c4, p4, e2][g4], _ = [p4, e2, e2, h, c4, c4][g4], w4 = [c4, c4, p4, e2, e2, h][g4];
    return { r: y4 * 255, g: _ * 255, b: w4 * 255 };
  }
  function sIt(i, n2, e2, o) {
    var l4 = [cie(Math.round(i).toString(16)), cie(Math.round(n2).toString(16)), cie(Math.round(e2).toString(16))];
    return o && l4[0].startsWith(l4[0].charAt(1)) && l4[1].startsWith(l4[1].charAt(1)) && l4[2].startsWith(l4[2].charAt(1)) ? l4[0].charAt(0) + l4[1].charAt(0) + l4[2].charAt(0) : l4.join("");
  }
  function OEe(i) {
    return J0(i) / 255;
  }
  function J0(i) {
    return parseInt(i, 16);
  }
  var REe = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
  function SN(i) {
    var n2 = { r: 0, g: 0, b: 0 }, e2 = 1, o = null, l4 = null, c4 = null, h = false, p4 = false;
    return typeof i == "string" && (i = cIt(i)), typeof i == "object" && (o2(i.r) && o2(i.g) && o2(i.b) ? (n2 = rIt(i.r, i.g, i.b), h = true, p4 = String(i.r).substr(-1) === "%" ? "prgb" : "rgb") : o2(i.h) && o2(i.s) && o2(i.v) ? (o = GW(i.s), l4 = GW(i.v), n2 = oIt(i.h, o, l4), h = true, p4 = "hsv") : o2(i.h) && o2(i.s) && o2(i.l) && (o = GW(i.s), c4 = GW(i.l), n2 = aIt(i.h, o, c4), h = true, p4 = "hsl"), Object.prototype.hasOwnProperty.call(i, "a") && (e2 = i.a)), e2 = nIt(e2), { ok: h, format: i.format || p4, r: Math.min(255, Math.max(n2.r, 0)), g: Math.min(255, Math.max(n2.g, 0)), b: Math.min(255, Math.max(n2.b, 0)), a: e2 };
  }
  var lIt = "[-\\+]?\\d+%?", uIt = "[-\\+]?\\d*\\.\\d+%?", $C = "(?:" + uIt + ")|(?:" + lIt + ")", hie = "[\\s|\\(]+(" + $C + ")[,|\\s]+(" + $C + ")[,|\\s]+(" + $C + ")\\s*\\)?", die = "[\\s|\\(]+(" + $C + ")[,|\\s]+(" + $C + ")[,|\\s]+(" + $C + ")[,|\\s]+(" + $C + ")\\s*\\)?", K1 = { CSS_UNIT: new RegExp($C), rgb: new RegExp("rgb" + hie), rgba: new RegExp("rgba" + die), hsl: new RegExp("hsl" + hie), hsla: new RegExp("hsla" + die), hsv: new RegExp("hsv" + hie), hsva: new RegExp("hsva" + die), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
  function cIt(i) {
    if (i = i.trim().toLowerCase(), i.length === 0)
      return false;
    var n2 = false;
    if (REe[i])
      i = REe[i], n2 = true;
    else if (i === "transparent")
      return { r: 0, g: 0, b: 0, a: 0, format: "name" };
    var e2 = K1.rgb.exec(i);
    return e2 ? { r: e2[1], g: e2[2], b: e2[3] } : (e2 = K1.rgba.exec(i), e2 ? { r: e2[1], g: e2[2], b: e2[3], a: e2[4] } : (e2 = K1.hsl.exec(i), e2 ? { h: e2[1], s: e2[2], l: e2[3] } : (e2 = K1.hsla.exec(i), e2 ? { h: e2[1], s: e2[2], l: e2[3], a: e2[4] } : (e2 = K1.hsv.exec(i), e2 ? { h: e2[1], s: e2[2], v: e2[3] } : (e2 = K1.hsva.exec(i), e2 ? { h: e2[1], s: e2[2], v: e2[3], a: e2[4] } : (e2 = K1.hex8.exec(i), e2 ? { r: J0(e2[1]), g: J0(e2[2]), b: J0(e2[3]), a: OEe(e2[4]), format: n2 ? "name" : "hex8" } : (e2 = K1.hex6.exec(i), e2 ? { r: J0(e2[1]), g: J0(e2[2]), b: J0(e2[3]), format: n2 ? "name" : "hex" } : (e2 = K1.hex4.exec(i), e2 ? { r: J0(e2[1] + e2[1]), g: J0(e2[2] + e2[2]), b: J0(e2[3] + e2[3]), a: OEe(e2[4] + e2[4]), format: n2 ? "name" : "hex8" } : (e2 = K1.hex3.exec(i), e2 ? { r: J0(e2[1] + e2[1]), g: J0(e2[2] + e2[2]), b: J0(e2[3] + e2[3]), format: n2 ? "name" : "hex" } : false)))))))));
  }
  function o2(i) {
    return Boolean(K1.CSS_UNIT.exec(String(i)));
  }
  var WW = 2, FEe = 0.16, fIt = 0.05, hIt = 0.05, dIt = 0.15, CLe = 5, MLe = 4, pIt = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
  function NEe(i) {
    var n2 = i.r, e2 = i.g, o = i.b, l4 = iIt(n2, e2, o);
    return { h: l4.h * 360, s: l4.s, v: l4.v };
  }
  function HW(i) {
    var n2 = i.r, e2 = i.g, o = i.b;
    return "#".concat(sIt(n2, e2, o, false));
  }
  function vIt(i, n2, e2) {
    var o = e2 / 100, l4 = { r: (n2.r - i.r) * o + i.r, g: (n2.g - i.g) * o + i.g, b: (n2.b - i.b) * o + i.b };
    return l4;
  }
  function VEe(i, n2, e2) {
    var o;
    return Math.round(i.h) >= 60 && Math.round(i.h) <= 240 ? o = e2 ? Math.round(i.h) - WW * n2 : Math.round(i.h) + WW * n2 : o = e2 ? Math.round(i.h) + WW * n2 : Math.round(i.h) - WW * n2, o < 0 ? o += 360 : o >= 360 && (o -= 360), o;
  }
  function zEe(i, n2, e2) {
    if (i.h === 0 && i.s === 0)
      return i.s;
    var o;
    return e2 ? o = i.s - FEe * n2 : n2 === MLe ? o = i.s + FEe : o = i.s + fIt * n2, o > 1 && (o = 1), e2 && n2 === CLe && o > 0.1 && (o = 0.1), o < 0.06 && (o = 0.06), Number(o.toFixed(2));
  }
  function BEe(i, n2, e2) {
    var o;
    return e2 ? o = i.v + hIt * n2 : o = i.v - dIt * n2, o > 1 && (o = 1), Number(o.toFixed(2));
  }
  function lse(i) {
    for (var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = [], o = SN(i), l4 = CLe; l4 > 0; l4 -= 1) {
      var c4 = NEe(o), h = HW(SN({ h: VEe(c4, l4, true), s: zEe(c4, l4, true), v: BEe(c4, l4, true) }));
      e2.push(h);
    }
    e2.push(HW(o));
    for (var p4 = 1; p4 <= MLe; p4 += 1) {
      var g4 = NEe(o), y4 = HW(SN({ h: VEe(g4, p4), s: zEe(g4, p4), v: BEe(g4, p4) }));
      e2.push(y4);
    }
    return n2.theme === "dark" ? pIt.map(function(_) {
      var w4 = _.index, C = _.opacity, E = HW(vIt(SN(n2.backgroundColor || "#141414"), SN(e2[w4]), C * 100));
      return E;
    }) : e2;
  }
  var pie = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, vv = {}, vie = {};
  Object.keys(pie).forEach(function(i) {
    vv[i] = lse(pie[i]), vv[i].primary = vv[i][5], vie[i] = lse(pie[i], { theme: "dark", backgroundColor: "#141414" }), vie[i].primary = vie[i][5];
  });
  vv.red;
  vv.volcano;
  vv.gold;
  vv.orange;
  vv.yellow;
  vv.lime;
  vv.green;
  vv.cyan;
  vv.blue;
  vv.geekblue;
  vv.purple;
  vv.magenta;
  vv.grey;
  var jEe = {};
  function gIt(i, n2) {
  }
  function mIt(i, n2, e2) {
    !n2 && !jEe[e2] && (i(false, e2), jEe[e2] = true);
  }
  function U_(i, n2) {
    mIt(gIt, i, n2);
  }
  function ALe() {
    return !!(typeof window != "undefined" && window.document && window.document.createElement);
  }
  var yIt = "rc-util-key";
  function ELe() {
    var i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, n2 = i.mark;
    return n2 ? n2.startsWith("data-") ? n2 : "data-".concat(n2) : yIt;
  }
  function Lue(i) {
    if (i.attachTo)
      return i.attachTo;
    var n2 = document.querySelector("head");
    return n2 || document.body;
  }
  function GEe(i) {
    var n2, e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (!ALe())
      return null;
    var o = document.createElement("style");
    if (!((n2 = e2.csp) === null || n2 === void 0) && n2.nonce) {
      var l4;
      o.nonce = (l4 = e2.csp) === null || l4 === void 0 ? void 0 : l4.nonce;
    }
    o.innerHTML = i;
    var c4 = Lue(e2), h = c4.firstChild;
    return e2.prepend && c4.prepend ? c4.prepend(o) : e2.prepend && h ? c4.insertBefore(o, h) : c4.appendChild(o), o;
  }
  var use2 = /* @__PURE__ */ new Map();
  function bIt(i) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = Lue(n2);
    return Array.from(use2.get(e2).children).find(function(o) {
      return o.tagName === "STYLE" && o.getAttribute(ELe(n2)) === i;
    });
  }
  function ILe(i, n2) {
    var e2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, o = Lue(e2);
    if (!use2.has(o)) {
      var l4 = GEe("", e2), c4 = l4.parentNode;
      use2.set(o, c4), c4.removeChild(l4);
    }
    var h = bIt(n2, e2);
    if (h) {
      var p4, g4;
      if (((p4 = e2.csp) === null || p4 === void 0 ? void 0 : p4.nonce) && h.nonce !== ((g4 = e2.csp) === null || g4 === void 0 ? void 0 : g4.nonce)) {
        var y4;
        h.nonce = (y4 = e2.csp) === null || y4 === void 0 ? void 0 : y4.nonce;
      }
      return h.innerHTML !== i && (h.innerHTML = i), h;
    }
    var _ = GEe(i, e2);
    return _.setAttribute(ELe(e2), n2), _;
  }
  function _It(i, n2) {
    U_(i, "[@ant-design/icons] ".concat(n2));
  }
  function WEe(i) {
    return pv(i) === "object" && typeof i.name == "string" && typeof i.theme == "string" && (pv(i.icon) === "object" || typeof i.icon == "function");
  }
  function HEe() {
    var i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return Object.keys(i).reduce(function(n2, e2) {
      var o = i[e2];
      switch (e2) {
        case "class":
          n2.className = o, delete n2.class;
          break;
        default:
          n2[e2] = o;
      }
      return n2;
    }, {});
  }
  function cse(i, n2, e2) {
    return e2 ? P3.default.createElement(i.tag, Yo(Yo({ key: n2 }, HEe(i.attrs)), e2), (i.children || []).map(function(o, l4) {
      return cse(o, "".concat(n2, "-").concat(i.tag, "-").concat(l4));
    })) : P3.default.createElement(i.tag, Yo({ key: n2 }, HEe(i.attrs)), (i.children || []).map(function(o, l4) {
      return cse(o, "".concat(n2, "-").concat(i.tag, "-").concat(l4));
    }));
  }
  function TLe(i) {
    return lse(i)[0];
  }
  function DLe(i) {
    return i ? Array.isArray(i) ? i : [i] : [];
  }
  var xIt = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, wIt = function() {
    var n2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : xIt, e2 = il.useContext(_Le), o = e2.csp;
    il.useEffect(function() {
      ILe(n2, "@ant-design-icons", { prepend: true, csp: o });
    }, []);
  }, SIt = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], t8 = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
  function CIt(i) {
    var n2 = i.primaryColor, e2 = i.secondaryColor;
    t8.primaryColor = n2, t8.secondaryColor = e2 || TLe(n2), t8.calculated = !!e2;
  }
  function MIt() {
    return Yo({}, t8);
  }
  var nU = function(n2) {
    var e2 = n2.icon, o = n2.className, l4 = n2.onClick, c4 = n2.style, h = n2.primaryColor, p4 = n2.secondaryColor, g4 = aL(n2, SIt), y4 = t8;
    if (h && (y4 = { primaryColor: h, secondaryColor: p4 || TLe(h) }), wIt(), _It(WEe(e2), "icon should be icon definiton, but got ".concat(e2)), !WEe(e2))
      return null;
    var _ = e2;
    return _ && typeof _.icon == "function" && (_ = Yo(Yo({}, _), {}, { icon: _.icon(y4.primaryColor, y4.secondaryColor) })), cse(_.icon, "svg-".concat(_.name), Yo({ className: o, onClick: l4, style: c4, "data-icon": _.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, g4));
  };
  nU.displayName = "IconReact";
  nU.getTwoToneColors = MIt;
  nU.setTwoToneColors = CIt;
  var Oue = nU;
  function kLe(i) {
    var n2 = DLe(i), e2 = Ry(n2, 2), o = e2[0], l4 = e2[1];
    return Oue.setTwoToneColors({ primaryColor: o, secondaryColor: l4 });
  }
  function AIt() {
    var i = Oue.getTwoToneColors();
    return i.calculated ? [i.primaryColor, i.secondaryColor] : i.primaryColor;
  }
  var EIt = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
  kLe("#1890ff");
  var rU = Qr.forwardRef(function(i, n2) {
    var e2, o = i.className, l4 = i.icon, c4 = i.spin, h = i.rotate, p4 = i.tabIndex, g4 = i.onClick, y4 = i.twoToneColor, _ = aL(i, EIt), w4 = Qr.useContext(_Le), C = w4.prefixCls, E = C === void 0 ? "anticon" : C, T = iL(E, (e2 = {}, pu(e2, "".concat(E, "-").concat(l4.name), !!l4.name), pu(e2, "".concat(E, "-spin"), !!c4 || l4.name === "loading"), e2), o), O = p4;
    O === void 0 && g4 && (O = -1);
    var N = h ? { msTransform: "rotate(".concat(h, "deg)"), transform: "rotate(".concat(h, "deg)") } : void 0, V = DLe(y4), H = Ry(V, 2), X = H[0], q2 = H[1];
    return Qr.createElement("span", Yo(Yo({ role: "img", "aria-label": l4.name }, _), {}, { ref: n2, tabIndex: O, onClick: g4, className: T }), Qr.createElement(Oue, { icon: l4, primaryColor: X, secondaryColor: q2, style: N }));
  });
  rU.displayName = "AntdIcon";
  rU.getTwoToneColor = AIt;
  rU.setTwoToneColor = kLe;
  var IIt = rU, TIt = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, DIt = TIt, PLe = function(n2, e2) {
    return Qr.createElement(IIt, Yo(Yo({}, n2), {}, { ref: e2, icon: DIt }));
  };
  PLe.displayName = "LoadingOutlined";
  var kIt = Qr.forwardRef(PLe);
  function mh() {
    return mh = Object.assign || function(i) {
      for (var n2 = 1; n2 < arguments.length; n2++) {
        var e2 = arguments[n2];
        for (var o in e2)
          Object.prototype.hasOwnProperty.call(e2, o) && (i[o] = e2[o]);
      }
      return i;
    }, mh.apply(this, arguments);
  }
  function a9(i, n2) {
    if (!(i instanceof n2))
      throw new TypeError("Cannot call a class as a function");
  }
  function $Ee(i, n2) {
    for (var e2 = 0; e2 < n2.length; e2++) {
      var o = n2[e2];
      o.enumerable = o.enumerable || false, o.configurable = true, "value" in o && (o.writable = true), Object.defineProperty(i, o.key, o);
    }
  }
  function i9(i, n2, e2) {
    return n2 && $Ee(i.prototype, n2), e2 && $Ee(i, e2), Object.defineProperty(i, "prototype", { writable: false }), i;
  }
  function fse(i, n2) {
    return fse = Object.setPrototypeOf || function(o, l4) {
      return o.__proto__ = l4, o;
    }, fse(i, n2);
  }
  function Rue(i, n2) {
    if (typeof n2 != "function" && n2 !== null)
      throw new TypeError("Super expression must either be null or a function");
    i.prototype = Object.create(n2 && n2.prototype, { constructor: { value: i, writable: true, configurable: true } }), Object.defineProperty(i, "prototype", { writable: false }), n2 && fse(i, n2);
  }
  function h$(i) {
    return h$ = Object.setPrototypeOf ? Object.getPrototypeOf : function(e2) {
      return e2.__proto__ || Object.getPrototypeOf(e2);
    }, h$(i);
  }
  function PIt() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function Fue(i) {
    if (i === void 0)
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return i;
  }
  function LIt(i, n2) {
    if (n2 && (pv(n2) === "object" || typeof n2 == "function"))
      return n2;
    if (n2 !== void 0)
      throw new TypeError("Derived constructors may only return object or undefined");
    return Fue(i);
  }
  function Nue(i) {
    var n2 = PIt();
    return function() {
      var o = h$(i), l4;
      if (n2) {
        var c4 = h$(this).constructor;
        l4 = Reflect.construct(o, arguments, c4);
      } else
        l4 = o.apply(this, arguments);
      return LIt(this, l4);
    };
  }
  var Vue = { exports: {} }, Fu = {};
  /** @license React v16.13.1
  * react-is.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var Bd = typeof Symbol == "function" && Symbol.for, zue = Bd ? Symbol.for("react.element") : 60103, Bue = Bd ? Symbol.for("react.portal") : 60106, aU = Bd ? Symbol.for("react.fragment") : 60107, iU = Bd ? Symbol.for("react.strict_mode") : 60108, oU = Bd ? Symbol.for("react.profiler") : 60114, sU = Bd ? Symbol.for("react.provider") : 60109, lU = Bd ? Symbol.for("react.context") : 60110, jue = Bd ? Symbol.for("react.async_mode") : 60111, uU = Bd ? Symbol.for("react.concurrent_mode") : 60111, cU = Bd ? Symbol.for("react.forward_ref") : 60112, fU = Bd ? Symbol.for("react.suspense") : 60113, OIt = Bd ? Symbol.for("react.suspense_list") : 60120, hU = Bd ? Symbol.for("react.memo") : 60115, dU = Bd ? Symbol.for("react.lazy") : 60116, RIt = Bd ? Symbol.for("react.block") : 60121, FIt = Bd ? Symbol.for("react.fundamental") : 60117, NIt = Bd ? Symbol.for("react.responder") : 60118, VIt = Bd ? Symbol.for("react.scope") : 60119;
  function im(i) {
    if (typeof i == "object" && i !== null) {
      var n2 = i.$$typeof;
      switch (n2) {
        case zue:
          switch (i = i.type, i) {
            case jue:
            case uU:
            case aU:
            case oU:
            case iU:
            case fU:
              return i;
            default:
              switch (i = i && i.$$typeof, i) {
                case lU:
                case cU:
                case dU:
                case hU:
                case sU:
                  return i;
                default:
                  return n2;
              }
          }
        case Bue:
          return n2;
      }
    }
  }
  function LLe(i) {
    return im(i) === uU;
  }
  Fu.AsyncMode = jue;
  Fu.ConcurrentMode = uU;
  Fu.ContextConsumer = lU;
  Fu.ContextProvider = sU;
  Fu.Element = zue;
  Fu.ForwardRef = cU;
  Fu.Fragment = aU;
  Fu.Lazy = dU;
  Fu.Memo = hU;
  Fu.Portal = Bue;
  Fu.Profiler = oU;
  Fu.StrictMode = iU;
  Fu.Suspense = fU;
  Fu.isAsyncMode = function(i) {
    return LLe(i) || im(i) === jue;
  };
  Fu.isConcurrentMode = LLe;
  Fu.isContextConsumer = function(i) {
    return im(i) === lU;
  };
  Fu.isContextProvider = function(i) {
    return im(i) === sU;
  };
  Fu.isElement = function(i) {
    return typeof i == "object" && i !== null && i.$$typeof === zue;
  };
  Fu.isForwardRef = function(i) {
    return im(i) === cU;
  };
  Fu.isFragment = function(i) {
    return im(i) === aU;
  };
  Fu.isLazy = function(i) {
    return im(i) === dU;
  };
  Fu.isMemo = function(i) {
    return im(i) === hU;
  };
  Fu.isPortal = function(i) {
    return im(i) === Bue;
  };
  Fu.isProfiler = function(i) {
    return im(i) === oU;
  };
  Fu.isStrictMode = function(i) {
    return im(i) === iU;
  };
  Fu.isSuspense = function(i) {
    return im(i) === fU;
  };
  Fu.isValidElementType = function(i) {
    return typeof i == "string" || typeof i == "function" || i === aU || i === uU || i === oU || i === iU || i === fU || i === OIt || typeof i == "object" && i !== null && (i.$$typeof === dU || i.$$typeof === hU || i.$$typeof === sU || i.$$typeof === lU || i.$$typeof === cU || i.$$typeof === FIt || i.$$typeof === NIt || i.$$typeof === VIt || i.$$typeof === RIt);
  };
  Fu.typeOf = im;
  Vue.exports = Fu;
  function hse(i) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e2 = [];
    return P3.default.Children.forEach(i, function(o) {
      o == null && !n2.keepEmpty || (Array.isArray(o) ? e2 = e2.concat(hse(o)) : Vue.exports.isFragment(o) && o.props ? e2 = e2.concat(hse(o.props.children, n2)) : e2.push(o));
    }), e2;
  }
  function zIt(i, n2) {
    typeof i == "function" ? i(n2) : pv(i) === "object" && i && "current" in i && (i.current = n2);
  }
  function BIt() {
    for (var i = arguments.length, n2 = new Array(i), e2 = 0; e2 < i; e2++)
      n2[e2] = arguments[e2];
    var o = n2.filter(function(l4) {
      return l4;
    });
    return o.length <= 1 ? o[0] : function(l4) {
      n2.forEach(function(c4) {
        zIt(c4, l4);
      });
    };
  }
  function jIt(i) {
    var n2, e2, o = Vue.exports.isMemo(i) ? i.type.type : i.type;
    return !(typeof o == "function" && !(!((n2 = o.prototype) === null || n2 === void 0) && n2.render) || typeof i == "function" && !(!((e2 = i.prototype) === null || e2 === void 0) && e2.render));
  }
  function $It() {
    try {
      if (!Object.assign)
        return false;
      var i = new String("abc");
      if (i[5] = "de", Object.getOwnPropertyNames(i)[0] === "5")
        return false;
      for (var n2 = {}, e2 = 0; e2 < 10; e2++)
        n2["_" + String.fromCharCode(e2)] = e2;
      var o = Object.getOwnPropertyNames(n2).map(function(c4) {
        return n2[c4];
      });
      if (o.join("") !== "0123456789")
        return false;
      var l4 = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(c4) {
        l4[c4] = c4;
      }), Object.keys(Object.assign({}, l4)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return false;
    }
  }
  $It();
  function UIt(i) {
    if (Array.isArray(i))
      return sse(i);
  }
  function OLe(i) {
    if (typeof Symbol != "undefined" && i[Symbol.iterator] != null || i["@@iterator"] != null)
      return Array.from(i);
  }
  function qIt() {
    throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function _l(i) {
    return UIt(i) || OLe(i) || Pue(i) || qIt();
  }
  var C3 = "RC_FORM_INTERNAL_HOOKS", Ic = function() {
    U_(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
  }, L8 = Qr.createContext({ getFieldValue: Ic, getFieldsValue: Ic, getFieldError: Ic, getFieldWarning: Ic, getFieldsError: Ic, isFieldsTouched: Ic, isFieldTouched: Ic, isFieldValidating: Ic, isFieldsValidating: Ic, resetFields: Ic, setFields: Ic, setFieldsValue: Ic, validateFields: Ic, submit: Ic, getInternalHooks: function() {
    return Ic(), { dispatch: Ic, initEntityValue: Ic, registerField: Ic, useSubscribe: Ic, setInitialValues: Ic, setCallbacks: Ic, getFields: Ic, setValidateMessages: Ic, setPreserve: Ic, getInitialValue: Ic };
  } });
  function dse(i) {
    return i == null ? [] : Array.isArray(i) ? i : [i];
  }
  var RLe = { exports: {} };
  (function(i) {
    var n2 = function(e2) {
      var o = Object.prototype, l4 = o.hasOwnProperty, c4, h = typeof Symbol == "function" ? Symbol : {}, p4 = h.iterator || "@@iterator", g4 = h.asyncIterator || "@@asyncIterator", y4 = h.toStringTag || "@@toStringTag";
      function _(xt, It, Wt) {
        return Object.defineProperty(xt, It, { value: Wt, enumerable: true, configurable: true, writable: true }), xt[It];
      }
      try {
        _({}, "");
      } catch {
        _ = function(It, Wt, sn) {
          return It[Wt] = sn;
        };
      }
      function w4(xt, It, Wt, sn) {
        var vn = It && It.prototype instanceof H ? It : H, $r = Object.create(vn.prototype), ga = new ft(sn || []);
        return $r._invoke = Pe(xt, Wt, ga), $r;
      }
      e2.wrap = w4;
      function C(xt, It, Wt) {
        try {
          return { type: "normal", arg: xt.call(It, Wt) };
        } catch (sn) {
          return { type: "throw", arg: sn };
        }
      }
      var E = "suspendedStart", T = "suspendedYield", O = "executing", N = "completed", V = {};
      function H() {
      }
      function X() {
      }
      function q2() {
      }
      var de = {};
      _(de, p4, function() {
        return this;
      });
      var le = Object.getPrototypeOf, me = le && le(le(et([])));
      me && me !== o && l4.call(me, p4) && (de = me);
      var ye = q2.prototype = H.prototype = Object.create(de);
      X.prototype = q2, _(ye, "constructor", q2), _(q2, "constructor", X), X.displayName = _(q2, y4, "GeneratorFunction");
      function be(xt) {
        ["next", "throw", "return"].forEach(function(It) {
          _(xt, It, function(Wt) {
            return this._invoke(It, Wt);
          });
        });
      }
      e2.isGeneratorFunction = function(xt) {
        var It = typeof xt == "function" && xt.constructor;
        return It ? It === X || (It.displayName || It.name) === "GeneratorFunction" : false;
      }, e2.mark = function(xt) {
        return Object.setPrototypeOf ? Object.setPrototypeOf(xt, q2) : (xt.__proto__ = q2, _(xt, y4, "GeneratorFunction")), xt.prototype = Object.create(ye), xt;
      }, e2.awrap = function(xt) {
        return { __await: xt };
      };
      function we(xt, It) {
        function Wt($r, ga, Za, $a) {
          var Pa = C(xt[$r], xt, ga);
          if (Pa.type === "throw")
            $a(Pa.arg);
          else {
            var da = Pa.arg, Ra = da.value;
            return Ra && typeof Ra == "object" && l4.call(Ra, "__await") ? It.resolve(Ra.__await).then(function(Wa) {
              Wt("next", Wa, Za, $a);
            }, function(Wa) {
              Wt("throw", Wa, Za, $a);
            }) : It.resolve(Ra).then(function(Wa) {
              da.value = Wa, Za(da);
            }, function(Wa) {
              return Wt("throw", Wa, Za, $a);
            });
          }
        }
        var sn;
        function vn($r, ga) {
          function Za() {
            return new It(function($a, Pa) {
              Wt($r, ga, $a, Pa);
            });
          }
          return sn = sn ? sn.then(Za, Za) : Za();
        }
        this._invoke = vn;
      }
      be(we.prototype), _(we.prototype, g4, function() {
        return this;
      }), e2.AsyncIterator = we, e2.async = function(xt, It, Wt, sn, vn) {
        vn === void 0 && (vn = Promise);
        var $r = new we(w4(xt, It, Wt, sn), vn);
        return e2.isGeneratorFunction(It) ? $r : $r.next().then(function(ga) {
          return ga.done ? ga.value : $r.next();
        });
      };
      function Pe(xt, It, Wt) {
        var sn = E;
        return function($r, ga) {
          if (sn === O)
            throw new Error("Generator is already running");
          if (sn === N) {
            if ($r === "throw")
              throw ga;
            return Jt();
          }
          for (Wt.method = $r, Wt.arg = ga; ; ) {
            var Za = Wt.delegate;
            if (Za) {
              var $a = ze(Za, Wt);
              if ($a) {
                if ($a === V)
                  continue;
                return $a;
              }
            }
            if (Wt.method === "next")
              Wt.sent = Wt._sent = Wt.arg;
            else if (Wt.method === "throw") {
              if (sn === E)
                throw sn = N, Wt.arg;
              Wt.dispatchException(Wt.arg);
            } else
              Wt.method === "return" && Wt.abrupt("return", Wt.arg);
            sn = O;
            var Pa = C(xt, It, Wt);
            if (Pa.type === "normal") {
              if (sn = Wt.done ? N : T, Pa.arg === V)
                continue;
              return { value: Pa.arg, done: Wt.done };
            } else
              Pa.type === "throw" && (sn = N, Wt.method = "throw", Wt.arg = Pa.arg);
          }
        };
      }
      function ze(xt, It) {
        var Wt = xt.iterator[It.method];
        if (Wt === c4) {
          if (It.delegate = null, It.method === "throw") {
            if (xt.iterator.return && (It.method = "return", It.arg = c4, ze(xt, It), It.method === "throw"))
              return V;
            It.method = "throw", It.arg = new TypeError("The iterator does not provide a 'throw' method");
          }
          return V;
        }
        var sn = C(Wt, xt.iterator, It.arg);
        if (sn.type === "throw")
          return It.method = "throw", It.arg = sn.arg, It.delegate = null, V;
        var vn = sn.arg;
        if (!vn)
          return It.method = "throw", It.arg = new TypeError("iterator result is not an object"), It.delegate = null, V;
        if (vn.done)
          It[xt.resultName] = vn.value, It.next = xt.nextLoc, It.method !== "return" && (It.method = "next", It.arg = c4);
        else
          return vn;
        return It.delegate = null, V;
      }
      be(ye), _(ye, y4, "Generator"), _(ye, p4, function() {
        return this;
      }), _(ye, "toString", function() {
        return "[object Generator]";
      });
      function Re(xt) {
        var It = { tryLoc: xt[0] };
        1 in xt && (It.catchLoc = xt[1]), 2 in xt && (It.finallyLoc = xt[2], It.afterLoc = xt[3]), this.tryEntries.push(It);
      }
      function rt2(xt) {
        var It = xt.completion || {};
        It.type = "normal", delete It.arg, xt.completion = It;
      }
      function ft(xt) {
        this.tryEntries = [{ tryLoc: "root" }], xt.forEach(Re, this), this.reset(true);
      }
      e2.keys = function(xt) {
        var It = [];
        for (var Wt in xt)
          It.push(Wt);
        return It.reverse(), function sn() {
          for (; It.length; ) {
            var vn = It.pop();
            if (vn in xt)
              return sn.value = vn, sn.done = false, sn;
          }
          return sn.done = true, sn;
        };
      };
      function et(xt) {
        if (xt) {
          var It = xt[p4];
          if (It)
            return It.call(xt);
          if (typeof xt.next == "function")
            return xt;
          if (!isNaN(xt.length)) {
            var Wt = -1, sn = function vn() {
              for (; ++Wt < xt.length; )
                if (l4.call(xt, Wt))
                  return vn.value = xt[Wt], vn.done = false, vn;
              return vn.value = c4, vn.done = true, vn;
            };
            return sn.next = sn;
          }
        }
        return { next: Jt };
      }
      e2.values = et;
      function Jt() {
        return { value: c4, done: true };
      }
      return ft.prototype = { constructor: ft, reset: function(xt) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = c4, this.done = false, this.delegate = null, this.method = "next", this.arg = c4, this.tryEntries.forEach(rt2), !xt)
          for (var It in this)
            It.charAt(0) === "t" && l4.call(this, It) && !isNaN(+It.slice(1)) && (this[It] = c4);
      }, stop: function() {
        this.done = true;
        var xt = this.tryEntries[0], It = xt.completion;
        if (It.type === "throw")
          throw It.arg;
        return this.rval;
      }, dispatchException: function(xt) {
        if (this.done)
          throw xt;
        var It = this;
        function Wt($a, Pa) {
          return $r.type = "throw", $r.arg = xt, It.next = $a, Pa && (It.method = "next", It.arg = c4), !!Pa;
        }
        for (var sn = this.tryEntries.length - 1; sn >= 0; --sn) {
          var vn = this.tryEntries[sn], $r = vn.completion;
          if (vn.tryLoc === "root")
            return Wt("end");
          if (vn.tryLoc <= this.prev) {
            var ga = l4.call(vn, "catchLoc"), Za = l4.call(vn, "finallyLoc");
            if (ga && Za) {
              if (this.prev < vn.catchLoc)
                return Wt(vn.catchLoc, true);
              if (this.prev < vn.finallyLoc)
                return Wt(vn.finallyLoc);
            } else if (ga) {
              if (this.prev < vn.catchLoc)
                return Wt(vn.catchLoc, true);
            } else if (Za) {
              if (this.prev < vn.finallyLoc)
                return Wt(vn.finallyLoc);
            } else
              throw new Error("try statement without catch or finally");
          }
        }
      }, abrupt: function(xt, It) {
        for (var Wt = this.tryEntries.length - 1; Wt >= 0; --Wt) {
          var sn = this.tryEntries[Wt];
          if (sn.tryLoc <= this.prev && l4.call(sn, "finallyLoc") && this.prev < sn.finallyLoc) {
            var vn = sn;
            break;
          }
        }
        vn && (xt === "break" || xt === "continue") && vn.tryLoc <= It && It <= vn.finallyLoc && (vn = null);
        var $r = vn ? vn.completion : {};
        return $r.type = xt, $r.arg = It, vn ? (this.method = "next", this.next = vn.finallyLoc, V) : this.complete($r);
      }, complete: function(xt, It) {
        if (xt.type === "throw")
          throw xt.arg;
        return xt.type === "break" || xt.type === "continue" ? this.next = xt.arg : xt.type === "return" ? (this.rval = this.arg = xt.arg, this.method = "return", this.next = "end") : xt.type === "normal" && It && (this.next = It), V;
      }, finish: function(xt) {
        for (var It = this.tryEntries.length - 1; It >= 0; --It) {
          var Wt = this.tryEntries[It];
          if (Wt.finallyLoc === xt)
            return this.complete(Wt.completion, Wt.afterLoc), rt2(Wt), V;
        }
      }, catch: function(xt) {
        for (var It = this.tryEntries.length - 1; It >= 0; --It) {
          var Wt = this.tryEntries[It];
          if (Wt.tryLoc === xt) {
            var sn = Wt.completion;
            if (sn.type === "throw") {
              var vn = sn.arg;
              rt2(Wt);
            }
            return vn;
          }
        }
        throw new Error("illegal catch attempt");
      }, delegateYield: function(xt, It, Wt) {
        return this.delegate = { iterator: et(xt), resultName: It, nextLoc: Wt }, this.method === "next" && (this.arg = c4), V;
      } }, e2;
    }(i.exports);
    try {
      regeneratorRuntime = n2;
    } catch {
      typeof globalThis == "object" ? globalThis.regeneratorRuntime = n2 : Function("r", "regeneratorRuntime = r")(n2);
    }
  })(RLe);
  var iM = RLe.exports;
  function qEe(i, n2, e2, o, l4, c4, h) {
    try {
      var p4 = i[c4](h), g4 = p4.value;
    } catch (y4) {
      e2(y4);
      return;
    }
    p4.done ? n2(g4) : Promise.resolve(g4).then(o, l4);
  }
  function pU(i) {
    return function() {
      var n2 = this, e2 = arguments;
      return new Promise(function(o, l4) {
        var c4 = i.apply(n2, e2);
        function h(g4) {
          qEe(c4, o, l4, h, p4, "next", g4);
        }
        function p4(g4) {
          qEe(c4, o, l4, h, p4, "throw", g4);
        }
        h(void 0);
      });
    };
  }
  function sT() {
    return sT = Object.assign || function(i) {
      for (var n2 = 1; n2 < arguments.length; n2++) {
        var e2 = arguments[n2];
        for (var o in e2)
          Object.prototype.hasOwnProperty.call(e2, o) && (i[o] = e2[o]);
      }
      return i;
    }, sT.apply(this, arguments);
  }
  function YIt(i, n2) {
    i.prototype = Object.create(n2.prototype), i.prototype.constructor = i, O8(i, n2);
  }
  function pse(i) {
    return pse = Object.setPrototypeOf ? Object.getPrototypeOf : function(e2) {
      return e2.__proto__ || Object.getPrototypeOf(e2);
    }, pse(i);
  }
  function O8(i, n2) {
    return O8 = Object.setPrototypeOf || function(o, l4) {
      return o.__proto__ = l4, o;
    }, O8(i, n2);
  }
  function ZIt() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function pH(i, n2, e2) {
    return ZIt() ? pH = Reflect.construct : pH = function(l4, c4, h) {
      var p4 = [null];
      p4.push.apply(p4, c4);
      var g4 = Function.bind.apply(l4, p4), y4 = new g4();
      return h && O8(y4, h.prototype), y4;
    }, pH.apply(null, arguments);
  }
  function XIt(i) {
    return Function.toString.call(i).indexOf("[native code]") !== -1;
  }
  function vse(i) {
    var n2 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
    return vse = function(o) {
      if (o === null || !XIt(o))
        return o;
      if (typeof o != "function")
        throw new TypeError("Super expression must either be null or a function");
      if (typeof n2 != "undefined") {
        if (n2.has(o))
          return n2.get(o);
        n2.set(o, l4);
      }
      function l4() {
        return pH(o, arguments, pse(this).constructor);
      }
      return l4.prototype = Object.create(o.prototype, { constructor: { value: l4, enumerable: false, writable: true, configurable: true } }), O8(l4, o);
    }, vse(i);
  }
  var KIt = /%[sdj%]/g, JIt = function() {
  };
  typeof process != "undefined" && process.env;
  function gse(i) {
    if (!i || !i.length)
      return null;
    var n2 = {};
    return i.forEach(function(e2) {
      var o = e2.field;
      n2[o] = n2[o] || [], n2[o].push(e2);
    }), n2;
  }
  function tm(i) {
    for (var n2 = arguments.length, e2 = new Array(n2 > 1 ? n2 - 1 : 0), o = 1; o < n2; o++)
      e2[o - 1] = arguments[o];
    var l4 = 0, c4 = e2.length;
    if (typeof i == "function")
      return i.apply(null, e2);
    if (typeof i == "string") {
      var h = i.replace(KIt, function(p4) {
        if (p4 === "%%")
          return "%";
        if (l4 >= c4)
          return p4;
        switch (p4) {
          case "%s":
            return String(e2[l4++]);
          case "%d":
            return Number(e2[l4++]);
          case "%j":
            try {
              return JSON.stringify(e2[l4++]);
            } catch {
              return "[Circular]";
            }
            break;
          default:
            return p4;
        }
      });
      return h;
    }
    return i;
  }
  function QIt(i) {
    return i === "string" || i === "url" || i === "hex" || i === "email" || i === "date" || i === "pattern";
  }
  function ed(i, n2) {
    return !!(i == null || n2 === "array" && Array.isArray(i) && !i.length || QIt(n2) && typeof i == "string" && !i);
  }
  function eTt(i, n2, e2) {
    var o = [], l4 = 0, c4 = i.length;
    function h(p4) {
      o.push.apply(o, p4 || []), l4++, l4 === c4 && e2(o);
    }
    i.forEach(function(p4) {
      n2(p4, h);
    });
  }
  function YEe(i, n2, e2) {
    var o = 0, l4 = i.length;
    function c4(h) {
      if (h && h.length) {
        e2(h);
        return;
      }
      var p4 = o;
      o = o + 1, p4 < l4 ? n2(i[p4], c4) : e2([]);
    }
    c4([]);
  }
  function tTt(i) {
    var n2 = [];
    return Object.keys(i).forEach(function(e2) {
      n2.push.apply(n2, i[e2] || []);
    }), n2;
  }
  var ZEe = function(i) {
    YIt(n2, i);
    function n2(e2, o) {
      var l4;
      return l4 = i.call(this, "Async Validation Error") || this, l4.errors = e2, l4.fields = o, l4;
    }
    return n2;
  }(vse(Error));
  function nTt(i, n2, e2, o, l4) {
    if (n2.first) {
      var c4 = new Promise(function(C, E) {
        var T = function(V) {
          return o(V), V.length ? E(new ZEe(V, gse(V))) : C(l4);
        }, O = tTt(i);
        YEe(O, e2, T);
      });
      return c4.catch(function(C) {
        return C;
      }), c4;
    }
    var h = n2.firstFields === true ? Object.keys(i) : n2.firstFields || [], p4 = Object.keys(i), g4 = p4.length, y4 = 0, _ = [], w4 = new Promise(function(C, E) {
      var T = function(N) {
        if (_.push.apply(_, N), y4++, y4 === g4)
          return o(_), _.length ? E(new ZEe(_, gse(_))) : C(l4);
      };
      p4.length || (o(_), C(l4)), p4.forEach(function(O) {
        var N = i[O];
        h.indexOf(O) !== -1 ? YEe(N, e2, T) : eTt(N, e2, T);
      });
    });
    return w4.catch(function(C) {
      return C;
    }), w4;
  }
  function rTt(i) {
    return !!(i && i.message !== void 0);
  }
  function aTt(i, n2) {
    for (var e2 = i, o = 0; o < n2.length; o++) {
      if (e2 == null)
        return e2;
      e2 = e2[n2[o]];
    }
    return e2;
  }
  function XEe(i, n2) {
    return function(e2) {
      var o;
      return i.fullFields ? o = aTt(n2, i.fullFields) : o = n2[e2.field || i.fullField], rTt(e2) ? (e2.field = e2.field || i.fullField, e2.fieldValue = o, e2) : { message: typeof e2 == "function" ? e2() : e2, fieldValue: o, field: e2.field || i.fullField };
    };
  }
  function KEe(i, n2) {
    if (n2) {
      for (var e2 in n2)
        if (n2.hasOwnProperty(e2)) {
          var o = n2[e2];
          typeof o == "object" && typeof i[e2] == "object" ? i[e2] = sT({}, i[e2], o) : i[e2] = o;
        }
    }
    return i;
  }
  var FLe = function(n2, e2, o, l4, c4, h) {
    n2.required && (!o.hasOwnProperty(n2.field) || ed(e2, h || n2.type)) && l4.push(tm(c4.messages.required, n2.fullField));
  }, iTt = function(n2, e2, o, l4, c4) {
    (/^\s+$/.test(e2) || e2 === "") && l4.push(tm(c4.messages.whitespace, n2.fullField));
  }, gie = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, VN = { integer: function(n2) {
    return VN.number(n2) && parseInt(n2, 10) === n2;
  }, float: function(n2) {
    return VN.number(n2) && !VN.integer(n2);
  }, array: function(n2) {
    return Array.isArray(n2);
  }, regexp: function(n2) {
    if (n2 instanceof RegExp)
      return true;
    try {
      return !!new RegExp(n2);
    } catch {
      return false;
    }
  }, date: function(n2) {
    return typeof n2.getTime == "function" && typeof n2.getMonth == "function" && typeof n2.getYear == "function" && !isNaN(n2.getTime());
  }, number: function(n2) {
    return isNaN(n2) ? false : typeof n2 == "number";
  }, object: function(n2) {
    return typeof n2 == "object" && !VN.array(n2);
  }, method: function(n2) {
    return typeof n2 == "function";
  }, email: function(n2) {
    return typeof n2 == "string" && n2.length <= 320 && !!n2.match(gie.email);
  }, url: function(n2) {
    return typeof n2 == "string" && n2.length <= 2048 && !!n2.match(gie.url);
  }, hex: function(n2) {
    return typeof n2 == "string" && !!n2.match(gie.hex);
  } }, oTt = function(n2, e2, o, l4, c4) {
    if (n2.required && e2 === void 0) {
      FLe(n2, e2, o, l4, c4);
      return;
    }
    var h = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], p4 = n2.type;
    h.indexOf(p4) > -1 ? VN[p4](e2) || l4.push(tm(c4.messages.types[p4], n2.fullField, n2.type)) : p4 && typeof e2 !== n2.type && l4.push(tm(c4.messages.types[p4], n2.fullField, n2.type));
  }, sTt = function(n2, e2, o, l4, c4) {
    var h = typeof n2.len == "number", p4 = typeof n2.min == "number", g4 = typeof n2.max == "number", y4 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, _ = e2, w4 = null, C = typeof e2 == "number", E = typeof e2 == "string", T = Array.isArray(e2);
    if (C ? w4 = "number" : E ? w4 = "string" : T && (w4 = "array"), !w4)
      return false;
    T && (_ = e2.length), E && (_ = e2.replace(y4, "_").length), h ? _ !== n2.len && l4.push(tm(c4.messages[w4].len, n2.fullField, n2.len)) : p4 && !g4 && _ < n2.min ? l4.push(tm(c4.messages[w4].min, n2.fullField, n2.min)) : g4 && !p4 && _ > n2.max ? l4.push(tm(c4.messages[w4].max, n2.fullField, n2.max)) : p4 && g4 && (_ < n2.min || _ > n2.max) && l4.push(tm(c4.messages[w4].range, n2.fullField, n2.min, n2.max));
  }, f3 = "enum", lTt = function(n2, e2, o, l4, c4) {
    n2[f3] = Array.isArray(n2[f3]) ? n2[f3] : [], n2[f3].indexOf(e2) === -1 && l4.push(tm(c4.messages[f3], n2.fullField, n2[f3].join(", ")));
  }, uTt = function(n2, e2, o, l4, c4) {
    if (n2.pattern) {
      if (n2.pattern instanceof RegExp)
        n2.pattern.lastIndex = 0, n2.pattern.test(e2) || l4.push(tm(c4.messages.pattern.mismatch, n2.fullField, e2, n2.pattern));
      else if (typeof n2.pattern == "string") {
        var h = new RegExp(n2.pattern);
        h.test(e2) || l4.push(tm(c4.messages.pattern.mismatch, n2.fullField, e2, n2.pattern));
      }
    }
  }, pl = { required: FLe, whitespace: iTt, type: oTt, range: sTt, enum: lTt, pattern: uTt }, cTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2, "string") && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4, "string"), ed(e2, "string") || (pl.type(n2, e2, l4, h, c4), pl.range(n2, e2, l4, h, c4), pl.pattern(n2, e2, l4, h, c4), n2.whitespace === true && pl.whitespace(n2, e2, l4, h, c4));
    }
    o(h);
  }, fTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && pl.type(n2, e2, l4, h, c4);
    }
    o(h);
  }, hTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (e2 === "" && (e2 = void 0), ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && (pl.type(n2, e2, l4, h, c4), pl.range(n2, e2, l4, h, c4));
    }
    o(h);
  }, dTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && pl.type(n2, e2, l4, h, c4);
    }
    o(h);
  }, pTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), ed(e2) || pl.type(n2, e2, l4, h, c4);
    }
    o(h);
  }, vTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && (pl.type(n2, e2, l4, h, c4), pl.range(n2, e2, l4, h, c4));
    }
    o(h);
  }, gTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && (pl.type(n2, e2, l4, h, c4), pl.range(n2, e2, l4, h, c4));
    }
    o(h);
  }, mTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (e2 == null && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4, "array"), e2 != null && (pl.type(n2, e2, l4, h, c4), pl.range(n2, e2, l4, h, c4));
    }
    o(h);
  }, yTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && pl.type(n2, e2, l4, h, c4);
    }
    o(h);
  }, bTt = "enum", _Tt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), e2 !== void 0 && pl[bTt](n2, e2, l4, h, c4);
    }
    o(h);
  }, xTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2, "string") && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4), ed(e2, "string") || pl.pattern(n2, e2, l4, h, c4);
    }
    o(h);
  }, wTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2, "date") && !n2.required)
        return o();
      if (pl.required(n2, e2, l4, h, c4), !ed(e2, "date")) {
        var g4;
        e2 instanceof Date ? g4 = e2 : g4 = new Date(e2), pl.type(n2, g4, l4, h, c4), g4 && pl.range(n2, g4.getTime(), l4, h, c4);
      }
    }
    o(h);
  }, STt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = Array.isArray(e2) ? "array" : typeof e2;
    pl.required(n2, e2, l4, h, c4, p4), o(h);
  }, mie = function(n2, e2, o, l4, c4) {
    var h = n2.type, p4 = [], g4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (g4) {
      if (ed(e2, h) && !n2.required)
        return o();
      pl.required(n2, e2, l4, p4, c4, h), ed(e2, h) || pl.type(n2, e2, l4, p4, c4);
    }
    o(p4);
  }, CTt = function(n2, e2, o, l4, c4) {
    var h = [], p4 = n2.required || !n2.required && l4.hasOwnProperty(n2.field);
    if (p4) {
      if (ed(e2) && !n2.required)
        return o();
      pl.required(n2, e2, l4, h, c4);
    }
    o(h);
  }, n8 = { string: cTt, method: fTt, number: hTt, boolean: dTt, regexp: pTt, integer: vTt, float: gTt, array: mTt, object: yTt, enum: _Tt, pattern: xTt, date: wTt, url: mie, hex: mie, email: mie, required: STt, any: CTt };
  function mse() {
    return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
      var n2 = JSON.parse(JSON.stringify(this));
      return n2.clone = this.clone, n2;
    } };
  }
  var yse = mse(), o9 = function() {
    function i(e2) {
      this.rules = null, this._messages = yse, this.define(e2);
    }
    var n2 = i.prototype;
    return n2.define = function(o) {
      var l4 = this;
      if (!o)
        throw new Error("Cannot configure a schema with no rules");
      if (typeof o != "object" || Array.isArray(o))
        throw new Error("Rules must be an object");
      this.rules = {}, Object.keys(o).forEach(function(c4) {
        var h = o[c4];
        l4.rules[c4] = Array.isArray(h) ? h : [h];
      });
    }, n2.messages = function(o) {
      return o && (this._messages = KEe(mse(), o)), this._messages;
    }, n2.validate = function(o, l4, c4) {
      var h = this;
      l4 === void 0 && (l4 = {}), c4 === void 0 && (c4 = function() {
      });
      var p4 = o, g4 = l4, y4 = c4;
      if (typeof g4 == "function" && (y4 = g4, g4 = {}), !this.rules || Object.keys(this.rules).length === 0)
        return y4 && y4(null, p4), Promise.resolve(p4);
      function _(O) {
        var N = [], V = {};
        function H(q2) {
          if (Array.isArray(q2)) {
            var de;
            N = (de = N).concat.apply(de, q2);
          } else
            N.push(q2);
        }
        for (var X = 0; X < O.length; X++)
          H(O[X]);
        N.length ? (V = gse(N), y4(N, V)) : y4(null, p4);
      }
      if (g4.messages) {
        var w4 = this.messages();
        w4 === yse && (w4 = mse()), KEe(w4, g4.messages), g4.messages = w4;
      } else
        g4.messages = this.messages();
      var C = {}, E = g4.keys || Object.keys(this.rules);
      E.forEach(function(O) {
        var N = h.rules[O], V = p4[O];
        N.forEach(function(H) {
          var X = H;
          typeof X.transform == "function" && (p4 === o && (p4 = sT({}, p4)), V = p4[O] = X.transform(V)), typeof X == "function" ? X = { validator: X } : X = sT({}, X), X.validator = h.getValidationMethod(X), X.validator && (X.field = O, X.fullField = X.fullField || O, X.type = h.getType(X), C[O] = C[O] || [], C[O].push({ rule: X, value: V, source: p4, field: O }));
        });
      });
      var T = {};
      return nTt(C, g4, function(O, N) {
        var V = O.rule, H = (V.type === "object" || V.type === "array") && (typeof V.fields == "object" || typeof V.defaultField == "object");
        H = H && (V.required || !V.required && O.value), V.field = O.field;
        function X(le, me) {
          return sT({}, me, { fullField: V.fullField + "." + le, fullFields: V.fullFields ? [].concat(V.fullFields, [le]) : [le] });
        }
        function q2(le) {
          le === void 0 && (le = []);
          var me = Array.isArray(le) ? le : [le];
          !g4.suppressWarning && me.length && i.warning("async-validator:", me), me.length && V.message !== void 0 && (me = [].concat(V.message));
          var ye = me.map(XEe(V, p4));
          if (g4.first && ye.length)
            return T[V.field] = 1, N(ye);
          if (!H)
            N(ye);
          else {
            if (V.required && !O.value)
              return V.message !== void 0 ? ye = [].concat(V.message).map(XEe(V, p4)) : g4.error && (ye = [g4.error(V, tm(g4.messages.required, V.field))]), N(ye);
            var be = {};
            V.defaultField && Object.keys(O.value).map(function(ze) {
              be[ze] = V.defaultField;
            }), be = sT({}, be, O.rule.fields);
            var we = {};
            Object.keys(be).forEach(function(ze) {
              var Re = be[ze], rt2 = Array.isArray(Re) ? Re : [Re];
              we[ze] = rt2.map(X.bind(null, ze));
            });
            var Pe = new i(we);
            Pe.messages(g4.messages), O.rule.options && (O.rule.options.messages = g4.messages, O.rule.options.error = g4.error), Pe.validate(O.value, O.rule.options || g4, function(ze) {
              var Re = [];
              ye && ye.length && Re.push.apply(Re, ye), ze && ze.length && Re.push.apply(Re, ze), N(Re.length ? Re : null);
            });
          }
        }
        var de;
        V.asyncValidator ? de = V.asyncValidator(V, O.value, q2, O.source, g4) : V.validator && (de = V.validator(V, O.value, q2, O.source, g4), de === true ? q2() : de === false ? q2(typeof V.message == "function" ? V.message(V.fullField || V.field) : V.message || (V.fullField || V.field) + " fails") : de instanceof Array ? q2(de) : de instanceof Error && q2(de.message)), de && de.then && de.then(function() {
          return q2();
        }, function(le) {
          return q2(le);
        });
      }, function(O) {
        _(O);
      }, p4);
    }, n2.getType = function(o) {
      if (o.type === void 0 && o.pattern instanceof RegExp && (o.type = "pattern"), typeof o.validator != "function" && o.type && !n8.hasOwnProperty(o.type))
        throw new Error(tm("Unknown rule type %s", o.type));
      return o.type || "string";
    }, n2.getValidationMethod = function(o) {
      if (typeof o.validator == "function")
        return o.validator;
      var l4 = Object.keys(o), c4 = l4.indexOf("message");
      return c4 !== -1 && l4.splice(c4, 1), l4.length === 1 && l4[0] === "required" ? n8.required : n8[this.getType(o)] || void 0;
    }, i;
  }();
  o9.register = function(n2, e2) {
    if (typeof e2 != "function")
      throw new Error("Cannot register a validator by type, validator is not a function");
    n8[n2] = e2;
  };
  o9.warning = JIt;
  o9.messages = yse;
  o9.validators = n8;
  var X0 = "'${name}' is not a valid ${type}", NLe = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: X0, method: X0, array: X0, object: X0, number: X0, date: X0, boolean: X0, integer: X0, float: X0, regexp: X0, email: X0, url: X0, hex: X0 }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
  function VLe(i, n2) {
    for (var e2 = i, o = 0; o < n2.length; o += 1) {
      if (e2 == null)
        return;
      e2 = e2[n2[o]];
    }
    return e2;
  }
  function MTt(i) {
    return xLe(i) || OLe(i) || Pue(i) || wLe();
  }
  function zLe(i, n2, e2, o) {
    if (!n2.length)
      return e2;
    var l4 = MTt(n2), c4 = l4[0], h = l4.slice(1), p4;
    return !i && typeof c4 == "number" ? p4 = [] : Array.isArray(i) ? p4 = _l(i) : p4 = Yo({}, i), o && e2 === void 0 && h.length === 1 ? delete p4[c4][h[0]] : p4[c4] = zLe(p4[c4], h, e2, o), p4;
  }
  function ATt(i, n2, e2) {
    var o = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    return n2.length && o && e2 === void 0 && !VLe(i, n2.slice(0, -1)) ? i : zLe(i, n2, e2, o);
  }
  function gh(i) {
    return dse(i);
  }
  function M3(i, n2) {
    var e2 = VLe(i, n2);
    return e2;
  }
  function KI(i, n2, e2) {
    var o = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, l4 = ATt(i, n2, e2, o);
    return l4;
  }
  function JEe(i, n2) {
    var e2 = {};
    return n2.forEach(function(o) {
      var l4 = M3(i, o);
      e2 = KI(e2, o, l4);
    }), e2;
  }
  function r8(i, n2) {
    return i && i.some(function(e2) {
      return jLe(e2, n2);
    });
  }
  function QEe(i) {
    return pv(i) === "object" && i !== null && Object.getPrototypeOf(i) === Object.prototype;
  }
  function BLe(i, n2) {
    var e2 = Array.isArray(i) ? _l(i) : Yo({}, i);
    return n2 && Object.keys(n2).forEach(function(o) {
      var l4 = e2[o], c4 = n2[o], h = QEe(l4) && QEe(c4);
      e2[o] = h ? BLe(l4, c4 || {}) : c4;
    }), e2;
  }
  function vH(i) {
    for (var n2 = arguments.length, e2 = new Array(n2 > 1 ? n2 - 1 : 0), o = 1; o < n2; o++)
      e2[o - 1] = arguments[o];
    return e2.reduce(function(l4, c4) {
      return BLe(l4, c4);
    }, i);
  }
  function jLe(i, n2) {
    return !i || !n2 || i.length !== n2.length ? false : i.every(function(e2, o) {
      return n2[o] === e2;
    });
  }
  function ETt(i, n2) {
    if (i === n2)
      return true;
    if (!i && n2 || i && !n2 || !i || !n2 || pv(i) !== "object" || pv(n2) !== "object")
      return false;
    var e2 = Object.keys(i), o = Object.keys(n2), l4 = new Set([].concat(_l(e2), _l(o)));
    return _l(l4).every(function(c4) {
      var h = i[c4], p4 = n2[c4];
      return typeof h == "function" && typeof p4 == "function" ? true : h === p4;
    });
  }
  function ITt(i) {
    var n2 = arguments.length <= 1 ? void 0 : arguments[1];
    return n2 && n2.target && pv(n2.target) === "object" && i in n2.target ? n2.target[i] : n2;
  }
  function eIe(i, n2, e2) {
    var o = i.length;
    if (n2 < 0 || n2 >= o || e2 < 0 || e2 >= o)
      return i;
    var l4 = i[n2], c4 = n2 - e2;
    return c4 > 0 ? [].concat(_l(i.slice(0, e2)), [l4], _l(i.slice(e2, n2)), _l(i.slice(n2 + 1, o))) : c4 < 0 ? [].concat(_l(i.slice(0, n2)), _l(i.slice(n2 + 1, e2 + 1)), [l4], _l(i.slice(e2 + 1, o))) : i;
  }
  var TTt = o9;
  function DTt(i, n2) {
    return i.replace(/\$\{\w+\}/g, function(e2) {
      var o = e2.slice(2, -1);
      return n2[o];
    });
  }
  function bse(i, n2, e2, o, l4) {
    return _se.apply(this, arguments);
  }
  function _se() {
    return _se = pU(iM.mark(function i(n2, e2, o, l4, c4) {
      var h, p4, g4, y4, _, w4, C, E;
      return iM.wrap(function(O) {
        for (; ; )
          switch (O.prev = O.next) {
            case 0:
              return h = Yo({}, o), delete h.ruleIndex, p4 = null, h && h.type === "array" && h.defaultField && (p4 = h.defaultField, delete h.defaultField), g4 = new TTt(pu({}, n2, [h])), y4 = vH({}, NLe, l4.validateMessages), g4.messages(y4), _ = [], O.prev = 8, O.next = 11, Promise.resolve(g4.validate(pu({}, n2, e2), Yo({}, l4)));
            case 11:
              O.next = 16;
              break;
            case 13:
              O.prev = 13, O.t0 = O.catch(8), O.t0.errors ? _ = O.t0.errors.map(function(N, V) {
                var H = N.message;
                return Qr.isValidElement(H) ? Qr.cloneElement(H, { key: "error_".concat(V) }) : H;
              }) : (console.error(O.t0), _ = [y4.default]);
            case 16:
              if (!(!_.length && p4)) {
                O.next = 21;
                break;
              }
              return O.next = 19, Promise.all(e2.map(function(N, V) {
                return bse("".concat(n2, ".").concat(V), N, p4, l4, c4);
              }));
            case 19:
              return w4 = O.sent, O.abrupt("return", w4.reduce(function(N, V) {
                return [].concat(_l(N), _l(V));
              }, []));
            case 21:
              return C = Yo(Yo({}, o), {}, { name: n2, enum: (o.enum || []).join(", ") }, c4), E = _.map(function(N) {
                return typeof N == "string" ? DTt(N, C) : N;
              }), O.abrupt("return", E);
            case 24:
            case "end":
              return O.stop();
          }
      }, i, null, [[8, 13]]);
    })), _se.apply(this, arguments);
  }
  function kTt(i, n2, e2, o, l4, c4) {
    var h = i.join("."), p4 = e2.map(function(_, w4) {
      var C = _.validator, E = Yo(Yo({}, _), {}, { ruleIndex: w4 });
      return C && (E.validator = function(T, O, N) {
        var V = false, H = function() {
          for (var de = arguments.length, le = new Array(de), me = 0; me < de; me++)
            le[me] = arguments[me];
          Promise.resolve().then(function() {
            U_(!V, "Your validator function has already return a promise. `callback` will be ignored."), V || N.apply(void 0, le);
          });
        }, X = C(T, O, H);
        V = X && typeof X.then == "function" && typeof X.catch == "function", U_(V, "`callback` is deprecated. Please return a promise instead."), V && X.then(function() {
          N();
        }).catch(function(q2) {
          N(q2 || " ");
        });
      }), E;
    }).sort(function(_, w4) {
      var C = _.warningOnly, E = _.ruleIndex, T = w4.warningOnly, O = w4.ruleIndex;
      return !!C == !!T ? E - O : C ? 1 : -1;
    }), g4;
    if (l4 === true)
      g4 = new Promise(function() {
        var _ = pU(iM.mark(function w4(C, E) {
          var T, O, N;
          return iM.wrap(function(H) {
            for (; ; )
              switch (H.prev = H.next) {
                case 0:
                  T = 0;
                case 1:
                  if (!(T < p4.length)) {
                    H.next = 12;
                    break;
                  }
                  return O = p4[T], H.next = 5, bse(h, n2, O, o, c4);
                case 5:
                  if (N = H.sent, !N.length) {
                    H.next = 9;
                    break;
                  }
                  return E([{ errors: N, rule: O }]), H.abrupt("return");
                case 9:
                  T += 1, H.next = 1;
                  break;
                case 12:
                  C([]);
                case 13:
                case "end":
                  return H.stop();
              }
          }, w4);
        }));
        return function(w4, C) {
          return _.apply(this, arguments);
        };
      }());
    else {
      var y4 = p4.map(function(_) {
        return bse(h, n2, _, o, c4).then(function(w4) {
          return { errors: w4, rule: _ };
        });
      });
      g4 = (l4 ? LTt(y4) : PTt(y4)).then(function(_) {
        return Promise.reject(_);
      });
    }
    return g4.catch(function(_) {
      return _;
    }), g4;
  }
  function PTt(i) {
    return xse.apply(this, arguments);
  }
  function xse() {
    return xse = pU(iM.mark(function i(n2) {
      return iM.wrap(function(o) {
        for (; ; )
          switch (o.prev = o.next) {
            case 0:
              return o.abrupt("return", Promise.all(n2).then(function(l4) {
                var c4, h = (c4 = []).concat.apply(c4, _l(l4));
                return h;
              }));
            case 1:
            case "end":
              return o.stop();
          }
      }, i);
    })), xse.apply(this, arguments);
  }
  function LTt(i) {
    return wse.apply(this, arguments);
  }
  function wse() {
    return wse = pU(iM.mark(function i(n2) {
      var e2;
      return iM.wrap(function(l4) {
        for (; ; )
          switch (l4.prev = l4.next) {
            case 0:
              return e2 = 0, l4.abrupt("return", new Promise(function(c4) {
                n2.forEach(function(h) {
                  h.then(function(p4) {
                    p4.errors.length && c4([p4]), e2 += 1, e2 === n2.length && c4([]);
                  });
                });
              }));
            case 2:
            case "end":
              return l4.stop();
          }
      }, i);
    })), wse.apply(this, arguments);
  }
  var OTt = ["name"], wy = [];
  function tIe(i, n2, e2, o, l4, c4) {
    return typeof i == "function" ? i(n2, e2, "source" in c4 ? { source: c4.source } : {}) : o !== l4;
  }
  var Gue = function(i) {
    Rue(e2, i);
    var n2 = Nue(e2);
    function e2(o) {
      var l4;
      if (a9(this, e2), l4 = n2.call(this, o), l4.state = { resetCount: 0 }, l4.cancelRegisterFunc = null, l4.mounted = false, l4.touched = false, l4.dirty = false, l4.validatePromise = null, l4.prevValidating = void 0, l4.errors = wy, l4.warnings = wy, l4.cancelRegister = function() {
        var g4 = l4.props, y4 = g4.preserve, _ = g4.isListField, w4 = g4.name;
        l4.cancelRegisterFunc && l4.cancelRegisterFunc(_, y4, gh(w4)), l4.cancelRegisterFunc = null;
      }, l4.getNamePath = function() {
        var g4 = l4.props, y4 = g4.name, _ = g4.fieldContext, w4 = _.prefixName, C = w4 === void 0 ? [] : w4;
        return y4 !== void 0 ? [].concat(_l(C), _l(y4)) : [];
      }, l4.getRules = function() {
        var g4 = l4.props, y4 = g4.rules, _ = y4 === void 0 ? [] : y4, w4 = g4.fieldContext;
        return _.map(function(C) {
          return typeof C == "function" ? C(w4) : C;
        });
      }, l4.refresh = function() {
        !l4.mounted || l4.setState(function(g4) {
          var y4 = g4.resetCount;
          return { resetCount: y4 + 1 };
        });
      }, l4.triggerMetaEvent = function(g4) {
        var y4 = l4.props.onMetaChange;
        y4 == null || y4(Yo(Yo({}, l4.getMeta()), {}, { destroy: g4 }));
      }, l4.onStoreChange = function(g4, y4, _) {
        var w4 = l4.props, C = w4.shouldUpdate, E = w4.dependencies, T = E === void 0 ? [] : E, O = w4.onReset, N = _.store, V = l4.getNamePath(), H = l4.getValue(g4), X = l4.getValue(N), q2 = y4 && r8(y4, V);
        switch (_.type === "valueUpdate" && _.source === "external" && H !== X && (l4.touched = true, l4.dirty = true, l4.validatePromise = null, l4.errors = wy, l4.warnings = wy, l4.triggerMetaEvent()), _.type) {
          case "reset":
            if (!y4 || q2) {
              l4.touched = false, l4.dirty = false, l4.validatePromise = null, l4.errors = wy, l4.warnings = wy, l4.triggerMetaEvent(), O == null || O(), l4.refresh();
              return;
            }
            break;
          case "remove": {
            if (C) {
              l4.reRender();
              return;
            }
            break;
          }
          case "setField": {
            if (q2) {
              var de = _.data;
              "touched" in de && (l4.touched = de.touched), "validating" in de && !("originRCField" in de) && (l4.validatePromise = de.validating ? Promise.resolve([]) : null), "errors" in de && (l4.errors = de.errors || wy), "warnings" in de && (l4.warnings = de.warnings || wy), l4.dirty = true, l4.triggerMetaEvent(), l4.reRender();
              return;
            }
            if (C && !V.length && tIe(C, g4, N, H, X, _)) {
              l4.reRender();
              return;
            }
            break;
          }
          case "dependenciesUpdate": {
            var le = T.map(gh);
            if (le.some(function(me) {
              return r8(_.relatedFields, me);
            })) {
              l4.reRender();
              return;
            }
            break;
          }
          default:
            if (q2 || (!T.length || V.length || C) && tIe(C, g4, N, H, X, _)) {
              l4.reRender();
              return;
            }
            break;
        }
        C === true && l4.reRender();
      }, l4.validateRules = function(g4) {
        var y4 = l4.getNamePath(), _ = l4.getValue(), w4 = Promise.resolve().then(function() {
          if (!l4.mounted)
            return [];
          var C = l4.props, E = C.validateFirst, T = E === void 0 ? false : E, O = C.messageVariables, N = g4 || {}, V = N.triggerName, H = l4.getRules();
          V && (H = H.filter(function(q2) {
            var de = q2.validateTrigger;
            if (!de)
              return true;
            var le = dse(de);
            return le.includes(V);
          }));
          var X = kTt(y4, _, H, g4, T, O);
          return X.catch(function(q2) {
            return q2;
          }).then(function() {
            var q2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : wy;
            if (l4.validatePromise === w4) {
              l4.validatePromise = null;
              var de = [], le = [];
              q2.forEach(function(me) {
                var ye = me.rule.warningOnly, be = me.errors, we = be === void 0 ? wy : be;
                ye ? le.push.apply(le, _l(we)) : de.push.apply(de, _l(we));
              }), l4.errors = de, l4.warnings = le, l4.triggerMetaEvent(), l4.reRender();
            }
          }), X;
        });
        return l4.validatePromise = w4, l4.dirty = true, l4.errors = wy, l4.warnings = wy, l4.triggerMetaEvent(), l4.reRender(), w4;
      }, l4.isFieldValidating = function() {
        return !!l4.validatePromise;
      }, l4.isFieldTouched = function() {
        return l4.touched;
      }, l4.isFieldDirty = function() {
        if (l4.dirty || l4.props.initialValue !== void 0)
          return true;
        var g4 = l4.props.fieldContext, y4 = g4.getInternalHooks(C3), _ = y4.getInitialValue;
        return _(l4.getNamePath()) !== void 0;
      }, l4.getErrors = function() {
        return l4.errors;
      }, l4.getWarnings = function() {
        return l4.warnings;
      }, l4.isListField = function() {
        return l4.props.isListField;
      }, l4.isList = function() {
        return l4.props.isList;
      }, l4.isPreserve = function() {
        return l4.props.preserve;
      }, l4.getMeta = function() {
        l4.prevValidating = l4.isFieldValidating();
        var g4 = { touched: l4.isFieldTouched(), validating: l4.prevValidating, errors: l4.errors, warnings: l4.warnings, name: l4.getNamePath() };
        return g4;
      }, l4.getOnlyChild = function(g4) {
        if (typeof g4 == "function") {
          var y4 = l4.getMeta();
          return Yo(Yo({}, l4.getOnlyChild(g4(l4.getControlled(), y4, l4.props.fieldContext))), {}, { isFunction: true });
        }
        var _ = hse(g4);
        return _.length !== 1 || !Qr.isValidElement(_[0]) ? { child: _, isFunction: false } : { child: _[0], isFunction: false };
      }, l4.getValue = function(g4) {
        var y4 = l4.props.fieldContext.getFieldsValue, _ = l4.getNamePath();
        return M3(g4 || y4(true), _);
      }, l4.getControlled = function() {
        var g4 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, y4 = l4.props, _ = y4.trigger, w4 = y4.validateTrigger, C = y4.getValueFromEvent, E = y4.normalize, T = y4.valuePropName, O = y4.getValueProps, N = y4.fieldContext, V = w4 !== void 0 ? w4 : N.validateTrigger, H = l4.getNamePath(), X = N.getInternalHooks, q2 = N.getFieldsValue, de = X(C3), le = de.dispatch, me = l4.getValue(), ye = O || function(ze) {
          return pu({}, T, ze);
        }, be = g4[_], we = Yo(Yo({}, g4), ye(me));
        we[_] = function() {
          l4.touched = true, l4.dirty = true, l4.triggerMetaEvent();
          for (var ze, Re = arguments.length, rt2 = new Array(Re), ft = 0; ft < Re; ft++)
            rt2[ft] = arguments[ft];
          C ? ze = C.apply(void 0, rt2) : ze = ITt.apply(void 0, [T].concat(rt2)), E && (ze = E(ze, me, q2(true))), le({ type: "updateValue", namePath: H, value: ze }), be && be.apply(void 0, rt2);
        };
        var Pe = dse(V || []);
        return Pe.forEach(function(ze) {
          var Re = we[ze];
          we[ze] = function() {
            Re && Re.apply(void 0, arguments);
            var rt2 = l4.props.rules;
            rt2 && rt2.length && le({ type: "validateField", namePath: H, triggerName: ze });
          };
        }), we;
      }, o.fieldContext) {
        var c4 = o.fieldContext.getInternalHooks, h = c4(C3), p4 = h.initEntityValue;
        p4(Fue(l4));
      }
      return l4;
    }
    return i9(e2, [{ key: "componentDidMount", value: function() {
      var l4 = this.props, c4 = l4.shouldUpdate, h = l4.fieldContext;
      if (this.mounted = true, h) {
        var p4 = h.getInternalHooks, g4 = p4(C3), y4 = g4.registerField;
        this.cancelRegisterFunc = y4(this);
      }
      c4 === true && this.reRender();
    } }, { key: "componentWillUnmount", value: function() {
      this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
    } }, { key: "reRender", value: function() {
      !this.mounted || this.forceUpdate();
    } }, { key: "render", value: function() {
      var l4 = this.state.resetCount, c4 = this.props.children, h = this.getOnlyChild(c4), p4 = h.child, g4 = h.isFunction, y4;
      return g4 ? y4 = p4 : Qr.isValidElement(p4) ? y4 = Qr.cloneElement(p4, this.getControlled(p4.props)) : (U_(!p4, "`children` of Field is not validate ReactElement."), y4 = p4), Qr.createElement(Qr.Fragment, { key: l4 }, y4);
    } }]), e2;
  }(Qr.Component);
  Gue.contextType = L8;
  Gue.defaultProps = { trigger: "onChange", valuePropName: "value" };
  function GLe(i) {
    var n2 = i.name, e2 = aL(i, OTt), o = Qr.useContext(L8), l4 = n2 !== void 0 ? gh(n2) : void 0, c4 = "keep";
    return e2.isListField || (c4 = "_".concat((l4 || []).join("_"))), Qr.createElement(Gue, mh({ key: c4, name: l4 }, e2, { fieldContext: o }));
  }
  var RTt = Qr.createContext(null), FTt = function(n2) {
    var e2 = n2.name, o = n2.initialValue, l4 = n2.children, c4 = n2.rules, h = n2.validateTrigger, p4 = Qr.useContext(L8), g4 = Qr.useRef({ keys: [], id: 0 }), y4 = g4.current, _ = Qr.useMemo(function() {
      var T = gh(p4.prefixName) || [];
      return [].concat(_l(T), _l(gh(e2)));
    }, [p4.prefixName, e2]), w4 = Qr.useMemo(function() {
      return Yo(Yo({}, p4), {}, { prefixName: _ });
    }, [p4, _]), C = Qr.useMemo(function() {
      return { getKey: function(O) {
        var N = _.length, V = O[N];
        return [y4.keys[V], O.slice(N + 1)];
      } };
    }, [_]);
    if (typeof l4 != "function")
      return U_(false, "Form.List only accepts function as children."), null;
    var E = function(O, N, V) {
      var H = V.source;
      return H === "internal" ? false : O !== N;
    };
    return Qr.createElement(RTt.Provider, { value: C }, Qr.createElement(L8.Provider, { value: w4 }, Qr.createElement(GLe, { name: [], shouldUpdate: E, rules: c4, validateTrigger: h, initialValue: o, isList: true }, function(T, O) {
      var N = T.value, V = N === void 0 ? [] : N, H = T.onChange, X = p4.getFieldValue, q2 = function() {
        var ye = X(_ || []);
        return ye || [];
      }, de = { add: function(ye, be) {
        var we = q2();
        be >= 0 && be <= we.length ? (y4.keys = [].concat(_l(y4.keys.slice(0, be)), [y4.id], _l(y4.keys.slice(be))), H([].concat(_l(we.slice(0, be)), [ye], _l(we.slice(be))))) : (y4.keys = [].concat(_l(y4.keys), [y4.id]), H([].concat(_l(we), [ye]))), y4.id += 1;
      }, remove: function(ye) {
        var be = q2(), we = new Set(Array.isArray(ye) ? ye : [ye]);
        we.size <= 0 || (y4.keys = y4.keys.filter(function(Pe, ze) {
          return !we.has(ze);
        }), H(be.filter(function(Pe, ze) {
          return !we.has(ze);
        })));
      }, move: function(ye, be) {
        if (ye !== be) {
          var we = q2();
          ye < 0 || ye >= we.length || be < 0 || be >= we.length || (y4.keys = eIe(y4.keys, ye, be), H(eIe(we, ye, be)));
        }
      } }, le = V || [];
      return Array.isArray(le) || (le = []), l4(le.map(function(me, ye) {
        var be = y4.keys[ye];
        return be === void 0 && (y4.keys[ye] = y4.id, be = y4.keys[ye], y4.id += 1), { name: ye, key: be, isListField: true };
      }), de, O);
    })));
  };
  function NTt(i) {
    var n2 = false, e2 = i.length, o = [];
    return i.length ? new Promise(function(l4, c4) {
      i.forEach(function(h, p4) {
        h.catch(function(g4) {
          return n2 = true, g4;
        }).then(function(g4) {
          e2 -= 1, o[p4] = g4, !(e2 > 0) && (n2 && c4(o), l4(o));
        });
      });
    }) : Promise.resolve([]);
  }
  var WLe = "__@field_split__";
  function yie(i) {
    return i.map(function(n2) {
      return "".concat(pv(n2), ":").concat(n2);
    }).join(WLe);
  }
  var CN = function() {
    function i() {
      a9(this, i), this.kvs = /* @__PURE__ */ new Map();
    }
    return i9(i, [{ key: "set", value: function(e2, o) {
      this.kvs.set(yie(e2), o);
    } }, { key: "get", value: function(e2) {
      return this.kvs.get(yie(e2));
    } }, { key: "update", value: function(e2, o) {
      var l4 = this.get(e2), c4 = o(l4);
      c4 ? this.set(e2, c4) : this.delete(e2);
    } }, { key: "delete", value: function(e2) {
      this.kvs.delete(yie(e2));
    } }, { key: "map", value: function(e2) {
      return _l(this.kvs.entries()).map(function(o) {
        var l4 = Ry(o, 2), c4 = l4[0], h = l4[1], p4 = c4.split(WLe);
        return e2({ key: p4.map(function(g4) {
          var y4 = g4.match(/^([^:]*):(.*)$/), _ = Ry(y4, 3), w4 = _[1], C = _[2];
          return w4 === "number" ? Number(C) : C;
        }), value: h });
      });
    } }, { key: "toJSON", value: function() {
      var e2 = {};
      return this.map(function(o) {
        var l4 = o.key, c4 = o.value;
        return e2[l4.join(".")] = c4, null;
      }), e2;
    } }]), i;
  }(), VTt = ["name", "errors"], zTt = i9(function i(n2) {
    var e2 = this;
    a9(this, i), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
      return { getFieldValue: e2.getFieldValue, getFieldsValue: e2.getFieldsValue, getFieldError: e2.getFieldError, getFieldWarning: e2.getFieldWarning, getFieldsError: e2.getFieldsError, isFieldsTouched: e2.isFieldsTouched, isFieldTouched: e2.isFieldTouched, isFieldValidating: e2.isFieldValidating, isFieldsValidating: e2.isFieldsValidating, resetFields: e2.resetFields, setFields: e2.setFields, setFieldsValue: e2.setFieldsValue, validateFields: e2.validateFields, submit: e2.submit, getInternalHooks: e2.getInternalHooks };
    }, this.getInternalHooks = function(o) {
      return o === C3 ? (e2.formHooked = true, { dispatch: e2.dispatch, initEntityValue: e2.initEntityValue, registerField: e2.registerField, useSubscribe: e2.useSubscribe, setInitialValues: e2.setInitialValues, setCallbacks: e2.setCallbacks, setValidateMessages: e2.setValidateMessages, getFields: e2.getFields, setPreserve: e2.setPreserve, getInitialValue: e2.getInitialValue }) : (U_(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
    }, this.useSubscribe = function(o) {
      e2.subscribable = o;
    }, this.setInitialValues = function(o, l4) {
      e2.initialValues = o || {}, l4 && (e2.store = vH({}, o, e2.store));
    }, this.getInitialValue = function(o) {
      return M3(e2.initialValues, o);
    }, this.setCallbacks = function(o) {
      e2.callbacks = o;
    }, this.setValidateMessages = function(o) {
      e2.validateMessages = o;
    }, this.setPreserve = function(o) {
      e2.preserve = o;
    }, this.timeoutId = null, this.warningUnhooked = function() {
    }, this.getFieldEntities = function() {
      var o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
      return o ? e2.fieldEntities.filter(function(l4) {
        return l4.getNamePath().length;
      }) : e2.fieldEntities;
    }, this.getFieldsMap = function() {
      var o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, l4 = new CN();
      return e2.getFieldEntities(o).forEach(function(c4) {
        var h = c4.getNamePath();
        l4.set(h, c4);
      }), l4;
    }, this.getFieldEntitiesForNamePathList = function(o) {
      if (!o)
        return e2.getFieldEntities(true);
      var l4 = e2.getFieldsMap(true);
      return o.map(function(c4) {
        var h = gh(c4);
        return l4.get(h) || { INVALIDATE_NAME_PATH: gh(c4) };
      });
    }, this.getFieldsValue = function(o, l4) {
      if (e2.warningUnhooked(), o === true && !l4)
        return e2.store;
      var c4 = e2.getFieldEntitiesForNamePathList(Array.isArray(o) ? o : null), h = [];
      return c4.forEach(function(p4) {
        var g4, y4 = "INVALIDATE_NAME_PATH" in p4 ? p4.INVALIDATE_NAME_PATH : p4.getNamePath();
        if (!(!o && ((g4 = p4.isListField) === null || g4 === void 0 ? void 0 : g4.call(p4))))
          if (!l4)
            h.push(y4);
          else {
            var _ = "getMeta" in p4 ? p4.getMeta() : null;
            l4(_) && h.push(y4);
          }
      }), JEe(e2.store, h.map(gh));
    }, this.getFieldValue = function(o) {
      e2.warningUnhooked();
      var l4 = gh(o);
      return M3(e2.store, l4);
    }, this.getFieldsError = function(o) {
      e2.warningUnhooked();
      var l4 = e2.getFieldEntitiesForNamePathList(o);
      return l4.map(function(c4, h) {
        return c4 && !("INVALIDATE_NAME_PATH" in c4) ? { name: c4.getNamePath(), errors: c4.getErrors(), warnings: c4.getWarnings() } : { name: gh(o[h]), errors: [], warnings: [] };
      });
    }, this.getFieldError = function(o) {
      e2.warningUnhooked();
      var l4 = gh(o), c4 = e2.getFieldsError([l4])[0];
      return c4.errors;
    }, this.getFieldWarning = function(o) {
      e2.warningUnhooked();
      var l4 = gh(o), c4 = e2.getFieldsError([l4])[0];
      return c4.warnings;
    }, this.isFieldsTouched = function() {
      e2.warningUnhooked();
      for (var o = arguments.length, l4 = new Array(o), c4 = 0; c4 < o; c4++)
        l4[c4] = arguments[c4];
      var h = l4[0], p4 = l4[1], g4, y4 = false;
      l4.length === 0 ? g4 = null : l4.length === 1 ? Array.isArray(h) ? (g4 = h.map(gh), y4 = false) : (g4 = null, y4 = h) : (g4 = h.map(gh), y4 = p4);
      var _ = e2.getFieldEntities(true), w4 = function(N) {
        return N.isFieldTouched();
      };
      if (!g4)
        return y4 ? _.every(w4) : _.some(w4);
      var C = new CN();
      g4.forEach(function(O) {
        C.set(O, []);
      }), _.forEach(function(O) {
        var N = O.getNamePath();
        g4.forEach(function(V) {
          V.every(function(H, X) {
            return N[X] === H;
          }) && C.update(V, function(H) {
            return [].concat(_l(H), [O]);
          });
        });
      });
      var E = function(N) {
        return N.some(w4);
      }, T = C.map(function(O) {
        var N = O.value;
        return N;
      });
      return y4 ? T.every(E) : T.some(E);
    }, this.isFieldTouched = function(o) {
      return e2.warningUnhooked(), e2.isFieldsTouched([o]);
    }, this.isFieldsValidating = function(o) {
      e2.warningUnhooked();
      var l4 = e2.getFieldEntities();
      if (!o)
        return l4.some(function(h) {
          return h.isFieldValidating();
        });
      var c4 = o.map(gh);
      return l4.some(function(h) {
        var p4 = h.getNamePath();
        return r8(c4, p4) && h.isFieldValidating();
      });
    }, this.isFieldValidating = function(o) {
      return e2.warningUnhooked(), e2.isFieldsValidating([o]);
    }, this.resetWithFieldInitialValue = function() {
      var o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, l4 = new CN(), c4 = e2.getFieldEntities(true);
      c4.forEach(function(g4) {
        var y4 = g4.props.initialValue, _ = g4.getNamePath();
        if (y4 !== void 0) {
          var w4 = l4.get(_) || /* @__PURE__ */ new Set();
          w4.add({ entity: g4, value: y4 }), l4.set(_, w4);
        }
      });
      var h = function(y4) {
        y4.forEach(function(_) {
          var w4 = _.props.initialValue;
          if (w4 !== void 0) {
            var C = _.getNamePath(), E = e2.getInitialValue(C);
            if (E !== void 0)
              U_(false, "Form already set 'initialValues' with path '".concat(C.join("."), "'. Field can not overwrite it."));
            else {
              var T = l4.get(C);
              if (T && T.size > 1)
                U_(false, "Multiple Field with path '".concat(C.join("."), "' set 'initialValue'. Can not decide which one to pick."));
              else if (T) {
                var O = e2.getFieldValue(C);
                (!o.skipExist || O === void 0) && (e2.store = KI(e2.store, C, _l(T)[0].value));
              }
            }
          }
        });
      }, p4;
      o.entities ? p4 = o.entities : o.namePathList ? (p4 = [], o.namePathList.forEach(function(g4) {
        var y4 = l4.get(g4);
        if (y4) {
          var _;
          (_ = p4).push.apply(_, _l(_l(y4).map(function(w4) {
            return w4.entity;
          })));
        }
      })) : p4 = c4, h(p4);
    }, this.resetFields = function(o) {
      e2.warningUnhooked();
      var l4 = e2.store;
      if (!o) {
        e2.store = vH({}, e2.initialValues), e2.resetWithFieldInitialValue(), e2.notifyObservers(l4, null, { type: "reset" });
        return;
      }
      var c4 = o.map(gh);
      c4.forEach(function(h) {
        var p4 = e2.getInitialValue(h);
        e2.store = KI(e2.store, h, p4);
      }), e2.resetWithFieldInitialValue({ namePathList: c4 }), e2.notifyObservers(l4, c4, { type: "reset" });
    }, this.setFields = function(o) {
      e2.warningUnhooked();
      var l4 = e2.store;
      o.forEach(function(c4) {
        var h = c4.name;
        c4.errors;
        var p4 = aL(c4, VTt), g4 = gh(h);
        "value" in p4 && (e2.store = KI(e2.store, g4, p4.value)), e2.notifyObservers(l4, [g4], { type: "setField", data: c4 });
      });
    }, this.getFields = function() {
      var o = e2.getFieldEntities(true), l4 = o.map(function(c4) {
        var h = c4.getNamePath(), p4 = c4.getMeta(), g4 = Yo(Yo({}, p4), {}, { name: h, value: e2.getFieldValue(h) });
        return Object.defineProperty(g4, "originRCField", { value: true }), g4;
      });
      return l4;
    }, this.initEntityValue = function(o) {
      var l4 = o.props.initialValue;
      if (l4 !== void 0) {
        var c4 = o.getNamePath(), h = M3(e2.store, c4);
        h === void 0 && (e2.store = KI(e2.store, c4, l4));
      }
    }, this.registerField = function(o) {
      if (e2.fieldEntities.push(o), o.props.initialValue !== void 0) {
        var l4 = e2.store;
        e2.resetWithFieldInitialValue({ entities: [o], skipExist: true }), e2.notifyObservers(l4, [o.getNamePath()], { type: "valueUpdate", source: "internal" });
      }
      return function(c4, h) {
        var p4 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
        e2.fieldEntities = e2.fieldEntities.filter(function(C) {
          return C !== o;
        });
        var g4 = h !== void 0 ? h : e2.preserve;
        if (g4 === false && (!c4 || p4.length > 1)) {
          var y4 = o.getNamePath(), _ = c4 ? void 0 : M3(e2.initialValues, y4);
          if (y4.length && e2.getFieldValue(y4) !== _ && e2.fieldEntities.every(function(C) {
            return !jLe(C.getNamePath(), y4);
          })) {
            var w4 = e2.store;
            e2.store = KI(w4, y4, _, true), e2.notifyObservers(w4, [y4], { type: "remove" }), e2.triggerDependenciesUpdate(w4, y4);
          }
        }
      };
    }, this.dispatch = function(o) {
      switch (o.type) {
        case "updateValue": {
          var l4 = o.namePath, c4 = o.value;
          e2.updateValue(l4, c4);
          break;
        }
        case "validateField": {
          var h = o.namePath, p4 = o.triggerName;
          e2.validateFields([h], { triggerName: p4 });
          break;
        }
      }
    }, this.notifyObservers = function(o, l4, c4) {
      if (e2.subscribable) {
        var h = Yo(Yo({}, c4), {}, { store: e2.getFieldsValue(true) });
        e2.getFieldEntities().forEach(function(p4) {
          var g4 = p4.onStoreChange;
          g4(o, l4, h);
        });
      } else
        e2.forceRootUpdate();
    }, this.triggerDependenciesUpdate = function(o, l4) {
      var c4 = e2.getDependencyChildrenFields(l4);
      return c4.length && e2.validateFields(c4), e2.notifyObservers(o, c4, { type: "dependenciesUpdate", relatedFields: [l4].concat(_l(c4)) }), c4;
    }, this.updateValue = function(o, l4) {
      var c4 = gh(o), h = e2.store;
      e2.store = KI(e2.store, c4, l4), e2.notifyObservers(h, [c4], { type: "valueUpdate", source: "internal" });
      var p4 = e2.triggerDependenciesUpdate(h, c4), g4 = e2.callbacks.onValuesChange;
      if (g4) {
        var y4 = JEe(e2.store, [c4]);
        g4(y4, e2.getFieldsValue());
      }
      e2.triggerOnFieldsChange([c4].concat(_l(p4)));
    }, this.setFieldsValue = function(o) {
      e2.warningUnhooked();
      var l4 = e2.store;
      o && (e2.store = vH(e2.store, o)), e2.notifyObservers(l4, null, { type: "valueUpdate", source: "external" });
    }, this.getDependencyChildrenFields = function(o) {
      var l4 = /* @__PURE__ */ new Set(), c4 = [], h = new CN();
      e2.getFieldEntities().forEach(function(g4) {
        var y4 = g4.props.dependencies;
        (y4 || []).forEach(function(_) {
          var w4 = gh(_);
          h.update(w4, function() {
            var C = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
            return C.add(g4), C;
          });
        });
      });
      var p4 = function g4(y4) {
        var _ = h.get(y4) || /* @__PURE__ */ new Set();
        _.forEach(function(w4) {
          if (!l4.has(w4)) {
            l4.add(w4);
            var C = w4.getNamePath();
            w4.isFieldDirty() && C.length && (c4.push(C), g4(C));
          }
        });
      };
      return p4(o), c4;
    }, this.triggerOnFieldsChange = function(o, l4) {
      var c4 = e2.callbacks.onFieldsChange;
      if (c4) {
        var h = e2.getFields();
        if (l4) {
          var p4 = new CN();
          l4.forEach(function(y4) {
            var _ = y4.name, w4 = y4.errors;
            p4.set(_, w4);
          }), h.forEach(function(y4) {
            y4.errors = p4.get(y4.name) || y4.errors;
          });
        }
        var g4 = h.filter(function(y4) {
          var _ = y4.name;
          return r8(o, _);
        });
        c4(g4, h);
      }
    }, this.validateFields = function(o, l4) {
      e2.warningUnhooked();
      var c4 = !!o, h = c4 ? o.map(gh) : [], p4 = [];
      e2.getFieldEntities(true).forEach(function(_) {
        if (c4 || h.push(_.getNamePath()), (l4 == null ? void 0 : l4.recursive) && c4) {
          var w4 = _.getNamePath();
          w4.every(function(T, O) {
            return o[O] === T || o[O] === void 0;
          }) && h.push(w4);
        }
        if (!(!_.props.rules || !_.props.rules.length)) {
          var C = _.getNamePath();
          if (!c4 || r8(h, C)) {
            var E = _.validateRules(Yo({ validateMessages: Yo(Yo({}, NLe), e2.validateMessages) }, l4));
            p4.push(E.then(function() {
              return { name: C, errors: [], warnings: [] };
            }).catch(function(T) {
              var O = [], N = [];
              return T.forEach(function(V) {
                var H = V.rule.warningOnly, X = V.errors;
                H ? N.push.apply(N, _l(X)) : O.push.apply(O, _l(X));
              }), O.length ? Promise.reject({ name: C, errors: O, warnings: N }) : { name: C, errors: O, warnings: N };
            }));
          }
        }
      });
      var g4 = NTt(p4);
      e2.lastValidatePromise = g4, g4.catch(function(_) {
        return _;
      }).then(function(_) {
        var w4 = _.map(function(C) {
          var E = C.name;
          return E;
        });
        e2.notifyObservers(e2.store, w4, { type: "validateFinish" }), e2.triggerOnFieldsChange(w4, _);
      });
      var y4 = g4.then(function() {
        return e2.lastValidatePromise === g4 ? Promise.resolve(e2.getFieldsValue(h)) : Promise.reject([]);
      }).catch(function(_) {
        var w4 = _.filter(function(C) {
          return C && C.errors.length;
        });
        return Promise.reject({ values: e2.getFieldsValue(h), errorFields: w4, outOfDate: e2.lastValidatePromise !== g4 });
      });
      return y4.catch(function(_) {
        return _;
      }), y4;
    }, this.submit = function() {
      e2.warningUnhooked(), e2.validateFields().then(function(o) {
        var l4 = e2.callbacks.onFinish;
        if (l4)
          try {
            l4(o);
          } catch (c4) {
            console.error(c4);
          }
      }).catch(function(o) {
        var l4 = e2.callbacks.onFinishFailed;
        l4 && l4(o);
      });
    }, this.forceRootUpdate = n2;
  });
  function HLe(i) {
    var n2 = Qr.useRef(), e2 = Qr.useState({}), o = Ry(e2, 2), l4 = o[1];
    if (!n2.current)
      if (i)
        n2.current = i;
      else {
        var c4 = function() {
          l4({});
        }, h = new zTt(c4);
        n2.current = h.getForm();
      }
    return [n2.current];
  }
  var Sse = Qr.createContext({ triggerFormChange: function() {
  }, triggerFormFinish: function() {
  }, registerForm: function() {
  }, unregisterForm: function() {
  } }), BTt = function(n2) {
    var e2 = n2.validateMessages, o = n2.onFormChange, l4 = n2.onFormFinish, c4 = n2.children, h = Qr.useContext(Sse), p4 = Qr.useRef({});
    return Qr.createElement(Sse.Provider, { value: Yo(Yo({}, h), {}, { validateMessages: Yo(Yo({}, h.validateMessages), e2), triggerFormChange: function(y4, _) {
      o && o(y4, { changedFields: _, forms: p4.current }), h.triggerFormChange(y4, _);
    }, triggerFormFinish: function(y4, _) {
      l4 && l4(y4, { values: _, forms: p4.current }), h.triggerFormFinish(y4, _);
    }, registerForm: function(y4, _) {
      y4 && (p4.current = Yo(Yo({}, p4.current), {}, pu({}, y4, _))), h.registerForm(y4, _);
    }, unregisterForm: function(y4) {
      var _ = Yo({}, p4.current);
      delete _[y4], p4.current = _, h.unregisterForm(y4);
    } }) }, c4);
  }, jTt = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], GTt = function(n2, e2) {
    var o = n2.name, l4 = n2.initialValues, c4 = n2.fields, h = n2.form, p4 = n2.preserve, g4 = n2.children, y4 = n2.component, _ = y4 === void 0 ? "form" : y4, w4 = n2.validateMessages, C = n2.validateTrigger, E = C === void 0 ? "onChange" : C, T = n2.onValuesChange, O = n2.onFieldsChange, N = n2.onFinish, V = n2.onFinishFailed, H = aL(n2, jTt), X = Qr.useContext(Sse), q2 = HLe(h), de = Ry(q2, 1), le = de[0], me = le.getInternalHooks(C3), ye = me.useSubscribe, be = me.setInitialValues, we = me.setCallbacks, Pe = me.setValidateMessages, ze = me.setPreserve;
    Qr.useImperativeHandle(e2, function() {
      return le;
    }), Qr.useEffect(function() {
      return X.registerForm(o, le), function() {
        X.unregisterForm(o);
      };
    }, [X, le, o]), Pe(Yo(Yo({}, X.validateMessages), w4)), we({ onValuesChange: T, onFieldsChange: function(sn) {
      if (X.triggerFormChange(o, sn), O) {
        for (var vn = arguments.length, $r = new Array(vn > 1 ? vn - 1 : 0), ga = 1; ga < vn; ga++)
          $r[ga - 1] = arguments[ga];
        O.apply(void 0, [sn].concat($r));
      }
    }, onFinish: function(sn) {
      X.triggerFormFinish(o, sn), N && N(sn);
    }, onFinishFailed: V }), ze(p4);
    var Re = Qr.useRef(null);
    be(l4, !Re.current), Re.current || (Re.current = true);
    var rt2 = g4, ft = typeof g4 == "function";
    if (ft) {
      var et = le.getFieldsValue(true);
      rt2 = g4(et, le);
    }
    ye(!ft);
    var Jt = Qr.useRef();
    Qr.useEffect(function() {
      ETt(Jt.current || [], c4 || []) || le.setFields(c4 || []), Jt.current = c4;
    }, [c4, le]);
    var xt = Qr.useMemo(function() {
      return Yo(Yo({}, le), {}, { validateTrigger: E });
    }, [le, E]), It = Qr.createElement(L8.Provider, { value: xt }, rt2);
    return _ === false ? It : Qr.createElement(_, mh({}, H, { onSubmit: function(sn) {
      sn.preventDefault(), sn.stopPropagation(), le.submit();
    }, onReset: function(sn) {
      var vn;
      sn.preventDefault(), le.resetFields(), (vn = H.onReset) === null || vn === void 0 || vn.call(H, sn);
    } }), It);
  }, WTt = Qr.forwardRef(GTt), vU = WTt;
  vU.FormProvider = BTt;
  vU.Field = GLe;
  vU.List = FTt;
  vU.useForm = HLe;
  var HTt = function(i, n2, e2) {
    U_(i, "[antd: ".concat(n2, "] ").concat(e2));
  }, $Tt = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, UTt = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, qTt = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, $Le = qTt, YTt = { lang: mh({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, UTt), timePickerLocale: mh({}, $Le) }, nIe = YTt, K0 = "${label} is not a valid ${type}", ZTt = { locale: "en", Pagination: $Tt, DatePicker: nIe, TimePicker: $Le, Calendar: nIe, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: K0, method: K0, array: K0, object: K0, number: K0, date: K0, boolean: K0, integer: K0, float: K0, regexp: K0, email: K0, url: K0, hex: K0 }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, rIe = ZTt, XTt = il.createContext(void 0), KTt = XTt, Wue = function(i) {
    Rue(e2, i);
    var n2 = Nue(e2);
    function e2() {
      return a9(this, e2), n2.apply(this, arguments);
    }
    return i9(e2, [{ key: "getLocale", value: function() {
      var l4 = this.props, c4 = l4.componentName, h = l4.defaultLocale, p4 = h || rIe[c4 != null ? c4 : "global"], g4 = this.context, y4 = c4 && g4 ? g4[c4] : {};
      return mh(mh({}, p4 instanceof Function ? p4() : p4), y4 || {});
    } }, { key: "getLocaleCode", value: function() {
      var l4 = this.context, c4 = l4 && l4.locale;
      return l4 && l4.exist && !c4 ? rIe.locale : c4;
    } }, { key: "render", value: function() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    } }]), e2;
  }(Qr.Component);
  Wue.defaultProps = { componentName: "global" };
  Wue.contextType = KTt;
  var JTt = function() {
    var n2 = Qr.useContext(lM), e2 = n2.getPrefixCls, o = e2("empty-img-default");
    return Qr.createElement("svg", { className: o, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, Qr.createElement("g", { fill: "none", fillRule: "evenodd" }, Qr.createElement("g", { transform: "translate(24 31.67)" }, Qr.createElement("ellipse", { className: "".concat(o, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), Qr.createElement("path", { className: "".concat(o, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), Qr.createElement("path", { className: "".concat(o, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), Qr.createElement("path", { className: "".concat(o, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), Qr.createElement("path", { className: "".concat(o, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), Qr.createElement("path", { className: "".concat(o, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), Qr.createElement("g", { className: "".concat(o, "-g"), transform: "translate(149.65 15.383)" }, Qr.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), Qr.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
  }, QTt = JTt, eDt = function() {
    var n2 = Qr.useContext(lM), e2 = n2.getPrefixCls, o = e2("empty-img-simple");
    return Qr.createElement("svg", { className: o, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, Qr.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, Qr.createElement("ellipse", { className: "".concat(o, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), Qr.createElement("g", { className: "".concat(o, "-g"), fillRule: "nonzero" }, Qr.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), Qr.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(o, "-path") }))));
  }, tDt = eDt, nDt = globalThis && globalThis.__rest || function(i, n2) {
    var e2 = {};
    for (var o in i)
      Object.prototype.hasOwnProperty.call(i, o) && n2.indexOf(o) < 0 && (e2[o] = i[o]);
    if (i != null && typeof Object.getOwnPropertySymbols == "function")
      for (var l4 = 0, o = Object.getOwnPropertySymbols(i); l4 < o.length; l4++)
        n2.indexOf(o[l4]) < 0 && Object.prototype.propertyIsEnumerable.call(i, o[l4]) && (e2[o[l4]] = i[o[l4]]);
    return e2;
  }, ULe = Qr.createElement(QTt, null), qLe = Qr.createElement(tDt, null), Hue = function(n2) {
    var e2 = n2.className, o = n2.prefixCls, l4 = n2.image, c4 = l4 === void 0 ? ULe : l4, h = n2.description, p4 = n2.children, g4 = n2.imageStyle, y4 = nDt(n2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), _ = Qr.useContext(lM), w4 = _.getPrefixCls, C = _.direction;
    return Qr.createElement(Wue, { componentName: "Empty" }, function(E) {
      var T, O = w4("empty", o), N = typeof h != "undefined" ? h : E.description, V = typeof N == "string" ? N : "empty", H = null;
      return typeof c4 == "string" ? H = Qr.createElement("img", { alt: V, src: c4 }) : H = c4, Qr.createElement("div", mh({ className: iL(O, (T = {}, pu(T, "".concat(O, "-normal"), c4 === qLe), pu(T, "".concat(O, "-rtl"), C === "rtl"), T), e2) }, y4), Qr.createElement("div", { className: "".concat(O, "-image"), style: g4 }, H), N && Qr.createElement("div", { className: "".concat(O, "-description") }, N), p4 && Qr.createElement("div", { className: "".concat(O, "-footer") }, p4));
    });
  };
  Hue.PRESENTED_IMAGE_DEFAULT = ULe;
  Hue.PRESENTED_IMAGE_SIMPLE = qLe;
  var MN = Hue, rDt = function(n2) {
    return Qr.createElement(YLe, null, function(e2) {
      var o = e2.getPrefixCls, l4 = o("empty");
      switch (n2) {
        case "Table":
        case "List":
          return Qr.createElement(MN, { image: MN.PRESENTED_IMAGE_SIMPLE });
        case "Select":
        case "TreeSelect":
        case "Cascader":
        case "Transfer":
        case "Mentions":
          return Qr.createElement(MN, { image: MN.PRESENTED_IMAGE_SIMPLE, className: "".concat(l4, "-small") });
        default:
          return Qr.createElement(MN, null);
      }
    });
  }, aDt = rDt, iDt = function(n2, e2) {
    return e2 || (n2 ? "ant-".concat(n2) : "ant");
  }, lM = Qr.createContext({ getPrefixCls: iDt, renderEmpty: aDt }), YLe = lM.Consumer, oDt = Qr.createContext(void 0), sDt = oDt, ZLe = function(n2) {
    return +setTimeout(n2, 16);
  }, XLe = function(n2) {
    return clearTimeout(n2);
  };
  typeof window != "undefined" && "requestAnimationFrame" in window && (ZLe = function(n2) {
    return window.requestAnimationFrame(n2);
  }, XLe = function(n2) {
    return window.cancelAnimationFrame(n2);
  });
  var aIe = 0, $ue = /* @__PURE__ */ new Map();
  function KLe(i) {
    $ue.delete(i);
  }
  function d$(i) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    aIe += 1;
    var e2 = aIe;
    function o(l4) {
      if (l4 === 0)
        KLe(e2), i();
      else {
        var c4 = ZLe(function() {
          o(l4 - 1);
        });
        $ue.set(e2, c4);
      }
    }
    return o(n2), e2;
  }
  d$.cancel = function(i) {
    var n2 = $ue.get(i);
    return KLe(n2), XLe(n2);
  };
  function lDt(i, n2) {
    var e2 = n2 || {}, o = e2.defaultValue, l4 = e2.value, c4 = e2.onChange, h = e2.postState, p4 = Qr.useState(function() {
      return l4 !== void 0 ? l4 : o !== void 0 ? typeof o == "function" ? o() : o : typeof i == "function" ? i() : i;
    }), g4 = Ry(p4, 2), y4 = g4[0], _ = g4[1], w4 = l4 !== void 0 ? l4 : y4;
    h && (w4 = h(w4));
    var C = Qr.useRef(c4);
    C.current = c4;
    var E = Qr.useCallback(function(O) {
      _(O), w4 !== O && C.current && C.current(O, w4);
    }, [w4, C]), T = Qr.useRef(true);
    return Qr.useEffect(function() {
      if (T.current) {
        T.current = false;
        return;
      }
      l4 === void 0 && _(l4);
    }, [l4]), [w4, E];
  }
  var vo = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(n2) {
    var e2 = n2.keyCode;
    if (n2.altKey && !n2.ctrlKey || n2.metaKey || e2 >= vo.F1 && e2 <= vo.F12)
      return false;
    switch (e2) {
      case vo.ALT:
      case vo.CAPS_LOCK:
      case vo.CONTEXT_MENU:
      case vo.CTRL:
      case vo.DOWN:
      case vo.END:
      case vo.ESC:
      case vo.HOME:
      case vo.INSERT:
      case vo.LEFT:
      case vo.MAC_FF_META:
      case vo.META:
      case vo.NUMLOCK:
      case vo.NUM_CENTER:
      case vo.PAGE_DOWN:
      case vo.PAGE_UP:
      case vo.PAUSE:
      case vo.PRINT_SCREEN:
      case vo.RIGHT:
      case vo.SHIFT:
      case vo.UP:
      case vo.WIN_KEY:
      case vo.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  }, isCharacterKey: function(n2) {
    if (n2 >= vo.ZERO && n2 <= vo.NINE || n2 >= vo.NUM_ZERO && n2 <= vo.NUM_MULTIPLY || n2 >= vo.A && n2 <= vo.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && n2 === 0)
      return true;
    switch (n2) {
      case vo.SPACE:
      case vo.QUESTION_MARK:
      case vo.NUM_PLUS:
      case vo.NUM_MINUS:
      case vo.NUM_PERIOD:
      case vo.NUM_DIVISION:
      case vo.SEMICOLON:
      case vo.DASH:
      case vo.EQUALS:
      case vo.COMMA:
      case vo.PERIOD:
      case vo.SLASH:
      case vo.APOSTROPHE:
      case vo.SINGLE_QUOTE:
      case vo.OPEN_SQUARE_BRACKET:
      case vo.BACKSLASH:
      case vo.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  } }, JLe = function() {
    for (var n2 = arguments.length, e2 = new Array(n2), o = 0; o < n2; o++)
      e2[o] = arguments[o];
    return e2;
  }, uDt = Qr.isValidElement;
  function cDt(i, n2, e2) {
    return uDt(i) ? Qr.cloneElement(i, typeof e2 == "function" ? e2(i.props || {}) : e2) : n2;
  }
  function fDt(i, n2) {
    return cDt(i, i, n2);
  }
  var iIe = ["xxl", "xl", "lg", "md", "sm", "xs"], $W = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, WI = /* @__PURE__ */ new Map(), bie = -1, UW = {}, hDt = { matchHandlers: {}, dispatch: function(n2) {
    return UW = n2, WI.forEach(function(e2) {
      return e2(UW);
    }), WI.size >= 1;
  }, subscribe: function(n2) {
    return WI.size || this.register(), bie += 1, WI.set(bie, n2), n2(UW), bie;
  }, unsubscribe: function(n2) {
    WI.delete(n2), WI.size || this.unregister();
  }, unregister: function() {
    var n2 = this;
    Object.keys($W).forEach(function(e2) {
      var o = $W[e2], l4 = n2.matchHandlers[o];
      l4 == null || l4.mql.removeListener(l4 == null ? void 0 : l4.listener);
    }), WI.clear();
  }, register: function() {
    var n2 = this;
    Object.keys($W).forEach(function(e2) {
      var o = $W[e2], l4 = function(p4) {
        var g4 = p4.matches;
        n2.dispatch(mh(mh({}, UW), pu({}, e2, g4)));
      }, c4 = window.matchMedia(o);
      c4.addListener(l4), n2.matchHandlers[o] = { mql: c4, listener: l4 }, l4(c4);
    });
  } }, oIe = hDt, dDt = 0, k3 = {};
  function p$(i) {
    var n2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, e2 = dDt++, o = n2;
    function l4() {
      o -= 1, o <= 0 ? (i(), delete k3[e2]) : k3[e2] = d$(l4);
    }
    return k3[e2] = d$(l4), e2;
  }
  p$.cancel = function(n2) {
    n2 !== void 0 && (d$.cancel(k3[n2]), delete k3[n2]);
  };
  p$.ids = k3;
  var _ie;
  function sIe(i) {
    return !i || i.offsetParent === null || i.hidden;
  }
  function pDt(i) {
    var n2 = (i || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
    return n2 && n2[1] && n2[2] && n2[3] ? !(n2[1] === n2[2] && n2[2] === n2[3]) : true;
  }
  var QLe = function(i) {
    Rue(e2, i);
    var n2 = Nue(e2);
    function e2() {
      var o;
      return a9(this, e2), o = n2.apply(this, arguments), o.containerRef = Qr.createRef(), o.animationStart = false, o.destroyed = false, o.onClick = function(l4, c4) {
        var h, p4, g4 = o.props, y4 = g4.insertExtraNode, _ = g4.disabled;
        if (!(_ || !l4 || sIe(l4) || l4.className.indexOf("-leave") >= 0)) {
          o.extraNode = document.createElement("div");
          var w4 = Fue(o), C = w4.extraNode, E = o.context.getPrefixCls;
          C.className = "".concat(E(""), "-click-animating-node");
          var T = o.getAttributeName();
          if (l4.setAttribute(T, "true"), c4 && c4 !== "#ffffff" && c4 !== "rgb(255, 255, 255)" && pDt(c4) && !/rgba\((?:\d*, ){3}0\)/.test(c4) && c4 !== "transparent") {
            C.style.borderColor = c4;
            var O = ((h = l4.getRootNode) === null || h === void 0 ? void 0 : h.call(l4)) || l4.ownerDocument, N = O instanceof Document ? O.body : (p4 = O.firstChild) !== null && p4 !== void 0 ? p4 : O;
            _ie = ILe(`
      [`.concat(E(""), "-click-animating-without-extra-node='true']::after, .").concat(E(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(c4, `;
      }`), "antd-wave", { csp: o.csp, attachTo: N });
          }
          y4 && l4.appendChild(C), ["transition", "animation"].forEach(function(V) {
            l4.addEventListener("".concat(V, "start"), o.onTransitionStart), l4.addEventListener("".concat(V, "end"), o.onTransitionEnd);
          });
        }
      }, o.onTransitionStart = function(l4) {
        if (!o.destroyed) {
          var c4 = o.containerRef.current;
          !l4 || l4.target !== c4 || o.animationStart || o.resetEffect(c4);
        }
      }, o.onTransitionEnd = function(l4) {
        !l4 || l4.animationName !== "fadeEffect" || o.resetEffect(l4.target);
      }, o.bindAnimationEvent = function(l4) {
        if (!(!l4 || !l4.getAttribute || l4.getAttribute("disabled") || l4.className.indexOf("disabled") >= 0)) {
          var c4 = function(p4) {
            if (!(p4.target.tagName === "INPUT" || sIe(p4.target))) {
              o.resetEffect(l4);
              var g4 = getComputedStyle(l4).getPropertyValue("border-top-color") || getComputedStyle(l4).getPropertyValue("border-color") || getComputedStyle(l4).getPropertyValue("background-color");
              o.clickWaveTimeoutId = window.setTimeout(function() {
                return o.onClick(l4, g4);
              }, 0), p$.cancel(o.animationStartId), o.animationStart = true, o.animationStartId = p$(function() {
                o.animationStart = false;
              }, 10);
            }
          };
          return l4.addEventListener("click", c4, true), { cancel: function() {
            l4.removeEventListener("click", c4, true);
          } };
        }
      }, o.renderWave = function(l4) {
        var c4 = l4.csp, h = o.props.children;
        if (o.csp = c4, !Qr.isValidElement(h))
          return h;
        var p4 = o.containerRef;
        return jIt(h) && (p4 = BIt(h.ref, o.containerRef)), fDt(h, { ref: p4 });
      }, o;
    }
    return i9(e2, [{ key: "componentDidMount", value: function() {
      var l4 = this.containerRef.current;
      !l4 || l4.nodeType !== 1 || (this.instance = this.bindAnimationEvent(l4));
    } }, { key: "componentWillUnmount", value: function() {
      this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
    } }, { key: "getAttributeName", value: function() {
      var l4 = this.context.getPrefixCls, c4 = this.props.insertExtraNode;
      return c4 ? "".concat(l4(""), "-click-animating") : "".concat(l4(""), "-click-animating-without-extra-node");
    } }, { key: "resetEffect", value: function(l4) {
      var c4 = this;
      if (!(!l4 || l4 === this.extraNode || !(l4 instanceof Element))) {
        var h = this.props.insertExtraNode, p4 = this.getAttributeName();
        l4.setAttribute(p4, "false"), _ie && (_ie.innerHTML = ""), h && this.extraNode && l4.contains(this.extraNode) && l4.removeChild(this.extraNode), ["transition", "animation"].forEach(function(g4) {
          l4.removeEventListener("".concat(g4, "start"), c4.onTransitionStart), l4.removeEventListener("".concat(g4, "end"), c4.onTransitionEnd);
        });
      }
    } }, { key: "render", value: function() {
      return Qr.createElement(YLe, null, this.renderWave);
    } }]), e2;
  }(Qr.Component);
  QLe.contextType = lM;
  var Uue = { exports: {} }, s9 = {};
  /** @license React v17.0.2
  * react-jsx-runtime.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var vDt = P3.default, eOe = 60103;
  s9.Fragment = 60107;
  if (typeof Symbol == "function" && Symbol.for) {
    var lIe = Symbol.for;
    eOe = lIe("react.element"), s9.Fragment = lIe("react.fragment");
  }
  var gDt = vDt.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, mDt = Object.prototype.hasOwnProperty, yDt = { key: true, ref: true, __self: true, __source: true };
  function tOe(i, n2, e2) {
    var o, l4 = {}, c4 = null, h = null;
    e2 !== void 0 && (c4 = "" + e2), n2.key !== void 0 && (c4 = "" + n2.key), n2.ref !== void 0 && (h = n2.ref);
    for (o in n2)
      mDt.call(n2, o) && !yDt.hasOwnProperty(o) && (l4[o] = n2[o]);
    if (i && i.defaultProps)
      for (o in n2 = i.defaultProps, n2)
        l4[o] === void 0 && (l4[o] = n2[o]);
    return { $$typeof: eOe, type: i, key: c4, ref: h, props: l4, _owner: gDt.current };
  }
  s9.jsx = tOe;
  s9.jsxs = tOe;
  Uue.exports = s9;
  const m3 = Uue.exports.jsx, bDt = Uue.exports.jsxs;
  var _Dt = il.createContext({}), nOe = _Dt, xDt = function() {
    return ALe() && window.document.documentElement;
  }, qW, wDt = function() {
    if (!xDt())
      return false;
    if (qW !== void 0)
      return qW;
    var n2 = document.createElement("div");
    return n2.style.display = "flex", n2.style.flexDirection = "column", n2.style.rowGap = "1px", n2.appendChild(document.createElement("div")), n2.appendChild(document.createElement("div")), document.body.appendChild(n2), qW = n2.scrollHeight === 1, document.body.removeChild(n2), qW;
  }, SDt = function() {
    var i = Qr.useState(false), n2 = Ry(i, 2), e2 = n2[0], o = n2[1];
    return Qr.useEffect(function() {
      o(wDt());
    }, []), e2;
  }, CDt = globalThis && globalThis.__rest || function(i, n2) {
    var e2 = {};
    for (var o in i)
      Object.prototype.hasOwnProperty.call(i, o) && n2.indexOf(o) < 0 && (e2[o] = i[o]);
    if (i != null && typeof Object.getOwnPropertySymbols == "function")
      for (var l4 = 0, o = Object.getOwnPropertySymbols(i); l4 < o.length; l4++)
        n2.indexOf(o[l4]) < 0 && Object.prototype.propertyIsEnumerable.call(i, o[l4]) && (e2[o[l4]] = i[o[l4]]);
    return e2;
  };
  JLe("top", "middle", "bottom", "stretch");
  JLe("start", "end", "center", "space-around", "space-between");
  var rOe = Qr.forwardRef(function(i, n2) {
    var e2, o = i.prefixCls, l4 = i.justify, c4 = i.align, h = i.className, p4 = i.style, g4 = i.children, y4 = i.gutter, _ = y4 === void 0 ? 0 : y4, w4 = i.wrap, C = CDt(i, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), E = Qr.useContext(lM), T = E.getPrefixCls, O = E.direction, N = Qr.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), V = Ry(N, 2), H = V[0], X = V[1], q2 = SDt(), de = Qr.useRef(_);
    Qr.useEffect(function() {
      var xt = oIe.subscribe(function(It) {
        var Wt = de.current || 0;
        (!Array.isArray(Wt) && pv(Wt) === "object" || Array.isArray(Wt) && (pv(Wt[0]) === "object" || pv(Wt[1]) === "object")) && X(It);
      });
      return function() {
        return oIe.unsubscribe(xt);
      };
    }, []);
    var le = function() {
      var It = [0, 0], Wt = Array.isArray(_) ? _ : [_, 0];
      return Wt.forEach(function(sn, vn) {
        if (pv(sn) === "object")
          for (var $r = 0; $r < iIe.length; $r++) {
            var ga = iIe[$r];
            if (H[ga] && sn[ga] !== void 0) {
              It[vn] = sn[ga];
              break;
            }
          }
        else
          It[vn] = sn || 0;
      }), It;
    }, me = T("row", o), ye = le(), be = iL(me, (e2 = {}, pu(e2, "".concat(me, "-no-wrap"), w4 === false), pu(e2, "".concat(me, "-").concat(l4), l4), pu(e2, "".concat(me, "-").concat(c4), c4), pu(e2, "".concat(me, "-rtl"), O === "rtl"), e2), h), we = {}, Pe = ye[0] > 0 ? ye[0] / -2 : void 0, ze = ye[1] > 0 ? ye[1] / -2 : void 0;
    if (Pe && (we.marginLeft = Pe, we.marginRight = Pe), q2) {
      var Re = Ry(ye, 2);
      we.rowGap = Re[1];
    } else
      ze && (we.marginTop = ze, we.marginBottom = ze);
    var rt2 = Ry(ye, 2), ft = rt2[0], et = rt2[1], Jt = Qr.useMemo(function() {
      return { gutter: [ft, et], wrap: w4, supportFlexGap: q2 };
    }, [ft, et, w4, q2]);
    return Qr.createElement(nOe.Provider, { value: Jt }, Qr.createElement("div", mh({}, C, { className: be, style: mh(mh({}, we), p4), ref: n2 }), g4));
  });
  rOe.displayName = "Row";
  var MDt = rOe, ADt = globalThis && globalThis.__rest || function(i, n2) {
    var e2 = {};
    for (var o in i)
      Object.prototype.hasOwnProperty.call(i, o) && n2.indexOf(o) < 0 && (e2[o] = i[o]);
    if (i != null && typeof Object.getOwnPropertySymbols == "function")
      for (var l4 = 0, o = Object.getOwnPropertySymbols(i); l4 < o.length; l4++)
        n2.indexOf(o[l4]) < 0 && Object.prototype.propertyIsEnumerable.call(i, o[l4]) && (e2[o[l4]] = i[o[l4]]);
    return e2;
  };
  function EDt(i) {
    return typeof i == "number" ? "".concat(i, " ").concat(i, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(i) ? "0 0 ".concat(i) : i;
  }
  var IDt = ["xs", "sm", "md", "lg", "xl", "xxl"], aOe = Qr.forwardRef(function(i, n2) {
    var e2, o = Qr.useContext(lM), l4 = o.getPrefixCls, c4 = o.direction, h = Qr.useContext(nOe), p4 = h.gutter, g4 = h.wrap, y4 = h.supportFlexGap, _ = i.prefixCls, w4 = i.span, C = i.order, E = i.offset, T = i.push, O = i.pull, N = i.className, V = i.children, H = i.flex, X = i.style, q2 = ADt(i, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), de = l4("col", _), le = {};
    IDt.forEach(function(Pe) {
      var ze, Re = {}, rt2 = i[Pe];
      typeof rt2 == "number" ? Re.span = rt2 : pv(rt2) === "object" && (Re = rt2 || {}), delete q2[Pe], le = mh(mh({}, le), (ze = {}, pu(ze, "".concat(de, "-").concat(Pe, "-").concat(Re.span), Re.span !== void 0), pu(ze, "".concat(de, "-").concat(Pe, "-order-").concat(Re.order), Re.order || Re.order === 0), pu(ze, "".concat(de, "-").concat(Pe, "-offset-").concat(Re.offset), Re.offset || Re.offset === 0), pu(ze, "".concat(de, "-").concat(Pe, "-push-").concat(Re.push), Re.push || Re.push === 0), pu(ze, "".concat(de, "-").concat(Pe, "-pull-").concat(Re.pull), Re.pull || Re.pull === 0), pu(ze, "".concat(de, "-rtl"), c4 === "rtl"), ze));
    });
    var me = iL(de, (e2 = {}, pu(e2, "".concat(de, "-").concat(w4), w4 !== void 0), pu(e2, "".concat(de, "-order-").concat(C), C), pu(e2, "".concat(de, "-offset-").concat(E), E), pu(e2, "".concat(de, "-push-").concat(T), T), pu(e2, "".concat(de, "-pull-").concat(O), O), e2), N, le), ye = {};
    if (p4 && p4[0] > 0) {
      var be = p4[0] / 2;
      ye.paddingLeft = be, ye.paddingRight = be;
    }
    if (p4 && p4[1] > 0 && !y4) {
      var we = p4[1] / 2;
      ye.paddingTop = we, ye.paddingBottom = we;
    }
    return H && (ye.flex = EDt(H), g4 === false && !ye.minWidth && (ye.minWidth = 0)), Qr.createElement("div", mh({}, q2, { style: mh(mh({}, ye), X), className: me, ref: n2 }), V);
  });
  aOe.displayName = "Col";
  var TDt = aOe, iOe = Qr.forwardRef(function(i, n2) {
    var e2, o = i.prefixCls, l4 = o === void 0 ? "rc-switch" : o, c4 = i.className, h = i.checked, p4 = i.defaultChecked, g4 = i.disabled, y4 = i.loadingIcon, _ = i.checkedChildren, w4 = i.unCheckedChildren, C = i.onClick, E = i.onChange, T = i.onKeyDown, O = aL(i, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), N = lDt(false, { value: h, defaultValue: p4 }), V = Ry(N, 2), H = V[0], X = V[1];
    function q2(ye, be) {
      var we = H;
      return g4 || (we = ye, X(we), E == null || E(we, be)), we;
    }
    function de(ye) {
      ye.which === vo.LEFT ? q2(false, ye) : ye.which === vo.RIGHT && q2(true, ye), T == null || T(ye);
    }
    function le(ye) {
      var be = q2(!H, ye);
      C == null || C(be, ye);
    }
    var me = iL(l4, c4, (e2 = {}, pu(e2, "".concat(l4, "-checked"), H), pu(e2, "".concat(l4, "-disabled"), g4), e2));
    return Qr.createElement("button", Object.assign({}, O, { type: "button", role: "switch", "aria-checked": H, disabled: g4, className: me, ref: n2, onKeyDown: de, onClick: le }), y4, Qr.createElement("span", { className: "".concat(l4, "-inner") }, H ? _ : w4));
  });
  iOe.displayName = "Switch";
  var DDt = globalThis && globalThis.__rest || function(i, n2) {
    var e2 = {};
    for (var o in i)
      Object.prototype.hasOwnProperty.call(i, o) && n2.indexOf(o) < 0 && (e2[o] = i[o]);
    if (i != null && typeof Object.getOwnPropertySymbols == "function")
      for (var l4 = 0, o = Object.getOwnPropertySymbols(i); l4 < o.length; l4++)
        n2.indexOf(o[l4]) < 0 && Object.prototype.propertyIsEnumerable.call(i, o[l4]) && (e2[o[l4]] = i[o[l4]]);
    return e2;
  }, que = Qr.forwardRef(function(i, n2) {
    var e2, o = i.prefixCls, l4 = i.size, c4 = i.loading, h = i.className, p4 = h === void 0 ? "" : h, g4 = i.disabled, y4 = DDt(i, ["prefixCls", "size", "loading", "className", "disabled"]);
    HTt("checked" in y4 || !("value" in y4), "Switch", "`value` is not a valid prop, do you mean `checked`?");
    var _ = Qr.useContext(lM), w4 = _.getPrefixCls, C = _.direction, E = Qr.useContext(sDt), T = w4("switch", o), O = Qr.createElement("div", { className: "".concat(T, "-handle") }, c4 && Qr.createElement(kIt, { className: "".concat(T, "-loading-icon") })), N = iL((e2 = {}, pu(e2, "".concat(T, "-small"), (l4 || E) === "small"), pu(e2, "".concat(T, "-loading"), c4), pu(e2, "".concat(T, "-rtl"), C === "rtl"), e2), p4);
    return Qr.createElement(QLe, { insertExtraNode: true }, Qr.createElement(iOe, mh({}, y4, { prefixCls: T, className: N, disabled: g4 || c4, ref: n2, loadingIcon: O })));
  });
  que.__ANT_SWITCH = true;
  que.displayName = "Switch";
  var kDt = que;
  const PDt = "_container_oi76t_1";
  var LDt = { container: PDt, function: "_function_oi76t_10" }, ODt = {};
  (function(i) {
    var n2 = Object.defineProperty, e2 = Object.getOwnPropertySymbols, o = Object.prototype.hasOwnProperty, l4 = Object.prototype.propertyIsEnumerable, c4 = (a, r6, t2) => r6 in a ? n2(a, r6, { enumerable: true, configurable: true, writable: true, value: t2 }) : a[r6] = t2, h = (a, r6) => {
      for (var t2 in r6 || (r6 = {}))
        o.call(r6, t2) && c4(a, t2, r6[t2]);
      if (e2)
        for (var t2 of e2(r6))
          l4.call(r6, t2) && c4(a, t2, r6[t2]);
      return a;
    }, p4 = (a, r6, t2) => (c4(a, typeof r6 != "symbol" ? r6 + "" : r6, t2), t2);
    Object.defineProperties(i, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
    var g4 = P3.default;
    function y4(a) {
      return a && typeof a == "object" && "default" in a ? a : { default: a };
    }
    function _(a) {
      if (a && a.__esModule)
        return a;
      var r6 = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
      return a && Object.keys(a).forEach(function(t2) {
        if (t2 !== "default") {
          var s = Object.getOwnPropertyDescriptor(a, t2);
          Object.defineProperty(r6, t2, s.get ? s : { enumerable: true, get: function() {
            return a[t2];
          } });
        }
      }), r6.default = a, Object.freeze(r6);
    }
    var w4 = y4(g4), C = _(g4), E = globalThis && globalThis.__read || function(a, r6) {
      var t2 = typeof Symbol == "function" && a[Symbol.iterator];
      if (!t2)
        return a;
      var s = t2.call(a), u, f6 = [], d6;
      try {
        for (; (r6 === void 0 || r6-- > 0) && !(u = s.next()).done; )
          f6.push(u.value);
      } catch (v6) {
        d6 = { error: v6 };
      } finally {
        try {
          u && !u.done && (t2 = s.return) && t2.call(s);
        } finally {
          if (d6)
            throw d6.error;
        }
      }
      return f6;
    };
    function T(a, r6) {
      a === void 0 && (a = false);
      var t2 = E(g4.useState(a), 2), s = t2[0], u = t2[1], f6 = g4.useMemo(function() {
        var d6 = r6 === void 0 ? !a : r6, v6 = function() {
          return u(function(S) {
            return S === a ? d6 : a;
          });
        }, m6 = function(S) {
          return u(S);
        }, b6 = function() {
          return u(a);
        }, x6 = function() {
          return u(d6);
        };
        return { toggle: v6, set: m6, setLeft: b6, setRight: x6 };
      }, []);
      return [s, f6];
    }
    var O = globalThis && globalThis.__read || function(a, r6) {
      var t2 = typeof Symbol == "function" && a[Symbol.iterator];
      if (!t2)
        return a;
      var s = t2.call(a), u, f6 = [], d6;
      try {
        for (; (r6 === void 0 || r6-- > 0) && !(u = s.next()).done; )
          f6.push(u.value);
      } catch (v6) {
        d6 = { error: v6 };
      } finally {
        try {
          u && !u.done && (t2 = s.return) && t2.call(s);
        } finally {
          if (d6)
            throw d6.error;
        }
      }
      return f6;
    };
    function N(a) {
      a === void 0 && (a = false);
      var r6 = O(T(a), 2), t2 = r6[0], s = r6[1], u = s.toggle, f6 = s.set, d6 = g4.useMemo(function() {
        var v6 = function() {
          return f6(true);
        }, m6 = function() {
          return f6(false);
        };
        return { toggle: u, set: function(b6) {
          return f6(!!b6);
        }, setTrue: v6, setFalse: m6 };
      }, []);
      return [t2, d6];
    }
    function V(a) {
      var r6 = g4.useRef(a);
      return r6.current = a, r6;
    }
    var H = !!(typeof window != "undefined" && window.document && window.document.createElement), X = H;
    function q2(a, r6) {
      if (X) {
        if (!a)
          return r6;
        var t2;
        return typeof a == "function" ? t2 = a() : "current" in a ? t2 = a.current : t2 = a, t2;
      }
    }
    var de = function(a) {
      var r6 = V(a);
      g4.useEffect(function() {
        return function() {
          r6.current();
        };
      }, []);
    }, le = de;
    function me(a, r6) {
      if (a === r6)
        return true;
      for (var t2 = 0; t2 < a.length; t2++)
        if (!Object.is(a[t2], r6[t2]))
          return false;
      return true;
    }
    var ye = function(a) {
      var r6 = function(t2, s, u) {
        var f6 = g4.useRef(false), d6 = g4.useRef([]), v6 = g4.useRef([]), m6 = g4.useRef();
        a(function() {
          var b6, x6 = Array.isArray(u) ? u : [u], S = x6.map(function(M) {
            return q2(M);
          });
          if (!f6.current) {
            f6.current = true, d6.current = S, v6.current = s, m6.current = t2();
            return;
          }
          (S.length !== d6.current.length || !me(S, d6.current) || !me(s, v6.current)) && ((b6 = m6.current) === null || b6 === void 0 || b6.call(m6), d6.current = S, v6.current = s, m6.current = t2());
        }), le(function() {
          var b6;
          (b6 = m6.current) === null || b6 === void 0 || b6.call(m6), f6.current = false;
        });
      };
      return r6;
    }, be = ye, we = be(g4.useEffect), Pe = we, ze = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof Dy != "undefined" ? Dy : typeof self != "undefined" ? self : {};
    function Re(a) {
      return a && a.__esModule && Object.prototype.hasOwnProperty.call(a, "default") ? a.default : a;
    }
    function rt2(a) {
      var r6 = typeof a;
      return a != null && (r6 == "object" || r6 == "function");
    }
    var ft = rt2, et = typeof ze == "object" && ze && ze.Object === Object && ze, Jt = et, xt = Jt, It = typeof self == "object" && self && self.Object === Object && self, Wt = xt || It || Function("return this")(), sn = Wt, vn = sn, $r = function() {
      return vn.Date.now();
    }, ga = $r, Za = /\s/;
    function $a(a) {
      for (var r6 = a.length; r6-- && Za.test(a.charAt(r6)); )
        ;
      return r6;
    }
    var Pa = $a, da = Pa, Ra = /^\s+/;
    function Wa(a) {
      return a && a.slice(0, da(a) + 1).replace(Ra, "");
    }
    var wa = Wa, li = sn, Ts = li.Symbol, wi = Ts, ps = wi, Bs = Object.prototype, vl = Bs.hasOwnProperty, If = Bs.toString, Xl = ps ? ps.toStringTag : void 0;
    function _h(a) {
      var r6 = vl.call(a, Xl), t2 = a[Xl];
      try {
        a[Xl] = void 0;
        var s = true;
      } catch {
      }
      var u = If.call(a);
      return s && (r6 ? a[Xl] = t2 : delete a[Xl]), u;
    }
    var Nl = _h, Uc = Object.prototype, Nu = Uc.toString;
    function om(a) {
      return Nu.call(a);
    }
    var Rr = om, $n = wi, Bn = Nl, Fr = Rr, Oa = "[object Null]", yi = "[object Undefined]", Bo = $n ? $n.toStringTag : void 0;
    function jo(a) {
      return a == null ? a === void 0 ? yi : Oa : Bo && Bo in Object(a) ? Bn(a) : Fr(a);
    }
    var xl = jo;
    function Uu(a) {
      return a != null && typeof a == "object";
    }
    var vu = Uu, qc = xl, gu = vu, td = "[object Symbol]";
    function jd(a) {
      return typeof a == "symbol" || gu(a) && qc(a) == td;
    }
    var Qv = jd, Gd = wa, xc = ft, js = Qv, vf = 0 / 0, xh = /^[-+]0x[0-9a-f]+$/i, eg = /^0b[01]+$/i, Ep = /^0o[0-7]+$/i, Wd = parseInt;
    function bv(a) {
      if (typeof a == "number")
        return a;
      if (js(a))
        return vf;
      if (xc(a)) {
        var r6 = typeof a.valueOf == "function" ? a.valueOf() : a;
        a = xc(r6) ? r6 + "" : r6;
      }
      if (typeof a != "string")
        return a === 0 ? a : +a;
      a = Gd(a);
      var t2 = eg.test(a);
      return t2 || Ep.test(a) ? Wd(a.slice(2), t2 ? 2 : 8) : xh.test(a) ? vf : +a;
    }
    var ub = bv, Gy = ft, uM = ga, Wy = ub, oL = "Expected a function", sL = Math.max, lL = Math.min;
    function uL(a, r6, t2) {
      var s, u, f6, d6, v6, m6, b6 = 0, x6 = false, S = false, M = true;
      if (typeof a != "function")
        throw new TypeError(oL);
      r6 = Wy(r6) || 0, Gy(t2) && (x6 = !!t2.leading, S = "maxWait" in t2, f6 = S ? sL(Wy(t2.maxWait) || 0, r6) : f6, M = "trailing" in t2 ? !!t2.trailing : M);
      function A6(ue) {
        var pe = s, _e = u;
        return s = u = void 0, b6 = ue, d6 = a.apply(_e, pe), d6;
      }
      function I(ue) {
        return b6 = ue, v6 = setTimeout(j, r6), x6 ? A6(ue) : d6;
      }
      function R(ue) {
        var pe = ue - m6, _e = ue - b6, xe = r6 - pe;
        return S ? lL(xe, f6 - _e) : xe;
      }
      function F(ue) {
        var pe = ue - m6, _e = ue - b6;
        return m6 === void 0 || pe >= r6 || pe < 0 || S && _e >= f6;
      }
      function j() {
        var ue = uM();
        if (F(ue))
          return $(ue);
        v6 = setTimeout(j, R(ue));
      }
      function $(ue) {
        return v6 = void 0, M && s ? A6(ue) : (s = u = void 0, d6);
      }
      function K() {
        v6 !== void 0 && clearTimeout(v6), b6 = 0, s = m6 = u = v6 = void 0;
      }
      function U() {
        return v6 === void 0 ? d6 : $(uM());
      }
      function he() {
        var ue = uM(), pe = F(ue);
        if (s = arguments, u = this, m6 = ue, pe) {
          if (v6 === void 0)
            return I(m6);
          if (S)
            return clearTimeout(v6), v6 = setTimeout(j, r6), A6(m6);
        }
        return v6 === void 0 && (v6 = setTimeout(j, r6)), d6;
      }
      return he.cancel = K, he.flush = U, he;
    }
    var E2 = uL, Lt = globalThis && globalThis.__read || function(a, r6) {
      var t2 = typeof Symbol == "function" && a[Symbol.iterator];
      if (!t2)
        return a;
      var s = t2.call(a), u, f6 = [], d6;
      try {
        for (; (r6 === void 0 || r6-- > 0) && !(u = s.next()).done; )
          f6.push(u.value);
      } catch (v6) {
        d6 = { error: v6 };
      } finally {
        try {
          u && !u.done && (t2 = s.return) && t2.call(s);
        } finally {
          if (d6)
            throw d6.error;
        }
      }
      return f6;
    }, zt = globalThis && globalThis.__spread || function() {
      for (var a = [], r6 = 0; r6 < arguments.length; r6++)
        a = a.concat(Lt(arguments[r6]));
      return a;
    };
    function lt2(a, r6) {
      var t2, s = V(a), u = (t2 = r6 == null ? void 0 : r6.wait) !== null && t2 !== void 0 ? t2 : 1e3, f6 = g4.useMemo(function() {
        return E2(function() {
          for (var d6 = [], v6 = 0; v6 < arguments.length; v6++)
            d6[v6] = arguments[v6];
          return s.current.apply(s, zt(d6));
        }, u, r6);
      }, []);
      return le(function() {
        f6.cancel();
      }), { run: f6, cancel: f6.cancel, flush: f6.flush };
    }
    function Et(a, r6, t2) {
      t2 === void 0 && (t2 = {});
      var s = V(r6);
      Pe(function() {
        var u = q2(t2.target, window);
        if (u != null && u.addEventListener) {
          var f6 = function(d6) {
            return s.current(d6);
          };
          return u.addEventListener(a, f6, { capture: t2.capture, once: t2.once, passive: t2.passive }), function() {
            u.removeEventListener(a, f6, { capture: t2.capture });
          };
        }
      }, [a, t2.capture, t2.once, t2.passive], t2.target);
    }
    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.
    
    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.
    
    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    var kt = function(a, r6) {
      return kt = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(t2, s) {
        t2.__proto__ = s;
      } || function(t2, s) {
        for (var u in s)
          Object.prototype.hasOwnProperty.call(s, u) && (t2[u] = s[u]);
      }, kt(a, r6);
    };
    function tt(a, r6) {
      if (typeof r6 != "function" && r6 !== null)
        throw new TypeError("Class extends value " + String(r6) + " is not a constructor or null");
      kt(a, r6);
      function t2() {
        this.constructor = a;
      }
      a.prototype = r6 === null ? Object.create(r6) : (t2.prototype = r6.prototype, new t2());
    }
    var Ir = function() {
      function a() {
        this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
      }
      return a;
    }(), hr = function() {
      function a() {
        this.browser = new Ir(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
      }
      return a;
    }(), hn = new hr();
    typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (hn.wxa = true, hn.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? hn.worker = true : typeof navigator == "undefined" ? (hn.node = true, hn.svgSupported = true) : oa(navigator.userAgent, hn);
    function oa(a, r6) {
      var t2 = r6.browser, s = a.match(/Firefox\/([\d.]+)/), u = a.match(/MSIE\s([\d.]+)/) || a.match(/Trident\/.+?rv:(([\d.]+))/), f6 = a.match(/Edge?\/([\d.]+)/), d6 = /micromessenger/i.test(a);
      s && (t2.firefox = true, t2.version = s[1]), u && (t2.ie = true, t2.version = u[1]), f6 && (t2.edge = true, t2.version = f6[1], t2.newEdge = +f6[1].split(".")[0] > 18), d6 && (t2.weChat = true), r6.svgSupported = typeof SVGRect != "undefined", r6.touchEventsSupported = "ontouchstart" in window && !t2.ie && !t2.edge, r6.pointerEventsSupported = "onpointerdown" in window && (t2.edge || t2.ie && +t2.version >= 11), r6.domSupported = typeof document != "undefined";
      var v6 = document.documentElement.style;
      r6.transform3dSupported = (t2.ie && "transition" in v6 || t2.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in v6) && !("OTransition" in v6), r6.transformSupported = r6.transform3dSupported || t2.ie && +t2.version >= 9;
    }
    var ha = hn, Zo = 12, Ds = "sans-serif", Gs = Zo + "px " + Ds, ns = 20, Vl = 100, ac = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
    function yo(a) {
      var r6 = {};
      if (typeof JSON == "undefined")
        return r6;
      for (var t2 = 0; t2 < a.length; t2++) {
        var s = String.fromCharCode(t2 + 32), u = (a.charCodeAt(t2) - ns) / Vl;
        r6[s] = u;
      }
      return r6;
    }
    var Yc = yo(ac), Tc = { createCanvas: function() {
      return typeof document != "undefined" && document.createElement("canvas");
    }, measureText: function() {
      var a, r6;
      return function(t2, s) {
        if (!a) {
          var u = Tc.createCanvas();
          a = u && u.getContext("2d");
        }
        if (a)
          return r6 !== s && (r6 = a.font = s || Gs), a.measureText(t2);
        t2 = t2 || "", s = s || Gs;
        var f6 = /^([0-9]*?)px$/.exec(s), d6 = +(f6 && f6[1]) || Zo, v6 = 0;
        if (s.indexOf("mono") >= 0)
          v6 = d6 * t2.length;
        else
          for (var m6 = 0; m6 < t2.length; m6++) {
            var b6 = Yc[t2[m6]];
            v6 += b6 == null ? d6 : b6 * d6;
          }
        return { width: v6 };
      };
    }(), loadImage: function(a, r6, t2) {
      var s = new Image();
      return s.onload = r6, s.onerror = t2, s.src = a, s;
    } }, tg = qg(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(a, r6) {
      return a["[object " + r6 + "]"] = true, a;
    }, {}), tx = qg(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(a, r6) {
      return a["[object " + r6 + "Array]"] = true, a;
    }, {}), nd = Object.prototype.toString, sm = Array.prototype, Hy = sm.forEach, Tf = sm.filter, ng = sm.slice, nx = sm.map, lm = function() {
    }.constructor, um = lm ? lm.prototype : null, $y = "__proto__", cM = 2311;
    function rx() {
      return cM++;
    }
    function cb() {
      for (var a = [], r6 = 0; r6 < arguments.length; r6++)
        a[r6] = arguments[r6];
      typeof console != "undefined" && console.error.apply(console, a);
    }
    function Qa(a) {
      if (a == null || typeof a != "object")
        return a;
      var r6 = a, t2 = nd.call(a);
      if (t2 === "[object Array]") {
        if (!I2(a)) {
          r6 = [];
          for (var s = 0, u = a.length; s < u; s++)
            r6[s] = Qa(a[s]);
        }
      } else if (tx[t2]) {
        if (!I2(a)) {
          var f6 = a.constructor;
          if (f6.from)
            r6 = f6.from(a);
          else {
            r6 = new f6(a.length);
            for (var s = 0, u = a.length; s < u; s++)
              r6[s] = a[s];
          }
        }
      } else if (!tg[t2] && !I2(a) && !hM(a)) {
        r6 = {};
        for (var d6 in a)
          a.hasOwnProperty(d6) && d6 !== $y && (r6[d6] = Qa(a[d6]));
      }
      return r6;
    }
    function Di(a, r6, t2) {
      if (!ui(r6) || !ui(a))
        return t2 ? Qa(r6) : a;
      for (var s in r6)
        if (r6.hasOwnProperty(s) && s !== $y) {
          var u = a[s], f6 = r6[s];
          ui(f6) && ui(u) && !br(f6) && !br(u) && !hM(f6) && !hM(u) && !u9(f6) && !u9(u) && !I2(f6) && !I2(u) ? Di(u, f6, t2) : (t2 || !(s in a)) && (a[s] = Qa(r6[s]));
        }
      return a;
    }
    function ax(a, r6) {
      for (var t2 = a[0], s = 1, u = a.length; s < u; s++)
        t2 = Di(t2, a[s], r6);
      return t2;
    }
    function qn(a, r6) {
      if (Object.assign)
        Object.assign(a, r6);
      else
        for (var t2 in r6)
          r6.hasOwnProperty(t2) && t2 !== $y && (a[t2] = r6[t2]);
      return a;
    }
    function ei(a, r6, t2) {
      for (var s = Po(r6), u = 0; u < s.length; u++) {
        var f6 = s[u];
        (t2 ? r6[f6] != null : a[f6] == null) && (a[f6] = r6[f6]);
      }
      return a;
    }
    function Vi(a, r6) {
      if (a) {
        if (a.indexOf)
          return a.indexOf(r6);
        for (var t2 = 0, s = a.length; t2 < s; t2++)
          if (a[t2] === r6)
            return t2;
      }
      return -1;
    }
    function l9(a, r6) {
      var t2 = a.prototype;
      function s() {
      }
      s.prototype = r6.prototype, a.prototype = new s();
      for (var u in t2)
        t2.hasOwnProperty(u) && (a.prototype[u] = t2[u]);
      a.prototype.constructor = a, a.superClass = r6;
    }
    function Dc(a, r6, t2) {
      if (a = "prototype" in a ? a.prototype : a, r6 = "prototype" in r6 ? r6.prototype : r6, Object.getOwnPropertyNames)
        for (var s = Object.getOwnPropertyNames(r6), u = 0; u < s.length; u++) {
          var f6 = s[u];
          f6 !== "constructor" && (t2 ? r6[f6] != null : a[f6] == null) && (a[f6] = r6[f6]);
        }
      else
        ei(a, r6, t2);
    }
    function rd(a) {
      return !a || typeof a == "string" ? false : typeof a.length == "number";
    }
    function Ne(a, r6, t2) {
      if (a && r6)
        if (a.forEach && a.forEach === Hy)
          a.forEach(r6, t2);
        else if (a.length === +a.length)
          for (var s = 0, u = a.length; s < u; s++)
            r6.call(t2, a[s], s, a);
        else
          for (var f6 in a)
            a.hasOwnProperty(f6) && r6.call(t2, a[f6], f6, a);
    }
    function wr(a, r6, t2) {
      if (!a)
        return [];
      if (!r6)
        return cL(a);
      if (a.map && a.map === nx)
        return a.map(r6, t2);
      for (var s = [], u = 0, f6 = a.length; u < f6; u++)
        s.push(r6.call(t2, a[u], u, a));
      return s;
    }
    function qg(a, r6, t2, s) {
      if (a && r6) {
        for (var u = 0, f6 = a.length; u < f6; u++)
          t2 = r6.call(s, t2, a[u], u, a);
        return t2;
      }
    }
    function gl(a, r6, t2) {
      if (!a)
        return [];
      if (!r6)
        return cL(a);
      if (a.filter && a.filter === Tf)
        return a.filter(r6, t2);
      for (var s = [], u = 0, f6 = a.length; u < f6; u++)
        r6.call(t2, a[u], u, a) && s.push(a[u]);
      return s;
    }
    function gU(a, r6, t2) {
      if (a && r6) {
        for (var s = 0, u = a.length; s < u; s++)
          if (r6.call(t2, a[s], s, a))
            return a[s];
      }
    }
    function Po(a) {
      if (!a)
        return [];
      if (Object.keys)
        return Object.keys(a);
      var r6 = [];
      for (var t2 in a)
        a.hasOwnProperty(t2) && r6.push(t2);
      return r6;
    }
    function mU(a, r6) {
      for (var t2 = [], s = 2; s < arguments.length; s++)
        t2[s - 2] = arguments[s];
      return function() {
        return a.apply(r6, t2.concat(ng.call(arguments)));
      };
    }
    var Ca = um && ti(um.bind) ? um.call.bind(um.bind) : mU;
    function Oi(a) {
      for (var r6 = [], t2 = 1; t2 < arguments.length; t2++)
        r6[t2 - 1] = arguments[t2];
      return function() {
        return a.apply(this, r6.concat(ng.call(arguments)));
      };
    }
    function br(a) {
      return Array.isArray ? Array.isArray(a) : nd.call(a) === "[object Array]";
    }
    function ti(a) {
      return typeof a == "function";
    }
    function _a2(a) {
      return typeof a == "string";
    }
    function fM(a) {
      return nd.call(a) === "[object String]";
    }
    function ks(a) {
      return typeof a == "number";
    }
    function ui(a) {
      var r6 = typeof a;
      return r6 === "function" || !!a && r6 === "object";
    }
    function u9(a) {
      return !!tg[nd.call(a)];
    }
    function _v(a) {
      return !!tx[nd.call(a)];
    }
    function hM(a) {
      return typeof a == "object" && typeof a.nodeType == "number" && typeof a.ownerDocument == "object";
    }
    function au(a) {
      return a.colorStops != null;
    }
    function Vu(a) {
      return a.image != null;
    }
    function yU(a) {
      return nd.call(a) === "[object RegExp]";
    }
    function dM(a) {
      return a !== a;
    }
    function Jf() {
      for (var a = [], r6 = 0; r6 < arguments.length; r6++)
        a[r6] = arguments[r6];
      for (var t2 = 0, s = a.length; t2 < s; t2++)
        if (a[t2] != null)
          return a[t2];
    }
    function qi(a, r6) {
      return a != null ? a : r6;
    }
    function Uy(a, r6, t2) {
      return a != null ? a : r6 != null ? r6 : t2;
    }
    function cL(a) {
      for (var r6 = [], t2 = 1; t2 < arguments.length; t2++)
        r6[t2 - 1] = arguments[t2];
      return ng.apply(a, r6);
    }
    function DT(a) {
      if (typeof a == "number")
        return [a, a, a, a];
      var r6 = a.length;
      return r6 === 2 ? [a[0], a[1], a[0], a[1]] : r6 === 3 ? [a[0], a[1], a[2], a[1]] : a;
    }
    function Hd(a, r6) {
      if (!a)
        throw new Error(r6);
    }
    function mu(a) {
      return a == null ? null : typeof a.trim == "function" ? a.trim() : a.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
    }
    var kT = "__ec_primitive__";
    function cm(a) {
      a[kT] = true;
    }
    function I2(a) {
      return a[kT];
    }
    var fL = function() {
      function a(r6) {
        this.data = {};
        var t2 = br(r6);
        this.data = {};
        var s = this;
        r6 instanceof a ? r6.each(u) : r6 && Ne(r6, u);
        function u(f6, d6) {
          t2 ? s.set(f6, d6) : s.set(d6, f6);
        }
      }
      return a.prototype.get = function(r6) {
        return this.data.hasOwnProperty(r6) ? this.data[r6] : null;
      }, a.prototype.set = function(r6, t2) {
        return this.data[r6] = t2;
      }, a.prototype.each = function(r6, t2) {
        for (var s in this.data)
          this.data.hasOwnProperty(s) && r6.call(t2, this.data[s], s);
      }, a.prototype.keys = function() {
        return Po(this.data);
      }, a.prototype.removeKey = function(r6) {
        delete this.data[r6];
      }, a;
    }();
    function Ta(a) {
      return new fL(a);
    }
    function PT(a, r6) {
      for (var t2 = new a.constructor(a.length + r6.length), s = 0; s < a.length; s++)
        t2[s] = a[s];
      for (var u = a.length, s = 0; s < r6.length; s++)
        t2[s + u] = r6[s];
      return t2;
    }
    function pM(a, r6) {
      var t2;
      if (Object.create)
        t2 = Object.create(a);
      else {
        var s = function() {
        };
        s.prototype = a, t2 = new s();
      }
      return r6 && qn(t2, r6), t2;
    }
    function hL(a) {
      var r6 = a.style;
      r6.webkitUserSelect = "none", r6.userSelect = "none", r6.webkitTapHighlightColor = "rgba(0,0,0,0)", r6["-webkit-touch-callout"] = "none";
    }
    function Da(a, r6) {
      return a.hasOwnProperty(r6);
    }
    function kc() {
    }
    var vM = 180 / Math.PI;
    function Df(a, r6) {
      return a == null && (a = 0), r6 == null && (r6 = 0), [a, r6];
    }
    function $d(a, r6) {
      return a[0] = r6[0], a[1] = r6[1], a;
    }
    function gf(a) {
      return [a[0], a[1]];
    }
    function bU(a, r6, t2) {
      return a[0] = r6, a[1] = t2, a;
    }
    function dL(a, r6, t2) {
      return a[0] = r6[0] + t2[0], a[1] = r6[1] + t2[1], a;
    }
    function fm(a, r6, t2, s) {
      return a[0] = r6[0] + t2[0] * s, a[1] = r6[1] + t2[1] * s, a;
    }
    function hm(a, r6, t2) {
      return a[0] = r6[0] - t2[0], a[1] = r6[1] - t2[1], a;
    }
    function gM(a) {
      return Math.sqrt(ic(a));
    }
    function ic(a) {
      return a[0] * a[0] + a[1] * a[1];
    }
    function dm(a, r6, t2) {
      return a[0] = r6[0] * t2, a[1] = r6[1] * t2, a;
    }
    function ix(a, r6) {
      var t2 = gM(r6);
      return t2 === 0 ? (a[0] = 0, a[1] = 0) : (a[0] = r6[0] / t2, a[1] = r6[1] / t2), a;
    }
    function pL(a, r6) {
      return Math.sqrt((a[0] - r6[0]) * (a[0] - r6[0]) + (a[1] - r6[1]) * (a[1] - r6[1]));
    }
    var pm = pL;
    function _U(a, r6) {
      return (a[0] - r6[0]) * (a[0] - r6[0]) + (a[1] - r6[1]) * (a[1] - r6[1]);
    }
    var ox = _U;
    function LT(a, r6, t2, s) {
      return a[0] = r6[0] + s * (t2[0] - r6[0]), a[1] = r6[1] + s * (t2[1] - r6[1]), a;
    }
    function Qf(a, r6, t2) {
      var s = r6[0], u = r6[1];
      return a[0] = t2[0] * s + t2[2] * u + t2[4], a[1] = t2[1] * s + t2[3] * u + t2[5], a;
    }
    function Yg(a, r6, t2) {
      return a[0] = Math.min(r6[0], t2[0]), a[1] = Math.min(r6[1], t2[1]), a;
    }
    function xv(a, r6, t2) {
      return a[0] = Math.max(r6[0], t2[0]), a[1] = Math.max(r6[1], t2[1]), a;
    }
    var T2 = function() {
      function a(r6, t2) {
        this.target = r6, this.topTarget = t2 && t2.topTarget;
      }
      return a;
    }(), c9 = function() {
      function a(r6) {
        this.handler = r6, r6.on("mousedown", this._dragStart, this), r6.on("mousemove", this._drag, this), r6.on("mouseup", this._dragEnd, this);
      }
      return a.prototype._dragStart = function(r6) {
        for (var t2 = r6.target; t2 && !t2.draggable; )
          t2 = t2.parent || t2.__hostTarget;
        t2 && (this._draggingTarget = t2, t2.dragging = true, this._x = r6.offsetX, this._y = r6.offsetY, this.handler.dispatchToElement(new T2(t2, r6), "dragstart", r6.event));
      }, a.prototype._drag = function(r6) {
        var t2 = this._draggingTarget;
        if (t2) {
          var s = r6.offsetX, u = r6.offsetY, f6 = s - this._x, d6 = u - this._y;
          this._x = s, this._y = u, t2.drift(f6, d6, r6), this.handler.dispatchToElement(new T2(t2, r6), "drag", r6.event);
          var v6 = this.handler.findHover(s, u, t2).target, m6 = this._dropTarget;
          this._dropTarget = v6, t2 !== v6 && (m6 && v6 !== m6 && this.handler.dispatchToElement(new T2(m6, r6), "dragleave", r6.event), v6 && v6 !== m6 && this.handler.dispatchToElement(new T2(v6, r6), "dragenter", r6.event));
        }
      }, a.prototype._dragEnd = function(r6) {
        var t2 = this._draggingTarget;
        t2 && (t2.dragging = false), this.handler.dispatchToElement(new T2(t2, r6), "dragend", r6.event), this._dropTarget && this.handler.dispatchToElement(new T2(this._dropTarget, r6), "drop", r6.event), this._draggingTarget = null, this._dropTarget = null;
      }, a;
    }(), f9 = c9, vL = function() {
      function a(r6) {
        r6 && (this._$eventProcessor = r6);
      }
      return a.prototype.on = function(r6, t2, s, u) {
        this._$handlers || (this._$handlers = {});
        var f6 = this._$handlers;
        if (typeof t2 == "function" && (u = s, s = t2, t2 = null), !s || !r6)
          return this;
        var d6 = this._$eventProcessor;
        t2 != null && d6 && d6.normalizeQuery && (t2 = d6.normalizeQuery(t2)), f6[r6] || (f6[r6] = []);
        for (var v6 = 0; v6 < f6[r6].length; v6++)
          if (f6[r6][v6].h === s)
            return this;
        var m6 = { h: s, query: t2, ctx: u || this, callAtLast: s.zrEventfulCallAtLast }, b6 = f6[r6].length - 1, x6 = f6[r6][b6];
        return x6 && x6.callAtLast ? f6[r6].splice(b6, 0, m6) : f6[r6].push(m6), this;
      }, a.prototype.isSilent = function(r6) {
        var t2 = this._$handlers;
        return !t2 || !t2[r6] || !t2[r6].length;
      }, a.prototype.off = function(r6, t2) {
        var s = this._$handlers;
        if (!s)
          return this;
        if (!r6)
          return this._$handlers = {}, this;
        if (t2) {
          if (s[r6]) {
            for (var u = [], f6 = 0, d6 = s[r6].length; f6 < d6; f6++)
              s[r6][f6].h !== t2 && u.push(s[r6][f6]);
            s[r6] = u;
          }
          s[r6] && s[r6].length === 0 && delete s[r6];
        } else
          delete s[r6];
        return this;
      }, a.prototype.trigger = function(r6) {
        for (var t2 = [], s = 1; s < arguments.length; s++)
          t2[s - 1] = arguments[s];
        if (!this._$handlers)
          return this;
        var u = this._$handlers[r6], f6 = this._$eventProcessor;
        if (u)
          for (var d6 = t2.length, v6 = u.length, m6 = 0; m6 < v6; m6++) {
            var b6 = u[m6];
            if (!(f6 && f6.filter && b6.query != null && !f6.filter(r6, b6.query)))
              switch (d6) {
                case 0:
                  b6.h.call(b6.ctx);
                  break;
                case 1:
                  b6.h.call(b6.ctx, t2[0]);
                  break;
                case 2:
                  b6.h.call(b6.ctx, t2[0], t2[1]);
                  break;
                default:
                  b6.h.apply(b6.ctx, t2);
                  break;
              }
          }
        return f6 && f6.afterTrigger && f6.afterTrigger(r6), this;
      }, a.prototype.triggerWithContext = function(r6) {
        for (var t2 = [], s = 1; s < arguments.length; s++)
          t2[s - 1] = arguments[s];
        if (!this._$handlers)
          return this;
        var u = this._$handlers[r6], f6 = this._$eventProcessor;
        if (u)
          for (var d6 = t2.length, v6 = t2[d6 - 1], m6 = u.length, b6 = 0; b6 < m6; b6++) {
            var x6 = u[b6];
            if (!(f6 && f6.filter && x6.query != null && !f6.filter(r6, x6.query)))
              switch (d6) {
                case 0:
                  x6.h.call(v6);
                  break;
                case 1:
                  x6.h.call(v6, t2[0]);
                  break;
                case 2:
                  x6.h.call(v6, t2[0], t2[1]);
                  break;
                default:
                  x6.h.apply(v6, t2.slice(1, d6 - 1));
                  break;
              }
          }
        return f6 && f6.afterTrigger && f6.afterTrigger(r6), this;
      }, a;
    }(), Ip = vL, h9 = Math.log(2);
    function gL(a, r6, t2, s, u, f6) {
      var d6 = s + "-" + u, v6 = a.length;
      if (f6.hasOwnProperty(d6))
        return f6[d6];
      if (r6 === 1) {
        var m6 = Math.round(Math.log((1 << v6) - 1 & ~u) / h9);
        return a[t2][m6];
      }
      for (var b6 = s | 1 << t2, x6 = t2 + 1; s & 1 << x6; )
        x6++;
      for (var S = 0, M = 0, A6 = 0; M < v6; M++) {
        var I = 1 << M;
        I & u || (S += (A6 % 2 ? -1 : 1) * a[t2][M] * gL(a, r6 - 1, x6, b6, u | I, f6), A6++);
      }
      return f6[d6] = S, S;
    }
    function OT(a, r6) {
      var t2 = [[a[0], a[1], 1, 0, 0, 0, -r6[0] * a[0], -r6[0] * a[1]], [0, 0, 0, a[0], a[1], 1, -r6[1] * a[0], -r6[1] * a[1]], [a[2], a[3], 1, 0, 0, 0, -r6[2] * a[2], -r6[2] * a[3]], [0, 0, 0, a[2], a[3], 1, -r6[3] * a[2], -r6[3] * a[3]], [a[4], a[5], 1, 0, 0, 0, -r6[4] * a[4], -r6[4] * a[5]], [0, 0, 0, a[4], a[5], 1, -r6[5] * a[4], -r6[5] * a[5]], [a[6], a[7], 1, 0, 0, 0, -r6[6] * a[6], -r6[6] * a[7]], [0, 0, 0, a[6], a[7], 1, -r6[7] * a[6], -r6[7] * a[7]]], s = {}, u = gL(t2, 8, 0, 0, 0, s);
      if (u !== 0) {
        for (var f6 = [], d6 = 0; d6 < 8; d6++)
          for (var v6 = 0; v6 < 8; v6++)
            f6[v6] == null && (f6[v6] = 0), f6[v6] += ((d6 + v6) % 2 ? -1 : 1) * gL(t2, 7, d6 === 0 ? 1 : 0, 1 << d6, 1 << v6, s) / u * r6[d6];
        return function(m6, b6, x6) {
          var S = b6 * f6[6] + x6 * f6[7] + 1;
          m6[0] = (b6 * f6[0] + x6 * f6[1] + f6[2]) / S, m6[1] = (b6 * f6[3] + x6 * f6[4] + f6[5]) / S;
        };
      }
    }
    var RT = "___zrEVENTSAVED", mL = [];
    function d9(a, r6, t2, s, u) {
      return Ud(mL, r6, s, u, true) && Ud(a, t2, mL[0], mL[1]);
    }
    function Ud(a, r6, t2, s, u) {
      if (r6.getBoundingClientRect && ha.domSupported && !bL(r6)) {
        var f6 = r6[RT] || (r6[RT] = {}), d6 = yL(r6, f6), v6 = mM(d6, f6, u);
        if (v6)
          return v6(a, t2, s), true;
      }
      return false;
    }
    function yL(a, r6) {
      var t2 = r6.markers;
      if (t2)
        return t2;
      t2 = r6.markers = [];
      for (var s = ["left", "right"], u = ["top", "bottom"], f6 = 0; f6 < 4; f6++) {
        var d6 = document.createElement("div"), v6 = d6.style, m6 = f6 % 2, b6 = (f6 >> 1) % 2;
        v6.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", s[m6] + ":0", u[b6] + ":0", s[1 - m6] + ":auto", u[1 - b6] + ":auto", ""].join("!important;"), a.appendChild(d6), t2.push(d6);
      }
      return t2;
    }
    function mM(a, r6, t2) {
      for (var s = t2 ? "invTrans" : "trans", u = r6[s], f6 = r6.srcCoords, d6 = [], v6 = [], m6 = true, b6 = 0; b6 < 4; b6++) {
        var x6 = a[b6].getBoundingClientRect(), S = 2 * b6, M = x6.left, A6 = x6.top;
        d6.push(M, A6), m6 = m6 && f6 && M === f6[S] && A6 === f6[S + 1], v6.push(a[b6].offsetLeft, a[b6].offsetTop);
      }
      return m6 && u ? u : (r6.srcCoords = d6, r6[s] = t2 ? OT(v6, d6) : OT(d6, v6));
    }
    function bL(a) {
      return a.nodeName.toUpperCase() === "CANVAS";
    }
    var p9 = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, _L = [], xU = ha.browser.firefox && +ha.browser.version.split(".")[0] < 39;
    function xL(a, r6, t2, s) {
      return t2 = t2 || {}, s ? v9(a, r6, t2) : xU && r6.layerX != null && r6.layerX !== r6.offsetX ? (t2.zrX = r6.layerX, t2.zrY = r6.layerY) : r6.offsetX != null ? (t2.zrX = r6.offsetX, t2.zrY = r6.offsetY) : v9(a, r6, t2), t2;
    }
    function v9(a, r6, t2) {
      if (ha.domSupported && a.getBoundingClientRect) {
        var s = r6.clientX, u = r6.clientY;
        if (bL(a)) {
          var f6 = a.getBoundingClientRect();
          t2.zrX = s - f6.left, t2.zrY = u - f6.top;
          return;
        } else if (Ud(_L, a, s, u)) {
          t2.zrX = _L[0], t2.zrY = _L[1];
          return;
        }
      }
      t2.zrX = t2.zrY = 0;
    }
    function wL(a) {
      return a || window.event;
    }
    function wh(a, r6, t2) {
      if (r6 = wL(r6), r6.zrX != null)
        return r6;
      var s = r6.type, u = s && s.indexOf("touch") >= 0;
      if (u) {
        var f6 = s !== "touchend" ? r6.targetTouches[0] : r6.changedTouches[0];
        f6 && xL(a, f6, r6, t2);
      } else {
        xL(a, r6, r6, t2);
        var d6 = wU(r6);
        r6.zrDelta = d6 ? d6 / 120 : -(r6.detail || 0) / 3;
      }
      var v6 = r6.button;
      return r6.which == null && v6 !== void 0 && p9.test(r6.type) && (r6.which = v6 & 1 ? 1 : v6 & 2 ? 3 : v6 & 4 ? 2 : 0), r6;
    }
    function wU(a) {
      var r6 = a.wheelDelta;
      if (r6)
        return r6;
      var t2 = a.deltaX, s = a.deltaY;
      if (t2 == null || s == null)
        return r6;
      var u = Math.abs(s !== 0 ? s : t2), f6 = s > 0 ? -1 : s < 0 ? 1 : t2 > 0 ? -1 : 1;
      return 3 * u * f6;
    }
    function SL(a, r6, t2, s) {
      a.addEventListener(r6, t2, s);
    }
    function CL(a, r6, t2, s) {
      a.removeEventListener(r6, t2, s);
    }
    var vm = function(a) {
      a.preventDefault(), a.stopPropagation(), a.cancelBubble = true;
    };
    function qy(a) {
      return a.which === 2 || a.which === 3;
    }
    var FT = function() {
      function a() {
        this._track = [];
      }
      return a.prototype.recognize = function(r6, t2, s) {
        return this._doTrack(r6, t2, s), this._recognize(r6);
      }, a.prototype.clear = function() {
        return this._track.length = 0, this;
      }, a.prototype._doTrack = function(r6, t2, s) {
        var u = r6.touches;
        if (u) {
          for (var f6 = { points: [], touches: [], target: t2, event: r6 }, d6 = 0, v6 = u.length; d6 < v6; d6++) {
            var m6 = u[d6], b6 = xL(s, m6, {});
            f6.points.push([b6.zrX, b6.zrY]), f6.touches.push(m6);
          }
          this._track.push(f6);
        }
      }, a.prototype._recognize = function(r6) {
        for (var t2 in ML)
          if (ML.hasOwnProperty(t2)) {
            var s = ML[t2](this._track, r6);
            if (s)
              return s;
          }
      }, a;
    }();
    function g9(a) {
      var r6 = a[1][0] - a[0][0], t2 = a[1][1] - a[0][1];
      return Math.sqrt(r6 * r6 + t2 * t2);
    }
    function SU(a) {
      return [(a[0][0] + a[1][0]) / 2, (a[0][1] + a[1][1]) / 2];
    }
    var ML = { pinch: function(a, r6) {
      var t2 = a.length;
      if (t2) {
        var s = (a[t2 - 1] || {}).points, u = (a[t2 - 2] || {}).points || s;
        if (u && u.length > 1 && s && s.length > 1) {
          var f6 = g9(s) / g9(u);
          !isFinite(f6) && (f6 = 1), r6.pinchScale = f6;
          var d6 = SU(s);
          return r6.pinchX = d6[0], r6.pinchY = d6[1], { type: "pinch", target: a[0].target, event: r6 };
        }
      }
    } }, sx = "silent";
    function Zg(a, r6, t2) {
      return { type: a, event: t2, target: r6.target, topTarget: r6.topTarget, cancelBubble: false, offsetX: t2.zrX, offsetY: t2.zrY, gestureEvent: t2.gestureEvent, pinchX: t2.pinchX, pinchY: t2.pinchY, pinchScale: t2.pinchScale, wheelDelta: t2.zrDelta, zrByTouch: t2.zrByTouch, which: t2.which, stop: m9 };
    }
    function m9() {
      vm(this.event);
    }
    var CU = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.handler = null, t2;
      }
      return r6.prototype.dispose = function() {
      }, r6.prototype.setCursor = function() {
      }, r6;
    }(Ip), yM = function() {
      function a(r6, t2) {
        this.x = r6, this.y = t2;
      }
      return a;
    }(), MU = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], y9 = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6) {
        var d6 = a.call(this) || this;
        return d6._hovered = new yM(0, 0), d6.storage = t2, d6.painter = s, d6.painterRoot = f6, u = u || new CU(), d6.proxy = null, d6.setHandlerProxy(u), d6._draggingMgr = new f9(d6), d6;
      }
      return r6.prototype.setHandlerProxy = function(t2) {
        this.proxy && this.proxy.dispose(), t2 && (Ne(MU, function(s) {
          t2.on && t2.on(s, this[s], this);
        }, this), t2.handler = this), this.proxy = t2;
      }, r6.prototype.mousemove = function(t2) {
        var s = t2.zrX, u = t2.zrY, f6 = lx(this, s, u), d6 = this._hovered, v6 = d6.target;
        v6 && !v6.__zr && (d6 = this.findHover(d6.x, d6.y), v6 = d6.target);
        var m6 = this._hovered = f6 ? new yM(s, u) : this.findHover(s, u), b6 = m6.target, x6 = this.proxy;
        x6.setCursor && x6.setCursor(b6 ? b6.cursor : "default"), v6 && b6 !== v6 && this.dispatchToElement(d6, "mouseout", t2), this.dispatchToElement(m6, "mousemove", t2), b6 && b6 !== v6 && this.dispatchToElement(m6, "mouseover", t2);
      }, r6.prototype.mouseout = function(t2) {
        var s = t2.zrEventControl;
        s !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", t2), s !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: t2 });
      }, r6.prototype.resize = function() {
        this._hovered = new yM(0, 0);
      }, r6.prototype.dispatch = function(t2, s) {
        var u = this[t2];
        u && u.call(this, s);
      }, r6.prototype.dispose = function() {
        this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
      }, r6.prototype.setCursorStyle = function(t2) {
        var s = this.proxy;
        s.setCursor && s.setCursor(t2);
      }, r6.prototype.dispatchToElement = function(t2, s, u) {
        t2 = t2 || {};
        var f6 = t2.target;
        if (!(f6 && f6.silent)) {
          for (var d6 = "on" + s, v6 = Zg(s, t2, u); f6 && (f6[d6] && (v6.cancelBubble = !!f6[d6].call(f6, v6)), f6.trigger(s, v6), f6 = f6.__hostTarget ? f6.__hostTarget : f6.parent, !v6.cancelBubble); )
            ;
          v6.cancelBubble || (this.trigger(s, v6), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(m6) {
            typeof m6[d6] == "function" && m6[d6].call(m6, v6), m6.trigger && m6.trigger(s, v6);
          }));
        }
      }, r6.prototype.findHover = function(t2, s, u) {
        for (var f6 = this.storage.getDisplayList(), d6 = new yM(t2, s), v6 = f6.length - 1; v6 >= 0; v6--) {
          var m6 = void 0;
          if (f6[v6] !== u && !f6[v6].ignore && (m6 = AU(f6[v6], t2, s)) && (!d6.topTarget && (d6.topTarget = f6[v6]), m6 !== sx)) {
            d6.target = f6[v6];
            break;
          }
        }
        return d6;
      }, r6.prototype.processGesture = function(t2, s) {
        this._gestureMgr || (this._gestureMgr = new FT());
        var u = this._gestureMgr;
        s === "start" && u.clear();
        var f6 = u.recognize(t2, this.findHover(t2.zrX, t2.zrY, null).target, this.proxy.dom);
        if (s === "end" && u.clear(), f6) {
          var d6 = f6.type;
          t2.gestureEvent = d6;
          var v6 = new yM();
          v6.target = f6.target, this.dispatchToElement(v6, d6, f6.event);
        }
      }, r6;
    }(Ip);
    Ne(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(a) {
      y9.prototype[a] = function(r6) {
        var t2 = r6.zrX, s = r6.zrY, u = lx(this, t2, s), f6, d6;
        if ((a !== "mouseup" || !u) && (f6 = this.findHover(t2, s), d6 = f6.target), a === "mousedown")
          this._downEl = d6, this._downPoint = [r6.zrX, r6.zrY], this._upEl = d6;
        else if (a === "mouseup")
          this._upEl = d6;
        else if (a === "click") {
          if (this._downEl !== this._upEl || !this._downPoint || pm(this._downPoint, [r6.zrX, r6.zrY]) > 4)
            return;
          this._downPoint = null;
        }
        this.dispatchToElement(f6, a, r6);
      };
    });
    function AU(a, r6, t2) {
      if (a[a.rectHover ? "rectContain" : "contain"](r6, t2)) {
        for (var s = a, u = void 0, f6 = false; s; ) {
          if (s.ignoreClip && (f6 = true), !f6) {
            var d6 = s.getClipPath();
            if (d6 && !d6.contain(r6, t2))
              return false;
            s.silent && (u = true);
          }
          var v6 = s.__hostTarget;
          s = v6 || s.parent;
        }
        return u ? sx : true;
      }
      return false;
    }
    function lx(a, r6, t2) {
      var s = a.painter;
      return r6 < 0 || r6 > s.getWidth() || t2 < 0 || t2 > s.getHeight();
    }
    var dn = y9, Dr = 32, Jn = 7;
    function ci(a) {
      for (var r6 = 0; a >= Dr; )
        r6 |= a & 1, a >>= 1;
      return a + r6;
    }
    function Io(a, r6, t2, s) {
      var u = r6 + 1;
      if (u === t2)
        return 1;
      if (s(a[u++], a[r6]) < 0) {
        for (; u < t2 && s(a[u], a[u - 1]) < 0; )
          u++;
        Dl(a, r6, u);
      } else
        for (; u < t2 && s(a[u], a[u - 1]) >= 0; )
          u++;
      return u - r6;
    }
    function Dl(a, r6, t2) {
      for (t2--; r6 < t2; ) {
        var s = a[r6];
        a[r6++] = a[t2], a[t2--] = s;
      }
    }
    function mf(a, r6, t2, s, u) {
      for (s === r6 && s++; s < t2; s++) {
        for (var f6 = a[s], d6 = r6, v6 = s, m6; d6 < v6; )
          m6 = d6 + v6 >>> 1, u(f6, a[m6]) < 0 ? v6 = m6 : d6 = m6 + 1;
        var b6 = s - d6;
        switch (b6) {
          case 3:
            a[d6 + 3] = a[d6 + 2];
          case 2:
            a[d6 + 2] = a[d6 + 1];
          case 1:
            a[d6 + 1] = a[d6];
            break;
          default:
            for (; b6 > 0; )
              a[d6 + b6] = a[d6 + b6 - 1], b6--;
        }
        a[d6] = f6;
      }
    }
    function Kl(a, r6, t2, s, u, f6) {
      var d6 = 0, v6 = 0, m6 = 1;
      if (f6(a, r6[t2 + u]) > 0) {
        for (v6 = s - u; m6 < v6 && f6(a, r6[t2 + u + m6]) > 0; )
          d6 = m6, m6 = (m6 << 1) + 1, m6 <= 0 && (m6 = v6);
        m6 > v6 && (m6 = v6), d6 += u, m6 += u;
      } else {
        for (v6 = u + 1; m6 < v6 && f6(a, r6[t2 + u - m6]) <= 0; )
          d6 = m6, m6 = (m6 << 1) + 1, m6 <= 0 && (m6 = v6);
        m6 > v6 && (m6 = v6);
        var b6 = d6;
        d6 = u - m6, m6 = u - b6;
      }
      for (d6++; d6 < m6; ) {
        var x6 = d6 + (m6 - d6 >>> 1);
        f6(a, r6[t2 + x6]) > 0 ? d6 = x6 + 1 : m6 = x6;
      }
      return m6;
    }
    function bM(a, r6, t2, s, u, f6) {
      var d6 = 0, v6 = 0, m6 = 1;
      if (f6(a, r6[t2 + u]) < 0) {
        for (v6 = u + 1; m6 < v6 && f6(a, r6[t2 + u - m6]) < 0; )
          d6 = m6, m6 = (m6 << 1) + 1, m6 <= 0 && (m6 = v6);
        m6 > v6 && (m6 = v6);
        var b6 = d6;
        d6 = u - m6, m6 = u - b6;
      } else {
        for (v6 = s - u; m6 < v6 && f6(a, r6[t2 + u + m6]) >= 0; )
          d6 = m6, m6 = (m6 << 1) + 1, m6 <= 0 && (m6 = v6);
        m6 > v6 && (m6 = v6), d6 += u, m6 += u;
      }
      for (d6++; d6 < m6; ) {
        var x6 = d6 + (m6 - d6 >>> 1);
        f6(a, r6[t2 + x6]) < 0 ? m6 = x6 : d6 = x6 + 1;
      }
      return m6;
    }
    function EU(a, r6) {
      var t2 = Jn, s, u, f6 = 0, d6 = [];
      s = [], u = [];
      function v6(A6, I) {
        s[f6] = A6, u[f6] = I, f6 += 1;
      }
      function m6() {
        for (; f6 > 1; ) {
          var A6 = f6 - 2;
          if (A6 >= 1 && u[A6 - 1] <= u[A6] + u[A6 + 1] || A6 >= 2 && u[A6 - 2] <= u[A6] + u[A6 - 1])
            u[A6 - 1] < u[A6 + 1] && A6--;
          else if (u[A6] > u[A6 + 1])
            break;
          x6(A6);
        }
      }
      function b6() {
        for (; f6 > 1; ) {
          var A6 = f6 - 2;
          A6 > 0 && u[A6 - 1] < u[A6 + 1] && A6--, x6(A6);
        }
      }
      function x6(A6) {
        var I = s[A6], R = u[A6], F = s[A6 + 1], j = u[A6 + 1];
        u[A6] = R + j, A6 === f6 - 3 && (s[A6 + 1] = s[A6 + 2], u[A6 + 1] = u[A6 + 2]), f6--;
        var $ = bM(a[F], a, I, R, 0, r6);
        I += $, R -= $, R !== 0 && (j = Kl(a[I + R - 1], a, F, j, j - 1, r6), j !== 0 && (R <= j ? S(I, R, F, j) : M(I, R, F, j)));
      }
      function S(A6, I, R, F) {
        var j = 0;
        for (j = 0; j < I; j++)
          d6[j] = a[A6 + j];
        var $ = 0, K = R, U = A6;
        if (a[U++] = a[K++], --F === 0) {
          for (j = 0; j < I; j++)
            a[U + j] = d6[$ + j];
          return;
        }
        if (I === 1) {
          for (j = 0; j < F; j++)
            a[U + j] = a[K + j];
          a[U + F] = d6[$];
          return;
        }
        for (var he = t2, ue, pe, _e; ; ) {
          ue = 0, pe = 0, _e = false;
          do
            if (r6(a[K], d6[$]) < 0) {
              if (a[U++] = a[K++], pe++, ue = 0, --F === 0) {
                _e = true;
                break;
              }
            } else if (a[U++] = d6[$++], ue++, pe = 0, --I === 1) {
              _e = true;
              break;
            }
          while ((ue | pe) < he);
          if (_e)
            break;
          do {
            if (ue = bM(a[K], d6, $, I, 0, r6), ue !== 0) {
              for (j = 0; j < ue; j++)
                a[U + j] = d6[$ + j];
              if (U += ue, $ += ue, I -= ue, I <= 1) {
                _e = true;
                break;
              }
            }
            if (a[U++] = a[K++], --F === 0) {
              _e = true;
              break;
            }
            if (pe = Kl(d6[$], a, K, F, 0, r6), pe !== 0) {
              for (j = 0; j < pe; j++)
                a[U + j] = a[K + j];
              if (U += pe, K += pe, F -= pe, F === 0) {
                _e = true;
                break;
              }
            }
            if (a[U++] = d6[$++], --I === 1) {
              _e = true;
              break;
            }
            he--;
          } while (ue >= Jn || pe >= Jn);
          if (_e)
            break;
          he < 0 && (he = 0), he += 2;
        }
        if (t2 = he, t2 < 1 && (t2 = 1), I === 1) {
          for (j = 0; j < F; j++)
            a[U + j] = a[K + j];
          a[U + F] = d6[$];
        } else {
          if (I === 0)
            throw new Error();
          for (j = 0; j < I; j++)
            a[U + j] = d6[$ + j];
        }
      }
      function M(A6, I, R, F) {
        var j = 0;
        for (j = 0; j < F; j++)
          d6[j] = a[R + j];
        var $ = A6 + I - 1, K = F - 1, U = R + F - 1, he = 0, ue = 0;
        if (a[U--] = a[$--], --I === 0) {
          for (he = U - (F - 1), j = 0; j < F; j++)
            a[he + j] = d6[j];
          return;
        }
        if (F === 1) {
          for (U -= I, $ -= I, ue = U + 1, he = $ + 1, j = I - 1; j >= 0; j--)
            a[ue + j] = a[he + j];
          a[U] = d6[K];
          return;
        }
        for (var pe = t2; ; ) {
          var _e = 0, xe = 0, Ae = false;
          do
            if (r6(d6[K], a[$]) < 0) {
              if (a[U--] = a[$--], _e++, xe = 0, --I === 0) {
                Ae = true;
                break;
              }
            } else if (a[U--] = d6[K--], xe++, _e = 0, --F === 1) {
              Ae = true;
              break;
            }
          while ((_e | xe) < pe);
          if (Ae)
            break;
          do {
            if (_e = I - bM(d6[K], a, A6, I, I - 1, r6), _e !== 0) {
              for (U -= _e, $ -= _e, I -= _e, ue = U + 1, he = $ + 1, j = _e - 1; j >= 0; j--)
                a[ue + j] = a[he + j];
              if (I === 0) {
                Ae = true;
                break;
              }
            }
            if (a[U--] = d6[K--], --F === 1) {
              Ae = true;
              break;
            }
            if (xe = F - Kl(a[$], d6, 0, F, F - 1, r6), xe !== 0) {
              for (U -= xe, K -= xe, F -= xe, ue = U + 1, he = K + 1, j = 0; j < xe; j++)
                a[ue + j] = d6[he + j];
              if (F <= 1) {
                Ae = true;
                break;
              }
            }
            if (a[U--] = a[$--], --I === 0) {
              Ae = true;
              break;
            }
            pe--;
          } while (_e >= Jn || xe >= Jn);
          if (Ae)
            break;
          pe < 0 && (pe = 0), pe += 2;
        }
        if (t2 = pe, t2 < 1 && (t2 = 1), F === 1) {
          for (U -= I, $ -= I, ue = U + 1, he = $ + 1, j = I - 1; j >= 0; j--)
            a[ue + j] = a[he + j];
          a[U] = d6[K];
        } else {
          if (F === 0)
            throw new Error();
          for (he = U - (F - 1), j = 0; j < F; j++)
            a[he + j] = d6[j];
        }
      }
      return { mergeRuns: m6, forceMergeRuns: b6, pushRun: v6 };
    }
    function qd(a, r6, t2, s) {
      t2 || (t2 = 0), s || (s = a.length);
      var u = s - t2;
      if (!(u < 2)) {
        var f6 = 0;
        if (u < Dr) {
          f6 = Io(a, t2, s, r6), mf(a, t2, s, t2 + f6, r6);
          return;
        }
        var d6 = EU(a, r6), v6 = ci(u);
        do {
          if (f6 = Io(a, t2, s, r6), f6 < v6) {
            var m6 = u;
            m6 > v6 && (m6 = v6), mf(a, t2, t2 + m6, t2 + f6, r6), f6 = m6;
          }
          d6.pushRun(t2, f6), d6.mergeRuns(), u -= f6, t2 += f6;
        } while (u !== 0);
        d6.forceMergeRuns();
      }
    }
    var ad = 1, _M = 2, Xg = 4, xM = false;
    function D2() {
      xM || (xM = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
    }
    function zl(a, r6) {
      return a.zlevel === r6.zlevel ? a.z === r6.z ? a.z2 - r6.z2 : a.z - r6.z : a.zlevel - r6.zlevel;
    }
    var IU = function() {
      function a() {
        this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = zl;
      }
      return a.prototype.traverse = function(r6, t2) {
        for (var s = 0; s < this._roots.length; s++)
          this._roots[s].traverse(r6, t2);
      }, a.prototype.getDisplayList = function(r6, t2) {
        t2 = t2 || false;
        var s = this._displayList;
        return (r6 || !s.length) && this.updateDisplayList(t2), s;
      }, a.prototype.updateDisplayList = function(r6) {
        this._displayListLen = 0;
        for (var t2 = this._roots, s = this._displayList, u = 0, f6 = t2.length; u < f6; u++)
          this._updateAndAddDisplayable(t2[u], null, r6);
        s.length = this._displayListLen, qd(s, zl);
      }, a.prototype._updateAndAddDisplayable = function(r6, t2, s) {
        if (!(r6.ignore && !s)) {
          r6.beforeUpdate(), r6.update(), r6.afterUpdate();
          var u = r6.getClipPath();
          if (r6.ignoreClip)
            t2 = null;
          else if (u) {
            t2 ? t2 = t2.slice() : t2 = [];
            for (var f6 = u, d6 = r6; f6; )
              f6.parent = d6, f6.updateTransform(), t2.push(f6), d6 = f6, f6 = f6.getClipPath();
          }
          if (r6.childrenRef) {
            for (var v6 = r6.childrenRef(), m6 = 0; m6 < v6.length; m6++) {
              var b6 = v6[m6];
              r6.__dirty && (b6.__dirty |= ad), this._updateAndAddDisplayable(b6, t2, s);
            }
            r6.__dirty = 0;
          } else {
            var x6 = r6;
            t2 && t2.length ? x6.__clipPaths = t2 : x6.__clipPaths && x6.__clipPaths.length > 0 && (x6.__clipPaths = []), isNaN(x6.z) && (D2(), x6.z = 0), isNaN(x6.z2) && (D2(), x6.z2 = 0), isNaN(x6.zlevel) && (D2(), x6.zlevel = 0), this._displayList[this._displayListLen++] = x6;
          }
          var S = r6.getDecalElement && r6.getDecalElement();
          S && this._updateAndAddDisplayable(S, t2, s);
          var M = r6.getTextGuideLine();
          M && this._updateAndAddDisplayable(M, t2, s);
          var A6 = r6.getTextContent();
          A6 && this._updateAndAddDisplayable(A6, t2, s);
        }
      }, a.prototype.addRoot = function(r6) {
        r6.__zr && r6.__zr.storage === this || this._roots.push(r6);
      }, a.prototype.delRoot = function(r6) {
        if (r6 instanceof Array) {
          for (var t2 = 0, s = r6.length; t2 < s; t2++)
            this.delRoot(r6[t2]);
          return;
        }
        var u = Vi(this._roots, r6);
        u >= 0 && this._roots.splice(u, 1);
      }, a.prototype.delAllRoots = function() {
        this._roots = [], this._displayList = [], this._displayListLen = 0;
      }, a.prototype.getRoots = function() {
        return this._roots;
      }, a.prototype.dispose = function() {
        this._displayList = null, this._roots = null;
      }, a;
    }(), b9 = IU, wM;
    wM = ha.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(a) {
      return setTimeout(a, 16);
    };
    var AL = wM, NT = { linear: function(a) {
      return a;
    }, quadraticIn: function(a) {
      return a * a;
    }, quadraticOut: function(a) {
      return a * (2 - a);
    }, quadraticInOut: function(a) {
      return (a *= 2) < 1 ? 0.5 * a * a : -0.5 * (--a * (a - 2) - 1);
    }, cubicIn: function(a) {
      return a * a * a;
    }, cubicOut: function(a) {
      return --a * a * a + 1;
    }, cubicInOut: function(a) {
      return (a *= 2) < 1 ? 0.5 * a * a * a : 0.5 * ((a -= 2) * a * a + 2);
    }, quarticIn: function(a) {
      return a * a * a * a;
    }, quarticOut: function(a) {
      return 1 - --a * a * a * a;
    }, quarticInOut: function(a) {
      return (a *= 2) < 1 ? 0.5 * a * a * a * a : -0.5 * ((a -= 2) * a * a * a - 2);
    }, quinticIn: function(a) {
      return a * a * a * a * a;
    }, quinticOut: function(a) {
      return --a * a * a * a * a + 1;
    }, quinticInOut: function(a) {
      return (a *= 2) < 1 ? 0.5 * a * a * a * a * a : 0.5 * ((a -= 2) * a * a * a * a + 2);
    }, sinusoidalIn: function(a) {
      return 1 - Math.cos(a * Math.PI / 2);
    }, sinusoidalOut: function(a) {
      return Math.sin(a * Math.PI / 2);
    }, sinusoidalInOut: function(a) {
      return 0.5 * (1 - Math.cos(Math.PI * a));
    }, exponentialIn: function(a) {
      return a === 0 ? 0 : Math.pow(1024, a - 1);
    }, exponentialOut: function(a) {
      return a === 1 ? 1 : 1 - Math.pow(2, -10 * a);
    }, exponentialInOut: function(a) {
      return a === 0 ? 0 : a === 1 ? 1 : (a *= 2) < 1 ? 0.5 * Math.pow(1024, a - 1) : 0.5 * (-Math.pow(2, -10 * (a - 1)) + 2);
    }, circularIn: function(a) {
      return 1 - Math.sqrt(1 - a * a);
    }, circularOut: function(a) {
      return Math.sqrt(1 - --a * a);
    }, circularInOut: function(a) {
      return (a *= 2) < 1 ? -0.5 * (Math.sqrt(1 - a * a) - 1) : 0.5 * (Math.sqrt(1 - (a -= 2) * a) + 1);
    }, elasticIn: function(a) {
      var r6, t2 = 0.1, s = 0.4;
      return a === 0 ? 0 : a === 1 ? 1 : (!t2 || t2 < 1 ? (t2 = 1, r6 = s / 4) : r6 = s * Math.asin(1 / t2) / (2 * Math.PI), -(t2 * Math.pow(2, 10 * (a -= 1)) * Math.sin((a - r6) * (2 * Math.PI) / s)));
    }, elasticOut: function(a) {
      var r6, t2 = 0.1, s = 0.4;
      return a === 0 ? 0 : a === 1 ? 1 : (!t2 || t2 < 1 ? (t2 = 1, r6 = s / 4) : r6 = s * Math.asin(1 / t2) / (2 * Math.PI), t2 * Math.pow(2, -10 * a) * Math.sin((a - r6) * (2 * Math.PI) / s) + 1);
    }, elasticInOut: function(a) {
      var r6, t2 = 0.1, s = 0.4;
      return a === 0 ? 0 : a === 1 ? 1 : (!t2 || t2 < 1 ? (t2 = 1, r6 = s / 4) : r6 = s * Math.asin(1 / t2) / (2 * Math.PI), (a *= 2) < 1 ? -0.5 * (t2 * Math.pow(2, 10 * (a -= 1)) * Math.sin((a - r6) * (2 * Math.PI) / s)) : t2 * Math.pow(2, -10 * (a -= 1)) * Math.sin((a - r6) * (2 * Math.PI) / s) * 0.5 + 1);
    }, backIn: function(a) {
      var r6 = 1.70158;
      return a * a * ((r6 + 1) * a - r6);
    }, backOut: function(a) {
      var r6 = 1.70158;
      return --a * a * ((r6 + 1) * a + r6) + 1;
    }, backInOut: function(a) {
      var r6 = 2.5949095;
      return (a *= 2) < 1 ? 0.5 * (a * a * ((r6 + 1) * a - r6)) : 0.5 * ((a -= 2) * a * ((r6 + 1) * a + r6) + 2);
    }, bounceIn: function(a) {
      return 1 - NT.bounceOut(1 - a);
    }, bounceOut: function(a) {
      return a < 1 / 2.75 ? 7.5625 * a * a : a < 2 / 2.75 ? 7.5625 * (a -= 1.5 / 2.75) * a + 0.75 : a < 2.5 / 2.75 ? 7.5625 * (a -= 2.25 / 2.75) * a + 0.9375 : 7.5625 * (a -= 2.625 / 2.75) * a + 0.984375;
    }, bounceInOut: function(a) {
      return a < 0.5 ? NT.bounceIn(a * 2) * 0.5 : NT.bounceOut(a * 2 - 1) * 0.5 + 0.5;
    } }, _9 = NT, ux = Math.pow, Yd = Math.sqrt, cx = 1e-8, EL = 1e-4, SM = Yd(3), CM = 1 / 3, Kg = Df(), Zd = Df(), fx = Df();
    function rg(a) {
      return a > -cx && a < cx;
    }
    function fb(a) {
      return a > cx || a < -cx;
    }
    function Pc(a, r6, t2, s, u) {
      var f6 = 1 - u;
      return f6 * f6 * (f6 * a + 3 * u * r6) + u * u * (u * s + 3 * f6 * t2);
    }
    function x9(a, r6, t2, s, u) {
      var f6 = 1 - u;
      return 3 * (((r6 - a) * f6 + 2 * (t2 - r6) * u) * f6 + (s - t2) * u * u);
    }
    function VT(a, r6, t2, s, u, f6) {
      var d6 = s + 3 * (r6 - t2) - a, v6 = 3 * (t2 - r6 * 2 + a), m6 = 3 * (r6 - a), b6 = a - u, x6 = v6 * v6 - 3 * d6 * m6, S = v6 * m6 - 9 * d6 * b6, M = m6 * m6 - 3 * v6 * b6, A6 = 0;
      if (rg(x6) && rg(S))
        if (rg(v6))
          f6[0] = 0;
        else {
          var I = -m6 / v6;
          I >= 0 && I <= 1 && (f6[A6++] = I);
        }
      else {
        var R = S * S - 4 * x6 * M;
        if (rg(R)) {
          var F = S / x6, I = -v6 / d6 + F, j = -F / 2;
          I >= 0 && I <= 1 && (f6[A6++] = I), j >= 0 && j <= 1 && (f6[A6++] = j);
        } else if (R > 0) {
          var $ = Yd(R), K = x6 * v6 + 1.5 * d6 * (-S + $), U = x6 * v6 + 1.5 * d6 * (-S - $);
          K < 0 ? K = -ux(-K, CM) : K = ux(K, CM), U < 0 ? U = -ux(-U, CM) : U = ux(U, CM);
          var I = (-v6 - (K + U)) / (3 * d6);
          I >= 0 && I <= 1 && (f6[A6++] = I);
        } else {
          var he = (2 * x6 * v6 - 3 * d6 * S) / (2 * Yd(x6 * x6 * x6)), ue = Math.acos(he) / 3, pe = Yd(x6), _e = Math.cos(ue), I = (-v6 - 2 * pe * _e) / (3 * d6), j = (-v6 + pe * (_e + SM * Math.sin(ue))) / (3 * d6), xe = (-v6 + pe * (_e - SM * Math.sin(ue))) / (3 * d6);
          I >= 0 && I <= 1 && (f6[A6++] = I), j >= 0 && j <= 1 && (f6[A6++] = j), xe >= 0 && xe <= 1 && (f6[A6++] = xe);
        }
      }
      return A6;
    }
    function w9(a, r6, t2, s, u) {
      var f6 = 6 * t2 - 12 * r6 + 6 * a, d6 = 9 * r6 + 3 * s - 3 * a - 9 * t2, v6 = 3 * r6 - 3 * a, m6 = 0;
      if (rg(d6)) {
        if (fb(f6)) {
          var b6 = -v6 / f6;
          b6 >= 0 && b6 <= 1 && (u[m6++] = b6);
        }
      } else {
        var x6 = f6 * f6 - 4 * d6 * v6;
        if (rg(x6))
          u[0] = -f6 / (2 * d6);
        else if (x6 > 0) {
          var S = Yd(x6), b6 = (-f6 + S) / (2 * d6), M = (-f6 - S) / (2 * d6);
          b6 >= 0 && b6 <= 1 && (u[m6++] = b6), M >= 0 && M <= 1 && (u[m6++] = M);
        }
      }
      return m6;
    }
    function Jg(a, r6, t2, s, u, f6) {
      var d6 = (r6 - a) * u + a, v6 = (t2 - r6) * u + r6, m6 = (s - t2) * u + t2, b6 = (v6 - d6) * u + d6, x6 = (m6 - v6) * u + v6, S = (x6 - b6) * u + b6;
      f6[0] = a, f6[1] = d6, f6[2] = b6, f6[3] = S, f6[4] = S, f6[5] = x6, f6[6] = m6, f6[7] = s;
    }
    function MM(a, r6, t2, s, u, f6, d6, v6, m6, b6, x6) {
      var S, M = 5e-3, A6 = 1 / 0, I, R, F, j;
      Kg[0] = m6, Kg[1] = b6;
      for (var $ = 0; $ < 1; $ += 0.05)
        Zd[0] = Pc(a, t2, u, d6, $), Zd[1] = Pc(r6, s, f6, v6, $), F = ox(Kg, Zd), F < A6 && (S = $, A6 = F);
      A6 = 1 / 0;
      for (var K = 0; K < 32 && !(M < EL); K++)
        I = S - M, R = S + M, Zd[0] = Pc(a, t2, u, d6, I), Zd[1] = Pc(r6, s, f6, v6, I), F = ox(Zd, Kg), I >= 0 && F < A6 ? (S = I, A6 = F) : (fx[0] = Pc(a, t2, u, d6, R), fx[1] = Pc(r6, s, f6, v6, R), j = ox(fx, Kg), R <= 1 && j < A6 ? (S = R, A6 = j) : M *= 0.5);
      return x6 && (x6[0] = Pc(a, t2, u, d6, S), x6[1] = Pc(r6, s, f6, v6, S)), Yd(A6);
    }
    function IL(a, r6, t2, s, u, f6, d6, v6, m6) {
      for (var b6 = a, x6 = r6, S = 0, M = 1 / m6, A6 = 1; A6 <= m6; A6++) {
        var I = A6 * M, R = Pc(a, t2, u, d6, I), F = Pc(r6, s, f6, v6, I), j = R - b6, $ = F - x6;
        S += Math.sqrt(j * j + $ * $), b6 = R, x6 = F;
      }
      return S;
    }
    function eh(a, r6, t2, s) {
      var u = 1 - s;
      return u * (u * a + 2 * s * r6) + s * s * t2;
    }
    function zT(a, r6, t2, s) {
      return 2 * ((1 - s) * (r6 - a) + s * (t2 - r6));
    }
    function TU(a, r6, t2, s, u) {
      var f6 = a - 2 * r6 + t2, d6 = 2 * (r6 - a), v6 = a - s, m6 = 0;
      if (rg(f6)) {
        if (fb(d6)) {
          var b6 = -v6 / d6;
          b6 >= 0 && b6 <= 1 && (u[m6++] = b6);
        }
      } else {
        var x6 = d6 * d6 - 4 * f6 * v6;
        if (rg(x6)) {
          var b6 = -d6 / (2 * f6);
          b6 >= 0 && b6 <= 1 && (u[m6++] = b6);
        } else if (x6 > 0) {
          var S = Yd(x6), b6 = (-d6 + S) / (2 * f6), M = (-d6 - S) / (2 * f6);
          b6 >= 0 && b6 <= 1 && (u[m6++] = b6), M >= 0 && M <= 1 && (u[m6++] = M);
        }
      }
      return m6;
    }
    function S9(a, r6, t2) {
      var s = a + t2 - 2 * r6;
      return s === 0 ? 0.5 : (a - r6) / s;
    }
    function wc(a, r6, t2, s, u) {
      var f6 = (r6 - a) * s + a, d6 = (t2 - r6) * s + r6, v6 = (d6 - f6) * s + f6;
      u[0] = a, u[1] = f6, u[2] = v6, u[3] = v6, u[4] = d6, u[5] = t2;
    }
    function Sh(a, r6, t2, s, u, f6, d6, v6, m6) {
      var b6, x6 = 5e-3, S = 1 / 0;
      Kg[0] = d6, Kg[1] = v6;
      for (var M = 0; M < 1; M += 0.05) {
        Zd[0] = eh(a, t2, u, M), Zd[1] = eh(r6, s, f6, M);
        var A6 = ox(Kg, Zd);
        A6 < S && (b6 = M, S = A6);
      }
      S = 1 / 0;
      for (var I = 0; I < 32 && !(x6 < EL); I++) {
        var R = b6 - x6, F = b6 + x6;
        Zd[0] = eh(a, t2, u, R), Zd[1] = eh(r6, s, f6, R);
        var A6 = ox(Zd, Kg);
        if (R >= 0 && A6 < S)
          b6 = R, S = A6;
        else {
          fx[0] = eh(a, t2, u, F), fx[1] = eh(r6, s, f6, F);
          var j = ox(fx, Kg);
          F <= 1 && j < S ? (b6 = F, S = j) : x6 *= 0.5;
        }
      }
      return m6 && (m6[0] = eh(a, t2, u, b6), m6[1] = eh(r6, s, f6, b6)), Yd(S);
    }
    function DU(a, r6, t2, s, u, f6, d6) {
      for (var v6 = a, m6 = r6, b6 = 0, x6 = 1 / d6, S = 1; S <= d6; S++) {
        var M = S * x6, A6 = eh(a, t2, u, M), I = eh(r6, s, f6, M), R = A6 - v6, F = I - m6;
        b6 += Math.sqrt(R * R + F * F), v6 = A6, m6 = I;
      }
      return b6;
    }
    var kU = /cubic-bezier\(([0-9,\.e ]+)\)/;
    function BT(a) {
      var r6 = a && kU.exec(a);
      if (r6) {
        var t2 = r6[1].split(","), s = +mu(t2[0]), u = +mu(t2[1]), f6 = +mu(t2[2]), d6 = +mu(t2[3]);
        if (isNaN(s + u + f6 + d6))
          return;
        var v6 = [];
        return function(m6) {
          return m6 <= 0 ? 0 : m6 >= 1 ? 1 : VT(0, s, f6, 1, m6, v6) && Pc(0, u, d6, 1, v6[0]);
        };
      }
    }
    var PU = function() {
      function a(r6) {
        this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = r6.life || 1e3, this._delay = r6.delay || 0, this.loop = r6.loop || false, this.onframe = r6.onframe || kc, this.ondestroy = r6.ondestroy || kc, this.onrestart = r6.onrestart || kc, r6.easing && this.setEasing(r6.easing);
      }
      return a.prototype.step = function(r6, t2) {
        if (this._inited || (this._startTime = r6 + this._delay, this._inited = true), this._paused) {
          this._pausedTime += t2;
          return;
        }
        var s = this._life, u = r6 - this._startTime - this._pausedTime, f6 = u / s;
        f6 < 0 && (f6 = 0), f6 = Math.min(f6, 1);
        var d6 = this.easingFunc, v6 = d6 ? d6(f6) : f6;
        if (this.onframe(v6), f6 === 1)
          if (this.loop) {
            var m6 = u % s;
            this._startTime = r6 - m6, this._pausedTime = 0, this.onrestart();
          } else
            return true;
        return false;
      }, a.prototype.pause = function() {
        this._paused = true;
      }, a.prototype.resume = function() {
        this._paused = false;
      }, a.prototype.setEasing = function(r6) {
        this.easing = r6, this.easingFunc = ti(r6) ? r6 : _9[r6] || BT(r6);
      }, a;
    }(), TL = PU, k2 = function() {
      function a(r6) {
        this.value = r6;
      }
      return a;
    }(), DL = function() {
      function a() {
        this._len = 0;
      }
      return a.prototype.insert = function(r6) {
        var t2 = new k2(r6);
        return this.insertEntry(t2), t2;
      }, a.prototype.insertEntry = function(r6) {
        this.head ? (this.tail.next = r6, r6.prev = this.tail, r6.next = null, this.tail = r6) : this.head = this.tail = r6, this._len++;
      }, a.prototype.remove = function(r6) {
        var t2 = r6.prev, s = r6.next;
        t2 ? t2.next = s : this.head = s, s ? s.prev = t2 : this.tail = t2, r6.next = r6.prev = null, this._len--;
      }, a.prototype.len = function() {
        return this._len;
      }, a.prototype.clear = function() {
        this.head = this.tail = null, this._len = 0;
      }, a;
    }(), P2 = function() {
      function a(r6) {
        this._list = new DL(), this._maxSize = 10, this._map = {}, this._maxSize = r6;
      }
      return a.prototype.put = function(r6, t2) {
        var s = this._list, u = this._map, f6 = null;
        if (u[r6] == null) {
          var d6 = s.len(), v6 = this._lastRemovedEntry;
          if (d6 >= this._maxSize && d6 > 0) {
            var m6 = s.head;
            s.remove(m6), delete u[m6.key], f6 = m6.value, this._lastRemovedEntry = m6;
          }
          v6 ? v6.value = t2 : v6 = new k2(t2), v6.key = r6, s.insertEntry(v6), u[r6] = v6;
        }
        return f6;
      }, a.prototype.get = function(r6) {
        var t2 = this._map[r6], s = this._list;
        if (t2 != null)
          return t2 !== s.tail && (s.remove(t2), s.insertEntry(t2)), t2.value;
      }, a.prototype.clear = function() {
        this._list.clear(), this._map = {};
      }, a.prototype.len = function() {
        return this._list.len();
      }, a;
    }(), Yy = P2, L2 = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
    function Tp(a) {
      return a = Math.round(a), a < 0 ? 0 : a > 255 ? 255 : a;
    }
    function O2(a) {
      return a = Math.round(a), a < 0 ? 0 : a > 360 ? 360 : a;
    }
    function AM(a) {
      return a < 0 ? 0 : a > 1 ? 1 : a;
    }
    function kL(a) {
      var r6 = a;
      return r6.length && r6.charAt(r6.length - 1) === "%" ? Tp(parseFloat(r6) / 100 * 255) : Tp(parseInt(r6, 10));
    }
    function R2(a) {
      var r6 = a;
      return r6.length && r6.charAt(r6.length - 1) === "%" ? AM(parseFloat(r6) / 100) : AM(parseFloat(r6));
    }
    function PL(a, r6, t2) {
      return t2 < 0 ? t2 += 1 : t2 > 1 && (t2 -= 1), t2 * 6 < 1 ? a + (r6 - a) * t2 * 6 : t2 * 2 < 1 ? r6 : t2 * 3 < 2 ? a + (r6 - a) * (2 / 3 - t2) * 6 : a;
    }
    function hb(a, r6, t2) {
      return a + (r6 - a) * t2;
    }
    function Xd(a, r6, t2, s, u) {
      return a[0] = r6, a[1] = t2, a[2] = s, a[3] = u, a;
    }
    function hx(a, r6) {
      return a[0] = r6[0], a[1] = r6[1], a[2] = r6[2], a[3] = r6[3], a;
    }
    var LL = new Yy(20), ot = null;
    function Qg(a, r6) {
      ot && hx(ot, r6), ot = LL.put(a, ot || r6.slice());
    }
    function id2(a, r6) {
      if (a) {
        r6 = r6 || [];
        var t2 = LL.get(a);
        if (t2)
          return hx(r6, t2);
        a = a + "";
        var s = a.replace(/ /g, "").toLowerCase();
        if (s in L2)
          return hx(r6, L2[s]), Qg(a, r6), r6;
        var u = s.length;
        if (s.charAt(0) === "#") {
          if (u === 4 || u === 5) {
            var f6 = parseInt(s.slice(1, 4), 16);
            if (!(f6 >= 0 && f6 <= 4095)) {
              Xd(r6, 0, 0, 0, 1);
              return;
            }
            return Xd(r6, (f6 & 3840) >> 4 | (f6 & 3840) >> 8, f6 & 240 | (f6 & 240) >> 4, f6 & 15 | (f6 & 15) << 4, u === 5 ? parseInt(s.slice(4), 16) / 15 : 1), Qg(a, r6), r6;
          } else if (u === 7 || u === 9) {
            var f6 = parseInt(s.slice(1, 7), 16);
            if (!(f6 >= 0 && f6 <= 16777215)) {
              Xd(r6, 0, 0, 0, 1);
              return;
            }
            return Xd(r6, (f6 & 16711680) >> 16, (f6 & 65280) >> 8, f6 & 255, u === 9 ? parseInt(s.slice(7), 16) / 255 : 1), Qg(a, r6), r6;
          }
          return;
        }
        var d6 = s.indexOf("("), v6 = s.indexOf(")");
        if (d6 !== -1 && v6 + 1 === u) {
          var m6 = s.substr(0, d6), b6 = s.substr(d6 + 1, v6 - (d6 + 1)).split(","), x6 = 1;
          switch (m6) {
            case "rgba":
              if (b6.length !== 4)
                return b6.length === 3 ? Xd(r6, +b6[0], +b6[1], +b6[2], 1) : Xd(r6, 0, 0, 0, 1);
              x6 = R2(b6.pop());
            case "rgb":
              if (b6.length !== 3) {
                Xd(r6, 0, 0, 0, 1);
                return;
              }
              return Xd(r6, kL(b6[0]), kL(b6[1]), kL(b6[2]), x6), Qg(a, r6), r6;
            case "hsla":
              if (b6.length !== 4) {
                Xd(r6, 0, 0, 0, 1);
                return;
              }
              return b6[3] = R2(b6[3]), Dp(b6, r6), Qg(a, r6), r6;
            case "hsl":
              if (b6.length !== 3) {
                Xd(r6, 0, 0, 0, 1);
                return;
              }
              return Dp(b6, r6), Qg(a, r6), r6;
            default:
              return;
          }
        }
        Xd(r6, 0, 0, 0, 1);
      }
    }
    function Dp(a, r6) {
      var t2 = (parseFloat(a[0]) % 360 + 360) % 360 / 360, s = R2(a[1]), u = R2(a[2]), f6 = u <= 0.5 ? u * (s + 1) : u + s - u * s, d6 = u * 2 - f6;
      return r6 = r6 || [], Xd(r6, Tp(PL(d6, f6, t2 + 1 / 3) * 255), Tp(PL(d6, f6, t2) * 255), Tp(PL(d6, f6, t2 - 1 / 3) * 255), 1), a.length === 4 && (r6[3] = a[3]), r6;
    }
    function el(a) {
      if (a) {
        var r6 = a[0] / 255, t2 = a[1] / 255, s = a[2] / 255, u = Math.min(r6, t2, s), f6 = Math.max(r6, t2, s), d6 = f6 - u, v6 = (f6 + u) / 2, m6, b6;
        if (d6 === 0)
          m6 = 0, b6 = 0;
        else {
          v6 < 0.5 ? b6 = d6 / (f6 + u) : b6 = d6 / (2 - f6 - u);
          var x6 = ((f6 - r6) / 6 + d6 / 2) / d6, S = ((f6 - t2) / 6 + d6 / 2) / d6, M = ((f6 - s) / 6 + d6 / 2) / d6;
          r6 === f6 ? m6 = M - S : t2 === f6 ? m6 = 1 / 3 + x6 - M : s === f6 && (m6 = 2 / 3 + S - x6), m6 < 0 && (m6 += 1), m6 > 1 && (m6 -= 1);
        }
        var A6 = [m6 * 360, b6, v6];
        return a[3] != null && A6.push(a[3]), A6;
      }
    }
    function OL(a, r6) {
      var t2 = id2(a);
      if (t2) {
        for (var s = 0; s < 3; s++)
          r6 < 0 ? t2[s] = t2[s] * (1 - r6) | 0 : t2[s] = (255 - t2[s]) * r6 + t2[s] | 0, t2[s] > 255 ? t2[s] = 255 : t2[s] < 0 && (t2[s] = 0);
        return Zy(t2, t2.length === 4 ? "rgba" : "rgb");
      }
    }
    function RL(a, r6, t2) {
      if (!(!(r6 && r6.length) || !(a >= 0 && a <= 1))) {
        t2 = t2 || [];
        var s = a * (r6.length - 1), u = Math.floor(s), f6 = Math.ceil(s), d6 = r6[u], v6 = r6[f6], m6 = s - u;
        return t2[0] = Tp(hb(d6[0], v6[0], m6)), t2[1] = Tp(hb(d6[1], v6[1], m6)), t2[2] = Tp(hb(d6[2], v6[2], m6)), t2[3] = AM(hb(d6[3], v6[3], m6)), t2;
      }
    }
    function LU(a, r6, t2) {
      if (!(!(r6 && r6.length) || !(a >= 0 && a <= 1))) {
        var s = a * (r6.length - 1), u = Math.floor(s), f6 = Math.ceil(s), d6 = id2(r6[u]), v6 = id2(r6[f6]), m6 = s - u, b6 = Zy([Tp(hb(d6[0], v6[0], m6)), Tp(hb(d6[1], v6[1], m6)), Tp(hb(d6[2], v6[2], m6)), AM(hb(d6[3], v6[3], m6))], "rgba");
        return t2 ? { color: b6, leftIndex: u, rightIndex: f6, value: s } : b6;
      }
    }
    function e0(a, r6, t2, s) {
      var u = id2(a);
      if (a)
        return u = el(u), r6 != null && (u[0] = O2(r6)), t2 != null && (u[1] = R2(t2)), s != null && (u[2] = R2(s)), Zy(Dp(u), "rgba");
    }
    function jT(a, r6) {
      var t2 = id2(a);
      if (t2 && r6 != null)
        return t2[3] = AM(r6), Zy(t2, "rgba");
    }
    function Zy(a, r6) {
      if (!(!a || !a.length)) {
        var t2 = a[0] + "," + a[1] + "," + a[2];
        return (r6 === "rgba" || r6 === "hsva" || r6 === "hsla") && (t2 += "," + a[3]), r6 + "(" + t2 + ")";
      }
    }
    function GT(a, r6) {
      var t2 = id2(a);
      return t2 ? (0.299 * t2[0] + 0.587 * t2[1] + 0.114 * t2[2]) * t2[3] / 255 + (1 - t2[3]) * r6 : 0;
    }
    var WT = Math.round;
    function F2(a) {
      var r6;
      if (!a || a === "transparent")
        a = "none";
      else if (typeof a == "string" && a.indexOf("rgba") > -1) {
        var t2 = id2(a);
        t2 && (a = "rgb(" + t2[0] + "," + t2[1] + "," + t2[2] + ")", r6 = t2[3]);
      }
      return { color: a, opacity: r6 == null ? 1 : r6 };
    }
    var gm = 1e-4;
    function db(a) {
      return a < gm && a > -gm;
    }
    function HT(a) {
      return WT(a * 1e3) / 1e3;
    }
    function FL(a) {
      return WT(a * 1e4) / 1e4;
    }
    function OU(a) {
      return "matrix(" + HT(a[0]) + "," + HT(a[1]) + "," + HT(a[2]) + "," + HT(a[3]) + "," + FL(a[4]) + "," + FL(a[5]) + ")";
    }
    var RU = { left: "start", right: "end", center: "middle", middle: "middle" };
    function Xy(a, r6, t2) {
      return t2 === "top" ? a += r6 / 2 : t2 === "bottom" && (a -= r6 / 2), a;
    }
    function FU(a) {
      return a && (a.shadowBlur || a.shadowOffsetX || a.shadowOffsetY);
    }
    function NU(a) {
      var r6 = a.style, t2 = a.getGlobalScale();
      return [r6.shadowColor, (r6.shadowBlur || 0).toFixed(2), (r6.shadowOffsetX || 0).toFixed(2), (r6.shadowOffsetY || 0).toFixed(2), t2[0], t2[1]].join(",");
    }
    function C9(a) {
      return a && !!a.image;
    }
    function VU(a) {
      return a && !!a.svgElement;
    }
    function zU(a) {
      return C9(a) || VU(a);
    }
    function pb(a) {
      return a.type === "linear";
    }
    function M9(a) {
      return a.type === "radial";
    }
    function BU(a) {
      return a && (a.type === "linear" || a.type === "radial");
    }
    function kp(a) {
      return "url(#" + a + ")";
    }
    function A9(a) {
      var r6 = a.getGlobalScale(), t2 = Math.max(r6[0], r6[1]);
      return Math.max(Math.ceil(Math.log(t2) / Math.log(10)), 1);
    }
    function E9(a) {
      var r6 = a.x || 0, t2 = a.y || 0, s = (a.rotation || 0) * vM, u = qi(a.scaleX, 1), f6 = qi(a.scaleY, 1), d6 = a.skewX || 0, v6 = a.skewY || 0, m6 = [];
      return (r6 || t2) && m6.push("translate(" + r6 + "px," + t2 + "px)"), s && m6.push("rotate(" + s + ")"), (u !== 1 || f6 !== 1) && m6.push("scale(" + u + "," + f6 + ")"), (d6 || v6) && m6.push("skew(" + WT(d6 * vM) + "deg, " + WT(v6 * vM) + "deg)"), m6.join(" ");
    }
    var jU = function() {
      return ha.hasGlobalWindow && ti(window.btoa) ? function(a) {
        return window.btoa(unescape(a));
      } : typeof Buffer != "undefined" ? function(a) {
        return Buffer.from(a).toString("base64");
      } : function(a) {
        return null;
      };
    }(), NL = Array.prototype.slice;
    function Ky(a, r6, t2) {
      return (r6 - a) * t2 + a;
    }
    function $T(a, r6, t2, s) {
      for (var u = r6.length, f6 = 0; f6 < u; f6++)
        a[f6] = Ky(r6[f6], t2[f6], s);
      return a;
    }
    function I9(a, r6, t2, s) {
      for (var u = r6.length, f6 = u && r6[0].length, d6 = 0; d6 < u; d6++) {
        a[d6] || (a[d6] = []);
        for (var v6 = 0; v6 < f6; v6++)
          a[d6][v6] = Ky(r6[d6][v6], t2[d6][v6], s);
      }
      return a;
    }
    function UT(a, r6, t2, s) {
      for (var u = r6.length, f6 = 0; f6 < u; f6++)
        a[f6] = r6[f6] + t2[f6] * s;
      return a;
    }
    function T9(a, r6, t2, s) {
      for (var u = r6.length, f6 = u && r6[0].length, d6 = 0; d6 < u; d6++) {
        a[d6] || (a[d6] = []);
        for (var v6 = 0; v6 < f6; v6++)
          a[d6][v6] = r6[d6][v6] + t2[d6][v6] * s;
      }
      return a;
    }
    function VL(a, r6) {
      for (var t2 = a.length, s = r6.length, u = t2 > s ? r6 : a, f6 = Math.min(t2, s), d6 = u[f6 - 1] || { color: [0, 0, 0, 0], offset: 0 }, v6 = f6; v6 < Math.max(t2, s); v6++)
        u.push({ offset: d6.offset, color: d6.color.slice() });
    }
    function EM(a, r6, t2) {
      var s = a, u = r6;
      if (!(!s.push || !u.push)) {
        var f6 = s.length, d6 = u.length;
        if (f6 !== d6) {
          var v6 = f6 > d6;
          if (v6)
            s.length = d6;
          else
            for (var m6 = f6; m6 < d6; m6++)
              s.push(t2 === 1 ? u[m6] : NL.call(u[m6]));
        }
        for (var b6 = s[0] && s[0].length, m6 = 0; m6 < s.length; m6++)
          if (t2 === 1)
            isNaN(s[m6]) && (s[m6] = u[m6]);
          else
            for (var x6 = 0; x6 < b6; x6++)
              isNaN(s[m6][x6]) && (s[m6][x6] = u[m6][x6]);
      }
    }
    function vb(a) {
      if (rd(a)) {
        var r6 = a.length;
        if (rd(a[0])) {
          for (var t2 = [], s = 0; s < r6; s++)
            t2.push(NL.call(a[s]));
          return t2;
        }
        return NL.call(a);
      }
      return a;
    }
    function qT(a) {
      return a[0] = Math.floor(a[0]) || 0, a[1] = Math.floor(a[1]) || 0, a[2] = Math.floor(a[2]) || 0, a[3] = a[3] == null ? 1 : a[3], "rgba(" + a.join(",") + ")";
    }
    function D9(a) {
      return rd(a && a[0]) ? 2 : 1;
    }
    var YT = 0, ag = 1, ZT = 2, t0 = 3, Pp = 4, zL = 5, BL = 6;
    function jL(a) {
      return a === Pp || a === zL;
    }
    function gb(a) {
      return a === ag || a === ZT;
    }
    var ig = [0, 0, 0, 0], k9 = function() {
      function a(r6) {
        this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = r6;
      }
      return a.prototype.isFinished = function() {
        return this._finished;
      }, a.prototype.setFinished = function() {
        this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
      }, a.prototype.needsAnimate = function() {
        return this.keyframes.length >= 1;
      }, a.prototype.getAdditiveTrack = function() {
        return this._additiveTrack;
      }, a.prototype.addKeyframe = function(r6, t2, s) {
        this._needsSort = true;
        var u = this.keyframes, f6 = u.length, d6 = false, v6 = BL, m6 = t2;
        if (rd(t2)) {
          var b6 = D9(t2);
          v6 = b6, (b6 === 1 && !ks(t2[0]) || b6 === 2 && !ks(t2[0][0])) && (d6 = true);
        } else if (ks(t2) && !dM(t2))
          v6 = YT;
        else if (_a2(t2))
          if (!isNaN(+t2))
            v6 = YT;
          else {
            var x6 = id2(t2);
            x6 && (m6 = x6, v6 = t0);
          }
        else if (au(t2)) {
          var S = qn({}, m6);
          S.colorStops = wr(t2.colorStops, function(A6) {
            return { offset: A6.offset, color: id2(A6.color) };
          }), pb(t2) ? v6 = Pp : M9(t2) && (v6 = zL), m6 = S;
        }
        f6 === 0 ? this.valType = v6 : (v6 !== this.valType || v6 === BL) && (d6 = true), this.discrete = this.discrete || d6;
        var M = { time: r6, value: m6, rawValue: t2, percent: 0 };
        return s && (M.easing = s, M.easingFunc = ti(s) ? s : _9[s] || BT(s)), u.push(M), M;
      }, a.prototype.prepare = function(r6, t2) {
        var s = this.keyframes;
        this._needsSort && s.sort(function(R, F) {
          return R.time - F.time;
        });
        for (var u = this.valType, f6 = s.length, d6 = s[f6 - 1], v6 = this.discrete, m6 = gb(u), b6 = jL(u), x6 = 0; x6 < f6; x6++) {
          var S = s[x6], M = S.value, A6 = d6.value;
          S.percent = S.time / r6, v6 || (m6 && x6 !== f6 - 1 ? EM(M, A6, u) : b6 && VL(M.colorStops, A6.colorStops));
        }
        if (!v6 && u !== zL && t2 && this.needsAnimate() && t2.needsAnimate() && u === t2.valType && !t2._finished) {
          this._additiveTrack = t2;
          for (var I = s[0].value, x6 = 0; x6 < f6; x6++)
            u === YT ? s[x6].additiveValue = s[x6].value - I : u === t0 ? s[x6].additiveValue = UT([], s[x6].value, I, -1) : gb(u) && (s[x6].additiveValue = u === ag ? UT([], s[x6].value, I, -1) : T9([], s[x6].value, I, -1));
        }
      }, a.prototype.step = function(r6, t2) {
        if (!this._finished) {
          this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
          var s = this._additiveTrack != null, u = s ? "additiveValue" : "value", f6 = this.valType, d6 = this.keyframes, v6 = d6.length, m6 = this.propName, b6 = f6 === t0, x6, S = this._lastFr, M = Math.min, A6, I;
          if (v6 === 1)
            A6 = I = d6[0];
          else {
            if (t2 < 0)
              x6 = 0;
            else if (t2 < this._lastFrP) {
              var R = M(S + 1, v6 - 1);
              for (x6 = R; x6 >= 0 && !(d6[x6].percent <= t2); x6--)
                ;
              x6 = M(x6, v6 - 2);
            } else {
              for (x6 = S; x6 < v6 && !(d6[x6].percent > t2); x6++)
                ;
              x6 = M(x6 - 1, v6 - 2);
            }
            I = d6[x6 + 1], A6 = d6[x6];
          }
          if (A6 && I) {
            this._lastFr = x6, this._lastFrP = t2;
            var F = I.percent - A6.percent, j = F === 0 ? 1 : M((t2 - A6.percent) / F, 1);
            I.easingFunc && (j = I.easingFunc(j));
            var $ = s ? this._additiveValue : b6 ? ig : r6[m6];
            if ((gb(f6) || b6) && !$ && ($ = this._additiveValue = []), this.discrete)
              r6[m6] = j < 1 ? A6.rawValue : I.rawValue;
            else if (gb(f6))
              f6 === ag ? $T($, A6[u], I[u], j) : I9($, A6[u], I[u], j);
            else if (jL(f6)) {
              var K = A6[u], U = I[u], he = f6 === Pp;
              r6[m6] = { type: he ? "linear" : "radial", x: Ky(K.x, U.x, j), y: Ky(K.y, U.y, j), colorStops: wr(K.colorStops, function(pe, _e) {
                var xe = U.colorStops[_e];
                return { offset: Ky(pe.offset, xe.offset, j), color: qT($T([], pe.color, xe.color, j)) };
              }), global: U.global }, he ? (r6[m6].x2 = Ky(K.x2, U.x2, j), r6[m6].y2 = Ky(K.y2, U.y2, j)) : r6[m6].r = Ky(K.r, U.r, j);
            } else if (b6)
              $T($, A6[u], I[u], j), s || (r6[m6] = qT($));
            else {
              var ue = Ky(A6[u], I[u], j);
              s ? this._additiveValue = ue : r6[m6] = ue;
            }
            s && this._addToTarget(r6);
          }
        }
      }, a.prototype._addToTarget = function(r6) {
        var t2 = this.valType, s = this.propName, u = this._additiveValue;
        t2 === YT ? r6[s] = r6[s] + u : t2 === t0 ? (id2(r6[s], ig), UT(ig, ig, u, 1), r6[s] = qT(ig)) : t2 === ag ? UT(r6[s], r6[s], u, 1) : t2 === ZT && T9(r6[s], r6[s], u, 1);
      }, a;
    }(), GL = function() {
      function a(r6, t2, s, u) {
        if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = r6, this._loop = t2, t2 && u) {
          cb("Can' use additive animation on looped animation.");
          return;
        }
        this._additiveAnimators = u, this._allowDiscrete = s;
      }
      return a.prototype.getMaxTime = function() {
        return this._maxTime;
      }, a.prototype.getDelay = function() {
        return this._delay;
      }, a.prototype.getLoop = function() {
        return this._loop;
      }, a.prototype.getTarget = function() {
        return this._target;
      }, a.prototype.changeTarget = function(r6) {
        this._target = r6;
      }, a.prototype.when = function(r6, t2, s) {
        return this.whenWithKeys(r6, t2, Po(t2), s);
      }, a.prototype.whenWithKeys = function(r6, t2, s, u) {
        for (var f6 = this._tracks, d6 = 0; d6 < s.length; d6++) {
          var v6 = s[d6], m6 = f6[v6];
          if (!m6) {
            m6 = f6[v6] = new k9(v6);
            var b6 = void 0, x6 = this._getAdditiveTrack(v6);
            if (x6) {
              var S = x6.keyframes, M = S[S.length - 1];
              b6 = M && M.value, x6.valType === t0 && b6 && (b6 = qT(b6));
            } else
              b6 = this._target[v6];
            if (b6 == null)
              continue;
            r6 > 0 && m6.addKeyframe(0, vb(b6), u), this._trackKeys.push(v6);
          }
          m6.addKeyframe(r6, vb(t2[v6]), u);
        }
        return this._maxTime = Math.max(this._maxTime, r6), this;
      }, a.prototype.pause = function() {
        this._clip.pause(), this._paused = true;
      }, a.prototype.resume = function() {
        this._clip.resume(), this._paused = false;
      }, a.prototype.isPaused = function() {
        return !!this._paused;
      }, a.prototype.duration = function(r6) {
        return this._maxTime = r6, this._force = true, this;
      }, a.prototype._doneCallback = function() {
        this._setTracksFinished(), this._clip = null;
        var r6 = this._doneCbs;
        if (r6)
          for (var t2 = r6.length, s = 0; s < t2; s++)
            r6[s].call(this);
      }, a.prototype._abortedCallback = function() {
        this._setTracksFinished();
        var r6 = this.animation, t2 = this._abortedCbs;
        if (r6 && r6.removeClip(this._clip), this._clip = null, t2)
          for (var s = 0; s < t2.length; s++)
            t2[s].call(this);
      }, a.prototype._setTracksFinished = function() {
        for (var r6 = this._tracks, t2 = this._trackKeys, s = 0; s < t2.length; s++)
          r6[t2[s]].setFinished();
      }, a.prototype._getAdditiveTrack = function(r6) {
        var t2, s = this._additiveAnimators;
        if (s)
          for (var u = 0; u < s.length; u++) {
            var f6 = s[u].getTrack(r6);
            f6 && (t2 = f6);
          }
        return t2;
      }, a.prototype.start = function(r6) {
        if (!(this._started > 0)) {
          this._started = 1;
          for (var t2 = this, s = [], u = this._maxTime || 0, f6 = 0; f6 < this._trackKeys.length; f6++) {
            var d6 = this._trackKeys[f6], v6 = this._tracks[d6], m6 = this._getAdditiveTrack(d6), b6 = v6.keyframes, x6 = b6.length;
            if (v6.prepare(u, m6), v6.needsAnimate())
              if (!this._allowDiscrete && v6.discrete) {
                var S = b6[x6 - 1];
                S && (t2._target[v6.propName] = S.rawValue), v6.setFinished();
              } else
                s.push(v6);
          }
          if (s.length || this._force) {
            var M = new TL({ life: u, loop: this._loop, delay: this._delay || 0, onframe: function(A6) {
              t2._started = 2;
              var I = t2._additiveAnimators;
              if (I) {
                for (var R = false, F = 0; F < I.length; F++)
                  if (I[F]._clip) {
                    R = true;
                    break;
                  }
                R || (t2._additiveAnimators = null);
              }
              for (var F = 0; F < s.length; F++)
                s[F].step(t2._target, A6);
              var j = t2._onframeCbs;
              if (j)
                for (var F = 0; F < j.length; F++)
                  j[F](t2._target, A6);
            }, ondestroy: function() {
              t2._doneCallback();
            } });
            this._clip = M, this.animation && this.animation.addClip(M), r6 && M.setEasing(r6);
          } else
            this._doneCallback();
          return this;
        }
      }, a.prototype.stop = function(r6) {
        if (this._clip) {
          var t2 = this._clip;
          r6 && t2.onframe(1), this._abortedCallback();
        }
      }, a.prototype.delay = function(r6) {
        return this._delay = r6, this;
      }, a.prototype.during = function(r6) {
        return r6 && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(r6)), this;
      }, a.prototype.done = function(r6) {
        return r6 && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(r6)), this;
      }, a.prototype.aborted = function(r6) {
        return r6 && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(r6)), this;
      }, a.prototype.getClip = function() {
        return this._clip;
      }, a.prototype.getTrack = function(r6) {
        return this._tracks[r6];
      }, a.prototype.getTracks = function() {
        var r6 = this;
        return wr(this._trackKeys, function(t2) {
          return r6._tracks[t2];
        });
      }, a.prototype.stopTracks = function(r6, t2) {
        if (!r6.length || !this._clip)
          return true;
        for (var s = this._tracks, u = this._trackKeys, f6 = 0; f6 < r6.length; f6++) {
          var d6 = s[r6[f6]];
          d6 && !d6.isFinished() && (t2 ? d6.step(this._target, 1) : this._started === 1 && d6.step(this._target, 0), d6.setFinished());
        }
        for (var v6 = true, f6 = 0; f6 < u.length; f6++)
          if (!s[u[f6]].isFinished()) {
            v6 = false;
            break;
          }
        return v6 && this._abortedCallback(), v6;
      }, a.prototype.saveTo = function(r6, t2, s) {
        if (r6) {
          t2 = t2 || this._trackKeys;
          for (var u = 0; u < t2.length; u++) {
            var f6 = t2[u], d6 = this._tracks[f6];
            if (!(!d6 || d6.isFinished())) {
              var v6 = d6.keyframes, m6 = v6[s ? 0 : v6.length - 1];
              m6 && (r6[f6] = vb(m6.rawValue));
            }
          }
        }
      }, a.prototype.__changeFinalValue = function(r6, t2) {
        t2 = t2 || Po(r6);
        for (var s = 0; s < t2.length; s++) {
          var u = t2[s], f6 = this._tracks[u];
          if (f6) {
            var d6 = f6.keyframes;
            if (d6.length > 1) {
              var v6 = d6.pop();
              f6.addKeyframe(v6.time, r6[u]), f6.prepare(this._maxTime, f6.getAdditiveTrack());
            }
          }
        }
      }, a;
    }();
    function Jy() {
      return new Date().getTime();
    }
    var GU = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this) || this;
        return s._running = false, s._time = 0, s._pausedTime = 0, s._pauseStart = 0, s._paused = false, t2 = t2 || {}, s.stage = t2.stage || {}, s;
      }
      return r6.prototype.addClip = function(t2) {
        t2.animation && this.removeClip(t2), this._head ? (this._tail.next = t2, t2.prev = this._tail, t2.next = null, this._tail = t2) : this._head = this._tail = t2, t2.animation = this;
      }, r6.prototype.addAnimator = function(t2) {
        t2.animation = this;
        var s = t2.getClip();
        s && this.addClip(s);
      }, r6.prototype.removeClip = function(t2) {
        if (t2.animation) {
          var s = t2.prev, u = t2.next;
          s ? s.next = u : this._head = u, u ? u.prev = s : this._tail = s, t2.next = t2.prev = t2.animation = null;
        }
      }, r6.prototype.removeAnimator = function(t2) {
        var s = t2.getClip();
        s && this.removeClip(s), t2.animation = null;
      }, r6.prototype.update = function(t2) {
        for (var s = Jy() - this._pausedTime, u = s - this._time, f6 = this._head; f6; ) {
          var d6 = f6.next, v6 = f6.step(s, u);
          v6 && (f6.ondestroy(), this.removeClip(f6)), f6 = d6;
        }
        this._time = s, t2 || (this.trigger("frame", u), this.stage.update && this.stage.update());
      }, r6.prototype._startLoop = function() {
        var t2 = this;
        this._running = true;
        function s() {
          t2._running && (AL(s), !t2._paused && t2.update());
        }
        AL(s);
      }, r6.prototype.start = function() {
        this._running || (this._time = Jy(), this._pausedTime = 0, this._startLoop());
      }, r6.prototype.stop = function() {
        this._running = false;
      }, r6.prototype.pause = function() {
        this._paused || (this._pauseStart = Jy(), this._paused = true);
      }, r6.prototype.resume = function() {
        this._paused && (this._pausedTime += Jy() - this._pauseStart, this._paused = false);
      }, r6.prototype.clear = function() {
        for (var t2 = this._head; t2; ) {
          var s = t2.next;
          t2.prev = t2.next = t2.animation = null, t2 = s;
        }
        this._head = this._tail = null;
      }, r6.prototype.isFinished = function() {
        return this._head == null;
      }, r6.prototype.animate = function(t2, s) {
        s = s || {}, this.start();
        var u = new GL(t2, s.loop);
        return this.addAnimator(u), u;
      }, r6;
    }(Ip), P9 = GU, Ch = 300, IM = ha.domSupported, XT = function() {
      var a = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], r6 = ["touchstart", "touchend", "touchmove"], t2 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, s = wr(a, function(u) {
        var f6 = u.replace("mouse", "pointer");
        return t2.hasOwnProperty(f6) ? f6 : u;
      });
      return { mouse: a, touch: r6, pointer: s };
    }(), n0 = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, KT = false;
    function N2(a) {
      var r6 = a.pointerType;
      return r6 === "pen" || r6 === "touch";
    }
    function dx(a) {
      a.touching = true, a.touchTimer != null && (clearTimeout(a.touchTimer), a.touchTimer = null), a.touchTimer = setTimeout(function() {
        a.touching = false, a.touchTimer = null;
      }, 700);
    }
    function JT(a) {
      a && (a.zrByTouch = true);
    }
    function Kd(a, r6) {
      return wh(a.dom, new WU(a, r6), true);
    }
    function QT(a, r6) {
      for (var t2 = r6, s = false; t2 && t2.nodeType !== 9 && !(s = t2.domBelongToZr || t2 !== r6 && t2 === a.painterRoot); )
        t2 = t2.parentNode;
      return s;
    }
    var WU = function() {
      function a(r6, t2) {
        this.stopPropagation = kc, this.stopImmediatePropagation = kc, this.preventDefault = kc, this.type = t2.type, this.target = this.currentTarget = r6.dom, this.pointerType = t2.pointerType, this.clientX = t2.clientX, this.clientY = t2.clientY;
      }
      return a;
    }(), r0 = { mousedown: function(a) {
      a = wh(this.dom, a), this.__mayPointerCapture = [a.zrX, a.zrY], this.trigger("mousedown", a);
    }, mousemove: function(a) {
      a = wh(this.dom, a);
      var r6 = this.__mayPointerCapture;
      r6 && (a.zrX !== r6[0] || a.zrY !== r6[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", a);
    }, mouseup: function(a) {
      a = wh(this.dom, a), this.__togglePointerCapture(false), this.trigger("mouseup", a);
    }, mouseout: function(a) {
      a = wh(this.dom, a);
      var r6 = a.toElement || a.relatedTarget;
      QT(this, r6) || (this.__pointerCapturing && (a.zrEventControl = "no_globalout"), this.trigger("mouseout", a));
    }, wheel: function(a) {
      KT = true, a = wh(this.dom, a), this.trigger("mousewheel", a);
    }, mousewheel: function(a) {
      KT || (a = wh(this.dom, a), this.trigger("mousewheel", a));
    }, touchstart: function(a) {
      a = wh(this.dom, a), JT(a), this.__lastTouchMoment = new Date(), this.handler.processGesture(a, "start"), r0.mousemove.call(this, a), r0.mousedown.call(this, a);
    }, touchmove: function(a) {
      a = wh(this.dom, a), JT(a), this.handler.processGesture(a, "change"), r0.mousemove.call(this, a);
    }, touchend: function(a) {
      a = wh(this.dom, a), JT(a), this.handler.processGesture(a, "end"), r0.mouseup.call(this, a), +new Date() - +this.__lastTouchMoment < Ch && r0.click.call(this, a);
    }, pointerdown: function(a) {
      r0.mousedown.call(this, a);
    }, pointermove: function(a) {
      N2(a) || r0.mousemove.call(this, a);
    }, pointerup: function(a) {
      r0.mouseup.call(this, a);
    }, pointerout: function(a) {
      N2(a) || r0.mouseout.call(this, a);
    } };
    Ne(["click", "dblclick", "contextmenu"], function(a) {
      r0[a] = function(r6) {
        r6 = wh(this.dom, r6), this.trigger(a, r6);
      };
    });
    var WL = { pointermove: function(a) {
      N2(a) || WL.mousemove.call(this, a);
    }, pointerup: function(a) {
      WL.mouseup.call(this, a);
    }, mousemove: function(a) {
      this.trigger("mousemove", a);
    }, mouseup: function(a) {
      var r6 = this.__pointerCapturing;
      this.__togglePointerCapture(false), this.trigger("mouseup", a), r6 && (a.zrEventControl = "only_globalout", this.trigger("mouseout", a));
    } };
    function HL(a, r6) {
      var t2 = r6.domHandlers;
      ha.pointerEventsSupported ? Ne(XT.pointer, function(s) {
        mb(r6, s, function(u) {
          t2[s].call(a, u);
        });
      }) : (ha.touchEventsSupported && Ne(XT.touch, function(s) {
        mb(r6, s, function(u) {
          t2[s].call(a, u), dx(r6);
        });
      }), Ne(XT.mouse, function(s) {
        mb(r6, s, function(u) {
          u = wL(u), r6.touching || t2[s].call(a, u);
        });
      }));
    }
    function HU(a, r6) {
      ha.pointerEventsSupported ? Ne(n0.pointer, t2) : ha.touchEventsSupported || Ne(n0.mouse, t2);
      function t2(s) {
        function u(f6) {
          f6 = wL(f6), QT(a, f6.target) || (f6 = Kd(a, f6), r6.domHandlers[s].call(a, f6));
        }
        mb(r6, s, u, { capture: true });
      }
    }
    function mb(a, r6, t2, s) {
      a.mounted[r6] = t2, a.listenerOpts[r6] = s, SL(a.domTarget, r6, t2, s);
    }
    function eD(a) {
      var r6 = a.mounted;
      for (var t2 in r6)
        r6.hasOwnProperty(t2) && CL(a.domTarget, t2, r6[t2], a.listenerOpts[t2]);
      a.mounted = {};
    }
    var L9 = function() {
      function a(r6, t2) {
        this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = r6, this.domHandlers = t2;
      }
      return a;
    }(), $U = function(a) {
      tt(r6, a);
      function r6(t2, s) {
        var u = a.call(this) || this;
        return u.__pointerCapturing = false, u.dom = t2, u.painterRoot = s, u._localHandlerScope = new L9(t2, r0), IM && (u._globalHandlerScope = new L9(document, WL)), HL(u, u._localHandlerScope), u;
      }
      return r6.prototype.dispose = function() {
        eD(this._localHandlerScope), IM && eD(this._globalHandlerScope);
      }, r6.prototype.setCursor = function(t2) {
        this.dom.style && (this.dom.style.cursor = t2 || "default");
      }, r6.prototype.__togglePointerCapture = function(t2) {
        if (this.__mayPointerCapture = null, IM && +this.__pointerCapturing ^ +t2) {
          this.__pointerCapturing = t2;
          var s = this._globalHandlerScope;
          t2 ? HU(this, s) : eD(s);
        }
      }, r6;
    }(Ip), TM = $U, O9 = 1;
    ha.hasGlobalWindow && (O9 = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
    var tD = O9, DM = 0.4, nD = "#333", $L = "#ccc", UU = "#eee";
    function og() {
      return [1, 0, 0, 1, 0, 0];
    }
    function kM(a) {
      return a[0] = 1, a[1] = 0, a[2] = 0, a[3] = 1, a[4] = 0, a[5] = 0, a;
    }
    function PM(a, r6) {
      return a[0] = r6[0], a[1] = r6[1], a[2] = r6[2], a[3] = r6[3], a[4] = r6[4], a[5] = r6[5], a;
    }
    function Qy(a, r6, t2) {
      var s = r6[0] * t2[0] + r6[2] * t2[1], u = r6[1] * t2[0] + r6[3] * t2[1], f6 = r6[0] * t2[2] + r6[2] * t2[3], d6 = r6[1] * t2[2] + r6[3] * t2[3], v6 = r6[0] * t2[4] + r6[2] * t2[5] + r6[4], m6 = r6[1] * t2[4] + r6[3] * t2[5] + r6[5];
      return a[0] = s, a[1] = u, a[2] = f6, a[3] = d6, a[4] = v6, a[5] = m6, a;
    }
    function sg(a, r6, t2) {
      return a[0] = r6[0], a[1] = r6[1], a[2] = r6[2], a[3] = r6[3], a[4] = r6[4] + t2[0], a[5] = r6[5] + t2[1], a;
    }
    function yb(a, r6, t2) {
      var s = r6[0], u = r6[2], f6 = r6[4], d6 = r6[1], v6 = r6[3], m6 = r6[5], b6 = Math.sin(t2), x6 = Math.cos(t2);
      return a[0] = s * x6 + d6 * b6, a[1] = -s * b6 + d6 * x6, a[2] = u * x6 + v6 * b6, a[3] = -u * b6 + x6 * v6, a[4] = x6 * f6 + b6 * m6, a[5] = x6 * m6 - b6 * f6, a;
    }
    function rD(a, r6, t2) {
      var s = t2[0], u = t2[1];
      return a[0] = r6[0] * s, a[1] = r6[1] * u, a[2] = r6[2] * s, a[3] = r6[3] * u, a[4] = r6[4] * s, a[5] = r6[5] * u, a;
    }
    function px(a, r6) {
      var t2 = r6[0], s = r6[2], u = r6[4], f6 = r6[1], d6 = r6[3], v6 = r6[5], m6 = t2 * d6 - f6 * s;
      return m6 ? (m6 = 1 / m6, a[0] = d6 * m6, a[1] = -f6 * m6, a[2] = -s * m6, a[3] = t2 * m6, a[4] = (s * v6 - d6 * u) * m6, a[5] = (f6 * u - t2 * v6) * m6, a) : null;
    }
    function aD(a) {
      var r6 = og();
      return PM(r6, a), r6;
    }
    var R9 = kM, UL = 5e-5;
    function bb(a) {
      return a > UL || a < -UL;
    }
    var vx = [], gx = [], qL = og(), LM = Math.abs, F9 = function() {
      function a() {
      }
      return a.prototype.getLocalTransform = function(r6) {
        return a.getLocalTransform(this, r6);
      }, a.prototype.setPosition = function(r6) {
        this.x = r6[0], this.y = r6[1];
      }, a.prototype.setScale = function(r6) {
        this.scaleX = r6[0], this.scaleY = r6[1];
      }, a.prototype.setSkew = function(r6) {
        this.skewX = r6[0], this.skewY = r6[1];
      }, a.prototype.setOrigin = function(r6) {
        this.originX = r6[0], this.originY = r6[1];
      }, a.prototype.needLocalTransform = function() {
        return bb(this.rotation) || bb(this.x) || bb(this.y) || bb(this.scaleX - 1) || bb(this.scaleY - 1) || bb(this.skewX) || bb(this.skewY);
      }, a.prototype.updateTransform = function() {
        var r6 = this.parent && this.parent.transform, t2 = this.needLocalTransform(), s = this.transform;
        if (!(t2 || r6)) {
          s && R9(s);
          return;
        }
        s = s || og(), t2 ? this.getLocalTransform(s) : R9(s), r6 && (t2 ? Qy(s, r6, s) : PM(s, r6)), this.transform = s, this._resolveGlobalScaleRatio(s);
      }, a.prototype._resolveGlobalScaleRatio = function(r6) {
        var t2 = this.globalScaleRatio;
        if (t2 != null && t2 !== 1) {
          this.getGlobalScale(vx);
          var s = vx[0] < 0 ? -1 : 1, u = vx[1] < 0 ? -1 : 1, f6 = ((vx[0] - s) * t2 + s) / vx[0] || 0, d6 = ((vx[1] - u) * t2 + u) / vx[1] || 0;
          r6[0] *= f6, r6[1] *= f6, r6[2] *= d6, r6[3] *= d6;
        }
        this.invTransform = this.invTransform || og(), px(this.invTransform, r6);
      }, a.prototype.getComputedTransform = function() {
        for (var r6 = this, t2 = []; r6; )
          t2.push(r6), r6 = r6.parent;
        for (; r6 = t2.pop(); )
          r6.updateTransform();
        return this.transform;
      }, a.prototype.setLocalTransform = function(r6) {
        if (r6) {
          var t2 = r6[0] * r6[0] + r6[1] * r6[1], s = r6[2] * r6[2] + r6[3] * r6[3], u = Math.atan2(r6[1], r6[0]), f6 = Math.PI / 2 + u - Math.atan2(r6[3], r6[2]);
          s = Math.sqrt(s) * Math.cos(f6), t2 = Math.sqrt(t2), this.skewX = f6, this.skewY = 0, this.rotation = -u, this.x = +r6[4], this.y = +r6[5], this.scaleX = t2, this.scaleY = s, this.originX = 0, this.originY = 0;
        }
      }, a.prototype.decomposeTransform = function() {
        if (this.transform) {
          var r6 = this.parent, t2 = this.transform;
          r6 && r6.transform && (Qy(gx, r6.invTransform, t2), t2 = gx);
          var s = this.originX, u = this.originY;
          (s || u) && (qL[4] = s, qL[5] = u, Qy(gx, t2, qL), gx[4] -= s, gx[5] -= u, t2 = gx), this.setLocalTransform(t2);
        }
      }, a.prototype.getGlobalScale = function(r6) {
        var t2 = this.transform;
        return r6 = r6 || [], t2 ? (r6[0] = Math.sqrt(t2[0] * t2[0] + t2[1] * t2[1]), r6[1] = Math.sqrt(t2[2] * t2[2] + t2[3] * t2[3]), t2[0] < 0 && (r6[0] = -r6[0]), t2[3] < 0 && (r6[1] = -r6[1]), r6) : (r6[0] = 1, r6[1] = 1, r6);
      }, a.prototype.transformCoordToLocal = function(r6, t2) {
        var s = [r6, t2], u = this.invTransform;
        return u && Qf(s, s, u), s;
      }, a.prototype.transformCoordToGlobal = function(r6, t2) {
        var s = [r6, t2], u = this.transform;
        return u && Qf(s, s, u), s;
      }, a.prototype.getLineScale = function() {
        var r6 = this.transform;
        return r6 && LM(r6[0] - 1) > 1e-10 && LM(r6[3] - 1) > 1e-10 ? Math.sqrt(LM(r6[0] * r6[3] - r6[2] * r6[1])) : 1;
      }, a.prototype.copyTransform = function(r6) {
        N9(this, r6);
      }, a.getLocalTransform = function(r6, t2) {
        t2 = t2 || [];
        var s = r6.originX || 0, u = r6.originY || 0, f6 = r6.scaleX, d6 = r6.scaleY, v6 = r6.anchorX, m6 = r6.anchorY, b6 = r6.rotation || 0, x6 = r6.x, S = r6.y, M = r6.skewX ? Math.tan(r6.skewX) : 0, A6 = r6.skewY ? Math.tan(-r6.skewY) : 0;
        if (s || u || v6 || m6) {
          var I = s + v6, R = u + m6;
          t2[4] = -I * f6 - M * R * d6, t2[5] = -R * d6 - A6 * I * f6;
        } else
          t2[4] = t2[5] = 0;
        return t2[0] = f6, t2[3] = d6, t2[1] = A6 * f6, t2[2] = M * d6, b6 && yb(t2, t2, b6), t2[4] += s + x6, t2[5] += u + S, t2;
      }, a.initDefaultProps = function() {
        var r6 = a.prototype;
        r6.scaleX = r6.scaleY = r6.globalScaleRatio = 1, r6.x = r6.y = r6.originX = r6.originY = r6.skewX = r6.skewY = r6.rotation = r6.anchorX = r6.anchorY = 0;
      }(), a;
    }(), lg = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
    function N9(a, r6) {
      for (var t2 = 0; t2 < lg.length; t2++) {
        var s = lg[t2];
        a[s] = r6[s];
      }
    }
    var a0 = F9, vs = function() {
      function a(r6, t2) {
        this.x = r6 || 0, this.y = t2 || 0;
      }
      return a.prototype.copy = function(r6) {
        return this.x = r6.x, this.y = r6.y, this;
      }, a.prototype.clone = function() {
        return new a(this.x, this.y);
      }, a.prototype.set = function(r6, t2) {
        return this.x = r6, this.y = t2, this;
      }, a.prototype.equal = function(r6) {
        return r6.x === this.x && r6.y === this.y;
      }, a.prototype.add = function(r6) {
        return this.x += r6.x, this.y += r6.y, this;
      }, a.prototype.scale = function(r6) {
        this.x *= r6, this.y *= r6;
      }, a.prototype.scaleAndAdd = function(r6, t2) {
        this.x += r6.x * t2, this.y += r6.y * t2;
      }, a.prototype.sub = function(r6) {
        return this.x -= r6.x, this.y -= r6.y, this;
      }, a.prototype.dot = function(r6) {
        return this.x * r6.x + this.y * r6.y;
      }, a.prototype.len = function() {
        return Math.sqrt(this.x * this.x + this.y * this.y);
      }, a.prototype.lenSquare = function() {
        return this.x * this.x + this.y * this.y;
      }, a.prototype.normalize = function() {
        var r6 = this.len();
        return this.x /= r6, this.y /= r6, this;
      }, a.prototype.distance = function(r6) {
        var t2 = this.x - r6.x, s = this.y - r6.y;
        return Math.sqrt(t2 * t2 + s * s);
      }, a.prototype.distanceSquare = function(r6) {
        var t2 = this.x - r6.x, s = this.y - r6.y;
        return t2 * t2 + s * s;
      }, a.prototype.negate = function() {
        return this.x = -this.x, this.y = -this.y, this;
      }, a.prototype.transform = function(r6) {
        if (r6) {
          var t2 = this.x, s = this.y;
          return this.x = r6[0] * t2 + r6[2] * s + r6[4], this.y = r6[1] * t2 + r6[3] * s + r6[5], this;
        }
      }, a.prototype.toArray = function(r6) {
        return r6[0] = this.x, r6[1] = this.y, r6;
      }, a.prototype.fromArray = function(r6) {
        this.x = r6[0], this.y = r6[1];
      }, a.set = function(r6, t2, s) {
        r6.x = t2, r6.y = s;
      }, a.copy = function(r6, t2) {
        r6.x = t2.x, r6.y = t2.y;
      }, a.len = function(r6) {
        return Math.sqrt(r6.x * r6.x + r6.y * r6.y);
      }, a.lenSquare = function(r6) {
        return r6.x * r6.x + r6.y * r6.y;
      }, a.dot = function(r6, t2) {
        return r6.x * t2.x + r6.y * t2.y;
      }, a.add = function(r6, t2, s) {
        r6.x = t2.x + s.x, r6.y = t2.y + s.y;
      }, a.sub = function(r6, t2, s) {
        r6.x = t2.x - s.x, r6.y = t2.y - s.y;
      }, a.scale = function(r6, t2, s) {
        r6.x = t2.x * s, r6.y = t2.y * s;
      }, a.scaleAndAdd = function(r6, t2, s, u) {
        r6.x = t2.x + s.x * u, r6.y = t2.y + s.y * u;
      }, a.lerp = function(r6, t2, s, u) {
        var f6 = 1 - u;
        r6.x = f6 * t2.x + u * s.x, r6.y = f6 * t2.y + u * s.y;
      }, a;
    }(), Bi = vs, iD = Math.min, _b2 = Math.max, xb = new Bi(), mx = new Bi(), yx = new Bi(), th = new Bi(), OM = new Bi(), wb = new Bi(), YL = function() {
      function a(r6, t2, s, u) {
        s < 0 && (r6 = r6 + s, s = -s), u < 0 && (t2 = t2 + u, u = -u), this.x = r6, this.y = t2, this.width = s, this.height = u;
      }
      return a.prototype.union = function(r6) {
        var t2 = iD(r6.x, this.x), s = iD(r6.y, this.y);
        isFinite(this.x) && isFinite(this.width) ? this.width = _b2(r6.x + r6.width, this.x + this.width) - t2 : this.width = r6.width, isFinite(this.y) && isFinite(this.height) ? this.height = _b2(r6.y + r6.height, this.y + this.height) - s : this.height = r6.height, this.x = t2, this.y = s;
      }, a.prototype.applyTransform = function(r6) {
        a.applyTransform(this, this, r6);
      }, a.prototype.calculateTransform = function(r6) {
        var t2 = this, s = r6.width / t2.width, u = r6.height / t2.height, f6 = og();
        return sg(f6, f6, [-t2.x, -t2.y]), rD(f6, f6, [s, u]), sg(f6, f6, [r6.x, r6.y]), f6;
      }, a.prototype.intersect = function(r6, t2) {
        if (!r6)
          return false;
        r6 instanceof a || (r6 = a.create(r6));
        var s = this, u = s.x, f6 = s.x + s.width, d6 = s.y, v6 = s.y + s.height, m6 = r6.x, b6 = r6.x + r6.width, x6 = r6.y, S = r6.y + r6.height, M = !(f6 < m6 || b6 < u || v6 < x6 || S < d6);
        if (t2) {
          var A6 = 1 / 0, I = 0, R = Math.abs(f6 - m6), F = Math.abs(b6 - u), j = Math.abs(v6 - x6), $ = Math.abs(S - d6), K = Math.min(R, F), U = Math.min(j, $);
          f6 < m6 || b6 < u ? K > I && (I = K, R < F ? Bi.set(wb, -R, 0) : Bi.set(wb, F, 0)) : K < A6 && (A6 = K, R < F ? Bi.set(OM, R, 0) : Bi.set(OM, -F, 0)), v6 < x6 || S < d6 ? U > I && (I = U, j < $ ? Bi.set(wb, 0, -j) : Bi.set(wb, 0, $)) : K < A6 && (A6 = K, j < $ ? Bi.set(OM, 0, j) : Bi.set(OM, 0, -$));
        }
        return t2 && Bi.copy(t2, M ? OM : wb), M;
      }, a.prototype.contain = function(r6, t2) {
        var s = this;
        return r6 >= s.x && r6 <= s.x + s.width && t2 >= s.y && t2 <= s.y + s.height;
      }, a.prototype.clone = function() {
        return new a(this.x, this.y, this.width, this.height);
      }, a.prototype.copy = function(r6) {
        a.copy(this, r6);
      }, a.prototype.plain = function() {
        return { x: this.x, y: this.y, width: this.width, height: this.height };
      }, a.prototype.isFinite = function() {
        return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
      }, a.prototype.isZero = function() {
        return this.width === 0 || this.height === 0;
      }, a.create = function(r6) {
        return new a(r6.x, r6.y, r6.width, r6.height);
      }, a.copy = function(r6, t2) {
        r6.x = t2.x, r6.y = t2.y, r6.width = t2.width, r6.height = t2.height;
      }, a.applyTransform = function(r6, t2, s) {
        if (!s) {
          r6 !== t2 && a.copy(r6, t2);
          return;
        }
        if (s[1] < 1e-5 && s[1] > -1e-5 && s[2] < 1e-5 && s[2] > -1e-5) {
          var u = s[0], f6 = s[3], d6 = s[4], v6 = s[5];
          r6.x = t2.x * u + d6, r6.y = t2.y * f6 + v6, r6.width = t2.width * u, r6.height = t2.height * f6, r6.width < 0 && (r6.x += r6.width, r6.width = -r6.width), r6.height < 0 && (r6.y += r6.height, r6.height = -r6.height);
          return;
        }
        xb.x = yx.x = t2.x, xb.y = th.y = t2.y, mx.x = th.x = t2.x + t2.width, mx.y = yx.y = t2.y + t2.height, xb.transform(s), th.transform(s), mx.transform(s), yx.transform(s), r6.x = iD(xb.x, mx.x, yx.x, th.x), r6.y = iD(xb.y, mx.y, yx.y, th.y);
        var m6 = _b2(xb.x, mx.x, yx.x, th.x), b6 = _b2(xb.y, mx.y, yx.y, th.y);
        r6.width = m6 - r6.x, r6.height = b6 - r6.y;
      }, a;
    }(), Qi = YL, ZL = {};
    function qu(a, r6) {
      r6 = r6 || Gs;
      var t2 = ZL[r6];
      t2 || (t2 = ZL[r6] = new Yy(500));
      var s = t2.get(a);
      return s == null && (s = Tc.measureText(a, r6).width, t2.put(a, s)), s;
    }
    function e1(a, r6, t2, s) {
      var u = qu(a, r6), f6 = RM(r6), d6 = V2(0, u, t2), v6 = t1(0, f6, s), m6 = new Qi(d6, v6, u, f6);
      return m6;
    }
    function bx(a, r6, t2, s) {
      var u = ((a || "") + "").split(`
`), f6 = u.length;
      if (f6 === 1)
        return e1(u[0], r6, t2, s);
      for (var d6 = new Qi(0, 0, 0, 0), v6 = 0; v6 < u.length; v6++) {
        var m6 = e1(u[v6], r6, t2, s);
        v6 === 0 ? d6.copy(m6) : d6.union(m6);
      }
      return d6;
    }
    function V2(a, r6, t2) {
      return t2 === "right" ? a -= r6 : t2 === "center" && (a -= r6 / 2), a;
    }
    function t1(a, r6, t2) {
      return t2 === "middle" ? a -= r6 / 2 : t2 === "bottom" && (a -= r6), a;
    }
    function RM(a) {
      return qu("\u56FD", a);
    }
    function wv(a, r6) {
      return typeof a == "string" ? a.lastIndexOf("%") >= 0 ? parseFloat(a) / 100 * r6 : parseFloat(a) : a;
    }
    function FM(a, r6, t2) {
      var s = r6.position || "inside", u = r6.distance != null ? r6.distance : 5, f6 = t2.height, d6 = t2.width, v6 = f6 / 2, m6 = t2.x, b6 = t2.y, x6 = "left", S = "top";
      if (s instanceof Array)
        m6 += wv(s[0], t2.width), b6 += wv(s[1], t2.height), x6 = null, S = null;
      else
        switch (s) {
          case "left":
            m6 -= u, b6 += v6, x6 = "right", S = "middle";
            break;
          case "right":
            m6 += u + d6, b6 += v6, S = "middle";
            break;
          case "top":
            m6 += d6 / 2, b6 -= u, x6 = "center", S = "bottom";
            break;
          case "bottom":
            m6 += d6 / 2, b6 += f6 + u, x6 = "center";
            break;
          case "inside":
            m6 += d6 / 2, b6 += v6, x6 = "center", S = "middle";
            break;
          case "insideLeft":
            m6 += u, b6 += v6, S = "middle";
            break;
          case "insideRight":
            m6 += d6 - u, b6 += v6, x6 = "right", S = "middle";
            break;
          case "insideTop":
            m6 += d6 / 2, b6 += u, x6 = "center";
            break;
          case "insideBottom":
            m6 += d6 / 2, b6 += f6 - u, x6 = "center", S = "bottom";
            break;
          case "insideTopLeft":
            m6 += u, b6 += u;
            break;
          case "insideTopRight":
            m6 += d6 - u, b6 += u, x6 = "right";
            break;
          case "insideBottomLeft":
            m6 += u, b6 += f6 - u, S = "bottom";
            break;
          case "insideBottomRight":
            m6 += d6 - u, b6 += f6 - u, x6 = "right", S = "bottom";
            break;
        }
      return a = a || {}, a.x = m6, a.y = b6, a.align = x6, a.verticalAlign = S, a;
    }
    var NM = "__zr_normal__", VM = lg.concat(["ignore"]), Sb = qg(lg, function(a, r6) {
      return a[r6] = true, a;
    }, { ignore: false }), z2 = {}, Cb = new Qi(0, 0, 0, 0), oD = function() {
      function a(r6) {
        this.id = rx(), this.animators = [], this.currentStates = [], this.states = {}, this._init(r6);
      }
      return a.prototype._init = function(r6) {
        this.attr(r6);
      }, a.prototype.drift = function(r6, t2, s) {
        switch (this.draggable) {
          case "horizontal":
            t2 = 0;
            break;
          case "vertical":
            r6 = 0;
            break;
        }
        var u = this.transform;
        u || (u = this.transform = [1, 0, 0, 1, 0, 0]), u[4] += r6, u[5] += t2, this.decomposeTransform(), this.markRedraw();
      }, a.prototype.beforeUpdate = function() {
      }, a.prototype.afterUpdate = function() {
      }, a.prototype.update = function() {
        this.updateTransform(), this.__dirty && this.updateInnerText();
      }, a.prototype.updateInnerText = function(r6) {
        var t2 = this._textContent;
        if (t2 && (!t2.ignore || r6)) {
          this.textConfig || (this.textConfig = {});
          var s = this.textConfig, u = s.local, f6 = t2.innerTransformable, d6 = void 0, v6 = void 0, m6 = false;
          f6.parent = u ? this : null;
          var b6 = false;
          if (f6.copyTransform(t2), s.position != null) {
            var x6 = Cb;
            s.layoutRect ? x6.copy(s.layoutRect) : x6.copy(this.getBoundingRect()), u || x6.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(z2, s, x6) : FM(z2, s, x6), f6.x = z2.x, f6.y = z2.y, d6 = z2.align, v6 = z2.verticalAlign;
            var S = s.origin;
            if (S && s.rotation != null) {
              var M = void 0, A6 = void 0;
              S === "center" ? (M = x6.width * 0.5, A6 = x6.height * 0.5) : (M = wv(S[0], x6.width), A6 = wv(S[1], x6.height)), b6 = true, f6.originX = -f6.x + M + (u ? 0 : x6.x), f6.originY = -f6.y + A6 + (u ? 0 : x6.y);
            }
          }
          s.rotation != null && (f6.rotation = s.rotation);
          var I = s.offset;
          I && (f6.x += I[0], f6.y += I[1], b6 || (f6.originX = -I[0], f6.originY = -I[1]));
          var R = s.inside == null ? typeof s.position == "string" && s.position.indexOf("inside") >= 0 : s.inside, F = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), j = void 0, $ = void 0, K = void 0;
          R && this.canBeInsideText() ? (j = s.insideFill, $ = s.insideStroke, (j == null || j === "auto") && (j = this.getInsideTextFill()), ($ == null || $ === "auto") && ($ = this.getInsideTextStroke(j), K = true)) : (j = s.outsideFill, $ = s.outsideStroke, (j == null || j === "auto") && (j = this.getOutsideFill()), ($ == null || $ === "auto") && ($ = this.getOutsideStroke(j), K = true)), j = j || "#000", (j !== F.fill || $ !== F.stroke || K !== F.autoStroke || d6 !== F.align || v6 !== F.verticalAlign) && (m6 = true, F.fill = j, F.stroke = $, F.autoStroke = K, F.align = d6, F.verticalAlign = v6, t2.setDefaultTextStyle(F)), t2.__dirty |= ad, m6 && t2.dirtyStyle(true);
        }
      }, a.prototype.canBeInsideText = function() {
        return true;
      }, a.prototype.getInsideTextFill = function() {
        return "#fff";
      }, a.prototype.getInsideTextStroke = function(r6) {
        return "#000";
      }, a.prototype.getOutsideFill = function() {
        return this.__zr && this.__zr.isDarkMode() ? $L : nD;
      }, a.prototype.getOutsideStroke = function(r6) {
        var t2 = this.__zr && this.__zr.getBackgroundColor(), s = typeof t2 == "string" && id2(t2);
        s || (s = [255, 255, 255, 1]);
        for (var u = s[3], f6 = this.__zr.isDarkMode(), d6 = 0; d6 < 3; d6++)
          s[d6] = s[d6] * u + (f6 ? 0 : 255) * (1 - u);
        return s[3] = 1, Zy(s, "rgba");
      }, a.prototype.traverse = function(r6, t2) {
      }, a.prototype.attrKV = function(r6, t2) {
        r6 === "textConfig" ? this.setTextConfig(t2) : r6 === "textContent" ? this.setTextContent(t2) : r6 === "clipPath" ? this.setClipPath(t2) : r6 === "extra" ? (this.extra = this.extra || {}, qn(this.extra, t2)) : this[r6] = t2;
      }, a.prototype.hide = function() {
        this.ignore = true, this.markRedraw();
      }, a.prototype.show = function() {
        this.ignore = false, this.markRedraw();
      }, a.prototype.attr = function(r6, t2) {
        if (typeof r6 == "string")
          this.attrKV(r6, t2);
        else if (ui(r6))
          for (var s = r6, u = Po(s), f6 = 0; f6 < u.length; f6++) {
            var d6 = u[f6];
            this.attrKV(d6, r6[d6]);
          }
        return this.markRedraw(), this;
      }, a.prototype.saveCurrentToNormalState = function(r6) {
        this._innerSaveToNormal(r6);
        for (var t2 = this._normalState, s = 0; s < this.animators.length; s++) {
          var u = this.animators[s], f6 = u.__fromStateTransition;
          if (!(u.getLoop() || f6 && f6 !== NM)) {
            var d6 = u.targetName, v6 = d6 ? t2[d6] : t2;
            u.saveTo(v6);
          }
        }
      }, a.prototype._innerSaveToNormal = function(r6) {
        var t2 = this._normalState;
        t2 || (t2 = this._normalState = {}), r6.textConfig && !t2.textConfig && (t2.textConfig = this.textConfig), this._savePrimaryToNormal(r6, t2, VM);
      }, a.prototype._savePrimaryToNormal = function(r6, t2, s) {
        for (var u = 0; u < s.length; u++) {
          var f6 = s[u];
          r6[f6] != null && !(f6 in t2) && (t2[f6] = this[f6]);
        }
      }, a.prototype.hasState = function() {
        return this.currentStates.length > 0;
      }, a.prototype.getState = function(r6) {
        return this.states[r6];
      }, a.prototype.ensureState = function(r6) {
        var t2 = this.states;
        return t2[r6] || (t2[r6] = {}), t2[r6];
      }, a.prototype.clearStates = function(r6) {
        this.useState(NM, false, r6);
      }, a.prototype.useState = function(r6, t2, s, u) {
        var f6 = r6 === NM, d6 = this.hasState();
        if (!(!d6 && f6)) {
          var v6 = this.currentStates, m6 = this.stateTransition;
          if (!(Vi(v6, r6) >= 0 && (t2 || v6.length === 1))) {
            var b6;
            if (this.stateProxy && !f6 && (b6 = this.stateProxy(r6)), b6 || (b6 = this.states && this.states[r6]), !b6 && !f6) {
              cb("State " + r6 + " not exists.");
              return;
            }
            f6 || this.saveCurrentToNormalState(b6);
            var x6 = !!(b6 && b6.hoverLayer || u);
            x6 && this._toggleHoverLayerFlag(true), this._applyStateObj(r6, b6, this._normalState, t2, !s && !this.__inHover && m6 && m6.duration > 0, m6);
            var S = this._textContent, M = this._textGuide;
            return S && S.useState(r6, t2, s, x6), M && M.useState(r6, t2, s, x6), f6 ? (this.currentStates = [], this._normalState = {}) : t2 ? this.currentStates.push(r6) : this.currentStates = [r6], this._updateAnimationTargets(), this.markRedraw(), !x6 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~ad), b6;
          }
        }
      }, a.prototype.useStates = function(r6, t2, s) {
        if (!r6.length)
          this.clearStates();
        else {
          var u = [], f6 = this.currentStates, d6 = r6.length, v6 = d6 === f6.length;
          if (v6) {
            for (var m6 = 0; m6 < d6; m6++)
              if (r6[m6] !== f6[m6]) {
                v6 = false;
                break;
              }
          }
          if (v6)
            return;
          for (var m6 = 0; m6 < d6; m6++) {
            var b6 = r6[m6], x6 = void 0;
            this.stateProxy && (x6 = this.stateProxy(b6, r6)), x6 || (x6 = this.states[b6]), x6 && u.push(x6);
          }
          var S = u[d6 - 1], M = !!(S && S.hoverLayer || s);
          M && this._toggleHoverLayerFlag(true);
          var A6 = this._mergeStates(u), I = this.stateTransition;
          this.saveCurrentToNormalState(A6), this._applyStateObj(r6.join(","), A6, this._normalState, false, !t2 && !this.__inHover && I && I.duration > 0, I);
          var R = this._textContent, F = this._textGuide;
          R && R.useStates(r6, t2, M), F && F.useStates(r6, t2, M), this._updateAnimationTargets(), this.currentStates = r6.slice(), this.markRedraw(), !M && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~ad);
        }
      }, a.prototype._updateAnimationTargets = function() {
        for (var r6 = 0; r6 < this.animators.length; r6++) {
          var t2 = this.animators[r6];
          t2.targetName && t2.changeTarget(this[t2.targetName]);
        }
      }, a.prototype.removeState = function(r6) {
        var t2 = Vi(this.currentStates, r6);
        if (t2 >= 0) {
          var s = this.currentStates.slice();
          s.splice(t2, 1), this.useStates(s);
        }
      }, a.prototype.replaceState = function(r6, t2, s) {
        var u = this.currentStates.slice(), f6 = Vi(u, r6), d6 = Vi(u, t2) >= 0;
        f6 >= 0 ? d6 ? u.splice(f6, 1) : u[f6] = t2 : s && !d6 && u.push(t2), this.useStates(u);
      }, a.prototype.toggleState = function(r6, t2) {
        t2 ? this.useState(r6, true) : this.removeState(r6);
      }, a.prototype._mergeStates = function(r6) {
        for (var t2 = {}, s, u = 0; u < r6.length; u++) {
          var f6 = r6[u];
          qn(t2, f6), f6.textConfig && (s = s || {}, qn(s, f6.textConfig));
        }
        return s && (t2.textConfig = s), t2;
      }, a.prototype._applyStateObj = function(r6, t2, s, u, f6, d6) {
        var v6 = !(t2 && u);
        t2 && t2.textConfig ? (this.textConfig = qn({}, u ? this.textConfig : s.textConfig), qn(this.textConfig, t2.textConfig)) : v6 && s.textConfig && (this.textConfig = s.textConfig);
        for (var m6 = {}, b6 = false, x6 = 0; x6 < VM.length; x6++) {
          var S = VM[x6], M = f6 && Sb[S];
          t2 && t2[S] != null ? M ? (b6 = true, m6[S] = t2[S]) : this[S] = t2[S] : v6 && s[S] != null && (M ? (b6 = true, m6[S] = s[S]) : this[S] = s[S]);
        }
        if (!f6)
          for (var x6 = 0; x6 < this.animators.length; x6++) {
            var A6 = this.animators[x6], I = A6.targetName;
            A6.getLoop() || A6.__changeFinalValue(I ? (t2 || s)[I] : t2 || s);
          }
        b6 && this._transitionState(r6, m6, d6);
      }, a.prototype._attachComponent = function(r6) {
        if (!(r6.__zr && !r6.__hostTarget) && r6 !== this) {
          var t2 = this.__zr;
          t2 && r6.addSelfToZr(t2), r6.__zr = t2, r6.__hostTarget = this;
        }
      }, a.prototype._detachComponent = function(r6) {
        r6.__zr && r6.removeSelfFromZr(r6.__zr), r6.__zr = null, r6.__hostTarget = null;
      }, a.prototype.getClipPath = function() {
        return this._clipPath;
      }, a.prototype.setClipPath = function(r6) {
        this._clipPath && this._clipPath !== r6 && this.removeClipPath(), this._attachComponent(r6), this._clipPath = r6, this.markRedraw();
      }, a.prototype.removeClipPath = function() {
        var r6 = this._clipPath;
        r6 && (this._detachComponent(r6), this._clipPath = null, this.markRedraw());
      }, a.prototype.getTextContent = function() {
        return this._textContent;
      }, a.prototype.setTextContent = function(r6) {
        var t2 = this._textContent;
        t2 !== r6 && (t2 && t2 !== r6 && this.removeTextContent(), r6.innerTransformable = new a0(), this._attachComponent(r6), this._textContent = r6, this.markRedraw());
      }, a.prototype.setTextConfig = function(r6) {
        this.textConfig || (this.textConfig = {}), qn(this.textConfig, r6), this.markRedraw();
      }, a.prototype.removeTextConfig = function() {
        this.textConfig = null, this.markRedraw();
      }, a.prototype.removeTextContent = function() {
        var r6 = this._textContent;
        r6 && (r6.innerTransformable = null, this._detachComponent(r6), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
      }, a.prototype.getTextGuideLine = function() {
        return this._textGuide;
      }, a.prototype.setTextGuideLine = function(r6) {
        this._textGuide && this._textGuide !== r6 && this.removeTextGuideLine(), this._attachComponent(r6), this._textGuide = r6, this.markRedraw();
      }, a.prototype.removeTextGuideLine = function() {
        var r6 = this._textGuide;
        r6 && (this._detachComponent(r6), this._textGuide = null, this.markRedraw());
      }, a.prototype.markRedraw = function() {
        this.__dirty |= ad;
        var r6 = this.__zr;
        r6 && (this.__inHover ? r6.refreshHover() : r6.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
      }, a.prototype.dirty = function() {
        this.markRedraw();
      }, a.prototype._toggleHoverLayerFlag = function(r6) {
        this.__inHover = r6;
        var t2 = this._textContent, s = this._textGuide;
        t2 && (t2.__inHover = r6), s && (s.__inHover = r6);
      }, a.prototype.addSelfToZr = function(r6) {
        if (this.__zr !== r6) {
          this.__zr = r6;
          var t2 = this.animators;
          if (t2)
            for (var s = 0; s < t2.length; s++)
              r6.animation.addAnimator(t2[s]);
          this._clipPath && this._clipPath.addSelfToZr(r6), this._textContent && this._textContent.addSelfToZr(r6), this._textGuide && this._textGuide.addSelfToZr(r6);
        }
      }, a.prototype.removeSelfFromZr = function(r6) {
        if (this.__zr) {
          this.__zr = null;
          var t2 = this.animators;
          if (t2)
            for (var s = 0; s < t2.length; s++)
              r6.animation.removeAnimator(t2[s]);
          this._clipPath && this._clipPath.removeSelfFromZr(r6), this._textContent && this._textContent.removeSelfFromZr(r6), this._textGuide && this._textGuide.removeSelfFromZr(r6);
        }
      }, a.prototype.animate = function(r6, t2, s) {
        var u = r6 ? this[r6] : this, f6 = new GL(u, t2, s);
        return r6 && (f6.targetName = r6), this.addAnimator(f6, r6), f6;
      }, a.prototype.addAnimator = function(r6, t2) {
        var s = this.__zr, u = this;
        r6.during(function() {
          u.updateDuringAnimation(t2);
        }).done(function() {
          var f6 = u.animators, d6 = Vi(f6, r6);
          d6 >= 0 && f6.splice(d6, 1);
        }), this.animators.push(r6), s && s.animation.addAnimator(r6), s && s.wakeUp();
      }, a.prototype.updateDuringAnimation = function(r6) {
        this.markRedraw();
      }, a.prototype.stopAnimation = function(r6, t2) {
        for (var s = this.animators, u = s.length, f6 = [], d6 = 0; d6 < u; d6++) {
          var v6 = s[d6];
          !r6 || r6 === v6.scope ? v6.stop(t2) : f6.push(v6);
        }
        return this.animators = f6, this;
      }, a.prototype.animateTo = function(r6, t2, s) {
        sD(this, r6, t2, s);
      }, a.prototype.animateFrom = function(r6, t2, s) {
        sD(this, r6, t2, s, true);
      }, a.prototype._transitionState = function(r6, t2, s, u) {
        for (var f6 = sD(this, t2, s, u), d6 = 0; d6 < f6.length; d6++)
          f6[d6].__fromStateTransition = r6;
      }, a.prototype.getBoundingRect = function() {
        return null;
      }, a.prototype.getPaintRect = function() {
        return null;
      }, a.initDefaultProps = function() {
        var r6 = a.prototype;
        r6.type = "element", r6.name = "", r6.ignore = r6.silent = r6.isGroup = r6.draggable = r6.dragging = r6.ignoreClip = r6.__inHover = false, r6.__dirty = ad;
        function t2(s, u, f6, d6) {
          Object.defineProperty(r6, s, { get: function() {
            if (!this[u]) {
              var m6 = this[u] = [];
              v6(this, m6);
            }
            return this[u];
          }, set: function(m6) {
            this[f6] = m6[0], this[d6] = m6[1], this[u] = m6, v6(this, m6);
          } });
          function v6(m6, b6) {
            Object.defineProperty(b6, 0, { get: function() {
              return m6[f6];
            }, set: function(x6) {
              m6[f6] = x6;
            } }), Object.defineProperty(b6, 1, { get: function() {
              return m6[d6];
            }, set: function(x6) {
              m6[d6] = x6;
            } });
          }
        }
        Object.defineProperty && (t2("position", "_legacyPos", "x", "y"), t2("scale", "_legacyScale", "scaleX", "scaleY"), t2("origin", "_legacyOrigin", "originX", "originY"));
      }(), a;
    }();
    Dc(oD, Ip), Dc(oD, a0);
    function sD(a, r6, t2, s, u) {
      t2 = t2 || {};
      var f6 = [];
      XL(a, "", a, r6, t2, s, f6, u);
      var d6 = f6.length, v6 = false, m6 = t2.done, b6 = t2.aborted, x6 = function() {
        v6 = true, d6--, d6 <= 0 && (v6 ? m6 && m6() : b6 && b6());
      }, S = function() {
        d6--, d6 <= 0 && (v6 ? m6 && m6() : b6 && b6());
      };
      d6 || m6 && m6(), f6.length > 0 && t2.during && f6[0].during(function(I, R) {
        t2.during(R);
      });
      for (var M = 0; M < f6.length; M++) {
        var A6 = f6[M];
        x6 && A6.done(x6), S && A6.aborted(S), t2.force && A6.duration(t2.duration), A6.start(t2.easing);
      }
      return f6;
    }
    function zM(a, r6, t2) {
      for (var s = 0; s < t2; s++)
        a[s] = r6[s];
    }
    function qU(a) {
      return rd(a[0]);
    }
    function YU(a, r6, t2) {
      if (rd(r6[t2]))
        if (rd(a[t2]) || (a[t2] = []), _v(r6[t2])) {
          var s = r6[t2].length;
          a[t2].length !== s && (a[t2] = new r6[t2].constructor(s), zM(a[t2], r6[t2], s));
        } else {
          var u = r6[t2], f6 = a[t2], d6 = u.length;
          if (qU(u))
            for (var v6 = u[0].length, m6 = 0; m6 < d6; m6++)
              f6[m6] ? zM(f6[m6], u[m6], v6) : f6[m6] = Array.prototype.slice.call(u[m6]);
          else
            zM(f6, u, d6);
          f6.length = u.length;
        }
      else
        a[t2] = r6[t2];
    }
    function ZU(a, r6) {
      return a === r6 || rd(a) && rd(r6) && V9(a, r6);
    }
    function V9(a, r6) {
      var t2 = a.length;
      if (t2 !== r6.length)
        return false;
      for (var s = 0; s < t2; s++)
        if (a[s] !== r6[s])
          return false;
      return true;
    }
    function XL(a, r6, t2, s, u, f6, d6, v6) {
      for (var m6 = Po(s), b6 = u.duration, x6 = u.delay, S = u.additive, M = u.setToFinal, A6 = !ui(f6), I = a.animators, R = [], F = 0; F < m6.length; F++) {
        var j = m6[F], $ = s[j];
        if ($ != null && t2[j] != null && (A6 || f6[j]))
          if (ui($) && !rd($) && !au($)) {
            if (r6) {
              v6 || (t2[j] = $, a.updateDuringAnimation(r6));
              continue;
            }
            XL(a, j, t2[j], $, u, f6 && f6[j], d6, v6);
          } else
            R.push(j);
        else
          v6 || (t2[j] = $, a.updateDuringAnimation(r6), R.push(j));
      }
      var K = R.length;
      if (!S && K)
        for (var U = 0; U < I.length; U++) {
          var he = I[U];
          if (he.targetName === r6) {
            var ue = he.stopTracks(R);
            if (ue) {
              var pe = Vi(I, he);
              I.splice(pe, 1);
            }
          }
        }
      if (u.force || (R = gl(R, function(ke) {
        return !ZU(s[ke], t2[ke]);
      }), K = R.length), K > 0 || u.force && !d6.length) {
        var _e = void 0, xe = void 0, Ae = void 0;
        if (v6) {
          xe = {}, M && (_e = {});
          for (var U = 0; U < K; U++) {
            var j = R[U];
            xe[j] = t2[j], M ? _e[j] = s[j] : t2[j] = s[j];
          }
        } else if (M) {
          Ae = {};
          for (var U = 0; U < K; U++) {
            var j = R[U];
            Ae[j] = vb(t2[j]), YU(t2, s, j);
          }
        }
        var he = new GL(t2, false, false, S ? gl(I, function(je) {
          return je.targetName === r6;
        }) : null);
        he.targetName = r6, u.scope && (he.scope = u.scope), M && _e && he.whenWithKeys(0, _e, R), Ae && he.whenWithKeys(0, Ae, R), he.whenWithKeys(b6 == null ? 500 : b6, v6 ? xe : s, R).delay(x6 || 0), a.addAnimator(he, r6), d6.push(he);
      }
    }
    var z9 = oD, KL = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this) || this;
        return s.isGroup = true, s._children = [], s.attr(t2), s;
      }
      return r6.prototype.childrenRef = function() {
        return this._children;
      }, r6.prototype.children = function() {
        return this._children.slice();
      }, r6.prototype.childAt = function(t2) {
        return this._children[t2];
      }, r6.prototype.childOfName = function(t2) {
        for (var s = this._children, u = 0; u < s.length; u++)
          if (s[u].name === t2)
            return s[u];
      }, r6.prototype.childCount = function() {
        return this._children.length;
      }, r6.prototype.add = function(t2) {
        return t2 && t2 !== this && t2.parent !== this && (this._children.push(t2), this._doAdd(t2)), this;
      }, r6.prototype.addBefore = function(t2, s) {
        if (t2 && t2 !== this && t2.parent !== this && s && s.parent === this) {
          var u = this._children, f6 = u.indexOf(s);
          f6 >= 0 && (u.splice(f6, 0, t2), this._doAdd(t2));
        }
        return this;
      }, r6.prototype.replace = function(t2, s) {
        var u = Vi(this._children, t2);
        return u >= 0 && this.replaceAt(s, u), this;
      }, r6.prototype.replaceAt = function(t2, s) {
        var u = this._children, f6 = u[s];
        if (t2 && t2 !== this && t2.parent !== this && t2 !== f6) {
          u[s] = t2, f6.parent = null;
          var d6 = this.__zr;
          d6 && f6.removeSelfFromZr(d6), this._doAdd(t2);
        }
        return this;
      }, r6.prototype._doAdd = function(t2) {
        t2.parent && t2.parent.remove(t2), t2.parent = this;
        var s = this.__zr;
        s && s !== t2.__zr && t2.addSelfToZr(s), s && s.refresh();
      }, r6.prototype.remove = function(t2) {
        var s = this.__zr, u = this._children, f6 = Vi(u, t2);
        return f6 < 0 ? this : (u.splice(f6, 1), t2.parent = null, s && t2.removeSelfFromZr(s), s && s.refresh(), this);
      }, r6.prototype.removeAll = function() {
        for (var t2 = this._children, s = this.__zr, u = 0; u < t2.length; u++) {
          var f6 = t2[u];
          s && f6.removeSelfFromZr(s), f6.parent = null;
        }
        return t2.length = 0, this;
      }, r6.prototype.eachChild = function(t2, s) {
        for (var u = this._children, f6 = 0; f6 < u.length; f6++) {
          var d6 = u[f6];
          t2.call(s, d6, f6);
        }
        return this;
      }, r6.prototype.traverse = function(t2, s) {
        for (var u = 0; u < this._children.length; u++) {
          var f6 = this._children[u], d6 = t2.call(s, f6);
          f6.isGroup && !d6 && f6.traverse(t2, s);
        }
        return this;
      }, r6.prototype.addSelfToZr = function(t2) {
        a.prototype.addSelfToZr.call(this, t2);
        for (var s = 0; s < this._children.length; s++) {
          var u = this._children[s];
          u.addSelfToZr(t2);
        }
      }, r6.prototype.removeSelfFromZr = function(t2) {
        a.prototype.removeSelfFromZr.call(this, t2);
        for (var s = 0; s < this._children.length; s++) {
          var u = this._children[s];
          u.removeSelfFromZr(t2);
        }
      }, r6.prototype.getBoundingRect = function(t2) {
        for (var s = new Qi(0, 0, 0, 0), u = t2 || this._children, f6 = [], d6 = null, v6 = 0; v6 < u.length; v6++) {
          var m6 = u[v6];
          if (!(m6.ignore || m6.invisible)) {
            var b6 = m6.getBoundingRect(), x6 = m6.getLocalTransform(f6);
            x6 ? (Qi.applyTransform(s, b6, x6), d6 = d6 || s.clone(), d6.union(s)) : (d6 = d6 || b6.clone(), d6.union(b6));
          }
        }
        return d6 || s;
      }, r6;
    }(z9);
    KL.prototype.type = "group";
    var bi = KL;
    /*!
    * ZRender, a high performance 2d drawing library.
    *
    * Copyright (c) 2013, Baidu Inc.
    * All rights reserved.
    *
    * LICENSE
    * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
    */
    var Mh = {}, i0 = {};
    function XU(a) {
      delete i0[a];
    }
    function KU(a) {
      if (!a)
        return false;
      if (typeof a == "string")
        return GT(a, 1) < DM;
      if (a.colorStops) {
        for (var r6 = a.colorStops, t2 = 0, s = r6.length, u = 0; u < s; u++)
          t2 += GT(r6[u].color, 1);
        return t2 /= s, t2 < DM;
      }
      return false;
    }
    var lD = function() {
      function a(r6, t2, s) {
        var u = this;
        this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, s = s || {}, this.dom = t2, this.id = r6;
        var f6 = new b9(), d6 = s.renderer || "canvas";
        Mh[d6] || (d6 = Po(Mh)[0]), s.useDirtyRect = s.useDirtyRect == null ? false : s.useDirtyRect;
        var v6 = new Mh[d6](t2, f6, s, r6), m6 = s.ssr || v6.ssrOnly;
        this.storage = f6, this.painter = v6;
        var b6 = !ha.node && !ha.worker && !m6 ? new TM(v6.getViewportRoot(), v6.root) : null;
        this.handler = new dn(f6, v6, b6, v6.root), this.animation = new P9({ stage: { update: m6 ? null : function() {
          return u._flush(true);
        } } }), m6 || this.animation.start();
      }
      return a.prototype.add = function(r6) {
        !r6 || (this.storage.addRoot(r6), r6.addSelfToZr(this), this.refresh());
      }, a.prototype.remove = function(r6) {
        !r6 || (this.storage.delRoot(r6), r6.removeSelfFromZr(this), this.refresh());
      }, a.prototype.configLayer = function(r6, t2) {
        this.painter.configLayer && this.painter.configLayer(r6, t2), this.refresh();
      }, a.prototype.setBackgroundColor = function(r6) {
        this.painter.setBackgroundColor && this.painter.setBackgroundColor(r6), this.refresh(), this._backgroundColor = r6, this._darkMode = KU(r6);
      }, a.prototype.getBackgroundColor = function() {
        return this._backgroundColor;
      }, a.prototype.setDarkMode = function(r6) {
        this._darkMode = r6;
      }, a.prototype.isDarkMode = function() {
        return this._darkMode;
      }, a.prototype.refreshImmediately = function(r6) {
        r6 || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
      }, a.prototype.refresh = function() {
        this._needsRefresh = true, this.animation.start();
      }, a.prototype.flush = function() {
        this._flush(false);
      }, a.prototype._flush = function(r6) {
        var t2, s = Jy();
        this._needsRefresh && (t2 = true, this.refreshImmediately(r6)), this._needsRefreshHover && (t2 = true, this.refreshHoverImmediately());
        var u = Jy();
        t2 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: u - s })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
      }, a.prototype.setSleepAfterStill = function(r6) {
        this._sleepAfterStill = r6;
      }, a.prototype.wakeUp = function() {
        this.animation.start(), this._stillFrameAccum = 0;
      }, a.prototype.refreshHover = function() {
        this._needsRefreshHover = true;
      }, a.prototype.refreshHoverImmediately = function() {
        this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
      }, a.prototype.resize = function(r6) {
        r6 = r6 || {}, this.painter.resize(r6.width, r6.height), this.handler.resize();
      }, a.prototype.clearAnimation = function() {
        this.animation.clear();
      }, a.prototype.getWidth = function() {
        return this.painter.getWidth();
      }, a.prototype.getHeight = function() {
        return this.painter.getHeight();
      }, a.prototype.setCursorStyle = function(r6) {
        this.handler.setCursorStyle(r6);
      }, a.prototype.findHover = function(r6, t2) {
        return this.handler.findHover(r6, t2);
      }, a.prototype.on = function(r6, t2, s) {
        return this.handler.on(r6, t2, s), this;
      }, a.prototype.off = function(r6, t2) {
        this.handler.off(r6, t2);
      }, a.prototype.trigger = function(r6, t2) {
        this.handler.trigger(r6, t2);
      }, a.prototype.clear = function() {
        for (var r6 = this.storage.getRoots(), t2 = 0; t2 < r6.length; t2++)
          r6[t2] instanceof bi && r6[t2].removeSelfFromZr(this);
        this.storage.delAllRoots(), this.painter.clear();
      }, a.prototype.dispose = function() {
        this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, XU(this.id);
      }, a;
    }();
    function _x(a, r6) {
      var t2 = new lD(rx(), a, r6);
      return i0[t2.id] = t2, t2;
    }
    function B9(a, r6) {
      Mh[a] = r6;
    }
    var JL = 1e-4, j9 = 20;
    function G9(a) {
      return a.replace(/^\s+|\s+$/g, "");
    }
    function gs(a, r6, t2, s) {
      var u = r6[0], f6 = r6[1], d6 = t2[0], v6 = t2[1], m6 = f6 - u, b6 = v6 - d6;
      if (m6 === 0)
        return b6 === 0 ? d6 : (d6 + v6) / 2;
      if (s)
        if (m6 > 0) {
          if (a <= u)
            return d6;
          if (a >= f6)
            return v6;
        } else {
          if (a >= u)
            return d6;
          if (a <= f6)
            return v6;
        }
      else {
        if (a === u)
          return d6;
        if (a === f6)
          return v6;
      }
      return (a - u) / m6 * b6 + d6;
    }
    function ua(a, r6) {
      switch (a) {
        case "center":
        case "middle":
          a = "50%";
          break;
        case "left":
        case "top":
          a = "0%";
          break;
        case "right":
        case "bottom":
          a = "100%";
          break;
      }
      return _a2(a) ? G9(a).match(/%$/) ? parseFloat(a) / 100 * r6 : parseFloat(a) : a == null ? NaN : +a;
    }
    function Sc(a, r6, t2) {
      return r6 == null && (r6 = 10), r6 = Math.min(Math.max(0, r6), j9), a = (+a).toFixed(r6), t2 ? a : +a;
    }
    function Sv(a) {
      return a.sort(function(r6, t2) {
        return r6 - t2;
      }), a;
    }
    function o0(a) {
      if (a = +a, isNaN(a))
        return 0;
      if (a > 1e-14) {
        for (var r6 = 1, t2 = 0; t2 < 15; t2++, r6 *= 10)
          if (Math.round(a * r6) / r6 === a)
            return t2;
      }
      return uD(a);
    }
    function uD(a) {
      var r6 = a.toString().toLowerCase(), t2 = r6.indexOf("e"), s = t2 > 0 ? +r6.slice(t2 + 1) : 0, u = t2 > 0 ? t2 : r6.length, f6 = r6.indexOf("."), d6 = f6 < 0 ? 0 : u - 1 - f6;
      return Math.max(0, d6 - s);
    }
    function QL(a, r6) {
      var t2 = Math.log, s = Math.LN10, u = Math.floor(t2(a[1] - a[0]) / s), f6 = Math.round(t2(Math.abs(r6[1] - r6[0])) / s), d6 = Math.min(Math.max(-u + f6, 0), 20);
      return isFinite(d6) ? d6 : 20;
    }
    function cD(a, r6, t2) {
      if (!a[r6])
        return 0;
      var s = qg(a, function(I, R) {
        return I + (isNaN(R) ? 0 : R);
      }, 0);
      if (s === 0)
        return 0;
      for (var u = Math.pow(10, t2), f6 = wr(a, function(I) {
        return (isNaN(I) ? 0 : I) / s * u * 100;
      }), d6 = u * 100, v6 = wr(f6, function(I) {
        return Math.floor(I);
      }), m6 = qg(v6, function(I, R) {
        return I + R;
      }, 0), b6 = wr(f6, function(I, R) {
        return I - v6[R];
      }); m6 < d6; ) {
        for (var x6 = Number.NEGATIVE_INFINITY, S = null, M = 0, A6 = b6.length; M < A6; ++M)
          b6[M] > x6 && (x6 = b6[M], S = M);
        ++v6[S], b6[S] = 0, ++m6;
      }
      return v6[r6] / u;
    }
    function eO(a, r6) {
      var t2 = Math.max(o0(a), o0(r6)), s = a + r6;
      return t2 > j9 ? s : Sc(s, t2);
    }
    var BM = 9007199254740991;
    function W9(a) {
      var r6 = Math.PI * 2;
      return (a % r6 + r6) % r6;
    }
    function jM(a) {
      return a > -JL && a < JL;
    }
    var fD = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
    function s0(a) {
      if (a instanceof Date)
        return a;
      if (_a2(a)) {
        var r6 = fD.exec(a);
        if (!r6)
          return new Date(NaN);
        if (r6[8]) {
          var t2 = +r6[4] || 0;
          return r6[8].toUpperCase() !== "Z" && (t2 -= +r6[8].slice(0, 3)), new Date(Date.UTC(+r6[1], +(r6[2] || 1) - 1, +r6[3] || 1, t2, +(r6[5] || 0), +r6[6] || 0, r6[7] ? +r6[7].substring(0, 3) : 0));
        } else
          return new Date(+r6[1], +(r6[2] || 1) - 1, +r6[3] || 1, +r6[4] || 0, +(r6[5] || 0), +r6[6] || 0, r6[7] ? +r6[7].substring(0, 3) : 0);
      } else if (a == null)
        return new Date(NaN);
      return new Date(Math.round(a));
    }
    function tO(a) {
      return Math.pow(10, nO(a));
    }
    function nO(a) {
      if (a === 0)
        return 0;
      var r6 = Math.floor(Math.log(a) / Math.LN10);
      return a / Math.pow(10, r6) >= 10 && r6++, r6;
    }
    function rO(a, r6) {
      var t2 = nO(a), s = Math.pow(10, t2), u = a / s, f6;
      return r6 ? u < 1.5 ? f6 = 1 : u < 2.5 ? f6 = 2 : u < 4 ? f6 = 3 : u < 7 ? f6 = 5 : f6 = 10 : u < 1 ? f6 = 1 : u < 2 ? f6 = 2 : u < 3 ? f6 = 3 : u < 5 ? f6 = 5 : f6 = 10, a = f6 * s, t2 >= -20 ? +a.toFixed(t2 < 0 ? -t2 : 0) : a;
    }
    function l0(a, r6) {
      var t2 = (a.length - 1) * r6 + 1, s = Math.floor(t2), u = +a[s - 1], f6 = t2 - s;
      return f6 ? u + f6 * (a[s] - u) : u;
    }
    function aO(a) {
      a.sort(function(m6, b6) {
        return v6(m6, b6, 0) ? -1 : 1;
      });
      for (var r6 = -1 / 0, t2 = 1, s = 0; s < a.length; ) {
        for (var u = a[s].interval, f6 = a[s].close, d6 = 0; d6 < 2; d6++)
          u[d6] <= r6 && (u[d6] = r6, f6[d6] = d6 ? 1 : 1 - t2), r6 = u[d6], t2 = f6[d6];
        u[0] === u[1] && f6[0] * f6[1] !== 1 ? a.splice(s, 1) : s++;
      }
      return a;
      function v6(m6, b6, x6) {
        return m6.interval[x6] < b6.interval[x6] || m6.interval[x6] === b6.interval[x6] && (m6.close[x6] - b6.close[x6] === (x6 ? -1 : 1) || !x6 && v6(m6, b6, 1));
      }
    }
    function mm(a) {
      var r6 = parseFloat(a);
      return r6 == a && (r6 !== 0 || !_a2(a) || a.indexOf("x") <= 0) ? r6 : NaN;
    }
    function H9(a) {
      return !isNaN(mm(a));
    }
    function iO() {
      return Math.round(Math.random() * 9);
    }
    function $9(a, r6) {
      return r6 === 0 ? a : $9(r6, a % r6);
    }
    function U9(a, r6) {
      return a == null ? r6 : r6 == null ? a : a * r6 / $9(a, r6);
    }
    function Lo(a) {
      throw new Error(a);
    }
    function hD(a, r6, t2) {
      return (r6 - a) * t2 + a;
    }
    var dD = "series\0", pD = "\0_ec_\0";
    function ll(a) {
      return a instanceof Array ? a : a == null ? [] : [a];
    }
    function ug(a, r6, t2) {
      if (a) {
        a[r6] = a[r6] || {}, a.emphasis = a.emphasis || {}, a.emphasis[r6] = a.emphasis[r6] || {};
        for (var s = 0, u = t2.length; s < u; s++) {
          var f6 = t2[s];
          !a.emphasis[r6].hasOwnProperty(f6) && a[r6].hasOwnProperty(f6) && (a.emphasis[r6][f6] = a[r6][f6]);
        }
      }
    }
    var Yi = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
    function n1(a) {
      return ui(a) && !br(a) && !(a instanceof Date) ? a.value : a;
    }
    function oO(a) {
      return ui(a) && !(a instanceof Array);
    }
    function Mb(a, r6, t2) {
      var s = t2 === "normalMerge", u = t2 === "replaceMerge", f6 = t2 === "replaceAll";
      a = a || [], r6 = (r6 || []).slice();
      var d6 = Ta();
      Ne(r6, function(m6, b6) {
        if (!ui(m6)) {
          r6[b6] = null;
          return;
        }
      });
      var v6 = JU(a, d6, t2);
      return (s || u) && sO(v6, a, d6, r6), s && q9(v6, r6), s || u ? od(v6, r6, u) : f6 && QU(v6, r6), eq(v6), v6;
    }
    function JU(a, r6, t2) {
      var s = [];
      if (t2 === "replaceAll")
        return s;
      for (var u = 0; u < a.length; u++) {
        var f6 = a[u];
        f6 && f6.id != null && r6.set(f6.id, u), s.push({ existing: t2 === "replaceMerge" || WM(f6) ? null : f6, newOption: null, keyInfo: null, brandNew: null });
      }
      return s;
    }
    function sO(a, r6, t2, s) {
      Ne(s, function(u, f6) {
        if (!(!u || u.id == null)) {
          var d6 = GM(u.id), v6 = t2.get(d6);
          if (v6 != null) {
            var m6 = a[v6];
            Hd(!m6.newOption, 'Duplicated option on id "' + d6 + '".'), m6.newOption = u, m6.existing = r6[v6], s[f6] = null;
          }
        }
      });
    }
    function q9(a, r6) {
      Ne(r6, function(t2, s) {
        if (!(!t2 || t2.name == null))
          for (var u = 0; u < a.length; u++) {
            var f6 = a[u].existing;
            if (!a[u].newOption && f6 && (f6.id == null || t2.id == null) && !WM(t2) && !WM(f6) && lO("name", f6, t2)) {
              a[u].newOption = t2, r6[s] = null;
              return;
            }
          }
      });
    }
    function od(a, r6, t2) {
      Ne(r6, function(s) {
        if (s) {
          for (var u, f6 = 0; (u = a[f6]) && (u.newOption || WM(u.existing) || u.existing && s.id != null && !lO("id", s, u.existing)); )
            f6++;
          u ? (u.newOption = s, u.brandNew = t2) : a.push({ newOption: s, brandNew: t2, existing: null, keyInfo: null }), f6++;
        }
      });
    }
    function QU(a, r6) {
      Ne(r6, function(t2) {
        a.push({ newOption: t2, brandNew: true, existing: null, keyInfo: null });
      });
    }
    function eq(a) {
      var r6 = Ta();
      Ne(a, function(t2) {
        var s = t2.existing;
        s && r6.set(s.id, t2);
      }), Ne(a, function(t2) {
        var s = t2.newOption;
        Hd(!s || s.id == null || !r6.get(s.id) || r6.get(s.id) === t2, "id duplicates: " + (s && s.id)), s && s.id != null && r6.set(s.id, t2), !t2.keyInfo && (t2.keyInfo = {});
      }), Ne(a, function(t2, s) {
        var u = t2.existing, f6 = t2.newOption, d6 = t2.keyInfo;
        if (ui(f6)) {
          if (d6.name = f6.name != null ? GM(f6.name) : u ? u.name : dD + s, u)
            d6.id = GM(u.id);
          else if (f6.id != null)
            d6.id = GM(f6.id);
          else {
            var v6 = 0;
            do
              d6.id = "\0" + d6.name + "\0" + v6++;
            while (r6.get(d6.id));
          }
          r6.set(d6.id, t2);
        }
      });
    }
    function lO(a, r6, t2) {
      var s = Zc(r6[a], null), u = Zc(t2[a], null);
      return s != null && u != null && s === u;
    }
    function GM(a) {
      return Zc(a, "");
    }
    function Zc(a, r6) {
      return a == null ? r6 : _a2(a) ? a : ks(a) || fM(a) ? a + "" : r6;
    }
    function uO(a) {
      var r6 = a.name;
      return !!(r6 && r6.indexOf(dD));
    }
    function WM(a) {
      return a && a.id != null && GM(a.id).indexOf(pD) === 0;
    }
    function tq(a) {
      return pD + a;
    }
    function r1(a, r6, t2) {
      Ne(a, function(s) {
        var u = s.newOption;
        ui(u) && (s.keyInfo.mainType = r6, s.keyInfo.subType = Jd(r6, u, s.existing, t2));
      });
    }
    function Jd(a, r6, t2, s) {
      var u = r6.type ? r6.type : t2 ? t2.subType : s.determineSubType(a, r6);
      return u;
    }
    function cO(a, r6) {
      var t2 = {}, s = {};
      return u(a || [], t2), u(r6 || [], s, t2), [f6(t2), f6(s)];
      function u(d6, v6, m6) {
        for (var b6 = 0, x6 = d6.length; b6 < x6; b6++) {
          var S = Zc(d6[b6].seriesId, null);
          if (S == null)
            return;
          for (var M = ll(d6[b6].dataIndex), A6 = m6 && m6[S], I = 0, R = M.length; I < R; I++) {
            var F = M[I];
            A6 && A6[F] ? A6[F] = null : (v6[S] || (v6[S] = {}))[F] = 1;
          }
        }
      }
      function f6(d6, v6) {
        var m6 = [];
        for (var b6 in d6)
          if (d6.hasOwnProperty(b6) && d6[b6] != null)
            if (v6)
              m6.push(+b6);
            else {
              var x6 = f6(d6[b6], true);
              x6.length && m6.push({ seriesId: b6, dataIndex: x6 });
            }
        return m6;
      }
    }
    function xx(a, r6) {
      if (r6.dataIndexInside != null)
        return r6.dataIndexInside;
      if (r6.dataIndex != null)
        return br(r6.dataIndex) ? wr(r6.dataIndex, function(t2) {
          return a.indexOfRawIndex(t2);
        }) : a.indexOfRawIndex(r6.dataIndex);
      if (r6.name != null)
        return br(r6.name) ? wr(r6.name, function(t2) {
          return a.indexOfName(t2);
        }) : a.indexOfName(r6.name);
    }
    function Xo() {
      var a = "__ec_inner_" + nq++;
      return function(r6) {
        return r6[a] || (r6[a] = {});
      };
    }
    var nq = iO();
    function HM(a, r6, t2) {
      var s = Sx(r6, t2), u = s.mainTypeSpecified, f6 = s.queryOptionMap, d6 = s.others, v6 = d6, m6 = t2 ? t2.defaultMainType : null;
      return !u && m6 && f6.set(m6, {}), f6.each(function(b6, x6) {
        var S = $M(a, x6, b6, { useDefault: m6 === x6, enableAll: t2 && t2.enableAll != null ? t2.enableAll : true, enableNone: t2 && t2.enableNone != null ? t2.enableNone : true });
        v6[x6 + "Models"] = S.models, v6[x6 + "Model"] = S.models[0];
      }), v6;
    }
    function Sx(a, r6) {
      var t2;
      if (_a2(a)) {
        var s = {};
        s[a + "Index"] = 0, t2 = s;
      } else
        t2 = a;
      var u = Ta(), f6 = {}, d6 = false;
      return Ne(t2, function(v6, m6) {
        if (m6 === "dataIndex" || m6 === "dataIndexInside") {
          f6[m6] = v6;
          return;
        }
        var b6 = m6.match(/^(\w+)(Index|Id|Name)$/) || [], x6 = b6[1], S = (b6[2] || "").toLowerCase();
        if (!(!x6 || !S || r6 && r6.includeMainTypes && Vi(r6.includeMainTypes, x6) < 0)) {
          d6 = d6 || !!x6;
          var M = u.get(x6) || u.set(x6, {});
          M[S] = v6;
        }
      }), { mainTypeSpecified: d6, queryOptionMap: u, others: f6 };
    }
    var Lc = { useDefault: true, enableAll: false, enableNone: false }, Y9 = { useDefault: false, enableAll: true, enableNone: true };
    function $M(a, r6, t2, s) {
      s = s || Lc;
      var u = t2.index, f6 = t2.id, d6 = t2.name, v6 = { models: null, specified: u != null || f6 != null || d6 != null };
      if (!v6.specified) {
        var m6 = void 0;
        return v6.models = s.useDefault && (m6 = a.getComponent(r6)) ? [m6] : [], v6;
      }
      return u === "none" || u === false ? (Hd(s.enableNone, '`"none"` or `false` is not a valid value on index option.'), v6.models = [], v6) : (u === "all" && (Hd(s.enableAll, '`"all"` is not a valid value on index option.'), u = f6 = d6 = null), v6.models = a.queryComponents({ mainType: r6, index: u, id: f6, name: d6 }), v6);
    }
    function Z9(a, r6, t2) {
      a.setAttribute ? a.setAttribute(r6, t2) : a[r6] = t2;
    }
    function rq(a, r6) {
      return a.getAttribute ? a.getAttribute(r6) : a[r6];
    }
    function aq(a) {
      return a === "auto" ? ha.domSupported ? "html" : "richText" : a || "html";
    }
    function vD(a, r6) {
      var t2 = Ta(), s = [];
      return Ne(a, function(u) {
        var f6 = r6(u);
        (t2.get(f6) || (s.push(f6), t2.set(f6, []))).push(u);
      }), { keys: s, buckets: t2 };
    }
    function fO(a, r6, t2, s, u) {
      var f6 = r6 == null || r6 === "auto";
      if (s == null)
        return s;
      if (ks(s)) {
        var d6 = hD(t2 || 0, s, u);
        return Sc(d6, f6 ? Math.max(o0(t2 || 0), o0(s)) : r6);
      } else {
        if (_a2(s))
          return u < 1 ? t2 : s;
        for (var v6 = [], m6 = t2, b6 = s, x6 = Math.max(m6 ? m6.length : 0, b6.length), S = 0; S < x6; ++S) {
          var M = a.getDimensionInfo(S);
          if (M && M.type === "ordinal")
            v6[S] = (u < 1 && m6 ? m6 : b6)[S];
          else {
            var A6 = m6 && m6[S] ? m6[S] : 0, I = b6[S], d6 = hD(A6, I, u);
            v6[S] = Sc(d6, f6 ? Math.max(o0(A6), o0(I)) : r6);
          }
        }
        return v6;
      }
    }
    var iq = ".", a1 = "___EC__COMPONENT__CONTAINER___", hO = "___EC__EXTENDED_CLASS___";
    function Lp(a) {
      var r6 = { main: "", sub: "" };
      if (a) {
        var t2 = a.split(iq);
        r6.main = t2[0] || "", r6.sub = t2[1] || "";
      }
      return r6;
    }
    function dO(a) {
      Hd(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(a), 'componentType "' + a + '" illegal');
    }
    function X9(a) {
      return !!(a && a[hO]);
    }
    function gD(a, r6) {
      a.$constructor = a, a.extend = function(t2) {
        var s = this, u;
        return mD(s) ? u = function(f6) {
          tt(d6, f6);
          function d6() {
            return f6.apply(this, arguments) || this;
          }
          return d6;
        }(s) : (u = function() {
          (t2.$constructor || s).apply(this, arguments);
        }, l9(u, this)), qn(u.prototype, t2), u[hO] = true, u.extend = this.extend, u.superCall = oq, u.superApply = K9, u.superClass = s, u;
      };
    }
    function mD(a) {
      return ti(a) && /^class\s/.test(Function.prototype.toString.call(a));
    }
    function pO(a, r6) {
      a.extend = r6.extend;
    }
    var ym = Math.round(Math.random() * 10);
    function Cx(a) {
      var r6 = ["__\0is_clz", ym++].join("_");
      a.prototype[r6] = true, a.isInstance = function(t2) {
        return !!(t2 && t2[r6]);
      };
    }
    function oq(a, r6) {
      for (var t2 = [], s = 2; s < arguments.length; s++)
        t2[s - 2] = arguments[s];
      return this.superClass.prototype[r6].apply(a, t2);
    }
    function K9(a, r6, t2) {
      return this.superClass.prototype[r6].apply(a, t2);
    }
    function yD(a) {
      var r6 = {};
      a.registerClass = function(s) {
        var u = s.type || s.prototype.type;
        if (u) {
          dO(u), s.prototype.type = u;
          var f6 = Lp(u);
          if (!f6.sub)
            r6[f6.main] = s;
          else if (f6.sub !== a1) {
            var d6 = t2(f6);
            d6[f6.sub] = s;
          }
        }
        return s;
      }, a.getClass = function(s, u, f6) {
        var d6 = r6[s];
        if (d6 && d6[a1] && (d6 = u ? d6[u] : null), f6 && !d6)
          throw new Error(u ? "Component " + s + "." + (u || "") + " is used but not imported." : s + ".type should be specified.");
        return d6;
      }, a.getClassesByMainType = function(s) {
        var u = Lp(s), f6 = [], d6 = r6[u.main];
        return d6 && d6[a1] ? Ne(d6, function(v6, m6) {
          m6 !== a1 && f6.push(v6);
        }) : f6.push(d6), f6;
      }, a.hasClass = function(s) {
        var u = Lp(s);
        return !!r6[u.main];
      }, a.getAllClassMainTypes = function() {
        var s = [];
        return Ne(r6, function(u, f6) {
          s.push(f6);
        }), s;
      }, a.hasSubTypes = function(s) {
        var u = Lp(s), f6 = r6[u.main];
        return f6 && f6[a1];
      };
      function t2(s) {
        var u = r6[s.main];
        return (!u || !u[a1]) && (u = r6[s.main] = {}, u[a1] = true), u;
      }
    }
    function Mx(a, r6) {
      for (var t2 = 0; t2 < a.length; t2++)
        a[t2][1] || (a[t2][1] = a[t2][0]);
      return r6 = r6 || false, function(s, u, f6) {
        for (var d6 = {}, v6 = 0; v6 < a.length; v6++) {
          var m6 = a[v6][1];
          if (!(u && Vi(u, m6) >= 0 || f6 && Vi(f6, m6) < 0)) {
            var b6 = s.getShallow(m6, r6);
            b6 != null && (d6[a[v6][0]] = b6);
          }
        }
        return d6;
      };
    }
    var sq = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], lq = Mx(sq), uq = function() {
      function a() {
      }
      return a.prototype.getAreaStyle = function(r6, t2) {
        return lq(this, r6, t2);
      }, a;
    }(), vO = new Yy(50);
    function cq(a) {
      if (typeof a == "string") {
        var r6 = vO.get(a);
        return r6 && r6.image;
      } else
        return a;
    }
    function gO(a, r6, t2, s, u) {
      if (a)
        if (typeof a == "string") {
          if (r6 && r6.__zrImageSrc === a || !t2)
            return r6;
          var f6 = vO.get(a), d6 = { hostEl: t2, cb: s, cbPayload: u };
          if (f6)
            r6 = f6.image, !bD(r6) && f6.pending.push(d6);
          else {
            var v6 = Tc.loadImage(a, J9, J9);
            v6.__zrImageSrc = a, vO.put(a, v6.__cachedImgObj = { image: v6, pending: [d6] });
          }
          return r6;
        } else
          return a;
      else
        return r6;
    }
    function J9() {
      var a = this.__cachedImgObj;
      this.onload = this.onerror = this.__cachedImgObj = null;
      for (var r6 = 0; r6 < a.pending.length; r6++) {
        var t2 = a.pending[r6], s = t2.cb;
        s && s(this, t2.cbPayload), t2.hostEl.dirty();
      }
      a.pending.length = 0;
    }
    function bD(a) {
      return a && a.width && a.height;
    }
    var mO = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
    function Q9(a, r6, t2, s, u) {
      if (!r6)
        return "";
      var f6 = (a + "").split(`
`);
      u = yO(r6, t2, s, u);
      for (var d6 = 0, v6 = f6.length; d6 < v6; d6++)
        f6[d6] = bO(f6[d6], u);
      return f6.join(`
`);
    }
    function yO(a, r6, t2, s) {
      s = s || {};
      var u = qn({}, s);
      u.font = r6, t2 = qi(t2, "..."), u.maxIterations = qi(s.maxIterations, 2);
      var f6 = u.minChar = qi(s.minChar, 0);
      u.cnCharWidth = qu("\u56FD", r6);
      var d6 = u.ascCharWidth = qu("a", r6);
      u.placeholder = qi(s.placeholder, "");
      for (var v6 = a = Math.max(0, a - 1), m6 = 0; m6 < f6 && v6 >= d6; m6++)
        v6 -= d6;
      var b6 = qu(t2, r6);
      return b6 > v6 && (t2 = "", b6 = 0), v6 = a - b6, u.ellipsis = t2, u.ellipsisWidth = b6, u.contentWidth = v6, u.containerWidth = a, u;
    }
    function bO(a, r6) {
      var t2 = r6.containerWidth, s = r6.font, u = r6.contentWidth;
      if (!t2)
        return "";
      var f6 = qu(a, s);
      if (f6 <= t2)
        return a;
      for (var d6 = 0; ; d6++) {
        if (f6 <= u || d6 >= r6.maxIterations) {
          a += r6.ellipsis;
          break;
        }
        var v6 = d6 === 0 ? fq(a, u, r6.ascCharWidth, r6.cnCharWidth) : f6 > 0 ? Math.floor(a.length * u / f6) : 0;
        a = a.substr(0, v6), f6 = qu(a, s);
      }
      return a === "" && (a = r6.placeholder), a;
    }
    function fq(a, r6, t2, s) {
      for (var u = 0, f6 = 0, d6 = a.length; f6 < d6 && u < r6; f6++) {
        var v6 = a.charCodeAt(f6);
        u += 0 <= v6 && v6 <= 127 ? t2 : s;
      }
      return f6;
    }
    function hq(a, r6) {
      a != null && (a += "");
      var t2 = r6.overflow, s = r6.padding, u = r6.font, f6 = t2 === "truncate", d6 = RM(u), v6 = qi(r6.lineHeight, d6), m6 = !!r6.backgroundColor, b6 = r6.lineOverflow === "truncate", x6 = r6.width, S;
      x6 != null && (t2 === "break" || t2 === "breakAll") ? S = a ? Cv(a, r6.font, x6, t2 === "breakAll", 0).lines : [] : S = a ? a.split(`
`) : [];
      var M = S.length * v6, A6 = qi(r6.height, M);
      if (M > A6 && b6) {
        var I = Math.floor(A6 / v6);
        S = S.slice(0, I);
      }
      if (a && f6 && x6 != null)
        for (var R = yO(x6, u, r6.ellipsis, { minChar: r6.truncateMinChar, placeholder: r6.placeholder }), F = 0; F < S.length; F++)
          S[F] = bO(S[F], R);
      for (var j = A6, $ = 0, F = 0; F < S.length; F++)
        $ = Math.max(qu(S[F], u), $);
      x6 == null && (x6 = $);
      var K = $;
      return s && (j += s[0] + s[2], K += s[1] + s[3], x6 += s[1] + s[3]), m6 && (K = x6), { lines: S, height: A6, outerWidth: K, outerHeight: j, lineHeight: v6, calculatedLineHeight: d6, contentWidth: $, contentHeight: M, width: x6 };
    }
    var dq = function() {
      function a() {
      }
      return a;
    }(), _O = function() {
      function a(r6) {
        this.tokens = [], r6 && (this.tokens = r6);
      }
      return a;
    }(), pq = function() {
      function a() {
        this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
      }
      return a;
    }();
    function vq(a, r6) {
      var t2 = new pq();
      if (a != null && (a += ""), !a)
        return t2;
      for (var s = r6.width, u = r6.height, f6 = r6.overflow, d6 = (f6 === "break" || f6 === "breakAll") && s != null ? { width: s, accumWidth: 0, breakAll: f6 === "breakAll" } : null, v6 = mO.lastIndex = 0, m6; (m6 = mO.exec(a)) != null; ) {
        var b6 = m6.index;
        b6 > v6 && xO(t2, a.substring(v6, b6), r6, d6), xO(t2, m6[2], r6, d6, m6[1]), v6 = mO.lastIndex;
      }
      v6 < a.length && xO(t2, a.substring(v6, a.length), r6, d6);
      var x6 = [], S = 0, M = 0, A6 = r6.padding, I = f6 === "truncate", R = r6.lineOverflow === "truncate";
      function F(bt, wt, Ft) {
        bt.width = wt, bt.lineHeight = Ft, S += Ft, M = Math.max(M, wt);
      }
      e:
        for (var j = 0; j < t2.lines.length; j++) {
          for (var $ = t2.lines[j], K = 0, U = 0, he = 0; he < $.tokens.length; he++) {
            var ue = $.tokens[he], pe = ue.styleName && r6.rich[ue.styleName] || {}, _e = ue.textPadding = pe.padding, xe = _e ? _e[1] + _e[3] : 0, Ae = ue.font = pe.font || r6.font;
            ue.contentHeight = RM(Ae);
            var ke = qi(pe.height, ue.contentHeight);
            if (ue.innerHeight = ke, _e && (ke += _e[0] + _e[2]), ue.height = ke, ue.lineHeight = Uy(pe.lineHeight, r6.lineHeight, ke), ue.align = pe && pe.align || r6.align, ue.verticalAlign = pe && pe.verticalAlign || "middle", R && u != null && S + ue.lineHeight > u) {
              he > 0 ? ($.tokens = $.tokens.slice(0, he), F($, U, K), t2.lines = t2.lines.slice(0, j + 1)) : t2.lines = t2.lines.slice(0, j);
              break e;
            }
            var je = pe.width, Fe = je == null || je === "auto";
            if (typeof je == "string" && je.charAt(je.length - 1) === "%")
              ue.percentWidth = je, x6.push(ue), ue.contentWidth = qu(ue.text, Ae);
            else {
              if (Fe) {
                var at = pe.backgroundColor, ht = at && at.image;
                ht && (ht = cq(ht), bD(ht) && (ue.width = Math.max(ue.width, ht.width * ke / ht.height)));
              }
              var Qe = I && s != null ? s - U : null;
              Qe != null && Qe < ue.width ? !Fe || Qe < xe ? (ue.text = "", ue.width = ue.contentWidth = 0) : (ue.text = Q9(ue.text, Qe - xe, Ae, r6.ellipsis, { minChar: r6.truncateMinChar }), ue.width = ue.contentWidth = qu(ue.text, Ae)) : ue.contentWidth = qu(ue.text, Ae);
            }
            ue.width += xe, U += ue.width, pe && (K = Math.max(K, ue.lineHeight));
          }
          F($, U, K);
        }
      t2.outerWidth = t2.width = qi(s, M), t2.outerHeight = t2.height = qi(u, S), t2.contentHeight = S, t2.contentWidth = M, A6 && (t2.outerWidth += A6[1] + A6[3], t2.outerHeight += A6[0] + A6[2]);
      for (var j = 0; j < x6.length; j++) {
        var ue = x6[j], en = ue.percentWidth;
        ue.width = parseInt(en, 10) / 100 * t2.width;
      }
      return t2;
    }
    function xO(a, r6, t2, s, u) {
      var f6 = r6 === "", d6 = u && t2.rich[u] || {}, v6 = a.lines, m6 = d6.font || t2.font, b6 = false, x6, S;
      if (s) {
        var M = d6.padding, A6 = M ? M[1] + M[3] : 0;
        if (d6.width != null && d6.width !== "auto") {
          var I = wv(d6.width, s.width) + A6;
          v6.length > 0 && I + s.accumWidth > s.width && (x6 = r6.split(`
`), b6 = true), s.accumWidth = I;
        } else {
          var R = Cv(r6, m6, s.width, s.breakAll, s.accumWidth);
          s.accumWidth = R.accumWidth + A6, S = R.linesWidths, x6 = R.lines;
        }
      } else
        x6 = r6.split(`
`);
      for (var F = 0; F < x6.length; F++) {
        var j = x6[F], $ = new dq();
        if ($.styleName = u, $.text = j, $.isLineHolder = !j && !f6, typeof d6.width == "number" ? $.width = d6.width : $.width = S ? S[F] : qu(j, m6), !F && !b6) {
          var K = (v6[v6.length - 1] || (v6[0] = new _O())).tokens, U = K.length;
          U === 1 && K[0].isLineHolder ? K[0] = $ : (j || !U || f6) && K.push($);
        } else
          v6.push(new _O([$]));
      }
    }
    function gq(a) {
      var r6 = a.charCodeAt(0);
      return r6 >= 33 && r6 <= 383;
    }
    var mq = qg(",&?/;] ".split(""), function(a, r6) {
      return a[r6] = true, a;
    }, {});
    function yq(a) {
      return gq(a) ? !!mq[a] : true;
    }
    function Cv(a, r6, t2, s, u) {
      for (var f6 = [], d6 = [], v6 = "", m6 = "", b6 = 0, x6 = 0, S = 0; S < a.length; S++) {
        var M = a.charAt(S);
        if (M === `
`) {
          m6 && (v6 += m6, x6 += b6), f6.push(v6), d6.push(x6), v6 = "", m6 = "", b6 = 0, x6 = 0;
          continue;
        }
        var A6 = qu(M, r6), I = s ? false : !yq(M);
        if (f6.length ? x6 + A6 > t2 : u + x6 + A6 > t2) {
          x6 ? (v6 || m6) && (I ? (v6 || (v6 = m6, m6 = "", b6 = 0, x6 = b6), f6.push(v6), d6.push(x6 - b6), m6 += M, b6 += A6, v6 = "", x6 = b6) : (m6 && (v6 += m6, m6 = "", b6 = 0), f6.push(v6), d6.push(x6), v6 = M, x6 = A6)) : I ? (f6.push(m6), d6.push(b6), m6 = M, b6 = A6) : (f6.push(M), d6.push(A6));
          continue;
        }
        x6 += A6, I ? (m6 += M, b6 += A6) : (m6 && (v6 += m6, m6 = "", b6 = 0), v6 += M);
      }
      return !f6.length && !v6 && (v6 = a, m6 = "", b6 = 0), m6 && (v6 += m6), v6 && (f6.push(v6), d6.push(x6)), f6.length === 1 && (x6 += u), { accumWidth: x6, lines: f6, linesWidths: d6 };
    }
    var wO = "__zr_style_" + Math.round(Math.random() * 10), Ax = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, _D = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
    Ax[wO] = true;
    var SO = ["z", "z2", "invisible"], bq = ["invisible"], _q = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype._init = function(t2) {
        for (var s = Po(t2), u = 0; u < s.length; u++) {
          var f6 = s[u];
          f6 === "style" ? this.useStyle(t2[f6]) : a.prototype.attrKV.call(this, f6, t2[f6]);
        }
        this.style || this.useStyle({});
      }, r6.prototype.beforeBrush = function() {
      }, r6.prototype.afterBrush = function() {
      }, r6.prototype.innerBeforeBrush = function() {
      }, r6.prototype.innerAfterBrush = function() {
      }, r6.prototype.shouldBePainted = function(t2, s, u, f6) {
        var d6 = this.transform;
        if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && AO(this, t2, s) || d6 && !d6[0] && !d6[3])
          return false;
        if (u && this.__clipPaths) {
          for (var v6 = 0; v6 < this.__clipPaths.length; ++v6)
            if (this.__clipPaths[v6].isZeroArea())
              return false;
        }
        if (f6 && this.parent)
          for (var m6 = this.parent; m6; ) {
            if (m6.ignore)
              return false;
            m6 = m6.parent;
          }
        return true;
      }, r6.prototype.contain = function(t2, s) {
        return this.rectContain(t2, s);
      }, r6.prototype.traverse = function(t2, s) {
        t2.call(s, this);
      }, r6.prototype.rectContain = function(t2, s) {
        var u = this.transformCoordToLocal(t2, s), f6 = this.getBoundingRect();
        return f6.contain(u[0], u[1]);
      }, r6.prototype.getPaintRect = function() {
        var t2 = this._paintRect;
        if (!this._paintRect || this.__dirty) {
          var s = this.transform, u = this.getBoundingRect(), f6 = this.style, d6 = f6.shadowBlur || 0, v6 = f6.shadowOffsetX || 0, m6 = f6.shadowOffsetY || 0;
          t2 = this._paintRect || (this._paintRect = new Qi(0, 0, 0, 0)), s ? Qi.applyTransform(t2, u, s) : t2.copy(u), (d6 || v6 || m6) && (t2.width += d6 * 2 + Math.abs(v6), t2.height += d6 * 2 + Math.abs(m6), t2.x = Math.min(t2.x, t2.x + v6 - d6), t2.y = Math.min(t2.y, t2.y + m6 - d6));
          var b6 = this.dirtyRectTolerance;
          t2.isZero() || (t2.x = Math.floor(t2.x - b6), t2.y = Math.floor(t2.y - b6), t2.width = Math.ceil(t2.width + 1 + b6 * 2), t2.height = Math.ceil(t2.height + 1 + b6 * 2));
        }
        return t2;
      }, r6.prototype.setPrevPaintRect = function(t2) {
        t2 ? (this._prevPaintRect = this._prevPaintRect || new Qi(0, 0, 0, 0), this._prevPaintRect.copy(t2)) : this._prevPaintRect = null;
      }, r6.prototype.getPrevPaintRect = function() {
        return this._prevPaintRect;
      }, r6.prototype.animateStyle = function(t2) {
        return this.animate("style", t2);
      }, r6.prototype.updateDuringAnimation = function(t2) {
        t2 === "style" ? this.dirtyStyle() : this.markRedraw();
      }, r6.prototype.attrKV = function(t2, s) {
        t2 !== "style" ? a.prototype.attrKV.call(this, t2, s) : this.style ? this.setStyle(s) : this.useStyle(s);
      }, r6.prototype.setStyle = function(t2, s) {
        return typeof t2 == "string" ? this.style[t2] = s : qn(this.style, t2), this.dirtyStyle(), this;
      }, r6.prototype.dirtyStyle = function(t2) {
        t2 || this.markRedraw(), this.__dirty |= _M, this._rect && (this._rect = null);
      }, r6.prototype.dirty = function() {
        this.dirtyStyle();
      }, r6.prototype.styleChanged = function() {
        return !!(this.__dirty & _M);
      }, r6.prototype.styleUpdated = function() {
        this.__dirty &= ~_M;
      }, r6.prototype.createStyle = function(t2) {
        return pM(Ax, t2);
      }, r6.prototype.useStyle = function(t2) {
        t2[wO] || (t2 = this.createStyle(t2)), this.__inHover ? this.__hoverStyle = t2 : this.style = t2, this.dirtyStyle();
      }, r6.prototype.isStyleObject = function(t2) {
        return t2[wO];
      }, r6.prototype._innerSaveToNormal = function(t2) {
        a.prototype._innerSaveToNormal.call(this, t2);
        var s = this._normalState;
        t2.style && !s.style && (s.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(t2, s, SO);
      }, r6.prototype._applyStateObj = function(t2, s, u, f6, d6, v6) {
        a.prototype._applyStateObj.call(this, t2, s, u, f6, d6, v6);
        var m6 = !(s && f6), b6;
        if (s && s.style ? d6 ? f6 ? b6 = s.style : (b6 = this._mergeStyle(this.createStyle(), u.style), this._mergeStyle(b6, s.style)) : (b6 = this._mergeStyle(this.createStyle(), f6 ? this.style : u.style), this._mergeStyle(b6, s.style)) : m6 && (b6 = u.style), b6)
          if (d6) {
            var x6 = this.style;
            if (this.style = this.createStyle(m6 ? {} : x6), m6)
              for (var S = Po(x6), M = 0; M < S.length; M++) {
                var A6 = S[M];
                A6 in b6 && (b6[A6] = b6[A6], this.style[A6] = x6[A6]);
              }
            for (var I = Po(b6), M = 0; M < I.length; M++) {
              var A6 = I[M];
              this.style[A6] = this.style[A6];
            }
            this._transitionState(t2, { style: b6 }, v6, this.getAnimationStyleProps());
          } else
            this.useStyle(b6);
        for (var R = this.__inHover ? bq : SO, M = 0; M < R.length; M++) {
          var A6 = R[M];
          s && s[A6] != null ? this[A6] = s[A6] : m6 && u[A6] != null && (this[A6] = u[A6]);
        }
      }, r6.prototype._mergeStates = function(t2) {
        for (var s = a.prototype._mergeStates.call(this, t2), u, f6 = 0; f6 < t2.length; f6++) {
          var d6 = t2[f6];
          d6.style && (u = u || {}, this._mergeStyle(u, d6.style));
        }
        return u && (s.style = u), s;
      }, r6.prototype._mergeStyle = function(t2, s) {
        return qn(t2, s), t2;
      }, r6.prototype.getAnimationStyleProps = function() {
        return _D;
      }, r6.initDefaultProps = function() {
        var t2 = r6.prototype;
        t2.type = "displayable", t2.invisible = false, t2.z = 0, t2.z2 = 0, t2.zlevel = 0, t2.culling = false, t2.cursor = "pointer", t2.rectHover = false, t2.incremental = false, t2._rect = null, t2.dirtyRectTolerance = 0, t2.__dirty = ad | _M;
      }(), r6;
    }(z9), CO = new Qi(0, 0, 0, 0), MO = new Qi(0, 0, 0, 0);
    function AO(a, r6, t2) {
      return CO.copy(a.getBoundingRect()), a.transform && CO.applyTransform(a.transform), MO.width = r6, MO.height = t2, !CO.intersect(MO);
    }
    var cg = _q, Op = Math.min, Rp = Math.max, EO = Math.sin, IO = Math.cos, Ex = Math.PI * 2, xD = Df(), wD = Df(), SD = Df();
    function CD(a, r6, t2) {
      if (a.length !== 0) {
        for (var s = a[0], u = s[0], f6 = s[0], d6 = s[1], v6 = s[1], m6 = 1; m6 < a.length; m6++)
          s = a[m6], u = Op(u, s[0]), f6 = Rp(f6, s[0]), d6 = Op(d6, s[1]), v6 = Rp(v6, s[1]);
        r6[0] = u, r6[1] = d6, t2[0] = f6, t2[1] = v6;
      }
    }
    function e7(a, r6, t2, s, u, f6) {
      u[0] = Op(a, t2), u[1] = Op(r6, s), f6[0] = Rp(a, t2), f6[1] = Rp(r6, s);
    }
    var t7 = [], n7 = [];
    function xq(a, r6, t2, s, u, f6, d6, v6, m6, b6) {
      var x6 = w9, S = Pc, M = x6(a, t2, u, d6, t7);
      m6[0] = 1 / 0, m6[1] = 1 / 0, b6[0] = -1 / 0, b6[1] = -1 / 0;
      for (var A6 = 0; A6 < M; A6++) {
        var I = S(a, t2, u, d6, t7[A6]);
        m6[0] = Op(I, m6[0]), b6[0] = Rp(I, b6[0]);
      }
      M = x6(r6, s, f6, v6, n7);
      for (var A6 = 0; A6 < M; A6++) {
        var R = S(r6, s, f6, v6, n7[A6]);
        m6[1] = Op(R, m6[1]), b6[1] = Rp(R, b6[1]);
      }
      m6[0] = Op(a, m6[0]), b6[0] = Rp(a, b6[0]), m6[0] = Op(d6, m6[0]), b6[0] = Rp(d6, b6[0]), m6[1] = Op(r6, m6[1]), b6[1] = Rp(r6, b6[1]), m6[1] = Op(v6, m6[1]), b6[1] = Rp(v6, b6[1]);
    }
    function wq(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = S9, b6 = eh, x6 = Rp(Op(m6(a, t2, u), 1), 0), S = Rp(Op(m6(r6, s, f6), 1), 0), M = b6(a, t2, u, x6), A6 = b6(r6, s, f6, S);
      d6[0] = Op(a, u, M), d6[1] = Op(r6, f6, A6), v6[0] = Rp(a, u, M), v6[1] = Rp(r6, f6, A6);
    }
    function Sq(a, r6, t2, s, u, f6, d6, v6, m6) {
      var b6 = Yg, x6 = xv, S = Math.abs(u - f6);
      if (S % Ex < 1e-4 && S > 1e-4) {
        v6[0] = a - t2, v6[1] = r6 - s, m6[0] = a + t2, m6[1] = r6 + s;
        return;
      }
      if (xD[0] = IO(u) * t2 + a, xD[1] = EO(u) * s + r6, wD[0] = IO(f6) * t2 + a, wD[1] = EO(f6) * s + r6, b6(v6, xD, wD), x6(m6, xD, wD), u = u % Ex, u < 0 && (u = u + Ex), f6 = f6 % Ex, f6 < 0 && (f6 = f6 + Ex), u > f6 && !d6 ? f6 += Ex : u < f6 && d6 && (u += Ex), d6) {
        var M = f6;
        f6 = u, u = M;
      }
      for (var A6 = 0; A6 < f6; A6 += Math.PI / 2)
        A6 > u && (SD[0] = IO(A6) * t2 + a, SD[1] = EO(A6) * s + r6, b6(v6, SD, v6), x6(m6, SD, m6));
    }
    var Bl = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, Ix = [], Tx = [], bm = [], _m = [], u0 = [], xm = [], TO = Math.min, DO = Math.max, Dx = Math.cos, kx = Math.sin, i1 = Math.abs, kO = Math.PI, Ab = kO * 2, MD = typeof Float32Array != "undefined", UM = [];
    function B2(a) {
      var r6 = Math.round(a / kO * 1e8) / 1e8;
      return r6 % 2 * kO;
    }
    function Cq(a, r6) {
      var t2 = B2(a[0]);
      t2 < 0 && (t2 += Ab);
      var s = t2 - a[0], u = a[1];
      u += s, !r6 && u - t2 >= Ab ? u = t2 + Ab : r6 && t2 - u >= Ab ? u = t2 - Ab : !r6 && t2 > u ? u = t2 + (Ab - B2(t2 - u)) : r6 && t2 < u && (u = t2 - (Ab - B2(u - t2))), a[0] = t2, a[1] = u;
    }
    var Mq = function() {
      function a(r6) {
        this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, r6 && (this._saveData = false), this._saveData && (this.data = []);
      }
      return a.prototype.increaseVersion = function() {
        this._version++;
      }, a.prototype.getVersion = function() {
        return this._version;
      }, a.prototype.setScale = function(r6, t2, s) {
        s = s || 0, s > 0 && (this._ux = i1(s / tD / r6) || 0, this._uy = i1(s / tD / t2) || 0);
      }, a.prototype.setDPR = function(r6) {
        this.dpr = r6;
      }, a.prototype.setContext = function(r6) {
        this._ctx = r6;
      }, a.prototype.getContext = function() {
        return this._ctx;
      }, a.prototype.beginPath = function() {
        return this._ctx && this._ctx.beginPath(), this.reset(), this;
      }, a.prototype.reset = function() {
        this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
      }, a.prototype.moveTo = function(r6, t2) {
        return this._drawPendingPt(), this.addData(Bl.M, r6, t2), this._ctx && this._ctx.moveTo(r6, t2), this._x0 = r6, this._y0 = t2, this._xi = r6, this._yi = t2, this;
      }, a.prototype.lineTo = function(r6, t2) {
        var s = i1(r6 - this._xi), u = i1(t2 - this._yi), f6 = s > this._ux || u > this._uy;
        if (this.addData(Bl.L, r6, t2), this._ctx && f6 && this._ctx.lineTo(r6, t2), f6)
          this._xi = r6, this._yi = t2, this._pendingPtDist = 0;
        else {
          var d6 = s * s + u * u;
          d6 > this._pendingPtDist && (this._pendingPtX = r6, this._pendingPtY = t2, this._pendingPtDist = d6);
        }
        return this;
      }, a.prototype.bezierCurveTo = function(r6, t2, s, u, f6, d6) {
        return this._drawPendingPt(), this.addData(Bl.C, r6, t2, s, u, f6, d6), this._ctx && this._ctx.bezierCurveTo(r6, t2, s, u, f6, d6), this._xi = f6, this._yi = d6, this;
      }, a.prototype.quadraticCurveTo = function(r6, t2, s, u) {
        return this._drawPendingPt(), this.addData(Bl.Q, r6, t2, s, u), this._ctx && this._ctx.quadraticCurveTo(r6, t2, s, u), this._xi = s, this._yi = u, this;
      }, a.prototype.arc = function(r6, t2, s, u, f6, d6) {
        this._drawPendingPt(), UM[0] = u, UM[1] = f6, Cq(UM, d6), u = UM[0], f6 = UM[1];
        var v6 = f6 - u;
        return this.addData(Bl.A, r6, t2, s, s, u, v6, 0, d6 ? 0 : 1), this._ctx && this._ctx.arc(r6, t2, s, u, f6, d6), this._xi = Dx(f6) * s + r6, this._yi = kx(f6) * s + t2, this;
      }, a.prototype.arcTo = function(r6, t2, s, u, f6) {
        return this._drawPendingPt(), this._ctx && this._ctx.arcTo(r6, t2, s, u, f6), this;
      }, a.prototype.rect = function(r6, t2, s, u) {
        return this._drawPendingPt(), this._ctx && this._ctx.rect(r6, t2, s, u), this.addData(Bl.R, r6, t2, s, u), this;
      }, a.prototype.closePath = function() {
        this._drawPendingPt(), this.addData(Bl.Z);
        var r6 = this._ctx, t2 = this._x0, s = this._y0;
        return r6 && r6.closePath(), this._xi = t2, this._yi = s, this;
      }, a.prototype.fill = function(r6) {
        r6 && r6.fill(), this.toStatic();
      }, a.prototype.stroke = function(r6) {
        r6 && r6.stroke(), this.toStatic();
      }, a.prototype.len = function() {
        return this._len;
      }, a.prototype.setData = function(r6) {
        var t2 = r6.length;
        !(this.data && this.data.length === t2) && MD && (this.data = new Float32Array(t2));
        for (var s = 0; s < t2; s++)
          this.data[s] = r6[s];
        this._len = t2;
      }, a.prototype.appendPath = function(r6) {
        r6 instanceof Array || (r6 = [r6]);
        for (var t2 = r6.length, s = 0, u = this._len, f6 = 0; f6 < t2; f6++)
          s += r6[f6].len();
        MD && this.data instanceof Float32Array && (this.data = new Float32Array(u + s));
        for (var f6 = 0; f6 < t2; f6++)
          for (var d6 = r6[f6].data, v6 = 0; v6 < d6.length; v6++)
            this.data[u++] = d6[v6];
        this._len = u;
      }, a.prototype.addData = function(r6, t2, s, u, f6, d6, v6, m6, b6) {
        if (this._saveData) {
          var x6 = this.data;
          this._len + arguments.length > x6.length && (this._expandData(), x6 = this.data);
          for (var S = 0; S < arguments.length; S++)
            x6[this._len++] = arguments[S];
        }
      }, a.prototype._drawPendingPt = function() {
        this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
      }, a.prototype._expandData = function() {
        if (!(this.data instanceof Array)) {
          for (var r6 = [], t2 = 0; t2 < this._len; t2++)
            r6[t2] = this.data[t2];
          this.data = r6;
        }
      }, a.prototype.toStatic = function() {
        if (this._saveData) {
          this._drawPendingPt();
          var r6 = this.data;
          r6 instanceof Array && (r6.length = this._len, MD && this._len > 11 && (this.data = new Float32Array(r6)));
        }
      }, a.prototype.getBoundingRect = function() {
        bm[0] = bm[1] = u0[0] = u0[1] = Number.MAX_VALUE, _m[0] = _m[1] = xm[0] = xm[1] = -Number.MAX_VALUE;
        var r6 = this.data, t2 = 0, s = 0, u = 0, f6 = 0, d6;
        for (d6 = 0; d6 < this._len; ) {
          var v6 = r6[d6++], m6 = d6 === 1;
          switch (m6 && (t2 = r6[d6], s = r6[d6 + 1], u = t2, f6 = s), v6) {
            case Bl.M:
              t2 = u = r6[d6++], s = f6 = r6[d6++], u0[0] = u, u0[1] = f6, xm[0] = u, xm[1] = f6;
              break;
            case Bl.L:
              e7(t2, s, r6[d6], r6[d6 + 1], u0, xm), t2 = r6[d6++], s = r6[d6++];
              break;
            case Bl.C:
              xq(t2, s, r6[d6++], r6[d6++], r6[d6++], r6[d6++], r6[d6], r6[d6 + 1], u0, xm), t2 = r6[d6++], s = r6[d6++];
              break;
            case Bl.Q:
              wq(t2, s, r6[d6++], r6[d6++], r6[d6], r6[d6 + 1], u0, xm), t2 = r6[d6++], s = r6[d6++];
              break;
            case Bl.A:
              var b6 = r6[d6++], x6 = r6[d6++], S = r6[d6++], M = r6[d6++], A6 = r6[d6++], I = r6[d6++] + A6;
              d6 += 1;
              var R = !r6[d6++];
              m6 && (u = Dx(A6) * S + b6, f6 = kx(A6) * M + x6), Sq(b6, x6, S, M, A6, I, R, u0, xm), t2 = Dx(I) * S + b6, s = kx(I) * M + x6;
              break;
            case Bl.R:
              u = t2 = r6[d6++], f6 = s = r6[d6++];
              var F = r6[d6++], j = r6[d6++];
              e7(u, f6, u + F, f6 + j, u0, xm);
              break;
            case Bl.Z:
              t2 = u, s = f6;
              break;
          }
          Yg(bm, bm, u0), xv(_m, _m, xm);
        }
        return d6 === 0 && (bm[0] = bm[1] = _m[0] = _m[1] = 0), new Qi(bm[0], bm[1], _m[0] - bm[0], _m[1] - bm[1]);
      }, a.prototype._calculateLength = function() {
        var r6 = this.data, t2 = this._len, s = this._ux, u = this._uy, f6 = 0, d6 = 0, v6 = 0, m6 = 0;
        this._pathSegLen || (this._pathSegLen = []);
        for (var b6 = this._pathSegLen, x6 = 0, S = 0, M = 0; M < t2; ) {
          var A6 = r6[M++], I = M === 1;
          I && (f6 = r6[M], d6 = r6[M + 1], v6 = f6, m6 = d6);
          var R = -1;
          switch (A6) {
            case Bl.M:
              f6 = v6 = r6[M++], d6 = m6 = r6[M++];
              break;
            case Bl.L: {
              var F = r6[M++], j = r6[M++], $ = F - f6, K = j - d6;
              (i1($) > s || i1(K) > u || M === t2 - 1) && (R = Math.sqrt($ * $ + K * K), f6 = F, d6 = j);
              break;
            }
            case Bl.C: {
              var U = r6[M++], he = r6[M++], F = r6[M++], j = r6[M++], ue = r6[M++], pe = r6[M++];
              R = IL(f6, d6, U, he, F, j, ue, pe, 10), f6 = ue, d6 = pe;
              break;
            }
            case Bl.Q: {
              var U = r6[M++], he = r6[M++], F = r6[M++], j = r6[M++];
              R = DU(f6, d6, U, he, F, j, 10), f6 = F, d6 = j;
              break;
            }
            case Bl.A:
              var _e = r6[M++], xe = r6[M++], Ae = r6[M++], ke = r6[M++], je = r6[M++], Fe = r6[M++], at = Fe + je;
              M += 1, r6[M++], I && (v6 = Dx(je) * Ae + _e, m6 = kx(je) * ke + xe), R = DO(Ae, ke) * TO(Ab, Math.abs(Fe)), f6 = Dx(at) * Ae + _e, d6 = kx(at) * ke + xe;
              break;
            case Bl.R: {
              v6 = f6 = r6[M++], m6 = d6 = r6[M++];
              var ht = r6[M++], Qe = r6[M++];
              R = ht * 2 + Qe * 2;
              break;
            }
            case Bl.Z: {
              var $ = v6 - f6, K = m6 - d6;
              R = Math.sqrt($ * $ + K * K), f6 = v6, d6 = m6;
              break;
            }
          }
          R >= 0 && (b6[S++] = R, x6 += R);
        }
        return this._pathLen = x6, x6;
      }, a.prototype.rebuildPath = function(r6, t2) {
        var s = this.data, u = this._ux, f6 = this._uy, d6 = this._len, v6, m6, b6, x6, S, M, A6 = t2 < 1, I, R, F = 0, j = 0, $, K = 0, U, he;
        if (A6 && (this._pathSegLen || this._calculateLength(), I = this._pathSegLen, R = this._pathLen, $ = t2 * R, !$))
          return;
        e:
          for (var ue = 0; ue < d6; ) {
            var pe = s[ue++], _e = ue === 1;
            switch (_e && (b6 = s[ue], x6 = s[ue + 1], v6 = b6, m6 = x6), pe !== Bl.L && K > 0 && (r6.lineTo(U, he), K = 0), pe) {
              case Bl.M:
                v6 = b6 = s[ue++], m6 = x6 = s[ue++], r6.moveTo(b6, x6);
                break;
              case Bl.L: {
                S = s[ue++], M = s[ue++];
                var xe = i1(S - b6), Ae = i1(M - x6);
                if (xe > u || Ae > f6) {
                  if (A6) {
                    var ke = I[j++];
                    if (F + ke > $) {
                      var je = ($ - F) / ke;
                      r6.lineTo(b6 * (1 - je) + S * je, x6 * (1 - je) + M * je);
                      break e;
                    }
                    F += ke;
                  }
                  r6.lineTo(S, M), b6 = S, x6 = M, K = 0;
                } else {
                  var Fe = xe * xe + Ae * Ae;
                  Fe > K && (U = S, he = M, K = Fe);
                }
                break;
              }
              case Bl.C: {
                var at = s[ue++], ht = s[ue++], Qe = s[ue++], en = s[ue++], bt = s[ue++], wt = s[ue++];
                if (A6) {
                  var ke = I[j++];
                  if (F + ke > $) {
                    var je = ($ - F) / ke;
                    Jg(b6, at, Qe, bt, je, Ix), Jg(x6, ht, en, wt, je, Tx), r6.bezierCurveTo(Ix[1], Tx[1], Ix[2], Tx[2], Ix[3], Tx[3]);
                    break e;
                  }
                  F += ke;
                }
                r6.bezierCurveTo(at, ht, Qe, en, bt, wt), b6 = bt, x6 = wt;
                break;
              }
              case Bl.Q: {
                var at = s[ue++], ht = s[ue++], Qe = s[ue++], en = s[ue++];
                if (A6) {
                  var ke = I[j++];
                  if (F + ke > $) {
                    var je = ($ - F) / ke;
                    wc(b6, at, Qe, je, Ix), wc(x6, ht, en, je, Tx), r6.quadraticCurveTo(Ix[1], Tx[1], Ix[2], Tx[2]);
                    break e;
                  }
                  F += ke;
                }
                r6.quadraticCurveTo(at, ht, Qe, en), b6 = Qe, x6 = en;
                break;
              }
              case Bl.A:
                var Ft = s[ue++], fn = s[ue++], gn = s[ue++], Zr = s[ue++], Ma = s[ue++], Ua = s[ue++], ja = s[ue++], Ga = !s[ue++], pa = gn > Zr ? gn : Zr, Fa = i1(gn - Zr) > 1e-3, Ha = Ma + Ua, Sa = false;
                if (A6) {
                  var ke = I[j++];
                  F + ke > $ && (Ha = Ma + Ua * ($ - F) / ke, Sa = true), F += ke;
                }
                if (Fa && r6.ellipse ? r6.ellipse(Ft, fn, gn, Zr, ja, Ma, Ha, Ga) : r6.arc(Ft, fn, pa, Ma, Ha, Ga), Sa)
                  break e;
                _e && (v6 = Dx(Ma) * gn + Ft, m6 = kx(Ma) * Zr + fn), b6 = Dx(Ha) * gn + Ft, x6 = kx(Ha) * Zr + fn;
                break;
              case Bl.R:
                v6 = b6 = s[ue], m6 = x6 = s[ue + 1], S = s[ue++], M = s[ue++];
                var oi = s[ue++], bs = s[ue++];
                if (A6) {
                  var ke = I[j++];
                  if (F + ke > $) {
                    var Si = $ - F;
                    r6.moveTo(S, M), r6.lineTo(S + TO(Si, oi), M), Si -= oi, Si > 0 && r6.lineTo(S + oi, M + TO(Si, bs)), Si -= bs, Si > 0 && r6.lineTo(S + DO(oi - Si, 0), M + bs), Si -= oi, Si > 0 && r6.lineTo(S, M + DO(bs - Si, 0));
                    break e;
                  }
                  F += ke;
                }
                r6.rect(S, M, oi, bs);
                break;
              case Bl.Z:
                if (A6) {
                  var ke = I[j++];
                  if (F + ke > $) {
                    var je = ($ - F) / ke;
                    r6.lineTo(b6 * (1 - je) + v6 * je, x6 * (1 - je) + m6 * je);
                    break e;
                  }
                  F += ke;
                }
                r6.closePath(), b6 = v6, x6 = m6;
            }
          }
      }, a.prototype.clone = function() {
        var r6 = new a(), t2 = this.data;
        return r6.data = t2.slice ? t2.slice() : Array.prototype.slice.call(t2), r6._len = this._len, r6;
      }, a.CMD = Bl, a.initDefaultProps = function() {
        var r6 = a.prototype;
        r6._saveData = true, r6._ux = 0, r6._uy = 0, r6._pendingPtDist = 0, r6._version = 0;
      }(), a;
    }(), wm = Mq;
    function Eb(a, r6, t2, s, u, f6, d6) {
      if (u === 0)
        return false;
      var v6 = u, m6 = 0, b6 = a;
      if (d6 > r6 + v6 && d6 > s + v6 || d6 < r6 - v6 && d6 < s - v6 || f6 > a + v6 && f6 > t2 + v6 || f6 < a - v6 && f6 < t2 - v6)
        return false;
      if (a !== t2)
        m6 = (r6 - s) / (a - t2), b6 = (a * s - t2 * r6) / (a - t2);
      else
        return Math.abs(f6 - a) <= v6 / 2;
      var x6 = m6 * f6 - d6 + b6, S = x6 * x6 / (m6 * m6 + 1);
      return S <= v6 / 2 * v6 / 2;
    }
    function Aq(a, r6, t2, s, u, f6, d6, v6, m6, b6, x6) {
      if (m6 === 0)
        return false;
      var S = m6;
      if (x6 > r6 + S && x6 > s + S && x6 > f6 + S && x6 > v6 + S || x6 < r6 - S && x6 < s - S && x6 < f6 - S && x6 < v6 - S || b6 > a + S && b6 > t2 + S && b6 > u + S && b6 > d6 + S || b6 < a - S && b6 < t2 - S && b6 < u - S && b6 < d6 - S)
        return false;
      var M = MM(a, r6, t2, s, u, f6, d6, v6, b6, x6, null);
      return M <= S / 2;
    }
    function r7(a, r6, t2, s, u, f6, d6, v6, m6) {
      if (d6 === 0)
        return false;
      var b6 = d6;
      if (m6 > r6 + b6 && m6 > s + b6 && m6 > f6 + b6 || m6 < r6 - b6 && m6 < s - b6 && m6 < f6 - b6 || v6 > a + b6 && v6 > t2 + b6 && v6 > u + b6 || v6 < a - b6 && v6 < t2 - b6 && v6 < u - b6)
        return false;
      var x6 = Sh(a, r6, t2, s, u, f6, v6, m6, null);
      return x6 <= b6 / 2;
    }
    var a7 = Math.PI * 2;
    function Ib(a) {
      return a %= a7, a < 0 && (a += a7), a;
    }
    var qM = Math.PI * 2;
    function Eq(a, r6, t2, s, u, f6, d6, v6, m6) {
      if (d6 === 0)
        return false;
      var b6 = d6;
      v6 -= a, m6 -= r6;
      var x6 = Math.sqrt(v6 * v6 + m6 * m6);
      if (x6 - b6 > t2 || x6 + b6 < t2)
        return false;
      if (Math.abs(s - u) % qM < 1e-4)
        return true;
      if (f6) {
        var S = s;
        s = Ib(u), u = Ib(S);
      } else
        s = Ib(s), u = Ib(u);
      s > u && (u += qM);
      var M = Math.atan2(m6, v6);
      return M < 0 && (M += qM), M >= s && M <= u || M + qM >= s && M + qM <= u;
    }
    function o1(a, r6, t2, s, u, f6) {
      if (f6 > r6 && f6 > s || f6 < r6 && f6 < s || s === r6)
        return 0;
      var d6 = (f6 - r6) / (s - r6), v6 = s < r6 ? 1 : -1;
      (d6 === 1 || d6 === 0) && (v6 = s < r6 ? 0.5 : -0.5);
      var m6 = d6 * (t2 - a) + a;
      return m6 === u ? 1 / 0 : m6 > u ? v6 : 0;
    }
    var Tb = wm.CMD, Px = Math.PI * 2, Iq = 1e-4;
    function Tq(a, r6) {
      return Math.abs(a - r6) < Iq;
    }
    var Qd = [-1, -1, -1], Mv = [-1, -1];
    function i7() {
      var a = Mv[0];
      Mv[0] = Mv[1], Mv[1] = a;
    }
    function Dq(a, r6, t2, s, u, f6, d6, v6, m6, b6) {
      if (b6 > r6 && b6 > s && b6 > f6 && b6 > v6 || b6 < r6 && b6 < s && b6 < f6 && b6 < v6)
        return 0;
      var x6 = VT(r6, s, f6, v6, b6, Qd);
      if (x6 === 0)
        return 0;
      for (var S = 0, M = -1, A6 = void 0, I = void 0, R = 0; R < x6; R++) {
        var F = Qd[R], j = F === 0 || F === 1 ? 0.5 : 1, $ = Pc(a, t2, u, d6, F);
        $ < m6 || (M < 0 && (M = w9(r6, s, f6, v6, Mv), Mv[1] < Mv[0] && M > 1 && i7(), A6 = Pc(r6, s, f6, v6, Mv[0]), M > 1 && (I = Pc(r6, s, f6, v6, Mv[1]))), M === 2 ? F < Mv[0] ? S += A6 < r6 ? j : -j : F < Mv[1] ? S += I < A6 ? j : -j : S += v6 < I ? j : -j : F < Mv[0] ? S += A6 < r6 ? j : -j : S += v6 < A6 ? j : -j);
      }
      return S;
    }
    function kq(a, r6, t2, s, u, f6, d6, v6) {
      if (v6 > r6 && v6 > s && v6 > f6 || v6 < r6 && v6 < s && v6 < f6)
        return 0;
      var m6 = TU(r6, s, f6, v6, Qd);
      if (m6 === 0)
        return 0;
      var b6 = S9(r6, s, f6);
      if (b6 >= 0 && b6 <= 1) {
        for (var x6 = 0, S = eh(r6, s, f6, b6), M = 0; M < m6; M++) {
          var A6 = Qd[M] === 0 || Qd[M] === 1 ? 0.5 : 1, I = eh(a, t2, u, Qd[M]);
          I < d6 || (Qd[M] < b6 ? x6 += S < r6 ? A6 : -A6 : x6 += f6 < S ? A6 : -A6);
        }
        return x6;
      } else {
        var A6 = Qd[0] === 0 || Qd[0] === 1 ? 0.5 : 1, I = eh(a, t2, u, Qd[0]);
        return I < d6 ? 0 : f6 < r6 ? A6 : -A6;
      }
    }
    function Pq(a, r6, t2, s, u, f6, d6, v6) {
      if (v6 -= r6, v6 > t2 || v6 < -t2)
        return 0;
      var m6 = Math.sqrt(t2 * t2 - v6 * v6);
      Qd[0] = -m6, Qd[1] = m6;
      var b6 = Math.abs(s - u);
      if (b6 < 1e-4)
        return 0;
      if (b6 >= Px - 1e-4) {
        s = 0, u = Px;
        var x6 = f6 ? 1 : -1;
        return d6 >= Qd[0] + a && d6 <= Qd[1] + a ? x6 : 0;
      }
      if (s > u) {
        var S = s;
        s = u, u = S;
      }
      s < 0 && (s += Px, u += Px);
      for (var M = 0, A6 = 0; A6 < 2; A6++) {
        var I = Qd[A6];
        if (I + a > d6) {
          var R = Math.atan2(v6, I), x6 = f6 ? 1 : -1;
          R < 0 && (R = Px + R), (R >= s && R <= u || R + Px >= s && R + Px <= u) && (R > Math.PI / 2 && R < Math.PI * 1.5 && (x6 = -x6), M += x6);
        }
      }
      return M;
    }
    function o7(a, r6, t2, s, u) {
      for (var f6 = a.data, d6 = a.len(), v6 = 0, m6 = 0, b6 = 0, x6 = 0, S = 0, M, A6, I = 0; I < d6; ) {
        var R = f6[I++], F = I === 1;
        switch (R === Tb.M && I > 1 && (t2 || (v6 += o1(m6, b6, x6, S, s, u))), F && (m6 = f6[I], b6 = f6[I + 1], x6 = m6, S = b6), R) {
          case Tb.M:
            x6 = f6[I++], S = f6[I++], m6 = x6, b6 = S;
            break;
          case Tb.L:
            if (t2) {
              if (Eb(m6, b6, f6[I], f6[I + 1], r6, s, u))
                return true;
            } else
              v6 += o1(m6, b6, f6[I], f6[I + 1], s, u) || 0;
            m6 = f6[I++], b6 = f6[I++];
            break;
          case Tb.C:
            if (t2) {
              if (Aq(m6, b6, f6[I++], f6[I++], f6[I++], f6[I++], f6[I], f6[I + 1], r6, s, u))
                return true;
            } else
              v6 += Dq(m6, b6, f6[I++], f6[I++], f6[I++], f6[I++], f6[I], f6[I + 1], s, u) || 0;
            m6 = f6[I++], b6 = f6[I++];
            break;
          case Tb.Q:
            if (t2) {
              if (r7(m6, b6, f6[I++], f6[I++], f6[I], f6[I + 1], r6, s, u))
                return true;
            } else
              v6 += kq(m6, b6, f6[I++], f6[I++], f6[I], f6[I + 1], s, u) || 0;
            m6 = f6[I++], b6 = f6[I++];
            break;
          case Tb.A:
            var j = f6[I++], $ = f6[I++], K = f6[I++], U = f6[I++], he = f6[I++], ue = f6[I++];
            I += 1;
            var pe = !!(1 - f6[I++]);
            M = Math.cos(he) * K + j, A6 = Math.sin(he) * U + $, F ? (x6 = M, S = A6) : v6 += o1(m6, b6, M, A6, s, u);
            var _e = (s - j) * U / K + j;
            if (t2) {
              if (Eq(j, $, U, he, he + ue, pe, r6, _e, u))
                return true;
            } else
              v6 += Pq(j, $, U, he, he + ue, pe, _e, u);
            m6 = Math.cos(he + ue) * K + j, b6 = Math.sin(he + ue) * U + $;
            break;
          case Tb.R:
            x6 = m6 = f6[I++], S = b6 = f6[I++];
            var xe = f6[I++], Ae = f6[I++];
            if (M = x6 + xe, A6 = S + Ae, t2) {
              if (Eb(x6, S, M, S, r6, s, u) || Eb(M, S, M, A6, r6, s, u) || Eb(M, A6, x6, A6, r6, s, u) || Eb(x6, A6, x6, S, r6, s, u))
                return true;
            } else
              v6 += o1(M, S, M, A6, s, u), v6 += o1(x6, A6, x6, S, s, u);
            break;
          case Tb.Z:
            if (t2) {
              if (Eb(m6, b6, x6, S, r6, s, u))
                return true;
            } else
              v6 += o1(m6, b6, x6, S, s, u);
            m6 = x6, b6 = S;
            break;
        }
      }
      return !t2 && !Tq(b6, S) && (v6 += o1(m6, b6, x6, S, s, u) || 0), v6 !== 0;
    }
    function AD(a, r6, t2) {
      return o7(a, 0, false, r6, t2);
    }
    function Lq(a, r6, t2, s) {
      return o7(a, r6, true, t2, s);
    }
    var ED = ei({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, Ax), Oq = { style: ei({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, _D.style) }, PO = lg.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), Rq = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.update = function() {
        var t2 = this;
        a.prototype.update.call(this);
        var s = this.style;
        if (s.decal) {
          var u = this._decalEl = this._decalEl || new r6();
          u.buildPath === r6.prototype.buildPath && (u.buildPath = function(m6) {
            t2.buildPath(m6, t2.shape);
          }), u.silent = true;
          var f6 = u.style;
          for (var d6 in s)
            f6[d6] !== s[d6] && (f6[d6] = s[d6]);
          f6.fill = s.fill ? s.decal : null, f6.decal = null, f6.shadowColor = null, s.strokeFirst && (f6.stroke = null);
          for (var v6 = 0; v6 < PO.length; ++v6)
            u[PO[v6]] = this[PO[v6]];
          u.__dirty |= ad;
        } else
          this._decalEl && (this._decalEl = null);
      }, r6.prototype.getDecalElement = function() {
        return this._decalEl;
      }, r6.prototype._init = function(t2) {
        var s = Po(t2);
        this.shape = this.getDefaultShape();
        var u = this.getDefaultStyle();
        u && this.useStyle(u);
        for (var f6 = 0; f6 < s.length; f6++) {
          var d6 = s[f6], v6 = t2[d6];
          d6 === "style" ? this.style ? qn(this.style, v6) : this.useStyle(v6) : d6 === "shape" ? qn(this.shape, v6) : a.prototype.attrKV.call(this, d6, v6);
        }
        this.style || this.useStyle({});
      }, r6.prototype.getDefaultStyle = function() {
        return null;
      }, r6.prototype.getDefaultShape = function() {
        return {};
      }, r6.prototype.canBeInsideText = function() {
        return this.hasFill();
      }, r6.prototype.getInsideTextFill = function() {
        var t2 = this.style.fill;
        if (t2 !== "none") {
          if (_a2(t2)) {
            var s = GT(t2, 0);
            return s > 0.5 ? nD : s > 0.2 ? UU : $L;
          } else if (t2)
            return $L;
        }
        return nD;
      }, r6.prototype.getInsideTextStroke = function(t2) {
        var s = this.style.fill;
        if (_a2(s)) {
          var u = this.__zr, f6 = !!(u && u.isDarkMode()), d6 = GT(t2, 0) < DM;
          if (f6 === d6)
            return s;
        }
      }, r6.prototype.buildPath = function(t2, s, u) {
      }, r6.prototype.pathUpdated = function() {
        this.__dirty &= ~Xg;
      }, r6.prototype.getUpdatedPathProxy = function(t2) {
        return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, t2), this.path;
      }, r6.prototype.createPathProxy = function() {
        this.path = new wm(false);
      }, r6.prototype.hasStroke = function() {
        var t2 = this.style, s = t2.stroke;
        return !(s == null || s === "none" || !(t2.lineWidth > 0));
      }, r6.prototype.hasFill = function() {
        var t2 = this.style, s = t2.fill;
        return s != null && s !== "none";
      }, r6.prototype.getBoundingRect = function() {
        var t2 = this._rect, s = this.style, u = !t2;
        if (u) {
          var f6 = false;
          this.path || (f6 = true, this.createPathProxy());
          var d6 = this.path;
          (f6 || this.__dirty & Xg) && (d6.beginPath(), this.buildPath(d6, this.shape, false), this.pathUpdated()), t2 = d6.getBoundingRect();
        }
        if (this._rect = t2, this.hasStroke() && this.path && this.path.len() > 0) {
          var v6 = this._rectStroke || (this._rectStroke = t2.clone());
          if (this.__dirty || u) {
            v6.copy(t2);
            var m6 = s.strokeNoScale ? this.getLineScale() : 1, b6 = s.lineWidth;
            if (!this.hasFill()) {
              var x6 = this.strokeContainThreshold;
              b6 = Math.max(b6, x6 == null ? 4 : x6);
            }
            m6 > 1e-10 && (v6.width += b6 / m6, v6.height += b6 / m6, v6.x -= b6 / m6 / 2, v6.y -= b6 / m6 / 2);
          }
          return v6;
        }
        return t2;
      }, r6.prototype.contain = function(t2, s) {
        var u = this.transformCoordToLocal(t2, s), f6 = this.getBoundingRect(), d6 = this.style;
        if (t2 = u[0], s = u[1], f6.contain(t2, s)) {
          var v6 = this.path;
          if (this.hasStroke()) {
            var m6 = d6.lineWidth, b6 = d6.strokeNoScale ? this.getLineScale() : 1;
            if (b6 > 1e-10 && (this.hasFill() || (m6 = Math.max(m6, this.strokeContainThreshold)), Lq(v6, m6 / b6, t2, s)))
              return true;
          }
          if (this.hasFill())
            return AD(v6, t2, s);
        }
        return false;
      }, r6.prototype.dirtyShape = function() {
        this.__dirty |= Xg, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
      }, r6.prototype.dirty = function() {
        this.dirtyStyle(), this.dirtyShape();
      }, r6.prototype.animateShape = function(t2) {
        return this.animate("shape", t2);
      }, r6.prototype.updateDuringAnimation = function(t2) {
        t2 === "style" ? this.dirtyStyle() : t2 === "shape" ? this.dirtyShape() : this.markRedraw();
      }, r6.prototype.attrKV = function(t2, s) {
        t2 === "shape" ? this.setShape(s) : a.prototype.attrKV.call(this, t2, s);
      }, r6.prototype.setShape = function(t2, s) {
        var u = this.shape;
        return u || (u = this.shape = {}), typeof t2 == "string" ? u[t2] = s : qn(u, t2), this.dirtyShape(), this;
      }, r6.prototype.shapeChanged = function() {
        return !!(this.__dirty & Xg);
      }, r6.prototype.createStyle = function(t2) {
        return pM(ED, t2);
      }, r6.prototype._innerSaveToNormal = function(t2) {
        a.prototype._innerSaveToNormal.call(this, t2);
        var s = this._normalState;
        t2.shape && !s.shape && (s.shape = qn({}, this.shape));
      }, r6.prototype._applyStateObj = function(t2, s, u, f6, d6, v6) {
        a.prototype._applyStateObj.call(this, t2, s, u, f6, d6, v6);
        var m6 = !(s && f6), b6;
        if (s && s.shape ? d6 ? f6 ? b6 = s.shape : (b6 = qn({}, u.shape), qn(b6, s.shape)) : (b6 = qn({}, f6 ? this.shape : u.shape), qn(b6, s.shape)) : m6 && (b6 = u.shape), b6)
          if (d6) {
            this.shape = qn({}, this.shape);
            for (var x6 = {}, S = Po(b6), M = 0; M < S.length; M++) {
              var A6 = S[M];
              typeof b6[A6] == "object" ? this.shape[A6] = b6[A6] : x6[A6] = b6[A6];
            }
            this._transitionState(t2, { shape: x6 }, v6);
          } else
            this.shape = b6, this.dirtyShape();
      }, r6.prototype._mergeStates = function(t2) {
        for (var s = a.prototype._mergeStates.call(this, t2), u, f6 = 0; f6 < t2.length; f6++) {
          var d6 = t2[f6];
          d6.shape && (u = u || {}, this._mergeStyle(u, d6.shape));
        }
        return u && (s.shape = u), s;
      }, r6.prototype.getAnimationStyleProps = function() {
        return Oq;
      }, r6.prototype.isZeroArea = function() {
        return false;
      }, r6.extend = function(t2) {
        var s = function(f6) {
          tt(d6, f6);
          function d6(v6) {
            var m6 = f6.call(this, v6) || this;
            return t2.init && t2.init.call(m6, v6), m6;
          }
          return d6.prototype.getDefaultStyle = function() {
            return Qa(t2.style);
          }, d6.prototype.getDefaultShape = function() {
            return Qa(t2.shape);
          }, d6;
        }(r6);
        for (var u in t2)
          typeof t2[u] == "function" && (s.prototype[u] = t2[u]);
        return s;
      }, r6.initDefaultProps = function() {
        var t2 = r6.prototype;
        t2.type = "path", t2.strokeContainThreshold = 5, t2.segmentIgnoreThreshold = 0, t2.subPixelOptimize = false, t2.autoBatch = false, t2.__dirty = ad | _M | Xg;
      }(), r6;
    }(cg), uo = Rq, Fq = ei({ strokeFirst: true, font: Gs, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, ED), s7 = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.hasStroke = function() {
        var t2 = this.style, s = t2.stroke;
        return s != null && s !== "none" && t2.lineWidth > 0;
      }, r6.prototype.hasFill = function() {
        var t2 = this.style, s = t2.fill;
        return s != null && s !== "none";
      }, r6.prototype.createStyle = function(t2) {
        return pM(Fq, t2);
      }, r6.prototype.setBoundingRect = function(t2) {
        this._rect = t2;
      }, r6.prototype.getBoundingRect = function() {
        var t2 = this.style;
        if (!this._rect) {
          var s = t2.text;
          s != null ? s += "" : s = "";
          var u = bx(s, t2.font, t2.textAlign, t2.textBaseline);
          if (u.x += t2.x || 0, u.y += t2.y || 0, this.hasStroke()) {
            var f6 = t2.lineWidth;
            u.x -= f6 / 2, u.y -= f6 / 2, u.width += f6, u.height += f6;
          }
          this._rect = u;
        }
        return this._rect;
      }, r6.initDefaultProps = function() {
        var t2 = r6.prototype;
        t2.dirtyRectTolerance = 10;
      }(), r6;
    }(cg);
    s7.prototype.type = "tspan";
    var YM = s7, Nq = ei({ x: 0, y: 0 }, Ax), Vq = { style: ei({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, _D.style) };
    function ID(a) {
      return !!(a && typeof a != "string" && a.width && a.height);
    }
    var l7 = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.createStyle = function(t2) {
        return pM(Nq, t2);
      }, r6.prototype._getSize = function(t2) {
        var s = this.style, u = s[t2];
        if (u != null)
          return u;
        var f6 = ID(s.image) ? s.image : this.__image;
        if (!f6)
          return 0;
        var d6 = t2 === "width" ? "height" : "width", v6 = s[d6];
        return v6 == null ? f6[t2] : f6[t2] / f6[d6] * v6;
      }, r6.prototype.getWidth = function() {
        return this._getSize("width");
      }, r6.prototype.getHeight = function() {
        return this._getSize("height");
      }, r6.prototype.getAnimationStyleProps = function() {
        return Vq;
      }, r6.prototype.getBoundingRect = function() {
        var t2 = this.style;
        return this._rect || (this._rect = new Qi(t2.x || 0, t2.y || 0, this.getWidth(), this.getHeight())), this._rect;
      }, r6;
    }(cg);
    l7.prototype.type = "image";
    var nh = l7;
    function u7(a, r6) {
      var t2 = r6.x, s = r6.y, u = r6.width, f6 = r6.height, d6 = r6.r, v6, m6, b6, x6;
      u < 0 && (t2 = t2 + u, u = -u), f6 < 0 && (s = s + f6, f6 = -f6), typeof d6 == "number" ? v6 = m6 = b6 = x6 = d6 : d6 instanceof Array ? d6.length === 1 ? v6 = m6 = b6 = x6 = d6[0] : d6.length === 2 ? (v6 = b6 = d6[0], m6 = x6 = d6[1]) : d6.length === 3 ? (v6 = d6[0], m6 = x6 = d6[1], b6 = d6[2]) : (v6 = d6[0], m6 = d6[1], b6 = d6[2], x6 = d6[3]) : v6 = m6 = b6 = x6 = 0;
      var S;
      v6 + m6 > u && (S = v6 + m6, v6 *= u / S, m6 *= u / S), b6 + x6 > u && (S = b6 + x6, b6 *= u / S, x6 *= u / S), m6 + b6 > f6 && (S = m6 + b6, m6 *= f6 / S, b6 *= f6 / S), v6 + x6 > f6 && (S = v6 + x6, v6 *= f6 / S, x6 *= f6 / S), a.moveTo(t2 + v6, s), a.lineTo(t2 + u - m6, s), m6 !== 0 && a.arc(t2 + u - m6, s + m6, m6, -Math.PI / 2, 0), a.lineTo(t2 + u, s + f6 - b6), b6 !== 0 && a.arc(t2 + u - b6, s + f6 - b6, b6, 0, Math.PI / 2), a.lineTo(t2 + x6, s + f6), x6 !== 0 && a.arc(t2 + x6, s + f6 - x6, x6, Math.PI / 2, Math.PI), a.lineTo(t2, s + v6), v6 !== 0 && a.arc(t2 + v6, s + v6, v6, Math.PI, Math.PI * 1.5);
    }
    var Db = Math.round;
    function LO(a, r6, t2) {
      if (r6) {
        var s = r6.x1, u = r6.x2, f6 = r6.y1, d6 = r6.y2;
        a.x1 = s, a.x2 = u, a.y1 = f6, a.y2 = d6;
        var v6 = t2 && t2.lineWidth;
        return v6 && (Db(s * 2) === Db(u * 2) && (a.x1 = a.x2 = kb(s, v6, true)), Db(f6 * 2) === Db(d6 * 2) && (a.y1 = a.y2 = kb(f6, v6, true))), a;
      }
    }
    function OO(a, r6, t2) {
      if (r6) {
        var s = r6.x, u = r6.y, f6 = r6.width, d6 = r6.height;
        a.x = s, a.y = u, a.width = f6, a.height = d6;
        var v6 = t2 && t2.lineWidth;
        return v6 && (a.x = kb(s, v6, true), a.y = kb(u, v6, true), a.width = Math.max(kb(s + f6, v6, false) - a.x, f6 === 0 ? 0 : 1), a.height = Math.max(kb(u + d6, v6, false) - a.y, d6 === 0 ? 0 : 1)), a;
      }
    }
    function kb(a, r6, t2) {
      if (!r6)
        return a;
      var s = Db(a * 2);
      return (s + Db(r6)) % 2 === 0 ? s / 2 : (s + (t2 ? 1 : -1)) / 2;
    }
    var c7 = function() {
      function a() {
        this.x = 0, this.y = 0, this.width = 0, this.height = 0;
      }
      return a;
    }(), zq = {}, f7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new c7();
      }, r6.prototype.buildPath = function(t2, s) {
        var u, f6, d6, v6;
        if (this.subPixelOptimize) {
          var m6 = OO(zq, s, this.style);
          u = m6.x, f6 = m6.y, d6 = m6.width, v6 = m6.height, m6.r = s.r, s = m6;
        } else
          u = s.x, f6 = s.y, d6 = s.width, v6 = s.height;
        s.r ? u7(t2, s) : t2.rect(u, f6, d6, v6);
      }, r6.prototype.isZeroArea = function() {
        return !this.shape.width || !this.shape.height;
      }, r6;
    }(uo);
    f7.prototype.type = "rect";
    var rs = f7, ZM = { fill: "#000" }, XM = 2, Bq = { style: ei({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, _D.style) }, h7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this) || this;
        return s.type = "text", s._children = [], s._defaultStyle = ZM, s.attr(t2), s;
      }
      return r6.prototype.childrenRef = function() {
        return this._children;
      }, r6.prototype.update = function() {
        a.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
        for (var t2 = 0; t2 < this._children.length; t2++) {
          var s = this._children[t2];
          s.zlevel = this.zlevel, s.z = this.z, s.z2 = this.z2, s.culling = this.culling, s.cursor = this.cursor, s.invisible = this.invisible;
        }
      }, r6.prototype.updateTransform = function() {
        var t2 = this.innerTransformable;
        t2 ? (t2.updateTransform(), t2.transform && (this.transform = t2.transform)) : a.prototype.updateTransform.call(this);
      }, r6.prototype.getLocalTransform = function(t2) {
        var s = this.innerTransformable;
        return s ? s.getLocalTransform(t2) : a.prototype.getLocalTransform.call(this, t2);
      }, r6.prototype.getComputedTransform = function() {
        return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), a.prototype.getComputedTransform.call(this);
      }, r6.prototype._updateSubTexts = function() {
        this._childCursor = 0, jq(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
      }, r6.prototype.addSelfToZr = function(t2) {
        a.prototype.addSelfToZr.call(this, t2);
        for (var s = 0; s < this._children.length; s++)
          this._children[s].__zr = t2;
      }, r6.prototype.removeSelfFromZr = function(t2) {
        a.prototype.removeSelfFromZr.call(this, t2);
        for (var s = 0; s < this._children.length; s++)
          this._children[s].__zr = null;
      }, r6.prototype.getBoundingRect = function() {
        if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
          for (var t2 = new Qi(0, 0, 0, 0), s = this._children, u = [], f6 = null, d6 = 0; d6 < s.length; d6++) {
            var v6 = s[d6], m6 = v6.getBoundingRect(), b6 = v6.getLocalTransform(u);
            b6 ? (t2.copy(m6), t2.applyTransform(b6), f6 = f6 || t2.clone(), f6.union(t2)) : (f6 = f6 || m6.clone(), f6.union(m6));
          }
          this._rect = f6 || t2;
        }
        return this._rect;
      }, r6.prototype.setDefaultTextStyle = function(t2) {
        this._defaultStyle = t2 || ZM;
      }, r6.prototype.setTextContent = function(t2) {
      }, r6.prototype._mergeStyle = function(t2, s) {
        if (!s)
          return t2;
        var u = s.rich, f6 = t2.rich || u && {};
        return qn(t2, s), u && f6 ? (this._mergeRich(f6, u), t2.rich = f6) : f6 && (t2.rich = f6), t2;
      }, r6.prototype._mergeRich = function(t2, s) {
        for (var u = Po(s), f6 = 0; f6 < u.length; f6++) {
          var d6 = u[f6];
          t2[d6] = t2[d6] || {}, qn(t2[d6], s[d6]);
        }
      }, r6.prototype.getAnimationStyleProps = function() {
        return Bq;
      }, r6.prototype._getOrCreateChild = function(t2) {
        var s = this._children[this._childCursor];
        return (!s || !(s instanceof t2)) && (s = new t2()), this._children[this._childCursor++] = s, s.__zr = this.__zr, s.parent = this, s;
      }, r6.prototype._updatePlainTexts = function() {
        var t2 = this.style, s = t2.font || Gs, u = t2.padding, f6 = w7(t2), d6 = hq(f6, t2), v6 = FO(t2), m6 = !!t2.backgroundColor, b6 = d6.outerHeight, x6 = d6.outerWidth, S = d6.contentWidth, M = d6.lines, A6 = d6.lineHeight, I = this._defaultStyle, R = t2.x || 0, F = t2.y || 0, j = t2.align || I.align || "left", $ = t2.verticalAlign || I.verticalAlign || "top", K = R, U = t1(F, d6.contentHeight, $);
        if (v6 || u) {
          var he = V2(R, x6, j), ue = t1(F, b6, $);
          v6 && this._renderBackground(t2, t2, he, ue, x6, b6);
        }
        U += A6 / 2, u && (K = x7(R, j, u), $ === "top" ? U += u[0] : $ === "bottom" && (U -= u[2]));
        for (var pe = 0, _e = false, xe = _7("fill" in t2 ? t2.fill : (_e = true, I.fill)), Ae = b7("stroke" in t2 ? t2.stroke : !m6 && (!I.autoStroke || _e) ? (pe = XM, I.stroke) : null), ke = t2.textShadowBlur > 0, je = t2.width != null && (t2.overflow === "truncate" || t2.overflow === "break" || t2.overflow === "breakAll"), Fe = d6.calculatedLineHeight, at = 0; at < M.length; at++) {
          var ht = this._getOrCreateChild(YM), Qe = ht.createStyle();
          ht.useStyle(Qe), Qe.text = M[at], Qe.x = K, Qe.y = U, j && (Qe.textAlign = j), Qe.textBaseline = "middle", Qe.opacity = t2.opacity, Qe.strokeFirst = true, ke && (Qe.shadowBlur = t2.textShadowBlur || 0, Qe.shadowColor = t2.textShadowColor || "transparent", Qe.shadowOffsetX = t2.textShadowOffsetX || 0, Qe.shadowOffsetY = t2.textShadowOffsetY || 0), Qe.stroke = Ae, Qe.fill = xe, Ae && (Qe.lineWidth = t2.lineWidth || pe, Qe.lineDash = t2.lineDash, Qe.lineDashOffset = t2.lineDashOffset || 0), Qe.font = s, g7(Qe, t2), U += A6, je && ht.setBoundingRect(new Qi(V2(Qe.x, t2.width, Qe.textAlign), t1(Qe.y, Fe, Qe.textBaseline), S, Fe));
        }
      }, r6.prototype._updateRichTexts = function() {
        var t2 = this.style, s = w7(t2), u = vq(s, t2), f6 = u.width, d6 = u.outerWidth, v6 = u.outerHeight, m6 = t2.padding, b6 = t2.x || 0, x6 = t2.y || 0, S = this._defaultStyle, M = t2.align || S.align, A6 = t2.verticalAlign || S.verticalAlign, I = V2(b6, d6, M), R = t1(x6, v6, A6), F = I, j = R;
        m6 && (F += m6[3], j += m6[0]);
        var $ = F + f6;
        FO(t2) && this._renderBackground(t2, t2, I, R, d6, v6);
        for (var K = !!t2.backgroundColor, U = 0; U < u.lines.length; U++) {
          for (var he = u.lines[U], ue = he.tokens, pe = ue.length, _e = he.lineHeight, xe = he.width, Ae = 0, ke = F, je = $, Fe = pe - 1, at = void 0; Ae < pe && (at = ue[Ae], !at.align || at.align === "left"); )
            this._placeToken(at, t2, _e, j, ke, "left", K), xe -= at.width, ke += at.width, Ae++;
          for (; Fe >= 0 && (at = ue[Fe], at.align === "right"); )
            this._placeToken(at, t2, _e, j, je, "right", K), xe -= at.width, je -= at.width, Fe--;
          for (ke += (f6 - (ke - F) - ($ - je) - xe) / 2; Ae <= Fe; )
            at = ue[Ae], this._placeToken(at, t2, _e, j, ke + at.width / 2, "center", K), ke += at.width, Ae++;
          j += _e;
        }
      }, r6.prototype._placeToken = function(t2, s, u, f6, d6, v6, m6) {
        var b6 = s.rich[t2.styleName] || {};
        b6.text = t2.text;
        var x6 = t2.verticalAlign, S = f6 + u / 2;
        x6 === "top" ? S = f6 + t2.height / 2 : x6 === "bottom" && (S = f6 + u - t2.height / 2);
        var M = !t2.isLineHolder && FO(b6);
        M && this._renderBackground(b6, s, v6 === "right" ? d6 - t2.width : v6 === "center" ? d6 - t2.width / 2 : d6, S - t2.height / 2, t2.width, t2.height);
        var A6 = !!b6.backgroundColor, I = t2.textPadding;
        I && (d6 = x7(d6, v6, I), S -= t2.height / 2 - I[0] - t2.innerHeight / 2);
        var R = this._getOrCreateChild(YM), F = R.createStyle();
        R.useStyle(F);
        var j = this._defaultStyle, $ = false, K = 0, U = _7("fill" in b6 ? b6.fill : "fill" in s ? s.fill : ($ = true, j.fill)), he = b7("stroke" in b6 ? b6.stroke : "stroke" in s ? s.stroke : !A6 && !m6 && (!j.autoStroke || $) ? (K = XM, j.stroke) : null), ue = b6.textShadowBlur > 0 || s.textShadowBlur > 0;
        F.text = t2.text, F.x = d6, F.y = S, ue && (F.shadowBlur = b6.textShadowBlur || s.textShadowBlur || 0, F.shadowColor = b6.textShadowColor || s.textShadowColor || "transparent", F.shadowOffsetX = b6.textShadowOffsetX || s.textShadowOffsetX || 0, F.shadowOffsetY = b6.textShadowOffsetY || s.textShadowOffsetY || 0), F.textAlign = v6, F.textBaseline = "middle", F.font = t2.font || Gs, F.opacity = Uy(b6.opacity, s.opacity, 1), g7(F, b6), he && (F.lineWidth = Uy(b6.lineWidth, s.lineWidth, K), F.lineDash = qi(b6.lineDash, s.lineDash), F.lineDashOffset = s.lineDashOffset || 0, F.stroke = he), U && (F.fill = U);
        var pe = t2.contentWidth, _e = t2.contentHeight;
        R.setBoundingRect(new Qi(V2(F.x, pe, F.textAlign), t1(F.y, _e, F.textBaseline), pe, _e));
      }, r6.prototype._renderBackground = function(t2, s, u, f6, d6, v6) {
        var m6 = t2.backgroundColor, b6 = t2.borderWidth, x6 = t2.borderColor, S = m6 && m6.image, M = m6 && !S, A6 = t2.borderRadius, I = this, R, F;
        if (M || t2.lineHeight || b6 && x6) {
          R = this._getOrCreateChild(rs), R.useStyle(R.createStyle()), R.style.fill = null;
          var j = R.shape;
          j.x = u, j.y = f6, j.width = d6, j.height = v6, j.r = A6, R.dirtyShape();
        }
        if (M) {
          var $ = R.style;
          $.fill = m6 || null, $.fillOpacity = qi(t2.fillOpacity, 1);
        } else if (S) {
          F = this._getOrCreateChild(nh), F.onload = function() {
            I.dirtyStyle();
          };
          var K = F.style;
          K.image = m6.image, K.x = u, K.y = f6, K.width = d6, K.height = v6;
        }
        if (b6 && x6) {
          var $ = R.style;
          $.lineWidth = b6, $.stroke = x6, $.strokeOpacity = qi(t2.strokeOpacity, 1), $.lineDash = t2.borderDash, $.lineDashOffset = t2.borderDashOffset || 0, R.strokeContainThreshold = 0, R.hasFill() && R.hasStroke() && ($.strokeFirst = true, $.lineWidth *= 2);
        }
        var U = (R || F).style;
        U.shadowBlur = t2.shadowBlur || 0, U.shadowColor = t2.shadowColor || "transparent", U.shadowOffsetX = t2.shadowOffsetX || 0, U.shadowOffsetY = t2.shadowOffsetY || 0, U.opacity = Uy(t2.opacity, s.opacity, 1);
      }, r6.makeFont = function(t2) {
        var s = "";
        return m7(t2) && (s = [t2.fontStyle, t2.fontWeight, v7(t2.fontSize), t2.fontFamily || "sans-serif"].join(" ")), s && mu(s) || t2.textFont || t2.font;
      }, r6;
    }(cg), RO = { left: true, right: 1, center: 1 }, d7 = { top: 1, bottom: 1, middle: 1 }, p7 = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
    function v7(a) {
      return typeof a == "string" && (a.indexOf("px") !== -1 || a.indexOf("rem") !== -1 || a.indexOf("em") !== -1) ? a : isNaN(+a) ? Zo + "px" : a + "px";
    }
    function g7(a, r6) {
      for (var t2 = 0; t2 < p7.length; t2++) {
        var s = p7[t2], u = r6[s];
        u != null && (a[s] = u);
      }
    }
    function m7(a) {
      return a.fontSize != null || a.fontFamily || a.fontWeight;
    }
    function jq(a) {
      return y7(a), Ne(a.rich, y7), a;
    }
    function y7(a) {
      if (a) {
        a.font = h7.makeFont(a);
        var r6 = a.align;
        r6 === "middle" && (r6 = "center"), a.align = r6 == null || RO[r6] ? r6 : "left";
        var t2 = a.verticalAlign;
        t2 === "center" && (t2 = "middle"), a.verticalAlign = t2 == null || d7[t2] ? t2 : "top";
        var s = a.padding;
        s && (a.padding = DT(a.padding));
      }
    }
    function b7(a, r6) {
      return a == null || r6 <= 0 || a === "transparent" || a === "none" ? null : a.image || a.colorStops ? "#000" : a;
    }
    function _7(a) {
      return a == null || a === "none" ? null : a.image || a.colorStops ? "#000" : a;
    }
    function x7(a, r6, t2) {
      return r6 === "right" ? a - t2[1] : r6 === "center" ? a + t2[3] / 2 - t2[1] / 2 : a + t2[3];
    }
    function w7(a) {
      var r6 = a.text;
      return r6 != null && (r6 += ""), r6;
    }
    function FO(a) {
      return !!(a.backgroundColor || a.lineHeight || a.borderWidth && a.borderColor);
    }
    var ms = h7, ii = Xo(), NO = function(a, r6, t2, s) {
      if (s) {
        var u = ii(s);
        u.dataIndex = t2, u.dataType = r6, u.seriesIndex = a, s.type === "group" && s.traverse(function(f6) {
          var d6 = ii(f6);
          d6.seriesIndex = a, d6.dataIndex = t2, d6.dataType = r6;
        });
      }
    }, S7 = 1, Pb = {}, Oo = Xo(), VO = Xo(), sd = 0, Yu = 1, TD = 2, Oc = ["emphasis", "blur", "select"], KM = ["normal", "emphasis", "blur", "select"], j2 = 10, Gq = 9, Lx = "highlight", DD = "downplay", Ox = "select", kD = "unselect", Av = "toggleSelect";
    function Rx(a) {
      return a != null && a !== "none";
    }
    var JM = new Yy(100);
    function oc(a) {
      if (_a2(a)) {
        var r6 = JM.get(a);
        return r6 || (r6 = OL(a, -0.1), JM.put(a, r6)), r6;
      } else if (au(a)) {
        var t2 = qn({}, a);
        return t2.colorStops = wr(a.colorStops, function(s) {
          return { offset: s.offset, color: OL(s.color, -0.1) };
        }), t2;
      }
      return a;
    }
    function Zu(a, r6, t2) {
      a.onHoverStateChange && (a.hoverState || 0) !== t2 && a.onHoverStateChange(r6), a.hoverState = t2;
    }
    function zO(a) {
      Zu(a, "emphasis", TD);
    }
    function C7(a) {
      a.hoverState === TD && Zu(a, "normal", sd);
    }
    function BO(a) {
      Zu(a, "blur", Yu);
    }
    function M7(a) {
      a.hoverState === Yu && Zu(a, "normal", sd);
    }
    function Wq(a) {
      a.selected = true;
    }
    function Hq(a) {
      a.selected = false;
    }
    function A7(a, r6, t2) {
      r6(a, t2);
    }
    function Sm(a, r6, t2) {
      A7(a, r6, t2), a.isGroup && a.traverse(function(s) {
        A7(s, r6, t2);
      });
    }
    function Lb(a, r6) {
      switch (r6) {
        case "emphasis":
          a.hoverState = TD;
          break;
        case "normal":
          a.hoverState = sd;
          break;
        case "blur":
          a.hoverState = Yu;
          break;
        case "select":
          a.selected = true;
      }
    }
    function jO(a, r6, t2, s) {
      for (var u = a.style, f6 = {}, d6 = 0; d6 < r6.length; d6++) {
        var v6 = r6[d6], m6 = u[v6];
        f6[v6] = m6 == null ? s && s[v6] : m6;
      }
      for (var d6 = 0; d6 < a.animators.length; d6++) {
        var b6 = a.animators[d6];
        b6.__fromStateTransition && b6.__fromStateTransition.indexOf(t2) < 0 && b6.targetName === "style" && b6.saveTo(f6, r6);
      }
      return f6;
    }
    function $q(a, r6, t2, s) {
      var u = t2 && Vi(t2, "select") >= 0, f6 = false;
      if (a instanceof uo) {
        var d6 = Oo(a), v6 = u && d6.selectFill || d6.normalFill, m6 = u && d6.selectStroke || d6.normalStroke;
        if (Rx(v6) || Rx(m6)) {
          s = s || {};
          var b6 = s.style || {};
          b6.fill === "inherit" ? (f6 = true, s = qn({}, s), b6 = qn({}, b6), b6.fill = v6) : !Rx(b6.fill) && Rx(v6) ? (f6 = true, s = qn({}, s), b6 = qn({}, b6), b6.fill = oc(v6)) : !Rx(b6.stroke) && Rx(m6) && (f6 || (s = qn({}, s), b6 = qn({}, b6)), b6.stroke = oc(m6)), s.style = b6;
        }
      }
      if (s && s.z2 == null) {
        f6 || (s = qn({}, s));
        var x6 = a.z2EmphasisLift;
        s.z2 = a.z2 + (x6 != null ? x6 : j2);
      }
      return s;
    }
    function E7(a, r6, t2) {
      if (t2 && t2.z2 == null) {
        t2 = qn({}, t2);
        var s = a.z2SelectLift;
        t2.z2 = a.z2 + (s != null ? s : Gq);
      }
      return t2;
    }
    function PD(a, r6, t2) {
      var s = Vi(a.currentStates, r6) >= 0, u = a.style.opacity, f6 = s ? null : jO(a, ["opacity"], r6, { opacity: 1 });
      t2 = t2 || {};
      var d6 = t2.style || {};
      return d6.opacity == null && (t2 = qn({}, t2), d6 = qn({ opacity: s ? u : f6.opacity * 0.1 }, d6), t2.style = d6), t2;
    }
    function ep(a, r6) {
      var t2 = this.states[a];
      if (this.style) {
        if (a === "emphasis")
          return $q(this, a, r6, t2);
        if (a === "blur")
          return PD(this, a, t2);
        if (a === "select")
          return E7(this, a, t2);
      }
      return t2;
    }
    function fg(a) {
      a.stateProxy = ep;
      var r6 = a.getTextContent(), t2 = a.getTextGuideLine();
      r6 && (r6.stateProxy = ep), t2 && (t2.stateProxy = ep);
    }
    function I7(a, r6) {
      !WO(a, r6) && !a.__highByOuter && Sm(a, zO);
    }
    function T7(a, r6) {
      !WO(a, r6) && !a.__highByOuter && Sm(a, C7);
    }
    function Cm(a, r6) {
      a.__highByOuter |= 1 << (r6 || 0), Sm(a, zO);
    }
    function Mm(a, r6) {
      !(a.__highByOuter &= ~(1 << (r6 || 0))) && Sm(a, C7);
    }
    function D7(a) {
      Sm(a, BO);
    }
    function GO(a) {
      Sm(a, M7);
    }
    function Am(a) {
      Sm(a, Wq);
    }
    function Ko(a) {
      Sm(a, Hq);
    }
    function WO(a, r6) {
      return a.__highDownSilentOnTouch && r6.zrByTouch;
    }
    function Ev(a) {
      var r6 = a.getModel();
      r6.eachComponent(function(t2, s) {
        var u = VO(s);
        if (u.isBlured) {
          var f6 = t2 === "series" ? a.getViewOfSeriesModel(s) : a.getViewOfComponentModel(s);
          f6.group.traverse(function(d6) {
            M7(d6);
          });
        }
        u.isBlured = false;
      });
    }
    function LD(a, r6, t2, s) {
      var u = s.getModel();
      t2 = t2 || "coordinateSystem";
      function f6(b6, x6) {
        for (var S = 0; S < x6.length; S++) {
          var M = b6.getItemGraphicEl(x6[S]);
          M && GO(M);
        }
      }
      if (a != null && !(!r6 || r6 === "none")) {
        var d6 = u.getSeriesByIndex(a), v6 = d6.coordinateSystem;
        v6 && v6.master && (v6 = v6.master);
        var m6 = [];
        u.eachSeries(function(b6) {
          var x6 = d6 === b6, S = b6.coordinateSystem;
          S && S.master && (S = S.master);
          var M = S && v6 ? S === v6 : x6;
          if (!(t2 === "series" && !x6 || t2 === "coordinateSystem" && !M || r6 === "series" && x6)) {
            var A6 = s.getViewOfSeriesModel(b6);
            if (A6.group.traverse(function(F) {
              BO(F);
            }), rd(r6))
              f6(b6.getData(), r6);
            else if (ui(r6))
              for (var I = Po(r6), R = 0; R < I.length; R++)
                f6(b6.getData(I[R]), r6[I[R]]);
            m6.push(b6), VO(b6).isBlured = true;
          }
        }), u.eachComponent(function(b6, x6) {
          if (b6 !== "series") {
            var S = s.getViewOfComponentModel(x6);
            S && S.blurSeries && S.blurSeries(m6, u);
          }
        });
      }
    }
    function HO(a, r6, t2) {
      if (!(a == null || r6 == null)) {
        var s = t2.getModel().getComponent(a, r6);
        if (s) {
          VO(s).isBlured = true;
          var u = t2.getViewOfComponentModel(s);
          !u || !u.focusBlurEnabled || u.group.traverse(function(f6) {
            BO(f6);
          });
        }
      }
    }
    function jl(a, r6, t2) {
      var s = a.seriesIndex, u = a.getData(r6.dataType);
      if (u) {
        var f6 = xx(u, r6);
        f6 = (br(f6) ? f6[0] : f6) || 0;
        var d6 = u.getItemGraphicEl(f6);
        if (!d6)
          for (var v6 = u.count(), m6 = 0; !d6 && m6 < v6; )
            d6 = u.getItemGraphicEl(m6++);
        if (d6) {
          var b6 = ii(d6);
          LD(s, b6.focus, b6.blurScope, t2);
        } else {
          var x6 = a.get(["emphasis", "focus"]), S = a.get(["emphasis", "blurScope"]);
          x6 != null && LD(s, x6, S, t2);
        }
      }
    }
    function $O(a, r6, t2, s) {
      var u = { focusSelf: false, dispatchers: null };
      if (a == null || a === "series" || r6 == null || t2 == null)
        return u;
      var f6 = s.getModel().getComponent(a, r6);
      if (!f6)
        return u;
      var d6 = s.getViewOfComponentModel(f6);
      if (!d6 || !d6.findHighDownDispatchers)
        return u;
      for (var v6 = d6.findHighDownDispatchers(t2), m6, b6 = 0; b6 < v6.length; b6++)
        if (ii(v6[b6]).focus === "self") {
          m6 = true;
          break;
        }
      return { focusSelf: m6, dispatchers: v6 };
    }
    function k7(a, r6, t2) {
      var s = ii(a), u = $O(s.componentMainType, s.componentIndex, s.componentHighDownName, t2), f6 = u.dispatchers, d6 = u.focusSelf;
      f6 ? (d6 && HO(s.componentMainType, s.componentIndex, t2), Ne(f6, function(v6) {
        return I7(v6, r6);
      })) : (LD(s.seriesIndex, s.focus, s.blurScope, t2), s.focus === "self" && HO(s.componentMainType, s.componentIndex, t2), I7(a, r6));
    }
    function OD(a, r6, t2) {
      Ev(t2);
      var s = ii(a), u = $O(s.componentMainType, s.componentIndex, s.componentHighDownName, t2).dispatchers;
      u ? Ne(u, function(f6) {
        return T7(f6, r6);
      }) : T7(a, r6);
    }
    function Uq(a, r6, t2) {
      if (YO(r6)) {
        var s = r6.dataType, u = a.getData(s), f6 = xx(u, r6);
        br(f6) || (f6 = [f6]), a[r6.type === Av ? "toggleSelect" : r6.type === Ox ? "select" : "unselect"](f6, s);
      }
    }
    function P7(a) {
      var r6 = a.getAllData();
      Ne(r6, function(t2) {
        var s = t2.data, u = t2.type;
        s.eachItemGraphicEl(function(f6, d6) {
          a.isSelected(d6, u) ? Am(f6) : Ko(f6);
        });
      });
    }
    function qq(a) {
      var r6 = [];
      return a.eachSeries(function(t2) {
        var s = t2.getAllData();
        Ne(s, function(u) {
          u.data;
          var f6 = u.type, d6 = t2.getSelectedDataIndices();
          if (d6.length > 0) {
            var v6 = { dataIndex: d6, seriesIndex: t2.seriesIndex };
            f6 != null && (v6.dataType = f6), r6.push(v6);
          }
        });
      }), r6;
    }
    function Fx(a, r6, t2) {
      Nx(a, true), Sm(a, fg), UO(a, r6, t2);
    }
    function Yq(a) {
      Nx(a, false);
    }
    function Cc(a, r6, t2, s) {
      s ? Yq(a) : Fx(a, r6, t2);
    }
    function UO(a, r6, t2) {
      var s = ii(a);
      r6 != null ? (s.focus = r6, s.blurScope = t2) : s.focus && (s.focus = null);
    }
    var L7 = ["emphasis", "blur", "select"], Zq = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
    function Ah(a, r6, t2, s) {
      t2 = t2 || "itemStyle";
      for (var u = 0; u < L7.length; u++) {
        var f6 = L7[u], d6 = r6.getModel([f6, t2]), v6 = a.ensureState(f6);
        v6.style = s ? s(d6) : d6[Zq[t2]]();
      }
    }
    function Nx(a, r6) {
      var t2 = r6 === false, s = a;
      a.highDownSilentOnTouch && (s.__highDownSilentOnTouch = a.highDownSilentOnTouch), (!t2 || s.__highDownDispatcher) && (s.__highByOuter = s.__highByOuter || 0, s.__highDownDispatcher = !t2);
    }
    function QM(a) {
      return !!(a && a.__highDownDispatcher);
    }
    function Xq(a, r6, t2) {
      var s = ii(a);
      s.componentMainType = r6.mainType, s.componentIndex = r6.componentIndex, s.componentHighDownName = t2;
    }
    function qO(a) {
      var r6 = Pb[a];
      return r6 == null && S7 <= 32 && (r6 = Pb[a] = S7++), r6;
    }
    function YO(a) {
      var r6 = a.type;
      return r6 === Ox || r6 === kD || r6 === Av;
    }
    function RD(a) {
      var r6 = a.type;
      return r6 === Lx || r6 === DD;
    }
    function Kq(a) {
      var r6 = Oo(a);
      r6.normalFill = a.style.fill, r6.normalStroke = a.style.stroke;
      var t2 = a.states.select || {};
      r6.selectFill = t2.style && t2.style.fill || null, r6.selectStroke = t2.style && t2.style.stroke || null;
    }
    var G2 = wm.CMD, Jq = [[], [], []], kf = Math.sqrt, Fp = Math.atan2;
    function O7(a, r6) {
      if (r6) {
        var t2 = a.data, s = a.len(), u, f6, d6, v6, m6, b6, x6 = G2.M, S = G2.C, M = G2.L, A6 = G2.R, I = G2.A, R = G2.Q;
        for (d6 = 0, v6 = 0; d6 < s; ) {
          switch (u = t2[d6++], v6 = d6, f6 = 0, u) {
            case x6:
              f6 = 1;
              break;
            case M:
              f6 = 1;
              break;
            case S:
              f6 = 3;
              break;
            case R:
              f6 = 2;
              break;
            case I:
              var F = r6[4], j = r6[5], $ = kf(r6[0] * r6[0] + r6[1] * r6[1]), K = kf(r6[2] * r6[2] + r6[3] * r6[3]), U = Fp(-r6[1] / K, r6[0] / $);
              t2[d6] *= $, t2[d6++] += F, t2[d6] *= K, t2[d6++] += j, t2[d6++] *= $, t2[d6++] *= K, t2[d6++] += U, t2[d6++] += U, d6 += 2, v6 = d6;
              break;
            case A6:
              b6[0] = t2[d6++], b6[1] = t2[d6++], Qf(b6, b6, r6), t2[v6++] = b6[0], t2[v6++] = b6[1], b6[0] += t2[d6++], b6[1] += t2[d6++], Qf(b6, b6, r6), t2[v6++] = b6[0], t2[v6++] = b6[1];
          }
          for (m6 = 0; m6 < f6; m6++) {
            var he = Jq[m6];
            he[0] = t2[d6++], he[1] = t2[d6++], Qf(he, he, r6), t2[v6++] = he[0], t2[v6++] = he[1];
          }
        }
        a.increaseVersion();
      }
    }
    var ZO = Math.sqrt, FD = Math.sin, eA = Math.cos, tA = Math.PI;
    function R7(a) {
      return Math.sqrt(a[0] * a[0] + a[1] * a[1]);
    }
    function XO(a, r6) {
      return (a[0] * r6[0] + a[1] * r6[1]) / (R7(a) * R7(r6));
    }
    function KO(a, r6) {
      return (a[0] * r6[1] < a[1] * r6[0] ? -1 : 1) * Math.acos(XO(a, r6));
    }
    function F7(a, r6, t2, s, u, f6, d6, v6, m6, b6, x6) {
      var S = m6 * (tA / 180), M = eA(S) * (a - t2) / 2 + FD(S) * (r6 - s) / 2, A6 = -1 * FD(S) * (a - t2) / 2 + eA(S) * (r6 - s) / 2, I = M * M / (d6 * d6) + A6 * A6 / (v6 * v6);
      I > 1 && (d6 *= ZO(I), v6 *= ZO(I));
      var R = (u === f6 ? -1 : 1) * ZO((d6 * d6 * (v6 * v6) - d6 * d6 * (A6 * A6) - v6 * v6 * (M * M)) / (d6 * d6 * (A6 * A6) + v6 * v6 * (M * M))) || 0, F = R * d6 * A6 / v6, j = R * -v6 * M / d6, $ = (a + t2) / 2 + eA(S) * F - FD(S) * j, K = (r6 + s) / 2 + FD(S) * F + eA(S) * j, U = KO([1, 0], [(M - F) / d6, (A6 - j) / v6]), he = [(M - F) / d6, (A6 - j) / v6], ue = [(-1 * M - F) / d6, (-1 * A6 - j) / v6], pe = KO(he, ue);
      if (XO(he, ue) <= -1 && (pe = tA), XO(he, ue) >= 1 && (pe = 0), pe < 0) {
        var _e = Math.round(pe / tA * 1e6) / 1e6;
        pe = tA * 2 + _e % 2 * tA;
      }
      x6.addData(b6, $, K, d6, v6, U, pe, S, f6);
    }
    var Qq = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, eY = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
    function N7(a) {
      var r6 = new wm();
      if (!a)
        return r6;
      var t2 = 0, s = 0, u = t2, f6 = s, d6, v6 = wm.CMD, m6 = a.match(Qq);
      if (!m6)
        return r6;
      for (var b6 = 0; b6 < m6.length; b6++) {
        for (var x6 = m6[b6], S = x6.charAt(0), M = void 0, A6 = x6.match(eY) || [], I = A6.length, R = 0; R < I; R++)
          A6[R] = parseFloat(A6[R]);
        for (var F = 0; F < I; ) {
          var j = void 0, $ = void 0, K = void 0, U = void 0, he = void 0, ue = void 0, pe = void 0, _e = t2, xe = s, Ae = void 0, ke = void 0;
          switch (S) {
            case "l":
              t2 += A6[F++], s += A6[F++], M = v6.L, r6.addData(M, t2, s);
              break;
            case "L":
              t2 = A6[F++], s = A6[F++], M = v6.L, r6.addData(M, t2, s);
              break;
            case "m":
              t2 += A6[F++], s += A6[F++], M = v6.M, r6.addData(M, t2, s), u = t2, f6 = s, S = "l";
              break;
            case "M":
              t2 = A6[F++], s = A6[F++], M = v6.M, r6.addData(M, t2, s), u = t2, f6 = s, S = "L";
              break;
            case "h":
              t2 += A6[F++], M = v6.L, r6.addData(M, t2, s);
              break;
            case "H":
              t2 = A6[F++], M = v6.L, r6.addData(M, t2, s);
              break;
            case "v":
              s += A6[F++], M = v6.L, r6.addData(M, t2, s);
              break;
            case "V":
              s = A6[F++], M = v6.L, r6.addData(M, t2, s);
              break;
            case "C":
              M = v6.C, r6.addData(M, A6[F++], A6[F++], A6[F++], A6[F++], A6[F++], A6[F++]), t2 = A6[F - 2], s = A6[F - 1];
              break;
            case "c":
              M = v6.C, r6.addData(M, A6[F++] + t2, A6[F++] + s, A6[F++] + t2, A6[F++] + s, A6[F++] + t2, A6[F++] + s), t2 += A6[F - 2], s += A6[F - 1];
              break;
            case "S":
              j = t2, $ = s, Ae = r6.len(), ke = r6.data, d6 === v6.C && (j += t2 - ke[Ae - 4], $ += s - ke[Ae - 3]), M = v6.C, _e = A6[F++], xe = A6[F++], t2 = A6[F++], s = A6[F++], r6.addData(M, j, $, _e, xe, t2, s);
              break;
            case "s":
              j = t2, $ = s, Ae = r6.len(), ke = r6.data, d6 === v6.C && (j += t2 - ke[Ae - 4], $ += s - ke[Ae - 3]), M = v6.C, _e = t2 + A6[F++], xe = s + A6[F++], t2 += A6[F++], s += A6[F++], r6.addData(M, j, $, _e, xe, t2, s);
              break;
            case "Q":
              _e = A6[F++], xe = A6[F++], t2 = A6[F++], s = A6[F++], M = v6.Q, r6.addData(M, _e, xe, t2, s);
              break;
            case "q":
              _e = A6[F++] + t2, xe = A6[F++] + s, t2 += A6[F++], s += A6[F++], M = v6.Q, r6.addData(M, _e, xe, t2, s);
              break;
            case "T":
              j = t2, $ = s, Ae = r6.len(), ke = r6.data, d6 === v6.Q && (j += t2 - ke[Ae - 4], $ += s - ke[Ae - 3]), t2 = A6[F++], s = A6[F++], M = v6.Q, r6.addData(M, j, $, t2, s);
              break;
            case "t":
              j = t2, $ = s, Ae = r6.len(), ke = r6.data, d6 === v6.Q && (j += t2 - ke[Ae - 4], $ += s - ke[Ae - 3]), t2 += A6[F++], s += A6[F++], M = v6.Q, r6.addData(M, j, $, t2, s);
              break;
            case "A":
              K = A6[F++], U = A6[F++], he = A6[F++], ue = A6[F++], pe = A6[F++], _e = t2, xe = s, t2 = A6[F++], s = A6[F++], M = v6.A, F7(_e, xe, t2, s, ue, pe, K, U, he, M, r6);
              break;
            case "a":
              K = A6[F++], U = A6[F++], he = A6[F++], ue = A6[F++], pe = A6[F++], _e = t2, xe = s, t2 += A6[F++], s += A6[F++], M = v6.A, F7(_e, xe, t2, s, ue, pe, K, U, he, M, r6);
              break;
          }
        }
        (S === "z" || S === "Z") && (M = v6.Z, r6.addData(M), t2 = u, s = f6), d6 = M;
      }
      return r6.toStatic(), r6;
    }
    var JO = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.applyTransform = function(t2) {
      }, r6;
    }(uo);
    function V7(a) {
      return a.setData != null;
    }
    function z7(a, r6) {
      var t2 = N7(a), s = qn({}, r6);
      return s.buildPath = function(u) {
        if (V7(u)) {
          u.setData(t2.data);
          var f6 = u.getContext();
          f6 && u.rebuildPath(f6, 1);
        } else {
          var f6 = u;
          t2.rebuildPath(f6, 1);
        }
      }, s.applyTransform = function(u) {
        O7(t2, u), this.dirtyShape();
      }, s;
    }
    function B7(a, r6) {
      return new JO(z7(a, r6));
    }
    function tY(a, r6) {
      var t2 = z7(a, r6), s = function(u) {
        tt(f6, u);
        function f6(d6) {
          var v6 = u.call(this, d6) || this;
          return v6.applyTransform = t2.applyTransform, v6.buildPath = t2.buildPath, v6;
        }
        return f6;
      }(JO);
      return s;
    }
    function W2(a, r6) {
      for (var t2 = [], s = a.length, u = 0; u < s; u++) {
        var f6 = a[u];
        t2.push(f6.getUpdatedPathProxy(true));
      }
      var d6 = new uo(r6);
      return d6.createPathProxy(), d6.buildPath = function(v6) {
        if (V7(v6)) {
          v6.appendPath(t2);
          var m6 = v6.getContext();
          m6 && v6.rebuildPath(m6, 1);
        }
      }, d6;
    }
    function QO(a, r6) {
      r6 = r6 || {};
      var t2 = new uo();
      return a.shape && t2.setShape(a.shape), t2.setStyle(a.style), r6.bakeTransform ? O7(t2.path, a.getComputedTransform()) : r6.toLocal ? t2.setLocalTransform(a.getComputedTransform()) : t2.copyTransform(a), t2.buildPath = a.buildPath, t2.applyTransform = t2.applyTransform, t2.z = a.z, t2.z2 = a.z2, t2.zlevel = a.zlevel, t2;
    }
    var nY = function() {
      function a() {
        this.cx = 0, this.cy = 0, this.r = 0;
      }
      return a;
    }(), j7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new nY();
      }, r6.prototype.buildPath = function(t2, s) {
        t2.moveTo(s.cx + s.r, s.cy), t2.arc(s.cx, s.cy, s.r, 0, Math.PI * 2);
      }, r6;
    }(uo);
    j7.prototype.type = "circle";
    var Em = j7, rY = function() {
      function a() {
        this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
      }
      return a;
    }(), eR = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new rY();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = 0.5522848, f6 = s.cx, d6 = s.cy, v6 = s.rx, m6 = s.ry, b6 = v6 * u, x6 = m6 * u;
        t2.moveTo(f6 - v6, d6), t2.bezierCurveTo(f6 - v6, d6 - x6, f6 - b6, d6 - m6, f6, d6 - m6), t2.bezierCurveTo(f6 + b6, d6 - m6, f6 + v6, d6 - x6, f6 + v6, d6), t2.bezierCurveTo(f6 + v6, d6 + x6, f6 + b6, d6 + m6, f6, d6 + m6), t2.bezierCurveTo(f6 - b6, d6 + m6, f6 - v6, d6 + x6, f6 - v6, d6), t2.closePath();
      }, r6;
    }(uo);
    eR.prototype.type = "ellipse";
    var ND = eR, G7 = Math.PI, tR = G7 * 2, Vx = Math.sin, H2 = Math.cos, aY = Math.acos, ld = Math.atan2, W7 = Math.abs, nA = Math.sqrt, rA = Math.max, Im = Math.min, c0 = 1e-4;
    function iY(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = t2 - a, b6 = s - r6, x6 = d6 - u, S = v6 - f6, M = S * m6 - x6 * b6;
      if (!(M * M < c0))
        return M = (x6 * (r6 - f6) - S * (a - u)) / M, [a + M * m6, r6 + M * b6];
    }
    function VD(a, r6, t2, s, u, f6, d6) {
      var v6 = a - t2, m6 = r6 - s, b6 = (d6 ? f6 : -f6) / nA(v6 * v6 + m6 * m6), x6 = b6 * m6, S = -b6 * v6, M = a + x6, A6 = r6 + S, I = t2 + x6, R = s + S, F = (M + I) / 2, j = (A6 + R) / 2, $ = I - M, K = R - A6, U = $ * $ + K * K, he = u - f6, ue = M * R - I * A6, pe = (K < 0 ? -1 : 1) * nA(rA(0, he * he * U - ue * ue)), _e = (ue * K - $ * pe) / U, xe = (-ue * $ - K * pe) / U, Ae = (ue * K + $ * pe) / U, ke = (-ue * $ + K * pe) / U, je = _e - F, Fe = xe - j, at = Ae - F, ht = ke - j;
      return je * je + Fe * Fe > at * at + ht * ht && (_e = Ae, xe = ke), { cx: _e, cy: xe, x0: -x6, y0: -S, x1: _e * (u / he - 1), y1: xe * (u / he - 1) };
    }
    function oY(a) {
      var r6;
      if (br(a)) {
        var t2 = a.length;
        if (!t2)
          return a;
        t2 === 1 ? r6 = [a[0], a[0], 0, 0] : t2 === 2 ? r6 = [a[0], a[0], a[1], a[1]] : t2 === 3 ? r6 = a.concat(a[2]) : r6 = a;
      } else
        r6 = [a, a, a, a];
      return r6;
    }
    function sY(a, r6) {
      var t2, s = rA(r6.r, 0), u = rA(r6.r0 || 0, 0), f6 = s > 0, d6 = u > 0;
      if (!(!f6 && !d6)) {
        if (f6 || (s = u, u = 0), u > s) {
          var v6 = s;
          s = u, u = v6;
        }
        var m6 = r6.startAngle, b6 = r6.endAngle;
        if (!(isNaN(m6) || isNaN(b6))) {
          var x6 = r6.cx, S = r6.cy, M = !!r6.clockwise, A6 = W7(b6 - m6), I = A6 > tR && A6 % tR;
          if (I > c0 && (A6 = I), !(s > c0))
            a.moveTo(x6, S);
          else if (A6 > tR - c0)
            a.moveTo(x6 + s * H2(m6), S + s * Vx(m6)), a.arc(x6, S, s, m6, b6, !M), u > c0 && (a.moveTo(x6 + u * H2(b6), S + u * Vx(b6)), a.arc(x6, S, u, b6, m6, M));
          else {
            var R = void 0, F = void 0, j = void 0, $ = void 0, K = void 0, U = void 0, he = void 0, ue = void 0, pe = void 0, _e = void 0, xe = void 0, Ae = void 0, ke = void 0, je = void 0, Fe = void 0, at = void 0, ht = s * H2(m6), Qe = s * Vx(m6), en = u * H2(b6), bt = u * Vx(b6), wt = A6 > c0;
            if (wt) {
              var Ft = r6.cornerRadius;
              Ft && (t2 = oY(Ft), R = t2[0], F = t2[1], j = t2[2], $ = t2[3]);
              var fn = W7(s - u) / 2;
              if (K = Im(fn, j), U = Im(fn, $), he = Im(fn, R), ue = Im(fn, F), xe = pe = rA(K, U), Ae = _e = rA(he, ue), (pe > c0 || _e > c0) && (ke = s * H2(b6), je = s * Vx(b6), Fe = u * H2(m6), at = u * Vx(m6), A6 < G7)) {
                var gn = iY(ht, Qe, Fe, at, ke, je, en, bt);
                if (gn) {
                  var Zr = ht - gn[0], Ma = Qe - gn[1], Ua = ke - gn[0], ja = je - gn[1], Ga = 1 / Vx(aY((Zr * Ua + Ma * ja) / (nA(Zr * Zr + Ma * Ma) * nA(Ua * Ua + ja * ja))) / 2), pa = nA(gn[0] * gn[0] + gn[1] * gn[1]);
                  xe = Im(pe, (s - pa) / (Ga + 1)), Ae = Im(_e, (u - pa) / (Ga - 1));
                }
              }
            }
            if (!wt)
              a.moveTo(x6 + ht, S + Qe);
            else if (xe > c0) {
              var Fa = Im(j, xe), Ha = Im($, xe), Sa = VD(Fe, at, ht, Qe, s, Fa, M), oi = VD(ke, je, en, bt, s, Ha, M);
              a.moveTo(x6 + Sa.cx + Sa.x0, S + Sa.cy + Sa.y0), xe < pe && Fa === Ha ? a.arc(x6 + Sa.cx, S + Sa.cy, xe, ld(Sa.y0, Sa.x0), ld(oi.y0, oi.x0), !M) : (Fa > 0 && a.arc(x6 + Sa.cx, S + Sa.cy, Fa, ld(Sa.y0, Sa.x0), ld(Sa.y1, Sa.x1), !M), a.arc(x6, S, s, ld(Sa.cy + Sa.y1, Sa.cx + Sa.x1), ld(oi.cy + oi.y1, oi.cx + oi.x1), !M), Ha > 0 && a.arc(x6 + oi.cx, S + oi.cy, Ha, ld(oi.y1, oi.x1), ld(oi.y0, oi.x0), !M));
            } else
              a.moveTo(x6 + ht, S + Qe), a.arc(x6, S, s, m6, b6, !M);
            if (!(u > c0) || !wt)
              a.lineTo(x6 + en, S + bt);
            else if (Ae > c0) {
              var Fa = Im(R, Ae), Ha = Im(F, Ae), Sa = VD(en, bt, ke, je, u, -Ha, M), oi = VD(ht, Qe, Fe, at, u, -Fa, M);
              a.lineTo(x6 + Sa.cx + Sa.x0, S + Sa.cy + Sa.y0), Ae < _e && Fa === Ha ? a.arc(x6 + Sa.cx, S + Sa.cy, Ae, ld(Sa.y0, Sa.x0), ld(oi.y0, oi.x0), !M) : (Ha > 0 && a.arc(x6 + Sa.cx, S + Sa.cy, Ha, ld(Sa.y0, Sa.x0), ld(Sa.y1, Sa.x1), !M), a.arc(x6, S, u, ld(Sa.cy + Sa.y1, Sa.cx + Sa.x1), ld(oi.cy + oi.y1, oi.cx + oi.x1), M), Fa > 0 && a.arc(x6 + oi.cx, S + oi.cy, Fa, ld(oi.y1, oi.x1), ld(oi.y0, oi.x0), !M));
            } else
              a.lineTo(x6 + en, S + bt), a.arc(x6, S, u, b6, m6, M);
          }
          a.closePath();
        }
      }
    }
    var lY = function() {
      function a() {
        this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
      }
      return a;
    }(), H7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new lY();
      }, r6.prototype.buildPath = function(t2, s) {
        sY(t2, s);
      }, r6.prototype.isZeroArea = function() {
        return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
      }, r6;
    }(uo);
    H7.prototype.type = "sector";
    var Np = H7, uY = function() {
      function a() {
        this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
      }
      return a;
    }(), $7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new uY();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.cx, f6 = s.cy, d6 = Math.PI * 2;
        t2.moveTo(u + s.r, f6), t2.arc(u, f6, s.r, 0, d6, false), t2.moveTo(u + s.r0, f6), t2.arc(u, f6, s.r0, 0, d6, true);
      }, r6;
    }(uo);
    $7.prototype.type = "ring";
    var zD = $7;
    function cY(a, r6, t2, s) {
      var u = [], f6 = [], d6 = [], v6 = [], m6, b6, x6, S;
      if (s) {
        x6 = [1 / 0, 1 / 0], S = [-1 / 0, -1 / 0];
        for (var M = 0, A6 = a.length; M < A6; M++)
          Yg(x6, x6, a[M]), xv(S, S, a[M]);
        Yg(x6, x6, s[0]), xv(S, S, s[1]);
      }
      for (var M = 0, A6 = a.length; M < A6; M++) {
        var I = a[M];
        if (t2)
          m6 = a[M ? M - 1 : A6 - 1], b6 = a[(M + 1) % A6];
        else if (M === 0 || M === A6 - 1) {
          u.push(gf(a[M]));
          continue;
        } else
          m6 = a[M - 1], b6 = a[M + 1];
        hm(f6, b6, m6), dm(f6, f6, r6);
        var R = pL(I, m6), F = pL(I, b6), j = R + F;
        j !== 0 && (R /= j, F /= j), dm(d6, f6, -R), dm(v6, f6, F);
        var $ = dL([], I, d6), K = dL([], I, v6);
        s && (xv($, $, x6), Yg($, $, S), xv(K, K, x6), Yg(K, K, S)), u.push($), u.push(K);
      }
      return t2 && u.push(u.shift()), u;
    }
    function U7(a, r6, t2) {
      var s = r6.smooth, u = r6.points;
      if (u && u.length >= 2) {
        if (s) {
          var f6 = cY(u, s, t2, r6.smoothConstraint);
          a.moveTo(u[0][0], u[0][1]);
          for (var d6 = u.length, v6 = 0; v6 < (t2 ? d6 : d6 - 1); v6++) {
            var m6 = f6[v6 * 2], b6 = f6[v6 * 2 + 1], x6 = u[(v6 + 1) % d6];
            a.bezierCurveTo(m6[0], m6[1], b6[0], b6[1], x6[0], x6[1]);
          }
        } else {
          a.moveTo(u[0][0], u[0][1]);
          for (var v6 = 1, S = u.length; v6 < S; v6++)
            a.lineTo(u[v6][0], u[v6][1]);
        }
        t2 && a.closePath();
      }
    }
    var fY = function() {
      function a() {
        this.points = null, this.smooth = 0, this.smoothConstraint = null;
      }
      return a;
    }(), q7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new fY();
      }, r6.prototype.buildPath = function(t2, s) {
        U7(t2, s, true);
      }, r6;
    }(uo);
    q7.prototype.type = "polygon";
    var ud = q7, Y7 = function() {
      function a() {
        this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
      }
      return a;
    }(), nR = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new Y7();
      }, r6.prototype.buildPath = function(t2, s) {
        U7(t2, s, false);
      }, r6;
    }(uo);
    nR.prototype.type = "polyline";
    var Vp = nR, hY = {}, dY = function() {
      function a() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
      }
      return a;
    }(), BD = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new dY();
      }, r6.prototype.buildPath = function(t2, s) {
        var u, f6, d6, v6;
        if (this.subPixelOptimize) {
          var m6 = LO(hY, s, this.style);
          u = m6.x1, f6 = m6.y1, d6 = m6.x2, v6 = m6.y2;
        } else
          u = s.x1, f6 = s.y1, d6 = s.x2, v6 = s.y2;
        var b6 = s.percent;
        b6 !== 0 && (t2.moveTo(u, f6), b6 < 1 && (d6 = u * (1 - b6) + d6 * b6, v6 = f6 * (1 - b6) + v6 * b6), t2.lineTo(d6, v6));
      }, r6.prototype.pointAt = function(t2) {
        var s = this.shape;
        return [s.x1 * (1 - t2) + s.x2 * t2, s.y1 * (1 - t2) + s.y2 * t2];
      }, r6;
    }(uo);
    BD.prototype.type = "line";
    var rh = BD, zp = [], pY = function() {
      function a() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
      }
      return a;
    }();
    function tp(a, r6, t2) {
      var s = a.cpx2, u = a.cpy2;
      return s != null || u != null ? [(t2 ? x9 : Pc)(a.x1, a.cpx1, a.cpx2, a.x2, r6), (t2 ? x9 : Pc)(a.y1, a.cpy1, a.cpy2, a.y2, r6)] : [(t2 ? zT : eh)(a.x1, a.cpx1, a.x2, r6), (t2 ? zT : eh)(a.y1, a.cpy1, a.y2, r6)];
    }
    var jD = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new pY();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.x1, f6 = s.y1, d6 = s.x2, v6 = s.y2, m6 = s.cpx1, b6 = s.cpy1, x6 = s.cpx2, S = s.cpy2, M = s.percent;
        M !== 0 && (t2.moveTo(u, f6), x6 == null || S == null ? (M < 1 && (wc(u, m6, d6, M, zp), m6 = zp[1], d6 = zp[2], wc(f6, b6, v6, M, zp), b6 = zp[1], v6 = zp[2]), t2.quadraticCurveTo(m6, b6, d6, v6)) : (M < 1 && (Jg(u, m6, x6, d6, M, zp), m6 = zp[1], x6 = zp[2], d6 = zp[3], Jg(f6, b6, S, v6, M, zp), b6 = zp[1], S = zp[2], v6 = zp[3]), t2.bezierCurveTo(m6, b6, x6, S, d6, v6)));
      }, r6.prototype.pointAt = function(t2) {
        return tp(this.shape, t2, false);
      }, r6.prototype.tangentAt = function(t2) {
        var s = tp(this.shape, t2, true);
        return ix(s, s);
      }, r6;
    }(uo);
    jD.prototype.type = "bezier-curve";
    var GD = jD, vY = function() {
      function a() {
        this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
      }
      return a;
    }(), Z7 = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new vY();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.cx, f6 = s.cy, d6 = Math.max(s.r, 0), v6 = s.startAngle, m6 = s.endAngle, b6 = s.clockwise, x6 = Math.cos(v6), S = Math.sin(v6);
        t2.moveTo(x6 * d6 + u, S * d6 + f6), t2.arc(u, f6, d6, v6, m6, !b6);
      }, r6;
    }(uo);
    Z7.prototype.type = "arc";
    var rR = Z7, aR = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "compound", t2;
      }
      return r6.prototype._updatePathDirty = function() {
        for (var t2 = this.shape.paths, s = this.shapeChanged(), u = 0; u < t2.length; u++)
          s = s || t2[u].shapeChanged();
        s && this.dirtyShape();
      }, r6.prototype.beforeBrush = function() {
        this._updatePathDirty();
        for (var t2 = this.shape.paths || [], s = this.getGlobalScale(), u = 0; u < t2.length; u++)
          t2[u].path || t2[u].createPathProxy(), t2[u].path.setScale(s[0], s[1], t2[u].segmentIgnoreThreshold);
      }, r6.prototype.buildPath = function(t2, s) {
        for (var u = s.paths || [], f6 = 0; f6 < u.length; f6++)
          u[f6].buildPath(t2, u[f6].shape, true);
      }, r6.prototype.afterBrush = function() {
        for (var t2 = this.shape.paths || [], s = 0; s < t2.length; s++)
          t2[s].pathUpdated();
      }, r6.prototype.getBoundingRect = function() {
        return this._updatePathDirty.call(this), uo.prototype.getBoundingRect.call(this);
      }, r6;
    }(uo), iR = aR, oR = function() {
      function a(r6) {
        this.colorStops = r6 || [];
      }
      return a.prototype.addColorStop = function(r6, t2) {
        this.colorStops.push({ offset: r6, color: t2 });
      }, a;
    }(), X7 = oR, gY = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6, d6, v6) {
        var m6 = a.call(this, d6) || this;
        return m6.x = t2 == null ? 0 : t2, m6.y = s == null ? 0 : s, m6.x2 = u == null ? 1 : u, m6.y2 = f6 == null ? 0 : f6, m6.type = "linear", m6.global = v6 || false, m6;
      }
      return r6;
    }(X7), aA = gY, mY = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6, d6) {
        var v6 = a.call(this, f6) || this;
        return v6.x = t2 == null ? 0.5 : t2, v6.y = s == null ? 0.5 : s, v6.r = u == null ? 0.5 : u, v6.type = "radial", v6.global = d6 || false, v6;
      }
      return r6;
    }(X7), sR = mY, zx = [0, 0], Bx = [0, 0], WD = new Bi(), $2 = new Bi(), lR = function() {
      function a(r6, t2) {
        this._corners = [], this._axes = [], this._origin = [0, 0];
        for (var s = 0; s < 4; s++)
          this._corners[s] = new Bi();
        for (var s = 0; s < 2; s++)
          this._axes[s] = new Bi();
        r6 && this.fromBoundingRect(r6, t2);
      }
      return a.prototype.fromBoundingRect = function(r6, t2) {
        var s = this._corners, u = this._axes, f6 = r6.x, d6 = r6.y, v6 = f6 + r6.width, m6 = d6 + r6.height;
        if (s[0].set(f6, d6), s[1].set(v6, d6), s[2].set(v6, m6), s[3].set(f6, m6), t2)
          for (var b6 = 0; b6 < 4; b6++)
            s[b6].transform(t2);
        Bi.sub(u[0], s[1], s[0]), Bi.sub(u[1], s[3], s[0]), u[0].normalize(), u[1].normalize();
        for (var b6 = 0; b6 < 2; b6++)
          this._origin[b6] = u[b6].dot(s[0]);
      }, a.prototype.intersect = function(r6, t2) {
        var s = true, u = !t2;
        return WD.set(1 / 0, 1 / 0), $2.set(0, 0), !this._intersectCheckOneSide(this, r6, WD, $2, u, 1) && (s = false, u) || !this._intersectCheckOneSide(r6, this, WD, $2, u, -1) && (s = false, u) || u || Bi.copy(t2, s ? WD : $2), s;
      }, a.prototype._intersectCheckOneSide = function(r6, t2, s, u, f6, d6) {
        for (var v6 = true, m6 = 0; m6 < 2; m6++) {
          var b6 = this._axes[m6];
          if (this._getProjMinMaxOnAxis(m6, r6._corners, zx), this._getProjMinMaxOnAxis(m6, t2._corners, Bx), zx[1] < Bx[0] || zx[0] > Bx[1]) {
            if (v6 = false, f6)
              return v6;
            var x6 = Math.abs(Bx[0] - zx[1]), S = Math.abs(zx[0] - Bx[1]);
            Math.min(x6, S) > u.len() && (x6 < S ? Bi.scale(u, b6, -x6 * d6) : Bi.scale(u, b6, S * d6));
          } else if (s) {
            var x6 = Math.abs(Bx[0] - zx[1]), S = Math.abs(zx[0] - Bx[1]);
            Math.min(x6, S) < s.len() && (x6 < S ? Bi.scale(s, b6, x6 * d6) : Bi.scale(s, b6, -S * d6));
          }
        }
        return v6;
      }, a.prototype._getProjMinMaxOnAxis = function(r6, t2, s) {
        for (var u = this._axes[r6], f6 = this._origin, d6 = t2[0].dot(u) + f6[r6], v6 = d6, m6 = d6, b6 = 1; b6 < t2.length; b6++) {
          var x6 = t2[b6].dot(u) + f6[r6];
          v6 = Math.min(x6, v6), m6 = Math.max(x6, m6);
        }
        s[0] = v6, s[1] = m6;
      }, a;
    }(), HD = lR, yY = [], bY = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.notClear = true, t2.incremental = true, t2._displayables = [], t2._temporaryDisplayables = [], t2._cursor = 0, t2;
      }
      return r6.prototype.traverse = function(t2, s) {
        t2.call(s, this);
      }, r6.prototype.useStyle = function() {
        this.style = {};
      }, r6.prototype.getCursor = function() {
        return this._cursor;
      }, r6.prototype.innerAfterBrush = function() {
        this._cursor = this._displayables.length;
      }, r6.prototype.clearDisplaybles = function() {
        this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
      }, r6.prototype.clearTemporalDisplayables = function() {
        this._temporaryDisplayables = [];
      }, r6.prototype.addDisplayable = function(t2, s) {
        s ? this._temporaryDisplayables.push(t2) : this._displayables.push(t2), this.markRedraw();
      }, r6.prototype.addDisplayables = function(t2, s) {
        s = s || false;
        for (var u = 0; u < t2.length; u++)
          this.addDisplayable(t2[u], s);
      }, r6.prototype.getDisplayables = function() {
        return this._displayables;
      }, r6.prototype.getTemporalDisplayables = function() {
        return this._temporaryDisplayables;
      }, r6.prototype.eachPendingDisplayable = function(t2) {
        for (var s = this._cursor; s < this._displayables.length; s++)
          t2 && t2(this._displayables[s]);
        for (var s = 0; s < this._temporaryDisplayables.length; s++)
          t2 && t2(this._temporaryDisplayables[s]);
      }, r6.prototype.update = function() {
        this.updateTransform();
        for (var t2 = this._cursor; t2 < this._displayables.length; t2++) {
          var s = this._displayables[t2];
          s.parent = this, s.update(), s.parent = null;
        }
        for (var t2 = 0; t2 < this._temporaryDisplayables.length; t2++) {
          var s = this._temporaryDisplayables[t2];
          s.parent = this, s.update(), s.parent = null;
        }
      }, r6.prototype.getBoundingRect = function() {
        if (!this._rect) {
          for (var t2 = new Qi(1 / 0, 1 / 0, -1 / 0, -1 / 0), s = 0; s < this._displayables.length; s++) {
            var u = this._displayables[s], f6 = u.getBoundingRect().clone();
            u.needLocalTransform() && f6.applyTransform(u.getLocalTransform(yY)), t2.union(f6);
          }
          this._rect = t2;
        }
        return this._rect;
      }, r6.prototype.contain = function(t2, s) {
        var u = this.transformCoordToLocal(t2, s), f6 = this.getBoundingRect();
        if (f6.contain(u[0], u[1]))
          for (var d6 = 0; d6 < this._displayables.length; d6++) {
            var v6 = this._displayables[d6];
            if (v6.contain(t2, s))
              return true;
          }
        return false;
      }, r6;
    }(cg), _Y = bY, K7 = Xo();
    function U2(a, r6, t2, s, u) {
      var f6;
      if (r6 && r6.ecModel) {
        var d6 = r6.ecModel.getUpdatePayload();
        f6 = d6 && d6.animation;
      }
      var v6 = r6 && r6.isAnimationEnabled(), m6 = a === "update";
      if (v6) {
        var b6 = void 0, x6 = void 0, S = void 0;
        s ? (b6 = qi(s.duration, 200), x6 = qi(s.easing, "cubicOut"), S = 0) : (b6 = r6.getShallow(m6 ? "animationDurationUpdate" : "animationDuration"), x6 = r6.getShallow(m6 ? "animationEasingUpdate" : "animationEasing"), S = r6.getShallow(m6 ? "animationDelayUpdate" : "animationDelay")), f6 && (f6.duration != null && (b6 = f6.duration), f6.easing != null && (x6 = f6.easing), f6.delay != null && (S = f6.delay)), ti(S) && (S = S(t2, u)), ti(b6) && (b6 = b6(t2));
        var M = { duration: b6 || 0, delay: S, easing: x6 };
        return M;
      } else
        return null;
    }
    function uR(a, r6, t2, s, u, f6, d6) {
      var v6 = false, m6;
      ti(u) ? (d6 = f6, f6 = u, u = null) : ui(u) && (f6 = u.cb, d6 = u.during, v6 = u.isFrom, m6 = u.removeOpt, u = u.dataIndex);
      var b6 = a === "leave";
      b6 || r6.stopAnimation("leave");
      var x6 = U2(a, s, u, b6 ? m6 || {} : null, s && s.getAnimationDelayParams ? s.getAnimationDelayParams(r6, u) : null);
      if (x6 && x6.duration > 0) {
        var S = x6.duration, M = x6.delay, A6 = x6.easing, I = { duration: S, delay: M || 0, easing: A6, done: f6, force: !!f6 || !!d6, setToFinal: !b6, scope: a, during: d6 };
        v6 ? r6.animateFrom(t2, I) : r6.animateTo(t2, I);
      } else
        r6.stopAnimation(), !v6 && r6.attr(t2), d6 && d6(1), f6 && f6();
    }
    function fs(a, r6, t2, s, u, f6) {
      uR("update", a, r6, t2, s, u, f6);
    }
    function zu(a, r6, t2, s, u, f6) {
      uR("enter", a, r6, t2, s, u, f6);
    }
    function q22(a) {
      if (!a.__zr)
        return true;
      for (var r6 = 0; r6 < a.animators.length; r6++) {
        var t2 = a.animators[r6];
        if (t2.scope === "leave")
          return true;
      }
      return false;
    }
    function Ob(a, r6, t2, s, u, f6) {
      q22(a) || uR("leave", a, r6, t2, s, u, f6);
    }
    function J7(a, r6, t2, s) {
      a.removeTextContent(), a.removeTextGuideLine(), Ob(a, { style: { opacity: 0 } }, r6, t2, s);
    }
    function iA(a, r6, t2) {
      function s() {
        a.parent && a.parent.remove(a);
      }
      a.isGroup ? a.traverse(function(u) {
        u.isGroup || J7(u, r6, t2, s);
      }) : J7(a, r6, t2, s);
    }
    function f0(a) {
      K7(a).oldStyle = a.style;
    }
    function xY(a) {
      return K7(a).oldStyle;
    }
    var $D = Math.max, UD = Math.min, cR = {};
    function wY(a) {
      return uo.extend(a);
    }
    var SY = tY;
    function CY(a, r6) {
      return SY(a, r6);
    }
    function D(a, r6) {
      cR[a] = r6;
    }
    function B(a) {
      if (cR.hasOwnProperty(a))
        return cR[a];
    }
    function ie(a, r6, t2, s) {
      var u = B7(a, r6);
      return t2 && (s === "center" && (t2 = $e(t2, u.getBoundingRect())), $t(u, t2)), u;
    }
    function Ce(a, r6, t2) {
      var s = new nh({ style: { image: a, x: r6.x, y: r6.y, width: r6.width, height: r6.height }, onload: function(u) {
        if (t2 === "center") {
          var f6 = { width: u.width, height: u.height };
          s.setStyle($e(r6, f6));
        }
      } });
      return s;
    }
    function $e(a, r6) {
      var t2 = r6.width / r6.height, s = a.height * t2, u;
      s <= a.width ? u = a.height : (s = a.width, u = s / t2);
      var f6 = a.x + a.width / 2, d6 = a.y + a.height / 2;
      return { x: f6 - s / 2, y: d6 - u / 2, width: s, height: u };
    }
    var dt = W2;
    function $t(a, r6) {
      if (a.applyTransform) {
        var t2 = a.getBoundingRect(), s = t2.calculateTransform(r6);
        a.applyTransform(s);
      }
    }
    function Qt(a) {
      return LO(a.shape, a.shape, a.style), a;
    }
    function In(a) {
      return OO(a.shape, a.shape, a.style), a;
    }
    var jr = kb;
    function Nr(a, r6) {
      for (var t2 = kM([]); a && a !== r6; )
        Qy(t2, a.getLocalTransform(), t2), a = a.parent;
      return t2;
    }
    function Yr(a, r6, t2) {
      return r6 && !rd(r6) && (r6 = a0.getLocalTransform(r6)), t2 && (r6 = px([], r6)), Qf([], a, r6);
    }
    function za(a, r6, t2) {
      var s = r6[4] === 0 || r6[5] === 0 || r6[0] === 0 ? 1 : Math.abs(2 * r6[4] / r6[0]), u = r6[4] === 0 || r6[5] === 0 || r6[2] === 0 ? 1 : Math.abs(2 * r6[4] / r6[2]), f6 = [a === "left" ? -s : a === "right" ? s : 0, a === "top" ? -u : a === "bottom" ? u : 0];
      return f6 = Yr(f6, r6, t2), Math.abs(f6[0]) > Math.abs(f6[1]) ? f6[0] > 0 ? "right" : "left" : f6[1] > 0 ? "bottom" : "top";
    }
    function Ii(a) {
      return !a.isGroup;
    }
    function no(a) {
      return a.shape != null;
    }
    function Ro(a, r6, t2) {
      if (!a || !r6)
        return;
      function s(d6) {
        var v6 = {};
        return d6.traverse(function(m6) {
          Ii(m6) && m6.anid && (v6[m6.anid] = m6);
        }), v6;
      }
      function u(d6) {
        var v6 = { x: d6.x, y: d6.y, rotation: d6.rotation };
        return no(d6) && (v6.shape = qn({}, d6.shape)), v6;
      }
      var f6 = s(a);
      r6.traverse(function(d6) {
        if (Ii(d6) && d6.anid) {
          var v6 = f6[d6.anid];
          if (v6) {
            var m6 = u(d6);
            d6.attr(u(v6)), fs(d6, m6, t2, ii(d6).dataIndex);
          }
        }
      });
    }
    function eo(a, r6) {
      return wr(a, function(t2) {
        var s = t2[0];
        s = $D(s, r6.x), s = UD(s, r6.x + r6.width);
        var u = t2[1];
        return u = $D(u, r6.y), u = UD(u, r6.y + r6.height), [s, u];
      });
    }
    function Ws(a, r6) {
      var t2 = $D(a.x, r6.x), s = UD(a.x + a.width, r6.x + r6.width), u = $D(a.y, r6.y), f6 = UD(a.y + a.height, r6.y + r6.height);
      if (s >= t2 && f6 >= u)
        return { x: t2, y: u, width: s - t2, height: f6 - u };
    }
    function ys(a, r6, t2) {
      var s = qn({ rectHover: true }, r6), u = s.style = { strokeNoScale: true };
      if (t2 = t2 || { x: -1, y: -1, width: 2, height: 2 }, a)
        return a.indexOf("image://") === 0 ? (u.image = a.slice(8), ei(u, t2), new nh(s)) : ie(a.replace("path://", ""), s, t2, "center");
    }
    function Eh(a, r6, t2, s, u) {
      for (var f6 = 0, d6 = u[u.length - 1]; f6 < u.length; f6++) {
        var v6 = u[f6];
        if (cd(a, r6, t2, s, v6[0], v6[1], d6[0], d6[1]))
          return true;
        d6 = v6;
      }
    }
    function cd(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = t2 - a, b6 = s - r6, x6 = d6 - u, S = v6 - f6, M = np(x6, S, m6, b6);
      if (Xc(M))
        return false;
      var A6 = a - u, I = r6 - f6, R = np(A6, I, m6, b6) / M;
      if (R < 0 || R > 1)
        return false;
      var F = np(A6, I, x6, S) / M;
      return !(F < 0 || F > 1);
    }
    function np(a, r6, t2, s) {
      return a * s - t2 * r6;
    }
    function Xc(a) {
      return a <= 1e-6 && a >= -1e-6;
    }
    function fd(a) {
      var r6 = a.itemTooltipOption, t2 = a.componentModel, s = a.itemName, u = _a2(r6) ? { formatter: r6 } : r6, f6 = t2.mainType, d6 = t2.componentIndex, v6 = { componentType: f6, name: s, $vars: ["name"] };
      v6[f6 + "Index"] = d6;
      var m6 = a.formatterParamsExtra;
      m6 && Ne(Po(m6), function(x6) {
        Da(v6, x6) || (v6[x6] = m6[x6], v6.$vars.push(x6));
      });
      var b6 = ii(a.el);
      b6.componentMainType = f6, b6.componentIndex = d6, b6.tooltipConfig = { name: s, option: ei({ content: s, formatterParams: v6 }, u) };
    }
    function Tm(a, r6) {
      var t2;
      a.isGroup && (t2 = r6(a)), t2 || a.traverse(r6);
    }
    function s1(a, r6) {
      if (a)
        if (br(a))
          for (var t2 = 0; t2 < a.length; t2++)
            Tm(a[t2], r6);
        else
          Tm(a, r6);
    }
    D("circle", Em), D("ellipse", ND), D("sector", Np), D("ring", zD), D("polygon", ud), D("polyline", Vp), D("rect", rs), D("line", rh), D("bezierCurve", GD), D("arc", rR);
    var fR = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: fs, initProps: zu, removeElement: Ob, removeElementWithFadeOut: iA, isElementRemoved: q22, extendShape: wY, extendPath: CY, registerShape: D, getShapeClass: B, makePath: ie, makeImage: Ce, mergePath: dt, resizePath: $t, subPixelOptimizeLine: Qt, subPixelOptimizeRect: In, subPixelOptimize: jr, getTransform: Nr, applyTransform: Yr, transformDirection: za, groupTransition: Ro, clipPointsByRect: eo, clipRectByRect: Ws, createIcon: ys, linePolygonIntersect: Eh, lineLineIntersect: cd, setTooltipConfig: fd, traverseElements: s1, Group: bi, Image: nh, Text: ms, Circle: Em, Ellipse: ND, Sector: Np, Ring: zD, Polygon: ud, Polyline: Vp, Rect: rs, Line: rh, BezierCurve: GD, Arc: rR, IncrementalDisplayable: _Y, CompoundPath: iR, LinearGradient: aA, RadialGradient: sR, BoundingRect: Qi, OrientedBoundingRect: HD, Point: Bi, Path: uo }, Symbol.toStringTag, { value: "Module" })), Q7 = {};
    function Yue(a, r6) {
      for (var t2 = 0; t2 < Oc.length; t2++) {
        var s = Oc[t2], u = r6[s], f6 = a.ensureState(s);
        f6.style = f6.style || {}, f6.style.text = u;
      }
      var d6 = a.currentStates.slice();
      a.clearStates(true), a.setStyle({ text: r6.normal }), a.useStates(d6, true);
    }
    function MY(a, r6, t2) {
      var s = a.labelFetcher, u = a.labelDataIndex, f6 = a.labelDimIndex, d6 = r6.normal, v6;
      s && (v6 = s.getFormattedLabel(u, "normal", null, f6, d6 && d6.get("formatter"), t2 != null ? { interpolatedValue: t2 } : null)), v6 == null && (v6 = ti(a.defaultText) ? a.defaultText(u, a, t2) : a.defaultText);
      for (var m6 = { normal: v6 }, b6 = 0; b6 < Oc.length; b6++) {
        var x6 = Oc[b6], S = r6[x6];
        m6[x6] = qi(s ? s.getFormattedLabel(u, x6, null, f6, S && S.get("formatter")) : null, v6);
      }
      return m6;
    }
    function Bp(a, r6, t2, s) {
      t2 = t2 || Q7;
      for (var u = a instanceof ms, f6 = false, d6 = 0; d6 < KM.length; d6++) {
        var v6 = r6[KM[d6]];
        if (v6 && v6.getShallow("show")) {
          f6 = true;
          break;
        }
      }
      var m6 = u ? a : a.getTextContent();
      if (f6) {
        u || (m6 || (m6 = new ms(), a.setTextContent(m6)), a.stateProxy && (m6.stateProxy = a.stateProxy));
        var b6 = MY(t2, r6), x6 = r6.normal, S = !!x6.getShallow("show"), M = yf(x6, s && s.normal, t2, false, !u);
        M.text = b6.normal, u || a.setTextConfig(eV(x6, t2, false));
        for (var d6 = 0; d6 < Oc.length; d6++) {
          var A6 = Oc[d6], v6 = r6[A6];
          if (v6) {
            var I = m6.ensureState(A6), R = !!qi(v6.getShallow("show"), S);
            if (R !== S && (I.ignore = !R), I.style = yf(v6, s && s[A6], t2, true, !u), I.style.text = b6[A6], !u) {
              var F = a.ensureState(A6);
              F.textConfig = eV(v6, t2, true);
            }
          }
        }
        m6.silent = !!x6.getShallow("silent"), m6.style.x != null && (M.x = m6.style.x), m6.style.y != null && (M.y = m6.style.y), m6.ignore = !S, m6.useStyle(M), m6.dirty(), t2.enableTextSetter && (qD(m6).setLabelText = function(j) {
          var $ = MY(t2, r6, j);
          Yue(m6, $);
        });
      } else
        m6 && (m6.ignore = true);
      a.dirty();
    }
    function hd(a, r6) {
      r6 = r6 || "label";
      for (var t2 = { normal: a.getModel(r6) }, s = 0; s < Oc.length; s++) {
        var u = Oc[s];
        t2[u] = a.getModel([u, r6]);
      }
      return t2;
    }
    function yf(a, r6, t2, s, u) {
      var f6 = {};
      return sOe(f6, a, t2, s, u), r6 && qn(f6, r6), f6;
    }
    function eV(a, r6, t2) {
      r6 = r6 || {};
      var s = {}, u, f6 = a.getShallow("rotate"), d6 = qi(a.getShallow("distance"), t2 ? null : 5), v6 = a.getShallow("offset");
      return u = a.getShallow("position") || (t2 ? null : "inside"), u === "outside" && (u = r6.defaultOutsidePosition || "top"), u != null && (s.position = u), v6 != null && (s.offset = v6), f6 != null && (f6 *= Math.PI / 180, s.rotation = f6), d6 != null && (s.distance = d6), s.outsideFill = a.get("color") === "inherit" ? r6.inheritColor || null : "auto", s;
    }
    function sOe(a, r6, t2, s, u) {
      t2 = t2 || Q7;
      var f6 = r6.ecModel, d6 = f6 && f6.option.textStyle, v6 = lOe(r6), m6;
      if (v6) {
        m6 = {};
        for (var b6 in v6)
          if (v6.hasOwnProperty(b6)) {
            var x6 = r6.getModel(["rich", b6]);
            Jue(m6[b6] = {}, x6, d6, t2, s, u, false, true);
          }
      }
      m6 && (a.rich = m6);
      var S = r6.get("overflow");
      S && (a.overflow = S);
      var M = r6.get("minMargin");
      M != null && (a.margin = M), Jue(a, r6, d6, t2, s, u, true, false);
    }
    function lOe(a) {
      for (var r6; a && a !== a.ecModel; ) {
        var t2 = (a.option || Q7).rich;
        if (t2) {
          r6 = r6 || {};
          for (var s = Po(t2), u = 0; u < s.length; u++) {
            var f6 = s[u];
            r6[f6] = 1;
          }
        }
        a = a.parentModel;
      }
      return r6;
    }
    var Zue = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], Xue = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], Kue = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
    function Jue(a, r6, t2, s, u, f6, d6, v6) {
      t2 = !u && t2 || Q7;
      var m6 = s && s.inheritColor, b6 = r6.getShallow("color"), x6 = r6.getShallow("textBorderColor"), S = qi(r6.getShallow("opacity"), t2.opacity);
      (b6 === "inherit" || b6 === "auto") && (m6 ? b6 = m6 : b6 = null), (x6 === "inherit" || x6 === "auto") && (m6 ? x6 = m6 : x6 = null), f6 || (b6 = b6 || t2.color, x6 = x6 || t2.textBorderColor), b6 != null && (a.fill = b6), x6 != null && (a.stroke = x6);
      var M = qi(r6.getShallow("textBorderWidth"), t2.textBorderWidth);
      M != null && (a.lineWidth = M);
      var A6 = qi(r6.getShallow("textBorderType"), t2.textBorderType);
      A6 != null && (a.lineDash = A6);
      var I = qi(r6.getShallow("textBorderDashOffset"), t2.textBorderDashOffset);
      I != null && (a.lineDashOffset = I), !u && S == null && !v6 && (S = s && s.defaultOpacity), S != null && (a.opacity = S), !u && !f6 && a.fill == null && s.inheritColor && (a.fill = s.inheritColor);
      for (var R = 0; R < Zue.length; R++) {
        var F = Zue[R], j = qi(r6.getShallow(F), t2[F]);
        j != null && (a[F] = j);
      }
      for (var R = 0; R < Xue.length; R++) {
        var F = Xue[R], j = r6.getShallow(F);
        j != null && (a[F] = j);
      }
      if (a.verticalAlign == null) {
        var $ = r6.getShallow("baseline");
        $ != null && (a.verticalAlign = $);
      }
      if (!d6 || !s.disableBox) {
        for (var R = 0; R < Kue.length; R++) {
          var F = Kue[R], j = r6.getShallow(F);
          j != null && (a[F] = j);
        }
        var K = r6.getShallow("borderType");
        K != null && (a.borderDash = K), (a.backgroundColor === "auto" || a.backgroundColor === "inherit") && m6 && (a.backgroundColor = m6), (a.borderColor === "auto" || a.borderColor === "inherit") && m6 && (a.borderColor = m6);
      }
    }
    function Que(a, r6) {
      var t2 = r6 && r6.getModel("textStyle");
      return mu([a.fontStyle || t2 && t2.getShallow("fontStyle") || "", a.fontWeight || t2 && t2.getShallow("fontWeight") || "", (a.fontSize || t2 && t2.getShallow("fontSize") || 12) + "px", a.fontFamily || t2 && t2.getShallow("fontFamily") || "sans-serif"].join(" "));
    }
    var qD = Xo();
    function ece(a, r6, t2, s) {
      if (a) {
        var u = qD(a);
        u.prevValue = u.value, u.value = t2;
        var f6 = r6.normal;
        u.valueAnimation = f6.get("valueAnimation"), u.valueAnimation && (u.precision = f6.get("precision"), u.defaultInterpolatedText = s, u.statesModels = r6);
      }
    }
    function tce(a, r6, t2, s, u) {
      var f6 = qD(a);
      if (!f6.valueAnimation || f6.prevValue === f6.value)
        return;
      var d6 = f6.defaultInterpolatedText, v6 = qi(f6.interpolatedValue, f6.prevValue), m6 = f6.value;
      function b6(x6) {
        var S = fO(t2, f6.precision, v6, m6, x6);
        f6.interpolatedValue = x6 === 1 ? null : S;
        var M = MY({ labelDataIndex: r6, labelFetcher: u, defaultText: d6 ? d6(S) : S + "" }, f6.statesModels, S);
        Yue(a, M);
      }
      a.percent = 0, (f6.prevValue == null ? zu : fs)(a, { percent: 1 }, s, r6, null, b6);
    }
    var uOe = ["textStyle", "color"], AY = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], EY = new ms(), cOe = function() {
      function a() {
      }
      return a.prototype.getTextColor = function(r6) {
        var t2 = this.ecModel;
        return this.getShallow("color") || (!r6 && t2 ? t2.get(uOe) : null);
      }, a.prototype.getFont = function() {
        return Que({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
      }, a.prototype.getTextRect = function(r6) {
        for (var t2 = { text: r6, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, s = 0; s < AY.length; s++)
          t2[AY[s]] = this.getShallow(AY[s]);
        return EY.useStyle(t2), EY.update(), EY.getBoundingRect();
      }, a;
    }(), fOe = cOe, nce = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], hOe = Mx(nce), dOe = function() {
      function a() {
      }
      return a.prototype.getLineStyle = function(r6) {
        return hOe(this, r6);
      }, a;
    }(), rce = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], pOe = Mx(rce), vOe = function() {
      function a() {
      }
      return a.prototype.getItemStyle = function(r6, t2) {
        return pOe(this, r6, t2);
      }, a;
    }(), oA = function() {
      function a(r6, t2, s) {
        this.parentModel = t2, this.ecModel = s, this.option = r6;
      }
      return a.prototype.init = function(r6, t2, s) {
        for (var u = [], f6 = 3; f6 < arguments.length; f6++)
          u[f6 - 3] = arguments[f6];
      }, a.prototype.mergeOption = function(r6, t2) {
        Di(this.option, r6, true);
      }, a.prototype.get = function(r6, t2) {
        return r6 == null ? this.option : this._doGet(this.parsePath(r6), !t2 && this.parentModel);
      }, a.prototype.getShallow = function(r6, t2) {
        var s = this.option, u = s == null ? s : s[r6];
        if (u == null && !t2) {
          var f6 = this.parentModel;
          f6 && (u = f6.getShallow(r6));
        }
        return u;
      }, a.prototype.getModel = function(r6, t2) {
        var s = r6 != null, u = s ? this.parsePath(r6) : null, f6 = s ? this._doGet(u) : this.option;
        return t2 = t2 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(u)), new a(f6, t2, this.ecModel);
      }, a.prototype.isEmpty = function() {
        return this.option == null;
      }, a.prototype.restoreData = function() {
      }, a.prototype.clone = function() {
        var r6 = this.constructor;
        return new r6(Qa(this.option));
      }, a.prototype.parsePath = function(r6) {
        return typeof r6 == "string" ? r6.split(".") : r6;
      }, a.prototype.resolveParentPath = function(r6) {
        return r6;
      }, a.prototype.isAnimationEnabled = function() {
        if (!ha.node && this.option) {
          if (this.option.animation != null)
            return !!this.option.animation;
          if (this.parentModel)
            return this.parentModel.isAnimationEnabled();
        }
      }, a.prototype._doGet = function(r6, t2) {
        var s = this.option;
        if (!r6)
          return s;
        for (var u = 0; u < r6.length && !(!!r6[u] && (s = s && typeof s == "object" ? s[r6[u]] : null, s == null)); u++)
          ;
        return s == null && t2 && (s = t2._doGet(this.resolveParentPath(r6), t2.parentModel)), s;
      }, a;
    }();
    gD(oA), Cx(oA), Dc(oA, dOe), Dc(oA, vOe), Dc(oA, uq), Dc(oA, fOe);
    var yu = oA, gOe = Math.round(Math.random() * 10);
    function YD(a) {
      return [a || "", gOe++].join("_");
    }
    function mOe(a) {
      var r6 = {};
      a.registerSubTypeDefaulter = function(t2, s) {
        var u = Lp(t2);
        r6[u.main] = s;
      }, a.determineSubType = function(t2, s) {
        var u = s.type;
        if (!u) {
          var f6 = Lp(t2).main;
          a.hasSubTypes(t2) && r6[f6] && (u = r6[f6](s));
        }
        return u;
      };
    }
    function yOe(a, r6) {
      a.topologicalTravel = function(f6, d6, v6, m6) {
        if (!f6.length)
          return;
        var b6 = t2(d6), x6 = b6.graph, S = b6.noEntryList, M = {};
        for (Ne(f6, function($) {
          M[$] = true;
        }); S.length; ) {
          var A6 = S.pop(), I = x6[A6], R = !!M[A6];
          R && (v6.call(m6, A6, I.originalDeps.slice()), delete M[A6]), Ne(I.successor, R ? j : F);
        }
        Ne(M, function() {
          var $ = "";
          throw new Error($);
        });
        function F($) {
          x6[$].entryCount--, x6[$].entryCount === 0 && S.push($);
        }
        function j($) {
          M[$] = true, F($);
        }
      };
      function t2(f6) {
        var d6 = {}, v6 = [];
        return Ne(f6, function(m6) {
          var b6 = s(d6, m6), x6 = b6.originalDeps = r6(m6), S = u(x6, f6);
          b6.entryCount = S.length, b6.entryCount === 0 && v6.push(m6), Ne(S, function(M) {
            Vi(b6.predecessor, M) < 0 && b6.predecessor.push(M);
            var A6 = s(d6, M);
            Vi(A6.successor, M) < 0 && A6.successor.push(m6);
          });
        }), { graph: d6, noEntryList: v6 };
      }
      function s(f6, d6) {
        return f6[d6] || (f6[d6] = { predecessor: [], successor: [] }), f6[d6];
      }
      function u(f6, d6) {
        var v6 = [];
        return Ne(f6, function(m6) {
          Vi(d6, m6) >= 0 && v6.push(m6);
        }), v6;
      }
    }
    function Y2(a, r6) {
      return Di(Di({}, a, true), r6, true);
    }
    var bOe = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, _Oe = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, tV = "ZH", IY = "EN", hR = IY, nV = {}, TY = {}, ace = ha.domSupported ? function() {
      var a = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
      return a.indexOf(tV) > -1 ? tV : hR;
    }() : hR;
    function ice(a, r6) {
      a = a.toUpperCase(), TY[a] = new yu(r6), nV[a] = r6;
    }
    function xOe(a) {
      if (_a2(a)) {
        var r6 = nV[a.toUpperCase()] || {};
        return a === tV || a === IY ? Qa(r6) : Di(Qa(r6), Qa(nV[hR]), false);
      } else
        return Di(Qa(a), Qa(nV[hR]), false);
    }
    function DY(a) {
      return TY[a];
    }
    function wOe() {
      return TY[hR];
    }
    ice(IY, bOe), ice(tV, _Oe);
    var kY = 1e3, PY = kY * 60, dR = PY * 60, Dm = dR * 24, oce = Dm * 365, pR = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, rV = "{yyyy}-{MM}-{dd}", sce = { year: "{yyyy}", month: "{yyyy}-{MM}", day: rV, hour: rV + " " + pR.hour, minute: rV + " " + pR.minute, second: rV + " " + pR.second, millisecond: pR.none }, LY = ["year", "month", "day", "hour", "minute", "second", "millisecond"], lce = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
    function sA(a, r6) {
      return a += "", "0000".substr(0, r6 - a.length) + a;
    }
    function ZD(a) {
      switch (a) {
        case "half-year":
        case "quarter":
          return "month";
        case "week":
        case "half-week":
          return "day";
        case "half-day":
        case "quarter-day":
          return "hour";
        default:
          return a;
      }
    }
    function SOe(a) {
      return a === ZD(a);
    }
    function COe(a) {
      switch (a) {
        case "year":
        case "month":
          return "day";
        case "millisecond":
          return "millisecond";
        default:
          return "second";
      }
    }
    function aV(a, r6, t2, s) {
      var u = s0(a), f6 = u[OY(t2)](), d6 = u[XD(t2)]() + 1, v6 = Math.floor((d6 - 1) / 4) + 1, m6 = u[iV(t2)](), b6 = u["get" + (t2 ? "UTC" : "") + "Day"](), x6 = u[vR(t2)](), S = (x6 - 1) % 12 + 1, M = u[oV(t2)](), A6 = u[sV(t2)](), I = u[lV(t2)](), R = s instanceof yu ? s : DY(s || ace) || wOe(), F = R.getModel("time"), j = F.get("month"), $ = F.get("monthAbbr"), K = F.get("dayOfWeek"), U = F.get("dayOfWeekAbbr");
      return (r6 || "").replace(/{yyyy}/g, f6 + "").replace(/{yy}/g, f6 % 100 + "").replace(/{Q}/g, v6 + "").replace(/{MMMM}/g, j[d6 - 1]).replace(/{MMM}/g, $[d6 - 1]).replace(/{MM}/g, sA(d6, 2)).replace(/{M}/g, d6 + "").replace(/{dd}/g, sA(m6, 2)).replace(/{d}/g, m6 + "").replace(/{eeee}/g, K[b6]).replace(/{ee}/g, U[b6]).replace(/{e}/g, b6 + "").replace(/{HH}/g, sA(x6, 2)).replace(/{H}/g, x6 + "").replace(/{hh}/g, sA(S + "", 2)).replace(/{h}/g, S + "").replace(/{mm}/g, sA(M, 2)).replace(/{m}/g, M + "").replace(/{ss}/g, sA(A6, 2)).replace(/{s}/g, A6 + "").replace(/{SSS}/g, sA(I, 3)).replace(/{S}/g, I + "");
    }
    function MOe(a, r6, t2, s, u) {
      var f6 = null;
      if (_a2(t2))
        f6 = t2;
      else if (ti(t2))
        f6 = t2(a.value, r6, { level: a.level });
      else {
        var d6 = qn({}, pR);
        if (a.level > 0)
          for (var v6 = 0; v6 < LY.length; ++v6)
            d6[LY[v6]] = "{primary|" + d6[LY[v6]] + "}";
        var m6 = t2 ? t2.inherit === false ? t2 : ei(t2, d6) : d6, b6 = uce(a.value, u);
        if (m6[b6])
          f6 = m6[b6];
        else if (m6.inherit) {
          for (var x6 = lce.indexOf(b6), v6 = x6 - 1; v6 >= 0; --v6)
            if (m6[b6]) {
              f6 = m6[b6];
              break;
            }
          f6 = f6 || d6.none;
        }
        if (br(f6)) {
          var S = a.level == null ? 0 : a.level >= 0 ? a.level : f6.length + a.level;
          S = Math.min(S, f6.length - 1), f6 = f6[S];
        }
      }
      return aV(new Date(a.value), f6, u, s);
    }
    function uce(a, r6) {
      var t2 = s0(a), s = t2[XD(r6)]() + 1, u = t2[iV(r6)](), f6 = t2[vR(r6)](), d6 = t2[oV(r6)](), v6 = t2[sV(r6)](), m6 = t2[lV(r6)](), b6 = m6 === 0, x6 = b6 && v6 === 0, S = x6 && d6 === 0, M = S && f6 === 0, A6 = M && u === 1, I = A6 && s === 1;
      return I ? "year" : A6 ? "month" : M ? "day" : S ? "hour" : x6 ? "minute" : b6 ? "second" : "millisecond";
    }
    function cce(a, r6, t2) {
      var s = ks(a) ? s0(a) : a;
      switch (r6 = r6 || uce(a, t2), r6) {
        case "year":
          return s[OY(t2)]();
        case "half-year":
          return s[XD(t2)]() >= 6 ? 1 : 0;
        case "quarter":
          return Math.floor((s[XD(t2)]() + 1) / 4);
        case "month":
          return s[XD(t2)]();
        case "day":
          return s[iV(t2)]();
        case "half-day":
          return s[vR(t2)]() / 24;
        case "hour":
          return s[vR(t2)]();
        case "minute":
          return s[oV(t2)]();
        case "second":
          return s[sV(t2)]();
        case "millisecond":
          return s[lV(t2)]();
      }
    }
    function OY(a) {
      return a ? "getUTCFullYear" : "getFullYear";
    }
    function XD(a) {
      return a ? "getUTCMonth" : "getMonth";
    }
    function iV(a) {
      return a ? "getUTCDate" : "getDate";
    }
    function vR(a) {
      return a ? "getUTCHours" : "getHours";
    }
    function oV(a) {
      return a ? "getUTCMinutes" : "getMinutes";
    }
    function sV(a) {
      return a ? "getUTCSeconds" : "getSeconds";
    }
    function lV(a) {
      return a ? "getUTCMilliseconds" : "getMilliseconds";
    }
    function AOe(a) {
      return a ? "setUTCFullYear" : "setFullYear";
    }
    function fce(a) {
      return a ? "setUTCMonth" : "setMonth";
    }
    function hce(a) {
      return a ? "setUTCDate" : "setDate";
    }
    function dce(a) {
      return a ? "setUTCHours" : "setHours";
    }
    function pce(a) {
      return a ? "setUTCMinutes" : "setMinutes";
    }
    function vce(a) {
      return a ? "setUTCSeconds" : "setSeconds";
    }
    function gce(a) {
      return a ? "setUTCMilliseconds" : "setMilliseconds";
    }
    function mce(a) {
      if (!H9(a))
        return _a2(a) ? a : "-";
      var r6 = (a + "").split(".");
      return r6[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (r6.length > 1 ? "." + r6[1] : "");
    }
    function yce(a, r6) {
      return a = (a || "").toLowerCase().replace(/-(.)/g, function(t2, s) {
        return s.toUpperCase();
      }), r6 && a && (a = a.charAt(0).toUpperCase() + a.slice(1)), a;
    }
    var KD = DT, EOe = /([&<>"'])/g, IOe = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
    function h0(a) {
      return a == null ? "" : (a + "").replace(EOe, function(r6, t2) {
        return IOe[t2];
      });
    }
    function RY(a, r6, t2) {
      var s = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
      function u(x6) {
        return x6 && mu(x6) ? x6 : "-";
      }
      function f6(x6) {
        return !!(x6 != null && !isNaN(x6) && isFinite(x6));
      }
      var d6 = r6 === "time", v6 = a instanceof Date;
      if (d6 || v6) {
        var m6 = d6 ? s0(a) : a;
        if (isNaN(+m6)) {
          if (v6)
            return "-";
        } else
          return aV(m6, s, t2);
      }
      if (r6 === "ordinal")
        return fM(a) ? u(a) : ks(a) && f6(a) ? a + "" : "-";
      var b6 = mm(a);
      return f6(b6) ? mce(b6) : fM(a) ? u(a) : typeof a == "boolean" ? a + "" : "-";
    }
    var bce = ["a", "b", "c", "d", "e", "f", "g"], FY = function(a, r6) {
      return "{" + a + (r6 == null ? "" : r6) + "}";
    };
    function _ce(a, r6, t2) {
      br(r6) || (r6 = [r6]);
      var s = r6.length;
      if (!s)
        return "";
      for (var u = r6[0].$vars || [], f6 = 0; f6 < u.length; f6++) {
        var d6 = bce[f6];
        a = a.replace(FY(d6), FY(d6, 0));
      }
      for (var v6 = 0; v6 < s; v6++)
        for (var m6 = 0; m6 < u.length; m6++) {
          var b6 = r6[v6][u[m6]];
          a = a.replace(FY(bce[m6], v6), t2 ? h0(b6) : b6);
        }
      return a;
    }
    function TOe(a, r6, t2) {
      return Ne(r6, function(s, u) {
        a = a.replace("{" + u + "}", t2 ? h0(s) : s);
      }), a;
    }
    function DOe(a, r6) {
      var t2 = _a2(a) ? { color: a, extraCssText: r6 } : a || {}, s = t2.color, u = t2.type;
      r6 = t2.extraCssText;
      var f6 = t2.renderMode || "html";
      if (!s)
        return "";
      if (f6 === "html")
        return u === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + h0(s) + ";" + (r6 || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + h0(s) + ";" + (r6 || "") + '"></span>';
      var d6 = t2.markerId || "markerX";
      return { renderMode: f6, content: "{" + d6 + "|}  ", style: u === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: s } : { width: 10, height: 10, borderRadius: 5, backgroundColor: s } };
    }
    function lA(a, r6) {
      return r6 = r6 || "transparent", _a2(a) ? a : ui(a) && a.colorStops && (a.colorStops[0] || {}).color || r6;
    }
    function uV(a, r6) {
      if (r6 === "_blank" || r6 === "blank") {
        var t2 = window.open();
        t2.opener = null, t2.location.href = a;
      } else
        window.open(a, r6);
    }
    var cV = Ne, xce = ["left", "right", "top", "bottom", "width", "height"], uA = [["width", "left", "right"], ["height", "top", "bottom"]];
    function NY(a, r6, t2, s, u) {
      var f6 = 0, d6 = 0;
      s == null && (s = 1 / 0), u == null && (u = 1 / 0);
      var v6 = 0;
      r6.eachChild(function(m6, b6) {
        var x6 = m6.getBoundingRect(), S = r6.childAt(b6 + 1), M = S && S.getBoundingRect(), A6, I;
        if (a === "horizontal") {
          var R = x6.width + (M ? -M.x + x6.x : 0);
          A6 = f6 + R, A6 > s || m6.newline ? (f6 = 0, A6 = R, d6 += v6 + t2, v6 = x6.height) : v6 = Math.max(v6, x6.height);
        } else {
          var F = x6.height + (M ? -M.y + x6.y : 0);
          I = d6 + F, I > u || m6.newline ? (f6 += v6 + t2, d6 = 0, I = F, v6 = x6.width) : v6 = Math.max(v6, x6.width);
        }
        m6.newline || (m6.x = f6, m6.y = d6, m6.markRedraw(), a === "horizontal" ? f6 = A6 + t2 : d6 = I + t2);
      });
    }
    var cA = NY;
    Oi(NY, "vertical"), Oi(NY, "horizontal");
    function kOe(a, r6, t2) {
      var s = r6.width, u = r6.height, f6 = ua(a.left, s), d6 = ua(a.top, u), v6 = ua(a.right, s), m6 = ua(a.bottom, u);
      return (isNaN(f6) || isNaN(parseFloat(a.left))) && (f6 = 0), (isNaN(v6) || isNaN(parseFloat(a.right))) && (v6 = s), (isNaN(d6) || isNaN(parseFloat(a.top))) && (d6 = 0), (isNaN(m6) || isNaN(parseFloat(a.bottom))) && (m6 = u), t2 = KD(t2 || 0), { width: Math.max(v6 - f6 - t2[1] - t2[3], 0), height: Math.max(m6 - d6 - t2[0] - t2[2], 0) };
    }
    function ah(a, r6, t2) {
      t2 = KD(t2 || 0);
      var s = r6.width, u = r6.height, f6 = ua(a.left, s), d6 = ua(a.top, u), v6 = ua(a.right, s), m6 = ua(a.bottom, u), b6 = ua(a.width, s), x6 = ua(a.height, u), S = t2[2] + t2[0], M = t2[1] + t2[3], A6 = a.aspect;
      switch (isNaN(b6) && (b6 = s - v6 - M - f6), isNaN(x6) && (x6 = u - m6 - S - d6), A6 != null && (isNaN(b6) && isNaN(x6) && (A6 > s / u ? b6 = s * 0.8 : x6 = u * 0.8), isNaN(b6) && (b6 = A6 * x6), isNaN(x6) && (x6 = b6 / A6)), isNaN(f6) && (f6 = s - v6 - b6 - M), isNaN(d6) && (d6 = u - m6 - x6 - S), a.left || a.right) {
        case "center":
          f6 = s / 2 - b6 / 2 - t2[3];
          break;
        case "right":
          f6 = s - b6 - M;
          break;
      }
      switch (a.top || a.bottom) {
        case "middle":
        case "center":
          d6 = u / 2 - x6 / 2 - t2[0];
          break;
        case "bottom":
          d6 = u - x6 - S;
          break;
      }
      f6 = f6 || 0, d6 = d6 || 0, isNaN(b6) && (b6 = s - M - f6 - (v6 || 0)), isNaN(x6) && (x6 = u - S - d6 - (m6 || 0));
      var I = new Qi(f6 + t2[3], d6 + t2[0], b6, x6);
      return I.margin = t2, I;
    }
    function fV(a, r6, t2, s, u, f6) {
      var d6 = !u || !u.hv || u.hv[0], v6 = !u || !u.hv || u.hv[1], m6 = u && u.boundingMode || "all";
      if (f6 = f6 || a, f6.x = a.x, f6.y = a.y, !d6 && !v6)
        return false;
      var b6;
      if (m6 === "raw")
        b6 = a.type === "group" ? new Qi(0, 0, +r6.width || 0, +r6.height || 0) : a.getBoundingRect();
      else if (b6 = a.getBoundingRect(), a.needLocalTransform()) {
        var x6 = a.getLocalTransform();
        b6 = b6.clone(), b6.applyTransform(x6);
      }
      var S = ah(ei({ width: b6.width, height: b6.height }, r6), t2, s), M = d6 ? S.x - b6.x : 0, A6 = v6 ? S.y - b6.y : 0;
      return m6 === "raw" ? (f6.x = M, f6.y = A6) : (f6.x += M, f6.y += A6), f6 === a && a.markRedraw(), true;
    }
    function POe(a, r6) {
      return a[uA[r6][0]] != null || a[uA[r6][1]] != null && a[uA[r6][2]] != null;
    }
    function gR(a) {
      var r6 = a.layoutMode || a.constructor.layoutMode;
      return ui(r6) ? r6 : r6 ? { type: r6 } : null;
    }
    function Z2(a, r6, t2) {
      var s = t2 && t2.ignoreSize;
      !br(s) && (s = [s, s]);
      var u = d6(uA[0], 0), f6 = d6(uA[1], 1);
      b6(uA[0], a, u), b6(uA[1], a, f6);
      function d6(x6, S) {
        var M = {}, A6 = 0, I = {}, R = 0, F = 2;
        if (cV(x6, function(K) {
          I[K] = a[K];
        }), cV(x6, function(K) {
          v6(r6, K) && (M[K] = I[K] = r6[K]), m6(M, K) && A6++, m6(I, K) && R++;
        }), s[S])
          return m6(r6, x6[1]) ? I[x6[2]] = null : m6(r6, x6[2]) && (I[x6[1]] = null), I;
        if (R === F || !A6)
          return I;
        if (A6 >= F)
          return M;
        for (var j = 0; j < x6.length; j++) {
          var $ = x6[j];
          if (!v6(M, $) && v6(a, $)) {
            M[$] = a[$];
            break;
          }
        }
        return M;
      }
      function v6(x6, S) {
        return x6.hasOwnProperty(S);
      }
      function m6(x6, S) {
        return x6[S] != null && x6[S] !== "auto";
      }
      function b6(x6, S, M) {
        cV(x6, function(A6) {
          S[A6] = M[A6];
        });
      }
    }
    function JD(a) {
      return wce({}, a);
    }
    function wce(a, r6) {
      return r6 && a && cV(xce, function(t2) {
        r6.hasOwnProperty(t2) && (a[t2] = r6[t2]);
      }), a;
    }
    var LOe = Xo(), QD = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this, t2, s, u) || this;
        return f6.uid = YD("ec_cpt_model"), f6;
      }
      return r6.prototype.init = function(t2, s, u) {
        this.mergeDefaultAndTheme(t2, u);
      }, r6.prototype.mergeDefaultAndTheme = function(t2, s) {
        var u = gR(this), f6 = u ? JD(t2) : {}, d6 = s.getTheme();
        Di(t2, d6.get(this.mainType)), Di(t2, this.getDefaultOption()), u && Z2(t2, f6, u);
      }, r6.prototype.mergeOption = function(t2, s) {
        Di(this.option, t2, true);
        var u = gR(this);
        u && Z2(this.option, t2, u);
      }, r6.prototype.optionUpdated = function(t2, s) {
      }, r6.prototype.getDefaultOption = function() {
        var t2 = this.constructor;
        if (!X9(t2))
          return t2.defaultOption;
        var s = LOe(this);
        if (!s.defaultOption) {
          for (var u = [], f6 = t2; f6; ) {
            var d6 = f6.prototype.defaultOption;
            d6 && u.push(d6), f6 = f6.superClass;
          }
          for (var v6 = {}, m6 = u.length - 1; m6 >= 0; m6--)
            v6 = Di(v6, u[m6], true);
          s.defaultOption = v6;
        }
        return s.defaultOption;
      }, r6.prototype.getReferringComponents = function(t2, s) {
        var u = t2 + "Index", f6 = t2 + "Id";
        return $M(this.ecModel, t2, { index: this.get(u, true), id: this.get(f6, true) }, s);
      }, r6.prototype.getBoxLayoutParams = function() {
        var t2 = this;
        return { left: t2.get("left"), top: t2.get("top"), right: t2.get("right"), bottom: t2.get("bottom"), width: t2.get("width"), height: t2.get("height") };
      }, r6.prototype.getZLevelKey = function() {
        return "";
      }, r6.prototype.setZLevel = function(t2) {
        this.option.zlevel = t2;
      }, r6.protoInitialize = function() {
        var t2 = r6.prototype;
        t2.type = "component", t2.id = "", t2.name = "", t2.mainType = "", t2.subType = "", t2.componentIndex = 0;
      }(), r6;
    }(yu);
    pO(QD, yu), yD(QD), mOe(QD), yOe(QD, OOe);
    function OOe(a) {
      var r6 = [];
      return Ne(QD.getClassesByMainType(a), function(t2) {
        r6 = r6.concat(t2.dependencies || t2.prototype.dependencies || []);
      }), r6 = wr(r6, function(t2) {
        return Lp(t2).main;
      }), a !== "dataset" && Vi(r6, "dataset") <= 0 && r6.unshift("dataset"), r6;
    }
    var Ps = QD, Sce = "";
    typeof navigator != "undefined" && (Sce = navigator.platform || "");
    var e5 = "rgba(0, 0, 0, 0.2)", ROe = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: e5, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: e5, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: e5, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: e5, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: e5, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: e5, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: Sce.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, Cce = Ta(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), km = "original", jp = "arrayRows", Pm = "objectRows", Rb = "keyedColumns", X2 = "typedArray", Mce = "unknown", Fb = "column", t5 = "row", rp = { Must: 1, Might: 2, Not: 3 }, Ace = Xo();
    function FOe(a) {
      Ace(a).datasetMap = Ta();
    }
    function Ece(a, r6, t2) {
      var s = {}, u = zY(r6);
      if (!u || !a)
        return s;
      var f6 = [], d6 = [], v6 = r6.ecModel, m6 = Ace(v6).datasetMap, b6 = u.uid + "_" + t2.seriesLayoutBy, x6, S;
      a = a.slice(), Ne(a, function(R, F) {
        var j = ui(R) ? R : a[F] = { name: R };
        j.type === "ordinal" && x6 == null && (x6 = F, S = I(j)), s[j.name] = [];
      });
      var M = m6.get(b6) || m6.set(b6, { categoryWayDim: S, valueWayDim: 0 });
      Ne(a, function(R, F) {
        var j = R.name, $ = I(R);
        if (x6 == null) {
          var K = M.valueWayDim;
          A6(s[j], K, $), A6(d6, K, $), M.valueWayDim += $;
        } else if (x6 === F)
          A6(s[j], 0, $), A6(f6, 0, $);
        else {
          var K = M.categoryWayDim;
          A6(s[j], K, $), A6(d6, K, $), M.categoryWayDim += $;
        }
      });
      function A6(R, F, j) {
        for (var $ = 0; $ < j; $++)
          R.push(F + $);
      }
      function I(R) {
        var F = R.dimsDef;
        return F ? F.length : 1;
      }
      return f6.length && (s.itemName = f6), d6.length && (s.seriesName = d6), s;
    }
    function VY(a, r6, t2) {
      var s = {}, u = zY(a);
      if (!u)
        return s;
      var f6 = r6.sourceFormat, d6 = r6.dimensionsDefine, v6;
      (f6 === Pm || f6 === Rb) && Ne(d6, function(x6, S) {
        (ui(x6) ? x6.name : x6) === "name" && (v6 = S);
      });
      var m6 = function() {
        for (var x6 = {}, S = {}, M = [], A6 = 0, I = Math.min(5, t2); A6 < I; A6++) {
          var R = Tce(r6.data, f6, r6.seriesLayoutBy, d6, r6.startIndex, A6);
          M.push(R);
          var F = R === rp.Not;
          if (F && x6.v == null && A6 !== v6 && (x6.v = A6), (x6.n == null || x6.n === x6.v || !F && M[x6.n] === rp.Not) && (x6.n = A6), j(x6) && M[x6.n] !== rp.Not)
            return x6;
          F || (R === rp.Might && S.v == null && A6 !== v6 && (S.v = A6), (S.n == null || S.n === S.v) && (S.n = A6));
        }
        function j($) {
          return $.v != null && $.n != null;
        }
        return j(x6) ? x6 : j(S) ? S : null;
      }();
      if (m6) {
        s.value = [m6.v];
        var b6 = v6 != null ? v6 : m6.n;
        s.itemName = [b6], s.seriesName = [b6];
      }
      return s;
    }
    function zY(a) {
      var r6 = a.get("data", true);
      if (!r6)
        return $M(a.ecModel, "dataset", { index: a.get("datasetIndex", true), id: a.get("datasetId", true) }, Lc).models[0];
    }
    function NOe(a) {
      return !a.get("transform", true) && !a.get("fromTransformResult", true) ? [] : $M(a.ecModel, "dataset", { index: a.get("fromDatasetIndex", true), id: a.get("fromDatasetId", true) }, Lc).models;
    }
    function Ice(a, r6) {
      return Tce(a.data, a.sourceFormat, a.seriesLayoutBy, a.dimensionsDefine, a.startIndex, r6);
    }
    function Tce(a, r6, t2, s, u, f6) {
      var d6, v6 = 5;
      if (_v(a))
        return rp.Not;
      var m6, b6;
      if (s) {
        var x6 = s[f6];
        ui(x6) ? (m6 = x6.name, b6 = x6.type) : _a2(x6) && (m6 = x6);
      }
      if (b6 != null)
        return b6 === "ordinal" ? rp.Must : rp.Not;
      if (r6 === jp) {
        var S = a;
        if (t2 === t5) {
          for (var M = S[f6], A6 = 0; A6 < (M || []).length && A6 < v6; A6++)
            if ((d6 = U(M[u + A6])) != null)
              return d6;
        } else
          for (var A6 = 0; A6 < S.length && A6 < v6; A6++) {
            var I = S[u + A6];
            if (I && (d6 = U(I[f6])) != null)
              return d6;
          }
      } else if (r6 === Pm) {
        var R = a;
        if (!m6)
          return rp.Not;
        for (var A6 = 0; A6 < R.length && A6 < v6; A6++) {
          var F = R[A6];
          if (F && (d6 = U(F[m6])) != null)
            return d6;
        }
      } else if (r6 === Rb) {
        var j = a;
        if (!m6)
          return rp.Not;
        var M = j[m6];
        if (!M || _v(M))
          return rp.Not;
        for (var A6 = 0; A6 < M.length && A6 < v6; A6++)
          if ((d6 = U(M[A6])) != null)
            return d6;
      } else if (r6 === km)
        for (var $ = a, A6 = 0; A6 < $.length && A6 < v6; A6++) {
          var F = $[A6], K = n1(F);
          if (!br(K))
            return rp.Not;
          if ((d6 = U(K[f6])) != null)
            return d6;
        }
      function U(he) {
        var ue = _a2(he);
        if (he != null && isFinite(he) && he !== "")
          return ue ? rp.Might : rp.Not;
        if (ue && he !== "-")
          return rp.Must;
      }
      return rp.Not;
    }
    var BY = Ta();
    function VOe(a, r6) {
      Hd(BY.get(a) == null && r6), BY.set(a, r6);
    }
    function zOe(a, r6, t2) {
      var s = BY.get(r6);
      if (!s)
        return t2;
      var u = s(a);
      return u ? t2.concat(u) : t2;
    }
    var Dce = Xo(), BOe = Xo(), jY = function() {
      function a() {
      }
      return a.prototype.getColorFromPalette = function(r6, t2, s) {
        var u = ll(this.get("color", true)), f6 = this.get("colorLayer", true);
        return kce(this, Dce, u, f6, r6, t2, s);
      }, a.prototype.clearColorPalette = function() {
        GOe(this, Dce);
      }, a;
    }();
    function GY(a, r6, t2, s) {
      var u = ll(a.get(["aria", "decal", "decals"]));
      return kce(a, BOe, u, null, r6, t2, s);
    }
    function jOe(a, r6) {
      for (var t2 = a.length, s = 0; s < t2; s++)
        if (a[s].length > r6)
          return a[s];
      return a[t2 - 1];
    }
    function kce(a, r6, t2, s, u, f6, d6) {
      f6 = f6 || a;
      var v6 = r6(f6), m6 = v6.paletteIdx || 0, b6 = v6.paletteNameMap = v6.paletteNameMap || {};
      if (b6.hasOwnProperty(u))
        return b6[u];
      var x6 = d6 == null || !s ? t2 : jOe(s, d6);
      if (x6 = x6 || t2, !(!x6 || !x6.length)) {
        var S = x6[m6];
        return u && (b6[u] = S), v6.paletteIdx = (m6 + 1) % x6.length, S;
      }
    }
    function GOe(a, r6) {
      r6(a).paletteIdx = 0, r6(a).paletteNameMap = {};
    }
    var hV, mR, Pce, Lce = "\0_ec_inner", WOe = 1, Oce = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.init = function(t2, s, u, f6, d6, v6) {
        f6 = f6 || {}, this.option = null, this._theme = new yu(f6), this._locale = new yu(d6), this._optionManager = v6;
      }, r6.prototype.setOption = function(t2, s, u) {
        var f6 = Nce(s);
        this._optionManager.setOption(t2, u, f6), this._resetOption(null, f6);
      }, r6.prototype.resetOption = function(t2, s) {
        return this._resetOption(t2, Nce(s));
      }, r6.prototype._resetOption = function(t2, s) {
        var u = false, f6 = this._optionManager;
        if (!t2 || t2 === "recreate") {
          var d6 = f6.mountOption(t2 === "recreate");
          !this.option || t2 === "recreate" ? Pce(this, d6) : (this.restoreData(), this._mergeOption(d6, s)), u = true;
        }
        if ((t2 === "timeline" || t2 === "media") && this.restoreData(), !t2 || t2 === "recreate" || t2 === "timeline") {
          var v6 = f6.getTimelineOption(this);
          v6 && (u = true, this._mergeOption(v6, s));
        }
        if (!t2 || t2 === "recreate" || t2 === "media") {
          var m6 = f6.getMediaOption(this);
          m6.length && Ne(m6, function(b6) {
            u = true, this._mergeOption(b6, s);
          }, this);
        }
        return u;
      }, r6.prototype.mergeOption = function(t2) {
        this._mergeOption(t2, null);
      }, r6.prototype._mergeOption = function(t2, s) {
        var u = this.option, f6 = this._componentsMap, d6 = this._componentsCount, v6 = [], m6 = Ta(), b6 = s && s.replaceMergeMainTypeMap;
        FOe(this), Ne(t2, function(S, M) {
          S != null && (Ps.hasClass(M) ? M && (v6.push(M), m6.set(M, true)) : u[M] = u[M] == null ? Qa(S) : Di(u[M], S, true));
        }), b6 && b6.each(function(S, M) {
          Ps.hasClass(M) && !m6.get(M) && (v6.push(M), m6.set(M, true));
        }), Ps.topologicalTravel(v6, Ps.getAllClassMainTypes(), x6, this);
        function x6(S) {
          var M = zOe(this, S, ll(t2[S])), A6 = f6.get(S), I = A6 ? b6 && b6.get(S) ? "replaceMerge" : "normalMerge" : "replaceAll", R = Mb(A6, M, I);
          r1(R, S, Ps), u[S] = null, f6.set(S, null), d6.set(S, 0);
          var F = [], j = [], $ = 0, K;
          Ne(R, function(U, he) {
            var ue = U.existing, pe = U.newOption;
            if (!pe)
              ue && (ue.mergeOption({}, this), ue.optionUpdated({}, false));
            else {
              var _e = S === "series", xe = Ps.getClass(S, U.keyInfo.subType, !_e);
              if (!xe)
                return;
              if (S === "tooltip") {
                if (K)
                  return;
                K = true;
              }
              if (ue && ue.constructor === xe)
                ue.name = U.keyInfo.name, ue.mergeOption(pe, this), ue.optionUpdated(pe, false);
              else {
                var Ae = qn({ componentIndex: he }, U.keyInfo);
                ue = new xe(pe, this, this, Ae), qn(ue, Ae), U.brandNew && (ue.__requireNewView = true), ue.init(pe, this, this), ue.optionUpdated(null, true);
              }
            }
            ue ? (F.push(ue.option), j.push(ue), $++) : (F.push(void 0), j.push(void 0));
          }, this), u[S] = F, f6.set(S, j), d6.set(S, $), S === "series" && hV(this);
        }
        this._seriesIndices || hV(this);
      }, r6.prototype.getOption = function() {
        var t2 = Qa(this.option);
        return Ne(t2, function(s, u) {
          if (Ps.hasClass(u)) {
            for (var f6 = ll(s), d6 = f6.length, v6 = false, m6 = d6 - 1; m6 >= 0; m6--)
              f6[m6] && !WM(f6[m6]) ? v6 = true : (f6[m6] = null, !v6 && d6--);
            f6.length = d6, t2[u] = f6;
          }
        }), delete t2[Lce], t2;
      }, r6.prototype.getTheme = function() {
        return this._theme;
      }, r6.prototype.getLocaleModel = function() {
        return this._locale;
      }, r6.prototype.setUpdatePayload = function(t2) {
        this._payload = t2;
      }, r6.prototype.getUpdatePayload = function() {
        return this._payload;
      }, r6.prototype.getComponent = function(t2, s) {
        var u = this._componentsMap.get(t2);
        if (u) {
          var f6 = u[s || 0];
          if (f6)
            return f6;
          if (s == null) {
            for (var d6 = 0; d6 < u.length; d6++)
              if (u[d6])
                return u[d6];
          }
        }
      }, r6.prototype.queryComponents = function(t2) {
        var s = t2.mainType;
        if (!s)
          return [];
        var u = t2.index, f6 = t2.id, d6 = t2.name, v6 = this._componentsMap.get(s);
        if (!v6 || !v6.length)
          return [];
        var m6;
        return u != null ? (m6 = [], Ne(ll(u), function(b6) {
          v6[b6] && m6.push(v6[b6]);
        })) : f6 != null ? m6 = Rce("id", f6, v6) : d6 != null ? m6 = Rce("name", d6, v6) : m6 = gl(v6, function(b6) {
          return !!b6;
        }), Fce(m6, t2);
      }, r6.prototype.findComponents = function(t2) {
        var s = t2.query, u = t2.mainType, f6 = v6(s), d6 = f6 ? this.queryComponents(f6) : gl(this._componentsMap.get(u), function(b6) {
          return !!b6;
        });
        return m6(Fce(d6, t2));
        function v6(b6) {
          var x6 = u + "Index", S = u + "Id", M = u + "Name";
          return b6 && (b6[x6] != null || b6[S] != null || b6[M] != null) ? { mainType: u, index: b6[x6], id: b6[S], name: b6[M] } : null;
        }
        function m6(b6) {
          return t2.filter ? gl(b6, t2.filter) : b6;
        }
      }, r6.prototype.eachComponent = function(t2, s, u) {
        var f6 = this._componentsMap;
        if (ti(t2)) {
          var d6 = s, v6 = t2;
          f6.each(function(S, M) {
            for (var A6 = 0; S && A6 < S.length; A6++) {
              var I = S[A6];
              I && v6.call(d6, M, I, I.componentIndex);
            }
          });
        } else
          for (var m6 = _a2(t2) ? f6.get(t2) : ui(t2) ? this.findComponents(t2) : null, b6 = 0; m6 && b6 < m6.length; b6++) {
            var x6 = m6[b6];
            x6 && s.call(u, x6, x6.componentIndex);
          }
      }, r6.prototype.getSeriesByName = function(t2) {
        var s = Zc(t2, null);
        return gl(this._componentsMap.get("series"), function(u) {
          return !!u && s != null && u.name === s;
        });
      }, r6.prototype.getSeriesByIndex = function(t2) {
        return this._componentsMap.get("series")[t2];
      }, r6.prototype.getSeriesByType = function(t2) {
        return gl(this._componentsMap.get("series"), function(s) {
          return !!s && s.subType === t2;
        });
      }, r6.prototype.getSeries = function() {
        return gl(this._componentsMap.get("series"), function(t2) {
          return !!t2;
        });
      }, r6.prototype.getSeriesCount = function() {
        return this._componentsCount.get("series");
      }, r6.prototype.eachSeries = function(t2, s) {
        mR(this), Ne(this._seriesIndices, function(u) {
          var f6 = this._componentsMap.get("series")[u];
          t2.call(s, f6, u);
        }, this);
      }, r6.prototype.eachRawSeries = function(t2, s) {
        Ne(this._componentsMap.get("series"), function(u) {
          u && t2.call(s, u, u.componentIndex);
        });
      }, r6.prototype.eachSeriesByType = function(t2, s, u) {
        mR(this), Ne(this._seriesIndices, function(f6) {
          var d6 = this._componentsMap.get("series")[f6];
          d6.subType === t2 && s.call(u, d6, f6);
        }, this);
      }, r6.prototype.eachRawSeriesByType = function(t2, s, u) {
        return Ne(this.getSeriesByType(t2), s, u);
      }, r6.prototype.isSeriesFiltered = function(t2) {
        return mR(this), this._seriesIndicesMap.get(t2.componentIndex) == null;
      }, r6.prototype.getCurrentSeriesIndices = function() {
        return (this._seriesIndices || []).slice();
      }, r6.prototype.filterSeries = function(t2, s) {
        mR(this);
        var u = [];
        Ne(this._seriesIndices, function(f6) {
          var d6 = this._componentsMap.get("series")[f6];
          t2.call(s, d6, f6) && u.push(f6);
        }, this), this._seriesIndices = u, this._seriesIndicesMap = Ta(u);
      }, r6.prototype.restoreData = function(t2) {
        hV(this);
        var s = this._componentsMap, u = [];
        s.each(function(f6, d6) {
          Ps.hasClass(d6) && u.push(d6);
        }), Ps.topologicalTravel(u, Ps.getAllClassMainTypes(), function(f6) {
          Ne(s.get(f6), function(d6) {
            d6 && (f6 !== "series" || !HOe(d6, t2)) && d6.restoreData();
          });
        });
      }, r6.internalField = function() {
        hV = function(t2) {
          var s = t2._seriesIndices = [];
          Ne(t2._componentsMap.get("series"), function(u) {
            u && s.push(u.componentIndex);
          }), t2._seriesIndicesMap = Ta(s);
        }, mR = function(t2) {
        }, Pce = function(t2, s) {
          t2.option = {}, t2.option[Lce] = WOe, t2._componentsMap = Ta({ series: [] }), t2._componentsCount = Ta();
          var u = s.aria;
          ui(u) && u.enabled == null && (u.enabled = true), $Oe(s, t2._theme.option), Di(s, ROe, false), t2._mergeOption(s, null);
        };
      }(), r6;
    }(yu);
    function HOe(a, r6) {
      if (r6) {
        var t2 = r6.seriesIndex, s = r6.seriesId, u = r6.seriesName;
        return t2 != null && a.componentIndex !== t2 || s != null && a.id !== s || u != null && a.name !== u;
      }
    }
    function $Oe(a, r6) {
      var t2 = a.color && !a.colorLayer;
      Ne(r6, function(s, u) {
        u === "colorLayer" && t2 || Ps.hasClass(u) || (typeof s == "object" ? a[u] = a[u] ? Di(a[u], s, false) : Qa(s) : a[u] == null && (a[u] = s));
      });
    }
    function Rce(a, r6, t2) {
      if (br(r6)) {
        var s = Ta();
        return Ne(r6, function(f6) {
          if (f6 != null) {
            var d6 = Zc(f6, null);
            d6 != null && s.set(f6, true);
          }
        }), gl(t2, function(f6) {
          return f6 && s.get(f6[a]);
        });
      } else {
        var u = Zc(r6, null);
        return gl(t2, function(f6) {
          return f6 && u != null && f6[a] === u;
        });
      }
    }
    function Fce(a, r6) {
      return r6.hasOwnProperty("subType") ? gl(a, function(t2) {
        return t2 && t2.subType === r6.subType;
      }) : a;
    }
    function Nce(a) {
      var r6 = Ta();
      return a && Ne(ll(a.replaceMerge), function(t2) {
        r6.set(t2, true);
      }), { replaceMergeMainTypeMap: r6 };
    }
    Dc(Oce, jY);
    var Vce = Oce, UOe = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], qOe = function() {
      function a(r6) {
        Ne(UOe, function(t2) {
          this[t2] = Ca(r6[t2], r6);
        }, this);
      }
      return a;
    }(), zce = qOe, WY = {}, YOe = function() {
      function a() {
        this._coordinateSystems = [];
      }
      return a.prototype.create = function(r6, t2) {
        var s = [];
        Ne(WY, function(u, f6) {
          var d6 = u.create(r6, t2);
          s = s.concat(d6 || []);
        }), this._coordinateSystems = s;
      }, a.prototype.update = function(r6, t2) {
        Ne(this._coordinateSystems, function(s) {
          s.update && s.update(r6, t2);
        });
      }, a.prototype.getCoordinateSystems = function() {
        return this._coordinateSystems.slice();
      }, a.register = function(r6, t2) {
        WY[r6] = t2;
      }, a.get = function(r6) {
        return WY[r6];
      }, a;
    }(), yR = YOe, ZOe = /^(min|max)?(.+)$/, XOe = function() {
      function a(r6) {
        this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = r6;
      }
      return a.prototype.setOption = function(r6, t2, s) {
        r6 && (Ne(ll(r6.series), function(d6) {
          d6 && d6.data && _v(d6.data) && cm(d6.data);
        }), Ne(ll(r6.dataset), function(d6) {
          d6 && d6.source && _v(d6.source) && cm(d6.source);
        })), r6 = Qa(r6);
        var u = this._optionBackup, f6 = KOe(r6, t2, !u);
        this._newBaseOption = f6.baseOption, u ? (f6.timelineOptions.length && (u.timelineOptions = f6.timelineOptions), f6.mediaList.length && (u.mediaList = f6.mediaList), f6.mediaDefault && (u.mediaDefault = f6.mediaDefault)) : this._optionBackup = f6;
      }, a.prototype.mountOption = function(r6) {
        var t2 = this._optionBackup;
        return this._timelineOptions = t2.timelineOptions, this._mediaList = t2.mediaList, this._mediaDefault = t2.mediaDefault, this._currentMediaIndices = [], Qa(r6 ? t2.baseOption : this._newBaseOption);
      }, a.prototype.getTimelineOption = function(r6) {
        var t2, s = this._timelineOptions;
        if (s.length) {
          var u = r6.getComponent("timeline");
          u && (t2 = Qa(s[u.getCurrentIndex()]));
        }
        return t2;
      }, a.prototype.getMediaOption = function(r6) {
        var t2 = this._api.getWidth(), s = this._api.getHeight(), u = this._mediaList, f6 = this._mediaDefault, d6 = [], v6 = [];
        if (!u.length && !f6)
          return v6;
        for (var m6 = 0, b6 = u.length; m6 < b6; m6++)
          JOe(u[m6].query, t2, s) && d6.push(m6);
        return !d6.length && f6 && (d6 = [-1]), d6.length && !eRe(d6, this._currentMediaIndices) && (v6 = wr(d6, function(x6) {
          return Qa(x6 === -1 ? f6.option : u[x6].option);
        })), this._currentMediaIndices = d6, v6;
      }, a;
    }();
    function KOe(a, r6, t2) {
      var s = [], u, f6, d6 = a.baseOption, v6 = a.timeline, m6 = a.options, b6 = a.media, x6 = !!a.media, S = !!(m6 || v6 || d6 && d6.timeline);
      d6 ? (f6 = d6, f6.timeline || (f6.timeline = v6)) : ((S || x6) && (a.options = a.media = null), f6 = a), x6 && br(b6) && Ne(b6, function(A6) {
        A6 && A6.option && (A6.query ? s.push(A6) : u || (u = A6));
      }), M(f6), Ne(m6, function(A6) {
        return M(A6);
      }), Ne(s, function(A6) {
        return M(A6.option);
      });
      function M(A6) {
        Ne(r6, function(I) {
          I(A6, t2);
        });
      }
      return { baseOption: f6, timelineOptions: m6 || [], mediaDefault: u, mediaList: s };
    }
    function JOe(a, r6, t2) {
      var s = { width: r6, height: t2, aspectratio: r6 / t2 }, u = true;
      return Ne(a, function(f6, d6) {
        var v6 = d6.match(ZOe);
        if (!(!v6 || !v6[1] || !v6[2])) {
          var m6 = v6[1], b6 = v6[2].toLowerCase();
          QOe(s[b6], f6, m6) || (u = false);
        }
      }), u;
    }
    function QOe(a, r6, t2) {
      return t2 === "min" ? a >= r6 : t2 === "max" ? a <= r6 : a === r6;
    }
    function eRe(a, r6) {
      return a.join(",") === r6.join(",");
    }
    var tRe = XOe, l1 = Ne, bR = ui, Bce = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
    function HY(a) {
      var r6 = a && a.itemStyle;
      if (r6)
        for (var t2 = 0, s = Bce.length; t2 < s; t2++) {
          var u = Bce[t2], f6 = r6.normal, d6 = r6.emphasis;
          f6 && f6[u] && (a[u] = a[u] || {}, a[u].normal ? Di(a[u].normal, f6[u]) : a[u].normal = f6[u], f6[u] = null), d6 && d6[u] && (a[u] = a[u] || {}, a[u].emphasis ? Di(a[u].emphasis, d6[u]) : a[u].emphasis = d6[u], d6[u] = null);
        }
    }
    function Gp(a, r6, t2) {
      if (a && a[r6] && (a[r6].normal || a[r6].emphasis)) {
        var s = a[r6].normal, u = a[r6].emphasis;
        s && (t2 ? (a[r6].normal = a[r6].emphasis = null, ei(a[r6], s)) : a[r6] = s), u && (a.emphasis = a.emphasis || {}, a.emphasis[r6] = u, u.focus && (a.emphasis.focus = u.focus), u.blurScope && (a.emphasis.blurScope = u.blurScope));
      }
    }
    function _R(a) {
      Gp(a, "itemStyle"), Gp(a, "lineStyle"), Gp(a, "areaStyle"), Gp(a, "label"), Gp(a, "labelLine"), Gp(a, "upperLabel"), Gp(a, "edgeLabel");
    }
    function Pf(a, r6) {
      var t2 = bR(a) && a[r6], s = bR(t2) && t2.textStyle;
      if (s)
        for (var u = 0, f6 = Yi.length; u < f6; u++) {
          var d6 = Yi[u];
          s.hasOwnProperty(d6) && (t2[d6] = s[d6]);
        }
    }
    function Lm(a) {
      a && (_R(a), Pf(a, "label"), a.emphasis && Pf(a.emphasis, "label"));
    }
    function nRe(a) {
      if (bR(a)) {
        HY(a), _R(a), Pf(a, "label"), Pf(a, "upperLabel"), Pf(a, "edgeLabel"), a.emphasis && (Pf(a.emphasis, "label"), Pf(a.emphasis, "upperLabel"), Pf(a.emphasis, "edgeLabel"));
        var r6 = a.markPoint;
        r6 && (HY(r6), Lm(r6));
        var t2 = a.markLine;
        t2 && (HY(t2), Lm(t2));
        var s = a.markArea;
        s && Lm(s);
        var u = a.data;
        if (a.type === "graph") {
          u = u || a.nodes;
          var f6 = a.links || a.edges;
          if (f6 && !_v(f6))
            for (var d6 = 0; d6 < f6.length; d6++)
              Lm(f6[d6]);
          Ne(a.categories, function(b6) {
            _R(b6);
          });
        }
        if (u && !_v(u))
          for (var d6 = 0; d6 < u.length; d6++)
            Lm(u[d6]);
        if (r6 = a.markPoint, r6 && r6.data)
          for (var v6 = r6.data, d6 = 0; d6 < v6.length; d6++)
            Lm(v6[d6]);
        if (t2 = a.markLine, t2 && t2.data)
          for (var m6 = t2.data, d6 = 0; d6 < m6.length; d6++)
            br(m6[d6]) ? (Lm(m6[d6][0]), Lm(m6[d6][1])) : Lm(m6[d6]);
        a.type === "gauge" ? (Pf(a, "axisLabel"), Pf(a, "title"), Pf(a, "detail")) : a.type === "treemap" ? (Gp(a.breadcrumb, "itemStyle"), Ne(a.levels, function(b6) {
          _R(b6);
        })) : a.type === "tree" && _R(a.leaves);
      }
    }
    function jx(a) {
      return br(a) ? a : a ? [a] : [];
    }
    function jce(a) {
      return (br(a) ? a[0] : a) || {};
    }
    function rRe(a, r6) {
      l1(jx(a.series), function(s) {
        bR(s) && nRe(s);
      });
      var t2 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
      r6 && t2.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), l1(t2, function(s) {
        l1(jx(a[s]), function(u) {
          u && (Pf(u, "axisLabel"), Pf(u.axisPointer, "label"));
        });
      }), l1(jx(a.parallel), function(s) {
        var u = s && s.parallelAxisDefault;
        Pf(u, "axisLabel"), Pf(u && u.axisPointer, "label");
      }), l1(jx(a.calendar), function(s) {
        Gp(s, "itemStyle"), Pf(s, "dayLabel"), Pf(s, "monthLabel"), Pf(s, "yearLabel");
      }), l1(jx(a.radar), function(s) {
        Pf(s, "name"), s.name && s.axisName == null && (s.axisName = s.name, delete s.name), s.nameGap != null && s.axisNameGap == null && (s.axisNameGap = s.nameGap, delete s.nameGap);
      }), l1(jx(a.geo), function(s) {
        bR(s) && (Lm(s), l1(jx(s.regions), function(u) {
          Lm(u);
        }));
      }), l1(jx(a.timeline), function(s) {
        Lm(s), Gp(s, "label"), Gp(s, "itemStyle"), Gp(s, "controlStyle", true);
        var u = s.data;
        br(u) && Ne(u, function(f6) {
          ui(f6) && (Gp(f6, "label"), Gp(f6, "itemStyle"));
        });
      }), l1(jx(a.toolbox), function(s) {
        Gp(s, "iconStyle"), l1(s.feature, function(u) {
          Gp(u, "iconStyle");
        });
      }), Pf(jce(a.axisPointer), "label"), Pf(jce(a.tooltip).axisPointer, "label");
    }
    function aRe(a, r6) {
      for (var t2 = r6.split(","), s = a, u = 0; u < t2.length && (s = s && s[t2[u]], s != null); u++)
        ;
      return s;
    }
    function iRe(a, r6, t2, s) {
      for (var u = r6.split(","), f6 = a, d6, v6 = 0; v6 < u.length - 1; v6++)
        d6 = u[v6], f6[d6] == null && (f6[d6] = {}), f6 = f6[d6];
      (s || f6[u[v6]] == null) && (f6[u[v6]] = t2);
    }
    function Gce(a) {
      a && Ne(oRe, function(r6) {
        r6[0] in a && !(r6[1] in a) && (a[r6[1]] = a[r6[0]]);
      });
    }
    var oRe = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], sRe = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], $Y = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
    function xR(a) {
      var r6 = a && a.itemStyle;
      if (r6)
        for (var t2 = 0; t2 < $Y.length; t2++) {
          var s = $Y[t2][1], u = $Y[t2][0];
          r6[s] != null && (r6[u] = r6[s]);
        }
    }
    function Wce(a) {
      !a || a.alignTo === "edge" && a.margin != null && a.edgeDistance == null && (a.edgeDistance = a.margin);
    }
    function Hce(a) {
      !a || a.downplay && !a.blur && (a.blur = a.downplay);
    }
    function lRe(a) {
      !a || a.focusNodeAdjacency != null && (a.emphasis = a.emphasis || {}, a.emphasis.focus == null && (a.emphasis.focus = "adjacency"));
    }
    function $ce(a, r6) {
      if (a)
        for (var t2 = 0; t2 < a.length; t2++)
          r6(a[t2]), a[t2] && $ce(a[t2].children, r6);
    }
    function Uce(a, r6) {
      rRe(a, r6), a.series = ll(a.series), Ne(a.series, function(t2) {
        if (ui(t2)) {
          var s = t2.type;
          if (s === "line")
            t2.clipOverflow != null && (t2.clip = t2.clipOverflow);
          else if (s === "pie" || s === "gauge") {
            t2.clockWise != null && (t2.clockwise = t2.clockWise), Wce(t2.label);
            var u = t2.data;
            if (u && !_v(u))
              for (var f6 = 0; f6 < u.length; f6++)
                Wce(u[f6]);
            t2.hoverOffset != null && (t2.emphasis = t2.emphasis || {}, (t2.emphasis.scaleSize = null) && (t2.emphasis.scaleSize = t2.hoverOffset));
          } else if (s === "gauge") {
            var d6 = aRe(t2, "pointer.color");
            d6 != null && iRe(t2, "itemStyle.color", d6);
          } else if (s === "bar") {
            xR(t2), xR(t2.backgroundStyle), xR(t2.emphasis);
            var u = t2.data;
            if (u && !_v(u))
              for (var f6 = 0; f6 < u.length; f6++)
                typeof u[f6] == "object" && (xR(u[f6]), xR(u[f6] && u[f6].emphasis));
          } else if (s === "sunburst") {
            var v6 = t2.highlightPolicy;
            v6 && (t2.emphasis = t2.emphasis || {}, t2.emphasis.focus || (t2.emphasis.focus = v6)), Hce(t2), $ce(t2.data, Hce);
          } else
            s === "graph" || s === "sankey" ? lRe(t2) : s === "map" && (t2.mapType && !t2.map && (t2.map = t2.mapType), t2.mapLocation && ei(t2, t2.mapLocation));
          t2.hoverAnimation != null && (t2.emphasis = t2.emphasis || {}, t2.emphasis && t2.emphasis.scale == null && (t2.emphasis.scale = t2.hoverAnimation)), Gce(t2);
        }
      }), a.dataRange && (a.visualMap = a.dataRange), Ne(sRe, function(t2) {
        var s = a[t2];
        s && (br(s) || (s = [s]), Ne(s, function(u) {
          Gce(u);
        }));
      });
    }
    function uRe(a) {
      var r6 = Ta();
      a.eachSeries(function(t2) {
        var s = t2.get("stack");
        if (s) {
          var u = r6.get(s) || r6.set(s, []), f6 = t2.getData(), d6 = { stackResultDimension: f6.getCalculationInfo("stackResultDimension"), stackedOverDimension: f6.getCalculationInfo("stackedOverDimension"), stackedDimension: f6.getCalculationInfo("stackedDimension"), stackedByDimension: f6.getCalculationInfo("stackedByDimension"), isStackedByIndex: f6.getCalculationInfo("isStackedByIndex"), data: f6, seriesModel: t2 };
          if (!d6.stackedDimension || !(d6.isStackedByIndex || d6.stackedByDimension))
            return;
          u.length && f6.setCalculationInfo("stackedOnSeries", u[u.length - 1].seriesModel), u.push(d6);
        }
      }), r6.each(cRe);
    }
    function cRe(a) {
      Ne(a, function(r6, t2) {
        var s = [], u = [NaN, NaN], f6 = [r6.stackResultDimension, r6.stackedOverDimension], d6 = r6.data, v6 = r6.isStackedByIndex;
        d6.modify(f6, function(m6, b6, x6) {
          var S = d6.get(r6.stackedDimension, x6);
          if (isNaN(S))
            return u;
          var M, A6;
          v6 ? A6 = d6.getRawIndex(x6) : M = d6.get(r6.stackedByDimension, x6);
          for (var I = NaN, R = t2 - 1; R >= 0; R--) {
            var F = a[R];
            if (v6 || (A6 = F.data.rawIndexOf(F.stackedByDimension, M)), A6 >= 0) {
              var j = F.data.getByRawIndex(F.stackResultDimension, A6);
              if (S >= 0 && j > 0 || S <= 0 && j < 0) {
                S = eO(S, j), I = j;
                break;
              }
            }
          }
          return s[0] = S, s[1] = I, s;
        });
      });
    }
    var dV = function() {
      function a(r6) {
        this.data = r6.data || (r6.sourceFormat === Rb ? {} : []), this.sourceFormat = r6.sourceFormat || Mce, this.seriesLayoutBy = r6.seriesLayoutBy || Fb, this.startIndex = r6.startIndex || 0, this.dimensionsDetectedCount = r6.dimensionsDetectedCount, this.metaRawOption = r6.metaRawOption;
        var t2 = this.dimensionsDefine = r6.dimensionsDefine;
        if (t2)
          for (var s = 0; s < t2.length; s++) {
            var u = t2[s];
            u.type == null && Ice(this, s) === rp.Must && (u.type = "ordinal");
          }
      }
      return a;
    }();
    function UY(a) {
      return a instanceof dV;
    }
    function qY(a, r6, t2) {
      t2 = t2 || qce(a);
      var s = r6.seriesLayoutBy, u = hRe(a, t2, s, r6.sourceHeader, r6.dimensions), f6 = new dV({ data: a, sourceFormat: t2, seriesLayoutBy: s, dimensionsDefine: u.dimensionsDefine, startIndex: u.startIndex, dimensionsDetectedCount: u.dimensionsDetectedCount, metaRawOption: Qa(r6) });
      return f6;
    }
    function YY(a) {
      return new dV({ data: a, sourceFormat: _v(a) ? X2 : km });
    }
    function fRe(a) {
      return new dV({ data: a.data, sourceFormat: a.sourceFormat, seriesLayoutBy: a.seriesLayoutBy, dimensionsDefine: Qa(a.dimensionsDefine), startIndex: a.startIndex, dimensionsDetectedCount: a.dimensionsDetectedCount });
    }
    function qce(a) {
      var r6 = Mce;
      if (_v(a))
        r6 = X2;
      else if (br(a)) {
        a.length === 0 && (r6 = jp);
        for (var t2 = 0, s = a.length; t2 < s; t2++) {
          var u = a[t2];
          if (u != null) {
            if (br(u)) {
              r6 = jp;
              break;
            } else if (ui(u)) {
              r6 = Pm;
              break;
            }
          }
        }
      } else if (ui(a)) {
        for (var f6 in a)
          if (Da(a, f6) && rd(a[f6])) {
            r6 = Rb;
            break;
          }
      }
      return r6;
    }
    function hRe(a, r6, t2, s, u) {
      var f6, d6;
      if (!a)
        return { dimensionsDefine: Yce(u), startIndex: d6, dimensionsDetectedCount: f6 };
      if (r6 === jp) {
        var v6 = a;
        s === "auto" || s == null ? Zce(function(b6) {
          b6 != null && b6 !== "-" && (_a2(b6) ? d6 == null && (d6 = 1) : d6 = 0);
        }, t2, v6, 10) : d6 = ks(s) ? s : s ? 1 : 0, !u && d6 === 1 && (u = [], Zce(function(b6, x6) {
          u[x6] = b6 != null ? b6 + "" : "";
        }, t2, v6, 1 / 0)), f6 = u ? u.length : t2 === t5 ? v6.length : v6[0] ? v6[0].length : null;
      } else if (r6 === Pm)
        u || (u = dRe(a));
      else if (r6 === Rb)
        u || (u = [], Ne(a, function(b6, x6) {
          u.push(x6);
        }));
      else if (r6 === km) {
        var m6 = n1(a[0]);
        f6 = br(m6) && m6.length || 1;
      }
      return { startIndex: d6, dimensionsDefine: Yce(u), dimensionsDetectedCount: f6 };
    }
    function dRe(a) {
      for (var r6 = 0, t2; r6 < a.length && !(t2 = a[r6++]); )
        ;
      if (t2) {
        var s = [];
        return Ne(t2, function(u, f6) {
          s.push(f6);
        }), s;
      }
    }
    function Yce(a) {
      if (a) {
        var r6 = Ta();
        return wr(a, function(t2, s) {
          t2 = ui(t2) ? t2 : { name: t2 };
          var u = { name: t2.name, displayName: t2.displayName, type: t2.type };
          if (u.name == null)
            return u;
          u.name += "", u.displayName == null && (u.displayName = u.name);
          var f6 = r6.get(u.name);
          return f6 ? u.name += "-" + f6.count++ : r6.set(u.name, { count: 1 }), u;
        });
      }
    }
    function Zce(a, r6, t2, s) {
      if (r6 === t5)
        for (var u = 0; u < t2.length && u < s; u++)
          a(t2[u] ? t2[u][0] : null, u);
      else
        for (var f6 = t2[0] || [], u = 0; u < f6.length && u < s; u++)
          a(f6[u], u);
    }
    function Xce(a) {
      var r6 = a.sourceFormat;
      return r6 === Pm || r6 === Rb;
    }
    var fA, hA, dA, Kce, Jce, Qce = function() {
      function a(r6, t2) {
        var s = UY(r6) ? r6 : YY(r6);
        this._source = s;
        var u = this._data = s.data;
        s.sourceFormat === X2 && (this._offset = 0, this._dimSize = t2, this._data = u), Jce(this, u, s);
      }
      return a.prototype.getSource = function() {
        return this._source;
      }, a.prototype.count = function() {
        return 0;
      }, a.prototype.getItem = function(r6, t2) {
      }, a.prototype.appendData = function(r6) {
      }, a.prototype.clean = function() {
      }, a.protoInitialize = function() {
        var r6 = a.prototype;
        r6.pure = false, r6.persistent = true;
      }(), a.internalField = function() {
        var r6;
        Jce = function(d6, v6, m6) {
          var b6 = m6.sourceFormat, x6 = m6.seriesLayoutBy, S = m6.startIndex, M = m6.dimensionsDefine, A6 = Kce[XY2(b6, x6)];
          if (qn(d6, A6), b6 === X2)
            d6.getItem = t2, d6.count = u, d6.fillStorage = s;
          else {
            var I = tfe(b6, x6);
            d6.getItem = Ca(I, null, v6, S, M);
            var R = rfe(b6, x6);
            d6.count = Ca(R, null, v6, S, M);
          }
        };
        var t2 = function(d6, v6) {
          d6 = d6 - this._offset, v6 = v6 || [];
          for (var m6 = this._data, b6 = this._dimSize, x6 = b6 * d6, S = 0; S < b6; S++)
            v6[S] = m6[x6 + S];
          return v6;
        }, s = function(d6, v6, m6, b6) {
          for (var x6 = this._data, S = this._dimSize, M = 0; M < S; M++) {
            for (var A6 = b6[M], I = A6[0] == null ? 1 / 0 : A6[0], R = A6[1] == null ? -1 / 0 : A6[1], F = v6 - d6, j = m6[M], $ = 0; $ < F; $++) {
              var K = x6[$ * S + M];
              j[d6 + $] = K, K < I && (I = K), K > R && (R = K);
            }
            A6[0] = I, A6[1] = R;
          }
        }, u = function() {
          return this._data ? this._data.length / this._dimSize : 0;
        };
        Kce = (r6 = {}, r6[jp + "_" + Fb] = { pure: true, appendData: f6 }, r6[jp + "_" + t5] = { pure: true, appendData: function() {
          throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
        } }, r6[Pm] = { pure: true, appendData: f6 }, r6[Rb] = { pure: true, appendData: function(d6) {
          var v6 = this._data;
          Ne(d6, function(m6, b6) {
            for (var x6 = v6[b6] || (v6[b6] = []), S = 0; S < (m6 || []).length; S++)
              x6.push(m6[S]);
          });
        } }, r6[km] = { appendData: f6 }, r6[X2] = { persistent: false, pure: true, appendData: function(d6) {
          this._data = d6;
        }, clean: function() {
          this._offset += this.count(), this._data = null;
        } }, r6);
        function f6(d6) {
          for (var v6 = 0; v6 < d6.length; v6++)
            this._data.push(d6[v6]);
        }
      }(), a;
    }(), efe = function(a, r6, t2, s) {
      return a[s];
    }, pRe = (fA = {}, fA[jp + "_" + Fb] = function(a, r6, t2, s) {
      return a[s + r6];
    }, fA[jp + "_" + t5] = function(a, r6, t2, s, u) {
      s += r6;
      for (var f6 = u || [], d6 = a, v6 = 0; v6 < d6.length; v6++) {
        var m6 = d6[v6];
        f6[v6] = m6 ? m6[s] : null;
      }
      return f6;
    }, fA[Pm] = efe, fA[Rb] = function(a, r6, t2, s, u) {
      for (var f6 = u || [], d6 = 0; d6 < t2.length; d6++) {
        var v6 = t2[d6].name, m6 = a[v6];
        f6[d6] = m6 ? m6[s] : null;
      }
      return f6;
    }, fA[km] = efe, fA);
    function tfe(a, r6) {
      var t2 = pRe[XY2(a, r6)];
      return t2;
    }
    var nfe = function(a, r6, t2) {
      return a.length;
    }, vRe = (hA = {}, hA[jp + "_" + Fb] = function(a, r6, t2) {
      return Math.max(0, a.length - r6);
    }, hA[jp + "_" + t5] = function(a, r6, t2) {
      var s = a[0];
      return s ? Math.max(0, s.length - r6) : 0;
    }, hA[Pm] = nfe, hA[Rb] = function(a, r6, t2) {
      var s = t2[0].name, u = a[s];
      return u ? u.length : 0;
    }, hA[km] = nfe, hA);
    function rfe(a, r6) {
      var t2 = vRe[XY2(a, r6)];
      return t2;
    }
    var ZY = function(a, r6, t2) {
      return a[r6];
    }, gRe = (dA = {}, dA[jp] = ZY, dA[Pm] = function(a, r6, t2) {
      return a[t2];
    }, dA[Rb] = ZY, dA[km] = function(a, r6, t2) {
      var s = n1(a);
      return s instanceof Array ? s[r6] : s;
    }, dA[X2] = ZY, dA);
    function afe(a) {
      var r6 = gRe[a];
      return r6;
    }
    function XY2(a, r6) {
      return a === jp ? a + "_" + r6 : a;
    }
    function n5(a, r6, t2) {
      if (a) {
        var s = a.getRawDataItem(r6);
        if (s != null) {
          var u = a.getStore(), f6 = u.getSource().sourceFormat;
          if (t2 != null) {
            var d6 = a.getDimensionIndex(t2), v6 = u.getDimensionProperty(d6);
            return afe(f6)(s, d6, v6);
          } else {
            var m6 = s;
            return f6 === km && (m6 = n1(s)), m6;
          }
        }
      }
    }
    var mRe = /\{@(.+?)\}/g, KY = function() {
      function a() {
      }
      return a.prototype.getDataParams = function(r6, t2) {
        var s = this.getData(t2), u = this.getRawValue(r6, t2), f6 = s.getRawIndex(r6), d6 = s.getName(r6), v6 = s.getRawDataItem(r6), m6 = s.getItemVisual(r6, "style"), b6 = m6 && m6[s.getItemVisual(r6, "drawType") || "fill"], x6 = m6 && m6.stroke, S = this.mainType, M = S === "series", A6 = s.userOutput && s.userOutput.get();
        return { componentType: S, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: M ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: M ? this.id : null, seriesName: M ? this.name : null, name: d6, dataIndex: f6, data: v6, dataType: t2, value: u, color: b6, borderColor: x6, dimensionNames: A6 ? A6.fullDimensions : null, encode: A6 ? A6.encode : null, $vars: ["seriesName", "name", "value"] };
      }, a.prototype.getFormattedLabel = function(r6, t2, s, u, f6, d6) {
        t2 = t2 || "normal";
        var v6 = this.getData(s), m6 = this.getDataParams(r6, s);
        if (d6 && (m6.value = d6.interpolatedValue), u != null && br(m6.value) && (m6.value = m6.value[u]), !f6) {
          var b6 = v6.getItemModel(r6);
          f6 = b6.get(t2 === "normal" ? ["label", "formatter"] : [t2, "label", "formatter"]);
        }
        if (ti(f6))
          return m6.status = t2, m6.dimensionIndex = u, f6(m6);
        if (_a2(f6)) {
          var x6 = _ce(f6, m6);
          return x6.replace(mRe, function(S, M) {
            var A6 = M.length, I = M;
            I.charAt(0) === "[" && I.charAt(A6 - 1) === "]" && (I = +I.slice(1, A6 - 1));
            var R = n5(v6, r6, I);
            if (d6 && br(d6.interpolatedValue)) {
              var F = v6.getDimensionIndex(I);
              F >= 0 && (R = d6.interpolatedValue[F]);
            }
            return R != null ? R + "" : "";
          });
        }
      }, a.prototype.getRawValue = function(r6, t2) {
        return n5(this.getData(t2), r6);
      }, a.prototype.formatTooltip = function(r6, t2, s) {
      }, a;
    }();
    function ife(a) {
      var r6, t2;
      return ui(a) ? a.type && (t2 = a) : r6 = a, { text: r6, frag: t2 };
    }
    function wR(a) {
      return new yRe(a);
    }
    var yRe = function() {
      function a(r6) {
        r6 = r6 || {}, this._reset = r6.reset, this._plan = r6.plan, this._count = r6.count, this._onDirty = r6.onDirty, this._dirty = true;
      }
      return a.prototype.perform = function(r6) {
        var t2 = this._upstream, s = r6 && r6.skip;
        if (this._dirty && t2) {
          var u = this.context;
          u.data = u.outputData = t2.context.outputData;
        }
        this.__pipeline && (this.__pipeline.currentTask = this);
        var f6;
        this._plan && !s && (f6 = this._plan(this.context));
        var d6 = x6(this._modBy), v6 = this._modDataCount || 0, m6 = x6(r6 && r6.modBy), b6 = r6 && r6.modDataCount || 0;
        (d6 !== m6 || v6 !== b6) && (f6 = "reset");
        function x6($) {
          return !($ >= 1) && ($ = 1), $;
        }
        var S;
        (this._dirty || f6 === "reset") && (this._dirty = false, S = this._doReset(s)), this._modBy = m6, this._modDataCount = b6;
        var M = r6 && r6.step;
        if (t2 ? this._dueEnd = t2._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
          var A6 = this._dueIndex, I = Math.min(M != null ? this._dueIndex + M : 1 / 0, this._dueEnd);
          if (!s && (S || A6 < I)) {
            var R = this._progress;
            if (br(R))
              for (var F = 0; F < R.length; F++)
                this._doProgress(R[F], A6, I, m6, b6);
            else
              this._doProgress(R, A6, I, m6, b6);
          }
          this._dueIndex = I;
          var j = this._settedOutputEnd != null ? this._settedOutputEnd : I;
          this._outputDueEnd = j;
        } else
          this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
        return this.unfinished();
      }, a.prototype.dirty = function() {
        this._dirty = true, this._onDirty && this._onDirty(this.context);
      }, a.prototype._doProgress = function(r6, t2, s, u, f6) {
        ofe.reset(t2, s, u, f6), this._callingProgress = r6, this._callingProgress({ start: t2, end: s, count: s - t2, next: ofe.next }, this.context);
      }, a.prototype._doReset = function(r6) {
        this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
        var t2, s;
        !r6 && this._reset && (t2 = this._reset(this.context), t2 && t2.progress && (s = t2.forceFirstProgress, t2 = t2.progress), br(t2) && !t2.length && (t2 = null)), this._progress = t2, this._modBy = this._modDataCount = null;
        var u = this._downstream;
        return u && u.dirty(), s;
      }, a.prototype.unfinished = function() {
        return this._progress && this._dueIndex < this._dueEnd;
      }, a.prototype.pipe = function(r6) {
        (this._downstream !== r6 || this._dirty) && (this._downstream = r6, r6._upstream = this, r6.dirty());
      }, a.prototype.dispose = function() {
        this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
      }, a.prototype.getUpstream = function() {
        return this._upstream;
      }, a.prototype.getDownstream = function() {
        return this._downstream;
      }, a.prototype.setOutputEnd = function(r6) {
        this._outputDueEnd = this._settedOutputEnd = r6;
      }, a;
    }(), ofe = function() {
      var a, r6, t2, s, u, f6 = { reset: function(m6, b6, x6, S) {
        r6 = m6, a = b6, t2 = x6, s = S, u = Math.ceil(s / t2), f6.next = t2 > 1 && s > 0 ? v6 : d6;
      } };
      return f6;
      function d6() {
        return r6 < a ? r6++ : null;
      }
      function v6() {
        var m6 = r6 % u * t2 + Math.ceil(r6 / u), b6 = r6 >= a ? null : m6 < s ? m6 : r6;
        return r6++, b6;
      }
    }();
    function K2(a, r6) {
      var t2 = r6 && r6.type;
      return t2 === "ordinal" ? a : (t2 === "time" && !ks(a) && a != null && a !== "-" && (a = +s0(a)), a == null || a === "" ? NaN : +a);
    }
    var bRe = Ta({ number: function(a) {
      return parseFloat(a);
    }, time: function(a) {
      return +s0(a);
    }, trim: function(a) {
      return _a2(a) ? mu(a) : a;
    } });
    function sfe(a) {
      return bRe.get(a);
    }
    var lfe = { lt: function(a, r6) {
      return a < r6;
    }, lte: function(a, r6) {
      return a <= r6;
    }, gt: function(a, r6) {
      return a > r6;
    }, gte: function(a, r6) {
      return a >= r6;
    } }, _Re = function() {
      function a(r6, t2) {
        if (!ks(t2)) {
          var s = "";
          Lo(s);
        }
        this._opFn = lfe[r6], this._rvalFloat = mm(t2);
      }
      return a.prototype.evaluate = function(r6) {
        return ks(r6) ? this._opFn(r6, this._rvalFloat) : this._opFn(mm(r6), this._rvalFloat);
      }, a;
    }(), ufe = function() {
      function a(r6, t2) {
        var s = r6 === "desc";
        this._resultLT = s ? 1 : -1, t2 == null && (t2 = s ? "min" : "max"), this._incomparable = t2 === "min" ? -1 / 0 : 1 / 0;
      }
      return a.prototype.evaluate = function(r6, t2) {
        var s = ks(r6) ? r6 : mm(r6), u = ks(t2) ? t2 : mm(t2), f6 = isNaN(s), d6 = isNaN(u);
        if (f6 && (s = this._incomparable), d6 && (u = this._incomparable), f6 && d6) {
          var v6 = _a2(r6), m6 = _a2(t2);
          v6 && (s = m6 ? r6 : 0), m6 && (u = v6 ? t2 : 0);
        }
        return s < u ? this._resultLT : s > u ? -this._resultLT : 0;
      }, a;
    }(), xRe = function() {
      function a(r6, t2) {
        this._rval = t2, this._isEQ = r6, this._rvalTypeof = typeof t2, this._rvalFloat = mm(t2);
      }
      return a.prototype.evaluate = function(r6) {
        var t2 = r6 === this._rval;
        if (!t2) {
          var s = typeof r6;
          s !== this._rvalTypeof && (s === "number" || this._rvalTypeof === "number") && (t2 = mm(r6) === this._rvalFloat);
        }
        return this._isEQ ? t2 : !t2;
      }, a;
    }();
    function wRe(a, r6) {
      return a === "eq" || a === "ne" ? new xRe(a === "eq", r6) : Da(lfe, a) ? new _Re(a, r6) : null;
    }
    var SRe = function() {
      function a() {
      }
      return a.prototype.getRawData = function() {
        throw new Error("not supported");
      }, a.prototype.getRawDataItem = function(r6) {
        throw new Error("not supported");
      }, a.prototype.cloneRawData = function() {
      }, a.prototype.getDimensionInfo = function(r6) {
      }, a.prototype.cloneAllDimensionInfo = function() {
      }, a.prototype.count = function() {
      }, a.prototype.retrieveValue = function(r6, t2) {
      }, a.prototype.retrieveValueFromItem = function(r6, t2) {
      }, a.prototype.convertValue = function(r6, t2) {
        return K2(r6, t2);
      }, a;
    }();
    function CRe(a, r6) {
      var t2 = new SRe(), s = a.data, u = t2.sourceFormat = a.sourceFormat, f6 = a.startIndex, d6 = "";
      a.seriesLayoutBy !== Fb && Lo(d6);
      var v6 = [], m6 = {}, b6 = a.dimensionsDefine;
      if (b6)
        Ne(b6, function(R, F) {
          var j = R.name, $ = { index: F, name: j, displayName: R.displayName };
          if (v6.push($), j != null) {
            var K = "";
            Da(m6, j) && Lo(K), m6[j] = $;
          }
        });
      else
        for (var x6 = 0; x6 < a.dimensionsDetectedCount; x6++)
          v6.push({ index: x6 });
      var S = tfe(u, Fb);
      r6.__isBuiltIn && (t2.getRawDataItem = function(R) {
        return S(s, f6, v6, R);
      }, t2.getRawData = Ca(MRe, null, a)), t2.cloneRawData = Ca(ARe, null, a);
      var M = rfe(u, Fb);
      t2.count = Ca(M, null, s, f6, v6);
      var A6 = afe(u);
      t2.retrieveValue = function(R, F) {
        var j = S(s, f6, v6, R);
        return I(j, F);
      };
      var I = t2.retrieveValueFromItem = function(R, F) {
        if (R != null) {
          var j = v6[F];
          if (j)
            return A6(R, F, j.name);
        }
      };
      return t2.getDimensionInfo = Ca(ERe, null, v6, m6), t2.cloneAllDimensionInfo = Ca(IRe, null, v6), t2;
    }
    function MRe(a) {
      var r6 = a.sourceFormat;
      if (!JY(r6)) {
        var t2 = "";
        Lo(t2);
      }
      return a.data;
    }
    function ARe(a) {
      var r6 = a.sourceFormat, t2 = a.data;
      if (!JY(r6)) {
        var s = "";
        Lo(s);
      }
      if (r6 === jp) {
        for (var u = [], f6 = 0, d6 = t2.length; f6 < d6; f6++)
          u.push(t2[f6].slice());
        return u;
      } else if (r6 === Pm) {
        for (var u = [], f6 = 0, d6 = t2.length; f6 < d6; f6++)
          u.push(qn({}, t2[f6]));
        return u;
      }
    }
    function ERe(a, r6, t2) {
      if (t2 != null) {
        if (ks(t2) || !isNaN(t2) && !Da(r6, t2))
          return a[t2];
        if (Da(r6, t2))
          return r6[t2];
      }
    }
    function IRe(a) {
      return Qa(a);
    }
    var cfe = Ta();
    function TRe(a) {
      a = Qa(a);
      var r6 = a.type, t2 = "";
      r6 || Lo(t2);
      var s = r6.split(":");
      s.length !== 2 && Lo(t2);
      var u = false;
      s[0] === "echarts" && (r6 = s[1], u = true), a.__isBuiltIn = u, cfe.set(r6, a);
    }
    function DRe(a, r6, t2) {
      var s = ll(a), u = s.length, f6 = "";
      u || Lo(f6);
      for (var d6 = 0, v6 = u; d6 < v6; d6++) {
        var m6 = s[d6];
        r6 = kRe(m6, r6), d6 !== v6 - 1 && (r6.length = Math.max(r6.length, 1));
      }
      return r6;
    }
    function kRe(a, r6, t2, s) {
      var u = "";
      r6.length || Lo(u), ui(a) || Lo(u);
      var f6 = a.type, d6 = cfe.get(f6);
      d6 || Lo(u);
      var v6 = wr(r6, function(b6) {
        return CRe(b6, d6);
      }), m6 = ll(d6.transform({ upstream: v6[0], upstreamList: v6, config: Qa(a.config) }));
      return wr(m6, function(b6, x6) {
        var S = "";
        ui(b6) || Lo(S), b6.data || Lo(S);
        var M = qce(b6.data);
        JY(M) || Lo(S);
        var A6, I = r6[0];
        if (I && x6 === 0 && !b6.dimensions) {
          var R = I.startIndex;
          R && (b6.data = I.data.slice(0, R).concat(b6.data)), A6 = { seriesLayoutBy: Fb, sourceHeader: R, dimensions: I.metaRawOption.dimensions };
        } else
          A6 = { seriesLayoutBy: Fb, sourceHeader: 0, dimensions: b6.dimensions };
        return qY(b6.data, A6, null);
      });
    }
    function JY(a) {
      return a === jp || a === Pm;
    }
    var pV = "undefined", PRe = typeof Uint32Array === pV ? Array : Uint32Array, LRe = typeof Uint16Array === pV ? Array : Uint16Array, ffe = typeof Int32Array === pV ? Array : Int32Array, hfe = typeof Float64Array === pV ? Array : Float64Array, dfe = { float: hfe, int: ffe, ordinal: Array, number: Array, time: hfe }, QY;
    function SR(a) {
      return a > 65535 ? PRe : LRe;
    }
    function r5() {
      return [1 / 0, -1 / 0];
    }
    function ORe(a) {
      var r6 = a.constructor;
      return r6 === Array ? a.slice() : new r6(a);
    }
    function pfe(a, r6, t2, s, u) {
      var f6 = dfe[t2 || "float"];
      if (u) {
        var d6 = a[r6], v6 = d6 && d6.length;
        if (v6 !== s) {
          for (var m6 = new f6(s), b6 = 0; b6 < v6; b6++)
            m6[b6] = d6[b6];
          a[r6] = m6;
        }
      } else
        a[r6] = new f6(s);
    }
    var eZ = function() {
      function a() {
        this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = Ta();
      }
      return a.prototype.initData = function(r6, t2, s) {
        this._provider = r6, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
        var u = r6.getSource(), f6 = this.defaultDimValueGetter = QY[u.sourceFormat];
        this._dimValueGetter = s || f6, this._rawExtent = [], Xce(u), this._dimensions = wr(t2, function(d6) {
          return { type: d6.type, property: d6.property };
        }), this._initDataFromProvider(0, r6.count());
      }, a.prototype.getProvider = function() {
        return this._provider;
      }, a.prototype.getSource = function() {
        return this._provider.getSource();
      }, a.prototype.ensureCalculationDimension = function(r6, t2) {
        var s = this._calcDimNameToIdx, u = this._dimensions, f6 = s.get(r6);
        if (f6 != null) {
          if (u[f6].type === t2)
            return f6;
        } else
          f6 = u.length;
        return u[f6] = { type: t2 }, s.set(r6, f6), this._chunks[f6] = new dfe[t2 || "float"](this._rawCount), this._rawExtent[f6] = r5(), f6;
      }, a.prototype.collectOrdinalMeta = function(r6, t2) {
        var s = this._chunks[r6], u = this._dimensions[r6], f6 = this._rawExtent, d6 = u.ordinalOffset || 0, v6 = s.length;
        d6 === 0 && (f6[r6] = r5());
        for (var m6 = f6[r6], b6 = d6; b6 < v6; b6++) {
          var x6 = s[b6] = t2.parseAndCollect(s[b6]);
          m6[0] = Math.min(x6, m6[0]), m6[1] = Math.max(x6, m6[1]);
        }
        u.ordinalMeta = t2, u.ordinalOffset = v6, u.type = "ordinal";
      }, a.prototype.getOrdinalMeta = function(r6) {
        var t2 = this._dimensions[r6], s = t2.ordinalMeta;
        return s;
      }, a.prototype.getDimensionProperty = function(r6) {
        var t2 = this._dimensions[r6];
        return t2 && t2.property;
      }, a.prototype.appendData = function(r6) {
        var t2 = this._provider, s = this.count();
        t2.appendData(r6);
        var u = t2.count();
        return t2.persistent || (u += s), s < u && this._initDataFromProvider(s, u, true), [s, u];
      }, a.prototype.appendValues = function(r6, t2) {
        for (var s = this._chunks, u = this._dimensions, f6 = u.length, d6 = this._rawExtent, v6 = this.count(), m6 = v6 + Math.max(r6.length, t2 || 0), b6 = 0; b6 < f6; b6++) {
          var x6 = u[b6];
          pfe(s, b6, x6.type, m6, true);
        }
        for (var S = [], M = v6; M < m6; M++)
          for (var A6 = M - v6, I = 0; I < f6; I++) {
            var x6 = u[I], R = QY.arrayRows.call(this, r6[A6] || S, x6.property, A6, I);
            s[I][M] = R;
            var F = d6[I];
            R < F[0] && (F[0] = R), R > F[1] && (F[1] = R);
          }
        return this._rawCount = this._count = m6, { start: v6, end: m6 };
      }, a.prototype._initDataFromProvider = function(r6, t2, s) {
        for (var u = this._provider, f6 = this._chunks, d6 = this._dimensions, v6 = d6.length, m6 = this._rawExtent, b6 = wr(d6, function($) {
          return $.property;
        }), x6 = 0; x6 < v6; x6++) {
          var S = d6[x6];
          m6[x6] || (m6[x6] = r5()), pfe(f6, x6, S.type, t2, s);
        }
        if (u.fillStorage)
          u.fillStorage(r6, t2, f6, m6);
        else
          for (var M = [], A6 = r6; A6 < t2; A6++) {
            M = u.getItem(A6, M);
            for (var I = 0; I < v6; I++) {
              var R = f6[I], F = this._dimValueGetter(M, b6[I], A6, I);
              R[A6] = F;
              var j = m6[I];
              F < j[0] && (j[0] = F), F > j[1] && (j[1] = F);
            }
          }
        !u.persistent && u.clean && u.clean(), this._rawCount = this._count = t2, this._extent = [];
      }, a.prototype.count = function() {
        return this._count;
      }, a.prototype.get = function(r6, t2) {
        if (!(t2 >= 0 && t2 < this._count))
          return NaN;
        var s = this._chunks[r6];
        return s ? s[this.getRawIndex(t2)] : NaN;
      }, a.prototype.getValues = function(r6, t2) {
        var s = [], u = [];
        if (t2 == null) {
          t2 = r6, r6 = [];
          for (var f6 = 0; f6 < this._dimensions.length; f6++)
            u.push(f6);
        } else
          u = r6;
        for (var f6 = 0, d6 = u.length; f6 < d6; f6++)
          s.push(this.get(u[f6], t2));
        return s;
      }, a.prototype.getByRawIndex = function(r6, t2) {
        if (!(t2 >= 0 && t2 < this._rawCount))
          return NaN;
        var s = this._chunks[r6];
        return s ? s[t2] : NaN;
      }, a.prototype.getSum = function(r6) {
        var t2 = this._chunks[r6], s = 0;
        if (t2)
          for (var u = 0, f6 = this.count(); u < f6; u++) {
            var d6 = this.get(r6, u);
            isNaN(d6) || (s += d6);
          }
        return s;
      }, a.prototype.getMedian = function(r6) {
        var t2 = [];
        this.each([r6], function(f6) {
          isNaN(f6) || t2.push(f6);
        });
        var s = t2.sort(function(f6, d6) {
          return f6 - d6;
        }), u = this.count();
        return u === 0 ? 0 : u % 2 === 1 ? s[(u - 1) / 2] : (s[u / 2] + s[u / 2 - 1]) / 2;
      }, a.prototype.indexOfRawIndex = function(r6) {
        if (r6 >= this._rawCount || r6 < 0)
          return -1;
        if (!this._indices)
          return r6;
        var t2 = this._indices, s = t2[r6];
        if (s != null && s < this._count && s === r6)
          return r6;
        for (var u = 0, f6 = this._count - 1; u <= f6; ) {
          var d6 = (u + f6) / 2 | 0;
          if (t2[d6] < r6)
            u = d6 + 1;
          else if (t2[d6] > r6)
            f6 = d6 - 1;
          else
            return d6;
        }
        return -1;
      }, a.prototype.indicesOfNearest = function(r6, t2, s) {
        var u = this._chunks, f6 = u[r6], d6 = [];
        if (!f6)
          return d6;
        s == null && (s = 1 / 0);
        for (var v6 = 1 / 0, m6 = -1, b6 = 0, x6 = 0, S = this.count(); x6 < S; x6++) {
          var M = this.getRawIndex(x6), A6 = t2 - f6[M], I = Math.abs(A6);
          I <= s && ((I < v6 || I === v6 && A6 >= 0 && m6 < 0) && (v6 = I, m6 = A6, b6 = 0), A6 === m6 && (d6[b6++] = x6));
        }
        return d6.length = b6, d6;
      }, a.prototype.getIndices = function() {
        var r6, t2 = this._indices;
        if (t2) {
          var s = t2.constructor, u = this._count;
          if (s === Array) {
            r6 = new s(u);
            for (var f6 = 0; f6 < u; f6++)
              r6[f6] = t2[f6];
          } else
            r6 = new s(t2.buffer, 0, u);
        } else {
          var s = SR(this._rawCount);
          r6 = new s(this.count());
          for (var f6 = 0; f6 < r6.length; f6++)
            r6[f6] = f6;
        }
        return r6;
      }, a.prototype.filter = function(r6, t2) {
        if (!this._count)
          return this;
        for (var s = this.clone(), u = s.count(), f6 = SR(s._rawCount), d6 = new f6(u), v6 = [], m6 = r6.length, b6 = 0, x6 = r6[0], S = s._chunks, M = 0; M < u; M++) {
          var A6 = void 0, I = s.getRawIndex(M);
          if (m6 === 0)
            A6 = t2(M);
          else if (m6 === 1) {
            var R = S[x6][I];
            A6 = t2(R, M);
          } else {
            for (var F = 0; F < m6; F++)
              v6[F] = S[r6[F]][I];
            v6[F] = M, A6 = t2.apply(null, v6);
          }
          A6 && (d6[b6++] = I);
        }
        return b6 < u && (s._indices = d6), s._count = b6, s._extent = [], s._updateGetRawIdx(), s;
      }, a.prototype.selectRange = function(r6) {
        var t2 = this.clone(), s = t2._count;
        if (!s)
          return this;
        var u = Po(r6), f6 = u.length;
        if (!f6)
          return this;
        var d6 = t2.count(), v6 = SR(t2._rawCount), m6 = new v6(d6), b6 = 0, x6 = u[0], S = r6[x6][0], M = r6[x6][1], A6 = t2._chunks, I = false;
        if (!t2._indices) {
          var R = 0;
          if (f6 === 1) {
            for (var F = A6[u[0]], j = 0; j < s; j++) {
              var $ = F[j];
              ($ >= S && $ <= M || isNaN($)) && (m6[b6++] = R), R++;
            }
            I = true;
          } else if (f6 === 2) {
            for (var F = A6[u[0]], K = A6[u[1]], U = r6[u[1]][0], he = r6[u[1]][1], j = 0; j < s; j++) {
              var $ = F[j], ue = K[j];
              ($ >= S && $ <= M || isNaN($)) && (ue >= U && ue <= he || isNaN(ue)) && (m6[b6++] = R), R++;
            }
            I = true;
          }
        }
        if (!I)
          if (f6 === 1)
            for (var j = 0; j < d6; j++) {
              var pe = t2.getRawIndex(j), $ = A6[u[0]][pe];
              ($ >= S && $ <= M || isNaN($)) && (m6[b6++] = pe);
            }
          else
            for (var j = 0; j < d6; j++) {
              for (var _e = true, pe = t2.getRawIndex(j), xe = 0; xe < f6; xe++) {
                var Ae = u[xe], $ = A6[Ae][pe];
                ($ < r6[Ae][0] || $ > r6[Ae][1]) && (_e = false);
              }
              _e && (m6[b6++] = t2.getRawIndex(j));
            }
        return b6 < d6 && (t2._indices = m6), t2._count = b6, t2._extent = [], t2._updateGetRawIdx(), t2;
      }, a.prototype.map = function(r6, t2) {
        var s = this.clone(r6);
        return this._updateDims(s, r6, t2), s;
      }, a.prototype.modify = function(r6, t2) {
        this._updateDims(this, r6, t2);
      }, a.prototype._updateDims = function(r6, t2, s) {
        for (var u = r6._chunks, f6 = [], d6 = t2.length, v6 = r6.count(), m6 = [], b6 = r6._rawExtent, x6 = 0; x6 < t2.length; x6++)
          b6[t2[x6]] = r5();
        for (var S = 0; S < v6; S++) {
          for (var M = r6.getRawIndex(S), A6 = 0; A6 < d6; A6++)
            m6[A6] = u[t2[A6]][M];
          m6[d6] = S;
          var I = s && s.apply(null, m6);
          if (I != null) {
            typeof I != "object" && (f6[0] = I, I = f6);
            for (var x6 = 0; x6 < I.length; x6++) {
              var R = t2[x6], F = I[x6], j = b6[R], $ = u[R];
              $ && ($[M] = F), F < j[0] && (j[0] = F), F > j[1] && (j[1] = F);
            }
          }
        }
      }, a.prototype.lttbDownSample = function(r6, t2) {
        var s = this.clone([r6], true), u = s._chunks, f6 = u[r6], d6 = this.count(), v6 = 0, m6 = Math.floor(1 / t2), b6 = this.getRawIndex(0), x6, S, M, A6 = new (SR(this._rawCount))(Math.min((Math.ceil(d6 / m6) + 2) * 2, d6));
        A6[v6++] = b6;
        for (var I = 1; I < d6 - 1; I += m6) {
          for (var R = Math.min(I + m6, d6 - 1), F = Math.min(I + m6 * 2, d6), j = (F + R) / 2, $ = 0, K = R; K < F; K++) {
            var U = this.getRawIndex(K), he = f6[U];
            isNaN(he) || ($ += he);
          }
          $ /= F - R;
          var ue = I, pe = Math.min(I + m6, d6), _e = I - 1, xe = f6[b6];
          x6 = -1, M = ue;
          for (var Ae = -1, ke = 0, K = ue; K < pe; K++) {
            var U = this.getRawIndex(K), he = f6[U];
            if (isNaN(he)) {
              ke++, Ae < 0 && (Ae = U);
              continue;
            }
            S = Math.abs((_e - j) * (he - xe) - (_e - K) * ($ - xe)), S > x6 && (x6 = S, M = U);
          }
          ke > 0 && ke < pe - ue && (A6[v6++] = Math.min(Ae, M), M = Math.max(Ae, M)), A6[v6++] = M, b6 = M;
        }
        return A6[v6++] = this.getRawIndex(d6 - 1), s._count = v6, s._indices = A6, s.getRawIndex = this._getRawIdx, s;
      }, a.prototype.downSample = function(r6, t2, s, u) {
        for (var f6 = this.clone([r6], true), d6 = f6._chunks, v6 = [], m6 = Math.floor(1 / t2), b6 = d6[r6], x6 = this.count(), S = f6._rawExtent[r6] = r5(), M = new (SR(this._rawCount))(Math.ceil(x6 / m6)), A6 = 0, I = 0; I < x6; I += m6) {
          m6 > x6 - I && (m6 = x6 - I, v6.length = m6);
          for (var R = 0; R < m6; R++) {
            var F = this.getRawIndex(I + R);
            v6[R] = b6[F];
          }
          var j = s(v6), $ = this.getRawIndex(Math.min(I + u(v6, j) || 0, x6 - 1));
          b6[$] = j, j < S[0] && (S[0] = j), j > S[1] && (S[1] = j), M[A6++] = $;
        }
        return f6._count = A6, f6._indices = M, f6._updateGetRawIdx(), f6;
      }, a.prototype.each = function(r6, t2) {
        if (this._count)
          for (var s = r6.length, u = this._chunks, f6 = 0, d6 = this.count(); f6 < d6; f6++) {
            var v6 = this.getRawIndex(f6);
            switch (s) {
              case 0:
                t2(f6);
                break;
              case 1:
                t2(u[r6[0]][v6], f6);
                break;
              case 2:
                t2(u[r6[0]][v6], u[r6[1]][v6], f6);
                break;
              default:
                for (var m6 = 0, b6 = []; m6 < s; m6++)
                  b6[m6] = u[r6[m6]][v6];
                b6[m6] = f6, t2.apply(null, b6);
            }
          }
      }, a.prototype.getDataExtent = function(r6) {
        var t2 = this._chunks[r6], s = r5();
        if (!t2)
          return s;
        var u = this.count(), f6 = !this._indices, d6;
        if (f6)
          return this._rawExtent[r6].slice();
        if (d6 = this._extent[r6], d6)
          return d6.slice();
        d6 = s;
        for (var v6 = d6[0], m6 = d6[1], b6 = 0; b6 < u; b6++) {
          var x6 = this.getRawIndex(b6), S = t2[x6];
          S < v6 && (v6 = S), S > m6 && (m6 = S);
        }
        return d6 = [v6, m6], this._extent[r6] = d6, d6;
      }, a.prototype.getRawDataItem = function(r6) {
        var t2 = this.getRawIndex(r6);
        if (this._provider.persistent)
          return this._provider.getItem(t2);
        for (var s = [], u = this._chunks, f6 = 0; f6 < u.length; f6++)
          s.push(u[f6][t2]);
        return s;
      }, a.prototype.clone = function(r6, t2) {
        var s = new a(), u = this._chunks, f6 = r6 && qg(r6, function(v6, m6) {
          return v6[m6] = true, v6;
        }, {});
        if (f6)
          for (var d6 = 0; d6 < u.length; d6++)
            s._chunks[d6] = f6[d6] ? ORe(u[d6]) : u[d6];
        else
          s._chunks = u;
        return this._copyCommonProps(s), t2 || (s._indices = this._cloneIndices()), s._updateGetRawIdx(), s;
      }, a.prototype._copyCommonProps = function(r6) {
        r6._count = this._count, r6._rawCount = this._rawCount, r6._provider = this._provider, r6._dimensions = this._dimensions, r6._extent = Qa(this._extent), r6._rawExtent = Qa(this._rawExtent);
      }, a.prototype._cloneIndices = function() {
        if (this._indices) {
          var r6 = this._indices.constructor, t2 = void 0;
          if (r6 === Array) {
            var s = this._indices.length;
            t2 = new r6(s);
            for (var u = 0; u < s; u++)
              t2[u] = this._indices[u];
          } else
            t2 = new r6(this._indices);
          return t2;
        }
        return null;
      }, a.prototype._getRawIdxIdentity = function(r6) {
        return r6;
      }, a.prototype._getRawIdx = function(r6) {
        return r6 < this._count && r6 >= 0 ? this._indices[r6] : -1;
      }, a.prototype._updateGetRawIdx = function() {
        this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
      }, a.internalField = function() {
        function r6(t2, s, u, f6) {
          return K2(t2[f6], this._dimensions[f6]);
        }
        QY = { arrayRows: r6, objectRows: function(t2, s, u, f6) {
          return K2(t2[s], this._dimensions[f6]);
        }, keyedColumns: r6, original: function(t2, s, u, f6) {
          var d6 = t2 && (t2.value == null ? t2 : t2.value);
          return K2(d6 instanceof Array ? d6[f6] : d6, this._dimensions[f6]);
        }, typedArray: function(t2, s, u, f6) {
          return t2[f6];
        } };
      }(), a;
    }(), vfe = function() {
      function a(r6) {
        this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = r6;
      }
      return a.prototype.dirty = function() {
        this._setLocalSource([], []), this._storeList = [], this._dirty = true;
      }, a.prototype._setLocalSource = function(r6, t2) {
        this._sourceList = r6, this._upstreamSignList = t2, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
      }, a.prototype._getVersionSign = function() {
        return this._sourceHost.uid + "_" + this._versionSignBase;
      }, a.prototype.prepareSource = function() {
        this._isDirty() && (this._createSource(), this._dirty = false);
      }, a.prototype._createSource = function() {
        this._setLocalSource([], []);
        var r6 = this._sourceHost, t2 = this._getUpstreamSourceManagers(), s = !!t2.length, u, f6;
        if (vV(r6)) {
          var d6 = r6, v6 = void 0, m6 = void 0, b6 = void 0;
          if (s) {
            var x6 = t2[0];
            x6.prepareSource(), b6 = x6.getSource(), v6 = b6.data, m6 = b6.sourceFormat, f6 = [x6._getVersionSign()];
          } else
            v6 = d6.get("data", true), m6 = _v(v6) ? X2 : km, f6 = [];
          var S = this._getSourceMetaRawOption() || {}, M = b6 && b6.metaRawOption || {}, A6 = qi(S.seriesLayoutBy, M.seriesLayoutBy) || null, I = qi(S.sourceHeader, M.sourceHeader), R = qi(S.dimensions, M.dimensions), F = A6 !== M.seriesLayoutBy || !!I != !!M.sourceHeader || R;
          u = F ? [qY(v6, { seriesLayoutBy: A6, sourceHeader: I, dimensions: R }, m6)] : [];
        } else {
          var j = r6;
          if (s) {
            var $ = this._applyTransform(t2);
            u = $.sourceList, f6 = $.upstreamSignList;
          } else {
            var K = j.get("source", true);
            u = [qY(K, this._getSourceMetaRawOption(), null)], f6 = [];
          }
        }
        this._setLocalSource(u, f6);
      }, a.prototype._applyTransform = function(r6) {
        var t2 = this._sourceHost, s = t2.get("transform", true), u = t2.get("fromTransformResult", true);
        if (u != null) {
          var f6 = "";
          r6.length !== 1 && mfe(f6);
        }
        var d6, v6 = [], m6 = [];
        return Ne(r6, function(b6) {
          b6.prepareSource();
          var x6 = b6.getSource(u || 0), S = "";
          u != null && !x6 && mfe(S), v6.push(x6), m6.push(b6._getVersionSign());
        }), s ? d6 = DRe(s, v6, { datasetIndex: t2.componentIndex }) : u != null && (d6 = [fRe(v6[0])]), { sourceList: d6, upstreamSignList: m6 };
      }, a.prototype._isDirty = function() {
        if (this._dirty)
          return true;
        for (var r6 = this._getUpstreamSourceManagers(), t2 = 0; t2 < r6.length; t2++) {
          var s = r6[t2];
          if (s._isDirty() || this._upstreamSignList[t2] !== s._getVersionSign())
            return true;
        }
      }, a.prototype.getSource = function(r6) {
        r6 = r6 || 0;
        var t2 = this._sourceList[r6];
        if (!t2) {
          var s = this._getUpstreamSourceManagers();
          return s[0] && s[0].getSource(r6);
        }
        return t2;
      }, a.prototype.getSharedDataStore = function(r6) {
        var t2 = r6.makeStoreSchema();
        return this._innerGetDataStore(t2.dimensions, r6.source, t2.hash);
      }, a.prototype._innerGetDataStore = function(r6, t2, s) {
        var u = 0, f6 = this._storeList, d6 = f6[u];
        d6 || (d6 = f6[u] = {});
        var v6 = d6[s];
        if (!v6) {
          var m6 = this._getUpstreamSourceManagers()[0];
          vV(this._sourceHost) && m6 ? v6 = m6._innerGetDataStore(r6, t2, s) : (v6 = new eZ(), v6.initData(new Qce(t2, r6.length), r6)), d6[s] = v6;
        }
        return v6;
      }, a.prototype._getUpstreamSourceManagers = function() {
        var r6 = this._sourceHost;
        if (vV(r6)) {
          var t2 = zY(r6);
          return t2 ? [t2.getSourceManager()] : [];
        } else
          return wr(NOe(r6), function(s) {
            return s.getSourceManager();
          });
      }, a.prototype._getSourceMetaRawOption = function() {
        var r6 = this._sourceHost, t2, s, u;
        if (vV(r6))
          t2 = r6.get("seriesLayoutBy", true), s = r6.get("sourceHeader", true), u = r6.get("dimensions", true);
        else if (!this._getUpstreamSourceManagers().length) {
          var f6 = r6;
          t2 = f6.get("seriesLayoutBy", true), s = f6.get("sourceHeader", true), u = f6.get("dimensions", true);
        }
        return { seriesLayoutBy: t2, sourceHeader: s, dimensions: u };
      }, a;
    }();
    function gfe(a) {
      var r6 = a.option.transform;
      r6 && cm(a.option.transform);
    }
    function vV(a) {
      return a.mainType === "series";
    }
    function mfe(a) {
      throw new Error(a);
    }
    var yfe = "line-height:1";
    function bfe(a, r6) {
      var t2 = a.color || "#6e7079", s = a.fontSize || 12, u = a.fontWeight || "400", f6 = a.color || "#464646", d6 = a.fontSize || 14, v6 = a.fontWeight || "900";
      return r6 === "html" ? { nameStyle: "font-size:" + h0(s + "") + "px;color:" + h0(t2) + ";font-weight:" + h0(u + ""), valueStyle: "font-size:" + h0(d6 + "") + "px;color:" + h0(f6) + ";font-weight:" + h0(v6 + "") } : { nameStyle: { fontSize: s, fill: t2, fontWeight: u }, valueStyle: { fontSize: d6, fill: f6, fontWeight: v6 } };
    }
    var RRe = [0, 10, 20, 30], FRe = ["", `
`, `

`, `


`];
    function Ih(a, r6) {
      return r6.type = a, r6;
    }
    function tZ(a) {
      return a.type === "section";
    }
    function _fe(a) {
      return tZ(a) ? NRe : VRe;
    }
    function xfe(a) {
      if (tZ(a)) {
        var r6 = 0, t2 = a.blocks.length, s = t2 > 1 || t2 > 0 && !a.noHeader;
        return Ne(a.blocks, function(u) {
          var f6 = xfe(u);
          f6 >= r6 && (r6 = f6 + +(s && (!f6 || tZ(u) && !u.noHeader)));
        }), r6;
      }
      return 0;
    }
    function NRe(a, r6, t2, s) {
      var u = r6.noHeader, f6 = zRe(xfe(r6)), d6 = [], v6 = r6.blocks || [];
      Hd(!v6 || br(v6)), v6 = v6 || [];
      var m6 = a.orderMode;
      if (r6.sortBlocks && m6) {
        v6 = v6.slice();
        var b6 = { valueAsc: "asc", valueDesc: "desc" };
        if (Da(b6, m6)) {
          var x6 = new ufe(b6[m6], null);
          v6.sort(function(I, R) {
            return x6.evaluate(I.sortParam, R.sortParam);
          });
        } else
          m6 === "seriesDesc" && v6.reverse();
      }
      Ne(v6, function(I, R) {
        var F = r6.valueFormatter, j = _fe(I)(F ? qn(qn({}, a), { valueFormatter: F }) : a, I, R > 0 ? f6.html : 0, s);
        j != null && d6.push(j);
      });
      var S = a.renderMode === "richText" ? d6.join(f6.richText) : nZ(d6.join(""), u ? t2 : f6.html);
      if (u)
        return S;
      var M = RY(r6.header, "ordinal", a.useUTC), A6 = bfe(s, a.renderMode).nameStyle;
      return a.renderMode === "richText" ? Sfe(a, M, A6) + f6.richText + S : nZ('<div style="' + A6 + ";" + yfe + ';">' + h0(M) + "</div>" + S, t2);
    }
    function VRe(a, r6, t2, s) {
      var u = a.renderMode, f6 = r6.noName, d6 = r6.noValue, v6 = !r6.markerType, m6 = r6.name, b6 = a.useUTC, x6 = r6.valueFormatter || a.valueFormatter || function(U) {
        return U = br(U) ? U : [U], wr(U, function(he, ue) {
          return RY(he, br(A6) ? A6[ue] : A6, b6);
        });
      };
      if (!(f6 && d6)) {
        var S = v6 ? "" : a.markupStyleCreator.makeTooltipMarker(r6.markerType, r6.markerColor || "#333", u), M = f6 ? "" : RY(m6, "ordinal", b6), A6 = r6.valueType, I = d6 ? [] : x6(r6.value), R = !v6 || !f6, F = !v6 && f6, j = bfe(s, u), $ = j.nameStyle, K = j.valueStyle;
        return u === "richText" ? (v6 ? "" : S) + (f6 ? "" : Sfe(a, M, $)) + (d6 ? "" : GRe(a, I, R, F, K)) : nZ((v6 ? "" : S) + (f6 ? "" : BRe(M, !v6, $)) + (d6 ? "" : jRe(I, R, F, K)), t2);
      }
    }
    function wfe(a, r6, t2, s, u, f6) {
      if (a) {
        var d6 = _fe(a), v6 = { useUTC: u, renderMode: t2, orderMode: s, markupStyleCreator: r6, valueFormatter: a.valueFormatter };
        return d6(v6, a, 0, f6);
      }
    }
    function zRe(a) {
      return { html: RRe[a], richText: FRe[a] };
    }
    function nZ(a, r6) {
      var t2 = '<div style="clear:both"></div>', s = "margin: " + r6 + "px 0 0";
      return '<div style="' + s + ";" + yfe + ';">' + a + t2 + "</div>";
    }
    function BRe(a, r6, t2) {
      var s = r6 ? "margin-left:2px" : "";
      return '<span style="' + t2 + ";" + s + '">' + h0(a) + "</span>";
    }
    function jRe(a, r6, t2, s) {
      var u = t2 ? "10px" : "20px", f6 = r6 ? "float:right;margin-left:" + u : "";
      return a = br(a) ? a : [a], '<span style="' + f6 + ";" + s + '">' + wr(a, function(d6) {
        return h0(d6);
      }).join("&nbsp;&nbsp;") + "</span>";
    }
    function Sfe(a, r6, t2) {
      return a.markupStyleCreator.wrapRichTextStyle(r6, t2);
    }
    function GRe(a, r6, t2, s, u) {
      var f6 = [u], d6 = s ? 10 : 20;
      return t2 && f6.push({ padding: [0, 0, 0, d6], align: "right" }), a.markupStyleCreator.wrapRichTextStyle(br(r6) ? r6.join("  ") : r6, f6);
    }
    function Cfe(a, r6) {
      var t2 = a.getData().getItemVisual(r6, "style"), s = t2[a.visualDrawType];
      return lA(s);
    }
    function Mfe(a, r6) {
      var t2 = a.get("padding");
      return t2 != null ? t2 : r6 === "richText" ? [8, 10] : 10;
    }
    var rZ = function() {
      function a() {
        this.richTextStyles = {}, this._nextStyleNameId = iO();
      }
      return a.prototype._generateStyleName = function() {
        return "__EC_aUTo_" + this._nextStyleNameId++;
      }, a.prototype.makeTooltipMarker = function(r6, t2, s) {
        var u = s === "richText" ? this._generateStyleName() : null, f6 = DOe({ color: t2, type: r6, renderMode: s, markerId: u });
        return _a2(f6) ? f6 : (this.richTextStyles[u] = f6.style, f6.content);
      }, a.prototype.wrapRichTextStyle = function(r6, t2) {
        var s = {};
        br(t2) ? Ne(t2, function(f6) {
          return qn(s, f6);
        }) : qn(s, t2);
        var u = this._generateStyleName();
        return this.richTextStyles[u] = s, "{" + u + "|" + r6 + "}";
      }, a;
    }();
    function Afe(a) {
      var r6 = a.series, t2 = a.dataIndex, s = a.multipleSeries, u = r6.getData(), f6 = u.mapDimensionsAll("defaultedTooltip"), d6 = f6.length, v6 = r6.getRawValue(t2), m6 = br(v6), b6 = Cfe(r6, t2), x6, S, M, A6;
      if (d6 > 1 || m6 && !d6) {
        var I = WRe(v6, r6, t2, f6, b6);
        x6 = I.inlineValues, S = I.inlineValueTypes, M = I.blocks, A6 = I.inlineValues[0];
      } else if (d6) {
        var R = u.getDimensionInfo(f6[0]);
        A6 = x6 = n5(u, t2, f6[0]), S = R.type;
      } else
        A6 = x6 = m6 ? v6[0] : v6;
      var F = uO(r6), j = F && r6.name || "", $ = u.getName(t2), K = s ? j : $;
      return Ih("section", { header: j, noHeader: s || !F, sortParam: A6, blocks: [Ih("nameValue", { markerType: "item", markerColor: b6, name: K, noName: !mu(K), value: x6, valueType: S })].concat(M || []) });
    }
    function WRe(a, r6, t2, s, u) {
      var f6 = r6.getData(), d6 = qg(a, function(S, M, A6) {
        var I = f6.getDimensionInfo(A6);
        return S = S || I && I.tooltip !== false && I.displayName != null;
      }, false), v6 = [], m6 = [], b6 = [];
      s.length ? Ne(s, function(S) {
        x6(n5(f6, t2, S), S);
      }) : Ne(a, x6);
      function x6(S, M) {
        var A6 = f6.getDimensionInfo(M);
        !A6 || A6.otherDims.tooltip === false || (d6 ? b6.push(Ih("nameValue", { markerType: "subItem", markerColor: u, name: A6.displayName, value: S, valueType: A6.type })) : (v6.push(S), m6.push(A6.type)));
      }
      return { inlineValues: v6, inlineValueTypes: m6, blocks: b6 };
    }
    var J2 = Xo();
    function gV(a, r6) {
      return a.getName(r6) || a.getId(r6);
    }
    var mV = "__universalTransitionEnabled", yV = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2._selectedDataIndicesMap = {}, t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        this.seriesIndex = this.componentIndex, this.dataTask = wR({ count: $Re, reset: URe }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(t2, u);
        var f6 = J2(this).sourceManager = new vfe(this);
        f6.prepareSource();
        var d6 = this.getInitialData(t2, u);
        Ife(d6, this), this.dataTask.context.data = d6, J2(this).dataBeforeProcessed = d6, Efe(this), this._initSelectedMapFromData(d6);
      }, r6.prototype.mergeDefaultAndTheme = function(t2, s) {
        var u = gR(this), f6 = u ? JD(t2) : {}, d6 = this.subType;
        Ps.hasClass(d6) && (d6 += "Series"), Di(t2, s.getTheme().get(this.subType)), Di(t2, this.getDefaultOption()), ug(t2, "label", ["show"]), this.fillDataTextStyle(t2.data), u && Z2(t2, f6, u);
      }, r6.prototype.mergeOption = function(t2, s) {
        t2 = Di(this.option, t2, true), this.fillDataTextStyle(t2.data);
        var u = gR(this);
        u && Z2(this.option, t2, u);
        var f6 = J2(this).sourceManager;
        f6.dirty(), f6.prepareSource();
        var d6 = this.getInitialData(t2, s);
        Ife(d6, this), this.dataTask.dirty(), this.dataTask.context.data = d6, J2(this).dataBeforeProcessed = d6, Efe(this), this._initSelectedMapFromData(d6);
      }, r6.prototype.fillDataTextStyle = function(t2) {
        if (t2 && !_v(t2))
          for (var s = ["show"], u = 0; u < t2.length; u++)
            t2[u] && t2[u].label && ug(t2[u], "label", s);
      }, r6.prototype.getInitialData = function(t2, s) {
      }, r6.prototype.appendData = function(t2) {
        var s = this.getRawData();
        s.appendData(t2.data);
      }, r6.prototype.getData = function(t2) {
        var s = aZ(this);
        if (s) {
          var u = s.context.data;
          return t2 == null ? u : u.getLinkedData(t2);
        } else
          return J2(this).data;
      }, r6.prototype.getAllData = function() {
        var t2 = this.getData();
        return t2 && t2.getLinkedDataAll ? t2.getLinkedDataAll() : [{ data: t2 }];
      }, r6.prototype.setData = function(t2) {
        var s = aZ(this);
        if (s) {
          var u = s.context;
          u.outputData = t2, s !== this.dataTask && (u.data = t2);
        }
        J2(this).data = t2;
      }, r6.prototype.getEncode = function() {
        var t2 = this.get("encode", true);
        if (t2)
          return Ta(t2);
      }, r6.prototype.getSourceManager = function() {
        return J2(this).sourceManager;
      }, r6.prototype.getSource = function() {
        return this.getSourceManager().getSource();
      }, r6.prototype.getRawData = function() {
        return J2(this).dataBeforeProcessed;
      }, r6.prototype.getColorBy = function() {
        var t2 = this.get("colorBy");
        return t2 || "series";
      }, r6.prototype.isColorBySeries = function() {
        return this.getColorBy() === "series";
      }, r6.prototype.getBaseAxis = function() {
        var t2 = this.coordinateSystem;
        return t2 && t2.getBaseAxis && t2.getBaseAxis();
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        return Afe({ series: this, dataIndex: t2, multipleSeries: s });
      }, r6.prototype.isAnimationEnabled = function() {
        var t2 = this.ecModel;
        if (ha.node && !(t2 && t2.ssr))
          return false;
        var s = this.getShallow("animation");
        return s && this.getData().count() > this.getShallow("animationThreshold") && (s = false), !!s;
      }, r6.prototype.restoreData = function() {
        this.dataTask.dirty();
      }, r6.prototype.getColorFromPalette = function(t2, s, u) {
        var f6 = this.ecModel, d6 = jY.prototype.getColorFromPalette.call(this, t2, s, u);
        return d6 || (d6 = f6.getColorFromPalette(t2, s, u)), d6;
      }, r6.prototype.coordDimToDataDim = function(t2) {
        return this.getRawData().mapDimensionsAll(t2);
      }, r6.prototype.getProgressive = function() {
        return this.get("progressive");
      }, r6.prototype.getProgressiveThreshold = function() {
        return this.get("progressiveThreshold");
      }, r6.prototype.select = function(t2, s) {
        this._innerSelect(this.getData(s), t2);
      }, r6.prototype.unselect = function(t2, s) {
        var u = this.option.selectedMap;
        if (u) {
          var f6 = this.option.selectedMode, d6 = this.getData(s);
          if (f6 === "series" || u === "all") {
            this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
            return;
          }
          for (var v6 = 0; v6 < t2.length; v6++) {
            var m6 = t2[v6], b6 = gV(d6, m6);
            u[b6] = false, this._selectedDataIndicesMap[b6] = -1;
          }
        }
      }, r6.prototype.toggleSelect = function(t2, s) {
        for (var u = [], f6 = 0; f6 < t2.length; f6++)
          u[0] = t2[f6], this.isSelected(t2[f6], s) ? this.unselect(u, s) : this.select(u, s);
      }, r6.prototype.getSelectedDataIndices = function() {
        if (this.option.selectedMap === "all")
          return [].slice.call(this.getData().getIndices());
        for (var t2 = this._selectedDataIndicesMap, s = Po(t2), u = [], f6 = 0; f6 < s.length; f6++) {
          var d6 = t2[s[f6]];
          d6 >= 0 && u.push(d6);
        }
        return u;
      }, r6.prototype.isSelected = function(t2, s) {
        var u = this.option.selectedMap;
        if (!u)
          return false;
        var f6 = this.getData(s);
        return (u === "all" || u[gV(f6, t2)]) && !f6.getItemModel(t2).get(["select", "disabled"]);
      }, r6.prototype.isUniversalTransitionEnabled = function() {
        if (this[mV])
          return true;
        var t2 = this.option.universalTransition;
        return t2 ? t2 === true ? true : t2 && t2.enabled : false;
      }, r6.prototype._innerSelect = function(t2, s) {
        var u, f6, d6 = this.option, v6 = d6.selectedMode, m6 = s.length;
        if (!(!v6 || !m6)) {
          if (v6 === "series")
            d6.selectedMap = "all";
          else if (v6 === "multiple") {
            ui(d6.selectedMap) || (d6.selectedMap = {});
            for (var b6 = d6.selectedMap, x6 = 0; x6 < m6; x6++) {
              var S = s[x6], M = gV(t2, S);
              b6[M] = true, this._selectedDataIndicesMap[M] = t2.getRawIndex(S);
            }
          } else if (v6 === "single" || v6 === true) {
            var A6 = s[m6 - 1], M = gV(t2, A6);
            d6.selectedMap = (u = {}, u[M] = true, u), this._selectedDataIndicesMap = (f6 = {}, f6[M] = t2.getRawIndex(A6), f6);
          }
        }
      }, r6.prototype._initSelectedMapFromData = function(t2) {
        if (!this.option.selectedMap) {
          var s = [];
          t2.hasItemOption && t2.each(function(u) {
            var f6 = t2.getRawDataItem(u);
            f6 && f6.selected && s.push(u);
          }), s.length > 0 && this._innerSelect(t2, s);
        }
      }, r6.registerClass = function(t2) {
        return Ps.registerClass(t2);
      }, r6.protoInitialize = function() {
        var t2 = r6.prototype;
        t2.type = "series.__base__", t2.seriesIndex = 0, t2.ignoreStyleOnData = false, t2.hasSymbolVisual = false, t2.defaultSymbol = "circle", t2.visualStyleAccessPath = "itemStyle", t2.visualDrawType = "fill";
      }(), r6;
    }(Ps);
    Dc(yV, KY), Dc(yV, jY), pO(yV, Ps);
    function Efe(a) {
      var r6 = a.name;
      uO(a) || (a.name = HRe(a) || r6);
    }
    function HRe(a) {
      var r6 = a.getRawData(), t2 = r6.mapDimensionsAll("seriesName"), s = [];
      return Ne(t2, function(u) {
        var f6 = r6.getDimensionInfo(u);
        f6.displayName && s.push(f6.displayName);
      }), s.join(" ");
    }
    function $Re(a) {
      return a.model.getRawData().count();
    }
    function URe(a) {
      var r6 = a.model;
      return r6.setData(r6.getRawData().cloneShallow()), qRe;
    }
    function qRe(a, r6) {
      r6.outputData && a.end > r6.outputData.count() && r6.model.getRawData().cloneShallow(r6.outputData);
    }
    function Ife(a, r6) {
      Ne(PT(a.CHANGABLE_METHODS, a.DOWNSAMPLE_METHODS), function(t2) {
        a.wrapMethod(t2, Oi(YRe, r6));
      });
    }
    function YRe(a, r6) {
      var t2 = aZ(a);
      return t2 && t2.setOutputEnd((r6 || this).count()), r6;
    }
    function aZ(a) {
      var r6 = (a.ecModel || {}).scheduler, t2 = r6 && r6.getPipeline(a.uid);
      if (t2) {
        var s = t2.currentTask;
        if (s) {
          var u = s.agentStubMap;
          u && (s = u.get(a.uid));
        }
        return s;
      }
    }
    var sc = yV, iZ = function() {
      function a() {
        this.group = new bi(), this.uid = YD("viewComponent");
      }
      return a.prototype.init = function(r6, t2) {
      }, a.prototype.render = function(r6, t2, s, u) {
      }, a.prototype.dispose = function(r6, t2) {
      }, a.prototype.updateView = function(r6, t2, s, u) {
      }, a.prototype.updateLayout = function(r6, t2, s, u) {
      }, a.prototype.updateVisual = function(r6, t2, s, u) {
      }, a.prototype.blurSeries = function(r6, t2) {
      }, a.prototype.eachRendered = function(r6) {
        var t2 = this.group;
        t2 && t2.traverse(r6);
      }, a;
    }();
    gD(iZ), yD(iZ);
    var Rc = iZ;
    function a5() {
      var a = Xo();
      return function(r6) {
        var t2 = a(r6), s = r6.pipelineContext, u = !!t2.large, f6 = !!t2.progressiveRender, d6 = t2.large = !!(s && s.large), v6 = t2.progressiveRender = !!(s && s.progressiveRender);
        return (u !== d6 || f6 !== v6) && "reset";
      };
    }
    var Tfe = Xo(), ZRe = a5(), oZ = function() {
      function a() {
        this.group = new bi(), this.uid = YD("viewChart"), this.renderTask = wR({ plan: XRe, reset: KRe }), this.renderTask.context = { view: this };
      }
      return a.prototype.init = function(r6, t2) {
      }, a.prototype.render = function(r6, t2, s, u) {
      }, a.prototype.highlight = function(r6, t2, s, u) {
        var f6 = r6.getData(u && u.dataType);
        !f6 || kfe(f6, u, "emphasis");
      }, a.prototype.downplay = function(r6, t2, s, u) {
        var f6 = r6.getData(u && u.dataType);
        !f6 || kfe(f6, u, "normal");
      }, a.prototype.remove = function(r6, t2) {
        this.group.removeAll();
      }, a.prototype.dispose = function(r6, t2) {
      }, a.prototype.updateView = function(r6, t2, s, u) {
        this.render(r6, t2, s, u);
      }, a.prototype.updateLayout = function(r6, t2, s, u) {
        this.render(r6, t2, s, u);
      }, a.prototype.updateVisual = function(r6, t2, s, u) {
        this.render(r6, t2, s, u);
      }, a.prototype.eachRendered = function(r6) {
        s1(this.group, r6);
      }, a.markUpdateMethod = function(r6, t2) {
        Tfe(r6).updateMethod = t2;
      }, a.protoInitialize = function() {
        var r6 = a.prototype;
        r6.type = "chart";
      }(), a;
    }();
    function Dfe(a, r6, t2) {
      a && QM(a) && (r6 === "emphasis" ? Cm : Mm)(a, t2);
    }
    function kfe(a, r6, t2) {
      var s = xx(a, r6), u = r6 && r6.highlightKey != null ? qO(r6.highlightKey) : null;
      s != null ? Ne(ll(s), function(f6) {
        Dfe(a.getItemGraphicEl(f6), t2, u);
      }) : a.eachItemGraphicEl(function(f6) {
        Dfe(f6, t2, u);
      });
    }
    gD(oZ), yD(oZ);
    function XRe(a) {
      return ZRe(a.model);
    }
    function KRe(a) {
      var r6 = a.model, t2 = a.ecModel, s = a.api, u = a.payload, f6 = r6.pipelineContext.progressiveRender, d6 = a.view, v6 = u && Tfe(u).updateMethod, m6 = f6 ? "incrementalPrepareRender" : v6 && d6[v6] ? v6 : "render";
      return m6 !== "render" && d6[m6](r6, t2, s, u), JRe[m6];
    }
    var JRe = { incrementalPrepareRender: { progress: function(a, r6) {
      r6.view.incrementalRender(a, r6.model, r6.ecModel, r6.api, r6.payload);
    } }, render: { forceFirstProgress: true, progress: function(a, r6) {
      r6.view.render(r6.model, r6.ecModel, r6.api, r6.payload);
    } } }, bu = oZ, bV = "\0__throttleOriginMethod", Pfe = "\0__throttleRate", Lfe = "\0__throttleType";
    function sZ(a, r6, t2) {
      var s, u = 0, f6 = 0, d6 = null, v6, m6, b6, x6;
      r6 = r6 || 0;
      function S() {
        f6 = new Date().getTime(), d6 = null, a.apply(m6, b6 || []);
      }
      var M = function() {
        for (var A6 = [], I = 0; I < arguments.length; I++)
          A6[I] = arguments[I];
        s = new Date().getTime(), m6 = this, b6 = A6;
        var R = x6 || r6, F = x6 || t2;
        x6 = null, v6 = s - (F ? u : f6) - R, clearTimeout(d6), F ? d6 = setTimeout(S, R) : v6 >= 0 ? S() : d6 = setTimeout(S, -v6), u = s;
      };
      return M.clear = function() {
        d6 && (clearTimeout(d6), d6 = null);
      }, M.debounceNextCall = function(A6) {
        x6 = A6;
      }, M;
    }
    function i5(a, r6, t2, s) {
      var u = a[r6];
      if (u) {
        var f6 = u[bV] || u, d6 = u[Lfe], v6 = u[Pfe];
        if (v6 !== t2 || d6 !== s) {
          if (t2 == null || !s)
            return a[r6] = f6;
          u = a[r6] = sZ(f6, t2, s === "debounce"), u[bV] = f6, u[Lfe] = s, u[Pfe] = t2;
        }
        return u;
      }
    }
    function CR(a, r6) {
      var t2 = a[r6];
      t2 && t2[bV] && (t2.clear && t2.clear(), a[r6] = t2[bV]);
    }
    var Ofe = Xo(), Rfe = { itemStyle: Mx(rce, true), lineStyle: Mx(nce, true) }, QRe = { lineStyle: "stroke", itemStyle: "fill" };
    function Ffe(a, r6) {
      var t2 = a.visualStyleMapper || Rfe[r6];
      return t2 || (console.warn("Unkown style type '" + r6 + "'."), Rfe.itemStyle);
    }
    function Nfe(a, r6) {
      var t2 = a.visualDrawType || QRe[r6];
      return t2 || (console.warn("Unkown style type '" + r6 + "'."), "fill");
    }
    var e4e = { createOnAllSeries: true, performRawSeries: true, reset: function(a, r6) {
      var t2 = a.getData(), s = a.visualStyleAccessPath || "itemStyle", u = a.getModel(s), f6 = Ffe(a, s), d6 = f6(u), v6 = u.getShallow("decal");
      v6 && (t2.setVisual("decal", v6), v6.dirty = true);
      var m6 = Nfe(a, s), b6 = d6[m6], x6 = ti(b6) ? b6 : null, S = d6.fill === "auto" || d6.stroke === "auto";
      if (!d6[m6] || x6 || S) {
        var M = a.getColorFromPalette(a.name, null, r6.getSeriesCount());
        d6[m6] || (d6[m6] = M, t2.setVisual("colorFromPalette", true)), d6.fill = d6.fill === "auto" || ti(d6.fill) ? M : d6.fill, d6.stroke = d6.stroke === "auto" || ti(d6.stroke) ? M : d6.stroke;
      }
      if (t2.setVisual("style", d6), t2.setVisual("drawType", m6), !r6.isSeriesFiltered(a) && x6)
        return t2.setVisual("colorFromPalette", false), { dataEach: function(A6, I) {
          var R = a.getDataParams(I), F = qn({}, d6);
          F[m6] = x6(R), A6.setItemVisual(I, "style", F);
        } };
    } }, MR = new yu(), t4e = { createOnAllSeries: true, performRawSeries: true, reset: function(a, r6) {
      if (!(a.ignoreStyleOnData || r6.isSeriesFiltered(a))) {
        var t2 = a.getData(), s = a.visualStyleAccessPath || "itemStyle", u = Ffe(a, s), f6 = t2.getVisual("drawType");
        return { dataEach: t2.hasItemOption ? function(d6, v6) {
          var m6 = d6.getRawDataItem(v6);
          if (m6 && m6[s]) {
            MR.option = m6[s];
            var b6 = u(MR), x6 = d6.ensureUniqueItemVisual(v6, "style");
            qn(x6, b6), MR.option.decal && (d6.setItemVisual(v6, "decal", MR.option.decal), MR.option.decal.dirty = true), f6 in b6 && d6.setItemVisual(v6, "colorFromPalette", false);
          }
        } : null };
      }
    } }, n4e = { performRawSeries: true, overallReset: function(a) {
      var r6 = Ta();
      a.eachSeries(function(t2) {
        var s = t2.getColorBy();
        if (!t2.isColorBySeries()) {
          var u = t2.type + "-" + s, f6 = r6.get(u);
          f6 || (f6 = {}, r6.set(u, f6)), Ofe(t2).scope = f6;
        }
      }), a.eachSeries(function(t2) {
        if (!(t2.isColorBySeries() || a.isSeriesFiltered(t2))) {
          var s = t2.getRawData(), u = {}, f6 = t2.getData(), d6 = Ofe(t2).scope, v6 = t2.visualStyleAccessPath || "itemStyle", m6 = Nfe(t2, v6);
          f6.each(function(b6) {
            var x6 = f6.getRawIndex(b6);
            u[x6] = b6;
          }), s.each(function(b6) {
            var x6 = u[b6], S = f6.getItemVisual(x6, "colorFromPalette");
            if (S) {
              var M = f6.ensureUniqueItemVisual(x6, "style"), A6 = s.getName(b6) || b6 + "", I = s.count();
              M[m6] = t2.getColorFromPalette(A6, d6, I);
            }
          });
        }
      });
    } }, _V = Math.PI;
    function r4e(a, r6) {
      r6 = r6 || {}, ei(r6, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
      var t2 = new bi(), s = new rs({ style: { fill: r6.maskColor }, zlevel: r6.zlevel, z: 1e4 });
      t2.add(s);
      var u = new ms({ style: { text: r6.text, fill: r6.textColor, fontSize: r6.fontSize, fontWeight: r6.fontWeight, fontStyle: r6.fontStyle, fontFamily: r6.fontFamily }, zlevel: r6.zlevel, z: 10001 }), f6 = new rs({ style: { fill: "none" }, textContent: u, textConfig: { position: "right", distance: 10 }, zlevel: r6.zlevel, z: 10001 });
      t2.add(f6);
      var d6;
      return r6.showSpinner && (d6 = new rR({ shape: { startAngle: -_V / 2, endAngle: -_V / 2 + 0.1, r: r6.spinnerRadius }, style: { stroke: r6.color, lineCap: "round", lineWidth: r6.lineWidth }, zlevel: r6.zlevel, z: 10001 }), d6.animateShape(true).when(1e3, { endAngle: _V * 3 / 2 }).start("circularInOut"), d6.animateShape(true).when(1e3, { startAngle: _V * 3 / 2 }).delay(300).start("circularInOut"), t2.add(d6)), t2.resize = function() {
        var v6 = u.getBoundingRect().width, m6 = r6.showSpinner ? r6.spinnerRadius : 0, b6 = (a.getWidth() - m6 * 2 - (r6.showSpinner && v6 ? 10 : 0) - v6) / 2 - (r6.showSpinner && v6 ? 0 : 5 + v6 / 2) + (r6.showSpinner ? 0 : v6 / 2) + (v6 ? 0 : m6), x6 = a.getHeight() / 2;
        r6.showSpinner && d6.setShape({ cx: b6, cy: x6 }), f6.setShape({ x: b6 - m6, y: x6 - m6, width: m6 * 2, height: m6 * 2 }), s.setShape({ x: 0, y: 0, width: a.getWidth(), height: a.getHeight() });
      }, t2.resize(), t2;
    }
    var a4e = function() {
      function a(r6, t2, s, u) {
        this._stageTaskMap = Ta(), this.ecInstance = r6, this.api = t2, s = this._dataProcessorHandlers = s.slice(), u = this._visualHandlers = u.slice(), this._allHandlers = s.concat(u);
      }
      return a.prototype.restoreData = function(r6, t2) {
        r6.restoreData(t2), this._stageTaskMap.each(function(s) {
          var u = s.overallTask;
          u && u.dirty();
        });
      }, a.prototype.getPerformArgs = function(r6, t2) {
        if (r6.__pipeline) {
          var s = this._pipelineMap.get(r6.__pipeline.id), u = s.context, f6 = !t2 && s.progressiveEnabled && (!u || u.progressiveRender) && r6.__idxInPipeline > s.blockIndex, d6 = f6 ? s.step : null, v6 = u && u.modDataCount, m6 = v6 != null ? Math.ceil(v6 / d6) : null;
          return { step: d6, modBy: m6, modDataCount: v6 };
        }
      }, a.prototype.getPipeline = function(r6) {
        return this._pipelineMap.get(r6);
      }, a.prototype.updateStreamModes = function(r6, t2) {
        var s = this._pipelineMap.get(r6.uid), u = r6.getData(), f6 = u.count(), d6 = s.progressiveEnabled && t2.incrementalPrepareRender && f6 >= s.threshold, v6 = r6.get("large") && f6 >= r6.get("largeThreshold"), m6 = r6.get("progressiveChunkMode") === "mod" ? f6 : null;
        r6.pipelineContext = s.context = { progressiveRender: d6, modDataCount: m6, large: v6 };
      }, a.prototype.restorePipelines = function(r6) {
        var t2 = this, s = t2._pipelineMap = Ta();
        r6.eachSeries(function(u) {
          var f6 = u.getProgressive(), d6 = u.uid;
          s.set(d6, { id: d6, head: null, tail: null, threshold: u.getProgressiveThreshold(), progressiveEnabled: f6 && !(u.preventIncremental && u.preventIncremental()), blockIndex: -1, step: Math.round(f6 || 700), count: 0 }), t2._pipe(u, u.dataTask);
        });
      }, a.prototype.prepareStageTasks = function() {
        var r6 = this._stageTaskMap, t2 = this.api.getModel(), s = this.api;
        Ne(this._allHandlers, function(u) {
          var f6 = r6.get(u.uid) || r6.set(u.uid, {}), d6 = "";
          Hd(!(u.reset && u.overallReset), d6), u.reset && this._createSeriesStageTask(u, f6, t2, s), u.overallReset && this._createOverallStageTask(u, f6, t2, s);
        }, this);
      }, a.prototype.prepareView = function(r6, t2, s, u) {
        var f6 = r6.renderTask, d6 = f6.context;
        d6.model = t2, d6.ecModel = s, d6.api = u, f6.__block = !r6.incrementalPrepareRender, this._pipe(t2, f6);
      }, a.prototype.performDataProcessorTasks = function(r6, t2) {
        this._performStageTasks(this._dataProcessorHandlers, r6, t2, { block: true });
      }, a.prototype.performVisualTasks = function(r6, t2, s) {
        this._performStageTasks(this._visualHandlers, r6, t2, s);
      }, a.prototype._performStageTasks = function(r6, t2, s, u) {
        u = u || {};
        var f6 = false, d6 = this;
        Ne(r6, function(m6, b6) {
          if (!(u.visualType && u.visualType !== m6.visualType)) {
            var x6 = d6._stageTaskMap.get(m6.uid), S = x6.seriesTaskMap, M = x6.overallTask;
            if (M) {
              var A6, I = M.agentStubMap;
              I.each(function(F) {
                v6(u, F) && (F.dirty(), A6 = true);
              }), A6 && M.dirty(), d6.updatePayload(M, s);
              var R = d6.getPerformArgs(M, u.block);
              I.each(function(F) {
                F.perform(R);
              }), M.perform(R) && (f6 = true);
            } else
              S && S.each(function(F, j) {
                v6(u, F) && F.dirty();
                var $ = d6.getPerformArgs(F, u.block);
                $.skip = !m6.performRawSeries && t2.isSeriesFiltered(F.context.model), d6.updatePayload(F, s), F.perform($) && (f6 = true);
              });
          }
        });
        function v6(m6, b6) {
          return m6.setDirty && (!m6.dirtyMap || m6.dirtyMap.get(b6.__pipeline.id));
        }
        this.unfinished = f6 || this.unfinished;
      }, a.prototype.performSeriesTasks = function(r6) {
        var t2;
        r6.eachSeries(function(s) {
          t2 = s.dataTask.perform() || t2;
        }), this.unfinished = t2 || this.unfinished;
      }, a.prototype.plan = function() {
        this._pipelineMap.each(function(r6) {
          var t2 = r6.tail;
          do {
            if (t2.__block) {
              r6.blockIndex = t2.__idxInPipeline;
              break;
            }
            t2 = t2.getUpstream();
          } while (t2);
        });
      }, a.prototype.updatePayload = function(r6, t2) {
        t2 !== "remain" && (r6.context.payload = t2);
      }, a.prototype._createSeriesStageTask = function(r6, t2, s, u) {
        var f6 = this, d6 = t2.seriesTaskMap, v6 = t2.seriesTaskMap = Ta(), m6 = r6.seriesType, b6 = r6.getTargetSeries;
        r6.createOnAllSeries ? s.eachRawSeries(x6) : m6 ? s.eachRawSeriesByType(m6, x6) : b6 && b6(s, u).each(x6);
        function x6(S) {
          var M = S.uid, A6 = v6.set(M, d6 && d6.get(M) || wR({ plan: u4e, reset: c4e, count: h4e }));
          A6.context = { model: S, ecModel: s, api: u, useClearVisual: r6.isVisual && !r6.isLayout, plan: r6.plan, reset: r6.reset, scheduler: f6 }, f6._pipe(S, A6);
        }
      }, a.prototype._createOverallStageTask = function(r6, t2, s, u) {
        var f6 = this, d6 = t2.overallTask = t2.overallTask || wR({ reset: i4e });
        d6.context = { ecModel: s, api: u, overallReset: r6.overallReset, scheduler: f6 };
        var v6 = d6.agentStubMap, m6 = d6.agentStubMap = Ta(), b6 = r6.seriesType, x6 = r6.getTargetSeries, S = true, M = false, A6 = "";
        Hd(!r6.createOnAllSeries, A6), b6 ? s.eachRawSeriesByType(b6, I) : x6 ? x6(s, u).each(I) : (S = false, Ne(s.getSeries(), I));
        function I(R) {
          var F = R.uid, j = m6.set(F, v6 && v6.get(F) || (M = true, wR({ reset: o4e, onDirty: l4e })));
          j.context = { model: R, overallProgress: S }, j.agent = d6, j.__block = S, f6._pipe(R, j);
        }
        M && d6.dirty();
      }, a.prototype._pipe = function(r6, t2) {
        var s = r6.uid, u = this._pipelineMap.get(s);
        !u.head && (u.head = t2), u.tail && u.tail.pipe(t2), u.tail = t2, t2.__idxInPipeline = u.count++, t2.__pipeline = u;
      }, a.wrapStageHandler = function(r6, t2) {
        return ti(r6) && (r6 = { overallReset: r6, seriesType: d4e(r6) }), r6.uid = YD("stageHandler"), t2 && (r6.visualType = t2), r6;
      }, a;
    }();
    function i4e(a) {
      a.overallReset(a.ecModel, a.api, a.payload);
    }
    function o4e(a) {
      return a.overallProgress && s4e;
    }
    function s4e() {
      this.agent.dirty(), this.getDownstream().dirty();
    }
    function l4e() {
      this.agent && this.agent.dirty();
    }
    function u4e(a) {
      return a.plan ? a.plan(a.model, a.ecModel, a.api, a.payload) : null;
    }
    function c4e(a) {
      a.useClearVisual && a.data.clearAllVisual();
      var r6 = a.resetDefines = ll(a.reset(a.model, a.ecModel, a.api, a.payload));
      return r6.length > 1 ? wr(r6, function(t2, s) {
        return Vfe(s);
      }) : f4e;
    }
    var f4e = Vfe(0);
    function Vfe(a) {
      return function(r6, t2) {
        var s = t2.data, u = t2.resetDefines[a];
        if (u && u.dataEach)
          for (var f6 = r6.start; f6 < r6.end; f6++)
            u.dataEach(s, f6);
        else
          u && u.progress && u.progress(r6, s);
      };
    }
    function h4e(a) {
      return a.data.count();
    }
    function d4e(a) {
      xV = null;
      try {
        a(AR, zfe);
      } catch {
      }
      return xV;
    }
    var AR = {}, zfe = {}, xV;
    Bfe(AR, Vce), Bfe(zfe, zce), AR.eachSeriesByType = AR.eachRawSeriesByType = function(a) {
      xV = a;
    }, AR.eachComponent = function(a) {
      a.mainType === "series" && a.subType && (xV = a.subType);
    };
    function Bfe(a, r6) {
      for (var t2 in r6.prototype)
        a[t2] = kc;
    }
    var jfe = a4e, Gfe = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], p4e = { color: Gfe, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], Gfe] }, Iv = "#B9B8CE", Wfe = "#100C2A", wV = function() {
      return { axisLine: { lineStyle: { color: Iv } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
    }, Hfe = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], $fe = { darkMode: true, color: Hfe, backgroundColor: Wfe, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: Iv } }, textStyle: { color: Iv }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: Iv } }, dataZoom: { borderColor: "#71708A", textStyle: { color: Iv }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: Iv } }, timeline: { lineStyle: { color: Iv }, label: { color: Iv }, controlStyle: { color: Iv, borderColor: Iv } }, calendar: { itemStyle: { color: Wfe }, dayLabel: { color: Iv }, monthLabel: { color: Iv }, yearLabel: { color: Iv } }, timeAxis: wV(), logAxis: wV(), valueAxis: wV(), categoryAxis: wV(), line: { symbol: "circle" }, graph: { color: Hfe }, gauge: { title: { color: Iv }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: Iv }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
    $fe.categoryAxis.splitLine.show = false;
    var v4e = $fe, g4e = function() {
      function a() {
      }
      return a.prototype.normalizeQuery = function(r6) {
        var t2 = {}, s = {}, u = {};
        if (_a2(r6)) {
          var f6 = Lp(r6);
          t2.mainType = f6.main || null, t2.subType = f6.sub || null;
        } else {
          var d6 = ["Index", "Name", "Id"], v6 = { name: 1, dataIndex: 1, dataType: 1 };
          Ne(r6, function(m6, b6) {
            for (var x6 = false, S = 0; S < d6.length; S++) {
              var M = d6[S], A6 = b6.lastIndexOf(M);
              if (A6 > 0 && A6 === b6.length - M.length) {
                var I = b6.slice(0, A6);
                I !== "data" && (t2.mainType = I, t2[M.toLowerCase()] = m6, x6 = true);
              }
            }
            v6.hasOwnProperty(b6) && (s[b6] = m6, x6 = true), x6 || (u[b6] = m6);
          });
        }
        return { cptQuery: t2, dataQuery: s, otherQuery: u };
      }, a.prototype.filter = function(r6, t2) {
        var s = this.eventInfo;
        if (!s)
          return true;
        var u = s.targetEl, f6 = s.packedEvent, d6 = s.model, v6 = s.view;
        if (!d6 || !v6)
          return true;
        var m6 = t2.cptQuery, b6 = t2.dataQuery;
        return x6(m6, d6, "mainType") && x6(m6, d6, "subType") && x6(m6, d6, "index", "componentIndex") && x6(m6, d6, "name") && x6(m6, d6, "id") && x6(b6, f6, "name") && x6(b6, f6, "dataIndex") && x6(b6, f6, "dataType") && (!v6.filterForExposedEvent || v6.filterForExposedEvent(r6, t2.otherQuery, u, f6));
        function x6(S, M, A6, I) {
          return S[A6] == null || M[I || A6] === S[A6];
        }
      }, a.prototype.afterTrigger = function() {
        this.eventInfo = null;
      }, a;
    }(), lZ = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], Ufe = lZ.concat(["symbolKeepAspect"]), m4e = { createOnAllSeries: true, performRawSeries: true, reset: function(a, r6) {
      var t2 = a.getData();
      if (a.legendIcon && t2.setVisual("legendIcon", a.legendIcon), !a.hasSymbolVisual)
        return;
      for (var s = {}, u = {}, f6 = false, d6 = 0; d6 < lZ.length; d6++) {
        var v6 = lZ[d6], m6 = a.get(v6);
        ti(m6) ? (f6 = true, u[v6] = m6) : s[v6] = m6;
      }
      if (s.symbol = s.symbol || a.defaultSymbol, t2.setVisual(qn({ legendIcon: a.legendIcon || s.symbol, symbolKeepAspect: a.get("symbolKeepAspect") }, s)), r6.isSeriesFiltered(a))
        return;
      var b6 = Po(u);
      function x6(S, M) {
        for (var A6 = a.getRawValue(M), I = a.getDataParams(M), R = 0; R < b6.length; R++) {
          var F = b6[R];
          S.setItemVisual(M, F, u[F](A6, I));
        }
      }
      return { dataEach: f6 ? x6 : null };
    } }, y4e = { createOnAllSeries: true, performRawSeries: true, reset: function(a, r6) {
      if (!a.hasSymbolVisual || r6.isSeriesFiltered(a))
        return;
      var t2 = a.getData();
      function s(u, f6) {
        for (var d6 = u.getItemModel(f6), v6 = 0; v6 < Ufe.length; v6++) {
          var m6 = Ufe[v6], b6 = d6.getShallow(m6, true);
          b6 != null && u.setItemVisual(f6, m6, b6);
        }
      }
      return { dataEach: t2.hasItemOption ? s : null };
    } };
    function uZ(a, r6, t2) {
      switch (t2) {
        case "color":
          var s = a.getItemVisual(r6, "style");
          return s[a.getVisual("drawType")];
        case "opacity":
          return a.getItemVisual(r6, "style").opacity;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          return a.getItemVisual(r6, t2);
      }
    }
    function ER(a, r6) {
      switch (r6) {
        case "color":
          var t2 = a.getVisual("style");
          return t2[a.getVisual("drawType")];
        case "opacity":
          return a.getVisual("style").opacity;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          return a.getVisual(r6);
      }
    }
    function qfe(a, r6, t2, s) {
      switch (t2) {
        case "color":
          var u = a.ensureUniqueItemVisual(r6, "style");
          u[a.getVisual("drawType")] = s, a.setItemVisual(r6, "colorFromPalette", false);
          break;
        case "opacity":
          a.ensureUniqueItemVisual(r6, "style").opacity = s;
          break;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          a.setItemVisual(r6, t2, s);
          break;
      }
    }
    function Yfe(a, r6) {
      function t2(s, u) {
        var f6 = [];
        return s.eachComponent({ mainType: "series", subType: a, query: u }, function(d6) {
          f6.push(d6.seriesIndex);
        }), f6;
      }
      Ne([[a + "ToggleSelect", "toggleSelect"], [a + "Select", "select"], [a + "UnSelect", "unselect"]], function(s) {
        r6(s[0], function(u, f6, d6) {
          u = qn({}, u), d6.dispatchAction(qn(u, { type: s[1], seriesIndex: t2(f6, u) }));
        });
      });
    }
    function o5(a, r6, t2, s, u) {
      var f6 = a + r6;
      t2.isSilent(f6) || s.eachComponent({ mainType: "series", subType: "pie" }, function(d6) {
        for (var v6 = d6.seriesIndex, m6 = d6.option.selectedMap, b6 = u.selected, x6 = 0; x6 < b6.length; x6++)
          if (b6[x6].seriesIndex === v6) {
            var S = d6.getData(), M = xx(S, u.fromActionPayload);
            t2.trigger(f6, { type: f6, seriesId: d6.id, name: br(M) ? S.getName(M[0]) : S.getName(M), selected: _a2(m6) ? m6 : qn({}, m6) });
          }
      });
    }
    function b4e(a, r6, t2) {
      a.on("selectchanged", function(s) {
        var u = t2.getModel();
        s.isFromClick ? (o5("map", "selectchanged", r6, u, s), o5("pie", "selectchanged", r6, u, s)) : s.fromAction === "select" ? (o5("map", "selected", r6, u, s), o5("pie", "selected", r6, u, s)) : s.fromAction === "unselect" && (o5("map", "unselected", r6, u, s), o5("pie", "unselected", r6, u, s));
      });
    }
    function s5(a, r6, t2) {
      for (var s; a && !(r6(a) && (s = a, t2)); )
        a = a.__hostTarget || a.parent;
      return s;
    }
    var _4e = Math.round(Math.random() * 9), x4e = typeof Object.defineProperty == "function", w4e = function() {
      function a() {
        this._id = "__ec_inner_" + _4e++;
      }
      return a.prototype.get = function(r6) {
        return this._guard(r6)[this._id];
      }, a.prototype.set = function(r6, t2) {
        var s = this._guard(r6);
        return x4e ? Object.defineProperty(s, this._id, { value: t2, enumerable: false, configurable: true }) : s[this._id] = t2, this;
      }, a.prototype.delete = function(r6) {
        return this.has(r6) ? (delete this._guard(r6)[this._id], true) : false;
      }, a.prototype.has = function(r6) {
        return !!this._guard(r6)[this._id];
      }, a.prototype._guard = function(r6) {
        if (r6 !== Object(r6))
          throw TypeError("Value of WeakMap is not a non-null object.");
        return r6;
      }, a;
    }(), S4e = w4e, C4e = uo.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(a, r6) {
      var t2 = r6.cx, s = r6.cy, u = r6.width / 2, f6 = r6.height / 2;
      a.moveTo(t2, s - f6), a.lineTo(t2 + u, s + f6), a.lineTo(t2 - u, s + f6), a.closePath();
    } }), M4e = uo.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(a, r6) {
      var t2 = r6.cx, s = r6.cy, u = r6.width / 2, f6 = r6.height / 2;
      a.moveTo(t2, s - f6), a.lineTo(t2 + u, s), a.lineTo(t2, s + f6), a.lineTo(t2 - u, s), a.closePath();
    } }), A4e = uo.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(a, r6) {
      var t2 = r6.x, s = r6.y, u = r6.width / 5 * 3, f6 = Math.max(u, r6.height), d6 = u / 2, v6 = d6 * d6 / (f6 - d6), m6 = s - f6 + d6 + v6, b6 = Math.asin(v6 / d6), x6 = Math.cos(b6) * d6, S = Math.sin(b6), M = Math.cos(b6), A6 = d6 * 0.6, I = d6 * 0.7;
      a.moveTo(t2 - x6, m6 + v6), a.arc(t2, m6, d6, Math.PI - b6, Math.PI * 2 + b6), a.bezierCurveTo(t2 + x6 - S * A6, m6 + v6 + M * A6, t2, s - I, t2, s), a.bezierCurveTo(t2, s - I, t2 - x6 + S * A6, m6 + v6 + M * A6, t2 - x6, m6 + v6), a.closePath();
    } }), E4e = uo.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(a, r6) {
      var t2 = r6.height, s = r6.width, u = r6.x, f6 = r6.y, d6 = s / 3 * 2;
      a.moveTo(u, f6), a.lineTo(u + d6, f6 + t2), a.lineTo(u, f6 + t2 / 4 * 3), a.lineTo(u - d6, f6 + t2), a.lineTo(u, f6), a.closePath();
    } }), I4e = { line: rh, rect: rs, roundRect: rs, square: rs, circle: Em, diamond: M4e, pin: A4e, arrow: E4e, triangle: C4e }, T4e = { line: function(a, r6, t2, s, u) {
      u.x1 = a, u.y1 = r6 + s / 2, u.x2 = a + t2, u.y2 = r6 + s / 2;
    }, rect: function(a, r6, t2, s, u) {
      u.x = a, u.y = r6, u.width = t2, u.height = s;
    }, roundRect: function(a, r6, t2, s, u) {
      u.x = a, u.y = r6, u.width = t2, u.height = s, u.r = Math.min(t2, s) / 4;
    }, square: function(a, r6, t2, s, u) {
      var f6 = Math.min(t2, s);
      u.x = a, u.y = r6, u.width = f6, u.height = f6;
    }, circle: function(a, r6, t2, s, u) {
      u.cx = a + t2 / 2, u.cy = r6 + s / 2, u.r = Math.min(t2, s) / 2;
    }, diamond: function(a, r6, t2, s, u) {
      u.cx = a + t2 / 2, u.cy = r6 + s / 2, u.width = t2, u.height = s;
    }, pin: function(a, r6, t2, s, u) {
      u.x = a + t2 / 2, u.y = r6 + s / 2, u.width = t2, u.height = s;
    }, arrow: function(a, r6, t2, s, u) {
      u.x = a + t2 / 2, u.y = r6 + s / 2, u.width = t2, u.height = s;
    }, triangle: function(a, r6, t2, s, u) {
      u.cx = a + t2 / 2, u.cy = r6 + s / 2, u.width = t2, u.height = s;
    } }, SV = {};
    Ne(I4e, function(a, r6) {
      SV[r6] = new a();
    });
    var D4e = uo.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(a, r6, t2) {
      var s = FM(a, r6, t2), u = this.shape;
      return u && u.symbolType === "pin" && r6.position === "inside" && (s.y = t2.y + t2.height * 0.4), s;
    }, buildPath: function(a, r6, t2) {
      var s = r6.symbolType;
      if (s !== "none") {
        var u = SV[s];
        u || (s = "rect", u = SV[s]), T4e[s](r6.x, r6.y, r6.width, r6.height, u.shape), u.buildPath(a, u.shape, t2);
      }
    } });
    function k4e(a, r6) {
      if (this.type !== "image") {
        var t2 = this.style;
        this.__isEmptyBrush ? (t2.stroke = a, t2.fill = r6 || "#fff", t2.lineWidth = 2) : this.shape.symbolType === "line" ? t2.stroke = a : t2.fill = a, this.markRedraw();
      }
    }
    function Lf(a, r6, t2, s, u, f6, d6) {
      var v6 = a.indexOf("empty") === 0;
      v6 && (a = a.substr(5, 1).toLowerCase() + a.substr(6));
      var m6;
      return a.indexOf("image://") === 0 ? m6 = Ce(a.slice(8), new Qi(r6, t2, s, u), d6 ? "center" : "cover") : a.indexOf("path://") === 0 ? m6 = ie(a.slice(7), {}, new Qi(r6, t2, s, u), d6 ? "center" : "cover") : m6 = new D4e({ shape: { symbolType: a, x: r6, y: t2, width: s, height: u } }), m6.__isEmptyBrush = v6, m6.setColor = k4e, f6 && m6.setColor(f6), m6;
    }
    function IR(a) {
      return br(a) || (a = [+a, +a]), [a[0] || 0, a[1] || 0];
    }
    function l5(a, r6) {
      if (a != null)
        return br(a) || (a = [a, a]), [ua(a[0], r6[0]) || 0, ua(qi(a[1], a[0]), r6[1]) || 0];
    }
    function P4e(a, r6, t2) {
      var s = r6.x == null ? 0 : r6.x, u = r6.x2 == null ? 1 : r6.x2, f6 = r6.y == null ? 0 : r6.y, d6 = r6.y2 == null ? 0 : r6.y2;
      r6.global || (s = s * t2.width + t2.x, u = u * t2.width + t2.x, f6 = f6 * t2.height + t2.y, d6 = d6 * t2.height + t2.y), s = isNaN(s) ? 0 : s, u = isNaN(u) ? 1 : u, f6 = isNaN(f6) ? 0 : f6, d6 = isNaN(d6) ? 0 : d6;
      var v6 = a.createLinearGradient(s, f6, u, d6);
      return v6;
    }
    function L4e(a, r6, t2) {
      var s = t2.width, u = t2.height, f6 = Math.min(s, u), d6 = r6.x == null ? 0.5 : r6.x, v6 = r6.y == null ? 0.5 : r6.y, m6 = r6.r == null ? 0.5 : r6.r;
      r6.global || (d6 = d6 * s + t2.x, v6 = v6 * u + t2.y, m6 = m6 * f6);
      var b6 = a.createRadialGradient(d6, v6, 0, d6, v6, m6);
      return b6;
    }
    function cZ(a, r6, t2) {
      for (var s = r6.type === "radial" ? L4e(a, r6, t2) : P4e(a, r6, t2), u = r6.colorStops, f6 = 0; f6 < u.length; f6++)
        s.addColorStop(u[f6].offset, u[f6].color);
      return s;
    }
    function O4e(a, r6) {
      if (a === r6 || !a && !r6)
        return false;
      if (!a || !r6 || a.length !== r6.length)
        return true;
      for (var t2 = 0; t2 < a.length; t2++)
        if (a[t2] !== r6[t2])
          return true;
      return false;
    }
    function CV(a) {
      return parseInt(a, 10);
    }
    function u5(a, r6, t2) {
      var s = ["width", "height"][r6], u = ["clientWidth", "clientHeight"][r6], f6 = ["paddingLeft", "paddingTop"][r6], d6 = ["paddingRight", "paddingBottom"][r6];
      if (t2[s] != null && t2[s] !== "auto")
        return parseFloat(t2[s]);
      var v6 = document.defaultView.getComputedStyle(a);
      return (a[u] || CV(v6[s]) || CV(a.style[s])) - (CV(v6[f6]) || 0) - (CV(v6[d6]) || 0) | 0;
    }
    function R4e(a, r6) {
      return !a || a === "solid" || !(r6 > 0) ? null : a === "dashed" ? [4 * r6, 2 * r6] : a === "dotted" ? [r6] : ks(a) ? [a] : br(a) ? a : null;
    }
    function fZ(a) {
      var r6 = a.style, t2 = r6.lineDash && r6.lineWidth > 0 && R4e(r6.lineDash, r6.lineWidth), s = r6.lineDashOffset;
      if (t2) {
        var u = r6.strokeNoScale && a.getLineScale ? a.getLineScale() : 1;
        u && u !== 1 && (t2 = wr(t2, function(f6) {
          return f6 / u;
        }), s /= u);
      }
      return [t2, s];
    }
    var F4e = new wm(true);
    function MV(a) {
      var r6 = a.stroke;
      return !(r6 == null || r6 === "none" || !(a.lineWidth > 0));
    }
    function Zfe(a) {
      return typeof a == "string" && a !== "none";
    }
    function AV(a) {
      var r6 = a.fill;
      return r6 != null && r6 !== "none";
    }
    function Xfe(a, r6) {
      if (r6.fillOpacity != null && r6.fillOpacity !== 1) {
        var t2 = a.globalAlpha;
        a.globalAlpha = r6.fillOpacity * r6.opacity, a.fill(), a.globalAlpha = t2;
      } else
        a.fill();
    }
    function Kfe(a, r6) {
      if (r6.strokeOpacity != null && r6.strokeOpacity !== 1) {
        var t2 = a.globalAlpha;
        a.globalAlpha = r6.strokeOpacity * r6.opacity, a.stroke(), a.globalAlpha = t2;
      } else
        a.stroke();
    }
    function hZ(a, r6, t2) {
      var s = gO(r6.image, r6.__image, t2);
      if (bD(s)) {
        var u = a.createPattern(s, r6.repeat || "repeat");
        if (typeof DOMMatrix == "function" && u && u.setTransform) {
          var f6 = new DOMMatrix();
          f6.translateSelf(r6.x || 0, r6.y || 0), f6.rotateSelf(0, 0, (r6.rotation || 0) * vM), f6.scaleSelf(r6.scaleX || 1, r6.scaleY || 1), u.setTransform(f6);
        }
        return u;
      }
    }
    function N4e(a, r6, t2, s) {
      var u, f6 = MV(t2), d6 = AV(t2), v6 = t2.strokePercent, m6 = v6 < 1, b6 = !r6.path;
      (!r6.silent || m6) && b6 && r6.createPathProxy();
      var x6 = r6.path || F4e, S = r6.__dirty;
      if (!s) {
        var M = t2.fill, A6 = t2.stroke, I = d6 && !!M.colorStops, R = f6 && !!A6.colorStops, F = d6 && !!M.image, j = f6 && !!A6.image, $ = void 0, K = void 0, U = void 0, he = void 0, ue = void 0;
        (I || R) && (ue = r6.getBoundingRect()), I && ($ = S ? cZ(a, M, ue) : r6.__canvasFillGradient, r6.__canvasFillGradient = $), R && (K = S ? cZ(a, A6, ue) : r6.__canvasStrokeGradient, r6.__canvasStrokeGradient = K), F && (U = S || !r6.__canvasFillPattern ? hZ(a, M, r6) : r6.__canvasFillPattern, r6.__canvasFillPattern = U), j && (he = S || !r6.__canvasStrokePattern ? hZ(a, A6, r6) : r6.__canvasStrokePattern, r6.__canvasStrokePattern = U), I ? a.fillStyle = $ : F && (U ? a.fillStyle = U : d6 = false), R ? a.strokeStyle = K : j && (he ? a.strokeStyle = he : f6 = false);
      }
      var pe = r6.getGlobalScale();
      x6.setScale(pe[0], pe[1], r6.segmentIgnoreThreshold);
      var _e, xe;
      a.setLineDash && t2.lineDash && (u = fZ(r6), _e = u[0], xe = u[1]);
      var Ae = true;
      (b6 || S & Xg) && (x6.setDPR(a.dpr), m6 ? x6.setContext(null) : (x6.setContext(a), Ae = false), x6.reset(), r6.buildPath(x6, r6.shape, s), x6.toStatic(), r6.pathUpdated()), Ae && x6.rebuildPath(a, m6 ? v6 : 1), _e && (a.setLineDash(_e), a.lineDashOffset = xe), s || (t2.strokeFirst ? (f6 && Kfe(a, t2), d6 && Xfe(a, t2)) : (d6 && Xfe(a, t2), f6 && Kfe(a, t2))), _e && a.setLineDash([]);
    }
    function V4e(a, r6, t2) {
      var s = r6.__image = gO(t2.image, r6.__image, r6, r6.onload);
      if (!(!s || !bD(s))) {
        var u = t2.x || 0, f6 = t2.y || 0, d6 = r6.getWidth(), v6 = r6.getHeight(), m6 = s.width / s.height;
        if (d6 == null && v6 != null ? d6 = v6 * m6 : v6 == null && d6 != null ? v6 = d6 / m6 : d6 == null && v6 == null && (d6 = s.width, v6 = s.height), t2.sWidth && t2.sHeight) {
          var b6 = t2.sx || 0, x6 = t2.sy || 0;
          a.drawImage(s, b6, x6, t2.sWidth, t2.sHeight, u, f6, d6, v6);
        } else if (t2.sx && t2.sy) {
          var b6 = t2.sx, x6 = t2.sy, S = d6 - b6, M = v6 - x6;
          a.drawImage(s, b6, x6, S, M, u, f6, d6, v6);
        } else
          a.drawImage(s, u, f6, d6, v6);
      }
    }
    function z4e(a, r6, t2) {
      var s, u = t2.text;
      if (u != null && (u += ""), u) {
        a.font = t2.font || Gs, a.textAlign = t2.textAlign, a.textBaseline = t2.textBaseline;
        var f6 = void 0, d6 = void 0;
        a.setLineDash && t2.lineDash && (s = fZ(r6), f6 = s[0], d6 = s[1]), f6 && (a.setLineDash(f6), a.lineDashOffset = d6), t2.strokeFirst ? (MV(t2) && a.strokeText(u, t2.x, t2.y), AV(t2) && a.fillText(u, t2.x, t2.y)) : (AV(t2) && a.fillText(u, t2.x, t2.y), MV(t2) && a.strokeText(u, t2.x, t2.y)), f6 && a.setLineDash([]);
      }
    }
    var Jfe = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], Qfe = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
    function ehe(a, r6, t2, s, u) {
      var f6 = false;
      if (!s && (t2 = t2 || {}, r6 === t2))
        return false;
      if (s || r6.opacity !== t2.opacity) {
        hg(a, u), f6 = true;
        var d6 = Math.max(Math.min(r6.opacity, 1), 0);
        a.globalAlpha = isNaN(d6) ? Ax.opacity : d6;
      }
      (s || r6.blend !== t2.blend) && (f6 || (hg(a, u), f6 = true), a.globalCompositeOperation = r6.blend || Ax.blend);
      for (var v6 = 0; v6 < Jfe.length; v6++) {
        var m6 = Jfe[v6];
        (s || r6[m6] !== t2[m6]) && (f6 || (hg(a, u), f6 = true), a[m6] = a.dpr * (r6[m6] || 0));
      }
      return (s || r6.shadowColor !== t2.shadowColor) && (f6 || (hg(a, u), f6 = true), a.shadowColor = r6.shadowColor || Ax.shadowColor), f6;
    }
    function the(a, r6, t2, s, u) {
      var f6 = TR(r6, u.inHover), d6 = s ? null : t2 && TR(t2, u.inHover) || {};
      if (f6 === d6)
        return false;
      var v6 = ehe(a, f6, d6, s, u);
      if ((s || f6.fill !== d6.fill) && (v6 || (hg(a, u), v6 = true), Zfe(f6.fill) && (a.fillStyle = f6.fill)), (s || f6.stroke !== d6.stroke) && (v6 || (hg(a, u), v6 = true), Zfe(f6.stroke) && (a.strokeStyle = f6.stroke)), (s || f6.opacity !== d6.opacity) && (v6 || (hg(a, u), v6 = true), a.globalAlpha = f6.opacity == null ? 1 : f6.opacity), r6.hasStroke()) {
        var m6 = f6.lineWidth, b6 = m6 / (f6.strokeNoScale && r6.getLineScale ? r6.getLineScale() : 1);
        a.lineWidth !== b6 && (v6 || (hg(a, u), v6 = true), a.lineWidth = b6);
      }
      for (var x6 = 0; x6 < Qfe.length; x6++) {
        var S = Qfe[x6], M = S[0];
        (s || f6[M] !== d6[M]) && (v6 || (hg(a, u), v6 = true), a[M] = f6[M] || S[1]);
      }
      return v6;
    }
    function B4e(a, r6, t2, s, u) {
      return ehe(a, TR(r6, u.inHover), t2 && TR(t2, u.inHover), s, u);
    }
    function nhe(a, r6) {
      var t2 = r6.transform, s = a.dpr || 1;
      t2 ? a.setTransform(s * t2[0], s * t2[1], s * t2[2], s * t2[3], s * t2[4], s * t2[5]) : a.setTransform(s, 0, 0, s, 0, 0);
    }
    function j4e(a, r6, t2) {
      for (var s = false, u = 0; u < a.length; u++) {
        var f6 = a[u];
        s = s || f6.isZeroArea(), nhe(r6, f6), r6.beginPath(), f6.buildPath(r6, f6.shape), r6.clip();
      }
      t2.allClipped = s;
    }
    function G4e(a, r6) {
      return a && r6 ? a[0] !== r6[0] || a[1] !== r6[1] || a[2] !== r6[2] || a[3] !== r6[3] || a[4] !== r6[4] || a[5] !== r6[5] : !(!a && !r6);
    }
    var rhe = 1, ahe = 2, ihe = 3, ohe = 4;
    function W4e(a) {
      var r6 = AV(a), t2 = MV(a);
      return !(a.lineDash || !(+r6 ^ +t2) || r6 && typeof a.fill != "string" || t2 && typeof a.stroke != "string" || a.strokePercent < 1 || a.strokeOpacity < 1 || a.fillOpacity < 1);
    }
    function hg(a, r6) {
      r6.batchFill && a.fill(), r6.batchStroke && a.stroke(), r6.batchFill = "", r6.batchStroke = "";
    }
    function TR(a, r6) {
      return r6 && a.__hoverStyle || a.style;
    }
    function she(a, r6) {
      pA(a, r6, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
    }
    function pA(a, r6, t2, s) {
      var u = r6.transform;
      if (!r6.shouldBePainted(t2.viewWidth, t2.viewHeight, false, false)) {
        r6.__dirty &= ~ad, r6.__isRendered = false;
        return;
      }
      var f6 = r6.__clipPaths, d6 = t2.prevElClipPaths, v6 = false, m6 = false;
      if ((!d6 || O4e(f6, d6)) && (d6 && d6.length && (hg(a, t2), a.restore(), m6 = v6 = true, t2.prevElClipPaths = null, t2.allClipped = false, t2.prevEl = null), f6 && f6.length && (hg(a, t2), a.save(), j4e(f6, a, t2), v6 = true), t2.prevElClipPaths = f6), t2.allClipped) {
        r6.__isRendered = false;
        return;
      }
      r6.beforeBrush && r6.beforeBrush(), r6.innerBeforeBrush();
      var b6 = t2.prevEl;
      b6 || (m6 = v6 = true);
      var x6 = r6 instanceof uo && r6.autoBatch && W4e(r6.style);
      v6 || G4e(u, b6.transform) ? (hg(a, t2), nhe(a, r6)) : x6 || hg(a, t2);
      var S = TR(r6, t2.inHover);
      r6 instanceof uo ? (t2.lastDrawType !== rhe && (m6 = true, t2.lastDrawType = rhe), the(a, r6, b6, m6, t2), (!x6 || !t2.batchFill && !t2.batchStroke) && a.beginPath(), N4e(a, r6, S, x6), x6 && (t2.batchFill = S.fill || "", t2.batchStroke = S.stroke || "")) : r6 instanceof YM ? (t2.lastDrawType !== ihe && (m6 = true, t2.lastDrawType = ihe), the(a, r6, b6, m6, t2), z4e(a, r6, S)) : r6 instanceof nh ? (t2.lastDrawType !== ahe && (m6 = true, t2.lastDrawType = ahe), B4e(a, r6, b6, m6, t2), V4e(a, r6, S)) : r6.getTemporalDisplayables && (t2.lastDrawType !== ohe && (m6 = true, t2.lastDrawType = ohe), H4e(a, r6, t2)), x6 && s && hg(a, t2), r6.innerAfterBrush(), r6.afterBrush && r6.afterBrush(), t2.prevEl = r6, r6.__dirty = 0, r6.__isRendered = true;
    }
    function H4e(a, r6, t2) {
      var s = r6.getDisplayables(), u = r6.getTemporalDisplayables();
      a.save();
      var f6 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: t2.viewWidth, viewHeight: t2.viewHeight, inHover: t2.inHover }, d6, v6;
      for (d6 = r6.getCursor(), v6 = s.length; d6 < v6; d6++) {
        var m6 = s[d6];
        m6.beforeBrush && m6.beforeBrush(), m6.innerBeforeBrush(), pA(a, m6, f6, d6 === v6 - 1), m6.innerAfterBrush(), m6.afterBrush && m6.afterBrush(), f6.prevEl = m6;
      }
      for (var b6 = 0, x6 = u.length; b6 < x6; b6++) {
        var m6 = u[b6];
        m6.beforeBrush && m6.beforeBrush(), m6.innerBeforeBrush(), pA(a, m6, f6, b6 === x6 - 1), m6.innerAfterBrush(), m6.afterBrush && m6.afterBrush(), f6.prevEl = m6;
      }
      r6.clearTemporalDisplayables(), r6.notClear = true, a.restore();
    }
    var dZ = new S4e(), lhe = new Yy(100), uhe = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
    function DR(a, r6) {
      if (a === "none")
        return null;
      var t2 = r6.getDevicePixelRatio(), s = r6.getZr(), u = s.painter.type === "svg";
      a.dirty && dZ.delete(a);
      var f6 = dZ.get(a);
      if (f6)
        return f6;
      var d6 = ei(a, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
      d6.backgroundColor === "none" && (d6.backgroundColor = null);
      var v6 = { repeat: "repeat" };
      return m6(v6), v6.rotation = d6.rotation, v6.scaleX = v6.scaleY = u ? 1 : 1 / t2, dZ.set(a, v6), a.dirty = false, v6;
      function m6(b6) {
        for (var x6 = [t2], S = true, M = 0; M < uhe.length; ++M) {
          var A6 = d6[uhe[M]];
          if (A6 != null && !br(A6) && !_a2(A6) && !ks(A6) && typeof A6 != "boolean") {
            S = false;
            break;
          }
          x6.push(A6);
        }
        var I;
        if (S) {
          I = x6.join(",") + (u ? "-svg" : "");
          var R = lhe.get(I);
          R && (u ? b6.svgElement = R : b6.image = R);
        }
        var F = fhe(d6.dashArrayX), j = $4e(d6.dashArrayY), $ = che(d6.symbol), K = U4e(F), U = hhe(j), he = !u && Tc.createCanvas(), ue = u && { tag: "g", attrs: {}, key: "dcl", children: [] }, pe = xe(), _e;
        he && (he.width = pe.width * t2, he.height = pe.height * t2, _e = he.getContext("2d")), Ae(), S && lhe.put(I, he || ue), b6.image = he, b6.svgElement = ue, b6.svgWidth = pe.width, b6.svgHeight = pe.height;
        function xe() {
          for (var ke = 1, je = 0, Fe = K.length; je < Fe; ++je)
            ke = U9(ke, K[je]);
          for (var at = 1, je = 0, Fe = $.length; je < Fe; ++je)
            at = U9(at, $[je].length);
          ke *= at;
          var ht = U * K.length * $.length;
          return { width: Math.max(1, Math.min(ke, d6.maxTileWidth)), height: Math.max(1, Math.min(ht, d6.maxTileHeight)) };
        }
        function Ae() {
          _e && (_e.clearRect(0, 0, he.width, he.height), d6.backgroundColor && (_e.fillStyle = d6.backgroundColor, _e.fillRect(0, 0, he.width, he.height)));
          for (var ke = 0, je = 0; je < j.length; ++je)
            ke += j[je];
          if (ke <= 0)
            return;
          for (var Fe = -U, at = 0, ht = 0, Qe = 0; Fe < pe.height; ) {
            if (at % 2 === 0) {
              for (var en = ht / 2 % $.length, bt = 0, wt = 0, Ft = 0; bt < pe.width * 2; ) {
                for (var fn = 0, je = 0; je < F[Qe].length; ++je)
                  fn += F[Qe][je];
                if (fn <= 0)
                  break;
                if (wt % 2 === 0) {
                  var gn = (1 - d6.symbolSize) * 0.5, Zr = bt + F[Qe][wt] * gn, Ma = Fe + j[at] * gn, Ua = F[Qe][wt] * d6.symbolSize, ja = j[at] * d6.symbolSize, Ga = Ft / 2 % $[en].length;
                  pa(Zr, Ma, Ua, ja, $[en][Ga]);
                }
                bt += F[Qe][wt], ++Ft, ++wt, wt === F[Qe].length && (wt = 0);
              }
              ++Qe, Qe === F.length && (Qe = 0);
            }
            Fe += j[at], ++ht, ++at, at === j.length && (at = 0);
          }
          function pa(Fa, Ha, Sa, oi, bs) {
            var Si = u ? 1 : t2, Ls = Lf(bs, Fa * Si, Ha * Si, Sa * Si, oi * Si, d6.color, d6.symbolKeepAspect);
            if (u) {
              var tl = s.painter.renderOneToVNode(Ls);
              tl && ue.children.push(tl);
            } else
              she(_e, Ls);
          }
        }
      }
    }
    function che(a) {
      if (!a || a.length === 0)
        return [["rect"]];
      if (_a2(a))
        return [[a]];
      for (var r6 = true, t2 = 0; t2 < a.length; ++t2)
        if (!_a2(a[t2])) {
          r6 = false;
          break;
        }
      if (r6)
        return che([a]);
      for (var s = [], t2 = 0; t2 < a.length; ++t2)
        _a2(a[t2]) ? s.push([a[t2]]) : s.push(a[t2]);
      return s;
    }
    function fhe(a) {
      if (!a || a.length === 0)
        return [[0, 0]];
      if (ks(a)) {
        var r6 = Math.ceil(a);
        return [[r6, r6]];
      }
      for (var t2 = true, s = 0; s < a.length; ++s)
        if (!ks(a[s])) {
          t2 = false;
          break;
        }
      if (t2)
        return fhe([a]);
      for (var u = [], s = 0; s < a.length; ++s)
        if (ks(a[s])) {
          var r6 = Math.ceil(a[s]);
          u.push([r6, r6]);
        } else {
          var r6 = wr(a[s], function(v6) {
            return Math.ceil(v6);
          });
          r6.length % 2 === 1 ? u.push(r6.concat(r6)) : u.push(r6);
        }
      return u;
    }
    function $4e(a) {
      if (!a || typeof a == "object" && a.length === 0)
        return [0, 0];
      if (ks(a)) {
        var r6 = Math.ceil(a);
        return [r6, r6];
      }
      var t2 = wr(a, function(s) {
        return Math.ceil(s);
      });
      return a.length % 2 ? t2.concat(t2) : t2;
    }
    function U4e(a) {
      return wr(a, function(r6) {
        return hhe(r6);
      });
    }
    function hhe(a) {
      for (var r6 = 0, t2 = 0; t2 < a.length; ++t2)
        r6 += a[t2];
      return a.length % 2 === 1 ? r6 * 2 : r6;
    }
    function q4e(a, r6) {
      a.eachRawSeries(function(t2) {
        if (!a.isSeriesFiltered(t2)) {
          var s = t2.getData();
          s.hasItemVisual() && s.each(function(d6) {
            var v6 = s.getItemVisual(d6, "decal");
            if (v6) {
              var m6 = s.ensureUniqueItemVisual(d6, "style");
              m6.decal = DR(v6, r6);
            }
          });
          var u = s.getVisual("decal");
          if (u) {
            var f6 = s.getVisual("style");
            f6.decal = DR(u, r6);
          }
        }
      });
    }
    var Y4e = new Ip(), u1 = Y4e, dhe = {};
    function Z4e(a, r6) {
      dhe[a] = r6;
    }
    function X4e(a) {
      return dhe[a];
    }
    var K4e = typeof window != "undefined", J4e = 1, Q4e = 800, e6e = 900, t6e = 1e3, n6e = 2e3, r6e = 5e3, phe = 1e3, a6e = 1100, pZ = 2e3, vhe = 3e3, i6e = 4e3, EV = 4500, o6e = 4600, s6e = 5e3, l6e = 6e3, ghe = 7e3, u6e = { PROCESSOR: { FILTER: t6e, SERIES_FILTER: Q4e, STATISTIC: r6e }, VISUAL: { LAYOUT: phe, PROGRESSIVE_LAYOUT: a6e, GLOBAL: pZ, CHART: vhe, POST_CHART_LAYOUT: o6e, COMPONENT: i6e, BRUSH: s6e, CHART_ITEM: EV, ARIA: l6e, DECAL: ghe } }, Wp = "__flagInMainProcess", dg = "__pendingUpdate", vZ = "__needsUpdateStatus", mhe = /^[a-zA-Z0-9_]+$/, gZ = "__connectUpdateStatus", yhe = 0, c6e = 1, f6e = 2;
    function bhe(a) {
      return function() {
        for (var r6 = [], t2 = 0; t2 < arguments.length; t2++)
          r6[t2] = arguments[t2];
        if (this.isDisposed()) {
          this.id;
          return;
        }
        return xhe(this, a, r6);
      };
    }
    function _he(a) {
      return function() {
        for (var r6 = [], t2 = 0; t2 < arguments.length; t2++)
          r6[t2] = arguments[t2];
        return xhe(this, a, r6);
      };
    }
    function xhe(a, r6, t2) {
      return t2[0] = t2[0] && t2[0].toLowerCase(), Ip.prototype[r6].apply(a, t2);
    }
    var whe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6;
    }(Ip), She = whe.prototype;
    She.on = _he("on"), She.off = _he("off");
    var c5, mZ, IV, Q2, yZ, bZ, _Z, kR, PR, Che, Mhe, xZ, Ahe, TV, Ehe, Ihe, Om, The, Dhe = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this, new g4e()) || this;
        f6._chartsViews = [], f6._chartsMap = {}, f6._componentsViews = [], f6._componentsMap = {}, f6._pendingActions = [], u = u || {}, _a2(s) && (s = khe[s]), f6._dom = t2;
        var d6 = "canvas", v6 = false, m6 = f6._zr = _x(t2, { renderer: u.renderer || d6, devicePixelRatio: u.devicePixelRatio, width: u.width, height: u.height, ssr: u.ssr, useDirtyRect: u.useDirtyRect == null ? v6 : u.useDirtyRect });
        f6._ssr = u.ssr, f6._throttledZrFlush = sZ(Ca(m6.flush, m6), 17), s = Qa(s), s && Uce(s, true), f6._theme = s, f6._locale = xOe(u.locale || ace), f6._coordSysMgr = new yR();
        var b6 = f6._api = Ehe(f6);
        function x6(S, M) {
          return S.__prio - M.__prio;
        }
        return qd(kV, x6), qd(SZ, x6), f6._scheduler = new jfe(f6, b6, SZ, kV), f6._messageCenter = new whe(), f6._initEvents(), f6.resize = Ca(f6.resize, f6), m6.animation.on("frame", f6._onframe, f6), Che(m6, f6), Mhe(m6, f6), cm(f6), f6;
      }
      return r6.prototype._onframe = function() {
        if (!this._disposed) {
          The(this);
          var t2 = this._scheduler;
          if (this[dg]) {
            var s = this[dg].silent;
            this[Wp] = true;
            try {
              c5(this), Q2.update.call(this, null, this[dg].updateParams);
            } catch (m6) {
              throw this[Wp] = false, this[dg] = null, m6;
            }
            this._zr.flush(), this[Wp] = false, this[dg] = null, kR.call(this, s), PR.call(this, s);
          } else if (t2.unfinished) {
            var u = J4e, f6 = this._model, d6 = this._api;
            t2.unfinished = false;
            do {
              var v6 = +new Date();
              t2.performSeriesTasks(f6), t2.performDataProcessorTasks(f6), bZ(this, f6), t2.performVisualTasks(f6), TV(this, this._model, d6, "remain", {}), u -= +new Date() - v6;
            } while (u > 0 && t2.unfinished);
            t2.unfinished || this._zr.flush();
          }
        }
      }, r6.prototype.getDom = function() {
        return this._dom;
      }, r6.prototype.getId = function() {
        return this.id;
      }, r6.prototype.getZr = function() {
        return this._zr;
      }, r6.prototype.isSSR = function() {
        return this._ssr;
      }, r6.prototype.setOption = function(t2, s, u) {
        if (!this[Wp]) {
          if (this._disposed) {
            this.id;
            return;
          }
          var f6, d6, v6;
          if (ui(s) && (u = s.lazyUpdate, f6 = s.silent, d6 = s.replaceMerge, v6 = s.transition, s = s.notMerge), this[Wp] = true, !this._model || s) {
            var m6 = new tRe(this._api), b6 = this._theme, x6 = this._model = new Vce();
            x6.scheduler = this._scheduler, x6.ssr = this._ssr, x6.init(null, null, null, b6, this._locale, m6);
          }
          this._model.setOption(t2, { replaceMerge: d6 }, CZ);
          var S = { seriesTransition: v6, optionChanged: true };
          if (u)
            this[dg] = { silent: f6, updateParams: S }, this[Wp] = false, this.getZr().wakeUp();
          else {
            try {
              c5(this), Q2.update.call(this, null, S);
            } catch (M) {
              throw this[dg] = null, this[Wp] = false, M;
            }
            this._ssr || this._zr.flush(), this[dg] = null, this[Wp] = false, kR.call(this, f6), PR.call(this, f6);
          }
        }
      }, r6.prototype.setTheme = function() {
      }, r6.prototype.getModel = function() {
        return this._model;
      }, r6.prototype.getOption = function() {
        return this._model && this._model.getOption();
      }, r6.prototype.getWidth = function() {
        return this._zr.getWidth();
      }, r6.prototype.getHeight = function() {
        return this._zr.getHeight();
      }, r6.prototype.getDevicePixelRatio = function() {
        return this._zr.painter.dpr || K4e && window.devicePixelRatio || 1;
      }, r6.prototype.getRenderedCanvas = function(t2) {
        return this.renderToCanvas(t2);
      }, r6.prototype.renderToCanvas = function(t2) {
        t2 = t2 || {};
        var s = this._zr.painter;
        return s.getRenderedCanvas({ backgroundColor: t2.backgroundColor || this._model.get("backgroundColor"), pixelRatio: t2.pixelRatio || this.getDevicePixelRatio() });
      }, r6.prototype.renderToSVGString = function(t2) {
        t2 = t2 || {};
        var s = this._zr.painter;
        return s.renderToString({ useViewBox: t2.useViewBox });
      }, r6.prototype.getSvgDataURL = function() {
        if (ha.svgSupported) {
          var t2 = this._zr, s = t2.storage.getDisplayList();
          return Ne(s, function(u) {
            u.stopAnimation(null, true);
          }), t2.painter.toDataURL();
        }
      }, r6.prototype.getDataURL = function(t2) {
        if (this._disposed) {
          this.id;
          return;
        }
        t2 = t2 || {};
        var s = t2.excludeComponents, u = this._model, f6 = [], d6 = this;
        Ne(s, function(m6) {
          u.eachComponent({ mainType: m6 }, function(b6) {
            var x6 = d6._componentsMap[b6.__viewId];
            x6.group.ignore || (f6.push(x6), x6.group.ignore = true);
          });
        });
        var v6 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(t2).toDataURL("image/" + (t2 && t2.type || "png"));
        return Ne(f6, function(m6) {
          m6.group.ignore = false;
        }), v6;
      }, r6.prototype.getConnectedDataURL = function(t2) {
        if (this._disposed) {
          this.id;
          return;
        }
        var s = t2.type === "svg", u = this.group, f6 = Math.min, d6 = Math.max, v6 = 1 / 0;
        if (Phe[u]) {
          var m6 = v6, b6 = v6, x6 = -v6, S = -v6, M = [], A6 = t2 && t2.pixelRatio || this.getDevicePixelRatio();
          Ne(OR, function(K, U) {
            if (K.group === u) {
              var he = s ? K.getZr().painter.getSvgDom().innerHTML : K.renderToCanvas(Qa(t2)), ue = K.getDom().getBoundingClientRect();
              m6 = f6(ue.left, m6), b6 = f6(ue.top, b6), x6 = d6(ue.right, x6), S = d6(ue.bottom, S), M.push({ dom: he, left: ue.left, top: ue.top });
            }
          }), m6 *= A6, b6 *= A6, x6 *= A6, S *= A6;
          var I = x6 - m6, R = S - b6, F = Tc.createCanvas(), j = _x(F, { renderer: s ? "svg" : "canvas" });
          if (j.resize({ width: I, height: R }), s) {
            var $ = "";
            return Ne(M, function(K) {
              var U = K.left - m6, he = K.top - b6;
              $ += '<g transform="translate(' + U + "," + he + ')">' + K.dom + "</g>";
            }), j.painter.getSvgRoot().innerHTML = $, t2.connectedBackgroundColor && j.painter.setBackgroundColor(t2.connectedBackgroundColor), j.refreshImmediately(), j.painter.toDataURL();
          } else
            return t2.connectedBackgroundColor && j.add(new rs({ shape: { x: 0, y: 0, width: I, height: R }, style: { fill: t2.connectedBackgroundColor } })), Ne(M, function(K) {
              var U = new nh({ style: { x: K.left * A6 - m6, y: K.top * A6 - b6, image: K.dom } });
              j.add(U);
            }), j.refreshImmediately(), F.toDataURL("image/" + (t2 && t2.type || "png"));
        } else
          return this.getDataURL(t2);
      }, r6.prototype.convertToPixel = function(t2, s) {
        return yZ(this, "convertToPixel", t2, s);
      }, r6.prototype.convertFromPixel = function(t2, s) {
        return yZ(this, "convertFromPixel", t2, s);
      }, r6.prototype.containPixel = function(t2, s) {
        if (this._disposed) {
          this.id;
          return;
        }
        var u = this._model, f6, d6 = HM(u, t2);
        return Ne(d6, function(v6, m6) {
          m6.indexOf("Models") >= 0 && Ne(v6, function(b6) {
            var x6 = b6.coordinateSystem;
            if (x6 && x6.containPoint)
              f6 = f6 || !!x6.containPoint(s);
            else if (m6 === "seriesModels") {
              var S = this._chartsMap[b6.__viewId];
              S && S.containPoint && (f6 = f6 || S.containPoint(s, b6));
            }
          }, this);
        }, this), !!f6;
      }, r6.prototype.getVisual = function(t2, s) {
        var u = this._model, f6 = HM(u, t2, { defaultMainType: "series" }), d6 = f6.seriesModel, v6 = d6.getData(), m6 = f6.hasOwnProperty("dataIndexInside") ? f6.dataIndexInside : f6.hasOwnProperty("dataIndex") ? v6.indexOfRawIndex(f6.dataIndex) : null;
        return m6 != null ? uZ(v6, m6, s) : ER(v6, s);
      }, r6.prototype.getViewOfComponentModel = function(t2) {
        return this._componentsMap[t2.__viewId];
      }, r6.prototype.getViewOfSeriesModel = function(t2) {
        return this._chartsMap[t2.__viewId];
      }, r6.prototype._initEvents = function() {
        var t2 = this;
        Ne(h6e, function(s) {
          var u = function(f6) {
            var d6 = t2.getModel(), v6 = f6.target, m6, b6 = s === "globalout";
            if (b6 ? m6 = {} : v6 && s5(v6, function(I) {
              var R = ii(I);
              if (R && R.dataIndex != null) {
                var F = R.dataModel || d6.getSeriesByIndex(R.seriesIndex);
                return m6 = F && F.getDataParams(R.dataIndex, R.dataType) || {}, true;
              } else if (R.eventData)
                return m6 = qn({}, R.eventData), true;
            }, true), m6) {
              var x6 = m6.componentType, S = m6.componentIndex;
              (x6 === "markLine" || x6 === "markPoint" || x6 === "markArea") && (x6 = "series", S = m6.seriesIndex);
              var M = x6 && S != null && d6.getComponent(x6, S), A6 = M && t2[M.mainType === "series" ? "_chartsMap" : "_componentsMap"][M.__viewId];
              m6.event = f6, m6.type = s, t2._$eventProcessor.eventInfo = { targetEl: v6, packedEvent: m6, model: M, view: A6 }, t2.trigger(s, m6);
            }
          };
          u.zrEventfulCallAtLast = true, t2._zr.on(s, u, t2);
        }), Ne(LR, function(s, u) {
          t2._messageCenter.on(u, function(f6) {
            this.trigger(u, f6);
          }, t2);
        }), Ne(["selectchanged"], function(s) {
          t2._messageCenter.on(s, function(u) {
            this.trigger(s, u);
          }, t2);
        }), b4e(this._messageCenter, this, this._api);
      }, r6.prototype.isDisposed = function() {
        return this._disposed;
      }, r6.prototype.clear = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this.setOption({ series: [] }, true);
      }, r6.prototype.dispose = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this._disposed = true;
        var t2 = this.getDom();
        t2 && Z9(this.getDom(), AZ, "");
        var s = this, u = s._api, f6 = s._model;
        Ne(s._componentsViews, function(d6) {
          d6.dispose(f6, u);
        }), Ne(s._chartsViews, function(d6) {
          d6.dispose(f6, u);
        }), s._zr.dispose(), s._dom = s._model = s._chartsMap = s._componentsMap = s._chartsViews = s._componentsViews = s._scheduler = s._api = s._zr = s._throttledZrFlush = s._theme = s._coordSysMgr = s._messageCenter = null, delete OR[s.id];
      }, r6.prototype.resize = function(t2) {
        if (!this[Wp]) {
          if (this._disposed) {
            this.id;
            return;
          }
          this._zr.resize(t2);
          var s = this._model;
          if (this._loadingFX && this._loadingFX.resize(), !!s) {
            var u = s.resetOption("media"), f6 = t2 && t2.silent;
            this[dg] && (f6 == null && (f6 = this[dg].silent), u = true, this[dg] = null), this[Wp] = true;
            try {
              u && c5(this), Q2.update.call(this, { type: "resize", animation: qn({ duration: 0 }, t2 && t2.animation) });
            } catch (d6) {
              throw this[Wp] = false, d6;
            }
            this[Wp] = false, kR.call(this, f6), PR.call(this, f6);
          }
        }
      }, r6.prototype.showLoading = function(t2, s) {
        if (this._disposed) {
          this.id;
          return;
        }
        if (ui(t2) && (s = t2, t2 = ""), t2 = t2 || "default", this.hideLoading(), !!MZ[t2]) {
          var u = MZ[t2](this._api, s), f6 = this._zr;
          this._loadingFX = u, f6.add(u);
        }
      }, r6.prototype.hideLoading = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
      }, r6.prototype.makeActionFromEvent = function(t2) {
        var s = qn({}, t2);
        return s.type = LR[t2.type], s;
      }, r6.prototype.dispatchAction = function(t2, s) {
        if (this._disposed) {
          this.id;
          return;
        }
        if (ui(s) || (s = { silent: !!s }), !!DV[t2.type] && !!this._model) {
          if (this[Wp]) {
            this._pendingActions.push(t2);
            return;
          }
          var u = s.silent;
          _Z.call(this, t2, u);
          var f6 = s.flush;
          f6 ? this._zr.flush() : f6 !== false && ha.browser.weChat && this._throttledZrFlush(), kR.call(this, u), PR.call(this, u);
        }
      }, r6.prototype.updateLabelLayout = function() {
        u1.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
      }, r6.prototype.appendData = function(t2) {
        if (this._disposed) {
          this.id;
          return;
        }
        var s = t2.seriesIndex, u = this.getModel(), f6 = u.getSeriesByIndex(s);
        f6.appendData(t2), this._scheduler.unfinished = true, this.getZr().wakeUp();
      }, r6.internalField = function() {
        c5 = function(S) {
          var M = S._scheduler;
          M.restorePipelines(S._model), M.prepareStageTasks(), mZ(S, true), mZ(S, false), M.plan();
        }, mZ = function(S, M) {
          for (var A6 = S._model, I = S._scheduler, R = M ? S._componentsViews : S._chartsViews, F = M ? S._componentsMap : S._chartsMap, j = S._zr, $ = S._api, K = 0; K < R.length; K++)
            R[K].__alive = false;
          M ? A6.eachComponent(function(ue, pe) {
            ue !== "series" && U(pe);
          }) : A6.eachSeries(U);
          function U(ue) {
            var pe = ue.__requireNewView;
            ue.__requireNewView = false;
            var _e = "_ec_" + ue.id + "_" + ue.type, xe = !pe && F[_e];
            if (!xe) {
              var Ae = Lp(ue.type), ke = M ? Rc.getClass(Ae.main, Ae.sub) : bu.getClass(Ae.sub);
              xe = new ke(), xe.init(A6, $), F[_e] = xe, R.push(xe), j.add(xe.group);
            }
            ue.__viewId = xe.__id = _e, xe.__alive = true, xe.__model = ue, xe.group.__ecComponentInfo = { mainType: ue.mainType, index: ue.componentIndex }, !M && I.prepareView(xe, ue, A6, $);
          }
          for (var K = 0; K < R.length; ) {
            var he = R[K];
            he.__alive ? K++ : (!M && he.renderTask.dispose(), j.remove(he.group), he.dispose(A6, $), R.splice(K, 1), F[he.__id] === he && delete F[he.__id], he.__id = he.group.__ecComponentInfo = null);
          }
        }, IV = function(S, M, A6, I, R) {
          var F = S._model;
          if (F.setUpdatePayload(A6), !I) {
            Ne([].concat(S._componentsViews).concat(S._chartsViews), he);
            return;
          }
          var j = {};
          j[I + "Id"] = A6[I + "Id"], j[I + "Index"] = A6[I + "Index"], j[I + "Name"] = A6[I + "Name"];
          var $ = { mainType: I, query: j };
          R && ($.subType = R);
          var K = A6.excludeSeriesId, U;
          K != null && (U = Ta(), Ne(ll(K), function(ue) {
            var pe = Zc(ue, null);
            pe != null && U.set(pe, true);
          })), F && F.eachComponent($, function(ue) {
            var pe = U && U.get(ue.id) !== null;
            if (!pe)
              if (RD(A6))
                if (ue instanceof sc)
                  A6.type === Lx && !A6.notBlur && !ue.get(["emphasis", "disabled"]) && jl(ue, A6, S._api);
                else {
                  var _e = $O(ue.mainType, ue.componentIndex, A6.name, S._api), xe = _e.focusSelf, Ae = _e.dispatchers;
                  A6.type === Lx && xe && !A6.notBlur && HO(ue.mainType, ue.componentIndex, S._api), Ae && Ne(Ae, function(ke) {
                    A6.type === Lx ? Cm(ke) : Mm(ke);
                  });
                }
              else
                YO(A6) && ue instanceof sc && (Uq(ue, A6, S._api), P7(ue), Om(S));
          }, S), F && F.eachComponent($, function(ue) {
            var pe = U && U.get(ue.id) !== null;
            pe || he(S[I === "series" ? "_chartsMap" : "_componentsMap"][ue.__viewId]);
          }, S);
          function he(ue) {
            ue && ue.__alive && ue[M] && ue[M](ue.__model, F, S._api, A6);
          }
        }, Q2 = { prepareAndUpdate: function(S) {
          c5(this), Q2.update.call(this, S, { optionChanged: S.newOption != null });
        }, update: function(S, M) {
          var A6 = this._model, I = this._api, R = this._zr, F = this._coordSysMgr, j = this._scheduler;
          if (A6) {
            A6.setUpdatePayload(S), j.restoreData(A6, S), j.performSeriesTasks(A6), F.create(A6, I), j.performDataProcessorTasks(A6, S), bZ(this, A6), F.update(A6, I), t2(A6), j.performVisualTasks(A6, S), xZ(this, A6, I, S, M);
            var $ = A6.get("backgroundColor") || "transparent", K = A6.get("darkMode");
            R.setBackgroundColor($), K != null && K !== "auto" && R.setDarkMode(K), u1.trigger("afterupdate", A6, I);
          }
        }, updateTransform: function(S) {
          var M = this, A6 = this._model, I = this._api;
          if (A6) {
            A6.setUpdatePayload(S);
            var R = [];
            A6.eachComponent(function(j, $) {
              if (j !== "series") {
                var K = M.getViewOfComponentModel($);
                if (K && K.__alive)
                  if (K.updateTransform) {
                    var U = K.updateTransform($, A6, I, S);
                    U && U.update && R.push(K);
                  } else
                    R.push(K);
              }
            });
            var F = Ta();
            A6.eachSeries(function(j) {
              var $ = M._chartsMap[j.__viewId];
              if ($.updateTransform) {
                var K = $.updateTransform(j, A6, I, S);
                K && K.update && F.set(j.uid, 1);
              } else
                F.set(j.uid, 1);
            }), t2(A6), this._scheduler.performVisualTasks(A6, S, { setDirty: true, dirtyMap: F }), TV(this, A6, I, S, {}, F), u1.trigger("afterupdate", A6, I);
          }
        }, updateView: function(S) {
          var M = this._model;
          !M || (M.setUpdatePayload(S), bu.markUpdateMethod(S, "updateView"), t2(M), this._scheduler.performVisualTasks(M, S, { setDirty: true }), xZ(this, M, this._api, S, {}), u1.trigger("afterupdate", M, this._api));
        }, updateVisual: function(S) {
          var M = this, A6 = this._model;
          !A6 || (A6.setUpdatePayload(S), A6.eachSeries(function(I) {
            I.getData().clearAllVisual();
          }), bu.markUpdateMethod(S, "updateVisual"), t2(A6), this._scheduler.performVisualTasks(A6, S, { visualType: "visual", setDirty: true }), A6.eachComponent(function(I, R) {
            if (I !== "series") {
              var F = M.getViewOfComponentModel(R);
              F && F.__alive && F.updateVisual(R, A6, M._api, S);
            }
          }), A6.eachSeries(function(I) {
            var R = M._chartsMap[I.__viewId];
            R.updateVisual(I, A6, M._api, S);
          }), u1.trigger("afterupdate", A6, this._api));
        }, updateLayout: function(S) {
          Q2.update.call(this, S);
        } }, yZ = function(S, M, A6, I) {
          if (S._disposed) {
            S.id;
            return;
          }
          for (var R = S._model, F = S._coordSysMgr.getCoordinateSystems(), j, $ = HM(R, A6), K = 0; K < F.length; K++) {
            var U = F[K];
            if (U[M] && (j = U[M](R, $, I)) != null)
              return j;
          }
        }, bZ = function(S, M) {
          var A6 = S._chartsMap, I = S._scheduler;
          M.eachSeries(function(R) {
            I.updateStreamModes(R, A6[R.__viewId]);
          });
        }, _Z = function(S, M) {
          var A6 = this, I = this.getModel(), R = S.type, F = S.escapeConnect, j = DV[R], $ = j.actionInfo, K = ($.update || "update").split(":"), U = K.pop(), he = K[0] != null && Lp(K[0]);
          this[Wp] = true;
          var ue = [S], pe = false;
          S.batch && (pe = true, ue = wr(S.batch, function(at) {
            return at = ei(qn({}, at), S), at.batch = null, at;
          }));
          var _e = [], xe, Ae = YO(S), ke = RD(S);
          if (ke && Ev(this._api), Ne(ue, function(at) {
            if (xe = j.action(at, A6._model, A6._api), xe = xe || qn({}, at), xe.type = $.event || xe.type, _e.push(xe), ke) {
              var ht = Sx(S), Qe = ht.queryOptionMap, en = ht.mainTypeSpecified, bt = en ? Qe.keys()[0] : "series";
              IV(A6, U, at, bt), Om(A6);
            } else
              Ae ? (IV(A6, U, at, "series"), Om(A6)) : he && IV(A6, U, at, he.main, he.sub);
          }), U !== "none" && !ke && !Ae && !he)
            try {
              this[dg] ? (c5(this), Q2.update.call(this, S), this[dg] = null) : Q2[U].call(this, S);
            } catch (at) {
              throw this[Wp] = false, at;
            }
          if (pe ? xe = { type: $.event || R, escapeConnect: F, batch: _e } : xe = _e[0], this[Wp] = false, !M) {
            var je = this._messageCenter;
            if (je.trigger(xe.type, xe), Ae) {
              var Fe = { type: "selectchanged", escapeConnect: F, selected: qq(I), isFromClick: S.isFromClick || false, fromAction: S.type, fromActionPayload: S };
              je.trigger(Fe.type, Fe);
            }
          }
        }, kR = function(S) {
          for (var M = this._pendingActions; M.length; ) {
            var A6 = M.shift();
            _Z.call(this, A6, S);
          }
        }, PR = function(S) {
          !S && this.trigger("updated");
        }, Che = function(S, M) {
          S.on("rendered", function(A6) {
            M.trigger("rendered", A6), S.animation.isFinished() && !M[dg] && !M._scheduler.unfinished && !M._pendingActions.length && M.trigger("finished");
          });
        }, Mhe = function(S, M) {
          S.on("mouseover", function(A6) {
            var I = A6.target, R = s5(I, QM);
            R && (k7(R, A6, M._api), Om(M));
          }).on("mouseout", function(A6) {
            var I = A6.target, R = s5(I, QM);
            R && (OD(R, A6, M._api), Om(M));
          }).on("click", function(A6) {
            var I = A6.target, R = s5(I, function($) {
              return ii($).dataIndex != null;
            }, true);
            if (R) {
              var F = R.selected ? "unselect" : "select", j = ii(R);
              M._api.dispatchAction({ type: F, dataType: j.dataType, dataIndexInside: j.dataIndex, seriesIndex: j.seriesIndex, isFromClick: true });
            }
          });
        };
        function t2(S) {
          S.clearColorPalette(), S.eachSeries(function(M) {
            M.clearColorPalette();
          });
        }
        function s(S) {
          var M = [], A6 = [], I = false;
          if (S.eachComponent(function($, K) {
            var U = K.get("zlevel") || 0, he = K.get("z") || 0, ue = K.getZLevelKey();
            I = I || !!ue, ($ === "series" ? A6 : M).push({ zlevel: U, z: he, idx: K.componentIndex, type: $, key: ue });
          }), I) {
            var R = M.concat(A6), F, j;
            qd(R, function($, K) {
              return $.zlevel === K.zlevel ? $.z - K.z : $.zlevel - K.zlevel;
            }), Ne(R, function($) {
              var K = S.getComponent($.type, $.idx), U = $.zlevel, he = $.key;
              F != null && (U = Math.max(F, U)), he ? (U === F && he !== j && U++, j = he) : j && (U === F && U++, j = ""), F = U, K.setZLevel(U);
            });
          }
        }
        xZ = function(S, M, A6, I, R) {
          s(M), Ahe(S, M, A6, I, R), Ne(S._chartsViews, function(F) {
            F.__alive = false;
          }), TV(S, M, A6, I, R), Ne(S._chartsViews, function(F) {
            F.__alive || F.remove(M, A6);
          });
        }, Ahe = function(S, M, A6, I, R, F) {
          Ne(F || S._componentsViews, function(j) {
            var $ = j.__model;
            b6($, j), j.render($, M, A6, I), v6($, j), x6($, j);
          });
        }, TV = function(S, M, A6, I, R, F) {
          var j = S._scheduler;
          R = qn(R || {}, { updatedSeries: M.getSeries() }), u1.trigger("series:beforeupdate", M, A6, R);
          var $ = false;
          M.eachSeries(function(K) {
            var U = S._chartsMap[K.__viewId];
            U.__alive = true;
            var he = U.renderTask;
            j.updatePayload(he, I), b6(K, U), F && F.get(K.uid) && he.dirty(), he.perform(j.getPerformArgs(he)) && ($ = true), U.group.silent = !!K.get("silent"), d6(K, U), P7(K);
          }), j.unfinished = $ || j.unfinished, u1.trigger("series:layoutlabels", M, A6, R), u1.trigger("series:transition", M, A6, R), M.eachSeries(function(K) {
            var U = S._chartsMap[K.__viewId];
            v6(K, U), x6(K, U);
          }), f6(S, M), u1.trigger("series:afterupdate", M, A6, R);
        }, Om = function(S) {
          S[vZ] = true, S.getZr().wakeUp();
        }, The = function(S) {
          !S[vZ] || (S.getZr().storage.traverse(function(M) {
            q22(M) || u(M);
          }), S[vZ] = false);
        };
        function u(S) {
          for (var M = [], A6 = S.currentStates, I = 0; I < A6.length; I++) {
            var R = A6[I];
            R === "emphasis" || R === "blur" || R === "select" || M.push(R);
          }
          S.selected && S.states.select && M.push("select"), S.hoverState === TD && S.states.emphasis ? M.push("emphasis") : S.hoverState === Yu && S.states.blur && M.push("blur"), S.useStates(M);
        }
        function f6(S, M) {
          var A6 = S._zr, I = A6.storage, R = 0;
          I.traverse(function(F) {
            F.isGroup || R++;
          }), R > M.get("hoverLayerThreshold") && !ha.node && !ha.worker && M.eachSeries(function(F) {
            if (!F.preventUsingHoverLayer) {
              var j = S._chartsMap[F.__viewId];
              j.__alive && j.eachRendered(function($) {
                $.states.emphasis && ($.states.emphasis.hoverLayer = true);
              });
            }
          });
        }
        function d6(S, M) {
          var A6 = S.get("blendMode") || null;
          M.eachRendered(function(I) {
            I.isGroup || (I.style.blend = A6);
          });
        }
        function v6(S, M) {
          if (!S.preventAutoZ) {
            var A6 = S.get("z") || 0, I = S.get("zlevel") || 0;
            M.eachRendered(function(R) {
              return m6(R, A6, I, -1 / 0), true;
            });
          }
        }
        function m6(S, M, A6, I) {
          var R = S.getTextContent(), F = S.getTextGuideLine(), j = S.isGroup;
          if (j)
            for (var $ = S.childrenRef(), K = 0; K < $.length; K++)
              I = Math.max(m6($[K], M, A6, I), I);
          else
            S.z = M, S.zlevel = A6, I = Math.max(S.z2, I);
          if (R && (R.z = M, R.zlevel = A6, isFinite(I) && (R.z2 = I + 2)), F) {
            var U = S.textGuideLineConfig;
            F.z = M, F.zlevel = A6, isFinite(I) && (F.z2 = I + (U && U.showAbove ? 1 : -1));
          }
          return I;
        }
        function b6(S, M) {
          M.eachRendered(function(A6) {
            if (!q22(A6)) {
              var I = A6.getTextContent(), R = A6.getTextGuideLine();
              A6.stateTransition && (A6.stateTransition = null), I && I.stateTransition && (I.stateTransition = null), R && R.stateTransition && (R.stateTransition = null), A6.hasState() ? (A6.prevStates = A6.currentStates, A6.clearStates()) : A6.prevStates && (A6.prevStates = null);
            }
          });
        }
        function x6(S, M) {
          var A6 = S.getModel("stateAnimation"), I = S.isAnimationEnabled(), R = A6.get("duration"), F = R > 0 ? { duration: R, delay: A6.get("delay"), easing: A6.get("easing") } : null;
          M.eachRendered(function(j) {
            if (j.states && j.states.emphasis) {
              if (q22(j))
                return;
              if (j instanceof uo && Kq(j), j.__dirty) {
                var $ = j.prevStates;
                $ && j.useStates($);
              }
              if (I) {
                j.stateTransition = F;
                var K = j.getTextContent(), U = j.getTextGuideLine();
                K && (K.stateTransition = F), U && (U.stateTransition = F);
              }
              j.__dirty && u(j);
            }
          });
        }
        Ehe = function(S) {
          return new (function(M) {
            tt(A6, M);
            function A6() {
              return M !== null && M.apply(this, arguments) || this;
            }
            return A6.prototype.getCoordinateSystems = function() {
              return S._coordSysMgr.getCoordinateSystems();
            }, A6.prototype.getComponentByElement = function(I) {
              for (; I; ) {
                var R = I.__ecComponentInfo;
                if (R != null)
                  return S._model.getComponent(R.mainType, R.index);
                I = I.parent;
              }
            }, A6.prototype.enterEmphasis = function(I, R) {
              Cm(I, R), Om(S);
            }, A6.prototype.leaveEmphasis = function(I, R) {
              Mm(I, R), Om(S);
            }, A6.prototype.enterBlur = function(I) {
              D7(I), Om(S);
            }, A6.prototype.leaveBlur = function(I) {
              GO(I), Om(S);
            }, A6.prototype.enterSelect = function(I) {
              Am(I), Om(S);
            }, A6.prototype.leaveSelect = function(I) {
              Ko(I), Om(S);
            }, A6.prototype.getModel = function() {
              return S.getModel();
            }, A6.prototype.getViewOfComponentModel = function(I) {
              return S.getViewOfComponentModel(I);
            }, A6.prototype.getViewOfSeriesModel = function(I) {
              return S.getViewOfSeriesModel(I);
            }, A6;
          }(zce))(S);
        }, Ihe = function(S) {
          function M(A6, I) {
            for (var R = 0; R < A6.length; R++) {
              var F = A6[R];
              F[gZ] = I;
            }
          }
          Ne(LR, function(A6, I) {
            S._messageCenter.on(I, function(R) {
              if (Phe[S.group] && S[gZ] !== yhe) {
                if (R && R.escapeConnect)
                  return;
                var F = S.makeActionFromEvent(R), j = [];
                Ne(OR, function($) {
                  $ !== S && $.group === S.group && j.push($);
                }), M(j, yhe), Ne(j, function($) {
                  $[gZ] !== c6e && $.dispatchAction(F);
                }), M(j, f6e);
              }
            });
          });
        };
      }(), r6;
    }(Ip), wZ = Dhe.prototype;
    wZ.on = bhe("on"), wZ.off = bhe("off"), wZ.one = function(a, r6, t2) {
      var s = this;
      function u() {
        for (var f6 = [], d6 = 0; d6 < arguments.length; d6++)
          f6[d6] = arguments[d6];
        r6 && r6.apply && r6.apply(this, f6), s.off(a, u);
      }
      this.on.call(this, a, u, t2);
    };
    var h6e = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"], DV = {}, LR = {}, SZ = [], CZ = [], kV = [], khe = {}, MZ = {}, OR = {}, Phe = {}, d6e = +new Date() - 0, AZ = "_echarts_instance_";
    function p6e(a, r6, t2) {
      var s = !(t2 && t2.ssr);
      if (s) {
        var u = v6e(a);
        if (u)
          return u;
      }
      var f6 = new Dhe(a, r6, t2);
      return f6.id = "ec_" + d6e++, OR[f6.id] = f6, s && Z9(a, AZ, f6.id), Ihe(f6), u1.trigger("afterinit", f6), f6;
    }
    function v6e(a) {
      return OR[rq(a, AZ)];
    }
    function Lhe(a, r6) {
      khe[a] = r6;
    }
    function Ohe(a) {
      Vi(CZ, a) < 0 && CZ.push(a);
    }
    function Rhe(a, r6) {
      IZ(SZ, a, r6, n6e);
    }
    function g6e(a) {
      EZ("afterinit", a);
    }
    function m6e(a) {
      EZ("afterupdate", a);
    }
    function EZ(a, r6) {
      u1.on(a, r6);
    }
    function Nb(a, r6, t2) {
      ti(r6) && (t2 = r6, r6 = "");
      var s = ui(a) ? a.type : [a, a = { event: r6 }][0];
      a.event = (a.event || s).toLowerCase(), r6 = a.event, !LR[r6] && (Hd(mhe.test(s) && mhe.test(r6)), DV[s] || (DV[s] = { action: t2, actionInfo: a }), LR[r6] = s);
    }
    function y6e(a, r6) {
      yR.register(a, r6);
    }
    function b6e(a, r6) {
      IZ(kV, a, r6, phe, "layout");
    }
    function vA(a, r6) {
      IZ(kV, a, r6, vhe, "visual");
    }
    var Fhe = [];
    function IZ(a, r6, t2, s, u) {
      if ((ti(r6) || ui(r6)) && (t2 = r6, r6 = s), !(Vi(Fhe, t2) >= 0)) {
        Fhe.push(t2);
        var f6 = jfe.wrapStageHandler(t2, u);
        f6.__prio = r6, f6.__raw = t2, a.push(f6);
      }
    }
    function Nhe(a, r6) {
      MZ[a] = r6;
    }
    function _6e(a, r6, t2) {
      var s = X4e("registerMap");
      s && s(a, r6, t2);
    }
    var x6e = TRe;
    vA(pZ, e4e), vA(EV, t4e), vA(EV, n4e), vA(pZ, m4e), vA(EV, y4e), vA(ghe, q4e), Ohe(Uce), Rhe(e6e, uRe), Nhe("default", r4e), Nb({ type: Lx, event: Lx, update: Lx }, kc), Nb({ type: DD, event: DD, update: DD }, kc), Nb({ type: Ox, event: Ox, update: Ox }, kc), Nb({ type: kD, event: kD, update: kD }, kc), Nb({ type: Av, event: Av, update: Av }, kc), Lhe("light", p4e), Lhe("dark", v4e);
    var Vhe = [], w6e = { registerPreprocessor: Ohe, registerProcessor: Rhe, registerPostInit: g6e, registerPostUpdate: m6e, registerUpdateLifecycle: EZ, registerAction: Nb, registerCoordinateSystem: y6e, registerLayout: b6e, registerVisual: vA, registerTransform: x6e, registerLoading: Nhe, registerMap: _6e, registerImpl: Z4e, PRIORITY: u6e, ComponentModel: Ps, ComponentView: Rc, SeriesModel: sc, ChartView: bu, registerComponentModel: function(a) {
      Ps.registerClass(a);
    }, registerComponentView: function(a) {
      Rc.registerClass(a);
    }, registerSeriesModel: function(a) {
      sc.registerClass(a);
    }, registerChartView: function(a) {
      bu.registerClass(a);
    }, registerSubTypeDefaulter: function(a, r6) {
      Ps.registerSubTypeDefaulter(a, r6);
    }, registerPainter: function(a, r6) {
      B9(a, r6);
    } };
    function bo(a) {
      if (br(a)) {
        Ne(a, function(r6) {
          bo(r6);
        });
        return;
      }
      Vi(Vhe, a) >= 0 || (Vhe.push(a), ti(a) && (a = { install: a }), a.install(w6e));
    }
    function RR(a) {
      return a == null ? 0 : a.length || 1;
    }
    function zhe(a) {
      return a;
    }
    var S6e = function() {
      function a(r6, t2, s, u, f6, d6) {
        this._old = r6, this._new = t2, this._oldKeyGetter = s || zhe, this._newKeyGetter = u || zhe, this.context = f6, this._diffModeMultiple = d6 === "multiple";
      }
      return a.prototype.add = function(r6) {
        return this._add = r6, this;
      }, a.prototype.update = function(r6) {
        return this._update = r6, this;
      }, a.prototype.updateManyToOne = function(r6) {
        return this._updateManyToOne = r6, this;
      }, a.prototype.updateOneToMany = function(r6) {
        return this._updateOneToMany = r6, this;
      }, a.prototype.updateManyToMany = function(r6) {
        return this._updateManyToMany = r6, this;
      }, a.prototype.remove = function(r6) {
        return this._remove = r6, this;
      }, a.prototype.execute = function() {
        this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
      }, a.prototype._executeOneToOne = function() {
        var r6 = this._old, t2 = this._new, s = {}, u = new Array(r6.length), f6 = new Array(t2.length);
        this._initIndexMap(r6, null, u, "_oldKeyGetter"), this._initIndexMap(t2, s, f6, "_newKeyGetter");
        for (var d6 = 0; d6 < r6.length; d6++) {
          var v6 = u[d6], m6 = s[v6], b6 = RR(m6);
          if (b6 > 1) {
            var x6 = m6.shift();
            m6.length === 1 && (s[v6] = m6[0]), this._update && this._update(x6, d6);
          } else
            b6 === 1 ? (s[v6] = null, this._update && this._update(m6, d6)) : this._remove && this._remove(d6);
        }
        this._performRestAdd(f6, s);
      }, a.prototype._executeMultiple = function() {
        var r6 = this._old, t2 = this._new, s = {}, u = {}, f6 = [], d6 = [];
        this._initIndexMap(r6, s, f6, "_oldKeyGetter"), this._initIndexMap(t2, u, d6, "_newKeyGetter");
        for (var v6 = 0; v6 < f6.length; v6++) {
          var m6 = f6[v6], b6 = s[m6], x6 = u[m6], S = RR(b6), M = RR(x6);
          if (S > 1 && M === 1)
            this._updateManyToOne && this._updateManyToOne(x6, b6), u[m6] = null;
          else if (S === 1 && M > 1)
            this._updateOneToMany && this._updateOneToMany(x6, b6), u[m6] = null;
          else if (S === 1 && M === 1)
            this._update && this._update(x6, b6), u[m6] = null;
          else if (S > 1 && M > 1)
            this._updateManyToMany && this._updateManyToMany(x6, b6), u[m6] = null;
          else if (S > 1)
            for (var A6 = 0; A6 < S; A6++)
              this._remove && this._remove(b6[A6]);
          else
            this._remove && this._remove(b6);
        }
        this._performRestAdd(d6, u);
      }, a.prototype._performRestAdd = function(r6, t2) {
        for (var s = 0; s < r6.length; s++) {
          var u = r6[s], f6 = t2[u], d6 = RR(f6);
          if (d6 > 1)
            for (var v6 = 0; v6 < d6; v6++)
              this._add && this._add(f6[v6]);
          else
            d6 === 1 && this._add && this._add(f6);
          t2[u] = null;
        }
      }, a.prototype._initIndexMap = function(r6, t2, s, u) {
        for (var f6 = this._diffModeMultiple, d6 = 0; d6 < r6.length; d6++) {
          var v6 = "_ec_" + this[u](r6[d6], d6);
          if (f6 || (s[d6] = v6), !!t2) {
            var m6 = t2[v6], b6 = RR(m6);
            b6 === 0 ? (t2[v6] = d6, f6 && s.push(v6)) : b6 === 1 ? t2[v6] = [m6, d6] : m6.push(d6);
          }
        }
      }, a;
    }(), Gx = S6e, C6e = function() {
      function a(r6, t2) {
        this._encode = r6, this._schema = t2;
      }
      return a.prototype.get = function() {
        return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
      }, a.prototype._getFullDimensionNames = function() {
        return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
      }, a;
    }();
    function M6e(a, r6) {
      var t2 = {}, s = t2.encode = {}, u = Ta(), f6 = [], d6 = [], v6 = {};
      Ne(a.dimensions, function(M) {
        var A6 = a.getDimensionInfo(M), I = A6.coordDim;
        if (I) {
          var R = A6.coordDimIndex;
          TZ(s, I)[R] = M, A6.isExtraCoord || (u.set(I, 1), A6e(A6.type) && (f6[0] = M), TZ(v6, I)[R] = a.getDimensionIndex(A6.name)), A6.defaultTooltip && d6.push(M);
        }
        Cce.each(function(F, j) {
          var $ = TZ(s, j), K = A6.otherDims[j];
          K != null && K !== false && ($[K] = A6.name);
        });
      });
      var m6 = [], b6 = {};
      u.each(function(M, A6) {
        var I = s[A6];
        b6[A6] = I[0], m6 = m6.concat(I);
      }), t2.dataDimsOnCoord = m6, t2.dataDimIndicesOnCoord = wr(m6, function(M) {
        return a.getDimensionInfo(M).storeDimIndex;
      }), t2.encodeFirstDimNotExtra = b6;
      var x6 = s.label;
      x6 && x6.length && (f6 = x6.slice());
      var S = s.tooltip;
      return S && S.length ? d6 = S.slice() : d6.length || (d6 = f6.slice()), s.defaultedLabel = f6, s.defaultedTooltip = d6, t2.userOutput = new C6e(v6, r6), t2;
    }
    function TZ(a, r6) {
      return a.hasOwnProperty(r6) || (a[r6] = []), a[r6];
    }
    function PV(a) {
      return a === "category" ? "ordinal" : a === "time" ? "time" : "float";
    }
    function A6e(a) {
      return !(a === "ordinal" || a === "time");
    }
    var E6e = function() {
      function a(r6) {
        this.otherDims = {}, r6 != null && qn(this, r6);
      }
      return a;
    }(), LV = E6e, I6e = Xo(), T6e = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, Bhe = function() {
      function a(r6) {
        this.dimensions = r6.dimensions, this._dimOmitted = r6.dimensionOmitted, this.source = r6.source, this._fullDimCount = r6.fullDimensionCount, this._updateDimOmitted(r6.dimensionOmitted);
      }
      return a.prototype.isDimensionOmitted = function() {
        return this._dimOmitted;
      }, a.prototype._updateDimOmitted = function(r6) {
        this._dimOmitted = r6, r6 && (this._dimNameMap || (this._dimNameMap = Whe(this.source)));
      }, a.prototype.getSourceDimensionIndex = function(r6) {
        return qi(this._dimNameMap.get(r6), -1);
      }, a.prototype.getSourceDimension = function(r6) {
        var t2 = this.source.dimensionsDefine;
        if (t2)
          return t2[r6];
      }, a.prototype.makeStoreSchema = function() {
        for (var r6 = this._fullDimCount, t2 = Xce(this.source), s = !Hhe(r6), u = "", f6 = [], d6 = 0, v6 = 0; d6 < r6; d6++) {
          var m6 = void 0, b6 = void 0, x6 = void 0, S = this.dimensions[v6];
          if (S && S.storeDimIndex === d6)
            m6 = t2 ? S.name : null, b6 = S.type, x6 = S.ordinalMeta, v6++;
          else {
            var M = this.getSourceDimension(d6);
            M && (m6 = t2 ? M.name : null, b6 = M.type);
          }
          f6.push({ property: m6, type: b6, ordinalMeta: x6 }), t2 && m6 != null && (!S || !S.isCalculationCoord) && (u += s ? m6.replace(/\`/g, "`1").replace(/\$/g, "`2") : m6), u += "$", u += T6e[b6] || "f", x6 && (u += x6.uid), u += "$";
        }
        var A6 = this.source, I = [A6.seriesLayoutBy, A6.startIndex, u].join("$$");
        return { dimensions: f6, hash: I };
      }, a.prototype.makeOutputDimensionNames = function() {
        for (var r6 = [], t2 = 0, s = 0; t2 < this._fullDimCount; t2++) {
          var u = void 0, f6 = this.dimensions[s];
          if (f6 && f6.storeDimIndex === t2)
            f6.isCalculationCoord || (u = f6.name), s++;
          else {
            var d6 = this.getSourceDimension(t2);
            d6 && (u = d6.name);
          }
          r6.push(u);
        }
        return r6;
      }, a.prototype.appendCalculationDimension = function(r6) {
        this.dimensions.push(r6), r6.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
      }, a;
    }();
    function jhe(a) {
      return a instanceof Bhe;
    }
    function Ghe(a) {
      for (var r6 = Ta(), t2 = 0; t2 < (a || []).length; t2++) {
        var s = a[t2], u = ui(s) ? s.name : s;
        u != null && r6.get(u) == null && r6.set(u, t2);
      }
      return r6;
    }
    function Whe(a) {
      var r6 = I6e(a);
      return r6.dimNameMap || (r6.dimNameMap = Ghe(a.dimensionsDefine));
    }
    function Hhe(a) {
      return a > 30;
    }
    var FR = ui, eS = wr, D6e = typeof Int32Array == "undefined" ? Array : Int32Array, k6e = "e\0\0", $he = -1, P6e = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], L6e = ["_approximateExtent"], Uhe, OV, NR, VR, DZ, RV, kZ, O6e = function() {
      function a(r6, t2) {
        this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
        var s, u = false;
        jhe(r6) ? (s = r6.dimensions, this._dimOmitted = r6.isDimensionOmitted(), this._schema = r6) : (u = true, s = r6), s = s || ["x", "y"];
        for (var f6 = {}, d6 = [], v6 = {}, m6 = false, b6 = {}, x6 = 0; x6 < s.length; x6++) {
          var S = s[x6], M = _a2(S) ? new LV({ name: S }) : S instanceof LV ? S : new LV(S), A6 = M.name;
          M.type = M.type || "float", M.coordDim || (M.coordDim = A6, M.coordDimIndex = 0);
          var I = M.otherDims = M.otherDims || {};
          d6.push(A6), f6[A6] = M, b6[A6] != null && (m6 = true), M.createInvertedIndices && (v6[A6] = []), I.itemName === 0 && (this._nameDimIdx = x6), I.itemId === 0 && (this._idDimIdx = x6), u && (M.storeDimIndex = x6);
        }
        if (this.dimensions = d6, this._dimInfos = f6, this._initGetDimensionInfo(m6), this.hostModel = t2, this._invertedIndicesMap = v6, this._dimOmitted) {
          var R = this._dimIdxToName = Ta();
          Ne(d6, function(F) {
            R.set(f6[F].storeDimIndex, F);
          });
        }
      }
      return a.prototype.getDimension = function(r6) {
        var t2 = this._recognizeDimIndex(r6);
        if (t2 == null)
          return r6;
        if (t2 = r6, !this._dimOmitted)
          return this.dimensions[t2];
        var s = this._dimIdxToName.get(t2);
        if (s != null)
          return s;
        var u = this._schema.getSourceDimension(t2);
        if (u)
          return u.name;
      }, a.prototype.getDimensionIndex = function(r6) {
        var t2 = this._recognizeDimIndex(r6);
        if (t2 != null)
          return t2;
        if (r6 == null)
          return -1;
        var s = this._getDimInfo(r6);
        return s ? s.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(r6) : -1;
      }, a.prototype._recognizeDimIndex = function(r6) {
        if (ks(r6) || r6 != null && !isNaN(r6) && !this._getDimInfo(r6) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(r6) < 0))
          return +r6;
      }, a.prototype._getStoreDimIndex = function(r6) {
        var t2 = this.getDimensionIndex(r6);
        return t2;
      }, a.prototype.getDimensionInfo = function(r6) {
        return this._getDimInfo(this.getDimension(r6));
      }, a.prototype._initGetDimensionInfo = function(r6) {
        var t2 = this._dimInfos;
        this._getDimInfo = r6 ? function(s) {
          return t2.hasOwnProperty(s) ? t2[s] : void 0;
        } : function(s) {
          return t2[s];
        };
      }, a.prototype.getDimensionsOnCoord = function() {
        return this._dimSummary.dataDimsOnCoord.slice();
      }, a.prototype.mapDimension = function(r6, t2) {
        var s = this._dimSummary;
        if (t2 == null)
          return s.encodeFirstDimNotExtra[r6];
        var u = s.encode[r6];
        return u ? u[t2] : null;
      }, a.prototype.mapDimensionsAll = function(r6) {
        var t2 = this._dimSummary, s = t2.encode[r6];
        return (s || []).slice();
      }, a.prototype.getStore = function() {
        return this._store;
      }, a.prototype.initData = function(r6, t2, s) {
        var u = this, f6;
        if (r6 instanceof eZ && (f6 = r6), !f6) {
          var d6 = this.dimensions, v6 = UY(r6) || rd(r6) ? new Qce(r6, d6.length) : r6;
          f6 = new eZ();
          var m6 = eS(d6, function(b6) {
            return { type: u._dimInfos[b6].type, property: b6 };
          });
          f6.initData(v6, m6, s);
        }
        this._store = f6, this._nameList = (t2 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, f6.count()), this._dimSummary = M6e(this, this._schema), this.userOutput = this._dimSummary.userOutput;
      }, a.prototype.appendData = function(r6) {
        var t2 = this._store.appendData(r6);
        this._doInit(t2[0], t2[1]);
      }, a.prototype.appendValues = function(r6, t2) {
        var s = this._store.appendValues(r6, t2.length), u = s.start, f6 = s.end, d6 = this._shouldMakeIdFromName();
        if (this._updateOrdinalMeta(), t2)
          for (var v6 = u; v6 < f6; v6++) {
            var m6 = v6 - u;
            this._nameList[v6] = t2[m6], d6 && kZ(this, v6);
          }
      }, a.prototype._updateOrdinalMeta = function() {
        for (var r6 = this._store, t2 = this.dimensions, s = 0; s < t2.length; s++) {
          var u = this._dimInfos[t2[s]];
          u.ordinalMeta && r6.collectOrdinalMeta(u.storeDimIndex, u.ordinalMeta);
        }
      }, a.prototype._shouldMakeIdFromName = function() {
        var r6 = this._store.getProvider();
        return this._idDimIdx == null && r6.getSource().sourceFormat !== X2 && !r6.fillStorage;
      }, a.prototype._doInit = function(r6, t2) {
        if (!(r6 >= t2)) {
          var s = this._store, u = s.getProvider();
          this._updateOrdinalMeta();
          var f6 = this._nameList, d6 = this._idList, v6 = u.getSource().sourceFormat, m6 = v6 === km;
          if (m6 && !u.pure)
            for (var b6 = [], x6 = r6; x6 < t2; x6++) {
              var S = u.getItem(x6, b6);
              if (!this.hasItemOption && oO(S) && (this.hasItemOption = true), S) {
                var M = S.name;
                f6[x6] == null && M != null && (f6[x6] = Zc(M, null));
                var A6 = S.id;
                d6[x6] == null && A6 != null && (d6[x6] = Zc(A6, null));
              }
            }
          if (this._shouldMakeIdFromName())
            for (var x6 = r6; x6 < t2; x6++)
              kZ(this, x6);
          Uhe(this);
        }
      }, a.prototype.getApproximateExtent = function(r6) {
        return this._approximateExtent[r6] || this._store.getDataExtent(this._getStoreDimIndex(r6));
      }, a.prototype.setApproximateExtent = function(r6, t2) {
        t2 = this.getDimension(t2), this._approximateExtent[t2] = r6.slice();
      }, a.prototype.getCalculationInfo = function(r6) {
        return this._calculationInfo[r6];
      }, a.prototype.setCalculationInfo = function(r6, t2) {
        FR(r6) ? qn(this._calculationInfo, r6) : this._calculationInfo[r6] = t2;
      }, a.prototype.getName = function(r6) {
        var t2 = this.getRawIndex(r6), s = this._nameList[t2];
        return s == null && this._nameDimIdx != null && (s = NR(this, this._nameDimIdx, t2)), s == null && (s = ""), s;
      }, a.prototype._getCategory = function(r6, t2) {
        var s = this._store.get(r6, t2), u = this._store.getOrdinalMeta(r6);
        return u ? u.categories[s] : s;
      }, a.prototype.getId = function(r6) {
        return OV(this, this.getRawIndex(r6));
      }, a.prototype.count = function() {
        return this._store.count();
      }, a.prototype.get = function(r6, t2) {
        var s = this._store, u = this._dimInfos[r6];
        if (u)
          return s.get(u.storeDimIndex, t2);
      }, a.prototype.getByRawIndex = function(r6, t2) {
        var s = this._store, u = this._dimInfos[r6];
        if (u)
          return s.getByRawIndex(u.storeDimIndex, t2);
      }, a.prototype.getIndices = function() {
        return this._store.getIndices();
      }, a.prototype.getDataExtent = function(r6) {
        return this._store.getDataExtent(this._getStoreDimIndex(r6));
      }, a.prototype.getSum = function(r6) {
        return this._store.getSum(this._getStoreDimIndex(r6));
      }, a.prototype.getMedian = function(r6) {
        return this._store.getMedian(this._getStoreDimIndex(r6));
      }, a.prototype.getValues = function(r6, t2) {
        var s = this, u = this._store;
        return br(r6) ? u.getValues(eS(r6, function(f6) {
          return s._getStoreDimIndex(f6);
        }), t2) : u.getValues(r6);
      }, a.prototype.hasValue = function(r6) {
        for (var t2 = this._dimSummary.dataDimIndicesOnCoord, s = 0, u = t2.length; s < u; s++)
          if (isNaN(this._store.get(t2[s], r6)))
            return false;
        return true;
      }, a.prototype.indexOfName = function(r6) {
        for (var t2 = 0, s = this._store.count(); t2 < s; t2++)
          if (this.getName(t2) === r6)
            return t2;
        return -1;
      }, a.prototype.getRawIndex = function(r6) {
        return this._store.getRawIndex(r6);
      }, a.prototype.indexOfRawIndex = function(r6) {
        return this._store.indexOfRawIndex(r6);
      }, a.prototype.rawIndexOf = function(r6, t2) {
        var s = r6 && this._invertedIndicesMap[r6], u = s[t2];
        return u == null || isNaN(u) ? $he : u;
      }, a.prototype.indicesOfNearest = function(r6, t2, s) {
        return this._store.indicesOfNearest(this._getStoreDimIndex(r6), t2, s);
      }, a.prototype.each = function(r6, t2, s) {
        ti(r6) && (s = t2, t2 = r6, r6 = []);
        var u = s || this, f6 = eS(VR(r6), this._getStoreDimIndex, this);
        this._store.each(f6, u ? Ca(t2, u) : t2);
      }, a.prototype.filterSelf = function(r6, t2, s) {
        ti(r6) && (s = t2, t2 = r6, r6 = []);
        var u = s || this, f6 = eS(VR(r6), this._getStoreDimIndex, this);
        return this._store = this._store.filter(f6, u ? Ca(t2, u) : t2), this;
      }, a.prototype.selectRange = function(r6) {
        var t2 = this, s = {}, u = Po(r6);
        return Ne(u, function(f6) {
          var d6 = t2._getStoreDimIndex(f6);
          s[d6] = r6[f6];
        }), this._store = this._store.selectRange(s), this;
      }, a.prototype.mapArray = function(r6, t2, s) {
        ti(r6) && (s = t2, t2 = r6, r6 = []), s = s || this;
        var u = [];
        return this.each(r6, function() {
          u.push(t2 && t2.apply(this, arguments));
        }, s), u;
      }, a.prototype.map = function(r6, t2, s, u) {
        var f6 = s || u || this, d6 = eS(VR(r6), this._getStoreDimIndex, this), v6 = RV(this);
        return v6._store = this._store.map(d6, f6 ? Ca(t2, f6) : t2), v6;
      }, a.prototype.modify = function(r6, t2, s, u) {
        var f6 = s || u || this, d6 = eS(VR(r6), this._getStoreDimIndex, this);
        this._store.modify(d6, f6 ? Ca(t2, f6) : t2);
      }, a.prototype.downSample = function(r6, t2, s, u) {
        var f6 = RV(this);
        return f6._store = this._store.downSample(this._getStoreDimIndex(r6), t2, s, u), f6;
      }, a.prototype.lttbDownSample = function(r6, t2) {
        var s = RV(this);
        return s._store = this._store.lttbDownSample(this._getStoreDimIndex(r6), t2), s;
      }, a.prototype.getRawDataItem = function(r6) {
        return this._store.getRawDataItem(r6);
      }, a.prototype.getItemModel = function(r6) {
        var t2 = this.hostModel, s = this.getRawDataItem(r6);
        return new yu(s, t2, t2 && t2.ecModel);
      }, a.prototype.diff = function(r6) {
        var t2 = this;
        return new Gx(r6 ? r6.getStore().getIndices() : [], this.getStore().getIndices(), function(s) {
          return OV(r6, s);
        }, function(s) {
          return OV(t2, s);
        });
      }, a.prototype.getVisual = function(r6) {
        var t2 = this._visual;
        return t2 && t2[r6];
      }, a.prototype.setVisual = function(r6, t2) {
        this._visual = this._visual || {}, FR(r6) ? qn(this._visual, r6) : this._visual[r6] = t2;
      }, a.prototype.getItemVisual = function(r6, t2) {
        var s = this._itemVisuals[r6], u = s && s[t2];
        return u == null ? this.getVisual(t2) : u;
      }, a.prototype.hasItemVisual = function() {
        return this._itemVisuals.length > 0;
      }, a.prototype.ensureUniqueItemVisual = function(r6, t2) {
        var s = this._itemVisuals, u = s[r6];
        u || (u = s[r6] = {});
        var f6 = u[t2];
        return f6 == null && (f6 = this.getVisual(t2), br(f6) ? f6 = f6.slice() : FR(f6) && (f6 = qn({}, f6)), u[t2] = f6), f6;
      }, a.prototype.setItemVisual = function(r6, t2, s) {
        var u = this._itemVisuals[r6] || {};
        this._itemVisuals[r6] = u, FR(t2) ? qn(u, t2) : u[t2] = s;
      }, a.prototype.clearAllVisual = function() {
        this._visual = {}, this._itemVisuals = [];
      }, a.prototype.setLayout = function(r6, t2) {
        FR(r6) ? qn(this._layout, r6) : this._layout[r6] = t2;
      }, a.prototype.getLayout = function(r6) {
        return this._layout[r6];
      }, a.prototype.getItemLayout = function(r6) {
        return this._itemLayouts[r6];
      }, a.prototype.setItemLayout = function(r6, t2, s) {
        this._itemLayouts[r6] = s ? qn(this._itemLayouts[r6] || {}, t2) : t2;
      }, a.prototype.clearItemLayouts = function() {
        this._itemLayouts.length = 0;
      }, a.prototype.setItemGraphicEl = function(r6, t2) {
        var s = this.hostModel && this.hostModel.seriesIndex;
        NO(s, this.dataType, r6, t2), this._graphicEls[r6] = t2;
      }, a.prototype.getItemGraphicEl = function(r6) {
        return this._graphicEls[r6];
      }, a.prototype.eachItemGraphicEl = function(r6, t2) {
        Ne(this._graphicEls, function(s, u) {
          s && r6 && r6.call(t2, s, u);
        });
      }, a.prototype.cloneShallow = function(r6) {
        return r6 || (r6 = new a(this._schema ? this._schema : eS(this.dimensions, this._getDimInfo, this), this.hostModel)), DZ(r6, this), r6._store = this._store, r6;
      }, a.prototype.wrapMethod = function(r6, t2) {
        var s = this[r6];
        !ti(s) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(r6), this[r6] = function() {
          var u = s.apply(this, arguments);
          return t2.apply(this, [u].concat(cL(arguments)));
        });
      }, a.internalField = function() {
        Uhe = function(r6) {
          var t2 = r6._invertedIndicesMap;
          Ne(t2, function(s, u) {
            var f6 = r6._dimInfos[u], d6 = f6.ordinalMeta, v6 = r6._store;
            if (d6) {
              s = t2[u] = new D6e(d6.categories.length);
              for (var m6 = 0; m6 < s.length; m6++)
                s[m6] = $he;
              for (var m6 = 0; m6 < v6.count(); m6++)
                s[v6.get(f6.storeDimIndex, m6)] = m6;
            }
          });
        }, NR = function(r6, t2, s) {
          return Zc(r6._getCategory(t2, s), null);
        }, OV = function(r6, t2) {
          var s = r6._idList[t2];
          return s == null && r6._idDimIdx != null && (s = NR(r6, r6._idDimIdx, t2)), s == null && (s = k6e + t2), s;
        }, VR = function(r6) {
          return br(r6) || (r6 = r6 != null ? [r6] : []), r6;
        }, RV = function(r6) {
          var t2 = new a(r6._schema ? r6._schema : eS(r6.dimensions, r6._getDimInfo, r6), r6.hostModel);
          return DZ(t2, r6), t2;
        }, DZ = function(r6, t2) {
          Ne(P6e.concat(t2.__wrappedMethods || []), function(s) {
            t2.hasOwnProperty(s) && (r6[s] = t2[s]);
          }), r6.__wrappedMethods = t2.__wrappedMethods, Ne(L6e, function(s) {
            r6[s] = Qa(t2[s]);
          }), r6._calculationInfo = qn({}, t2._calculationInfo);
        }, kZ = function(r6, t2) {
          var s = r6._nameList, u = r6._idList, f6 = r6._nameDimIdx, d6 = r6._idDimIdx, v6 = s[t2], m6 = u[t2];
          if (v6 == null && f6 != null && (s[t2] = v6 = NR(r6, f6, t2)), m6 == null && d6 != null && (u[t2] = m6 = NR(r6, d6, t2)), m6 == null && v6 != null) {
            var b6 = r6._nameRepeatCount, x6 = b6[v6] = (b6[v6] || 0) + 1;
            m6 = v6, x6 > 1 && (m6 += "__ec__" + x6), u[t2] = m6;
          }
        };
      }(), a;
    }(), Tv = O6e;
    function zR(a, r6) {
      UY(a) || (a = YY(a)), r6 = r6 || {};
      var t2 = r6.coordDimensions || [], s = r6.dimensionsDefine || a.dimensionsDefine || [], u = Ta(), f6 = [], d6 = F6e(a, t2, s, r6.dimensionsCount), v6 = r6.canOmitUnusedDimensions && Hhe(d6), m6 = s === a.dimensionsDefine, b6 = m6 ? Whe(a) : Ghe(s), x6 = r6.encodeDefine;
      !x6 && r6.encodeDefaulter && (x6 = r6.encodeDefaulter(a, d6));
      for (var S = Ta(x6), M = new ffe(d6), A6 = 0; A6 < M.length; A6++)
        M[A6] = -1;
      function I(xe) {
        var Ae = M[xe];
        if (Ae < 0) {
          var ke = s[xe], je = ui(ke) ? ke : { name: ke }, Fe = new LV(), at = je.name;
          at != null && b6.get(at) != null && (Fe.name = Fe.displayName = at), je.type != null && (Fe.type = je.type), je.displayName != null && (Fe.displayName = je.displayName);
          var ht = f6.length;
          return M[xe] = ht, Fe.storeDimIndex = xe, f6.push(Fe), Fe;
        }
        return f6[Ae];
      }
      if (!v6)
        for (var A6 = 0; A6 < d6; A6++)
          I(A6);
      S.each(function(xe, Ae) {
        var ke = ll(xe).slice();
        if (ke.length === 1 && !_a2(ke[0]) && ke[0] < 0) {
          S.set(Ae, false);
          return;
        }
        var je = S.set(Ae, []);
        Ne(ke, function(Fe, at) {
          var ht = _a2(Fe) ? b6.get(Fe) : Fe;
          ht != null && ht < d6 && (je[at] = ht, F(I(ht), Ae, at));
        });
      });
      var R = 0;
      Ne(t2, function(xe) {
        var Ae, ke, je, Fe;
        if (_a2(xe))
          Ae = xe, Fe = {};
        else {
          Fe = xe, Ae = Fe.name;
          var at = Fe.ordinalMeta;
          Fe.ordinalMeta = null, Fe = qn({}, Fe), Fe.ordinalMeta = at, ke = Fe.dimsDef, je = Fe.otherDims, Fe.name = Fe.coordDim = Fe.coordDimIndex = Fe.dimsDef = Fe.otherDims = null;
        }
        var ht = S.get(Ae);
        if (ht !== false) {
          if (ht = ll(ht), !ht.length)
            for (var Qe = 0; Qe < (ke && ke.length || 1); Qe++) {
              for (; R < d6 && I(R).coordDim != null; )
                R++;
              R < d6 && ht.push(R++);
            }
          Ne(ht, function(en, bt) {
            var wt = I(en);
            if (m6 && Fe.type != null && (wt.type = Fe.type), F(ei(wt, Fe), Ae, bt), wt.name == null && ke) {
              var Ft = ke[bt];
              !ui(Ft) && (Ft = { name: Ft }), wt.name = wt.displayName = Ft.name, wt.defaultTooltip = Ft.defaultTooltip;
            }
            je && ei(wt.otherDims, je);
          });
        }
      });
      function F(xe, Ae, ke) {
        Cce.get(Ae) != null ? xe.otherDims[Ae] = ke : (xe.coordDim = Ae, xe.coordDimIndex = ke, u.set(Ae, true));
      }
      var j = r6.generateCoord, $ = r6.generateCoordCount, K = $ != null;
      $ = j ? $ || 1 : 0;
      var U = j || "value";
      function he(xe) {
        xe.name == null && (xe.name = xe.coordDim);
      }
      if (v6)
        Ne(f6, function(xe) {
          he(xe);
        }), f6.sort(function(xe, Ae) {
          return xe.storeDimIndex - Ae.storeDimIndex;
        });
      else
        for (var ue = 0; ue < d6; ue++) {
          var pe = I(ue), _e = pe.coordDim;
          _e == null && (pe.coordDim = N6e(U, u, K), pe.coordDimIndex = 0, (!j || $ <= 0) && (pe.isExtraCoord = true), $--), he(pe), pe.type == null && (Ice(a, ue) === rp.Must || pe.isExtraCoord && (pe.otherDims.itemName != null || pe.otherDims.seriesName != null)) && (pe.type = "ordinal");
        }
      return R6e(f6), new Bhe({ source: a, dimensions: f6, fullDimensionCount: d6, dimensionOmitted: v6 });
    }
    function R6e(a) {
      for (var r6 = Ta(), t2 = 0; t2 < a.length; t2++) {
        var s = a[t2], u = s.name, f6 = r6.get(u) || 0;
        f6 > 0 && (s.name = u + (f6 - 1)), f6++, r6.set(u, f6);
      }
    }
    function F6e(a, r6, t2, s) {
      var u = Math.max(a.dimensionsDetectedCount || 1, r6.length, t2.length, s || 0);
      return Ne(r6, function(f6) {
        var d6;
        ui(f6) && (d6 = f6.dimsDef) && (u = Math.max(u, d6.length));
      }), u;
    }
    function N6e(a, r6, t2) {
      var s = r6.data;
      if (t2 || s.hasOwnProperty(a)) {
        for (var u = 0; s.hasOwnProperty(a + u); )
          u++;
        a += u;
      }
      return r6.set(a, true), a;
    }
    var V6e = function() {
      function a(r6) {
        this.coordSysDims = [], this.axisMap = Ta(), this.categoryAxisMap = Ta(), this.coordSysName = r6;
      }
      return a;
    }();
    function z6e(a) {
      var r6 = a.get("coordinateSystem"), t2 = new V6e(r6), s = B6e[r6];
      if (s)
        return s(a, t2, t2.axisMap, t2.categoryAxisMap), t2;
    }
    var B6e = { cartesian2d: function(a, r6, t2, s) {
      var u = a.getReferringComponents("xAxis", Lc).models[0], f6 = a.getReferringComponents("yAxis", Lc).models[0];
      r6.coordSysDims = ["x", "y"], t2.set("x", u), t2.set("y", f6), f5(u) && (s.set("x", u), r6.firstCategoryDimIndex = 0), f5(f6) && (s.set("y", f6), r6.firstCategoryDimIndex == null && (r6.firstCategoryDimIndex = 1));
    }, singleAxis: function(a, r6, t2, s) {
      var u = a.getReferringComponents("singleAxis", Lc).models[0];
      r6.coordSysDims = ["single"], t2.set("single", u), f5(u) && (s.set("single", u), r6.firstCategoryDimIndex = 0);
    }, polar: function(a, r6, t2, s) {
      var u = a.getReferringComponents("polar", Lc).models[0], f6 = u.findAxisModel("radiusAxis"), d6 = u.findAxisModel("angleAxis");
      r6.coordSysDims = ["radius", "angle"], t2.set("radius", f6), t2.set("angle", d6), f5(f6) && (s.set("radius", f6), r6.firstCategoryDimIndex = 0), f5(d6) && (s.set("angle", d6), r6.firstCategoryDimIndex == null && (r6.firstCategoryDimIndex = 1));
    }, geo: function(a, r6, t2, s) {
      r6.coordSysDims = ["lng", "lat"];
    }, parallel: function(a, r6, t2, s) {
      var u = a.ecModel, f6 = u.getComponent("parallel", a.get("parallelIndex")), d6 = r6.coordSysDims = f6.dimensions.slice();
      Ne(f6.parallelAxisIndex, function(v6, m6) {
        var b6 = u.getComponent("parallelAxis", v6), x6 = d6[m6];
        t2.set(x6, b6), f5(b6) && (s.set(x6, b6), r6.firstCategoryDimIndex == null && (r6.firstCategoryDimIndex = m6));
      });
    } };
    function f5(a) {
      return a.get("type") === "category";
    }
    function j6e(a, r6, t2) {
      t2 = t2 || {};
      var s = t2.byIndex, u = t2.stackedCoordDimension, f6, d6, v6;
      G6e(r6) ? f6 = r6 : (d6 = r6.schema, f6 = d6.dimensions, v6 = r6.store);
      var m6 = !!(a && a.get("stack")), b6, x6, S, M;
      if (Ne(f6, function($, K) {
        _a2($) && (f6[K] = $ = { name: $ }), m6 && !$.isExtraCoord && (!s && !b6 && $.ordinalMeta && (b6 = $), !x6 && $.type !== "ordinal" && $.type !== "time" && (!u || u === $.coordDim) && (x6 = $));
      }), x6 && !s && !b6 && (s = true), x6) {
        S = "__\0ecstackresult_" + a.id, M = "__\0ecstackedover_" + a.id, b6 && (b6.createInvertedIndices = true);
        var A6 = x6.coordDim, I = x6.type, R = 0;
        Ne(f6, function($) {
          $.coordDim === A6 && R++;
        });
        var F = { name: S, coordDim: A6, coordDimIndex: R, type: I, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: f6.length }, j = { name: M, coordDim: M, coordDimIndex: R + 1, type: I, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: f6.length + 1 };
        d6 ? (v6 && (F.storeDimIndex = v6.ensureCalculationDimension(M, I), j.storeDimIndex = v6.ensureCalculationDimension(S, I)), d6.appendCalculationDimension(F), d6.appendCalculationDimension(j)) : (f6.push(F), f6.push(j));
      }
      return { stackedDimension: x6 && x6.name, stackedByDimension: b6 && b6.name, isStackedByIndex: s, stackedOverDimension: M, stackResultDimension: S };
    }
    function G6e(a) {
      return !jhe(a.schema);
    }
    function tS(a, r6) {
      return !!r6 && r6 === a.getCalculationInfo("stackedDimension");
    }
    function qhe(a, r6) {
      return tS(a, r6) ? a.getCalculationInfo("stackResultDimension") : r6;
    }
    function W6e(a, r6) {
      var t2 = a.get("coordinateSystem"), s = yR.get(t2), u;
      return r6 && r6.coordSysDims && (u = wr(r6.coordSysDims, function(f6) {
        var d6 = { name: f6 }, v6 = r6.axisMap.get(f6);
        if (v6) {
          var m6 = v6.get("type");
          d6.type = PV(m6);
        }
        return d6;
      })), u || (u = s && (s.getDimensionsInfo ? s.getDimensionsInfo() : s.dimensions.slice()) || ["x", "y"]), u;
    }
    function H6e(a, r6, t2) {
      var s, u;
      return t2 && Ne(a, function(f6, d6) {
        var v6 = f6.coordDim, m6 = t2.categoryAxisMap.get(v6);
        m6 && (s == null && (s = d6), f6.ordinalMeta = m6.getOrdinalMeta(), r6 && (f6.createInvertedIndices = true)), f6.otherDims.itemName != null && (u = true);
      }), !u && s != null && (a[s].otherDims.itemName = 0), s;
    }
    function Wx(a, r6, t2) {
      t2 = t2 || {};
      var s = r6.getSourceManager(), u, f6 = false;
      a ? (f6 = true, u = YY(a)) : (u = s.getSource(), f6 = u.sourceFormat === km);
      var d6 = z6e(r6), v6 = W6e(r6, d6), m6 = t2.useEncodeDefaulter, b6 = ti(m6) ? m6 : m6 ? Oi(Ece, v6, r6) : null, x6 = { coordDimensions: v6, generateCoord: t2.generateCoord, encodeDefine: r6.getEncode(), encodeDefaulter: b6, canOmitUnusedDimensions: !f6 }, S = zR(u, x6), M = H6e(S.dimensions, t2.createInvertedIndices, d6), A6 = f6 ? null : s.getSharedDataStore(S), I = j6e(r6, { schema: S, store: A6 }), R = new Tv(S, r6);
      R.setCalculationInfo(I);
      var F = M != null && $6e(u) ? function(j, $, K, U) {
        return U === M ? K : this.defaultDimValueGetter(j, $, K, U);
      } : null;
      return R.hasItemOption = false, R.initData(f6 ? u : A6, null, F), R;
    }
    function $6e(a) {
      if (a.sourceFormat === km) {
        var r6 = U6e(a.data || []);
        return !br(n1(r6));
      }
    }
    function U6e(a) {
      for (var r6 = 0; r6 < a.length && a[r6] == null; )
        r6++;
      return a[r6];
    }
    var Yhe = function() {
      function a(r6) {
        this._setting = r6 || {}, this._extent = [1 / 0, -1 / 0];
      }
      return a.prototype.getSetting = function(r6) {
        return this._setting[r6];
      }, a.prototype.unionExtent = function(r6) {
        var t2 = this._extent;
        r6[0] < t2[0] && (t2[0] = r6[0]), r6[1] > t2[1] && (t2[1] = r6[1]);
      }, a.prototype.unionExtentFromData = function(r6, t2) {
        this.unionExtent(r6.getApproximateExtent(t2));
      }, a.prototype.getExtent = function() {
        return this._extent.slice();
      }, a.prototype.setExtent = function(r6, t2) {
        var s = this._extent;
        isNaN(r6) || (s[0] = r6), isNaN(t2) || (s[1] = t2);
      }, a.prototype.isInExtentRange = function(r6) {
        return this._extent[0] <= r6 && this._extent[1] >= r6;
      }, a.prototype.isBlank = function() {
        return this._isBlank;
      }, a.prototype.setBlank = function(r6) {
        this._isBlank = r6;
      }, a;
    }();
    yD(Yhe);
    var Hx = Yhe, q6e = 0, Y6e = function() {
      function a(r6) {
        this.categories = r6.categories || [], this._needCollect = r6.needCollect, this._deduplication = r6.deduplication, this.uid = ++q6e;
      }
      return a.createByAxisModel = function(r6) {
        var t2 = r6.option, s = t2.data, u = s && wr(s, Z6e);
        return new a({ categories: u, needCollect: !u, deduplication: t2.dedplication !== false });
      }, a.prototype.getOrdinal = function(r6) {
        return this._getOrCreateMap().get(r6);
      }, a.prototype.parseAndCollect = function(r6) {
        var t2, s = this._needCollect;
        if (!_a2(r6) && !s)
          return r6;
        if (s && !this._deduplication)
          return t2 = this.categories.length, this.categories[t2] = r6, t2;
        var u = this._getOrCreateMap();
        return t2 = u.get(r6), t2 == null && (s ? (t2 = this.categories.length, this.categories[t2] = r6, u.set(r6, t2)) : t2 = NaN), t2;
      }, a.prototype._getOrCreateMap = function() {
        return this._map || (this._map = Ta(this.categories));
      }, a;
    }();
    function Z6e(a) {
      return ui(a) && a.value != null ? a.value : a + "";
    }
    var PZ = Y6e;
    function LZ(a) {
      return a.type === "interval" || a.type === "log";
    }
    function X6e(a, r6, t2, s) {
      var u = {}, f6 = a[1] - a[0], d6 = u.interval = rO(f6 / r6, true);
      t2 != null && d6 < t2 && (d6 = u.interval = t2), s != null && d6 > s && (d6 = u.interval = s);
      var v6 = u.intervalPrecision = Zhe(d6), m6 = u.niceTickExtent = [Sc(Math.ceil(a[0] / d6) * d6, v6), Sc(Math.floor(a[1] / d6) * d6, v6)];
      return K6e(m6, a), u;
    }
    function OZ(a) {
      var r6 = Math.pow(10, nO(a)), t2 = a / r6;
      return t2 ? t2 === 2 ? t2 = 3 : t2 === 3 ? t2 = 5 : t2 *= 2 : t2 = 1, Sc(t2 * r6);
    }
    function Zhe(a) {
      return o0(a) + 2;
    }
    function Xhe(a, r6, t2) {
      a[r6] = Math.max(Math.min(a[r6], t2[1]), t2[0]);
    }
    function K6e(a, r6) {
      !isFinite(a[0]) && (a[0] = r6[0]), !isFinite(a[1]) && (a[1] = r6[1]), Xhe(a, 0, r6), Xhe(a, 1, r6), a[0] > a[1] && (a[0] = a[1]);
    }
    function FV(a, r6) {
      return a >= r6[0] && a <= r6[1];
    }
    function NV(a, r6) {
      return r6[1] === r6[0] ? 0.5 : (a - r6[0]) / (r6[1] - r6[0]);
    }
    function VV(a, r6) {
      return a * (r6[1] - r6[0]) + r6[0];
    }
    var Khe = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        s.type = "ordinal";
        var u = s.getSetting("ordinalMeta");
        return u || (u = new PZ({})), br(u) && (u = new PZ({ categories: wr(u, function(f6) {
          return ui(f6) ? f6.value : f6;
        }) })), s._ordinalMeta = u, s._extent = s.getSetting("extent") || [0, u.categories.length - 1], s;
      }
      return r6.prototype.parse = function(t2) {
        return _a2(t2) ? this._ordinalMeta.getOrdinal(t2) : Math.round(t2);
      }, r6.prototype.contain = function(t2) {
        return t2 = this.parse(t2), FV(t2, this._extent) && this._ordinalMeta.categories[t2] != null;
      }, r6.prototype.normalize = function(t2) {
        return t2 = this._getTickNumber(this.parse(t2)), NV(t2, this._extent);
      }, r6.prototype.scale = function(t2) {
        return t2 = Math.round(VV(t2, this._extent)), this.getRawOrdinalNumber(t2);
      }, r6.prototype.getTicks = function() {
        for (var t2 = [], s = this._extent, u = s[0]; u <= s[1]; )
          t2.push({ value: u }), u++;
        return t2;
      }, r6.prototype.getMinorTicks = function(t2) {
      }, r6.prototype.setSortInfo = function(t2) {
        if (t2 == null) {
          this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
          return;
        }
        for (var s = t2.ordinalNumbers, u = this._ordinalNumbersByTick = [], f6 = this._ticksByOrdinalNumber = [], d6 = 0, v6 = this._ordinalMeta.categories.length, m6 = Math.min(v6, s.length); d6 < m6; ++d6) {
          var b6 = s[d6];
          u[d6] = b6, f6[b6] = d6;
        }
        for (var x6 = 0; d6 < v6; ++d6) {
          for (; f6[x6] != null; )
            x6++;
          u.push(x6), f6[x6] = d6;
        }
      }, r6.prototype._getTickNumber = function(t2) {
        var s = this._ticksByOrdinalNumber;
        return s && t2 >= 0 && t2 < s.length ? s[t2] : t2;
      }, r6.prototype.getRawOrdinalNumber = function(t2) {
        var s = this._ordinalNumbersByTick;
        return s && t2 >= 0 && t2 < s.length ? s[t2] : t2;
      }, r6.prototype.getLabel = function(t2) {
        if (!this.isBlank()) {
          var s = this.getRawOrdinalNumber(t2.value), u = this._ordinalMeta.categories[s];
          return u == null ? "" : u + "";
        }
      }, r6.prototype.count = function() {
        return this._extent[1] - this._extent[0] + 1;
      }, r6.prototype.unionExtentFromData = function(t2, s) {
        this.unionExtent(t2.getApproximateExtent(s));
      }, r6.prototype.isInExtentRange = function(t2) {
        return t2 = this._getTickNumber(t2), this._extent[0] <= t2 && this._extent[1] >= t2;
      }, r6.prototype.getOrdinalMeta = function() {
        return this._ordinalMeta;
      }, r6.prototype.calcNiceTicks = function() {
      }, r6.prototype.calcNiceExtent = function() {
      }, r6.type = "ordinal", r6;
    }(Hx);
    Hx.registerClass(Khe);
    var RZ = Khe, gA = Sc, Jhe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "interval", t2._interval = 0, t2._intervalPrecision = 2, t2;
      }
      return r6.prototype.parse = function(t2) {
        return t2;
      }, r6.prototype.contain = function(t2) {
        return FV(t2, this._extent);
      }, r6.prototype.normalize = function(t2) {
        return NV(t2, this._extent);
      }, r6.prototype.scale = function(t2) {
        return VV(t2, this._extent);
      }, r6.prototype.setExtent = function(t2, s) {
        var u = this._extent;
        isNaN(t2) || (u[0] = parseFloat(t2)), isNaN(s) || (u[1] = parseFloat(s));
      }, r6.prototype.unionExtent = function(t2) {
        var s = this._extent;
        t2[0] < s[0] && (s[0] = t2[0]), t2[1] > s[1] && (s[1] = t2[1]), this.setExtent(s[0], s[1]);
      }, r6.prototype.getInterval = function() {
        return this._interval;
      }, r6.prototype.setInterval = function(t2) {
        this._interval = t2, this._niceExtent = this._extent.slice(), this._intervalPrecision = Zhe(t2);
      }, r6.prototype.getTicks = function(t2) {
        var s = this._interval, u = this._extent, f6 = this._niceExtent, d6 = this._intervalPrecision, v6 = [];
        if (!s)
          return v6;
        var m6 = 1e4;
        u[0] < f6[0] && (t2 ? v6.push({ value: gA(f6[0] - s, d6) }) : v6.push({ value: u[0] }));
        for (var b6 = f6[0]; b6 <= f6[1] && (v6.push({ value: b6 }), b6 = gA(b6 + s, d6), b6 !== v6[v6.length - 1].value); )
          if (v6.length > m6)
            return [];
        var x6 = v6.length ? v6[v6.length - 1].value : f6[1];
        return u[1] > x6 && (t2 ? v6.push({ value: gA(x6 + s, d6) }) : v6.push({ value: u[1] })), v6;
      }, r6.prototype.getMinorTicks = function(t2) {
        for (var s = this.getTicks(true), u = [], f6 = this.getExtent(), d6 = 1; d6 < s.length; d6++) {
          for (var v6 = s[d6], m6 = s[d6 - 1], b6 = 0, x6 = [], S = v6.value - m6.value, M = S / t2; b6 < t2 - 1; ) {
            var A6 = gA(m6.value + (b6 + 1) * M);
            A6 > f6[0] && A6 < f6[1] && x6.push(A6), b6++;
          }
          u.push(x6);
        }
        return u;
      }, r6.prototype.getLabel = function(t2, s) {
        if (t2 == null)
          return "";
        var u = s && s.precision;
        u == null ? u = o0(t2.value) || 0 : u === "auto" && (u = this._intervalPrecision);
        var f6 = gA(t2.value, u, true);
        return mce(f6);
      }, r6.prototype.calcNiceTicks = function(t2, s, u) {
        t2 = t2 || 5;
        var f6 = this._extent, d6 = f6[1] - f6[0];
        if (isFinite(d6)) {
          d6 < 0 && (d6 = -d6, f6.reverse());
          var v6 = X6e(f6, t2, s, u);
          this._intervalPrecision = v6.intervalPrecision, this._interval = v6.interval, this._niceExtent = v6.niceTickExtent;
        }
      }, r6.prototype.calcNiceExtent = function(t2) {
        var s = this._extent;
        if (s[0] === s[1])
          if (s[0] !== 0) {
            var u = s[0];
            t2.fixMax || (s[1] += u / 2), s[0] -= u / 2;
          } else
            s[1] = 1;
        var f6 = s[1] - s[0];
        isFinite(f6) || (s[0] = 0, s[1] = 1), this.calcNiceTicks(t2.splitNumber, t2.minInterval, t2.maxInterval);
        var d6 = this._interval;
        t2.fixMin || (s[0] = gA(Math.floor(s[0] / d6) * d6)), t2.fixMax || (s[1] = gA(Math.ceil(s[1] / d6) * d6));
      }, r6.prototype.setNiceExtent = function(t2, s) {
        this._niceExtent = [t2, s];
      }, r6.type = "interval", r6;
    }(Hx);
    Hx.registerClass(Jhe);
    var nS = Jhe, Qhe = typeof Float32Array != "undefined", J6e = Qhe ? Float32Array : Array;
    function Vb(a) {
      return br(a) ? Qhe ? new Float32Array(a) : a : new J6e(a);
    }
    var FZ = "__ec_stack_";
    function NZ(a) {
      return a.get("stack") || FZ + a.seriesIndex;
    }
    function VZ(a) {
      return a.dim + a.index;
    }
    function Q6e(a) {
      var r6 = [], t2 = a.axis, s = "axis0";
      if (t2.type === "category") {
        for (var u = t2.getBandWidth(), f6 = 0; f6 < a.count; f6++)
          r6.push(ei({ bandWidth: u, axisKey: s, stackId: FZ + f6 }, a));
        for (var d6 = nde(r6), v6 = [], f6 = 0; f6 < a.count; f6++) {
          var m6 = d6[s][FZ + f6];
          m6.offsetCenter = m6.offset + m6.width / 2, v6.push(m6);
        }
        return v6;
      }
    }
    function ede(a, r6) {
      var t2 = [];
      return r6.eachSeriesByType(a, function(s) {
        ide(s) && t2.push(s);
      }), t2;
    }
    function eFe(a) {
      var r6 = {};
      Ne(a, function(m6) {
        var b6 = m6.coordinateSystem, x6 = b6.getBaseAxis();
        if (!(x6.type !== "time" && x6.type !== "value"))
          for (var S = m6.getData(), M = x6.dim + "_" + x6.index, A6 = S.getDimensionIndex(S.mapDimension(x6.dim)), I = S.getStore(), R = 0, F = I.count(); R < F; ++R) {
            var j = I.get(A6, R);
            r6[M] ? r6[M].push(j) : r6[M] = [j];
          }
      });
      var t2 = {};
      for (var s in r6)
        if (r6.hasOwnProperty(s)) {
          var u = r6[s];
          if (u) {
            u.sort(function(m6, b6) {
              return m6 - b6;
            });
            for (var f6 = null, d6 = 1; d6 < u.length; ++d6) {
              var v6 = u[d6] - u[d6 - 1];
              v6 > 0 && (f6 = f6 === null ? v6 : Math.min(f6, v6));
            }
            t2[s] = f6;
          }
        }
      return t2;
    }
    function tde(a) {
      var r6 = eFe(a), t2 = [];
      return Ne(a, function(s) {
        var u = s.coordinateSystem, f6 = u.getBaseAxis(), d6 = f6.getExtent(), v6;
        if (f6.type === "category")
          v6 = f6.getBandWidth();
        else if (f6.type === "value" || f6.type === "time") {
          var m6 = f6.dim + "_" + f6.index, b6 = r6[m6], x6 = Math.abs(d6[1] - d6[0]), S = f6.scale.getExtent(), M = Math.abs(S[1] - S[0]);
          v6 = b6 ? x6 / M * b6 : x6;
        } else {
          var A6 = s.getData();
          v6 = Math.abs(d6[1] - d6[0]) / A6.count();
        }
        var I = ua(s.get("barWidth"), v6), R = ua(s.get("barMaxWidth"), v6), F = ua(s.get("barMinWidth") || (ode(s) ? 0.5 : 1), v6), j = s.get("barGap"), $ = s.get("barCategoryGap");
        t2.push({ bandWidth: v6, barWidth: I, barMaxWidth: R, barMinWidth: F, barGap: j, barCategoryGap: $, axisKey: VZ(f6), stackId: NZ(s) });
      }), nde(t2);
    }
    function nde(a) {
      var r6 = {};
      Ne(a, function(s, u) {
        var f6 = s.axisKey, d6 = s.bandWidth, v6 = r6[f6] || { bandWidth: d6, remainedWidth: d6, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, m6 = v6.stacks;
        r6[f6] = v6;
        var b6 = s.stackId;
        m6[b6] || v6.autoWidthCount++, m6[b6] = m6[b6] || { width: 0, maxWidth: 0 };
        var x6 = s.barWidth;
        x6 && !m6[b6].width && (m6[b6].width = x6, x6 = Math.min(v6.remainedWidth, x6), v6.remainedWidth -= x6);
        var S = s.barMaxWidth;
        S && (m6[b6].maxWidth = S);
        var M = s.barMinWidth;
        M && (m6[b6].minWidth = M);
        var A6 = s.barGap;
        A6 != null && (v6.gap = A6);
        var I = s.barCategoryGap;
        I != null && (v6.categoryGap = I);
      });
      var t2 = {};
      return Ne(r6, function(s, u) {
        t2[u] = {};
        var f6 = s.stacks, d6 = s.bandWidth, v6 = s.categoryGap;
        if (v6 == null) {
          var m6 = Po(f6).length;
          v6 = Math.max(35 - m6 * 4, 15) + "%";
        }
        var b6 = ua(v6, d6), x6 = ua(s.gap, 1), S = s.remainedWidth, M = s.autoWidthCount, A6 = (S - b6) / (M + (M - 1) * x6);
        A6 = Math.max(A6, 0), Ne(f6, function(j) {
          var $ = j.maxWidth, K = j.minWidth;
          if (j.width) {
            var U = j.width;
            $ && (U = Math.min(U, $)), K && (U = Math.max(U, K)), j.width = U, S -= U + x6 * U, M--;
          } else {
            var U = A6;
            $ && $ < U && (U = Math.min($, S)), K && K > U && (U = K), U !== A6 && (j.width = U, S -= U + x6 * U, M--);
          }
        }), A6 = (S - b6) / (M + (M - 1) * x6), A6 = Math.max(A6, 0);
        var I = 0, R;
        Ne(f6, function(j, $) {
          j.width || (j.width = A6), R = j, I += j.width * (1 + x6);
        }), R && (I -= R.width * x6);
        var F = -I / 2;
        Ne(f6, function(j, $) {
          t2[u][$] = t2[u][$] || { bandWidth: d6, offset: F, width: j.width }, F += j.width * (1 + x6);
        });
      }), t2;
    }
    function tFe(a, r6, t2) {
      if (a && r6) {
        var s = a[VZ(r6)];
        return s != null && t2 != null ? s[NZ(t2)] : s;
      }
    }
    function rde(a, r6) {
      var t2 = ede(a, r6), s = tde(t2);
      Ne(t2, function(u) {
        var f6 = u.getData(), d6 = u.coordinateSystem, v6 = d6.getBaseAxis(), m6 = NZ(u), b6 = s[VZ(v6)][m6], x6 = b6.offset, S = b6.width;
        f6.setLayout({ bandWidth: b6.bandWidth, offset: x6, size: S });
      });
    }
    function ade(a) {
      return { seriesType: a, plan: a5(), reset: function(r6) {
        if (ide(r6)) {
          var t2 = r6.getData(), s = r6.coordinateSystem, u = s.getBaseAxis(), f6 = s.getOtherAxis(u), d6 = t2.getDimensionIndex(t2.mapDimension(f6.dim)), v6 = t2.getDimensionIndex(t2.mapDimension(u.dim)), m6 = r6.get("showBackground", true), b6 = t2.mapDimension(f6.dim), x6 = t2.getCalculationInfo("stackResultDimension"), S = tS(t2, b6) && !!t2.getCalculationInfo("stackedOnSeries"), M = f6.isHorizontal(), A6 = nFe(u, f6), I = ode(r6), R = r6.get("barMinHeight") || 0, F = x6 && t2.getDimensionIndex(x6), j = t2.getLayout("size"), $ = t2.getLayout("offset");
          return { progress: function(K, U) {
            for (var he = K.count, ue = I && Vb(he * 3), pe = I && m6 && Vb(he * 3), _e = I && Vb(he), xe = s.master.getRect(), Ae = M ? xe.width : xe.height, ke, je = U.getStore(), Fe = 0; (ke = K.next()) != null; ) {
              var at = je.get(S ? F : d6, ke), ht = je.get(v6, ke), Qe = A6, en = void 0;
              S && (en = +at - je.get(d6, ke));
              var bt = void 0, wt = void 0, Ft = void 0, fn = void 0;
              if (M) {
                var gn = s.dataToPoint([at, ht]);
                if (S) {
                  var Zr = s.dataToPoint([en, ht]);
                  Qe = Zr[0];
                }
                bt = Qe, wt = gn[1] + $, Ft = gn[0] - Qe, fn = j, Math.abs(Ft) < R && (Ft = (Ft < 0 ? -1 : 1) * R);
              } else {
                var gn = s.dataToPoint([ht, at]);
                if (S) {
                  var Zr = s.dataToPoint([ht, en]);
                  Qe = Zr[1];
                }
                bt = gn[0] + $, wt = Qe, Ft = j, fn = gn[1] - Qe, Math.abs(fn) < R && (fn = (fn <= 0 ? -1 : 1) * R);
              }
              I ? (ue[Fe] = bt, ue[Fe + 1] = wt, ue[Fe + 2] = M ? Ft : fn, pe && (pe[Fe] = M ? xe.x : bt, pe[Fe + 1] = M ? wt : xe.y, pe[Fe + 2] = Ae), _e[ke] = ke) : U.setItemLayout(ke, { x: bt, y: wt, width: Ft, height: fn }), Fe += 3;
            }
            I && U.setLayout({ largePoints: ue, largeDataIndices: _e, largeBackgroundPoints: pe, valueAxisHorizontal: M });
          } };
        }
      } };
    }
    function ide(a) {
      return a.coordinateSystem && a.coordinateSystem.type === "cartesian2d";
    }
    function ode(a) {
      return a.pipelineContext && a.pipelineContext.large;
    }
    function nFe(a, r6) {
      return r6.toGlobalCoord(r6.dataToCoord(r6.type === "log" ? 1 : 0));
    }
    var rFe = function(a, r6, t2, s) {
      for (; t2 < s; ) {
        var u = t2 + s >>> 1;
        a[u][1] < r6 ? t2 = u + 1 : s = u;
      }
      return t2;
    }, sde = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "time", s;
      }
      return r6.prototype.getLabel = function(t2) {
        var s = this.getSetting("useUTC");
        return aV(t2.value, sce[COe(ZD(this._minLevelUnit))] || sce.second, s, this.getSetting("locale"));
      }, r6.prototype.getFormattedLabel = function(t2, s, u) {
        var f6 = this.getSetting("useUTC"), d6 = this.getSetting("locale");
        return MOe(t2, s, u, d6, f6);
      }, r6.prototype.getTicks = function() {
        var t2 = this._interval, s = this._extent, u = [];
        if (!t2)
          return u;
        u.push({ value: s[0], level: 0 });
        var f6 = this.getSetting("useUTC"), d6 = cFe(this._minLevelUnit, this._approxInterval, f6, s);
        return u = u.concat(d6), u.push({ value: s[1], level: 0 }), u;
      }, r6.prototype.calcNiceExtent = function(t2) {
        var s = this._extent;
        if (s[0] === s[1] && (s[0] -= Dm, s[1] += Dm), s[1] === -1 / 0 && s[0] === 1 / 0) {
          var u = new Date();
          s[1] = +new Date(u.getFullYear(), u.getMonth(), u.getDate()), s[0] = s[1] - Dm;
        }
        this.calcNiceTicks(t2.splitNumber, t2.minInterval, t2.maxInterval);
      }, r6.prototype.calcNiceTicks = function(t2, s, u) {
        t2 = t2 || 10;
        var f6 = this._extent, d6 = f6[1] - f6[0];
        this._approxInterval = d6 / t2, s != null && this._approxInterval < s && (this._approxInterval = s), u != null && this._approxInterval > u && (this._approxInterval = u);
        var v6 = zV.length, m6 = Math.min(rFe(zV, this._approxInterval, 0, v6), v6 - 1);
        this._interval = zV[m6][1], this._minLevelUnit = zV[Math.max(m6 - 1, 0)][0];
      }, r6.prototype.parse = function(t2) {
        return ks(t2) ? t2 : +s0(t2);
      }, r6.prototype.contain = function(t2) {
        return FV(this.parse(t2), this._extent);
      }, r6.prototype.normalize = function(t2) {
        return NV(this.parse(t2), this._extent);
      }, r6.prototype.scale = function(t2) {
        return VV(t2, this._extent);
      }, r6.type = "time", r6;
    }(nS), zV = [["second", kY], ["minute", PY], ["hour", dR], ["quarter-day", dR * 6], ["half-day", dR * 12], ["day", Dm * 1.2], ["half-week", Dm * 3.5], ["week", Dm * 7], ["month", Dm * 31], ["quarter", Dm * 95], ["half-year", oce / 2], ["year", oce]];
    function aFe(a, r6, t2, s) {
      var u = s0(r6), f6 = s0(t2), d6 = function(I) {
        return cce(u, I, s) === cce(f6, I, s);
      }, v6 = function() {
        return d6("year");
      }, m6 = function() {
        return v6() && d6("month");
      }, b6 = function() {
        return m6() && d6("day");
      }, x6 = function() {
        return b6() && d6("hour");
      }, S = function() {
        return x6() && d6("minute");
      }, M = function() {
        return S() && d6("second");
      }, A6 = function() {
        return M() && d6("millisecond");
      };
      switch (a) {
        case "year":
          return v6();
        case "month":
          return m6();
        case "day":
          return b6();
        case "hour":
          return x6();
        case "minute":
          return S();
        case "second":
          return M();
        case "millisecond":
          return A6();
      }
    }
    function iFe(a, r6) {
      return a /= Dm, a > 16 ? 16 : a > 7.5 ? 7 : a > 3.5 ? 4 : a > 1.5 ? 2 : 1;
    }
    function oFe(a) {
      var r6 = 30 * Dm;
      return a /= r6, a > 6 ? 6 : a > 3 ? 3 : a > 2 ? 2 : 1;
    }
    function sFe(a) {
      return a /= dR, a > 12 ? 12 : a > 6 ? 6 : a > 3.5 ? 4 : a > 2 ? 2 : 1;
    }
    function lde(a, r6) {
      return a /= r6 ? PY : kY, a > 30 ? 30 : a > 20 ? 20 : a > 15 ? 15 : a > 10 ? 10 : a > 5 ? 5 : a > 2 ? 2 : 1;
    }
    function lFe(a) {
      return rO(a, true);
    }
    function uFe(a, r6, t2) {
      var s = new Date(a);
      switch (ZD(r6)) {
        case "year":
        case "month":
          s[fce(t2)](0);
        case "day":
          s[hce(t2)](1);
        case "hour":
          s[dce(t2)](0);
        case "minute":
          s[pce(t2)](0);
        case "second":
          s[vce(t2)](0), s[gce(t2)](0);
      }
      return s.getTime();
    }
    function cFe(a, r6, t2, s) {
      var u = 1e4, f6 = lce, d6 = 0;
      function v6(Ae, ke, je, Fe, at, ht, Qe) {
        for (var en = new Date(ke), bt = ke, wt = en[Fe](); bt < je && bt <= s[1]; )
          Qe.push({ value: bt }), wt += Ae, en[at](wt), bt = en.getTime();
        Qe.push({ value: bt, notAdd: true });
      }
      function m6(Ae, ke, je) {
        var Fe = [], at = !ke.length;
        if (!aFe(ZD(Ae), s[0], s[1], t2)) {
          at && (ke = [{ value: uFe(new Date(s[0]), Ae, t2) }, { value: s[1] }]);
          for (var ht = 0; ht < ke.length - 1; ht++) {
            var Qe = ke[ht].value, en = ke[ht + 1].value;
            if (Qe !== en) {
              var bt = void 0, wt = void 0, Ft = void 0, fn = false;
              switch (Ae) {
                case "year":
                  bt = Math.max(1, Math.round(r6 / Dm / 365)), wt = OY(t2), Ft = AOe(t2);
                  break;
                case "half-year":
                case "quarter":
                case "month":
                  bt = oFe(r6), wt = XD(t2), Ft = fce(t2);
                  break;
                case "week":
                case "half-week":
                case "day":
                  bt = iFe(r6), wt = iV(t2), Ft = hce(t2), fn = true;
                  break;
                case "half-day":
                case "quarter-day":
                case "hour":
                  bt = sFe(r6), wt = vR(t2), Ft = dce(t2);
                  break;
                case "minute":
                  bt = lde(r6, true), wt = oV(t2), Ft = pce(t2);
                  break;
                case "second":
                  bt = lde(r6, false), wt = sV(t2), Ft = vce(t2);
                  break;
                case "millisecond":
                  bt = lFe(r6), wt = lV(t2), Ft = gce(t2);
                  break;
              }
              v6(bt, Qe, en, wt, Ft, fn, Fe), Ae === "year" && je.length > 1 && ht === 0 && je.unshift({ value: je[0].value - bt });
            }
          }
          for (var ht = 0; ht < Fe.length; ht++)
            je.push(Fe[ht]);
          return Fe;
        }
      }
      for (var b6 = [], x6 = [], S = 0, M = 0, A6 = 0; A6 < f6.length && d6++ < u; ++A6) {
        var I = ZD(f6[A6]);
        if (SOe(f6[A6])) {
          m6(f6[A6], b6[b6.length - 1] || [], x6);
          var R = f6[A6 + 1] ? ZD(f6[A6 + 1]) : null;
          if (I !== R) {
            if (x6.length) {
              M = S, x6.sort(function(Ae, ke) {
                return Ae.value - ke.value;
              });
              for (var F = [], j = 0; j < x6.length; ++j) {
                var $ = x6[j].value;
                (j === 0 || x6[j - 1].value !== $) && (F.push(x6[j]), $ >= s[0] && $ <= s[1] && S++);
              }
              var K = (s[1] - s[0]) / r6;
              if (S > K * 1.5 && M > K / 1.5 || (b6.push(F), S > K || a === f6[A6]))
                break;
            }
            x6 = [];
          }
        }
      }
      for (var U = gl(wr(b6, function(ke) {
        return gl(ke, function(je) {
          return je.value >= s[0] && je.value <= s[1] && !je.notAdd;
        });
      }), function(ke) {
        return ke.length > 0;
      }), he = [], ue = U.length - 1, A6 = 0; A6 < U.length; ++A6)
        for (var pe = U[A6], _e = 0; _e < pe.length; ++_e)
          he.push({ value: pe[_e].value, level: ue - A6 });
      he.sort(function(Ae, ke) {
        return Ae.value - ke.value;
      });
      for (var xe = [], A6 = 0; A6 < he.length; ++A6)
        (A6 === 0 || he[A6].value !== he[A6 - 1].value) && xe.push(he[A6]);
      return xe;
    }
    Hx.registerClass(sde);
    var ude = sde, cde = Hx.prototype, BR = nS.prototype, fFe = Sc, hFe = Math.floor, dFe = Math.ceil, BV = Math.pow, Rm = Math.log, zZ = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "log", t2.base = 10, t2._originalScale = new nS(), t2._interval = 0, t2;
      }
      return r6.prototype.getTicks = function(t2) {
        var s = this._originalScale, u = this._extent, f6 = s.getExtent(), d6 = BR.getTicks.call(this, t2);
        return wr(d6, function(v6) {
          var m6 = v6.value, b6 = Sc(BV(this.base, m6));
          return b6 = m6 === u[0] && this._fixMin ? jV(b6, f6[0]) : b6, b6 = m6 === u[1] && this._fixMax ? jV(b6, f6[1]) : b6, { value: b6 };
        }, this);
      }, r6.prototype.setExtent = function(t2, s) {
        var u = this.base;
        t2 = Rm(t2) / Rm(u), s = Rm(s) / Rm(u), BR.setExtent.call(this, t2, s);
      }, r6.prototype.getExtent = function() {
        var t2 = this.base, s = cde.getExtent.call(this);
        s[0] = BV(t2, s[0]), s[1] = BV(t2, s[1]);
        var u = this._originalScale, f6 = u.getExtent();
        return this._fixMin && (s[0] = jV(s[0], f6[0])), this._fixMax && (s[1] = jV(s[1], f6[1])), s;
      }, r6.prototype.unionExtent = function(t2) {
        this._originalScale.unionExtent(t2);
        var s = this.base;
        t2[0] = Rm(t2[0]) / Rm(s), t2[1] = Rm(t2[1]) / Rm(s), cde.unionExtent.call(this, t2);
      }, r6.prototype.unionExtentFromData = function(t2, s) {
        this.unionExtent(t2.getApproximateExtent(s));
      }, r6.prototype.calcNiceTicks = function(t2) {
        t2 = t2 || 10;
        var s = this._extent, u = s[1] - s[0];
        if (!(u === 1 / 0 || u <= 0)) {
          var f6 = tO(u), d6 = t2 / u * f6;
          for (d6 <= 0.5 && (f6 *= 10); !isNaN(f6) && Math.abs(f6) < 1 && Math.abs(f6) > 0; )
            f6 *= 10;
          var v6 = [Sc(dFe(s[0] / f6) * f6), Sc(hFe(s[1] / f6) * f6)];
          this._interval = f6, this._niceExtent = v6;
        }
      }, r6.prototype.calcNiceExtent = function(t2) {
        BR.calcNiceExtent.call(this, t2), this._fixMin = t2.fixMin, this._fixMax = t2.fixMax;
      }, r6.prototype.parse = function(t2) {
        return t2;
      }, r6.prototype.contain = function(t2) {
        return t2 = Rm(t2) / Rm(this.base), FV(t2, this._extent);
      }, r6.prototype.normalize = function(t2) {
        return t2 = Rm(t2) / Rm(this.base), NV(t2, this._extent);
      }, r6.prototype.scale = function(t2) {
        return t2 = VV(t2, this._extent), BV(this.base, t2);
      }, r6.type = "log", r6;
    }(Hx), fde = zZ.prototype;
    fde.getMinorTicks = BR.getMinorTicks, fde.getLabel = BR.getLabel;
    function jV(a, r6) {
      return fFe(a, o0(r6));
    }
    Hx.registerClass(zZ);
    var pFe = zZ, vFe = function() {
      function a(r6, t2, s) {
        this._prepareParams(r6, t2, s);
      }
      return a.prototype._prepareParams = function(r6, t2, s) {
        s[1] < s[0] && (s = [NaN, NaN]), this._dataMin = s[0], this._dataMax = s[1];
        var u = this._isOrdinal = r6.type === "ordinal";
        this._needCrossZero = r6.type === "interval" && t2.getNeedCrossZero && t2.getNeedCrossZero();
        var f6 = this._modelMinRaw = t2.get("min", true);
        ti(f6) ? this._modelMinNum = GV(r6, f6({ min: s[0], max: s[1] })) : f6 !== "dataMin" && (this._modelMinNum = GV(r6, f6));
        var d6 = this._modelMaxRaw = t2.get("max", true);
        if (ti(d6) ? this._modelMaxNum = GV(r6, d6({ min: s[0], max: s[1] })) : d6 !== "dataMax" && (this._modelMaxNum = GV(r6, d6)), u)
          this._axisDataLen = t2.getCategories().length;
        else {
          var v6 = t2.get("boundaryGap"), m6 = br(v6) ? v6 : [v6 || 0, v6 || 0];
          typeof m6[0] == "boolean" || typeof m6[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [wv(m6[0], 1), wv(m6[1], 1)];
        }
      }, a.prototype.calculate = function() {
        var r6 = this._isOrdinal, t2 = this._dataMin, s = this._dataMax, u = this._axisDataLen, f6 = this._boundaryGapInner, d6 = r6 ? null : s - t2 || Math.abs(t2), v6 = this._modelMinRaw === "dataMin" ? t2 : this._modelMinNum, m6 = this._modelMaxRaw === "dataMax" ? s : this._modelMaxNum, b6 = v6 != null, x6 = m6 != null;
        v6 == null && (v6 = r6 ? u ? 0 : NaN : t2 - f6[0] * d6), m6 == null && (m6 = r6 ? u ? u - 1 : NaN : s + f6[1] * d6), (v6 == null || !isFinite(v6)) && (v6 = NaN), (m6 == null || !isFinite(m6)) && (m6 = NaN);
        var S = dM(v6) || dM(m6) || r6 && !u;
        this._needCrossZero && (v6 > 0 && m6 > 0 && !b6 && (v6 = 0), v6 < 0 && m6 < 0 && !x6 && (m6 = 0));
        var M = this._determinedMin, A6 = this._determinedMax;
        return M != null && (v6 = M, b6 = true), A6 != null && (m6 = A6, x6 = true), { min: v6, max: m6, minFixed: b6, maxFixed: x6, isBlank: S };
      }, a.prototype.modifyDataMinMax = function(r6, t2) {
        this[mFe[r6]] = t2;
      }, a.prototype.setDeterminedMinMax = function(r6, t2) {
        var s = gFe[r6];
        this[s] = t2;
      }, a.prototype.freeze = function() {
        this.frozen = true;
      }, a;
    }(), gFe = { min: "_determinedMin", max: "_determinedMax" }, mFe = { min: "_dataMin", max: "_dataMax" };
    function hde(a, r6, t2) {
      var s = a.rawExtentInfo;
      return s || (s = new vFe(a, r6, t2), a.rawExtentInfo = s, s);
    }
    function GV(a, r6) {
      return r6 == null ? null : dM(r6) ? NaN : a.parse(r6);
    }
    function dde(a, r6) {
      var t2 = a.type, s = hde(a, r6, a.getExtent()).calculate();
      a.setBlank(s.isBlank);
      var u = s.min, f6 = s.max, d6 = r6.ecModel;
      if (d6 && t2 === "time") {
        var v6 = ede("bar", d6), m6 = false;
        if (Ne(v6, function(S) {
          m6 = m6 || S.getBaseAxis() === r6.axis;
        }), m6) {
          var b6 = tde(v6), x6 = yFe(u, f6, r6, b6);
          u = x6.min, f6 = x6.max;
        }
      }
      return { extent: [u, f6], fixMin: s.minFixed, fixMax: s.maxFixed };
    }
    function yFe(a, r6, t2, s) {
      var u = t2.axis.getExtent(), f6 = u[1] - u[0], d6 = tFe(s, t2.axis);
      if (d6 === void 0)
        return { min: a, max: r6 };
      var v6 = 1 / 0;
      Ne(d6, function(A6) {
        v6 = Math.min(A6.offset, v6);
      });
      var m6 = -1 / 0;
      Ne(d6, function(A6) {
        m6 = Math.max(A6.offset + A6.width, m6);
      }), v6 = Math.abs(v6), m6 = Math.abs(m6);
      var b6 = v6 + m6, x6 = r6 - a, S = 1 - (v6 + m6) / f6, M = x6 / S - x6;
      return r6 += M * (m6 / b6), a -= M * (v6 / b6), { min: a, max: r6 };
    }
    function h5(a, r6) {
      var t2 = r6, s = dde(a, t2), u = s.extent, f6 = t2.get("splitNumber");
      a instanceof pFe && (a.base = t2.get("logBase"));
      var d6 = a.type, v6 = t2.get("interval"), m6 = d6 === "interval" || d6 === "time";
      a.setExtent(u[0], u[1]), a.calcNiceExtent({ splitNumber: f6, fixMin: s.fixMin, fixMax: s.fixMax, minInterval: m6 ? t2.get("minInterval") : null, maxInterval: m6 ? t2.get("maxInterval") : null }), v6 != null && a.setInterval && a.setInterval(v6);
    }
    function WV(a, r6) {
      if (r6 = r6 || a.get("type"), r6)
        switch (r6) {
          case "category":
            return new RZ({ ordinalMeta: a.getOrdinalMeta ? a.getOrdinalMeta() : a.getCategories(), extent: [1 / 0, -1 / 0] });
          case "time":
            return new ude({ locale: a.ecModel.getLocaleModel(), useUTC: a.ecModel.get("useUTC") });
          default:
            return new (Hx.getClass(r6) || nS)();
        }
    }
    function bFe(a) {
      var r6 = a.scale.getExtent(), t2 = r6[0], s = r6[1];
      return !(t2 > 0 && s > 0 || t2 < 0 && s < 0);
    }
    function jR(a) {
      var r6 = a.getLabelModel().get("formatter"), t2 = a.type === "category" ? a.scale.getExtent()[0] : null;
      return a.scale.type === "time" ? function(s) {
        return function(u, f6) {
          return a.scale.getFormattedLabel(u, f6, s);
        };
      }(r6) : _a2(r6) ? function(s) {
        return function(u) {
          var f6 = a.scale.getLabel(u), d6 = s.replace("{value}", f6 != null ? f6 : "");
          return d6;
        };
      }(r6) : ti(r6) ? function(s) {
        return function(u, f6) {
          return t2 != null && (f6 = u.value - t2), s(BZ(a, u), f6, u.level != null ? { level: u.level } : null);
        };
      }(r6) : function(s) {
        return a.scale.getLabel(s);
      };
    }
    function BZ(a, r6) {
      return a.type === "category" ? a.scale.getLabel(r6) : r6.value;
    }
    function _Fe(a) {
      var r6 = a.model, t2 = a.scale;
      if (!(!r6.get(["axisLabel", "show"]) || t2.isBlank())) {
        var s, u, f6 = t2.getExtent();
        t2 instanceof RZ ? u = t2.count() : (s = t2.getTicks(), u = s.length);
        var d6 = a.getLabelModel(), v6 = jR(a), m6, b6 = 1;
        u > 40 && (b6 = Math.ceil(u / 40));
        for (var x6 = 0; x6 < u; x6 += b6) {
          var S = s ? s[x6] : { value: f6[0] + x6 }, M = v6(S, x6), A6 = d6.getTextRect(M), I = xFe(A6, d6.get("rotate") || 0);
          m6 ? m6.union(I) : m6 = I;
        }
        return m6;
      }
    }
    function xFe(a, r6) {
      var t2 = r6 * Math.PI / 180, s = a.width, u = a.height, f6 = s * Math.abs(Math.cos(t2)) + Math.abs(u * Math.sin(t2)), d6 = s * Math.abs(Math.sin(t2)) + Math.abs(u * Math.cos(t2)), v6 = new Qi(a.x, a.y, f6, d6);
      return v6;
    }
    function jZ(a) {
      var r6 = a.get("interval");
      return r6 == null ? "auto" : r6;
    }
    function pde(a) {
      return a.type === "category" && jZ(a.getLabelModel()) === 0;
    }
    function HV(a, r6) {
      var t2 = {};
      return Ne(a.mapDimensionsAll(r6), function(s) {
        t2[qhe(a, s)] = true;
      }), Po(t2);
    }
    function wFe(a, r6, t2) {
      r6 && Ne(HV(r6, t2), function(s) {
        var u = r6.getApproximateExtent(s);
        u[0] < a[0] && (a[0] = u[0]), u[1] > a[1] && (a[1] = u[1]);
      });
    }
    var GR = function() {
      function a() {
      }
      return a.prototype.getNeedCrossZero = function() {
        var r6 = this.option;
        return !r6.scale;
      }, a.prototype.getCoordSysModel = function() {
      }, a;
    }(), SFe = 1e-8;
    function vde(a, r6) {
      return Math.abs(a - r6) < SFe;
    }
    function mA(a, r6, t2) {
      var s = 0, u = a[0];
      if (!u)
        return false;
      for (var f6 = 1; f6 < a.length; f6++) {
        var d6 = a[f6];
        s += o1(u[0], u[1], d6[0], d6[1], r6, t2), u = d6;
      }
      var v6 = a[0];
      return (!vde(u[0], v6[0]) || !vde(u[1], v6[1])) && (s += o1(u[0], u[1], v6[0], v6[1], r6, t2)), s !== 0;
    }
    var CFe = [];
    function GZ(a, r6) {
      for (var t2 = 0; t2 < a.length; t2++)
        Qf(a[t2], a[t2], r6);
    }
    function gde(a, r6, t2, s) {
      for (var u = 0; u < a.length; u++) {
        var f6 = a[u];
        s && (f6 = s.project(f6)), f6 && isFinite(f6[0]) && isFinite(f6[1]) && (Yg(r6, r6, f6), xv(t2, t2, f6));
      }
    }
    function MFe(a) {
      for (var r6 = 0, t2 = 0, s = 0, u = a.length, f6 = a[u - 1][0], d6 = a[u - 1][1], v6 = 0; v6 < u; v6++) {
        var m6 = a[v6][0], b6 = a[v6][1], x6 = f6 * b6 - m6 * d6;
        r6 += x6, t2 += (f6 + m6) * x6, s += (d6 + b6) * x6, f6 = m6, d6 = b6;
      }
      return r6 ? [t2 / r6 / 3, s / r6 / 3, r6] : [a[0][0] || 0, a[0][1] || 0];
    }
    var mde = function() {
      function a(r6) {
        this.name = r6;
      }
      return a.prototype.setCenter = function(r6) {
        this._center = r6;
      }, a.prototype.getCenter = function() {
        var r6 = this._center;
        return r6 || (r6 = this._center = this.calcCenter()), r6;
      }, a;
    }(), yde = function() {
      function a(r6, t2) {
        this.type = "polygon", this.exterior = r6, this.interiors = t2;
      }
      return a;
    }(), bde = function() {
      function a(r6) {
        this.type = "linestring", this.points = r6;
      }
      return a;
    }(), _de = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this, t2) || this;
        return f6.type = "geoJSON", f6.geometries = s, f6._center = u && [u[0], u[1]], f6;
      }
      return r6.prototype.calcCenter = function() {
        for (var t2 = this.geometries, s, u = 0, f6 = 0; f6 < t2.length; f6++) {
          var d6 = t2[f6], v6 = d6.exterior, m6 = v6 && v6.length;
          m6 > u && (s = d6, u = m6);
        }
        if (s)
          return MFe(s.exterior);
        var b6 = this.getBoundingRect();
        return [b6.x + b6.width / 2, b6.y + b6.height / 2];
      }, r6.prototype.getBoundingRect = function(t2) {
        var s = this._rect;
        if (s && !t2)
          return s;
        var u = [1 / 0, 1 / 0], f6 = [-1 / 0, -1 / 0], d6 = this.geometries;
        return Ne(d6, function(v6) {
          v6.type === "polygon" ? gde(v6.exterior, u, f6, t2) : Ne(v6.points, function(m6) {
            gde(m6, u, f6, t2);
          });
        }), isFinite(u[0]) && isFinite(u[1]) && isFinite(f6[0]) && isFinite(f6[1]) || (u[0] = u[1] = f6[0] = f6[1] = 0), s = new Qi(u[0], u[1], f6[0] - u[0], f6[1] - u[1]), t2 || (this._rect = s), s;
      }, r6.prototype.contain = function(t2) {
        var s = this.getBoundingRect(), u = this.geometries;
        if (!s.contain(t2[0], t2[1]))
          return false;
        e:
          for (var f6 = 0, d6 = u.length; f6 < d6; f6++) {
            var v6 = u[f6];
            if (v6.type === "polygon") {
              var m6 = v6.exterior, b6 = v6.interiors;
              if (mA(m6, t2[0], t2[1])) {
                for (var x6 = 0; x6 < (b6 ? b6.length : 0); x6++)
                  if (mA(b6[x6], t2[0], t2[1]))
                    continue e;
                return true;
              }
            }
          }
        return false;
      }, r6.prototype.transformTo = function(t2, s, u, f6) {
        var d6 = this.getBoundingRect(), v6 = d6.width / d6.height;
        u ? f6 || (f6 = u / v6) : u = v6 * f6;
        for (var m6 = new Qi(t2, s, u, f6), b6 = d6.calculateTransform(m6), x6 = this.geometries, S = 0; S < x6.length; S++) {
          var M = x6[S];
          M.type === "polygon" ? (GZ(M.exterior, b6), Ne(M.interiors, function(A6) {
            GZ(A6, b6);
          })) : Ne(M.points, function(A6) {
            GZ(A6, b6);
          });
        }
        d6 = this._rect, d6.copy(m6), this._center = [d6.x + d6.width / 2, d6.y + d6.height / 2];
      }, r6.prototype.cloneShallow = function(t2) {
        t2 == null && (t2 = this.name);
        var s = new r6(t2, this.geometries, this._center);
        return s._rect = this._rect, s.transformTo = null, s;
      }, r6;
    }(mde), AFe = function(a) {
      tt(r6, a);
      function r6(t2, s) {
        var u = a.call(this, t2) || this;
        return u.type = "geoSVG", u._elOnlyForCalculate = s, u;
      }
      return r6.prototype.calcCenter = function() {
        for (var t2 = this._elOnlyForCalculate, s = t2.getBoundingRect(), u = [s.x + s.width / 2, s.y + s.height / 2], f6 = kM(CFe), d6 = t2; d6 && !d6.isGeoSVGGraphicRoot; )
          Qy(f6, d6.getLocalTransform(), f6), d6 = d6.parent;
        return px(f6, f6), Qf(u, u, f6), u;
      }, r6;
    }(mde);
    function EFe(a) {
      if (!a.UTF8Encoding)
        return a;
      var r6 = a, t2 = r6.UTF8Scale;
      t2 == null && (t2 = 1024);
      var s = r6.features;
      return Ne(s, function(u) {
        var f6 = u.geometry, d6 = f6.encodeOffsets, v6 = f6.coordinates;
        if (d6)
          switch (f6.type) {
            case "LineString":
              f6.coordinates = xde(v6, d6, t2);
              break;
            case "Polygon":
              WZ(v6, d6, t2);
              break;
            case "MultiLineString":
              WZ(v6, d6, t2);
              break;
            case "MultiPolygon":
              Ne(v6, function(m6, b6) {
                return WZ(m6, d6[b6], t2);
              });
          }
      }), r6.UTF8Encoding = false, r6;
    }
    function WZ(a, r6, t2) {
      for (var s = 0; s < a.length; s++)
        a[s] = xde(a[s], r6[s], t2);
    }
    function xde(a, r6, t2) {
      for (var s = [], u = r6[0], f6 = r6[1], d6 = 0; d6 < a.length; d6 += 2) {
        var v6 = a.charCodeAt(d6) - 64, m6 = a.charCodeAt(d6 + 1) - 64;
        v6 = v6 >> 1 ^ -(v6 & 1), m6 = m6 >> 1 ^ -(m6 & 1), v6 += u, m6 += f6, u = v6, f6 = m6, s.push([v6 / t2, m6 / t2]);
      }
      return s;
    }
    function IFe(a, r6) {
      return a = EFe(a), wr(gl(a.features, function(t2) {
        return t2.geometry && t2.properties && t2.geometry.coordinates.length > 0;
      }), function(t2) {
        var s = t2.properties, u = t2.geometry, f6 = [];
        switch (u.type) {
          case "Polygon":
            var d6 = u.coordinates;
            f6.push(new yde(d6[0], d6.slice(1)));
            break;
          case "MultiPolygon":
            Ne(u.coordinates, function(m6) {
              m6[0] && f6.push(new yde(m6[0], m6.slice(1)));
            });
            break;
          case "LineString":
            f6.push(new bde([u.coordinates]));
            break;
          case "MultiLineString":
            f6.push(new bde(u.coordinates));
        }
        var v6 = new _de(s[r6 || "name"], f6, s.cp);
        return v6.properties = s, v6;
      });
    }
    var WR = Xo();
    function TFe(a) {
      return a.type === "category" ? kFe(a) : LFe(a);
    }
    function DFe(a, r6) {
      return a.type === "category" ? PFe(a, r6) : { ticks: wr(a.scale.getTicks(), function(t2) {
        return t2.value;
      }) };
    }
    function kFe(a) {
      var r6 = a.getLabelModel(), t2 = wde(a, r6);
      return !r6.get("show") || a.scale.isBlank() ? { labels: [], labelCategoryInterval: t2.labelCategoryInterval } : t2;
    }
    function wde(a, r6) {
      var t2 = Sde(a, "labels"), s = jZ(r6), u = Cde(t2, s);
      if (u)
        return u;
      var f6, d6;
      return ti(s) ? f6 = Ede(a, s) : (d6 = s === "auto" ? OFe(a) : s, f6 = Ade(a, d6)), Mde(t2, s, { labels: f6, labelCategoryInterval: d6 });
    }
    function PFe(a, r6) {
      var t2 = Sde(a, "ticks"), s = jZ(r6), u = Cde(t2, s);
      if (u)
        return u;
      var f6, d6;
      if ((!r6.get("show") || a.scale.isBlank()) && (f6 = []), ti(s))
        f6 = Ede(a, s, true);
      else if (s === "auto") {
        var v6 = wde(a, a.getLabelModel());
        d6 = v6.labelCategoryInterval, f6 = wr(v6.labels, function(m6) {
          return m6.tickValue;
        });
      } else
        d6 = s, f6 = Ade(a, d6, true);
      return Mde(t2, s, { ticks: f6, tickCategoryInterval: d6 });
    }
    function LFe(a) {
      var r6 = a.scale.getTicks(), t2 = jR(a);
      return { labels: wr(r6, function(s, u) {
        return { level: s.level, formattedLabel: t2(s, u), rawLabel: a.scale.getLabel(s), tickValue: s.value };
      }) };
    }
    function Sde(a, r6) {
      return WR(a)[r6] || (WR(a)[r6] = []);
    }
    function Cde(a, r6) {
      for (var t2 = 0; t2 < a.length; t2++)
        if (a[t2].key === r6)
          return a[t2].value;
    }
    function Mde(a, r6, t2) {
      return a.push({ key: r6, value: t2 }), t2;
    }
    function OFe(a) {
      var r6 = WR(a).autoInterval;
      return r6 != null ? r6 : WR(a).autoInterval = a.calculateCategoryInterval();
    }
    function RFe(a) {
      var r6 = FFe(a), t2 = jR(a), s = (r6.axisRotate - r6.labelRotate) / 180 * Math.PI, u = a.scale, f6 = u.getExtent(), d6 = u.count();
      if (f6[1] - f6[0] < 1)
        return 0;
      var v6 = 1;
      d6 > 40 && (v6 = Math.max(1, Math.floor(d6 / 40)));
      for (var m6 = f6[0], b6 = a.dataToCoord(m6 + 1) - a.dataToCoord(m6), x6 = Math.abs(b6 * Math.cos(s)), S = Math.abs(b6 * Math.sin(s)), M = 0, A6 = 0; m6 <= f6[1]; m6 += v6) {
        var I = 0, R = 0, F = bx(t2({ value: m6 }), r6.font, "center", "top");
        I = F.width * 1.3, R = F.height * 1.3, M = Math.max(M, I, 7), A6 = Math.max(A6, R, 7);
      }
      var j = M / x6, $ = A6 / S;
      isNaN(j) && (j = 1 / 0), isNaN($) && ($ = 1 / 0);
      var K = Math.max(0, Math.floor(Math.min(j, $))), U = WR(a.model), he = a.getExtent(), ue = U.lastAutoInterval, pe = U.lastTickCount;
      return ue != null && pe != null && Math.abs(ue - K) <= 1 && Math.abs(pe - d6) <= 1 && ue > K && U.axisExtent0 === he[0] && U.axisExtent1 === he[1] ? K = ue : (U.lastTickCount = d6, U.lastAutoInterval = K, U.axisExtent0 = he[0], U.axisExtent1 = he[1]), K;
    }
    function FFe(a) {
      var r6 = a.getLabelModel();
      return { axisRotate: a.getRotate ? a.getRotate() : a.isHorizontal && !a.isHorizontal() ? 90 : 0, labelRotate: r6.get("rotate") || 0, font: r6.getFont() };
    }
    function Ade(a, r6, t2) {
      var s = jR(a), u = a.scale, f6 = u.getExtent(), d6 = a.getLabelModel(), v6 = [], m6 = Math.max((r6 || 0) + 1, 1), b6 = f6[0], x6 = u.count();
      b6 !== 0 && m6 > 1 && x6 / m6 > 2 && (b6 = Math.round(Math.ceil(b6 / m6) * m6));
      var S = pde(a), M = d6.get("showMinLabel") || S, A6 = d6.get("showMaxLabel") || S;
      M && b6 !== f6[0] && R(f6[0]);
      for (var I = b6; I <= f6[1]; I += m6)
        R(I);
      A6 && I - m6 !== f6[1] && R(f6[1]);
      function R(F) {
        var j = { value: F };
        v6.push(t2 ? F : { formattedLabel: s(j), rawLabel: u.getLabel(j), tickValue: F });
      }
      return v6;
    }
    function Ede(a, r6, t2) {
      var s = a.scale, u = jR(a), f6 = [];
      return Ne(s.getTicks(), function(d6) {
        var v6 = s.getLabel(d6), m6 = d6.value;
        r6(d6.value, v6) && f6.push(t2 ? m6 : { formattedLabel: u(d6), rawLabel: v6, tickValue: m6 });
      }), f6;
    }
    var Ide = [0, 1], NFe = function() {
      function a(r6, t2, s) {
        this.onBand = false, this.inverse = false, this.dim = r6, this.scale = t2, this._extent = s || [0, 0];
      }
      return a.prototype.contain = function(r6) {
        var t2 = this._extent, s = Math.min(t2[0], t2[1]), u = Math.max(t2[0], t2[1]);
        return r6 >= s && r6 <= u;
      }, a.prototype.containData = function(r6) {
        return this.scale.contain(r6);
      }, a.prototype.getExtent = function() {
        return this._extent.slice();
      }, a.prototype.getPixelPrecision = function(r6) {
        return QL(r6 || this.scale.getExtent(), this._extent);
      }, a.prototype.setExtent = function(r6, t2) {
        var s = this._extent;
        s[0] = r6, s[1] = t2;
      }, a.prototype.dataToCoord = function(r6, t2) {
        var s = this._extent, u = this.scale;
        return r6 = u.normalize(r6), this.onBand && u.type === "ordinal" && (s = s.slice(), Tde(s, u.count())), gs(r6, Ide, s, t2);
      }, a.prototype.coordToData = function(r6, t2) {
        var s = this._extent, u = this.scale;
        this.onBand && u.type === "ordinal" && (s = s.slice(), Tde(s, u.count()));
        var f6 = gs(r6, s, Ide, t2);
        return this.scale.scale(f6);
      }, a.prototype.pointToData = function(r6, t2) {
      }, a.prototype.getTicksCoords = function(r6) {
        r6 = r6 || {};
        var t2 = r6.tickModel || this.getTickModel(), s = DFe(this, t2), u = s.ticks, f6 = wr(u, function(v6) {
          return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(v6) : v6), tickValue: v6 };
        }, this), d6 = t2.get("alignWithLabel");
        return VFe(this, f6, d6, r6.clamp), f6;
      }, a.prototype.getMinorTicksCoords = function() {
        if (this.scale.type === "ordinal")
          return [];
        var r6 = this.model.getModel("minorTick"), t2 = r6.get("splitNumber");
        t2 > 0 && t2 < 100 || (t2 = 5);
        var s = this.scale.getMinorTicks(t2), u = wr(s, function(f6) {
          return wr(f6, function(d6) {
            return { coord: this.dataToCoord(d6), tickValue: d6 };
          }, this);
        }, this);
        return u;
      }, a.prototype.getViewLabels = function() {
        return TFe(this).labels;
      }, a.prototype.getLabelModel = function() {
        return this.model.getModel("axisLabel");
      }, a.prototype.getTickModel = function() {
        return this.model.getModel("axisTick");
      }, a.prototype.getBandWidth = function() {
        var r6 = this._extent, t2 = this.scale.getExtent(), s = t2[1] - t2[0] + (this.onBand ? 1 : 0);
        s === 0 && (s = 1);
        var u = Math.abs(r6[1] - r6[0]);
        return Math.abs(u) / s;
      }, a.prototype.calculateCategoryInterval = function() {
        return RFe(this);
      }, a;
    }();
    function Tde(a, r6) {
      var t2 = a[1] - a[0], s = r6, u = t2 / s / 2;
      a[0] += u, a[1] -= u;
    }
    function VFe(a, r6, t2, s) {
      var u = r6.length;
      if (!a.onBand || t2 || !u)
        return;
      var f6 = a.getExtent(), d6, v6;
      if (u === 1)
        r6[0].coord = f6[0], d6 = r6[1] = { coord: f6[0] };
      else {
        var m6 = r6[u - 1].tickValue - r6[0].tickValue, b6 = (r6[u - 1].coord - r6[0].coord) / m6;
        Ne(r6, function(A6) {
          A6.coord -= b6 / 2;
        });
        var x6 = a.scale.getExtent();
        v6 = 1 + x6[1] - r6[u - 1].tickValue, d6 = { coord: r6[u - 1].coord + b6 * v6 }, r6.push(d6);
      }
      var S = f6[0] > f6[1];
      M(r6[0].coord, f6[0]) && (s ? r6[0].coord = f6[0] : r6.shift()), s && M(f6[0], r6[0].coord) && r6.unshift({ coord: f6[0] }), M(f6[1], d6.coord) && (s ? d6.coord = f6[1] : r6.pop()), s && M(d6.coord, f6[1]) && r6.push({ coord: f6[1] });
      function M(A6, I) {
        return A6 = Sc(A6), I = Sc(I), S ? A6 > I : A6 < I;
      }
    }
    var c1 = NFe, HR = Math.PI * 2, yA = wm.CMD, zFe = ["top", "right", "bottom", "left"];
    function BFe(a, r6, t2, s, u) {
      var f6 = t2.width, d6 = t2.height;
      switch (a) {
        case "top":
          s.set(t2.x + f6 / 2, t2.y - r6), u.set(0, -1);
          break;
        case "bottom":
          s.set(t2.x + f6 / 2, t2.y + d6 + r6), u.set(0, 1);
          break;
        case "left":
          s.set(t2.x - r6, t2.y + d6 / 2), u.set(-1, 0);
          break;
        case "right":
          s.set(t2.x + f6 + r6, t2.y + d6 / 2), u.set(1, 0);
          break;
      }
    }
    function jFe(a, r6, t2, s, u, f6, d6, v6, m6) {
      d6 -= a, v6 -= r6;
      var b6 = Math.sqrt(d6 * d6 + v6 * v6);
      d6 /= b6, v6 /= b6;
      var x6 = d6 * t2 + a, S = v6 * t2 + r6;
      if (Math.abs(s - u) % HR < 1e-4)
        return m6[0] = x6, m6[1] = S, b6 - t2;
      if (f6) {
        var M = s;
        s = Ib(u), u = Ib(M);
      } else
        s = Ib(s), u = Ib(u);
      s > u && (u += HR);
      var A6 = Math.atan2(v6, d6);
      if (A6 < 0 && (A6 += HR), A6 >= s && A6 <= u || A6 + HR >= s && A6 + HR <= u)
        return m6[0] = x6, m6[1] = S, b6 - t2;
      var I = t2 * Math.cos(s) + a, R = t2 * Math.sin(s) + r6, F = t2 * Math.cos(u) + a, j = t2 * Math.sin(u) + r6, $ = (I - d6) * (I - d6) + (R - v6) * (R - v6), K = (F - d6) * (F - d6) + (j - v6) * (j - v6);
      return $ < K ? (m6[0] = I, m6[1] = R, Math.sqrt($)) : (m6[0] = F, m6[1] = j, Math.sqrt(K));
    }
    function $V(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = u - a, b6 = f6 - r6, x6 = t2 - a, S = s - r6, M = Math.sqrt(x6 * x6 + S * S);
      x6 /= M, S /= M;
      var A6 = m6 * x6 + b6 * S, I = A6 / M;
      v6 && (I = Math.min(Math.max(I, 0), 1)), I *= M;
      var R = d6[0] = a + I * x6, F = d6[1] = r6 + I * S;
      return Math.sqrt((R - u) * (R - u) + (F - f6) * (F - f6));
    }
    function Dde(a, r6, t2, s, u, f6, d6) {
      t2 < 0 && (a = a + t2, t2 = -t2), s < 0 && (r6 = r6 + s, s = -s);
      var v6 = a + t2, m6 = r6 + s, b6 = d6[0] = Math.min(Math.max(u, a), v6), x6 = d6[1] = Math.min(Math.max(f6, r6), m6);
      return Math.sqrt((b6 - u) * (b6 - u) + (x6 - f6) * (x6 - f6));
    }
    var f1 = [];
    function GFe(a, r6, t2) {
      var s = Dde(r6.x, r6.y, r6.width, r6.height, a.x, a.y, f1);
      return t2.set(f1[0], f1[1]), s;
    }
    function WFe(a, r6, t2) {
      for (var s = 0, u = 0, f6 = 0, d6 = 0, v6, m6, b6 = 1 / 0, x6 = r6.data, S = a.x, M = a.y, A6 = 0; A6 < x6.length; ) {
        var I = x6[A6++];
        A6 === 1 && (s = x6[A6], u = x6[A6 + 1], f6 = s, d6 = u);
        var R = b6;
        switch (I) {
          case yA.M:
            f6 = x6[A6++], d6 = x6[A6++], s = f6, u = d6;
            break;
          case yA.L:
            R = $V(s, u, x6[A6], x6[A6 + 1], S, M, f1, true), s = x6[A6++], u = x6[A6++];
            break;
          case yA.C:
            R = MM(s, u, x6[A6++], x6[A6++], x6[A6++], x6[A6++], x6[A6], x6[A6 + 1], S, M, f1), s = x6[A6++], u = x6[A6++];
            break;
          case yA.Q:
            R = Sh(s, u, x6[A6++], x6[A6++], x6[A6], x6[A6 + 1], S, M, f1), s = x6[A6++], u = x6[A6++];
            break;
          case yA.A:
            var F = x6[A6++], j = x6[A6++], $ = x6[A6++], K = x6[A6++], U = x6[A6++], he = x6[A6++];
            A6 += 1;
            var ue = !!(1 - x6[A6++]);
            v6 = Math.cos(U) * $ + F, m6 = Math.sin(U) * K + j, A6 <= 1 && (f6 = v6, d6 = m6);
            var pe = (S - F) * K / $ + F;
            R = jFe(F, j, K, U, U + he, ue, pe, M, f1), s = Math.cos(U + he) * $ + F, u = Math.sin(U + he) * K + j;
            break;
          case yA.R:
            f6 = s = x6[A6++], d6 = u = x6[A6++];
            var _e = x6[A6++], xe = x6[A6++];
            R = Dde(f6, d6, _e, xe, S, M, f1);
            break;
          case yA.Z:
            R = $V(s, u, f6, d6, S, M, f1, true), s = f6, u = d6;
            break;
        }
        R < b6 && (b6 = R, t2.set(f1[0], f1[1]));
      }
      return b6;
    }
    var h1 = new Bi(), _u = new Bi(), bf = new Bi(), zb = new Bi(), Bb = new Bi();
    function kde(a, r6) {
      if (a) {
        var t2 = a.getTextGuideLine(), s = a.getTextContent();
        if (s && t2) {
          var u = a.textGuideLineConfig || {}, f6 = [[0, 0], [0, 0], [0, 0]], d6 = u.candidates || zFe, v6 = s.getBoundingRect().clone();
          v6.applyTransform(s.getComputedTransform());
          var m6 = 1 / 0, b6 = u.anchor, x6 = a.getComputedTransform(), S = x6 && px([], x6), M = r6.get("length2") || 0;
          b6 && bf.copy(b6);
          for (var A6 = 0; A6 < d6.length; A6++) {
            var I = d6[A6];
            BFe(I, 0, v6, h1, zb), Bi.scaleAndAdd(_u, h1, zb, M), _u.transform(S);
            var R = a.getBoundingRect(), F = b6 ? b6.distance(_u) : a instanceof uo ? WFe(_u, a.path, bf) : GFe(_u, R, bf);
            F < m6 && (m6 = F, _u.transform(x6), bf.transform(x6), bf.toArray(f6[0]), _u.toArray(f6[1]), h1.toArray(f6[2]));
          }
          Pde(f6, r6.get("minTurnAngle")), t2.setShape({ points: f6 });
        }
      }
    }
    var UV = [], Dv = new Bi();
    function Pde(a, r6) {
      if (r6 <= 180 && r6 > 0) {
        r6 = r6 / 180 * Math.PI, h1.fromArray(a[0]), _u.fromArray(a[1]), bf.fromArray(a[2]), Bi.sub(zb, h1, _u), Bi.sub(Bb, bf, _u);
        var t2 = zb.len(), s = Bb.len();
        if (!(t2 < 1e-3 || s < 1e-3)) {
          zb.scale(1 / t2), Bb.scale(1 / s);
          var u = zb.dot(Bb), f6 = Math.cos(r6);
          if (f6 < u) {
            var d6 = $V(_u.x, _u.y, bf.x, bf.y, h1.x, h1.y, UV, false);
            Dv.fromArray(UV), Dv.scaleAndAdd(Bb, d6 / Math.tan(Math.PI - r6));
            var v6 = bf.x !== _u.x ? (Dv.x - _u.x) / (bf.x - _u.x) : (Dv.y - _u.y) / (bf.y - _u.y);
            if (isNaN(v6))
              return;
            v6 < 0 ? Bi.copy(Dv, _u) : v6 > 1 && Bi.copy(Dv, bf), Dv.toArray(a[1]);
          }
        }
      }
    }
    function HFe(a, r6, t2) {
      if (t2 <= 180 && t2 > 0) {
        t2 = t2 / 180 * Math.PI, h1.fromArray(a[0]), _u.fromArray(a[1]), bf.fromArray(a[2]), Bi.sub(zb, _u, h1), Bi.sub(Bb, bf, _u);
        var s = zb.len(), u = Bb.len();
        if (!(s < 1e-3 || u < 1e-3)) {
          zb.scale(1 / s), Bb.scale(1 / u);
          var f6 = zb.dot(r6), d6 = Math.cos(t2);
          if (f6 < d6) {
            var v6 = $V(_u.x, _u.y, bf.x, bf.y, h1.x, h1.y, UV, false);
            Dv.fromArray(UV);
            var m6 = Math.PI / 2, b6 = Math.acos(Bb.dot(r6)), x6 = m6 + b6 - t2;
            if (x6 >= m6)
              Bi.copy(Dv, bf);
            else {
              Dv.scaleAndAdd(Bb, v6 / Math.tan(Math.PI / 2 - x6));
              var S = bf.x !== _u.x ? (Dv.x - _u.x) / (bf.x - _u.x) : (Dv.y - _u.y) / (bf.y - _u.y);
              if (isNaN(S))
                return;
              S < 0 ? Bi.copy(Dv, _u) : S > 1 && Bi.copy(Dv, bf);
            }
            Dv.toArray(a[1]);
          }
        }
      }
    }
    function Lde(a, r6, t2, s) {
      var u = t2 === "normal", f6 = u ? a : a.ensureState(t2);
      f6.ignore = r6;
      var d6 = s.get("smooth");
      d6 && d6 === true && (d6 = 0.3), f6.shape = f6.shape || {}, d6 > 0 && (f6.shape.smooth = d6);
      var v6 = s.getModel("lineStyle").getLineStyle();
      u ? a.useStyle(v6) : f6.style = v6;
    }
    function $Fe(a, r6) {
      var t2 = r6.smooth, s = r6.points;
      if (s)
        if (a.moveTo(s[0][0], s[0][1]), t2 > 0 && s.length >= 3) {
          var u = pm(s[0], s[1]), f6 = pm(s[1], s[2]);
          if (!u || !f6) {
            a.lineTo(s[1][0], s[1][1]), a.lineTo(s[2][0], s[2][1]);
            return;
          }
          var d6 = Math.min(u, f6) * t2, v6 = LT([], s[1], s[0], d6 / u), m6 = LT([], s[1], s[2], d6 / f6), b6 = LT([], v6, m6, 0.5);
          a.bezierCurveTo(v6[0], v6[1], v6[0], v6[1], b6[0], b6[1]), a.bezierCurveTo(m6[0], m6[1], m6[0], m6[1], s[2][0], s[2][1]);
        } else
          for (var x6 = 1; x6 < s.length; x6++)
            a.lineTo(s[x6][0], s[x6][1]);
    }
    function HZ(a, r6, t2) {
      var s = a.getTextGuideLine(), u = a.getTextContent();
      if (!u) {
        s && a.removeTextGuideLine();
        return;
      }
      for (var f6 = r6.normal, d6 = f6.get("show"), v6 = u.ignore, m6 = 0; m6 < KM.length; m6++) {
        var b6 = KM[m6], x6 = r6[b6], S = b6 === "normal";
        if (x6) {
          var M = x6.get("show"), A6 = S ? v6 : qi(u.states[b6] && u.states[b6].ignore, v6);
          if (A6 || !qi(M, d6)) {
            var I = S ? s : s && s.states.normal;
            I && (I.ignore = true);
            continue;
          }
          s || (s = new Vp(), a.setTextGuideLine(s), !S && (v6 || !d6) && Lde(s, true, "normal", r6.normal), a.stateProxy && (s.stateProxy = a.stateProxy)), Lde(s, false, b6, x6);
        }
      }
      if (s) {
        ei(s.style, t2), s.style.fill = null;
        var R = f6.get("showAbove"), F = a.textGuideLineConfig = a.textGuideLineConfig || {};
        F.showAbove = R || false, s.buildPath = $Fe;
      }
    }
    function $Z(a, r6) {
      r6 = r6 || "labelLine";
      for (var t2 = { normal: a.getModel(r6) }, s = 0; s < Oc.length; s++) {
        var u = Oc[s];
        t2[u] = a.getModel([u, r6]);
      }
      return t2;
    }
    function Ode(a) {
      for (var r6 = [], t2 = 0; t2 < a.length; t2++) {
        var s = a[t2];
        if (!s.defaultAttr.ignore) {
          var u = s.label, f6 = u.getComputedTransform(), d6 = u.getBoundingRect(), v6 = !f6 || f6[1] < 1e-5 && f6[2] < 1e-5, m6 = u.style.margin || 0, b6 = d6.clone();
          b6.applyTransform(f6), b6.x -= m6 / 2, b6.y -= m6 / 2, b6.width += m6, b6.height += m6;
          var x6 = v6 ? new HD(d6, f6) : null;
          r6.push({ label: u, labelLine: s.labelLine, rect: b6, localRect: d6, obb: x6, priority: s.priority, defaultAttr: s.defaultAttr, layoutOption: s.computedLayoutOption, axisAligned: v6, transform: f6 });
        }
      }
      return r6;
    }
    function Rde(a, r6, t2, s, u, f6) {
      var d6 = a.length;
      if (d6 < 2)
        return;
      a.sort(function(_e, xe) {
        return _e.rect[r6] - xe.rect[r6];
      });
      for (var v6 = 0, m6, b6 = false, x6 = 0, S = 0; S < d6; S++) {
        var M = a[S], A6 = M.rect;
        m6 = A6[r6] - v6, m6 < 0 && (A6[r6] -= m6, M.label[r6] -= m6, b6 = true);
        var I = Math.max(-m6, 0);
        x6 += I, v6 = A6[r6] + A6[t2];
      }
      x6 > 0 && f6 && he(-x6 / d6, 0, d6);
      var R = a[0], F = a[d6 - 1], j, $;
      K(), j < 0 && ue(-j, 0.8), $ < 0 && ue($, 0.8), K(), U(j, $, 1), U($, j, -1), K(), j < 0 && pe(-j), $ < 0 && pe($);
      function K() {
        j = R.rect[r6] - s, $ = u - F.rect[r6] - F.rect[t2];
      }
      function U(_e, xe, Ae) {
        if (_e < 0) {
          var ke = Math.min(xe, -_e);
          if (ke > 0) {
            he(ke * Ae, 0, d6);
            var je = ke + _e;
            je < 0 && ue(-je * Ae, 1);
          } else
            ue(-_e * Ae, 1);
        }
      }
      function he(_e, xe, Ae) {
        _e !== 0 && (b6 = true);
        for (var ke = xe; ke < Ae; ke++) {
          var je = a[ke], Fe = je.rect;
          Fe[r6] += _e, je.label[r6] += _e;
        }
      }
      function ue(_e, xe) {
        for (var Ae = [], ke = 0, je = 1; je < d6; je++) {
          var Fe = a[je - 1].rect, at = Math.max(a[je].rect[r6] - Fe[r6] - Fe[t2], 0);
          Ae.push(at), ke += at;
        }
        if (ke) {
          var ht = Math.min(Math.abs(_e) / ke, xe);
          if (_e > 0)
            for (var je = 0; je < d6 - 1; je++) {
              var Qe = Ae[je] * ht;
              he(Qe, 0, je + 1);
            }
          else
            for (var je = d6 - 1; je > 0; je--) {
              var Qe = Ae[je - 1] * ht;
              he(-Qe, je, d6);
            }
        }
      }
      function pe(_e) {
        var xe = _e < 0 ? -1 : 1;
        _e = Math.abs(_e);
        for (var Ae = Math.ceil(_e / (d6 - 1)), ke = 0; ke < d6 - 1; ke++)
          if (xe > 0 ? he(Ae, 0, ke + 1) : he(-Ae, d6 - ke - 1, d6), _e -= Ae, _e <= 0)
            return;
      }
      return b6;
    }
    function UFe(a, r6, t2, s) {
      return Rde(a, "x", "width", r6, t2, s);
    }
    function Fde(a, r6, t2, s) {
      return Rde(a, "y", "height", r6, t2, s);
    }
    function Nde(a) {
      var r6 = [];
      a.sort(function(R, F) {
        return F.priority - R.priority;
      });
      var t2 = new Qi(0, 0, 0, 0);
      function s(R) {
        if (!R.ignore) {
          var F = R.ensureState("emphasis");
          F.ignore == null && (F.ignore = false);
        }
        R.ignore = true;
      }
      for (var u = 0; u < a.length; u++) {
        var f6 = a[u], d6 = f6.axisAligned, v6 = f6.localRect, m6 = f6.transform, b6 = f6.label, x6 = f6.labelLine;
        t2.copy(f6.rect), t2.width -= 0.1, t2.height -= 0.1, t2.x += 0.05, t2.y += 0.05;
        for (var S = f6.obb, M = false, A6 = 0; A6 < r6.length; A6++) {
          var I = r6[A6];
          if (t2.intersect(I.rect)) {
            if (d6 && I.axisAligned) {
              M = true;
              break;
            }
            if (I.obb || (I.obb = new HD(I.localRect, I.transform)), S || (S = new HD(v6, m6)), S.intersect(I.obb)) {
              M = true;
              break;
            }
          }
        }
        M ? (s(b6), x6 && s(x6)) : (b6.attr("ignore", f6.defaultAttr.ignore), x6 && x6.attr("ignore", f6.defaultAttr.labelGuideIgnore), r6.push(f6));
      }
    }
    function qFe(a) {
      if (a) {
        for (var r6 = [], t2 = 0; t2 < a.length; t2++)
          r6.push(a[t2].slice());
        return r6;
      }
    }
    function YFe(a, r6) {
      var t2 = a.label, s = r6 && r6.getTextGuideLine();
      return { dataIndex: a.dataIndex, dataType: a.dataType, seriesIndex: a.seriesModel.seriesIndex, text: a.label.style.text, rect: a.hostRect, labelRect: a.rect, align: t2.style.align, verticalAlign: t2.style.verticalAlign, labelLinePoints: qFe(s && s.shape.points) };
    }
    var Vde = ["align", "verticalAlign", "width", "height", "fontSize"], d0 = new a0(), UZ = Xo(), ZFe = Xo();
    function qV(a, r6, t2) {
      for (var s = 0; s < t2.length; s++) {
        var u = t2[s];
        r6[u] != null && (a[u] = r6[u]);
      }
    }
    var YV = ["x", "y", "rotation"], XFe = function() {
      function a() {
        this._labelList = [], this._chartViewList = [];
      }
      return a.prototype.clearLabels = function() {
        this._labelList = [], this._chartViewList = [];
      }, a.prototype._addLabel = function(r6, t2, s, u, f6) {
        var d6 = u.style, v6 = u.__hostTarget, m6 = v6.textConfig || {}, b6 = u.getComputedTransform(), x6 = u.getBoundingRect().plain();
        Qi.applyTransform(x6, x6, b6), b6 ? d0.setLocalTransform(b6) : (d0.x = d0.y = d0.rotation = d0.originX = d0.originY = 0, d0.scaleX = d0.scaleY = 1);
        var S = u.__hostTarget, M;
        if (S) {
          M = S.getBoundingRect().plain();
          var A6 = S.getComputedTransform();
          Qi.applyTransform(M, M, A6);
        }
        var I = M && S.getTextGuideLine();
        this._labelList.push({ label: u, labelLine: I, seriesModel: s, dataIndex: r6, dataType: t2, layoutOption: f6, computedLayoutOption: null, rect: x6, hostRect: M, priority: M ? M.width * M.height : 0, defaultAttr: { ignore: u.ignore, labelGuideIgnore: I && I.ignore, x: d0.x, y: d0.y, scaleX: d0.scaleX, scaleY: d0.scaleY, rotation: d0.rotation, style: { x: d6.x, y: d6.y, align: d6.align, verticalAlign: d6.verticalAlign, width: d6.width, height: d6.height, fontSize: d6.fontSize }, cursor: u.cursor, attachedPos: m6.position, attachedRot: m6.rotation } });
      }, a.prototype.addLabelsOfSeries = function(r6) {
        var t2 = this;
        this._chartViewList.push(r6);
        var s = r6.__model, u = s.get("labelLayout");
        !(ti(u) || Po(u).length) || r6.group.traverse(function(f6) {
          if (f6.ignore)
            return true;
          var d6 = f6.getTextContent(), v6 = ii(f6);
          d6 && !d6.disableLabelLayout && t2._addLabel(v6.dataIndex, v6.dataType, s, d6, u);
        });
      }, a.prototype.updateLayoutConfig = function(r6) {
        var t2 = r6.getWidth(), s = r6.getHeight();
        function u(K, U) {
          return function() {
            kde(K, U);
          };
        }
        for (var f6 = 0; f6 < this._labelList.length; f6++) {
          var d6 = this._labelList[f6], v6 = d6.label, m6 = v6.__hostTarget, b6 = d6.defaultAttr, x6 = void 0;
          ti(d6.layoutOption) ? x6 = d6.layoutOption(YFe(d6, m6)) : x6 = d6.layoutOption, x6 = x6 || {}, d6.computedLayoutOption = x6;
          var S = Math.PI / 180;
          m6 && m6.setTextConfig({ local: false, position: x6.x != null || x6.y != null ? null : b6.attachedPos, rotation: x6.rotate != null ? x6.rotate * S : b6.attachedRot, offset: [x6.dx || 0, x6.dy || 0] });
          var M = false;
          if (x6.x != null ? (v6.x = ua(x6.x, t2), v6.setStyle("x", 0), M = true) : (v6.x = b6.x, v6.setStyle("x", b6.style.x)), x6.y != null ? (v6.y = ua(x6.y, s), v6.setStyle("y", 0), M = true) : (v6.y = b6.y, v6.setStyle("y", b6.style.y)), x6.labelLinePoints) {
            var A6 = m6.getTextGuideLine();
            A6 && (A6.setShape({ points: x6.labelLinePoints }), M = false);
          }
          var I = UZ(v6);
          I.needsUpdateLabelLine = M, v6.rotation = x6.rotate != null ? x6.rotate * S : b6.rotation, v6.scaleX = b6.scaleX, v6.scaleY = b6.scaleY;
          for (var R = 0; R < Vde.length; R++) {
            var F = Vde[R];
            v6.setStyle(F, x6[F] != null ? x6[F] : b6.style[F]);
          }
          if (x6.draggable) {
            if (v6.draggable = true, v6.cursor = "move", m6) {
              var j = d6.seriesModel;
              if (d6.dataIndex != null) {
                var $ = d6.seriesModel.getData(d6.dataType);
                j = $.getItemModel(d6.dataIndex);
              }
              v6.on("drag", u(m6, j.getModel("labelLine")));
            }
          } else
            v6.off("drag"), v6.cursor = b6.cursor;
        }
      }, a.prototype.layout = function(r6) {
        var t2 = r6.getWidth(), s = r6.getHeight(), u = Ode(this._labelList), f6 = gl(u, function(m6) {
          return m6.layoutOption.moveOverlap === "shiftX";
        }), d6 = gl(u, function(m6) {
          return m6.layoutOption.moveOverlap === "shiftY";
        });
        UFe(f6, 0, t2), Fde(d6, 0, s);
        var v6 = gl(u, function(m6) {
          return m6.layoutOption.hideOverlap;
        });
        Nde(v6);
      }, a.prototype.processLabelsOverall = function() {
        var r6 = this;
        Ne(this._chartViewList, function(t2) {
          var s = t2.__model, u = t2.ignoreLabelLineUpdate, f6 = s.isAnimationEnabled();
          t2.group.traverse(function(d6) {
            if (d6.ignore && !d6.forceLabelAnimation)
              return true;
            var v6 = !u, m6 = d6.getTextContent();
            !v6 && m6 && (v6 = UZ(m6).needsUpdateLabelLine), v6 && r6._updateLabelLine(d6, s), f6 && r6._animateLabels(d6, s);
          });
        });
      }, a.prototype._updateLabelLine = function(r6, t2) {
        var s = r6.getTextContent(), u = ii(r6), f6 = u.dataIndex;
        if (s && f6 != null) {
          var d6 = t2.getData(u.dataType), v6 = d6.getItemModel(f6), m6 = {}, b6 = d6.getItemVisual(f6, "style"), x6 = d6.getVisual("drawType");
          m6.stroke = b6[x6];
          var S = v6.getModel("labelLine");
          HZ(r6, $Z(v6), m6), kde(r6, S);
        }
      }, a.prototype._animateLabels = function(r6, t2) {
        var s = r6.getTextContent(), u = r6.getTextGuideLine();
        if (s && (r6.forceLabelAnimation || !s.ignore && !s.invisible && !r6.disableLabelAnimation && !q22(r6))) {
          var f6 = UZ(s), d6 = f6.oldLayout, v6 = ii(r6), m6 = v6.dataIndex, b6 = { x: s.x, y: s.y, rotation: s.rotation }, x6 = t2.getData(v6.dataType);
          if (d6) {
            s.attr(d6);
            var S = r6.prevStates;
            S && (Vi(S, "select") >= 0 && s.attr(f6.oldLayoutSelect), Vi(S, "emphasis") >= 0 && s.attr(f6.oldLayoutEmphasis)), fs(s, b6, t2, m6);
          } else if (s.attr(b6), !qD(s).valueAnimation) {
            var M = qi(s.style.opacity, 1);
            s.style.opacity = 0, zu(s, { style: { opacity: M } }, t2, m6);
          }
          if (f6.oldLayout = b6, s.states.select) {
            var A6 = f6.oldLayoutSelect = {};
            qV(A6, b6, YV), qV(A6, s.states.select, YV);
          }
          if (s.states.emphasis) {
            var I = f6.oldLayoutEmphasis = {};
            qV(I, b6, YV), qV(I, s.states.emphasis, YV);
          }
          tce(s, m6, x6, t2, t2);
        }
        if (u && !u.ignore && !u.invisible) {
          var f6 = ZFe(u), d6 = f6.oldLayout, R = { points: u.shape.points };
          d6 ? (u.attr({ shape: d6 }), fs(u, { shape: R }, t2)) : (u.setShape(R), u.style.strokePercent = 0, zu(u, { style: { strokePercent: 1 } }, t2)), f6.oldLayout = R;
        }
      }, a;
    }(), KFe = XFe, qZ = Xo();
    function JFe(a) {
      a.registerUpdateLifecycle("series:beforeupdate", function(r6, t2, s) {
        var u = qZ(t2).labelManager;
        u || (u = qZ(t2).labelManager = new KFe()), u.clearLabels();
      }), a.registerUpdateLifecycle("series:layoutlabels", function(r6, t2, s) {
        var u = qZ(t2).labelManager;
        s.updatedSeries.forEach(function(f6) {
          u.addLabelsOfSeries(t2.getViewOfSeriesModel(f6));
        }), u.updateLayoutConfig(t2), u.layout(t2), u.processLabelsOverall();
      });
    }
    var YZ = Math.sin, ZZ = Math.cos, zde = Math.PI, bA = Math.PI * 2, QFe = 180 / zde, eNe = function() {
      function a() {
      }
      return a.prototype.reset = function(r6) {
        this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, r6 || 4);
      }, a.prototype.moveTo = function(r6, t2) {
        this._add("M", r6, t2);
      }, a.prototype.lineTo = function(r6, t2) {
        this._add("L", r6, t2);
      }, a.prototype.bezierCurveTo = function(r6, t2, s, u, f6, d6) {
        this._add("C", r6, t2, s, u, f6, d6);
      }, a.prototype.quadraticCurveTo = function(r6, t2, s, u) {
        this._add("Q", r6, t2, s, u);
      }, a.prototype.arc = function(r6, t2, s, u, f6, d6) {
        this.ellipse(r6, t2, s, s, 0, u, f6, d6);
      }, a.prototype.ellipse = function(r6, t2, s, u, f6, d6, v6, m6) {
        var b6 = v6 - d6, x6 = !m6, S = Math.abs(b6), M = db(S - bA) || (x6 ? b6 >= bA : -b6 >= bA), A6 = b6 > 0 ? b6 % bA : b6 % bA + bA, I = false;
        M ? I = true : db(S) ? I = false : I = A6 >= zde == !!x6;
        var R = r6 + s * ZZ(d6), F = t2 + u * YZ(d6);
        this._start && this._add("M", R, F);
        var j = Math.round(f6 * QFe);
        if (M) {
          var $ = 1 / this._p, K = (x6 ? 1 : -1) * (bA - $);
          this._add("A", s, u, j, 1, +x6, r6 + s * ZZ(d6 + K), t2 + u * YZ(d6 + K)), $ > 0.01 && this._add("A", s, u, j, 0, +x6, R, F);
        } else {
          var U = r6 + s * ZZ(v6), he = t2 + u * YZ(v6);
          this._add("A", s, u, j, +I, +x6, U, he);
        }
      }, a.prototype.rect = function(r6, t2, s, u) {
        this._add("M", r6, t2), this._add("l", s, 0), this._add("l", 0, u), this._add("l", -s, 0), this._add("Z");
      }, a.prototype.closePath = function() {
        this._d.length > 0 && this._add("Z");
      }, a.prototype._add = function(r6, t2, s, u, f6, d6, v6, m6, b6) {
        for (var x6 = [], S = this._p, M = 1; M < arguments.length; M++) {
          var A6 = arguments[M];
          if (isNaN(A6)) {
            this._invalid = true;
            return;
          }
          x6.push(Math.round(A6 * S) / S);
        }
        this._d.push(r6 + x6.join(" ")), this._start = r6 === "Z";
      }, a.prototype.generateStr = function() {
        this._str = this._invalid ? "" : this._d.join(""), this._d = [];
      }, a.prototype.getStr = function() {
        return this._str;
      }, a;
    }(), Bde = eNe, $R = "none", tNe = Math.round;
    function nNe(a) {
      var r6 = a.fill;
      return r6 != null && r6 !== $R;
    }
    function rNe(a) {
      var r6 = a.stroke;
      return r6 != null && r6 !== $R;
    }
    var XZ = ["lineCap", "miterLimit", "lineJoin"], aNe = wr(XZ, function(a) {
      return "stroke-" + a.toLowerCase();
    });
    function iNe(a, r6, t2, s) {
      var u = r6.opacity == null ? 1 : r6.opacity;
      if (t2 instanceof nh) {
        a("opacity", u);
        return;
      }
      if (nNe(r6)) {
        var f6 = F2(r6.fill);
        a("fill", f6.color);
        var d6 = r6.fillOpacity != null ? r6.fillOpacity * f6.opacity * u : f6.opacity * u;
        (s || d6 < 1) && a("fill-opacity", d6);
      } else
        a("fill", $R);
      if (rNe(r6)) {
        var v6 = F2(r6.stroke);
        a("stroke", v6.color);
        var m6 = r6.strokeNoScale ? t2.getLineScale() : 1, b6 = m6 ? (r6.lineWidth || 0) / m6 : 0, x6 = r6.strokeOpacity != null ? r6.strokeOpacity * v6.opacity * u : v6.opacity * u, S = r6.strokeFirst;
        if ((s || b6 !== 1) && a("stroke-width", b6), (s || S) && a("paint-order", S ? "stroke" : "fill"), (s || x6 < 1) && a("stroke-opacity", x6), r6.lineDash) {
          var M = fZ(t2), A6 = M[0], I = M[1];
          A6 && (I = tNe(I || 0), a("stroke-dasharray", A6.join(",")), (I || s) && a("stroke-dashoffset", I));
        } else
          s && a("stroke-dasharray", $R);
        for (var R = 0; R < XZ.length; R++) {
          var F = XZ[R];
          if (s || r6[F] !== ED[F]) {
            var j = r6[F] || ED[F];
            j && a(aNe[R], j);
          }
        }
      } else
        s && a("stroke", $R);
    }
    var jde = "http://www.w3.org/2000/svg", Gde = "http://www.w3.org/1999/xlink", oNe = "http://www.w3.org/2000/xmlns/", sNe = "http://www.w3.org/XML/1998/namespace";
    function Wde(a) {
      return document.createElementNS(jde, a);
    }
    function Th(a, r6, t2, s, u) {
      return { tag: a, attrs: t2 || {}, children: s, text: u, key: r6 };
    }
    function lNe(a, r6) {
      var t2 = [];
      if (r6)
        for (var s in r6) {
          var u = r6[s], f6 = s;
          u !== false && (u !== true && u != null && (f6 += '="' + u + '"'), t2.push(f6));
        }
      return "<" + a + " " + t2.join(" ") + ">";
    }
    function uNe(a) {
      return "</" + a + ">";
    }
    function KZ(a, r6) {
      r6 = r6 || {};
      var t2 = r6.newline ? `
` : "";
      function s(u) {
        var f6 = u.children, d6 = u.tag, v6 = u.attrs;
        return lNe(d6, v6) + (u.text || "") + (f6 ? "" + t2 + wr(f6, function(m6) {
          return s(m6);
        }).join(t2) + t2 : "") + uNe(d6);
      }
      return s(a);
    }
    function cNe(a, r6, t2) {
      t2 = t2 || {};
      var s = t2.newline ? `
` : "", u = " {" + s, f6 = s + "}", d6 = wr(Po(a), function(m6) {
        return m6 + u + wr(Po(a[m6]), function(b6) {
          return b6 + ":" + a[m6][b6] + ";";
        }).join(s) + f6;
      }).join(s), v6 = wr(Po(r6), function(m6) {
        return "@keyframes " + m6 + u + wr(Po(r6[m6]), function(b6) {
          return b6 + u + wr(Po(r6[m6][b6]), function(x6) {
            var S = r6[m6][b6][x6];
            return x6 === "d" && (S = 'path("' + S + '")'), x6 + ":" + S + ";";
          }).join(s) + f6;
        }).join(s) + f6;
      }).join(s);
      return !d6 && !v6 ? "" : ["<![CDATA[", d6, v6, "]]>"].join(s);
    }
    function JZ(a) {
      return { zrId: a, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
    }
    function Hde(a, r6, t2, s) {
      return Th("svg", "root", { width: a, height: r6, xmlns: jde, "xmlns:xlink": Gde, version: "1.1", baseProfile: "full", viewBox: s ? "0 0 " + a + " " + r6 : false }, t2);
    }
    var $de = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, _A = "transform-origin";
    function fNe(a, r6, t2) {
      var s = qn({}, a.shape);
      qn(s, r6), a.buildPath(t2, s);
      var u = new Bde();
      return u.reset(A9(a)), t2.rebuildPath(u, 1), u.generateStr(), u.getStr();
    }
    function hNe(a, r6) {
      var t2 = r6.originX, s = r6.originY;
      (t2 || s) && (a[_A] = t2 + "px " + s + "px");
    }
    var dNe = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
    function Ude(a, r6) {
      var t2 = r6.zrId + "-ani-" + r6.cssAnimIdx++;
      return r6.cssAnims[t2] = a, t2;
    }
    function pNe(a, r6, t2) {
      var s = a.shape.paths, u = {}, f6, d6;
      if (Ne(s, function(m6) {
        var b6 = JZ(t2.zrId);
        b6.animation = true, ZV(m6, {}, b6, true);
        var x6 = b6.cssAnims, S = b6.cssNodes, M = Po(x6), A6 = M.length;
        if (A6) {
          d6 = M[A6 - 1];
          var I = x6[d6];
          for (var R in I) {
            var F = I[R];
            u[R] = u[R] || { d: "" }, u[R].d += F.d || "";
          }
          for (var j in S) {
            var $ = S[j].animation;
            $.indexOf(d6) >= 0 && (f6 = $);
          }
        }
      }), !!f6) {
        r6.d = false;
        var v6 = Ude(u, t2);
        return f6.replace(d6, v6);
      }
    }
    function qde(a) {
      return _a2(a) ? $de[a] ? "cubic-bezier(" + $de[a] + ")" : BT(a) ? a : "" : "";
    }
    function ZV(a, r6, t2, s) {
      var u = a.animators, f6 = u.length, d6 = [];
      if (a instanceof iR) {
        var v6 = pNe(a, r6, t2);
        if (v6)
          d6.push(v6);
        else if (!f6)
          return;
      } else if (!f6)
        return;
      for (var m6 = {}, b6 = 0; b6 < f6; b6++) {
        var x6 = u[b6], S = [x6.getMaxTime() / 1e3 + "s"], M = qde(x6.getClip().easing), A6 = x6.getDelay();
        M ? S.push(M) : S.push("linear"), A6 && S.push(A6 / 1e3 + "s"), x6.getLoop() && S.push("infinite");
        var I = S.join(" ");
        m6[I] = m6[I] || [I, []], m6[I][1].push(x6);
      }
      function R($) {
        var K = $[1], U = K.length, he = {}, ue = {}, pe = {}, _e = "animation-timing-function";
        function xe(pa, Fa, Ha) {
          for (var Sa = pa.getTracks(), oi = pa.getMaxTime(), bs = 0; bs < Sa.length; bs++) {
            var Si = Sa[bs];
            if (Si.needsAnimate()) {
              var Ls = Si.keyframes, tl = Si.propName;
              if (Ha && (tl = Ha(tl)), tl)
                for (var Hs = 0; Hs < Ls.length; Hs++) {
                  var Of = Ls[Hs], Xu = Math.round(Of.time / oi * 100) + "%", kh = qde(Of.easing), ou = Of.rawValue;
                  (_a2(ou) || ks(ou)) && (Fa[Xu] = Fa[Xu] || {}, Fa[Xu][tl] = Of.rawValue, kh && (Fa[Xu][_e] = kh));
                }
            }
          }
        }
        for (var Ae = 0; Ae < U; Ae++) {
          var ke = K[Ae], je = ke.targetName;
          je ? je === "shape" && xe(ke, ue) : !s && xe(ke, he);
        }
        for (var Fe in he) {
          var at = {};
          N9(at, a), qn(at, he[Fe]);
          var ht = E9(at), Qe = he[Fe][_e];
          pe[Fe] = ht ? { transform: ht } : {}, hNe(pe[Fe], at), Qe && (pe[Fe][_e] = Qe);
        }
        var en, bt = true;
        for (var Fe in ue) {
          pe[Fe] = pe[Fe] || {};
          var wt = !en, Qe = ue[Fe][_e];
          wt && (en = new wm());
          var Ft = en.len();
          en.reset(), pe[Fe].d = fNe(a, ue[Fe], en);
          var fn = en.len();
          if (!wt && Ft !== fn) {
            bt = false;
            break;
          }
          Qe && (pe[Fe][_e] = Qe);
        }
        if (!bt)
          for (var Fe in pe)
            delete pe[Fe].d;
        if (!s)
          for (var Ae = 0; Ae < U; Ae++) {
            var ke = K[Ae], je = ke.targetName;
            je === "style" && xe(ke, pe, function(Sa) {
              return dNe[Sa];
            });
          }
        for (var gn = Po(pe), Zr = true, Ma, Ae = 1; Ae < gn.length; Ae++) {
          var Ua = gn[Ae - 1], ja = gn[Ae];
          if (pe[Ua][_A] !== pe[ja][_A]) {
            Zr = false;
            break;
          }
          Ma = pe[Ua][_A];
        }
        if (Zr && Ma) {
          for (var Fe in pe)
            pe[Fe][_A] && delete pe[Fe][_A];
          r6[_A] = Ma;
        }
        if (gl(gn, function(pa) {
          return Po(pe[pa]).length > 0;
        }).length) {
          var Ga = Ude(pe, t2);
          return Ga + " " + $[0] + " both";
        }
      }
      for (var F in m6) {
        var v6 = R(m6[F]);
        v6 && d6.push(v6);
      }
      if (d6.length) {
        var j = t2.zrId + "-cls-" + t2.cssClassIdx++;
        t2.cssNodes["." + j] = { animation: d6.join(",") }, r6.class = j;
      }
    }
    var UR = Math.round;
    function Yde(a) {
      return a && _a2(a.src);
    }
    function Zde(a) {
      return a && ti(a.toDataURL);
    }
    function QZ(a, r6, t2, s) {
      iNe(function(u, f6) {
        var d6 = u === "fill" || u === "stroke";
        d6 && BU(f6) ? wNe(r6, a, u, s) : d6 && zU(f6) ? SNe(t2, a, u, s) : a[u] = f6;
      }, r6, t2, false), xNe(t2, a, s);
    }
    function Xde(a) {
      return db(a[0] - 1) && db(a[1]) && db(a[2]) && db(a[3] - 1);
    }
    function vNe(a) {
      return db(a[4]) && db(a[5]);
    }
    function eX(a, r6, t2) {
      if (r6 && !(vNe(r6) && Xde(r6))) {
        var s = t2 ? 10 : 1e4;
        a.transform = Xde(r6) ? "translate(" + UR(r6[4] * s) / s + " " + UR(r6[5] * s) / s + ")" : OU(r6);
      }
    }
    function Kde(a, r6, t2) {
      for (var s = a.points, u = [], f6 = 0; f6 < s.length; f6++)
        u.push(UR(s[f6][0] * t2) / t2), u.push(UR(s[f6][1] * t2) / t2);
      r6.points = u.join(" ");
    }
    function Jde(a) {
      return !a.smooth;
    }
    function gNe(a) {
      var r6 = wr(a, function(t2) {
        return typeof t2 == "string" ? [t2, t2] : t2;
      });
      return function(t2, s, u) {
        for (var f6 = 0; f6 < r6.length; f6++) {
          var d6 = r6[f6], v6 = t2[d6[0]];
          v6 != null && (s[d6[1]] = UR(v6 * u) / u);
        }
      };
    }
    var mNe = { circle: [gNe(["cx", "cy", "r"])], polyline: [Kde, Jde], polygon: [Kde, Jde] };
    function yNe(a) {
      for (var r6 = a.animators, t2 = 0; t2 < r6.length; t2++)
        if (r6[t2].targetName === "shape")
          return true;
      return false;
    }
    function Qde(a, r6) {
      var t2 = a.style, s = a.shape, u = mNe[a.type], f6 = {}, d6 = r6.animation, v6 = "path", m6 = a.style.strokePercent, b6 = r6.compress && A9(a) || 4;
      if (u && !r6.willUpdate && !(u[1] && !u[1](s)) && !(d6 && yNe(a)) && !(m6 < 1)) {
        v6 = a.type;
        var x6 = Math.pow(10, b6);
        u[0](s, f6, x6);
      } else {
        a.path || a.createPathProxy();
        var S = a.path;
        a.shapeChanged() && (S.beginPath(), a.buildPath(S, a.shape), a.pathUpdated());
        var M = S.getVersion(), A6 = a, I = A6.__svgPathBuilder;
        (A6.__svgPathVersion !== M || !I || m6 !== A6.__svgPathStrokePercent) && (I || (I = A6.__svgPathBuilder = new Bde()), I.reset(b6), S.rebuildPath(I, m6), I.generateStr(), A6.__svgPathVersion = M, A6.__svgPathStrokePercent = m6), f6.d = I.getStr();
      }
      return eX(f6, a.transform), QZ(f6, t2, a, r6), r6.animation && ZV(a, f6, r6), Th(v6, a.id + "", f6);
    }
    function bNe(a, r6) {
      var t2 = a.style, s = t2.image;
      if (s && !_a2(s) && (Yde(s) ? s = s.src : Zde(s) && (s = s.toDataURL())), !!s) {
        var u = t2.x || 0, f6 = t2.y || 0, d6 = t2.width, v6 = t2.height, m6 = { href: s, width: d6, height: v6 };
        return u && (m6.x = u), f6 && (m6.y = f6), eX(m6, a.transform), QZ(m6, t2, a, r6), r6.animation && ZV(a, m6, r6), Th("image", a.id + "", m6);
      }
    }
    function _Ne(a, r6) {
      var t2 = a.style, s = t2.text;
      if (s != null && (s += ""), !(!s || isNaN(t2.x) || isNaN(t2.y))) {
        var u = t2.font || Gs, f6 = t2.x || 0, d6 = Xy(t2.y || 0, RM(u), t2.textBaseline), v6 = RU[t2.textAlign] || t2.textAlign, m6 = { "dominant-baseline": "central", "text-anchor": v6 };
        if (m7(t2)) {
          var b6 = "", x6 = t2.fontStyle, S = v7(t2.fontSize);
          if (!parseFloat(S))
            return;
          var M = t2.fontFamily || Ds, A6 = t2.fontWeight;
          b6 += "font-size:" + S + ";font-family:" + M + ";", x6 && x6 !== "normal" && (b6 += "font-style:" + x6 + ";"), A6 && A6 !== "normal" && (b6 += "font-weight:" + A6 + ";"), m6.style = b6;
        } else
          m6.style = "font: " + u;
        return s.match(/\s/) && (m6["xml:space"] = "preserve"), f6 && (m6.x = f6), d6 && (m6.y = d6), eX(m6, a.transform), QZ(m6, t2, a, r6), r6.animation && ZV(a, m6, r6), Th("text", a.id + "", m6, void 0, s);
      }
    }
    function epe(a, r6) {
      if (a instanceof uo)
        return Qde(a, r6);
      if (a instanceof nh)
        return bNe(a, r6);
      if (a instanceof YM)
        return _Ne(a, r6);
    }
    function xNe(a, r6, t2) {
      var s = a.style;
      if (FU(s)) {
        var u = NU(a), f6 = t2.shadowCache, d6 = f6[u];
        if (!d6) {
          var v6 = a.getGlobalScale(), m6 = v6[0], b6 = v6[1];
          if (!m6 || !b6)
            return;
          var x6 = s.shadowOffsetX || 0, S = s.shadowOffsetY || 0, M = s.shadowBlur, A6 = F2(s.shadowColor), I = A6.opacity, R = A6.color, F = M / 2 / m6, j = M / 2 / b6, $ = F + " " + j;
          d6 = t2.zrId + "-s" + t2.shadowIdx++, t2.defs[d6] = Th("filter", d6, { id: d6, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [Th("feDropShadow", "", { dx: x6 / m6, dy: S / b6, stdDeviation: $, "flood-color": R, "flood-opacity": I })]), f6[u] = d6;
        }
        r6.filter = kp(d6);
      }
    }
    function wNe(a, r6, t2, s) {
      var u = a[t2], f6, d6 = { gradientUnits: u.global ? "userSpaceOnUse" : "objectBoundingBox" };
      if (pb(u))
        f6 = "linearGradient", d6.x1 = u.x, d6.y1 = u.y, d6.x2 = u.x2, d6.y2 = u.y2;
      else if (M9(u))
        f6 = "radialGradient", d6.cx = qi(u.x, 0.5), d6.cy = qi(u.y, 0.5), d6.r = qi(u.r, 0.5);
      else
        return;
      for (var v6 = u.colorStops, m6 = [], b6 = 0, x6 = v6.length; b6 < x6; ++b6) {
        var S = FL(v6[b6].offset) * 100 + "%", M = v6[b6].color, A6 = F2(M), I = A6.color, R = A6.opacity, F = { offset: S };
        F["stop-color"] = I, R < 1 && (F["stop-opacity"] = R), m6.push(Th("stop", b6 + "", F));
      }
      var j = Th(f6, "", d6, m6), $ = KZ(j), K = s.gradientCache, U = K[$];
      U || (U = s.zrId + "-g" + s.gradientIdx++, K[$] = U, d6.id = U, s.defs[U] = Th(f6, U, d6, m6)), r6[t2] = kp(U);
    }
    function SNe(a, r6, t2, s) {
      var u = a.style[t2], f6 = { patternUnits: "userSpaceOnUse" }, d6;
      if (C9(u)) {
        var v6 = u.imageWidth, m6 = u.imageHeight, b6 = void 0, x6 = u.image;
        if (_a2(x6) ? b6 = x6 : Yde(x6) ? b6 = x6.src : Zde(x6) && (b6 = x6.toDataURL()), typeof Image == "undefined") {
          var S = "Image width/height must been given explictly in svg-ssr renderer.";
          Hd(v6, S), Hd(m6, S);
        } else if (v6 == null || m6 == null) {
          var M = function($, K) {
            if ($) {
              var U = $.elm, he = $.attrs.width = v6 || K.width, ue = $.attrs.height = m6 || K.height;
              U && (U.setAttribute("width", he), U.setAttribute("height", ue));
            }
          }, A6 = gO(b6, null, a, function($) {
            M(I, $), M(d6, $);
          });
          A6 && A6.width && A6.height && (v6 = v6 || A6.width, m6 = m6 || A6.height);
        }
        d6 = Th("image", "img", { href: b6, width: v6, height: m6 }), f6.width = v6, f6.height = m6;
      } else
        u.svgElement && (d6 = Qa(u.svgElement), f6.width = u.svgWidth, f6.height = u.svgHeight);
      if (d6) {
        f6.patternTransform = E9(u);
        var I = Th("pattern", "", f6, [d6]), R = KZ(I), F = s.patternCache, j = F[R];
        j || (j = s.zrId + "-p" + s.patternIdx++, F[R] = j, f6.id = j, I = s.defs[j] = Th("pattern", j, f6, [d6])), r6[t2] = kp(j);
      }
    }
    function CNe(a, r6, t2) {
      var s = t2.clipPathCache, u = t2.defs, f6 = s[a.id];
      if (!f6) {
        f6 = t2.zrId + "-c" + t2.clipPathIdx++;
        var d6 = { id: f6 };
        s[a.id] = f6, u[f6] = Th("clipPath", f6, d6, [Qde(a, t2)]);
      }
      r6["clip-path"] = kp(f6);
    }
    function tpe(a) {
      return document.createTextNode(a);
    }
    function xA(a, r6, t2) {
      a.insertBefore(r6, t2);
    }
    function npe(a, r6) {
      a.removeChild(r6);
    }
    function rpe(a, r6) {
      a.appendChild(r6);
    }
    function ape(a) {
      return a.parentNode;
    }
    function ipe(a) {
      return a.nextSibling;
    }
    function tX(a, r6) {
      a.textContent = r6;
    }
    var ope = 58, MNe = 120, ANe = Th("", "");
    function nX(a) {
      return a === void 0;
    }
    function jb(a) {
      return a !== void 0;
    }
    function ENe(a, r6, t2) {
      for (var s = {}, u = r6; u <= t2; ++u) {
        var f6 = a[u].key;
        f6 !== void 0 && (s[f6] = u);
      }
      return s;
    }
    function qR(a, r6) {
      var t2 = a.key === r6.key, s = a.tag === r6.tag;
      return s && t2;
    }
    function YR(a) {
      var r6, t2 = a.children, s = a.tag;
      if (jb(s)) {
        var u = a.elm = Wde(s);
        if (rX(ANe, a), br(t2))
          for (r6 = 0; r6 < t2.length; ++r6) {
            var f6 = t2[r6];
            f6 != null && rpe(u, YR(f6));
          }
        else
          jb(a.text) && !ui(a.text) && rpe(u, tpe(a.text));
      } else
        a.elm = tpe(a.text);
      return a.elm;
    }
    function spe(a, r6, t2, s, u) {
      for (; s <= u; ++s) {
        var f6 = t2[s];
        f6 != null && xA(a, YR(f6), r6);
      }
    }
    function XV(a, r6, t2, s) {
      for (; t2 <= s; ++t2) {
        var u = r6[t2];
        if (u != null)
          if (jb(u.tag)) {
            var f6 = ape(u.elm);
            npe(f6, u.elm);
          } else
            npe(a, u.elm);
      }
    }
    function rX(a, r6) {
      var t2, s = r6.elm, u = a && a.attrs || {}, f6 = r6.attrs || {};
      if (u !== f6) {
        for (t2 in f6) {
          var d6 = f6[t2], v6 = u[t2];
          v6 !== d6 && (d6 === true ? s.setAttribute(t2, "") : d6 === false ? s.removeAttribute(t2) : t2.charCodeAt(0) !== MNe ? s.setAttribute(t2, d6) : t2 === "xmlns:xlink" || t2 === "xmlns" ? s.setAttributeNS(oNe, t2, d6) : t2.charCodeAt(3) === ope ? s.setAttributeNS(sNe, t2, d6) : t2.charCodeAt(5) === ope ? s.setAttributeNS(Gde, t2, d6) : s.setAttribute(t2, d6));
        }
        for (t2 in u)
          t2 in f6 || s.removeAttribute(t2);
      }
    }
    function INe(a, r6, t2) {
      for (var s = 0, u = 0, f6 = r6.length - 1, d6 = r6[0], v6 = r6[f6], m6 = t2.length - 1, b6 = t2[0], x6 = t2[m6], S, M, A6, I; s <= f6 && u <= m6; )
        d6 == null ? d6 = r6[++s] : v6 == null ? v6 = r6[--f6] : b6 == null ? b6 = t2[++u] : x6 == null ? x6 = t2[--m6] : qR(d6, b6) ? (d5(d6, b6), d6 = r6[++s], b6 = t2[++u]) : qR(v6, x6) ? (d5(v6, x6), v6 = r6[--f6], x6 = t2[--m6]) : qR(d6, x6) ? (d5(d6, x6), xA(a, d6.elm, ipe(v6.elm)), d6 = r6[++s], x6 = t2[--m6]) : qR(v6, b6) ? (d5(v6, b6), xA(a, v6.elm, d6.elm), v6 = r6[--f6], b6 = t2[++u]) : (nX(S) && (S = ENe(r6, s, f6)), M = S[b6.key], nX(M) ? xA(a, YR(b6), d6.elm) : (A6 = r6[M], A6.tag !== b6.tag ? xA(a, YR(b6), d6.elm) : (d5(A6, b6), r6[M] = void 0, xA(a, A6.elm, d6.elm))), b6 = t2[++u]);
      (s <= f6 || u <= m6) && (s > f6 ? (I = t2[m6 + 1] == null ? null : t2[m6 + 1].elm, spe(a, I, t2, u, m6)) : XV(a, r6, s, f6));
    }
    function d5(a, r6) {
      var t2 = r6.elm = a.elm, s = a.children, u = r6.children;
      a !== r6 && (rX(a, r6), nX(r6.text) ? jb(s) && jb(u) ? s !== u && INe(t2, s, u) : jb(u) ? (jb(a.text) && tX(t2, ""), spe(t2, null, u, 0, u.length - 1)) : jb(s) ? XV(t2, s, 0, s.length - 1) : jb(a.text) && tX(t2, "") : a.text !== r6.text && (jb(s) && XV(t2, s, 0, s.length - 1), tX(t2, r6.text)));
    }
    function TNe(a, r6) {
      if (qR(a, r6))
        d5(a, r6);
      else {
        var t2 = a.elm, s = ape(t2);
        YR(r6), s !== null && (xA(s, r6.elm, ipe(t2)), XV(s, [a], 0, 0));
      }
      return r6;
    }
    var DNe = 0, kNe = function() {
      function a(r6, t2, s) {
        if (this.type = "svg", this.refreshHover = lpe(), this.configLayer = lpe(), this.storage = t2, this._opts = s = qn({}, s), this.root = r6, this._id = "zr" + DNe++, this._oldVNode = Hde(s.width, s.height), r6 && !s.ssr) {
          var u = this._viewport = document.createElement("div");
          u.style.cssText = "position:relative;overflow:hidden";
          var f6 = this._svgDom = this._oldVNode.elm = Wde("svg");
          rX(null, this._oldVNode), u.appendChild(f6), r6.appendChild(u);
        }
        this.resize(s.width, s.height);
      }
      return a.prototype.getType = function() {
        return this.type;
      }, a.prototype.getViewportRoot = function() {
        return this._viewport;
      }, a.prototype.getViewportRootOffset = function() {
        var r6 = this.getViewportRoot();
        if (r6)
          return { offsetLeft: r6.offsetLeft || 0, offsetTop: r6.offsetTop || 0 };
      }, a.prototype.getSvgDom = function() {
        return this._svgDom;
      }, a.prototype.refresh = function() {
        if (this.root) {
          var r6 = this.renderToVNode({ willUpdate: true });
          r6.attrs.style = "position:absolute;left:0;top:0;user-select:none", TNe(this._oldVNode, r6), this._oldVNode = r6;
        }
      }, a.prototype.renderOneToVNode = function(r6) {
        return epe(r6, JZ(this._id));
      }, a.prototype.renderToVNode = function(r6) {
        r6 = r6 || {};
        var t2 = this.storage.getDisplayList(true), s = this._backgroundColor, u = this._width, f6 = this._height, d6 = JZ(this._id);
        d6.animation = r6.animation, d6.willUpdate = r6.willUpdate, d6.compress = r6.compress;
        var v6 = [];
        if (s && s !== "none") {
          var m6 = F2(s), b6 = m6.color, x6 = m6.opacity;
          this._bgVNode = Th("rect", "bg", { width: u, height: f6, x: "0", y: "0", id: "0", fill: b6, "fill-opacity": x6 }), v6.push(this._bgVNode);
        } else
          this._bgVNode = null;
        var S = r6.compress ? null : this._mainVNode = Th("g", "main", {}, []);
        this._paintList(t2, d6, S ? S.children : v6), S && v6.push(S);
        var M = wr(Po(d6.defs), function(R) {
          return d6.defs[R];
        });
        if (M.length && v6.push(Th("defs", "defs", {}, M)), r6.animation) {
          var A6 = cNe(d6.cssNodes, d6.cssAnims, { newline: true });
          if (A6) {
            var I = Th("style", "stl", {}, [], A6);
            v6.push(I);
          }
        }
        return Hde(u, f6, v6, r6.useViewBox);
      }, a.prototype.renderToString = function(r6) {
        return r6 = r6 || {}, KZ(this.renderToVNode({ animation: qi(r6.cssAnimation, true), willUpdate: false, compress: true, useViewBox: qi(r6.useViewBox, true) }), { newline: true });
      }, a.prototype.setBackgroundColor = function(r6) {
        this._backgroundColor = r6;
        var t2 = this._bgVNode;
        if (t2 && t2.elm) {
          var s = F2(r6), u = s.color, f6 = s.opacity;
          t2.elm.setAttribute("fill", u), f6 < 1 && t2.elm.setAttribute("fill-opacity", f6);
        }
      }, a.prototype.getSvgRoot = function() {
        return this._mainVNode && this._mainVNode.elm;
      }, a.prototype._paintList = function(r6, t2, s) {
        for (var u = r6.length, f6 = [], d6 = 0, v6, m6, b6 = 0, x6 = 0; x6 < u; x6++) {
          var S = r6[x6];
          if (!S.invisible) {
            var M = S.__clipPaths, A6 = M && M.length || 0, I = m6 && m6.length || 0, R = void 0;
            for (R = Math.max(A6 - 1, I - 1); R >= 0 && !(M && m6 && M[R] === m6[R]); R--)
              ;
            for (var F = I - 1; F > R; F--)
              d6--, v6 = f6[d6 - 1];
            for (var j = R + 1; j < A6; j++) {
              var $ = {};
              CNe(M[j], $, t2);
              var K = Th("g", "clip-g-" + b6++, $, []);
              (v6 ? v6.children : s).push(K), f6[d6++] = K, v6 = K;
            }
            m6 = M;
            var U = epe(S, t2);
            U && (v6 ? v6.children : s).push(U);
          }
        }
      }, a.prototype.resize = function(r6, t2) {
        var s = this._opts, u = this.root, f6 = this._viewport;
        if (r6 != null && (s.width = r6), t2 != null && (s.height = t2), u && f6 && (f6.style.display = "none", r6 = u5(u, 0, s), t2 = u5(u, 1, s), f6.style.display = ""), this._width !== r6 || this._height !== t2) {
          if (this._width = r6, this._height = t2, f6) {
            var d6 = f6.style;
            d6.width = r6 + "px", d6.height = t2 + "px";
          }
          var v6 = this._svgDom;
          v6 && (v6.setAttribute("width", r6), v6.setAttribute("height", t2));
        }
      }, a.prototype.getWidth = function() {
        return this._width;
      }, a.prototype.getHeight = function() {
        return this._height;
      }, a.prototype.dispose = function() {
        this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
      }, a.prototype.clear = function() {
        this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
      }, a.prototype.toDataURL = function(r6) {
        var t2 = encodeURIComponent(this.renderToString()), s = "data:image/svg+xml;";
        return r6 ? (t2 = jU(t2), t2 && s + "base64," + t2) : s + "charset=UTF-8," + t2;
      }, a;
    }();
    function lpe(a) {
      return function() {
      };
    }
    var PNe = kNe;
    function LNe(a) {
      a.registerPainter("svg", PNe);
    }
    function upe(a, r6, t2) {
      var s = Tc.createCanvas(), u = r6.getWidth(), f6 = r6.getHeight(), d6 = s.style;
      return d6 && (d6.position = "absolute", d6.left = "0", d6.top = "0", d6.width = u + "px", d6.height = f6 + "px", s.setAttribute("data-zr-dom-id", a)), s.width = u * t2, s.height = f6 * t2, s;
    }
    var ONe = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this) || this;
        f6.motionBlur = false, f6.lastFrameAlpha = 0.7, f6.dpr = 1, f6.virtual = false, f6.config = {}, f6.incremental = false, f6.zlevel = 0, f6.maxRepaintRectCount = 5, f6.__dirty = true, f6.__firstTimePaint = true, f6.__used = false, f6.__drawIndex = 0, f6.__startIndex = 0, f6.__endIndex = 0, f6.__prevStartIndex = null, f6.__prevEndIndex = null;
        var d6;
        u = u || tD, typeof t2 == "string" ? d6 = upe(t2, s, u) : ui(t2) && (d6 = t2, t2 = d6.id), f6.id = t2, f6.dom = d6;
        var v6 = d6.style;
        return v6 && (hL(d6), d6.onselectstart = function() {
          return false;
        }, v6.padding = "0", v6.margin = "0", v6.borderWidth = "0"), f6.painter = s, f6.dpr = u, f6;
      }
      return r6.prototype.getElementCount = function() {
        return this.__endIndex - this.__startIndex;
      }, r6.prototype.afterBrush = function() {
        this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
      }, r6.prototype.initContext = function() {
        this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
      }, r6.prototype.setUnpainted = function() {
        this.__firstTimePaint = true;
      }, r6.prototype.createBackBuffer = function() {
        var t2 = this.dpr;
        this.domBack = upe("back-" + this.id, this.painter, t2), this.ctxBack = this.domBack.getContext("2d"), t2 !== 1 && this.ctxBack.scale(t2, t2);
      }, r6.prototype.createRepaintRects = function(t2, s, u, f6) {
        if (this.__firstTimePaint)
          return this.__firstTimePaint = false, null;
        var d6 = [], v6 = this.maxRepaintRectCount, m6 = false, b6 = new Qi(0, 0, 0, 0);
        function x6($) {
          if (!(!$.isFinite() || $.isZero()))
            if (d6.length === 0) {
              var K = new Qi(0, 0, 0, 0);
              K.copy($), d6.push(K);
            } else {
              for (var U = false, he = 1 / 0, ue = 0, pe = 0; pe < d6.length; ++pe) {
                var _e = d6[pe];
                if (_e.intersect($)) {
                  var xe = new Qi(0, 0, 0, 0);
                  xe.copy(_e), xe.union($), d6[pe] = xe, U = true;
                  break;
                } else if (m6) {
                  b6.copy($), b6.union(_e);
                  var Ae = $.width * $.height, ke = _e.width * _e.height, je = b6.width * b6.height, Fe = je - Ae - ke;
                  Fe < he && (he = Fe, ue = pe);
                }
              }
              if (m6 && (d6[ue].union($), U = true), !U) {
                var K = new Qi(0, 0, 0, 0);
                K.copy($), d6.push(K);
              }
              m6 || (m6 = d6.length >= v6);
            }
        }
        for (var S = this.__startIndex; S < this.__endIndex; ++S) {
          var M = t2[S];
          if (M) {
            var A6 = M.shouldBePainted(u, f6, true, true), I = M.__isRendered && (M.__dirty & ad || !A6) ? M.getPrevPaintRect() : null;
            I && x6(I);
            var R = A6 && (M.__dirty & ad || !M.__isRendered) ? M.getPaintRect() : null;
            R && x6(R);
          }
        }
        for (var S = this.__prevStartIndex; S < this.__prevEndIndex; ++S) {
          var M = s[S], A6 = M.shouldBePainted(u, f6, true, true);
          if (M && (!A6 || !M.__zr) && M.__isRendered) {
            var I = M.getPrevPaintRect();
            I && x6(I);
          }
        }
        var F;
        do {
          F = false;
          for (var S = 0; S < d6.length; ) {
            if (d6[S].isZero()) {
              d6.splice(S, 1);
              continue;
            }
            for (var j = S + 1; j < d6.length; )
              d6[S].intersect(d6[j]) ? (F = true, d6[S].union(d6[j]), d6.splice(j, 1)) : j++;
            S++;
          }
        } while (F);
        return this._paintRects = d6, d6;
      }, r6.prototype.debugGetPaintRects = function() {
        return (this._paintRects || []).slice();
      }, r6.prototype.resize = function(t2, s) {
        var u = this.dpr, f6 = this.dom, d6 = f6.style, v6 = this.domBack;
        d6 && (d6.width = t2 + "px", d6.height = s + "px"), f6.width = t2 * u, f6.height = s * u, v6 && (v6.width = t2 * u, v6.height = s * u, u !== 1 && this.ctxBack.scale(u, u));
      }, r6.prototype.clear = function(t2, s, u) {
        var f6 = this.dom, d6 = this.ctx, v6 = f6.width, m6 = f6.height;
        s = s || this.clearColor;
        var b6 = this.motionBlur && !t2, x6 = this.lastFrameAlpha, S = this.dpr, M = this;
        b6 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(f6, 0, 0, v6 / S, m6 / S));
        var A6 = this.domBack;
        function I(R, F, j, $) {
          if (d6.clearRect(R, F, j, $), s && s !== "transparent") {
            var K = void 0;
            au(s) ? (K = s.__canvasGradient || cZ(d6, s, { x: 0, y: 0, width: j, height: $ }), s.__canvasGradient = K) : Vu(s) && (K = hZ(d6, s, { dirty: function() {
              M.setUnpainted(), M.__painter.refresh();
            } })), d6.save(), d6.fillStyle = K || s, d6.fillRect(R, F, j, $), d6.restore();
          }
          b6 && (d6.save(), d6.globalAlpha = x6, d6.drawImage(A6, R, F, j, $), d6.restore());
        }
        !u || b6 ? I(0, 0, v6, m6) : u.length && Ne(u, function(R) {
          I(R.x * S, R.y * S, R.width * S, R.height * S);
        });
      }, r6;
    }(Ip), aX = ONe, cpe = 1e5, wA = 314159, KV = 0.01, RNe = 1e-3;
    function FNe(a) {
      return a ? a.__builtin__ ? true : !(typeof a.resize != "function" || typeof a.refresh != "function") : false;
    }
    function NNe(a, r6) {
      var t2 = document.createElement("div");
      return t2.style.cssText = ["position:relative", "width:" + a + "px", "height:" + r6 + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", t2;
    }
    var VNe = function() {
      function a(r6, t2, s, u) {
        this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
        var f6 = !r6.nodeName || r6.nodeName.toUpperCase() === "CANVAS";
        this._opts = s = qn({}, s || {}), this.dpr = s.devicePixelRatio || tD, this._singleCanvas = f6, this.root = r6;
        var d6 = r6.style;
        d6 && (hL(r6), r6.innerHTML = ""), this.storage = t2;
        var v6 = this._zlevelList;
        this._prevDisplayList = [];
        var m6 = this._layers;
        if (f6) {
          var b6 = r6, x6 = b6.width, S = b6.height;
          s.width != null && (x6 = s.width), s.height != null && (S = s.height), this.dpr = s.devicePixelRatio || 1, b6.width = x6 * this.dpr, b6.height = S * this.dpr, this._width = x6, this._height = S;
          var M = new aX(b6, this, this.dpr);
          M.__builtin__ = true, M.initContext(), m6[wA] = M, M.zlevel = wA, v6.push(wA), this._domRoot = r6;
        } else {
          this._width = u5(r6, 0, s), this._height = u5(r6, 1, s);
          var A6 = this._domRoot = NNe(this._width, this._height);
          r6.appendChild(A6);
        }
      }
      return a.prototype.getType = function() {
        return "canvas";
      }, a.prototype.isSingleCanvas = function() {
        return this._singleCanvas;
      }, a.prototype.getViewportRoot = function() {
        return this._domRoot;
      }, a.prototype.getViewportRootOffset = function() {
        var r6 = this.getViewportRoot();
        if (r6)
          return { offsetLeft: r6.offsetLeft || 0, offsetTop: r6.offsetTop || 0 };
      }, a.prototype.refresh = function(r6) {
        var t2 = this.storage.getDisplayList(true), s = this._prevDisplayList, u = this._zlevelList;
        this._redrawId = Math.random(), this._paintList(t2, s, r6, this._redrawId);
        for (var f6 = 0; f6 < u.length; f6++) {
          var d6 = u[f6], v6 = this._layers[d6];
          if (!v6.__builtin__ && v6.refresh) {
            var m6 = f6 === 0 ? this._backgroundColor : null;
            v6.refresh(m6);
          }
        }
        return this._opts.useDirtyRect && (this._prevDisplayList = t2.slice()), this;
      }, a.prototype.refreshHover = function() {
        this._paintHoverList(this.storage.getDisplayList(false));
      }, a.prototype._paintHoverList = function(r6) {
        var t2 = r6.length, s = this._hoverlayer;
        if (s && s.clear(), !!t2) {
          for (var u = { inHover: true, viewWidth: this._width, viewHeight: this._height }, f6, d6 = 0; d6 < t2; d6++) {
            var v6 = r6[d6];
            v6.__inHover && (s || (s = this._hoverlayer = this.getLayer(cpe)), f6 || (f6 = s.ctx, f6.save()), pA(f6, v6, u, d6 === t2 - 1));
          }
          f6 && f6.restore();
        }
      }, a.prototype.getHoverLayer = function() {
        return this.getLayer(cpe);
      }, a.prototype.paintOne = function(r6, t2) {
        she(r6, t2);
      }, a.prototype._paintList = function(r6, t2, s, u) {
        if (this._redrawId === u) {
          s = s || false, this._updateLayerStatus(r6);
          var f6 = this._doPaintList(r6, t2, s), d6 = f6.finished, v6 = f6.needsRefreshHover;
          if (this._needsManuallyCompositing && this._compositeManually(), v6 && this._paintHoverList(r6), d6)
            this.eachLayer(function(b6) {
              b6.afterBrush && b6.afterBrush();
            });
          else {
            var m6 = this;
            AL(function() {
              m6._paintList(r6, t2, s, u);
            });
          }
        }
      }, a.prototype._compositeManually = function() {
        var r6 = this.getLayer(wA).ctx, t2 = this._domRoot.width, s = this._domRoot.height;
        r6.clearRect(0, 0, t2, s), this.eachBuiltinLayer(function(u) {
          u.virtual && r6.drawImage(u.dom, 0, 0, t2, s);
        });
      }, a.prototype._doPaintList = function(r6, t2, s) {
        for (var u = this, f6 = [], d6 = this._opts.useDirtyRect, v6 = 0; v6 < this._zlevelList.length; v6++) {
          var m6 = this._zlevelList[v6], b6 = this._layers[m6];
          b6.__builtin__ && b6 !== this._hoverlayer && (b6.__dirty || s) && f6.push(b6);
        }
        for (var x6 = true, S = false, M = function(R) {
          var F = f6[R], j = F.ctx, $ = d6 && F.createRepaintRects(r6, t2, A6._width, A6._height), K = s ? F.__startIndex : F.__drawIndex, U = !s && F.incremental && Date.now, he = U && Date.now(), ue = F.zlevel === A6._zlevelList[0] ? A6._backgroundColor : null;
          if (F.__startIndex === F.__endIndex)
            F.clear(false, ue, $);
          else if (K === F.__startIndex) {
            var pe = r6[K];
            (!pe.incremental || !pe.notClear || s) && F.clear(false, ue, $);
          }
          K === -1 && (console.error("For some unknown reason. drawIndex is -1"), K = F.__startIndex);
          var _e, xe = function(Fe) {
            var at = { inHover: false, allClipped: false, prevEl: null, viewWidth: u._width, viewHeight: u._height };
            for (_e = K; _e < F.__endIndex; _e++) {
              var ht = r6[_e];
              if (ht.__inHover && (S = true), u._doPaintEl(ht, F, d6, Fe, at, _e === F.__endIndex - 1), U) {
                var Qe = Date.now() - he;
                if (Qe > 15)
                  break;
              }
            }
            at.prevElClipPaths && j.restore();
          };
          if ($)
            if ($.length === 0)
              _e = F.__endIndex;
            else
              for (var Ae = A6.dpr, ke = 0; ke < $.length; ++ke) {
                var je = $[ke];
                j.save(), j.beginPath(), j.rect(je.x * Ae, je.y * Ae, je.width * Ae, je.height * Ae), j.clip(), xe(je), j.restore();
              }
          else
            j.save(), xe(), j.restore();
          F.__drawIndex = _e, F.__drawIndex < F.__endIndex && (x6 = false);
        }, A6 = this, I = 0; I < f6.length; I++)
          M(I);
        return ha.wxa && Ne(this._layers, function(R) {
          R && R.ctx && R.ctx.draw && R.ctx.draw();
        }), { finished: x6, needsRefreshHover: S };
      }, a.prototype._doPaintEl = function(r6, t2, s, u, f6, d6) {
        var v6 = t2.ctx;
        if (s) {
          var m6 = r6.getPaintRect();
          (!u || m6 && m6.intersect(u)) && (pA(v6, r6, f6, d6), r6.setPrevPaintRect(m6));
        } else
          pA(v6, r6, f6, d6);
      }, a.prototype.getLayer = function(r6, t2) {
        this._singleCanvas && !this._needsManuallyCompositing && (r6 = wA);
        var s = this._layers[r6];
        return s || (s = new aX("zr_" + r6, this, this.dpr), s.zlevel = r6, s.__builtin__ = true, this._layerConfig[r6] ? Di(s, this._layerConfig[r6], true) : this._layerConfig[r6 - KV] && Di(s, this._layerConfig[r6 - KV], true), t2 && (s.virtual = t2), this.insertLayer(r6, s), s.initContext()), s;
      }, a.prototype.insertLayer = function(r6, t2) {
        var s = this._layers, u = this._zlevelList, f6 = u.length, d6 = this._domRoot, v6 = null, m6 = -1;
        if (!s[r6] && !!FNe(t2)) {
          if (f6 > 0 && r6 > u[0]) {
            for (m6 = 0; m6 < f6 - 1 && !(u[m6] < r6 && u[m6 + 1] > r6); m6++)
              ;
            v6 = s[u[m6]];
          }
          if (u.splice(m6 + 1, 0, r6), s[r6] = t2, !t2.virtual)
            if (v6) {
              var b6 = v6.dom;
              b6.nextSibling ? d6.insertBefore(t2.dom, b6.nextSibling) : d6.appendChild(t2.dom);
            } else
              d6.firstChild ? d6.insertBefore(t2.dom, d6.firstChild) : d6.appendChild(t2.dom);
          t2.__painter = this;
        }
      }, a.prototype.eachLayer = function(r6, t2) {
        for (var s = this._zlevelList, u = 0; u < s.length; u++) {
          var f6 = s[u];
          r6.call(t2, this._layers[f6], f6);
        }
      }, a.prototype.eachBuiltinLayer = function(r6, t2) {
        for (var s = this._zlevelList, u = 0; u < s.length; u++) {
          var f6 = s[u], d6 = this._layers[f6];
          d6.__builtin__ && r6.call(t2, d6, f6);
        }
      }, a.prototype.eachOtherLayer = function(r6, t2) {
        for (var s = this._zlevelList, u = 0; u < s.length; u++) {
          var f6 = s[u], d6 = this._layers[f6];
          d6.__builtin__ || r6.call(t2, d6, f6);
        }
      }, a.prototype.getLayers = function() {
        return this._layers;
      }, a.prototype._updateLayerStatus = function(r6) {
        this.eachBuiltinLayer(function(S, M) {
          S.__dirty = S.__used = false;
        });
        function t2(S) {
          f6 && (f6.__endIndex !== S && (f6.__dirty = true), f6.__endIndex = S);
        }
        if (this._singleCanvas)
          for (var s = 1; s < r6.length; s++) {
            var u = r6[s];
            if (u.zlevel !== r6[s - 1].zlevel || u.incremental) {
              this._needsManuallyCompositing = true;
              break;
            }
          }
        var f6 = null, d6 = 0, v6, m6;
        for (m6 = 0; m6 < r6.length; m6++) {
          var u = r6[m6], b6 = u.zlevel, x6 = void 0;
          v6 !== b6 && (v6 = b6, d6 = 0), u.incremental ? (x6 = this.getLayer(b6 + RNe, this._needsManuallyCompositing), x6.incremental = true, d6 = 1) : x6 = this.getLayer(b6 + (d6 > 0 ? KV : 0), this._needsManuallyCompositing), x6.__builtin__ || cb("ZLevel " + b6 + " has been used by unkown layer " + x6.id), x6 !== f6 && (x6.__used = true, x6.__startIndex !== m6 && (x6.__dirty = true), x6.__startIndex = m6, x6.incremental ? x6.__drawIndex = -1 : x6.__drawIndex = m6, t2(m6), f6 = x6), u.__dirty & ad && !u.__inHover && (x6.__dirty = true, x6.incremental && x6.__drawIndex < 0 && (x6.__drawIndex = m6));
        }
        t2(m6), this.eachBuiltinLayer(function(S, M) {
          !S.__used && S.getElementCount() > 0 && (S.__dirty = true, S.__startIndex = S.__endIndex = S.__drawIndex = 0), S.__dirty && S.__drawIndex < 0 && (S.__drawIndex = S.__startIndex);
        });
      }, a.prototype.clear = function() {
        return this.eachBuiltinLayer(this._clearLayer), this;
      }, a.prototype._clearLayer = function(r6) {
        r6.clear();
      }, a.prototype.setBackgroundColor = function(r6) {
        this._backgroundColor = r6, Ne(this._layers, function(t2) {
          t2.setUnpainted();
        });
      }, a.prototype.configLayer = function(r6, t2) {
        if (t2) {
          var s = this._layerConfig;
          s[r6] ? Di(s[r6], t2, true) : s[r6] = t2;
          for (var u = 0; u < this._zlevelList.length; u++) {
            var f6 = this._zlevelList[u];
            if (f6 === r6 || f6 === r6 + KV) {
              var d6 = this._layers[f6];
              Di(d6, s[r6], true);
            }
          }
        }
      }, a.prototype.delLayer = function(r6) {
        var t2 = this._layers, s = this._zlevelList, u = t2[r6];
        !u || (u.dom.parentNode.removeChild(u.dom), delete t2[r6], s.splice(Vi(s, r6), 1));
      }, a.prototype.resize = function(r6, t2) {
        if (this._domRoot.style) {
          var s = this._domRoot;
          s.style.display = "none";
          var u = this._opts, f6 = this.root;
          if (r6 != null && (u.width = r6), t2 != null && (u.height = t2), r6 = u5(f6, 0, u), t2 = u5(f6, 1, u), s.style.display = "", this._width !== r6 || t2 !== this._height) {
            s.style.width = r6 + "px", s.style.height = t2 + "px";
            for (var d6 in this._layers)
              this._layers.hasOwnProperty(d6) && this._layers[d6].resize(r6, t2);
            this.refresh(true);
          }
          this._width = r6, this._height = t2;
        } else {
          if (r6 == null || t2 == null)
            return;
          this._width = r6, this._height = t2, this.getLayer(wA).resize(r6, t2);
        }
        return this;
      }, a.prototype.clearLayer = function(r6) {
        var t2 = this._layers[r6];
        t2 && t2.clear();
      }, a.prototype.dispose = function() {
        this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
      }, a.prototype.getRenderedCanvas = function(r6) {
        if (r6 = r6 || {}, this._singleCanvas && !this._compositeManually)
          return this._layers[wA].dom;
        var t2 = new aX("image", this, r6.pixelRatio || this.dpr);
        t2.initContext(), t2.clear(false, r6.backgroundColor || this._backgroundColor);
        var s = t2.ctx;
        if (r6.pixelRatio <= this.dpr) {
          this.refresh();
          var u = t2.dom.width, f6 = t2.dom.height;
          this.eachLayer(function(S) {
            S.__builtin__ ? s.drawImage(S.dom, 0, 0, u, f6) : S.renderToCanvas && (s.save(), S.renderToCanvas(s), s.restore());
          });
        } else
          for (var d6 = { inHover: false, viewWidth: this._width, viewHeight: this._height }, v6 = this.storage.getDisplayList(true), m6 = 0, b6 = v6.length; m6 < b6; m6++) {
            var x6 = v6[m6];
            pA(s, x6, d6, m6 === b6 - 1);
          }
        return t2.dom;
      }, a.prototype.getWidth = function() {
        return this._width;
      }, a.prototype.getHeight = function() {
        return this._height;
      }, a;
    }(), zNe = VNe;
    function BNe(a) {
      a.registerPainter("canvas", zNe);
    }
    var jNe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.hasSymbolVisual = true, t2;
      }
      return r6.prototype.getInitialData = function(t2) {
        return Wx(null, this, { useEncodeDefaulter: true });
      }, r6.prototype.getLegendIcon = function(t2) {
        var s = new bi(), u = Lf("line", 0, t2.itemHeight / 2, t2.itemWidth, 0, t2.lineStyle.stroke, false);
        s.add(u), u.setStyle(t2.lineStyle);
        var f6 = this.getData().getVisual("symbol"), d6 = this.getData().getVisual("symbolRotate"), v6 = f6 === "none" ? "circle" : f6, m6 = t2.itemHeight * 0.8, b6 = Lf(v6, (t2.itemWidth - m6) / 2, (t2.itemHeight - m6) / 2, m6, m6, t2.itemStyle.fill);
        s.add(b6), b6.setStyle(t2.itemStyle);
        var x6 = t2.iconRotate === "inherit" ? d6 : t2.iconRotate || 0;
        return b6.rotation = x6 * Math.PI / 180, b6.setOrigin([t2.itemWidth / 2, t2.itemHeight / 2]), v6.indexOf("empty") > -1 && (b6.style.stroke = b6.style.fill, b6.style.fill = "#fff", b6.style.lineWidth = 2), s;
      }, r6.type = "series.line", r6.dependencies = ["grid", "polar"], r6.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, r6;
    }(sc), GNe = jNe;
    function p5(a, r6) {
      var t2 = a.mapDimensionsAll("defaultedLabel"), s = t2.length;
      if (s === 1) {
        var u = n5(a, r6, t2[0]);
        return u != null ? u + "" : null;
      } else if (s) {
        for (var f6 = [], d6 = 0; d6 < t2.length; d6++)
          f6.push(n5(a, r6, t2[d6]));
        return f6.join(" ");
      }
    }
    function fpe(a, r6) {
      var t2 = a.mapDimensionsAll("defaultedLabel");
      if (!br(r6))
        return r6 + "";
      for (var s = [], u = 0; u < t2.length; u++) {
        var f6 = a.getDimensionIndex(t2[u]);
        f6 >= 0 && s.push(r6[f6]);
      }
      return s.join(" ");
    }
    var WNe = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6) {
        var d6 = a.call(this) || this;
        return d6.updateData(t2, s, u, f6), d6;
      }
      return r6.prototype._createSymbol = function(t2, s, u, f6, d6) {
        this.removeAll();
        var v6 = Lf(t2, -1, -1, 2, 2, null, d6);
        v6.attr({ z2: 100, culling: true, scaleX: f6[0] / 2, scaleY: f6[1] / 2 }), v6.drift = HNe, this._symbolType = t2, this.add(v6);
      }, r6.prototype.stopSymbolAnimation = function(t2) {
        this.childAt(0).stopAnimation(null, t2);
      }, r6.prototype.getSymbolType = function() {
        return this._symbolType;
      }, r6.prototype.getSymbolPath = function() {
        return this.childAt(0);
      }, r6.prototype.highlight = function() {
        Cm(this.childAt(0));
      }, r6.prototype.downplay = function() {
        Mm(this.childAt(0));
      }, r6.prototype.setZ = function(t2, s) {
        var u = this.childAt(0);
        u.zlevel = t2, u.z = s;
      }, r6.prototype.setDraggable = function(t2) {
        var s = this.childAt(0);
        s.draggable = t2, s.cursor = t2 ? "move" : s.cursor;
      }, r6.prototype.updateData = function(t2, s, u, f6) {
        this.silent = false;
        var d6 = t2.getItemVisual(s, "symbol") || "circle", v6 = t2.hostModel, m6 = r6.getSymbolSize(t2, s), b6 = d6 !== this._symbolType, x6 = f6 && f6.disableAnimation;
        if (b6) {
          var S = t2.getItemVisual(s, "symbolKeepAspect");
          this._createSymbol(d6, t2, s, m6, S);
        } else {
          var M = this.childAt(0);
          M.silent = false;
          var A6 = { scaleX: m6[0] / 2, scaleY: m6[1] / 2 };
          x6 ? M.attr(A6) : fs(M, A6, v6, s), f0(M);
        }
        if (this._updateCommon(t2, s, m6, u, f6), b6) {
          var M = this.childAt(0);
          if (!x6) {
            var A6 = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: M.style.opacity } };
            M.scaleX = M.scaleY = 0, M.style.opacity = 0, zu(M, A6, v6, s);
          }
        }
        x6 && this.childAt(0).stopAnimation("leave");
      }, r6.prototype._updateCommon = function(t2, s, u, f6, d6) {
        var v6 = this.childAt(0), m6 = t2.hostModel, b6, x6, S, M, A6, I, R, F, j;
        if (f6 && (b6 = f6.emphasisItemStyle, x6 = f6.blurItemStyle, S = f6.selectItemStyle, M = f6.focus, A6 = f6.blurScope, R = f6.labelStatesModels, F = f6.hoverScale, j = f6.cursorStyle, I = f6.emphasisDisabled), !f6 || t2.hasItemOption) {
          var $ = f6 && f6.itemModel ? f6.itemModel : t2.getItemModel(s), K = $.getModel("emphasis");
          b6 = K.getModel("itemStyle").getItemStyle(), S = $.getModel(["select", "itemStyle"]).getItemStyle(), x6 = $.getModel(["blur", "itemStyle"]).getItemStyle(), M = K.get("focus"), A6 = K.get("blurScope"), I = K.get("disabled"), R = hd($), F = K.getShallow("scale"), j = $.getShallow("cursor");
        }
        var U = t2.getItemVisual(s, "symbolRotate");
        v6.attr("rotation", (U || 0) * Math.PI / 180 || 0);
        var he = l5(t2.getItemVisual(s, "symbolOffset"), u);
        he && (v6.x = he[0], v6.y = he[1]), j && v6.attr("cursor", j);
        var ue = t2.getItemVisual(s, "style"), pe = ue.fill;
        if (v6 instanceof nh) {
          var _e = v6.style;
          v6.useStyle(qn({ image: _e.image, x: _e.x, y: _e.y, width: _e.width, height: _e.height }, ue));
        } else
          v6.__isEmptyBrush ? v6.useStyle(qn({}, ue)) : v6.useStyle(ue), v6.style.decal = null, v6.setColor(pe, d6 && d6.symbolInnerColor), v6.style.strokeNoScale = true;
        var xe = t2.getItemVisual(s, "liftZ"), Ae = this._z2;
        xe != null ? Ae == null && (this._z2 = v6.z2, v6.z2 += xe) : Ae != null && (v6.z2 = Ae, this._z2 = null);
        var ke = d6 && d6.useNameLabel;
        Bp(v6, R, { labelFetcher: m6, labelDataIndex: s, defaultText: je, inheritColor: pe, defaultOpacity: ue.opacity });
        function je(ht) {
          return ke ? t2.getName(ht) : p5(t2, ht);
        }
        this._sizeX = u[0] / 2, this._sizeY = u[1] / 2;
        var Fe = v6.ensureState("emphasis");
        if (Fe.style = b6, v6.ensureState("select").style = S, v6.ensureState("blur").style = x6, F) {
          var at = Math.max(1.1, 3 / this._sizeY);
          Fe.scaleX = this._sizeX * at, Fe.scaleY = this._sizeY * at;
        }
        this.setSymbolScale(1), Cc(this, M, A6, I);
      }, r6.prototype.setSymbolScale = function(t2) {
        this.scaleX = this.scaleY = t2;
      }, r6.prototype.fadeOut = function(t2, s, u) {
        var f6 = this.childAt(0), d6 = ii(this).dataIndex, v6 = u && u.animation;
        if (this.silent = f6.silent = true, u && u.fadeLabel) {
          var m6 = f6.getTextContent();
          m6 && Ob(m6, { style: { opacity: 0 } }, s, { dataIndex: d6, removeOpt: v6, cb: function() {
            f6.removeTextContent();
          } });
        } else
          f6.removeTextContent();
        Ob(f6, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, s, { dataIndex: d6, cb: t2, removeOpt: v6 });
      }, r6.getSymbolSize = function(t2, s) {
        return IR(t2.getItemVisual(s, "symbolSize"));
      }, r6;
    }(bi);
    function HNe(a, r6) {
      this.parent.drift(a, r6);
    }
    var ZR = WNe;
    function iX(a, r6, t2, s) {
      return r6 && !isNaN(r6[0]) && !isNaN(r6[1]) && !(s.isIgnore && s.isIgnore(t2)) && !(s.clipShape && !s.clipShape.contain(r6[0], r6[1])) && a.getItemVisual(t2, "symbol") !== "none";
    }
    function hpe(a) {
      return a != null && !ui(a) && (a = { isIgnore: a }), a || {};
    }
    function dpe(a) {
      var r6 = a.hostModel, t2 = r6.getModel("emphasis");
      return { emphasisItemStyle: t2.getModel("itemStyle").getItemStyle(), blurItemStyle: r6.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: r6.getModel(["select", "itemStyle"]).getItemStyle(), focus: t2.get("focus"), blurScope: t2.get("blurScope"), emphasisDisabled: t2.get("disabled"), hoverScale: t2.get("scale"), labelStatesModels: hd(r6), cursorStyle: r6.get("cursor") };
    }
    var $Ne = function() {
      function a(r6) {
        this.group = new bi(), this._SymbolCtor = r6 || ZR;
      }
      return a.prototype.updateData = function(r6, t2) {
        this._progressiveEls = null, t2 = hpe(t2);
        var s = this.group, u = r6.hostModel, f6 = this._data, d6 = this._SymbolCtor, v6 = t2.disableAnimation, m6 = dpe(r6), b6 = { disableAnimation: v6 }, x6 = t2.getSymbolPoint || function(S) {
          return r6.getItemLayout(S);
        };
        f6 || s.removeAll(), r6.diff(f6).add(function(S) {
          var M = x6(S);
          if (iX(r6, M, S, t2)) {
            var A6 = new d6(r6, S, m6, b6);
            A6.setPosition(M), r6.setItemGraphicEl(S, A6), s.add(A6);
          }
        }).update(function(S, M) {
          var A6 = f6.getItemGraphicEl(M), I = x6(S);
          if (!iX(r6, I, S, t2)) {
            s.remove(A6);
            return;
          }
          var R = r6.getItemVisual(S, "symbol") || "circle", F = A6 && A6.getSymbolType && A6.getSymbolType();
          if (!A6 || F && F !== R)
            s.remove(A6), A6 = new d6(r6, S, m6, b6), A6.setPosition(I);
          else {
            A6.updateData(r6, S, m6, b6);
            var j = { x: I[0], y: I[1] };
            v6 ? A6.attr(j) : fs(A6, j, u);
          }
          s.add(A6), r6.setItemGraphicEl(S, A6);
        }).remove(function(S) {
          var M = f6.getItemGraphicEl(S);
          M && M.fadeOut(function() {
            s.remove(M);
          }, u);
        }).execute(), this._getSymbolPoint = x6, this._data = r6;
      }, a.prototype.updateLayout = function() {
        var r6 = this, t2 = this._data;
        t2 && t2.eachItemGraphicEl(function(s, u) {
          var f6 = r6._getSymbolPoint(u);
          s.setPosition(f6), s.markRedraw();
        });
      }, a.prototype.incrementalPrepareUpdate = function(r6) {
        this._seriesScope = dpe(r6), this._data = null, this.group.removeAll();
      }, a.prototype.incrementalUpdate = function(r6, t2, s) {
        this._progressiveEls = [], s = hpe(s);
        function u(m6) {
          m6.isGroup || (m6.incremental = true, m6.ensureState("emphasis").hoverLayer = true);
        }
        for (var f6 = r6.start; f6 < r6.end; f6++) {
          var d6 = t2.getItemLayout(f6);
          if (iX(t2, d6, f6, s)) {
            var v6 = new this._SymbolCtor(t2, f6, this._seriesScope);
            v6.traverse(u), v6.setPosition(d6), this.group.add(v6), t2.setItemGraphicEl(f6, v6), this._progressiveEls.push(v6);
          }
        }
      }, a.prototype.eachRendered = function(r6) {
        s1(this._progressiveEls || this.group, r6);
      }, a.prototype.remove = function(r6) {
        var t2 = this.group, s = this._data;
        s && r6 ? s.eachItemGraphicEl(function(u) {
          u.fadeOut(function() {
            t2.remove(u);
          }, s.hostModel);
        }) : t2.removeAll();
      }, a;
    }(), XR = $Ne;
    function ppe(a, r6, t2) {
      var s = a.getBaseAxis(), u = a.getOtherAxis(s), f6 = UNe(u, t2), d6 = s.dim, v6 = u.dim, m6 = r6.mapDimension(v6), b6 = r6.mapDimension(d6), x6 = v6 === "x" || v6 === "radius" ? 1 : 0, S = wr(a.dimensions, function(I) {
        return r6.mapDimension(I);
      }), M = false, A6 = r6.getCalculationInfo("stackResultDimension");
      return tS(r6, S[0]) && (M = true, S[0] = A6), tS(r6, S[1]) && (M = true, S[1] = A6), { dataDimsForPoint: S, valueStart: f6, valueAxisDim: v6, baseAxisDim: d6, stacked: !!M, valueDim: m6, baseDim: b6, baseDataOffset: x6, stackedOverDimension: r6.getCalculationInfo("stackedOverDimension") };
    }
    function UNe(a, r6) {
      var t2 = 0, s = a.scale.getExtent();
      return r6 === "start" ? t2 = s[0] : r6 === "end" ? t2 = s[1] : s[0] > 0 ? t2 = s[0] : s[1] < 0 && (t2 = s[1]), t2;
    }
    function vpe(a, r6, t2, s) {
      var u = NaN;
      a.stacked && (u = t2.get(t2.getCalculationInfo("stackedOverDimension"), s)), isNaN(u) && (u = a.valueStart);
      var f6 = a.baseDataOffset, d6 = [];
      return d6[f6] = t2.get(a.baseDim, s), d6[1 - f6] = u, r6.dataToPoint(d6);
    }
    function qNe(a, r6) {
      var t2 = [];
      return r6.diff(a).add(function(s) {
        t2.push({ cmd: "+", idx: s });
      }).update(function(s, u) {
        t2.push({ cmd: "=", idx: u, idx1: s });
      }).remove(function(s) {
        t2.push({ cmd: "-", idx: s });
      }).execute(), t2;
    }
    function YNe(a, r6, t2, s, u, f6, d6, v6) {
      for (var m6 = qNe(a, r6), b6 = [], x6 = [], S = [], M = [], A6 = [], I = [], R = [], F = ppe(u, r6, d6), j = a.getLayout("points") || [], $ = r6.getLayout("points") || [], K = 0; K < m6.length; K++) {
        var U = m6[K], he = true, ue = void 0, pe = void 0;
        switch (U.cmd) {
          case "=":
            ue = U.idx * 2, pe = U.idx1 * 2;
            var _e = j[ue], xe = j[ue + 1], Ae = $[pe], ke = $[pe + 1];
            (isNaN(_e) || isNaN(xe)) && (_e = Ae, xe = ke), b6.push(_e, xe), x6.push(Ae, ke), S.push(t2[ue], t2[ue + 1]), M.push(s[pe], s[pe + 1]), R.push(r6.getRawIndex(U.idx1));
            break;
          case "+":
            var je = U.idx, Fe = F.dataDimsForPoint, at = u.dataToPoint([r6.get(Fe[0], je), r6.get(Fe[1], je)]);
            pe = je * 2, b6.push(at[0], at[1]), x6.push($[pe], $[pe + 1]);
            var ht = vpe(F, u, r6, je);
            S.push(ht[0], ht[1]), M.push(s[pe], s[pe + 1]), R.push(r6.getRawIndex(je));
            break;
          case "-":
            he = false;
        }
        he && (A6.push(U), I.push(I.length));
      }
      I.sort(function(Ua, ja) {
        return R[Ua] - R[ja];
      });
      for (var Qe = b6.length, en = Vb(Qe), bt = Vb(Qe), wt = Vb(Qe), Ft = Vb(Qe), fn = [], K = 0; K < I.length; K++) {
        var gn = I[K], Zr = K * 2, Ma = gn * 2;
        en[Zr] = b6[Ma], en[Zr + 1] = b6[Ma + 1], bt[Zr] = x6[Ma], bt[Zr + 1] = x6[Ma + 1], wt[Zr] = S[Ma], wt[Zr + 1] = S[Ma + 1], Ft[Zr] = M[Ma], Ft[Zr + 1] = M[Ma + 1], fn[K] = A6[gn];
      }
      return { current: en, next: bt, stackedOnCurrent: wt, stackedOnNext: Ft, status: fn };
    }
    var rS = Math.min, aS = Math.max;
    function SA(a, r6) {
      return isNaN(a) || isNaN(r6);
    }
    function oX(a, r6, t2, s, u, f6, d6, v6, m6) {
      for (var b6, x6, S, M, A6, I, R = t2, F = 0; F < s; F++) {
        var j = r6[R * 2], $ = r6[R * 2 + 1];
        if (R >= u || R < 0)
          break;
        if (SA(j, $)) {
          if (m6) {
            R += f6;
            continue;
          }
          break;
        }
        if (R === t2)
          a[f6 > 0 ? "moveTo" : "lineTo"](j, $), S = j, M = $;
        else {
          var K = j - b6, U = $ - x6;
          if (K * K + U * U < 0.5) {
            R += f6;
            continue;
          }
          if (d6 > 0) {
            for (var he = R + f6, ue = r6[he * 2], pe = r6[he * 2 + 1]; ue === j && pe === $ && F < s; )
              F++, he += f6, R += f6, ue = r6[he * 2], pe = r6[he * 2 + 1], j = r6[R * 2], $ = r6[R * 2 + 1], K = j - b6, U = $ - x6;
            var _e = F + 1;
            if (m6)
              for (; SA(ue, pe) && _e < s; )
                _e++, he += f6, ue = r6[he * 2], pe = r6[he * 2 + 1];
            var xe = 0.5, Ae = 0, ke = 0, je = void 0, Fe = void 0;
            if (_e >= s || SA(ue, pe))
              A6 = j, I = $;
            else {
              Ae = ue - b6, ke = pe - x6;
              var at = j - b6, ht = ue - j, Qe = $ - x6, en = pe - $, bt = void 0, wt = void 0;
              if (v6 === "x") {
                bt = Math.abs(at), wt = Math.abs(ht);
                var Ft = Ae > 0 ? 1 : -1;
                A6 = j - Ft * bt * d6, I = $, je = j + Ft * wt * d6, Fe = $;
              } else if (v6 === "y") {
                bt = Math.abs(Qe), wt = Math.abs(en);
                var fn = ke > 0 ? 1 : -1;
                A6 = j, I = $ - fn * bt * d6, je = j, Fe = $ + fn * wt * d6;
              } else
                bt = Math.sqrt(at * at + Qe * Qe), wt = Math.sqrt(ht * ht + en * en), xe = wt / (wt + bt), A6 = j - Ae * d6 * (1 - xe), I = $ - ke * d6 * (1 - xe), je = j + Ae * d6 * xe, Fe = $ + ke * d6 * xe, je = rS(je, aS(ue, j)), Fe = rS(Fe, aS(pe, $)), je = aS(je, rS(ue, j)), Fe = aS(Fe, rS(pe, $)), Ae = je - j, ke = Fe - $, A6 = j - Ae * bt / wt, I = $ - ke * bt / wt, A6 = rS(A6, aS(b6, j)), I = rS(I, aS(x6, $)), A6 = aS(A6, rS(b6, j)), I = aS(I, rS(x6, $)), Ae = j - A6, ke = $ - I, je = j + Ae * wt / bt, Fe = $ + ke * wt / bt;
            }
            a.bezierCurveTo(S, M, A6, I, j, $), S = je, M = Fe;
          } else
            a.lineTo(j, $);
        }
        b6 = j, x6 = $, R += f6;
      }
      return F;
    }
    var gpe = function() {
      function a() {
        this.smooth = 0, this.smoothConstraint = true;
      }
      return a;
    }(), ZNe = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "ec-polyline", s;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new gpe();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.points, f6 = 0, d6 = u.length / 2;
        if (s.connectNulls) {
          for (; d6 > 0 && SA(u[d6 * 2 - 2], u[d6 * 2 - 1]); d6--)
            ;
          for (; f6 < d6 && SA(u[f6 * 2], u[f6 * 2 + 1]); f6++)
            ;
        }
        for (; f6 < d6; )
          f6 += oX(t2, u, f6, d6, d6, 1, s.smooth, s.smoothMonotone, s.connectNulls) + 1;
      }, r6.prototype.getPointOn = function(t2, s) {
        this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
        for (var u = this.path, f6 = u.data, d6 = wm.CMD, v6, m6, b6 = s === "x", x6 = [], S = 0; S < f6.length; ) {
          var M = f6[S++], A6 = void 0, I = void 0, R = void 0, F = void 0, j = void 0, $ = void 0, K = void 0;
          switch (M) {
            case d6.M:
              v6 = f6[S++], m6 = f6[S++];
              break;
            case d6.L:
              if (A6 = f6[S++], I = f6[S++], K = b6 ? (t2 - v6) / (A6 - v6) : (t2 - m6) / (I - m6), K <= 1 && K >= 0) {
                var U = b6 ? (I - m6) * K + m6 : (A6 - v6) * K + v6;
                return b6 ? [t2, U] : [U, t2];
              }
              v6 = A6, m6 = I;
              break;
            case d6.C:
              A6 = f6[S++], I = f6[S++], R = f6[S++], F = f6[S++], j = f6[S++], $ = f6[S++];
              var he = b6 ? VT(v6, A6, R, j, t2, x6) : VT(m6, I, F, $, t2, x6);
              if (he > 0)
                for (var ue = 0; ue < he; ue++) {
                  var pe = x6[ue];
                  if (pe <= 1 && pe >= 0) {
                    var U = b6 ? Pc(m6, I, F, $, pe) : Pc(v6, A6, R, j, pe);
                    return b6 ? [t2, U] : [U, t2];
                  }
                }
              v6 = j, m6 = $;
              break;
          }
        }
      }, r6;
    }(uo), XNe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6;
    }(gpe), mpe = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "ec-polygon", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new XNe();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.points, f6 = s.stackedOnPoints, d6 = 0, v6 = u.length / 2, m6 = s.smoothMonotone;
        if (s.connectNulls) {
          for (; v6 > 0 && SA(u[v6 * 2 - 2], u[v6 * 2 - 1]); v6--)
            ;
          for (; d6 < v6 && SA(u[d6 * 2], u[d6 * 2 + 1]); d6++)
            ;
        }
        for (; d6 < v6; ) {
          var b6 = oX(t2, u, d6, v6, v6, 1, s.smooth, m6, s.connectNulls);
          oX(t2, f6, d6 + b6 - 1, b6, v6, -1, s.stackedOnSmooth, m6, s.connectNulls), d6 += b6 + 1, t2.closePath();
        }
      }, r6;
    }(uo);
    function ype(a, r6, t2, s, u) {
      var f6 = a.getArea(), d6 = f6.x, v6 = f6.y, m6 = f6.width, b6 = f6.height, x6 = t2.get(["lineStyle", "width"]) || 2;
      d6 -= x6 / 2, v6 -= x6 / 2, m6 += x6, b6 += x6, d6 = Math.floor(d6), m6 = Math.round(m6);
      var S = new rs({ shape: { x: d6, y: v6, width: m6, height: b6 } });
      if (r6) {
        var M = a.getBaseAxis(), A6 = M.isHorizontal(), I = M.inverse;
        A6 ? (I && (S.shape.x += m6), S.shape.width = 0) : (I || (S.shape.y += b6), S.shape.height = 0);
        var R = ti(u) ? function(F) {
          u(F, S);
        } : null;
        zu(S, { shape: { width: m6, height: b6, x: d6, y: v6 } }, t2, null, s, R);
      }
      return S;
    }
    function bpe(a, r6, t2) {
      var s = a.getArea(), u = Sc(s.r0, 1), f6 = Sc(s.r, 1), d6 = new Np({ shape: { cx: Sc(a.cx, 1), cy: Sc(a.cy, 1), r0: u, r: f6, startAngle: s.startAngle, endAngle: s.endAngle, clockwise: s.clockwise } });
      if (r6) {
        var v6 = a.getBaseAxis().dim === "angle";
        v6 ? d6.shape.endAngle = s.startAngle : d6.shape.r = u, zu(d6, { shape: { endAngle: s.endAngle, r: f6 } }, t2);
      }
      return d6;
    }
    function JV(a, r6, t2, s, u) {
      if (a) {
        if (a.type === "polar")
          return bpe(a, r6, t2);
        if (a.type === "cartesian2d")
          return ype(a, r6, t2, s, u);
      } else
        return null;
      return null;
    }
    function $x(a, r6) {
      return a.type === r6;
    }
    function _pe(a, r6) {
      if (a.length === r6.length) {
        for (var t2 = 0; t2 < a.length; t2++)
          if (a[t2] !== r6[t2])
            return;
        return true;
      }
    }
    function xpe(a) {
      for (var r6 = 1 / 0, t2 = 1 / 0, s = -1 / 0, u = -1 / 0, f6 = 0; f6 < a.length; ) {
        var d6 = a[f6++], v6 = a[f6++];
        isNaN(d6) || (r6 = Math.min(d6, r6), s = Math.max(d6, s)), isNaN(v6) || (t2 = Math.min(v6, t2), u = Math.max(v6, u));
      }
      return [[r6, t2], [s, u]];
    }
    function wpe(a, r6) {
      var t2 = xpe(a), s = t2[0], u = t2[1], f6 = xpe(r6), d6 = f6[0], v6 = f6[1];
      return Math.max(Math.abs(s[0] - d6[0]), Math.abs(s[1] - d6[1]), Math.abs(u[0] - v6[0]), Math.abs(u[1] - v6[1]));
    }
    function Spe(a) {
      return ks(a) ? a : a ? 0.5 : 0;
    }
    function KNe(a, r6, t2) {
      if (!t2.valueDim)
        return [];
      for (var s = r6.count(), u = Vb(s * 2), f6 = 0; f6 < s; f6++) {
        var d6 = vpe(t2, a, r6, f6);
        u[f6 * 2] = d6[0], u[f6 * 2 + 1] = d6[1];
      }
      return u;
    }
    function iS(a, r6, t2, s) {
      var u = r6.getBaseAxis(), f6 = u.dim === "x" || u.dim === "radius" ? 0 : 1, d6 = [], v6 = 0, m6 = [], b6 = [], x6 = [], S = [];
      if (s) {
        for (v6 = 0; v6 < a.length; v6 += 2)
          !isNaN(a[v6]) && !isNaN(a[v6 + 1]) && S.push(a[v6], a[v6 + 1]);
        a = S;
      }
      for (v6 = 0; v6 < a.length - 2; v6 += 2)
        switch (x6[0] = a[v6 + 2], x6[1] = a[v6 + 3], b6[0] = a[v6], b6[1] = a[v6 + 1], d6.push(b6[0], b6[1]), t2) {
          case "end":
            m6[f6] = x6[f6], m6[1 - f6] = b6[1 - f6], d6.push(m6[0], m6[1]);
            break;
          case "middle":
            var M = (b6[f6] + x6[f6]) / 2, A6 = [];
            m6[f6] = A6[f6] = M, m6[1 - f6] = b6[1 - f6], A6[1 - f6] = x6[1 - f6], d6.push(m6[0], m6[1]), d6.push(A6[0], A6[1]);
            break;
          default:
            m6[f6] = b6[f6], m6[1 - f6] = x6[1 - f6], d6.push(m6[0], m6[1]);
        }
      return d6.push(a[v6++], a[v6++]), d6;
    }
    function JNe(a, r6) {
      var t2 = [], s = a.length, u, f6;
      function d6(x6, S, M) {
        var A6 = x6.coord, I = (M - A6) / (S.coord - A6), R = LU(I, [x6.color, S.color]);
        return { coord: M, color: R };
      }
      for (var v6 = 0; v6 < s; v6++) {
        var m6 = a[v6], b6 = m6.coord;
        if (b6 < 0)
          u = m6;
        else if (b6 > r6) {
          f6 ? t2.push(d6(f6, m6, r6)) : u && t2.push(d6(u, m6, 0), d6(u, m6, r6));
          break;
        } else
          u && (t2.push(d6(u, m6, 0)), u = null), t2.push(m6), f6 = m6;
      }
      return t2;
    }
    function QNe(a, r6, t2) {
      var s = a.getVisual("visualMeta");
      if (!(!s || !s.length || !a.count()) && r6.type === "cartesian2d") {
        for (var u, f6, d6 = s.length - 1; d6 >= 0; d6--) {
          var v6 = a.getDimensionInfo(s[d6].dimension);
          if (u = v6 && v6.coordDim, u === "x" || u === "y") {
            f6 = s[d6];
            break;
          }
        }
        if (f6) {
          var m6 = r6.getAxis(u), b6 = wr(f6.stops, function(K) {
            return { coord: m6.toGlobalCoord(m6.dataToCoord(K.value)), color: K.color };
          }), x6 = b6.length, S = f6.outerColors.slice();
          x6 && b6[0].coord > b6[x6 - 1].coord && (b6.reverse(), S.reverse());
          var M = JNe(b6, u === "x" ? t2.getWidth() : t2.getHeight()), A6 = M.length;
          if (!A6 && x6)
            return b6[0].coord < 0 ? S[1] ? S[1] : b6[x6 - 1].color : S[0] ? S[0] : b6[0].color;
          var I = 10, R = M[0].coord - I, F = M[A6 - 1].coord + I, j = F - R;
          if (j < 1e-3)
            return "transparent";
          Ne(M, function(K) {
            K.offset = (K.coord - R) / j;
          }), M.push({ offset: A6 ? M[A6 - 1].offset : 0.5, color: S[1] || "transparent" }), M.unshift({ offset: A6 ? M[0].offset : 0.5, color: S[0] || "transparent" });
          var $ = new aA(0, 0, 0, 0, M, true);
          return $[u] = R, $[u + "2"] = F, $;
        }
      }
    }
    function e8e(a, r6, t2) {
      var s = a.get("showAllSymbol"), u = s === "auto";
      if (!(s && !u)) {
        var f6 = t2.getAxesByScale("ordinal")[0];
        if (!!f6 && !(u && t8e(f6, r6))) {
          var d6 = r6.mapDimension(f6.dim), v6 = {};
          return Ne(f6.getViewLabels(), function(m6) {
            var b6 = f6.scale.getRawOrdinalNumber(m6.tickValue);
            v6[b6] = 1;
          }), function(m6) {
            return !v6.hasOwnProperty(r6.get(d6, m6));
          };
        }
      }
    }
    function t8e(a, r6) {
      var t2 = a.getExtent(), s = Math.abs(t2[1] - t2[0]) / a.scale.count();
      isNaN(s) && (s = 0);
      for (var u = r6.count(), f6 = Math.max(1, Math.round(u / 5)), d6 = 0; d6 < u; d6 += f6)
        if (ZR.getSymbolSize(r6, d6)[a.isHorizontal() ? 1 : 0] * 1.5 > s)
          return false;
      return true;
    }
    function n8e(a, r6) {
      return isNaN(a) || isNaN(r6);
    }
    function r8e(a) {
      for (var r6 = a.length / 2; r6 > 0 && n8e(a[r6 * 2 - 2], a[r6 * 2 - 1]); r6--)
        ;
      return r6 - 1;
    }
    function Cpe(a, r6) {
      return [a[r6 * 2], a[r6 * 2 + 1]];
    }
    function a8e(a, r6, t2) {
      for (var s = a.length / 2, u = t2 === "x" ? 0 : 1, f6, d6, v6 = 0, m6 = -1, b6 = 0; b6 < s; b6++)
        if (d6 = a[b6 * 2 + u], !(isNaN(d6) || isNaN(a[b6 * 2 + 1 - u]))) {
          if (b6 === 0) {
            f6 = d6;
            continue;
          }
          if (f6 <= r6 && d6 >= r6 || f6 >= r6 && d6 <= r6) {
            m6 = b6;
            break;
          }
          v6 = b6, f6 = d6;
        }
      return { range: [v6, m6], t: (r6 - f6) / (d6 - f6) };
    }
    function Mpe(a) {
      if (a.get(["endLabel", "show"]))
        return true;
      for (var r6 = 0; r6 < Oc.length; r6++)
        if (a.get([Oc[r6], "endLabel", "show"]))
          return true;
      return false;
    }
    function sX(a, r6, t2, s) {
      if ($x(r6, "cartesian2d")) {
        var u = s.getModel("endLabel"), f6 = u.get("valueAnimation"), d6 = s.getData(), v6 = { lastFrameIndex: 0 }, m6 = Mpe(s) ? function(A6, I) {
          a._endLabelOnDuring(A6, I, d6, v6, f6, u, r6);
        } : null, b6 = r6.getBaseAxis().isHorizontal(), x6 = ype(r6, t2, s, function() {
          var A6 = a._endLabel;
          A6 && t2 && v6.originalX != null && A6.attr({ x: v6.originalX, y: v6.originalY });
        }, m6);
        if (!s.get("clip", true)) {
          var S = x6.shape, M = Math.max(S.width, S.height);
          b6 ? (S.y -= M, S.height += M * 2) : (S.x -= M, S.width += M * 2);
        }
        return m6 && m6(1, x6), x6;
      } else
        return bpe(r6, t2, s);
    }
    function i8e(a, r6) {
      var t2 = r6.getBaseAxis(), s = t2.isHorizontal(), u = t2.inverse, f6 = s ? u ? "right" : "left" : "center", d6 = s ? "middle" : u ? "top" : "bottom";
      return { normal: { align: a.get("align") || f6, verticalAlign: a.get("verticalAlign") || d6 } };
    }
    var o8e = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.init = function() {
        var t2 = new bi(), s = new XR();
        this.group.add(s.group), this._symbolDraw = s, this._lineGroup = t2;
      }, r6.prototype.render = function(t2, s, u) {
        var f6 = this, d6 = t2.coordinateSystem, v6 = this.group, m6 = t2.getData(), b6 = t2.getModel("lineStyle"), x6 = t2.getModel("areaStyle"), S = m6.getLayout("points") || [], M = d6.type === "polar", A6 = this._coordSys, I = this._symbolDraw, R = this._polyline, F = this._polygon, j = this._lineGroup, $ = t2.get("animation"), K = !x6.isEmpty(), U = x6.get("origin"), he = ppe(d6, m6, U), ue = K && KNe(d6, m6, he), pe = t2.get("showSymbol"), _e = t2.get("connectNulls"), xe = pe && !M && e8e(t2, m6, d6), Ae = this._data;
        Ae && Ae.eachItemGraphicEl(function(ja, Ga) {
          ja.__temp && (v6.remove(ja), Ae.setItemGraphicEl(Ga, null));
        }), pe || I.remove(), v6.add(j);
        var ke = M ? false : t2.get("step"), je;
        d6 && d6.getArea && t2.get("clip", true) && (je = d6.getArea(), je.width != null ? (je.x -= 0.1, je.y -= 0.1, je.width += 0.2, je.height += 0.2) : je.r0 && (je.r0 -= 0.5, je.r += 0.5)), this._clipShapeForSymbol = je;
        var Fe = QNe(m6, d6, u) || m6.getVisual("style")[m6.getVisual("drawType")];
        if (!(R && A6.type === d6.type && ke === this._step))
          pe && I.updateData(m6, { isIgnore: xe, clipShape: je, disableAnimation: true, getSymbolPoint: function(ja) {
            return [S[ja * 2], S[ja * 2 + 1]];
          } }), $ && this._initSymbolLabelAnimation(m6, d6, je), ke && (S = iS(S, d6, ke, _e), ue && (ue = iS(ue, d6, ke, _e))), R = this._newPolyline(S), K && (F = this._newPolygon(S, ue)), M || this._initOrUpdateEndLabel(t2, d6, lA(Fe)), j.setClipPath(sX(this, d6, true, t2));
        else {
          K && !F ? F = this._newPolygon(S, ue) : F && !K && (j.remove(F), F = this._polygon = null), M || this._initOrUpdateEndLabel(t2, d6, lA(Fe));
          var at = j.getClipPath();
          if (at) {
            var ht = sX(this, d6, false, t2);
            zu(at, { shape: ht.shape }, t2);
          } else
            j.setClipPath(sX(this, d6, true, t2));
          pe && I.updateData(m6, { isIgnore: xe, clipShape: je, disableAnimation: true, getSymbolPoint: function(ja) {
            return [S[ja * 2], S[ja * 2 + 1]];
          } }), (!_pe(this._stackedOnPoints, ue) || !_pe(this._points, S)) && ($ ? this._doUpdateAnimation(m6, ue, d6, u, ke, U, _e) : (ke && (S = iS(S, d6, ke, _e), ue && (ue = iS(ue, d6, ke, _e))), R.setShape({ points: S }), F && F.setShape({ points: S, stackedOnPoints: ue })));
        }
        var Qe = t2.getModel("emphasis"), en = Qe.get("focus"), bt = Qe.get("blurScope"), wt = Qe.get("disabled");
        if (R.useStyle(ei(b6.getLineStyle(), { fill: "none", stroke: Fe, lineJoin: "bevel" })), Ah(R, t2, "lineStyle"), R.style.lineWidth > 0 && t2.get(["emphasis", "lineStyle", "width"]) === "bolder") {
          var Ft = R.getState("emphasis").style;
          Ft.lineWidth = +R.style.lineWidth + 1;
        }
        ii(R).seriesIndex = t2.seriesIndex, Cc(R, en, bt, wt);
        var fn = Spe(t2.get("smooth")), gn = t2.get("smoothMonotone");
        if (R.setShape({ smooth: fn, smoothMonotone: gn, connectNulls: _e }), F) {
          var Zr = m6.getCalculationInfo("stackedOnSeries"), Ma = 0;
          F.useStyle(ei(x6.getAreaStyle(), { fill: Fe, opacity: 0.7, lineJoin: "bevel", decal: m6.getVisual("style").decal })), Zr && (Ma = Spe(Zr.get("smooth"))), F.setShape({ smooth: fn, stackedOnSmooth: Ma, smoothMonotone: gn, connectNulls: _e }), Ah(F, t2, "areaStyle"), ii(F).seriesIndex = t2.seriesIndex, Cc(F, en, bt, wt);
        }
        var Ua = function(ja) {
          f6._changePolyState(ja);
        };
        m6.eachItemGraphicEl(function(ja) {
          ja && (ja.onHoverStateChange = Ua);
        }), this._polyline.onHoverStateChange = Ua, this._data = m6, this._coordSys = d6, this._stackedOnPoints = ue, this._points = S, this._step = ke, this._valueOrigin = U, t2.get("triggerLineEvent") && (this.packEventData(t2, R), F && this.packEventData(t2, F));
      }, r6.prototype.packEventData = function(t2, s) {
        ii(s).eventData = { componentType: "series", componentSubType: "line", componentIndex: t2.componentIndex, seriesIndex: t2.seriesIndex, seriesName: t2.name, seriesType: "line" };
      }, r6.prototype.highlight = function(t2, s, u, f6) {
        var d6 = t2.getData(), v6 = xx(d6, f6);
        if (this._changePolyState("emphasis"), !(v6 instanceof Array) && v6 != null && v6 >= 0) {
          var m6 = d6.getLayout("points"), b6 = d6.getItemGraphicEl(v6);
          if (!b6) {
            var x6 = m6[v6 * 2], S = m6[v6 * 2 + 1];
            if (isNaN(x6) || isNaN(S) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(x6, S))
              return;
            var M = t2.get("zlevel"), A6 = t2.get("z");
            b6 = new ZR(d6, v6), b6.x = x6, b6.y = S, b6.setZ(M, A6);
            var I = b6.getSymbolPath().getTextContent();
            I && (I.zlevel = M, I.z = A6, I.z2 = this._polyline.z2 + 1), b6.__temp = true, d6.setItemGraphicEl(v6, b6), b6.stopSymbolAnimation(true), this.group.add(b6);
          }
          b6.highlight();
        } else
          bu.prototype.highlight.call(this, t2, s, u, f6);
      }, r6.prototype.downplay = function(t2, s, u, f6) {
        var d6 = t2.getData(), v6 = xx(d6, f6);
        if (this._changePolyState("normal"), v6 != null && v6 >= 0) {
          var m6 = d6.getItemGraphicEl(v6);
          m6 && (m6.__temp ? (d6.setItemGraphicEl(v6, null), this.group.remove(m6)) : m6.downplay());
        } else
          bu.prototype.downplay.call(this, t2, s, u, f6);
      }, r6.prototype._changePolyState = function(t2) {
        var s = this._polygon;
        Lb(this._polyline, t2), s && Lb(s, t2);
      }, r6.prototype._newPolyline = function(t2) {
        var s = this._polyline;
        return s && this._lineGroup.remove(s), s = new ZNe({ shape: { points: t2 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(s), this._polyline = s, s;
      }, r6.prototype._newPolygon = function(t2, s) {
        var u = this._polygon;
        return u && this._lineGroup.remove(u), u = new mpe({ shape: { points: t2, stackedOnPoints: s }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(u), this._polygon = u, u;
      }, r6.prototype._initSymbolLabelAnimation = function(t2, s, u) {
        var f6, d6, v6 = s.getBaseAxis(), m6 = v6.inverse;
        s.type === "cartesian2d" ? (f6 = v6.isHorizontal(), d6 = false) : s.type === "polar" && (f6 = v6.dim === "angle", d6 = true);
        var b6 = t2.hostModel, x6 = b6.get("animationDuration");
        ti(x6) && (x6 = x6(null));
        var S = b6.get("animationDelay") || 0, M = ti(S) ? S(null) : S;
        t2.eachItemGraphicEl(function(A6, I) {
          var R = A6;
          if (R) {
            var F = [A6.x, A6.y], j = void 0, $ = void 0, K = void 0;
            if (u)
              if (d6) {
                var U = u, he = s.pointToCoord(F);
                f6 ? (j = U.startAngle, $ = U.endAngle, K = -he[1] / 180 * Math.PI) : (j = U.r0, $ = U.r, K = he[0]);
              } else {
                var ue = u;
                f6 ? (j = ue.x, $ = ue.x + ue.width, K = A6.x) : (j = ue.y + ue.height, $ = ue.y, K = A6.y);
              }
            var pe = $ === j ? 0 : (K - j) / ($ - j);
            m6 && (pe = 1 - pe);
            var _e = ti(S) ? S(I) : x6 * pe + M, xe = R.getSymbolPath(), Ae = xe.getTextContent();
            R.attr({ scaleX: 0, scaleY: 0 }), R.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: _e }), Ae && Ae.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: _e }), xe.disableLabelAnimation = true;
          }
        });
      }, r6.prototype._initOrUpdateEndLabel = function(t2, s, u) {
        var f6 = t2.getModel("endLabel");
        if (Mpe(t2)) {
          var d6 = t2.getData(), v6 = this._polyline, m6 = d6.getLayout("points");
          if (!m6) {
            v6.removeTextContent(), this._endLabel = null;
            return;
          }
          var b6 = this._endLabel;
          b6 || (b6 = this._endLabel = new ms({ z2: 200 }), b6.ignoreClip = true, v6.setTextContent(this._endLabel), v6.disableLabelAnimation = true);
          var x6 = r8e(m6);
          x6 >= 0 && (Bp(v6, hd(t2, "endLabel"), { inheritColor: u, labelFetcher: t2, labelDataIndex: x6, defaultText: function(S, M, A6) {
            return A6 != null ? fpe(d6, A6) : p5(d6, S);
          }, enableTextSetter: true }, i8e(f6, s)), v6.textConfig.position = null);
        } else
          this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
      }, r6.prototype._endLabelOnDuring = function(t2, s, u, f6, d6, v6, m6) {
        var b6 = this._endLabel, x6 = this._polyline;
        if (b6) {
          t2 < 1 && f6.originalX == null && (f6.originalX = b6.x, f6.originalY = b6.y);
          var S = u.getLayout("points"), M = u.hostModel, A6 = M.get("connectNulls"), I = v6.get("precision"), R = v6.get("distance") || 0, F = m6.getBaseAxis(), j = F.isHorizontal(), $ = F.inverse, K = s.shape, U = $ ? j ? K.x : K.y + K.height : j ? K.x + K.width : K.y, he = (j ? R : 0) * ($ ? -1 : 1), ue = (j ? 0 : -R) * ($ ? -1 : 1), pe = j ? "x" : "y", _e = a8e(S, U, pe), xe = _e.range, Ae = xe[1] - xe[0], ke = void 0;
          if (Ae >= 1) {
            if (Ae > 1 && !A6) {
              var je = Cpe(S, xe[0]);
              b6.attr({ x: je[0] + he, y: je[1] + ue }), d6 && (ke = M.getRawValue(xe[0]));
            } else {
              var je = x6.getPointOn(U, pe);
              je && b6.attr({ x: je[0] + he, y: je[1] + ue });
              var Fe = M.getRawValue(xe[0]), at = M.getRawValue(xe[1]);
              d6 && (ke = fO(u, I, Fe, at, _e.t));
            }
            f6.lastFrameIndex = xe[0];
          } else {
            var ht = t2 === 1 || f6.lastFrameIndex > 0 ? xe[0] : 0, je = Cpe(S, ht);
            d6 && (ke = M.getRawValue(ht)), b6.attr({ x: je[0] + he, y: je[1] + ue });
          }
          d6 && qD(b6).setLabelText(ke);
        }
      }, r6.prototype._doUpdateAnimation = function(t2, s, u, f6, d6, v6, m6) {
        var b6 = this._polyline, x6 = this._polygon, S = t2.hostModel, M = YNe(this._data, t2, this._stackedOnPoints, s, this._coordSys, u, this._valueOrigin), A6 = M.current, I = M.stackedOnCurrent, R = M.next, F = M.stackedOnNext;
        if (d6 && (A6 = iS(M.current, u, d6, m6), I = iS(M.stackedOnCurrent, u, d6, m6), R = iS(M.next, u, d6, m6), F = iS(M.stackedOnNext, u, d6, m6)), wpe(A6, R) > 3e3 || x6 && wpe(I, F) > 3e3) {
          b6.stopAnimation(), b6.setShape({ points: R }), x6 && (x6.stopAnimation(), x6.setShape({ points: R, stackedOnPoints: F }));
          return;
        }
        b6.shape.__points = M.current, b6.shape.points = A6;
        var j = { shape: { points: R } };
        M.current !== A6 && (j.shape.__points = M.next), b6.stopAnimation(), fs(b6, j, S), x6 && (x6.setShape({ points: A6, stackedOnPoints: I }), x6.stopAnimation(), fs(x6, { shape: { stackedOnPoints: F } }, S), b6.shape.points !== x6.shape.points && (x6.shape.points = b6.shape.points));
        for (var $ = [], K = M.status, U = 0; U < K.length; U++) {
          var he = K[U].cmd;
          if (he === "=") {
            var ue = t2.getItemGraphicEl(K[U].idx1);
            ue && $.push({ el: ue, ptIdx: U });
          }
        }
        b6.animators && b6.animators.length && b6.animators[0].during(function() {
          x6 && x6.dirtyShape();
          for (var pe = b6.shape.__points, _e = 0; _e < $.length; _e++) {
            var xe = $[_e].el, Ae = $[_e].ptIdx * 2;
            xe.x = pe[Ae], xe.y = pe[Ae + 1], xe.markRedraw();
          }
        });
      }, r6.prototype.remove = function(t2) {
        var s = this.group, u = this._data;
        this._lineGroup.removeAll(), this._symbolDraw.remove(true), u && u.eachItemGraphicEl(function(f6, d6) {
          f6.__temp && (s.remove(f6), u.setItemGraphicEl(d6, null));
        }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
      }, r6.type = "line", r6;
    }(bu), s8e = o8e;
    function KR(a, r6) {
      return { seriesType: a, plan: a5(), reset: function(t2) {
        var s = t2.getData(), u = t2.coordinateSystem, f6 = t2.pipelineContext, d6 = r6 || f6.large;
        if (u) {
          var v6 = wr(u.dimensions, function(A6) {
            return s.mapDimension(A6);
          }).slice(0, 2), m6 = v6.length, b6 = s.getCalculationInfo("stackResultDimension");
          tS(s, v6[0]) && (v6[0] = b6), tS(s, v6[1]) && (v6[1] = b6);
          var x6 = s.getStore(), S = s.getDimensionIndex(v6[0]), M = s.getDimensionIndex(v6[1]);
          return m6 && { progress: function(A6, I) {
            for (var R = A6.end - A6.start, F = d6 && Vb(R * m6), j = [], $ = [], K = A6.start, U = 0; K < A6.end; K++) {
              var he = void 0;
              if (m6 === 1) {
                var ue = x6.get(S, K);
                he = u.dataToPoint(ue, null, $);
              } else
                j[0] = x6.get(S, K), j[1] = x6.get(M, K), he = u.dataToPoint(j, null, $);
              d6 ? (F[U++] = he[0], F[U++] = he[1]) : I.setItemLayout(K, he.slice());
            }
            d6 && I.setLayout("points", F);
          } };
        }
      } };
    }
    var l8e = { average: function(a) {
      for (var r6 = 0, t2 = 0, s = 0; s < a.length; s++)
        isNaN(a[s]) || (r6 += a[s], t2++);
      return t2 === 0 ? NaN : r6 / t2;
    }, sum: function(a) {
      for (var r6 = 0, t2 = 0; t2 < a.length; t2++)
        r6 += a[t2] || 0;
      return r6;
    }, max: function(a) {
      for (var r6 = -1 / 0, t2 = 0; t2 < a.length; t2++)
        a[t2] > r6 && (r6 = a[t2]);
      return isFinite(r6) ? r6 : NaN;
    }, min: function(a) {
      for (var r6 = 1 / 0, t2 = 0; t2 < a.length; t2++)
        a[t2] < r6 && (r6 = a[t2]);
      return isFinite(r6) ? r6 : NaN;
    }, nearest: function(a) {
      return a[0];
    } }, u8e = function(a) {
      return Math.round(a.length / 2);
    };
    function Ape(a) {
      return { seriesType: a, reset: function(r6, t2, s) {
        var u = r6.getData(), f6 = r6.get("sampling"), d6 = r6.coordinateSystem, v6 = u.count();
        if (v6 > 10 && d6.type === "cartesian2d" && f6) {
          var m6 = d6.getBaseAxis(), b6 = d6.getOtherAxis(m6), x6 = m6.getExtent(), S = s.getDevicePixelRatio(), M = Math.abs(x6[1] - x6[0]) * (S || 1), A6 = Math.round(v6 / M);
          if (isFinite(A6) && A6 > 1) {
            f6 === "lttb" && r6.setData(u.lttbDownSample(u.mapDimension(b6.dim), 1 / A6));
            var I = void 0;
            _a2(f6) ? I = l8e[f6] : ti(f6) && (I = f6), I && r6.setData(u.downSample(u.mapDimension(b6.dim), 1 / A6, I, u8e));
          }
        }
      } };
    }
    function c8e(a) {
      a.registerChartView(s8e), a.registerSeriesModel(GNe), a.registerLayout(KR("line", true)), a.registerVisual({ seriesType: "line", reset: function(r6) {
        var t2 = r6.getData(), s = r6.getModel("lineStyle").getLineStyle();
        s && !s.stroke && (s.stroke = t2.getVisual("style").fill), t2.setVisual("legendLineStyle", s);
      } }), a.registerProcessor(a.PRIORITY.PROCESSOR.STATISTIC, Ape("line"));
    }
    var Epe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        return Wx(null, this, { useEncodeDefaulter: true });
      }, r6.prototype.getMarkerPosition = function(t2) {
        var s = this.coordinateSystem;
        if (s && s.clampData) {
          var u = s.dataToPoint(s.clampData(t2)), f6 = this.getData(), d6 = f6.getLayout("offset"), v6 = f6.getLayout("size"), m6 = s.getBaseAxis().isHorizontal() ? 0 : 1;
          return u[m6] += d6 + v6 / 2, u;
        }
        return [NaN, NaN];
      }, r6.type = "series.__base_bar__", r6.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, r6;
    }(sc);
    sc.registerClass(Epe);
    var QV = Epe, f8e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.getInitialData = function() {
        return Wx(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
      }, r6.prototype.getProgressive = function() {
        return this.get("large") ? this.get("progressive") : false;
      }, r6.prototype.getProgressiveThreshold = function() {
        var t2 = this.get("progressiveThreshold"), s = this.get("largeThreshold");
        return s > t2 && (t2 = s), t2;
      }, r6.prototype.brushSelector = function(t2, s, u) {
        return u.rect(s.getItemLayout(t2));
      }, r6.type = "series.bar", r6.dependencies = ["grid", "polar"], r6.defaultOption = Y2(QV.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), r6;
    }(QV), h8e = f8e, d8e = function() {
      function a() {
        this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
      }
      return a;
    }(), p8e = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "sausage", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new d8e();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.cx, f6 = s.cy, d6 = Math.max(s.r0 || 0, 0), v6 = Math.max(s.r, 0), m6 = (v6 - d6) * 0.5, b6 = d6 + m6, x6 = s.startAngle, S = s.endAngle, M = s.clockwise, A6 = Math.PI * 2, I = M ? S - x6 < A6 : x6 - S < A6;
        I || (x6 = S - (M ? A6 : -A6));
        var R = Math.cos(x6), F = Math.sin(x6), j = Math.cos(S), $ = Math.sin(S);
        I ? (t2.moveTo(R * d6 + u, F * d6 + f6), t2.arc(R * b6 + u, F * b6 + f6, m6, -Math.PI + x6, x6, !M)) : t2.moveTo(R * v6 + u, F * v6 + f6), t2.arc(u, f6, v6, x6, S, !M), t2.arc(j * b6 + u, $ * b6 + f6, m6, S - Math.PI * 2, S - Math.PI, !M), d6 !== 0 && t2.arc(u, f6, d6, S, x6, M);
      }, r6;
    }(uo), ez = p8e;
    function v8e(a, r6) {
      r6 = r6 || {};
      var t2 = r6.isRoundCap;
      return function(s, u, f6) {
        var d6 = u.position;
        if (!d6 || d6 instanceof Array)
          return FM(s, u, f6);
        var v6 = a(d6), m6 = u.distance != null ? u.distance : 5, b6 = this.shape, x6 = b6.cx, S = b6.cy, M = b6.r, A6 = b6.r0, I = (M + A6) / 2, R = b6.startAngle, F = b6.endAngle, j = (R + F) / 2, $ = t2 ? Math.abs(M - A6) / 2 : 0, K = Math.cos, U = Math.sin, he = x6 + M * K(R), ue = S + M * U(R), pe = "left", _e = "top";
        switch (v6) {
          case "startArc":
            he = x6 + (A6 - m6) * K(j), ue = S + (A6 - m6) * U(j), pe = "center", _e = "top";
            break;
          case "insideStartArc":
            he = x6 + (A6 + m6) * K(j), ue = S + (A6 + m6) * U(j), pe = "center", _e = "bottom";
            break;
          case "startAngle":
            he = x6 + I * K(R) + tz(R, m6 + $, false), ue = S + I * U(R) + nz(R, m6 + $, false), pe = "right", _e = "middle";
            break;
          case "insideStartAngle":
            he = x6 + I * K(R) + tz(R, -m6 + $, false), ue = S + I * U(R) + nz(R, -m6 + $, false), pe = "left", _e = "middle";
            break;
          case "middle":
            he = x6 + I * K(j), ue = S + I * U(j), pe = "center", _e = "middle";
            break;
          case "endArc":
            he = x6 + (M + m6) * K(j), ue = S + (M + m6) * U(j), pe = "center", _e = "bottom";
            break;
          case "insideEndArc":
            he = x6 + (M - m6) * K(j), ue = S + (M - m6) * U(j), pe = "center", _e = "top";
            break;
          case "endAngle":
            he = x6 + I * K(F) + tz(F, m6 + $, true), ue = S + I * U(F) + nz(F, m6 + $, true), pe = "left", _e = "middle";
            break;
          case "insideEndAngle":
            he = x6 + I * K(F) + tz(F, -m6 + $, true), ue = S + I * U(F) + nz(F, -m6 + $, true), pe = "right", _e = "middle";
            break;
          default:
            return FM(s, u, f6);
        }
        return s = s || {}, s.x = he, s.y = ue, s.align = pe, s.verticalAlign = _e, s;
      };
    }
    function g8e(a, r6, t2, s) {
      if (ks(s)) {
        a.setTextConfig({ rotation: s });
        return;
      } else if (br(r6)) {
        a.setTextConfig({ rotation: 0 });
        return;
      }
      var u = a.shape, f6 = u.clockwise ? u.startAngle : u.endAngle, d6 = u.clockwise ? u.endAngle : u.startAngle, v6 = (f6 + d6) / 2, m6, b6 = t2(r6);
      switch (b6) {
        case "startArc":
        case "insideStartArc":
        case "middle":
        case "insideEndArc":
        case "endArc":
          m6 = v6;
          break;
        case "startAngle":
        case "insideStartAngle":
          m6 = f6;
          break;
        case "endAngle":
        case "insideEndAngle":
          m6 = d6;
          break;
        default:
          a.setTextConfig({ rotation: 0 });
          return;
      }
      var x6 = Math.PI * 1.5 - m6;
      b6 === "middle" && x6 > Math.PI / 2 && x6 < Math.PI * 1.5 && (x6 -= Math.PI), a.setTextConfig({ rotation: x6 });
    }
    function tz(a, r6, t2) {
      return r6 * Math.sin(a) * (t2 ? -1 : 1);
    }
    function nz(a, r6, t2) {
      return r6 * Math.cos(a) * (t2 ? 1 : -1);
    }
    var lX = Math.max, uX = Math.min;
    function m8e(a, r6) {
      var t2 = a.getArea && a.getArea();
      if ($x(a, "cartesian2d")) {
        var s = a.getBaseAxis();
        if (s.type !== "category" || !s.onBand) {
          var u = r6.getLayout("bandWidth");
          s.isHorizontal() ? (t2.x -= u, t2.width += u * 2) : (t2.y -= u, t2.height += u * 2);
        }
      }
      return t2;
    }
    var y8e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a.call(this) || this;
        return t2.type = r6.type, t2._isFirstFrame = true, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        this._model = t2, this._removeOnRenderedListener(u), this._updateDrawMode(t2);
        var d6 = t2.get("coordinateSystem");
        (d6 === "cartesian2d" || d6 === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(t2, s, u) : this._renderNormal(t2, s, u, f6));
      }, r6.prototype.incrementalPrepareRender = function(t2) {
        this._clear(), this._updateDrawMode(t2), this._updateLargeClip(t2);
      }, r6.prototype.incrementalRender = function(t2, s) {
        this._progressiveEls = [], this._incrementalRenderLarge(t2, s);
      }, r6.prototype.eachRendered = function(t2) {
        s1(this._progressiveEls || this.group, t2);
      }, r6.prototype._updateDrawMode = function(t2) {
        var s = t2.pipelineContext.large;
        (this._isLargeDraw == null || s !== this._isLargeDraw) && (this._isLargeDraw = s, this._clear());
      }, r6.prototype._renderNormal = function(t2, s, u, f6) {
        var d6 = this.group, v6 = t2.getData(), m6 = this._data, b6 = t2.coordinateSystem, x6 = b6.getBaseAxis(), S;
        b6.type === "cartesian2d" ? S = x6.isHorizontal() : b6.type === "polar" && (S = x6.dim === "angle");
        var M = t2.isAnimationEnabled() ? t2 : null, A6 = b8e(t2, b6);
        A6 && this._enableRealtimeSort(A6, v6, u);
        var I = t2.get("clip", true) || A6, R = m8e(b6, v6);
        d6.removeClipPath();
        var F = t2.get("roundCap", true), j = t2.get("showBackground", true), $ = t2.getModel("backgroundStyle"), K = $.get("borderRadius") || 0, U = [], he = this._backgroundEls, ue = f6 && f6.isInitSort, pe = f6 && f6.type === "changeAxisOrder";
        function _e(ke) {
          var je = rz[b6.type](v6, ke), Fe = A8e(b6, S, je);
          return Fe.useStyle($.getItemStyle()), b6.type === "cartesian2d" && Fe.setShape("r", K), U[ke] = Fe, Fe;
        }
        v6.diff(m6).add(function(ke) {
          var je = v6.getItemModel(ke), Fe = rz[b6.type](v6, ke, je);
          if (j && _e(ke), !(!v6.hasValue(ke) || !Ppe[b6.type](Fe))) {
            var at = false;
            I && (at = Ipe[b6.type](R, Fe));
            var ht = Tpe[b6.type](t2, v6, ke, Fe, S, M, x6.model, false, F);
            A6 && (ht.forceLabelAnimation = true), Ope(ht, v6, ke, je, Fe, t2, S, b6.type === "polar"), ue ? ht.attr({ shape: Fe }) : A6 ? Dpe(A6, M, ht, Fe, ke, S, false, false) : zu(ht, { shape: Fe }, t2, ke), v6.setItemGraphicEl(ke, ht), d6.add(ht), ht.ignore = at;
          }
        }).update(function(ke, je) {
          var Fe = v6.getItemModel(ke), at = rz[b6.type](v6, ke, Fe);
          if (j) {
            var ht = void 0;
            he.length === 0 ? ht = _e(je) : (ht = he[je], ht.useStyle($.getItemStyle()), b6.type === "cartesian2d" && ht.setShape("r", K), U[ke] = ht);
            var Qe = rz[b6.type](v6, ke), en = Vpe(S, Qe, b6);
            fs(ht, { shape: en }, M, ke);
          }
          var bt = m6.getItemGraphicEl(je);
          if (!v6.hasValue(ke) || !Ppe[b6.type](at)) {
            d6.remove(bt);
            return;
          }
          var wt = false;
          if (I && (wt = Ipe[b6.type](R, at), wt && d6.remove(bt)), bt ? f0(bt) : bt = Tpe[b6.type](t2, v6, ke, at, S, M, x6.model, !!bt, F), A6 && (bt.forceLabelAnimation = true), pe) {
            var Ft = bt.getTextContent();
            if (Ft) {
              var fn = qD(Ft);
              fn.prevValue != null && (fn.prevValue = fn.value);
            }
          } else
            Ope(bt, v6, ke, Fe, at, t2, S, b6.type === "polar");
          ue ? bt.attr({ shape: at }) : A6 ? Dpe(A6, M, bt, at, ke, S, true, pe) : fs(bt, { shape: at }, t2, ke, null), v6.setItemGraphicEl(ke, bt), bt.ignore = wt, d6.add(bt);
        }).remove(function(ke) {
          var je = m6.getItemGraphicEl(ke);
          je && iA(je, t2, ke);
        }).execute();
        var xe = this._backgroundGroup || (this._backgroundGroup = new bi());
        xe.removeAll();
        for (var Ae = 0; Ae < U.length; ++Ae)
          xe.add(U[Ae]);
        d6.add(xe), this._backgroundEls = U, this._data = v6;
      }, r6.prototype._renderLarge = function(t2, s, u) {
        this._clear(), Fpe(t2, this.group), this._updateLargeClip(t2);
      }, r6.prototype._incrementalRenderLarge = function(t2, s) {
        this._removeBackground(), Fpe(s, this.group, this._progressiveEls, true);
      }, r6.prototype._updateLargeClip = function(t2) {
        var s = t2.get("clip", true) && JV(t2.coordinateSystem, false, t2), u = this.group;
        s ? u.setClipPath(s) : u.removeClipPath();
      }, r6.prototype._enableRealtimeSort = function(t2, s, u) {
        var f6 = this;
        if (s.count()) {
          var d6 = t2.baseAxis;
          if (this._isFirstFrame)
            this._dispatchInitSort(s, t2, u), this._isFirstFrame = false;
          else {
            var v6 = function(m6) {
              var b6 = s.getItemGraphicEl(m6), x6 = b6 && b6.shape;
              return x6 && Math.abs(d6.isHorizontal() ? x6.height : x6.width) || 0;
            };
            this._onRendered = function() {
              f6._updateSortWithinSameData(s, v6, d6, u);
            }, u.getZr().on("rendered", this._onRendered);
          }
        }
      }, r6.prototype._dataSort = function(t2, s, u) {
        var f6 = [];
        return t2.each(t2.mapDimension(s.dim), function(d6, v6) {
          var m6 = u(v6);
          m6 = m6 == null ? NaN : m6, f6.push({ dataIndex: v6, mappedValue: m6, ordinalNumber: d6 });
        }), f6.sort(function(d6, v6) {
          return v6.mappedValue - d6.mappedValue;
        }), { ordinalNumbers: wr(f6, function(d6) {
          return d6.ordinalNumber;
        }) };
      }, r6.prototype._isOrderChangedWithinSameData = function(t2, s, u) {
        for (var f6 = u.scale, d6 = t2.mapDimension(u.dim), v6 = Number.MAX_VALUE, m6 = 0, b6 = f6.getOrdinalMeta().categories.length; m6 < b6; ++m6) {
          var x6 = t2.rawIndexOf(d6, f6.getRawOrdinalNumber(m6)), S = x6 < 0 ? Number.MIN_VALUE : s(t2.indexOfRawIndex(x6));
          if (S > v6)
            return true;
          v6 = S;
        }
        return false;
      }, r6.prototype._isOrderDifferentInView = function(t2, s) {
        for (var u = s.scale, f6 = u.getExtent(), d6 = Math.max(0, f6[0]), v6 = Math.min(f6[1], u.getOrdinalMeta().categories.length - 1); d6 <= v6; ++d6)
          if (t2.ordinalNumbers[d6] !== u.getRawOrdinalNumber(d6))
            return true;
      }, r6.prototype._updateSortWithinSameData = function(t2, s, u, f6) {
        if (this._isOrderChangedWithinSameData(t2, s, u)) {
          var d6 = this._dataSort(t2, u, s);
          this._isOrderDifferentInView(d6, u) && (this._removeOnRenderedListener(f6), f6.dispatchAction({ type: "changeAxisOrder", componentType: u.dim + "Axis", axisId: u.index, sortInfo: d6 }));
        }
      }, r6.prototype._dispatchInitSort = function(t2, s, u) {
        var f6 = s.baseAxis, d6 = this._dataSort(t2, f6, function(v6) {
          return t2.get(t2.mapDimension(s.otherAxis.dim), v6);
        });
        u.dispatchAction({ type: "changeAxisOrder", componentType: f6.dim + "Axis", isInitSort: true, axisId: f6.index, sortInfo: d6 });
      }, r6.prototype.remove = function(t2, s) {
        this._clear(this._model), this._removeOnRenderedListener(s);
      }, r6.prototype.dispose = function(t2, s) {
        this._removeOnRenderedListener(s);
      }, r6.prototype._removeOnRenderedListener = function(t2) {
        this._onRendered && (t2.getZr().off("rendered", this._onRendered), this._onRendered = null);
      }, r6.prototype._clear = function(t2) {
        var s = this.group, u = this._data;
        t2 && t2.isAnimationEnabled() && u && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], u.eachItemGraphicEl(function(f6) {
          iA(f6, t2, ii(f6).dataIndex);
        })) : s.removeAll(), this._data = null, this._isFirstFrame = true;
      }, r6.prototype._removeBackground = function() {
        this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
      }, r6.type = "bar", r6;
    }(bu), Ipe = { cartesian2d: function(a, r6) {
      var t2 = r6.width < 0 ? -1 : 1, s = r6.height < 0 ? -1 : 1;
      t2 < 0 && (r6.x += r6.width, r6.width = -r6.width), s < 0 && (r6.y += r6.height, r6.height = -r6.height);
      var u = a.x + a.width, f6 = a.y + a.height, d6 = lX(r6.x, a.x), v6 = uX(r6.x + r6.width, u), m6 = lX(r6.y, a.y), b6 = uX(r6.y + r6.height, f6), x6 = v6 < d6, S = b6 < m6;
      return r6.x = x6 && d6 > u ? v6 : d6, r6.y = S && m6 > f6 ? b6 : m6, r6.width = x6 ? 0 : v6 - d6, r6.height = S ? 0 : b6 - m6, t2 < 0 && (r6.x += r6.width, r6.width = -r6.width), s < 0 && (r6.y += r6.height, r6.height = -r6.height), x6 || S;
    }, polar: function(a, r6) {
      var t2 = r6.r0 <= r6.r ? 1 : -1;
      if (t2 < 0) {
        var s = r6.r;
        r6.r = r6.r0, r6.r0 = s;
      }
      var u = uX(r6.r, a.r), f6 = lX(r6.r0, a.r0);
      r6.r = u, r6.r0 = f6;
      var d6 = u - f6 < 0;
      if (t2 < 0) {
        var s = r6.r;
        r6.r = r6.r0, r6.r0 = s;
      }
      return d6;
    } }, Tpe = { cartesian2d: function(a, r6, t2, s, u, f6, d6, v6, m6) {
      var b6 = new rs({ shape: qn({}, s), z2: 1 });
      if (b6.__dataIndex = t2, b6.name = "item", f6) {
        var x6 = b6.shape, S = u ? "height" : "width";
        x6[S] = 0;
      }
      return b6;
    }, polar: function(a, r6, t2, s, u, f6, d6, v6, m6) {
      var b6 = !u && m6 ? ez : Np, x6 = new b6({ shape: s, z2: 1 });
      x6.name = "item";
      var S = Lpe(u);
      if (x6.calculateTextPosition = v8e(S, { isRoundCap: b6 === ez }), f6) {
        var M = x6.shape, A6 = u ? "r" : "endAngle", I = {};
        M[A6] = u ? 0 : s.startAngle, I[A6] = s[A6], (v6 ? fs : zu)(x6, { shape: I }, f6);
      }
      return x6;
    } };
    function b8e(a, r6) {
      var t2 = a.get("realtimeSort", true), s = r6.getBaseAxis();
      if (t2 && s.type === "category" && r6.type === "cartesian2d")
        return { baseAxis: s, otherAxis: r6.getOtherAxis(s) };
    }
    function Dpe(a, r6, t2, s, u, f6, d6, v6) {
      var m6, b6;
      f6 ? (b6 = { x: s.x, width: s.width }, m6 = { y: s.y, height: s.height }) : (b6 = { y: s.y, height: s.height }, m6 = { x: s.x, width: s.width }), v6 || (d6 ? fs : zu)(t2, { shape: m6 }, r6, u, null);
      var x6 = r6 ? a.baseAxis.model : null;
      (d6 ? fs : zu)(t2, { shape: b6 }, x6, u);
    }
    function kpe(a, r6) {
      for (var t2 = 0; t2 < r6.length; t2++)
        if (!isFinite(a[r6[t2]]))
          return true;
      return false;
    }
    var _8e = ["x", "y", "width", "height"], x8e = ["cx", "cy", "r", "startAngle", "endAngle"], Ppe = { cartesian2d: function(a) {
      return !kpe(a, _8e);
    }, polar: function(a) {
      return !kpe(a, x8e);
    } }, rz = { cartesian2d: function(a, r6, t2) {
      var s = a.getItemLayout(r6), u = t2 ? S8e(t2, s) : 0, f6 = s.width > 0 ? 1 : -1, d6 = s.height > 0 ? 1 : -1;
      return { x: s.x + f6 * u / 2, y: s.y + d6 * u / 2, width: s.width - f6 * u, height: s.height - d6 * u };
    }, polar: function(a, r6, t2) {
      var s = a.getItemLayout(r6);
      return { cx: s.cx, cy: s.cy, r0: s.r0, r: s.r, startAngle: s.startAngle, endAngle: s.endAngle, clockwise: s.clockwise };
    } };
    function w8e(a) {
      return a.startAngle != null && a.endAngle != null && a.startAngle === a.endAngle;
    }
    function Lpe(a) {
      return function(r6) {
        var t2 = r6 ? "Arc" : "Angle";
        return function(s) {
          switch (s) {
            case "start":
            case "insideStart":
            case "end":
            case "insideEnd":
              return s + t2;
            default:
              return s;
          }
        };
      }(a);
    }
    function Ope(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = r6.getItemVisual(t2, "style");
      v6 || a.setShape("r", s.get(["itemStyle", "borderRadius"]) || 0), a.useStyle(m6);
      var b6 = s.getShallow("cursor");
      b6 && a.attr("cursor", b6);
      var x6 = v6 ? d6 ? u.r >= u.r0 ? "endArc" : "startArc" : u.endAngle >= u.startAngle ? "endAngle" : "startAngle" : d6 ? u.height >= 0 ? "bottom" : "top" : u.width >= 0 ? "right" : "left", S = hd(s);
      Bp(a, S, { labelFetcher: f6, labelDataIndex: t2, defaultText: p5(f6.getData(), t2), inheritColor: m6.fill, defaultOpacity: m6.opacity, defaultOutsidePosition: x6 });
      var M = a.getTextContent();
      if (v6 && M) {
        var A6 = s.get(["label", "position"]);
        a.textConfig.inside = A6 === "middle" ? true : null, g8e(a, A6 === "outside" ? x6 : A6, Lpe(d6), s.get(["label", "rotate"]));
      }
      ece(M, S, f6.getRawValue(t2), function(R) {
        return fpe(r6, R);
      });
      var I = s.getModel(["emphasis"]);
      Cc(a, I.get("focus"), I.get("blurScope"), I.get("disabled")), Ah(a, s), w8e(u) && (a.style.fill = "none", a.style.stroke = "none", Ne(a.states, function(R) {
        R.style && (R.style.fill = R.style.stroke = "none");
      }));
    }
    function S8e(a, r6) {
      var t2 = a.get(["itemStyle", "borderColor"]);
      if (!t2 || t2 === "none")
        return 0;
      var s = a.get(["itemStyle", "borderWidth"]) || 0, u = isNaN(r6.width) ? Number.MAX_VALUE : Math.abs(r6.width), f6 = isNaN(r6.height) ? Number.MAX_VALUE : Math.abs(r6.height);
      return Math.min(s, u, f6);
    }
    var C8e = function() {
      function a() {
      }
      return a;
    }(), Rpe = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "largeBar", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new C8e();
      }, r6.prototype.buildPath = function(t2, s) {
        for (var u = s.points, f6 = this.baseDimIdx, d6 = 1 - this.baseDimIdx, v6 = [], m6 = [], b6 = this.barWidth, x6 = 0; x6 < u.length; x6 += 3)
          m6[f6] = b6, m6[d6] = u[x6 + 2], v6[f6] = u[x6 + f6], v6[d6] = u[x6 + d6], t2.rect(v6[0], v6[1], m6[0], m6[1]);
      }, r6;
    }(uo);
    function Fpe(a, r6, t2, s) {
      var u = a.getData(), f6 = u.getLayout("valueAxisHorizontal") ? 1 : 0, d6 = u.getLayout("largeDataIndices"), v6 = u.getLayout("size"), m6 = a.getModel("backgroundStyle"), b6 = u.getLayout("largeBackgroundPoints");
      if (b6) {
        var x6 = new Rpe({ shape: { points: b6 }, incremental: !!s, silent: true, z2: 0 });
        x6.baseDimIdx = f6, x6.largeDataIndices = d6, x6.barWidth = v6, x6.useStyle(m6.getItemStyle()), r6.add(x6), t2 && t2.push(x6);
      }
      var S = new Rpe({ shape: { points: u.getLayout("largePoints") }, incremental: !!s, z2: 1 });
      S.baseDimIdx = f6, S.largeDataIndices = d6, S.barWidth = v6, r6.add(S), S.useStyle(u.getVisual("style")), ii(S).seriesIndex = a.seriesIndex, a.get("silent") || (S.on("mousedown", Npe), S.on("mousemove", Npe)), t2 && t2.push(S);
    }
    var Npe = sZ(function(a) {
      var r6 = this, t2 = M8e(r6, a.offsetX, a.offsetY);
      ii(r6).dataIndex = t2 >= 0 ? t2 : null;
    }, 30, false);
    function M8e(a, r6, t2) {
      for (var s = a.baseDimIdx, u = 1 - s, f6 = a.shape.points, d6 = a.largeDataIndices, v6 = [], m6 = [], b6 = a.barWidth, x6 = 0, S = f6.length / 3; x6 < S; x6++) {
        var M = x6 * 3;
        if (m6[s] = b6, m6[u] = f6[M + 2], v6[s] = f6[M + s], v6[u] = f6[M + u], m6[u] < 0 && (v6[u] += m6[u], m6[u] = -m6[u]), r6 >= v6[0] && r6 <= v6[0] + m6[0] && t2 >= v6[1] && t2 <= v6[1] + m6[1])
          return d6[x6];
      }
      return -1;
    }
    function Vpe(a, r6, t2) {
      if ($x(t2, "cartesian2d")) {
        var s = r6, u = t2.getArea();
        return { x: a ? s.x : u.x, y: a ? u.y : s.y, width: a ? s.width : u.width, height: a ? u.height : s.height };
      } else {
        var u = t2.getArea(), f6 = r6;
        return { cx: u.cx, cy: u.cy, r0: a ? u.r0 : f6.r0, r: a ? u.r : f6.r, startAngle: a ? f6.startAngle : 0, endAngle: a ? f6.endAngle : Math.PI * 2 };
      }
    }
    function A8e(a, r6, t2) {
      var s = a.type === "polar" ? Np : rs;
      return new s({ shape: Vpe(r6, t2, a), silent: true, z2: 0 });
    }
    var E8e = y8e;
    function I8e(a) {
      a.registerChartView(E8e), a.registerSeriesModel(h8e), a.registerLayout(a.PRIORITY.VISUAL.LAYOUT, Oi(rde, "bar")), a.registerLayout(a.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, ade("bar")), a.registerProcessor(a.PRIORITY.PROCESSOR.STATISTIC, Ape("bar")), a.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(r6, t2) {
        var s = r6.componentType || "series";
        t2.eachComponent({ mainType: s, query: r6 }, function(u) {
          r6.sortInfo && u.axis.setCategorySortInfo(r6.sortInfo);
        });
      });
    }
    var az = Math.PI * 2, zpe = Math.PI / 180;
    function Bpe(a, r6) {
      return ah(a.getBoxLayoutParams(), { width: r6.getWidth(), height: r6.getHeight() });
    }
    function jpe(a, r6) {
      var t2 = Bpe(a, r6), s = a.get("center"), u = a.get("radius");
      br(u) || (u = [0, u]), br(s) || (s = [s, s]);
      var f6 = ua(t2.width, r6.getWidth()), d6 = ua(t2.height, r6.getHeight()), v6 = Math.min(f6, d6), m6 = ua(s[0], f6) + t2.x, b6 = ua(s[1], d6) + t2.y, x6 = ua(u[0], v6 / 2), S = ua(u[1], v6 / 2);
      return { cx: m6, cy: b6, r0: x6, r: S };
    }
    function T8e(a, r6, t2) {
      r6.eachSeriesByType(a, function(s) {
        var u = s.getData(), f6 = u.mapDimension("value"), d6 = Bpe(s, t2), v6 = jpe(s, t2), m6 = v6.cx, b6 = v6.cy, x6 = v6.r, S = v6.r0, M = -s.get("startAngle") * zpe, A6 = s.get("minAngle") * zpe, I = 0;
        u.each(f6, function(Ae) {
          !isNaN(Ae) && I++;
        });
        var R = u.getSum(f6), F = Math.PI / (R || I) * 2, j = s.get("clockwise"), $ = s.get("roseType"), K = s.get("stillShowZeroSum"), U = u.getDataExtent(f6);
        U[0] = 0;
        var he = az, ue = 0, pe = M, _e = j ? 1 : -1;
        if (u.setLayout({ viewRect: d6, r: x6 }), u.each(f6, function(Ae, ke) {
          var je;
          if (isNaN(Ae)) {
            u.setItemLayout(ke, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: j, cx: m6, cy: b6, r0: S, r: $ ? NaN : x6 });
            return;
          }
          $ !== "area" ? je = R === 0 && K ? F : Ae * F : je = az / I, je < A6 ? (je = A6, he -= A6) : ue += Ae;
          var Fe = pe + _e * je;
          u.setItemLayout(ke, { angle: je, startAngle: pe, endAngle: Fe, clockwise: j, cx: m6, cy: b6, r0: S, r: $ ? gs(Ae, U, [S, x6]) : x6 }), pe = Fe;
        }), he < az && I)
          if (he <= 1e-3) {
            var xe = az / I;
            u.each(f6, function(Ae, ke) {
              if (!isNaN(Ae)) {
                var je = u.getItemLayout(ke);
                je.angle = xe, je.startAngle = M + _e * ke * xe, je.endAngle = M + _e * (ke + 1) * xe;
              }
            });
          } else
            F = he / ue, pe = M, u.each(f6, function(Ae, ke) {
              if (!isNaN(Ae)) {
                var je = u.getItemLayout(ke), Fe = je.angle === A6 ? A6 : Ae * F;
                je.startAngle = pe, je.endAngle = pe + _e * Fe, pe += _e * Fe;
              }
            });
      });
    }
    function JR(a) {
      return { seriesType: a, reset: function(r6, t2) {
        var s = t2.findComponents({ mainType: "legend" });
        if (!(!s || !s.length)) {
          var u = r6.getData();
          u.filterSelf(function(f6) {
            for (var d6 = u.getName(f6), v6 = 0; v6 < s.length; v6++)
              if (!s[v6].isSelected(d6))
                return false;
            return true;
          });
        }
      } };
    }
    var D8e = Math.PI / 180;
    function Gpe(a, r6, t2, s, u, f6, d6, v6, m6, b6) {
      if (a.length < 2)
        return;
      function x6(R) {
        for (var F = R.rB, j = F * F, $ = 0; $ < R.list.length; $++) {
          var K = R.list[$], U = Math.abs(K.label.y - t2), he = s + K.len, ue = he * he, pe = Math.sqrt((1 - Math.abs(U * U / j)) * ue), _e = r6 + (pe + K.len2) * u, xe = _e - K.label.x, Ae = K.targetTextWidth - xe * u;
          Wpe(K, Ae, true), K.label.x = _e;
        }
      }
      function S(R) {
        for (var F = { list: [], maxY: 0 }, j = { list: [], maxY: 0 }, $ = 0; $ < R.length; $++)
          if (R[$].labelAlignTo === "none") {
            var K = R[$], U = K.label.y > t2 ? j : F, he = Math.abs(K.label.y - t2);
            if (he >= U.maxY) {
              var ue = K.label.x - r6 - K.len2 * u, pe = s + K.len, _e = Math.abs(ue) < pe ? Math.sqrt(he * he / (1 - ue * ue / pe / pe)) : pe;
              U.rB = _e, U.maxY = he;
            }
            U.list.push(K);
          }
        x6(F), x6(j);
      }
      for (var M = a.length, A6 = 0; A6 < M; A6++)
        if (a[A6].position === "outer" && a[A6].labelAlignTo === "labelLine") {
          var I = a[A6].label.x - b6;
          a[A6].linePoints[1][0] += I, a[A6].label.x = b6;
        }
      Fde(a, m6, m6 + d6) && S(a);
    }
    function k8e(a, r6, t2, s, u, f6, d6, v6) {
      for (var m6 = [], b6 = [], x6 = Number.MAX_VALUE, S = -Number.MAX_VALUE, M = 0; M < a.length; M++) {
        var A6 = a[M].label;
        cX(a[M]) || (A6.x < r6 ? (x6 = Math.min(x6, A6.x), m6.push(a[M])) : (S = Math.max(S, A6.x), b6.push(a[M])));
      }
      for (var M = 0; M < a.length; M++) {
        var I = a[M];
        if (!cX(I) && I.linePoints) {
          if (I.labelStyleWidth != null)
            continue;
          var A6 = I.label, R = I.linePoints, F = void 0;
          I.labelAlignTo === "edge" ? A6.x < r6 ? F = R[2][0] - I.labelDistance - d6 - I.edgeDistance : F = d6 + u - I.edgeDistance - R[2][0] - I.labelDistance : I.labelAlignTo === "labelLine" ? A6.x < r6 ? F = x6 - d6 - I.bleedMargin : F = d6 + u - S - I.bleedMargin : A6.x < r6 ? F = A6.x - d6 - I.bleedMargin : F = d6 + u - A6.x - I.bleedMargin, I.targetTextWidth = F, Wpe(I, F);
        }
      }
      Gpe(b6, r6, t2, s, 1, u, f6, d6, v6, S), Gpe(m6, r6, t2, s, -1, u, f6, d6, v6, x6);
      for (var M = 0; M < a.length; M++) {
        var I = a[M];
        if (!cX(I) && I.linePoints) {
          var A6 = I.label, R = I.linePoints, j = I.labelAlignTo === "edge", $ = A6.style.padding, K = $ ? $[1] + $[3] : 0, U = A6.style.backgroundColor ? 0 : K, he = I.rect.width + U, ue = R[1][0] - R[2][0];
          j ? A6.x < r6 ? R[2][0] = d6 + I.edgeDistance + he + I.labelDistance : R[2][0] = d6 + u - I.edgeDistance - he - I.labelDistance : (A6.x < r6 ? R[2][0] = A6.x + I.labelDistance : R[2][0] = A6.x - I.labelDistance, R[1][0] = R[2][0] + ue), R[1][1] = R[2][1] = A6.y;
        }
      }
    }
    function Wpe(a, r6, t2) {
      if (t2 === void 0 && (t2 = false), a.labelStyleWidth == null) {
        var s = a.label, u = s.style, f6 = a.rect, d6 = u.backgroundColor, v6 = u.padding, m6 = v6 ? v6[1] + v6[3] : 0, b6 = u.overflow, x6 = f6.width + (d6 ? 0 : m6);
        if (r6 < x6 || t2) {
          var S = f6.height;
          if (b6 && b6.match("break")) {
            s.setStyle("backgroundColor", null), s.setStyle("width", r6 - m6);
            var M = s.getBoundingRect();
            s.setStyle("width", Math.ceil(M.width)), s.setStyle("backgroundColor", d6);
          } else {
            var A6 = r6 - m6, I = r6 < x6 ? A6 : t2 ? A6 > a.unconstrainedWidth ? null : A6 : null;
            s.setStyle("width", I);
          }
          var R = s.getBoundingRect();
          f6.width = R.width;
          var F = (s.style.margin || 0) + 2.1;
          f6.height = R.height + F, f6.y -= (f6.height - S) / 2;
        }
      }
    }
    function cX(a) {
      return a.position === "center";
    }
    function P8e(a) {
      var r6 = a.getData(), t2 = [], s, u, f6 = false, d6 = (a.get("minShowLabelAngle") || 0) * D8e, v6 = r6.getLayout("viewRect"), m6 = r6.getLayout("r"), b6 = v6.width, x6 = v6.x, S = v6.y, M = v6.height;
      function A6(ue) {
        ue.ignore = true;
      }
      function I(ue) {
        if (!ue.ignore)
          return true;
        for (var pe in ue.states)
          if (ue.states[pe].ignore === false)
            return true;
        return false;
      }
      r6.each(function(ue) {
        var pe = r6.getItemGraphicEl(ue), _e = pe.shape, xe = pe.getTextContent(), Ae = pe.getTextGuideLine(), ke = r6.getItemModel(ue), je = ke.getModel("label"), Fe = je.get("position") || ke.get(["emphasis", "label", "position"]), at = je.get("distanceToLabelLine"), ht = je.get("alignTo"), Qe = ua(je.get("edgeDistance"), b6), en = je.get("bleedMargin"), bt = ke.getModel("labelLine"), wt = bt.get("length");
        wt = ua(wt, b6);
        var Ft = bt.get("length2");
        if (Ft = ua(Ft, b6), Math.abs(_e.endAngle - _e.startAngle) < d6) {
          Ne(xe.states, A6), xe.ignore = true;
          return;
        }
        if (I(xe)) {
          var fn = (_e.startAngle + _e.endAngle) / 2, gn = Math.cos(fn), Zr = Math.sin(fn), Ma, Ua, ja, Ga;
          s = _e.cx, u = _e.cy;
          var pa = Fe === "inside" || Fe === "inner";
          if (Fe === "center")
            Ma = _e.cx, Ua = _e.cy, Ga = "center";
          else {
            var Fa = (pa ? (_e.r + _e.r0) / 2 * gn : _e.r * gn) + s, Ha = (pa ? (_e.r + _e.r0) / 2 * Zr : _e.r * Zr) + u;
            if (Ma = Fa + gn * 3, Ua = Ha + Zr * 3, !pa) {
              var Sa = Fa + gn * (wt + m6 - _e.r), oi = Ha + Zr * (wt + m6 - _e.r), bs = Sa + (gn < 0 ? -1 : 1) * Ft, Si = oi;
              ht === "edge" ? Ma = gn < 0 ? x6 + Qe : x6 + b6 - Qe : Ma = bs + (gn < 0 ? -at : at), Ua = Si, ja = [[Fa, Ha], [Sa, oi], [bs, Si]];
            }
            Ga = pa ? "center" : ht === "edge" ? gn > 0 ? "right" : "left" : gn > 0 ? "left" : "right";
          }
          var Ls = Math.PI, tl = 0, Hs = je.get("rotate");
          if (ks(Hs))
            tl = Hs * (Ls / 180);
          else if (Fe === "center")
            tl = 0;
          else if (Hs === "radial" || Hs === true) {
            var Of = gn < 0 ? -fn + Ls : -fn;
            tl = Of;
          } else if (Hs === "tangential" && Fe !== "outside" && Fe !== "outer") {
            var Xu = Math.atan2(gn, Zr);
            Xu < 0 && (Xu = Ls * 2 + Xu);
            var kh = Zr > 0;
            kh && (Xu = Ls + Xu), tl = Xu - Ls;
          }
          if (f6 = !!tl, xe.x = Ma, xe.y = Ua, xe.rotation = tl, xe.setStyle({ verticalAlign: "middle" }), pa) {
            xe.setStyle({ align: Ga });
            var ou = xe.states.select;
            ou && (ou.x += xe.x, ou.y += xe.y);
          } else {
            var lc = xe.getBoundingRect().clone();
            lc.applyTransform(xe.getComputedTransform());
            var Ku = (xe.style.margin || 0) + 2.1;
            lc.y -= Ku / 2, lc.height += Ku, t2.push({ label: xe, labelLine: Ae, position: Fe, len: wt, len2: Ft, minTurnAngle: bt.get("minTurnAngle"), maxSurfaceAngle: bt.get("maxSurfaceAngle"), surfaceNormal: new Bi(gn, Zr), linePoints: ja, textAlign: Ga, labelDistance: at, labelAlignTo: ht, edgeDistance: Qe, bleedMargin: en, rect: lc, unconstrainedWidth: lc.width, labelStyleWidth: xe.style.width });
          }
          pe.setTextConfig({ inside: pa });
        }
      }), !f6 && a.get("avoidLabelOverlap") && k8e(t2, s, u, m6, b6, M, x6, S);
      for (var R = 0; R < t2.length; R++) {
        var F = t2[R], j = F.label, $ = F.labelLine, K = isNaN(j.x) || isNaN(j.y);
        if (j) {
          j.setStyle({ align: F.textAlign }), K && (Ne(j.states, A6), j.ignore = true);
          var U = j.states.select;
          U && (U.x += j.x, U.y += j.y);
        }
        if ($) {
          var he = F.linePoints;
          K || !he ? (Ne($.states, A6), $.ignore = true) : (Pde(he, F.minTurnAngle), HFe(he, F.surfaceNormal, F.maxSurfaceAngle), $.setShape({ points: he }), j.__hostTarget.textGuideLineConfig = { anchor: new Bi(he[0][0], he[0][1]) });
        }
      }
    }
    function v5(a, r6, t2) {
      var s = a.get("borderRadius");
      if (s == null)
        return t2 ? { cornerRadius: 0 } : null;
      br(s) || (s = [s, s, s, s]);
      var u = Math.abs(r6.r || 0 - r6.r0 || 0);
      return { cornerRadius: wr(s, function(f6) {
        return wv(f6, u);
      }) };
    }
    var L8e = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this) || this;
        f6.z2 = 2;
        var d6 = new ms();
        return f6.setTextContent(d6), f6.updateData(t2, s, u, true), f6;
      }
      return r6.prototype.updateData = function(t2, s, u, f6) {
        var d6 = this, v6 = t2.hostModel, m6 = t2.getItemModel(s), b6 = m6.getModel("emphasis"), x6 = t2.getItemLayout(s), S = qn(v5(m6.getModel("itemStyle"), x6, true), x6);
        if (isNaN(S.startAngle)) {
          d6.setShape(S);
          return;
        }
        if (f6) {
          d6.setShape(S);
          var M = v6.getShallow("animationType");
          v6.ecModel.ssr ? (zu(d6, { scaleX: 0, scaleY: 0 }, v6, { dataIndex: s, isFrom: true }), d6.originX = S.cx, d6.originY = S.cy) : M === "scale" ? (d6.shape.r = x6.r0, zu(d6, { shape: { r: x6.r } }, v6, s)) : u != null ? (d6.setShape({ startAngle: u, endAngle: u }), zu(d6, { shape: { startAngle: x6.startAngle, endAngle: x6.endAngle } }, v6, s)) : (d6.shape.endAngle = x6.startAngle, fs(d6, { shape: { endAngle: x6.endAngle } }, v6, s));
        } else
          f0(d6), fs(d6, { shape: S }, v6, s);
        d6.useStyle(t2.getItemVisual(s, "style")), Ah(d6, m6);
        var A6 = (x6.startAngle + x6.endAngle) / 2, I = v6.get("selectedOffset"), R = Math.cos(A6) * I, F = Math.sin(A6) * I, j = m6.getShallow("cursor");
        j && d6.attr("cursor", j), this._updateLabel(v6, t2, s), d6.ensureState("emphasis").shape = qn({ r: x6.r + (b6.get("scale") && b6.get("scaleSize") || 0) }, v5(b6.getModel("itemStyle"), x6)), qn(d6.ensureState("select"), { x: R, y: F, shape: v5(m6.getModel(["select", "itemStyle"]), x6) }), qn(d6.ensureState("blur"), { shape: v5(m6.getModel(["blur", "itemStyle"]), x6) });
        var $ = d6.getTextGuideLine(), K = d6.getTextContent();
        $ && qn($.ensureState("select"), { x: R, y: F }), qn(K.ensureState("select"), { x: R, y: F }), Cc(this, b6.get("focus"), b6.get("blurScope"), b6.get("disabled"));
      }, r6.prototype._updateLabel = function(t2, s, u) {
        var f6 = this, d6 = s.getItemModel(u), v6 = d6.getModel("labelLine"), m6 = s.getItemVisual(u, "style"), b6 = m6 && m6.fill, x6 = m6 && m6.opacity;
        Bp(f6, hd(d6), { labelFetcher: s.hostModel, labelDataIndex: u, inheritColor: b6, defaultOpacity: x6, defaultText: t2.getFormattedLabel(u, "normal") || s.getName(u) });
        var S = f6.getTextContent();
        f6.setTextConfig({ position: null, rotation: null }), S.attr({ z2: 10 });
        var M = t2.get(["label", "position"]);
        if (M !== "outside" && M !== "outer")
          f6.removeTextGuideLine();
        else {
          var A6 = this.getTextGuideLine();
          A6 || (A6 = new Vp(), this.setTextGuideLine(A6)), HZ(this, $Z(d6), { stroke: b6, opacity: Uy(v6.get(["lineStyle", "opacity"]), x6, 1) });
        }
      }, r6;
    }(Np), O8e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.ignoreLabelLineUpdate = true, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        var d6 = t2.getData(), v6 = this._data, m6 = this.group, b6;
        if (!v6 && d6.count() > 0) {
          for (var x6 = d6.getItemLayout(0), S = 1; isNaN(x6 && x6.startAngle) && S < d6.count(); ++S)
            x6 = d6.getItemLayout(S);
          x6 && (b6 = x6.startAngle);
        }
        if (this._emptyCircleSector && m6.remove(this._emptyCircleSector), d6.count() === 0 && t2.get("showEmptyCircle")) {
          var M = new Np({ shape: jpe(t2, u) });
          M.useStyle(t2.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = M, m6.add(M);
        }
        d6.diff(v6).add(function(A6) {
          var I = new L8e(d6, A6, b6);
          d6.setItemGraphicEl(A6, I), m6.add(I);
        }).update(function(A6, I) {
          var R = v6.getItemGraphicEl(I);
          R.updateData(d6, A6, b6), R.off("click"), m6.add(R), d6.setItemGraphicEl(A6, R);
        }).remove(function(A6) {
          var I = v6.getItemGraphicEl(A6);
          iA(I, t2, A6);
        }).execute(), P8e(t2), t2.get("animationTypeUpdate") !== "expansion" && (this._data = d6);
      }, r6.prototype.dispose = function() {
      }, r6.prototype.containPoint = function(t2, s) {
        var u = s.getData(), f6 = u.getItemLayout(0);
        if (f6) {
          var d6 = t2[0] - f6.cx, v6 = t2[1] - f6.cy, m6 = Math.sqrt(d6 * d6 + v6 * v6);
          return m6 <= f6.r && m6 >= f6.r0;
        }
      }, r6.type = "pie", r6;
    }(bu), R8e = O8e;
    function g5(a, r6, t2) {
      r6 = br(r6) && { coordDimensions: r6 } || qn({ encodeDefine: a.getEncode() }, r6);
      var s = a.getSource(), u = zR(s, r6).dimensions, f6 = new Tv(u, a);
      return f6.initData(s, t2), f6;
    }
    var F8e = function() {
      function a(r6, t2) {
        this._getDataWithEncodedVisual = r6, this._getRawData = t2;
      }
      return a.prototype.getAllNames = function() {
        var r6 = this._getRawData();
        return r6.mapArray(r6.getName);
      }, a.prototype.containName = function(r6) {
        var t2 = this._getRawData();
        return t2.indexOfName(r6) >= 0;
      }, a.prototype.indexOfName = function(r6) {
        var t2 = this._getDataWithEncodedVisual();
        return t2.indexOfName(r6);
      }, a.prototype.getItemVisual = function(r6, t2) {
        var s = this._getDataWithEncodedVisual();
        return s.getItemVisual(r6, t2);
      }, a;
    }(), QR = F8e, N8e = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.init = function(t2) {
        a.prototype.init.apply(this, arguments), this.legendVisualProvider = new QR(Ca(this.getData, this), Ca(this.getRawData, this)), this._defaultLabelLine(t2);
      }, r6.prototype.mergeOption = function() {
        a.prototype.mergeOption.apply(this, arguments);
      }, r6.prototype.getInitialData = function() {
        return g5(this, { coordDimensions: ["value"], encodeDefaulter: Oi(VY, this) });
      }, r6.prototype.getDataParams = function(t2) {
        var s = this.getData(), u = a.prototype.getDataParams.call(this, t2), f6 = [];
        return s.each(s.mapDimension("value"), function(d6) {
          f6.push(d6);
        }), u.percent = cD(f6, t2, s.hostModel.get("percentPrecision")), u.$vars.push("percent"), u;
      }, r6.prototype._defaultLabelLine = function(t2) {
        ug(t2, "labelLine", ["show"]);
        var s = t2.labelLine, u = t2.emphasis.labelLine;
        s.show = s.show && t2.label.show, u.show = u.show && t2.emphasis.label.show;
      }, r6.type = "series.pie", r6.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, r6;
    }(sc), V8e = N8e;
    function z8e(a) {
      return { seriesType: a, reset: function(r6, t2) {
        var s = r6.getData();
        s.filterSelf(function(u) {
          var f6 = s.mapDimension("value"), d6 = s.get(f6, u);
          return !(ks(d6) && !isNaN(d6) && d6 < 0);
        });
      } };
    }
    function B8e(a) {
      a.registerChartView(R8e), a.registerSeriesModel(V8e), Yfe("pie", a.registerAction), a.registerLayout(Oi(T8e, "pie")), a.registerProcessor(JR("pie")), a.registerProcessor(z8e("pie"));
    }
    var j8e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.hasSymbolVisual = true, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        return Wx(null, this, { useEncodeDefaulter: true });
      }, r6.prototype.getProgressive = function() {
        var t2 = this.option.progressive;
        return t2 == null ? this.option.large ? 5e3 : this.get("progressive") : t2;
      }, r6.prototype.getProgressiveThreshold = function() {
        var t2 = this.option.progressiveThreshold;
        return t2 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : t2;
      }, r6.prototype.brushSelector = function(t2, s, u) {
        return u.point(s.getItemLayout(t2));
      }, r6.prototype.getZLevelKey = function() {
        return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
      }, r6.type = "series.scatter", r6.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], r6.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, r6;
    }(sc), G8e = j8e, Hpe = 4, W8e = function() {
      function a() {
      }
      return a;
    }(), H8e = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s._off = 0, s.hoverDataIdx = -1, s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new W8e();
      }, r6.prototype.reset = function() {
        this.notClear = false, this._off = 0;
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.points, f6 = s.size, d6 = this.symbolProxy, v6 = d6.shape, m6 = t2.getContext ? t2.getContext() : t2, b6 = m6 && f6[0] < Hpe, x6 = this.softClipShape, S;
        if (b6) {
          this._ctx = m6;
          return;
        }
        for (this._ctx = null, S = this._off; S < u.length; ) {
          var M = u[S++], A6 = u[S++];
          isNaN(M) || isNaN(A6) || x6 && !x6.contain(M, A6) || (v6.x = M - f6[0] / 2, v6.y = A6 - f6[1] / 2, v6.width = f6[0], v6.height = f6[1], d6.buildPath(t2, v6, true));
        }
        this.incremental && (this._off = S, this.notClear = true);
      }, r6.prototype.afterBrush = function() {
        var t2 = this.shape, s = t2.points, u = t2.size, f6 = this._ctx, d6 = this.softClipShape, v6;
        if (f6) {
          for (v6 = this._off; v6 < s.length; ) {
            var m6 = s[v6++], b6 = s[v6++];
            isNaN(m6) || isNaN(b6) || d6 && !d6.contain(m6, b6) || f6.fillRect(m6 - u[0] / 2, b6 - u[1] / 2, u[0], u[1]);
          }
          this.incremental && (this._off = v6, this.notClear = true);
        }
      }, r6.prototype.findDataIndex = function(t2, s) {
        for (var u = this.shape, f6 = u.points, d6 = u.size, v6 = Math.max(d6[0], 4), m6 = Math.max(d6[1], 4), b6 = f6.length / 2 - 1; b6 >= 0; b6--) {
          var x6 = b6 * 2, S = f6[x6] - v6 / 2, M = f6[x6 + 1] - m6 / 2;
          if (t2 >= S && s >= M && t2 <= S + v6 && s <= M + m6)
            return b6;
        }
        return -1;
      }, r6.prototype.contain = function(t2, s) {
        var u = this.transformCoordToLocal(t2, s), f6 = this.getBoundingRect();
        if (t2 = u[0], s = u[1], f6.contain(t2, s)) {
          var d6 = this.hoverDataIdx = this.findDataIndex(t2, s);
          return d6 >= 0;
        }
        return this.hoverDataIdx = -1, false;
      }, r6.prototype.getBoundingRect = function() {
        var t2 = this._rect;
        if (!t2) {
          for (var s = this.shape, u = s.points, f6 = s.size, d6 = f6[0], v6 = f6[1], m6 = 1 / 0, b6 = 1 / 0, x6 = -1 / 0, S = -1 / 0, M = 0; M < u.length; ) {
            var A6 = u[M++], I = u[M++];
            m6 = Math.min(A6, m6), x6 = Math.max(A6, x6), b6 = Math.min(I, b6), S = Math.max(I, S);
          }
          t2 = this._rect = new Qi(m6 - d6 / 2, b6 - v6 / 2, x6 - m6 + d6, S - b6 + v6);
        }
        return t2;
      }, r6;
    }(uo), $8e = function() {
      function a() {
        this.group = new bi();
      }
      return a.prototype.updateData = function(r6, t2) {
        this._clear();
        var s = this._create();
        s.setShape({ points: r6.getLayout("points") }), this._setCommon(s, r6, t2);
      }, a.prototype.updateLayout = function(r6) {
        var t2 = r6.getLayout("points");
        this.group.eachChild(function(s) {
          if (s.startIndex != null) {
            var u = (s.endIndex - s.startIndex) * 2, f6 = s.startIndex * 4 * 2;
            t2 = new Float32Array(t2.buffer, f6, u);
          }
          s.setShape("points", t2), s.reset();
        });
      }, a.prototype.incrementalPrepareUpdate = function(r6) {
        this._clear();
      }, a.prototype.incrementalUpdate = function(r6, t2, s) {
        var u = this._newAdded[0], f6 = t2.getLayout("points"), d6 = u && u.shape.points;
        if (d6 && d6.length < 2e4) {
          var v6 = d6.length, m6 = new Float32Array(v6 + f6.length);
          m6.set(d6), m6.set(f6, v6), u.endIndex = r6.end, u.setShape({ points: m6 });
        } else {
          this._newAdded = [];
          var b6 = this._create();
          b6.startIndex = r6.start, b6.endIndex = r6.end, b6.incremental = true, b6.setShape({ points: f6 }), this._setCommon(b6, t2, s);
        }
      }, a.prototype.eachRendered = function(r6) {
        this._newAdded[0] && r6(this._newAdded[0]);
      }, a.prototype._create = function() {
        var r6 = new H8e({ cursor: "default" });
        return this.group.add(r6), this._newAdded.push(r6), r6;
      }, a.prototype._setCommon = function(r6, t2, s) {
        var u = t2.hostModel;
        s = s || {};
        var f6 = t2.getVisual("symbolSize");
        r6.setShape("size", f6 instanceof Array ? f6 : [f6, f6]), r6.softClipShape = s.clipShape || null, r6.symbolProxy = Lf(t2.getVisual("symbol"), 0, 0, 0, 0), r6.setColor = r6.symbolProxy.setColor;
        var d6 = r6.shape.size[0] < Hpe;
        r6.useStyle(u.getModel("itemStyle").getItemStyle(d6 ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
        var v6 = t2.getVisual("style"), m6 = v6 && v6.fill;
        m6 && r6.setColor(m6);
        var b6 = ii(r6);
        b6.seriesIndex = u.seriesIndex, r6.on("mousemove", function(x6) {
          b6.dataIndex = null;
          var S = r6.hoverDataIdx;
          S >= 0 && (b6.dataIndex = S + (r6.startIndex || 0));
        });
      }, a.prototype.remove = function() {
        this._clear();
      }, a.prototype._clear = function() {
        this._newAdded = [], this.group.removeAll();
      }, a;
    }(), U8e = $8e, q8e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this._updateSymbolDraw(f6, t2);
        d6.updateData(f6, { clipShape: this._getClipShape(t2) }), this._finished = true;
      }, r6.prototype.incrementalPrepareRender = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this._updateSymbolDraw(f6, t2);
        d6.incrementalPrepareUpdate(f6), this._finished = false;
      }, r6.prototype.incrementalRender = function(t2, s, u) {
        this._symbolDraw.incrementalUpdate(t2, s.getData(), { clipShape: this._getClipShape(s) }), this._finished = t2.end === s.getData().count();
      }, r6.prototype.updateTransform = function(t2, s, u) {
        var f6 = t2.getData();
        if (this.group.dirty(), !this._finished || f6.count() > 1e4)
          return { update: true };
        var d6 = KR("").reset(t2, s, u);
        d6.progress && d6.progress({ start: 0, end: f6.count(), count: f6.count() }, f6), this._symbolDraw.updateLayout(f6);
      }, r6.prototype.eachRendered = function(t2) {
        this._symbolDraw && this._symbolDraw.eachRendered(t2);
      }, r6.prototype._getClipShape = function(t2) {
        var s = t2.coordinateSystem, u = s && s.getArea && s.getArea();
        return t2.get("clip", true) ? u : null;
      }, r6.prototype._updateSymbolDraw = function(t2, s) {
        var u = this._symbolDraw, f6 = s.pipelineContext, d6 = f6.large;
        return (!u || d6 !== this._isLargeDraw) && (u && u.remove(), u = this._symbolDraw = d6 ? new U8e() : new XR(), this._isLargeDraw = d6, this.group.removeAll()), this.group.add(u.group), u;
      }, r6.prototype.remove = function(t2, s) {
        this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
      }, r6.prototype.dispose = function() {
      }, r6.type = "scatter", r6;
    }(bu), Y8e = q8e, Z8e = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.type = "grid", r6.dependencies = ["xAxis", "yAxis"], r6.layoutMode = "box", r6.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, r6;
    }(Ps), X8e = Z8e, fX = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.getCoordSysModel = function() {
        return this.getReferringComponents("grid", Lc).models[0];
      }, r6.type = "cartesian2dAxis", r6;
    }(Ps);
    Dc(fX, GR);
    var $pe = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, K8e = Di({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, $pe), hX = Di({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, $pe), J8e = Di({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, hX), Q8e = ei({ logBase: 10 }, hX), Upe = { category: K8e, value: hX, time: J8e, log: Q8e }, e9e = { value: 1, category: 1, time: 1, log: 1 };
    function m5(a, r6, t2, s) {
      Ne(e9e, function(u, f6) {
        var d6 = Di(Di({}, Upe[f6], true), s, true), v6 = function(m6) {
          tt(b6, m6);
          function b6() {
            var x6 = m6 !== null && m6.apply(this, arguments) || this;
            return x6.type = r6 + "Axis." + f6, x6;
          }
          return b6.prototype.mergeDefaultAndTheme = function(x6, S) {
            var M = gR(this), A6 = M ? JD(x6) : {}, I = S.getTheme();
            Di(x6, I.get(f6 + "Axis")), Di(x6, this.getDefaultOption()), x6.type = qpe(x6), M && Z2(x6, A6, M);
          }, b6.prototype.optionUpdated = function() {
            var x6 = this.option;
            x6.type === "category" && (this.__ordinalMeta = PZ.createByAxisModel(this));
          }, b6.prototype.getCategories = function(x6) {
            var S = this.option;
            if (S.type === "category")
              return x6 ? S.data : this.__ordinalMeta.categories;
          }, b6.prototype.getOrdinalMeta = function() {
            return this.__ordinalMeta;
          }, b6.type = r6 + "Axis." + f6, b6.defaultOption = d6, b6;
        }(t2);
        a.registerComponentModel(v6);
      }), a.registerSubTypeDefaulter(r6 + "Axis", qpe);
    }
    function qpe(a) {
      return a.type || (a.data ? "category" : "value");
    }
    var t9e = function() {
      function a(r6) {
        this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = r6 || "";
      }
      return a.prototype.getAxis = function(r6) {
        return this._axes[r6];
      }, a.prototype.getAxes = function() {
        return wr(this._dimList, function(r6) {
          return this._axes[r6];
        }, this);
      }, a.prototype.getAxesByScale = function(r6) {
        return r6 = r6.toLowerCase(), gl(this.getAxes(), function(t2) {
          return t2.scale.type === r6;
        });
      }, a.prototype.addAxis = function(r6) {
        var t2 = r6.dim;
        this._axes[t2] = r6, this._dimList.push(t2);
      }, a;
    }(), n9e = t9e, dX = ["x", "y"];
    function Ype(a) {
      return a.type === "interval" || a.type === "time";
    }
    var r9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "cartesian2d", t2.dimensions = dX, t2;
      }
      return r6.prototype.calcAffineTransform = function() {
        this._transform = this._invTransform = null;
        var t2 = this.getAxis("x").scale, s = this.getAxis("y").scale;
        if (!(!Ype(t2) || !Ype(s))) {
          var u = t2.getExtent(), f6 = s.getExtent(), d6 = this.dataToPoint([u[0], f6[0]]), v6 = this.dataToPoint([u[1], f6[1]]), m6 = u[1] - u[0], b6 = f6[1] - f6[0];
          if (!(!m6 || !b6)) {
            var x6 = (v6[0] - d6[0]) / m6, S = (v6[1] - d6[1]) / b6, M = d6[0] - u[0] * x6, A6 = d6[1] - f6[0] * S, I = this._transform = [x6, 0, 0, S, M, A6];
            this._invTransform = px([], I);
          }
        }
      }, r6.prototype.getBaseAxis = function() {
        return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
      }, r6.prototype.containPoint = function(t2) {
        var s = this.getAxis("x"), u = this.getAxis("y");
        return s.contain(s.toLocalCoord(t2[0])) && u.contain(u.toLocalCoord(t2[1]));
      }, r6.prototype.containData = function(t2) {
        return this.getAxis("x").containData(t2[0]) && this.getAxis("y").containData(t2[1]);
      }, r6.prototype.dataToPoint = function(t2, s, u) {
        u = u || [];
        var f6 = t2[0], d6 = t2[1];
        if (this._transform && f6 != null && isFinite(f6) && d6 != null && isFinite(d6))
          return Qf(u, t2, this._transform);
        var v6 = this.getAxis("x"), m6 = this.getAxis("y");
        return u[0] = v6.toGlobalCoord(v6.dataToCoord(f6, s)), u[1] = m6.toGlobalCoord(m6.dataToCoord(d6, s)), u;
      }, r6.prototype.clampData = function(t2, s) {
        var u = this.getAxis("x").scale, f6 = this.getAxis("y").scale, d6 = u.getExtent(), v6 = f6.getExtent(), m6 = u.parse(t2[0]), b6 = f6.parse(t2[1]);
        return s = s || [], s[0] = Math.min(Math.max(Math.min(d6[0], d6[1]), m6), Math.max(d6[0], d6[1])), s[1] = Math.min(Math.max(Math.min(v6[0], v6[1]), b6), Math.max(v6[0], v6[1])), s;
      }, r6.prototype.pointToData = function(t2, s) {
        var u = [];
        if (this._invTransform)
          return Qf(u, t2, this._invTransform);
        var f6 = this.getAxis("x"), d6 = this.getAxis("y");
        return u[0] = f6.coordToData(f6.toLocalCoord(t2[0]), s), u[1] = d6.coordToData(d6.toLocalCoord(t2[1]), s), u;
      }, r6.prototype.getOtherAxis = function(t2) {
        return this.getAxis(t2.dim === "x" ? "y" : "x");
      }, r6.prototype.getArea = function() {
        var t2 = this.getAxis("x").getGlobalExtent(), s = this.getAxis("y").getGlobalExtent(), u = Math.min(t2[0], t2[1]), f6 = Math.min(s[0], s[1]), d6 = Math.max(t2[0], t2[1]) - u, v6 = Math.max(s[0], s[1]) - f6;
        return new Qi(u, f6, d6, v6);
      }, r6;
    }(n9e), a9e = r9e, i9e = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6, d6) {
        var v6 = a.call(this, t2, s, u) || this;
        return v6.index = 0, v6.type = f6 || "value", v6.position = d6 || "bottom", v6;
      }
      return r6.prototype.isHorizontal = function() {
        var t2 = this.position;
        return t2 === "top" || t2 === "bottom";
      }, r6.prototype.getGlobalExtent = function(t2) {
        var s = this.getExtent();
        return s[0] = this.toGlobalCoord(s[0]), s[1] = this.toGlobalCoord(s[1]), t2 && s[0] > s[1] && s.reverse(), s;
      }, r6.prototype.pointToData = function(t2, s) {
        return this.coordToData(this.toLocalCoord(t2[this.dim === "x" ? 0 : 1]), s);
      }, r6.prototype.setCategorySortInfo = function(t2) {
        if (this.type !== "category")
          return false;
        this.model.option.categorySortInfo = t2, this.scale.setSortInfo(t2);
      }, r6;
    }(c1), o9e = i9e;
    function pX(a, r6, t2) {
      t2 = t2 || {};
      var s = a.coordinateSystem, u = r6.axis, f6 = {}, d6 = u.getAxesOnZeroOf()[0], v6 = u.position, m6 = d6 ? "onZero" : v6, b6 = u.dim, x6 = s.getRect(), S = [x6.x, x6.x + x6.width, x6.y, x6.y + x6.height], M = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, A6 = r6.get("offset") || 0, I = b6 === "x" ? [S[2] - A6, S[3] + A6] : [S[0] - A6, S[1] + A6];
      if (d6) {
        var R = d6.toGlobalCoord(d6.dataToCoord(0));
        I[M.onZero] = Math.max(Math.min(R, I[1]), I[0]);
      }
      f6.position = [b6 === "y" ? I[M[m6]] : S[0], b6 === "x" ? I[M[m6]] : S[3]], f6.rotation = Math.PI / 2 * (b6 === "x" ? 0 : 1);
      var F = { top: -1, bottom: 1, left: -1, right: 1 };
      f6.labelDirection = f6.tickDirection = f6.nameDirection = F[v6], f6.labelOffset = d6 ? I[M[v6]] - I[M.onZero] : 0, r6.get(["axisTick", "inside"]) && (f6.tickDirection = -f6.tickDirection), Jf(t2.labelInside, r6.get(["axisLabel", "inside"])) && (f6.labelDirection = -f6.labelDirection);
      var j = r6.get(["axisLabel", "rotate"]);
      return f6.labelRotate = m6 === "top" ? -j : j, f6.z2 = 1, f6;
    }
    function Zpe(a) {
      return a.get("coordinateSystem") === "cartesian2d";
    }
    function Xpe(a) {
      var r6 = { xAxisModel: null, yAxisModel: null };
      return Ne(r6, function(t2, s) {
        var u = s.replace(/Model$/, ""), f6 = a.getReferringComponents(u, Lc).models[0];
        r6[s] = f6;
      }), r6;
    }
    var vX = Math.log;
    function Kpe(a, r6, t2) {
      var s = nS.prototype, u = s.getTicks.call(t2), f6 = s.getTicks.call(t2, true), d6 = u.length - 1, v6 = s.getInterval.call(t2), m6 = dde(a, r6), b6 = m6.extent, x6 = m6.fixMin, S = m6.fixMax;
      if (a.type === "log") {
        var M = vX(a.base);
        b6 = [vX(b6[0]) / M, vX(b6[1]) / M];
      }
      a.setExtent(b6[0], b6[1]), a.calcNiceExtent({ splitNumber: d6, fixMin: x6, fixMax: S });
      var A6 = s.getExtent.call(a);
      x6 && (b6[0] = A6[0]), S && (b6[1] = A6[1]);
      var I = s.getInterval.call(a), R = b6[0], F = b6[1];
      if (x6 && S)
        I = (F - R) / d6;
      else if (x6)
        for (F = b6[0] + I * d6; F < b6[1] && isFinite(F) && isFinite(b6[1]); )
          I = OZ(I), F = b6[0] + I * d6;
      else if (S)
        for (R = b6[1] - I * d6; R > b6[0] && isFinite(R) && isFinite(b6[0]); )
          I = OZ(I), R = b6[1] - I * d6;
      else {
        var j = a.getTicks().length - 1;
        j > d6 && (I = OZ(I));
        var $ = I * d6;
        F = Math.ceil(b6[1] / I) * I, R = Sc(F - $), R < 0 && b6[0] >= 0 ? (R = 0, F = Sc($)) : F > 0 && b6[1] <= 0 && (F = 0, R = -Sc($));
      }
      var K = (u[0].value - f6[0].value) / v6, U = (u[d6].value - f6[d6].value) / v6;
      s.setExtent.call(a, R + I * K, F + I * U), s.setInterval.call(a, I), (K || U) && s.setNiceExtent.call(a, R + I, F - I);
    }
    var s9e = function() {
      function a(r6, t2, s) {
        this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = dX, this._initCartesian(r6, t2, s), this.model = r6;
      }
      return a.prototype.getRect = function() {
        return this._rect;
      }, a.prototype.update = function(r6, t2) {
        var s = this._axesMap;
        this._updateScale(r6, this.model);
        function u(d6) {
          var v6, m6 = Po(d6), b6 = m6.length;
          if (b6) {
            for (var x6 = [], S = b6 - 1; S >= 0; S--) {
              var M = +m6[S], A6 = d6[M], I = A6.model, R = A6.scale;
              LZ(R) && I.get("alignTicks") && I.get("interval") == null ? x6.push(A6) : (h5(R, I), LZ(R) && (v6 = A6));
            }
            x6.length && (v6 || (v6 = x6.pop(), h5(v6.scale, v6.model)), Ne(x6, function(F) {
              Kpe(F.scale, F.model, v6.scale);
            }));
          }
        }
        u(s.x), u(s.y);
        var f6 = {};
        Ne(s.x, function(d6) {
          Jpe(s, "y", d6, f6);
        }), Ne(s.y, function(d6) {
          Jpe(s, "x", d6, f6);
        }), this.resize(this.model, t2);
      }, a.prototype.resize = function(r6, t2, s) {
        var u = r6.getBoxLayoutParams(), f6 = !s && r6.get("containLabel"), d6 = ah(u, { width: t2.getWidth(), height: t2.getHeight() });
        this._rect = d6;
        var v6 = this._axesList;
        m6(), f6 && (Ne(v6, function(b6) {
          if (!b6.model.get(["axisLabel", "inside"])) {
            var x6 = _Fe(b6);
            if (x6) {
              var S = b6.isHorizontal() ? "height" : "width", M = b6.model.get(["axisLabel", "margin"]);
              d6[S] -= x6[S] + M, b6.position === "top" ? d6.y += x6.height + M : b6.position === "left" && (d6.x += x6.width + M);
            }
          }
        }), m6()), Ne(this._coordsList, function(b6) {
          b6.calcAffineTransform();
        });
        function m6() {
          Ne(v6, function(b6) {
            var x6 = b6.isHorizontal(), S = x6 ? [0, d6.width] : [0, d6.height], M = b6.inverse ? 1 : 0;
            b6.setExtent(S[M], S[1 - M]), l9e(b6, x6 ? d6.x : d6.y);
          });
        }
      }, a.prototype.getAxis = function(r6, t2) {
        var s = this._axesMap[r6];
        if (s != null)
          return s[t2 || 0];
      }, a.prototype.getAxes = function() {
        return this._axesList.slice();
      }, a.prototype.getCartesian = function(r6, t2) {
        if (r6 != null && t2 != null) {
          var s = "x" + r6 + "y" + t2;
          return this._coordsMap[s];
        }
        ui(r6) && (t2 = r6.yAxisIndex, r6 = r6.xAxisIndex);
        for (var u = 0, f6 = this._coordsList; u < f6.length; u++)
          if (f6[u].getAxis("x").index === r6 || f6[u].getAxis("y").index === t2)
            return f6[u];
      }, a.prototype.getCartesians = function() {
        return this._coordsList.slice();
      }, a.prototype.convertToPixel = function(r6, t2, s) {
        var u = this._findConvertTarget(t2);
        return u.cartesian ? u.cartesian.dataToPoint(s) : u.axis ? u.axis.toGlobalCoord(u.axis.dataToCoord(s)) : null;
      }, a.prototype.convertFromPixel = function(r6, t2, s) {
        var u = this._findConvertTarget(t2);
        return u.cartesian ? u.cartesian.pointToData(s) : u.axis ? u.axis.coordToData(u.axis.toLocalCoord(s)) : null;
      }, a.prototype._findConvertTarget = function(r6) {
        var t2 = r6.seriesModel, s = r6.xAxisModel || t2 && t2.getReferringComponents("xAxis", Lc).models[0], u = r6.yAxisModel || t2 && t2.getReferringComponents("yAxis", Lc).models[0], f6 = r6.gridModel, d6 = this._coordsList, v6, m6;
        if (t2)
          v6 = t2.coordinateSystem, Vi(d6, v6) < 0 && (v6 = null);
        else if (s && u)
          v6 = this.getCartesian(s.componentIndex, u.componentIndex);
        else if (s)
          m6 = this.getAxis("x", s.componentIndex);
        else if (u)
          m6 = this.getAxis("y", u.componentIndex);
        else if (f6) {
          var b6 = f6.coordinateSystem;
          b6 === this && (v6 = this._coordsList[0]);
        }
        return { cartesian: v6, axis: m6 };
      }, a.prototype.containPoint = function(r6) {
        var t2 = this._coordsList[0];
        if (t2)
          return t2.containPoint(r6);
      }, a.prototype._initCartesian = function(r6, t2, s) {
        var u = this, f6 = this, d6 = { left: false, right: false, top: false, bottom: false }, v6 = { x: {}, y: {} }, m6 = { x: 0, y: 0 };
        if (t2.eachComponent("xAxis", b6("x"), this), t2.eachComponent("yAxis", b6("y"), this), !m6.x || !m6.y) {
          this._axesMap = {}, this._axesList = [];
          return;
        }
        this._axesMap = v6, Ne(v6.x, function(x6, S) {
          Ne(v6.y, function(M, A6) {
            var I = "x" + S + "y" + A6, R = new a9e(I);
            R.master = u, R.model = r6, u._coordsMap[I] = R, u._coordsList.push(R), R.addAxis(x6), R.addAxis(M);
          });
        });
        function b6(x6) {
          return function(S, M) {
            if (gX(S, r6)) {
              var A6 = S.get("position");
              x6 === "x" ? A6 !== "top" && A6 !== "bottom" && (A6 = d6.bottom ? "top" : "bottom") : A6 !== "left" && A6 !== "right" && (A6 = d6.left ? "right" : "left"), d6[A6] = true;
              var I = new o9e(x6, WV(S), [0, 0], S.get("type"), A6), R = I.type === "category";
              I.onBand = R && S.get("boundaryGap"), I.inverse = S.get("inverse"), S.axis = I, I.model = S, I.grid = f6, I.index = M, f6._axesList.push(I), v6[x6][M] = I, m6[x6]++;
            }
          };
        }
      }, a.prototype._updateScale = function(r6, t2) {
        Ne(this._axesList, function(u) {
          if (u.scale.setExtent(1 / 0, -1 / 0), u.type === "category") {
            var f6 = u.model.get("categorySortInfo");
            u.scale.setSortInfo(f6);
          }
        }), r6.eachSeries(function(u) {
          if (Zpe(u)) {
            var f6 = Xpe(u), d6 = f6.xAxisModel, v6 = f6.yAxisModel;
            if (!gX(d6, t2) || !gX(v6, t2))
              return;
            var m6 = this.getCartesian(d6.componentIndex, v6.componentIndex), b6 = u.getData(), x6 = m6.getAxis("x"), S = m6.getAxis("y");
            s(b6, x6), s(b6, S);
          }
        }, this);
        function s(u, f6) {
          Ne(HV(u, f6.dim), function(d6) {
            f6.scale.unionExtentFromData(u, d6);
          });
        }
      }, a.prototype.getTooltipAxes = function(r6) {
        var t2 = [], s = [];
        return Ne(this.getCartesians(), function(u) {
          var f6 = r6 != null && r6 !== "auto" ? u.getAxis(r6) : u.getBaseAxis(), d6 = u.getOtherAxis(f6);
          Vi(t2, f6) < 0 && t2.push(f6), Vi(s, d6) < 0 && s.push(d6);
        }), { baseAxes: t2, otherAxes: s };
      }, a.create = function(r6, t2) {
        var s = [];
        return r6.eachComponent("grid", function(u, f6) {
          var d6 = new a(u, r6, t2);
          d6.name = "grid_" + f6, d6.resize(u, t2, true), u.coordinateSystem = d6, s.push(d6);
        }), r6.eachSeries(function(u) {
          if (Zpe(u)) {
            var f6 = Xpe(u), d6 = f6.xAxisModel, v6 = f6.yAxisModel, m6 = d6.getCoordSysModel(), b6 = m6.coordinateSystem;
            u.coordinateSystem = b6.getCartesian(d6.componentIndex, v6.componentIndex);
          }
        }), s;
      }, a.dimensions = dX, a;
    }();
    function gX(a, r6) {
      return a.getCoordSysModel() === r6;
    }
    function Jpe(a, r6, t2, s) {
      t2.getAxesOnZeroOf = function() {
        return f6 ? [f6] : [];
      };
      var u = a[r6], f6, d6 = t2.model, v6 = d6.get(["axisLine", "onZero"]), m6 = d6.get(["axisLine", "onZeroAxisIndex"]);
      if (!v6)
        return;
      if (m6 != null)
        Qpe(u[m6]) && (f6 = u[m6]);
      else
        for (var b6 in u)
          if (u.hasOwnProperty(b6) && Qpe(u[b6]) && !s[x6(u[b6])]) {
            f6 = u[b6];
            break;
          }
      f6 && (s[x6(f6)] = true);
      function x6(S) {
        return S.dim + "_" + S.index;
      }
    }
    function Qpe(a) {
      return a && a.type !== "category" && a.type !== "time" && bFe(a);
    }
    function l9e(a, r6) {
      var t2 = a.getExtent(), s = t2[0] + t2[1];
      a.toGlobalCoord = a.dim === "x" ? function(u) {
        return u + r6;
      } : function(u) {
        return s - u + r6;
      }, a.toLocalCoord = a.dim === "x" ? function(u) {
        return u - r6;
      } : function(u) {
        return s - u + r6;
      };
    }
    var u9e = s9e, oS = Math.PI, CA = function() {
      function a(r6, t2) {
        this.group = new bi(), this.opt = t2, this.axisModel = r6, ei(t2, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
          return true;
        } });
        var s = new bi({ x: t2.position[0], y: t2.position[1], rotation: t2.rotation });
        s.updateTransform(), this._transformGroup = s;
      }
      return a.prototype.hasBuilder = function(r6) {
        return !!eve[r6];
      }, a.prototype.add = function(r6) {
        eve[r6](this.opt, this.axisModel, this.group, this._transformGroup);
      }, a.prototype.getGroup = function() {
        return this.group;
      }, a.innerTextLayout = function(r6, t2, s) {
        var u = W9(t2 - r6), f6, d6;
        return jM(u) ? (d6 = s > 0 ? "top" : "bottom", f6 = "center") : jM(u - oS) ? (d6 = s > 0 ? "bottom" : "top", f6 = "center") : (d6 = "middle", u > 0 && u < oS ? f6 = s > 0 ? "right" : "left" : f6 = s > 0 ? "left" : "right"), { rotation: u, textAlign: f6, textVerticalAlign: d6 };
      }, a.makeAxisEventDataBase = function(r6) {
        var t2 = { componentType: r6.mainType, componentIndex: r6.componentIndex };
        return t2[r6.mainType + "Index"] = r6.componentIndex, t2;
      }, a.isLabelSilent = function(r6) {
        var t2 = r6.get("tooltip");
        return r6.get("silent") || !(r6.get("triggerEvent") || t2 && t2.show);
      }, a;
    }(), eve = { axisLine: function(a, r6, t2, s) {
      var u = r6.get(["axisLine", "show"]);
      if (u === "auto" && a.handleAutoShown && (u = a.handleAutoShown("axisLine")), !!u) {
        var f6 = r6.axis.getExtent(), d6 = s.transform, v6 = [f6[0], 0], m6 = [f6[1], 0];
        d6 && (Qf(v6, v6, d6), Qf(m6, m6, d6));
        var b6 = qn({ lineCap: "round" }, r6.getModel(["axisLine", "lineStyle"]).getLineStyle()), x6 = new rh({ subPixelOptimize: true, shape: { x1: v6[0], y1: v6[1], x2: m6[0], y2: m6[1] }, style: b6, strokeContainThreshold: a.strokeContainThreshold || 5, silent: true, z2: 1 });
        x6.anid = "line", t2.add(x6);
        var S = r6.get(["axisLine", "symbol"]);
        if (S != null) {
          var M = r6.get(["axisLine", "symbolSize"]);
          _a2(S) && (S = [S, S]), (_a2(M) || ks(M)) && (M = [M, M]);
          var A6 = l5(r6.get(["axisLine", "symbolOffset"]) || 0, M), I = M[0], R = M[1];
          Ne([{ rotate: a.rotation + Math.PI / 2, offset: A6[0], r: 0 }, { rotate: a.rotation - Math.PI / 2, offset: A6[1], r: Math.sqrt((v6[0] - m6[0]) * (v6[0] - m6[0]) + (v6[1] - m6[1]) * (v6[1] - m6[1])) }], function(F, j) {
            if (S[j] !== "none" && S[j] != null) {
              var $ = Lf(S[j], -I / 2, -R / 2, I, R, b6.stroke, true), K = F.r + F.offset;
              $.attr({ rotation: F.rotate, x: v6[0] + K * Math.cos(a.rotation), y: v6[1] - K * Math.sin(a.rotation), silent: true, z2: 11 }), t2.add($);
            }
          });
        }
      }
    }, axisTickLabel: function(a, r6, t2, s) {
      var u = h9e(t2, s, r6, a), f6 = p9e(t2, s, r6, a);
      if (f9e(r6, f6, u), d9e(t2, s, r6, a.tickDirection), r6.get(["axisLabel", "hideOverlap"])) {
        var d6 = Ode(wr(f6, function(v6) {
          return { label: v6, priority: v6.z2, defaultAttr: { ignore: v6.ignore } };
        }));
        Nde(d6);
      }
    }, axisName: function(a, r6, t2, s) {
      var u = Jf(a.axisName, r6.get("name"));
      if (u) {
        var f6 = r6.get("nameLocation"), d6 = a.nameDirection, v6 = r6.getModel("nameTextStyle"), m6 = r6.get("nameGap") || 0, b6 = r6.axis.getExtent(), x6 = b6[0] > b6[1] ? -1 : 1, S = [f6 === "start" ? b6[0] - x6 * m6 : f6 === "end" ? b6[1] + x6 * m6 : (b6[0] + b6[1]) / 2, nve(f6) ? a.labelOffset + d6 * m6 : 0], M, A6 = r6.get("nameRotate");
        A6 != null && (A6 = A6 * oS / 180);
        var I;
        nve(f6) ? M = CA.innerTextLayout(a.rotation, A6 != null ? A6 : a.rotation, d6) : (M = c9e(a.rotation, f6, A6 || 0, b6), I = a.axisNameAvailableWidth, I != null && (I = Math.abs(I / Math.sin(M.rotation)), !isFinite(I) && (I = null)));
        var R = v6.getFont(), F = r6.get("nameTruncate", true) || {}, j = F.ellipsis, $ = Jf(a.nameTruncateMaxWidth, F.maxWidth, I), K = new ms({ x: S[0], y: S[1], rotation: M.rotation, silent: CA.isLabelSilent(r6), style: yf(v6, { text: u, font: R, overflow: "truncate", width: $, ellipsis: j, fill: v6.getTextColor() || r6.get(["axisLine", "lineStyle", "color"]), align: v6.get("align") || M.textAlign, verticalAlign: v6.get("verticalAlign") || M.textVerticalAlign }), z2: 1 });
        if (fd({ el: K, componentModel: r6, itemName: u }), K.__fullText = u, K.anid = "name", r6.get("triggerEvent")) {
          var U = CA.makeAxisEventDataBase(r6);
          U.targetType = "axisName", U.name = u, ii(K).eventData = U;
        }
        s.add(K), K.updateTransform(), t2.add(K), K.decomposeTransform();
      }
    } };
    function c9e(a, r6, t2, s) {
      var u = W9(t2 - a), f6, d6, v6 = s[0] > s[1], m6 = r6 === "start" && !v6 || r6 !== "start" && v6;
      return jM(u - oS / 2) ? (d6 = m6 ? "bottom" : "top", f6 = "center") : jM(u - oS * 1.5) ? (d6 = m6 ? "top" : "bottom", f6 = "center") : (d6 = "middle", u < oS * 1.5 && u > oS / 2 ? f6 = m6 ? "left" : "right" : f6 = m6 ? "right" : "left"), { rotation: u, textAlign: f6, textVerticalAlign: d6 };
    }
    function f9e(a, r6, t2) {
      if (!pde(a.axis)) {
        var s = a.get(["axisLabel", "showMinLabel"]), u = a.get(["axisLabel", "showMaxLabel"]);
        r6 = r6 || [], t2 = t2 || [];
        var f6 = r6[0], d6 = r6[1], v6 = r6[r6.length - 1], m6 = r6[r6.length - 2], b6 = t2[0], x6 = t2[1], S = t2[t2.length - 1], M = t2[t2.length - 2];
        s === false ? (Fm(f6), Fm(b6)) : tve(f6, d6) && (s ? (Fm(d6), Fm(x6)) : (Fm(f6), Fm(b6))), u === false ? (Fm(v6), Fm(S)) : tve(m6, v6) && (u ? (Fm(m6), Fm(M)) : (Fm(v6), Fm(S)));
      }
    }
    function Fm(a) {
      a && (a.ignore = true);
    }
    function tve(a, r6) {
      var t2 = a && a.getBoundingRect().clone(), s = r6 && r6.getBoundingRect().clone();
      if (!(!t2 || !s)) {
        var u = kM([]);
        return yb(u, u, -a.rotation), t2.applyTransform(Qy([], u, a.getLocalTransform())), s.applyTransform(Qy([], u, r6.getLocalTransform())), t2.intersect(s);
      }
    }
    function nve(a) {
      return a === "middle" || a === "center";
    }
    function rve(a, r6, t2, s, u) {
      for (var f6 = [], d6 = [], v6 = [], m6 = 0; m6 < a.length; m6++) {
        var b6 = a[m6].coord;
        d6[0] = b6, d6[1] = 0, v6[0] = b6, v6[1] = t2, r6 && (Qf(d6, d6, r6), Qf(v6, v6, r6));
        var x6 = new rh({ subPixelOptimize: true, shape: { x1: d6[0], y1: d6[1], x2: v6[0], y2: v6[1] }, style: s, z2: 2, autoBatch: true, silent: true });
        x6.anid = u + "_" + a[m6].tickValue, f6.push(x6);
      }
      return f6;
    }
    function h9e(a, r6, t2, s) {
      var u = t2.axis, f6 = t2.getModel("axisTick"), d6 = f6.get("show");
      if (d6 === "auto" && s.handleAutoShown && (d6 = s.handleAutoShown("axisTick")), !(!d6 || u.scale.isBlank())) {
        for (var v6 = f6.getModel("lineStyle"), m6 = s.tickDirection * f6.get("length"), b6 = u.getTicksCoords(), x6 = rve(b6, r6.transform, m6, ei(v6.getLineStyle(), { stroke: t2.get(["axisLine", "lineStyle", "color"]) }), "ticks"), S = 0; S < x6.length; S++)
          a.add(x6[S]);
        return x6;
      }
    }
    function d9e(a, r6, t2, s) {
      var u = t2.axis, f6 = t2.getModel("minorTick");
      if (!(!f6.get("show") || u.scale.isBlank())) {
        var d6 = u.getMinorTicksCoords();
        if (d6.length)
          for (var v6 = f6.getModel("lineStyle"), m6 = s * f6.get("length"), b6 = ei(v6.getLineStyle(), ei(t2.getModel("axisTick").getLineStyle(), { stroke: t2.get(["axisLine", "lineStyle", "color"]) })), x6 = 0; x6 < d6.length; x6++)
            for (var S = rve(d6[x6], r6.transform, m6, b6, "minorticks_" + x6), M = 0; M < S.length; M++)
              a.add(S[M]);
      }
    }
    function p9e(a, r6, t2, s) {
      var u = t2.axis, f6 = Jf(s.axisLabelShow, t2.get(["axisLabel", "show"]));
      if (!(!f6 || u.scale.isBlank())) {
        var d6 = t2.getModel("axisLabel"), v6 = d6.get("margin"), m6 = u.getViewLabels(), b6 = (Jf(s.labelRotate, d6.get("rotate")) || 0) * oS / 180, x6 = CA.innerTextLayout(s.rotation, b6, s.labelDirection), S = t2.getCategories && t2.getCategories(true), M = [], A6 = CA.isLabelSilent(t2), I = t2.get("triggerEvent");
        return Ne(m6, function(R, F) {
          var j = u.scale.type === "ordinal" ? u.scale.getRawOrdinalNumber(R.tickValue) : R.tickValue, $ = R.formattedLabel, K = R.rawLabel, U = d6;
          if (S && S[j]) {
            var he = S[j];
            ui(he) && he.textStyle && (U = new yu(he.textStyle, d6, t2.ecModel));
          }
          var ue = U.getTextColor() || t2.get(["axisLine", "lineStyle", "color"]), pe = u.dataToCoord(j), _e = new ms({ x: pe, y: s.labelOffset + s.labelDirection * v6, rotation: x6.rotation, silent: A6, z2: 10 + (R.level || 0), style: yf(U, { text: $, align: U.getShallow("align", true) || x6.textAlign, verticalAlign: U.getShallow("verticalAlign", true) || U.getShallow("baseline", true) || x6.textVerticalAlign, fill: ti(ue) ? ue(u.type === "category" ? K : u.type === "value" ? j + "" : j, F) : ue }) });
          if (_e.anid = "label_" + j, I) {
            var xe = CA.makeAxisEventDataBase(t2);
            xe.targetType = "axisLabel", xe.value = K, xe.tickIndex = F, u.type === "category" && (xe.dataIndex = j), ii(_e).eventData = xe;
          }
          r6.add(_e), _e.updateTransform(), M.push(_e), a.add(_e), _e.decomposeTransform();
        }), M;
      }
    }
    var Ux = CA;
    function v9e(a, r6) {
      var t2 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
      return g9e(t2, a, r6), t2.seriesInvolved && y9e(t2, a), t2;
    }
    function g9e(a, r6, t2) {
      var s = r6.getComponent("tooltip"), u = r6.getComponent("axisPointer"), f6 = u.get("link", true) || [], d6 = [];
      Ne(t2.getCoordinateSystems(), function(v6) {
        if (!v6.axisPointerEnabled)
          return;
        var m6 = e4(v6.model), b6 = a.coordSysAxesInfo[m6] = {};
        a.coordSysMap[m6] = v6;
        var x6 = v6.model, S = x6.getModel("tooltip", s);
        if (Ne(v6.getAxes(), Oi(R, false, null)), v6.getTooltipAxes && s && S.get("show")) {
          var M = S.get("trigger") === "axis", A6 = S.get(["axisPointer", "type"]) === "cross", I = v6.getTooltipAxes(S.get(["axisPointer", "axis"]));
          (M || A6) && Ne(I.baseAxes, Oi(R, A6 ? "cross" : true, M)), A6 && Ne(I.otherAxes, Oi(R, "cross", false));
        }
        function R(F, j, $) {
          var K = $.model.getModel("axisPointer", u), U = K.get("show");
          if (!(!U || U === "auto" && !F && !bX(K))) {
            j == null && (j = K.get("triggerTooltip")), K = F ? m9e($, S, u, r6, F, j) : K;
            var he = K.get("snap"), ue = e4($.model), pe = j || he || $.type === "category", _e = a.axesInfo[ue] = { key: ue, axis: $, coordSys: v6, axisPointerModel: K, triggerTooltip: j, involveSeries: pe, snap: he, useHandle: bX(K), seriesModels: [], linkGroup: null };
            b6[ue] = _e, a.seriesInvolved = a.seriesInvolved || pe;
            var xe = b9e(f6, $);
            if (xe != null) {
              var Ae = d6[xe] || (d6[xe] = { axesInfo: {} });
              Ae.axesInfo[ue] = _e, Ae.mapper = f6[xe].mapper, _e.linkGroup = Ae;
            }
          }
        }
      });
    }
    function m9e(a, r6, t2, s, u, f6) {
      var d6 = r6.getModel("axisPointer"), v6 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], m6 = {};
      Ne(v6, function(M) {
        m6[M] = Qa(d6.get(M));
      }), m6.snap = a.type !== "category" && !!f6, d6.get("type") === "cross" && (m6.type = "line");
      var b6 = m6.label || (m6.label = {});
      if (b6.show == null && (b6.show = false), u === "cross") {
        var x6 = d6.get(["label", "show"]);
        if (b6.show = x6 != null ? x6 : true, !f6) {
          var S = m6.lineStyle = d6.get("crossStyle");
          S && ei(b6, S.textStyle);
        }
      }
      return a.model.getModel("axisPointer", new yu(m6, t2, s));
    }
    function y9e(a, r6) {
      r6.eachSeries(function(t2) {
        var s = t2.coordinateSystem, u = t2.get(["tooltip", "trigger"], true), f6 = t2.get(["tooltip", "show"], true);
        !s || u === "none" || u === false || u === "item" || f6 === false || t2.get(["axisPointer", "show"], true) === false || Ne(a.coordSysAxesInfo[e4(s.model)], function(d6) {
          var v6 = d6.axis;
          s.getAxis(v6.dim) === v6 && (d6.seriesModels.push(t2), d6.seriesDataCount == null && (d6.seriesDataCount = 0), d6.seriesDataCount += t2.getData().count());
        });
      });
    }
    function b9e(a, r6) {
      for (var t2 = r6.model, s = r6.dim, u = 0; u < a.length; u++) {
        var f6 = a[u] || {};
        if (mX(f6[s + "AxisId"], t2.id) || mX(f6[s + "AxisIndex"], t2.componentIndex) || mX(f6[s + "AxisName"], t2.name))
          return u;
      }
    }
    function mX(a, r6) {
      return a === "all" || br(a) && Vi(a, r6) >= 0 || a === r6;
    }
    function _9e(a) {
      var r6 = yX(a);
      if (r6) {
        var t2 = r6.axisPointerModel, s = r6.axis.scale, u = t2.option, f6 = t2.get("status"), d6 = t2.get("value");
        d6 != null && (d6 = s.parse(d6));
        var v6 = bX(t2);
        f6 == null && (u.status = v6 ? "show" : "hide");
        var m6 = s.getExtent().slice();
        m6[0] > m6[1] && m6.reverse(), (d6 == null || d6 > m6[1]) && (d6 = m6[1]), d6 < m6[0] && (d6 = m6[0]), u.value = d6, v6 && (u.status = r6.axis.scale.isBlank() ? "hide" : "show");
      }
    }
    function yX(a) {
      var r6 = (a.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
      return r6 && r6.axesInfo[e4(a)];
    }
    function x9e(a) {
      var r6 = yX(a);
      return r6 && r6.axisPointerModel;
    }
    function bX(a) {
      return !!a.get(["handle", "show"]);
    }
    function e4(a) {
      return a.type + "||" + a.id;
    }
    var ave = {}, w9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        this.axisPointerClass && _9e(t2), a.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(t2, u, true);
      }, r6.prototype.updateAxisPointer = function(t2, s, u, f6) {
        this._doUpdateAxisPointerClass(t2, u, false);
      }, r6.prototype.remove = function(t2, s) {
        var u = this._axisPointer;
        u && u.remove(s);
      }, r6.prototype.dispose = function(t2, s) {
        this._disposeAxisPointer(s), a.prototype.dispose.apply(this, arguments);
      }, r6.prototype._doUpdateAxisPointerClass = function(t2, s, u) {
        var f6 = r6.getAxisPointerClass(this.axisPointerClass);
        if (f6) {
          var d6 = x9e(t2);
          d6 ? (this._axisPointer || (this._axisPointer = new f6())).render(t2, d6, s, u) : this._disposeAxisPointer(s);
        }
      }, r6.prototype._disposeAxisPointer = function(t2) {
        this._axisPointer && this._axisPointer.dispose(t2), this._axisPointer = null;
      }, r6.registerAxisPointerClass = function(t2, s) {
        ave[t2] = s;
      }, r6.getAxisPointerClass = function(t2) {
        return t2 && ave[t2];
      }, r6.type = "axis", r6;
    }(Rc), MA = w9e, _X = Xo();
    function ive(a, r6, t2, s) {
      var u = t2.axis;
      if (!u.scale.isBlank()) {
        var f6 = t2.getModel("splitArea"), d6 = f6.getModel("areaStyle"), v6 = d6.get("color"), m6 = s.coordinateSystem.getRect(), b6 = u.getTicksCoords({ tickModel: f6, clamp: true });
        if (b6.length) {
          var x6 = v6.length, S = _X(a).splitAreaColors, M = Ta(), A6 = 0;
          if (S)
            for (var I = 0; I < b6.length; I++) {
              var R = S.get(b6[I].tickValue);
              if (R != null) {
                A6 = (R + (x6 - 1) * I) % x6;
                break;
              }
            }
          var F = u.toGlobalCoord(b6[0].coord), j = d6.getAreaStyle();
          v6 = br(v6) ? v6 : [v6];
          for (var I = 1; I < b6.length; I++) {
            var $ = u.toGlobalCoord(b6[I].coord), K = void 0, U = void 0, he = void 0, ue = void 0;
            u.isHorizontal() ? (K = F, U = m6.y, he = $ - K, ue = m6.height, F = K + he) : (K = m6.x, U = F, he = m6.width, ue = $ - U, F = U + ue);
            var pe = b6[I - 1].tickValue;
            pe != null && M.set(pe, A6), r6.add(new rs({ anid: pe != null ? "area_" + pe : null, shape: { x: K, y: U, width: he, height: ue }, style: ei({ fill: v6[A6] }, j), autoBatch: true, silent: true })), A6 = (A6 + 1) % x6;
          }
          _X(a).splitAreaColors = M;
        }
      }
    }
    function ove(a) {
      _X(a).splitAreaColors = null;
    }
    var S9e = ["axisLine", "axisTickLabel", "axisName"], C9e = ["splitArea", "splitLine", "minorSplitLine"], sve = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.axisPointerClass = "CartesianAxisPointer", t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        this.group.removeAll();
        var d6 = this._axisGroup;
        if (this._axisGroup = new bi(), this.group.add(this._axisGroup), !!t2.get("show")) {
          var v6 = t2.getCoordSysModel(), m6 = pX(v6, t2), b6 = new Ux(t2, qn({ handleAutoShown: function(S) {
            for (var M = v6.coordinateSystem.getCartesians(), A6 = 0; A6 < M.length; A6++)
              if (LZ(M[A6].getOtherAxis(t2.axis).scale))
                return true;
            return false;
          } }, m6));
          Ne(S9e, b6.add, b6), this._axisGroup.add(b6.getGroup()), Ne(C9e, function(S) {
            t2.get([S, "show"]) && M9e[S](this, this._axisGroup, t2, v6);
          }, this);
          var x6 = f6 && f6.type === "changeAxisOrder" && f6.isInitSort;
          x6 || Ro(d6, this._axisGroup, t2), a.prototype.render.call(this, t2, s, u, f6);
        }
      }, r6.prototype.remove = function() {
        ove(this);
      }, r6.type = "cartesianAxis", r6;
    }(MA), M9e = { splitLine: function(a, r6, t2, s) {
      var u = t2.axis;
      if (!u.scale.isBlank()) {
        var f6 = t2.getModel("splitLine"), d6 = f6.getModel("lineStyle"), v6 = d6.get("color");
        v6 = br(v6) ? v6 : [v6];
        for (var m6 = s.coordinateSystem.getRect(), b6 = u.isHorizontal(), x6 = 0, S = u.getTicksCoords({ tickModel: f6 }), M = [], A6 = [], I = d6.getLineStyle(), R = 0; R < S.length; R++) {
          var F = u.toGlobalCoord(S[R].coord);
          b6 ? (M[0] = F, M[1] = m6.y, A6[0] = F, A6[1] = m6.y + m6.height) : (M[0] = m6.x, M[1] = F, A6[0] = m6.x + m6.width, A6[1] = F);
          var j = x6++ % v6.length, $ = S[R].tickValue;
          r6.add(new rh({ anid: $ != null ? "line_" + S[R].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: M[0], y1: M[1], x2: A6[0], y2: A6[1] }, style: ei({ stroke: v6[j] }, I), silent: true }));
        }
      }
    }, minorSplitLine: function(a, r6, t2, s) {
      var u = t2.axis, f6 = t2.getModel("minorSplitLine"), d6 = f6.getModel("lineStyle"), v6 = s.coordinateSystem.getRect(), m6 = u.isHorizontal(), b6 = u.getMinorTicksCoords();
      if (b6.length)
        for (var x6 = [], S = [], M = d6.getLineStyle(), A6 = 0; A6 < b6.length; A6++)
          for (var I = 0; I < b6[A6].length; I++) {
            var R = u.toGlobalCoord(b6[A6][I].coord);
            m6 ? (x6[0] = R, x6[1] = v6.y, S[0] = R, S[1] = v6.y + v6.height) : (x6[0] = v6.x, x6[1] = R, S[0] = v6.x + v6.width, S[1] = R), r6.add(new rh({ anid: "minor_line_" + b6[A6][I].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: x6[0], y1: x6[1], x2: S[0], y2: S[1] }, style: M, silent: true }));
          }
    }, splitArea: function(a, r6, t2, s) {
      ive(a, r6, t2, s);
    } }, lve = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "xAxis", r6;
    }(sve), A9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = lve.type, t2;
      }
      return r6.type = "yAxis", r6;
    }(sve), E9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "grid", t2;
      }
      return r6.prototype.render = function(t2, s) {
        this.group.removeAll(), t2.get("show") && this.group.add(new rs({ shape: t2.coordinateSystem.getRect(), style: ei({ fill: t2.get("backgroundColor") }, t2.getItemStyle()), silent: true, z2: -1 }));
      }, r6.type = "grid", r6;
    }(Rc), uve = { offset: 0 };
    function cve(a) {
      a.registerComponentView(E9e), a.registerComponentModel(X8e), a.registerCoordinateSystem("cartesian2d", u9e), m5(a, "x", fX, uve), m5(a, "y", fX, uve), a.registerComponentView(lve), a.registerComponentView(A9e), a.registerPreprocessor(function(r6) {
        r6.xAxis && r6.yAxis && !r6.grid && (r6.grid = {});
      });
    }
    function I9e(a) {
      bo(cve), a.registerSeriesModel(G8e), a.registerChartView(Y8e), a.registerLayout(KR("scatter"));
    }
    function T9e(a) {
      a.eachSeriesByType("radar", function(r6) {
        var t2 = r6.getData(), s = [], u = r6.coordinateSystem;
        if (u) {
          var f6 = u.getIndicatorAxes();
          Ne(f6, function(d6, v6) {
            t2.each(t2.mapDimension(f6[v6].dim), function(m6, b6) {
              s[b6] = s[b6] || [];
              var x6 = u.dataToPoint(m6, v6);
              s[b6][v6] = fve(x6) ? x6 : hve(u);
            });
          }), t2.each(function(d6) {
            var v6 = gU(s[d6], function(m6) {
              return fve(m6);
            }) || hve(u);
            s[d6].push(v6.slice()), t2.setItemLayout(d6, s[d6]);
          });
        }
      });
    }
    function fve(a) {
      return !isNaN(a[0]) && !isNaN(a[1]);
    }
    function hve(a) {
      return [a.cx, a.cy];
    }
    function D9e(a) {
      var r6 = a.polar;
      if (r6) {
        br(r6) || (r6 = [r6]);
        var t2 = [];
        Ne(r6, function(s, u) {
          s.indicator ? (s.type && !s.shape && (s.shape = s.type), a.radar = a.radar || [], br(a.radar) || (a.radar = [a.radar]), a.radar.push(s)) : t2.push(s);
        }), a.polar = t2;
      }
      Ne(a.series, function(s) {
        s && s.type === "radar" && s.polarIndex && (s.radarIndex = s.polarIndex);
      });
    }
    var k9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = t2.coordinateSystem, d6 = this.group, v6 = t2.getData(), m6 = this._data;
        function b6(M, A6) {
          var I = M.getItemVisual(A6, "symbol") || "circle";
          if (I !== "none") {
            var R = IR(M.getItemVisual(A6, "symbolSize")), F = Lf(I, -1, -1, 2, 2), j = M.getItemVisual(A6, "symbolRotate") || 0;
            return F.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: R[0] / 2, scaleY: R[1] / 2, rotation: j * Math.PI / 180 || 0 }), F;
          }
        }
        function x6(M, A6, I, R, F, j) {
          I.removeAll();
          for (var $ = 0; $ < A6.length - 1; $++) {
            var K = b6(R, F);
            K && (K.__dimIdx = $, M[$] ? (K.setPosition(M[$]), fR[j ? "initProps" : "updateProps"](K, { x: A6[$][0], y: A6[$][1] }, t2, F)) : K.setPosition(A6[$]), I.add(K));
          }
        }
        function S(M) {
          return wr(M, function(A6) {
            return [f6.cx, f6.cy];
          });
        }
        v6.diff(m6).add(function(M) {
          var A6 = v6.getItemLayout(M);
          if (A6) {
            var I = new ud(), R = new Vp(), F = { shape: { points: A6 } };
            I.shape.points = S(A6), R.shape.points = S(A6), zu(I, F, t2, M), zu(R, F, t2, M);
            var j = new bi(), $ = new bi();
            j.add(R), j.add(I), j.add($), x6(R.shape.points, A6, $, v6, M, true), v6.setItemGraphicEl(M, j);
          }
        }).update(function(M, A6) {
          var I = m6.getItemGraphicEl(A6), R = I.childAt(0), F = I.childAt(1), j = I.childAt(2), $ = { shape: { points: v6.getItemLayout(M) } };
          !$.shape.points || (x6(R.shape.points, $.shape.points, j, v6, M, false), f0(F), f0(R), fs(R, $, t2), fs(F, $, t2), v6.setItemGraphicEl(M, I));
        }).remove(function(M) {
          d6.remove(m6.getItemGraphicEl(M));
        }).execute(), v6.eachItemGraphicEl(function(M, A6) {
          var I = v6.getItemModel(A6), R = M.childAt(0), F = M.childAt(1), j = M.childAt(2), $ = v6.getItemVisual(A6, "style"), K = $.fill;
          d6.add(M), R.useStyle(ei(I.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: K })), Ah(R, I, "lineStyle"), Ah(F, I, "areaStyle");
          var U = I.getModel("areaStyle"), he = U.isEmpty() && U.parentModel.isEmpty();
          F.ignore = he, Ne(["emphasis", "select", "blur"], function(_e) {
            var xe = I.getModel([_e, "areaStyle"]), Ae = xe.isEmpty() && xe.parentModel.isEmpty();
            F.ensureState(_e).ignore = Ae && he;
          }), F.useStyle(ei(U.getAreaStyle(), { fill: K, opacity: 0.7, decal: $.decal }));
          var ue = I.getModel("emphasis"), pe = ue.getModel("itemStyle").getItemStyle();
          j.eachChild(function(_e) {
            if (_e instanceof nh) {
              var xe = _e.style;
              _e.useStyle(qn({ image: xe.image, x: xe.x, y: xe.y, width: xe.width, height: xe.height }, $));
            } else
              _e.useStyle($), _e.setColor(K), _e.style.strokeNoScale = true;
            var Ae = _e.ensureState("emphasis");
            Ae.style = Qa(pe);
            var ke = v6.getStore().get(v6.getDimensionIndex(_e.__dimIdx), A6);
            (ke == null || isNaN(ke)) && (ke = ""), Bp(_e, hd(I), { labelFetcher: v6.hostModel, labelDataIndex: A6, labelDimIndex: _e.__dimIdx, defaultText: ke, inheritColor: K, defaultOpacity: $.opacity });
          }), Cc(M, ue.get("focus"), ue.get("blurScope"), ue.get("disabled"));
        }), this._data = v6;
      }, r6.prototype.remove = function() {
        this.group.removeAll(), this._data = null;
      }, r6.type = "radar", r6;
    }(bu), P9e = k9e, L9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.hasSymbolVisual = true, t2;
      }
      return r6.prototype.init = function(t2) {
        a.prototype.init.apply(this, arguments), this.legendVisualProvider = new QR(Ca(this.getData, this), Ca(this.getRawData, this));
      }, r6.prototype.getInitialData = function(t2, s) {
        return g5(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        var f6 = this.getData(), d6 = this.coordinateSystem, v6 = d6.getIndicatorAxes(), m6 = this.getData().getName(t2), b6 = m6 === "" ? this.name : m6, x6 = Cfe(this, t2);
        return Ih("section", { header: b6, sortBlocks: true, blocks: wr(v6, function(S) {
          var M = f6.get(f6.mapDimension(S.dim), t2);
          return Ih("nameValue", { markerType: "subItem", markerColor: x6, name: S.name, value: M, sortParam: M });
        }) });
      }, r6.prototype.getTooltipPosition = function(t2) {
        if (t2 != null) {
          for (var s = this.getData(), u = this.coordinateSystem, f6 = s.getValues(wr(u.dimensions, function(b6) {
            return s.mapDimension(b6);
          }), t2), d6 = 0, v6 = f6.length; d6 < v6; d6++)
            if (!isNaN(f6[d6])) {
              var m6 = u.getIndicatorAxes();
              return u.coordToPoint(m6[d6].dataToCoord(f6[d6]), d6);
            }
        }
      }, r6.type = "series.radar", r6.dependencies = ["radar"], r6.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, r6;
    }(sc), O9e = L9e, t4 = Upe.value;
    function iz(a, r6) {
      return ei({ show: r6 }, a);
    }
    var R9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.optionUpdated = function() {
        var t2 = this.get("boundaryGap"), s = this.get("splitNumber"), u = this.get("scale"), f6 = this.get("axisLine"), d6 = this.get("axisTick"), v6 = this.get("axisLabel"), m6 = this.get("axisName"), b6 = this.get(["axisName", "show"]), x6 = this.get(["axisName", "formatter"]), S = this.get("axisNameGap"), M = this.get("triggerEvent"), A6 = wr(this.get("indicator") || [], function(I) {
          I.max != null && I.max > 0 && !I.min ? I.min = 0 : I.min != null && I.min < 0 && !I.max && (I.max = 0);
          var R = m6;
          I.color != null && (R = ei({ color: I.color }, m6));
          var F = Di(Qa(I), { boundaryGap: t2, splitNumber: s, scale: u, axisLine: f6, axisTick: d6, axisLabel: v6, name: I.text, showName: b6, nameLocation: "end", nameGap: S, nameTextStyle: R, triggerEvent: M }, false);
          if (b6 || (F.name = ""), _a2(x6)) {
            var j = F.name;
            F.name = x6.replace("{value}", j != null ? j : "");
          } else
            ti(x6) && (F.name = x6(F.name, F));
          var $ = new yu(F, null, this.ecModel);
          return Dc($, GR.prototype), $.mainType = "radar", $.componentIndex = this.componentIndex, $;
        }, this);
        this._indicatorModels = A6;
      }, r6.prototype.getIndicatorModels = function() {
        return this._indicatorModels;
      }, r6.type = "radar", r6.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: Di({ lineStyle: { color: "#bbb" } }, t4.axisLine), axisLabel: iz(t4.axisLabel, false), axisTick: iz(t4.axisTick, false), splitLine: iz(t4.splitLine, true), splitArea: iz(t4.splitArea, true), indicator: [] }, r6;
    }(Ps), F9e = R9e, N9e = ["axisLine", "axisTickLabel", "axisName"], V9e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = this.group;
        f6.removeAll(), this._buildAxes(t2), this._buildSplitLineAndArea(t2);
      }, r6.prototype._buildAxes = function(t2) {
        var s = t2.coordinateSystem, u = s.getIndicatorAxes(), f6 = wr(u, function(d6) {
          var v6 = d6.model.get("showName") ? d6.name : "", m6 = new Ux(d6.model, { axisName: v6, position: [s.cx, s.cy], rotation: d6.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
          return m6;
        });
        Ne(f6, function(d6) {
          Ne(N9e, d6.add, d6), this.group.add(d6.getGroup());
        }, this);
      }, r6.prototype._buildSplitLineAndArea = function(t2) {
        var s = t2.coordinateSystem, u = s.getIndicatorAxes();
        if (!u.length)
          return;
        var f6 = t2.get("shape"), d6 = t2.getModel("splitLine"), v6 = t2.getModel("splitArea"), m6 = d6.getModel("lineStyle"), b6 = v6.getModel("areaStyle"), x6 = d6.get("show"), S = v6.get("show"), M = m6.get("color"), A6 = b6.get("color"), I = br(M) ? M : [M], R = br(A6) ? A6 : [A6], F = [], j = [];
        function $(ht, Qe, en) {
          var bt = en % Qe.length;
          return ht[bt] = ht[bt] || [], bt;
        }
        if (f6 === "circle")
          for (var K = u[0].getTicksCoords(), U = s.cx, he = s.cy, ue = 0; ue < K.length; ue++) {
            if (x6) {
              var pe = $(F, I, ue);
              F[pe].push(new Em({ shape: { cx: U, cy: he, r: K[ue].coord } }));
            }
            if (S && ue < K.length - 1) {
              var pe = $(j, R, ue);
              j[pe].push(new zD({ shape: { cx: U, cy: he, r0: K[ue].coord, r: K[ue + 1].coord } }));
            }
          }
        else
          for (var _e, xe = wr(u, function(Qe, en) {
            var bt = Qe.getTicksCoords();
            return _e = _e == null ? bt.length - 1 : Math.min(bt.length - 1, _e), wr(bt, function(wt) {
              return s.coordToPoint(wt.coord, en);
            });
          }), Ae = [], ue = 0; ue <= _e; ue++) {
            for (var ke = [], je = 0; je < u.length; je++)
              ke.push(xe[je][ue]);
            if (ke[0] && ke.push(ke[0].slice()), x6) {
              var pe = $(F, I, ue);
              F[pe].push(new Vp({ shape: { points: ke } }));
            }
            if (S && Ae) {
              var pe = $(j, R, ue - 1);
              j[pe].push(new ud({ shape: { points: ke.concat(Ae) } }));
            }
            Ae = ke.slice().reverse();
          }
        var Fe = m6.getLineStyle(), at = b6.getAreaStyle();
        Ne(j, function(ht, Qe) {
          this.group.add(dt(ht, { style: ei({ stroke: "none", fill: R[Qe % R.length] }, at), silent: true }));
        }, this), Ne(F, function(ht, Qe) {
          this.group.add(dt(ht, { style: ei({ fill: "none", stroke: I[Qe % I.length] }, Fe), silent: true }));
        }, this);
      }, r6.type = "radar", r6;
    }(Rc), z9e = V9e, B9e = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this, t2, s, u) || this;
        return f6.type = "value", f6.angle = 0, f6.name = "", f6;
      }
      return r6;
    }(c1), j9e = B9e, G9e = function() {
      function a(r6, t2, s) {
        this.dimensions = [], this._model = r6, this._indicatorAxes = wr(r6.getIndicatorModels(), function(u, f6) {
          var d6 = "indicator_" + f6, v6 = new j9e(d6, new nS());
          return v6.name = u.get("name"), v6.model = u, u.axis = v6, this.dimensions.push(d6), v6;
        }, this), this.resize(r6, s);
      }
      return a.prototype.getIndicatorAxes = function() {
        return this._indicatorAxes;
      }, a.prototype.dataToPoint = function(r6, t2) {
        var s = this._indicatorAxes[t2];
        return this.coordToPoint(s.dataToCoord(r6), t2);
      }, a.prototype.coordToPoint = function(r6, t2) {
        var s = this._indicatorAxes[t2], u = s.angle, f6 = this.cx + r6 * Math.cos(u), d6 = this.cy - r6 * Math.sin(u);
        return [f6, d6];
      }, a.prototype.pointToData = function(r6) {
        var t2 = r6[0] - this.cx, s = r6[1] - this.cy, u = Math.sqrt(t2 * t2 + s * s);
        t2 /= u, s /= u;
        for (var f6 = Math.atan2(-s, t2), d6 = 1 / 0, v6, m6 = -1, b6 = 0; b6 < this._indicatorAxes.length; b6++) {
          var x6 = this._indicatorAxes[b6], S = Math.abs(f6 - x6.angle);
          S < d6 && (v6 = x6, m6 = b6, d6 = S);
        }
        return [m6, +(v6 && v6.coordToData(u))];
      }, a.prototype.resize = function(r6, t2) {
        var s = r6.get("center"), u = t2.getWidth(), f6 = t2.getHeight(), d6 = Math.min(u, f6) / 2;
        this.cx = ua(s[0], u), this.cy = ua(s[1], f6), this.startAngle = r6.get("startAngle") * Math.PI / 180;
        var v6 = r6.get("radius");
        (_a2(v6) || ks(v6)) && (v6 = [0, v6]), this.r0 = ua(v6[0], d6), this.r = ua(v6[1], d6), Ne(this._indicatorAxes, function(m6, b6) {
          m6.setExtent(this.r0, this.r);
          var x6 = this.startAngle + b6 * Math.PI * 2 / this._indicatorAxes.length;
          x6 = Math.atan2(Math.sin(x6), Math.cos(x6)), m6.angle = x6;
        }, this);
      }, a.prototype.update = function(r6, t2) {
        var s = this._indicatorAxes, u = this._model;
        Ne(s, function(v6) {
          v6.scale.setExtent(1 / 0, -1 / 0);
        }), r6.eachSeriesByType("radar", function(v6, m6) {
          if (!(v6.get("coordinateSystem") !== "radar" || r6.getComponent("radar", v6.get("radarIndex")) !== u)) {
            var b6 = v6.getData();
            Ne(s, function(x6) {
              x6.scale.unionExtentFromData(b6, b6.mapDimension(x6.dim));
            });
          }
        }, this);
        var f6 = u.get("splitNumber"), d6 = new nS();
        d6.setExtent(0, f6), d6.setInterval(1), Ne(s, function(v6, m6) {
          Kpe(v6.scale, v6.model, d6);
        });
      }, a.prototype.convertToPixel = function(r6, t2, s) {
        return console.warn("Not implemented."), null;
      }, a.prototype.convertFromPixel = function(r6, t2, s) {
        return console.warn("Not implemented."), null;
      }, a.prototype.containPoint = function(r6) {
        return console.warn("Not implemented."), false;
      }, a.create = function(r6, t2) {
        var s = [];
        return r6.eachComponent("radar", function(u) {
          var f6 = new a(u, r6, t2);
          s.push(f6), u.coordinateSystem = f6;
        }), r6.eachSeriesByType("radar", function(u) {
          u.get("coordinateSystem") === "radar" && (u.coordinateSystem = s[u.get("radarIndex") || 0]);
        }), s;
      }, a.dimensions = [], a;
    }(), W9e = G9e;
    function H9e(a) {
      a.registerCoordinateSystem("radar", W9e), a.registerComponentModel(F9e), a.registerComponentView(z9e), a.registerVisual({ seriesType: "radar", reset: function(r6) {
        var t2 = r6.getData();
        t2.each(function(s) {
          t2.setItemVisual(s, "legendIcon", "roundRect");
        }), t2.setVisual("legendIcon", "roundRect");
      } });
    }
    function $9e(a) {
      bo(H9e), a.registerChartView(P9e), a.registerSeriesModel(O9e), a.registerLayout(T9e), a.registerProcessor(JR("radar")), a.registerPreprocessor(D9e);
    }
    var dve = "\0_ec_interaction_mutex";
    function U9e(a, r6, t2) {
      var s = xX(a);
      s[r6] = t2;
    }
    function q9e(a, r6, t2) {
      var s = xX(a), u = s[r6];
      u === t2 && (s[r6] = null);
    }
    function pve(a, r6) {
      return !!xX(a)[r6];
    }
    function xX(a) {
      return a[dve] || (a[dve] = {});
    }
    Nb({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, kc);
    var Y9e = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this) || this;
        s._zr = t2;
        var u = Ca(s._mousedownHandler, s), f6 = Ca(s._mousemoveHandler, s), d6 = Ca(s._mouseupHandler, s), v6 = Ca(s._mousewheelHandler, s), m6 = Ca(s._pinchHandler, s);
        return s.enable = function(b6, x6) {
          this.disable(), this._opt = ei(Qa(x6) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), b6 == null && (b6 = true), (b6 === true || b6 === "move" || b6 === "pan") && (t2.on("mousedown", u), t2.on("mousemove", f6), t2.on("mouseup", d6)), (b6 === true || b6 === "scale" || b6 === "zoom") && (t2.on("mousewheel", v6), t2.on("pinch", m6));
        }, s.disable = function() {
          t2.off("mousedown", u), t2.off("mousemove", f6), t2.off("mouseup", d6), t2.off("mousewheel", v6), t2.off("pinch", m6);
        }, s;
      }
      return r6.prototype.isDragging = function() {
        return this._dragging;
      }, r6.prototype.isPinching = function() {
        return this._pinching;
      }, r6.prototype.setPointerChecker = function(t2) {
        this.pointerChecker = t2;
      }, r6.prototype.dispose = function() {
        this.disable();
      }, r6.prototype._mousedownHandler = function(t2) {
        if (!(qy(t2) || t2.target && t2.target.draggable)) {
          var s = t2.offsetX, u = t2.offsetY;
          this.pointerChecker && this.pointerChecker(t2, s, u) && (this._x = s, this._y = u, this._dragging = true);
        }
      }, r6.prototype._mousemoveHandler = function(t2) {
        if (!(!this._dragging || !oz("moveOnMouseMove", t2, this._opt) || t2.gestureEvent === "pinch" || pve(this._zr, "globalPan"))) {
          var s = t2.offsetX, u = t2.offsetY, f6 = this._x, d6 = this._y, v6 = s - f6, m6 = u - d6;
          this._x = s, this._y = u, this._opt.preventDefaultMouseMove && vm(t2.event), vve(this, "pan", "moveOnMouseMove", t2, { dx: v6, dy: m6, oldX: f6, oldY: d6, newX: s, newY: u, isAvailableBehavior: null });
        }
      }, r6.prototype._mouseupHandler = function(t2) {
        qy(t2) || (this._dragging = false);
      }, r6.prototype._mousewheelHandler = function(t2) {
        var s = oz("zoomOnMouseWheel", t2, this._opt), u = oz("moveOnMouseWheel", t2, this._opt), f6 = t2.wheelDelta, d6 = Math.abs(f6), v6 = t2.offsetX, m6 = t2.offsetY;
        if (!(f6 === 0 || !s && !u)) {
          if (s) {
            var b6 = d6 > 3 ? 1.4 : d6 > 1 ? 1.2 : 1.1, x6 = f6 > 0 ? b6 : 1 / b6;
            wX(this, "zoom", "zoomOnMouseWheel", t2, { scale: x6, originX: v6, originY: m6, isAvailableBehavior: null });
          }
          if (u) {
            var S = Math.abs(f6), M = (f6 > 0 ? 1 : -1) * (S > 3 ? 0.4 : S > 1 ? 0.15 : 0.05);
            wX(this, "scrollMove", "moveOnMouseWheel", t2, { scrollDelta: M, originX: v6, originY: m6, isAvailableBehavior: null });
          }
        }
      }, r6.prototype._pinchHandler = function(t2) {
        if (!pve(this._zr, "globalPan")) {
          var s = t2.pinchScale > 1 ? 1.1 : 0.9090909090909091;
          wX(this, "zoom", null, t2, { scale: s, originX: t2.pinchX, originY: t2.pinchY, isAvailableBehavior: null });
        }
      }, r6;
    }(Ip);
    function wX(a, r6, t2, s, u) {
      a.pointerChecker && a.pointerChecker(s, u.originX, u.originY) && (vm(s.event), vve(a, r6, t2, s, u));
    }
    function vve(a, r6, t2, s, u) {
      u.isAvailableBehavior = Ca(oz, null, t2, s), a.trigger(r6, u);
    }
    function oz(a, r6, t2) {
      var s = t2[a];
      return !a || s && (!_a2(s) || r6.event[s + "Key"]);
    }
    var n4 = Y9e;
    function SX(a, r6, t2) {
      var s = a.target;
      s.x += r6, s.y += t2, s.dirty();
    }
    function CX(a, r6, t2, s) {
      var u = a.target, f6 = a.zoomLimit, d6 = a.zoom = a.zoom || 1;
      if (d6 *= r6, f6) {
        var v6 = f6.min || 0, m6 = f6.max || 1 / 0;
        d6 = Math.max(Math.min(m6, d6), v6);
      }
      var b6 = d6 / a.zoom;
      a.zoom = d6, u.x -= (t2 - u.x) * (b6 - 1), u.y -= (s - u.y) * (b6 - 1), u.scaleX *= b6, u.scaleY *= b6, u.dirty();
    }
    var Z9e = { axisPointer: 1, tooltip: 1, brush: 1 };
    function sz(a, r6, t2) {
      var s = r6.getComponentByElement(a.topTarget), u = s && s.coordinateSystem;
      return s && s !== t2 && !Z9e.hasOwnProperty(s.mainType) && u && u.model !== t2;
    }
    function gve(a) {
      if (_a2(a)) {
        var r6 = new DOMParser();
        a = r6.parseFromString(a, "text/xml");
      }
      var t2 = a;
      for (t2.nodeType === 9 && (t2 = t2.firstChild); t2.nodeName.toLowerCase() !== "svg" || t2.nodeType !== 1; )
        t2 = t2.nextSibling;
      return t2;
    }
    var MX, lz = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, mve = Po(lz), uz = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, yve = Po(uz), X9e = function() {
      function a() {
        this._defs = {}, this._root = null;
      }
      return a.prototype.parse = function(r6, t2) {
        t2 = t2 || {};
        var s = gve(r6);
        this._defsUsePending = [];
        var u = new bi();
        this._root = u;
        var f6 = [], d6 = s.getAttribute("viewBox") || "", v6 = parseFloat(s.getAttribute("width") || t2.width), m6 = parseFloat(s.getAttribute("height") || t2.height);
        isNaN(v6) && (v6 = null), isNaN(m6) && (m6 = null), p0(s, u, null, true, false);
        for (var b6 = s.firstChild; b6; )
          this._parseNode(b6, u, f6, null, false, false), b6 = b6.nextSibling;
        Q9e(this._defs, this._defsUsePending), this._defsUsePending = [];
        var x6, S;
        if (d6) {
          var M = cz(d6);
          M.length >= 4 && (x6 = { x: parseFloat(M[0] || 0), y: parseFloat(M[1] || 0), width: parseFloat(M[2]), height: parseFloat(M[3]) });
        }
        if (x6 && v6 != null && m6 != null && (S = Ave(x6, { x: 0, y: 0, width: v6, height: m6 }), !t2.ignoreViewBox)) {
          var A6 = u;
          u = new bi(), u.add(A6), A6.scaleX = A6.scaleY = S.scale, A6.x = S.x, A6.y = S.y;
        }
        return !t2.ignoreRootClip && v6 != null && m6 != null && u.setClipPath(new rs({ shape: { x: 0, y: 0, width: v6, height: m6 } })), { root: u, width: v6, height: m6, viewBoxRect: x6, viewBoxTransform: S, named: f6 };
      }, a.prototype._parseNode = function(r6, t2, s, u, f6, d6) {
        var v6 = r6.nodeName.toLowerCase(), m6, b6 = u;
        if (v6 === "defs" && (f6 = true), v6 === "text" && (d6 = true), v6 === "defs" || v6 === "switch")
          m6 = t2;
        else {
          if (!f6) {
            var x6 = MX[v6];
            if (x6 && Da(MX, v6)) {
              m6 = x6.call(this, r6, t2);
              var S = r6.getAttribute("name");
              if (S) {
                var M = { name: S, namedFrom: null, svgNodeTagLower: v6, el: m6 };
                s.push(M), v6 === "g" && (b6 = M);
              } else
                u && s.push({ name: u.name, namedFrom: u, svgNodeTagLower: v6, el: m6 });
              t2.add(m6);
            }
          }
          var A6 = bve[v6];
          if (A6 && Da(bve, v6)) {
            var I = A6.call(this, r6), R = r6.getAttribute("id");
            R && (this._defs[R] = I);
          }
        }
        if (m6 && m6.isGroup)
          for (var F = r6.firstChild; F; )
            F.nodeType === 1 ? this._parseNode(F, m6, s, b6, f6, d6) : F.nodeType === 3 && d6 && this._parseText(F, m6), F = F.nextSibling;
      }, a.prototype._parseText = function(r6, t2) {
        var s = new YM({ style: { text: r6.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
        Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), K9e(s, t2);
        var u = s.style, f6 = u.fontSize;
        f6 && f6 < 9 && (u.fontSize = 9, s.scaleX *= f6 / 9, s.scaleY *= f6 / 9);
        var d6 = (u.fontSize || u.fontFamily) && [u.fontStyle, u.fontWeight, (u.fontSize || 12) + "px", u.fontFamily || "sans-serif"].join(" ");
        u.font = d6;
        var v6 = s.getBoundingRect();
        return this._textX += v6.width, t2.add(s), s;
      }, a.internalField = function() {
        MX = { g: function(r6, t2) {
          var s = new bi();
          return Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), s;
        }, rect: function(r6, t2) {
          var s = new rs();
          return Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), s.setShape({ x: parseFloat(r6.getAttribute("x") || "0"), y: parseFloat(r6.getAttribute("y") || "0"), width: parseFloat(r6.getAttribute("width") || "0"), height: parseFloat(r6.getAttribute("height") || "0") }), s.silent = true, s;
        }, circle: function(r6, t2) {
          var s = new Em();
          return Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), s.setShape({ cx: parseFloat(r6.getAttribute("cx") || "0"), cy: parseFloat(r6.getAttribute("cy") || "0"), r: parseFloat(r6.getAttribute("r") || "0") }), s.silent = true, s;
        }, line: function(r6, t2) {
          var s = new rh();
          return Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), s.setShape({ x1: parseFloat(r6.getAttribute("x1") || "0"), y1: parseFloat(r6.getAttribute("y1") || "0"), x2: parseFloat(r6.getAttribute("x2") || "0"), y2: parseFloat(r6.getAttribute("y2") || "0") }), s.silent = true, s;
        }, ellipse: function(r6, t2) {
          var s = new ND();
          return Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), s.setShape({ cx: parseFloat(r6.getAttribute("cx") || "0"), cy: parseFloat(r6.getAttribute("cy") || "0"), rx: parseFloat(r6.getAttribute("rx") || "0"), ry: parseFloat(r6.getAttribute("ry") || "0") }), s.silent = true, s;
        }, polygon: function(r6, t2) {
          var s = r6.getAttribute("points"), u;
          s && (u = wve(s));
          var f6 = new ud({ shape: { points: u || [] }, silent: true });
          return Nm(t2, f6), p0(r6, f6, this._defsUsePending, false, false), f6;
        }, polyline: function(r6, t2) {
          var s = r6.getAttribute("points"), u;
          s && (u = wve(s));
          var f6 = new Vp({ shape: { points: u || [] }, silent: true });
          return Nm(t2, f6), p0(r6, f6, this._defsUsePending, false, false), f6;
        }, image: function(r6, t2) {
          var s = new nh();
          return Nm(t2, s), p0(r6, s, this._defsUsePending, false, false), s.setStyle({ image: r6.getAttribute("xlink:href") || r6.getAttribute("href"), x: +r6.getAttribute("x"), y: +r6.getAttribute("y"), width: +r6.getAttribute("width"), height: +r6.getAttribute("height") }), s.silent = true, s;
        }, text: function(r6, t2) {
          var s = r6.getAttribute("x") || "0", u = r6.getAttribute("y") || "0", f6 = r6.getAttribute("dx") || "0", d6 = r6.getAttribute("dy") || "0";
          this._textX = parseFloat(s) + parseFloat(f6), this._textY = parseFloat(u) + parseFloat(d6);
          var v6 = new bi();
          return Nm(t2, v6), p0(r6, v6, this._defsUsePending, false, true), v6;
        }, tspan: function(r6, t2) {
          var s = r6.getAttribute("x"), u = r6.getAttribute("y");
          s != null && (this._textX = parseFloat(s)), u != null && (this._textY = parseFloat(u));
          var f6 = r6.getAttribute("dx") || "0", d6 = r6.getAttribute("dy") || "0", v6 = new bi();
          return Nm(t2, v6), p0(r6, v6, this._defsUsePending, false, true), this._textX += parseFloat(f6), this._textY += parseFloat(d6), v6;
        }, path: function(r6, t2) {
          var s = r6.getAttribute("d") || "", u = B7(s);
          return Nm(t2, u), p0(r6, u, this._defsUsePending, false, false), u.silent = true, u;
        } };
      }(), a;
    }(), bve = { lineargradient: function(a) {
      var r6 = parseInt(a.getAttribute("x1") || "0", 10), t2 = parseInt(a.getAttribute("y1") || "0", 10), s = parseInt(a.getAttribute("x2") || "10", 10), u = parseInt(a.getAttribute("y2") || "0", 10), f6 = new aA(r6, t2, s, u);
      return _ve(a, f6), xve(a, f6), f6;
    }, radialgradient: function(a) {
      var r6 = parseInt(a.getAttribute("cx") || "0", 10), t2 = parseInt(a.getAttribute("cy") || "0", 10), s = parseInt(a.getAttribute("r") || "0", 10), u = new sR(r6, t2, s);
      return _ve(a, u), xve(a, u), u;
    } };
    function _ve(a, r6) {
      var t2 = a.getAttribute("gradientUnits");
      t2 === "userSpaceOnUse" && (r6.global = true);
    }
    function xve(a, r6) {
      for (var t2 = a.firstChild; t2; ) {
        if (t2.nodeType === 1 && t2.nodeName.toLocaleLowerCase() === "stop") {
          var s = t2.getAttribute("offset"), u = void 0;
          s && s.indexOf("%") > 0 ? u = parseInt(s, 10) / 100 : s ? u = parseFloat(s) : u = 0;
          var f6 = {};
          Mve(t2, f6, f6);
          var d6 = f6.stopColor || t2.getAttribute("stop-color") || "#000000";
          r6.colorStops.push({ offset: u, color: d6 });
        }
        t2 = t2.nextSibling;
      }
    }
    function Nm(a, r6) {
      a && a.__inheritedStyle && (r6.__inheritedStyle || (r6.__inheritedStyle = {}), ei(r6.__inheritedStyle, a.__inheritedStyle));
    }
    function wve(a) {
      for (var r6 = cz(a), t2 = [], s = 0; s < r6.length; s += 2) {
        var u = parseFloat(r6[s]), f6 = parseFloat(r6[s + 1]);
        t2.push([u, f6]);
      }
      return t2;
    }
    function p0(a, r6, t2, s, u) {
      var f6 = r6, d6 = f6.__inheritedStyle = f6.__inheritedStyle || {}, v6 = {};
      a.nodeType === 1 && (n7e(a, r6), Mve(a, d6, v6), s || r7e(a, d6, v6)), f6.style = f6.style || {}, d6.fill != null && (f6.style.fill = Sve(f6, "fill", d6.fill, t2)), d6.stroke != null && (f6.style.stroke = Sve(f6, "stroke", d6.stroke, t2)), Ne(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(m6) {
        d6[m6] != null && (f6.style[m6] = parseFloat(d6[m6]));
      }), Ne(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(m6) {
        d6[m6] != null && (f6.style[m6] = d6[m6]);
      }), u && (f6.__selfStyle = v6), d6.lineDash && (f6.style.lineDash = wr(cz(d6.lineDash), function(m6) {
        return parseFloat(m6);
      })), (d6.visibility === "hidden" || d6.visibility === "collapse") && (f6.invisible = true), d6.display === "none" && (f6.ignore = true);
    }
    function K9e(a, r6) {
      var t2 = r6.__selfStyle;
      if (t2) {
        var s = t2.textBaseline, u = s;
        !s || s === "auto" || s === "baseline" ? u = "alphabetic" : s === "before-edge" || s === "text-before-edge" ? u = "top" : s === "after-edge" || s === "text-after-edge" ? u = "bottom" : (s === "central" || s === "mathematical") && (u = "middle"), a.style.textBaseline = u;
      }
      var f6 = r6.__inheritedStyle;
      if (f6) {
        var d6 = f6.textAlign, v6 = d6;
        d6 && (d6 === "middle" && (v6 = "center"), a.style.textAlign = v6);
      }
    }
    var J9e = /^url\(\s*#(.*?)\)/;
    function Sve(a, r6, t2, s) {
      var u = t2 && t2.match(J9e);
      if (u) {
        var f6 = mu(u[1]);
        s.push([a, r6, f6]);
        return;
      }
      return t2 === "none" && (t2 = null), t2;
    }
    function Q9e(a, r6) {
      for (var t2 = 0; t2 < r6.length; t2++) {
        var s = r6[t2];
        s[0].style[s[1]] = a[s[2]];
      }
    }
    var e7e = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
    function cz(a) {
      return a.match(e7e) || [];
    }
    var t7e = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, AX = Math.PI / 180;
    function n7e(a, r6) {
      var t2 = a.getAttribute("transform");
      if (t2) {
        t2 = t2.replace(/,/g, " ");
        var s = [], u = null;
        t2.replace(t7e, function(S, M, A6) {
          return s.push(M, A6), "";
        });
        for (var f6 = s.length - 1; f6 > 0; f6 -= 2) {
          var d6 = s[f6], v6 = s[f6 - 1], m6 = cz(d6);
          switch (u = u || og(), v6) {
            case "translate":
              sg(u, u, [parseFloat(m6[0]), parseFloat(m6[1] || "0")]);
              break;
            case "scale":
              rD(u, u, [parseFloat(m6[0]), parseFloat(m6[1] || m6[0])]);
              break;
            case "rotate":
              yb(u, u, -parseFloat(m6[0]) * AX);
              break;
            case "skewX":
              var b6 = Math.tan(parseFloat(m6[0]) * AX);
              Qy(u, [1, 0, b6, 1, 0, 0], u);
              break;
            case "skewY":
              var x6 = Math.tan(parseFloat(m6[0]) * AX);
              Qy(u, [1, x6, 0, 1, 0, 0], u);
              break;
            case "matrix":
              u[0] = parseFloat(m6[0]), u[1] = parseFloat(m6[1]), u[2] = parseFloat(m6[2]), u[3] = parseFloat(m6[3]), u[4] = parseFloat(m6[4]), u[5] = parseFloat(m6[5]);
              break;
          }
        }
        r6.setLocalTransform(u);
      }
    }
    var Cve = /([^\s:;]+)\s*:\s*([^:;]+)/g;
    function Mve(a, r6, t2) {
      var s = a.getAttribute("style");
      if (s) {
        Cve.lastIndex = 0;
        for (var u; (u = Cve.exec(s)) != null; ) {
          var f6 = u[1], d6 = Da(lz, f6) ? lz[f6] : null;
          d6 && (r6[d6] = u[2]);
          var v6 = Da(uz, f6) ? uz[f6] : null;
          v6 && (t2[v6] = u[2]);
        }
      }
    }
    function r7e(a, r6, t2) {
      for (var s = 0; s < mve.length; s++) {
        var u = mve[s], f6 = a.getAttribute(u);
        f6 != null && (r6[lz[u]] = f6);
      }
      for (var s = 0; s < yve.length; s++) {
        var u = yve[s], f6 = a.getAttribute(u);
        f6 != null && (t2[uz[u]] = f6);
      }
    }
    function Ave(a, r6) {
      var t2 = r6.width / a.width, s = r6.height / a.height, u = Math.min(t2, s);
      return { scale: u, x: -(a.x + a.width / 2) * u + (r6.x + r6.width / 2), y: -(a.y + a.height / 2) * u + (r6.y + r6.height / 2) };
    }
    function a7e(a, r6) {
      var t2 = new X9e();
      return t2.parse(a, r6);
    }
    var i7e = Ta(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), o7e = function() {
      function a(r6, t2) {
        this.type = "geoSVG", this._usedGraphicMap = Ta(), this._freedGraphics = [], this._mapName = r6, this._parsedXML = gve(t2);
      }
      return a.prototype.load = function() {
        var r6 = this._firstGraphic;
        if (!r6) {
          r6 = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(r6), this._boundingRect = this._firstGraphic.boundingRect.clone();
          var t2 = l7e(r6.named), s = t2.regions, u = t2.regionsMap;
          this._regions = s, this._regionsMap = u;
        }
        return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
      }, a.prototype._buildGraphic = function(r6) {
        var t2, s;
        try {
          t2 = r6 && a7e(r6, { ignoreViewBox: true, ignoreRootClip: true }) || {}, s = t2.root, Hd(s != null);
        } catch (F) {
          throw new Error(`Invalid svg format
` + F.message);
        }
        var u = new bi();
        u.add(s), u.isGeoSVGGraphicRoot = true;
        var f6 = t2.width, d6 = t2.height, v6 = t2.viewBoxRect, m6 = this._boundingRect;
        if (!m6) {
          var b6 = void 0, x6 = void 0, S = void 0, M = void 0;
          if (f6 != null ? (b6 = 0, S = f6) : v6 && (b6 = v6.x, S = v6.width), d6 != null ? (x6 = 0, M = d6) : v6 && (x6 = v6.y, M = v6.height), b6 == null || x6 == null) {
            var A6 = s.getBoundingRect();
            b6 == null && (b6 = A6.x, S = A6.width), x6 == null && (x6 = A6.y, M = A6.height);
          }
          m6 = this._boundingRect = new Qi(b6, x6, S, M);
        }
        if (v6) {
          var I = Ave(v6, m6);
          s.scaleX = s.scaleY = I.scale, s.x = I.x, s.y = I.y;
        }
        u.setClipPath(new rs({ shape: m6.plain() }));
        var R = [];
        return Ne(t2.named, function(F) {
          i7e.get(F.svgNodeTagLower) != null && (R.push(F), s7e(F.el));
        }), { root: u, boundingRect: m6, named: R };
      }, a.prototype.useGraphic = function(r6) {
        var t2 = this._usedGraphicMap, s = t2.get(r6);
        return s || (s = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), t2.set(r6, s), s);
      }, a.prototype.freeGraphic = function(r6) {
        var t2 = this._usedGraphicMap, s = t2.get(r6);
        s && (t2.removeKey(r6), this._freedGraphics.push(s));
      }, a;
    }();
    function s7e(a) {
      a.silent = false, a.isGroup && a.traverse(function(r6) {
        r6.silent = false;
      });
    }
    function l7e(a) {
      var r6 = [], t2 = Ta();
      return Ne(a, function(s) {
        if (s.namedFrom == null) {
          var u = new AFe(s.name, s.el);
          r6.push(u), t2.set(s.name, u);
        }
      }), { regions: r6, regionsMap: t2 };
    }
    for (var EX = [126, 25], Eve = "\u5357\u6D77\u8BF8\u5C9B", AA = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]], EA = 0; EA < AA.length; EA++)
      for (var y5 = 0; y5 < AA[EA].length; y5++)
        AA[EA][y5][0] /= 10.5, AA[EA][y5][1] /= -10.5 / 0.75, AA[EA][y5][0] += EX[0], AA[EA][y5][1] += EX[1];
    function u7e(a, r6) {
      if (a === "china") {
        for (var t2 = 0; t2 < r6.length; t2++)
          if (r6[t2].name === Eve)
            return;
        r6.push(new _de(Eve, wr(AA, function(s) {
          return { type: "polygon", exterior: s };
        }), EX));
      }
    }
    var c7e = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
    function f7e(a, r6) {
      if (a === "china") {
        var t2 = c7e[r6.name];
        if (t2) {
          var s = r6.getCenter();
          s[0] += t2[0] / 10.5, s[1] += -t2[1] / (10.5 / 0.75), r6.setCenter(s);
        }
      }
    }
    var h7e = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
    function d7e(a, r6) {
      a === "china" && r6.name === "\u53F0\u6E7E" && r6.geometries.push({ type: "polygon", exterior: h7e[0] });
    }
    var p7e = "name", v7e = function() {
      function a(r6, t2, s) {
        this.type = "geoJSON", this._parsedMap = Ta(), this._mapName = r6, this._specialAreas = s, this._geoJSON = m7e(t2);
      }
      return a.prototype.load = function(r6, t2) {
        t2 = t2 || p7e;
        var s = this._parsedMap.get(t2);
        if (!s) {
          var u = this._parseToRegions(t2);
          s = this._parsedMap.set(t2, { regions: u, boundingRect: g7e(u) });
        }
        var f6 = Ta(), d6 = [];
        return Ne(s.regions, function(v6) {
          var m6 = v6.name;
          r6 && Da(r6, m6) && (v6 = v6.cloneShallow(m6 = r6[m6])), d6.push(v6), f6.set(m6, v6);
        }), { regions: d6, boundingRect: s.boundingRect || new Qi(0, 0, 0, 0), regionsMap: f6 };
      }, a.prototype._parseToRegions = function(r6) {
        var t2 = this._mapName, s = this._geoJSON, u;
        try {
          u = s ? IFe(s, r6) : [];
        } catch (f6) {
          throw new Error(`Invalid geoJson format
` + f6.message);
        }
        return u7e(t2, u), Ne(u, function(f6) {
          var d6 = f6.name;
          f7e(t2, f6), d7e(t2, f6);
          var v6 = this._specialAreas && this._specialAreas[d6];
          v6 && f6.transformTo(v6.left, v6.top, v6.width, v6.height);
        }, this), u;
      }, a.prototype.getMapForUser = function() {
        return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
      }, a;
    }();
    function g7e(a) {
      for (var r6, t2 = 0; t2 < a.length; t2++) {
        var s = a[t2].getBoundingRect();
        r6 = r6 || s.clone(), r6.union(s);
      }
      return r6;
    }
    function m7e(a) {
      return _a2(a) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(a) : new Function("return (" + a + ");")() : a;
    }
    var r4 = Ta(), qx = { registerMap: function(a, r6, t2) {
      if (r6.svg) {
        var s = new o7e(a, r6.svg);
        r4.set(a, s);
      } else {
        var u = r6.geoJson || r6.geoJSON;
        u && !r6.features ? t2 = r6.specialAreas : u = r6;
        var s = new v7e(a, u, t2);
        r4.set(a, s);
      }
    }, getGeoResource: function(a) {
      return r4.get(a);
    }, getMapForUser: function(a) {
      var r6 = r4.get(a);
      return r6 && r6.type === "geoJSON" && r6.getMapForUser();
    }, load: function(a, r6, t2) {
      var s = r4.get(a);
      if (s)
        return s.load(r6, t2);
    } }, IX = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], y7e = Ta(IX), b7e = Ta(IX.concat(["g"])), _7e = Ta(IX.concat(["g"])), Ive = Xo();
    function fz(a) {
      var r6 = a.getItemStyle(), t2 = a.get("areaColor");
      return t2 != null && (r6.fill = t2), r6;
    }
    function Tve(a) {
      var r6 = a.style;
      r6 && (r6.stroke = r6.stroke || r6.fill, r6.fill = null);
    }
    var x7e = function() {
      function a(r6) {
        var t2 = new bi();
        this.uid = YD("ec_map_draw"), this._controller = new n4(r6.getZr()), this._controllerHost = { target: t2 }, this.group = t2, t2.add(this._regionsGroup = new bi()), t2.add(this._svgGroup = new bi());
      }
      return a.prototype.draw = function(r6, t2, s, u, f6) {
        var d6 = r6.mainType === "geo", v6 = r6.getData && r6.getData();
        d6 && t2.eachComponent({ mainType: "series", subType: "map" }, function(j) {
          !v6 && j.getHostGeoModel() === r6 && (v6 = j.getData());
        });
        var m6 = r6.coordinateSystem, b6 = this._regionsGroup, x6 = this.group, S = m6.getTransformInfo(), M = S.raw, A6 = S.roam, I = !b6.childAt(0) || f6;
        I ? (x6.x = A6.x, x6.y = A6.y, x6.scaleX = A6.scaleX, x6.scaleY = A6.scaleY, x6.dirty()) : fs(x6, A6, r6);
        var R = v6 && v6.getVisual("visualMeta") && v6.getVisual("visualMeta").length > 0, F = { api: s, geo: m6, mapOrGeoModel: r6, data: v6, isVisualEncodedByVisualMap: R, isGeo: d6, transformInfoRaw: M };
        m6.resourceType === "geoJSON" ? this._buildGeoJSON(F) : m6.resourceType === "geoSVG" && this._buildSVG(F), this._updateController(r6, t2, s), this._updateMapSelectHandler(r6, b6, s, u);
      }, a.prototype._buildGeoJSON = function(r6) {
        var t2 = this._regionsGroupByName = Ta(), s = Ta(), u = this._regionsGroup, f6 = r6.transformInfoRaw, d6 = r6.mapOrGeoModel, v6 = r6.data, m6 = r6.geo.projection, b6 = m6 && m6.stream;
        function x6(A6, I) {
          return I && (A6 = I(A6)), A6 && [A6[0] * f6.scaleX + f6.x, A6[1] * f6.scaleY + f6.y];
        }
        function S(A6) {
          for (var I = [], R = !b6 && m6 && m6.project, F = 0; F < A6.length; ++F) {
            var j = x6(A6[F], R);
            j && I.push(j);
          }
          return I;
        }
        function M(A6) {
          return { shape: { points: S(A6) } };
        }
        u.removeAll(), Ne(r6.geo.regions, function(A6) {
          var I = A6.name, R = t2.get(I), F = s.get(I) || {}, j = F.dataIdx, $ = F.regionModel;
          R || (R = t2.set(I, new bi()), u.add(R), j = v6 ? v6.indexOfName(I) : null, $ = r6.isGeo ? d6.getRegionModel(I) : v6 ? v6.getItemModel(j) : null, s.set(I, { dataIdx: j, regionModel: $ }));
          var K = [], U = [];
          Ne(A6.geometries, function(pe) {
            if (pe.type === "polygon") {
              var _e = [pe.exterior].concat(pe.interiors || []);
              b6 && (_e = Rve(_e, b6)), Ne(_e, function(Ae) {
                K.push(new ud(M(Ae)));
              });
            } else {
              var xe = pe.points;
              b6 && (xe = Rve(xe, b6, true)), Ne(xe, function(Ae) {
                U.push(new Vp(M(Ae)));
              });
            }
          });
          var he = x6(A6.getCenter(), m6 && m6.project);
          function ue(pe, _e) {
            if (pe.length) {
              var xe = new iR({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: pe } });
              R.add(xe), Dve(r6, xe, j, $), kve(r6, xe, I, $, d6, j, he), _e && (Tve(xe), Ne(xe.states, Tve));
            }
          }
          ue(K), ue(U, true);
        }), t2.each(function(A6, I) {
          var R = s.get(I), F = R.dataIdx, j = R.regionModel;
          Pve(r6, A6, I, j, d6, F), Lve(r6, A6, I, j, d6), Ove(r6, A6, I, j, d6);
        }, this);
      }, a.prototype._buildSVG = function(r6) {
        var t2 = r6.geo.map, s = r6.transformInfoRaw;
        this._svgGroup.x = s.x, this._svgGroup.y = s.y, this._svgGroup.scaleX = s.scaleX, this._svgGroup.scaleY = s.scaleY, this._svgResourceChanged(t2) && (this._freeSVG(), this._useSVG(t2));
        var u = this._svgDispatcherMap = Ta(), f6 = false;
        Ne(this._svgGraphicRecord.named, function(d6) {
          var v6 = d6.name, m6 = r6.mapOrGeoModel, b6 = r6.data, x6 = d6.svgNodeTagLower, S = d6.el, M = b6 ? b6.indexOfName(v6) : null, A6 = m6.getRegionModel(v6);
          if (y7e.get(x6) != null && S instanceof cg && Dve(r6, S, M, A6), S instanceof cg && (S.culling = true), S.z2EmphasisLift = 0, !d6.namedFrom && (_7e.get(x6) != null && kve(r6, S, v6, A6, m6, M, null), Pve(r6, S, v6, A6, m6, M), Lve(r6, S, v6, A6, m6), b7e.get(x6) != null)) {
            var I = Ove(r6, S, v6, A6, m6);
            I === "self" && (f6 = true);
            var R = u.get(v6) || u.set(v6, []);
            R.push(S);
          }
        }, this), this._enableBlurEntireSVG(f6, r6);
      }, a.prototype._enableBlurEntireSVG = function(r6, t2) {
        if (r6 && t2.isGeo) {
          var s = t2.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), u = s.opacity;
          this._svgGraphicRecord.root.traverse(function(f6) {
            if (!f6.isGroup) {
              fg(f6);
              var d6 = f6.ensureState("blur").style || {};
              d6.opacity == null && u != null && (d6.opacity = u), f6.ensureState("emphasis");
            }
          });
        }
      }, a.prototype.remove = function() {
        this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
      }, a.prototype.findHighDownDispatchers = function(r6, t2) {
        if (r6 == null)
          return [];
        var s = t2.coordinateSystem;
        if (s.resourceType === "geoJSON") {
          var u = this._regionsGroupByName;
          if (u) {
            var f6 = u.get(r6);
            return f6 ? [f6] : [];
          }
        } else if (s.resourceType === "geoSVG")
          return this._svgDispatcherMap && this._svgDispatcherMap.get(r6) || [];
      }, a.prototype._svgResourceChanged = function(r6) {
        return this._svgMapName !== r6;
      }, a.prototype._useSVG = function(r6) {
        var t2 = qx.getGeoResource(r6);
        if (t2 && t2.type === "geoSVG") {
          var s = t2.useGraphic(this.uid);
          this._svgGroup.add(s.root), this._svgGraphicRecord = s, this._svgMapName = r6;
        }
      }, a.prototype._freeSVG = function() {
        var r6 = this._svgMapName;
        if (r6 != null) {
          var t2 = qx.getGeoResource(r6);
          t2 && t2.type === "geoSVG" && t2.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
        }
      }, a.prototype._updateController = function(r6, t2, s) {
        var u = r6.coordinateSystem, f6 = this._controller, d6 = this._controllerHost;
        d6.zoomLimit = r6.get("scaleLimit"), d6.zoom = u.getZoom(), f6.enable(r6.get("roam") || false);
        var v6 = r6.mainType;
        function m6() {
          var b6 = { type: "geoRoam", componentType: v6 };
          return b6[v6 + "Id"] = r6.id, b6;
        }
        f6.off("pan").on("pan", function(b6) {
          this._mouseDownFlag = false, SX(d6, b6.dx, b6.dy), s.dispatchAction(qn(m6(), { dx: b6.dx, dy: b6.dy, animation: { duration: 0 } }));
        }, this), f6.off("zoom").on("zoom", function(b6) {
          this._mouseDownFlag = false, CX(d6, b6.scale, b6.originX, b6.originY), s.dispatchAction(qn(m6(), { zoom: b6.scale, originX: b6.originX, originY: b6.originY, animation: { duration: 0 } }));
        }, this), f6.setPointerChecker(function(b6, x6, S) {
          return u.containPoint([x6, S]) && !sz(b6, s, r6);
        });
      }, a.prototype.resetForLabelLayout = function() {
        this.group.traverse(function(r6) {
          var t2 = r6.getTextContent();
          t2 && (t2.ignore = Ive(t2).ignore);
        });
      }, a.prototype._updateMapSelectHandler = function(r6, t2, s, u) {
        var f6 = this;
        t2.off("mousedown"), t2.off("click"), r6.get("selectedMode") && (t2.on("mousedown", function() {
          f6._mouseDownFlag = true;
        }), t2.on("click", function(d6) {
          !f6._mouseDownFlag || (f6._mouseDownFlag = false);
        }));
      }, a;
    }();
    function Dve(a, r6, t2, s) {
      var u = s.getModel("itemStyle"), f6 = s.getModel(["emphasis", "itemStyle"]), d6 = s.getModel(["blur", "itemStyle"]), v6 = s.getModel(["select", "itemStyle"]), m6 = fz(u), b6 = fz(f6), x6 = fz(v6), S = fz(d6), M = a.data;
      if (M) {
        var A6 = M.getItemVisual(t2, "style"), I = M.getItemVisual(t2, "decal");
        a.isVisualEncodedByVisualMap && A6.fill && (m6.fill = A6.fill), I && (m6.decal = DR(I, a.api));
      }
      r6.setStyle(m6), r6.style.strokeNoScale = true, r6.ensureState("emphasis").style = b6, r6.ensureState("select").style = x6, r6.ensureState("blur").style = S, fg(r6);
    }
    function kve(a, r6, t2, s, u, f6, d6) {
      var v6 = a.data, m6 = a.isGeo, b6 = v6 && isNaN(v6.get(v6.mapDimension("value"), f6)), x6 = v6 && v6.getItemLayout(f6);
      if (m6 || b6 || x6 && x6.showLabel) {
        var S = m6 ? t2 : f6, M = void 0;
        (!v6 || f6 >= 0) && (M = u);
        var A6 = d6 ? { normal: { align: "center", verticalAlign: "middle" } } : null;
        Bp(r6, hd(s), { labelFetcher: M, labelDataIndex: S, defaultText: t2 }, A6);
        var I = r6.getTextContent();
        if (I && (Ive(I).ignore = I.ignore, r6.textConfig && d6)) {
          var R = r6.getBoundingRect().clone();
          r6.textConfig.layoutRect = R, r6.textConfig.position = [(d6[0] - R.x) / R.width * 100 + "%", (d6[1] - R.y) / R.height * 100 + "%"];
        }
        r6.disableLabelAnimation = true;
      } else
        r6.removeTextContent(), r6.removeTextConfig(), r6.disableLabelAnimation = null;
    }
    function Pve(a, r6, t2, s, u, f6) {
      a.data ? a.data.setItemGraphicEl(f6, r6) : ii(r6).eventData = { componentType: "geo", componentIndex: u.componentIndex, geoIndex: u.componentIndex, name: t2, region: s && s.option || {} };
    }
    function Lve(a, r6, t2, s, u) {
      a.data || fd({ el: r6, componentModel: u, itemName: t2, itemTooltipOption: s.get("tooltip") });
    }
    function Ove(a, r6, t2, s, u) {
      r6.highDownSilentOnTouch = !!u.get("selectedMode");
      var f6 = s.getModel("emphasis"), d6 = f6.get("focus");
      return Cc(r6, d6, f6.get("blurScope"), f6.get("disabled")), a.isGeo && Xq(r6, u, t2), d6;
    }
    function Rve(a, r6, t2) {
      var s = [], u;
      function f6() {
        u = [];
      }
      function d6() {
        u.length && (s.push(u), u = []);
      }
      var v6 = r6({ polygonStart: f6, polygonEnd: d6, lineStart: f6, lineEnd: d6, point: function(m6, b6) {
        isFinite(m6) && isFinite(b6) && u.push([m6, b6]);
      }, sphere: function() {
      } });
      return !t2 && v6.polygonStart(), Ne(a, function(m6) {
        v6.lineStart();
        for (var b6 = 0; b6 < m6.length; b6++)
          v6.point(m6[b6][0], m6[b6][1]);
        v6.lineEnd();
      }), !t2 && v6.polygonEnd(), s;
    }
    var Fve = x7e, w7e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        if (!(f6 && f6.type === "mapToggleSelect" && f6.from === this.uid)) {
          var d6 = this.group;
          if (d6.removeAll(), !t2.getHostGeoModel()) {
            if (this._mapDraw && f6 && f6.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), f6 && f6.type === "geoRoam" && f6.componentType === "series" && f6.seriesId === t2.id) {
              var v6 = this._mapDraw;
              v6 && d6.add(v6.group);
            } else if (t2.needsDrawMap) {
              var v6 = this._mapDraw || new Fve(u);
              d6.add(v6.group), v6.draw(t2, s, u, this, f6), this._mapDraw = v6;
            } else
              this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
            t2.get("showLegendSymbol") && s.getComponent("legend") && this._renderSymbols(t2, s, u);
          }
        }
      }, r6.prototype.remove = function() {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
      }, r6.prototype.dispose = function() {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
      }, r6.prototype._renderSymbols = function(t2, s, u) {
        var f6 = t2.originalData, d6 = this.group;
        f6.each(f6.mapDimension("value"), function(v6, m6) {
          if (!isNaN(v6)) {
            var b6 = f6.getItemLayout(m6);
            if (!(!b6 || !b6.point)) {
              var x6 = b6.point, S = b6.offset, M = new Em({ style: { fill: t2.getData().getVisual("style").fill }, shape: { cx: x6[0] + S * 9, cy: x6[1], r: 3 }, silent: true, z2: 8 + (S ? 0 : j2 + 1) });
              if (!S) {
                var A6 = t2.mainSeries.getData(), I = f6.getName(m6), R = A6.indexOfName(I), F = f6.getItemModel(m6), j = F.getModel("label"), $ = A6.getItemGraphicEl(R);
                Bp(M, hd(F), { labelFetcher: { getFormattedLabel: function(K, U) {
                  return t2.getFormattedLabel(R, U);
                } }, defaultText: I }), M.disableLabelAnimation = true, j.get("position") || M.setTextConfig({ position: "bottom" }), $.onHoverStateChange = function(K) {
                  Lb(M, K);
                };
              }
              d6.add(M);
            }
          }
        });
      }, r6.type = "map", r6;
    }(bu), S7e = w7e, C7e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.needsDrawMap = false, t2.seriesGroup = [], t2.getTooltipPosition = function(s) {
          if (s != null) {
            var u = this.getData().getName(s), f6 = this.coordinateSystem, d6 = f6.getRegion(u);
            return d6 && f6.dataToPoint(d6.getCenter());
          }
        }, t2;
      }
      return r6.prototype.getInitialData = function(t2) {
        for (var s = g5(this, { coordDimensions: ["value"], encodeDefaulter: Oi(VY, this) }), u = Ta(), f6 = [], d6 = 0, v6 = s.count(); d6 < v6; d6++) {
          var m6 = s.getName(d6);
          u.set(m6, true);
        }
        var b6 = qx.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
        return Ne(b6.regions, function(x6) {
          var S = x6.name;
          u.get(S) || f6.push(S);
        }), s.appendValues([], f6), s;
      }, r6.prototype.getHostGeoModel = function() {
        var t2 = this.option.geoIndex;
        return t2 != null ? this.ecModel.getComponent("geo", t2) : null;
      }, r6.prototype.getMapType = function() {
        return (this.getHostGeoModel() || this).option.map;
      }, r6.prototype.getRawValue = function(t2) {
        var s = this.getData();
        return s.get(s.mapDimension("value"), t2);
      }, r6.prototype.getRegionModel = function(t2) {
        var s = this.getData();
        return s.getItemModel(s.indexOfName(t2));
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        for (var f6 = this.getData(), d6 = this.getRawValue(t2), v6 = f6.getName(t2), m6 = this.seriesGroup, b6 = [], x6 = 0; x6 < m6.length; x6++) {
          var S = m6[x6].originalData.indexOfName(v6), M = f6.mapDimension("value");
          isNaN(m6[x6].originalData.get(M, S)) || b6.push(m6[x6].name);
        }
        return Ih("section", { header: b6.join(", "), noHeader: !b6.length, blocks: [Ih("nameValue", { name: v6, value: d6 })] });
      }, r6.prototype.setZoom = function(t2) {
        this.option.zoom = t2;
      }, r6.prototype.setCenter = function(t2) {
        this.option.center = t2;
      }, r6.prototype.getLegendIcon = function(t2) {
        var s = t2.icon || "roundRect", u = Lf(s, 0, 0, t2.itemWidth, t2.itemHeight, t2.itemStyle.fill);
        return u.setStyle(t2.itemStyle), u.style.stroke = "none", s.indexOf("empty") > -1 && (u.style.stroke = u.style.fill, u.style.fill = "#fff", u.style.lineWidth = 2), u;
      }, r6.type = "series.map", r6.dependencies = ["geo"], r6.layoutMode = "box", r6.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, r6;
    }(sc), M7e = C7e;
    function A7e(a, r6) {
      var t2 = {};
      return Ne(a, function(s) {
        s.each(s.mapDimension("value"), function(u, f6) {
          var d6 = "ec-" + s.getName(f6);
          t2[d6] = t2[d6] || [], isNaN(u) || t2[d6].push(u);
        });
      }), a[0].map(a[0].mapDimension("value"), function(s, u) {
        for (var f6 = "ec-" + a[0].getName(u), d6 = 0, v6 = 1 / 0, m6 = -1 / 0, b6 = t2[f6].length, x6 = 0; x6 < b6; x6++)
          v6 = Math.min(v6, t2[f6][x6]), m6 = Math.max(m6, t2[f6][x6]), d6 += t2[f6][x6];
        var S;
        return r6 === "min" ? S = v6 : r6 === "max" ? S = m6 : r6 === "average" ? S = d6 / b6 : S = d6, b6 === 0 ? NaN : S;
      });
    }
    function E7e(a) {
      var r6 = {};
      a.eachSeriesByType("map", function(t2) {
        var s = t2.getHostGeoModel(), u = s ? "o" + s.id : "i" + t2.getMapType();
        (r6[u] = r6[u] || []).push(t2);
      }), Ne(r6, function(t2, s) {
        for (var u = A7e(wr(t2, function(d6) {
          return d6.getData();
        }), t2[0].get("mapValueCalculation")), f6 = 0; f6 < t2.length; f6++)
          t2[f6].originalData = t2[f6].getData();
        for (var f6 = 0; f6 < t2.length; f6++)
          t2[f6].seriesGroup = t2, t2[f6].needsDrawMap = f6 === 0 && !t2[f6].getHostGeoModel(), t2[f6].setData(u.cloneShallow()), t2[f6].mainSeries = t2[0];
      });
    }
    function I7e(a) {
      var r6 = {};
      a.eachSeriesByType("map", function(t2) {
        var s = t2.getMapType();
        if (!(t2.getHostGeoModel() || r6[s])) {
          var u = {};
          Ne(t2.seriesGroup, function(d6) {
            var v6 = d6.coordinateSystem, m6 = d6.originalData;
            d6.get("showLegendSymbol") && a.getComponent("legend") && m6.each(m6.mapDimension("value"), function(b6, x6) {
              var S = m6.getName(x6), M = v6.getRegion(S);
              if (!(!M || isNaN(b6))) {
                var A6 = u[S] || 0, I = v6.dataToPoint(M.getCenter());
                u[S] = A6 + 1, m6.setItemLayout(x6, { point: I, offset: A6 });
              }
            });
          });
          var f6 = t2.getData();
          f6.each(function(d6) {
            var v6 = f6.getName(d6), m6 = f6.getItemLayout(d6) || {};
            m6.showLabel = !u[v6], f6.setItemLayout(d6, m6);
          }), r6[s] = true;
        }
      });
    }
    var Nve = Qf, T7e = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this) || this;
        return s.type = "view", s.dimensions = ["x", "y"], s._roamTransformable = new a0(), s._rawTransformable = new a0(), s.name = t2, s;
      }
      return r6.prototype.setBoundingRect = function(t2, s, u, f6) {
        return this._rect = new Qi(t2, s, u, f6), this._rect;
      }, r6.prototype.getBoundingRect = function() {
        return this._rect;
      }, r6.prototype.setViewRect = function(t2, s, u, f6) {
        this._transformTo(t2, s, u, f6), this._viewRect = new Qi(t2, s, u, f6);
      }, r6.prototype._transformTo = function(t2, s, u, f6) {
        var d6 = this.getBoundingRect(), v6 = this._rawTransformable;
        v6.transform = d6.calculateTransform(new Qi(t2, s, u, f6));
        var m6 = v6.parent;
        v6.parent = null, v6.decomposeTransform(), v6.parent = m6, this._updateTransform();
      }, r6.prototype.setCenter = function(t2) {
        !t2 || (this._center = t2, this._updateCenterAndZoom());
      }, r6.prototype.setZoom = function(t2) {
        t2 = t2 || 1;
        var s = this.zoomLimit;
        s && (s.max != null && (t2 = Math.min(s.max, t2)), s.min != null && (t2 = Math.max(s.min, t2))), this._zoom = t2, this._updateCenterAndZoom();
      }, r6.prototype.getDefaultCenter = function() {
        var t2 = this.getBoundingRect(), s = t2.x + t2.width / 2, u = t2.y + t2.height / 2;
        return [s, u];
      }, r6.prototype.getCenter = function() {
        return this._center || this.getDefaultCenter();
      }, r6.prototype.getZoom = function() {
        return this._zoom || 1;
      }, r6.prototype.getRoamTransform = function() {
        return this._roamTransformable.getLocalTransform();
      }, r6.prototype._updateCenterAndZoom = function() {
        var t2 = this._rawTransformable.getLocalTransform(), s = this._roamTransformable, u = this.getDefaultCenter(), f6 = this.getCenter(), d6 = this.getZoom();
        f6 = Qf([], f6, t2), u = Qf([], u, t2), s.originX = f6[0], s.originY = f6[1], s.x = u[0] - f6[0], s.y = u[1] - f6[1], s.scaleX = s.scaleY = d6, this._updateTransform();
      }, r6.prototype._updateTransform = function() {
        var t2 = this._roamTransformable, s = this._rawTransformable;
        s.parent = t2, t2.updateTransform(), s.updateTransform(), PM(this.transform || (this.transform = []), s.transform || og()), this._rawTransform = s.getLocalTransform(), this.invTransform = this.invTransform || [], px(this.invTransform, this.transform), this.decomposeTransform();
      }, r6.prototype.getTransformInfo = function() {
        var t2 = this._rawTransformable, s = this._roamTransformable, u = new a0();
        return u.transform = s.transform, u.decomposeTransform(), { roam: { x: u.x, y: u.y, scaleX: u.scaleX, scaleY: u.scaleY }, raw: { x: t2.x, y: t2.y, scaleX: t2.scaleX, scaleY: t2.scaleY } };
      }, r6.prototype.getViewRect = function() {
        return this._viewRect;
      }, r6.prototype.getViewRectAfterRoam = function() {
        var t2 = this.getBoundingRect().clone();
        return t2.applyTransform(this.transform), t2;
      }, r6.prototype.dataToPoint = function(t2, s, u) {
        var f6 = s ? this._rawTransform : this.transform;
        return u = u || [], f6 ? Nve(u, t2, f6) : $d(u, t2);
      }, r6.prototype.pointToData = function(t2) {
        var s = this.invTransform;
        return s ? Nve([], t2, s) : [t2[0], t2[1]];
      }, r6.prototype.convertToPixel = function(t2, s, u) {
        var f6 = Vve(s);
        return f6 === this ? f6.dataToPoint(u) : null;
      }, r6.prototype.convertFromPixel = function(t2, s, u) {
        var f6 = Vve(s);
        return f6 === this ? f6.pointToData(u) : null;
      }, r6.prototype.containPoint = function(t2) {
        return this.getViewRectAfterRoam().contain(t2[0], t2[1]);
      }, r6.dimensions = ["x", "y"], r6;
    }(a0);
    function Vve(a) {
      var r6 = a.seriesModel;
      return r6 ? r6.coordinateSystem : null;
    }
    var a4 = T7e, D7e = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, zve = ["lng", "lat"], Bve = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this, t2) || this;
        f6.dimensions = zve, f6.type = "geo", f6._nameCoordMap = Ta(), f6.map = s;
        var d6 = u.projection, v6 = qx.load(s, u.nameMap, u.nameProperty), m6 = qx.getGeoResource(s);
        f6.resourceType = m6 ? m6.type : null;
        var b6 = f6.regions = v6.regions, x6 = D7e[m6.type];
        f6._regionsMap = v6.regionsMap, f6.regions = v6.regions, f6.projection = d6;
        var S;
        if (d6)
          for (var M = 0; M < b6.length; M++) {
            var A6 = b6[M].getBoundingRect(d6);
            S = S || A6.clone(), S.union(A6);
          }
        else
          S = v6.boundingRect;
        return f6.setBoundingRect(S.x, S.y, S.width, S.height), f6.aspectScale = d6 ? 1 : qi(u.aspectScale, x6.aspectScale), f6._invertLongitute = d6 ? false : x6.invertLongitute, f6;
      }
      return r6.prototype._transformTo = function(t2, s, u, f6) {
        var d6 = this.getBoundingRect(), v6 = this._invertLongitute;
        d6 = d6.clone(), v6 && (d6.y = -d6.y - d6.height);
        var m6 = this._rawTransformable;
        m6.transform = d6.calculateTransform(new Qi(t2, s, u, f6));
        var b6 = m6.parent;
        m6.parent = null, m6.decomposeTransform(), m6.parent = b6, v6 && (m6.scaleY = -m6.scaleY), this._updateTransform();
      }, r6.prototype.getRegion = function(t2) {
        return this._regionsMap.get(t2);
      }, r6.prototype.getRegionByCoord = function(t2) {
        for (var s = this.regions, u = 0; u < s.length; u++) {
          var f6 = s[u];
          if (f6.type === "geoJSON" && f6.contain(t2))
            return s[u];
        }
      }, r6.prototype.addGeoCoord = function(t2, s) {
        this._nameCoordMap.set(t2, s);
      }, r6.prototype.getGeoCoord = function(t2) {
        var s = this._regionsMap.get(t2);
        return this._nameCoordMap.get(t2) || s && s.getCenter();
      }, r6.prototype.dataToPoint = function(t2, s, u) {
        if (_a2(t2) && (t2 = this.getGeoCoord(t2)), t2) {
          var f6 = this.projection;
          return f6 && (t2 = f6.project(t2)), t2 && this.projectedToPoint(t2);
        }
      }, r6.prototype.pointToData = function(t2) {
        var s = this.projection;
        return s && (t2 = s.unproject(t2)), t2 && this.pointToProjected(t2);
      }, r6.prototype.pointToProjected = function(t2) {
        return a.prototype.pointToData.call(this, t2);
      }, r6.prototype.projectedToPoint = function(t2, s, u) {
        return a.prototype.dataToPoint.call(this, t2, s, u);
      }, r6.prototype.convertToPixel = function(t2, s, u) {
        var f6 = jve(s);
        return f6 === this ? f6.dataToPoint(u) : null;
      }, r6.prototype.convertFromPixel = function(t2, s, u) {
        var f6 = jve(s);
        return f6 === this ? f6.pointToData(u) : null;
      }, r6;
    }(a4);
    Dc(Bve, a4);
    function jve(a) {
      var r6 = a.geoModel, t2 = a.seriesModel;
      return r6 ? r6.coordinateSystem : t2 ? t2.coordinateSystem || (t2.getReferringComponents("geo", Lc).models[0] || {}).coordinateSystem : null;
    }
    var Gve = Bve;
    function Wve(a, r6) {
      var t2 = a.get("boundingCoords");
      if (t2 != null) {
        var s = t2[0], u = t2[1];
        if (isFinite(s[0]) && isFinite(s[1]) && isFinite(u[0]) && isFinite(u[1])) {
          var f6 = this.projection;
          if (f6) {
            var d6 = s[0], v6 = s[1], m6 = u[0], b6 = u[1];
            s = [1 / 0, 1 / 0], u = [-1 / 0, -1 / 0];
            var x6 = function(ue, pe, _e, xe) {
              for (var Ae = _e - ue, ke = xe - pe, je = 0; je <= 100; je++) {
                var Fe = je / 100, at = f6.project([ue + Ae * Fe, pe + ke * Fe]);
                Yg(s, s, at), xv(u, u, at);
              }
            };
            x6(d6, v6, m6, v6), x6(m6, v6, m6, b6), x6(m6, b6, d6, b6), x6(d6, b6, m6, v6);
          }
          this.setBoundingRect(s[0], s[1], u[0] - s[0], u[1] - s[1]);
        }
      }
      var S = this.getBoundingRect(), M = a.get("layoutCenter"), A6 = a.get("layoutSize"), I = r6.getWidth(), R = r6.getHeight(), F = S.width / S.height * this.aspectScale, j = false, $, K;
      M && A6 && ($ = [ua(M[0], I), ua(M[1], R)], K = ua(A6, Math.min(I, R)), !isNaN($[0]) && !isNaN($[1]) && !isNaN(K) && (j = true));
      var U;
      if (j)
        U = {}, F > 1 ? (U.width = K, U.height = K / F) : (U.height = K, U.width = K * F), U.y = $[1] - U.height / 2, U.x = $[0] - U.width / 2;
      else {
        var he = a.getBoxLayoutParams();
        he.aspect = F, U = ah(he, { width: I, height: R });
      }
      this.setViewRect(U.x, U.y, U.width, U.height), this.setCenter(a.get("center")), this.setZoom(a.get("zoom"));
    }
    function k7e(a, r6) {
      Ne(r6.get("geoCoord"), function(t2, s) {
        a.addGeoCoord(s, t2);
      });
    }
    var P7e = function() {
      function a() {
        this.dimensions = zve;
      }
      return a.prototype.create = function(r6, t2) {
        var s = [];
        function u(d6) {
          return { nameProperty: d6.get("nameProperty"), aspectScale: d6.get("aspectScale"), projection: d6.get("projection") };
        }
        r6.eachComponent("geo", function(d6, v6) {
          var m6 = d6.get("map"), b6 = new Gve(m6 + v6, m6, qn({ nameMap: d6.get("nameMap") }, u(d6)));
          b6.zoomLimit = d6.get("scaleLimit"), s.push(b6), d6.coordinateSystem = b6, b6.model = d6, b6.resize = Wve, b6.resize(d6, t2);
        }), r6.eachSeries(function(d6) {
          var v6 = d6.get("coordinateSystem");
          if (v6 === "geo") {
            var m6 = d6.get("geoIndex") || 0;
            d6.coordinateSystem = s[m6];
          }
        });
        var f6 = {};
        return r6.eachSeriesByType("map", function(d6) {
          if (!d6.getHostGeoModel()) {
            var v6 = d6.getMapType();
            f6[v6] = f6[v6] || [], f6[v6].push(d6);
          }
        }), Ne(f6, function(d6, v6) {
          var m6 = wr(d6, function(x6) {
            return x6.get("nameMap");
          }), b6 = new Gve(v6, v6, qn({ nameMap: ax(m6) }, u(d6[0])));
          b6.zoomLimit = Jf.apply(null, wr(d6, function(x6) {
            return x6.get("scaleLimit");
          })), s.push(b6), b6.resize = Wve, b6.resize(d6[0], t2), Ne(d6, function(x6) {
            x6.coordinateSystem = b6, k7e(b6, x6);
          });
        }), s;
      }, a.prototype.getFilledRegions = function(r6, t2, s, u) {
        for (var f6 = (r6 || []).slice(), d6 = Ta(), v6 = 0; v6 < f6.length; v6++)
          d6.set(f6[v6].name, f6[v6]);
        var m6 = qx.load(t2, s, u);
        return Ne(m6.regions, function(b6) {
          var x6 = b6.name;
          !d6.get(x6) && f6.push({ name: x6 });
        }), f6;
      }, a;
    }(), L7e = new P7e(), Hve = L7e, O7e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        var f6 = qx.getGeoResource(t2.map);
        if (f6 && f6.type === "geoJSON") {
          var d6 = t2.itemStyle = t2.itemStyle || {};
          "color" in d6 || (d6.color = "#eee");
        }
        this.mergeDefaultAndTheme(t2, u), ug(t2, "label", ["show"]);
      }, r6.prototype.optionUpdated = function() {
        var t2 = this, s = this.option;
        s.regions = Hve.getFilledRegions(s.regions, s.map, s.nameMap, s.nameProperty);
        var u = {};
        this._optionModelMap = qg(s.regions || [], function(f6, d6) {
          var v6 = d6.name;
          return v6 && (f6.set(v6, new yu(d6, t2, t2.ecModel)), d6.selected && (u[v6] = true)), f6;
        }, Ta()), s.selectedMap || (s.selectedMap = u);
      }, r6.prototype.getRegionModel = function(t2) {
        return this._optionModelMap.get(t2) || new yu(null, this, this.ecModel);
      }, r6.prototype.getFormattedLabel = function(t2, s) {
        var u = this.getRegionModel(t2), f6 = s === "normal" ? u.get(["label", "formatter"]) : u.get(["emphasis", "label", "formatter"]), d6 = { name: t2 };
        if (ti(f6))
          return d6.status = s, f6(d6);
        if (_a2(f6))
          return f6.replace("{a}", t2 != null ? t2 : "");
      }, r6.prototype.setZoom = function(t2) {
        this.option.zoom = t2;
      }, r6.prototype.setCenter = function(t2) {
        this.option.center = t2;
      }, r6.prototype.select = function(t2) {
        var s = this.option, u = s.selectedMode;
        if (u) {
          u !== "multiple" && (s.selectedMap = null);
          var f6 = s.selectedMap || (s.selectedMap = {});
          f6[t2] = true;
        }
      }, r6.prototype.unSelect = function(t2) {
        var s = this.option.selectedMap;
        s && (s[t2] = false);
      }, r6.prototype.toggleSelected = function(t2) {
        this[this.isSelected(t2) ? "unSelect" : "select"](t2);
      }, r6.prototype.isSelected = function(t2) {
        var s = this.option.selectedMap;
        return !!(s && s[t2]);
      }, r6.type = "geo", r6.layoutMode = "box", r6.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, r6;
    }(Ps), R7e = O7e;
    function $ve(a, r6) {
      return a.pointToProjected ? a.pointToProjected(r6) : a.pointToData(r6);
    }
    function TX(a, r6, t2) {
      var s = a.getZoom(), u = a.getCenter(), f6 = r6.zoom, d6 = a.projectedToPoint ? a.projectedToPoint(u) : a.dataToPoint(u);
      if (r6.dx != null && r6.dy != null && (d6[0] -= r6.dx, d6[1] -= r6.dy, a.setCenter($ve(a, d6))), f6 != null) {
        if (t2) {
          var v6 = t2.min || 0, m6 = t2.max || 1 / 0;
          f6 = Math.max(Math.min(s * f6, m6), v6) / s;
        }
        a.scaleX *= f6, a.scaleY *= f6;
        var b6 = (r6.originX - a.x) * (f6 - 1), x6 = (r6.originY - a.y) * (f6 - 1);
        a.x -= b6, a.y -= x6, a.updateTransform(), a.setCenter($ve(a, d6)), a.setZoom(f6 * s);
      }
      return { center: a.getCenter(), zoom: a.getZoom() };
    }
    var F7e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.focusBlurEnabled = true, t2;
      }
      return r6.prototype.init = function(t2, s) {
        this._api = s;
      }, r6.prototype.render = function(t2, s, u, f6) {
        if (this._model = t2, !t2.get("show")) {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          return;
        }
        this._mapDraw || (this._mapDraw = new Fve(u));
        var d6 = this._mapDraw;
        d6.draw(t2, s, u, this, f6), d6.group.on("click", this._handleRegionClick, this), d6.group.silent = t2.get("silent"), this.group.add(d6.group), this.updateSelectStatus(t2, s, u);
      }, r6.prototype._handleRegionClick = function(t2) {
        var s;
        s5(t2.target, function(u) {
          return (s = ii(u).eventData) != null;
        }, true), s && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: s.name });
      }, r6.prototype.updateSelectStatus = function(t2, s, u) {
        var f6 = this;
        this._mapDraw.group.traverse(function(d6) {
          var v6 = ii(d6).eventData;
          if (v6)
            return f6._model.isSelected(v6.name) ? u.enterSelect(d6) : u.leaveSelect(d6), true;
        });
      }, r6.prototype.findHighDownDispatchers = function(t2) {
        return this._mapDraw && this._mapDraw.findHighDownDispatchers(t2, this._model);
      }, r6.prototype.dispose = function() {
        this._mapDraw && this._mapDraw.remove();
      }, r6.type = "geo", r6;
    }(Rc), N7e = F7e;
    function V7e(a, r6, t2) {
      qx.registerMap(a, r6, t2);
    }
    function Uve(a) {
      a.registerCoordinateSystem("geo", Hve), a.registerComponentModel(R7e), a.registerComponentView(N7e), a.registerImpl("registerMap", V7e), a.registerImpl("getMap", function(t2) {
        return qx.getMapForUser(t2);
      });
      function r6(t2, s) {
        s.update = "geo:updateSelectStatus", a.registerAction(s, function(u, f6) {
          var d6 = {}, v6 = [];
          return f6.eachComponent({ mainType: "geo", query: u }, function(m6) {
            m6[t2](u.name);
            var b6 = m6.coordinateSystem;
            Ne(b6.regions, function(S) {
              d6[S.name] = m6.isSelected(S.name) || false;
            });
            var x6 = [];
            Ne(d6, function(S, M) {
              d6[M] && x6.push(M);
            }), v6.push({ geoIndex: m6.componentIndex, name: x6 });
          }), { selected: d6, allSelected: v6, name: u.name };
        });
      }
      r6("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), r6("select", { type: "geoSelect", event: "geoselected" }), r6("unSelect", { type: "geoUnSelect", event: "geounselected" }), a.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(t2, s) {
        var u = t2.componentType || "series";
        s.eachComponent({ mainType: u, query: t2 }, function(f6) {
          var d6 = f6.coordinateSystem;
          if (d6.type === "geo") {
            var v6 = TX(d6, t2, f6.get("scaleLimit"));
            f6.setCenter && f6.setCenter(v6.center), f6.setZoom && f6.setZoom(v6.zoom), u === "series" && Ne(f6.seriesGroup, function(m6) {
              m6.setCenter(v6.center), m6.setZoom(v6.zoom);
            });
          }
        });
      });
    }
    function z7e(a) {
      bo(Uve), a.registerChartView(S7e), a.registerSeriesModel(M7e), a.registerLayout(I7e), a.registerProcessor(a.PRIORITY.PROCESSOR.STATISTIC, E7e), Yfe("map", a.registerAction);
    }
    function B7e(a) {
      var r6 = a;
      r6.hierNode = { defaultAncestor: null, ancestor: r6, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
      for (var t2 = [r6], s, u; s = t2.pop(); )
        if (u = s.children, s.isExpand && u.length)
          for (var f6 = u.length, d6 = f6 - 1; d6 >= 0; d6--) {
            var v6 = u[d6];
            v6.hierNode = { defaultAncestor: null, ancestor: v6, prelim: 0, modifier: 0, change: 0, shift: 0, i: d6, thread: null }, t2.push(v6);
          }
    }
    function j7e(a, r6) {
      var t2 = a.isExpand ? a.children : [], s = a.parentNode.children, u = a.hierNode.i ? s[a.hierNode.i - 1] : null;
      if (t2.length) {
        H7e(a);
        var f6 = (t2[0].hierNode.prelim + t2[t2.length - 1].hierNode.prelim) / 2;
        u ? (a.hierNode.prelim = u.hierNode.prelim + r6(a, u), a.hierNode.modifier = a.hierNode.prelim - f6) : a.hierNode.prelim = f6;
      } else
        u && (a.hierNode.prelim = u.hierNode.prelim + r6(a, u));
      a.parentNode.hierNode.defaultAncestor = $7e(a, u, a.parentNode.hierNode.defaultAncestor || s[0], r6);
    }
    function G7e(a) {
      var r6 = a.hierNode.prelim + a.parentNode.hierNode.modifier;
      a.setLayout({ x: r6 }, true), a.hierNode.modifier += a.parentNode.hierNode.modifier;
    }
    function qve(a) {
      return arguments.length ? a : Y7e;
    }
    function i4(a, r6) {
      return a -= Math.PI / 2, { x: r6 * Math.cos(a), y: r6 * Math.sin(a) };
    }
    function W7e(a, r6) {
      return ah(a.getBoxLayoutParams(), { width: r6.getWidth(), height: r6.getHeight() });
    }
    function H7e(a) {
      for (var r6 = a.children, t2 = r6.length, s = 0, u = 0; --t2 >= 0; ) {
        var f6 = r6[t2];
        f6.hierNode.prelim += s, f6.hierNode.modifier += s, u += f6.hierNode.change, s += f6.hierNode.shift + u;
      }
    }
    function $7e(a, r6, t2, s) {
      if (r6) {
        for (var u = a, f6 = a, d6 = f6.parentNode.children[0], v6 = r6, m6 = u.hierNode.modifier, b6 = f6.hierNode.modifier, x6 = d6.hierNode.modifier, S = v6.hierNode.modifier; v6 = DX(v6), f6 = kX(f6), v6 && f6; ) {
          u = DX(u), d6 = kX(d6), u.hierNode.ancestor = a;
          var M = v6.hierNode.prelim + S - f6.hierNode.prelim - b6 + s(v6, f6);
          M > 0 && (q7e(U7e(v6, a, t2), a, M), b6 += M, m6 += M), S += v6.hierNode.modifier, b6 += f6.hierNode.modifier, m6 += u.hierNode.modifier, x6 += d6.hierNode.modifier;
        }
        v6 && !DX(u) && (u.hierNode.thread = v6, u.hierNode.modifier += S - m6), f6 && !kX(d6) && (d6.hierNode.thread = f6, d6.hierNode.modifier += b6 - x6, t2 = a);
      }
      return t2;
    }
    function DX(a) {
      var r6 = a.children;
      return r6.length && a.isExpand ? r6[r6.length - 1] : a.hierNode.thread;
    }
    function kX(a) {
      var r6 = a.children;
      return r6.length && a.isExpand ? r6[0] : a.hierNode.thread;
    }
    function U7e(a, r6, t2) {
      return a.hierNode.ancestor.parentNode === r6.parentNode ? a.hierNode.ancestor : t2;
    }
    function q7e(a, r6, t2) {
      var s = t2 / (r6.hierNode.i - a.hierNode.i);
      r6.hierNode.change -= s, r6.hierNode.shift += t2, r6.hierNode.modifier += t2, r6.hierNode.prelim += t2, a.hierNode.change += s;
    }
    function Y7e(a, r6) {
      return a.parentNode === r6.parentNode ? 1 : 2;
    }
    var Z7e = function() {
      function a() {
        this.parentPoint = [], this.childPoints = [];
      }
      return a;
    }(), X7e = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new Z7e();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.childPoints, f6 = u.length, d6 = s.parentPoint, v6 = u[0], m6 = u[f6 - 1];
        if (f6 === 1) {
          t2.moveTo(d6[0], d6[1]), t2.lineTo(v6[0], v6[1]);
          return;
        }
        var b6 = s.orient, x6 = b6 === "TB" || b6 === "BT" ? 0 : 1, S = 1 - x6, M = ua(s.forkPosition, 1), A6 = [];
        A6[x6] = d6[x6], A6[S] = d6[S] + (m6[S] - d6[S]) * M, t2.moveTo(d6[0], d6[1]), t2.lineTo(A6[0], A6[1]), t2.moveTo(v6[0], v6[1]), A6[x6] = v6[x6], t2.lineTo(A6[0], A6[1]), A6[x6] = m6[x6], t2.lineTo(A6[0], A6[1]), t2.lineTo(m6[0], m6[1]);
        for (var I = 1; I < f6 - 1; I++) {
          var R = u[I];
          t2.moveTo(R[0], R[1]), A6[x6] = R[x6], t2.lineTo(A6[0], A6[1]);
        }
      }, r6;
    }(uo), K7e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._mainGroup = new bi(), t2;
      }
      return r6.prototype.init = function(t2, s) {
        this._controller = new n4(s.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
      }, r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = t2.layoutInfo, v6 = this._mainGroup, m6 = t2.get("layout");
        m6 === "radial" ? (v6.x = d6.x + d6.width / 2, v6.y = d6.y + d6.height / 2) : (v6.x = d6.x, v6.y = d6.y), this._updateViewCoordSys(t2), this._updateController(t2, s, u);
        var b6 = this._data;
        f6.diff(b6).add(function(x6) {
          Yve(f6, x6) && Zve(f6, x6, null, v6, t2);
        }).update(function(x6, S) {
          var M = b6.getItemGraphicEl(S);
          if (!Yve(f6, x6)) {
            M && Jve(b6, S, M, v6, t2);
            return;
          }
          Zve(f6, x6, M, v6, t2);
        }).remove(function(x6) {
          var S = b6.getItemGraphicEl(x6);
          S && Jve(b6, x6, S, v6, t2);
        }).execute(), this._nodeScaleRatio = t2.get("nodeScaleRatio"), this._updateNodeAndLinkScale(t2), t2.get("expandAndCollapse") === true && f6.eachItemGraphicEl(function(x6, S) {
          x6.off("click").on("click", function() {
            u.dispatchAction({ type: "treeExpandAndCollapse", seriesId: t2.id, dataIndex: S });
          });
        }), this._data = f6;
      }, r6.prototype._updateViewCoordSys = function(t2) {
        var s = t2.getData(), u = [];
        s.each(function(x6) {
          var S = s.getItemLayout(x6);
          S && !isNaN(S.x) && !isNaN(S.y) && u.push([+S.x, +S.y]);
        });
        var f6 = [], d6 = [];
        CD(u, f6, d6);
        var v6 = this._min, m6 = this._max;
        d6[0] - f6[0] === 0 && (f6[0] = v6 ? v6[0] : f6[0] - 1, d6[0] = m6 ? m6[0] : d6[0] + 1), d6[1] - f6[1] === 0 && (f6[1] = v6 ? v6[1] : f6[1] - 1, d6[1] = m6 ? m6[1] : d6[1] + 1);
        var b6 = t2.coordinateSystem = new a4();
        b6.zoomLimit = t2.get("scaleLimit"), b6.setBoundingRect(f6[0], f6[1], d6[0] - f6[0], d6[1] - f6[1]), b6.setCenter(t2.get("center")), b6.setZoom(t2.get("zoom")), this.group.attr({ x: b6.x, y: b6.y, scaleX: b6.scaleX, scaleY: b6.scaleY }), this._min = f6, this._max = d6;
      }, r6.prototype._updateController = function(t2, s, u) {
        var f6 = this, d6 = this._controller, v6 = this._controllerHost, m6 = this.group;
        d6.setPointerChecker(function(b6, x6, S) {
          var M = m6.getBoundingRect();
          return M.applyTransform(m6.transform), M.contain(x6, S) && !sz(b6, u, t2);
        }), d6.enable(t2.get("roam")), v6.zoomLimit = t2.get("scaleLimit"), v6.zoom = t2.coordinateSystem.getZoom(), d6.off("pan").off("zoom").on("pan", function(b6) {
          SX(v6, b6.dx, b6.dy), u.dispatchAction({ seriesId: t2.id, type: "treeRoam", dx: b6.dx, dy: b6.dy });
        }).on("zoom", function(b6) {
          CX(v6, b6.scale, b6.originX, b6.originY), u.dispatchAction({ seriesId: t2.id, type: "treeRoam", zoom: b6.scale, originX: b6.originX, originY: b6.originY }), f6._updateNodeAndLinkScale(t2), u.updateLabelLayout();
        });
      }, r6.prototype._updateNodeAndLinkScale = function(t2) {
        var s = t2.getData(), u = this._getNodeGlobalScale(t2);
        s.eachItemGraphicEl(function(f6, d6) {
          f6.setSymbolScale(u);
        });
      }, r6.prototype._getNodeGlobalScale = function(t2) {
        var s = t2.coordinateSystem;
        if (s.type !== "view")
          return 1;
        var u = this._nodeScaleRatio, f6 = s.scaleX || 1, d6 = s.getZoom(), v6 = (d6 - 1) * u + 1;
        return v6 / f6;
      }, r6.prototype.dispose = function() {
        this._controller && this._controller.dispose(), this._controllerHost = null;
      }, r6.prototype.remove = function() {
        this._mainGroup.removeAll(), this._data = null;
      }, r6.type = "tree", r6;
    }(bu);
    function Yve(a, r6) {
      var t2 = a.getItemLayout(r6);
      return t2 && !isNaN(t2.x) && !isNaN(t2.y);
    }
    function Zve(a, r6, t2, s, u) {
      var f6 = !t2, d6 = a.tree.getNodeByDataIndex(r6), v6 = d6.getModel(), m6 = d6.getVisual("style").fill, b6 = d6.isExpand === false && d6.children.length !== 0 ? m6 : "#fff", x6 = a.tree.root, S = d6.parentNode === x6 ? d6 : d6.parentNode || d6, M = a.getItemGraphicEl(S.dataIndex), A6 = S.getLayout(), I = M ? { x: M.__oldX, y: M.__oldY, rawX: M.__radialOldRawX, rawY: M.__radialOldRawY } : A6, R = d6.getLayout();
      f6 ? (t2 = new ZR(a, r6, null, { symbolInnerColor: b6, useNameLabel: true }), t2.x = I.x, t2.y = I.y) : t2.updateData(a, r6, null, { symbolInnerColor: b6, useNameLabel: true }), t2.__radialOldRawX = t2.__radialRawX, t2.__radialOldRawY = t2.__radialRawY, t2.__radialRawX = R.rawX, t2.__radialRawY = R.rawY, s.add(t2), a.setItemGraphicEl(r6, t2), t2.__oldX = t2.x, t2.__oldY = t2.y, fs(t2, { x: R.x, y: R.y }, u);
      var F = t2.getSymbolPath();
      if (u.get("layout") === "radial") {
        var j = x6.children[0], $ = j.getLayout(), K = j.children.length, U = void 0, he = void 0;
        if (R.x === $.x && d6.isExpand === true) {
          var ue = { x: (j.children[0].getLayout().x + j.children[K - 1].getLayout().x) / 2, y: (j.children[0].getLayout().y + j.children[K - 1].getLayout().y) / 2 };
          U = Math.atan2(ue.y - $.y, ue.x - $.x), U < 0 && (U = Math.PI * 2 + U), he = ue.x < $.x, he && (U = U - Math.PI);
        } else
          U = Math.atan2(R.y - $.y, R.x - $.x), U < 0 && (U = Math.PI * 2 + U), d6.children.length === 0 || d6.children.length !== 0 && d6.isExpand === false ? (he = R.x < $.x, he && (U = U - Math.PI)) : (he = R.x > $.x, he || (U = U - Math.PI));
        var pe = he ? "left" : "right", _e = v6.getModel("label"), xe = _e.get("rotate"), Ae = xe * (Math.PI / 180), ke = F.getTextContent();
        ke && (F.setTextConfig({ position: _e.get("position") || pe, rotation: xe == null ? -U : Ae, origin: "center" }), ke.setStyle("verticalAlign", "middle"));
      }
      var je = v6.get(["emphasis", "focus"]), Fe = je === "ancestor" ? d6.getAncestorsIndices() : je === "descendant" ? d6.getDescendantIndices() : null;
      Fe && (ii(t2).focus = Fe), J7e(u, d6, x6, t2, I, A6, R, s), t2.__edge && (t2.onHoverStateChange = function(at) {
        if (at !== "blur") {
          var ht = d6.parentNode && a.getItemGraphicEl(d6.parentNode.dataIndex);
          ht && ht.hoverState === Yu || Lb(t2.__edge, at);
        }
      });
    }
    function J7e(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = r6.getModel(), b6 = a.get("edgeShape"), x6 = a.get("layout"), S = a.getOrient(), M = a.get(["lineStyle", "curveness"]), A6 = a.get("edgeForkPosition"), I = m6.getModel("lineStyle").getLineStyle(), R = s.__edge;
      if (b6 === "curve")
        r6.parentNode && r6.parentNode !== t2 && (R || (R = s.__edge = new GD({ shape: PX(x6, S, M, u, u) })), fs(R, { shape: PX(x6, S, M, f6, d6) }, a));
      else if (b6 === "polyline" && x6 === "orthogonal" && r6 !== t2 && r6.children && r6.children.length !== 0 && r6.isExpand === true) {
        for (var F = r6.children, j = [], $ = 0; $ < F.length; $++) {
          var K = F[$].getLayout();
          j.push([K.x, K.y]);
        }
        R || (R = s.__edge = new X7e({ shape: { parentPoint: [d6.x, d6.y], childPoints: [[d6.x, d6.y]], orient: S, forkPosition: A6 } })), fs(R, { shape: { parentPoint: [d6.x, d6.y], childPoints: j } }, a);
      }
      R && (R.useStyle(ei({ strokeNoScale: true, fill: null }, I)), Ah(R, m6, "lineStyle"), fg(R), v6.add(R));
    }
    function Xve(a, r6, t2, s, u) {
      var f6 = r6.tree.root, d6 = Kve(f6, a), v6 = d6.source, m6 = d6.sourceLayout, b6 = r6.getItemGraphicEl(a.dataIndex);
      if (b6) {
        var x6 = r6.getItemGraphicEl(v6.dataIndex), S = x6.__edge, M = b6.__edge || (v6.isExpand === false || v6.children.length === 1 ? S : void 0), A6 = s.get("edgeShape"), I = s.get("layout"), R = s.get("orient"), F = s.get(["lineStyle", "curveness"]);
        M && (A6 === "curve" ? Ob(M, { shape: PX(I, R, F, m6, m6), style: { opacity: 0 } }, s, { cb: function() {
          t2.remove(M);
        }, removeOpt: u }) : A6 === "polyline" && s.get("layout") === "orthogonal" && Ob(M, { shape: { parentPoint: [m6.x, m6.y], childPoints: [[m6.x, m6.y]] }, style: { opacity: 0 } }, s, { cb: function() {
          t2.remove(M);
        }, removeOpt: u }));
      }
    }
    function Kve(a, r6) {
      for (var t2 = r6.parentNode === a ? r6 : r6.parentNode || r6, s; s = t2.getLayout(), s == null; )
        t2 = t2.parentNode === a ? t2 : t2.parentNode || t2;
      return { source: t2, sourceLayout: s };
    }
    function Jve(a, r6, t2, s, u) {
      var f6 = a.tree.getNodeByDataIndex(r6), d6 = a.tree.root, v6 = Kve(d6, f6).sourceLayout, m6 = { duration: u.get("animationDurationUpdate"), easing: u.get("animationEasingUpdate") };
      Ob(t2, { x: v6.x + 1, y: v6.y + 1 }, u, { cb: function() {
        s.remove(t2), a.setItemGraphicEl(r6, null);
      }, removeOpt: m6 }), t2.fadeOut(null, a.hostModel, { fadeLabel: true, animation: m6 }), f6.children.forEach(function(b6) {
        Xve(b6, a, s, u, m6);
      }), Xve(f6, a, s, u, m6);
    }
    function PX(a, r6, t2, s, u) {
      var f6, d6, v6, m6, b6, x6, S, M;
      if (a === "radial") {
        b6 = s.rawX, S = s.rawY, x6 = u.rawX, M = u.rawY;
        var A6 = i4(b6, S), I = i4(b6, S + (M - S) * t2), R = i4(x6, M + (S - M) * t2), F = i4(x6, M);
        return { x1: A6.x || 0, y1: A6.y || 0, x2: F.x || 0, y2: F.y || 0, cpx1: I.x || 0, cpy1: I.y || 0, cpx2: R.x || 0, cpy2: R.y || 0 };
      } else
        b6 = s.x, S = s.y, x6 = u.x, M = u.y, (r6 === "LR" || r6 === "RL") && (f6 = b6 + (x6 - b6) * t2, d6 = S, v6 = x6 + (b6 - x6) * t2, m6 = M), (r6 === "TB" || r6 === "BT") && (f6 = b6, d6 = S + (M - S) * t2, v6 = x6, m6 = M + (S - M) * t2);
      return { x1: b6, y1: S, x2: x6, y2: M, cpx1: f6, cpy1: d6, cpx2: v6, cpy2: m6 };
    }
    var Q7e = K7e, Vm = Xo();
    function Qve(a) {
      var r6 = a.mainData, t2 = a.datas;
      t2 || (t2 = { main: r6 }, a.datasAttr = { main: "data" }), a.datas = a.mainData = null, ege(r6, t2, a), Ne(t2, function(s) {
        Ne(r6.TRANSFERABLE_METHODS, function(u) {
          s.wrapMethod(u, Oi(eVe, a));
        });
      }), r6.wrapMethod("cloneShallow", Oi(nVe, a)), Ne(r6.CHANGABLE_METHODS, function(s) {
        r6.wrapMethod(s, Oi(tVe, a));
      }), Hd(t2[r6.dataType] === r6);
    }
    function eVe(a, r6) {
      if (iVe(this)) {
        var t2 = qn({}, Vm(this).datas);
        t2[this.dataType] = r6, ege(r6, t2, a);
      } else
        LX(r6, this.dataType, Vm(this).mainData, a);
      return r6;
    }
    function tVe(a, r6) {
      return a.struct && a.struct.update(), r6;
    }
    function nVe(a, r6) {
      return Ne(Vm(r6).datas, function(t2, s) {
        t2 !== r6 && LX(t2.cloneShallow(), s, r6, a);
      }), r6;
    }
    function rVe(a) {
      var r6 = Vm(this).mainData;
      return a == null || r6 == null ? r6 : Vm(r6).datas[a];
    }
    function aVe() {
      var a = Vm(this).mainData;
      return a == null ? [{ data: a }] : wr(Po(Vm(a).datas), function(r6) {
        return { type: r6, data: Vm(a).datas[r6] };
      });
    }
    function iVe(a) {
      return Vm(a).mainData === a;
    }
    function ege(a, r6, t2) {
      Vm(a).datas = {}, Ne(r6, function(s, u) {
        LX(s, u, a, t2);
      });
    }
    function LX(a, r6, t2, s) {
      Vm(t2).datas[r6] = a, Vm(a).mainData = t2, a.dataType = r6, s.struct && (a[s.structAttr] = s.struct, s.struct[s.datasAttr[r6]] = a), a.getLinkedData = rVe, a.getLinkedDataAll = aVe;
    }
    var oVe = function() {
      function a(r6, t2) {
        this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = r6 || "", this.hostTree = t2;
      }
      return a.prototype.isRemoved = function() {
        return this.dataIndex < 0;
      }, a.prototype.eachNode = function(r6, t2, s) {
        ti(r6) && (s = t2, t2 = r6, r6 = null), r6 = r6 || {}, _a2(r6) && (r6 = { order: r6 });
        var u = r6.order || "preorder", f6 = this[r6.attr || "children"], d6;
        u === "preorder" && (d6 = t2.call(s, this));
        for (var v6 = 0; !d6 && v6 < f6.length; v6++)
          f6[v6].eachNode(r6, t2, s);
        u === "postorder" && t2.call(s, this);
      }, a.prototype.updateDepthAndHeight = function(r6) {
        var t2 = 0;
        this.depth = r6;
        for (var s = 0; s < this.children.length; s++) {
          var u = this.children[s];
          u.updateDepthAndHeight(r6 + 1), u.height > t2 && (t2 = u.height);
        }
        this.height = t2 + 1;
      }, a.prototype.getNodeById = function(r6) {
        if (this.getId() === r6)
          return this;
        for (var t2 = 0, s = this.children, u = s.length; t2 < u; t2++) {
          var f6 = s[t2].getNodeById(r6);
          if (f6)
            return f6;
        }
      }, a.prototype.contains = function(r6) {
        if (r6 === this)
          return true;
        for (var t2 = 0, s = this.children, u = s.length; t2 < u; t2++) {
          var f6 = s[t2].contains(r6);
          if (f6)
            return f6;
        }
      }, a.prototype.getAncestors = function(r6) {
        for (var t2 = [], s = r6 ? this : this.parentNode; s; )
          t2.push(s), s = s.parentNode;
        return t2.reverse(), t2;
      }, a.prototype.getAncestorsIndices = function() {
        for (var r6 = [], t2 = this; t2; )
          r6.push(t2.dataIndex), t2 = t2.parentNode;
        return r6.reverse(), r6;
      }, a.prototype.getDescendantIndices = function() {
        var r6 = [];
        return this.eachNode(function(t2) {
          r6.push(t2.dataIndex);
        }), r6;
      }, a.prototype.getValue = function(r6) {
        var t2 = this.hostTree.data;
        return t2.getStore().get(t2.getDimensionIndex(r6 || "value"), this.dataIndex);
      }, a.prototype.setLayout = function(r6, t2) {
        this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, r6, t2);
      }, a.prototype.getLayout = function() {
        return this.hostTree.data.getItemLayout(this.dataIndex);
      }, a.prototype.getModel = function(r6) {
        if (!(this.dataIndex < 0)) {
          var t2 = this.hostTree, s = t2.data.getItemModel(this.dataIndex);
          return s.getModel(r6);
        }
      }, a.prototype.getLevelModel = function() {
        return (this.hostTree.levelModels || [])[this.depth];
      }, a.prototype.setVisual = function(r6, t2) {
        this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, r6, t2);
      }, a.prototype.getVisual = function(r6) {
        return this.hostTree.data.getItemVisual(this.dataIndex, r6);
      }, a.prototype.getRawIndex = function() {
        return this.hostTree.data.getRawIndex(this.dataIndex);
      }, a.prototype.getId = function() {
        return this.hostTree.data.getId(this.dataIndex);
      }, a.prototype.getChildIndex = function() {
        if (this.parentNode) {
          for (var r6 = this.parentNode.children, t2 = 0; t2 < r6.length; ++t2)
            if (r6[t2] === this)
              return t2;
          return -1;
        }
        return -1;
      }, a.prototype.isAncestorOf = function(r6) {
        for (var t2 = r6.parentNode; t2; ) {
          if (t2 === this)
            return true;
          t2 = t2.parentNode;
        }
        return false;
      }, a.prototype.isDescendantOf = function(r6) {
        return r6 !== this && r6.isAncestorOf(this);
      }, a;
    }(), sVe = function() {
      function a(r6) {
        this.type = "tree", this._nodes = [], this.hostModel = r6;
      }
      return a.prototype.eachNode = function(r6, t2, s) {
        this.root.eachNode(r6, t2, s);
      }, a.prototype.getNodeByDataIndex = function(r6) {
        var t2 = this.data.getRawIndex(r6);
        return this._nodes[t2];
      }, a.prototype.getNodeById = function(r6) {
        return this.root.getNodeById(r6);
      }, a.prototype.update = function() {
        for (var r6 = this.data, t2 = this._nodes, s = 0, u = t2.length; s < u; s++)
          t2[s].dataIndex = -1;
        for (var s = 0, u = r6.count(); s < u; s++)
          t2[r6.getRawIndex(s)].dataIndex = s;
      }, a.prototype.clearLayouts = function() {
        this.data.clearItemLayouts();
      }, a.createTree = function(r6, t2, s) {
        var u = new a(t2), f6 = [], d6 = 1;
        v6(r6);
        function v6(x6, S) {
          var M = x6.value;
          d6 = Math.max(d6, br(M) ? M.length : 1), f6.push(x6);
          var A6 = new oVe(Zc(x6.name, ""), u);
          S ? lVe(A6, S) : u.root = A6, u._nodes.push(A6);
          var I = x6.children;
          if (I)
            for (var R = 0; R < I.length; R++)
              v6(I[R], A6);
        }
        u.root.updateDepthAndHeight(0);
        var m6 = zR(f6, { coordDimensions: ["value"], dimensionsCount: d6 }).dimensions, b6 = new Tv(m6, t2);
        return b6.initData(f6), s && s(b6), Qve({ mainData: b6, struct: u, structAttr: "tree" }), u.update(), u;
      }, a;
    }();
    function lVe(a, r6) {
      var t2 = r6.children;
      a.parentNode !== r6 && (t2.push(a), a.parentNode = r6);
    }
    var OX = sVe;
    function o4(a, r6, t2) {
      if (a && Vi(r6, a.type) >= 0) {
        var s = t2.getData().tree.root, u = a.targetNode;
        if (_a2(u) && (u = s.getNodeById(u)), u && s.contains(u))
          return { node: u };
        var f6 = a.targetNodeId;
        if (f6 != null && (u = s.getNodeById(f6)))
          return { node: u };
      }
    }
    function tge(a) {
      for (var r6 = []; a; )
        a = a.parentNode, a && r6.push(a);
      return r6.reverse();
    }
    function RX(a, r6) {
      var t2 = tge(a);
      return Vi(t2, r6) >= 0;
    }
    function hz(a, r6) {
      for (var t2 = []; a; ) {
        var s = a.dataIndex;
        t2.push({ name: a.name, dataIndex: s, value: r6.getRawValue(s) }), a = a.parentNode;
      }
      return t2.reverse(), t2;
    }
    var uVe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.hasSymbolVisual = true, t2.ignoreStyleOnData = true, t2;
      }
      return r6.prototype.getInitialData = function(t2) {
        var s = { name: t2.name, children: t2.data }, u = t2.leaves || {}, f6 = new yu(u, this, this.ecModel), d6 = OX.createTree(s, this, v6);
        function v6(S) {
          S.wrapMethod("getItemModel", function(M, A6) {
            var I = d6.getNodeByDataIndex(A6);
            return I && I.children.length && I.isExpand || (M.parentModel = f6), M;
          });
        }
        var m6 = 0;
        d6.eachNode("preorder", function(S) {
          S.depth > m6 && (m6 = S.depth);
        });
        var b6 = t2.expandAndCollapse, x6 = b6 && t2.initialTreeDepth >= 0 ? t2.initialTreeDepth : m6;
        return d6.root.eachNode("preorder", function(S) {
          var M = S.hostTree.data.getRawDataItem(S.dataIndex);
          S.isExpand = M && M.collapsed != null ? !M.collapsed : S.depth <= x6;
        }), d6.data;
      }, r6.prototype.getOrient = function() {
        var t2 = this.get("orient");
        return t2 === "horizontal" ? t2 = "LR" : t2 === "vertical" && (t2 = "TB"), t2;
      }, r6.prototype.setZoom = function(t2) {
        this.option.zoom = t2;
      }, r6.prototype.setCenter = function(t2) {
        this.option.center = t2;
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        for (var f6 = this.getData().tree, d6 = f6.root.children[0], v6 = f6.getNodeByDataIndex(t2), m6 = v6.getValue(), b6 = v6.name; v6 && v6 !== d6; )
          b6 = v6.parentNode.name + "." + b6, v6 = v6.parentNode;
        return Ih("nameValue", { name: b6, value: m6, noValue: isNaN(m6) || m6 == null });
      }, r6.prototype.getDataParams = function(t2) {
        var s = a.prototype.getDataParams.apply(this, arguments), u = this.getData().tree.getNodeByDataIndex(t2);
        return s.treeAncestors = hz(u, this), s;
      }, r6.type = "series.tree", r6.layoutMode = "box", r6.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, r6;
    }(sc), cVe = uVe;
    function fVe(a, r6, t2) {
      for (var s = [a], u = [], f6; f6 = s.pop(); )
        if (u.push(f6), f6.isExpand) {
          var d6 = f6.children;
          if (d6.length)
            for (var v6 = 0; v6 < d6.length; v6++)
              s.push(d6[v6]);
        }
      for (; f6 = u.pop(); )
        r6(f6, t2);
    }
    function s4(a, r6) {
      for (var t2 = [a], s; s = t2.pop(); )
        if (r6(s), s.isExpand) {
          var u = s.children;
          if (u.length)
            for (var f6 = u.length - 1; f6 >= 0; f6--)
              t2.push(u[f6]);
        }
    }
    function hVe(a, r6) {
      a.eachSeriesByType("tree", function(t2) {
        dVe(t2, r6);
      });
    }
    function dVe(a, r6) {
      var t2 = W7e(a, r6);
      a.layoutInfo = t2;
      var s = a.get("layout"), u = 0, f6 = 0, d6 = null;
      s === "radial" ? (u = 2 * Math.PI, f6 = Math.min(t2.height, t2.width) / 2, d6 = qve(function(K, U) {
        return (K.parentNode === U.parentNode ? 1 : 2) / K.depth;
      })) : (u = t2.width, f6 = t2.height, d6 = qve());
      var v6 = a.getData().tree.root, m6 = v6.children[0];
      if (m6) {
        B7e(v6), fVe(m6, j7e, d6), v6.hierNode.modifier = -m6.hierNode.prelim, s4(m6, G7e);
        var b6 = m6, x6 = m6, S = m6;
        s4(m6, function(K) {
          var U = K.getLayout().x;
          U < b6.getLayout().x && (b6 = K), U > x6.getLayout().x && (x6 = K), K.depth > S.depth && (S = K);
        });
        var M = b6 === x6 ? 1 : d6(b6, x6) / 2, A6 = M - b6.getLayout().x, I = 0, R = 0, F = 0, j = 0;
        if (s === "radial")
          I = u / (x6.getLayout().x + M + A6), R = f6 / (S.depth - 1 || 1), s4(m6, function(K) {
            F = (K.getLayout().x + A6) * I, j = (K.depth - 1) * R;
            var U = i4(F, j);
            K.setLayout({ x: U.x, y: U.y, rawX: F, rawY: j }, true);
          });
        else {
          var $ = a.getOrient();
          $ === "RL" || $ === "LR" ? (R = f6 / (x6.getLayout().x + M + A6), I = u / (S.depth - 1 || 1), s4(m6, function(K) {
            j = (K.getLayout().x + A6) * R, F = $ === "LR" ? (K.depth - 1) * I : u - (K.depth - 1) * I, K.setLayout({ x: F, y: j }, true);
          })) : ($ === "TB" || $ === "BT") && (I = u / (x6.getLayout().x + M + A6), R = f6 / (S.depth - 1 || 1), s4(m6, function(K) {
            F = (K.getLayout().x + A6) * I, j = $ === "TB" ? (K.depth - 1) * R : f6 - (K.depth - 1) * R, K.setLayout({ x: F, y: j }, true);
          }));
        }
      }
    }
    function pVe(a) {
      a.eachSeriesByType("tree", function(r6) {
        var t2 = r6.getData(), s = t2.tree;
        s.eachNode(function(u) {
          var f6 = u.getModel(), d6 = f6.getModel("itemStyle").getItemStyle(), v6 = t2.ensureUniqueItemVisual(u.dataIndex, "style");
          qn(v6, d6);
        });
      });
    }
    function vVe(a) {
      a.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(r6, t2) {
        t2.eachComponent({ mainType: "series", subType: "tree", query: r6 }, function(s) {
          var u = r6.dataIndex, f6 = s.getData().tree, d6 = f6.getNodeByDataIndex(u);
          d6.isExpand = !d6.isExpand;
        });
      }), a.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(r6, t2) {
        t2.eachComponent({ mainType: "series", subType: "tree", query: r6 }, function(s) {
          var u = s.coordinateSystem, f6 = TX(u, r6);
          s.setCenter && s.setCenter(f6.center), s.setZoom && s.setZoom(f6.zoom);
        });
      });
    }
    function gVe(a) {
      a.registerChartView(Q7e), a.registerSeriesModel(cVe), a.registerLayout(hVe), a.registerVisual(pVe), vVe(a);
    }
    var nge = ["treemapZoomToNode", "treemapRender", "treemapMove"];
    function mVe(a) {
      for (var r6 = 0; r6 < nge.length; r6++)
        a.registerAction({ type: nge[r6], update: "updateView" }, kc);
      a.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(t2, s) {
        s.eachComponent({ mainType: "series", subType: "treemap", query: t2 }, u);
        function u(f6, d6) {
          var v6 = ["treemapZoomToNode", "treemapRootToNode"], m6 = o4(t2, v6, f6);
          if (m6) {
            var b6 = f6.getViewRoot();
            b6 && (t2.direction = RX(b6, m6.node) ? "rollUp" : "drillDown"), f6.resetViewRoot(m6.node);
          }
        }
      });
    }
    function rge(a) {
      var r6 = a.getData(), t2 = r6.tree, s = {};
      t2.eachNode(function(u) {
        for (var f6 = u; f6 && f6.depth > 1; )
          f6 = f6.parentNode;
        var d6 = GY(a.ecModel, f6.name || f6.dataIndex + "", s);
        u.setVisual("decal", d6);
      });
    }
    var yVe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.preventUsingHoverLayer = true, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        var u = { name: t2.name, children: t2.data };
        age(u);
        var f6 = t2.levels || [], d6 = this.designatedVisualItemStyle = {}, v6 = new yu({ itemStyle: d6 }, this, s);
        f6 = t2.levels = bVe(f6, s);
        var m6 = wr(f6 || [], function(S) {
          return new yu(S, v6, s);
        }, this), b6 = OX.createTree(u, this, x6);
        function x6(S) {
          S.wrapMethod("getItemModel", function(M, A6) {
            var I = b6.getNodeByDataIndex(A6), R = I ? m6[I.depth] : null;
            return M.parentModel = R || v6, M;
          });
        }
        return b6.data;
      }, r6.prototype.optionUpdated = function() {
        this.resetViewRoot();
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        var f6 = this.getData(), d6 = this.getRawValue(t2), v6 = f6.getName(t2);
        return Ih("nameValue", { name: v6, value: d6 });
      }, r6.prototype.getDataParams = function(t2) {
        var s = a.prototype.getDataParams.apply(this, arguments), u = this.getData().tree.getNodeByDataIndex(t2);
        return s.treeAncestors = hz(u, this), s.treePathInfo = s.treeAncestors, s;
      }, r6.prototype.setLayoutInfo = function(t2) {
        this.layoutInfo = this.layoutInfo || {}, qn(this.layoutInfo, t2);
      }, r6.prototype.mapIdToIndex = function(t2) {
        var s = this._idIndexMap;
        s || (s = this._idIndexMap = Ta(), this._idIndexMapCount = 0);
        var u = s.get(t2);
        return u == null && s.set(t2, u = this._idIndexMapCount++), u;
      }, r6.prototype.getViewRoot = function() {
        return this._viewRoot;
      }, r6.prototype.resetViewRoot = function(t2) {
        t2 ? this._viewRoot = t2 : t2 = this._viewRoot;
        var s = this.getRawData().tree.root;
        (!t2 || t2 !== s && !s.contains(t2)) && (this._viewRoot = s);
      }, r6.prototype.enableAriaDecal = function() {
        rge(this);
      }, r6.type = "series.treemap", r6.layoutMode = "box", r6.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, r6;
    }(sc);
    function age(a) {
      var r6 = 0;
      Ne(a.children, function(s) {
        age(s);
        var u = s.value;
        br(u) && (u = u[0]), r6 += u;
      });
      var t2 = a.value;
      br(t2) && (t2 = t2[0]), (t2 == null || isNaN(t2)) && (t2 = r6), t2 < 0 && (t2 = 0), br(a.value) ? a.value[0] = t2 : a.value = t2;
    }
    function bVe(a, r6) {
      var t2 = ll(r6.get("color")), s = ll(r6.get(["aria", "decal", "decals"]));
      if (t2) {
        a = a || [];
        var u, f6;
        Ne(a, function(v6) {
          var m6 = new yu(v6), b6 = m6.get("color"), x6 = m6.get("decal");
          (m6.get(["itemStyle", "color"]) || b6 && b6 !== "none") && (u = true), (m6.get(["itemStyle", "decal"]) || x6 && x6 !== "none") && (f6 = true);
        });
        var d6 = a[0] || (a[0] = {});
        return u || (d6.color = t2.slice()), !f6 && s && (d6.decal = s.slice()), a;
      }
    }
    var _Ve = yVe, xVe = 8, ige = 8, FX = 5, wVe = function() {
      function a(r6) {
        this.group = new bi(), r6.add(this.group);
      }
      return a.prototype.render = function(r6, t2, s, u) {
        var f6 = r6.getModel("breadcrumb"), d6 = this.group;
        if (d6.removeAll(), !(!f6.get("show") || !s)) {
          var v6 = f6.getModel("itemStyle"), m6 = v6.getModel("textStyle"), b6 = { pos: { left: f6.get("left"), right: f6.get("right"), top: f6.get("top"), bottom: f6.get("bottom") }, box: { width: t2.getWidth(), height: t2.getHeight() }, emptyItemWidth: f6.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
          this._prepare(s, b6, m6), this._renderContent(r6, b6, v6, m6, u), fV(d6, b6.pos, b6.box);
        }
      }, a.prototype._prepare = function(r6, t2, s) {
        for (var u = r6; u; u = u.parentNode) {
          var f6 = Zc(u.getModel().get("name"), ""), d6 = s.getTextRect(f6), v6 = Math.max(d6.width + xVe * 2, t2.emptyItemWidth);
          t2.totalWidth += v6 + ige, t2.renderList.push({ node: u, text: f6, width: v6 });
        }
      }, a.prototype._renderContent = function(r6, t2, s, u, f6) {
        for (var d6 = 0, v6 = t2.emptyItemWidth, m6 = r6.get(["breadcrumb", "height"]), b6 = kOe(t2.pos, t2.box), x6 = t2.totalWidth, S = t2.renderList, M = S.length - 1; M >= 0; M--) {
          var A6 = S[M], I = A6.node, R = A6.width, F = A6.text;
          x6 > b6.width && (x6 -= R - v6, R = v6, F = null);
          var j = new ud({ shape: { points: SVe(d6, 0, R, m6, M === S.length - 1, M === 0) }, style: ei(s.getItemStyle(), { lineJoin: "bevel" }), textContent: new ms({ style: { text: F, fill: u.getTextColor(), font: u.getFont() } }), textConfig: { position: "inside" }, z2: j2 * 1e4, onclick: Oi(f6, I) });
          j.disableLabelAnimation = true, this.group.add(j), CVe(j, r6, I), d6 += R + ige;
        }
      }, a.prototype.remove = function() {
        this.group.removeAll();
      }, a;
    }();
    function SVe(a, r6, t2, s, u, f6) {
      var d6 = [[u ? a : a - FX, r6], [a + t2, r6], [a + t2, r6 + s], [u ? a : a - FX, r6 + s]];
      return !f6 && d6.splice(2, 0, [a + t2 + FX, r6 + s / 2]), !u && d6.push([a, r6 + s / 2]), d6;
    }
    function CVe(a, r6, t2) {
      ii(a).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: r6.componentIndex, seriesIndex: r6.seriesIndex, seriesName: r6.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: t2 && t2.dataIndex, name: t2 && t2.name }, treePathInfo: t2 && hz(t2, r6) };
    }
    var MVe = wVe, AVe = function() {
      function a() {
        this._storage = [], this._elExistsMap = {};
      }
      return a.prototype.add = function(r6, t2, s, u, f6) {
        return this._elExistsMap[r6.id] ? false : (this._elExistsMap[r6.id] = true, this._storage.push({ el: r6, target: t2, duration: s, delay: u, easing: f6 }), true);
      }, a.prototype.finished = function(r6) {
        return this._finishedCallback = r6, this;
      }, a.prototype.start = function() {
        for (var r6 = this, t2 = this._storage.length, s = function() {
          t2--, t2 <= 0 && (r6._storage.length = 0, r6._elExistsMap = {}, r6._finishedCallback && r6._finishedCallback());
        }, u = 0, f6 = this._storage.length; u < f6; u++) {
          var d6 = this._storage[u];
          d6.el.animateTo(d6.target, { duration: d6.duration, delay: d6.delay, easing: d6.easing, setToFinal: true, done: s, aborted: s });
        }
        return this;
      }, a;
    }();
    function EVe() {
      return new AVe();
    }
    var NX = bi, oge = rs, sge = 3, lge = "label", uge = "upperLabel", IVe = j2 * 10, TVe = j2 * 2, DVe = j2 * 3, IA = Mx([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), cge = function(a) {
      var r6 = IA(a);
      return r6.stroke = r6.fill = r6.lineWidth = null, r6;
    }, dz = Xo(), kVe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._state = "ready", t2._storage = l42(), t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        var d6 = s.findComponents({ mainType: "series", subType: "treemap", query: f6 });
        if (!(Vi(d6, t2) < 0)) {
          this.seriesModel = t2, this.api = u, this.ecModel = s;
          var v6 = ["treemapZoomToNode", "treemapRootToNode"], m6 = o4(f6, v6, t2), b6 = f6 && f6.type, x6 = t2.layoutInfo, S = !this._oldTree, M = this._storage, A6 = b6 === "treemapRootToNode" && m6 && M ? { rootNodeGroup: M.nodeGroup[m6.node.getRawIndex()], direction: f6.direction } : null, I = this._giveContainerGroup(x6), R = t2.get("animation"), F = this._doRender(I, t2, A6);
          R && !S && (!b6 || b6 === "treemapZoomToNode" || b6 === "treemapRootToNode") ? this._doAnimation(I, F, t2, A6) : F.renderFinally(), this._resetController(u), this._renderBreadcrumb(t2, u, m6);
        }
      }, r6.prototype._giveContainerGroup = function(t2) {
        var s = this._containerGroup;
        return s || (s = this._containerGroup = new NX(), this._initEvents(s), this.group.add(s)), s.x = t2.x, s.y = t2.y, s;
      }, r6.prototype._doRender = function(t2, s, u) {
        var f6 = s.getData().tree, d6 = this._oldTree, v6 = l42(), m6 = l42(), b6 = this._storage, x6 = [];
        function S(F, j, $, K) {
          return PVe(s, m6, b6, u, v6, x6, F, j, $, K);
        }
        A6(f6.root ? [f6.root] : [], d6 && d6.root ? [d6.root] : [], t2, f6 === d6 || !d6, 0);
        var M = I(b6);
        return this._oldTree = f6, this._storage = m6, { lastsForAnimation: v6, willDeleteEls: M, renderFinally: R };
        function A6(F, j, $, K, U) {
          K ? (j = F, Ne(F, function(pe, _e) {
            !pe.isRemoved() && ue(_e, _e);
          })) : new Gx(j, F, he, he).add(ue).update(ue).remove(Oi(ue, null)).execute();
          function he(pe) {
            return pe.getId();
          }
          function ue(pe, _e) {
            var xe = pe != null ? F[pe] : null, Ae = _e != null ? j[_e] : null, ke = S(xe, Ae, $, U);
            ke && A6(xe && xe.viewChildren || [], Ae && Ae.viewChildren || [], ke, K, U + 1);
          }
        }
        function I(F) {
          var j = l42();
          return F && Ne(F, function($, K) {
            var U = j[K];
            Ne($, function(he) {
              he && (U.push(he), dz(he).willDelete = true);
            });
          }), j;
        }
        function R() {
          Ne(M, function(F) {
            Ne(F, function(j) {
              j.parent && j.parent.remove(j);
            });
          }), Ne(x6, function(F) {
            F.invisible = true, F.dirty();
          });
        }
      }, r6.prototype._doAnimation = function(t2, s, u, f6) {
        var d6 = u.get("animationDurationUpdate"), v6 = u.get("animationEasing"), m6 = (ti(d6) ? 0 : d6) || 0, b6 = (ti(v6) ? null : v6) || "cubicOut", x6 = EVe();
        Ne(s.willDeleteEls, function(S, M) {
          Ne(S, function(A6, I) {
            if (!A6.invisible) {
              var R = A6.parent, F, j = dz(R);
              if (f6 && f6.direction === "drillDown")
                F = R === f6.rootNodeGroup ? { shape: { x: 0, y: 0, width: j.nodeWidth, height: j.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
              else {
                var $ = 0, K = 0;
                j.willDelete || ($ = j.nodeWidth / 2, K = j.nodeHeight / 2), F = M === "nodeGroup" ? { x: $, y: K, style: { opacity: 0 } } : { shape: { x: $, y: K, width: 0, height: 0 }, style: { opacity: 0 } };
              }
              F && x6.add(A6, F, m6, 0, b6);
            }
          });
        }), Ne(this._storage, function(S, M) {
          Ne(S, function(A6, I) {
            var R = s.lastsForAnimation[M][I], F = {};
            !R || (A6 instanceof bi ? R.oldX != null && (F.x = A6.x, F.y = A6.y, A6.x = R.oldX, A6.y = R.oldY) : (R.oldShape && (F.shape = qn({}, A6.shape), A6.setShape(R.oldShape)), R.fadein ? (A6.setStyle("opacity", 0), F.style = { opacity: 1 }) : A6.style.opacity !== 1 && (F.style = { opacity: 1 })), x6.add(A6, F, m6, 0, b6));
          });
        }, this), this._state = "animating", x6.finished(Ca(function() {
          this._state = "ready", s.renderFinally();
        }, this)).start();
      }, r6.prototype._resetController = function(t2) {
        var s = this._controller;
        s || (s = this._controller = new n4(t2.getZr()), s.enable(this.seriesModel.get("roam")), s.on("pan", Ca(this._onPan, this)), s.on("zoom", Ca(this._onZoom, this)));
        var u = new Qi(0, 0, t2.getWidth(), t2.getHeight());
        s.setPointerChecker(function(f6, d6, v6) {
          return u.contain(d6, v6);
        });
      }, r6.prototype._clearController = function() {
        var t2 = this._controller;
        t2 && (t2.dispose(), t2 = null);
      }, r6.prototype._onPan = function(t2) {
        if (this._state !== "animating" && (Math.abs(t2.dx) > sge || Math.abs(t2.dy) > sge)) {
          var s = this.seriesModel.getData().tree.root;
          if (!s)
            return;
          var u = s.getLayout();
          if (!u)
            return;
          this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: u.x + t2.dx, y: u.y + t2.dy, width: u.width, height: u.height } });
        }
      }, r6.prototype._onZoom = function(t2) {
        var s = t2.originX, u = t2.originY;
        if (this._state !== "animating") {
          var f6 = this.seriesModel.getData().tree.root;
          if (!f6)
            return;
          var d6 = f6.getLayout();
          if (!d6)
            return;
          var v6 = new Qi(d6.x, d6.y, d6.width, d6.height), m6 = this.seriesModel.layoutInfo;
          s -= m6.x, u -= m6.y;
          var b6 = og();
          sg(b6, b6, [-s, -u]), rD(b6, b6, [t2.scale, t2.scale]), sg(b6, b6, [s, u]), v6.applyTransform(b6), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: v6.x, y: v6.y, width: v6.width, height: v6.height } });
        }
      }, r6.prototype._initEvents = function(t2) {
        var s = this;
        t2.on("click", function(u) {
          if (s._state === "ready") {
            var f6 = s.seriesModel.get("nodeClick", true);
            if (f6) {
              var d6 = s.findTarget(u.offsetX, u.offsetY);
              if (d6) {
                var v6 = d6.node;
                if (v6.getLayout().isLeafRoot)
                  s._rootToNode(d6);
                else if (f6 === "zoomToNode")
                  s._zoomToNode(d6);
                else if (f6 === "link") {
                  var m6 = v6.hostTree.data.getItemModel(v6.dataIndex), b6 = m6.get("link", true), x6 = m6.get("target", true) || "blank";
                  b6 && uV(b6, x6);
                }
              }
            }
          }
        }, this);
      }, r6.prototype._renderBreadcrumb = function(t2, s, u) {
        var f6 = this;
        u || (u = t2.get("leafDepth", true) != null ? { node: t2.getViewRoot() } : this.findTarget(s.getWidth() / 2, s.getHeight() / 2), u || (u = { node: t2.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new MVe(this.group))).render(t2, s, u.node, function(d6) {
          f6._state !== "animating" && (RX(t2.getViewRoot(), d6) ? f6._rootToNode({ node: d6 }) : f6._zoomToNode({ node: d6 }));
        });
      }, r6.prototype.remove = function() {
        this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = l42(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
      }, r6.prototype.dispose = function() {
        this._clearController();
      }, r6.prototype._zoomToNode = function(t2) {
        this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: t2.node });
      }, r6.prototype._rootToNode = function(t2) {
        this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: t2.node });
      }, r6.prototype.findTarget = function(t2, s) {
        var u, f6 = this.seriesModel.getViewRoot();
        return f6.eachNode({ attr: "viewChildren", order: "preorder" }, function(d6) {
          var v6 = this._storage.background[d6.getRawIndex()];
          if (v6) {
            var m6 = v6.transformCoordToLocal(t2, s), b6 = v6.shape;
            if (b6.x <= m6[0] && m6[0] <= b6.x + b6.width && b6.y <= m6[1] && m6[1] <= b6.y + b6.height)
              u = { node: d6, offsetX: m6[0], offsetY: m6[1] };
            else
              return false;
          }
        }, this), u;
      }, r6.type = "treemap", r6;
    }(bu);
    function l42() {
      return { nodeGroup: [], background: [], content: [] };
    }
    function PVe(a, r6, t2, s, u, f6, d6, v6, m6, b6) {
      if (!d6)
        return;
      var x6 = d6.getLayout(), S = a.getData(), M = d6.getModel();
      if (S.setItemGraphicEl(d6.dataIndex, null), !x6 || !x6.isInView)
        return;
      var A6 = x6.width, I = x6.height, R = x6.borderWidth, F = x6.invisible, j = d6.getRawIndex(), $ = v6 && v6.getRawIndex(), K = d6.viewChildren, U = x6.upperHeight, he = K && K.length, ue = M.getModel("itemStyle"), pe = M.getModel(["emphasis", "itemStyle"]), _e = M.getModel(["blur", "itemStyle"]), xe = M.getModel(["select", "itemStyle"]), Ae = ue.get("borderRadius") || 0, ke = Ma("nodeGroup", NX);
      if (!ke)
        return;
      if (m6.add(ke), ke.x = x6.x || 0, ke.y = x6.y || 0, ke.markRedraw(), dz(ke).nodeWidth = A6, dz(ke).nodeHeight = I, x6.isAboveViewRoot)
        return ke;
      var je = Ma("background", oge, b6, TVe);
      je && wt(ke, je, he && x6.upperLabelHeight);
      var Fe = M.getModel("emphasis"), at = Fe.get("focus"), ht = Fe.get("blurScope"), Qe = Fe.get("disabled"), en = at === "ancestor" ? d6.getAncestorsIndices() : at === "descendant" ? d6.getDescendantIndices() : at;
      if (he)
        QM(ke) && Nx(ke, false), je && (Nx(je, !Qe), S.setItemGraphicEl(d6.dataIndex, je), UO(je, en, ht));
      else {
        var bt = Ma("content", oge, b6, DVe);
        bt && Ft(ke, bt), je.disableMorphing = true, je && QM(je) && Nx(je, false), Nx(ke, !Qe), S.setItemGraphicEl(d6.dataIndex, ke), UO(ke, en, ht);
      }
      return ke;
      function wt(Ga, pa, Fa) {
        var Ha = ii(pa);
        if (Ha.dataIndex = d6.dataIndex, Ha.seriesIndex = a.seriesIndex, pa.setShape({ x: 0, y: 0, width: A6, height: I, r: Ae }), F)
          fn(pa);
        else {
          pa.invisible = false;
          var Sa = d6.getVisual("style"), oi = Sa.stroke, bs = cge(ue);
          bs.fill = oi;
          var Si = IA(pe);
          Si.fill = pe.get("borderColor");
          var Ls = IA(_e);
          Ls.fill = _e.get("borderColor");
          var tl = IA(xe);
          if (tl.fill = xe.get("borderColor"), Fa) {
            var Hs = A6 - 2 * R;
            gn(pa, oi, Sa.opacity, { x: R, y: 0, width: Hs, height: U });
          } else
            pa.removeTextContent();
          pa.setStyle(bs), pa.ensureState("emphasis").style = Si, pa.ensureState("blur").style = Ls, pa.ensureState("select").style = tl, fg(pa);
        }
        Ga.add(pa);
      }
      function Ft(Ga, pa) {
        var Fa = ii(pa);
        Fa.dataIndex = d6.dataIndex, Fa.seriesIndex = a.seriesIndex;
        var Ha = Math.max(A6 - 2 * R, 0), Sa = Math.max(I - 2 * R, 0);
        if (pa.culling = true, pa.setShape({ x: R, y: R, width: Ha, height: Sa, r: Ae }), F)
          fn(pa);
        else {
          pa.invisible = false;
          var oi = d6.getVisual("style"), bs = oi.fill, Si = cge(ue);
          Si.fill = bs, Si.decal = oi.decal;
          var Ls = IA(pe), tl = IA(_e), Hs = IA(xe);
          gn(pa, bs, oi.opacity, null), pa.setStyle(Si), pa.ensureState("emphasis").style = Ls, pa.ensureState("blur").style = tl, pa.ensureState("select").style = Hs, fg(pa);
        }
        Ga.add(pa);
      }
      function fn(Ga) {
        !Ga.invisible && f6.push(Ga);
      }
      function gn(Ga, pa, Fa, Ha) {
        var Sa = M.getModel(Ha ? uge : lge), oi = Zc(M.get("name"), null), bs = Sa.getShallow("show");
        Bp(Ga, hd(M, Ha ? uge : lge), { defaultText: bs ? oi : null, inheritColor: pa, defaultOpacity: Fa, labelFetcher: a, labelDataIndex: d6.dataIndex });
        var Si = Ga.getTextContent();
        if (Si) {
          var Ls = Si.style, tl = DT(Ls.padding || 0);
          Ha && (Ga.setTextConfig({ layoutRect: Ha }), Si.disableLabelLayout = true), Si.beforeUpdate = function() {
            var Of = Math.max((Ha ? Ha.width : Ga.shape.width) - tl[1] - tl[3], 0), Xu = Math.max((Ha ? Ha.height : Ga.shape.height) - tl[0] - tl[2], 0);
            (Ls.width !== Of || Ls.height !== Xu) && Si.setStyle({ width: Of, height: Xu });
          }, Ls.truncateMinChar = 2, Ls.lineOverflow = "truncate", Zr(Ls, Ha, x6);
          var Hs = Si.getState("emphasis");
          Zr(Hs ? Hs.style : null, Ha, x6);
        }
      }
      function Zr(Ga, pa, Fa) {
        var Ha = Ga ? Ga.text : null;
        if (!pa && Fa.isLeafRoot && Ha != null) {
          var Sa = a.get("drillDownIcon", true);
          Ga.text = Sa ? Sa + " " + Ha : Ha;
        }
      }
      function Ma(Ga, pa, Fa, Ha) {
        var Sa = $ != null && t2[Ga][$], oi = u[Ga];
        return Sa ? (t2[Ga][$] = null, Ua(oi, Sa)) : F || (Sa = new pa(), Sa instanceof cg && (Sa.z2 = LVe(Fa, Ha)), ja(oi, Sa)), r6[Ga][j] = Sa;
      }
      function Ua(Ga, pa) {
        var Fa = Ga[j] = {};
        pa instanceof NX ? (Fa.oldX = pa.x, Fa.oldY = pa.y) : Fa.oldShape = qn({}, pa.shape);
      }
      function ja(Ga, pa) {
        var Fa = Ga[j] = {}, Ha = d6.parentNode, Sa = pa instanceof bi;
        if (Ha && (!s || s.direction === "drillDown")) {
          var oi = 0, bs = 0, Si = u.background[Ha.getRawIndex()];
          !s && Si && Si.oldShape && (oi = Si.oldShape.width, bs = Si.oldShape.height), Sa ? (Fa.oldX = 0, Fa.oldY = bs) : Fa.oldShape = { x: oi, y: bs, width: 0, height: 0 };
        }
        Fa.fadein = !Sa;
      }
    }
    function LVe(a, r6) {
      return a * IVe + r6;
    }
    var OVe = kVe, u4 = Ne, RVe = ui, pz = -1, VX = function() {
      function a(r6) {
        var t2 = r6.mappingMethod, s = r6.type, u = this.option = Qa(r6);
        this.type = s, this.mappingMethod = t2, this._normalizeData = VVe[t2];
        var f6 = a.visualHandlers[s];
        this.applyVisual = f6.applyVisual, this.getColorMapper = f6.getColorMapper, this._normalizedToVisual = f6._normalizedToVisual[t2], t2 === "piecewise" ? (zX(u), FVe(u)) : t2 === "category" ? u.categories ? NVe(u) : zX(u, true) : (Hd(t2 !== "linear" || u.dataExtent), zX(u));
      }
      return a.prototype.mapValueToVisual = function(r6) {
        var t2 = this._normalizeData(r6);
        return this._normalizedToVisual(t2, r6);
      }, a.prototype.getNormalizer = function() {
        return Ca(this._normalizeData, this);
      }, a.listVisualTypes = function() {
        return Po(a.visualHandlers);
      }, a.isValidType = function(r6) {
        return a.visualHandlers.hasOwnProperty(r6);
      }, a.eachVisual = function(r6, t2, s) {
        ui(r6) ? Ne(r6, t2, s) : t2.call(s, r6);
      }, a.mapVisual = function(r6, t2, s) {
        var u, f6 = br(r6) ? [] : ui(r6) ? {} : (u = true, null);
        return a.eachVisual(r6, function(d6, v6) {
          var m6 = t2.call(s, d6, v6);
          u ? f6 = m6 : f6[v6] = m6;
        }), f6;
      }, a.retrieveVisuals = function(r6) {
        var t2 = {}, s;
        return r6 && u4(a.visualHandlers, function(u, f6) {
          r6.hasOwnProperty(f6) && (t2[f6] = r6[f6], s = true);
        }), s ? t2 : null;
      }, a.prepareVisualTypes = function(r6) {
        if (br(r6))
          r6 = r6.slice();
        else if (RVe(r6)) {
          var t2 = [];
          u4(r6, function(s, u) {
            t2.push(u);
          }), r6 = t2;
        } else
          return [];
        return r6.sort(function(s, u) {
          return u === "color" && s !== "color" && s.indexOf("color") === 0 ? 1 : -1;
        }), r6;
      }, a.dependsOn = function(r6, t2) {
        return t2 === "color" ? !!(r6 && r6.indexOf(t2) === 0) : r6 === t2;
      }, a.findPieceIndex = function(r6, t2, s) {
        for (var u, f6 = 1 / 0, d6 = 0, v6 = t2.length; d6 < v6; d6++) {
          var m6 = t2[d6].value;
          if (m6 != null) {
            if (m6 === r6 || _a2(m6) && m6 === r6 + "")
              return d6;
            s && M(m6, d6);
          }
        }
        for (var d6 = 0, v6 = t2.length; d6 < v6; d6++) {
          var b6 = t2[d6], x6 = b6.interval, S = b6.close;
          if (x6) {
            if (x6[0] === -1 / 0) {
              if (gz(S[1], r6, x6[1]))
                return d6;
            } else if (x6[1] === 1 / 0) {
              if (gz(S[0], x6[0], r6))
                return d6;
            } else if (gz(S[0], x6[0], r6) && gz(S[1], r6, x6[1]))
              return d6;
            s && M(x6[0], d6), s && M(x6[1], d6);
          }
        }
        if (s)
          return r6 === 1 / 0 ? t2.length - 1 : r6 === -1 / 0 ? 0 : u;
        function M(A6, I) {
          var R = Math.abs(A6 - r6);
          R < f6 && (f6 = R, u = I);
        }
      }, a.visualHandlers = { color: { applyVisual: c42("color"), getColorMapper: function() {
        var r6 = this.option;
        return Ca(r6.mappingMethod === "category" ? function(t2, s) {
          return !s && (t2 = this._normalizeData(t2)), f4.call(this, t2);
        } : function(t2, s, u) {
          var f6 = !!u;
          return !s && (t2 = this._normalizeData(t2)), u = RL(t2, r6.parsedVisual, u), f6 ? u : Zy(u, "rgba");
        }, this);
      }, _normalizedToVisual: { linear: function(r6) {
        return Zy(RL(r6, this.option.parsedVisual), "rgba");
      }, category: f4, piecewise: function(r6, t2) {
        var s = jX.call(this, t2);
        return s == null && (s = Zy(RL(r6, this.option.parsedVisual), "rgba")), s;
      }, fixed: TA } }, colorHue: vz(function(r6, t2) {
        return e0(r6, t2);
      }), colorSaturation: vz(function(r6, t2) {
        return e0(r6, null, t2);
      }), colorLightness: vz(function(r6, t2) {
        return e0(r6, null, null, t2);
      }), colorAlpha: vz(function(r6, t2) {
        return jT(r6, t2);
      }), decal: { applyVisual: c42("decal"), _normalizedToVisual: { linear: null, category: f4, piecewise: null, fixed: null } }, opacity: { applyVisual: c42("opacity"), _normalizedToVisual: BX([0, 1]) }, liftZ: { applyVisual: c42("liftZ"), _normalizedToVisual: { linear: TA, category: TA, piecewise: TA, fixed: TA } }, symbol: { applyVisual: function(r6, t2, s) {
        var u = this.mapValueToVisual(r6);
        s("symbol", u);
      }, _normalizedToVisual: { linear: fge, category: f4, piecewise: function(r6, t2) {
        var s = jX.call(this, t2);
        return s == null && (s = fge.call(this, r6)), s;
      }, fixed: TA } }, symbolSize: { applyVisual: c42("symbolSize"), _normalizedToVisual: BX([0, 1]) } }, a;
    }();
    function FVe(a) {
      var r6 = a.pieceList;
      a.hasSpecialVisual = false, Ne(r6, function(t2, s) {
        t2.originIndex = s, t2.visual != null && (a.hasSpecialVisual = true);
      });
    }
    function NVe(a) {
      var r6 = a.categories, t2 = a.categoryMap = {}, s = a.visual;
      if (u4(r6, function(d6, v6) {
        t2[d6] = v6;
      }), !br(s)) {
        var u = [];
        ui(s) ? u4(s, function(d6, v6) {
          var m6 = t2[v6];
          u[m6 != null ? m6 : pz] = d6;
        }) : u[pz] = s, s = hge(a, u);
      }
      for (var f6 = r6.length - 1; f6 >= 0; f6--)
        s[f6] == null && (delete t2[r6[f6]], r6.pop());
    }
    function zX(a, r6) {
      var t2 = a.visual, s = [];
      ui(t2) ? u4(t2, function(f6) {
        s.push(f6);
      }) : t2 != null && s.push(t2);
      var u = { color: 1, symbol: 1 };
      !r6 && s.length === 1 && !u.hasOwnProperty(a.type) && (s[1] = s[0]), hge(a, s);
    }
    function vz(a) {
      return { applyVisual: function(r6, t2, s) {
        var u = this.mapValueToVisual(r6);
        s("color", a(t2("color"), u));
      }, _normalizedToVisual: BX([0, 1]) };
    }
    function fge(a) {
      var r6 = this.option.visual;
      return r6[Math.round(gs(a, [0, 1], [0, r6.length - 1], true))] || {};
    }
    function c42(a) {
      return function(r6, t2, s) {
        s(a, this.mapValueToVisual(r6));
      };
    }
    function f4(a) {
      var r6 = this.option.visual;
      return r6[this.option.loop && a !== pz ? a % r6.length : a];
    }
    function TA() {
      return this.option.visual[0];
    }
    function BX(a) {
      return { linear: function(r6) {
        return gs(r6, a, this.option.visual, true);
      }, category: f4, piecewise: function(r6, t2) {
        var s = jX.call(this, t2);
        return s == null && (s = gs(r6, a, this.option.visual, true)), s;
      }, fixed: TA };
    }
    function jX(a) {
      var r6 = this.option, t2 = r6.pieceList;
      if (r6.hasSpecialVisual) {
        var s = VX.findPieceIndex(a, t2), u = t2[s];
        if (u && u.visual)
          return u.visual[this.type];
      }
    }
    function hge(a, r6) {
      return a.visual = r6, a.type === "color" && (a.parsedVisual = wr(r6, function(t2) {
        return id2(t2);
      })), r6;
    }
    var VVe = { linear: function(a) {
      return gs(a, this.option.dataExtent, [0, 1], true);
    }, piecewise: function(a) {
      var r6 = this.option.pieceList, t2 = VX.findPieceIndex(a, r6, true);
      if (t2 != null)
        return gs(t2, [0, r6.length - 1], [0, 1], true);
    }, category: function(a) {
      var r6 = this.option.categories ? this.option.categoryMap[a] : a;
      return r6 == null ? pz : r6;
    }, fixed: kc };
    function gz(a, r6, t2) {
      return a ? r6 <= t2 : r6 < t2;
    }
    var ap = VX, zVe = "itemStyle", dge = Xo(), BVe = { seriesType: "treemap", reset: function(a) {
      var r6 = a.getData().tree, t2 = r6.root;
      t2.isRemoved() || pge(t2, {}, a.getViewRoot().getAncestors(), a);
    } };
    function pge(a, r6, t2, s) {
      var u = a.getModel(), f6 = a.getLayout(), d6 = a.hostTree.data;
      if (!(!f6 || f6.invisible || !f6.isInView)) {
        var v6 = u.getModel(zVe), m6 = jVe(v6, r6, s), b6 = d6.ensureUniqueItemVisual(a.dataIndex, "style"), x6 = v6.get("borderColor"), S = v6.get("borderColorSaturation"), M;
        S != null && (M = vge(m6), x6 = GVe(S, M)), b6.stroke = x6;
        var A6 = a.viewChildren;
        if (!A6 || !A6.length)
          M = vge(m6), b6.fill = M;
        else {
          var I = WVe(a, u, f6, v6, m6, A6);
          Ne(A6, function(R, F) {
            if (R.depth >= t2.length || R === t2[R.depth]) {
              var j = HVe(u, m6, R, F, I, s);
              pge(R, j, t2, s);
            }
          });
        }
      }
    }
    function jVe(a, r6, t2) {
      var s = qn({}, r6), u = t2.designatedVisualItemStyle;
      return Ne(["color", "colorAlpha", "colorSaturation"], function(f6) {
        u[f6] = r6[f6];
        var d6 = a.get(f6);
        u[f6] = null, d6 != null && (s[f6] = d6);
      }), s;
    }
    function vge(a) {
      var r6 = GX(a, "color");
      if (r6) {
        var t2 = GX(a, "colorAlpha"), s = GX(a, "colorSaturation");
        return s && (r6 = e0(r6, null, null, s)), t2 && (r6 = jT(r6, t2)), r6;
      }
    }
    function GVe(a, r6) {
      return r6 != null ? e0(r6, null, null, a) : null;
    }
    function GX(a, r6) {
      var t2 = a[r6];
      if (t2 != null && t2 !== "none")
        return t2;
    }
    function WVe(a, r6, t2, s, u, f6) {
      if (!(!f6 || !f6.length)) {
        var d6 = WX(r6, "color") || u.color != null && u.color !== "none" && (WX(r6, "colorAlpha") || WX(r6, "colorSaturation"));
        if (d6) {
          var v6 = r6.get("visualMin"), m6 = r6.get("visualMax"), b6 = t2.dataExtent.slice();
          v6 != null && v6 < b6[0] && (b6[0] = v6), m6 != null && m6 > b6[1] && (b6[1] = m6);
          var x6 = r6.get("colorMappingBy"), S = { type: d6.name, dataExtent: b6, visual: d6.range };
          S.type === "color" && (x6 === "index" || x6 === "id") ? (S.mappingMethod = "category", S.loop = true) : S.mappingMethod = "linear";
          var M = new ap(S);
          return dge(M).drColorMappingBy = x6, M;
        }
      }
    }
    function WX(a, r6) {
      var t2 = a.get(r6);
      return br(t2) && t2.length ? { name: r6, range: t2 } : null;
    }
    function HVe(a, r6, t2, s, u, f6) {
      var d6 = qn({}, r6);
      if (u) {
        var v6 = u.type, m6 = v6 === "color" && dge(u).drColorMappingBy, b6 = m6 === "index" ? s : m6 === "id" ? f6.mapIdToIndex(t2.getId()) : t2.getValue(a.get("visualDimension"));
        d6[v6] = u.mapValueToVisual(b6);
      }
      return d6;
    }
    var h4 = Math.max, mz = Math.min, gge = Jf, HX = Ne, mge = ["itemStyle", "borderWidth"], $Ve = ["itemStyle", "gapWidth"], UVe = ["upperLabel", "show"], qVe = ["upperLabel", "height"], YVe = { seriesType: "treemap", reset: function(a, r6, t2, s) {
      var u = t2.getWidth(), f6 = t2.getHeight(), d6 = a.option, v6 = ah(a.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() }), m6 = d6.size || [], b6 = ua(gge(v6.width, m6[0]), u), x6 = ua(gge(v6.height, m6[1]), f6), S = s && s.type, M = ["treemapZoomToNode", "treemapRootToNode"], A6 = o4(s, M, a), I = S === "treemapRender" || S === "treemapMove" ? s.rootRect : null, R = a.getViewRoot(), F = tge(R);
      if (S !== "treemapMove") {
        var j = S === "treemapZoomToNode" ? eze(a, A6, R, b6, x6) : I ? [I.width, I.height] : [b6, x6], $ = d6.sort;
        $ && $ !== "asc" && $ !== "desc" && ($ = "desc");
        var K = { squareRatio: d6.squareRatio, sort: $, leafDepth: d6.leafDepth };
        R.hostTree.clearLayouts();
        var U = { x: 0, y: 0, width: j[0], height: j[1], area: j[0] * j[1] };
        R.setLayout(U), yge(R, K, false, 0), U = R.getLayout(), HX(F, function(ue, pe) {
          var _e = (F[pe + 1] || R).getValue();
          ue.setLayout(qn({ dataExtent: [_e, _e], borderWidth: 0, upperHeight: 0 }, U));
        });
      }
      var he = a.getData().tree.root;
      he.setLayout(tze(v6, I, A6), true), a.setLayoutInfo(v6), _ge(he, new Qi(-v6.x, -v6.y, u, f6), F, R, 0);
    } };
    function yge(a, r6, t2, s) {
      var u, f6;
      if (!a.isRemoved()) {
        var d6 = a.getLayout();
        u = d6.width, f6 = d6.height;
        var v6 = a.getModel(), m6 = v6.get(mge), b6 = v6.get($Ve) / 2, x6 = xge(v6), S = Math.max(m6, x6), M = m6 - b6, A6 = S - b6;
        a.setLayout({ borderWidth: m6, upperHeight: S, upperLabelHeight: x6 }, true), u = h4(u - 2 * M, 0), f6 = h4(f6 - M - A6, 0);
        var I = u * f6, R = ZVe(a, v6, I, r6, t2, s);
        if (R.length) {
          var F = { x: M, y: A6, width: u, height: f6 }, j = mz(u, f6), $ = 1 / 0, K = [];
          K.area = 0;
          for (var U = 0, he = R.length; U < he; ) {
            var ue = R[U];
            K.push(ue), K.area += ue.getLayout().area;
            var pe = QVe(K, j, r6.squareRatio);
            pe <= $ ? (U++, $ = pe) : (K.area -= K.pop().getLayout().area, bge(K, j, F, b6, false), j = mz(F.width, F.height), K.length = K.area = 0, $ = 1 / 0);
          }
          if (K.length && bge(K, j, F, b6, true), !t2) {
            var _e = v6.get("childrenVisibleMin");
            _e != null && I < _e && (t2 = true);
          }
          for (var U = 0, he = R.length; U < he; U++)
            yge(R[U], r6, t2, s + 1);
        }
      }
    }
    function ZVe(a, r6, t2, s, u, f6) {
      var d6 = a.children || [], v6 = s.sort;
      v6 !== "asc" && v6 !== "desc" && (v6 = null);
      var m6 = s.leafDepth != null && s.leafDepth <= f6;
      if (u && !m6)
        return a.viewChildren = [];
      d6 = gl(d6, function(A6) {
        return !A6.isRemoved();
      }), KVe(d6, v6);
      var b6 = JVe(r6, d6, v6);
      if (b6.sum === 0)
        return a.viewChildren = [];
      if (b6.sum = XVe(r6, t2, b6.sum, v6, d6), b6.sum === 0)
        return a.viewChildren = [];
      for (var x6 = 0, S = d6.length; x6 < S; x6++) {
        var M = d6[x6].getValue() / b6.sum * t2;
        d6[x6].setLayout({ area: M });
      }
      return m6 && (d6.length && a.setLayout({ isLeafRoot: true }, true), d6.length = 0), a.viewChildren = d6, a.setLayout({ dataExtent: b6.dataExtent }, true), d6;
    }
    function XVe(a, r6, t2, s, u) {
      if (!s)
        return t2;
      for (var f6 = a.get("visibleMin"), d6 = u.length, v6 = d6, m6 = d6 - 1; m6 >= 0; m6--) {
        var b6 = u[s === "asc" ? d6 - m6 - 1 : m6].getValue();
        b6 / t2 * r6 < f6 && (v6 = m6, t2 -= b6);
      }
      return s === "asc" ? u.splice(0, d6 - v6) : u.splice(v6, d6 - v6), t2;
    }
    function KVe(a, r6) {
      return r6 && a.sort(function(t2, s) {
        var u = r6 === "asc" ? t2.getValue() - s.getValue() : s.getValue() - t2.getValue();
        return u === 0 ? r6 === "asc" ? t2.dataIndex - s.dataIndex : s.dataIndex - t2.dataIndex : u;
      }), a;
    }
    function JVe(a, r6, t2) {
      for (var s = 0, u = 0, f6 = r6.length; u < f6; u++)
        s += r6[u].getValue();
      var d6 = a.get("visualDimension"), v6;
      return !r6 || !r6.length ? v6 = [NaN, NaN] : d6 === "value" && t2 ? (v6 = [r6[r6.length - 1].getValue(), r6[0].getValue()], t2 === "asc" && v6.reverse()) : (v6 = [1 / 0, -1 / 0], HX(r6, function(m6) {
        var b6 = m6.getValue(d6);
        b6 < v6[0] && (v6[0] = b6), b6 > v6[1] && (v6[1] = b6);
      })), { sum: s, dataExtent: v6 };
    }
    function QVe(a, r6, t2) {
      for (var s = 0, u = 1 / 0, f6 = 0, d6 = void 0, v6 = a.length; f6 < v6; f6++)
        d6 = a[f6].getLayout().area, d6 && (d6 < u && (u = d6), d6 > s && (s = d6));
      var m6 = a.area * a.area, b6 = r6 * r6 * t2;
      return m6 ? h4(b6 * s / m6, m6 / (b6 * u)) : 1 / 0;
    }
    function bge(a, r6, t2, s, u) {
      var f6 = r6 === t2.width ? 0 : 1, d6 = 1 - f6, v6 = ["x", "y"], m6 = ["width", "height"], b6 = t2[v6[f6]], x6 = r6 ? a.area / r6 : 0;
      (u || x6 > t2[m6[d6]]) && (x6 = t2[m6[d6]]);
      for (var S = 0, M = a.length; S < M; S++) {
        var A6 = a[S], I = {}, R = x6 ? A6.getLayout().area / x6 : 0, F = I[m6[d6]] = h4(x6 - 2 * s, 0), j = t2[v6[f6]] + t2[m6[f6]] - b6, $ = S === M - 1 || j < R ? j : R, K = I[m6[f6]] = h4($ - 2 * s, 0);
        I[v6[d6]] = t2[v6[d6]] + mz(s, F / 2), I[v6[f6]] = b6 + mz(s, K / 2), b6 += $, A6.setLayout(I, true);
      }
      t2[v6[d6]] += x6, t2[m6[d6]] -= x6;
    }
    function eze(a, r6, t2, s, u) {
      var f6 = (r6 || {}).node, d6 = [s, u];
      if (!f6 || f6 === t2)
        return d6;
      for (var v6, m6 = s * u, b6 = m6 * a.option.zoomToNodeRatio; v6 = f6.parentNode; ) {
        for (var x6 = 0, S = v6.children, M = 0, A6 = S.length; M < A6; M++)
          x6 += S[M].getValue();
        var I = f6.getValue();
        if (I === 0)
          return d6;
        b6 *= x6 / I;
        var R = v6.getModel(), F = R.get(mge), j = Math.max(F, xge(R));
        b6 += 4 * F * F + (3 * F + j) * Math.pow(b6, 0.5), b6 > BM && (b6 = BM), f6 = v6;
      }
      b6 < m6 && (b6 = m6);
      var $ = Math.pow(b6 / m6, 0.5);
      return [s * $, u * $];
    }
    function tze(a, r6, t2) {
      if (r6)
        return { x: r6.x, y: r6.y };
      var s = { x: 0, y: 0 };
      if (!t2)
        return s;
      var u = t2.node, f6 = u.getLayout();
      if (!f6)
        return s;
      for (var d6 = [f6.width / 2, f6.height / 2], v6 = u; v6; ) {
        var m6 = v6.getLayout();
        d6[0] += m6.x, d6[1] += m6.y, v6 = v6.parentNode;
      }
      return { x: a.width / 2 - d6[0], y: a.height / 2 - d6[1] };
    }
    function _ge(a, r6, t2, s, u) {
      var f6 = a.getLayout(), d6 = t2[u], v6 = d6 && d6 === a;
      if (!(d6 && !v6 || u === t2.length && a !== s)) {
        a.setLayout({ isInView: true, invisible: !v6 && !r6.intersect(f6), isAboveViewRoot: v6 }, true);
        var m6 = new Qi(r6.x - f6.x, r6.y - f6.y, r6.width, r6.height);
        HX(a.viewChildren || [], function(b6) {
          _ge(b6, m6, t2, s, u + 1);
        });
      }
    }
    function xge(a) {
      return a.get(UVe) ? a.get(qVe) : 0;
    }
    function nze(a) {
      a.registerSeriesModel(_Ve), a.registerChartView(OVe), a.registerVisual(BVe), a.registerLayout(YVe), mVe(a);
    }
    function rze(a) {
      var r6 = a.findComponents({ mainType: "legend" });
      !r6 || !r6.length || a.eachSeriesByType("graph", function(t2) {
        var s = t2.getCategoriesData(), u = t2.getGraph(), f6 = u.data, d6 = s.mapArray(s.getName);
        f6.filterSelf(function(v6) {
          var m6 = f6.getItemModel(v6), b6 = m6.getShallow("category");
          if (b6 != null) {
            ks(b6) && (b6 = d6[b6]);
            for (var x6 = 0; x6 < r6.length; x6++)
              if (!r6[x6].isSelected(b6))
                return false;
          }
          return true;
        });
      });
    }
    function aze(a) {
      var r6 = {};
      a.eachSeriesByType("graph", function(t2) {
        var s = t2.getCategoriesData(), u = t2.getData(), f6 = {};
        s.each(function(d6) {
          var v6 = s.getName(d6);
          f6["ec-" + v6] = d6;
          var m6 = s.getItemModel(d6), b6 = m6.getModel("itemStyle").getItemStyle();
          b6.fill || (b6.fill = t2.getColorFromPalette(v6, r6)), s.setItemVisual(d6, "style", b6);
          for (var x6 = ["symbol", "symbolSize", "symbolKeepAspect"], S = 0; S < x6.length; S++) {
            var M = m6.getShallow(x6[S], true);
            M != null && s.setItemVisual(d6, x6[S], M);
          }
        }), s.count() && u.each(function(d6) {
          var v6 = u.getItemModel(d6), m6 = v6.getShallow("category");
          if (m6 != null) {
            _a2(m6) && (m6 = f6["ec-" + m6]);
            var b6 = s.getItemVisual(m6, "style"), x6 = u.ensureUniqueItemVisual(d6, "style");
            qn(x6, b6);
            for (var S = ["symbol", "symbolSize", "symbolKeepAspect"], M = 0; M < S.length; M++)
              u.setItemVisual(d6, S[M], s.getItemVisual(m6, S[M]));
          }
        });
      });
    }
    function yz(a) {
      return a instanceof Array || (a = [a, a]), a;
    }
    function ize(a) {
      a.eachSeriesByType("graph", function(r6) {
        var t2 = r6.getGraph(), s = r6.getEdgeData(), u = yz(r6.get("edgeSymbol")), f6 = yz(r6.get("edgeSymbolSize"));
        s.setVisual("fromSymbol", u && u[0]), s.setVisual("toSymbol", u && u[1]), s.setVisual("fromSymbolSize", f6 && f6[0]), s.setVisual("toSymbolSize", f6 && f6[1]), s.setVisual("style", r6.getModel("lineStyle").getLineStyle()), s.each(function(d6) {
          var v6 = s.getItemModel(d6), m6 = t2.getEdgeByIndex(d6), b6 = yz(v6.getShallow("symbol", true)), x6 = yz(v6.getShallow("symbolSize", true)), S = v6.getModel("lineStyle").getLineStyle(), M = s.ensureUniqueItemVisual(d6, "style");
          switch (qn(M, S), M.stroke) {
            case "source": {
              var A6 = m6.node1.getVisual("style");
              M.stroke = A6 && A6.fill;
              break;
            }
            case "target": {
              var A6 = m6.node2.getVisual("style");
              M.stroke = A6 && A6.fill;
              break;
            }
          }
          b6[0] && m6.setVisual("fromSymbol", b6[0]), b6[1] && m6.setVisual("toSymbol", b6[1]), x6[0] && m6.setVisual("fromSymbolSize", x6[0]), x6[1] && m6.setVisual("toSymbolSize", x6[1]);
        });
      });
    }
    var $X = "-->", bz = function(a) {
      return a.get("autoCurveness") || null;
    }, wge = function(a, r6) {
      var t2 = bz(a), s = 20, u = [];
      if (ks(t2))
        s = t2;
      else if (br(t2)) {
        a.__curvenessList = t2;
        return;
      }
      r6 > s && (s = r6);
      var f6 = s % 2 ? s + 2 : s + 3;
      u = [];
      for (var d6 = 0; d6 < f6; d6++)
        u.push((d6 % 2 ? d6 + 1 : d6) / 10 * (d6 % 2 ? -1 : 1));
      a.__curvenessList = u;
    }, d4 = function(a, r6, t2) {
      var s = [a.id, a.dataIndex].join("."), u = [r6.id, r6.dataIndex].join(".");
      return [t2.uid, s, u].join($X);
    }, Sge = function(a) {
      var r6 = a.split($X);
      return [r6[0], r6[2], r6[1]].join($X);
    }, oze = function(a, r6) {
      var t2 = d4(a.node1, a.node2, r6);
      return r6.__edgeMap[t2];
    }, sze = function(a, r6) {
      var t2 = UX(d4(a.node1, a.node2, r6), r6), s = UX(d4(a.node2, a.node1, r6), r6);
      return t2 + s;
    }, UX = function(a, r6) {
      var t2 = r6.__edgeMap;
      return t2[a] ? t2[a].length : 0;
    };
    function lze(a) {
      !bz(a) || (a.__curvenessList = [], a.__edgeMap = {}, wge(a));
    }
    function uze(a, r6, t2, s) {
      if (bz(t2)) {
        var u = d4(a, r6, t2), f6 = t2.__edgeMap, d6 = f6[Sge(u)];
        f6[u] && !d6 ? f6[u].isForward = true : d6 && f6[u] && (d6.isForward = true, f6[u].isForward = false), f6[u] = f6[u] || [], f6[u].push(s);
      }
    }
    function qX(a, r6, t2, s) {
      var u = bz(r6), f6 = br(u);
      if (!u)
        return null;
      var d6 = oze(a, r6);
      if (!d6)
        return null;
      for (var v6 = -1, m6 = 0; m6 < d6.length; m6++)
        if (d6[m6] === t2) {
          v6 = m6;
          break;
        }
      var b6 = sze(a, r6);
      wge(r6, b6), a.lineStyle = a.lineStyle || {};
      var x6 = d4(a.node1, a.node2, r6), S = r6.__curvenessList, M = f6 || b6 % 2 ? 0 : 1;
      if (d6.isForward)
        return S[M + v6];
      var A6 = Sge(x6), I = UX(A6, r6), R = S[v6 + I + M];
      return s ? f6 ? u && u[0] === 0 ? (I + M) % 2 ? R : -R : ((I % 2 ? 0 : 1) + M) % 2 ? R : -R : (I + M) % 2 ? R : -R : S[v6 + I + M];
    }
    function Cge(a) {
      var r6 = a.coordinateSystem;
      if (!(r6 && r6.type !== "view")) {
        var t2 = a.getGraph();
        t2.eachNode(function(s) {
          var u = s.getModel();
          s.setLayout([+u.get("x"), +u.get("y")]);
        }), Mge(t2, a);
      }
    }
    function Mge(a, r6) {
      a.eachEdge(function(t2, s) {
        var u = Uy(t2.getModel().get(["lineStyle", "curveness"]), -qX(t2, r6, s, true), 0), f6 = gf(t2.node1.getLayout()), d6 = gf(t2.node2.getLayout()), v6 = [f6, d6];
        +u && v6.push([(f6[0] + d6[0]) / 2 - (f6[1] - d6[1]) * u, (f6[1] + d6[1]) / 2 - (d6[0] - f6[0]) * u]), t2.setLayout(v6);
      });
    }
    function cze(a, r6) {
      a.eachSeriesByType("graph", function(t2) {
        var s = t2.get("layout"), u = t2.coordinateSystem;
        if (u && u.type !== "view") {
          var f6 = t2.getData(), d6 = [];
          Ne(u.dimensions, function(M) {
            d6 = d6.concat(f6.mapDimensionsAll(M));
          });
          for (var v6 = 0; v6 < f6.count(); v6++) {
            for (var m6 = [], b6 = false, x6 = 0; x6 < d6.length; x6++) {
              var S = f6.get(d6[x6], v6);
              isNaN(S) || (b6 = true), m6.push(S);
            }
            b6 ? f6.setItemLayout(v6, u.dataToPoint(m6)) : f6.setItemLayout(v6, [NaN, NaN]);
          }
          Mge(f6.graph, t2);
        } else
          (!s || s === "none") && Cge(t2);
      });
    }
    function p42(a) {
      var r6 = a.coordinateSystem;
      if (r6.type !== "view")
        return 1;
      var t2 = a.option.nodeScaleRatio, s = r6.scaleX, u = r6.getZoom(), f6 = (u - 1) * t2 + 1;
      return f6 / s;
    }
    function v4(a) {
      var r6 = a.getVisual("symbolSize");
      return r6 instanceof Array && (r6 = (r6[0] + r6[1]) / 2), +r6;
    }
    var Age = Math.PI, YX = [];
    function Ege(a, r6) {
      var t2 = a.coordinateSystem;
      if (!(t2 && t2.type !== "view")) {
        var s = t2.getBoundingRect(), u = a.getData(), f6 = u.graph, d6 = s.width / 2 + s.x, v6 = s.height / 2 + s.y, m6 = Math.min(s.width, s.height) / 2, b6 = u.count();
        u.setLayout({ cx: d6, cy: v6 }), b6 && (fze[r6](a, f6, u, m6, d6, v6, b6), f6.eachEdge(function(x6, S) {
          var M = Uy(x6.getModel().get(["lineStyle", "curveness"]), qX(x6, a, S), 0), A6 = gf(x6.node1.getLayout()), I = gf(x6.node2.getLayout()), R, F = (A6[0] + I[0]) / 2, j = (A6[1] + I[1]) / 2;
          +M && (M *= 3, R = [d6 * M + F * (1 - M), v6 * M + j * (1 - M)]), x6.setLayout([A6, I, R]);
        }));
      }
    }
    var fze = { value: function(a, r6, t2, s, u, f6, d6) {
      var v6 = 0, m6 = t2.getSum("value"), b6 = Math.PI * 2 / (m6 || d6);
      r6.eachNode(function(x6) {
        var S = x6.getValue("value"), M = b6 * (m6 ? S : 1) / 2;
        v6 += M, x6.setLayout([s * Math.cos(v6) + u, s * Math.sin(v6) + f6]), v6 += M;
      });
    }, symbolSize: function(a, r6, t2, s, u, f6, d6) {
      var v6 = 0;
      YX.length = d6;
      var m6 = p42(a);
      r6.eachNode(function(S) {
        var M = v4(S);
        isNaN(M) && (M = 2), M < 0 && (M = 0), M *= m6;
        var A6 = Math.asin(M / 2 / s);
        isNaN(A6) && (A6 = Age / 2), YX[S.dataIndex] = A6, v6 += A6 * 2;
      });
      var b6 = (2 * Age - v6) / d6 / 2, x6 = 0;
      r6.eachNode(function(S) {
        var M = b6 + YX[S.dataIndex];
        x6 += M, S.setLayout([s * Math.cos(x6) + u, s * Math.sin(x6) + f6]), x6 += M;
      });
    } };
    function hze(a) {
      a.eachSeriesByType("graph", function(r6) {
        r6.get("layout") === "circular" && Ege(r6, "symbolSize");
      });
    }
    var b5 = fm;
    function dze(a, r6, t2) {
      for (var s = a, u = r6, f6 = t2.rect, d6 = f6.width, v6 = f6.height, m6 = [f6.x + d6 / 2, f6.y + v6 / 2], b6 = t2.gravity == null ? 0.1 : t2.gravity, x6 = 0; x6 < s.length; x6++) {
        var S = s[x6];
        S.p || (S.p = Df(d6 * (Math.random() - 0.5) + m6[0], v6 * (Math.random() - 0.5) + m6[1])), S.pp = gf(S.p), S.edges = null;
      }
      var M = t2.friction == null ? 0.6 : t2.friction, A6 = M, I, R;
      return { warmUp: function() {
        A6 = M * 0.8;
      }, setFixed: function(F) {
        s[F].fixed = true;
      }, setUnfixed: function(F) {
        s[F].fixed = false;
      }, beforeStep: function(F) {
        I = F;
      }, afterStep: function(F) {
        R = F;
      }, step: function(F) {
        I && I(s, u);
        for (var j = [], $ = s.length, K = 0; K < u.length; K++) {
          var U = u[K];
          if (!U.ignoreForceLayout) {
            var he = U.n1, ue = U.n2;
            hm(j, ue.p, he.p);
            var pe = gM(j) - U.d, _e = ue.w / (he.w + ue.w);
            isNaN(_e) && (_e = 0), ix(j, j), !he.fixed && b5(he.p, he.p, j, _e * pe * A6), !ue.fixed && b5(ue.p, ue.p, j, -(1 - _e) * pe * A6);
          }
        }
        for (var K = 0; K < $; K++) {
          var xe = s[K];
          xe.fixed || (hm(j, m6, xe.p), b5(xe.p, xe.p, j, b6 * A6));
        }
        for (var K = 0; K < $; K++)
          for (var he = s[K], Ae = K + 1; Ae < $; Ae++) {
            var ue = s[Ae];
            hm(j, ue.p, he.p);
            var pe = gM(j);
            pe === 0 && (bU(j, Math.random() - 0.5, Math.random() - 0.5), pe = 1);
            var ke = (he.rep + ue.rep) / pe / pe;
            !he.fixed && b5(he.pp, he.pp, j, ke), !ue.fixed && b5(ue.pp, ue.pp, j, -ke);
          }
        for (var je = [], K = 0; K < $; K++) {
          var xe = s[K];
          xe.fixed || (hm(je, xe.p, xe.pp), b5(xe.p, xe.p, je, A6), $d(xe.pp, xe.p));
        }
        A6 = A6 * 0.992;
        var Fe = A6 < 0.01;
        R && R(s, u, Fe), F && F(Fe);
      } };
    }
    function pze(a) {
      a.eachSeriesByType("graph", function(r6) {
        var t2 = r6.coordinateSystem;
        if (!(t2 && t2.type !== "view"))
          if (r6.get("layout") === "force") {
            var s = r6.preservedPoints || {}, u = r6.getGraph(), f6 = u.data, d6 = u.edgeData, v6 = r6.getModel("force"), m6 = v6.get("initLayout");
            r6.preservedPoints ? f6.each(function(K) {
              var U = f6.getId(K);
              f6.setItemLayout(K, s[U] || [NaN, NaN]);
            }) : !m6 || m6 === "none" ? Cge(r6) : m6 === "circular" && Ege(r6, "value");
            var b6 = f6.getDataExtent("value"), x6 = d6.getDataExtent("value"), S = v6.get("repulsion"), M = v6.get("edgeLength"), A6 = br(S) ? S : [S, S], I = br(M) ? M : [M, M];
            I = [I[1], I[0]];
            var R = f6.mapArray("value", function(K, U) {
              var he = f6.getItemLayout(U), ue = gs(K, b6, A6);
              return isNaN(ue) && (ue = (A6[0] + A6[1]) / 2), { w: ue, rep: ue, fixed: f6.getItemModel(U).get("fixed"), p: !he || isNaN(he[0]) || isNaN(he[1]) ? null : he };
            }), F = d6.mapArray("value", function(K, U) {
              var he = u.getEdgeByIndex(U), ue = gs(K, x6, I);
              isNaN(ue) && (ue = (I[0] + I[1]) / 2);
              var pe = he.getModel(), _e = Uy(he.getModel().get(["lineStyle", "curveness"]), -qX(he, r6, U, true), 0);
              return { n1: R[he.node1.dataIndex], n2: R[he.node2.dataIndex], d: ue, curveness: _e, ignoreForceLayout: pe.get("ignoreForceLayout") };
            }), j = t2.getBoundingRect(), $ = dze(R, F, { rect: j, gravity: v6.get("gravity"), friction: v6.get("friction") });
            $.beforeStep(function(K, U) {
              for (var he = 0, ue = K.length; he < ue; he++)
                K[he].fixed && $d(K[he].p, u.getNodeByIndex(he).getLayout());
            }), $.afterStep(function(K, U, he) {
              for (var ue = 0, pe = K.length; ue < pe; ue++)
                K[ue].fixed || u.getNodeByIndex(ue).setLayout(K[ue].p), s[f6.getId(ue)] = K[ue].p;
              for (var ue = 0, pe = U.length; ue < pe; ue++) {
                var _e = U[ue], xe = u.getEdgeByIndex(ue), Ae = _e.n1.p, ke = _e.n2.p, je = xe.getLayout();
                je = je ? je.slice() : [], je[0] = je[0] || [], je[1] = je[1] || [], $d(je[0], Ae), $d(je[1], ke), +_e.curveness && (je[2] = [(Ae[0] + ke[0]) / 2 - (Ae[1] - ke[1]) * _e.curveness, (Ae[1] + ke[1]) / 2 - (ke[0] - Ae[0]) * _e.curveness]), xe.setLayout(je);
              }
            }), r6.forceLayout = $, r6.preservedPoints = s, $.step();
          } else
            r6.forceLayout = null;
      });
    }
    function vze(a, r6, t2) {
      var s = qn(a.getBoxLayoutParams(), { aspect: t2 });
      return ah(s, { width: r6.getWidth(), height: r6.getHeight() });
    }
    function gze(a, r6) {
      var t2 = [];
      return a.eachSeriesByType("graph", function(s) {
        var u = s.get("coordinateSystem");
        if (!u || u === "view") {
          var f6 = s.getData(), d6 = f6.mapArray(function(F) {
            var j = f6.getItemModel(F);
            return [+j.get("x"), +j.get("y")];
          }), v6 = [], m6 = [];
          CD(d6, v6, m6), m6[0] - v6[0] === 0 && (m6[0] += 1, v6[0] -= 1), m6[1] - v6[1] === 0 && (m6[1] += 1, v6[1] -= 1);
          var b6 = (m6[0] - v6[0]) / (m6[1] - v6[1]), x6 = vze(s, r6, b6);
          isNaN(b6) && (v6 = [x6.x, x6.y], m6 = [x6.x + x6.width, x6.y + x6.height]);
          var S = m6[0] - v6[0], M = m6[1] - v6[1], A6 = x6.width, I = x6.height, R = s.coordinateSystem = new a4();
          R.zoomLimit = s.get("scaleLimit"), R.setBoundingRect(v6[0], v6[1], S, M), R.setViewRect(x6.x, x6.y, A6, I), R.setCenter(s.get("center")), R.setZoom(s.get("zoom")), t2.push(R);
        }
      }), t2;
    }
    var Ige = rh.prototype, ZX = GD.prototype, Tge = function() {
      function a() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
      }
      return a;
    }();
    (function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6;
    })(Tge);
    function XX(a) {
      return isNaN(+a.cpx1) || isNaN(+a.cpy1);
    }
    var mze = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "ec-line", s;
      }
      return r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new Tge();
      }, r6.prototype.buildPath = function(t2, s) {
        XX(s) ? Ige.buildPath.call(this, t2, s) : ZX.buildPath.call(this, t2, s);
      }, r6.prototype.pointAt = function(t2) {
        return XX(this.shape) ? Ige.pointAt.call(this, t2) : ZX.pointAt.call(this, t2);
      }, r6.prototype.tangentAt = function(t2) {
        var s = this.shape, u = XX(s) ? [s.x2 - s.x1, s.y2 - s.y1] : ZX.tangentAt.call(this, t2);
        return ix(u, u);
      }, r6;
    }(uo), yze = mze, KX = ["fromSymbol", "toSymbol"];
    function Dge(a) {
      return "_" + a + "Type";
    }
    function kge(a, r6, t2) {
      var s = r6.getItemVisual(t2, a);
      if (!(!s || s === "none")) {
        var u = r6.getItemVisual(t2, a + "Size"), f6 = r6.getItemVisual(t2, a + "Rotate"), d6 = r6.getItemVisual(t2, a + "Offset"), v6 = r6.getItemVisual(t2, a + "KeepAspect"), m6 = IR(u), b6 = l5(d6 || 0, m6), x6 = Lf(s, -m6[0] / 2 + b6[0], -m6[1] / 2 + b6[1], m6[0], m6[1], null, v6);
        return x6.__specifiedRotation = f6 == null || isNaN(f6) ? void 0 : +f6 * Math.PI / 180 || 0, x6.name = a, x6;
      }
    }
    function bze(a) {
      var r6 = new yze({ name: "line", subPixelOptimize: true });
      return JX(r6.shape, a), r6;
    }
    function JX(a, r6) {
      a.x1 = r6[0][0], a.y1 = r6[0][1], a.x2 = r6[1][0], a.y2 = r6[1][1], a.percent = 1;
      var t2 = r6[2];
      t2 ? (a.cpx1 = t2[0], a.cpy1 = t2[1]) : (a.cpx1 = NaN, a.cpy1 = NaN);
    }
    var _ze = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this) || this;
        return f6._createLine(t2, s, u), f6;
      }
      return r6.prototype._createLine = function(t2, s, u) {
        var f6 = t2.hostModel, d6 = t2.getItemLayout(s), v6 = bze(d6);
        v6.shape.percent = 0, zu(v6, { shape: { percent: 1 } }, f6, s), this.add(v6), Ne(KX, function(m6) {
          var b6 = kge(m6, t2, s);
          this.add(b6), this[Dge(m6)] = t2.getItemVisual(s, m6);
        }, this), this._updateCommonStl(t2, s, u);
      }, r6.prototype.updateData = function(t2, s, u) {
        var f6 = t2.hostModel, d6 = this.childOfName("line"), v6 = t2.getItemLayout(s), m6 = { shape: {} };
        JX(m6.shape, v6), fs(d6, m6, f6, s), Ne(KX, function(b6) {
          var x6 = t2.getItemVisual(s, b6), S = Dge(b6);
          if (this[S] !== x6) {
            this.remove(this.childOfName(b6));
            var M = kge(b6, t2, s);
            this.add(M);
          }
          this[S] = x6;
        }, this), this._updateCommonStl(t2, s, u);
      }, r6.prototype.getLinePath = function() {
        return this.childAt(0);
      }, r6.prototype._updateCommonStl = function(t2, s, u) {
        var f6 = t2.hostModel, d6 = this.childOfName("line"), v6 = u && u.emphasisLineStyle, m6 = u && u.blurLineStyle, b6 = u && u.selectLineStyle, x6 = u && u.labelStatesModels, S = u && u.emphasisDisabled, M = u && u.focus, A6 = u && u.blurScope;
        if (!u || t2.hasItemOption) {
          var I = t2.getItemModel(s), R = I.getModel("emphasis");
          v6 = R.getModel("lineStyle").getLineStyle(), m6 = I.getModel(["blur", "lineStyle"]).getLineStyle(), b6 = I.getModel(["select", "lineStyle"]).getLineStyle(), S = R.get("disabled"), M = R.get("focus"), A6 = R.get("blurScope"), x6 = hd(I);
        }
        var F = t2.getItemVisual(s, "style"), j = F.stroke;
        d6.useStyle(F), d6.style.fill = null, d6.style.strokeNoScale = true, d6.ensureState("emphasis").style = v6, d6.ensureState("blur").style = m6, d6.ensureState("select").style = b6, Ne(KX, function(ue) {
          var pe = this.childOfName(ue);
          if (pe) {
            pe.setColor(j), pe.style.opacity = F.opacity;
            for (var _e = 0; _e < Oc.length; _e++) {
              var xe = Oc[_e], Ae = d6.getState(xe);
              if (Ae) {
                var ke = Ae.style || {}, je = pe.ensureState(xe), Fe = je.style || (je.style = {});
                ke.stroke != null && (Fe[pe.__isEmptyBrush ? "stroke" : "fill"] = ke.stroke), ke.opacity != null && (Fe.opacity = ke.opacity);
              }
            }
            pe.markRedraw();
          }
        }, this);
        var $ = f6.getRawValue(s);
        Bp(this, x6, { labelDataIndex: s, labelFetcher: { getFormattedLabel: function(ue, pe) {
          return f6.getFormattedLabel(ue, pe, t2.dataType);
        } }, inheritColor: j || "#000", defaultOpacity: F.opacity, defaultText: ($ == null ? t2.getName(s) : isFinite($) ? Sc($) : $) + "" });
        var K = this.getTextContent();
        if (K) {
          var U = x6.normal;
          K.__align = K.style.align, K.__verticalAlign = K.style.verticalAlign, K.__position = U.get("position") || "middle";
          var he = U.get("distance");
          br(he) || (he = [he, he]), K.__labelDistance = he;
        }
        this.setTextConfig({ position: null, local: true, inside: false }), Cc(this, M, A6, S);
      }, r6.prototype.highlight = function() {
        Cm(this);
      }, r6.prototype.downplay = function() {
        Mm(this);
      }, r6.prototype.updateLayout = function(t2, s) {
        this.setLinePoints(t2.getItemLayout(s));
      }, r6.prototype.setLinePoints = function(t2) {
        var s = this.childOfName("line");
        JX(s.shape, t2), s.dirty();
      }, r6.prototype.beforeUpdate = function() {
        var t2 = this, s = t2.childOfName("fromSymbol"), u = t2.childOfName("toSymbol"), f6 = t2.getTextContent();
        if (!s && !u && (!f6 || f6.ignore))
          return;
        for (var d6 = 1, v6 = this.parent; v6; )
          v6.scaleX && (d6 /= v6.scaleX), v6 = v6.parent;
        var m6 = t2.childOfName("line");
        if (!this.__dirty && !m6.__dirty)
          return;
        var b6 = m6.shape.percent, x6 = m6.pointAt(0), S = m6.pointAt(b6), M = hm([], S, x6);
        ix(M, M);
        function A6(Ae, ke) {
          var je = Ae.__specifiedRotation;
          if (je == null) {
            var Fe = m6.tangentAt(ke);
            Ae.attr("rotation", (ke === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(Fe[1], Fe[0]));
          } else
            Ae.attr("rotation", je);
        }
        if (s && (s.setPosition(x6), A6(s, 0), s.scaleX = s.scaleY = d6 * b6, s.markRedraw()), u && (u.setPosition(S), A6(u, 1), u.scaleX = u.scaleY = d6 * b6, u.markRedraw()), f6 && !f6.ignore) {
          f6.x = f6.y = 0, f6.originX = f6.originY = 0;
          var I = void 0, R = void 0, F = f6.__labelDistance, j = F[0] * d6, $ = F[1] * d6, K = b6 / 2, U = m6.tangentAt(K), he = [U[1], -U[0]], ue = m6.pointAt(K);
          he[1] > 0 && (he[0] = -he[0], he[1] = -he[1]);
          var pe = U[0] < 0 ? -1 : 1;
          if (f6.__position !== "start" && f6.__position !== "end") {
            var _e = -Math.atan2(U[1], U[0]);
            S[0] < x6[0] && (_e = Math.PI + _e), f6.rotation = _e;
          }
          var xe = void 0;
          switch (f6.__position) {
            case "insideStartTop":
            case "insideMiddleTop":
            case "insideEndTop":
            case "middle":
              xe = -$, R = "bottom";
              break;
            case "insideStartBottom":
            case "insideMiddleBottom":
            case "insideEndBottom":
              xe = $, R = "top";
              break;
            default:
              xe = 0, R = "middle";
          }
          switch (f6.__position) {
            case "end":
              f6.x = M[0] * j + S[0], f6.y = M[1] * $ + S[1], I = M[0] > 0.8 ? "left" : M[0] < -0.8 ? "right" : "center", R = M[1] > 0.8 ? "top" : M[1] < -0.8 ? "bottom" : "middle";
              break;
            case "start":
              f6.x = -M[0] * j + x6[0], f6.y = -M[1] * $ + x6[1], I = M[0] > 0.8 ? "right" : M[0] < -0.8 ? "left" : "center", R = M[1] > 0.8 ? "bottom" : M[1] < -0.8 ? "top" : "middle";
              break;
            case "insideStartTop":
            case "insideStart":
            case "insideStartBottom":
              f6.x = j * pe + x6[0], f6.y = x6[1] + xe, I = U[0] < 0 ? "right" : "left", f6.originX = -j * pe, f6.originY = -xe;
              break;
            case "insideMiddleTop":
            case "insideMiddle":
            case "insideMiddleBottom":
            case "middle":
              f6.x = ue[0], f6.y = ue[1] + xe, I = "center", f6.originY = -xe;
              break;
            case "insideEndTop":
            case "insideEnd":
            case "insideEndBottom":
              f6.x = -j * pe + S[0], f6.y = S[1] + xe, I = U[0] >= 0 ? "right" : "left", f6.originX = j * pe, f6.originY = -xe;
              break;
          }
          f6.scaleX = f6.scaleY = d6, f6.setStyle({ verticalAlign: f6.__verticalAlign || R, align: f6.__align || I });
        }
      }, r6;
    }(bi), QX = _ze, xze = function() {
      function a(r6) {
        this.group = new bi(), this._LineCtor = r6 || QX;
      }
      return a.prototype.updateData = function(r6) {
        var t2 = this;
        this._progressiveEls = null;
        var s = this, u = s.group, f6 = s._lineData;
        s._lineData = r6, f6 || u.removeAll();
        var d6 = Pge(r6);
        r6.diff(f6).add(function(v6) {
          t2._doAdd(r6, v6, d6);
        }).update(function(v6, m6) {
          t2._doUpdate(f6, r6, m6, v6, d6);
        }).remove(function(v6) {
          u.remove(f6.getItemGraphicEl(v6));
        }).execute();
      }, a.prototype.updateLayout = function() {
        var r6 = this._lineData;
        !r6 || r6.eachItemGraphicEl(function(t2, s) {
          t2.updateLayout(r6, s);
        }, this);
      }, a.prototype.incrementalPrepareUpdate = function(r6) {
        this._seriesScope = Pge(r6), this._lineData = null, this.group.removeAll();
      }, a.prototype.incrementalUpdate = function(r6, t2) {
        this._progressiveEls = [];
        function s(v6) {
          !v6.isGroup && !wze(v6) && (v6.incremental = true, v6.ensureState("emphasis").hoverLayer = true);
        }
        for (var u = r6.start; u < r6.end; u++) {
          var f6 = t2.getItemLayout(u);
          if (eK(f6)) {
            var d6 = new this._LineCtor(t2, u, this._seriesScope);
            d6.traverse(s), this.group.add(d6), t2.setItemGraphicEl(u, d6), this._progressiveEls.push(d6);
          }
        }
      }, a.prototype.remove = function() {
        this.group.removeAll();
      }, a.prototype.eachRendered = function(r6) {
        s1(this._progressiveEls || this.group, r6);
      }, a.prototype._doAdd = function(r6, t2, s) {
        var u = r6.getItemLayout(t2);
        if (eK(u)) {
          var f6 = new this._LineCtor(r6, t2, s);
          r6.setItemGraphicEl(t2, f6), this.group.add(f6);
        }
      }, a.prototype._doUpdate = function(r6, t2, s, u, f6) {
        var d6 = r6.getItemGraphicEl(s);
        if (!eK(t2.getItemLayout(u))) {
          this.group.remove(d6);
          return;
        }
        d6 ? d6.updateData(t2, u, f6) : d6 = new this._LineCtor(t2, u, f6), t2.setItemGraphicEl(u, d6), this.group.add(d6);
      }, a;
    }();
    function wze(a) {
      return a.animators && a.animators.length > 0;
    }
    function Pge(a) {
      var r6 = a.hostModel, t2 = r6.getModel("emphasis");
      return { lineStyle: r6.getModel("lineStyle").getLineStyle(), emphasisLineStyle: t2.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: r6.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: r6.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: t2.get("disabled"), blurScope: t2.get("blurScope"), focus: t2.get("focus"), labelStatesModels: hd(r6) };
    }
    function Lge(a) {
      return isNaN(a[0]) || isNaN(a[1]);
    }
    function eK(a) {
      return a && !Lge(a[0]) && !Lge(a[1]);
    }
    var tK = xze, nK = [], rK = [], aK = [], _5 = eh, iK = ox, Oge = Math.abs;
    function Rge(a, r6, t2) {
      for (var s = a[0], u = a[1], f6 = a[2], d6 = 1 / 0, v6, m6 = t2 * t2, b6 = 0.1, x6 = 0.1; x6 <= 0.9; x6 += 0.1) {
        nK[0] = _5(s[0], u[0], f6[0], x6), nK[1] = _5(s[1], u[1], f6[1], x6);
        var S = Oge(iK(nK, r6) - m6);
        S < d6 && (d6 = S, v6 = x6);
      }
      for (var M = 0; M < 32; M++) {
        var A6 = v6 + b6;
        rK[0] = _5(s[0], u[0], f6[0], v6), rK[1] = _5(s[1], u[1], f6[1], v6), aK[0] = _5(s[0], u[0], f6[0], A6), aK[1] = _5(s[1], u[1], f6[1], A6);
        var S = iK(rK, r6) - m6;
        if (Oge(S) < 0.01)
          break;
        var I = iK(aK, r6) - m6;
        b6 /= 2, S < 0 ? I >= 0 ? v6 = v6 + b6 : v6 = v6 - b6 : I >= 0 ? v6 = v6 - b6 : v6 = v6 + b6;
      }
      return v6;
    }
    function oK(a, r6) {
      var t2 = [], s = wc, u = [[], [], []], f6 = [[], []], d6 = [];
      r6 /= 2, a.eachEdge(function(v6, m6) {
        var b6 = v6.getLayout(), x6 = v6.getVisual("fromSymbol"), S = v6.getVisual("toSymbol");
        b6.__original || (b6.__original = [gf(b6[0]), gf(b6[1])], b6[2] && b6.__original.push(gf(b6[2])));
        var M = b6.__original;
        if (b6[2] != null) {
          if ($d(u[0], M[0]), $d(u[1], M[2]), $d(u[2], M[1]), x6 && x6 !== "none") {
            var A6 = v4(v6.node1), I = Rge(u, M[0], A6 * r6);
            s(u[0][0], u[1][0], u[2][0], I, t2), u[0][0] = t2[3], u[1][0] = t2[4], s(u[0][1], u[1][1], u[2][1], I, t2), u[0][1] = t2[3], u[1][1] = t2[4];
          }
          if (S && S !== "none") {
            var A6 = v4(v6.node2), I = Rge(u, M[1], A6 * r6);
            s(u[0][0], u[1][0], u[2][0], I, t2), u[1][0] = t2[1], u[2][0] = t2[2], s(u[0][1], u[1][1], u[2][1], I, t2), u[1][1] = t2[1], u[2][1] = t2[2];
          }
          $d(b6[0], u[0]), $d(b6[1], u[2]), $d(b6[2], u[1]);
        } else {
          if ($d(f6[0], M[0]), $d(f6[1], M[1]), hm(d6, f6[1], f6[0]), ix(d6, d6), x6 && x6 !== "none") {
            var A6 = v4(v6.node1);
            fm(f6[0], f6[0], d6, A6 * r6);
          }
          if (S && S !== "none") {
            var A6 = v4(v6.node2);
            fm(f6[1], f6[1], d6, -A6 * r6);
          }
          $d(b6[0], f6[0]), $d(b6[1], f6[1]);
        }
      });
    }
    function Fge(a) {
      return a.type === "view";
    }
    var Sze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s) {
        var u = new XR(), f6 = new tK(), d6 = this.group;
        this._controller = new n4(s.getZr()), this._controllerHost = { target: d6 }, d6.add(u.group), d6.add(f6.group), this._symbolDraw = u, this._lineDraw = f6, this._firstRender = true;
      }, r6.prototype.render = function(t2, s, u) {
        var f6 = this, d6 = t2.coordinateSystem;
        this._model = t2;
        var v6 = this._symbolDraw, m6 = this._lineDraw, b6 = this.group;
        if (Fge(d6)) {
          var x6 = { x: d6.x, y: d6.y, scaleX: d6.scaleX, scaleY: d6.scaleY };
          this._firstRender ? b6.attr(x6) : fs(b6, x6, t2);
        }
        oK(t2.getGraph(), p42(t2));
        var S = t2.getData();
        v6.updateData(S);
        var M = t2.getEdgeData();
        m6.updateData(M), this._updateNodeAndLinkScale(), this._updateController(t2, s, u), clearTimeout(this._layoutTimeout);
        var A6 = t2.forceLayout, I = t2.get(["force", "layoutAnimation"]);
        A6 && this._startForceLayoutIteration(A6, I), S.graph.eachNode(function($) {
          var K = $.dataIndex, U = $.getGraphicEl(), he = $.getModel();
          if (U) {
            U.off("drag").off("dragend");
            var ue = he.get("draggable");
            ue && U.on("drag", function() {
              A6 && (A6.warmUp(), !f6._layouting && f6._startForceLayoutIteration(A6, I), A6.setFixed(K), S.setItemLayout(K, [U.x, U.y]));
            }).on("dragend", function() {
              A6 && A6.setUnfixed(K);
            }), U.setDraggable(ue && !!A6);
            var pe = he.get(["emphasis", "focus"]);
            pe === "adjacency" && (ii(U).focus = $.getAdjacentDataIndices());
          }
        }), S.graph.eachEdge(function($) {
          var K = $.getGraphicEl(), U = $.getModel().get(["emphasis", "focus"]);
          !K || U === "adjacency" && (ii(K).focus = { edge: [$.dataIndex], node: [$.node1.dataIndex, $.node2.dataIndex] });
        });
        var R = t2.get("layout") === "circular" && t2.get(["circular", "rotateLabel"]), F = S.getLayout("cx"), j = S.getLayout("cy");
        S.eachItemGraphicEl(function($, K) {
          var U = S.getItemModel(K), he = U.get(["label", "rotate"]) || 0, ue = $.getSymbolPath();
          if (R) {
            var pe = S.getItemLayout(K), _e = Math.atan2(pe[1] - j, pe[0] - F);
            _e < 0 && (_e = Math.PI * 2 + _e);
            var xe = pe[0] < F;
            xe && (_e = _e - Math.PI);
            var Ae = xe ? "left" : "right";
            ue.setTextConfig({ rotation: -_e, position: Ae, origin: "center" });
            var ke = ue.ensureState("emphasis");
            qn(ke.textConfig || (ke.textConfig = {}), { position: Ae });
          } else
            ue.setTextConfig({ rotation: he *= Math.PI / 180 });
        }), this._firstRender = false;
      }, r6.prototype.dispose = function() {
        this._controller && this._controller.dispose(), this._controllerHost = null;
      }, r6.prototype._startForceLayoutIteration = function(t2, s) {
        var u = this;
        (function f6() {
          t2.step(function(d6) {
            u.updateLayout(u._model), (u._layouting = !d6) && (s ? u._layoutTimeout = setTimeout(f6, 16) : f6());
          });
        })();
      }, r6.prototype._updateController = function(t2, s, u) {
        var f6 = this, d6 = this._controller, v6 = this._controllerHost, m6 = this.group;
        if (d6.setPointerChecker(function(b6, x6, S) {
          var M = m6.getBoundingRect();
          return M.applyTransform(m6.transform), M.contain(x6, S) && !sz(b6, u, t2);
        }), !Fge(t2.coordinateSystem)) {
          d6.disable();
          return;
        }
        d6.enable(t2.get("roam")), v6.zoomLimit = t2.get("scaleLimit"), v6.zoom = t2.coordinateSystem.getZoom(), d6.off("pan").off("zoom").on("pan", function(b6) {
          SX(v6, b6.dx, b6.dy), u.dispatchAction({ seriesId: t2.id, type: "graphRoam", dx: b6.dx, dy: b6.dy });
        }).on("zoom", function(b6) {
          CX(v6, b6.scale, b6.originX, b6.originY), u.dispatchAction({ seriesId: t2.id, type: "graphRoam", zoom: b6.scale, originX: b6.originX, originY: b6.originY }), f6._updateNodeAndLinkScale(), oK(t2.getGraph(), p42(t2)), f6._lineDraw.updateLayout(), u.updateLabelLayout();
        });
      }, r6.prototype._updateNodeAndLinkScale = function() {
        var t2 = this._model, s = t2.getData(), u = p42(t2);
        s.eachItemGraphicEl(function(f6, d6) {
          f6 && f6.setSymbolScale(u);
        });
      }, r6.prototype.updateLayout = function(t2) {
        oK(t2.getGraph(), p42(t2)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
      }, r6.prototype.remove = function(t2, s) {
        this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
      }, r6.type = "graph", r6;
    }(bu), Cze = Sze;
    function x5(a) {
      return "_EC_" + a;
    }
    var Mze = function() {
      function a(r6) {
        this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = r6 || false;
      }
      return a.prototype.isDirected = function() {
        return this._directed;
      }, a.prototype.addNode = function(r6, t2) {
        r6 = r6 == null ? "" + t2 : "" + r6;
        var s = this._nodesMap;
        if (!s[x5(r6)]) {
          var u = new DA(r6, t2);
          return u.hostGraph = this, this.nodes.push(u), s[x5(r6)] = u, u;
        }
      }, a.prototype.getNodeByIndex = function(r6) {
        var t2 = this.data.getRawIndex(r6);
        return this.nodes[t2];
      }, a.prototype.getNodeById = function(r6) {
        return this._nodesMap[x5(r6)];
      }, a.prototype.addEdge = function(r6, t2, s) {
        var u = this._nodesMap, f6 = this._edgesMap;
        if (ks(r6) && (r6 = this.nodes[r6]), ks(t2) && (t2 = this.nodes[t2]), r6 instanceof DA || (r6 = u[x5(r6)]), t2 instanceof DA || (t2 = u[x5(t2)]), !(!r6 || !t2)) {
          var d6 = r6.id + "-" + t2.id, v6 = new Nge(r6, t2, s);
          return v6.hostGraph = this, this._directed && (r6.outEdges.push(v6), t2.inEdges.push(v6)), r6.edges.push(v6), r6 !== t2 && t2.edges.push(v6), this.edges.push(v6), f6[d6] = v6, v6;
        }
      }, a.prototype.getEdgeByIndex = function(r6) {
        var t2 = this.edgeData.getRawIndex(r6);
        return this.edges[t2];
      }, a.prototype.getEdge = function(r6, t2) {
        r6 instanceof DA && (r6 = r6.id), t2 instanceof DA && (t2 = t2.id);
        var s = this._edgesMap;
        return this._directed ? s[r6 + "-" + t2] : s[r6 + "-" + t2] || s[t2 + "-" + r6];
      }, a.prototype.eachNode = function(r6, t2) {
        for (var s = this.nodes, u = s.length, f6 = 0; f6 < u; f6++)
          s[f6].dataIndex >= 0 && r6.call(t2, s[f6], f6);
      }, a.prototype.eachEdge = function(r6, t2) {
        for (var s = this.edges, u = s.length, f6 = 0; f6 < u; f6++)
          s[f6].dataIndex >= 0 && s[f6].node1.dataIndex >= 0 && s[f6].node2.dataIndex >= 0 && r6.call(t2, s[f6], f6);
      }, a.prototype.breadthFirstTraverse = function(r6, t2, s, u) {
        if (t2 instanceof DA || (t2 = this._nodesMap[x5(t2)]), !!t2) {
          for (var f6 = s === "out" ? "outEdges" : s === "in" ? "inEdges" : "edges", d6 = 0; d6 < this.nodes.length; d6++)
            this.nodes[d6].__visited = false;
          if (!r6.call(u, t2, null))
            for (var v6 = [t2]; v6.length; )
              for (var m6 = v6.shift(), b6 = m6[f6], d6 = 0; d6 < b6.length; d6++) {
                var x6 = b6[d6], S = x6.node1 === m6 ? x6.node2 : x6.node1;
                if (!S.__visited) {
                  if (r6.call(u, S, m6))
                    return;
                  v6.push(S), S.__visited = true;
                }
              }
        }
      }, a.prototype.update = function() {
        for (var r6 = this.data, t2 = this.edgeData, s = this.nodes, u = this.edges, f6 = 0, d6 = s.length; f6 < d6; f6++)
          s[f6].dataIndex = -1;
        for (var f6 = 0, d6 = r6.count(); f6 < d6; f6++)
          s[r6.getRawIndex(f6)].dataIndex = f6;
        t2.filterSelf(function(v6) {
          var m6 = u[t2.getRawIndex(v6)];
          return m6.node1.dataIndex >= 0 && m6.node2.dataIndex >= 0;
        });
        for (var f6 = 0, d6 = u.length; f6 < d6; f6++)
          u[f6].dataIndex = -1;
        for (var f6 = 0, d6 = t2.count(); f6 < d6; f6++)
          u[t2.getRawIndex(f6)].dataIndex = f6;
      }, a.prototype.clone = function() {
        for (var r6 = new a(this._directed), t2 = this.nodes, s = this.edges, u = 0; u < t2.length; u++)
          r6.addNode(t2[u].id, t2[u].dataIndex);
        for (var u = 0; u < s.length; u++) {
          var f6 = s[u];
          r6.addEdge(f6.node1.id, f6.node2.id, f6.dataIndex);
        }
        return r6;
      }, a;
    }(), DA = function() {
      function a(r6, t2) {
        this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = r6 == null ? "" : r6, this.dataIndex = t2 == null ? -1 : t2;
      }
      return a.prototype.degree = function() {
        return this.edges.length;
      }, a.prototype.inDegree = function() {
        return this.inEdges.length;
      }, a.prototype.outDegree = function() {
        return this.outEdges.length;
      }, a.prototype.getModel = function(r6) {
        if (!(this.dataIndex < 0)) {
          var t2 = this.hostGraph, s = t2.data.getItemModel(this.dataIndex);
          return s.getModel(r6);
        }
      }, a.prototype.getAdjacentDataIndices = function() {
        for (var r6 = { edge: [], node: [] }, t2 = 0; t2 < this.edges.length; t2++) {
          var s = this.edges[t2];
          s.dataIndex < 0 || (r6.edge.push(s.dataIndex), r6.node.push(s.node1.dataIndex, s.node2.dataIndex));
        }
        return r6;
      }, a;
    }(), Nge = function() {
      function a(r6, t2, s) {
        this.dataIndex = -1, this.node1 = r6, this.node2 = t2, this.dataIndex = s == null ? -1 : s;
      }
      return a.prototype.getModel = function(r6) {
        if (!(this.dataIndex < 0)) {
          var t2 = this.hostGraph, s = t2.edgeData.getItemModel(this.dataIndex);
          return s.getModel(r6);
        }
      }, a.prototype.getAdjacentDataIndices = function() {
        return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
      }, a;
    }();
    function Vge(a, r6) {
      return { getValue: function(t2) {
        var s = this[a][r6];
        return s.getStore().get(s.getDimensionIndex(t2 || "value"), this.dataIndex);
      }, setVisual: function(t2, s) {
        this.dataIndex >= 0 && this[a][r6].setItemVisual(this.dataIndex, t2, s);
      }, getVisual: function(t2) {
        return this[a][r6].getItemVisual(this.dataIndex, t2);
      }, setLayout: function(t2, s) {
        this.dataIndex >= 0 && this[a][r6].setItemLayout(this.dataIndex, t2, s);
      }, getLayout: function() {
        return this[a][r6].getItemLayout(this.dataIndex);
      }, getGraphicEl: function() {
        return this[a][r6].getItemGraphicEl(this.dataIndex);
      }, getRawIndex: function() {
        return this[a][r6].getRawIndex(this.dataIndex);
      } };
    }
    Dc(DA, Vge("hostGraph", "data")), Dc(Nge, Vge("hostGraph", "edgeData"));
    var Aze = Mze;
    function zge(a, r6, t2, s, u) {
      for (var f6 = new Aze(s), d6 = 0; d6 < a.length; d6++)
        f6.addNode(Jf(a[d6].id, a[d6].name, d6), d6);
      for (var v6 = [], m6 = [], b6 = 0, d6 = 0; d6 < r6.length; d6++) {
        var x6 = r6[d6], S = x6.source, M = x6.target;
        f6.addEdge(S, M, b6) && (m6.push(x6), v6.push(Jf(Zc(x6.id, null), S + " > " + M)), b6++);
      }
      var A6 = t2.get("coordinateSystem"), I;
      if (A6 === "cartesian2d" || A6 === "polar")
        I = Wx(a, t2);
      else {
        var R = yR.get(A6), F = R ? R.dimensions || [] : [];
        Vi(F, "value") < 0 && F.concat(["value"]);
        var j = zR(a, { coordDimensions: F, encodeDefine: t2.getEncode() }).dimensions;
        I = new Tv(j, t2), I.initData(a);
      }
      var $ = new Tv(["value"], t2);
      return $.initData(m6, v6), u && u(I, $), Qve({ mainData: I, struct: f6, structAttr: "graph", datas: { node: I, edge: $ }, datasAttr: { node: "data", edge: "edgeData" } }), f6.update(), f6;
    }
    var Eze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.hasSymbolVisual = true, t2;
      }
      return r6.prototype.init = function(t2) {
        a.prototype.init.apply(this, arguments);
        var s = this;
        function u() {
          return s._categoriesData;
        }
        this.legendVisualProvider = new QR(u, u), this.fillDataTextStyle(t2.edges || t2.links), this._updateCategoriesData();
      }, r6.prototype.mergeOption = function(t2) {
        a.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(t2.edges || t2.links), this._updateCategoriesData();
      }, r6.prototype.mergeDefaultAndTheme = function(t2) {
        a.prototype.mergeDefaultAndTheme.apply(this, arguments), ug(t2, "edgeLabel", ["show"]);
      }, r6.prototype.getInitialData = function(t2, s) {
        var u = t2.edges || t2.links || [], f6 = t2.data || t2.nodes || [], d6 = this;
        if (f6 && u) {
          lze(this);
          var v6 = zge(f6, u, this, true, m6);
          return Ne(v6.edges, function(b6) {
            uze(b6.node1, b6.node2, this, b6.dataIndex);
          }, this), v6.data;
        }
        function m6(b6, x6) {
          b6.wrapMethod("getItemModel", function(I) {
            var R = d6._categoriesModels, F = I.getShallow("category"), j = R[F];
            return j && (j.parentModel = I.parentModel, I.parentModel = j), I;
          });
          var S = yu.prototype.getModel;
          function M(I, R) {
            var F = S.call(this, I, R);
            return F.resolveParentPath = A6, F;
          }
          x6.wrapMethod("getItemModel", function(I) {
            return I.resolveParentPath = A6, I.getModel = M, I;
          });
          function A6(I) {
            if (I && (I[0] === "label" || I[1] === "label")) {
              var R = I.slice();
              return I[0] === "label" ? R[0] = "edgeLabel" : I[1] === "label" && (R[1] = "edgeLabel"), R;
            }
            return I;
          }
        }
      }, r6.prototype.getGraph = function() {
        return this.getData().graph;
      }, r6.prototype.getEdgeData = function() {
        return this.getGraph().edgeData;
      }, r6.prototype.getCategoriesData = function() {
        return this._categoriesData;
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        if (u === "edge") {
          var f6 = this.getData(), d6 = this.getDataParams(t2, u), v6 = f6.graph.getEdgeByIndex(t2), m6 = f6.getName(v6.node1.dataIndex), b6 = f6.getName(v6.node2.dataIndex), x6 = [];
          return m6 != null && x6.push(m6), b6 != null && x6.push(b6), Ih("nameValue", { name: x6.join(" > "), value: d6.value, noValue: d6.value == null });
        }
        var S = Afe({ series: this, dataIndex: t2, multipleSeries: s });
        return S;
      }, r6.prototype._updateCategoriesData = function() {
        var t2 = wr(this.option.categories || [], function(u) {
          return u.value != null ? u : qn({ value: 0 }, u);
        }), s = new Tv(["value"], this);
        s.initData(t2), this._categoriesData = s, this._categoriesModels = s.mapArray(function(u) {
          return s.getItemModel(u);
        });
      }, r6.prototype.setZoom = function(t2) {
        this.option.zoom = t2;
      }, r6.prototype.setCenter = function(t2) {
        this.option.center = t2;
      }, r6.prototype.isAnimationEnabled = function() {
        return a.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
      }, r6.type = "series.graph", r6.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], r6.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, r6;
    }(sc), Ize = Eze, Tze = { type: "graphRoam", event: "graphRoam", update: "none" };
    function Dze(a) {
      a.registerChartView(Cze), a.registerSeriesModel(Ize), a.registerProcessor(rze), a.registerVisual(aze), a.registerVisual(ize), a.registerLayout(cze), a.registerLayout(a.PRIORITY.VISUAL.POST_CHART_LAYOUT, hze), a.registerLayout(pze), a.registerCoordinateSystem("graphView", { dimensions: a4.dimensions, create: gze }), a.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, kc), a.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, kc), a.registerAction(Tze, function(r6, t2) {
        t2.eachComponent({ mainType: "series", query: r6 }, function(s) {
          var u = s.coordinateSystem, f6 = TX(u, r6);
          s.setCenter && s.setCenter(f6.center), s.setZoom && s.setZoom(f6.zoom);
        });
      });
    }
    var kze = function() {
      function a() {
        this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
      }
      return a;
    }(), Pze = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "pointer", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new kze();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = Math.cos, f6 = Math.sin, d6 = s.r, v6 = s.width, m6 = s.angle, b6 = s.x - u(m6) * v6 * (v6 >= d6 / 3 ? 1 : 2), x6 = s.y - f6(m6) * v6 * (v6 >= d6 / 3 ? 1 : 2);
        m6 = s.angle - Math.PI / 2, t2.moveTo(b6, x6), t2.lineTo(s.x + u(m6) * v6, s.y + f6(m6) * v6), t2.lineTo(s.x + u(s.angle) * d6, s.y + f6(s.angle) * d6), t2.lineTo(s.x - u(m6) * v6, s.y - f6(m6) * v6), t2.lineTo(b6, x6);
      }, r6;
    }(uo), Lze = Pze;
    function Oze(a, r6) {
      var t2 = a.get("center"), s = r6.getWidth(), u = r6.getHeight(), f6 = Math.min(s, u), d6 = ua(t2[0], r6.getWidth()), v6 = ua(t2[1], r6.getHeight()), m6 = ua(a.get("radius"), f6 / 2);
      return { cx: d6, cy: v6, r: m6 };
    }
    function _z(a, r6) {
      var t2 = a == null ? "" : a + "";
      return r6 && (_a2(r6) ? t2 = r6.replace("{value}", t2) : ti(r6) && (t2 = r6(a))), t2;
    }
    var sK = Math.PI * 2, Rze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        this.group.removeAll();
        var f6 = t2.get(["axisLine", "lineStyle", "color"]), d6 = Oze(t2, u);
        this._renderMain(t2, s, u, f6, d6), this._data = t2.getData();
      }, r6.prototype.dispose = function() {
      }, r6.prototype._renderMain = function(t2, s, u, f6, d6) {
        for (var v6 = this.group, m6 = t2.get("clockwise"), b6 = -t2.get("startAngle") / 180 * Math.PI, x6 = -t2.get("endAngle") / 180 * Math.PI, S = t2.getModel("axisLine"), M = S.get("roundCap"), A6 = M ? ez : Np, I = S.get("show"), R = S.getModel("lineStyle"), F = R.get("width"), j = !((x6 - b6) % sK) && x6 !== b6 ? sK : (x6 - b6) % sK, $ = b6, K = 0; I && K < f6.length; K++) {
          var U = Math.min(Math.max(f6[K][0], 0), 1);
          x6 = b6 + j * U;
          var he = new A6({ shape: { startAngle: $, endAngle: x6, cx: d6.cx, cy: d6.cy, clockwise: m6, r0: d6.r - F, r: d6.r }, silent: true });
          he.setStyle({ fill: f6[K][1] }), he.setStyle(R.getLineStyle(["color", "width"])), v6.add(he), $ = x6;
        }
        var ue = function(_e) {
          if (_e <= 0)
            return f6[0][1];
          var xe;
          for (xe = 0; xe < f6.length; xe++)
            if (f6[xe][0] >= _e && (xe === 0 ? 0 : f6[xe - 1][0]) < _e)
              return f6[xe][1];
          return f6[xe - 1][1];
        };
        if (!m6) {
          var pe = b6;
          b6 = x6, x6 = pe;
        }
        this._renderTicks(t2, s, u, ue, d6, b6, x6, m6, F), this._renderTitleAndDetail(t2, s, u, ue, d6), this._renderAnchor(t2, d6), this._renderPointer(t2, s, u, ue, d6, b6, x6, m6, F);
      }, r6.prototype._renderTicks = function(t2, s, u, f6, d6, v6, m6, b6, x6) {
        for (var S = this.group, M = d6.cx, A6 = d6.cy, I = d6.r, R = +t2.get("min"), F = +t2.get("max"), j = t2.getModel("splitLine"), $ = t2.getModel("axisTick"), K = t2.getModel("axisLabel"), U = t2.get("splitNumber"), he = $.get("splitNumber"), ue = ua(j.get("length"), I), pe = ua($.get("length"), I), _e = v6, xe = (m6 - v6) / U, Ae = xe / he, ke = j.getModel("lineStyle").getLineStyle(), je = $.getModel("lineStyle").getLineStyle(), Fe = j.get("distance"), at, ht, Qe = 0; Qe <= U; Qe++) {
          if (at = Math.cos(_e), ht = Math.sin(_e), j.get("show")) {
            var en = Fe ? Fe + x6 : x6, bt = new rh({ shape: { x1: at * (I - en) + M, y1: ht * (I - en) + A6, x2: at * (I - ue - en) + M, y2: ht * (I - ue - en) + A6 }, style: ke, silent: true });
            ke.stroke === "auto" && bt.setStyle({ stroke: f6(Qe / U) }), S.add(bt);
          }
          if (K.get("show")) {
            var en = K.get("distance") + Fe, wt = _z(Sc(Qe / U * (F - R) + R), K.get("formatter")), Ft = f6(Qe / U);
            S.add(new ms({ style: yf(K, { text: wt, x: at * (I - ue - en) + M, y: ht * (I - ue - en) + A6, verticalAlign: ht < -0.8 ? "top" : ht > 0.8 ? "bottom" : "middle", align: at < -0.4 ? "left" : at > 0.4 ? "right" : "center" }, { inheritColor: Ft }), silent: true }));
          }
          if ($.get("show") && Qe !== U) {
            var en = $.get("distance");
            en = en ? en + x6 : x6;
            for (var fn = 0; fn <= he; fn++) {
              at = Math.cos(_e), ht = Math.sin(_e);
              var gn = new rh({ shape: { x1: at * (I - en) + M, y1: ht * (I - en) + A6, x2: at * (I - pe - en) + M, y2: ht * (I - pe - en) + A6 }, silent: true, style: je });
              je.stroke === "auto" && gn.setStyle({ stroke: f6((Qe + fn / he) / U) }), S.add(gn), _e += Ae;
            }
            _e -= Ae;
          } else
            _e += xe;
        }
      }, r6.prototype._renderPointer = function(t2, s, u, f6, d6, v6, m6, b6, x6) {
        var S = this.group, M = this._data, A6 = this._progressEls, I = [], R = t2.get(["pointer", "show"]), F = t2.getModel("progress"), j = F.get("show"), $ = t2.getData(), K = $.mapDimension("value"), U = +t2.get("min"), he = +t2.get("max"), ue = [U, he], pe = [v6, m6];
        function _e(Ae, ke) {
          var je = $.getItemModel(Ae), Fe = je.getModel("pointer"), at = ua(Fe.get("width"), d6.r), ht = ua(Fe.get("length"), d6.r), Qe = t2.get(["pointer", "icon"]), en = Fe.get("offsetCenter"), bt = ua(en[0], d6.r), wt = ua(en[1], d6.r), Ft = Fe.get("keepAspect"), fn;
          return Qe ? fn = Lf(Qe, bt - at / 2, wt - ht, at, ht, null, Ft) : fn = new Lze({ shape: { angle: -Math.PI / 2, width: at, r: ht, x: bt, y: wt } }), fn.rotation = -(ke + Math.PI / 2), fn.x = d6.cx, fn.y = d6.cy, fn;
        }
        function xe(Ae, ke) {
          var je = F.get("roundCap"), Fe = je ? ez : Np, at = F.get("overlap"), ht = at ? F.get("width") : x6 / $.count(), Qe = at ? d6.r - ht : d6.r - (Ae + 1) * ht, en = at ? d6.r : d6.r - Ae * ht, bt = new Fe({ shape: { startAngle: v6, endAngle: ke, cx: d6.cx, cy: d6.cy, clockwise: b6, r0: Qe, r: en } });
          return at && (bt.z2 = he - $.get(K, Ae) % he), bt;
        }
        (j || R) && ($.diff(M).add(function(Ae) {
          var ke = $.get(K, Ae);
          if (R) {
            var je = _e(Ae, v6);
            zu(je, { rotation: -((isNaN(+ke) ? pe[0] : gs(ke, ue, pe, true)) + Math.PI / 2) }, t2), S.add(je), $.setItemGraphicEl(Ae, je);
          }
          if (j) {
            var Fe = xe(Ae, v6), at = F.get("clip");
            zu(Fe, { shape: { endAngle: gs(ke, ue, pe, at) } }, t2), S.add(Fe), NO(t2.seriesIndex, $.dataType, Ae, Fe), I[Ae] = Fe;
          }
        }).update(function(Ae, ke) {
          var je = $.get(K, Ae);
          if (R) {
            var Fe = M.getItemGraphicEl(ke), at = Fe ? Fe.rotation : v6, ht = _e(Ae, at);
            ht.rotation = at, fs(ht, { rotation: -((isNaN(+je) ? pe[0] : gs(je, ue, pe, true)) + Math.PI / 2) }, t2), S.add(ht), $.setItemGraphicEl(Ae, ht);
          }
          if (j) {
            var Qe = A6[ke], en = Qe ? Qe.shape.endAngle : v6, bt = xe(Ae, en), wt = F.get("clip");
            fs(bt, { shape: { endAngle: gs(je, ue, pe, wt) } }, t2), S.add(bt), NO(t2.seriesIndex, $.dataType, Ae, bt), I[Ae] = bt;
          }
        }).execute(), $.each(function(Ae) {
          var ke = $.getItemModel(Ae), je = ke.getModel("emphasis"), Fe = je.get("focus"), at = je.get("blurScope"), ht = je.get("disabled");
          if (R) {
            var Qe = $.getItemGraphicEl(Ae), en = $.getItemVisual(Ae, "style"), bt = en.fill;
            if (Qe instanceof nh) {
              var wt = Qe.style;
              Qe.useStyle(qn({ image: wt.image, x: wt.x, y: wt.y, width: wt.width, height: wt.height }, en));
            } else
              Qe.useStyle(en), Qe.type !== "pointer" && Qe.setColor(bt);
            Qe.setStyle(ke.getModel(["pointer", "itemStyle"]).getItemStyle()), Qe.style.fill === "auto" && Qe.setStyle("fill", f6(gs($.get(K, Ae), ue, [0, 1], true))), Qe.z2EmphasisLift = 0, Ah(Qe, ke), Cc(Qe, Fe, at, ht);
          }
          if (j) {
            var Ft = I[Ae];
            Ft.useStyle($.getItemVisual(Ae, "style")), Ft.setStyle(ke.getModel(["progress", "itemStyle"]).getItemStyle()), Ft.z2EmphasisLift = 0, Ah(Ft, ke), Cc(Ft, Fe, at, ht);
          }
        }), this._progressEls = I);
      }, r6.prototype._renderAnchor = function(t2, s) {
        var u = t2.getModel("anchor"), f6 = u.get("show");
        if (f6) {
          var d6 = u.get("size"), v6 = u.get("icon"), m6 = u.get("offsetCenter"), b6 = u.get("keepAspect"), x6 = Lf(v6, s.cx - d6 / 2 + ua(m6[0], s.r), s.cy - d6 / 2 + ua(m6[1], s.r), d6, d6, null, b6);
          x6.z2 = u.get("showAbove") ? 1 : 0, x6.setStyle(u.getModel("itemStyle").getItemStyle()), this.group.add(x6);
        }
      }, r6.prototype._renderTitleAndDetail = function(t2, s, u, f6, d6) {
        var v6 = this, m6 = t2.getData(), b6 = m6.mapDimension("value"), x6 = +t2.get("min"), S = +t2.get("max"), M = new bi(), A6 = [], I = [], R = t2.isAnimationEnabled(), F = t2.get(["pointer", "showAbove"]);
        m6.diff(this._data).add(function(j) {
          A6[j] = new ms({ silent: true }), I[j] = new ms({ silent: true });
        }).update(function(j, $) {
          A6[j] = v6._titleEls[$], I[j] = v6._detailEls[$];
        }).execute(), m6.each(function(j) {
          var $ = m6.getItemModel(j), K = m6.get(b6, j), U = new bi(), he = f6(gs(K, [x6, S], [0, 1], true)), ue = $.getModel("title");
          if (ue.get("show")) {
            var pe = ue.get("offsetCenter"), _e = d6.cx + ua(pe[0], d6.r), xe = d6.cy + ua(pe[1], d6.r), Ae = A6[j];
            Ae.attr({ z2: F ? 0 : 2, style: yf(ue, { x: _e, y: xe, text: m6.getName(j), align: "center", verticalAlign: "middle" }, { inheritColor: he }) }), U.add(Ae);
          }
          var ke = $.getModel("detail");
          if (ke.get("show")) {
            var je = ke.get("offsetCenter"), Fe = d6.cx + ua(je[0], d6.r), at = d6.cy + ua(je[1], d6.r), ht = ua(ke.get("width"), d6.r), Qe = ua(ke.get("height"), d6.r), en = t2.get(["progress", "show"]) ? m6.getItemVisual(j, "style").fill : he, Ae = I[j], bt = ke.get("formatter");
            Ae.attr({ z2: F ? 0 : 2, style: yf(ke, { x: Fe, y: at, text: _z(K, bt), width: isNaN(ht) ? null : ht, height: isNaN(Qe) ? null : Qe, align: "center", verticalAlign: "middle" }, { inheritColor: en }) }), ece(Ae, { normal: ke }, K, function(Ft) {
              return _z(Ft, bt);
            }), R && tce(Ae, j, m6, t2, { getFormattedLabel: function(Ft, fn, gn, Zr, Ma, Ua) {
              return _z(Ua ? Ua.interpolatedValue : K, bt);
            } }), U.add(Ae);
          }
          M.add(U);
        }), this.group.add(M), this._titleEls = A6, this._detailEls = I;
      }, r6.type = "gauge", r6;
    }(bu), Fze = Rze, Nze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.visualStyleAccessPath = "itemStyle", t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        return g5(this, ["value"]);
      }, r6.type = "series.gauge", r6.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, r6;
    }(sc), Vze = Nze;
    function zze(a) {
      a.registerChartView(Fze), a.registerSeriesModel(Vze);
    }
    var Bze = ["itemStyle", "opacity"], jze = function(a) {
      tt(r6, a);
      function r6(t2, s) {
        var u = a.call(this) || this, f6 = u, d6 = new Vp(), v6 = new ms();
        return f6.setTextContent(v6), u.setTextGuideLine(d6), u.updateData(t2, s, true), u;
      }
      return r6.prototype.updateData = function(t2, s, u) {
        var f6 = this, d6 = t2.hostModel, v6 = t2.getItemModel(s), m6 = t2.getItemLayout(s), b6 = v6.getModel("emphasis"), x6 = v6.get(Bze);
        x6 = x6 == null ? 1 : x6, u || f0(f6), f6.useStyle(t2.getItemVisual(s, "style")), f6.style.lineJoin = "round", u ? (f6.setShape({ points: m6.points }), f6.style.opacity = 0, zu(f6, { style: { opacity: x6 } }, d6, s)) : fs(f6, { style: { opacity: x6 }, shape: { points: m6.points } }, d6, s), Ah(f6, v6), this._updateLabel(t2, s), Cc(this, b6.get("focus"), b6.get("blurScope"), b6.get("disabled"));
      }, r6.prototype._updateLabel = function(t2, s) {
        var u = this, f6 = this.getTextGuideLine(), d6 = u.getTextContent(), v6 = t2.hostModel, m6 = t2.getItemModel(s), b6 = t2.getItemLayout(s), x6 = b6.label, S = t2.getItemVisual(s, "style"), M = S.fill;
        Bp(d6, hd(m6), { labelFetcher: t2.hostModel, labelDataIndex: s, defaultOpacity: S.opacity, defaultText: t2.getName(s) }, { normal: { align: x6.textAlign, verticalAlign: x6.verticalAlign } }), u.setTextConfig({ local: true, inside: !!x6.inside, insideStroke: M, outsideFill: M });
        var A6 = x6.linePoints;
        f6.setShape({ points: A6 }), u.textGuideLineConfig = { anchor: A6 ? new Bi(A6[0][0], A6[0][1]) : null }, fs(d6, { style: { x: x6.x, y: x6.y } }, v6, s), d6.attr({ rotation: x6.rotation, originX: x6.x, originY: x6.y, z2: 10 }), HZ(u, $Z(m6), { stroke: M });
      }, r6;
    }(ud), Gze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.ignoreLabelLineUpdate = true, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this._data, v6 = this.group;
        f6.diff(d6).add(function(m6) {
          var b6 = new jze(f6, m6);
          f6.setItemGraphicEl(m6, b6), v6.add(b6);
        }).update(function(m6, b6) {
          var x6 = d6.getItemGraphicEl(b6);
          x6.updateData(f6, m6), v6.add(x6), f6.setItemGraphicEl(m6, x6);
        }).remove(function(m6) {
          var b6 = d6.getItemGraphicEl(m6);
          iA(b6, t2, m6);
        }).execute(), this._data = f6;
      }, r6.prototype.remove = function() {
        this.group.removeAll(), this._data = null;
      }, r6.prototype.dispose = function() {
      }, r6.type = "funnel", r6;
    }(bu), Wze = Gze, Hze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2) {
        a.prototype.init.apply(this, arguments), this.legendVisualProvider = new QR(Ca(this.getData, this), Ca(this.getRawData, this)), this._defaultLabelLine(t2);
      }, r6.prototype.getInitialData = function(t2, s) {
        return g5(this, { coordDimensions: ["value"], encodeDefaulter: Oi(VY, this) });
      }, r6.prototype._defaultLabelLine = function(t2) {
        ug(t2, "labelLine", ["show"]);
        var s = t2.labelLine, u = t2.emphasis.labelLine;
        s.show = s.show && t2.label.show, u.show = u.show && t2.emphasis.label.show;
      }, r6.prototype.getDataParams = function(t2) {
        var s = this.getData(), u = a.prototype.getDataParams.call(this, t2), f6 = s.mapDimension("value"), d6 = s.getSum(f6);
        return u.percent = d6 ? +(s.get(f6, t2) / d6 * 100).toFixed(2) : 0, u.$vars.push("percent"), u;
      }, r6.type = "series.funnel", r6.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, r6;
    }(sc), $ze = Hze;
    function Uze(a, r6) {
      return ah(a.getBoxLayoutParams(), { width: r6.getWidth(), height: r6.getHeight() });
    }
    function qze(a, r6) {
      for (var t2 = a.mapDimension("value"), s = a.mapArray(t2, function(m6) {
        return m6;
      }), u = [], f6 = r6 === "ascending", d6 = 0, v6 = a.count(); d6 < v6; d6++)
        u[d6] = d6;
      return ti(r6) ? u.sort(r6) : r6 !== "none" && u.sort(function(m6, b6) {
        return f6 ? s[m6] - s[b6] : s[b6] - s[m6];
      }), u;
    }
    function Yze(a) {
      var r6 = a.hostModel, t2 = r6.get("orient");
      a.each(function(s) {
        var u = a.getItemModel(s), f6 = u.getModel("label"), d6 = f6.get("position"), v6 = u.getModel("labelLine"), m6 = a.getItemLayout(s), b6 = m6.points, x6 = d6 === "inner" || d6 === "inside" || d6 === "center" || d6 === "insideLeft" || d6 === "insideRight", S, M, A6, I;
        if (x6)
          d6 === "insideLeft" ? (M = (b6[0][0] + b6[3][0]) / 2 + 5, A6 = (b6[0][1] + b6[3][1]) / 2, S = "left") : d6 === "insideRight" ? (M = (b6[1][0] + b6[2][0]) / 2 - 5, A6 = (b6[1][1] + b6[2][1]) / 2, S = "right") : (M = (b6[0][0] + b6[1][0] + b6[2][0] + b6[3][0]) / 4, A6 = (b6[0][1] + b6[1][1] + b6[2][1] + b6[3][1]) / 4, S = "center"), I = [[M, A6], [M, A6]];
        else {
          var R = void 0, F = void 0, j = void 0, $ = void 0, K = v6.get("length");
          d6 === "left" ? (R = (b6[3][0] + b6[0][0]) / 2, F = (b6[3][1] + b6[0][1]) / 2, j = R - K, M = j - 5, S = "right") : d6 === "right" ? (R = (b6[1][0] + b6[2][0]) / 2, F = (b6[1][1] + b6[2][1]) / 2, j = R + K, M = j + 5, S = "left") : d6 === "top" ? (R = (b6[3][0] + b6[0][0]) / 2, F = (b6[3][1] + b6[0][1]) / 2, $ = F - K, A6 = $ - 5, S = "center") : d6 === "bottom" ? (R = (b6[1][0] + b6[2][0]) / 2, F = (b6[1][1] + b6[2][1]) / 2, $ = F + K, A6 = $ + 5, S = "center") : d6 === "rightTop" ? (R = t2 === "horizontal" ? b6[3][0] : b6[1][0], F = t2 === "horizontal" ? b6[3][1] : b6[1][1], t2 === "horizontal" ? ($ = F - K, A6 = $ - 5, S = "center") : (j = R + K, M = j + 5, S = "top")) : d6 === "rightBottom" ? (R = b6[2][0], F = b6[2][1], t2 === "horizontal" ? ($ = F + K, A6 = $ + 5, S = "center") : (j = R + K, M = j + 5, S = "bottom")) : d6 === "leftTop" ? (R = b6[0][0], F = t2 === "horizontal" ? b6[0][1] : b6[1][1], t2 === "horizontal" ? ($ = F - K, A6 = $ - 5, S = "center") : (j = R - K, M = j - 5, S = "right")) : d6 === "leftBottom" ? (R = t2 === "horizontal" ? b6[1][0] : b6[3][0], F = t2 === "horizontal" ? b6[1][1] : b6[2][1], t2 === "horizontal" ? ($ = F + K, A6 = $ + 5, S = "center") : (j = R - K, M = j - 5, S = "right")) : (R = (b6[1][0] + b6[2][0]) / 2, F = (b6[1][1] + b6[2][1]) / 2, t2 === "horizontal" ? ($ = F + K, A6 = $ + 5, S = "center") : (j = R + K, M = j + 5, S = "left")), t2 === "horizontal" ? (j = R, M = j) : ($ = F, A6 = $), I = [[R, F], [j, $]];
        }
        m6.label = { linePoints: I, x: M, y: A6, verticalAlign: "middle", textAlign: S, inside: x6 };
      });
    }
    function Zze(a, r6) {
      a.eachSeriesByType("funnel", function(t2) {
        var s = t2.getData(), u = s.mapDimension("value"), f6 = t2.get("sort"), d6 = Uze(t2, r6), v6 = t2.get("orient"), m6 = d6.width, b6 = d6.height, x6 = qze(s, f6), S = d6.x, M = d6.y, A6 = v6 === "horizontal" ? [ua(t2.get("minSize"), b6), ua(t2.get("maxSize"), b6)] : [ua(t2.get("minSize"), m6), ua(t2.get("maxSize"), m6)], I = s.getDataExtent(u), R = t2.get("min"), F = t2.get("max");
        R == null && (R = Math.min(I[0], 0)), F == null && (F = I[1]);
        var j = t2.get("funnelAlign"), $ = t2.get("gap"), K = v6 === "horizontal" ? m6 : b6, U = (K - $ * (s.count() - 1)) / s.count(), he = function(at, ht) {
          if (v6 === "horizontal") {
            var Qe = s.get(u, at) || 0, en = gs(Qe, [R, F], A6, true), bt = void 0;
            switch (j) {
              case "top":
                bt = M;
                break;
              case "center":
                bt = M + (b6 - en) / 2;
                break;
              case "bottom":
                bt = M + (b6 - en);
                break;
            }
            return [[ht, bt], [ht, bt + en]];
          }
          var wt = s.get(u, at) || 0, Ft = gs(wt, [R, F], A6, true), fn;
          switch (j) {
            case "left":
              fn = S;
              break;
            case "center":
              fn = S + (m6 - Ft) / 2;
              break;
            case "right":
              fn = S + m6 - Ft;
              break;
          }
          return [[fn, ht], [fn + Ft, ht]];
        };
        f6 === "ascending" && (U = -U, $ = -$, v6 === "horizontal" ? S += m6 : M += b6, x6 = x6.reverse());
        for (var ue = 0; ue < x6.length; ue++) {
          var pe = x6[ue], _e = x6[ue + 1], xe = s.getItemModel(pe);
          if (v6 === "horizontal") {
            var Ae = xe.get(["itemStyle", "width"]);
            Ae == null ? Ae = U : (Ae = ua(Ae, m6), f6 === "ascending" && (Ae = -Ae));
            var ke = he(pe, S), je = he(_e, S + Ae);
            S += Ae + $, s.setItemLayout(pe, { points: ke.concat(je.slice().reverse()) });
          } else {
            var Fe = xe.get(["itemStyle", "height"]);
            Fe == null ? Fe = U : (Fe = ua(Fe, b6), f6 === "ascending" && (Fe = -Fe));
            var ke = he(pe, M), je = he(_e, M + Fe);
            M += Fe + $, s.setItemLayout(pe, { points: ke.concat(je.slice().reverse()) });
          }
        }
        Yze(s);
      });
    }
    function Xze(a) {
      a.registerChartView(Wze), a.registerSeriesModel($ze), a.registerLayout(Zze), a.registerProcessor(JR("funnel"));
    }
    var Kze = 0.3, Jze = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._dataGroup = new bi(), t2._initialized = false, t2;
      }
      return r6.prototype.init = function() {
        this.group.add(this._dataGroup);
      }, r6.prototype.render = function(t2, s, u, f6) {
        this._progressiveEls = null;
        var d6 = this._dataGroup, v6 = t2.getData(), m6 = this._data, b6 = t2.coordinateSystem, x6 = b6.dimensions, S = Gge(t2);
        v6.diff(m6).add(M).update(A6).remove(I).execute();
        function M(F) {
          var j = jge(v6, d6, F, x6, b6);
          lK(j, v6, F, S);
        }
        function A6(F, j) {
          var $ = m6.getItemGraphicEl(j), K = Bge(v6, F, x6, b6);
          v6.setItemGraphicEl(F, $), fs($, { shape: { points: K } }, t2, F), f0($), lK($, v6, F, S);
        }
        function I(F) {
          var j = m6.getItemGraphicEl(F);
          d6.remove(j);
        }
        if (!this._initialized) {
          this._initialized = true;
          var R = Qze(b6, t2, function() {
            setTimeout(function() {
              d6.removeClipPath();
            });
          });
          d6.setClipPath(R);
        }
        this._data = v6;
      }, r6.prototype.incrementalPrepareRender = function(t2, s, u) {
        this._initialized = true, this._data = null, this._dataGroup.removeAll();
      }, r6.prototype.incrementalRender = function(t2, s, u) {
        for (var f6 = s.getData(), d6 = s.coordinateSystem, v6 = d6.dimensions, m6 = Gge(s), b6 = this._progressiveEls = [], x6 = t2.start; x6 < t2.end; x6++) {
          var S = jge(f6, this._dataGroup, x6, v6, d6);
          S.incremental = true, lK(S, f6, x6, m6), b6.push(S);
        }
      }, r6.prototype.remove = function() {
        this._dataGroup && this._dataGroup.removeAll(), this._data = null;
      }, r6.type = "parallel", r6;
    }(bu);
    function Qze(a, r6, t2) {
      var s = a.model, u = a.getRect(), f6 = new rs({ shape: { x: u.x, y: u.y, width: u.width, height: u.height } }), d6 = s.get("layout") === "horizontal" ? "width" : "height";
      return f6.setShape(d6, 0), zu(f6, { shape: { width: u.width, height: u.height } }, r6, t2), f6;
    }
    function Bge(a, r6, t2, s) {
      for (var u = [], f6 = 0; f6 < t2.length; f6++) {
        var d6 = t2[f6], v6 = a.get(a.mapDimension(d6), r6);
        eBe(v6, s.getAxis(d6).type) || u.push(s.dataToPoint(v6, d6));
      }
      return u;
    }
    function jge(a, r6, t2, s, u) {
      var f6 = Bge(a, t2, s, u), d6 = new Vp({ shape: { points: f6 }, z2: 10 });
      return r6.add(d6), a.setItemGraphicEl(t2, d6), d6;
    }
    function Gge(a) {
      var r6 = a.get("smooth", true);
      return r6 === true && (r6 = Kze), r6 = mm(r6), dM(r6) && (r6 = 0), { smooth: r6 };
    }
    function lK(a, r6, t2, s) {
      a.useStyle(r6.getItemVisual(t2, "style")), a.style.fill = null, a.setShape("smooth", s.smooth);
      var u = r6.getItemModel(t2), f6 = u.getModel("emphasis");
      Ah(a, u, "lineStyle"), Cc(a, f6.get("focus"), f6.get("blurScope"), f6.get("disabled"));
    }
    function eBe(a, r6) {
      return r6 === "category" ? a == null : a == null || isNaN(a);
    }
    var tBe = Jze, nBe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.visualStyleAccessPath = "lineStyle", t2.visualDrawType = "stroke", t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        return Wx(null, this, { useEncodeDefaulter: Ca(rBe, null, this) });
      }, r6.prototype.getRawIndicesByActiveState = function(t2) {
        var s = this.coordinateSystem, u = this.getData(), f6 = [];
        return s.eachActiveState(u, function(d6, v6) {
          t2 === d6 && f6.push(u.getRawIndex(v6));
        }), f6;
      }, r6.type = "series.parallel", r6.dependencies = ["parallel"], r6.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, r6;
    }(sc);
    function rBe(a) {
      var r6 = a.ecModel.getComponent("parallel", a.get("parallelIndex"));
      if (r6) {
        var t2 = {};
        return Ne(r6.dimensions, function(s) {
          var u = aBe(s);
          t2[s] = u;
        }), t2;
      }
    }
    function aBe(a) {
      return +a.replace("dim", "");
    }
    var iBe = nBe, oBe = ["lineStyle", "opacity"], sBe = { seriesType: "parallel", reset: function(a, r6) {
      var t2 = a.coordinateSystem, s = { normal: a.get(["lineStyle", "opacity"]), active: a.get("activeOpacity"), inactive: a.get("inactiveOpacity") };
      return { progress: function(u, f6) {
        t2.eachActiveState(f6, function(d6, v6) {
          var m6 = s[d6];
          if (d6 === "normal" && f6.hasItemOption) {
            var b6 = f6.getItemModel(v6).get(oBe, true);
            b6 != null && (m6 = b6);
          }
          var x6 = f6.ensureUniqueItemVisual(v6, "style");
          x6.opacity = m6;
        }, u.start, u.end);
      } };
    } }, lBe = sBe;
    function uBe(a) {
      cBe(a), fBe(a);
    }
    function cBe(a) {
      if (!a.parallel) {
        var r6 = false;
        Ne(a.series, function(t2) {
          t2 && t2.type === "parallel" && (r6 = true);
        }), r6 && (a.parallel = [{}]);
      }
    }
    function fBe(a) {
      var r6 = ll(a.parallelAxis);
      Ne(r6, function(t2) {
        if (ui(t2)) {
          var s = t2.parallelIndex || 0, u = ll(a.parallel)[s];
          u && u.parallelAxisDefault && Di(t2, u.parallelAxisDefault, false);
        }
      });
    }
    var hBe = 5, dBe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        this._model = t2, this._api = u, this._handlers || (this._handlers = {}, Ne(pBe, function(f6, d6) {
          u.getZr().on(d6, this._handlers[d6] = Ca(f6, this));
        }, this)), i5(this, "_throttledDispatchExpand", t2.get("axisExpandRate"), "fixRate");
      }, r6.prototype.dispose = function(t2, s) {
        CR(this, "_throttledDispatchExpand"), Ne(this._handlers, function(u, f6) {
          s.getZr().off(f6, u);
        }), this._handlers = null;
      }, r6.prototype._throttledDispatchExpand = function(t2) {
        this._dispatchExpand(t2);
      }, r6.prototype._dispatchExpand = function(t2) {
        t2 && this._api.dispatchAction(qn({ type: "parallelAxisExpand" }, t2));
      }, r6.type = "parallel", r6;
    }(Rc), pBe = { mousedown: function(a) {
      uK(this, "click") && (this._mouseDownPoint = [a.offsetX, a.offsetY]);
    }, mouseup: function(a) {
      var r6 = this._mouseDownPoint;
      if (uK(this, "click") && r6) {
        var t2 = [a.offsetX, a.offsetY], s = Math.pow(r6[0] - t2[0], 2) + Math.pow(r6[1] - t2[1], 2);
        if (s > hBe)
          return;
        var u = this._model.coordinateSystem.getSlidedAxisExpandWindow([a.offsetX, a.offsetY]);
        u.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: u.axisExpandWindow });
      }
      this._mouseDownPoint = null;
    }, mousemove: function(a) {
      if (!(this._mouseDownPoint || !uK(this, "mousemove"))) {
        var r6 = this._model, t2 = r6.coordinateSystem.getSlidedAxisExpandWindow([a.offsetX, a.offsetY]), s = t2.behavior;
        s === "jump" && this._throttledDispatchExpand.debounceNextCall(r6.get("axisExpandDebounce")), this._throttledDispatchExpand(s === "none" ? null : { axisExpandWindow: t2.axisExpandWindow, animation: s === "jump" ? null : { duration: 0 } });
      }
    } };
    function uK(a, r6) {
      var t2 = a._model;
      return t2.get("axisExpandable") && t2.get("axisExpandTriggerOn") === r6;
    }
    var vBe = dBe, gBe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function() {
        a.prototype.init.apply(this, arguments), this.mergeOption({});
      }, r6.prototype.mergeOption = function(t2) {
        var s = this.option;
        t2 && Di(s, t2, true), this._initDimensions();
      }, r6.prototype.contains = function(t2, s) {
        var u = t2.get("parallelIndex");
        return u != null && s.getComponent("parallel", u) === this;
      }, r6.prototype.setAxisExpand = function(t2) {
        Ne(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(s) {
          t2.hasOwnProperty(s) && (this.option[s] = t2[s]);
        }, this);
      }, r6.prototype._initDimensions = function() {
        var t2 = this.dimensions = [], s = this.parallelAxisIndex = [], u = gl(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(f6) {
          return (f6.get("parallelIndex") || 0) === this.componentIndex;
        }, this);
        Ne(u, function(f6) {
          t2.push("dim" + f6.get("dim")), s.push(f6.componentIndex);
        });
      }, r6.type = "parallel", r6.dependencies = ["parallelAxis"], r6.layoutMode = "box", r6.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, r6;
    }(Ps), mBe = gBe, yBe = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6, d6) {
        var v6 = a.call(this, t2, s, u) || this;
        return v6.type = f6 || "value", v6.axisIndex = d6, v6;
      }
      return r6.prototype.isHorizontal = function() {
        return this.coordinateSystem.getModel().get("layout") !== "horizontal";
      }, r6;
    }(c1), bBe = yBe;
    function kA(a, r6, t2, s, u, f6) {
      a = a || 0;
      var d6 = t2[1] - t2[0];
      if (u != null && (u = w5(u, [0, d6])), f6 != null && (f6 = Math.max(f6, u != null ? u : 0)), s === "all") {
        var v6 = Math.abs(r6[1] - r6[0]);
        v6 = w5(v6, [0, d6]), u = f6 = w5(v6, [u, f6]), s = 0;
      }
      r6[0] = w5(r6[0], t2), r6[1] = w5(r6[1], t2);
      var m6 = cK(r6, s);
      r6[s] += a;
      var b6 = u || 0, x6 = t2.slice();
      m6.sign < 0 ? x6[0] += b6 : x6[1] -= b6, r6[s] = w5(r6[s], x6);
      var S;
      return S = cK(r6, s), u != null && (S.sign !== m6.sign || S.span < u) && (r6[1 - s] = r6[s] + m6.sign * u), S = cK(r6, s), f6 != null && S.span > f6 && (r6[1 - s] = r6[s] + S.sign * f6), r6;
    }
    function cK(a, r6) {
      var t2 = a[r6] - a[1 - r6];
      return { span: Math.abs(t2), sign: t2 > 0 ? -1 : t2 < 0 ? 1 : r6 ? -1 : 1 };
    }
    function w5(a, r6) {
      return Math.min(r6[1] != null ? r6[1] : 1 / 0, Math.max(r6[0] != null ? r6[0] : -1 / 0, a));
    }
    var fK = Ne, Wge = Math.min, Hge = Math.max, $ge = Math.floor, _Be = Math.ceil, Uge = Sc, xBe = Math.PI, wBe = function() {
      function a(r6, t2, s) {
        this.type = "parallel", this._axesMap = Ta(), this._axesLayout = {}, this.dimensions = r6.dimensions, this._model = r6, this._init(r6, t2, s);
      }
      return a.prototype._init = function(r6, t2, s) {
        var u = r6.dimensions, f6 = r6.parallelAxisIndex;
        fK(u, function(d6, v6) {
          var m6 = f6[v6], b6 = t2.getComponent("parallelAxis", m6), x6 = this._axesMap.set(d6, new bBe(d6, WV(b6), [0, 0], b6.get("type"), m6)), S = x6.type === "category";
          x6.onBand = S && b6.get("boundaryGap"), x6.inverse = b6.get("inverse"), b6.axis = x6, x6.model = b6, x6.coordinateSystem = b6.coordinateSystem = this;
        }, this);
      }, a.prototype.update = function(r6, t2) {
        this._updateAxesFromSeries(this._model, r6);
      }, a.prototype.containPoint = function(r6) {
        var t2 = this._makeLayoutInfo(), s = t2.axisBase, u = t2.layoutBase, f6 = t2.pixelDimIndex, d6 = r6[1 - f6], v6 = r6[f6];
        return d6 >= s && d6 <= s + t2.axisLength && v6 >= u && v6 <= u + t2.layoutLength;
      }, a.prototype.getModel = function() {
        return this._model;
      }, a.prototype._updateAxesFromSeries = function(r6, t2) {
        t2.eachSeries(function(s) {
          if (r6.contains(s, t2)) {
            var u = s.getData();
            fK(this.dimensions, function(f6) {
              var d6 = this._axesMap.get(f6);
              d6.scale.unionExtentFromData(u, u.mapDimension(f6)), h5(d6.scale, d6.model);
            }, this);
          }
        }, this);
      }, a.prototype.resize = function(r6, t2) {
        this._rect = ah(r6.getBoxLayoutParams(), { width: t2.getWidth(), height: t2.getHeight() }), this._layoutAxes();
      }, a.prototype.getRect = function() {
        return this._rect;
      }, a.prototype._makeLayoutInfo = function() {
        var r6 = this._model, t2 = this._rect, s = ["x", "y"], u = ["width", "height"], f6 = r6.get("layout"), d6 = f6 === "horizontal" ? 0 : 1, v6 = t2[u[d6]], m6 = [0, v6], b6 = this.dimensions.length, x6 = xz(r6.get("axisExpandWidth"), m6), S = xz(r6.get("axisExpandCount") || 0, [0, b6]), M = r6.get("axisExpandable") && b6 > 3 && b6 > S && S > 1 && x6 > 0 && v6 > 0, A6 = r6.get("axisExpandWindow"), I;
        if (A6)
          I = xz(A6[1] - A6[0], m6), A6[1] = A6[0] + I;
        else {
          I = xz(x6 * (S - 1), m6);
          var R = r6.get("axisExpandCenter") || $ge(b6 / 2);
          A6 = [x6 * R - I / 2], A6[1] = A6[0] + I;
        }
        var F = (v6 - I) / (b6 - S);
        F < 3 && (F = 0);
        var j = [$ge(Uge(A6[0] / x6, 1)) + 1, _Be(Uge(A6[1] / x6, 1)) - 1], $ = F / x6 * A6[0];
        return { layout: f6, pixelDimIndex: d6, layoutBase: t2[s[d6]], layoutLength: v6, axisBase: t2[s[1 - d6]], axisLength: t2[u[1 - d6]], axisExpandable: M, axisExpandWidth: x6, axisCollapseWidth: F, axisExpandWindow: A6, axisCount: b6, winInnerIndices: j, axisExpandWindow0Pos: $ };
      }, a.prototype._layoutAxes = function() {
        var r6 = this._rect, t2 = this._axesMap, s = this.dimensions, u = this._makeLayoutInfo(), f6 = u.layout;
        t2.each(function(d6) {
          var v6 = [0, u.axisLength], m6 = d6.inverse ? 1 : 0;
          d6.setExtent(v6[m6], v6[1 - m6]);
        }), fK(s, function(d6, v6) {
          var m6 = (u.axisExpandable ? CBe : SBe)(v6, u), b6 = { horizontal: { x: m6.position, y: u.axisLength }, vertical: { x: 0, y: m6.position } }, x6 = { horizontal: xBe / 2, vertical: 0 }, S = [b6[f6].x + r6.x, b6[f6].y + r6.y], M = x6[f6], A6 = og();
          yb(A6, A6, M), sg(A6, A6, S), this._axesLayout[d6] = { position: S, rotation: M, transform: A6, axisNameAvailableWidth: m6.axisNameAvailableWidth, axisLabelShow: m6.axisLabelShow, nameTruncateMaxWidth: m6.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
        }, this);
      }, a.prototype.getAxis = function(r6) {
        return this._axesMap.get(r6);
      }, a.prototype.dataToPoint = function(r6, t2) {
        return this.axisCoordToPoint(this._axesMap.get(t2).dataToCoord(r6), t2);
      }, a.prototype.eachActiveState = function(r6, t2, s, u) {
        s == null && (s = 0), u == null && (u = r6.count());
        var f6 = this._axesMap, d6 = this.dimensions, v6 = [], m6 = [];
        Ne(d6, function(F) {
          v6.push(r6.mapDimension(F)), m6.push(f6.get(F).model);
        });
        for (var b6 = this.hasAxisBrushed(), x6 = s; x6 < u; x6++) {
          var S = void 0;
          if (!b6)
            S = "normal";
          else {
            S = "active";
            for (var M = r6.getValues(v6, x6), A6 = 0, I = d6.length; A6 < I; A6++) {
              var R = m6[A6].getActiveState(M[A6]);
              if (R === "inactive") {
                S = "inactive";
                break;
              }
            }
          }
          t2(S, x6);
        }
      }, a.prototype.hasAxisBrushed = function() {
        for (var r6 = this.dimensions, t2 = this._axesMap, s = false, u = 0, f6 = r6.length; u < f6; u++)
          t2.get(r6[u]).model.getActiveState() !== "normal" && (s = true);
        return s;
      }, a.prototype.axisCoordToPoint = function(r6, t2) {
        var s = this._axesLayout[t2];
        return Yr([r6, 0], s.transform);
      }, a.prototype.getAxisLayout = function(r6) {
        return Qa(this._axesLayout[r6]);
      }, a.prototype.getSlidedAxisExpandWindow = function(r6) {
        var t2 = this._makeLayoutInfo(), s = t2.pixelDimIndex, u = t2.axisExpandWindow.slice(), f6 = u[1] - u[0], d6 = [0, t2.axisExpandWidth * (t2.axisCount - 1)];
        if (!this.containPoint(r6))
          return { behavior: "none", axisExpandWindow: u };
        var v6 = r6[s] - t2.layoutBase - t2.axisExpandWindow0Pos, m6, b6 = "slide", x6 = t2.axisCollapseWidth, S = this._model.get("axisExpandSlideTriggerArea"), M = S[0] != null;
        if (x6)
          M && x6 && v6 < f6 * S[0] ? (b6 = "jump", m6 = v6 - f6 * S[2]) : M && x6 && v6 > f6 * (1 - S[0]) ? (b6 = "jump", m6 = v6 - f6 * (1 - S[2])) : (m6 = v6 - f6 * S[1]) >= 0 && (m6 = v6 - f6 * (1 - S[1])) <= 0 && (m6 = 0), m6 *= t2.axisExpandWidth / x6, m6 ? kA(m6, u, d6, "all") : b6 = "none";
        else {
          var A6 = u[1] - u[0], I = d6[1] * v6 / A6;
          u = [Hge(0, I - A6 / 2)], u[1] = Wge(d6[1], u[0] + A6), u[0] = u[1] - A6;
        }
        return { axisExpandWindow: u, behavior: b6 };
      }, a;
    }();
    function xz(a, r6) {
      return Wge(Hge(a, r6[0]), r6[1]);
    }
    function SBe(a, r6) {
      var t2 = r6.layoutLength / (r6.axisCount - 1);
      return { position: t2 * a, axisNameAvailableWidth: t2, axisLabelShow: true };
    }
    function CBe(a, r6) {
      var t2 = r6.layoutLength, s = r6.axisExpandWidth, u = r6.axisCount, f6 = r6.axisCollapseWidth, d6 = r6.winInnerIndices, v6, m6 = f6, b6 = false, x6;
      return a < d6[0] ? (v6 = a * f6, x6 = f6) : a <= d6[1] ? (v6 = r6.axisExpandWindow0Pos + a * s - r6.axisExpandWindow[0], m6 = s, b6 = true) : (v6 = t2 - (u - 1 - a) * f6, x6 = f6), { position: v6, axisNameAvailableWidth: m6, axisLabelShow: b6, nameTruncateMaxWidth: x6 };
    }
    var MBe = wBe;
    function ABe(a, r6) {
      var t2 = [];
      return a.eachComponent("parallel", function(s, u) {
        var f6 = new MBe(s, a, r6);
        f6.name = "parallel_" + u, f6.resize(s, r6), s.coordinateSystem = f6, f6.model = s, t2.push(f6);
      }), a.eachSeries(function(s) {
        if (s.get("coordinateSystem") === "parallel") {
          var u = s.getReferringComponents("parallel", Lc).models[0];
          s.coordinateSystem = u.coordinateSystem;
        }
      }), t2;
    }
    var EBe = { create: ABe }, IBe = EBe, qge = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.activeIntervals = [], t2;
      }
      return r6.prototype.getAreaSelectStyle = function() {
        return Mx([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
      }, r6.prototype.setActiveIntervals = function(t2) {
        var s = this.activeIntervals = Qa(t2);
        if (s)
          for (var u = s.length - 1; u >= 0; u--)
            Sv(s[u]);
      }, r6.prototype.getActiveState = function(t2) {
        var s = this.activeIntervals;
        if (!s.length)
          return "normal";
        if (t2 == null || isNaN(+t2))
          return "inactive";
        if (s.length === 1) {
          var u = s[0];
          if (u[0] <= t2 && t2 <= u[1])
            return "active";
        } else
          for (var f6 = 0, d6 = s.length; f6 < d6; f6++)
            if (s[f6][0] <= t2 && t2 <= s[f6][1])
              return "active";
        return "inactive";
      }, r6;
    }(Ps);
    Dc(qge, GR);
    var Yge = qge, PA = true, g42 = Math.min, S5 = Math.max, TBe = Math.pow, DBe = 1e4, kBe = 6, PBe = 6, Zge = "globalPan", LBe = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, OBe = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, Xge = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, RBe = 0, FBe = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this) || this;
        return s._track = [], s._covers = [], s._handlers = {}, s._zr = t2, s.group = new bi(), s._uid = "brushController_" + RBe++, Ne(WBe, function(u, f6) {
          this._handlers[f6] = Ca(u, this);
        }, s), s;
      }
      return r6.prototype.enableBrush = function(t2) {
        return this._brushType && this._doDisableBrush(), t2.brushType && this._doEnableBrush(t2), this;
      }, r6.prototype._doEnableBrush = function(t2) {
        var s = this._zr;
        this._enableGlobalPan || U9e(s, Zge, this._uid), Ne(this._handlers, function(u, f6) {
          s.on(f6, u);
        }), this._brushType = t2.brushType, this._brushOption = Di(Qa(Xge), t2, true);
      }, r6.prototype._doDisableBrush = function() {
        var t2 = this._zr;
        q9e(t2, Zge, this._uid), Ne(this._handlers, function(s, u) {
          t2.off(u, s);
        }), this._brushType = this._brushOption = null;
      }, r6.prototype.setPanels = function(t2) {
        if (t2 && t2.length) {
          var s = this._panels = {};
          Ne(t2, function(u) {
            s[u.panelId] = Qa(u);
          });
        } else
          this._panels = null;
        return this;
      }, r6.prototype.mount = function(t2) {
        t2 = t2 || {}, this._enableGlobalPan = t2.enableGlobalPan;
        var s = this.group;
        return this._zr.add(s), s.attr({ x: t2.x || 0, y: t2.y || 0, rotation: t2.rotation || 0, scaleX: t2.scaleX || 1, scaleY: t2.scaleY || 1 }), this._transform = s.getLocalTransform(), this;
      }, r6.prototype.updateCovers = function(t2) {
        t2 = wr(t2, function(M) {
          return Di(Qa(Xge), M, true);
        });
        var s = "\0-brush-index-", u = this._covers, f6 = this._covers = [], d6 = this, v6 = this._creatingCover;
        return new Gx(u, t2, b6, m6).add(x6).update(x6).remove(S).execute(), this;
        function m6(M, A6) {
          return (M.id != null ? M.id : s + A6) + "-" + M.brushType;
        }
        function b6(M, A6) {
          return m6(M.__brushOption, A6);
        }
        function x6(M, A6) {
          var I = t2[M];
          if (A6 != null && u[A6] === v6)
            f6[M] = u[A6];
          else {
            var R = f6[M] = A6 != null ? (u[A6].__brushOption = I, u[A6]) : Jge(d6, Kge(d6, I));
            hK(d6, R);
          }
        }
        function S(M) {
          u[M] !== v6 && d6.group.remove(u[M]);
        }
      }, r6.prototype.unmount = function() {
        return this.enableBrush(false), vK(this), this._zr.remove(this.group), this;
      }, r6.prototype.dispose = function() {
        this.unmount(), this.off();
      }, r6;
    }(Ip);
    function Kge(a, r6) {
      var t2 = wz[r6.brushType].createCover(a, r6);
      return t2.__brushOption = r6, e0e(t2, r6), a.group.add(t2), t2;
    }
    function Jge(a, r6) {
      var t2 = dK(r6);
      return t2.endCreating && (t2.endCreating(a, r6), e0e(r6, r6.__brushOption)), r6;
    }
    function Qge(a, r6) {
      var t2 = r6.__brushOption;
      dK(r6).updateCoverShape(a, r6, t2.range, t2);
    }
    function e0e(a, r6) {
      var t2 = r6.z;
      t2 == null && (t2 = DBe), a.traverse(function(s) {
        s.z = t2, s.z2 = t2;
      });
    }
    function hK(a, r6) {
      dK(r6).updateCommon(a, r6), Qge(a, r6);
    }
    function dK(a) {
      return wz[a.__brushOption.brushType];
    }
    function pK(a, r6, t2) {
      var s = a._panels;
      if (!s)
        return PA;
      var u, f6 = a._transform;
      return Ne(s, function(d6) {
        d6.isTargetByCursor(r6, t2, f6) && (u = d6);
      }), u;
    }
    function t0e(a, r6) {
      var t2 = a._panels;
      if (!t2)
        return PA;
      var s = r6.__brushOption.panelId;
      return s != null ? t2[s] : PA;
    }
    function vK(a) {
      var r6 = a._covers, t2 = r6.length;
      return Ne(r6, function(s) {
        a.group.remove(s);
      }, a), r6.length = 0, !!t2;
    }
    function LA(a, r6) {
      var t2 = wr(a._covers, function(s) {
        var u = s.__brushOption, f6 = Qa(u.range);
        return { brushType: u.brushType, panelId: u.panelId, range: f6 };
      });
      a.trigger("brush", { areas: t2, isEnd: !!r6.isEnd, removeOnClick: !!r6.removeOnClick });
    }
    function NBe(a) {
      var r6 = a._track;
      if (!r6.length)
        return false;
      var t2 = r6[r6.length - 1], s = r6[0], u = t2[0] - s[0], f6 = t2[1] - s[1], d6 = TBe(u * u + f6 * f6, 0.5);
      return d6 > kBe;
    }
    function n0e(a) {
      var r6 = a.length - 1;
      return r6 < 0 && (r6 = 0), [a[0], a[r6]];
    }
    function r0e(a, r6, t2, s) {
      var u = new bi();
      return u.add(new rs({ name: "main", style: mK(t2), silent: true, draggable: true, cursor: "move", drift: Oi(o0e, a, r6, u, ["n", "s", "w", "e"]), ondragend: Oi(LA, r6, { isEnd: true }) })), Ne(s, function(f6) {
        u.add(new rs({ name: f6.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: Oi(o0e, a, r6, u, f6), ondragend: Oi(LA, r6, { isEnd: true }) }));
      }), u;
    }
    function a0e(a, r6, t2, s) {
      var u = s.brushStyle.lineWidth || 0, f6 = S5(u, PBe), d6 = t2[0][0], v6 = t2[1][0], m6 = d6 - u / 2, b6 = v6 - u / 2, x6 = t2[0][1], S = t2[1][1], M = x6 - f6 + u / 2, A6 = S - f6 + u / 2, I = x6 - d6, R = S - v6, F = I + u, j = R + u;
      Yx(a, r6, "main", d6, v6, I, R), s.transformable && (Yx(a, r6, "w", m6, b6, f6, j), Yx(a, r6, "e", M, b6, f6, j), Yx(a, r6, "n", m6, b6, F, f6), Yx(a, r6, "s", m6, A6, F, f6), Yx(a, r6, "nw", m6, b6, f6, f6), Yx(a, r6, "ne", M, b6, f6, f6), Yx(a, r6, "sw", m6, A6, f6, f6), Yx(a, r6, "se", M, A6, f6, f6));
    }
    function gK(a, r6) {
      var t2 = r6.__brushOption, s = t2.transformable, u = r6.childAt(0);
      u.useStyle(mK(t2)), u.attr({ silent: !s, cursor: s ? "move" : "default" }), Ne([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(f6) {
        var d6 = r6.childOfName(f6.join("")), v6 = f6.length === 1 ? yK(a, f6[0]) : zBe(a, f6);
        d6 && d6.attr({ silent: !s, invisible: !s, cursor: s ? OBe[v6] + "-resize" : null });
      });
    }
    function Yx(a, r6, t2, s, u, f6, d6) {
      var v6 = r6.childOfName(t2);
      v6 && v6.setShape(jBe(bK(a, r6, [[s, u], [s + f6, u + d6]])));
    }
    function mK(a) {
      return ei({ strokeNoScale: true }, a.brushStyle);
    }
    function i0e(a, r6, t2, s) {
      var u = [g42(a, t2), g42(r6, s)], f6 = [S5(a, t2), S5(r6, s)];
      return [[u[0], f6[0]], [u[1], f6[1]]];
    }
    function VBe(a) {
      return Nr(a.group);
    }
    function yK(a, r6) {
      var t2 = { w: "left", e: "right", n: "top", s: "bottom" }, s = { left: "w", right: "e", top: "n", bottom: "s" }, u = za(t2[r6], VBe(a));
      return s[u];
    }
    function zBe(a, r6) {
      var t2 = [yK(a, r6[0]), yK(a, r6[1])];
      return (t2[0] === "e" || t2[0] === "w") && t2.reverse(), t2.join("");
    }
    function o0e(a, r6, t2, s, u, f6) {
      var d6 = t2.__brushOption, v6 = a.toRectRange(d6.range), m6 = s0e(r6, u, f6);
      Ne(s, function(b6) {
        var x6 = LBe[b6];
        v6[x6[0]][x6[1]] += m6[x6[0]];
      }), d6.range = a.fromRectRange(i0e(v6[0][0], v6[1][0], v6[0][1], v6[1][1])), hK(r6, t2), LA(r6, { isEnd: false });
    }
    function BBe(a, r6, t2, s) {
      var u = r6.__brushOption.range, f6 = s0e(a, t2, s);
      Ne(u, function(d6) {
        d6[0] += f6[0], d6[1] += f6[1];
      }), hK(a, r6), LA(a, { isEnd: false });
    }
    function s0e(a, r6, t2) {
      var s = a.group, u = s.transformCoordToLocal(r6, t2), f6 = s.transformCoordToLocal(0, 0);
      return [u[0] - f6[0], u[1] - f6[1]];
    }
    function bK(a, r6, t2) {
      var s = t0e(a, r6);
      return s && s !== PA ? s.clipPath(t2, a._transform) : Qa(t2);
    }
    function jBe(a) {
      var r6 = g42(a[0][0], a[1][0]), t2 = g42(a[0][1], a[1][1]), s = S5(a[0][0], a[1][0]), u = S5(a[0][1], a[1][1]);
      return { x: r6, y: t2, width: s - r6, height: u - t2 };
    }
    function GBe(a, r6, t2) {
      if (!(!a._brushType || HBe(a, r6.offsetX, r6.offsetY))) {
        var s = a._zr, u = a._covers, f6 = pK(a, r6, t2);
        if (!a._dragging)
          for (var d6 = 0; d6 < u.length; d6++) {
            var v6 = u[d6].__brushOption;
            if (f6 && (f6 === PA || v6.panelId === f6.panelId) && wz[v6.brushType].contain(u[d6], t2[0], t2[1]))
              return;
          }
        f6 && s.setCursorStyle("crosshair");
      }
    }
    function _K(a) {
      var r6 = a.event;
      r6.preventDefault && r6.preventDefault();
    }
    function xK(a, r6, t2) {
      return a.childOfName("main").contain(r6, t2);
    }
    function l0e(a, r6, t2, s) {
      var u = a._creatingCover, f6 = a._creatingPanel, d6 = a._brushOption, v6;
      if (a._track.push(t2.slice()), NBe(a) || u) {
        if (f6 && !u) {
          d6.brushMode === "single" && vK(a);
          var m6 = Qa(d6);
          m6.brushType = u0e(m6.brushType, f6), m6.panelId = f6 === PA ? null : f6.panelId, u = a._creatingCover = Kge(a, m6), a._covers.push(u);
        }
        if (u) {
          var b6 = wz[u0e(a._brushType, f6)], x6 = u.__brushOption;
          x6.range = b6.getCreatingRange(bK(a, u, a._track)), s && (Jge(a, u), b6.updateCommon(a, u)), Qge(a, u), v6 = { isEnd: s };
        }
      } else
        s && d6.brushMode === "single" && d6.removeOnClick && pK(a, r6, t2) && vK(a) && (v6 = { isEnd: s, removeOnClick: true });
      return v6;
    }
    function u0e(a, r6) {
      return a === "auto" ? r6.defaultBrushType : a;
    }
    var WBe = { mousedown: function(a) {
      if (this._dragging)
        c0e(this, a);
      else if (!a.target || !a.target.draggable) {
        _K(a);
        var r6 = this.group.transformCoordToLocal(a.offsetX, a.offsetY);
        this._creatingCover = null;
        var t2 = this._creatingPanel = pK(this, a, r6);
        t2 && (this._dragging = true, this._track = [r6.slice()]);
      }
    }, mousemove: function(a) {
      var r6 = a.offsetX, t2 = a.offsetY, s = this.group.transformCoordToLocal(r6, t2);
      if (GBe(this, a, s), this._dragging) {
        _K(a);
        var u = l0e(this, a, s, false);
        u && LA(this, u);
      }
    }, mouseup: function(a) {
      c0e(this, a);
    } };
    function c0e(a, r6) {
      if (a._dragging) {
        _K(r6);
        var t2 = r6.offsetX, s = r6.offsetY, u = a.group.transformCoordToLocal(t2, s), f6 = l0e(a, r6, u, true);
        a._dragging = false, a._track = [], a._creatingCover = null, f6 && LA(a, f6);
      }
    }
    function HBe(a, r6, t2) {
      var s = a._zr;
      return r6 < 0 || r6 > s.getWidth() || t2 < 0 || t2 > s.getHeight();
    }
    var wz = { lineX: f0e(0), lineY: f0e(1), rect: { createCover: function(a, r6) {
      function t2(s) {
        return s;
      }
      return r0e({ toRectRange: t2, fromRectRange: t2 }, a, r6, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    }, getCreatingRange: function(a) {
      var r6 = n0e(a);
      return i0e(r6[1][0], r6[1][1], r6[0][0], r6[0][1]);
    }, updateCoverShape: function(a, r6, t2, s) {
      a0e(a, r6, t2, s);
    }, updateCommon: gK, contain: xK }, polygon: { createCover: function(a, r6) {
      var t2 = new bi();
      return t2.add(new Vp({ name: "main", style: mK(r6), silent: true })), t2;
    }, getCreatingRange: function(a) {
      return a;
    }, endCreating: function(a, r6) {
      r6.remove(r6.childAt(0)), r6.add(new ud({ name: "main", draggable: true, drift: Oi(BBe, a, r6), ondragend: Oi(LA, a, { isEnd: true }) }));
    }, updateCoverShape: function(a, r6, t2, s) {
      r6.childAt(0).setShape({ points: bK(a, r6, t2) });
    }, updateCommon: gK, contain: xK } };
    function f0e(a) {
      return { createCover: function(r6, t2) {
        return r0e({ toRectRange: function(s) {
          var u = [s, [0, 100]];
          return a && u.reverse(), u;
        }, fromRectRange: function(s) {
          return s[a];
        } }, r6, t2, [[["w"], ["e"]], [["n"], ["s"]]][a]);
      }, getCreatingRange: function(r6) {
        var t2 = n0e(r6), s = g42(t2[0][a], t2[1][a]), u = S5(t2[0][a], t2[1][a]);
        return [s, u];
      }, updateCoverShape: function(r6, t2, s, u) {
        var f6, d6 = t0e(r6, t2);
        if (d6 !== PA && d6.getLinearBrushOtherExtent)
          f6 = d6.getLinearBrushOtherExtent(a);
        else {
          var v6 = r6._zr;
          f6 = [0, [v6.getWidth(), v6.getHeight()][1 - a]];
        }
        var m6 = [s, f6];
        a && m6.reverse(), a0e(r6, t2, m6, u);
      }, updateCommon: gK, contain: xK };
    }
    var wK = FBe;
    function h0e(a) {
      return a = SK(a), function(r6) {
        return eo(r6, a);
      };
    }
    function d0e(a, r6) {
      return a = SK(a), function(t2) {
        var s = r6 != null ? r6 : t2, u = s ? a.width : a.height, f6 = s ? a.x : a.y;
        return [f6, f6 + (u || 0)];
      };
    }
    function p0e(a, r6, t2) {
      var s = SK(a);
      return function(u, f6) {
        return s.contain(f6[0], f6[1]) && !sz(u, r6, t2);
      };
    }
    function SK(a) {
      return Qi.create(a);
    }
    var $Be = ["axisLine", "axisTickLabel", "axisName"], UBe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s) {
        a.prototype.init.apply(this, arguments), (this._brushController = new wK(s.getZr())).on("brush", Ca(this._onBrush, this));
      }, r6.prototype.render = function(t2, s, u, f6) {
        if (!qBe(t2, s, f6)) {
          this.axisModel = t2, this.api = u, this.group.removeAll();
          var d6 = this._axisGroup;
          if (this._axisGroup = new bi(), this.group.add(this._axisGroup), !!t2.get("show")) {
            var v6 = ZBe(t2, s), m6 = v6.coordinateSystem, b6 = t2.getAreaSelectStyle(), x6 = b6.width, S = t2.axis.dim, M = m6.getAxisLayout(S), A6 = qn({ strokeContainThreshold: x6 }, M), I = new Ux(t2, A6);
            Ne($Be, I.add, I), this._axisGroup.add(I.getGroup()), this._refreshBrushController(A6, b6, t2, v6, x6, u), Ro(d6, this._axisGroup, t2);
          }
        }
      }, r6.prototype._refreshBrushController = function(t2, s, u, f6, d6, v6) {
        var m6 = u.axis.getExtent(), b6 = m6[1] - m6[0], x6 = Math.min(30, Math.abs(b6) * 0.1), S = Qi.create({ x: m6[0], y: -d6 / 2, width: b6, height: d6 });
        S.x -= x6, S.width += 2 * x6, this._brushController.mount({ enableGlobalPan: true, rotation: t2.rotation, x: t2.position[0], y: t2.position[1] }).setPanels([{ panelId: "pl", clipPath: h0e(S), isTargetByCursor: p0e(S, v6, f6), getLinearBrushOtherExtent: d0e(S, 0) }]).enableBrush({ brushType: "lineX", brushStyle: s, removeOnClick: true }).updateCovers(YBe(u));
      }, r6.prototype._onBrush = function(t2) {
        var s = t2.areas, u = this.axisModel, f6 = u.axis, d6 = wr(s, function(v6) {
          return [f6.coordToData(v6.range[0], true), f6.coordToData(v6.range[1], true)];
        });
        (!u.option.realtime === t2.isEnd || t2.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: u.id, intervals: d6 });
      }, r6.prototype.dispose = function() {
        this._brushController.dispose();
      }, r6.type = "parallelAxis", r6;
    }(Rc);
    function qBe(a, r6, t2) {
      return t2 && t2.type === "axisAreaSelect" && r6.findComponents({ mainType: "parallelAxis", query: t2 })[0] === a;
    }
    function YBe(a) {
      var r6 = a.axis;
      return wr(a.activeIntervals, function(t2) {
        return { brushType: "lineX", panelId: "pl", range: [r6.dataToCoord(t2[0], true), r6.dataToCoord(t2[1], true)] };
      });
    }
    function ZBe(a, r6) {
      return r6.getComponent("parallel", a.get("parallelIndex"));
    }
    var XBe = UBe, KBe = { type: "axisAreaSelect", event: "axisAreaSelected" };
    function JBe(a) {
      a.registerAction(KBe, function(r6, t2) {
        t2.eachComponent({ mainType: "parallelAxis", query: r6 }, function(s) {
          s.axis.model.setActiveIntervals(r6.intervals);
        });
      }), a.registerAction("parallelAxisExpand", function(r6, t2) {
        t2.eachComponent({ mainType: "parallel", query: r6 }, function(s) {
          s.setAxisExpand(r6);
        });
      });
    }
    var QBe = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
    function v0e(a) {
      a.registerComponentView(vBe), a.registerComponentModel(mBe), a.registerCoordinateSystem("parallel", IBe), a.registerPreprocessor(uBe), a.registerComponentModel(Yge), a.registerComponentView(XBe), m5(a, "parallel", Yge, QBe), JBe(a);
    }
    function eje(a) {
      bo(v0e), a.registerChartView(tBe), a.registerSeriesModel(iBe), a.registerVisual(a.PRIORITY.VISUAL.BRUSH, lBe);
    }
    var tje = function() {
      function a() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
      }
      return a;
    }(), nje = function(a) {
      tt(r6, a);
      function r6(t2) {
        return a.call(this, t2) || this;
      }
      return r6.prototype.getDefaultShape = function() {
        return new tje();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.extent;
        t2.moveTo(s.x1, s.y1), t2.bezierCurveTo(s.cpx1, s.cpy1, s.cpx2, s.cpy2, s.x2, s.y2), s.orient === "vertical" ? (t2.lineTo(s.x2 + u, s.y2), t2.bezierCurveTo(s.cpx2 + u, s.cpy2, s.cpx1 + u, s.cpy1, s.x1 + u, s.y1)) : (t2.lineTo(s.x2, s.y2 + u), t2.bezierCurveTo(s.cpx2, s.cpy2 + u, s.cpx1, s.cpy1 + u, s.x1, s.y1 + u)), t2.closePath();
      }, r6.prototype.highlight = function() {
        Cm(this);
      }, r6.prototype.downplay = function() {
        Mm(this);
      }, r6;
    }(uo), rje = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._focusAdjacencyDisabled = false, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = this, d6 = t2.getGraph(), v6 = this.group, m6 = t2.layoutInfo, b6 = m6.width, x6 = m6.height, S = t2.getData(), M = t2.getData("edge"), A6 = t2.get("orient");
        this._model = t2, v6.removeAll(), v6.x = m6.x, v6.y = m6.y, d6.eachEdge(function(I) {
          var R = new nje(), F = ii(R);
          F.dataIndex = I.dataIndex, F.seriesIndex = t2.seriesIndex, F.dataType = "edge";
          var j = I.getModel(), $ = j.getModel("lineStyle"), K = $.get("curveness"), U = I.node1.getLayout(), he = I.node1.getModel(), ue = he.get("localX"), pe = he.get("localY"), _e = I.node2.getLayout(), xe = I.node2.getModel(), Ae = xe.get("localX"), ke = xe.get("localY"), je = I.getLayout(), Fe, at, ht, Qe, en, bt, wt, Ft;
          switch (R.shape.extent = Math.max(1, je.dy), R.shape.orient = A6, A6 === "vertical" ? (Fe = (ue != null ? ue * b6 : U.x) + je.sy, at = (pe != null ? pe * x6 : U.y) + U.dy, ht = (Ae != null ? Ae * b6 : _e.x) + je.ty, Qe = ke != null ? ke * x6 : _e.y, en = Fe, bt = at * (1 - K) + Qe * K, wt = ht, Ft = at * K + Qe * (1 - K)) : (Fe = (ue != null ? ue * b6 : U.x) + U.dx, at = (pe != null ? pe * x6 : U.y) + je.sy, ht = Ae != null ? Ae * b6 : _e.x, Qe = (ke != null ? ke * x6 : _e.y) + je.ty, en = Fe * (1 - K) + ht * K, bt = at, wt = Fe * K + ht * (1 - K), Ft = Qe), R.setShape({ x1: Fe, y1: at, x2: ht, y2: Qe, cpx1: en, cpy1: bt, cpx2: wt, cpy2: Ft }), R.useStyle($.getItemStyle()), R.style.fill) {
            case "source":
              R.style.fill = I.node1.getVisual("color"), R.style.decal = I.node1.getVisual("style").decal;
              break;
            case "target":
              R.style.fill = I.node2.getVisual("color"), R.style.decal = I.node2.getVisual("style").decal;
              break;
            case "gradient":
              var fn = I.node1.getVisual("color"), gn = I.node2.getVisual("color");
              _a2(fn) && _a2(gn) && (R.style.fill = new aA(0, 0, +(A6 === "horizontal"), +(A6 === "vertical"), [{ color: fn, offset: 0 }, { color: gn, offset: 1 }]));
          }
          var Zr = j.getModel("emphasis");
          Ah(R, j, "lineStyle", function(Ua) {
            return Ua.getItemStyle();
          }), v6.add(R), M.setItemGraphicEl(I.dataIndex, R);
          var Ma = Zr.get("focus");
          Cc(R, Ma === "adjacency" ? I.getAdjacentDataIndices() : Ma, Zr.get("blurScope"), Zr.get("disabled")), ii(R).dataType = "edge";
        }), d6.eachNode(function(I) {
          var R = I.getLayout(), F = I.getModel(), j = F.get("localX"), $ = F.get("localY"), K = F.getModel("emphasis"), U = new rs({ shape: { x: j != null ? j * b6 : R.x, y: $ != null ? $ * x6 : R.y, width: R.dx, height: R.dy }, style: F.getModel("itemStyle").getItemStyle(), z2: 10 });
          Bp(U, hd(F), { labelFetcher: t2, labelDataIndex: I.dataIndex, defaultText: I.id }), U.disableLabelAnimation = true, U.setStyle("fill", I.getVisual("color")), U.setStyle("decal", I.getVisual("style").decal), Ah(U, F), v6.add(U), S.setItemGraphicEl(I.dataIndex, U), ii(U).dataType = "node";
          var he = K.get("focus");
          Cc(U, he === "adjacency" ? I.getAdjacentDataIndices() : he, K.get("blurScope"), K.get("disabled"));
        }), S.eachItemGraphicEl(function(I, R) {
          var F = S.getItemModel(R);
          F.get("draggable") && (I.drift = function(j, $) {
            f6._focusAdjacencyDisabled = true, this.shape.x += j, this.shape.y += $, this.dirty(), u.dispatchAction({ type: "dragNode", seriesId: t2.id, dataIndex: S.getRawIndex(R), localX: this.shape.x / b6, localY: this.shape.y / x6 });
          }, I.ondragend = function() {
            f6._focusAdjacencyDisabled = false;
          }, I.draggable = true, I.cursor = "move");
        }), !this._data && t2.isAnimationEnabled() && v6.setClipPath(aje(v6.getBoundingRect(), t2, function() {
          v6.removeClipPath();
        })), this._data = t2.getData();
      }, r6.prototype.dispose = function() {
      }, r6.type = "sankey", r6;
    }(bu);
    function aje(a, r6, t2) {
      var s = new rs({ shape: { x: a.x - 10, y: a.y - 10, width: 0, height: a.height + 20 } });
      return zu(s, { shape: { width: a.width + 20 } }, r6, t2), s;
    }
    var ije = rje, oje = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        var u = t2.edges || t2.links, f6 = t2.data || t2.nodes, d6 = t2.levels;
        this.levelModels = [];
        for (var v6 = this.levelModels, m6 = 0; m6 < d6.length; m6++)
          d6[m6].depth != null && d6[m6].depth >= 0 && (v6[d6[m6].depth] = new yu(d6[m6], this, s));
        if (f6 && u) {
          var b6 = zge(f6, u, this, true, x6);
          return b6.data;
        }
        function x6(S, M) {
          S.wrapMethod("getItemModel", function(A6, I) {
            var R = A6.parentModel, F = R.getData().getItemLayout(I);
            if (F) {
              var j = F.depth, $ = R.levelModels[j];
              $ && (A6.parentModel = $);
            }
            return A6;
          }), M.wrapMethod("getItemModel", function(A6, I) {
            var R = A6.parentModel, F = R.getGraph().getEdgeByIndex(I), j = F.node1.getLayout();
            if (j) {
              var $ = j.depth, K = R.levelModels[$];
              K && (A6.parentModel = K);
            }
            return A6;
          });
        }
      }, r6.prototype.setNodePosition = function(t2, s) {
        var u = this.option.data || this.option.nodes, f6 = u[t2];
        f6.localX = s[0], f6.localY = s[1];
      }, r6.prototype.getGraph = function() {
        return this.getData().graph;
      }, r6.prototype.getEdgeData = function() {
        return this.getGraph().edgeData;
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        function f6(A6) {
          return isNaN(A6) || A6 == null;
        }
        if (u === "edge") {
          var d6 = this.getDataParams(t2, u), v6 = d6.data, m6 = d6.value, b6 = v6.source + " -- " + v6.target;
          return Ih("nameValue", { name: b6, value: m6, noValue: f6(m6) });
        } else {
          var x6 = this.getGraph().getNodeByIndex(t2), S = x6.getLayout().value, M = this.getDataParams(t2, u).data.name;
          return Ih("nameValue", { name: M != null ? M + "" : null, value: S, noValue: f6(S) });
        }
      }, r6.prototype.optionUpdated = function() {
      }, r6.prototype.getDataParams = function(t2, s) {
        var u = a.prototype.getDataParams.call(this, t2, s);
        if (u.value == null && s === "node") {
          var f6 = this.getGraph().getNodeByIndex(t2), d6 = f6.getLayout().value;
          u.value = d6;
        }
        return u;
      }, r6.type = "series.sankey", r6.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, r6;
    }(sc), sje = oje;
    function lje(a, r6) {
      a.eachSeriesByType("sankey", function(t2) {
        var s = t2.get("nodeWidth"), u = t2.get("nodeGap"), f6 = uje(t2, r6);
        t2.layoutInfo = f6;
        var d6 = f6.width, v6 = f6.height, m6 = t2.getGraph(), b6 = m6.nodes, x6 = m6.edges;
        fje(b6);
        var S = gl(b6, function(R) {
          return R.getLayout().value === 0;
        }), M = S.length !== 0 ? 0 : t2.get("layoutIterations"), A6 = t2.get("orient"), I = t2.get("nodeAlign");
        cje(b6, x6, s, u, d6, v6, M, A6, I);
      });
    }
    function uje(a, r6) {
      return ah(a.getBoxLayoutParams(), { width: r6.getWidth(), height: r6.getHeight() });
    }
    function cje(a, r6, t2, s, u, f6, d6, v6, m6) {
      hje(a, r6, t2, u, f6, v6, m6), gje(a, r6, f6, u, s, d6, v6), Mje(a, v6);
    }
    function fje(a) {
      Ne(a, function(r6) {
        var t2 = lS(r6.outEdges, Sz), s = lS(r6.inEdges, Sz), u = r6.getValue() || 0, f6 = Math.max(t2, s, u);
        r6.setLayout({ value: f6 }, true);
      });
    }
    function hje(a, r6, t2, s, u, f6, d6) {
      for (var v6 = [], m6 = [], b6 = [], x6 = [], S = 0, M = 0; M < r6.length; M++)
        v6[M] = 1;
      for (var M = 0; M < a.length; M++)
        m6[M] = a[M].inEdges.length, m6[M] === 0 && b6.push(a[M]);
      for (var A6 = -1; b6.length; ) {
        for (var I = 0; I < b6.length; I++) {
          var R = b6[I], F = R.hostGraph.data.getRawDataItem(R.dataIndex), j = F.depth != null && F.depth >= 0;
          j && F.depth > A6 && (A6 = F.depth), R.setLayout({ depth: j ? F.depth : S }, true), f6 === "vertical" ? R.setLayout({ dy: t2 }, true) : R.setLayout({ dx: t2 }, true);
          for (var $ = 0; $ < R.outEdges.length; $++) {
            var K = R.outEdges[$], U = r6.indexOf(K);
            v6[U] = 0;
            var he = K.node2, ue = a.indexOf(he);
            --m6[ue] === 0 && x6.indexOf(he) < 0 && x6.push(he);
          }
        }
        ++S, b6 = x6, x6 = [];
      }
      for (var M = 0; M < v6.length; M++)
        if (v6[M] === 1)
          throw new Error("Sankey is a DAG, the original data has cycle!");
      var pe = A6 > S - 1 ? A6 : S - 1;
      d6 && d6 !== "left" && dje(a, d6, f6, pe);
      var _e = f6 === "vertical" ? (u - t2) / pe : (s - t2) / pe;
      vje(a, _e, f6);
    }
    function g0e(a) {
      var r6 = a.hostGraph.data.getRawDataItem(a.dataIndex);
      return r6.depth != null && r6.depth >= 0;
    }
    function dje(a, r6, t2, s) {
      if (r6 === "right") {
        for (var u = [], f6 = a, d6 = 0; f6.length; ) {
          for (var v6 = 0; v6 < f6.length; v6++) {
            var m6 = f6[v6];
            m6.setLayout({ skNodeHeight: d6 }, true);
            for (var b6 = 0; b6 < m6.inEdges.length; b6++) {
              var x6 = m6.inEdges[b6];
              u.indexOf(x6.node1) < 0 && u.push(x6.node1);
            }
          }
          f6 = u, u = [], ++d6;
        }
        Ne(a, function(S) {
          g0e(S) || S.setLayout({ depth: Math.max(0, s - S.getLayout().skNodeHeight) }, true);
        });
      } else
        r6 === "justify" && pje(a, s);
    }
    function pje(a, r6) {
      Ne(a, function(t2) {
        !g0e(t2) && !t2.outEdges.length && t2.setLayout({ depth: r6 }, true);
      });
    }
    function vje(a, r6, t2) {
      Ne(a, function(s) {
        var u = s.getLayout().depth * r6;
        t2 === "vertical" ? s.setLayout({ y: u }, true) : s.setLayout({ x: u }, true);
      });
    }
    function gje(a, r6, t2, s, u, f6, d6) {
      var v6 = mje(a, d6);
      yje(v6, r6, t2, s, u, d6), CK(v6, u, t2, s, d6);
      for (var m6 = 1; f6 > 0; f6--)
        m6 *= 0.99, bje(v6, m6, d6), CK(v6, u, t2, s, d6), Cje(v6, m6, d6), CK(v6, u, t2, s, d6);
    }
    function mje(a, r6) {
      var t2 = [], s = r6 === "vertical" ? "y" : "x", u = vD(a, function(f6) {
        return f6.getLayout()[s];
      });
      return u.keys.sort(function(f6, d6) {
        return f6 - d6;
      }), Ne(u.keys, function(f6) {
        t2.push(u.buckets.get(f6));
      }), t2;
    }
    function yje(a, r6, t2, s, u, f6) {
      var d6 = 1 / 0;
      Ne(a, function(v6) {
        var m6 = v6.length, b6 = 0;
        Ne(v6, function(S) {
          b6 += S.getLayout().value;
        });
        var x6 = f6 === "vertical" ? (s - (m6 - 1) * u) / b6 : (t2 - (m6 - 1) * u) / b6;
        x6 < d6 && (d6 = x6);
      }), Ne(a, function(v6) {
        Ne(v6, function(m6, b6) {
          var x6 = m6.getLayout().value * d6;
          f6 === "vertical" ? (m6.setLayout({ x: b6 }, true), m6.setLayout({ dx: x6 }, true)) : (m6.setLayout({ y: b6 }, true), m6.setLayout({ dy: x6 }, true));
        });
      }), Ne(r6, function(v6) {
        var m6 = +v6.getValue() * d6;
        v6.setLayout({ dy: m6 }, true);
      });
    }
    function CK(a, r6, t2, s, u) {
      var f6 = u === "vertical" ? "x" : "y";
      Ne(a, function(d6) {
        d6.sort(function(R, F) {
          return R.getLayout()[f6] - F.getLayout()[f6];
        });
        for (var v6, m6, b6, x6 = 0, S = d6.length, M = u === "vertical" ? "dx" : "dy", A6 = 0; A6 < S; A6++)
          m6 = d6[A6], b6 = x6 - m6.getLayout()[f6], b6 > 0 && (v6 = m6.getLayout()[f6] + b6, u === "vertical" ? m6.setLayout({ x: v6 }, true) : m6.setLayout({ y: v6 }, true)), x6 = m6.getLayout()[f6] + m6.getLayout()[M] + r6;
        var I = u === "vertical" ? s : t2;
        if (b6 = x6 - r6 - I, b6 > 0) {
          v6 = m6.getLayout()[f6] - b6, u === "vertical" ? m6.setLayout({ x: v6 }, true) : m6.setLayout({ y: v6 }, true), x6 = v6;
          for (var A6 = S - 2; A6 >= 0; --A6)
            m6 = d6[A6], b6 = m6.getLayout()[f6] + m6.getLayout()[M] + r6 - x6, b6 > 0 && (v6 = m6.getLayout()[f6] - b6, u === "vertical" ? m6.setLayout({ x: v6 }, true) : m6.setLayout({ y: v6 }, true)), x6 = m6.getLayout()[f6];
        }
      });
    }
    function bje(a, r6, t2) {
      Ne(a.slice().reverse(), function(s) {
        Ne(s, function(u) {
          if (u.outEdges.length) {
            var f6 = lS(u.outEdges, _je, t2) / lS(u.outEdges, Sz);
            if (isNaN(f6)) {
              var d6 = u.outEdges.length;
              f6 = d6 ? lS(u.outEdges, xje, t2) / d6 : 0;
            }
            if (t2 === "vertical") {
              var v6 = u.getLayout().x + (f6 - sS(u, t2)) * r6;
              u.setLayout({ x: v6 }, true);
            } else {
              var m6 = u.getLayout().y + (f6 - sS(u, t2)) * r6;
              u.setLayout({ y: m6 }, true);
            }
          }
        });
      });
    }
    function _je(a, r6) {
      return sS(a.node2, r6) * a.getValue();
    }
    function xje(a, r6) {
      return sS(a.node2, r6);
    }
    function wje(a, r6) {
      return sS(a.node1, r6) * a.getValue();
    }
    function Sje(a, r6) {
      return sS(a.node1, r6);
    }
    function sS(a, r6) {
      return r6 === "vertical" ? a.getLayout().x + a.getLayout().dx / 2 : a.getLayout().y + a.getLayout().dy / 2;
    }
    function Sz(a) {
      return a.getValue();
    }
    function lS(a, r6, t2) {
      for (var s = 0, u = a.length, f6 = -1; ++f6 < u; ) {
        var d6 = +r6(a[f6], t2);
        isNaN(d6) || (s += d6);
      }
      return s;
    }
    function Cje(a, r6, t2) {
      Ne(a, function(s) {
        Ne(s, function(u) {
          if (u.inEdges.length) {
            var f6 = lS(u.inEdges, wje, t2) / lS(u.inEdges, Sz);
            if (isNaN(f6)) {
              var d6 = u.inEdges.length;
              f6 = d6 ? lS(u.inEdges, Sje, t2) / d6 : 0;
            }
            if (t2 === "vertical") {
              var v6 = u.getLayout().x + (f6 - sS(u, t2)) * r6;
              u.setLayout({ x: v6 }, true);
            } else {
              var m6 = u.getLayout().y + (f6 - sS(u, t2)) * r6;
              u.setLayout({ y: m6 }, true);
            }
          }
        });
      });
    }
    function Mje(a, r6) {
      var t2 = r6 === "vertical" ? "x" : "y";
      Ne(a, function(s) {
        s.outEdges.sort(function(u, f6) {
          return u.node2.getLayout()[t2] - f6.node2.getLayout()[t2];
        }), s.inEdges.sort(function(u, f6) {
          return u.node1.getLayout()[t2] - f6.node1.getLayout()[t2];
        });
      }), Ne(a, function(s) {
        var u = 0, f6 = 0;
        Ne(s.outEdges, function(d6) {
          d6.setLayout({ sy: u }, true), u += d6.getLayout().dy;
        }), Ne(s.inEdges, function(d6) {
          d6.setLayout({ ty: f6 }, true), f6 += d6.getLayout().dy;
        });
      });
    }
    function Aje(a) {
      a.eachSeriesByType("sankey", function(r6) {
        var t2 = r6.getGraph(), s = t2.nodes;
        if (s.length) {
          var u = 1 / 0, f6 = -1 / 0;
          Ne(s, function(d6) {
            var v6 = d6.getLayout().value;
            v6 < u && (u = v6), v6 > f6 && (f6 = v6);
          }), Ne(s, function(d6) {
            var v6 = new ap({ type: "color", mappingMethod: "linear", dataExtent: [u, f6], visual: r6.get("color") }), m6 = v6.mapValueToVisual(d6.getLayout().value), b6 = d6.getModel().get(["itemStyle", "color"]);
            b6 != null ? (d6.setVisual("color", b6), d6.setVisual("style", { fill: b6 })) : (d6.setVisual("color", m6), d6.setVisual("style", { fill: m6 }));
          });
        }
      });
    }
    function Eje(a) {
      a.registerChartView(ije), a.registerSeriesModel(sje), a.registerLayout(lje), a.registerVisual(Aje), a.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(r6, t2) {
        t2.eachComponent({ mainType: "series", subType: "sankey", query: r6 }, function(s) {
          s.setNodePosition(r6.dataIndex, [r6.localX, r6.localY]);
        });
      });
    }
    var m0e = function() {
      function a() {
      }
      return a.prototype.getInitialData = function(r6, t2) {
        var s, u = t2.getComponent("xAxis", this.get("xAxisIndex")), f6 = t2.getComponent("yAxis", this.get("yAxisIndex")), d6 = u.get("type"), v6 = f6.get("type"), m6;
        d6 === "category" ? (r6.layout = "horizontal", s = u.getOrdinalMeta(), m6 = true) : v6 === "category" ? (r6.layout = "vertical", s = f6.getOrdinalMeta(), m6 = true) : r6.layout = r6.layout || "horizontal";
        var b6 = ["x", "y"], x6 = r6.layout === "horizontal" ? 0 : 1, S = this._baseAxisDim = b6[x6], M = b6[1 - x6], A6 = [u, f6], I = A6[x6].get("type"), R = A6[1 - x6].get("type"), F = r6.data;
        if (F && m6) {
          var j = [];
          Ne(F, function(U, he) {
            var ue;
            br(U) ? (ue = U.slice(), U.unshift(he)) : br(U.value) ? (ue = qn({}, U), ue.value = ue.value.slice(), U.value.unshift(he)) : ue = U, j.push(ue);
          }), r6.data = j;
        }
        var $ = this.defaultValueDimensions, K = [{ name: S, type: PV(I), ordinalMeta: s, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: M, type: PV(R), dimsDef: $.slice() }];
        return g5(this, { coordDimensions: K, dimensionsCount: $.length + 1, encodeDefaulter: Oi(Ece, K, this) });
      }, a.prototype.getBaseAxis = function() {
        var r6 = this._baseAxisDim;
        return this.ecModel.getComponent(r6 + "Axis", this.get(r6 + "AxisIndex")).axis;
      }, a;
    }(), y0e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], t2.visualDrawType = "stroke", t2;
      }
      return r6.type = "series.boxplot", r6.dependencies = ["xAxis", "yAxis", "grid"], r6.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, r6;
    }(sc);
    Dc(y0e, m0e, true);
    var Ije = y0e, Tje = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this.group, v6 = this._data;
        this._data || d6.removeAll();
        var m6 = t2.get("layout") === "horizontal" ? 1 : 0;
        f6.diff(v6).add(function(b6) {
          if (f6.hasValue(b6)) {
            var x6 = f6.getItemLayout(b6), S = b0e(x6, f6, b6, m6, true);
            f6.setItemGraphicEl(b6, S), d6.add(S);
          }
        }).update(function(b6, x6) {
          var S = v6.getItemGraphicEl(x6);
          if (!f6.hasValue(b6)) {
            d6.remove(S);
            return;
          }
          var M = f6.getItemLayout(b6);
          S ? (f0(S), _0e(M, S, f6, b6)) : S = b0e(M, f6, b6, m6), d6.add(S), f6.setItemGraphicEl(b6, S);
        }).remove(function(b6) {
          var x6 = v6.getItemGraphicEl(b6);
          x6 && d6.remove(x6);
        }).execute(), this._data = f6;
      }, r6.prototype.remove = function(t2) {
        var s = this.group, u = this._data;
        this._data = null, u && u.eachItemGraphicEl(function(f6) {
          f6 && s.remove(f6);
        });
      }, r6.type = "boxplot", r6;
    }(bu), Dje = function() {
      function a() {
      }
      return a;
    }(), kje = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "boxplotBoxPath", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new Dje();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.points, f6 = 0;
        for (t2.moveTo(u[f6][0], u[f6][1]), f6++; f6 < 4; f6++)
          t2.lineTo(u[f6][0], u[f6][1]);
        for (t2.closePath(); f6 < u.length; f6++)
          t2.moveTo(u[f6][0], u[f6][1]), f6++, t2.lineTo(u[f6][0], u[f6][1]);
      }, r6;
    }(uo);
    function b0e(a, r6, t2, s, u) {
      var f6 = a.ends, d6 = new kje({ shape: { points: u ? Pje(f6, s, a) : f6 } });
      return _0e(a, d6, r6, t2, u), d6;
    }
    function _0e(a, r6, t2, s, u) {
      var f6 = t2.hostModel, d6 = fR[u ? "initProps" : "updateProps"];
      d6(r6, { shape: { points: a.ends } }, f6, s), r6.useStyle(t2.getItemVisual(s, "style")), r6.style.strokeNoScale = true, r6.z2 = 100;
      var v6 = t2.getItemModel(s), m6 = v6.getModel("emphasis");
      Ah(r6, v6), Cc(r6, m6.get("focus"), m6.get("blurScope"), m6.get("disabled"));
    }
    function Pje(a, r6, t2) {
      return wr(a, function(s) {
        return s = s.slice(), s[r6] = t2.initBaseline, s;
      });
    }
    var Lje = Tje;
    function Oje(a, r6) {
    }
    var m4 = Ne;
    function Rje(a) {
      var r6 = Fje(a);
      m4(r6, function(t2) {
        var s = t2.seriesModels;
        !s.length || (Nje(t2), m4(s, function(u, f6) {
          Vje(u, t2.boxOffsetList[f6], t2.boxWidthList[f6]);
        }));
      });
    }
    function Fje(a) {
      var r6 = [], t2 = [];
      return a.eachSeriesByType("boxplot", function(s) {
        var u = s.getBaseAxis(), f6 = Vi(t2, u);
        f6 < 0 && (f6 = t2.length, t2[f6] = u, r6[f6] = { axis: u, seriesModels: [] }), r6[f6].seriesModels.push(s);
      }), r6;
    }
    function Nje(a) {
      var r6 = a.axis, t2 = a.seriesModels, s = t2.length, u = a.boxWidthList = [], f6 = a.boxOffsetList = [], d6 = [], v6;
      if (r6.type === "category")
        v6 = r6.getBandWidth();
      else {
        var m6 = 0;
        m4(t2, function(I) {
          m6 = Math.max(m6, I.getData().count());
        });
        var b6 = r6.getExtent();
        v6 = Math.abs(b6[1] - b6[0]) / m6;
      }
      m4(t2, function(I) {
        var R = I.get("boxWidth");
        br(R) || (R = [R, R]), d6.push([ua(R[0], v6) || 0, ua(R[1], v6) || 0]);
      });
      var x6 = v6 * 0.8 - 2, S = x6 / s * 0.3, M = (x6 - S * (s - 1)) / s, A6 = M / 2 - x6 / 2;
      m4(t2, function(I, R) {
        f6.push(A6), A6 += S + M, u.push(Math.min(Math.max(M, d6[R][0]), d6[R][1]));
      });
    }
    function Vje(a, r6, t2) {
      var s = a.coordinateSystem, u = a.getData(), f6 = t2 / 2, d6 = a.get("layout") === "horizontal" ? 0 : 1, v6 = 1 - d6, m6 = ["x", "y"], b6 = u.mapDimension(m6[d6]), x6 = u.mapDimensionsAll(m6[v6]);
      if (b6 == null || x6.length < 5)
        return;
      for (var S = 0; S < u.count(); S++) {
        var M = u.get(b6, S), A6 = K(M, x6[2], S), I = K(M, x6[0], S), R = K(M, x6[1], S), F = K(M, x6[3], S), j = K(M, x6[4], S), $ = [];
        U($, R, false), U($, F, true), $.push(I, R, j, F), he($, I), he($, j), he($, A6), u.setItemLayout(S, { initBaseline: A6[v6], ends: $ });
      }
      function K(ue, pe, _e) {
        var xe = u.get(pe, _e), Ae = [];
        Ae[d6] = ue, Ae[v6] = xe;
        var ke;
        return isNaN(ue) || isNaN(xe) ? ke = [NaN, NaN] : (ke = s.dataToPoint(Ae), ke[d6] += r6), ke;
      }
      function U(ue, pe, _e) {
        var xe = pe.slice(), Ae = pe.slice();
        xe[d6] += f6, Ae[d6] -= f6, _e ? ue.push(xe, Ae) : ue.push(Ae, xe);
      }
      function he(ue, pe) {
        var _e = pe.slice(), xe = pe.slice();
        _e[d6] -= f6, xe[d6] += f6, ue.push(_e, xe);
      }
    }
    function zje(a, r6) {
      r6 = r6 || {};
      for (var t2 = [], s = [], u = r6.boundIQR, f6 = u === "none" || u === 0, d6 = 0; d6 < a.length; d6++) {
        var v6 = Sv(a[d6].slice()), m6 = l0(v6, 0.25), b6 = l0(v6, 0.5), x6 = l0(v6, 0.75), S = v6[0], M = v6[v6.length - 1], A6 = (u == null ? 1.5 : u) * (x6 - m6), I = f6 ? S : Math.max(S, m6 - A6), R = f6 ? M : Math.min(M, x6 + A6), F = r6.itemNameFormatter, j = ti(F) ? F({ value: d6 }) : _a2(F) ? F.replace("{value}", d6 + "") : d6 + "";
        t2.push([j, I, m6, b6, x6, R]);
        for (var $ = 0; $ < v6.length; $++) {
          var K = v6[$];
          if (K < I || K > R) {
            var U = [j, K];
            s.push(U);
          }
        }
      }
      return { boxData: t2, outliers: s };
    }
    var Bje = { type: "echarts:boxplot", transform: function(a) {
      var r6 = a.upstream;
      if (r6.sourceFormat !== jp) {
        var t2 = "";
        Lo(t2);
      }
      var s = zje(r6.getRawData(), a.config);
      return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: s.boxData }, { data: s.outliers }];
    } };
    function jje(a) {
      a.registerSeriesModel(Ije), a.registerChartView(Lje), a.registerVisual(Oje), a.registerLayout(Rje), a.registerTransform(Bje);
    }
    var Gje = ["color", "borderColor"], Wje = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(t2), this._isLargeDraw ? this._renderLarge(t2) : this._renderNormal(t2);
      }, r6.prototype.incrementalPrepareRender = function(t2, s, u) {
        this._clear(), this._updateDrawMode(t2);
      }, r6.prototype.incrementalRender = function(t2, s, u, f6) {
        this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(t2, s) : this._incrementalRenderNormal(t2, s);
      }, r6.prototype.eachRendered = function(t2) {
        s1(this._progressiveEls || this.group, t2);
      }, r6.prototype._updateDrawMode = function(t2) {
        var s = t2.pipelineContext.large;
        (this._isLargeDraw == null || s !== this._isLargeDraw) && (this._isLargeDraw = s, this._clear());
      }, r6.prototype._renderNormal = function(t2) {
        var s = t2.getData(), u = this._data, f6 = this.group, d6 = s.getLayout("isSimpleBox"), v6 = t2.get("clip", true), m6 = t2.coordinateSystem, b6 = m6.getArea && m6.getArea();
        this._data || f6.removeAll(), s.diff(u).add(function(x6) {
          if (s.hasValue(x6)) {
            var S = s.getItemLayout(x6);
            if (v6 && x0e(b6, S))
              return;
            var M = MK(S, x6, true);
            zu(M, { shape: { points: S.ends } }, t2, x6), AK(M, s, x6, d6), f6.add(M), s.setItemGraphicEl(x6, M);
          }
        }).update(function(x6, S) {
          var M = u.getItemGraphicEl(S);
          if (!s.hasValue(x6)) {
            f6.remove(M);
            return;
          }
          var A6 = s.getItemLayout(x6);
          if (v6 && x0e(b6, A6)) {
            f6.remove(M);
            return;
          }
          M ? (fs(M, { shape: { points: A6.ends } }, t2, x6), f0(M)) : M = MK(A6), AK(M, s, x6, d6), f6.add(M), s.setItemGraphicEl(x6, M);
        }).remove(function(x6) {
          var S = u.getItemGraphicEl(x6);
          S && f6.remove(S);
        }).execute(), this._data = s;
      }, r6.prototype._renderLarge = function(t2) {
        this._clear(), S0e(t2, this.group);
        var s = t2.get("clip", true) ? JV(t2.coordinateSystem, false, t2) : null;
        s ? this.group.setClipPath(s) : this.group.removeClipPath();
      }, r6.prototype._incrementalRenderNormal = function(t2, s) {
        for (var u = s.getData(), f6 = u.getLayout("isSimpleBox"), d6; (d6 = t2.next()) != null; ) {
          var v6 = u.getItemLayout(d6), m6 = MK(v6);
          AK(m6, u, d6, f6), m6.incremental = true, this.group.add(m6), this._progressiveEls.push(m6);
        }
      }, r6.prototype._incrementalRenderLarge = function(t2, s) {
        S0e(s, this.group, this._progressiveEls, true);
      }, r6.prototype.remove = function(t2) {
        this._clear();
      }, r6.prototype._clear = function() {
        this.group.removeAll(), this._data = null;
      }, r6.type = "candlestick", r6;
    }(bu), Hje = function() {
      function a() {
      }
      return a;
    }(), $je = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "normalCandlestickBox", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new Hje();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.points;
        this.__simpleBox ? (t2.moveTo(u[4][0], u[4][1]), t2.lineTo(u[6][0], u[6][1])) : (t2.moveTo(u[0][0], u[0][1]), t2.lineTo(u[1][0], u[1][1]), t2.lineTo(u[2][0], u[2][1]), t2.lineTo(u[3][0], u[3][1]), t2.closePath(), t2.moveTo(u[4][0], u[4][1]), t2.lineTo(u[5][0], u[5][1]), t2.moveTo(u[6][0], u[6][1]), t2.lineTo(u[7][0], u[7][1]));
      }, r6;
    }(uo);
    function MK(a, r6, t2) {
      var s = a.ends;
      return new $je({ shape: { points: t2 ? Uje(s, a) : s }, z2: 100 });
    }
    function x0e(a, r6) {
      for (var t2 = true, s = 0; s < r6.ends.length; s++)
        if (a.contain(r6.ends[s][0], r6.ends[s][1])) {
          t2 = false;
          break;
        }
      return t2;
    }
    function AK(a, r6, t2, s) {
      var u = r6.getItemModel(t2);
      a.useStyle(r6.getItemVisual(t2, "style")), a.style.strokeNoScale = true, a.__simpleBox = s, Ah(a, u);
    }
    function Uje(a, r6) {
      return wr(a, function(t2) {
        return t2 = t2.slice(), t2[1] = r6.initBaseline, t2;
      });
    }
    var qje = function() {
      function a() {
      }
      return a;
    }(), w0e = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s.type = "largeCandlestickBox", s;
      }
      return r6.prototype.getDefaultShape = function() {
        return new qje();
      }, r6.prototype.buildPath = function(t2, s) {
        for (var u = s.points, f6 = 0; f6 < u.length; )
          if (this.__sign === u[f6++]) {
            var d6 = u[f6++];
            t2.moveTo(d6, u[f6++]), t2.lineTo(d6, u[f6++]);
          } else
            f6 += 3;
      }, r6;
    }(uo);
    function S0e(a, r6, t2, s) {
      var u = a.getData(), f6 = u.getLayout("largePoints"), d6 = new w0e({ shape: { points: f6 }, __sign: 1 });
      r6.add(d6);
      var v6 = new w0e({ shape: { points: f6 }, __sign: -1 });
      r6.add(v6), C0e(1, d6, a), C0e(-1, v6, a), s && (d6.incremental = true, v6.incremental = true), t2 && t2.push(d6, v6);
    }
    function C0e(a, r6, t2, s) {
      var u = t2.get(["itemStyle", a > 0 ? "borderColor" : "borderColor0"]) || t2.get(["itemStyle", a > 0 ? "color" : "color0"]), f6 = t2.getModel("itemStyle").getItemStyle(Gje);
      r6.useStyle(f6), r6.style.fill = null, r6.style.stroke = u;
    }
    var Yje = Wje, M0e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], t2;
      }
      return r6.prototype.getShadowDim = function() {
        return "open";
      }, r6.prototype.brushSelector = function(t2, s, u) {
        var f6 = s.getItemLayout(t2);
        return f6 && u.rect(f6.brushRect);
      }, r6.type = "series.candlestick", r6.dependencies = ["xAxis", "yAxis", "grid"], r6.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, r6;
    }(sc);
    Dc(M0e, m0e, true);
    var Zje = M0e;
    function Xje(a) {
      !a || !br(a.series) || Ne(a.series, function(r6) {
        ui(r6) && r6.type === "k" && (r6.type = "candlestick");
      });
    }
    var Kje = ["itemStyle", "borderColor"], Jje = ["itemStyle", "borderColor0"], Qje = ["itemStyle", "color"], eGe = ["itemStyle", "color0"], tGe = { seriesType: "candlestick", plan: a5(), performRawSeries: true, reset: function(a, r6) {
      function t2(f6, d6) {
        return d6.get(f6 > 0 ? Qje : eGe);
      }
      function s(f6, d6) {
        return d6.get(f6 > 0 ? Kje : Jje);
      }
      if (!r6.isSeriesFiltered(a)) {
        var u = a.pipelineContext.large;
        return !u && { progress: function(f6, d6) {
          for (var v6; (v6 = f6.next()) != null; ) {
            var m6 = d6.getItemModel(v6), b6 = d6.getItemLayout(v6).sign, x6 = m6.getItemStyle();
            x6.fill = t2(b6, m6), x6.stroke = s(b6, m6) || x6.fill;
            var S = d6.ensureUniqueItemVisual(v6, "style");
            qn(S, x6);
          }
        } };
      }
    } }, nGe = tGe, rGe = { seriesType: "candlestick", plan: a5(), reset: function(a) {
      var r6 = a.coordinateSystem, t2 = a.getData(), s = aGe(a, t2), u = 0, f6 = 1, d6 = ["x", "y"], v6 = t2.getDimensionIndex(t2.mapDimension(d6[u])), m6 = wr(t2.mapDimensionsAll(d6[f6]), t2.getDimensionIndex, t2), b6 = m6[0], x6 = m6[1], S = m6[2], M = m6[3];
      if (t2.setLayout({ candleWidth: s, isSimpleBox: s <= 1.3 }), v6 < 0 || m6.length < 4)
        return;
      return { progress: a.pipelineContext.large ? I : A6 };
      function A6(R, F) {
        for (var j, $ = F.getStore(); (j = R.next()) != null; ) {
          var K = $.get(v6, j), U = $.get(b6, j), he = $.get(x6, j), ue = $.get(S, j), pe = $.get(M, j), _e = Math.min(U, he), xe = Math.max(U, he), Ae = ht(_e, K), ke = ht(xe, K), je = ht(ue, K), Fe = ht(pe, K), at = [];
          Qe(at, ke, 0), Qe(at, Ae, 1), at.push(bt(Fe), bt(ke), bt(je), bt(Ae)), F.setItemLayout(j, { sign: A0e($, j, U, he, x6), initBaseline: U > he ? ke[f6] : Ae[f6], ends: at, brushRect: en(ue, pe, K) });
        }
        function ht(wt, Ft) {
          var fn = [];
          return fn[u] = Ft, fn[f6] = wt, isNaN(Ft) || isNaN(wt) ? [NaN, NaN] : r6.dataToPoint(fn);
        }
        function Qe(wt, Ft, fn) {
          var gn = Ft.slice(), Zr = Ft.slice();
          gn[u] = jr(gn[u] + s / 2, 1, false), Zr[u] = jr(Zr[u] - s / 2, 1, true), fn ? wt.push(gn, Zr) : wt.push(Zr, gn);
        }
        function en(wt, Ft, fn) {
          var gn = ht(wt, fn), Zr = ht(Ft, fn);
          return gn[u] -= s / 2, Zr[u] -= s / 2, { x: gn[0], y: gn[1], width: s, height: Zr[1] - gn[1] };
        }
        function bt(wt) {
          return wt[u] = jr(wt[u], 1), wt;
        }
      }
      function I(R, F) {
        for (var j = Vb(R.count * 4), $ = 0, K, U = [], he = [], ue, pe = F.getStore(); (ue = R.next()) != null; ) {
          var _e = pe.get(v6, ue), xe = pe.get(b6, ue), Ae = pe.get(x6, ue), ke = pe.get(S, ue), je = pe.get(M, ue);
          if (isNaN(_e) || isNaN(ke) || isNaN(je)) {
            j[$++] = NaN, $ += 3;
            continue;
          }
          j[$++] = A0e(pe, ue, xe, Ae, x6), U[u] = _e, U[f6] = ke, K = r6.dataToPoint(U, null, he), j[$++] = K ? K[0] : NaN, j[$++] = K ? K[1] : NaN, U[f6] = je, K = r6.dataToPoint(U, null, he), j[$++] = K ? K[1] : NaN;
        }
        F.setLayout("largePoints", j);
      }
    } };
    function A0e(a, r6, t2, s, u) {
      var f6;
      return t2 > s ? f6 = -1 : t2 < s ? f6 = 1 : f6 = r6 > 0 ? a.get(u, r6 - 1) <= s ? 1 : -1 : 1, f6;
    }
    function aGe(a, r6) {
      var t2 = a.getBaseAxis(), s, u = t2.type === "category" ? t2.getBandWidth() : (s = t2.getExtent(), Math.abs(s[1] - s[0]) / r6.count()), f6 = ua(qi(a.get("barMaxWidth"), u), u), d6 = ua(qi(a.get("barMinWidth"), 1), u), v6 = a.get("barWidth");
      return v6 != null ? ua(v6, u) : Math.max(Math.min(u / 2, f6), d6);
    }
    var iGe = rGe;
    function oGe(a) {
      a.registerChartView(Yje), a.registerSeriesModel(Zje), a.registerPreprocessor(Xje), a.registerVisual(nGe), a.registerLayout(iGe);
    }
    function E0e(a, r6) {
      var t2 = r6.rippleEffectColor || r6.color;
      a.eachChild(function(s) {
        s.attr({ z: r6.z, zlevel: r6.zlevel, style: { stroke: r6.brushType === "stroke" ? t2 : null, fill: r6.brushType === "fill" ? t2 : null } });
      });
    }
    var sGe = function(a) {
      tt(r6, a);
      function r6(t2, s) {
        var u = a.call(this) || this, f6 = new ZR(t2, s), d6 = new bi();
        return u.add(f6), u.add(d6), u.updateData(t2, s), u;
      }
      return r6.prototype.stopEffectAnimation = function() {
        this.childAt(1).removeAll();
      }, r6.prototype.startEffectAnimation = function(t2) {
        for (var s = t2.symbolType, u = t2.color, f6 = t2.rippleNumber, d6 = this.childAt(1), v6 = 0; v6 < f6; v6++) {
          var m6 = Lf(s, -1, -1, 2, 2, u);
          m6.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
          var b6 = -v6 / f6 * t2.period + t2.effectOffset;
          m6.animate("", true).when(t2.period, { scaleX: t2.rippleScale / 2, scaleY: t2.rippleScale / 2 }).delay(b6).start(), m6.animateStyle(true).when(t2.period, { opacity: 0 }).delay(b6).start(), d6.add(m6);
        }
        E0e(d6, t2);
      }, r6.prototype.updateEffectAnimation = function(t2) {
        for (var s = this._effectCfg, u = this.childAt(1), f6 = ["symbolType", "period", "rippleScale", "rippleNumber"], d6 = 0; d6 < f6.length; d6++) {
          var v6 = f6[d6];
          if (s[v6] !== t2[v6]) {
            this.stopEffectAnimation(), this.startEffectAnimation(t2);
            return;
          }
        }
        E0e(u, t2);
      }, r6.prototype.highlight = function() {
        Cm(this);
      }, r6.prototype.downplay = function() {
        Mm(this);
      }, r6.prototype.getSymbolType = function() {
        var t2 = this.childAt(0);
        return t2 && t2.getSymbolType();
      }, r6.prototype.updateData = function(t2, s) {
        var u = this, f6 = t2.hostModel;
        this.childAt(0).updateData(t2, s);
        var d6 = this.childAt(1), v6 = t2.getItemModel(s), m6 = t2.getItemVisual(s, "symbol"), b6 = IR(t2.getItemVisual(s, "symbolSize")), x6 = t2.getItemVisual(s, "style"), S = x6 && x6.fill, M = v6.getModel("emphasis");
        d6.setScale(b6), d6.traverse(function(F) {
          F.setStyle("fill", S);
        });
        var A6 = l5(t2.getItemVisual(s, "symbolOffset"), b6);
        A6 && (d6.x = A6[0], d6.y = A6[1]);
        var I = t2.getItemVisual(s, "symbolRotate");
        d6.rotation = (I || 0) * Math.PI / 180 || 0;
        var R = {};
        R.showEffectOn = f6.get("showEffectOn"), R.rippleScale = v6.get(["rippleEffect", "scale"]), R.brushType = v6.get(["rippleEffect", "brushType"]), R.period = v6.get(["rippleEffect", "period"]) * 1e3, R.effectOffset = s / t2.count(), R.z = f6.getShallow("z") || 0, R.zlevel = f6.getShallow("zlevel") || 0, R.symbolType = m6, R.color = S, R.rippleEffectColor = v6.get(["rippleEffect", "color"]), R.rippleNumber = v6.get(["rippleEffect", "number"]), R.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(R) : this.startEffectAnimation(R), this._effectCfg = R) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(F) {
          F === "emphasis" ? R.showEffectOn !== "render" && u.startEffectAnimation(R) : F === "normal" && R.showEffectOn !== "render" && u.stopEffectAnimation();
        }), this._effectCfg = R, Cc(this, M.get("focus"), M.get("blurScope"), M.get("disabled"));
      }, r6.prototype.fadeOut = function(t2) {
        t2 && t2();
      }, r6;
    }(bi), lGe = sGe, uGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function() {
        this._symbolDraw = new XR(lGe);
      }, r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this._symbolDraw;
        d6.updateData(f6, { clipShape: this._getClipShape(t2) }), this.group.add(d6.group);
      }, r6.prototype._getClipShape = function(t2) {
        var s = t2.coordinateSystem, u = s && s.getArea && s.getArea();
        return t2.get("clip", true) ? u : null;
      }, r6.prototype.updateTransform = function(t2, s, u) {
        var f6 = t2.getData();
        this.group.dirty();
        var d6 = KR("").reset(t2, s, u);
        d6.progress && d6.progress({ start: 0, end: f6.count(), count: f6.count() }, f6), this._symbolDraw.updateLayout();
      }, r6.prototype._updateGroupTransform = function(t2) {
        var s = t2.coordinateSystem;
        s && s.getRoamTransform && (this.group.transform = aD(s.getRoamTransform()), this.group.decomposeTransform());
      }, r6.prototype.remove = function(t2, s) {
        this._symbolDraw && this._symbolDraw.remove(true);
      }, r6.type = "effectScatter", r6;
    }(bu), cGe = uGe, fGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.hasSymbolVisual = true, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        return Wx(null, this, { useEncodeDefaulter: true });
      }, r6.prototype.brushSelector = function(t2, s, u) {
        return u.point(s.getItemLayout(t2));
      }, r6.type = "series.effectScatter", r6.dependencies = ["grid", "polar"], r6.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, r6;
    }(sc), hGe = fGe;
    function dGe(a) {
      a.registerChartView(cGe), a.registerSeriesModel(hGe), a.registerLayout(KR("effectScatter"));
    }
    var pGe = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this) || this;
        return f6.add(f6.createLine(t2, s, u)), f6._updateEffectSymbol(t2, s), f6;
      }
      return r6.prototype.createLine = function(t2, s, u) {
        return new QX(t2, s, u);
      }, r6.prototype._updateEffectSymbol = function(t2, s) {
        var u = t2.getItemModel(s), f6 = u.getModel("effect"), d6 = f6.get("symbolSize"), v6 = f6.get("symbol");
        br(d6) || (d6 = [d6, d6]);
        var m6 = t2.getItemVisual(s, "style"), b6 = f6.get("color") || m6 && m6.stroke, x6 = this.childAt(1);
        this._symbolType !== v6 && (this.remove(x6), x6 = Lf(v6, -0.5, -0.5, 1, 1, b6), x6.z2 = 100, x6.culling = true, this.add(x6)), x6 && (x6.setStyle("shadowColor", b6), x6.setStyle(f6.getItemStyle(["color"])), x6.scaleX = d6[0], x6.scaleY = d6[1], x6.setColor(b6), this._symbolType = v6, this._symbolScale = d6, this._updateEffectAnimation(t2, f6, s));
      }, r6.prototype._updateEffectAnimation = function(t2, s, u) {
        var f6 = this.childAt(1);
        if (f6) {
          var d6 = t2.getItemLayout(u), v6 = s.get("period") * 1e3, m6 = s.get("loop"), b6 = s.get("constantSpeed"), x6 = Jf(s.get("delay"), function(M) {
            return M / t2.count() * v6 / 3;
          });
          if (f6.ignore = true, this._updateAnimationPoints(f6, d6), b6 > 0 && (v6 = this._getLineLength(f6) / b6 * 1e3), v6 !== this._period || m6 !== this._loop) {
            f6.stopAnimation();
            var S = void 0;
            ti(x6) ? S = x6(u) : S = x6, f6.__t > 0 && (S = -v6 * f6.__t), this._animateSymbol(f6, v6, S, m6);
          }
          this._period = v6, this._loop = m6;
        }
      }, r6.prototype._animateSymbol = function(t2, s, u, f6) {
        if (s > 0) {
          t2.__t = 0;
          var d6 = this, v6 = t2.animate("", f6).when(s, { __t: 1 }).delay(u).during(function() {
            d6._updateSymbolPosition(t2);
          });
          f6 || v6.done(function() {
            d6.remove(t2);
          }), v6.start();
        }
      }, r6.prototype._getLineLength = function(t2) {
        return pm(t2.__p1, t2.__cp1) + pm(t2.__cp1, t2.__p2);
      }, r6.prototype._updateAnimationPoints = function(t2, s) {
        t2.__p1 = s[0], t2.__p2 = s[1], t2.__cp1 = s[2] || [(s[0][0] + s[1][0]) / 2, (s[0][1] + s[1][1]) / 2];
      }, r6.prototype.updateData = function(t2, s, u) {
        this.childAt(0).updateData(t2, s, u), this._updateEffectSymbol(t2, s);
      }, r6.prototype._updateSymbolPosition = function(t2) {
        var s = t2.__p1, u = t2.__p2, f6 = t2.__cp1, d6 = t2.__t, v6 = [t2.x, t2.y], m6 = v6.slice(), b6 = eh, x6 = zT;
        v6[0] = b6(s[0], f6[0], u[0], d6), v6[1] = b6(s[1], f6[1], u[1], d6);
        var S = x6(s[0], f6[0], u[0], d6), M = x6(s[1], f6[1], u[1], d6);
        t2.rotation = -Math.atan2(M, S) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (t2.__lastT !== void 0 && t2.__lastT < t2.__t ? (t2.scaleY = pm(m6, v6) * 1.05, d6 === 1 && (v6[0] = m6[0] + (v6[0] - m6[0]) / 2, v6[1] = m6[1] + (v6[1] - m6[1]) / 2)) : t2.__lastT === 1 ? t2.scaleY = 2 * pm(s, v6) : t2.scaleY = this._symbolScale[1]), t2.__lastT = t2.__t, t2.ignore = false, t2.x = v6[0], t2.y = v6[1];
      }, r6.prototype.updateLayout = function(t2, s) {
        this.childAt(0).updateLayout(t2, s);
        var u = t2.getItemModel(s).getModel("effect");
        this._updateEffectAnimation(t2, u, s);
      }, r6;
    }(bi), I0e = pGe, vGe = function(a) {
      tt(r6, a);
      function r6(t2, s, u) {
        var f6 = a.call(this) || this;
        return f6._createPolyline(t2, s, u), f6;
      }
      return r6.prototype._createPolyline = function(t2, s, u) {
        var f6 = t2.getItemLayout(s), d6 = new Vp({ shape: { points: f6 } });
        this.add(d6), this._updateCommonStl(t2, s, u);
      }, r6.prototype.updateData = function(t2, s, u) {
        var f6 = t2.hostModel, d6 = this.childAt(0), v6 = { shape: { points: t2.getItemLayout(s) } };
        fs(d6, v6, f6, s), this._updateCommonStl(t2, s, u);
      }, r6.prototype._updateCommonStl = function(t2, s, u) {
        var f6 = this.childAt(0), d6 = t2.getItemModel(s), v6 = u && u.emphasisLineStyle, m6 = u && u.focus, b6 = u && u.blurScope, x6 = u && u.emphasisDisabled;
        if (!u || t2.hasItemOption) {
          var S = d6.getModel("emphasis");
          v6 = S.getModel("lineStyle").getLineStyle(), x6 = S.get("disabled"), m6 = S.get("focus"), b6 = S.get("blurScope");
        }
        f6.useStyle(t2.getItemVisual(s, "style")), f6.style.fill = null, f6.style.strokeNoScale = true;
        var M = f6.ensureState("emphasis");
        M.style = v6, Cc(this, m6, b6, x6);
      }, r6.prototype.updateLayout = function(t2, s) {
        var u = this.childAt(0);
        u.setShape("points", t2.getItemLayout(s));
      }, r6;
    }(bi), T0e = vGe, gGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2._lastFrame = 0, t2._lastFramePercent = 0, t2;
      }
      return r6.prototype.createLine = function(t2, s, u) {
        return new T0e(t2, s, u);
      }, r6.prototype._updateAnimationPoints = function(t2, s) {
        this._points = s;
        for (var u = [0], f6 = 0, d6 = 1; d6 < s.length; d6++) {
          var v6 = s[d6 - 1], m6 = s[d6];
          f6 += pm(v6, m6), u.push(f6);
        }
        if (f6 === 0) {
          this._length = 0;
          return;
        }
        for (var d6 = 0; d6 < u.length; d6++)
          u[d6] /= f6;
        this._offsets = u, this._length = f6;
      }, r6.prototype._getLineLength = function() {
        return this._length;
      }, r6.prototype._updateSymbolPosition = function(t2) {
        var s = t2.__t, u = this._points, f6 = this._offsets, d6 = u.length;
        if (f6) {
          var v6 = this._lastFrame, m6;
          if (s < this._lastFramePercent) {
            var b6 = Math.min(v6 + 1, d6 - 1);
            for (m6 = b6; m6 >= 0 && !(f6[m6] <= s); m6--)
              ;
            m6 = Math.min(m6, d6 - 2);
          } else {
            for (m6 = v6; m6 < d6 && !(f6[m6] > s); m6++)
              ;
            m6 = Math.min(m6 - 1, d6 - 2);
          }
          var x6 = (s - f6[m6]) / (f6[m6 + 1] - f6[m6]), S = u[m6], M = u[m6 + 1];
          t2.x = S[0] * (1 - x6) + x6 * M[0], t2.y = S[1] * (1 - x6) + x6 * M[1];
          var A6 = M[0] - S[0], I = M[1] - S[1];
          t2.rotation = -Math.atan2(I, A6) - Math.PI / 2, this._lastFrame = m6, this._lastFramePercent = s, t2.ignore = false;
        }
      }, r6;
    }(I0e), mGe = gGe, yGe = function() {
      function a() {
        this.polyline = false, this.curveness = 0, this.segs = [];
      }
      return a;
    }(), bGe = function(a) {
      tt(r6, a);
      function r6(t2) {
        var s = a.call(this, t2) || this;
        return s._off = 0, s.hoverDataIdx = -1, s;
      }
      return r6.prototype.reset = function() {
        this.notClear = false, this._off = 0;
      }, r6.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, r6.prototype.getDefaultShape = function() {
        return new yGe();
      }, r6.prototype.buildPath = function(t2, s) {
        var u = s.segs, f6 = s.curveness, d6;
        if (s.polyline)
          for (d6 = this._off; d6 < u.length; ) {
            var v6 = u[d6++];
            if (v6 > 0) {
              t2.moveTo(u[d6++], u[d6++]);
              for (var m6 = 1; m6 < v6; m6++)
                t2.lineTo(u[d6++], u[d6++]);
            }
          }
        else
          for (d6 = this._off; d6 < u.length; ) {
            var b6 = u[d6++], x6 = u[d6++], S = u[d6++], M = u[d6++];
            if (t2.moveTo(b6, x6), f6 > 0) {
              var A6 = (b6 + S) / 2 - (x6 - M) * f6, I = (x6 + M) / 2 - (S - b6) * f6;
              t2.quadraticCurveTo(A6, I, S, M);
            } else
              t2.lineTo(S, M);
          }
        this.incremental && (this._off = d6, this.notClear = true);
      }, r6.prototype.findDataIndex = function(t2, s) {
        var u = this.shape, f6 = u.segs, d6 = u.curveness, v6 = this.style.lineWidth;
        if (u.polyline)
          for (var m6 = 0, b6 = 0; b6 < f6.length; ) {
            var x6 = f6[b6++];
            if (x6 > 0)
              for (var S = f6[b6++], M = f6[b6++], A6 = 1; A6 < x6; A6++) {
                var I = f6[b6++], R = f6[b6++];
                if (Eb(S, M, I, R, v6, t2, s))
                  return m6;
              }
            m6++;
          }
        else
          for (var m6 = 0, b6 = 0; b6 < f6.length; ) {
            var S = f6[b6++], M = f6[b6++], I = f6[b6++], R = f6[b6++];
            if (d6 > 0) {
              var F = (S + I) / 2 - (M - R) * d6, j = (M + R) / 2 - (I - S) * d6;
              if (r7(S, M, F, j, I, R, v6, t2, s))
                return m6;
            } else if (Eb(S, M, I, R, v6, t2, s))
              return m6;
            m6++;
          }
        return -1;
      }, r6.prototype.contain = function(t2, s) {
        var u = this.transformCoordToLocal(t2, s), f6 = this.getBoundingRect();
        if (t2 = u[0], s = u[1], f6.contain(t2, s)) {
          var d6 = this.hoverDataIdx = this.findDataIndex(t2, s);
          return d6 >= 0;
        }
        return this.hoverDataIdx = -1, false;
      }, r6.prototype.getBoundingRect = function() {
        var t2 = this._rect;
        if (!t2) {
          for (var s = this.shape, u = s.segs, f6 = 1 / 0, d6 = 1 / 0, v6 = -1 / 0, m6 = -1 / 0, b6 = 0; b6 < u.length; ) {
            var x6 = u[b6++], S = u[b6++];
            f6 = Math.min(x6, f6), v6 = Math.max(x6, v6), d6 = Math.min(S, d6), m6 = Math.max(S, m6);
          }
          t2 = this._rect = new Qi(f6, d6, v6, m6);
        }
        return t2;
      }, r6;
    }(uo), _Ge = function() {
      function a() {
        this.group = new bi();
      }
      return a.prototype.updateData = function(r6) {
        this._clear();
        var t2 = this._create();
        t2.setShape({ segs: r6.getLayout("linesPoints") }), this._setCommon(t2, r6);
      }, a.prototype.incrementalPrepareUpdate = function(r6) {
        this.group.removeAll(), this._clear();
      }, a.prototype.incrementalUpdate = function(r6, t2) {
        var s = this._newAdded[0], u = t2.getLayout("linesPoints"), f6 = s && s.shape.segs;
        if (f6 && f6.length < 2e4) {
          var d6 = f6.length, v6 = new Float32Array(d6 + u.length);
          v6.set(f6), v6.set(u, d6), s.setShape({ segs: v6 });
        } else {
          this._newAdded = [];
          var m6 = this._create();
          m6.incremental = true, m6.setShape({ segs: u }), this._setCommon(m6, t2), m6.__startIndex = r6.start;
        }
      }, a.prototype.remove = function() {
        this._clear();
      }, a.prototype.eachRendered = function(r6) {
        this._newAdded[0] && r6(this._newAdded[0]);
      }, a.prototype._create = function() {
        var r6 = new bGe({ cursor: "default" });
        return this._newAdded.push(r6), this.group.add(r6), r6;
      }, a.prototype._setCommon = function(r6, t2, s) {
        var u = t2.hostModel;
        r6.setShape({ polyline: u.get("polyline"), curveness: u.get(["lineStyle", "curveness"]) }), r6.useStyle(u.getModel("lineStyle").getLineStyle()), r6.style.strokeNoScale = true;
        var f6 = t2.getVisual("style");
        f6 && f6.stroke && r6.setStyle("stroke", f6.stroke), r6.setStyle("fill", null);
        var d6 = ii(r6);
        d6.seriesIndex = u.seriesIndex, r6.on("mousemove", function(v6) {
          d6.dataIndex = null;
          var m6 = r6.hoverDataIdx;
          m6 > 0 && (d6.dataIndex = m6 + r6.__startIndex);
        });
      }, a.prototype._clear = function() {
        this._newAdded = [], this.group.removeAll();
      }, a;
    }(), xGe = _Ge, wGe = { seriesType: "lines", plan: a5(), reset: function(a) {
      var r6 = a.coordinateSystem;
      if (r6) {
        var t2 = a.get("polyline"), s = a.pipelineContext.large;
        return { progress: function(u, f6) {
          var d6 = [];
          if (s) {
            var v6 = void 0, m6 = u.end - u.start;
            if (t2) {
              for (var b6 = 0, x6 = u.start; x6 < u.end; x6++)
                b6 += a.getLineCoordsCount(x6);
              v6 = new Float32Array(m6 + b6 * 2);
            } else
              v6 = new Float32Array(m6 * 4);
            for (var S = 0, M = [], x6 = u.start; x6 < u.end; x6++) {
              var A6 = a.getLineCoords(x6, d6);
              t2 && (v6[S++] = A6);
              for (var I = 0; I < A6; I++)
                M = r6.dataToPoint(d6[I], false, M), v6[S++] = M[0], v6[S++] = M[1];
            }
            f6.setLayout("linesPoints", v6);
          } else
            for (var x6 = u.start; x6 < u.end; x6++) {
              var R = f6.getItemModel(x6), A6 = a.getLineCoords(x6, d6), F = [];
              if (t2)
                for (var j = 0; j < A6; j++)
                  F.push(r6.dataToPoint(d6[j]));
              else {
                F[0] = r6.dataToPoint(d6[0]), F[1] = r6.dataToPoint(d6[1]);
                var $ = R.get(["lineStyle", "curveness"]);
                +$ && (F[2] = [(F[0][0] + F[1][0]) / 2 - (F[0][1] - F[1][1]) * $, (F[0][1] + F[1][1]) / 2 - (F[1][0] - F[0][0]) * $]);
              }
              f6.setItemLayout(x6, F);
            }
        } };
      }
    } }, D0e = wGe, SGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this._updateLineDraw(f6, t2), v6 = t2.get("zlevel"), m6 = t2.get(["effect", "trailLength"]), b6 = u.getZr(), x6 = b6.painter.getType() === "svg";
        x6 || b6.painter.getLayer(v6).clear(true), this._lastZlevel != null && !x6 && b6.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(t2) && m6 > 0 && (x6 || b6.configLayer(v6, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(m6 / 10 + 0.9, 1), 0) })), d6.updateData(f6);
        var S = t2.get("clip", true) && JV(t2.coordinateSystem, false, t2);
        S ? this.group.setClipPath(S) : this.group.removeClipPath(), this._lastZlevel = v6, this._finished = true;
      }, r6.prototype.incrementalPrepareRender = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this._updateLineDraw(f6, t2);
        d6.incrementalPrepareUpdate(f6), this._clearLayer(u), this._finished = false;
      }, r6.prototype.incrementalRender = function(t2, s, u) {
        this._lineDraw.incrementalUpdate(t2, s.getData()), this._finished = t2.end === s.getData().count();
      }, r6.prototype.eachRendered = function(t2) {
        this._lineDraw && this._lineDraw.eachRendered(t2);
      }, r6.prototype.updateTransform = function(t2, s, u) {
        var f6 = t2.getData(), d6 = t2.pipelineContext;
        if (!this._finished || d6.large || d6.progressiveRender)
          return { update: true };
        var v6 = D0e.reset(t2, s, u);
        v6.progress && v6.progress({ start: 0, end: f6.count(), count: f6.count() }, f6), this._lineDraw.updateLayout(), this._clearLayer(u);
      }, r6.prototype._updateLineDraw = function(t2, s) {
        var u = this._lineDraw, f6 = this._showEffect(s), d6 = !!s.get("polyline"), v6 = s.pipelineContext, m6 = v6.large;
        return (!u || f6 !== this._hasEffet || d6 !== this._isPolyline || m6 !== this._isLargeDraw) && (u && u.remove(), u = this._lineDraw = m6 ? new xGe() : new tK(d6 ? f6 ? mGe : T0e : f6 ? I0e : QX), this._hasEffet = f6, this._isPolyline = d6, this._isLargeDraw = m6), this.group.add(u.group), u;
      }, r6.prototype._showEffect = function(t2) {
        return !!t2.get(["effect", "show"]);
      }, r6.prototype._clearLayer = function(t2) {
        var s = t2.getZr(), u = s.painter.getType() === "svg";
        !u && this._lastZlevel != null && s.painter.getLayer(this._lastZlevel).clear(true);
      }, r6.prototype.remove = function(t2, s) {
        this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(s);
      }, r6.prototype.dispose = function(t2, s) {
        this.remove(t2, s);
      }, r6.type = "lines", r6;
    }(bu), CGe = SGe, MGe = typeof Uint32Array == "undefined" ? Array : Uint32Array, AGe = typeof Float64Array == "undefined" ? Array : Float64Array;
    function k0e(a) {
      var r6 = a.data;
      r6 && r6[0] && r6[0][0] && r6[0][0].coord && (a.data = wr(r6, function(t2) {
        var s = [t2[0].coord, t2[1].coord], u = { coords: s };
        return t2[0].name && (u.fromName = t2[0].name), t2[1].name && (u.toName = t2[1].name), ax([u, t2[0], t2[1]]);
      }));
    }
    var EGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.visualStyleAccessPath = "lineStyle", t2.visualDrawType = "stroke", t2;
      }
      return r6.prototype.init = function(t2) {
        t2.data = t2.data || [], k0e(t2);
        var s = this._processFlatCoordsArray(t2.data);
        this._flatCoords = s.flatCoords, this._flatCoordsOffset = s.flatCoordsOffset, s.flatCoords && (t2.data = new Float32Array(s.count)), a.prototype.init.apply(this, arguments);
      }, r6.prototype.mergeOption = function(t2) {
        if (k0e(t2), t2.data) {
          var s = this._processFlatCoordsArray(t2.data);
          this._flatCoords = s.flatCoords, this._flatCoordsOffset = s.flatCoordsOffset, s.flatCoords && (t2.data = new Float32Array(s.count));
        }
        a.prototype.mergeOption.apply(this, arguments);
      }, r6.prototype.appendData = function(t2) {
        var s = this._processFlatCoordsArray(t2.data);
        s.flatCoords && (this._flatCoords ? (this._flatCoords = PT(this._flatCoords, s.flatCoords), this._flatCoordsOffset = PT(this._flatCoordsOffset, s.flatCoordsOffset)) : (this._flatCoords = s.flatCoords, this._flatCoordsOffset = s.flatCoordsOffset), t2.data = new Float32Array(s.count)), this.getRawData().appendData(t2.data);
      }, r6.prototype._getCoordsFromItemModel = function(t2) {
        var s = this.getData().getItemModel(t2), u = s.option instanceof Array ? s.option : s.getShallow("coords");
        return u;
      }, r6.prototype.getLineCoordsCount = function(t2) {
        return this._flatCoordsOffset ? this._flatCoordsOffset[t2 * 2 + 1] : this._getCoordsFromItemModel(t2).length;
      }, r6.prototype.getLineCoords = function(t2, s) {
        if (this._flatCoordsOffset) {
          for (var u = this._flatCoordsOffset[t2 * 2], f6 = this._flatCoordsOffset[t2 * 2 + 1], d6 = 0; d6 < f6; d6++)
            s[d6] = s[d6] || [], s[d6][0] = this._flatCoords[u + d6 * 2], s[d6][1] = this._flatCoords[u + d6 * 2 + 1];
          return f6;
        } else {
          for (var v6 = this._getCoordsFromItemModel(t2), d6 = 0; d6 < v6.length; d6++)
            s[d6] = s[d6] || [], s[d6][0] = v6[d6][0], s[d6][1] = v6[d6][1];
          return v6.length;
        }
      }, r6.prototype._processFlatCoordsArray = function(t2) {
        var s = 0;
        if (this._flatCoords && (s = this._flatCoords.length), ks(t2[0])) {
          for (var u = t2.length, f6 = new MGe(u), d6 = new AGe(u), v6 = 0, m6 = 0, b6 = 0, x6 = 0; x6 < u; ) {
            b6++;
            var S = t2[x6++];
            f6[m6++] = v6 + s, f6[m6++] = S;
            for (var M = 0; M < S; M++) {
              var A6 = t2[x6++], I = t2[x6++];
              d6[v6++] = A6, d6[v6++] = I;
            }
          }
          return { flatCoordsOffset: new Uint32Array(f6.buffer, 0, m6), flatCoords: d6, count: b6 };
        }
        return { flatCoordsOffset: null, flatCoords: null, count: t2.length };
      }, r6.prototype.getInitialData = function(t2, s) {
        var u = new Tv(["value"], this);
        return u.hasItemOption = false, u.initData(t2.data, [], function(f6, d6, v6, m6) {
          if (f6 instanceof Array)
            return NaN;
          u.hasItemOption = true;
          var b6 = f6.value;
          if (b6 != null)
            return b6 instanceof Array ? b6[m6] : b6;
        }), u;
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        var f6 = this.getData(), d6 = f6.getItemModel(t2), v6 = d6.get("name");
        if (v6)
          return v6;
        var m6 = d6.get("fromName"), b6 = d6.get("toName"), x6 = [];
        return m6 != null && x6.push(m6), b6 != null && x6.push(b6), Ih("nameValue", { name: x6.join(" > ") });
      }, r6.prototype.preventIncremental = function() {
        return !!this.get(["effect", "show"]);
      }, r6.prototype.getProgressive = function() {
        var t2 = this.option.progressive;
        return t2 == null ? this.option.large ? 1e4 : this.get("progressive") : t2;
      }, r6.prototype.getProgressiveThreshold = function() {
        var t2 = this.option.progressiveThreshold;
        return t2 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : t2;
      }, r6.prototype.getZLevelKey = function() {
        var t2 = this.getModel("effect"), s = t2.get("trailLength");
        return this.getData().count() > this.getProgressiveThreshold() ? this.id : t2.get("show") && s > 0 ? s + "" : "";
      }, r6.type = "series.lines", r6.dependencies = ["grid", "polar", "geo", "calendar"], r6.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, r6;
    }(sc), IGe = EGe;
    function Cz(a) {
      return a instanceof Array || (a = [a, a]), a;
    }
    var TGe = { seriesType: "lines", reset: function(a) {
      var r6 = Cz(a.get("symbol")), t2 = Cz(a.get("symbolSize")), s = a.getData();
      s.setVisual("fromSymbol", r6 && r6[0]), s.setVisual("toSymbol", r6 && r6[1]), s.setVisual("fromSymbolSize", t2 && t2[0]), s.setVisual("toSymbolSize", t2 && t2[1]);
      function u(f6, d6) {
        var v6 = f6.getItemModel(d6), m6 = Cz(v6.getShallow("symbol", true)), b6 = Cz(v6.getShallow("symbolSize", true));
        m6[0] && f6.setItemVisual(d6, "fromSymbol", m6[0]), m6[1] && f6.setItemVisual(d6, "toSymbol", m6[1]), b6[0] && f6.setItemVisual(d6, "fromSymbolSize", b6[0]), b6[1] && f6.setItemVisual(d6, "toSymbolSize", b6[1]);
      }
      return { dataEach: s.hasItemOption ? u : null };
    } }, DGe = TGe;
    function kGe(a) {
      a.registerChartView(CGe), a.registerSeriesModel(IGe), a.registerLayout(D0e), a.registerVisual(DGe);
    }
    var PGe = 256, LGe = function() {
      function a() {
        this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
        var r6 = Tc.createCanvas();
        this.canvas = r6;
      }
      return a.prototype.update = function(r6, t2, s, u, f6, d6) {
        var v6 = this._getBrush(), m6 = this._getGradient(f6, "inRange"), b6 = this._getGradient(f6, "outOfRange"), x6 = this.pointSize + this.blurSize, S = this.canvas, M = S.getContext("2d"), A6 = r6.length;
        S.width = t2, S.height = s;
        for (var I = 0; I < A6; ++I) {
          var R = r6[I], F = R[0], j = R[1], $ = R[2], K = u($);
          M.globalAlpha = K, M.drawImage(v6, F - x6, j - x6);
        }
        if (!S.width || !S.height)
          return S;
        for (var U = M.getImageData(0, 0, S.width, S.height), he = U.data, ue = 0, pe = he.length, _e = this.minOpacity, xe = this.maxOpacity, Ae = xe - _e; ue < pe; ) {
          var K = he[ue + 3] / 256, ke = Math.floor(K * (PGe - 1)) * 4;
          if (K > 0) {
            var je = d6(K) ? m6 : b6;
            K > 0 && (K = K * Ae + _e), he[ue++] = je[ke], he[ue++] = je[ke + 1], he[ue++] = je[ke + 2], he[ue++] = je[ke + 3] * K * 256;
          } else
            ue += 4;
        }
        return M.putImageData(U, 0, 0), S;
      }, a.prototype._getBrush = function() {
        var r6 = this._brushCanvas || (this._brushCanvas = Tc.createCanvas()), t2 = this.pointSize + this.blurSize, s = t2 * 2;
        r6.width = s, r6.height = s;
        var u = r6.getContext("2d");
        return u.clearRect(0, 0, s, s), u.shadowOffsetX = s, u.shadowBlur = this.blurSize, u.shadowColor = "#000", u.beginPath(), u.arc(-t2, t2, this.pointSize, 0, Math.PI * 2, true), u.closePath(), u.fill(), r6;
      }, a.prototype._getGradient = function(r6, t2) {
        for (var s = this._gradientPixels, u = s[t2] || (s[t2] = new Uint8ClampedArray(256 * 4)), f6 = [0, 0, 0, 0], d6 = 0, v6 = 0; v6 < 256; v6++)
          r6[t2](v6 / 255, true, f6), u[d6++] = f6[0], u[d6++] = f6[1], u[d6++] = f6[2], u[d6++] = f6[3];
        return u;
      }, a;
    }(), OGe = LGe;
    function RGe(a, r6, t2) {
      var s = a[1] - a[0];
      r6 = wr(r6, function(d6) {
        return { interval: [(d6.interval[0] - a[0]) / s, (d6.interval[1] - a[0]) / s] };
      });
      var u = r6.length, f6 = 0;
      return function(d6) {
        var v6;
        for (v6 = f6; v6 < u; v6++) {
          var m6 = r6[v6].interval;
          if (m6[0] <= d6 && d6 <= m6[1]) {
            f6 = v6;
            break;
          }
        }
        if (v6 === u)
          for (v6 = f6 - 1; v6 >= 0; v6--) {
            var m6 = r6[v6].interval;
            if (m6[0] <= d6 && d6 <= m6[1]) {
              f6 = v6;
              break;
            }
          }
        return v6 >= 0 && v6 < u && t2[v6];
      };
    }
    function FGe(a, r6) {
      var t2 = a[1] - a[0];
      return r6 = [(r6[0] - a[0]) / t2, (r6[1] - a[0]) / t2], function(s) {
        return s >= r6[0] && s <= r6[1];
      };
    }
    function P0e(a) {
      var r6 = a.dimensions;
      return r6[0] === "lng" && r6[1] === "lat";
    }
    var NGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6;
        s.eachComponent("visualMap", function(v6) {
          v6.eachTargetSeries(function(m6) {
            m6 === t2 && (f6 = v6);
          });
        }), this._progressiveEls = null, this.group.removeAll();
        var d6 = t2.coordinateSystem;
        d6.type === "cartesian2d" || d6.type === "calendar" ? this._renderOnCartesianAndCalendar(t2, u, 0, t2.getData().count()) : P0e(d6) && this._renderOnGeo(d6, t2, f6, u);
      }, r6.prototype.incrementalPrepareRender = function(t2, s, u) {
        this.group.removeAll();
      }, r6.prototype.incrementalRender = function(t2, s, u, f6) {
        var d6 = s.coordinateSystem;
        d6 && (P0e(d6) ? this.render(s, u, f6) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(s, f6, t2.start, t2.end, true)));
      }, r6.prototype.eachRendered = function(t2) {
        s1(this._progressiveEls || this.group, t2);
      }, r6.prototype._renderOnCartesianAndCalendar = function(t2, s, u, f6, d6) {
        var v6 = t2.coordinateSystem, m6, b6, x6, S;
        if ($x(v6, "cartesian2d")) {
          var M = v6.getAxis("x"), A6 = v6.getAxis("y");
          m6 = M.getBandWidth(), b6 = A6.getBandWidth(), x6 = M.scale.getExtent(), S = A6.scale.getExtent();
        }
        for (var I = this.group, R = t2.getData(), F = t2.getModel(["emphasis", "itemStyle"]).getItemStyle(), j = t2.getModel(["blur", "itemStyle"]).getItemStyle(), $ = t2.getModel(["select", "itemStyle"]).getItemStyle(), K = t2.get(["itemStyle", "borderRadius"]), U = hd(t2), he = t2.getModel("emphasis"), ue = he.get("focus"), pe = he.get("blurScope"), _e = he.get("disabled"), xe = $x(v6, "cartesian2d") ? [R.mapDimension("x"), R.mapDimension("y"), R.mapDimension("value")] : [R.mapDimension("time"), R.mapDimension("value")], Ae = u; Ae < f6; Ae++) {
          var ke = void 0, je = R.getItemVisual(Ae, "style");
          if ($x(v6, "cartesian2d")) {
            var Fe = R.get(xe[0], Ae), at = R.get(xe[1], Ae);
            if (isNaN(R.get(xe[2], Ae)) || Fe < x6[0] || Fe > x6[1] || at < S[0] || at > S[1])
              continue;
            var ht = v6.dataToPoint([Fe, at]);
            ke = new rs({ shape: { x: Math.floor(Math.round(ht[0]) - m6 / 2), y: Math.floor(Math.round(ht[1]) - b6 / 2), width: Math.ceil(m6), height: Math.ceil(b6) }, style: je });
          } else {
            if (isNaN(R.get(xe[1], Ae)))
              continue;
            ke = new rs({ z2: 1, shape: v6.dataToRect([R.get(xe[0], Ae)]).contentShape, style: je });
          }
          if (R.hasItemOption) {
            var Qe = R.getItemModel(Ae), en = Qe.getModel("emphasis");
            F = en.getModel("itemStyle").getItemStyle(), j = Qe.getModel(["blur", "itemStyle"]).getItemStyle(), $ = Qe.getModel(["select", "itemStyle"]).getItemStyle(), K = Qe.get(["itemStyle", "borderRadius"]), ue = en.get("focus"), pe = en.get("blurScope"), _e = en.get("disabled"), U = hd(Qe);
          }
          ke.shape.r = K;
          var bt = t2.getRawValue(Ae), wt = "-";
          bt && bt[2] != null && (wt = bt[2] + ""), Bp(ke, U, { labelFetcher: t2, labelDataIndex: Ae, defaultOpacity: je.opacity, defaultText: wt }), ke.ensureState("emphasis").style = F, ke.ensureState("blur").style = j, ke.ensureState("select").style = $, Cc(ke, ue, pe, _e), ke.incremental = d6, d6 && (ke.states.emphasis.hoverLayer = true), I.add(ke), R.setItemGraphicEl(Ae, ke), this._progressiveEls && this._progressiveEls.push(ke);
        }
      }, r6.prototype._renderOnGeo = function(t2, s, u, f6) {
        var d6 = u.targetVisuals.inRange, v6 = u.targetVisuals.outOfRange, m6 = s.getData(), b6 = this._hmLayer || this._hmLayer || new OGe();
        b6.blurSize = s.get("blurSize"), b6.pointSize = s.get("pointSize"), b6.minOpacity = s.get("minOpacity"), b6.maxOpacity = s.get("maxOpacity");
        var x6 = t2.getViewRect().clone(), S = t2.getRoamTransform();
        x6.applyTransform(S);
        var M = Math.max(x6.x, 0), A6 = Math.max(x6.y, 0), I = Math.min(x6.width + x6.x, f6.getWidth()), R = Math.min(x6.height + x6.y, f6.getHeight()), F = I - M, j = R - A6, $ = [m6.mapDimension("lng"), m6.mapDimension("lat"), m6.mapDimension("value")], K = m6.mapArray($, function(pe, _e, xe) {
          var Ae = t2.dataToPoint([pe, _e]);
          return Ae[0] -= M, Ae[1] -= A6, Ae.push(xe), Ae;
        }), U = u.getExtent(), he = u.type === "visualMap.continuous" ? FGe(U, u.option.range) : RGe(U, u.getPieceList(), u.option.selected);
        b6.update(K, F, j, d6.color.getNormalizer(), { inRange: d6.color.getColorMapper(), outOfRange: v6.color.getColorMapper() }, he);
        var ue = new nh({ style: { width: F, height: j, x: M, y: A6, image: b6.canvas }, silent: true });
        this.group.add(ue);
      }, r6.type = "heatmap", r6;
    }(bu), VGe = NGe, zGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        return Wx(null, this, { generateCoord: "value" });
      }, r6.prototype.preventIncremental = function() {
        var t2 = yR.get(this.get("coordinateSystem"));
        if (t2 && t2.dimensions)
          return t2.dimensions[0] === "lng" && t2.dimensions[1] === "lat";
      }, r6.type = "series.heatmap", r6.dependencies = ["grid", "geo", "calendar"], r6.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, r6;
    }(sc), BGe = zGe;
    function jGe(a) {
      a.registerChartView(VGe), a.registerSeriesModel(BGe);
    }
    var GGe = ["itemStyle", "borderWidth"], L0e = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], EK = new Em(), WGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = this.group, d6 = t2.getData(), v6 = this._data, m6 = t2.coordinateSystem, b6 = m6.getBaseAxis(), x6 = b6.isHorizontal(), S = m6.master.getRect(), M = { ecSize: { width: u.getWidth(), height: u.getHeight() }, seriesModel: t2, coordSys: m6, coordSysExtent: [[S.x, S.x + S.width], [S.y, S.y + S.height]], isHorizontal: x6, valueDim: L0e[+x6], categoryDim: L0e[1 - +x6] };
        return d6.diff(v6).add(function(A6) {
          if (d6.hasValue(A6)) {
            var I = B0e(d6, A6), R = O0e(d6, A6, I, M), F = j0e(d6, M, R);
            d6.setItemGraphicEl(A6, F), f6.add(F), H0e(F, M, R);
          }
        }).update(function(A6, I) {
          var R = v6.getItemGraphicEl(I);
          if (!d6.hasValue(A6)) {
            f6.remove(R);
            return;
          }
          var F = B0e(d6, A6), j = O0e(d6, A6, F, M), $ = W0e(d6, j);
          R && $ !== R.__pictorialShapeStr && (f6.remove(R), d6.setItemGraphicEl(A6, null), R = null), R ? XGe(R, M, j) : R = j0e(d6, M, j, true), d6.setItemGraphicEl(A6, R), R.__pictorialSymbolMeta = j, f6.add(R), H0e(R, M, j);
        }).remove(function(A6) {
          var I = v6.getItemGraphicEl(A6);
          I && G0e(v6, A6, I.__pictorialSymbolMeta.animationModel, I);
        }).execute(), this._data = d6, this.group;
      }, r6.prototype.remove = function(t2, s) {
        var u = this.group, f6 = this._data;
        t2.get("animation") ? f6 && f6.eachItemGraphicEl(function(d6) {
          G0e(f6, ii(d6).dataIndex, t2, d6);
        }) : u.removeAll();
      }, r6.type = "pictorialBar", r6;
    }(bu);
    function O0e(a, r6, t2, s) {
      var u = a.getItemLayout(r6), f6 = t2.get("symbolRepeat"), d6 = t2.get("symbolClip"), v6 = t2.get("symbolPosition") || "start", m6 = t2.get("symbolRotate"), b6 = (m6 || 0) * Math.PI / 180 || 0, x6 = t2.get("symbolPatternSize") || 2, S = t2.isAnimationEnabled(), M = { dataIndex: r6, layout: u, itemModel: t2, symbolType: a.getItemVisual(r6, "symbol") || "circle", style: a.getItemVisual(r6, "style"), symbolClip: d6, symbolRepeat: f6, symbolRepeatDirection: t2.get("symbolRepeatDirection"), symbolPatternSize: x6, rotation: b6, animationModel: S ? t2 : null, hoverScale: S && t2.get(["emphasis", "scale"]), z2: t2.getShallow("z", true) || 0 };
      HGe(t2, f6, u, s, M), $Ge(a, r6, u, f6, d6, M.boundingLength, M.pxSign, x6, s, M), UGe(t2, M.symbolScale, b6, s, M);
      var A6 = M.symbolSize, I = l5(t2.get("symbolOffset"), A6);
      return qGe(t2, A6, u, f6, d6, I, v6, M.valueLineWidth, M.boundingLength, M.repeatCutLength, s, M), M;
    }
    function HGe(a, r6, t2, s, u) {
      var f6 = s.valueDim, d6 = a.get("symbolBoundingData"), v6 = s.coordSys.getOtherAxis(s.coordSys.getBaseAxis()), m6 = v6.toGlobalCoord(v6.dataToCoord(0)), b6 = 1 - +(t2[f6.wh] <= 0), x6;
      if (br(d6)) {
        var S = [IK(v6, d6[0]) - m6, IK(v6, d6[1]) - m6];
        S[1] < S[0] && S.reverse(), x6 = S[b6];
      } else
        d6 != null ? x6 = IK(v6, d6) - m6 : r6 ? x6 = s.coordSysExtent[f6.index][b6] - m6 : x6 = t2[f6.wh];
      u.boundingLength = x6, r6 && (u.repeatCutLength = t2[f6.wh]), u.pxSign = x6 > 0 ? 1 : -1;
    }
    function IK(a, r6) {
      return a.toGlobalCoord(a.dataToCoord(a.scale.parse(r6)));
    }
    function $Ge(a, r6, t2, s, u, f6, d6, v6, m6, b6) {
      var x6 = m6.valueDim, S = m6.categoryDim, M = Math.abs(t2[S.wh]), A6 = a.getItemVisual(r6, "symbolSize"), I;
      br(A6) ? I = A6.slice() : A6 == null ? I = ["100%", "100%"] : I = [A6, A6], I[S.index] = ua(I[S.index], M), I[x6.index] = ua(I[x6.index], s ? M : Math.abs(f6)), b6.symbolSize = I;
      var R = b6.symbolScale = [I[0] / v6, I[1] / v6];
      R[x6.index] *= (m6.isHorizontal ? -1 : 1) * d6;
    }
    function UGe(a, r6, t2, s, u) {
      var f6 = a.get(GGe) || 0;
      f6 && (EK.attr({ scaleX: r6[0], scaleY: r6[1], rotation: t2 }), EK.updateTransform(), f6 /= EK.getLineScale(), f6 *= r6[s.valueDim.index]), u.valueLineWidth = f6 || 0;
    }
    function qGe(a, r6, t2, s, u, f6, d6, v6, m6, b6, x6, S) {
      var M = x6.categoryDim, A6 = x6.valueDim, I = S.pxSign, R = Math.max(r6[A6.index] + v6, 0), F = R;
      if (s) {
        var j = Math.abs(m6), $ = Jf(a.get("symbolMargin"), "15%") + "", K = false;
        $.lastIndexOf("!") === $.length - 1 && (K = true, $ = $.slice(0, $.length - 1));
        var U = ua($, r6[A6.index]), he = Math.max(R + U * 2, 0), ue = K ? 0 : U * 2, pe = H9(s), _e = pe ? s : $0e((j + ue) / he), xe = j - _e * R;
        U = xe / 2 / (K ? _e : Math.max(_e - 1, 1)), he = R + U * 2, ue = K ? 0 : U * 2, !pe && s !== "fixed" && (_e = b6 ? $0e((Math.abs(b6) + ue) / he) : 0), F = _e * he - ue, S.repeatTimes = _e, S.symbolMargin = U;
      }
      var Ae = I * (F / 2), ke = S.pathPosition = [];
      ke[M.index] = t2[M.wh] / 2, ke[A6.index] = d6 === "start" ? Ae : d6 === "end" ? m6 - Ae : m6 / 2, f6 && (ke[0] += f6[0], ke[1] += f6[1]);
      var je = S.bundlePosition = [];
      je[M.index] = t2[M.xy], je[A6.index] = t2[A6.xy];
      var Fe = S.barRectShape = qn({}, t2);
      Fe[A6.wh] = I * Math.max(Math.abs(t2[A6.wh]), Math.abs(ke[A6.index] + Ae)), Fe[M.wh] = t2[M.wh];
      var at = S.clipShape = {};
      at[M.xy] = -t2[M.xy], at[M.wh] = x6.ecSize[M.wh], at[A6.xy] = 0, at[A6.wh] = t2[A6.wh];
    }
    function R0e(a) {
      var r6 = a.symbolPatternSize, t2 = Lf(a.symbolType, -r6 / 2, -r6 / 2, r6, r6);
      return t2.attr({ culling: true }), t2.type !== "image" && t2.setStyle({ strokeNoScale: true }), t2;
    }
    function F0e(a, r6, t2, s) {
      var u = a.__pictorialBundle, f6 = t2.symbolSize, d6 = t2.valueLineWidth, v6 = t2.pathPosition, m6 = r6.valueDim, b6 = t2.repeatTimes || 0, x6 = 0, S = f6[r6.valueDim.index] + d6 + t2.symbolMargin * 2;
      for (TK(a, function(R) {
        R.__pictorialAnimationIndex = x6, R.__pictorialRepeatTimes = b6, x6 < b6 ? C5(R, null, I(x6), t2, s) : C5(R, null, { scaleX: 0, scaleY: 0 }, t2, s, function() {
          u.remove(R);
        }), x6++;
      }); x6 < b6; x6++) {
        var M = R0e(t2);
        M.__pictorialAnimationIndex = x6, M.__pictorialRepeatTimes = b6, u.add(M);
        var A6 = I(x6);
        C5(M, { x: A6.x, y: A6.y, scaleX: 0, scaleY: 0 }, { scaleX: A6.scaleX, scaleY: A6.scaleY, rotation: A6.rotation }, t2, s);
      }
      function I(R) {
        var F = v6.slice(), j = t2.pxSign, $ = R;
        return (t2.symbolRepeatDirection === "start" ? j > 0 : j < 0) && ($ = b6 - 1 - R), F[m6.index] = S * ($ - b6 / 2 + 0.5) + v6[m6.index], { x: F[0], y: F[1], scaleX: t2.symbolScale[0], scaleY: t2.symbolScale[1], rotation: t2.rotation };
      }
    }
    function N0e(a, r6, t2, s) {
      var u = a.__pictorialBundle, f6 = a.__pictorialMainPath;
      f6 ? C5(f6, null, { x: t2.pathPosition[0], y: t2.pathPosition[1], scaleX: t2.symbolScale[0], scaleY: t2.symbolScale[1], rotation: t2.rotation }, t2, s) : (f6 = a.__pictorialMainPath = R0e(t2), u.add(f6), C5(f6, { x: t2.pathPosition[0], y: t2.pathPosition[1], scaleX: 0, scaleY: 0, rotation: t2.rotation }, { scaleX: t2.symbolScale[0], scaleY: t2.symbolScale[1] }, t2, s));
    }
    function V0e(a, r6, t2) {
      var s = qn({}, r6.barRectShape), u = a.__pictorialBarRect;
      u ? C5(u, null, { shape: s }, r6, t2) : (u = a.__pictorialBarRect = new rs({ z2: 2, shape: s, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), u.disableMorphing = true, a.add(u));
    }
    function z0e(a, r6, t2, s) {
      if (t2.symbolClip) {
        var u = a.__pictorialClipPath, f6 = qn({}, t2.clipShape), d6 = r6.valueDim, v6 = t2.animationModel, m6 = t2.dataIndex;
        if (u)
          fs(u, { shape: f6 }, v6, m6);
        else {
          f6[d6.wh] = 0, u = new rs({ shape: f6 }), a.__pictorialBundle.setClipPath(u), a.__pictorialClipPath = u;
          var b6 = {};
          b6[d6.wh] = t2.clipShape[d6.wh], fR[s ? "updateProps" : "initProps"](u, { shape: b6 }, v6, m6);
        }
      }
    }
    function B0e(a, r6) {
      var t2 = a.getItemModel(r6);
      return t2.getAnimationDelayParams = YGe, t2.isAnimationEnabled = ZGe, t2;
    }
    function YGe(a) {
      return { index: a.__pictorialAnimationIndex, count: a.__pictorialRepeatTimes };
    }
    function ZGe() {
      return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
    }
    function j0e(a, r6, t2, s) {
      var u = new bi(), f6 = new bi();
      return u.add(f6), u.__pictorialBundle = f6, f6.x = t2.bundlePosition[0], f6.y = t2.bundlePosition[1], t2.symbolRepeat ? F0e(u, r6, t2) : N0e(u, r6, t2), V0e(u, t2, s), z0e(u, r6, t2, s), u.__pictorialShapeStr = W0e(a, t2), u.__pictorialSymbolMeta = t2, u;
    }
    function XGe(a, r6, t2) {
      var s = t2.animationModel, u = t2.dataIndex, f6 = a.__pictorialBundle;
      fs(f6, { x: t2.bundlePosition[0], y: t2.bundlePosition[1] }, s, u), t2.symbolRepeat ? F0e(a, r6, t2, true) : N0e(a, r6, t2, true), V0e(a, t2, true), z0e(a, r6, t2, true);
    }
    function G0e(a, r6, t2, s) {
      var u = s.__pictorialBarRect;
      u && u.removeTextContent();
      var f6 = [];
      TK(s, function(d6) {
        f6.push(d6);
      }), s.__pictorialMainPath && f6.push(s.__pictorialMainPath), s.__pictorialClipPath && (t2 = null), Ne(f6, function(d6) {
        Ob(d6, { scaleX: 0, scaleY: 0 }, t2, r6, function() {
          s.parent && s.parent.remove(s);
        });
      }), a.setItemGraphicEl(r6, null);
    }
    function W0e(a, r6) {
      return [a.getItemVisual(r6.dataIndex, "symbol") || "none", !!r6.symbolRepeat, !!r6.symbolClip].join(":");
    }
    function TK(a, r6, t2) {
      Ne(a.__pictorialBundle.children(), function(s) {
        s !== a.__pictorialBarRect && r6.call(t2, s);
      });
    }
    function C5(a, r6, t2, s, u, f6) {
      r6 && a.attr(r6), s.symbolClip && !u ? t2 && a.attr(t2) : t2 && fR[u ? "updateProps" : "initProps"](a, t2, s.animationModel, s.dataIndex, f6);
    }
    function H0e(a, r6, t2) {
      var s = t2.dataIndex, u = t2.itemModel, f6 = u.getModel("emphasis"), d6 = f6.getModel("itemStyle").getItemStyle(), v6 = u.getModel(["blur", "itemStyle"]).getItemStyle(), m6 = u.getModel(["select", "itemStyle"]).getItemStyle(), b6 = u.getShallow("cursor"), x6 = f6.get("focus"), S = f6.get("blurScope"), M = f6.get("scale");
      TK(a, function(R) {
        if (R instanceof nh) {
          var F = R.style;
          R.useStyle(qn({ image: F.image, x: F.x, y: F.y, width: F.width, height: F.height }, t2.style));
        } else
          R.useStyle(t2.style);
        var j = R.ensureState("emphasis");
        j.style = d6, M && (j.scaleX = R.scaleX * 1.1, j.scaleY = R.scaleY * 1.1), R.ensureState("blur").style = v6, R.ensureState("select").style = m6, b6 && (R.cursor = b6), R.z2 = t2.z2;
      });
      var A6 = r6.valueDim.posDesc[+(t2.boundingLength > 0)], I = a.__pictorialBarRect;
      Bp(I, hd(u), { labelFetcher: r6.seriesModel, labelDataIndex: s, defaultText: p5(r6.seriesModel.getData(), s), inheritColor: t2.style.fill, defaultOpacity: t2.style.opacity, defaultOutsidePosition: A6 }), Cc(a, x6, S, f6.get("disabled"));
    }
    function $0e(a) {
      var r6 = Math.round(a);
      return Math.abs(a - r6) < 1e-4 ? r6 : Math.ceil(a);
    }
    var KGe = WGe, JGe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.hasSymbolVisual = true, t2.defaultSymbol = "roundRect", t2;
      }
      return r6.prototype.getInitialData = function(t2) {
        return t2.stack = null, a.prototype.getInitialData.apply(this, arguments);
      }, r6.type = "series.pictorialBar", r6.dependencies = ["grid"], r6.defaultOption = Y2(QV.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), r6;
    }(QV), QGe = JGe;
    function eWe(a) {
      a.registerChartView(KGe), a.registerSeriesModel(QGe), a.registerLayout(a.PRIORITY.VISUAL.LAYOUT, Oi(rde, "pictorialBar")), a.registerLayout(a.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, ade("pictorialBar"));
    }
    var tWe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._layers = [], t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = t2.getData(), d6 = this, v6 = this.group, m6 = t2.getLayerSeries(), b6 = f6.getLayout("layoutInfo"), x6 = b6.rect, S = b6.boundaryGap;
        v6.x = 0, v6.y = x6.y + S[0];
        function M(F) {
          return F.name;
        }
        var A6 = new Gx(this._layersSeries || [], m6, M, M), I = [];
        A6.add(Ca(R, this, "add")).update(Ca(R, this, "update")).remove(Ca(R, this, "remove")).execute();
        function R(F, j, $) {
          var K = d6._layers;
          if (F === "remove") {
            v6.remove(K[j]);
            return;
          }
          for (var U = [], he = [], ue, pe = m6[j].indices, _e = 0; _e < pe.length; _e++) {
            var xe = f6.getItemLayout(pe[_e]), Ae = xe.x, ke = xe.y0, je = xe.y;
            U.push(Ae, ke), he.push(Ae, ke + je), ue = f6.getItemVisual(pe[_e], "style");
          }
          var Fe, at = f6.getItemLayout(pe[0]), ht = t2.getModel("label"), Qe = ht.get("margin"), en = t2.getModel("emphasis");
          if (F === "add") {
            var bt = I[j] = new bi();
            Fe = new mpe({ shape: { points: U, stackedOnPoints: he, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), bt.add(Fe), v6.add(bt), t2.isAnimationEnabled() && Fe.setClipPath(nWe(Fe.getBoundingRect(), t2, function() {
              Fe.removeClipPath();
            }));
          } else {
            var bt = K[$];
            Fe = bt.childAt(0), v6.add(bt), I[j] = bt, fs(Fe, { shape: { points: U, stackedOnPoints: he } }, t2), f0(Fe);
          }
          Bp(Fe, hd(t2), { labelDataIndex: pe[_e - 1], defaultText: f6.getName(pe[_e - 1]), inheritColor: ue.fill }, { normal: { verticalAlign: "middle" } }), Fe.setTextConfig({ position: null, local: true });
          var wt = Fe.getTextContent();
          wt && (wt.x = at.x - Qe, wt.y = at.y0 + at.y / 2), Fe.useStyle(ue), f6.setItemGraphicEl(j, Fe), Ah(Fe, t2), Cc(Fe, en.get("focus"), en.get("blurScope"), en.get("disabled"));
        }
        this._layersSeries = m6, this._layers = I;
      }, r6.type = "themeRiver", r6;
    }(bu);
    function nWe(a, r6, t2) {
      var s = new rs({ shape: { x: a.x - 10, y: a.y - 10, width: 0, height: a.height + 20 } });
      return zu(s, { shape: { x: a.x - 50, width: a.width + 100, height: a.height + 20 } }, r6, t2), s;
    }
    var rWe = tWe, DK = 2, aWe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2) {
        a.prototype.init.apply(this, arguments), this.legendVisualProvider = new QR(Ca(this.getData, this), Ca(this.getRawData, this));
      }, r6.prototype.fixData = function(t2) {
        var s = t2.length, u = {}, f6 = vD(t2, function(M) {
          return u.hasOwnProperty(M[0] + "") || (u[M[0] + ""] = -1), M[2];
        }), d6 = [];
        f6.buckets.each(function(M, A6) {
          d6.push({ name: A6, dataList: M });
        });
        for (var v6 = d6.length, m6 = 0; m6 < v6; ++m6) {
          for (var b6 = d6[m6].name, x6 = 0; x6 < d6[m6].dataList.length; ++x6) {
            var S = d6[m6].dataList[x6][0] + "";
            u[S] = m6;
          }
          for (var S in u)
            u.hasOwnProperty(S) && u[S] !== m6 && (u[S] = m6, t2[s] = [S, 0, b6], s++);
        }
        return t2;
      }, r6.prototype.getInitialData = function(t2, s) {
        for (var u = this.getReferringComponents("singleAxis", Lc).models[0], f6 = u.get("type"), d6 = gl(t2.data, function(I) {
          return I[2] !== void 0;
        }), v6 = this.fixData(d6 || []), m6 = [], b6 = this.nameMap = Ta(), x6 = 0, S = 0; S < v6.length; ++S)
          m6.push(v6[S][DK]), b6.get(v6[S][DK]) || (b6.set(v6[S][DK], x6), x6++);
        var M = zR(v6, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: PV(f6) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, A6 = new Tv(M, this);
        return A6.initData(v6), A6;
      }, r6.prototype.getLayerSeries = function() {
        for (var t2 = this.getData(), s = t2.count(), u = [], f6 = 0; f6 < s; ++f6)
          u[f6] = f6;
        var d6 = t2.mapDimension("single"), v6 = vD(u, function(b6) {
          return t2.get("name", b6);
        }), m6 = [];
        return v6.buckets.each(function(b6, x6) {
          b6.sort(function(S, M) {
            return t2.get(d6, S) - t2.get(d6, M);
          }), m6.push({ name: x6, indices: b6 });
        }), m6;
      }, r6.prototype.getAxisTooltipData = function(t2, s, u) {
        br(t2) || (t2 = t2 ? [t2] : []);
        for (var f6 = this.getData(), d6 = this.getLayerSeries(), v6 = [], m6 = d6.length, b6, x6 = 0; x6 < m6; ++x6) {
          for (var S = Number.MAX_VALUE, M = -1, A6 = d6[x6].indices.length, I = 0; I < A6; ++I) {
            var R = f6.get(t2[0], d6[x6].indices[I]), F = Math.abs(R - s);
            F <= S && (b6 = R, S = F, M = d6[x6].indices[I]);
          }
          v6.push(M);
        }
        return { dataIndices: v6, nestestValue: b6 };
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        var f6 = this.getData(), d6 = f6.getName(t2), v6 = f6.get(f6.mapDimension("value"), t2);
        return Ih("nameValue", { name: d6, value: v6 });
      }, r6.type = "series.themeRiver", r6.dependencies = ["singleAxis"], r6.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, r6;
    }(sc), iWe = aWe;
    function oWe(a, r6) {
      a.eachSeriesByType("themeRiver", function(t2) {
        var s = t2.getData(), u = t2.coordinateSystem, f6 = {}, d6 = u.getRect();
        f6.rect = d6;
        var v6 = t2.get("boundaryGap"), m6 = u.getAxis();
        if (f6.boundaryGap = v6, m6.orient === "horizontal") {
          v6[0] = ua(v6[0], d6.height), v6[1] = ua(v6[1], d6.height);
          var b6 = d6.height - v6[0] - v6[1];
          U0e(s, t2, b6);
        } else {
          v6[0] = ua(v6[0], d6.width), v6[1] = ua(v6[1], d6.width);
          var x6 = d6.width - v6[0] - v6[1];
          U0e(s, t2, x6);
        }
        s.setLayout("layoutInfo", f6);
      });
    }
    function U0e(a, r6, t2) {
      if (a.count())
        for (var s = r6.coordinateSystem, u = r6.getLayerSeries(), f6 = a.mapDimension("single"), d6 = a.mapDimension("value"), v6 = wr(u, function(F) {
          return wr(F.indices, function(j) {
            var $ = s.dataToPoint(a.get(f6, j));
            return $[1] = a.get(d6, j), $;
          });
        }), m6 = sWe(v6), b6 = m6.y0, x6 = t2 / m6.max, S = u.length, M = u[0].indices.length, A6, I = 0; I < M; ++I) {
          A6 = b6[I] * x6, a.setItemLayout(u[0].indices[I], { layerIndex: 0, x: v6[0][I][0], y0: A6, y: v6[0][I][1] * x6 });
          for (var R = 1; R < S; ++R)
            A6 += v6[R - 1][I][1] * x6, a.setItemLayout(u[R].indices[I], { layerIndex: R, x: v6[R][I][0], y0: A6, y: v6[R][I][1] * x6 });
        }
    }
    function sWe(a) {
      for (var r6 = a.length, t2 = a[0].length, s = [], u = [], f6 = 0, d6 = 0; d6 < t2; ++d6) {
        for (var v6 = 0, m6 = 0; m6 < r6; ++m6)
          v6 += a[m6][d6][1];
        v6 > f6 && (f6 = v6), s.push(v6);
      }
      for (var b6 = 0; b6 < t2; ++b6)
        u[b6] = (f6 - s[b6]) / 2;
      f6 = 0;
      for (var x6 = 0; x6 < t2; ++x6) {
        var S = s[x6] + u[x6];
        S > f6 && (f6 = S);
      }
      return { y0: u, max: f6 };
    }
    function lWe(a) {
      a.registerChartView(rWe), a.registerSeriesModel(iWe), a.registerLayout(oWe), a.registerProcessor(JR("themeRiver"));
    }
    var uWe = 2, cWe = 4, fWe = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6) {
        var d6 = a.call(this) || this;
        d6.z2 = uWe, d6.textConfig = { inside: true }, ii(d6).seriesIndex = s.seriesIndex;
        var v6 = new ms({ z2: cWe, silent: t2.getModel().get(["label", "silent"]) });
        return d6.setTextContent(v6), d6.updateData(true, t2, s, u, f6), d6;
      }
      return r6.prototype.updateData = function(t2, s, u, f6, d6) {
        this.node = s, s.piece = this, u = u || this._seriesModel, f6 = f6 || this._ecModel;
        var v6 = this;
        ii(v6).dataIndex = s.dataIndex;
        var m6 = s.getModel(), b6 = m6.getModel("emphasis"), x6 = s.getLayout(), S = qn({}, x6);
        S.label = null;
        var M = s.getVisual("style");
        M.lineJoin = "bevel";
        var A6 = s.getVisual("decal");
        A6 && (M.decal = DR(A6, d6));
        var I = v5(m6.getModel("itemStyle"), S, true);
        qn(S, I), Ne(Oc, function($) {
          var K = v6.ensureState($), U = m6.getModel([$, "itemStyle"]);
          K.style = U.getItemStyle();
          var he = v5(U, S);
          he && (K.shape = he);
        }), t2 ? (v6.setShape(S), v6.shape.r = x6.r0, fs(v6, { shape: { r: x6.r } }, u, s.dataIndex)) : (fs(v6, { shape: S }, u), f0(v6)), v6.useStyle(M), this._updateLabel(u);
        var R = m6.getShallow("cursor");
        R && v6.attr("cursor", R), this._seriesModel = u || this._seriesModel, this._ecModel = f6 || this._ecModel;
        var F = b6.get("focus"), j = F === "ancestor" ? s.getAncestorsIndices() : F === "descendant" ? s.getDescendantIndices() : F;
        Cc(this, j, b6.get("blurScope"), b6.get("disabled"));
      }, r6.prototype._updateLabel = function(t2) {
        var s = this, u = this.node.getModel(), f6 = u.getModel("label"), d6 = this.node.getLayout(), v6 = d6.endAngle - d6.startAngle, m6 = (d6.startAngle + d6.endAngle) / 2, b6 = Math.cos(m6), x6 = Math.sin(m6), S = this, M = S.getTextContent(), A6 = this.node.dataIndex, I = f6.get("minAngle") / 180 * Math.PI, R = f6.get("show") && !(I != null && Math.abs(v6) < I);
        M.ignore = !R, Ne(KM, function(j) {
          var $ = j === "normal" ? u.getModel("label") : u.getModel([j, "label"]), K = j === "normal", U = K ? M : M.ensureState(j), he = t2.getFormattedLabel(A6, j);
          K && (he = he || s.node.name), U.style = yf($, {}, null, j !== "normal", true), he && (U.style.text = he);
          var ue = $.get("show");
          ue != null && !K && (U.ignore = !ue);
          var pe = F($, "position"), _e = K ? S : S.states[j], xe = _e.style.fill;
          _e.textConfig = { outsideFill: $.get("color") === "inherit" ? xe : null, inside: pe !== "outside" };
          var Ae, ke = F($, "distance") || 0, je = F($, "align");
          pe === "outside" ? (Ae = d6.r + ke, je = m6 > Math.PI / 2 ? "right" : "left") : !je || je === "center" ? (v6 === 2 * Math.PI && d6.r0 === 0 ? Ae = 0 : Ae = (d6.r + d6.r0) / 2, je = "center") : je === "left" ? (Ae = d6.r0 + ke, m6 > Math.PI / 2 && (je = "right")) : je === "right" && (Ae = d6.r - ke, m6 > Math.PI / 2 && (je = "left")), U.style.align = je, U.style.verticalAlign = F($, "verticalAlign") || "middle", U.x = Ae * b6 + d6.cx, U.y = Ae * x6 + d6.cy;
          var Fe = F($, "rotate"), at = 0;
          Fe === "radial" ? (at = -m6, at < -Math.PI / 2 && (at += Math.PI)) : Fe === "tangential" ? (at = Math.PI / 2 - m6, at > Math.PI / 2 ? at -= Math.PI : at < -Math.PI / 2 && (at += Math.PI)) : ks(Fe) && (at = Fe * Math.PI / 180), U.rotation = at;
        });
        function F(j, $) {
          var K = j.get($);
          return K == null ? f6.get($) : K;
        }
        M.dirtyStyle();
      }, r6;
    }(Np), q0e = fWe, kK = "sunburstRootToNode", Y0e = "sunburstHighlight", hWe = "sunburstUnhighlight";
    function dWe(a) {
      a.registerAction({ type: kK, update: "updateView" }, function(r6, t2) {
        t2.eachComponent({ mainType: "series", subType: "sunburst", query: r6 }, s);
        function s(u, f6) {
          var d6 = o4(r6, [kK], u);
          if (d6) {
            var v6 = u.getViewRoot();
            v6 && (r6.direction = RX(v6, d6.node) ? "rollUp" : "drillDown"), u.resetViewRoot(d6.node);
          }
        }
      }), a.registerAction({ type: Y0e, update: "none" }, function(r6, t2, s) {
        r6 = qn({}, r6), t2.eachComponent({ mainType: "series", subType: "sunburst", query: r6 }, u);
        function u(f6) {
          var d6 = o4(r6, [Y0e], f6);
          d6 && (r6.dataIndex = d6.node.dataIndex);
        }
        s.dispatchAction(qn(r6, { type: "highlight" }));
      }), a.registerAction({ type: hWe, update: "updateView" }, function(r6, t2, s) {
        r6 = qn({}, r6), s.dispatchAction(qn(r6, { type: "downplay" }));
      });
    }
    var pWe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        var d6 = this;
        this.seriesModel = t2, this.api = u, this.ecModel = s;
        var v6 = t2.getData(), m6 = v6.tree.root, b6 = t2.getViewRoot(), x6 = this.group, S = t2.get("renderLabelForZeroData"), M = [];
        b6.eachNode(function($) {
          M.push($);
        });
        var A6 = this._oldChildren || [];
        I(M, A6), j(m6, b6), this._initEvents(), this._oldChildren = M;
        function I($, K) {
          if ($.length === 0 && K.length === 0)
            return;
          new Gx(K, $, U, U).add(he).update(he).remove(Oi(he, null)).execute();
          function U(ue) {
            return ue.getId();
          }
          function he(ue, pe) {
            var _e = ue == null ? null : $[ue], xe = pe == null ? null : K[pe];
            R(_e, xe);
          }
        }
        function R($, K) {
          if (!S && $ && !$.getValue() && ($ = null), $ !== m6 && K !== m6) {
            if (K && K.piece)
              $ ? (K.piece.updateData(false, $, t2, s, u), v6.setItemGraphicEl($.dataIndex, K.piece)) : F(K);
            else if ($) {
              var U = new q0e($, t2, s, u);
              x6.add(U), v6.setItemGraphicEl($.dataIndex, U);
            }
          }
        }
        function F($) {
          !$ || $.piece && (x6.remove($.piece), $.piece = null);
        }
        function j($, K) {
          K.depth > 0 ? (d6.virtualPiece ? d6.virtualPiece.updateData(false, $, t2, s, u) : (d6.virtualPiece = new q0e($, t2, s, u), x6.add(d6.virtualPiece)), K.piece.off("click"), d6.virtualPiece.on("click", function(U) {
            d6._rootToNode(K.parentNode);
          })) : d6.virtualPiece && (x6.remove(d6.virtualPiece), d6.virtualPiece = null);
        }
      }, r6.prototype._initEvents = function() {
        var t2 = this;
        this.group.off("click"), this.group.on("click", function(s) {
          var u = false, f6 = t2.seriesModel.getViewRoot();
          f6.eachNode(function(d6) {
            if (!u && d6.piece && d6.piece === s.target) {
              var v6 = d6.getModel().get("nodeClick");
              if (v6 === "rootToNode")
                t2._rootToNode(d6);
              else if (v6 === "link") {
                var m6 = d6.getModel(), b6 = m6.get("link");
                if (b6) {
                  var x6 = m6.get("target", true) || "_blank";
                  uV(b6, x6);
                }
              }
              u = true;
            }
          });
        });
      }, r6.prototype._rootToNode = function(t2) {
        t2 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: kK, from: this.uid, seriesId: this.seriesModel.id, targetNode: t2 });
      }, r6.prototype.containPoint = function(t2, s) {
        var u = s.getData(), f6 = u.getItemLayout(0);
        if (f6) {
          var d6 = t2[0] - f6.cx, v6 = t2[1] - f6.cy, m6 = Math.sqrt(d6 * d6 + v6 * v6);
          return m6 <= f6.r && m6 >= f6.r0;
        }
      }, r6.type = "sunburst", r6;
    }(bu), vWe = pWe, gWe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.ignoreStyleOnData = true, t2;
      }
      return r6.prototype.getInitialData = function(t2, s) {
        var u = { name: t2.name, children: t2.data };
        Z0e(u);
        var f6 = this._levelModels = wr(t2.levels || [], function(m6) {
          return new yu(m6, this, s);
        }, this), d6 = OX.createTree(u, this, v6);
        function v6(m6) {
          m6.wrapMethod("getItemModel", function(b6, x6) {
            var S = d6.getNodeByDataIndex(x6), M = f6[S.depth];
            return M && (b6.parentModel = M), b6;
          });
        }
        return d6.data;
      }, r6.prototype.optionUpdated = function() {
        this.resetViewRoot();
      }, r6.prototype.getDataParams = function(t2) {
        var s = a.prototype.getDataParams.apply(this, arguments), u = this.getData().tree.getNodeByDataIndex(t2);
        return s.treePathInfo = hz(u, this), s;
      }, r6.prototype.getLevelModel = function(t2) {
        return this._levelModels && this._levelModels[t2.depth];
      }, r6.prototype.getViewRoot = function() {
        return this._viewRoot;
      }, r6.prototype.resetViewRoot = function(t2) {
        t2 ? this._viewRoot = t2 : t2 = this._viewRoot;
        var s = this.getRawData().tree.root;
        (!t2 || t2 !== s && !s.contains(t2)) && (this._viewRoot = s);
      }, r6.prototype.enableAriaDecal = function() {
        rge(this);
      }, r6.type = "series.sunburst", r6.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, r6;
    }(sc);
    function Z0e(a) {
      var r6 = 0;
      Ne(a.children, function(s) {
        Z0e(s);
        var u = s.value;
        br(u) && (u = u[0]), r6 += u;
      });
      var t2 = a.value;
      br(t2) && (t2 = t2[0]), (t2 == null || isNaN(t2)) && (t2 = r6), t2 < 0 && (t2 = 0), br(a.value) ? a.value[0] = t2 : a.value = t2;
    }
    var mWe = gWe, X0e = Math.PI / 180;
    function yWe(a, r6, t2) {
      r6.eachSeriesByType(a, function(s) {
        var u = s.get("center"), f6 = s.get("radius");
        br(f6) || (f6 = [0, f6]), br(u) || (u = [u, u]);
        var d6 = t2.getWidth(), v6 = t2.getHeight(), m6 = Math.min(d6, v6), b6 = ua(u[0], d6), x6 = ua(u[1], v6), S = ua(f6[0], m6 / 2), M = ua(f6[1], m6 / 2), A6 = -s.get("startAngle") * X0e, I = s.get("minAngle") * X0e, R = s.getData().tree.root, F = s.getViewRoot(), j = F.depth, $ = s.get("sort");
        $ != null && K0e(F, $);
        var K = 0;
        Ne(F.children, function(Qe) {
          !isNaN(Qe.getValue()) && K++;
        });
        var U = F.getValue(), he = Math.PI / (U || K) * 2, ue = F.depth > 0, pe = F.height - (ue ? -1 : 1), _e = (M - S) / (pe || 1), xe = s.get("clockwise"), Ae = s.get("stillShowZeroSum"), ke = xe ? 1 : -1, je = function(Qe, en) {
          if (Qe) {
            var bt = en;
            if (Qe !== R) {
              var wt = Qe.getValue(), Ft = U === 0 && Ae ? he : wt * he;
              Ft < I && (Ft = I), bt = en + ke * Ft;
              var fn = Qe.depth - j - (ue ? -1 : 1), gn = S + _e * fn, Zr = S + _e * (fn + 1), Ma = s.getLevelModel(Qe);
              if (Ma) {
                var Ua = Ma.get("r0", true), ja = Ma.get("r", true), Ga = Ma.get("radius", true);
                Ga != null && (Ua = Ga[0], ja = Ga[1]), Ua != null && (gn = ua(Ua, m6 / 2)), ja != null && (Zr = ua(ja, m6 / 2));
              }
              Qe.setLayout({ angle: Ft, startAngle: en, endAngle: bt, clockwise: xe, cx: b6, cy: x6, r0: gn, r: Zr });
            }
            if (Qe.children && Qe.children.length) {
              var pa = 0;
              Ne(Qe.children, function(Fa) {
                pa += je(Fa, en + pa);
              });
            }
            return bt - en;
          }
        };
        if (ue) {
          var Fe = S, at = S + _e, ht = Math.PI * 2;
          R.setLayout({ angle: ht, startAngle: A6, endAngle: A6 + ht, clockwise: xe, cx: b6, cy: x6, r0: Fe, r: at });
        }
        je(F, A6);
      });
    }
    function K0e(a, r6) {
      var t2 = a.children || [];
      a.children = bWe(t2, r6), t2.length && Ne(a.children, function(s) {
        K0e(s, r6);
      });
    }
    function bWe(a, r6) {
      if (ti(r6)) {
        var t2 = wr(a, function(u, f6) {
          var d6 = u.getValue();
          return { params: { depth: u.depth, height: u.height, dataIndex: u.dataIndex, getValue: function() {
            return d6;
          } }, index: f6 };
        });
        return t2.sort(function(u, f6) {
          return r6(u.params, f6.params);
        }), wr(t2, function(u) {
          return a[u.index];
        });
      } else {
        var s = r6 === "asc";
        return a.sort(function(u, f6) {
          var d6 = (u.getValue() - f6.getValue()) * (s ? 1 : -1);
          return d6 === 0 ? (u.dataIndex - f6.dataIndex) * (s ? -1 : 1) : d6;
        });
      }
    }
    function _We(a) {
      var r6 = {};
      function t2(s, u, f6) {
        for (var d6 = s; d6 && d6.depth > 1; )
          d6 = d6.parentNode;
        var v6 = u.getColorFromPalette(d6.name || d6.dataIndex + "", r6);
        return s.depth > 1 && _a2(v6) && (v6 = OL(v6, (s.depth - 1) / (f6 - 1) * 0.5)), v6;
      }
      a.eachSeriesByType("sunburst", function(s) {
        var u = s.getData(), f6 = u.tree;
        f6.eachNode(function(d6) {
          var v6 = d6.getModel(), m6 = v6.getModel("itemStyle").getItemStyle();
          m6.fill || (m6.fill = t2(d6, s, f6.root.height));
          var b6 = u.ensureUniqueItemVisual(d6.dataIndex, "style");
          qn(b6, m6);
        });
      });
    }
    function xWe(a) {
      a.registerChartView(vWe), a.registerSeriesModel(mWe), a.registerLayout(Oi(yWe, "sunburst")), a.registerProcessor(Oi(JR, "sunburst")), a.registerVisual(_We), dWe(a);
    }
    var J0e = { color: "fill", borderColor: "stroke" }, wWe = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, Zx = Xo(), SWe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.optionUpdated = function() {
        this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
      }, r6.prototype.getInitialData = function(t2, s) {
        return Wx(null, this);
      }, r6.prototype.getDataParams = function(t2, s, u) {
        var f6 = a.prototype.getDataParams.call(this, t2, s);
        return u && (f6.info = Zx(u).info), f6;
      }, r6.type = "series.custom", r6.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], r6.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, r6;
    }(sc), CWe = SWe;
    function MWe(a, r6) {
      return r6 = r6 || [0, 0], wr(["x", "y"], function(t2, s) {
        var u = this.getAxis(t2), f6 = r6[s], d6 = a[s] / 2;
        return u.type === "category" ? u.getBandWidth() : Math.abs(u.dataToCoord(f6 - d6) - u.dataToCoord(f6 + d6));
      }, this);
    }
    function AWe(a) {
      var r6 = a.master.getRect();
      return { coordSys: { type: "cartesian2d", x: r6.x, y: r6.y, width: r6.width, height: r6.height }, api: { coord: function(t2) {
        return a.dataToPoint(t2);
      }, size: Ca(MWe, a) } };
    }
    function EWe(a, r6) {
      return r6 = r6 || [0, 0], wr([0, 1], function(t2) {
        var s = r6[t2], u = a[t2] / 2, f6 = [], d6 = [];
        return f6[t2] = s - u, d6[t2] = s + u, f6[1 - t2] = d6[1 - t2] = r6[1 - t2], Math.abs(this.dataToPoint(f6)[t2] - this.dataToPoint(d6)[t2]);
      }, this);
    }
    function IWe(a) {
      var r6 = a.getBoundingRect();
      return { coordSys: { type: "geo", x: r6.x, y: r6.y, width: r6.width, height: r6.height, zoom: a.getZoom() }, api: { coord: function(t2) {
        return a.dataToPoint(t2);
      }, size: Ca(EWe, a) } };
    }
    function TWe(a, r6) {
      var t2 = this.getAxis(), s = r6 instanceof Array ? r6[0] : r6, u = (a instanceof Array ? a[0] : a) / 2;
      return t2.type === "category" ? t2.getBandWidth() : Math.abs(t2.dataToCoord(s - u) - t2.dataToCoord(s + u));
    }
    function DWe(a) {
      var r6 = a.getRect();
      return { coordSys: { type: "singleAxis", x: r6.x, y: r6.y, width: r6.width, height: r6.height }, api: { coord: function(t2) {
        return a.dataToPoint(t2);
      }, size: Ca(TWe, a) } };
    }
    function kWe(a, r6) {
      return r6 = r6 || [0, 0], wr(["Radius", "Angle"], function(t2, s) {
        var u = "get" + t2 + "Axis", f6 = this[u](), d6 = r6[s], v6 = a[s] / 2, m6 = f6.type === "category" ? f6.getBandWidth() : Math.abs(f6.dataToCoord(d6 - v6) - f6.dataToCoord(d6 + v6));
        return t2 === "Angle" && (m6 = m6 * Math.PI / 180), m6;
      }, this);
    }
    function PWe(a) {
      var r6 = a.getRadiusAxis(), t2 = a.getAngleAxis(), s = r6.getExtent();
      return s[0] > s[1] && s.reverse(), { coordSys: { type: "polar", cx: a.cx, cy: a.cy, r: s[1], r0: s[0] }, api: { coord: function(u) {
        var f6 = r6.dataToRadius(u[0]), d6 = t2.dataToAngle(u[1]), v6 = a.coordToPoint([f6, d6]);
        return v6.push(f6, d6 * Math.PI / 180), v6;
      }, size: Ca(kWe, a) } };
    }
    function LWe(a) {
      var r6 = a.getRect(), t2 = a.getRangeInfo();
      return { coordSys: { type: "calendar", x: r6.x, y: r6.y, width: r6.width, height: r6.height, cellWidth: a.getCellWidth(), cellHeight: a.getCellHeight(), rangeInfo: { start: t2.start, end: t2.end, weeks: t2.weeks, dayCount: t2.allDay } }, api: { coord: function(s, u) {
        return a.dataToPoint(s, u);
      } } };
    }
    function Q0e(a, r6, t2, s) {
      return a && (a.legacy || a.legacy !== false && !t2 && !s && r6 !== "tspan" && (r6 === "text" || Da(a, "text")));
    }
    function eme(a, r6, t2) {
      var s = a, u, f6, d6;
      if (r6 === "text")
        d6 = s;
      else {
        d6 = {}, Da(s, "text") && (d6.text = s.text), Da(s, "rich") && (d6.rich = s.rich), Da(s, "textFill") && (d6.fill = s.textFill), Da(s, "textStroke") && (d6.stroke = s.textStroke), Da(s, "fontFamily") && (d6.fontFamily = s.fontFamily), Da(s, "fontSize") && (d6.fontSize = s.fontSize), Da(s, "fontStyle") && (d6.fontStyle = s.fontStyle), Da(s, "fontWeight") && (d6.fontWeight = s.fontWeight), f6 = { type: "text", style: d6, silent: true }, u = {};
        var v6 = Da(s, "textPosition");
        t2 ? u.position = v6 ? s.textPosition : "inside" : v6 && (u.position = s.textPosition), Da(s, "textPosition") && (u.position = s.textPosition), Da(s, "textOffset") && (u.offset = s.textOffset), Da(s, "textRotation") && (u.rotation = s.textRotation), Da(s, "textDistance") && (u.distance = s.textDistance);
      }
      return tme(d6, a), Ne(d6.rich, function(m6) {
        tme(m6, m6);
      }), { textConfig: u, textContent: f6 };
    }
    function tme(a, r6) {
      !r6 || (r6.font = r6.textFont || r6.font, Da(r6, "textStrokeWidth") && (a.lineWidth = r6.textStrokeWidth), Da(r6, "textAlign") && (a.align = r6.textAlign), Da(r6, "textVerticalAlign") && (a.verticalAlign = r6.textVerticalAlign), Da(r6, "textLineHeight") && (a.lineHeight = r6.textLineHeight), Da(r6, "textWidth") && (a.width = r6.textWidth), Da(r6, "textHeight") && (a.height = r6.textHeight), Da(r6, "textBackgroundColor") && (a.backgroundColor = r6.textBackgroundColor), Da(r6, "textPadding") && (a.padding = r6.textPadding), Da(r6, "textBorderColor") && (a.borderColor = r6.textBorderColor), Da(r6, "textBorderWidth") && (a.borderWidth = r6.textBorderWidth), Da(r6, "textBorderRadius") && (a.borderRadius = r6.textBorderRadius), Da(r6, "textBoxShadowColor") && (a.shadowColor = r6.textBoxShadowColor), Da(r6, "textBoxShadowBlur") && (a.shadowBlur = r6.textBoxShadowBlur), Da(r6, "textBoxShadowOffsetX") && (a.shadowOffsetX = r6.textBoxShadowOffsetX), Da(r6, "textBoxShadowOffsetY") && (a.shadowOffsetY = r6.textBoxShadowOffsetY));
    }
    function nme(a, r6, t2) {
      var s = a;
      s.textPosition = s.textPosition || t2.position || "inside", t2.offset != null && (s.textOffset = t2.offset), t2.rotation != null && (s.textRotation = t2.rotation), t2.distance != null && (s.textDistance = t2.distance);
      var u = s.textPosition.indexOf("inside") >= 0, f6 = a.fill || "#000";
      rme(s, r6);
      var d6 = s.textFill == null;
      return u ? d6 && (s.textFill = t2.insideFill || "#fff", !s.textStroke && t2.insideStroke && (s.textStroke = t2.insideStroke), !s.textStroke && (s.textStroke = f6), s.textStrokeWidth == null && (s.textStrokeWidth = 2)) : (d6 && (s.textFill = a.fill || t2.outsideFill || "#000"), !s.textStroke && t2.outsideStroke && (s.textStroke = t2.outsideStroke)), s.text = r6.text, s.rich = r6.rich, Ne(r6.rich, function(v6) {
        rme(v6, v6);
      }), s;
    }
    function rme(a, r6) {
      !r6 || (Da(r6, "fill") && (a.textFill = r6.fill), Da(r6, "stroke") && (a.textStroke = r6.fill), Da(r6, "lineWidth") && (a.textStrokeWidth = r6.lineWidth), Da(r6, "font") && (a.font = r6.font), Da(r6, "fontStyle") && (a.fontStyle = r6.fontStyle), Da(r6, "fontWeight") && (a.fontWeight = r6.fontWeight), Da(r6, "fontSize") && (a.fontSize = r6.fontSize), Da(r6, "fontFamily") && (a.fontFamily = r6.fontFamily), Da(r6, "align") && (a.textAlign = r6.align), Da(r6, "verticalAlign") && (a.textVerticalAlign = r6.verticalAlign), Da(r6, "lineHeight") && (a.textLineHeight = r6.lineHeight), Da(r6, "width") && (a.textWidth = r6.width), Da(r6, "height") && (a.textHeight = r6.height), Da(r6, "backgroundColor") && (a.textBackgroundColor = r6.backgroundColor), Da(r6, "padding") && (a.textPadding = r6.padding), Da(r6, "borderColor") && (a.textBorderColor = r6.borderColor), Da(r6, "borderWidth") && (a.textBorderWidth = r6.borderWidth), Da(r6, "borderRadius") && (a.textBorderRadius = r6.borderRadius), Da(r6, "shadowColor") && (a.textBoxShadowColor = r6.shadowColor), Da(r6, "shadowBlur") && (a.textBoxShadowBlur = r6.shadowBlur), Da(r6, "shadowOffsetX") && (a.textBoxShadowOffsetX = r6.shadowOffsetX), Da(r6, "shadowOffsetY") && (a.textBoxShadowOffsetY = r6.shadowOffsetY), Da(r6, "textShadowColor") && (a.textShadowColor = r6.textShadowColor), Da(r6, "textShadowBlur") && (a.textShadowBlur = r6.textShadowBlur), Da(r6, "textShadowOffsetX") && (a.textShadowOffsetX = r6.textShadowOffsetX), Da(r6, "textShadowOffsetY") && (a.textShadowOffsetY = r6.textShadowOffsetY));
    }
    var ame = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, ime = Po(ame);
    qg(lg, function(a, r6) {
      return a[r6] = 1, a;
    }, {}), lg.join(", ");
    var Mz = ["", "style", "shape", "extra"], M5 = Xo();
    function PK(a, r6, t2, s, u) {
      var f6 = a + "Animation", d6 = U2(a, s, u) || {}, v6 = M5(r6).userDuring;
      return d6.duration > 0 && (d6.during = v6 ? Ca(VWe, { el: r6, userDuring: v6 }) : null, d6.setToFinal = true, d6.scope = a), qn(d6, t2[f6]), d6;
    }
    function Az(a, r6, t2, s) {
      s = s || {};
      var u = s.dataIndex, f6 = s.isInit, d6 = s.clearStyle, v6 = t2.isAnimationEnabled(), m6 = M5(a), b6 = r6.style;
      m6.userDuring = r6.during;
      var x6 = {}, S = {};
      if (BWe(a, r6, S), lme("shape", r6, S), lme("extra", r6, S), !f6 && v6 && (zWe(a, r6, x6), sme("shape", a, r6, x6), sme("extra", a, r6, x6), jWe(a, r6, b6, x6)), S.style = b6, OWe(a, S, d6), FWe(a, r6), v6)
        if (f6) {
          var M = {};
          Ne(Mz, function(I) {
            var R = I ? r6[I] : r6;
            R && R.enterFrom && (I && (M[I] = M[I] || {}), qn(I ? M[I] : M, R.enterFrom));
          });
          var A6 = PK("enter", a, r6, t2, u);
          A6.duration > 0 && a.animateFrom(M, A6);
        } else
          RWe(a, r6, u || 0, t2, x6);
      ome(a, r6), b6 ? a.dirty() : a.markRedraw();
    }
    function ome(a, r6) {
      for (var t2 = M5(a).leaveToProps, s = 0; s < Mz.length; s++) {
        var u = Mz[s], f6 = u ? r6[u] : r6;
        f6 && f6.leaveTo && (t2 || (t2 = M5(a).leaveToProps = {}), u && (t2[u] = t2[u] || {}), qn(u ? t2[u] : t2, f6.leaveTo));
      }
    }
    function Ez(a, r6, t2, s) {
      if (a) {
        var u = a.parent, f6 = M5(a).leaveToProps;
        if (f6) {
          var d6 = PK("update", a, r6, t2, 0);
          d6.done = function() {
            u.remove(a), s && s();
          }, a.animateTo(f6, d6);
        } else
          u.remove(a), s && s();
      }
    }
    function OA(a) {
      return a === "all";
    }
    function OWe(a, r6, t2) {
      var s = r6.style;
      if (!a.isGroup && s) {
        if (t2) {
          a.useStyle({});
          for (var u = a.animators, f6 = 0; f6 < u.length; f6++) {
            var d6 = u[f6];
            d6.targetName === "style" && d6.changeTarget(a.style);
          }
        }
        a.setStyle(s);
      }
      r6 && (r6.style = null, r6 && a.attr(r6), r6.style = s);
    }
    function RWe(a, r6, t2, s, u) {
      if (u) {
        var f6 = PK("update", a, r6, s, t2);
        f6.duration > 0 && a.animateFrom(u, f6);
      }
    }
    function FWe(a, r6) {
      Da(r6, "silent") && (a.silent = r6.silent), Da(r6, "ignore") && (a.ignore = r6.ignore), a instanceof cg && Da(r6, "invisible") && (a.invisible = r6.invisible), a instanceof uo && Da(r6, "autoBatch") && (a.autoBatch = r6.autoBatch);
    }
    var Gb = {}, NWe = { setTransform: function(a, r6) {
      return Gb.el[a] = r6, this;
    }, getTransform: function(a) {
      return Gb.el[a];
    }, setShape: function(a, r6) {
      var t2 = Gb.el, s = t2.shape || (t2.shape = {});
      return s[a] = r6, t2.dirtyShape && t2.dirtyShape(), this;
    }, getShape: function(a) {
      var r6 = Gb.el.shape;
      if (r6)
        return r6[a];
    }, setStyle: function(a, r6) {
      var t2 = Gb.el, s = t2.style;
      return s && (s[a] = r6, t2.dirtyStyle && t2.dirtyStyle()), this;
    }, getStyle: function(a) {
      var r6 = Gb.el.style;
      if (r6)
        return r6[a];
    }, setExtra: function(a, r6) {
      var t2 = Gb.el.extra || (Gb.el.extra = {});
      return t2[a] = r6, this;
    }, getExtra: function(a) {
      var r6 = Gb.el.extra;
      if (r6)
        return r6[a];
    } };
    function VWe() {
      var a = this, r6 = a.el;
      if (r6) {
        var t2 = M5(r6).userDuring, s = a.userDuring;
        if (t2 !== s) {
          a.el = a.userDuring = null;
          return;
        }
        Gb.el = r6, s(NWe);
      }
    }
    function sme(a, r6, t2, s) {
      var u = t2[a];
      if (u) {
        var f6 = r6[a], d6;
        if (f6) {
          var v6 = t2.transition, m6 = u.transition;
          if (m6)
            if (!d6 && (d6 = s[a] = {}), OA(m6))
              qn(d6, f6);
            else
              for (var b6 = ll(m6), x6 = 0; x6 < b6.length; x6++) {
                var S = b6[x6], M = f6[S];
                d6[S] = M;
              }
          else if (OA(v6) || Vi(v6, a) >= 0) {
            !d6 && (d6 = s[a] = {});
            for (var A6 = Po(f6), x6 = 0; x6 < A6.length; x6++) {
              var S = A6[x6], M = f6[S];
              GWe(u[S], M) && (d6[S] = M);
            }
          }
        }
      }
    }
    function lme(a, r6, t2) {
      var s = r6[a];
      if (s)
        for (var u = t2[a] = {}, f6 = Po(s), d6 = 0; d6 < f6.length; d6++) {
          var v6 = f6[d6];
          u[v6] = vb(s[v6]);
        }
    }
    function zWe(a, r6, t2) {
      for (var s = r6.transition, u = OA(s) ? lg : ll(s || []), f6 = 0; f6 < u.length; f6++) {
        var d6 = u[f6];
        if (!(d6 === "style" || d6 === "shape" || d6 === "extra")) {
          var v6 = a[d6];
          t2[d6] = v6;
        }
      }
    }
    function BWe(a, r6, t2) {
      for (var s = 0; s < ime.length; s++) {
        var u = ime[s], f6 = ame[u], d6 = r6[u];
        d6 && (t2[f6[0]] = d6[0], t2[f6[1]] = d6[1]);
      }
      for (var s = 0; s < lg.length; s++) {
        var v6 = lg[s];
        r6[v6] != null && (t2[v6] = r6[v6]);
      }
    }
    function jWe(a, r6, t2, s) {
      if (t2) {
        var u = a.style, f6;
        if (u) {
          var d6 = t2.transition, v6 = r6.transition;
          if (d6 && !OA(d6)) {
            var m6 = ll(d6);
            !f6 && (f6 = s.style = {});
            for (var b6 = 0; b6 < m6.length; b6++) {
              var x6 = m6[b6], S = u[x6];
              f6[x6] = S;
            }
          } else if (a.getAnimationStyleProps && (OA(v6) || OA(d6) || Vi(v6, "style") >= 0)) {
            var M = a.getAnimationStyleProps(), A6 = M ? M.style : null;
            if (A6) {
              !f6 && (f6 = s.style = {});
              for (var I = Po(t2), b6 = 0; b6 < I.length; b6++) {
                var x6 = I[b6];
                if (A6[x6]) {
                  var S = u[x6];
                  f6[x6] = S;
                }
              }
            }
          }
        }
      }
    }
    function GWe(a, r6) {
      return rd(a) ? a !== r6 : a != null && isFinite(a);
    }
    var ume = Xo(), WWe = ["percent", "easing", "shape", "style", "extra"];
    function cme(a) {
      a.stopAnimation("keyframe"), a.attr(ume(a));
    }
    function Iz(a, r6, t2) {
      if (!(!t2.isAnimationEnabled() || !r6)) {
        if (br(r6)) {
          Ne(r6, function(v6) {
            Iz(a, v6, t2);
          });
          return;
        }
        var s = r6.keyframes, u = r6.duration;
        if (t2 && u == null) {
          var f6 = U2("enter", t2, 0);
          u = f6 && f6.duration;
        }
        if (!(!s || !u)) {
          var d6 = ume(a);
          Ne(Mz, function(v6) {
            if (!(v6 && !a[v6])) {
              var m6;
              s.sort(function(b6, x6) {
                return b6.percent - x6.percent;
              }), Ne(s, function(b6) {
                var x6 = a.animators, S = v6 ? b6[v6] : b6;
                if (S) {
                  var M = Po(S);
                  if (v6 || (M = gl(M, function(R) {
                    return Vi(WWe, R) < 0;
                  })), !!M.length) {
                    m6 || (m6 = a.animate(v6, r6.loop, true), m6.scope = "keyframe");
                    for (var A6 = 0; A6 < x6.length; A6++)
                      x6[A6] !== m6 && x6[A6].targetName === m6.targetName && x6[A6].stopTracks(M);
                    v6 && (d6[v6] = d6[v6] || {});
                    var I = v6 ? d6[v6] : d6;
                    Ne(M, function(R) {
                      I[R] = ((v6 ? a[v6] : a) || {})[R];
                    }), m6.whenWithKeys(u * b6.percent, S, M, b6.easing);
                  }
                }
              }), m6 && m6.delay(r6.delay || 0).duration(u).start(r6.easing);
            }
          });
        }
      }
    }
    var Xx = "emphasis", uS = "normal", LK = "blur", OK = "select", cS = [uS, Xx, LK, OK], RK = { normal: ["itemStyle"], emphasis: [Xx, "itemStyle"], blur: [LK, "itemStyle"], select: [OK, "itemStyle"] }, FK = { normal: ["label"], emphasis: [Xx, "label"], blur: [LK, "label"], select: [OK, "label"] }, HWe = ["x", "y"], $We = "e\0\0", zm = { normal: {}, emphasis: {}, blur: {}, select: {} }, UWe = { cartesian2d: AWe, geo: IWe, singleAxis: DWe, polar: PWe, calendar: LWe };
    function NK(a) {
      return a instanceof uo;
    }
    function VK(a) {
      return a instanceof cg;
    }
    function qWe(a, r6) {
      r6.copyTransform(a), VK(r6) && VK(a) && (r6.setStyle(a.style), r6.z = a.z, r6.z2 = a.z2, r6.zlevel = a.zlevel, r6.invisible = a.invisible, r6.ignore = a.ignore, NK(r6) && NK(a) && r6.setShape(a.shape));
    }
    var YWe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        this._progressiveEls = null;
        var d6 = this._data, v6 = t2.getData(), m6 = this.group, b6 = hme(t2, v6, s, u);
        d6 || m6.removeAll(), v6.diff(d6).add(function(S) {
          jK(u, null, S, b6(S, f6), t2, m6, v6);
        }).remove(function(S) {
          var M = d6.getItemGraphicEl(S);
          Ez(M, Zx(M).option, t2);
        }).update(function(S, M) {
          var A6 = d6.getItemGraphicEl(M);
          jK(u, A6, S, b6(S, f6), t2, m6, v6);
        }).execute();
        var x6 = t2.get("clip", true) ? JV(t2.coordinateSystem, false, t2) : null;
        x6 ? m6.setClipPath(x6) : m6.removeClipPath(), this._data = v6;
      }, r6.prototype.incrementalPrepareRender = function(t2, s, u) {
        this.group.removeAll(), this._data = null;
      }, r6.prototype.incrementalRender = function(t2, s, u, f6, d6) {
        var v6 = s.getData(), m6 = hme(s, v6, u, f6), b6 = this._progressiveEls = [];
        function x6(A6) {
          A6.isGroup || (A6.incremental = true, A6.ensureState("emphasis").hoverLayer = true);
        }
        for (var S = t2.start; S < t2.end; S++) {
          var M = jK(null, null, S, m6(S, d6), s, this.group, v6);
          M && (M.traverse(x6), b6.push(M));
        }
      }, r6.prototype.eachRendered = function(t2) {
        s1(this._progressiveEls || this.group, t2);
      }, r6.prototype.filterForExposedEvent = function(t2, s, u, f6) {
        var d6 = s.element;
        if (d6 == null || u.name === d6)
          return true;
        for (; (u = u.__hostTarget || u.parent) && u !== this.group; )
          if (u.name === d6)
            return true;
        return false;
      }, r6.type = "custom", r6;
    }(bu), ZWe = YWe;
    function zK(a) {
      var r6 = a.type, t2;
      if (r6 === "path") {
        var s = a.shape, u = s.width != null && s.height != null ? { x: s.x || 0, y: s.y || 0, width: s.width, height: s.height } : null, f6 = mme(s);
        t2 = ie(f6, null, u, s.layout || "center"), Zx(t2).customPathData = f6;
      } else if (r6 === "image")
        t2 = new nh({}), Zx(t2).customImagePath = a.style.image;
      else if (r6 === "text")
        t2 = new ms({});
      else if (r6 === "group")
        t2 = new bi();
      else {
        if (r6 === "compoundPath")
          throw new Error('"compoundPath" is not supported yet.');
        var d6 = B(r6);
        if (!d6) {
          var v6 = "";
          Lo(v6);
        }
        t2 = new d6();
      }
      return Zx(t2).customGraphicType = r6, t2.name = a.name, t2.z2EmphasisLift = 1, t2.z2SelectLift = 1, t2;
    }
    function BK(a, r6, t2, s, u, f6, d6) {
      cme(r6);
      var v6 = u && u.normal.cfg;
      v6 && r6.setTextConfig(v6), s && s.transition == null && (s.transition = HWe);
      var m6 = s && s.style;
      if (m6) {
        if (r6.type === "text") {
          var b6 = m6;
          Da(b6, "textFill") && (b6.fill = b6.textFill), Da(b6, "textStroke") && (b6.stroke = b6.textStroke);
        }
        var x6 = void 0, S = NK(r6) ? m6.decal : null;
        a && S && (S.dirty = true, x6 = DR(S, a)), m6.__decalPattern = x6;
      }
      if (VK(r6) && m6) {
        var x6 = m6.__decalPattern;
        x6 && (m6.decal = x6);
      }
      Az(r6, s, f6, { dataIndex: t2, isInit: d6, clearStyle: true }), Iz(r6, s.keyframeAnimation, f6);
    }
    function fme(a, r6, t2, s, u) {
      var f6 = r6.isGroup ? null : r6, d6 = u && u[a].cfg;
      if (f6) {
        var v6 = f6.ensureState(a);
        if (s === false) {
          var m6 = f6.getState(a);
          m6 && (m6.style = null);
        } else
          v6.style = s || null;
        d6 && (v6.textConfig = d6), fg(f6);
      }
    }
    function XWe(a, r6, t2) {
      if (!a.isGroup) {
        var s = a, u = t2.currentZ, f6 = t2.currentZLevel;
        s.z = u, s.zlevel = f6;
        var d6 = r6.z2;
        d6 != null && (s.z2 = d6 || 0);
        for (var v6 = 0; v6 < cS.length; v6++)
          KWe(s, r6, cS[v6]);
      }
    }
    function KWe(a, r6, t2) {
      var s = t2 === uS, u = s ? r6 : Tz(r6, t2), f6 = u ? u.z2 : null, d6;
      f6 != null && (d6 = s ? a : a.ensureState(t2), d6.z2 = f6 || 0);
    }
    function hme(a, r6, t2, s) {
      var u = a.get("renderItem"), f6 = a.coordinateSystem, d6 = {};
      f6 && (d6 = f6.prepareCustoms ? f6.prepareCustoms(f6) : UWe[f6.type](f6));
      for (var v6 = ei({ getWidth: s.getWidth, getHeight: s.getHeight, getZr: s.getZr, getDevicePixelRatio: s.getDevicePixelRatio, value: U, style: ue, ordinalRawValue: he, styleEmphasis: pe, visual: Ae, barLayout: ke, currentSeriesIndices: je, font: Fe }, d6.api || {}), m6 = { context: {}, seriesId: a.id, seriesName: a.name, seriesIndex: a.seriesIndex, coordSys: d6.coordSys, dataInsideLength: r6.count(), encode: JWe(a.getData()) }, b6, x6, S = {}, M = {}, A6 = {}, I = {}, R = 0; R < cS.length; R++) {
        var F = cS[R];
        A6[F] = a.getModel(RK[F]), I[F] = a.getModel(FK[F]);
      }
      function j(at) {
        return at === b6 ? x6 || (x6 = r6.getItemModel(at)) : r6.getItemModel(at);
      }
      function $(at, ht) {
        return r6.hasItemOption ? at === b6 ? S[ht] || (S[ht] = j(at).getModel(RK[ht])) : j(at).getModel(RK[ht]) : A6[ht];
      }
      function K(at, ht) {
        return r6.hasItemOption ? at === b6 ? M[ht] || (M[ht] = j(at).getModel(FK[ht])) : j(at).getModel(FK[ht]) : I[ht];
      }
      return function(at, ht) {
        return b6 = at, x6 = null, S = {}, M = {}, u && u(ei({ dataIndexInside: at, dataIndex: r6.getRawIndex(at), actionType: ht ? ht.type : null }, m6), v6);
      };
      function U(at, ht) {
        return ht == null && (ht = b6), r6.getStore().get(r6.getDimensionIndex(at || 0), ht);
      }
      function he(at, ht) {
        ht == null && (ht = b6), at = at || 0;
        var Qe = r6.getDimensionInfo(at);
        if (!Qe) {
          var en = r6.getDimensionIndex(at);
          return en >= 0 ? r6.getStore().get(en, ht) : void 0;
        }
        var bt = r6.get(Qe.name, ht), wt = Qe && Qe.ordinalMeta;
        return wt ? wt.categories[bt] : bt;
      }
      function ue(at, ht) {
        ht == null && (ht = b6);
        var Qe = r6.getItemVisual(ht, "style"), en = Qe && Qe.fill, bt = Qe && Qe.opacity, wt = $(ht, uS).getItemStyle();
        en != null && (wt.fill = en), bt != null && (wt.opacity = bt);
        var Ft = { inheritColor: _a2(en) ? en : "#000" }, fn = K(ht, uS), gn = yf(fn, null, Ft, false, true);
        gn.text = fn.getShallow("show") ? qi(a.getFormattedLabel(ht, uS), p5(r6, ht)) : null;
        var Zr = eV(fn, Ft, false);
        return xe(at, wt), wt = nme(wt, gn, Zr), at && _e(wt, at), wt.legacy = true, wt;
      }
      function pe(at, ht) {
        ht == null && (ht = b6);
        var Qe = $(ht, Xx).getItemStyle(), en = K(ht, Xx), bt = yf(en, null, null, true, true);
        bt.text = en.getShallow("show") ? Uy(a.getFormattedLabel(ht, Xx), a.getFormattedLabel(ht, uS), p5(r6, ht)) : null;
        var wt = eV(en, null, true);
        return xe(at, Qe), Qe = nme(Qe, bt, wt), at && _e(Qe, at), Qe.legacy = true, Qe;
      }
      function _e(at, ht) {
        for (var Qe in ht)
          Da(ht, Qe) && (at[Qe] = ht[Qe]);
      }
      function xe(at, ht) {
        at && (at.textFill && (ht.textFill = at.textFill), at.textPosition && (ht.textPosition = at.textPosition));
      }
      function Ae(at, ht) {
        if (ht == null && (ht = b6), Da(J0e, at)) {
          var Qe = r6.getItemVisual(ht, "style");
          return Qe ? Qe[J0e[at]] : null;
        }
        if (Da(wWe, at))
          return r6.getItemVisual(ht, at);
      }
      function ke(at) {
        if (f6.type === "cartesian2d") {
          var ht = f6.getBaseAxis();
          return Q6e(ei({ axis: ht }, at));
        }
      }
      function je() {
        return t2.getCurrentSeriesIndices();
      }
      function Fe(at) {
        return Que(at, t2);
      }
    }
    function JWe(a) {
      var r6 = {};
      return Ne(a.dimensions, function(t2) {
        var s = a.getDimensionInfo(t2);
        if (!s.isExtraCoord) {
          var u = s.coordDim, f6 = r6[u] = r6[u] || [];
          f6[s.coordDimIndex] = a.getDimensionIndex(t2);
        }
      }), r6;
    }
    function jK(a, r6, t2, s, u, f6, d6) {
      if (!s) {
        f6.remove(r6);
        return;
      }
      var v6 = GK(a, r6, t2, s, u, f6);
      return v6 && d6.setItemGraphicEl(t2, v6), v6 && Cc(v6, s.focus, s.blurScope, s.emphasisDisabled), v6;
    }
    function GK(a, r6, t2, s, u, f6) {
      var d6 = -1, v6 = r6;
      r6 && dme(r6, s, u) && (d6 = Vi(f6.childrenRef(), r6), r6 = null);
      var m6 = !r6, b6 = r6;
      b6 ? b6.clearStates() : (b6 = zK(s), v6 && qWe(v6, b6)), s.morph === false ? b6.disableMorphing = true : b6.disableMorphing && (b6.disableMorphing = false), zm.normal.cfg = zm.normal.conOpt = zm.emphasis.cfg = zm.emphasis.conOpt = zm.blur.cfg = zm.blur.conOpt = zm.select.cfg = zm.select.conOpt = null, zm.isLegacy = false, eHe(b6, t2, s, u, m6, zm), QWe(b6, t2, s, u, m6), BK(a, b6, t2, s, zm, u, m6), Da(s, "info") && (Zx(b6).info = s.info);
      for (var x6 = 0; x6 < cS.length; x6++) {
        var S = cS[x6];
        if (S !== uS) {
          var M = Tz(s, S), A6 = WK(s, M, S);
          fme(S, b6, M, A6, zm);
        }
      }
      return XWe(b6, s, u), s.type === "group" && tHe(a, b6, t2, s, u), d6 >= 0 ? f6.replaceAt(b6, d6) : f6.add(b6), b6;
    }
    function dme(a, r6, t2) {
      var s = Zx(a), u = r6.type, f6 = r6.shape, d6 = r6.style;
      return t2.isUniversalTransitionEnabled() || u != null && u !== s.customGraphicType || u === "path" && aHe(f6) && mme(f6) !== s.customPathData || u === "image" && Da(d6, "image") && d6.image !== s.customImagePath;
    }
    function QWe(a, r6, t2, s, u) {
      var f6 = t2.clipPath;
      if (f6 === false)
        a && a.getClipPath() && a.removeClipPath();
      else if (f6) {
        var d6 = a.getClipPath();
        d6 && dme(d6, f6, s) && (d6 = null), d6 || (d6 = zK(f6), a.setClipPath(d6)), BK(null, d6, r6, f6, null, s, u);
      }
    }
    function eHe(a, r6, t2, s, u, f6) {
      if (!a.isGroup) {
        pme(t2, null, f6), pme(t2, Xx, f6);
        var d6 = f6.normal.conOpt, v6 = f6.emphasis.conOpt, m6 = f6.blur.conOpt, b6 = f6.select.conOpt;
        if (d6 != null || v6 != null || b6 != null || m6 != null) {
          var x6 = a.getTextContent();
          if (d6 === false)
            x6 && a.removeTextContent();
          else {
            d6 = f6.normal.conOpt = d6 || { type: "text" }, x6 ? x6.clearStates() : (x6 = zK(d6), a.setTextContent(x6)), BK(null, x6, r6, d6, null, s, u);
            for (var S = d6 && d6.style, M = 0; M < cS.length; M++) {
              var A6 = cS[M];
              if (A6 !== uS) {
                var I = f6[A6].conOpt;
                fme(A6, x6, I, WK(d6, I, A6), null);
              }
            }
            S ? x6.dirty() : x6.markRedraw();
          }
        }
      }
    }
    function pme(a, r6, t2) {
      var s = r6 ? Tz(a, r6) : a, u = r6 ? WK(a, s, Xx) : a.style, f6 = a.type, d6 = s ? s.textConfig : null, v6 = a.textContent, m6 = v6 ? r6 ? Tz(v6, r6) : v6 : null;
      if (u && (t2.isLegacy || Q0e(u, f6, !!d6, !!m6))) {
        t2.isLegacy = true;
        var b6 = eme(u, f6, !r6);
        !d6 && b6.textConfig && (d6 = b6.textConfig), !m6 && b6.textContent && (m6 = b6.textContent);
      }
      if (!r6 && m6) {
        var x6 = m6;
        !x6.type && (x6.type = "text");
      }
      var S = r6 ? t2[r6] : t2.normal;
      S.cfg = d6, S.conOpt = m6;
    }
    function Tz(a, r6) {
      return r6 ? a ? a[r6] : null : a;
    }
    function WK(a, r6, t2) {
      var s = r6 && r6.style;
      return s == null && t2 === Xx && a && (s = a.styleEmphasis), s;
    }
    function tHe(a, r6, t2, s, u) {
      var f6 = s.children, d6 = f6 ? f6.length : 0, v6 = s.$mergeChildren, m6 = v6 === "byName" || s.diffChildrenByName, b6 = v6 === false;
      if (!(!d6 && !m6 && !b6)) {
        if (m6) {
          nHe({ api: a, oldChildren: r6.children() || [], newChildren: f6 || [], dataIndex: t2, seriesModel: u, group: r6 });
          return;
        }
        b6 && r6.removeAll();
        for (var x6 = 0; x6 < d6; x6++)
          f6[x6] && GK(a, r6.childAt(x6), t2, f6[x6], u, r6);
        for (var S = r6.childCount() - 1; S >= x6; S--) {
          var M = r6.childAt(S);
          Ez(M, Zx(r6).option, u);
        }
      }
    }
    function nHe(a) {
      new Gx(a.oldChildren, a.newChildren, vme, vme, a).add(gme).update(gme).remove(rHe).execute();
    }
    function vme(a, r6) {
      var t2 = a && a.name;
      return t2 != null ? t2 : $We + r6;
    }
    function gme(a, r6) {
      var t2 = this.context, s = a != null ? t2.newChildren[a] : null, u = r6 != null ? t2.oldChildren[r6] : null;
      GK(t2.api, u, t2.dataIndex, s, t2.seriesModel, t2.group);
    }
    function rHe(a) {
      var r6 = this.context, t2 = r6.oldChildren[a];
      Ez(t2, Zx(t2).option, r6.seriesModel);
    }
    function mme(a) {
      return a && (a.pathData || a.d);
    }
    function aHe(a) {
      return a && (Da(a, "pathData") || Da(a, "d"));
    }
    function iHe(a) {
      a.registerChartView(ZWe), a.registerSeriesModel(CWe);
    }
    var RA = Xo(), yme = Qa, HK = Ca, oHe = function() {
      function a() {
        this._dragging = false, this.animationThreshold = 15;
      }
      return a.prototype.render = function(r6, t2, s, u) {
        var f6 = t2.get("value"), d6 = t2.get("status");
        if (this._axisModel = r6, this._axisPointerModel = t2, this._api = s, !(!u && this._lastValue === f6 && this._lastStatus === d6)) {
          this._lastValue = f6, this._lastStatus = d6;
          var v6 = this._group, m6 = this._handle;
          if (!d6 || d6 === "hide") {
            v6 && v6.hide(), m6 && m6.hide();
            return;
          }
          v6 && v6.show(), m6 && m6.show();
          var b6 = {};
          this.makeElOption(b6, f6, r6, t2, s);
          var x6 = b6.graphicKey;
          x6 !== this._lastGraphicKey && this.clear(s), this._lastGraphicKey = x6;
          var S = this._moveAnimation = this.determineAnimation(r6, t2);
          if (!v6)
            v6 = this._group = new bi(), this.createPointerEl(v6, b6, r6, t2), this.createLabelEl(v6, b6, r6, t2), s.getZr().add(v6);
          else {
            var M = Oi(bme, t2, S);
            this.updatePointerEl(v6, b6, M), this.updateLabelEl(v6, b6, M, t2);
          }
          wme(v6, t2, true), this._renderHandle(f6);
        }
      }, a.prototype.remove = function(r6) {
        this.clear(r6);
      }, a.prototype.dispose = function(r6) {
        this.clear(r6);
      }, a.prototype.determineAnimation = function(r6, t2) {
        var s = t2.get("animation"), u = r6.axis, f6 = u.type === "category", d6 = t2.get("snap");
        if (!d6 && !f6)
          return false;
        if (s === "auto" || s == null) {
          var v6 = this.animationThreshold;
          if (f6 && u.getBandWidth() > v6)
            return true;
          if (d6) {
            var m6 = yX(r6).seriesDataCount, b6 = u.getExtent();
            return Math.abs(b6[0] - b6[1]) / m6 > v6;
          }
          return false;
        }
        return s === true;
      }, a.prototype.makeElOption = function(r6, t2, s, u, f6) {
      }, a.prototype.createPointerEl = function(r6, t2, s, u) {
        var f6 = t2.pointer;
        if (f6) {
          var d6 = RA(r6).pointerEl = new fR[f6.type](yme(t2.pointer));
          r6.add(d6);
        }
      }, a.prototype.createLabelEl = function(r6, t2, s, u) {
        if (t2.label) {
          var f6 = RA(r6).labelEl = new ms(yme(t2.label));
          r6.add(f6), xme(f6, u);
        }
      }, a.prototype.updatePointerEl = function(r6, t2, s) {
        var u = RA(r6).pointerEl;
        u && t2.pointer && (u.setStyle(t2.pointer.style), s(u, { shape: t2.pointer.shape }));
      }, a.prototype.updateLabelEl = function(r6, t2, s, u) {
        var f6 = RA(r6).labelEl;
        f6 && (f6.setStyle(t2.label.style), s(f6, { x: t2.label.x, y: t2.label.y }), xme(f6, u));
      }, a.prototype._renderHandle = function(r6) {
        if (!(this._dragging || !this.updateHandleTransform)) {
          var t2 = this._axisPointerModel, s = this._api.getZr(), u = this._handle, f6 = t2.getModel("handle"), d6 = t2.get("status");
          if (!f6.get("show") || !d6 || d6 === "hide") {
            u && s.remove(u), this._handle = null;
            return;
          }
          var v6;
          this._handle || (v6 = true, u = this._handle = ys(f6.get("icon"), { cursor: "move", draggable: true, onmousemove: function(b6) {
            vm(b6.event);
          }, onmousedown: HK(this._onHandleDragMove, this, 0, 0), drift: HK(this._onHandleDragMove, this), ondragend: HK(this._onHandleDragEnd, this) }), s.add(u)), wme(u, t2, false), u.setStyle(f6.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
          var m6 = f6.get("size");
          br(m6) || (m6 = [m6, m6]), u.scaleX = m6[0] / 2, u.scaleY = m6[1] / 2, i5(this, "_doDispatchAxisPointer", f6.get("throttle") || 0, "fixRate"), this._moveHandleToValue(r6, v6);
        }
      }, a.prototype._moveHandleToValue = function(r6, t2) {
        bme(this._axisPointerModel, !t2 && this._moveAnimation, this._handle, $K(this.getHandleTransform(r6, this._axisModel, this._axisPointerModel)));
      }, a.prototype._onHandleDragMove = function(r6, t2) {
        var s = this._handle;
        if (s) {
          this._dragging = true;
          var u = this.updateHandleTransform($K(s), [r6, t2], this._axisModel, this._axisPointerModel);
          this._payloadInfo = u, s.stopAnimation(), s.attr($K(u)), RA(s).lastProp = null, this._doDispatchAxisPointer();
        }
      }, a.prototype._doDispatchAxisPointer = function() {
        var r6 = this._handle;
        if (r6) {
          var t2 = this._payloadInfo, s = this._axisModel;
          this._api.dispatchAction({ type: "updateAxisPointer", x: t2.cursorPoint[0], y: t2.cursorPoint[1], tooltipOption: t2.tooltipOption, axesInfo: [{ axisDim: s.axis.dim, axisIndex: s.componentIndex }] });
        }
      }, a.prototype._onHandleDragEnd = function() {
        this._dragging = false;
        var r6 = this._handle;
        if (r6) {
          var t2 = this._axisPointerModel.get("value");
          this._moveHandleToValue(t2), this._api.dispatchAction({ type: "hideTip" });
        }
      }, a.prototype.clear = function(r6) {
        this._lastValue = null, this._lastStatus = null;
        var t2 = r6.getZr(), s = this._group, u = this._handle;
        t2 && s && (this._lastGraphicKey = null, s && t2.remove(s), u && t2.remove(u), this._group = null, this._handle = null, this._payloadInfo = null), CR(this, "_doDispatchAxisPointer");
      }, a.prototype.doClear = function() {
      }, a.prototype.buildLabel = function(r6, t2, s) {
        return s = s || 0, { x: r6[s], y: r6[1 - s], width: t2[s], height: t2[1 - s] };
      }, a;
    }();
    function bme(a, r6, t2, s) {
      _me(RA(t2).lastProp, s) || (RA(t2).lastProp = s, r6 ? fs(t2, s, a) : (t2.stopAnimation(), t2.attr(s)));
    }
    function _me(a, r6) {
      if (ui(a) && ui(r6)) {
        var t2 = true;
        return Ne(r6, function(s, u) {
          t2 = t2 && _me(a[u], s);
        }), !!t2;
      } else
        return a === r6;
    }
    function xme(a, r6) {
      a[r6.get(["label", "show"]) ? "show" : "hide"]();
    }
    function $K(a) {
      return { x: a.x || 0, y: a.y || 0, rotation: a.rotation || 0 };
    }
    function wme(a, r6, t2) {
      var s = r6.get("z"), u = r6.get("zlevel");
      a && a.traverse(function(f6) {
        f6.type !== "group" && (s != null && (f6.z = s), u != null && (f6.zlevel = u), f6.silent = t2);
      });
    }
    var UK = oHe;
    function qK(a) {
      var r6 = a.get("type"), t2 = a.getModel(r6 + "Style"), s;
      return r6 === "line" ? (s = t2.getLineStyle(), s.fill = null) : r6 === "shadow" && (s = t2.getAreaStyle(), s.stroke = null), s;
    }
    function Sme(a, r6, t2, s, u) {
      var f6 = t2.get("value"), d6 = Cme(f6, r6.axis, r6.ecModel, t2.get("seriesDataIndices"), { precision: t2.get(["label", "precision"]), formatter: t2.get(["label", "formatter"]) }), v6 = t2.getModel("label"), m6 = KD(v6.get("padding") || 0), b6 = v6.getFont(), x6 = bx(d6, b6), S = u.position, M = x6.width + m6[1] + m6[3], A6 = x6.height + m6[0] + m6[2], I = u.align;
      I === "right" && (S[0] -= M), I === "center" && (S[0] -= M / 2);
      var R = u.verticalAlign;
      R === "bottom" && (S[1] -= A6), R === "middle" && (S[1] -= A6 / 2), sHe(S, M, A6, s);
      var F = v6.get("backgroundColor");
      (!F || F === "auto") && (F = r6.get(["axisLine", "lineStyle", "color"])), a.label = { x: S[0], y: S[1], style: yf(v6, { text: d6, font: b6, fill: v6.getTextColor(), padding: m6, backgroundColor: F }), z2: 10 };
    }
    function sHe(a, r6, t2, s) {
      var u = s.getWidth(), f6 = s.getHeight();
      a[0] = Math.min(a[0] + r6, u) - r6, a[1] = Math.min(a[1] + t2, f6) - t2, a[0] = Math.max(a[0], 0), a[1] = Math.max(a[1], 0);
    }
    function Cme(a, r6, t2, s, u) {
      a = r6.scale.parse(a);
      var f6 = r6.scale.getLabel({ value: a }, { precision: u.precision }), d6 = u.formatter;
      if (d6) {
        var v6 = { value: BZ(r6, { value: a }), axisDimension: r6.dim, axisIndex: r6.index, seriesData: [] };
        Ne(s, function(m6) {
          var b6 = t2.getSeriesByIndex(m6.seriesIndex), x6 = m6.dataIndexInside, S = b6 && b6.getDataParams(x6);
          S && v6.seriesData.push(S);
        }), _a2(d6) ? f6 = d6.replace("{value}", f6) : ti(d6) && (f6 = d6(v6));
      }
      return f6;
    }
    function YK(a, r6, t2) {
      var s = og();
      return yb(s, s, t2.rotation), sg(s, s, t2.position), Yr([a.dataToCoord(r6), (t2.labelOffset || 0) + (t2.labelDirection || 1) * (t2.labelMargin || 0)], s);
    }
    function Mme(a, r6, t2, s, u, f6) {
      var d6 = Ux.innerTextLayout(t2.rotation, 0, t2.labelDirection);
      t2.labelMargin = u.get(["label", "margin"]), Sme(r6, s, u, f6, { position: YK(s.axis, a, t2), align: d6.textAlign, verticalAlign: d6.textVerticalAlign });
    }
    function ZK(a, r6, t2) {
      return t2 = t2 || 0, { x1: a[t2], y1: a[1 - t2], x2: r6[t2], y2: r6[1 - t2] };
    }
    function Ame(a, r6, t2) {
      return t2 = t2 || 0, { x: a[t2], y: a[1 - t2], width: r6[t2], height: r6[1 - t2] };
    }
    function Eme(a, r6, t2, s, u, f6) {
      return { cx: a, cy: r6, r0: t2, r: s, startAngle: u, endAngle: f6, clockwise: true };
    }
    var lHe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.makeElOption = function(t2, s, u, f6, d6) {
        var v6 = u.axis, m6 = v6.grid, b6 = f6.get("type"), x6 = Ime(m6, v6).getOtherAxis(v6).getGlobalExtent(), S = v6.toGlobalCoord(v6.dataToCoord(s, true));
        if (b6 && b6 !== "none") {
          var M = qK(f6), A6 = uHe[b6](v6, S, x6);
          A6.style = M, t2.graphicKey = A6.type, t2.pointer = A6;
        }
        var I = pX(m6.model, u);
        Mme(s, t2, I, u, f6, d6);
      }, r6.prototype.getHandleTransform = function(t2, s, u) {
        var f6 = pX(s.axis.grid.model, s, { labelInside: false });
        f6.labelMargin = u.get(["handle", "margin"]);
        var d6 = YK(s.axis, t2, f6);
        return { x: d6[0], y: d6[1], rotation: f6.rotation + (f6.labelDirection < 0 ? Math.PI : 0) };
      }, r6.prototype.updateHandleTransform = function(t2, s, u, f6) {
        var d6 = u.axis, v6 = d6.grid, m6 = d6.getGlobalExtent(true), b6 = Ime(v6, d6).getOtherAxis(d6).getGlobalExtent(), x6 = d6.dim === "x" ? 0 : 1, S = [t2.x, t2.y];
        S[x6] += s[x6], S[x6] = Math.min(m6[1], S[x6]), S[x6] = Math.max(m6[0], S[x6]);
        var M = (b6[1] + b6[0]) / 2, A6 = [M, M];
        A6[x6] = S[x6];
        var I = [{ verticalAlign: "middle" }, { align: "center" }];
        return { x: S[0], y: S[1], rotation: t2.rotation, cursorPoint: A6, tooltipOption: I[x6] };
      }, r6;
    }(UK);
    function Ime(a, r6) {
      var t2 = {};
      return t2[r6.dim + "AxisIndex"] = r6.index, a.getCartesian(t2);
    }
    var uHe = { line: function(a, r6, t2) {
      var s = ZK([r6, t2[0]], [r6, t2[1]], Tme(a));
      return { type: "Line", subPixelOptimize: true, shape: s };
    }, shadow: function(a, r6, t2) {
      var s = Math.max(1, a.getBandWidth()), u = t2[1] - t2[0];
      return { type: "Rect", shape: Ame([r6 - s / 2, t2[0]], [s, u], Tme(a)) };
    } };
    function Tme(a) {
      return a.dim === "x" ? 0 : 1;
    }
    var cHe = lHe, fHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "axisPointer", r6.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, r6;
    }(Ps), hHe = fHe, Kx = Xo(), dHe = Ne;
    function Dme(a, r6, t2) {
      if (!ha.node) {
        var s = r6.getZr();
        Kx(s).records || (Kx(s).records = {}), pHe(s, r6);
        var u = Kx(s).records[a] || (Kx(s).records[a] = {});
        u.handler = t2;
      }
    }
    function pHe(a, r6) {
      if (Kx(a).initialized)
        return;
      Kx(a).initialized = true, t2("click", Oi(kme, "click")), t2("mousemove", Oi(kme, "mousemove")), t2("globalout", gHe);
      function t2(s, u) {
        a.on(s, function(f6) {
          var d6 = mHe(r6);
          dHe(Kx(a).records, function(v6) {
            v6 && u(v6, f6, d6.dispatchAction);
          }), vHe(d6.pendings, r6);
        });
      }
    }
    function vHe(a, r6) {
      var t2 = a.showTip.length, s = a.hideTip.length, u;
      t2 ? u = a.showTip[t2 - 1] : s && (u = a.hideTip[s - 1]), u && (u.dispatchAction = null, r6.dispatchAction(u));
    }
    function gHe(a, r6, t2) {
      a.handler("leave", null, t2);
    }
    function kme(a, r6, t2, s) {
      r6.handler(a, t2, s);
    }
    function mHe(a) {
      var r6 = { showTip: [], hideTip: [] }, t2 = function(s) {
        var u = r6[s.type];
        u ? u.push(s) : (s.dispatchAction = t2, a.dispatchAction(s));
      };
      return { dispatchAction: t2, pendings: r6 };
    }
    function XK(a, r6) {
      if (!ha.node) {
        var t2 = r6.getZr(), s = (Kx(t2).records || {})[a];
        s && (Kx(t2).records[a] = null);
      }
    }
    var yHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = s.getComponent("tooltip"), d6 = t2.get("triggerOn") || f6 && f6.get("triggerOn") || "mousemove|click";
        Dme("axisPointer", u, function(v6, m6, b6) {
          d6 !== "none" && (v6 === "leave" || d6.indexOf(v6) >= 0) && b6({ type: "updateAxisPointer", currTrigger: v6, x: m6 && m6.offsetX, y: m6 && m6.offsetY });
        });
      }, r6.prototype.remove = function(t2, s) {
        XK("axisPointer", s);
      }, r6.prototype.dispose = function(t2, s) {
        XK("axisPointer", s);
      }, r6.type = "axisPointer", r6;
    }(Rc), bHe = yHe;
    function Pme(a, r6) {
      var t2 = [], s = a.seriesIndex, u;
      if (s == null || !(u = r6.getSeriesByIndex(s)))
        return { point: [] };
      var f6 = u.getData(), d6 = xx(f6, a);
      if (d6 == null || d6 < 0 || br(d6))
        return { point: [] };
      var v6 = f6.getItemGraphicEl(d6), m6 = u.coordinateSystem;
      if (u.getTooltipPosition)
        t2 = u.getTooltipPosition(d6) || [];
      else if (m6 && m6.dataToPoint)
        if (a.isStacked) {
          var b6 = m6.getBaseAxis(), x6 = m6.getOtherAxis(b6), S = x6.dim, M = b6.dim, A6 = S === "x" || S === "radius" ? 1 : 0, I = f6.mapDimension(M), R = [];
          R[A6] = f6.get(I, d6), R[1 - A6] = f6.get(f6.getCalculationInfo("stackResultDimension"), d6), t2 = m6.dataToPoint(R) || [];
        } else
          t2 = m6.dataToPoint(f6.getValues(wr(m6.dimensions, function(j) {
            return f6.mapDimension(j);
          }), d6)) || [];
      else if (v6) {
        var F = v6.getBoundingRect().clone();
        F.applyTransform(v6.transform), t2 = [F.x + F.width / 2, F.y + F.height / 2];
      }
      return { point: t2, el: v6 };
    }
    var Lme = Xo();
    function _He(a, r6, t2) {
      var s = a.currTrigger, u = [a.x, a.y], f6 = a, d6 = a.dispatchAction || Ca(t2.dispatchAction, t2), v6 = r6.getComponent("axisPointer").coordSysAxesInfo;
      if (v6) {
        Dz(u) && (u = Pme({ seriesIndex: f6.seriesIndex, dataIndex: f6.dataIndex }, r6).point);
        var m6 = Dz(u), b6 = f6.axesInfo, x6 = v6.axesInfo, S = s === "leave" || Dz(u), M = {}, A6 = {}, I = { list: [], map: {} }, R = { showPointer: Oi(wHe, A6), showTooltip: Oi(SHe, I) };
        Ne(v6.coordSysMap, function(j, $) {
          var K = m6 || j.containPoint(u);
          Ne(v6.coordSysAxesInfo[$], function(U, he) {
            var ue = U.axis, pe = EHe(b6, U);
            if (!S && K && (!b6 || pe)) {
              var _e = pe && pe.value;
              _e == null && !m6 && (_e = ue.pointToData(u)), _e != null && Ome(U, _e, R, false, M);
            }
          });
        });
        var F = {};
        return Ne(x6, function(j, $) {
          var K = j.linkGroup;
          K && !A6[$] && Ne(K.axesInfo, function(U, he) {
            var ue = A6[he];
            if (U !== j && ue) {
              var pe = ue.value;
              K.mapper && (pe = j.axis.scale.parse(K.mapper(pe, Rme(U), Rme(j)))), F[j.key] = pe;
            }
          });
        }), Ne(F, function(j, $) {
          Ome(x6[$], j, R, true, M);
        }), CHe(A6, x6, M), MHe(I, u, a, d6), AHe(x6, d6, t2), M;
      }
    }
    function Ome(a, r6, t2, s, u) {
      var f6 = a.axis;
      if (!(f6.scale.isBlank() || !f6.containData(r6))) {
        if (!a.involveSeries) {
          t2.showPointer(a, r6);
          return;
        }
        var d6 = xHe(r6, a), v6 = d6.payloadBatch, m6 = d6.snapToValue;
        v6[0] && u.seriesIndex == null && qn(u, v6[0]), !s && a.snap && f6.containData(m6) && m6 != null && (r6 = m6), t2.showPointer(a, r6, v6), t2.showTooltip(a, d6, m6);
      }
    }
    function xHe(a, r6) {
      var t2 = r6.axis, s = t2.dim, u = a, f6 = [], d6 = Number.MAX_VALUE, v6 = -1;
      return Ne(r6.seriesModels, function(m6, b6) {
        var x6 = m6.getData().mapDimensionsAll(s), S, M;
        if (m6.getAxisTooltipData) {
          var A6 = m6.getAxisTooltipData(x6, a, t2);
          M = A6.dataIndices, S = A6.nestestValue;
        } else {
          if (M = m6.getData().indicesOfNearest(x6[0], a, t2.type === "category" ? 0.5 : null), !M.length)
            return;
          S = m6.getData().get(x6[0], M[0]);
        }
        if (!(S == null || !isFinite(S))) {
          var I = a - S, R = Math.abs(I);
          R <= d6 && ((R < d6 || I >= 0 && v6 < 0) && (d6 = R, v6 = I, u = S, f6.length = 0), Ne(M, function(F) {
            f6.push({ seriesIndex: m6.seriesIndex, dataIndexInside: F, dataIndex: m6.getData().getRawIndex(F) });
          }));
        }
      }), { payloadBatch: f6, snapToValue: u };
    }
    function wHe(a, r6, t2, s) {
      a[r6.key] = { value: t2, payloadBatch: s };
    }
    function SHe(a, r6, t2, s) {
      var u = t2.payloadBatch, f6 = r6.axis, d6 = f6.model, v6 = r6.axisPointerModel;
      if (!(!r6.triggerTooltip || !u.length)) {
        var m6 = r6.coordSys.model, b6 = e4(m6), x6 = a.map[b6];
        x6 || (x6 = a.map[b6] = { coordSysId: m6.id, coordSysIndex: m6.componentIndex, coordSysType: m6.type, coordSysMainType: m6.mainType, dataByAxis: [] }, a.list.push(x6)), x6.dataByAxis.push({ axisDim: f6.dim, axisIndex: d6.componentIndex, axisType: d6.type, axisId: d6.id, value: s, valueLabelOpt: { precision: v6.get(["label", "precision"]), formatter: v6.get(["label", "formatter"]) }, seriesDataIndices: u.slice() });
      }
    }
    function CHe(a, r6, t2) {
      var s = t2.axesInfo = [];
      Ne(r6, function(u, f6) {
        var d6 = u.axisPointerModel.option, v6 = a[f6];
        v6 ? (!u.useHandle && (d6.status = "show"), d6.value = v6.value, d6.seriesDataIndices = (v6.payloadBatch || []).slice()) : !u.useHandle && (d6.status = "hide"), d6.status === "show" && s.push({ axisDim: u.axis.dim, axisIndex: u.axis.model.componentIndex, value: d6.value });
      });
    }
    function MHe(a, r6, t2, s) {
      if (Dz(r6) || !a.list.length) {
        s({ type: "hideTip" });
        return;
      }
      var u = ((a.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
      s({ type: "showTip", escapeConnect: true, x: r6[0], y: r6[1], tooltipOption: t2.tooltipOption, position: t2.position, dataIndexInside: u.dataIndexInside, dataIndex: u.dataIndex, seriesIndex: u.seriesIndex, dataByCoordSys: a.list });
    }
    function AHe(a, r6, t2) {
      var s = t2.getZr(), u = "axisPointerLastHighlights", f6 = Lme(s)[u] || {}, d6 = Lme(s)[u] = {};
      Ne(a, function(b6, x6) {
        var S = b6.axisPointerModel.option;
        S.status === "show" && Ne(S.seriesDataIndices, function(M) {
          var A6 = M.seriesIndex + " | " + M.dataIndex;
          d6[A6] = M;
        });
      });
      var v6 = [], m6 = [];
      Ne(f6, function(b6, x6) {
        !d6[x6] && m6.push(b6);
      }), Ne(d6, function(b6, x6) {
        !f6[x6] && v6.push(b6);
      }), m6.length && t2.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: m6 }), v6.length && t2.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: v6 });
    }
    function EHe(a, r6) {
      for (var t2 = 0; t2 < (a || []).length; t2++) {
        var s = a[t2];
        if (r6.axis.dim === s.axisDim && r6.axis.model.componentIndex === s.axisIndex)
          return s;
      }
    }
    function Rme(a) {
      var r6 = a.axis.model, t2 = {}, s = t2.axisDim = a.axis.dim;
      return t2.axisIndex = t2[s + "AxisIndex"] = r6.componentIndex, t2.axisName = t2[s + "AxisName"] = r6.name, t2.axisId = t2[s + "AxisId"] = r6.id, t2;
    }
    function Dz(a) {
      return !a || a[0] == null || isNaN(a[0]) || a[1] == null || isNaN(a[1]);
    }
    function y42(a) {
      MA.registerAxisPointerClass("CartesianAxisPointer", cHe), a.registerComponentModel(hHe), a.registerComponentView(bHe), a.registerPreprocessor(function(r6) {
        if (r6) {
          (!r6.axisPointer || r6.axisPointer.length === 0) && (r6.axisPointer = {});
          var t2 = r6.axisPointer.link;
          t2 && !br(t2) && (r6.axisPointer.link = [t2]);
        }
      }), a.registerProcessor(a.PRIORITY.PROCESSOR.STATISTIC, function(r6, t2) {
        r6.getComponent("axisPointer").coordSysAxesInfo = v9e(r6, t2);
      }), a.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, _He);
    }
    function IHe(a) {
      bo(cve), bo(y42);
    }
    var THe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.makeElOption = function(t2, s, u, f6, d6) {
        var v6 = u.axis;
        v6.dim === "angle" && (this.animationThreshold = Math.PI / 18);
        var m6 = v6.polar, b6 = m6.getOtherAxis(v6), x6 = b6.getExtent(), S = v6.dataToCoord(s), M = f6.get("type");
        if (M && M !== "none") {
          var A6 = qK(f6), I = kHe[M](v6, m6, S, x6);
          I.style = A6, t2.graphicKey = I.type, t2.pointer = I;
        }
        var R = f6.get(["label", "margin"]), F = DHe(s, u, f6, m6, R);
        Sme(t2, u, f6, d6, F);
      }, r6;
    }(UK);
    function DHe(a, r6, t2, s, u) {
      var f6 = r6.axis, d6 = f6.dataToCoord(a), v6 = s.getAngleAxis().getExtent()[0];
      v6 = v6 / 180 * Math.PI;
      var m6 = s.getRadiusAxis().getExtent(), b6, x6, S;
      if (f6.dim === "radius") {
        var M = og();
        yb(M, M, v6), sg(M, M, [s.cx, s.cy]), b6 = Yr([d6, -u], M);
        var A6 = r6.getModel("axisLabel").get("rotate") || 0, I = Ux.innerTextLayout(v6, A6 * Math.PI / 180, -1);
        x6 = I.textAlign, S = I.textVerticalAlign;
      } else {
        var R = m6[1];
        b6 = s.coordToPoint([R + u, d6]);
        var F = s.cx, j = s.cy;
        x6 = Math.abs(b6[0] - F) / R < 0.3 ? "center" : b6[0] > F ? "left" : "right", S = Math.abs(b6[1] - j) / R < 0.3 ? "middle" : b6[1] > j ? "top" : "bottom";
      }
      return { position: b6, align: x6, verticalAlign: S };
    }
    var kHe = { line: function(a, r6, t2, s) {
      return a.dim === "angle" ? { type: "Line", shape: ZK(r6.coordToPoint([s[0], t2]), r6.coordToPoint([s[1], t2])) } : { type: "Circle", shape: { cx: r6.cx, cy: r6.cy, r: t2 } };
    }, shadow: function(a, r6, t2, s) {
      var u = Math.max(1, a.getBandWidth()), f6 = Math.PI / 180;
      return a.dim === "angle" ? { type: "Sector", shape: Eme(r6.cx, r6.cy, s[0], s[1], (-t2 - u / 2) * f6, (-t2 + u / 2) * f6) } : { type: "Sector", shape: Eme(r6.cx, r6.cy, t2 - u / 2, t2 + u / 2, 0, Math.PI * 2) };
    } }, PHe = THe, LHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.findAxisModel = function(t2) {
        var s, u = this.ecModel;
        return u.eachComponent(t2, function(f6) {
          f6.getCoordSysModel() === this && (s = f6);
        }, this), s;
      }, r6.type = "polar", r6.dependencies = ["radiusAxis", "angleAxis"], r6.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, r6;
    }(Ps), OHe = LHe, KK = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.getCoordSysModel = function() {
        return this.getReferringComponents("polar", Lc).models[0];
      }, r6.type = "polarAxis", r6;
    }(Ps);
    Dc(KK, GR);
    var RHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "angleAxis", r6;
    }(KK), FHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "radiusAxis", r6;
    }(KK), JK = function(a) {
      tt(r6, a);
      function r6(t2, s) {
        return a.call(this, "radius", t2, s) || this;
      }
      return r6.prototype.pointToData = function(t2, s) {
        return this.polar.pointToData(t2, s)[this.dim === "radius" ? 0 : 1];
      }, r6;
    }(c1);
    JK.prototype.dataToRadius = c1.prototype.dataToCoord, JK.prototype.radiusToData = c1.prototype.coordToData;
    var NHe = JK, VHe = Xo(), QK = function(a) {
      tt(r6, a);
      function r6(t2, s) {
        return a.call(this, "angle", t2, s || [0, 360]) || this;
      }
      return r6.prototype.pointToData = function(t2, s) {
        return this.polar.pointToData(t2, s)[this.dim === "radius" ? 0 : 1];
      }, r6.prototype.calculateCategoryInterval = function() {
        var t2 = this, s = t2.getLabelModel(), u = t2.scale, f6 = u.getExtent(), d6 = u.count();
        if (f6[1] - f6[0] < 1)
          return 0;
        var v6 = f6[0], m6 = t2.dataToCoord(v6 + 1) - t2.dataToCoord(v6), b6 = Math.abs(m6), x6 = bx(v6 == null ? "" : v6 + "", s.getFont(), "center", "top"), S = Math.max(x6.height, 7), M = S / b6;
        isNaN(M) && (M = 1 / 0);
        var A6 = Math.max(0, Math.floor(M)), I = VHe(t2.model), R = I.lastAutoInterval, F = I.lastTickCount;
        return R != null && F != null && Math.abs(R - A6) <= 1 && Math.abs(F - d6) <= 1 && R > A6 ? A6 = R : (I.lastTickCount = d6, I.lastAutoInterval = A6), A6;
      }, r6;
    }(c1);
    QK.prototype.dataToAngle = c1.prototype.dataToCoord, QK.prototype.angleToData = c1.prototype.coordToData;
    var zHe = QK, Fme = ["radius", "angle"], BHe = function() {
      function a(r6) {
        this.dimensions = Fme, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new NHe(), this._angleAxis = new zHe(), this.axisPointerEnabled = true, this.name = r6 || "", this._radiusAxis.polar = this._angleAxis.polar = this;
      }
      return a.prototype.containPoint = function(r6) {
        var t2 = this.pointToCoord(r6);
        return this._radiusAxis.contain(t2[0]) && this._angleAxis.contain(t2[1]);
      }, a.prototype.containData = function(r6) {
        return this._radiusAxis.containData(r6[0]) && this._angleAxis.containData(r6[1]);
      }, a.prototype.getAxis = function(r6) {
        var t2 = "_" + r6 + "Axis";
        return this[t2];
      }, a.prototype.getAxes = function() {
        return [this._radiusAxis, this._angleAxis];
      }, a.prototype.getAxesByScale = function(r6) {
        var t2 = [], s = this._angleAxis, u = this._radiusAxis;
        return s.scale.type === r6 && t2.push(s), u.scale.type === r6 && t2.push(u), t2;
      }, a.prototype.getAngleAxis = function() {
        return this._angleAxis;
      }, a.prototype.getRadiusAxis = function() {
        return this._radiusAxis;
      }, a.prototype.getOtherAxis = function(r6) {
        var t2 = this._angleAxis;
        return r6 === t2 ? this._radiusAxis : t2;
      }, a.prototype.getBaseAxis = function() {
        return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
      }, a.prototype.getTooltipAxes = function(r6) {
        var t2 = r6 != null && r6 !== "auto" ? this.getAxis(r6) : this.getBaseAxis();
        return { baseAxes: [t2], otherAxes: [this.getOtherAxis(t2)] };
      }, a.prototype.dataToPoint = function(r6, t2) {
        return this.coordToPoint([this._radiusAxis.dataToRadius(r6[0], t2), this._angleAxis.dataToAngle(r6[1], t2)]);
      }, a.prototype.pointToData = function(r6, t2) {
        var s = this.pointToCoord(r6);
        return [this._radiusAxis.radiusToData(s[0], t2), this._angleAxis.angleToData(s[1], t2)];
      }, a.prototype.pointToCoord = function(r6) {
        var t2 = r6[0] - this.cx, s = r6[1] - this.cy, u = this.getAngleAxis(), f6 = u.getExtent(), d6 = Math.min(f6[0], f6[1]), v6 = Math.max(f6[0], f6[1]);
        u.inverse ? d6 = v6 - 360 : v6 = d6 + 360;
        var m6 = Math.sqrt(t2 * t2 + s * s);
        t2 /= m6, s /= m6;
        for (var b6 = Math.atan2(-s, t2) / Math.PI * 180, x6 = b6 < d6 ? 1 : -1; b6 < d6 || b6 > v6; )
          b6 += x6 * 360;
        return [m6, b6];
      }, a.prototype.coordToPoint = function(r6) {
        var t2 = r6[0], s = r6[1] / 180 * Math.PI, u = Math.cos(s) * t2 + this.cx, f6 = -Math.sin(s) * t2 + this.cy;
        return [u, f6];
      }, a.prototype.getArea = function() {
        var r6 = this.getAngleAxis(), t2 = this.getRadiusAxis(), s = t2.getExtent().slice();
        s[0] > s[1] && s.reverse();
        var u = r6.getExtent(), f6 = Math.PI / 180;
        return { cx: this.cx, cy: this.cy, r0: s[0], r: s[1], startAngle: -u[0] * f6, endAngle: -u[1] * f6, clockwise: r6.inverse, contain: function(d6, v6) {
          var m6 = d6 - this.cx, b6 = v6 - this.cy, x6 = m6 * m6 + b6 * b6 - 1e-4, S = this.r, M = this.r0;
          return x6 <= S * S && x6 >= M * M;
        } };
      }, a.prototype.convertToPixel = function(r6, t2, s) {
        var u = Nme(t2);
        return u === this ? this.dataToPoint(s) : null;
      }, a.prototype.convertFromPixel = function(r6, t2, s) {
        var u = Nme(t2);
        return u === this ? this.pointToData(s) : null;
      }, a;
    }();
    function Nme(a) {
      var r6 = a.seriesModel, t2 = a.polarModel;
      return t2 && t2.coordinateSystem || r6 && r6.coordinateSystem;
    }
    var jHe = BHe;
    function GHe(a, r6, t2) {
      var s = r6.get("center"), u = t2.getWidth(), f6 = t2.getHeight();
      a.cx = ua(s[0], u), a.cy = ua(s[1], f6);
      var d6 = a.getRadiusAxis(), v6 = Math.min(u, f6) / 2, m6 = r6.get("radius");
      m6 == null ? m6 = [0, "100%"] : br(m6) || (m6 = [0, m6]);
      var b6 = [ua(m6[0], v6), ua(m6[1], v6)];
      d6.inverse ? d6.setExtent(b6[1], b6[0]) : d6.setExtent(b6[0], b6[1]);
    }
    function WHe(a, r6) {
      var t2 = this, s = t2.getAngleAxis(), u = t2.getRadiusAxis();
      if (s.scale.setExtent(1 / 0, -1 / 0), u.scale.setExtent(1 / 0, -1 / 0), a.eachSeries(function(v6) {
        if (v6.coordinateSystem === t2) {
          var m6 = v6.getData();
          Ne(HV(m6, "radius"), function(b6) {
            u.scale.unionExtentFromData(m6, b6);
          }), Ne(HV(m6, "angle"), function(b6) {
            s.scale.unionExtentFromData(m6, b6);
          });
        }
      }), h5(s.scale, s.model), h5(u.scale, u.model), s.type === "category" && !s.onBand) {
        var f6 = s.getExtent(), d6 = 360 / s.scale.count();
        s.inverse ? f6[1] += d6 : f6[1] -= d6, s.setExtent(f6[0], f6[1]);
      }
    }
    function HHe(a) {
      return a.mainType === "angleAxis";
    }
    function Vme(a, r6) {
      if (a.type = r6.get("type"), a.scale = WV(r6), a.onBand = r6.get("boundaryGap") && a.type === "category", a.inverse = r6.get("inverse"), HHe(r6)) {
        a.inverse = a.inverse !== r6.get("clockwise");
        var t2 = r6.get("startAngle");
        a.setExtent(t2, t2 + (a.inverse ? -360 : 360));
      }
      r6.axis = a, a.model = r6;
    }
    var $He = { dimensions: Fme, create: function(a, r6) {
      var t2 = [];
      return a.eachComponent("polar", function(s, u) {
        var f6 = new jHe(u + "");
        f6.update = WHe;
        var d6 = f6.getRadiusAxis(), v6 = f6.getAngleAxis(), m6 = s.findAxisModel("radiusAxis"), b6 = s.findAxisModel("angleAxis");
        Vme(d6, m6), Vme(v6, b6), GHe(f6, s, r6), t2.push(f6), s.coordinateSystem = f6, f6.model = s;
      }), a.eachSeries(function(s) {
        if (s.get("coordinateSystem") === "polar") {
          var u = s.getReferringComponents("polar", Lc).models[0];
          s.coordinateSystem = u.coordinateSystem;
        }
      }), t2;
    } }, UHe = $He, qHe = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
    function kz(a, r6, t2) {
      r6[1] > r6[0] && (r6 = r6.slice().reverse());
      var s = a.coordToPoint([r6[0], t2]), u = a.coordToPoint([r6[1], t2]);
      return { x1: s[0], y1: s[1], x2: u[0], y2: u[1] };
    }
    function Pz(a) {
      var r6 = a.getRadiusAxis();
      return r6.inverse ? 0 : 1;
    }
    function zme(a) {
      var r6 = a[0], t2 = a[a.length - 1];
      r6 && t2 && Math.abs(Math.abs(r6.coord - t2.coord) - 360) < 1e-4 && a.pop();
    }
    var YHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.axisPointerClass = "PolarAxisPointer", t2;
      }
      return r6.prototype.render = function(t2, s) {
        if (this.group.removeAll(), !!t2.get("show")) {
          var u = t2.axis, f6 = u.polar, d6 = f6.getRadiusAxis().getExtent(), v6 = u.getTicksCoords(), m6 = u.getMinorTicksCoords(), b6 = wr(u.getViewLabels(), function(x6) {
            x6 = Qa(x6);
            var S = u.scale, M = S.type === "ordinal" ? S.getRawOrdinalNumber(x6.tickValue) : x6.tickValue;
            return x6.coord = u.dataToCoord(M), x6;
          });
          zme(b6), zme(v6), Ne(qHe, function(x6) {
            t2.get([x6, "show"]) && (!u.scale.isBlank() || x6 === "axisLine") && ZHe[x6](this.group, t2, f6, v6, m6, d6, b6);
          }, this);
        }
      }, r6.type = "angleAxis", r6;
    }(MA), ZHe = { axisLine: function(a, r6, t2, s, u, f6) {
      var d6 = r6.getModel(["axisLine", "lineStyle"]), v6 = Pz(t2), m6 = v6 ? 0 : 1, b6;
      f6[m6] === 0 ? b6 = new Em({ shape: { cx: t2.cx, cy: t2.cy, r: f6[v6] }, style: d6.getLineStyle(), z2: 1, silent: true }) : b6 = new zD({ shape: { cx: t2.cx, cy: t2.cy, r: f6[v6], r0: f6[m6] }, style: d6.getLineStyle(), z2: 1, silent: true }), b6.style.fill = null, a.add(b6);
    }, axisTick: function(a, r6, t2, s, u, f6) {
      var d6 = r6.getModel("axisTick"), v6 = (d6.get("inside") ? -1 : 1) * d6.get("length"), m6 = f6[Pz(t2)], b6 = wr(s, function(x6) {
        return new rh({ shape: kz(t2, [m6, m6 + v6], x6.coord) });
      });
      a.add(dt(b6, { style: ei(d6.getModel("lineStyle").getLineStyle(), { stroke: r6.get(["axisLine", "lineStyle", "color"]) }) }));
    }, minorTick: function(a, r6, t2, s, u, f6) {
      if (u.length) {
        for (var d6 = r6.getModel("axisTick"), v6 = r6.getModel("minorTick"), m6 = (d6.get("inside") ? -1 : 1) * v6.get("length"), b6 = f6[Pz(t2)], x6 = [], S = 0; S < u.length; S++)
          for (var M = 0; M < u[S].length; M++)
            x6.push(new rh({ shape: kz(t2, [b6, b6 + m6], u[S][M].coord) }));
        a.add(dt(x6, { style: ei(v6.getModel("lineStyle").getLineStyle(), ei(d6.getLineStyle(), { stroke: r6.get(["axisLine", "lineStyle", "color"]) })) }));
      }
    }, axisLabel: function(a, r6, t2, s, u, f6, d6) {
      var v6 = r6.getCategories(true), m6 = r6.getModel("axisLabel"), b6 = m6.get("margin"), x6 = r6.get("triggerEvent");
      Ne(d6, function(S, M) {
        var A6 = m6, I = S.tickValue, R = f6[Pz(t2)], F = t2.coordToPoint([R + b6, S.coord]), j = t2.cx, $ = t2.cy, K = Math.abs(F[0] - j) / R < 0.3 ? "center" : F[0] > j ? "left" : "right", U = Math.abs(F[1] - $) / R < 0.3 ? "middle" : F[1] > $ ? "top" : "bottom";
        if (v6 && v6[I]) {
          var he = v6[I];
          ui(he) && he.textStyle && (A6 = new yu(he.textStyle, m6, m6.ecModel));
        }
        var ue = new ms({ silent: Ux.isLabelSilent(r6), style: yf(A6, { x: F[0], y: F[1], fill: A6.getTextColor() || r6.get(["axisLine", "lineStyle", "color"]), text: S.formattedLabel, align: K, verticalAlign: U }) });
        if (a.add(ue), x6) {
          var pe = Ux.makeAxisEventDataBase(r6);
          pe.targetType = "axisLabel", pe.value = S.rawLabel, ii(ue).eventData = pe;
        }
      }, this);
    }, splitLine: function(a, r6, t2, s, u, f6) {
      var d6 = r6.getModel("splitLine"), v6 = d6.getModel("lineStyle"), m6 = v6.get("color"), b6 = 0;
      m6 = m6 instanceof Array ? m6 : [m6];
      for (var x6 = [], S = 0; S < s.length; S++) {
        var M = b6++ % m6.length;
        x6[M] = x6[M] || [], x6[M].push(new rh({ shape: kz(t2, f6, s[S].coord) }));
      }
      for (var S = 0; S < x6.length; S++)
        a.add(dt(x6[S], { style: ei({ stroke: m6[S % m6.length] }, v6.getLineStyle()), silent: true, z: r6.get("z") }));
    }, minorSplitLine: function(a, r6, t2, s, u, f6) {
      if (u.length) {
        for (var d6 = r6.getModel("minorSplitLine"), v6 = d6.getModel("lineStyle"), m6 = [], b6 = 0; b6 < u.length; b6++)
          for (var x6 = 0; x6 < u[b6].length; x6++)
            m6.push(new rh({ shape: kz(t2, f6, u[b6][x6].coord) }));
        a.add(dt(m6, { style: v6.getLineStyle(), silent: true, z: r6.get("z") }));
      }
    }, splitArea: function(a, r6, t2, s, u, f6) {
      if (s.length) {
        var d6 = r6.getModel("splitArea"), v6 = d6.getModel("areaStyle"), m6 = v6.get("color"), b6 = 0;
        m6 = m6 instanceof Array ? m6 : [m6];
        for (var x6 = [], S = Math.PI / 180, M = -s[0].coord * S, A6 = Math.min(f6[0], f6[1]), I = Math.max(f6[0], f6[1]), R = r6.get("clockwise"), F = 1, j = s.length; F <= j; F++) {
          var $ = F === j ? s[0].coord : s[F].coord, K = b6++ % m6.length;
          x6[K] = x6[K] || [], x6[K].push(new Np({ shape: { cx: t2.cx, cy: t2.cy, r0: A6, r: I, startAngle: M, endAngle: -$ * S, clockwise: R }, silent: true })), M = -$ * S;
        }
        for (var F = 0; F < x6.length; F++)
          a.add(dt(x6[F], { style: ei({ fill: m6[F % m6.length] }, v6.getAreaStyle()), silent: true }));
      }
    } }, XHe = YHe, KHe = ["axisLine", "axisTickLabel", "axisName"], JHe = ["splitLine", "splitArea", "minorSplitLine"], QHe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.axisPointerClass = "PolarAxisPointer", t2;
      }
      return r6.prototype.render = function(t2, s) {
        if (this.group.removeAll(), !!t2.get("show")) {
          var u = this._axisGroup, f6 = this._axisGroup = new bi();
          this.group.add(f6);
          var d6 = t2.axis, v6 = d6.polar, m6 = v6.getAngleAxis(), b6 = d6.getTicksCoords(), x6 = d6.getMinorTicksCoords(), S = m6.getExtent()[0], M = d6.getExtent(), A6 = t$e(v6, t2, S), I = new Ux(t2, A6);
          Ne(KHe, I.add, I), f6.add(I.getGroup()), Ro(u, f6, t2), Ne(JHe, function(R) {
            t2.get([R, "show"]) && !d6.scale.isBlank() && e$e[R](this.group, t2, v6, S, M, b6, x6);
          }, this);
        }
      }, r6.type = "radiusAxis", r6;
    }(MA), e$e = { splitLine: function(a, r6, t2, s, u, f6) {
      var d6 = r6.getModel("splitLine"), v6 = d6.getModel("lineStyle"), m6 = v6.get("color"), b6 = 0;
      m6 = m6 instanceof Array ? m6 : [m6];
      for (var x6 = [], S = 0; S < f6.length; S++) {
        var M = b6++ % m6.length;
        x6[M] = x6[M] || [], x6[M].push(new Em({ shape: { cx: t2.cx, cy: t2.cy, r: f6[S].coord } }));
      }
      for (var S = 0; S < x6.length; S++)
        a.add(dt(x6[S], { style: ei({ stroke: m6[S % m6.length], fill: null }, v6.getLineStyle()), silent: true }));
    }, minorSplitLine: function(a, r6, t2, s, u, f6, d6) {
      if (d6.length) {
        for (var v6 = r6.getModel("minorSplitLine"), m6 = v6.getModel("lineStyle"), b6 = [], x6 = 0; x6 < d6.length; x6++)
          for (var S = 0; S < d6[x6].length; S++)
            b6.push(new Em({ shape: { cx: t2.cx, cy: t2.cy, r: d6[x6][S].coord } }));
        a.add(dt(b6, { style: ei({ fill: null }, m6.getLineStyle()), silent: true }));
      }
    }, splitArea: function(a, r6, t2, s, u, f6) {
      if (f6.length) {
        var d6 = r6.getModel("splitArea"), v6 = d6.getModel("areaStyle"), m6 = v6.get("color"), b6 = 0;
        m6 = m6 instanceof Array ? m6 : [m6];
        for (var x6 = [], S = f6[0].coord, M = 1; M < f6.length; M++) {
          var A6 = b6++ % m6.length;
          x6[A6] = x6[A6] || [], x6[A6].push(new Np({ shape: { cx: t2.cx, cy: t2.cy, r0: S, r: f6[M].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), S = f6[M].coord;
        }
        for (var M = 0; M < x6.length; M++)
          a.add(dt(x6[M], { style: ei({ fill: m6[M % m6.length] }, v6.getAreaStyle()), silent: true }));
      }
    } };
    function t$e(a, r6, t2) {
      return { position: [a.cx, a.cy], rotation: t2 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: r6.getModel("axisLabel").get("rotate"), z2: 1 };
    }
    var n$e = QHe;
    function Bme(a) {
      return a.get("stack") || "__ec_stack_" + a.seriesIndex;
    }
    function jme(a, r6) {
      return r6.dim + a.model.componentIndex;
    }
    function r$e(a, r6, t2) {
      var s = {}, u = a$e(gl(r6.getSeriesByType(a), function(f6) {
        return !r6.isSeriesFiltered(f6) && f6.coordinateSystem && f6.coordinateSystem.type === "polar";
      }));
      r6.eachSeriesByType(a, function(f6) {
        if (f6.coordinateSystem.type === "polar") {
          var d6 = f6.getData(), v6 = f6.coordinateSystem, m6 = v6.getBaseAxis(), b6 = jme(v6, m6), x6 = Bme(f6), S = u[b6][x6], M = S.offset, A6 = S.width, I = v6.getOtherAxis(m6), R = f6.coordinateSystem.cx, F = f6.coordinateSystem.cy, j = f6.get("barMinHeight") || 0, $ = f6.get("barMinAngle") || 0;
          s[x6] = s[x6] || [];
          for (var K = d6.mapDimension(I.dim), U = d6.mapDimension(m6.dim), he = tS(d6, K), ue = m6.dim !== "radius" || !f6.get("roundCap", true), pe = I.dataToCoord(0), _e = 0, xe = d6.count(); _e < xe; _e++) {
            var Ae = d6.get(K, _e), ke = d6.get(U, _e), je = Ae >= 0 ? "p" : "n", Fe = pe;
            he && (s[x6][ke] || (s[x6][ke] = { p: pe, n: pe }), Fe = s[x6][ke][je]);
            var at = void 0, ht = void 0, Qe = void 0, en = void 0;
            if (I.dim === "radius") {
              var bt = I.dataToCoord(Ae) - pe, wt = m6.dataToCoord(ke);
              Math.abs(bt) < j && (bt = (bt < 0 ? -1 : 1) * j), at = Fe, ht = Fe + bt, Qe = wt - M, en = Qe - A6, he && (s[x6][ke][je] = ht);
            } else {
              var Ft = I.dataToCoord(Ae, ue) - pe, fn = m6.dataToCoord(ke);
              Math.abs(Ft) < $ && (Ft = (Ft < 0 ? -1 : 1) * $), at = fn + M, ht = at + A6, Qe = Fe, en = Fe + Ft, he && (s[x6][ke][je] = en);
            }
            d6.setItemLayout(_e, { cx: R, cy: F, r0: at, r: ht, startAngle: -Qe * Math.PI / 180, endAngle: -en * Math.PI / 180, clockwise: Qe >= en });
          }
        }
      });
    }
    function a$e(a) {
      var r6 = {};
      Ne(a, function(s, u) {
        var f6 = s.getData(), d6 = s.coordinateSystem, v6 = d6.getBaseAxis(), m6 = jme(d6, v6), b6 = v6.getExtent(), x6 = v6.type === "category" ? v6.getBandWidth() : Math.abs(b6[1] - b6[0]) / f6.count(), S = r6[m6] || { bandWidth: x6, remainedWidth: x6, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, M = S.stacks;
        r6[m6] = S;
        var A6 = Bme(s);
        M[A6] || S.autoWidthCount++, M[A6] = M[A6] || { width: 0, maxWidth: 0 };
        var I = ua(s.get("barWidth"), x6), R = ua(s.get("barMaxWidth"), x6), F = s.get("barGap"), j = s.get("barCategoryGap");
        I && !M[A6].width && (I = Math.min(S.remainedWidth, I), M[A6].width = I, S.remainedWidth -= I), R && (M[A6].maxWidth = R), F != null && (S.gap = F), j != null && (S.categoryGap = j);
      });
      var t2 = {};
      return Ne(r6, function(s, u) {
        t2[u] = {};
        var f6 = s.stacks, d6 = s.bandWidth, v6 = ua(s.categoryGap, d6), m6 = ua(s.gap, 1), b6 = s.remainedWidth, x6 = s.autoWidthCount, S = (b6 - v6) / (x6 + (x6 - 1) * m6);
        S = Math.max(S, 0), Ne(f6, function(R, F) {
          var j = R.maxWidth;
          j && j < S && (j = Math.min(j, b6), R.width && (j = Math.min(j, R.width)), b6 -= j, R.width = j, x6--);
        }), S = (b6 - v6) / (x6 + (x6 - 1) * m6), S = Math.max(S, 0);
        var M = 0, A6;
        Ne(f6, function(R, F) {
          R.width || (R.width = S), A6 = R, M += R.width * (1 + m6);
        }), A6 && (M -= A6.width * m6);
        var I = -M / 2;
        Ne(f6, function(R, F) {
          t2[u][F] = t2[u][F] || { offset: I, width: R.width }, I += R.width * (1 + m6);
        });
      }), t2;
    }
    var i$e = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, o$e = { splitNumber: 5 }, s$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "polar", r6;
    }(Rc);
    function l$e(a) {
      bo(y42), MA.registerAxisPointerClass("PolarAxisPointer", PHe), a.registerCoordinateSystem("polar", UHe), a.registerComponentModel(OHe), a.registerComponentView(s$e), m5(a, "angle", RHe, i$e), m5(a, "radius", FHe, o$e), a.registerComponentView(XHe), a.registerComponentView(n$e), a.registerLayout(Oi(r$e, "bar"));
    }
    function eJ(a, r6) {
      r6 = r6 || {};
      var t2 = a.coordinateSystem, s = a.axis, u = {}, f6 = s.position, d6 = s.orient, v6 = t2.getRect(), m6 = [v6.x, v6.x + v6.width, v6.y, v6.y + v6.height], b6 = { horizontal: { top: m6[2], bottom: m6[3] }, vertical: { left: m6[0], right: m6[1] } };
      u.position = [d6 === "vertical" ? b6.vertical[f6] : m6[0], d6 === "horizontal" ? b6.horizontal[f6] : m6[3]];
      var x6 = { horizontal: 0, vertical: 1 };
      u.rotation = Math.PI / 2 * x6[d6];
      var S = { top: -1, bottom: 1, right: 1, left: -1 };
      u.labelDirection = u.tickDirection = u.nameDirection = S[f6], a.get(["axisTick", "inside"]) && (u.tickDirection = -u.tickDirection), Jf(r6.labelInside, a.get(["axisLabel", "inside"])) && (u.labelDirection = -u.labelDirection);
      var M = r6.rotate;
      return M == null && (M = a.get(["axisLabel", "rotate"])), u.labelRotation = f6 === "top" ? -M : M, u.z2 = 1, u;
    }
    var u$e = ["axisLine", "axisTickLabel", "axisName"], c$e = ["splitArea", "splitLine"], f$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.axisPointerClass = "SingleAxisPointer", t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        var d6 = this.group;
        d6.removeAll();
        var v6 = this._axisGroup;
        this._axisGroup = new bi();
        var m6 = eJ(t2), b6 = new Ux(t2, m6);
        Ne(u$e, b6.add, b6), d6.add(this._axisGroup), d6.add(b6.getGroup()), Ne(c$e, function(x6) {
          t2.get([x6, "show"]) && h$e[x6](this, this.group, this._axisGroup, t2);
        }, this), Ro(v6, this._axisGroup, t2), a.prototype.render.call(this, t2, s, u, f6);
      }, r6.prototype.remove = function() {
        ove(this);
      }, r6.type = "singleAxis", r6;
    }(MA), h$e = { splitLine: function(a, r6, t2, s) {
      var u = s.axis;
      if (!u.scale.isBlank()) {
        var f6 = s.getModel("splitLine"), d6 = f6.getModel("lineStyle"), v6 = d6.get("color");
        v6 = v6 instanceof Array ? v6 : [v6];
        for (var m6 = s.coordinateSystem.getRect(), b6 = u.isHorizontal(), x6 = [], S = 0, M = u.getTicksCoords({ tickModel: f6 }), A6 = [], I = [], R = 0; R < M.length; ++R) {
          var F = u.toGlobalCoord(M[R].coord);
          b6 ? (A6[0] = F, A6[1] = m6.y, I[0] = F, I[1] = m6.y + m6.height) : (A6[0] = m6.x, A6[1] = F, I[0] = m6.x + m6.width, I[1] = F);
          var j = S++ % v6.length;
          x6[j] = x6[j] || [], x6[j].push(new rh({ subPixelOptimize: true, shape: { x1: A6[0], y1: A6[1], x2: I[0], y2: I[1] }, silent: true }));
        }
        for (var $ = d6.getLineStyle(["color"]), R = 0; R < x6.length; ++R)
          r6.add(dt(x6[R], { style: ei({ stroke: v6[R % v6.length] }, $), silent: true }));
      }
    }, splitArea: function(a, r6, t2, s) {
      ive(a, t2, s, s);
    } }, d$e = f$e, Gme = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.getCoordSysModel = function() {
        return this;
      }, r6.type = "singleAxis", r6.layoutMode = "box", r6.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, r6;
    }(Ps);
    Dc(Gme, GR.prototype);
    var tJ = Gme, p$e = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6, d6) {
        var v6 = a.call(this, t2, s, u) || this;
        return v6.type = f6 || "value", v6.position = d6 || "bottom", v6;
      }
      return r6.prototype.isHorizontal = function() {
        var t2 = this.position;
        return t2 === "top" || t2 === "bottom";
      }, r6.prototype.pointToData = function(t2, s) {
        return this.coordinateSystem.pointToData(t2)[0];
      }, r6;
    }(c1), v$e = p$e, Wme = ["single"], g$e = function() {
      function a(r6, t2, s) {
        this.type = "single", this.dimension = "single", this.dimensions = Wme, this.axisPointerEnabled = true, this.model = r6, this._init(r6, t2, s);
      }
      return a.prototype._init = function(r6, t2, s) {
        var u = this.dimension, f6 = new v$e(u, WV(r6), [0, 0], r6.get("type"), r6.get("position")), d6 = f6.type === "category";
        f6.onBand = d6 && r6.get("boundaryGap"), f6.inverse = r6.get("inverse"), f6.orient = r6.get("orient"), r6.axis = f6, f6.model = r6, f6.coordinateSystem = this, this._axis = f6;
      }, a.prototype.update = function(r6, t2) {
        r6.eachSeries(function(s) {
          if (s.coordinateSystem === this) {
            var u = s.getData();
            Ne(u.mapDimensionsAll(this.dimension), function(f6) {
              this._axis.scale.unionExtentFromData(u, f6);
            }, this), h5(this._axis.scale, this._axis.model);
          }
        }, this);
      }, a.prototype.resize = function(r6, t2) {
        this._rect = ah({ left: r6.get("left"), top: r6.get("top"), right: r6.get("right"), bottom: r6.get("bottom"), width: r6.get("width"), height: r6.get("height") }, { width: t2.getWidth(), height: t2.getHeight() }), this._adjustAxis();
      }, a.prototype.getRect = function() {
        return this._rect;
      }, a.prototype._adjustAxis = function() {
        var r6 = this._rect, t2 = this._axis, s = t2.isHorizontal(), u = s ? [0, r6.width] : [0, r6.height], f6 = t2.reverse ? 1 : 0;
        t2.setExtent(u[f6], u[1 - f6]), this._updateAxisTransform(t2, s ? r6.x : r6.y);
      }, a.prototype._updateAxisTransform = function(r6, t2) {
        var s = r6.getExtent(), u = s[0] + s[1], f6 = r6.isHorizontal();
        r6.toGlobalCoord = f6 ? function(d6) {
          return d6 + t2;
        } : function(d6) {
          return u - d6 + t2;
        }, r6.toLocalCoord = f6 ? function(d6) {
          return d6 - t2;
        } : function(d6) {
          return u - d6 + t2;
        };
      }, a.prototype.getAxis = function() {
        return this._axis;
      }, a.prototype.getBaseAxis = function() {
        return this._axis;
      }, a.prototype.getAxes = function() {
        return [this._axis];
      }, a.prototype.getTooltipAxes = function() {
        return { baseAxes: [this.getAxis()], otherAxes: [] };
      }, a.prototype.containPoint = function(r6) {
        var t2 = this.getRect(), s = this.getAxis(), u = s.orient;
        return u === "horizontal" ? s.contain(s.toLocalCoord(r6[0])) && r6[1] >= t2.y && r6[1] <= t2.y + t2.height : s.contain(s.toLocalCoord(r6[1])) && r6[0] >= t2.y && r6[0] <= t2.y + t2.height;
      }, a.prototype.pointToData = function(r6) {
        var t2 = this.getAxis();
        return [t2.coordToData(t2.toLocalCoord(r6[t2.orient === "horizontal" ? 0 : 1]))];
      }, a.prototype.dataToPoint = function(r6) {
        var t2 = this.getAxis(), s = this.getRect(), u = [], f6 = t2.orient === "horizontal" ? 0 : 1;
        return r6 instanceof Array && (r6 = r6[0]), u[f6] = t2.toGlobalCoord(t2.dataToCoord(+r6)), u[1 - f6] = f6 === 0 ? s.y + s.height / 2 : s.x + s.width / 2, u;
      }, a.prototype.convertToPixel = function(r6, t2, s) {
        var u = Hme(t2);
        return u === this ? this.dataToPoint(s) : null;
      }, a.prototype.convertFromPixel = function(r6, t2, s) {
        var u = Hme(t2);
        return u === this ? this.pointToData(s) : null;
      }, a;
    }();
    function Hme(a) {
      var r6 = a.seriesModel, t2 = a.singleAxisModel;
      return t2 && t2.coordinateSystem || r6 && r6.coordinateSystem;
    }
    function m$e(a, r6) {
      var t2 = [];
      return a.eachComponent("singleAxis", function(s, u) {
        var f6 = new g$e(s, a, r6);
        f6.name = "single_" + u, f6.resize(s, r6), s.coordinateSystem = f6, t2.push(f6);
      }), a.eachSeries(function(s) {
        if (s.get("coordinateSystem") === "singleAxis") {
          var u = s.getReferringComponents("singleAxis", Lc).models[0];
          s.coordinateSystem = u && u.coordinateSystem;
        }
      }), t2;
    }
    var y$e = { create: m$e, dimensions: Wme }, b$e = y$e, $me = ["x", "y"], _$e = ["width", "height"], x$e = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.makeElOption = function(t2, s, u, f6, d6) {
        var v6 = u.axis, m6 = v6.coordinateSystem, b6 = nJ(m6, 1 - Lz(v6)), x6 = m6.dataToPoint(s)[0], S = f6.get("type");
        if (S && S !== "none") {
          var M = qK(f6), A6 = w$e[S](v6, x6, b6);
          A6.style = M, t2.graphicKey = A6.type, t2.pointer = A6;
        }
        var I = eJ(u);
        Mme(s, t2, I, u, f6, d6);
      }, r6.prototype.getHandleTransform = function(t2, s, u) {
        var f6 = eJ(s, { labelInside: false });
        f6.labelMargin = u.get(["handle", "margin"]);
        var d6 = YK(s.axis, t2, f6);
        return { x: d6[0], y: d6[1], rotation: f6.rotation + (f6.labelDirection < 0 ? Math.PI : 0) };
      }, r6.prototype.updateHandleTransform = function(t2, s, u, f6) {
        var d6 = u.axis, v6 = d6.coordinateSystem, m6 = Lz(d6), b6 = nJ(v6, m6), x6 = [t2.x, t2.y];
        x6[m6] += s[m6], x6[m6] = Math.min(b6[1], x6[m6]), x6[m6] = Math.max(b6[0], x6[m6]);
        var S = nJ(v6, 1 - m6), M = (S[1] + S[0]) / 2, A6 = [M, M];
        return A6[m6] = x6[m6], { x: x6[0], y: x6[1], rotation: t2.rotation, cursorPoint: A6, tooltipOption: { verticalAlign: "middle" } };
      }, r6;
    }(UK), w$e = { line: function(a, r6, t2) {
      var s = ZK([r6, t2[0]], [r6, t2[1]], Lz(a));
      return { type: "Line", subPixelOptimize: true, shape: s };
    }, shadow: function(a, r6, t2) {
      var s = a.getBandWidth(), u = t2[1] - t2[0];
      return { type: "Rect", shape: Ame([r6 - s / 2, t2[0]], [s, u], Lz(a)) };
    } };
    function Lz(a) {
      return a.isHorizontal() ? 0 : 1;
    }
    function nJ(a, r6) {
      var t2 = a.getRect();
      return [t2[$me[r6]], t2[$me[r6]] + t2[_$e[r6]]];
    }
    var S$e = x$e, C$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "single", r6;
    }(Rc);
    function M$e(a) {
      bo(y42), MA.registerAxisPointerClass("SingleAxisPointer", S$e), a.registerComponentView(C$e), a.registerComponentView(d$e), a.registerComponentModel(tJ), m5(a, "single", tJ, tJ.defaultOption), a.registerCoordinateSystem("single", b$e);
    }
    var A$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        var f6 = JD(t2);
        a.prototype.init.apply(this, arguments), Ume(t2, f6);
      }, r6.prototype.mergeOption = function(t2) {
        a.prototype.mergeOption.apply(this, arguments), Ume(this.option, t2);
      }, r6.prototype.getCellSize = function() {
        return this.option.cellSize;
      }, r6.type = "calendar", r6.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, r6;
    }(Ps);
    function Ume(a, r6) {
      var t2 = a.cellSize, s;
      br(t2) ? s = t2 : s = a.cellSize = [t2, t2], s.length === 1 && (s[1] = s[0]);
      var u = wr([0, 1], function(f6) {
        return POe(r6, f6) && (s[f6] = "auto"), s[f6] != null && s[f6] !== "auto";
      });
      Z2(a, r6, { type: "box", ignoreSize: u });
    }
    var E$e = A$e, I$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6 = this.group;
        f6.removeAll();
        var d6 = t2.coordinateSystem, v6 = d6.getRangeInfo(), m6 = d6.getOrient(), b6 = s.getLocaleModel();
        this._renderDayRect(t2, v6, f6), this._renderLines(t2, v6, m6, f6), this._renderYearText(t2, v6, m6, f6), this._renderMonthText(t2, b6, m6, f6), this._renderWeekText(t2, b6, v6, m6, f6);
      }, r6.prototype._renderDayRect = function(t2, s, u) {
        for (var f6 = t2.coordinateSystem, d6 = t2.getModel("itemStyle").getItemStyle(), v6 = f6.getCellWidth(), m6 = f6.getCellHeight(), b6 = s.start.time; b6 <= s.end.time; b6 = f6.getNextNDay(b6, 1).time) {
          var x6 = f6.dataToRect([b6], false).tl, S = new rs({ shape: { x: x6[0], y: x6[1], width: v6, height: m6 }, cursor: "default", style: d6 });
          u.add(S);
        }
      }, r6.prototype._renderLines = function(t2, s, u, f6) {
        var d6 = this, v6 = t2.coordinateSystem, m6 = t2.getModel(["splitLine", "lineStyle"]).getLineStyle(), b6 = t2.get(["splitLine", "show"]), x6 = m6.lineWidth;
        this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
        for (var S = s.start, M = 0; S.time <= s.end.time; M++) {
          I(S.formatedDate), M === 0 && (S = v6.getDateInfo(s.start.y + "-" + s.start.m));
          var A6 = S.date;
          A6.setMonth(A6.getMonth() + 1), S = v6.getDateInfo(A6);
        }
        I(v6.getNextNDay(s.end.time, 1).formatedDate);
        function I(R) {
          d6._firstDayOfMonth.push(v6.getDateInfo(R)), d6._firstDayPoints.push(v6.dataToRect([R], false).tl);
          var F = d6._getLinePointsOfOneWeek(t2, R, u);
          d6._tlpoints.push(F[0]), d6._blpoints.push(F[F.length - 1]), b6 && d6._drawSplitline(F, m6, f6);
        }
        b6 && this._drawSplitline(d6._getEdgesPoints(d6._tlpoints, x6, u), m6, f6), b6 && this._drawSplitline(d6._getEdgesPoints(d6._blpoints, x6, u), m6, f6);
      }, r6.prototype._getEdgesPoints = function(t2, s, u) {
        var f6 = [t2[0].slice(), t2[t2.length - 1].slice()], d6 = u === "horizontal" ? 0 : 1;
        return f6[0][d6] = f6[0][d6] - s / 2, f6[1][d6] = f6[1][d6] + s / 2, f6;
      }, r6.prototype._drawSplitline = function(t2, s, u) {
        var f6 = new Vp({ z2: 20, shape: { points: t2 }, style: s });
        u.add(f6);
      }, r6.prototype._getLinePointsOfOneWeek = function(t2, s, u) {
        for (var f6 = t2.coordinateSystem, d6 = f6.getDateInfo(s), v6 = [], m6 = 0; m6 < 7; m6++) {
          var b6 = f6.getNextNDay(d6.time, m6), x6 = f6.dataToRect([b6.time], false);
          v6[2 * b6.day] = x6.tl, v6[2 * b6.day + 1] = x6[u === "horizontal" ? "bl" : "tr"];
        }
        return v6;
      }, r6.prototype._formatterLabel = function(t2, s) {
        return _a2(t2) && t2 ? TOe(t2, s) : ti(t2) ? t2(s) : s.nameMap;
      }, r6.prototype._yearTextPositionControl = function(t2, s, u, f6, d6) {
        var v6 = s[0], m6 = s[1], b6 = ["center", "bottom"];
        f6 === "bottom" ? (m6 += d6, b6 = ["center", "top"]) : f6 === "left" ? v6 -= d6 : f6 === "right" ? (v6 += d6, b6 = ["center", "top"]) : m6 -= d6;
        var x6 = 0;
        return (f6 === "left" || f6 === "right") && (x6 = Math.PI / 2), { rotation: x6, x: v6, y: m6, style: { align: b6[0], verticalAlign: b6[1] } };
      }, r6.prototype._renderYearText = function(t2, s, u, f6) {
        var d6 = t2.getModel("yearLabel");
        if (d6.get("show")) {
          var v6 = d6.get("margin"), m6 = d6.get("position");
          m6 || (m6 = u !== "horizontal" ? "top" : "left");
          var b6 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], x6 = (b6[0][0] + b6[1][0]) / 2, S = (b6[0][1] + b6[1][1]) / 2, M = u === "horizontal" ? 0 : 1, A6 = { top: [x6, b6[M][1]], bottom: [x6, b6[1 - M][1]], left: [b6[1 - M][0], S], right: [b6[M][0], S] }, I = s.start.y;
          +s.end.y > +s.start.y && (I = I + "-" + s.end.y);
          var R = d6.get("formatter"), F = { start: s.start.y, end: s.end.y, nameMap: I }, j = this._formatterLabel(R, F), $ = new ms({ z2: 30, style: yf(d6, { text: j }) });
          $.attr(this._yearTextPositionControl($, A6[m6], u, m6, v6)), f6.add($);
        }
      }, r6.prototype._monthTextPositionControl = function(t2, s, u, f6, d6) {
        var v6 = "left", m6 = "top", b6 = t2[0], x6 = t2[1];
        return u === "horizontal" ? (x6 = x6 + d6, s && (v6 = "center"), f6 === "start" && (m6 = "bottom")) : (b6 = b6 + d6, s && (m6 = "middle"), f6 === "start" && (v6 = "right")), { x: b6, y: x6, align: v6, verticalAlign: m6 };
      }, r6.prototype._renderMonthText = function(t2, s, u, f6) {
        var d6 = t2.getModel("monthLabel");
        if (d6.get("show")) {
          var v6 = d6.get("nameMap"), m6 = d6.get("margin"), b6 = d6.get("position"), x6 = d6.get("align"), S = [this._tlpoints, this._blpoints];
          (!v6 || _a2(v6)) && (v6 && (s = DY(v6) || s), v6 = s.get(["time", "monthAbbr"]) || []);
          var M = b6 === "start" ? 0 : 1, A6 = u === "horizontal" ? 0 : 1;
          m6 = b6 === "start" ? -m6 : m6;
          for (var I = x6 === "center", R = 0; R < S[M].length - 1; R++) {
            var F = S[M][R].slice(), j = this._firstDayOfMonth[R];
            if (I) {
              var $ = this._firstDayPoints[R];
              F[A6] = ($[A6] + S[0][R + 1][A6]) / 2;
            }
            var K = d6.get("formatter"), U = v6[+j.m - 1], he = { yyyy: j.y, yy: (j.y + "").slice(2), MM: j.m, M: +j.m, nameMap: U }, ue = this._formatterLabel(K, he), pe = new ms({ z2: 30, style: qn(yf(d6, { text: ue }), this._monthTextPositionControl(F, I, u, b6, m6)) });
            f6.add(pe);
          }
        }
      }, r6.prototype._weekTextPositionControl = function(t2, s, u, f6, d6) {
        var v6 = "center", m6 = "middle", b6 = t2[0], x6 = t2[1], S = u === "start";
        return s === "horizontal" ? (b6 = b6 + f6 + (S ? 1 : -1) * d6[0] / 2, v6 = S ? "right" : "left") : (x6 = x6 + f6 + (S ? 1 : -1) * d6[1] / 2, m6 = S ? "bottom" : "top"), { x: b6, y: x6, align: v6, verticalAlign: m6 };
      }, r6.prototype._renderWeekText = function(t2, s, u, f6, d6) {
        var v6 = t2.getModel("dayLabel");
        if (v6.get("show")) {
          var m6 = t2.coordinateSystem, b6 = v6.get("position"), x6 = v6.get("nameMap"), S = v6.get("margin"), M = m6.getFirstDayOfWeek();
          if (!x6 || _a2(x6)) {
            x6 && (s = DY(x6) || s);
            var A6 = s.get(["time", "dayOfWeekShort"]);
            x6 = A6 || wr(s.get(["time", "dayOfWeekAbbr"]), function(he) {
              return he[0];
            });
          }
          var I = m6.getNextNDay(u.end.time, 7 - u.lweek).time, R = [m6.getCellWidth(), m6.getCellHeight()];
          S = ua(S, Math.min(R[1], R[0])), b6 === "start" && (I = m6.getNextNDay(u.start.time, -(7 + u.fweek)).time, S = -S);
          for (var F = 0; F < 7; F++) {
            var j = m6.getNextNDay(I, F), $ = m6.dataToRect([j.time], false).center, K = F;
            K = Math.abs((F + M) % 7);
            var U = new ms({ z2: 30, style: qn(yf(v6, { text: x6[K] }), this._weekTextPositionControl($, f6, b6, S, R)) });
            d6.add(U);
          }
        }
      }, r6.type = "calendar", r6;
    }(Rc), T$e = I$e, rJ = 864e5, D$e = function() {
      function a(r6, t2, s) {
        this.type = "calendar", this.dimensions = a.dimensions, this.getDimensionsInfo = a.getDimensionsInfo, this._model = r6;
      }
      return a.getDimensionsInfo = function() {
        return [{ name: "time", type: "time" }, "value"];
      }, a.prototype.getRangeInfo = function() {
        return this._rangeInfo;
      }, a.prototype.getModel = function() {
        return this._model;
      }, a.prototype.getRect = function() {
        return this._rect;
      }, a.prototype.getCellWidth = function() {
        return this._sw;
      }, a.prototype.getCellHeight = function() {
        return this._sh;
      }, a.prototype.getOrient = function() {
        return this._orient;
      }, a.prototype.getFirstDayOfWeek = function() {
        return this._firstDayOfWeek;
      }, a.prototype.getDateInfo = function(r6) {
        r6 = s0(r6);
        var t2 = r6.getFullYear(), s = r6.getMonth() + 1, u = s < 10 ? "0" + s : "" + s, f6 = r6.getDate(), d6 = f6 < 10 ? "0" + f6 : "" + f6, v6 = r6.getDay();
        return v6 = Math.abs((v6 + 7 - this.getFirstDayOfWeek()) % 7), { y: t2 + "", m: u, d: d6, day: v6, time: r6.getTime(), formatedDate: t2 + "-" + u + "-" + d6, date: r6 };
      }, a.prototype.getNextNDay = function(r6, t2) {
        return t2 = t2 || 0, t2 === 0 ? this.getDateInfo(r6) : (r6 = new Date(this.getDateInfo(r6).time), r6.setDate(r6.getDate() + t2), this.getDateInfo(r6));
      }, a.prototype.update = function(r6, t2) {
        this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
        var s = this._rangeInfo.weeks || 1, u = ["width", "height"], f6 = this._model.getCellSize().slice(), d6 = this._model.getBoxLayoutParams(), v6 = this._orient === "horizontal" ? [s, 7] : [7, s];
        Ne([0, 1], function(S) {
          x6(f6, S) && (d6[u[S]] = f6[S] * v6[S]);
        });
        var m6 = { width: t2.getWidth(), height: t2.getHeight() }, b6 = this._rect = ah(d6, m6);
        Ne([0, 1], function(S) {
          x6(f6, S) || (f6[S] = b6[u[S]] / v6[S]);
        });
        function x6(S, M) {
          return S[M] != null && S[M] !== "auto";
        }
        this._sw = f6[0], this._sh = f6[1];
      }, a.prototype.dataToPoint = function(r6, t2) {
        br(r6) && (r6 = r6[0]), t2 == null && (t2 = true);
        var s = this.getDateInfo(r6), u = this._rangeInfo, f6 = s.formatedDate;
        if (t2 && !(s.time >= u.start.time && s.time < u.end.time + rJ))
          return [NaN, NaN];
        var d6 = s.day, v6 = this._getRangeInfo([u.start.time, f6]).nthWeek;
        return this._orient === "vertical" ? [this._rect.x + d6 * this._sw + this._sw / 2, this._rect.y + v6 * this._sh + this._sh / 2] : [this._rect.x + v6 * this._sw + this._sw / 2, this._rect.y + d6 * this._sh + this._sh / 2];
      }, a.prototype.pointToData = function(r6) {
        var t2 = this.pointToDate(r6);
        return t2 && t2.time;
      }, a.prototype.dataToRect = function(r6, t2) {
        var s = this.dataToPoint(r6, t2);
        return { contentShape: { x: s[0] - (this._sw - this._lineWidth) / 2, y: s[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: s, tl: [s[0] - this._sw / 2, s[1] - this._sh / 2], tr: [s[0] + this._sw / 2, s[1] - this._sh / 2], br: [s[0] + this._sw / 2, s[1] + this._sh / 2], bl: [s[0] - this._sw / 2, s[1] + this._sh / 2] };
      }, a.prototype.pointToDate = function(r6) {
        var t2 = Math.floor((r6[0] - this._rect.x) / this._sw) + 1, s = Math.floor((r6[1] - this._rect.y) / this._sh) + 1, u = this._rangeInfo.range;
        return this._orient === "vertical" ? this._getDateByWeeksAndDay(s, t2 - 1, u) : this._getDateByWeeksAndDay(t2, s - 1, u);
      }, a.prototype.convertToPixel = function(r6, t2, s) {
        var u = qme(t2);
        return u === this ? u.dataToPoint(s) : null;
      }, a.prototype.convertFromPixel = function(r6, t2, s) {
        var u = qme(t2);
        return u === this ? u.pointToData(s) : null;
      }, a.prototype.containPoint = function(r6) {
        return console.warn("Not implemented."), false;
      }, a.prototype._initRangeOption = function() {
        var r6 = this._model.get("range"), t2;
        if (br(r6) && r6.length === 1 && (r6 = r6[0]), br(r6))
          t2 = r6;
        else {
          var s = r6.toString();
          if (/^\d{4}$/.test(s) && (t2 = [s + "-01-01", s + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(s)) {
            var u = this.getDateInfo(s), f6 = u.date;
            f6.setMonth(f6.getMonth() + 1);
            var d6 = this.getNextNDay(f6, -1);
            t2 = [u.formatedDate, d6.formatedDate];
          }
          /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(s) && (t2 = [s, s]);
        }
        if (!t2)
          return r6;
        var v6 = this._getRangeInfo(t2);
        return v6.start.time > v6.end.time && t2.reverse(), t2;
      }, a.prototype._getRangeInfo = function(r6) {
        var t2 = [this.getDateInfo(r6[0]), this.getDateInfo(r6[1])], s;
        t2[0].time > t2[1].time && (s = true, t2.reverse());
        var u = Math.floor(t2[1].time / rJ) - Math.floor(t2[0].time / rJ) + 1, f6 = new Date(t2[0].time), d6 = f6.getDate(), v6 = t2[1].date.getDate();
        f6.setDate(d6 + u - 1);
        var m6 = f6.getDate();
        if (m6 !== v6)
          for (var b6 = f6.getTime() - t2[1].time > 0 ? 1 : -1; (m6 = f6.getDate()) !== v6 && (f6.getTime() - t2[1].time) * b6 > 0; )
            u -= b6, f6.setDate(m6 - b6);
        var x6 = Math.floor((u + t2[0].day + 6) / 7), S = s ? -x6 + 1 : x6 - 1;
        return s && t2.reverse(), { range: [t2[0].formatedDate, t2[1].formatedDate], start: t2[0], end: t2[1], allDay: u, weeks: x6, nthWeek: S, fweek: t2[0].day, lweek: t2[1].day };
      }, a.prototype._getDateByWeeksAndDay = function(r6, t2, s) {
        var u = this._getRangeInfo(s);
        if (r6 > u.weeks || r6 === 0 && t2 < u.fweek || r6 === u.weeks && t2 > u.lweek)
          return null;
        var f6 = (r6 - 1) * 7 - u.fweek + t2, d6 = new Date(u.start.time);
        return d6.setDate(+u.start.d + f6), this.getDateInfo(d6);
      }, a.create = function(r6, t2) {
        var s = [];
        return r6.eachComponent("calendar", function(u) {
          var f6 = new a(u, r6, t2);
          s.push(f6), u.coordinateSystem = f6;
        }), r6.eachSeries(function(u) {
          u.get("coordinateSystem") === "calendar" && (u.coordinateSystem = s[u.get("calendarIndex") || 0]);
        }), s;
      }, a.dimensions = ["time", "value"], a;
    }();
    function qme(a) {
      var r6 = a.calendarModel, t2 = a.seriesModel, s = r6 ? r6.coordinateSystem : t2 ? t2.coordinateSystem : null;
      return s;
    }
    var k$e = D$e;
    function P$e(a) {
      a.registerComponentModel(E$e), a.registerComponentView(T$e), a.registerCoordinateSystem("calendar", k$e);
    }
    function L$e(a, r6) {
      var t2 = a.existing;
      if (r6.id = a.keyInfo.id, !r6.type && t2 && (r6.type = t2.type), r6.parentId == null) {
        var s = r6.parentOption;
        s ? r6.parentId = s.id : t2 && (r6.parentId = t2.parentId);
      }
      r6.parentOption = null;
    }
    function Yme(a, r6) {
      var t2;
      return Ne(r6, function(s) {
        a[s] != null && a[s] !== "auto" && (t2 = true);
      }), t2;
    }
    function O$e(a, r6, t2) {
      var s = qn({}, t2), u = a[r6], f6 = t2.$action || "merge";
      f6 === "merge" ? u ? (Di(u, s, true), Z2(u, s, { ignoreSize: true }), wce(t2, u), Oz(t2, u), Oz(t2, u, "shape"), Oz(t2, u, "style"), Oz(t2, u, "extra"), t2.clipPath = u.clipPath) : a[r6] = s : f6 === "replace" ? a[r6] = s : f6 === "remove" && u && (a[r6] = null);
    }
    var Zme = ["transition", "enterFrom", "leaveTo"], R$e = Zme.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
    function Oz(a, r6, t2) {
      if (t2 && (!a[t2] && r6[t2] && (a[t2] = {}), a = a[t2], r6 = r6[t2]), !(!a || !r6))
        for (var s = t2 ? Zme : R$e, u = 0; u < s.length; u++) {
          var f6 = s[u];
          a[f6] == null && r6[f6] != null && (a[f6] = r6[f6]);
        }
    }
    function F$e(a, r6) {
      if (!!a && (a.hv = r6.hv = [Yme(r6, ["left", "right"]), Yme(r6, ["top", "bottom"])], a.type === "group")) {
        var t2 = a, s = r6;
        t2.width == null && (t2.width = s.width = 0), t2.height == null && (t2.height = s.height = 0);
      }
    }
    var N$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.preventAutoZ = true, t2;
      }
      return r6.prototype.mergeOption = function(t2, s) {
        var u = this.option.elements;
        this.option.elements = null, a.prototype.mergeOption.call(this, t2, s), this.option.elements = u;
      }, r6.prototype.optionUpdated = function(t2, s) {
        var u = this.option, f6 = (s ? u : t2).elements, d6 = u.elements = s ? [] : u.elements, v6 = [];
        this._flatten(f6, v6, null);
        var m6 = Mb(d6, v6, "normalMerge"), b6 = this._elOptionsToUpdate = [];
        Ne(m6, function(x6, S) {
          var M = x6.newOption;
          !M || (b6.push(M), L$e(x6, M), O$e(d6, S, M), F$e(d6[S], M));
        }, this), u.elements = gl(d6, function(x6) {
          return x6 && delete x6.$action, x6 != null;
        });
      }, r6.prototype._flatten = function(t2, s, u) {
        Ne(t2, function(f6) {
          if (f6) {
            u && (f6.parentOption = u), s.push(f6);
            var d6 = f6.children;
            f6.type === "group" && d6 && this._flatten(d6, s, f6), delete f6.children;
          }
        }, this);
      }, r6.prototype.useElOptionsToUpdate = function() {
        var t2 = this._elOptionsToUpdate;
        return this._elOptionsToUpdate = null, t2;
      }, r6.type = "graphic", r6.defaultOption = { elements: [] }, r6;
    }(Ps), Xme = { path: null, compoundPath: null, group: bi, image: nh, text: ms }, Bm = Xo(), V$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function() {
        this._elMap = Ta();
      }, r6.prototype.render = function(t2, s, u) {
        t2 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = t2, this._updateElements(t2), this._relocate(t2, u);
      }, r6.prototype._updateElements = function(t2) {
        var s = t2.useElOptionsToUpdate();
        if (s) {
          var u = this._elMap, f6 = this.group, d6 = t2.get("z"), v6 = t2.get("zlevel");
          Ne(s, function(m6) {
            var b6 = Zc(m6.id, null), x6 = b6 != null ? u.get(b6) : null, S = Zc(m6.parentId, null), M = S != null ? u.get(S) : f6, A6 = m6.type, I = m6.style;
            A6 === "text" && I && m6.hv && m6.hv[1] && (I.textVerticalAlign = I.textBaseline = I.verticalAlign = I.align = null);
            var R = m6.textContent, F = m6.textConfig;
            if (I && Q0e(I, A6, !!F, !!R)) {
              var j = eme(I, A6, true);
              !F && j.textConfig && (F = m6.textConfig = j.textConfig), !R && j.textContent && (R = j.textContent);
            }
            var $ = z$e(m6), K = m6.$action || "merge", U = K === "merge", he = K === "replace";
            if (U) {
              var ue = !x6, pe = x6;
              ue ? pe = Kme(b6, M, m6.type, u) : (pe && (Bm(pe).isNew = false), cme(pe)), pe && (Az(pe, $, t2, { isInit: ue }), Jme(pe, m6, d6, v6));
            } else if (he) {
              Rz(x6, m6, u, t2);
              var _e = Kme(b6, M, m6.type, u);
              _e && (Az(_e, $, t2, { isInit: true }), Jme(_e, m6, d6, v6));
            } else
              K === "remove" && (ome(x6, m6), Rz(x6, m6, u, t2));
            var xe = u.get(b6);
            if (xe && R)
              if (U) {
                var Ae = xe.getTextContent();
                Ae ? Ae.attr(R) : xe.setTextContent(new ms(R));
              } else
                he && xe.setTextContent(new ms(R));
            if (xe) {
              var ke = m6.clipPath;
              if (ke) {
                var je = ke.type, Fe = void 0, ue = false;
                if (U) {
                  var at = xe.getClipPath();
                  ue = !at || Bm(at).type !== je, Fe = ue ? aJ(je) : at;
                } else
                  he && (ue = true, Fe = aJ(je));
                xe.setClipPath(Fe), Az(Fe, ke, t2, { isInit: ue }), Iz(Fe, ke.keyframeAnimation, t2);
              }
              var ht = Bm(xe);
              xe.setTextConfig(F), ht.option = m6, B$e(xe, t2, m6), fd({ el: xe, componentModel: t2, itemName: xe.name, itemTooltipOption: m6.tooltip }), Iz(xe, m6.keyframeAnimation, t2);
            }
          });
        }
      }, r6.prototype._relocate = function(t2, s) {
        for (var u = t2.option.elements, f6 = this.group, d6 = this._elMap, v6 = s.getWidth(), m6 = s.getHeight(), b6 = ["x", "y"], x6 = 0; x6 < u.length; x6++) {
          var S = u[x6], M = Zc(S.id, null), A6 = M != null ? d6.get(M) : null;
          if (!(!A6 || !A6.isGroup)) {
            var I = A6.parent, R = I === f6, F = Bm(A6), j = Bm(I);
            F.width = ua(F.option.width, R ? v6 : j.width) || 0, F.height = ua(F.option.height, R ? m6 : j.height) || 0;
          }
        }
        for (var x6 = u.length - 1; x6 >= 0; x6--) {
          var S = u[x6], M = Zc(S.id, null), A6 = M != null ? d6.get(M) : null;
          if (A6) {
            var I = A6.parent, j = Bm(I), $ = I === f6 ? { width: v6, height: m6 } : { width: j.width, height: j.height }, K = {}, U = fV(A6, S, $, null, { hv: S.hv, boundingMode: S.bounding }, K);
            if (!Bm(A6).isNew && U) {
              for (var he = S.transition, ue = {}, pe = 0; pe < b6.length; pe++) {
                var _e = b6[pe], xe = K[_e];
                he && (OA(he) || Vi(he, _e) >= 0) ? ue[_e] = xe : A6[_e] = xe;
              }
              fs(A6, ue, t2, 0);
            } else
              A6.attr(K);
          }
        }
      }, r6.prototype._clear = function() {
        var t2 = this, s = this._elMap;
        s.each(function(u) {
          Rz(u, Bm(u).option, s, t2._lastGraphicModel);
        }), this._elMap = Ta();
      }, r6.prototype.dispose = function() {
        this._clear();
      }, r6.type = "graphic", r6;
    }(Rc);
    function aJ(a) {
      var r6 = Da(Xme, a) ? Xme[a] : B(a), t2 = new r6({});
      return Bm(t2).type = a, t2;
    }
    function Kme(a, r6, t2, s) {
      var u = aJ(t2);
      return r6.add(u), s.set(a, u), Bm(u).id = a, Bm(u).isNew = true, u;
    }
    function Rz(a, r6, t2, s) {
      var u = a && a.parent;
      u && (a.type === "group" && a.traverse(function(f6) {
        Rz(f6, r6, t2, s);
      }), Ez(a, r6, s), t2.removeKey(Bm(a).id));
    }
    function Jme(a, r6, t2, s) {
      if (!a.isGroup) {
        var u = a;
        u.cursor = qi(r6.cursor, cg.prototype.cursor), u.z = qi(r6.z, t2 || 0), u.zlevel = qi(r6.zlevel, s || 0);
        var f6 = r6.z2;
        f6 != null && (u.z2 = f6 || 0);
      }
      Ne(Po(r6), function(d6) {
        var v6 = r6[d6];
        d6.indexOf("on") === 0 && ti(v6) && (a[d6] = v6);
      }), a.draggable = r6.draggable, r6.name != null && (a.name = r6.name), r6.id != null && (a.id = r6.id);
    }
    function z$e(a) {
      return a = qn({}, a), Ne(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(xce), function(r6) {
        delete a[r6];
      }), a;
    }
    function B$e(a, r6, t2) {
      var s = ii(a).eventData;
      !a.silent && !a.ignore && !s && (s = ii(a).eventData = { componentType: "graphic", componentIndex: r6.componentIndex, name: a.name }), s && (s.info = t2.info);
    }
    function j$e(a) {
      a.registerComponentModel(N$e), a.registerComponentView(V$e), a.registerPreprocessor(function(r6) {
        var t2 = r6.graphic;
        br(t2) ? !t2[0] || !t2[0].elements ? r6.graphic = [{ elements: t2 }] : r6.graphic = [r6.graphic[0]] : t2 && !t2.elements && (r6.graphic = [{ elements: [t2] }]);
      });
    }
    var Qme = ["x", "y", "radius", "angle", "single"], G$e = ["cartesian2d", "polar", "singleAxis"];
    function W$e(a) {
      var r6 = a.get("coordinateSystem");
      return Vi(G$e, r6) >= 0;
    }
    function fS(a) {
      return a + "Axis";
    }
    function H$e(a, r6) {
      var t2 = Ta(), s = [], u = Ta();
      a.eachComponent({ mainType: "dataZoom", query: r6 }, function(x6) {
        u.get(x6.uid) || v6(x6);
      });
      var f6;
      do
        f6 = false, a.eachComponent("dataZoom", d6);
      while (f6);
      function d6(x6) {
        !u.get(x6.uid) && m6(x6) && (v6(x6), f6 = true);
      }
      function v6(x6) {
        u.set(x6.uid, true), s.push(x6), b6(x6);
      }
      function m6(x6) {
        var S = false;
        return x6.eachTargetAxis(function(M, A6) {
          var I = t2.get(M);
          I && I[A6] && (S = true);
        }), S;
      }
      function b6(x6) {
        x6.eachTargetAxis(function(S, M) {
          (t2.get(S) || t2.set(S, []))[M] = true;
        });
      }
      return s;
    }
    function eye(a) {
      var r6 = a.ecModel, t2 = { infoList: [], infoMap: Ta() };
      return a.eachTargetAxis(function(s, u) {
        var f6 = r6.getComponent(fS(s), u);
        if (f6) {
          var d6 = f6.getCoordSysModel();
          if (d6) {
            var v6 = d6.uid, m6 = t2.infoMap.get(v6);
            m6 || (m6 = { model: d6, axisModels: [] }, t2.infoList.push(m6), t2.infoMap.set(v6, m6)), m6.axisModels.push(f6);
          }
        }
      }), t2;
    }
    var iJ = function() {
      function a() {
        this.indexList = [], this.indexMap = [];
      }
      return a.prototype.add = function(r6) {
        this.indexMap[r6] || (this.indexList.push(r6), this.indexMap[r6] = true);
      }, a;
    }(), $$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._autoThrottle = true, t2._noTarget = true, t2._rangePropMode = ["percent", "percent"], t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        var f6 = tye(t2);
        this.settledOption = f6, this.mergeDefaultAndTheme(t2, u), this._doInit(f6);
      }, r6.prototype.mergeOption = function(t2) {
        var s = tye(t2);
        Di(this.option, t2, true), Di(this.settledOption, s, true), this._doInit(s);
      }, r6.prototype._doInit = function(t2) {
        var s = this.option;
        this._setDefaultThrottle(t2), this._updateRangeUse(t2);
        var u = this.settledOption;
        Ne([["start", "startValue"], ["end", "endValue"]], function(f6, d6) {
          this._rangePropMode[d6] === "value" && (s[f6[0]] = u[f6[0]] = null);
        }, this), this._resetTarget();
      }, r6.prototype._resetTarget = function() {
        var t2 = this.get("orient", true), s = this._targetAxisInfoMap = Ta(), u = this._fillSpecifiedTargetAxis(s);
        u ? this._orient = t2 || this._makeAutoOrientByTargetAxis() : (this._orient = t2 || "horizontal", this._fillAutoTargetAxisByOrient(s, this._orient)), this._noTarget = true, s.each(function(f6) {
          f6.indexList.length && (this._noTarget = false);
        }, this);
      }, r6.prototype._fillSpecifiedTargetAxis = function(t2) {
        var s = false;
        return Ne(Qme, function(u) {
          var f6 = this.getReferringComponents(fS(u), Y9);
          if (f6.specified) {
            s = true;
            var d6 = new iJ();
            Ne(f6.models, function(v6) {
              d6.add(v6.componentIndex);
            }), t2.set(u, d6);
          }
        }, this), s;
      }, r6.prototype._fillAutoTargetAxisByOrient = function(t2, s) {
        var u = this.ecModel, f6 = true;
        if (f6) {
          var d6 = s === "vertical" ? "y" : "x", v6 = u.findComponents({ mainType: d6 + "Axis" });
          m6(v6, d6);
        }
        if (f6) {
          var v6 = u.findComponents({ mainType: "singleAxis", filter: function(x6) {
            return x6.get("orient", true) === s;
          } });
          m6(v6, "single");
        }
        function m6(b6, x6) {
          var S = b6[0];
          if (S) {
            var M = new iJ();
            if (M.add(S.componentIndex), t2.set(x6, M), f6 = false, x6 === "x" || x6 === "y") {
              var A6 = S.getReferringComponents("grid", Lc).models[0];
              A6 && Ne(b6, function(I) {
                S.componentIndex !== I.componentIndex && A6 === I.getReferringComponents("grid", Lc).models[0] && M.add(I.componentIndex);
              });
            }
          }
        }
        f6 && Ne(Qme, function(b6) {
          if (f6) {
            var x6 = u.findComponents({ mainType: fS(b6), filter: function(M) {
              return M.get("type", true) === "category";
            } });
            if (x6[0]) {
              var S = new iJ();
              S.add(x6[0].componentIndex), t2.set(b6, S), f6 = false;
            }
          }
        }, this);
      }, r6.prototype._makeAutoOrientByTargetAxis = function() {
        var t2;
        return this.eachTargetAxis(function(s) {
          !t2 && (t2 = s);
        }, this), t2 === "y" ? "vertical" : "horizontal";
      }, r6.prototype._setDefaultThrottle = function(t2) {
        if (t2.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
          var s = this.ecModel.option;
          this.option.throttle = s.animation && s.animationDurationUpdate > 0 ? 100 : 20;
        }
      }, r6.prototype._updateRangeUse = function(t2) {
        var s = this._rangePropMode, u = this.get("rangeMode");
        Ne([["start", "startValue"], ["end", "endValue"]], function(f6, d6) {
          var v6 = t2[f6[0]] != null, m6 = t2[f6[1]] != null;
          v6 && !m6 ? s[d6] = "percent" : !v6 && m6 ? s[d6] = "value" : u ? s[d6] = u[d6] : v6 && (s[d6] = "percent");
        });
      }, r6.prototype.noTarget = function() {
        return this._noTarget;
      }, r6.prototype.getFirstTargetAxisModel = function() {
        var t2;
        return this.eachTargetAxis(function(s, u) {
          t2 == null && (t2 = this.ecModel.getComponent(fS(s), u));
        }, this), t2;
      }, r6.prototype.eachTargetAxis = function(t2, s) {
        this._targetAxisInfoMap.each(function(u, f6) {
          Ne(u.indexList, function(d6) {
            t2.call(s, f6, d6);
          });
        });
      }, r6.prototype.getAxisProxy = function(t2, s) {
        var u = this.getAxisModel(t2, s);
        if (u)
          return u.__dzAxisProxy;
      }, r6.prototype.getAxisModel = function(t2, s) {
        var u = this._targetAxisInfoMap.get(t2);
        if (u && u.indexMap[s])
          return this.ecModel.getComponent(fS(t2), s);
      }, r6.prototype.setRawRange = function(t2) {
        var s = this.option, u = this.settledOption;
        Ne([["start", "startValue"], ["end", "endValue"]], function(f6) {
          (t2[f6[0]] != null || t2[f6[1]] != null) && (s[f6[0]] = u[f6[0]] = t2[f6[0]], s[f6[1]] = u[f6[1]] = t2[f6[1]]);
        }, this), this._updateRangeUse(t2);
      }, r6.prototype.setCalculatedRange = function(t2) {
        var s = this.option;
        Ne(["start", "startValue", "end", "endValue"], function(u) {
          s[u] = t2[u];
        });
      }, r6.prototype.getPercentRange = function() {
        var t2 = this.findRepresentativeAxisProxy();
        if (t2)
          return t2.getDataPercentWindow();
      }, r6.prototype.getValueRange = function(t2, s) {
        if (t2 == null && s == null) {
          var u = this.findRepresentativeAxisProxy();
          if (u)
            return u.getDataValueWindow();
        } else
          return this.getAxisProxy(t2, s).getDataValueWindow();
      }, r6.prototype.findRepresentativeAxisProxy = function(t2) {
        if (t2)
          return t2.__dzAxisProxy;
        for (var s, u = this._targetAxisInfoMap.keys(), f6 = 0; f6 < u.length; f6++)
          for (var d6 = u[f6], v6 = this._targetAxisInfoMap.get(d6), m6 = 0; m6 < v6.indexList.length; m6++) {
            var b6 = this.getAxisProxy(d6, v6.indexList[m6]);
            if (b6.hostedBy(this))
              return b6;
            s || (s = b6);
          }
        return s;
      }, r6.prototype.getRangePropMode = function() {
        return this._rangePropMode.slice();
      }, r6.prototype.getOrient = function() {
        return this._orient;
      }, r6.type = "dataZoom", r6.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], r6.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, r6;
    }(Ps);
    function tye(a) {
      var r6 = {};
      return Ne(["start", "end", "startValue", "endValue", "throttle"], function(t2) {
        a.hasOwnProperty(t2) && (r6[t2] = a[t2]);
      }), r6;
    }
    var b4 = $$e, U$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "dataZoom.select", r6;
    }(b4), q$e = U$e, Y$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        this.dataZoomModel = t2, this.ecModel = s, this.api = u;
      }, r6.type = "dataZoom", r6;
    }(Rc), oJ = Y$e, Z$e = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "dataZoom.select", r6;
    }(oJ), X$e = Z$e, A5 = Ne, nye = Sv, K$e = function() {
      function a(r6, t2, s, u) {
        this._dimName = r6, this._axisIndex = t2, this.ecModel = u, this._dataZoomModel = s;
      }
      return a.prototype.hostedBy = function(r6) {
        return this._dataZoomModel === r6;
      }, a.prototype.getDataValueWindow = function() {
        return this._valueWindow.slice();
      }, a.prototype.getDataPercentWindow = function() {
        return this._percentWindow.slice();
      }, a.prototype.getTargetSeriesModels = function() {
        var r6 = [];
        return this.ecModel.eachSeries(function(t2) {
          if (W$e(t2)) {
            var s = fS(this._dimName), u = t2.getReferringComponents(s, Lc).models[0];
            u && this._axisIndex === u.componentIndex && r6.push(t2);
          }
        }, this), r6;
      }, a.prototype.getAxisModel = function() {
        return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
      }, a.prototype.getMinMaxSpan = function() {
        return Qa(this._minMaxSpan);
      }, a.prototype.calculateDataWindow = function(r6) {
        var t2 = this._dataExtent, s = this.getAxisModel(), u = s.axis.scale, f6 = this._dataZoomModel.getRangePropMode(), d6 = [0, 100], v6 = [], m6 = [], b6;
        A5(["start", "end"], function(M, A6) {
          var I = r6[M], R = r6[M + "Value"];
          f6[A6] === "percent" ? (I == null && (I = d6[A6]), R = u.parse(gs(I, d6, t2))) : (b6 = true, R = R == null ? t2[A6] : u.parse(R), I = gs(R, t2, d6)), m6[A6] = R, v6[A6] = I;
        }), nye(m6), nye(v6);
        var x6 = this._minMaxSpan;
        b6 ? S(m6, v6, t2, d6, false) : S(v6, m6, d6, t2, true);
        function S(M, A6, I, R, F) {
          var j = F ? "Span" : "ValueSpan";
          kA(0, M, I, "all", x6["min" + j], x6["max" + j]);
          for (var $ = 0; $ < 2; $++)
            A6[$] = gs(M[$], I, R, true), F && (A6[$] = u.parse(A6[$]));
        }
        return { valueWindow: m6, percentWindow: v6 };
      }, a.prototype.reset = function(r6) {
        if (r6 === this._dataZoomModel) {
          var t2 = this.getTargetSeriesModels();
          this._dataExtent = J$e(this, this._dimName, t2), this._updateMinMaxSpan();
          var s = this.calculateDataWindow(r6.settledOption);
          this._valueWindow = s.valueWindow, this._percentWindow = s.percentWindow, this._setAxisModel();
        }
      }, a.prototype.filterData = function(r6, t2) {
        if (r6 !== this._dataZoomModel)
          return;
        var s = this._dimName, u = this.getTargetSeriesModels(), f6 = r6.get("filterMode"), d6 = this._valueWindow;
        if (f6 === "none")
          return;
        A5(u, function(m6) {
          var b6 = m6.getData(), x6 = b6.mapDimensionsAll(s);
          if (x6.length) {
            if (f6 === "weakFilter") {
              var S = b6.getStore(), M = wr(x6, function(A6) {
                return b6.getDimensionIndex(A6);
              }, b6);
              b6.filterSelf(function(A6) {
                for (var I, R, F, j = 0; j < x6.length; j++) {
                  var $ = S.get(M[j], A6), K = !isNaN($), U = $ < d6[0], he = $ > d6[1];
                  if (K && !U && !he)
                    return true;
                  K && (F = true), U && (I = true), he && (R = true);
                }
                return F && I && R;
              });
            } else
              A5(x6, function(A6) {
                if (f6 === "empty")
                  m6.setData(b6 = b6.map(A6, function(R) {
                    return v6(R) ? R : NaN;
                  }));
                else {
                  var I = {};
                  I[A6] = d6, b6.selectRange(I);
                }
              });
            A5(x6, function(A6) {
              b6.setApproximateExtent(d6, A6);
            });
          }
        });
        function v6(m6) {
          return m6 >= d6[0] && m6 <= d6[1];
        }
      }, a.prototype._updateMinMaxSpan = function() {
        var r6 = this._minMaxSpan = {}, t2 = this._dataZoomModel, s = this._dataExtent;
        A5(["min", "max"], function(u) {
          var f6 = t2.get(u + "Span"), d6 = t2.get(u + "ValueSpan");
          d6 != null && (d6 = this.getAxisModel().axis.scale.parse(d6)), d6 != null ? f6 = gs(s[0] + d6, s, [0, 100], true) : f6 != null && (d6 = gs(f6, [0, 100], s, true) - s[0]), r6[u + "Span"] = f6, r6[u + "ValueSpan"] = d6;
        }, this);
      }, a.prototype._setAxisModel = function() {
        var r6 = this.getAxisModel(), t2 = this._percentWindow, s = this._valueWindow;
        if (t2) {
          var u = QL(s, [0, 500]);
          u = Math.min(u, 20);
          var f6 = r6.axis.scale.rawExtentInfo;
          t2[0] !== 0 && f6.setDeterminedMinMax("min", +s[0].toFixed(u)), t2[1] !== 100 && f6.setDeterminedMinMax("max", +s[1].toFixed(u)), f6.freeze();
        }
      }, a;
    }();
    function J$e(a, r6, t2) {
      var s = [1 / 0, -1 / 0];
      A5(t2, function(d6) {
        wFe(s, d6.getData(), r6);
      });
      var u = a.getAxisModel(), f6 = hde(u.axis.scale, u, s).calculate();
      return [f6.min, f6.max];
    }
    var Q$e = K$e, eUe = { getTargetSeries: function(a) {
      function r6(u) {
        a.eachComponent("dataZoom", function(f6) {
          f6.eachTargetAxis(function(d6, v6) {
            var m6 = a.getComponent(fS(d6), v6);
            u(d6, v6, m6, f6);
          });
        });
      }
      r6(function(u, f6, d6, v6) {
        d6.__dzAxisProxy = null;
      });
      var t2 = [];
      r6(function(u, f6, d6, v6) {
        d6.__dzAxisProxy || (d6.__dzAxisProxy = new Q$e(u, f6, v6, a), t2.push(d6.__dzAxisProxy));
      });
      var s = Ta();
      return Ne(t2, function(u) {
        Ne(u.getTargetSeriesModels(), function(f6) {
          s.set(f6.uid, f6);
        });
      }), s;
    }, overallReset: function(a, r6) {
      a.eachComponent("dataZoom", function(t2) {
        t2.eachTargetAxis(function(s, u) {
          t2.getAxisProxy(s, u).reset(t2);
        }), t2.eachTargetAxis(function(s, u) {
          t2.getAxisProxy(s, u).filterData(t2, r6);
        });
      }), a.eachComponent("dataZoom", function(t2) {
        var s = t2.findRepresentativeAxisProxy();
        if (s) {
          var u = s.getDataPercentWindow(), f6 = s.getDataValueWindow();
          t2.setCalculatedRange({ start: u[0], end: u[1], startValue: f6[0], endValue: f6[1] });
        }
      });
    } }, tUe = eUe;
    function nUe(a) {
      a.registerAction("dataZoom", function(r6, t2) {
        var s = H$e(t2, r6);
        Ne(s, function(u) {
          u.setRawRange({ start: r6.start, end: r6.end, startValue: r6.startValue, endValue: r6.endValue });
        });
      });
    }
    var rye = false;
    function sJ(a) {
      rye || (rye = true, a.registerProcessor(a.PRIORITY.PROCESSOR.FILTER, tUe), nUe(a), a.registerSubTypeDefaulter("dataZoom", function() {
        return "slider";
      }));
    }
    function rUe(a) {
      a.registerComponentModel(q$e), a.registerComponentView(X$e), sJ(a);
    }
    var jm = function() {
      function a() {
      }
      return a;
    }(), aye = {};
    function E5(a, r6) {
      aye[a] = r6;
    }
    function iye(a) {
      return aye[a];
    }
    var aUe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.optionUpdated = function() {
        a.prototype.optionUpdated.apply(this, arguments);
        var t2 = this.ecModel;
        Ne(this.option.feature, function(s, u) {
          var f6 = iye(u);
          f6 && (f6.getDefaultOption && (f6.defaultOption = f6.getDefaultOption(t2)), Di(s, f6.defaultOption));
        });
      }, r6.type = "toolbox", r6.layoutMode = { type: "box", ignoreSize: true }, r6.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, r6;
    }(Ps), iUe = aUe;
    function oUe(a, r6, t2) {
      var s = r6.getBoxLayoutParams(), u = r6.get("padding"), f6 = { width: t2.getWidth(), height: t2.getHeight() }, d6 = ah(s, f6, u);
      cA(r6.get("orient"), a, r6.get("itemGap"), d6.width, d6.height), fV(a, s, f6, u);
    }
    function oye(a, r6) {
      var t2 = KD(r6.get("padding")), s = r6.getItemStyle(["color", "opacity"]);
      return s.fill = r6.get("backgroundColor"), a = new rs({ shape: { x: a.x - t2[3], y: a.y - t2[0], width: a.width + t2[1] + t2[3], height: a.height + t2[0] + t2[2], r: r6.get("borderRadius") }, style: s, silent: true, z2: -1 }), a;
    }
    var sUe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        var d6 = this.group;
        if (d6.removeAll(), !t2.get("show"))
          return;
        var v6 = +t2.get("itemSize"), m6 = t2.get("feature") || {}, b6 = this._features || (this._features = {}), x6 = [];
        Ne(m6, function(A6, I) {
          x6.push(I);
        }), new Gx(this._featureNames || [], x6).add(S).update(S).remove(Oi(S, null)).execute(), this._featureNames = x6;
        function S(A6, I) {
          var R = x6[A6], F = x6[I], j = m6[R], $ = new yu(j, t2, t2.ecModel), K;
          if (f6 && f6.newTitle != null && f6.featureName === R && (j.title = f6.newTitle), R && !F) {
            if (lUe(R))
              K = { onclick: $.option.onclick, featureName: R };
            else {
              var U = iye(R);
              if (!U)
                return;
              K = new U();
            }
            b6[R] = K;
          } else if (K = b6[F], !K)
            return;
          K.uid = YD("toolbox-feature"), K.model = $, K.ecModel = s, K.api = u;
          var he = K instanceof jm;
          if (!R && F) {
            he && K.dispose && K.dispose(s, u);
            return;
          }
          if (!$.get("show") || he && K.unusable) {
            he && K.remove && K.remove(s, u);
            return;
          }
          M($, K, R), $.setIconStatus = function(ue, pe) {
            var _e = this.option, xe = this.iconPaths;
            _e.iconStatus = _e.iconStatus || {}, _e.iconStatus[ue] = pe, xe[ue] && (pe === "emphasis" ? Cm : Mm)(xe[ue]);
          }, K instanceof jm && K.render && K.render($, s, u, f6);
        }
        function M(A6, I, R) {
          var F = A6.getModel("iconStyle"), j = A6.getModel(["emphasis", "iconStyle"]), $ = I instanceof jm && I.getIcons ? I.getIcons() : A6.get("icon"), K = A6.get("title") || {}, U, he;
          _a2($) ? (U = {}, U[R] = $) : U = $, _a2(K) ? (he = {}, he[R] = K) : he = K;
          var ue = A6.iconPaths = {};
          Ne(U, function(pe, _e) {
            var xe = ys(pe, {}, { x: -v6 / 2, y: -v6 / 2, width: v6, height: v6 });
            xe.setStyle(F.getItemStyle());
            var Ae = xe.ensureState("emphasis");
            Ae.style = j.getItemStyle();
            var ke = new ms({ style: { text: he[_e], align: j.get("textAlign"), borderRadius: j.get("textBorderRadius"), padding: j.get("textPadding"), fill: null }, ignore: true });
            xe.setTextContent(ke), fd({ el: xe, componentModel: t2, itemName: _e, formatterParamsExtra: { title: he[_e] } }), xe.__title = he[_e], xe.on("mouseover", function() {
              var je = j.getItemStyle(), Fe = t2.get("orient") === "vertical" ? t2.get("right") == null ? "right" : "left" : t2.get("bottom") == null ? "bottom" : "top";
              ke.setStyle({ fill: j.get("textFill") || je.fill || je.stroke || "#000", backgroundColor: j.get("textBackgroundColor") }), xe.setTextConfig({ position: j.get("textPosition") || Fe }), ke.ignore = !t2.get("showTitle"), Cm(this);
            }).on("mouseout", function() {
              A6.get(["iconStatus", _e]) !== "emphasis" && Mm(this), ke.hide();
            }), (A6.get(["iconStatus", _e]) === "emphasis" ? Cm : Mm)(xe), d6.add(xe), xe.on("click", Ca(I.onclick, I, s, u, _e)), ue[_e] = xe;
          });
        }
        oUe(d6, t2, u), d6.add(oye(d6.getBoundingRect(), t2)), d6.eachChild(function(A6) {
          var I = A6.__title, R = A6.ensureState("emphasis"), F = R.textConfig || (R.textConfig = {}), j = A6.getTextContent(), $ = j && j.states.emphasis;
          if ($ && !ti($) && I) {
            var K = $.style || ($.style = {}), U = bx(I, ms.makeFont(K)), he = A6.x + d6.x, ue = A6.y + d6.y + v6, pe = false;
            ue + U.height > u.getHeight() && (F.position = "top", pe = true);
            var _e = pe ? -5 - U.height : v6 + 8;
            he + U.width / 2 > u.getWidth() ? (F.position = ["100%", _e], K.align = "right") : he - U.width / 2 < 0 && (F.position = [0, _e], K.align = "left");
          }
        });
      }, r6.prototype.updateView = function(t2, s, u, f6) {
        Ne(this._features, function(d6) {
          d6 instanceof jm && d6.updateView && d6.updateView(d6.model, s, u, f6);
        });
      }, r6.prototype.remove = function(t2, s) {
        Ne(this._features, function(u) {
          u instanceof jm && u.remove && u.remove(t2, s);
        }), this.group.removeAll();
      }, r6.prototype.dispose = function(t2, s) {
        Ne(this._features, function(u) {
          u instanceof jm && u.dispose && u.dispose(t2, s);
        });
      }, r6.type = "toolbox", r6;
    }(Rc);
    function lUe(a) {
      return a.indexOf("my") === 0;
    }
    var uUe = sUe, cUe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.onclick = function(t2, s) {
        var u = this.model, f6 = u.get("name") || t2.get("title.0.text") || "echarts", d6 = s.getZr().painter.getType() === "svg", v6 = d6 ? "svg" : u.get("type", true) || "png", m6 = s.getConnectedDataURL({ type: v6, backgroundColor: u.get("backgroundColor", true) || t2.get("backgroundColor") || "#fff", connectedBackgroundColor: u.get("connectedBackgroundColor"), excludeComponents: u.get("excludeComponents"), pixelRatio: u.get("pixelRatio") }), b6 = ha.browser;
        if (ti(MouseEvent) && (b6.newEdge || !b6.ie && !b6.edge)) {
          var x6 = document.createElement("a");
          x6.download = f6 + "." + v6, x6.target = "_blank", x6.href = m6;
          var S = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
          x6.dispatchEvent(S);
        } else if (window.navigator.msSaveOrOpenBlob || d6) {
          var M = m6.split(","), A6 = M[0].indexOf("base64") > -1, I = d6 ? decodeURIComponent(M[1]) : M[1];
          A6 && (I = window.atob(I));
          var R = f6 + "." + v6;
          if (window.navigator.msSaveOrOpenBlob) {
            for (var F = I.length, j = new Uint8Array(F); F--; )
              j[F] = I.charCodeAt(F);
            var $ = new Blob([j]);
            window.navigator.msSaveOrOpenBlob($, R);
          } else {
            var K = document.createElement("iframe");
            document.body.appendChild(K);
            var U = K.contentWindow, he = U.document;
            he.open("image/svg+xml", "replace"), he.write(I), he.close(), U.focus(), he.execCommand("SaveAs", true, R), document.body.removeChild(K);
          }
        } else {
          var ue = u.get("lang"), pe = '<body style="margin:0;"><img src="' + m6 + '" style="max-width:100%;" title="' + (ue && ue[0] || "") + '" /></body>', _e = window.open();
          _e.document.write(pe), _e.document.title = f6;
        }
      }, r6.getDefaultOption = function(t2) {
        var s = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: t2.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: t2.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
        return s;
      }, r6;
    }(jm), fUe = cUe, sye = "__ec_magicType_stack__", hUe = [["line", "bar"], ["stack"]], dUe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.getIcons = function() {
        var t2 = this.model, s = t2.get("icon"), u = {};
        return Ne(t2.get("type"), function(f6) {
          s[f6] && (u[f6] = s[f6]);
        }), u;
      }, r6.getDefaultOption = function(t2) {
        var s = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: t2.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
        return s;
      }, r6.prototype.onclick = function(t2, s, u) {
        var f6 = this.model, d6 = f6.get(["seriesIndex", u]);
        if (lye[u]) {
          var v6 = { series: [] }, m6 = function(S) {
            var M = S.subType, A6 = S.id, I = lye[u](M, A6, S, f6);
            I && (ei(I, S.option), v6.series.push(I));
            var R = S.coordinateSystem;
            if (R && R.type === "cartesian2d" && (u === "line" || u === "bar")) {
              var F = R.getAxesByScale("ordinal")[0];
              if (F) {
                var j = F.dim, $ = j + "Axis", K = S.getReferringComponents($, Lc).models[0], U = K.componentIndex;
                v6[$] = v6[$] || [];
                for (var he = 0; he <= U; he++)
                  v6[$][U] = v6[$][U] || {};
                v6[$][U].boundaryGap = u === "bar";
              }
            }
          };
          Ne(hUe, function(S) {
            Vi(S, u) >= 0 && Ne(S, function(M) {
              f6.setIconStatus(M, "normal");
            });
          }), f6.setIconStatus(u, "emphasis"), t2.eachComponent({ mainType: "series", query: d6 == null ? null : { seriesIndex: d6 } }, m6);
          var b6, x6 = u;
          u === "stack" && (b6 = Di({ stack: f6.option.title.tiled, tiled: f6.option.title.stack }, f6.option.title), f6.get(["iconStatus", u]) !== "emphasis" && (x6 = "tiled")), s.dispatchAction({ type: "changeMagicType", currentType: x6, newOption: v6, newTitle: b6, featureName: "magicType" });
        }
      }, r6;
    }(jm), lye = { line: function(a, r6, t2, s) {
      if (a === "bar")
        return Di({ id: r6, type: "line", data: t2.get("data"), stack: t2.get("stack"), markPoint: t2.get("markPoint"), markLine: t2.get("markLine") }, s.get(["option", "line"]) || {}, true);
    }, bar: function(a, r6, t2, s) {
      if (a === "line")
        return Di({ id: r6, type: "bar", data: t2.get("data"), stack: t2.get("stack"), markPoint: t2.get("markPoint"), markLine: t2.get("markLine") }, s.get(["option", "bar"]) || {}, true);
    }, stack: function(a, r6, t2, s) {
      var u = t2.get("stack") === sye;
      if (a === "line" || a === "bar")
        return s.setIconStatus("stack", u ? "normal" : "emphasis"), Di({ id: r6, stack: u ? "" : sye }, s.get(["option", "stack"]) || {}, true);
    } };
    Nb({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(a, r6) {
      r6.mergeOption(a.newOption);
    });
    var pUe = dUe, Fz = new Array(60).join("-"), I5 = "	";
    function vUe(a) {
      var r6 = {}, t2 = [], s = [];
      return a.eachRawSeries(function(u) {
        var f6 = u.coordinateSystem;
        if (f6 && (f6.type === "cartesian2d" || f6.type === "polar")) {
          var d6 = f6.getBaseAxis();
          if (d6.type === "category") {
            var v6 = d6.dim + "_" + d6.index;
            r6[v6] || (r6[v6] = { categoryAxis: d6, valueAxis: f6.getOtherAxis(d6), series: [] }, s.push({ axisDim: d6.dim, axisIndex: d6.index })), r6[v6].series.push(u);
          } else
            t2.push(u);
        } else
          t2.push(u);
      }), { seriesGroupByCategoryAxis: r6, other: t2, meta: s };
    }
    function gUe(a) {
      var r6 = [];
      return Ne(a, function(t2, s) {
        var u = t2.categoryAxis, f6 = t2.valueAxis, d6 = f6.dim, v6 = [" "].concat(wr(t2.series, function(A6) {
          return A6.name;
        })), m6 = [u.model.getCategories()];
        Ne(t2.series, function(A6) {
          var I = A6.getRawData();
          m6.push(A6.getRawData().mapArray(I.mapDimension(d6), function(R) {
            return R;
          }));
        });
        for (var b6 = [v6.join(I5)], x6 = 0; x6 < m6[0].length; x6++) {
          for (var S = [], M = 0; M < m6.length; M++)
            S.push(m6[M][x6]);
          b6.push(S.join(I5));
        }
        r6.push(b6.join(`
`));
      }), r6.join(`

` + Fz + `

`);
    }
    function mUe(a) {
      return wr(a, function(r6) {
        var t2 = r6.getRawData(), s = [r6.name], u = [];
        return t2.each(t2.dimensions, function() {
          for (var f6 = arguments.length, d6 = arguments[f6 - 1], v6 = t2.getName(d6), m6 = 0; m6 < f6 - 1; m6++)
            u[m6] = arguments[m6];
          s.push((v6 ? v6 + I5 : "") + u.join(I5));
        }), s.join(`
`);
      }).join(`

` + Fz + `

`);
    }
    function yUe(a) {
      var r6 = vUe(a);
      return { value: gl([gUe(r6.seriesGroupByCategoryAxis), mUe(r6.other)], function(t2) {
        return !!t2.replace(/[\n\t\s]/g, "");
      }).join(`

` + Fz + `

`), meta: r6.meta };
    }
    function Nz(a) {
      return a.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
    }
    function bUe(a) {
      var r6 = a.slice(0, a.indexOf(`
`));
      if (r6.indexOf(I5) >= 0)
        return true;
    }
    var lJ = new RegExp("[" + I5 + "]+", "g");
    function _Ue(a) {
      for (var r6 = a.split(/\n+/g), t2 = Nz(r6.shift()).split(lJ), s = [], u = wr(t2, function(m6) {
        return { name: m6, data: [] };
      }), f6 = 0; f6 < r6.length; f6++) {
        var d6 = Nz(r6[f6]).split(lJ);
        s.push(d6.shift());
        for (var v6 = 0; v6 < d6.length; v6++)
          u[v6] && (u[v6].data[f6] = d6[v6]);
      }
      return { series: u, categories: s };
    }
    function xUe(a) {
      for (var r6 = a.split(/\n+/g), t2 = Nz(r6.shift()), s = [], u = 0; u < r6.length; u++) {
        var f6 = Nz(r6[u]);
        if (f6) {
          var d6 = f6.split(lJ), v6 = "", m6 = void 0, b6 = false;
          isNaN(d6[0]) ? (b6 = true, v6 = d6[0], d6 = d6.slice(1), s[u] = { name: v6, value: [] }, m6 = s[u].value) : m6 = s[u] = [];
          for (var x6 = 0; x6 < d6.length; x6++)
            m6.push(+d6[x6]);
          m6.length === 1 && (b6 ? s[u].value = m6[0] : s[u] = m6[0]);
        }
      }
      return { name: t2, data: s };
    }
    function wUe(a, r6) {
      var t2 = a.split(new RegExp(`
*` + Fz + `
*`, "g")), s = { series: [] };
      return Ne(t2, function(u, f6) {
        if (bUe(u)) {
          var d6 = _Ue(u), v6 = r6[f6], m6 = v6.axisDim + "Axis";
          v6 && (s[m6] = s[m6] || [], s[m6][v6.axisIndex] = { data: d6.categories }, s.series = s.series.concat(d6.series));
        } else {
          var d6 = xUe(u);
          s.series.push(d6);
        }
      }), s;
    }
    var SUe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.onclick = function(t2, s) {
        setTimeout(function() {
          s.dispatchAction({ type: "hideTip" });
        });
        var u = s.getDom(), f6 = this.model;
        this._dom && u.removeChild(this._dom);
        var d6 = document.createElement("div");
        d6.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", d6.style.backgroundColor = f6.get("backgroundColor") || "#fff";
        var v6 = document.createElement("h4"), m6 = f6.get("lang") || [];
        v6.innerHTML = m6[0] || f6.get("title"), v6.style.cssText = "margin:10px 20px", v6.style.color = f6.get("textColor");
        var b6 = document.createElement("div"), x6 = document.createElement("textarea");
        b6.style.cssText = "overflow:auto";
        var S = f6.get("optionToContent"), M = f6.get("contentToOption"), A6 = yUe(t2);
        if (ti(S)) {
          var I = S(s.getOption());
          _a2(I) ? b6.innerHTML = I : hM(I) && b6.appendChild(I);
        } else {
          x6.readOnly = f6.get("readOnly");
          var R = x6.style;
          R.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", R.color = f6.get("textColor"), R.borderColor = f6.get("textareaBorderColor"), R.backgroundColor = f6.get("textareaColor"), x6.value = A6.value, b6.appendChild(x6);
        }
        var F = A6.meta, j = document.createElement("div");
        j.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
        var $ = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", K = document.createElement("div"), U = document.createElement("div");
        $ += ";background-color:" + f6.get("buttonColor"), $ += ";color:" + f6.get("buttonTextColor");
        var he = this;
        function ue() {
          u.removeChild(d6), he._dom = null;
        }
        SL(K, "click", ue), SL(U, "click", function() {
          if (M == null && S != null || M != null && S == null) {
            ue();
            return;
          }
          var pe;
          try {
            ti(M) ? pe = M(b6, s.getOption()) : pe = wUe(x6.value, F);
          } catch (_e) {
            throw ue(), new Error("Data view format error " + _e);
          }
          pe && s.dispatchAction({ type: "changeDataView", newOption: pe }), ue();
        }), K.innerHTML = m6[1], U.innerHTML = m6[2], U.style.cssText = K.style.cssText = $, !f6.get("readOnly") && j.appendChild(U), j.appendChild(K), d6.appendChild(v6), d6.appendChild(b6), d6.appendChild(j), b6.style.height = u.clientHeight - 80 + "px", u.appendChild(d6), this._dom = d6;
      }, r6.prototype.remove = function(t2, s) {
        this._dom && s.getDom().removeChild(this._dom);
      }, r6.prototype.dispose = function(t2, s) {
        this.remove(t2, s);
      }, r6.getDefaultOption = function(t2) {
        var s = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: t2.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: t2.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
        return s;
      }, r6;
    }(jm);
    function CUe(a, r6) {
      return wr(a, function(t2, s) {
        var u = r6 && r6[s];
        if (ui(u) && !br(u)) {
          var f6 = ui(t2) && !br(t2);
          f6 || (t2 = { value: t2 });
          var d6 = u.name != null && t2.name == null;
          return t2 = ei(t2, u), d6 && delete t2.name, t2;
        } else
          return t2;
      });
    }
    Nb({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(a, r6) {
      var t2 = [];
      Ne(a.newOption.series, function(s) {
        var u = r6.getSeriesByName(s.name)[0];
        if (!u)
          t2.push(qn({ type: "scatter" }, s));
        else {
          var f6 = u.get("data");
          t2.push({ name: s.name, data: CUe(s.data, f6) });
        }
      }), r6.mergeOption(ei({ series: t2 }, a.newOption));
    });
    var MUe = SUe, uye = Ne, cye = Xo();
    function AUe(a, r6) {
      var t2 = uJ(a);
      uye(r6, function(s, u) {
        for (var f6 = t2.length - 1; f6 >= 0; f6--) {
          var d6 = t2[f6];
          if (d6[u])
            break;
        }
        if (f6 < 0) {
          var v6 = a.queryComponents({ mainType: "dataZoom", subType: "select", id: u })[0];
          if (v6) {
            var m6 = v6.getPercentRange();
            t2[0][u] = { dataZoomId: u, start: m6[0], end: m6[1] };
          }
        }
      }), t2.push(r6);
    }
    function EUe(a) {
      var r6 = uJ(a), t2 = r6[r6.length - 1];
      r6.length > 1 && r6.pop();
      var s = {};
      return uye(t2, function(u, f6) {
        for (var d6 = r6.length - 1; d6 >= 0; d6--)
          if (u = r6[d6][f6], u) {
            s[f6] = u;
            break;
          }
      }), s;
    }
    function IUe(a) {
      cye(a).snapshots = null;
    }
    function TUe(a) {
      return uJ(a).length;
    }
    function uJ(a) {
      var r6 = cye(a);
      return r6.snapshots || (r6.snapshots = [{}]), r6.snapshots;
    }
    var DUe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.onclick = function(t2, s) {
        IUe(t2), s.dispatchAction({ type: "restore", from: this.uid });
      }, r6.getDefaultOption = function(t2) {
        var s = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: t2.getLocaleModel().get(["toolbox", "restore", "title"]) };
        return s;
      }, r6;
    }(jm);
    Nb({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(a, r6) {
      r6.resetOption("recreate");
    });
    var kUe = DUe, PUe = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], LUe = function() {
      function a(r6, t2, s) {
        var u = this;
        this._targetInfoList = [];
        var f6 = fye(t2, r6);
        Ne(OUe, function(d6, v6) {
          (!s || !s.include || Vi(s.include, v6) >= 0) && d6(f6, u._targetInfoList);
        });
      }
      return a.prototype.setOutputRanges = function(r6, t2) {
        return this.matchOutputRanges(r6, t2, function(s, u, f6) {
          if ((s.coordRanges || (s.coordRanges = [])).push(u), !s.coordRange) {
            s.coordRange = u;
            var d6 = fJ[s.brushType](0, f6, u);
            s.__rangeOffset = { offset: vye[s.brushType](d6.values, s.range, [1, 1]), xyMinMax: d6.xyMinMax };
          }
        }), r6;
      }, a.prototype.matchOutputRanges = function(r6, t2, s) {
        Ne(r6, function(u) {
          var f6 = this.findTargetInfo(u, t2);
          f6 && f6 !== true && Ne(f6.coordSyses, function(d6) {
            var v6 = fJ[u.brushType](1, d6, u.range, true);
            s(u, v6.values, d6, t2);
          });
        }, this);
      }, a.prototype.setInputRanges = function(r6, t2) {
        Ne(r6, function(s) {
          var u = this.findTargetInfo(s, t2);
          if (s.range = s.range || [], u && u !== true) {
            s.panelId = u.panelId;
            var f6 = fJ[s.brushType](0, u.coordSys, s.coordRange), d6 = s.__rangeOffset;
            s.range = d6 ? vye[s.brushType](f6.values, d6.offset, RUe(f6.xyMinMax, d6.xyMinMax)) : f6.values;
          }
        }, this);
      }, a.prototype.makePanelOpts = function(r6, t2) {
        return wr(this._targetInfoList, function(s) {
          var u = s.getPanelRect();
          return { panelId: s.panelId, defaultBrushType: t2 ? t2(s) : null, clipPath: h0e(u), isTargetByCursor: p0e(u, r6, s.coordSysModel), getLinearBrushOtherExtent: d0e(u) };
        });
      }, a.prototype.controlSeries = function(r6, t2, s) {
        var u = this.findTargetInfo(r6, s);
        return u === true || u && Vi(u.coordSyses, t2.coordinateSystem) >= 0;
      }, a.prototype.findTargetInfo = function(r6, t2) {
        for (var s = this._targetInfoList, u = fye(t2, r6), f6 = 0; f6 < s.length; f6++) {
          var d6 = s[f6], v6 = r6.panelId;
          if (v6) {
            if (d6.panelId === v6)
              return d6;
          } else
            for (var m6 = 0; m6 < hye.length; m6++)
              if (hye[m6](u, d6))
                return d6;
        }
        return true;
      }, a;
    }();
    function cJ(a) {
      return a[0] > a[1] && a.reverse(), a;
    }
    function fye(a, r6) {
      return HM(a, r6, { includeMainTypes: PUe });
    }
    var OUe = { grid: function(a, r6) {
      var t2 = a.xAxisModels, s = a.yAxisModels, u = a.gridModels, f6 = Ta(), d6 = {}, v6 = {};
      !t2 && !s && !u || (Ne(t2, function(m6) {
        var b6 = m6.axis.grid.model;
        f6.set(b6.id, b6), d6[b6.id] = true;
      }), Ne(s, function(m6) {
        var b6 = m6.axis.grid.model;
        f6.set(b6.id, b6), v6[b6.id] = true;
      }), Ne(u, function(m6) {
        f6.set(m6.id, m6), d6[m6.id] = true, v6[m6.id] = true;
      }), f6.each(function(m6) {
        var b6 = m6.coordinateSystem, x6 = [];
        Ne(b6.getCartesians(), function(S, M) {
          (Vi(t2, S.getAxis("x").model) >= 0 || Vi(s, S.getAxis("y").model) >= 0) && x6.push(S);
        }), r6.push({ panelId: "grid--" + m6.id, gridModel: m6, coordSysModel: m6, coordSys: x6[0], coordSyses: x6, getPanelRect: dye.grid, xAxisDeclared: d6[m6.id], yAxisDeclared: v6[m6.id] });
      }));
    }, geo: function(a, r6) {
      Ne(a.geoModels, function(t2) {
        var s = t2.coordinateSystem;
        r6.push({ panelId: "geo--" + t2.id, geoModel: t2, coordSysModel: t2, coordSys: s, coordSyses: [s], getPanelRect: dye.geo });
      });
    } }, hye = [function(a, r6) {
      var t2 = a.xAxisModel, s = a.yAxisModel, u = a.gridModel;
      return !u && t2 && (u = t2.axis.grid.model), !u && s && (u = s.axis.grid.model), u && u === r6.gridModel;
    }, function(a, r6) {
      var t2 = a.geoModel;
      return t2 && t2 === r6.geoModel;
    }], dye = { grid: function() {
      return this.coordSys.master.getRect().clone();
    }, geo: function() {
      var a = this.coordSys, r6 = a.getBoundingRect().clone();
      return r6.applyTransform(Nr(a)), r6;
    } }, fJ = { lineX: Oi(pye, 0), lineY: Oi(pye, 1), rect: function(a, r6, t2, s) {
      var u = a ? r6.pointToData([t2[0][0], t2[1][0]], s) : r6.dataToPoint([t2[0][0], t2[1][0]], s), f6 = a ? r6.pointToData([t2[0][1], t2[1][1]], s) : r6.dataToPoint([t2[0][1], t2[1][1]], s), d6 = [cJ([u[0], f6[0]]), cJ([u[1], f6[1]])];
      return { values: d6, xyMinMax: d6 };
    }, polygon: function(a, r6, t2, s) {
      var u = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], f6 = wr(t2, function(d6) {
        var v6 = a ? r6.pointToData(d6, s) : r6.dataToPoint(d6, s);
        return u[0][0] = Math.min(u[0][0], v6[0]), u[1][0] = Math.min(u[1][0], v6[1]), u[0][1] = Math.max(u[0][1], v6[0]), u[1][1] = Math.max(u[1][1], v6[1]), v6;
      });
      return { values: f6, xyMinMax: u };
    } };
    function pye(a, r6, t2, s) {
      var u = t2.getAxis(["x", "y"][a]), f6 = cJ(wr([0, 1], function(v6) {
        return r6 ? u.coordToData(u.toLocalCoord(s[v6]), true) : u.toGlobalCoord(u.dataToCoord(s[v6]));
      })), d6 = [];
      return d6[a] = f6, d6[1 - a] = [NaN, NaN], { values: f6, xyMinMax: d6 };
    }
    var vye = { lineX: Oi(gye, 0), lineY: Oi(gye, 1), rect: function(a, r6, t2) {
      return [[a[0][0] - t2[0] * r6[0][0], a[0][1] - t2[0] * r6[0][1]], [a[1][0] - t2[1] * r6[1][0], a[1][1] - t2[1] * r6[1][1]]];
    }, polygon: function(a, r6, t2) {
      return wr(a, function(s, u) {
        return [s[0] - t2[0] * r6[u][0], s[1] - t2[1] * r6[u][1]];
      });
    } };
    function gye(a, r6, t2, s) {
      return [r6[0] - s[a] * t2[0], r6[1] - s[a] * t2[1]];
    }
    function RUe(a, r6) {
      var t2 = mye(a), s = mye(r6), u = [t2[0] / s[0], t2[1] / s[1]];
      return isNaN(u[0]) && (u[0] = 1), isNaN(u[1]) && (u[1] = 1), u;
    }
    function mye(a) {
      return a ? [a[0][1] - a[0][0], a[1][1] - a[1][0]] : [NaN, NaN];
    }
    var hJ = LUe, dJ = Ne, FUe = tq("toolbox-dataZoom_"), NUe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.render = function(t2, s, u, f6) {
        this._brushController || (this._brushController = new wK(u.getZr()), this._brushController.on("brush", Ca(this._onBrush, this)).mount()), BUe(t2, s, this, f6, u), zUe(t2, s);
      }, r6.prototype.onclick = function(t2, s, u) {
        VUe[u].call(this);
      }, r6.prototype.remove = function(t2, s) {
        this._brushController && this._brushController.unmount();
      }, r6.prototype.dispose = function(t2, s) {
        this._brushController && this._brushController.dispose();
      }, r6.prototype._onBrush = function(t2) {
        var s = t2.areas;
        if (!t2.isEnd || !s.length)
          return;
        var u = {}, f6 = this.ecModel;
        this._brushController.updateCovers([]);
        var d6 = new hJ(pJ(this.model), f6, { include: ["grid"] });
        d6.matchOutputRanges(s, f6, function(b6, x6, S) {
          if (S.type === "cartesian2d") {
            var M = b6.brushType;
            M === "rect" ? (v6("x", S, x6[0]), v6("y", S, x6[1])) : v6({ lineX: "x", lineY: "y" }[M], S, x6);
          }
        }), AUe(f6, u), this._dispatchZoomAction(u);
        function v6(b6, x6, S) {
          var M = x6.getAxis(b6), A6 = M.model, I = m6(b6, A6, f6), R = I.findRepresentativeAxisProxy(A6).getMinMaxSpan();
          (R.minValueSpan != null || R.maxValueSpan != null) && (S = kA(0, S.slice(), M.scale.getExtent(), 0, R.minValueSpan, R.maxValueSpan)), I && (u[I.id] = { dataZoomId: I.id, startValue: S[0], endValue: S[1] });
        }
        function m6(b6, x6, S) {
          var M;
          return S.eachComponent({ mainType: "dataZoom", subType: "select" }, function(A6) {
            var I = A6.getAxisModel(b6, x6.componentIndex);
            I && (M = A6);
          }), M;
        }
      }, r6.prototype._dispatchZoomAction = function(t2) {
        var s = [];
        dJ(t2, function(u, f6) {
          s.push(Qa(u));
        }), s.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: s });
      }, r6.getDefaultOption = function(t2) {
        var s = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: t2.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
        return s;
      }, r6;
    }(jm), VUe = { zoom: function() {
      var a = !this._isZoomActive;
      this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: a });
    }, back: function() {
      this._dispatchZoomAction(EUe(this.ecModel));
    } };
    function pJ(a) {
      var r6 = { xAxisIndex: a.get("xAxisIndex", true), yAxisIndex: a.get("yAxisIndex", true), xAxisId: a.get("xAxisId", true), yAxisId: a.get("yAxisId", true) };
      return r6.xAxisIndex == null && r6.xAxisId == null && (r6.xAxisIndex = "all"), r6.yAxisIndex == null && r6.yAxisId == null && (r6.yAxisIndex = "all"), r6;
    }
    function zUe(a, r6) {
      a.setIconStatus("back", TUe(r6) > 1 ? "emphasis" : "normal");
    }
    function BUe(a, r6, t2, s, u) {
      var f6 = t2._isZoomActive;
      s && s.type === "takeGlobalCursor" && (f6 = s.key === "dataZoomSelect" ? s.dataZoomSelectActive : false), t2._isZoomActive = f6, a.setIconStatus("zoom", f6 ? "emphasis" : "normal");
      var d6 = new hJ(pJ(a), r6, { include: ["grid"] }), v6 = d6.makePanelOpts(u, function(m6) {
        return m6.xAxisDeclared && !m6.yAxisDeclared ? "lineX" : !m6.xAxisDeclared && m6.yAxisDeclared ? "lineY" : "rect";
      });
      t2._brushController.setPanels(v6).enableBrush(f6 && v6.length ? { brushType: "auto", brushStyle: a.getModel("brushStyle").getItemStyle() } : false);
    }
    VOe("dataZoom", function(a) {
      var r6 = a.getComponent("toolbox", 0), t2 = ["feature", "dataZoom"];
      if (!r6 || r6.get(t2) == null)
        return;
      var s = r6.getModel(t2), u = [], f6 = pJ(s), d6 = HM(a, f6);
      dJ(d6.xAxisModels, function(m6) {
        return v6(m6, "xAxis", "xAxisIndex");
      }), dJ(d6.yAxisModels, function(m6) {
        return v6(m6, "yAxis", "yAxisIndex");
      });
      function v6(m6, b6, x6) {
        var S = m6.componentIndex, M = { type: "select", $fromToolbox: true, filterMode: s.get("filterMode", true) || "filter", id: FUe + b6 + S };
        M[x6] = S, u.push(M);
      }
      return u;
    });
    var jUe = NUe;
    function GUe(a) {
      a.registerComponentModel(iUe), a.registerComponentView(uUe), E5("saveAsImage", fUe), E5("magicType", pUe), E5("dataView", MUe), E5("dataZoom", jUe), E5("restore", kUe), bo(rUe);
    }
    var WUe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "tooltip", r6.dependencies = ["axisPointer"], r6.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, r6;
    }(Ps), HUe = WUe;
    function yye(a) {
      var r6 = a.get("confine");
      return r6 != null ? !!r6 : a.get("renderMode") === "richText";
    }
    function bye(a) {
      if (ha.domSupported) {
        for (var r6 = document.documentElement.style, t2 = 0, s = a.length; t2 < s; t2++)
          if (a[t2] in r6)
            return a[t2];
      }
    }
    var _ye = bye(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), $Ue = bye(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
    function xye(a, r6) {
      if (!a)
        return r6;
      r6 = yce(r6, true);
      var t2 = a.indexOf(r6);
      return a = t2 === -1 ? r6 : "-" + a.slice(0, t2) + "-" + r6, a.toLowerCase();
    }
    function UUe(a, r6) {
      var t2 = a.currentStyle || document.defaultView && document.defaultView.getComputedStyle(a);
      return t2 ? r6 ? t2[r6] : t2 : null;
    }
    var qUe = xye($Ue, "transition"), vJ = xye(_ye, "transform"), YUe = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (ha.transform3dSupported ? "will-change:transform;" : "");
    function ZUe(a) {
      return a = a === "left" ? "right" : a === "right" ? "left" : a === "top" ? "bottom" : "top", a;
    }
    function XUe(a, r6, t2) {
      if (!_a2(t2) || t2 === "inside")
        return "";
      var s = a.get("backgroundColor"), u = a.get("borderWidth");
      r6 = lA(r6);
      var f6 = ZUe(t2), d6 = Math.max(Math.round(u) * 1.5, 6), v6 = "", m6 = vJ + ":", b6;
      Vi(["left", "right"], f6) > -1 ? (v6 += "top:50%", m6 += "translateY(-50%) rotate(" + (b6 = f6 === "left" ? -225 : -45) + "deg)") : (v6 += "left:50%", m6 += "translateX(-50%) rotate(" + (b6 = f6 === "top" ? 225 : 45) + "deg)");
      var x6 = b6 * Math.PI / 180, S = d6 + u, M = S * Math.abs(Math.cos(x6)) + S * Math.abs(Math.sin(x6)), A6 = Math.round(((M - Math.SQRT2 * u) / 2 + Math.SQRT2 * u - (M - S) / 2) * 100) / 100;
      v6 += ";" + f6 + ":-" + A6 + "px";
      var I = r6 + " solid " + u + "px;", R = ["position:absolute;width:" + d6 + "px;height:" + d6 + "px;", v6 + ";" + m6 + ";", "border-bottom:" + I, "border-right:" + I, "background-color:" + s + ";"];
      return '<div style="' + R.join("") + '"></div>';
    }
    function KUe(a, r6) {
      var t2 = "cubic-bezier(0.23,1,0.32,1)", s = " " + a / 2 + "s " + t2, u = "opacity" + s + ",visibility" + s;
      return r6 || (s = " " + a + "s " + t2, u += ha.transformSupported ? "," + vJ + s : ",left" + s + ",top" + s), qUe + ":" + u;
    }
    function wye(a, r6, t2) {
      var s = a.toFixed(0) + "px", u = r6.toFixed(0) + "px";
      if (!ha.transformSupported)
        return t2 ? "top:" + u + ";left:" + s + ";" : [["top", u], ["left", s]];
      var f6 = ha.transform3dSupported, d6 = "translate" + (f6 ? "3d" : "") + "(" + s + "," + u + (f6 ? ",0" : "") + ")";
      return t2 ? "top:0;left:0;" + vJ + ":" + d6 + ";" : [["top", 0], ["left", 0], [_ye, d6]];
    }
    function JUe(a) {
      var r6 = [], t2 = a.get("fontSize"), s = a.getTextColor();
      s && r6.push("color:" + s), r6.push("font:" + a.getFont()), t2 && r6.push("line-height:" + Math.round(t2 * 3 / 2) + "px");
      var u = a.get("textShadowColor"), f6 = a.get("textShadowBlur") || 0, d6 = a.get("textShadowOffsetX") || 0, v6 = a.get("textShadowOffsetY") || 0;
      return u && f6 && r6.push("text-shadow:" + d6 + "px " + v6 + "px " + f6 + "px " + u), Ne(["decoration", "align"], function(m6) {
        var b6 = a.get(m6);
        b6 && r6.push("text-" + m6 + ":" + b6);
      }), r6.join(";");
    }
    function QUe(a, r6, t2) {
      var s = [], u = a.get("transitionDuration"), f6 = a.get("backgroundColor"), d6 = a.get("shadowBlur"), v6 = a.get("shadowColor"), m6 = a.get("shadowOffsetX"), b6 = a.get("shadowOffsetY"), x6 = a.getModel("textStyle"), S = Mfe(a, "html"), M = m6 + "px " + b6 + "px " + d6 + "px " + v6;
      return s.push("box-shadow:" + M), r6 && u && s.push(KUe(u, t2)), f6 && s.push("background-color:" + f6), Ne(["width", "color", "radius"], function(A6) {
        var I = "border-" + A6, R = yce(I), F = a.get(R);
        F != null && s.push(I + ":" + F + (A6 === "color" ? "" : "px"));
      }), s.push(JUe(x6)), S != null && s.push("padding:" + KD(S).join("px ") + "px"), s.join(";") + ";";
    }
    function Sye(a, r6, t2, s, u) {
      var f6 = r6 && r6.painter;
      if (t2) {
        var d6 = f6 && f6.getViewportRoot();
        d6 && d9(a, d6, document.body, s, u);
      } else {
        a[0] = s, a[1] = u;
        var v6 = f6 && f6.getViewportRootOffset();
        v6 && (a[0] += v6.offsetLeft, a[1] += v6.offsetTop);
      }
      a[2] = a[0] / r6.getWidth(), a[3] = a[1] / r6.getHeight();
    }
    var eqe = function() {
      function a(r6, t2, s) {
        if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, ha.wxa)
          return null;
        var u = document.createElement("div");
        u.domBelongToZr = true, this.el = u;
        var f6 = this._zr = t2.getZr(), d6 = this._appendToBody = s && s.appendToBody;
        Sye(this._styleCoord, f6, d6, t2.getWidth() / 2, t2.getHeight() / 2), d6 ? document.body.appendChild(u) : r6.appendChild(u), this._container = r6;
        var v6 = this;
        u.onmouseenter = function() {
          v6._enterable && (clearTimeout(v6._hideTimeout), v6._show = true), v6._inContent = true;
        }, u.onmousemove = function(m6) {
          if (m6 = m6 || window.event, !v6._enterable) {
            var b6 = f6.handler, x6 = f6.painter.getViewportRoot();
            wh(x6, m6, true), b6.dispatch("mousemove", m6);
          }
        }, u.onmouseleave = function() {
          v6._inContent = false, v6._enterable && v6._show && v6.hideLater(v6._hideDelay);
        };
      }
      return a.prototype.update = function(r6) {
        var t2 = this._container, s = UUe(t2, "position"), u = t2.style;
        u.position !== "absolute" && s !== "absolute" && (u.position = "relative");
        var f6 = r6.get("alwaysShowContent");
        f6 && this._moveIfResized(), this.el.className = r6.get("className") || "";
      }, a.prototype.show = function(r6, t2) {
        clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
        var s = this.el, u = s.style, f6 = this._styleCoord;
        s.innerHTML ? u.cssText = YUe + QUe(r6, !this._firstShow, this._longHide) + wye(f6[0], f6[1], true) + ("border-color:" + lA(t2) + ";") + (r6.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : u.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
      }, a.prototype.setContent = function(r6, t2, s, u, f6) {
        var d6 = this.el;
        if (r6 == null) {
          d6.innerHTML = "";
          return;
        }
        var v6 = "";
        if (_a2(f6) && s.get("trigger") === "item" && !yye(s) && (v6 = XUe(s, u, f6)), _a2(r6))
          d6.innerHTML = r6 + v6;
        else if (r6) {
          d6.innerHTML = "", br(r6) || (r6 = [r6]);
          for (var m6 = 0; m6 < r6.length; m6++)
            hM(r6[m6]) && r6[m6].parentNode !== d6 && d6.appendChild(r6[m6]);
          if (v6 && d6.childNodes.length) {
            var b6 = document.createElement("div");
            b6.innerHTML = v6, d6.appendChild(b6);
          }
        }
      }, a.prototype.setEnterable = function(r6) {
        this._enterable = r6;
      }, a.prototype.getSize = function() {
        var r6 = this.el;
        return [r6.offsetWidth, r6.offsetHeight];
      }, a.prototype.moveTo = function(r6, t2) {
        var s = this._styleCoord;
        if (Sye(s, this._zr, this._appendToBody, r6, t2), s[0] != null && s[1] != null) {
          var u = this.el.style, f6 = wye(s[0], s[1]);
          Ne(f6, function(d6) {
            u[d6[0]] = d6[1];
          });
        }
      }, a.prototype._moveIfResized = function() {
        var r6 = this._styleCoord[2], t2 = this._styleCoord[3];
        this.moveTo(r6 * this._zr.getWidth(), t2 * this._zr.getHeight());
      }, a.prototype.hide = function() {
        var r6 = this, t2 = this.el.style;
        t2.visibility = "hidden", t2.opacity = "0", ha.transform3dSupported && (t2.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
          return r6._longHide = true;
        }, 500);
      }, a.prototype.hideLater = function(r6) {
        this._show && !(this._inContent && this._enterable) && (r6 ? (this._hideDelay = r6, this._show = false, this._hideTimeout = setTimeout(Ca(this.hide, this), r6)) : this.hide());
      }, a.prototype.isShow = function() {
        return this._show;
      }, a.prototype.dispose = function() {
        this.el.parentNode.removeChild(this.el);
      }, a;
    }(), tqe = eqe, nqe = function() {
      function a(r6) {
        this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = r6.getZr(), Mye(this._styleCoord, this._zr, r6.getWidth() / 2, r6.getHeight() / 2);
      }
      return a.prototype.update = function(r6) {
        var t2 = r6.get("alwaysShowContent");
        t2 && this._moveIfResized();
      }, a.prototype.show = function() {
        this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
      }, a.prototype.setContent = function(r6, t2, s, u, f6) {
        var d6 = this;
        ui(r6) && Lo(""), this.el && this._zr.remove(this.el);
        var v6 = s.getModel("textStyle");
        this.el = new ms({ style: { rich: t2.richTextStyles, text: r6, lineHeight: 22, borderWidth: 1, borderColor: u, textShadowColor: v6.get("textShadowColor"), fill: s.get(["textStyle", "color"]), padding: Mfe(s, "richText"), verticalAlign: "top", align: "left" }, z: s.get("z") }), Ne(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(b6) {
          d6.el.style[b6] = s.get(b6);
        }), Ne(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(b6) {
          d6.el.style[b6] = v6.get(b6) || 0;
        }), this._zr.add(this.el);
        var m6 = this;
        this.el.on("mouseover", function() {
          m6._enterable && (clearTimeout(m6._hideTimeout), m6._show = true), m6._inContent = true;
        }), this.el.on("mouseout", function() {
          m6._enterable && m6._show && m6.hideLater(m6._hideDelay), m6._inContent = false;
        });
      }, a.prototype.setEnterable = function(r6) {
        this._enterable = r6;
      }, a.prototype.getSize = function() {
        var r6 = this.el, t2 = this.el.getBoundingRect(), s = Cye(r6.style);
        return [t2.width + s.left + s.right, t2.height + s.top + s.bottom];
      }, a.prototype.moveTo = function(r6, t2) {
        var s = this.el;
        if (s) {
          var u = this._styleCoord;
          Mye(u, this._zr, r6, t2), r6 = u[0], t2 = u[1];
          var f6 = s.style, d6 = hS(f6.borderWidth || 0), v6 = Cye(f6);
          s.x = r6 + d6 + v6.left, s.y = t2 + d6 + v6.top, s.markRedraw();
        }
      }, a.prototype._moveIfResized = function() {
        var r6 = this._styleCoord[2], t2 = this._styleCoord[3];
        this.moveTo(r6 * this._zr.getWidth(), t2 * this._zr.getHeight());
      }, a.prototype.hide = function() {
        this.el && this.el.hide(), this._show = false;
      }, a.prototype.hideLater = function(r6) {
        this._show && !(this._inContent && this._enterable) && (r6 ? (this._hideDelay = r6, this._show = false, this._hideTimeout = setTimeout(Ca(this.hide, this), r6)) : this.hide());
      }, a.prototype.isShow = function() {
        return this._show;
      }, a.prototype.dispose = function() {
        this._zr.remove(this.el);
      }, a;
    }();
    function hS(a) {
      return Math.max(0, a);
    }
    function Cye(a) {
      var r6 = hS(a.shadowBlur || 0), t2 = hS(a.shadowOffsetX || 0), s = hS(a.shadowOffsetY || 0);
      return { left: hS(r6 - t2), right: hS(r6 + t2), top: hS(r6 - s), bottom: hS(r6 + s) };
    }
    function Mye(a, r6, t2, s) {
      a[0] = t2, a[1] = s, a[2] = a[0] / r6.getWidth(), a[3] = a[1] / r6.getHeight();
    }
    var rqe = nqe, aqe = new rs({ shape: { x: -1, y: -1, width: 2, height: 2 } }), iqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s) {
        if (!(ha.node || !s.getDom())) {
          var u = t2.getComponent("tooltip"), f6 = this._renderMode = aq(u.get("renderMode"));
          this._tooltipContent = f6 === "richText" ? new rqe(s) : new tqe(s.getDom(), s, { appendToBody: u.get("appendToBody", true) });
        }
      }, r6.prototype.render = function(t2, s, u) {
        if (!(ha.node || !u.getDom())) {
          this.group.removeAll(), this._tooltipModel = t2, this._ecModel = s, this._api = u, this._alwaysShowContent = t2.get("alwaysShowContent");
          var f6 = this._tooltipContent;
          f6.update(t2), f6.setEnterable(t2.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && t2.get("transitionDuration") ? i5(this, "_updatePosition", 50, "fixRate") : CR(this, "_updatePosition");
        }
      }, r6.prototype._initGlobalListener = function() {
        var t2 = this._tooltipModel, s = t2.get("triggerOn");
        Dme("itemTooltip", this._api, Ca(function(u, f6, d6) {
          s !== "none" && (s.indexOf(u) >= 0 ? this._tryShow(f6, d6) : u === "leave" && this._hide(d6));
        }, this));
      }, r6.prototype._keepShow = function() {
        var t2 = this._tooltipModel, s = this._ecModel, u = this._api;
        if (this._lastX != null && this._lastY != null && t2.get("triggerOn") !== "none") {
          var f6 = this;
          clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
            !u.isDisposed() && f6.manuallyShowTip(t2, s, u, { x: f6._lastX, y: f6._lastY, dataByCoordSys: f6._lastDataByCoordSys });
          });
        }
      }, r6.prototype.manuallyShowTip = function(t2, s, u, f6) {
        if (!(f6.from === this.uid || ha.node || !u.getDom())) {
          var d6 = Aye(f6, u);
          this._ticket = "";
          var v6 = f6.dataByCoordSys, m6 = uqe(f6, s, u);
          if (m6) {
            var b6 = m6.el.getBoundingRect().clone();
            b6.applyTransform(m6.el.transform), this._tryShow({ offsetX: b6.x + b6.width / 2, offsetY: b6.y + b6.height / 2, target: m6.el, position: f6.position, positionDefault: "bottom" }, d6);
          } else if (f6.tooltip && f6.x != null && f6.y != null) {
            var x6 = aqe;
            x6.x = f6.x, x6.y = f6.y, x6.update(), ii(x6).tooltipConfig = { name: null, option: f6.tooltip }, this._tryShow({ offsetX: f6.x, offsetY: f6.y, target: x6 }, d6);
          } else if (v6)
            this._tryShow({ offsetX: f6.x, offsetY: f6.y, position: f6.position, dataByCoordSys: v6, tooltipOption: f6.tooltipOption }, d6);
          else if (f6.seriesIndex != null) {
            if (this._manuallyAxisShowTip(t2, s, u, f6))
              return;
            var S = Pme(f6, s), M = S.point[0], A6 = S.point[1];
            M != null && A6 != null && this._tryShow({ offsetX: M, offsetY: A6, target: S.el, position: f6.position, positionDefault: "bottom" }, d6);
          } else
            f6.x != null && f6.y != null && (u.dispatchAction({ type: "updateAxisPointer", x: f6.x, y: f6.y }), this._tryShow({ offsetX: f6.x, offsetY: f6.y, position: f6.position, target: u.getZr().findHover(f6.x, f6.y).target }, d6));
        }
      }, r6.prototype.manuallyHideTip = function(t2, s, u, f6) {
        var d6 = this._tooltipContent;
        !this._alwaysShowContent && this._tooltipModel && d6.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, f6.from !== this.uid && this._hide(Aye(f6, u));
      }, r6.prototype._manuallyAxisShowTip = function(t2, s, u, f6) {
        var d6 = f6.seriesIndex, v6 = f6.dataIndex, m6 = s.getComponent("axisPointer").coordSysAxesInfo;
        if (!(d6 == null || v6 == null || m6 == null)) {
          var b6 = s.getSeriesByIndex(d6);
          if (b6) {
            var x6 = b6.getData(), S = _4([x6.getItemModel(v6), b6, (b6.coordinateSystem || {}).model], this._tooltipModel);
            if (S.get("trigger") === "axis")
              return u.dispatchAction({ type: "updateAxisPointer", seriesIndex: d6, dataIndex: v6, position: f6.position }), true;
          }
        }
      }, r6.prototype._tryShow = function(t2, s) {
        var u = t2.target, f6 = this._tooltipModel;
        if (f6) {
          this._lastX = t2.offsetX, this._lastY = t2.offsetY;
          var d6 = t2.dataByCoordSys;
          if (d6 && d6.length)
            this._showAxisTooltip(d6, t2);
          else if (u) {
            this._lastDataByCoordSys = null;
            var v6, m6;
            s5(u, function(b6) {
              if (ii(b6).dataIndex != null)
                return v6 = b6, true;
              if (ii(b6).tooltipConfig != null)
                return m6 = b6, true;
            }, true), v6 ? this._showSeriesItemTooltip(t2, v6, s) : m6 ? this._showComponentItemTooltip(t2, m6, s) : this._hide(s);
          } else
            this._lastDataByCoordSys = null, this._hide(s);
        }
      }, r6.prototype._showOrMove = function(t2, s) {
        var u = t2.get("showDelay");
        s = Ca(s, this), clearTimeout(this._showTimout), u > 0 ? this._showTimout = setTimeout(s, u) : s();
      }, r6.prototype._showAxisTooltip = function(t2, s) {
        var u = this._ecModel, f6 = this._tooltipModel, d6 = [s.offsetX, s.offsetY], v6 = _4([s.tooltipOption], f6), m6 = this._renderMode, b6 = [], x6 = Ih("section", { blocks: [], noHeader: true }), S = [], M = new rZ();
        Ne(t2, function($) {
          Ne($.dataByAxis, function(K) {
            var U = u.getComponent(K.axisDim + "Axis", K.axisIndex), he = K.value;
            if (!(!U || he == null)) {
              var ue = Cme(he, U.axis, u, K.seriesDataIndices, K.valueLabelOpt), pe = Ih("section", { header: ue, noHeader: !mu(ue), sortBlocks: true, blocks: [] });
              x6.blocks.push(pe), Ne(K.seriesDataIndices, function(_e) {
                var xe = u.getSeriesByIndex(_e.seriesIndex), Ae = _e.dataIndexInside, ke = xe.getDataParams(Ae);
                if (!(ke.dataIndex < 0)) {
                  ke.axisDim = K.axisDim, ke.axisIndex = K.axisIndex, ke.axisType = K.axisType, ke.axisId = K.axisId, ke.axisValue = BZ(U.axis, { value: he }), ke.axisValueLabel = ue, ke.marker = M.makeTooltipMarker("item", lA(ke.color), m6);
                  var je = ife(xe.formatTooltip(Ae, true, null)), Fe = je.frag;
                  if (Fe) {
                    var at = _4([xe], f6).get("valueFormatter");
                    pe.blocks.push(at ? qn({ valueFormatter: at }, Fe) : Fe);
                  }
                  je.text && S.push(je.text), b6.push(ke);
                }
              });
            }
          });
        }), x6.blocks.reverse(), S.reverse();
        var A6 = s.position, I = v6.get("order"), R = wfe(x6, M, m6, I, u.get("useUTC"), v6.get("textStyle"));
        R && S.unshift(R);
        var F = m6 === "richText" ? `

` : "<br/>", j = S.join(F);
        this._showOrMove(v6, function() {
          this._updateContentNotChangedOnAxis(t2, b6) ? this._updatePosition(v6, A6, d6[0], d6[1], this._tooltipContent, b6) : this._showTooltipContent(v6, j, b6, Math.random() + "", d6[0], d6[1], A6, null, M);
        });
      }, r6.prototype._showSeriesItemTooltip = function(t2, s, u) {
        var f6 = this._ecModel, d6 = ii(s), v6 = d6.seriesIndex, m6 = f6.getSeriesByIndex(v6), b6 = d6.dataModel || m6, x6 = d6.dataIndex, S = d6.dataType, M = b6.getData(S), A6 = this._renderMode, I = t2.positionDefault, R = _4([M.getItemModel(x6), b6, m6 && (m6.coordinateSystem || {}).model], this._tooltipModel, I ? { position: I } : null), F = R.get("trigger");
        if (!(F != null && F !== "item")) {
          var j = b6.getDataParams(x6, S), $ = new rZ();
          j.marker = $.makeTooltipMarker("item", lA(j.color), A6);
          var K = ife(b6.formatTooltip(x6, false, S)), U = R.get("order"), he = R.get("valueFormatter"), ue = K.frag, pe = ue ? wfe(he ? qn({ valueFormatter: he }, ue) : ue, $, A6, U, f6.get("useUTC"), R.get("textStyle")) : K.text, _e = "item_" + b6.name + "_" + x6;
          this._showOrMove(R, function() {
            this._showTooltipContent(R, pe, j, _e, t2.offsetX, t2.offsetY, t2.position, t2.target, $);
          }), u({ type: "showTip", dataIndexInside: x6, dataIndex: M.getRawIndex(x6), seriesIndex: v6, from: this.uid });
        }
      }, r6.prototype._showComponentItemTooltip = function(t2, s, u) {
        var f6 = ii(s), d6 = f6.tooltipConfig, v6 = d6.option || {};
        if (_a2(v6)) {
          var m6 = v6;
          v6 = { content: m6, formatter: m6 };
        }
        var b6 = [v6], x6 = this._ecModel.getComponent(f6.componentMainType, f6.componentIndex);
        x6 && b6.push(x6), b6.push({ formatter: v6.content });
        var S = t2.positionDefault, M = _4(b6, this._tooltipModel, S ? { position: S } : null), A6 = M.get("content"), I = Math.random() + "", R = new rZ();
        this._showOrMove(M, function() {
          var F = Qa(M.get("formatterParams") || {});
          this._showTooltipContent(M, A6, F, I, t2.offsetX, t2.offsetY, t2.position, s, R);
        }), u({ type: "showTip", from: this.uid });
      }, r6.prototype._showTooltipContent = function(t2, s, u, f6, d6, v6, m6, b6, x6) {
        if (this._ticket = "", !(!t2.get("showContent") || !t2.get("show"))) {
          var S = this._tooltipContent;
          S.setEnterable(t2.get("enterable"));
          var M = t2.get("formatter");
          m6 = m6 || t2.get("position");
          var A6 = s, I = this._getNearestPoint([d6, v6], u, t2.get("trigger"), t2.get("borderColor")), R = I.color;
          if (M)
            if (_a2(M)) {
              var F = t2.ecModel.get("useUTC"), j = br(u) ? u[0] : u, $ = j && j.axisType && j.axisType.indexOf("time") >= 0;
              A6 = M, $ && (A6 = aV(j.axisValue, A6, F)), A6 = _ce(A6, u, true);
            } else if (ti(M)) {
              var K = Ca(function(U, he) {
                U === this._ticket && (S.setContent(he, x6, t2, R, m6), this._updatePosition(t2, m6, d6, v6, S, u, b6));
              }, this);
              this._ticket = f6, A6 = M(u, f6, K);
            } else
              A6 = M;
          S.setContent(A6, x6, t2, R, m6), S.show(t2, R), this._updatePosition(t2, m6, d6, v6, S, u, b6);
        }
      }, r6.prototype._getNearestPoint = function(t2, s, u, f6) {
        if (u === "axis" || br(s))
          return { color: f6 || (this._renderMode === "html" ? "#fff" : "none") };
        if (!br(s))
          return { color: f6 || s.color || s.borderColor };
      }, r6.prototype._updatePosition = function(t2, s, u, f6, d6, v6, m6) {
        var b6 = this._api.getWidth(), x6 = this._api.getHeight();
        s = s || t2.get("position");
        var S = d6.getSize(), M = t2.get("align"), A6 = t2.get("verticalAlign"), I = m6 && m6.getBoundingRect().clone();
        if (m6 && I.applyTransform(m6.transform), ti(s) && (s = s([u, f6], v6, d6.el, I, { viewSize: [b6, x6], contentSize: S.slice() })), br(s))
          u = ua(s[0], b6), f6 = ua(s[1], x6);
        else if (ui(s)) {
          var R = s;
          R.width = S[0], R.height = S[1];
          var F = ah(R, { width: b6, height: x6 });
          u = F.x, f6 = F.y, M = null, A6 = null;
        } else if (_a2(s) && m6) {
          var j = lqe(s, I, S, t2.get("borderWidth"));
          u = j[0], f6 = j[1];
        } else {
          var j = oqe(u, f6, d6, b6, x6, M ? null : 20, A6 ? null : 20);
          u = j[0], f6 = j[1];
        }
        if (M && (u -= Eye(M) ? S[0] / 2 : M === "right" ? S[0] : 0), A6 && (f6 -= Eye(A6) ? S[1] / 2 : A6 === "bottom" ? S[1] : 0), yye(t2)) {
          var j = sqe(u, f6, d6, b6, x6);
          u = j[0], f6 = j[1];
        }
        d6.moveTo(u, f6);
      }, r6.prototype._updateContentNotChangedOnAxis = function(t2, s) {
        var u = this._lastDataByCoordSys, f6 = this._cbParamsList, d6 = !!u && u.length === t2.length;
        return d6 && Ne(u, function(v6, m6) {
          var b6 = v6.dataByAxis || [], x6 = t2[m6] || {}, S = x6.dataByAxis || [];
          d6 = d6 && b6.length === S.length, d6 && Ne(b6, function(M, A6) {
            var I = S[A6] || {}, R = M.seriesDataIndices || [], F = I.seriesDataIndices || [];
            d6 = d6 && M.value === I.value && M.axisType === I.axisType && M.axisId === I.axisId && R.length === F.length, d6 && Ne(R, function(j, $) {
              var K = F[$];
              d6 = d6 && j.seriesIndex === K.seriesIndex && j.dataIndex === K.dataIndex;
            }), f6 && Ne(M.seriesDataIndices, function(j) {
              var $ = j.seriesIndex, K = s[$], U = f6[$];
              K && U && U.data !== K.data && (d6 = false);
            });
          });
        }), this._lastDataByCoordSys = t2, this._cbParamsList = s, !!d6;
      }, r6.prototype._hide = function(t2) {
        this._lastDataByCoordSys = null, t2({ type: "hideTip", from: this.uid });
      }, r6.prototype.dispose = function(t2, s) {
        ha.node || !s.getDom() || (CR(this, "_updatePosition"), this._tooltipContent.dispose(), XK("itemTooltip", s));
      }, r6.type = "tooltip", r6;
    }(Rc);
    function _4(a, r6, t2) {
      var s = r6.ecModel, u;
      t2 ? (u = new yu(t2, s, s), u = new yu(r6.option, u, s)) : u = r6;
      for (var f6 = a.length - 1; f6 >= 0; f6--) {
        var d6 = a[f6];
        d6 && (d6 instanceof yu && (d6 = d6.get("tooltip", true)), _a2(d6) && (d6 = { formatter: d6 }), d6 && (u = new yu(d6, u, s)));
      }
      return u;
    }
    function Aye(a, r6) {
      return a.dispatchAction || Ca(r6.dispatchAction, r6);
    }
    function oqe(a, r6, t2, s, u, f6, d6) {
      var v6 = t2.getSize(), m6 = v6[0], b6 = v6[1];
      return f6 != null && (a + m6 + f6 + 2 > s ? a -= m6 + f6 : a += f6), d6 != null && (r6 + b6 + d6 > u ? r6 -= b6 + d6 : r6 += d6), [a, r6];
    }
    function sqe(a, r6, t2, s, u) {
      var f6 = t2.getSize(), d6 = f6[0], v6 = f6[1];
      return a = Math.min(a + d6, s) - d6, r6 = Math.min(r6 + v6, u) - v6, a = Math.max(a, 0), r6 = Math.max(r6, 0), [a, r6];
    }
    function lqe(a, r6, t2, s) {
      var u = t2[0], f6 = t2[1], d6 = Math.ceil(Math.SQRT2 * s) + 8, v6 = 0, m6 = 0, b6 = r6.width, x6 = r6.height;
      switch (a) {
        case "inside":
          v6 = r6.x + b6 / 2 - u / 2, m6 = r6.y + x6 / 2 - f6 / 2;
          break;
        case "top":
          v6 = r6.x + b6 / 2 - u / 2, m6 = r6.y - f6 - d6;
          break;
        case "bottom":
          v6 = r6.x + b6 / 2 - u / 2, m6 = r6.y + x6 + d6;
          break;
        case "left":
          v6 = r6.x - u - d6, m6 = r6.y + x6 / 2 - f6 / 2;
          break;
        case "right":
          v6 = r6.x + b6 + d6, m6 = r6.y + x6 / 2 - f6 / 2;
      }
      return [v6, m6];
    }
    function Eye(a) {
      return a === "center" || a === "middle";
    }
    function uqe(a, r6, t2) {
      var s = Sx(a).queryOptionMap, u = s.keys()[0];
      if (!(!u || u === "series")) {
        var f6 = $M(r6, u, s.get(u), { useDefault: false, enableAll: false, enableNone: false }), d6 = f6.models[0];
        if (d6) {
          var v6 = t2.getViewOfComponentModel(d6), m6;
          if (v6.group.traverse(function(b6) {
            var x6 = ii(b6).tooltipConfig;
            if (x6 && x6.name === a.name)
              return m6 = b6, true;
          }), m6)
            return { componentMainType: u, componentIndex: d6.componentIndex, el: m6 };
        }
      }
    }
    var cqe = iqe;
    function fqe(a) {
      bo(y42), a.registerComponentModel(HUe), a.registerComponentView(cqe), a.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, kc), a.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, kc);
    }
    var hqe = ["rect", "polygon", "keep", "clear"];
    function dqe(a, r6) {
      var t2 = ll(a ? a.brush : []);
      if (t2.length) {
        var s = [];
        Ne(t2, function(m6) {
          var b6 = m6.hasOwnProperty("toolbox") ? m6.toolbox : [];
          b6 instanceof Array && (s = s.concat(b6));
        });
        var u = a && a.toolbox;
        br(u) && (u = u[0]), u || (u = { feature: {} }, a.toolbox = [u]);
        var f6 = u.feature || (u.feature = {}), d6 = f6.brush || (f6.brush = {}), v6 = d6.type || (d6.type = []);
        v6.push.apply(v6, s), pqe(v6), r6 && !v6.length && v6.push.apply(v6, hqe);
      }
    }
    function pqe(a) {
      var r6 = {};
      Ne(a, function(t2) {
        r6[t2] = 1;
      }), a.length = 0, Ne(r6, function(t2, s) {
        a.push(s);
      });
    }
    var Iye = Ne;
    function Tye(a) {
      if (a) {
        for (var r6 in a)
          if (a.hasOwnProperty(r6))
            return true;
      }
    }
    function gJ(a, r6, t2) {
      var s = {};
      return Iye(r6, function(f6) {
        var d6 = s[f6] = u();
        Iye(a[f6], function(v6, m6) {
          if (ap.isValidType(m6)) {
            var b6 = { type: m6, visual: v6 };
            t2 && t2(b6, f6), d6[m6] = new ap(b6), m6 === "opacity" && (b6 = Qa(b6), b6.type = "colorAlpha", d6.__hidden.__alphaForOpacity = new ap(b6));
          }
        });
      }), s;
      function u() {
        var f6 = function() {
        };
        f6.prototype.__hidden = f6.prototype;
        var d6 = new f6();
        return d6;
      }
    }
    function Dye(a, r6, t2) {
      var s;
      Ne(t2, function(u) {
        r6.hasOwnProperty(u) && Tye(r6[u]) && (s = true);
      }), s && Ne(t2, function(u) {
        r6.hasOwnProperty(u) && Tye(r6[u]) ? a[u] = Qa(r6[u]) : delete a[u];
      });
    }
    function vqe(a, r6, t2, s, u, f6) {
      var d6 = {};
      Ne(a, function(S) {
        var M = ap.prepareVisualTypes(r6[S]);
        d6[S] = M;
      });
      var v6;
      function m6(S) {
        return uZ(t2, v6, S);
      }
      function b6(S, M) {
        qfe(t2, v6, S, M);
      }
      f6 == null ? t2.each(x6) : t2.each([f6], x6);
      function x6(S, M) {
        v6 = f6 == null ? S : M;
        var A6 = t2.getRawDataItem(v6);
        if (!(A6 && A6.visualMap === false))
          for (var I = s.call(u, S), R = r6[I], F = d6[I], j = 0, $ = F.length; j < $; j++) {
            var K = F[j];
            R[K] && R[K].applyVisual(S, m6, b6);
          }
      }
    }
    function gqe(a, r6, t2, s) {
      var u = {};
      return Ne(a, function(f6) {
        var d6 = ap.prepareVisualTypes(r6[f6]);
        u[f6] = d6;
      }), { progress: function(f6, d6) {
        var v6;
        s != null && (v6 = d6.getDimensionIndex(s));
        function m6(U) {
          return uZ(d6, x6, U);
        }
        function b6(U, he) {
          qfe(d6, x6, U, he);
        }
        for (var x6, S = d6.getStore(); (x6 = f6.next()) != null; ) {
          var M = d6.getRawDataItem(x6);
          if (!(M && M.visualMap === false))
            for (var A6 = s != null ? S.get(v6, x6) : x6, I = t2(A6), R = r6[I], F = u[I], j = 0, $ = F.length; j < $; j++) {
              var K = F[j];
              R[K] && R[K].applyVisual(A6, m6, b6);
            }
        }
      } };
    }
    function mqe(a) {
      var r6 = a.brushType, t2 = { point: function(s) {
        return kye[r6].point(s, t2, a);
      }, rect: function(s) {
        return kye[r6].rect(s, t2, a);
      } };
      return t2;
    }
    var kye = { lineX: Pye(0), lineY: Pye(1), rect: { point: function(a, r6, t2) {
      return a && t2.boundingRect.contain(a[0], a[1]);
    }, rect: function(a, r6, t2) {
      return a && t2.boundingRect.intersect(a);
    } }, polygon: { point: function(a, r6, t2) {
      return a && t2.boundingRect.contain(a[0], a[1]) && mA(t2.range, a[0], a[1]);
    }, rect: function(a, r6, t2) {
      var s = t2.range;
      if (!a || s.length <= 1)
        return false;
      var u = a.x, f6 = a.y, d6 = a.width, v6 = a.height, m6 = s[0];
      if (mA(s, u, f6) || mA(s, u + d6, f6) || mA(s, u, f6 + v6) || mA(s, u + d6, f6 + v6) || Qi.create(a).contain(m6[0], m6[1]) || Eh(u, f6, u + d6, f6, s) || Eh(u, f6, u, f6 + v6, s) || Eh(u + d6, f6, u + d6, f6 + v6, s) || Eh(u, f6 + v6, u + d6, f6 + v6, s))
        return true;
    } } };
    function Pye(a) {
      var r6 = ["x", "y"], t2 = ["width", "height"];
      return { point: function(s, u, f6) {
        if (s) {
          var d6 = f6.range, v6 = s[a];
          return x4(v6, d6);
        }
      }, rect: function(s, u, f6) {
        if (s) {
          var d6 = f6.range, v6 = [s[r6[a]], s[r6[a]] + s[t2[a]]];
          return v6[1] < v6[0] && v6.reverse(), x4(v6[0], d6) || x4(v6[1], d6) || x4(d6[0], v6) || x4(d6[1], v6);
        }
      } };
    }
    function x4(a, r6) {
      return r6[0] <= a && a <= r6[1];
    }
    var Lye = ["inBrush", "outOfBrush"], mJ = "__ecBrushSelect", yJ = "__ecInBrushSelectEvent";
    function Oye(a) {
      a.eachComponent({ mainType: "brush" }, function(r6) {
        var t2 = r6.brushTargetManager = new hJ(r6.option, a);
        t2.setInputRanges(r6.areas, a);
      });
    }
    function yqe(a, r6, t2) {
      var s = [], u, f6;
      a.eachComponent({ mainType: "brush" }, function(d6) {
        t2 && t2.type === "takeGlobalCursor" && d6.setBrushOption(t2.key === "brush" ? t2.brushOption : { brushType: false });
      }), Oye(a), a.eachComponent({ mainType: "brush" }, function(d6, v6) {
        var m6 = { brushId: d6.id, brushIndex: v6, brushName: d6.name, areas: Qa(d6.areas), selected: [] };
        s.push(m6);
        var b6 = d6.option, x6 = b6.brushLink, S = [], M = [], A6 = [], I = false;
        v6 || (u = b6.throttleType, f6 = b6.throttleDelay);
        var R = wr(d6.areas, function(he) {
          var ue = wqe[he.brushType], pe = ei({ boundingRect: ue ? ue(he) : void 0 }, he);
          return pe.selectors = mqe(pe), pe;
        }), F = gJ(d6.option, Lye, function(he) {
          he.mappingMethod = "fixed";
        });
        br(x6) && Ne(x6, function(he) {
          S[he] = 1;
        });
        function j(he) {
          return x6 === "all" || !!S[he];
        }
        function $(he) {
          return !!he.length;
        }
        a.eachSeries(function(he, ue) {
          var pe = A6[ue] = [];
          he.subType === "parallel" ? K(he, ue) : U(he, ue, pe);
        });
        function K(he, ue) {
          var pe = he.coordinateSystem;
          I = I || pe.hasAxisBrushed(), j(ue) && pe.eachActiveState(he.getData(), function(_e, xe) {
            _e === "active" && (M[xe] = 1);
          });
        }
        function U(he, ue, pe) {
          if (!(!he.brushSelector || xqe(d6, ue)) && (Ne(R, function(xe) {
            d6.brushTargetManager.controlSeries(xe, he, a) && pe.push(xe), I = I || $(pe);
          }), j(ue) && $(pe))) {
            var _e = he.getData();
            _e.each(function(xe) {
              Rye(he, pe, _e, xe) && (M[xe] = 1);
            });
          }
        }
        a.eachSeries(function(he, ue) {
          var pe = { seriesId: he.id, seriesIndex: ue, seriesName: he.name, dataIndex: [] };
          m6.selected.push(pe);
          var _e = A6[ue], xe = he.getData(), Ae = j(ue) ? function(ke) {
            return M[ke] ? (pe.dataIndex.push(xe.getRawIndex(ke)), "inBrush") : "outOfBrush";
          } : function(ke) {
            return Rye(he, _e, xe, ke) ? (pe.dataIndex.push(xe.getRawIndex(ke)), "inBrush") : "outOfBrush";
          };
          (j(ue) ? I : $(_e)) && vqe(Lye, F, xe, Ae);
        });
      }), bqe(r6, u, f6, s, t2);
    }
    function bqe(a, r6, t2, s, u) {
      if (u) {
        var f6 = a.getZr();
        if (!f6[yJ]) {
          f6[mJ] || (f6[mJ] = _qe);
          var d6 = i5(f6, mJ, t2, r6);
          d6(a, s);
        }
      }
    }
    function _qe(a, r6) {
      if (!a.isDisposed()) {
        var t2 = a.getZr();
        t2[yJ] = true, a.dispatchAction({ type: "brushSelect", batch: r6 }), t2[yJ] = false;
      }
    }
    function Rye(a, r6, t2, s) {
      for (var u = 0, f6 = r6.length; u < f6; u++) {
        var d6 = r6[u];
        if (a.brushSelector(s, t2, d6.selectors, d6))
          return true;
      }
    }
    function xqe(a, r6) {
      var t2 = a.option.seriesIndex;
      return t2 != null && t2 !== "all" && (br(t2) ? Vi(t2, r6) < 0 : r6 !== t2);
    }
    var wqe = { rect: function(a) {
      return Fye(a.range);
    }, polygon: function(a) {
      for (var r6, t2 = a.range, s = 0, u = t2.length; s < u; s++) {
        r6 = r6 || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
        var f6 = t2[s];
        f6[0] < r6[0][0] && (r6[0][0] = f6[0]), f6[0] > r6[0][1] && (r6[0][1] = f6[0]), f6[1] < r6[1][0] && (r6[1][0] = f6[1]), f6[1] > r6[1][1] && (r6[1][1] = f6[1]);
      }
      return r6 && Fye(r6);
    } };
    function Fye(a) {
      return new Qi(a[0][0], a[1][0], a[0][1] - a[0][0], a[1][1] - a[1][0]);
    }
    var Sqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s) {
        this.ecModel = t2, this.api = s, this.model, (this._brushController = new wK(s.getZr())).on("brush", Ca(this._onBrush, this)).mount();
      }, r6.prototype.render = function(t2, s, u, f6) {
        this.model = t2, this._updateController(t2, s, u, f6);
      }, r6.prototype.updateTransform = function(t2, s, u, f6) {
        Oye(s), this._updateController(t2, s, u, f6);
      }, r6.prototype.updateVisual = function(t2, s, u, f6) {
        this.updateTransform(t2, s, u, f6);
      }, r6.prototype.updateView = function(t2, s, u, f6) {
        this._updateController(t2, s, u, f6);
      }, r6.prototype._updateController = function(t2, s, u, f6) {
        (!f6 || f6.$from !== t2.id) && this._brushController.setPanels(t2.brushTargetManager.makePanelOpts(u)).enableBrush(t2.brushOption).updateCovers(t2.areas.slice());
      }, r6.prototype.dispose = function() {
        this._brushController.dispose();
      }, r6.prototype._onBrush = function(t2) {
        var s = this.model.id, u = this.model.brushTargetManager.setOutputRanges(t2.areas, this.ecModel);
        (!t2.isEnd || t2.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: s, areas: Qa(u), $from: s }), t2.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: s, areas: Qa(u), $from: s });
      }, r6.type = "brush", r6;
    }(Rc), Cqe = Sqe, Mqe = "#ddd", Aqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.areas = [], t2.brushOption = {}, t2;
      }
      return r6.prototype.optionUpdated = function(t2, s) {
        var u = this.option;
        !s && Dye(u, t2, ["inBrush", "outOfBrush"]);
        var f6 = u.inBrush = u.inBrush || {};
        u.outOfBrush = u.outOfBrush || { color: Mqe }, f6.hasOwnProperty("liftZ") || (f6.liftZ = 5);
      }, r6.prototype.setAreas = function(t2) {
        !t2 || (this.areas = wr(t2, function(s) {
          return Nye(this.option, s);
        }, this));
      }, r6.prototype.setBrushOption = function(t2) {
        this.brushOption = Nye(this.option, t2), this.brushType = this.brushOption.brushType;
      }, r6.type = "brush", r6.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], r6.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, r6;
    }(Ps);
    function Nye(a, r6) {
      return Di({ brushType: a.brushType, brushMode: a.brushMode, transformable: a.transformable, brushStyle: new yu(a.brushStyle).getItemStyle(), removeOnClick: a.removeOnClick, z: a.z }, r6, true);
    }
    var Eqe = Aqe, Iqe = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], Tqe = function(a) {
      tt(r6, a);
      function r6() {
        return a !== null && a.apply(this, arguments) || this;
      }
      return r6.prototype.render = function(t2, s, u) {
        var f6, d6, v6;
        s.eachComponent({ mainType: "brush" }, function(m6) {
          f6 = m6.brushType, d6 = m6.brushOption.brushMode || "single", v6 = v6 || !!m6.areas.length;
        }), this._brushType = f6, this._brushMode = d6, Ne(t2.get("type", true), function(m6) {
          t2.setIconStatus(m6, (m6 === "keep" ? d6 === "multiple" : m6 === "clear" ? v6 : m6 === f6) ? "emphasis" : "normal");
        });
      }, r6.prototype.updateView = function(t2, s, u) {
        this.render(t2, s, u);
      }, r6.prototype.getIcons = function() {
        var t2 = this.model, s = t2.get("icon", true), u = {};
        return Ne(t2.get("type", true), function(f6) {
          s[f6] && (u[f6] = s[f6]);
        }), u;
      }, r6.prototype.onclick = function(t2, s, u) {
        var f6 = this._brushType, d6 = this._brushMode;
        u === "clear" ? (s.dispatchAction({ type: "axisAreaSelect", intervals: [] }), s.dispatchAction({ type: "brush", command: "clear", areas: [] })) : s.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: u === "keep" ? f6 : f6 === u ? false : u, brushMode: u === "keep" ? d6 === "multiple" ? "single" : "multiple" : d6 } });
      }, r6.getDefaultOption = function(t2) {
        var s = { show: true, type: Iqe.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: t2.getLocaleModel().get(["toolbox", "brush", "title"]) };
        return s;
      }, r6;
    }(jm), Dqe = Tqe;
    function kqe(a) {
      a.registerComponentView(Cqe), a.registerComponentModel(Eqe), a.registerPreprocessor(dqe), a.registerVisual(a.PRIORITY.VISUAL.BRUSH, yqe), a.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(r6, t2) {
        t2.eachComponent({ mainType: "brush", query: r6 }, function(s) {
          s.setAreas(r6.areas);
        });
      }), a.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, kc), a.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, kc), E5("brush", Dqe);
    }
    var Pqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.layoutMode = { type: "box", ignoreSize: true }, t2;
      }
      return r6.type = "title", r6.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, r6;
    }(Ps), Lqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        if (this.group.removeAll(), !!t2.get("show")) {
          var f6 = this.group, d6 = t2.getModel("textStyle"), v6 = t2.getModel("subtextStyle"), m6 = t2.get("textAlign"), b6 = qi(t2.get("textBaseline"), t2.get("textVerticalAlign")), x6 = new ms({ style: yf(d6, { text: t2.get("text"), fill: d6.getTextColor() }, { disableBox: true }), z2: 10 }), S = x6.getBoundingRect(), M = t2.get("subtext"), A6 = new ms({ style: yf(v6, { text: M, fill: v6.getTextColor(), y: S.height + t2.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), I = t2.get("link"), R = t2.get("sublink"), F = t2.get("triggerEvent", true);
          x6.silent = !I && !F, A6.silent = !R && !F, I && x6.on("click", function() {
            uV(I, "_" + t2.get("target"));
          }), R && A6.on("click", function() {
            uV(R, "_" + t2.get("subtarget"));
          }), ii(x6).eventData = ii(A6).eventData = F ? { componentType: "title", componentIndex: t2.componentIndex } : null, f6.add(x6), M && f6.add(A6);
          var j = f6.getBoundingRect(), $ = t2.getBoxLayoutParams();
          $.width = j.width, $.height = j.height;
          var K = ah($, { width: u.getWidth(), height: u.getHeight() }, t2.get("padding"));
          m6 || (m6 = t2.get("left") || t2.get("right"), m6 === "middle" && (m6 = "center"), m6 === "right" ? K.x += K.width : m6 === "center" && (K.x += K.width / 2)), b6 || (b6 = t2.get("top") || t2.get("bottom"), b6 === "center" && (b6 = "middle"), b6 === "bottom" ? K.y += K.height : b6 === "middle" && (K.y += K.height / 2), b6 = b6 || "top"), f6.x = K.x, f6.y = K.y, f6.markRedraw();
          var U = { align: m6, verticalAlign: b6 };
          x6.setStyle(U), A6.setStyle(U), j = f6.getBoundingRect();
          var he = K.margin, ue = t2.getItemStyle(["color", "opacity"]);
          ue.fill = t2.get("backgroundColor");
          var pe = new rs({ shape: { x: j.x - he[3], y: j.y - he[0], width: j.width + he[1] + he[3], height: j.height + he[0] + he[2], r: t2.get("borderRadius") }, style: ue, subPixelOptimize: true, silent: true });
          f6.add(pe);
        }
      }, r6.type = "title", r6;
    }(Rc);
    function Oqe(a) {
      a.registerComponentModel(Pqe), a.registerComponentView(Lqe);
    }
    var Rqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.layoutMode = "box", t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        this.mergeDefaultAndTheme(t2, u), this._initData();
      }, r6.prototype.mergeOption = function(t2) {
        a.prototype.mergeOption.apply(this, arguments), this._initData();
      }, r6.prototype.setCurrentIndex = function(t2) {
        t2 == null && (t2 = this.option.currentIndex);
        var s = this._data.count();
        this.option.loop ? t2 = (t2 % s + s) % s : (t2 >= s && (t2 = s - 1), t2 < 0 && (t2 = 0)), this.option.currentIndex = t2;
      }, r6.prototype.getCurrentIndex = function() {
        return this.option.currentIndex;
      }, r6.prototype.isIndexMax = function() {
        return this.getCurrentIndex() >= this._data.count() - 1;
      }, r6.prototype.setPlayState = function(t2) {
        this.option.autoPlay = !!t2;
      }, r6.prototype.getPlayState = function() {
        return !!this.option.autoPlay;
      }, r6.prototype._initData = function() {
        var t2 = this.option, s = t2.data || [], u = t2.axisType, f6 = this._names = [], d6;
        u === "category" ? (d6 = [], Ne(s, function(b6, x6) {
          var S = Zc(n1(b6), ""), M;
          ui(b6) ? (M = Qa(b6), M.value = x6) : M = x6, d6.push(M), f6.push(S);
        })) : d6 = s;
        var v6 = { category: "ordinal", time: "time", value: "number" }[u] || "number", m6 = this._data = new Tv([{ name: "value", type: v6 }], this);
        m6.initData(d6, f6);
      }, r6.prototype.getData = function() {
        return this._data;
      }, r6.prototype.getCategories = function() {
        if (this.get("axisType") === "category")
          return this._names.slice();
      }, r6.type = "timeline", r6.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, r6;
    }(Ps), Vye = Rqe, zye = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "timeline.slider", r6.defaultOption = Y2(Vye.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), r6;
    }(Vye);
    Dc(zye, KY.prototype);
    var Fqe = zye, Nqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "timeline", r6;
    }(Rc), Vqe = Nqe, zqe = function(a) {
      tt(r6, a);
      function r6(t2, s, u, f6) {
        var d6 = a.call(this, t2, s, u) || this;
        return d6.type = f6 || "value", d6;
      }
      return r6.prototype.getLabelModel = function() {
        return this.model.getModel("label");
      }, r6.prototype.isHorizontal = function() {
        return this.model.get("orient") === "horizontal";
      }, r6;
    }(c1), Bqe = zqe, bJ = Math.PI, Bye = Xo(), jqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function(t2, s) {
        this.api = s;
      }, r6.prototype.render = function(t2, s, u) {
        if (this.model = t2, this.api = u, this.ecModel = s, this.group.removeAll(), t2.get("show", true)) {
          var f6 = this._layout(t2, u), d6 = this._createGroup("_mainGroup"), v6 = this._createGroup("_labelGroup"), m6 = this._axis = this._createAxis(f6, t2);
          t2.formatTooltip = function(b6) {
            var x6 = m6.scale.getLabel({ value: b6 });
            return Ih("nameValue", { noName: true, value: x6 });
          }, Ne(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(b6) {
            this["_render" + b6](f6, d6, m6, t2);
          }, this), this._renderAxisLabel(f6, v6, m6, t2), this._position(f6, t2);
        }
        this._doPlayStop(), this._updateTicksStatus();
      }, r6.prototype.remove = function() {
        this._clearTimer(), this.group.removeAll();
      }, r6.prototype.dispose = function() {
        this._clearTimer();
      }, r6.prototype._layout = function(t2, s) {
        var u = t2.get(["label", "position"]), f6 = t2.get("orient"), d6 = Wqe(t2, s), v6;
        u == null || u === "auto" ? v6 = f6 === "horizontal" ? d6.y + d6.height / 2 < s.getHeight() / 2 ? "-" : "+" : d6.x + d6.width / 2 < s.getWidth() / 2 ? "+" : "-" : _a2(u) ? v6 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[f6][u] : v6 = u;
        var m6 = { horizontal: "center", vertical: v6 >= 0 || v6 === "+" ? "left" : "right" }, b6 = { horizontal: v6 >= 0 || v6 === "+" ? "top" : "bottom", vertical: "middle" }, x6 = { horizontal: 0, vertical: bJ / 2 }, S = f6 === "vertical" ? d6.height : d6.width, M = t2.getModel("controlStyle"), A6 = M.get("show", true), I = A6 ? M.get("itemSize") : 0, R = A6 ? M.get("itemGap") : 0, F = I + R, j = t2.get(["label", "rotate"]) || 0;
        j = j * bJ / 180;
        var $, K, U, he = M.get("position", true), ue = A6 && M.get("showPlayBtn", true), pe = A6 && M.get("showPrevBtn", true), _e = A6 && M.get("showNextBtn", true), xe = 0, Ae = S;
        he === "left" || he === "bottom" ? (ue && ($ = [0, 0], xe += F), pe && (K = [xe, 0], xe += F), _e && (U = [Ae - I, 0], Ae -= F)) : (ue && ($ = [Ae - I, 0], Ae -= F), pe && (K = [0, 0], xe += F), _e && (U = [Ae - I, 0], Ae -= F));
        var ke = [xe, Ae];
        return t2.get("inverse") && ke.reverse(), { viewRect: d6, mainLength: S, orient: f6, rotation: x6[f6], labelRotation: j, labelPosOpt: v6, labelAlign: t2.get(["label", "align"]) || m6[f6], labelBaseline: t2.get(["label", "verticalAlign"]) || t2.get(["label", "baseline"]) || b6[f6], playPosition: $, prevBtnPosition: K, nextBtnPosition: U, axisExtent: ke, controlSize: I, controlGap: R };
      }, r6.prototype._position = function(t2, s) {
        var u = this._mainGroup, f6 = this._labelGroup, d6 = t2.viewRect;
        if (t2.orient === "vertical") {
          var v6 = og(), m6 = d6.x, b6 = d6.y + d6.height;
          sg(v6, v6, [-m6, -b6]), yb(v6, v6, -bJ / 2), sg(v6, v6, [m6, b6]), d6 = d6.clone(), d6.applyTransform(v6);
        }
        var x6 = $(d6), S = $(u.getBoundingRect()), M = $(f6.getBoundingRect()), A6 = [u.x, u.y], I = [f6.x, f6.y];
        I[0] = A6[0] = x6[0][0];
        var R = t2.labelPosOpt;
        if (R == null || _a2(R)) {
          var F = R === "+" ? 0 : 1;
          K(A6, S, x6, 1, F), K(I, M, x6, 1, 1 - F);
        } else {
          var F = R >= 0 ? 0 : 1;
          K(A6, S, x6, 1, F), I[1] = A6[1] + R;
        }
        u.setPosition(A6), f6.setPosition(I), u.rotation = f6.rotation = t2.rotation, j(u), j(f6);
        function j(U) {
          U.originX = x6[0][0] - U.x, U.originY = x6[1][0] - U.y;
        }
        function $(U) {
          return [[U.x, U.x + U.width], [U.y, U.y + U.height]];
        }
        function K(U, he, ue, pe, _e) {
          U[pe] += ue[pe][_e] - he[pe][_e];
        }
      }, r6.prototype._createAxis = function(t2, s) {
        var u = s.getData(), f6 = s.get("axisType"), d6 = Gqe(s, f6);
        d6.getTicks = function() {
          return u.mapArray(["value"], function(b6) {
            return { value: b6 };
          });
        };
        var v6 = u.getDataExtent("value");
        d6.setExtent(v6[0], v6[1]), d6.calcNiceTicks();
        var m6 = new Bqe("value", d6, t2.axisExtent, f6);
        return m6.model = s, m6;
      }, r6.prototype._createGroup = function(t2) {
        var s = this[t2] = new bi();
        return this.group.add(s), s;
      }, r6.prototype._renderAxisLine = function(t2, s, u, f6) {
        var d6 = u.getExtent();
        if (f6.get(["lineStyle", "show"])) {
          var v6 = new rh({ shape: { x1: d6[0], y1: 0, x2: d6[1], y2: 0 }, style: qn({ lineCap: "round" }, f6.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
          s.add(v6);
          var m6 = this._progressLine = new rh({ shape: { x1: d6[0], x2: this._currentPointer ? this._currentPointer.x : d6[0], y1: 0, y2: 0 }, style: ei({ lineCap: "round", lineWidth: v6.style.lineWidth }, f6.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
          s.add(m6);
        }
      }, r6.prototype._renderAxisTick = function(t2, s, u, f6) {
        var d6 = this, v6 = f6.getData(), m6 = u.scale.getTicks();
        this._tickSymbols = [], Ne(m6, function(b6) {
          var x6 = u.dataToCoord(b6.value), S = v6.getItemModel(b6.value), M = S.getModel("itemStyle"), A6 = S.getModel(["emphasis", "itemStyle"]), I = S.getModel(["progress", "itemStyle"]), R = { x: x6, y: 0, onclick: Ca(d6._changeTimeline, d6, b6.value) }, F = jye(S, M, s, R);
          F.ensureState("emphasis").style = A6.getItemStyle(), F.ensureState("progress").style = I.getItemStyle(), Fx(F);
          var j = ii(F);
          S.get("tooltip") ? (j.dataIndex = b6.value, j.dataModel = f6) : j.dataIndex = j.dataModel = null, d6._tickSymbols.push(F);
        });
      }, r6.prototype._renderAxisLabel = function(t2, s, u, f6) {
        var d6 = this, v6 = u.getLabelModel();
        if (v6.get("show")) {
          var m6 = f6.getData(), b6 = u.getViewLabels();
          this._tickLabels = [], Ne(b6, function(x6) {
            var S = x6.tickValue, M = m6.getItemModel(S), A6 = M.getModel("label"), I = M.getModel(["emphasis", "label"]), R = M.getModel(["progress", "label"]), F = u.dataToCoord(x6.tickValue), j = new ms({ x: F, y: 0, rotation: t2.labelRotation - t2.rotation, onclick: Ca(d6._changeTimeline, d6, S), silent: false, style: yf(A6, { text: x6.formattedLabel, align: t2.labelAlign, verticalAlign: t2.labelBaseline }) });
            j.ensureState("emphasis").style = yf(I), j.ensureState("progress").style = yf(R), s.add(j), Fx(j), Bye(j).dataIndex = S, d6._tickLabels.push(j);
          });
        }
      }, r6.prototype._renderControl = function(t2, s, u, f6) {
        var d6 = t2.controlSize, v6 = t2.rotation, m6 = f6.getModel("controlStyle").getItemStyle(), b6 = f6.getModel(["emphasis", "controlStyle"]).getItemStyle(), x6 = f6.getPlayState(), S = f6.get("inverse", true);
        M(t2.nextBtnPosition, "next", Ca(this._changeTimeline, this, S ? "-" : "+")), M(t2.prevBtnPosition, "prev", Ca(this._changeTimeline, this, S ? "+" : "-")), M(t2.playPosition, x6 ? "stop" : "play", Ca(this._handlePlayClick, this, !x6), true);
        function M(A6, I, R, F) {
          if (A6) {
            var j = wv(qi(f6.get(["controlStyle", I + "BtnSize"]), d6), d6), $ = [0, -j / 2, j, j], K = Hqe(f6, I + "Icon", $, { x: A6[0], y: A6[1], originX: d6 / 2, originY: 0, rotation: F ? -v6 : 0, rectHover: true, style: m6, onclick: R });
            K.ensureState("emphasis").style = b6, s.add(K), Fx(K);
          }
        }
      }, r6.prototype._renderCurrentPointer = function(t2, s, u, f6) {
        var d6 = f6.getData(), v6 = f6.getCurrentIndex(), m6 = d6.getItemModel(v6).getModel("checkpointStyle"), b6 = this, x6 = { onCreate: function(S) {
          S.draggable = true, S.drift = Ca(b6._handlePointerDrag, b6), S.ondragend = Ca(b6._handlePointerDragend, b6), Gye(S, b6._progressLine, v6, u, f6, true);
        }, onUpdate: function(S) {
          Gye(S, b6._progressLine, v6, u, f6);
        } };
        this._currentPointer = jye(m6, m6, this._mainGroup, {}, this._currentPointer, x6);
      }, r6.prototype._handlePlayClick = function(t2) {
        this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: t2, from: this.uid });
      }, r6.prototype._handlePointerDrag = function(t2, s, u) {
        this._clearTimer(), this._pointerChangeTimeline([u.offsetX, u.offsetY]);
      }, r6.prototype._handlePointerDragend = function(t2) {
        this._pointerChangeTimeline([t2.offsetX, t2.offsetY], true);
      }, r6.prototype._pointerChangeTimeline = function(t2, s) {
        var u = this._toAxisCoord(t2)[0], f6 = this._axis, d6 = Sv(f6.getExtent().slice());
        u > d6[1] && (u = d6[1]), u < d6[0] && (u = d6[0]), this._currentPointer.x = u, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = u, this._progressLine.dirty();
        var v6 = this._findNearestTick(u), m6 = this.model;
        (s || v6 !== m6.getCurrentIndex() && m6.get("realtime")) && this._changeTimeline(v6);
      }, r6.prototype._doPlayStop = function() {
        var t2 = this;
        this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
          var s = t2.model;
          t2._changeTimeline(s.getCurrentIndex() + (s.get("rewind", true) ? -1 : 1));
        }, this.model.get("playInterval")));
      }, r6.prototype._toAxisCoord = function(t2) {
        var s = this._mainGroup.getLocalTransform();
        return Yr(t2, s, true);
      }, r6.prototype._findNearestTick = function(t2) {
        var s = this.model.getData(), u = 1 / 0, f6, d6 = this._axis;
        return s.each(["value"], function(v6, m6) {
          var b6 = d6.dataToCoord(v6), x6 = Math.abs(b6 - t2);
          x6 < u && (u = x6, f6 = m6);
        }), f6;
      }, r6.prototype._clearTimer = function() {
        this._timer && (clearTimeout(this._timer), this._timer = null);
      }, r6.prototype._changeTimeline = function(t2) {
        var s = this.model.getCurrentIndex();
        t2 === "+" ? t2 = s + 1 : t2 === "-" && (t2 = s - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: t2, from: this.uid });
      }, r6.prototype._updateTicksStatus = function() {
        var t2 = this.model.getCurrentIndex(), s = this._tickSymbols, u = this._tickLabels;
        if (s)
          for (var f6 = 0; f6 < s.length; f6++)
            s && s[f6] && s[f6].toggleState("progress", f6 < t2);
        if (u)
          for (var f6 = 0; f6 < u.length; f6++)
            u && u[f6] && u[f6].toggleState("progress", Bye(u[f6]).dataIndex <= t2);
      }, r6.type = "timeline.slider", r6;
    }(Vqe);
    function Gqe(a, r6) {
      if (r6 = r6 || a.get("type"), r6)
        switch (r6) {
          case "category":
            return new RZ({ ordinalMeta: a.getCategories(), extent: [1 / 0, -1 / 0] });
          case "time":
            return new ude({ locale: a.ecModel.getLocaleModel(), useUTC: a.ecModel.get("useUTC") });
          default:
            return new nS();
        }
    }
    function Wqe(a, r6) {
      return ah(a.getBoxLayoutParams(), { width: r6.getWidth(), height: r6.getHeight() }, a.get("padding"));
    }
    function Hqe(a, r6, t2, s) {
      var u = s.style, f6 = ys(a.get(["controlStyle", r6]), s || {}, new Qi(t2[0], t2[1], t2[2], t2[3]));
      return u && f6.setStyle(u), f6;
    }
    function jye(a, r6, t2, s, u, f6) {
      var d6 = r6.get("color");
      if (u)
        u.setColor(d6), t2.add(u), f6 && f6.onUpdate(u);
      else {
        var v6 = a.get("symbol");
        u = Lf(v6, -1, -1, 2, 2, d6), u.setStyle("strokeNoScale", true), t2.add(u), f6 && f6.onCreate(u);
      }
      var m6 = r6.getItemStyle(["color"]);
      u.setStyle(m6), s = Di({ rectHover: true, z2: 100 }, s, true);
      var b6 = IR(a.get("symbolSize"));
      s.scaleX = b6[0] / 2, s.scaleY = b6[1] / 2;
      var x6 = l5(a.get("symbolOffset"), b6);
      x6 && (s.x = (s.x || 0) + x6[0], s.y = (s.y || 0) + x6[1]);
      var S = a.get("symbolRotate");
      return s.rotation = (S || 0) * Math.PI / 180 || 0, u.attr(s), u.updateTransform(), u;
    }
    function Gye(a, r6, t2, s, u, f6) {
      if (!a.dragging) {
        var d6 = u.getModel("checkpointStyle"), v6 = s.dataToCoord(u.getData().get("value", t2));
        if (f6 || !d6.get("animation", true))
          a.attr({ x: v6, y: 0 }), r6 && r6.attr({ shape: { x2: v6 } });
        else {
          var m6 = { duration: d6.get("animationDuration", true), easing: d6.get("animationEasing", true) };
          a.stopAnimation(null, true), a.animateTo({ x: v6, y: 0 }, m6), r6 && r6.animateTo({ shape: { x2: v6 } }, m6);
        }
      }
    }
    var $qe = jqe;
    function Uqe(a) {
      a.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(r6, t2, s) {
        var u = t2.getComponent("timeline");
        return u && r6.currentIndex != null && (u.setCurrentIndex(r6.currentIndex), !u.get("loop", true) && u.isIndexMax() && u.getPlayState() && (u.setPlayState(false), s.dispatchAction({ type: "timelinePlayChange", playState: false, from: r6.from }))), t2.resetOption("timeline", { replaceMerge: u.get("replaceMerge", true) }), ei({ currentIndex: u.option.currentIndex }, r6);
      }), a.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(r6, t2) {
        var s = t2.getComponent("timeline");
        s && r6.playState != null && s.setPlayState(r6.playState);
      });
    }
    function qqe(a) {
      var r6 = a && a.timeline;
      br(r6) || (r6 = r6 ? [r6] : []), Ne(r6, function(t2) {
        !t2 || Yqe(t2);
      });
    }
    function Yqe(a) {
      var r6 = a.type, t2 = { number: "value", time: "time" };
      if (t2[r6] && (a.axisType = t2[r6], delete a.type), Wye(a), FA(a, "controlPosition")) {
        var s = a.controlStyle || (a.controlStyle = {});
        FA(s, "position") || (s.position = a.controlPosition), s.position === "none" && !FA(s, "show") && (s.show = false, delete s.position), delete a.controlPosition;
      }
      Ne(a.data || [], function(u) {
        ui(u) && !br(u) && (!FA(u, "value") && FA(u, "name") && (u.value = u.name), Wye(u));
      });
    }
    function Wye(a) {
      var r6 = a.itemStyle || (a.itemStyle = {}), t2 = r6.emphasis || (r6.emphasis = {}), s = a.label || a.label || {}, u = s.normal || (s.normal = {}), f6 = { normal: 1, emphasis: 1 };
      Ne(s, function(d6, v6) {
        !f6[v6] && !FA(u, v6) && (u[v6] = d6);
      }), t2.label && !FA(s, "emphasis") && (s.emphasis = t2.label, delete t2.label);
    }
    function FA(a, r6) {
      return a.hasOwnProperty(r6);
    }
    function Zqe(a) {
      a.registerComponentModel(Fqe), a.registerComponentView($qe), a.registerSubTypeDefaulter("timeline", function() {
        return "slider";
      }), Uqe(a), a.registerPreprocessor(qqe);
    }
    function _J(a, r6) {
      if (!a)
        return false;
      for (var t2 = br(a) ? a : [a], s = 0; s < t2.length; s++)
        if (t2[s] && t2[s][r6])
          return true;
      return false;
    }
    function Vz(a) {
      ug(a, "label", ["show"]);
    }
    var zz = Xo(), Hye = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.createdBySelf = false, t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        this.mergeDefaultAndTheme(t2, u), this._mergeOption(t2, u, false, true);
      }, r6.prototype.isAnimationEnabled = function() {
        if (ha.node)
          return false;
        var t2 = this.__hostSeries;
        return this.getShallow("animation") && t2 && t2.isAnimationEnabled();
      }, r6.prototype.mergeOption = function(t2, s) {
        this._mergeOption(t2, s, false, false);
      }, r6.prototype._mergeOption = function(t2, s, u, f6) {
        var d6 = this.mainType;
        u || s.eachSeries(function(v6) {
          var m6 = v6.get(this.mainType, true), b6 = zz(v6)[d6];
          if (!m6 || !m6.data) {
            zz(v6)[d6] = null;
            return;
          }
          b6 ? b6._mergeOption(m6, s, true) : (f6 && Vz(m6), Ne(m6.data, function(x6) {
            x6 instanceof Array ? (Vz(x6[0]), Vz(x6[1])) : Vz(x6);
          }), b6 = this.createMarkerModelFromSeries(m6, this, s), qn(b6, { mainType: this.mainType, seriesIndex: v6.seriesIndex, name: v6.name, createdBySelf: true }), b6.__hostSeries = v6), zz(v6)[d6] = b6;
        }, this);
      }, r6.prototype.formatTooltip = function(t2, s, u) {
        var f6 = this.getData(), d6 = this.getRawValue(t2), v6 = f6.getName(t2);
        return Ih("section", { header: this.name, blocks: [Ih("nameValue", { name: v6, value: d6, noName: !v6, noValue: d6 == null })] });
      }, r6.prototype.getData = function() {
        return this._data;
      }, r6.prototype.setData = function(t2) {
        this._data = t2;
      }, r6.getMarkerModelFromSeries = function(t2, s) {
        return zz(t2)[s];
      }, r6.type = "marker", r6.dependencies = ["series", "grid", "polar", "geo"], r6;
    }(Ps);
    Dc(Hye, KY.prototype);
    var dS = Hye, Xqe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.createMarkerModelFromSeries = function(t2, s, u) {
        return new r6(t2, s, u);
      }, r6.type = "markPoint", r6.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, r6;
    }(dS), Kqe = Xqe;
    function Jqe(a) {
      return !(isNaN(parseFloat(a.x)) && isNaN(parseFloat(a.y)));
    }
    function Qqe(a) {
      return !isNaN(parseFloat(a.x)) && !isNaN(parseFloat(a.y));
    }
    function Bz(a, r6, t2, s, u, f6) {
      var d6 = [], v6 = tS(r6, s), m6 = v6 ? r6.getCalculationInfo("stackResultDimension") : s, b6 = wJ(r6, m6, a), x6 = r6.indicesOfNearest(m6, b6)[0];
      d6[u] = r6.get(t2, x6), d6[f6] = r6.get(m6, x6);
      var S = r6.get(s, x6), M = o0(r6.get(s, x6));
      return M = Math.min(M, 20), M >= 0 && (d6[f6] = +d6[f6].toFixed(M)), [d6, S];
    }
    var xJ = { min: Oi(Bz, "min"), max: Oi(Bz, "max"), average: Oi(Bz, "average"), median: Oi(Bz, "median") };
    function w42(a, r6) {
      var t2 = a.getData(), s = a.coordinateSystem;
      if (r6 && !Qqe(r6) && !br(r6.coord) && s) {
        var u = s.dimensions, f6 = $ye(r6, t2, s, a);
        if (r6 = Qa(r6), r6.type && xJ[r6.type] && f6.baseAxis && f6.valueAxis) {
          var d6 = Vi(u, f6.baseAxis.dim), v6 = Vi(u, f6.valueAxis.dim), m6 = xJ[r6.type](t2, f6.baseDataDim, f6.valueDataDim, d6, v6);
          r6.coord = m6[0], r6.value = m6[1];
        } else {
          for (var b6 = [r6.xAxis != null ? r6.xAxis : r6.radiusAxis, r6.yAxis != null ? r6.yAxis : r6.angleAxis], x6 = 0; x6 < 2; x6++)
            xJ[b6[x6]] && (b6[x6] = wJ(t2, t2.mapDimension(u[x6]), b6[x6]));
          r6.coord = b6;
        }
      }
      return r6;
    }
    function $ye(a, r6, t2, s) {
      var u = {};
      return a.valueIndex != null || a.valueDim != null ? (u.valueDataDim = a.valueIndex != null ? r6.getDimension(a.valueIndex) : a.valueDim, u.valueAxis = t2.getAxis(eYe(s, u.valueDataDim)), u.baseAxis = t2.getOtherAxis(u.valueAxis), u.baseDataDim = r6.mapDimension(u.baseAxis.dim)) : (u.baseAxis = s.getBaseAxis(), u.valueAxis = t2.getOtherAxis(u.baseAxis), u.baseDataDim = r6.mapDimension(u.baseAxis.dim), u.valueDataDim = r6.mapDimension(u.valueAxis.dim)), u;
    }
    function eYe(a, r6) {
      var t2 = a.getData().getDimensionInfo(r6);
      return t2 && t2.coordDim;
    }
    function S4(a, r6) {
      return a && a.containData && r6.coord && !Jqe(r6) ? a.containData(r6.coord) : true;
    }
    function Uye(a, r6) {
      return a ? function(t2, s, u, f6) {
        var d6 = f6 < 2 ? t2.coord && t2.coord[f6] : t2.value;
        return K2(d6, r6[f6]);
      } : function(t2, s, u, f6) {
        return K2(t2.value, r6[f6]);
      };
    }
    function wJ(a, r6, t2) {
      if (t2 === "average") {
        var s = 0, u = 0;
        return a.each(r6, function(f6, d6) {
          isNaN(f6) || (s += f6, u++);
        }), s / u;
      } else
        return t2 === "median" ? a.getMedian(r6) : a.getDataExtent(r6)[t2 === "max" ? 1 : 0];
    }
    var SJ = Xo(), tYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.init = function() {
        this.markerGroupMap = Ta();
      }, r6.prototype.render = function(t2, s, u) {
        var f6 = this, d6 = this.markerGroupMap;
        d6.each(function(v6) {
          SJ(v6).keep = false;
        }), s.eachSeries(function(v6) {
          var m6 = dS.getMarkerModelFromSeries(v6, f6.type);
          m6 && f6.renderSeries(v6, m6, s, u);
        }), d6.each(function(v6) {
          !SJ(v6).keep && f6.group.remove(v6.group);
        });
      }, r6.prototype.markKeep = function(t2) {
        SJ(t2).keep = true;
      }, r6.prototype.blurSeries = function(t2) {
        var s = this;
        Ne(t2, function(u) {
          var f6 = dS.getMarkerModelFromSeries(u, s.type);
          if (f6) {
            var d6 = f6.getData();
            d6.eachItemGraphicEl(function(v6) {
              v6 && D7(v6);
            });
          }
        });
      }, r6.type = "marker", r6;
    }(Rc), CJ = tYe;
    function qye(a, r6, t2) {
      var s = r6.coordinateSystem;
      a.each(function(u) {
        var f6 = a.getItemModel(u), d6, v6 = ua(f6.get("x"), t2.getWidth()), m6 = ua(f6.get("y"), t2.getHeight());
        if (!isNaN(v6) && !isNaN(m6))
          d6 = [v6, m6];
        else if (r6.getMarkerPosition)
          d6 = r6.getMarkerPosition(a.getValues(a.dimensions, u));
        else if (s) {
          var b6 = a.get(s.dimensions[0], u), x6 = a.get(s.dimensions[1], u);
          d6 = s.dataToPoint([b6, x6]);
        }
        isNaN(v6) || (d6[0] = v6), isNaN(m6) || (d6[1] = m6), a.setItemLayout(u, d6);
      });
    }
    var nYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.updateTransform = function(t2, s, u) {
        s.eachSeries(function(f6) {
          var d6 = dS.getMarkerModelFromSeries(f6, "markPoint");
          d6 && (qye(d6.getData(), f6, u), this.markerGroupMap.get(f6.id).updateLayout());
        }, this);
      }, r6.prototype.renderSeries = function(t2, s, u, f6) {
        var d6 = t2.coordinateSystem, v6 = t2.id, m6 = t2.getData(), b6 = this.markerGroupMap, x6 = b6.get(v6) || b6.set(v6, new XR()), S = rYe(d6, t2, s);
        s.setData(S), qye(s.getData(), t2, f6), S.each(function(M) {
          var A6 = S.getItemModel(M), I = A6.getShallow("symbol"), R = A6.getShallow("symbolSize"), F = A6.getShallow("symbolRotate"), j = A6.getShallow("symbolOffset"), $ = A6.getShallow("symbolKeepAspect");
          if (ti(I) || ti(R) || ti(F) || ti(j)) {
            var K = s.getRawValue(M), U = s.getDataParams(M);
            ti(I) && (I = I(K, U)), ti(R) && (R = R(K, U)), ti(F) && (F = F(K, U)), ti(j) && (j = j(K, U));
          }
          var he = A6.getModel("itemStyle").getItemStyle(), ue = ER(m6, "color");
          he.fill || (he.fill = ue), S.setItemVisual(M, { symbol: I, symbolSize: R, symbolRotate: F, symbolOffset: j, symbolKeepAspect: $, style: he });
        }), x6.updateData(S), this.group.add(x6.group), S.eachItemGraphicEl(function(M) {
          M.traverse(function(A6) {
            ii(A6).dataModel = s;
          });
        }), this.markKeep(x6), x6.group.silent = s.get("silent") || t2.get("silent");
      }, r6.type = "markPoint", r6;
    }(CJ);
    function rYe(a, r6, t2) {
      var s;
      a ? s = wr(a && a.dimensions, function(v6) {
        var m6 = r6.getData().getDimensionInfo(r6.getData().mapDimension(v6)) || {};
        return qn(qn({}, m6), { name: v6, ordinalMeta: null });
      }) : s = [{ name: "value", type: "float" }];
      var u = new Tv(s, t2), f6 = wr(t2.get("data"), Oi(w42, r6));
      a && (f6 = gl(f6, Oi(S4, a)));
      var d6 = Uye(!!a, s);
      return u.initData(f6, null, d6), u;
    }
    var aYe = nYe;
    function iYe(a) {
      a.registerComponentModel(Kqe), a.registerComponentView(aYe), a.registerPreprocessor(function(r6) {
        _J(r6.series, "markPoint") && (r6.markPoint = r6.markPoint || {});
      });
    }
    var oYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.createMarkerModelFromSeries = function(t2, s, u) {
        return new r6(t2, s, u);
      }, r6.type = "markLine", r6.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, r6;
    }(dS), sYe = oYe, jz = Xo(), lYe = function(a, r6, t2, s) {
      var u = a.getData(), f6;
      if (br(s))
        f6 = s;
      else {
        var d6 = s.type;
        if (d6 === "min" || d6 === "max" || d6 === "average" || d6 === "median" || s.xAxis != null || s.yAxis != null) {
          var v6 = void 0, m6 = void 0;
          if (s.yAxis != null || s.xAxis != null)
            v6 = r6.getAxis(s.yAxis != null ? "y" : "x"), m6 = Jf(s.yAxis, s.xAxis);
          else {
            var b6 = $ye(s, u, r6, a);
            v6 = b6.valueAxis;
            var x6 = qhe(u, b6.valueDataDim);
            m6 = wJ(u, x6, d6);
          }
          var S = v6.dim === "x" ? 0 : 1, M = 1 - S, A6 = Qa(s), I = { coord: [] };
          A6.type = null, A6.coord = [], A6.coord[M] = -1 / 0, I.coord[M] = 1 / 0;
          var R = t2.get("precision");
          R >= 0 && ks(m6) && (m6 = +m6.toFixed(Math.min(R, 20))), A6.coord[S] = I.coord[S] = m6, f6 = [A6, I, { type: d6, valueIndex: s.valueIndex, value: m6 }];
        } else
          f6 = [];
      }
      var F = [w42(a, f6[0]), w42(a, f6[1]), qn({}, f6[2])];
      return F[2].type = F[2].type || null, Di(F[2], F[0]), Di(F[2], F[1]), F;
    };
    function Gz(a) {
      return !isNaN(a) && !isFinite(a);
    }
    function Yye(a, r6, t2, s) {
      var u = 1 - a, f6 = s.dimensions[a];
      return Gz(r6[u]) && Gz(t2[u]) && r6[a] === t2[a] && s.getAxis(f6).containData(r6[a]);
    }
    function uYe(a, r6) {
      if (a.type === "cartesian2d") {
        var t2 = r6[0].coord, s = r6[1].coord;
        if (t2 && s && (Yye(1, t2, s, a) || Yye(0, t2, s, a)))
          return true;
      }
      return S4(a, r6[0]) && S4(a, r6[1]);
    }
    function MJ(a, r6, t2, s, u) {
      var f6 = s.coordinateSystem, d6 = a.getItemModel(r6), v6, m6 = ua(d6.get("x"), u.getWidth()), b6 = ua(d6.get("y"), u.getHeight());
      if (!isNaN(m6) && !isNaN(b6))
        v6 = [m6, b6];
      else {
        if (s.getMarkerPosition)
          v6 = s.getMarkerPosition(a.getValues(a.dimensions, r6));
        else {
          var x6 = f6.dimensions, S = a.get(x6[0], r6), M = a.get(x6[1], r6);
          v6 = f6.dataToPoint([S, M]);
        }
        if ($x(f6, "cartesian2d")) {
          var A6 = f6.getAxis("x"), I = f6.getAxis("y"), x6 = f6.dimensions;
          Gz(a.get(x6[0], r6)) ? v6[0] = A6.toGlobalCoord(A6.getExtent()[t2 ? 0 : 1]) : Gz(a.get(x6[1], r6)) && (v6[1] = I.toGlobalCoord(I.getExtent()[t2 ? 0 : 1]));
        }
        isNaN(m6) || (v6[0] = m6), isNaN(b6) || (v6[1] = b6);
      }
      a.setItemLayout(r6, v6);
    }
    var cYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.updateTransform = function(t2, s, u) {
        s.eachSeries(function(f6) {
          var d6 = dS.getMarkerModelFromSeries(f6, "markLine");
          if (d6) {
            var v6 = d6.getData(), m6 = jz(d6).from, b6 = jz(d6).to;
            m6.each(function(x6) {
              MJ(m6, x6, true, f6, u), MJ(b6, x6, false, f6, u);
            }), v6.each(function(x6) {
              v6.setItemLayout(x6, [m6.getItemLayout(x6), b6.getItemLayout(x6)]);
            }), this.markerGroupMap.get(f6.id).updateLayout();
          }
        }, this);
      }, r6.prototype.renderSeries = function(t2, s, u, f6) {
        var d6 = t2.coordinateSystem, v6 = t2.id, m6 = t2.getData(), b6 = this.markerGroupMap, x6 = b6.get(v6) || b6.set(v6, new tK());
        this.group.add(x6.group);
        var S = fYe(d6, t2, s), M = S.from, A6 = S.to, I = S.line;
        jz(s).from = M, jz(s).to = A6, s.setData(I);
        var R = s.get("symbol"), F = s.get("symbolSize"), j = s.get("symbolRotate"), $ = s.get("symbolOffset");
        br(R) || (R = [R, R]), br(F) || (F = [F, F]), br(j) || (j = [j, j]), br($) || ($ = [$, $]), S.from.each(function(U) {
          K(M, U, true), K(A6, U, false);
        }), I.each(function(U) {
          var he = I.getItemModel(U).getModel("lineStyle").getLineStyle();
          I.setItemLayout(U, [M.getItemLayout(U), A6.getItemLayout(U)]), he.stroke == null && (he.stroke = M.getItemVisual(U, "style").fill), I.setItemVisual(U, { fromSymbolKeepAspect: M.getItemVisual(U, "symbolKeepAspect"), fromSymbolOffset: M.getItemVisual(U, "symbolOffset"), fromSymbolRotate: M.getItemVisual(U, "symbolRotate"), fromSymbolSize: M.getItemVisual(U, "symbolSize"), fromSymbol: M.getItemVisual(U, "symbol"), toSymbolKeepAspect: A6.getItemVisual(U, "symbolKeepAspect"), toSymbolOffset: A6.getItemVisual(U, "symbolOffset"), toSymbolRotate: A6.getItemVisual(U, "symbolRotate"), toSymbolSize: A6.getItemVisual(U, "symbolSize"), toSymbol: A6.getItemVisual(U, "symbol"), style: he });
        }), x6.updateData(I), S.line.eachItemGraphicEl(function(U, he) {
          U.traverse(function(ue) {
            ii(ue).dataModel = s;
          });
        });
        function K(U, he, ue) {
          var pe = U.getItemModel(he);
          MJ(U, he, ue, t2, f6);
          var _e = pe.getModel("itemStyle").getItemStyle();
          _e.fill == null && (_e.fill = ER(m6, "color")), U.setItemVisual(he, { symbolKeepAspect: pe.get("symbolKeepAspect"), symbolOffset: qi(pe.get("symbolOffset", true), $[ue ? 0 : 1]), symbolRotate: qi(pe.get("symbolRotate", true), j[ue ? 0 : 1]), symbolSize: qi(pe.get("symbolSize"), F[ue ? 0 : 1]), symbol: qi(pe.get("symbol", true), R[ue ? 0 : 1]), style: _e });
        }
        this.markKeep(x6), x6.group.silent = s.get("silent") || t2.get("silent");
      }, r6.type = "markLine", r6;
    }(CJ);
    function fYe(a, r6, t2) {
      var s;
      a ? s = wr(a && a.dimensions, function(b6) {
        var x6 = r6.getData().getDimensionInfo(r6.getData().mapDimension(b6)) || {};
        return qn(qn({}, x6), { name: b6, ordinalMeta: null });
      }) : s = [{ name: "value", type: "float" }];
      var u = new Tv(s, t2), f6 = new Tv(s, t2), d6 = new Tv([], t2), v6 = wr(t2.get("data"), Oi(lYe, r6, a, t2));
      a && (v6 = gl(v6, Oi(uYe, a)));
      var m6 = Uye(!!a, s);
      return u.initData(wr(v6, function(b6) {
        return b6[0];
      }), null, m6), f6.initData(wr(v6, function(b6) {
        return b6[1];
      }), null, m6), d6.initData(wr(v6, function(b6) {
        return b6[2];
      })), d6.hasItemOption = true, { from: u, to: f6, line: d6 };
    }
    var hYe = cYe;
    function dYe(a) {
      a.registerComponentModel(sYe), a.registerComponentView(hYe), a.registerPreprocessor(function(r6) {
        _J(r6.series, "markLine") && (r6.markLine = r6.markLine || {});
      });
    }
    var pYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.createMarkerModelFromSeries = function(t2, s, u) {
        return new r6(t2, s, u);
      }, r6.type = "markArea", r6.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, r6;
    }(dS), vYe = pYe, Wz = Xo(), gYe = function(a, r6, t2, s) {
      var u = w42(a, s[0]), f6 = w42(a, s[1]), d6 = u.coord, v6 = f6.coord;
      d6[0] = Jf(d6[0], -1 / 0), d6[1] = Jf(d6[1], -1 / 0), v6[0] = Jf(v6[0], 1 / 0), v6[1] = Jf(v6[1], 1 / 0);
      var m6 = ax([{}, u, f6]);
      return m6.coord = [u.coord, f6.coord], m6.x0 = u.x, m6.y0 = u.y, m6.x1 = f6.x, m6.y1 = f6.y, m6;
    };
    function Hz(a) {
      return !isNaN(a) && !isFinite(a);
    }
    function Zye(a, r6, t2, s) {
      var u = 1 - a;
      return Hz(r6[u]) && Hz(t2[u]);
    }
    function mYe(a, r6) {
      var t2 = r6.coord[0], s = r6.coord[1];
      return $x(a, "cartesian2d") && t2 && s && (Zye(1, t2, s) || Zye(0, t2, s)) ? true : S4(a, { coord: t2, x: r6.x0, y: r6.y0 }) || S4(a, { coord: s, x: r6.x1, y: r6.y1 });
    }
    function Xye(a, r6, t2, s, u) {
      var f6 = s.coordinateSystem, d6 = a.getItemModel(r6), v6, m6 = ua(d6.get(t2[0]), u.getWidth()), b6 = ua(d6.get(t2[1]), u.getHeight());
      if (!isNaN(m6) && !isNaN(b6))
        v6 = [m6, b6];
      else {
        if (s.getMarkerPosition)
          v6 = s.getMarkerPosition(a.getValues(t2, r6));
        else {
          var x6 = a.get(t2[0], r6), S = a.get(t2[1], r6), M = [x6, S];
          f6.clampData && f6.clampData(M, M), v6 = f6.dataToPoint(M, true);
        }
        if ($x(f6, "cartesian2d")) {
          var A6 = f6.getAxis("x"), I = f6.getAxis("y"), x6 = a.get(t2[0], r6), S = a.get(t2[1], r6);
          Hz(x6) ? v6[0] = A6.toGlobalCoord(A6.getExtent()[t2[0] === "x0" ? 0 : 1]) : Hz(S) && (v6[1] = I.toGlobalCoord(I.getExtent()[t2[1] === "y0" ? 0 : 1]));
        }
        isNaN(m6) || (v6[0] = m6), isNaN(b6) || (v6[1] = b6);
      }
      return v6;
    }
    var Kye = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], yYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.updateTransform = function(t2, s, u) {
        s.eachSeries(function(f6) {
          var d6 = dS.getMarkerModelFromSeries(f6, "markArea");
          if (d6) {
            var v6 = d6.getData();
            v6.each(function(m6) {
              var b6 = wr(Kye, function(S) {
                return Xye(v6, m6, S, f6, u);
              });
              v6.setItemLayout(m6, b6);
              var x6 = v6.getItemGraphicEl(m6);
              x6.setShape("points", b6);
            });
          }
        }, this);
      }, r6.prototype.renderSeries = function(t2, s, u, f6) {
        var d6 = t2.coordinateSystem, v6 = t2.id, m6 = t2.getData(), b6 = this.markerGroupMap, x6 = b6.get(v6) || b6.set(v6, { group: new bi() });
        this.group.add(x6.group), this.markKeep(x6);
        var S = bYe(d6, t2, s);
        s.setData(S), S.each(function(M) {
          var A6 = wr(Kye, function(_e) {
            return Xye(S, M, _e, t2, f6);
          }), I = d6.getAxis("x").scale, R = d6.getAxis("y").scale, F = I.getExtent(), j = R.getExtent(), $ = [I.parse(S.get("x0", M)), I.parse(S.get("x1", M))], K = [R.parse(S.get("y0", M)), R.parse(S.get("y1", M))];
          Sv($), Sv(K);
          var U = !(F[0] > $[1] || F[1] < $[0] || j[0] > K[1] || j[1] < K[0]), he = !U;
          S.setItemLayout(M, { points: A6, allClipped: he });
          var ue = S.getItemModel(M).getModel("itemStyle").getItemStyle(), pe = ER(m6, "color");
          ue.fill || (ue.fill = pe, _a2(ue.fill) && (ue.fill = jT(ue.fill, 0.4))), ue.stroke || (ue.stroke = pe), S.setItemVisual(M, "style", ue);
        }), S.diff(Wz(x6).data).add(function(M) {
          var A6 = S.getItemLayout(M);
          if (!A6.allClipped) {
            var I = new ud({ shape: { points: A6.points } });
            S.setItemGraphicEl(M, I), x6.group.add(I);
          }
        }).update(function(M, A6) {
          var I = Wz(x6).data.getItemGraphicEl(A6), R = S.getItemLayout(M);
          R.allClipped ? I && x6.group.remove(I) : (I ? fs(I, { shape: { points: R.points } }, s, M) : I = new ud({ shape: { points: R.points } }), S.setItemGraphicEl(M, I), x6.group.add(I));
        }).remove(function(M) {
          var A6 = Wz(x6).data.getItemGraphicEl(M);
          x6.group.remove(A6);
        }).execute(), S.eachItemGraphicEl(function(M, A6) {
          var I = S.getItemModel(A6), R = S.getItemVisual(A6, "style");
          M.useStyle(S.getItemVisual(A6, "style")), Bp(M, hd(I), { labelFetcher: s, labelDataIndex: A6, defaultText: S.getName(A6) || "", inheritColor: _a2(R.fill) ? jT(R.fill, 1) : "#000" }), Ah(M, I), Cc(M, null, null, I.get(["emphasis", "disabled"])), ii(M).dataModel = s;
        }), Wz(x6).data = S, x6.group.silent = s.get("silent") || t2.get("silent");
      }, r6.type = "markArea", r6;
    }(CJ);
    function bYe(a, r6, t2) {
      var s, u, f6 = ["x0", "y0", "x1", "y1"];
      if (a) {
        var d6 = wr(a && a.dimensions, function(b6) {
          var x6 = r6.getData(), S = x6.getDimensionInfo(x6.mapDimension(b6)) || {};
          return qn(qn({}, S), { name: b6, ordinalMeta: null });
        });
        u = wr(f6, function(b6, x6) {
          return { name: b6, type: d6[x6 % 2].type };
        }), s = new Tv(u, t2);
      } else
        u = [{ name: "value", type: "float" }], s = new Tv(u, t2);
      var v6 = wr(t2.get("data"), Oi(gYe, r6, a, t2));
      a && (v6 = gl(v6, Oi(mYe, a)));
      var m6 = a ? function(b6, x6, S, M) {
        var A6 = b6.coord[Math.floor(M / 2)][M % 2];
        return K2(A6, u[M]);
      } : function(b6, x6, S, M) {
        return K2(b6.value, u[M]);
      };
      return s.initData(v6, null, m6), s.hasItemOption = true, s;
    }
    var _Ye = yYe;
    function xYe(a) {
      a.registerComponentModel(vYe), a.registerComponentView(_Ye), a.registerPreprocessor(function(r6) {
        _J(r6.series, "markArea") && (r6.markArea = r6.markArea || {});
      });
    }
    var wYe = function(a, r6) {
      if (r6 === "all")
        return { type: "all", title: a.getLocaleModel().get(["legend", "selector", "all"]) };
      if (r6 === "inverse")
        return { type: "inverse", title: a.getLocaleModel().get(["legend", "selector", "inverse"]) };
    }, SYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.layoutMode = { type: "box", ignoreSize: true }, t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        this.mergeDefaultAndTheme(t2, u), t2.selected = t2.selected || {}, this._updateSelector(t2);
      }, r6.prototype.mergeOption = function(t2, s) {
        a.prototype.mergeOption.call(this, t2, s), this._updateSelector(t2);
      }, r6.prototype._updateSelector = function(t2) {
        var s = t2.selector, u = this.ecModel;
        s === true && (s = t2.selector = ["all", "inverse"]), br(s) && Ne(s, function(f6, d6) {
          _a2(f6) && (f6 = { type: f6 }), s[d6] = Di(f6, wYe(u, f6.type));
        });
      }, r6.prototype.optionUpdated = function() {
        this._updateData(this.ecModel);
        var t2 = this._data;
        if (t2[0] && this.get("selectedMode") === "single") {
          for (var s = false, u = 0; u < t2.length; u++) {
            var f6 = t2[u].get("name");
            if (this.isSelected(f6)) {
              this.select(f6), s = true;
              break;
            }
          }
          !s && this.select(t2[0].get("name"));
        }
      }, r6.prototype._updateData = function(t2) {
        var s = [], u = [];
        t2.eachRawSeries(function(v6) {
          var m6 = v6.name;
          u.push(m6);
          var b6;
          if (v6.legendVisualProvider) {
            var x6 = v6.legendVisualProvider, S = x6.getAllNames();
            t2.isSeriesFiltered(v6) || (u = u.concat(S)), S.length ? s = s.concat(S) : b6 = true;
          } else
            b6 = true;
          b6 && uO(v6) && s.push(v6.name);
        }), this._availableNames = u;
        var f6 = this.get("data") || s, d6 = wr(f6, function(v6) {
          return (_a2(v6) || ks(v6)) && (v6 = { name: v6 }), new yu(v6, this, this.ecModel);
        }, this);
        this._data = d6;
      }, r6.prototype.getData = function() {
        return this._data;
      }, r6.prototype.select = function(t2) {
        var s = this.option.selected, u = this.get("selectedMode");
        if (u === "single") {
          var f6 = this._data;
          Ne(f6, function(d6) {
            s[d6.get("name")] = false;
          });
        }
        s[t2] = true;
      }, r6.prototype.unSelect = function(t2) {
        this.get("selectedMode") !== "single" && (this.option.selected[t2] = false);
      }, r6.prototype.toggleSelected = function(t2) {
        var s = this.option.selected;
        s.hasOwnProperty(t2) || (s[t2] = true), this[s[t2] ? "unSelect" : "select"](t2);
      }, r6.prototype.allSelect = function() {
        var t2 = this._data, s = this.option.selected;
        Ne(t2, function(u) {
          s[u.get("name", true)] = true;
        });
      }, r6.prototype.inverseSelect = function() {
        var t2 = this._data, s = this.option.selected;
        Ne(t2, function(u) {
          var f6 = u.get("name", true);
          s.hasOwnProperty(f6) || (s[f6] = true), s[f6] = !s[f6];
        });
      }, r6.prototype.isSelected = function(t2) {
        var s = this.option.selected;
        return !(s.hasOwnProperty(t2) && !s[t2]) && Vi(this._availableNames, t2) >= 0;
      }, r6.prototype.getOrient = function() {
        return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
      }, r6.type = "legend.plain", r6.dependencies = ["series"], r6.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, r6;
    }(Ps), AJ = SYe, T5 = Oi, EJ = Ne, $z = bi, CYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.newlineDisabled = false, t2;
      }
      return r6.prototype.init = function() {
        this.group.add(this._contentGroup = new $z()), this.group.add(this._selectorGroup = new $z()), this._isFirstRender = true;
      }, r6.prototype.getContentGroup = function() {
        return this._contentGroup;
      }, r6.prototype.getSelectorGroup = function() {
        return this._selectorGroup;
      }, r6.prototype.render = function(t2, s, u) {
        var f6 = this._isFirstRender;
        if (this._isFirstRender = false, this.resetInner(), !!t2.get("show", true)) {
          var d6 = t2.get("align"), v6 = t2.get("orient");
          (!d6 || d6 === "auto") && (d6 = t2.get("left") === "right" && v6 === "vertical" ? "right" : "left");
          var m6 = t2.get("selector", true), b6 = t2.get("selectorPosition", true);
          m6 && (!b6 || b6 === "auto") && (b6 = v6 === "horizontal" ? "end" : "start"), this.renderInner(d6, t2, s, u, m6, v6, b6);
          var x6 = t2.getBoxLayoutParams(), S = { width: u.getWidth(), height: u.getHeight() }, M = t2.get("padding"), A6 = ah(x6, S, M), I = this.layoutInner(t2, d6, A6, f6, m6, b6), R = ah(ei({ width: I.width, height: I.height }, x6), S, M);
          this.group.x = R.x - I.x, this.group.y = R.y - I.y, this.group.markRedraw(), this.group.add(this._backgroundEl = oye(I, t2));
        }
      }, r6.prototype.resetInner = function() {
        this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
      }, r6.prototype.renderInner = function(t2, s, u, f6, d6, v6, m6) {
        var b6 = this.getContentGroup(), x6 = Ta(), S = s.get("selectedMode"), M = [];
        u.eachRawSeries(function(A6) {
          !A6.get("legendHoverLink") && M.push(A6.id);
        }), EJ(s.getData(), function(A6, I) {
          var R = A6.get("name");
          if (!this.newlineDisabled && (R === "" || R === `
`)) {
            var F = new $z();
            F.newline = true, b6.add(F);
            return;
          }
          var j = u.getSeriesByName(R)[0];
          if (!x6.get(R))
            if (j) {
              var $ = j.getData(), K = $.getVisual("legendLineStyle") || {}, U = $.getVisual("legendIcon"), he = $.getVisual("style"), ue = this._createItem(j, R, I, A6, s, t2, K, he, U, S);
              ue.on("click", T5(Jye, R, null, f6, M)).on("mouseover", T5(IJ, j.name, null, f6, M)).on("mouseout", T5(TJ, j.name, null, f6, M)), x6.set(R, true);
            } else
              u.eachRawSeries(function(pe) {
                if (!x6.get(R) && pe.legendVisualProvider) {
                  var _e = pe.legendVisualProvider;
                  if (!_e.containName(R))
                    return;
                  var xe = _e.indexOfName(R), Ae = _e.getItemVisual(xe, "style"), ke = _e.getItemVisual(xe, "legendIcon"), je = id2(Ae.fill);
                  je && je[3] === 0 && (je[3] = 0.2, Ae = qn(qn({}, Ae), { fill: Zy(je, "rgba") }));
                  var Fe = this._createItem(pe, R, I, A6, s, t2, {}, Ae, ke, S);
                  Fe.on("click", T5(Jye, null, R, f6, M)).on("mouseover", T5(IJ, null, R, f6, M)).on("mouseout", T5(TJ, null, R, f6, M)), x6.set(R, true);
                }
              }, this);
        }, this), d6 && this._createSelector(d6, s, f6, v6, m6);
      }, r6.prototype._createSelector = function(t2, s, u, f6, d6) {
        var v6 = this.getSelectorGroup();
        EJ(t2, function(m6) {
          var b6 = m6.type, x6 = new ms({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
            u.dispatchAction({ type: b6 === "all" ? "legendAllSelect" : "legendInverseSelect" });
          } });
          v6.add(x6);
          var S = s.getModel("selectorLabel"), M = s.getModel(["emphasis", "selectorLabel"]);
          Bp(x6, { normal: S, emphasis: M }, { defaultText: m6.title }), Fx(x6);
        });
      }, r6.prototype._createItem = function(t2, s, u, f6, d6, v6, m6, b6, x6, S) {
        var M = t2.visualDrawType, A6 = d6.get("itemWidth"), I = d6.get("itemHeight"), R = d6.isSelected(s), F = f6.get("symbolRotate"), j = f6.get("symbolKeepAspect"), $ = f6.get("icon");
        x6 = $ || x6 || "roundRect";
        var K = MYe(x6, f6, m6, b6, M, R), U = new $z(), he = f6.getModel("textStyle");
        if (ti(t2.getLegendIcon) && (!$ || $ === "inherit"))
          U.add(t2.getLegendIcon({ itemWidth: A6, itemHeight: I, icon: x6, iconRotate: F, itemStyle: K.itemStyle, lineStyle: K.lineStyle, symbolKeepAspect: j }));
        else {
          var ue = $ === "inherit" && t2.getData().getVisual("symbol") ? F === "inherit" ? t2.getData().getVisual("symbolRotate") : F : 0;
          U.add(AYe({ itemWidth: A6, itemHeight: I, icon: x6, iconRotate: ue, itemStyle: K.itemStyle, lineStyle: K.lineStyle, symbolKeepAspect: j }));
        }
        var pe = v6 === "left" ? A6 + 5 : -5, _e = v6, xe = d6.get("formatter"), Ae = s;
        _a2(xe) && xe ? Ae = xe.replace("{name}", s != null ? s : "") : ti(xe) && (Ae = xe(s));
        var ke = f6.get("inactiveColor");
        U.add(new ms({ style: yf(he, { text: Ae, x: pe, y: I / 2, fill: R ? he.getTextColor() : ke, align: _e, verticalAlign: "middle" }) }));
        var je = new rs({ shape: U.getBoundingRect(), invisible: true }), Fe = f6.getModel("tooltip");
        return Fe.get("show") && fd({ el: je, componentModel: d6, itemName: s, itemTooltipOption: Fe.option }), U.add(je), U.eachChild(function(at) {
          at.silent = true;
        }), je.silent = !S, this.getContentGroup().add(U), Fx(U), U.__legendDataIndex = u, U;
      }, r6.prototype.layoutInner = function(t2, s, u, f6, d6, v6) {
        var m6 = this.getContentGroup(), b6 = this.getSelectorGroup();
        cA(t2.get("orient"), m6, t2.get("itemGap"), u.width, u.height);
        var x6 = m6.getBoundingRect(), S = [-x6.x, -x6.y];
        if (b6.markRedraw(), m6.markRedraw(), d6) {
          cA("horizontal", b6, t2.get("selectorItemGap", true));
          var M = b6.getBoundingRect(), A6 = [-M.x, -M.y], I = t2.get("selectorButtonGap", true), R = t2.getOrient().index, F = R === 0 ? "width" : "height", j = R === 0 ? "height" : "width", $ = R === 0 ? "y" : "x";
          v6 === "end" ? A6[R] += x6[F] + I : S[R] += M[F] + I, A6[1 - R] += x6[j] / 2 - M[j] / 2, b6.x = A6[0], b6.y = A6[1], m6.x = S[0], m6.y = S[1];
          var K = { x: 0, y: 0 };
          return K[F] = x6[F] + I + M[F], K[j] = Math.max(x6[j], M[j]), K[$] = Math.min(0, M[$] + A6[1 - R]), K;
        } else
          return m6.x = S[0], m6.y = S[1], this.group.getBoundingRect();
      }, r6.prototype.remove = function() {
        this.getContentGroup().removeAll(), this._isFirstRender = true;
      }, r6.type = "legend.plain", r6;
    }(Rc);
    function MYe(a, r6, t2, s, u, f6) {
      function d6(I, R) {
        I.lineWidth === "auto" && (I.lineWidth = R.lineWidth > 0 ? 2 : 0), EJ(I, function(F, j) {
          I[j] === "inherit" && (I[j] = R[j]);
        });
      }
      var v6 = r6.getModel("itemStyle"), m6 = v6.getItemStyle(), b6 = a.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
      m6.decal = s.decal, m6.fill === "inherit" && (m6.fill = s[u]), m6.stroke === "inherit" && (m6.stroke = s[b6]), m6.opacity === "inherit" && (m6.opacity = (u === "fill" ? s : t2).opacity), d6(m6, s);
      var x6 = r6.getModel("lineStyle"), S = x6.getLineStyle();
      if (d6(S, t2), m6.fill === "auto" && (m6.fill = s.fill), m6.stroke === "auto" && (m6.stroke = s.fill), S.stroke === "auto" && (S.stroke = s.fill), !f6) {
        var M = r6.get("inactiveBorderWidth"), A6 = m6[b6];
        m6.lineWidth = M === "auto" ? s.lineWidth > 0 && A6 ? 2 : 0 : m6.lineWidth, m6.fill = r6.get("inactiveColor"), m6.stroke = r6.get("inactiveBorderColor"), S.stroke = x6.get("inactiveColor"), S.lineWidth = x6.get("inactiveWidth");
      }
      return { itemStyle: m6, lineStyle: S };
    }
    function AYe(a) {
      var r6 = a.icon || "roundRect", t2 = Lf(r6, 0, 0, a.itemWidth, a.itemHeight, a.itemStyle.fill, a.symbolKeepAspect);
      return t2.setStyle(a.itemStyle), t2.rotation = (a.iconRotate || 0) * Math.PI / 180, t2.setOrigin([a.itemWidth / 2, a.itemHeight / 2]), r6.indexOf("empty") > -1 && (t2.style.stroke = t2.style.fill, t2.style.fill = "#fff", t2.style.lineWidth = 2), t2;
    }
    function Jye(a, r6, t2, s) {
      TJ(a, r6, t2, s), t2.dispatchAction({ type: "legendToggleSelect", name: a != null ? a : r6 }), IJ(a, r6, t2, s);
    }
    function Qye(a) {
      for (var r6 = a.getZr().storage.getDisplayList(), t2, s = 0, u = r6.length; s < u && !(t2 = r6[s].states.emphasis); )
        s++;
      return t2 && t2.hoverLayer;
    }
    function IJ(a, r6, t2, s) {
      Qye(t2) || t2.dispatchAction({ type: "highlight", seriesName: a, name: r6, excludeSeriesId: s });
    }
    function TJ(a, r6, t2, s) {
      Qye(t2) || t2.dispatchAction({ type: "downplay", seriesName: a, name: r6, excludeSeriesId: s });
    }
    var e1e = CYe;
    function EYe(a) {
      var r6 = a.findComponents({ mainType: "legend" });
      r6 && r6.length && a.filterSeries(function(t2) {
        for (var s = 0; s < r6.length; s++)
          if (!r6[s].isSelected(t2.name))
            return false;
        return true;
      });
    }
    function C4(a, r6, t2) {
      var s = {}, u = a === "toggleSelected", f6;
      return t2.eachComponent("legend", function(d6) {
        u && f6 != null ? d6[f6 ? "select" : "unSelect"](r6.name) : a === "allSelect" || a === "inverseSelect" ? d6[a]() : (d6[a](r6.name), f6 = d6.isSelected(r6.name));
        var v6 = d6.getData();
        Ne(v6, function(m6) {
          var b6 = m6.get("name");
          if (!(b6 === `
` || b6 === "")) {
            var x6 = d6.isSelected(b6);
            s.hasOwnProperty(b6) ? s[b6] = s[b6] && x6 : s[b6] = x6;
          }
        });
      }), a === "allSelect" || a === "inverseSelect" ? { selected: s } : { name: r6.name, selected: s };
    }
    function IYe(a) {
      a.registerAction("legendToggleSelect", "legendselectchanged", Oi(C4, "toggleSelected")), a.registerAction("legendAllSelect", "legendselectall", Oi(C4, "allSelect")), a.registerAction("legendInverseSelect", "legendinverseselect", Oi(C4, "inverseSelect")), a.registerAction("legendSelect", "legendselected", Oi(C4, "select")), a.registerAction("legendUnSelect", "legendunselected", Oi(C4, "unSelect"));
    }
    function t1e(a) {
      a.registerComponentModel(AJ), a.registerComponentView(e1e), a.registerProcessor(a.PRIORITY.PROCESSOR.SERIES_FILTER, EYe), a.registerSubTypeDefaulter("legend", function() {
        return "plain";
      }), IYe(a);
    }
    var TYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.setScrollDataIndex = function(t2) {
        this.option.scrollDataIndex = t2;
      }, r6.prototype.init = function(t2, s, u) {
        var f6 = JD(t2);
        a.prototype.init.call(this, t2, s, u), n1e(this, t2, f6);
      }, r6.prototype.mergeOption = function(t2, s) {
        a.prototype.mergeOption.call(this, t2, s), n1e(this, this.option, t2);
      }, r6.type = "legend.scroll", r6.defaultOption = Y2(AJ.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), r6;
    }(AJ);
    function n1e(a, r6, t2) {
      var s = a.getOrient(), u = [1, 1];
      u[s.index] = 0, Z2(r6, t2, { type: "box", ignoreSize: !!u });
    }
    var DYe = TYe, r1e = bi, DJ = ["width", "height"], kJ = ["x", "y"], kYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.newlineDisabled = true, t2._currentIndex = 0, t2;
      }
      return r6.prototype.init = function() {
        a.prototype.init.call(this), this.group.add(this._containerGroup = new r1e()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new r1e());
      }, r6.prototype.resetInner = function() {
        a.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
      }, r6.prototype.renderInner = function(t2, s, u, f6, d6, v6, m6) {
        var b6 = this;
        a.prototype.renderInner.call(this, t2, s, u, f6, d6, v6, m6);
        var x6 = this._controllerGroup, S = s.get("pageIconSize", true), M = br(S) ? S : [S, S];
        I("pagePrev", 0);
        var A6 = s.getModel("pageTextStyle");
        x6.add(new ms({ name: "pageText", style: { text: "xx/xx", fill: A6.getTextColor(), font: A6.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), I("pageNext", 1);
        function I(R, F) {
          var j = R + "DataIndex", $ = ys(s.get("pageIcons", true)[s.getOrient().name][F], { onclick: Ca(b6._pageGo, b6, j, s, f6) }, { x: -M[0] / 2, y: -M[1] / 2, width: M[0], height: M[1] });
          $.name = R, x6.add($);
        }
      }, r6.prototype.layoutInner = function(t2, s, u, f6, d6, v6) {
        var m6 = this.getSelectorGroup(), b6 = t2.getOrient().index, x6 = DJ[b6], S = kJ[b6], M = DJ[1 - b6], A6 = kJ[1 - b6];
        d6 && cA("horizontal", m6, t2.get("selectorItemGap", true));
        var I = t2.get("selectorButtonGap", true), R = m6.getBoundingRect(), F = [-R.x, -R.y], j = Qa(u);
        d6 && (j[x6] = u[x6] - R[x6] - I);
        var $ = this._layoutContentAndController(t2, f6, j, b6, x6, M, A6, S);
        if (d6) {
          if (v6 === "end")
            F[b6] += $[x6] + I;
          else {
            var K = R[x6] + I;
            F[b6] -= K, $[S] -= K;
          }
          $[x6] += R[x6] + I, F[1 - b6] += $[A6] + $[M] / 2 - R[M] / 2, $[M] = Math.max($[M], R[M]), $[A6] = Math.min($[A6], R[A6] + F[1 - b6]), m6.x = F[0], m6.y = F[1], m6.markRedraw();
        }
        return $;
      }, r6.prototype._layoutContentAndController = function(t2, s, u, f6, d6, v6, m6, b6) {
        var x6 = this.getContentGroup(), S = this._containerGroup, M = this._controllerGroup;
        cA(t2.get("orient"), x6, t2.get("itemGap"), f6 ? u.width : null, f6 ? null : u.height), cA("horizontal", M, t2.get("pageButtonItemGap", true));
        var A6 = x6.getBoundingRect(), I = M.getBoundingRect(), R = this._showController = A6[d6] > u[d6], F = [-A6.x, -A6.y];
        s || (F[f6] = x6[b6]);
        var j = [0, 0], $ = [-I.x, -I.y], K = qi(t2.get("pageButtonGap", true), t2.get("itemGap", true));
        if (R) {
          var U = t2.get("pageButtonPosition", true);
          U === "end" ? $[f6] += u[d6] - I[d6] : j[f6] += I[d6] + K;
        }
        $[1 - f6] += A6[v6] / 2 - I[v6] / 2, x6.setPosition(F), S.setPosition(j), M.setPosition($);
        var he = { x: 0, y: 0 };
        if (he[d6] = R ? u[d6] : A6[d6], he[v6] = Math.max(A6[v6], I[v6]), he[m6] = Math.min(0, I[m6] + $[1 - f6]), S.__rectSize = u[d6], R) {
          var ue = { x: 0, y: 0 };
          ue[d6] = Math.max(u[d6] - I[d6] - K, 0), ue[v6] = he[v6], S.setClipPath(new rs({ shape: ue })), S.__rectSize = ue[d6];
        } else
          M.eachChild(function(_e) {
            _e.attr({ invisible: true, silent: true });
          });
        var pe = this._getPageInfo(t2);
        return pe.pageIndex != null && fs(x6, { x: pe.contentPosition[0], y: pe.contentPosition[1] }, R ? t2 : null), this._updatePageInfoView(t2, pe), he;
      }, r6.prototype._pageGo = function(t2, s, u) {
        var f6 = this._getPageInfo(s)[t2];
        f6 != null && u.dispatchAction({ type: "legendScroll", scrollDataIndex: f6, legendId: s.id });
      }, r6.prototype._updatePageInfoView = function(t2, s) {
        var u = this._controllerGroup;
        Ne(["pagePrev", "pageNext"], function(x6) {
          var S = x6 + "DataIndex", M = s[S] != null, A6 = u.childOfName(x6);
          A6 && (A6.setStyle("fill", M ? t2.get("pageIconColor", true) : t2.get("pageIconInactiveColor", true)), A6.cursor = M ? "pointer" : "default");
        });
        var f6 = u.childOfName("pageText"), d6 = t2.get("pageFormatter"), v6 = s.pageIndex, m6 = v6 != null ? v6 + 1 : 0, b6 = s.pageCount;
        f6 && d6 && f6.setStyle("text", _a2(d6) ? d6.replace("{current}", m6 == null ? "" : m6 + "").replace("{total}", b6 == null ? "" : b6 + "") : d6({ current: m6, total: b6 }));
      }, r6.prototype._getPageInfo = function(t2) {
        var s = t2.get("scrollDataIndex", true), u = this.getContentGroup(), f6 = this._containerGroup.__rectSize, d6 = t2.getOrient().index, v6 = DJ[d6], m6 = kJ[d6], b6 = this._findTargetItemIndex(s), x6 = u.children(), S = x6[b6], M = x6.length, A6 = M ? 1 : 0, I = { contentPosition: [u.x, u.y], pageCount: A6, pageIndex: A6 - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
        if (!S)
          return I;
        var R = U(S);
        I.contentPosition[d6] = -R.s;
        for (var F = b6 + 1, j = R, $ = R, K = null; F <= M; ++F)
          K = U(x6[F]), (!K && $.e > j.s + f6 || K && !he(K, j.s)) && ($.i > j.i ? j = $ : j = K, j && (I.pageNextDataIndex == null && (I.pageNextDataIndex = j.i), ++I.pageCount)), $ = K;
        for (var F = b6 - 1, j = R, $ = R, K = null; F >= -1; --F)
          K = U(x6[F]), (!K || !he($, K.s)) && j.i < $.i && ($ = j, I.pagePrevDataIndex == null && (I.pagePrevDataIndex = j.i), ++I.pageCount, ++I.pageIndex), j = K;
        return I;
        function U(ue) {
          if (ue) {
            var pe = ue.getBoundingRect(), _e = pe[m6] + ue[m6];
            return { s: _e, e: _e + pe[v6], i: ue.__legendDataIndex };
          }
        }
        function he(ue, pe) {
          return ue.e >= pe && ue.s <= pe + f6;
        }
      }, r6.prototype._findTargetItemIndex = function(t2) {
        if (!this._showController)
          return 0;
        var s, u = this.getContentGroup(), f6;
        return u.eachChild(function(d6, v6) {
          var m6 = d6.__legendDataIndex;
          f6 == null && m6 != null && (f6 = v6), m6 === t2 && (s = v6);
        }), s != null ? s : f6;
      }, r6.type = "legend.scroll", r6;
    }(e1e), PYe = kYe;
    function LYe(a) {
      a.registerAction("legendScroll", "legendscroll", function(r6, t2) {
        var s = r6.scrollDataIndex;
        s != null && t2.eachComponent({ mainType: "legend", subType: "scroll", query: r6 }, function(u) {
          u.setScrollDataIndex(s);
        });
      });
    }
    function OYe(a) {
      bo(t1e), a.registerComponentModel(DYe), a.registerComponentView(PYe), LYe(a);
    }
    function RYe(a) {
      bo(t1e), bo(OYe);
    }
    var FYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "dataZoom.inside", r6.defaultOption = Y2(b4.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), r6;
    }(b4), NYe = FYe, PJ = Xo();
    function VYe(a, r6, t2) {
      PJ(a).coordSysRecordMap.each(function(s) {
        var u = s.dataZoomInfoMap.get(r6.uid);
        u && (u.getRange = t2);
      });
    }
    function zYe(a, r6) {
      for (var t2 = PJ(a).coordSysRecordMap, s = t2.keys(), u = 0; u < s.length; u++) {
        var f6 = s[u], d6 = t2.get(f6), v6 = d6.dataZoomInfoMap;
        if (v6) {
          var m6 = r6.uid, b6 = v6.get(m6);
          b6 && (v6.removeKey(m6), v6.keys().length || a1e(t2, d6));
        }
      }
    }
    function a1e(a, r6) {
      if (r6) {
        a.removeKey(r6.model.uid);
        var t2 = r6.controller;
        t2 && t2.dispose();
      }
    }
    function BYe(a, r6) {
      var t2 = { model: r6, containsPoint: Oi(GYe, r6), dispatchAction: Oi(jYe, a), dataZoomInfoMap: null, controller: null }, s = t2.controller = new n4(a.getZr());
      return Ne(["pan", "zoom", "scrollMove"], function(u) {
        s.on(u, function(f6) {
          var d6 = [];
          t2.dataZoomInfoMap.each(function(v6) {
            if (f6.isAvailableBehavior(v6.model.option)) {
              var m6 = (v6.getRange || {})[u], b6 = m6 && m6(v6.dzReferCoordSysInfo, t2.model.mainType, t2.controller, f6);
              !v6.model.get("disabled", true) && b6 && d6.push({ dataZoomId: v6.model.id, start: b6[0], end: b6[1] });
            }
          }), d6.length && t2.dispatchAction(d6);
        });
      }), t2;
    }
    function jYe(a, r6) {
      a.isDisposed() || a.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: r6 });
    }
    function GYe(a, r6, t2, s) {
      return a.coordinateSystem.containPoint([t2, s]);
    }
    function WYe(a) {
      var r6, t2 = "type_", s = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, u = true;
      return a.each(function(f6) {
        var d6 = f6.model, v6 = d6.get("disabled", true) ? false : d6.get("zoomLock", true) ? "move" : true;
        s[t2 + v6] > s[t2 + r6] && (r6 = v6), u = u && d6.get("preventDefaultMouseMove", true);
      }), { controlType: r6, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!u } };
    }
    function HYe(a) {
      a.registerProcessor(a.PRIORITY.PROCESSOR.FILTER, function(r6, t2) {
        var s = PJ(t2), u = s.coordSysRecordMap || (s.coordSysRecordMap = Ta());
        u.each(function(f6) {
          f6.dataZoomInfoMap = null;
        }), r6.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(f6) {
          var d6 = eye(f6);
          Ne(d6.infoList, function(v6) {
            var m6 = v6.model.uid, b6 = u.get(m6) || u.set(m6, BYe(t2, v6.model)), x6 = b6.dataZoomInfoMap || (b6.dataZoomInfoMap = Ta());
            x6.set(f6.uid, { dzReferCoordSysInfo: v6, model: f6, getRange: null });
          });
        }), u.each(function(f6) {
          var d6 = f6.controller, v6, m6 = f6.dataZoomInfoMap;
          if (m6) {
            var b6 = m6.keys()[0];
            b6 != null && (v6 = m6.get(b6));
          }
          if (!v6) {
            a1e(u, f6);
            return;
          }
          var x6 = WYe(m6);
          d6.enable(x6.controlType, x6.opt), d6.setPointerChecker(f6.containsPoint), i5(f6, "dispatchAction", v6.model.get("throttle", true), "fixRate");
        });
      });
    }
    var $Ye = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "dataZoom.inside", t2;
      }
      return r6.prototype.render = function(t2, s, u) {
        if (a.prototype.render.apply(this, arguments), t2.noTarget()) {
          this._clear();
          return;
        }
        this.range = t2.getPercentRange(), VYe(u, t2, { pan: Ca(LJ.pan, this), zoom: Ca(LJ.zoom, this), scrollMove: Ca(LJ.scrollMove, this) });
      }, r6.prototype.dispose = function() {
        this._clear(), a.prototype.dispose.apply(this, arguments);
      }, r6.prototype._clear = function() {
        zYe(this.api, this.dataZoomModel), this.range = null;
      }, r6.type = "dataZoom.inside", r6;
    }(oJ), LJ = { zoom: function(a, r6, t2, s) {
      var u = this.range, f6 = u.slice(), d6 = a.axisModels[0];
      if (d6) {
        var v6 = OJ[r6](null, [s.originX, s.originY], d6, t2, a), m6 = (v6.signal > 0 ? v6.pixelStart + v6.pixelLength - v6.pixel : v6.pixel - v6.pixelStart) / v6.pixelLength * (f6[1] - f6[0]) + f6[0], b6 = Math.max(1 / s.scale, 0);
        f6[0] = (f6[0] - m6) * b6 + m6, f6[1] = (f6[1] - m6) * b6 + m6;
        var x6 = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
        if (kA(0, f6, [0, 100], 0, x6.minSpan, x6.maxSpan), this.range = f6, u[0] !== f6[0] || u[1] !== f6[1])
          return f6;
      }
    }, pan: i1e(function(a, r6, t2, s, u, f6) {
      var d6 = OJ[s]([f6.oldX, f6.oldY], [f6.newX, f6.newY], r6, u, t2);
      return d6.signal * (a[1] - a[0]) * d6.pixel / d6.pixelLength;
    }), scrollMove: i1e(function(a, r6, t2, s, u, f6) {
      var d6 = OJ[s]([0, 0], [f6.scrollDelta, f6.scrollDelta], r6, u, t2);
      return d6.signal * (a[1] - a[0]) * f6.scrollDelta;
    }) };
    function i1e(a) {
      return function(r6, t2, s, u) {
        var f6 = this.range, d6 = f6.slice(), v6 = r6.axisModels[0];
        if (v6) {
          var m6 = a(d6, v6, r6, t2, s, u);
          if (kA(m6, d6, [0, 100], "all"), this.range = d6, f6[0] !== d6[0] || f6[1] !== d6[1])
            return d6;
        }
      };
    }
    var OJ = { grid: function(a, r6, t2, s, u) {
      var f6 = t2.axis, d6 = {}, v6 = u.model.coordinateSystem.getRect();
      return a = a || [0, 0], f6.dim === "x" ? (d6.pixel = r6[0] - a[0], d6.pixelLength = v6.width, d6.pixelStart = v6.x, d6.signal = f6.inverse ? 1 : -1) : (d6.pixel = r6[1] - a[1], d6.pixelLength = v6.height, d6.pixelStart = v6.y, d6.signal = f6.inverse ? -1 : 1), d6;
    }, polar: function(a, r6, t2, s, u) {
      var f6 = t2.axis, d6 = {}, v6 = u.model.coordinateSystem, m6 = v6.getRadiusAxis().getExtent(), b6 = v6.getAngleAxis().getExtent();
      return a = a ? v6.pointToCoord(a) : [0, 0], r6 = v6.pointToCoord(r6), t2.mainType === "radiusAxis" ? (d6.pixel = r6[0] - a[0], d6.pixelLength = m6[1] - m6[0], d6.pixelStart = m6[0], d6.signal = f6.inverse ? 1 : -1) : (d6.pixel = r6[1] - a[1], d6.pixelLength = b6[1] - b6[0], d6.pixelStart = b6[0], d6.signal = f6.inverse ? -1 : 1), d6;
    }, singleAxis: function(a, r6, t2, s, u) {
      var f6 = t2.axis, d6 = u.model.coordinateSystem.getRect(), v6 = {};
      return a = a || [0, 0], f6.orient === "horizontal" ? (v6.pixel = r6[0] - a[0], v6.pixelLength = d6.width, v6.pixelStart = d6.x, v6.signal = f6.inverse ? 1 : -1) : (v6.pixel = r6[1] - a[1], v6.pixelLength = d6.height, v6.pixelStart = d6.y, v6.signal = f6.inverse ? -1 : 1), v6;
    } }, UYe = $Ye;
    function o1e(a) {
      sJ(a), a.registerComponentModel(NYe), a.registerComponentView(UYe), HYe(a);
    }
    var qYe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.type = "dataZoom.slider", r6.layoutMode = "box", r6.defaultOption = Y2(b4.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), r6;
    }(b4), YYe = qYe, M4 = rs, s1e = 7, ZYe = 1, RJ = 30, XYe = 7, A4 = "horizontal", l1e = "vertical", KYe = 5, JYe = ["line", "bar", "candlestick", "scatter"], QYe = { easing: "cubicOut", duration: 100, delay: 0 }, eZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._displayables = {}, t2;
      }
      return r6.prototype.init = function(t2, s) {
        this.api = s, this._onBrush = Ca(this._onBrush, this), this._onBrushEnd = Ca(this._onBrushEnd, this);
      }, r6.prototype.render = function(t2, s, u, f6) {
        if (a.prototype.render.apply(this, arguments), i5(this, "_dispatchZoomAction", t2.get("throttle"), "fixRate"), this._orient = t2.getOrient(), t2.get("show") === false) {
          this.group.removeAll();
          return;
        }
        if (t2.noTarget()) {
          this._clear(), this.group.removeAll();
          return;
        }
        (!f6 || f6.type !== "dataZoom" || f6.from !== this.uid) && this._buildView(), this._updateView();
      }, r6.prototype.dispose = function() {
        this._clear(), a.prototype.dispose.apply(this, arguments);
      }, r6.prototype._clear = function() {
        CR(this, "_dispatchZoomAction");
        var t2 = this.api.getZr();
        t2.off("mousemove", this._onBrush), t2.off("mouseup", this._onBrushEnd);
      }, r6.prototype._buildView = function() {
        var t2 = this.group;
        t2.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
        var s = this._displayables.sliderGroup = new bi();
        this._renderBackground(), this._renderHandle(), this._renderDataShadow(), t2.add(s), this._positionGroup();
      }, r6.prototype._resetLocation = function() {
        var t2 = this.dataZoomModel, s = this.api, u = t2.get("brushSelect"), f6 = u ? XYe : 0, d6 = this._findCoordRect(), v6 = { width: s.getWidth(), height: s.getHeight() }, m6 = this._orient === A4 ? { right: v6.width - d6.x - d6.width, top: v6.height - RJ - s1e - f6, width: d6.width, height: RJ } : { right: s1e, top: d6.y, width: RJ, height: d6.height }, b6 = JD(t2.option);
        Ne(["right", "top", "width", "height"], function(S) {
          b6[S] === "ph" && (b6[S] = m6[S]);
        });
        var x6 = ah(b6, v6);
        this._location = { x: x6.x, y: x6.y }, this._size = [x6.width, x6.height], this._orient === l1e && this._size.reverse();
      }, r6.prototype._positionGroup = function() {
        var t2 = this.group, s = this._location, u = this._orient, f6 = this.dataZoomModel.getFirstTargetAxisModel(), d6 = f6 && f6.get("inverse"), v6 = this._displayables.sliderGroup, m6 = (this._dataShadowInfo || {}).otherAxisInverse;
        v6.attr(u === A4 && !d6 ? { scaleY: m6 ? 1 : -1, scaleX: 1 } : u === A4 && d6 ? { scaleY: m6 ? 1 : -1, scaleX: -1 } : u === l1e && !d6 ? { scaleY: m6 ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: m6 ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
        var b6 = t2.getBoundingRect([v6]);
        t2.x = s.x - b6.x, t2.y = s.y - b6.y, t2.markRedraw();
      }, r6.prototype._getViewExtent = function() {
        return [0, this._size[0]];
      }, r6.prototype._renderBackground = function() {
        var t2 = this.dataZoomModel, s = this._size, u = this._displayables.sliderGroup, f6 = t2.get("brushSelect");
        u.add(new M4({ silent: true, shape: { x: 0, y: 0, width: s[0], height: s[1] }, style: { fill: t2.get("backgroundColor") }, z2: -40 }));
        var d6 = new M4({ shape: { x: 0, y: 0, width: s[0], height: s[1] }, style: { fill: "transparent" }, z2: 0, onclick: Ca(this._onClickPanel, this) }), v6 = this.api.getZr();
        f6 ? (d6.on("mousedown", this._onBrushStart, this), d6.cursor = "crosshair", v6.on("mousemove", this._onBrush), v6.on("mouseup", this._onBrushEnd)) : (v6.off("mousemove", this._onBrush), v6.off("mouseup", this._onBrushEnd)), u.add(d6);
      }, r6.prototype._renderDataShadow = function() {
        var t2 = this._dataShadowInfo = this._prepareDataShadowInfo();
        if (this._displayables.dataShadowSegs = [], !t2)
          return;
        var s = this._size, u = this._shadowSize || [], f6 = t2.series, d6 = f6.getRawData(), v6 = f6.getShadowDim ? f6.getShadowDim() : t2.otherDim;
        if (v6 == null)
          return;
        var m6 = this._shadowPolygonPts, b6 = this._shadowPolylinePts;
        if (d6 !== this._shadowData || v6 !== this._shadowDim || s[0] !== u[0] || s[1] !== u[1]) {
          var x6 = d6.getDataExtent(v6), S = (x6[1] - x6[0]) * 0.3;
          x6 = [x6[0] - S, x6[1] + S];
          var M = [0, s[1]], A6 = [0, s[0]], I = [[s[0], 0], [0, 0]], R = [], F = A6[1] / (d6.count() - 1), j = 0, $ = Math.round(d6.count() / s[0]), K;
          d6.each([v6], function(_e, xe) {
            if ($ > 0 && xe % $) {
              j += F;
              return;
            }
            var Ae = _e == null || isNaN(_e) || _e === "", ke = Ae ? 0 : gs(_e, x6, M, true);
            Ae && !K && xe ? (I.push([I[I.length - 1][0], 0]), R.push([R[R.length - 1][0], 0])) : !Ae && K && (I.push([j, 0]), R.push([j, 0])), I.push([j, ke]), R.push([j, ke]), j += F, K = Ae;
          }), m6 = this._shadowPolygonPts = I, b6 = this._shadowPolylinePts = R;
        }
        this._shadowData = d6, this._shadowDim = v6, this._shadowSize = [s[0], s[1]];
        var U = this.dataZoomModel;
        function he(_e) {
          var xe = U.getModel(_e ? "selectedDataBackground" : "dataBackground"), Ae = new bi(), ke = new ud({ shape: { points: m6 }, segmentIgnoreThreshold: 1, style: xe.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), je = new Vp({ shape: { points: b6 }, segmentIgnoreThreshold: 1, style: xe.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
          return Ae.add(ke), Ae.add(je), Ae;
        }
        for (var ue = 0; ue < 3; ue++) {
          var pe = he(ue === 1);
          this._displayables.sliderGroup.add(pe), this._displayables.dataShadowSegs.push(pe);
        }
      }, r6.prototype._prepareDataShadowInfo = function() {
        var t2 = this.dataZoomModel, s = t2.get("showDataShadow");
        if (s !== false) {
          var u, f6 = this.ecModel;
          return t2.eachTargetAxis(function(d6, v6) {
            var m6 = t2.getAxisProxy(d6, v6).getTargetSeriesModels();
            Ne(m6, function(b6) {
              if (!u && !(s !== true && Vi(JYe, b6.get("type")) < 0)) {
                var x6 = f6.getComponent(fS(d6), v6).axis, S = tZe(d6), M, A6 = b6.coordinateSystem;
                S != null && A6.getOtherAxis && (M = A6.getOtherAxis(x6).inverse), S = b6.getData().mapDimension(S), u = { thisAxis: x6, series: b6, thisDim: d6, otherDim: S, otherAxisInverse: M };
              }
            }, this);
          }, this), u;
        }
      }, r6.prototype._renderHandle = function() {
        var t2 = this.group, s = this._displayables, u = s.handles = [null, null], f6 = s.handleLabels = [null, null], d6 = this._displayables.sliderGroup, v6 = this._size, m6 = this.dataZoomModel, b6 = this.api, x6 = m6.get("borderRadius") || 0, S = m6.get("brushSelect"), M = s.filler = new M4({ silent: S, style: { fill: m6.get("fillerColor") }, textConfig: { position: "inside" } });
        d6.add(M), d6.add(new M4({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: v6[0], height: v6[1], r: x6 }, style: { stroke: m6.get("dataBackgroundColor") || m6.get("borderColor"), lineWidth: ZYe, fill: "rgba(0,0,0,0)" } })), Ne([0, 1], function(K) {
          var U = m6.get("handleIcon");
          !SV[U] && U.indexOf("path://") < 0 && U.indexOf("image://") < 0 && (U = "path://" + U);
          var he = Lf(U, -1, 0, 2, 2, null, true);
          he.attr({ cursor: u1e(this._orient), draggable: true, drift: Ca(this._onDragMove, this, K), ondragend: Ca(this._onDragEnd, this), onmouseover: Ca(this._showDataInfo, this, true), onmouseout: Ca(this._showDataInfo, this, false), z2: 5 });
          var ue = he.getBoundingRect(), pe = m6.get("handleSize");
          this._handleHeight = ua(pe, this._size[1]), this._handleWidth = ue.width / ue.height * this._handleHeight, he.setStyle(m6.getModel("handleStyle").getItemStyle()), he.style.strokeNoScale = true, he.rectHover = true, he.ensureState("emphasis").style = m6.getModel(["emphasis", "handleStyle"]).getItemStyle(), Fx(he);
          var _e = m6.get("handleColor");
          _e != null && (he.style.fill = _e), d6.add(u[K] = he);
          var xe = m6.getModel("textStyle");
          t2.add(f6[K] = new ms({ silent: true, invisible: true, style: yf(xe, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: xe.getTextColor(), font: xe.getFont() }), z2: 10 }));
        }, this);
        var A6 = M;
        if (S) {
          var I = ua(m6.get("moveHandleSize"), v6[1]), R = s.moveHandle = new rs({ style: m6.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: v6[1] - 0.5, height: I } }), F = I * 0.8, j = s.moveHandleIcon = Lf(m6.get("moveHandleIcon"), -F / 2, -F / 2, F, F, "#fff", true);
          j.silent = true, j.y = v6[1] + I / 2 - 0.5, R.ensureState("emphasis").style = m6.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
          var $ = Math.min(v6[1] / 2, Math.max(I, 10));
          A6 = s.moveZone = new rs({ invisible: true, shape: { y: v6[1] - $, height: I + $ } }), A6.on("mouseover", function() {
            b6.enterEmphasis(R);
          }).on("mouseout", function() {
            b6.leaveEmphasis(R);
          }), d6.add(R), d6.add(j), d6.add(A6);
        }
        A6.attr({ draggable: true, cursor: u1e(this._orient), drift: Ca(this._onDragMove, this, "all"), ondragstart: Ca(this._showDataInfo, this, true), ondragend: Ca(this._onDragEnd, this), onmouseover: Ca(this._showDataInfo, this, true), onmouseout: Ca(this._showDataInfo, this, false) });
      }, r6.prototype._resetInterval = function() {
        var t2 = this._range = this.dataZoomModel.getPercentRange(), s = this._getViewExtent();
        this._handleEnds = [gs(t2[0], [0, 100], s, true), gs(t2[1], [0, 100], s, true)];
      }, r6.prototype._updateInterval = function(t2, s) {
        var u = this.dataZoomModel, f6 = this._handleEnds, d6 = this._getViewExtent(), v6 = u.findRepresentativeAxisProxy().getMinMaxSpan(), m6 = [0, 100];
        kA(s, f6, d6, u.get("zoomLock") ? "all" : t2, v6.minSpan != null ? gs(v6.minSpan, m6, d6, true) : null, v6.maxSpan != null ? gs(v6.maxSpan, m6, d6, true) : null);
        var b6 = this._range, x6 = this._range = Sv([gs(f6[0], d6, m6, true), gs(f6[1], d6, m6, true)]);
        return !b6 || b6[0] !== x6[0] || b6[1] !== x6[1];
      }, r6.prototype._updateView = function(t2) {
        var s = this._displayables, u = this._handleEnds, f6 = Sv(u.slice()), d6 = this._size;
        Ne([0, 1], function(A6) {
          var I = s.handles[A6], R = this._handleHeight;
          I.attr({ scaleX: R / 2, scaleY: R / 2, x: u[A6] + (A6 ? -1 : 1), y: d6[1] / 2 - R / 2 });
        }, this), s.filler.setShape({ x: f6[0], y: 0, width: f6[1] - f6[0], height: d6[1] });
        var v6 = { x: f6[0], width: f6[1] - f6[0] };
        s.moveHandle && (s.moveHandle.setShape(v6), s.moveZone.setShape(v6), s.moveZone.getBoundingRect(), s.moveHandleIcon && s.moveHandleIcon.attr("x", v6.x + v6.width / 2));
        for (var m6 = s.dataShadowSegs, b6 = [0, f6[0], f6[1], d6[0]], x6 = 0; x6 < m6.length; x6++) {
          var S = m6[x6], M = S.getClipPath();
          M || (M = new rs(), S.setClipPath(M)), M.setShape({ x: b6[x6], y: 0, width: b6[x6 + 1] - b6[x6], height: d6[1] });
        }
        this._updateDataInfo(t2);
      }, r6.prototype._updateDataInfo = function(t2) {
        var s = this.dataZoomModel, u = this._displayables, f6 = u.handleLabels, d6 = this._orient, v6 = ["", ""];
        if (s.get("showDetail")) {
          var m6 = s.findRepresentativeAxisProxy();
          if (m6) {
            var b6 = m6.getAxisModel().axis, x6 = this._range, S = t2 ? m6.calculateDataWindow({ start: x6[0], end: x6[1] }).valueWindow : m6.getDataValueWindow();
            v6 = [this._formatLabel(S[0], b6), this._formatLabel(S[1], b6)];
          }
        }
        var M = Sv(this._handleEnds.slice());
        A6.call(this, 0), A6.call(this, 1);
        function A6(I) {
          var R = Nr(u.handles[I].parent, this.group), F = za(I === 0 ? "right" : "left", R), j = this._handleWidth / 2 + KYe, $ = Yr([M[I] + (I === 0 ? -j : j), this._size[1] / 2], R);
          f6[I].setStyle({ x: $[0], y: $[1], verticalAlign: d6 === A4 ? "middle" : F, align: d6 === A4 ? F : "center", text: v6[I] });
        }
      }, r6.prototype._formatLabel = function(t2, s) {
        var u = this.dataZoomModel, f6 = u.get("labelFormatter"), d6 = u.get("labelPrecision");
        (d6 == null || d6 === "auto") && (d6 = s.getPixelPrecision());
        var v6 = t2 == null || isNaN(t2) ? "" : s.type === "category" || s.type === "time" ? s.scale.getLabel({ value: Math.round(t2) }) : t2.toFixed(Math.min(d6, 20));
        return ti(f6) ? f6(t2, v6) : _a2(f6) ? f6.replace("{value}", v6) : v6;
      }, r6.prototype._showDataInfo = function(t2) {
        t2 = this._dragging || t2;
        var s = this._displayables, u = s.handleLabels;
        u[0].attr("invisible", !t2), u[1].attr("invisible", !t2), s.moveHandle && this.api[t2 ? "enterEmphasis" : "leaveEmphasis"](s.moveHandle, 1);
      }, r6.prototype._onDragMove = function(t2, s, u, f6) {
        this._dragging = true, vm(f6.event);
        var d6 = this._displayables.sliderGroup.getLocalTransform(), v6 = Yr([s, u], d6, true), m6 = this._updateInterval(t2, v6[0]), b6 = this.dataZoomModel.get("realtime");
        this._updateView(!b6), m6 && b6 && this._dispatchZoomAction(true);
      }, r6.prototype._onDragEnd = function() {
        this._dragging = false, this._showDataInfo(false);
        var t2 = this.dataZoomModel.get("realtime");
        !t2 && this._dispatchZoomAction(false);
      }, r6.prototype._onClickPanel = function(t2) {
        var s = this._size, u = this._displayables.sliderGroup.transformCoordToLocal(t2.offsetX, t2.offsetY);
        if (!(u[0] < 0 || u[0] > s[0] || u[1] < 0 || u[1] > s[1])) {
          var f6 = this._handleEnds, d6 = (f6[0] + f6[1]) / 2, v6 = this._updateInterval("all", u[0] - d6);
          this._updateView(), v6 && this._dispatchZoomAction(false);
        }
      }, r6.prototype._onBrushStart = function(t2) {
        var s = t2.offsetX, u = t2.offsetY;
        this._brushStart = new Bi(s, u), this._brushing = true, this._brushStartTime = +new Date();
      }, r6.prototype._onBrushEnd = function(t2) {
        if (this._brushing) {
          var s = this._displayables.brushRect;
          if (this._brushing = false, !!s) {
            s.attr("ignore", true);
            var u = s.shape, f6 = +new Date();
            if (!(f6 - this._brushStartTime < 200 && Math.abs(u.width) < 5)) {
              var d6 = this._getViewExtent(), v6 = [0, 100];
              this._range = Sv([gs(u.x, d6, v6, true), gs(u.x + u.width, d6, v6, true)]), this._handleEnds = [u.x, u.x + u.width], this._updateView(), this._dispatchZoomAction(false);
            }
          }
        }
      }, r6.prototype._onBrush = function(t2) {
        this._brushing && (vm(t2.event), this._updateBrushRect(t2.offsetX, t2.offsetY));
      }, r6.prototype._updateBrushRect = function(t2, s) {
        var u = this._displayables, f6 = this.dataZoomModel, d6 = u.brushRect;
        d6 || (d6 = u.brushRect = new M4({ silent: true, style: f6.getModel("brushStyle").getItemStyle() }), u.sliderGroup.add(d6)), d6.attr("ignore", false);
        var v6 = this._brushStart, m6 = this._displayables.sliderGroup, b6 = m6.transformCoordToLocal(t2, s), x6 = m6.transformCoordToLocal(v6.x, v6.y), S = this._size;
        b6[0] = Math.max(Math.min(S[0], b6[0]), 0), d6.setShape({ x: x6[0], y: 0, width: b6[0] - x6[0], height: S[1] });
      }, r6.prototype._dispatchZoomAction = function(t2) {
        var s = this._range;
        this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: t2 ? QYe : null, start: s[0], end: s[1] });
      }, r6.prototype._findCoordRect = function() {
        var t2, s = eye(this.dataZoomModel).infoList;
        if (!t2 && s.length) {
          var u = s[0].model.coordinateSystem;
          t2 = u.getRect && u.getRect();
        }
        if (!t2) {
          var f6 = this.api.getWidth(), d6 = this.api.getHeight();
          t2 = { x: f6 * 0.2, y: d6 * 0.2, width: f6 * 0.6, height: d6 * 0.6 };
        }
        return t2;
      }, r6.type = "dataZoom.slider", r6;
    }(oJ);
    function tZe(a) {
      var r6 = { x: "y", y: "x", radius: "angle", angle: "radius" };
      return r6[a];
    }
    function u1e(a) {
      return a === "vertical" ? "ns-resize" : "ew-resize";
    }
    var nZe = eZe;
    function c1e(a) {
      a.registerComponentModel(YYe), a.registerComponentView(nZe), sJ(a);
    }
    function rZe(a) {
      bo(o1e), bo(c1e);
    }
    var aZe = { get: function(a, r6, t2) {
      var s = Qa((iZe[a] || {})[r6]);
      return t2 && br(s) ? s[s.length - 1] : s;
    } }, iZe = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, f1e = aZe, h1e = ap.mapVisual, oZe = ap.eachVisual, sZe = br, d1e = Ne, lZe = Sv, uZe = gs, cZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.stateList = ["inRange", "outOfRange"], t2.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], t2.layoutMode = { type: "box", ignoreSize: true }, t2.dataBound = [-1 / 0, 1 / 0], t2.targetVisuals = {}, t2.controllerVisuals = {}, t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        this.mergeDefaultAndTheme(t2, u);
      }, r6.prototype.optionUpdated = function(t2, s) {
        var u = this.option;
        !s && Dye(u, t2, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
      }, r6.prototype.resetVisual = function(t2) {
        var s = this.stateList;
        t2 = Ca(t2, this), this.controllerVisuals = gJ(this.option.controller, s, t2), this.targetVisuals = gJ(this.option.target, s, t2);
      }, r6.prototype.getItemSymbol = function() {
        return null;
      }, r6.prototype.getTargetSeriesIndices = function() {
        var t2 = this.option.seriesIndex, s = [];
        return t2 == null || t2 === "all" ? this.ecModel.eachSeries(function(u, f6) {
          s.push(f6);
        }) : s = ll(t2), s;
      }, r6.prototype.eachTargetSeries = function(t2, s) {
        Ne(this.getTargetSeriesIndices(), function(u) {
          var f6 = this.ecModel.getSeriesByIndex(u);
          f6 && t2.call(s, f6);
        }, this);
      }, r6.prototype.isTargetSeries = function(t2) {
        var s = false;
        return this.eachTargetSeries(function(u) {
          u === t2 && (s = true);
        }), s;
      }, r6.prototype.formatValueText = function(t2, s, u) {
        var f6 = this.option, d6 = f6.precision, v6 = this.dataBound, m6 = f6.formatter, b6;
        u = u || ["<", ">"], br(t2) && (t2 = t2.slice(), b6 = true);
        var x6 = s ? t2 : b6 ? [S(t2[0]), S(t2[1])] : S(t2);
        if (_a2(m6))
          return m6.replace("{value}", b6 ? x6[0] : x6).replace("{value2}", b6 ? x6[1] : x6);
        if (ti(m6))
          return b6 ? m6(t2[0], t2[1]) : m6(t2);
        if (b6)
          return t2[0] === v6[0] ? u[0] + " " + x6[1] : t2[1] === v6[1] ? u[1] + " " + x6[0] : x6[0] + " - " + x6[1];
        return x6;
        function S(M) {
          return M === v6[0] ? "min" : M === v6[1] ? "max" : (+M).toFixed(Math.min(d6, 20));
        }
      }, r6.prototype.resetExtent = function() {
        var t2 = this.option, s = lZe([t2.min, t2.max]);
        this._dataExtent = s;
      }, r6.prototype.getDataDimensionIndex = function(t2) {
        var s = this.option.dimension;
        if (s != null)
          return t2.getDimensionIndex(s);
        for (var u = t2.dimensions, f6 = u.length - 1; f6 >= 0; f6--) {
          var d6 = u[f6], v6 = t2.getDimensionInfo(d6);
          if (!v6.isCalculationCoord)
            return v6.storeDimIndex;
        }
      }, r6.prototype.getExtent = function() {
        return this._dataExtent.slice();
      }, r6.prototype.completeVisualOption = function() {
        var t2 = this.ecModel, s = this.option, u = { inRange: s.inRange, outOfRange: s.outOfRange }, f6 = s.target || (s.target = {}), d6 = s.controller || (s.controller = {});
        Di(f6, u), Di(d6, u);
        var v6 = this.isCategory();
        m6.call(this, f6), m6.call(this, d6), b6.call(this, f6, "inRange", "outOfRange"), x6.call(this, d6);
        function m6(S) {
          sZe(s.color) && !S.inRange && (S.inRange = { color: s.color.slice().reverse() }), S.inRange = S.inRange || { color: t2.get("gradientColor") };
        }
        function b6(S, M, A6) {
          var I = S[M], R = S[A6];
          I && !R && (R = S[A6] = {}, d1e(I, function(F, j) {
            if (ap.isValidType(j)) {
              var $ = f1e.get(j, "inactive", v6);
              $ != null && (R[j] = $, j === "color" && !R.hasOwnProperty("opacity") && !R.hasOwnProperty("colorAlpha") && (R.opacity = [0, 0]));
            }
          }));
        }
        function x6(S) {
          var M = (S.inRange || {}).symbol || (S.outOfRange || {}).symbol, A6 = (S.inRange || {}).symbolSize || (S.outOfRange || {}).symbolSize, I = this.get("inactiveColor"), R = this.getItemSymbol(), F = R || "roundRect";
          d1e(this.stateList, function(j) {
            var $ = this.itemSize, K = S[j];
            K || (K = S[j] = { color: v6 ? I : [I] }), K.symbol == null && (K.symbol = M && Qa(M) || (v6 ? F : [F])), K.symbolSize == null && (K.symbolSize = A6 && Qa(A6) || (v6 ? $[0] : [$[0], $[0]])), K.symbol = h1e(K.symbol, function(ue) {
              return ue === "none" ? F : ue;
            });
            var U = K.symbolSize;
            if (U != null) {
              var he = -1 / 0;
              oZe(U, function(ue) {
                ue > he && (he = ue);
              }), K.symbolSize = h1e(U, function(ue) {
                return uZe(ue, [0, he], [0, $[0]], true);
              });
            }
          }, this);
        }
      }, r6.prototype.resetItemSize = function() {
        this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
      }, r6.prototype.isCategory = function() {
        return !!this.option.categories;
      }, r6.prototype.setSelected = function(t2) {
      }, r6.prototype.getSelected = function() {
        return null;
      }, r6.prototype.getValueState = function(t2) {
        return null;
      }, r6.prototype.getVisualMeta = function(t2) {
        return null;
      }, r6.type = "visualMap", r6.dependencies = ["series"], r6.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, r6;
    }(Ps), Uz = cZe, p1e = [20, 140], fZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.optionUpdated = function(t2, s) {
        a.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(u) {
          u.mappingMethod = "linear", u.dataExtent = this.getExtent();
        }), this._resetRange();
      }, r6.prototype.resetItemSize = function() {
        a.prototype.resetItemSize.apply(this, arguments);
        var t2 = this.itemSize;
        (t2[0] == null || isNaN(t2[0])) && (t2[0] = p1e[0]), (t2[1] == null || isNaN(t2[1])) && (t2[1] = p1e[1]);
      }, r6.prototype._resetRange = function() {
        var t2 = this.getExtent(), s = this.option.range;
        !s || s.auto ? (t2.auto = 1, this.option.range = t2) : br(s) && (s[0] > s[1] && s.reverse(), s[0] = Math.max(s[0], t2[0]), s[1] = Math.min(s[1], t2[1]));
      }, r6.prototype.completeVisualOption = function() {
        a.prototype.completeVisualOption.apply(this, arguments), Ne(this.stateList, function(t2) {
          var s = this.option.controller[t2].symbolSize;
          s && s[0] !== s[1] && (s[0] = s[1] / 3);
        }, this);
      }, r6.prototype.setSelected = function(t2) {
        this.option.range = t2.slice(), this._resetRange();
      }, r6.prototype.getSelected = function() {
        var t2 = this.getExtent(), s = Sv((this.get("range") || []).slice());
        return s[0] > t2[1] && (s[0] = t2[1]), s[1] > t2[1] && (s[1] = t2[1]), s[0] < t2[0] && (s[0] = t2[0]), s[1] < t2[0] && (s[1] = t2[0]), s;
      }, r6.prototype.getValueState = function(t2) {
        var s = this.option.range, u = this.getExtent();
        return (s[0] <= u[0] || s[0] <= t2) && (s[1] >= u[1] || t2 <= s[1]) ? "inRange" : "outOfRange";
      }, r6.prototype.findTargetDataIndices = function(t2) {
        var s = [];
        return this.eachTargetSeries(function(u) {
          var f6 = [], d6 = u.getData();
          d6.each(this.getDataDimensionIndex(d6), function(v6, m6) {
            t2[0] <= v6 && v6 <= t2[1] && f6.push(m6);
          }, this), s.push({ seriesId: u.id, dataIndex: f6 });
        }, this), s;
      }, r6.prototype.getVisualMeta = function(t2) {
        var s = v1e(this, "outOfRange", this.getExtent()), u = v1e(this, "inRange", this.option.range.slice()), f6 = [];
        function d6(A6, I) {
          f6.push({ value: A6, color: t2(A6, I) });
        }
        for (var v6 = 0, m6 = 0, b6 = u.length, x6 = s.length; m6 < x6 && (!u.length || s[m6] <= u[0]); m6++)
          s[m6] < u[v6] && d6(s[m6], "outOfRange");
        for (var S = 1; v6 < b6; v6++, S = 0)
          S && f6.length && d6(u[v6], "outOfRange"), d6(u[v6], "inRange");
        for (var S = 1; m6 < x6; m6++)
          (!u.length || u[u.length - 1] < s[m6]) && (S && (f6.length && d6(f6[f6.length - 1].value, "outOfRange"), S = 0), d6(s[m6], "outOfRange"));
        var M = f6.length;
        return { stops: f6, outerColors: [M ? f6[0].color : "transparent", M ? f6[M - 1].color : "transparent"] };
      }, r6.type = "visualMap.continuous", r6.defaultOption = Y2(Uz.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), r6;
    }(Uz);
    function v1e(a, r6, t2) {
      if (t2[0] === t2[1])
        return t2.slice();
      for (var s = 200, u = (t2[1] - t2[0]) / s, f6 = t2[0], d6 = [], v6 = 0; v6 <= s && f6 < t2[1]; v6++)
        d6.push(f6), f6 += u;
      return d6.push(t2[1]), d6;
    }
    var hZe = fZe, dZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, t2;
      }
      return r6.prototype.init = function(t2, s) {
        this.ecModel = t2, this.api = s;
      }, r6.prototype.render = function(t2, s, u, f6) {
        if (this.visualMapModel = t2, t2.get("show") === false) {
          this.group.removeAll();
          return;
        }
        this.doRender(t2, s, u, f6);
      }, r6.prototype.renderBackground = function(t2) {
        var s = this.visualMapModel, u = KD(s.get("padding") || 0), f6 = t2.getBoundingRect();
        t2.add(new rs({ z2: -1, silent: true, shape: { x: f6.x - u[3], y: f6.y - u[0], width: f6.width + u[3] + u[1], height: f6.height + u[0] + u[2] }, style: { fill: s.get("backgroundColor"), stroke: s.get("borderColor"), lineWidth: s.get("borderWidth") } }));
      }, r6.prototype.getControllerVisual = function(t2, s, u) {
        u = u || {};
        var f6 = u.forceState, d6 = this.visualMapModel, v6 = {};
        if (s === "color") {
          var m6 = d6.get("contentColor");
          v6.color = m6;
        }
        function b6(A6) {
          return v6[A6];
        }
        function x6(A6, I) {
          v6[A6] = I;
        }
        var S = d6.controllerVisuals[f6 || d6.getValueState(t2)], M = ap.prepareVisualTypes(S);
        return Ne(M, function(A6) {
          var I = S[A6];
          u.convertOpacityToAlpha && A6 === "opacity" && (A6 = "colorAlpha", I = S.__alphaForOpacity), ap.dependsOn(A6, s) && I && I.applyVisual(t2, b6, x6);
        }), v6[s];
      }, r6.prototype.positionGroup = function(t2) {
        var s = this.visualMapModel, u = this.api;
        fV(t2, s.getBoxLayoutParams(), { width: u.getWidth(), height: u.getHeight() });
      }, r6.prototype.doRender = function(t2, s, u, f6) {
      }, r6.type = "visualMap", r6;
    }(Rc), g1e = dZe, m1e = [["left", "right", "width"], ["top", "bottom", "height"]];
    function y1e(a, r6, t2) {
      var s = a.option, u = s.align;
      if (u != null && u !== "auto")
        return u;
      for (var f6 = { width: r6.getWidth(), height: r6.getHeight() }, d6 = s.orient === "horizontal" ? 1 : 0, v6 = m1e[d6], m6 = [0, null, 10], b6 = {}, x6 = 0; x6 < 3; x6++)
        b6[m1e[1 - d6][x6]] = m6[x6], b6[v6[x6]] = x6 === 2 ? t2[0] : s[v6[x6]];
      var S = [["x", "width", 3], ["y", "height", 0]][d6], M = ah(b6, f6, s.padding);
      return v6[(M.margin[S[2]] || 0) + M[S[0]] + M[S[1]] * 0.5 < f6[S[1]] * 0.5 ? 0 : 1];
    }
    function qz(a, r6) {
      return Ne(a || [], function(t2) {
        t2.dataIndex != null && (t2.dataIndexInside = t2.dataIndex, t2.dataIndex = null), t2.highlightKey = "visualMap" + (r6 ? r6.componentIndex : "");
      }), a;
    }
    var Wb = gs, pZe = Ne, b1e = Math.min, FJ = Math.max, vZe = 12, gZe = 6, mZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._shapes = {}, t2._dataInterval = [], t2._handleEnds = [], t2._hoverLinkDataIndices = [], t2;
      }
      return r6.prototype.doRender = function(t2, s, u, f6) {
        this._api = u, (!f6 || f6.type !== "selectDataRange" || f6.from !== this.uid) && this._buildView();
      }, r6.prototype._buildView = function() {
        this.group.removeAll();
        var t2 = this.visualMapModel, s = this.group;
        this._orient = t2.get("orient"), this._useHandle = t2.get("calculable"), this._resetInterval(), this._renderBar(s);
        var u = t2.get("text");
        this._renderEndsText(s, u, 0), this._renderEndsText(s, u, 1), this._updateView(true), this.renderBackground(s), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(s);
      }, r6.prototype._renderEndsText = function(t2, s, u) {
        if (s) {
          var f6 = s[1 - u];
          f6 = f6 != null ? f6 + "" : "";
          var d6 = this.visualMapModel, v6 = d6.get("textGap"), m6 = d6.itemSize, b6 = this._shapes.mainGroup, x6 = this._applyTransform([m6[0] / 2, u === 0 ? -v6 : m6[1] + v6], b6), S = this._applyTransform(u === 0 ? "bottom" : "top", b6), M = this._orient, A6 = this.visualMapModel.textStyleModel;
          this.group.add(new ms({ style: { x: x6[0], y: x6[1], verticalAlign: M === "horizontal" ? "middle" : S, align: M === "horizontal" ? S : "center", text: f6, font: A6.getFont(), fill: A6.getTextColor() } }));
        }
      }, r6.prototype._renderBar = function(t2) {
        var s = this.visualMapModel, u = this._shapes, f6 = s.itemSize, d6 = this._orient, v6 = this._useHandle, m6 = y1e(s, this.api, f6), b6 = u.mainGroup = this._createBarGroup(m6), x6 = new bi();
        b6.add(x6), x6.add(u.outOfRange = _1e()), x6.add(u.inRange = _1e(null, v6 ? w1e(this._orient) : null, Ca(this._dragHandle, this, "all", false), Ca(this._dragHandle, this, "all", true))), x6.setClipPath(new rs({ shape: { x: 0, y: 0, width: f6[0], height: f6[1], r: 3 } }));
        var S = s.textStyleModel.getTextRect("\u56FD"), M = FJ(S.width, S.height);
        v6 && (u.handleThumbs = [], u.handleLabels = [], u.handleLabelPoints = [], this._createHandle(s, b6, 0, f6, M, d6), this._createHandle(s, b6, 1, f6, M, d6)), this._createIndicator(s, b6, f6, M, d6), t2.add(b6);
      }, r6.prototype._createHandle = function(t2, s, u, f6, d6, v6) {
        var m6 = Ca(this._dragHandle, this, u, false), b6 = Ca(this._dragHandle, this, u, true), x6 = wv(t2.get("handleSize"), f6[0]), S = Lf(t2.get("handleIcon"), -x6 / 2, -x6 / 2, x6, x6, null, true), M = w1e(this._orient);
        S.attr({ cursor: M, draggable: true, drift: m6, ondragend: b6, onmousemove: function(j) {
          vm(j.event);
        } }), S.x = f6[0] / 2, S.useStyle(t2.getModel("handleStyle").getItemStyle()), S.setStyle({ strokeNoScale: true, strokeFirst: true }), S.style.lineWidth *= 2, S.ensureState("emphasis").style = t2.getModel(["emphasis", "handleStyle"]).getItemStyle(), Nx(S, true), s.add(S);
        var A6 = this.visualMapModel.textStyleModel, I = new ms({ cursor: M, draggable: true, drift: m6, onmousemove: function(j) {
          vm(j.event);
        }, ondragend: b6, style: { x: 0, y: 0, text: "", font: A6.getFont(), fill: A6.getTextColor() } });
        I.ensureState("blur").style = { opacity: 0.1 }, I.stateTransition = { duration: 200 }, this.group.add(I);
        var R = [x6, 0], F = this._shapes;
        F.handleThumbs[u] = S, F.handleLabelPoints[u] = R, F.handleLabels[u] = I;
      }, r6.prototype._createIndicator = function(t2, s, u, f6, d6) {
        var v6 = wv(t2.get("indicatorSize"), u[0]), m6 = Lf(t2.get("indicatorIcon"), -v6 / 2, -v6 / 2, v6, v6, null, true);
        m6.attr({ cursor: "move", invisible: true, silent: true, x: u[0] / 2 });
        var b6 = t2.getModel("indicatorStyle").getItemStyle();
        if (m6 instanceof nh) {
          var x6 = m6.style;
          m6.useStyle(qn({ image: x6.image, x: x6.x, y: x6.y, width: x6.width, height: x6.height }, b6));
        } else
          m6.useStyle(b6);
        s.add(m6);
        var S = this.visualMapModel.textStyleModel, M = new ms({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: S.getFont(), fill: S.getTextColor() } });
        this.group.add(M);
        var A6 = [(d6 === "horizontal" ? f6 / 2 : gZe) + u[0] / 2, 0], I = this._shapes;
        I.indicator = m6, I.indicatorLabel = M, I.indicatorLabelPoint = A6, this._firstShowIndicator = true;
      }, r6.prototype._dragHandle = function(t2, s, u, f6) {
        if (this._useHandle) {
          if (this._dragging = !s, !s) {
            var d6 = this._applyTransform([u, f6], this._shapes.mainGroup, true);
            this._updateInterval(t2, d6[1]), this._hideIndicator(), this._updateView();
          }
          s === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), s ? !this._hovering && this._clearHoverLinkToSeries() : x1e(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[t2], false);
        }
      }, r6.prototype._resetInterval = function() {
        var t2 = this.visualMapModel, s = this._dataInterval = t2.getSelected(), u = t2.getExtent(), f6 = [0, t2.itemSize[1]];
        this._handleEnds = [Wb(s[0], u, f6, true), Wb(s[1], u, f6, true)];
      }, r6.prototype._updateInterval = function(t2, s) {
        s = s || 0;
        var u = this.visualMapModel, f6 = this._handleEnds, d6 = [0, u.itemSize[1]];
        kA(s, f6, d6, t2, 0);
        var v6 = u.getExtent();
        this._dataInterval = [Wb(f6[0], d6, v6, true), Wb(f6[1], d6, v6, true)];
      }, r6.prototype._updateView = function(t2) {
        var s = this.visualMapModel, u = s.getExtent(), f6 = this._shapes, d6 = [0, s.itemSize[1]], v6 = t2 ? d6 : this._handleEnds, m6 = this._createBarVisual(this._dataInterval, u, v6, "inRange"), b6 = this._createBarVisual(u, u, d6, "outOfRange");
        f6.inRange.setStyle({ fill: m6.barColor }).setShape("points", m6.barPoints), f6.outOfRange.setStyle({ fill: b6.barColor }).setShape("points", b6.barPoints), this._updateHandle(v6, m6);
      }, r6.prototype._createBarVisual = function(t2, s, u, f6) {
        var d6 = { forceState: f6, convertOpacityToAlpha: true }, v6 = this._makeColorGradient(t2, d6), m6 = [this.getControllerVisual(t2[0], "symbolSize", d6), this.getControllerVisual(t2[1], "symbolSize", d6)], b6 = this._createBarPoints(u, m6);
        return { barColor: new aA(0, 0, 0, 1, v6), barPoints: b6, handlesColor: [v6[0].color, v6[v6.length - 1].color] };
      }, r6.prototype._makeColorGradient = function(t2, s) {
        var u = 100, f6 = [], d6 = (t2[1] - t2[0]) / u;
        f6.push({ color: this.getControllerVisual(t2[0], "color", s), offset: 0 });
        for (var v6 = 1; v6 < u; v6++) {
          var m6 = t2[0] + d6 * v6;
          if (m6 > t2[1])
            break;
          f6.push({ color: this.getControllerVisual(m6, "color", s), offset: v6 / u });
        }
        return f6.push({ color: this.getControllerVisual(t2[1], "color", s), offset: 1 }), f6;
      }, r6.prototype._createBarPoints = function(t2, s) {
        var u = this.visualMapModel.itemSize;
        return [[u[0] - s[0], t2[0]], [u[0], t2[0]], [u[0], t2[1]], [u[0] - s[1], t2[1]]];
      }, r6.prototype._createBarGroup = function(t2) {
        var s = this._orient, u = this.visualMapModel.get("inverse");
        return new bi(s === "horizontal" && !u ? { scaleX: t2 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : s === "horizontal" && u ? { scaleX: t2 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : s === "vertical" && !u ? { scaleX: t2 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: t2 === "left" ? 1 : -1 });
      }, r6.prototype._updateHandle = function(t2, s) {
        if (this._useHandle) {
          var u = this._shapes, f6 = this.visualMapModel, d6 = u.handleThumbs, v6 = u.handleLabels, m6 = f6.itemSize, b6 = f6.getExtent();
          pZe([0, 1], function(x6) {
            var S = d6[x6];
            S.setStyle("fill", s.handlesColor[x6]), S.y = t2[x6];
            var M = Wb(t2[x6], [0, m6[1]], b6, true), A6 = this.getControllerVisual(M, "symbolSize");
            S.scaleX = S.scaleY = A6 / m6[0], S.x = m6[0] - A6 / 2;
            var I = Yr(u.handleLabelPoints[x6], Nr(S, this.group));
            v6[x6].setStyle({ x: I[0], y: I[1], text: f6.formatValueText(this._dataInterval[x6]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", u.mainGroup) : "center" });
          }, this);
        }
      }, r6.prototype._showIndicator = function(t2, s, u, f6) {
        var d6 = this.visualMapModel, v6 = d6.getExtent(), m6 = d6.itemSize, b6 = [0, m6[1]], x6 = this._shapes, S = x6.indicator;
        if (S) {
          S.attr("invisible", false);
          var M = { convertOpacityToAlpha: true }, A6 = this.getControllerVisual(t2, "color", M), I = this.getControllerVisual(t2, "symbolSize"), R = Wb(t2, v6, b6, true), F = m6[0] - I / 2, j = { x: S.x, y: S.y };
          S.y = R, S.x = F;
          var $ = Yr(x6.indicatorLabelPoint, Nr(S, this.group)), K = x6.indicatorLabel;
          K.attr("invisible", false);
          var U = this._applyTransform("left", x6.mainGroup), he = this._orient, ue = he === "horizontal";
          K.setStyle({ text: (u || "") + d6.formatValueText(s), verticalAlign: ue ? U : "middle", align: ue ? "center" : U });
          var pe = { x: F, y: R, style: { fill: A6 } }, _e = { style: { x: $[0], y: $[1] } };
          if (d6.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
            var xe = { duration: 100, easing: "cubicInOut", additive: true };
            S.x = j.x, S.y = j.y, S.animateTo(pe, xe), K.animateTo(_e, xe);
          } else
            S.attr(pe), K.attr(_e);
          this._firstShowIndicator = false;
          var Ae = this._shapes.handleLabels;
          if (Ae)
            for (var ke = 0; ke < Ae.length; ke++)
              this._api.enterBlur(Ae[ke]);
        }
      }, r6.prototype._enableHoverLinkToSeries = function() {
        var t2 = this;
        this._shapes.mainGroup.on("mousemove", function(s) {
          if (t2._hovering = true, !t2._dragging) {
            var u = t2.visualMapModel.itemSize, f6 = t2._applyTransform([s.offsetX, s.offsetY], t2._shapes.mainGroup, true, true);
            f6[1] = b1e(FJ(0, f6[1]), u[1]), t2._doHoverLinkToSeries(f6[1], 0 <= f6[0] && f6[0] <= u[0]);
          }
        }).on("mouseout", function() {
          t2._hovering = false, !t2._dragging && t2._clearHoverLinkToSeries();
        });
      }, r6.prototype._enableHoverLinkFromSeries = function() {
        var t2 = this.api.getZr();
        this.visualMapModel.option.hoverLink ? (t2.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), t2.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
      }, r6.prototype._doHoverLinkToSeries = function(t2, s) {
        var u = this.visualMapModel, f6 = u.itemSize;
        if (u.option.hoverLink) {
          var d6 = [0, f6[1]], v6 = u.getExtent();
          t2 = b1e(FJ(d6[0], t2), d6[1]);
          var m6 = yZe(u, v6, d6), b6 = [t2 - m6, t2 + m6], x6 = Wb(t2, d6, v6, true), S = [Wb(b6[0], d6, v6, true), Wb(b6[1], d6, v6, true)];
          b6[0] < d6[0] && (S[0] = -1 / 0), b6[1] > d6[1] && (S[1] = 1 / 0), s && (S[0] === -1 / 0 ? this._showIndicator(x6, S[1], "< ", m6) : S[1] === 1 / 0 ? this._showIndicator(x6, S[0], "> ", m6) : this._showIndicator(x6, x6, "\u2248 ", m6));
          var M = this._hoverLinkDataIndices, A6 = [];
          (s || x1e(u)) && (A6 = this._hoverLinkDataIndices = u.findTargetDataIndices(S));
          var I = cO(M, A6);
          this._dispatchHighDown("downplay", qz(I[0], u)), this._dispatchHighDown("highlight", qz(I[1], u));
        }
      }, r6.prototype._hoverLinkFromSeriesMouseOver = function(t2) {
        var s = t2.target, u = this.visualMapModel;
        if (!(!s || ii(s).dataIndex == null)) {
          var f6 = ii(s), d6 = this.ecModel.getSeriesByIndex(f6.seriesIndex);
          if (u.isTargetSeries(d6)) {
            var v6 = d6.getData(f6.dataType), m6 = v6.getStore().get(u.getDataDimensionIndex(v6), f6.dataIndex);
            isNaN(m6) || this._showIndicator(m6, m6);
          }
        }
      }, r6.prototype._hideIndicator = function() {
        var t2 = this._shapes;
        t2.indicator && t2.indicator.attr("invisible", true), t2.indicatorLabel && t2.indicatorLabel.attr("invisible", true);
        var s = this._shapes.handleLabels;
        if (s)
          for (var u = 0; u < s.length; u++)
            this._api.leaveBlur(s[u]);
      }, r6.prototype._clearHoverLinkToSeries = function() {
        this._hideIndicator();
        var t2 = this._hoverLinkDataIndices;
        this._dispatchHighDown("downplay", qz(t2, this.visualMapModel)), t2.length = 0;
      }, r6.prototype._clearHoverLinkFromSeries = function() {
        this._hideIndicator();
        var t2 = this.api.getZr();
        t2.off("mouseover", this._hoverLinkFromSeriesMouseOver), t2.off("mouseout", this._hideIndicator);
      }, r6.prototype._applyTransform = function(t2, s, u, f6) {
        var d6 = Nr(s, f6 ? null : this.group);
        return br(t2) ? Yr(t2, d6, u) : za(t2, d6, u);
      }, r6.prototype._dispatchHighDown = function(t2, s) {
        s && s.length && this.api.dispatchAction({ type: t2, batch: s });
      }, r6.prototype.dispose = function() {
        this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
      }, r6.prototype.remove = function() {
        this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
      }, r6.type = "visualMap.continuous", r6;
    }(g1e);
    function _1e(a, r6, t2, s) {
      return new ud({ shape: { points: a }, draggable: !!t2, cursor: r6, drift: t2, onmousemove: function(u) {
        vm(u.event);
      }, ondragend: s });
    }
    function yZe(a, r6, t2) {
      var s = vZe / 2, u = a.get("hoverLinkDataSize");
      return u && (s = Wb(u, r6, t2, true) / 2), s;
    }
    function x1e(a) {
      var r6 = a.get("hoverLinkOnHandle");
      return !!(r6 == null ? a.get("realtime") : r6);
    }
    function w1e(a) {
      return a === "vertical" ? "ns-resize" : "ew-resize";
    }
    var bZe = mZe, _Ze = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, xZe = function(a, r6) {
      r6.eachComponent({ mainType: "visualMap", query: a }, function(t2) {
        t2.setSelected(a.selected);
      });
    }, wZe = [{ createOnAllSeries: true, reset: function(a, r6) {
      var t2 = [];
      return r6.eachComponent("visualMap", function(s) {
        var u = a.pipelineContext;
        !s.isTargetSeries(a) || u && u.large || t2.push(gqe(s.stateList, s.targetVisuals, Ca(s.getValueState, s), s.getDataDimensionIndex(a.getData())));
      }), t2;
    } }, { createOnAllSeries: true, reset: function(a, r6) {
      var t2 = a.getData(), s = [];
      r6.eachComponent("visualMap", function(u) {
        if (u.isTargetSeries(a)) {
          var f6 = u.getVisualMeta(Ca(SZe, null, a, u)) || { stops: [], outerColors: [] }, d6 = u.getDataDimensionIndex(t2);
          d6 >= 0 && (f6.dimension = d6, s.push(f6));
        }
      }), a.getData().setVisual("visualMeta", s);
    } }];
    function SZe(a, r6, t2, s) {
      for (var u = r6.targetVisuals[s], f6 = ap.prepareVisualTypes(u), d6 = { color: ER(a.getData(), "color") }, v6 = 0, m6 = f6.length; v6 < m6; v6++) {
        var b6 = f6[v6], x6 = u[b6 === "opacity" ? "__alphaForOpacity" : b6];
        x6 && x6.applyVisual(t2, S, M);
      }
      return d6.color;
      function S(A6) {
        return d6[A6];
      }
      function M(A6, I) {
        d6[A6] = I;
      }
    }
    var S1e = Ne;
    function CZe(a) {
      var r6 = a && a.visualMap;
      br(r6) || (r6 = r6 ? [r6] : []), S1e(r6, function(t2) {
        if (t2) {
          D5(t2, "splitList") && !D5(t2, "pieces") && (t2.pieces = t2.splitList, delete t2.splitList);
          var s = t2.pieces;
          s && br(s) && S1e(s, function(u) {
            ui(u) && (D5(u, "start") && !D5(u, "min") && (u.min = u.start), D5(u, "end") && !D5(u, "max") && (u.max = u.end));
          });
        }
      });
    }
    function D5(a, r6) {
      return a && a.hasOwnProperty && a.hasOwnProperty(r6);
    }
    var C1e = false;
    function M1e(a) {
      C1e || (C1e = true, a.registerSubTypeDefaulter("visualMap", function(r6) {
        return !r6.categories && (!(r6.pieces ? r6.pieces.length > 0 : r6.splitNumber > 0) || r6.calculable) ? "continuous" : "piecewise";
      }), a.registerAction(_Ze, xZe), Ne(wZe, function(r6) {
        a.registerVisual(a.PRIORITY.VISUAL.COMPONENT, r6);
      }), a.registerPreprocessor(CZe));
    }
    function A1e(a) {
      a.registerComponentModel(hZe), a.registerComponentView(bZe), M1e(a);
    }
    var MZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2._pieceList = [], t2;
      }
      return r6.prototype.optionUpdated = function(t2, s) {
        a.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
        var u = this._mode = this._determineMode();
        this._pieceList = [], AZe[this._mode].call(this, this._pieceList), this._resetSelected(t2, s);
        var f6 = this.option.categories;
        this.resetVisual(function(d6, v6) {
          u === "categories" ? (d6.mappingMethod = "category", d6.categories = Qa(f6)) : (d6.dataExtent = this.getExtent(), d6.mappingMethod = "piecewise", d6.pieceList = wr(this._pieceList, function(m6) {
            return m6 = Qa(m6), v6 !== "inRange" && (m6.visual = null), m6;
          }));
        });
      }, r6.prototype.completeVisualOption = function() {
        var t2 = this.option, s = {}, u = ap.listVisualTypes(), f6 = this.isCategory();
        Ne(t2.pieces, function(v6) {
          Ne(u, function(m6) {
            v6.hasOwnProperty(m6) && (s[m6] = 1);
          });
        }), Ne(s, function(v6, m6) {
          var b6 = false;
          Ne(this.stateList, function(x6) {
            b6 = b6 || d6(t2, x6, m6) || d6(t2.target, x6, m6);
          }, this), !b6 && Ne(this.stateList, function(x6) {
            (t2[x6] || (t2[x6] = {}))[m6] = f1e.get(m6, x6 === "inRange" ? "active" : "inactive", f6);
          });
        }, this);
        function d6(v6, m6, b6) {
          return v6 && v6[m6] && v6[m6].hasOwnProperty(b6);
        }
        a.prototype.completeVisualOption.apply(this, arguments);
      }, r6.prototype._resetSelected = function(t2, s) {
        var u = this.option, f6 = this._pieceList, d6 = (s ? u : t2).selected || {};
        if (u.selected = d6, Ne(f6, function(m6, b6) {
          var x6 = this.getSelectedMapKey(m6);
          d6.hasOwnProperty(x6) || (d6[x6] = true);
        }, this), u.selectedMode === "single") {
          var v6 = false;
          Ne(f6, function(m6, b6) {
            var x6 = this.getSelectedMapKey(m6);
            d6[x6] && (v6 ? d6[x6] = false : v6 = true);
          }, this);
        }
      }, r6.prototype.getItemSymbol = function() {
        return this.get("itemSymbol");
      }, r6.prototype.getSelectedMapKey = function(t2) {
        return this._mode === "categories" ? t2.value + "" : t2.index + "";
      }, r6.prototype.getPieceList = function() {
        return this._pieceList;
      }, r6.prototype._determineMode = function() {
        var t2 = this.option;
        return t2.pieces && t2.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
      }, r6.prototype.setSelected = function(t2) {
        this.option.selected = Qa(t2);
      }, r6.prototype.getValueState = function(t2) {
        var s = ap.findPieceIndex(t2, this._pieceList);
        return s != null && this.option.selected[this.getSelectedMapKey(this._pieceList[s])] ? "inRange" : "outOfRange";
      }, r6.prototype.findTargetDataIndices = function(t2) {
        var s = [], u = this._pieceList;
        return this.eachTargetSeries(function(f6) {
          var d6 = [], v6 = f6.getData();
          v6.each(this.getDataDimensionIndex(v6), function(m6, b6) {
            var x6 = ap.findPieceIndex(m6, u);
            x6 === t2 && d6.push(b6);
          }, this), s.push({ seriesId: f6.id, dataIndex: d6 });
        }, this), s;
      }, r6.prototype.getRepresentValue = function(t2) {
        var s;
        if (this.isCategory())
          s = t2.value;
        else if (t2.value != null)
          s = t2.value;
        else {
          var u = t2.interval || [];
          s = u[0] === -1 / 0 && u[1] === 1 / 0 ? 0 : (u[0] + u[1]) / 2;
        }
        return s;
      }, r6.prototype.getVisualMeta = function(t2) {
        if (this.isCategory())
          return;
        var s = [], u = ["", ""], f6 = this;
        function d6(x6, S) {
          var M = f6.getRepresentValue({ interval: x6 });
          S || (S = f6.getValueState(M));
          var A6 = t2(M, S);
          x6[0] === -1 / 0 ? u[0] = A6 : x6[1] === 1 / 0 ? u[1] = A6 : s.push({ value: x6[0], color: A6 }, { value: x6[1], color: A6 });
        }
        var v6 = this._pieceList.slice();
        if (!v6.length)
          v6.push({ interval: [-1 / 0, 1 / 0] });
        else {
          var m6 = v6[0].interval[0];
          m6 !== -1 / 0 && v6.unshift({ interval: [-1 / 0, m6] }), m6 = v6[v6.length - 1].interval[1], m6 !== 1 / 0 && v6.push({ interval: [m6, 1 / 0] });
        }
        var b6 = -1 / 0;
        return Ne(v6, function(x6) {
          var S = x6.interval;
          S && (S[0] > b6 && d6([b6, S[0]], "outOfRange"), d6(S.slice()), b6 = S[1]);
        }, this), { stops: s, outerColors: u };
      }, r6.type = "visualMap.piecewise", r6.defaultOption = Y2(Uz.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), r6;
    }(Uz), AZe = { splitNumber: function(a) {
      var r6 = this.option, t2 = Math.min(r6.precision, 20), s = this.getExtent(), u = r6.splitNumber;
      u = Math.max(parseInt(u, 10), 1), r6.splitNumber = u;
      for (var f6 = (s[1] - s[0]) / u; +f6.toFixed(t2) !== f6 && t2 < 5; )
        t2++;
      r6.precision = t2, f6 = +f6.toFixed(t2), r6.minOpen && a.push({ interval: [-1 / 0, s[0]], close: [0, 0] });
      for (var d6 = 0, v6 = s[0]; d6 < u; v6 += f6, d6++) {
        var m6 = d6 === u - 1 ? s[1] : v6 + f6;
        a.push({ interval: [v6, m6], close: [1, 1] });
      }
      r6.maxOpen && a.push({ interval: [s[1], 1 / 0], close: [0, 0] }), aO(a), Ne(a, function(b6, x6) {
        b6.index = x6, b6.text = this.formatValueText(b6.interval);
      }, this);
    }, categories: function(a) {
      var r6 = this.option;
      Ne(r6.categories, function(t2) {
        a.push({ text: this.formatValueText(t2, true), value: t2 });
      }, this), E1e(r6, a);
    }, pieces: function(a) {
      var r6 = this.option;
      Ne(r6.pieces, function(t2, s) {
        ui(t2) || (t2 = { value: t2 });
        var u = { text: "", index: s };
        if (t2.label != null && (u.text = t2.label), t2.hasOwnProperty("value")) {
          var f6 = u.value = t2.value;
          u.interval = [f6, f6], u.close = [1, 1];
        } else {
          for (var d6 = u.interval = [], v6 = u.close = [0, 0], m6 = [1, 0, 1], b6 = [-1 / 0, 1 / 0], x6 = [], S = 0; S < 2; S++) {
            for (var M = [["gte", "gt", "min"], ["lte", "lt", "max"]][S], A6 = 0; A6 < 3 && d6[S] == null; A6++)
              d6[S] = t2[M[A6]], v6[S] = m6[A6], x6[S] = A6 === 2;
            d6[S] == null && (d6[S] = b6[S]);
          }
          x6[0] && d6[1] === 1 / 0 && (v6[0] = 0), x6[1] && d6[0] === -1 / 0 && (v6[1] = 0), d6[0] === d6[1] && v6[0] && v6[1] && (u.value = d6[0]);
        }
        u.visual = ap.retrieveVisuals(t2), a.push(u);
      }, this), E1e(r6, a), aO(a), Ne(a, function(t2) {
        var s = t2.close, u = [["<", "\u2264"][s[1]], [">", "\u2265"][s[0]]];
        t2.text = t2.text || this.formatValueText(t2.value != null ? t2.value : t2.interval, false, u);
      }, this);
    } };
    function E1e(a, r6) {
      var t2 = a.inverse;
      (a.orient === "vertical" ? !t2 : t2) && r6.reverse();
    }
    var EZe = MZe, IZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = r6.type, t2;
      }
      return r6.prototype.doRender = function() {
        var t2 = this.group;
        t2.removeAll();
        var s = this.visualMapModel, u = s.get("textGap"), f6 = s.textStyleModel, d6 = f6.getFont(), v6 = f6.getTextColor(), m6 = this._getItemAlign(), b6 = s.itemSize, x6 = this._getViewData(), S = x6.endsText, M = Jf(s.get("showLabel", true), !S);
        S && this._renderEndsText(t2, S[0], b6, M, m6), Ne(x6.viewPieceList, function(A6) {
          var I = A6.piece, R = new bi();
          R.onclick = Ca(this._onItemClick, this, I), this._enableHoverLink(R, A6.indexInModelPieceList);
          var F = s.getRepresentValue(I);
          if (this._createItemSymbol(R, F, [0, 0, b6[0], b6[1]]), M) {
            var j = this.visualMapModel.getValueState(F);
            R.add(new ms({ style: { x: m6 === "right" ? -u : b6[0] + u, y: b6[1] / 2, text: I.text, verticalAlign: "middle", align: m6, font: d6, fill: v6, opacity: j === "outOfRange" ? 0.5 : 1 } }));
          }
          t2.add(R);
        }, this), S && this._renderEndsText(t2, S[1], b6, M, m6), cA(s.get("orient"), t2, s.get("itemGap")), this.renderBackground(t2), this.positionGroup(t2);
      }, r6.prototype._enableHoverLink = function(t2, s) {
        var u = this;
        t2.on("mouseover", function() {
          return f6("highlight");
        }).on("mouseout", function() {
          return f6("downplay");
        });
        var f6 = function(d6) {
          var v6 = u.visualMapModel;
          v6.option.hoverLink && u.api.dispatchAction({ type: d6, batch: qz(v6.findTargetDataIndices(s), v6) });
        };
      }, r6.prototype._getItemAlign = function() {
        var t2 = this.visualMapModel, s = t2.option;
        if (s.orient === "vertical")
          return y1e(t2, this.api, t2.itemSize);
        var u = s.align;
        return (!u || u === "auto") && (u = "left"), u;
      }, r6.prototype._renderEndsText = function(t2, s, u, f6, d6) {
        if (s) {
          var v6 = new bi(), m6 = this.visualMapModel.textStyleModel;
          v6.add(new ms({ style: { x: f6 ? d6 === "right" ? u[0] : 0 : u[0] / 2, y: u[1] / 2, verticalAlign: "middle", align: f6 ? d6 : "center", text: s, font: m6.getFont(), fill: m6.getTextColor() } })), t2.add(v6);
        }
      }, r6.prototype._getViewData = function() {
        var t2 = this.visualMapModel, s = wr(t2.getPieceList(), function(v6, m6) {
          return { piece: v6, indexInModelPieceList: m6 };
        }), u = t2.get("text"), f6 = t2.get("orient"), d6 = t2.get("inverse");
        return (f6 === "horizontal" ? d6 : !d6) ? s.reverse() : u && (u = u.slice().reverse()), { viewPieceList: s, endsText: u };
      }, r6.prototype._createItemSymbol = function(t2, s, u) {
        t2.add(Lf(this.getControllerVisual(s, "symbol"), u[0], u[1], u[2], u[3], this.getControllerVisual(s, "color")));
      }, r6.prototype._onItemClick = function(t2) {
        var s = this.visualMapModel, u = s.option, f6 = Qa(u.selected), d6 = s.getSelectedMapKey(t2);
        u.selectedMode === "single" ? (f6[d6] = true, Ne(f6, function(v6, m6) {
          f6[m6] = m6 === d6;
        })) : f6[d6] = !f6[d6], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: f6 });
      }, r6.type = "visualMap.piecewise", r6;
    }(g1e), TZe = IZe;
    function I1e(a) {
      a.registerComponentModel(EZe), a.registerComponentView(TZe), M1e(a);
    }
    function DZe(a) {
      bo(A1e), bo(I1e);
    }
    var kZe = { label: { enabled: true }, decal: { show: false } }, T1e = Xo(), PZe = {};
    function LZe(a, r6) {
      var t2 = a.getModel("aria");
      if (!t2.get("enabled"))
        return;
      var s = Qa(kZe);
      Di(s.label, a.getLocaleModel().get("aria"), false), Di(t2.option, s, false), u(), f6();
      function u() {
        var b6 = t2.getModel("decal"), x6 = b6.get("show");
        if (x6) {
          var S = Ta();
          a.eachSeries(function(M) {
            if (!M.isColorBySeries()) {
              var A6 = S.get(M.type);
              A6 || (A6 = {}, S.set(M.type, A6)), T1e(M).scope = A6;
            }
          }), a.eachRawSeries(function(M) {
            if (a.isSeriesFiltered(M))
              return;
            if (ti(M.enableAriaDecal)) {
              M.enableAriaDecal();
              return;
            }
            var A6 = M.getData();
            if (M.isColorBySeries()) {
              var I = GY(M.ecModel, M.name, PZe, a.getSeriesCount()), R = A6.getVisual("decal");
              A6.setVisual("decal", U(R, I));
            } else {
              var F = M.getRawData(), j = {}, $ = T1e(M).scope;
              A6.each(function(he) {
                var ue = A6.getRawIndex(he);
                j[ue] = he;
              });
              var K = F.count();
              F.each(function(he) {
                var ue = j[he], pe = F.getName(he) || he + "", _e = GY(M.ecModel, pe, $, K), xe = A6.getItemVisual(ue, "decal");
                A6.setItemVisual(ue, "decal", U(xe, _e));
              });
            }
            function U(he, ue) {
              var pe = he ? qn(qn({}, ue), he) : ue;
              return pe.dirty = true, pe;
            }
          });
        }
      }
      function f6() {
        var b6 = a.getLocaleModel().get("aria"), x6 = t2.getModel("label");
        if (x6.option = ei(x6.option, b6), !!x6.get("enabled")) {
          var S = r6.getZr().dom;
          if (x6.get("description")) {
            S.setAttribute("aria-label", x6.get("description"));
            return;
          }
          var M = a.getSeriesCount(), A6 = x6.get(["data", "maxCount"]) || 10, I = x6.get(["series", "maxCount"]) || 10, R = Math.min(M, I), F;
          if (!(M < 1)) {
            var j = v6();
            if (j) {
              var $ = x6.get(["general", "withTitle"]);
              F = d6($, { title: j });
            } else
              F = x6.get(["general", "withoutTitle"]);
            var K = [], U = M > 1 ? x6.get(["series", "multiple", "prefix"]) : x6.get(["series", "single", "prefix"]);
            F += d6(U, { seriesCount: M }), a.eachSeries(function(_e, xe) {
              if (xe < R) {
                var Ae = void 0, ke = _e.get("name"), je = ke ? "withName" : "withoutName";
                Ae = M > 1 ? x6.get(["series", "multiple", je]) : x6.get(["series", "single", je]), Ae = d6(Ae, { seriesId: _e.seriesIndex, seriesName: _e.get("name"), seriesType: m6(_e.subType) });
                var Fe = _e.getData();
                if (Fe.count() > A6) {
                  var at = x6.get(["data", "partialData"]);
                  Ae += d6(at, { displayCnt: A6 });
                } else
                  Ae += x6.get(["data", "allData"]);
                for (var ht = x6.get(["data", "separator", "middle"]), Qe = x6.get(["data", "separator", "end"]), en = [], bt = 0; bt < Fe.count(); bt++)
                  if (bt < A6) {
                    var wt = Fe.getName(bt), Ft = Fe.getValues(bt), fn = x6.get(["data", wt ? "withName" : "withoutName"]);
                    en.push(d6(fn, { name: wt, value: Ft.join(ht) }));
                  }
                Ae += en.join(ht) + Qe, K.push(Ae);
              }
            });
            var he = x6.getModel(["series", "multiple", "separator"]), ue = he.get("middle"), pe = he.get("end");
            F += K.join(ue) + pe, S.setAttribute("aria-label", F);
          }
        }
      }
      function d6(b6, x6) {
        if (!_a2(b6))
          return b6;
        var S = b6;
        return Ne(x6, function(M, A6) {
          S = S.replace(new RegExp("\\{\\s*" + A6 + "\\s*\\}", "g"), M);
        }), S;
      }
      function v6() {
        var b6 = a.get("title");
        return b6 && b6.length && (b6 = b6[0]), b6 && b6.text;
      }
      function m6(b6) {
        return a.getLocaleModel().get(["series", "typeNames"])[b6] || "\u81EA\u5B9A\u4E49\u56FE";
      }
    }
    function OZe(a) {
      if (!(!a || !a.aria)) {
        var r6 = a.aria;
        r6.show != null && (r6.enabled = r6.show), r6.label = r6.label || {}, Ne(["description", "general", "series", "data"], function(t2) {
          r6[t2] != null && (r6.label[t2] = r6[t2]);
        });
      }
    }
    function RZe(a) {
      a.registerPreprocessor(OZe), a.registerVisual(a.PRIORITY.VISUAL.ARIA, LZe);
    }
    var D1e = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, FZe = function() {
      function a(r6) {
        var t2 = this._condVal = _a2(r6) ? new RegExp(r6) : yU(r6) ? r6 : null;
        if (t2 == null) {
          var s = "";
          Lo(s);
        }
      }
      return a.prototype.evaluate = function(r6) {
        var t2 = typeof r6;
        return _a2(t2) ? this._condVal.test(r6) : ks(t2) ? this._condVal.test(r6 + "") : false;
      }, a;
    }(), NZe = function() {
      function a() {
      }
      return a.prototype.evaluate = function() {
        return this.value;
      }, a;
    }(), VZe = function() {
      function a() {
      }
      return a.prototype.evaluate = function() {
        for (var r6 = this.children, t2 = 0; t2 < r6.length; t2++)
          if (!r6[t2].evaluate())
            return false;
        return true;
      }, a;
    }(), zZe = function() {
      function a() {
      }
      return a.prototype.evaluate = function() {
        for (var r6 = this.children, t2 = 0; t2 < r6.length; t2++)
          if (r6[t2].evaluate())
            return true;
        return false;
      }, a;
    }(), BZe = function() {
      function a() {
      }
      return a.prototype.evaluate = function() {
        return !this.child.evaluate();
      }, a;
    }(), jZe = function() {
      function a() {
      }
      return a.prototype.evaluate = function() {
        for (var r6 = !!this.valueParser, t2 = this.getValue, s = t2(this.valueGetterParam), u = r6 ? this.valueParser(s) : null, f6 = 0; f6 < this.subCondList.length; f6++)
          if (!this.subCondList[f6].evaluate(r6 ? u : s))
            return false;
        return true;
      }, a;
    }();
    function NJ(a, r6) {
      if (a === true || a === false) {
        var t2 = new NZe();
        return t2.value = a, t2;
      }
      var s = "";
      return P1e(a) || Lo(s), a.and ? k1e("and", a, r6) : a.or ? k1e("or", a, r6) : a.not ? GZe(a, r6) : WZe(a, r6);
    }
    function k1e(a, r6, t2) {
      var s = r6[a], u = "";
      br(s) || Lo(u), s.length || Lo(u);
      var f6 = a === "and" ? new VZe() : new zZe();
      return f6.children = wr(s, function(d6) {
        return NJ(d6, t2);
      }), f6.children.length || Lo(u), f6;
    }
    function GZe(a, r6) {
      var t2 = a.not, s = "";
      P1e(t2) || Lo(s);
      var u = new BZe();
      return u.child = NJ(t2, r6), u.child || Lo(s), u;
    }
    function WZe(a, r6) {
      for (var t2 = "", s = r6.prepareGetValue(a), u = [], f6 = Po(a), d6 = a.parser, v6 = d6 ? sfe(d6) : null, m6 = 0; m6 < f6.length; m6++) {
        var b6 = f6[m6];
        if (!(b6 === "parser" || r6.valueGetterAttrMap.get(b6))) {
          var x6 = Da(D1e, b6) ? D1e[b6] : b6, S = a[b6], M = v6 ? v6(S) : S, A6 = wRe(x6, M) || x6 === "reg" && new FZe(M);
          A6 || Lo(t2), u.push(A6);
        }
      }
      u.length || Lo(t2);
      var I = new jZe();
      return I.valueGetterParam = s, I.valueParser = v6, I.getValue = r6.getValue, I.subCondList = u, I;
    }
    function P1e(a) {
      return ui(a) && !rd(a);
    }
    var HZe = function() {
      function a(r6, t2) {
        this._cond = NJ(r6, t2);
      }
      return a.prototype.evaluate = function() {
        return this._cond.evaluate();
      }, a;
    }();
    function $Ze(a, r6) {
      return new HZe(a, r6);
    }
    var UZe = { type: "echarts:filter", transform: function(a) {
      for (var r6 = a.upstream, t2, s = $Ze(a.config, { valueGetterAttrMap: Ta({ dimension: true }), prepareGetValue: function(v6) {
        var m6 = "", b6 = v6.dimension;
        Da(v6, "dimension") || Lo(m6);
        var x6 = r6.getDimensionInfo(b6);
        return x6 || Lo(m6), { dimIdx: x6.index };
      }, getValue: function(v6) {
        return r6.retrieveValueFromItem(t2, v6.dimIdx);
      } }), u = [], f6 = 0, d6 = r6.count(); f6 < d6; f6++)
        t2 = r6.getRawDataItem(f6), s.evaluate() && u.push(t2);
      return { data: u };
    } }, qZe = { type: "echarts:sort", transform: function(a) {
      var r6 = a.upstream, t2 = a.config, s = "", u = ll(t2);
      u.length || Lo(s);
      var f6 = [];
      Ne(u, function(x6) {
        var S = x6.dimension, M = x6.order, A6 = x6.parser, I = x6.incomparable;
        if (S == null && Lo(s), M !== "asc" && M !== "desc" && Lo(s), I && I !== "min" && I !== "max") {
          var R = "";
          Lo(R);
        }
        if (M !== "asc" && M !== "desc") {
          var F = "";
          Lo(F);
        }
        var j = r6.getDimensionInfo(S);
        j || Lo(s);
        var $ = A6 ? sfe(A6) : null;
        A6 && !$ && Lo(s), f6.push({ dimIdx: j.index, parser: $, comparator: new ufe(M, I) });
      });
      var d6 = r6.sourceFormat;
      d6 !== jp && d6 !== Pm && Lo(s);
      for (var v6 = [], m6 = 0, b6 = r6.count(); m6 < b6; m6++)
        v6.push(r6.getRawDataItem(m6));
      return v6.sort(function(x6, S) {
        for (var M = 0; M < f6.length; M++) {
          var A6 = f6[M], I = r6.retrieveValueFromItem(x6, A6.dimIdx), R = r6.retrieveValueFromItem(S, A6.dimIdx);
          A6.parser && (I = A6.parser(I), R = A6.parser(R));
          var F = A6.comparator.evaluate(I, R);
          if (F !== 0)
            return F;
        }
        return 0;
      }), { data: v6 };
    } };
    function YZe(a) {
      a.registerTransform(UZe), a.registerTransform(qZe);
    }
    var ZZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "dataset", t2;
      }
      return r6.prototype.init = function(t2, s, u) {
        a.prototype.init.call(this, t2, s, u), this._sourceManager = new vfe(this), gfe(this);
      }, r6.prototype.mergeOption = function(t2, s) {
        a.prototype.mergeOption.call(this, t2, s), gfe(this);
      }, r6.prototype.optionUpdated = function() {
        this._sourceManager.dirty();
      }, r6.prototype.getSourceManager = function() {
        return this._sourceManager;
      }, r6.type = "dataset", r6.defaultOption = { seriesLayoutBy: Fb }, r6;
    }(Ps), XZe = function(a) {
      tt(r6, a);
      function r6() {
        var t2 = a !== null && a.apply(this, arguments) || this;
        return t2.type = "dataset", t2;
      }
      return r6.type = "dataset", r6;
    }(Rc);
    function KZe(a) {
      a.registerComponentModel(ZZe), a.registerComponentView(XZe);
    }
    var Hb = wm.CMD;
    function k5(a, r6) {
      return Math.abs(a - r6) < 1e-5;
    }
    function VJ(a) {
      var r6 = a.data, t2 = a.len(), s = [], u, f6 = 0, d6 = 0, v6 = 0, m6 = 0;
      function b6(Fe, at) {
        u && u.length > 2 && s.push(u), u = [Fe, at];
      }
      function x6(Fe, at, ht, Qe) {
        k5(Fe, ht) && k5(at, Qe) || u.push(Fe, at, ht, Qe, ht, Qe);
      }
      function S(Fe, at, ht, Qe, en, bt) {
        var wt = Math.abs(at - Fe), Ft = Math.tan(wt / 4) * 4 / 3, fn = at < Fe ? -1 : 1, gn = Math.cos(Fe), Zr = Math.sin(Fe), Ma = Math.cos(at), Ua = Math.sin(at), ja = gn * en + ht, Ga = Zr * bt + Qe, pa = Ma * en + ht, Fa = Ua * bt + Qe, Ha = en * Ft * fn, Sa = bt * Ft * fn;
        u.push(ja - Ha * Zr, Ga + Sa * gn, pa + Ha * Ua, Fa - Sa * Ma, pa, Fa);
      }
      for (var M, A6, I, R, F = 0; F < t2; ) {
        var j = r6[F++], $ = F === 1;
        switch ($ && (f6 = r6[F], d6 = r6[F + 1], v6 = f6, m6 = d6, (j === Hb.L || j === Hb.C || j === Hb.Q) && (u = [v6, m6])), j) {
          case Hb.M:
            f6 = v6 = r6[F++], d6 = m6 = r6[F++], b6(v6, m6);
            break;
          case Hb.L:
            M = r6[F++], A6 = r6[F++], x6(f6, d6, M, A6), f6 = M, d6 = A6;
            break;
          case Hb.C:
            u.push(r6[F++], r6[F++], r6[F++], r6[F++], f6 = r6[F++], d6 = r6[F++]);
            break;
          case Hb.Q:
            M = r6[F++], A6 = r6[F++], I = r6[F++], R = r6[F++], u.push(f6 + 2 / 3 * (M - f6), d6 + 2 / 3 * (A6 - d6), I + 2 / 3 * (M - I), R + 2 / 3 * (A6 - R), I, R), f6 = I, d6 = R;
            break;
          case Hb.A:
            var K = r6[F++], U = r6[F++], he = r6[F++], ue = r6[F++], pe = r6[F++], _e = r6[F++] + pe;
            F += 1;
            var xe = !r6[F++];
            M = Math.cos(pe) * he + K, A6 = Math.sin(pe) * ue + U, $ ? (v6 = M, m6 = A6, b6(v6, m6)) : x6(f6, d6, M, A6), f6 = Math.cos(_e) * he + K, d6 = Math.sin(_e) * ue + U;
            for (var Ae = (xe ? -1 : 1) * Math.PI / 2, ke = pe; xe ? ke > _e : ke < _e; ke += Ae) {
              var je = xe ? Math.max(ke + Ae, _e) : Math.min(ke + Ae, _e);
              S(ke, je, K, U, he, ue);
            }
            break;
          case Hb.R:
            v6 = f6 = r6[F++], m6 = d6 = r6[F++], M = v6 + r6[F++], A6 = m6 + r6[F++], b6(M, m6), x6(M, m6, M, A6), x6(M, A6, v6, A6), x6(v6, A6, v6, m6), x6(v6, m6, M, m6);
            break;
          case Hb.Z:
            u && x6(f6, d6, v6, m6), f6 = v6, d6 = m6;
            break;
        }
      }
      return u && u.length > 2 && s.push(u), s;
    }
    function zJ(a, r6, t2, s, u, f6, d6, v6, m6, b6) {
      if (k5(a, t2) && k5(r6, s) && k5(u, d6) && k5(f6, v6)) {
        m6.push(d6, v6);
        return;
      }
      var x6 = 2 / b6, S = x6 * x6, M = d6 - a, A6 = v6 - r6, I = Math.sqrt(M * M + A6 * A6);
      M /= I, A6 /= I;
      var R = t2 - a, F = s - r6, j = u - d6, $ = f6 - v6, K = R * R + F * F, U = j * j + $ * $;
      if (K < S && U < S) {
        m6.push(d6, v6);
        return;
      }
      var he = M * R + A6 * F, ue = -M * j - A6 * $, pe = K - he * he, _e = U - ue * ue;
      if (pe < S && he >= 0 && _e < S && ue >= 0) {
        m6.push(d6, v6);
        return;
      }
      var xe = [], Ae = [];
      Jg(a, t2, u, d6, 0.5, xe), Jg(r6, s, f6, v6, 0.5, Ae), zJ(xe[0], Ae[0], xe[1], Ae[1], xe[2], Ae[2], xe[3], Ae[3], m6, b6), zJ(xe[4], Ae[4], xe[5], Ae[5], xe[6], Ae[6], xe[7], Ae[7], m6, b6);
    }
    function JZe(a, r6) {
      var t2 = VJ(a), s = [];
      r6 = r6 || 1;
      for (var u = 0; u < t2.length; u++) {
        var f6 = t2[u], d6 = [], v6 = f6[0], m6 = f6[1];
        d6.push(v6, m6);
        for (var b6 = 2; b6 < f6.length; ) {
          var x6 = f6[b6++], S = f6[b6++], M = f6[b6++], A6 = f6[b6++], I = f6[b6++], R = f6[b6++];
          zJ(v6, m6, x6, S, M, A6, I, R, d6, r6), v6 = I, m6 = R;
        }
        s.push(d6);
      }
      return s;
    }
    function L1e(a, r6, t2) {
      var s = a[r6], u = a[1 - r6], f6 = Math.abs(s / u), d6 = Math.ceil(Math.sqrt(f6 * t2)), v6 = Math.floor(t2 / d6);
      v6 === 0 && (v6 = 1, d6 = t2);
      for (var m6 = [], b6 = 0; b6 < d6; b6++)
        m6.push(v6);
      var x6 = d6 * v6, S = t2 - x6;
      if (S > 0)
        for (var b6 = 0; b6 < S; b6++)
          m6[b6 % d6] += 1;
      return m6;
    }
    function O1e(a, r6, t2) {
      for (var s = a.r0, u = a.r, f6 = a.startAngle, d6 = a.endAngle, v6 = Math.abs(d6 - f6), m6 = v6 * u, b6 = u - s, x6 = m6 > Math.abs(b6), S = L1e([m6, b6], x6 ? 0 : 1, r6), M = (x6 ? v6 : b6) / S.length, A6 = 0; A6 < S.length; A6++)
        for (var I = (x6 ? b6 : v6) / S[A6], R = 0; R < S[A6]; R++) {
          var F = {};
          x6 ? (F.startAngle = f6 + M * A6, F.endAngle = f6 + M * (A6 + 1), F.r0 = s + I * R, F.r = s + I * (R + 1)) : (F.startAngle = f6 + I * R, F.endAngle = f6 + I * (R + 1), F.r0 = s + M * A6, F.r = s + M * (A6 + 1)), F.clockwise = a.clockwise, F.cx = a.cx, F.cy = a.cy, t2.push(F);
        }
    }
    function QZe(a, r6, t2) {
      for (var s = a.width, u = a.height, f6 = s > u, d6 = L1e([s, u], f6 ? 0 : 1, r6), v6 = f6 ? "width" : "height", m6 = f6 ? "height" : "width", b6 = f6 ? "x" : "y", x6 = f6 ? "y" : "x", S = a[v6] / d6.length, M = 0; M < d6.length; M++)
        for (var A6 = a[m6] / d6[M], I = 0; I < d6[M]; I++) {
          var R = {};
          R[b6] = M * S, R[x6] = I * A6, R[v6] = S, R[m6] = A6, R.x += a.x, R.y += a.y, t2.push(R);
        }
    }
    function R1e(a, r6, t2, s) {
      return a * s - t2 * r6;
    }
    function eXe(a, r6, t2, s, u, f6, d6, v6) {
      var m6 = t2 - a, b6 = s - r6, x6 = d6 - u, S = v6 - f6, M = R1e(x6, S, m6, b6);
      if (Math.abs(M) < 1e-6)
        return null;
      var A6 = a - u, I = r6 - f6, R = R1e(A6, I, x6, S) / M;
      return R < 0 || R > 1 ? null : new Bi(R * m6 + a, R * b6 + r6);
    }
    function tXe(a, r6, t2) {
      var s = new Bi();
      Bi.sub(s, t2, r6), s.normalize();
      var u = new Bi();
      Bi.sub(u, a, r6);
      var f6 = u.dot(s);
      return f6;
    }
    function P5(a, r6) {
      var t2 = a[a.length - 1];
      t2 && t2[0] === r6[0] && t2[1] === r6[1] || a.push(r6);
    }
    function nXe(a, r6, t2) {
      for (var s = a.length, u = [], f6 = 0; f6 < s; f6++) {
        var d6 = a[f6], v6 = a[(f6 + 1) % s], m6 = eXe(d6[0], d6[1], v6[0], v6[1], r6.x, r6.y, t2.x, t2.y);
        m6 && u.push({ projPt: tXe(m6, r6, t2), pt: m6, idx: f6 });
      }
      if (u.length < 2)
        return [{ points: a }, { points: a }];
      u.sort(function(F, j) {
        return F.projPt - j.projPt;
      });
      var b6 = u[0], x6 = u[u.length - 1];
      if (x6.idx < b6.idx) {
        var S = b6;
        b6 = x6, x6 = S;
      }
      for (var M = [b6.pt.x, b6.pt.y], A6 = [x6.pt.x, x6.pt.y], I = [M], R = [A6], f6 = b6.idx + 1; f6 <= x6.idx; f6++)
        P5(I, a[f6].slice());
      P5(I, A6), P5(I, M);
      for (var f6 = x6.idx + 1; f6 <= b6.idx + s; f6++)
        P5(R, a[f6 % s].slice());
      return P5(R, M), P5(R, A6), [{ points: I }, { points: R }];
    }
    function F1e(a) {
      var r6 = a.points, t2 = [], s = [];
      CD(r6, t2, s);
      var u = new Qi(t2[0], t2[1], s[0] - t2[0], s[1] - t2[1]), f6 = u.width, d6 = u.height, v6 = u.x, m6 = u.y, b6 = new Bi(), x6 = new Bi();
      return f6 > d6 ? (b6.x = x6.x = v6 + f6 / 2, b6.y = m6, x6.y = m6 + d6) : (b6.y = x6.y = m6 + d6 / 2, b6.x = v6, x6.x = v6 + f6), nXe(r6, b6, x6);
    }
    function Yz(a, r6, t2, s) {
      if (t2 === 1)
        s.push(r6);
      else {
        var u = Math.floor(t2 / 2), f6 = a(r6);
        Yz(a, f6[0], u, s), Yz(a, f6[1], t2 - u, s);
      }
      return s;
    }
    function rXe(a, r6) {
      for (var t2 = [], s = 0; s < r6; s++)
        t2.push(QO(a));
      return t2;
    }
    function aXe(a, r6) {
      r6.setStyle(a.style), r6.z = a.z, r6.z2 = a.z2, r6.zlevel = a.zlevel;
    }
    function iXe(a) {
      for (var r6 = [], t2 = 0; t2 < a.length; )
        r6.push([a[t2++], a[t2++]]);
      return r6;
    }
    function oXe(a, r6) {
      var t2 = [], s = a.shape, u;
      switch (a.type) {
        case "rect":
          QZe(s, r6, t2), u = rs;
          break;
        case "sector":
          O1e(s, r6, t2), u = Np;
          break;
        case "circle":
          O1e({ r0: 0, r: s.r, startAngle: 0, endAngle: Math.PI * 2, cx: s.cx, cy: s.cy }, r6, t2), u = Np;
          break;
        default:
          var f6 = a.getComputedTransform(), d6 = f6 ? Math.sqrt(Math.max(f6[0] * f6[0] + f6[1] * f6[1], f6[2] * f6[2] + f6[3] * f6[3])) : 1, v6 = wr(JZe(a.getUpdatedPathProxy(), d6), function(j) {
            return iXe(j);
          }), m6 = v6.length;
          if (m6 === 0)
            Yz(F1e, { points: v6[0] }, r6, t2);
          else if (m6 === r6)
            for (var b6 = 0; b6 < m6; b6++)
              t2.push({ points: v6[b6] });
          else {
            var x6 = 0, S = wr(v6, function(j) {
              var $ = [], K = [];
              CD(j, $, K);
              var U = (K[1] - $[1]) * (K[0] - $[0]);
              return x6 += U, { poly: j, area: U };
            });
            S.sort(function(j, $) {
              return $.area - j.area;
            });
            for (var M = r6, b6 = 0; b6 < m6; b6++) {
              var A6 = S[b6];
              if (M <= 0)
                break;
              var I = b6 === m6 - 1 ? M : Math.ceil(A6.area / x6 * r6);
              I < 0 || (Yz(F1e, { points: A6.poly }, I, t2), M -= I);
            }
          }
          u = ud;
          break;
      }
      if (!u)
        return rXe(a, r6);
      for (var R = [], b6 = 0; b6 < t2.length; b6++) {
        var F = new u();
        F.setShape(t2[b6]), aXe(a, F), R.push(F);
      }
      return R;
    }
    function sXe(a, r6) {
      var t2 = a.length, s = r6.length;
      if (t2 === s)
        return [a, r6];
      for (var u = [], f6 = [], d6 = t2 < s ? a : r6, v6 = Math.min(t2, s), m6 = Math.abs(s - t2) / 6, b6 = (v6 - 2) / 6, x6 = Math.ceil(m6 / b6) + 1, S = [d6[0], d6[1]], M = m6, A6 = 2; A6 < v6; ) {
        var I = d6[A6 - 2], R = d6[A6 - 1], F = d6[A6++], j = d6[A6++], $ = d6[A6++], K = d6[A6++], U = d6[A6++], he = d6[A6++];
        if (M <= 0) {
          S.push(F, j, $, K, U, he);
          continue;
        }
        for (var ue = Math.min(M, x6 - 1) + 1, pe = 1; pe <= ue; pe++) {
          var _e = pe / ue;
          Jg(I, F, $, U, _e, u), Jg(R, j, K, he, _e, f6), I = u[3], R = f6[3], S.push(u[1], f6[1], u[2], f6[2], I, R), F = u[5], j = f6[5], $ = u[6], K = f6[6];
        }
        M -= ue - 1;
      }
      return d6 === a ? [S, r6] : [a, S];
    }
    function N1e(a, r6) {
      for (var t2 = a.length, s = a[t2 - 2], u = a[t2 - 1], f6 = [], d6 = 0; d6 < r6.length; )
        f6[d6++] = s, f6[d6++] = u;
      return f6;
    }
    function lXe(a, r6) {
      for (var t2, s, u, f6 = [], d6 = [], v6 = 0; v6 < Math.max(a.length, r6.length); v6++) {
        var m6 = a[v6], b6 = r6[v6], x6 = void 0, S = void 0;
        m6 ? b6 ? (t2 = sXe(m6, b6), x6 = t2[0], S = t2[1], s = x6, u = S) : (S = N1e(u || m6, m6), x6 = m6) : (x6 = N1e(s || b6, b6), S = b6), f6.push(x6), d6.push(S);
      }
      return [f6, d6];
    }
    function V1e(a) {
      for (var r6 = 0, t2 = 0, s = 0, u = a.length, f6 = 0, d6 = u - 2; f6 < u; d6 = f6, f6 += 2) {
        var v6 = a[d6], m6 = a[d6 + 1], b6 = a[f6], x6 = a[f6 + 1], S = v6 * x6 - b6 * m6;
        r6 += S, t2 += (v6 + b6) * S, s += (m6 + x6) * S;
      }
      return r6 === 0 ? [a[0] || 0, a[1] || 0] : [t2 / r6 / 3, s / r6 / 3, r6];
    }
    function uXe(a, r6, t2, s) {
      for (var u = (a.length - 2) / 6, f6 = 1 / 0, d6 = 0, v6 = a.length, m6 = v6 - 2, b6 = 0; b6 < u; b6++) {
        for (var x6 = b6 * 6, S = 0, M = 0; M < v6; M += 2) {
          var A6 = M === 0 ? x6 : (x6 + M - 2) % m6 + 2, I = a[A6] - t2[0], R = a[A6 + 1] - t2[1], F = r6[M] - s[0], j = r6[M + 1] - s[1], $ = F - I, K = j - R;
          S += $ * $ + K * K;
        }
        S < f6 && (f6 = S, d6 = b6);
      }
      return d6;
    }
    function cXe(a) {
      for (var r6 = [], t2 = a.length, s = 0; s < t2; s += 2)
        r6[s] = a[t2 - s - 2], r6[s + 1] = a[t2 - s - 1];
      return r6;
    }
    function fXe(a, r6, t2, s) {
      for (var u = [], f6, d6 = 0; d6 < a.length; d6++) {
        var v6 = a[d6], m6 = r6[d6], b6 = V1e(v6), x6 = V1e(m6);
        f6 == null && (f6 = b6[2] < 0 != x6[2] < 0);
        var S = [], M = [], A6 = 0, I = 1 / 0, R = [], F = v6.length;
        f6 && (v6 = cXe(v6));
        for (var j = uXe(v6, m6, b6, x6) * 6, $ = F - 2, K = 0; K < $; K += 2) {
          var U = (j + K) % $ + 2;
          S[K + 2] = v6[U] - b6[0], S[K + 3] = v6[U + 1] - b6[1];
        }
        if (S[0] = v6[j] - b6[0], S[1] = v6[j + 1] - b6[1], t2 > 0)
          for (var he = s / t2, ue = -s / 2; ue <= s / 2; ue += he) {
            for (var pe = Math.sin(ue), _e = Math.cos(ue), xe = 0, K = 0; K < v6.length; K += 2) {
              var Ae = S[K], ke = S[K + 1], je = m6[K] - x6[0], Fe = m6[K + 1] - x6[1], at = je * _e - Fe * pe, ht = je * pe + Fe * _e;
              R[K] = at, R[K + 1] = ht;
              var Qe = at - Ae, en = ht - ke;
              xe += Qe * Qe + en * en;
            }
            if (xe < I) {
              I = xe, A6 = ue;
              for (var bt = 0; bt < R.length; bt++)
                M[bt] = R[bt];
            }
          }
        else
          for (var wt = 0; wt < F; wt += 2)
            M[wt] = m6[wt] - x6[0], M[wt + 1] = m6[wt + 1] - x6[1];
        u.push({ from: S, to: M, fromCp: b6, toCp: x6, rotation: -A6 });
      }
      return u;
    }
    function Zz(a) {
      return a.__isCombineMorphing;
    }
    var z1e = "__mOriginal_";
    function Xz(a, r6, t2) {
      var s = z1e + r6, u = a[s] || a[r6];
      a[s] || (a[s] = a[r6]);
      var f6 = t2.replace, d6 = t2.after, v6 = t2.before;
      a[r6] = function() {
        var m6 = arguments, b6;
        return v6 && v6.apply(this, m6), f6 ? b6 = f6.apply(this, m6) : b6 = u.apply(this, m6), d6 && d6.apply(this, m6), b6;
      };
    }
    function E4(a, r6) {
      var t2 = z1e + r6;
      a[t2] && (a[r6] = a[t2], a[t2] = null);
    }
    function B1e(a, r6) {
      for (var t2 = 0; t2 < a.length; t2++)
        for (var s = a[t2], u = 0; u < s.length; ) {
          var f6 = s[u], d6 = s[u + 1];
          s[u++] = r6[0] * f6 + r6[2] * d6 + r6[4], s[u++] = r6[1] * f6 + r6[3] * d6 + r6[5];
        }
    }
    function j1e(a, r6) {
      var t2 = a.getUpdatedPathProxy(), s = r6.getUpdatedPathProxy(), u = lXe(VJ(t2), VJ(s)), f6 = u[0], d6 = u[1], v6 = a.getComputedTransform(), m6 = r6.getComputedTransform();
      function b6() {
        this.transform = null;
      }
      v6 && B1e(f6, v6), m6 && B1e(d6, m6), Xz(r6, "updateTransform", { replace: b6 }), r6.transform = null;
      var x6 = fXe(f6, d6, 10, Math.PI), S = [];
      Xz(r6, "buildPath", { replace: function(M) {
        for (var A6 = r6.__morphT, I = 1 - A6, R = [], F = 0; F < x6.length; F++) {
          var j = x6[F], $ = j.from, K = j.to, U = j.rotation * A6, he = j.fromCp, ue = j.toCp, pe = Math.sin(U), _e = Math.cos(U);
          LT(R, he, ue, A6);
          for (var xe = 0; xe < $.length; xe += 2) {
            var Ae = $[xe], ke = $[xe + 1], je = K[xe], Fe = K[xe + 1], at = Ae * I + je * A6, ht = ke * I + Fe * A6;
            S[xe] = at * _e - ht * pe + R[0], S[xe + 1] = at * pe + ht * _e + R[1];
          }
          var Qe = S[0], en = S[1];
          M.moveTo(Qe, en);
          for (var xe = 2; xe < $.length; ) {
            var je = S[xe++], Fe = S[xe++], bt = S[xe++], wt = S[xe++], Ft = S[xe++], fn = S[xe++];
            Qe === je && en === Fe && bt === Ft && wt === fn ? M.lineTo(Ft, fn) : M.bezierCurveTo(je, Fe, bt, wt, Ft, fn), Qe = Ft, en = fn;
          }
        }
      } });
    }
    function BJ(a, r6, t2) {
      if (!a || !r6)
        return r6;
      var s = t2.done, u = t2.during;
      j1e(a, r6), r6.__morphT = 0;
      function f6() {
        E4(r6, "buildPath"), E4(r6, "updateTransform"), r6.__morphT = -1, r6.createPathProxy(), r6.dirtyShape();
      }
      return r6.animateTo({ __morphT: 1 }, ei({ during: function(d6) {
        r6.dirtyShape(), u && u(d6);
      }, done: function() {
        f6(), s && s();
      } }, t2)), r6;
    }
    function hXe(a, r6, t2, s, u, f6) {
      var d6 = 16;
      a = u === t2 ? 0 : Math.round(32767 * (a - t2) / (u - t2)), r6 = f6 === s ? 0 : Math.round(32767 * (r6 - s) / (f6 - s));
      for (var v6 = 0, m6, b6 = (1 << d6) / 2; b6 > 0; b6 /= 2) {
        var x6 = 0, S = 0;
        (a & b6) > 0 && (x6 = 1), (r6 & b6) > 0 && (S = 1), v6 += b6 * b6 * (3 * x6 ^ S), S === 0 && (x6 === 1 && (a = b6 - 1 - a, r6 = b6 - 1 - r6), m6 = a, a = r6, r6 = m6);
      }
      return v6;
    }
    function Kz(a) {
      var r6 = 1 / 0, t2 = 1 / 0, s = -1 / 0, u = -1 / 0, f6 = wr(a, function(v6) {
        var m6 = v6.getBoundingRect(), b6 = v6.getComputedTransform(), x6 = m6.x + m6.width / 2 + (b6 ? b6[4] : 0), S = m6.y + m6.height / 2 + (b6 ? b6[5] : 0);
        return r6 = Math.min(x6, r6), t2 = Math.min(S, t2), s = Math.max(x6, s), u = Math.max(S, u), [x6, S];
      }), d6 = wr(f6, function(v6, m6) {
        return { cp: v6, z: hXe(v6[0], v6[1], r6, t2, s, u), path: a[m6] };
      });
      return d6.sort(function(v6, m6) {
        return v6.z - m6.z;
      }).map(function(v6) {
        return v6.path;
      });
    }
    function G1e(a) {
      return oXe(a.path, a.count);
    }
    function jJ() {
      return { fromIndividuals: [], toIndividuals: [], count: 0 };
    }
    function dXe(a, r6, t2) {
      var s = [];
      function u(he) {
        for (var ue = 0; ue < he.length; ue++) {
          var pe = he[ue];
          Zz(pe) ? u(pe.childrenRef()) : pe instanceof uo && s.push(pe);
        }
      }
      u(a);
      var f6 = s.length;
      if (!f6)
        return jJ();
      var d6 = t2.dividePath || G1e, v6 = d6({ path: r6, count: f6 });
      if (v6.length !== f6)
        return console.error("Invalid morphing: unmatched splitted path"), jJ();
      s = Kz(s), v6 = Kz(v6);
      for (var m6 = t2.done, b6 = t2.during, x6 = t2.individualDelay, S = new a0(), M = 0; M < f6; M++) {
        var A6 = s[M], I = v6[M];
        I.parent = r6, I.copyTransform(S), x6 || j1e(A6, I);
      }
      r6.__isCombineMorphing = true, r6.childrenRef = function() {
        return v6;
      };
      function R(he) {
        for (var ue = 0; ue < v6.length; ue++)
          v6[ue].addSelfToZr(he);
      }
      Xz(r6, "addSelfToZr", { after: function(he) {
        R(he);
      } }), Xz(r6, "removeSelfFromZr", { after: function(he) {
        for (var ue = 0; ue < v6.length; ue++)
          v6[ue].removeSelfFromZr(he);
      } });
      function F() {
        r6.__isCombineMorphing = false, r6.__morphT = -1, r6.childrenRef = null, E4(r6, "addSelfToZr"), E4(r6, "removeSelfFromZr");
      }
      var j = v6.length;
      if (x6)
        for (var $ = j, K = function() {
          $--, $ === 0 && (F(), m6 && m6());
        }, M = 0; M < j; M++) {
          var U = x6 ? ei({ delay: (t2.delay || 0) + x6(M, j, s[M], v6[M]), done: K }, t2) : t2;
          BJ(s[M], v6[M], U);
        }
      else
        r6.__morphT = 0, r6.animateTo({ __morphT: 1 }, ei({ during: function(he) {
          for (var ue = 0; ue < j; ue++) {
            var pe = v6[ue];
            pe.__morphT = r6.__morphT, pe.dirtyShape();
          }
          b6 && b6(he);
        }, done: function() {
          F();
          for (var he = 0; he < a.length; he++)
            E4(a[he], "updateTransform");
          m6 && m6();
        } }, t2));
      return r6.__zr && R(r6.__zr), { fromIndividuals: s, toIndividuals: v6, count: j };
    }
    function pXe(a, r6, t2) {
      var s = r6.length, u = [], f6 = t2.dividePath || G1e;
      function d6(A6) {
        for (var I = 0; I < A6.length; I++) {
          var R = A6[I];
          Zz(R) ? d6(R.childrenRef()) : R instanceof uo && u.push(R);
        }
      }
      if (Zz(a)) {
        d6(a.childrenRef());
        var v6 = u.length;
        if (v6 < s)
          for (var m6 = 0, b6 = v6; b6 < s; b6++)
            u.push(QO(u[m6++ % v6]));
        u.length = s;
      } else {
        u = f6({ path: a, count: s });
        for (var x6 = a.getComputedTransform(), b6 = 0; b6 < u.length; b6++)
          u[b6].setLocalTransform(x6);
        if (u.length !== s)
          return console.error("Invalid morphing: unmatched splitted path"), jJ();
      }
      u = Kz(u), r6 = Kz(r6);
      for (var S = t2.individualDelay, b6 = 0; b6 < s; b6++) {
        var M = S ? ei({ delay: (t2.delay || 0) + S(b6, s, u[b6], r6[b6]) }, t2) : t2;
        BJ(u[b6], r6[b6], M);
      }
      return { fromIndividuals: u, toIndividuals: r6, count: r6.length };
    }
    function W1e(a) {
      return br(a[0]);
    }
    function H1e(a, r6) {
      for (var t2 = [], s = a.length, u = 0; u < s; u++)
        t2.push({ one: a[u], many: [] });
      for (var u = 0; u < r6.length; u++) {
        var f6 = r6[u].length, d6 = void 0;
        for (d6 = 0; d6 < f6; d6++)
          t2[d6 % s].many.push(r6[u][d6]);
      }
      for (var v6 = 0, u = s - 1; u >= 0; u--)
        if (!t2[u].many.length) {
          var m6 = t2[v6].many;
          if (m6.length <= 1)
            if (v6)
              v6 = 0;
            else
              return t2;
          var f6 = m6.length, b6 = Math.ceil(f6 / 2);
          t2[u].many = m6.slice(b6, f6), t2[v6].many = m6.slice(0, b6), v6++;
        }
      return t2;
    }
    var vXe = { clone: function(a) {
      for (var r6 = [], t2 = 1 - Math.pow(1 - a.path.style.opacity, 1 / a.count), s = 0; s < a.count; s++) {
        var u = QO(a.path);
        u.setStyle("opacity", t2), r6.push(u);
      }
      return r6;
    }, split: null };
    function GJ(a, r6, t2, s, u, f6) {
      if (!a.length || !r6.length)
        return;
      var d6 = U2("update", s, u);
      if (!(d6 && d6.duration > 0))
        return;
      var v6 = s.getModel("universalTransition").get("delay"), m6 = Object.assign({ setToFinal: true }, d6), b6, x6;
      W1e(a) && (b6 = a, x6 = r6), W1e(r6) && (b6 = r6, x6 = a);
      function S(j, $, K, U, he) {
        var ue = j.many, pe = j.one;
        if (ue.length === 1 && !he) {
          var _e = $ ? ue[0] : pe, xe = $ ? pe : ue[0];
          if (Zz(_e))
            S({ many: [_e], one: xe }, true, K, U, true);
          else {
            var Ae = v6 ? ei({ delay: v6(K, U) }, m6) : m6;
            BJ(_e, xe, Ae), f6(_e, xe, _e, xe, Ae);
          }
        } else
          for (var ke = ei({ dividePath: vXe[t2], individualDelay: v6 && function(en, bt, wt, Ft) {
            return v6(en + K, U);
          } }, m6), je = $ ? dXe(ue, pe, ke) : pXe(pe, ue, ke), Fe = je.fromIndividuals, at = je.toIndividuals, ht = Fe.length, Qe = 0; Qe < ht; Qe++) {
            var Ae = v6 ? ei({ delay: v6(Qe, ht) }, m6) : m6;
            f6(Fe[Qe], at[Qe], $ ? ue[Qe] : j.one, $ ? j.one : ue[Qe], Ae);
          }
      }
      for (var M = b6 ? b6 === a : a.length > r6.length, A6 = b6 ? H1e(x6, b6) : H1e(M ? r6 : a, [M ? a : r6]), I = 0, R = 0; R < A6.length; R++)
        I += A6[R].many.length;
      for (var F = 0, R = 0; R < A6.length; R++)
        S(A6[R], M, F, I), F += A6[R].many.length;
    }
    function NA(a) {
      if (!a)
        return [];
      if (br(a)) {
        for (var r6 = [], t2 = 0; t2 < a.length; t2++)
          r6.push(NA(a[t2]));
        return r6;
      }
      var s = [];
      return a.traverse(function(u) {
        u instanceof uo && !u.disableMorphing && !u.invisible && !u.ignore && s.push(u);
      }), s;
    }
    var $1e = 1e4, gXe = Xo();
    function mXe(a) {
      for (var r6 = a.dimensions, t2 = 0; t2 < r6.length; t2++) {
        var s = a.getDimensionInfo(r6[t2]);
        if (s && s.otherDims.itemGroupId === 0)
          return r6[t2];
      }
    }
    function U1e(a) {
      var r6 = [];
      return Ne(a, function(t2) {
        var s = t2.data;
        if (!(s.count() > $1e))
          for (var u = s.getIndices(), f6 = mXe(s), d6 = 0; d6 < u.length; d6++)
            r6.push({ data: s, dim: t2.dim || f6, divide: t2.divide, dataIndex: d6 });
      }), r6;
    }
    function WJ(a, r6, t2) {
      a.traverse(function(s) {
        s instanceof uo && zu(s, { style: { opacity: 0 } }, r6, { dataIndex: t2, isFrom: true });
      });
    }
    function HJ(a) {
      if (a.parent) {
        var r6 = a.getComputedTransform();
        a.setLocalTransform(r6), a.parent.remove(a);
      }
    }
    function L5(a) {
      a.stopAnimation(), a.isGroup && a.traverse(function(r6) {
        r6.stopAnimation();
      });
    }
    function yXe(a, r6, t2) {
      var s = U2("update", t2, r6);
      s && a.traverse(function(u) {
        if (u instanceof cg) {
          var f6 = xY(u);
          f6 && u.animateFrom({ style: f6 }, s);
        }
      });
    }
    function bXe(a, r6) {
      var t2 = a.length;
      if (t2 !== r6.length)
        return false;
      for (var s = 0; s < t2; s++) {
        var u = a[s], f6 = r6[s];
        if (u.data.getId(u.dataIndex) !== f6.data.getId(f6.dataIndex))
          return false;
      }
      return true;
    }
    function q1e(a, r6, t2) {
      var s = U1e(a), u = U1e(r6);
      function f6(j, $, K, U, he) {
        (K || j) && $.animateFrom({ style: K && K !== j ? qn(qn({}, K.style), j.style) : j.style }, he);
      }
      function d6(j) {
        for (var $ = 0; $ < j.length; $++)
          if (j[$].dim)
            return j[$].dim;
      }
      var v6 = d6(s), m6 = d6(u), b6 = false;
      function x6(j, $) {
        return function(K) {
          var U = K.data, he = K.dataIndex;
          if ($)
            return U.getId(he);
          var ue = U.hostModel && U.hostModel.get("dataGroupId"), pe = j ? v6 || m6 : m6 || v6, _e = pe && U.getDimensionInfo(pe), xe = _e && _e.ordinalMeta;
          if (_e) {
            var Ae = U.get(_e.name, he);
            return xe && xe.categories[Ae] || Ae + "";
          }
          var ke = U.getRawDataItem(he);
          return ke && ke.groupId ? ke.groupId + "" : ue || U.getId(he);
        };
      }
      var S = bXe(s, u), M = {};
      if (!S)
        for (var A6 = 0; A6 < u.length; A6++) {
          var I = u[A6], R = I.data.getItemGraphicEl(I.dataIndex);
          R && (M[R.id] = true);
        }
      function F(j, $) {
        var K = s[$], U = u[j], he = U.data.hostModel, ue = K.data.getItemGraphicEl(K.dataIndex), pe = U.data.getItemGraphicEl(U.dataIndex);
        if (ue === pe) {
          pe && yXe(pe, U.dataIndex, he);
          return;
        }
        ue && M[ue.id] || pe && (L5(pe), ue ? (L5(ue), HJ(ue), b6 = true, GJ(NA(ue), NA(pe), U.divide, he, j, f6)) : WJ(pe, he, j));
      }
      new Gx(s, u, x6(true, S), x6(false, S), null, "multiple").update(F).updateManyToOne(function(j, $) {
        var K = u[j], U = K.data, he = U.hostModel, ue = U.getItemGraphicEl(K.dataIndex), pe = gl(wr($, function(_e) {
          return s[_e].data.getItemGraphicEl(s[_e].dataIndex);
        }), function(_e) {
          return _e && _e !== ue && !M[_e.id];
        });
        ue && (L5(ue), pe.length ? (Ne(pe, function(_e) {
          L5(_e), HJ(_e);
        }), b6 = true, GJ(NA(pe), NA(ue), K.divide, he, j, f6)) : WJ(ue, he, K.dataIndex));
      }).updateOneToMany(function(j, $) {
        var K = s[$], U = K.data.getItemGraphicEl(K.dataIndex);
        if (!(U && M[U.id])) {
          var he = gl(wr(j, function(pe) {
            return u[pe].data.getItemGraphicEl(u[pe].dataIndex);
          }), function(pe) {
            return pe && pe !== U;
          }), ue = u[j[0]].data.hostModel;
          he.length && (Ne(he, function(pe) {
            return L5(pe);
          }), U ? (L5(U), HJ(U), b6 = true, GJ(NA(U), NA(he), K.divide, ue, j[0], f6)) : Ne(he, function(pe) {
            return WJ(pe, ue, j[0]);
          }));
        }
      }).updateManyToMany(function(j, $) {
        new Gx($, j, function(K) {
          return s[K].data.getId(s[K].dataIndex);
        }, function(K) {
          return u[K].data.getId(u[K].dataIndex);
        }).update(function(K, U) {
          F(j[K], $[U]);
        }).execute();
      }).execute(), b6 && Ne(r6, function(j) {
        var $ = j.data, K = $.hostModel, U = K && t2.getViewOfSeriesModel(K), he = U2("update", K, 0);
        U && K.isAnimationEnabled() && he && he.duration > 0 && U.group.traverse(function(ue) {
          ue instanceof uo && !ue.animators.length && ue.animateFrom({ style: { opacity: 0 } }, he);
        });
      });
    }
    function Y1e(a) {
      var r6 = a.getModel("universalTransition").get("seriesKey");
      return r6 || a.id;
    }
    function Z1e(a) {
      return br(a) ? a.sort().join(",") : a;
    }
    function pS(a) {
      if (a.hostModel)
        return a.hostModel.getModel("universalTransition").get("divideShape");
    }
    function _Xe(a, r6) {
      var t2 = Ta(), s = Ta(), u = Ta();
      return Ne(a.oldSeries, function(f6, d6) {
        var v6 = a.oldData[d6], m6 = Y1e(f6), b6 = Z1e(m6);
        s.set(b6, v6), br(m6) && Ne(m6, function(x6) {
          u.set(x6, { data: v6, key: b6 });
        });
      }), Ne(r6.updatedSeries, function(f6) {
        if (f6.isUniversalTransitionEnabled() && f6.isAnimationEnabled()) {
          var d6 = f6.getData(), v6 = Y1e(f6), m6 = Z1e(v6), b6 = s.get(m6);
          if (b6)
            t2.set(m6, { oldSeries: [{ divide: pS(b6), data: b6 }], newSeries: [{ divide: pS(d6), data: d6 }] });
          else if (br(v6)) {
            var x6 = [];
            Ne(v6, function(A6) {
              var I = s.get(A6);
              I && x6.push({ divide: pS(I), data: I });
            }), x6.length && t2.set(m6, { oldSeries: x6, newSeries: [{ data: d6, divide: pS(d6) }] });
          } else {
            var S = u.get(v6);
            if (S) {
              var M = t2.get(S.key);
              M || (M = { oldSeries: [{ data: S.data, divide: pS(S.data) }], newSeries: [] }, t2.set(S.key, M)), M.newSeries.push({ data: d6, divide: pS(d6) });
            }
          }
        }
      }), t2;
    }
    function X1e(a, r6) {
      for (var t2 = 0; t2 < a.length; t2++) {
        var s = r6.seriesIndex != null && r6.seriesIndex === a[t2].seriesIndex || r6.seriesId != null && r6.seriesId === a[t2].id;
        if (s)
          return t2;
      }
    }
    function xXe(a, r6, t2, s) {
      var u = [], f6 = [];
      Ne(ll(a.from), function(d6) {
        var v6 = X1e(r6.oldSeries, d6);
        v6 >= 0 && u.push({ data: r6.oldData[v6], divide: pS(r6.oldData[v6]), dim: d6.dimension });
      }), Ne(ll(a.to), function(d6) {
        var v6 = X1e(t2.updatedSeries, d6);
        if (v6 >= 0) {
          var m6 = t2.updatedSeries[v6].getData();
          f6.push({ data: m6, divide: pS(m6), dim: d6.dimension });
        }
      }), u.length > 0 && f6.length > 0 && q1e(u, f6, s);
    }
    function wXe(a) {
      a.registerUpdateLifecycle("series:beforeupdate", function(r6, t2, s) {
        Ne(ll(s.seriesTransition), function(u) {
          Ne(ll(u.to), function(f6) {
            for (var d6 = s.updatedSeries, v6 = 0; v6 < d6.length; v6++)
              (f6.seriesIndex != null && f6.seriesIndex === d6[v6].seriesIndex || f6.seriesId != null && f6.seriesId === d6[v6].id) && (d6[v6][mV] = true);
          });
        });
      }), a.registerUpdateLifecycle("series:transition", function(r6, t2, s) {
        var u = gXe(t2);
        if (u.oldSeries && s.updatedSeries && s.optionChanged) {
          var f6 = s.seriesTransition;
          if (f6)
            Ne(ll(f6), function(M) {
              xXe(M, u, s, t2);
            });
          else {
            var d6 = _Xe(u, s);
            Ne(d6.keys(), function(M) {
              var A6 = d6.get(M);
              q1e(A6.oldSeries, A6.newSeries, t2);
            });
          }
          Ne(s.updatedSeries, function(M) {
            M[mV] && (M[mV] = false);
          });
        }
        for (var v6 = r6.getSeries(), m6 = u.oldSeries = [], b6 = u.oldData = [], x6 = 0; x6 < v6.length; x6++) {
          var S = v6[x6].getData();
          S.count() < $1e && (m6.push(v6[x6]), b6.push(S));
        }
      });
    }
    bo([BNe]), bo([LNe]), bo([c8e, I8e, B8e, I9e, $9e, z7e, gVe, nze, Dze, zze, Xze, eje, Eje, jje, oGe, dGe, kGe, jGe, eWe, lWe, xWe, iHe]), bo(IHe), bo(l$e), bo(Uve), bo(M$e), bo(v0e), bo(P$e), bo(j$e), bo(GUe), bo(fqe), bo(y42), bo(kqe), bo(Oqe), bo(Zqe), bo(iYe), bo(dYe), bo(xYe), bo(RYe), bo(rZe), bo(o1e), bo(c1e), bo(DZe), bo(A1e), bo(I1e), bo(RZe), bo(YZe), bo(KZe), bo(wXe), bo(JFe);
    function SXe(a) {
      const { defaultOptions: r6 } = a != null ? a : {}, t2 = g4.useRef(null), s = g4.useRef(), u = g4.useRef(r6);
      return g4.useEffect(() => {
        if (!t2.current)
          return;
        const f6 = p6e(t2.current);
        s.current = f6, u.current && f6.setOption(u.current);
      }, []), g4.useEffect(() => () => {
        var f6, d6, v6, m6;
        (d6 = (f6 = s.current) == null ? void 0 : f6.dispose) == null || d6.call(f6), (m6 = (v6 = s.current) == null ? void 0 : v6.off) == null || m6.call(v6, "*"), s.current = void 0;
      }, []), Et("resize", () => {
        requestAnimationFrame(() => {
          var f6, d6;
          (d6 = (f6 = s == null ? void 0 : s.current) == null ? void 0 : f6.resize) == null || d6.call(f6);
        });
      }), { chart: s, container: t2 };
    }
    class CXe {
      constructor() {
        p4(this, "chartsEmitters", /* @__PURE__ */ new Map()), p4(this, "add", (r6, t2, s, u) => {
          t2 && s ? this.chartsEmitters.set(r6, { chart: t2, option: s, title: u }) : console.log("\u6DFB\u52A0\u5931\u8D25");
        }), p4(this, "get", (r6) => this.chartsEmitters.get(r6)), p4(this, "clear", () => {
          this.chartsEmitters.clear();
        }), p4(this, "delete", (r6) => {
          this.chartsEmitters.delete(r6);
        }), p4(this, "list", () => {
          var r6, t2, s;
          const u = [];
          for (const f6 of this.chartsEmitters.keys())
            u.push({ id: f6, chart: (r6 = this.chartsEmitters.get(f6)) == null ? void 0 : r6.chart, option: (t2 = this.chartsEmitters.get(f6)) == null ? void 0 : t2.option, title: (s = this.chartsEmitters.get(f6)) == null ? void 0 : s.title });
          return u;
        });
      }
    }
    const MXe = new CXe();
    var Jz = { exports: {} };
    /**
    * @license
    * Lodash <https://lodash.com/>
    * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
    * Released under MIT license <https://lodash.com/license>
    * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
    * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
    */
    (function(a, r6) {
      (function() {
        var t2, s = "4.17.21", u = 200, f6 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", d6 = "Expected a function", v6 = "Invalid `variable` option passed into `_.template`", m6 = "__lodash_hash_undefined__", b6 = 500, x6 = "__lodash_placeholder__", S = 1, M = 2, A6 = 4, I = 1, R = 2, F = 1, j = 2, $ = 4, K = 8, U = 16, he = 32, ue = 64, pe = 128, _e = 256, xe = 512, Ae = 30, ke = "...", je = 800, Fe = 16, at = 1, ht = 2, Qe = 3, en = 1 / 0, bt = 9007199254740991, wt = 17976931348623157e292, Ft = 0 / 0, fn = 4294967295, gn = fn - 1, Zr = fn >>> 1, Ma = [["ary", pe], ["bind", F], ["bindKey", j], ["curry", K], ["curryRight", U], ["flip", xe], ["partial", he], ["partialRight", ue], ["rearg", _e]], Ua = "[object Arguments]", ja = "[object Array]", Ga = "[object AsyncFunction]", pa = "[object Boolean]", Fa = "[object Date]", Ha = "[object DOMException]", Sa = "[object Error]", oi = "[object Function]", bs = "[object GeneratorFunction]", Si = "[object Map]", Ls = "[object Number]", tl = "[object Null]", Hs = "[object Object]", Of = "[object Promise]", Xu = "[object Proxy]", kh = "[object RegExp]", ou = "[object Set]", lc = "[object String]", Ku = "[object Symbol]", _0 = "[object Undefined]", Vr = "[object WeakMap]", Un = "[object WeakSet]", Wn = "[object ArrayBuffer]", zr = "[object DataView]", La = "[object Float32Array]", _i = "[object Float64Array]", Jo = "[object Int8Array]", Wo = "[object Int16Array]", wl = "[object Int32Array]", Ju = "[object Uint8Array]", wu = "[object Uint8ClampedArray]", Kc = "[object Uint16Array]", Su = "[object Uint32Array]", pd = /\b__p \+= '';/g, ip = /\b(__p \+=) '' \+/g, kv = /(__e\(.*?\)|\b__t\)) \+\n'';/g, op = /&(?:amp|lt|gt|quot|#39);/g, Ac = /[&<>"']/g, $s = RegExp(op.source), Rf = RegExp(Ac.source), Ph = /<%-([\s\S]+?)%>/g, pg = /<%([\s\S]+?)%>/g, Up = /<%=([\s\S]+?)%>/g, sp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, Pv = /^\w*$/, $m = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, Um = /[\\^$.*+?()[\]{}|]/g, j4 = RegExp(Um.source), Ub = /^\s+/, G4 = /\s/, W4 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, H4 = /\{\n\/\* \[wrapped with (.+)\] \*/, $4 = /,? & /, yS = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Ot = /[()=,{}\[\]\/\s]/, Nt = /\\(\\)?/g, ct = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, Mt = /\w*$/, _t = /^[-+]0x[0-9a-f]+$/i, Rn = /^0b[01]+$/i, Pn = /^\[object .+?Constructor\]$/, lr = /^0o[0-7]+$/i, Mn = /^(?:0|[1-9]\d*)$/, ta = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, di = /($^)/, as = /['\n\r\u2028\u2029\\]/g, fo = "\\ud800-\\udfff", Gl = "\\u0300-\\u036f", So = "\\ufe20-\\ufe2f", kl = "\\u20d0-\\u20ff", Jl = Gl + So + kl, Mi = "\\u2700-\\u27bf", Sl = "a-z\\xdf-\\xf6\\xf8-\\xff", lp = "\\xac\\xb1\\xd7\\xf7", x0 = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", bS = "\\u2000-\\u206f", qp = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", p1 = "A-Z\\xc0-\\xd6\\xd8-\\xde", v12 = "\\ufe0e\\ufe0f", Jc = lp + x0 + bS + qp, qm = "['\u2019]", Qx = "[" + fo + "]", g1 = "[" + Jc + "]", ew = "[" + Jl + "]", qb = "\\d+", Lh = "[" + Mi + "]", tw = "[" + Sl + "]", Ym = "[^" + fo + Jc + qb + Mi + Sl + p1 + "]", nw = "\\ud83c[\\udffb-\\udfff]", Yb = "(?:" + ew + "|" + nw + ")", vg = "[^" + fo + "]", jA = "(?:\\ud83c[\\udde6-\\uddff]){2}", GA = "[\\ud800-\\udbff][\\udc00-\\udfff]", vd = "[" + p1 + "]", MB = "\\u200d", Zm = "(?:" + tw + "|" + Ym + ")", j5 = "(?:" + vd + "|" + Ym + ")", U4 = "(?:" + qm + "(?:d|ll|m|re|s|t|ve))?", AB = "(?:" + qm + "(?:D|LL|M|RE|S|T|VE))?", EB = Yb + "?", IB = "[" + v12 + "]?", TB = "(?:" + MB + "(?:" + [vg, jA, GA].join("|") + ")" + IB + EB + ")*", DB = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", FQ = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", q4 = IB + EB + TB, G5 = "(?:" + [Lh, jA, GA].join("|") + ")" + q4, NQ = "(?:" + [vg + ew + "?", ew, jA, GA, Qx].join("|") + ")", kB = RegExp(qm, "g"), PB = RegExp(ew, "g"), W5 = RegExp(nw + "(?=" + nw + ")|" + NQ + q4, "g"), Y4 = RegExp([vd + "?" + tw + "+" + U4 + "(?=" + [g1, vd, "$"].join("|") + ")", j5 + "+" + AB + "(?=" + [g1, vd + Zm, "$"].join("|") + ")", vd + "?" + Zm + "+" + U4, vd + "+" + AB, FQ, DB, qb, G5].join("|"), "g"), Z4 = RegExp("[" + MB + fo + Jl + v12 + "]"), gd = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, X4 = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], LB = -1, Qu = {};
        Qu[La] = Qu[_i] = Qu[Jo] = Qu[Wo] = Qu[wl] = Qu[Ju] = Qu[wu] = Qu[Kc] = Qu[Su] = true, Qu[Ua] = Qu[ja] = Qu[Wn] = Qu[pa] = Qu[zr] = Qu[Fa] = Qu[Sa] = Qu[oi] = Qu[Si] = Qu[Ls] = Qu[Hs] = Qu[kh] = Qu[ou] = Qu[lc] = Qu[Vr] = false;
        var Bu = {};
        Bu[Ua] = Bu[ja] = Bu[Wn] = Bu[zr] = Bu[pa] = Bu[Fa] = Bu[La] = Bu[_i] = Bu[Jo] = Bu[Wo] = Bu[wl] = Bu[Si] = Bu[Ls] = Bu[Hs] = Bu[kh] = Bu[ou] = Bu[lc] = Bu[Ku] = Bu[Ju] = Bu[wu] = Bu[Kc] = Bu[Su] = true, Bu[Sa] = Bu[oi] = Bu[Vr] = false;
        var Xm = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, OB = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, VQ = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, RB = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, K4 = parseFloat, FB = parseInt, H5 = typeof ze == "object" && ze && ze.Object === Object && ze, zQ = typeof self == "object" && self && self.Object === Object && self, sh = H5 || zQ || Function("return this")(), J4 = r6 && !r6.nodeType && r6, Zb = J4 && true && a && !a.nodeType && a, Q4 = Zb && Zb.exports === J4, WA = Q4 && H5.process, Lv = function() {
          try {
            var mn = Zb && Zb.require && Zb.require("util").types;
            return mn || WA && WA.binding && WA.binding("util");
          } catch {
          }
        }(), e6 = Lv && Lv.isArrayBuffer, NB = Lv && Lv.isDate, VB = Lv && Lv.isMap, zB = Lv && Lv.isRegExp, _S = Lv && Lv.isSet, BB = Lv && Lv.isTypedArray;
        function Ov(mn, Sr, ar) {
          switch (ar.length) {
            case 0:
              return mn.call(Sr);
            case 1:
              return mn.call(Sr, ar[0]);
            case 2:
              return mn.call(Sr, ar[0], ar[1]);
            case 3:
              return mn.call(Sr, ar[0], ar[1], ar[2]);
          }
          return mn.apply(Sr, ar);
        }
        function $5(mn, Sr, ar, ai) {
          for (var ro = -1, Pl = mn == null ? 0 : mn.length; ++ro < Pl; ) {
            var Qc = mn[ro];
            Sr(ai, Qc, ar(Qc), mn);
          }
          return ai;
        }
        function Yp(mn, Sr) {
          for (var ar = -1, ai = mn == null ? 0 : mn.length; ++ar < ai && Sr(mn[ar], ar, mn) !== false; )
            ;
          return mn;
        }
        function jB(mn, Sr) {
          for (var ar = mn == null ? 0 : mn.length; ar-- && Sr(mn[ar], ar, mn) !== false; )
            ;
          return mn;
        }
        function GB(mn, Sr) {
          for (var ar = -1, ai = mn == null ? 0 : mn.length; ++ar < ai; )
            if (!Sr(mn[ar], ar, mn))
              return false;
          return true;
        }
        function Xb(mn, Sr) {
          for (var ar = -1, ai = mn == null ? 0 : mn.length, ro = 0, Pl = []; ++ar < ai; ) {
            var Qc = mn[ar];
            Sr(Qc, ar, mn) && (Pl[ro++] = Qc);
          }
          return Pl;
        }
        function rw(mn, Sr) {
          var ar = mn == null ? 0 : mn.length;
          return !!ar && m1(mn, Sr, 0) > -1;
        }
        function t6(mn, Sr, ar) {
          for (var ai = -1, ro = mn == null ? 0 : mn.length; ++ai < ro; )
            if (ar(Sr, mn[ai]))
              return true;
          return false;
        }
        function uc(mn, Sr) {
          for (var ar = -1, ai = mn == null ? 0 : mn.length, ro = Array(ai); ++ar < ai; )
            ro[ar] = Sr(mn[ar], ar, mn);
          return ro;
        }
        function Kb(mn, Sr) {
          for (var ar = -1, ai = Sr.length, ro = mn.length; ++ar < ai; )
            mn[ro + ar] = Sr[ar];
          return mn;
        }
        function U5(mn, Sr, ar, ai) {
          var ro = -1, Pl = mn == null ? 0 : mn.length;
          for (ai && Pl && (ar = mn[++ro]); ++ro < Pl; )
            ar = Sr(ar, mn[ro], ro, mn);
          return ar;
        }
        function BQ(mn, Sr, ar, ai) {
          var ro = mn == null ? 0 : mn.length;
          for (ai && ro && (ar = mn[--ro]); ro--; )
            ar = Sr(ar, mn[ro], ro, mn);
          return ar;
        }
        function Fc(mn, Sr) {
          for (var ar = -1, ai = mn == null ? 0 : mn.length; ++ar < ai; )
            if (Sr(mn[ar], ar, mn))
              return true;
          return false;
        }
        var HA = UA("length");
        function WB(mn) {
          return mn.split("");
        }
        function $A(mn) {
          return mn.match(yS) || [];
        }
        function q5(mn, Sr, ar) {
          var ai;
          return ar(mn, function(ro, Pl, Qc) {
            if (Sr(ro, Pl, Qc))
              return ai = Pl, false;
          }), ai;
        }
        function xS(mn, Sr, ar, ai) {
          for (var ro = mn.length, Pl = ar + (ai ? 1 : -1); ai ? Pl-- : ++Pl < ro; )
            if (Sr(mn[Pl], Pl, mn))
              return Pl;
          return -1;
        }
        function m1(mn, Sr, ar) {
          return Sr === Sr ? UQ(mn, Sr, ar) : xS(mn, Y5, ar);
        }
        function jQ(mn, Sr, ar, ai) {
          for (var ro = ar - 1, Pl = mn.length; ++ro < Pl; )
            if (ai(mn[ro], Sr))
              return ro;
          return -1;
        }
        function Y5(mn) {
          return mn !== mn;
        }
        function HB(mn, Sr) {
          var ar = mn == null ? 0 : mn.length;
          return ar ? YA(mn, Sr) / ar : Ft;
        }
        function UA(mn) {
          return function(Sr) {
            return Sr == null ? t2 : Sr[mn];
          };
        }
        function qA(mn) {
          return function(Sr) {
            return mn == null ? t2 : mn[Sr];
          };
        }
        function Wl(mn, Sr, ar, ai, ro) {
          return ro(mn, function(Pl, Qc, Ll) {
            ar = ai ? (ai = false, Pl) : Sr(ar, Pl, Qc, Ll);
          }), ar;
        }
        function lh(mn, Sr) {
          var ar = mn.length;
          for (mn.sort(Sr); ar--; )
            mn[ar] = mn[ar].value;
          return mn;
        }
        function YA(mn, Sr) {
          for (var ar, ai = -1, ro = mn.length; ++ai < ro; ) {
            var Pl = Sr(mn[ai]);
            Pl !== t2 && (ar = ar === t2 ? Pl : ar + Pl);
          }
          return ar;
        }
        function ZA(mn, Sr) {
          for (var ar = -1, ai = Array(mn); ++ar < mn; )
            ai[ar] = Sr(ar);
          return ai;
        }
        function Z5(mn, Sr) {
          return uc(Sr, function(ar) {
            return [ar, mn[ar]];
          });
        }
        function XA(mn) {
          return mn && mn.slice(0, r62(mn) + 1).replace(Ub, "");
        }
        function md(mn) {
          return function(Sr) {
            return mn(Sr);
          };
        }
        function wS(mn, Sr) {
          return uc(Sr, function(ar) {
            return mn[ar];
          });
        }
        function Jb(mn, Sr) {
          return mn.has(Sr);
        }
        function X5(mn, Sr) {
          for (var ar = -1, ai = mn.length; ++ar < ai && m1(Sr, mn[ar], 0) > -1; )
            ;
          return ar;
        }
        function KA(mn, Sr) {
          for (var ar = mn.length; ar-- && m1(Sr, mn[ar], 0) > -1; )
            ;
          return ar;
        }
        function K5(mn, Sr) {
          for (var ar = mn.length, ai = 0; ar--; )
            mn[ar] === Sr && ++ai;
          return ai;
        }
        var J5 = qA(Xm), GQ = qA(OB);
        function Q5(mn) {
          return "\\" + RB[mn];
        }
        function ek(mn, Sr) {
          return mn == null ? t2 : mn[Sr];
        }
        function SS(mn) {
          return Z4.test(mn);
        }
        function WQ(mn) {
          return gd.test(mn);
        }
        function HQ(mn) {
          for (var Sr, ar = []; !(Sr = mn.next()).done; )
            ar.push(Sr.value);
          return ar;
        }
        function n6(mn) {
          var Sr = -1, ar = Array(mn.size);
          return mn.forEach(function(ai, ro) {
            ar[++Sr] = [ro, ai];
          }), ar;
        }
        function Zp(mn, Sr) {
          return function(ar) {
            return mn(Sr(ar));
          };
        }
        function y1(mn, Sr) {
          for (var ar = -1, ai = mn.length, ro = 0, Pl = []; ++ar < ai; ) {
            var Qc = mn[ar];
            (Qc === Sr || Qc === x6) && (mn[ar] = x6, Pl[ro++] = ar);
          }
          return Pl;
        }
        function CS(mn) {
          var Sr = -1, ar = Array(mn.size);
          return mn.forEach(function(ai) {
            ar[++Sr] = ai;
          }), ar;
        }
        function $Q(mn) {
          var Sr = -1, ar = Array(mn.size);
          return mn.forEach(function(ai) {
            ar[++Sr] = [ai, ai];
          }), ar;
        }
        function UQ(mn, Sr, ar) {
          for (var ai = ar - 1, ro = mn.length; ++ai < ro; )
            if (mn[ai] === Sr)
              return ai;
          return -1;
        }
        function qQ(mn, Sr, ar) {
          for (var ai = ar + 1; ai--; )
            if (mn[ai] === Sr)
              return ai;
          return ai;
        }
        function MS(mn) {
          return SS(mn) ? ul(mn) : HA(mn);
        }
        function w0(mn) {
          return SS(mn) ? AS(mn) : WB(mn);
        }
        function r62(mn) {
          for (var Sr = mn.length; Sr-- && G4.test(mn.charAt(Sr)); )
            ;
          return Sr;
        }
        var YQ = qA(VQ);
        function ul(mn) {
          for (var Sr = W5.lastIndex = 0; W5.test(mn); )
            ++Sr;
          return Sr;
        }
        function AS(mn) {
          return mn.match(W5) || [];
        }
        function ec(mn) {
          return mn.match(Y4) || [];
        }
        var JA = function mn(Sr) {
          Sr = Sr == null ? sh : Qb.defaults(sh.Object(), Sr, Qb.pick(sh, X4));
          var ar = Sr.Array, ai = Sr.Date, ro = Sr.Error, Pl = Sr.Function, Qc = Sr.Math, Ll = Sr.Object, a6 = Sr.RegExp, tk = Sr.String, gg = Sr.TypeError, ES = ar.prototype, ZQ = Pl.prototype, IS = Ll.prototype, TS = Sr["__core-js_shared__"], yd = ZQ.toString, Ql = IS.hasOwnProperty, Ff = 0, $B = function() {
            var k10 = /[^.]+$/.exec(TS && TS.keys && TS.keys.IE_PROTO || "");
            return k10 ? "Symbol(src)_1." + k10 : "";
          }(), QA = IS.toString, XQ = yd.call(Ll), UB = sh._, KQ = a6("^" + yd.call(Ql).replace(Um, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), nk = Q4 ? Sr.Buffer : t2, e_ = Sr.Symbol, eE = Sr.Uint8Array, i6 = nk ? nk.allocUnsafe : t2, tE = Zp(Ll.getPrototypeOf, Ll), qB = Ll.create, rk = IS.propertyIsEnumerable, t_ = ES.splice, YB = e_ ? e_.isConcatSpreadable : t2, nE = e_ ? e_.iterator : t2, mg = e_ ? e_.toStringTag : t2, ak = function() {
            try {
              var k10 = ju(Ll, "defineProperty");
              return k10({}, "", {}), k10;
            } catch {
            }
          }(), JQ = Sr.clearTimeout !== sh.clearTimeout && Sr.clearTimeout, nl = ai && ai.now !== sh.Date.now && ai.now, QQ = Sr.setTimeout !== sh.setTimeout && Sr.setTimeout, ik = Qc.ceil, ok = Qc.floor, o6 = Ll.getOwnPropertySymbols, eee = nk ? nk.isBuffer : t2, ZB = Sr.isFinite, tee = ES.join, nee = Zp(Ll.keys, Ll), Nf = Qc.max, bd = Qc.min, ree = ai.now, aee = Sr.parseInt, XB = Qc.random, iee = ES.reverse, rE = ju(Sr, "DataView"), aE = ju(Sr, "Map"), aw = ju(Sr, "Promise"), n_ = ju(Sr, "Set"), iw = ju(Sr, "WeakMap"), b1 = ju(Ll, "create"), _d = iw && new iw(), ow = {}, KB = Xe(rE), oee = Xe(aE), JB = Xe(aw), see = Xe(n_), _f = Xe(iw), _1 = e_ ? e_.prototype : t2, S0 = _1 ? _1.valueOf : t2, s6 = _1 ? _1.toString : t2;
          function it(k10) {
            if (cu(k10) && !Co(k10) && !(k10 instanceof Us)) {
              if (k10 instanceof up)
                return k10;
              if (Ql.call(k10, "__wrapped__"))
                return Tt(k10);
            }
            return new up(k10);
          }
          var sw = function() {
            function k10() {
            }
            return function(z10) {
              if (!uu(z10))
                return {};
              if (qB)
                return qB(z10);
              k10.prototype = z10;
              var oe = new k10();
              return k10.prototype = t2, oe;
            };
          }();
          function iE() {
          }
          function up(k10, z10) {
            this.__wrapped__ = k10, this.__actions__ = [], this.__chain__ = !!z10, this.__index__ = 0, this.__values__ = t2;
          }
          it.templateSettings = { escape: Ph, evaluate: pg, interpolate: Up, variable: "", imports: { _: it } }, it.prototype = iE.prototype, it.prototype.constructor = it, up.prototype = sw(iE.prototype), up.prototype.constructor = up;
          function Us(k10) {
            this.__wrapped__ = k10, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = fn, this.__views__ = [];
          }
          function lee() {
            var k10 = new Us(this.__wrapped__);
            return k10.__actions__ = nn(this.__actions__), k10.__dir__ = this.__dir__, k10.__filtered__ = this.__filtered__, k10.__iteratees__ = nn(this.__iteratees__), k10.__takeCount__ = this.__takeCount__, k10.__views__ = nn(this.__views__), k10;
          }
          function uee() {
            if (this.__filtered__) {
              var k10 = new Us(this);
              k10.__dir__ = -1, k10.__filtered__ = true;
            } else
              k10 = this.clone(), k10.__dir__ *= -1;
            return k10;
          }
          function QB() {
            var k10 = this.__wrapped__.value(), z10 = this.__dir__, oe = Co(k10), Se = z10 < 0, Ge = oe ? k10.length : 0, vt = jn(0, Ge, this.__views__), Ht = vt.start, Kt = vt.end, xn = Kt - Ht, Gr = Se ? Kt : Ht - 1, Wr = this.__iteratees__, Ur = Wr.length, Ba = 0, vi = bd(xn, this.__takeCount__);
            if (!oe || !Se && Ge == xn && vi == xn)
              return bj(k10, this.__actions__);
            var Ni = [];
            e:
              for (; xn-- && Ba < vi; ) {
                Gr += z10;
                for (var $o = -1, Hi = k10[Gr]; ++$o < Ur; ) {
                  var Zi = Wr[$o], No = Zi.iteratee, Wh = Zi.type, dh = No(Hi);
                  if (Wh == ht)
                    Hi = dh;
                  else if (!dh) {
                    if (Wh == at)
                      continue e;
                    break e;
                  }
                }
                Ni[Ba++] = Hi;
              }
            return Ni;
          }
          Us.prototype = sw(iE.prototype), Us.prototype.constructor = Us;
          function lw(k10) {
            var z10 = -1, oe = k10 == null ? 0 : k10.length;
            for (this.clear(); ++z10 < oe; ) {
              var Se = k10[z10];
              this.set(Se[0], Se[1]);
            }
          }
          function cee() {
            this.__data__ = b1 ? b1(null) : {}, this.size = 0;
          }
          function l6(k10) {
            var z10 = this.has(k10) && delete this.__data__[k10];
            return this.size -= z10 ? 1 : 0, z10;
          }
          function u6(k10) {
            var z10 = this.__data__;
            if (b1) {
              var oe = z10[k10];
              return oe === m6 ? t2 : oe;
            }
            return Ql.call(z10, k10) ? z10[k10] : t2;
          }
          function fee(k10) {
            var z10 = this.__data__;
            return b1 ? z10[k10] !== t2 : Ql.call(z10, k10);
          }
          function hee(k10, z10) {
            var oe = this.__data__;
            return this.size += this.has(k10) ? 0 : 1, oe[k10] = b1 && z10 === t2 ? m6 : z10, this;
          }
          lw.prototype.clear = cee, lw.prototype.delete = l6, lw.prototype.get = u6, lw.prototype.has = fee, lw.prototype.set = hee;
          function C0(k10) {
            var z10 = -1, oe = k10 == null ? 0 : k10.length;
            for (this.clear(); ++z10 < oe; ) {
              var Se = k10[z10];
              this.set(Se[0], Se[1]);
            }
          }
          function dee() {
            this.__data__ = [], this.size = 0;
          }
          function c6(k10) {
            var z10 = this.__data__, oe = uE(z10, k10);
            if (oe < 0)
              return false;
            var Se = z10.length - 1;
            return oe == Se ? z10.pop() : t_.call(z10, oe, 1), --this.size, true;
          }
          function pee(k10) {
            var z10 = this.__data__, oe = uE(z10, k10);
            return oe < 0 ? t2 : z10[oe][1];
          }
          function yg(k10) {
            return uE(this.__data__, k10) > -1;
          }
          function ej(k10, z10) {
            var oe = this.__data__, Se = uE(oe, k10);
            return Se < 0 ? (++this.size, oe.push([k10, z10])) : oe[Se][1] = z10, this;
          }
          C0.prototype.clear = dee, C0.prototype.delete = c6, C0.prototype.get = pee, C0.prototype.has = yg, C0.prototype.set = ej;
          function M0(k10) {
            var z10 = -1, oe = k10 == null ? 0 : k10.length;
            for (this.clear(); ++z10 < oe; ) {
              var Se = k10[z10];
              this.set(Se[0], Se[1]);
            }
          }
          function tj() {
            this.size = 0, this.__data__ = { hash: new lw(), map: new (aE || C0)(), string: new lw() };
          }
          function vee(k10) {
            var z10 = ch(this, k10).delete(k10);
            return this.size -= z10 ? 1 : 0, z10;
          }
          function gee(k10) {
            return ch(this, k10).get(k10);
          }
          function mee(k10) {
            return ch(this, k10).has(k10);
          }
          function nj(k10, z10) {
            var oe = ch(this, k10), Se = oe.size;
            return oe.set(k10, z10), this.size += oe.size == Se ? 0 : 1, this;
          }
          M0.prototype.clear = tj, M0.prototype.delete = vee, M0.prototype.get = gee, M0.prototype.has = mee, M0.prototype.set = nj;
          function x1(k10) {
            var z10 = -1, oe = k10 == null ? 0 : k10.length;
            for (this.__data__ = new M0(); ++z10 < oe; )
              this.add(k10[z10]);
          }
          function oE(k10) {
            return this.__data__.set(k10, m6), this;
          }
          function yee(k10) {
            return this.__data__.has(k10);
          }
          x1.prototype.add = x1.prototype.push = oE, x1.prototype.has = yee;
          function A0(k10) {
            var z10 = this.__data__ = new C0(k10);
            this.size = z10.size;
          }
          function rj() {
            this.__data__ = new C0(), this.size = 0;
          }
          function f62(k10) {
            var z10 = this.__data__, oe = z10.delete(k10);
            return this.size = z10.size, oe;
          }
          function bee(k10) {
            return this.__data__.get(k10);
          }
          function _ee(k10) {
            return this.__data__.has(k10);
          }
          function xee(k10, z10) {
            var oe = this.__data__;
            if (oe instanceof C0) {
              var Se = oe.__data__;
              if (!aE || Se.length < u - 1)
                return Se.push([k10, z10]), this.size = ++oe.size, this;
              oe = this.__data__ = new M0(Se);
            }
            return oe.set(k10, z10), this.size = oe.size, this;
          }
          A0.prototype.clear = rj, A0.prototype.delete = f62, A0.prototype.get = bee, A0.prototype.has = _ee, A0.prototype.set = xee;
          function aj(k10, z10) {
            var oe = Co(k10), Se = !oe && Ad(k10), Ge = !oe && !Se && Va(k10), vt = !oe && !Se && !Ge && R0(k10), Ht = oe || Se || Ge || vt, Kt = Ht ? ZA(k10.length, tk) : [], xn = Kt.length;
            for (var Gr in k10)
              (z10 || Ql.call(k10, Gr)) && !(Ht && (Gr == "length" || Ge && (Gr == "offset" || Gr == "parent") || vt && (Gr == "buffer" || Gr == "byteLength" || Gr == "byteOffset") || qs(Gr, xn))) && Kt.push(Gr);
            return Kt;
          }
          function sE(k10) {
            var z10 = k10.length;
            return z10 ? k10[C6(0, z10 - 1)] : t2;
          }
          function wee(k10, z10) {
            return xg(nn(k10), uw(z10, 0, k10.length));
          }
          function See(k10) {
            return xg(nn(k10));
          }
          function h6(k10, z10, oe) {
            (oe !== t2 && !Bh(k10[z10], oe) || oe === t2 && !(z10 in k10)) && w1(k10, z10, oe);
          }
          function lE(k10, z10, oe) {
            var Se = k10[z10];
            (!(Ql.call(k10, z10) && Bh(Se, oe)) || oe === t2 && !(z10 in k10)) && w1(k10, z10, oe);
          }
          function uE(k10, z10) {
            for (var oe = k10.length; oe--; )
              if (Bh(k10[oe][0], z10))
                return oe;
            return -1;
          }
          function Cee(k10, z10, oe, Se) {
            return r_(k10, function(Ge, vt, Ht) {
              z10(Se, Ge, oe(Ge), Ht);
            }), Se;
          }
          function d62(k10, z10) {
            return k10 && ln(z10, pc(z10), k10);
          }
          function Rv(k10, z10) {
            return k10 && ln(z10, nt(z10), k10);
          }
          function w1(k10, z10, oe) {
            z10 == "__proto__" && ak ? ak(k10, z10, { configurable: true, enumerable: true, value: oe, writable: true }) : k10[z10] = oe;
          }
          function sk(k10, z10) {
            for (var oe = -1, Se = z10.length, Ge = ar(Se), vt = k10 == null; ++oe < Se; )
              Ge[oe] = vt ? t2 : ly(k10, z10[oe]);
            return Ge;
          }
          function uw(k10, z10, oe) {
            return k10 === k10 && (oe !== t2 && (k10 = k10 <= oe ? k10 : oe), z10 !== t2 && (k10 = k10 >= z10 ? k10 : z10)), k10;
          }
          function bg(k10, z10, oe, Se, Ge, vt) {
            var Ht, Kt = z10 & S, xn = z10 & M, Gr = z10 & A6;
            if (oe && (Ht = Ge ? oe(k10, Se, Ge, vt) : oe(k10)), Ht !== t2)
              return Ht;
            if (!uu(k10))
              return k10;
            var Wr = Co(k10);
            if (Wr) {
              if (Ht = pi(k10), !Kt)
                return nn(k10, Ht);
            } else {
              var Ur = kn(k10), Ba = Ur == oi || Ur == bs;
              if (Va(k10))
                return ce(k10, Kt);
              if (Ur == Hs || Ur == Ua || Ba && !Ge) {
                if (Ht = xn || Ba ? {} : To(k10), !Kt)
                  return xn ? sr(k10, Rv(Ht, k10)) : yr(k10, d62(Ht, k10));
              } else {
                if (!Bu[Ur])
                  return Ge ? k10 : {};
                Ht = Do(k10, Ur, Kt);
              }
            }
            vt || (vt = new A0());
            var vi = vt.get(k10);
            if (vi)
              return vi;
            vt.set(k10, Ht), Ew(k10) ? k10.forEach(function(Hi) {
              Ht.add(bg(Hi, z10, oe, Hi, k10, vt));
            }) : Al(k10) && k10.forEach(function(Hi, Zi) {
              Ht.set(Zi, bg(Hi, z10, oe, Zi, k10, vt));
            });
            var Ni = Gr ? xn ? uh : cc : xn ? nt : pc, $o = Wr ? t2 : Ni(k10);
            return Yp($o || k10, function(Hi, Zi) {
              $o && (Zi = Hi, Hi = k10[Zi]), lE(Ht, Zi, bg(Hi, z10, oe, Zi, k10, vt));
            }), Ht;
          }
          function p6(k10) {
            var z10 = pc(k10);
            return function(oe) {
              return ij(oe, k10, z10);
            };
          }
          function ij(k10, z10, oe) {
            var Se = oe.length;
            if (k10 == null)
              return !Se;
            for (k10 = Ll(k10); Se--; ) {
              var Ge = oe[Se], vt = z10[Ge], Ht = k10[Ge];
              if (Ht === t2 && !(Ge in k10) || !vt(Ht))
                return false;
            }
            return true;
          }
          function oj(k10, z10, oe) {
            if (typeof k10 != "function")
              throw new gg(d6);
            return S1(function() {
              k10.apply(t2, oe);
            }, z10);
          }
          function cE(k10, z10, oe, Se) {
            var Ge = -1, vt = rw, Ht = true, Kt = k10.length, xn = [], Gr = z10.length;
            if (!Kt)
              return xn;
            oe && (z10 = uc(z10, md(oe))), Se ? (vt = t6, Ht = false) : z10.length >= u && (vt = Jb, Ht = false, z10 = new x1(z10));
            e:
              for (; ++Ge < Kt; ) {
                var Wr = k10[Ge], Ur = oe == null ? Wr : oe(Wr);
                if (Wr = Se || Wr !== 0 ? Wr : 0, Ht && Ur === Ur) {
                  for (var Ba = Gr; Ba--; )
                    if (z10[Ba] === Ur)
                      continue e;
                  xn.push(Wr);
                } else
                  vt(z10, Ur, Se) || xn.push(Wr);
              }
            return xn;
          }
          var r_ = Cn(Rh), sj = Cn(lk, true);
          function lj(k10, z10) {
            var oe = true;
            return r_(k10, function(Se, Ge, vt) {
              return oe = !!z10(Se, Ge, vt), oe;
            }), oe;
          }
          function fE(k10, z10, oe) {
            for (var Se = -1, Ge = k10.length; ++Se < Ge; ) {
              var vt = k10[Se], Ht = z10(vt);
              if (Ht != null && (Kt === t2 ? Ht === Ht && !sf(Ht) : oe(Ht, Kt)))
                var Kt = Ht, xn = vt;
            }
            return xn;
          }
          function v62(k10, z10, oe, Se) {
            var Ge = k10.length;
            for (oe = Ao(oe), oe < 0 && (oe = -oe > Ge ? 0 : Ge + oe), Se = Se === t2 || Se > Ge ? Ge : Ao(Se), Se < 0 && (Se += Ge), Se = oe > Se ? 0 : Tw(Se); oe < Se; )
              k10[oe++] = z10;
            return k10;
          }
          function DS(k10, z10) {
            var oe = [];
            return r_(k10, function(Se, Ge, vt) {
              z10(Se, Ge, vt) && oe.push(Se);
            }), oe;
          }
          function Oh(k10, z10, oe, Se, Ge) {
            var vt = -1, Ht = k10.length;
            for (oe || (oe = Mu), Ge || (Ge = []); ++vt < Ht; ) {
              var Kt = k10[vt];
              z10 > 0 && oe(Kt) ? z10 > 1 ? Oh(Kt, z10 - 1, oe, Se, Ge) : Kb(Ge, Kt) : Se || (Ge[Ge.length] = Kt);
            }
            return Ge;
          }
          var g6 = On(), uj = On(true);
          function Rh(k10, z10) {
            return k10 && g6(k10, z10, pc);
          }
          function lk(k10, z10) {
            return k10 && uj(k10, z10, pc);
          }
          function uk(k10, z10) {
            return Xb(z10, function(oe) {
              return Gu(k10[oe]);
            });
          }
          function cw(k10, z10) {
            z10 = ve(z10, k10);
            for (var oe = 0, Se = z10.length; k10 != null && oe < Se; )
              k10 = k10[Rt(z10[oe++])];
            return oe && oe == Se ? k10 : t2;
          }
          function m62(k10, z10, oe) {
            var Se = z10(k10);
            return Co(k10) ? Se : Kb(Se, oe(k10));
          }
          function xd(k10) {
            return k10 == null ? k10 === t2 ? _0 : tl : mg && mg in Ll(k10) ? fc(k10) : Vh(k10);
          }
          function ck(k10, z10) {
            return k10 > z10;
          }
          function y6(k10, z10) {
            return k10 != null && Ql.call(k10, z10);
          }
          function cj(k10, z10) {
            return k10 != null && z10 in Ll(k10);
          }
          function fk(k10, z10, oe) {
            return k10 >= bd(z10, oe) && k10 < Nf(z10, oe);
          }
          function b62(k10, z10, oe) {
            for (var Se = oe ? t6 : rw, Ge = k10[0].length, vt = k10.length, Ht = vt, Kt = ar(vt), xn = 1 / 0, Gr = []; Ht--; ) {
              var Wr = k10[Ht];
              Ht && z10 && (Wr = uc(Wr, md(z10))), xn = bd(Wr.length, xn), Kt[Ht] = !oe && (z10 || Ge >= 120 && Wr.length >= 120) ? new x1(Ht && Wr) : t2;
            }
            Wr = k10[0];
            var Ur = -1, Ba = Kt[0];
            e:
              for (; ++Ur < Ge && Gr.length < xn; ) {
                var vi = Wr[Ur], Ni = z10 ? z10(vi) : vi;
                if (vi = oe || vi !== 0 ? vi : 0, !(Ba ? Jb(Ba, Ni) : Se(Gr, Ni, oe))) {
                  for (Ht = vt; --Ht; ) {
                    var $o = Kt[Ht];
                    if (!($o ? Jb($o, Ni) : Se(k10[Ht], Ni, oe)))
                      continue e;
                  }
                  Ba && Ba.push(Ni), Gr.push(vi);
                }
              }
            return Gr;
          }
          function ao(k10, z10, oe, Se) {
            return Rh(k10, function(Ge, vt, Ht) {
              z10(Se, oe(Ge), vt, Ht);
            }), Se;
          }
          function kS(k10, z10, oe) {
            z10 = ve(z10, k10), k10 = E0(k10, z10);
            var Se = k10 == null ? k10 : k10[Rt(hc(z10))];
            return Se == null ? t2 : Ov(Se, k10, oe);
          }
          function fj(k10) {
            return cu(k10) && xd(k10) == Ua;
          }
          function Mee(k10) {
            return cu(k10) && xd(k10) == Wn;
          }
          function Aee(k10) {
            return cu(k10) && xd(k10) == Fa;
          }
          function PS(k10, z10, oe, Se, Ge) {
            return k10 === z10 ? true : k10 == null || z10 == null || !cu(k10) && !cu(z10) ? k10 !== k10 && z10 !== z10 : hk(k10, z10, oe, Se, PS, Ge);
          }
          function hk(k10, z10, oe, Se, Ge, vt) {
            var Ht = Co(k10), Kt = Co(z10), xn = Ht ? ja : kn(k10), Gr = Kt ? ja : kn(z10);
            xn = xn == Ua ? Hs : xn, Gr = Gr == Ua ? Hs : Gr;
            var Wr = xn == Hs, Ur = Gr == Hs, Ba = xn == Gr;
            if (Ba && Va(k10)) {
              if (!Va(z10))
                return false;
              Ht = true, Wr = false;
            }
            if (Ba && !Wr)
              return vt || (vt = new A0()), Ht || R0(k10) ? Cu(k10, z10, oe, Se, Ge, vt) : wd(k10, z10, xn, oe, Se, Ge, vt);
            if (!(oe & I)) {
              var vi = Wr && Ql.call(k10, "__wrapped__"), Ni = Ur && Ql.call(z10, "__wrapped__");
              if (vi || Ni) {
                var $o = vi ? k10.value() : k10, Hi = Ni ? z10.value() : z10;
                return vt || (vt = new A0()), Ge($o, Hi, oe, Se, vt);
              }
            }
            return Ba ? (vt || (vt = new A0()), cp(k10, z10, oe, Se, Ge, vt)) : false;
          }
          function fw(k10) {
            return cu(k10) && kn(k10) == Si;
          }
          function hE(k10, z10, oe, Se) {
            var Ge = oe.length, vt = Ge, Ht = !Se;
            if (k10 == null)
              return !vt;
            for (k10 = Ll(k10); Ge--; ) {
              var Kt = oe[Ge];
              if (Ht && Kt[2] ? Kt[1] !== k10[Kt[0]] : !(Kt[0] in k10))
                return false;
            }
            for (; ++Ge < vt; ) {
              Kt = oe[Ge];
              var xn = Kt[0], Gr = k10[xn], Wr = Kt[1];
              if (Ht && Kt[2]) {
                if (Gr === t2 && !(xn in k10))
                  return false;
              } else {
                var Ur = new A0();
                if (Se)
                  var Ba = Se(Gr, Wr, xn, k10, z10, Ur);
                if (!(Ba === t2 ? PS(Wr, Gr, I | R, Se, Ur) : Ba))
                  return false;
              }
            }
            return true;
          }
          function dE(k10) {
            if (!uu(k10) || Kp(k10))
              return false;
            var z10 = Gu(k10) ? KQ : Pn;
            return z10.test(Xe(k10));
          }
          function Eee(k10) {
            return cu(k10) && xd(k10) == kh;
          }
          function hj(k10) {
            return cu(k10) && kn(k10) == ou;
          }
          function Iee(k10) {
            return cu(k10) && tu(k10.length) && !!Qu[xd(k10)];
          }
          function hw(k10) {
            return typeof k10 == "function" ? k10 : k10 == null ? Gh : typeof k10 == "object" ? Co(k10) ? pk(k10[0], k10[1]) : x62(k10) : R1(k10);
          }
          function LS(k10) {
            if (!su(k10))
              return nee(k10);
            var z10 = [];
            for (var oe in Ll(k10))
              Ql.call(k10, oe) && oe != "constructor" && z10.push(oe);
            return z10;
          }
          function _6(k10) {
            if (!uu(k10))
              return Nh(k10);
            var z10 = su(k10), oe = [];
            for (var Se in k10)
              Se == "constructor" && (z10 || !Ql.call(k10, Se)) || oe.push(Se);
            return oe;
          }
          function dk(k10, z10) {
            return k10 < z10;
          }
          function dj(k10, z10) {
            var oe = -1, Se = an(k10) ? ar(k10.length) : [];
            return r_(k10, function(Ge, vt, Ht) {
              Se[++oe] = z10(Ge, vt, Ht);
            }), Se;
          }
          function x62(k10) {
            var z10 = nc(k10);
            return z10.length == 1 && z10[0][2] ? Nc(z10[0][0], z10[0][1]) : function(oe) {
              return oe === k10 || hE(oe, k10, z10);
            };
          }
          function pk(k10, z10) {
            return Rl(k10) && hs(z10) ? Nc(Rt(k10), z10) : function(oe) {
              var Se = ly(oe, k10);
              return Se === t2 && Se === z10 ? qS(oe, k10) : PS(z10, Se, I | R);
            };
          }
          function a_(k10, z10, oe, Se, Ge) {
            k10 !== z10 && g6(z10, function(vt, Ht) {
              if (Ge || (Ge = new A0()), uu(vt))
                Tee(k10, z10, Ht, oe, a_, Se, Ge);
              else {
                var Kt = Se ? Se(pw(k10, Ht), vt, Ht + "", k10, z10, Ge) : t2;
                Kt === t2 && (Kt = vt), h6(k10, Ht, Kt);
              }
            }, nt);
          }
          function Tee(k10, z10, oe, Se, Ge, vt, Ht) {
            var Kt = pw(k10, oe), xn = pw(z10, oe), Gr = Ht.get(xn);
            if (Gr) {
              h6(k10, oe, Gr);
              return;
            }
            var Wr = vt ? vt(Kt, xn, oe + "", k10, z10, Ht) : t2, Ur = Wr === t2;
            if (Ur) {
              var Ba = Co(xn), vi = !Ba && Va(xn), Ni = !Ba && !vi && R0(xn);
              Wr = xn, Ba || vi || Ni ? Co(Kt) ? Wr = Kt : er(Kt) ? Wr = nn(Kt) : vi ? (Ur = false, Wr = ce(xn, true)) : Ni ? (Ur = false, Wr = Ke(xn, true)) : Wr = [] : nv(xn) || Ad(xn) ? (Wr = Kt, Ad(Kt) ? Wr = qk(Kt) : (!uu(Kt) || Gu(Kt)) && (Wr = To(xn))) : Ur = false;
            }
            Ur && (Ht.set(xn, Wr), Ge(Wr, xn, Se, vt, Ht), Ht.delete(xn)), h6(k10, oe, Wr);
          }
          function w6(k10, z10) {
            var oe = k10.length;
            if (oe)
              return z10 += z10 < 0 ? oe : 0, qs(z10, oe) ? k10[z10] : t2;
          }
          function S6(k10, z10, oe) {
            z10.length ? z10 = uc(z10, function(vt) {
              return Co(vt) ? function(Ht) {
                return cw(Ht, vt.length === 1 ? vt[0] : vt);
              } : vt;
            }) : z10 = [Gh];
            var Se = -1;
            z10 = uc(z10, md(Ei()));
            var Ge = dj(k10, function(vt, Ht, Kt) {
              var xn = uc(z10, function(Gr) {
                return Gr(vt);
              });
              return { criteria: xn, index: ++Se, value: vt };
            });
            return lh(Ge, function(vt, Ht) {
              return Bt(vt, Ht, oe);
            });
          }
          function Dee(k10, z10) {
            return pj(k10, z10, function(oe, Se) {
              return qS(k10, Se);
            });
          }
          function pj(k10, z10, oe) {
            for (var Se = -1, Ge = z10.length, vt = {}; ++Se < Ge; ) {
              var Ht = z10[Se], Kt = cw(k10, Ht);
              oe(Kt, Ht) && pE(vt, ve(Ht, k10), Kt);
            }
            return vt;
          }
          function kee(k10) {
            return function(z10) {
              return cw(z10, k10);
            };
          }
          function vk(k10, z10, oe, Se) {
            var Ge = Se ? jQ : m1, vt = -1, Ht = z10.length, Kt = k10;
            for (k10 === z10 && (z10 = nn(z10)), oe && (Kt = uc(k10, md(oe))); ++vt < Ht; )
              for (var xn = 0, Gr = z10[vt], Wr = oe ? oe(Gr) : Gr; (xn = Ge(Kt, Wr, xn, Se)) > -1; )
                Kt !== k10 && t_.call(Kt, xn, 1), t_.call(k10, xn, 1);
            return k10;
          }
          function dw(k10, z10) {
            for (var oe = k10 ? z10.length : 0, Se = oe - 1; oe--; ) {
              var Ge = z10[oe];
              if (oe == Se || Ge !== vt) {
                var vt = Ge;
                qs(Ge) ? t_.call(k10, Ge, 1) : A62(k10, Ge);
              }
            }
            return k10;
          }
          function C6(k10, z10) {
            return k10 + ok(XB() * (z10 - k10 + 1));
          }
          function Pee(k10, z10, oe, Se) {
            for (var Ge = -1, vt = Nf(ik((z10 - k10) / (oe || 1)), 0), Ht = ar(vt); vt--; )
              Ht[Se ? vt : ++Ge] = k10, k10 += oe;
            return Ht;
          }
          function gk(k10, z10) {
            var oe = "";
            if (!k10 || z10 < 1 || z10 > bt)
              return oe;
            do
              z10 % 2 && (oe += k10), z10 = ok(z10 / 2), z10 && (k10 += k10);
            while (z10);
            return oe;
          }
          function _s(k10, z10) {
            return vw(Md(k10, z10, Gh), k10 + "");
          }
          function mk(k10) {
            return sE(v_(k10));
          }
          function Lee(k10, z10) {
            var oe = v_(k10);
            return xg(oe, uw(z10, 0, oe.length));
          }
          function pE(k10, z10, oe, Se) {
            if (!uu(k10))
              return k10;
            z10 = ve(z10, k10);
            for (var Ge = -1, vt = z10.length, Ht = vt - 1, Kt = k10; Kt != null && ++Ge < vt; ) {
              var xn = Rt(z10[Ge]), Gr = oe;
              if (xn === "__proto__" || xn === "constructor" || xn === "prototype")
                return k10;
              if (Ge != Ht) {
                var Wr = Kt[xn];
                Gr = Se ? Se(Wr, xn, Kt) : t2, Gr === t2 && (Gr = uu(Wr) ? Wr : qs(z10[Ge + 1]) ? [] : {});
              }
              lE(Kt, xn, Gr), Kt = Kt[xn];
            }
            return k10;
          }
          var vj = _d ? function(k10, z10) {
            return _d.set(k10, z10), k10;
          } : Gh, gj = ak ? function(k10, z10) {
            return ak(k10, "toString", { configurable: true, enumerable: false, value: HE(z10), writable: true });
          } : Gh;
          function Oee(k10) {
            return xg(v_(k10));
          }
          function _g(k10, z10, oe) {
            var Se = -1, Ge = k10.length;
            z10 < 0 && (z10 = -z10 > Ge ? 0 : Ge + z10), oe = oe > Ge ? Ge : oe, oe < 0 && (oe += Ge), Ge = z10 > oe ? 0 : oe - z10 >>> 0, z10 >>>= 0;
            for (var vt = ar(Ge); ++Se < Ge; )
              vt[Se] = k10[Se + z10];
            return vt;
          }
          function Ree(k10, z10) {
            var oe;
            return r_(k10, function(Se, Ge, vt) {
              return oe = z10(Se, Ge, vt), !oe;
            }), !!oe;
          }
          function yk(k10, z10, oe) {
            var Se = 0, Ge = k10 == null ? Se : k10.length;
            if (typeof z10 == "number" && z10 === z10 && Ge <= Zr) {
              for (; Se < Ge; ) {
                var vt = Se + Ge >>> 1, Ht = k10[vt];
                Ht !== null && !sf(Ht) && (oe ? Ht <= z10 : Ht < z10) ? Se = vt + 1 : Ge = vt;
              }
              return Ge;
            }
            return bk(k10, z10, Gh, oe);
          }
          function bk(k10, z10, oe, Se) {
            var Ge = 0, vt = k10 == null ? 0 : k10.length;
            if (vt === 0)
              return 0;
            z10 = oe(z10);
            for (var Ht = z10 !== z10, Kt = z10 === null, xn = sf(z10), Gr = z10 === t2; Ge < vt; ) {
              var Wr = ok((Ge + vt) / 2), Ur = oe(k10[Wr]), Ba = Ur !== t2, vi = Ur === null, Ni = Ur === Ur, $o = sf(Ur);
              if (Ht)
                var Hi = Se || Ni;
              else
                Gr ? Hi = Ni && (Se || Ba) : Kt ? Hi = Ni && Ba && (Se || !vi) : xn ? Hi = Ni && Ba && !vi && (Se || !$o) : vi || $o ? Hi = false : Hi = Se ? Ur <= z10 : Ur < z10;
              Hi ? Ge = Wr + 1 : vt = Wr;
            }
            return bd(vt, gn);
          }
          function mj(k10, z10) {
            for (var oe = -1, Se = k10.length, Ge = 0, vt = []; ++oe < Se; ) {
              var Ht = k10[oe], Kt = z10 ? z10(Ht) : Ht;
              if (!oe || !Bh(Kt, xn)) {
                var xn = Kt;
                vt[Ge++] = Ht === 0 ? 0 : Ht;
              }
            }
            return vt;
          }
          function M6(k10) {
            return typeof k10 == "number" ? k10 : sf(k10) ? Ft : +k10;
          }
          function Fv(k10) {
            if (typeof k10 == "string")
              return k10;
            if (Co(k10))
              return uc(k10, Fv) + "";
            if (sf(k10))
              return s6 ? s6.call(k10) : "";
            var z10 = k10 + "";
            return z10 == "0" && 1 / k10 == -en ? "-0" : z10;
          }
          function Km(k10, z10, oe) {
            var Se = -1, Ge = rw, vt = k10.length, Ht = true, Kt = [], xn = Kt;
            if (oe)
              Ht = false, Ge = t6;
            else if (vt >= u) {
              var Gr = z10 ? null : xs(k10);
              if (Gr)
                return CS(Gr);
              Ht = false, Ge = Jb, xn = new x1();
            } else
              xn = z10 ? [] : Kt;
            e:
              for (; ++Se < vt; ) {
                var Wr = k10[Se], Ur = z10 ? z10(Wr) : Wr;
                if (Wr = oe || Wr !== 0 ? Wr : 0, Ht && Ur === Ur) {
                  for (var Ba = xn.length; Ba--; )
                    if (xn[Ba] === Ur)
                      continue e;
                  z10 && xn.push(Ur), Kt.push(Wr);
                } else
                  Ge(xn, Ur, oe) || (xn !== Kt && xn.push(Ur), Kt.push(Wr));
              }
            return Kt;
          }
          function A62(k10, z10) {
            return z10 = ve(z10, k10), k10 = E0(k10, z10), k10 == null || delete k10[Rt(hc(z10))];
          }
          function yj(k10, z10, oe, Se) {
            return pE(k10, z10, oe(cw(k10, z10)), Se);
          }
          function _k(k10, z10, oe, Se) {
            for (var Ge = k10.length, vt = Se ? Ge : -1; (Se ? vt-- : ++vt < Ge) && z10(k10[vt], vt, k10); )
              ;
            return oe ? _g(k10, Se ? 0 : vt, Se ? vt + 1 : Ge) : _g(k10, Se ? vt + 1 : 0, Se ? Ge : vt);
          }
          function bj(k10, z10) {
            var oe = k10;
            return oe instanceof Us && (oe = oe.value()), U5(z10, function(Se, Ge) {
              return Ge.func.apply(Ge.thisArg, Kb([Se], Ge.args));
            }, oe);
          }
          function xk(k10, z10, oe) {
            var Se = k10.length;
            if (Se < 2)
              return Se ? Km(k10[0]) : [];
            for (var Ge = -1, vt = ar(Se); ++Ge < Se; )
              for (var Ht = k10[Ge], Kt = -1; ++Kt < Se; )
                Kt != Ge && (vt[Ge] = cE(vt[Ge] || Ht, k10[Kt], z10, oe));
            return Km(Oh(vt, 1), z10, oe);
          }
          function _j(k10, z10, oe) {
            for (var Se = -1, Ge = k10.length, vt = z10.length, Ht = {}; ++Se < Ge; ) {
              var Kt = Se < vt ? z10[Se] : t2;
              oe(Ht, k10[Se], Kt);
            }
            return Ht;
          }
          function E6(k10) {
            return er(k10) ? k10 : [];
          }
          function Z(k10) {
            return typeof k10 == "function" ? k10 : Gh;
          }
          function ve(k10, z10) {
            return Co(k10) ? k10 : Rl(k10, z10) ? [k10] : St(El(k10));
          }
          var J = _s;
          function ee(k10, z10, oe) {
            var Se = k10.length;
            return oe = oe === t2 ? Se : oe, !z10 && oe >= Se ? k10 : _g(k10, z10, oe);
          }
          var te = JQ || function(k10) {
            return sh.clearTimeout(k10);
          };
          function ce(k10, z10) {
            if (z10)
              return k10.slice();
            var oe = k10.length, Se = i6 ? i6(oe) : new k10.constructor(oe);
            return k10.copy(Se), Se;
          }
          function Ie(k10) {
            var z10 = new k10.constructor(k10.byteLength);
            return new eE(z10).set(new eE(k10)), z10;
          }
          function Le(k10, z10) {
            var oe = z10 ? Ie(k10.buffer) : k10.buffer;
            return new k10.constructor(oe, k10.byteOffset, k10.byteLength);
          }
          function De(k10) {
            var z10 = new k10.constructor(k10.source, Mt.exec(k10));
            return z10.lastIndex = k10.lastIndex, z10;
          }
          function Ye(k10) {
            return S0 ? Ll(S0.call(k10)) : {};
          }
          function Ke(k10, z10) {
            var oe = z10 ? Ie(k10.buffer) : k10.buffer;
            return new k10.constructor(oe, k10.byteOffset, k10.length);
          }
          function pt(k10, z10) {
            if (k10 !== z10) {
              var oe = k10 !== t2, Se = k10 === null, Ge = k10 === k10, vt = sf(k10), Ht = z10 !== t2, Kt = z10 === null, xn = z10 === z10, Gr = sf(z10);
              if (!Kt && !Gr && !vt && k10 > z10 || vt && Ht && xn && !Kt && !Gr || Se && Ht && xn || !oe && xn || !Ge)
                return 1;
              if (!Se && !vt && !Gr && k10 < z10 || Gr && oe && Ge && !Se && !vt || Kt && oe && Ge || !Ht && Ge || !xn)
                return -1;
            }
            return 0;
          }
          function Bt(k10, z10, oe) {
            for (var Se = -1, Ge = k10.criteria, vt = z10.criteria, Ht = Ge.length, Kt = oe.length; ++Se < Ht; ) {
              var xn = pt(Ge[Se], vt[Se]);
              if (xn) {
                if (Se >= Kt)
                  return xn;
                var Gr = oe[Se];
                return xn * (Gr == "desc" ? -1 : 1);
              }
            }
            return k10.index - z10.index;
          }
          function qt(k10, z10, oe, Se) {
            for (var Ge = -1, vt = k10.length, Ht = oe.length, Kt = -1, xn = z10.length, Gr = Nf(vt - Ht, 0), Wr = ar(xn + Gr), Ur = !Se; ++Kt < xn; )
              Wr[Kt] = z10[Kt];
            for (; ++Ge < Ht; )
              (Ur || Ge < vt) && (Wr[oe[Ge]] = k10[Ge]);
            for (; Gr--; )
              Wr[Kt++] = k10[Ge++];
            return Wr;
          }
          function Yt(k10, z10, oe, Se) {
            for (var Ge = -1, vt = k10.length, Ht = -1, Kt = oe.length, xn = -1, Gr = z10.length, Wr = Nf(vt - Kt, 0), Ur = ar(Wr + Gr), Ba = !Se; ++Ge < Wr; )
              Ur[Ge] = k10[Ge];
            for (var vi = Ge; ++xn < Gr; )
              Ur[vi + xn] = z10[xn];
            for (; ++Ht < Kt; )
              (Ba || Ge < vt) && (Ur[vi + oe[Ht]] = k10[Ge++]);
            return Ur;
          }
          function nn(k10, z10) {
            var oe = -1, Se = k10.length;
            for (z10 || (z10 = ar(Se)); ++oe < Se; )
              z10[oe] = k10[oe];
            return z10;
          }
          function ln(k10, z10, oe, Se) {
            var Ge = !oe;
            oe || (oe = {});
            for (var vt = -1, Ht = z10.length; ++vt < Ht; ) {
              var Kt = z10[vt], xn = Se ? Se(oe[Kt], k10[Kt], Kt, oe, k10) : t2;
              xn === t2 && (xn = k10[Kt]), Ge ? w1(oe, Kt, xn) : lE(oe, Kt, xn);
            }
            return oe;
          }
          function yr(k10, z10) {
            return ln(k10, Xp(k10), z10);
          }
          function sr(k10, z10) {
            return ln(k10, kr(k10), z10);
          }
          function aa(k10, z10) {
            return function(oe, Se) {
              var Ge = Co(oe) ? $5 : Cee, vt = z10 ? z10() : {};
              return Ge(oe, k10, Ei(Se, 2), vt);
            };
          }
          function He(k10) {
            return _s(function(z10, oe) {
              var Se = -1, Ge = oe.length, vt = Ge > 1 ? oe[Ge - 1] : t2, Ht = Ge > 2 ? oe[2] : t2;
              for (vt = k10.length > 3 && typeof vt == "function" ? (Ge--, vt) : t2, Ht && Os(oe[0], oe[1], Ht) && (vt = Ge < 3 ? t2 : vt, Ge = 1), z10 = Ll(z10); ++Se < Ge; ) {
                var Kt = oe[Se];
                Kt && k10(z10, Kt, Se, vt);
              }
              return z10;
            });
          }
          function Cn(k10, z10) {
            return function(oe, Se) {
              if (oe == null)
                return oe;
              if (!an(oe))
                return k10(oe, Se);
              for (var Ge = oe.length, vt = z10 ? Ge : -1, Ht = Ll(oe); (z10 ? vt-- : ++vt < Ge) && Se(Ht[vt], vt, Ht) !== false; )
                ;
              return oe;
            };
          }
          function On(k10) {
            return function(z10, oe, Se) {
              for (var Ge = -1, vt = Ll(z10), Ht = Se(z10), Kt = Ht.length; Kt--; ) {
                var xn = Ht[k10 ? Kt : ++Ge];
                if (oe(vt[xn], xn, vt) === false)
                  break;
              }
              return z10;
            };
          }
          function dr(k10, z10, oe) {
            var Se = z10 & F, Ge = Nn(k10);
            function vt() {
              var Ht = this && this !== sh && this instanceof vt ? Ge : k10;
              return Ht.apply(Se ? oe : this, arguments);
            }
            return vt;
          }
          function ur(k10) {
            return function(z10) {
              z10 = El(z10);
              var oe = SS(z10) ? w0(z10) : t2, Se = oe ? oe[0] : z10.charAt(0), Ge = oe ? ee(oe, 1).join("") : z10.slice(1);
              return Se[k10]() + Ge;
            };
          }
          function An(k10) {
            return function(z10) {
              return U5(O1(eP(z10).replace(kB, "")), k10, "");
            };
          }
          function Nn(k10) {
            return function() {
              var z10 = arguments;
              switch (z10.length) {
                case 0:
                  return new k10();
                case 1:
                  return new k10(z10[0]);
                case 2:
                  return new k10(z10[0], z10[1]);
                case 3:
                  return new k10(z10[0], z10[1], z10[2]);
                case 4:
                  return new k10(z10[0], z10[1], z10[2], z10[3]);
                case 5:
                  return new k10(z10[0], z10[1], z10[2], z10[3], z10[4]);
                case 6:
                  return new k10(z10[0], z10[1], z10[2], z10[3], z10[4], z10[5]);
                case 7:
                  return new k10(z10[0], z10[1], z10[2], z10[3], z10[4], z10[5], z10[6]);
              }
              var oe = sw(k10.prototype), Se = k10.apply(oe, z10);
              return uu(Se) ? Se : oe;
            };
          }
          function Ar(k10, z10, oe) {
            var Se = Nn(k10);
            function Ge() {
              for (var vt = arguments.length, Ht = ar(vt), Kt = vt, xn = Sd(Ge); Kt--; )
                Ht[Kt] = arguments[Kt];
              var Gr = vt < 3 && Ht[0] !== xn && Ht[vt - 1] !== xn ? [] : y1(Ht, xn);
              if (vt -= Gr.length, vt < oe)
                return sa(k10, z10, Xa, Ge.placeholder, t2, Ht, Gr, t2, t2, oe - vt);
              var Wr = this && this !== sh && this instanceof Ge ? Se : k10;
              return Ov(Wr, this, Ht);
            }
            return Ge;
          }
          function Jr(k10) {
            return function(z10, oe, Se) {
              var Ge = Ll(z10);
              if (!an(z10)) {
                var vt = Ei(oe, 3);
                z10 = pc(z10), oe = function(Kt) {
                  return vt(Ge[Kt], Kt, Ge);
                };
              }
              var Ht = k10(z10, oe, Se);
              return Ht > -1 ? Ge[vt ? z10[Ht] : Ht] : t2;
            };
          }
          function bn(k10) {
            return tc(function(z10) {
              var oe = z10.length, Se = oe, Ge = up.prototype.thru;
              for (k10 && z10.reverse(); Se--; ) {
                var vt = z10[Se];
                if (typeof vt != "function")
                  throw new gg(d6);
                if (Ge && !Ht && ef(vt) == "wrapper")
                  var Ht = new up([], true);
              }
              for (Se = Ht ? Se : oe; ++Se < oe; ) {
                vt = z10[Se];
                var Kt = ef(vt), xn = Kt == "wrapper" ? fp(vt) : t2;
                xn && zf(xn[0]) && xn[1] == (pe | K | he | _e) && !xn[4].length && xn[9] == 1 ? Ht = Ht[ef(xn[0])].apply(Ht, xn[3]) : Ht = vt.length == 1 && zf(vt) ? Ht[Kt]() : Ht.thru(vt);
              }
              return function() {
                var Gr = arguments, Wr = Gr[0];
                if (Ht && Gr.length == 1 && Co(Wr))
                  return Ht.plant(Wr).value();
                for (var Ur = 0, Ba = oe ? z10[Ur].apply(this, Gr) : Wr; ++Ur < oe; )
                  Ba = z10[Ur].call(this, Ba);
                return Ba;
              };
            });
          }
          function Xa(k10, z10, oe, Se, Ge, vt, Ht, Kt, xn, Gr) {
            var Wr = z10 & pe, Ur = z10 & F, Ba = z10 & j, vi = z10 & (K | U), Ni = z10 & xe, $o = Ba ? t2 : Nn(k10);
            function Hi() {
              for (var Zi = arguments.length, No = ar(Zi), Wh = Zi; Wh--; )
                No[Wh] = arguments[Wh];
              if (vi)
                var dh = Sd(Hi), Y = K5(No, dh);
              if (Se && (No = qt(No, Se, Ge, vi)), vt && (No = Yt(No, vt, Ht, vi)), Zi -= Y, vi && Zi < Gr) {
                var ge = y1(No, dh);
                return sa(k10, z10, Xa, Hi.placeholder, oe, No, ge, Kt, xn, Gr - Zi);
              }
              var Q = Ur ? oe : this, ne = Ba ? Q[k10] : k10;
              return Zi = No.length, Kt ? No = I0(No, Kt) : Ni && Zi > 1 && No.reverse(), Wr && xn < Zi && (No.length = xn), this && this !== sh && this instanceof Hi && (ne = $o || Nn(ne)), ne.apply(Q, No);
            }
            return Hi;
          }
          function qa(k10, z10) {
            return function(oe, Se) {
              return ao(oe, k10, z10(Se), {});
            };
          }
          function ir(k10, z10) {
            return function(oe, Se) {
              var Ge;
              if (oe === t2 && Se === t2)
                return z10;
              if (oe !== t2 && (Ge = oe), Se !== t2) {
                if (Ge === t2)
                  return Se;
                typeof oe == "string" || typeof Se == "string" ? (oe = Fv(oe), Se = Fv(Se)) : (oe = M6(oe), Se = M6(Se)), Ge = k10(oe, Se);
              }
              return Ge;
            };
          }
          function Ai(k10) {
            return tc(function(z10) {
              return z10 = uc(z10, md(Ei())), _s(function(oe) {
                var Se = this;
                return k10(z10, function(Ge) {
                  return Ov(Ge, Se, oe);
                });
              });
            });
          }
          function gr(k10, z10) {
            z10 = z10 === t2 ? " " : Fv(z10);
            var oe = z10.length;
            if (oe < 2)
              return oe ? gk(z10, k10) : z10;
            var Se = gk(z10, ik(k10 / MS(z10)));
            return SS(z10) ? ee(w0(Se), 0, k10).join("") : Se.slice(0, k10);
          }
          function Qn(k10, z10, oe, Se) {
            var Ge = z10 & F, vt = Nn(k10);
            function Ht() {
              for (var Kt = -1, xn = arguments.length, Gr = -1, Wr = Se.length, Ur = ar(Wr + xn), Ba = this && this !== sh && this instanceof Ht ? vt : k10; ++Gr < Wr; )
                Ur[Gr] = Se[Gr];
              for (; xn--; )
                Ur[Gr++] = arguments[++Kt];
              return Ov(Ba, Ge ? oe : this, Ur);
            }
            return Ht;
          }
          function Yn(k10) {
            return function(z10, oe, Se) {
              return Se && typeof Se != "number" && Os(z10, oe, Se) && (oe = Se = t2), z10 = F0(z10), oe === t2 ? (oe = z10, z10 = 0) : oe = F0(oe), Se = Se === t2 ? z10 < oe ? 1 : -1 : F0(Se), Pee(z10, oe, Se, k10);
            };
          }
          function ya(k10) {
            return function(z10, oe) {
              return typeof z10 == "string" && typeof oe == "string" || (z10 = Id(z10), oe = Id(oe)), k10(z10, oe);
            };
          }
          function sa(k10, z10, oe, Se, Ge, vt, Ht, Kt, xn, Gr) {
            var Wr = z10 & K, Ur = Wr ? Ht : t2, Ba = Wr ? t2 : Ht, vi = Wr ? vt : t2, Ni = Wr ? t2 : vt;
            z10 |= Wr ? he : ue, z10 &= ~(Wr ? ue : he), z10 & $ || (z10 &= ~(F | j));
            var $o = [k10, z10, Ge, vi, Ur, Ni, Ba, Kt, xn, Gr], Hi = oe.apply(t2, $o);
            return zf(k10) && T0(Hi, $o), Hi.placeholder = Se, i_(Hi, k10, z10);
          }
          function Wi(k10) {
            var z10 = Qc[k10];
            return function(oe, Se) {
              if (oe = Id(oe), Se = Se == null ? 0 : bd(Ao(Se), 292), Se && ZB(oe)) {
                var Ge = (El(oe) + "e").split("e"), vt = z10(Ge[0] + "e" + (+Ge[1] + Se));
                return Ge = (El(vt) + "e").split("e"), +(Ge[0] + "e" + (+Ge[1] - Se));
              }
              return z10(oe);
            };
          }
          var xs = n_ && 1 / CS(new n_([, -0]))[1] == en ? function(k10) {
            return new n_(k10);
          } : Gi;
          function is(k10) {
            return function(z10) {
              var oe = kn(z10);
              return oe == Si ? n6(z10) : oe == ou ? $Q(z10) : Z5(z10, k10(z10));
            };
          }
          function io(k10, z10, oe, Se, Ge, vt, Ht, Kt) {
            var xn = z10 & j;
            if (!xn && typeof k10 != "function")
              throw new gg(d6);
            var Gr = Se ? Se.length : 0;
            if (Gr || (z10 &= ~(he | ue), Se = Ge = t2), Ht = Ht === t2 ? Ht : Nf(Ao(Ht), 0), Kt = Kt === t2 ? Kt : Ao(Kt), Gr -= Ge ? Ge.length : 0, z10 & ue) {
              var Wr = Se, Ur = Ge;
              Se = Ge = t2;
            }
            var Ba = xn ? t2 : fp(k10), vi = [k10, z10, oe, Se, Ge, Wr, Ur, vt, Ht, Kt];
            if (Ba && Cd(vi, Ba), k10 = vi[0], z10 = vi[1], oe = vi[2], Se = vi[3], Ge = vi[4], Kt = vi[9] = vi[9] === t2 ? xn ? 0 : k10.length : Nf(vi[9] - Gr, 0), !Kt && z10 & (K | U) && (z10 &= ~(K | U)), !z10 || z10 == F)
              var Ni = dr(k10, z10, oe);
            else
              z10 == K || z10 == U ? Ni = Ar(k10, z10, Kt) : (z10 == he || z10 == (F | he)) && !Ge.length ? Ni = Qn(k10, z10, oe, Se) : Ni = Xa.apply(t2, vi);
            var $o = Ba ? vj : T0;
            return i_($o(Ni, vi), k10, z10);
          }
          function Ol(k10, z10, oe, Se) {
            return k10 === t2 || Bh(k10, IS[oe]) && !Ql.call(Se, oe) ? z10 : k10;
          }
          function os(k10, z10, oe, Se, Ge, vt) {
            return uu(k10) && uu(z10) && (vt.set(z10, k10), a_(k10, z10, t2, os, vt), vt.delete(z10)), k10;
          }
          function rl(k10) {
            return nv(k10) ? t2 : k10;
          }
          function Cu(k10, z10, oe, Se, Ge, vt) {
            var Ht = oe & I, Kt = k10.length, xn = z10.length;
            if (Kt != xn && !(Ht && xn > Kt))
              return false;
            var Gr = vt.get(k10), Wr = vt.get(z10);
            if (Gr && Wr)
              return Gr == z10 && Wr == k10;
            var Ur = -1, Ba = true, vi = oe & R ? new x1() : t2;
            for (vt.set(k10, z10), vt.set(z10, k10); ++Ur < Kt; ) {
              var Ni = k10[Ur], $o = z10[Ur];
              if (Se)
                var Hi = Ht ? Se($o, Ni, Ur, z10, k10, vt) : Se(Ni, $o, Ur, k10, z10, vt);
              if (Hi !== t2) {
                if (Hi)
                  continue;
                Ba = false;
                break;
              }
              if (vi) {
                if (!Fc(z10, function(Zi, No) {
                  if (!Jb(vi, No) && (Ni === Zi || Ge(Ni, Zi, oe, Se, vt)))
                    return vi.push(No);
                })) {
                  Ba = false;
                  break;
                }
              } else if (!(Ni === $o || Ge(Ni, $o, oe, Se, vt))) {
                Ba = false;
                break;
              }
            }
            return vt.delete(k10), vt.delete(z10), Ba;
          }
          function wd(k10, z10, oe, Se, Ge, vt, Ht) {
            switch (oe) {
              case zr:
                if (k10.byteLength != z10.byteLength || k10.byteOffset != z10.byteOffset)
                  return false;
                k10 = k10.buffer, z10 = z10.buffer;
              case Wn:
                return !(k10.byteLength != z10.byteLength || !vt(new eE(k10), new eE(z10)));
              case pa:
              case Fa:
              case Ls:
                return Bh(+k10, +z10);
              case Sa:
                return k10.name == z10.name && k10.message == z10.message;
              case kh:
              case lc:
                return k10 == z10 + "";
              case Si:
                var Kt = n6;
              case ou:
                var xn = Se & I;
                if (Kt || (Kt = CS), k10.size != z10.size && !xn)
                  return false;
                var Gr = Ht.get(k10);
                if (Gr)
                  return Gr == z10;
                Se |= R, Ht.set(k10, z10);
                var Wr = Cu(Kt(k10), Kt(z10), Se, Ge, vt, Ht);
                return Ht.delete(k10), Wr;
              case Ku:
                if (S0)
                  return S0.call(k10) == S0.call(z10);
            }
            return false;
          }
          function cp(k10, z10, oe, Se, Ge, vt) {
            var Ht = oe & I, Kt = cc(k10), xn = Kt.length, Gr = cc(z10), Wr = Gr.length;
            if (xn != Wr && !Ht)
              return false;
            for (var Ur = xn; Ur--; ) {
              var Ba = Kt[Ur];
              if (!(Ht ? Ba in z10 : Ql.call(z10, Ba)))
                return false;
            }
            var vi = vt.get(k10), Ni = vt.get(z10);
            if (vi && Ni)
              return vi == z10 && Ni == k10;
            var $o = true;
            vt.set(k10, z10), vt.set(z10, k10);
            for (var Hi = Ht; ++Ur < xn; ) {
              Ba = Kt[Ur];
              var Zi = k10[Ba], No = z10[Ba];
              if (Se)
                var Wh = Ht ? Se(No, Zi, Ba, z10, k10, vt) : Se(Zi, No, Ba, k10, z10, vt);
              if (!(Wh === t2 ? Zi === No || Ge(Zi, No, oe, Se, vt) : Wh)) {
                $o = false;
                break;
              }
              Hi || (Hi = Ba == "constructor");
            }
            if ($o && !Hi) {
              var dh = k10.constructor, Y = z10.constructor;
              dh != Y && "constructor" in k10 && "constructor" in z10 && !(typeof dh == "function" && dh instanceof dh && typeof Y == "function" && Y instanceof Y) && ($o = false);
            }
            return vt.delete(k10), vt.delete(z10), $o;
          }
          function tc(k10) {
            return vw(Md(k10, t2, Eu), k10 + "");
          }
          function cc(k10) {
            return m62(k10, pc, Xp);
          }
          function uh(k10) {
            return m62(k10, nt, kr);
          }
          var fp = _d ? function(k10) {
            return _d.get(k10);
          } : Gi;
          function ef(k10) {
            for (var z10 = k10.name + "", oe = ow[z10], Se = Ql.call(ow, z10) ? oe.length : 0; Se--; ) {
              var Ge = oe[Se], vt = Ge.func;
              if (vt == null || vt == k10)
                return Ge.name;
            }
            return z10;
          }
          function Sd(k10) {
            var z10 = Ql.call(it, "placeholder") ? it : k10;
            return z10.placeholder;
          }
          function Ei() {
            var k10 = it.iteratee || vp;
            return k10 = k10 === vp ? hw : k10, arguments.length ? k10(arguments[0], arguments[1]) : k10;
          }
          function ch(k10, z10) {
            var oe = k10.__data__;
            return Vf(z10) ? oe[typeof z10 == "string" ? "string" : "hash"] : oe.map;
          }
          function nc(k10) {
            for (var z10 = pc(k10), oe = z10.length; oe--; ) {
              var Se = z10[oe], Ge = k10[Se];
              z10[oe] = [Se, Ge, hs(Ge)];
            }
            return z10;
          }
          function ju(k10, z10) {
            var oe = ek(k10, z10);
            return dE(oe) ? oe : t2;
          }
          function fc(k10) {
            var z10 = Ql.call(k10, mg), oe = k10[mg];
            try {
              k10[mg] = t2;
              var Se = true;
            } catch {
            }
            var Ge = QA.call(k10);
            return Se && (z10 ? k10[mg] = oe : delete k10[mg]), Ge;
          }
          var Xp = o6 ? function(k10) {
            return k10 == null ? [] : (k10 = Ll(k10), Xb(o6(k10), function(z10) {
              return rk.call(k10, z10);
            }));
          } : Sg, kr = o6 ? function(k10) {
            for (var z10 = []; k10; )
              Kb(z10, Xp(k10)), k10 = tE(k10);
            return z10;
          } : Sg, kn = xd;
          (rE && kn(new rE(new ArrayBuffer(1))) != zr || aE && kn(new aE()) != Si || aw && kn(aw.resolve()) != Of || n_ && kn(new n_()) != ou || iw && kn(new iw()) != Vr) && (kn = function(k10) {
            var z10 = xd(k10), oe = z10 == Hs ? k10.constructor : t2, Se = oe ? Xe(oe) : "";
            if (Se)
              switch (Se) {
                case KB:
                  return zr;
                case oee:
                  return Si;
                case JB:
                  return Of;
                case see:
                  return ou;
                case _f:
                  return Vr;
              }
            return z10;
          });
          function jn(k10, z10, oe) {
            for (var Se = -1, Ge = oe.length; ++Se < Ge; ) {
              var vt = oe[Se], Ht = vt.size;
              switch (vt.type) {
                case "drop":
                  k10 += Ht;
                  break;
                case "dropRight":
                  z10 -= Ht;
                  break;
                case "take":
                  z10 = bd(z10, k10 + Ht);
                  break;
                case "takeRight":
                  k10 = Nf(k10, z10 - Ht);
                  break;
              }
            }
            return { start: k10, end: z10 };
          }
          function Or(k10) {
            var z10 = k10.match(H4);
            return z10 ? z10[1].split($4) : [];
          }
          function Ea(k10, z10, oe) {
            z10 = ve(z10, k10);
            for (var Se = -1, Ge = z10.length, vt = false; ++Se < Ge; ) {
              var Ht = Rt(z10[Se]);
              if (!(vt = k10 != null && oe(k10, Ht)))
                break;
              k10 = k10[Ht];
            }
            return vt || ++Se != Ge ? vt : (Ge = k10 == null ? 0 : k10.length, !!Ge && tu(Ge) && qs(Ht, Ge) && (Co(k10) || Ad(k10)));
          }
          function pi(k10) {
            var z10 = k10.length, oe = new k10.constructor(z10);
            return z10 && typeof k10[0] == "string" && Ql.call(k10, "index") && (oe.index = k10.index, oe.input = k10.input), oe;
          }
          function To(k10) {
            return typeof k10.constructor == "function" && !su(k10) ? sw(tE(k10)) : {};
          }
          function Do(k10, z10, oe) {
            var Se = k10.constructor;
            switch (z10) {
              case Wn:
                return Ie(k10);
              case pa:
              case Fa:
                return new Se(+k10);
              case zr:
                return Le(k10, oe);
              case La:
              case _i:
              case Jo:
              case Wo:
              case wl:
              case Ju:
              case wu:
              case Kc:
              case Su:
                return Ke(k10, oe);
              case Si:
                return new Se();
              case Ls:
              case lc:
                return new Se(k10);
              case kh:
                return De(k10);
              case ou:
                return new Se();
              case Ku:
                return Ye(k10);
            }
          }
          function hl(k10, z10) {
            var oe = z10.length;
            if (!oe)
              return k10;
            var Se = oe - 1;
            return z10[Se] = (oe > 1 ? "& " : "") + z10[Se], z10 = z10.join(oe > 2 ? ", " : " "), k10.replace(W4, `{
/* [wrapped with ` + z10 + `] */
`);
          }
          function Mu(k10) {
            return Co(k10) || Ad(k10) || !!(YB && k10 && k10[YB]);
          }
          function qs(k10, z10) {
            var oe = typeof k10;
            return z10 = z10 == null ? bt : z10, !!z10 && (oe == "number" || oe != "symbol" && Mn.test(k10)) && k10 > -1 && k10 % 1 == 0 && k10 < z10;
          }
          function Os(k10, z10, oe) {
            if (!uu(oe))
              return false;
            var Se = typeof z10;
            return (Se == "number" ? an(oe) && qs(z10, oe.length) : Se == "string" && z10 in oe) ? Bh(oe[z10], k10) : false;
          }
          function Rl(k10, z10) {
            if (Co(k10))
              return false;
            var oe = typeof k10;
            return oe == "number" || oe == "symbol" || oe == "boolean" || k10 == null || sf(k10) ? true : Pv.test(k10) || !sp.test(k10) || z10 != null && k10 in Ll(z10);
          }
          function Vf(k10) {
            var z10 = typeof k10;
            return z10 == "string" || z10 == "number" || z10 == "symbol" || z10 == "boolean" ? k10 !== "__proto__" : k10 === null;
          }
          function zf(k10) {
            var z10 = ef(k10), oe = it[z10];
            if (typeof oe != "function" || !(z10 in Us.prototype))
              return false;
            if (k10 === oe)
              return true;
            var Se = fp(oe);
            return !!Se && k10 === Se[0];
          }
          function Kp(k10) {
            return !!$B && $B in k10;
          }
          var Fh = TS ? Gu : XE;
          function su(k10) {
            var z10 = k10 && k10.constructor, oe = typeof z10 == "function" && z10.prototype || IS;
            return k10 === oe;
          }
          function hs(k10) {
            return k10 === k10 && !uu(k10);
          }
          function Nc(k10, z10) {
            return function(oe) {
              return oe == null ? false : oe[k10] === z10 && (z10 !== t2 || k10 in Ll(oe));
            };
          }
          function Bf(k10) {
            var z10 = T1(k10, function(Se) {
              return oe.size === b6 && oe.clear(), Se;
            }), oe = z10.cache;
            return z10;
          }
          function Cd(k10, z10) {
            var oe = k10[1], Se = z10[1], Ge = oe | Se, vt = Ge < (F | j | pe), Ht = Se == pe && oe == K || Se == pe && oe == _e && k10[7].length <= z10[8] || Se == (pe | _e) && z10[7].length <= z10[8] && oe == K;
            if (!(vt || Ht))
              return k10;
            Se & F && (k10[2] = z10[2], Ge |= oe & F ? 0 : $);
            var Kt = z10[3];
            if (Kt) {
              var xn = k10[3];
              k10[3] = xn ? qt(xn, Kt, z10[4]) : Kt, k10[4] = xn ? y1(k10[3], x6) : z10[4];
            }
            return Kt = z10[5], Kt && (xn = k10[5], k10[5] = xn ? Yt(xn, Kt, z10[6]) : Kt, k10[6] = xn ? y1(k10[5], x6) : z10[6]), Kt = z10[7], Kt && (k10[7] = Kt), Se & pe && (k10[8] = k10[8] == null ? z10[8] : bd(k10[8], z10[8])), k10[9] == null && (k10[9] = z10[9]), k10[0] = z10[0], k10[1] = Ge, k10;
          }
          function Nh(k10) {
            var z10 = [];
            if (k10 != null)
              for (var oe in Ll(k10))
                z10.push(oe);
            return z10;
          }
          function Vh(k10) {
            return QA.call(k10);
          }
          function Md(k10, z10, oe) {
            return z10 = Nf(z10 === t2 ? k10.length - 1 : z10, 0), function() {
              for (var Se = arguments, Ge = -1, vt = Nf(Se.length - z10, 0), Ht = ar(vt); ++Ge < vt; )
                Ht[Ge] = Se[z10 + Ge];
              Ge = -1;
              for (var Kt = ar(z10 + 1); ++Ge < z10; )
                Kt[Ge] = Se[Ge];
              return Kt[z10] = oe(Ht), Ov(k10, this, Kt);
            };
          }
          function E0(k10, z10) {
            return z10.length < 2 ? k10 : cw(k10, _g(z10, 0, -1));
          }
          function I0(k10, z10) {
            for (var oe = k10.length, Se = bd(z10.length, oe), Ge = nn(k10); Se--; ) {
              var vt = z10[Se];
              k10[Se] = qs(vt, oe) ? Ge[vt] : t2;
            }
            return k10;
          }
          function pw(k10, z10) {
            if (!(z10 === "constructor" && typeof k10[z10] == "function") && z10 != "__proto__")
              return k10[z10];
          }
          var T0 = OS(vj), S1 = QQ || function(k10, z10) {
            return sh.setTimeout(k10, z10);
          }, vw = OS(gj);
          function i_(k10, z10, oe) {
            var Se = z10 + "";
            return vw(k10, hl(Se, Ct(Or(Se), oe)));
          }
          function OS(k10) {
            var z10 = 0, oe = 0;
            return function() {
              var Se = ree(), Ge = Fe - (Se - oe);
              if (oe = Se, Ge > 0) {
                if (++z10 >= je)
                  return arguments[0];
              } else
                z10 = 0;
              return k10.apply(t2, arguments);
            };
          }
          function xg(k10, z10) {
            var oe = -1, Se = k10.length, Ge = Se - 1;
            for (z10 = z10 === t2 ? Se : z10; ++oe < z10; ) {
              var vt = C6(oe, Ge), Ht = k10[vt];
              k10[vt] = k10[oe], k10[oe] = Ht;
            }
            return k10.length = z10, k10;
          }
          var St = Bf(function(k10) {
            var z10 = [];
            return k10.charCodeAt(0) === 46 && z10.push(""), k10.replace($m, function(oe, Se, Ge, vt) {
              z10.push(Ge ? vt.replace(Nt, "$1") : Se || oe);
            }), z10;
          });
          function Rt(k10) {
            if (typeof k10 == "string" || sf(k10))
              return k10;
            var z10 = k10 + "";
            return z10 == "0" && 1 / k10 == -en ? "-0" : z10;
          }
          function Xe(k10) {
            if (k10 != null) {
              try {
                return yd.call(k10);
              } catch {
              }
              try {
                return k10 + "";
              } catch {
              }
            }
            return "";
          }
          function Ct(k10, z10) {
            return Yp(Ma, function(oe) {
              var Se = "_." + oe[0];
              z10 & oe[1] && !rw(k10, Se) && k10.push(Se);
            }), k10.sort();
          }
          function Tt(k10) {
            if (k10 instanceof Us)
              return k10.clone();
            var z10 = new up(k10.__wrapped__, k10.__chain__);
            return z10.__actions__ = nn(k10.__actions__), z10.__index__ = k10.__index__, z10.__values__ = k10.__values__, z10;
          }
          function Ln(k10, z10, oe) {
            (oe ? Os(k10, z10, oe) : z10 === t2) ? z10 = 1 : z10 = Nf(Ao(z10), 0);
            var Se = k10 == null ? 0 : k10.length;
            if (!Se || z10 < 1)
              return [];
            for (var Ge = 0, vt = 0, Ht = ar(ik(Se / z10)); Ge < Se; )
              Ht[vt++] = _g(k10, Ge, Ge += z10);
            return Ht;
          }
          function Cr(k10) {
            for (var z10 = -1, oe = k10 == null ? 0 : k10.length, Se = 0, Ge = []; ++z10 < oe; ) {
              var vt = k10[z10];
              vt && (Ge[Se++] = vt);
            }
            return Ge;
          }
          function or() {
            var k10 = arguments.length;
            if (!k10)
              return [];
            for (var z10 = ar(k10 - 1), oe = arguments[0], Se = k10; Se--; )
              z10[Se - 1] = arguments[Se];
            return Kb(Co(oe) ? nn(oe) : [oe], Oh(z10, 1));
          }
          var cn = _s(function(k10, z10) {
            return er(k10) ? cE(k10, Oh(z10, 1, er, true)) : [];
          }), na = _s(function(k10, z10) {
            var oe = hc(z10);
            return er(oe) && (oe = t2), er(k10) ? cE(k10, Oh(z10, 1, er, true), Ei(oe, 2)) : [];
          }), ni = _s(function(k10, z10) {
            var oe = hc(z10);
            return er(oe) && (oe = t2), er(k10) ? cE(k10, Oh(z10, 1, er, true), t2, oe) : [];
          });
          function Ho(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            return Se ? (z10 = oe || z10 === t2 ? 1 : Ao(z10), _g(k10, z10 < 0 ? 0 : z10, Se)) : [];
          }
          function Fo(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            return Se ? (z10 = oe || z10 === t2 ? 1 : Ao(z10), z10 = Se - z10, _g(k10, 0, z10 < 0 ? 0 : z10)) : [];
          }
          function _o(k10, z10) {
            return k10 && k10.length ? _k(k10, Ei(z10, 3), true, true) : [];
          }
          function ji(k10, z10) {
            return k10 && k10.length ? _k(k10, Ei(z10, 3), true) : [];
          }
          function Cl(k10, z10, oe, Se) {
            var Ge = k10 == null ? 0 : k10.length;
            return Ge ? (oe && typeof oe != "number" && Os(k10, z10, oe) && (oe = 0, Se = Ge), v62(k10, z10, oe, Se)) : [];
          }
          function Au(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            if (!Se)
              return -1;
            var Ge = oe == null ? 0 : Ao(oe);
            return Ge < 0 && (Ge = Nf(Se + Ge, 0)), xS(k10, Ei(z10, 3), Ge);
          }
          function oo(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            if (!Se)
              return -1;
            var Ge = Se - 1;
            return oe !== t2 && (Ge = Ao(oe), Ge = oe < 0 ? Nf(Se + Ge, 0) : bd(Ge, Se - 1)), xS(k10, Ei(z10, 3), Ge, true);
          }
          function Eu(k10) {
            var z10 = k10 == null ? 0 : k10.length;
            return z10 ? Oh(k10, 1) : [];
          }
          function jf(k10) {
            var z10 = k10 == null ? 0 : k10.length;
            return z10 ? Oh(k10, en) : [];
          }
          function Nv(k10, z10) {
            var oe = k10 == null ? 0 : k10.length;
            return oe ? (z10 = z10 === t2 ? 1 : Ao(z10), Oh(k10, z10)) : [];
          }
          function Jm(k10) {
            for (var z10 = -1, oe = k10 == null ? 0 : k10.length, Se = {}; ++z10 < oe; ) {
              var Ge = k10[z10];
              Se[Ge[0]] = Ge[1];
            }
            return Se;
          }
          function Jp(k10) {
            return k10 && k10.length ? k10[0] : t2;
          }
          function C1(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            if (!Se)
              return -1;
            var Ge = oe == null ? 0 : Ao(oe);
            return Ge < 0 && (Ge = Nf(Se + Ge, 0)), m1(k10, z10, Ge);
          }
          function D0(k10) {
            var z10 = k10 == null ? 0 : k10.length;
            return z10 ? _g(k10, 0, -1) : [];
          }
          var tf = _s(function(k10) {
            var z10 = uc(k10, E6);
            return z10.length && z10[0] === k10[0] ? b62(z10) : [];
          }), Vv = _s(function(k10) {
            var z10 = hc(k10), oe = uc(k10, E6);
            return z10 === hc(oe) ? z10 = t2 : oe.pop(), oe.length && oe[0] === k10[0] ? b62(oe, Ei(z10, 2)) : [];
          }), nf = _s(function(k10) {
            var z10 = hc(k10), oe = uc(k10, E6);
            return z10 = typeof z10 == "function" ? z10 : t2, z10 && oe.pop(), oe.length && oe[0] === k10[0] ? b62(oe, t2, z10) : [];
          });
          function wg(k10, z10) {
            return k10 == null ? "" : tee.call(k10, z10);
          }
          function hc(k10) {
            var z10 = k10 == null ? 0 : k10.length;
            return z10 ? k10[z10 - 1] : t2;
          }
          function M1(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            if (!Se)
              return -1;
            var Ge = Se;
            return oe !== t2 && (Ge = Ao(oe), Ge = Ge < 0 ? Nf(Se + Ge, 0) : bd(Ge, Se - 1)), z10 === z10 ? qQ(k10, z10, Ge) : xS(k10, Y5, Ge, true);
          }
          function gw(k10, z10) {
            return k10 && k10.length ? w6(k10, Ao(z10)) : t2;
          }
          var hp = _s(k0);
          function k0(k10, z10) {
            return k10 && k10.length && z10 && z10.length ? vk(k10, z10) : k10;
          }
          function P0(k10, z10, oe) {
            return k10 && k10.length && z10 && z10.length ? vk(k10, z10, Ei(oe, 2)) : k10;
          }
          function xf(k10, z10, oe) {
            return k10 && k10.length && z10 && z10.length ? vk(k10, z10, t2, oe) : k10;
          }
          var mw = tc(function(k10, z10) {
            var oe = k10 == null ? 0 : k10.length, Se = sk(k10, z10);
            return dw(k10, uc(z10, function(Ge) {
              return qs(Ge, oe) ? +Ge : Ge;
            }).sort(pt)), Se;
          });
          function zv(k10, z10) {
            var oe = [];
            if (!(k10 && k10.length))
              return oe;
            var Se = -1, Ge = [], vt = k10.length;
            for (z10 = Ei(z10, 3); ++Se < vt; ) {
              var Ht = k10[Se];
              z10(Ht, Se, k10) && (oe.push(Ht), Ge.push(Se));
            }
            return dw(k10, Ge), oe;
          }
          function Qm(k10) {
            return k10 == null ? k10 : iee.call(k10);
          }
          function A1(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            return Se ? (oe && typeof oe != "number" && Os(k10, z10, oe) ? (z10 = 0, oe = Se) : (z10 = z10 == null ? 0 : Ao(z10), oe = oe === t2 ? Se : Ao(oe)), _g(k10, z10, oe)) : [];
          }
          function wk(k10, z10) {
            return yk(k10, z10);
          }
          function Sk(k10, z10, oe) {
            return bk(k10, z10, Ei(oe, 2));
          }
          function I6(k10, z10) {
            var oe = k10 == null ? 0 : k10.length;
            if (oe) {
              var Se = yk(k10, z10);
              if (Se < oe && Bh(k10[Se], z10))
                return Se;
            }
            return -1;
          }
          function vE(k10, z10) {
            return yk(k10, z10, true);
          }
          function gE(k10, z10, oe) {
            return bk(k10, z10, Ei(oe, 2), true);
          }
          function Ck(k10, z10) {
            var oe = k10 == null ? 0 : k10.length;
            if (oe) {
              var Se = yk(k10, z10, true) - 1;
              if (Bh(k10[Se], z10))
                return Se;
            }
            return -1;
          }
          function mE(k10) {
            return k10 && k10.length ? mj(k10) : [];
          }
          function RS(k10, z10) {
            return k10 && k10.length ? mj(k10, Ei(z10, 2)) : [];
          }
          function T6(k10) {
            var z10 = k10 == null ? 0 : k10.length;
            return z10 ? _g(k10, 1, z10) : [];
          }
          function Mk(k10, z10, oe) {
            return k10 && k10.length ? (z10 = oe || z10 === t2 ? 1 : Ao(z10), _g(k10, 0, z10 < 0 ? 0 : z10)) : [];
          }
          function yE(k10, z10, oe) {
            var Se = k10 == null ? 0 : k10.length;
            return Se ? (z10 = oe || z10 === t2 ? 1 : Ao(z10), z10 = Se - z10, _g(k10, z10 < 0 ? 0 : z10, Se)) : [];
          }
          function Ak(k10, z10) {
            return k10 && k10.length ? _k(k10, Ei(z10, 3), false, true) : [];
          }
          function bE(k10, z10) {
            return k10 && k10.length ? _k(k10, Ei(z10, 3)) : [];
          }
          var _E = _s(function(k10) {
            return Km(Oh(k10, 1, er, true));
          }), fh = _s(function(k10) {
            var z10 = hc(k10);
            return er(z10) && (z10 = t2), Km(Oh(k10, 1, er, true), Ei(z10, 2));
          }), yw = _s(function(k10) {
            var z10 = hc(k10);
            return z10 = typeof z10 == "function" ? z10 : t2, Km(Oh(k10, 1, er, true), t2, z10);
          });
          function Ek(k10) {
            return k10 && k10.length ? Km(k10) : [];
          }
          function D6(k10, z10) {
            return k10 && k10.length ? Km(k10, Ei(z10, 2)) : [];
          }
          function k6(k10, z10) {
            return z10 = typeof z10 == "function" ? z10 : t2, k10 && k10.length ? Km(k10, t2, z10) : [];
          }
          function Qp(k10) {
            if (!(k10 && k10.length))
              return [];
            var z10 = 0;
            return k10 = Xb(k10, function(oe) {
              if (er(oe))
                return z10 = Nf(oe.length, z10), true;
            }), ZA(z10, function(oe) {
              return uc(k10, UA(oe));
            });
          }
          function xE(k10, z10) {
            if (!(k10 && k10.length))
              return [];
            var oe = Qp(k10);
            return z10 == null ? oe : uc(oe, function(Se) {
              return Ov(z10, t2, Se);
            });
          }
          var Iu = _s(function(k10, z10) {
            return er(k10) ? cE(k10, z10) : [];
          }), eu = _s(function(k10) {
            return xk(Xb(k10, er));
          }), wE = _s(function(k10) {
            var z10 = hc(k10);
            return er(z10) && (z10 = t2), xk(Xb(k10, er), Ei(z10, 2));
          }), Ik = _s(function(k10) {
            var z10 = hc(k10);
            return z10 = typeof z10 == "function" ? z10 : t2, xk(Xb(k10, er), t2, z10);
          }), SE = _s(Qp);
          function P6(k10, z10) {
            return _j(k10 || [], z10 || [], lE);
          }
          function Tk(k10, z10) {
            return _j(k10 || [], z10 || [], pE);
          }
          var L6 = _s(function(k10) {
            var z10 = k10.length, oe = z10 > 1 ? k10[z10 - 1] : t2;
            return oe = typeof oe == "function" ? (k10.pop(), oe) : t2, xE(k10, oe);
          });
          function FS(k10) {
            var z10 = it(k10);
            return z10.__chain__ = true, z10;
          }
          function Dk(k10, z10) {
            return z10(k10), k10;
          }
          function dc(k10, z10) {
            return z10(k10);
          }
          var NS = tc(function(k10) {
            var z10 = k10.length, oe = z10 ? k10[0] : 0, Se = this.__wrapped__, Ge = function(vt) {
              return sk(vt, k10);
            };
            return z10 > 1 || this.__actions__.length || !(Se instanceof Us) || !qs(oe) ? this.thru(Ge) : (Se = Se.slice(oe, +oe + (z10 ? 1 : 0)), Se.__actions__.push({ func: dc, args: [Ge], thisArg: t2 }), new up(Se, this.__chain__).thru(function(vt) {
              return z10 && !vt.length && vt.push(t2), vt;
            }));
          });
          function ey() {
            return FS(this);
          }
          function kk() {
            return new up(this.value(), this.__chain__);
          }
          function CE() {
            this.__values__ === t2 && (this.__values__ = Uk(this.value()));
            var k10 = this.__index__ >= this.__values__.length, z10 = k10 ? t2 : this.__values__[this.__index__++];
            return { done: k10, value: z10 };
          }
          function ev() {
            return this;
          }
          function o_(k10) {
            for (var z10, oe = this; oe instanceof iE; ) {
              var Se = Tt(oe);
              Se.__index__ = 0, Se.__values__ = t2, z10 ? Ge.__wrapped__ = Se : z10 = Se;
              var Ge = Se;
              oe = oe.__wrapped__;
            }
            return Ge.__wrapped__ = k10, z10;
          }
          function Pk() {
            var k10 = this.__wrapped__;
            if (k10 instanceof Us) {
              var z10 = k10;
              return this.__actions__.length && (z10 = new Us(this)), z10 = z10.reverse(), z10.__actions__.push({ func: dc, args: [Qm], thisArg: t2 }), new up(z10, this.__chain__);
            }
            return this.thru(Qm);
          }
          function Lk() {
            return bj(this.__wrapped__, this.__actions__);
          }
          var bw = aa(function(k10, z10, oe) {
            Ql.call(k10, oe) ? ++k10[oe] : w1(k10, oe, 1);
          });
          function VS(k10, z10, oe) {
            var Se = Co(k10) ? GB : lj;
            return oe && Os(k10, z10, oe) && (z10 = t2), Se(k10, Ei(z10, 3));
          }
          function ME(k10, z10) {
            var oe = Co(k10) ? Xb : DS;
            return oe(k10, Ei(z10, 3));
          }
          var dp = Jr(Au), O6 = Jr(oo);
          function zh(k10, z10) {
            return Oh(ty(k10, z10), 1);
          }
          function R6(k10, z10) {
            return Oh(ty(k10, z10), en);
          }
          function Ok(k10, z10, oe) {
            return oe = oe === t2 ? 1 : Ao(oe), Oh(ty(k10, z10), oe);
          }
          function L0(k10, z10) {
            var oe = Co(k10) ? Yp : r_;
            return oe(k10, Ei(z10, 3));
          }
          function s_(k10, z10) {
            var oe = Co(k10) ? jB : sj;
            return oe(k10, Ei(z10, 3));
          }
          var AE = aa(function(k10, z10, oe) {
            Ql.call(k10, oe) ? k10[oe].push(z10) : w1(k10, oe, [z10]);
          });
          function ko(k10, z10, oe, Se) {
            k10 = an(k10) ? k10 : v_(k10), oe = oe && !Se ? Ao(oe) : 0;
            var Ge = k10.length;
            return oe < 0 && (oe = Nf(Ge + oe, 0)), Iw(k10) ? oe <= Ge && k10.indexOf(z10, oe) > -1 : !!Ge && m1(k10, z10, oe) > -1;
          }
          var tv = _s(function(k10, z10, oe) {
            var Se = -1, Ge = typeof z10 == "function", vt = an(k10) ? ar(k10.length) : [];
            return r_(k10, function(Ht) {
              vt[++Se] = Ge ? Ov(z10, Ht, oe) : kS(Ht, z10, oe);
            }), vt;
          }), zS = aa(function(k10, z10, oe) {
            w1(k10, oe, z10);
          });
          function ty(k10, z10) {
            var oe = Co(k10) ? uc : dj;
            return oe(k10, Ei(z10, 3));
          }
          function _w(k10, z10, oe, Se) {
            return k10 == null ? [] : (Co(z10) || (z10 = z10 == null ? [] : [z10]), oe = Se ? t2 : oe, Co(oe) || (oe = oe == null ? [] : [oe]), S6(k10, z10, oe));
          }
          var EE = aa(function(k10, z10, oe) {
            k10[oe ? 0 : 1].push(z10);
          }, function() {
            return [[], []];
          });
          function BS(k10, z10, oe) {
            var Se = Co(k10) ? U5 : Wl, Ge = arguments.length < 3;
            return Se(k10, Ei(z10, 4), oe, Ge, r_);
          }
          function F6(k10, z10, oe) {
            var Se = Co(k10) ? BQ : Wl, Ge = arguments.length < 3;
            return Se(k10, Ei(z10, 4), oe, Ge, sj);
          }
          function jS(k10, z10) {
            var oe = Co(k10) ? Xb : DS;
            return oe(k10, WS(Ei(z10, 3)));
          }
          function GS(k10) {
            var z10 = Co(k10) ? sE : mk;
            return z10(k10);
          }
          function ny(k10, z10, oe) {
            (oe ? Os(k10, z10, oe) : z10 === t2) ? z10 = 1 : z10 = Ao(z10);
            var Se = Co(k10) ? wee : Lee;
            return Se(k10, z10);
          }
          function IE(k10) {
            var z10 = Co(k10) ? See : Oee;
            return z10(k10);
          }
          function Ml(k10) {
            if (k10 == null)
              return 0;
            if (an(k10))
              return Iw(k10) ? MS(k10) : k10.length;
            var z10 = kn(k10);
            return z10 == Si || z10 == ou ? k10.size : LS(k10).length;
          }
          function rf(k10, z10, oe) {
            var Se = Co(k10) ? Fc : Ree;
            return oe && Os(k10, z10, oe) && (z10 = t2), Se(k10, Ei(z10, 3));
          }
          var xw = _s(function(k10, z10) {
            if (k10 == null)
              return [];
            var oe = z10.length;
            return oe > 1 && Os(k10, z10[0], z10[1]) ? z10 = [] : oe > 2 && Os(z10[0], z10[1], z10[2]) && (z10 = [z10[0]]), S6(k10, Oh(z10, 1), []);
          }), ry = nl || function() {
            return sh.Date.now();
          };
          function ww(k10, z10) {
            if (typeof z10 != "function")
              throw new gg(d6);
            return k10 = Ao(k10), function() {
              if (--k10 < 1)
                return z10.apply(this, arguments);
            };
          }
          function Sw(k10, z10, oe) {
            return z10 = oe ? t2 : z10, z10 = k10 && z10 == null ? k10.length : z10, io(k10, pe, t2, t2, t2, t2, z10);
          }
          function E1(k10, z10) {
            var oe;
            if (typeof z10 != "function")
              throw new gg(d6);
            return k10 = Ao(k10), function() {
              return --k10 > 0 && (oe = z10.apply(this, arguments)), k10 <= 1 && (z10 = t2), oe;
            };
          }
          var ay = _s(function(k10, z10, oe) {
            var Se = F;
            if (oe.length) {
              var Ge = y1(oe, Sd(ay));
              Se |= he;
            }
            return io(k10, Se, z10, oe, Ge);
          }), Cw = _s(function(k10, z10, oe) {
            var Se = F | j;
            if (oe.length) {
              var Ge = y1(oe, Sd(Cw));
              Se |= he;
            }
            return io(z10, Se, k10, oe, Ge);
          });
          function Mw(k10, z10, oe) {
            z10 = oe ? t2 : z10;
            var Se = io(k10, K, t2, t2, t2, t2, t2, z10);
            return Se.placeholder = Mw.placeholder, Se;
          }
          function Gf(k10, z10, oe) {
            z10 = oe ? t2 : z10;
            var Se = io(k10, U, t2, t2, t2, t2, t2, z10);
            return Se.placeholder = Gf.placeholder, Se;
          }
          function I1(k10, z10, oe) {
            var Se, Ge, vt, Ht, Kt, xn, Gr = 0, Wr = false, Ur = false, Ba = true;
            if (typeof k10 != "function")
              throw new gg(d6);
            z10 = Id(z10) || 0, uu(oe) && (Wr = !!oe.leading, Ur = "maxWait" in oe, vt = Ur ? Nf(Id(oe.maxWait) || 0, z10) : vt, Ba = "trailing" in oe ? !!oe.trailing : Ba);
            function vi(ge) {
              var Q = Se, ne = Ge;
              return Se = Ge = t2, Gr = ge, Ht = k10.apply(ne, Q), Ht;
            }
            function Ni(ge) {
              return Gr = ge, Kt = S1(Zi, z10), Wr ? vi(ge) : Ht;
            }
            function $o(ge) {
              var Q = ge - xn, ne = ge - Gr, re = z10 - Q;
              return Ur ? bd(re, vt - ne) : re;
            }
            function Hi(ge) {
              var Q = ge - xn, ne = ge - Gr;
              return xn === t2 || Q >= z10 || Q < 0 || Ur && ne >= vt;
            }
            function Zi() {
              var ge = ry();
              if (Hi(ge))
                return No(ge);
              Kt = S1(Zi, $o(ge));
            }
            function No(ge) {
              return Kt = t2, Ba && Se ? vi(ge) : (Se = Ge = t2, Ht);
            }
            function Wh() {
              Kt !== t2 && te(Kt), Gr = 0, Se = xn = Ge = Kt = t2;
            }
            function dh() {
              return Kt === t2 ? Ht : No(ry());
            }
            function Y() {
              var ge = ry(), Q = Hi(ge);
              if (Se = arguments, Ge = this, xn = ge, Q) {
                if (Kt === t2)
                  return Ni(xn);
                if (Ur)
                  return te(Kt), Kt = S1(Zi, z10), vi(xn);
              }
              return Kt === t2 && (Kt = S1(Zi, z10)), Ht;
            }
            return Y.cancel = Wh, Y.flush = dh, Y;
          }
          var iy = _s(function(k10, z10) {
            return oj(k10, 1, z10);
          }), Rk = _s(function(k10, z10, oe) {
            return oj(k10, Id(z10) || 0, oe);
          });
          function Aw(k10) {
            return io(k10, xe);
          }
          function T1(k10, z10) {
            if (typeof k10 != "function" || z10 != null && typeof z10 != "function")
              throw new gg(d6);
            var oe = function() {
              var Se = arguments, Ge = z10 ? z10.apply(this, Se) : Se[0], vt = oe.cache;
              if (vt.has(Ge))
                return vt.get(Ge);
              var Ht = k10.apply(this, Se);
              return oe.cache = vt.set(Ge, Ht) || vt, Ht;
            };
            return oe.cache = new (T1.Cache || M0)(), oe;
          }
          T1.Cache = M0;
          function WS(k10) {
            if (typeof k10 != "function")
              throw new gg(d6);
            return function() {
              var z10 = arguments;
              switch (z10.length) {
                case 0:
                  return !k10.call(this);
                case 1:
                  return !k10.call(this, z10[0]);
                case 2:
                  return !k10.call(this, z10[0], z10[1]);
                case 3:
                  return !k10.call(this, z10[0], z10[1], z10[2]);
              }
              return !k10.apply(this, z10);
            };
          }
          function N6(k10) {
            return E1(2, k10);
          }
          var V6 = J(function(k10, z10) {
            z10 = z10.length == 1 && Co(z10[0]) ? uc(z10[0], md(Ei())) : uc(Oh(z10, 1), md(Ei()));
            var oe = z10.length;
            return _s(function(Se) {
              for (var Ge = -1, vt = bd(Se.length, oe); ++Ge < vt; )
                Se[Ge] = z10[Ge].call(this, Se[Ge]);
              return Ov(k10, this, Se);
            });
          }), TE = _s(function(k10, z10) {
            var oe = y1(z10, Sd(TE));
            return io(k10, he, t2, z10, oe);
          }), af = _s(function(k10, z10) {
            var oe = y1(z10, Sd(af));
            return io(k10, ue, t2, z10, oe);
          }), Fk = tc(function(k10, z10) {
            return io(k10, _e, t2, t2, t2, z10);
          });
          function DE(k10, z10) {
            if (typeof k10 != "function")
              throw new gg(d6);
            return z10 = z10 === t2 ? z10 : Ao(z10), _s(k10, z10);
          }
          function kE(k10, z10) {
            if (typeof k10 != "function")
              throw new gg(d6);
            return z10 = z10 == null ? 0 : Nf(Ao(z10), 0), _s(function(oe) {
              var Se = oe[z10], Ge = ee(oe, 0, z10);
              return Se && Kb(Ge, Se), Ov(k10, this, Ge);
            });
          }
          function Nk(k10, z10, oe) {
            var Se = true, Ge = true;
            if (typeof k10 != "function")
              throw new gg(d6);
            return uu(oe) && (Se = "leading" in oe ? !!oe.leading : Se, Ge = "trailing" in oe ? !!oe.trailing : Ge), I1(k10, z10, { leading: Se, maxWait: z10, trailing: Ge });
          }
          function oy(k10) {
            return Sw(k10, 1);
          }
          function HS(k10, z10) {
            return TE(Z(z10), k10);
          }
          function z6() {
            if (!arguments.length)
              return [];
            var k10 = arguments[0];
            return Co(k10) ? k10 : [k10];
          }
          function Vk(k10) {
            return bg(k10, A6);
          }
          function B6(k10, z10) {
            return z10 = typeof z10 == "function" ? z10 : t2, bg(k10, A6, z10);
          }
          function Qo(k10) {
            return bg(k10, S | A6);
          }
          function hh(k10, z10) {
            return z10 = typeof z10 == "function" ? z10 : t2, bg(k10, S | A6, z10);
          }
          function lu(k10, z10) {
            return z10 == null || ij(k10, z10, pc(z10));
          }
          function Bh(k10, z10) {
            return k10 === z10 || k10 !== k10 && z10 !== z10;
          }
          var PE = ya(ck), zk = ya(function(k10, z10) {
            return k10 >= z10;
          }), Ad = fj(function() {
            return arguments;
          }()) ? fj : function(k10) {
            return cu(k10) && Ql.call(k10, "callee") && !rk.call(k10, "callee");
          }, Co = ar.isArray, O0 = e6 ? md(e6) : Mee;
          function an(k10) {
            return k10 != null && tu(k10.length) && !Gu(k10);
          }
          function er(k10) {
            return cu(k10) && an(k10);
          }
          function tr(k10) {
            return k10 === true || k10 === false || cu(k10) && xd(k10) == pa;
          }
          var Va = eee || XE, Mo = NB ? md(NB) : Aee;
          function al(k10) {
            return cu(k10) && k10.nodeType === 1 && !nv(k10);
          }
          function of(k10) {
            if (k10 == null)
              return true;
            if (an(k10) && (Co(k10) || typeof k10 == "string" || typeof k10.splice == "function" || Va(k10) || R0(k10) || Ad(k10)))
              return !k10.length;
            var z10 = kn(k10);
            if (z10 == Si || z10 == ou)
              return !k10.size;
            if (su(k10))
              return !LS(k10).length;
            for (var oe in k10)
              if (Ql.call(k10, oe))
                return false;
            return true;
          }
          function Fl(k10, z10) {
            return PS(k10, z10);
          }
          function LE(k10, z10, oe) {
            oe = typeof oe == "function" ? oe : t2;
            var Se = oe ? oe(k10, z10) : t2;
            return Se === t2 ? PS(k10, z10, t2, oe) : !!Se;
          }
          function OE(k10) {
            if (!cu(k10))
              return false;
            var z10 = xd(k10);
            return z10 == Sa || z10 == Ha || typeof k10.message == "string" && typeof k10.name == "string" && !nv(k10);
          }
          function Ed(k10) {
            return typeof k10 == "number" && ZB(k10);
          }
          function Gu(k10) {
            if (!uu(k10))
              return false;
            var z10 = xd(k10);
            return z10 == oi || z10 == bs || z10 == Ga || z10 == Xu;
          }
          function Bk(k10) {
            return typeof k10 == "number" && k10 == Ao(k10);
          }
          function tu(k10) {
            return typeof k10 == "number" && k10 > -1 && k10 % 1 == 0 && k10 <= bt;
          }
          function uu(k10) {
            var z10 = typeof k10;
            return k10 != null && (z10 == "object" || z10 == "function");
          }
          function cu(k10) {
            return k10 != null && typeof k10 == "object";
          }
          var Al = VB ? md(VB) : fw;
          function jk(k10, z10) {
            return k10 === z10 || hE(k10, z10, nc(z10));
          }
          function Gk(k10, z10, oe) {
            return oe = typeof oe == "function" ? oe : t2, hE(k10, z10, nc(z10), oe);
          }
          function $S(k10) {
            return l_(k10) && k10 != +k10;
          }
          function j6(k10) {
            if (Fh(k10))
              throw new ro(f6);
            return dE(k10);
          }
          function Wk(k10) {
            return k10 === null;
          }
          function Hk(k10) {
            return k10 == null;
          }
          function l_(k10) {
            return typeof k10 == "number" || cu(k10) && xd(k10) == Ls;
          }
          function nv(k10) {
            if (!cu(k10) || xd(k10) != Hs)
              return false;
            var z10 = tE(k10);
            if (z10 === null)
              return true;
            var oe = Ql.call(z10, "constructor") && z10.constructor;
            return typeof oe == "function" && oe instanceof oe && yd.call(oe) == XQ;
          }
          var sy = zB ? md(zB) : Eee;
          function u_(k10) {
            return Bk(k10) && k10 >= -bt && k10 <= bt;
          }
          var Ew = _S ? md(_S) : hj;
          function Iw(k10) {
            return typeof k10 == "string" || !Co(k10) && cu(k10) && xd(k10) == lc;
          }
          function sf(k10) {
            return typeof k10 == "symbol" || cu(k10) && xd(k10) == Ku;
          }
          var R0 = BB ? md(BB) : Iee;
          function $k(k10) {
            return k10 === t2;
          }
          function es(k10) {
            return cu(k10) && kn(k10) == Vr;
          }
          function D1(k10) {
            return cu(k10) && xd(k10) == Un;
          }
          var US = ya(dk), G6 = ya(function(k10, z10) {
            return k10 <= z10;
          });
          function Uk(k10) {
            if (!k10)
              return [];
            if (an(k10))
              return Iw(k10) ? w0(k10) : nn(k10);
            if (nE && k10[nE])
              return HQ(k10[nE]());
            var z10 = kn(k10), oe = z10 == Si ? n6 : z10 == ou ? CS : v_;
            return oe(k10);
          }
          function F0(k10) {
            if (!k10)
              return k10 === 0 ? k10 : 0;
            if (k10 = Id(k10), k10 === en || k10 === -en) {
              var z10 = k10 < 0 ? -1 : 1;
              return z10 * wt;
            }
            return k10 === k10 ? k10 : 0;
          }
          function Ao(k10) {
            var z10 = F0(k10), oe = z10 % 1;
            return z10 === z10 ? oe ? z10 - oe : z10 : 0;
          }
          function Tw(k10) {
            return k10 ? uw(Ao(k10), 0, fn) : 0;
          }
          function Id(k10) {
            if (typeof k10 == "number")
              return k10;
            if (sf(k10))
              return Ft;
            if (uu(k10)) {
              var z10 = typeof k10.valueOf == "function" ? k10.valueOf() : k10;
              k10 = uu(z10) ? z10 + "" : z10;
            }
            if (typeof k10 != "string")
              return k10 === 0 ? k10 : +k10;
            k10 = XA(k10);
            var oe = Rn.test(k10);
            return oe || lr.test(k10) ? FB(k10.slice(2), oe ? 2 : 8) : _t.test(k10) ? Ft : +k10;
          }
          function qk(k10) {
            return ln(k10, nt(k10));
          }
          function Yk(k10) {
            return k10 ? uw(Ao(k10), -bt, bt) : k10 === 0 ? k10 : 0;
          }
          function El(k10) {
            return k10 == null ? "" : Fv(k10);
          }
          var W6 = He(function(k10, z10) {
            if (su(z10) || an(z10)) {
              ln(z10, pc(z10), k10);
              return;
            }
            for (var oe in z10)
              Ql.call(z10, oe) && lE(k10, oe, z10[oe]);
          }), Vc = He(function(k10, z10) {
            ln(z10, nt(z10), k10);
          }), lf = He(function(k10, z10, oe, Se) {
            ln(z10, nt(z10), k10, Se);
          }), RE = He(function(k10, z10, oe, Se) {
            ln(z10, pc(z10), k10, Se);
          }), H6 = tc(sk);
          function c_(k10, z10) {
            var oe = sw(k10);
            return z10 == null ? oe : d62(oe, z10);
          }
          var FE = _s(function(k10, z10) {
            k10 = Ll(k10);
            var oe = -1, Se = z10.length, Ge = Se > 2 ? z10[2] : t2;
            for (Ge && Os(z10[0], z10[1], Ge) && (Se = 1); ++oe < Se; )
              for (var vt = z10[oe], Ht = nt(vt), Kt = -1, xn = Ht.length; ++Kt < xn; ) {
                var Gr = Ht[Kt], Wr = k10[Gr];
                (Wr === t2 || Bh(Wr, IS[Gr]) && !Ql.call(k10, Gr)) && (k10[Gr] = vt[Gr]);
              }
            return k10;
          }), Dw = _s(function(k10) {
            return k10.push(t2, os), Ov(ws, t2, k10);
          });
          function N0(k10, z10) {
            return q5(k10, Ei(z10, 3), Rh);
          }
          function jh(k10, z10) {
            return q5(k10, Ei(z10, 3), lk);
          }
          function k1(k10, z10) {
            return k10 == null ? k10 : g6(k10, Ei(z10, 3), nt);
          }
          function f_(k10, z10) {
            return k10 == null ? k10 : uj(k10, Ei(z10, 3), nt);
          }
          function kw(k10, z10) {
            return k10 && Rh(k10, Ei(z10, 3));
          }
          function Pw(k10, z10) {
            return k10 && lk(k10, Ei(z10, 3));
          }
          function h_(k10) {
            return k10 == null ? [] : uk(k10, pc(k10));
          }
          function zc(k10) {
            return k10 == null ? [] : uk(k10, nt(k10));
          }
          function ly(k10, z10, oe) {
            var Se = k10 == null ? t2 : cw(k10, z10);
            return Se === t2 ? oe : Se;
          }
          function P1(k10, z10) {
            return k10 != null && Ea(k10, z10, y6);
          }
          function qS(k10, z10) {
            return k10 != null && Ea(k10, z10, cj);
          }
          var Lw = qa(function(k10, z10, oe) {
            z10 != null && typeof z10.toString != "function" && (z10 = QA.call(z10)), k10[z10] = oe;
          }, HE(Gh)), Ow = qa(function(k10, z10, oe) {
            z10 != null && typeof z10.toString != "function" && (z10 = QA.call(z10)), Ql.call(k10, z10) ? k10[z10].push(oe) : k10[z10] = [oe];
          }, Ei), d_ = _s(kS);
          function pc(k10) {
            return an(k10) ? aj(k10) : LS(k10);
          }
          function nt(k10) {
            return an(k10) ? aj(k10, true) : _6(k10);
          }
          function p_(k10, z10) {
            var oe = {};
            return z10 = Ei(z10, 3), Rh(k10, function(Se, Ge, vt) {
              w1(oe, z10(Se, Ge, vt), Se);
            }), oe;
          }
          function YS(k10, z10) {
            var oe = {};
            return z10 = Ei(z10, 3), Rh(k10, function(Se, Ge, vt) {
              w1(oe, Ge, z10(Se, Ge, vt));
            }), oe;
          }
          var pp = He(function(k10, z10, oe) {
            a_(k10, z10, oe);
          }), ws = He(function(k10, z10, oe, Se) {
            a_(k10, z10, oe, Se);
          }), $6 = tc(function(k10, z10) {
            var oe = {};
            if (k10 == null)
              return oe;
            var Se = false;
            z10 = uc(z10, function(vt) {
              return vt = ve(vt, k10), Se || (Se = vt.length > 1), vt;
            }), ln(k10, uh(k10), oe), Se && (oe = bg(oe, S | M | A6, rl));
            for (var Ge = z10.length; Ge--; )
              A62(oe, z10[Ge]);
            return oe;
          });
          function NE(k10, z10) {
            return uy(k10, WS(Ei(z10)));
          }
          var VE = tc(function(k10, z10) {
            return k10 == null ? {} : Dee(k10, z10);
          });
          function uy(k10, z10) {
            if (k10 == null)
              return {};
            var oe = uc(uh(k10), function(Se) {
              return [Se];
            });
            return z10 = Ei(z10), pj(k10, oe, function(Se, Ge) {
              return z10(Se, Ge[0]);
            });
          }
          function U6(k10, z10, oe) {
            z10 = ve(z10, k10);
            var Se = -1, Ge = z10.length;
            for (Ge || (Ge = 1, k10 = t2); ++Se < Ge; ) {
              var vt = k10 == null ? t2 : k10[Rt(z10[Se])];
              vt === t2 && (Se = Ge, vt = oe), k10 = Gu(vt) ? vt.call(k10) : vt;
            }
            return k10;
          }
          function zE(k10, z10, oe) {
            return k10 == null ? k10 : pE(k10, z10, oe);
          }
          function q6(k10, z10, oe, Se) {
            return Se = typeof Se == "function" ? Se : t2, k10 == null ? k10 : pE(k10, z10, oe, Se);
          }
          var ZS = is(pc), Zk = is(nt);
          function Bc(k10, z10, oe) {
            var Se = Co(k10), Ge = Se || Va(k10) || R0(k10);
            if (z10 = Ei(z10, 4), oe == null) {
              var vt = k10 && k10.constructor;
              Ge ? oe = Se ? new vt() : [] : uu(k10) ? oe = Gu(vt) ? sw(tE(k10)) : {} : oe = {};
            }
            return (Ge ? Yp : Rh)(k10, function(Ht, Kt, xn) {
              return z10(oe, Ht, Kt, xn);
            }), oe;
          }
          function Xk(k10, z10) {
            return k10 == null ? true : A62(k10, z10);
          }
          function BE(k10, z10, oe) {
            return k10 == null ? k10 : yj(k10, z10, Z(oe));
          }
          function Kk(k10, z10, oe, Se) {
            return Se = typeof Se == "function" ? Se : t2, k10 == null ? k10 : yj(k10, z10, Z(oe), Se);
          }
          function v_(k10) {
            return k10 == null ? [] : wS(k10, pc(k10));
          }
          function Y6(k10) {
            return k10 == null ? [] : wS(k10, nt(k10));
          }
          function V0(k10, z10, oe) {
            return oe === t2 && (oe = z10, z10 = t2), oe !== t2 && (oe = Id(oe), oe = oe === oe ? oe : 0), z10 !== t2 && (z10 = Id(z10), z10 = z10 === z10 ? z10 : 0), uw(Id(k10), z10, oe);
          }
          function Jk(k10, z10, oe) {
            return z10 = F0(z10), oe === t2 ? (oe = z10, z10 = 0) : oe = F0(oe), k10 = Id(k10), fk(k10, z10, oe);
          }
          function jE(k10, z10, oe) {
            if (oe && typeof oe != "boolean" && Os(k10, z10, oe) && (z10 = oe = t2), oe === t2 && (typeof z10 == "boolean" ? (oe = z10, z10 = t2) : typeof k10 == "boolean" && (oe = k10, k10 = t2)), k10 === t2 && z10 === t2 ? (k10 = 0, z10 = 1) : (k10 = F0(k10), z10 === t2 ? (z10 = k10, k10 = 0) : z10 = F0(z10)), k10 > z10) {
              var Se = k10;
              k10 = z10, z10 = Se;
            }
            if (oe || k10 % 1 || z10 % 1) {
              var Ge = XB();
              return bd(k10 + Ge * (z10 - k10 + K4("1e-" + ((Ge + "").length - 1))), z10);
            }
            return C6(k10, z10);
          }
          var Rw = An(function(k10, z10, oe) {
            return z10 = z10.toLowerCase(), k10 + (oe ? Qk(z10) : z10);
          });
          function Qk(k10) {
            return Fw(El(k10).toLowerCase());
          }
          function eP(k10) {
            return k10 = El(k10), k10 && k10.replace(ta, J5).replace(PB, "");
          }
          function cy(k10, z10, oe) {
            k10 = El(k10), z10 = Fv(z10);
            var Se = k10.length;
            oe = oe === t2 ? Se : uw(Ao(oe), 0, Se);
            var Ge = oe;
            return oe -= z10.length, oe >= 0 && k10.slice(oe, Ge) == z10;
          }
          function GE(k10) {
            return k10 = El(k10), k10 && Rf.test(k10) ? k10.replace(Ac, GQ) : k10;
          }
          function Z6(k10) {
            return k10 = El(k10), k10 && j4.test(k10) ? k10.replace(Um, "\\$&") : k10;
          }
          var Bv = An(function(k10, z10, oe) {
            return k10 + (oe ? "-" : "") + z10.toLowerCase();
          }), X6 = An(function(k10, z10, oe) {
            return k10 + (oe ? " " : "") + z10.toLowerCase();
          }), K6 = ur("toLowerCase");
          function XS(k10, z10, oe) {
            k10 = El(k10), z10 = Ao(z10);
            var Se = z10 ? MS(k10) : 0;
            if (!z10 || Se >= z10)
              return k10;
            var Ge = (z10 - Se) / 2;
            return gr(ok(Ge), oe) + k10 + gr(ik(Ge), oe);
          }
          function J6(k10, z10, oe) {
            k10 = El(k10), z10 = Ao(z10);
            var Se = z10 ? MS(k10) : 0;
            return z10 && Se < z10 ? k10 + gr(z10 - Se, oe) : k10;
          }
          function Q6(k10, z10, oe) {
            k10 = El(k10), z10 = Ao(z10);
            var Se = z10 ? MS(k10) : 0;
            return z10 && Se < z10 ? gr(z10 - Se, oe) + k10 : k10;
          }
          function tP(k10, z10, oe) {
            return oe || z10 == null ? z10 = 0 : z10 && (z10 = +z10), aee(El(k10).replace(Ub, ""), z10 || 0);
          }
          function nP(k10, z10, oe) {
            return (oe ? Os(k10, z10, oe) : z10 === t2) ? z10 = 1 : z10 = Ao(z10), gk(El(k10), z10);
          }
          function rP() {
            var k10 = arguments, z10 = El(k10[0]);
            return k10.length < 3 ? z10 : z10.replace(k10[1], k10[2]);
          }
          var eF = An(function(k10, z10, oe) {
            return k10 + (oe ? "_" : "") + z10.toLowerCase();
          });
          function KS(k10, z10, oe) {
            return oe && typeof oe != "number" && Os(k10, z10, oe) && (z10 = oe = t2), oe = oe === t2 ? fn : oe >>> 0, oe ? (k10 = El(k10), k10 && (typeof z10 == "string" || z10 != null && !sy(z10)) && (z10 = Fv(z10), !z10 && SS(k10)) ? ee(w0(k10), 0, oe) : k10.split(z10, oe)) : [];
          }
          var Wf = An(function(k10, z10, oe) {
            return k10 + (oe ? " " : "") + Fw(z10);
          });
          function JS(k10, z10, oe) {
            return k10 = El(k10), oe = oe == null ? 0 : uw(Ao(oe), 0, k10.length), z10 = Fv(z10), k10.slice(oe, oe + z10.length) == z10;
          }
          function aP(k10, z10, oe) {
            var Se = it.templateSettings;
            oe && Os(k10, z10, oe) && (z10 = t2), k10 = El(k10), z10 = lf({}, z10, Se, Ol);
            var Ge = lf({}, z10.imports, Se.imports, Ol), vt = pc(Ge), Ht = wS(Ge, vt), Kt, xn, Gr = 0, Wr = z10.interpolate || di, Ur = "__p += '", Ba = a6((z10.escape || di).source + "|" + Wr.source + "|" + (Wr === Up ? ct : di).source + "|" + (z10.evaluate || di).source + "|$", "g"), vi = "//# sourceURL=" + (Ql.call(z10, "sourceURL") ? (z10.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++LB + "]") + `
`;
            k10.replace(Ba, function(Hi, Zi, No, Wh, dh, Y) {
              return No || (No = Wh), Ur += k10.slice(Gr, Y).replace(as, Q5), Zi && (Kt = true, Ur += `' +
__e(` + Zi + `) +
'`), dh && (xn = true, Ur += `';
` + dh + `;
__p += '`), No && (Ur += `' +
((__t = (` + No + `)) == null ? '' : __t) +
'`), Gr = Y + Hi.length, Hi;
            }), Ur += `';
`;
            var Ni = Ql.call(z10, "variable") && z10.variable;
            if (!Ni)
              Ur = `with (obj) {
` + Ur + `
}
`;
            else if (Ot.test(Ni))
              throw new ro(v6);
            Ur = (xn ? Ur.replace(pd, "") : Ur).replace(ip, "$1").replace(kv, "$1;"), Ur = "function(" + (Ni || "obj") + `) {
` + (Ni ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Kt ? ", __e = _.escape" : "") + (xn ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Ur + `return __p
}`;
            var $o = Gv(function() {
              return Pl(vt, vi + "return " + Ur).apply(t2, Ht);
            });
            if ($o.source = Ur, OE($o))
              throw $o;
            return $o;
          }
          function iP(k10) {
            return El(k10).toLowerCase();
          }
          function tF(k10) {
            return El(k10).toUpperCase();
          }
          function jv(k10, z10, oe) {
            if (k10 = El(k10), k10 && (oe || z10 === t2))
              return XA(k10);
            if (!k10 || !(z10 = Fv(z10)))
              return k10;
            var Se = w0(k10), Ge = w0(z10), vt = X5(Se, Ge), Ht = KA(Se, Ge) + 1;
            return ee(Se, vt, Ht).join("");
          }
          function WE(k10, z10, oe) {
            if (k10 = El(k10), k10 && (oe || z10 === t2))
              return k10.slice(0, r62(k10) + 1);
            if (!k10 || !(z10 = Fv(z10)))
              return k10;
            var Se = w0(k10), Ge = KA(Se, w0(z10)) + 1;
            return ee(Se, 0, Ge).join("");
          }
          function L1(k10, z10, oe) {
            if (k10 = El(k10), k10 && (oe || z10 === t2))
              return k10.replace(Ub, "");
            if (!k10 || !(z10 = Fv(z10)))
              return k10;
            var Se = w0(k10), Ge = X5(Se, w0(z10));
            return ee(Se, Ge).join("");
          }
          function rv(k10, z10) {
            var oe = Ae, Se = ke;
            if (uu(z10)) {
              var Ge = "separator" in z10 ? z10.separator : Ge;
              oe = "length" in z10 ? Ao(z10.length) : oe, Se = "omission" in z10 ? Fv(z10.omission) : Se;
            }
            k10 = El(k10);
            var vt = k10.length;
            if (SS(k10)) {
              var Ht = w0(k10);
              vt = Ht.length;
            }
            if (oe >= vt)
              return k10;
            var Kt = oe - MS(Se);
            if (Kt < 1)
              return Se;
            var xn = Ht ? ee(Ht, 0, Kt).join("") : k10.slice(0, Kt);
            if (Ge === t2)
              return xn + Se;
            if (Ht && (Kt += xn.length - Kt), sy(Ge)) {
              if (k10.slice(Kt).search(Ge)) {
                var Gr, Wr = xn;
                for (Ge.global || (Ge = a6(Ge.source, El(Mt.exec(Ge)) + "g")), Ge.lastIndex = 0; Gr = Ge.exec(Wr); )
                  var Ur = Gr.index;
                xn = xn.slice(0, Ur === t2 ? Kt : Ur);
              }
            } else if (k10.indexOf(Fv(Ge), Kt) != Kt) {
              var Ba = xn.lastIndexOf(Ge);
              Ba > -1 && (xn = xn.slice(0, Ba));
            }
            return xn + Se;
          }
          function nF(k10) {
            return k10 = El(k10), k10 && $s.test(k10) ? k10.replace(op, YQ) : k10;
          }
          var oP = An(function(k10, z10, oe) {
            return k10 + (oe ? " " : "") + z10.toUpperCase();
          }), Fw = ur("toUpperCase");
          function O1(k10, z10, oe) {
            return k10 = El(k10), z10 = oe ? t2 : z10, z10 === t2 ? WQ(k10) ? ec(k10) : $A(k10) : k10.match(z10) || [];
          }
          var Gv = _s(function(k10, z10) {
            try {
              return Ov(k10, t2, z10);
            } catch (oe) {
              return OE(oe) ? oe : new ro(oe);
            }
          }), g_ = tc(function(k10, z10) {
            return Yp(z10, function(oe) {
              oe = Rt(oe), w1(k10, oe, ay(k10[oe], k10));
            }), k10;
          });
          function rF(k10) {
            var z10 = k10 == null ? 0 : k10.length, oe = Ei();
            return k10 = z10 ? uc(k10, function(Se) {
              if (typeof Se[1] != "function")
                throw new gg(d6);
              return [oe(Se[0]), Se[1]];
            }) : [], _s(function(Se) {
              for (var Ge = -1; ++Ge < z10; ) {
                var vt = k10[Ge];
                if (Ov(vt[0], this, Se))
                  return Ov(vt[1], this, Se);
              }
            });
          }
          function QS(k10) {
            return p6(bg(k10, S));
          }
          function HE(k10) {
            return function() {
              return k10;
            };
          }
          function z0(k10, z10) {
            return k10 == null || k10 !== k10 ? z10 : k10;
          }
          var wf = bn(), $E = bn(true);
          function Gh(k10) {
            return k10;
          }
          function vp(k10) {
            return hw(typeof k10 == "function" ? k10 : bg(k10, S));
          }
          function eC(k10) {
            return x62(bg(k10, S));
          }
          function Nw(k10, z10) {
            return pk(k10, bg(z10, S));
          }
          var B0 = _s(function(k10, z10) {
            return function(oe) {
              return kS(oe, k10, z10);
            };
          }), UE = _s(function(k10, z10) {
            return function(oe) {
              return kS(k10, oe, z10);
            };
          });
          function jc(k10, z10, oe) {
            var Se = pc(z10), Ge = uk(z10, Se);
            oe == null && !(uu(z10) && (Ge.length || !Se.length)) && (oe = z10, z10 = k10, k10 = this, Ge = uk(z10, pc(z10)));
            var vt = !(uu(oe) && "chain" in oe) || !!oe.chain, Ht = Gu(k10);
            return Yp(Ge, function(Kt) {
              var xn = z10[Kt];
              k10[Kt] = xn, Ht && (k10.prototype[Kt] = function() {
                var Gr = this.__chain__;
                if (vt || Gr) {
                  var Wr = k10(this.__wrapped__), Ur = Wr.__actions__ = nn(this.__actions__);
                  return Ur.push({ func: xn, args: arguments, thisArg: k10 }), Wr.__chain__ = Gr, Wr;
                }
                return xn.apply(k10, Kb([this.value()], arguments));
              });
            }), k10;
          }
          function qE() {
            return sh._ === this && (sh._ = UB), this;
          }
          function Gi() {
          }
          function sP(k10) {
            return k10 = Ao(k10), _s(function(z10) {
              return w6(z10, k10);
            });
          }
          var aF = Ai(uc), YE = Ai(GB), iF = Ai(Fc);
          function R1(k10) {
            return Rl(k10) ? UA(Rt(k10)) : kee(k10);
          }
          function Vw(k10) {
            return function(z10) {
              return k10 == null ? t2 : cw(k10, z10);
            };
          }
          var F1 = Yn(), ZE = Yn(true);
          function Sg() {
            return [];
          }
          function XE() {
            return false;
          }
          function lP() {
            return {};
          }
          function KE() {
            return "";
          }
          function N1() {
            return true;
          }
          function tC(k10, z10) {
            if (k10 = Ao(k10), k10 < 1 || k10 > bt)
              return [];
            var oe = fn, Se = bd(k10, fn);
            z10 = Ei(z10), k10 -= fn;
            for (var Ge = ZA(Se, z10); ++oe < k10; )
              z10(oe);
            return Ge;
          }
          function JE(k10) {
            return Co(k10) ? uc(k10, Rt) : sf(k10) ? [k10] : nn(St(El(k10)));
          }
          function uP(k10) {
            var z10 = ++Ff;
            return El(k10) + z10;
          }
          var cP = ir(function(k10, z10) {
            return k10 + z10;
          }, 0), nC = Wi("ceil"), QE = ir(function(k10, z10) {
            return k10 / z10;
          }, 1), V1 = Wi("floor");
          function fP(k10) {
            return k10 && k10.length ? fE(k10, Gh, ck) : t2;
          }
          function eI(k10, z10) {
            return k10 && k10.length ? fE(k10, Ei(z10, 2), ck) : t2;
          }
          function tI(k10) {
            return HB(k10, Gh);
          }
          function rC(k10, z10) {
            return HB(k10, Ei(z10, 2));
          }
          function oF(k10) {
            return k10 && k10.length ? fE(k10, Gh, dk) : t2;
          }
          function hP(k10, z10) {
            return k10 && k10.length ? fE(k10, Ei(z10, 2), dk) : t2;
          }
          var nI = ir(function(k10, z10) {
            return k10 * z10;
          }, 1), m_ = Wi("round"), dP = ir(function(k10, z10) {
            return k10 - z10;
          }, 0);
          function sF(k10) {
            return k10 && k10.length ? YA(k10, Gh) : 0;
          }
          function aC(k10, z10) {
            return k10 && k10.length ? YA(k10, Ei(z10, 2)) : 0;
          }
          return it.after = ww, it.ary = Sw, it.assign = W6, it.assignIn = Vc, it.assignInWith = lf, it.assignWith = RE, it.at = H6, it.before = E1, it.bind = ay, it.bindAll = g_, it.bindKey = Cw, it.castArray = z6, it.chain = FS, it.chunk = Ln, it.compact = Cr, it.concat = or, it.cond = rF, it.conforms = QS, it.constant = HE, it.countBy = bw, it.create = c_, it.curry = Mw, it.curryRight = Gf, it.debounce = I1, it.defaults = FE, it.defaultsDeep = Dw, it.defer = iy, it.delay = Rk, it.difference = cn, it.differenceBy = na, it.differenceWith = ni, it.drop = Ho, it.dropRight = Fo, it.dropRightWhile = _o, it.dropWhile = ji, it.fill = Cl, it.filter = ME, it.flatMap = zh, it.flatMapDeep = R6, it.flatMapDepth = Ok, it.flatten = Eu, it.flattenDeep = jf, it.flattenDepth = Nv, it.flip = Aw, it.flow = wf, it.flowRight = $E, it.fromPairs = Jm, it.functions = h_, it.functionsIn = zc, it.groupBy = AE, it.initial = D0, it.intersection = tf, it.intersectionBy = Vv, it.intersectionWith = nf, it.invert = Lw, it.invertBy = Ow, it.invokeMap = tv, it.iteratee = vp, it.keyBy = zS, it.keys = pc, it.keysIn = nt, it.map = ty, it.mapKeys = p_, it.mapValues = YS, it.matches = eC, it.matchesProperty = Nw, it.memoize = T1, it.merge = pp, it.mergeWith = ws, it.method = B0, it.methodOf = UE, it.mixin = jc, it.negate = WS, it.nthArg = sP, it.omit = $6, it.omitBy = NE, it.once = N6, it.orderBy = _w, it.over = aF, it.overArgs = V6, it.overEvery = YE, it.overSome = iF, it.partial = TE, it.partialRight = af, it.partition = EE, it.pick = VE, it.pickBy = uy, it.property = R1, it.propertyOf = Vw, it.pull = hp, it.pullAll = k0, it.pullAllBy = P0, it.pullAllWith = xf, it.pullAt = mw, it.range = F1, it.rangeRight = ZE, it.rearg = Fk, it.reject = jS, it.remove = zv, it.rest = DE, it.reverse = Qm, it.sampleSize = ny, it.set = zE, it.setWith = q6, it.shuffle = IE, it.slice = A1, it.sortBy = xw, it.sortedUniq = mE, it.sortedUniqBy = RS, it.split = KS, it.spread = kE, it.tail = T6, it.take = Mk, it.takeRight = yE, it.takeRightWhile = Ak, it.takeWhile = bE, it.tap = Dk, it.throttle = Nk, it.thru = dc, it.toArray = Uk, it.toPairs = ZS, it.toPairsIn = Zk, it.toPath = JE, it.toPlainObject = qk, it.transform = Bc, it.unary = oy, it.union = _E, it.unionBy = fh, it.unionWith = yw, it.uniq = Ek, it.uniqBy = D6, it.uniqWith = k6, it.unset = Xk, it.unzip = Qp, it.unzipWith = xE, it.update = BE, it.updateWith = Kk, it.values = v_, it.valuesIn = Y6, it.without = Iu, it.words = O1, it.wrap = HS, it.xor = eu, it.xorBy = wE, it.xorWith = Ik, it.zip = SE, it.zipObject = P6, it.zipObjectDeep = Tk, it.zipWith = L6, it.entries = ZS, it.entriesIn = Zk, it.extend = Vc, it.extendWith = lf, jc(it, it), it.add = cP, it.attempt = Gv, it.camelCase = Rw, it.capitalize = Qk, it.ceil = nC, it.clamp = V0, it.clone = Vk, it.cloneDeep = Qo, it.cloneDeepWith = hh, it.cloneWith = B6, it.conformsTo = lu, it.deburr = eP, it.defaultTo = z0, it.divide = QE, it.endsWith = cy, it.eq = Bh, it.escape = GE, it.escapeRegExp = Z6, it.every = VS, it.find = dp, it.findIndex = Au, it.findKey = N0, it.findLast = O6, it.findLastIndex = oo, it.findLastKey = jh, it.floor = V1, it.forEach = L0, it.forEachRight = s_, it.forIn = k1, it.forInRight = f_, it.forOwn = kw, it.forOwnRight = Pw, it.get = ly, it.gt = PE, it.gte = zk, it.has = P1, it.hasIn = qS, it.head = Jp, it.identity = Gh, it.includes = ko, it.indexOf = C1, it.inRange = Jk, it.invoke = d_, it.isArguments = Ad, it.isArray = Co, it.isArrayBuffer = O0, it.isArrayLike = an, it.isArrayLikeObject = er, it.isBoolean = tr, it.isBuffer = Va, it.isDate = Mo, it.isElement = al, it.isEmpty = of, it.isEqual = Fl, it.isEqualWith = LE, it.isError = OE, it.isFinite = Ed, it.isFunction = Gu, it.isInteger = Bk, it.isLength = tu, it.isMap = Al, it.isMatch = jk, it.isMatchWith = Gk, it.isNaN = $S, it.isNative = j6, it.isNil = Hk, it.isNull = Wk, it.isNumber = l_, it.isObject = uu, it.isObjectLike = cu, it.isPlainObject = nv, it.isRegExp = sy, it.isSafeInteger = u_, it.isSet = Ew, it.isString = Iw, it.isSymbol = sf, it.isTypedArray = R0, it.isUndefined = $k, it.isWeakMap = es, it.isWeakSet = D1, it.join = wg, it.kebabCase = Bv, it.last = hc, it.lastIndexOf = M1, it.lowerCase = X6, it.lowerFirst = K6, it.lt = US, it.lte = G6, it.max = fP, it.maxBy = eI, it.mean = tI, it.meanBy = rC, it.min = oF, it.minBy = hP, it.stubArray = Sg, it.stubFalse = XE, it.stubObject = lP, it.stubString = KE, it.stubTrue = N1, it.multiply = nI, it.nth = gw, it.noConflict = qE, it.noop = Gi, it.now = ry, it.pad = XS, it.padEnd = J6, it.padStart = Q6, it.parseInt = tP, it.random = jE, it.reduce = BS, it.reduceRight = F6, it.repeat = nP, it.replace = rP, it.result = U6, it.round = m_, it.runInContext = mn, it.sample = GS, it.size = Ml, it.snakeCase = eF, it.some = rf, it.sortedIndex = wk, it.sortedIndexBy = Sk, it.sortedIndexOf = I6, it.sortedLastIndex = vE, it.sortedLastIndexBy = gE, it.sortedLastIndexOf = Ck, it.startCase = Wf, it.startsWith = JS, it.subtract = dP, it.sum = sF, it.sumBy = aC, it.template = aP, it.times = tC, it.toFinite = F0, it.toInteger = Ao, it.toLength = Tw, it.toLower = iP, it.toNumber = Id, it.toSafeInteger = Yk, it.toString = El, it.toUpper = tF, it.trim = jv, it.trimEnd = WE, it.trimStart = L1, it.truncate = rv, it.unescape = nF, it.uniqueId = uP, it.upperCase = oP, it.upperFirst = Fw, it.each = L0, it.eachRight = s_, it.first = Jp, jc(it, function() {
            var k10 = {};
            return Rh(it, function(z10, oe) {
              Ql.call(it.prototype, oe) || (k10[oe] = z10);
            }), k10;
          }(), { chain: false }), it.VERSION = s, Yp(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(k10) {
            it[k10].placeholder = it;
          }), Yp(["drop", "take"], function(k10, z10) {
            Us.prototype[k10] = function(oe) {
              oe = oe === t2 ? 1 : Nf(Ao(oe), 0);
              var Se = this.__filtered__ && !z10 ? new Us(this) : this.clone();
              return Se.__filtered__ ? Se.__takeCount__ = bd(oe, Se.__takeCount__) : Se.__views__.push({ size: bd(oe, fn), type: k10 + (Se.__dir__ < 0 ? "Right" : "") }), Se;
            }, Us.prototype[k10 + "Right"] = function(oe) {
              return this.reverse()[k10](oe).reverse();
            };
          }), Yp(["filter", "map", "takeWhile"], function(k10, z10) {
            var oe = z10 + 1, Se = oe == at || oe == Qe;
            Us.prototype[k10] = function(Ge) {
              var vt = this.clone();
              return vt.__iteratees__.push({ iteratee: Ei(Ge, 3), type: oe }), vt.__filtered__ = vt.__filtered__ || Se, vt;
            };
          }), Yp(["head", "last"], function(k10, z10) {
            var oe = "take" + (z10 ? "Right" : "");
            Us.prototype[k10] = function() {
              return this[oe](1).value()[0];
            };
          }), Yp(["initial", "tail"], function(k10, z10) {
            var oe = "drop" + (z10 ? "" : "Right");
            Us.prototype[k10] = function() {
              return this.__filtered__ ? new Us(this) : this[oe](1);
            };
          }), Us.prototype.compact = function() {
            return this.filter(Gh);
          }, Us.prototype.find = function(k10) {
            return this.filter(k10).head();
          }, Us.prototype.findLast = function(k10) {
            return this.reverse().find(k10);
          }, Us.prototype.invokeMap = _s(function(k10, z10) {
            return typeof k10 == "function" ? new Us(this) : this.map(function(oe) {
              return kS(oe, k10, z10);
            });
          }), Us.prototype.reject = function(k10) {
            return this.filter(WS(Ei(k10)));
          }, Us.prototype.slice = function(k10, z10) {
            k10 = Ao(k10);
            var oe = this;
            return oe.__filtered__ && (k10 > 0 || z10 < 0) ? new Us(oe) : (k10 < 0 ? oe = oe.takeRight(-k10) : k10 && (oe = oe.drop(k10)), z10 !== t2 && (z10 = Ao(z10), oe = z10 < 0 ? oe.dropRight(-z10) : oe.take(z10 - k10)), oe);
          }, Us.prototype.takeRightWhile = function(k10) {
            return this.reverse().takeWhile(k10).reverse();
          }, Us.prototype.toArray = function() {
            return this.take(fn);
          }, Rh(Us.prototype, function(k10, z10) {
            var oe = /^(?:filter|find|map|reject)|While$/.test(z10), Se = /^(?:head|last)$/.test(z10), Ge = it[Se ? "take" + (z10 == "last" ? "Right" : "") : z10], vt = Se || /^find/.test(z10);
            !Ge || (it.prototype[z10] = function() {
              var Ht = this.__wrapped__, Kt = Se ? [1] : arguments, xn = Ht instanceof Us, Gr = Kt[0], Wr = xn || Co(Ht), Ur = function(Zi) {
                var No = Ge.apply(it, Kb([Zi], Kt));
                return Se && Ba ? No[0] : No;
              };
              Wr && oe && typeof Gr == "function" && Gr.length != 1 && (xn = Wr = false);
              var Ba = this.__chain__, vi = !!this.__actions__.length, Ni = vt && !Ba, $o = xn && !vi;
              if (!vt && Wr) {
                Ht = $o ? Ht : new Us(this);
                var Hi = k10.apply(Ht, Kt);
                return Hi.__actions__.push({ func: dc, args: [Ur], thisArg: t2 }), new up(Hi, Ba);
              }
              return Ni && $o ? k10.apply(this, Kt) : (Hi = this.thru(Ur), Ni ? Se ? Hi.value()[0] : Hi.value() : Hi);
            });
          }), Yp(["pop", "push", "shift", "sort", "splice", "unshift"], function(k10) {
            var z10 = ES[k10], oe = /^(?:push|sort|unshift)$/.test(k10) ? "tap" : "thru", Se = /^(?:pop|shift)$/.test(k10);
            it.prototype[k10] = function() {
              var Ge = arguments;
              if (Se && !this.__chain__) {
                var vt = this.value();
                return z10.apply(Co(vt) ? vt : [], Ge);
              }
              return this[oe](function(Ht) {
                return z10.apply(Co(Ht) ? Ht : [], Ge);
              });
            };
          }), Rh(Us.prototype, function(k10, z10) {
            var oe = it[z10];
            if (oe) {
              var Se = oe.name + "";
              Ql.call(ow, Se) || (ow[Se] = []), ow[Se].push({ name: z10, func: oe });
            }
          }), ow[Xa(t2, j).name] = [{ name: "wrapper", func: t2 }], Us.prototype.clone = lee, Us.prototype.reverse = uee, Us.prototype.value = QB, it.prototype.at = NS, it.prototype.chain = ey, it.prototype.commit = kk, it.prototype.next = CE, it.prototype.plant = o_, it.prototype.reverse = Pk, it.prototype.toJSON = it.prototype.valueOf = it.prototype.value = Lk, it.prototype.first = it.prototype.head, nE && (it.prototype[nE] = ev), it;
        }, Qb = JA();
        Zb ? ((Zb.exports = Qb)._ = Qb, J4._ = Qb) : sh._ = Qb;
      }).call(ze);
    })(Jz, Jz.exports);
    class K1e {
      constructor() {
        p4(this, "subscriptions", /* @__PURE__ */ new Map()), p4(this, "emitEffectCache", /* @__PURE__ */ new Map()), p4(this, "useSubscription", (r6, t2) => {
          const s = g4.useRef();
          g4.useEffect(() => {
            var u, f6;
            s.current = t2;
            function d6(m6) {
              s.current && s.current(m6);
            }
            const v6 = (f6 = (u = this.subscriptions) == null ? void 0 : u.get(r6)) != null ? f6 : [];
            return v6.push(d6), this.subscriptions.set(r6, v6), this.emitEffect(r6), () => {
              this.subscriptions.delete(r6);
            };
          });
        }), p4(this, "emit", (r6, ...t2) => {
          if (typeof r6 == "string" || typeof r6 == "number") {
            const s = this.subscriptions.get(r6);
            s == null || s.forEach((u) => {
              u == null || u({ params: Jz.exports.cloneDeep(t2), event: r6 });
            }), this.emitEffectCache.set(r6, { params: Jz.exports.cloneDeep(t2), event: r6 });
          } else
            throw new TypeError("event must be string or number !");
        }), p4(this, "emitEffect", (r6) => {
          const t2 = this.emitEffectCache.get(r6), s = this.subscriptions.get(r6);
          t2 && (s == null || s.forEach((u) => {
            u == null || u(h({}, t2));
          }));
        }), p4(this, "removeListener", (r6) => {
          this.subscriptions.delete(r6);
        }), p4(this, "clear", () => {
          this.subscriptions.clear();
        }), this.clear();
      }
    }
    const AXe = new K1e();
    function Qz(a) {
      const r6 = g4.useRef(), t2 = g4.useMemo(() => a != null ? a : { global: false }, [a]);
      return r6.current || (r6.current = t2.global ? r6.current = AXe : r6.current = new K1e()), g4.useEffect(() => () => {
        var s;
        return (s = r6.current) == null ? void 0 : s.clear();
      }, []), r6.current;
    }
    const $J = ({ id: a, title: r6, chart: t2, option: s }, u) => {
      const f6 = g4.useRef(), d6 = Qz({ global: true });
      f6.current = g4.useMemo(() => {
        if (!f6.current)
          return MXe;
      }, []);
      const { run: v6 } = lt2(() => {
        a && d6.emit("list");
      }, { wait: 100 });
      return g4.useEffect(() => {
        console.log(t2 == null ? void 0 : t2.current), f6.current && (t2 == null ? void 0 : t2.current) && a && s && (f6.current.add(a, t2 == null ? void 0 : t2.current, s, r6), v6());
      }, u), { tool: f6.current };
    };
    var EXe = g4.createContext({}), J1e = EXe;
    function iu(a, r6, t2) {
      return r6 in a ? Object.defineProperty(a, r6, { value: t2, enumerable: true, configurable: true, writable: true }) : a[r6] = t2, a;
    }
    function Q1e(a, r6) {
      var t2 = Object.keys(a);
      if (Object.getOwnPropertySymbols) {
        var s = Object.getOwnPropertySymbols(a);
        r6 && (s = s.filter(function(u) {
          return Object.getOwnPropertyDescriptor(a, u).enumerable;
        })), t2.push.apply(t2, s);
      }
      return t2;
    }
    function Go(a) {
      for (var r6 = 1; r6 < arguments.length; r6++) {
        var t2 = arguments[r6] != null ? arguments[r6] : {};
        r6 % 2 ? Q1e(Object(t2), true).forEach(function(s) {
          iu(a, s, t2[s]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(a, Object.getOwnPropertyDescriptors(t2)) : Q1e(Object(t2)).forEach(function(s) {
          Object.defineProperty(a, s, Object.getOwnPropertyDescriptor(t2, s));
        });
      }
      return a;
    }
    function ebe(a) {
      if (Array.isArray(a))
        return a;
    }
    function IXe(a, r6) {
      var t2 = a == null ? null : typeof Symbol != "undefined" && a[Symbol.iterator] || a["@@iterator"];
      if (t2 != null) {
        var s = [], u = true, f6 = false, d6, v6;
        try {
          for (t2 = t2.call(a); !(u = (d6 = t2.next()).done) && (s.push(d6.value), !(r6 && s.length === r6)); u = true)
            ;
        } catch (m6) {
          f6 = true, v6 = m6;
        } finally {
          try {
            !u && t2.return != null && t2.return();
          } finally {
            if (f6)
              throw v6;
          }
        }
        return s;
      }
    }
    function UJ(a, r6) {
      (r6 == null || r6 > a.length) && (r6 = a.length);
      for (var t2 = 0, s = new Array(r6); t2 < r6; t2++)
        s[t2] = a[t2];
      return s;
    }
    function qJ(a, r6) {
      if (a) {
        if (typeof a == "string")
          return UJ(a, r6);
        var t2 = Object.prototype.toString.call(a).slice(8, -1);
        if (t2 === "Object" && a.constructor && (t2 = a.constructor.name), t2 === "Map" || t2 === "Set")
          return Array.from(a);
        if (t2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t2))
          return UJ(a, r6);
      }
    }
    function tbe() {
      throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function Gm(a, r6) {
      return ebe(a) || IXe(a, r6) || qJ(a, r6) || tbe();
    }
    function TXe(a, r6) {
      if (a == null)
        return {};
      var t2 = {}, s = Object.keys(a), u, f6;
      for (f6 = 0; f6 < s.length; f6++)
        u = s[f6], !(r6.indexOf(u) >= 0) && (t2[u] = a[u]);
      return t2;
    }
    function O5(a, r6) {
      if (a == null)
        return {};
      var t2 = TXe(a, r6), s, u;
      if (Object.getOwnPropertySymbols) {
        var f6 = Object.getOwnPropertySymbols(a);
        for (u = 0; u < f6.length; u++)
          s = f6[u], !(r6.indexOf(s) >= 0) && (!Object.prototype.propertyIsEnumerable.call(a, s) || (t2[s] = a[s]));
      }
      return t2;
    }
    var nbe = { exports: {} };
    /*!
      Copyright (c) 2018 Jed Watson.
      Licensed under the MIT License (MIT), see
      http://jedwatson.github.io/classnames
    */
    (function(a) {
      (function() {
        var r6 = {}.hasOwnProperty;
        function t2() {
          for (var s = [], u = 0; u < arguments.length; u++) {
            var f6 = arguments[u];
            if (f6) {
              var d6 = typeof f6;
              if (d6 === "string" || d6 === "number")
                s.push(f6);
              else if (Array.isArray(f6)) {
                if (f6.length) {
                  var v6 = t2.apply(null, f6);
                  v6 && s.push(v6);
                }
              } else if (d6 === "object")
                if (f6.toString === Object.prototype.toString)
                  for (var m6 in f6)
                    r6.call(f6, m6) && f6[m6] && s.push(m6);
                else
                  s.push(f6.toString());
            }
          }
          return s.join(" ");
        }
        a.exports ? (t2.default = t2, a.exports = t2) : window.classNames = t2;
      })();
    })(nbe);
    var R5 = nbe.exports;
    function Hp(a) {
      return Hp = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(r6) {
        return typeof r6;
      } : function(r6) {
        return r6 && typeof Symbol == "function" && r6.constructor === Symbol && r6 !== Symbol.prototype ? "symbol" : typeof r6;
      }, Hp(a);
    }
    function Wm(a, r6) {
      DXe(a) && (a = "100%");
      var t2 = kXe(a);
      return a = r6 === 360 ? a : Math.min(r6, Math.max(0, parseFloat(a))), t2 && (a = parseInt(String(a * r6), 10) / 100), Math.abs(a - r6) < 1e-6 ? 1 : (r6 === 360 ? a = (a < 0 ? a % r6 + r6 : a % r6) / parseFloat(String(r6)) : a = a % r6 / parseFloat(String(r6)), a);
    }
    function DXe(a) {
      return typeof a == "string" && a.indexOf(".") !== -1 && parseFloat(a) === 1;
    }
    function kXe(a) {
      return typeof a == "string" && a.indexOf("%") !== -1;
    }
    function PXe(a) {
      return a = parseFloat(a), (isNaN(a) || a < 0 || a > 1) && (a = 1), a;
    }
    function eB(a) {
      return a <= 1 ? Number(a) * 100 + "%" : a;
    }
    function YJ(a) {
      return a.length === 1 ? "0" + a : String(a);
    }
    function LXe(a, r6, t2) {
      return { r: Wm(a, 255) * 255, g: Wm(r6, 255) * 255, b: Wm(t2, 255) * 255 };
    }
    function ZJ(a, r6, t2) {
      return t2 < 0 && (t2 += 1), t2 > 1 && (t2 -= 1), t2 < 1 / 6 ? a + (r6 - a) * (6 * t2) : t2 < 1 / 2 ? r6 : t2 < 2 / 3 ? a + (r6 - a) * (2 / 3 - t2) * 6 : a;
    }
    function OXe(a, r6, t2) {
      var s, u, f6;
      if (a = Wm(a, 360), r6 = Wm(r6, 100), t2 = Wm(t2, 100), r6 === 0)
        u = t2, f6 = t2, s = t2;
      else {
        var d6 = t2 < 0.5 ? t2 * (1 + r6) : t2 + r6 - t2 * r6, v6 = 2 * t2 - d6;
        s = ZJ(v6, d6, a + 1 / 3), u = ZJ(v6, d6, a), f6 = ZJ(v6, d6, a - 1 / 3);
      }
      return { r: s * 255, g: u * 255, b: f6 * 255 };
    }
    function RXe(a, r6, t2) {
      a = Wm(a, 255), r6 = Wm(r6, 255), t2 = Wm(t2, 255);
      var s = Math.max(a, r6, t2), u = Math.min(a, r6, t2), f6 = 0, d6 = s, v6 = s - u, m6 = s === 0 ? 0 : v6 / s;
      if (s === u)
        f6 = 0;
      else {
        switch (s) {
          case a:
            f6 = (r6 - t2) / v6 + (r6 < t2 ? 6 : 0);
            break;
          case r6:
            f6 = (t2 - a) / v6 + 2;
            break;
          case t2:
            f6 = (a - r6) / v6 + 4;
            break;
        }
        f6 /= 6;
      }
      return { h: f6, s: m6, v: d6 };
    }
    function FXe(a, r6, t2) {
      a = Wm(a, 360) * 6, r6 = Wm(r6, 100), t2 = Wm(t2, 100);
      var s = Math.floor(a), u = a - s, f6 = t2 * (1 - r6), d6 = t2 * (1 - u * r6), v6 = t2 * (1 - (1 - u) * r6), m6 = s % 6, b6 = [t2, d6, f6, f6, v6, t2][m6], x6 = [v6, t2, t2, d6, f6, f6][m6], S = [f6, f6, v6, t2, t2, d6][m6];
      return { r: b6 * 255, g: x6 * 255, b: S * 255 };
    }
    function NXe(a, r6, t2, s) {
      var u = [YJ(Math.round(a).toString(16)), YJ(Math.round(r6).toString(16)), YJ(Math.round(t2).toString(16))];
      return s && u[0].startsWith(u[0].charAt(1)) && u[1].startsWith(u[1].charAt(1)) && u[2].startsWith(u[2].charAt(1)) ? u[0].charAt(0) + u[1].charAt(0) + u[2].charAt(0) : u.join("");
    }
    function rbe(a) {
      return v0(a) / 255;
    }
    function v0(a) {
      return parseInt(a, 16);
    }
    var abe = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
    function I4(a) {
      var r6 = { r: 0, g: 0, b: 0 }, t2 = 1, s = null, u = null, f6 = null, d6 = false, v6 = false;
      return typeof a == "string" && (a = BXe(a)), typeof a == "object" && (Jx(a.r) && Jx(a.g) && Jx(a.b) ? (r6 = LXe(a.r, a.g, a.b), d6 = true, v6 = String(a.r).substr(-1) === "%" ? "prgb" : "rgb") : Jx(a.h) && Jx(a.s) && Jx(a.v) ? (s = eB(a.s), u = eB(a.v), r6 = FXe(a.h, s, u), d6 = true, v6 = "hsv") : Jx(a.h) && Jx(a.s) && Jx(a.l) && (s = eB(a.s), f6 = eB(a.l), r6 = OXe(a.h, s, f6), d6 = true, v6 = "hsl"), Object.prototype.hasOwnProperty.call(a, "a") && (t2 = a.a)), t2 = PXe(t2), { ok: d6, format: a.format || v6, r: Math.min(255, Math.max(r6.r, 0)), g: Math.min(255, Math.max(r6.g, 0)), b: Math.min(255, Math.max(r6.b, 0)), a: t2 };
    }
    var VXe = "[-\\+]?\\d+%?", zXe = "[-\\+]?\\d*\\.\\d+%?", vS = "(?:" + zXe + ")|(?:" + VXe + ")", XJ = "[\\s|\\(]+(" + vS + ")[,|\\s]+(" + vS + ")[,|\\s]+(" + vS + ")\\s*\\)?", KJ = "[\\s|\\(]+(" + vS + ")[,|\\s]+(" + vS + ")[,|\\s]+(" + vS + ")[,|\\s]+(" + vS + ")\\s*\\)?", d1 = { CSS_UNIT: new RegExp(vS), rgb: new RegExp("rgb" + XJ), rgba: new RegExp("rgba" + KJ), hsl: new RegExp("hsl" + XJ), hsla: new RegExp("hsla" + KJ), hsv: new RegExp("hsv" + XJ), hsva: new RegExp("hsva" + KJ), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
    function BXe(a) {
      if (a = a.trim().toLowerCase(), a.length === 0)
        return false;
      var r6 = false;
      if (abe[a])
        a = abe[a], r6 = true;
      else if (a === "transparent")
        return { r: 0, g: 0, b: 0, a: 0, format: "name" };
      var t2 = d1.rgb.exec(a);
      return t2 ? { r: t2[1], g: t2[2], b: t2[3] } : (t2 = d1.rgba.exec(a), t2 ? { r: t2[1], g: t2[2], b: t2[3], a: t2[4] } : (t2 = d1.hsl.exec(a), t2 ? { h: t2[1], s: t2[2], l: t2[3] } : (t2 = d1.hsla.exec(a), t2 ? { h: t2[1], s: t2[2], l: t2[3], a: t2[4] } : (t2 = d1.hsv.exec(a), t2 ? { h: t2[1], s: t2[2], v: t2[3] } : (t2 = d1.hsva.exec(a), t2 ? { h: t2[1], s: t2[2], v: t2[3], a: t2[4] } : (t2 = d1.hex8.exec(a), t2 ? { r: v0(t2[1]), g: v0(t2[2]), b: v0(t2[3]), a: rbe(t2[4]), format: r6 ? "name" : "hex8" } : (t2 = d1.hex6.exec(a), t2 ? { r: v0(t2[1]), g: v0(t2[2]), b: v0(t2[3]), format: r6 ? "name" : "hex" } : (t2 = d1.hex4.exec(a), t2 ? { r: v0(t2[1] + t2[1]), g: v0(t2[2] + t2[2]), b: v0(t2[3] + t2[3]), a: rbe(t2[4] + t2[4]), format: r6 ? "name" : "hex8" } : (t2 = d1.hex3.exec(a), t2 ? { r: v0(t2[1] + t2[1]), g: v0(t2[2] + t2[2]), b: v0(t2[3] + t2[3]), format: r6 ? "name" : "hex" } : false)))))))));
    }
    function Jx(a) {
      return Boolean(d1.CSS_UNIT.exec(String(a)));
    }
    var tB = 2, ibe = 0.16, jXe = 0.05, GXe = 0.05, WXe = 0.15, obe = 5, sbe = 4, HXe = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
    function lbe(a) {
      var r6 = a.r, t2 = a.g, s = a.b, u = RXe(r6, t2, s);
      return { h: u.h * 360, s: u.s, v: u.v };
    }
    function nB(a) {
      var r6 = a.r, t2 = a.g, s = a.b;
      return "#".concat(NXe(r6, t2, s, false));
    }
    function $Xe(a, r6, t2) {
      var s = t2 / 100, u = { r: (r6.r - a.r) * s + a.r, g: (r6.g - a.g) * s + a.g, b: (r6.b - a.b) * s + a.b };
      return u;
    }
    function ube(a, r6, t2) {
      var s;
      return Math.round(a.h) >= 60 && Math.round(a.h) <= 240 ? s = t2 ? Math.round(a.h) - tB * r6 : Math.round(a.h) + tB * r6 : s = t2 ? Math.round(a.h) + tB * r6 : Math.round(a.h) - tB * r6, s < 0 ? s += 360 : s >= 360 && (s -= 360), s;
    }
    function cbe(a, r6, t2) {
      if (a.h === 0 && a.s === 0)
        return a.s;
      var s;
      return t2 ? s = a.s - ibe * r6 : r6 === sbe ? s = a.s + ibe : s = a.s + jXe * r6, s > 1 && (s = 1), t2 && r6 === obe && s > 0.1 && (s = 0.1), s < 0.06 && (s = 0.06), Number(s.toFixed(2));
    }
    function fbe(a, r6, t2) {
      var s;
      return t2 ? s = a.v + GXe * r6 : s = a.v - WXe * r6, s > 1 && (s = 1), Number(s.toFixed(2));
    }
    function JJ(a) {
      for (var r6 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t2 = [], s = I4(a), u = obe; u > 0; u -= 1) {
        var f6 = lbe(s), d6 = nB(I4({ h: ube(f6, u, true), s: cbe(f6, u, true), v: fbe(f6, u, true) }));
        t2.push(d6);
      }
      t2.push(nB(s));
      for (var v6 = 1; v6 <= sbe; v6 += 1) {
        var m6 = lbe(s), b6 = nB(I4({ h: ube(m6, v6), s: cbe(m6, v6), v: fbe(m6, v6) }));
        t2.push(b6);
      }
      return r6.theme === "dark" ? HXe.map(function(x6) {
        var S = x6.index, M = x6.opacity, A6 = nB($Xe(I4(r6.backgroundColor || "#141414"), I4(t2[S]), M * 100));
        return A6;
      }) : t2;
    }
    var QJ = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, $p = {}, eQ = {};
    Object.keys(QJ).forEach(function(a) {
      $p[a] = JJ(QJ[a]), $p[a].primary = $p[a][5], eQ[a] = JJ(QJ[a], { theme: "dark", backgroundColor: "#141414" }), eQ[a].primary = eQ[a][5];
    }), $p.red, $p.volcano, $p.gold, $p.orange, $p.yellow, $p.lime, $p.green, $p.cyan, $p.blue, $p.geekblue, $p.purple, $p.magenta, $p.grey;
    var hbe = {};
    function UXe(a, r6) {
    }
    function qXe(a, r6, t2) {
      !r6 && !hbe[t2] && (a(false, t2), hbe[t2] = true);
    }
    function $b(a, r6) {
      qXe(UXe, a, r6);
    }
    function dbe() {
      return !!(typeof window != "undefined" && window.document && window.document.createElement);
    }
    var YXe = "rc-util-key";
    function pbe() {
      var a = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, r6 = a.mark;
      return r6 ? r6.startsWith("data-") ? r6 : "data-".concat(r6) : YXe;
    }
    function tQ(a) {
      if (a.attachTo)
        return a.attachTo;
      var r6 = document.querySelector("head");
      return r6 || document.body;
    }
    function vbe(a) {
      var r6, t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      if (!dbe())
        return null;
      var s = document.createElement("style");
      if (!((r6 = t2.csp) === null || r6 === void 0) && r6.nonce) {
        var u;
        s.nonce = (u = t2.csp) === null || u === void 0 ? void 0 : u.nonce;
      }
      s.innerHTML = a;
      var f6 = tQ(t2), d6 = f6.firstChild;
      return t2.prepend && f6.prepend ? f6.prepend(s) : t2.prepend && d6 ? f6.insertBefore(s, d6) : f6.appendChild(s), s;
    }
    var nQ = /* @__PURE__ */ new Map();
    function ZXe(a) {
      var r6 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t2 = tQ(r6);
      return Array.from(nQ.get(t2).children).find(function(s) {
        return s.tagName === "STYLE" && s.getAttribute(pbe(r6)) === a;
      });
    }
    function gbe(a, r6) {
      var t2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, s = tQ(t2);
      if (!nQ.has(s)) {
        var u = vbe("", t2), f6 = u.parentNode;
        nQ.set(s, f6), f6.removeChild(u);
      }
      var d6 = ZXe(r6, t2);
      if (d6) {
        var v6, m6;
        if (((v6 = t2.csp) === null || v6 === void 0 ? void 0 : v6.nonce) && d6.nonce !== ((m6 = t2.csp) === null || m6 === void 0 ? void 0 : m6.nonce)) {
          var b6;
          d6.nonce = (b6 = t2.csp) === null || b6 === void 0 ? void 0 : b6.nonce;
        }
        return d6.innerHTML !== a && (d6.innerHTML = a), d6;
      }
      var x6 = vbe(a, t2);
      return x6.setAttribute(pbe(t2), r6), x6;
    }
    function XXe(a, r6) {
      $b(a, "[@ant-design/icons] ".concat(r6));
    }
    function mbe(a) {
      return Hp(a) === "object" && typeof a.name == "string" && typeof a.theme == "string" && (Hp(a.icon) === "object" || typeof a.icon == "function");
    }
    function ybe() {
      var a = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      return Object.keys(a).reduce(function(r6, t2) {
        var s = a[t2];
        switch (t2) {
          case "class":
            r6.className = s, delete r6.class;
            break;
          default:
            r6[t2] = s;
        }
        return r6;
      }, {});
    }
    function rQ(a, r6, t2) {
      return t2 ? w4.default.createElement(a.tag, Go(Go({ key: r6 }, ybe(a.attrs)), t2), (a.children || []).map(function(s, u) {
        return rQ(s, "".concat(r6, "-").concat(a.tag, "-").concat(u));
      })) : w4.default.createElement(a.tag, Go({ key: r6 }, ybe(a.attrs)), (a.children || []).map(function(s, u) {
        return rQ(s, "".concat(r6, "-").concat(a.tag, "-").concat(u));
      }));
    }
    function bbe(a) {
      return JJ(a)[0];
    }
    function _be(a) {
      return a ? Array.isArray(a) ? a : [a] : [];
    }
    var KXe = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, JXe = function() {
      var a = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : KXe, r6 = g4.useContext(J1e), t2 = r6.csp;
      g4.useEffect(function() {
        gbe(a, "@ant-design-icons", { prepend: true, csp: t2 });
      }, []);
    }, QXe = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], T4 = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
    function eKe(a) {
      var r6 = a.primaryColor, t2 = a.secondaryColor;
      T4.primaryColor = r6, T4.secondaryColor = t2 || bbe(r6), T4.calculated = !!t2;
    }
    function tKe() {
      return Go({}, T4);
    }
    var rB = function(a) {
      var r6 = a.icon, t2 = a.className, s = a.onClick, u = a.style, f6 = a.primaryColor, d6 = a.secondaryColor, v6 = O5(a, QXe), m6 = T4;
      if (f6 && (m6 = { primaryColor: f6, secondaryColor: d6 || bbe(f6) }), JXe(), XXe(mbe(r6), "icon should be icon definiton, but got ".concat(r6)), !mbe(r6))
        return null;
      var b6 = r6;
      return b6 && typeof b6.icon == "function" && (b6 = Go(Go({}, b6), {}, { icon: b6.icon(m6.primaryColor, m6.secondaryColor) })), rQ(b6.icon, "svg-".concat(b6.name), Go({ className: t2, onClick: s, style: u, "data-icon": b6.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, v6));
    };
    rB.displayName = "IconReact", rB.getTwoToneColors = tKe, rB.setTwoToneColors = eKe;
    var aQ = rB;
    function xbe(a) {
      var r6 = _be(a), t2 = Gm(r6, 2), s = t2[0], u = t2[1];
      return aQ.setTwoToneColors({ primaryColor: s, secondaryColor: u });
    }
    function nKe() {
      var a = aQ.getTwoToneColors();
      return a.calculated ? [a.primaryColor, a.secondaryColor] : a.primaryColor;
    }
    var rKe = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
    xbe("#1890ff");
    var aB = C.forwardRef(function(a, r6) {
      var t2, s = a.className, u = a.icon, f6 = a.spin, d6 = a.rotate, v6 = a.tabIndex, m6 = a.onClick, b6 = a.twoToneColor, x6 = O5(a, rKe), S = C.useContext(J1e), M = S.prefixCls, A6 = M === void 0 ? "anticon" : M, I = R5(A6, (t2 = {}, iu(t2, "".concat(A6, "-").concat(u.name), !!u.name), iu(t2, "".concat(A6, "-spin"), !!f6 || u.name === "loading"), t2), s), R = v6;
      R === void 0 && m6 && (R = -1);
      var F = d6 ? { msTransform: "rotate(".concat(d6, "deg)"), transform: "rotate(".concat(d6, "deg)") } : void 0, j = _be(b6), $ = Gm(j, 2), K = $[0], U = $[1];
      return C.createElement("span", Go(Go({ role: "img", "aria-label": u.name }, x6), {}, { ref: r6, tabIndex: R, onClick: m6, className: I }), C.createElement(aQ, { icon: u, primaryColor: K, secondaryColor: U, style: F }));
    });
    aB.displayName = "AntdIcon", aB.getTwoToneColor = nKe, aB.setTwoToneColor = xbe;
    var aKe = aB, iKe = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, oKe = iKe, wbe = function(a, r6) {
      return C.createElement(aKe, Go(Go({}, a), {}, { ref: r6, icon: oKe }));
    };
    wbe.displayName = "LoadingOutlined";
    var sKe = C.forwardRef(wbe);
    function ih() {
      return ih = Object.assign || function(a) {
        for (var r6 = 1; r6 < arguments.length; r6++) {
          var t2 = arguments[r6];
          for (var s in t2)
            Object.prototype.hasOwnProperty.call(t2, s) && (a[s] = t2[s]);
        }
        return a;
      }, ih.apply(this, arguments);
    }
    function D4(a, r6) {
      if (!(a instanceof r6))
        throw new TypeError("Cannot call a class as a function");
    }
    function Sbe(a, r6) {
      for (var t2 = 0; t2 < r6.length; t2++) {
        var s = r6[t2];
        s.enumerable = s.enumerable || false, s.configurable = true, "value" in s && (s.writable = true), Object.defineProperty(a, s.key, s);
      }
    }
    function k4(a, r6, t2) {
      return r6 && Sbe(a.prototype, r6), t2 && Sbe(a, t2), Object.defineProperty(a, "prototype", { writable: false }), a;
    }
    function iQ(a, r6) {
      return iQ = Object.setPrototypeOf || function(t2, s) {
        return t2.__proto__ = s, t2;
      }, iQ(a, r6);
    }
    function oQ(a, r6) {
      if (typeof r6 != "function" && r6 !== null)
        throw new TypeError("Super expression must either be null or a function");
      a.prototype = Object.create(r6 && r6.prototype, { constructor: { value: a, writable: true, configurable: true } }), Object.defineProperty(a, "prototype", { writable: false }), r6 && iQ(a, r6);
    }
    function iB(a) {
      return iB = Object.setPrototypeOf ? Object.getPrototypeOf : function(r6) {
        return r6.__proto__ || Object.getPrototypeOf(r6);
      }, iB(a);
    }
    function lKe() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function sQ(a) {
      if (a === void 0)
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      return a;
    }
    function uKe(a, r6) {
      if (r6 && (Hp(r6) === "object" || typeof r6 == "function"))
        return r6;
      if (r6 !== void 0)
        throw new TypeError("Derived constructors may only return object or undefined");
      return sQ(a);
    }
    function lQ(a) {
      var r6 = lKe();
      return function() {
        var t2 = iB(a), s;
        if (r6) {
          var u = iB(this).constructor;
          s = Reflect.construct(t2, arguments, u);
        } else
          s = t2.apply(this, arguments);
        return uKe(this, s);
      };
    }
    var uQ = { exports: {} }, xu = {};
    /** @license React v16.13.1
    * react-is.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var dd = typeof Symbol == "function" && Symbol.for, cQ = dd ? Symbol.for("react.element") : 60103, fQ = dd ? Symbol.for("react.portal") : 60106, oB = dd ? Symbol.for("react.fragment") : 60107, sB = dd ? Symbol.for("react.strict_mode") : 60108, lB = dd ? Symbol.for("react.profiler") : 60114, uB = dd ? Symbol.for("react.provider") : 60109, cB = dd ? Symbol.for("react.context") : 60110, hQ = dd ? Symbol.for("react.async_mode") : 60111, fB = dd ? Symbol.for("react.concurrent_mode") : 60111, hB = dd ? Symbol.for("react.forward_ref") : 60112, dB = dd ? Symbol.for("react.suspense") : 60113, cKe = dd ? Symbol.for("react.suspense_list") : 60120, pB = dd ? Symbol.for("react.memo") : 60115, vB = dd ? Symbol.for("react.lazy") : 60116, fKe = dd ? Symbol.for("react.block") : 60121, hKe = dd ? Symbol.for("react.fundamental") : 60117, dKe = dd ? Symbol.for("react.responder") : 60118, pKe = dd ? Symbol.for("react.scope") : 60119;
    function g0(a) {
      if (typeof a == "object" && a !== null) {
        var r6 = a.$$typeof;
        switch (r6) {
          case cQ:
            switch (a = a.type, a) {
              case hQ:
              case fB:
              case oB:
              case lB:
              case sB:
              case dB:
                return a;
              default:
                switch (a = a && a.$$typeof, a) {
                  case cB:
                  case hB:
                  case vB:
                  case pB:
                  case uB:
                    return a;
                  default:
                    return r6;
                }
            }
          case fQ:
            return r6;
        }
      }
    }
    function Cbe(a) {
      return g0(a) === fB;
    }
    xu.AsyncMode = hQ, xu.ConcurrentMode = fB, xu.ContextConsumer = cB, xu.ContextProvider = uB, xu.Element = cQ, xu.ForwardRef = hB, xu.Fragment = oB, xu.Lazy = vB, xu.Memo = pB, xu.Portal = fQ, xu.Profiler = lB, xu.StrictMode = sB, xu.Suspense = dB, xu.isAsyncMode = function(a) {
      return Cbe(a) || g0(a) === hQ;
    }, xu.isConcurrentMode = Cbe, xu.isContextConsumer = function(a) {
      return g0(a) === cB;
    }, xu.isContextProvider = function(a) {
      return g0(a) === uB;
    }, xu.isElement = function(a) {
      return typeof a == "object" && a !== null && a.$$typeof === cQ;
    }, xu.isForwardRef = function(a) {
      return g0(a) === hB;
    }, xu.isFragment = function(a) {
      return g0(a) === oB;
    }, xu.isLazy = function(a) {
      return g0(a) === vB;
    }, xu.isMemo = function(a) {
      return g0(a) === pB;
    }, xu.isPortal = function(a) {
      return g0(a) === fQ;
    }, xu.isProfiler = function(a) {
      return g0(a) === lB;
    }, xu.isStrictMode = function(a) {
      return g0(a) === sB;
    }, xu.isSuspense = function(a) {
      return g0(a) === dB;
    }, xu.isValidElementType = function(a) {
      return typeof a == "string" || typeof a == "function" || a === oB || a === fB || a === lB || a === sB || a === dB || a === cKe || typeof a == "object" && a !== null && (a.$$typeof === vB || a.$$typeof === pB || a.$$typeof === uB || a.$$typeof === cB || a.$$typeof === hB || a.$$typeof === hKe || a.$$typeof === dKe || a.$$typeof === pKe || a.$$typeof === fKe);
    }, xu.typeOf = g0, uQ.exports = xu;
    function dQ(a) {
      var r6 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t2 = [];
      return w4.default.Children.forEach(a, function(s) {
        s == null && !r6.keepEmpty || (Array.isArray(s) ? t2 = t2.concat(dQ(s)) : uQ.exports.isFragment(s) && s.props ? t2 = t2.concat(dQ(s.props.children, r6)) : t2.push(s));
      }), t2;
    }
    function vKe(a, r6) {
      typeof a == "function" ? a(r6) : Hp(a) === "object" && a && "current" in a && (a.current = r6);
    }
    function gKe() {
      for (var a = arguments.length, r6 = new Array(a), t2 = 0; t2 < a; t2++)
        r6[t2] = arguments[t2];
      var s = r6.filter(function(u) {
        return u;
      });
      return s.length <= 1 ? s[0] : function(u) {
        r6.forEach(function(f6) {
          vKe(f6, u);
        });
      };
    }
    function mKe(a) {
      var r6, t2, s = uQ.exports.isMemo(a) ? a.type.type : a.type;
      return !(typeof s == "function" && !(!((r6 = s.prototype) === null || r6 === void 0) && r6.render) || typeof a == "function" && !(!((t2 = a.prototype) === null || t2 === void 0) && t2.render));
    }
    function yKe() {
      try {
        if (!Object.assign)
          return false;
        var a = new String("abc");
        if (a[5] = "de", Object.getOwnPropertyNames(a)[0] === "5")
          return false;
        for (var r6 = {}, t2 = 0; t2 < 10; t2++)
          r6["_" + String.fromCharCode(t2)] = t2;
        var s = Object.getOwnPropertyNames(r6).map(function(f6) {
          return r6[f6];
        });
        if (s.join("") !== "0123456789")
          return false;
        var u = {};
        return "abcdefghijklmnopqrst".split("").forEach(function(f6) {
          u[f6] = f6;
        }), Object.keys(Object.assign({}, u)).join("") === "abcdefghijklmnopqrst";
      } catch {
        return false;
      }
    }
    yKe();
    function bKe(a) {
      if (Array.isArray(a))
        return UJ(a);
    }
    function Mbe(a) {
      if (typeof Symbol != "undefined" && a[Symbol.iterator] != null || a["@@iterator"] != null)
        return Array.from(a);
    }
    function _Ke() {
      throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function ml(a) {
      return bKe(a) || Mbe(a) || qJ(a) || _Ke();
    }
    var F5 = "RC_FORM_INTERNAL_HOOKS", Mc = function() {
      $b(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
    }, P4 = C.createContext({ getFieldValue: Mc, getFieldsValue: Mc, getFieldError: Mc, getFieldWarning: Mc, getFieldsError: Mc, isFieldsTouched: Mc, isFieldTouched: Mc, isFieldValidating: Mc, isFieldsValidating: Mc, resetFields: Mc, setFields: Mc, setFieldsValue: Mc, validateFields: Mc, submit: Mc, getInternalHooks: function() {
      return Mc(), { dispatch: Mc, initEntityValue: Mc, registerField: Mc, useSubscribe: Mc, setInitialValues: Mc, setCallbacks: Mc, getFields: Mc, setValidateMessages: Mc, setPreserve: Mc, getInitialValue: Mc };
    } });
    function pQ(a) {
      return a == null ? [] : Array.isArray(a) ? a : [a];
    }
    var Abe = { exports: {} };
    (function(a) {
      var r6 = function(t2) {
        var s = Object.prototype, u = s.hasOwnProperty, f6, d6 = typeof Symbol == "function" ? Symbol : {}, v6 = d6.iterator || "@@iterator", m6 = d6.asyncIterator || "@@asyncIterator", b6 = d6.toStringTag || "@@toStringTag";
        function x6(bt, wt, Ft) {
          return Object.defineProperty(bt, wt, { value: Ft, enumerable: true, configurable: true, writable: true }), bt[wt];
        }
        try {
          x6({}, "");
        } catch {
          x6 = function(bt, wt, Ft) {
            return bt[wt] = Ft;
          };
        }
        function S(bt, wt, Ft, fn) {
          var gn = wt && wt.prototype instanceof $ ? wt : $, Zr = Object.create(gn.prototype), Ma = new ht(fn || []);
          return Zr._invoke = ke(bt, Ft, Ma), Zr;
        }
        t2.wrap = S;
        function M(bt, wt, Ft) {
          try {
            return { type: "normal", arg: bt.call(wt, Ft) };
          } catch (fn) {
            return { type: "throw", arg: fn };
          }
        }
        var A6 = "suspendedStart", I = "suspendedYield", R = "executing", F = "completed", j = {};
        function $() {
        }
        function K() {
        }
        function U() {
        }
        var he = {};
        x6(he, v6, function() {
          return this;
        });
        var ue = Object.getPrototypeOf, pe = ue && ue(ue(Qe([])));
        pe && pe !== s && u.call(pe, v6) && (he = pe);
        var _e = U.prototype = $.prototype = Object.create(he);
        K.prototype = U, x6(_e, "constructor", U), x6(U, "constructor", K), K.displayName = x6(U, b6, "GeneratorFunction");
        function xe(bt) {
          ["next", "throw", "return"].forEach(function(wt) {
            x6(bt, wt, function(Ft) {
              return this._invoke(wt, Ft);
            });
          });
        }
        t2.isGeneratorFunction = function(bt) {
          var wt = typeof bt == "function" && bt.constructor;
          return wt ? wt === K || (wt.displayName || wt.name) === "GeneratorFunction" : false;
        }, t2.mark = function(bt) {
          return Object.setPrototypeOf ? Object.setPrototypeOf(bt, U) : (bt.__proto__ = U, x6(bt, b6, "GeneratorFunction")), bt.prototype = Object.create(_e), bt;
        }, t2.awrap = function(bt) {
          return { __await: bt };
        };
        function Ae(bt, wt) {
          function Ft(Zr, Ma, Ua, ja) {
            var Ga = M(bt[Zr], bt, Ma);
            if (Ga.type === "throw")
              ja(Ga.arg);
            else {
              var pa = Ga.arg, Fa = pa.value;
              return Fa && typeof Fa == "object" && u.call(Fa, "__await") ? wt.resolve(Fa.__await).then(function(Ha) {
                Ft("next", Ha, Ua, ja);
              }, function(Ha) {
                Ft("throw", Ha, Ua, ja);
              }) : wt.resolve(Fa).then(function(Ha) {
                pa.value = Ha, Ua(pa);
              }, function(Ha) {
                return Ft("throw", Ha, Ua, ja);
              });
            }
          }
          var fn;
          function gn(Zr, Ma) {
            function Ua() {
              return new wt(function(ja, Ga) {
                Ft(Zr, Ma, ja, Ga);
              });
            }
            return fn = fn ? fn.then(Ua, Ua) : Ua();
          }
          this._invoke = gn;
        }
        xe(Ae.prototype), x6(Ae.prototype, m6, function() {
          return this;
        }), t2.AsyncIterator = Ae, t2.async = function(bt, wt, Ft, fn, gn) {
          gn === void 0 && (gn = Promise);
          var Zr = new Ae(S(bt, wt, Ft, fn), gn);
          return t2.isGeneratorFunction(wt) ? Zr : Zr.next().then(function(Ma) {
            return Ma.done ? Ma.value : Zr.next();
          });
        };
        function ke(bt, wt, Ft) {
          var fn = A6;
          return function(gn, Zr) {
            if (fn === R)
              throw new Error("Generator is already running");
            if (fn === F) {
              if (gn === "throw")
                throw Zr;
              return en();
            }
            for (Ft.method = gn, Ft.arg = Zr; ; ) {
              var Ma = Ft.delegate;
              if (Ma) {
                var Ua = je(Ma, Ft);
                if (Ua) {
                  if (Ua === j)
                    continue;
                  return Ua;
                }
              }
              if (Ft.method === "next")
                Ft.sent = Ft._sent = Ft.arg;
              else if (Ft.method === "throw") {
                if (fn === A6)
                  throw fn = F, Ft.arg;
                Ft.dispatchException(Ft.arg);
              } else
                Ft.method === "return" && Ft.abrupt("return", Ft.arg);
              fn = R;
              var ja = M(bt, wt, Ft);
              if (ja.type === "normal") {
                if (fn = Ft.done ? F : I, ja.arg === j)
                  continue;
                return { value: ja.arg, done: Ft.done };
              } else
                ja.type === "throw" && (fn = F, Ft.method = "throw", Ft.arg = ja.arg);
            }
          };
        }
        function je(bt, wt) {
          var Ft = bt.iterator[wt.method];
          if (Ft === f6) {
            if (wt.delegate = null, wt.method === "throw") {
              if (bt.iterator.return && (wt.method = "return", wt.arg = f6, je(bt, wt), wt.method === "throw"))
                return j;
              wt.method = "throw", wt.arg = new TypeError("The iterator does not provide a 'throw' method");
            }
            return j;
          }
          var fn = M(Ft, bt.iterator, wt.arg);
          if (fn.type === "throw")
            return wt.method = "throw", wt.arg = fn.arg, wt.delegate = null, j;
          var gn = fn.arg;
          if (!gn)
            return wt.method = "throw", wt.arg = new TypeError("iterator result is not an object"), wt.delegate = null, j;
          if (gn.done)
            wt[bt.resultName] = gn.value, wt.next = bt.nextLoc, wt.method !== "return" && (wt.method = "next", wt.arg = f6);
          else
            return gn;
          return wt.delegate = null, j;
        }
        xe(_e), x6(_e, b6, "Generator"), x6(_e, v6, function() {
          return this;
        }), x6(_e, "toString", function() {
          return "[object Generator]";
        });
        function Fe(bt) {
          var wt = { tryLoc: bt[0] };
          1 in bt && (wt.catchLoc = bt[1]), 2 in bt && (wt.finallyLoc = bt[2], wt.afterLoc = bt[3]), this.tryEntries.push(wt);
        }
        function at(bt) {
          var wt = bt.completion || {};
          wt.type = "normal", delete wt.arg, bt.completion = wt;
        }
        function ht(bt) {
          this.tryEntries = [{ tryLoc: "root" }], bt.forEach(Fe, this), this.reset(true);
        }
        t2.keys = function(bt) {
          var wt = [];
          for (var Ft in bt)
            wt.push(Ft);
          return wt.reverse(), function fn() {
            for (; wt.length; ) {
              var gn = wt.pop();
              if (gn in bt)
                return fn.value = gn, fn.done = false, fn;
            }
            return fn.done = true, fn;
          };
        };
        function Qe(bt) {
          if (bt) {
            var wt = bt[v6];
            if (wt)
              return wt.call(bt);
            if (typeof bt.next == "function")
              return bt;
            if (!isNaN(bt.length)) {
              var Ft = -1, fn = function gn() {
                for (; ++Ft < bt.length; )
                  if (u.call(bt, Ft))
                    return gn.value = bt[Ft], gn.done = false, gn;
                return gn.value = f6, gn.done = true, gn;
              };
              return fn.next = fn;
            }
          }
          return { next: en };
        }
        t2.values = Qe;
        function en() {
          return { value: f6, done: true };
        }
        return ht.prototype = { constructor: ht, reset: function(bt) {
          if (this.prev = 0, this.next = 0, this.sent = this._sent = f6, this.done = false, this.delegate = null, this.method = "next", this.arg = f6, this.tryEntries.forEach(at), !bt)
            for (var wt in this)
              wt.charAt(0) === "t" && u.call(this, wt) && !isNaN(+wt.slice(1)) && (this[wt] = f6);
        }, stop: function() {
          this.done = true;
          var bt = this.tryEntries[0], wt = bt.completion;
          if (wt.type === "throw")
            throw wt.arg;
          return this.rval;
        }, dispatchException: function(bt) {
          if (this.done)
            throw bt;
          var wt = this;
          function Ft(ja, Ga) {
            return Zr.type = "throw", Zr.arg = bt, wt.next = ja, Ga && (wt.method = "next", wt.arg = f6), !!Ga;
          }
          for (var fn = this.tryEntries.length - 1; fn >= 0; --fn) {
            var gn = this.tryEntries[fn], Zr = gn.completion;
            if (gn.tryLoc === "root")
              return Ft("end");
            if (gn.tryLoc <= this.prev) {
              var Ma = u.call(gn, "catchLoc"), Ua = u.call(gn, "finallyLoc");
              if (Ma && Ua) {
                if (this.prev < gn.catchLoc)
                  return Ft(gn.catchLoc, true);
                if (this.prev < gn.finallyLoc)
                  return Ft(gn.finallyLoc);
              } else if (Ma) {
                if (this.prev < gn.catchLoc)
                  return Ft(gn.catchLoc, true);
              } else if (Ua) {
                if (this.prev < gn.finallyLoc)
                  return Ft(gn.finallyLoc);
              } else
                throw new Error("try statement without catch or finally");
            }
          }
        }, abrupt: function(bt, wt) {
          for (var Ft = this.tryEntries.length - 1; Ft >= 0; --Ft) {
            var fn = this.tryEntries[Ft];
            if (fn.tryLoc <= this.prev && u.call(fn, "finallyLoc") && this.prev < fn.finallyLoc) {
              var gn = fn;
              break;
            }
          }
          gn && (bt === "break" || bt === "continue") && gn.tryLoc <= wt && wt <= gn.finallyLoc && (gn = null);
          var Zr = gn ? gn.completion : {};
          return Zr.type = bt, Zr.arg = wt, gn ? (this.method = "next", this.next = gn.finallyLoc, j) : this.complete(Zr);
        }, complete: function(bt, wt) {
          if (bt.type === "throw")
            throw bt.arg;
          return bt.type === "break" || bt.type === "continue" ? this.next = bt.arg : bt.type === "return" ? (this.rval = this.arg = bt.arg, this.method = "return", this.next = "end") : bt.type === "normal" && wt && (this.next = wt), j;
        }, finish: function(bt) {
          for (var wt = this.tryEntries.length - 1; wt >= 0; --wt) {
            var Ft = this.tryEntries[wt];
            if (Ft.finallyLoc === bt)
              return this.complete(Ft.completion, Ft.afterLoc), at(Ft), j;
          }
        }, catch: function(bt) {
          for (var wt = this.tryEntries.length - 1; wt >= 0; --wt) {
            var Ft = this.tryEntries[wt];
            if (Ft.tryLoc === bt) {
              var fn = Ft.completion;
              if (fn.type === "throw") {
                var gn = fn.arg;
                at(Ft);
              }
              return gn;
            }
          }
          throw new Error("illegal catch attempt");
        }, delegateYield: function(bt, wt, Ft) {
          return this.delegate = { iterator: Qe(bt), resultName: wt, nextLoc: Ft }, this.method === "next" && (this.arg = f6), j;
        } }, t2;
      }(a.exports);
      try {
        regeneratorRuntime = r6;
      } catch {
        typeof globalThis == "object" ? globalThis.regeneratorRuntime = r6 : Function("r", "regeneratorRuntime = r")(r6);
      }
    })(Abe);
    var gS = Abe.exports;
    function Ebe(a, r6, t2, s, u, f6, d6) {
      try {
        var v6 = a[f6](d6), m6 = v6.value;
      } catch (b6) {
        t2(b6);
        return;
      }
      v6.done ? r6(m6) : Promise.resolve(m6).then(s, u);
    }
    function gB(a) {
      return function() {
        var r6 = this, t2 = arguments;
        return new Promise(function(s, u) {
          var f6 = a.apply(r6, t2);
          function d6(m6) {
            Ebe(f6, s, u, d6, v6, "next", m6);
          }
          function v6(m6) {
            Ebe(f6, s, u, d6, v6, "throw", m6);
          }
          d6(void 0);
        });
      };
    }
    function VA() {
      return VA = Object.assign || function(a) {
        for (var r6 = 1; r6 < arguments.length; r6++) {
          var t2 = arguments[r6];
          for (var s in t2)
            Object.prototype.hasOwnProperty.call(t2, s) && (a[s] = t2[s]);
        }
        return a;
      }, VA.apply(this, arguments);
    }
    function xKe(a, r6) {
      a.prototype = Object.create(r6.prototype), a.prototype.constructor = a, L4(a, r6);
    }
    function vQ(a) {
      return vQ = Object.setPrototypeOf ? Object.getPrototypeOf : function(r6) {
        return r6.__proto__ || Object.getPrototypeOf(r6);
      }, vQ(a);
    }
    function L4(a, r6) {
      return L4 = Object.setPrototypeOf || function(t2, s) {
        return t2.__proto__ = s, t2;
      }, L4(a, r6);
    }
    function wKe() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function mB(a, r6, t2) {
      return wKe() ? mB = Reflect.construct : mB = function(s, u, f6) {
        var d6 = [null];
        d6.push.apply(d6, u);
        var v6 = Function.bind.apply(s, d6), m6 = new v6();
        return f6 && L4(m6, f6.prototype), m6;
      }, mB.apply(null, arguments);
    }
    function SKe(a) {
      return Function.toString.call(a).indexOf("[native code]") !== -1;
    }
    function gQ(a) {
      var r6 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
      return gQ = function(t2) {
        if (t2 === null || !SKe(t2))
          return t2;
        if (typeof t2 != "function")
          throw new TypeError("Super expression must either be null or a function");
        if (typeof r6 != "undefined") {
          if (r6.has(t2))
            return r6.get(t2);
          r6.set(t2, s);
        }
        function s() {
          return mB(t2, arguments, vQ(this).constructor);
        }
        return s.prototype = Object.create(t2.prototype, { constructor: { value: s, enumerable: false, writable: true, configurable: true } }), L4(s, t2);
      }, gQ(a);
    }
    var CKe = /%[sdj%]/g, MKe = function() {
    };
    typeof process != "undefined" && process.env;
    function mQ(a) {
      if (!a || !a.length)
        return null;
      var r6 = {};
      return a.forEach(function(t2) {
        var s = t2.field;
        r6[s] = r6[s] || [], r6[s].push(t2);
      }), r6;
    }
    function m0(a) {
      for (var r6 = arguments.length, t2 = new Array(r6 > 1 ? r6 - 1 : 0), s = 1; s < r6; s++)
        t2[s - 1] = arguments[s];
      var u = 0, f6 = t2.length;
      if (typeof a == "function")
        return a.apply(null, t2);
      if (typeof a == "string") {
        var d6 = a.replace(CKe, function(v6) {
          if (v6 === "%%")
            return "%";
          if (u >= f6)
            return v6;
          switch (v6) {
            case "%s":
              return String(t2[u++]);
            case "%d":
              return Number(t2[u++]);
            case "%j":
              try {
                return JSON.stringify(t2[u++]);
              } catch {
                return "[Circular]";
              }
              break;
            default:
              return v6;
          }
        });
        return d6;
      }
      return a;
    }
    function AKe(a) {
      return a === "string" || a === "url" || a === "hex" || a === "email" || a === "date" || a === "pattern";
    }
    function Dh(a, r6) {
      return !!(a == null || r6 === "array" && Array.isArray(a) && !a.length || AKe(r6) && typeof a == "string" && !a);
    }
    function EKe(a, r6, t2) {
      var s = [], u = 0, f6 = a.length;
      function d6(v6) {
        s.push.apply(s, v6 || []), u++, u === f6 && t2(s);
      }
      a.forEach(function(v6) {
        r6(v6, d6);
      });
    }
    function Ibe(a, r6, t2) {
      var s = 0, u = a.length;
      function f6(d6) {
        if (d6 && d6.length) {
          t2(d6);
          return;
        }
        var v6 = s;
        s = s + 1, v6 < u ? r6(a[v6], f6) : t2([]);
      }
      f6([]);
    }
    function IKe(a) {
      var r6 = [];
      return Object.keys(a).forEach(function(t2) {
        r6.push.apply(r6, a[t2] || []);
      }), r6;
    }
    var Tbe = function(a) {
      xKe(r6, a);
      function r6(t2, s) {
        var u;
        return u = a.call(this, "Async Validation Error") || this, u.errors = t2, u.fields = s, u;
      }
      return r6;
    }(gQ(Error));
    function TKe(a, r6, t2, s, u) {
      if (r6.first) {
        var f6 = new Promise(function(M, A6) {
          var I = function(F) {
            return s(F), F.length ? A6(new Tbe(F, mQ(F))) : M(u);
          }, R = IKe(a);
          Ibe(R, t2, I);
        });
        return f6.catch(function(M) {
          return M;
        }), f6;
      }
      var d6 = r6.firstFields === true ? Object.keys(a) : r6.firstFields || [], v6 = Object.keys(a), m6 = v6.length, b6 = 0, x6 = [], S = new Promise(function(M, A6) {
        var I = function(R) {
          if (x6.push.apply(x6, R), b6++, b6 === m6)
            return s(x6), x6.length ? A6(new Tbe(x6, mQ(x6))) : M(u);
        };
        v6.length || (s(x6), M(u)), v6.forEach(function(R) {
          var F = a[R];
          d6.indexOf(R) !== -1 ? Ibe(F, t2, I) : EKe(F, t2, I);
        });
      });
      return S.catch(function(M) {
        return M;
      }), S;
    }
    function DKe(a) {
      return !!(a && a.message !== void 0);
    }
    function kKe(a, r6) {
      for (var t2 = a, s = 0; s < r6.length; s++) {
        if (t2 == null)
          return t2;
        t2 = t2[r6[s]];
      }
      return t2;
    }
    function Dbe(a, r6) {
      return function(t2) {
        var s;
        return a.fullFields ? s = kKe(r6, a.fullFields) : s = r6[t2.field || a.fullField], DKe(t2) ? (t2.field = t2.field || a.fullField, t2.fieldValue = s, t2) : { message: typeof t2 == "function" ? t2() : t2, fieldValue: s, field: t2.field || a.fullField };
      };
    }
    function kbe(a, r6) {
      if (r6) {
        for (var t2 in r6)
          if (r6.hasOwnProperty(t2)) {
            var s = r6[t2];
            typeof s == "object" && typeof a[t2] == "object" ? a[t2] = VA({}, a[t2], s) : a[t2] = s;
          }
      }
      return a;
    }
    var Pbe = function(a, r6, t2, s, u, f6) {
      a.required && (!t2.hasOwnProperty(a.field) || Dh(r6, f6 || a.type)) && s.push(m0(u.messages.required, a.fullField));
    }, PKe = function(a, r6, t2, s, u) {
      (/^\s+$/.test(r6) || r6 === "") && s.push(m0(u.messages.whitespace, a.fullField));
    }, yQ = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, O4 = { integer: function(a) {
      return O4.number(a) && parseInt(a, 10) === a;
    }, float: function(a) {
      return O4.number(a) && !O4.integer(a);
    }, array: function(a) {
      return Array.isArray(a);
    }, regexp: function(a) {
      if (a instanceof RegExp)
        return true;
      try {
        return !!new RegExp(a);
      } catch {
        return false;
      }
    }, date: function(a) {
      return typeof a.getTime == "function" && typeof a.getMonth == "function" && typeof a.getYear == "function" && !isNaN(a.getTime());
    }, number: function(a) {
      return isNaN(a) ? false : typeof a == "number";
    }, object: function(a) {
      return typeof a == "object" && !O4.array(a);
    }, method: function(a) {
      return typeof a == "function";
    }, email: function(a) {
      return typeof a == "string" && a.length <= 320 && !!a.match(yQ.email);
    }, url: function(a) {
      return typeof a == "string" && a.length <= 2048 && !!a.match(yQ.url);
    }, hex: function(a) {
      return typeof a == "string" && !!a.match(yQ.hex);
    } }, LKe = function(a, r6, t2, s, u) {
      if (a.required && r6 === void 0) {
        Pbe(a, r6, t2, s, u);
        return;
      }
      var f6 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], d6 = a.type;
      f6.indexOf(d6) > -1 ? O4[d6](r6) || s.push(m0(u.messages.types[d6], a.fullField, a.type)) : d6 && typeof r6 !== a.type && s.push(m0(u.messages.types[d6], a.fullField, a.type));
    }, OKe = function(a, r6, t2, s, u) {
      var f6 = typeof a.len == "number", d6 = typeof a.min == "number", v6 = typeof a.max == "number", m6 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, b6 = r6, x6 = null, S = typeof r6 == "number", M = typeof r6 == "string", A6 = Array.isArray(r6);
      if (S ? x6 = "number" : M ? x6 = "string" : A6 && (x6 = "array"), !x6)
        return false;
      A6 && (b6 = r6.length), M && (b6 = r6.replace(m6, "_").length), f6 ? b6 !== a.len && s.push(m0(u.messages[x6].len, a.fullField, a.len)) : d6 && !v6 && b6 < a.min ? s.push(m0(u.messages[x6].min, a.fullField, a.min)) : v6 && !d6 && b6 > a.max ? s.push(m0(u.messages[x6].max, a.fullField, a.max)) : d6 && v6 && (b6 < a.min || b6 > a.max) && s.push(m0(u.messages[x6].range, a.fullField, a.min, a.max));
    }, N5 = "enum", RKe = function(a, r6, t2, s, u) {
      a[N5] = Array.isArray(a[N5]) ? a[N5] : [], a[N5].indexOf(r6) === -1 && s.push(m0(u.messages[N5], a.fullField, a[N5].join(", ")));
    }, FKe = function(a, r6, t2, s, u) {
      if (a.pattern) {
        if (a.pattern instanceof RegExp)
          a.pattern.lastIndex = 0, a.pattern.test(r6) || s.push(m0(u.messages.pattern.mismatch, a.fullField, r6, a.pattern));
        else if (typeof a.pattern == "string") {
          var f6 = new RegExp(a.pattern);
          f6.test(r6) || s.push(m0(u.messages.pattern.mismatch, a.fullField, r6, a.pattern));
        }
      }
    }, fl = { required: Pbe, whitespace: PKe, type: LKe, range: OKe, enum: RKe, pattern: FKe }, NKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6, "string") && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u, "string"), Dh(r6, "string") || (fl.type(a, r6, s, f6, u), fl.range(a, r6, s, f6, u), fl.pattern(a, r6, s, f6, u), a.whitespace === true && fl.whitespace(a, r6, s, f6, u));
      }
      t2(f6);
    }, VKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && fl.type(a, r6, s, f6, u);
      }
      t2(f6);
    }, zKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (r6 === "" && (r6 = void 0), Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && (fl.type(a, r6, s, f6, u), fl.range(a, r6, s, f6, u));
      }
      t2(f6);
    }, BKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && fl.type(a, r6, s, f6, u);
      }
      t2(f6);
    }, jKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), Dh(r6) || fl.type(a, r6, s, f6, u);
      }
      t2(f6);
    }, GKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && (fl.type(a, r6, s, f6, u), fl.range(a, r6, s, f6, u));
      }
      t2(f6);
    }, WKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && (fl.type(a, r6, s, f6, u), fl.range(a, r6, s, f6, u));
      }
      t2(f6);
    }, HKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (r6 == null && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u, "array"), r6 != null && (fl.type(a, r6, s, f6, u), fl.range(a, r6, s, f6, u));
      }
      t2(f6);
    }, $Ke = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && fl.type(a, r6, s, f6, u);
      }
      t2(f6);
    }, UKe = "enum", qKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), r6 !== void 0 && fl[UKe](a, r6, s, f6, u);
      }
      t2(f6);
    }, YKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6, "string") && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u), Dh(r6, "string") || fl.pattern(a, r6, s, f6, u);
      }
      t2(f6);
    }, ZKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6, "date") && !a.required)
          return t2();
        if (fl.required(a, r6, s, f6, u), !Dh(r6, "date")) {
          var v6;
          r6 instanceof Date ? v6 = r6 : v6 = new Date(r6), fl.type(a, v6, s, f6, u), v6 && fl.range(a, v6.getTime(), s, f6, u);
        }
      }
      t2(f6);
    }, XKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = Array.isArray(r6) ? "array" : typeof r6;
      fl.required(a, r6, s, f6, u, d6), t2(f6);
    }, bQ = function(a, r6, t2, s, u) {
      var f6 = a.type, d6 = [], v6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (v6) {
        if (Dh(r6, f6) && !a.required)
          return t2();
        fl.required(a, r6, s, d6, u, f6), Dh(r6, f6) || fl.type(a, r6, s, d6, u);
      }
      t2(d6);
    }, KKe = function(a, r6, t2, s, u) {
      var f6 = [], d6 = a.required || !a.required && s.hasOwnProperty(a.field);
      if (d6) {
        if (Dh(r6) && !a.required)
          return t2();
        fl.required(a, r6, s, f6, u);
      }
      t2(f6);
    }, R4 = { string: NKe, method: VKe, number: zKe, boolean: BKe, regexp: jKe, integer: GKe, float: WKe, array: HKe, object: $Ke, enum: qKe, pattern: YKe, date: ZKe, url: bQ, hex: bQ, email: bQ, required: XKe, any: KKe };
    function _Q() {
      return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
        var a = JSON.parse(JSON.stringify(this));
        return a.clone = this.clone, a;
      } };
    }
    var xQ = _Q(), F4 = function() {
      function a(t2) {
        this.rules = null, this._messages = xQ, this.define(t2);
      }
      var r6 = a.prototype;
      return r6.define = function(t2) {
        var s = this;
        if (!t2)
          throw new Error("Cannot configure a schema with no rules");
        if (typeof t2 != "object" || Array.isArray(t2))
          throw new Error("Rules must be an object");
        this.rules = {}, Object.keys(t2).forEach(function(u) {
          var f6 = t2[u];
          s.rules[u] = Array.isArray(f6) ? f6 : [f6];
        });
      }, r6.messages = function(t2) {
        return t2 && (this._messages = kbe(_Q(), t2)), this._messages;
      }, r6.validate = function(t2, s, u) {
        var f6 = this;
        s === void 0 && (s = {}), u === void 0 && (u = function() {
        });
        var d6 = t2, v6 = s, m6 = u;
        if (typeof v6 == "function" && (m6 = v6, v6 = {}), !this.rules || Object.keys(this.rules).length === 0)
          return m6 && m6(null, d6), Promise.resolve(d6);
        function b6(I) {
          var R = [], F = {};
          function j(K) {
            if (Array.isArray(K)) {
              var U;
              R = (U = R).concat.apply(U, K);
            } else
              R.push(K);
          }
          for (var $ = 0; $ < I.length; $++)
            j(I[$]);
          R.length ? (F = mQ(R), m6(R, F)) : m6(null, d6);
        }
        if (v6.messages) {
          var x6 = this.messages();
          x6 === xQ && (x6 = _Q()), kbe(x6, v6.messages), v6.messages = x6;
        } else
          v6.messages = this.messages();
        var S = {}, M = v6.keys || Object.keys(this.rules);
        M.forEach(function(I) {
          var R = f6.rules[I], F = d6[I];
          R.forEach(function(j) {
            var $ = j;
            typeof $.transform == "function" && (d6 === t2 && (d6 = VA({}, d6)), F = d6[I] = $.transform(F)), typeof $ == "function" ? $ = { validator: $ } : $ = VA({}, $), $.validator = f6.getValidationMethod($), $.validator && ($.field = I, $.fullField = $.fullField || I, $.type = f6.getType($), S[I] = S[I] || [], S[I].push({ rule: $, value: F, source: d6, field: I }));
          });
        });
        var A6 = {};
        return TKe(S, v6, function(I, R) {
          var F = I.rule, j = (F.type === "object" || F.type === "array") && (typeof F.fields == "object" || typeof F.defaultField == "object");
          j = j && (F.required || !F.required && I.value), F.field = I.field;
          function $(he, ue) {
            return VA({}, ue, { fullField: F.fullField + "." + he, fullFields: F.fullFields ? [].concat(F.fullFields, [he]) : [he] });
          }
          function K(he) {
            he === void 0 && (he = []);
            var ue = Array.isArray(he) ? he : [he];
            !v6.suppressWarning && ue.length && a.warning("async-validator:", ue), ue.length && F.message !== void 0 && (ue = [].concat(F.message));
            var pe = ue.map(Dbe(F, d6));
            if (v6.first && pe.length)
              return A6[F.field] = 1, R(pe);
            if (!j)
              R(pe);
            else {
              if (F.required && !I.value)
                return F.message !== void 0 ? pe = [].concat(F.message).map(Dbe(F, d6)) : v6.error && (pe = [v6.error(F, m0(v6.messages.required, F.field))]), R(pe);
              var _e = {};
              F.defaultField && Object.keys(I.value).map(function(ke) {
                _e[ke] = F.defaultField;
              }), _e = VA({}, _e, I.rule.fields);
              var xe = {};
              Object.keys(_e).forEach(function(ke) {
                var je = _e[ke], Fe = Array.isArray(je) ? je : [je];
                xe[ke] = Fe.map($.bind(null, ke));
              });
              var Ae = new a(xe);
              Ae.messages(v6.messages), I.rule.options && (I.rule.options.messages = v6.messages, I.rule.options.error = v6.error), Ae.validate(I.value, I.rule.options || v6, function(ke) {
                var je = [];
                pe && pe.length && je.push.apply(je, pe), ke && ke.length && je.push.apply(je, ke), R(je.length ? je : null);
              });
            }
          }
          var U;
          F.asyncValidator ? U = F.asyncValidator(F, I.value, K, I.source, v6) : F.validator && (U = F.validator(F, I.value, K, I.source, v6), U === true ? K() : U === false ? K(typeof F.message == "function" ? F.message(F.fullField || F.field) : F.message || (F.fullField || F.field) + " fails") : U instanceof Array ? K(U) : U instanceof Error && K(U.message)), U && U.then && U.then(function() {
            return K();
          }, function(he) {
            return K(he);
          });
        }, function(I) {
          b6(I);
        }, d6);
      }, r6.getType = function(t2) {
        if (t2.type === void 0 && t2.pattern instanceof RegExp && (t2.type = "pattern"), typeof t2.validator != "function" && t2.type && !R4.hasOwnProperty(t2.type))
          throw new Error(m0("Unknown rule type %s", t2.type));
        return t2.type || "string";
      }, r6.getValidationMethod = function(t2) {
        if (typeof t2.validator == "function")
          return t2.validator;
        var s = Object.keys(t2), u = s.indexOf("message");
        return u !== -1 && s.splice(u, 1), s.length === 1 && s[0] === "required" ? R4.required : R4[this.getType(t2)] || void 0;
      }, a;
    }();
    F4.register = function(a, r6) {
      if (typeof r6 != "function")
        throw new Error("Cannot register a validator by type, validator is not a function");
      R4[a] = r6;
    }, F4.warning = MKe, F4.messages = xQ, F4.validators = R4;
    var y0 = "'${name}' is not a valid ${type}", Lbe = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: y0, method: y0, array: y0, object: y0, number: y0, date: y0, boolean: y0, integer: y0, float: y0, regexp: y0, email: y0, url: y0, hex: y0 }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
    function Obe(a, r6) {
      for (var t2 = a, s = 0; s < r6.length; s += 1) {
        if (t2 == null)
          return;
        t2 = t2[r6[s]];
      }
      return t2;
    }
    function JKe(a) {
      return ebe(a) || Mbe(a) || qJ(a) || tbe();
    }
    function Rbe(a, r6, t2, s) {
      if (!r6.length)
        return t2;
      var u = JKe(r6), f6 = u[0], d6 = u.slice(1), v6;
      return !a && typeof f6 == "number" ? v6 = [] : Array.isArray(a) ? v6 = ml(a) : v6 = Go({}, a), s && t2 === void 0 && d6.length === 1 ? delete v6[f6][d6[0]] : v6[f6] = Rbe(v6[f6], d6, t2, s), v6;
    }
    function QKe(a, r6, t2) {
      var s = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
      return r6.length && s && t2 === void 0 && !Obe(a, r6.slice(0, -1)) ? a : Rbe(a, r6, t2, s);
    }
    function oh(a) {
      return pQ(a);
    }
    function V5(a, r6) {
      var t2 = Obe(a, r6);
      return t2;
    }
    function zA(a, r6, t2) {
      var s = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, u = QKe(a, r6, t2, s);
      return u;
    }
    function Fbe(a, r6) {
      var t2 = {};
      return r6.forEach(function(s) {
        var u = V5(a, s);
        t2 = zA(t2, s, u);
      }), t2;
    }
    function N4(a, r6) {
      return a && a.some(function(t2) {
        return zbe(t2, r6);
      });
    }
    function Nbe(a) {
      return Hp(a) === "object" && a !== null && Object.getPrototypeOf(a) === Object.prototype;
    }
    function Vbe(a, r6) {
      var t2 = Array.isArray(a) ? ml(a) : Go({}, a);
      return r6 && Object.keys(r6).forEach(function(s) {
        var u = t2[s], f6 = r6[s], d6 = Nbe(u) && Nbe(f6);
        t2[s] = d6 ? Vbe(u, f6 || {}) : f6;
      }), t2;
    }
    function yB(a) {
      for (var r6 = arguments.length, t2 = new Array(r6 > 1 ? r6 - 1 : 0), s = 1; s < r6; s++)
        t2[s - 1] = arguments[s];
      return t2.reduce(function(u, f6) {
        return Vbe(u, f6);
      }, a);
    }
    function zbe(a, r6) {
      return !a || !r6 || a.length !== r6.length ? false : a.every(function(t2, s) {
        return r6[s] === t2;
      });
    }
    function eJe(a, r6) {
      if (a === r6)
        return true;
      if (!a && r6 || a && !r6 || !a || !r6 || Hp(a) !== "object" || Hp(r6) !== "object")
        return false;
      var t2 = Object.keys(a), s = Object.keys(r6), u = new Set([].concat(ml(t2), ml(s)));
      return ml(u).every(function(f6) {
        var d6 = a[f6], v6 = r6[f6];
        return typeof d6 == "function" && typeof v6 == "function" ? true : d6 === v6;
      });
    }
    function tJe(a) {
      var r6 = arguments.length <= 1 ? void 0 : arguments[1];
      return r6 && r6.target && Hp(r6.target) === "object" && a in r6.target ? r6.target[a] : r6;
    }
    function Bbe(a, r6, t2) {
      var s = a.length;
      if (r6 < 0 || r6 >= s || t2 < 0 || t2 >= s)
        return a;
      var u = a[r6], f6 = r6 - t2;
      return f6 > 0 ? [].concat(ml(a.slice(0, t2)), [u], ml(a.slice(t2, r6)), ml(a.slice(r6 + 1, s))) : f6 < 0 ? [].concat(ml(a.slice(0, r6)), ml(a.slice(r6 + 1, t2 + 1)), [u], ml(a.slice(t2 + 1, s))) : a;
    }
    var nJe = F4;
    function rJe(a, r6) {
      return a.replace(/\$\{\w+\}/g, function(t2) {
        var s = t2.slice(2, -1);
        return r6[s];
      });
    }
    function wQ(a, r6, t2, s, u) {
      return SQ.apply(this, arguments);
    }
    function SQ() {
      return SQ = gB(gS.mark(function a(r6, t2, s, u, f6) {
        var d6, v6, m6, b6, x6, S, M, A6;
        return gS.wrap(function(I) {
          for (; ; )
            switch (I.prev = I.next) {
              case 0:
                return d6 = Go({}, s), delete d6.ruleIndex, v6 = null, d6 && d6.type === "array" && d6.defaultField && (v6 = d6.defaultField, delete d6.defaultField), m6 = new nJe(iu({}, r6, [d6])), b6 = yB({}, Lbe, u.validateMessages), m6.messages(b6), x6 = [], I.prev = 8, I.next = 11, Promise.resolve(m6.validate(iu({}, r6, t2), Go({}, u)));
              case 11:
                I.next = 16;
                break;
              case 13:
                I.prev = 13, I.t0 = I.catch(8), I.t0.errors ? x6 = I.t0.errors.map(function(R, F) {
                  var j = R.message;
                  return C.isValidElement(j) ? C.cloneElement(j, { key: "error_".concat(F) }) : j;
                }) : (console.error(I.t0), x6 = [b6.default]);
              case 16:
                if (!(!x6.length && v6)) {
                  I.next = 21;
                  break;
                }
                return I.next = 19, Promise.all(t2.map(function(R, F) {
                  return wQ("".concat(r6, ".").concat(F), R, v6, u, f6);
                }));
              case 19:
                return S = I.sent, I.abrupt("return", S.reduce(function(R, F) {
                  return [].concat(ml(R), ml(F));
                }, []));
              case 21:
                return M = Go(Go({}, s), {}, { name: r6, enum: (s.enum || []).join(", ") }, f6), A6 = x6.map(function(R) {
                  return typeof R == "string" ? rJe(R, M) : R;
                }), I.abrupt("return", A6);
              case 24:
              case "end":
                return I.stop();
            }
        }, a, null, [[8, 13]]);
      })), SQ.apply(this, arguments);
    }
    function aJe(a, r6, t2, s, u, f6) {
      var d6 = a.join("."), v6 = t2.map(function(x6, S) {
        var M = x6.validator, A6 = Go(Go({}, x6), {}, { ruleIndex: S });
        return M && (A6.validator = function(I, R, F) {
          var j = false, $ = function() {
            for (var U = arguments.length, he = new Array(U), ue = 0; ue < U; ue++)
              he[ue] = arguments[ue];
            Promise.resolve().then(function() {
              $b(!j, "Your validator function has already return a promise. `callback` will be ignored."), j || F.apply(void 0, he);
            });
          }, K = M(I, R, $);
          j = K && typeof K.then == "function" && typeof K.catch == "function", $b(j, "`callback` is deprecated. Please return a promise instead."), j && K.then(function() {
            F();
          }).catch(function(U) {
            F(U || " ");
          });
        }), A6;
      }).sort(function(x6, S) {
        var M = x6.warningOnly, A6 = x6.ruleIndex, I = S.warningOnly, R = S.ruleIndex;
        return !!M == !!I ? A6 - R : M ? 1 : -1;
      }), m6;
      if (u === true)
        m6 = new Promise(function() {
          var x6 = gB(gS.mark(function S(M, A6) {
            var I, R, F;
            return gS.wrap(function(j) {
              for (; ; )
                switch (j.prev = j.next) {
                  case 0:
                    I = 0;
                  case 1:
                    if (!(I < v6.length)) {
                      j.next = 12;
                      break;
                    }
                    return R = v6[I], j.next = 5, wQ(d6, r6, R, s, f6);
                  case 5:
                    if (F = j.sent, !F.length) {
                      j.next = 9;
                      break;
                    }
                    return A6([{ errors: F, rule: R }]), j.abrupt("return");
                  case 9:
                    I += 1, j.next = 1;
                    break;
                  case 12:
                    M([]);
                  case 13:
                  case "end":
                    return j.stop();
                }
            }, S);
          }));
          return function(S, M) {
            return x6.apply(this, arguments);
          };
        }());
      else {
        var b6 = v6.map(function(x6) {
          return wQ(d6, r6, x6, s, f6).then(function(S) {
            return { errors: S, rule: x6 };
          });
        });
        m6 = (u ? oJe(b6) : iJe(b6)).then(function(x6) {
          return Promise.reject(x6);
        });
      }
      return m6.catch(function(x6) {
        return x6;
      }), m6;
    }
    function iJe(a) {
      return CQ.apply(this, arguments);
    }
    function CQ() {
      return CQ = gB(gS.mark(function a(r6) {
        return gS.wrap(function(t2) {
          for (; ; )
            switch (t2.prev = t2.next) {
              case 0:
                return t2.abrupt("return", Promise.all(r6).then(function(s) {
                  var u, f6 = (u = []).concat.apply(u, ml(s));
                  return f6;
                }));
              case 1:
              case "end":
                return t2.stop();
            }
        }, a);
      })), CQ.apply(this, arguments);
    }
    function oJe(a) {
      return MQ.apply(this, arguments);
    }
    function MQ() {
      return MQ = gB(gS.mark(function a(r6) {
        var t2;
        return gS.wrap(function(s) {
          for (; ; )
            switch (s.prev = s.next) {
              case 0:
                return t2 = 0, s.abrupt("return", new Promise(function(u) {
                  r6.forEach(function(f6) {
                    f6.then(function(d6) {
                      d6.errors.length && u([d6]), t2 += 1, t2 === r6.length && u([]);
                    });
                  });
                }));
              case 2:
              case "end":
                return s.stop();
            }
        }, a);
      })), MQ.apply(this, arguments);
    }
    var sJe = ["name"], Hm = [];
    function jbe(a, r6, t2, s, u, f6) {
      return typeof a == "function" ? a(r6, t2, "source" in f6 ? { source: f6.source } : {}) : s !== u;
    }
    var AQ = function(a) {
      oQ(t2, a);
      var r6 = lQ(t2);
      function t2(s) {
        var u;
        if (D4(this, t2), u = r6.call(this, s), u.state = { resetCount: 0 }, u.cancelRegisterFunc = null, u.mounted = false, u.touched = false, u.dirty = false, u.validatePromise = null, u.prevValidating = void 0, u.errors = Hm, u.warnings = Hm, u.cancelRegister = function() {
          var m6 = u.props, b6 = m6.preserve, x6 = m6.isListField, S = m6.name;
          u.cancelRegisterFunc && u.cancelRegisterFunc(x6, b6, oh(S)), u.cancelRegisterFunc = null;
        }, u.getNamePath = function() {
          var m6 = u.props, b6 = m6.name, x6 = m6.fieldContext, S = x6.prefixName, M = S === void 0 ? [] : S;
          return b6 !== void 0 ? [].concat(ml(M), ml(b6)) : [];
        }, u.getRules = function() {
          var m6 = u.props, b6 = m6.rules, x6 = b6 === void 0 ? [] : b6, S = m6.fieldContext;
          return x6.map(function(M) {
            return typeof M == "function" ? M(S) : M;
          });
        }, u.refresh = function() {
          !u.mounted || u.setState(function(m6) {
            var b6 = m6.resetCount;
            return { resetCount: b6 + 1 };
          });
        }, u.triggerMetaEvent = function(m6) {
          var b6 = u.props.onMetaChange;
          b6 == null || b6(Go(Go({}, u.getMeta()), {}, { destroy: m6 }));
        }, u.onStoreChange = function(m6, b6, x6) {
          var S = u.props, M = S.shouldUpdate, A6 = S.dependencies, I = A6 === void 0 ? [] : A6, R = S.onReset, F = x6.store, j = u.getNamePath(), $ = u.getValue(m6), K = u.getValue(F), U = b6 && N4(b6, j);
          switch (x6.type === "valueUpdate" && x6.source === "external" && $ !== K && (u.touched = true, u.dirty = true, u.validatePromise = null, u.errors = Hm, u.warnings = Hm, u.triggerMetaEvent()), x6.type) {
            case "reset":
              if (!b6 || U) {
                u.touched = false, u.dirty = false, u.validatePromise = null, u.errors = Hm, u.warnings = Hm, u.triggerMetaEvent(), R == null || R(), u.refresh();
                return;
              }
              break;
            case "remove": {
              if (M) {
                u.reRender();
                return;
              }
              break;
            }
            case "setField": {
              if (U) {
                var he = x6.data;
                "touched" in he && (u.touched = he.touched), "validating" in he && !("originRCField" in he) && (u.validatePromise = he.validating ? Promise.resolve([]) : null), "errors" in he && (u.errors = he.errors || Hm), "warnings" in he && (u.warnings = he.warnings || Hm), u.dirty = true, u.triggerMetaEvent(), u.reRender();
                return;
              }
              if (M && !j.length && jbe(M, m6, F, $, K, x6)) {
                u.reRender();
                return;
              }
              break;
            }
            case "dependenciesUpdate": {
              var ue = I.map(oh);
              if (ue.some(function(pe) {
                return N4(x6.relatedFields, pe);
              })) {
                u.reRender();
                return;
              }
              break;
            }
            default:
              if (U || (!I.length || j.length || M) && jbe(M, m6, F, $, K, x6)) {
                u.reRender();
                return;
              }
              break;
          }
          M === true && u.reRender();
        }, u.validateRules = function(m6) {
          var b6 = u.getNamePath(), x6 = u.getValue(), S = Promise.resolve().then(function() {
            if (!u.mounted)
              return [];
            var M = u.props, A6 = M.validateFirst, I = A6 === void 0 ? false : A6, R = M.messageVariables, F = m6 || {}, j = F.triggerName, $ = u.getRules();
            j && ($ = $.filter(function(U) {
              var he = U.validateTrigger;
              if (!he)
                return true;
              var ue = pQ(he);
              return ue.includes(j);
            }));
            var K = aJe(b6, x6, $, m6, I, R);
            return K.catch(function(U) {
              return U;
            }).then(function() {
              var U = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Hm;
              if (u.validatePromise === S) {
                u.validatePromise = null;
                var he = [], ue = [];
                U.forEach(function(pe) {
                  var _e = pe.rule.warningOnly, xe = pe.errors, Ae = xe === void 0 ? Hm : xe;
                  _e ? ue.push.apply(ue, ml(Ae)) : he.push.apply(he, ml(Ae));
                }), u.errors = he, u.warnings = ue, u.triggerMetaEvent(), u.reRender();
              }
            }), K;
          });
          return u.validatePromise = S, u.dirty = true, u.errors = Hm, u.warnings = Hm, u.triggerMetaEvent(), u.reRender(), S;
        }, u.isFieldValidating = function() {
          return !!u.validatePromise;
        }, u.isFieldTouched = function() {
          return u.touched;
        }, u.isFieldDirty = function() {
          if (u.dirty || u.props.initialValue !== void 0)
            return true;
          var m6 = u.props.fieldContext, b6 = m6.getInternalHooks(F5), x6 = b6.getInitialValue;
          return x6(u.getNamePath()) !== void 0;
        }, u.getErrors = function() {
          return u.errors;
        }, u.getWarnings = function() {
          return u.warnings;
        }, u.isListField = function() {
          return u.props.isListField;
        }, u.isList = function() {
          return u.props.isList;
        }, u.isPreserve = function() {
          return u.props.preserve;
        }, u.getMeta = function() {
          u.prevValidating = u.isFieldValidating();
          var m6 = { touched: u.isFieldTouched(), validating: u.prevValidating, errors: u.errors, warnings: u.warnings, name: u.getNamePath() };
          return m6;
        }, u.getOnlyChild = function(m6) {
          if (typeof m6 == "function") {
            var b6 = u.getMeta();
            return Go(Go({}, u.getOnlyChild(m6(u.getControlled(), b6, u.props.fieldContext))), {}, { isFunction: true });
          }
          var x6 = dQ(m6);
          return x6.length !== 1 || !C.isValidElement(x6[0]) ? { child: x6, isFunction: false } : { child: x6[0], isFunction: false };
        }, u.getValue = function(m6) {
          var b6 = u.props.fieldContext.getFieldsValue, x6 = u.getNamePath();
          return V5(m6 || b6(true), x6);
        }, u.getControlled = function() {
          var m6 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, b6 = u.props, x6 = b6.trigger, S = b6.validateTrigger, M = b6.getValueFromEvent, A6 = b6.normalize, I = b6.valuePropName, R = b6.getValueProps, F = b6.fieldContext, j = S !== void 0 ? S : F.validateTrigger, $ = u.getNamePath(), K = F.getInternalHooks, U = F.getFieldsValue, he = K(F5), ue = he.dispatch, pe = u.getValue(), _e = R || function(je) {
            return iu({}, I, je);
          }, xe = m6[x6], Ae = Go(Go({}, m6), _e(pe));
          Ae[x6] = function() {
            u.touched = true, u.dirty = true, u.triggerMetaEvent();
            for (var je, Fe = arguments.length, at = new Array(Fe), ht = 0; ht < Fe; ht++)
              at[ht] = arguments[ht];
            M ? je = M.apply(void 0, at) : je = tJe.apply(void 0, [I].concat(at)), A6 && (je = A6(je, pe, U(true))), ue({ type: "updateValue", namePath: $, value: je }), xe && xe.apply(void 0, at);
          };
          var ke = pQ(j || []);
          return ke.forEach(function(je) {
            var Fe = Ae[je];
            Ae[je] = function() {
              Fe && Fe.apply(void 0, arguments);
              var at = u.props.rules;
              at && at.length && ue({ type: "validateField", namePath: $, triggerName: je });
            };
          }), Ae;
        }, s.fieldContext) {
          var f6 = s.fieldContext.getInternalHooks, d6 = f6(F5), v6 = d6.initEntityValue;
          v6(sQ(u));
        }
        return u;
      }
      return k4(t2, [{ key: "componentDidMount", value: function() {
        var s = this.props, u = s.shouldUpdate, f6 = s.fieldContext;
        if (this.mounted = true, f6) {
          var d6 = f6.getInternalHooks, v6 = d6(F5), m6 = v6.registerField;
          this.cancelRegisterFunc = m6(this);
        }
        u === true && this.reRender();
      } }, { key: "componentWillUnmount", value: function() {
        this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
      } }, { key: "reRender", value: function() {
        !this.mounted || this.forceUpdate();
      } }, { key: "render", value: function() {
        var s = this.state.resetCount, u = this.props.children, f6 = this.getOnlyChild(u), d6 = f6.child, v6 = f6.isFunction, m6;
        return v6 ? m6 = d6 : C.isValidElement(d6) ? m6 = C.cloneElement(d6, this.getControlled(d6.props)) : ($b(!d6, "`children` of Field is not validate ReactElement."), m6 = d6), C.createElement(C.Fragment, { key: s }, m6);
      } }]), t2;
    }(C.Component);
    AQ.contextType = P4, AQ.defaultProps = { trigger: "onChange", valuePropName: "value" };
    function Gbe(a) {
      var r6 = a.name, t2 = O5(a, sJe), s = C.useContext(P4), u = r6 !== void 0 ? oh(r6) : void 0, f6 = "keep";
      return t2.isListField || (f6 = "_".concat((u || []).join("_"))), C.createElement(AQ, ih({ key: f6, name: u }, t2, { fieldContext: s }));
    }
    var lJe = C.createContext(null), uJe = function(a) {
      var r6 = a.name, t2 = a.initialValue, s = a.children, u = a.rules, f6 = a.validateTrigger, d6 = C.useContext(P4), v6 = C.useRef({ keys: [], id: 0 }), m6 = v6.current, b6 = C.useMemo(function() {
        var A6 = oh(d6.prefixName) || [];
        return [].concat(ml(A6), ml(oh(r6)));
      }, [d6.prefixName, r6]), x6 = C.useMemo(function() {
        return Go(Go({}, d6), {}, { prefixName: b6 });
      }, [d6, b6]), S = C.useMemo(function() {
        return { getKey: function(A6) {
          var I = b6.length, R = A6[I];
          return [m6.keys[R], A6.slice(I + 1)];
        } };
      }, [b6]);
      if (typeof s != "function")
        return $b(false, "Form.List only accepts function as children."), null;
      var M = function(A6, I, R) {
        var F = R.source;
        return F === "internal" ? false : A6 !== I;
      };
      return C.createElement(lJe.Provider, { value: S }, C.createElement(P4.Provider, { value: x6 }, C.createElement(Gbe, { name: [], shouldUpdate: M, rules: u, validateTrigger: f6, initialValue: t2, isList: true }, function(A6, I) {
        var R = A6.value, F = R === void 0 ? [] : R, j = A6.onChange, $ = d6.getFieldValue, K = function() {
          var ue = $(b6 || []);
          return ue || [];
        }, U = { add: function(ue, pe) {
          var _e = K();
          pe >= 0 && pe <= _e.length ? (m6.keys = [].concat(ml(m6.keys.slice(0, pe)), [m6.id], ml(m6.keys.slice(pe))), j([].concat(ml(_e.slice(0, pe)), [ue], ml(_e.slice(pe))))) : (m6.keys = [].concat(ml(m6.keys), [m6.id]), j([].concat(ml(_e), [ue]))), m6.id += 1;
        }, remove: function(ue) {
          var pe = K(), _e = new Set(Array.isArray(ue) ? ue : [ue]);
          _e.size <= 0 || (m6.keys = m6.keys.filter(function(xe, Ae) {
            return !_e.has(Ae);
          }), j(pe.filter(function(xe, Ae) {
            return !_e.has(Ae);
          })));
        }, move: function(ue, pe) {
          if (ue !== pe) {
            var _e = K();
            ue < 0 || ue >= _e.length || pe < 0 || pe >= _e.length || (m6.keys = Bbe(m6.keys, ue, pe), j(Bbe(_e, ue, pe)));
          }
        } }, he = F || [];
        return Array.isArray(he) || (he = []), s(he.map(function(ue, pe) {
          var _e = m6.keys[pe];
          return _e === void 0 && (m6.keys[pe] = m6.id, _e = m6.keys[pe], m6.id += 1), { name: pe, key: _e, isListField: true };
        }), U, I);
      })));
    };
    function cJe(a) {
      var r6 = false, t2 = a.length, s = [];
      return a.length ? new Promise(function(u, f6) {
        a.forEach(function(d6, v6) {
          d6.catch(function(m6) {
            return r6 = true, m6;
          }).then(function(m6) {
            t2 -= 1, s[v6] = m6, !(t2 > 0) && (r6 && f6(s), u(s));
          });
        });
      }) : Promise.resolve([]);
    }
    var Wbe = "__@field_split__";
    function EQ(a) {
      return a.map(function(r6) {
        return "".concat(Hp(r6), ":").concat(r6);
      }).join(Wbe);
    }
    var V4 = function() {
      function a() {
        D4(this, a), this.kvs = /* @__PURE__ */ new Map();
      }
      return k4(a, [{ key: "set", value: function(r6, t2) {
        this.kvs.set(EQ(r6), t2);
      } }, { key: "get", value: function(r6) {
        return this.kvs.get(EQ(r6));
      } }, { key: "update", value: function(r6, t2) {
        var s = this.get(r6), u = t2(s);
        u ? this.set(r6, u) : this.delete(r6);
      } }, { key: "delete", value: function(r6) {
        this.kvs.delete(EQ(r6));
      } }, { key: "map", value: function(r6) {
        return ml(this.kvs.entries()).map(function(t2) {
          var s = Gm(t2, 2), u = s[0], f6 = s[1], d6 = u.split(Wbe);
          return r6({ key: d6.map(function(v6) {
            var m6 = v6.match(/^([^:]*):(.*)$/), b6 = Gm(m6, 3), x6 = b6[1], S = b6[2];
            return x6 === "number" ? Number(S) : S;
          }), value: f6 });
        });
      } }, { key: "toJSON", value: function() {
        var r6 = {};
        return this.map(function(t2) {
          var s = t2.key, u = t2.value;
          return r6[s.join(".")] = u, null;
        }), r6;
      } }]), a;
    }(), fJe = ["name", "errors"], hJe = k4(function a(r6) {
      var t2 = this;
      D4(this, a), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
        return { getFieldValue: t2.getFieldValue, getFieldsValue: t2.getFieldsValue, getFieldError: t2.getFieldError, getFieldWarning: t2.getFieldWarning, getFieldsError: t2.getFieldsError, isFieldsTouched: t2.isFieldsTouched, isFieldTouched: t2.isFieldTouched, isFieldValidating: t2.isFieldValidating, isFieldsValidating: t2.isFieldsValidating, resetFields: t2.resetFields, setFields: t2.setFields, setFieldsValue: t2.setFieldsValue, validateFields: t2.validateFields, submit: t2.submit, getInternalHooks: t2.getInternalHooks };
      }, this.getInternalHooks = function(s) {
        return s === F5 ? (t2.formHooked = true, { dispatch: t2.dispatch, initEntityValue: t2.initEntityValue, registerField: t2.registerField, useSubscribe: t2.useSubscribe, setInitialValues: t2.setInitialValues, setCallbacks: t2.setCallbacks, setValidateMessages: t2.setValidateMessages, getFields: t2.getFields, setPreserve: t2.setPreserve, getInitialValue: t2.getInitialValue }) : ($b(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
      }, this.useSubscribe = function(s) {
        t2.subscribable = s;
      }, this.setInitialValues = function(s, u) {
        t2.initialValues = s || {}, u && (t2.store = yB({}, s, t2.store));
      }, this.getInitialValue = function(s) {
        return V5(t2.initialValues, s);
      }, this.setCallbacks = function(s) {
        t2.callbacks = s;
      }, this.setValidateMessages = function(s) {
        t2.validateMessages = s;
      }, this.setPreserve = function(s) {
        t2.preserve = s;
      }, this.timeoutId = null, this.warningUnhooked = function() {
      }, this.getFieldEntities = function() {
        var s = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
        return s ? t2.fieldEntities.filter(function(u) {
          return u.getNamePath().length;
        }) : t2.fieldEntities;
      }, this.getFieldsMap = function() {
        var s = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, u = new V4();
        return t2.getFieldEntities(s).forEach(function(f6) {
          var d6 = f6.getNamePath();
          u.set(d6, f6);
        }), u;
      }, this.getFieldEntitiesForNamePathList = function(s) {
        if (!s)
          return t2.getFieldEntities(true);
        var u = t2.getFieldsMap(true);
        return s.map(function(f6) {
          var d6 = oh(f6);
          return u.get(d6) || { INVALIDATE_NAME_PATH: oh(f6) };
        });
      }, this.getFieldsValue = function(s, u) {
        if (t2.warningUnhooked(), s === true && !u)
          return t2.store;
        var f6 = t2.getFieldEntitiesForNamePathList(Array.isArray(s) ? s : null), d6 = [];
        return f6.forEach(function(v6) {
          var m6, b6 = "INVALIDATE_NAME_PATH" in v6 ? v6.INVALIDATE_NAME_PATH : v6.getNamePath();
          if (!(!s && ((m6 = v6.isListField) === null || m6 === void 0 ? void 0 : m6.call(v6))))
            if (!u)
              d6.push(b6);
            else {
              var x6 = "getMeta" in v6 ? v6.getMeta() : null;
              u(x6) && d6.push(b6);
            }
        }), Fbe(t2.store, d6.map(oh));
      }, this.getFieldValue = function(s) {
        t2.warningUnhooked();
        var u = oh(s);
        return V5(t2.store, u);
      }, this.getFieldsError = function(s) {
        t2.warningUnhooked();
        var u = t2.getFieldEntitiesForNamePathList(s);
        return u.map(function(f6, d6) {
          return f6 && !("INVALIDATE_NAME_PATH" in f6) ? { name: f6.getNamePath(), errors: f6.getErrors(), warnings: f6.getWarnings() } : { name: oh(s[d6]), errors: [], warnings: [] };
        });
      }, this.getFieldError = function(s) {
        t2.warningUnhooked();
        var u = oh(s), f6 = t2.getFieldsError([u])[0];
        return f6.errors;
      }, this.getFieldWarning = function(s) {
        t2.warningUnhooked();
        var u = oh(s), f6 = t2.getFieldsError([u])[0];
        return f6.warnings;
      }, this.isFieldsTouched = function() {
        t2.warningUnhooked();
        for (var s = arguments.length, u = new Array(s), f6 = 0; f6 < s; f6++)
          u[f6] = arguments[f6];
        var d6 = u[0], v6 = u[1], m6, b6 = false;
        u.length === 0 ? m6 = null : u.length === 1 ? Array.isArray(d6) ? (m6 = d6.map(oh), b6 = false) : (m6 = null, b6 = d6) : (m6 = d6.map(oh), b6 = v6);
        var x6 = t2.getFieldEntities(true), S = function(R) {
          return R.isFieldTouched();
        };
        if (!m6)
          return b6 ? x6.every(S) : x6.some(S);
        var M = new V4();
        m6.forEach(function(R) {
          M.set(R, []);
        }), x6.forEach(function(R) {
          var F = R.getNamePath();
          m6.forEach(function(j) {
            j.every(function($, K) {
              return F[K] === $;
            }) && M.update(j, function($) {
              return [].concat(ml($), [R]);
            });
          });
        });
        var A6 = function(R) {
          return R.some(S);
        }, I = M.map(function(R) {
          var F = R.value;
          return F;
        });
        return b6 ? I.every(A6) : I.some(A6);
      }, this.isFieldTouched = function(s) {
        return t2.warningUnhooked(), t2.isFieldsTouched([s]);
      }, this.isFieldsValidating = function(s) {
        t2.warningUnhooked();
        var u = t2.getFieldEntities();
        if (!s)
          return u.some(function(d6) {
            return d6.isFieldValidating();
          });
        var f6 = s.map(oh);
        return u.some(function(d6) {
          var v6 = d6.getNamePath();
          return N4(f6, v6) && d6.isFieldValidating();
        });
      }, this.isFieldValidating = function(s) {
        return t2.warningUnhooked(), t2.isFieldsValidating([s]);
      }, this.resetWithFieldInitialValue = function() {
        var s = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, u = new V4(), f6 = t2.getFieldEntities(true);
        f6.forEach(function(m6) {
          var b6 = m6.props.initialValue, x6 = m6.getNamePath();
          if (b6 !== void 0) {
            var S = u.get(x6) || /* @__PURE__ */ new Set();
            S.add({ entity: m6, value: b6 }), u.set(x6, S);
          }
        });
        var d6 = function(m6) {
          m6.forEach(function(b6) {
            var x6 = b6.props.initialValue;
            if (x6 !== void 0) {
              var S = b6.getNamePath(), M = t2.getInitialValue(S);
              if (M !== void 0)
                $b(false, "Form already set 'initialValues' with path '".concat(S.join("."), "'. Field can not overwrite it."));
              else {
                var A6 = u.get(S);
                if (A6 && A6.size > 1)
                  $b(false, "Multiple Field with path '".concat(S.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                else if (A6) {
                  var I = t2.getFieldValue(S);
                  (!s.skipExist || I === void 0) && (t2.store = zA(t2.store, S, ml(A6)[0].value));
                }
              }
            }
          });
        }, v6;
        s.entities ? v6 = s.entities : s.namePathList ? (v6 = [], s.namePathList.forEach(function(m6) {
          var b6 = u.get(m6);
          if (b6) {
            var x6;
            (x6 = v6).push.apply(x6, ml(ml(b6).map(function(S) {
              return S.entity;
            })));
          }
        })) : v6 = f6, d6(v6);
      }, this.resetFields = function(s) {
        t2.warningUnhooked();
        var u = t2.store;
        if (!s) {
          t2.store = yB({}, t2.initialValues), t2.resetWithFieldInitialValue(), t2.notifyObservers(u, null, { type: "reset" });
          return;
        }
        var f6 = s.map(oh);
        f6.forEach(function(d6) {
          var v6 = t2.getInitialValue(d6);
          t2.store = zA(t2.store, d6, v6);
        }), t2.resetWithFieldInitialValue({ namePathList: f6 }), t2.notifyObservers(u, f6, { type: "reset" });
      }, this.setFields = function(s) {
        t2.warningUnhooked();
        var u = t2.store;
        s.forEach(function(f6) {
          var d6 = f6.name;
          f6.errors;
          var v6 = O5(f6, fJe), m6 = oh(d6);
          "value" in v6 && (t2.store = zA(t2.store, m6, v6.value)), t2.notifyObservers(u, [m6], { type: "setField", data: f6 });
        });
      }, this.getFields = function() {
        var s = t2.getFieldEntities(true), u = s.map(function(f6) {
          var d6 = f6.getNamePath(), v6 = f6.getMeta(), m6 = Go(Go({}, v6), {}, { name: d6, value: t2.getFieldValue(d6) });
          return Object.defineProperty(m6, "originRCField", { value: true }), m6;
        });
        return u;
      }, this.initEntityValue = function(s) {
        var u = s.props.initialValue;
        if (u !== void 0) {
          var f6 = s.getNamePath(), d6 = V5(t2.store, f6);
          d6 === void 0 && (t2.store = zA(t2.store, f6, u));
        }
      }, this.registerField = function(s) {
        if (t2.fieldEntities.push(s), s.props.initialValue !== void 0) {
          var u = t2.store;
          t2.resetWithFieldInitialValue({ entities: [s], skipExist: true }), t2.notifyObservers(u, [s.getNamePath()], { type: "valueUpdate", source: "internal" });
        }
        return function(f6, d6) {
          var v6 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
          t2.fieldEntities = t2.fieldEntities.filter(function(M) {
            return M !== s;
          });
          var m6 = d6 !== void 0 ? d6 : t2.preserve;
          if (m6 === false && (!f6 || v6.length > 1)) {
            var b6 = s.getNamePath(), x6 = f6 ? void 0 : V5(t2.initialValues, b6);
            if (b6.length && t2.getFieldValue(b6) !== x6 && t2.fieldEntities.every(function(M) {
              return !zbe(M.getNamePath(), b6);
            })) {
              var S = t2.store;
              t2.store = zA(S, b6, x6, true), t2.notifyObservers(S, [b6], { type: "remove" }), t2.triggerDependenciesUpdate(S, b6);
            }
          }
        };
      }, this.dispatch = function(s) {
        switch (s.type) {
          case "updateValue": {
            var u = s.namePath, f6 = s.value;
            t2.updateValue(u, f6);
            break;
          }
          case "validateField": {
            var d6 = s.namePath, v6 = s.triggerName;
            t2.validateFields([d6], { triggerName: v6 });
            break;
          }
        }
      }, this.notifyObservers = function(s, u, f6) {
        if (t2.subscribable) {
          var d6 = Go(Go({}, f6), {}, { store: t2.getFieldsValue(true) });
          t2.getFieldEntities().forEach(function(v6) {
            var m6 = v6.onStoreChange;
            m6(s, u, d6);
          });
        } else
          t2.forceRootUpdate();
      }, this.triggerDependenciesUpdate = function(s, u) {
        var f6 = t2.getDependencyChildrenFields(u);
        return f6.length && t2.validateFields(f6), t2.notifyObservers(s, f6, { type: "dependenciesUpdate", relatedFields: [u].concat(ml(f6)) }), f6;
      }, this.updateValue = function(s, u) {
        var f6 = oh(s), d6 = t2.store;
        t2.store = zA(t2.store, f6, u), t2.notifyObservers(d6, [f6], { type: "valueUpdate", source: "internal" });
        var v6 = t2.triggerDependenciesUpdate(d6, f6), m6 = t2.callbacks.onValuesChange;
        if (m6) {
          var b6 = Fbe(t2.store, [f6]);
          m6(b6, t2.getFieldsValue());
        }
        t2.triggerOnFieldsChange([f6].concat(ml(v6)));
      }, this.setFieldsValue = function(s) {
        t2.warningUnhooked();
        var u = t2.store;
        s && (t2.store = yB(t2.store, s)), t2.notifyObservers(u, null, { type: "valueUpdate", source: "external" });
      }, this.getDependencyChildrenFields = function(s) {
        var u = /* @__PURE__ */ new Set(), f6 = [], d6 = new V4();
        t2.getFieldEntities().forEach(function(m6) {
          var b6 = m6.props.dependencies;
          (b6 || []).forEach(function(x6) {
            var S = oh(x6);
            d6.update(S, function() {
              var M = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
              return M.add(m6), M;
            });
          });
        });
        var v6 = function m6(b6) {
          var x6 = d6.get(b6) || /* @__PURE__ */ new Set();
          x6.forEach(function(S) {
            if (!u.has(S)) {
              u.add(S);
              var M = S.getNamePath();
              S.isFieldDirty() && M.length && (f6.push(M), m6(M));
            }
          });
        };
        return v6(s), f6;
      }, this.triggerOnFieldsChange = function(s, u) {
        var f6 = t2.callbacks.onFieldsChange;
        if (f6) {
          var d6 = t2.getFields();
          if (u) {
            var v6 = new V4();
            u.forEach(function(b6) {
              var x6 = b6.name, S = b6.errors;
              v6.set(x6, S);
            }), d6.forEach(function(b6) {
              b6.errors = v6.get(b6.name) || b6.errors;
            });
          }
          var m6 = d6.filter(function(b6) {
            var x6 = b6.name;
            return N4(s, x6);
          });
          f6(m6, d6);
        }
      }, this.validateFields = function(s, u) {
        t2.warningUnhooked();
        var f6 = !!s, d6 = f6 ? s.map(oh) : [], v6 = [];
        t2.getFieldEntities(true).forEach(function(x6) {
          if (f6 || d6.push(x6.getNamePath()), (u == null ? void 0 : u.recursive) && f6) {
            var S = x6.getNamePath();
            S.every(function(I, R) {
              return s[R] === I || s[R] === void 0;
            }) && d6.push(S);
          }
          if (!(!x6.props.rules || !x6.props.rules.length)) {
            var M = x6.getNamePath();
            if (!f6 || N4(d6, M)) {
              var A6 = x6.validateRules(Go({ validateMessages: Go(Go({}, Lbe), t2.validateMessages) }, u));
              v6.push(A6.then(function() {
                return { name: M, errors: [], warnings: [] };
              }).catch(function(I) {
                var R = [], F = [];
                return I.forEach(function(j) {
                  var $ = j.rule.warningOnly, K = j.errors;
                  $ ? F.push.apply(F, ml(K)) : R.push.apply(R, ml(K));
                }), R.length ? Promise.reject({ name: M, errors: R, warnings: F }) : { name: M, errors: R, warnings: F };
              }));
            }
          }
        });
        var m6 = cJe(v6);
        t2.lastValidatePromise = m6, m6.catch(function(x6) {
          return x6;
        }).then(function(x6) {
          var S = x6.map(function(M) {
            var A6 = M.name;
            return A6;
          });
          t2.notifyObservers(t2.store, S, { type: "validateFinish" }), t2.triggerOnFieldsChange(S, x6);
        });
        var b6 = m6.then(function() {
          return t2.lastValidatePromise === m6 ? Promise.resolve(t2.getFieldsValue(d6)) : Promise.reject([]);
        }).catch(function(x6) {
          var S = x6.filter(function(M) {
            return M && M.errors.length;
          });
          return Promise.reject({ values: t2.getFieldsValue(d6), errorFields: S, outOfDate: t2.lastValidatePromise !== m6 });
        });
        return b6.catch(function(x6) {
          return x6;
        }), b6;
      }, this.submit = function() {
        t2.warningUnhooked(), t2.validateFields().then(function(s) {
          var u = t2.callbacks.onFinish;
          if (u)
            try {
              u(s);
            } catch (f6) {
              console.error(f6);
            }
        }).catch(function(s) {
          var u = t2.callbacks.onFinishFailed;
          u && u(s);
        });
      }, this.forceRootUpdate = r6;
    });
    function Hbe(a) {
      var r6 = C.useRef(), t2 = C.useState({}), s = Gm(t2, 2), u = s[1];
      if (!r6.current)
        if (a)
          r6.current = a;
        else {
          var f6 = function() {
            u({});
          }, d6 = new hJe(f6);
          r6.current = d6.getForm();
        }
      return [r6.current];
    }
    var IQ = C.createContext({ triggerFormChange: function() {
    }, triggerFormFinish: function() {
    }, registerForm: function() {
    }, unregisterForm: function() {
    } }), dJe = function(a) {
      var r6 = a.validateMessages, t2 = a.onFormChange, s = a.onFormFinish, u = a.children, f6 = C.useContext(IQ), d6 = C.useRef({});
      return C.createElement(IQ.Provider, { value: Go(Go({}, f6), {}, { validateMessages: Go(Go({}, f6.validateMessages), r6), triggerFormChange: function(v6, m6) {
        t2 && t2(v6, { changedFields: m6, forms: d6.current }), f6.triggerFormChange(v6, m6);
      }, triggerFormFinish: function(v6, m6) {
        s && s(v6, { values: m6, forms: d6.current }), f6.triggerFormFinish(v6, m6);
      }, registerForm: function(v6, m6) {
        v6 && (d6.current = Go(Go({}, d6.current), {}, iu({}, v6, m6))), f6.registerForm(v6, m6);
      }, unregisterForm: function(v6) {
        var m6 = Go({}, d6.current);
        delete m6[v6], d6.current = m6, f6.unregisterForm(v6);
      } }) }, u);
    }, pJe = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], vJe = function(a, r6) {
      var t2 = a.name, s = a.initialValues, u = a.fields, f6 = a.form, d6 = a.preserve, v6 = a.children, m6 = a.component, b6 = m6 === void 0 ? "form" : m6, x6 = a.validateMessages, S = a.validateTrigger, M = S === void 0 ? "onChange" : S, A6 = a.onValuesChange, I = a.onFieldsChange, R = a.onFinish, F = a.onFinishFailed, j = O5(a, pJe), $ = C.useContext(IQ), K = Hbe(f6), U = Gm(K, 1), he = U[0], ue = he.getInternalHooks(F5), pe = ue.useSubscribe, _e = ue.setInitialValues, xe = ue.setCallbacks, Ae = ue.setValidateMessages, ke = ue.setPreserve;
      C.useImperativeHandle(r6, function() {
        return he;
      }), C.useEffect(function() {
        return $.registerForm(t2, he), function() {
          $.unregisterForm(t2);
        };
      }, [$, he, t2]), Ae(Go(Go({}, $.validateMessages), x6)), xe({ onValuesChange: A6, onFieldsChange: function(wt) {
        if ($.triggerFormChange(t2, wt), I) {
          for (var Ft = arguments.length, fn = new Array(Ft > 1 ? Ft - 1 : 0), gn = 1; gn < Ft; gn++)
            fn[gn - 1] = arguments[gn];
          I.apply(void 0, [wt].concat(fn));
        }
      }, onFinish: function(wt) {
        $.triggerFormFinish(t2, wt), R && R(wt);
      }, onFinishFailed: F }), ke(d6);
      var je = C.useRef(null);
      _e(s, !je.current), je.current || (je.current = true);
      var Fe = v6, at = typeof v6 == "function";
      if (at) {
        var ht = he.getFieldsValue(true);
        Fe = v6(ht, he);
      }
      pe(!at);
      var Qe = C.useRef();
      C.useEffect(function() {
        eJe(Qe.current || [], u || []) || he.setFields(u || []), Qe.current = u;
      }, [u, he]);
      var en = C.useMemo(function() {
        return Go(Go({}, he), {}, { validateTrigger: M });
      }, [he, M]), bt = C.createElement(P4.Provider, { value: en }, Fe);
      return b6 === false ? bt : C.createElement(b6, ih({}, j, { onSubmit: function(wt) {
        wt.preventDefault(), wt.stopPropagation(), he.submit();
      }, onReset: function(wt) {
        var Ft;
        wt.preventDefault(), he.resetFields(), (Ft = j.onReset) === null || Ft === void 0 || Ft.call(j, wt);
      } }), bt);
    }, gJe = C.forwardRef(vJe), bB = gJe;
    bB.FormProvider = dJe, bB.Field = Gbe, bB.List = uJe, bB.useForm = Hbe;
    var mJe = function(a, r6, t2) {
      $b(a, "[antd: ".concat(r6, "] ").concat(t2));
    }, yJe = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, bJe = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, _Je = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, $be = _Je, xJe = { lang: ih({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, bJe), timePickerLocale: ih({}, $be) }, Ube = xJe, b0 = "${label} is not a valid ${type}", wJe = { locale: "en", Pagination: yJe, DatePicker: Ube, TimePicker: $be, Calendar: Ube, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: b0, method: b0, array: b0, object: b0, number: b0, date: b0, boolean: b0, integer: b0, float: b0, regexp: b0, email: b0, url: b0, hex: b0 }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, qbe = wJe, SJe = g4.createContext(void 0), CJe = SJe, TQ = function(a) {
      oQ(t2, a);
      var r6 = lQ(t2);
      function t2() {
        return D4(this, t2), r6.apply(this, arguments);
      }
      return k4(t2, [{ key: "getLocale", value: function() {
        var s = this.props, u = s.componentName, f6 = s.defaultLocale, d6 = f6 || qbe[u != null ? u : "global"], v6 = this.context, m6 = u && v6 ? v6[u] : {};
        return ih(ih({}, d6 instanceof Function ? d6() : d6), m6 || {});
      } }, { key: "getLocaleCode", value: function() {
        var s = this.context, u = s && s.locale;
        return s && s.exist && !u ? qbe.locale : u;
      } }, { key: "render", value: function() {
        return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
      } }]), t2;
    }(C.Component);
    TQ.defaultProps = { componentName: "global" }, TQ.contextType = CJe;
    var MJe = function() {
      var a = C.useContext(mS), r6 = a.getPrefixCls, t2 = r6("empty-img-default");
      return C.createElement("svg", { className: t2, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, C.createElement("g", { fill: "none", fillRule: "evenodd" }, C.createElement("g", { transform: "translate(24 31.67)" }, C.createElement("ellipse", { className: "".concat(t2, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), C.createElement("path", { className: "".concat(t2, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), C.createElement("path", { className: "".concat(t2, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), C.createElement("path", { className: "".concat(t2, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), C.createElement("path", { className: "".concat(t2, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), C.createElement("path", { className: "".concat(t2, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), C.createElement("g", { className: "".concat(t2, "-g"), transform: "translate(149.65 15.383)" }, C.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), C.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
    }, AJe = MJe, EJe = function() {
      var a = C.useContext(mS), r6 = a.getPrefixCls, t2 = r6("empty-img-simple");
      return C.createElement("svg", { className: t2, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, C.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, C.createElement("ellipse", { className: "".concat(t2, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), C.createElement("g", { className: "".concat(t2, "-g"), fillRule: "nonzero" }, C.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), C.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(t2, "-path") }))));
    }, IJe = EJe, TJe = globalThis && globalThis.__rest || function(a, r6) {
      var t2 = {};
      for (var s in a)
        Object.prototype.hasOwnProperty.call(a, s) && r6.indexOf(s) < 0 && (t2[s] = a[s]);
      if (a != null && typeof Object.getOwnPropertySymbols == "function")
        for (var u = 0, s = Object.getOwnPropertySymbols(a); u < s.length; u++)
          r6.indexOf(s[u]) < 0 && Object.prototype.propertyIsEnumerable.call(a, s[u]) && (t2[s[u]] = a[s[u]]);
      return t2;
    }, Ybe = C.createElement(AJe, null), Zbe = C.createElement(IJe, null), DQ = function(a) {
      var r6 = a.className, t2 = a.prefixCls, s = a.image, u = s === void 0 ? Ybe : s, f6 = a.description, d6 = a.children, v6 = a.imageStyle, m6 = TJe(a, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), b6 = C.useContext(mS), x6 = b6.getPrefixCls, S = b6.direction;
      return C.createElement(TQ, { componentName: "Empty" }, function(M) {
        var A6, I = x6("empty", t2), R = typeof f6 != "undefined" ? f6 : M.description, F = typeof R == "string" ? R : "empty", j = null;
        return typeof u == "string" ? j = C.createElement("img", { alt: F, src: u }) : j = u, C.createElement("div", ih({ className: R5(I, (A6 = {}, iu(A6, "".concat(I, "-normal"), u === Zbe), iu(A6, "".concat(I, "-rtl"), S === "rtl"), A6), r6) }, m6), C.createElement("div", { className: "".concat(I, "-image"), style: v6 }, j), R && C.createElement("div", { className: "".concat(I, "-description") }, R), d6 && C.createElement("div", { className: "".concat(I, "-footer") }, d6));
      });
    };
    DQ.PRESENTED_IMAGE_DEFAULT = Ybe, DQ.PRESENTED_IMAGE_SIMPLE = Zbe;
    var z4 = DQ, DJe = function(a) {
      return C.createElement(Xbe, null, function(r6) {
        var t2 = r6.getPrefixCls, s = t2("empty");
        switch (a) {
          case "Table":
          case "List":
            return C.createElement(z4, { image: z4.PRESENTED_IMAGE_SIMPLE });
          case "Select":
          case "TreeSelect":
          case "Cascader":
          case "Transfer":
          case "Mentions":
            return C.createElement(z4, { image: z4.PRESENTED_IMAGE_SIMPLE, className: "".concat(s, "-small") });
          default:
            return C.createElement(z4, null);
        }
      });
    }, kJe = DJe, PJe = function(a, r6) {
      return r6 || (a ? "ant-".concat(a) : "ant");
    }, mS = C.createContext({ getPrefixCls: PJe, renderEmpty: kJe }), Xbe = mS.Consumer, LJe = C.createContext(void 0), OJe = LJe, Kbe = function(a) {
      return +setTimeout(a, 16);
    }, Jbe = function(a) {
      return clearTimeout(a);
    };
    typeof window != "undefined" && "requestAnimationFrame" in window && (Kbe = function(a) {
      return window.requestAnimationFrame(a);
    }, Jbe = function(a) {
      return window.cancelAnimationFrame(a);
    });
    var Qbe = 0, kQ = /* @__PURE__ */ new Map();
    function e_e(a) {
      kQ.delete(a);
    }
    function _B(a) {
      var r6 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
      Qbe += 1;
      var t2 = Qbe;
      function s(u) {
        if (u === 0)
          e_e(t2), a();
        else {
          var f6 = Kbe(function() {
            s(u - 1);
          });
          kQ.set(t2, f6);
        }
      }
      return s(r6), t2;
    }
    _B.cancel = function(a) {
      var r6 = kQ.get(a);
      return e_e(r6), Jbe(r6);
    };
    function RJe(a, r6) {
      var t2 = r6 || {}, s = t2.defaultValue, u = t2.value, f6 = t2.onChange, d6 = t2.postState, v6 = C.useState(function() {
        return u !== void 0 ? u : s !== void 0 ? typeof s == "function" ? s() : s : typeof a == "function" ? a() : a;
      }), m6 = Gm(v6, 2), b6 = m6[0], x6 = m6[1], S = u !== void 0 ? u : b6;
      d6 && (S = d6(S));
      var M = C.useRef(f6);
      M.current = f6;
      var A6 = C.useCallback(function(R) {
        x6(R), S !== R && M.current && M.current(R, S);
      }, [S, M]), I = C.useRef(true);
      return C.useEffect(function() {
        if (I.current) {
          I.current = false;
          return;
        }
        u === void 0 && x6(u);
      }, [u]), [S, A6];
    }
    var co = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(a) {
      var r6 = a.keyCode;
      if (a.altKey && !a.ctrlKey || a.metaKey || r6 >= co.F1 && r6 <= co.F12)
        return false;
      switch (r6) {
        case co.ALT:
        case co.CAPS_LOCK:
        case co.CONTEXT_MENU:
        case co.CTRL:
        case co.DOWN:
        case co.END:
        case co.ESC:
        case co.HOME:
        case co.INSERT:
        case co.LEFT:
        case co.MAC_FF_META:
        case co.META:
        case co.NUMLOCK:
        case co.NUM_CENTER:
        case co.PAGE_DOWN:
        case co.PAGE_UP:
        case co.PAUSE:
        case co.PRINT_SCREEN:
        case co.RIGHT:
        case co.SHIFT:
        case co.UP:
        case co.WIN_KEY:
        case co.WIN_KEY_RIGHT:
          return false;
        default:
          return true;
      }
    }, isCharacterKey: function(a) {
      if (a >= co.ZERO && a <= co.NINE || a >= co.NUM_ZERO && a <= co.NUM_MULTIPLY || a >= co.A && a <= co.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && a === 0)
        return true;
      switch (a) {
        case co.SPACE:
        case co.QUESTION_MARK:
        case co.NUM_PLUS:
        case co.NUM_MINUS:
        case co.NUM_PERIOD:
        case co.NUM_DIVISION:
        case co.SEMICOLON:
        case co.DASH:
        case co.EQUALS:
        case co.COMMA:
        case co.PERIOD:
        case co.SLASH:
        case co.APOSTROPHE:
        case co.SINGLE_QUOTE:
        case co.OPEN_SQUARE_BRACKET:
        case co.BACKSLASH:
        case co.CLOSE_SQUARE_BRACKET:
          return true;
        default:
          return false;
      }
    } }, t_e = function() {
      for (var a = arguments.length, r6 = new Array(a), t2 = 0; t2 < a; t2++)
        r6[t2] = arguments[t2];
      return r6;
    }, FJe = C.isValidElement;
    function NJe(a, r6, t2) {
      return FJe(a) ? C.cloneElement(a, typeof t2 == "function" ? t2(a.props || {}) : t2) : r6;
    }
    function VJe(a, r6) {
      return NJe(a, a, r6);
    }
    var n_e = ["xxl", "xl", "lg", "md", "sm", "xs"], xB = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, BA = /* @__PURE__ */ new Map(), PQ = -1, wB = {}, zJe = { matchHandlers: {}, dispatch: function(a) {
      return wB = a, BA.forEach(function(r6) {
        return r6(wB);
      }), BA.size >= 1;
    }, subscribe: function(a) {
      return BA.size || this.register(), PQ += 1, BA.set(PQ, a), a(wB), PQ;
    }, unsubscribe: function(a) {
      BA.delete(a), BA.size || this.unregister();
    }, unregister: function() {
      var a = this;
      Object.keys(xB).forEach(function(r6) {
        var t2 = xB[r6], s = a.matchHandlers[t2];
        s == null || s.mql.removeListener(s == null ? void 0 : s.listener);
      }), BA.clear();
    }, register: function() {
      var a = this;
      Object.keys(xB).forEach(function(r6) {
        var t2 = xB[r6], s = function(f6) {
          var d6 = f6.matches;
          a.dispatch(ih(ih({}, wB), iu({}, r6, d6)));
        }, u = window.matchMedia(t2);
        u.addListener(s), a.matchHandlers[t2] = { mql: u, listener: s }, s(u);
      });
    } }, r_e = zJe, BJe = 0, z5 = {};
    function SB(a) {
      var r6 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, t2 = BJe++, s = r6;
      function u() {
        s -= 1, s <= 0 ? (a(), delete z5[t2]) : z5[t2] = _B(u);
      }
      return z5[t2] = _B(u), t2;
    }
    SB.cancel = function(a) {
      a !== void 0 && (_B.cancel(z5[a]), delete z5[a]);
    }, SB.ids = z5;
    var LQ;
    function a_e(a) {
      return !a || a.offsetParent === null || a.hidden;
    }
    function jJe(a) {
      var r6 = (a || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
      return r6 && r6[1] && r6[2] && r6[3] ? !(r6[1] === r6[2] && r6[2] === r6[3]) : true;
    }
    var i_e = function(a) {
      oQ(t2, a);
      var r6 = lQ(t2);
      function t2() {
        var s;
        return D4(this, t2), s = r6.apply(this, arguments), s.containerRef = C.createRef(), s.animationStart = false, s.destroyed = false, s.onClick = function(u, f6) {
          var d6, v6, m6 = s.props, b6 = m6.insertExtraNode, x6 = m6.disabled;
          if (!(x6 || !u || a_e(u) || u.className.indexOf("-leave") >= 0)) {
            s.extraNode = document.createElement("div");
            var S = sQ(s), M = S.extraNode, A6 = s.context.getPrefixCls;
            M.className = "".concat(A6(""), "-click-animating-node");
            var I = s.getAttributeName();
            if (u.setAttribute(I, "true"), f6 && f6 !== "#ffffff" && f6 !== "rgb(255, 255, 255)" && jJe(f6) && !/rgba\((?:\d*, ){3}0\)/.test(f6) && f6 !== "transparent") {
              M.style.borderColor = f6;
              var R = ((d6 = u.getRootNode) === null || d6 === void 0 ? void 0 : d6.call(u)) || u.ownerDocument, F = R instanceof Document ? R.body : (v6 = R.firstChild) !== null && v6 !== void 0 ? v6 : R;
              LQ = gbe(`
      [`.concat(A6(""), "-click-animating-without-extra-node='true']::after, .").concat(A6(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(f6, `;
      }`), "antd-wave", { csp: s.csp, attachTo: F });
            }
            b6 && u.appendChild(M), ["transition", "animation"].forEach(function(j) {
              u.addEventListener("".concat(j, "start"), s.onTransitionStart), u.addEventListener("".concat(j, "end"), s.onTransitionEnd);
            });
          }
        }, s.onTransitionStart = function(u) {
          if (!s.destroyed) {
            var f6 = s.containerRef.current;
            !u || u.target !== f6 || s.animationStart || s.resetEffect(f6);
          }
        }, s.onTransitionEnd = function(u) {
          !u || u.animationName !== "fadeEffect" || s.resetEffect(u.target);
        }, s.bindAnimationEvent = function(u) {
          if (!(!u || !u.getAttribute || u.getAttribute("disabled") || u.className.indexOf("disabled") >= 0)) {
            var f6 = function(d6) {
              if (!(d6.target.tagName === "INPUT" || a_e(d6.target))) {
                s.resetEffect(u);
                var v6 = getComputedStyle(u).getPropertyValue("border-top-color") || getComputedStyle(u).getPropertyValue("border-color") || getComputedStyle(u).getPropertyValue("background-color");
                s.clickWaveTimeoutId = window.setTimeout(function() {
                  return s.onClick(u, v6);
                }, 0), SB.cancel(s.animationStartId), s.animationStart = true, s.animationStartId = SB(function() {
                  s.animationStart = false;
                }, 10);
              }
            };
            return u.addEventListener("click", f6, true), { cancel: function() {
              u.removeEventListener("click", f6, true);
            } };
          }
        }, s.renderWave = function(u) {
          var f6 = u.csp, d6 = s.props.children;
          if (s.csp = f6, !C.isValidElement(d6))
            return d6;
          var v6 = s.containerRef;
          return mKe(d6) && (v6 = gKe(d6.ref, s.containerRef)), VJe(d6, { ref: v6 });
        }, s;
      }
      return k4(t2, [{ key: "componentDidMount", value: function() {
        var s = this.containerRef.current;
        !s || s.nodeType !== 1 || (this.instance = this.bindAnimationEvent(s));
      } }, { key: "componentWillUnmount", value: function() {
        this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
      } }, { key: "getAttributeName", value: function() {
        var s = this.context.getPrefixCls, u = this.props.insertExtraNode;
        return u ? "".concat(s(""), "-click-animating") : "".concat(s(""), "-click-animating-without-extra-node");
      } }, { key: "resetEffect", value: function(s) {
        var u = this;
        if (!(!s || s === this.extraNode || !(s instanceof Element))) {
          var f6 = this.props.insertExtraNode, d6 = this.getAttributeName();
          s.setAttribute(d6, "false"), LQ && (LQ.innerHTML = ""), f6 && this.extraNode && s.contains(this.extraNode) && s.removeChild(this.extraNode), ["transition", "animation"].forEach(function(v6) {
            s.removeEventListener("".concat(v6, "start"), u.onTransitionStart), s.removeEventListener("".concat(v6, "end"), u.onTransitionEnd);
          });
        }
      } }, { key: "render", value: function() {
        return C.createElement(Xbe, null, this.renderWave);
      } }]), t2;
    }(C.Component);
    i_e.contextType = mS;
    var OQ = { exports: {} }, B4 = {};
    /** @license React v17.0.2
    * react-jsx-runtime.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var GJe = w4.default, o_e = 60103;
    if (B4.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
      var s_e = Symbol.for;
      o_e = s_e("react.element"), B4.Fragment = s_e("react.fragment");
    }
    var WJe = GJe.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, HJe = Object.prototype.hasOwnProperty, $Je = { key: true, ref: true, __self: true, __source: true };
    function l_e(a, r6, t2) {
      var s, u = {}, f6 = null, d6 = null;
      t2 !== void 0 && (f6 = "" + t2), r6.key !== void 0 && (f6 = "" + r6.key), r6.ref !== void 0 && (d6 = r6.ref);
      for (s in r6)
        HJe.call(r6, s) && !$Je.hasOwnProperty(s) && (u[s] = r6[s]);
      if (a && a.defaultProps)
        for (s in r6 = a.defaultProps, r6)
          u[s] === void 0 && (u[s] = r6[s]);
      return { $$typeof: o_e, type: a, key: f6, ref: d6, props: u, _owner: WJe.current };
    }
    B4.jsx = l_e, B4.jsxs = l_e, OQ.exports = B4;
    const B5 = OQ.exports.jsx, UJe = OQ.exports.jsxs;
    var qJe = g4.createContext({}), u_e = qJe, YJe = function() {
      return dbe() && window.document.documentElement;
    }, CB, ZJe = function() {
      if (!YJe())
        return false;
      if (CB !== void 0)
        return CB;
      var a = document.createElement("div");
      return a.style.display = "flex", a.style.flexDirection = "column", a.style.rowGap = "1px", a.appendChild(document.createElement("div")), a.appendChild(document.createElement("div")), document.body.appendChild(a), CB = a.scrollHeight === 1, document.body.removeChild(a), CB;
    }, XJe = function() {
      var a = C.useState(false), r6 = Gm(a, 2), t2 = r6[0], s = r6[1];
      return C.useEffect(function() {
        s(ZJe());
      }, []), t2;
    }, KJe = globalThis && globalThis.__rest || function(a, r6) {
      var t2 = {};
      for (var s in a)
        Object.prototype.hasOwnProperty.call(a, s) && r6.indexOf(s) < 0 && (t2[s] = a[s]);
      if (a != null && typeof Object.getOwnPropertySymbols == "function")
        for (var u = 0, s = Object.getOwnPropertySymbols(a); u < s.length; u++)
          r6.indexOf(s[u]) < 0 && Object.prototype.propertyIsEnumerable.call(a, s[u]) && (t2[s[u]] = a[s[u]]);
      return t2;
    };
    t_e("top", "middle", "bottom", "stretch"), t_e("start", "end", "center", "space-around", "space-between");
    var c_e = C.forwardRef(function(a, r6) {
      var t2, s = a.prefixCls, u = a.justify, f6 = a.align, d6 = a.className, v6 = a.style, m6 = a.children, b6 = a.gutter, x6 = b6 === void 0 ? 0 : b6, S = a.wrap, M = KJe(a, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), A6 = C.useContext(mS), I = A6.getPrefixCls, R = A6.direction, F = C.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), j = Gm(F, 2), $ = j[0], K = j[1], U = XJe(), he = C.useRef(x6);
      C.useEffect(function() {
        var bt = r_e.subscribe(function(wt) {
          var Ft = he.current || 0;
          (!Array.isArray(Ft) && Hp(Ft) === "object" || Array.isArray(Ft) && (Hp(Ft[0]) === "object" || Hp(Ft[1]) === "object")) && K(wt);
        });
        return function() {
          return r_e.unsubscribe(bt);
        };
      }, []);
      var ue = function() {
        var bt = [0, 0], wt = Array.isArray(x6) ? x6 : [x6, 0];
        return wt.forEach(function(Ft, fn) {
          if (Hp(Ft) === "object")
            for (var gn = 0; gn < n_e.length; gn++) {
              var Zr = n_e[gn];
              if ($[Zr] && Ft[Zr] !== void 0) {
                bt[fn] = Ft[Zr];
                break;
              }
            }
          else
            bt[fn] = Ft || 0;
        }), bt;
      }, pe = I("row", s), _e = ue(), xe = R5(pe, (t2 = {}, iu(t2, "".concat(pe, "-no-wrap"), S === false), iu(t2, "".concat(pe, "-").concat(u), u), iu(t2, "".concat(pe, "-").concat(f6), f6), iu(t2, "".concat(pe, "-rtl"), R === "rtl"), t2), d6), Ae = {}, ke = _e[0] > 0 ? _e[0] / -2 : void 0, je = _e[1] > 0 ? _e[1] / -2 : void 0;
      if (ke && (Ae.marginLeft = ke, Ae.marginRight = ke), U) {
        var Fe = Gm(_e, 2);
        Ae.rowGap = Fe[1];
      } else
        je && (Ae.marginTop = je, Ae.marginBottom = je);
      var at = Gm(_e, 2), ht = at[0], Qe = at[1], en = C.useMemo(function() {
        return { gutter: [ht, Qe], wrap: S, supportFlexGap: U };
      }, [ht, Qe, S, U]);
      return C.createElement(u_e.Provider, { value: en }, C.createElement("div", ih({}, M, { className: xe, style: ih(ih({}, Ae), v6), ref: r6 }), m6));
    });
    c_e.displayName = "Row";
    var JJe = c_e, QJe = globalThis && globalThis.__rest || function(a, r6) {
      var t2 = {};
      for (var s in a)
        Object.prototype.hasOwnProperty.call(a, s) && r6.indexOf(s) < 0 && (t2[s] = a[s]);
      if (a != null && typeof Object.getOwnPropertySymbols == "function")
        for (var u = 0, s = Object.getOwnPropertySymbols(a); u < s.length; u++)
          r6.indexOf(s[u]) < 0 && Object.prototype.propertyIsEnumerable.call(a, s[u]) && (t2[s[u]] = a[s[u]]);
      return t2;
    };
    function eQe(a) {
      return typeof a == "number" ? "".concat(a, " ").concat(a, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(a) ? "0 0 ".concat(a) : a;
    }
    var tQe = ["xs", "sm", "md", "lg", "xl", "xxl"], f_e = C.forwardRef(function(a, r6) {
      var t2, s = C.useContext(mS), u = s.getPrefixCls, f6 = s.direction, d6 = C.useContext(u_e), v6 = d6.gutter, m6 = d6.wrap, b6 = d6.supportFlexGap, x6 = a.prefixCls, S = a.span, M = a.order, A6 = a.offset, I = a.push, R = a.pull, F = a.className, j = a.children, $ = a.flex, K = a.style, U = QJe(a, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), he = u("col", x6), ue = {};
      tQe.forEach(function(ke) {
        var je, Fe = {}, at = a[ke];
        typeof at == "number" ? Fe.span = at : Hp(at) === "object" && (Fe = at || {}), delete U[ke], ue = ih(ih({}, ue), (je = {}, iu(je, "".concat(he, "-").concat(ke, "-").concat(Fe.span), Fe.span !== void 0), iu(je, "".concat(he, "-").concat(ke, "-order-").concat(Fe.order), Fe.order || Fe.order === 0), iu(je, "".concat(he, "-").concat(ke, "-offset-").concat(Fe.offset), Fe.offset || Fe.offset === 0), iu(je, "".concat(he, "-").concat(ke, "-push-").concat(Fe.push), Fe.push || Fe.push === 0), iu(je, "".concat(he, "-").concat(ke, "-pull-").concat(Fe.pull), Fe.pull || Fe.pull === 0), iu(je, "".concat(he, "-rtl"), f6 === "rtl"), je));
      });
      var pe = R5(he, (t2 = {}, iu(t2, "".concat(he, "-").concat(S), S !== void 0), iu(t2, "".concat(he, "-order-").concat(M), M), iu(t2, "".concat(he, "-offset-").concat(A6), A6), iu(t2, "".concat(he, "-push-").concat(I), I), iu(t2, "".concat(he, "-pull-").concat(R), R), t2), F, ue), _e = {};
      if (v6 && v6[0] > 0) {
        var xe = v6[0] / 2;
        _e.paddingLeft = xe, _e.paddingRight = xe;
      }
      if (v6 && v6[1] > 0 && !b6) {
        var Ae = v6[1] / 2;
        _e.paddingTop = Ae, _e.paddingBottom = Ae;
      }
      return $ && (_e.flex = eQe($), m6 === false && !_e.minWidth && (_e.minWidth = 0)), C.createElement("div", ih({}, U, { style: ih(ih({}, _e), K), className: pe, ref: r6 }), j);
    });
    f_e.displayName = "Col";
    var nQe = f_e, h_e = C.forwardRef(function(a, r6) {
      var t2, s = a.prefixCls, u = s === void 0 ? "rc-switch" : s, f6 = a.className, d6 = a.checked, v6 = a.defaultChecked, m6 = a.disabled, b6 = a.loadingIcon, x6 = a.checkedChildren, S = a.unCheckedChildren, M = a.onClick, A6 = a.onChange, I = a.onKeyDown, R = O5(a, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), F = RJe(false, { value: d6, defaultValue: v6 }), j = Gm(F, 2), $ = j[0], K = j[1];
      function U(_e, xe) {
        var Ae = $;
        return m6 || (Ae = _e, K(Ae), A6 == null || A6(Ae, xe)), Ae;
      }
      function he(_e) {
        _e.which === co.LEFT ? U(false, _e) : _e.which === co.RIGHT && U(true, _e), I == null || I(_e);
      }
      function ue(_e) {
        var xe = U(!$, _e);
        M == null || M(xe, _e);
      }
      var pe = R5(u, f6, (t2 = {}, iu(t2, "".concat(u, "-checked"), $), iu(t2, "".concat(u, "-disabled"), m6), t2));
      return C.createElement("button", Object.assign({}, R, { type: "button", role: "switch", "aria-checked": $, disabled: m6, className: pe, ref: r6, onKeyDown: he, onClick: ue }), b6, C.createElement("span", { className: "".concat(u, "-inner") }, $ ? x6 : S));
    });
    h_e.displayName = "Switch";
    var rQe = globalThis && globalThis.__rest || function(a, r6) {
      var t2 = {};
      for (var s in a)
        Object.prototype.hasOwnProperty.call(a, s) && r6.indexOf(s) < 0 && (t2[s] = a[s]);
      if (a != null && typeof Object.getOwnPropertySymbols == "function")
        for (var u = 0, s = Object.getOwnPropertySymbols(a); u < s.length; u++)
          r6.indexOf(s[u]) < 0 && Object.prototype.propertyIsEnumerable.call(a, s[u]) && (t2[s[u]] = a[s[u]]);
      return t2;
    }, RQ = C.forwardRef(function(a, r6) {
      var t2, s = a.prefixCls, u = a.size, f6 = a.loading, d6 = a.className, v6 = d6 === void 0 ? "" : d6, m6 = a.disabled, b6 = rQe(a, ["prefixCls", "size", "loading", "className", "disabled"]);
      mJe("checked" in b6 || !("value" in b6), "Switch", "`value` is not a valid prop, do you mean `checked`?");
      var x6 = C.useContext(mS), S = x6.getPrefixCls, M = x6.direction, A6 = C.useContext(OJe), I = S("switch", s), R = C.createElement("div", { className: "".concat(I, "-handle") }, f6 && C.createElement(sKe, { className: "".concat(I, "-loading-icon") })), F = R5((t2 = {}, iu(t2, "".concat(I, "-small"), (u || A6) === "small"), iu(t2, "".concat(I, "-loading"), f6), iu(t2, "".concat(I, "-rtl"), M === "rtl"), t2), v6);
      return C.createElement(i_e, { insertExtraNode: true }, C.createElement(h_e, ih({}, b6, { prefixCls: I, className: F, disabled: m6 || f6, ref: r6, loadingIcon: R })));
    });
    RQ.__ANT_SWITCH = true, RQ.displayName = "Switch";
    var aQe = RQ, iQe = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, oQe = {};
    (function(a) {
      var r6 = Object.defineProperty, t2 = Object.getOwnPropertySymbols, s = Object.prototype.hasOwnProperty, u = Object.prototype.propertyIsEnumerable, f6 = (Z, ve, J) => ve in Z ? r6(Z, ve, { enumerable: true, configurable: true, writable: true, value: J }) : Z[ve] = J, d6 = (Z, ve) => {
        for (var J in ve || (ve = {}))
          s.call(ve, J) && f6(Z, J, ve[J]);
        if (t2)
          for (var J of t2(ve))
            u.call(ve, J) && f6(Z, J, ve[J]);
        return Z;
      }, v6 = (Z, ve, J) => (f6(Z, typeof ve != "symbol" ? ve + "" : ve, J), J);
      Object.defineProperties(a, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
      var m6 = w4.default;
      function b6(Z) {
        return Z && typeof Z == "object" && "default" in Z ? Z : { default: Z };
      }
      function x6(Z) {
        if (Z && Z.__esModule)
          return Z;
        var ve = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
        return Z && Object.keys(Z).forEach(function(J) {
          if (J !== "default") {
            var ee = Object.getOwnPropertyDescriptor(Z, J);
            Object.defineProperty(ve, J, ee.get ? ee : { enumerable: true, get: function() {
              return Z[J];
            } });
          }
        }), ve.default = Z, Object.freeze(ve);
      }
      var S = b6(m6), M = x6(m6);
      class A6 {
        constructor() {
          v6(this, "chartsEmitters", /* @__PURE__ */ new Map()), v6(this, "add", (ve, J, ee, te) => {
            J && ee ? this.chartsEmitters.set(ve, { chart: J, option: ee, title: te }) : console.log("\u6DFB\u52A0\u5931\u8D25");
          }), v6(this, "get", (ve) => this.chartsEmitters.get(ve)), v6(this, "clear", () => {
            this.chartsEmitters.clear();
          }), v6(this, "delete", (ve) => {
            this.chartsEmitters.delete(ve);
          }), v6(this, "list", () => {
            var ve, J, ee;
            const te = [];
            for (const ce of this.chartsEmitters.keys())
              te.push({ id: ce, chart: (ve = this.chartsEmitters.get(ce)) == null ? void 0 : ve.chart, option: (J = this.chartsEmitters.get(ce)) == null ? void 0 : J.option, title: (ee = this.chartsEmitters.get(ce)) == null ? void 0 : ee.title });
            return te;
          });
        }
      }
      const I = new A6();
      var R = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof ze != "undefined" ? ze : typeof self != "undefined" ? self : {};
      function F(Z) {
        return Z && Z.__esModule && Object.prototype.hasOwnProperty.call(Z, "default") ? Z.default : Z;
      }
      var j = { exports: {} };
      /**
      * @license
      * Lodash <https://lodash.com/>
      * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
      * Released under MIT license <https://lodash.com/license>
      * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
      * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
      */
      (function(Z, ve) {
        (function() {
          var J, ee = "4.17.21", te = 200, ce = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", Ie = "Expected a function", Le = "Invalid `variable` option passed into `_.template`", De = "__lodash_hash_undefined__", Ye = 500, Ke = "__lodash_placeholder__", pt = 1, Bt = 2, qt = 4, Yt = 1, nn = 2, ln = 1, yr = 2, sr = 4, aa = 8, He = 16, Cn = 32, On = 64, dr = 128, ur = 256, An = 512, Nn = 30, Ar = "...", Jr = 800, bn = 16, Xa = 1, qa = 2, ir = 3, Ai = 1 / 0, gr = 9007199254740991, Qn = 17976931348623157e292, Yn = 0 / 0, ya = 4294967295, sa = ya - 1, Wi = ya >>> 1, xs = [["ary", dr], ["bind", ln], ["bindKey", yr], ["curry", aa], ["curryRight", He], ["flip", An], ["partial", Cn], ["partialRight", On], ["rearg", ur]], is = "[object Arguments]", io = "[object Array]", Ol = "[object AsyncFunction]", os = "[object Boolean]", rl = "[object Date]", Cu = "[object DOMException]", wd = "[object Error]", cp = "[object Function]", tc = "[object GeneratorFunction]", cc = "[object Map]", uh = "[object Number]", fp = "[object Null]", ef = "[object Object]", Sd = "[object Promise]", Ei = "[object Proxy]", ch = "[object RegExp]", nc = "[object Set]", ju = "[object String]", fc = "[object Symbol]", Xp = "[object Undefined]", kr = "[object WeakMap]", kn = "[object WeakSet]", jn = "[object ArrayBuffer]", Or = "[object DataView]", Ea = "[object Float32Array]", pi = "[object Float64Array]", To = "[object Int8Array]", Do = "[object Int16Array]", hl = "[object Int32Array]", Mu = "[object Uint8Array]", qs = "[object Uint8ClampedArray]", Os = "[object Uint16Array]", Rl = "[object Uint32Array]", Vf = /\b__p \+= '';/g, zf = /\b(__p \+=) '' \+/g, Kp = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Fh = /&(?:amp|lt|gt|quot|#39);/g, su = /[&<>"']/g, hs = RegExp(Fh.source), Nc = RegExp(su.source), Bf = /<%-([\s\S]+?)%>/g, Cd = /<%([\s\S]+?)%>/g, Nh = /<%=([\s\S]+?)%>/g, Vh = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, Md = /^\w*$/, E0 = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, I0 = /[\\^$.*+?()[\]{}|]/g, pw = RegExp(I0.source), T0 = /^\s+/, S1 = /\s/, vw = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, i_ = /\{\n\/\* \[wrapped with (.+)\] \*/, OS = /,? & /, xg = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, St = /[()=,{}\[\]\/\s]/, Rt = /\\(\\)?/g, Xe = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, Ct = /\w*$/, Tt = /^[-+]0x[0-9a-f]+$/i, Ln = /^0b[01]+$/i, Cr = /^\[object .+?Constructor\]$/, or = /^0o[0-7]+$/i, cn = /^(?:0|[1-9]\d*)$/, na = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, ni = /($^)/, Ho = /['\n\r\u2028\u2029\\]/g, Fo = "\\ud800-\\udfff", _o = "\\u0300-\\u036f", ji = "\\ufe20-\\ufe2f", Cl = "\\u20d0-\\u20ff", Au = _o + ji + Cl, oo = "\\u2700-\\u27bf", Eu = "a-z\\xdf-\\xf6\\xf8-\\xff", jf = "\\xac\\xb1\\xd7\\xf7", Nv = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", Jm = "\\u2000-\\u206f", Jp = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", C1 = "A-Z\\xc0-\\xd6\\xd8-\\xde", D0 = "\\ufe0e\\ufe0f", tf = jf + Nv + Jm + Jp, Vv = "['\u2019]", nf = "[" + Fo + "]", wg = "[" + tf + "]", hc = "[" + Au + "]", M1 = "\\d+", gw = "[" + oo + "]", hp = "[" + Eu + "]", k0 = "[^" + Fo + tf + M1 + oo + Eu + C1 + "]", P0 = "\\ud83c[\\udffb-\\udfff]", xf = "(?:" + hc + "|" + P0 + ")", mw = "[^" + Fo + "]", zv = "(?:\\ud83c[\\udde6-\\uddff]){2}", Qm = "[\\ud800-\\udbff][\\udc00-\\udfff]", A1 = "[" + C1 + "]", wk = "\\u200d", Sk = "(?:" + hp + "|" + k0 + ")", I6 = "(?:" + A1 + "|" + k0 + ")", vE = "(?:" + Vv + "(?:d|ll|m|re|s|t|ve))?", gE = "(?:" + Vv + "(?:D|LL|M|RE|S|T|VE))?", Ck = xf + "?", mE = "[" + D0 + "]?", RS = "(?:" + wk + "(?:" + [mw, zv, Qm].join("|") + ")" + mE + Ck + ")*", T6 = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", Mk = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", yE = mE + Ck + RS, Ak = "(?:" + [gw, zv, Qm].join("|") + ")" + yE, bE = "(?:" + [mw + hc + "?", hc, zv, Qm, nf].join("|") + ")", _E = RegExp(Vv, "g"), fh = RegExp(hc, "g"), yw = RegExp(P0 + "(?=" + P0 + ")|" + bE + yE, "g"), Ek = RegExp([A1 + "?" + hp + "+" + vE + "(?=" + [wg, A1, "$"].join("|") + ")", I6 + "+" + gE + "(?=" + [wg, A1 + Sk, "$"].join("|") + ")", A1 + "?" + Sk + "+" + vE, A1 + "+" + gE, Mk, T6, M1, Ak].join("|"), "g"), D6 = RegExp("[" + wk + Fo + Au + D0 + "]"), k6 = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Qp = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], xE = -1, Iu = {};
          Iu[Ea] = Iu[pi] = Iu[To] = Iu[Do] = Iu[hl] = Iu[Mu] = Iu[qs] = Iu[Os] = Iu[Rl] = true, Iu[is] = Iu[io] = Iu[jn] = Iu[os] = Iu[Or] = Iu[rl] = Iu[wd] = Iu[cp] = Iu[cc] = Iu[uh] = Iu[ef] = Iu[ch] = Iu[nc] = Iu[ju] = Iu[kr] = false;
          var eu = {};
          eu[is] = eu[io] = eu[jn] = eu[Or] = eu[os] = eu[rl] = eu[Ea] = eu[pi] = eu[To] = eu[Do] = eu[hl] = eu[cc] = eu[uh] = eu[ef] = eu[ch] = eu[nc] = eu[ju] = eu[fc] = eu[Mu] = eu[qs] = eu[Os] = eu[Rl] = true, eu[wd] = eu[cp] = eu[kr] = false;
          var wE = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, Ik = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, SE = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, P6 = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, Tk = parseFloat, L6 = parseInt, FS = typeof R == "object" && R && R.Object === Object && R, Dk = typeof self == "object" && self && self.Object === Object && self, dc = FS || Dk || Function("return this")(), NS = ve && !ve.nodeType && ve, ey = NS && true && Z && !Z.nodeType && Z, kk = ey && ey.exports === NS, CE = kk && FS.process, ev = function() {
            try {
              var an = ey && ey.require && ey.require("util").types;
              return an || CE && CE.binding && CE.binding("util");
            } catch {
            }
          }(), o_ = ev && ev.isArrayBuffer, Pk = ev && ev.isDate, Lk = ev && ev.isMap, bw = ev && ev.isRegExp, VS = ev && ev.isSet, ME = ev && ev.isTypedArray;
          function dp(an, er, tr) {
            switch (tr.length) {
              case 0:
                return an.call(er);
              case 1:
                return an.call(er, tr[0]);
              case 2:
                return an.call(er, tr[0], tr[1]);
              case 3:
                return an.call(er, tr[0], tr[1], tr[2]);
            }
            return an.apply(er, tr);
          }
          function O6(an, er, tr, Va) {
            for (var Mo = -1, al = an == null ? 0 : an.length; ++Mo < al; ) {
              var of = an[Mo];
              er(Va, of, tr(of), an);
            }
            return Va;
          }
          function zh(an, er) {
            for (var tr = -1, Va = an == null ? 0 : an.length; ++tr < Va && er(an[tr], tr, an) !== false; )
              ;
            return an;
          }
          function R6(an, er) {
            for (var tr = an == null ? 0 : an.length; tr-- && er(an[tr], tr, an) !== false; )
              ;
            return an;
          }
          function Ok(an, er) {
            for (var tr = -1, Va = an == null ? 0 : an.length; ++tr < Va; )
              if (!er(an[tr], tr, an))
                return false;
            return true;
          }
          function L0(an, er) {
            for (var tr = -1, Va = an == null ? 0 : an.length, Mo = 0, al = []; ++tr < Va; ) {
              var of = an[tr];
              er(of, tr, an) && (al[Mo++] = of);
            }
            return al;
          }
          function s_(an, er) {
            var tr = an == null ? 0 : an.length;
            return !!tr && ny(an, er, 0) > -1;
          }
          function AE(an, er, tr) {
            for (var Va = -1, Mo = an == null ? 0 : an.length; ++Va < Mo; )
              if (tr(er, an[Va]))
                return true;
            return false;
          }
          function ko(an, er) {
            for (var tr = -1, Va = an == null ? 0 : an.length, Mo = Array(Va); ++tr < Va; )
              Mo[tr] = er(an[tr], tr, an);
            return Mo;
          }
          function tv(an, er) {
            for (var tr = -1, Va = er.length, Mo = an.length; ++tr < Va; )
              an[Mo + tr] = er[tr];
            return an;
          }
          function zS(an, er, tr, Va) {
            var Mo = -1, al = an == null ? 0 : an.length;
            for (Va && al && (tr = an[++Mo]); ++Mo < al; )
              tr = er(tr, an[Mo], Mo, an);
            return tr;
          }
          function ty(an, er, tr, Va) {
            var Mo = an == null ? 0 : an.length;
            for (Va && Mo && (tr = an[--Mo]); Mo--; )
              tr = er(tr, an[Mo], Mo, an);
            return tr;
          }
          function _w(an, er) {
            for (var tr = -1, Va = an == null ? 0 : an.length; ++tr < Va; )
              if (er(an[tr], tr, an))
                return true;
            return false;
          }
          var EE = xw("length");
          function BS(an) {
            return an.split("");
          }
          function F6(an) {
            return an.match(xg) || [];
          }
          function jS(an, er, tr) {
            var Va;
            return tr(an, function(Mo, al, of) {
              if (er(Mo, al, of))
                return Va = al, false;
            }), Va;
          }
          function GS(an, er, tr, Va) {
            for (var Mo = an.length, al = tr + (Va ? 1 : -1); Va ? al-- : ++al < Mo; )
              if (er(an[al], al, an))
                return al;
            return -1;
          }
          function ny(an, er, tr) {
            return er === er ? Vk(an, er, tr) : GS(an, Ml, tr);
          }
          function IE(an, er, tr, Va) {
            for (var Mo = tr - 1, al = an.length; ++Mo < al; )
              if (Va(an[Mo], er))
                return Mo;
            return -1;
          }
          function Ml(an) {
            return an !== an;
          }
          function rf(an, er) {
            var tr = an == null ? 0 : an.length;
            return tr ? E1(an, er) / tr : Yn;
          }
          function xw(an) {
            return function(er) {
              return er == null ? J : er[an];
            };
          }
          function ry(an) {
            return function(er) {
              return an == null ? J : an[er];
            };
          }
          function ww(an, er, tr, Va, Mo) {
            return Mo(an, function(al, of, Fl) {
              tr = Va ? (Va = false, al) : er(tr, al, of, Fl);
            }), tr;
          }
          function Sw(an, er) {
            var tr = an.length;
            for (an.sort(er); tr--; )
              an[tr] = an[tr].value;
            return an;
          }
          function E1(an, er) {
            for (var tr, Va = -1, Mo = an.length; ++Va < Mo; ) {
              var al = er(an[Va]);
              al !== J && (tr = tr === J ? al : tr + al);
            }
            return tr;
          }
          function ay(an, er) {
            for (var tr = -1, Va = Array(an); ++tr < an; )
              Va[tr] = er(tr);
            return Va;
          }
          function Cw(an, er) {
            return ko(er, function(tr) {
              return [tr, an[tr]];
            });
          }
          function Mw(an) {
            return an && an.slice(0, lu(an) + 1).replace(T0, "");
          }
          function Gf(an) {
            return function(er) {
              return an(er);
            };
          }
          function I1(an, er) {
            return ko(er, function(tr) {
              return an[tr];
            });
          }
          function iy(an, er) {
            return an.has(er);
          }
          function Rk(an, er) {
            for (var tr = -1, Va = an.length; ++tr < Va && ny(er, an[tr], 0) > -1; )
              ;
            return tr;
          }
          function Aw(an, er) {
            for (var tr = an.length; tr-- && ny(er, an[tr], 0) > -1; )
              ;
            return tr;
          }
          function T1(an, er) {
            for (var tr = an.length, Va = 0; tr--; )
              an[tr] === er && ++Va;
            return Va;
          }
          var WS = ry(wE), N6 = ry(Ik);
          function V6(an) {
            return "\\" + P6[an];
          }
          function TE(an, er) {
            return an == null ? J : an[er];
          }
          function af(an) {
            return D6.test(an);
          }
          function Fk(an) {
            return k6.test(an);
          }
          function DE(an) {
            for (var er, tr = []; !(er = an.next()).done; )
              tr.push(er.value);
            return tr;
          }
          function kE(an) {
            var er = -1, tr = Array(an.size);
            return an.forEach(function(Va, Mo) {
              tr[++er] = [Mo, Va];
            }), tr;
          }
          function Nk(an, er) {
            return function(tr) {
              return an(er(tr));
            };
          }
          function oy(an, er) {
            for (var tr = -1, Va = an.length, Mo = 0, al = []; ++tr < Va; ) {
              var of = an[tr];
              (of === er || of === Ke) && (an[tr] = Ke, al[Mo++] = tr);
            }
            return al;
          }
          function HS(an) {
            var er = -1, tr = Array(an.size);
            return an.forEach(function(Va) {
              tr[++er] = Va;
            }), tr;
          }
          function z6(an) {
            var er = -1, tr = Array(an.size);
            return an.forEach(function(Va) {
              tr[++er] = [Va, Va];
            }), tr;
          }
          function Vk(an, er, tr) {
            for (var Va = tr - 1, Mo = an.length; ++Va < Mo; )
              if (an[Va] === er)
                return Va;
            return -1;
          }
          function B6(an, er, tr) {
            for (var Va = tr + 1; Va--; )
              if (an[Va] === er)
                return Va;
            return Va;
          }
          function Qo(an) {
            return af(an) ? PE(an) : EE(an);
          }
          function hh(an) {
            return af(an) ? zk(an) : BS(an);
          }
          function lu(an) {
            for (var er = an.length; er-- && S1.test(an.charAt(er)); )
              ;
            return er;
          }
          var Bh = ry(SE);
          function PE(an) {
            for (var er = yw.lastIndex = 0; yw.test(an); )
              ++er;
            return er;
          }
          function zk(an) {
            return an.match(yw) || [];
          }
          function Ad(an) {
            return an.match(Ek) || [];
          }
          var Co = function an(er) {
            er = er == null ? dc : O0.defaults(dc.Object(), er, O0.pick(dc, Qp));
            var tr = er.Array, Va = er.Date, Mo = er.Error, al = er.Function, of = er.Math, Fl = er.Object, LE = er.RegExp, OE = er.String, Ed = er.TypeError, Gu = tr.prototype, Bk = al.prototype, tu = Fl.prototype, uu = er["__core-js_shared__"], cu = Bk.toString, Al = tu.hasOwnProperty, jk = 0, Gk = function() {
              var P = /[^.]+$/.exec(uu && uu.keys && uu.keys.IE_PROTO || "");
              return P ? "Symbol(src)_1." + P : "";
            }(), $S = tu.toString, j6 = cu.call(Fl), Wk = dc._, Hk = LE("^" + cu.call(Al).replace(I0, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), l_ = kk ? er.Buffer : J, nv = er.Symbol, sy = er.Uint8Array, u_ = l_ ? l_.allocUnsafe : J, Ew = Nk(Fl.getPrototypeOf, Fl), Iw = Fl.create, sf = tu.propertyIsEnumerable, R0 = Gu.splice, $k = nv ? nv.isConcatSpreadable : J, es = nv ? nv.iterator : J, D1 = nv ? nv.toStringTag : J, US = function() {
              try {
                var P = Vn(Fl, "defineProperty");
                return P({}, "", {}), P;
              } catch {
              }
            }(), G6 = er.clearTimeout !== dc.clearTimeout && er.clearTimeout, Uk = Va && Va.now !== dc.Date.now && Va.now, F0 = er.setTimeout !== dc.setTimeout && er.setTimeout, Ao = of.ceil, Tw = of.floor, Id = Fl.getOwnPropertySymbols, qk = l_ ? l_.isBuffer : J, Yk = er.isFinite, El = Gu.join, W6 = Nk(Fl.keys, Fl), Vc = of.max, lf = of.min, RE = Va.now, H6 = er.parseInt, c_ = of.random, FE = Gu.reverse, Dw = Vn(er, "DataView"), N0 = Vn(er, "Map"), jh = Vn(er, "Promise"), k1 = Vn(er, "Set"), f_ = Vn(er, "WeakMap"), kw = Vn(Fl, "create"), Pw = f_ && new f_(), h_ = {}, zc = nr(Dw), ly = nr(N0), P1 = nr(jh), qS = nr(k1), Lw = nr(f_), Ow = nv ? nv.prototype : J, d_ = Ow ? Ow.valueOf : J, pc = Ow ? Ow.toString : J;
            function nt(P) {
              if (Hc(P) && !ea(P) && !(P instanceof ws)) {
                if (P instanceof pp)
                  return P;
                if (Al.call(P, "__wrapped__"))
                  return ia(P);
              }
              return new pp(P);
            }
            var p_ = function() {
              function P() {
              }
              return function(G) {
                if (!$u(G))
                  return {};
                if (Iw)
                  return Iw(G);
                P.prototype = G;
                var ae = new P();
                return P.prototype = J, ae;
              };
            }();
            function YS() {
            }
            function pp(P, G) {
              this.__wrapped__ = P, this.__actions__ = [], this.__chain__ = !!G, this.__index__ = 0, this.__values__ = J;
            }
            nt.templateSettings = { escape: Bf, evaluate: Cd, interpolate: Nh, variable: "", imports: { _: nt } }, nt.prototype = YS.prototype, nt.prototype.constructor = nt, pp.prototype = p_(YS.prototype), pp.prototype.constructor = pp;
            function ws(P) {
              this.__wrapped__ = P, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = ya, this.__views__ = [];
            }
            function $6() {
              var P = new ws(this.__wrapped__);
              return P.__actions__ = We(this.__actions__), P.__dir__ = this.__dir__, P.__filtered__ = this.__filtered__, P.__iteratees__ = We(this.__iteratees__), P.__takeCount__ = this.__takeCount__, P.__views__ = We(this.__views__), P;
            }
            function NE() {
              if (this.__filtered__) {
                var P = new ws(this);
                P.__dir__ = -1, P.__filtered__ = true;
              } else
                P = this.clone(), P.__dir__ *= -1;
              return P;
            }
            function VE() {
              var P = this.__wrapped__.value(), G = this.__dir__, ae = ea(P), Me = G < 0, Ue = ae ? P.length : 0, gt = qo(0, Ue, this.__views__), jt = gt.start, tn = gt.end, Sn = tn - jt, Hr = Me ? tn : jt - 1, qr = this.__iteratees__, ca = qr.length, Aa = 0, fi = lf(Sn, this.__takeCount__);
              if (!ae || !Me && Ue == Sn && fi == Sn)
                return ge(P, this.__actions__);
              var Ki = [];
              e:
                for (; Sn-- && Aa < fi; ) {
                  Hr += G;
                  for (var us = -1, Ui = P[Hr]; ++us < ca; ) {
                    var Rs = qr[us], Js = Rs.iteratee, uv = Rs.type, Xh = Js(Ui);
                    if (uv == qa)
                      Ui = Xh;
                    else if (!Xh) {
                      if (uv == Xa)
                        continue e;
                      break e;
                    }
                  }
                  Ki[Aa++] = Ui;
                }
              return Ki;
            }
            ws.prototype = p_(YS.prototype), ws.prototype.constructor = ws;
            function uy(P) {
              var G = -1, ae = P == null ? 0 : P.length;
              for (this.clear(); ++G < ae; ) {
                var Me = P[G];
                this.set(Me[0], Me[1]);
              }
            }
            function U6() {
              this.__data__ = kw ? kw(null) : {}, this.size = 0;
            }
            function zE(P) {
              var G = this.has(P) && delete this.__data__[P];
              return this.size -= G ? 1 : 0, G;
            }
            function q6(P) {
              var G = this.__data__;
              if (kw) {
                var ae = G[P];
                return ae === De ? J : ae;
              }
              return Al.call(G, P) ? G[P] : J;
            }
            function ZS(P) {
              var G = this.__data__;
              return kw ? G[P] !== J : Al.call(G, P);
            }
            function Zk(P, G) {
              var ae = this.__data__;
              return this.size += this.has(P) ? 0 : 1, ae[P] = kw && G === J ? De : G, this;
            }
            uy.prototype.clear = U6, uy.prototype.delete = zE, uy.prototype.get = q6, uy.prototype.has = ZS, uy.prototype.set = Zk;
            function Bc(P) {
              var G = -1, ae = P == null ? 0 : P.length;
              for (this.clear(); ++G < ae; ) {
                var Me = P[G];
                this.set(Me[0], Me[1]);
              }
            }
            function Xk() {
              this.__data__ = [], this.size = 0;
            }
            function BE(P) {
              var G = this.__data__, ae = JS(G, P);
              if (ae < 0)
                return false;
              var Me = G.length - 1;
              return ae == Me ? G.pop() : R0.call(G, ae, 1), --this.size, true;
            }
            function Kk(P) {
              var G = this.__data__, ae = JS(G, P);
              return ae < 0 ? J : G[ae][1];
            }
            function v_(P) {
              return JS(this.__data__, P) > -1;
            }
            function Y6(P, G) {
              var ae = this.__data__, Me = JS(ae, P);
              return Me < 0 ? (++this.size, ae.push([P, G])) : ae[Me][1] = G, this;
            }
            Bc.prototype.clear = Xk, Bc.prototype.delete = BE, Bc.prototype.get = Kk, Bc.prototype.has = v_, Bc.prototype.set = Y6;
            function V0(P) {
              var G = -1, ae = P == null ? 0 : P.length;
              for (this.clear(); ++G < ae; ) {
                var Me = P[G];
                this.set(Me[0], Me[1]);
              }
            }
            function Jk() {
              this.size = 0, this.__data__ = { hash: new uy(), map: new (N0 || Bc)(), string: new uy() };
            }
            function jE(P) {
              var G = Pr(this, P).delete(P);
              return this.size -= G ? 1 : 0, G;
            }
            function Rw(P) {
              return Pr(this, P).get(P);
            }
            function Qk(P) {
              return Pr(this, P).has(P);
            }
            function eP(P, G) {
              var ae = Pr(this, P), Me = ae.size;
              return ae.set(P, G), this.size += ae.size == Me ? 0 : 1, this;
            }
            V0.prototype.clear = Jk, V0.prototype.delete = jE, V0.prototype.get = Rw, V0.prototype.has = Qk, V0.prototype.set = eP;
            function cy(P) {
              var G = -1, ae = P == null ? 0 : P.length;
              for (this.__data__ = new V0(); ++G < ae; )
                this.add(P[G]);
            }
            function GE(P) {
              return this.__data__.set(P, De), this;
            }
            function Z6(P) {
              return this.__data__.has(P);
            }
            cy.prototype.add = cy.prototype.push = GE, cy.prototype.has = Z6;
            function Bv(P) {
              var G = this.__data__ = new Bc(P);
              this.size = G.size;
            }
            function X6() {
              this.__data__ = new Bc(), this.size = 0;
            }
            function K6(P) {
              var G = this.__data__, ae = G.delete(P);
              return this.size = G.size, ae;
            }
            function XS(P) {
              return this.__data__.get(P);
            }
            function J6(P) {
              return this.__data__.has(P);
            }
            function Q6(P, G) {
              var ae = this.__data__;
              if (ae instanceof Bc) {
                var Me = ae.__data__;
                if (!N0 || Me.length < te - 1)
                  return Me.push([P, G]), this.size = ++ae.size, this;
                ae = this.__data__ = new V0(Me);
              }
              return ae.set(P, G), this.size = ae.size, this;
            }
            Bv.prototype.clear = X6, Bv.prototype.delete = K6, Bv.prototype.get = XS, Bv.prototype.has = J6, Bv.prototype.set = Q6;
            function tP(P, G) {
              var ae = ea(P), Me = !ae && Zn(P), Ue = !ae && !Me && hy(P), gt = !ae && !Me && !Ue && vC(P), jt = ae || Me || Ue || gt, tn = jt ? ay(P.length, OE) : [], Sn = tn.length;
              for (var Hr in P)
                (G || Al.call(P, Hr)) && !(jt && (Hr == "length" || Ue && (Hr == "offset" || Hr == "parent") || gt && (Hr == "buffer" || Hr == "byteLength" || Hr == "byteOffset") || Cf(Hr, Sn))) && tn.push(Hr);
              return tn;
            }
            function nP(P) {
              var G = P.length;
              return G ? P[z10(0, G - 1)] : J;
            }
            function rP(P, G) {
              return Dt(We(P), L1(G, 0, P.length));
            }
            function eF(P) {
              return Dt(We(P));
            }
            function KS(P, G, ae) {
              (ae !== J && !Pd(P[G], ae) || ae === J && !(G in P)) && jv(P, G, ae);
            }
            function Wf(P, G, ae) {
              var Me = P[G];
              (!(Al.call(P, G) && Pd(Me, ae)) || ae === J && !(G in P)) && jv(P, G, ae);
            }
            function JS(P, G) {
              for (var ae = P.length; ae--; )
                if (Pd(P[ae][0], G))
                  return ae;
              return -1;
            }
            function aP(P, G, ae, Me) {
              return Gv(P, function(Ue, gt, jt) {
                G(Me, Ue, ae(Ue), jt);
              }), Me;
            }
            function iP(P, G) {
              return P && pn(G, $i(G), P);
            }
            function tF(P, G) {
              return P && pn(G, lv(G), P);
            }
            function jv(P, G, ae) {
              G == "__proto__" && US ? US(P, G, { configurable: true, enumerable: true, value: ae, writable: true }) : P[G] = ae;
            }
            function WE(P, G) {
              for (var ae = -1, Me = G.length, Ue = tr(Me), gt = P == null; ++ae < Me; )
                Ue[ae] = gt ? J : $w(P, G[ae]);
              return Ue;
            }
            function L1(P, G, ae) {
              return P === P && (ae !== J && (P = P <= ae ? P : ae), G !== J && (P = P >= G ? P : G)), P;
            }
            function rv(P, G, ae, Me, Ue, gt) {
              var jt, tn = G & pt, Sn = G & Bt, Hr = G & qt;
              if (ae && (jt = Ue ? ae(P, Me, Ue, gt) : ae(P)), jt !== J)
                return jt;
              if (!$u(P))
                return P;
              var qr = ea(P);
              if (qr) {
                if (jt = Du(P), !tn)
                  return We(P, jt);
              } else {
                var ca = Ri(P), Aa = ca == cp || ca == tc;
                if (hy(P))
                  return Je(P, tn);
                if (ca == ef || ca == is || Aa && !Ue) {
                  if (jt = Sn || Aa ? {} : Wc(P), !tn)
                    return Sn ? pr(P, tF(jt, P)) : zn(P, iP(jt, P));
                } else {
                  if (!eu[ca])
                    return Ue ? P : {};
                  jt = ku(P, ca, tn);
                }
              }
              gt || (gt = new Bv());
              var fi = gt.get(P);
              if (fi)
                return fi;
              gt.set(P, jt), pC(P) ? P.forEach(function(Ui) {
                jt.add(rv(Ui, G, ae, Ui, P, gt));
              }) : $j(P) && P.forEach(function(Ui, Rs) {
                jt.set(Rs, rv(Ui, G, ae, Rs, P, gt));
              });
              var Ki = Hr ? Sn ? iv : Mg : Sn ? lv : $i, us = qr ? J : Ki(P);
              return zh(us || P, function(Ui, Rs) {
                us && (Rs = Ui, Ui = P[Rs]), Wf(jt, Rs, rv(Ui, G, ae, Rs, P, gt));
              }), jt;
            }
            function nF(P) {
              var G = $i(P);
              return function(ae) {
                return oP(ae, P, G);
              };
            }
            function oP(P, G, ae) {
              var Me = ae.length;
              if (P == null)
                return !Me;
              for (P = Fl(P); Me--; ) {
                var Ue = ae[Me], gt = G[Ue], jt = P[Ue];
                if (jt === J && !(Ue in P) || !gt(jt))
                  return false;
              }
              return true;
            }
            function Fw(P, G, ae) {
              if (typeof P != "function")
                throw new Ed(Ie);
              return Pt(function() {
                P.apply(J, ae);
              }, G);
            }
            function O1(P, G, ae, Me) {
              var Ue = -1, gt = s_, jt = true, tn = P.length, Sn = [], Hr = G.length;
              if (!tn)
                return Sn;
              ae && (G = ko(G, Gf(ae))), Me ? (gt = AE, jt = false) : G.length >= te && (gt = iy, jt = false, G = new cy(G));
              e:
                for (; ++Ue < tn; ) {
                  var qr = P[Ue], ca = ae == null ? qr : ae(qr);
                  if (qr = Me || qr !== 0 ? qr : 0, jt && ca === ca) {
                    for (var Aa = Hr; Aa--; )
                      if (G[Aa] === ca)
                        continue e;
                    Sn.push(qr);
                  } else
                    gt(G, ca, Me) || Sn.push(qr);
                }
              return Sn;
            }
            var Gv = Gn(vp), g_ = Gn(eC, true);
            function rF(P, G) {
              var ae = true;
              return Gv(P, function(Me, Ue, gt) {
                return ae = !!G(Me, Ue, gt), ae;
              }), ae;
            }
            function QS(P, G, ae) {
              for (var Me = -1, Ue = P.length; ++Me < Ue; ) {
                var gt = P[Me], jt = G(gt);
                if (jt != null && (tn === J ? jt === jt && !Ld(jt) : ae(jt, tn)))
                  var tn = jt, Sn = gt;
              }
              return Sn;
            }
            function HE(P, G, ae, Me) {
              var Ue = P.length;
              for (ae = ls(ae), ae < 0 && (ae = -ae > Ue ? 0 : Ue + ae), Me = Me === J || Me > Ue ? Ue : ls(Me), Me < 0 && (Me += Ue), Me = ae > Me ? 0 : Zj(Me); ae < Me; )
                P[ae++] = G;
              return P;
            }
            function z0(P, G) {
              var ae = [];
              return Gv(P, function(Me, Ue, gt) {
                G(Me, Ue, gt) && ae.push(Me);
              }), ae;
            }
            function wf(P, G, ae, Me, Ue) {
              var gt = -1, jt = P.length;
              for (ae || (ae = mp), Ue || (Ue = []); ++gt < jt; ) {
                var tn = P[gt];
                G > 0 && ae(tn) ? G > 1 ? wf(tn, G - 1, ae, Me, Ue) : tv(Ue, tn) : Me || (Ue[Ue.length] = tn);
              }
              return Ue;
            }
            var $E = Tr(), Gh = Tr(true);
            function vp(P, G) {
              return P && $E(P, G, $i);
            }
            function eC(P, G) {
              return P && Gh(P, G, $i);
            }
            function Nw(P, G) {
              return L0(G, function(ae) {
                return Ks(P[ae]);
              });
            }
            function B0(P, G) {
              G = Ee(G, P);
              for (var ae = 0, Me = G.length; P != null && ae < Me; )
                P = P[mr(G[ae++])];
              return ae && ae == Me ? P : J;
            }
            function UE(P, G, ae) {
              var Me = G(P);
              return ea(P) ? Me : tv(Me, ae(P));
            }
            function jc(P) {
              return P == null ? P === J ? Xp : fp : D1 && D1 in Fl(P) ? Br(P) : b_(P);
            }
            function qE(P, G) {
              return P > G;
            }
            function Gi(P, G) {
              return P != null && Al.call(P, G);
            }
            function sP(P, G) {
              return P != null && G in Fl(P);
            }
            function aF(P, G, ae) {
              return P >= lf(G, ae) && P < Vc(G, ae);
            }
            function YE(P, G, ae) {
              for (var Me = ae ? AE : s_, Ue = P[0].length, gt = P.length, jt = gt, tn = tr(gt), Sn = 1 / 0, Hr = []; jt--; ) {
                var qr = P[jt];
                jt && G && (qr = ko(qr, Gf(G))), Sn = lf(qr.length, Sn), tn[jt] = !ae && (G || Ue >= 120 && qr.length >= 120) ? new cy(jt && qr) : J;
              }
              qr = P[0];
              var ca = -1, Aa = tn[0];
              e:
                for (; ++ca < Ue && Hr.length < Sn; ) {
                  var fi = qr[ca], Ki = G ? G(fi) : fi;
                  if (fi = ae || fi !== 0 ? fi : 0, !(Aa ? iy(Aa, Ki) : Me(Hr, Ki, ae))) {
                    for (jt = gt; --jt; ) {
                      var us = tn[jt];
                      if (!(us ? iy(us, Ki) : Me(P[jt], Ki, ae)))
                        continue e;
                    }
                    Aa && Aa.push(Ki), Hr.push(fi);
                  }
                }
              return Hr;
            }
            function iF(P, G, ae, Me) {
              return vp(P, function(Ue, gt, jt) {
                G(Me, ae(Ue), gt, jt);
              }), Me;
            }
            function R1(P, G, ae) {
              G = Ee(G, P), P = vP(P, G);
              var Me = P == null ? P : P[mr(vh(G))];
              return Me == null ? J : dp(Me, P, ae);
            }
            function Vw(P) {
              return Hc(P) && jc(P) == is;
            }
            function F1(P) {
              return Hc(P) && jc(P) == jn;
            }
            function ZE(P) {
              return Hc(P) && jc(P) == rl;
            }
            function Sg(P, G, ae, Me, Ue) {
              return P === G ? true : P == null || G == null || !Hc(P) && !Hc(G) ? P !== P && G !== G : XE(P, G, ae, Me, Sg, Ue);
            }
            function XE(P, G, ae, Me, Ue, gt) {
              var jt = ea(P), tn = ea(G), Sn = jt ? io : Ri(P), Hr = tn ? io : Ri(G);
              Sn = Sn == is ? ef : Sn, Hr = Hr == is ? ef : Hr;
              var qr = Sn == ef, ca = Hr == ef, Aa = Sn == Hr;
              if (Aa && hy(P)) {
                if (!hy(G))
                  return false;
                jt = true, qr = false;
              }
              if (Aa && !qr)
                return gt || (gt = new Bv()), jt || vC(P) ? gp(P, G, ae, Me, Ue, gt) : j0(P, G, Sn, ae, Me, Ue, gt);
              if (!(ae & Yt)) {
                var fi = qr && Al.call(P, "__wrapped__"), Ki = ca && Al.call(G, "__wrapped__");
                if (fi || Ki) {
                  var us = fi ? P.value() : P, Ui = Ki ? G.value() : G;
                  return gt || (gt = new Bv()), Ue(us, Ui, ae, Me, gt);
                }
              }
              return Aa ? (gt || (gt = new Bv()), Td(P, G, ae, Me, Ue, gt)) : false;
            }
            function lP(P) {
              return Hc(P) && Ri(P) == cc;
            }
            function KE(P, G, ae, Me) {
              var Ue = ae.length, gt = Ue, jt = !Me;
              if (P == null)
                return !gt;
              for (P = Fl(P); Ue--; ) {
                var tn = ae[Ue];
                if (jt && tn[2] ? tn[1] !== P[tn[0]] : !(tn[0] in P))
                  return false;
              }
              for (; ++Ue < gt; ) {
                tn = ae[Ue];
                var Sn = tn[0], Hr = P[Sn], qr = tn[1];
                if (jt && tn[2]) {
                  if (Hr === J && !(Sn in P))
                    return false;
                } else {
                  var ca = new Bv();
                  if (Me)
                    var Aa = Me(Hr, qr, Sn, P, G, ca);
                  if (!(Aa === J ? Sg(qr, Hr, Yt | nn, Me, ca) : Aa))
                    return false;
                }
              }
              return true;
            }
            function N1(P) {
              if (!$u(P) || $h(P))
                return false;
              var G = Ks(P) ? Hk : Cr;
              return G.test(nr(P));
            }
            function tC(P) {
              return Hc(P) && jc(P) == ch;
            }
            function JE(P) {
              return Hc(P) && Ri(P) == nc;
            }
            function uP(P) {
              return Hc(P) && sI(P.length) && !!Iu[jc(P)];
            }
            function cP(P) {
              return typeof P == "function" ? P : P == null ? _p : typeof P == "object" ? ea(P) ? tI(P[0], P[1]) : eI(P) : dG(P);
            }
            function nC(P) {
              if (!ph(P))
                return W6(P);
              var G = [];
              for (var ae in Fl(P))
                Al.call(P, ae) && ae != "constructor" && G.push(ae);
              return G;
            }
            function QE(P) {
              if (!$u(P))
                return lF(P);
              var G = ph(P), ae = [];
              for (var Me in P)
                Me == "constructor" && (G || !Al.call(P, Me)) || ae.push(Me);
              return ae;
            }
            function V1(P, G) {
              return P < G;
            }
            function fP(P, G) {
              var ae = -1, Me = zo(P) ? tr(P.length) : [];
              return Gv(P, function(Ue, gt, jt) {
                Me[++ae] = G(Ue, gt, jt);
              }), Me;
            }
            function eI(P) {
              var G = Hn(P);
              return G.length == 1 && G[0][2] ? ov(G[0][0], G[0][1]) : function(ae) {
                return ae === P || KE(ae, P, G);
              };
            }
            function tI(P, G) {
              return gc(P) && kd(G) ? ov(mr(P), G) : function(ae) {
                var Me = $w(ae, P);
                return Me === J && Me === G ? st(ae, P) : Sg(G, Me, Yt | nn);
              };
            }
            function rC(P, G, ae, Me, Ue) {
              P !== G && $E(G, function(gt, jt) {
                if (Ue || (Ue = new Bv()), $u(gt))
                  oF(P, G, jt, ae, rC, Me, Ue);
                else {
                  var tn = Me ? Me(rI(P, jt), gt, jt + "", P, G, Ue) : J;
                  tn === J && (tn = gt), KS(P, jt, tn);
                }
              }, lv);
            }
            function oF(P, G, ae, Me, Ue, gt, jt) {
              var tn = rI(P, ae), Sn = rI(G, ae), Hr = jt.get(Sn);
              if (Hr) {
                KS(P, ae, Hr);
                return;
              }
              var qr = gt ? gt(tn, Sn, ae + "", P, G, jt) : J, ca = qr === J;
              if (ca) {
                var Aa = ea(Sn), fi = !Aa && hy(Sn), Ki = !Aa && !fi && vC(Sn);
                qr = Sn, Aa || fi || Ki ? ea(tn) ? qr = tn : Ms(tn) ? qr = We(tn) : fi ? (ca = false, qr = Je(Sn, true)) : Ki ? (ca = false, qr = un(Sn, true)) : qr = [] : hC(Sn) || Zn(Sn) ? (qr = tn, Zn(tn) ? qr = qh(tn) : (!$u(tn) || Ks(tn)) && (qr = Wc(Sn))) : ca = false;
              }
              ca && (jt.set(Sn, qr), Ue(qr, Sn, Me, gt, jt), jt.delete(Sn)), KS(P, ae, qr);
            }
            function hP(P, G) {
              var ae = P.length;
              if (ae)
                return G += G < 0 ? ae : 0, Cf(G, ae) ? P[G] : J;
            }
            function nI(P, G, ae) {
              G.length ? G = ko(G, function(gt) {
                return ea(gt) ? function(jt) {
                  return B0(jt, gt.length === 1 ? gt[0] : gt);
                } : gt;
              }) : G = [_p];
              var Me = -1;
              G = ko(G, Gf(ki()));
              var Ue = fP(P, function(gt, jt, tn) {
                var Sn = ko(G, function(Hr) {
                  return Hr(gt);
                });
                return { criteria: Sn, index: ++Me, value: gt };
              });
              return Sw(Ue, function(gt, jt) {
                return _r(gt, jt, ae);
              });
            }
            function m_(P, G) {
              return dP(P, G, function(ae, Me) {
                return st(P, Me);
              });
            }
            function dP(P, G, ae) {
              for (var Me = -1, Ue = G.length, gt = {}; ++Me < Ue; ) {
                var jt = G[Me], tn = B0(P, jt);
                ae(tn, jt) && Kt(gt, Ee(jt, P), tn);
              }
              return gt;
            }
            function sF(P) {
              return function(G) {
                return B0(G, P);
              };
            }
            function aC(P, G, ae, Me) {
              var Ue = Me ? IE : ny, gt = -1, jt = G.length, tn = P;
              for (P === G && (G = We(G)), ae && (tn = ko(P, Gf(ae))); ++gt < jt; )
                for (var Sn = 0, Hr = G[gt], qr = ae ? ae(Hr) : Hr; (Sn = Ue(tn, qr, Sn, Me)) > -1; )
                  tn !== P && R0.call(tn, Sn, 1), R0.call(P, Sn, 1);
              return P;
            }
            function k10(P, G) {
              for (var ae = P ? G.length : 0, Me = ae - 1; ae--; ) {
                var Ue = G[ae];
                if (ae == Me || Ue !== gt) {
                  var gt = Ue;
                  Cf(Ue) ? R0.call(P, Ue, 1) : Wh(P, Ue);
                }
              }
              return P;
            }
            function z10(P, G) {
              return P + Tw(c_() * (G - P + 1));
            }
            function oe(P, G, ae, Me) {
              for (var Ue = -1, gt = Vc(Ao((G - P) / (ae || 1)), 0), jt = tr(gt); gt--; )
                jt[Me ? gt : ++Ue] = P, P += ae;
              return jt;
            }
            function Se(P, G) {
              var ae = "";
              if (!P || G < 1 || G > gr)
                return ae;
              do
                G % 2 && (ae += P), G = Tw(G / 2), G && (P += P);
              while (G);
              return ae;
            }
            function Ge(P, G) {
              return Vt(pP(P, G, _p), P + "");
            }
            function vt(P) {
              return nP(_C(P));
            }
            function Ht(P, G) {
              var ae = _C(P);
              return Dt(ae, L1(G, 0, ae.length));
            }
            function Kt(P, G, ae, Me) {
              if (!$u(P))
                return P;
              G = Ee(G, P);
              for (var Ue = -1, gt = G.length, jt = gt - 1, tn = P; tn != null && ++Ue < gt; ) {
                var Sn = mr(G[Ue]), Hr = ae;
                if (Sn === "__proto__" || Sn === "constructor" || Sn === "prototype")
                  return P;
                if (Ue != jt) {
                  var qr = tn[Sn];
                  Hr = Me ? Me(qr, Sn, tn) : J, Hr === J && (Hr = $u(qr) ? qr : Cf(G[Ue + 1]) ? [] : {});
                }
                Wf(tn, Sn, Hr), tn = tn[Sn];
              }
              return P;
            }
            var xn = Pw ? function(P, G) {
              return Pw.set(P, G), P;
            } : _p, Gr = US ? function(P, G) {
              return US(P, "toString", { configurable: true, enumerable: false, value: Lg(G), writable: true });
            } : _p;
            function Wr(P) {
              return Dt(_C(P));
            }
            function Ur(P, G, ae) {
              var Me = -1, Ue = P.length;
              G < 0 && (G = -G > Ue ? 0 : Ue + G), ae = ae > Ue ? Ue : ae, ae < 0 && (ae += Ue), Ue = G > ae ? 0 : ae - G >>> 0, G >>>= 0;
              for (var gt = tr(Ue); ++Me < Ue; )
                gt[Me] = P[Me + G];
              return gt;
            }
            function Ba(P, G) {
              var ae;
              return Gv(P, function(Me, Ue, gt) {
                return ae = G(Me, Ue, gt), !ae;
              }), !!ae;
            }
            function vi(P, G, ae) {
              var Me = 0, Ue = P == null ? Me : P.length;
              if (typeof G == "number" && G === G && Ue <= Wi) {
                for (; Me < Ue; ) {
                  var gt = Me + Ue >>> 1, jt = P[gt];
                  jt !== null && !Ld(jt) && (ae ? jt <= G : jt < G) ? Me = gt + 1 : Ue = gt;
                }
                return Ue;
              }
              return Ni(P, G, _p, ae);
            }
            function Ni(P, G, ae, Me) {
              var Ue = 0, gt = P == null ? 0 : P.length;
              if (gt === 0)
                return 0;
              G = ae(G);
              for (var jt = G !== G, tn = G === null, Sn = Ld(G), Hr = G === J; Ue < gt; ) {
                var qr = Tw((Ue + gt) / 2), ca = ae(P[qr]), Aa = ca !== J, fi = ca === null, Ki = ca === ca, us = Ld(ca);
                if (jt)
                  var Ui = Me || Ki;
                else
                  Hr ? Ui = Ki && (Me || Aa) : tn ? Ui = Ki && Aa && (Me || !fi) : Sn ? Ui = Ki && Aa && !fi && (Me || !us) : fi || us ? Ui = false : Ui = Me ? ca <= G : ca < G;
                Ui ? Ue = qr + 1 : gt = qr;
              }
              return lf(gt, sa);
            }
            function $o(P, G) {
              for (var ae = -1, Me = P.length, Ue = 0, gt = []; ++ae < Me; ) {
                var jt = P[ae], tn = G ? G(jt) : jt;
                if (!ae || !Pd(tn, Sn)) {
                  var Sn = tn;
                  gt[Ue++] = jt === 0 ? 0 : jt;
                }
              }
              return gt;
            }
            function Hi(P) {
              return typeof P == "number" ? P : Ld(P) ? Yn : +P;
            }
            function Zi(P) {
              if (typeof P == "string")
                return P;
              if (ea(P))
                return ko(P, Zi) + "";
              if (Ld(P))
                return pc ? pc.call(P) : "";
              var G = P + "";
              return G == "0" && 1 / P == -Ai ? "-0" : G;
            }
            function No(P, G, ae) {
              var Me = -1, Ue = s_, gt = P.length, jt = true, tn = [], Sn = tn;
              if (ae)
                jt = false, Ue = AE;
              else if (gt >= te) {
                var Hr = G ? null : yl(P);
                if (Hr)
                  return HS(Hr);
                jt = false, Ue = iy, Sn = new cy();
              } else
                Sn = G ? [] : tn;
              e:
                for (; ++Me < gt; ) {
                  var qr = P[Me], ca = G ? G(qr) : qr;
                  if (qr = ae || qr !== 0 ? qr : 0, jt && ca === ca) {
                    for (var Aa = Sn.length; Aa--; )
                      if (Sn[Aa] === ca)
                        continue e;
                    G && Sn.push(ca), tn.push(qr);
                  } else
                    Ue(Sn, ca, ae) || (Sn !== tn && Sn.push(ca), tn.push(qr));
                }
              return tn;
            }
            function Wh(P, G) {
              return G = Ee(G, P), P = vP(P, G), P == null || delete P[mr(vh(G))];
            }
            function dh(P, G, ae, Me) {
              return Kt(P, G, ae(B0(P, G)), Me);
            }
            function Y(P, G, ae, Me) {
              for (var Ue = P.length, gt = Me ? Ue : -1; (Me ? gt-- : ++gt < Ue) && G(P[gt], gt, P); )
                ;
              return ae ? Ur(P, Me ? 0 : gt, Me ? gt + 1 : Ue) : Ur(P, Me ? gt + 1 : 0, Me ? Ue : gt);
            }
            function ge(P, G) {
              var ae = P;
              return ae instanceof ws && (ae = ae.value()), zS(G, function(Me, Ue) {
                return Ue.func.apply(Ue.thisArg, tv([Me], Ue.args));
              }, ae);
            }
            function Q(P, G, ae) {
              var Me = P.length;
              if (Me < 2)
                return Me ? No(P[0]) : [];
              for (var Ue = -1, gt = tr(Me); ++Ue < Me; )
                for (var jt = P[Ue], tn = -1; ++tn < Me; )
                  tn != Ue && (gt[Ue] = O1(gt[Ue] || jt, P[tn], G, ae));
              return No(wf(gt, 1), G, ae);
            }
            function ne(P, G, ae) {
              for (var Me = -1, Ue = P.length, gt = G.length, jt = {}; ++Me < Ue; ) {
                var tn = Me < gt ? G[Me] : J;
                ae(jt, P[Me], tn);
              }
              return jt;
            }
            function re(P) {
              return Ms(P) ? P : [];
            }
            function fe(P) {
              return typeof P == "function" ? P : _p;
            }
            function Ee(P, G) {
              return ea(P) ? P : gc(P, G) ? [P] : Fn(ql(P));
            }
            var Oe = Ge;
            function Be(P, G, ae) {
              var Me = P.length;
              return ae = ae === J ? Me : ae, !G && ae >= Me ? P : Ur(P, G, ae);
            }
            var Ze = G6 || function(P) {
              return dc.clearTimeout(P);
            };
            function Je(P, G) {
              if (G)
                return P.slice();
              var ae = P.length, Me = u_ ? u_(ae) : new P.constructor(ae);
              return P.copy(Me), Me;
            }
            function yt(P) {
              var G = new P.constructor(P.byteLength);
              return new sy(G).set(new sy(P)), G;
            }
            function Gt(P, G) {
              var ae = G ? yt(P.buffer) : P.buffer;
              return new P.constructor(ae, P.byteOffset, P.byteLength);
            }
            function Xt(P) {
              var G = new P.constructor(P.source, Ct.exec(P));
              return G.lastIndex = P.lastIndex, G;
            }
            function Zt(P) {
              return d_ ? Fl(d_.call(P)) : {};
            }
            function un(P, G) {
              var ae = G ? yt(P.buffer) : P.buffer;
              return new P.constructor(ae, P.byteOffset, P.length);
            }
            function yn(P, G) {
              if (P !== G) {
                var ae = P !== J, Me = P === null, Ue = P === P, gt = Ld(P), jt = G !== J, tn = G === null, Sn = G === G, Hr = Ld(G);
                if (!tn && !Hr && !gt && P > G || gt && jt && Sn && !tn && !Hr || Me && jt && Sn || !ae && Sn || !Ue)
                  return 1;
                if (!Me && !gt && !Hr && P < G || Hr && ae && Ue && !Me && !gt || tn && ae && Ue || !jt && Ue || !Sn)
                  return -1;
              }
              return 0;
            }
            function _r(P, G, ae) {
              for (var Me = -1, Ue = P.criteria, gt = G.criteria, jt = Ue.length, tn = ae.length; ++Me < jt; ) {
                var Sn = yn(Ue[Me], gt[Me]);
                if (Sn) {
                  if (Me >= tn)
                    return Sn;
                  var Hr = ae[Me];
                  return Sn * (Hr == "desc" ? -1 : 1);
                }
              }
              return P.index - G.index;
            }
            function cr(P, G, ae, Me) {
              for (var Ue = -1, gt = P.length, jt = ae.length, tn = -1, Sn = G.length, Hr = Vc(gt - jt, 0), qr = tr(Sn + Hr), ca = !Me; ++tn < Sn; )
                qr[tn] = G[tn];
              for (; ++Ue < jt; )
                (ca || Ue < gt) && (qr[ae[Ue]] = P[Ue]);
              for (; Hr--; )
                qr[tn++] = P[Ue++];
              return qr;
            }
            function fa(P, G, ae, Me) {
              for (var Ue = -1, gt = P.length, jt = -1, tn = ae.length, Sn = -1, Hr = G.length, qr = Vc(gt - tn, 0), ca = tr(qr + Hr), Aa = !Me; ++Ue < qr; )
                ca[Ue] = P[Ue];
              for (var fi = Ue; ++Sn < Hr; )
                ca[fi + Sn] = G[Sn];
              for (; ++jt < tn; )
                (Aa || Ue < gt) && (ca[fi + ae[jt]] = P[Ue++]);
              return ca;
            }
            function We(P, G) {
              var ae = -1, Me = P.length;
              for (G || (G = tr(Me)); ++ae < Me; )
                G[ae] = P[ae];
              return G;
            }
            function pn(P, G, ae, Me) {
              var Ue = !ae;
              ae || (ae = {});
              for (var gt = -1, jt = G.length; ++gt < jt; ) {
                var tn = G[gt], Sn = Me ? Me(ae[tn], P[tn], tn, ae, P) : J;
                Sn === J && (Sn = P[tn]), Ue ? jv(ae, tn, Sn) : Wf(ae, tn, Sn);
              }
              return ae;
            }
            function zn(P, G) {
              return pn(P, ka(P), G);
            }
            function pr(P, G) {
              return pn(P, gi(P), G);
            }
            function fr(P, G) {
              return function(ae, Me) {
                var Ue = ea(ae) ? O6 : aP, gt = G ? G() : {};
                return Ue(ae, P, ki(Me, 2), gt);
              };
            }
            function Tn(P) {
              return Ge(function(G, ae) {
                var Me = -1, Ue = ae.length, gt = Ue > 1 ? ae[Ue - 1] : J, jt = Ue > 2 ? ae[2] : J;
                for (gt = P.length > 3 && typeof gt == "function" ? (Ue--, gt) : J, jt && ru(ae[0], ae[1], jt) && (gt = Ue < 3 ? J : gt, Ue = 1), G = Fl(G); ++Me < Ue; ) {
                  var tn = ae[Me];
                  tn && P(G, tn, Me, gt);
                }
                return G;
              });
            }
            function Gn(P, G) {
              return function(ae, Me) {
                if (ae == null)
                  return ae;
                if (!zo(ae))
                  return P(ae, Me);
                for (var Ue = ae.length, gt = G ? Ue : -1, jt = Fl(ae); (G ? gt-- : ++gt < Ue) && Me(jt[gt], gt, jt) !== false; )
                  ;
                return ae;
              };
            }
            function Tr(P) {
              return function(G, ae, Me) {
                for (var Ue = -1, gt = Fl(G), jt = Me(G), tn = jt.length; tn--; ) {
                  var Sn = jt[P ? tn : ++Ue];
                  if (ae(gt[Sn], Sn, gt) === false)
                    break;
                }
                return G;
              };
            }
            function ra(P, G, ae) {
              var Me = G & ln, Ue = Ya(P);
              function gt() {
                var jt = this && this !== dc && this instanceof gt ? Ue : P;
                return jt.apply(Me ? ae : this, arguments);
              }
              return gt;
            }
            function wn(P) {
              return function(G) {
                G = ql(G);
                var ae = af(G) ? hh(G) : J, Me = ae ? ae[0] : G.charAt(0), Ue = ae ? Be(ae, 1).join("") : G.slice(1);
                return Me[P]() + Ue;
              };
            }
            function Ka(P) {
              return function(G) {
                return zS(cG(rG(G).replace(_E, "")), P, "");
              };
            }
            function Ya(P) {
              return function() {
                var G = arguments;
                switch (G.length) {
                  case 0:
                    return new P();
                  case 1:
                    return new P(G[0]);
                  case 2:
                    return new P(G[0], G[1]);
                  case 3:
                    return new P(G[0], G[1], G[2]);
                  case 4:
                    return new P(G[0], G[1], G[2], G[3]);
                  case 5:
                    return new P(G[0], G[1], G[2], G[3], G[4]);
                  case 6:
                    return new P(G[0], G[1], G[2], G[3], G[4], G[5]);
                  case 7:
                    return new P(G[0], G[1], G[2], G[3], G[4], G[5], G[6]);
                }
                var ae = p_(P.prototype), Me = P.apply(ae, G);
                return $u(Me) ? Me : ae;
              };
            }
            function vr(P, G, ae) {
              var Me = Ya(P);
              function Ue() {
                for (var gt = arguments.length, jt = tr(gt), tn = gt, Sn = Tu(Ue); tn--; )
                  jt[tn] = arguments[tn];
                var Hr = gt < 3 && jt[0] !== Sn && jt[gt - 1] !== Sn ? [] : oy(jt, Sn);
                if (gt -= Hr.length, gt < ae)
                  return nu(P, G, Xn, Ue.placeholder, J, jt, Hr, J, J, ae - gt);
                var qr = this && this !== dc && this instanceof Ue ? Me : P;
                return dp(qr, this, jt);
              }
              return Ue;
            }
            function Pi(P) {
              return function(G, ae, Me) {
                var Ue = Fl(G);
                if (!zo(G)) {
                  var gt = ki(ae, 3);
                  G = $i(G), ae = function(tn) {
                    return gt(Ue[tn], tn, Ue);
                  };
                }
                var jt = P(G, ae, Me);
                return jt > -1 ? Ue[gt ? G[jt] : jt] : J;
              };
            }
            function xr(P) {
              return Hh(function(G) {
                var ae = G.length, Me = ae, Ue = pp.prototype.thru;
                for (P && G.reverse(); Me--; ) {
                  var gt = G[Me];
                  if (typeof gt != "function")
                    throw new Ed(Ie);
                  if (Ue && !jt && uf(gt) == "wrapper")
                    var jt = new pp([], true);
                }
                for (Me = jt ? Me : ae; ++Me < ae; ) {
                  gt = G[Me];
                  var tn = uf(gt), Sn = tn == "wrapper" ? Ec(gt) : J;
                  Sn && cf(Sn[0]) && Sn[1] == (dr | aa | Cn | ur) && !Sn[4].length && Sn[9] == 1 ? jt = jt[uf(Sn[0])].apply(jt, Sn[3]) : jt = gt.length == 1 && cf(gt) ? jt[tn]() : jt.thru(gt);
                }
                return function() {
                  var Hr = arguments, qr = Hr[0];
                  if (jt && Hr.length == 1 && ea(qr))
                    return jt.plant(qr).value();
                  for (var ca = 0, Aa = ae ? G[ca].apply(this, Hr) : qr; ++ca < ae; )
                    Aa = G[ca].call(this, Aa);
                  return Aa;
                };
              });
            }
            function Xn(P, G, ae, Me, Ue, gt, jt, tn, Sn, Hr) {
              var qr = G & dr, ca = G & ln, Aa = G & yr, fi = G & (aa | He), Ki = G & An, us = Aa ? J : Ya(P);
              function Ui() {
                for (var Rs = arguments.length, Js = tr(Rs), uv = Rs; uv--; )
                  Js[uv] = arguments[uv];
                if (fi)
                  var Xh = Tu(Ui), xp = T1(Js, Xh);
                if (Me && (Js = cr(Js, Me, Ue, fi)), gt && (Js = fa(Js, gt, jt, fi)), Rs -= xp, fi && Rs < Hr) {
                  var fu = oy(Js, Xh);
                  return nu(P, G, Xn, Ui.placeholder, ae, Js, fu, tn, Sn, Hr - Rs);
                }
                var H0 = ca ? ae : this, Od = Aa ? H0[P] : P;
                return Rs = Js.length, tn ? Js = uF(Js, tn) : Ki && Rs > 1 && Js.reverse(), qr && Sn < Rs && (Js.length = Sn), this && this !== dc && this instanceof Ui && (Od = us || Ya(Od)), Od.apply(H0, Js);
              }
              return Ui;
            }
            function Kn(P, G) {
              return function(ae, Me) {
                return iF(ae, P, G(Me), {});
              };
            }
            function ba(P, G) {
              return function(ae, Me) {
                var Ue;
                if (ae === J && Me === J)
                  return G;
                if (ae !== J && (Ue = ae), Me !== J) {
                  if (Ue === J)
                    return Me;
                  typeof ae == "string" || typeof Me == "string" ? (ae = Zi(ae), Me = Zi(Me)) : (ae = Hi(ae), Me = Hi(Me)), Ue = P(ae, Me);
                }
                return Ue;
              };
            }
            function la(P) {
              return Hh(function(G) {
                return G = ko(G, Gf(ki())), Ge(function(ae) {
                  var Me = this;
                  return P(G, function(Ue) {
                    return dp(Ue, Me, ae);
                  });
                });
              });
            }
            function Xi(P, G) {
              G = G === J ? " " : Zi(G);
              var ae = G.length;
              if (ae < 2)
                return ae ? Se(G, P) : G;
              var Me = Se(G, Ao(P / Qo(G)));
              return af(G) ? Be(hh(Me), 0, P).join("") : Me.slice(0, P);
            }
            function Ys(P, G, ae, Me) {
              var Ue = G & ln, gt = Ya(P);
              function jt() {
                for (var tn = -1, Sn = arguments.length, Hr = -1, qr = Me.length, ca = tr(qr + Sn), Aa = this && this !== dc && this instanceof jt ? gt : P; ++Hr < qr; )
                  ca[Hr] = Me[Hr];
                for (; Sn--; )
                  ca[Hr++] = arguments[++tn];
                return dp(Aa, Ue ? ae : this, ca);
              }
              return jt;
            }
            function Ss(P) {
              return function(G, ae, Me) {
                return Me && typeof Me != "number" && ru(G, ae, Me) && (ae = Me = J), G = py(G), ae === J ? (ae = G, G = 0) : ae = py(ae), Me = Me === J ? G < ae ? 1 : -1 : py(Me), oe(G, ae, Me, P);
              };
            }
            function Uo(P) {
              return function(G, ae) {
                return typeof G == "string" && typeof ae == "string" || (G = Ul(G), ae = Ul(ae)), P(G, ae);
              };
            }
            function nu(P, G, ae, Me, Ue, gt, jt, tn, Sn, Hr) {
              var qr = G & aa, ca = qr ? jt : J, Aa = qr ? J : jt, fi = qr ? gt : J, Ki = qr ? J : gt;
              G |= qr ? Cn : On, G &= ~(qr ? On : Cn), G & sr || (G &= ~(ln | yr));
              var us = [P, G, Ue, fi, ca, Ki, Aa, tn, Sn, Hr], Ui = ae.apply(J, us);
              return cf(P) && zw(Ui, us), Ui.placeholder = Me, ut(Ui, P, G);
            }
            function Cs(P) {
              var G = of[P];
              return function(ae, Me) {
                if (ae = Ul(ae), Me = Me == null ? 0 : lf(ls(Me), 292), Me && Yk(ae)) {
                  var Ue = (ql(ae) + "e").split("e"), gt = G(Ue[0] + "e" + (+Ue[1] + Me));
                  return Ue = (ql(gt) + "e").split("e"), +(Ue[0] + "e" + (+Ue[1] - Me));
                }
                return G(ae);
              };
            }
            var yl = k1 && 1 / HS(new k1([, -0]))[1] == Ai ? function(P) {
              return new k1(P);
            } : Xw;
            function vc(P) {
              return function(G) {
                var ae = Ri(G);
                return ae == cc ? kE(G) : ae == nc ? z6(G) : Cw(G, P(G));
              };
            }
            function Gc(P, G, ae, Me, Ue, gt, jt, tn) {
              var Sn = G & yr;
              if (!Sn && typeof P != "function")
                throw new Ed(Ie);
              var Hr = Me ? Me.length : 0;
              if (Hr || (G &= ~(Cn | On), Me = Ue = J), jt = jt === J ? jt : Vc(ls(jt), 0), tn = tn === J ? tn : ls(tn), Hr -= Ue ? Ue.length : 0, G & On) {
                var qr = Me, ca = Ue;
                Me = Ue = J;
              }
              var Aa = Sn ? J : Ec(P), fi = [P, G, ae, Me, Ue, qr, ca, gt, jt, tn];
              if (Aa && z1(fi, Aa), P = fi[0], G = fi[1], ae = fi[2], Me = fi[3], Ue = fi[4], tn = fi[9] = fi[9] === J ? Sn ? 0 : P.length : Vc(fi[9] - Hr, 0), !tn && G & (aa | He) && (G &= ~(aa | He)), !G || G == ln)
                var Ki = ra(P, G, ae);
              else
                G == aa || G == He ? Ki = vr(P, G, tn) : (G == Cn || G == (ln | Cn)) && !Ue.length ? Ki = Ys(P, G, ae, Me) : Ki = Xn.apply(J, fi);
              var us = Aa ? xn : zw;
              return ut(us(Ki, fi), P, G);
            }
            function av(P, G, ae, Me) {
              return P === J || Pd(P, tu[ae]) && !Al.call(Me, ae) ? G : P;
            }
            function Cg(P, G, ae, Me, Ue, gt) {
              return $u(P) && $u(G) && (gt.set(G, P), rC(P, G, J, Cg, gt), gt.delete(G)), P;
            }
            function Sf(P) {
              return hC(P) ? J : P;
            }
            function gp(P, G, ae, Me, Ue, gt) {
              var jt = ae & Yt, tn = P.length, Sn = G.length;
              if (tn != Sn && !(jt && Sn > tn))
                return false;
              var Hr = gt.get(P), qr = gt.get(G);
              if (Hr && qr)
                return Hr == G && qr == P;
              var ca = -1, Aa = true, fi = ae & nn ? new cy() : J;
              for (gt.set(P, G), gt.set(G, P); ++ca < tn; ) {
                var Ki = P[ca], us = G[ca];
                if (Me)
                  var Ui = jt ? Me(us, Ki, ca, G, P, gt) : Me(Ki, us, ca, P, G, gt);
                if (Ui !== J) {
                  if (Ui)
                    continue;
                  Aa = false;
                  break;
                }
                if (fi) {
                  if (!_w(G, function(Rs, Js) {
                    if (!iy(fi, Js) && (Ki === Rs || Ue(Ki, Rs, ae, Me, gt)))
                      return fi.push(Js);
                  })) {
                    Aa = false;
                    break;
                  }
                } else if (!(Ki === us || Ue(Ki, us, ae, Me, gt))) {
                  Aa = false;
                  break;
                }
              }
              return gt.delete(P), gt.delete(G), Aa;
            }
            function j0(P, G, ae, Me, Ue, gt, jt) {
              switch (ae) {
                case Or:
                  if (P.byteLength != G.byteLength || P.byteOffset != G.byteOffset)
                    return false;
                  P = P.buffer, G = G.buffer;
                case jn:
                  return !(P.byteLength != G.byteLength || !gt(new sy(P), new sy(G)));
                case os:
                case rl:
                case uh:
                  return Pd(+P, +G);
                case wd:
                  return P.name == G.name && P.message == G.message;
                case ch:
                case ju:
                  return P == G + "";
                case cc:
                  var tn = kE;
                case nc:
                  var Sn = Me & Yt;
                  if (tn || (tn = HS), P.size != G.size && !Sn)
                    return false;
                  var Hr = jt.get(P);
                  if (Hr)
                    return Hr == G;
                  Me |= nn, jt.set(P, G);
                  var qr = gp(tn(P), tn(G), Me, Ue, gt, jt);
                  return jt.delete(P), qr;
                case fc:
                  if (d_)
                    return d_.call(P) == d_.call(G);
              }
              return false;
            }
            function Td(P, G, ae, Me, Ue, gt) {
              var jt = ae & Yt, tn = Mg(P), Sn = tn.length, Hr = Mg(G), qr = Hr.length;
              if (Sn != qr && !jt)
                return false;
              for (var ca = Sn; ca--; ) {
                var Aa = tn[ca];
                if (!(jt ? Aa in G : Al.call(G, Aa)))
                  return false;
              }
              var fi = gt.get(P), Ki = gt.get(G);
              if (fi && Ki)
                return fi == G && Ki == P;
              var us = true;
              gt.set(P, G), gt.set(G, P);
              for (var Ui = jt; ++ca < Sn; ) {
                Aa = tn[ca];
                var Rs = P[Aa], Js = G[Aa];
                if (Me)
                  var uv = jt ? Me(Js, Rs, Aa, G, P, gt) : Me(Rs, Js, Aa, P, G, gt);
                if (!(uv === J ? Rs === Js || Ue(Rs, Js, ae, Me, gt) : uv)) {
                  us = false;
                  break;
                }
                Ui || (Ui = Aa == "constructor");
              }
              if (us && !Ui) {
                var Xh = P.constructor, xp = G.constructor;
                Xh != xp && "constructor" in P && "constructor" in G && !(typeof Xh == "function" && Xh instanceof Xh && typeof xp == "function" && xp instanceof xp) && (us = false);
              }
              return gt.delete(P), gt.delete(G), us;
            }
            function Hh(P) {
              return Vt(pP(P, J, __), P + "");
            }
            function Mg(P) {
              return UE(P, $i, ka);
            }
            function iv(P) {
              return UE(P, lv, gi);
            }
            var Ec = Pw ? function(P) {
              return Pw.get(P);
            } : Xw;
            function uf(P) {
              for (var G = P.name + "", ae = h_[G], Me = Al.call(h_, G) ? ae.length : 0; Me--; ) {
                var Ue = ae[Me], gt = Ue.func;
                if (gt == null || gt == P)
                  return Ue.name;
              }
              return G;
            }
            function Tu(P) {
              var G = Al.call(nt, "placeholder") ? nt : P;
              return G.placeholder;
            }
            function ki() {
              var P = nt.iteratee || Zh;
              return P = P === Zh ? cP : P, arguments.length ? P(arguments[0], arguments[1]) : P;
            }
            function Pr(P, G) {
              var ae = P.__data__;
              return Zs(G) ? ae[typeof G == "string" ? "string" : "hash"] : ae.map;
            }
            function Hn(P) {
              for (var G = $i(P), ae = G.length; ae--; ) {
                var Me = G[ae], Ue = P[Me];
                G[ae] = [Me, Ue, kd(Ue)];
              }
              return G;
            }
            function Vn(P, G) {
              var ae = TE(P, G);
              return N1(ae) ? ae : J;
            }
            function Br(P) {
              var G = Al.call(P, D1), ae = P[D1];
              try {
                P[D1] = J;
                var Me = true;
              } catch {
              }
              var Ue = $S.call(P);
              return Me && (G ? P[D1] = ae : delete P[D1]), Ue;
            }
            var ka = Id ? function(P) {
              return P == null ? [] : (P = Fl(P), L0(Id(P), function(G) {
                return sf.call(P, G);
              }));
            } : RF, gi = Id ? function(P) {
              for (var G = []; P; )
                tv(G, ka(P)), P = Ew(P);
              return G;
            } : RF, Ri = jc;
            (Dw && Ri(new Dw(new ArrayBuffer(1))) != Or || N0 && Ri(new N0()) != cc || jh && Ri(jh.resolve()) != Sd || k1 && Ri(new k1()) != nc || f_ && Ri(new f_()) != kr) && (Ri = function(P) {
              var G = jc(P), ae = G == ef ? P.constructor : J, Me = ae ? nr(ae) : "";
              if (Me)
                switch (Me) {
                  case zc:
                    return Or;
                  case ly:
                    return cc;
                  case P1:
                    return Sd;
                  case qS:
                    return nc;
                  case Lw:
                    return kr;
                }
              return G;
            });
            function qo(P, G, ae) {
              for (var Me = -1, Ue = ae.length; ++Me < Ue; ) {
                var gt = ae[Me], jt = gt.size;
                switch (gt.type) {
                  case "drop":
                    P += jt;
                    break;
                  case "dropRight":
                    G -= jt;
                    break;
                  case "take":
                    G = lf(G, P + jt);
                    break;
                  case "takeRight":
                    P = Vc(P, G - jt);
                    break;
                }
              }
              return { start: P, end: G };
            }
            function Il(P) {
              var G = P.match(i_);
              return G ? G[1].split(OS) : [];
            }
            function Wu(P, G, ae) {
              G = Ee(G, P);
              for (var Me = -1, Ue = G.length, gt = false; ++Me < Ue; ) {
                var jt = mr(G[Me]);
                if (!(gt = P != null && ae(P, jt)))
                  break;
                P = P[jt];
              }
              return gt || ++Me != Ue ? gt : (Ue = P == null ? 0 : P.length, !!Ue && sI(Ue) && Cf(jt, Ue) && (ea(P) || Zn(P)));
            }
            function Du(P) {
              var G = P.length, ae = new P.constructor(G);
              return G && typeof P[0] == "string" && Al.call(P, "index") && (ae.index = P.index, ae.input = P.input), ae;
            }
            function Wc(P) {
              return typeof P.constructor == "function" && !ph(P) ? p_(Ew(P)) : {};
            }
            function ku(P, G, ae) {
              var Me = P.constructor;
              switch (G) {
                case jn:
                  return yt(P);
                case os:
                case rl:
                  return new Me(+P);
                case Or:
                  return Gt(P, ae);
                case Ea:
                case pi:
                case To:
                case Do:
                case hl:
                case Mu:
                case qs:
                case Os:
                case Rl:
                  return un(P, ae);
                case cc:
                  return new Me();
                case uh:
                case ju:
                  return new Me(P);
                case ch:
                  return Xt(P);
                case nc:
                  return new Me();
                case fc:
                  return Zt(P);
              }
            }
            function Dd(P, G) {
              var ae = G.length;
              if (!ae)
                return P;
              var Me = ae - 1;
              return G[Me] = (ae > 1 ? "& " : "") + G[Me], G = G.join(ae > 2 ? ", " : " "), P.replace(vw, `{
/* [wrapped with ` + G + `] */
`);
            }
            function mp(P) {
              return ea(P) || Zn(P) || !!($k && P && P[$k]);
            }
            function Cf(P, G) {
              var ae = typeof P;
              return G = G == null ? gr : G, !!G && (ae == "number" || ae != "symbol" && cn.test(P)) && P > -1 && P % 1 == 0 && P < G;
            }
            function ru(P, G, ae) {
              if (!$u(ae))
                return false;
              var Me = typeof G;
              return (Me == "number" ? zo(ae) && Cf(G, ae.length) : Me == "string" && G in ae) ? Pd(ae[G], P) : false;
            }
            function gc(P, G) {
              if (ea(P))
                return false;
              var ae = typeof P;
              return ae == "number" || ae == "symbol" || ae == "boolean" || P == null || Ld(P) ? true : Md.test(P) || !Vh.test(P) || G != null && P in Fl(G);
            }
            function Zs(P) {
              var G = typeof P;
              return G == "string" || G == "number" || G == "symbol" || G == "boolean" ? P !== "__proto__" : P === null;
            }
            function cf(P) {
              var G = uf(P), ae = nt[G];
              if (typeof ae != "function" || !(G in ws.prototype))
                return false;
              if (P === ae)
                return true;
              var Me = Ec(ae);
              return !!Me && P === Me[0];
            }
            function $h(P) {
              return !!Gk && Gk in P;
            }
            var Ag = uu ? Ks : FF;
            function ph(P) {
              var G = P && P.constructor, ae = typeof G == "function" && G.prototype || tu;
              return P === ae;
            }
            function kd(P) {
              return P === P && !$u(P);
            }
            function ov(P, G) {
              return function(ae) {
                return ae == null ? false : ae[P] === G && (G !== J || P in Fl(ae));
              };
            }
            function y_(P) {
              var G = G1(P, function(Me) {
                return ae.size === Ye && ae.clear(), Me;
              }), ae = G.cache;
              return G;
            }
            function z1(P, G) {
              var ae = P[1], Me = G[1], Ue = ae | Me, gt = Ue < (ln | yr | dr), jt = Me == dr && ae == aa || Me == dr && ae == ur && P[7].length <= G[8] || Me == (dr | ur) && G[7].length <= G[8] && ae == aa;
              if (!(gt || jt))
                return P;
              Me & ln && (P[2] = G[2], Ue |= ae & ln ? 0 : sr);
              var tn = G[3];
              if (tn) {
                var Sn = P[3];
                P[3] = Sn ? cr(Sn, tn, G[4]) : tn, P[4] = Sn ? oy(P[3], Ke) : G[4];
              }
              return tn = G[5], tn && (Sn = P[5], P[5] = Sn ? fa(Sn, tn, G[6]) : tn, P[6] = Sn ? oy(P[5], Ke) : G[6]), tn = G[7], tn && (P[7] = tn), Me & dr && (P[8] = P[8] == null ? G[8] : lf(P[8], G[8])), P[9] == null && (P[9] = G[9]), P[0] = G[0], P[1] = Ue, P;
            }
            function lF(P) {
              var G = [];
              if (P != null)
                for (var ae in Fl(P))
                  G.push(ae);
              return G;
            }
            function b_(P) {
              return $S.call(P);
            }
            function pP(P, G, ae) {
              return G = Vc(G === J ? P.length - 1 : G, 0), function() {
                for (var Me = arguments, Ue = -1, gt = Vc(Me.length - G, 0), jt = tr(gt); ++Ue < gt; )
                  jt[Ue] = Me[G + Ue];
                Ue = -1;
                for (var tn = tr(G + 1); ++Ue < G; )
                  tn[Ue] = Me[Ue];
                return tn[G] = ae(jt), dp(P, this, tn);
              };
            }
            function vP(P, G) {
              return G.length < 2 ? P : B0(P, Ur(G, 0, -1));
            }
            function uF(P, G) {
              for (var ae = P.length, Me = lf(G.length, ae), Ue = We(P); Me--; ) {
                var gt = G[Me];
                P[Me] = Cf(gt, ae) ? Ue[gt] : J;
              }
              return P;
            }
            function rI(P, G) {
              if (!(G === "constructor" && typeof P[G] == "function") && G != "__proto__")
                return P[G];
            }
            var zw = At(xn), Pt = F0 || function(P, G) {
              return dc.setTimeout(P, G);
            }, Vt = At(Gr);
            function ut(P, G, ae) {
              var Me = G + "";
              return Vt(P, Dd(Me, En(Il(Me), ae)));
            }
            function At(P) {
              var G = 0, ae = 0;
              return function() {
                var Me = RE(), Ue = bn - (Me - ae);
                if (ae = Me, Ue > 0) {
                  if (++G >= Jr)
                    return arguments[0];
                } else
                  G = 0;
                return P.apply(J, arguments);
              };
            }
            function Dt(P, G) {
              var ae = -1, Me = P.length, Ue = Me - 1;
              for (G = G === J ? Me : G; ++ae < G; ) {
                var gt = z10(ae, Ue), jt = P[gt];
                P[gt] = P[ae], P[ae] = jt;
              }
              return P.length = G, P;
            }
            var Fn = y_(function(P) {
              var G = [];
              return P.charCodeAt(0) === 46 && G.push(""), P.replace(E0, function(ae, Me, Ue, gt) {
                G.push(Ue ? gt.replace(Rt, "$1") : Me || ae);
              }), G;
            });
            function mr(P) {
              if (typeof P == "string" || Ld(P))
                return P;
              var G = P + "";
              return G == "0" && 1 / P == -Ai ? "-0" : G;
            }
            function nr(P) {
              if (P != null) {
                try {
                  return cu.call(P);
                } catch {
                }
                try {
                  return P + "";
                } catch {
                }
              }
              return "";
            }
            function En(P, G) {
              return zh(xs, function(ae) {
                var Me = "_." + ae[0];
                G & ae[1] && !s_(P, Me) && P.push(Me);
              }), P.sort();
            }
            function ia(P) {
              if (P instanceof ws)
                return P.clone();
              var G = new pp(P.__wrapped__, P.__chain__);
              return G.__actions__ = We(P.__actions__), G.__index__ = P.__index__, G.__values__ = P.__values__, G;
            }
            function xi(P, G, ae) {
              (ae ? ru(P, G, ae) : G === J) ? G = 1 : G = Vc(ls(G), 0);
              var Me = P == null ? 0 : P.length;
              if (!Me || G < 1)
                return [];
              for (var Ue = 0, gt = 0, jt = tr(Ao(Me / G)); Ue < Me; )
                jt[gt++] = Ur(P, Ue, Ue += G);
              return jt;
            }
            function ds(P) {
              for (var G = -1, ae = P == null ? 0 : P.length, Me = 0, Ue = []; ++G < ae; ) {
                var gt = P[G];
                gt && (Ue[Me++] = gt);
              }
              return Ue;
            }
            function Xs() {
              var P = arguments.length;
              if (!P)
                return [];
              for (var G = tr(P - 1), ae = arguments[0], Me = P; Me--; )
                G[Me - 1] = arguments[Me];
              return tv(ea(ae) ? We(ae) : [ae], wf(G, 1));
            }
            var Hl = Ge(function(P, G) {
              return Ms(P) ? O1(P, wf(G, 1, Ms, true)) : [];
            }), ss = Ge(function(P, G) {
              var ae = vh(G);
              return Ms(ae) && (ae = J), Ms(P) ? O1(P, wf(G, 1, Ms, true), ki(ae, 2)) : [];
            }), $l = Ge(function(P, G) {
              var ae = vh(G);
              return Ms(ae) && (ae = J), Ms(P) ? O1(P, wf(G, 1, Ms, true), J, ae) : [];
            });
            function mc(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              return Me ? (G = ae || G === J ? 1 : ls(G), Ur(P, G < 0 ? 0 : G, Me)) : [];
            }
            function xo(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              return Me ? (G = ae || G === J ? 1 : ls(G), G = Me - G, Ur(P, 0, G < 0 ? 0 : G)) : [];
            }
            function ff(P, G) {
              return P && P.length ? Y(P, ki(G, 3), true, true) : [];
            }
            function yp(P, G) {
              return P && P.length ? Y(P, ki(G, 3), true) : [];
            }
            function G0(P, G, ae, Me) {
              var Ue = P == null ? 0 : P.length;
              return Ue ? (ae && typeof ae != "number" && ru(P, G, ae) && (ae = 0, Me = Ue), HE(P, G, ae, Me)) : [];
            }
            function Bw(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              if (!Me)
                return -1;
              var Ue = ae == null ? 0 : ls(ae);
              return Ue < 0 && (Ue = Vc(Me + Ue, 0)), GS(P, ki(G, 3), Ue);
            }
            function Eg(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              if (!Me)
                return -1;
              var Ue = Me - 1;
              return ae !== J && (Ue = ls(ae), Ue = ae < 0 ? Vc(Me + Ue, 0) : lf(Ue, Me - 1)), GS(P, ki(G, 3), Ue, true);
            }
            function __(P) {
              var G = P == null ? 0 : P.length;
              return G ? wf(P, 1) : [];
            }
            function B1(P) {
              var G = P == null ? 0 : P.length;
              return G ? wf(P, Ai) : [];
            }
            function Hf(P, G) {
              var ae = P == null ? 0 : P.length;
              return ae ? (G = G === J ? 1 : ls(G), wf(P, G)) : [];
            }
            function fy(P) {
              for (var G = -1, ae = P == null ? 0 : P.length, Me = {}; ++G < ae; ) {
                var Ue = P[G];
                Me[Ue[0]] = Ue[1];
              }
              return Me;
            }
            function x_(P) {
              return P && P.length ? P[0] : J;
            }
            function j1(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              if (!Me)
                return -1;
              var Ue = ae == null ? 0 : ls(ae);
              return Ue < 0 && (Ue = Vc(Me + Ue, 0)), ny(P, G, Ue);
            }
            function jw(P) {
              var G = P == null ? 0 : P.length;
              return G ? Ur(P, 0, -1) : [];
            }
            var Gw = Ge(function(P) {
              var G = ko(P, re);
              return G.length && G[0] === P[0] ? YE(G) : [];
            }), aI = Ge(function(P) {
              var G = vh(P), ae = ko(P, re);
              return G === vh(ae) ? G = J : ae.pop(), ae.length && ae[0] === P[0] ? YE(ae, ki(G, 2)) : [];
            }), iC = Ge(function(P) {
              var G = vh(P), ae = ko(P, re);
              return G = typeof G == "function" ? G : J, G && ae.pop(), ae.length && ae[0] === P[0] ? YE(ae, J, G) : [];
            });
            function oC(P, G) {
              return P == null ? "" : El.call(P, G);
            }
            function vh(P) {
              var G = P == null ? 0 : P.length;
              return G ? P[G - 1] : J;
            }
            function w_(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              if (!Me)
                return -1;
              var Ue = Me;
              return ae !== J && (Ue = ls(ae), Ue = Ue < 0 ? Vc(Me + Ue, 0) : lf(Ue, Me - 1)), G === G ? B6(P, G, Ue) : GS(P, Ml, Ue, true);
            }
            function iI(P, G) {
              return P && P.length ? hP(P, ls(G)) : J;
            }
            var cF = Ge(gP);
            function gP(P, G) {
              return P && P.length && G && G.length ? aC(P, G) : P;
            }
            function sC(P, G, ae) {
              return P && P.length && G && G.length ? aC(P, G, ki(ae, 2)) : P;
            }
            function xj(P, G, ae) {
              return P && P.length && G && G.length ? aC(P, G, J, ae) : P;
            }
            var wj = Hh(function(P, G) {
              var ae = P == null ? 0 : P.length, Me = WE(P, G);
              return k10(P, ko(G, function(Ue) {
                return Cf(Ue, ae) ? +Ue : Ue;
              }).sort(yn)), Me;
            });
            function Fee(P, G) {
              var ae = [];
              if (!(P && P.length))
                return ae;
              var Me = -1, Ue = [], gt = P.length;
              for (G = ki(G, 3); ++Me < gt; ) {
                var jt = P[Me];
                G(jt, Me, P) && (ae.push(jt), Ue.push(Me));
              }
              return k10(P, Ue), ae;
            }
            function mP(P) {
              return P == null ? P : FE.call(P);
            }
            function Sj(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              return Me ? (ae && typeof ae != "number" && ru(P, G, ae) ? (G = 0, ae = Me) : (G = G == null ? 0 : ls(G), ae = ae === J ? Me : ls(ae)), Ur(P, G, ae)) : [];
            }
            function Cj(P, G) {
              return vi(P, G);
            }
            function Mj(P, G, ae) {
              return Ni(P, G, ki(ae, 2));
            }
            function Nee(P, G) {
              var ae = P == null ? 0 : P.length;
              if (ae) {
                var Me = vi(P, G);
                if (Me < ae && Pd(P[Me], G))
                  return Me;
              }
              return -1;
            }
            function Vee(P, G) {
              return vi(P, G, true);
            }
            function zee(P, G, ae) {
              return Ni(P, G, ki(ae, 2), true);
            }
            function Aj(P, G) {
              var ae = P == null ? 0 : P.length;
              if (ae) {
                var Me = vi(P, G, true) - 1;
                if (Pd(P[Me], G))
                  return Me;
              }
              return -1;
            }
            function Bee(P) {
              return P && P.length ? $o(P) : [];
            }
            function jee(P, G) {
              return P && P.length ? $o(P, ki(G, 2)) : [];
            }
            function Gee(P) {
              var G = P == null ? 0 : P.length;
              return G ? Ur(P, 1, G) : [];
            }
            function Wee(P, G, ae) {
              return P && P.length ? (G = ae || G === J ? 1 : ls(G), Ur(P, 0, G < 0 ? 0 : G)) : [];
            }
            function fF(P, G, ae) {
              var Me = P == null ? 0 : P.length;
              return Me ? (G = ae || G === J ? 1 : ls(G), G = Me - G, Ur(P, G < 0 ? 0 : G, Me)) : [];
            }
            function Hee(P, G) {
              return P && P.length ? Y(P, ki(G, 3), false, true) : [];
            }
            function $ee(P, G) {
              return P && P.length ? Y(P, ki(G, 3)) : [];
            }
            var Uee = Ge(function(P) {
              return No(wf(P, 1, Ms, true));
            }), qee = Ge(function(P) {
              var G = vh(P);
              return Ms(G) && (G = J), No(wf(P, 1, Ms, true), ki(G, 2));
            }), Yee = Ge(function(P) {
              var G = vh(P);
              return G = typeof G == "function" ? G : J, No(wf(P, 1, Ms, true), J, G);
            });
            function rc(P) {
              return P && P.length ? No(P) : [];
            }
            function Hu(P, G) {
              return P && P.length ? No(P, ki(G, 2)) : [];
            }
            function Zee(P, G) {
              return G = typeof G == "function" ? G : J, P && P.length ? No(P, J, G) : [];
            }
            function hF(P) {
              if (!(P && P.length))
                return [];
              var G = 0;
              return P = L0(P, function(ae) {
                if (Ms(ae))
                  return G = Vc(ae.length, G), true;
              }), ay(G, function(ae) {
                return ko(P, xw(ae));
              });
            }
            function Ej(P, G) {
              if (!(P && P.length))
                return [];
              var ae = hF(P);
              return G == null ? ae : ko(ae, function(Me) {
                return dp(G, J, Me);
              });
            }
            var Xee = Ge(function(P, G) {
              return Ms(P) ? O1(P, G) : [];
            }), Kee = Ge(function(P) {
              return Q(L0(P, Ms));
            }), Jee = Ge(function(P) {
              var G = vh(P);
              return Ms(G) && (G = J), Q(L0(P, Ms), ki(G, 2));
            }), Ij = Ge(function(P) {
              var G = vh(P);
              return G = typeof G == "function" ? G : J, Q(L0(P, Ms), J, G);
            }), Qee = Ge(hF);
            function Uh(P, G) {
              return ne(P || [], G || [], Wf);
            }
            function dF(P, G) {
              return ne(P || [], G || [], Kt);
            }
            var Ww = Ge(function(P) {
              var G = P.length, ae = G > 1 ? P[G - 1] : J;
              return ae = typeof ae == "function" ? (P.pop(), ae) : J, Ej(P, ae);
            });
            function pF(P) {
              var G = nt(P);
              return G.__chain__ = true, G;
            }
            function vF(P, G) {
              return G(P), P;
            }
            function bp(P, G) {
              return G(P);
            }
            var Tj = Hh(function(P) {
              var G = P.length, ae = G ? P[0] : 0, Me = this.__wrapped__, Ue = function(gt) {
                return WE(gt, P);
              };
              return G > 1 || this.__actions__.length || !(Me instanceof ws) || !Cf(ae) ? this.thru(Ue) : (Me = Me.slice(ae, +ae + (G ? 1 : 0)), Me.__actions__.push({ func: bp, args: [Ue], thisArg: J }), new pp(Me, this.__chain__).thru(function(gt) {
                return G && !gt.length && gt.push(J), gt;
              }));
            });
            function Dj() {
              return pF(this);
            }
            function kj() {
              return new pp(this.value(), this.__chain__);
            }
            function Pj() {
              this.__values__ === J && (this.__values__ = Yj(this.value()));
              var P = this.__index__ >= this.__values__.length, G = P ? J : this.__values__[this.__index__++];
              return { done: P, value: G };
            }
            function Lj() {
              return this;
            }
            function Oj(P) {
              for (var G, ae = this; ae instanceof YS; ) {
                var Me = ia(ae);
                Me.__index__ = 0, Me.__values__ = J, G ? Ue.__wrapped__ = Me : G = Me;
                var Ue = Me;
                ae = ae.__wrapped__;
              }
              return Ue.__wrapped__ = P, G;
            }
            function Wv() {
              var P = this.__wrapped__;
              if (P instanceof ws) {
                var G = P;
                return this.__actions__.length && (G = new ws(this)), G = G.reverse(), G.__actions__.push({ func: bp, args: [mP], thisArg: J }), new pp(G, this.__chain__);
              }
              return this.thru(mP);
            }
            function ete() {
              return ge(this.__wrapped__, this.__actions__);
            }
            var Ig = fr(function(P, G, ae) {
              Al.call(P, ae) ? ++P[ae] : jv(P, ae, 1);
            });
            function tte(P, G, ae) {
              var Me = ea(P) ? Ok : rF;
              return ae && ru(P, G, ae) && (G = J), Me(P, ki(G, 3));
            }
            function Rj(P, G) {
              var ae = ea(P) ? L0 : z0;
              return ae(P, ki(G, 3));
            }
            var S_ = Pi(Bw), yP = Pi(Eg);
            function gF(P, G) {
              return wf(oI(P, G), 1);
            }
            function yc(P, G) {
              return wf(oI(P, G), Ai);
            }
            function C_(P, G, ae) {
              return ae = ae === J ? 1 : ls(ae), wf(oI(P, G), ae);
            }
            function bP(P, G) {
              var ae = ea(P) ? zh : Gv;
              return ae(P, ki(G, 3));
            }
            function Fj(P, G) {
              var ae = ea(P) ? R6 : g_;
              return ae(P, ki(G, 3));
            }
            var mF = fr(function(P, G, ae) {
              Al.call(P, ae) ? P[ae].push(G) : jv(P, ae, [G]);
            });
            function nte(P, G, ae, Me) {
              P = zo(P) ? P : _C(P), ae = ae && !Me ? ls(ae) : 0;
              var Ue = P.length;
              return ae < 0 && (ae = Vc(Ue + ae, 0)), dy(P) ? ae <= Ue && P.indexOf(G, ae) > -1 : !!Ue && ny(P, G, ae) > -1;
            }
            var rte = Ge(function(P, G, ae) {
              var Me = -1, Ue = typeof G == "function", gt = zo(P) ? tr(P.length) : [];
              return Gv(P, function(jt) {
                gt[++Me] = Ue ? dp(G, jt, ae) : R1(jt, G, ae);
              }), gt;
            }), ate = fr(function(P, G, ae) {
              jv(P, ae, G);
            });
            function oI(P, G) {
              var ae = ea(P) ? ko : fP;
              return ae(P, ki(G, 3));
            }
            function _P(P, G, ae, Me) {
              return P == null ? [] : (ea(G) || (G = G == null ? [] : [G]), ae = Me ? J : ae, ea(ae) || (ae = ae == null ? [] : [ae]), nI(P, G, ae));
            }
            var lC = fr(function(P, G, ae) {
              P[ae ? 0 : 1].push(G);
            }, function() {
              return [[], []];
            });
            function ite(P, G, ae) {
              var Me = ea(P) ? zS : ww, Ue = arguments.length < 3;
              return Me(P, ki(G, 4), ae, Ue, Gv);
            }
            function Nj(P, G, ae) {
              var Me = ea(P) ? ty : ww, Ue = arguments.length < 3;
              return Me(P, ki(G, 4), ae, Ue, g_);
            }
            function Vj(P, G) {
              var ae = ea(P) ? L0 : z0;
              return ae(P, SP(ki(G, 3)));
            }
            function yF(P) {
              var G = ea(P) ? nP : vt;
              return G(P);
            }
            function bF(P, G, ae) {
              (ae ? ru(P, G, ae) : G === J) ? G = 1 : G = ls(G);
              var Me = ea(P) ? rP : Ht;
              return Me(P, G);
            }
            function zj(P) {
              var G = ea(P) ? eF : Wr;
              return G(P);
            }
            function ote(P) {
              if (P == null)
                return 0;
              if (zo(P))
                return dy(P) ? Qo(P) : P.length;
              var G = Ri(P);
              return G == cc || G == nc ? P.size : nC(P).length;
            }
            function _F(P, G, ae) {
              var Me = ea(P) ? _w : Ba;
              return ae && ru(P, G, ae) && (G = J), Me(P, ki(G, 3));
            }
            var xF = Ge(function(P, G) {
              if (P == null)
                return [];
              var ae = G.length;
              return ae > 1 && ru(P, G[0], G[1]) ? G = [] : ae > 2 && ru(G[0], G[1], G[2]) && (G = [G[0]]), nI(P, wf(G, 1), []);
            }), xP = Uk || function() {
              return dc.Date.now();
            };
            function Bj(P, G) {
              if (typeof G != "function")
                throw new Ed(Ie);
              return P = ls(P), function() {
                if (--P < 1)
                  return G.apply(this, arguments);
              };
            }
            function sv(P, G, ae) {
              return G = ae ? J : G, G = P && G == null ? P.length : G, Gc(P, dr, J, J, J, J, G);
            }
            function wP(P, G) {
              var ae;
              if (typeof G != "function")
                throw new Ed(Ie);
              return P = ls(P), function() {
                return --P > 0 && (ae = G.apply(this, arguments)), P <= 1 && (G = J), ae;
              };
            }
            var Hw = Ge(function(P, G, ae) {
              var Me = ln;
              if (ae.length) {
                var Ue = oy(ae, Tu(Hw));
                Me |= Cn;
              }
              return Gc(P, Me, G, ae, Ue);
            }), wF = Ge(function(P, G, ae) {
              var Me = ln | yr;
              if (ae.length) {
                var Ue = oy(ae, Tu(wF));
                Me |= Cn;
              }
              return Gc(G, Me, P, ae, Ue);
            });
            function SF(P, G, ae) {
              G = ae ? J : G;
              var Me = Gc(P, aa, J, J, J, J, J, G);
              return Me.placeholder = SF.placeholder, Me;
            }
            function jj(P, G, ae) {
              G = ae ? J : G;
              var Me = Gc(P, He, J, J, J, J, J, G);
              return Me.placeholder = jj.placeholder, Me;
            }
            function Gj(P, G, ae) {
              var Me, Ue, gt, jt, tn, Sn, Hr = 0, qr = false, ca = false, Aa = true;
              if (typeof P != "function")
                throw new Ed(Ie);
              G = Ul(G) || 0, $u(ae) && (qr = !!ae.leading, ca = "maxWait" in ae, gt = ca ? Vc(Ul(ae.maxWait) || 0, G) : gt, Aa = "trailing" in ae ? !!ae.trailing : Aa);
              function fi(fu) {
                var H0 = Me, Od = Ue;
                return Me = Ue = J, Hr = fu, jt = P.apply(Od, H0), jt;
              }
              function Ki(fu) {
                return Hr = fu, tn = Pt(Rs, G), qr ? fi(fu) : jt;
              }
              function us(fu) {
                var H0 = fu - Sn, Od = fu - Hr, GF = G - H0;
                return ca ? lf(GF, gt - Od) : GF;
              }
              function Ui(fu) {
                var H0 = fu - Sn, Od = fu - Hr;
                return Sn === J || H0 >= G || H0 < 0 || ca && Od >= gt;
              }
              function Rs() {
                var fu = xP();
                if (Ui(fu))
                  return Js(fu);
                tn = Pt(Rs, us(fu));
              }
              function Js(fu) {
                return tn = J, Aa && Me ? fi(fu) : (Me = Ue = J, jt);
              }
              function uv() {
                tn !== J && Ze(tn), Hr = 0, Me = Sn = Ue = tn = J;
              }
              function Xh() {
                return tn === J ? jt : Js(xP());
              }
              function xp() {
                var fu = xP(), H0 = Ui(fu);
                if (Me = arguments, Ue = this, Sn = fu, H0) {
                  if (tn === J)
                    return Ki(Sn);
                  if (ca)
                    return Ze(tn), tn = Pt(Rs, G), fi(Sn);
                }
                return tn === J && (tn = Pt(Rs, G)), jt;
              }
              return xp.cancel = uv, xp.flush = Xh, xp;
            }
            var ste = Ge(function(P, G) {
              return Fw(P, 1, G);
            }), lte = Ge(function(P, G, ae) {
              return Fw(P, Ul(G) || 0, ae);
            });
            function ute(P) {
              return Gc(P, An);
            }
            function G1(P, G) {
              if (typeof P != "function" || G != null && typeof G != "function")
                throw new Ed(Ie);
              var ae = function() {
                var Me = arguments, Ue = G ? G.apply(this, Me) : Me[0], gt = ae.cache;
                if (gt.has(Ue))
                  return gt.get(Ue);
                var jt = P.apply(this, Me);
                return ae.cache = gt.set(Ue, jt) || gt, jt;
              };
              return ae.cache = new (G1.Cache || V0)(), ae;
            }
            G1.Cache = V0;
            function SP(P) {
              if (typeof P != "function")
                throw new Ed(Ie);
              return function() {
                var G = arguments;
                switch (G.length) {
                  case 0:
                    return !P.call(this);
                  case 1:
                    return !P.call(this, G[0]);
                  case 2:
                    return !P.call(this, G[0], G[1]);
                  case 3:
                    return !P.call(this, G[0], G[1], G[2]);
                }
                return !P.apply(this, G);
              };
            }
            function cte(P) {
              return wP(2, P);
            }
            var CF = Oe(function(P, G) {
              G = G.length == 1 && ea(G[0]) ? ko(G[0], Gf(ki())) : ko(wf(G, 1), Gf(ki()));
              var ae = G.length;
              return Ge(function(Me) {
                for (var Ue = -1, gt = lf(Me.length, ae); ++Ue < gt; )
                  Me[Ue] = G[Ue].call(this, Me[Ue]);
                return dp(P, this, Me);
              });
            }), CP = Ge(function(P, G) {
              var ae = oy(G, Tu(CP));
              return Gc(P, Cn, J, G, ae);
            }), W1 = Ge(function(P, G) {
              var ae = oy(G, Tu(W1));
              return Gc(P, On, J, G, ae);
            }), MP = Hh(function(P, G) {
              return Gc(P, ur, J, J, J, G);
            });
            function fte(P, G) {
              if (typeof P != "function")
                throw new Ed(Ie);
              return G = G === J ? G : ls(G), Ge(P, G);
            }
            function hte(P, G) {
              if (typeof P != "function")
                throw new Ed(Ie);
              return G = G == null ? 0 : Vc(ls(G), 0), Ge(function(ae) {
                var Me = ae[G], Ue = Be(ae, 0, G);
                return Me && tv(Ue, Me), dp(P, this, Ue);
              });
            }
            function dte(P, G, ae) {
              var Me = true, Ue = true;
              if (typeof P != "function")
                throw new Ed(Ie);
              return $u(ae) && (Me = "leading" in ae ? !!ae.leading : Me, Ue = "trailing" in ae ? !!ae.trailing : Ue), Gj(P, G, { leading: Me, maxWait: G, trailing: Ue });
            }
            function uC(P) {
              return sv(P, 1);
            }
            function W0(P, G) {
              return CP(fe(G), P);
            }
            function Wj() {
              if (!arguments.length)
                return [];
              var P = arguments[0];
              return ea(P) ? P : [P];
            }
            function pte(P) {
              return rv(P, qt);
            }
            function vte(P, G) {
              return G = typeof G == "function" ? G : J, rv(P, qt, G);
            }
            function gte(P) {
              return rv(P, pt | qt);
            }
            function mte(P, G) {
              return G = typeof G == "function" ? G : J, rv(P, pt | qt, G);
            }
            function yte(P, G) {
              return G == null || oP(P, G, $i(G));
            }
            function Pd(P, G) {
              return P === G || P !== P && G !== G;
            }
            var _n = Uo(qE), Lr = Uo(function(P, G) {
              return P >= G;
            }), Zn = Vw(function() {
              return arguments;
            }()) ? Vw : function(P) {
              return Hc(P) && Al.call(P, "callee") && !sf.call(P, "callee");
            }, ea = tr.isArray, Vo = o_ ? Gf(o_) : F1;
            function zo(P) {
              return P != null && sI(P.length) && !Ks(P);
            }
            function Ms(P) {
              return Hc(P) && zo(P);
            }
            function Pu(P) {
              return P === true || P === false || Hc(P) && jc(P) == os;
            }
            var hy = qk || FF, bte = Pk ? Gf(Pk) : ZE;
            function Tg(P) {
              return Hc(P) && P.nodeType === 1 && !hC(P);
            }
            function AP(P) {
              if (P == null)
                return true;
              if (zo(P) && (ea(P) || typeof P == "string" || typeof P.splice == "function" || hy(P) || vC(P) || Zn(P)))
                return !P.length;
              var G = Ri(P);
              if (G == cc || G == nc)
                return !P.size;
              if (ph(P))
                return !nC(P).length;
              for (var ae in P)
                if (Al.call(P, ae))
                  return false;
              return true;
            }
            function _te(P, G) {
              return Sg(P, G);
            }
            function cC(P, G, ae) {
              ae = typeof ae == "function" ? ae : J;
              var Me = ae ? ae(P, G) : J;
              return Me === J ? Sg(P, G, J, ae) : !!Me;
            }
            function fC(P) {
              if (!Hc(P))
                return false;
              var G = jc(P);
              return G == wd || G == Cu || typeof P.message == "string" && typeof P.name == "string" && !hC(P);
            }
            function EP(P) {
              return typeof P == "number" && Yk(P);
            }
            function Ks(P) {
              if (!$u(P))
                return false;
              var G = jc(P);
              return G == cp || G == tc || G == Ol || G == Ei;
            }
            function Hj(P) {
              return typeof P == "number" && P == ls(P);
            }
            function sI(P) {
              return typeof P == "number" && P > -1 && P % 1 == 0 && P <= gr;
            }
            function $u(P) {
              var G = typeof P;
              return P != null && (G == "object" || G == "function");
            }
            function Hc(P) {
              return P != null && typeof P == "object";
            }
            var $j = Lk ? Gf(Lk) : lP;
            function xte(P, G) {
              return P === G || KE(P, G, Hn(G));
            }
            function IP(P, G, ae) {
              return ae = typeof ae == "function" ? ae : J, KE(P, G, Hn(G), ae);
            }
            function M_(P) {
              return MF(P) && P != +P;
            }
            function TP(P) {
              if (Ag(P))
                throw new Mo(ce);
              return N1(P);
            }
            function Uj(P) {
              return P === null;
            }
            function DP(P) {
              return P == null;
            }
            function MF(P) {
              return typeof P == "number" || Hc(P) && jc(P) == uh;
            }
            function hC(P) {
              if (!Hc(P) || jc(P) != ef)
                return false;
              var G = Ew(P);
              if (G === null)
                return true;
              var ae = Al.call(G, "constructor") && G.constructor;
              return typeof ae == "function" && ae instanceof ae && cu.call(ae) == j6;
            }
            var dC = bw ? Gf(bw) : tC;
            function qj(P) {
              return Hj(P) && P >= -gr && P <= gr;
            }
            var pC = VS ? Gf(VS) : JE;
            function dy(P) {
              return typeof P == "string" || !ea(P) && Hc(P) && jc(P) == ju;
            }
            function Ld(P) {
              return typeof P == "symbol" || Hc(P) && jc(P) == fc;
            }
            var vC = ME ? Gf(ME) : uP;
            function wte(P) {
              return P === J;
            }
            function Ste(P) {
              return Hc(P) && Ri(P) == kr;
            }
            function kP(P) {
              return Hc(P) && jc(P) == kn;
            }
            var PP = Uo(V1), AF = Uo(function(P, G) {
              return P <= G;
            });
            function Yj(P) {
              if (!P)
                return [];
              if (zo(P))
                return dy(P) ? hh(P) : We(P);
              if (es && P[es])
                return DE(P[es]());
              var G = Ri(P), ae = G == cc ? kE : G == nc ? HS : _C;
              return ae(P);
            }
            function py(P) {
              if (!P)
                return P === 0 ? P : 0;
              if (P = Ul(P), P === Ai || P === -Ai) {
                var G = P < 0 ? -1 : 1;
                return G * Qn;
              }
              return P === P ? P : 0;
            }
            function ls(P) {
              var G = py(P), ae = G % 1;
              return G === G ? ae ? G - ae : G : 0;
            }
            function Zj(P) {
              return P ? L1(ls(P), 0, ya) : 0;
            }
            function Ul(P) {
              if (typeof P == "number")
                return P;
              if (Ld(P))
                return Yn;
              if ($u(P)) {
                var G = typeof P.valueOf == "function" ? P.valueOf() : P;
                P = $u(G) ? G + "" : G;
              }
              if (typeof P != "string")
                return P === 0 ? P : +P;
              P = Mw(P);
              var ae = Ln.test(P);
              return ae || or.test(P) ? L6(P.slice(2), ae ? 2 : 8) : Tt.test(P) ? Yn : +P;
            }
            function qh(P) {
              return pn(P, lv(P));
            }
            function Cte(P) {
              return P ? L1(ls(P), -gr, gr) : P === 0 ? P : 0;
            }
            function ql(P) {
              return P == null ? "" : Zi(P);
            }
            var Xj = Tn(function(P, G) {
              if (ph(G) || zo(G)) {
                pn(G, $i(G), P);
                return;
              }
              for (var ae in G)
                Al.call(G, ae) && Wf(P, ae, G[ae]);
            }), Kj = Tn(function(P, G) {
              pn(G, lv(G), P);
            }), gC = Tn(function(P, G, ae, Me) {
              pn(G, lv(G), P, Me);
            }), lI = Tn(function(P, G, ae, Me) {
              pn(G, $i(G), P, Me);
            }), EF = Hh(WE);
            function mC(P, G) {
              var ae = p_(P);
              return G == null ? ae : iP(ae, G);
            }
            var uI = Ge(function(P, G) {
              P = Fl(P);
              var ae = -1, Me = G.length, Ue = Me > 2 ? G[2] : J;
              for (Ue && ru(G[0], G[1], Ue) && (Me = 1); ++ae < Me; )
                for (var gt = G[ae], jt = lv(gt), tn = -1, Sn = jt.length; ++tn < Sn; ) {
                  var Hr = jt[tn], qr = P[Hr];
                  (qr === J || Pd(qr, tu[Hr]) && !Al.call(P, Hr)) && (P[Hr] = gt[Hr]);
                }
              return P;
            }), cI = Ge(function(P) {
              return P.push(J, Cg), dp(Qj, J, P);
            });
            function LP(P, G) {
              return jS(P, ki(G, 3), vp);
            }
            function yC(P, G) {
              return jS(P, ki(G, 3), eC);
            }
            function Mte(P, G) {
              return P == null ? P : $E(P, ki(G, 3), lv);
            }
            function Ate(P, G) {
              return P == null ? P : Gh(P, ki(G, 3), lv);
            }
            function Ete(P, G) {
              return P && vp(P, ki(G, 3));
            }
            function Ite(P, G) {
              return P && eC(P, ki(G, 3));
            }
            function Tte(P) {
              return P == null ? [] : Nw(P, $i(P));
            }
            function OP(P) {
              return P == null ? [] : Nw(P, lv(P));
            }
            function $w(P, G, ae) {
              var Me = P == null ? J : B0(P, G);
              return Me === J ? ae : Me;
            }
            function Jj(P, G) {
              return P != null && Wu(P, G, Gi);
            }
            function st(P, G) {
              return P != null && Wu(P, G, sP);
            }
            var bC = Kn(function(P, G, ae) {
              G != null && typeof G.toString != "function" && (G = $S.call(G)), P[G] = ae;
            }, Lg(_p)), RP = Kn(function(P, G, ae) {
              G != null && typeof G.toString != "function" && (G = $S.call(G)), Al.call(P, G) ? P[G].push(ae) : P[G] = [ae];
            }, ki), Dg = Ge(R1);
            function $i(P) {
              return zo(P) ? tP(P) : nC(P);
            }
            function lv(P) {
              return zo(P) ? tP(P, true) : QE(P);
            }
            function Dte(P, G) {
              var ae = {};
              return G = ki(G, 3), vp(P, function(Me, Ue, gt) {
                jv(ae, G(Me, Ue, gt), Me);
              }), ae;
            }
            function kte(P, G) {
              var ae = {};
              return G = ki(G, 3), vp(P, function(Me, Ue, gt) {
                jv(ae, Ue, G(Me, Ue, gt));
              }), ae;
            }
            var Uw = Tn(function(P, G, ae) {
              rC(P, G, ae);
            }), Qj = Tn(function(P, G, ae, Me) {
              rC(P, G, ae, Me);
            }), Pte = Hh(function(P, G) {
              var ae = {};
              if (P == null)
                return ae;
              var Me = false;
              G = ko(G, function(gt) {
                return gt = Ee(gt, P), Me || (Me = gt.length > 1), gt;
              }), pn(P, iv(P), ae), Me && (ae = rv(ae, pt | Bt | qt, Sf));
              for (var Ue = G.length; Ue--; )
                Wh(ae, G[Ue]);
              return ae;
            });
            function Lte(P, G) {
              return eG(P, SP(ki(G)));
            }
            var Ote = Hh(function(P, G) {
              return P == null ? {} : m_(P, G);
            });
            function eG(P, G) {
              if (P == null)
                return {};
              var ae = ko(iv(P), function(Me) {
                return [Me];
              });
              return G = ki(G), dP(P, ae, function(Me, Ue) {
                return G(Me, Ue[0]);
              });
            }
            function H1(P, G, ae) {
              G = Ee(G, P);
              var Me = -1, Ue = G.length;
              for (Ue || (Ue = 1, P = J); ++Me < Ue; ) {
                var gt = P == null ? J : P[mr(G[Me])];
                gt === J && (Me = Ue, gt = ae), P = Ks(gt) ? gt.call(P) : gt;
              }
              return P;
            }
            function Rte(P, G, ae) {
              return P == null ? P : Kt(P, G, ae);
            }
            function Fte(P, G, ae, Me) {
              return Me = typeof Me == "function" ? Me : J, P == null ? P : Kt(P, G, ae, Me);
            }
            var tG = vc($i), nG = vc(lv);
            function Nte(P, G, ae) {
              var Me = ea(P), Ue = Me || hy(P) || vC(P);
              if (G = ki(G, 4), ae == null) {
                var gt = P && P.constructor;
                Ue ? ae = Me ? new gt() : [] : $u(P) ? ae = Ks(gt) ? p_(Ew(P)) : {} : ae = {};
              }
              return (Ue ? zh : vp)(P, function(jt, tn, Sn) {
                return G(ae, jt, tn, Sn);
              }), ae;
            }
            function $1(P, G) {
              return P == null ? true : Wh(P, G);
            }
            function Vte(P, G, ae) {
              return P == null ? P : dh(P, G, fe(ae));
            }
            function zte(P, G, ae, Me) {
              return Me = typeof Me == "function" ? Me : J, P == null ? P : dh(P, G, fe(ae), Me);
            }
            function _C(P) {
              return P == null ? [] : I1(P, $i(P));
            }
            function Bte(P) {
              return P == null ? [] : I1(P, lv(P));
            }
            function jte(P, G, ae) {
              return ae === J && (ae = G, G = J), ae !== J && (ae = Ul(ae), ae = ae === ae ? ae : 0), G !== J && (G = Ul(G), G = G === G ? G : 0), L1(Ul(P), G, ae);
            }
            function qw(P, G, ae) {
              return G = py(G), ae === J ? (ae = G, G = 0) : ae = py(ae), P = Ul(P), aF(P, G, ae);
            }
            function Gte(P, G, ae) {
              if (ae && typeof ae != "boolean" && ru(P, G, ae) && (G = ae = J), ae === J && (typeof G == "boolean" ? (ae = G, G = J) : typeof P == "boolean" && (ae = P, P = J)), P === J && G === J ? (P = 0, G = 1) : (P = py(P), G === J ? (G = P, P = 0) : G = py(G)), P > G) {
                var Me = P;
                P = G, G = Me;
              }
              if (ae || P % 1 || G % 1) {
                var Ue = c_();
                return lf(P + Ue * (G - P + Tk("1e-" + ((Ue + "").length - 1))), G);
              }
              return z10(P, G);
            }
            var Wte = Ka(function(P, G, ae) {
              return G = G.toLowerCase(), P + (ae ? kg(G) : G);
            });
            function kg(P) {
              return xC(ql(P).toLowerCase());
            }
            function rG(P) {
              return P = ql(P), P && P.replace(na, WS).replace(fh, "");
            }
            function Hte(P, G, ae) {
              P = ql(P), G = Zi(G);
              var Me = P.length;
              ae = ae === J ? Me : L1(ls(ae), 0, Me);
              var Ue = ae;
              return ae -= G.length, ae >= 0 && P.slice(ae, Ue) == G;
            }
            function $te(P) {
              return P = ql(P), P && Nc.test(P) ? P.replace(su, N6) : P;
            }
            function Ute(P) {
              return P = ql(P), P && pw.test(P) ? P.replace(I0, "\\$&") : P;
            }
            var qte = Ka(function(P, G, ae) {
              return P + (ae ? "-" : "") + G.toLowerCase();
            }), aG = Ka(function(P, G, ae) {
              return P + (ae ? " " : "") + G.toLowerCase();
            }), iG = wn("toLowerCase");
            function Yte(P, G, ae) {
              P = ql(P), G = ls(G);
              var Me = G ? Qo(P) : 0;
              if (!G || Me >= G)
                return P;
              var Ue = (G - Me) / 2;
              return Xi(Tw(Ue), ae) + P + Xi(Ao(Ue), ae);
            }
            function Zte(P, G, ae) {
              P = ql(P), G = ls(G);
              var Me = G ? Qo(P) : 0;
              return G && Me < G ? P + Xi(G - Me, ae) : P;
            }
            function IF(P, G, ae) {
              P = ql(P), G = ls(G);
              var Me = G ? Qo(P) : 0;
              return G && Me < G ? Xi(G - Me, ae) + P : P;
            }
            function fI(P, G, ae) {
              return ae || G == null ? G = 0 : G && (G = +G), H6(ql(P).replace(T0, ""), G || 0);
            }
            function FP(P, G, ae) {
              return (ae ? ru(P, G, ae) : G === J) ? G = 1 : G = ls(G), Se(ql(P), G);
            }
            function Xte() {
              var P = arguments, G = ql(P[0]);
              return P.length < 3 ? G : G.replace(P[1], P[2]);
            }
            var oG = Ka(function(P, G, ae) {
              return P + (ae ? "_" : "") + G.toLowerCase();
            });
            function Kte(P, G, ae) {
              return ae && typeof ae != "number" && ru(P, G, ae) && (G = ae = J), ae = ae === J ? ya : ae >>> 0, ae ? (P = ql(P), P && (typeof G == "string" || G != null && !dC(G)) && (G = Zi(G), !G && af(P)) ? Be(hh(P), 0, ae) : P.split(G, ae)) : [];
            }
            var U1 = Ka(function(P, G, ae) {
              return P + (ae ? " " : "") + xC(G);
            });
            function TF(P, G, ae) {
              return P = ql(P), ae = ae == null ? 0 : L1(ls(ae), 0, P.length), G = Zi(G), P.slice(ae, ae + G.length) == G;
            }
            function Yw(P, G, ae) {
              var Me = nt.templateSettings;
              ae && ru(P, G, ae) && (G = J), P = ql(P), G = gC({}, G, Me, av);
              var Ue = gC({}, G.imports, Me.imports, av), gt = $i(Ue), jt = I1(Ue, gt), tn, Sn, Hr = 0, qr = G.interpolate || ni, ca = "__p += '", Aa = LE((G.escape || ni).source + "|" + qr.source + "|" + (qr === Nh ? Xe : ni).source + "|" + (G.evaluate || ni).source + "|$", "g"), fi = "//# sourceURL=" + (Al.call(G, "sourceURL") ? (G.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++xE + "]") + `
`;
              P.replace(Aa, function(Ui, Rs, Js, uv, Xh, xp) {
                return Js || (Js = uv), ca += P.slice(Hr, xp).replace(Ho, V6), Rs && (tn = true, ca += `' +
__e(` + Rs + `) +
'`), Xh && (Sn = true, ca += `';
` + Xh + `;
__p += '`), Js && (ca += `' +
((__t = (` + Js + `)) == null ? '' : __t) +
'`), Hr = xp + Ui.length, Ui;
              }), ca += `';
`;
              var Ki = Al.call(G, "variable") && G.variable;
              if (!Ki)
                ca = `with (obj) {
` + ca + `
}
`;
              else if (St.test(Ki))
                throw new Mo(Le);
              ca = (Sn ? ca.replace(Vf, "") : ca).replace(zf, "$1").replace(Kp, "$1;"), ca = "function(" + (Ki || "obj") + `) {
` + (Ki ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (tn ? ", __e = _.escape" : "") + (Sn ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + ca + `return __p
}`;
              var us = DF(function() {
                return al(gt, fi + "return " + ca).apply(J, jt);
              });
              if (us.source = ca, fC(us))
                throw us;
              return us;
            }
            function Pg(P) {
              return ql(P).toLowerCase();
            }
            function Jte(P) {
              return ql(P).toUpperCase();
            }
            function sG(P, G, ae) {
              if (P = ql(P), P && (ae || G === J))
                return Mw(P);
              if (!P || !(G = Zi(G)))
                return P;
              var Me = hh(P), Ue = hh(G), gt = Rk(Me, Ue), jt = Aw(Me, Ue) + 1;
              return Be(Me, gt, jt).join("");
            }
            function lG(P, G, ae) {
              if (P = ql(P), P && (ae || G === J))
                return P.slice(0, lu(P) + 1);
              if (!P || !(G = Zi(G)))
                return P;
              var Me = hh(P), Ue = Aw(Me, hh(G)) + 1;
              return Be(Me, 0, Ue).join("");
            }
            function hI(P, G, ae) {
              if (P = ql(P), P && (ae || G === J))
                return P.replace(T0, "");
              if (!P || !(G = Zi(G)))
                return P;
              var Me = hh(P), Ue = Rk(Me, hh(G));
              return Be(Me, Ue).join("");
            }
            function A_(P, G) {
              var ae = Nn, Me = Ar;
              if ($u(G)) {
                var Ue = "separator" in G ? G.separator : Ue;
                ae = "length" in G ? ls(G.length) : ae, Me = "omission" in G ? Zi(G.omission) : Me;
              }
              P = ql(P);
              var gt = P.length;
              if (af(P)) {
                var jt = hh(P);
                gt = jt.length;
              }
              if (ae >= gt)
                return P;
              var tn = ae - Qo(Me);
              if (tn < 1)
                return Me;
              var Sn = jt ? Be(jt, 0, tn).join("") : P.slice(0, tn);
              if (Ue === J)
                return Sn + Me;
              if (jt && (tn += Sn.length - tn), dC(Ue)) {
                if (P.slice(tn).search(Ue)) {
                  var Hr, qr = Sn;
                  for (Ue.global || (Ue = LE(Ue.source, ql(Ct.exec(Ue)) + "g")), Ue.lastIndex = 0; Hr = Ue.exec(qr); )
                    var ca = Hr.index;
                  Sn = Sn.slice(0, ca === J ? tn : ca);
                }
              } else if (P.indexOf(Zi(Ue), tn) != tn) {
                var Aa = Sn.lastIndexOf(Ue);
                Aa > -1 && (Sn = Sn.slice(0, Aa));
              }
              return Sn + Me;
            }
            function uG(P) {
              return P = ql(P), P && hs.test(P) ? P.replace(Fh, Bh) : P;
            }
            var Qte = Ka(function(P, G, ae) {
              return P + (ae ? " " : "") + G.toUpperCase();
            }), xC = wn("toUpperCase");
            function cG(P, G, ae) {
              return P = ql(P), G = ae ? J : G, G === J ? Fk(P) ? Ad(P) : F6(P) : P.match(G) || [];
            }
            var DF = Ge(function(P, G) {
              try {
                return dp(P, J, G);
              } catch (ae) {
                return fC(ae) ? ae : new Mo(ae);
              }
            }), Yh = Hh(function(P, G) {
              return zh(G, function(ae) {
                ae = mr(ae), jv(P, ae, Hw(P[ae], P));
              }), P;
            });
            function kF(P) {
              var G = P == null ? 0 : P.length, ae = ki();
              return P = G ? ko(P, function(Me) {
                if (typeof Me[1] != "function")
                  throw new Ed(Ie);
                return [ae(Me[0]), Me[1]];
              }) : [], Ge(function(Me) {
                for (var Ue = -1; ++Ue < G; ) {
                  var gt = P[Ue];
                  if (dp(gt[0], this, Me))
                    return dp(gt[1], this, Me);
                }
              });
            }
            function fG(P) {
              return nF(rv(P, pt));
            }
            function Lg(P) {
              return function() {
                return P;
              };
            }
            function PF(P, G) {
              return P == null || P !== P ? G : P;
            }
            var NP = xr(), Zw = xr(true);
            function _p(P) {
              return P;
            }
            function Zh(P) {
              return cP(typeof P == "function" ? P : rv(P, pt));
            }
            function LF(P) {
              return eI(rv(P, pt));
            }
            function ene(P, G) {
              return tI(P, rv(G, pt));
            }
            var tne = Ge(function(P, G) {
              return function(ae) {
                return R1(ae, P, G);
              };
            }), nne = Ge(function(P, G) {
              return function(ae) {
                return R1(P, ae, G);
              };
            });
            function dI(P, G, ae) {
              var Me = $i(G), Ue = Nw(G, Me);
              ae == null && !($u(G) && (Ue.length || !Me.length)) && (ae = G, G = P, P = this, Ue = Nw(G, $i(G)));
              var gt = !($u(ae) && "chain" in ae) || !!ae.chain, jt = Ks(P);
              return zh(Ue, function(tn) {
                var Sn = G[tn];
                P[tn] = Sn, jt && (P.prototype[tn] = function() {
                  var Hr = this.__chain__;
                  if (gt || Hr) {
                    var qr = P(this.__wrapped__), ca = qr.__actions__ = We(this.__actions__);
                    return ca.push({ func: Sn, args: arguments, thisArg: P }), qr.__chain__ = Hr, qr;
                  }
                  return Sn.apply(P, tv([this.value()], arguments));
                });
              }), P;
            }
            function rne() {
              return dc._ === this && (dc._ = Wk), this;
            }
            function Xw() {
            }
            function hG(P) {
              return P = ls(P), Ge(function(G) {
                return hP(G, P);
              });
            }
            var ane = la(ko), ine = la(Ok), pI = la(_w);
            function dG(P) {
              return gc(P) ? xw(mr(P)) : sF(P);
            }
            function one(P) {
              return function(G) {
                return P == null ? J : B0(P, G);
              };
            }
            var OF = Ss(), pG = Ss(true);
            function RF() {
              return [];
            }
            function FF() {
              return false;
            }
            function sne() {
              return {};
            }
            function vG() {
              return "";
            }
            function NF() {
              return true;
            }
            function lne(P, G) {
              if (P = ls(P), P < 1 || P > gr)
                return [];
              var ae = ya, Me = lf(P, ya);
              G = ki(G), P -= ya;
              for (var Ue = ay(Me, G); ++ae < P; )
                G(ae);
              return Ue;
            }
            function VF(P) {
              return ea(P) ? ko(P, mr) : Ld(P) ? [P] : We(Fn(ql(P)));
            }
            function gG(P) {
              var G = ++jk;
              return ql(P) + G;
            }
            var mG = ba(function(P, G) {
              return P + G;
            }, 0), yG = Cs("ceil"), VP = ba(function(P, G) {
              return P / G;
            }, 1), une = Cs("floor");
            function bG(P) {
              return P && P.length ? QS(P, _p, qE) : J;
            }
            function _G(P, G) {
              return P && P.length ? QS(P, ki(G, 2), qE) : J;
            }
            function cne(P) {
              return rf(P, _p);
            }
            function xG(P, G) {
              return rf(P, ki(G, 2));
            }
            function fne(P) {
              return P && P.length ? QS(P, _p, V1) : J;
            }
            function zF(P, G) {
              return P && P.length ? QS(P, ki(G, 2), V1) : J;
            }
            var wG = ba(function(P, G) {
              return P * G;
            }, 1), BF = Cs("round"), hne = ba(function(P, G) {
              return P - G;
            }, 0);
            function jF(P) {
              return P && P.length ? E1(P, _p) : 0;
            }
            function As(P, G) {
              return P && P.length ? E1(P, ki(G, 2)) : 0;
            }
            return nt.after = Bj, nt.ary = sv, nt.assign = Xj, nt.assignIn = Kj, nt.assignInWith = gC, nt.assignWith = lI, nt.at = EF, nt.before = wP, nt.bind = Hw, nt.bindAll = Yh, nt.bindKey = wF, nt.castArray = Wj, nt.chain = pF, nt.chunk = xi, nt.compact = ds, nt.concat = Xs, nt.cond = kF, nt.conforms = fG, nt.constant = Lg, nt.countBy = Ig, nt.create = mC, nt.curry = SF, nt.curryRight = jj, nt.debounce = Gj, nt.defaults = uI, nt.defaultsDeep = cI, nt.defer = ste, nt.delay = lte, nt.difference = Hl, nt.differenceBy = ss, nt.differenceWith = $l, nt.drop = mc, nt.dropRight = xo, nt.dropRightWhile = ff, nt.dropWhile = yp, nt.fill = G0, nt.filter = Rj, nt.flatMap = gF, nt.flatMapDeep = yc, nt.flatMapDepth = C_, nt.flatten = __, nt.flattenDeep = B1, nt.flattenDepth = Hf, nt.flip = ute, nt.flow = NP, nt.flowRight = Zw, nt.fromPairs = fy, nt.functions = Tte, nt.functionsIn = OP, nt.groupBy = mF, nt.initial = jw, nt.intersection = Gw, nt.intersectionBy = aI, nt.intersectionWith = iC, nt.invert = bC, nt.invertBy = RP, nt.invokeMap = rte, nt.iteratee = Zh, nt.keyBy = ate, nt.keys = $i, nt.keysIn = lv, nt.map = oI, nt.mapKeys = Dte, nt.mapValues = kte, nt.matches = LF, nt.matchesProperty = ene, nt.memoize = G1, nt.merge = Uw, nt.mergeWith = Qj, nt.method = tne, nt.methodOf = nne, nt.mixin = dI, nt.negate = SP, nt.nthArg = hG, nt.omit = Pte, nt.omitBy = Lte, nt.once = cte, nt.orderBy = _P, nt.over = ane, nt.overArgs = CF, nt.overEvery = ine, nt.overSome = pI, nt.partial = CP, nt.partialRight = W1, nt.partition = lC, nt.pick = Ote, nt.pickBy = eG, nt.property = dG, nt.propertyOf = one, nt.pull = cF, nt.pullAll = gP, nt.pullAllBy = sC, nt.pullAllWith = xj, nt.pullAt = wj, nt.range = OF, nt.rangeRight = pG, nt.rearg = MP, nt.reject = Vj, nt.remove = Fee, nt.rest = fte, nt.reverse = mP, nt.sampleSize = bF, nt.set = Rte, nt.setWith = Fte, nt.shuffle = zj, nt.slice = Sj, nt.sortBy = xF, nt.sortedUniq = Bee, nt.sortedUniqBy = jee, nt.split = Kte, nt.spread = hte, nt.tail = Gee, nt.take = Wee, nt.takeRight = fF, nt.takeRightWhile = Hee, nt.takeWhile = $ee, nt.tap = vF, nt.throttle = dte, nt.thru = bp, nt.toArray = Yj, nt.toPairs = tG, nt.toPairsIn = nG, nt.toPath = VF, nt.toPlainObject = qh, nt.transform = Nte, nt.unary = uC, nt.union = Uee, nt.unionBy = qee, nt.unionWith = Yee, nt.uniq = rc, nt.uniqBy = Hu, nt.uniqWith = Zee, nt.unset = $1, nt.unzip = hF, nt.unzipWith = Ej, nt.update = Vte, nt.updateWith = zte, nt.values = _C, nt.valuesIn = Bte, nt.without = Xee, nt.words = cG, nt.wrap = W0, nt.xor = Kee, nt.xorBy = Jee, nt.xorWith = Ij, nt.zip = Qee, nt.zipObject = Uh, nt.zipObjectDeep = dF, nt.zipWith = Ww, nt.entries = tG, nt.entriesIn = nG, nt.extend = Kj, nt.extendWith = gC, dI(nt, nt), nt.add = mG, nt.attempt = DF, nt.camelCase = Wte, nt.capitalize = kg, nt.ceil = yG, nt.clamp = jte, nt.clone = pte, nt.cloneDeep = gte, nt.cloneDeepWith = mte, nt.cloneWith = vte, nt.conformsTo = yte, nt.deburr = rG, nt.defaultTo = PF, nt.divide = VP, nt.endsWith = Hte, nt.eq = Pd, nt.escape = $te, nt.escapeRegExp = Ute, nt.every = tte, nt.find = S_, nt.findIndex = Bw, nt.findKey = LP, nt.findLast = yP, nt.findLastIndex = Eg, nt.findLastKey = yC, nt.floor = une, nt.forEach = bP, nt.forEachRight = Fj, nt.forIn = Mte, nt.forInRight = Ate, nt.forOwn = Ete, nt.forOwnRight = Ite, nt.get = $w, nt.gt = _n, nt.gte = Lr, nt.has = Jj, nt.hasIn = st, nt.head = x_, nt.identity = _p, nt.includes = nte, nt.indexOf = j1, nt.inRange = qw, nt.invoke = Dg, nt.isArguments = Zn, nt.isArray = ea, nt.isArrayBuffer = Vo, nt.isArrayLike = zo, nt.isArrayLikeObject = Ms, nt.isBoolean = Pu, nt.isBuffer = hy, nt.isDate = bte, nt.isElement = Tg, nt.isEmpty = AP, nt.isEqual = _te, nt.isEqualWith = cC, nt.isError = fC, nt.isFinite = EP, nt.isFunction = Ks, nt.isInteger = Hj, nt.isLength = sI, nt.isMap = $j, nt.isMatch = xte, nt.isMatchWith = IP, nt.isNaN = M_, nt.isNative = TP, nt.isNil = DP, nt.isNull = Uj, nt.isNumber = MF, nt.isObject = $u, nt.isObjectLike = Hc, nt.isPlainObject = hC, nt.isRegExp = dC, nt.isSafeInteger = qj, nt.isSet = pC, nt.isString = dy, nt.isSymbol = Ld, nt.isTypedArray = vC, nt.isUndefined = wte, nt.isWeakMap = Ste, nt.isWeakSet = kP, nt.join = oC, nt.kebabCase = qte, nt.last = vh, nt.lastIndexOf = w_, nt.lowerCase = aG, nt.lowerFirst = iG, nt.lt = PP, nt.lte = AF, nt.max = bG, nt.maxBy = _G, nt.mean = cne, nt.meanBy = xG, nt.min = fne, nt.minBy = zF, nt.stubArray = RF, nt.stubFalse = FF, nt.stubObject = sne, nt.stubString = vG, nt.stubTrue = NF, nt.multiply = wG, nt.nth = iI, nt.noConflict = rne, nt.noop = Xw, nt.now = xP, nt.pad = Yte, nt.padEnd = Zte, nt.padStart = IF, nt.parseInt = fI, nt.random = Gte, nt.reduce = ite, nt.reduceRight = Nj, nt.repeat = FP, nt.replace = Xte, nt.result = H1, nt.round = BF, nt.runInContext = an, nt.sample = yF, nt.size = ote, nt.snakeCase = oG, nt.some = _F, nt.sortedIndex = Cj, nt.sortedIndexBy = Mj, nt.sortedIndexOf = Nee, nt.sortedLastIndex = Vee, nt.sortedLastIndexBy = zee, nt.sortedLastIndexOf = Aj, nt.startCase = U1, nt.startsWith = TF, nt.subtract = hne, nt.sum = jF, nt.sumBy = As, nt.template = Yw, nt.times = lne, nt.toFinite = py, nt.toInteger = ls, nt.toLength = Zj, nt.toLower = Pg, nt.toNumber = Ul, nt.toSafeInteger = Cte, nt.toString = ql, nt.toUpper = Jte, nt.trim = sG, nt.trimEnd = lG, nt.trimStart = hI, nt.truncate = A_, nt.unescape = uG, nt.uniqueId = gG, nt.upperCase = Qte, nt.upperFirst = xC, nt.each = bP, nt.eachRight = Fj, nt.first = x_, dI(nt, function() {
              var P = {};
              return vp(nt, function(G, ae) {
                Al.call(nt.prototype, ae) || (P[ae] = G);
              }), P;
            }(), { chain: false }), nt.VERSION = ee, zh(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(P) {
              nt[P].placeholder = nt;
            }), zh(["drop", "take"], function(P, G) {
              ws.prototype[P] = function(ae) {
                ae = ae === J ? 1 : Vc(ls(ae), 0);
                var Me = this.__filtered__ && !G ? new ws(this) : this.clone();
                return Me.__filtered__ ? Me.__takeCount__ = lf(ae, Me.__takeCount__) : Me.__views__.push({ size: lf(ae, ya), type: P + (Me.__dir__ < 0 ? "Right" : "") }), Me;
              }, ws.prototype[P + "Right"] = function(ae) {
                return this.reverse()[P](ae).reverse();
              };
            }), zh(["filter", "map", "takeWhile"], function(P, G) {
              var ae = G + 1, Me = ae == Xa || ae == ir;
              ws.prototype[P] = function(Ue) {
                var gt = this.clone();
                return gt.__iteratees__.push({ iteratee: ki(Ue, 3), type: ae }), gt.__filtered__ = gt.__filtered__ || Me, gt;
              };
            }), zh(["head", "last"], function(P, G) {
              var ae = "take" + (G ? "Right" : "");
              ws.prototype[P] = function() {
                return this[ae](1).value()[0];
              };
            }), zh(["initial", "tail"], function(P, G) {
              var ae = "drop" + (G ? "" : "Right");
              ws.prototype[P] = function() {
                return this.__filtered__ ? new ws(this) : this[ae](1);
              };
            }), ws.prototype.compact = function() {
              return this.filter(_p);
            }, ws.prototype.find = function(P) {
              return this.filter(P).head();
            }, ws.prototype.findLast = function(P) {
              return this.reverse().find(P);
            }, ws.prototype.invokeMap = Ge(function(P, G) {
              return typeof P == "function" ? new ws(this) : this.map(function(ae) {
                return R1(ae, P, G);
              });
            }), ws.prototype.reject = function(P) {
              return this.filter(SP(ki(P)));
            }, ws.prototype.slice = function(P, G) {
              P = ls(P);
              var ae = this;
              return ae.__filtered__ && (P > 0 || G < 0) ? new ws(ae) : (P < 0 ? ae = ae.takeRight(-P) : P && (ae = ae.drop(P)), G !== J && (G = ls(G), ae = G < 0 ? ae.dropRight(-G) : ae.take(G - P)), ae);
            }, ws.prototype.takeRightWhile = function(P) {
              return this.reverse().takeWhile(P).reverse();
            }, ws.prototype.toArray = function() {
              return this.take(ya);
            }, vp(ws.prototype, function(P, G) {
              var ae = /^(?:filter|find|map|reject)|While$/.test(G), Me = /^(?:head|last)$/.test(G), Ue = nt[Me ? "take" + (G == "last" ? "Right" : "") : G], gt = Me || /^find/.test(G);
              !Ue || (nt.prototype[G] = function() {
                var jt = this.__wrapped__, tn = Me ? [1] : arguments, Sn = jt instanceof ws, Hr = tn[0], qr = Sn || ea(jt), ca = function(Rs) {
                  var Js = Ue.apply(nt, tv([Rs], tn));
                  return Me && Aa ? Js[0] : Js;
                };
                qr && ae && typeof Hr == "function" && Hr.length != 1 && (Sn = qr = false);
                var Aa = this.__chain__, fi = !!this.__actions__.length, Ki = gt && !Aa, us = Sn && !fi;
                if (!gt && qr) {
                  jt = us ? jt : new ws(this);
                  var Ui = P.apply(jt, tn);
                  return Ui.__actions__.push({ func: bp, args: [ca], thisArg: J }), new pp(Ui, Aa);
                }
                return Ki && us ? P.apply(this, tn) : (Ui = this.thru(ca), Ki ? Me ? Ui.value()[0] : Ui.value() : Ui);
              });
            }), zh(["pop", "push", "shift", "sort", "splice", "unshift"], function(P) {
              var G = Gu[P], ae = /^(?:push|sort|unshift)$/.test(P) ? "tap" : "thru", Me = /^(?:pop|shift)$/.test(P);
              nt.prototype[P] = function() {
                var Ue = arguments;
                if (Me && !this.__chain__) {
                  var gt = this.value();
                  return G.apply(ea(gt) ? gt : [], Ue);
                }
                return this[ae](function(jt) {
                  return G.apply(ea(jt) ? jt : [], Ue);
                });
              };
            }), vp(ws.prototype, function(P, G) {
              var ae = nt[G];
              if (ae) {
                var Me = ae.name + "";
                Al.call(h_, Me) || (h_[Me] = []), h_[Me].push({ name: G, func: ae });
              }
            }), h_[Xn(J, yr).name] = [{ name: "wrapper", func: J }], ws.prototype.clone = $6, ws.prototype.reverse = NE, ws.prototype.value = VE, nt.prototype.at = Tj, nt.prototype.chain = Dj, nt.prototype.commit = kj, nt.prototype.next = Pj, nt.prototype.plant = Oj, nt.prototype.reverse = Wv, nt.prototype.toJSON = nt.prototype.valueOf = nt.prototype.value = ete, nt.prototype.first = nt.prototype.head, es && (nt.prototype[es] = Lj), nt;
          }, O0 = Co();
          ey ? ((ey.exports = O0)._ = O0, NS._ = O0) : dc._ = O0;
        }).call(R);
      })(j, j.exports);
      class $ {
        constructor() {
          v6(this, "subscriptions", /* @__PURE__ */ new Map()), v6(this, "emitEffectCache", /* @__PURE__ */ new Map()), v6(this, "useSubscription", (ve, J) => {
            const ee = m6.useRef();
            m6.useEffect(() => {
              var te, ce;
              ee.current = J;
              function Ie(De) {
                ee.current && ee.current(De);
              }
              const Le = (ce = (te = this.subscriptions) == null ? void 0 : te.get(ve)) != null ? ce : [];
              return Le.push(Ie), this.subscriptions.set(ve, Le), this.emitEffect(ve), () => {
                this.subscriptions.delete(ve);
              };
            });
          }), v6(this, "emit", (ve, ...J) => {
            if (typeof ve == "string" || typeof ve == "number") {
              const ee = this.subscriptions.get(ve);
              ee == null || ee.forEach((te) => {
                te == null || te({ params: j.exports.cloneDeep(J), event: ve });
              }), this.emitEffectCache.set(ve, { params: j.exports.cloneDeep(J), event: ve });
            } else
              throw new TypeError("event must be string or number !");
          }), v6(this, "emitEffect", (ve) => {
            const J = this.emitEffectCache.get(ve), ee = this.subscriptions.get(ve);
            J && (ee == null || ee.forEach((te) => {
              te == null || te(d6({}, J));
            }));
          }), v6(this, "removeListener", (ve) => {
            this.subscriptions.delete(ve);
          }), v6(this, "clear", () => {
            this.subscriptions.clear();
          }), this.clear();
        }
      }
      const K = new $();
      function U(Z) {
        const ve = m6.useRef(), J = m6.useMemo(() => Z != null ? Z : { global: false }, [Z]);
        return ve.current || (ve.current = J.global ? ve.current = K : ve.current = new $()), m6.useEffect(() => () => {
          var ee;
          return (ee = ve.current) == null ? void 0 : ee.clear();
        }, []), ve.current;
      }
      var he = globalThis && globalThis.__read || function(Z, ve) {
        var J = typeof Symbol == "function" && Z[Symbol.iterator];
        if (!J)
          return Z;
        var ee = J.call(Z), te, ce = [], Ie;
        try {
          for (; (ve === void 0 || ve-- > 0) && !(te = ee.next()).done; )
            ce.push(te.value);
        } catch (Le) {
          Ie = { error: Le };
        } finally {
          try {
            te && !te.done && (J = ee.return) && J.call(ee);
          } finally {
            if (Ie)
              throw Ie.error;
          }
        }
        return ce;
      };
      function ue(Z, ve) {
        Z === void 0 && (Z = false);
        var J = he(m6.useState(Z), 2), ee = J[0], te = J[1], ce = m6.useMemo(function() {
          var Ie = ve === void 0 ? !Z : ve, Le = function() {
            return te(function(pt) {
              return pt === Z ? Ie : Z;
            });
          }, De = function(pt) {
            return te(pt);
          }, Ye = function() {
            return te(Z);
          }, Ke = function() {
            return te(Ie);
          };
          return { toggle: Le, set: De, setLeft: Ye, setRight: Ke };
        }, []);
        return [ee, ce];
      }
      var pe = globalThis && globalThis.__read || function(Z, ve) {
        var J = typeof Symbol == "function" && Z[Symbol.iterator];
        if (!J)
          return Z;
        var ee = J.call(Z), te, ce = [], Ie;
        try {
          for (; (ve === void 0 || ve-- > 0) && !(te = ee.next()).done; )
            ce.push(te.value);
        } catch (Le) {
          Ie = { error: Le };
        } finally {
          try {
            te && !te.done && (J = ee.return) && J.call(ee);
          } finally {
            if (Ie)
              throw Ie.error;
          }
        }
        return ce;
      };
      function _e(Z) {
        Z === void 0 && (Z = false);
        var ve = pe(ue(Z), 2), J = ve[0], ee = ve[1], te = ee.toggle, ce = ee.set, Ie = m6.useMemo(function() {
          var Le = function() {
            return ce(true);
          }, De = function() {
            return ce(false);
          };
          return { toggle: te, set: function(Ye) {
            return ce(!!Ye);
          }, setTrue: Le, setFalse: De };
        }, []);
        return [J, Ie];
      }
      function xe(Z) {
        var ve = m6.useRef(Z);
        return ve.current = Z, ve;
      }
      var Ae = function(Z) {
        var ve = xe(Z);
        m6.useEffect(function() {
          return function() {
            ve.current();
          };
        }, []);
      }, ke = Ae;
      function je(Z) {
        var ve = typeof Z;
        return Z != null && (ve == "object" || ve == "function");
      }
      var Fe = je, at = typeof R == "object" && R && R.Object === Object && R, ht = at, Qe = ht, en = typeof self == "object" && self && self.Object === Object && self, bt = Qe || en || Function("return this")(), wt = bt, Ft = wt, fn = function() {
        return Ft.Date.now();
      }, gn = fn, Zr = /\s/;
      function Ma(Z) {
        for (var ve = Z.length; ve-- && Zr.test(Z.charAt(ve)); )
          ;
        return ve;
      }
      var Ua = Ma, ja = Ua, Ga = /^\s+/;
      function pa(Z) {
        return Z && Z.slice(0, ja(Z) + 1).replace(Ga, "");
      }
      var Fa = pa, Ha = wt, Sa = Ha.Symbol, oi = Sa, bs = oi, Si = Object.prototype, Ls = Si.hasOwnProperty, tl = Si.toString, Hs = bs ? bs.toStringTag : void 0;
      function Of(Z) {
        var ve = Ls.call(Z, Hs), J = Z[Hs];
        try {
          Z[Hs] = void 0;
          var ee = true;
        } catch {
        }
        var te = tl.call(Z);
        return ee && (ve ? Z[Hs] = J : delete Z[Hs]), te;
      }
      var Xu = Of, kh = Object.prototype, ou = kh.toString;
      function lc(Z) {
        return ou.call(Z);
      }
      var Ku = lc, _0 = oi, Vr = Xu, Un = Ku, Wn = "[object Null]", zr = "[object Undefined]", La = _0 ? _0.toStringTag : void 0;
      function _i(Z) {
        return Z == null ? Z === void 0 ? zr : Wn : La && La in Object(Z) ? Vr(Z) : Un(Z);
      }
      var Jo = _i;
      function Wo(Z) {
        return Z != null && typeof Z == "object";
      }
      var wl = Wo, Ju = Jo, wu = wl, Kc = "[object Symbol]";
      function Su(Z) {
        return typeof Z == "symbol" || wu(Z) && Ju(Z) == Kc;
      }
      var pd = Su, ip = Fa, kv = Fe, op = pd, Ac = 0 / 0, $s = /^[-+]0x[0-9a-f]+$/i, Rf = /^0b[01]+$/i, Ph = /^0o[0-7]+$/i, pg = parseInt;
      function Up(Z) {
        if (typeof Z == "number")
          return Z;
        if (op(Z))
          return Ac;
        if (kv(Z)) {
          var ve = typeof Z.valueOf == "function" ? Z.valueOf() : Z;
          Z = kv(ve) ? ve + "" : ve;
        }
        if (typeof Z != "string")
          return Z === 0 ? Z : +Z;
        Z = ip(Z);
        var J = Rf.test(Z);
        return J || Ph.test(Z) ? pg(Z.slice(2), J ? 2 : 8) : $s.test(Z) ? Ac : +Z;
      }
      var sp = Up, Pv = Fe, $m = gn, Um = sp, j4 = "Expected a function", Ub = Math.max, G4 = Math.min;
      function W4(Z, ve, J) {
        var ee, te, ce, Ie, Le, De, Ye = 0, Ke = false, pt = false, Bt = true;
        if (typeof Z != "function")
          throw new TypeError(j4);
        ve = Um(ve) || 0, Pv(J) && (Ke = !!J.leading, pt = "maxWait" in J, ce = pt ? Ub(Um(J.maxWait) || 0, ve) : ce, Bt = "trailing" in J ? !!J.trailing : Bt);
        function qt(On) {
          var dr = ee, ur = te;
          return ee = te = void 0, Ye = On, Ie = Z.apply(ur, dr), Ie;
        }
        function Yt(On) {
          return Ye = On, Le = setTimeout(yr, ve), Ke ? qt(On) : Ie;
        }
        function nn(On) {
          var dr = On - De, ur = On - Ye, An = ve - dr;
          return pt ? G4(An, ce - ur) : An;
        }
        function ln(On) {
          var dr = On - De, ur = On - Ye;
          return De === void 0 || dr >= ve || dr < 0 || pt && ur >= ce;
        }
        function yr() {
          var On = $m();
          if (ln(On))
            return sr(On);
          Le = setTimeout(yr, nn(On));
        }
        function sr(On) {
          return Le = void 0, Bt && ee ? qt(On) : (ee = te = void 0, Ie);
        }
        function aa() {
          Le !== void 0 && clearTimeout(Le), Ye = 0, ee = De = te = Le = void 0;
        }
        function He() {
          return Le === void 0 ? Ie : sr($m());
        }
        function Cn() {
          var On = $m(), dr = ln(On);
          if (ee = arguments, te = this, De = On, dr) {
            if (Le === void 0)
              return Yt(De);
            if (pt)
              return clearTimeout(Le), Le = setTimeout(yr, ve), qt(De);
          }
          return Le === void 0 && (Le = setTimeout(yr, ve)), Ie;
        }
        return Cn.cancel = aa, Cn.flush = He, Cn;
      }
      var H4 = W4, $4 = globalThis && globalThis.__read || function(Z, ve) {
        var J = typeof Symbol == "function" && Z[Symbol.iterator];
        if (!J)
          return Z;
        var ee = J.call(Z), te, ce = [], Ie;
        try {
          for (; (ve === void 0 || ve-- > 0) && !(te = ee.next()).done; )
            ce.push(te.value);
        } catch (Le) {
          Ie = { error: Le };
        } finally {
          try {
            te && !te.done && (J = ee.return) && J.call(ee);
          } finally {
            if (Ie)
              throw Ie.error;
          }
        }
        return ce;
      }, yS = globalThis && globalThis.__spread || function() {
        for (var Z = [], ve = 0; ve < arguments.length; ve++)
          Z = Z.concat($4(arguments[ve]));
        return Z;
      };
      function Ot(Z, ve) {
        var J, ee = xe(Z), te = (J = ve == null ? void 0 : ve.wait) !== null && J !== void 0 ? J : 1e3, ce = m6.useMemo(function() {
          return H4(function() {
            for (var Ie = [], Le = 0; Le < arguments.length; Le++)
              Ie[Le] = arguments[Le];
            return ee.current.apply(ee, yS(Ie));
          }, te, ve);
        }, []);
        return ke(function() {
          ce.cancel();
        }), { run: ce, cancel: ce.cancel, flush: ce.flush };
      }
      const Nt = ({ id: Z, title: ve, chart: J, option: ee }, te) => {
        const ce = m6.useRef(), Ie = U({ global: true });
        ce.current = m6.useMemo(() => {
          if (!ce.current)
            return I;
        }, []);
        const { run: Le } = Ot(() => {
          Z && Ie.emit("list");
        }, { wait: 100 });
        return m6.useEffect(() => {
          console.log(J == null ? void 0 : J.current), ce.current && (J == null ? void 0 : J.current) && Z && ee && (ce.current.add(Z, J == null ? void 0 : J.current, ee, ve), Le());
        }, te), { tool: ce.current };
      };
      var ct = m6.createContext({}), Mt = ct;
      function _t(Z, ve, J) {
        return ve in Z ? Object.defineProperty(Z, ve, { value: J, enumerable: true, configurable: true, writable: true }) : Z[ve] = J, Z;
      }
      function Rn(Z, ve) {
        var J = Object.keys(Z);
        if (Object.getOwnPropertySymbols) {
          var ee = Object.getOwnPropertySymbols(Z);
          ve && (ee = ee.filter(function(te) {
            return Object.getOwnPropertyDescriptor(Z, te).enumerable;
          })), J.push.apply(J, ee);
        }
        return J;
      }
      function Pn(Z) {
        for (var ve = 1; ve < arguments.length; ve++) {
          var J = arguments[ve] != null ? arguments[ve] : {};
          ve % 2 ? Rn(Object(J), true).forEach(function(ee) {
            _t(Z, ee, J[ee]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Z, Object.getOwnPropertyDescriptors(J)) : Rn(Object(J)).forEach(function(ee) {
            Object.defineProperty(Z, ee, Object.getOwnPropertyDescriptor(J, ee));
          });
        }
        return Z;
      }
      function lr(Z) {
        if (Array.isArray(Z))
          return Z;
      }
      function Mn(Z, ve) {
        var J = Z == null ? null : typeof Symbol != "undefined" && Z[Symbol.iterator] || Z["@@iterator"];
        if (J != null) {
          var ee = [], te = true, ce = false, Ie, Le;
          try {
            for (J = J.call(Z); !(te = (Ie = J.next()).done) && (ee.push(Ie.value), !(ve && ee.length === ve)); te = true)
              ;
          } catch (De) {
            ce = true, Le = De;
          } finally {
            try {
              !te && J.return != null && J.return();
            } finally {
              if (ce)
                throw Le;
            }
          }
          return ee;
        }
      }
      function ta(Z, ve) {
        (ve == null || ve > Z.length) && (ve = Z.length);
        for (var J = 0, ee = new Array(ve); J < ve; J++)
          ee[J] = Z[J];
        return ee;
      }
      function di(Z, ve) {
        if (Z) {
          if (typeof Z == "string")
            return ta(Z, ve);
          var J = Object.prototype.toString.call(Z).slice(8, -1);
          if (J === "Object" && Z.constructor && (J = Z.constructor.name), J === "Map" || J === "Set")
            return Array.from(Z);
          if (J === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(J))
            return ta(Z, ve);
        }
      }
      function as() {
        throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function fo(Z, ve) {
        return lr(Z) || Mn(Z, ve) || di(Z, ve) || as();
      }
      function Gl(Z, ve) {
        if (Z == null)
          return {};
        var J = {}, ee = Object.keys(Z), te, ce;
        for (ce = 0; ce < ee.length; ce++)
          te = ee[ce], !(ve.indexOf(te) >= 0) && (J[te] = Z[te]);
        return J;
      }
      function So(Z, ve) {
        if (Z == null)
          return {};
        var J = Gl(Z, ve), ee, te;
        if (Object.getOwnPropertySymbols) {
          var ce = Object.getOwnPropertySymbols(Z);
          for (te = 0; te < ce.length; te++)
            ee = ce[te], !(ve.indexOf(ee) >= 0) && (!Object.prototype.propertyIsEnumerable.call(Z, ee) || (J[ee] = Z[ee]));
        }
        return J;
      }
      var kl = { exports: {} };
      /*!
        Copyright (c) 2018 Jed Watson.
        Licensed under the MIT License (MIT), see
        http://jedwatson.github.io/classnames
      */
      (function(Z) {
        (function() {
          var ve = {}.hasOwnProperty;
          function J() {
            for (var ee = [], te = 0; te < arguments.length; te++) {
              var ce = arguments[te];
              if (ce) {
                var Ie = typeof ce;
                if (Ie === "string" || Ie === "number")
                  ee.push(ce);
                else if (Array.isArray(ce)) {
                  if (ce.length) {
                    var Le = J.apply(null, ce);
                    Le && ee.push(Le);
                  }
                } else if (Ie === "object")
                  if (ce.toString === Object.prototype.toString)
                    for (var De in ce)
                      ve.call(ce, De) && ce[De] && ee.push(De);
                  else
                    ee.push(ce.toString());
              }
            }
            return ee.join(" ");
          }
          Z.exports ? (J.default = J, Z.exports = J) : window.classNames = J;
        })();
      })(kl);
      var Jl = kl.exports;
      function Mi(Z) {
        return Mi = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(ve) {
          return typeof ve;
        } : function(ve) {
          return ve && typeof Symbol == "function" && ve.constructor === Symbol && ve !== Symbol.prototype ? "symbol" : typeof ve;
        }, Mi(Z);
      }
      function Sl(Z, ve) {
        lp(Z) && (Z = "100%");
        var J = x0(Z);
        return Z = ve === 360 ? Z : Math.min(ve, Math.max(0, parseFloat(Z))), J && (Z = parseInt(String(Z * ve), 10) / 100), Math.abs(Z - ve) < 1e-6 ? 1 : (ve === 360 ? Z = (Z < 0 ? Z % ve + ve : Z % ve) / parseFloat(String(ve)) : Z = Z % ve / parseFloat(String(ve)), Z);
      }
      function lp(Z) {
        return typeof Z == "string" && Z.indexOf(".") !== -1 && parseFloat(Z) === 1;
      }
      function x0(Z) {
        return typeof Z == "string" && Z.indexOf("%") !== -1;
      }
      function bS(Z) {
        return Z = parseFloat(Z), (isNaN(Z) || Z < 0 || Z > 1) && (Z = 1), Z;
      }
      function qp(Z) {
        return Z <= 1 ? Number(Z) * 100 + "%" : Z;
      }
      function p1(Z) {
        return Z.length === 1 ? "0" + Z : String(Z);
      }
      function v12(Z, ve, J) {
        return { r: Sl(Z, 255) * 255, g: Sl(ve, 255) * 255, b: Sl(J, 255) * 255 };
      }
      function Jc(Z, ve, J) {
        return J < 0 && (J += 1), J > 1 && (J -= 1), J < 1 / 6 ? Z + (ve - Z) * (6 * J) : J < 1 / 2 ? ve : J < 2 / 3 ? Z + (ve - Z) * (2 / 3 - J) * 6 : Z;
      }
      function qm(Z, ve, J) {
        var ee, te, ce;
        if (Z = Sl(Z, 360), ve = Sl(ve, 100), J = Sl(J, 100), ve === 0)
          te = J, ce = J, ee = J;
        else {
          var Ie = J < 0.5 ? J * (1 + ve) : J + ve - J * ve, Le = 2 * J - Ie;
          ee = Jc(Le, Ie, Z + 1 / 3), te = Jc(Le, Ie, Z), ce = Jc(Le, Ie, Z - 1 / 3);
        }
        return { r: ee * 255, g: te * 255, b: ce * 255 };
      }
      function Qx(Z, ve, J) {
        Z = Sl(Z, 255), ve = Sl(ve, 255), J = Sl(J, 255);
        var ee = Math.max(Z, ve, J), te = Math.min(Z, ve, J), ce = 0, Ie = ee, Le = ee - te, De = ee === 0 ? 0 : Le / ee;
        if (ee === te)
          ce = 0;
        else {
          switch (ee) {
            case Z:
              ce = (ve - J) / Le + (ve < J ? 6 : 0);
              break;
            case ve:
              ce = (J - Z) / Le + 2;
              break;
            case J:
              ce = (Z - ve) / Le + 4;
              break;
          }
          ce /= 6;
        }
        return { h: ce, s: De, v: Ie };
      }
      function g1(Z, ve, J) {
        Z = Sl(Z, 360) * 6, ve = Sl(ve, 100), J = Sl(J, 100);
        var ee = Math.floor(Z), te = Z - ee, ce = J * (1 - ve), Ie = J * (1 - te * ve), Le = J * (1 - (1 - te) * ve), De = ee % 6, Ye = [J, Ie, ce, ce, Le, J][De], Ke = [Le, J, J, Ie, ce, ce][De], pt = [ce, ce, Le, J, J, Ie][De];
        return { r: Ye * 255, g: Ke * 255, b: pt * 255 };
      }
      function ew(Z, ve, J, ee) {
        var te = [p1(Math.round(Z).toString(16)), p1(Math.round(ve).toString(16)), p1(Math.round(J).toString(16))];
        return ee && te[0].startsWith(te[0].charAt(1)) && te[1].startsWith(te[1].charAt(1)) && te[2].startsWith(te[2].charAt(1)) ? te[0].charAt(0) + te[1].charAt(0) + te[2].charAt(0) : te.join("");
      }
      function qb(Z) {
        return Lh(Z) / 255;
      }
      function Lh(Z) {
        return parseInt(Z, 16);
      }
      var tw = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
      function Ym(Z) {
        var ve = { r: 0, g: 0, b: 0 }, J = 1, ee = null, te = null, ce = null, Ie = false, Le = false;
        return typeof Z == "string" && (Z = MB(Z)), typeof Z == "object" && (Zm(Z.r) && Zm(Z.g) && Zm(Z.b) ? (ve = v12(Z.r, Z.g, Z.b), Ie = true, Le = String(Z.r).substr(-1) === "%" ? "prgb" : "rgb") : Zm(Z.h) && Zm(Z.s) && Zm(Z.v) ? (ee = qp(Z.s), te = qp(Z.v), ve = g1(Z.h, ee, te), Ie = true, Le = "hsv") : Zm(Z.h) && Zm(Z.s) && Zm(Z.l) && (ee = qp(Z.s), ce = qp(Z.l), ve = qm(Z.h, ee, ce), Ie = true, Le = "hsl"), Object.prototype.hasOwnProperty.call(Z, "a") && (J = Z.a)), J = bS(J), { ok: Ie, format: Z.format || Le, r: Math.min(255, Math.max(ve.r, 0)), g: Math.min(255, Math.max(ve.g, 0)), b: Math.min(255, Math.max(ve.b, 0)), a: J };
      }
      var nw = "[-\\+]?\\d+%?", Yb = "[-\\+]?\\d*\\.\\d+%?", vg = "(?:" + Yb + ")|(?:" + nw + ")", jA = "[\\s|\\(]+(" + vg + ")[,|\\s]+(" + vg + ")[,|\\s]+(" + vg + ")\\s*\\)?", GA = "[\\s|\\(]+(" + vg + ")[,|\\s]+(" + vg + ")[,|\\s]+(" + vg + ")[,|\\s]+(" + vg + ")\\s*\\)?", vd = { CSS_UNIT: new RegExp(vg), rgb: new RegExp("rgb" + jA), rgba: new RegExp("rgba" + GA), hsl: new RegExp("hsl" + jA), hsla: new RegExp("hsla" + GA), hsv: new RegExp("hsv" + jA), hsva: new RegExp("hsva" + GA), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
      function MB(Z) {
        if (Z = Z.trim().toLowerCase(), Z.length === 0)
          return false;
        var ve = false;
        if (tw[Z])
          Z = tw[Z], ve = true;
        else if (Z === "transparent")
          return { r: 0, g: 0, b: 0, a: 0, format: "name" };
        var J = vd.rgb.exec(Z);
        return J ? { r: J[1], g: J[2], b: J[3] } : (J = vd.rgba.exec(Z), J ? { r: J[1], g: J[2], b: J[3], a: J[4] } : (J = vd.hsl.exec(Z), J ? { h: J[1], s: J[2], l: J[3] } : (J = vd.hsla.exec(Z), J ? { h: J[1], s: J[2], l: J[3], a: J[4] } : (J = vd.hsv.exec(Z), J ? { h: J[1], s: J[2], v: J[3] } : (J = vd.hsva.exec(Z), J ? { h: J[1], s: J[2], v: J[3], a: J[4] } : (J = vd.hex8.exec(Z), J ? { r: Lh(J[1]), g: Lh(J[2]), b: Lh(J[3]), a: qb(J[4]), format: ve ? "name" : "hex8" } : (J = vd.hex6.exec(Z), J ? { r: Lh(J[1]), g: Lh(J[2]), b: Lh(J[3]), format: ve ? "name" : "hex" } : (J = vd.hex4.exec(Z), J ? { r: Lh(J[1] + J[1]), g: Lh(J[2] + J[2]), b: Lh(J[3] + J[3]), a: qb(J[4] + J[4]), format: ve ? "name" : "hex8" } : (J = vd.hex3.exec(Z), J ? { r: Lh(J[1] + J[1]), g: Lh(J[2] + J[2]), b: Lh(J[3] + J[3]), format: ve ? "name" : "hex" } : false)))))))));
      }
      function Zm(Z) {
        return Boolean(vd.CSS_UNIT.exec(String(Z)));
      }
      var j5 = 2, U4 = 0.16, AB = 0.05, EB = 0.05, IB = 0.15, TB = 5, DB = 4, FQ = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
      function q4(Z) {
        var ve = Z.r, J = Z.g, ee = Z.b, te = Qx(ve, J, ee);
        return { h: te.h * 360, s: te.s, v: te.v };
      }
      function G5(Z) {
        var ve = Z.r, J = Z.g, ee = Z.b;
        return "#".concat(ew(ve, J, ee, false));
      }
      function NQ(Z, ve, J) {
        var ee = J / 100, te = { r: (ve.r - Z.r) * ee + Z.r, g: (ve.g - Z.g) * ee + Z.g, b: (ve.b - Z.b) * ee + Z.b };
        return te;
      }
      function kB(Z, ve, J) {
        var ee;
        return Math.round(Z.h) >= 60 && Math.round(Z.h) <= 240 ? ee = J ? Math.round(Z.h) - j5 * ve : Math.round(Z.h) + j5 * ve : ee = J ? Math.round(Z.h) + j5 * ve : Math.round(Z.h) - j5 * ve, ee < 0 ? ee += 360 : ee >= 360 && (ee -= 360), ee;
      }
      function PB(Z, ve, J) {
        if (Z.h === 0 && Z.s === 0)
          return Z.s;
        var ee;
        return J ? ee = Z.s - U4 * ve : ve === DB ? ee = Z.s + U4 : ee = Z.s + AB * ve, ee > 1 && (ee = 1), J && ve === TB && ee > 0.1 && (ee = 0.1), ee < 0.06 && (ee = 0.06), Number(ee.toFixed(2));
      }
      function W5(Z, ve, J) {
        var ee;
        return J ? ee = Z.v + EB * ve : ee = Z.v - IB * ve, ee > 1 && (ee = 1), Number(ee.toFixed(2));
      }
      function Y4(Z) {
        for (var ve = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, J = [], ee = Ym(Z), te = TB; te > 0; te -= 1) {
          var ce = q4(ee), Ie = G5(Ym({ h: kB(ce, te, true), s: PB(ce, te, true), v: W5(ce, te, true) }));
          J.push(Ie);
        }
        J.push(G5(ee));
        for (var Le = 1; Le <= DB; Le += 1) {
          var De = q4(ee), Ye = G5(Ym({ h: kB(De, Le), s: PB(De, Le), v: W5(De, Le) }));
          J.push(Ye);
        }
        return ve.theme === "dark" ? FQ.map(function(Ke) {
          var pt = Ke.index, Bt = Ke.opacity, qt = G5(NQ(Ym(ve.backgroundColor || "#141414"), Ym(J[pt]), Bt * 100));
          return qt;
        }) : J;
      }
      var Z4 = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, gd = {}, X4 = {};
      Object.keys(Z4).forEach(function(Z) {
        gd[Z] = Y4(Z4[Z]), gd[Z].primary = gd[Z][5], X4[Z] = Y4(Z4[Z], { theme: "dark", backgroundColor: "#141414" }), X4[Z].primary = X4[Z][5];
      }), gd.red, gd.volcano, gd.gold, gd.orange, gd.yellow, gd.lime, gd.green, gd.cyan, gd.blue, gd.geekblue, gd.purple, gd.magenta, gd.grey;
      var LB = {};
      function Qu(Z, ve) {
      }
      function Bu(Z, ve, J) {
        !ve && !LB[J] && (Z(false, J), LB[J] = true);
      }
      function Xm(Z, ve) {
        Bu(Qu, Z, ve);
      }
      function OB() {
        return !!(typeof window != "undefined" && window.document && window.document.createElement);
      }
      var VQ = "rc-util-key";
      function RB() {
        var Z = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, ve = Z.mark;
        return ve ? ve.startsWith("data-") ? ve : "data-".concat(ve) : VQ;
      }
      function K4(Z) {
        if (Z.attachTo)
          return Z.attachTo;
        var ve = document.querySelector("head");
        return ve || document.body;
      }
      function FB(Z) {
        var ve, J = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        if (!OB())
          return null;
        var ee = document.createElement("style");
        if (!((ve = J.csp) === null || ve === void 0) && ve.nonce) {
          var te;
          ee.nonce = (te = J.csp) === null || te === void 0 ? void 0 : te.nonce;
        }
        ee.innerHTML = Z;
        var ce = K4(J), Ie = ce.firstChild;
        return J.prepend && ce.prepend ? ce.prepend(ee) : J.prepend && Ie ? ce.insertBefore(ee, Ie) : ce.appendChild(ee), ee;
      }
      var H5 = /* @__PURE__ */ new Map();
      function zQ(Z) {
        var ve = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, J = K4(ve);
        return Array.from(H5.get(J).children).find(function(ee) {
          return ee.tagName === "STYLE" && ee.getAttribute(RB(ve)) === Z;
        });
      }
      function sh(Z, ve) {
        var J = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, ee = K4(J);
        if (!H5.has(ee)) {
          var te = FB("", J), ce = te.parentNode;
          H5.set(ee, ce), ce.removeChild(te);
        }
        var Ie = zQ(ve, J);
        if (Ie) {
          var Le, De;
          if (((Le = J.csp) === null || Le === void 0 ? void 0 : Le.nonce) && Ie.nonce !== ((De = J.csp) === null || De === void 0 ? void 0 : De.nonce)) {
            var Ye;
            Ie.nonce = (Ye = J.csp) === null || Ye === void 0 ? void 0 : Ye.nonce;
          }
          return Ie.innerHTML !== Z && (Ie.innerHTML = Z), Ie;
        }
        var Ke = FB(Z, J);
        return Ke.setAttribute(RB(J), ve), Ke;
      }
      function J4(Z, ve) {
        Xm(Z, "[@ant-design/icons] ".concat(ve));
      }
      function Zb(Z) {
        return Mi(Z) === "object" && typeof Z.name == "string" && typeof Z.theme == "string" && (Mi(Z.icon) === "object" || typeof Z.icon == "function");
      }
      function Q4() {
        var Z = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
        return Object.keys(Z).reduce(function(ve, J) {
          var ee = Z[J];
          switch (J) {
            case "class":
              ve.className = ee, delete ve.class;
              break;
            default:
              ve[J] = ee;
          }
          return ve;
        }, {});
      }
      function WA(Z, ve, J) {
        return J ? S.default.createElement(Z.tag, Pn(Pn({ key: ve }, Q4(Z.attrs)), J), (Z.children || []).map(function(ee, te) {
          return WA(ee, "".concat(ve, "-").concat(Z.tag, "-").concat(te));
        })) : S.default.createElement(Z.tag, Pn({ key: ve }, Q4(Z.attrs)), (Z.children || []).map(function(ee, te) {
          return WA(ee, "".concat(ve, "-").concat(Z.tag, "-").concat(te));
        }));
      }
      function Lv(Z) {
        return Y4(Z)[0];
      }
      function e6(Z) {
        return Z ? Array.isArray(Z) ? Z : [Z] : [];
      }
      var NB = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, VB = function() {
        var Z = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : NB, ve = m6.useContext(Mt), J = ve.csp;
        m6.useEffect(function() {
          sh(Z, "@ant-design-icons", { prepend: true, csp: J });
        }, []);
      }, zB = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], _S = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
      function BB(Z) {
        var ve = Z.primaryColor, J = Z.secondaryColor;
        _S.primaryColor = ve, _S.secondaryColor = J || Lv(ve), _S.calculated = !!J;
      }
      function Ov() {
        return Pn({}, _S);
      }
      var $5 = function(Z) {
        var ve = Z.icon, J = Z.className, ee = Z.onClick, te = Z.style, ce = Z.primaryColor, Ie = Z.secondaryColor, Le = So(Z, zB), De = _S;
        if (ce && (De = { primaryColor: ce, secondaryColor: Ie || Lv(ce) }), VB(), J4(Zb(ve), "icon should be icon definiton, but got ".concat(ve)), !Zb(ve))
          return null;
        var Ye = ve;
        return Ye && typeof Ye.icon == "function" && (Ye = Pn(Pn({}, Ye), {}, { icon: Ye.icon(De.primaryColor, De.secondaryColor) })), WA(Ye.icon, "svg-".concat(Ye.name), Pn({ className: J, onClick: ee, style: te, "data-icon": Ye.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, Le));
      };
      $5.displayName = "IconReact", $5.getTwoToneColors = Ov, $5.setTwoToneColors = BB;
      var Yp = $5;
      function jB(Z) {
        var ve = e6(Z), J = fo(ve, 2), ee = J[0], te = J[1];
        return Yp.setTwoToneColors({ primaryColor: ee, secondaryColor: te });
      }
      function GB() {
        var Z = Yp.getTwoToneColors();
        return Z.calculated ? [Z.primaryColor, Z.secondaryColor] : Z.primaryColor;
      }
      var Xb = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
      jB("#1890ff");
      var rw = M.forwardRef(function(Z, ve) {
        var J, ee = Z.className, te = Z.icon, ce = Z.spin, Ie = Z.rotate, Le = Z.tabIndex, De = Z.onClick, Ye = Z.twoToneColor, Ke = So(Z, Xb), pt = M.useContext(Mt), Bt = pt.prefixCls, qt = Bt === void 0 ? "anticon" : Bt, Yt = Jl(qt, (J = {}, _t(J, "".concat(qt, "-").concat(te.name), !!te.name), _t(J, "".concat(qt, "-spin"), !!ce || te.name === "loading"), J), ee), nn = Le;
        nn === void 0 && De && (nn = -1);
        var ln = Ie ? { msTransform: "rotate(".concat(Ie, "deg)"), transform: "rotate(".concat(Ie, "deg)") } : void 0, yr = e6(Ye), sr = fo(yr, 2), aa = sr[0], He = sr[1];
        return M.createElement("span", Pn(Pn({ role: "img", "aria-label": te.name }, Ke), {}, { ref: ve, tabIndex: nn, onClick: De, className: Yt }), M.createElement(Yp, { icon: te, primaryColor: aa, secondaryColor: He, style: ln }));
      });
      rw.displayName = "AntdIcon", rw.getTwoToneColor = GB, rw.setTwoToneColor = jB;
      var t6 = rw, uc = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, Kb = uc, U5 = function(Z, ve) {
        return M.createElement(t6, Pn(Pn({}, Z), {}, { ref: ve, icon: Kb }));
      };
      U5.displayName = "LoadingOutlined";
      var BQ = M.forwardRef(U5);
      function Fc() {
        return Fc = Object.assign || function(Z) {
          for (var ve = 1; ve < arguments.length; ve++) {
            var J = arguments[ve];
            for (var ee in J)
              Object.prototype.hasOwnProperty.call(J, ee) && (Z[ee] = J[ee]);
          }
          return Z;
        }, Fc.apply(this, arguments);
      }
      function HA(Z, ve) {
        if (!(Z instanceof ve))
          throw new TypeError("Cannot call a class as a function");
      }
      function WB(Z, ve) {
        for (var J = 0; J < ve.length; J++) {
          var ee = ve[J];
          ee.enumerable = ee.enumerable || false, ee.configurable = true, "value" in ee && (ee.writable = true), Object.defineProperty(Z, ee.key, ee);
        }
      }
      function $A(Z, ve, J) {
        return ve && WB(Z.prototype, ve), J && WB(Z, J), Object.defineProperty(Z, "prototype", { writable: false }), Z;
      }
      function q5(Z, ve) {
        return q5 = Object.setPrototypeOf || function(J, ee) {
          return J.__proto__ = ee, J;
        }, q5(Z, ve);
      }
      function xS(Z, ve) {
        if (typeof ve != "function" && ve !== null)
          throw new TypeError("Super expression must either be null or a function");
        Z.prototype = Object.create(ve && ve.prototype, { constructor: { value: Z, writable: true, configurable: true } }), Object.defineProperty(Z, "prototype", { writable: false }), ve && q5(Z, ve);
      }
      function m1(Z) {
        return m1 = Object.setPrototypeOf ? Object.getPrototypeOf : function(ve) {
          return ve.__proto__ || Object.getPrototypeOf(ve);
        }, m1(Z);
      }
      function jQ() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function Y5(Z) {
        if (Z === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return Z;
      }
      function HB(Z, ve) {
        if (ve && (Mi(ve) === "object" || typeof ve == "function"))
          return ve;
        if (ve !== void 0)
          throw new TypeError("Derived constructors may only return object or undefined");
        return Y5(Z);
      }
      function UA(Z) {
        var ve = jQ();
        return function() {
          var J = m1(Z), ee;
          if (ve) {
            var te = m1(this).constructor;
            ee = Reflect.construct(J, arguments, te);
          } else
            ee = J.apply(this, arguments);
          return HB(this, ee);
        };
      }
      var qA = { exports: {} }, Wl = {};
      /** @license React v16.13.1
      * react-is.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var lh = typeof Symbol == "function" && Symbol.for, YA = lh ? Symbol.for("react.element") : 60103, ZA = lh ? Symbol.for("react.portal") : 60106, Z5 = lh ? Symbol.for("react.fragment") : 60107, XA = lh ? Symbol.for("react.strict_mode") : 60108, md = lh ? Symbol.for("react.profiler") : 60114, wS = lh ? Symbol.for("react.provider") : 60109, Jb = lh ? Symbol.for("react.context") : 60110, X5 = lh ? Symbol.for("react.async_mode") : 60111, KA = lh ? Symbol.for("react.concurrent_mode") : 60111, K5 = lh ? Symbol.for("react.forward_ref") : 60112, J5 = lh ? Symbol.for("react.suspense") : 60113, GQ = lh ? Symbol.for("react.suspense_list") : 60120, Q5 = lh ? Symbol.for("react.memo") : 60115, ek = lh ? Symbol.for("react.lazy") : 60116, SS = lh ? Symbol.for("react.block") : 60121, WQ = lh ? Symbol.for("react.fundamental") : 60117, HQ = lh ? Symbol.for("react.responder") : 60118, n6 = lh ? Symbol.for("react.scope") : 60119;
      function Zp(Z) {
        if (typeof Z == "object" && Z !== null) {
          var ve = Z.$$typeof;
          switch (ve) {
            case YA:
              switch (Z = Z.type, Z) {
                case X5:
                case KA:
                case Z5:
                case md:
                case XA:
                case J5:
                  return Z;
                default:
                  switch (Z = Z && Z.$$typeof, Z) {
                    case Jb:
                    case K5:
                    case ek:
                    case Q5:
                    case wS:
                      return Z;
                    default:
                      return ve;
                  }
              }
            case ZA:
              return ve;
          }
        }
      }
      function y1(Z) {
        return Zp(Z) === KA;
      }
      Wl.AsyncMode = X5, Wl.ConcurrentMode = KA, Wl.ContextConsumer = Jb, Wl.ContextProvider = wS, Wl.Element = YA, Wl.ForwardRef = K5, Wl.Fragment = Z5, Wl.Lazy = ek, Wl.Memo = Q5, Wl.Portal = ZA, Wl.Profiler = md, Wl.StrictMode = XA, Wl.Suspense = J5, Wl.isAsyncMode = function(Z) {
        return y1(Z) || Zp(Z) === X5;
      }, Wl.isConcurrentMode = y1, Wl.isContextConsumer = function(Z) {
        return Zp(Z) === Jb;
      }, Wl.isContextProvider = function(Z) {
        return Zp(Z) === wS;
      }, Wl.isElement = function(Z) {
        return typeof Z == "object" && Z !== null && Z.$$typeof === YA;
      }, Wl.isForwardRef = function(Z) {
        return Zp(Z) === K5;
      }, Wl.isFragment = function(Z) {
        return Zp(Z) === Z5;
      }, Wl.isLazy = function(Z) {
        return Zp(Z) === ek;
      }, Wl.isMemo = function(Z) {
        return Zp(Z) === Q5;
      }, Wl.isPortal = function(Z) {
        return Zp(Z) === ZA;
      }, Wl.isProfiler = function(Z) {
        return Zp(Z) === md;
      }, Wl.isStrictMode = function(Z) {
        return Zp(Z) === XA;
      }, Wl.isSuspense = function(Z) {
        return Zp(Z) === J5;
      }, Wl.isValidElementType = function(Z) {
        return typeof Z == "string" || typeof Z == "function" || Z === Z5 || Z === KA || Z === md || Z === XA || Z === J5 || Z === GQ || typeof Z == "object" && Z !== null && (Z.$$typeof === ek || Z.$$typeof === Q5 || Z.$$typeof === wS || Z.$$typeof === Jb || Z.$$typeof === K5 || Z.$$typeof === WQ || Z.$$typeof === HQ || Z.$$typeof === n6 || Z.$$typeof === SS);
      }, Wl.typeOf = Zp, qA.exports = Wl;
      function CS(Z) {
        var ve = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, J = [];
        return S.default.Children.forEach(Z, function(ee) {
          ee == null && !ve.keepEmpty || (Array.isArray(ee) ? J = J.concat(CS(ee)) : qA.exports.isFragment(ee) && ee.props ? J = J.concat(CS(ee.props.children, ve)) : J.push(ee));
        }), J;
      }
      function $Q(Z, ve) {
        typeof Z == "function" ? Z(ve) : Mi(Z) === "object" && Z && "current" in Z && (Z.current = ve);
      }
      function UQ() {
        for (var Z = arguments.length, ve = new Array(Z), J = 0; J < Z; J++)
          ve[J] = arguments[J];
        var ee = ve.filter(function(te) {
          return te;
        });
        return ee.length <= 1 ? ee[0] : function(te) {
          ve.forEach(function(ce) {
            $Q(ce, te);
          });
        };
      }
      function qQ(Z) {
        var ve, J, ee = qA.exports.isMemo(Z) ? Z.type.type : Z.type;
        return !(typeof ee == "function" && !(!((ve = ee.prototype) === null || ve === void 0) && ve.render) || typeof Z == "function" && !(!((J = Z.prototype) === null || J === void 0) && J.render));
      }
      function MS() {
        try {
          if (!Object.assign)
            return false;
          var Z = new String("abc");
          if (Z[5] = "de", Object.getOwnPropertyNames(Z)[0] === "5")
            return false;
          for (var ve = {}, J = 0; J < 10; J++)
            ve["_" + String.fromCharCode(J)] = J;
          var ee = Object.getOwnPropertyNames(ve).map(function(ce) {
            return ve[ce];
          });
          if (ee.join("") !== "0123456789")
            return false;
          var te = {};
          return "abcdefghijklmnopqrst".split("").forEach(function(ce) {
            te[ce] = ce;
          }), Object.keys(Object.assign({}, te)).join("") === "abcdefghijklmnopqrst";
        } catch {
          return false;
        }
      }
      MS();
      function w0(Z) {
        if (Array.isArray(Z))
          return ta(Z);
      }
      function r62(Z) {
        if (typeof Symbol != "undefined" && Z[Symbol.iterator] != null || Z["@@iterator"] != null)
          return Array.from(Z);
      }
      function YQ() {
        throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function ul(Z) {
        return w0(Z) || r62(Z) || di(Z) || YQ();
      }
      var AS = "RC_FORM_INTERNAL_HOOKS", ec = function() {
        Xm(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
      }, JA = M.createContext({ getFieldValue: ec, getFieldsValue: ec, getFieldError: ec, getFieldWarning: ec, getFieldsError: ec, isFieldsTouched: ec, isFieldTouched: ec, isFieldValidating: ec, isFieldsValidating: ec, resetFields: ec, setFields: ec, setFieldsValue: ec, validateFields: ec, submit: ec, getInternalHooks: function() {
        return ec(), { dispatch: ec, initEntityValue: ec, registerField: ec, useSubscribe: ec, setInitialValues: ec, setCallbacks: ec, getFields: ec, setValidateMessages: ec, setPreserve: ec, getInitialValue: ec };
      } });
      function Qb(Z) {
        return Z == null ? [] : Array.isArray(Z) ? Z : [Z];
      }
      var mn = { exports: {} };
      (function(Z) {
        var ve = function(J) {
          var ee = Object.prototype, te = ee.hasOwnProperty, ce, Ie = typeof Symbol == "function" ? Symbol : {}, Le = Ie.iterator || "@@iterator", De = Ie.asyncIterator || "@@asyncIterator", Ye = Ie.toStringTag || "@@toStringTag";
          function Ke(gr, Qn, Yn) {
            return Object.defineProperty(gr, Qn, { value: Yn, enumerable: true, configurable: true, writable: true }), gr[Qn];
          }
          try {
            Ke({}, "");
          } catch {
            Ke = function(gr, Qn, Yn) {
              return gr[Qn] = Yn;
            };
          }
          function pt(gr, Qn, Yn, ya) {
            var sa = Qn && Qn.prototype instanceof sr ? Qn : sr, Wi = Object.create(sa.prototype), xs = new qa(ya || []);
            return Wi._invoke = Ar(gr, Yn, xs), Wi;
          }
          J.wrap = pt;
          function Bt(gr, Qn, Yn) {
            try {
              return { type: "normal", arg: gr.call(Qn, Yn) };
            } catch (ya) {
              return { type: "throw", arg: ya };
            }
          }
          var qt = "suspendedStart", Yt = "suspendedYield", nn = "executing", ln = "completed", yr = {};
          function sr() {
          }
          function aa() {
          }
          function He() {
          }
          var Cn = {};
          Ke(Cn, Le, function() {
            return this;
          });
          var On = Object.getPrototypeOf, dr = On && On(On(ir([])));
          dr && dr !== ee && te.call(dr, Le) && (Cn = dr);
          var ur = He.prototype = sr.prototype = Object.create(Cn);
          aa.prototype = He, Ke(ur, "constructor", He), Ke(He, "constructor", aa), aa.displayName = Ke(He, Ye, "GeneratorFunction");
          function An(gr) {
            ["next", "throw", "return"].forEach(function(Qn) {
              Ke(gr, Qn, function(Yn) {
                return this._invoke(Qn, Yn);
              });
            });
          }
          J.isGeneratorFunction = function(gr) {
            var Qn = typeof gr == "function" && gr.constructor;
            return Qn ? Qn === aa || (Qn.displayName || Qn.name) === "GeneratorFunction" : false;
          }, J.mark = function(gr) {
            return Object.setPrototypeOf ? Object.setPrototypeOf(gr, He) : (gr.__proto__ = He, Ke(gr, Ye, "GeneratorFunction")), gr.prototype = Object.create(ur), gr;
          }, J.awrap = function(gr) {
            return { __await: gr };
          };
          function Nn(gr, Qn) {
            function Yn(Wi, xs, is, io) {
              var Ol = Bt(gr[Wi], gr, xs);
              if (Ol.type === "throw")
                io(Ol.arg);
              else {
                var os = Ol.arg, rl = os.value;
                return rl && typeof rl == "object" && te.call(rl, "__await") ? Qn.resolve(rl.__await).then(function(Cu) {
                  Yn("next", Cu, is, io);
                }, function(Cu) {
                  Yn("throw", Cu, is, io);
                }) : Qn.resolve(rl).then(function(Cu) {
                  os.value = Cu, is(os);
                }, function(Cu) {
                  return Yn("throw", Cu, is, io);
                });
              }
            }
            var ya;
            function sa(Wi, xs) {
              function is() {
                return new Qn(function(io, Ol) {
                  Yn(Wi, xs, io, Ol);
                });
              }
              return ya = ya ? ya.then(is, is) : is();
            }
            this._invoke = sa;
          }
          An(Nn.prototype), Ke(Nn.prototype, De, function() {
            return this;
          }), J.AsyncIterator = Nn, J.async = function(gr, Qn, Yn, ya, sa) {
            sa === void 0 && (sa = Promise);
            var Wi = new Nn(pt(gr, Qn, Yn, ya), sa);
            return J.isGeneratorFunction(Qn) ? Wi : Wi.next().then(function(xs) {
              return xs.done ? xs.value : Wi.next();
            });
          };
          function Ar(gr, Qn, Yn) {
            var ya = qt;
            return function(sa, Wi) {
              if (ya === nn)
                throw new Error("Generator is already running");
              if (ya === ln) {
                if (sa === "throw")
                  throw Wi;
                return Ai();
              }
              for (Yn.method = sa, Yn.arg = Wi; ; ) {
                var xs = Yn.delegate;
                if (xs) {
                  var is = Jr(xs, Yn);
                  if (is) {
                    if (is === yr)
                      continue;
                    return is;
                  }
                }
                if (Yn.method === "next")
                  Yn.sent = Yn._sent = Yn.arg;
                else if (Yn.method === "throw") {
                  if (ya === qt)
                    throw ya = ln, Yn.arg;
                  Yn.dispatchException(Yn.arg);
                } else
                  Yn.method === "return" && Yn.abrupt("return", Yn.arg);
                ya = nn;
                var io = Bt(gr, Qn, Yn);
                if (io.type === "normal") {
                  if (ya = Yn.done ? ln : Yt, io.arg === yr)
                    continue;
                  return { value: io.arg, done: Yn.done };
                } else
                  io.type === "throw" && (ya = ln, Yn.method = "throw", Yn.arg = io.arg);
              }
            };
          }
          function Jr(gr, Qn) {
            var Yn = gr.iterator[Qn.method];
            if (Yn === ce) {
              if (Qn.delegate = null, Qn.method === "throw") {
                if (gr.iterator.return && (Qn.method = "return", Qn.arg = ce, Jr(gr, Qn), Qn.method === "throw"))
                  return yr;
                Qn.method = "throw", Qn.arg = new TypeError("The iterator does not provide a 'throw' method");
              }
              return yr;
            }
            var ya = Bt(Yn, gr.iterator, Qn.arg);
            if (ya.type === "throw")
              return Qn.method = "throw", Qn.arg = ya.arg, Qn.delegate = null, yr;
            var sa = ya.arg;
            if (!sa)
              return Qn.method = "throw", Qn.arg = new TypeError("iterator result is not an object"), Qn.delegate = null, yr;
            if (sa.done)
              Qn[gr.resultName] = sa.value, Qn.next = gr.nextLoc, Qn.method !== "return" && (Qn.method = "next", Qn.arg = ce);
            else
              return sa;
            return Qn.delegate = null, yr;
          }
          An(ur), Ke(ur, Ye, "Generator"), Ke(ur, Le, function() {
            return this;
          }), Ke(ur, "toString", function() {
            return "[object Generator]";
          });
          function bn(gr) {
            var Qn = { tryLoc: gr[0] };
            1 in gr && (Qn.catchLoc = gr[1]), 2 in gr && (Qn.finallyLoc = gr[2], Qn.afterLoc = gr[3]), this.tryEntries.push(Qn);
          }
          function Xa(gr) {
            var Qn = gr.completion || {};
            Qn.type = "normal", delete Qn.arg, gr.completion = Qn;
          }
          function qa(gr) {
            this.tryEntries = [{ tryLoc: "root" }], gr.forEach(bn, this), this.reset(true);
          }
          J.keys = function(gr) {
            var Qn = [];
            for (var Yn in gr)
              Qn.push(Yn);
            return Qn.reverse(), function ya() {
              for (; Qn.length; ) {
                var sa = Qn.pop();
                if (sa in gr)
                  return ya.value = sa, ya.done = false, ya;
              }
              return ya.done = true, ya;
            };
          };
          function ir(gr) {
            if (gr) {
              var Qn = gr[Le];
              if (Qn)
                return Qn.call(gr);
              if (typeof gr.next == "function")
                return gr;
              if (!isNaN(gr.length)) {
                var Yn = -1, ya = function sa() {
                  for (; ++Yn < gr.length; )
                    if (te.call(gr, Yn))
                      return sa.value = gr[Yn], sa.done = false, sa;
                  return sa.value = ce, sa.done = true, sa;
                };
                return ya.next = ya;
              }
            }
            return { next: Ai };
          }
          J.values = ir;
          function Ai() {
            return { value: ce, done: true };
          }
          return qa.prototype = { constructor: qa, reset: function(gr) {
            if (this.prev = 0, this.next = 0, this.sent = this._sent = ce, this.done = false, this.delegate = null, this.method = "next", this.arg = ce, this.tryEntries.forEach(Xa), !gr)
              for (var Qn in this)
                Qn.charAt(0) === "t" && te.call(this, Qn) && !isNaN(+Qn.slice(1)) && (this[Qn] = ce);
          }, stop: function() {
            this.done = true;
            var gr = this.tryEntries[0], Qn = gr.completion;
            if (Qn.type === "throw")
              throw Qn.arg;
            return this.rval;
          }, dispatchException: function(gr) {
            if (this.done)
              throw gr;
            var Qn = this;
            function Yn(io, Ol) {
              return Wi.type = "throw", Wi.arg = gr, Qn.next = io, Ol && (Qn.method = "next", Qn.arg = ce), !!Ol;
            }
            for (var ya = this.tryEntries.length - 1; ya >= 0; --ya) {
              var sa = this.tryEntries[ya], Wi = sa.completion;
              if (sa.tryLoc === "root")
                return Yn("end");
              if (sa.tryLoc <= this.prev) {
                var xs = te.call(sa, "catchLoc"), is = te.call(sa, "finallyLoc");
                if (xs && is) {
                  if (this.prev < sa.catchLoc)
                    return Yn(sa.catchLoc, true);
                  if (this.prev < sa.finallyLoc)
                    return Yn(sa.finallyLoc);
                } else if (xs) {
                  if (this.prev < sa.catchLoc)
                    return Yn(sa.catchLoc, true);
                } else if (is) {
                  if (this.prev < sa.finallyLoc)
                    return Yn(sa.finallyLoc);
                } else
                  throw new Error("try statement without catch or finally");
              }
            }
          }, abrupt: function(gr, Qn) {
            for (var Yn = this.tryEntries.length - 1; Yn >= 0; --Yn) {
              var ya = this.tryEntries[Yn];
              if (ya.tryLoc <= this.prev && te.call(ya, "finallyLoc") && this.prev < ya.finallyLoc) {
                var sa = ya;
                break;
              }
            }
            sa && (gr === "break" || gr === "continue") && sa.tryLoc <= Qn && Qn <= sa.finallyLoc && (sa = null);
            var Wi = sa ? sa.completion : {};
            return Wi.type = gr, Wi.arg = Qn, sa ? (this.method = "next", this.next = sa.finallyLoc, yr) : this.complete(Wi);
          }, complete: function(gr, Qn) {
            if (gr.type === "throw")
              throw gr.arg;
            return gr.type === "break" || gr.type === "continue" ? this.next = gr.arg : gr.type === "return" ? (this.rval = this.arg = gr.arg, this.method = "return", this.next = "end") : gr.type === "normal" && Qn && (this.next = Qn), yr;
          }, finish: function(gr) {
            for (var Qn = this.tryEntries.length - 1; Qn >= 0; --Qn) {
              var Yn = this.tryEntries[Qn];
              if (Yn.finallyLoc === gr)
                return this.complete(Yn.completion, Yn.afterLoc), Xa(Yn), yr;
            }
          }, catch: function(gr) {
            for (var Qn = this.tryEntries.length - 1; Qn >= 0; --Qn) {
              var Yn = this.tryEntries[Qn];
              if (Yn.tryLoc === gr) {
                var ya = Yn.completion;
                if (ya.type === "throw") {
                  var sa = ya.arg;
                  Xa(Yn);
                }
                return sa;
              }
            }
            throw new Error("illegal catch attempt");
          }, delegateYield: function(gr, Qn, Yn) {
            return this.delegate = { iterator: ir(gr), resultName: Qn, nextLoc: Yn }, this.method === "next" && (this.arg = ce), yr;
          } }, J;
        }(Z.exports);
        try {
          regeneratorRuntime = ve;
        } catch {
          typeof globalThis == "object" ? globalThis.regeneratorRuntime = ve : Function("r", "regeneratorRuntime = r")(ve);
        }
      })(mn);
      var Sr = mn.exports;
      function ar(Z, ve, J, ee, te, ce, Ie) {
        try {
          var Le = Z[ce](Ie), De = Le.value;
        } catch (Ye) {
          J(Ye);
          return;
        }
        Le.done ? ve(De) : Promise.resolve(De).then(ee, te);
      }
      function ai(Z) {
        return function() {
          var ve = this, J = arguments;
          return new Promise(function(ee, te) {
            var ce = Z.apply(ve, J);
            function Ie(De) {
              ar(ce, ee, te, Ie, Le, "next", De);
            }
            function Le(De) {
              ar(ce, ee, te, Ie, Le, "throw", De);
            }
            Ie(void 0);
          });
        };
      }
      function ro() {
        return ro = Object.assign || function(Z) {
          for (var ve = 1; ve < arguments.length; ve++) {
            var J = arguments[ve];
            for (var ee in J)
              Object.prototype.hasOwnProperty.call(J, ee) && (Z[ee] = J[ee]);
          }
          return Z;
        }, ro.apply(this, arguments);
      }
      function Pl(Z, ve) {
        Z.prototype = Object.create(ve.prototype), Z.prototype.constructor = Z, Ll(Z, ve);
      }
      function Qc(Z) {
        return Qc = Object.setPrototypeOf ? Object.getPrototypeOf : function(ve) {
          return ve.__proto__ || Object.getPrototypeOf(ve);
        }, Qc(Z);
      }
      function Ll(Z, ve) {
        return Ll = Object.setPrototypeOf || function(J, ee) {
          return J.__proto__ = ee, J;
        }, Ll(Z, ve);
      }
      function a6() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function tk(Z, ve, J) {
        return a6() ? tk = Reflect.construct : tk = function(ee, te, ce) {
          var Ie = [null];
          Ie.push.apply(Ie, te);
          var Le = Function.bind.apply(ee, Ie), De = new Le();
          return ce && Ll(De, ce.prototype), De;
        }, tk.apply(null, arguments);
      }
      function gg(Z) {
        return Function.toString.call(Z).indexOf("[native code]") !== -1;
      }
      function ES(Z) {
        var ve = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
        return ES = function(J) {
          if (J === null || !gg(J))
            return J;
          if (typeof J != "function")
            throw new TypeError("Super expression must either be null or a function");
          if (typeof ve != "undefined") {
            if (ve.has(J))
              return ve.get(J);
            ve.set(J, ee);
          }
          function ee() {
            return tk(J, arguments, Qc(this).constructor);
          }
          return ee.prototype = Object.create(J.prototype, { constructor: { value: ee, enumerable: false, writable: true, configurable: true } }), Ll(ee, J);
        }, ES(Z);
      }
      var ZQ = /%[sdj%]/g, IS = function() {
      };
      typeof process != "undefined" && process.env;
      function TS(Z) {
        if (!Z || !Z.length)
          return null;
        var ve = {};
        return Z.forEach(function(J) {
          var ee = J.field;
          ve[ee] = ve[ee] || [], ve[ee].push(J);
        }), ve;
      }
      function yd(Z) {
        for (var ve = arguments.length, J = new Array(ve > 1 ? ve - 1 : 0), ee = 1; ee < ve; ee++)
          J[ee - 1] = arguments[ee];
        var te = 0, ce = J.length;
        if (typeof Z == "function")
          return Z.apply(null, J);
        if (typeof Z == "string") {
          var Ie = Z.replace(ZQ, function(Le) {
            if (Le === "%%")
              return "%";
            if (te >= ce)
              return Le;
            switch (Le) {
              case "%s":
                return String(J[te++]);
              case "%d":
                return Number(J[te++]);
              case "%j":
                try {
                  return JSON.stringify(J[te++]);
                } catch {
                  return "[Circular]";
                }
                break;
              default:
                return Le;
            }
          });
          return Ie;
        }
        return Z;
      }
      function Ql(Z) {
        return Z === "string" || Z === "url" || Z === "hex" || Z === "email" || Z === "date" || Z === "pattern";
      }
      function Ff(Z, ve) {
        return !!(Z == null || ve === "array" && Array.isArray(Z) && !Z.length || Ql(ve) && typeof Z == "string" && !Z);
      }
      function $B(Z, ve, J) {
        var ee = [], te = 0, ce = Z.length;
        function Ie(Le) {
          ee.push.apply(ee, Le || []), te++, te === ce && J(ee);
        }
        Z.forEach(function(Le) {
          ve(Le, Ie);
        });
      }
      function QA(Z, ve, J) {
        var ee = 0, te = Z.length;
        function ce(Ie) {
          if (Ie && Ie.length) {
            J(Ie);
            return;
          }
          var Le = ee;
          ee = ee + 1, Le < te ? ve(Z[Le], ce) : J([]);
        }
        ce([]);
      }
      function XQ(Z) {
        var ve = [];
        return Object.keys(Z).forEach(function(J) {
          ve.push.apply(ve, Z[J] || []);
        }), ve;
      }
      var UB = function(Z) {
        Pl(ve, Z);
        function ve(J, ee) {
          var te;
          return te = Z.call(this, "Async Validation Error") || this, te.errors = J, te.fields = ee, te;
        }
        return ve;
      }(ES(Error));
      function KQ(Z, ve, J, ee, te) {
        if (ve.first) {
          var ce = new Promise(function(Bt, qt) {
            var Yt = function(ln) {
              return ee(ln), ln.length ? qt(new UB(ln, TS(ln))) : Bt(te);
            }, nn = XQ(Z);
            QA(nn, J, Yt);
          });
          return ce.catch(function(Bt) {
            return Bt;
          }), ce;
        }
        var Ie = ve.firstFields === true ? Object.keys(Z) : ve.firstFields || [], Le = Object.keys(Z), De = Le.length, Ye = 0, Ke = [], pt = new Promise(function(Bt, qt) {
          var Yt = function(nn) {
            if (Ke.push.apply(Ke, nn), Ye++, Ye === De)
              return ee(Ke), Ke.length ? qt(new UB(Ke, TS(Ke))) : Bt(te);
          };
          Le.length || (ee(Ke), Bt(te)), Le.forEach(function(nn) {
            var ln = Z[nn];
            Ie.indexOf(nn) !== -1 ? QA(ln, J, Yt) : $B(ln, J, Yt);
          });
        });
        return pt.catch(function(Bt) {
          return Bt;
        }), pt;
      }
      function nk(Z) {
        return !!(Z && Z.message !== void 0);
      }
      function e_(Z, ve) {
        for (var J = Z, ee = 0; ee < ve.length; ee++) {
          if (J == null)
            return J;
          J = J[ve[ee]];
        }
        return J;
      }
      function eE(Z, ve) {
        return function(J) {
          var ee;
          return Z.fullFields ? ee = e_(ve, Z.fullFields) : ee = ve[J.field || Z.fullField], nk(J) ? (J.field = J.field || Z.fullField, J.fieldValue = ee, J) : { message: typeof J == "function" ? J() : J, fieldValue: ee, field: J.field || Z.fullField };
        };
      }
      function i6(Z, ve) {
        if (ve) {
          for (var J in ve)
            if (ve.hasOwnProperty(J)) {
              var ee = ve[J];
              typeof ee == "object" && typeof Z[J] == "object" ? Z[J] = ro({}, Z[J], ee) : Z[J] = ee;
            }
        }
        return Z;
      }
      var tE = function(Z, ve, J, ee, te, ce) {
        Z.required && (!J.hasOwnProperty(Z.field) || Ff(ve, ce || Z.type)) && ee.push(yd(te.messages.required, Z.fullField));
      }, qB = function(Z, ve, J, ee, te) {
        (/^\s+$/.test(ve) || ve === "") && ee.push(yd(te.messages.whitespace, Z.fullField));
      }, rk = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, t_ = { integer: function(Z) {
        return t_.number(Z) && parseInt(Z, 10) === Z;
      }, float: function(Z) {
        return t_.number(Z) && !t_.integer(Z);
      }, array: function(Z) {
        return Array.isArray(Z);
      }, regexp: function(Z) {
        if (Z instanceof RegExp)
          return true;
        try {
          return !!new RegExp(Z);
        } catch {
          return false;
        }
      }, date: function(Z) {
        return typeof Z.getTime == "function" && typeof Z.getMonth == "function" && typeof Z.getYear == "function" && !isNaN(Z.getTime());
      }, number: function(Z) {
        return isNaN(Z) ? false : typeof Z == "number";
      }, object: function(Z) {
        return typeof Z == "object" && !t_.array(Z);
      }, method: function(Z) {
        return typeof Z == "function";
      }, email: function(Z) {
        return typeof Z == "string" && Z.length <= 320 && !!Z.match(rk.email);
      }, url: function(Z) {
        return typeof Z == "string" && Z.length <= 2048 && !!Z.match(rk.url);
      }, hex: function(Z) {
        return typeof Z == "string" && !!Z.match(rk.hex);
      } }, YB = function(Z, ve, J, ee, te) {
        if (Z.required && ve === void 0) {
          tE(Z, ve, J, ee, te);
          return;
        }
        var ce = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], Ie = Z.type;
        ce.indexOf(Ie) > -1 ? t_[Ie](ve) || ee.push(yd(te.messages.types[Ie], Z.fullField, Z.type)) : Ie && typeof ve !== Z.type && ee.push(yd(te.messages.types[Ie], Z.fullField, Z.type));
      }, nE = function(Z, ve, J, ee, te) {
        var ce = typeof Z.len == "number", Ie = typeof Z.min == "number", Le = typeof Z.max == "number", De = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, Ye = ve, Ke = null, pt = typeof ve == "number", Bt = typeof ve == "string", qt = Array.isArray(ve);
        if (pt ? Ke = "number" : Bt ? Ke = "string" : qt && (Ke = "array"), !Ke)
          return false;
        qt && (Ye = ve.length), Bt && (Ye = ve.replace(De, "_").length), ce ? Ye !== Z.len && ee.push(yd(te.messages[Ke].len, Z.fullField, Z.len)) : Ie && !Le && Ye < Z.min ? ee.push(yd(te.messages[Ke].min, Z.fullField, Z.min)) : Le && !Ie && Ye > Z.max ? ee.push(yd(te.messages[Ke].max, Z.fullField, Z.max)) : Ie && Le && (Ye < Z.min || Ye > Z.max) && ee.push(yd(te.messages[Ke].range, Z.fullField, Z.min, Z.max));
      }, mg = "enum", ak = function(Z, ve, J, ee, te) {
        Z[mg] = Array.isArray(Z[mg]) ? Z[mg] : [], Z[mg].indexOf(ve) === -1 && ee.push(yd(te.messages[mg], Z.fullField, Z[mg].join(", ")));
      }, JQ = function(Z, ve, J, ee, te) {
        if (Z.pattern) {
          if (Z.pattern instanceof RegExp)
            Z.pattern.lastIndex = 0, Z.pattern.test(ve) || ee.push(yd(te.messages.pattern.mismatch, Z.fullField, ve, Z.pattern));
          else if (typeof Z.pattern == "string") {
            var ce = new RegExp(Z.pattern);
            ce.test(ve) || ee.push(yd(te.messages.pattern.mismatch, Z.fullField, ve, Z.pattern));
          }
        }
      }, nl = { required: tE, whitespace: qB, type: YB, range: nE, enum: ak, pattern: JQ }, QQ = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve, "string") && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te, "string"), Ff(ve, "string") || (nl.type(Z, ve, ee, ce, te), nl.range(Z, ve, ee, ce, te), nl.pattern(Z, ve, ee, ce, te), Z.whitespace === true && nl.whitespace(Z, ve, ee, ce, te));
        }
        J(ce);
      }, ik = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && nl.type(Z, ve, ee, ce, te);
        }
        J(ce);
      }, ok = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (ve === "" && (ve = void 0), Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && (nl.type(Z, ve, ee, ce, te), nl.range(Z, ve, ee, ce, te));
        }
        J(ce);
      }, o6 = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && nl.type(Z, ve, ee, ce, te);
        }
        J(ce);
      }, eee = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), Ff(ve) || nl.type(Z, ve, ee, ce, te);
        }
        J(ce);
      }, ZB = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && (nl.type(Z, ve, ee, ce, te), nl.range(Z, ve, ee, ce, te));
        }
        J(ce);
      }, tee = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && (nl.type(Z, ve, ee, ce, te), nl.range(Z, ve, ee, ce, te));
        }
        J(ce);
      }, nee = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (ve == null && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te, "array"), ve != null && (nl.type(Z, ve, ee, ce, te), nl.range(Z, ve, ee, ce, te));
        }
        J(ce);
      }, Nf = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && nl.type(Z, ve, ee, ce, te);
        }
        J(ce);
      }, bd = "enum", ree = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), ve !== void 0 && nl[bd](Z, ve, ee, ce, te);
        }
        J(ce);
      }, aee = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve, "string") && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te), Ff(ve, "string") || nl.pattern(Z, ve, ee, ce, te);
        }
        J(ce);
      }, XB = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve, "date") && !Z.required)
            return J();
          if (nl.required(Z, ve, ee, ce, te), !Ff(ve, "date")) {
            var Le;
            ve instanceof Date ? Le = ve : Le = new Date(ve), nl.type(Z, Le, ee, ce, te), Le && nl.range(Z, Le.getTime(), ee, ce, te);
          }
        }
        J(ce);
      }, iee = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Array.isArray(ve) ? "array" : typeof ve;
        nl.required(Z, ve, ee, ce, te, Ie), J(ce);
      }, rE = function(Z, ve, J, ee, te) {
        var ce = Z.type, Ie = [], Le = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Le) {
          if (Ff(ve, ce) && !Z.required)
            return J();
          nl.required(Z, ve, ee, Ie, te, ce), Ff(ve, ce) || nl.type(Z, ve, ee, Ie, te);
        }
        J(Ie);
      }, aE = function(Z, ve, J, ee, te) {
        var ce = [], Ie = Z.required || !Z.required && ee.hasOwnProperty(Z.field);
        if (Ie) {
          if (Ff(ve) && !Z.required)
            return J();
          nl.required(Z, ve, ee, ce, te);
        }
        J(ce);
      }, aw = { string: QQ, method: ik, number: ok, boolean: o6, regexp: eee, integer: ZB, float: tee, array: nee, object: Nf, enum: ree, pattern: aee, date: XB, url: rE, hex: rE, email: rE, required: iee, any: aE };
      function n_() {
        return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
          var Z = JSON.parse(JSON.stringify(this));
          return Z.clone = this.clone, Z;
        } };
      }
      var iw = n_(), b1 = function() {
        function Z(J) {
          this.rules = null, this._messages = iw, this.define(J);
        }
        var ve = Z.prototype;
        return ve.define = function(J) {
          var ee = this;
          if (!J)
            throw new Error("Cannot configure a schema with no rules");
          if (typeof J != "object" || Array.isArray(J))
            throw new Error("Rules must be an object");
          this.rules = {}, Object.keys(J).forEach(function(te) {
            var ce = J[te];
            ee.rules[te] = Array.isArray(ce) ? ce : [ce];
          });
        }, ve.messages = function(J) {
          return J && (this._messages = i6(n_(), J)), this._messages;
        }, ve.validate = function(J, ee, te) {
          var ce = this;
          ee === void 0 && (ee = {}), te === void 0 && (te = function() {
          });
          var Ie = J, Le = ee, De = te;
          if (typeof Le == "function" && (De = Le, Le = {}), !this.rules || Object.keys(this.rules).length === 0)
            return De && De(null, Ie), Promise.resolve(Ie);
          function Ye(Yt) {
            var nn = [], ln = {};
            function yr(aa) {
              if (Array.isArray(aa)) {
                var He;
                nn = (He = nn).concat.apply(He, aa);
              } else
                nn.push(aa);
            }
            for (var sr = 0; sr < Yt.length; sr++)
              yr(Yt[sr]);
            nn.length ? (ln = TS(nn), De(nn, ln)) : De(null, Ie);
          }
          if (Le.messages) {
            var Ke = this.messages();
            Ke === iw && (Ke = n_()), i6(Ke, Le.messages), Le.messages = Ke;
          } else
            Le.messages = this.messages();
          var pt = {}, Bt = Le.keys || Object.keys(this.rules);
          Bt.forEach(function(Yt) {
            var nn = ce.rules[Yt], ln = Ie[Yt];
            nn.forEach(function(yr) {
              var sr = yr;
              typeof sr.transform == "function" && (Ie === J && (Ie = ro({}, Ie)), ln = Ie[Yt] = sr.transform(ln)), typeof sr == "function" ? sr = { validator: sr } : sr = ro({}, sr), sr.validator = ce.getValidationMethod(sr), sr.validator && (sr.field = Yt, sr.fullField = sr.fullField || Yt, sr.type = ce.getType(sr), pt[Yt] = pt[Yt] || [], pt[Yt].push({ rule: sr, value: ln, source: Ie, field: Yt }));
            });
          });
          var qt = {};
          return KQ(pt, Le, function(Yt, nn) {
            var ln = Yt.rule, yr = (ln.type === "object" || ln.type === "array") && (typeof ln.fields == "object" || typeof ln.defaultField == "object");
            yr = yr && (ln.required || !ln.required && Yt.value), ln.field = Yt.field;
            function sr(Cn, On) {
              return ro({}, On, { fullField: ln.fullField + "." + Cn, fullFields: ln.fullFields ? [].concat(ln.fullFields, [Cn]) : [Cn] });
            }
            function aa(Cn) {
              Cn === void 0 && (Cn = []);
              var On = Array.isArray(Cn) ? Cn : [Cn];
              !Le.suppressWarning && On.length && Z.warning("async-validator:", On), On.length && ln.message !== void 0 && (On = [].concat(ln.message));
              var dr = On.map(eE(ln, Ie));
              if (Le.first && dr.length)
                return qt[ln.field] = 1, nn(dr);
              if (!yr)
                nn(dr);
              else {
                if (ln.required && !Yt.value)
                  return ln.message !== void 0 ? dr = [].concat(ln.message).map(eE(ln, Ie)) : Le.error && (dr = [Le.error(ln, yd(Le.messages.required, ln.field))]), nn(dr);
                var ur = {};
                ln.defaultField && Object.keys(Yt.value).map(function(Ar) {
                  ur[Ar] = ln.defaultField;
                }), ur = ro({}, ur, Yt.rule.fields);
                var An = {};
                Object.keys(ur).forEach(function(Ar) {
                  var Jr = ur[Ar], bn = Array.isArray(Jr) ? Jr : [Jr];
                  An[Ar] = bn.map(sr.bind(null, Ar));
                });
                var Nn = new Z(An);
                Nn.messages(Le.messages), Yt.rule.options && (Yt.rule.options.messages = Le.messages, Yt.rule.options.error = Le.error), Nn.validate(Yt.value, Yt.rule.options || Le, function(Ar) {
                  var Jr = [];
                  dr && dr.length && Jr.push.apply(Jr, dr), Ar && Ar.length && Jr.push.apply(Jr, Ar), nn(Jr.length ? Jr : null);
                });
              }
            }
            var He;
            ln.asyncValidator ? He = ln.asyncValidator(ln, Yt.value, aa, Yt.source, Le) : ln.validator && (He = ln.validator(ln, Yt.value, aa, Yt.source, Le), He === true ? aa() : He === false ? aa(typeof ln.message == "function" ? ln.message(ln.fullField || ln.field) : ln.message || (ln.fullField || ln.field) + " fails") : He instanceof Array ? aa(He) : He instanceof Error && aa(He.message)), He && He.then && He.then(function() {
              return aa();
            }, function(Cn) {
              return aa(Cn);
            });
          }, function(Yt) {
            Ye(Yt);
          }, Ie);
        }, ve.getType = function(J) {
          if (J.type === void 0 && J.pattern instanceof RegExp && (J.type = "pattern"), typeof J.validator != "function" && J.type && !aw.hasOwnProperty(J.type))
            throw new Error(yd("Unknown rule type %s", J.type));
          return J.type || "string";
        }, ve.getValidationMethod = function(J) {
          if (typeof J.validator == "function")
            return J.validator;
          var ee = Object.keys(J), te = ee.indexOf("message");
          return te !== -1 && ee.splice(te, 1), ee.length === 1 && ee[0] === "required" ? aw.required : aw[this.getType(J)] || void 0;
        }, Z;
      }();
      b1.register = function(Z, ve) {
        if (typeof ve != "function")
          throw new Error("Cannot register a validator by type, validator is not a function");
        aw[Z] = ve;
      }, b1.warning = IS, b1.messages = iw, b1.validators = aw;
      var _d = "'${name}' is not a valid ${type}", ow = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: _d, method: _d, array: _d, object: _d, number: _d, date: _d, boolean: _d, integer: _d, float: _d, regexp: _d, email: _d, url: _d, hex: _d }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
      function KB(Z, ve) {
        for (var J = Z, ee = 0; ee < ve.length; ee += 1) {
          if (J == null)
            return;
          J = J[ve[ee]];
        }
        return J;
      }
      function oee(Z) {
        return lr(Z) || r62(Z) || di(Z) || as();
      }
      function JB(Z, ve, J, ee) {
        if (!ve.length)
          return J;
        var te = oee(ve), ce = te[0], Ie = te.slice(1), Le;
        return !Z && typeof ce == "number" ? Le = [] : Array.isArray(Z) ? Le = ul(Z) : Le = Pn({}, Z), ee && J === void 0 && Ie.length === 1 ? delete Le[ce][Ie[0]] : Le[ce] = JB(Le[ce], Ie, J, ee), Le;
      }
      function see(Z, ve, J) {
        var ee = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
        return ve.length && ee && J === void 0 && !KB(Z, ve.slice(0, -1)) ? Z : JB(Z, ve, J, ee);
      }
      function _f(Z) {
        return Qb(Z);
      }
      function _1(Z, ve) {
        var J = KB(Z, ve);
        return J;
      }
      function S0(Z, ve, J) {
        var ee = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, te = see(Z, ve, J, ee);
        return te;
      }
      function s6(Z, ve) {
        var J = {};
        return ve.forEach(function(ee) {
          var te = _1(Z, ee);
          J = S0(J, ee, te);
        }), J;
      }
      function it(Z, ve) {
        return Z && Z.some(function(J) {
          return Us(J, ve);
        });
      }
      function sw(Z) {
        return Mi(Z) === "object" && Z !== null && Object.getPrototypeOf(Z) === Object.prototype;
      }
      function iE(Z, ve) {
        var J = Array.isArray(Z) ? ul(Z) : Pn({}, Z);
        return ve && Object.keys(ve).forEach(function(ee) {
          var te = J[ee], ce = ve[ee], Ie = sw(te) && sw(ce);
          J[ee] = Ie ? iE(te, ce || {}) : ce;
        }), J;
      }
      function up(Z) {
        for (var ve = arguments.length, J = new Array(ve > 1 ? ve - 1 : 0), ee = 1; ee < ve; ee++)
          J[ee - 1] = arguments[ee];
        return J.reduce(function(te, ce) {
          return iE(te, ce);
        }, Z);
      }
      function Us(Z, ve) {
        return !Z || !ve || Z.length !== ve.length ? false : Z.every(function(J, ee) {
          return ve[ee] === J;
        });
      }
      function lee(Z, ve) {
        if (Z === ve)
          return true;
        if (!Z && ve || Z && !ve || !Z || !ve || Mi(Z) !== "object" || Mi(ve) !== "object")
          return false;
        var J = Object.keys(Z), ee = Object.keys(ve), te = new Set([].concat(ul(J), ul(ee)));
        return ul(te).every(function(ce) {
          var Ie = Z[ce], Le = ve[ce];
          return typeof Ie == "function" && typeof Le == "function" ? true : Ie === Le;
        });
      }
      function uee(Z) {
        var ve = arguments.length <= 1 ? void 0 : arguments[1];
        return ve && ve.target && Mi(ve.target) === "object" && Z in ve.target ? ve.target[Z] : ve;
      }
      function QB(Z, ve, J) {
        var ee = Z.length;
        if (ve < 0 || ve >= ee || J < 0 || J >= ee)
          return Z;
        var te = Z[ve], ce = ve - J;
        return ce > 0 ? [].concat(ul(Z.slice(0, J)), [te], ul(Z.slice(J, ve)), ul(Z.slice(ve + 1, ee))) : ce < 0 ? [].concat(ul(Z.slice(0, ve)), ul(Z.slice(ve + 1, J + 1)), [te], ul(Z.slice(J + 1, ee))) : Z;
      }
      var lw = b1;
      function cee(Z, ve) {
        return Z.replace(/\$\{\w+\}/g, function(J) {
          var ee = J.slice(2, -1);
          return ve[ee];
        });
      }
      function l6(Z, ve, J, ee, te) {
        return u6.apply(this, arguments);
      }
      function u6() {
        return u6 = ai(Sr.mark(function Z(ve, J, ee, te, ce) {
          var Ie, Le, De, Ye, Ke, pt, Bt, qt;
          return Sr.wrap(function(Yt) {
            for (; ; )
              switch (Yt.prev = Yt.next) {
                case 0:
                  return Ie = Pn({}, ee), delete Ie.ruleIndex, Le = null, Ie && Ie.type === "array" && Ie.defaultField && (Le = Ie.defaultField, delete Ie.defaultField), De = new lw(_t({}, ve, [Ie])), Ye = up({}, ow, te.validateMessages), De.messages(Ye), Ke = [], Yt.prev = 8, Yt.next = 11, Promise.resolve(De.validate(_t({}, ve, J), Pn({}, te)));
                case 11:
                  Yt.next = 16;
                  break;
                case 13:
                  Yt.prev = 13, Yt.t0 = Yt.catch(8), Yt.t0.errors ? Ke = Yt.t0.errors.map(function(nn, ln) {
                    var yr = nn.message;
                    return M.isValidElement(yr) ? M.cloneElement(yr, { key: "error_".concat(ln) }) : yr;
                  }) : (console.error(Yt.t0), Ke = [Ye.default]);
                case 16:
                  if (!(!Ke.length && Le)) {
                    Yt.next = 21;
                    break;
                  }
                  return Yt.next = 19, Promise.all(J.map(function(nn, ln) {
                    return l6("".concat(ve, ".").concat(ln), nn, Le, te, ce);
                  }));
                case 19:
                  return pt = Yt.sent, Yt.abrupt("return", pt.reduce(function(nn, ln) {
                    return [].concat(ul(nn), ul(ln));
                  }, []));
                case 21:
                  return Bt = Pn(Pn({}, ee), {}, { name: ve, enum: (ee.enum || []).join(", ") }, ce), qt = Ke.map(function(nn) {
                    return typeof nn == "string" ? cee(nn, Bt) : nn;
                  }), Yt.abrupt("return", qt);
                case 24:
                case "end":
                  return Yt.stop();
              }
          }, Z, null, [[8, 13]]);
        })), u6.apply(this, arguments);
      }
      function fee(Z, ve, J, ee, te, ce) {
        var Ie = Z.join("."), Le = J.map(function(Ke, pt) {
          var Bt = Ke.validator, qt = Pn(Pn({}, Ke), {}, { ruleIndex: pt });
          return Bt && (qt.validator = function(Yt, nn, ln) {
            var yr = false, sr = function() {
              for (var He = arguments.length, Cn = new Array(He), On = 0; On < He; On++)
                Cn[On] = arguments[On];
              Promise.resolve().then(function() {
                Xm(!yr, "Your validator function has already return a promise. `callback` will be ignored."), yr || ln.apply(void 0, Cn);
              });
            }, aa = Bt(Yt, nn, sr);
            yr = aa && typeof aa.then == "function" && typeof aa.catch == "function", Xm(yr, "`callback` is deprecated. Please return a promise instead."), yr && aa.then(function() {
              ln();
            }).catch(function(He) {
              ln(He || " ");
            });
          }), qt;
        }).sort(function(Ke, pt) {
          var Bt = Ke.warningOnly, qt = Ke.ruleIndex, Yt = pt.warningOnly, nn = pt.ruleIndex;
          return !!Bt == !!Yt ? qt - nn : Bt ? 1 : -1;
        }), De;
        if (te === true)
          De = new Promise(function() {
            var Ke = ai(Sr.mark(function pt(Bt, qt) {
              var Yt, nn, ln;
              return Sr.wrap(function(yr) {
                for (; ; )
                  switch (yr.prev = yr.next) {
                    case 0:
                      Yt = 0;
                    case 1:
                      if (!(Yt < Le.length)) {
                        yr.next = 12;
                        break;
                      }
                      return nn = Le[Yt], yr.next = 5, l6(Ie, ve, nn, ee, ce);
                    case 5:
                      if (ln = yr.sent, !ln.length) {
                        yr.next = 9;
                        break;
                      }
                      return qt([{ errors: ln, rule: nn }]), yr.abrupt("return");
                    case 9:
                      Yt += 1, yr.next = 1;
                      break;
                    case 12:
                      Bt([]);
                    case 13:
                    case "end":
                      return yr.stop();
                  }
              }, pt);
            }));
            return function(pt, Bt) {
              return Ke.apply(this, arguments);
            };
          }());
        else {
          var Ye = Le.map(function(Ke) {
            return l6(Ie, ve, Ke, ee, ce).then(function(pt) {
              return { errors: pt, rule: Ke };
            });
          });
          De = (te ? dee(Ye) : hee(Ye)).then(function(Ke) {
            return Promise.reject(Ke);
          });
        }
        return De.catch(function(Ke) {
          return Ke;
        }), De;
      }
      function hee(Z) {
        return C0.apply(this, arguments);
      }
      function C0() {
        return C0 = ai(Sr.mark(function Z(ve) {
          return Sr.wrap(function(J) {
            for (; ; )
              switch (J.prev = J.next) {
                case 0:
                  return J.abrupt("return", Promise.all(ve).then(function(ee) {
                    var te, ce = (te = []).concat.apply(te, ul(ee));
                    return ce;
                  }));
                case 1:
                case "end":
                  return J.stop();
              }
          }, Z);
        })), C0.apply(this, arguments);
      }
      function dee(Z) {
        return c6.apply(this, arguments);
      }
      function c6() {
        return c6 = ai(Sr.mark(function Z(ve) {
          var J;
          return Sr.wrap(function(ee) {
            for (; ; )
              switch (ee.prev = ee.next) {
                case 0:
                  return J = 0, ee.abrupt("return", new Promise(function(te) {
                    ve.forEach(function(ce) {
                      ce.then(function(Ie) {
                        Ie.errors.length && te([Ie]), J += 1, J === ve.length && te([]);
                      });
                    });
                  }));
                case 2:
                case "end":
                  return ee.stop();
              }
          }, Z);
        })), c6.apply(this, arguments);
      }
      var pee = ["name"], yg = [];
      function ej(Z, ve, J, ee, te, ce) {
        return typeof Z == "function" ? Z(ve, J, "source" in ce ? { source: ce.source } : {}) : ee !== te;
      }
      var M0 = function(Z) {
        xS(J, Z);
        var ve = UA(J);
        function J(ee) {
          var te;
          if (HA(this, J), te = ve.call(this, ee), te.state = { resetCount: 0 }, te.cancelRegisterFunc = null, te.mounted = false, te.touched = false, te.dirty = false, te.validatePromise = null, te.prevValidating = void 0, te.errors = yg, te.warnings = yg, te.cancelRegister = function() {
            var De = te.props, Ye = De.preserve, Ke = De.isListField, pt = De.name;
            te.cancelRegisterFunc && te.cancelRegisterFunc(Ke, Ye, _f(pt)), te.cancelRegisterFunc = null;
          }, te.getNamePath = function() {
            var De = te.props, Ye = De.name, Ke = De.fieldContext, pt = Ke.prefixName, Bt = pt === void 0 ? [] : pt;
            return Ye !== void 0 ? [].concat(ul(Bt), ul(Ye)) : [];
          }, te.getRules = function() {
            var De = te.props, Ye = De.rules, Ke = Ye === void 0 ? [] : Ye, pt = De.fieldContext;
            return Ke.map(function(Bt) {
              return typeof Bt == "function" ? Bt(pt) : Bt;
            });
          }, te.refresh = function() {
            !te.mounted || te.setState(function(De) {
              var Ye = De.resetCount;
              return { resetCount: Ye + 1 };
            });
          }, te.triggerMetaEvent = function(De) {
            var Ye = te.props.onMetaChange;
            Ye == null || Ye(Pn(Pn({}, te.getMeta()), {}, { destroy: De }));
          }, te.onStoreChange = function(De, Ye, Ke) {
            var pt = te.props, Bt = pt.shouldUpdate, qt = pt.dependencies, Yt = qt === void 0 ? [] : qt, nn = pt.onReset, ln = Ke.store, yr = te.getNamePath(), sr = te.getValue(De), aa = te.getValue(ln), He = Ye && it(Ye, yr);
            switch (Ke.type === "valueUpdate" && Ke.source === "external" && sr !== aa && (te.touched = true, te.dirty = true, te.validatePromise = null, te.errors = yg, te.warnings = yg, te.triggerMetaEvent()), Ke.type) {
              case "reset":
                if (!Ye || He) {
                  te.touched = false, te.dirty = false, te.validatePromise = null, te.errors = yg, te.warnings = yg, te.triggerMetaEvent(), nn == null || nn(), te.refresh();
                  return;
                }
                break;
              case "remove": {
                if (Bt) {
                  te.reRender();
                  return;
                }
                break;
              }
              case "setField": {
                if (He) {
                  var Cn = Ke.data;
                  "touched" in Cn && (te.touched = Cn.touched), "validating" in Cn && !("originRCField" in Cn) && (te.validatePromise = Cn.validating ? Promise.resolve([]) : null), "errors" in Cn && (te.errors = Cn.errors || yg), "warnings" in Cn && (te.warnings = Cn.warnings || yg), te.dirty = true, te.triggerMetaEvent(), te.reRender();
                  return;
                }
                if (Bt && !yr.length && ej(Bt, De, ln, sr, aa, Ke)) {
                  te.reRender();
                  return;
                }
                break;
              }
              case "dependenciesUpdate": {
                var On = Yt.map(_f);
                if (On.some(function(dr) {
                  return it(Ke.relatedFields, dr);
                })) {
                  te.reRender();
                  return;
                }
                break;
              }
              default:
                if (He || (!Yt.length || yr.length || Bt) && ej(Bt, De, ln, sr, aa, Ke)) {
                  te.reRender();
                  return;
                }
                break;
            }
            Bt === true && te.reRender();
          }, te.validateRules = function(De) {
            var Ye = te.getNamePath(), Ke = te.getValue(), pt = Promise.resolve().then(function() {
              if (!te.mounted)
                return [];
              var Bt = te.props, qt = Bt.validateFirst, Yt = qt === void 0 ? false : qt, nn = Bt.messageVariables, ln = De || {}, yr = ln.triggerName, sr = te.getRules();
              yr && (sr = sr.filter(function(He) {
                var Cn = He.validateTrigger;
                if (!Cn)
                  return true;
                var On = Qb(Cn);
                return On.includes(yr);
              }));
              var aa = fee(Ye, Ke, sr, De, Yt, nn);
              return aa.catch(function(He) {
                return He;
              }).then(function() {
                var He = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : yg;
                if (te.validatePromise === pt) {
                  te.validatePromise = null;
                  var Cn = [], On = [];
                  He.forEach(function(dr) {
                    var ur = dr.rule.warningOnly, An = dr.errors, Nn = An === void 0 ? yg : An;
                    ur ? On.push.apply(On, ul(Nn)) : Cn.push.apply(Cn, ul(Nn));
                  }), te.errors = Cn, te.warnings = On, te.triggerMetaEvent(), te.reRender();
                }
              }), aa;
            });
            return te.validatePromise = pt, te.dirty = true, te.errors = yg, te.warnings = yg, te.triggerMetaEvent(), te.reRender(), pt;
          }, te.isFieldValidating = function() {
            return !!te.validatePromise;
          }, te.isFieldTouched = function() {
            return te.touched;
          }, te.isFieldDirty = function() {
            if (te.dirty || te.props.initialValue !== void 0)
              return true;
            var De = te.props.fieldContext, Ye = De.getInternalHooks(AS), Ke = Ye.getInitialValue;
            return Ke(te.getNamePath()) !== void 0;
          }, te.getErrors = function() {
            return te.errors;
          }, te.getWarnings = function() {
            return te.warnings;
          }, te.isListField = function() {
            return te.props.isListField;
          }, te.isList = function() {
            return te.props.isList;
          }, te.isPreserve = function() {
            return te.props.preserve;
          }, te.getMeta = function() {
            te.prevValidating = te.isFieldValidating();
            var De = { touched: te.isFieldTouched(), validating: te.prevValidating, errors: te.errors, warnings: te.warnings, name: te.getNamePath() };
            return De;
          }, te.getOnlyChild = function(De) {
            if (typeof De == "function") {
              var Ye = te.getMeta();
              return Pn(Pn({}, te.getOnlyChild(De(te.getControlled(), Ye, te.props.fieldContext))), {}, { isFunction: true });
            }
            var Ke = CS(De);
            return Ke.length !== 1 || !M.isValidElement(Ke[0]) ? { child: Ke, isFunction: false } : { child: Ke[0], isFunction: false };
          }, te.getValue = function(De) {
            var Ye = te.props.fieldContext.getFieldsValue, Ke = te.getNamePath();
            return _1(De || Ye(true), Ke);
          }, te.getControlled = function() {
            var De = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Ye = te.props, Ke = Ye.trigger, pt = Ye.validateTrigger, Bt = Ye.getValueFromEvent, qt = Ye.normalize, Yt = Ye.valuePropName, nn = Ye.getValueProps, ln = Ye.fieldContext, yr = pt !== void 0 ? pt : ln.validateTrigger, sr = te.getNamePath(), aa = ln.getInternalHooks, He = ln.getFieldsValue, Cn = aa(AS), On = Cn.dispatch, dr = te.getValue(), ur = nn || function(Jr) {
              return _t({}, Yt, Jr);
            }, An = De[Ke], Nn = Pn(Pn({}, De), ur(dr));
            Nn[Ke] = function() {
              te.touched = true, te.dirty = true, te.triggerMetaEvent();
              for (var Jr, bn = arguments.length, Xa = new Array(bn), qa = 0; qa < bn; qa++)
                Xa[qa] = arguments[qa];
              Bt ? Jr = Bt.apply(void 0, Xa) : Jr = uee.apply(void 0, [Yt].concat(Xa)), qt && (Jr = qt(Jr, dr, He(true))), On({ type: "updateValue", namePath: sr, value: Jr }), An && An.apply(void 0, Xa);
            };
            var Ar = Qb(yr || []);
            return Ar.forEach(function(Jr) {
              var bn = Nn[Jr];
              Nn[Jr] = function() {
                bn && bn.apply(void 0, arguments);
                var Xa = te.props.rules;
                Xa && Xa.length && On({ type: "validateField", namePath: sr, triggerName: Jr });
              };
            }), Nn;
          }, ee.fieldContext) {
            var ce = ee.fieldContext.getInternalHooks, Ie = ce(AS), Le = Ie.initEntityValue;
            Le(Y5(te));
          }
          return te;
        }
        return $A(J, [{ key: "componentDidMount", value: function() {
          var ee = this.props, te = ee.shouldUpdate, ce = ee.fieldContext;
          if (this.mounted = true, ce) {
            var Ie = ce.getInternalHooks, Le = Ie(AS), De = Le.registerField;
            this.cancelRegisterFunc = De(this);
          }
          te === true && this.reRender();
        } }, { key: "componentWillUnmount", value: function() {
          this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
        } }, { key: "reRender", value: function() {
          !this.mounted || this.forceUpdate();
        } }, { key: "render", value: function() {
          var ee = this.state.resetCount, te = this.props.children, ce = this.getOnlyChild(te), Ie = ce.child, Le = ce.isFunction, De;
          return Le ? De = Ie : M.isValidElement(Ie) ? De = M.cloneElement(Ie, this.getControlled(Ie.props)) : (Xm(!Ie, "`children` of Field is not validate ReactElement."), De = Ie), M.createElement(M.Fragment, { key: ee }, De);
        } }]), J;
      }(M.Component);
      M0.contextType = JA, M0.defaultProps = { trigger: "onChange", valuePropName: "value" };
      function tj(Z) {
        var ve = Z.name, J = So(Z, pee), ee = M.useContext(JA), te = ve !== void 0 ? _f(ve) : void 0, ce = "keep";
        return J.isListField || (ce = "_".concat((te || []).join("_"))), M.createElement(M0, Fc({ key: ce, name: te }, J, { fieldContext: ee }));
      }
      var vee = M.createContext(null), gee = function(Z) {
        var ve = Z.name, J = Z.initialValue, ee = Z.children, te = Z.rules, ce = Z.validateTrigger, Ie = M.useContext(JA), Le = M.useRef({ keys: [], id: 0 }), De = Le.current, Ye = M.useMemo(function() {
          var qt = _f(Ie.prefixName) || [];
          return [].concat(ul(qt), ul(_f(ve)));
        }, [Ie.prefixName, ve]), Ke = M.useMemo(function() {
          return Pn(Pn({}, Ie), {}, { prefixName: Ye });
        }, [Ie, Ye]), pt = M.useMemo(function() {
          return { getKey: function(qt) {
            var Yt = Ye.length, nn = qt[Yt];
            return [De.keys[nn], qt.slice(Yt + 1)];
          } };
        }, [Ye]);
        if (typeof ee != "function")
          return Xm(false, "Form.List only accepts function as children."), null;
        var Bt = function(qt, Yt, nn) {
          var ln = nn.source;
          return ln === "internal" ? false : qt !== Yt;
        };
        return M.createElement(vee.Provider, { value: pt }, M.createElement(JA.Provider, { value: Ke }, M.createElement(tj, { name: [], shouldUpdate: Bt, rules: te, validateTrigger: ce, initialValue: J, isList: true }, function(qt, Yt) {
          var nn = qt.value, ln = nn === void 0 ? [] : nn, yr = qt.onChange, sr = Ie.getFieldValue, aa = function() {
            var On = sr(Ye || []);
            return On || [];
          }, He = { add: function(On, dr) {
            var ur = aa();
            dr >= 0 && dr <= ur.length ? (De.keys = [].concat(ul(De.keys.slice(0, dr)), [De.id], ul(De.keys.slice(dr))), yr([].concat(ul(ur.slice(0, dr)), [On], ul(ur.slice(dr))))) : (De.keys = [].concat(ul(De.keys), [De.id]), yr([].concat(ul(ur), [On]))), De.id += 1;
          }, remove: function(On) {
            var dr = aa(), ur = new Set(Array.isArray(On) ? On : [On]);
            ur.size <= 0 || (De.keys = De.keys.filter(function(An, Nn) {
              return !ur.has(Nn);
            }), yr(dr.filter(function(An, Nn) {
              return !ur.has(Nn);
            })));
          }, move: function(On, dr) {
            if (On !== dr) {
              var ur = aa();
              On < 0 || On >= ur.length || dr < 0 || dr >= ur.length || (De.keys = QB(De.keys, On, dr), yr(QB(ur, On, dr)));
            }
          } }, Cn = ln || [];
          return Array.isArray(Cn) || (Cn = []), ee(Cn.map(function(On, dr) {
            var ur = De.keys[dr];
            return ur === void 0 && (De.keys[dr] = De.id, ur = De.keys[dr], De.id += 1), { name: dr, key: ur, isListField: true };
          }), He, Yt);
        })));
      };
      function mee(Z) {
        var ve = false, J = Z.length, ee = [];
        return Z.length ? new Promise(function(te, ce) {
          Z.forEach(function(Ie, Le) {
            Ie.catch(function(De) {
              return ve = true, De;
            }).then(function(De) {
              J -= 1, ee[Le] = De, !(J > 0) && (ve && ce(ee), te(ee));
            });
          });
        }) : Promise.resolve([]);
      }
      var nj = "__@field_split__";
      function x1(Z) {
        return Z.map(function(ve) {
          return "".concat(Mi(ve), ":").concat(ve);
        }).join(nj);
      }
      var oE = function() {
        function Z() {
          HA(this, Z), this.kvs = /* @__PURE__ */ new Map();
        }
        return $A(Z, [{ key: "set", value: function(ve, J) {
          this.kvs.set(x1(ve), J);
        } }, { key: "get", value: function(ve) {
          return this.kvs.get(x1(ve));
        } }, { key: "update", value: function(ve, J) {
          var ee = this.get(ve), te = J(ee);
          te ? this.set(ve, te) : this.delete(ve);
        } }, { key: "delete", value: function(ve) {
          this.kvs.delete(x1(ve));
        } }, { key: "map", value: function(ve) {
          return ul(this.kvs.entries()).map(function(J) {
            var ee = fo(J, 2), te = ee[0], ce = ee[1], Ie = te.split(nj);
            return ve({ key: Ie.map(function(Le) {
              var De = Le.match(/^([^:]*):(.*)$/), Ye = fo(De, 3), Ke = Ye[1], pt = Ye[2];
              return Ke === "number" ? Number(pt) : pt;
            }), value: ce });
          });
        } }, { key: "toJSON", value: function() {
          var ve = {};
          return this.map(function(J) {
            var ee = J.key, te = J.value;
            return ve[ee.join(".")] = te, null;
          }), ve;
        } }]), Z;
      }(), yee = ["name", "errors"], A0 = $A(function Z(ve) {
        var J = this;
        HA(this, Z), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
          return { getFieldValue: J.getFieldValue, getFieldsValue: J.getFieldsValue, getFieldError: J.getFieldError, getFieldWarning: J.getFieldWarning, getFieldsError: J.getFieldsError, isFieldsTouched: J.isFieldsTouched, isFieldTouched: J.isFieldTouched, isFieldValidating: J.isFieldValidating, isFieldsValidating: J.isFieldsValidating, resetFields: J.resetFields, setFields: J.setFields, setFieldsValue: J.setFieldsValue, validateFields: J.validateFields, submit: J.submit, getInternalHooks: J.getInternalHooks };
        }, this.getInternalHooks = function(ee) {
          return ee === AS ? (J.formHooked = true, { dispatch: J.dispatch, initEntityValue: J.initEntityValue, registerField: J.registerField, useSubscribe: J.useSubscribe, setInitialValues: J.setInitialValues, setCallbacks: J.setCallbacks, setValidateMessages: J.setValidateMessages, getFields: J.getFields, setPreserve: J.setPreserve, getInitialValue: J.getInitialValue }) : (Xm(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
        }, this.useSubscribe = function(ee) {
          J.subscribable = ee;
        }, this.setInitialValues = function(ee, te) {
          J.initialValues = ee || {}, te && (J.store = up({}, ee, J.store));
        }, this.getInitialValue = function(ee) {
          return _1(J.initialValues, ee);
        }, this.setCallbacks = function(ee) {
          J.callbacks = ee;
        }, this.setValidateMessages = function(ee) {
          J.validateMessages = ee;
        }, this.setPreserve = function(ee) {
          J.preserve = ee;
        }, this.timeoutId = null, this.warningUnhooked = function() {
        }, this.getFieldEntities = function() {
          var ee = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
          return ee ? J.fieldEntities.filter(function(te) {
            return te.getNamePath().length;
          }) : J.fieldEntities;
        }, this.getFieldsMap = function() {
          var ee = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, te = new oE();
          return J.getFieldEntities(ee).forEach(function(ce) {
            var Ie = ce.getNamePath();
            te.set(Ie, ce);
          }), te;
        }, this.getFieldEntitiesForNamePathList = function(ee) {
          if (!ee)
            return J.getFieldEntities(true);
          var te = J.getFieldsMap(true);
          return ee.map(function(ce) {
            var Ie = _f(ce);
            return te.get(Ie) || { INVALIDATE_NAME_PATH: _f(ce) };
          });
        }, this.getFieldsValue = function(ee, te) {
          if (J.warningUnhooked(), ee === true && !te)
            return J.store;
          var ce = J.getFieldEntitiesForNamePathList(Array.isArray(ee) ? ee : null), Ie = [];
          return ce.forEach(function(Le) {
            var De, Ye = "INVALIDATE_NAME_PATH" in Le ? Le.INVALIDATE_NAME_PATH : Le.getNamePath();
            if (!(!ee && ((De = Le.isListField) === null || De === void 0 ? void 0 : De.call(Le))))
              if (!te)
                Ie.push(Ye);
              else {
                var Ke = "getMeta" in Le ? Le.getMeta() : null;
                te(Ke) && Ie.push(Ye);
              }
          }), s6(J.store, Ie.map(_f));
        }, this.getFieldValue = function(ee) {
          J.warningUnhooked();
          var te = _f(ee);
          return _1(J.store, te);
        }, this.getFieldsError = function(ee) {
          J.warningUnhooked();
          var te = J.getFieldEntitiesForNamePathList(ee);
          return te.map(function(ce, Ie) {
            return ce && !("INVALIDATE_NAME_PATH" in ce) ? { name: ce.getNamePath(), errors: ce.getErrors(), warnings: ce.getWarnings() } : { name: _f(ee[Ie]), errors: [], warnings: [] };
          });
        }, this.getFieldError = function(ee) {
          J.warningUnhooked();
          var te = _f(ee), ce = J.getFieldsError([te])[0];
          return ce.errors;
        }, this.getFieldWarning = function(ee) {
          J.warningUnhooked();
          var te = _f(ee), ce = J.getFieldsError([te])[0];
          return ce.warnings;
        }, this.isFieldsTouched = function() {
          J.warningUnhooked();
          for (var ee = arguments.length, te = new Array(ee), ce = 0; ce < ee; ce++)
            te[ce] = arguments[ce];
          var Ie = te[0], Le = te[1], De, Ye = false;
          te.length === 0 ? De = null : te.length === 1 ? Array.isArray(Ie) ? (De = Ie.map(_f), Ye = false) : (De = null, Ye = Ie) : (De = Ie.map(_f), Ye = Le);
          var Ke = J.getFieldEntities(true), pt = function(nn) {
            return nn.isFieldTouched();
          };
          if (!De)
            return Ye ? Ke.every(pt) : Ke.some(pt);
          var Bt = new oE();
          De.forEach(function(nn) {
            Bt.set(nn, []);
          }), Ke.forEach(function(nn) {
            var ln = nn.getNamePath();
            De.forEach(function(yr) {
              yr.every(function(sr, aa) {
                return ln[aa] === sr;
              }) && Bt.update(yr, function(sr) {
                return [].concat(ul(sr), [nn]);
              });
            });
          });
          var qt = function(nn) {
            return nn.some(pt);
          }, Yt = Bt.map(function(nn) {
            var ln = nn.value;
            return ln;
          });
          return Ye ? Yt.every(qt) : Yt.some(qt);
        }, this.isFieldTouched = function(ee) {
          return J.warningUnhooked(), J.isFieldsTouched([ee]);
        }, this.isFieldsValidating = function(ee) {
          J.warningUnhooked();
          var te = J.getFieldEntities();
          if (!ee)
            return te.some(function(Ie) {
              return Ie.isFieldValidating();
            });
          var ce = ee.map(_f);
          return te.some(function(Ie) {
            var Le = Ie.getNamePath();
            return it(ce, Le) && Ie.isFieldValidating();
          });
        }, this.isFieldValidating = function(ee) {
          return J.warningUnhooked(), J.isFieldsValidating([ee]);
        }, this.resetWithFieldInitialValue = function() {
          var ee = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, te = new oE(), ce = J.getFieldEntities(true);
          ce.forEach(function(De) {
            var Ye = De.props.initialValue, Ke = De.getNamePath();
            if (Ye !== void 0) {
              var pt = te.get(Ke) || /* @__PURE__ */ new Set();
              pt.add({ entity: De, value: Ye }), te.set(Ke, pt);
            }
          });
          var Ie = function(De) {
            De.forEach(function(Ye) {
              var Ke = Ye.props.initialValue;
              if (Ke !== void 0) {
                var pt = Ye.getNamePath(), Bt = J.getInitialValue(pt);
                if (Bt !== void 0)
                  Xm(false, "Form already set 'initialValues' with path '".concat(pt.join("."), "'. Field can not overwrite it."));
                else {
                  var qt = te.get(pt);
                  if (qt && qt.size > 1)
                    Xm(false, "Multiple Field with path '".concat(pt.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                  else if (qt) {
                    var Yt = J.getFieldValue(pt);
                    (!ee.skipExist || Yt === void 0) && (J.store = S0(J.store, pt, ul(qt)[0].value));
                  }
                }
              }
            });
          }, Le;
          ee.entities ? Le = ee.entities : ee.namePathList ? (Le = [], ee.namePathList.forEach(function(De) {
            var Ye = te.get(De);
            if (Ye) {
              var Ke;
              (Ke = Le).push.apply(Ke, ul(ul(Ye).map(function(pt) {
                return pt.entity;
              })));
            }
          })) : Le = ce, Ie(Le);
        }, this.resetFields = function(ee) {
          J.warningUnhooked();
          var te = J.store;
          if (!ee) {
            J.store = up({}, J.initialValues), J.resetWithFieldInitialValue(), J.notifyObservers(te, null, { type: "reset" });
            return;
          }
          var ce = ee.map(_f);
          ce.forEach(function(Ie) {
            var Le = J.getInitialValue(Ie);
            J.store = S0(J.store, Ie, Le);
          }), J.resetWithFieldInitialValue({ namePathList: ce }), J.notifyObservers(te, ce, { type: "reset" });
        }, this.setFields = function(ee) {
          J.warningUnhooked();
          var te = J.store;
          ee.forEach(function(ce) {
            var Ie = ce.name;
            ce.errors;
            var Le = So(ce, yee), De = _f(Ie);
            "value" in Le && (J.store = S0(J.store, De, Le.value)), J.notifyObservers(te, [De], { type: "setField", data: ce });
          });
        }, this.getFields = function() {
          var ee = J.getFieldEntities(true), te = ee.map(function(ce) {
            var Ie = ce.getNamePath(), Le = ce.getMeta(), De = Pn(Pn({}, Le), {}, { name: Ie, value: J.getFieldValue(Ie) });
            return Object.defineProperty(De, "originRCField", { value: true }), De;
          });
          return te;
        }, this.initEntityValue = function(ee) {
          var te = ee.props.initialValue;
          if (te !== void 0) {
            var ce = ee.getNamePath(), Ie = _1(J.store, ce);
            Ie === void 0 && (J.store = S0(J.store, ce, te));
          }
        }, this.registerField = function(ee) {
          if (J.fieldEntities.push(ee), ee.props.initialValue !== void 0) {
            var te = J.store;
            J.resetWithFieldInitialValue({ entities: [ee], skipExist: true }), J.notifyObservers(te, [ee.getNamePath()], { type: "valueUpdate", source: "internal" });
          }
          return function(ce, Ie) {
            var Le = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
            J.fieldEntities = J.fieldEntities.filter(function(Bt) {
              return Bt !== ee;
            });
            var De = Ie !== void 0 ? Ie : J.preserve;
            if (De === false && (!ce || Le.length > 1)) {
              var Ye = ee.getNamePath(), Ke = ce ? void 0 : _1(J.initialValues, Ye);
              if (Ye.length && J.getFieldValue(Ye) !== Ke && J.fieldEntities.every(function(Bt) {
                return !Us(Bt.getNamePath(), Ye);
              })) {
                var pt = J.store;
                J.store = S0(pt, Ye, Ke, true), J.notifyObservers(pt, [Ye], { type: "remove" }), J.triggerDependenciesUpdate(pt, Ye);
              }
            }
          };
        }, this.dispatch = function(ee) {
          switch (ee.type) {
            case "updateValue": {
              var te = ee.namePath, ce = ee.value;
              J.updateValue(te, ce);
              break;
            }
            case "validateField": {
              var Ie = ee.namePath, Le = ee.triggerName;
              J.validateFields([Ie], { triggerName: Le });
              break;
            }
          }
        }, this.notifyObservers = function(ee, te, ce) {
          if (J.subscribable) {
            var Ie = Pn(Pn({}, ce), {}, { store: J.getFieldsValue(true) });
            J.getFieldEntities().forEach(function(Le) {
              var De = Le.onStoreChange;
              De(ee, te, Ie);
            });
          } else
            J.forceRootUpdate();
        }, this.triggerDependenciesUpdate = function(ee, te) {
          var ce = J.getDependencyChildrenFields(te);
          return ce.length && J.validateFields(ce), J.notifyObservers(ee, ce, { type: "dependenciesUpdate", relatedFields: [te].concat(ul(ce)) }), ce;
        }, this.updateValue = function(ee, te) {
          var ce = _f(ee), Ie = J.store;
          J.store = S0(J.store, ce, te), J.notifyObservers(Ie, [ce], { type: "valueUpdate", source: "internal" });
          var Le = J.triggerDependenciesUpdate(Ie, ce), De = J.callbacks.onValuesChange;
          if (De) {
            var Ye = s6(J.store, [ce]);
            De(Ye, J.getFieldsValue());
          }
          J.triggerOnFieldsChange([ce].concat(ul(Le)));
        }, this.setFieldsValue = function(ee) {
          J.warningUnhooked();
          var te = J.store;
          ee && (J.store = up(J.store, ee)), J.notifyObservers(te, null, { type: "valueUpdate", source: "external" });
        }, this.getDependencyChildrenFields = function(ee) {
          var te = /* @__PURE__ */ new Set(), ce = [], Ie = new oE();
          J.getFieldEntities().forEach(function(De) {
            var Ye = De.props.dependencies;
            (Ye || []).forEach(function(Ke) {
              var pt = _f(Ke);
              Ie.update(pt, function() {
                var Bt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                return Bt.add(De), Bt;
              });
            });
          });
          var Le = function De(Ye) {
            var Ke = Ie.get(Ye) || /* @__PURE__ */ new Set();
            Ke.forEach(function(pt) {
              if (!te.has(pt)) {
                te.add(pt);
                var Bt = pt.getNamePath();
                pt.isFieldDirty() && Bt.length && (ce.push(Bt), De(Bt));
              }
            });
          };
          return Le(ee), ce;
        }, this.triggerOnFieldsChange = function(ee, te) {
          var ce = J.callbacks.onFieldsChange;
          if (ce) {
            var Ie = J.getFields();
            if (te) {
              var Le = new oE();
              te.forEach(function(Ye) {
                var Ke = Ye.name, pt = Ye.errors;
                Le.set(Ke, pt);
              }), Ie.forEach(function(Ye) {
                Ye.errors = Le.get(Ye.name) || Ye.errors;
              });
            }
            var De = Ie.filter(function(Ye) {
              var Ke = Ye.name;
              return it(ee, Ke);
            });
            ce(De, Ie);
          }
        }, this.validateFields = function(ee, te) {
          J.warningUnhooked();
          var ce = !!ee, Ie = ce ? ee.map(_f) : [], Le = [];
          J.getFieldEntities(true).forEach(function(Ke) {
            if (ce || Ie.push(Ke.getNamePath()), (te == null ? void 0 : te.recursive) && ce) {
              var pt = Ke.getNamePath();
              pt.every(function(Yt, nn) {
                return ee[nn] === Yt || ee[nn] === void 0;
              }) && Ie.push(pt);
            }
            if (!(!Ke.props.rules || !Ke.props.rules.length)) {
              var Bt = Ke.getNamePath();
              if (!ce || it(Ie, Bt)) {
                var qt = Ke.validateRules(Pn({ validateMessages: Pn(Pn({}, ow), J.validateMessages) }, te));
                Le.push(qt.then(function() {
                  return { name: Bt, errors: [], warnings: [] };
                }).catch(function(Yt) {
                  var nn = [], ln = [];
                  return Yt.forEach(function(yr) {
                    var sr = yr.rule.warningOnly, aa = yr.errors;
                    sr ? ln.push.apply(ln, ul(aa)) : nn.push.apply(nn, ul(aa));
                  }), nn.length ? Promise.reject({ name: Bt, errors: nn, warnings: ln }) : { name: Bt, errors: nn, warnings: ln };
                }));
              }
            }
          });
          var De = mee(Le);
          J.lastValidatePromise = De, De.catch(function(Ke) {
            return Ke;
          }).then(function(Ke) {
            var pt = Ke.map(function(Bt) {
              var qt = Bt.name;
              return qt;
            });
            J.notifyObservers(J.store, pt, { type: "validateFinish" }), J.triggerOnFieldsChange(pt, Ke);
          });
          var Ye = De.then(function() {
            return J.lastValidatePromise === De ? Promise.resolve(J.getFieldsValue(Ie)) : Promise.reject([]);
          }).catch(function(Ke) {
            var pt = Ke.filter(function(Bt) {
              return Bt && Bt.errors.length;
            });
            return Promise.reject({ values: J.getFieldsValue(Ie), errorFields: pt, outOfDate: J.lastValidatePromise !== De });
          });
          return Ye.catch(function(Ke) {
            return Ke;
          }), Ye;
        }, this.submit = function() {
          J.warningUnhooked(), J.validateFields().then(function(ee) {
            var te = J.callbacks.onFinish;
            if (te)
              try {
                te(ee);
              } catch (ce) {
                console.error(ce);
              }
          }).catch(function(ee) {
            var te = J.callbacks.onFinishFailed;
            te && te(ee);
          });
        }, this.forceRootUpdate = ve;
      });
      function rj(Z) {
        var ve = M.useRef(), J = M.useState({}), ee = fo(J, 2), te = ee[1];
        if (!ve.current)
          if (Z)
            ve.current = Z;
          else {
            var ce = function() {
              te({});
            }, Ie = new A0(ce);
            ve.current = Ie.getForm();
          }
        return [ve.current];
      }
      var f62 = M.createContext({ triggerFormChange: function() {
      }, triggerFormFinish: function() {
      }, registerForm: function() {
      }, unregisterForm: function() {
      } }), bee = function(Z) {
        var ve = Z.validateMessages, J = Z.onFormChange, ee = Z.onFormFinish, te = Z.children, ce = M.useContext(f62), Ie = M.useRef({});
        return M.createElement(f62.Provider, { value: Pn(Pn({}, ce), {}, { validateMessages: Pn(Pn({}, ce.validateMessages), ve), triggerFormChange: function(Le, De) {
          J && J(Le, { changedFields: De, forms: Ie.current }), ce.triggerFormChange(Le, De);
        }, triggerFormFinish: function(Le, De) {
          ee && ee(Le, { values: De, forms: Ie.current }), ce.triggerFormFinish(Le, De);
        }, registerForm: function(Le, De) {
          Le && (Ie.current = Pn(Pn({}, Ie.current), {}, _t({}, Le, De))), ce.registerForm(Le, De);
        }, unregisterForm: function(Le) {
          var De = Pn({}, Ie.current);
          delete De[Le], Ie.current = De, ce.unregisterForm(Le);
        } }) }, te);
      }, _ee = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], xee = function(Z, ve) {
        var J = Z.name, ee = Z.initialValues, te = Z.fields, ce = Z.form, Ie = Z.preserve, Le = Z.children, De = Z.component, Ye = De === void 0 ? "form" : De, Ke = Z.validateMessages, pt = Z.validateTrigger, Bt = pt === void 0 ? "onChange" : pt, qt = Z.onValuesChange, Yt = Z.onFieldsChange, nn = Z.onFinish, ln = Z.onFinishFailed, yr = So(Z, _ee), sr = M.useContext(f62), aa = rj(ce), He = fo(aa, 1), Cn = He[0], On = Cn.getInternalHooks(AS), dr = On.useSubscribe, ur = On.setInitialValues, An = On.setCallbacks, Nn = On.setValidateMessages, Ar = On.setPreserve;
        M.useImperativeHandle(ve, function() {
          return Cn;
        }), M.useEffect(function() {
          return sr.registerForm(J, Cn), function() {
            sr.unregisterForm(J);
          };
        }, [sr, Cn, J]), Nn(Pn(Pn({}, sr.validateMessages), Ke)), An({ onValuesChange: qt, onFieldsChange: function(Qn) {
          if (sr.triggerFormChange(J, Qn), Yt) {
            for (var Yn = arguments.length, ya = new Array(Yn > 1 ? Yn - 1 : 0), sa = 1; sa < Yn; sa++)
              ya[sa - 1] = arguments[sa];
            Yt.apply(void 0, [Qn].concat(ya));
          }
        }, onFinish: function(Qn) {
          sr.triggerFormFinish(J, Qn), nn && nn(Qn);
        }, onFinishFailed: ln }), Ar(Ie);
        var Jr = M.useRef(null);
        ur(ee, !Jr.current), Jr.current || (Jr.current = true);
        var bn = Le, Xa = typeof Le == "function";
        if (Xa) {
          var qa = Cn.getFieldsValue(true);
          bn = Le(qa, Cn);
        }
        dr(!Xa);
        var ir = M.useRef();
        M.useEffect(function() {
          lee(ir.current || [], te || []) || Cn.setFields(te || []), ir.current = te;
        }, [te, Cn]);
        var Ai = M.useMemo(function() {
          return Pn(Pn({}, Cn), {}, { validateTrigger: Bt });
        }, [Cn, Bt]), gr = M.createElement(JA.Provider, { value: Ai }, bn);
        return Ye === false ? gr : M.createElement(Ye, Fc({}, yr, { onSubmit: function(Qn) {
          Qn.preventDefault(), Qn.stopPropagation(), Cn.submit();
        }, onReset: function(Qn) {
          var Yn;
          Qn.preventDefault(), Cn.resetFields(), (Yn = yr.onReset) === null || Yn === void 0 || Yn.call(yr, Qn);
        } }), gr);
      }, aj = M.forwardRef(xee), sE = aj;
      sE.FormProvider = bee, sE.Field = tj, sE.List = gee, sE.useForm = rj;
      var wee = function(Z, ve, J) {
        Xm(Z, "[antd: ".concat(ve, "] ").concat(J));
      }, See = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, h6 = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, lE = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, uE = lE, Cee = { lang: Fc({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, h6), timePickerLocale: Fc({}, uE) }, d62 = Cee, Rv = "${label} is not a valid ${type}", w1 = { locale: "en", Pagination: See, DatePicker: d62, TimePicker: uE, Calendar: d62, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: Rv, method: Rv, array: Rv, object: Rv, number: Rv, date: Rv, boolean: Rv, integer: Rv, float: Rv, regexp: Rv, email: Rv, url: Rv, hex: Rv }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, sk = w1, uw = m6.createContext(void 0), bg = uw, p6 = function(Z) {
        xS(J, Z);
        var ve = UA(J);
        function J() {
          return HA(this, J), ve.apply(this, arguments);
        }
        return $A(J, [{ key: "getLocale", value: function() {
          var ee = this.props, te = ee.componentName, ce = ee.defaultLocale, Ie = ce || sk[te != null ? te : "global"], Le = this.context, De = te && Le ? Le[te] : {};
          return Fc(Fc({}, Ie instanceof Function ? Ie() : Ie), De || {});
        } }, { key: "getLocaleCode", value: function() {
          var ee = this.context, te = ee && ee.locale;
          return ee && ee.exist && !te ? sk.locale : te;
        } }, { key: "render", value: function() {
          return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
        } }]), J;
      }(M.Component);
      p6.defaultProps = { componentName: "global" }, p6.contextType = bg;
      var ij = function() {
        var Z = M.useContext(Rh), ve = Z.getPrefixCls, J = ve("empty-img-default");
        return M.createElement("svg", { className: J, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, M.createElement("g", { fill: "none", fillRule: "evenodd" }, M.createElement("g", { transform: "translate(24 31.67)" }, M.createElement("ellipse", { className: "".concat(J, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), M.createElement("path", { className: "".concat(J, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), M.createElement("path", { className: "".concat(J, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), M.createElement("path", { className: "".concat(J, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), M.createElement("path", { className: "".concat(J, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), M.createElement("path", { className: "".concat(J, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), M.createElement("g", { className: "".concat(J, "-g"), transform: "translate(149.65 15.383)" }, M.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), M.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
      }, oj = ij, cE = function() {
        var Z = M.useContext(Rh), ve = Z.getPrefixCls, J = ve("empty-img-simple");
        return M.createElement("svg", { className: J, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, M.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, M.createElement("ellipse", { className: "".concat(J, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), M.createElement("g", { className: "".concat(J, "-g"), fillRule: "nonzero" }, M.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), M.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(J, "-path") }))));
      }, r_ = cE, sj = globalThis && globalThis.__rest || function(Z, ve) {
        var J = {};
        for (var ee in Z)
          Object.prototype.hasOwnProperty.call(Z, ee) && ve.indexOf(ee) < 0 && (J[ee] = Z[ee]);
        if (Z != null && typeof Object.getOwnPropertySymbols == "function")
          for (var te = 0, ee = Object.getOwnPropertySymbols(Z); te < ee.length; te++)
            ve.indexOf(ee[te]) < 0 && Object.prototype.propertyIsEnumerable.call(Z, ee[te]) && (J[ee[te]] = Z[ee[te]]);
        return J;
      }, lj = M.createElement(oj, null), fE = M.createElement(r_, null), v62 = function(Z) {
        var ve = Z.className, J = Z.prefixCls, ee = Z.image, te = ee === void 0 ? lj : ee, ce = Z.description, Ie = Z.children, Le = Z.imageStyle, De = sj(Z, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), Ye = M.useContext(Rh), Ke = Ye.getPrefixCls, pt = Ye.direction;
        return M.createElement(p6, { componentName: "Empty" }, function(Bt) {
          var qt, Yt = Ke("empty", J), nn = typeof ce != "undefined" ? ce : Bt.description, ln = typeof nn == "string" ? nn : "empty", yr = null;
          return typeof te == "string" ? yr = M.createElement("img", { alt: ln, src: te }) : yr = te, M.createElement("div", Fc({ className: Jl(Yt, (qt = {}, _t(qt, "".concat(Yt, "-normal"), te === fE), _t(qt, "".concat(Yt, "-rtl"), pt === "rtl"), qt), ve) }, De), M.createElement("div", { className: "".concat(Yt, "-image"), style: Le }, yr), nn && M.createElement("div", { className: "".concat(Yt, "-description") }, nn), Ie && M.createElement("div", { className: "".concat(Yt, "-footer") }, Ie));
        });
      };
      v62.PRESENTED_IMAGE_DEFAULT = lj, v62.PRESENTED_IMAGE_SIMPLE = fE;
      var DS = v62, Oh = function(Z) {
        return M.createElement(lk, null, function(ve) {
          var J = ve.getPrefixCls, ee = J("empty");
          switch (Z) {
            case "Table":
            case "List":
              return M.createElement(DS, { image: DS.PRESENTED_IMAGE_SIMPLE });
            case "Select":
            case "TreeSelect":
            case "Cascader":
            case "Transfer":
            case "Mentions":
              return M.createElement(DS, { image: DS.PRESENTED_IMAGE_SIMPLE, className: "".concat(ee, "-small") });
            default:
              return M.createElement(DS, null);
          }
        });
      }, g6 = Oh, uj = function(Z, ve) {
        return ve || (Z ? "ant-".concat(Z) : "ant");
      }, Rh = M.createContext({ getPrefixCls: uj, renderEmpty: g6 }), lk = Rh.Consumer, uk = M.createContext(void 0), cw = uk, m62 = function(Z) {
        return +setTimeout(Z, 16);
      }, xd = function(Z) {
        return clearTimeout(Z);
      };
      typeof window != "undefined" && "requestAnimationFrame" in window && (m62 = function(Z) {
        return window.requestAnimationFrame(Z);
      }, xd = function(Z) {
        return window.cancelAnimationFrame(Z);
      });
      var ck = 0, y6 = /* @__PURE__ */ new Map();
      function cj(Z) {
        y6.delete(Z);
      }
      function fk(Z) {
        var ve = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
        ck += 1;
        var J = ck;
        function ee(te) {
          if (te === 0)
            cj(J), Z();
          else {
            var ce = m62(function() {
              ee(te - 1);
            });
            y6.set(J, ce);
          }
        }
        return ee(ve), J;
      }
      fk.cancel = function(Z) {
        var ve = y6.get(Z);
        return cj(ve), xd(ve);
      };
      function b62(Z, ve) {
        var J = ve || {}, ee = J.defaultValue, te = J.value, ce = J.onChange, Ie = J.postState, Le = M.useState(function() {
          return te !== void 0 ? te : ee !== void 0 ? typeof ee == "function" ? ee() : ee : typeof Z == "function" ? Z() : Z;
        }), De = fo(Le, 2), Ye = De[0], Ke = De[1], pt = te !== void 0 ? te : Ye;
        Ie && (pt = Ie(pt));
        var Bt = M.useRef(ce);
        Bt.current = ce;
        var qt = M.useCallback(function(nn) {
          Ke(nn), pt !== nn && Bt.current && Bt.current(nn, pt);
        }, [pt, Bt]), Yt = M.useRef(true);
        return M.useEffect(function() {
          if (Yt.current) {
            Yt.current = false;
            return;
          }
          te === void 0 && Ke(te);
        }, [te]), [pt, qt];
      }
      var ao = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(Z) {
        var ve = Z.keyCode;
        if (Z.altKey && !Z.ctrlKey || Z.metaKey || ve >= ao.F1 && ve <= ao.F12)
          return false;
        switch (ve) {
          case ao.ALT:
          case ao.CAPS_LOCK:
          case ao.CONTEXT_MENU:
          case ao.CTRL:
          case ao.DOWN:
          case ao.END:
          case ao.ESC:
          case ao.HOME:
          case ao.INSERT:
          case ao.LEFT:
          case ao.MAC_FF_META:
          case ao.META:
          case ao.NUMLOCK:
          case ao.NUM_CENTER:
          case ao.PAGE_DOWN:
          case ao.PAGE_UP:
          case ao.PAUSE:
          case ao.PRINT_SCREEN:
          case ao.RIGHT:
          case ao.SHIFT:
          case ao.UP:
          case ao.WIN_KEY:
          case ao.WIN_KEY_RIGHT:
            return false;
          default:
            return true;
        }
      }, isCharacterKey: function(Z) {
        if (Z >= ao.ZERO && Z <= ao.NINE || Z >= ao.NUM_ZERO && Z <= ao.NUM_MULTIPLY || Z >= ao.A && Z <= ao.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && Z === 0)
          return true;
        switch (Z) {
          case ao.SPACE:
          case ao.QUESTION_MARK:
          case ao.NUM_PLUS:
          case ao.NUM_MINUS:
          case ao.NUM_PERIOD:
          case ao.NUM_DIVISION:
          case ao.SEMICOLON:
          case ao.DASH:
          case ao.EQUALS:
          case ao.COMMA:
          case ao.PERIOD:
          case ao.SLASH:
          case ao.APOSTROPHE:
          case ao.SINGLE_QUOTE:
          case ao.OPEN_SQUARE_BRACKET:
          case ao.BACKSLASH:
          case ao.CLOSE_SQUARE_BRACKET:
            return true;
          default:
            return false;
        }
      } }, kS = function() {
        for (var Z = arguments.length, ve = new Array(Z), J = 0; J < Z; J++)
          ve[J] = arguments[J];
        return ve;
      }, fj = M.isValidElement;
      function Mee(Z, ve, J) {
        return fj(Z) ? M.cloneElement(Z, typeof J == "function" ? J(Z.props || {}) : J) : ve;
      }
      function Aee(Z, ve) {
        return Mee(Z, Z, ve);
      }
      var PS = ["xxl", "xl", "lg", "md", "sm", "xs"], hk = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, fw = /* @__PURE__ */ new Map(), hE = -1, dE = {}, Eee = { matchHandlers: {}, dispatch: function(Z) {
        return dE = Z, fw.forEach(function(ve) {
          return ve(dE);
        }), fw.size >= 1;
      }, subscribe: function(Z) {
        return fw.size || this.register(), hE += 1, fw.set(hE, Z), Z(dE), hE;
      }, unsubscribe: function(Z) {
        fw.delete(Z), fw.size || this.unregister();
      }, unregister: function() {
        var Z = this;
        Object.keys(hk).forEach(function(ve) {
          var J = hk[ve], ee = Z.matchHandlers[J];
          ee == null || ee.mql.removeListener(ee == null ? void 0 : ee.listener);
        }), fw.clear();
      }, register: function() {
        var Z = this;
        Object.keys(hk).forEach(function(ve) {
          var J = hk[ve], ee = function(ce) {
            var Ie = ce.matches;
            Z.dispatch(Fc(Fc({}, dE), _t({}, ve, Ie)));
          }, te = window.matchMedia(J);
          te.addListener(ee), Z.matchHandlers[J] = { mql: te, listener: ee }, ee(te);
        });
      } }, hj = Eee, Iee = 0, hw = {};
      function LS(Z) {
        var ve = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, J = Iee++, ee = ve;
        function te() {
          ee -= 1, ee <= 0 ? (Z(), delete hw[J]) : hw[J] = fk(te);
        }
        return hw[J] = fk(te), J;
      }
      LS.cancel = function(Z) {
        Z !== void 0 && (fk.cancel(hw[Z]), delete hw[Z]);
      }, LS.ids = hw;
      var _6;
      function dk(Z) {
        return !Z || Z.offsetParent === null || Z.hidden;
      }
      function dj(Z) {
        var ve = (Z || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
        return ve && ve[1] && ve[2] && ve[3] ? !(ve[1] === ve[2] && ve[2] === ve[3]) : true;
      }
      var x62 = function(Z) {
        xS(J, Z);
        var ve = UA(J);
        function J() {
          var ee;
          return HA(this, J), ee = ve.apply(this, arguments), ee.containerRef = M.createRef(), ee.animationStart = false, ee.destroyed = false, ee.onClick = function(te, ce) {
            var Ie, Le, De = ee.props, Ye = De.insertExtraNode, Ke = De.disabled;
            if (!(Ke || !te || dk(te) || te.className.indexOf("-leave") >= 0)) {
              ee.extraNode = document.createElement("div");
              var pt = Y5(ee), Bt = pt.extraNode, qt = ee.context.getPrefixCls;
              Bt.className = "".concat(qt(""), "-click-animating-node");
              var Yt = ee.getAttributeName();
              if (te.setAttribute(Yt, "true"), ce && ce !== "#ffffff" && ce !== "rgb(255, 255, 255)" && dj(ce) && !/rgba\((?:\d*, ){3}0\)/.test(ce) && ce !== "transparent") {
                Bt.style.borderColor = ce;
                var nn = ((Ie = te.getRootNode) === null || Ie === void 0 ? void 0 : Ie.call(te)) || te.ownerDocument, ln = nn instanceof Document ? nn.body : (Le = nn.firstChild) !== null && Le !== void 0 ? Le : nn;
                _6 = sh(`
      [`.concat(qt(""), "-click-animating-without-extra-node='true']::after, .").concat(qt(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(ce, `;
      }`), "antd-wave", { csp: ee.csp, attachTo: ln });
              }
              Ye && te.appendChild(Bt), ["transition", "animation"].forEach(function(yr) {
                te.addEventListener("".concat(yr, "start"), ee.onTransitionStart), te.addEventListener("".concat(yr, "end"), ee.onTransitionEnd);
              });
            }
          }, ee.onTransitionStart = function(te) {
            if (!ee.destroyed) {
              var ce = ee.containerRef.current;
              !te || te.target !== ce || ee.animationStart || ee.resetEffect(ce);
            }
          }, ee.onTransitionEnd = function(te) {
            !te || te.animationName !== "fadeEffect" || ee.resetEffect(te.target);
          }, ee.bindAnimationEvent = function(te) {
            if (!(!te || !te.getAttribute || te.getAttribute("disabled") || te.className.indexOf("disabled") >= 0)) {
              var ce = function(Ie) {
                if (!(Ie.target.tagName === "INPUT" || dk(Ie.target))) {
                  ee.resetEffect(te);
                  var Le = getComputedStyle(te).getPropertyValue("border-top-color") || getComputedStyle(te).getPropertyValue("border-color") || getComputedStyle(te).getPropertyValue("background-color");
                  ee.clickWaveTimeoutId = window.setTimeout(function() {
                    return ee.onClick(te, Le);
                  }, 0), LS.cancel(ee.animationStartId), ee.animationStart = true, ee.animationStartId = LS(function() {
                    ee.animationStart = false;
                  }, 10);
                }
              };
              return te.addEventListener("click", ce, true), { cancel: function() {
                te.removeEventListener("click", ce, true);
              } };
            }
          }, ee.renderWave = function(te) {
            var ce = te.csp, Ie = ee.props.children;
            if (ee.csp = ce, !M.isValidElement(Ie))
              return Ie;
            var Le = ee.containerRef;
            return qQ(Ie) && (Le = UQ(Ie.ref, ee.containerRef)), Aee(Ie, { ref: Le });
          }, ee;
        }
        return $A(J, [{ key: "componentDidMount", value: function() {
          var ee = this.containerRef.current;
          !ee || ee.nodeType !== 1 || (this.instance = this.bindAnimationEvent(ee));
        } }, { key: "componentWillUnmount", value: function() {
          this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
        } }, { key: "getAttributeName", value: function() {
          var ee = this.context.getPrefixCls, te = this.props.insertExtraNode;
          return te ? "".concat(ee(""), "-click-animating") : "".concat(ee(""), "-click-animating-without-extra-node");
        } }, { key: "resetEffect", value: function(ee) {
          var te = this;
          if (!(!ee || ee === this.extraNode || !(ee instanceof Element))) {
            var ce = this.props.insertExtraNode, Ie = this.getAttributeName();
            ee.setAttribute(Ie, "false"), _6 && (_6.innerHTML = ""), ce && this.extraNode && ee.contains(this.extraNode) && ee.removeChild(this.extraNode), ["transition", "animation"].forEach(function(Le) {
              ee.removeEventListener("".concat(Le, "start"), te.onTransitionStart), ee.removeEventListener("".concat(Le, "end"), te.onTransitionEnd);
            });
          }
        } }, { key: "render", value: function() {
          return M.createElement(lk, null, this.renderWave);
        } }]), J;
      }(M.Component);
      x62.contextType = Rh;
      var pk = { exports: {} }, a_ = {};
      /** @license React v17.0.2
      * react-jsx-runtime.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var Tee = S.default, w6 = 60103;
      if (a_.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
        var S6 = Symbol.for;
        w6 = S6("react.element"), a_.Fragment = S6("react.fragment");
      }
      var Dee = Tee.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, pj = Object.prototype.hasOwnProperty, kee = { key: true, ref: true, __self: true, __source: true };
      function vk(Z, ve, J) {
        var ee, te = {}, ce = null, Ie = null;
        J !== void 0 && (ce = "" + J), ve.key !== void 0 && (ce = "" + ve.key), ve.ref !== void 0 && (Ie = ve.ref);
        for (ee in ve)
          pj.call(ve, ee) && !kee.hasOwnProperty(ee) && (te[ee] = ve[ee]);
        if (Z && Z.defaultProps)
          for (ee in ve = Z.defaultProps, ve)
            te[ee] === void 0 && (te[ee] = ve[ee]);
        return { $$typeof: w6, type: Z, key: ce, ref: Ie, props: te, _owner: Dee.current };
      }
      a_.jsx = vk, a_.jsxs = vk, pk.exports = a_;
      const dw = pk.exports.jsx, C6 = pk.exports.jsxs;
      var Pee = m6.createContext({}), gk = Pee, _s = function() {
        return OB() && window.document.documentElement;
      }, mk, Lee = function() {
        if (!_s())
          return false;
        if (mk !== void 0)
          return mk;
        var Z = document.createElement("div");
        return Z.style.display = "flex", Z.style.flexDirection = "column", Z.style.rowGap = "1px", Z.appendChild(document.createElement("div")), Z.appendChild(document.createElement("div")), document.body.appendChild(Z), mk = Z.scrollHeight === 1, document.body.removeChild(Z), mk;
      }, pE = function() {
        var Z = M.useState(false), ve = fo(Z, 2), J = ve[0], ee = ve[1];
        return M.useEffect(function() {
          ee(Lee());
        }, []), J;
      }, vj = globalThis && globalThis.__rest || function(Z, ve) {
        var J = {};
        for (var ee in Z)
          Object.prototype.hasOwnProperty.call(Z, ee) && ve.indexOf(ee) < 0 && (J[ee] = Z[ee]);
        if (Z != null && typeof Object.getOwnPropertySymbols == "function")
          for (var te = 0, ee = Object.getOwnPropertySymbols(Z); te < ee.length; te++)
            ve.indexOf(ee[te]) < 0 && Object.prototype.propertyIsEnumerable.call(Z, ee[te]) && (J[ee[te]] = Z[ee[te]]);
        return J;
      };
      kS("top", "middle", "bottom", "stretch"), kS("start", "end", "center", "space-around", "space-between");
      var gj = M.forwardRef(function(Z, ve) {
        var J, ee = Z.prefixCls, te = Z.justify, ce = Z.align, Ie = Z.className, Le = Z.style, De = Z.children, Ye = Z.gutter, Ke = Ye === void 0 ? 0 : Ye, pt = Z.wrap, Bt = vj(Z, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), qt = M.useContext(Rh), Yt = qt.getPrefixCls, nn = qt.direction, ln = M.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), yr = fo(ln, 2), sr = yr[0], aa = yr[1], He = pE(), Cn = M.useRef(Ke);
        M.useEffect(function() {
          var gr = hj.subscribe(function(Qn) {
            var Yn = Cn.current || 0;
            (!Array.isArray(Yn) && Mi(Yn) === "object" || Array.isArray(Yn) && (Mi(Yn[0]) === "object" || Mi(Yn[1]) === "object")) && aa(Qn);
          });
          return function() {
            return hj.unsubscribe(gr);
          };
        }, []);
        var On = function() {
          var gr = [0, 0], Qn = Array.isArray(Ke) ? Ke : [Ke, 0];
          return Qn.forEach(function(Yn, ya) {
            if (Mi(Yn) === "object")
              for (var sa = 0; sa < PS.length; sa++) {
                var Wi = PS[sa];
                if (sr[Wi] && Yn[Wi] !== void 0) {
                  gr[ya] = Yn[Wi];
                  break;
                }
              }
            else
              gr[ya] = Yn || 0;
          }), gr;
        }, dr = Yt("row", ee), ur = On(), An = Jl(dr, (J = {}, _t(J, "".concat(dr, "-no-wrap"), pt === false), _t(J, "".concat(dr, "-").concat(te), te), _t(J, "".concat(dr, "-").concat(ce), ce), _t(J, "".concat(dr, "-rtl"), nn === "rtl"), J), Ie), Nn = {}, Ar = ur[0] > 0 ? ur[0] / -2 : void 0, Jr = ur[1] > 0 ? ur[1] / -2 : void 0;
        if (Ar && (Nn.marginLeft = Ar, Nn.marginRight = Ar), He) {
          var bn = fo(ur, 2);
          Nn.rowGap = bn[1];
        } else
          Jr && (Nn.marginTop = Jr, Nn.marginBottom = Jr);
        var Xa = fo(ur, 2), qa = Xa[0], ir = Xa[1], Ai = M.useMemo(function() {
          return { gutter: [qa, ir], wrap: pt, supportFlexGap: He };
        }, [qa, ir, pt, He]);
        return M.createElement(gk.Provider, { value: Ai }, M.createElement("div", Fc({}, Bt, { className: An, style: Fc(Fc({}, Nn), Le), ref: ve }), De));
      });
      gj.displayName = "Row";
      var Oee = gj, _g = globalThis && globalThis.__rest || function(Z, ve) {
        var J = {};
        for (var ee in Z)
          Object.prototype.hasOwnProperty.call(Z, ee) && ve.indexOf(ee) < 0 && (J[ee] = Z[ee]);
        if (Z != null && typeof Object.getOwnPropertySymbols == "function")
          for (var te = 0, ee = Object.getOwnPropertySymbols(Z); te < ee.length; te++)
            ve.indexOf(ee[te]) < 0 && Object.prototype.propertyIsEnumerable.call(Z, ee[te]) && (J[ee[te]] = Z[ee[te]]);
        return J;
      };
      function Ree(Z) {
        return typeof Z == "number" ? "".concat(Z, " ").concat(Z, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(Z) ? "0 0 ".concat(Z) : Z;
      }
      var yk = ["xs", "sm", "md", "lg", "xl", "xxl"], bk = M.forwardRef(function(Z, ve) {
        var J, ee = M.useContext(Rh), te = ee.getPrefixCls, ce = ee.direction, Ie = M.useContext(gk), Le = Ie.gutter, De = Ie.wrap, Ye = Ie.supportFlexGap, Ke = Z.prefixCls, pt = Z.span, Bt = Z.order, qt = Z.offset, Yt = Z.push, nn = Z.pull, ln = Z.className, yr = Z.children, sr = Z.flex, aa = Z.style, He = _g(Z, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), Cn = te("col", Ke), On = {};
        yk.forEach(function(Ar) {
          var Jr, bn = {}, Xa = Z[Ar];
          typeof Xa == "number" ? bn.span = Xa : Mi(Xa) === "object" && (bn = Xa || {}), delete He[Ar], On = Fc(Fc({}, On), (Jr = {}, _t(Jr, "".concat(Cn, "-").concat(Ar, "-").concat(bn.span), bn.span !== void 0), _t(Jr, "".concat(Cn, "-").concat(Ar, "-order-").concat(bn.order), bn.order || bn.order === 0), _t(Jr, "".concat(Cn, "-").concat(Ar, "-offset-").concat(bn.offset), bn.offset || bn.offset === 0), _t(Jr, "".concat(Cn, "-").concat(Ar, "-push-").concat(bn.push), bn.push || bn.push === 0), _t(Jr, "".concat(Cn, "-").concat(Ar, "-pull-").concat(bn.pull), bn.pull || bn.pull === 0), _t(Jr, "".concat(Cn, "-rtl"), ce === "rtl"), Jr));
        });
        var dr = Jl(Cn, (J = {}, _t(J, "".concat(Cn, "-").concat(pt), pt !== void 0), _t(J, "".concat(Cn, "-order-").concat(Bt), Bt), _t(J, "".concat(Cn, "-offset-").concat(qt), qt), _t(J, "".concat(Cn, "-push-").concat(Yt), Yt), _t(J, "".concat(Cn, "-pull-").concat(nn), nn), J), ln, On), ur = {};
        if (Le && Le[0] > 0) {
          var An = Le[0] / 2;
          ur.paddingLeft = An, ur.paddingRight = An;
        }
        if (Le && Le[1] > 0 && !Ye) {
          var Nn = Le[1] / 2;
          ur.paddingTop = Nn, ur.paddingBottom = Nn;
        }
        return sr && (ur.flex = Ree(sr), De === false && !ur.minWidth && (ur.minWidth = 0)), M.createElement("div", Fc({}, He, { style: Fc(Fc({}, ur), aa), className: dr, ref: ve }), yr);
      });
      bk.displayName = "Col";
      var mj = bk, M6 = M.forwardRef(function(Z, ve) {
        var J, ee = Z.prefixCls, te = ee === void 0 ? "rc-switch" : ee, ce = Z.className, Ie = Z.checked, Le = Z.defaultChecked, De = Z.disabled, Ye = Z.loadingIcon, Ke = Z.checkedChildren, pt = Z.unCheckedChildren, Bt = Z.onClick, qt = Z.onChange, Yt = Z.onKeyDown, nn = So(Z, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), ln = b62(false, { value: Ie, defaultValue: Le }), yr = fo(ln, 2), sr = yr[0], aa = yr[1];
        function He(ur, An) {
          var Nn = sr;
          return De || (Nn = ur, aa(Nn), qt == null || qt(Nn, An)), Nn;
        }
        function Cn(ur) {
          ur.which === ao.LEFT ? He(false, ur) : ur.which === ao.RIGHT && He(true, ur), Yt == null || Yt(ur);
        }
        function On(ur) {
          var An = He(!sr, ur);
          Bt == null || Bt(An, ur);
        }
        var dr = Jl(te, ce, (J = {}, _t(J, "".concat(te, "-checked"), sr), _t(J, "".concat(te, "-disabled"), De), J));
        return M.createElement("button", Object.assign({}, nn, { type: "button", role: "switch", "aria-checked": sr, disabled: De, className: dr, ref: ve, onKeyDown: Cn, onClick: On }), Ye, M.createElement("span", { className: "".concat(te, "-inner") }, sr ? Ke : pt));
      });
      M6.displayName = "Switch";
      var Fv = globalThis && globalThis.__rest || function(Z, ve) {
        var J = {};
        for (var ee in Z)
          Object.prototype.hasOwnProperty.call(Z, ee) && ve.indexOf(ee) < 0 && (J[ee] = Z[ee]);
        if (Z != null && typeof Object.getOwnPropertySymbols == "function")
          for (var te = 0, ee = Object.getOwnPropertySymbols(Z); te < ee.length; te++)
            ve.indexOf(ee[te]) < 0 && Object.prototype.propertyIsEnumerable.call(Z, ee[te]) && (J[ee[te]] = Z[ee[te]]);
        return J;
      }, Km = M.forwardRef(function(Z, ve) {
        var J, ee = Z.prefixCls, te = Z.size, ce = Z.loading, Ie = Z.className, Le = Ie === void 0 ? "" : Ie, De = Z.disabled, Ye = Fv(Z, ["prefixCls", "size", "loading", "className", "disabled"]);
        wee("checked" in Ye || !("value" in Ye), "Switch", "`value` is not a valid prop, do you mean `checked`?");
        var Ke = M.useContext(Rh), pt = Ke.getPrefixCls, Bt = Ke.direction, qt = M.useContext(cw), Yt = pt("switch", ee), nn = M.createElement("div", { className: "".concat(Yt, "-handle") }, ce && M.createElement(BQ, { className: "".concat(Yt, "-loading-icon") })), ln = Jl((J = {}, _t(J, "".concat(Yt, "-small"), (te || qt) === "small"), _t(J, "".concat(Yt, "-loading"), ce), _t(J, "".concat(Yt, "-rtl"), Bt === "rtl"), J), Le);
        return M.createElement(x62, { insertExtraNode: true }, M.createElement(M6, Fc({}, Ye, { prefixCls: Yt, className: ln, disabled: De || ce, ref: ve, loadingIcon: nn })));
      });
      Km.__ANT_SWITCH = true, Km.displayName = "Switch";
      var A62 = Km, yj = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, _k = {};
      (function(Z) {
        var ve = Object.defineProperty, J = (Y, ge, Q) => ge in Y ? ve(Y, ge, { enumerable: true, configurable: true, writable: true, value: Q }) : Y[ge] = Q, ee = (Y, ge, Q) => (J(Y, typeof ge != "symbol" ? ge + "" : ge, Q), Q);
        Object.defineProperties(Z, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
        var te = S.default;
        function ce(Y) {
          return Y && typeof Y == "object" && "default" in Y ? Y : { default: Y };
        }
        function Ie(Y) {
          if (Y && Y.__esModule)
            return Y;
          var ge = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
          return Y && Object.keys(Y).forEach(function(Q) {
            if (Q !== "default") {
              var ne = Object.getOwnPropertyDescriptor(Y, Q);
              Object.defineProperty(ge, Q, ne.get ? ne : { enumerable: true, get: function() {
                return Y[Q];
              } });
            }
          }), ge.default = Y, Object.freeze(ge);
        }
        var Le = ce(te), De = Ie(te);
        class Ye {
          constructor() {
            ee(this, "chartsEmitters", /* @__PURE__ */ new Map()), ee(this, "add", (ge, Q, ne, re) => {
              Q && ne ? this.chartsEmitters.set(ge, { chart: Q, option: ne, title: re }) : console.log("\u6DFB\u52A0\u5931\u8D25");
            }), ee(this, "get", (ge) => this.chartsEmitters.get(ge)), ee(this, "clear", () => {
              this.chartsEmitters.clear();
            }), ee(this, "delete", (ge) => {
              this.chartsEmitters.delete(ge);
            }), ee(this, "list", () => {
              var ge, Q, ne;
              const re = [];
              for (const fe of this.chartsEmitters.keys())
                re.push({ id: fe, chart: (ge = this.chartsEmitters.get(fe)) == null ? void 0 : ge.chart, option: (Q = this.chartsEmitters.get(fe)) == null ? void 0 : Q.option, title: (ne = this.chartsEmitters.get(fe)) == null ? void 0 : ne.title });
              return re;
            });
          }
        }
        const Ke = new Ye();
        var pt = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof R != "undefined" ? R : typeof self != "undefined" ? self : {};
        function Bt(Y) {
          return Y && Y.__esModule && Object.prototype.hasOwnProperty.call(Y, "default") ? Y.default : Y;
        }
        var qt = { exports: {} };
        /**
        * @license
        * Lodash <https://lodash.com/>
        * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
        * Released under MIT license <https://lodash.com/license>
        * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
        * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
        */
        (function(Y, ge) {
          (function() {
            var Q, ne = "4.17.21", re = 200, fe = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", Ee = "Expected a function", Oe = "Invalid `variable` option passed into `_.template`", Be = "__lodash_hash_undefined__", Ze = 500, Je = "__lodash_placeholder__", yt = 1, Gt = 2, Xt = 4, Zt = 1, un = 2, yn = 1, _r = 2, cr = 4, fa = 8, We = 16, pn = 32, zn = 64, pr = 128, fr = 256, Tn = 512, Gn = 30, Tr = "...", ra = 800, wn = 16, Ka = 1, Ya = 2, vr = 3, Pi = 1 / 0, xr = 9007199254740991, Xn = 17976931348623157e292, Kn = 0 / 0, ba = 4294967295, la = ba - 1, Xi = ba >>> 1, Ys = [["ary", pr], ["bind", yn], ["bindKey", _r], ["curry", fa], ["curryRight", We], ["flip", Tn], ["partial", pn], ["partialRight", zn], ["rearg", fr]], Ss = "[object Arguments]", Uo = "[object Array]", nu = "[object AsyncFunction]", Cs = "[object Boolean]", yl = "[object Date]", vc = "[object DOMException]", Gc = "[object Error]", av = "[object Function]", Cg = "[object GeneratorFunction]", Sf = "[object Map]", gp = "[object Number]", j0 = "[object Null]", Td = "[object Object]", Hh = "[object Promise]", Mg = "[object Proxy]", iv = "[object RegExp]", Ec = "[object Set]", uf = "[object String]", Tu = "[object Symbol]", ki = "[object Undefined]", Pr = "[object WeakMap]", Hn = "[object WeakSet]", Vn = "[object ArrayBuffer]", Br = "[object DataView]", ka = "[object Float32Array]", gi = "[object Float64Array]", Ri = "[object Int8Array]", qo = "[object Int16Array]", Il = "[object Int32Array]", Wu = "[object Uint8Array]", Du = "[object Uint8ClampedArray]", Wc = "[object Uint16Array]", ku = "[object Uint32Array]", Dd = /\b__p \+= '';/g, mp = /\b(__p \+=) '' \+/g, Cf = /(__e\(.*?\)|\b__t\)) \+\n'';/g, ru = /&(?:amp|lt|gt|quot|#39);/g, gc = /[&<>"']/g, Zs = RegExp(ru.source), cf = RegExp(gc.source), $h = /<%-([\s\S]+?)%>/g, Ag = /<%([\s\S]+?)%>/g, ph = /<%=([\s\S]+?)%>/g, kd = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, ov = /^\w*$/, y_ = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, z1 = /[\\^$.*+?()[\]{}|]/g, lF = RegExp(z1.source), b_ = /^\s+/, pP = /\s/, vP = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, uF = /\{\n\/\* \[wrapped with (.+)\] \*/, rI = /,? & /, zw = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Pt = /[()=,{}\[\]\/\s]/, Vt = /\\(\\)?/g, ut = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, At = /\w*$/, Dt = /^[-+]0x[0-9a-f]+$/i, Fn = /^0b[01]+$/i, mr = /^\[object .+?Constructor\]$/, nr = /^0o[0-7]+$/i, En = /^(?:0|[1-9]\d*)$/, ia = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, xi = /($^)/, ds = /['\n\r\u2028\u2029\\]/g, Xs = "\\ud800-\\udfff", Hl = "\\u0300-\\u036f", ss = "\\ufe20-\\ufe2f", $l = "\\u20d0-\\u20ff", mc = Hl + ss + $l, xo = "\\u2700-\\u27bf", ff = "a-z\\xdf-\\xf6\\xf8-\\xff", yp = "\\xac\\xb1\\xd7\\xf7", G0 = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", Bw = "\\u2000-\\u206f", Eg = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", __ = "A-Z\\xc0-\\xd6\\xd8-\\xde", B1 = "\\ufe0e\\ufe0f", Hf = yp + G0 + Bw + Eg, fy = "['\u2019]", x_ = "[" + Xs + "]", j1 = "[" + Hf + "]", jw = "[" + mc + "]", Gw = "\\d+", aI = "[" + xo + "]", iC = "[" + ff + "]", oC = "[^" + Xs + Hf + Gw + xo + ff + __ + "]", vh = "\\ud83c[\\udffb-\\udfff]", w_ = "(?:" + jw + "|" + vh + ")", iI = "[^" + Xs + "]", cF = "(?:\\ud83c[\\udde6-\\uddff]){2}", gP = "[\\ud800-\\udbff][\\udc00-\\udfff]", sC = "[" + __ + "]", xj = "\\u200d", wj = "(?:" + iC + "|" + oC + ")", Fee = "(?:" + sC + "|" + oC + ")", mP = "(?:" + fy + "(?:d|ll|m|re|s|t|ve))?", Sj = "(?:" + fy + "(?:D|LL|M|RE|S|T|VE))?", Cj = w_ + "?", Mj = "[" + B1 + "]?", Nee = "(?:" + xj + "(?:" + [iI, cF, gP].join("|") + ")" + Mj + Cj + ")*", Vee = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", zee = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Aj = Mj + Cj + Nee, Bee = "(?:" + [aI, cF, gP].join("|") + ")" + Aj, jee = "(?:" + [iI + jw + "?", jw, cF, gP, x_].join("|") + ")", Gee = RegExp(fy, "g"), Wee = RegExp(jw, "g"), fF = RegExp(vh + "(?=" + vh + ")|" + jee + Aj, "g"), Hee = RegExp([sC + "?" + iC + "+" + mP + "(?=" + [j1, sC, "$"].join("|") + ")", Fee + "+" + Sj + "(?=" + [j1, sC + wj, "$"].join("|") + ")", sC + "?" + wj + "+" + mP, sC + "+" + Sj, zee, Vee, Gw, Bee].join("|"), "g"), $ee = RegExp("[" + xj + Xs + mc + B1 + "]"), Uee = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, qee = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], Yee = -1, rc = {};
            rc[ka] = rc[gi] = rc[Ri] = rc[qo] = rc[Il] = rc[Wu] = rc[Du] = rc[Wc] = rc[ku] = true, rc[Ss] = rc[Uo] = rc[Vn] = rc[Cs] = rc[Br] = rc[yl] = rc[Gc] = rc[av] = rc[Sf] = rc[gp] = rc[Td] = rc[iv] = rc[Ec] = rc[uf] = rc[Pr] = false;
            var Hu = {};
            Hu[Ss] = Hu[Uo] = Hu[Vn] = Hu[Br] = Hu[Cs] = Hu[yl] = Hu[ka] = Hu[gi] = Hu[Ri] = Hu[qo] = Hu[Il] = Hu[Sf] = Hu[gp] = Hu[Td] = Hu[iv] = Hu[Ec] = Hu[uf] = Hu[Tu] = Hu[Wu] = Hu[Du] = Hu[Wc] = Hu[ku] = true, Hu[Gc] = Hu[av] = Hu[Pr] = false;
            var Zee = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, hF = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, Ej = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, Xee = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, Kee = parseFloat, Jee = parseInt, Ij = typeof pt == "object" && pt && pt.Object === Object && pt, Qee = typeof self == "object" && self && self.Object === Object && self, Uh = Ij || Qee || Function("return this")(), dF = ge && !ge.nodeType && ge, Ww = dF && true && Y && !Y.nodeType && Y, pF = Ww && Ww.exports === dF, vF = pF && Ij.process, bp = function() {
              try {
                var _n = Ww && Ww.require && Ww.require("util").types;
                return _n || vF && vF.binding && vF.binding("util");
              } catch {
              }
            }(), Tj = bp && bp.isArrayBuffer, Dj = bp && bp.isDate, kj = bp && bp.isMap, Pj = bp && bp.isRegExp, Lj = bp && bp.isSet, Oj = bp && bp.isTypedArray;
            function Wv(_n, Lr, Zn) {
              switch (Zn.length) {
                case 0:
                  return _n.call(Lr);
                case 1:
                  return _n.call(Lr, Zn[0]);
                case 2:
                  return _n.call(Lr, Zn[0], Zn[1]);
                case 3:
                  return _n.call(Lr, Zn[0], Zn[1], Zn[2]);
              }
              return _n.apply(Lr, Zn);
            }
            function ete(_n, Lr, Zn, ea) {
              for (var Vo = -1, zo = _n == null ? 0 : _n.length; ++Vo < zo; ) {
                var Ms = _n[Vo];
                Lr(ea, Ms, Zn(Ms), _n);
              }
              return ea;
            }
            function Ig(_n, Lr) {
              for (var Zn = -1, ea = _n == null ? 0 : _n.length; ++Zn < ea && Lr(_n[Zn], Zn, _n) !== false; )
                ;
              return _n;
            }
            function tte(_n, Lr) {
              for (var Zn = _n == null ? 0 : _n.length; Zn-- && Lr(_n[Zn], Zn, _n) !== false; )
                ;
              return _n;
            }
            function Rj(_n, Lr) {
              for (var Zn = -1, ea = _n == null ? 0 : _n.length; ++Zn < ea; )
                if (!Lr(_n[Zn], Zn, _n))
                  return false;
              return true;
            }
            function S_(_n, Lr) {
              for (var Zn = -1, ea = _n == null ? 0 : _n.length, Vo = 0, zo = []; ++Zn < ea; ) {
                var Ms = _n[Zn];
                Lr(Ms, Zn, _n) && (zo[Vo++] = Ms);
              }
              return zo;
            }
            function yP(_n, Lr) {
              var Zn = _n == null ? 0 : _n.length;
              return !!Zn && lC(_n, Lr, 0) > -1;
            }
            function gF(_n, Lr, Zn) {
              for (var ea = -1, Vo = _n == null ? 0 : _n.length; ++ea < Vo; )
                if (Zn(Lr, _n[ea]))
                  return true;
              return false;
            }
            function yc(_n, Lr) {
              for (var Zn = -1, ea = _n == null ? 0 : _n.length, Vo = Array(ea); ++Zn < ea; )
                Vo[Zn] = Lr(_n[Zn], Zn, _n);
              return Vo;
            }
            function C_(_n, Lr) {
              for (var Zn = -1, ea = Lr.length, Vo = _n.length; ++Zn < ea; )
                _n[Vo + Zn] = Lr[Zn];
              return _n;
            }
            function bP(_n, Lr, Zn, ea) {
              var Vo = -1, zo = _n == null ? 0 : _n.length;
              for (ea && zo && (Zn = _n[++Vo]); ++Vo < zo; )
                Zn = Lr(Zn, _n[Vo], Vo, _n);
              return Zn;
            }
            function Fj(_n, Lr, Zn, ea) {
              var Vo = _n == null ? 0 : _n.length;
              for (ea && Vo && (Zn = _n[--Vo]); Vo--; )
                Zn = Lr(Zn, _n[Vo], Vo, _n);
              return Zn;
            }
            function mF(_n, Lr) {
              for (var Zn = -1, ea = _n == null ? 0 : _n.length; ++Zn < ea; )
                if (Lr(_n[Zn], Zn, _n))
                  return true;
              return false;
            }
            var nte = yF("length");
            function rte(_n) {
              return _n.split("");
            }
            function ate(_n) {
              return _n.match(zw) || [];
            }
            function oI(_n, Lr, Zn) {
              var ea;
              return Zn(_n, function(Vo, zo, Ms) {
                if (Lr(Vo, zo, Ms))
                  return ea = zo, false;
              }), ea;
            }
            function _P(_n, Lr, Zn, ea) {
              for (var Vo = _n.length, zo = Zn + (ea ? 1 : -1); ea ? zo-- : ++zo < Vo; )
                if (Lr(_n[zo], zo, _n))
                  return zo;
              return -1;
            }
            function lC(_n, Lr, Zn) {
              return Lr === Lr ? hte(_n, Lr, Zn) : _P(_n, Nj, Zn);
            }
            function ite(_n, Lr, Zn, ea) {
              for (var Vo = Zn - 1, zo = _n.length; ++Vo < zo; )
                if (ea(_n[Vo], Lr))
                  return Vo;
              return -1;
            }
            function Nj(_n) {
              return _n !== _n;
            }
            function Vj(_n, Lr) {
              var Zn = _n == null ? 0 : _n.length;
              return Zn ? _F(_n, Lr) / Zn : Kn;
            }
            function yF(_n) {
              return function(Lr) {
                return Lr == null ? Q : Lr[_n];
              };
            }
            function bF(_n) {
              return function(Lr) {
                return _n == null ? Q : _n[Lr];
              };
            }
            function zj(_n, Lr, Zn, ea, Vo) {
              return Vo(_n, function(zo, Ms, Pu) {
                Zn = ea ? (ea = false, zo) : Lr(Zn, zo, Ms, Pu);
              }), Zn;
            }
            function ote(_n, Lr) {
              var Zn = _n.length;
              for (_n.sort(Lr); Zn--; )
                _n[Zn] = _n[Zn].value;
              return _n;
            }
            function _F(_n, Lr) {
              for (var Zn, ea = -1, Vo = _n.length; ++ea < Vo; ) {
                var zo = Lr(_n[ea]);
                zo !== Q && (Zn = Zn === Q ? zo : Zn + zo);
              }
              return Zn;
            }
            function xF(_n, Lr) {
              for (var Zn = -1, ea = Array(_n); ++Zn < _n; )
                ea[Zn] = Lr(Zn);
              return ea;
            }
            function xP(_n, Lr) {
              return yc(Lr, function(Zn) {
                return [Zn, _n[Zn]];
              });
            }
            function Bj(_n) {
              return _n && _n.slice(0, Wj(_n) + 1).replace(b_, "");
            }
            function sv(_n) {
              return function(Lr) {
                return _n(Lr);
              };
            }
            function wP(_n, Lr) {
              return yc(Lr, function(Zn) {
                return _n[Zn];
              });
            }
            function Hw(_n, Lr) {
              return _n.has(Lr);
            }
            function wF(_n, Lr) {
              for (var Zn = -1, ea = _n.length; ++Zn < ea && lC(Lr, _n[Zn], 0) > -1; )
                ;
              return Zn;
            }
            function SF(_n, Lr) {
              for (var Zn = _n.length; Zn-- && lC(Lr, _n[Zn], 0) > -1; )
                ;
              return Zn;
            }
            function jj(_n, Lr) {
              for (var Zn = _n.length, ea = 0; Zn--; )
                _n[Zn] === Lr && ++ea;
              return ea;
            }
            var Gj = bF(Zee), ste = bF(hF);
            function lte(_n) {
              return "\\" + Xee[_n];
            }
            function ute(_n, Lr) {
              return _n == null ? Q : _n[Lr];
            }
            function G1(_n) {
              return $ee.test(_n);
            }
            function SP(_n) {
              return Uee.test(_n);
            }
            function cte(_n) {
              for (var Lr, Zn = []; !(Lr = _n.next()).done; )
                Zn.push(Lr.value);
              return Zn;
            }
            function CF(_n) {
              var Lr = -1, Zn = Array(_n.size);
              return _n.forEach(function(ea, Vo) {
                Zn[++Lr] = [Vo, ea];
              }), Zn;
            }
            function CP(_n, Lr) {
              return function(Zn) {
                return _n(Lr(Zn));
              };
            }
            function W1(_n, Lr) {
              for (var Zn = -1, ea = _n.length, Vo = 0, zo = []; ++Zn < ea; ) {
                var Ms = _n[Zn];
                (Ms === Lr || Ms === Je) && (_n[Zn] = Je, zo[Vo++] = Zn);
              }
              return zo;
            }
            function MP(_n) {
              var Lr = -1, Zn = Array(_n.size);
              return _n.forEach(function(ea) {
                Zn[++Lr] = ea;
              }), Zn;
            }
            function fte(_n) {
              var Lr = -1, Zn = Array(_n.size);
              return _n.forEach(function(ea) {
                Zn[++Lr] = [ea, ea];
              }), Zn;
            }
            function hte(_n, Lr, Zn) {
              for (var ea = Zn - 1, Vo = _n.length; ++ea < Vo; )
                if (_n[ea] === Lr)
                  return ea;
              return -1;
            }
            function dte(_n, Lr, Zn) {
              for (var ea = Zn + 1; ea--; )
                if (_n[ea] === Lr)
                  return ea;
              return ea;
            }
            function uC(_n) {
              return G1(_n) ? vte(_n) : nte(_n);
            }
            function W0(_n) {
              return G1(_n) ? gte(_n) : rte(_n);
            }
            function Wj(_n) {
              for (var Lr = _n.length; Lr-- && pP.test(_n.charAt(Lr)); )
                ;
              return Lr;
            }
            var pte = bF(Ej);
            function vte(_n) {
              for (var Lr = fF.lastIndex = 0; fF.test(_n); )
                ++Lr;
              return Lr;
            }
            function gte(_n) {
              return _n.match(fF) || [];
            }
            function mte(_n) {
              return _n.match(Hee) || [];
            }
            var yte = function _n(Lr) {
              Lr = Lr == null ? Uh : Pd.defaults(Uh.Object(), Lr, Pd.pick(Uh, qee));
              var Zn = Lr.Array, ea = Lr.Date, Vo = Lr.Error, zo = Lr.Function, Ms = Lr.Math, Pu = Lr.Object, hy = Lr.RegExp, bte = Lr.String, Tg = Lr.TypeError, AP = Zn.prototype, _te = zo.prototype, cC = Pu.prototype, fC = Lr["__core-js_shared__"], EP = _te.toString, Ks = cC.hasOwnProperty, Hj = 0, sI = function() {
                var L = /[^.]+$/.exec(fC && fC.keys && fC.keys.IE_PROTO || "");
                return L ? "Symbol(src)_1." + L : "";
              }(), $u = cC.toString, Hc = EP.call(Pu), $j = Uh._, xte = hy("^" + EP.call(Ks).replace(z1, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), IP = pF ? Lr.Buffer : Q, M_ = Lr.Symbol, TP = Lr.Uint8Array, Uj = IP ? IP.allocUnsafe : Q, DP = CP(Pu.getPrototypeOf, Pu), MF = Pu.create, hC = cC.propertyIsEnumerable, dC = AP.splice, qj = M_ ? M_.isConcatSpreadable : Q, pC = M_ ? M_.iterator : Q, dy = M_ ? M_.toStringTag : Q, Ld = function() {
                try {
                  var L = vI(Pu, "defineProperty");
                  return L({}, "", {}), L;
                } catch {
                }
              }(), vC = Lr.clearTimeout !== Uh.clearTimeout && Lr.clearTimeout, wte = ea && ea.now !== Uh.Date.now && ea.now, Ste = Lr.setTimeout !== Uh.setTimeout && Lr.setTimeout, kP = Ms.ceil, PP = Ms.floor, AF = Pu.getOwnPropertySymbols, Yj = IP ? IP.isBuffer : Q, py = Lr.isFinite, ls = AP.join, Zj = CP(Pu.keys, Pu), Ul = Ms.max, qh = Ms.min, Cte = ea.now, ql = Lr.parseInt, Xj = Ms.random, Kj = AP.reverse, gC = vI(Lr, "DataView"), lI = vI(Lr, "Map"), EF = vI(Lr, "Promise"), mC = vI(Lr, "Set"), uI = vI(Lr, "WeakMap"), cI = vI(Pu, "create"), LP = uI && new uI(), yC = {}, Mte = gI(gC), Ate = gI(lI), Ete = gI(EF), Ite = gI(mC), Tte = gI(uI), OP = M_ ? M_.prototype : Q, $w = OP ? OP.valueOf : Q, Jj = OP ? OP.toString : Q;
              function st(L) {
                if (Mf(L) && !cs(L) && !(L instanceof $i)) {
                  if (L instanceof Dg)
                    return L;
                  if (Ks.call(L, "__wrapped__"))
                    return W_e(L);
                }
                return new Dg(L);
              }
              var bC = function() {
                function L() {
                }
                return function(W) {
                  if (!hf(W))
                    return {};
                  if (MF)
                    return MF(W);
                  L.prototype = W;
                  var se = new L();
                  return L.prototype = Q, se;
                };
              }();
              function RP() {
              }
              function Dg(L, W) {
                this.__wrapped__ = L, this.__actions__ = [], this.__chain__ = !!W, this.__index__ = 0, this.__values__ = Q;
              }
              st.templateSettings = { escape: $h, evaluate: Ag, interpolate: ph, variable: "", imports: { _: st } }, st.prototype = RP.prototype, st.prototype.constructor = st, Dg.prototype = bC(RP.prototype), Dg.prototype.constructor = Dg;
              function $i(L) {
                this.__wrapped__ = L, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = ba, this.__views__ = [];
              }
              function lv() {
                var L = new $i(this.__wrapped__);
                return L.__actions__ = Og(this.__actions__), L.__dir__ = this.__dir__, L.__filtered__ = this.__filtered__, L.__iteratees__ = Og(this.__iteratees__), L.__takeCount__ = this.__takeCount__, L.__views__ = Og(this.__views__), L;
              }
              function Dte() {
                if (this.__filtered__) {
                  var L = new $i(this);
                  L.__dir__ = -1, L.__filtered__ = true;
                } else
                  L = this.clone(), L.__dir__ *= -1;
                return L;
              }
              function kte() {
                var L = this.__wrapped__.value(), W = this.__dir__, se = cs(L), Te = W < 0, qe = se ? L.length : 0, mt = CQe(0, qe, this.__views__), Ut = mt.start, rn = mt.end, Dn = rn - Ut, Xr = Te ? rn : Ut - 1, Kr = this.__iteratees__, va = Kr.length, Ja = 0, Li = qh(Dn, this.__takeCount__);
                if (!se || !Te && qe == Dn && Li == Dn)
                  return Rs(L, this.__actions__);
                var ho = [];
                e:
                  for (; Dn-- && Ja < Li; ) {
                    Xr += W;
                    for (var Fs = -1, po = L[Xr]; ++Fs < va; ) {
                      var cl = Kr[Fs], bl = cl.iteratee, U0 = cl.type, $v = bl(po);
                      if (U0 == Ya)
                        po = $v;
                      else if (!$v) {
                        if (U0 == Ka)
                          continue e;
                        break e;
                      }
                    }
                    ho[Ja++] = po;
                  }
                return ho;
              }
              $i.prototype = bC(RP.prototype), $i.prototype.constructor = $i;
              function Uw(L) {
                var W = -1, se = L == null ? 0 : L.length;
                for (this.clear(); ++W < se; ) {
                  var Te = L[W];
                  this.set(Te[0], Te[1]);
                }
              }
              function Qj() {
                this.__data__ = cI ? cI(null) : {}, this.size = 0;
              }
              function Pte(L) {
                var W = this.has(L) && delete this.__data__[L];
                return this.size -= W ? 1 : 0, W;
              }
              function Lte(L) {
                var W = this.__data__;
                if (cI) {
                  var se = W[L];
                  return se === Be ? Q : se;
                }
                return Ks.call(W, L) ? W[L] : Q;
              }
              function Ote(L) {
                var W = this.__data__;
                return cI ? W[L] !== Q : Ks.call(W, L);
              }
              function eG(L, W) {
                var se = this.__data__;
                return this.size += this.has(L) ? 0 : 1, se[L] = cI && W === Q ? Be : W, this;
              }
              Uw.prototype.clear = Qj, Uw.prototype.delete = Pte, Uw.prototype.get = Lte, Uw.prototype.has = Ote, Uw.prototype.set = eG;
              function H1(L) {
                var W = -1, se = L == null ? 0 : L.length;
                for (this.clear(); ++W < se; ) {
                  var Te = L[W];
                  this.set(Te[0], Te[1]);
                }
              }
              function Rte() {
                this.__data__ = [], this.size = 0;
              }
              function Fte(L) {
                var W = this.__data__, se = FP(W, L);
                if (se < 0)
                  return false;
                var Te = W.length - 1;
                return se == Te ? W.pop() : dC.call(W, se, 1), --this.size, true;
              }
              function tG(L) {
                var W = this.__data__, se = FP(W, L);
                return se < 0 ? Q : W[se][1];
              }
              function nG(L) {
                return FP(this.__data__, L) > -1;
              }
              function Nte(L, W) {
                var se = this.__data__, Te = FP(se, L);
                return Te < 0 ? (++this.size, se.push([L, W])) : se[Te][1] = W, this;
              }
              H1.prototype.clear = Rte, H1.prototype.delete = Fte, H1.prototype.get = tG, H1.prototype.has = nG, H1.prototype.set = Nte;
              function $1(L) {
                var W = -1, se = L == null ? 0 : L.length;
                for (this.clear(); ++W < se; ) {
                  var Te = L[W];
                  this.set(Te[0], Te[1]);
                }
              }
              function Vte() {
                this.size = 0, this.__data__ = { hash: new Uw(), map: new (lI || H1)(), string: new Uw() };
              }
              function zte(L) {
                var W = TG(this, L).delete(L);
                return this.size -= W ? 1 : 0, W;
              }
              function _C(L) {
                return TG(this, L).get(L);
              }
              function Bte(L) {
                return TG(this, L).has(L);
              }
              function jte(L, W) {
                var se = TG(this, L), Te = se.size;
                return se.set(L, W), this.size += se.size == Te ? 0 : 1, this;
              }
              $1.prototype.clear = Vte, $1.prototype.delete = zte, $1.prototype.get = _C, $1.prototype.has = Bte, $1.prototype.set = jte;
              function qw(L) {
                var W = -1, se = L == null ? 0 : L.length;
                for (this.__data__ = new $1(); ++W < se; )
                  this.add(L[W]);
              }
              function Gte(L) {
                return this.__data__.set(L, Be), this;
              }
              function Wte(L) {
                return this.__data__.has(L);
              }
              qw.prototype.add = qw.prototype.push = Gte, qw.prototype.has = Wte;
              function kg(L) {
                var W = this.__data__ = new H1(L);
                this.size = W.size;
              }
              function rG() {
                this.__data__ = new H1(), this.size = 0;
              }
              function Hte(L) {
                var W = this.__data__, se = W.delete(L);
                return this.size = W.size, se;
              }
              function $te(L) {
                return this.__data__.get(L);
              }
              function Ute(L) {
                return this.__data__.has(L);
              }
              function qte(L, W) {
                var se = this.__data__;
                if (se instanceof H1) {
                  var Te = se.__data__;
                  if (!lI || Te.length < re - 1)
                    return Te.push([L, W]), this.size = ++se.size, this;
                  se = this.__data__ = new $1(Te);
                }
                return se.set(L, W), this.size = se.size, this;
              }
              kg.prototype.clear = rG, kg.prototype.delete = Hte, kg.prototype.get = $te, kg.prototype.has = Ute, kg.prototype.set = qte;
              function aG(L, W) {
                var se = cs(L), Te = !se && mI(L), qe = !se && !Te && wC(L), mt = !se && !Te && !qe && GP(L), Ut = se || Te || qe || mt, rn = Ut ? xF(L.length, bte) : [], Dn = rn.length;
                for (var Xr in L)
                  (W || Ks.call(L, Xr)) && !(Ut && (Xr == "length" || qe && (Xr == "offset" || Xr == "parent") || mt && (Xr == "buffer" || Xr == "byteLength" || Xr == "byteOffset") || Qw(Xr, Dn))) && rn.push(Xr);
                return rn;
              }
              function iG(L) {
                var W = L.length;
                return W ? L[BF(0, W - 1)] : Q;
              }
              function Yte(L, W) {
                return DG(Og(L), Yw(W, 0, L.length));
              }
              function Zte(L) {
                return DG(Og(L));
              }
              function IF(L, W, se) {
                (se !== Q && !q1(L[W], se) || se === Q && !(W in L)) && U1(L, W, se);
              }
              function fI(L, W, se) {
                var Te = L[W];
                (!(Ks.call(L, W) && q1(Te, se)) || se === Q && !(W in L)) && U1(L, W, se);
              }
              function FP(L, W) {
                for (var se = L.length; se--; )
                  if (q1(L[se][0], W))
                    return se;
                return -1;
              }
              function Xte(L, W, se, Te) {
                return A_(L, function(qe, mt, Ut) {
                  W(Te, qe, se(qe), Ut);
                }), Te;
              }
              function oG(L, W) {
                return L && E_(W, Rd(W), L);
              }
              function Kte(L, W) {
                return L && E_(W, Fg(W), L);
              }
              function U1(L, W, se) {
                W == "__proto__" && Ld ? Ld(L, W, { configurable: true, enumerable: true, value: se, writable: true }) : L[W] = se;
              }
              function TF(L, W) {
                for (var se = -1, Te = W.length, qe = Zn(Te), mt = L == null; ++se < Te; )
                  qe[se] = mt ? Q : kne(L, W[se]);
                return qe;
              }
              function Yw(L, W, se) {
                return L === L && (se !== Q && (L = L <= se ? L : se), W !== Q && (L = L >= W ? L : W)), L;
              }
              function Pg(L, W, se, Te, qe, mt) {
                var Ut, rn = W & yt, Dn = W & Gt, Xr = W & Xt;
                if (se && (Ut = qe ? se(L, Te, qe, mt) : se(L)), Ut !== Q)
                  return Ut;
                if (!hf(L))
                  return L;
                var Kr = cs(L);
                if (Kr) {
                  if (Ut = AQe(L), !rn)
                    return Og(L, Ut);
                } else {
                  var va = cv(L), Ja = va == av || va == Cg;
                  if (wC(L))
                    return p_e(L, rn);
                  if (va == Td || va == Ss || Ja && !qe) {
                    if (Ut = Dn || Ja ? {} : O_e(L), !rn)
                      return Dn ? vQe(L, Kte(Ut, L)) : pQe(L, oG(Ut, L));
                  } else {
                    if (!Hu[va])
                      return qe ? L : {};
                    Ut = EQe(L, va, rn);
                  }
                }
                mt || (mt = new kg());
                var Li = mt.get(L);
                if (Li)
                  return Li;
                mt.set(L, Ut), uxe(L) ? L.forEach(function(po) {
                  Ut.add(Pg(po, W, se, po, L, mt));
                }) : sxe(L) && L.forEach(function(po, cl) {
                  Ut.set(cl, Pg(po, W, se, cl, L, mt));
                });
                var ho = Xr ? Dn ? mne : gne : Dn ? Fg : Rd, Fs = Kr ? Q : ho(L);
                return Ig(Fs || L, function(po, cl) {
                  Fs && (cl = po, po = L[cl]), fI(Ut, cl, Pg(po, W, se, cl, L, mt));
                }), Ut;
              }
              function Jte(L) {
                var W = Rd(L);
                return function(se) {
                  return sG(se, L, W);
                };
              }
              function sG(L, W, se) {
                var Te = se.length;
                if (L == null)
                  return !Te;
                for (L = Pu(L); Te--; ) {
                  var qe = se[Te], mt = W[qe], Ut = L[qe];
                  if (Ut === Q && !(qe in L) || !mt(Ut))
                    return false;
                }
                return true;
              }
              function lG(L, W, se) {
                if (typeof L != "function")
                  throw new Tg(Ee);
                return $F(function() {
                  L.apply(Q, se);
                }, W);
              }
              function hI(L, W, se, Te) {
                var qe = -1, mt = yP, Ut = true, rn = L.length, Dn = [], Xr = W.length;
                if (!rn)
                  return Dn;
                se && (W = yc(W, sv(se))), Te ? (mt = gF, Ut = false) : W.length >= re && (mt = Hw, Ut = false, W = new qw(W));
                e:
                  for (; ++qe < rn; ) {
                    var Kr = L[qe], va = se == null ? Kr : se(Kr);
                    if (Kr = Te || Kr !== 0 ? Kr : 0, Ut && va === va) {
                      for (var Ja = Xr; Ja--; )
                        if (W[Ja] === va)
                          continue e;
                      Dn.push(Kr);
                    } else
                      mt(W, va, Te) || Dn.push(Kr);
                  }
                return Dn;
              }
              var A_ = b_e(Lg), uG = b_e(PF, true);
              function Qte(L, W) {
                var se = true;
                return A_(L, function(Te, qe, mt) {
                  return se = !!W(Te, qe, mt), se;
                }), se;
              }
              function xC(L, W, se) {
                for (var Te = -1, qe = L.length; ++Te < qe; ) {
                  var mt = L[Te], Ut = W(mt);
                  if (Ut != null && (rn === Q ? Ut === Ut && !$0(Ut) : se(Ut, rn)))
                    var rn = Ut, Dn = mt;
                }
                return Dn;
              }
              function cG(L, W, se, Te) {
                var qe = L.length;
                for (se = Es(se), se < 0 && (se = -se > qe ? 0 : qe + se), Te = Te === Q || Te > qe ? qe : Es(Te), Te < 0 && (Te += qe), Te = se > Te ? 0 : fxe(Te); se < Te; )
                  L[se++] = W;
                return L;
              }
              function DF(L, W) {
                var se = [];
                return A_(L, function(Te, qe, mt) {
                  W(Te, qe, mt) && se.push(Te);
                }), se;
              }
              function Yh(L, W, se, Te, qe) {
                var mt = -1, Ut = L.length;
                for (se || (se = TQe), qe || (qe = []); ++mt < Ut; ) {
                  var rn = L[mt];
                  W > 0 && se(rn) ? W > 1 ? Yh(rn, W - 1, se, Te, qe) : C_(qe, rn) : Te || (qe[qe.length] = rn);
                }
                return qe;
              }
              var kF = x_e(), fG = x_e(true);
              function Lg(L, W) {
                return L && kF(L, W, Rd);
              }
              function PF(L, W) {
                return L && fG(L, W, Rd);
              }
              function NP(L, W) {
                return S_(W, function(se) {
                  return e22(L[se]);
                });
              }
              function Zw(L, W) {
                W = fu(W, L);
                for (var se = 0, Te = W.length; L != null && se < Te; )
                  L = L[I_(W[se++])];
                return se && se == Te ? L : Q;
              }
              function _p(L, W, se) {
                var Te = W(L);
                return cs(L) ? Te : C_(Te, se(L));
              }
              function Zh(L) {
                return L == null ? L === Q ? ki : j0 : dy && dy in Pu(L) ? SQe(L) : FQe(L);
              }
              function LF(L, W) {
                return L > W;
              }
              function ene(L, W) {
                return L != null && Ks.call(L, W);
              }
              function tne(L, W) {
                return L != null && W in Pu(L);
              }
              function nne(L, W, se) {
                return L >= qh(W, se) && L < Ul(W, se);
              }
              function dI(L, W, se) {
                for (var Te = se ? gF : yP, qe = L[0].length, mt = L.length, Ut = mt, rn = Zn(mt), Dn = 1 / 0, Xr = []; Ut--; ) {
                  var Kr = L[Ut];
                  Ut && W && (Kr = yc(Kr, sv(W))), Dn = qh(Kr.length, Dn), rn[Ut] = !se && (W || qe >= 120 && Kr.length >= 120) ? new qw(Ut && Kr) : Q;
                }
                Kr = L[0];
                var va = -1, Ja = rn[0];
                e:
                  for (; ++va < qe && Xr.length < Dn; ) {
                    var Li = Kr[va], ho = W ? W(Li) : Li;
                    if (Li = se || Li !== 0 ? Li : 0, !(Ja ? Hw(Ja, ho) : Te(Xr, ho, se))) {
                      for (Ut = mt; --Ut; ) {
                        var Fs = rn[Ut];
                        if (!(Fs ? Hw(Fs, ho) : Te(L[Ut], ho, se)))
                          continue e;
                      }
                      Ja && Ja.push(ho), Xr.push(Li);
                    }
                  }
                return Xr;
              }
              function rne(L, W, se, Te) {
                return Lg(L, function(qe, mt, Ut) {
                  W(Te, se(qe), mt, Ut);
                }), Te;
              }
              function Xw(L, W, se) {
                W = fu(W, L), L = V_e(L, W);
                var Te = L == null ? L : L[I_(vy(W))];
                return Te == null ? Q : Wv(Te, L, se);
              }
              function hG(L) {
                return Mf(L) && Zh(L) == Ss;
              }
              function ane(L) {
                return Mf(L) && Zh(L) == Vn;
              }
              function ine(L) {
                return Mf(L) && Zh(L) == yl;
              }
              function pI(L, W, se, Te, qe) {
                return L === W ? true : L == null || W == null || !Mf(L) && !Mf(W) ? L !== L && W !== W : dG(L, W, se, Te, pI, qe);
              }
              function dG(L, W, se, Te, qe, mt) {
                var Ut = cs(L), rn = cs(W), Dn = Ut ? Uo : cv(L), Xr = rn ? Uo : cv(W);
                Dn = Dn == Ss ? Td : Dn, Xr = Xr == Ss ? Td : Xr;
                var Kr = Dn == Td, va = Xr == Td, Ja = Dn == Xr;
                if (Ja && wC(L)) {
                  if (!wC(W))
                    return false;
                  Ut = true, Kr = false;
                }
                if (Ja && !Kr)
                  return mt || (mt = new kg()), Ut || GP(L) ? k_e(L, W, se, Te, qe, mt) : xQe(L, W, Dn, se, Te, qe, mt);
                if (!(se & Zt)) {
                  var Li = Kr && Ks.call(L, "__wrapped__"), ho = va && Ks.call(W, "__wrapped__");
                  if (Li || ho) {
                    var Fs = Li ? L.value() : L, po = ho ? W.value() : W;
                    return mt || (mt = new kg()), qe(Fs, po, se, Te, mt);
                  }
                }
                return Ja ? (mt || (mt = new kg()), wQe(L, W, se, Te, qe, mt)) : false;
              }
              function one(L) {
                return Mf(L) && cv(L) == Sf;
              }
              function OF(L, W, se, Te) {
                var qe = se.length, mt = qe, Ut = !Te;
                if (L == null)
                  return !mt;
                for (L = Pu(L); qe--; ) {
                  var rn = se[qe];
                  if (Ut && rn[2] ? rn[1] !== L[rn[0]] : !(rn[0] in L))
                    return false;
                }
                for (; ++qe < mt; ) {
                  rn = se[qe];
                  var Dn = rn[0], Xr = L[Dn], Kr = rn[1];
                  if (Ut && rn[2]) {
                    if (Xr === Q && !(Dn in L))
                      return false;
                  } else {
                    var va = new kg();
                    if (Te)
                      var Ja = Te(Xr, Kr, Dn, L, W, va);
                    if (!(Ja === Q ? pI(Kr, Xr, Zt | un, Te, va) : Ja))
                      return false;
                  }
                }
                return true;
              }
              function pG(L) {
                if (!hf(L) || kQe(L))
                  return false;
                var W = e22(L) ? xte : mr;
                return W.test(gI(L));
              }
              function RF(L) {
                return Mf(L) && Zh(L) == iv;
              }
              function FF(L) {
                return Mf(L) && cv(L) == Ec;
              }
              function sne(L) {
                return Mf(L) && FG(L.length) && !!rc[Zh(L)];
              }
              function vG(L) {
                return typeof L == "function" ? L : L == null ? Ng : typeof L == "object" ? cs(L) ? yG(L[0], L[1]) : mG(L) : wxe(L);
              }
              function NF(L) {
                if (!HF(L))
                  return Zj(L);
                var W = [];
                for (var se in Pu(L))
                  Ks.call(L, se) && se != "constructor" && W.push(se);
                return W;
              }
              function lne(L) {
                if (!hf(L))
                  return RQe(L);
                var W = HF(L), se = [];
                for (var Te in L)
                  Te == "constructor" && (W || !Ks.call(L, Te)) || se.push(Te);
                return se;
              }
              function VF(L, W) {
                return L < W;
              }
              function gG(L, W) {
                var se = -1, Te = Rg(L) ? Zn(L.length) : [];
                return A_(L, function(qe, mt, Ut) {
                  Te[++se] = W(qe, mt, Ut);
                }), Te;
              }
              function mG(L) {
                var W = bne(L);
                return W.length == 1 && W[0][2] ? F_e(W[0][0], W[0][1]) : function(se) {
                  return se === L || OF(se, L, W);
                };
              }
              function yG(L, W) {
                return xne(L) && R_e(W) ? F_e(I_(L), W) : function(se) {
                  var Te = kne(se, L);
                  return Te === Q && Te === W ? Pne(se, L) : pI(W, Te, Zt | un);
                };
              }
              function VP(L, W, se, Te, qe) {
                L !== W && kF(W, function(mt, Ut) {
                  if (qe || (qe = new kg()), hf(mt))
                    une(L, W, Ut, se, VP, Te, qe);
                  else {
                    var rn = Te ? Te(Sne(L, Ut), mt, Ut + "", L, W, qe) : Q;
                    rn === Q && (rn = mt), IF(L, Ut, rn);
                  }
                }, Fg);
              }
              function une(L, W, se, Te, qe, mt, Ut) {
                var rn = Sne(L, se), Dn = Sne(W, se), Xr = Ut.get(Dn);
                if (Xr) {
                  IF(L, se, Xr);
                  return;
                }
                var Kr = mt ? mt(rn, Dn, se + "", L, W, Ut) : Q, va = Kr === Q;
                if (va) {
                  var Ja = cs(Dn), Li = !Ja && wC(Dn), ho = !Ja && !Li && GP(Dn);
                  Kr = Dn, Ja || Li || ho ? cs(rn) ? Kr = rn : $f(rn) ? Kr = Og(rn) : Li ? (va = false, Kr = p_e(Dn, true)) : ho ? (va = false, Kr = v_e(Dn, true)) : Kr = [] : UF(Dn) || mI(Dn) ? (Kr = rn, mI(rn) ? Kr = hxe(rn) : (!hf(rn) || e22(rn)) && (Kr = O_e(Dn))) : va = false;
                }
                va && (Ut.set(Dn, Kr), qe(Kr, Dn, Te, mt, Ut), Ut.delete(Dn)), IF(L, se, Kr);
              }
              function bG(L, W) {
                var se = L.length;
                if (se)
                  return W += W < 0 ? se : 0, Qw(W, se) ? L[W] : Q;
              }
              function _G(L, W, se) {
                W.length ? W = yc(W, function(mt) {
                  return cs(mt) ? function(Ut) {
                    return Zw(Ut, mt.length === 1 ? mt[0] : mt);
                  } : mt;
                }) : W = [Ng];
                var Te = -1;
                W = yc(W, sv(lo()));
                var qe = gG(L, function(mt, Ut, rn) {
                  var Dn = yc(W, function(Xr) {
                    return Xr(mt);
                  });
                  return { criteria: Dn, index: ++Te, value: mt };
                });
                return ote(qe, function(mt, Ut) {
                  return dQe(mt, Ut, se);
                });
              }
              function cne(L, W) {
                return xG(L, W, function(se, Te) {
                  return Pne(L, Te);
                });
              }
              function xG(L, W, se) {
                for (var Te = -1, qe = W.length, mt = {}; ++Te < qe; ) {
                  var Ut = W[Te], rn = Zw(L, Ut);
                  se(rn, Ut) && ae(mt, fu(Ut, L), rn);
                }
                return mt;
              }
              function fne(L) {
                return function(W) {
                  return Zw(W, L);
                };
              }
              function zF(L, W, se, Te) {
                var qe = Te ? ite : lC, mt = -1, Ut = W.length, rn = L;
                for (L === W && (W = Og(W)), se && (rn = yc(L, sv(se))); ++mt < Ut; )
                  for (var Dn = 0, Xr = W[mt], Kr = se ? se(Xr) : Xr; (Dn = qe(rn, Kr, Dn, Te)) > -1; )
                    rn !== L && dC.call(rn, Dn, 1), dC.call(L, Dn, 1);
                return L;
              }
              function wG(L, W) {
                for (var se = L ? W.length : 0, Te = se - 1; se--; ) {
                  var qe = W[se];
                  if (se == Te || qe !== mt) {
                    var mt = qe;
                    Qw(qe) ? dC.call(L, qe, 1) : Ki(L, qe);
                  }
                }
                return L;
              }
              function BF(L, W) {
                return L + PP(Xj() * (W - L + 1));
              }
              function hne(L, W, se, Te) {
                for (var qe = -1, mt = Ul(kP((W - L) / (se || 1)), 0), Ut = Zn(mt); mt--; )
                  Ut[Te ? mt : ++qe] = L, L += se;
                return Ut;
              }
              function jF(L, W) {
                var se = "";
                if (!L || W < 1 || W > xr)
                  return se;
                do
                  W % 2 && (se += L), W = PP(W / 2), W && (L += L);
                while (W);
                return se;
              }
              function As(L, W) {
                return Cne(N_e(L, W, Ng), L + "");
              }
              function P(L) {
                return iG(WP(L));
              }
              function G(L, W) {
                var se = WP(L);
                return DG(se, Yw(W, 0, se.length));
              }
              function ae(L, W, se, Te) {
                if (!hf(L))
                  return L;
                W = fu(W, L);
                for (var qe = -1, mt = W.length, Ut = mt - 1, rn = L; rn != null && ++qe < mt; ) {
                  var Dn = I_(W[qe]), Xr = se;
                  if (Dn === "__proto__" || Dn === "constructor" || Dn === "prototype")
                    return L;
                  if (qe != Ut) {
                    var Kr = rn[Dn];
                    Xr = Te ? Te(Kr, Dn, rn) : Q, Xr === Q && (Xr = hf(Kr) ? Kr : Qw(W[qe + 1]) ? [] : {});
                  }
                  fI(rn, Dn, Xr), rn = rn[Dn];
                }
                return L;
              }
              var Me = LP ? function(L, W) {
                return LP.set(L, W), L;
              } : Ng, Ue = Ld ? function(L, W) {
                return Ld(L, "toString", { configurable: true, enumerable: false, value: One(W), writable: true });
              } : Ng;
              function gt(L) {
                return DG(WP(L));
              }
              function jt(L, W, se) {
                var Te = -1, qe = L.length;
                W < 0 && (W = -W > qe ? 0 : qe + W), se = se > qe ? qe : se, se < 0 && (se += qe), qe = W > se ? 0 : se - W >>> 0, W >>>= 0;
                for (var mt = Zn(qe); ++Te < qe; )
                  mt[Te] = L[Te + W];
                return mt;
              }
              function tn(L, W) {
                var se;
                return A_(L, function(Te, qe, mt) {
                  return se = W(Te, qe, mt), !se;
                }), !!se;
              }
              function Sn(L, W, se) {
                var Te = 0, qe = L == null ? Te : L.length;
                if (typeof W == "number" && W === W && qe <= Xi) {
                  for (; Te < qe; ) {
                    var mt = Te + qe >>> 1, Ut = L[mt];
                    Ut !== null && !$0(Ut) && (se ? Ut <= W : Ut < W) ? Te = mt + 1 : qe = mt;
                  }
                  return qe;
                }
                return Hr(L, W, Ng, se);
              }
              function Hr(L, W, se, Te) {
                var qe = 0, mt = L == null ? 0 : L.length;
                if (mt === 0)
                  return 0;
                W = se(W);
                for (var Ut = W !== W, rn = W === null, Dn = $0(W), Xr = W === Q; qe < mt; ) {
                  var Kr = PP((qe + mt) / 2), va = se(L[Kr]), Ja = va !== Q, Li = va === null, ho = va === va, Fs = $0(va);
                  if (Ut)
                    var po = Te || ho;
                  else
                    Xr ? po = ho && (Te || Ja) : rn ? po = ho && Ja && (Te || !Li) : Dn ? po = ho && Ja && !Li && (Te || !Fs) : Li || Fs ? po = false : po = Te ? va <= W : va < W;
                  po ? qe = Kr + 1 : mt = Kr;
                }
                return qh(mt, la);
              }
              function qr(L, W) {
                for (var se = -1, Te = L.length, qe = 0, mt = []; ++se < Te; ) {
                  var Ut = L[se], rn = W ? W(Ut) : Ut;
                  if (!se || !q1(rn, Dn)) {
                    var Dn = rn;
                    mt[qe++] = Ut === 0 ? 0 : Ut;
                  }
                }
                return mt;
              }
              function ca(L) {
                return typeof L == "number" ? L : $0(L) ? Kn : +L;
              }
              function Aa(L) {
                if (typeof L == "string")
                  return L;
                if (cs(L))
                  return yc(L, Aa) + "";
                if ($0(L))
                  return Jj ? Jj.call(L) : "";
                var W = L + "";
                return W == "0" && 1 / L == -Pi ? "-0" : W;
              }
              function fi(L, W, se) {
                var Te = -1, qe = yP, mt = L.length, Ut = true, rn = [], Dn = rn;
                if (se)
                  Ut = false, qe = gF;
                else if (mt >= re) {
                  var Xr = W ? null : bQe(L);
                  if (Xr)
                    return MP(Xr);
                  Ut = false, qe = Hw, Dn = new qw();
                } else
                  Dn = W ? [] : rn;
                e:
                  for (; ++Te < mt; ) {
                    var Kr = L[Te], va = W ? W(Kr) : Kr;
                    if (Kr = se || Kr !== 0 ? Kr : 0, Ut && va === va) {
                      for (var Ja = Dn.length; Ja--; )
                        if (Dn[Ja] === va)
                          continue e;
                      W && Dn.push(va), rn.push(Kr);
                    } else
                      qe(Dn, va, se) || (Dn !== rn && Dn.push(va), rn.push(Kr));
                  }
                return rn;
              }
              function Ki(L, W) {
                return W = fu(W, L), L = V_e(L, W), L == null || delete L[I_(vy(W))];
              }
              function us(L, W, se, Te) {
                return ae(L, W, se(Zw(L, W)), Te);
              }
              function Ui(L, W, se, Te) {
                for (var qe = L.length, mt = Te ? qe : -1; (Te ? mt-- : ++mt < qe) && W(L[mt], mt, L); )
                  ;
                return se ? jt(L, Te ? 0 : mt, Te ? mt + 1 : qe) : jt(L, Te ? mt + 1 : 0, Te ? qe : mt);
              }
              function Rs(L, W) {
                var se = L;
                return se instanceof $i && (se = se.value()), bP(W, function(Te, qe) {
                  return qe.func.apply(qe.thisArg, C_([Te], qe.args));
                }, se);
              }
              function Js(L, W, se) {
                var Te = L.length;
                if (Te < 2)
                  return Te ? fi(L[0]) : [];
                for (var qe = -1, mt = Zn(Te); ++qe < Te; )
                  for (var Ut = L[qe], rn = -1; ++rn < Te; )
                    rn != qe && (mt[qe] = hI(mt[qe] || Ut, L[rn], W, se));
                return fi(Yh(mt, 1), W, se);
              }
              function uv(L, W, se) {
                for (var Te = -1, qe = L.length, mt = W.length, Ut = {}; ++Te < qe; ) {
                  var rn = Te < mt ? W[Te] : Q;
                  se(Ut, L[Te], rn);
                }
                return Ut;
              }
              function Xh(L) {
                return $f(L) ? L : [];
              }
              function xp(L) {
                return typeof L == "function" ? L : Ng;
              }
              function fu(L, W) {
                return cs(L) ? L : xne(L, W) ? [L] : G_e(hu(L));
              }
              var H0 = As;
              function Od(L, W, se) {
                var Te = L.length;
                return se = se === Q ? Te : se, !W && se >= Te ? L : jt(L, W, se);
              }
              var GF = vC || function(L) {
                return Uh.clearTimeout(L);
              };
              function p_e(L, W) {
                if (W)
                  return L.slice();
                var se = L.length, Te = Uj ? Uj(se) : new L.constructor(se);
                return L.copy(Te), Te;
              }
              function dne(L) {
                var W = new L.constructor(L.byteLength);
                return new TP(W).set(new TP(L)), W;
              }
              function cQe(L, W) {
                var se = W ? dne(L.buffer) : L.buffer;
                return new L.constructor(se, L.byteOffset, L.byteLength);
              }
              function fQe(L) {
                var W = new L.constructor(L.source, At.exec(L));
                return W.lastIndex = L.lastIndex, W;
              }
              function hQe(L) {
                return $w ? Pu($w.call(L)) : {};
              }
              function v_e(L, W) {
                var se = W ? dne(L.buffer) : L.buffer;
                return new L.constructor(se, L.byteOffset, L.length);
              }
              function g_e(L, W) {
                if (L !== W) {
                  var se = L !== Q, Te = L === null, qe = L === L, mt = $0(L), Ut = W !== Q, rn = W === null, Dn = W === W, Xr = $0(W);
                  if (!rn && !Xr && !mt && L > W || mt && Ut && Dn && !rn && !Xr || Te && Ut && Dn || !se && Dn || !qe)
                    return 1;
                  if (!Te && !mt && !Xr && L < W || Xr && se && qe && !Te && !mt || rn && se && qe || !Ut && qe || !Dn)
                    return -1;
                }
                return 0;
              }
              function dQe(L, W, se) {
                for (var Te = -1, qe = L.criteria, mt = W.criteria, Ut = qe.length, rn = se.length; ++Te < Ut; ) {
                  var Dn = g_e(qe[Te], mt[Te]);
                  if (Dn) {
                    if (Te >= rn)
                      return Dn;
                    var Xr = se[Te];
                    return Dn * (Xr == "desc" ? -1 : 1);
                  }
                }
                return L.index - W.index;
              }
              function m_e(L, W, se, Te) {
                for (var qe = -1, mt = L.length, Ut = se.length, rn = -1, Dn = W.length, Xr = Ul(mt - Ut, 0), Kr = Zn(Dn + Xr), va = !Te; ++rn < Dn; )
                  Kr[rn] = W[rn];
                for (; ++qe < Ut; )
                  (va || qe < mt) && (Kr[se[qe]] = L[qe]);
                for (; Xr--; )
                  Kr[rn++] = L[qe++];
                return Kr;
              }
              function y_e(L, W, se, Te) {
                for (var qe = -1, mt = L.length, Ut = -1, rn = se.length, Dn = -1, Xr = W.length, Kr = Ul(mt - rn, 0), va = Zn(Kr + Xr), Ja = !Te; ++qe < Kr; )
                  va[qe] = L[qe];
                for (var Li = qe; ++Dn < Xr; )
                  va[Li + Dn] = W[Dn];
                for (; ++Ut < rn; )
                  (Ja || qe < mt) && (va[Li + se[Ut]] = L[qe++]);
                return va;
              }
              function Og(L, W) {
                var se = -1, Te = L.length;
                for (W || (W = Zn(Te)); ++se < Te; )
                  W[se] = L[se];
                return W;
              }
              function E_(L, W, se, Te) {
                var qe = !se;
                se || (se = {});
                for (var mt = -1, Ut = W.length; ++mt < Ut; ) {
                  var rn = W[mt], Dn = Te ? Te(se[rn], L[rn], rn, se, L) : Q;
                  Dn === Q && (Dn = L[rn]), qe ? U1(se, rn, Dn) : fI(se, rn, Dn);
                }
                return se;
              }
              function pQe(L, W) {
                return E_(L, _ne(L), W);
              }
              function vQe(L, W) {
                return E_(L, P_e(L), W);
              }
              function SG(L, W) {
                return function(se, Te) {
                  var qe = cs(se) ? ete : Xte, mt = W ? W() : {};
                  return qe(se, L, lo(Te, 2), mt);
                };
              }
              function zP(L) {
                return As(function(W, se) {
                  var Te = -1, qe = se.length, mt = qe > 1 ? se[qe - 1] : Q, Ut = qe > 2 ? se[2] : Q;
                  for (mt = L.length > 3 && typeof mt == "function" ? (qe--, mt) : Q, Ut && Hv(se[0], se[1], Ut) && (mt = qe < 3 ? Q : mt, qe = 1), W = Pu(W); ++Te < qe; ) {
                    var rn = se[Te];
                    rn && L(W, rn, Te, mt);
                  }
                  return W;
                });
              }
              function b_e(L, W) {
                return function(se, Te) {
                  if (se == null)
                    return se;
                  if (!Rg(se))
                    return L(se, Te);
                  for (var qe = se.length, mt = W ? qe : -1, Ut = Pu(se); (W ? mt-- : ++mt < qe) && Te(Ut[mt], mt, Ut) !== false; )
                    ;
                  return se;
                };
              }
              function x_e(L) {
                return function(W, se, Te) {
                  for (var qe = -1, mt = Pu(W), Ut = Te(W), rn = Ut.length; rn--; ) {
                    var Dn = Ut[L ? rn : ++qe];
                    if (se(mt[Dn], Dn, mt) === false)
                      break;
                  }
                  return W;
                };
              }
              function gQe(L, W, se) {
                var Te = W & yn, qe = WF(L);
                function mt() {
                  var Ut = this && this !== Uh && this instanceof mt ? qe : L;
                  return Ut.apply(Te ? se : this, arguments);
                }
                return mt;
              }
              function w_e(L) {
                return function(W) {
                  W = hu(W);
                  var se = G1(W) ? W0(W) : Q, Te = se ? se[0] : W.charAt(0), qe = se ? Od(se, 1).join("") : W.slice(1);
                  return Te[L]() + qe;
                };
              }
              function BP(L) {
                return function(W) {
                  return bP(_xe(bxe(W).replace(Gee, "")), L, "");
                };
              }
              function WF(L) {
                return function() {
                  var W = arguments;
                  switch (W.length) {
                    case 0:
                      return new L();
                    case 1:
                      return new L(W[0]);
                    case 2:
                      return new L(W[0], W[1]);
                    case 3:
                      return new L(W[0], W[1], W[2]);
                    case 4:
                      return new L(W[0], W[1], W[2], W[3]);
                    case 5:
                      return new L(W[0], W[1], W[2], W[3], W[4]);
                    case 6:
                      return new L(W[0], W[1], W[2], W[3], W[4], W[5]);
                    case 7:
                      return new L(W[0], W[1], W[2], W[3], W[4], W[5], W[6]);
                  }
                  var se = bC(L.prototype), Te = L.apply(se, W);
                  return hf(Te) ? Te : se;
                };
              }
              function mQe(L, W, se) {
                var Te = WF(L);
                function qe() {
                  for (var mt = arguments.length, Ut = Zn(mt), rn = mt, Dn = jP(qe); rn--; )
                    Ut[rn] = arguments[rn];
                  var Xr = mt < 3 && Ut[0] !== Dn && Ut[mt - 1] !== Dn ? [] : W1(Ut, Dn);
                  if (mt -= Xr.length, mt < se)
                    return E_e(L, W, CG, qe.placeholder, Q, Ut, Xr, Q, Q, se - mt);
                  var Kr = this && this !== Uh && this instanceof qe ? Te : L;
                  return Wv(Kr, this, Ut);
                }
                return qe;
              }
              function S_e(L) {
                return function(W, se, Te) {
                  var qe = Pu(W);
                  if (!Rg(W)) {
                    var mt = lo(se, 3);
                    W = Rd(W), se = function(rn) {
                      return mt(qe[rn], rn, qe);
                    };
                  }
                  var Ut = L(W, se, Te);
                  return Ut > -1 ? qe[mt ? W[Ut] : Ut] : Q;
                };
              }
              function C_e(L) {
                return Jw(function(W) {
                  var se = W.length, Te = se, qe = Dg.prototype.thru;
                  for (L && W.reverse(); Te--; ) {
                    var mt = W[Te];
                    if (typeof mt != "function")
                      throw new Tg(Ee);
                    if (qe && !Ut && IG(mt) == "wrapper")
                      var Ut = new Dg([], true);
                  }
                  for (Te = Ut ? Te : se; ++Te < se; ) {
                    mt = W[Te];
                    var rn = IG(mt), Dn = rn == "wrapper" ? yne(mt) : Q;
                    Dn && wne(Dn[0]) && Dn[1] == (pr | fa | pn | fr) && !Dn[4].length && Dn[9] == 1 ? Ut = Ut[IG(Dn[0])].apply(Ut, Dn[3]) : Ut = mt.length == 1 && wne(mt) ? Ut[rn]() : Ut.thru(mt);
                  }
                  return function() {
                    var Xr = arguments, Kr = Xr[0];
                    if (Ut && Xr.length == 1 && cs(Kr))
                      return Ut.plant(Kr).value();
                    for (var va = 0, Ja = se ? W[va].apply(this, Xr) : Kr; ++va < se; )
                      Ja = W[va].call(this, Ja);
                    return Ja;
                  };
                });
              }
              function CG(L, W, se, Te, qe, mt, Ut, rn, Dn, Xr) {
                var Kr = W & pr, va = W & yn, Ja = W & _r, Li = W & (fa | We), ho = W & Tn, Fs = Ja ? Q : WF(L);
                function po() {
                  for (var cl = arguments.length, bl = Zn(cl), U0 = cl; U0--; )
                    bl[U0] = arguments[U0];
                  if (Li)
                    var $v = jP(po), q0 = jj(bl, $v);
                  if (Te && (bl = m_e(bl, Te, qe, Li)), mt && (bl = y_e(bl, mt, Ut, Li)), cl -= q0, Li && cl < Xr) {
                    var Uf = W1(bl, $v);
                    return E_e(L, W, CG, po.placeholder, se, bl, Uf, rn, Dn, Xr - cl);
                  }
                  var Y1 = va ? se : this, n22 = Ja ? Y1[L] : L;
                  return cl = bl.length, rn ? bl = NQe(bl, rn) : ho && cl > 1 && bl.reverse(), Kr && Dn < cl && (bl.length = Dn), this && this !== Uh && this instanceof po && (n22 = Fs || WF(n22)), n22.apply(Y1, bl);
                }
                return po;
              }
              function M_e(L, W) {
                return function(se, Te) {
                  return rne(se, L, W(Te), {});
                };
              }
              function MG(L, W) {
                return function(se, Te) {
                  var qe;
                  if (se === Q && Te === Q)
                    return W;
                  if (se !== Q && (qe = se), Te !== Q) {
                    if (qe === Q)
                      return Te;
                    typeof se == "string" || typeof Te == "string" ? (se = Aa(se), Te = Aa(Te)) : (se = ca(se), Te = ca(Te)), qe = L(se, Te);
                  }
                  return qe;
                };
              }
              function pne(L) {
                return Jw(function(W) {
                  return W = yc(W, sv(lo())), As(function(se) {
                    var Te = this;
                    return L(W, function(qe) {
                      return Wv(qe, Te, se);
                    });
                  });
                });
              }
              function AG(L, W) {
                W = W === Q ? " " : Aa(W);
                var se = W.length;
                if (se < 2)
                  return se ? jF(W, L) : W;
                var Te = jF(W, kP(L / uC(W)));
                return G1(W) ? Od(W0(Te), 0, L).join("") : Te.slice(0, L);
              }
              function yQe(L, W, se, Te) {
                var qe = W & yn, mt = WF(L);
                function Ut() {
                  for (var rn = -1, Dn = arguments.length, Xr = -1, Kr = Te.length, va = Zn(Kr + Dn), Ja = this && this !== Uh && this instanceof Ut ? mt : L; ++Xr < Kr; )
                    va[Xr] = Te[Xr];
                  for (; Dn--; )
                    va[Xr++] = arguments[++rn];
                  return Wv(Ja, qe ? se : this, va);
                }
                return Ut;
              }
              function A_e(L) {
                return function(W, se, Te) {
                  return Te && typeof Te != "number" && Hv(W, se, Te) && (se = Te = Q), W = t22(W), se === Q ? (se = W, W = 0) : se = t22(se), Te = Te === Q ? W < se ? 1 : -1 : t22(Te), hne(W, se, Te, L);
                };
              }
              function EG(L) {
                return function(W, se) {
                  return typeof W == "string" && typeof se == "string" || (W = gy(W), se = gy(se)), L(W, se);
                };
              }
              function E_e(L, W, se, Te, qe, mt, Ut, rn, Dn, Xr) {
                var Kr = W & fa, va = Kr ? Ut : Q, Ja = Kr ? Q : Ut, Li = Kr ? mt : Q, ho = Kr ? Q : mt;
                W |= Kr ? pn : zn, W &= ~(Kr ? zn : pn), W & cr || (W &= ~(yn | _r));
                var Fs = [L, W, qe, Li, va, ho, Ja, rn, Dn, Xr], po = se.apply(Q, Fs);
                return wne(L) && z_e(po, Fs), po.placeholder = Te, B_e(po, L, W);
              }
              function vne(L) {
                var W = Ms[L];
                return function(se, Te) {
                  if (se = gy(se), Te = Te == null ? 0 : qh(Es(Te), 292), Te && py(se)) {
                    var qe = (hu(se) + "e").split("e"), mt = W(qe[0] + "e" + (+qe[1] + Te));
                    return qe = (hu(mt) + "e").split("e"), +(qe[0] + "e" + (+qe[1] - Te));
                  }
                  return W(se);
                };
              }
              var bQe = mC && 1 / MP(new mC([, -0]))[1] == Pi ? function(L) {
                return new mC(L);
              } : Nne;
              function I_e(L) {
                return function(W) {
                  var se = cv(W);
                  return se == Sf ? CF(W) : se == Ec ? fte(W) : xP(W, L(W));
                };
              }
              function Kw(L, W, se, Te, qe, mt, Ut, rn) {
                var Dn = W & _r;
                if (!Dn && typeof L != "function")
                  throw new Tg(Ee);
                var Xr = Te ? Te.length : 0;
                if (Xr || (W &= ~(pn | zn), Te = qe = Q), Ut = Ut === Q ? Ut : Ul(Es(Ut), 0), rn = rn === Q ? rn : Es(rn), Xr -= qe ? qe.length : 0, W & zn) {
                  var Kr = Te, va = qe;
                  Te = qe = Q;
                }
                var Ja = Dn ? Q : yne(L), Li = [L, W, se, Te, qe, Kr, va, mt, Ut, rn];
                if (Ja && OQe(Li, Ja), L = Li[0], W = Li[1], se = Li[2], Te = Li[3], qe = Li[4], rn = Li[9] = Li[9] === Q ? Dn ? 0 : L.length : Ul(Li[9] - Xr, 0), !rn && W & (fa | We) && (W &= ~(fa | We)), !W || W == yn)
                  var ho = gQe(L, W, se);
                else
                  W == fa || W == We ? ho = mQe(L, W, rn) : (W == pn || W == (yn | pn)) && !qe.length ? ho = yQe(L, W, se, Te) : ho = CG.apply(Q, Li);
                var Fs = Ja ? Me : z_e;
                return B_e(Fs(ho, Li), L, W);
              }
              function T_e(L, W, se, Te) {
                return L === Q || q1(L, cC[se]) && !Ks.call(Te, se) ? W : L;
              }
              function D_e(L, W, se, Te, qe, mt) {
                return hf(L) && hf(W) && (mt.set(W, L), VP(L, W, Q, D_e, mt), mt.delete(W)), L;
              }
              function _Qe(L) {
                return UF(L) ? Q : L;
              }
              function k_e(L, W, se, Te, qe, mt) {
                var Ut = se & Zt, rn = L.length, Dn = W.length;
                if (rn != Dn && !(Ut && Dn > rn))
                  return false;
                var Xr = mt.get(L), Kr = mt.get(W);
                if (Xr && Kr)
                  return Xr == W && Kr == L;
                var va = -1, Ja = true, Li = se & un ? new qw() : Q;
                for (mt.set(L, W), mt.set(W, L); ++va < rn; ) {
                  var ho = L[va], Fs = W[va];
                  if (Te)
                    var po = Ut ? Te(Fs, ho, va, W, L, mt) : Te(ho, Fs, va, L, W, mt);
                  if (po !== Q) {
                    if (po)
                      continue;
                    Ja = false;
                    break;
                  }
                  if (Li) {
                    if (!mF(W, function(cl, bl) {
                      if (!Hw(Li, bl) && (ho === cl || qe(ho, cl, se, Te, mt)))
                        return Li.push(bl);
                    })) {
                      Ja = false;
                      break;
                    }
                  } else if (!(ho === Fs || qe(ho, Fs, se, Te, mt))) {
                    Ja = false;
                    break;
                  }
                }
                return mt.delete(L), mt.delete(W), Ja;
              }
              function xQe(L, W, se, Te, qe, mt, Ut) {
                switch (se) {
                  case Br:
                    if (L.byteLength != W.byteLength || L.byteOffset != W.byteOffset)
                      return false;
                    L = L.buffer, W = W.buffer;
                  case Vn:
                    return !(L.byteLength != W.byteLength || !mt(new TP(L), new TP(W)));
                  case Cs:
                  case yl:
                  case gp:
                    return q1(+L, +W);
                  case Gc:
                    return L.name == W.name && L.message == W.message;
                  case iv:
                  case uf:
                    return L == W + "";
                  case Sf:
                    var rn = CF;
                  case Ec:
                    var Dn = Te & Zt;
                    if (rn || (rn = MP), L.size != W.size && !Dn)
                      return false;
                    var Xr = Ut.get(L);
                    if (Xr)
                      return Xr == W;
                    Te |= un, Ut.set(L, W);
                    var Kr = k_e(rn(L), rn(W), Te, qe, mt, Ut);
                    return Ut.delete(L), Kr;
                  case Tu:
                    if ($w)
                      return $w.call(L) == $w.call(W);
                }
                return false;
              }
              function wQe(L, W, se, Te, qe, mt) {
                var Ut = se & Zt, rn = gne(L), Dn = rn.length, Xr = gne(W), Kr = Xr.length;
                if (Dn != Kr && !Ut)
                  return false;
                for (var va = Dn; va--; ) {
                  var Ja = rn[va];
                  if (!(Ut ? Ja in W : Ks.call(W, Ja)))
                    return false;
                }
                var Li = mt.get(L), ho = mt.get(W);
                if (Li && ho)
                  return Li == W && ho == L;
                var Fs = true;
                mt.set(L, W), mt.set(W, L);
                for (var po = Ut; ++va < Dn; ) {
                  Ja = rn[va];
                  var cl = L[Ja], bl = W[Ja];
                  if (Te)
                    var U0 = Ut ? Te(bl, cl, Ja, W, L, mt) : Te(cl, bl, Ja, L, W, mt);
                  if (!(U0 === Q ? cl === bl || qe(cl, bl, se, Te, mt) : U0)) {
                    Fs = false;
                    break;
                  }
                  po || (po = Ja == "constructor");
                }
                if (Fs && !po) {
                  var $v = L.constructor, q0 = W.constructor;
                  $v != q0 && "constructor" in L && "constructor" in W && !(typeof $v == "function" && $v instanceof $v && typeof q0 == "function" && q0 instanceof q0) && (Fs = false);
                }
                return mt.delete(L), mt.delete(W), Fs;
              }
              function Jw(L) {
                return Cne(N_e(L, Q, U_e), L + "");
              }
              function gne(L) {
                return _p(L, Rd, _ne);
              }
              function mne(L) {
                return _p(L, Fg, P_e);
              }
              var yne = LP ? function(L) {
                return LP.get(L);
              } : Nne;
              function IG(L) {
                for (var W = L.name + "", se = yC[W], Te = Ks.call(yC, W) ? se.length : 0; Te--; ) {
                  var qe = se[Te], mt = qe.func;
                  if (mt == null || mt == L)
                    return qe.name;
                }
                return W;
              }
              function jP(L) {
                var W = Ks.call(st, "placeholder") ? st : L;
                return W.placeholder;
              }
              function lo() {
                var L = st.iteratee || Rne;
                return L = L === Rne ? vG : L, arguments.length ? L(arguments[0], arguments[1]) : L;
              }
              function TG(L, W) {
                var se = L.__data__;
                return DQe(W) ? se[typeof W == "string" ? "string" : "hash"] : se.map;
              }
              function bne(L) {
                for (var W = Rd(L), se = W.length; se--; ) {
                  var Te = W[se], qe = L[Te];
                  W[se] = [Te, qe, R_e(qe)];
                }
                return W;
              }
              function vI(L, W) {
                var se = ute(L, W);
                return pG(se) ? se : Q;
              }
              function SQe(L) {
                var W = Ks.call(L, dy), se = L[dy];
                try {
                  L[dy] = Q;
                  var Te = true;
                } catch {
                }
                var qe = $u.call(L);
                return Te && (W ? L[dy] = se : delete L[dy]), qe;
              }
              var _ne = AF ? function(L) {
                return L == null ? [] : (L = Pu(L), S_(AF(L), function(W) {
                  return hC.call(L, W);
                }));
              } : Vne, P_e = AF ? function(L) {
                for (var W = []; L; )
                  C_(W, _ne(L)), L = DP(L);
                return W;
              } : Vne, cv = Zh;
              (gC && cv(new gC(new ArrayBuffer(1))) != Br || lI && cv(new lI()) != Sf || EF && cv(EF.resolve()) != Hh || mC && cv(new mC()) != Ec || uI && cv(new uI()) != Pr) && (cv = function(L) {
                var W = Zh(L), se = W == Td ? L.constructor : Q, Te = se ? gI(se) : "";
                if (Te)
                  switch (Te) {
                    case Mte:
                      return Br;
                    case Ate:
                      return Sf;
                    case Ete:
                      return Hh;
                    case Ite:
                      return Ec;
                    case Tte:
                      return Pr;
                  }
                return W;
              });
              function CQe(L, W, se) {
                for (var Te = -1, qe = se.length; ++Te < qe; ) {
                  var mt = se[Te], Ut = mt.size;
                  switch (mt.type) {
                    case "drop":
                      L += Ut;
                      break;
                    case "dropRight":
                      W -= Ut;
                      break;
                    case "take":
                      W = qh(W, L + Ut);
                      break;
                    case "takeRight":
                      L = Ul(L, W - Ut);
                      break;
                  }
                }
                return { start: L, end: W };
              }
              function MQe(L) {
                var W = L.match(uF);
                return W ? W[1].split(rI) : [];
              }
              function L_e(L, W, se) {
                W = fu(W, L);
                for (var Te = -1, qe = W.length, mt = false; ++Te < qe; ) {
                  var Ut = I_(W[Te]);
                  if (!(mt = L != null && se(L, Ut)))
                    break;
                  L = L[Ut];
                }
                return mt || ++Te != qe ? mt : (qe = L == null ? 0 : L.length, !!qe && FG(qe) && Qw(Ut, qe) && (cs(L) || mI(L)));
              }
              function AQe(L) {
                var W = L.length, se = new L.constructor(W);
                return W && typeof L[0] == "string" && Ks.call(L, "index") && (se.index = L.index, se.input = L.input), se;
              }
              function O_e(L) {
                return typeof L.constructor == "function" && !HF(L) ? bC(DP(L)) : {};
              }
              function EQe(L, W, se) {
                var Te = L.constructor;
                switch (W) {
                  case Vn:
                    return dne(L);
                  case Cs:
                  case yl:
                    return new Te(+L);
                  case Br:
                    return cQe(L, se);
                  case ka:
                  case gi:
                  case Ri:
                  case qo:
                  case Il:
                  case Wu:
                  case Du:
                  case Wc:
                  case ku:
                    return v_e(L, se);
                  case Sf:
                    return new Te();
                  case gp:
                  case uf:
                    return new Te(L);
                  case iv:
                    return fQe(L);
                  case Ec:
                    return new Te();
                  case Tu:
                    return hQe(L);
                }
              }
              function IQe(L, W) {
                var se = W.length;
                if (!se)
                  return L;
                var Te = se - 1;
                return W[Te] = (se > 1 ? "& " : "") + W[Te], W = W.join(se > 2 ? ", " : " "), L.replace(vP, `{
/* [wrapped with ` + W + `] */
`);
              }
              function TQe(L) {
                return cs(L) || mI(L) || !!(qj && L && L[qj]);
              }
              function Qw(L, W) {
                var se = typeof L;
                return W = W == null ? xr : W, !!W && (se == "number" || se != "symbol" && En.test(L)) && L > -1 && L % 1 == 0 && L < W;
              }
              function Hv(L, W, se) {
                if (!hf(se))
                  return false;
                var Te = typeof W;
                return (Te == "number" ? Rg(se) && Qw(W, se.length) : Te == "string" && W in se) ? q1(se[W], L) : false;
              }
              function xne(L, W) {
                if (cs(L))
                  return false;
                var se = typeof L;
                return se == "number" || se == "symbol" || se == "boolean" || L == null || $0(L) ? true : ov.test(L) || !kd.test(L) || W != null && L in Pu(W);
              }
              function DQe(L) {
                var W = typeof L;
                return W == "string" || W == "number" || W == "symbol" || W == "boolean" ? L !== "__proto__" : L === null;
              }
              function wne(L) {
                var W = IG(L), se = st[W];
                if (typeof se != "function" || !(W in $i.prototype))
                  return false;
                if (L === se)
                  return true;
                var Te = yne(se);
                return !!Te && L === Te[0];
              }
              function kQe(L) {
                return !!sI && sI in L;
              }
              var PQe = fC ? e22 : zne;
              function HF(L) {
                var W = L && L.constructor, se = typeof W == "function" && W.prototype || cC;
                return L === se;
              }
              function R_e(L) {
                return L === L && !hf(L);
              }
              function F_e(L, W) {
                return function(se) {
                  return se == null ? false : se[L] === W && (W !== Q || L in Pu(se));
                };
              }
              function LQe(L) {
                var W = OG(L, function(Te) {
                  return se.size === Ze && se.clear(), Te;
                }), se = W.cache;
                return W;
              }
              function OQe(L, W) {
                var se = L[1], Te = W[1], qe = se | Te, mt = qe < (yn | _r | pr), Ut = Te == pr && se == fa || Te == pr && se == fr && L[7].length <= W[8] || Te == (pr | fr) && W[7].length <= W[8] && se == fa;
                if (!(mt || Ut))
                  return L;
                Te & yn && (L[2] = W[2], qe |= se & yn ? 0 : cr);
                var rn = W[3];
                if (rn) {
                  var Dn = L[3];
                  L[3] = Dn ? m_e(Dn, rn, W[4]) : rn, L[4] = Dn ? W1(L[3], Je) : W[4];
                }
                return rn = W[5], rn && (Dn = L[5], L[5] = Dn ? y_e(Dn, rn, W[6]) : rn, L[6] = Dn ? W1(L[5], Je) : W[6]), rn = W[7], rn && (L[7] = rn), Te & pr && (L[8] = L[8] == null ? W[8] : qh(L[8], W[8])), L[9] == null && (L[9] = W[9]), L[0] = W[0], L[1] = qe, L;
              }
              function RQe(L) {
                var W = [];
                if (L != null)
                  for (var se in Pu(L))
                    W.push(se);
                return W;
              }
              function FQe(L) {
                return $u.call(L);
              }
              function N_e(L, W, se) {
                return W = Ul(W === Q ? L.length - 1 : W, 0), function() {
                  for (var Te = arguments, qe = -1, mt = Ul(Te.length - W, 0), Ut = Zn(mt); ++qe < mt; )
                    Ut[qe] = Te[W + qe];
                  qe = -1;
                  for (var rn = Zn(W + 1); ++qe < W; )
                    rn[qe] = Te[qe];
                  return rn[W] = se(Ut), Wv(L, this, rn);
                };
              }
              function V_e(L, W) {
                return W.length < 2 ? L : Zw(L, jt(W, 0, -1));
              }
              function NQe(L, W) {
                for (var se = L.length, Te = qh(W.length, se), qe = Og(L); Te--; ) {
                  var mt = W[Te];
                  L[Te] = Qw(mt, se) ? qe[mt] : Q;
                }
                return L;
              }
              function Sne(L, W) {
                if (!(W === "constructor" && typeof L[W] == "function") && W != "__proto__")
                  return L[W];
              }
              var z_e = j_e(Me), $F = Ste || function(L, W) {
                return Uh.setTimeout(L, W);
              }, Cne = j_e(Ue);
              function B_e(L, W, se) {
                var Te = W + "";
                return Cne(L, IQe(Te, VQe(MQe(Te), se)));
              }
              function j_e(L) {
                var W = 0, se = 0;
                return function() {
                  var Te = Cte(), qe = wn - (Te - se);
                  if (se = Te, qe > 0) {
                    if (++W >= ra)
                      return arguments[0];
                  } else
                    W = 0;
                  return L.apply(Q, arguments);
                };
              }
              function DG(L, W) {
                var se = -1, Te = L.length, qe = Te - 1;
                for (W = W === Q ? Te : W; ++se < W; ) {
                  var mt = BF(se, qe), Ut = L[mt];
                  L[mt] = L[se], L[se] = Ut;
                }
                return L.length = W, L;
              }
              var G_e = LQe(function(L) {
                var W = [];
                return L.charCodeAt(0) === 46 && W.push(""), L.replace(y_, function(se, Te, qe, mt) {
                  W.push(qe ? mt.replace(Vt, "$1") : Te || se);
                }), W;
              });
              function I_(L) {
                if (typeof L == "string" || $0(L))
                  return L;
                var W = L + "";
                return W == "0" && 1 / L == -Pi ? "-0" : W;
              }
              function gI(L) {
                if (L != null) {
                  try {
                    return EP.call(L);
                  } catch {
                  }
                  try {
                    return L + "";
                  } catch {
                  }
                }
                return "";
              }
              function VQe(L, W) {
                return Ig(Ys, function(se) {
                  var Te = "_." + se[0];
                  W & se[1] && !yP(L, Te) && L.push(Te);
                }), L.sort();
              }
              function W_e(L) {
                if (L instanceof $i)
                  return L.clone();
                var W = new Dg(L.__wrapped__, L.__chain__);
                return W.__actions__ = Og(L.__actions__), W.__index__ = L.__index__, W.__values__ = L.__values__, W;
              }
              function zQe(L, W, se) {
                (se ? Hv(L, W, se) : W === Q) ? W = 1 : W = Ul(Es(W), 0);
                var Te = L == null ? 0 : L.length;
                if (!Te || W < 1)
                  return [];
                for (var qe = 0, mt = 0, Ut = Zn(kP(Te / W)); qe < Te; )
                  Ut[mt++] = jt(L, qe, qe += W);
                return Ut;
              }
              function BQe(L) {
                for (var W = -1, se = L == null ? 0 : L.length, Te = 0, qe = []; ++W < se; ) {
                  var mt = L[W];
                  mt && (qe[Te++] = mt);
                }
                return qe;
              }
              function jQe() {
                var L = arguments.length;
                if (!L)
                  return [];
                for (var W = Zn(L - 1), se = arguments[0], Te = L; Te--; )
                  W[Te - 1] = arguments[Te];
                return C_(cs(se) ? Og(se) : [se], Yh(W, 1));
              }
              var GQe = As(function(L, W) {
                return $f(L) ? hI(L, Yh(W, 1, $f, true)) : [];
              }), WQe = As(function(L, W) {
                var se = vy(W);
                return $f(se) && (se = Q), $f(L) ? hI(L, Yh(W, 1, $f, true), lo(se, 2)) : [];
              }), HQe = As(function(L, W) {
                var se = vy(W);
                return $f(se) && (se = Q), $f(L) ? hI(L, Yh(W, 1, $f, true), Q, se) : [];
              });
              function $Qe(L, W, se) {
                var Te = L == null ? 0 : L.length;
                return Te ? (W = se || W === Q ? 1 : Es(W), jt(L, W < 0 ? 0 : W, Te)) : [];
              }
              function UQe(L, W, se) {
                var Te = L == null ? 0 : L.length;
                return Te ? (W = se || W === Q ? 1 : Es(W), W = Te - W, jt(L, 0, W < 0 ? 0 : W)) : [];
              }
              function qQe(L, W) {
                return L && L.length ? Ui(L, lo(W, 3), true, true) : [];
              }
              function YQe(L, W) {
                return L && L.length ? Ui(L, lo(W, 3), true) : [];
              }
              function ZQe(L, W, se, Te) {
                var qe = L == null ? 0 : L.length;
                return qe ? (se && typeof se != "number" && Hv(L, W, se) && (se = 0, Te = qe), cG(L, W, se, Te)) : [];
              }
              function H_e(L, W, se) {
                var Te = L == null ? 0 : L.length;
                if (!Te)
                  return -1;
                var qe = se == null ? 0 : Es(se);
                return qe < 0 && (qe = Ul(Te + qe, 0)), _P(L, lo(W, 3), qe);
              }
              function $_e(L, W, se) {
                var Te = L == null ? 0 : L.length;
                if (!Te)
                  return -1;
                var qe = Te - 1;
                return se !== Q && (qe = Es(se), qe = se < 0 ? Ul(Te + qe, 0) : qh(qe, Te - 1)), _P(L, lo(W, 3), qe, true);
              }
              function U_e(L) {
                var W = L == null ? 0 : L.length;
                return W ? Yh(L, 1) : [];
              }
              function XQe(L) {
                var W = L == null ? 0 : L.length;
                return W ? Yh(L, Pi) : [];
              }
              function KQe(L, W) {
                var se = L == null ? 0 : L.length;
                return se ? (W = W === Q ? 1 : Es(W), Yh(L, W)) : [];
              }
              function JQe(L) {
                for (var W = -1, se = L == null ? 0 : L.length, Te = {}; ++W < se; ) {
                  var qe = L[W];
                  Te[qe[0]] = qe[1];
                }
                return Te;
              }
              function q_e(L) {
                return L && L.length ? L[0] : Q;
              }
              function QQe(L, W, se) {
                var Te = L == null ? 0 : L.length;
                if (!Te)
                  return -1;
                var qe = se == null ? 0 : Es(se);
                return qe < 0 && (qe = Ul(Te + qe, 0)), lC(L, W, qe);
              }
              function eet(L) {
                var W = L == null ? 0 : L.length;
                return W ? jt(L, 0, -1) : [];
              }
              var tet = As(function(L) {
                var W = yc(L, Xh);
                return W.length && W[0] === L[0] ? dI(W) : [];
              }), net = As(function(L) {
                var W = vy(L), se = yc(L, Xh);
                return W === vy(se) ? W = Q : se.pop(), se.length && se[0] === L[0] ? dI(se, lo(W, 2)) : [];
              }), ret = As(function(L) {
                var W = vy(L), se = yc(L, Xh);
                return W = typeof W == "function" ? W : Q, W && se.pop(), se.length && se[0] === L[0] ? dI(se, Q, W) : [];
              });
              function aet(L, W) {
                return L == null ? "" : ls.call(L, W);
              }
              function vy(L) {
                var W = L == null ? 0 : L.length;
                return W ? L[W - 1] : Q;
              }
              function iet(L, W, se) {
                var Te = L == null ? 0 : L.length;
                if (!Te)
                  return -1;
                var qe = Te;
                return se !== Q && (qe = Es(se), qe = qe < 0 ? Ul(Te + qe, 0) : qh(qe, Te - 1)), W === W ? dte(L, W, qe) : _P(L, Nj, qe, true);
              }
              function oet(L, W) {
                return L && L.length ? bG(L, Es(W)) : Q;
              }
              var set2 = As(Y_e);
              function Y_e(L, W) {
                return L && L.length && W && W.length ? zF(L, W) : L;
              }
              function uet(L, W, se) {
                return L && L.length && W && W.length ? zF(L, W, lo(se, 2)) : L;
              }
              function cet(L, W, se) {
                return L && L.length && W && W.length ? zF(L, W, Q, se) : L;
              }
              var fet = Jw(function(L, W) {
                var se = L == null ? 0 : L.length, Te = TF(L, W);
                return wG(L, yc(W, function(qe) {
                  return Qw(qe, se) ? +qe : qe;
                }).sort(g_e)), Te;
              });
              function het(L, W) {
                var se = [];
                if (!(L && L.length))
                  return se;
                var Te = -1, qe = [], mt = L.length;
                for (W = lo(W, 3); ++Te < mt; ) {
                  var Ut = L[Te];
                  W(Ut, Te, L) && (se.push(Ut), qe.push(Te));
                }
                return wG(L, qe), se;
              }
              function Mne(L) {
                return L == null ? L : Kj.call(L);
              }
              function det(L, W, se) {
                var Te = L == null ? 0 : L.length;
                return Te ? (se && typeof se != "number" && Hv(L, W, se) ? (W = 0, se = Te) : (W = W == null ? 0 : Es(W), se = se === Q ? Te : Es(se)), jt(L, W, se)) : [];
              }
              function pet(L, W) {
                return Sn(L, W);
              }
              function vet(L, W, se) {
                return Hr(L, W, lo(se, 2));
              }
              function get2(L, W) {
                var se = L == null ? 0 : L.length;
                if (se) {
                  var Te = Sn(L, W);
                  if (Te < se && q1(L[Te], W))
                    return Te;
                }
                return -1;
              }
              function met(L, W) {
                return Sn(L, W, true);
              }
              function yet(L, W, se) {
                return Hr(L, W, lo(se, 2), true);
              }
              function bet(L, W) {
                var se = L == null ? 0 : L.length;
                if (se) {
                  var Te = Sn(L, W, true) - 1;
                  if (q1(L[Te], W))
                    return Te;
                }
                return -1;
              }
              function _et(L) {
                return L && L.length ? qr(L) : [];
              }
              function xet(L, W) {
                return L && L.length ? qr(L, lo(W, 2)) : [];
              }
              function wet(L) {
                var W = L == null ? 0 : L.length;
                return W ? jt(L, 1, W) : [];
              }
              function Cet(L, W, se) {
                return L && L.length ? (W = se || W === Q ? 1 : Es(W), jt(L, 0, W < 0 ? 0 : W)) : [];
              }
              function Met(L, W, se) {
                var Te = L == null ? 0 : L.length;
                return Te ? (W = se || W === Q ? 1 : Es(W), W = Te - W, jt(L, W < 0 ? 0 : W, Te)) : [];
              }
              function Aet(L, W) {
                return L && L.length ? Ui(L, lo(W, 3), false, true) : [];
              }
              function Eet(L, W) {
                return L && L.length ? Ui(L, lo(W, 3)) : [];
              }
              var Iet = As(function(L) {
                return fi(Yh(L, 1, $f, true));
              }), Tet = As(function(L) {
                var W = vy(L);
                return $f(W) && (W = Q), fi(Yh(L, 1, $f, true), lo(W, 2));
              }), Det = As(function(L) {
                var W = vy(L);
                return W = typeof W == "function" ? W : Q, fi(Yh(L, 1, $f, true), Q, W);
              });
              function ket(L) {
                return L && L.length ? fi(L) : [];
              }
              function Pet(L, W) {
                return L && L.length ? fi(L, lo(W, 2)) : [];
              }
              function Let(L, W) {
                return W = typeof W == "function" ? W : Q, L && L.length ? fi(L, Q, W) : [];
              }
              function Ane(L) {
                if (!(L && L.length))
                  return [];
                var W = 0;
                return L = S_(L, function(se) {
                  if ($f(se))
                    return W = Ul(se.length, W), true;
                }), xF(W, function(se) {
                  return yc(L, yF(se));
                });
              }
              function Z_e(L, W) {
                if (!(L && L.length))
                  return [];
                var se = Ane(L);
                return W == null ? se : yc(se, function(Te) {
                  return Wv(W, Q, Te);
                });
              }
              var Oet = As(function(L, W) {
                return $f(L) ? hI(L, W) : [];
              }), Ret = As(function(L) {
                return Js(S_(L, $f));
              }), Fet = As(function(L) {
                var W = vy(L);
                return $f(W) && (W = Q), Js(S_(L, $f), lo(W, 2));
              }), Net = As(function(L) {
                var W = vy(L);
                return W = typeof W == "function" ? W : Q, Js(S_(L, $f), Q, W);
              }), Vet = As(Ane);
              function zet(L, W) {
                return uv(L || [], W || [], fI);
              }
              function Bet(L, W) {
                return uv(L || [], W || [], ae);
              }
              var jet = As(function(L) {
                var W = L.length, se = W > 1 ? L[W - 1] : Q;
                return se = typeof se == "function" ? (L.pop(), se) : Q, Z_e(L, se);
              });
              function X_e(L) {
                var W = st(L);
                return W.__chain__ = true, W;
              }
              function Get(L, W) {
                return W(L), L;
              }
              function kG(L, W) {
                return W(L);
              }
              var Wet = Jw(function(L) {
                var W = L.length, se = W ? L[0] : 0, Te = this.__wrapped__, qe = function(mt) {
                  return TF(mt, L);
                };
                return W > 1 || this.__actions__.length || !(Te instanceof $i) || !Qw(se) ? this.thru(qe) : (Te = Te.slice(se, +se + (W ? 1 : 0)), Te.__actions__.push({ func: kG, args: [qe], thisArg: Q }), new Dg(Te, this.__chain__).thru(function(mt) {
                  return W && !mt.length && mt.push(Q), mt;
                }));
              });
              function Het() {
                return X_e(this);
              }
              function $et() {
                return new Dg(this.value(), this.__chain__);
              }
              function Uet() {
                this.__values__ === Q && (this.__values__ = cxe(this.value()));
                var L = this.__index__ >= this.__values__.length, W = L ? Q : this.__values__[this.__index__++];
                return { done: L, value: W };
              }
              function qet() {
                return this;
              }
              function Yet(L) {
                for (var W, se = this; se instanceof RP; ) {
                  var Te = W_e(se);
                  Te.__index__ = 0, Te.__values__ = Q, W ? qe.__wrapped__ = Te : W = Te;
                  var qe = Te;
                  se = se.__wrapped__;
                }
                return qe.__wrapped__ = L, W;
              }
              function Zet() {
                var L = this.__wrapped__;
                if (L instanceof $i) {
                  var W = L;
                  return this.__actions__.length && (W = new $i(this)), W = W.reverse(), W.__actions__.push({ func: kG, args: [Mne], thisArg: Q }), new Dg(W, this.__chain__);
                }
                return this.thru(Mne);
              }
              function Xet() {
                return Rs(this.__wrapped__, this.__actions__);
              }
              var Ket = SG(function(L, W, se) {
                Ks.call(L, se) ? ++L[se] : U1(L, se, 1);
              });
              function Jet(L, W, se) {
                var Te = cs(L) ? Rj : Qte;
                return se && Hv(L, W, se) && (W = Q), Te(L, lo(W, 3));
              }
              function Qet(L, W) {
                var se = cs(L) ? S_ : DF;
                return se(L, lo(W, 3));
              }
              var ett = S_e(H_e), ttt = S_e($_e);
              function ntt(L, W) {
                return Yh(PG(L, W), 1);
              }
              function rtt(L, W) {
                return Yh(PG(L, W), Pi);
              }
              function att(L, W, se) {
                return se = se === Q ? 1 : Es(se), Yh(PG(L, W), se);
              }
              function K_e(L, W) {
                var se = cs(L) ? Ig : A_;
                return se(L, lo(W, 3));
              }
              function J_e(L, W) {
                var se = cs(L) ? tte : uG;
                return se(L, lo(W, 3));
              }
              var itt = SG(function(L, W, se) {
                Ks.call(L, se) ? L[se].push(W) : U1(L, se, [W]);
              });
              function ott(L, W, se, Te) {
                L = Rg(L) ? L : WP(L), se = se && !Te ? Es(se) : 0;
                var qe = L.length;
                return se < 0 && (se = Ul(qe + se, 0)), NG(L) ? se <= qe && L.indexOf(W, se) > -1 : !!qe && lC(L, W, se) > -1;
              }
              var stt = As(function(L, W, se) {
                var Te = -1, qe = typeof W == "function", mt = Rg(L) ? Zn(L.length) : [];
                return A_(L, function(Ut) {
                  mt[++Te] = qe ? Wv(W, Ut, se) : Xw(Ut, W, se);
                }), mt;
              }), ltt = SG(function(L, W, se) {
                U1(L, se, W);
              });
              function PG(L, W) {
                var se = cs(L) ? yc : gG;
                return se(L, lo(W, 3));
              }
              function utt(L, W, se, Te) {
                return L == null ? [] : (cs(W) || (W = W == null ? [] : [W]), se = Te ? Q : se, cs(se) || (se = se == null ? [] : [se]), _G(L, W, se));
              }
              var ctt = SG(function(L, W, se) {
                L[se ? 0 : 1].push(W);
              }, function() {
                return [[], []];
              });
              function ftt(L, W, se) {
                var Te = cs(L) ? bP : zj, qe = arguments.length < 3;
                return Te(L, lo(W, 4), se, qe, A_);
              }
              function htt(L, W, se) {
                var Te = cs(L) ? Fj : zj, qe = arguments.length < 3;
                return Te(L, lo(W, 4), se, qe, uG);
              }
              function dtt(L, W) {
                var se = cs(L) ? S_ : DF;
                return se(L, RG(lo(W, 3)));
              }
              function ptt(L) {
                var W = cs(L) ? iG : P;
                return W(L);
              }
              function vtt(L, W, se) {
                (se ? Hv(L, W, se) : W === Q) ? W = 1 : W = Es(W);
                var Te = cs(L) ? Yte : G;
                return Te(L, W);
              }
              function gtt(L) {
                var W = cs(L) ? Zte : gt;
                return W(L);
              }
              function mtt(L) {
                if (L == null)
                  return 0;
                if (Rg(L))
                  return NG(L) ? uC(L) : L.length;
                var W = cv(L);
                return W == Sf || W == Ec ? L.size : NF(L).length;
              }
              function ytt(L, W, se) {
                var Te = cs(L) ? mF : tn;
                return se && Hv(L, W, se) && (W = Q), Te(L, lo(W, 3));
              }
              var btt = As(function(L, W) {
                if (L == null)
                  return [];
                var se = W.length;
                return se > 1 && Hv(L, W[0], W[1]) ? W = [] : se > 2 && Hv(W[0], W[1], W[2]) && (W = [W[0]]), _G(L, Yh(W, 1), []);
              }), LG = wte || function() {
                return Uh.Date.now();
              };
              function _tt(L, W) {
                if (typeof W != "function")
                  throw new Tg(Ee);
                return L = Es(L), function() {
                  if (--L < 1)
                    return W.apply(this, arguments);
                };
              }
              function Q_e(L, W, se) {
                return W = se ? Q : W, W = L && W == null ? L.length : W, Kw(L, pr, Q, Q, Q, Q, W);
              }
              function exe(L, W) {
                var se;
                if (typeof W != "function")
                  throw new Tg(Ee);
                return L = Es(L), function() {
                  return --L > 0 && (se = W.apply(this, arguments)), L <= 1 && (W = Q), se;
                };
              }
              var Ene = As(function(L, W, se) {
                var Te = yn;
                if (se.length) {
                  var qe = W1(se, jP(Ene));
                  Te |= pn;
                }
                return Kw(L, Te, W, se, qe);
              }), txe = As(function(L, W, se) {
                var Te = yn | _r;
                if (se.length) {
                  var qe = W1(se, jP(txe));
                  Te |= pn;
                }
                return Kw(W, Te, L, se, qe);
              });
              function nxe(L, W, se) {
                W = se ? Q : W;
                var Te = Kw(L, fa, Q, Q, Q, Q, Q, W);
                return Te.placeholder = nxe.placeholder, Te;
              }
              function rxe(L, W, se) {
                W = se ? Q : W;
                var Te = Kw(L, We, Q, Q, Q, Q, Q, W);
                return Te.placeholder = rxe.placeholder, Te;
              }
              function axe(L, W, se) {
                var Te, qe, mt, Ut, rn, Dn, Xr = 0, Kr = false, va = false, Ja = true;
                if (typeof L != "function")
                  throw new Tg(Ee);
                W = gy(W) || 0, hf(se) && (Kr = !!se.leading, va = "maxWait" in se, mt = va ? Ul(gy(se.maxWait) || 0, W) : mt, Ja = "trailing" in se ? !!se.trailing : Ja);
                function Li(Uf) {
                  var Y1 = Te, n22 = qe;
                  return Te = qe = Q, Xr = Uf, Ut = L.apply(n22, Y1), Ut;
                }
                function ho(Uf) {
                  return Xr = Uf, rn = $F(cl, W), Kr ? Li(Uf) : Ut;
                }
                function Fs(Uf) {
                  var Y1 = Uf - Dn, n22 = Uf - Xr, Sxe = W - Y1;
                  return va ? qh(Sxe, mt - n22) : Sxe;
                }
                function po(Uf) {
                  var Y1 = Uf - Dn, n22 = Uf - Xr;
                  return Dn === Q || Y1 >= W || Y1 < 0 || va && n22 >= mt;
                }
                function cl() {
                  var Uf = LG();
                  if (po(Uf))
                    return bl(Uf);
                  rn = $F(cl, Fs(Uf));
                }
                function bl(Uf) {
                  return rn = Q, Ja && Te ? Li(Uf) : (Te = qe = Q, Ut);
                }
                function U0() {
                  rn !== Q && GF(rn), Xr = 0, Te = Dn = qe = rn = Q;
                }
                function $v() {
                  return rn === Q ? Ut : bl(LG());
                }
                function q0() {
                  var Uf = LG(), Y1 = po(Uf);
                  if (Te = arguments, qe = this, Dn = Uf, Y1) {
                    if (rn === Q)
                      return ho(Dn);
                    if (va)
                      return GF(rn), rn = $F(cl, W), Li(Dn);
                  }
                  return rn === Q && (rn = $F(cl, W)), Ut;
                }
                return q0.cancel = U0, q0.flush = $v, q0;
              }
              var xtt = As(function(L, W) {
                return lG(L, 1, W);
              }), wtt = As(function(L, W, se) {
                return lG(L, gy(W) || 0, se);
              });
              function Stt(L) {
                return Kw(L, Tn);
              }
              function OG(L, W) {
                if (typeof L != "function" || W != null && typeof W != "function")
                  throw new Tg(Ee);
                var se = function() {
                  var Te = arguments, qe = W ? W.apply(this, Te) : Te[0], mt = se.cache;
                  if (mt.has(qe))
                    return mt.get(qe);
                  var Ut = L.apply(this, Te);
                  return se.cache = mt.set(qe, Ut) || mt, Ut;
                };
                return se.cache = new (OG.Cache || $1)(), se;
              }
              OG.Cache = $1;
              function RG(L) {
                if (typeof L != "function")
                  throw new Tg(Ee);
                return function() {
                  var W = arguments;
                  switch (W.length) {
                    case 0:
                      return !L.call(this);
                    case 1:
                      return !L.call(this, W[0]);
                    case 2:
                      return !L.call(this, W[0], W[1]);
                    case 3:
                      return !L.call(this, W[0], W[1], W[2]);
                  }
                  return !L.apply(this, W);
                };
              }
              function Ctt(L) {
                return exe(2, L);
              }
              var Mtt = H0(function(L, W) {
                W = W.length == 1 && cs(W[0]) ? yc(W[0], sv(lo())) : yc(Yh(W, 1), sv(lo()));
                var se = W.length;
                return As(function(Te) {
                  for (var qe = -1, mt = qh(Te.length, se); ++qe < mt; )
                    Te[qe] = W[qe].call(this, Te[qe]);
                  return Wv(L, this, Te);
                });
              }), Ine = As(function(L, W) {
                var se = W1(W, jP(Ine));
                return Kw(L, pn, Q, W, se);
              }), ixe = As(function(L, W) {
                var se = W1(W, jP(ixe));
                return Kw(L, zn, Q, W, se);
              }), Att = Jw(function(L, W) {
                return Kw(L, fr, Q, Q, Q, W);
              });
              function Ett(L, W) {
                if (typeof L != "function")
                  throw new Tg(Ee);
                return W = W === Q ? W : Es(W), As(L, W);
              }
              function Itt(L, W) {
                if (typeof L != "function")
                  throw new Tg(Ee);
                return W = W == null ? 0 : Ul(Es(W), 0), As(function(se) {
                  var Te = se[W], qe = Od(se, 0, W);
                  return Te && C_(qe, Te), Wv(L, this, qe);
                });
              }
              function Ttt(L, W, se) {
                var Te = true, qe = true;
                if (typeof L != "function")
                  throw new Tg(Ee);
                return hf(se) && (Te = "leading" in se ? !!se.leading : Te, qe = "trailing" in se ? !!se.trailing : qe), axe(L, W, { leading: Te, maxWait: W, trailing: qe });
              }
              function Dtt(L) {
                return Q_e(L, 1);
              }
              function ktt(L, W) {
                return Ine(xp(W), L);
              }
              function Ptt() {
                if (!arguments.length)
                  return [];
                var L = arguments[0];
                return cs(L) ? L : [L];
              }
              function Ltt(L) {
                return Pg(L, Xt);
              }
              function Ott(L, W) {
                return W = typeof W == "function" ? W : Q, Pg(L, Xt, W);
              }
              function Rtt(L) {
                return Pg(L, yt | Xt);
              }
              function Ftt(L, W) {
                return W = typeof W == "function" ? W : Q, Pg(L, yt | Xt, W);
              }
              function Ntt(L, W) {
                return W == null || sG(L, W, Rd(W));
              }
              function q1(L, W) {
                return L === W || L !== L && W !== W;
              }
              var Vtt = EG(LF), ztt = EG(function(L, W) {
                return L >= W;
              }), mI = hG(function() {
                return arguments;
              }()) ? hG : function(L) {
                return Mf(L) && Ks.call(L, "callee") && !hC.call(L, "callee");
              }, cs = Zn.isArray, Btt = Tj ? sv(Tj) : ane;
              function Rg(L) {
                return L != null && FG(L.length) && !e22(L);
              }
              function $f(L) {
                return Mf(L) && Rg(L);
              }
              function jtt(L) {
                return L === true || L === false || Mf(L) && Zh(L) == Cs;
              }
              var wC = Yj || zne, Gtt = Dj ? sv(Dj) : ine;
              function Wtt(L) {
                return Mf(L) && L.nodeType === 1 && !UF(L);
              }
              function Htt(L) {
                if (L == null)
                  return true;
                if (Rg(L) && (cs(L) || typeof L == "string" || typeof L.splice == "function" || wC(L) || GP(L) || mI(L)))
                  return !L.length;
                var W = cv(L);
                if (W == Sf || W == Ec)
                  return !L.size;
                if (HF(L))
                  return !NF(L).length;
                for (var se in L)
                  if (Ks.call(L, se))
                    return false;
                return true;
              }
              function $tt(L, W) {
                return pI(L, W);
              }
              function Utt(L, W, se) {
                se = typeof se == "function" ? se : Q;
                var Te = se ? se(L, W) : Q;
                return Te === Q ? pI(L, W, Q, se) : !!Te;
              }
              function Tne(L) {
                if (!Mf(L))
                  return false;
                var W = Zh(L);
                return W == Gc || W == vc || typeof L.message == "string" && typeof L.name == "string" && !UF(L);
              }
              function qtt(L) {
                return typeof L == "number" && py(L);
              }
              function e22(L) {
                if (!hf(L))
                  return false;
                var W = Zh(L);
                return W == av || W == Cg || W == nu || W == Mg;
              }
              function oxe(L) {
                return typeof L == "number" && L == Es(L);
              }
              function FG(L) {
                return typeof L == "number" && L > -1 && L % 1 == 0 && L <= xr;
              }
              function hf(L) {
                var W = typeof L;
                return L != null && (W == "object" || W == "function");
              }
              function Mf(L) {
                return L != null && typeof L == "object";
              }
              var sxe = kj ? sv(kj) : one;
              function Ytt(L, W) {
                return L === W || OF(L, W, bne(W));
              }
              function Ztt(L, W, se) {
                return se = typeof se == "function" ? se : Q, OF(L, W, bne(W), se);
              }
              function Xtt(L) {
                return lxe(L) && L != +L;
              }
              function Ktt(L) {
                if (PQe(L))
                  throw new Vo(fe);
                return pG(L);
              }
              function Jtt(L) {
                return L === null;
              }
              function Qtt(L) {
                return L == null;
              }
              function lxe(L) {
                return typeof L == "number" || Mf(L) && Zh(L) == gp;
              }
              function UF(L) {
                if (!Mf(L) || Zh(L) != Td)
                  return false;
                var W = DP(L);
                if (W === null)
                  return true;
                var se = Ks.call(W, "constructor") && W.constructor;
                return typeof se == "function" && se instanceof se && EP.call(se) == Hc;
              }
              var Dne = Pj ? sv(Pj) : RF;
              function ent(L) {
                return oxe(L) && L >= -xr && L <= xr;
              }
              var uxe = Lj ? sv(Lj) : FF;
              function NG(L) {
                return typeof L == "string" || !cs(L) && Mf(L) && Zh(L) == uf;
              }
              function $0(L) {
                return typeof L == "symbol" || Mf(L) && Zh(L) == Tu;
              }
              var GP = Oj ? sv(Oj) : sne;
              function tnt(L) {
                return L === Q;
              }
              function nnt(L) {
                return Mf(L) && cv(L) == Pr;
              }
              function rnt(L) {
                return Mf(L) && Zh(L) == Hn;
              }
              var ant = EG(VF), int = EG(function(L, W) {
                return L <= W;
              });
              function cxe(L) {
                if (!L)
                  return [];
                if (Rg(L))
                  return NG(L) ? W0(L) : Og(L);
                if (pC && L[pC])
                  return cte(L[pC]());
                var W = cv(L), se = W == Sf ? CF : W == Ec ? MP : WP;
                return se(L);
              }
              function t22(L) {
                if (!L)
                  return L === 0 ? L : 0;
                if (L = gy(L), L === Pi || L === -Pi) {
                  var W = L < 0 ? -1 : 1;
                  return W * Xn;
                }
                return L === L ? L : 0;
              }
              function Es(L) {
                var W = t22(L), se = W % 1;
                return W === W ? se ? W - se : W : 0;
              }
              function fxe(L) {
                return L ? Yw(Es(L), 0, ba) : 0;
              }
              function gy(L) {
                if (typeof L == "number")
                  return L;
                if ($0(L))
                  return Kn;
                if (hf(L)) {
                  var W = typeof L.valueOf == "function" ? L.valueOf() : L;
                  L = hf(W) ? W + "" : W;
                }
                if (typeof L != "string")
                  return L === 0 ? L : +L;
                L = Bj(L);
                var se = Fn.test(L);
                return se || nr.test(L) ? Jee(L.slice(2), se ? 2 : 8) : Dt.test(L) ? Kn : +L;
              }
              function hxe(L) {
                return E_(L, Fg(L));
              }
              function ont(L) {
                return L ? Yw(Es(L), -xr, xr) : L === 0 ? L : 0;
              }
              function hu(L) {
                return L == null ? "" : Aa(L);
              }
              var snt = zP(function(L, W) {
                if (HF(W) || Rg(W)) {
                  E_(W, Rd(W), L);
                  return;
                }
                for (var se in W)
                  Ks.call(W, se) && fI(L, se, W[se]);
              }), dxe = zP(function(L, W) {
                E_(W, Fg(W), L);
              }), VG = zP(function(L, W, se, Te) {
                E_(W, Fg(W), L, Te);
              }), lnt = zP(function(L, W, se, Te) {
                E_(W, Rd(W), L, Te);
              }), unt = Jw(TF);
              function cnt(L, W) {
                var se = bC(L);
                return W == null ? se : oG(se, W);
              }
              var fnt = As(function(L, W) {
                L = Pu(L);
                var se = -1, Te = W.length, qe = Te > 2 ? W[2] : Q;
                for (qe && Hv(W[0], W[1], qe) && (Te = 1); ++se < Te; )
                  for (var mt = W[se], Ut = Fg(mt), rn = -1, Dn = Ut.length; ++rn < Dn; ) {
                    var Xr = Ut[rn], Kr = L[Xr];
                    (Kr === Q || q1(Kr, cC[Xr]) && !Ks.call(L, Xr)) && (L[Xr] = mt[Xr]);
                  }
                return L;
              }), hnt = As(function(L) {
                return L.push(Q, D_e), Wv(pxe, Q, L);
              });
              function dnt(L, W) {
                return oI(L, lo(W, 3), Lg);
              }
              function pnt(L, W) {
                return oI(L, lo(W, 3), PF);
              }
              function vnt(L, W) {
                return L == null ? L : kF(L, lo(W, 3), Fg);
              }
              function gnt(L, W) {
                return L == null ? L : fG(L, lo(W, 3), Fg);
              }
              function mnt(L, W) {
                return L && Lg(L, lo(W, 3));
              }
              function ynt(L, W) {
                return L && PF(L, lo(W, 3));
              }
              function bnt(L) {
                return L == null ? [] : NP(L, Rd(L));
              }
              function _nt(L) {
                return L == null ? [] : NP(L, Fg(L));
              }
              function kne(L, W, se) {
                var Te = L == null ? Q : Zw(L, W);
                return Te === Q ? se : Te;
              }
              function xnt(L, W) {
                return L != null && L_e(L, W, ene);
              }
              function Pne(L, W) {
                return L != null && L_e(L, W, tne);
              }
              var wnt = M_e(function(L, W, se) {
                W != null && typeof W.toString != "function" && (W = $u.call(W)), L[W] = se;
              }, One(Ng)), Snt = M_e(function(L, W, se) {
                W != null && typeof W.toString != "function" && (W = $u.call(W)), Ks.call(L, W) ? L[W].push(se) : L[W] = [se];
              }, lo), Cnt = As(Xw);
              function Rd(L) {
                return Rg(L) ? aG(L) : NF(L);
              }
              function Fg(L) {
                return Rg(L) ? aG(L, true) : lne(L);
              }
              function Mnt(L, W) {
                var se = {};
                return W = lo(W, 3), Lg(L, function(Te, qe, mt) {
                  U1(se, W(Te, qe, mt), Te);
                }), se;
              }
              function Ant(L, W) {
                var se = {};
                return W = lo(W, 3), Lg(L, function(Te, qe, mt) {
                  U1(se, qe, W(Te, qe, mt));
                }), se;
              }
              var Ent = zP(function(L, W, se) {
                VP(L, W, se);
              }), pxe = zP(function(L, W, se, Te) {
                VP(L, W, se, Te);
              }), Int = Jw(function(L, W) {
                var se = {};
                if (L == null)
                  return se;
                var Te = false;
                W = yc(W, function(mt) {
                  return mt = fu(mt, L), Te || (Te = mt.length > 1), mt;
                }), E_(L, mne(L), se), Te && (se = Pg(se, yt | Gt | Xt, _Qe));
                for (var qe = W.length; qe--; )
                  Ki(se, W[qe]);
                return se;
              });
              function Tnt(L, W) {
                return vxe(L, RG(lo(W)));
              }
              var Dnt = Jw(function(L, W) {
                return L == null ? {} : cne(L, W);
              });
              function vxe(L, W) {
                if (L == null)
                  return {};
                var se = yc(mne(L), function(Te) {
                  return [Te];
                });
                return W = lo(W), xG(L, se, function(Te, qe) {
                  return W(Te, qe[0]);
                });
              }
              function knt(L, W, se) {
                W = fu(W, L);
                var Te = -1, qe = W.length;
                for (qe || (qe = 1, L = Q); ++Te < qe; ) {
                  var mt = L == null ? Q : L[I_(W[Te])];
                  mt === Q && (Te = qe, mt = se), L = e22(mt) ? mt.call(L) : mt;
                }
                return L;
              }
              function Pnt(L, W, se) {
                return L == null ? L : ae(L, W, se);
              }
              function Lnt(L, W, se, Te) {
                return Te = typeof Te == "function" ? Te : Q, L == null ? L : ae(L, W, se, Te);
              }
              var gxe = I_e(Rd), mxe = I_e(Fg);
              function Ont(L, W, se) {
                var Te = cs(L), qe = Te || wC(L) || GP(L);
                if (W = lo(W, 4), se == null) {
                  var mt = L && L.constructor;
                  qe ? se = Te ? new mt() : [] : hf(L) ? se = e22(mt) ? bC(DP(L)) : {} : se = {};
                }
                return (qe ? Ig : Lg)(L, function(Ut, rn, Dn) {
                  return W(se, Ut, rn, Dn);
                }), se;
              }
              function Rnt(L, W) {
                return L == null ? true : Ki(L, W);
              }
              function Fnt(L, W, se) {
                return L == null ? L : us(L, W, xp(se));
              }
              function Nnt(L, W, se, Te) {
                return Te = typeof Te == "function" ? Te : Q, L == null ? L : us(L, W, xp(se), Te);
              }
              function WP(L) {
                return L == null ? [] : wP(L, Rd(L));
              }
              function Vnt(L) {
                return L == null ? [] : wP(L, Fg(L));
              }
              function znt(L, W, se) {
                return se === Q && (se = W, W = Q), se !== Q && (se = gy(se), se = se === se ? se : 0), W !== Q && (W = gy(W), W = W === W ? W : 0), Yw(gy(L), W, se);
              }
              function Bnt(L, W, se) {
                return W = t22(W), se === Q ? (se = W, W = 0) : se = t22(se), L = gy(L), nne(L, W, se);
              }
              function jnt(L, W, se) {
                if (se && typeof se != "boolean" && Hv(L, W, se) && (W = se = Q), se === Q && (typeof W == "boolean" ? (se = W, W = Q) : typeof L == "boolean" && (se = L, L = Q)), L === Q && W === Q ? (L = 0, W = 1) : (L = t22(L), W === Q ? (W = L, L = 0) : W = t22(W)), L > W) {
                  var Te = L;
                  L = W, W = Te;
                }
                if (se || L % 1 || W % 1) {
                  var qe = Xj();
                  return qh(L + qe * (W - L + Kee("1e-" + ((qe + "").length - 1))), W);
                }
                return BF(L, W);
              }
              var Gnt = BP(function(L, W, se) {
                return W = W.toLowerCase(), L + (se ? yxe(W) : W);
              });
              function yxe(L) {
                return Lne(hu(L).toLowerCase());
              }
              function bxe(L) {
                return L = hu(L), L && L.replace(ia, Gj).replace(Wee, "");
              }
              function Wnt(L, W, se) {
                L = hu(L), W = Aa(W);
                var Te = L.length;
                se = se === Q ? Te : Yw(Es(se), 0, Te);
                var qe = se;
                return se -= W.length, se >= 0 && L.slice(se, qe) == W;
              }
              function Hnt(L) {
                return L = hu(L), L && cf.test(L) ? L.replace(gc, ste) : L;
              }
              function $nt(L) {
                return L = hu(L), L && lF.test(L) ? L.replace(z1, "\\$&") : L;
              }
              var Unt = BP(function(L, W, se) {
                return L + (se ? "-" : "") + W.toLowerCase();
              }), qnt = BP(function(L, W, se) {
                return L + (se ? " " : "") + W.toLowerCase();
              }), Ynt = w_e("toLowerCase");
              function Znt(L, W, se) {
                L = hu(L), W = Es(W);
                var Te = W ? uC(L) : 0;
                if (!W || Te >= W)
                  return L;
                var qe = (W - Te) / 2;
                return AG(PP(qe), se) + L + AG(kP(qe), se);
              }
              function Xnt(L, W, se) {
                L = hu(L), W = Es(W);
                var Te = W ? uC(L) : 0;
                return W && Te < W ? L + AG(W - Te, se) : L;
              }
              function Knt(L, W, se) {
                L = hu(L), W = Es(W);
                var Te = W ? uC(L) : 0;
                return W && Te < W ? AG(W - Te, se) + L : L;
              }
              function Jnt(L, W, se) {
                return se || W == null ? W = 0 : W && (W = +W), ql(hu(L).replace(b_, ""), W || 0);
              }
              function Qnt(L, W, se) {
                return (se ? Hv(L, W, se) : W === Q) ? W = 1 : W = Es(W), jF(hu(L), W);
              }
              function ert() {
                var L = arguments, W = hu(L[0]);
                return L.length < 3 ? W : W.replace(L[1], L[2]);
              }
              var trt = BP(function(L, W, se) {
                return L + (se ? "_" : "") + W.toLowerCase();
              });
              function nrt(L, W, se) {
                return se && typeof se != "number" && Hv(L, W, se) && (W = se = Q), se = se === Q ? ba : se >>> 0, se ? (L = hu(L), L && (typeof W == "string" || W != null && !Dne(W)) && (W = Aa(W), !W && G1(L)) ? Od(W0(L), 0, se) : L.split(W, se)) : [];
              }
              var rrt = BP(function(L, W, se) {
                return L + (se ? " " : "") + Lne(W);
              });
              function art(L, W, se) {
                return L = hu(L), se = se == null ? 0 : Yw(Es(se), 0, L.length), W = Aa(W), L.slice(se, se + W.length) == W;
              }
              function irt(L, W, se) {
                var Te = st.templateSettings;
                se && Hv(L, W, se) && (W = Q), L = hu(L), W = VG({}, W, Te, T_e);
                var qe = VG({}, W.imports, Te.imports, T_e), mt = Rd(qe), Ut = wP(qe, mt), rn, Dn, Xr = 0, Kr = W.interpolate || xi, va = "__p += '", Ja = hy((W.escape || xi).source + "|" + Kr.source + "|" + (Kr === ph ? ut : xi).source + "|" + (W.evaluate || xi).source + "|$", "g"), Li = "//# sourceURL=" + (Ks.call(W, "sourceURL") ? (W.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++Yee + "]") + `
`;
                L.replace(Ja, function(po, cl, bl, U0, $v, q0) {
                  return bl || (bl = U0), va += L.slice(Xr, q0).replace(ds, lte), cl && (rn = true, va += `' +
__e(` + cl + `) +
'`), $v && (Dn = true, va += `';
` + $v + `;
__p += '`), bl && (va += `' +
((__t = (` + bl + `)) == null ? '' : __t) +
'`), Xr = q0 + po.length, po;
                }), va += `';
`;
                var ho = Ks.call(W, "variable") && W.variable;
                if (!ho)
                  va = `with (obj) {
` + va + `
}
`;
                else if (Pt.test(ho))
                  throw new Vo(Oe);
                va = (Dn ? va.replace(Dd, "") : va).replace(mp, "$1").replace(Cf, "$1;"), va = "function(" + (ho || "obj") + `) {
` + (ho ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (rn ? ", __e = _.escape" : "") + (Dn ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + va + `return __p
}`;
                var Fs = xxe(function() {
                  return zo(mt, Li + "return " + va).apply(Q, Ut);
                });
                if (Fs.source = va, Tne(Fs))
                  throw Fs;
                return Fs;
              }
              function ort(L) {
                return hu(L).toLowerCase();
              }
              function srt(L) {
                return hu(L).toUpperCase();
              }
              function lrt(L, W, se) {
                if (L = hu(L), L && (se || W === Q))
                  return Bj(L);
                if (!L || !(W = Aa(W)))
                  return L;
                var Te = W0(L), qe = W0(W), mt = wF(Te, qe), Ut = SF(Te, qe) + 1;
                return Od(Te, mt, Ut).join("");
              }
              function urt(L, W, se) {
                if (L = hu(L), L && (se || W === Q))
                  return L.slice(0, Wj(L) + 1);
                if (!L || !(W = Aa(W)))
                  return L;
                var Te = W0(L), qe = SF(Te, W0(W)) + 1;
                return Od(Te, 0, qe).join("");
              }
              function crt(L, W, se) {
                if (L = hu(L), L && (se || W === Q))
                  return L.replace(b_, "");
                if (!L || !(W = Aa(W)))
                  return L;
                var Te = W0(L), qe = wF(Te, W0(W));
                return Od(Te, qe).join("");
              }
              function frt(L, W) {
                var se = Gn, Te = Tr;
                if (hf(W)) {
                  var qe = "separator" in W ? W.separator : qe;
                  se = "length" in W ? Es(W.length) : se, Te = "omission" in W ? Aa(W.omission) : Te;
                }
                L = hu(L);
                var mt = L.length;
                if (G1(L)) {
                  var Ut = W0(L);
                  mt = Ut.length;
                }
                if (se >= mt)
                  return L;
                var rn = se - uC(Te);
                if (rn < 1)
                  return Te;
                var Dn = Ut ? Od(Ut, 0, rn).join("") : L.slice(0, rn);
                if (qe === Q)
                  return Dn + Te;
                if (Ut && (rn += Dn.length - rn), Dne(qe)) {
                  if (L.slice(rn).search(qe)) {
                    var Xr, Kr = Dn;
                    for (qe.global || (qe = hy(qe.source, hu(At.exec(qe)) + "g")), qe.lastIndex = 0; Xr = qe.exec(Kr); )
                      var va = Xr.index;
                    Dn = Dn.slice(0, va === Q ? rn : va);
                  }
                } else if (L.indexOf(Aa(qe), rn) != rn) {
                  var Ja = Dn.lastIndexOf(qe);
                  Ja > -1 && (Dn = Dn.slice(0, Ja));
                }
                return Dn + Te;
              }
              function hrt(L) {
                return L = hu(L), L && Zs.test(L) ? L.replace(ru, pte) : L;
              }
              var drt = BP(function(L, W, se) {
                return L + (se ? " " : "") + W.toUpperCase();
              }), Lne = w_e("toUpperCase");
              function _xe(L, W, se) {
                return L = hu(L), W = se ? Q : W, W === Q ? SP(L) ? mte(L) : ate(L) : L.match(W) || [];
              }
              var xxe = As(function(L, W) {
                try {
                  return Wv(L, Q, W);
                } catch (se) {
                  return Tne(se) ? se : new Vo(se);
                }
              }), prt = Jw(function(L, W) {
                return Ig(W, function(se) {
                  se = I_(se), U1(L, se, Ene(L[se], L));
                }), L;
              });
              function vrt(L) {
                var W = L == null ? 0 : L.length, se = lo();
                return L = W ? yc(L, function(Te) {
                  if (typeof Te[1] != "function")
                    throw new Tg(Ee);
                  return [se(Te[0]), Te[1]];
                }) : [], As(function(Te) {
                  for (var qe = -1; ++qe < W; ) {
                    var mt = L[qe];
                    if (Wv(mt[0], this, Te))
                      return Wv(mt[1], this, Te);
                  }
                });
              }
              function grt(L) {
                return Jte(Pg(L, yt));
              }
              function One(L) {
                return function() {
                  return L;
                };
              }
              function mrt(L, W) {
                return L == null || L !== L ? W : L;
              }
              var yrt = C_e(), brt = C_e(true);
              function Ng(L) {
                return L;
              }
              function Rne(L) {
                return vG(typeof L == "function" ? L : Pg(L, yt));
              }
              function _rt(L) {
                return mG(Pg(L, yt));
              }
              function xrt(L, W) {
                return yG(L, Pg(W, yt));
              }
              var wrt = As(function(L, W) {
                return function(se) {
                  return Xw(se, L, W);
                };
              }), Srt = As(function(L, W) {
                return function(se) {
                  return Xw(L, se, W);
                };
              });
              function Fne(L, W, se) {
                var Te = Rd(W), qe = NP(W, Te);
                se == null && !(hf(W) && (qe.length || !Te.length)) && (se = W, W = L, L = this, qe = NP(W, Rd(W)));
                var mt = !(hf(se) && "chain" in se) || !!se.chain, Ut = e22(L);
                return Ig(qe, function(rn) {
                  var Dn = W[rn];
                  L[rn] = Dn, Ut && (L.prototype[rn] = function() {
                    var Xr = this.__chain__;
                    if (mt || Xr) {
                      var Kr = L(this.__wrapped__), va = Kr.__actions__ = Og(this.__actions__);
                      return va.push({ func: Dn, args: arguments, thisArg: L }), Kr.__chain__ = Xr, Kr;
                    }
                    return Dn.apply(L, C_([this.value()], arguments));
                  });
                }), L;
              }
              function Crt() {
                return Uh._ === this && (Uh._ = $j), this;
              }
              function Nne() {
              }
              function Mrt(L) {
                return L = Es(L), As(function(W) {
                  return bG(W, L);
                });
              }
              var Art = pne(yc), Ert = pne(Rj), Irt = pne(mF);
              function wxe(L) {
                return xne(L) ? yF(I_(L)) : fne(L);
              }
              function Trt(L) {
                return function(W) {
                  return L == null ? Q : Zw(L, W);
                };
              }
              var Drt = A_e(), krt = A_e(true);
              function Vne() {
                return [];
              }
              function zne() {
                return false;
              }
              function Prt() {
                return {};
              }
              function Lrt() {
                return "";
              }
              function Ort() {
                return true;
              }
              function Rrt(L, W) {
                if (L = Es(L), L < 1 || L > xr)
                  return [];
                var se = ba, Te = qh(L, ba);
                W = lo(W), L -= ba;
                for (var qe = xF(Te, W); ++se < L; )
                  W(se);
                return qe;
              }
              function Frt(L) {
                return cs(L) ? yc(L, I_) : $0(L) ? [L] : Og(G_e(hu(L)));
              }
              function Nrt(L) {
                var W = ++Hj;
                return hu(L) + W;
              }
              var Vrt = MG(function(L, W) {
                return L + W;
              }, 0), zrt = vne("ceil"), Brt = MG(function(L, W) {
                return L / W;
              }, 1), jrt = vne("floor");
              function Grt(L) {
                return L && L.length ? xC(L, Ng, LF) : Q;
              }
              function Wrt(L, W) {
                return L && L.length ? xC(L, lo(W, 2), LF) : Q;
              }
              function Hrt(L) {
                return Vj(L, Ng);
              }
              function $rt(L, W) {
                return Vj(L, lo(W, 2));
              }
              function Urt(L) {
                return L && L.length ? xC(L, Ng, VF) : Q;
              }
              function qrt(L, W) {
                return L && L.length ? xC(L, lo(W, 2), VF) : Q;
              }
              var Yrt = MG(function(L, W) {
                return L * W;
              }, 1), Zrt = vne("round"), Xrt = MG(function(L, W) {
                return L - W;
              }, 0);
              function Krt(L) {
                return L && L.length ? _F(L, Ng) : 0;
              }
              function Jrt(L, W) {
                return L && L.length ? _F(L, lo(W, 2)) : 0;
              }
              return st.after = _tt, st.ary = Q_e, st.assign = snt, st.assignIn = dxe, st.assignInWith = VG, st.assignWith = lnt, st.at = unt, st.before = exe, st.bind = Ene, st.bindAll = prt, st.bindKey = txe, st.castArray = Ptt, st.chain = X_e, st.chunk = zQe, st.compact = BQe, st.concat = jQe, st.cond = vrt, st.conforms = grt, st.constant = One, st.countBy = Ket, st.create = cnt, st.curry = nxe, st.curryRight = rxe, st.debounce = axe, st.defaults = fnt, st.defaultsDeep = hnt, st.defer = xtt, st.delay = wtt, st.difference = GQe, st.differenceBy = WQe, st.differenceWith = HQe, st.drop = $Qe, st.dropRight = UQe, st.dropRightWhile = qQe, st.dropWhile = YQe, st.fill = ZQe, st.filter = Qet, st.flatMap = ntt, st.flatMapDeep = rtt, st.flatMapDepth = att, st.flatten = U_e, st.flattenDeep = XQe, st.flattenDepth = KQe, st.flip = Stt, st.flow = yrt, st.flowRight = brt, st.fromPairs = JQe, st.functions = bnt, st.functionsIn = _nt, st.groupBy = itt, st.initial = eet, st.intersection = tet, st.intersectionBy = net, st.intersectionWith = ret, st.invert = wnt, st.invertBy = Snt, st.invokeMap = stt, st.iteratee = Rne, st.keyBy = ltt, st.keys = Rd, st.keysIn = Fg, st.map = PG, st.mapKeys = Mnt, st.mapValues = Ant, st.matches = _rt, st.matchesProperty = xrt, st.memoize = OG, st.merge = Ent, st.mergeWith = pxe, st.method = wrt, st.methodOf = Srt, st.mixin = Fne, st.negate = RG, st.nthArg = Mrt, st.omit = Int, st.omitBy = Tnt, st.once = Ctt, st.orderBy = utt, st.over = Art, st.overArgs = Mtt, st.overEvery = Ert, st.overSome = Irt, st.partial = Ine, st.partialRight = ixe, st.partition = ctt, st.pick = Dnt, st.pickBy = vxe, st.property = wxe, st.propertyOf = Trt, st.pull = set2, st.pullAll = Y_e, st.pullAllBy = uet, st.pullAllWith = cet, st.pullAt = fet, st.range = Drt, st.rangeRight = krt, st.rearg = Att, st.reject = dtt, st.remove = het, st.rest = Ett, st.reverse = Mne, st.sampleSize = vtt, st.set = Pnt, st.setWith = Lnt, st.shuffle = gtt, st.slice = det, st.sortBy = btt, st.sortedUniq = _et, st.sortedUniqBy = xet, st.split = nrt, st.spread = Itt, st.tail = wet, st.take = Cet, st.takeRight = Met, st.takeRightWhile = Aet, st.takeWhile = Eet, st.tap = Get, st.throttle = Ttt, st.thru = kG, st.toArray = cxe, st.toPairs = gxe, st.toPairsIn = mxe, st.toPath = Frt, st.toPlainObject = hxe, st.transform = Ont, st.unary = Dtt, st.union = Iet, st.unionBy = Tet, st.unionWith = Det, st.uniq = ket, st.uniqBy = Pet, st.uniqWith = Let, st.unset = Rnt, st.unzip = Ane, st.unzipWith = Z_e, st.update = Fnt, st.updateWith = Nnt, st.values = WP, st.valuesIn = Vnt, st.without = Oet, st.words = _xe, st.wrap = ktt, st.xor = Ret, st.xorBy = Fet, st.xorWith = Net, st.zip = Vet, st.zipObject = zet, st.zipObjectDeep = Bet, st.zipWith = jet, st.entries = gxe, st.entriesIn = mxe, st.extend = dxe, st.extendWith = VG, Fne(st, st), st.add = Vrt, st.attempt = xxe, st.camelCase = Gnt, st.capitalize = yxe, st.ceil = zrt, st.clamp = znt, st.clone = Ltt, st.cloneDeep = Rtt, st.cloneDeepWith = Ftt, st.cloneWith = Ott, st.conformsTo = Ntt, st.deburr = bxe, st.defaultTo = mrt, st.divide = Brt, st.endsWith = Wnt, st.eq = q1, st.escape = Hnt, st.escapeRegExp = $nt, st.every = Jet, st.find = ett, st.findIndex = H_e, st.findKey = dnt, st.findLast = ttt, st.findLastIndex = $_e, st.findLastKey = pnt, st.floor = jrt, st.forEach = K_e, st.forEachRight = J_e, st.forIn = vnt, st.forInRight = gnt, st.forOwn = mnt, st.forOwnRight = ynt, st.get = kne, st.gt = Vtt, st.gte = ztt, st.has = xnt, st.hasIn = Pne, st.head = q_e, st.identity = Ng, st.includes = ott, st.indexOf = QQe, st.inRange = Bnt, st.invoke = Cnt, st.isArguments = mI, st.isArray = cs, st.isArrayBuffer = Btt, st.isArrayLike = Rg, st.isArrayLikeObject = $f, st.isBoolean = jtt, st.isBuffer = wC, st.isDate = Gtt, st.isElement = Wtt, st.isEmpty = Htt, st.isEqual = $tt, st.isEqualWith = Utt, st.isError = Tne, st.isFinite = qtt, st.isFunction = e22, st.isInteger = oxe, st.isLength = FG, st.isMap = sxe, st.isMatch = Ytt, st.isMatchWith = Ztt, st.isNaN = Xtt, st.isNative = Ktt, st.isNil = Qtt, st.isNull = Jtt, st.isNumber = lxe, st.isObject = hf, st.isObjectLike = Mf, st.isPlainObject = UF, st.isRegExp = Dne, st.isSafeInteger = ent, st.isSet = uxe, st.isString = NG, st.isSymbol = $0, st.isTypedArray = GP, st.isUndefined = tnt, st.isWeakMap = nnt, st.isWeakSet = rnt, st.join = aet, st.kebabCase = Unt, st.last = vy, st.lastIndexOf = iet, st.lowerCase = qnt, st.lowerFirst = Ynt, st.lt = ant, st.lte = int, st.max = Grt, st.maxBy = Wrt, st.mean = Hrt, st.meanBy = $rt, st.min = Urt, st.minBy = qrt, st.stubArray = Vne, st.stubFalse = zne, st.stubObject = Prt, st.stubString = Lrt, st.stubTrue = Ort, st.multiply = Yrt, st.nth = oet, st.noConflict = Crt, st.noop = Nne, st.now = LG, st.pad = Znt, st.padEnd = Xnt, st.padStart = Knt, st.parseInt = Jnt, st.random = jnt, st.reduce = ftt, st.reduceRight = htt, st.repeat = Qnt, st.replace = ert, st.result = knt, st.round = Zrt, st.runInContext = _n, st.sample = ptt, st.size = mtt, st.snakeCase = trt, st.some = ytt, st.sortedIndex = pet, st.sortedIndexBy = vet, st.sortedIndexOf = get2, st.sortedLastIndex = met, st.sortedLastIndexBy = yet, st.sortedLastIndexOf = bet, st.startCase = rrt, st.startsWith = art, st.subtract = Xrt, st.sum = Krt, st.sumBy = Jrt, st.template = irt, st.times = Rrt, st.toFinite = t22, st.toInteger = Es, st.toLength = fxe, st.toLower = ort, st.toNumber = gy, st.toSafeInteger = ont, st.toString = hu, st.toUpper = srt, st.trim = lrt, st.trimEnd = urt, st.trimStart = crt, st.truncate = frt, st.unescape = hrt, st.uniqueId = Nrt, st.upperCase = drt, st.upperFirst = Lne, st.each = K_e, st.eachRight = J_e, st.first = q_e, Fne(st, function() {
                var L = {};
                return Lg(st, function(W, se) {
                  Ks.call(st.prototype, se) || (L[se] = W);
                }), L;
              }(), { chain: false }), st.VERSION = ne, Ig(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(L) {
                st[L].placeholder = st;
              }), Ig(["drop", "take"], function(L, W) {
                $i.prototype[L] = function(se) {
                  se = se === Q ? 1 : Ul(Es(se), 0);
                  var Te = this.__filtered__ && !W ? new $i(this) : this.clone();
                  return Te.__filtered__ ? Te.__takeCount__ = qh(se, Te.__takeCount__) : Te.__views__.push({ size: qh(se, ba), type: L + (Te.__dir__ < 0 ? "Right" : "") }), Te;
                }, $i.prototype[L + "Right"] = function(se) {
                  return this.reverse()[L](se).reverse();
                };
              }), Ig(["filter", "map", "takeWhile"], function(L, W) {
                var se = W + 1, Te = se == Ka || se == vr;
                $i.prototype[L] = function(qe) {
                  var mt = this.clone();
                  return mt.__iteratees__.push({ iteratee: lo(qe, 3), type: se }), mt.__filtered__ = mt.__filtered__ || Te, mt;
                };
              }), Ig(["head", "last"], function(L, W) {
                var se = "take" + (W ? "Right" : "");
                $i.prototype[L] = function() {
                  return this[se](1).value()[0];
                };
              }), Ig(["initial", "tail"], function(L, W) {
                var se = "drop" + (W ? "" : "Right");
                $i.prototype[L] = function() {
                  return this.__filtered__ ? new $i(this) : this[se](1);
                };
              }), $i.prototype.compact = function() {
                return this.filter(Ng);
              }, $i.prototype.find = function(L) {
                return this.filter(L).head();
              }, $i.prototype.findLast = function(L) {
                return this.reverse().find(L);
              }, $i.prototype.invokeMap = As(function(L, W) {
                return typeof L == "function" ? new $i(this) : this.map(function(se) {
                  return Xw(se, L, W);
                });
              }), $i.prototype.reject = function(L) {
                return this.filter(RG(lo(L)));
              }, $i.prototype.slice = function(L, W) {
                L = Es(L);
                var se = this;
                return se.__filtered__ && (L > 0 || W < 0) ? new $i(se) : (L < 0 ? se = se.takeRight(-L) : L && (se = se.drop(L)), W !== Q && (W = Es(W), se = W < 0 ? se.dropRight(-W) : se.take(W - L)), se);
              }, $i.prototype.takeRightWhile = function(L) {
                return this.reverse().takeWhile(L).reverse();
              }, $i.prototype.toArray = function() {
                return this.take(ba);
              }, Lg($i.prototype, function(L, W) {
                var se = /^(?:filter|find|map|reject)|While$/.test(W), Te = /^(?:head|last)$/.test(W), qe = st[Te ? "take" + (W == "last" ? "Right" : "") : W], mt = Te || /^find/.test(W);
                !qe || (st.prototype[W] = function() {
                  var Ut = this.__wrapped__, rn = Te ? [1] : arguments, Dn = Ut instanceof $i, Xr = rn[0], Kr = Dn || cs(Ut), va = function(cl) {
                    var bl = qe.apply(st, C_([cl], rn));
                    return Te && Ja ? bl[0] : bl;
                  };
                  Kr && se && typeof Xr == "function" && Xr.length != 1 && (Dn = Kr = false);
                  var Ja = this.__chain__, Li = !!this.__actions__.length, ho = mt && !Ja, Fs = Dn && !Li;
                  if (!mt && Kr) {
                    Ut = Fs ? Ut : new $i(this);
                    var po = L.apply(Ut, rn);
                    return po.__actions__.push({ func: kG, args: [va], thisArg: Q }), new Dg(po, Ja);
                  }
                  return ho && Fs ? L.apply(this, rn) : (po = this.thru(va), ho ? Te ? po.value()[0] : po.value() : po);
                });
              }), Ig(["pop", "push", "shift", "sort", "splice", "unshift"], function(L) {
                var W = AP[L], se = /^(?:push|sort|unshift)$/.test(L) ? "tap" : "thru", Te = /^(?:pop|shift)$/.test(L);
                st.prototype[L] = function() {
                  var qe = arguments;
                  if (Te && !this.__chain__) {
                    var mt = this.value();
                    return W.apply(cs(mt) ? mt : [], qe);
                  }
                  return this[se](function(Ut) {
                    return W.apply(cs(Ut) ? Ut : [], qe);
                  });
                };
              }), Lg($i.prototype, function(L, W) {
                var se = st[W];
                if (se) {
                  var Te = se.name + "";
                  Ks.call(yC, Te) || (yC[Te] = []), yC[Te].push({ name: W, func: se });
                }
              }), yC[CG(Q, _r).name] = [{ name: "wrapper", func: Q }], $i.prototype.clone = lv, $i.prototype.reverse = Dte, $i.prototype.value = kte, st.prototype.at = Wet, st.prototype.chain = Het, st.prototype.commit = $et, st.prototype.next = Uet, st.prototype.plant = Yet, st.prototype.reverse = Zet, st.prototype.toJSON = st.prototype.valueOf = st.prototype.value = Xet, st.prototype.first = st.prototype.head, pC && (st.prototype[pC] = qet), st;
            }, Pd = yte();
            Ww ? ((Ww.exports = Pd)._ = Pd, dF._ = Pd) : Uh._ = Pd;
          }).call(pt);
        })(qt, qt.exports);
        class Yt {
          constructor() {
            ee(this, "subscriptions", /* @__PURE__ */ new Map()), ee(this, "useSubscription", (ge, Q) => {
              const ne = te.useRef();
              te.useEffect(() => {
                ne.current = Q;
                function re(fe) {
                  ne.current && ne.current(fe);
                }
                return this.subscriptions.set(ge, re), () => {
                  this.subscriptions.delete(ge);
                };
              }, []);
            }), ee(this, "emit", (ge, ...Q) => {
              if (typeof ge == "string" || typeof ge == "number") {
                const ne = this.subscriptions.get(ge);
                ne == null || ne({ params: qt.exports.cloneDeep(Q), event: ge });
              } else
                throw new TypeError("event must be string or number !");
            }), ee(this, "removeListener", (ge) => {
              this.subscriptions.delete(ge);
            }), ee(this, "clear", () => {
              this.subscriptions.clear();
            }), this.clear();
          }
        }
        const nn = new Yt();
        function ln(Y) {
          const ge = te.useRef(), Q = te.useMemo(() => Y != null ? Y : { global: false }, [Y]);
          return ge.current || (ge.current = Q.global ? ge.current = nn : ge.current = new Yt()), te.useEffect(() => () => {
            var ne;
            return (ne = ge.current) == null ? void 0 : ne.clear();
          }, []), ge.current;
        }
        var yr = globalThis && globalThis.__read || function(Y, ge) {
          var Q = typeof Symbol == "function" && Y[Symbol.iterator];
          if (!Q)
            return Y;
          var ne = Q.call(Y), re, fe = [], Ee;
          try {
            for (; (ge === void 0 || ge-- > 0) && !(re = ne.next()).done; )
              fe.push(re.value);
          } catch (Oe) {
            Ee = { error: Oe };
          } finally {
            try {
              re && !re.done && (Q = ne.return) && Q.call(ne);
            } finally {
              if (Ee)
                throw Ee.error;
            }
          }
          return fe;
        };
        function sr(Y, ge) {
          Y === void 0 && (Y = false);
          var Q = yr(te.useState(Y), 2), ne = Q[0], re = Q[1], fe = te.useMemo(function() {
            var Ee = ge === void 0 ? !Y : ge, Oe = function() {
              return re(function(yt) {
                return yt === Y ? Ee : Y;
              });
            }, Be = function(yt) {
              return re(yt);
            }, Ze = function() {
              return re(Y);
            }, Je = function() {
              return re(Ee);
            };
            return { toggle: Oe, set: Be, setLeft: Ze, setRight: Je };
          }, []);
          return [ne, fe];
        }
        var aa = globalThis && globalThis.__read || function(Y, ge) {
          var Q = typeof Symbol == "function" && Y[Symbol.iterator];
          if (!Q)
            return Y;
          var ne = Q.call(Y), re, fe = [], Ee;
          try {
            for (; (ge === void 0 || ge-- > 0) && !(re = ne.next()).done; )
              fe.push(re.value);
          } catch (Oe) {
            Ee = { error: Oe };
          } finally {
            try {
              re && !re.done && (Q = ne.return) && Q.call(ne);
            } finally {
              if (Ee)
                throw Ee.error;
            }
          }
          return fe;
        };
        function He(Y) {
          Y === void 0 && (Y = false);
          var ge = aa(sr(Y), 2), Q = ge[0], ne = ge[1], re = ne.toggle, fe = ne.set, Ee = te.useMemo(function() {
            var Oe = function() {
              return fe(true);
            }, Be = function() {
              return fe(false);
            };
            return { toggle: re, set: function(Ze) {
              return fe(!!Ze);
            }, setTrue: Oe, setFalse: Be };
          }, []);
          return [Q, Ee];
        }
        function Cn(Y) {
          var ge = te.useRef(Y);
          return ge.current = Y, ge;
        }
        var On = function(Y) {
          var ge = Cn(Y);
          te.useEffect(function() {
            return function() {
              ge.current();
            };
          }, []);
        }, dr = On;
        function ur(Y) {
          var ge = typeof Y;
          return Y != null && (ge == "object" || ge == "function");
        }
        var An = ur, Nn = typeof pt == "object" && pt && pt.Object === Object && pt, Ar = Nn, Jr = Ar, bn = typeof self == "object" && self && self.Object === Object && self, Xa = Jr || bn || Function("return this")(), qa = Xa, ir = qa, Ai = function() {
          return ir.Date.now();
        }, gr = Ai, Qn = /\s/;
        function Yn(Y) {
          for (var ge = Y.length; ge-- && Qn.test(Y.charAt(ge)); )
            ;
          return ge;
        }
        var ya = Yn, sa = ya, Wi = /^\s+/;
        function xs(Y) {
          return Y && Y.slice(0, sa(Y) + 1).replace(Wi, "");
        }
        var is = xs, io = qa, Ol = io.Symbol, os = Ol, rl = os, Cu = Object.prototype, wd = Cu.hasOwnProperty, cp = Cu.toString, tc = rl ? rl.toStringTag : void 0;
        function cc(Y) {
          var ge = wd.call(Y, tc), Q = Y[tc];
          try {
            Y[tc] = void 0;
            var ne = true;
          } catch {
          }
          var re = cp.call(Y);
          return ne && (ge ? Y[tc] = Q : delete Y[tc]), re;
        }
        var uh = cc, fp = Object.prototype, ef = fp.toString;
        function Sd(Y) {
          return ef.call(Y);
        }
        var Ei = Sd, ch = os, nc = uh, ju = Ei, fc = "[object Null]", Xp = "[object Undefined]", kr = ch ? ch.toStringTag : void 0;
        function kn(Y) {
          return Y == null ? Y === void 0 ? Xp : fc : kr && kr in Object(Y) ? nc(Y) : ju(Y);
        }
        var jn = kn;
        function Or(Y) {
          return Y != null && typeof Y == "object";
        }
        var Ea = Or, pi = jn, To = Ea, Do = "[object Symbol]";
        function hl(Y) {
          return typeof Y == "symbol" || To(Y) && pi(Y) == Do;
        }
        var Mu = hl, qs = is, Os = An, Rl = Mu, Vf = 0 / 0, zf = /^[-+]0x[0-9a-f]+$/i, Kp = /^0b[01]+$/i, Fh = /^0o[0-7]+$/i, su = parseInt;
        function hs(Y) {
          if (typeof Y == "number")
            return Y;
          if (Rl(Y))
            return Vf;
          if (Os(Y)) {
            var ge = typeof Y.valueOf == "function" ? Y.valueOf() : Y;
            Y = Os(ge) ? ge + "" : ge;
          }
          if (typeof Y != "string")
            return Y === 0 ? Y : +Y;
          Y = qs(Y);
          var Q = Kp.test(Y);
          return Q || Fh.test(Y) ? su(Y.slice(2), Q ? 2 : 8) : zf.test(Y) ? Vf : +Y;
        }
        var Nc = hs, Bf = An, Cd = gr, Nh = Nc, Vh = "Expected a function", Md = Math.max, E0 = Math.min;
        function I0(Y, ge, Q) {
          var ne, re, fe, Ee, Oe, Be, Ze = 0, Je = false, yt = false, Gt = true;
          if (typeof Y != "function")
            throw new TypeError(Vh);
          ge = Nh(ge) || 0, Bf(Q) && (Je = !!Q.leading, yt = "maxWait" in Q, fe = yt ? Md(Nh(Q.maxWait) || 0, ge) : fe, Gt = "trailing" in Q ? !!Q.trailing : Gt);
          function Xt(zn) {
            var pr = ne, fr = re;
            return ne = re = void 0, Ze = zn, Ee = Y.apply(fr, pr), Ee;
          }
          function Zt(zn) {
            return Ze = zn, Oe = setTimeout(_r, ge), Je ? Xt(zn) : Ee;
          }
          function un(zn) {
            var pr = zn - Be, fr = zn - Ze, Tn = ge - pr;
            return yt ? E0(Tn, fe - fr) : Tn;
          }
          function yn(zn) {
            var pr = zn - Be, fr = zn - Ze;
            return Be === void 0 || pr >= ge || pr < 0 || yt && fr >= fe;
          }
          function _r() {
            var zn = Cd();
            if (yn(zn))
              return cr(zn);
            Oe = setTimeout(_r, un(zn));
          }
          function cr(zn) {
            return Oe = void 0, Gt && ne ? Xt(zn) : (ne = re = void 0, Ee);
          }
          function fa() {
            Oe !== void 0 && clearTimeout(Oe), Ze = 0, ne = Be = re = Oe = void 0;
          }
          function We() {
            return Oe === void 0 ? Ee : cr(Cd());
          }
          function pn() {
            var zn = Cd(), pr = yn(zn);
            if (ne = arguments, re = this, Be = zn, pr) {
              if (Oe === void 0)
                return Zt(Be);
              if (yt)
                return clearTimeout(Oe), Oe = setTimeout(_r, ge), Xt(Be);
            }
            return Oe === void 0 && (Oe = setTimeout(_r, ge)), Ee;
          }
          return pn.cancel = fa, pn.flush = We, pn;
        }
        var pw = I0, T0 = globalThis && globalThis.__read || function(Y, ge) {
          var Q = typeof Symbol == "function" && Y[Symbol.iterator];
          if (!Q)
            return Y;
          var ne = Q.call(Y), re, fe = [], Ee;
          try {
            for (; (ge === void 0 || ge-- > 0) && !(re = ne.next()).done; )
              fe.push(re.value);
          } catch (Oe) {
            Ee = { error: Oe };
          } finally {
            try {
              re && !re.done && (Q = ne.return) && Q.call(ne);
            } finally {
              if (Ee)
                throw Ee.error;
            }
          }
          return fe;
        }, S1 = globalThis && globalThis.__spread || function() {
          for (var Y = [], ge = 0; ge < arguments.length; ge++)
            Y = Y.concat(T0(arguments[ge]));
          return Y;
        };
        function vw(Y, ge) {
          var Q, ne = Cn(Y), re = (Q = ge == null ? void 0 : ge.wait) !== null && Q !== void 0 ? Q : 1e3, fe = te.useMemo(function() {
            return pw(function() {
              for (var Ee = [], Oe = 0; Oe < arguments.length; Oe++)
                Ee[Oe] = arguments[Oe];
              return ne.current.apply(ne, S1(Ee));
            }, re, ge);
          }, []);
          return dr(function() {
            fe.cancel();
          }), { run: fe, cancel: fe.cancel, flush: fe.flush };
        }
        const i_ = ({ id: Y, title: ge, chart: Q, option: ne }, re) => {
          const fe = te.useRef(), Ee = ln({ global: true });
          fe.current = te.useMemo(() => {
            if (!fe.current)
              return Ke;
          }, []);
          const { run: Oe } = vw(() => {
            Y && Ee.emit("list");
          }, { wait: 100 });
          return te.useEffect(() => {
            console.log(Q == null ? void 0 : Q.current), fe.current && (Q == null ? void 0 : Q.current) && Y && ne && (fe.current.add(Y, Q == null ? void 0 : Q.current, ne, ge), Oe());
          }, re), { tool: fe.current };
        };
        var OS = te.createContext({}), xg = OS;
        function St(Y, ge, Q) {
          return ge in Y ? Object.defineProperty(Y, ge, { value: Q, enumerable: true, configurable: true, writable: true }) : Y[ge] = Q, Y;
        }
        function Rt(Y, ge) {
          var Q = Object.keys(Y);
          if (Object.getOwnPropertySymbols) {
            var ne = Object.getOwnPropertySymbols(Y);
            ge && (ne = ne.filter(function(re) {
              return Object.getOwnPropertyDescriptor(Y, re).enumerable;
            })), Q.push.apply(Q, ne);
          }
          return Q;
        }
        function Xe(Y) {
          for (var ge = 1; ge < arguments.length; ge++) {
            var Q = arguments[ge] != null ? arguments[ge] : {};
            ge % 2 ? Rt(Object(Q), true).forEach(function(ne) {
              St(Y, ne, Q[ne]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Y, Object.getOwnPropertyDescriptors(Q)) : Rt(Object(Q)).forEach(function(ne) {
              Object.defineProperty(Y, ne, Object.getOwnPropertyDescriptor(Q, ne));
            });
          }
          return Y;
        }
        function Ct(Y) {
          if (Array.isArray(Y))
            return Y;
        }
        function Tt(Y, ge) {
          var Q = Y == null ? null : typeof Symbol != "undefined" && Y[Symbol.iterator] || Y["@@iterator"];
          if (Q != null) {
            var ne = [], re = true, fe = false, Ee, Oe;
            try {
              for (Q = Q.call(Y); !(re = (Ee = Q.next()).done) && (ne.push(Ee.value), !(ge && ne.length === ge)); re = true)
                ;
            } catch (Be) {
              fe = true, Oe = Be;
            } finally {
              try {
                !re && Q.return != null && Q.return();
              } finally {
                if (fe)
                  throw Oe;
              }
            }
            return ne;
          }
        }
        function Ln(Y, ge) {
          (ge == null || ge > Y.length) && (ge = Y.length);
          for (var Q = 0, ne = new Array(ge); Q < ge; Q++)
            ne[Q] = Y[Q];
          return ne;
        }
        function Cr(Y, ge) {
          if (Y) {
            if (typeof Y == "string")
              return Ln(Y, ge);
            var Q = Object.prototype.toString.call(Y).slice(8, -1);
            if (Q === "Object" && Y.constructor && (Q = Y.constructor.name), Q === "Map" || Q === "Set")
              return Array.from(Y);
            if (Q === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Q))
              return Ln(Y, ge);
          }
        }
        function or() {
          throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
        }
        function cn(Y, ge) {
          return Ct(Y) || Tt(Y, ge) || Cr(Y, ge) || or();
        }
        function na(Y, ge) {
          if (Y == null)
            return {};
          var Q = {}, ne = Object.keys(Y), re, fe;
          for (fe = 0; fe < ne.length; fe++)
            re = ne[fe], !(ge.indexOf(re) >= 0) && (Q[re] = Y[re]);
          return Q;
        }
        function ni(Y, ge) {
          if (Y == null)
            return {};
          var Q = na(Y, ge), ne, re;
          if (Object.getOwnPropertySymbols) {
            var fe = Object.getOwnPropertySymbols(Y);
            for (re = 0; re < fe.length; re++)
              ne = fe[re], !(ge.indexOf(ne) >= 0) && (!Object.prototype.propertyIsEnumerable.call(Y, ne) || (Q[ne] = Y[ne]));
          }
          return Q;
        }
        var Ho = { exports: {} };
        /*!
          Copyright (c) 2018 Jed Watson.
          Licensed under the MIT License (MIT), see
          http://jedwatson.github.io/classnames
        */
        (function(Y) {
          (function() {
            var ge = {}.hasOwnProperty;
            function Q() {
              for (var ne = [], re = 0; re < arguments.length; re++) {
                var fe = arguments[re];
                if (fe) {
                  var Ee = typeof fe;
                  if (Ee === "string" || Ee === "number")
                    ne.push(fe);
                  else if (Array.isArray(fe)) {
                    if (fe.length) {
                      var Oe = Q.apply(null, fe);
                      Oe && ne.push(Oe);
                    }
                  } else if (Ee === "object")
                    if (fe.toString === Object.prototype.toString)
                      for (var Be in fe)
                        ge.call(fe, Be) && fe[Be] && ne.push(Be);
                    else
                      ne.push(fe.toString());
                }
              }
              return ne.join(" ");
            }
            Y.exports ? (Q.default = Q, Y.exports = Q) : window.classNames = Q;
          })();
        })(Ho);
        var Fo = Ho.exports;
        function _o(Y) {
          return _o = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(ge) {
            return typeof ge;
          } : function(ge) {
            return ge && typeof Symbol == "function" && ge.constructor === Symbol && ge !== Symbol.prototype ? "symbol" : typeof ge;
          }, _o(Y);
        }
        function ji(Y, ge) {
          Cl(Y) && (Y = "100%");
          var Q = Au(Y);
          return Y = ge === 360 ? Y : Math.min(ge, Math.max(0, parseFloat(Y))), Q && (Y = parseInt(String(Y * ge), 10) / 100), Math.abs(Y - ge) < 1e-6 ? 1 : (ge === 360 ? Y = (Y < 0 ? Y % ge + ge : Y % ge) / parseFloat(String(ge)) : Y = Y % ge / parseFloat(String(ge)), Y);
        }
        function Cl(Y) {
          return typeof Y == "string" && Y.indexOf(".") !== -1 && parseFloat(Y) === 1;
        }
        function Au(Y) {
          return typeof Y == "string" && Y.indexOf("%") !== -1;
        }
        function oo(Y) {
          return Y = parseFloat(Y), (isNaN(Y) || Y < 0 || Y > 1) && (Y = 1), Y;
        }
        function Eu(Y) {
          return Y <= 1 ? Number(Y) * 100 + "%" : Y;
        }
        function jf(Y) {
          return Y.length === 1 ? "0" + Y : String(Y);
        }
        function Nv(Y, ge, Q) {
          return { r: ji(Y, 255) * 255, g: ji(ge, 255) * 255, b: ji(Q, 255) * 255 };
        }
        function Jm(Y, ge, Q) {
          return Q < 0 && (Q += 1), Q > 1 && (Q -= 1), Q < 1 / 6 ? Y + (ge - Y) * (6 * Q) : Q < 1 / 2 ? ge : Q < 2 / 3 ? Y + (ge - Y) * (2 / 3 - Q) * 6 : Y;
        }
        function Jp(Y, ge, Q) {
          var ne, re, fe;
          if (Y = ji(Y, 360), ge = ji(ge, 100), Q = ji(Q, 100), ge === 0)
            re = Q, fe = Q, ne = Q;
          else {
            var Ee = Q < 0.5 ? Q * (1 + ge) : Q + ge - Q * ge, Oe = 2 * Q - Ee;
            ne = Jm(Oe, Ee, Y + 1 / 3), re = Jm(Oe, Ee, Y), fe = Jm(Oe, Ee, Y - 1 / 3);
          }
          return { r: ne * 255, g: re * 255, b: fe * 255 };
        }
        function C1(Y, ge, Q) {
          Y = ji(Y, 255), ge = ji(ge, 255), Q = ji(Q, 255);
          var ne = Math.max(Y, ge, Q), re = Math.min(Y, ge, Q), fe = 0, Ee = ne, Oe = ne - re, Be = ne === 0 ? 0 : Oe / ne;
          if (ne === re)
            fe = 0;
          else {
            switch (ne) {
              case Y:
                fe = (ge - Q) / Oe + (ge < Q ? 6 : 0);
                break;
              case ge:
                fe = (Q - Y) / Oe + 2;
                break;
              case Q:
                fe = (Y - ge) / Oe + 4;
                break;
            }
            fe /= 6;
          }
          return { h: fe, s: Be, v: Ee };
        }
        function D0(Y, ge, Q) {
          Y = ji(Y, 360) * 6, ge = ji(ge, 100), Q = ji(Q, 100);
          var ne = Math.floor(Y), re = Y - ne, fe = Q * (1 - ge), Ee = Q * (1 - re * ge), Oe = Q * (1 - (1 - re) * ge), Be = ne % 6, Ze = [Q, Ee, fe, fe, Oe, Q][Be], Je = [Oe, Q, Q, Ee, fe, fe][Be], yt = [fe, fe, Oe, Q, Q, Ee][Be];
          return { r: Ze * 255, g: Je * 255, b: yt * 255 };
        }
        function tf(Y, ge, Q, ne) {
          var re = [jf(Math.round(Y).toString(16)), jf(Math.round(ge).toString(16)), jf(Math.round(Q).toString(16))];
          return ne && re[0].startsWith(re[0].charAt(1)) && re[1].startsWith(re[1].charAt(1)) && re[2].startsWith(re[2].charAt(1)) ? re[0].charAt(0) + re[1].charAt(0) + re[2].charAt(0) : re.join("");
        }
        function Vv(Y) {
          return nf(Y) / 255;
        }
        function nf(Y) {
          return parseInt(Y, 16);
        }
        var wg = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
        function hc(Y) {
          var ge = { r: 0, g: 0, b: 0 }, Q = 1, ne = null, re = null, fe = null, Ee = false, Oe = false;
          return typeof Y == "string" && (Y = mw(Y)), typeof Y == "object" && (zv(Y.r) && zv(Y.g) && zv(Y.b) ? (ge = Nv(Y.r, Y.g, Y.b), Ee = true, Oe = String(Y.r).substr(-1) === "%" ? "prgb" : "rgb") : zv(Y.h) && zv(Y.s) && zv(Y.v) ? (ne = Eu(Y.s), re = Eu(Y.v), ge = D0(Y.h, ne, re), Ee = true, Oe = "hsv") : zv(Y.h) && zv(Y.s) && zv(Y.l) && (ne = Eu(Y.s), fe = Eu(Y.l), ge = Jp(Y.h, ne, fe), Ee = true, Oe = "hsl"), Object.prototype.hasOwnProperty.call(Y, "a") && (Q = Y.a)), Q = oo(Q), { ok: Ee, format: Y.format || Oe, r: Math.min(255, Math.max(ge.r, 0)), g: Math.min(255, Math.max(ge.g, 0)), b: Math.min(255, Math.max(ge.b, 0)), a: Q };
        }
        var M1 = "[-\\+]?\\d+%?", gw = "[-\\+]?\\d*\\.\\d+%?", hp = "(?:" + gw + ")|(?:" + M1 + ")", k0 = "[\\s|\\(]+(" + hp + ")[,|\\s]+(" + hp + ")[,|\\s]+(" + hp + ")\\s*\\)?", P0 = "[\\s|\\(]+(" + hp + ")[,|\\s]+(" + hp + ")[,|\\s]+(" + hp + ")[,|\\s]+(" + hp + ")\\s*\\)?", xf = { CSS_UNIT: new RegExp(hp), rgb: new RegExp("rgb" + k0), rgba: new RegExp("rgba" + P0), hsl: new RegExp("hsl" + k0), hsla: new RegExp("hsla" + P0), hsv: new RegExp("hsv" + k0), hsva: new RegExp("hsva" + P0), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
        function mw(Y) {
          if (Y = Y.trim().toLowerCase(), Y.length === 0)
            return false;
          var ge = false;
          if (wg[Y])
            Y = wg[Y], ge = true;
          else if (Y === "transparent")
            return { r: 0, g: 0, b: 0, a: 0, format: "name" };
          var Q = xf.rgb.exec(Y);
          return Q ? { r: Q[1], g: Q[2], b: Q[3] } : (Q = xf.rgba.exec(Y), Q ? { r: Q[1], g: Q[2], b: Q[3], a: Q[4] } : (Q = xf.hsl.exec(Y), Q ? { h: Q[1], s: Q[2], l: Q[3] } : (Q = xf.hsla.exec(Y), Q ? { h: Q[1], s: Q[2], l: Q[3], a: Q[4] } : (Q = xf.hsv.exec(Y), Q ? { h: Q[1], s: Q[2], v: Q[3] } : (Q = xf.hsva.exec(Y), Q ? { h: Q[1], s: Q[2], v: Q[3], a: Q[4] } : (Q = xf.hex8.exec(Y), Q ? { r: nf(Q[1]), g: nf(Q[2]), b: nf(Q[3]), a: Vv(Q[4]), format: ge ? "name" : "hex8" } : (Q = xf.hex6.exec(Y), Q ? { r: nf(Q[1]), g: nf(Q[2]), b: nf(Q[3]), format: ge ? "name" : "hex" } : (Q = xf.hex4.exec(Y), Q ? { r: nf(Q[1] + Q[1]), g: nf(Q[2] + Q[2]), b: nf(Q[3] + Q[3]), a: Vv(Q[4] + Q[4]), format: ge ? "name" : "hex8" } : (Q = xf.hex3.exec(Y), Q ? { r: nf(Q[1] + Q[1]), g: nf(Q[2] + Q[2]), b: nf(Q[3] + Q[3]), format: ge ? "name" : "hex" } : false)))))))));
        }
        function zv(Y) {
          return Boolean(xf.CSS_UNIT.exec(String(Y)));
        }
        var Qm = 2, A1 = 0.16, wk = 0.05, Sk = 0.05, I6 = 0.15, vE = 5, gE = 4, Ck = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
        function mE(Y) {
          var ge = Y.r, Q = Y.g, ne = Y.b, re = C1(ge, Q, ne);
          return { h: re.h * 360, s: re.s, v: re.v };
        }
        function RS(Y) {
          var ge = Y.r, Q = Y.g, ne = Y.b;
          return "#".concat(tf(ge, Q, ne, false));
        }
        function T6(Y, ge, Q) {
          var ne = Q / 100, re = { r: (ge.r - Y.r) * ne + Y.r, g: (ge.g - Y.g) * ne + Y.g, b: (ge.b - Y.b) * ne + Y.b };
          return re;
        }
        function Mk(Y, ge, Q) {
          var ne;
          return Math.round(Y.h) >= 60 && Math.round(Y.h) <= 240 ? ne = Q ? Math.round(Y.h) - Qm * ge : Math.round(Y.h) + Qm * ge : ne = Q ? Math.round(Y.h) + Qm * ge : Math.round(Y.h) - Qm * ge, ne < 0 ? ne += 360 : ne >= 360 && (ne -= 360), ne;
        }
        function yE(Y, ge, Q) {
          if (Y.h === 0 && Y.s === 0)
            return Y.s;
          var ne;
          return Q ? ne = Y.s - A1 * ge : ge === gE ? ne = Y.s + A1 : ne = Y.s + wk * ge, ne > 1 && (ne = 1), Q && ge === vE && ne > 0.1 && (ne = 0.1), ne < 0.06 && (ne = 0.06), Number(ne.toFixed(2));
        }
        function Ak(Y, ge, Q) {
          var ne;
          return Q ? ne = Y.v + Sk * ge : ne = Y.v - I6 * ge, ne > 1 && (ne = 1), Number(ne.toFixed(2));
        }
        function bE(Y) {
          for (var ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Q = [], ne = hc(Y), re = vE; re > 0; re -= 1) {
            var fe = mE(ne), Ee = RS(hc({ h: Mk(fe, re, true), s: yE(fe, re, true), v: Ak(fe, re, true) }));
            Q.push(Ee);
          }
          Q.push(RS(ne));
          for (var Oe = 1; Oe <= gE; Oe += 1) {
            var Be = mE(ne), Ze = RS(hc({ h: Mk(Be, Oe), s: yE(Be, Oe), v: Ak(Be, Oe) }));
            Q.push(Ze);
          }
          return ge.theme === "dark" ? Ck.map(function(Je) {
            var yt = Je.index, Gt = Je.opacity, Xt = RS(T6(hc(ge.backgroundColor || "#141414"), hc(Q[yt]), Gt * 100));
            return Xt;
          }) : Q;
        }
        var _E = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, fh = {}, yw = {};
        Object.keys(_E).forEach(function(Y) {
          fh[Y] = bE(_E[Y]), fh[Y].primary = fh[Y][5], yw[Y] = bE(_E[Y], { theme: "dark", backgroundColor: "#141414" }), yw[Y].primary = yw[Y][5];
        }), fh.red, fh.volcano, fh.gold, fh.orange, fh.yellow, fh.lime, fh.green, fh.cyan, fh.blue, fh.geekblue, fh.purple, fh.magenta, fh.grey;
        var Ek = {};
        function D6(Y, ge) {
        }
        function k6(Y, ge, Q) {
          !ge && !Ek[Q] && (Y(false, Q), Ek[Q] = true);
        }
        function Qp(Y, ge) {
          k6(D6, Y, ge);
        }
        function xE() {
          return !!(typeof window != "undefined" && window.document && window.document.createElement);
        }
        var Iu = "rc-util-key";
        function eu() {
          var Y = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, ge = Y.mark;
          return ge ? ge.startsWith("data-") ? ge : "data-".concat(ge) : Iu;
        }
        function wE(Y) {
          if (Y.attachTo)
            return Y.attachTo;
          var ge = document.querySelector("head");
          return ge || document.body;
        }
        function Ik(Y) {
          var ge, Q = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
          if (!xE())
            return null;
          var ne = document.createElement("style");
          if (!((ge = Q.csp) === null || ge === void 0) && ge.nonce) {
            var re;
            ne.nonce = (re = Q.csp) === null || re === void 0 ? void 0 : re.nonce;
          }
          ne.innerHTML = Y;
          var fe = wE(Q), Ee = fe.firstChild;
          return Q.prepend && fe.prepend ? fe.prepend(ne) : Q.prepend && Ee ? fe.insertBefore(ne, Ee) : fe.appendChild(ne), ne;
        }
        var SE = /* @__PURE__ */ new Map();
        function P6(Y) {
          var ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Q = wE(ge);
          return Array.from(SE.get(Q).children).find(function(ne) {
            return ne.tagName === "STYLE" && ne.getAttribute(eu(ge)) === Y;
          });
        }
        function Tk(Y, ge) {
          var Q = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, ne = wE(Q);
          if (!SE.has(ne)) {
            var re = Ik("", Q), fe = re.parentNode;
            SE.set(ne, fe), fe.removeChild(re);
          }
          var Ee = P6(ge, Q);
          if (Ee) {
            var Oe, Be;
            if (((Oe = Q.csp) === null || Oe === void 0 ? void 0 : Oe.nonce) && Ee.nonce !== ((Be = Q.csp) === null || Be === void 0 ? void 0 : Be.nonce)) {
              var Ze;
              Ee.nonce = (Ze = Q.csp) === null || Ze === void 0 ? void 0 : Ze.nonce;
            }
            return Ee.innerHTML !== Y && (Ee.innerHTML = Y), Ee;
          }
          var Je = Ik(Y, Q);
          return Je.setAttribute(eu(Q), ge), Je;
        }
        function L6(Y, ge) {
          Qp(Y, "[@ant-design/icons] ".concat(ge));
        }
        function FS(Y) {
          return _o(Y) === "object" && typeof Y.name == "string" && typeof Y.theme == "string" && (_o(Y.icon) === "object" || typeof Y.icon == "function");
        }
        function Dk() {
          var Y = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          return Object.keys(Y).reduce(function(ge, Q) {
            var ne = Y[Q];
            switch (Q) {
              case "class":
                ge.className = ne, delete ge.class;
                break;
              default:
                ge[Q] = ne;
            }
            return ge;
          }, {});
        }
        function dc(Y, ge, Q) {
          return Q ? Le.default.createElement(Y.tag, Xe(Xe({ key: ge }, Dk(Y.attrs)), Q), (Y.children || []).map(function(ne, re) {
            return dc(ne, "".concat(ge, "-").concat(Y.tag, "-").concat(re));
          })) : Le.default.createElement(Y.tag, Xe({ key: ge }, Dk(Y.attrs)), (Y.children || []).map(function(ne, re) {
            return dc(ne, "".concat(ge, "-").concat(Y.tag, "-").concat(re));
          }));
        }
        function NS(Y) {
          return bE(Y)[0];
        }
        function ey(Y) {
          return Y ? Array.isArray(Y) ? Y : [Y] : [];
        }
        var kk = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, CE = function() {
          var Y = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : kk, ge = te.useContext(xg), Q = ge.csp;
          te.useEffect(function() {
            Tk(Y, "@ant-design-icons", { prepend: true, csp: Q });
          }, []);
        }, ev = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], o_ = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
        function Pk(Y) {
          var ge = Y.primaryColor, Q = Y.secondaryColor;
          o_.primaryColor = ge, o_.secondaryColor = Q || NS(ge), o_.calculated = !!Q;
        }
        function Lk() {
          return Xe({}, o_);
        }
        var bw = function(Y) {
          var ge = Y.icon, Q = Y.className, ne = Y.onClick, re = Y.style, fe = Y.primaryColor, Ee = Y.secondaryColor, Oe = ni(Y, ev), Be = o_;
          if (fe && (Be = { primaryColor: fe, secondaryColor: Ee || NS(fe) }), CE(), L6(FS(ge), "icon should be icon definiton, but got ".concat(ge)), !FS(ge))
            return null;
          var Ze = ge;
          return Ze && typeof Ze.icon == "function" && (Ze = Xe(Xe({}, Ze), {}, { icon: Ze.icon(Be.primaryColor, Be.secondaryColor) })), dc(Ze.icon, "svg-".concat(Ze.name), Xe({ className: Q, onClick: ne, style: re, "data-icon": Ze.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, Oe));
        };
        bw.displayName = "IconReact", bw.getTwoToneColors = Lk, bw.setTwoToneColors = Pk;
        var VS = bw;
        function ME(Y) {
          var ge = ey(Y), Q = cn(ge, 2), ne = Q[0], re = Q[1];
          return VS.setTwoToneColors({ primaryColor: ne, secondaryColor: re });
        }
        function dp() {
          var Y = VS.getTwoToneColors();
          return Y.calculated ? [Y.primaryColor, Y.secondaryColor] : Y.primaryColor;
        }
        var O6 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
        ME("#1890ff");
        var zh = De.forwardRef(function(Y, ge) {
          var Q, ne = Y.className, re = Y.icon, fe = Y.spin, Ee = Y.rotate, Oe = Y.tabIndex, Be = Y.onClick, Ze = Y.twoToneColor, Je = ni(Y, O6), yt = De.useContext(xg), Gt = yt.prefixCls, Xt = Gt === void 0 ? "anticon" : Gt, Zt = Fo(Xt, (Q = {}, St(Q, "".concat(Xt, "-").concat(re.name), !!re.name), St(Q, "".concat(Xt, "-spin"), !!fe || re.name === "loading"), Q), ne), un = Oe;
          un === void 0 && Be && (un = -1);
          var yn = Ee ? { msTransform: "rotate(".concat(Ee, "deg)"), transform: "rotate(".concat(Ee, "deg)") } : void 0, _r = ey(Ze), cr = cn(_r, 2), fa = cr[0], We = cr[1];
          return De.createElement("span", Xe(Xe({ role: "img", "aria-label": re.name }, Je), {}, { ref: ge, tabIndex: un, onClick: Be, className: Zt }), De.createElement(VS, { icon: re, primaryColor: fa, secondaryColor: We, style: yn }));
        });
        zh.displayName = "AntdIcon", zh.getTwoToneColor = dp, zh.setTwoToneColor = ME;
        var R6 = zh, Ok = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, L0 = Ok, s_ = function(Y, ge) {
          return De.createElement(R6, Xe(Xe({}, Y), {}, { ref: ge, icon: L0 }));
        };
        s_.displayName = "LoadingOutlined";
        var AE = De.forwardRef(s_);
        function ko() {
          return ko = Object.assign || function(Y) {
            for (var ge = 1; ge < arguments.length; ge++) {
              var Q = arguments[ge];
              for (var ne in Q)
                Object.prototype.hasOwnProperty.call(Q, ne) && (Y[ne] = Q[ne]);
            }
            return Y;
          }, ko.apply(this, arguments);
        }
        function tv(Y, ge) {
          if (!(Y instanceof ge))
            throw new TypeError("Cannot call a class as a function");
        }
        function zS(Y, ge) {
          for (var Q = 0; Q < ge.length; Q++) {
            var ne = ge[Q];
            ne.enumerable = ne.enumerable || false, ne.configurable = true, "value" in ne && (ne.writable = true), Object.defineProperty(Y, ne.key, ne);
          }
        }
        function ty(Y, ge, Q) {
          return ge && zS(Y.prototype, ge), Q && zS(Y, Q), Object.defineProperty(Y, "prototype", { writable: false }), Y;
        }
        function _w(Y, ge) {
          return _w = Object.setPrototypeOf || function(Q, ne) {
            return Q.__proto__ = ne, Q;
          }, _w(Y, ge);
        }
        function EE(Y, ge) {
          if (typeof ge != "function" && ge !== null)
            throw new TypeError("Super expression must either be null or a function");
          Y.prototype = Object.create(ge && ge.prototype, { constructor: { value: Y, writable: true, configurable: true } }), Object.defineProperty(Y, "prototype", { writable: false }), ge && _w(Y, ge);
        }
        function BS(Y) {
          return BS = Object.setPrototypeOf ? Object.getPrototypeOf : function(ge) {
            return ge.__proto__ || Object.getPrototypeOf(ge);
          }, BS(Y);
        }
        function F6() {
          if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), true;
          } catch {
            return false;
          }
        }
        function jS(Y) {
          if (Y === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return Y;
        }
        function GS(Y, ge) {
          if (ge && (_o(ge) === "object" || typeof ge == "function"))
            return ge;
          if (ge !== void 0)
            throw new TypeError("Derived constructors may only return object or undefined");
          return jS(Y);
        }
        function ny(Y) {
          var ge = F6();
          return function() {
            var Q = BS(Y), ne;
            if (ge) {
              var re = BS(this).constructor;
              ne = Reflect.construct(Q, arguments, re);
            } else
              ne = Q.apply(this, arguments);
            return GS(this, ne);
          };
        }
        var IE = { exports: {} }, Ml = {};
        /** @license React v16.13.1
        * react-is.production.min.js
        *
        * Copyright (c) Facebook, Inc. and its affiliates.
        *
        * This source code is licensed under the MIT license found in the
        * LICENSE file in the root directory of this source tree.
        */
        var rf = typeof Symbol == "function" && Symbol.for, xw = rf ? Symbol.for("react.element") : 60103, ry = rf ? Symbol.for("react.portal") : 60106, ww = rf ? Symbol.for("react.fragment") : 60107, Sw = rf ? Symbol.for("react.strict_mode") : 60108, E1 = rf ? Symbol.for("react.profiler") : 60114, ay = rf ? Symbol.for("react.provider") : 60109, Cw = rf ? Symbol.for("react.context") : 60110, Mw = rf ? Symbol.for("react.async_mode") : 60111, Gf = rf ? Symbol.for("react.concurrent_mode") : 60111, I1 = rf ? Symbol.for("react.forward_ref") : 60112, iy = rf ? Symbol.for("react.suspense") : 60113, Rk = rf ? Symbol.for("react.suspense_list") : 60120, Aw = rf ? Symbol.for("react.memo") : 60115, T1 = rf ? Symbol.for("react.lazy") : 60116, WS = rf ? Symbol.for("react.block") : 60121, N6 = rf ? Symbol.for("react.fundamental") : 60117, V6 = rf ? Symbol.for("react.responder") : 60118, TE = rf ? Symbol.for("react.scope") : 60119;
        function af(Y) {
          if (typeof Y == "object" && Y !== null) {
            var ge = Y.$$typeof;
            switch (ge) {
              case xw:
                switch (Y = Y.type, Y) {
                  case Mw:
                  case Gf:
                  case ww:
                  case E1:
                  case Sw:
                  case iy:
                    return Y;
                  default:
                    switch (Y = Y && Y.$$typeof, Y) {
                      case Cw:
                      case I1:
                      case T1:
                      case Aw:
                      case ay:
                        return Y;
                      default:
                        return ge;
                    }
                }
              case ry:
                return ge;
            }
          }
        }
        function Fk(Y) {
          return af(Y) === Gf;
        }
        Ml.AsyncMode = Mw, Ml.ConcurrentMode = Gf, Ml.ContextConsumer = Cw, Ml.ContextProvider = ay, Ml.Element = xw, Ml.ForwardRef = I1, Ml.Fragment = ww, Ml.Lazy = T1, Ml.Memo = Aw, Ml.Portal = ry, Ml.Profiler = E1, Ml.StrictMode = Sw, Ml.Suspense = iy, Ml.isAsyncMode = function(Y) {
          return Fk(Y) || af(Y) === Mw;
        }, Ml.isConcurrentMode = Fk, Ml.isContextConsumer = function(Y) {
          return af(Y) === Cw;
        }, Ml.isContextProvider = function(Y) {
          return af(Y) === ay;
        }, Ml.isElement = function(Y) {
          return typeof Y == "object" && Y !== null && Y.$$typeof === xw;
        }, Ml.isForwardRef = function(Y) {
          return af(Y) === I1;
        }, Ml.isFragment = function(Y) {
          return af(Y) === ww;
        }, Ml.isLazy = function(Y) {
          return af(Y) === T1;
        }, Ml.isMemo = function(Y) {
          return af(Y) === Aw;
        }, Ml.isPortal = function(Y) {
          return af(Y) === ry;
        }, Ml.isProfiler = function(Y) {
          return af(Y) === E1;
        }, Ml.isStrictMode = function(Y) {
          return af(Y) === Sw;
        }, Ml.isSuspense = function(Y) {
          return af(Y) === iy;
        }, Ml.isValidElementType = function(Y) {
          return typeof Y == "string" || typeof Y == "function" || Y === ww || Y === Gf || Y === E1 || Y === Sw || Y === iy || Y === Rk || typeof Y == "object" && Y !== null && (Y.$$typeof === T1 || Y.$$typeof === Aw || Y.$$typeof === ay || Y.$$typeof === Cw || Y.$$typeof === I1 || Y.$$typeof === N6 || Y.$$typeof === V6 || Y.$$typeof === TE || Y.$$typeof === WS);
        }, Ml.typeOf = af, IE.exports = Ml;
        function DE(Y) {
          var ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Q = [];
          return Le.default.Children.forEach(Y, function(ne) {
            ne == null && !ge.keepEmpty || (Array.isArray(ne) ? Q = Q.concat(DE(ne)) : IE.exports.isFragment(ne) && ne.props ? Q = Q.concat(DE(ne.props.children, ge)) : Q.push(ne));
          }), Q;
        }
        function kE(Y, ge) {
          typeof Y == "function" ? Y(ge) : _o(Y) === "object" && Y && "current" in Y && (Y.current = ge);
        }
        function Nk() {
          for (var Y = arguments.length, ge = new Array(Y), Q = 0; Q < Y; Q++)
            ge[Q] = arguments[Q];
          var ne = ge.filter(function(re) {
            return re;
          });
          return ne.length <= 1 ? ne[0] : function(re) {
            ge.forEach(function(fe) {
              kE(fe, re);
            });
          };
        }
        function oy(Y) {
          var ge, Q, ne = IE.exports.isMemo(Y) ? Y.type.type : Y.type;
          return !(typeof ne == "function" && !(!((ge = ne.prototype) === null || ge === void 0) && ge.render) || typeof Y == "function" && !(!((Q = Y.prototype) === null || Q === void 0) && Q.render));
        }
        function HS() {
          try {
            if (!Object.assign)
              return false;
            var Y = new String("abc");
            if (Y[5] = "de", Object.getOwnPropertyNames(Y)[0] === "5")
              return false;
            for (var ge = {}, Q = 0; Q < 10; Q++)
              ge["_" + String.fromCharCode(Q)] = Q;
            var ne = Object.getOwnPropertyNames(ge).map(function(fe) {
              return ge[fe];
            });
            if (ne.join("") !== "0123456789")
              return false;
            var re = {};
            return "abcdefghijklmnopqrst".split("").forEach(function(fe) {
              re[fe] = fe;
            }), Object.keys(Object.assign({}, re)).join("") === "abcdefghijklmnopqrst";
          } catch {
            return false;
          }
        }
        HS();
        function z6(Y) {
          if (Array.isArray(Y))
            return Ln(Y);
        }
        function Vk(Y) {
          if (typeof Symbol != "undefined" && Y[Symbol.iterator] != null || Y["@@iterator"] != null)
            return Array.from(Y);
        }
        function B6() {
          throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
        }
        function Qo(Y) {
          return z6(Y) || Vk(Y) || Cr(Y) || B6();
        }
        var hh = "RC_FORM_INTERNAL_HOOKS", lu = function() {
          Qp(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
        }, Bh = De.createContext({ getFieldValue: lu, getFieldsValue: lu, getFieldError: lu, getFieldWarning: lu, getFieldsError: lu, isFieldsTouched: lu, isFieldTouched: lu, isFieldValidating: lu, isFieldsValidating: lu, resetFields: lu, setFields: lu, setFieldsValue: lu, validateFields: lu, submit: lu, getInternalHooks: function() {
          return lu(), { dispatch: lu, initEntityValue: lu, registerField: lu, useSubscribe: lu, setInitialValues: lu, setCallbacks: lu, getFields: lu, setValidateMessages: lu, setPreserve: lu, getInitialValue: lu };
        } });
        function PE(Y) {
          return Y == null ? [] : Array.isArray(Y) ? Y : [Y];
        }
        var zk = { exports: {} };
        (function(Y) {
          var ge = function(Q) {
            var ne = Object.prototype, re = ne.hasOwnProperty, fe, Ee = typeof Symbol == "function" ? Symbol : {}, Oe = Ee.iterator || "@@iterator", Be = Ee.asyncIterator || "@@asyncIterator", Ze = Ee.toStringTag || "@@toStringTag";
            function Je(xr, Xn, Kn) {
              return Object.defineProperty(xr, Xn, { value: Kn, enumerable: true, configurable: true, writable: true }), xr[Xn];
            }
            try {
              Je({}, "");
            } catch {
              Je = function(xr, Xn, Kn) {
                return xr[Xn] = Kn;
              };
            }
            function yt(xr, Xn, Kn, ba) {
              var la = Xn && Xn.prototype instanceof cr ? Xn : cr, Xi = Object.create(la.prototype), Ys = new Ya(ba || []);
              return Xi._invoke = Tr(xr, Kn, Ys), Xi;
            }
            Q.wrap = yt;
            function Gt(xr, Xn, Kn) {
              try {
                return { type: "normal", arg: xr.call(Xn, Kn) };
              } catch (ba) {
                return { type: "throw", arg: ba };
              }
            }
            var Xt = "suspendedStart", Zt = "suspendedYield", un = "executing", yn = "completed", _r = {};
            function cr() {
            }
            function fa() {
            }
            function We() {
            }
            var pn = {};
            Je(pn, Oe, function() {
              return this;
            });
            var zn = Object.getPrototypeOf, pr = zn && zn(zn(vr([])));
            pr && pr !== ne && re.call(pr, Oe) && (pn = pr);
            var fr = We.prototype = cr.prototype = Object.create(pn);
            fa.prototype = We, Je(fr, "constructor", We), Je(We, "constructor", fa), fa.displayName = Je(We, Ze, "GeneratorFunction");
            function Tn(xr) {
              ["next", "throw", "return"].forEach(function(Xn) {
                Je(xr, Xn, function(Kn) {
                  return this._invoke(Xn, Kn);
                });
              });
            }
            Q.isGeneratorFunction = function(xr) {
              var Xn = typeof xr == "function" && xr.constructor;
              return Xn ? Xn === fa || (Xn.displayName || Xn.name) === "GeneratorFunction" : false;
            }, Q.mark = function(xr) {
              return Object.setPrototypeOf ? Object.setPrototypeOf(xr, We) : (xr.__proto__ = We, Je(xr, Ze, "GeneratorFunction")), xr.prototype = Object.create(fr), xr;
            }, Q.awrap = function(xr) {
              return { __await: xr };
            };
            function Gn(xr, Xn) {
              function Kn(Xi, Ys, Ss, Uo) {
                var nu = Gt(xr[Xi], xr, Ys);
                if (nu.type === "throw")
                  Uo(nu.arg);
                else {
                  var Cs = nu.arg, yl = Cs.value;
                  return yl && typeof yl == "object" && re.call(yl, "__await") ? Xn.resolve(yl.__await).then(function(vc) {
                    Kn("next", vc, Ss, Uo);
                  }, function(vc) {
                    Kn("throw", vc, Ss, Uo);
                  }) : Xn.resolve(yl).then(function(vc) {
                    Cs.value = vc, Ss(Cs);
                  }, function(vc) {
                    return Kn("throw", vc, Ss, Uo);
                  });
                }
              }
              var ba;
              function la(Xi, Ys) {
                function Ss() {
                  return new Xn(function(Uo, nu) {
                    Kn(Xi, Ys, Uo, nu);
                  });
                }
                return ba = ba ? ba.then(Ss, Ss) : Ss();
              }
              this._invoke = la;
            }
            Tn(Gn.prototype), Je(Gn.prototype, Be, function() {
              return this;
            }), Q.AsyncIterator = Gn, Q.async = function(xr, Xn, Kn, ba, la) {
              la === void 0 && (la = Promise);
              var Xi = new Gn(yt(xr, Xn, Kn, ba), la);
              return Q.isGeneratorFunction(Xn) ? Xi : Xi.next().then(function(Ys) {
                return Ys.done ? Ys.value : Xi.next();
              });
            };
            function Tr(xr, Xn, Kn) {
              var ba = Xt;
              return function(la, Xi) {
                if (ba === un)
                  throw new Error("Generator is already running");
                if (ba === yn) {
                  if (la === "throw")
                    throw Xi;
                  return Pi();
                }
                for (Kn.method = la, Kn.arg = Xi; ; ) {
                  var Ys = Kn.delegate;
                  if (Ys) {
                    var Ss = ra(Ys, Kn);
                    if (Ss) {
                      if (Ss === _r)
                        continue;
                      return Ss;
                    }
                  }
                  if (Kn.method === "next")
                    Kn.sent = Kn._sent = Kn.arg;
                  else if (Kn.method === "throw") {
                    if (ba === Xt)
                      throw ba = yn, Kn.arg;
                    Kn.dispatchException(Kn.arg);
                  } else
                    Kn.method === "return" && Kn.abrupt("return", Kn.arg);
                  ba = un;
                  var Uo = Gt(xr, Xn, Kn);
                  if (Uo.type === "normal") {
                    if (ba = Kn.done ? yn : Zt, Uo.arg === _r)
                      continue;
                    return { value: Uo.arg, done: Kn.done };
                  } else
                    Uo.type === "throw" && (ba = yn, Kn.method = "throw", Kn.arg = Uo.arg);
                }
              };
            }
            function ra(xr, Xn) {
              var Kn = xr.iterator[Xn.method];
              if (Kn === fe) {
                if (Xn.delegate = null, Xn.method === "throw") {
                  if (xr.iterator.return && (Xn.method = "return", Xn.arg = fe, ra(xr, Xn), Xn.method === "throw"))
                    return _r;
                  Xn.method = "throw", Xn.arg = new TypeError("The iterator does not provide a 'throw' method");
                }
                return _r;
              }
              var ba = Gt(Kn, xr.iterator, Xn.arg);
              if (ba.type === "throw")
                return Xn.method = "throw", Xn.arg = ba.arg, Xn.delegate = null, _r;
              var la = ba.arg;
              if (!la)
                return Xn.method = "throw", Xn.arg = new TypeError("iterator result is not an object"), Xn.delegate = null, _r;
              if (la.done)
                Xn[xr.resultName] = la.value, Xn.next = xr.nextLoc, Xn.method !== "return" && (Xn.method = "next", Xn.arg = fe);
              else
                return la;
              return Xn.delegate = null, _r;
            }
            Tn(fr), Je(fr, Ze, "Generator"), Je(fr, Oe, function() {
              return this;
            }), Je(fr, "toString", function() {
              return "[object Generator]";
            });
            function wn(xr) {
              var Xn = { tryLoc: xr[0] };
              1 in xr && (Xn.catchLoc = xr[1]), 2 in xr && (Xn.finallyLoc = xr[2], Xn.afterLoc = xr[3]), this.tryEntries.push(Xn);
            }
            function Ka(xr) {
              var Xn = xr.completion || {};
              Xn.type = "normal", delete Xn.arg, xr.completion = Xn;
            }
            function Ya(xr) {
              this.tryEntries = [{ tryLoc: "root" }], xr.forEach(wn, this), this.reset(true);
            }
            Q.keys = function(xr) {
              var Xn = [];
              for (var Kn in xr)
                Xn.push(Kn);
              return Xn.reverse(), function ba() {
                for (; Xn.length; ) {
                  var la = Xn.pop();
                  if (la in xr)
                    return ba.value = la, ba.done = false, ba;
                }
                return ba.done = true, ba;
              };
            };
            function vr(xr) {
              if (xr) {
                var Xn = xr[Oe];
                if (Xn)
                  return Xn.call(xr);
                if (typeof xr.next == "function")
                  return xr;
                if (!isNaN(xr.length)) {
                  var Kn = -1, ba = function la() {
                    for (; ++Kn < xr.length; )
                      if (re.call(xr, Kn))
                        return la.value = xr[Kn], la.done = false, la;
                    return la.value = fe, la.done = true, la;
                  };
                  return ba.next = ba;
                }
              }
              return { next: Pi };
            }
            Q.values = vr;
            function Pi() {
              return { value: fe, done: true };
            }
            return Ya.prototype = { constructor: Ya, reset: function(xr) {
              if (this.prev = 0, this.next = 0, this.sent = this._sent = fe, this.done = false, this.delegate = null, this.method = "next", this.arg = fe, this.tryEntries.forEach(Ka), !xr)
                for (var Xn in this)
                  Xn.charAt(0) === "t" && re.call(this, Xn) && !isNaN(+Xn.slice(1)) && (this[Xn] = fe);
            }, stop: function() {
              this.done = true;
              var xr = this.tryEntries[0], Xn = xr.completion;
              if (Xn.type === "throw")
                throw Xn.arg;
              return this.rval;
            }, dispatchException: function(xr) {
              if (this.done)
                throw xr;
              var Xn = this;
              function Kn(Uo, nu) {
                return Xi.type = "throw", Xi.arg = xr, Xn.next = Uo, nu && (Xn.method = "next", Xn.arg = fe), !!nu;
              }
              for (var ba = this.tryEntries.length - 1; ba >= 0; --ba) {
                var la = this.tryEntries[ba], Xi = la.completion;
                if (la.tryLoc === "root")
                  return Kn("end");
                if (la.tryLoc <= this.prev) {
                  var Ys = re.call(la, "catchLoc"), Ss = re.call(la, "finallyLoc");
                  if (Ys && Ss) {
                    if (this.prev < la.catchLoc)
                      return Kn(la.catchLoc, true);
                    if (this.prev < la.finallyLoc)
                      return Kn(la.finallyLoc);
                  } else if (Ys) {
                    if (this.prev < la.catchLoc)
                      return Kn(la.catchLoc, true);
                  } else if (Ss) {
                    if (this.prev < la.finallyLoc)
                      return Kn(la.finallyLoc);
                  } else
                    throw new Error("try statement without catch or finally");
                }
              }
            }, abrupt: function(xr, Xn) {
              for (var Kn = this.tryEntries.length - 1; Kn >= 0; --Kn) {
                var ba = this.tryEntries[Kn];
                if (ba.tryLoc <= this.prev && re.call(ba, "finallyLoc") && this.prev < ba.finallyLoc) {
                  var la = ba;
                  break;
                }
              }
              la && (xr === "break" || xr === "continue") && la.tryLoc <= Xn && Xn <= la.finallyLoc && (la = null);
              var Xi = la ? la.completion : {};
              return Xi.type = xr, Xi.arg = Xn, la ? (this.method = "next", this.next = la.finallyLoc, _r) : this.complete(Xi);
            }, complete: function(xr, Xn) {
              if (xr.type === "throw")
                throw xr.arg;
              return xr.type === "break" || xr.type === "continue" ? this.next = xr.arg : xr.type === "return" ? (this.rval = this.arg = xr.arg, this.method = "return", this.next = "end") : xr.type === "normal" && Xn && (this.next = Xn), _r;
            }, finish: function(xr) {
              for (var Xn = this.tryEntries.length - 1; Xn >= 0; --Xn) {
                var Kn = this.tryEntries[Xn];
                if (Kn.finallyLoc === xr)
                  return this.complete(Kn.completion, Kn.afterLoc), Ka(Kn), _r;
              }
            }, catch: function(xr) {
              for (var Xn = this.tryEntries.length - 1; Xn >= 0; --Xn) {
                var Kn = this.tryEntries[Xn];
                if (Kn.tryLoc === xr) {
                  var ba = Kn.completion;
                  if (ba.type === "throw") {
                    var la = ba.arg;
                    Ka(Kn);
                  }
                  return la;
                }
              }
              throw new Error("illegal catch attempt");
            }, delegateYield: function(xr, Xn, Kn) {
              return this.delegate = { iterator: vr(xr), resultName: Xn, nextLoc: Kn }, this.method === "next" && (this.arg = fe), _r;
            } }, Q;
          }(Y.exports);
          try {
            regeneratorRuntime = ge;
          } catch {
            typeof globalThis == "object" ? globalThis.regeneratorRuntime = ge : Function("r", "regeneratorRuntime = r")(ge);
          }
        })(zk);
        var Ad = zk.exports;
        function Co(Y, ge, Q, ne, re, fe, Ee) {
          try {
            var Oe = Y[fe](Ee), Be = Oe.value;
          } catch (Ze) {
            Q(Ze);
            return;
          }
          Oe.done ? ge(Be) : Promise.resolve(Be).then(ne, re);
        }
        function O0(Y) {
          return function() {
            var ge = this, Q = arguments;
            return new Promise(function(ne, re) {
              var fe = Y.apply(ge, Q);
              function Ee(Be) {
                Co(fe, ne, re, Ee, Oe, "next", Be);
              }
              function Oe(Be) {
                Co(fe, ne, re, Ee, Oe, "throw", Be);
              }
              Ee(void 0);
            });
          };
        }
        function an() {
          return an = Object.assign || function(Y) {
            for (var ge = 1; ge < arguments.length; ge++) {
              var Q = arguments[ge];
              for (var ne in Q)
                Object.prototype.hasOwnProperty.call(Q, ne) && (Y[ne] = Q[ne]);
            }
            return Y;
          }, an.apply(this, arguments);
        }
        function er(Y, ge) {
          Y.prototype = Object.create(ge.prototype), Y.prototype.constructor = Y, Va(Y, ge);
        }
        function tr(Y) {
          return tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(ge) {
            return ge.__proto__ || Object.getPrototypeOf(ge);
          }, tr(Y);
        }
        function Va(Y, ge) {
          return Va = Object.setPrototypeOf || function(Q, ne) {
            return Q.__proto__ = ne, Q;
          }, Va(Y, ge);
        }
        function Mo() {
          if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), true;
          } catch {
            return false;
          }
        }
        function al(Y, ge, Q) {
          return Mo() ? al = Reflect.construct : al = function(ne, re, fe) {
            var Ee = [null];
            Ee.push.apply(Ee, re);
            var Oe = Function.bind.apply(ne, Ee), Be = new Oe();
            return fe && Va(Be, fe.prototype), Be;
          }, al.apply(null, arguments);
        }
        function of(Y) {
          return Function.toString.call(Y).indexOf("[native code]") !== -1;
        }
        function Fl(Y) {
          var ge = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
          return Fl = function(Q) {
            if (Q === null || !of(Q))
              return Q;
            if (typeof Q != "function")
              throw new TypeError("Super expression must either be null or a function");
            if (typeof ge != "undefined") {
              if (ge.has(Q))
                return ge.get(Q);
              ge.set(Q, ne);
            }
            function ne() {
              return al(Q, arguments, tr(this).constructor);
            }
            return ne.prototype = Object.create(Q.prototype, { constructor: { value: ne, enumerable: false, writable: true, configurable: true } }), Va(ne, Q);
          }, Fl(Y);
        }
        var LE = /%[sdj%]/g, OE = function() {
        };
        typeof process != "undefined" && process.env;
        function Ed(Y) {
          if (!Y || !Y.length)
            return null;
          var ge = {};
          return Y.forEach(function(Q) {
            var ne = Q.field;
            ge[ne] = ge[ne] || [], ge[ne].push(Q);
          }), ge;
        }
        function Gu(Y) {
          for (var ge = arguments.length, Q = new Array(ge > 1 ? ge - 1 : 0), ne = 1; ne < ge; ne++)
            Q[ne - 1] = arguments[ne];
          var re = 0, fe = Q.length;
          if (typeof Y == "function")
            return Y.apply(null, Q);
          if (typeof Y == "string") {
            var Ee = Y.replace(LE, function(Oe) {
              if (Oe === "%%")
                return "%";
              if (re >= fe)
                return Oe;
              switch (Oe) {
                case "%s":
                  return String(Q[re++]);
                case "%d":
                  return Number(Q[re++]);
                case "%j":
                  try {
                    return JSON.stringify(Q[re++]);
                  } catch {
                    return "[Circular]";
                  }
                  break;
                default:
                  return Oe;
              }
            });
            return Ee;
          }
          return Y;
        }
        function Bk(Y) {
          return Y === "string" || Y === "url" || Y === "hex" || Y === "email" || Y === "date" || Y === "pattern";
        }
        function tu(Y, ge) {
          return !!(Y == null || ge === "array" && Array.isArray(Y) && !Y.length || Bk(ge) && typeof Y == "string" && !Y);
        }
        function uu(Y, ge, Q) {
          var ne = [], re = 0, fe = Y.length;
          function Ee(Oe) {
            ne.push.apply(ne, Oe || []), re++, re === fe && Q(ne);
          }
          Y.forEach(function(Oe) {
            ge(Oe, Ee);
          });
        }
        function cu(Y, ge, Q) {
          var ne = 0, re = Y.length;
          function fe(Ee) {
            if (Ee && Ee.length) {
              Q(Ee);
              return;
            }
            var Oe = ne;
            ne = ne + 1, Oe < re ? ge(Y[Oe], fe) : Q([]);
          }
          fe([]);
        }
        function Al(Y) {
          var ge = [];
          return Object.keys(Y).forEach(function(Q) {
            ge.push.apply(ge, Y[Q] || []);
          }), ge;
        }
        var jk = function(Y) {
          er(ge, Y);
          function ge(Q, ne) {
            var re;
            return re = Y.call(this, "Async Validation Error") || this, re.errors = Q, re.fields = ne, re;
          }
          return ge;
        }(Fl(Error));
        function Gk(Y, ge, Q, ne, re) {
          if (ge.first) {
            var fe = new Promise(function(Gt, Xt) {
              var Zt = function(yn) {
                return ne(yn), yn.length ? Xt(new jk(yn, Ed(yn))) : Gt(re);
              }, un = Al(Y);
              cu(un, Q, Zt);
            });
            return fe.catch(function(Gt) {
              return Gt;
            }), fe;
          }
          var Ee = ge.firstFields === true ? Object.keys(Y) : ge.firstFields || [], Oe = Object.keys(Y), Be = Oe.length, Ze = 0, Je = [], yt = new Promise(function(Gt, Xt) {
            var Zt = function(un) {
              if (Je.push.apply(Je, un), Ze++, Ze === Be)
                return ne(Je), Je.length ? Xt(new jk(Je, Ed(Je))) : Gt(re);
            };
            Oe.length || (ne(Je), Gt(re)), Oe.forEach(function(un) {
              var yn = Y[un];
              Ee.indexOf(un) !== -1 ? cu(yn, Q, Zt) : uu(yn, Q, Zt);
            });
          });
          return yt.catch(function(Gt) {
            return Gt;
          }), yt;
        }
        function $S(Y) {
          return !!(Y && Y.message !== void 0);
        }
        function j6(Y, ge) {
          for (var Q = Y, ne = 0; ne < ge.length; ne++) {
            if (Q == null)
              return Q;
            Q = Q[ge[ne]];
          }
          return Q;
        }
        function Wk(Y, ge) {
          return function(Q) {
            var ne;
            return Y.fullFields ? ne = j6(ge, Y.fullFields) : ne = ge[Q.field || Y.fullField], $S(Q) ? (Q.field = Q.field || Y.fullField, Q.fieldValue = ne, Q) : { message: typeof Q == "function" ? Q() : Q, fieldValue: ne, field: Q.field || Y.fullField };
          };
        }
        function Hk(Y, ge) {
          if (ge) {
            for (var Q in ge)
              if (ge.hasOwnProperty(Q)) {
                var ne = ge[Q];
                typeof ne == "object" && typeof Y[Q] == "object" ? Y[Q] = an({}, Y[Q], ne) : Y[Q] = ne;
              }
          }
          return Y;
        }
        var l_ = function(Y, ge, Q, ne, re, fe) {
          Y.required && (!Q.hasOwnProperty(Y.field) || tu(ge, fe || Y.type)) && ne.push(Gu(re.messages.required, Y.fullField));
        }, nv = function(Y, ge, Q, ne, re) {
          (/^\s+$/.test(ge) || ge === "") && ne.push(Gu(re.messages.whitespace, Y.fullField));
        }, sy = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, u_ = { integer: function(Y) {
          return u_.number(Y) && parseInt(Y, 10) === Y;
        }, float: function(Y) {
          return u_.number(Y) && !u_.integer(Y);
        }, array: function(Y) {
          return Array.isArray(Y);
        }, regexp: function(Y) {
          if (Y instanceof RegExp)
            return true;
          try {
            return !!new RegExp(Y);
          } catch {
            return false;
          }
        }, date: function(Y) {
          return typeof Y.getTime == "function" && typeof Y.getMonth == "function" && typeof Y.getYear == "function" && !isNaN(Y.getTime());
        }, number: function(Y) {
          return isNaN(Y) ? false : typeof Y == "number";
        }, object: function(Y) {
          return typeof Y == "object" && !u_.array(Y);
        }, method: function(Y) {
          return typeof Y == "function";
        }, email: function(Y) {
          return typeof Y == "string" && Y.length <= 320 && !!Y.match(sy.email);
        }, url: function(Y) {
          return typeof Y == "string" && Y.length <= 2048 && !!Y.match(sy.url);
        }, hex: function(Y) {
          return typeof Y == "string" && !!Y.match(sy.hex);
        } }, Ew = function(Y, ge, Q, ne, re) {
          if (Y.required && ge === void 0) {
            l_(Y, ge, Q, ne, re);
            return;
          }
          var fe = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], Ee = Y.type;
          fe.indexOf(Ee) > -1 ? u_[Ee](ge) || ne.push(Gu(re.messages.types[Ee], Y.fullField, Y.type)) : Ee && typeof ge !== Y.type && ne.push(Gu(re.messages.types[Ee], Y.fullField, Y.type));
        }, Iw = function(Y, ge, Q, ne, re) {
          var fe = typeof Y.len == "number", Ee = typeof Y.min == "number", Oe = typeof Y.max == "number", Be = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, Ze = ge, Je = null, yt = typeof ge == "number", Gt = typeof ge == "string", Xt = Array.isArray(ge);
          if (yt ? Je = "number" : Gt ? Je = "string" : Xt && (Je = "array"), !Je)
            return false;
          Xt && (Ze = ge.length), Gt && (Ze = ge.replace(Be, "_").length), fe ? Ze !== Y.len && ne.push(Gu(re.messages[Je].len, Y.fullField, Y.len)) : Ee && !Oe && Ze < Y.min ? ne.push(Gu(re.messages[Je].min, Y.fullField, Y.min)) : Oe && !Ee && Ze > Y.max ? ne.push(Gu(re.messages[Je].max, Y.fullField, Y.max)) : Ee && Oe && (Ze < Y.min || Ze > Y.max) && ne.push(Gu(re.messages[Je].range, Y.fullField, Y.min, Y.max));
        }, sf = "enum", R0 = function(Y, ge, Q, ne, re) {
          Y[sf] = Array.isArray(Y[sf]) ? Y[sf] : [], Y[sf].indexOf(ge) === -1 && ne.push(Gu(re.messages[sf], Y.fullField, Y[sf].join(", ")));
        }, $k = function(Y, ge, Q, ne, re) {
          if (Y.pattern) {
            if (Y.pattern instanceof RegExp)
              Y.pattern.lastIndex = 0, Y.pattern.test(ge) || ne.push(Gu(re.messages.pattern.mismatch, Y.fullField, ge, Y.pattern));
            else if (typeof Y.pattern == "string") {
              var fe = new RegExp(Y.pattern);
              fe.test(ge) || ne.push(Gu(re.messages.pattern.mismatch, Y.fullField, ge, Y.pattern));
            }
          }
        }, es = { required: l_, whitespace: nv, type: Ew, range: Iw, enum: R0, pattern: $k }, D1 = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge, "string") && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re, "string"), tu(ge, "string") || (es.type(Y, ge, ne, fe, re), es.range(Y, ge, ne, fe, re), es.pattern(Y, ge, ne, fe, re), Y.whitespace === true && es.whitespace(Y, ge, ne, fe, re));
          }
          Q(fe);
        }, US = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && es.type(Y, ge, ne, fe, re);
          }
          Q(fe);
        }, G6 = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (ge === "" && (ge = void 0), tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && (es.type(Y, ge, ne, fe, re), es.range(Y, ge, ne, fe, re));
          }
          Q(fe);
        }, Uk = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && es.type(Y, ge, ne, fe, re);
          }
          Q(fe);
        }, F0 = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), tu(ge) || es.type(Y, ge, ne, fe, re);
          }
          Q(fe);
        }, Ao = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && (es.type(Y, ge, ne, fe, re), es.range(Y, ge, ne, fe, re));
          }
          Q(fe);
        }, Tw = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && (es.type(Y, ge, ne, fe, re), es.range(Y, ge, ne, fe, re));
          }
          Q(fe);
        }, Id = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (ge == null && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re, "array"), ge != null && (es.type(Y, ge, ne, fe, re), es.range(Y, ge, ne, fe, re));
          }
          Q(fe);
        }, qk = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && es.type(Y, ge, ne, fe, re);
          }
          Q(fe);
        }, Yk = "enum", El = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), ge !== void 0 && es[Yk](Y, ge, ne, fe, re);
          }
          Q(fe);
        }, W6 = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge, "string") && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re), tu(ge, "string") || es.pattern(Y, ge, ne, fe, re);
          }
          Q(fe);
        }, Vc = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge, "date") && !Y.required)
              return Q();
            if (es.required(Y, ge, ne, fe, re), !tu(ge, "date")) {
              var Oe;
              ge instanceof Date ? Oe = ge : Oe = new Date(ge), es.type(Y, Oe, ne, fe, re), Oe && es.range(Y, Oe.getTime(), ne, fe, re);
            }
          }
          Q(fe);
        }, lf = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Array.isArray(ge) ? "array" : typeof ge;
          es.required(Y, ge, ne, fe, re, Ee), Q(fe);
        }, RE = function(Y, ge, Q, ne, re) {
          var fe = Y.type, Ee = [], Oe = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Oe) {
            if (tu(ge, fe) && !Y.required)
              return Q();
            es.required(Y, ge, ne, Ee, re, fe), tu(ge, fe) || es.type(Y, ge, ne, Ee, re);
          }
          Q(Ee);
        }, H6 = function(Y, ge, Q, ne, re) {
          var fe = [], Ee = Y.required || !Y.required && ne.hasOwnProperty(Y.field);
          if (Ee) {
            if (tu(ge) && !Y.required)
              return Q();
            es.required(Y, ge, ne, fe, re);
          }
          Q(fe);
        }, c_ = { string: D1, method: US, number: G6, boolean: Uk, regexp: F0, integer: Ao, float: Tw, array: Id, object: qk, enum: El, pattern: W6, date: Vc, url: RE, hex: RE, email: RE, required: lf, any: H6 };
        function FE() {
          return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
            var Y = JSON.parse(JSON.stringify(this));
            return Y.clone = this.clone, Y;
          } };
        }
        var Dw = FE(), N0 = function() {
          function Y(Q) {
            this.rules = null, this._messages = Dw, this.define(Q);
          }
          var ge = Y.prototype;
          return ge.define = function(Q) {
            var ne = this;
            if (!Q)
              throw new Error("Cannot configure a schema with no rules");
            if (typeof Q != "object" || Array.isArray(Q))
              throw new Error("Rules must be an object");
            this.rules = {}, Object.keys(Q).forEach(function(re) {
              var fe = Q[re];
              ne.rules[re] = Array.isArray(fe) ? fe : [fe];
            });
          }, ge.messages = function(Q) {
            return Q && (this._messages = Hk(FE(), Q)), this._messages;
          }, ge.validate = function(Q, ne, re) {
            var fe = this;
            ne === void 0 && (ne = {}), re === void 0 && (re = function() {
            });
            var Ee = Q, Oe = ne, Be = re;
            if (typeof Oe == "function" && (Be = Oe, Oe = {}), !this.rules || Object.keys(this.rules).length === 0)
              return Be && Be(null, Ee), Promise.resolve(Ee);
            function Ze(Zt) {
              var un = [], yn = {};
              function _r(fa) {
                if (Array.isArray(fa)) {
                  var We;
                  un = (We = un).concat.apply(We, fa);
                } else
                  un.push(fa);
              }
              for (var cr = 0; cr < Zt.length; cr++)
                _r(Zt[cr]);
              un.length ? (yn = Ed(un), Be(un, yn)) : Be(null, Ee);
            }
            if (Oe.messages) {
              var Je = this.messages();
              Je === Dw && (Je = FE()), Hk(Je, Oe.messages), Oe.messages = Je;
            } else
              Oe.messages = this.messages();
            var yt = {}, Gt = Oe.keys || Object.keys(this.rules);
            Gt.forEach(function(Zt) {
              var un = fe.rules[Zt], yn = Ee[Zt];
              un.forEach(function(_r) {
                var cr = _r;
                typeof cr.transform == "function" && (Ee === Q && (Ee = an({}, Ee)), yn = Ee[Zt] = cr.transform(yn)), typeof cr == "function" ? cr = { validator: cr } : cr = an({}, cr), cr.validator = fe.getValidationMethod(cr), cr.validator && (cr.field = Zt, cr.fullField = cr.fullField || Zt, cr.type = fe.getType(cr), yt[Zt] = yt[Zt] || [], yt[Zt].push({ rule: cr, value: yn, source: Ee, field: Zt }));
              });
            });
            var Xt = {};
            return Gk(yt, Oe, function(Zt, un) {
              var yn = Zt.rule, _r = (yn.type === "object" || yn.type === "array") && (typeof yn.fields == "object" || typeof yn.defaultField == "object");
              _r = _r && (yn.required || !yn.required && Zt.value), yn.field = Zt.field;
              function cr(pn, zn) {
                return an({}, zn, { fullField: yn.fullField + "." + pn, fullFields: yn.fullFields ? [].concat(yn.fullFields, [pn]) : [pn] });
              }
              function fa(pn) {
                pn === void 0 && (pn = []);
                var zn = Array.isArray(pn) ? pn : [pn];
                !Oe.suppressWarning && zn.length && Y.warning("async-validator:", zn), zn.length && yn.message !== void 0 && (zn = [].concat(yn.message));
                var pr = zn.map(Wk(yn, Ee));
                if (Oe.first && pr.length)
                  return Xt[yn.field] = 1, un(pr);
                if (!_r)
                  un(pr);
                else {
                  if (yn.required && !Zt.value)
                    return yn.message !== void 0 ? pr = [].concat(yn.message).map(Wk(yn, Ee)) : Oe.error && (pr = [Oe.error(yn, Gu(Oe.messages.required, yn.field))]), un(pr);
                  var fr = {};
                  yn.defaultField && Object.keys(Zt.value).map(function(Tr) {
                    fr[Tr] = yn.defaultField;
                  }), fr = an({}, fr, Zt.rule.fields);
                  var Tn = {};
                  Object.keys(fr).forEach(function(Tr) {
                    var ra = fr[Tr], wn = Array.isArray(ra) ? ra : [ra];
                    Tn[Tr] = wn.map(cr.bind(null, Tr));
                  });
                  var Gn = new Y(Tn);
                  Gn.messages(Oe.messages), Zt.rule.options && (Zt.rule.options.messages = Oe.messages, Zt.rule.options.error = Oe.error), Gn.validate(Zt.value, Zt.rule.options || Oe, function(Tr) {
                    var ra = [];
                    pr && pr.length && ra.push.apply(ra, pr), Tr && Tr.length && ra.push.apply(ra, Tr), un(ra.length ? ra : null);
                  });
                }
              }
              var We;
              yn.asyncValidator ? We = yn.asyncValidator(yn, Zt.value, fa, Zt.source, Oe) : yn.validator && (We = yn.validator(yn, Zt.value, fa, Zt.source, Oe), We === true ? fa() : We === false ? fa(typeof yn.message == "function" ? yn.message(yn.fullField || yn.field) : yn.message || (yn.fullField || yn.field) + " fails") : We instanceof Array ? fa(We) : We instanceof Error && fa(We.message)), We && We.then && We.then(function() {
                return fa();
              }, function(pn) {
                return fa(pn);
              });
            }, function(Zt) {
              Ze(Zt);
            }, Ee);
          }, ge.getType = function(Q) {
            if (Q.type === void 0 && Q.pattern instanceof RegExp && (Q.type = "pattern"), typeof Q.validator != "function" && Q.type && !c_.hasOwnProperty(Q.type))
              throw new Error(Gu("Unknown rule type %s", Q.type));
            return Q.type || "string";
          }, ge.getValidationMethod = function(Q) {
            if (typeof Q.validator == "function")
              return Q.validator;
            var ne = Object.keys(Q), re = ne.indexOf("message");
            return re !== -1 && ne.splice(re, 1), ne.length === 1 && ne[0] === "required" ? c_.required : c_[this.getType(Q)] || void 0;
          }, Y;
        }();
        N0.register = function(Y, ge) {
          if (typeof ge != "function")
            throw new Error("Cannot register a validator by type, validator is not a function");
          c_[Y] = ge;
        }, N0.warning = OE, N0.messages = Dw, N0.validators = c_;
        var jh = "'${name}' is not a valid ${type}", k1 = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: jh, method: jh, array: jh, object: jh, number: jh, date: jh, boolean: jh, integer: jh, float: jh, regexp: jh, email: jh, url: jh, hex: jh }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
        function f_(Y, ge) {
          for (var Q = Y, ne = 0; ne < ge.length; ne += 1) {
            if (Q == null)
              return;
            Q = Q[ge[ne]];
          }
          return Q;
        }
        function kw(Y) {
          return Ct(Y) || Vk(Y) || Cr(Y) || or();
        }
        function Pw(Y, ge, Q, ne) {
          if (!ge.length)
            return Q;
          var re = kw(ge), fe = re[0], Ee = re.slice(1), Oe;
          return !Y && typeof fe == "number" ? Oe = [] : Array.isArray(Y) ? Oe = Qo(Y) : Oe = Xe({}, Y), ne && Q === void 0 && Ee.length === 1 ? delete Oe[fe][Ee[0]] : Oe[fe] = Pw(Oe[fe], Ee, Q, ne), Oe;
        }
        function h_(Y, ge, Q) {
          var ne = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
          return ge.length && ne && Q === void 0 && !f_(Y, ge.slice(0, -1)) ? Y : Pw(Y, ge, Q, ne);
        }
        function zc(Y) {
          return PE(Y);
        }
        function ly(Y, ge) {
          var Q = f_(Y, ge);
          return Q;
        }
        function P1(Y, ge, Q) {
          var ne = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, re = h_(Y, ge, Q, ne);
          return re;
        }
        function qS(Y, ge) {
          var Q = {};
          return ge.forEach(function(ne) {
            var re = ly(Y, ne);
            Q = P1(Q, ne, re);
          }), Q;
        }
        function Lw(Y, ge) {
          return Y && Y.some(function(Q) {
            return nt(Q, ge);
          });
        }
        function Ow(Y) {
          return _o(Y) === "object" && Y !== null && Object.getPrototypeOf(Y) === Object.prototype;
        }
        function d_(Y, ge) {
          var Q = Array.isArray(Y) ? Qo(Y) : Xe({}, Y);
          return ge && Object.keys(ge).forEach(function(ne) {
            var re = Q[ne], fe = ge[ne], Ee = Ow(re) && Ow(fe);
            Q[ne] = Ee ? d_(re, fe || {}) : fe;
          }), Q;
        }
        function pc(Y) {
          for (var ge = arguments.length, Q = new Array(ge > 1 ? ge - 1 : 0), ne = 1; ne < ge; ne++)
            Q[ne - 1] = arguments[ne];
          return Q.reduce(function(re, fe) {
            return d_(re, fe);
          }, Y);
        }
        function nt(Y, ge) {
          return !Y || !ge || Y.length !== ge.length ? false : Y.every(function(Q, ne) {
            return ge[ne] === Q;
          });
        }
        function p_(Y, ge) {
          if (Y === ge)
            return true;
          if (!Y && ge || Y && !ge || !Y || !ge || _o(Y) !== "object" || _o(ge) !== "object")
            return false;
          var Q = Object.keys(Y), ne = Object.keys(ge), re = new Set([].concat(Qo(Q), Qo(ne)));
          return Qo(re).every(function(fe) {
            var Ee = Y[fe], Oe = ge[fe];
            return typeof Ee == "function" && typeof Oe == "function" ? true : Ee === Oe;
          });
        }
        function YS(Y) {
          var ge = arguments.length <= 1 ? void 0 : arguments[1];
          return ge && ge.target && _o(ge.target) === "object" && Y in ge.target ? ge.target[Y] : ge;
        }
        function pp(Y, ge, Q) {
          var ne = Y.length;
          if (ge < 0 || ge >= ne || Q < 0 || Q >= ne)
            return Y;
          var re = Y[ge], fe = ge - Q;
          return fe > 0 ? [].concat(Qo(Y.slice(0, Q)), [re], Qo(Y.slice(Q, ge)), Qo(Y.slice(ge + 1, ne))) : fe < 0 ? [].concat(Qo(Y.slice(0, ge)), Qo(Y.slice(ge + 1, Q + 1)), [re], Qo(Y.slice(Q + 1, ne))) : Y;
        }
        var ws = N0;
        function $6(Y, ge) {
          return Y.replace(/\$\{\w+\}/g, function(Q) {
            var ne = Q.slice(2, -1);
            return ge[ne];
          });
        }
        function NE(Y, ge, Q, ne, re) {
          return VE.apply(this, arguments);
        }
        function VE() {
          return VE = O0(Ad.mark(function Y(ge, Q, ne, re, fe) {
            var Ee, Oe, Be, Ze, Je, yt, Gt, Xt;
            return Ad.wrap(function(Zt) {
              for (; ; )
                switch (Zt.prev = Zt.next) {
                  case 0:
                    return Ee = Xe({}, ne), delete Ee.ruleIndex, Oe = null, Ee && Ee.type === "array" && Ee.defaultField && (Oe = Ee.defaultField, delete Ee.defaultField), Be = new ws(St({}, ge, [Ee])), Ze = pc({}, k1, re.validateMessages), Be.messages(Ze), Je = [], Zt.prev = 8, Zt.next = 11, Promise.resolve(Be.validate(St({}, ge, Q), Xe({}, re)));
                  case 11:
                    Zt.next = 16;
                    break;
                  case 13:
                    Zt.prev = 13, Zt.t0 = Zt.catch(8), Zt.t0.errors ? Je = Zt.t0.errors.map(function(un, yn) {
                      var _r = un.message;
                      return De.isValidElement(_r) ? De.cloneElement(_r, { key: "error_".concat(yn) }) : _r;
                    }) : (console.error(Zt.t0), Je = [Ze.default]);
                  case 16:
                    if (!(!Je.length && Oe)) {
                      Zt.next = 21;
                      break;
                    }
                    return Zt.next = 19, Promise.all(Q.map(function(un, yn) {
                      return NE("".concat(ge, ".").concat(yn), un, Oe, re, fe);
                    }));
                  case 19:
                    return yt = Zt.sent, Zt.abrupt("return", yt.reduce(function(un, yn) {
                      return [].concat(Qo(un), Qo(yn));
                    }, []));
                  case 21:
                    return Gt = Xe(Xe({}, ne), {}, { name: ge, enum: (ne.enum || []).join(", ") }, fe), Xt = Je.map(function(un) {
                      return typeof un == "string" ? $6(un, Gt) : un;
                    }), Zt.abrupt("return", Xt);
                  case 24:
                  case "end":
                    return Zt.stop();
                }
            }, Y, null, [[8, 13]]);
          })), VE.apply(this, arguments);
        }
        function uy(Y, ge, Q, ne, re, fe) {
          var Ee = Y.join("."), Oe = Q.map(function(Je, yt) {
            var Gt = Je.validator, Xt = Xe(Xe({}, Je), {}, { ruleIndex: yt });
            return Gt && (Xt.validator = function(Zt, un, yn) {
              var _r = false, cr = function() {
                for (var We = arguments.length, pn = new Array(We), zn = 0; zn < We; zn++)
                  pn[zn] = arguments[zn];
                Promise.resolve().then(function() {
                  Qp(!_r, "Your validator function has already return a promise. `callback` will be ignored."), _r || yn.apply(void 0, pn);
                });
              }, fa = Gt(Zt, un, cr);
              _r = fa && typeof fa.then == "function" && typeof fa.catch == "function", Qp(_r, "`callback` is deprecated. Please return a promise instead."), _r && fa.then(function() {
                yn();
              }).catch(function(We) {
                yn(We || " ");
              });
            }), Xt;
          }).sort(function(Je, yt) {
            var Gt = Je.warningOnly, Xt = Je.ruleIndex, Zt = yt.warningOnly, un = yt.ruleIndex;
            return !!Gt == !!Zt ? Xt - un : Gt ? 1 : -1;
          }), Be;
          if (re === true)
            Be = new Promise(function() {
              var Je = O0(Ad.mark(function yt(Gt, Xt) {
                var Zt, un, yn;
                return Ad.wrap(function(_r) {
                  for (; ; )
                    switch (_r.prev = _r.next) {
                      case 0:
                        Zt = 0;
                      case 1:
                        if (!(Zt < Oe.length)) {
                          _r.next = 12;
                          break;
                        }
                        return un = Oe[Zt], _r.next = 5, NE(Ee, ge, un, ne, fe);
                      case 5:
                        if (yn = _r.sent, !yn.length) {
                          _r.next = 9;
                          break;
                        }
                        return Xt([{ errors: yn, rule: un }]), _r.abrupt("return");
                      case 9:
                        Zt += 1, _r.next = 1;
                        break;
                      case 12:
                        Gt([]);
                      case 13:
                      case "end":
                        return _r.stop();
                    }
                }, yt);
              }));
              return function(yt, Gt) {
                return Je.apply(this, arguments);
              };
            }());
          else {
            var Ze = Oe.map(function(Je) {
              return NE(Ee, ge, Je, ne, fe).then(function(yt) {
                return { errors: yt, rule: Je };
              });
            });
            Be = (re ? q6(Ze) : U6(Ze)).then(function(Je) {
              return Promise.reject(Je);
            });
          }
          return Be.catch(function(Je) {
            return Je;
          }), Be;
        }
        function U6(Y) {
          return zE.apply(this, arguments);
        }
        function zE() {
          return zE = O0(Ad.mark(function Y(ge) {
            return Ad.wrap(function(Q) {
              for (; ; )
                switch (Q.prev = Q.next) {
                  case 0:
                    return Q.abrupt("return", Promise.all(ge).then(function(ne) {
                      var re, fe = (re = []).concat.apply(re, Qo(ne));
                      return fe;
                    }));
                  case 1:
                  case "end":
                    return Q.stop();
                }
            }, Y);
          })), zE.apply(this, arguments);
        }
        function q6(Y) {
          return ZS.apply(this, arguments);
        }
        function ZS() {
          return ZS = O0(Ad.mark(function Y(ge) {
            var Q;
            return Ad.wrap(function(ne) {
              for (; ; )
                switch (ne.prev = ne.next) {
                  case 0:
                    return Q = 0, ne.abrupt("return", new Promise(function(re) {
                      ge.forEach(function(fe) {
                        fe.then(function(Ee) {
                          Ee.errors.length && re([Ee]), Q += 1, Q === ge.length && re([]);
                        });
                      });
                    }));
                  case 2:
                  case "end":
                    return ne.stop();
                }
            }, Y);
          })), ZS.apply(this, arguments);
        }
        var Zk = ["name"], Bc = [];
        function Xk(Y, ge, Q, ne, re, fe) {
          return typeof Y == "function" ? Y(ge, Q, "source" in fe ? { source: fe.source } : {}) : ne !== re;
        }
        var BE = function(Y) {
          EE(Q, Y);
          var ge = ny(Q);
          function Q(ne) {
            var re;
            if (tv(this, Q), re = ge.call(this, ne), re.state = { resetCount: 0 }, re.cancelRegisterFunc = null, re.mounted = false, re.touched = false, re.dirty = false, re.validatePromise = null, re.prevValidating = void 0, re.errors = Bc, re.warnings = Bc, re.cancelRegister = function() {
              var Be = re.props, Ze = Be.preserve, Je = Be.isListField, yt = Be.name;
              re.cancelRegisterFunc && re.cancelRegisterFunc(Je, Ze, zc(yt)), re.cancelRegisterFunc = null;
            }, re.getNamePath = function() {
              var Be = re.props, Ze = Be.name, Je = Be.fieldContext, yt = Je.prefixName, Gt = yt === void 0 ? [] : yt;
              return Ze !== void 0 ? [].concat(Qo(Gt), Qo(Ze)) : [];
            }, re.getRules = function() {
              var Be = re.props, Ze = Be.rules, Je = Ze === void 0 ? [] : Ze, yt = Be.fieldContext;
              return Je.map(function(Gt) {
                return typeof Gt == "function" ? Gt(yt) : Gt;
              });
            }, re.refresh = function() {
              !re.mounted || re.setState(function(Be) {
                var Ze = Be.resetCount;
                return { resetCount: Ze + 1 };
              });
            }, re.triggerMetaEvent = function(Be) {
              var Ze = re.props.onMetaChange;
              Ze == null || Ze(Xe(Xe({}, re.getMeta()), {}, { destroy: Be }));
            }, re.onStoreChange = function(Be, Ze, Je) {
              var yt = re.props, Gt = yt.shouldUpdate, Xt = yt.dependencies, Zt = Xt === void 0 ? [] : Xt, un = yt.onReset, yn = Je.store, _r = re.getNamePath(), cr = re.getValue(Be), fa = re.getValue(yn), We = Ze && Lw(Ze, _r);
              switch (Je.type === "valueUpdate" && Je.source === "external" && cr !== fa && (re.touched = true, re.dirty = true, re.validatePromise = null, re.errors = Bc, re.warnings = Bc, re.triggerMetaEvent()), Je.type) {
                case "reset":
                  if (!Ze || We) {
                    re.touched = false, re.dirty = false, re.validatePromise = null, re.errors = Bc, re.warnings = Bc, re.triggerMetaEvent(), un == null || un(), re.refresh();
                    return;
                  }
                  break;
                case "remove": {
                  if (Gt) {
                    re.reRender();
                    return;
                  }
                  break;
                }
                case "setField": {
                  if (We) {
                    var pn = Je.data;
                    "touched" in pn && (re.touched = pn.touched), "validating" in pn && !("originRCField" in pn) && (re.validatePromise = pn.validating ? Promise.resolve([]) : null), "errors" in pn && (re.errors = pn.errors || Bc), "warnings" in pn && (re.warnings = pn.warnings || Bc), re.dirty = true, re.triggerMetaEvent(), re.reRender();
                    return;
                  }
                  if (Gt && !_r.length && Xk(Gt, Be, yn, cr, fa, Je)) {
                    re.reRender();
                    return;
                  }
                  break;
                }
                case "dependenciesUpdate": {
                  var zn = Zt.map(zc);
                  if (zn.some(function(pr) {
                    return Lw(Je.relatedFields, pr);
                  })) {
                    re.reRender();
                    return;
                  }
                  break;
                }
                default:
                  if (We || (!Zt.length || _r.length || Gt) && Xk(Gt, Be, yn, cr, fa, Je)) {
                    re.reRender();
                    return;
                  }
                  break;
              }
              Gt === true && re.reRender();
            }, re.validateRules = function(Be) {
              var Ze = re.getNamePath(), Je = re.getValue(), yt = Promise.resolve().then(function() {
                if (!re.mounted)
                  return [];
                var Gt = re.props, Xt = Gt.validateFirst, Zt = Xt === void 0 ? false : Xt, un = Gt.messageVariables, yn = Be || {}, _r = yn.triggerName, cr = re.getRules();
                _r && (cr = cr.filter(function(We) {
                  var pn = We.validateTrigger;
                  if (!pn)
                    return true;
                  var zn = PE(pn);
                  return zn.includes(_r);
                }));
                var fa = uy(Ze, Je, cr, Be, Zt, un);
                return fa.catch(function(We) {
                  return We;
                }).then(function() {
                  var We = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Bc;
                  if (re.validatePromise === yt) {
                    re.validatePromise = null;
                    var pn = [], zn = [];
                    We.forEach(function(pr) {
                      var fr = pr.rule.warningOnly, Tn = pr.errors, Gn = Tn === void 0 ? Bc : Tn;
                      fr ? zn.push.apply(zn, Qo(Gn)) : pn.push.apply(pn, Qo(Gn));
                    }), re.errors = pn, re.warnings = zn, re.triggerMetaEvent(), re.reRender();
                  }
                }), fa;
              });
              return re.validatePromise = yt, re.dirty = true, re.errors = Bc, re.warnings = Bc, re.triggerMetaEvent(), re.reRender(), yt;
            }, re.isFieldValidating = function() {
              return !!re.validatePromise;
            }, re.isFieldTouched = function() {
              return re.touched;
            }, re.isFieldDirty = function() {
              if (re.dirty || re.props.initialValue !== void 0)
                return true;
              var Be = re.props.fieldContext, Ze = Be.getInternalHooks(hh), Je = Ze.getInitialValue;
              return Je(re.getNamePath()) !== void 0;
            }, re.getErrors = function() {
              return re.errors;
            }, re.getWarnings = function() {
              return re.warnings;
            }, re.isListField = function() {
              return re.props.isListField;
            }, re.isList = function() {
              return re.props.isList;
            }, re.isPreserve = function() {
              return re.props.preserve;
            }, re.getMeta = function() {
              re.prevValidating = re.isFieldValidating();
              var Be = { touched: re.isFieldTouched(), validating: re.prevValidating, errors: re.errors, warnings: re.warnings, name: re.getNamePath() };
              return Be;
            }, re.getOnlyChild = function(Be) {
              if (typeof Be == "function") {
                var Ze = re.getMeta();
                return Xe(Xe({}, re.getOnlyChild(Be(re.getControlled(), Ze, re.props.fieldContext))), {}, { isFunction: true });
              }
              var Je = DE(Be);
              return Je.length !== 1 || !De.isValidElement(Je[0]) ? { child: Je, isFunction: false } : { child: Je[0], isFunction: false };
            }, re.getValue = function(Be) {
              var Ze = re.props.fieldContext.getFieldsValue, Je = re.getNamePath();
              return ly(Be || Ze(true), Je);
            }, re.getControlled = function() {
              var Be = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Ze = re.props, Je = Ze.trigger, yt = Ze.validateTrigger, Gt = Ze.getValueFromEvent, Xt = Ze.normalize, Zt = Ze.valuePropName, un = Ze.getValueProps, yn = Ze.fieldContext, _r = yt !== void 0 ? yt : yn.validateTrigger, cr = re.getNamePath(), fa = yn.getInternalHooks, We = yn.getFieldsValue, pn = fa(hh), zn = pn.dispatch, pr = re.getValue(), fr = un || function(ra) {
                return St({}, Zt, ra);
              }, Tn = Be[Je], Gn = Xe(Xe({}, Be), fr(pr));
              Gn[Je] = function() {
                re.touched = true, re.dirty = true, re.triggerMetaEvent();
                for (var ra, wn = arguments.length, Ka = new Array(wn), Ya = 0; Ya < wn; Ya++)
                  Ka[Ya] = arguments[Ya];
                Gt ? ra = Gt.apply(void 0, Ka) : ra = YS.apply(void 0, [Zt].concat(Ka)), Xt && (ra = Xt(ra, pr, We(true))), zn({ type: "updateValue", namePath: cr, value: ra }), Tn && Tn.apply(void 0, Ka);
              };
              var Tr = PE(_r || []);
              return Tr.forEach(function(ra) {
                var wn = Gn[ra];
                Gn[ra] = function() {
                  wn && wn.apply(void 0, arguments);
                  var Ka = re.props.rules;
                  Ka && Ka.length && zn({ type: "validateField", namePath: cr, triggerName: ra });
                };
              }), Gn;
            }, ne.fieldContext) {
              var fe = ne.fieldContext.getInternalHooks, Ee = fe(hh), Oe = Ee.initEntityValue;
              Oe(jS(re));
            }
            return re;
          }
          return ty(Q, [{ key: "componentDidMount", value: function() {
            var ne = this.props, re = ne.shouldUpdate, fe = ne.fieldContext;
            if (this.mounted = true, fe) {
              var Ee = fe.getInternalHooks, Oe = Ee(hh), Be = Oe.registerField;
              this.cancelRegisterFunc = Be(this);
            }
            re === true && this.reRender();
          } }, { key: "componentWillUnmount", value: function() {
            this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
          } }, { key: "reRender", value: function() {
            !this.mounted || this.forceUpdate();
          } }, { key: "render", value: function() {
            var ne = this.state.resetCount, re = this.props.children, fe = this.getOnlyChild(re), Ee = fe.child, Oe = fe.isFunction, Be;
            return Oe ? Be = Ee : De.isValidElement(Ee) ? Be = De.cloneElement(Ee, this.getControlled(Ee.props)) : (Qp(!Ee, "`children` of Field is not validate ReactElement."), Be = Ee), De.createElement(De.Fragment, { key: ne }, Be);
          } }]), Q;
        }(De.Component);
        BE.contextType = Bh, BE.defaultProps = { trigger: "onChange", valuePropName: "value" };
        function Kk(Y) {
          var ge = Y.name, Q = ni(Y, Zk), ne = De.useContext(Bh), re = ge !== void 0 ? zc(ge) : void 0, fe = "keep";
          return Q.isListField || (fe = "_".concat((re || []).join("_"))), De.createElement(BE, ko({ key: fe, name: re }, Q, { fieldContext: ne }));
        }
        var v_ = De.createContext(null), Y6 = function(Y) {
          var ge = Y.name, Q = Y.initialValue, ne = Y.children, re = Y.rules, fe = Y.validateTrigger, Ee = De.useContext(Bh), Oe = De.useRef({ keys: [], id: 0 }), Be = Oe.current, Ze = De.useMemo(function() {
            var Xt = zc(Ee.prefixName) || [];
            return [].concat(Qo(Xt), Qo(zc(ge)));
          }, [Ee.prefixName, ge]), Je = De.useMemo(function() {
            return Xe(Xe({}, Ee), {}, { prefixName: Ze });
          }, [Ee, Ze]), yt = De.useMemo(function() {
            return { getKey: function(Xt) {
              var Zt = Ze.length, un = Xt[Zt];
              return [Be.keys[un], Xt.slice(Zt + 1)];
            } };
          }, [Ze]);
          if (typeof ne != "function")
            return Qp(false, "Form.List only accepts function as children."), null;
          var Gt = function(Xt, Zt, un) {
            var yn = un.source;
            return yn === "internal" ? false : Xt !== Zt;
          };
          return De.createElement(v_.Provider, { value: yt }, De.createElement(Bh.Provider, { value: Je }, De.createElement(Kk, { name: [], shouldUpdate: Gt, rules: re, validateTrigger: fe, initialValue: Q, isList: true }, function(Xt, Zt) {
            var un = Xt.value, yn = un === void 0 ? [] : un, _r = Xt.onChange, cr = Ee.getFieldValue, fa = function() {
              var zn = cr(Ze || []);
              return zn || [];
            }, We = { add: function(zn, pr) {
              var fr = fa();
              pr >= 0 && pr <= fr.length ? (Be.keys = [].concat(Qo(Be.keys.slice(0, pr)), [Be.id], Qo(Be.keys.slice(pr))), _r([].concat(Qo(fr.slice(0, pr)), [zn], Qo(fr.slice(pr))))) : (Be.keys = [].concat(Qo(Be.keys), [Be.id]), _r([].concat(Qo(fr), [zn]))), Be.id += 1;
            }, remove: function(zn) {
              var pr = fa(), fr = new Set(Array.isArray(zn) ? zn : [zn]);
              fr.size <= 0 || (Be.keys = Be.keys.filter(function(Tn, Gn) {
                return !fr.has(Gn);
              }), _r(pr.filter(function(Tn, Gn) {
                return !fr.has(Gn);
              })));
            }, move: function(zn, pr) {
              if (zn !== pr) {
                var fr = fa();
                zn < 0 || zn >= fr.length || pr < 0 || pr >= fr.length || (Be.keys = pp(Be.keys, zn, pr), _r(pp(fr, zn, pr)));
              }
            } }, pn = yn || [];
            return Array.isArray(pn) || (pn = []), ne(pn.map(function(zn, pr) {
              var fr = Be.keys[pr];
              return fr === void 0 && (Be.keys[pr] = Be.id, fr = Be.keys[pr], Be.id += 1), { name: pr, key: fr, isListField: true };
            }), We, Zt);
          })));
        };
        function V0(Y) {
          var ge = false, Q = Y.length, ne = [];
          return Y.length ? new Promise(function(re, fe) {
            Y.forEach(function(Ee, Oe) {
              Ee.catch(function(Be) {
                return ge = true, Be;
              }).then(function(Be) {
                Q -= 1, ne[Oe] = Be, !(Q > 0) && (ge && fe(ne), re(ne));
              });
            });
          }) : Promise.resolve([]);
        }
        var Jk = "__@field_split__";
        function jE(Y) {
          return Y.map(function(ge) {
            return "".concat(_o(ge), ":").concat(ge);
          }).join(Jk);
        }
        var Rw = function() {
          function Y() {
            tv(this, Y), this.kvs = /* @__PURE__ */ new Map();
          }
          return ty(Y, [{ key: "set", value: function(ge, Q) {
            this.kvs.set(jE(ge), Q);
          } }, { key: "get", value: function(ge) {
            return this.kvs.get(jE(ge));
          } }, { key: "update", value: function(ge, Q) {
            var ne = this.get(ge), re = Q(ne);
            re ? this.set(ge, re) : this.delete(ge);
          } }, { key: "delete", value: function(ge) {
            this.kvs.delete(jE(ge));
          } }, { key: "map", value: function(ge) {
            return Qo(this.kvs.entries()).map(function(Q) {
              var ne = cn(Q, 2), re = ne[0], fe = ne[1], Ee = re.split(Jk);
              return ge({ key: Ee.map(function(Oe) {
                var Be = Oe.match(/^([^:]*):(.*)$/), Ze = cn(Be, 3), Je = Ze[1], yt = Ze[2];
                return Je === "number" ? Number(yt) : yt;
              }), value: fe });
            });
          } }, { key: "toJSON", value: function() {
            var ge = {};
            return this.map(function(Q) {
              var ne = Q.key, re = Q.value;
              return ge[ne.join(".")] = re, null;
            }), ge;
          } }]), Y;
        }(), Qk = ["name", "errors"], eP = ty(function Y(ge) {
          var Q = this;
          tv(this, Y), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
            return { getFieldValue: Q.getFieldValue, getFieldsValue: Q.getFieldsValue, getFieldError: Q.getFieldError, getFieldWarning: Q.getFieldWarning, getFieldsError: Q.getFieldsError, isFieldsTouched: Q.isFieldsTouched, isFieldTouched: Q.isFieldTouched, isFieldValidating: Q.isFieldValidating, isFieldsValidating: Q.isFieldsValidating, resetFields: Q.resetFields, setFields: Q.setFields, setFieldsValue: Q.setFieldsValue, validateFields: Q.validateFields, submit: Q.submit, getInternalHooks: Q.getInternalHooks };
          }, this.getInternalHooks = function(ne) {
            return ne === hh ? (Q.formHooked = true, { dispatch: Q.dispatch, initEntityValue: Q.initEntityValue, registerField: Q.registerField, useSubscribe: Q.useSubscribe, setInitialValues: Q.setInitialValues, setCallbacks: Q.setCallbacks, setValidateMessages: Q.setValidateMessages, getFields: Q.getFields, setPreserve: Q.setPreserve, getInitialValue: Q.getInitialValue }) : (Qp(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
          }, this.useSubscribe = function(ne) {
            Q.subscribable = ne;
          }, this.setInitialValues = function(ne, re) {
            Q.initialValues = ne || {}, re && (Q.store = pc({}, ne, Q.store));
          }, this.getInitialValue = function(ne) {
            return ly(Q.initialValues, ne);
          }, this.setCallbacks = function(ne) {
            Q.callbacks = ne;
          }, this.setValidateMessages = function(ne) {
            Q.validateMessages = ne;
          }, this.setPreserve = function(ne) {
            Q.preserve = ne;
          }, this.timeoutId = null, this.warningUnhooked = function() {
          }, this.getFieldEntities = function() {
            var ne = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
            return ne ? Q.fieldEntities.filter(function(re) {
              return re.getNamePath().length;
            }) : Q.fieldEntities;
          }, this.getFieldsMap = function() {
            var ne = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, re = new Rw();
            return Q.getFieldEntities(ne).forEach(function(fe) {
              var Ee = fe.getNamePath();
              re.set(Ee, fe);
            }), re;
          }, this.getFieldEntitiesForNamePathList = function(ne) {
            if (!ne)
              return Q.getFieldEntities(true);
            var re = Q.getFieldsMap(true);
            return ne.map(function(fe) {
              var Ee = zc(fe);
              return re.get(Ee) || { INVALIDATE_NAME_PATH: zc(fe) };
            });
          }, this.getFieldsValue = function(ne, re) {
            if (Q.warningUnhooked(), ne === true && !re)
              return Q.store;
            var fe = Q.getFieldEntitiesForNamePathList(Array.isArray(ne) ? ne : null), Ee = [];
            return fe.forEach(function(Oe) {
              var Be, Ze = "INVALIDATE_NAME_PATH" in Oe ? Oe.INVALIDATE_NAME_PATH : Oe.getNamePath();
              if (!(!ne && ((Be = Oe.isListField) === null || Be === void 0 ? void 0 : Be.call(Oe))))
                if (!re)
                  Ee.push(Ze);
                else {
                  var Je = "getMeta" in Oe ? Oe.getMeta() : null;
                  re(Je) && Ee.push(Ze);
                }
            }), qS(Q.store, Ee.map(zc));
          }, this.getFieldValue = function(ne) {
            Q.warningUnhooked();
            var re = zc(ne);
            return ly(Q.store, re);
          }, this.getFieldsError = function(ne) {
            Q.warningUnhooked();
            var re = Q.getFieldEntitiesForNamePathList(ne);
            return re.map(function(fe, Ee) {
              return fe && !("INVALIDATE_NAME_PATH" in fe) ? { name: fe.getNamePath(), errors: fe.getErrors(), warnings: fe.getWarnings() } : { name: zc(ne[Ee]), errors: [], warnings: [] };
            });
          }, this.getFieldError = function(ne) {
            Q.warningUnhooked();
            var re = zc(ne), fe = Q.getFieldsError([re])[0];
            return fe.errors;
          }, this.getFieldWarning = function(ne) {
            Q.warningUnhooked();
            var re = zc(ne), fe = Q.getFieldsError([re])[0];
            return fe.warnings;
          }, this.isFieldsTouched = function() {
            Q.warningUnhooked();
            for (var ne = arguments.length, re = new Array(ne), fe = 0; fe < ne; fe++)
              re[fe] = arguments[fe];
            var Ee = re[0], Oe = re[1], Be, Ze = false;
            re.length === 0 ? Be = null : re.length === 1 ? Array.isArray(Ee) ? (Be = Ee.map(zc), Ze = false) : (Be = null, Ze = Ee) : (Be = Ee.map(zc), Ze = Oe);
            var Je = Q.getFieldEntities(true), yt = function(un) {
              return un.isFieldTouched();
            };
            if (!Be)
              return Ze ? Je.every(yt) : Je.some(yt);
            var Gt = new Rw();
            Be.forEach(function(un) {
              Gt.set(un, []);
            }), Je.forEach(function(un) {
              var yn = un.getNamePath();
              Be.forEach(function(_r) {
                _r.every(function(cr, fa) {
                  return yn[fa] === cr;
                }) && Gt.update(_r, function(cr) {
                  return [].concat(Qo(cr), [un]);
                });
              });
            });
            var Xt = function(un) {
              return un.some(yt);
            }, Zt = Gt.map(function(un) {
              var yn = un.value;
              return yn;
            });
            return Ze ? Zt.every(Xt) : Zt.some(Xt);
          }, this.isFieldTouched = function(ne) {
            return Q.warningUnhooked(), Q.isFieldsTouched([ne]);
          }, this.isFieldsValidating = function(ne) {
            Q.warningUnhooked();
            var re = Q.getFieldEntities();
            if (!ne)
              return re.some(function(Ee) {
                return Ee.isFieldValidating();
              });
            var fe = ne.map(zc);
            return re.some(function(Ee) {
              var Oe = Ee.getNamePath();
              return Lw(fe, Oe) && Ee.isFieldValidating();
            });
          }, this.isFieldValidating = function(ne) {
            return Q.warningUnhooked(), Q.isFieldsValidating([ne]);
          }, this.resetWithFieldInitialValue = function() {
            var ne = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, re = new Rw(), fe = Q.getFieldEntities(true);
            fe.forEach(function(Be) {
              var Ze = Be.props.initialValue, Je = Be.getNamePath();
              if (Ze !== void 0) {
                var yt = re.get(Je) || /* @__PURE__ */ new Set();
                yt.add({ entity: Be, value: Ze }), re.set(Je, yt);
              }
            });
            var Ee = function(Be) {
              Be.forEach(function(Ze) {
                var Je = Ze.props.initialValue;
                if (Je !== void 0) {
                  var yt = Ze.getNamePath(), Gt = Q.getInitialValue(yt);
                  if (Gt !== void 0)
                    Qp(false, "Form already set 'initialValues' with path '".concat(yt.join("."), "'. Field can not overwrite it."));
                  else {
                    var Xt = re.get(yt);
                    if (Xt && Xt.size > 1)
                      Qp(false, "Multiple Field with path '".concat(yt.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                    else if (Xt) {
                      var Zt = Q.getFieldValue(yt);
                      (!ne.skipExist || Zt === void 0) && (Q.store = P1(Q.store, yt, Qo(Xt)[0].value));
                    }
                  }
                }
              });
            }, Oe;
            ne.entities ? Oe = ne.entities : ne.namePathList ? (Oe = [], ne.namePathList.forEach(function(Be) {
              var Ze = re.get(Be);
              if (Ze) {
                var Je;
                (Je = Oe).push.apply(Je, Qo(Qo(Ze).map(function(yt) {
                  return yt.entity;
                })));
              }
            })) : Oe = fe, Ee(Oe);
          }, this.resetFields = function(ne) {
            Q.warningUnhooked();
            var re = Q.store;
            if (!ne) {
              Q.store = pc({}, Q.initialValues), Q.resetWithFieldInitialValue(), Q.notifyObservers(re, null, { type: "reset" });
              return;
            }
            var fe = ne.map(zc);
            fe.forEach(function(Ee) {
              var Oe = Q.getInitialValue(Ee);
              Q.store = P1(Q.store, Ee, Oe);
            }), Q.resetWithFieldInitialValue({ namePathList: fe }), Q.notifyObservers(re, fe, { type: "reset" });
          }, this.setFields = function(ne) {
            Q.warningUnhooked();
            var re = Q.store;
            ne.forEach(function(fe) {
              var Ee = fe.name;
              fe.errors;
              var Oe = ni(fe, Qk), Be = zc(Ee);
              "value" in Oe && (Q.store = P1(Q.store, Be, Oe.value)), Q.notifyObservers(re, [Be], { type: "setField", data: fe });
            });
          }, this.getFields = function() {
            var ne = Q.getFieldEntities(true), re = ne.map(function(fe) {
              var Ee = fe.getNamePath(), Oe = fe.getMeta(), Be = Xe(Xe({}, Oe), {}, { name: Ee, value: Q.getFieldValue(Ee) });
              return Object.defineProperty(Be, "originRCField", { value: true }), Be;
            });
            return re;
          }, this.initEntityValue = function(ne) {
            var re = ne.props.initialValue;
            if (re !== void 0) {
              var fe = ne.getNamePath(), Ee = ly(Q.store, fe);
              Ee === void 0 && (Q.store = P1(Q.store, fe, re));
            }
          }, this.registerField = function(ne) {
            if (Q.fieldEntities.push(ne), ne.props.initialValue !== void 0) {
              var re = Q.store;
              Q.resetWithFieldInitialValue({ entities: [ne], skipExist: true }), Q.notifyObservers(re, [ne.getNamePath()], { type: "valueUpdate", source: "internal" });
            }
            return function(fe, Ee) {
              var Oe = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
              Q.fieldEntities = Q.fieldEntities.filter(function(Gt) {
                return Gt !== ne;
              });
              var Be = Ee !== void 0 ? Ee : Q.preserve;
              if (Be === false && (!fe || Oe.length > 1)) {
                var Ze = ne.getNamePath(), Je = fe ? void 0 : ly(Q.initialValues, Ze);
                if (Ze.length && Q.getFieldValue(Ze) !== Je && Q.fieldEntities.every(function(Gt) {
                  return !nt(Gt.getNamePath(), Ze);
                })) {
                  var yt = Q.store;
                  Q.store = P1(yt, Ze, Je, true), Q.notifyObservers(yt, [Ze], { type: "remove" }), Q.triggerDependenciesUpdate(yt, Ze);
                }
              }
            };
          }, this.dispatch = function(ne) {
            switch (ne.type) {
              case "updateValue": {
                var re = ne.namePath, fe = ne.value;
                Q.updateValue(re, fe);
                break;
              }
              case "validateField": {
                var Ee = ne.namePath, Oe = ne.triggerName;
                Q.validateFields([Ee], { triggerName: Oe });
                break;
              }
            }
          }, this.notifyObservers = function(ne, re, fe) {
            if (Q.subscribable) {
              var Ee = Xe(Xe({}, fe), {}, { store: Q.getFieldsValue(true) });
              Q.getFieldEntities().forEach(function(Oe) {
                var Be = Oe.onStoreChange;
                Be(ne, re, Ee);
              });
            } else
              Q.forceRootUpdate();
          }, this.triggerDependenciesUpdate = function(ne, re) {
            var fe = Q.getDependencyChildrenFields(re);
            return fe.length && Q.validateFields(fe), Q.notifyObservers(ne, fe, { type: "dependenciesUpdate", relatedFields: [re].concat(Qo(fe)) }), fe;
          }, this.updateValue = function(ne, re) {
            var fe = zc(ne), Ee = Q.store;
            Q.store = P1(Q.store, fe, re), Q.notifyObservers(Ee, [fe], { type: "valueUpdate", source: "internal" });
            var Oe = Q.triggerDependenciesUpdate(Ee, fe), Be = Q.callbacks.onValuesChange;
            if (Be) {
              var Ze = qS(Q.store, [fe]);
              Be(Ze, Q.getFieldsValue());
            }
            Q.triggerOnFieldsChange([fe].concat(Qo(Oe)));
          }, this.setFieldsValue = function(ne) {
            Q.warningUnhooked();
            var re = Q.store;
            ne && (Q.store = pc(Q.store, ne)), Q.notifyObservers(re, null, { type: "valueUpdate", source: "external" });
          }, this.getDependencyChildrenFields = function(ne) {
            var re = /* @__PURE__ */ new Set(), fe = [], Ee = new Rw();
            Q.getFieldEntities().forEach(function(Be) {
              var Ze = Be.props.dependencies;
              (Ze || []).forEach(function(Je) {
                var yt = zc(Je);
                Ee.update(yt, function() {
                  var Gt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                  return Gt.add(Be), Gt;
                });
              });
            });
            var Oe = function Be(Ze) {
              var Je = Ee.get(Ze) || /* @__PURE__ */ new Set();
              Je.forEach(function(yt) {
                if (!re.has(yt)) {
                  re.add(yt);
                  var Gt = yt.getNamePath();
                  yt.isFieldDirty() && Gt.length && (fe.push(Gt), Be(Gt));
                }
              });
            };
            return Oe(ne), fe;
          }, this.triggerOnFieldsChange = function(ne, re) {
            var fe = Q.callbacks.onFieldsChange;
            if (fe) {
              var Ee = Q.getFields();
              if (re) {
                var Oe = new Rw();
                re.forEach(function(Ze) {
                  var Je = Ze.name, yt = Ze.errors;
                  Oe.set(Je, yt);
                }), Ee.forEach(function(Ze) {
                  Ze.errors = Oe.get(Ze.name) || Ze.errors;
                });
              }
              var Be = Ee.filter(function(Ze) {
                var Je = Ze.name;
                return Lw(ne, Je);
              });
              fe(Be, Ee);
            }
          }, this.validateFields = function(ne, re) {
            Q.warningUnhooked();
            var fe = !!ne, Ee = fe ? ne.map(zc) : [], Oe = [];
            Q.getFieldEntities(true).forEach(function(Je) {
              if (fe || Ee.push(Je.getNamePath()), (re == null ? void 0 : re.recursive) && fe) {
                var yt = Je.getNamePath();
                yt.every(function(Zt, un) {
                  return ne[un] === Zt || ne[un] === void 0;
                }) && Ee.push(yt);
              }
              if (!(!Je.props.rules || !Je.props.rules.length)) {
                var Gt = Je.getNamePath();
                if (!fe || Lw(Ee, Gt)) {
                  var Xt = Je.validateRules(Xe({ validateMessages: Xe(Xe({}, k1), Q.validateMessages) }, re));
                  Oe.push(Xt.then(function() {
                    return { name: Gt, errors: [], warnings: [] };
                  }).catch(function(Zt) {
                    var un = [], yn = [];
                    return Zt.forEach(function(_r) {
                      var cr = _r.rule.warningOnly, fa = _r.errors;
                      cr ? yn.push.apply(yn, Qo(fa)) : un.push.apply(un, Qo(fa));
                    }), un.length ? Promise.reject({ name: Gt, errors: un, warnings: yn }) : { name: Gt, errors: un, warnings: yn };
                  }));
                }
              }
            });
            var Be = V0(Oe);
            Q.lastValidatePromise = Be, Be.catch(function(Je) {
              return Je;
            }).then(function(Je) {
              var yt = Je.map(function(Gt) {
                var Xt = Gt.name;
                return Xt;
              });
              Q.notifyObservers(Q.store, yt, { type: "validateFinish" }), Q.triggerOnFieldsChange(yt, Je);
            });
            var Ze = Be.then(function() {
              return Q.lastValidatePromise === Be ? Promise.resolve(Q.getFieldsValue(Ee)) : Promise.reject([]);
            }).catch(function(Je) {
              var yt = Je.filter(function(Gt) {
                return Gt && Gt.errors.length;
              });
              return Promise.reject({ values: Q.getFieldsValue(Ee), errorFields: yt, outOfDate: Q.lastValidatePromise !== Be });
            });
            return Ze.catch(function(Je) {
              return Je;
            }), Ze;
          }, this.submit = function() {
            Q.warningUnhooked(), Q.validateFields().then(function(ne) {
              var re = Q.callbacks.onFinish;
              if (re)
                try {
                  re(ne);
                } catch (fe) {
                  console.error(fe);
                }
            }).catch(function(ne) {
              var re = Q.callbacks.onFinishFailed;
              re && re(ne);
            });
          }, this.forceRootUpdate = ge;
        });
        function cy(Y) {
          var ge = De.useRef(), Q = De.useState({}), ne = cn(Q, 2), re = ne[1];
          if (!ge.current)
            if (Y)
              ge.current = Y;
            else {
              var fe = function() {
                re({});
              }, Ee = new eP(fe);
              ge.current = Ee.getForm();
            }
          return [ge.current];
        }
        var GE = De.createContext({ triggerFormChange: function() {
        }, triggerFormFinish: function() {
        }, registerForm: function() {
        }, unregisterForm: function() {
        } }), Z6 = function(Y) {
          var ge = Y.validateMessages, Q = Y.onFormChange, ne = Y.onFormFinish, re = Y.children, fe = De.useContext(GE), Ee = De.useRef({});
          return De.createElement(GE.Provider, { value: Xe(Xe({}, fe), {}, { validateMessages: Xe(Xe({}, fe.validateMessages), ge), triggerFormChange: function(Oe, Be) {
            Q && Q(Oe, { changedFields: Be, forms: Ee.current }), fe.triggerFormChange(Oe, Be);
          }, triggerFormFinish: function(Oe, Be) {
            ne && ne(Oe, { values: Be, forms: Ee.current }), fe.triggerFormFinish(Oe, Be);
          }, registerForm: function(Oe, Be) {
            Oe && (Ee.current = Xe(Xe({}, Ee.current), {}, St({}, Oe, Be))), fe.registerForm(Oe, Be);
          }, unregisterForm: function(Oe) {
            var Be = Xe({}, Ee.current);
            delete Be[Oe], Ee.current = Be, fe.unregisterForm(Oe);
          } }) }, re);
        }, Bv = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], X6 = function(Y, ge) {
          var Q = Y.name, ne = Y.initialValues, re = Y.fields, fe = Y.form, Ee = Y.preserve, Oe = Y.children, Be = Y.component, Ze = Be === void 0 ? "form" : Be, Je = Y.validateMessages, yt = Y.validateTrigger, Gt = yt === void 0 ? "onChange" : yt, Xt = Y.onValuesChange, Zt = Y.onFieldsChange, un = Y.onFinish, yn = Y.onFinishFailed, _r = ni(Y, Bv), cr = De.useContext(GE), fa = cy(fe), We = cn(fa, 1), pn = We[0], zn = pn.getInternalHooks(hh), pr = zn.useSubscribe, fr = zn.setInitialValues, Tn = zn.setCallbacks, Gn = zn.setValidateMessages, Tr = zn.setPreserve;
          De.useImperativeHandle(ge, function() {
            return pn;
          }), De.useEffect(function() {
            return cr.registerForm(Q, pn), function() {
              cr.unregisterForm(Q);
            };
          }, [cr, pn, Q]), Gn(Xe(Xe({}, cr.validateMessages), Je)), Tn({ onValuesChange: Xt, onFieldsChange: function(Xn) {
            if (cr.triggerFormChange(Q, Xn), Zt) {
              for (var Kn = arguments.length, ba = new Array(Kn > 1 ? Kn - 1 : 0), la = 1; la < Kn; la++)
                ba[la - 1] = arguments[la];
              Zt.apply(void 0, [Xn].concat(ba));
            }
          }, onFinish: function(Xn) {
            cr.triggerFormFinish(Q, Xn), un && un(Xn);
          }, onFinishFailed: yn }), Tr(Ee);
          var ra = De.useRef(null);
          fr(ne, !ra.current), ra.current || (ra.current = true);
          var wn = Oe, Ka = typeof Oe == "function";
          if (Ka) {
            var Ya = pn.getFieldsValue(true);
            wn = Oe(Ya, pn);
          }
          pr(!Ka);
          var vr = De.useRef();
          De.useEffect(function() {
            p_(vr.current || [], re || []) || pn.setFields(re || []), vr.current = re;
          }, [re, pn]);
          var Pi = De.useMemo(function() {
            return Xe(Xe({}, pn), {}, { validateTrigger: Gt });
          }, [pn, Gt]), xr = De.createElement(Bh.Provider, { value: Pi }, wn);
          return Ze === false ? xr : De.createElement(Ze, ko({}, _r, { onSubmit: function(Xn) {
            Xn.preventDefault(), Xn.stopPropagation(), pn.submit();
          }, onReset: function(Xn) {
            var Kn;
            Xn.preventDefault(), pn.resetFields(), (Kn = _r.onReset) === null || Kn === void 0 || Kn.call(_r, Xn);
          } }), xr);
        }, K6 = De.forwardRef(X6), XS = K6;
        XS.FormProvider = Z6, XS.Field = Kk, XS.List = Y6, XS.useForm = cy;
        var J6 = function(Y, ge, Q) {
          Qp(Y, "[antd: ".concat(ge, "] ").concat(Q));
        }, Q6 = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, tP = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, nP = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, rP = nP, eF = { lang: ko({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, tP), timePickerLocale: ko({}, rP) }, KS = eF, Wf = "${label} is not a valid ${type}", JS = { locale: "en", Pagination: Q6, DatePicker: KS, TimePicker: rP, Calendar: KS, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: Wf, method: Wf, array: Wf, object: Wf, number: Wf, date: Wf, boolean: Wf, integer: Wf, float: Wf, regexp: Wf, email: Wf, url: Wf, hex: Wf }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, aP = JS, iP = te.createContext(void 0), tF = iP, jv = function(Y) {
          EE(Q, Y);
          var ge = ny(Q);
          function Q() {
            return tv(this, Q), ge.apply(this, arguments);
          }
          return ty(Q, [{ key: "getLocale", value: function() {
            var ne = this.props, re = ne.componentName, fe = ne.defaultLocale, Ee = fe || aP[re != null ? re : "global"], Oe = this.context, Be = re && Oe ? Oe[re] : {};
            return ko(ko({}, Ee instanceof Function ? Ee() : Ee), Be || {});
          } }, { key: "getLocaleCode", value: function() {
            var ne = this.context, re = ne && ne.locale;
            return ne && ne.exist && !re ? aP.locale : re;
          } }, { key: "render", value: function() {
            return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
          } }]), Q;
        }(De.Component);
        jv.defaultProps = { componentName: "global" }, jv.contextType = tF;
        var WE = function() {
          var Y = De.useContext(z0), ge = Y.getPrefixCls, Q = ge("empty-img-default");
          return De.createElement("svg", { className: Q, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, De.createElement("g", { fill: "none", fillRule: "evenodd" }, De.createElement("g", { transform: "translate(24 31.67)" }, De.createElement("ellipse", { className: "".concat(Q, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), De.createElement("path", { className: "".concat(Q, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), De.createElement("path", { className: "".concat(Q, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), De.createElement("path", { className: "".concat(Q, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), De.createElement("path", { className: "".concat(Q, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), De.createElement("path", { className: "".concat(Q, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), De.createElement("g", { className: "".concat(Q, "-g"), transform: "translate(149.65 15.383)" }, De.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), De.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
        }, L1 = WE, rv = function() {
          var Y = De.useContext(z0), ge = Y.getPrefixCls, Q = ge("empty-img-simple");
          return De.createElement("svg", { className: Q, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, De.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, De.createElement("ellipse", { className: "".concat(Q, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), De.createElement("g", { className: "".concat(Q, "-g"), fillRule: "nonzero" }, De.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), De.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(Q, "-path") }))));
        }, nF = rv, oP = globalThis && globalThis.__rest || function(Y, ge) {
          var Q = {};
          for (var ne in Y)
            Object.prototype.hasOwnProperty.call(Y, ne) && ge.indexOf(ne) < 0 && (Q[ne] = Y[ne]);
          if (Y != null && typeof Object.getOwnPropertySymbols == "function")
            for (var re = 0, ne = Object.getOwnPropertySymbols(Y); re < ne.length; re++)
              ge.indexOf(ne[re]) < 0 && Object.prototype.propertyIsEnumerable.call(Y, ne[re]) && (Q[ne[re]] = Y[ne[re]]);
          return Q;
        }, Fw = De.createElement(L1, null), O1 = De.createElement(nF, null), Gv = function(Y) {
          var ge = Y.className, Q = Y.prefixCls, ne = Y.image, re = ne === void 0 ? Fw : ne, fe = Y.description, Ee = Y.children, Oe = Y.imageStyle, Be = oP(Y, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), Ze = De.useContext(z0), Je = Ze.getPrefixCls, yt = Ze.direction;
          return De.createElement(jv, { componentName: "Empty" }, function(Gt) {
            var Xt, Zt = Je("empty", Q), un = typeof fe != "undefined" ? fe : Gt.description, yn = typeof un == "string" ? un : "empty", _r = null;
            return typeof re == "string" ? _r = De.createElement("img", { alt: yn, src: re }) : _r = re, De.createElement("div", ko({ className: Fo(Zt, (Xt = {}, St(Xt, "".concat(Zt, "-normal"), re === O1), St(Xt, "".concat(Zt, "-rtl"), yt === "rtl"), Xt), ge) }, Be), De.createElement("div", { className: "".concat(Zt, "-image"), style: Oe }, _r), un && De.createElement("div", { className: "".concat(Zt, "-description") }, un), Ee && De.createElement("div", { className: "".concat(Zt, "-footer") }, Ee));
          });
        };
        Gv.PRESENTED_IMAGE_DEFAULT = Fw, Gv.PRESENTED_IMAGE_SIMPLE = O1;
        var g_ = Gv, rF = function(Y) {
          return De.createElement(wf, null, function(ge) {
            var Q = ge.getPrefixCls, ne = Q("empty");
            switch (Y) {
              case "Table":
              case "List":
                return De.createElement(g_, { image: g_.PRESENTED_IMAGE_SIMPLE });
              case "Select":
              case "TreeSelect":
              case "Cascader":
              case "Transfer":
              case "Mentions":
                return De.createElement(g_, { image: g_.PRESENTED_IMAGE_SIMPLE, className: "".concat(ne, "-small") });
              default:
                return De.createElement(g_, null);
            }
          });
        }, QS = rF, HE = function(Y, ge) {
          return ge || (Y ? "ant-".concat(Y) : "ant");
        }, z0 = De.createContext({ getPrefixCls: HE, renderEmpty: QS }), wf = z0.Consumer, $E = De.createContext(void 0), Gh = $E, vp = function(Y) {
          return +setTimeout(Y, 16);
        }, eC = function(Y) {
          return clearTimeout(Y);
        };
        typeof window != "undefined" && "requestAnimationFrame" in window && (vp = function(Y) {
          return window.requestAnimationFrame(Y);
        }, eC = function(Y) {
          return window.cancelAnimationFrame(Y);
        });
        var Nw = 0, B0 = /* @__PURE__ */ new Map();
        function UE(Y) {
          B0.delete(Y);
        }
        function jc(Y) {
          var ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
          Nw += 1;
          var Q = Nw;
          function ne(re) {
            if (re === 0)
              UE(Q), Y();
            else {
              var fe = vp(function() {
                ne(re - 1);
              });
              B0.set(Q, fe);
            }
          }
          return ne(ge), Q;
        }
        jc.cancel = function(Y) {
          var ge = B0.get(Y);
          return UE(ge), eC(ge);
        };
        function qE(Y, ge) {
          var Q = ge || {}, ne = Q.defaultValue, re = Q.value, fe = Q.onChange, Ee = Q.postState, Oe = De.useState(function() {
            return re !== void 0 ? re : ne !== void 0 ? typeof ne == "function" ? ne() : ne : typeof Y == "function" ? Y() : Y;
          }), Be = cn(Oe, 2), Ze = Be[0], Je = Be[1], yt = re !== void 0 ? re : Ze;
          Ee && (yt = Ee(yt));
          var Gt = De.useRef(fe);
          Gt.current = fe;
          var Xt = De.useCallback(function(un) {
            Je(un), yt !== un && Gt.current && Gt.current(un, yt);
          }, [yt, Gt]), Zt = De.useRef(true);
          return De.useEffect(function() {
            if (Zt.current) {
              Zt.current = false;
              return;
            }
            re === void 0 && Je(re);
          }, [re]), [yt, Xt];
        }
        var Gi = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(Y) {
          var ge = Y.keyCode;
          if (Y.altKey && !Y.ctrlKey || Y.metaKey || ge >= Gi.F1 && ge <= Gi.F12)
            return false;
          switch (ge) {
            case Gi.ALT:
            case Gi.CAPS_LOCK:
            case Gi.CONTEXT_MENU:
            case Gi.CTRL:
            case Gi.DOWN:
            case Gi.END:
            case Gi.ESC:
            case Gi.HOME:
            case Gi.INSERT:
            case Gi.LEFT:
            case Gi.MAC_FF_META:
            case Gi.META:
            case Gi.NUMLOCK:
            case Gi.NUM_CENTER:
            case Gi.PAGE_DOWN:
            case Gi.PAGE_UP:
            case Gi.PAUSE:
            case Gi.PRINT_SCREEN:
            case Gi.RIGHT:
            case Gi.SHIFT:
            case Gi.UP:
            case Gi.WIN_KEY:
            case Gi.WIN_KEY_RIGHT:
              return false;
            default:
              return true;
          }
        }, isCharacterKey: function(Y) {
          if (Y >= Gi.ZERO && Y <= Gi.NINE || Y >= Gi.NUM_ZERO && Y <= Gi.NUM_MULTIPLY || Y >= Gi.A && Y <= Gi.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && Y === 0)
            return true;
          switch (Y) {
            case Gi.SPACE:
            case Gi.QUESTION_MARK:
            case Gi.NUM_PLUS:
            case Gi.NUM_MINUS:
            case Gi.NUM_PERIOD:
            case Gi.NUM_DIVISION:
            case Gi.SEMICOLON:
            case Gi.DASH:
            case Gi.EQUALS:
            case Gi.COMMA:
            case Gi.PERIOD:
            case Gi.SLASH:
            case Gi.APOSTROPHE:
            case Gi.SINGLE_QUOTE:
            case Gi.OPEN_SQUARE_BRACKET:
            case Gi.BACKSLASH:
            case Gi.CLOSE_SQUARE_BRACKET:
              return true;
            default:
              return false;
          }
        } }, sP = function() {
          for (var Y = arguments.length, ge = new Array(Y), Q = 0; Q < Y; Q++)
            ge[Q] = arguments[Q];
          return ge;
        }, aF = De.isValidElement;
        function YE(Y, ge, Q) {
          return aF(Y) ? De.cloneElement(Y, typeof Q == "function" ? Q(Y.props || {}) : Q) : ge;
        }
        function iF(Y, ge) {
          return YE(Y, Y, ge);
        }
        var R1 = ["xxl", "xl", "lg", "md", "sm", "xs"], Vw = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, F1 = /* @__PURE__ */ new Map(), ZE = -1, Sg = {}, XE = { matchHandlers: {}, dispatch: function(Y) {
          return Sg = Y, F1.forEach(function(ge) {
            return ge(Sg);
          }), F1.size >= 1;
        }, subscribe: function(Y) {
          return F1.size || this.register(), ZE += 1, F1.set(ZE, Y), Y(Sg), ZE;
        }, unsubscribe: function(Y) {
          F1.delete(Y), F1.size || this.unregister();
        }, unregister: function() {
          var Y = this;
          Object.keys(Vw).forEach(function(ge) {
            var Q = Vw[ge], ne = Y.matchHandlers[Q];
            ne == null || ne.mql.removeListener(ne == null ? void 0 : ne.listener);
          }), F1.clear();
        }, register: function() {
          var Y = this;
          Object.keys(Vw).forEach(function(ge) {
            var Q = Vw[ge], ne = function(fe) {
              var Ee = fe.matches;
              Y.dispatch(ko(ko({}, Sg), St({}, ge, Ee)));
            }, re = window.matchMedia(Q);
            re.addListener(ne), Y.matchHandlers[Q] = { mql: re, listener: ne }, ne(re);
          });
        } }, lP = XE, KE = 0, N1 = {};
        function tC(Y) {
          var ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, Q = KE++, ne = ge;
          function re() {
            ne -= 1, ne <= 0 ? (Y(), delete N1[Q]) : N1[Q] = jc(re);
          }
          return N1[Q] = jc(re), Q;
        }
        tC.cancel = function(Y) {
          Y !== void 0 && (jc.cancel(N1[Y]), delete N1[Y]);
        }, tC.ids = N1;
        var JE;
        function uP(Y) {
          return !Y || Y.offsetParent === null || Y.hidden;
        }
        function cP(Y) {
          var ge = (Y || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
          return ge && ge[1] && ge[2] && ge[3] ? !(ge[1] === ge[2] && ge[2] === ge[3]) : true;
        }
        var nC = function(Y) {
          EE(Q, Y);
          var ge = ny(Q);
          function Q() {
            var ne;
            return tv(this, Q), ne = ge.apply(this, arguments), ne.containerRef = De.createRef(), ne.animationStart = false, ne.destroyed = false, ne.onClick = function(re, fe) {
              var Ee, Oe, Be = ne.props, Ze = Be.insertExtraNode, Je = Be.disabled;
              if (!(Je || !re || uP(re) || re.className.indexOf("-leave") >= 0)) {
                ne.extraNode = document.createElement("div");
                var yt = jS(ne), Gt = yt.extraNode, Xt = ne.context.getPrefixCls;
                Gt.className = "".concat(Xt(""), "-click-animating-node");
                var Zt = ne.getAttributeName();
                if (re.setAttribute(Zt, "true"), fe && fe !== "#ffffff" && fe !== "rgb(255, 255, 255)" && cP(fe) && !/rgba\((?:\d*, ){3}0\)/.test(fe) && fe !== "transparent") {
                  Gt.style.borderColor = fe;
                  var un = ((Ee = re.getRootNode) === null || Ee === void 0 ? void 0 : Ee.call(re)) || re.ownerDocument, yn = un instanceof Document ? un.body : (Oe = un.firstChild) !== null && Oe !== void 0 ? Oe : un;
                  JE = Tk(`
      [`.concat(Xt(""), "-click-animating-without-extra-node='true']::after, .").concat(Xt(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(fe, `;
      }`), "antd-wave", { csp: ne.csp, attachTo: yn });
                }
                Ze && re.appendChild(Gt), ["transition", "animation"].forEach(function(_r) {
                  re.addEventListener("".concat(_r, "start"), ne.onTransitionStart), re.addEventListener("".concat(_r, "end"), ne.onTransitionEnd);
                });
              }
            }, ne.onTransitionStart = function(re) {
              if (!ne.destroyed) {
                var fe = ne.containerRef.current;
                !re || re.target !== fe || ne.animationStart || ne.resetEffect(fe);
              }
            }, ne.onTransitionEnd = function(re) {
              !re || re.animationName !== "fadeEffect" || ne.resetEffect(re.target);
            }, ne.bindAnimationEvent = function(re) {
              if (!(!re || !re.getAttribute || re.getAttribute("disabled") || re.className.indexOf("disabled") >= 0)) {
                var fe = function(Ee) {
                  if (!(Ee.target.tagName === "INPUT" || uP(Ee.target))) {
                    ne.resetEffect(re);
                    var Oe = getComputedStyle(re).getPropertyValue("border-top-color") || getComputedStyle(re).getPropertyValue("border-color") || getComputedStyle(re).getPropertyValue("background-color");
                    ne.clickWaveTimeoutId = window.setTimeout(function() {
                      return ne.onClick(re, Oe);
                    }, 0), tC.cancel(ne.animationStartId), ne.animationStart = true, ne.animationStartId = tC(function() {
                      ne.animationStart = false;
                    }, 10);
                  }
                };
                return re.addEventListener("click", fe, true), { cancel: function() {
                  re.removeEventListener("click", fe, true);
                } };
              }
            }, ne.renderWave = function(re) {
              var fe = re.csp, Ee = ne.props.children;
              if (ne.csp = fe, !De.isValidElement(Ee))
                return Ee;
              var Oe = ne.containerRef;
              return oy(Ee) && (Oe = Nk(Ee.ref, ne.containerRef)), iF(Ee, { ref: Oe });
            }, ne;
          }
          return ty(Q, [{ key: "componentDidMount", value: function() {
            var ne = this.containerRef.current;
            !ne || ne.nodeType !== 1 || (this.instance = this.bindAnimationEvent(ne));
          } }, { key: "componentWillUnmount", value: function() {
            this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
          } }, { key: "getAttributeName", value: function() {
            var ne = this.context.getPrefixCls, re = this.props.insertExtraNode;
            return re ? "".concat(ne(""), "-click-animating") : "".concat(ne(""), "-click-animating-without-extra-node");
          } }, { key: "resetEffect", value: function(ne) {
            var re = this;
            if (!(!ne || ne === this.extraNode || !(ne instanceof Element))) {
              var fe = this.props.insertExtraNode, Ee = this.getAttributeName();
              ne.setAttribute(Ee, "false"), JE && (JE.innerHTML = ""), fe && this.extraNode && ne.contains(this.extraNode) && ne.removeChild(this.extraNode), ["transition", "animation"].forEach(function(Oe) {
                ne.removeEventListener("".concat(Oe, "start"), re.onTransitionStart), ne.removeEventListener("".concat(Oe, "end"), re.onTransitionEnd);
              });
            }
          } }, { key: "render", value: function() {
            return De.createElement(wf, null, this.renderWave);
          } }]), Q;
        }(De.Component);
        nC.contextType = z0;
        var QE = { exports: {} }, V1 = {};
        /** @license React v17.0.2
        * react-jsx-runtime.production.min.js
        *
        * Copyright (c) Facebook, Inc. and its affiliates.
        *
        * This source code is licensed under the MIT license found in the
        * LICENSE file in the root directory of this source tree.
        */
        var fP = Le.default, eI = 60103;
        if (V1.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
          var tI = Symbol.for;
          eI = tI("react.element"), V1.Fragment = tI("react.fragment");
        }
        var rC = fP.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, oF = Object.prototype.hasOwnProperty, hP = { key: true, ref: true, __self: true, __source: true };
        function nI(Y, ge, Q) {
          var ne, re = {}, fe = null, Ee = null;
          Q !== void 0 && (fe = "" + Q), ge.key !== void 0 && (fe = "" + ge.key), ge.ref !== void 0 && (Ee = ge.ref);
          for (ne in ge)
            oF.call(ge, ne) && !hP.hasOwnProperty(ne) && (re[ne] = ge[ne]);
          if (Y && Y.defaultProps)
            for (ne in ge = Y.defaultProps, ge)
              re[ne] === void 0 && (re[ne] = ge[ne]);
          return { $$typeof: eI, type: Y, key: fe, ref: Ee, props: re, _owner: rC.current };
        }
        V1.jsx = nI, V1.jsxs = nI, QE.exports = V1;
        const m_ = QE.exports.jsx, dP = QE.exports.jsxs;
        var sF = te.createContext({}), aC = sF, k10 = function() {
          return xE() && window.document.documentElement;
        }, z10, oe = function() {
          if (!k10())
            return false;
          if (z10 !== void 0)
            return z10;
          var Y = document.createElement("div");
          return Y.style.display = "flex", Y.style.flexDirection = "column", Y.style.rowGap = "1px", Y.appendChild(document.createElement("div")), Y.appendChild(document.createElement("div")), document.body.appendChild(Y), z10 = Y.scrollHeight === 1, document.body.removeChild(Y), z10;
        }, Se = function() {
          var Y = De.useState(false), ge = cn(Y, 2), Q = ge[0], ne = ge[1];
          return De.useEffect(function() {
            ne(oe());
          }, []), Q;
        }, Ge = globalThis && globalThis.__rest || function(Y, ge) {
          var Q = {};
          for (var ne in Y)
            Object.prototype.hasOwnProperty.call(Y, ne) && ge.indexOf(ne) < 0 && (Q[ne] = Y[ne]);
          if (Y != null && typeof Object.getOwnPropertySymbols == "function")
            for (var re = 0, ne = Object.getOwnPropertySymbols(Y); re < ne.length; re++)
              ge.indexOf(ne[re]) < 0 && Object.prototype.propertyIsEnumerable.call(Y, ne[re]) && (Q[ne[re]] = Y[ne[re]]);
          return Q;
        };
        sP("top", "middle", "bottom", "stretch"), sP("start", "end", "center", "space-around", "space-between");
        var vt = De.forwardRef(function(Y, ge) {
          var Q, ne = Y.prefixCls, re = Y.justify, fe = Y.align, Ee = Y.className, Oe = Y.style, Be = Y.children, Ze = Y.gutter, Je = Ze === void 0 ? 0 : Ze, yt = Y.wrap, Gt = Ge(Y, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Xt = De.useContext(z0), Zt = Xt.getPrefixCls, un = Xt.direction, yn = De.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), _r = cn(yn, 2), cr = _r[0], fa = _r[1], We = Se(), pn = De.useRef(Je);
          De.useEffect(function() {
            var xr = lP.subscribe(function(Xn) {
              var Kn = pn.current || 0;
              (!Array.isArray(Kn) && _o(Kn) === "object" || Array.isArray(Kn) && (_o(Kn[0]) === "object" || _o(Kn[1]) === "object")) && fa(Xn);
            });
            return function() {
              return lP.unsubscribe(xr);
            };
          }, []);
          var zn = function() {
            var xr = [0, 0], Xn = Array.isArray(Je) ? Je : [Je, 0];
            return Xn.forEach(function(Kn, ba) {
              if (_o(Kn) === "object")
                for (var la = 0; la < R1.length; la++) {
                  var Xi = R1[la];
                  if (cr[Xi] && Kn[Xi] !== void 0) {
                    xr[ba] = Kn[Xi];
                    break;
                  }
                }
              else
                xr[ba] = Kn || 0;
            }), xr;
          }, pr = Zt("row", ne), fr = zn(), Tn = Fo(pr, (Q = {}, St(Q, "".concat(pr, "-no-wrap"), yt === false), St(Q, "".concat(pr, "-").concat(re), re), St(Q, "".concat(pr, "-").concat(fe), fe), St(Q, "".concat(pr, "-rtl"), un === "rtl"), Q), Ee), Gn = {}, Tr = fr[0] > 0 ? fr[0] / -2 : void 0, ra = fr[1] > 0 ? fr[1] / -2 : void 0;
          if (Tr && (Gn.marginLeft = Tr, Gn.marginRight = Tr), We) {
            var wn = cn(fr, 2);
            Gn.rowGap = wn[1];
          } else
            ra && (Gn.marginTop = ra, Gn.marginBottom = ra);
          var Ka = cn(fr, 2), Ya = Ka[0], vr = Ka[1], Pi = De.useMemo(function() {
            return { gutter: [Ya, vr], wrap: yt, supportFlexGap: We };
          }, [Ya, vr, yt, We]);
          return De.createElement(aC.Provider, { value: Pi }, De.createElement("div", ko({}, Gt, { className: Tn, style: ko(ko({}, Gn), Oe), ref: ge }), Be));
        });
        vt.displayName = "Row";
        var Ht = vt, Kt = globalThis && globalThis.__rest || function(Y, ge) {
          var Q = {};
          for (var ne in Y)
            Object.prototype.hasOwnProperty.call(Y, ne) && ge.indexOf(ne) < 0 && (Q[ne] = Y[ne]);
          if (Y != null && typeof Object.getOwnPropertySymbols == "function")
            for (var re = 0, ne = Object.getOwnPropertySymbols(Y); re < ne.length; re++)
              ge.indexOf(ne[re]) < 0 && Object.prototype.propertyIsEnumerable.call(Y, ne[re]) && (Q[ne[re]] = Y[ne[re]]);
          return Q;
        };
        function xn(Y) {
          return typeof Y == "number" ? "".concat(Y, " ").concat(Y, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(Y) ? "0 0 ".concat(Y) : Y;
        }
        var Gr = ["xs", "sm", "md", "lg", "xl", "xxl"], Wr = De.forwardRef(function(Y, ge) {
          var Q, ne = De.useContext(z0), re = ne.getPrefixCls, fe = ne.direction, Ee = De.useContext(aC), Oe = Ee.gutter, Be = Ee.wrap, Ze = Ee.supportFlexGap, Je = Y.prefixCls, yt = Y.span, Gt = Y.order, Xt = Y.offset, Zt = Y.push, un = Y.pull, yn = Y.className, _r = Y.children, cr = Y.flex, fa = Y.style, We = Kt(Y, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), pn = re("col", Je), zn = {};
          Gr.forEach(function(Tr) {
            var ra, wn = {}, Ka = Y[Tr];
            typeof Ka == "number" ? wn.span = Ka : _o(Ka) === "object" && (wn = Ka || {}), delete We[Tr], zn = ko(ko({}, zn), (ra = {}, St(ra, "".concat(pn, "-").concat(Tr, "-").concat(wn.span), wn.span !== void 0), St(ra, "".concat(pn, "-").concat(Tr, "-order-").concat(wn.order), wn.order || wn.order === 0), St(ra, "".concat(pn, "-").concat(Tr, "-offset-").concat(wn.offset), wn.offset || wn.offset === 0), St(ra, "".concat(pn, "-").concat(Tr, "-push-").concat(wn.push), wn.push || wn.push === 0), St(ra, "".concat(pn, "-").concat(Tr, "-pull-").concat(wn.pull), wn.pull || wn.pull === 0), St(ra, "".concat(pn, "-rtl"), fe === "rtl"), ra));
          });
          var pr = Fo(pn, (Q = {}, St(Q, "".concat(pn, "-").concat(yt), yt !== void 0), St(Q, "".concat(pn, "-order-").concat(Gt), Gt), St(Q, "".concat(pn, "-offset-").concat(Xt), Xt), St(Q, "".concat(pn, "-push-").concat(Zt), Zt), St(Q, "".concat(pn, "-pull-").concat(un), un), Q), yn, zn), fr = {};
          if (Oe && Oe[0] > 0) {
            var Tn = Oe[0] / 2;
            fr.paddingLeft = Tn, fr.paddingRight = Tn;
          }
          if (Oe && Oe[1] > 0 && !Ze) {
            var Gn = Oe[1] / 2;
            fr.paddingTop = Gn, fr.paddingBottom = Gn;
          }
          return cr && (fr.flex = xn(cr), Be === false && !fr.minWidth && (fr.minWidth = 0)), De.createElement("div", ko({}, We, { style: ko(ko({}, fr), fa), className: pr, ref: ge }), _r);
        });
        Wr.displayName = "Col";
        var Ur = Wr, Ba = De.forwardRef(function(Y, ge) {
          var Q, ne = Y.prefixCls, re = ne === void 0 ? "rc-switch" : ne, fe = Y.className, Ee = Y.checked, Oe = Y.defaultChecked, Be = Y.disabled, Ze = Y.loadingIcon, Je = Y.checkedChildren, yt = Y.unCheckedChildren, Gt = Y.onClick, Xt = Y.onChange, Zt = Y.onKeyDown, un = ni(Y, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), yn = qE(false, { value: Ee, defaultValue: Oe }), _r = cn(yn, 2), cr = _r[0], fa = _r[1];
          function We(fr, Tn) {
            var Gn = cr;
            return Be || (Gn = fr, fa(Gn), Xt == null || Xt(Gn, Tn)), Gn;
          }
          function pn(fr) {
            fr.which === Gi.LEFT ? We(false, fr) : fr.which === Gi.RIGHT && We(true, fr), Zt == null || Zt(fr);
          }
          function zn(fr) {
            var Tn = We(!cr, fr);
            Gt == null || Gt(Tn, fr);
          }
          var pr = Fo(re, fe, (Q = {}, St(Q, "".concat(re, "-checked"), cr), St(Q, "".concat(re, "-disabled"), Be), Q));
          return De.createElement("button", Object.assign({}, un, { type: "button", role: "switch", "aria-checked": cr, disabled: Be, className: pr, ref: ge, onKeyDown: pn, onClick: zn }), Ze, De.createElement("span", { className: "".concat(re, "-inner") }, cr ? Je : yt));
        });
        Ba.displayName = "Switch";
        var vi = globalThis && globalThis.__rest || function(Y, ge) {
          var Q = {};
          for (var ne in Y)
            Object.prototype.hasOwnProperty.call(Y, ne) && ge.indexOf(ne) < 0 && (Q[ne] = Y[ne]);
          if (Y != null && typeof Object.getOwnPropertySymbols == "function")
            for (var re = 0, ne = Object.getOwnPropertySymbols(Y); re < ne.length; re++)
              ge.indexOf(ne[re]) < 0 && Object.prototype.propertyIsEnumerable.call(Y, ne[re]) && (Q[ne[re]] = Y[ne[re]]);
          return Q;
        }, Ni = De.forwardRef(function(Y, ge) {
          var Q, ne = Y.prefixCls, re = Y.size, fe = Y.loading, Ee = Y.className, Oe = Ee === void 0 ? "" : Ee, Be = Y.disabled, Ze = vi(Y, ["prefixCls", "size", "loading", "className", "disabled"]);
          J6("checked" in Ze || !("value" in Ze), "Switch", "`value` is not a valid prop, do you mean `checked`?");
          var Je = De.useContext(z0), yt = Je.getPrefixCls, Gt = Je.direction, Xt = De.useContext(Gh), Zt = yt("switch", ne), un = De.createElement("div", { className: "".concat(Zt, "-handle") }, fe && De.createElement(AE, { className: "".concat(Zt, "-loading-icon") })), yn = Fo((Q = {}, St(Q, "".concat(Zt, "-small"), (re || Xt) === "small"), St(Q, "".concat(Zt, "-loading"), fe), St(Q, "".concat(Zt, "-rtl"), Gt === "rtl"), Q), Oe);
          return De.createElement(nC, { insertExtraNode: true }, De.createElement(Ba, ko({}, Ze, { prefixCls: Zt, className: yn, disabled: Be || fe, ref: ge, loadingIcon: un })));
        });
        Ni.__ANT_SWITCH = true, Ni.displayName = "Switch";
        var $o = Ni, Hi = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, Zi = { exports: {} };
        (function(Y, ge) {
          (function(Q, ne) {
            Y.exports = ne(Le.default);
          })(pt, function(Q) {
            return function(ne) {
              var re = {};
              function fe(Ee) {
                if (re[Ee])
                  return re[Ee].exports;
                var Oe = re[Ee] = { i: Ee, l: false, exports: {} };
                return ne[Ee].call(Oe.exports, Oe, Oe.exports, fe), Oe.l = true, Oe.exports;
              }
              return fe.m = ne, fe.c = re, fe.d = function(Ee, Oe, Be) {
                fe.o(Ee, Oe) || Object.defineProperty(Ee, Oe, { enumerable: true, get: Be });
              }, fe.r = function(Ee) {
                typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(Ee, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(Ee, "__esModule", { value: true });
              }, fe.t = function(Ee, Oe) {
                if (1 & Oe && (Ee = fe(Ee)), 8 & Oe || 4 & Oe && typeof Ee == "object" && Ee && Ee.__esModule)
                  return Ee;
                var Be = /* @__PURE__ */ Object.create(null);
                if (fe.r(Be), Object.defineProperty(Be, "default", { enumerable: true, value: Ee }), 2 & Oe && typeof Ee != "string")
                  for (var Ze in Ee)
                    fe.d(Be, Ze, function(Je) {
                      return Ee[Je];
                    }.bind(null, Ze));
                return Be;
              }, fe.n = function(Ee) {
                var Oe = Ee && Ee.__esModule ? function() {
                  return Ee.default;
                } : function() {
                  return Ee;
                };
                return fe.d(Oe, "a", Oe), Oe;
              }, fe.o = function(Ee, Oe) {
                return Object.prototype.hasOwnProperty.call(Ee, Oe);
              }, fe.p = "", fe(fe.s = 48);
            }([function(ne, re) {
              ne.exports = Q;
            }, function(ne, re) {
              var fe = ne.exports = { version: "2.6.12" };
              typeof __e == "number" && (__e = fe);
            }, function(ne, re, fe) {
              var Ee = fe(26)("wks"), Oe = fe(17), Be = fe(3).Symbol, Ze = typeof Be == "function";
              (ne.exports = function(Je) {
                return Ee[Je] || (Ee[Je] = Ze && Be[Je] || (Ze ? Be : Oe)("Symbol." + Je));
              }).store = Ee;
            }, function(ne, re) {
              var fe = ne.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
              typeof __g == "number" && (__g = fe);
            }, function(ne, re, fe) {
              ne.exports = !fe(8)(function() {
                return Object.defineProperty({}, "a", { get: function() {
                  return 7;
                } }).a != 7;
              });
            }, function(ne, re) {
              var fe = {}.hasOwnProperty;
              ne.exports = function(Ee, Oe) {
                return fe.call(Ee, Oe);
              };
            }, function(ne, re, fe) {
              var Ee = fe(7), Oe = fe(16);
              ne.exports = fe(4) ? function(Be, Ze, Je) {
                return Ee.f(Be, Ze, Oe(1, Je));
              } : function(Be, Ze, Je) {
                return Be[Ze] = Je, Be;
              };
            }, function(ne, re, fe) {
              var Ee = fe(10), Oe = fe(35), Be = fe(23), Ze = Object.defineProperty;
              re.f = fe(4) ? Object.defineProperty : function(Je, yt, Gt) {
                if (Ee(Je), yt = Be(yt, true), Ee(Gt), Oe)
                  try {
                    return Ze(Je, yt, Gt);
                  } catch {
                  }
                if ("get" in Gt || "set" in Gt)
                  throw TypeError("Accessors not supported!");
                return "value" in Gt && (Je[yt] = Gt.value), Je;
              };
            }, function(ne, re) {
              ne.exports = function(fe) {
                try {
                  return !!fe();
                } catch {
                  return true;
                }
              };
            }, function(ne, re, fe) {
              var Ee = fe(40), Oe = fe(22);
              ne.exports = function(Be) {
                return Ee(Oe(Be));
              };
            }, function(ne, re, fe) {
              var Ee = fe(11);
              ne.exports = function(Oe) {
                if (!Ee(Oe))
                  throw TypeError(Oe + " is not an object!");
                return Oe;
              };
            }, function(ne, re) {
              ne.exports = function(fe) {
                return typeof fe == "object" ? fe !== null : typeof fe == "function";
              };
            }, function(ne, re) {
              ne.exports = {};
            }, function(ne, re, fe) {
              var Ee = fe(39), Oe = fe(27);
              ne.exports = Object.keys || function(Be) {
                return Ee(Be, Oe);
              };
            }, function(ne, re) {
              ne.exports = true;
            }, function(ne, re, fe) {
              var Ee = fe(3), Oe = fe(1), Be = fe(53), Ze = fe(6), Je = fe(5), yt = function(Gt, Xt, Zt) {
                var un, yn, _r, cr = Gt & yt.F, fa = Gt & yt.G, We = Gt & yt.S, pn = Gt & yt.P, zn = Gt & yt.B, pr = Gt & yt.W, fr = fa ? Oe : Oe[Xt] || (Oe[Xt] = {}), Tn = fr.prototype, Gn = fa ? Ee : We ? Ee[Xt] : (Ee[Xt] || {}).prototype;
                for (un in fa && (Zt = Xt), Zt)
                  (yn = !cr && Gn && Gn[un] !== void 0) && Je(fr, un) || (_r = yn ? Gn[un] : Zt[un], fr[un] = fa && typeof Gn[un] != "function" ? Zt[un] : zn && yn ? Be(_r, Ee) : pr && Gn[un] == _r ? function(Tr) {
                    var ra = function(wn, Ka, Ya) {
                      if (this instanceof Tr) {
                        switch (arguments.length) {
                          case 0:
                            return new Tr();
                          case 1:
                            return new Tr(wn);
                          case 2:
                            return new Tr(wn, Ka);
                        }
                        return new Tr(wn, Ka, Ya);
                      }
                      return Tr.apply(this, arguments);
                    };
                    return ra.prototype = Tr.prototype, ra;
                  }(_r) : pn && typeof _r == "function" ? Be(Function.call, _r) : _r, pn && ((fr.virtual || (fr.virtual = {}))[un] = _r, Gt & yt.R && Tn && !Tn[un] && Ze(Tn, un, _r)));
              };
              yt.F = 1, yt.G = 2, yt.S = 4, yt.P = 8, yt.B = 16, yt.W = 32, yt.U = 64, yt.R = 128, ne.exports = yt;
            }, function(ne, re) {
              ne.exports = function(fe, Ee) {
                return { enumerable: !(1 & fe), configurable: !(2 & fe), writable: !(4 & fe), value: Ee };
              };
            }, function(ne, re) {
              var fe = 0, Ee = Math.random();
              ne.exports = function(Oe) {
                return "Symbol(".concat(Oe === void 0 ? "" : Oe, ")_", (++fe + Ee).toString(36));
              };
            }, function(ne, re, fe) {
              var Ee = fe(22);
              ne.exports = function(Oe) {
                return Object(Ee(Oe));
              };
            }, function(ne, re) {
              re.f = {}.propertyIsEnumerable;
            }, function(ne, re, fe) {
              var Ee = fe(52)(true);
              fe(34)(String, "String", function(Oe) {
                this._t = String(Oe), this._i = 0;
              }, function() {
                var Oe, Be = this._t, Ze = this._i;
                return Ze >= Be.length ? { value: void 0, done: true } : (Oe = Ee(Be, Ze), this._i += Oe.length, { value: Oe, done: false });
              });
            }, function(ne, re) {
              var fe = Math.ceil, Ee = Math.floor;
              ne.exports = function(Oe) {
                return isNaN(Oe = +Oe) ? 0 : (Oe > 0 ? Ee : fe)(Oe);
              };
            }, function(ne, re) {
              ne.exports = function(fe) {
                if (fe == null)
                  throw TypeError("Can't call method on  " + fe);
                return fe;
              };
            }, function(ne, re, fe) {
              var Ee = fe(11);
              ne.exports = function(Oe, Be) {
                if (!Ee(Oe))
                  return Oe;
                var Ze, Je;
                if (Be && typeof (Ze = Oe.toString) == "function" && !Ee(Je = Ze.call(Oe)) || typeof (Ze = Oe.valueOf) == "function" && !Ee(Je = Ze.call(Oe)) || !Be && typeof (Ze = Oe.toString) == "function" && !Ee(Je = Ze.call(Oe)))
                  return Je;
                throw TypeError("Can't convert object to primitive value");
              };
            }, function(ne, re) {
              var fe = {}.toString;
              ne.exports = function(Ee) {
                return fe.call(Ee).slice(8, -1);
              };
            }, function(ne, re, fe) {
              var Ee = fe(26)("keys"), Oe = fe(17);
              ne.exports = function(Be) {
                return Ee[Be] || (Ee[Be] = Oe(Be));
              };
            }, function(ne, re, fe) {
              var Ee = fe(1), Oe = fe(3), Be = Oe["__core-js_shared__"] || (Oe["__core-js_shared__"] = {});
              (ne.exports = function(Ze, Je) {
                return Be[Ze] || (Be[Ze] = Je !== void 0 ? Je : {});
              })("versions", []).push({ version: Ee.version, mode: fe(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
            }, function(ne, re) {
              ne.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
            }, function(ne, re, fe) {
              var Ee = fe(7).f, Oe = fe(5), Be = fe(2)("toStringTag");
              ne.exports = function(Ze, Je, yt) {
                Ze && !Oe(Ze = yt ? Ze : Ze.prototype, Be) && Ee(Ze, Be, { configurable: true, value: Je });
              };
            }, function(ne, re, fe) {
              fe(62);
              for (var Ee = fe(3), Oe = fe(6), Be = fe(12), Ze = fe(2)("toStringTag"), Je = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), yt = 0; yt < Je.length; yt++) {
                var Gt = Je[yt], Xt = Ee[Gt], Zt = Xt && Xt.prototype;
                Zt && !Zt[Ze] && Oe(Zt, Ze, Gt), Be[Gt] = Be.Array;
              }
            }, function(ne, re, fe) {
              re.f = fe(2);
            }, function(ne, re, fe) {
              var Ee = fe(3), Oe = fe(1), Be = fe(14), Ze = fe(30), Je = fe(7).f;
              ne.exports = function(yt) {
                var Gt = Oe.Symbol || (Oe.Symbol = Be ? {} : Ee.Symbol || {});
                yt.charAt(0) == "_" || yt in Gt || Je(Gt, yt, { value: Ze.f(yt) });
              };
            }, function(ne, re) {
              re.f = Object.getOwnPropertySymbols;
            }, function(ne, re) {
              ne.exports = function(fe, Ee, Oe) {
                return Math.min(Math.max(fe, Ee), Oe);
              };
            }, function(ne, re, fe) {
              var Ee = fe(14), Oe = fe(15), Be = fe(37), Ze = fe(6), Je = fe(12), yt = fe(55), Gt = fe(28), Xt = fe(61), Zt = fe(2)("iterator"), un = !([].keys && "next" in [].keys()), yn = function() {
                return this;
              };
              ne.exports = function(_r, cr, fa, We, pn, zn, pr) {
                yt(fa, cr, We);
                var fr, Tn, Gn, Tr = function(Kn) {
                  if (!un && Kn in Ya)
                    return Ya[Kn];
                  switch (Kn) {
                    case "keys":
                    case "values":
                      return function() {
                        return new fa(this, Kn);
                      };
                  }
                  return function() {
                    return new fa(this, Kn);
                  };
                }, ra = cr + " Iterator", wn = pn == "values", Ka = false, Ya = _r.prototype, vr = Ya[Zt] || Ya["@@iterator"] || pn && Ya[pn], Pi = vr || Tr(pn), xr = pn ? wn ? Tr("entries") : Pi : void 0, Xn = cr == "Array" && Ya.entries || vr;
                if (Xn && (Gn = Xt(Xn.call(new _r()))) !== Object.prototype && Gn.next && (Gt(Gn, ra, true), Ee || typeof Gn[Zt] == "function" || Ze(Gn, Zt, yn)), wn && vr && vr.name !== "values" && (Ka = true, Pi = function() {
                  return vr.call(this);
                }), Ee && !pr || !un && !Ka && Ya[Zt] || Ze(Ya, Zt, Pi), Je[cr] = Pi, Je[ra] = yn, pn)
                  if (fr = { values: wn ? Pi : Tr("values"), keys: zn ? Pi : Tr("keys"), entries: xr }, pr)
                    for (Tn in fr)
                      Tn in Ya || Be(Ya, Tn, fr[Tn]);
                  else
                    Oe(Oe.P + Oe.F * (un || Ka), cr, fr);
                return fr;
              };
            }, function(ne, re, fe) {
              ne.exports = !fe(4) && !fe(8)(function() {
                return Object.defineProperty(fe(36)("div"), "a", { get: function() {
                  return 7;
                } }).a != 7;
              });
            }, function(ne, re, fe) {
              var Ee = fe(11), Oe = fe(3).document, Be = Ee(Oe) && Ee(Oe.createElement);
              ne.exports = function(Ze) {
                return Be ? Oe.createElement(Ze) : {};
              };
            }, function(ne, re, fe) {
              ne.exports = fe(6);
            }, function(ne, re, fe) {
              var Ee = fe(10), Oe = fe(56), Be = fe(27), Ze = fe(25)("IE_PROTO"), Je = function() {
              }, yt = function() {
                var Gt, Xt = fe(36)("iframe"), Zt = Be.length;
                for (Xt.style.display = "none", fe(60).appendChild(Xt), Xt.src = "javascript:", (Gt = Xt.contentWindow.document).open(), Gt.write("<script>document.F=Object<\/script>"), Gt.close(), yt = Gt.F; Zt--; )
                  delete yt.prototype[Be[Zt]];
                return yt();
              };
              ne.exports = Object.create || function(Gt, Xt) {
                var Zt;
                return Gt !== null ? (Je.prototype = Ee(Gt), Zt = new Je(), Je.prototype = null, Zt[Ze] = Gt) : Zt = yt(), Xt === void 0 ? Zt : Oe(Zt, Xt);
              };
            }, function(ne, re, fe) {
              var Ee = fe(5), Oe = fe(9), Be = fe(57)(false), Ze = fe(25)("IE_PROTO");
              ne.exports = function(Je, yt) {
                var Gt, Xt = Oe(Je), Zt = 0, un = [];
                for (Gt in Xt)
                  Gt != Ze && Ee(Xt, Gt) && un.push(Gt);
                for (; yt.length > Zt; )
                  Ee(Xt, Gt = yt[Zt++]) && (~Be(un, Gt) || un.push(Gt));
                return un;
              };
            }, function(ne, re, fe) {
              var Ee = fe(24);
              ne.exports = Object("z").propertyIsEnumerable(0) ? Object : function(Oe) {
                return Ee(Oe) == "String" ? Oe.split("") : Object(Oe);
              };
            }, function(ne, re, fe) {
              var Ee = fe(39), Oe = fe(27).concat("length", "prototype");
              re.f = Object.getOwnPropertyNames || function(Be) {
                return Ee(Be, Oe);
              };
            }, function(ne, re, fe) {
              var Ee = fe(24), Oe = fe(2)("toStringTag"), Be = Ee(function() {
                return arguments;
              }()) == "Arguments";
              ne.exports = function(Ze) {
                var Je, yt, Gt;
                return Ze === void 0 ? "Undefined" : Ze === null ? "Null" : typeof (yt = function(Xt, Zt) {
                  try {
                    return Xt[Zt];
                  } catch {
                  }
                }(Je = Object(Ze), Oe)) == "string" ? yt : Be ? Ee(Je) : (Gt = Ee(Je)) == "Object" && typeof Je.callee == "function" ? "Arguments" : Gt;
              };
            }, function(ne, re) {
              var fe;
              fe = function() {
                return this;
              }();
              try {
                fe = fe || new Function("return this")();
              } catch {
                typeof window == "object" && (fe = window);
              }
              ne.exports = fe;
            }, function(ne, re) {
              var fe = /-?\d+(\.\d+)?%?/g;
              ne.exports = function(Ee) {
                return Ee.match(fe);
              };
            }, function(ne, re, fe) {
              Object.defineProperty(re, "__esModule", { value: true }), re.getBase16Theme = re.createStyling = re.invertTheme = void 0;
              var Ee = yn(fe(49)), Oe = yn(fe(76)), Be = yn(fe(81)), Ze = yn(fe(89)), Je = yn(fe(93)), yt = function(Tn) {
                if (Tn && Tn.__esModule)
                  return Tn;
                var Gn = {};
                if (Tn != null)
                  for (var Tr in Tn)
                    Object.prototype.hasOwnProperty.call(Tn, Tr) && (Gn[Tr] = Tn[Tr]);
                return Gn.default = Tn, Gn;
              }(fe(94)), Gt = yn(fe(132)), Xt = yn(fe(133)), Zt = yn(fe(138)), un = fe(139);
              function yn(Tn) {
                return Tn && Tn.__esModule ? Tn : { default: Tn };
              }
              var _r = yt.default, cr = (0, Ze.default)(_r), fa = (0, Zt.default)(Xt.default, un.rgb2yuv, function(Tn) {
                var Gn, Tr = (0, Be.default)(Tn, 3), ra = Tr[0], wn = Tr[1], Ka = Tr[2];
                return [(Gn = ra, Gn < 0.25 ? 1 : Gn < 0.5 ? 0.9 - Gn : 1.1 - Gn), wn, Ka];
              }, un.yuv2rgb, Gt.default), We = function(Tn) {
                return function(Gn) {
                  return { className: [Gn.className, Tn.className].filter(Boolean).join(" "), style: (0, Oe.default)({}, Gn.style || {}, Tn.style || {}) };
                };
              }, pn = function(Tn, Gn) {
                var Tr = (0, Ze.default)(Gn);
                for (var ra in Tn)
                  Tr.indexOf(ra) === -1 && Tr.push(ra);
                return Tr.reduce(function(wn, Ka) {
                  return wn[Ka] = function(Ya, vr) {
                    if (Ya === void 0)
                      return vr;
                    if (vr === void 0)
                      return Ya;
                    var Pi = Ya === void 0 ? "undefined" : (0, Ee.default)(Ya), xr = vr === void 0 ? "undefined" : (0, Ee.default)(vr);
                    switch (Pi) {
                      case "string":
                        switch (xr) {
                          case "string":
                            return [vr, Ya].filter(Boolean).join(" ");
                          case "object":
                            return We({ className: Ya, style: vr });
                          case "function":
                            return function(Xn) {
                              for (var Kn = arguments.length, ba = Array(Kn > 1 ? Kn - 1 : 0), la = 1; la < Kn; la++)
                                ba[la - 1] = arguments[la];
                              return We({ className: Ya })(vr.apply(void 0, [Xn].concat(ba)));
                            };
                        }
                      case "object":
                        switch (xr) {
                          case "string":
                            return We({ className: vr, style: Ya });
                          case "object":
                            return (0, Oe.default)({}, vr, Ya);
                          case "function":
                            return function(Xn) {
                              for (var Kn = arguments.length, ba = Array(Kn > 1 ? Kn - 1 : 0), la = 1; la < Kn; la++)
                                ba[la - 1] = arguments[la];
                              return We({ style: Ya })(vr.apply(void 0, [Xn].concat(ba)));
                            };
                        }
                      case "function":
                        switch (xr) {
                          case "string":
                            return function(Xn) {
                              for (var Kn = arguments.length, ba = Array(Kn > 1 ? Kn - 1 : 0), la = 1; la < Kn; la++)
                                ba[la - 1] = arguments[la];
                              return Ya.apply(void 0, [We(Xn)({ className: vr })].concat(ba));
                            };
                          case "object":
                            return function(Xn) {
                              for (var Kn = arguments.length, ba = Array(Kn > 1 ? Kn - 1 : 0), la = 1; la < Kn; la++)
                                ba[la - 1] = arguments[la];
                              return Ya.apply(void 0, [We(Xn)({ style: vr })].concat(ba));
                            };
                          case "function":
                            return function(Xn) {
                              for (var Kn = arguments.length, ba = Array(Kn > 1 ? Kn - 1 : 0), la = 1; la < Kn; la++)
                                ba[la - 1] = arguments[la];
                              return Ya.apply(void 0, [vr.apply(void 0, [Xn].concat(ba))].concat(ba));
                            };
                        }
                    }
                  }(Tn[Ka], Gn[Ka]), wn;
                }, {});
              }, zn = function(Tn, Gn) {
                for (var Tr = arguments.length, ra = Array(Tr > 2 ? Tr - 2 : 0), wn = 2; wn < Tr; wn++)
                  ra[wn - 2] = arguments[wn];
                if (Gn === null)
                  return Tn;
                Array.isArray(Gn) || (Gn = [Gn]);
                var Ka = Gn.map(function(vr) {
                  return Tn[vr];
                }).filter(Boolean), Ya = Ka.reduce(function(vr, Pi) {
                  return typeof Pi == "string" ? vr.className = [vr.className, Pi].filter(Boolean).join(" ") : (Pi === void 0 ? "undefined" : (0, Ee.default)(Pi)) === "object" ? vr.style = (0, Oe.default)({}, vr.style, Pi) : typeof Pi == "function" && (vr = (0, Oe.default)({}, vr, Pi.apply(void 0, [vr].concat(ra)))), vr;
                }, { className: "", style: {} });
                return Ya.className || delete Ya.className, (0, Ze.default)(Ya.style).length === 0 && delete Ya.style, Ya;
              }, pr = re.invertTheme = function(Tn) {
                return (0, Ze.default)(Tn).reduce(function(Gn, Tr) {
                  return Gn[Tr] = /^base/.test(Tr) ? fa(Tn[Tr]) : Tr === "scheme" ? Tn[Tr] + ":inverted" : Tn[Tr], Gn;
                }, {});
              }, fr = (re.createStyling = (0, Je.default)(function(Tn) {
                for (var Gn = arguments.length, Tr = Array(Gn > 3 ? Gn - 3 : 0), ra = 3; ra < Gn; ra++)
                  Tr[ra - 3] = arguments[ra];
                var wn = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ka = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Ya = wn.defaultBase16, vr = Ya === void 0 ? _r : Ya, Pi = wn.base16Themes, xr = Pi === void 0 ? null : Pi, Xn = fr(Ka, xr);
                Xn && (Ka = (0, Oe.default)({}, Xn, Ka));
                var Kn = cr.reduce(function(Ys, Ss) {
                  return Ys[Ss] = Ka[Ss] || vr[Ss], Ys;
                }, {}), ba = (0, Ze.default)(Ka).reduce(function(Ys, Ss) {
                  return cr.indexOf(Ss) === -1 && (Ys[Ss] = Ka[Ss]), Ys;
                }, {}), la = Tn(Kn), Xi = pn(ba, la);
                return (0, Je.default)(zn, 2).apply(void 0, [Xi].concat(Tr));
              }, 3), re.getBase16Theme = function(Tn, Gn) {
                if (Tn && Tn.extend && (Tn = Tn.extend), typeof Tn == "string") {
                  var Tr = Tn.split(":"), ra = (0, Be.default)(Tr, 2), wn = ra[0], Ka = ra[1];
                  Tn = (Gn || {})[wn] || yt[wn], Ka === "inverted" && (Tn = pr(Tn));
                }
                return Tn && Tn.hasOwnProperty("base00") ? Tn : void 0;
              });
            }, function(ne, re, fe) {
              var Ee, Oe = typeof Reflect == "object" ? Reflect : null, Be = Oe && typeof Oe.apply == "function" ? Oe.apply : function(We, pn, zn) {
                return Function.prototype.apply.call(We, pn, zn);
              };
              Ee = Oe && typeof Oe.ownKeys == "function" ? Oe.ownKeys : Object.getOwnPropertySymbols ? function(We) {
                return Object.getOwnPropertyNames(We).concat(Object.getOwnPropertySymbols(We));
              } : function(We) {
                return Object.getOwnPropertyNames(We);
              };
              var Ze = Number.isNaN || function(We) {
                return We != We;
              };
              function Je() {
                Je.init.call(this);
              }
              ne.exports = Je, ne.exports.once = function(We, pn) {
                return new Promise(function(zn, pr) {
                  function fr() {
                    Tn !== void 0 && We.removeListener("error", Tn), zn([].slice.call(arguments));
                  }
                  var Tn;
                  pn !== "error" && (Tn = function(Gn) {
                    We.removeListener(pn, fr), pr(Gn);
                  }, We.once("error", Tn)), We.once(pn, fr);
                });
              }, Je.EventEmitter = Je, Je.prototype._events = void 0, Je.prototype._eventsCount = 0, Je.prototype._maxListeners = void 0;
              var yt = 10;
              function Gt(We) {
                if (typeof We != "function")
                  throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof We);
              }
              function Xt(We) {
                return We._maxListeners === void 0 ? Je.defaultMaxListeners : We._maxListeners;
              }
              function Zt(We, pn, zn, pr) {
                var fr, Tn, Gn, Tr;
                if (Gt(zn), (Tn = We._events) === void 0 ? (Tn = We._events = /* @__PURE__ */ Object.create(null), We._eventsCount = 0) : (Tn.newListener !== void 0 && (We.emit("newListener", pn, zn.listener ? zn.listener : zn), Tn = We._events), Gn = Tn[pn]), Gn === void 0)
                  Gn = Tn[pn] = zn, ++We._eventsCount;
                else if (typeof Gn == "function" ? Gn = Tn[pn] = pr ? [zn, Gn] : [Gn, zn] : pr ? Gn.unshift(zn) : Gn.push(zn), (fr = Xt(We)) > 0 && Gn.length > fr && !Gn.warned) {
                  Gn.warned = true;
                  var ra = new Error("Possible EventEmitter memory leak detected. " + Gn.length + " " + String(pn) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                  ra.name = "MaxListenersExceededWarning", ra.emitter = We, ra.type = pn, ra.count = Gn.length, Tr = ra, console && console.warn && console.warn(Tr);
                }
                return We;
              }
              function un() {
                if (!this.fired)
                  return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
              }
              function yn(We, pn, zn) {
                var pr = { fired: false, wrapFn: void 0, target: We, type: pn, listener: zn }, fr = un.bind(pr);
                return fr.listener = zn, pr.wrapFn = fr, fr;
              }
              function _r(We, pn, zn) {
                var pr = We._events;
                if (pr === void 0)
                  return [];
                var fr = pr[pn];
                return fr === void 0 ? [] : typeof fr == "function" ? zn ? [fr.listener || fr] : [fr] : zn ? function(Tn) {
                  for (var Gn = new Array(Tn.length), Tr = 0; Tr < Gn.length; ++Tr)
                    Gn[Tr] = Tn[Tr].listener || Tn[Tr];
                  return Gn;
                }(fr) : fa(fr, fr.length);
              }
              function cr(We) {
                var pn = this._events;
                if (pn !== void 0) {
                  var zn = pn[We];
                  if (typeof zn == "function")
                    return 1;
                  if (zn !== void 0)
                    return zn.length;
                }
                return 0;
              }
              function fa(We, pn) {
                for (var zn = new Array(pn), pr = 0; pr < pn; ++pr)
                  zn[pr] = We[pr];
                return zn;
              }
              Object.defineProperty(Je, "defaultMaxListeners", { enumerable: true, get: function() {
                return yt;
              }, set: function(We) {
                if (typeof We != "number" || We < 0 || Ze(We))
                  throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + We + ".");
                yt = We;
              } }), Je.init = function() {
                this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
              }, Je.prototype.setMaxListeners = function(We) {
                if (typeof We != "number" || We < 0 || Ze(We))
                  throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + We + ".");
                return this._maxListeners = We, this;
              }, Je.prototype.getMaxListeners = function() {
                return Xt(this);
              }, Je.prototype.emit = function(We) {
                for (var pn = [], zn = 1; zn < arguments.length; zn++)
                  pn.push(arguments[zn]);
                var pr = We === "error", fr = this._events;
                if (fr !== void 0)
                  pr = pr && fr.error === void 0;
                else if (!pr)
                  return false;
                if (pr) {
                  var Tn;
                  if (pn.length > 0 && (Tn = pn[0]), Tn instanceof Error)
                    throw Tn;
                  var Gn = new Error("Unhandled error." + (Tn ? " (" + Tn.message + ")" : ""));
                  throw Gn.context = Tn, Gn;
                }
                var Tr = fr[We];
                if (Tr === void 0)
                  return false;
                if (typeof Tr == "function")
                  Be(Tr, this, pn);
                else {
                  var ra = Tr.length, wn = fa(Tr, ra);
                  for (zn = 0; zn < ra; ++zn)
                    Be(wn[zn], this, pn);
                }
                return true;
              }, Je.prototype.addListener = function(We, pn) {
                return Zt(this, We, pn, false);
              }, Je.prototype.on = Je.prototype.addListener, Je.prototype.prependListener = function(We, pn) {
                return Zt(this, We, pn, true);
              }, Je.prototype.once = function(We, pn) {
                return Gt(pn), this.on(We, yn(this, We, pn)), this;
              }, Je.prototype.prependOnceListener = function(We, pn) {
                return Gt(pn), this.prependListener(We, yn(this, We, pn)), this;
              }, Je.prototype.removeListener = function(We, pn) {
                var zn, pr, fr, Tn, Gn;
                if (Gt(pn), (pr = this._events) === void 0)
                  return this;
                if ((zn = pr[We]) === void 0)
                  return this;
                if (zn === pn || zn.listener === pn)
                  --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete pr[We], pr.removeListener && this.emit("removeListener", We, zn.listener || pn));
                else if (typeof zn != "function") {
                  for (fr = -1, Tn = zn.length - 1; Tn >= 0; Tn--)
                    if (zn[Tn] === pn || zn[Tn].listener === pn) {
                      Gn = zn[Tn].listener, fr = Tn;
                      break;
                    }
                  if (fr < 0)
                    return this;
                  fr === 0 ? zn.shift() : function(Tr, ra) {
                    for (; ra + 1 < Tr.length; ra++)
                      Tr[ra] = Tr[ra + 1];
                    Tr.pop();
                  }(zn, fr), zn.length === 1 && (pr[We] = zn[0]), pr.removeListener !== void 0 && this.emit("removeListener", We, Gn || pn);
                }
                return this;
              }, Je.prototype.off = Je.prototype.removeListener, Je.prototype.removeAllListeners = function(We) {
                var pn, zn, pr;
                if ((zn = this._events) === void 0)
                  return this;
                if (zn.removeListener === void 0)
                  return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : zn[We] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete zn[We]), this;
                if (arguments.length === 0) {
                  var fr, Tn = Object.keys(zn);
                  for (pr = 0; pr < Tn.length; ++pr)
                    (fr = Tn[pr]) !== "removeListener" && this.removeAllListeners(fr);
                  return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
                }
                if (typeof (pn = zn[We]) == "function")
                  this.removeListener(We, pn);
                else if (pn !== void 0)
                  for (pr = pn.length - 1; pr >= 0; pr--)
                    this.removeListener(We, pn[pr]);
                return this;
              }, Je.prototype.listeners = function(We) {
                return _r(this, We, true);
              }, Je.prototype.rawListeners = function(We) {
                return _r(this, We, false);
              }, Je.listenerCount = function(We, pn) {
                return typeof We.listenerCount == "function" ? We.listenerCount(pn) : cr.call(We, pn);
              }, Je.prototype.listenerCount = cr, Je.prototype.eventNames = function() {
                return this._eventsCount > 0 ? Ee(this._events) : [];
              };
            }, function(ne, re, fe) {
              ne.exports.Dispatcher = fe(140);
            }, function(ne, re, fe) {
              ne.exports = fe(142);
            }, function(ne, re, fe) {
              re.__esModule = true;
              var Ee = Ze(fe(50)), Oe = Ze(fe(65)), Be = typeof Oe.default == "function" && typeof Ee.default == "symbol" ? function(Je) {
                return typeof Je;
              } : function(Je) {
                return Je && typeof Oe.default == "function" && Je.constructor === Oe.default && Je !== Oe.default.prototype ? "symbol" : typeof Je;
              };
              function Ze(Je) {
                return Je && Je.__esModule ? Je : { default: Je };
              }
              re.default = typeof Oe.default == "function" && Be(Ee.default) === "symbol" ? function(Je) {
                return Je === void 0 ? "undefined" : Be(Je);
              } : function(Je) {
                return Je && typeof Oe.default == "function" && Je.constructor === Oe.default && Je !== Oe.default.prototype ? "symbol" : Je === void 0 ? "undefined" : Be(Je);
              };
            }, function(ne, re, fe) {
              ne.exports = { default: fe(51), __esModule: true };
            }, function(ne, re, fe) {
              fe(20), fe(29), ne.exports = fe(30).f("iterator");
            }, function(ne, re, fe) {
              var Ee = fe(21), Oe = fe(22);
              ne.exports = function(Be) {
                return function(Ze, Je) {
                  var yt, Gt, Xt = String(Oe(Ze)), Zt = Ee(Je), un = Xt.length;
                  return Zt < 0 || Zt >= un ? Be ? "" : void 0 : (yt = Xt.charCodeAt(Zt)) < 55296 || yt > 56319 || Zt + 1 === un || (Gt = Xt.charCodeAt(Zt + 1)) < 56320 || Gt > 57343 ? Be ? Xt.charAt(Zt) : yt : Be ? Xt.slice(Zt, Zt + 2) : Gt - 56320 + (yt - 55296 << 10) + 65536;
                };
              };
            }, function(ne, re, fe) {
              var Ee = fe(54);
              ne.exports = function(Oe, Be, Ze) {
                if (Ee(Oe), Be === void 0)
                  return Oe;
                switch (Ze) {
                  case 1:
                    return function(Je) {
                      return Oe.call(Be, Je);
                    };
                  case 2:
                    return function(Je, yt) {
                      return Oe.call(Be, Je, yt);
                    };
                  case 3:
                    return function(Je, yt, Gt) {
                      return Oe.call(Be, Je, yt, Gt);
                    };
                }
                return function() {
                  return Oe.apply(Be, arguments);
                };
              };
            }, function(ne, re) {
              ne.exports = function(fe) {
                if (typeof fe != "function")
                  throw TypeError(fe + " is not a function!");
                return fe;
              };
            }, function(ne, re, fe) {
              var Ee = fe(38), Oe = fe(16), Be = fe(28), Ze = {};
              fe(6)(Ze, fe(2)("iterator"), function() {
                return this;
              }), ne.exports = function(Je, yt, Gt) {
                Je.prototype = Ee(Ze, { next: Oe(1, Gt) }), Be(Je, yt + " Iterator");
              };
            }, function(ne, re, fe) {
              var Ee = fe(7), Oe = fe(10), Be = fe(13);
              ne.exports = fe(4) ? Object.defineProperties : function(Ze, Je) {
                Oe(Ze);
                for (var yt, Gt = Be(Je), Xt = Gt.length, Zt = 0; Xt > Zt; )
                  Ee.f(Ze, yt = Gt[Zt++], Je[yt]);
                return Ze;
              };
            }, function(ne, re, fe) {
              var Ee = fe(9), Oe = fe(58), Be = fe(59);
              ne.exports = function(Ze) {
                return function(Je, yt, Gt) {
                  var Xt, Zt = Ee(Je), un = Oe(Zt.length), yn = Be(Gt, un);
                  if (Ze && yt != yt) {
                    for (; un > yn; )
                      if ((Xt = Zt[yn++]) != Xt)
                        return true;
                  } else
                    for (; un > yn; yn++)
                      if ((Ze || yn in Zt) && Zt[yn] === yt)
                        return Ze || yn || 0;
                  return !Ze && -1;
                };
              };
            }, function(ne, re, fe) {
              var Ee = fe(21), Oe = Math.min;
              ne.exports = function(Be) {
                return Be > 0 ? Oe(Ee(Be), 9007199254740991) : 0;
              };
            }, function(ne, re, fe) {
              var Ee = fe(21), Oe = Math.max, Be = Math.min;
              ne.exports = function(Ze, Je) {
                return (Ze = Ee(Ze)) < 0 ? Oe(Ze + Je, 0) : Be(Ze, Je);
              };
            }, function(ne, re, fe) {
              var Ee = fe(3).document;
              ne.exports = Ee && Ee.documentElement;
            }, function(ne, re, fe) {
              var Ee = fe(5), Oe = fe(18), Be = fe(25)("IE_PROTO"), Ze = Object.prototype;
              ne.exports = Object.getPrototypeOf || function(Je) {
                return Je = Oe(Je), Ee(Je, Be) ? Je[Be] : typeof Je.constructor == "function" && Je instanceof Je.constructor ? Je.constructor.prototype : Je instanceof Object ? Ze : null;
              };
            }, function(ne, re, fe) {
              var Ee = fe(63), Oe = fe(64), Be = fe(12), Ze = fe(9);
              ne.exports = fe(34)(Array, "Array", function(Je, yt) {
                this._t = Ze(Je), this._i = 0, this._k = yt;
              }, function() {
                var Je = this._t, yt = this._k, Gt = this._i++;
                return !Je || Gt >= Je.length ? (this._t = void 0, Oe(1)) : Oe(0, yt == "keys" ? Gt : yt == "values" ? Je[Gt] : [Gt, Je[Gt]]);
              }, "values"), Be.Arguments = Be.Array, Ee("keys"), Ee("values"), Ee("entries");
            }, function(ne, re) {
              ne.exports = function() {
              };
            }, function(ne, re) {
              ne.exports = function(fe, Ee) {
                return { value: Ee, done: !!fe };
              };
            }, function(ne, re, fe) {
              ne.exports = { default: fe(66), __esModule: true };
            }, function(ne, re, fe) {
              fe(67), fe(73), fe(74), fe(75), ne.exports = fe(1).Symbol;
            }, function(ne, re, fe) {
              var Ee = fe(3), Oe = fe(5), Be = fe(4), Ze = fe(15), Je = fe(37), yt = fe(68).KEY, Gt = fe(8), Xt = fe(26), Zt = fe(28), un = fe(17), yn = fe(2), _r = fe(30), cr = fe(31), fa = fe(69), We = fe(70), pn = fe(10), zn = fe(11), pr = fe(18), fr = fe(9), Tn = fe(23), Gn = fe(16), Tr = fe(38), ra = fe(71), wn = fe(72), Ka = fe(32), Ya = fe(7), vr = fe(13), Pi = wn.f, xr = Ya.f, Xn = ra.f, Kn = Ee.Symbol, ba = Ee.JSON, la = ba && ba.stringify, Xi = yn("_hidden"), Ys = yn("toPrimitive"), Ss = {}.propertyIsEnumerable, Uo = Xt("symbol-registry"), nu = Xt("symbols"), Cs = Xt("op-symbols"), yl = Object.prototype, vc = typeof Kn == "function" && !!Ka.f, Gc = Ee.QObject, av = !Gc || !Gc.prototype || !Gc.prototype.findChild, Cg = Be && Gt(function() {
                return Tr(xr({}, "a", { get: function() {
                  return xr(this, "a", { value: 7 }).a;
                } })).a != 7;
              }) ? function(Vn, Br, ka) {
                var gi = Pi(yl, Br);
                gi && delete yl[Br], xr(Vn, Br, ka), gi && Vn !== yl && xr(yl, Br, gi);
              } : xr, Sf = function(Vn) {
                var Br = nu[Vn] = Tr(Kn.prototype);
                return Br._k = Vn, Br;
              }, gp = vc && typeof Kn.iterator == "symbol" ? function(Vn) {
                return typeof Vn == "symbol";
              } : function(Vn) {
                return Vn instanceof Kn;
              }, j0 = function(Vn, Br, ka) {
                return Vn === yl && j0(Cs, Br, ka), pn(Vn), Br = Tn(Br, true), pn(ka), Oe(nu, Br) ? (ka.enumerable ? (Oe(Vn, Xi) && Vn[Xi][Br] && (Vn[Xi][Br] = false), ka = Tr(ka, { enumerable: Gn(0, false) })) : (Oe(Vn, Xi) || xr(Vn, Xi, Gn(1, {})), Vn[Xi][Br] = true), Cg(Vn, Br, ka)) : xr(Vn, Br, ka);
              }, Td = function(Vn, Br) {
                pn(Vn);
                for (var ka, gi = fa(Br = fr(Br)), Ri = 0, qo = gi.length; qo > Ri; )
                  j0(Vn, ka = gi[Ri++], Br[ka]);
                return Vn;
              }, Hh = function(Vn) {
                var Br = Ss.call(this, Vn = Tn(Vn, true));
                return !(this === yl && Oe(nu, Vn) && !Oe(Cs, Vn)) && (!(Br || !Oe(this, Vn) || !Oe(nu, Vn) || Oe(this, Xi) && this[Xi][Vn]) || Br);
              }, Mg = function(Vn, Br) {
                if (Vn = fr(Vn), Br = Tn(Br, true), Vn !== yl || !Oe(nu, Br) || Oe(Cs, Br)) {
                  var ka = Pi(Vn, Br);
                  return !ka || !Oe(nu, Br) || Oe(Vn, Xi) && Vn[Xi][Br] || (ka.enumerable = true), ka;
                }
              }, iv = function(Vn) {
                for (var Br, ka = Xn(fr(Vn)), gi = [], Ri = 0; ka.length > Ri; )
                  Oe(nu, Br = ka[Ri++]) || Br == Xi || Br == yt || gi.push(Br);
                return gi;
              }, Ec = function(Vn) {
                for (var Br, ka = Vn === yl, gi = Xn(ka ? Cs : fr(Vn)), Ri = [], qo = 0; gi.length > qo; )
                  !Oe(nu, Br = gi[qo++]) || ka && !Oe(yl, Br) || Ri.push(nu[Br]);
                return Ri;
              };
              vc || (Je((Kn = function() {
                if (this instanceof Kn)
                  throw TypeError("Symbol is not a constructor!");
                var Vn = un(arguments.length > 0 ? arguments[0] : void 0), Br = function(ka) {
                  this === yl && Br.call(Cs, ka), Oe(this, Xi) && Oe(this[Xi], Vn) && (this[Xi][Vn] = false), Cg(this, Vn, Gn(1, ka));
                };
                return Be && av && Cg(yl, Vn, { configurable: true, set: Br }), Sf(Vn);
              }).prototype, "toString", function() {
                return this._k;
              }), wn.f = Mg, Ya.f = j0, fe(41).f = ra.f = iv, fe(19).f = Hh, Ka.f = Ec, Be && !fe(14) && Je(yl, "propertyIsEnumerable", Hh, true), _r.f = function(Vn) {
                return Sf(yn(Vn));
              }), Ze(Ze.G + Ze.W + Ze.F * !vc, { Symbol: Kn });
              for (var uf = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Tu = 0; uf.length > Tu; )
                yn(uf[Tu++]);
              for (var ki = vr(yn.store), Pr = 0; ki.length > Pr; )
                cr(ki[Pr++]);
              Ze(Ze.S + Ze.F * !vc, "Symbol", { for: function(Vn) {
                return Oe(Uo, Vn += "") ? Uo[Vn] : Uo[Vn] = Kn(Vn);
              }, keyFor: function(Vn) {
                if (!gp(Vn))
                  throw TypeError(Vn + " is not a symbol!");
                for (var Br in Uo)
                  if (Uo[Br] === Vn)
                    return Br;
              }, useSetter: function() {
                av = true;
              }, useSimple: function() {
                av = false;
              } }), Ze(Ze.S + Ze.F * !vc, "Object", { create: function(Vn, Br) {
                return Br === void 0 ? Tr(Vn) : Td(Tr(Vn), Br);
              }, defineProperty: j0, defineProperties: Td, getOwnPropertyDescriptor: Mg, getOwnPropertyNames: iv, getOwnPropertySymbols: Ec });
              var Hn = Gt(function() {
                Ka.f(1);
              });
              Ze(Ze.S + Ze.F * Hn, "Object", { getOwnPropertySymbols: function(Vn) {
                return Ka.f(pr(Vn));
              } }), ba && Ze(Ze.S + Ze.F * (!vc || Gt(function() {
                var Vn = Kn();
                return la([Vn]) != "[null]" || la({ a: Vn }) != "{}" || la(Object(Vn)) != "{}";
              })), "JSON", { stringify: function(Vn) {
                for (var Br, ka, gi = [Vn], Ri = 1; arguments.length > Ri; )
                  gi.push(arguments[Ri++]);
                if (ka = Br = gi[1], (zn(Br) || Vn !== void 0) && !gp(Vn))
                  return We(Br) || (Br = function(qo, Il) {
                    if (typeof ka == "function" && (Il = ka.call(this, qo, Il)), !gp(Il))
                      return Il;
                  }), gi[1] = Br, la.apply(ba, gi);
              } }), Kn.prototype[Ys] || fe(6)(Kn.prototype, Ys, Kn.prototype.valueOf), Zt(Kn, "Symbol"), Zt(Math, "Math", true), Zt(Ee.JSON, "JSON", true);
            }, function(ne, re, fe) {
              var Ee = fe(17)("meta"), Oe = fe(11), Be = fe(5), Ze = fe(7).f, Je = 0, yt = Object.isExtensible || function() {
                return true;
              }, Gt = !fe(8)(function() {
                return yt(Object.preventExtensions({}));
              }), Xt = function(un) {
                Ze(un, Ee, { value: { i: "O" + ++Je, w: {} } });
              }, Zt = ne.exports = { KEY: Ee, NEED: false, fastKey: function(un, yn) {
                if (!Oe(un))
                  return typeof un == "symbol" ? un : (typeof un == "string" ? "S" : "P") + un;
                if (!Be(un, Ee)) {
                  if (!yt(un))
                    return "F";
                  if (!yn)
                    return "E";
                  Xt(un);
                }
                return un[Ee].i;
              }, getWeak: function(un, yn) {
                if (!Be(un, Ee)) {
                  if (!yt(un))
                    return true;
                  if (!yn)
                    return false;
                  Xt(un);
                }
                return un[Ee].w;
              }, onFreeze: function(un) {
                return Gt && Zt.NEED && yt(un) && !Be(un, Ee) && Xt(un), un;
              } };
            }, function(ne, re, fe) {
              var Ee = fe(13), Oe = fe(32), Be = fe(19);
              ne.exports = function(Ze) {
                var Je = Ee(Ze), yt = Oe.f;
                if (yt)
                  for (var Gt, Xt = yt(Ze), Zt = Be.f, un = 0; Xt.length > un; )
                    Zt.call(Ze, Gt = Xt[un++]) && Je.push(Gt);
                return Je;
              };
            }, function(ne, re, fe) {
              var Ee = fe(24);
              ne.exports = Array.isArray || function(Oe) {
                return Ee(Oe) == "Array";
              };
            }, function(ne, re, fe) {
              var Ee = fe(9), Oe = fe(41).f, Be = {}.toString, Ze = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
              ne.exports.f = function(Je) {
                return Ze && Be.call(Je) == "[object Window]" ? function(yt) {
                  try {
                    return Oe(yt);
                  } catch {
                    return Ze.slice();
                  }
                }(Je) : Oe(Ee(Je));
              };
            }, function(ne, re, fe) {
              var Ee = fe(19), Oe = fe(16), Be = fe(9), Ze = fe(23), Je = fe(5), yt = fe(35), Gt = Object.getOwnPropertyDescriptor;
              re.f = fe(4) ? Gt : function(Xt, Zt) {
                if (Xt = Be(Xt), Zt = Ze(Zt, true), yt)
                  try {
                    return Gt(Xt, Zt);
                  } catch {
                  }
                if (Je(Xt, Zt))
                  return Oe(!Ee.f.call(Xt, Zt), Xt[Zt]);
              };
            }, function(ne, re) {
            }, function(ne, re, fe) {
              fe(31)("asyncIterator");
            }, function(ne, re, fe) {
              fe(31)("observable");
            }, function(ne, re, fe) {
              re.__esModule = true;
              var Ee, Oe = fe(77), Be = (Ee = Oe) && Ee.__esModule ? Ee : { default: Ee };
              re.default = Be.default || function(Ze) {
                for (var Je = 1; Je < arguments.length; Je++) {
                  var yt = arguments[Je];
                  for (var Gt in yt)
                    Object.prototype.hasOwnProperty.call(yt, Gt) && (Ze[Gt] = yt[Gt]);
                }
                return Ze;
              };
            }, function(ne, re, fe) {
              ne.exports = { default: fe(78), __esModule: true };
            }, function(ne, re, fe) {
              fe(79), ne.exports = fe(1).Object.assign;
            }, function(ne, re, fe) {
              var Ee = fe(15);
              Ee(Ee.S + Ee.F, "Object", { assign: fe(80) });
            }, function(ne, re, fe) {
              var Ee = fe(4), Oe = fe(13), Be = fe(32), Ze = fe(19), Je = fe(18), yt = fe(40), Gt = Object.assign;
              ne.exports = !Gt || fe(8)(function() {
                var Xt = {}, Zt = {}, un = Symbol(), yn = "abcdefghijklmnopqrst";
                return Xt[un] = 7, yn.split("").forEach(function(_r) {
                  Zt[_r] = _r;
                }), Gt({}, Xt)[un] != 7 || Object.keys(Gt({}, Zt)).join("") != yn;
              }) ? function(Xt, Zt) {
                for (var un = Je(Xt), yn = arguments.length, _r = 1, cr = Be.f, fa = Ze.f; yn > _r; )
                  for (var We, pn = yt(arguments[_r++]), zn = cr ? Oe(pn).concat(cr(pn)) : Oe(pn), pr = zn.length, fr = 0; pr > fr; )
                    We = zn[fr++], Ee && !fa.call(pn, We) || (un[We] = pn[We]);
                return un;
              } : Gt;
            }, function(ne, re, fe) {
              re.__esModule = true;
              var Ee = Be(fe(82)), Oe = Be(fe(85));
              function Be(Ze) {
                return Ze && Ze.__esModule ? Ze : { default: Ze };
              }
              re.default = function(Ze, Je) {
                if (Array.isArray(Ze))
                  return Ze;
                if ((0, Ee.default)(Object(Ze)))
                  return function(yt, Gt) {
                    var Xt = [], Zt = true, un = false, yn = void 0;
                    try {
                      for (var _r, cr = (0, Oe.default)(yt); !(Zt = (_r = cr.next()).done) && (Xt.push(_r.value), !Gt || Xt.length !== Gt); Zt = true)
                        ;
                    } catch (fa) {
                      un = true, yn = fa;
                    } finally {
                      try {
                        !Zt && cr.return && cr.return();
                      } finally {
                        if (un)
                          throw yn;
                      }
                    }
                    return Xt;
                  }(Ze, Je);
                throw new TypeError("Invalid attempt to destructure non-iterable instance");
              };
            }, function(ne, re, fe) {
              ne.exports = { default: fe(83), __esModule: true };
            }, function(ne, re, fe) {
              fe(29), fe(20), ne.exports = fe(84);
            }, function(ne, re, fe) {
              var Ee = fe(42), Oe = fe(2)("iterator"), Be = fe(12);
              ne.exports = fe(1).isIterable = function(Ze) {
                var Je = Object(Ze);
                return Je[Oe] !== void 0 || "@@iterator" in Je || Be.hasOwnProperty(Ee(Je));
              };
            }, function(ne, re, fe) {
              ne.exports = { default: fe(86), __esModule: true };
            }, function(ne, re, fe) {
              fe(29), fe(20), ne.exports = fe(87);
            }, function(ne, re, fe) {
              var Ee = fe(10), Oe = fe(88);
              ne.exports = fe(1).getIterator = function(Be) {
                var Ze = Oe(Be);
                if (typeof Ze != "function")
                  throw TypeError(Be + " is not iterable!");
                return Ee(Ze.call(Be));
              };
            }, function(ne, re, fe) {
              var Ee = fe(42), Oe = fe(2)("iterator"), Be = fe(12);
              ne.exports = fe(1).getIteratorMethod = function(Ze) {
                if (Ze != null)
                  return Ze[Oe] || Ze["@@iterator"] || Be[Ee(Ze)];
              };
            }, function(ne, re, fe) {
              ne.exports = { default: fe(90), __esModule: true };
            }, function(ne, re, fe) {
              fe(91), ne.exports = fe(1).Object.keys;
            }, function(ne, re, fe) {
              var Ee = fe(18), Oe = fe(13);
              fe(92)("keys", function() {
                return function(Be) {
                  return Oe(Ee(Be));
                };
              });
            }, function(ne, re, fe) {
              var Ee = fe(15), Oe = fe(1), Be = fe(8);
              ne.exports = function(Ze, Je) {
                var yt = (Oe.Object || {})[Ze] || Object[Ze], Gt = {};
                Gt[Ze] = Je(yt), Ee(Ee.S + Ee.F * Be(function() {
                  yt(1);
                }), "Object", Gt);
              };
            }, function(ne, re, fe) {
              (function(Ee) {
                var Oe = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], Be = /^\s+|\s+$/g, Ze = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Je = /\{\n\/\* \[wrapped with (.+)\] \*/, yt = /,? & /, Gt = /^[-+]0x[0-9a-f]+$/i, Xt = /^0b[01]+$/i, Zt = /^\[object .+?Constructor\]$/, un = /^0o[0-7]+$/i, yn = /^(?:0|[1-9]\d*)$/, _r = parseInt, cr = typeof Ee == "object" && Ee && Ee.Object === Object && Ee, fa = typeof self == "object" && self && self.Object === Object && self, We = cr || fa || Function("return this")();
                function pn(Pr, Hn, Vn) {
                  switch (Vn.length) {
                    case 0:
                      return Pr.call(Hn);
                    case 1:
                      return Pr.call(Hn, Vn[0]);
                    case 2:
                      return Pr.call(Hn, Vn[0], Vn[1]);
                    case 3:
                      return Pr.call(Hn, Vn[0], Vn[1], Vn[2]);
                  }
                  return Pr.apply(Hn, Vn);
                }
                function zn(Pr, Hn) {
                  return !!(Pr && Pr.length) && function(Vn, Br, ka) {
                    if (Br != Br)
                      return function(qo, Il, Wu, Du) {
                        for (var Wc = qo.length, ku = Wu + (Du ? 1 : -1); Du ? ku-- : ++ku < Wc; )
                          if (Il(qo[ku], ku, qo))
                            return ku;
                        return -1;
                      }(Vn, pr, ka);
                    for (var gi = ka - 1, Ri = Vn.length; ++gi < Ri; )
                      if (Vn[gi] === Br)
                        return gi;
                    return -1;
                  }(Pr, Hn, 0) > -1;
                }
                function pr(Pr) {
                  return Pr != Pr;
                }
                function fr(Pr, Hn) {
                  for (var Vn = Pr.length, Br = 0; Vn--; )
                    Pr[Vn] === Hn && Br++;
                  return Br;
                }
                function Tn(Pr, Hn) {
                  for (var Vn = -1, Br = Pr.length, ka = 0, gi = []; ++Vn < Br; ) {
                    var Ri = Pr[Vn];
                    Ri !== Hn && Ri !== "__lodash_placeholder__" || (Pr[Vn] = "__lodash_placeholder__", gi[ka++] = Vn);
                  }
                  return gi;
                }
                var Gn, Tr, ra, wn = Function.prototype, Ka = Object.prototype, Ya = We["__core-js_shared__"], vr = (Gn = /[^.]+$/.exec(Ya && Ya.keys && Ya.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Gn : "", Pi = wn.toString, xr = Ka.hasOwnProperty, Xn = Ka.toString, Kn = RegExp("^" + Pi.call(xr).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ba = Object.create, la = Math.max, Xi = Math.min, Ys = (Tr = Sf(Object, "defineProperty"), (ra = Sf.name) && ra.length > 2 ? Tr : void 0);
                function Ss(Pr) {
                  return uf(Pr) ? ba(Pr) : {};
                }
                function Uo(Pr) {
                  return !(!uf(Pr) || function(Hn) {
                    return !!vr && vr in Hn;
                  }(Pr)) && (function(Hn) {
                    var Vn = uf(Hn) ? Xn.call(Hn) : "";
                    return Vn == "[object Function]" || Vn == "[object GeneratorFunction]";
                  }(Pr) || function(Hn) {
                    var Vn = false;
                    if (Hn != null && typeof Hn.toString != "function")
                      try {
                        Vn = !!(Hn + "");
                      } catch {
                      }
                    return Vn;
                  }(Pr) ? Kn : Zt).test(function(Hn) {
                    if (Hn != null) {
                      try {
                        return Pi.call(Hn);
                      } catch {
                      }
                      try {
                        return Hn + "";
                      } catch {
                      }
                    }
                    return "";
                  }(Pr));
                }
                function nu(Pr, Hn, Vn, Br) {
                  for (var ka = -1, gi = Pr.length, Ri = Vn.length, qo = -1, Il = Hn.length, Wu = la(gi - Ri, 0), Du = Array(Il + Wu), Wc = !Br; ++qo < Il; )
                    Du[qo] = Hn[qo];
                  for (; ++ka < Ri; )
                    (Wc || ka < gi) && (Du[Vn[ka]] = Pr[ka]);
                  for (; Wu--; )
                    Du[qo++] = Pr[ka++];
                  return Du;
                }
                function Cs(Pr, Hn, Vn, Br) {
                  for (var ka = -1, gi = Pr.length, Ri = -1, qo = Vn.length, Il = -1, Wu = Hn.length, Du = la(gi - qo, 0), Wc = Array(Du + Wu), ku = !Br; ++ka < Du; )
                    Wc[ka] = Pr[ka];
                  for (var Dd = ka; ++Il < Wu; )
                    Wc[Dd + Il] = Hn[Il];
                  for (; ++Ri < qo; )
                    (ku || ka < gi) && (Wc[Dd + Vn[Ri]] = Pr[ka++]);
                  return Wc;
                }
                function yl(Pr) {
                  return function() {
                    var Hn = arguments;
                    switch (Hn.length) {
                      case 0:
                        return new Pr();
                      case 1:
                        return new Pr(Hn[0]);
                      case 2:
                        return new Pr(Hn[0], Hn[1]);
                      case 3:
                        return new Pr(Hn[0], Hn[1], Hn[2]);
                      case 4:
                        return new Pr(Hn[0], Hn[1], Hn[2], Hn[3]);
                      case 5:
                        return new Pr(Hn[0], Hn[1], Hn[2], Hn[3], Hn[4]);
                      case 6:
                        return new Pr(Hn[0], Hn[1], Hn[2], Hn[3], Hn[4], Hn[5]);
                      case 7:
                        return new Pr(Hn[0], Hn[1], Hn[2], Hn[3], Hn[4], Hn[5], Hn[6]);
                    }
                    var Vn = Ss(Pr.prototype), Br = Pr.apply(Vn, Hn);
                    return uf(Br) ? Br : Vn;
                  };
                }
                function vc(Pr, Hn, Vn, Br, ka, gi, Ri, qo, Il, Wu) {
                  var Du = 128 & Hn, Wc = 1 & Hn, ku = 2 & Hn, Dd = 24 & Hn, mp = 512 & Hn, Cf = ku ? void 0 : yl(Pr);
                  return function ru() {
                    for (var gc = arguments.length, Zs = Array(gc), cf = gc; cf--; )
                      Zs[cf] = arguments[cf];
                    if (Dd)
                      var $h = Cg(ru), Ag = fr(Zs, $h);
                    if (Br && (Zs = nu(Zs, Br, ka, Dd)), gi && (Zs = Cs(Zs, gi, Ri, Dd)), gc -= Ag, Dd && gc < Wu) {
                      var ph = Tn(Zs, $h);
                      return Gc(Pr, Hn, vc, ru.placeholder, Vn, Zs, ph, qo, Il, Wu - gc);
                    }
                    var kd = Wc ? Vn : this, ov = ku ? kd[Pr] : Pr;
                    return gc = Zs.length, qo ? Zs = Hh(Zs, qo) : mp && gc > 1 && Zs.reverse(), Du && Il < gc && (Zs.length = Il), this && this !== We && this instanceof ru && (ov = Cf || yl(ov)), ov.apply(kd, Zs);
                  };
                }
                function Gc(Pr, Hn, Vn, Br, ka, gi, Ri, qo, Il, Wu) {
                  var Du = 8 & Hn;
                  Hn |= Du ? 32 : 64, 4 & (Hn &= ~(Du ? 64 : 32)) || (Hn &= -4);
                  var Wc = Vn(Pr, Hn, ka, Du ? gi : void 0, Du ? Ri : void 0, Du ? void 0 : gi, Du ? void 0 : Ri, qo, Il, Wu);
                  return Wc.placeholder = Br, Mg(Wc, Pr, Hn);
                }
                function av(Pr, Hn, Vn, Br, ka, gi, Ri, qo) {
                  var Il = 2 & Hn;
                  if (!Il && typeof Pr != "function")
                    throw new TypeError("Expected a function");
                  var Wu = Br ? Br.length : 0;
                  if (Wu || (Hn &= -97, Br = ka = void 0), Ri = Ri === void 0 ? Ri : la(ki(Ri), 0), qo = qo === void 0 ? qo : ki(qo), Wu -= ka ? ka.length : 0, 64 & Hn) {
                    var Du = Br, Wc = ka;
                    Br = ka = void 0;
                  }
                  var ku = [Pr, Hn, Vn, Br, ka, Du, Wc, gi, Ri, qo];
                  if (Pr = ku[0], Hn = ku[1], Vn = ku[2], Br = ku[3], ka = ku[4], !(qo = ku[9] = ku[9] == null ? Il ? 0 : Pr.length : la(ku[9] - Wu, 0)) && 24 & Hn && (Hn &= -25), Hn && Hn != 1)
                    Dd = Hn == 8 || Hn == 16 ? function(mp, Cf, ru) {
                      var gc = yl(mp);
                      return function Zs() {
                        for (var cf = arguments.length, $h = Array(cf), Ag = cf, ph = Cg(Zs); Ag--; )
                          $h[Ag] = arguments[Ag];
                        var kd = cf < 3 && $h[0] !== ph && $h[cf - 1] !== ph ? [] : Tn($h, ph);
                        if ((cf -= kd.length) < ru)
                          return Gc(mp, Cf, vc, Zs.placeholder, void 0, $h, kd, void 0, void 0, ru - cf);
                        var ov = this && this !== We && this instanceof Zs ? gc : mp;
                        return pn(ov, this, $h);
                      };
                    }(Pr, Hn, qo) : Hn != 32 && Hn != 33 || ka.length ? vc.apply(void 0, ku) : function(mp, Cf, ru, gc) {
                      var Zs = 1 & Cf, cf = yl(mp);
                      return function $h() {
                        for (var Ag = -1, ph = arguments.length, kd = -1, ov = gc.length, y_ = Array(ov + ph), z1 = this && this !== We && this instanceof $h ? cf : mp; ++kd < ov; )
                          y_[kd] = gc[kd];
                        for (; ph--; )
                          y_[kd++] = arguments[++Ag];
                        return pn(z1, Zs ? ru : this, y_);
                      };
                    }(Pr, Hn, Vn, Br);
                  else
                    var Dd = function(mp, Cf, ru) {
                      var gc = 1 & Cf, Zs = yl(mp);
                      return function cf() {
                        var $h = this && this !== We && this instanceof cf ? Zs : mp;
                        return $h.apply(gc ? ru : this, arguments);
                      };
                    }(Pr, Hn, Vn);
                  return Mg(Dd, Pr, Hn);
                }
                function Cg(Pr) {
                  return Pr.placeholder;
                }
                function Sf(Pr, Hn) {
                  var Vn = function(Br, ka) {
                    return Br == null ? void 0 : Br[ka];
                  }(Pr, Hn);
                  return Uo(Vn) ? Vn : void 0;
                }
                function gp(Pr) {
                  var Hn = Pr.match(Je);
                  return Hn ? Hn[1].split(yt) : [];
                }
                function j0(Pr, Hn) {
                  var Vn = Hn.length, Br = Vn - 1;
                  return Hn[Br] = (Vn > 1 ? "& " : "") + Hn[Br], Hn = Hn.join(Vn > 2 ? ", " : " "), Pr.replace(Ze, `{
/* [wrapped with ` + Hn + `] */
`);
                }
                function Td(Pr, Hn) {
                  return !!(Hn = Hn == null ? 9007199254740991 : Hn) && (typeof Pr == "number" || yn.test(Pr)) && Pr > -1 && Pr % 1 == 0 && Pr < Hn;
                }
                function Hh(Pr, Hn) {
                  for (var Vn = Pr.length, Br = Xi(Hn.length, Vn), ka = function(Ri, qo) {
                    var Il = -1, Wu = Ri.length;
                    for (qo || (qo = Array(Wu)); ++Il < Wu; )
                      qo[Il] = Ri[Il];
                    return qo;
                  }(Pr); Br--; ) {
                    var gi = Hn[Br];
                    Pr[Br] = Td(gi, Vn) ? ka[gi] : void 0;
                  }
                  return Pr;
                }
                var Mg = Ys ? function(Pr, Hn, Vn) {
                  var Br, ka = Hn + "";
                  return Ys(Pr, "toString", { configurable: true, enumerable: false, value: (Br = j0(ka, iv(gp(ka), Vn)), function() {
                    return Br;
                  }) });
                } : function(Pr) {
                  return Pr;
                };
                function iv(Pr, Hn) {
                  return function(Vn, Br) {
                    for (var ka = -1, gi = Vn ? Vn.length : 0; ++ka < gi && Br(Vn[ka], ka, Vn) !== false; )
                      ;
                  }(Oe, function(Vn) {
                    var Br = "_." + Vn[0];
                    Hn & Vn[1] && !zn(Pr, Br) && Pr.push(Br);
                  }), Pr.sort();
                }
                function Ec(Pr, Hn, Vn) {
                  var Br = av(Pr, 8, void 0, void 0, void 0, void 0, void 0, Hn = Vn ? void 0 : Hn);
                  return Br.placeholder = Ec.placeholder, Br;
                }
                function uf(Pr) {
                  var Hn = typeof Pr;
                  return !!Pr && (Hn == "object" || Hn == "function");
                }
                function Tu(Pr) {
                  return Pr ? (Pr = function(Hn) {
                    if (typeof Hn == "number")
                      return Hn;
                    if (function(ka) {
                      return typeof ka == "symbol" || function(gi) {
                        return !!gi && typeof gi == "object";
                      }(ka) && Xn.call(ka) == "[object Symbol]";
                    }(Hn))
                      return NaN;
                    if (uf(Hn)) {
                      var Vn = typeof Hn.valueOf == "function" ? Hn.valueOf() : Hn;
                      Hn = uf(Vn) ? Vn + "" : Vn;
                    }
                    if (typeof Hn != "string")
                      return Hn === 0 ? Hn : +Hn;
                    Hn = Hn.replace(Be, "");
                    var Br = Xt.test(Hn);
                    return Br || un.test(Hn) ? _r(Hn.slice(2), Br ? 2 : 8) : Gt.test(Hn) ? NaN : +Hn;
                  }(Pr)) === 1 / 0 || Pr === -1 / 0 ? 17976931348623157e292 * (Pr < 0 ? -1 : 1) : Pr == Pr ? Pr : 0 : Pr === 0 ? Pr : 0;
                }
                function ki(Pr) {
                  var Hn = Tu(Pr), Vn = Hn % 1;
                  return Hn == Hn ? Vn ? Hn - Vn : Hn : 0;
                }
                Ec.placeholder = {}, ne.exports = Ec;
              }).call(this, fe(43));
            }, function(ne, re, fe) {
              function Ee(Cs) {
                return Cs && Cs.__esModule ? Cs.default : Cs;
              }
              re.__esModule = true;
              var Oe = fe(95);
              re.threezerotwofour = Ee(Oe);
              var Be = fe(96);
              re.apathy = Ee(Be);
              var Ze = fe(97);
              re.ashes = Ee(Ze);
              var Je = fe(98);
              re.atelierDune = Ee(Je);
              var yt = fe(99);
              re.atelierForest = Ee(yt);
              var Gt = fe(100);
              re.atelierHeath = Ee(Gt);
              var Xt = fe(101);
              re.atelierLakeside = Ee(Xt);
              var Zt = fe(102);
              re.atelierSeaside = Ee(Zt);
              var un = fe(103);
              re.bespin = Ee(un);
              var yn = fe(104);
              re.brewer = Ee(yn);
              var _r = fe(105);
              re.bright = Ee(_r);
              var cr = fe(106);
              re.chalk = Ee(cr);
              var fa = fe(107);
              re.codeschool = Ee(fa);
              var We = fe(108);
              re.colors = Ee(We);
              var pn = fe(109);
              re.default = Ee(pn);
              var zn = fe(110);
              re.eighties = Ee(zn);
              var pr = fe(111);
              re.embers = Ee(pr);
              var fr = fe(112);
              re.flat = Ee(fr);
              var Tn = fe(113);
              re.google = Ee(Tn);
              var Gn = fe(114);
              re.grayscale = Ee(Gn);
              var Tr = fe(115);
              re.greenscreen = Ee(Tr);
              var ra = fe(116);
              re.harmonic = Ee(ra);
              var wn = fe(117);
              re.hopscotch = Ee(wn);
              var Ka = fe(118);
              re.isotope = Ee(Ka);
              var Ya = fe(119);
              re.marrakesh = Ee(Ya);
              var vr = fe(120);
              re.mocha = Ee(vr);
              var Pi = fe(121);
              re.monokai = Ee(Pi);
              var xr = fe(122);
              re.ocean = Ee(xr);
              var Xn = fe(123);
              re.paraiso = Ee(Xn);
              var Kn = fe(124);
              re.pop = Ee(Kn);
              var ba = fe(125);
              re.railscasts = Ee(ba);
              var la = fe(126);
              re.shapeshifter = Ee(la);
              var Xi = fe(127);
              re.solarized = Ee(Xi);
              var Ys = fe(128);
              re.summerfruit = Ee(Ys);
              var Ss = fe(129);
              re.tomorrow = Ee(Ss);
              var Uo = fe(130);
              re.tube = Ee(Uo);
              var nu = fe(131);
              re.twilight = Ee(nu);
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              re.__esModule = true, re.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, ne.exports = re.default;
            }, function(ne, re, fe) {
              var Ee = fe(33);
              function Oe(Be) {
                var Ze = Math.round(Ee(Be, 0, 255)).toString(16);
                return Ze.length == 1 ? "0" + Ze : Ze;
              }
              ne.exports = function(Be) {
                var Ze = Be.length === 4 ? Oe(255 * Be[3]) : "";
                return "#" + Oe(Be[0]) + Oe(Be[1]) + Oe(Be[2]) + Ze;
              };
            }, function(ne, re, fe) {
              var Ee = fe(134), Oe = fe(135), Be = fe(136), Ze = fe(137), Je = { "#": Oe, hsl: function(Gt) {
                var Xt = Ee(Gt), Zt = Ze(Xt);
                return Xt.length === 4 && Zt.push(Xt[3]), Zt;
              }, rgb: Be };
              function yt(Gt) {
                for (var Xt in Je)
                  if (Gt.indexOf(Xt) === 0)
                    return Je[Xt](Gt);
              }
              yt.rgb = Be, yt.hsl = Ee, yt.hex = Oe, ne.exports = yt;
            }, function(ne, re, fe) {
              var Ee = fe(44), Oe = fe(33);
              function Be(Ze, Je) {
                switch (Ze = parseFloat(Ze), Je) {
                  case 0:
                    return Oe(Ze, 0, 360);
                  case 1:
                  case 2:
                    return Oe(Ze, 0, 100);
                  case 3:
                    return Oe(Ze, 0, 1);
                }
              }
              ne.exports = function(Ze) {
                return Ee(Ze).map(Be);
              };
            }, function(ne, re) {
              ne.exports = function(fe) {
                fe.length !== 4 && fe.length !== 5 || (fe = function(Be) {
                  for (var Ze = "#", Je = 1; Je < Be.length; Je++) {
                    var yt = Be.charAt(Je);
                    Ze += yt + yt;
                  }
                  return Ze;
                }(fe));
                var Ee = [parseInt(fe.substring(1, 3), 16), parseInt(fe.substring(3, 5), 16), parseInt(fe.substring(5, 7), 16)];
                if (fe.length === 9) {
                  var Oe = parseFloat((parseInt(fe.substring(7, 9), 16) / 255).toFixed(2));
                  Ee.push(Oe);
                }
                return Ee;
              };
            }, function(ne, re, fe) {
              var Ee = fe(44), Oe = fe(33);
              function Be(Ze, Je) {
                return Je < 3 ? Ze.indexOf("%") != -1 ? Math.round(255 * Oe(parseInt(Ze, 10), 0, 100) / 100) : Oe(parseInt(Ze, 10), 0, 255) : Oe(parseFloat(Ze), 0, 1);
              }
              ne.exports = function(Ze) {
                return Ee(Ze).map(Be);
              };
            }, function(ne, re) {
              ne.exports = function(fe) {
                var Ee, Oe, Be, Ze, Je, yt = fe[0] / 360, Gt = fe[1] / 100, Xt = fe[2] / 100;
                if (Gt == 0)
                  return [Je = 255 * Xt, Je, Je];
                Ee = 2 * Xt - (Oe = Xt < 0.5 ? Xt * (1 + Gt) : Xt + Gt - Xt * Gt), Ze = [0, 0, 0];
                for (var Zt = 0; Zt < 3; Zt++)
                  (Be = yt + 1 / 3 * -(Zt - 1)) < 0 && Be++, Be > 1 && Be--, Je = 6 * Be < 1 ? Ee + 6 * (Oe - Ee) * Be : 2 * Be < 1 ? Oe : 3 * Be < 2 ? Ee + (Oe - Ee) * (2 / 3 - Be) * 6 : Ee, Ze[Zt] = 255 * Je;
                return Ze;
              };
            }, function(ne, re, fe) {
              (function(Ee) {
                var Oe = typeof Ee == "object" && Ee && Ee.Object === Object && Ee, Be = typeof self == "object" && self && self.Object === Object && self, Ze = Oe || Be || Function("return this")();
                function Je(Tn, Gn, Tr) {
                  switch (Tr.length) {
                    case 0:
                      return Tn.call(Gn);
                    case 1:
                      return Tn.call(Gn, Tr[0]);
                    case 2:
                      return Tn.call(Gn, Tr[0], Tr[1]);
                    case 3:
                      return Tn.call(Gn, Tr[0], Tr[1], Tr[2]);
                  }
                  return Tn.apply(Gn, Tr);
                }
                function yt(Tn, Gn) {
                  for (var Tr = -1, ra = Gn.length, wn = Tn.length; ++Tr < ra; )
                    Tn[wn + Tr] = Gn[Tr];
                  return Tn;
                }
                var Gt = Object.prototype, Xt = Gt.hasOwnProperty, Zt = Gt.toString, un = Ze.Symbol, yn = Gt.propertyIsEnumerable, _r = un ? un.isConcatSpreadable : void 0, cr = Math.max;
                function fa(Tn) {
                  return We(Tn) || function(Gn) {
                    return function(Tr) {
                      return function(ra) {
                        return !!ra && typeof ra == "object";
                      }(Tr) && function(ra) {
                        return ra != null && function(wn) {
                          return typeof wn == "number" && wn > -1 && wn % 1 == 0 && wn <= 9007199254740991;
                        }(ra.length) && !function(wn) {
                          var Ka = function(Ya) {
                            var vr = typeof Ya;
                            return !!Ya && (vr == "object" || vr == "function");
                          }(wn) ? Zt.call(wn) : "";
                          return Ka == "[object Function]" || Ka == "[object GeneratorFunction]";
                        }(ra);
                      }(Tr);
                    }(Gn) && Xt.call(Gn, "callee") && (!yn.call(Gn, "callee") || Zt.call(Gn) == "[object Arguments]");
                  }(Tn) || !!(_r && Tn && Tn[_r]);
                }
                var We = Array.isArray, pn, zn, pr, fr = (zn = function(Tn) {
                  var Gn = (Tn = function ra(wn, Ka, Ya, vr, Pi) {
                    var xr = -1, Xn = wn.length;
                    for (Ya || (Ya = fa), Pi || (Pi = []); ++xr < Xn; ) {
                      var Kn = wn[xr];
                      Ka > 0 && Ya(Kn) ? Ka > 1 ? ra(Kn, Ka - 1, Ya, vr, Pi) : yt(Pi, Kn) : vr || (Pi[Pi.length] = Kn);
                    }
                    return Pi;
                  }(Tn, 1)).length, Tr = Gn;
                  for (pn; Tr--; )
                    if (typeof Tn[Tr] != "function")
                      throw new TypeError("Expected a function");
                  return function() {
                    for (var ra = 0, wn = Gn ? Tn[ra].apply(this, arguments) : arguments[0]; ++ra < Gn; )
                      wn = Tn[ra].call(this, wn);
                    return wn;
                  };
                }, pr = cr(pr === void 0 ? zn.length - 1 : pr, 0), function() {
                  for (var Tn = arguments, Gn = -1, Tr = cr(Tn.length - pr, 0), ra = Array(Tr); ++Gn < Tr; )
                    ra[Gn] = Tn[pr + Gn];
                  Gn = -1;
                  for (var wn = Array(pr + 1); ++Gn < pr; )
                    wn[Gn] = Tn[Gn];
                  return wn[pr] = ra, Je(zn, this, wn);
                });
                ne.exports = fr;
              }).call(this, fe(43));
            }, function(ne, re, fe) {
              Object.defineProperty(re, "__esModule", { value: true }), re.yuv2rgb = function(Ee) {
                var Oe, Be, Ze, Je = Ee[0], yt = Ee[1], Gt = Ee[2];
                return Oe = 1 * Je + 0 * yt + 1.13983 * Gt, Be = 1 * Je + -0.39465 * yt + -0.5806 * Gt, Ze = 1 * Je + 2.02311 * yt + 0 * Gt, Oe = Math.min(Math.max(0, Oe), 1), Be = Math.min(Math.max(0, Be), 1), Ze = Math.min(Math.max(0, Ze), 1), [255 * Oe, 255 * Be, 255 * Ze];
              }, re.rgb2yuv = function(Ee) {
                var Oe = Ee[0] / 255, Be = Ee[1] / 255, Ze = Ee[2] / 255;
                return [0.299 * Oe + 0.587 * Be + 0.114 * Ze, -0.14713 * Oe + -0.28886 * Be + 0.436 * Ze, 0.615 * Oe + -0.51499 * Be + -0.10001 * Ze];
              };
            }, function(ne, re, fe) {
              function Ee(Ze, Je, yt) {
                return Je in Ze ? Object.defineProperty(Ze, Je, { value: yt, enumerable: true, configurable: true, writable: true }) : Ze[Je] = yt, Ze;
              }
              var Oe = fe(141), Be = function() {
                function Ze() {
                  Ee(this, "_callbacks", void 0), Ee(this, "_isDispatching", void 0), Ee(this, "_isHandled", void 0), Ee(this, "_isPending", void 0), Ee(this, "_lastID", void 0), Ee(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
                }
                var Je = Ze.prototype;
                return Je.register = function(yt) {
                  var Gt = "ID_" + this._lastID++;
                  return this._callbacks[Gt] = yt, Gt;
                }, Je.unregister = function(yt) {
                  this._callbacks[yt] || Oe(false), delete this._callbacks[yt];
                }, Je.waitFor = function(yt) {
                  this._isDispatching || Oe(false);
                  for (var Gt = 0; Gt < yt.length; Gt++) {
                    var Xt = yt[Gt];
                    this._isPending[Xt] ? this._isHandled[Xt] || Oe(false) : (this._callbacks[Xt] || Oe(false), this._invokeCallback(Xt));
                  }
                }, Je.dispatch = function(yt) {
                  this._isDispatching && Oe(false), this._startDispatching(yt);
                  try {
                    for (var Gt in this._callbacks)
                      this._isPending[Gt] || this._invokeCallback(Gt);
                  } finally {
                    this._stopDispatching();
                  }
                }, Je.isDispatching = function() {
                  return this._isDispatching;
                }, Je._invokeCallback = function(yt) {
                  this._isPending[yt] = true, this._callbacks[yt](this._pendingPayload), this._isHandled[yt] = true;
                }, Je._startDispatching = function(yt) {
                  for (var Gt in this._callbacks)
                    this._isPending[Gt] = false, this._isHandled[Gt] = false;
                  this._pendingPayload = yt, this._isDispatching = true;
                }, Je._stopDispatching = function() {
                  delete this._pendingPayload, this._isDispatching = false;
                }, Ze;
              }();
              ne.exports = Be;
            }, function(ne, re, fe) {
              ne.exports = function(Ee, Oe) {
                for (var Be = arguments.length, Ze = new Array(Be > 2 ? Be - 2 : 0), Je = 2; Je < Be; Je++)
                  Ze[Je - 2] = arguments[Je];
                if (!Ee) {
                  var yt;
                  if (Oe === void 0)
                    yt = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                  else {
                    var Gt = 0;
                    (yt = new Error(Oe.replace(/%s/g, function() {
                      return String(Ze[Gt++]);
                    }))).name = "Invariant Violation";
                  }
                  throw yt.framesToPop = 1, yt;
                }
              };
            }, function(ne, re, fe) {
              function Ee(Pt, Vt, ut) {
                return Vt in Pt ? Object.defineProperty(Pt, Vt, { value: ut, enumerable: true, configurable: true, writable: true }) : Pt[Vt] = ut, Pt;
              }
              function Oe(Pt, Vt) {
                var ut = Object.keys(Pt);
                if (Object.getOwnPropertySymbols) {
                  var At = Object.getOwnPropertySymbols(Pt);
                  Vt && (At = At.filter(function(Dt) {
                    return Object.getOwnPropertyDescriptor(Pt, Dt).enumerable;
                  })), ut.push.apply(ut, At);
                }
                return ut;
              }
              function Be(Pt) {
                for (var Vt = 1; Vt < arguments.length; Vt++) {
                  var ut = arguments[Vt] != null ? arguments[Vt] : {};
                  Vt % 2 ? Oe(Object(ut), true).forEach(function(At) {
                    Ee(Pt, At, ut[At]);
                  }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Pt, Object.getOwnPropertyDescriptors(ut)) : Oe(Object(ut)).forEach(function(At) {
                    Object.defineProperty(Pt, At, Object.getOwnPropertyDescriptor(ut, At));
                  });
                }
                return Pt;
              }
              function Ze(Pt, Vt) {
                if (!(Pt instanceof Vt))
                  throw new TypeError("Cannot call a class as a function");
              }
              function Je(Pt, Vt) {
                for (var ut = 0; ut < Vt.length; ut++) {
                  var At = Vt[ut];
                  At.enumerable = At.enumerable || false, At.configurable = true, "value" in At && (At.writable = true), Object.defineProperty(Pt, At.key, At);
                }
              }
              function yt(Pt, Vt, ut) {
                return Vt && Je(Pt.prototype, Vt), ut && Je(Pt, ut), Pt;
              }
              function Gt(Pt, Vt) {
                return (Gt = Object.setPrototypeOf || function(ut, At) {
                  return ut.__proto__ = At, ut;
                })(Pt, Vt);
              }
              function Xt(Pt, Vt) {
                if (typeof Vt != "function" && Vt !== null)
                  throw new TypeError("Super expression must either be null or a function");
                Pt.prototype = Object.create(Vt && Vt.prototype, { constructor: { value: Pt, writable: true, configurable: true } }), Vt && Gt(Pt, Vt);
              }
              function Zt(Pt) {
                return (Zt = Object.setPrototypeOf ? Object.getPrototypeOf : function(Vt) {
                  return Vt.__proto__ || Object.getPrototypeOf(Vt);
                })(Pt);
              }
              function un(Pt) {
                return (un = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Vt) {
                  return typeof Vt;
                } : function(Vt) {
                  return Vt && typeof Symbol == "function" && Vt.constructor === Symbol && Vt !== Symbol.prototype ? "symbol" : typeof Vt;
                })(Pt);
              }
              function yn(Pt) {
                if (Pt === void 0)
                  throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return Pt;
              }
              function _r(Pt, Vt) {
                return !Vt || un(Vt) !== "object" && typeof Vt != "function" ? yn(Pt) : Vt;
              }
              function cr(Pt) {
                var Vt = function() {
                  if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                    return false;
                  if (typeof Proxy == "function")
                    return true;
                  try {
                    return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                    })), true;
                  } catch {
                    return false;
                  }
                }();
                return function() {
                  var ut, At = Zt(Pt);
                  if (Vt) {
                    var Dt = Zt(this).constructor;
                    ut = Reflect.construct(At, arguments, Dt);
                  } else
                    ut = At.apply(this, arguments);
                  return _r(this, ut);
                };
              }
              fe.r(re);
              var fa = fe(0), We = fe.n(fa);
              function pn() {
                var Pt = this.constructor.getDerivedStateFromProps(this.props, this.state);
                Pt != null && this.setState(Pt);
              }
              function zn(Pt) {
                this.setState(function(Vt) {
                  var ut = this.constructor.getDerivedStateFromProps(Pt, Vt);
                  return ut != null ? ut : null;
                }.bind(this));
              }
              function pr(Pt, Vt) {
                try {
                  var ut = this.props, At = this.state;
                  this.props = Pt, this.state = Vt, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(ut, At);
                } finally {
                  this.props = ut, this.state = At;
                }
              }
              function fr(Pt) {
                var Vt = Pt.prototype;
                if (!Vt || !Vt.isReactComponent)
                  throw new Error("Can only polyfill class components");
                if (typeof Pt.getDerivedStateFromProps != "function" && typeof Vt.getSnapshotBeforeUpdate != "function")
                  return Pt;
                var ut = null, At = null, Dt = null;
                if (typeof Vt.componentWillMount == "function" ? ut = "componentWillMount" : typeof Vt.UNSAFE_componentWillMount == "function" && (ut = "UNSAFE_componentWillMount"), typeof Vt.componentWillReceiveProps == "function" ? At = "componentWillReceiveProps" : typeof Vt.UNSAFE_componentWillReceiveProps == "function" && (At = "UNSAFE_componentWillReceiveProps"), typeof Vt.componentWillUpdate == "function" ? Dt = "componentWillUpdate" : typeof Vt.UNSAFE_componentWillUpdate == "function" && (Dt = "UNSAFE_componentWillUpdate"), ut !== null || At !== null || Dt !== null) {
                  var Fn = Pt.displayName || Pt.name, mr = typeof Pt.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                  throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Fn + " uses " + mr + " but also contains the following legacy lifecycles:" + (ut !== null ? `
  ` + ut : "") + (At !== null ? `
  ` + At : "") + (Dt !== null ? `
  ` + Dt : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
                }
                if (typeof Pt.getDerivedStateFromProps == "function" && (Vt.componentWillMount = pn, Vt.componentWillReceiveProps = zn), typeof Vt.getSnapshotBeforeUpdate == "function") {
                  if (typeof Vt.componentDidUpdate != "function")
                    throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                  Vt.componentWillUpdate = pr;
                  var nr = Vt.componentDidUpdate;
                  Vt.componentDidUpdate = function(En, ia, xi) {
                    var ds = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : xi;
                    nr.call(this, En, ia, ds);
                  };
                }
                return Pt;
              }
              function Tn(Pt, Vt) {
                if (Pt == null)
                  return {};
                var ut, At, Dt = function(mr, nr) {
                  if (mr == null)
                    return {};
                  var En, ia, xi = {}, ds = Object.keys(mr);
                  for (ia = 0; ia < ds.length; ia++)
                    En = ds[ia], nr.indexOf(En) >= 0 || (xi[En] = mr[En]);
                  return xi;
                }(Pt, Vt);
                if (Object.getOwnPropertySymbols) {
                  var Fn = Object.getOwnPropertySymbols(Pt);
                  for (At = 0; At < Fn.length; At++)
                    ut = Fn[At], Vt.indexOf(ut) >= 0 || Object.prototype.propertyIsEnumerable.call(Pt, ut) && (Dt[ut] = Pt[ut]);
                }
                return Dt;
              }
              function Gn(Pt) {
                var Vt = function(ut) {
                  return {}.toString.call(ut).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                }(Pt);
                return Vt === "number" && (Vt = isNaN(Pt) ? "nan" : (0 | Pt) != Pt ? "float" : "integer"), Vt;
              }
              pn.__suppressDeprecationWarning = true, zn.__suppressDeprecationWarning = true, pr.__suppressDeprecationWarning = true;
              var Tr = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, ra = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, wn = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Ka = fe(45), Ya = function(Pt) {
                var Vt = function(ut) {
                  return { backgroundColor: ut.base00, ellipsisColor: ut.base09, braceColor: ut.base07, expandedIcon: ut.base0D, collapsedIcon: ut.base0E, keyColor: ut.base07, arrayKeyColor: ut.base0C, objectSize: ut.base04, copyToClipboard: ut.base0F, copyToClipboardCheck: ut.base0D, objectBorder: ut.base02, dataTypes: { boolean: ut.base0E, date: ut.base0D, float: ut.base0B, function: ut.base0D, integer: ut.base0F, string: ut.base09, nan: ut.base08, null: ut.base0A, undefined: ut.base05, regexp: ut.base0A, background: ut.base02 }, editVariable: { editIcon: ut.base0E, cancelIcon: ut.base09, removeIcon: ut.base09, addIcon: ut.base0E, checkIcon: ut.base0E, background: ut.base01, color: ut.base0A, border: ut.base07 }, addKeyModal: { background: ut.base05, border: ut.base04, color: ut.base0A, labelColor: ut.base01 }, validationFailure: { background: ut.base09, iconColor: ut.base01, fontColor: ut.base01 } };
                }(Pt);
                return { "app-container": { fontFamily: wn.globalFontFamily, cursor: wn.globalCursor, backgroundColor: Vt.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Vt.ellipsisColor, fontSize: wn.ellipsisFontSize, lineHeight: wn.ellipsisLineHeight, cursor: wn.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: wn.braceCursor, fontWeight: wn.braceFontWeight, color: Vt.braceColor }, "expanded-icon": { color: Vt.expandedIcon }, "collapsed-icon": { color: Vt.collapsedIcon }, colon: { display: "inline-block", margin: wn.keyMargin, color: Vt.keyColor, verticalAlign: "top" }, objectKeyVal: function(ut, At) {
                  return { style: Be({ paddingTop: wn.keyValPaddingTop, paddingRight: wn.keyValPaddingRight, paddingBottom: wn.keyValPaddingBottom, borderLeft: wn.keyValBorderLeft + " " + Vt.objectBorder, ":hover": { paddingLeft: At.paddingLeft - 1 + "px", borderLeft: wn.keyValBorderHover + " " + Vt.objectBorder } }, At) };
                }, "object-key-val-no-border": { padding: wn.keyValPadding }, "pushed-content": { marginLeft: wn.pushedContentMarginLeft }, variableValue: function(ut, At) {
                  return { style: Be({ display: "inline-block", paddingRight: wn.variableValuePaddingRight, position: "relative" }, At) };
                }, "object-name": { display: "inline-block", color: Vt.keyColor, letterSpacing: wn.keyLetterSpacing, fontStyle: wn.keyFontStyle, verticalAlign: wn.keyVerticalAlign, opacity: wn.keyOpacity, ":hover": { opacity: wn.keyOpacityHover } }, "array-key": { display: "inline-block", color: Vt.arrayKeyColor, letterSpacing: wn.keyLetterSpacing, fontStyle: wn.keyFontStyle, verticalAlign: wn.keyVerticalAlign, opacity: wn.keyOpacity, ":hover": { opacity: wn.keyOpacityHover } }, "object-size": { color: Vt.objectSize, borderRadius: wn.objectSizeBorderRadius, fontStyle: wn.objectSizeFontStyle, margin: wn.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: wn.dataTypeFontSize, marginRight: wn.dataTypeMarginRight, opacity: wn.datatypeOpacity }, boolean: { display: "inline-block", color: Vt.dataTypes.boolean }, date: { display: "inline-block", color: Vt.dataTypes.date }, "date-value": { marginLeft: wn.dateValueMarginLeft }, float: { display: "inline-block", color: Vt.dataTypes.float }, function: { display: "inline-block", color: Vt.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Vt.dataTypes.integer }, string: { display: "inline-block", color: Vt.dataTypes.string }, nan: { display: "inline-block", color: Vt.dataTypes.nan, fontSize: wn.nanFontSize, fontWeight: wn.nanFontWeight, backgroundColor: Vt.dataTypes.background, padding: wn.nanPadding, borderRadius: wn.nanBorderRadius }, null: { display: "inline-block", color: Vt.dataTypes.null, fontSize: wn.nullFontSize, fontWeight: wn.nullFontWeight, backgroundColor: Vt.dataTypes.background, padding: wn.nullPadding, borderRadius: wn.nullBorderRadius }, undefined: { display: "inline-block", color: Vt.dataTypes.undefined, fontSize: wn.undefinedFontSize, padding: wn.undefinedPadding, borderRadius: wn.undefinedBorderRadius, backgroundColor: Vt.dataTypes.background }, regexp: { display: "inline-block", color: Vt.dataTypes.regexp }, "copy-to-clipboard": { cursor: wn.clipboardCursor }, "copy-icon": { color: Vt.copyToClipboard, fontSize: wn.iconFontSize, marginRight: wn.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Vt.copyToClipboardCheck, marginLeft: wn.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: wn.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: wn.metaDataPadding }, "icon-container": { display: "inline-block", width: wn.iconContainerWidth }, tooltip: { padding: wn.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Vt.editVariable.removeIcon, cursor: wn.iconCursor, fontSize: wn.iconFontSize, marginRight: wn.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Vt.editVariable.addIcon, cursor: wn.iconCursor, fontSize: wn.iconFontSize, marginRight: wn.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Vt.editVariable.editIcon, cursor: wn.iconCursor, fontSize: wn.iconFontSize, marginRight: wn.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: wn.iconCursor, color: Vt.editVariable.checkIcon, fontSize: wn.iconFontSize, paddingRight: wn.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: wn.iconCursor, color: Vt.editVariable.cancelIcon, fontSize: wn.iconFontSize, paddingRight: wn.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: wn.editInputMinWidth, borderRadius: wn.editInputBorderRadius, backgroundColor: Vt.editVariable.background, color: Vt.editVariable.color, padding: wn.editInputPadding, marginRight: wn.editInputMarginRight, fontFamily: wn.editInputFontFamily }, "detected-row": { paddingTop: wn.detectedRowPaddingTop }, "key-modal-request": { position: wn.addKeyCoverPosition, top: wn.addKeyCoverPositionPx, left: wn.addKeyCoverPositionPx, right: wn.addKeyCoverPositionPx, bottom: wn.addKeyCoverPositionPx, backgroundColor: wn.addKeyCoverBackground }, "key-modal": { width: wn.addKeyModalWidth, backgroundColor: Vt.addKeyModal.background, marginLeft: wn.addKeyModalMargin, marginRight: wn.addKeyModalMargin, padding: wn.addKeyModalPadding, borderRadius: wn.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Vt.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Vt.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Vt.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Vt.addKeyModal.labelColor, fontSize: wn.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Vt.editVariable.addIcon, fontSize: wn.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Vt.ellipsisColor, fontSize: wn.ellipsisFontSize, lineHeight: wn.ellipsisLineHeight, cursor: wn.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Vt.validationFailure.fontColor, backgroundColor: Vt.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Vt.validationFailure.iconColor, fontSize: wn.iconFontSize, transform: "rotate(45deg)" } };
              };
              function vr(Pt, Vt, ut) {
                return Pt || console.error("theme has not been set"), function(At) {
                  var Dt = Tr;
                  return At !== false && At !== "none" || (Dt = ra), Object(Ka.createStyling)(Ya, { defaultBase16: Dt })(At);
                }(Pt)(Vt, ut);
              }
              var Pi = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = (At.rjvId, At.type_name), Fn = At.displayDataTypes, mr = At.theme;
                  return Fn ? We.a.createElement("span", Object.assign({ className: "data-type-label" }, vr(mr, "data-type-label")), Dt) : null;
                } }]), ut;
              }(We.a.PureComponent), xr = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props;
                  return We.a.createElement("div", vr(At.theme, "boolean"), We.a.createElement(Pi, Object.assign({ type_name: "bool" }, At)), At.value ? "true" : "false");
                } }]), ut;
              }(We.a.PureComponent), Xn = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props;
                  return We.a.createElement("div", vr(At.theme, "date"), We.a.createElement(Pi, Object.assign({ type_name: "date" }, At)), We.a.createElement("span", Object.assign({ className: "date-value" }, vr(At.theme, "date-value")), At.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
                } }]), ut;
              }(We.a.PureComponent), Kn = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props;
                  return We.a.createElement("div", vr(At.theme, "float"), We.a.createElement(Pi, Object.assign({ type_name: "float" }, At)), this.props.value);
                } }]), ut;
              }(We.a.PureComponent);
              function ba(Pt, Vt) {
                (Vt == null || Vt > Pt.length) && (Vt = Pt.length);
                for (var ut = 0, At = new Array(Vt); ut < Vt; ut++)
                  At[ut] = Pt[ut];
                return At;
              }
              function la(Pt, Vt) {
                if (Pt) {
                  if (typeof Pt == "string")
                    return ba(Pt, Vt);
                  var ut = Object.prototype.toString.call(Pt).slice(8, -1);
                  return ut === "Object" && Pt.constructor && (ut = Pt.constructor.name), ut === "Map" || ut === "Set" ? Array.from(Pt) : ut === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ut) ? ba(Pt, Vt) : void 0;
                }
              }
              function Xi(Pt, Vt) {
                var ut;
                if (typeof Symbol == "undefined" || Pt[Symbol.iterator] == null) {
                  if (Array.isArray(Pt) || (ut = la(Pt)) || Vt && Pt && typeof Pt.length == "number") {
                    ut && (Pt = ut);
                    var At = 0, Dt = function() {
                    };
                    return { s: Dt, n: function() {
                      return At >= Pt.length ? { done: true } : { done: false, value: Pt[At++] };
                    }, e: function(En) {
                      throw En;
                    }, f: Dt };
                  }
                  throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                }
                var Fn, mr = true, nr = false;
                return { s: function() {
                  ut = Pt[Symbol.iterator]();
                }, n: function() {
                  var En = ut.next();
                  return mr = En.done, En;
                }, e: function(En) {
                  nr = true, Fn = En;
                }, f: function() {
                  try {
                    mr || ut.return == null || ut.return();
                  } finally {
                    if (nr)
                      throw Fn;
                  }
                } };
              }
              function Ys(Pt) {
                return function(Vt) {
                  if (Array.isArray(Vt))
                    return ba(Vt);
                }(Pt) || function(Vt) {
                  if (typeof Symbol != "undefined" && Symbol.iterator in Object(Vt))
                    return Array.from(Vt);
                }(Pt) || la(Pt) || function() {
                  throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                }();
              }
              var Ss = fe(46), Uo = new (fe(47)).Dispatcher(), nu = new (function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  var At;
                  Ze(this, ut);
                  for (var Dt = arguments.length, Fn = new Array(Dt), mr = 0; mr < Dt; mr++)
                    Fn[mr] = arguments[mr];
                  return (At = Vt.call.apply(Vt, [this].concat(Fn))).objects = {}, At.set = function(nr, En, ia, xi) {
                    At.objects[nr] === void 0 && (At.objects[nr] = {}), At.objects[nr][En] === void 0 && (At.objects[nr][En] = {}), At.objects[nr][En][ia] = xi;
                  }, At.get = function(nr, En, ia, xi) {
                    return At.objects[nr] === void 0 || At.objects[nr][En] === void 0 || At.objects[nr][En][ia] == null ? xi : At.objects[nr][En][ia];
                  }, At.handleAction = function(nr) {
                    var En = nr.rjvId, ia = nr.data;
                    switch (nr.name) {
                      case "RESET":
                        At.emit("reset-" + En);
                        break;
                      case "VARIABLE_UPDATED":
                        nr.data.updated_src = At.updateSrc(En, ia), At.set(En, "action", "variable-update", Be(Be({}, ia), {}, { type: "variable-edited" })), At.emit("variable-update-" + En);
                        break;
                      case "VARIABLE_REMOVED":
                        nr.data.updated_src = At.updateSrc(En, ia), At.set(En, "action", "variable-update", Be(Be({}, ia), {}, { type: "variable-removed" })), At.emit("variable-update-" + En);
                        break;
                      case "VARIABLE_ADDED":
                        nr.data.updated_src = At.updateSrc(En, ia), At.set(En, "action", "variable-update", Be(Be({}, ia), {}, { type: "variable-added" })), At.emit("variable-update-" + En);
                        break;
                      case "ADD_VARIABLE_KEY_REQUEST":
                        At.set(En, "action", "new-key-request", ia), At.emit("add-key-request-" + En);
                    }
                  }, At.updateSrc = function(nr, En) {
                    var ia = En.name, xi = En.namespace, ds = En.new_value, Xs = (En.existing_value, En.variable_removed);
                    xi.shift();
                    var Hl, ss = At.get(nr, "global", "src"), $l = At.deepCopy(ss, Ys(xi)), mc = $l, xo = Xi(xi);
                    try {
                      for (xo.s(); !(Hl = xo.n()).done; )
                        mc = mc[Hl.value];
                    } catch (ff) {
                      xo.e(ff);
                    } finally {
                      xo.f();
                    }
                    return Xs ? Gn(mc) == "array" ? mc.splice(ia, 1) : delete mc[ia] : ia !== null ? mc[ia] = ds : $l = ds, At.set(nr, "global", "src", $l), $l;
                  }, At.deepCopy = function(nr, En) {
                    var ia, xi = Gn(nr), ds = En.shift();
                    return xi == "array" ? ia = Ys(nr) : xi == "object" && (ia = Be({}, nr)), ds !== void 0 && (ia[ds] = At.deepCopy(nr[ds], En)), ia;
                  }, At;
                }
                return ut;
              }(Ss.EventEmitter))();
              Uo.register(nu.handleAction.bind(nu));
              var Cs = nu, yl = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).toggleCollapsed = function() {
                    Dt.setState({ collapsed: !Dt.state.collapsed }, function() {
                      Cs.set(Dt.props.rjvId, Dt.props.namespace, "collapsed", Dt.state.collapsed);
                    });
                  }, Dt.getFunctionDisplay = function(Fn) {
                    var mr = yn(Dt).props;
                    return Fn ? We.a.createElement("span", null, Dt.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), We.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, We.a.createElement("span", null, "{"), We.a.createElement("span", vr(mr.theme, "ellipsis"), "..."), We.a.createElement("span", null, "}"))) : Dt.props.value.toString().slice(9, -1);
                  }, Dt.state = { collapsed: Cs.get(At.rjvId, At.namespace, "collapsed", true) }, Dt;
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = this.state.collapsed;
                  return We.a.createElement("div", vr(At.theme, "function"), We.a.createElement(Pi, Object.assign({ type_name: "function" }, At)), We.a.createElement("span", Object.assign({}, vr(At.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Dt)));
                } }]), ut;
              }(We.a.PureComponent), vc = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  return We.a.createElement("div", vr(this.props.theme, "nan"), "NaN");
                } }]), ut;
              }(We.a.PureComponent), Gc = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  return We.a.createElement("div", vr(this.props.theme, "null"), "NULL");
                } }]), ut;
              }(We.a.PureComponent), av = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props;
                  return We.a.createElement("div", vr(At.theme, "integer"), We.a.createElement(Pi, Object.assign({ type_name: "int" }, At)), this.props.value);
                } }]), ut;
              }(We.a.PureComponent), Cg = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props;
                  return We.a.createElement("div", vr(At.theme, "regexp"), We.a.createElement(Pi, Object.assign({ type_name: "regexp" }, At)), this.props.value.toString());
                } }]), ut;
              }(We.a.PureComponent), Sf = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).toggleCollapsed = function() {
                    Dt.setState({ collapsed: !Dt.state.collapsed }, function() {
                      Cs.set(Dt.props.rjvId, Dt.props.namespace, "collapsed", Dt.state.collapsed);
                    });
                  }, Dt.state = { collapsed: Cs.get(At.rjvId, At.namespace, "collapsed", true) }, Dt;
                }
                return yt(ut, [{ key: "render", value: function() {
                  this.state.collapsed;
                  var At = this.props, Dt = At.collapseStringsAfterLength, Fn = At.theme, mr = At.value, nr = { style: { cursor: "default" } };
                  return Gn(Dt) === "integer" && mr.length > Dt && (nr.style.cursor = "pointer", this.state.collapsed && (mr = We.a.createElement("span", null, mr.substring(0, Dt), We.a.createElement("span", vr(Fn, "ellipsis"), " ...")))), We.a.createElement("div", vr(Fn, "string"), We.a.createElement(Pi, Object.assign({ type_name: "string" }, At)), We.a.createElement("span", Object.assign({ className: "string-value" }, nr, { onClick: this.toggleCollapsed }), '"', mr, '"'));
                } }]), ut;
              }(We.a.PureComponent), gp = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  return We.a.createElement("div", vr(this.props.theme, "undefined"), "undefined");
                } }]), ut;
              }(We.a.PureComponent);
              function j0() {
                return (j0 = Object.assign || function(Pt) {
                  for (var Vt = 1; Vt < arguments.length; Vt++) {
                    var ut = arguments[Vt];
                    for (var At in ut)
                      Object.prototype.hasOwnProperty.call(ut, At) && (Pt[At] = ut[At]);
                  }
                  return Pt;
                }).apply(this, arguments);
              }
              var Td = fa.useLayoutEffect, Hh = function(Pt) {
                var Vt = Object(fa.useRef)(Pt);
                return Td(function() {
                  Vt.current = Pt;
                }), Vt;
              }, Mg = function(Pt, Vt) {
                typeof Pt != "function" ? Pt.current = Vt : Pt(Vt);
              }, iv = function(Pt, Vt) {
                var ut = Object(fa.useRef)();
                return Object(fa.useCallback)(function(At) {
                  Pt.current = At, ut.current && Mg(ut.current, null), ut.current = Vt, Vt && Mg(Vt, At);
                }, [Vt]);
              }, Ec = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, uf = function(Pt) {
                Object.keys(Ec).forEach(function(Vt) {
                  Pt.style.setProperty(Vt, Ec[Vt], "important");
                });
              }, Tu = null, ki = function() {
              }, Pr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Hn = !!document.documentElement.currentStyle, Vn = function(Pt, Vt) {
                var ut = Pt.cacheMeasurements, At = Pt.maxRows, Dt = Pt.minRows, Fn = Pt.onChange, mr = Fn === void 0 ? ki : Fn, nr = Pt.onHeightChange, En = nr === void 0 ? ki : nr, ia = function(xo, ff) {
                  if (xo == null)
                    return {};
                  var yp, G0, Bw = {}, Eg = Object.keys(xo);
                  for (G0 = 0; G0 < Eg.length; G0++)
                    yp = Eg[G0], ff.indexOf(yp) >= 0 || (Bw[yp] = xo[yp]);
                  return Bw;
                }(Pt, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), xi, ds = ia.value !== void 0, Xs = Object(fa.useRef)(null), Hl = iv(Xs, Vt), ss = Object(fa.useRef)(0), $l = Object(fa.useRef)(), mc = function() {
                  var xo = Xs.current, ff = ut && $l.current ? $l.current : function(Eg) {
                    var __ = window.getComputedStyle(Eg);
                    if (__ === null)
                      return null;
                    var B1, Hf = (B1 = __, Pr.reduce(function(x_, j1) {
                      return x_[j1] = B1[j1], x_;
                    }, {})), fy = Hf.boxSizing;
                    return fy === "" ? null : (Hn && fy === "border-box" && (Hf.width = parseFloat(Hf.width) + parseFloat(Hf.borderRightWidth) + parseFloat(Hf.borderLeftWidth) + parseFloat(Hf.paddingRight) + parseFloat(Hf.paddingLeft) + "px"), { sizingStyle: Hf, paddingSize: parseFloat(Hf.paddingBottom) + parseFloat(Hf.paddingTop), borderSize: parseFloat(Hf.borderBottomWidth) + parseFloat(Hf.borderTopWidth) });
                  }(xo);
                  if (ff) {
                    $l.current = ff;
                    var yp = function(Eg, __, B1, Hf) {
                      B1 === void 0 && (B1 = 1), Hf === void 0 && (Hf = 1 / 0), Tu || ((Tu = document.createElement("textarea")).setAttribute("tab-index", "-1"), Tu.setAttribute("aria-hidden", "true"), uf(Tu)), Tu.parentNode === null && document.body.appendChild(Tu);
                      var fy = Eg.paddingSize, x_ = Eg.borderSize, j1 = Eg.sizingStyle, jw = j1.boxSizing;
                      Object.keys(j1).forEach(function(vh) {
                        var w_ = vh;
                        Tu.style[w_] = j1[w_];
                      }), uf(Tu), Tu.value = __;
                      var Gw = function(vh, w_) {
                        var iI = vh.scrollHeight;
                        return w_.sizingStyle.boxSizing === "border-box" ? iI + w_.borderSize : iI - w_.paddingSize;
                      }(Tu, Eg);
                      Tu.value = "x";
                      var aI = Tu.scrollHeight - fy, iC = aI * B1;
                      jw === "border-box" && (iC = iC + fy + x_), Gw = Math.max(iC, Gw);
                      var oC = aI * Hf;
                      return jw === "border-box" && (oC = oC + fy + x_), [Gw = Math.min(oC, Gw), aI];
                    }(ff, xo.value || xo.placeholder || "x", Dt, At), G0 = yp[0], Bw = yp[1];
                    ss.current !== G0 && (ss.current = G0, xo.style.setProperty("height", G0 + "px", "important"), En(G0, { rowHeight: Bw }));
                  }
                };
                return Object(fa.useLayoutEffect)(mc), xi = Hh(mc), Object(fa.useLayoutEffect)(function() {
                  var xo = function(ff) {
                    xi.current(ff);
                  };
                  return window.addEventListener("resize", xo), function() {
                    window.removeEventListener("resize", xo);
                  };
                }, []), Object(fa.createElement)("textarea", j0({}, ia, { onChange: function(xo) {
                  ds || mc(), mr(xo);
                }, ref: Hl }));
              }, Br = Object(fa.forwardRef)(Vn);
              function ka(Pt) {
                Pt = Pt.trim();
                try {
                  if ((Pt = JSON.stringify(JSON.parse(Pt)))[0] === "[")
                    return gi("array", JSON.parse(Pt));
                  if (Pt[0] === "{")
                    return gi("object", JSON.parse(Pt));
                  if (Pt.match(/\-?\d+\.\d+/) && Pt.match(/\-?\d+\.\d+/)[0] === Pt)
                    return gi("float", parseFloat(Pt));
                  if (Pt.match(/\-?\d+e-\d+/) && Pt.match(/\-?\d+e-\d+/)[0] === Pt)
                    return gi("float", Number(Pt));
                  if (Pt.match(/\-?\d+/) && Pt.match(/\-?\d+/)[0] === Pt)
                    return gi("integer", parseInt(Pt));
                  if (Pt.match(/\-?\d+e\+\d+/) && Pt.match(/\-?\d+e\+\d+/)[0] === Pt)
                    return gi("integer", Number(Pt));
                } catch {
                }
                switch (Pt = Pt.toLowerCase()) {
                  case "undefined":
                    return gi("undefined", void 0);
                  case "nan":
                    return gi("nan", NaN);
                  case "null":
                    return gi("null", null);
                  case "true":
                    return gi("boolean", true);
                  case "false":
                    return gi("boolean", false);
                  default:
                    if (Pt = Date.parse(Pt))
                      return gi("date", new Date(Pt));
                }
                return gi(false, null);
              }
              function gi(Pt, Vt) {
                return { type: Pt, value: Vt };
              }
              var Ri = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
                } }]), ut;
              }(We.a.PureComponent), qo = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
                } }]), ut;
              }(We.a.PureComponent), Il = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]), mr = Zs(Dt).style;
                  return We.a.createElement("span", Fn, We.a.createElement("svg", { fill: mr.color, width: mr.height, height: mr.width, style: mr, viewBox: "0 0 1792 1792" }, We.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                } }]), ut;
              }(We.a.PureComponent), Wu = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]), mr = Zs(Dt).style;
                  return We.a.createElement("span", Fn, We.a.createElement("svg", { fill: mr.color, width: mr.height, height: mr.width, style: mr, viewBox: "0 0 1792 1792" }, We.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                } }]), ut;
              }(We.a.PureComponent), Du = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", { style: Be(Be({}, Zs(Dt).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, We.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
                } }]), ut;
              }(We.a.PureComponent), Wc = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", { style: Be(Be({}, Zs(Dt).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, We.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
                } }]), ut;
              }(We.a.PureComponent), ku = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("g", null, We.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
                } }]), ut;
              }(We.a.PureComponent), Dd = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("g", null, We.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), ut;
              }(We.a.PureComponent), mp = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("g", null, We.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), ut;
              }(We.a.PureComponent), Cf = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("g", null, We.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
                } }]), ut;
              }(We.a.PureComponent), ru = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("g", null, We.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
                } }]), ut;
              }(We.a.PureComponent), gc = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.style, Fn = Tn(At, ["style"]);
                  return We.a.createElement("span", Fn, We.a.createElement("svg", Object.assign({}, Zs(Dt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), We.a.createElement("g", null, We.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), ut;
              }(We.a.PureComponent);
              function Zs(Pt) {
                return Pt || (Pt = {}), { style: Be(Be({ verticalAlign: "middle" }, Pt), {}, { color: Pt.color ? Pt.color : "#000000", height: "1em", width: "1em" }) };
              }
              var cf = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).copiedTimer = null, Dt.handleCopy = function() {
                    var Fn = document.createElement("textarea"), mr = Dt.props, nr = mr.clickCallback, En = mr.src, ia = mr.namespace;
                    Fn.innerHTML = JSON.stringify(Dt.clipboardValue(En), null, "  "), document.body.appendChild(Fn), Fn.select(), document.execCommand("copy"), document.body.removeChild(Fn), Dt.copiedTimer = setTimeout(function() {
                      Dt.setState({ copied: false });
                    }, 5500), Dt.setState({ copied: true }, function() {
                      typeof nr == "function" && nr({ src: En, namespace: ia, name: ia[ia.length - 1] });
                    });
                  }, Dt.getClippyIcon = function() {
                    var Fn = Dt.props.theme;
                    return Dt.state.copied ? We.a.createElement("span", null, We.a.createElement(ku, Object.assign({ className: "copy-icon" }, vr(Fn, "copy-icon"))), We.a.createElement("span", vr(Fn, "copy-icon-copied"), "\u2714")) : We.a.createElement(ku, Object.assign({ className: "copy-icon" }, vr(Fn, "copy-icon")));
                  }, Dt.clipboardValue = function(Fn) {
                    switch (Gn(Fn)) {
                      case "function":
                      case "regexp":
                        return Fn.toString();
                      default:
                        return Fn;
                    }
                  }, Dt.state = { copied: false }, Dt;
                }
                return yt(ut, [{ key: "componentWillUnmount", value: function() {
                  this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
                } }, { key: "render", value: function() {
                  var At = this.props, Dt = (At.src, At.theme), Fn = At.hidden, mr = At.rowHovered, nr = vr(Dt, "copy-to-clipboard").style, En = "inline";
                  return Fn && (En = "none"), We.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: mr ? "inline-block" : "none" } }, We.a.createElement("span", { style: Be(Be({}, nr), {}, { display: En }), onClick: this.handleCopy }, this.getClippyIcon()));
                } }]), ut;
              }(We.a.PureComponent), $h = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).getEditIcon = function() {
                    var Fn = Dt.props, mr = Fn.variable, nr = Fn.theme;
                    return We.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Dt.state.hovered ? "inline-block" : "none" } }, We.a.createElement(ru, Object.assign({ className: "click-to-edit-icon" }, vr(nr, "editVarIcon"), { onClick: function() {
                      Dt.prepopInput(mr);
                    } })));
                  }, Dt.prepopInput = function(Fn) {
                    if (Dt.props.onEdit !== false) {
                      var mr = function(En) {
                        var ia;
                        switch (Gn(En)) {
                          case "undefined":
                            ia = "undefined";
                            break;
                          case "nan":
                            ia = "NaN";
                            break;
                          case "string":
                            ia = En;
                            break;
                          case "date":
                          case "function":
                          case "regexp":
                            ia = En.toString();
                            break;
                          default:
                            try {
                              ia = JSON.stringify(En, null, "  ");
                            } catch {
                              ia = "";
                            }
                        }
                        return ia;
                      }(Fn.value), nr = ka(mr);
                      Dt.setState({ editMode: true, editValue: mr, parsedInput: { type: nr.type, value: nr.value } });
                    }
                  }, Dt.getRemoveIcon = function() {
                    var Fn = Dt.props, mr = Fn.variable, nr = Fn.namespace, En = Fn.theme, ia = Fn.rjvId;
                    return We.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Dt.state.hovered ? "inline-block" : "none" } }, We.a.createElement(Dd, Object.assign({ className: "click-to-remove-icon" }, vr(En, "removeVarIcon"), { onClick: function() {
                      Uo.dispatch({ name: "VARIABLE_REMOVED", rjvId: ia, data: { name: mr.name, namespace: nr, existing_value: mr.value, variable_removed: true } });
                    } })));
                  }, Dt.getValue = function(Fn, mr) {
                    var nr = !mr && Fn.type, En = yn(Dt).props;
                    switch (nr) {
                      case false:
                        return Dt.getEditInput();
                      case "string":
                        return We.a.createElement(Sf, Object.assign({ value: Fn.value }, En));
                      case "integer":
                        return We.a.createElement(av, Object.assign({ value: Fn.value }, En));
                      case "float":
                        return We.a.createElement(Kn, Object.assign({ value: Fn.value }, En));
                      case "boolean":
                        return We.a.createElement(xr, Object.assign({ value: Fn.value }, En));
                      case "function":
                        return We.a.createElement(yl, Object.assign({ value: Fn.value }, En));
                      case "null":
                        return We.a.createElement(Gc, En);
                      case "nan":
                        return We.a.createElement(vc, En);
                      case "undefined":
                        return We.a.createElement(gp, En);
                      case "date":
                        return We.a.createElement(Xn, Object.assign({ value: Fn.value }, En));
                      case "regexp":
                        return We.a.createElement(Cg, Object.assign({ value: Fn.value }, En));
                      default:
                        return We.a.createElement("div", { className: "object-value" }, JSON.stringify(Fn.value));
                    }
                  }, Dt.getEditInput = function() {
                    var Fn = Dt.props.theme, mr = Dt.state.editValue;
                    return We.a.createElement("div", null, We.a.createElement(Br, Object.assign({ type: "text", inputRef: function(nr) {
                      return nr && nr.focus();
                    }, value: mr, className: "variable-editor", onChange: function(nr) {
                      var En = nr.target.value, ia = ka(En);
                      Dt.setState({ editValue: En, parsedInput: { type: ia.type, value: ia.value } });
                    }, onKeyDown: function(nr) {
                      switch (nr.key) {
                        case "Escape":
                          Dt.setState({ editMode: false, editValue: "" });
                          break;
                        case "Enter":
                          (nr.ctrlKey || nr.metaKey) && Dt.submitEdit(true);
                      }
                      nr.stopPropagation();
                    }, placeholder: "update this value", minRows: 2 }, vr(Fn, "edit-input"))), We.a.createElement("div", vr(Fn, "edit-icon-container"), We.a.createElement(Dd, Object.assign({ className: "edit-cancel" }, vr(Fn, "cancel-icon"), { onClick: function() {
                      Dt.setState({ editMode: false, editValue: "" });
                    } })), We.a.createElement(gc, Object.assign({ className: "edit-check string-value" }, vr(Fn, "check-icon"), { onClick: function() {
                      Dt.submitEdit();
                    } })), We.a.createElement("div", null, Dt.showDetected())));
                  }, Dt.submitEdit = function(Fn) {
                    var mr = Dt.props, nr = mr.variable, En = mr.namespace, ia = mr.rjvId, xi = Dt.state, ds = xi.editValue, Xs = xi.parsedInput, Hl = ds;
                    Fn && Xs.type && (Hl = Xs.value), Dt.setState({ editMode: false }), Uo.dispatch({ name: "VARIABLE_UPDATED", rjvId: ia, data: { name: nr.name, namespace: En, existing_value: nr.value, new_value: Hl, variable_removed: false } });
                  }, Dt.showDetected = function() {
                    var Fn = Dt.props, mr = Fn.theme, nr = (Fn.variable, Fn.namespace, Fn.rjvId, Dt.state.parsedInput), En = (nr.type, nr.value, Dt.getDetectedInput());
                    if (En)
                      return We.a.createElement("div", null, We.a.createElement("div", vr(mr, "detected-row"), En, We.a.createElement(gc, { className: "edit-check detected", style: Be({ verticalAlign: "top", paddingLeft: "3px" }, vr(mr, "check-icon").style), onClick: function() {
                        Dt.submitEdit(true);
                      } })));
                  }, Dt.getDetectedInput = function() {
                    var Fn = Dt.state.parsedInput, mr = Fn.type, nr = Fn.value, En = yn(Dt).props, ia = En.theme;
                    if (mr !== false)
                      switch (mr.toLowerCase()) {
                        case "object":
                          return We.a.createElement("span", null, We.a.createElement("span", { style: Be(Be({}, vr(ia, "brace").style), {}, { cursor: "default" }) }, "{"), We.a.createElement("span", { style: Be(Be({}, vr(ia, "ellipsis").style), {}, { cursor: "default" }) }, "..."), We.a.createElement("span", { style: Be(Be({}, vr(ia, "brace").style), {}, { cursor: "default" }) }, "}"));
                        case "array":
                          return We.a.createElement("span", null, We.a.createElement("span", { style: Be(Be({}, vr(ia, "brace").style), {}, { cursor: "default" }) }, "["), We.a.createElement("span", { style: Be(Be({}, vr(ia, "ellipsis").style), {}, { cursor: "default" }) }, "..."), We.a.createElement("span", { style: Be(Be({}, vr(ia, "brace").style), {}, { cursor: "default" }) }, "]"));
                        case "string":
                          return We.a.createElement(Sf, Object.assign({ value: nr }, En));
                        case "integer":
                          return We.a.createElement(av, Object.assign({ value: nr }, En));
                        case "float":
                          return We.a.createElement(Kn, Object.assign({ value: nr }, En));
                        case "boolean":
                          return We.a.createElement(xr, Object.assign({ value: nr }, En));
                        case "function":
                          return We.a.createElement(yl, Object.assign({ value: nr }, En));
                        case "null":
                          return We.a.createElement(Gc, En);
                        case "nan":
                          return We.a.createElement(vc, En);
                        case "undefined":
                          return We.a.createElement(gp, En);
                        case "date":
                          return We.a.createElement(Xn, Object.assign({ value: new Date(nr) }, En));
                      }
                  }, Dt.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Dt;
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this, Dt = this.props, Fn = Dt.variable, mr = Dt.singleIndent, nr = Dt.type, En = Dt.theme, ia = Dt.namespace, xi = Dt.indentWidth, ds = Dt.enableClipboard, Xs = Dt.onEdit, Hl = Dt.onDelete, ss = Dt.onSelect, $l = Dt.displayArrayKey, mc = Dt.quotesOnKeys, xo = this.state.editMode;
                  return We.a.createElement("div", Object.assign({}, vr(En, "objectKeyVal", { paddingLeft: xi * mr }), { onMouseEnter: function() {
                    return At.setState(Be(Be({}, At.state), {}, { hovered: true }));
                  }, onMouseLeave: function() {
                    return At.setState(Be(Be({}, At.state), {}, { hovered: false }));
                  }, className: "variable-row", key: Fn.name }), nr == "array" ? $l ? We.a.createElement("span", Object.assign({}, vr(En, "array-key"), { key: Fn.name + "_" + ia }), Fn.name, We.a.createElement("div", vr(En, "colon"), ":")) : null : We.a.createElement("span", null, We.a.createElement("span", Object.assign({}, vr(En, "object-name"), { className: "object-key", key: Fn.name + "_" + ia }), !!mc && We.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), We.a.createElement("span", { style: { display: "inline-block" } }, Fn.name), !!mc && We.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), We.a.createElement("span", vr(En, "colon"), ":")), We.a.createElement("div", Object.assign({ className: "variable-value", onClick: ss === false && Xs === false ? null : function(ff) {
                    var yp = Ys(ia);
                    (ff.ctrlKey || ff.metaKey) && Xs !== false ? At.prepopInput(Fn) : ss !== false && (yp.shift(), ss(Be(Be({}, Fn), {}, { namespace: yp })));
                  } }, vr(En, "variableValue", { cursor: ss === false ? "default" : "pointer" })), this.getValue(Fn, xo)), ds ? We.a.createElement(cf, { rowHovered: this.state.hovered, hidden: xo, src: Fn.value, clickCallback: ds, theme: En, namespace: [].concat(Ys(ia), [Fn.name]) }) : null, Xs !== false && xo == 0 ? this.getEditIcon() : null, Hl !== false && xo == 0 ? this.getRemoveIcon() : null);
                } }]), ut;
              }(We.a.PureComponent), Ag = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  var At;
                  Ze(this, ut);
                  for (var Dt = arguments.length, Fn = new Array(Dt), mr = 0; mr < Dt; mr++)
                    Fn[mr] = arguments[mr];
                  return (At = Vt.call.apply(Vt, [this].concat(Fn))).getObjectSize = function() {
                    var nr = At.props, En = nr.size, ia = nr.theme;
                    if (nr.displayObjectSize)
                      return We.a.createElement("span", Object.assign({ className: "object-size" }, vr(ia, "object-size")), En, " item", En === 1 ? "" : "s");
                  }, At.getAddAttribute = function(nr) {
                    var En = At.props, ia = En.theme, xi = En.namespace, ds = En.name, Xs = En.src, Hl = En.rjvId, ss = En.depth;
                    return We.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: nr ? "inline-block" : "none" } }, We.a.createElement(mp, Object.assign({ className: "click-to-add-icon" }, vr(ia, "addVarIcon"), { onClick: function() {
                      var $l = { name: ss > 0 ? ds : null, namespace: xi.splice(0, xi.length - 1), existing_value: Xs, variable_removed: false, key_name: null };
                      Gn(Xs) === "object" ? Uo.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Hl, data: $l }) : Uo.dispatch({ name: "VARIABLE_ADDED", rjvId: Hl, data: Be(Be({}, $l), {}, { new_value: [].concat(Ys(Xs), [null]) }) });
                    } })));
                  }, At.getRemoveObject = function(nr) {
                    var En = At.props, ia = En.theme, xi = (En.hover, En.namespace), ds = En.name, Xs = En.src, Hl = En.rjvId;
                    if (xi.length !== 1)
                      return We.a.createElement("span", { className: "click-to-remove", style: { display: nr ? "inline-block" : "none" } }, We.a.createElement(Dd, Object.assign({ className: "click-to-remove-icon" }, vr(ia, "removeVarIcon"), { onClick: function() {
                        Uo.dispatch({ name: "VARIABLE_REMOVED", rjvId: Hl, data: { name: ds, namespace: xi.splice(0, xi.length - 1), existing_value: Xs, variable_removed: true } });
                      } })));
                  }, At.render = function() {
                    var nr = At.props, En = nr.theme, ia = nr.onDelete, xi = nr.onAdd, ds = nr.enableClipboard, Xs = nr.src, Hl = nr.namespace, ss = nr.rowHovered;
                    return We.a.createElement("div", Object.assign({}, vr(En, "object-meta-data"), { className: "object-meta-data", onClick: function($l) {
                      $l.stopPropagation();
                    } }), At.getObjectSize(), ds ? We.a.createElement(cf, { rowHovered: ss, clickCallback: ds, src: Xs, theme: En, namespace: Hl }) : null, xi !== false ? At.getAddAttribute(ss) : null, ia !== false ? At.getRemoveObject(ss) : null);
                  }, At;
                }
                return ut;
              }(We.a.PureComponent);
              function ph(Pt) {
                var Vt = Pt.parent_type, ut = Pt.namespace, At = Pt.quotesOnKeys, Dt = Pt.theme, Fn = Pt.jsvRoot, mr = Pt.name, nr = Pt.displayArrayKey, En = Pt.name ? Pt.name : "";
                return !Fn || mr !== false && mr !== null ? Vt == "array" ? nr ? We.a.createElement("span", Object.assign({}, vr(Dt, "array-key"), { key: ut }), We.a.createElement("span", { className: "array-key" }, En), We.a.createElement("span", vr(Dt, "colon"), ":")) : We.a.createElement("span", null) : We.a.createElement("span", Object.assign({}, vr(Dt, "object-name"), { key: ut }), We.a.createElement("span", { className: "object-key" }, At && We.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), We.a.createElement("span", null, En), At && We.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), We.a.createElement("span", vr(Dt, "colon"), ":")) : We.a.createElement("span", null);
              }
              function kd(Pt) {
                var Vt = Pt.theme;
                switch (Pt.iconStyle) {
                  case "triangle":
                    return We.a.createElement(Wc, Object.assign({}, vr(Vt, "expanded-icon"), { className: "expanded-icon" }));
                  case "square":
                    return We.a.createElement(Il, Object.assign({}, vr(Vt, "expanded-icon"), { className: "expanded-icon" }));
                  default:
                    return We.a.createElement(Ri, Object.assign({}, vr(Vt, "expanded-icon"), { className: "expanded-icon" }));
                }
              }
              function ov(Pt) {
                var Vt = Pt.theme;
                switch (Pt.iconStyle) {
                  case "triangle":
                    return We.a.createElement(Du, Object.assign({}, vr(Vt, "collapsed-icon"), { className: "collapsed-icon" }));
                  case "square":
                    return We.a.createElement(Wu, Object.assign({}, vr(Vt, "collapsed-icon"), { className: "collapsed-icon" }));
                  default:
                    return We.a.createElement(qo, Object.assign({}, vr(Vt, "collapsed-icon"), { className: "collapsed-icon" }));
                }
              }
              var y_ = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).toggleCollapsed = function(Fn) {
                    var mr = [];
                    for (var nr in Dt.state.expanded)
                      mr.push(Dt.state.expanded[nr]);
                    mr[Fn] = !mr[Fn], Dt.setState({ expanded: mr });
                  }, Dt.state = { expanded: [] }, Dt;
                }
                return yt(ut, [{ key: "getExpandedIcon", value: function(At) {
                  var Dt = this.props, Fn = Dt.theme, mr = Dt.iconStyle;
                  return this.state.expanded[At] ? We.a.createElement(kd, { theme: Fn, iconStyle: mr }) : We.a.createElement(ov, { theme: Fn, iconStyle: mr });
                } }, { key: "render", value: function() {
                  var At = this, Dt = this.props, Fn = Dt.src, mr = Dt.groupArraysAfterLength, nr = (Dt.depth, Dt.name), En = Dt.theme, ia = Dt.jsvRoot, xi = Dt.namespace, ds = (Dt.parent_type, Tn(Dt, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Xs = 0, Hl = 5 * this.props.indentWidth;
                  ia || (Xs = 5 * this.props.indentWidth);
                  var ss = mr, $l = Math.ceil(Fn.length / ss);
                  return We.a.createElement("div", Object.assign({ className: "object-key-val" }, vr(En, ia ? "jsv-root" : "objectKeyVal", { paddingLeft: Xs })), We.a.createElement(ph, this.props), We.a.createElement("span", null, We.a.createElement(Ag, Object.assign({ size: Fn.length }, this.props))), Ys(Array($l)).map(function(mc, xo) {
                    return We.a.createElement("div", Object.assign({ key: xo, className: "object-key-val array-group" }, vr(En, "objectKeyVal", { marginLeft: 6, paddingLeft: Hl })), We.a.createElement("span", vr(En, "brace-row"), We.a.createElement("div", Object.assign({ className: "icon-container" }, vr(En, "icon-container"), { onClick: function(ff) {
                      At.toggleCollapsed(xo);
                    } }), At.getExpandedIcon(xo)), At.state.expanded[xo] ? We.a.createElement(b_, Object.assign({ key: nr + xo, depth: 0, name: false, collapsed: false, groupArraysAfterLength: ss, index_offset: xo * ss, src: Fn.slice(xo * ss, xo * ss + ss), namespace: xi, type: "array", parent_type: "array_group", theme: En }, ds)) : We.a.createElement("span", Object.assign({}, vr(En, "brace"), { onClick: function(ff) {
                      At.toggleCollapsed(xo);
                    }, className: "array-group-brace" }), "[", We.a.createElement("div", Object.assign({}, vr(En, "array-group-meta-data"), { className: "array-group-meta-data" }), We.a.createElement("span", Object.assign({ className: "object-size" }, vr(En, "object-size")), xo * ss, " - ", xo * ss + ss > Fn.length ? Fn.length : xo * ss + ss)), "]")));
                  }));
                } }]), ut;
              }(We.a.PureComponent), z1 = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  Ze(this, ut), (Dt = Vt.call(this, At)).toggleCollapsed = function() {
                    Dt.setState({ expanded: !Dt.state.expanded }, function() {
                      Cs.set(Dt.props.rjvId, Dt.props.namespace, "expanded", Dt.state.expanded);
                    });
                  }, Dt.getObjectContent = function(mr, nr, En) {
                    return We.a.createElement("div", { className: "pushed-content object-container" }, We.a.createElement("div", Object.assign({ className: "object-content" }, vr(Dt.props.theme, "pushed-content")), Dt.renderObjectContents(nr, En)));
                  }, Dt.getEllipsis = function() {
                    return Dt.state.size === 0 ? null : We.a.createElement("div", Object.assign({}, vr(Dt.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Dt.toggleCollapsed }), "...");
                  }, Dt.getObjectMetaData = function(mr) {
                    var nr = Dt.props, En = (nr.rjvId, nr.theme, Dt.state), ia = En.size, xi = En.hovered;
                    return We.a.createElement(Ag, Object.assign({ rowHovered: xi, size: ia }, Dt.props));
                  }, Dt.renderObjectContents = function(mr, nr) {
                    var En, ia = Dt.props, xi = ia.depth, ds = ia.parent_type, Xs = ia.index_offset, Hl = ia.groupArraysAfterLength, ss = ia.namespace, $l = Dt.state.object_type, mc = [], xo = Object.keys(mr || {});
                    return Dt.props.sortKeys && $l !== "array" && (xo = xo.sort()), xo.forEach(function(ff) {
                      if (En = new lF(ff, mr[ff]), ds === "array_group" && Xs && (En.name = parseInt(En.name) + Xs), mr.hasOwnProperty(ff))
                        if (En.type === "object")
                          mc.push(We.a.createElement(b_, Object.assign({ key: En.name, depth: xi + 1, name: En.name, src: En.value, namespace: ss.concat(En.name), parent_type: $l }, nr)));
                        else if (En.type === "array") {
                          var yp = b_;
                          Hl && En.value.length > Hl && (yp = y_), mc.push(We.a.createElement(yp, Object.assign({ key: En.name, depth: xi + 1, name: En.name, src: En.value, namespace: ss.concat(En.name), type: "array", parent_type: $l }, nr)));
                        } else
                          mc.push(We.a.createElement($h, Object.assign({ key: En.name + "_" + ss, variable: En, singleIndent: 5, namespace: ss, type: Dt.props.type }, nr)));
                    }), mc;
                  };
                  var Fn = ut.getState(At);
                  return Dt.state = Be(Be({}, Fn), {}, { prevProps: {} }), Dt;
                }
                return yt(ut, [{ key: "getBraceStart", value: function(At, Dt) {
                  var Fn = this, mr = this.props, nr = mr.src, En = mr.theme, ia = mr.iconStyle;
                  if (mr.parent_type === "array_group")
                    return We.a.createElement("span", null, We.a.createElement("span", vr(En, "brace"), At === "array" ? "[" : "{"), Dt ? this.getObjectMetaData(nr) : null);
                  var xi = Dt ? kd : ov;
                  return We.a.createElement("span", null, We.a.createElement("span", Object.assign({ onClick: function(ds) {
                    Fn.toggleCollapsed();
                  } }, vr(En, "brace-row")), We.a.createElement("div", Object.assign({ className: "icon-container" }, vr(En, "icon-container")), We.a.createElement(xi, { theme: En, iconStyle: ia })), We.a.createElement(ph, this.props), We.a.createElement("span", vr(En, "brace"), At === "array" ? "[" : "{")), Dt ? this.getObjectMetaData(nr) : null);
                } }, { key: "render", value: function() {
                  var At = this, Dt = this.props, Fn = Dt.depth, mr = Dt.src, nr = (Dt.namespace, Dt.name, Dt.type, Dt.parent_type), En = Dt.theme, ia = Dt.jsvRoot, xi = Dt.iconStyle, ds = Tn(Dt, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Xs = this.state, Hl = Xs.object_type, ss = Xs.expanded, $l = {};
                  return ia || nr === "array_group" ? nr === "array_group" && ($l.borderLeft = 0, $l.display = "inline") : $l.paddingLeft = 5 * this.props.indentWidth, We.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                    return At.setState(Be(Be({}, At.state), {}, { hovered: true }));
                  }, onMouseLeave: function() {
                    return At.setState(Be(Be({}, At.state), {}, { hovered: false }));
                  } }, vr(En, ia ? "jsv-root" : "objectKeyVal", $l)), this.getBraceStart(Hl, ss), ss ? this.getObjectContent(Fn, mr, Be({ theme: En, iconStyle: xi }, ds)) : this.getEllipsis(), We.a.createElement("span", { className: "brace-row" }, We.a.createElement("span", { style: Be(Be({}, vr(En, "brace").style), {}, { paddingLeft: ss ? "3px" : "0px" }) }, Hl === "array" ? "]" : "}"), ss ? null : this.getObjectMetaData(mr)));
                } }], [{ key: "getDerivedStateFromProps", value: function(At, Dt) {
                  var Fn = Dt.prevProps;
                  return At.src !== Fn.src || At.collapsed !== Fn.collapsed || At.name !== Fn.name || At.namespace !== Fn.namespace || At.rjvId !== Fn.rjvId ? Be(Be({}, ut.getState(At)), {}, { prevProps: At }) : null;
                } }]), ut;
              }(We.a.PureComponent);
              z1.getState = function(Pt) {
                var Vt = Object.keys(Pt.src).length, ut = (Pt.collapsed === false || Pt.collapsed !== true && Pt.collapsed > Pt.depth) && (!Pt.shouldCollapse || Pt.shouldCollapse({ name: Pt.name, src: Pt.src, type: Gn(Pt.src), namespace: Pt.namespace }) === false) && Vt !== 0;
                return { expanded: Cs.get(Pt.rjvId, Pt.namespace, "expanded", ut), object_type: Pt.type === "array" ? "array" : "object", parent_type: Pt.type === "array" ? "array" : "object", size: Vt, hovered: false };
              };
              var lF = function Pt(Vt, ut) {
                Ze(this, Pt), this.name = Vt, this.value = ut, this.type = Gn(ut);
              };
              fr(z1);
              var b_ = z1, pP = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  var At;
                  Ze(this, ut);
                  for (var Dt = arguments.length, Fn = new Array(Dt), mr = 0; mr < Dt; mr++)
                    Fn[mr] = arguments[mr];
                  return (At = Vt.call.apply(Vt, [this].concat(Fn))).render = function() {
                    var nr = yn(At).props, En = [nr.name], ia = b_;
                    return Array.isArray(nr.src) && nr.groupArraysAfterLength && nr.src.length > nr.groupArraysAfterLength && (ia = y_), We.a.createElement("div", { className: "pretty-json-container object-container" }, We.a.createElement("div", { className: "object-content" }, We.a.createElement(ia, Object.assign({ namespace: En, depth: 0, jsvRoot: true }, nr))));
                  }, At;
                }
                return ut;
              }(We.a.PureComponent), vP = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).closeModal = function() {
                    Uo.dispatch({ rjvId: Dt.props.rjvId, name: "RESET" });
                  }, Dt.submit = function() {
                    Dt.props.submit(Dt.state.input);
                  }, Dt.state = { input: At.input ? At.input : "" }, Dt;
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this, Dt = this.props, Fn = Dt.theme, mr = Dt.rjvId, nr = Dt.isValid, En = this.state.input, ia = nr(En);
                  return We.a.createElement("div", Object.assign({ className: "key-modal-request" }, vr(Fn, "key-modal-request"), { onClick: this.closeModal }), We.a.createElement("div", Object.assign({}, vr(Fn, "key-modal"), { onClick: function(xi) {
                    xi.stopPropagation();
                  } }), We.a.createElement("div", vr(Fn, "key-modal-label"), "Key Name:"), We.a.createElement("div", { style: { position: "relative" } }, We.a.createElement("input", Object.assign({}, vr(Fn, "key-modal-input"), { className: "key-modal-input", ref: function(xi) {
                    return xi && xi.focus();
                  }, spellCheck: false, value: En, placeholder: "...", onChange: function(xi) {
                    At.setState({ input: xi.target.value });
                  }, onKeyPress: function(xi) {
                    ia && xi.key === "Enter" ? At.submit() : xi.key === "Escape" && At.closeModal();
                  } })), ia ? We.a.createElement(gc, Object.assign({}, vr(Fn, "key-modal-submit"), { className: "key-modal-submit", onClick: function(xi) {
                    return At.submit();
                  } })) : null), We.a.createElement("span", vr(Fn, "key-modal-cancel"), We.a.createElement(Cf, Object.assign({}, vr(Fn, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                    Uo.dispatch({ rjvId: mr, name: "RESET" });
                  } })))));
                } }]), ut;
              }(We.a.PureComponent), uF = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  var At;
                  Ze(this, ut);
                  for (var Dt = arguments.length, Fn = new Array(Dt), mr = 0; mr < Dt; mr++)
                    Fn[mr] = arguments[mr];
                  return (At = Vt.call.apply(Vt, [this].concat(Fn))).isValid = function(nr) {
                    var En = At.props.rjvId, ia = Cs.get(En, "action", "new-key-request");
                    return nr != "" && Object.keys(ia.existing_value).indexOf(nr) === -1;
                  }, At.submit = function(nr) {
                    var En = At.props.rjvId, ia = Cs.get(En, "action", "new-key-request");
                    ia.new_value = Be({}, ia.existing_value), ia.new_value[nr] = At.props.defaultValue, Uo.dispatch({ name: "VARIABLE_ADDED", rjvId: En, data: ia });
                  }, At;
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.active, Fn = At.theme, mr = At.rjvId;
                  return Dt ? We.a.createElement(vP, { rjvId: mr, theme: Fn, isValid: this.isValid, submit: this.submit }) : null;
                } }]), ut;
              }(We.a.PureComponent), rI = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut() {
                  return Ze(this, ut), Vt.apply(this, arguments);
                }
                return yt(ut, [{ key: "render", value: function() {
                  var At = this.props, Dt = At.message, Fn = At.active, mr = At.theme, nr = At.rjvId;
                  return Fn ? We.a.createElement("div", Object.assign({ className: "validation-failure" }, vr(mr, "validation-failure"), { onClick: function() {
                    Uo.dispatch({ rjvId: nr, name: "RESET" });
                  } }), We.a.createElement("span", vr(mr, "validation-failure-label"), Dt), We.a.createElement(Cf, vr(mr, "validation-failure-clear"))) : null;
                } }]), ut;
              }(We.a.PureComponent), zw = function(Pt) {
                Xt(ut, Pt);
                var Vt = cr(ut);
                function ut(At) {
                  var Dt;
                  return Ze(this, ut), (Dt = Vt.call(this, At)).rjvId = Date.now().toString(), Dt.getListeners = function() {
                    return { reset: Dt.resetState, "variable-update": Dt.updateSrc, "add-key-request": Dt.addKeyRequest };
                  }, Dt.updateSrc = function() {
                    var Fn, mr = Cs.get(Dt.rjvId, "action", "variable-update"), nr = mr.name, En = mr.namespace, ia = mr.new_value, xi = mr.existing_value, ds = (mr.variable_removed, mr.updated_src), Xs = mr.type, Hl = Dt.props, ss = Hl.onEdit, $l = Hl.onDelete, mc = Hl.onAdd, xo = { existing_src: Dt.state.src, new_value: ia, updated_src: ds, name: nr, namespace: En, existing_value: xi };
                    switch (Xs) {
                      case "variable-added":
                        Fn = mc(xo);
                        break;
                      case "variable-edited":
                        Fn = ss(xo);
                        break;
                      case "variable-removed":
                        Fn = $l(xo);
                    }
                    Fn !== false ? (Cs.set(Dt.rjvId, "global", "src", ds), Dt.setState({ src: ds })) : Dt.setState({ validationFailure: true });
                  }, Dt.addKeyRequest = function() {
                    Dt.setState({ addKeyRequest: true });
                  }, Dt.resetState = function() {
                    Dt.setState({ validationFailure: false, addKeyRequest: false });
                  }, Dt.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: ut.defaultProps.src, name: ut.defaultProps.name, theme: ut.defaultProps.theme, validationMessage: ut.defaultProps.validationMessage, prevSrc: ut.defaultProps.src, prevName: ut.defaultProps.name, prevTheme: ut.defaultProps.theme }, Dt;
                }
                return yt(ut, [{ key: "componentDidMount", value: function() {
                  Cs.set(this.rjvId, "global", "src", this.state.src);
                  var At = this.getListeners();
                  for (var Dt in At)
                    Cs.on(Dt + "-" + this.rjvId, At[Dt]);
                  this.setState({ addKeyRequest: false, editKeyRequest: false });
                } }, { key: "componentDidUpdate", value: function(At, Dt) {
                  Dt.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Dt.editKeyRequest !== false && this.setState({ editKeyRequest: false }), At.src !== this.state.src && Cs.set(this.rjvId, "global", "src", this.state.src);
                } }, { key: "componentWillUnmount", value: function() {
                  var At = this.getListeners();
                  for (var Dt in At)
                    Cs.removeListener(Dt + "-" + this.rjvId, At[Dt]);
                } }, { key: "render", value: function() {
                  var At = this.state, Dt = At.validationFailure, Fn = At.validationMessage, mr = At.addKeyRequest, nr = At.theme, En = At.src, ia = At.name, xi = this.props, ds = xi.style, Xs = xi.defaultValue;
                  return We.a.createElement("div", { className: "react-json-view", style: Be(Be({}, vr(nr, "app-container").style), ds) }, We.a.createElement(rI, { message: Fn, active: Dt, theme: nr, rjvId: this.rjvId }), We.a.createElement(pP, Object.assign({}, this.props, { src: En, name: ia, theme: nr, type: Gn(En), rjvId: this.rjvId })), We.a.createElement(uF, { active: mr, theme: nr, rjvId: this.rjvId, defaultValue: Xs }));
                } }], [{ key: "getDerivedStateFromProps", value: function(At, Dt) {
                  if (At.src !== Dt.prevSrc || At.name !== Dt.prevName || At.theme !== Dt.prevTheme) {
                    var Fn = { src: At.src, name: At.name, theme: At.theme, validationMessage: At.validationMessage, prevSrc: At.src, prevName: At.name, prevTheme: At.theme };
                    return ut.validateState(Fn);
                  }
                  return null;
                } }]), ut;
              }(We.a.PureComponent);
              zw.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, zw.validateState = function(Pt) {
                var Vt = {};
                return Gn(Pt.theme) !== "object" || function(ut) {
                  var At = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                  if (Gn(ut) === "object") {
                    for (var Dt = 0; Dt < At.length; Dt++)
                      if (!(At[Dt] in ut))
                        return false;
                    return true;
                  }
                  return false;
                }(Pt.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Vt.theme = "rjv-default"), Gn(Pt.src) !== "object" && Gn(Pt.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Vt.name = "ERROR", Vt.src = { message: "src property must be a valid json object" }), Be(Be({}, Pt), Vt);
              }, fr(zw), re.default = zw;
            }]);
          });
        })(Zi);
        var No = Bt(Zi.exports);
        const Wh = ({ id: Y, title: ge, chart: Q, option: ne }) => {
          const { tool: re } = i_({}), fe = ln({ global: true }), [Ee, { set: Oe }] = He(true), Be = (Ze) => {
            const { updated_src: Je } = Ze;
            Q == null || Q.setOption(Je), re == null || re.add(Y, Q, Je, ge), fe.emit("list");
          };
          return dP("div", { children: [m_(Ht, { children: m_(Ur, { children: m_($o, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (Ze) => {
            Oe(!Ze);
          } }) }) }), m_("br", {}), ne && m_(No, { src: ne, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: Ee, iconStyle: "triangle", enableClipboard: true, onEdit: Be, onAdd: Be, onDelete: Be })] });
        }, dh = () => {
          const Y = ln({ global: true }), ge = te.useRef(0), { tool: Q } = i_({});
          te.useState(false), te.useState("right");
          const [ne, re] = te.useState([]), [fe, Ee] = te.useState();
          return Y.useSubscription("list", () => {
            var Oe;
            Q != null && Q.list().length && (Ee((Oe = Q == null ? void 0 : Q.list()) == null ? void 0 : Oe[ge.current]), re(Q == null ? void 0 : Q.list()));
          }), m_("div", { className: Hi.container, children: false });
        };
        Z.EchartTool = dh, Z.ReactEchartsJson = Wh, Z.useEchartsTool = i_, Z.useEventEmitter = ln;
      })(_k);
      const bj = () => {
        const Z = U({ global: true }), ve = m6.useRef(0), { tool: J } = Nt({});
        m6.useState(false), m6.useState("right");
        const [ee, te] = m6.useState([]), [ce, Ie] = m6.useState();
        return Z.useSubscription("list", () => {
          var Le;
          J != null && J.list().length && (Ie((Le = J == null ? void 0 : J.list()) == null ? void 0 : Le[ve.current]), te(J == null ? void 0 : J.list()));
        }), dw("div", { className: yj.container, children: false });
      };
      var xk = { exports: {} };
      (function(Z, ve) {
        (function(J, ee) {
          Z.exports = ee(S.default);
        })(R, function(J) {
          return function(ee) {
            var te = {};
            function ce(Ie) {
              if (te[Ie])
                return te[Ie].exports;
              var Le = te[Ie] = { i: Ie, l: false, exports: {} };
              return ee[Ie].call(Le.exports, Le, Le.exports, ce), Le.l = true, Le.exports;
            }
            return ce.m = ee, ce.c = te, ce.d = function(Ie, Le, De) {
              ce.o(Ie, Le) || Object.defineProperty(Ie, Le, { enumerable: true, get: De });
            }, ce.r = function(Ie) {
              typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(Ie, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(Ie, "__esModule", { value: true });
            }, ce.t = function(Ie, Le) {
              if (1 & Le && (Ie = ce(Ie)), 8 & Le || 4 & Le && typeof Ie == "object" && Ie && Ie.__esModule)
                return Ie;
              var De = /* @__PURE__ */ Object.create(null);
              if (ce.r(De), Object.defineProperty(De, "default", { enumerable: true, value: Ie }), 2 & Le && typeof Ie != "string")
                for (var Ye in Ie)
                  ce.d(De, Ye, function(Ke) {
                    return Ie[Ke];
                  }.bind(null, Ye));
              return De;
            }, ce.n = function(Ie) {
              var Le = Ie && Ie.__esModule ? function() {
                return Ie.default;
              } : function() {
                return Ie;
              };
              return ce.d(Le, "a", Le), Le;
            }, ce.o = function(Ie, Le) {
              return Object.prototype.hasOwnProperty.call(Ie, Le);
            }, ce.p = "", ce(ce.s = 48);
          }([function(ee, te) {
            ee.exports = J;
          }, function(ee, te) {
            var ce = ee.exports = { version: "2.6.12" };
            typeof __e == "number" && (__e = ce);
          }, function(ee, te, ce) {
            var Ie = ce(26)("wks"), Le = ce(17), De = ce(3).Symbol, Ye = typeof De == "function";
            (ee.exports = function(Ke) {
              return Ie[Ke] || (Ie[Ke] = Ye && De[Ke] || (Ye ? De : Le)("Symbol." + Ke));
            }).store = Ie;
          }, function(ee, te) {
            var ce = ee.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
            typeof __g == "number" && (__g = ce);
          }, function(ee, te, ce) {
            ee.exports = !ce(8)(function() {
              return Object.defineProperty({}, "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(ee, te) {
            var ce = {}.hasOwnProperty;
            ee.exports = function(Ie, Le) {
              return ce.call(Ie, Le);
            };
          }, function(ee, te, ce) {
            var Ie = ce(7), Le = ce(16);
            ee.exports = ce(4) ? function(De, Ye, Ke) {
              return Ie.f(De, Ye, Le(1, Ke));
            } : function(De, Ye, Ke) {
              return De[Ye] = Ke, De;
            };
          }, function(ee, te, ce) {
            var Ie = ce(10), Le = ce(35), De = ce(23), Ye = Object.defineProperty;
            te.f = ce(4) ? Object.defineProperty : function(Ke, pt, Bt) {
              if (Ie(Ke), pt = De(pt, true), Ie(Bt), Le)
                try {
                  return Ye(Ke, pt, Bt);
                } catch {
                }
              if ("get" in Bt || "set" in Bt)
                throw TypeError("Accessors not supported!");
              return "value" in Bt && (Ke[pt] = Bt.value), Ke;
            };
          }, function(ee, te) {
            ee.exports = function(ce) {
              try {
                return !!ce();
              } catch {
                return true;
              }
            };
          }, function(ee, te, ce) {
            var Ie = ce(40), Le = ce(22);
            ee.exports = function(De) {
              return Ie(Le(De));
            };
          }, function(ee, te, ce) {
            var Ie = ce(11);
            ee.exports = function(Le) {
              if (!Ie(Le))
                throw TypeError(Le + " is not an object!");
              return Le;
            };
          }, function(ee, te) {
            ee.exports = function(ce) {
              return typeof ce == "object" ? ce !== null : typeof ce == "function";
            };
          }, function(ee, te) {
            ee.exports = {};
          }, function(ee, te, ce) {
            var Ie = ce(39), Le = ce(27);
            ee.exports = Object.keys || function(De) {
              return Ie(De, Le);
            };
          }, function(ee, te) {
            ee.exports = true;
          }, function(ee, te, ce) {
            var Ie = ce(3), Le = ce(1), De = ce(53), Ye = ce(6), Ke = ce(5), pt = function(Bt, qt, Yt) {
              var nn, ln, yr, sr = Bt & pt.F, aa = Bt & pt.G, He = Bt & pt.S, Cn = Bt & pt.P, On = Bt & pt.B, dr = Bt & pt.W, ur = aa ? Le : Le[qt] || (Le[qt] = {}), An = ur.prototype, Nn = aa ? Ie : He ? Ie[qt] : (Ie[qt] || {}).prototype;
              for (nn in aa && (Yt = qt), Yt)
                (ln = !sr && Nn && Nn[nn] !== void 0) && Ke(ur, nn) || (yr = ln ? Nn[nn] : Yt[nn], ur[nn] = aa && typeof Nn[nn] != "function" ? Yt[nn] : On && ln ? De(yr, Ie) : dr && Nn[nn] == yr ? function(Ar) {
                  var Jr = function(bn, Xa, qa) {
                    if (this instanceof Ar) {
                      switch (arguments.length) {
                        case 0:
                          return new Ar();
                        case 1:
                          return new Ar(bn);
                        case 2:
                          return new Ar(bn, Xa);
                      }
                      return new Ar(bn, Xa, qa);
                    }
                    return Ar.apply(this, arguments);
                  };
                  return Jr.prototype = Ar.prototype, Jr;
                }(yr) : Cn && typeof yr == "function" ? De(Function.call, yr) : yr, Cn && ((ur.virtual || (ur.virtual = {}))[nn] = yr, Bt & pt.R && An && !An[nn] && Ye(An, nn, yr)));
            };
            pt.F = 1, pt.G = 2, pt.S = 4, pt.P = 8, pt.B = 16, pt.W = 32, pt.U = 64, pt.R = 128, ee.exports = pt;
          }, function(ee, te) {
            ee.exports = function(ce, Ie) {
              return { enumerable: !(1 & ce), configurable: !(2 & ce), writable: !(4 & ce), value: Ie };
            };
          }, function(ee, te) {
            var ce = 0, Ie = Math.random();
            ee.exports = function(Le) {
              return "Symbol(".concat(Le === void 0 ? "" : Le, ")_", (++ce + Ie).toString(36));
            };
          }, function(ee, te, ce) {
            var Ie = ce(22);
            ee.exports = function(Le) {
              return Object(Ie(Le));
            };
          }, function(ee, te) {
            te.f = {}.propertyIsEnumerable;
          }, function(ee, te, ce) {
            var Ie = ce(52)(true);
            ce(34)(String, "String", function(Le) {
              this._t = String(Le), this._i = 0;
            }, function() {
              var Le, De = this._t, Ye = this._i;
              return Ye >= De.length ? { value: void 0, done: true } : (Le = Ie(De, Ye), this._i += Le.length, { value: Le, done: false });
            });
          }, function(ee, te) {
            var ce = Math.ceil, Ie = Math.floor;
            ee.exports = function(Le) {
              return isNaN(Le = +Le) ? 0 : (Le > 0 ? Ie : ce)(Le);
            };
          }, function(ee, te) {
            ee.exports = function(ce) {
              if (ce == null)
                throw TypeError("Can't call method on  " + ce);
              return ce;
            };
          }, function(ee, te, ce) {
            var Ie = ce(11);
            ee.exports = function(Le, De) {
              if (!Ie(Le))
                return Le;
              var Ye, Ke;
              if (De && typeof (Ye = Le.toString) == "function" && !Ie(Ke = Ye.call(Le)) || typeof (Ye = Le.valueOf) == "function" && !Ie(Ke = Ye.call(Le)) || !De && typeof (Ye = Le.toString) == "function" && !Ie(Ke = Ye.call(Le)))
                return Ke;
              throw TypeError("Can't convert object to primitive value");
            };
          }, function(ee, te) {
            var ce = {}.toString;
            ee.exports = function(Ie) {
              return ce.call(Ie).slice(8, -1);
            };
          }, function(ee, te, ce) {
            var Ie = ce(26)("keys"), Le = ce(17);
            ee.exports = function(De) {
              return Ie[De] || (Ie[De] = Le(De));
            };
          }, function(ee, te, ce) {
            var Ie = ce(1), Le = ce(3), De = Le["__core-js_shared__"] || (Le["__core-js_shared__"] = {});
            (ee.exports = function(Ye, Ke) {
              return De[Ye] || (De[Ye] = Ke !== void 0 ? Ke : {});
            })("versions", []).push({ version: Ie.version, mode: ce(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
          }, function(ee, te) {
            ee.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
          }, function(ee, te, ce) {
            var Ie = ce(7).f, Le = ce(5), De = ce(2)("toStringTag");
            ee.exports = function(Ye, Ke, pt) {
              Ye && !Le(Ye = pt ? Ye : Ye.prototype, De) && Ie(Ye, De, { configurable: true, value: Ke });
            };
          }, function(ee, te, ce) {
            ce(62);
            for (var Ie = ce(3), Le = ce(6), De = ce(12), Ye = ce(2)("toStringTag"), Ke = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), pt = 0; pt < Ke.length; pt++) {
              var Bt = Ke[pt], qt = Ie[Bt], Yt = qt && qt.prototype;
              Yt && !Yt[Ye] && Le(Yt, Ye, Bt), De[Bt] = De.Array;
            }
          }, function(ee, te, ce) {
            te.f = ce(2);
          }, function(ee, te, ce) {
            var Ie = ce(3), Le = ce(1), De = ce(14), Ye = ce(30), Ke = ce(7).f;
            ee.exports = function(pt) {
              var Bt = Le.Symbol || (Le.Symbol = De ? {} : Ie.Symbol || {});
              pt.charAt(0) == "_" || pt in Bt || Ke(Bt, pt, { value: Ye.f(pt) });
            };
          }, function(ee, te) {
            te.f = Object.getOwnPropertySymbols;
          }, function(ee, te) {
            ee.exports = function(ce, Ie, Le) {
              return Math.min(Math.max(ce, Ie), Le);
            };
          }, function(ee, te, ce) {
            var Ie = ce(14), Le = ce(15), De = ce(37), Ye = ce(6), Ke = ce(12), pt = ce(55), Bt = ce(28), qt = ce(61), Yt = ce(2)("iterator"), nn = !([].keys && "next" in [].keys()), ln = function() {
              return this;
            };
            ee.exports = function(yr, sr, aa, He, Cn, On, dr) {
              pt(aa, sr, He);
              var ur, An, Nn, Ar = function(Yn) {
                if (!nn && Yn in qa)
                  return qa[Yn];
                switch (Yn) {
                  case "keys":
                  case "values":
                    return function() {
                      return new aa(this, Yn);
                    };
                }
                return function() {
                  return new aa(this, Yn);
                };
              }, Jr = sr + " Iterator", bn = Cn == "values", Xa = false, qa = yr.prototype, ir = qa[Yt] || qa["@@iterator"] || Cn && qa[Cn], Ai = ir || Ar(Cn), gr = Cn ? bn ? Ar("entries") : Ai : void 0, Qn = sr == "Array" && qa.entries || ir;
              if (Qn && (Nn = qt(Qn.call(new yr()))) !== Object.prototype && Nn.next && (Bt(Nn, Jr, true), Ie || typeof Nn[Yt] == "function" || Ye(Nn, Yt, ln)), bn && ir && ir.name !== "values" && (Xa = true, Ai = function() {
                return ir.call(this);
              }), Ie && !dr || !nn && !Xa && qa[Yt] || Ye(qa, Yt, Ai), Ke[sr] = Ai, Ke[Jr] = ln, Cn)
                if (ur = { values: bn ? Ai : Ar("values"), keys: On ? Ai : Ar("keys"), entries: gr }, dr)
                  for (An in ur)
                    An in qa || De(qa, An, ur[An]);
                else
                  Le(Le.P + Le.F * (nn || Xa), sr, ur);
              return ur;
            };
          }, function(ee, te, ce) {
            ee.exports = !ce(4) && !ce(8)(function() {
              return Object.defineProperty(ce(36)("div"), "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(ee, te, ce) {
            var Ie = ce(11), Le = ce(3).document, De = Ie(Le) && Ie(Le.createElement);
            ee.exports = function(Ye) {
              return De ? Le.createElement(Ye) : {};
            };
          }, function(ee, te, ce) {
            ee.exports = ce(6);
          }, function(ee, te, ce) {
            var Ie = ce(10), Le = ce(56), De = ce(27), Ye = ce(25)("IE_PROTO"), Ke = function() {
            }, pt = function() {
              var Bt, qt = ce(36)("iframe"), Yt = De.length;
              for (qt.style.display = "none", ce(60).appendChild(qt), qt.src = "javascript:", (Bt = qt.contentWindow.document).open(), Bt.write("<script>document.F=Object<\/script>"), Bt.close(), pt = Bt.F; Yt--; )
                delete pt.prototype[De[Yt]];
              return pt();
            };
            ee.exports = Object.create || function(Bt, qt) {
              var Yt;
              return Bt !== null ? (Ke.prototype = Ie(Bt), Yt = new Ke(), Ke.prototype = null, Yt[Ye] = Bt) : Yt = pt(), qt === void 0 ? Yt : Le(Yt, qt);
            };
          }, function(ee, te, ce) {
            var Ie = ce(5), Le = ce(9), De = ce(57)(false), Ye = ce(25)("IE_PROTO");
            ee.exports = function(Ke, pt) {
              var Bt, qt = Le(Ke), Yt = 0, nn = [];
              for (Bt in qt)
                Bt != Ye && Ie(qt, Bt) && nn.push(Bt);
              for (; pt.length > Yt; )
                Ie(qt, Bt = pt[Yt++]) && (~De(nn, Bt) || nn.push(Bt));
              return nn;
            };
          }, function(ee, te, ce) {
            var Ie = ce(24);
            ee.exports = Object("z").propertyIsEnumerable(0) ? Object : function(Le) {
              return Ie(Le) == "String" ? Le.split("") : Object(Le);
            };
          }, function(ee, te, ce) {
            var Ie = ce(39), Le = ce(27).concat("length", "prototype");
            te.f = Object.getOwnPropertyNames || function(De) {
              return Ie(De, Le);
            };
          }, function(ee, te, ce) {
            var Ie = ce(24), Le = ce(2)("toStringTag"), De = Ie(function() {
              return arguments;
            }()) == "Arguments";
            ee.exports = function(Ye) {
              var Ke, pt, Bt;
              return Ye === void 0 ? "Undefined" : Ye === null ? "Null" : typeof (pt = function(qt, Yt) {
                try {
                  return qt[Yt];
                } catch {
                }
              }(Ke = Object(Ye), Le)) == "string" ? pt : De ? Ie(Ke) : (Bt = Ie(Ke)) == "Object" && typeof Ke.callee == "function" ? "Arguments" : Bt;
            };
          }, function(ee, te) {
            var ce;
            ce = function() {
              return this;
            }();
            try {
              ce = ce || new Function("return this")();
            } catch {
              typeof window == "object" && (ce = window);
            }
            ee.exports = ce;
          }, function(ee, te) {
            var ce = /-?\d+(\.\d+)?%?/g;
            ee.exports = function(Ie) {
              return Ie.match(ce);
            };
          }, function(ee, te, ce) {
            Object.defineProperty(te, "__esModule", { value: true }), te.getBase16Theme = te.createStyling = te.invertTheme = void 0;
            var Ie = ln(ce(49)), Le = ln(ce(76)), De = ln(ce(81)), Ye = ln(ce(89)), Ke = ln(ce(93)), pt = function(An) {
              if (An && An.__esModule)
                return An;
              var Nn = {};
              if (An != null)
                for (var Ar in An)
                  Object.prototype.hasOwnProperty.call(An, Ar) && (Nn[Ar] = An[Ar]);
              return Nn.default = An, Nn;
            }(ce(94)), Bt = ln(ce(132)), qt = ln(ce(133)), Yt = ln(ce(138)), nn = ce(139);
            function ln(An) {
              return An && An.__esModule ? An : { default: An };
            }
            var yr = pt.default, sr = (0, Ye.default)(yr), aa = (0, Yt.default)(qt.default, nn.rgb2yuv, function(An) {
              var Nn, Ar = (0, De.default)(An, 3), Jr = Ar[0], bn = Ar[1], Xa = Ar[2];
              return [(Nn = Jr, Nn < 0.25 ? 1 : Nn < 0.5 ? 0.9 - Nn : 1.1 - Nn), bn, Xa];
            }, nn.yuv2rgb, Bt.default), He = function(An) {
              return function(Nn) {
                return { className: [Nn.className, An.className].filter(Boolean).join(" "), style: (0, Le.default)({}, Nn.style || {}, An.style || {}) };
              };
            }, Cn = function(An, Nn) {
              var Ar = (0, Ye.default)(Nn);
              for (var Jr in An)
                Ar.indexOf(Jr) === -1 && Ar.push(Jr);
              return Ar.reduce(function(bn, Xa) {
                return bn[Xa] = function(qa, ir) {
                  if (qa === void 0)
                    return ir;
                  if (ir === void 0)
                    return qa;
                  var Ai = qa === void 0 ? "undefined" : (0, Ie.default)(qa), gr = ir === void 0 ? "undefined" : (0, Ie.default)(ir);
                  switch (Ai) {
                    case "string":
                      switch (gr) {
                        case "string":
                          return [ir, qa].filter(Boolean).join(" ");
                        case "object":
                          return He({ className: qa, style: ir });
                        case "function":
                          return function(Qn) {
                            for (var Yn = arguments.length, ya = Array(Yn > 1 ? Yn - 1 : 0), sa = 1; sa < Yn; sa++)
                              ya[sa - 1] = arguments[sa];
                            return He({ className: qa })(ir.apply(void 0, [Qn].concat(ya)));
                          };
                      }
                    case "object":
                      switch (gr) {
                        case "string":
                          return He({ className: ir, style: qa });
                        case "object":
                          return (0, Le.default)({}, ir, qa);
                        case "function":
                          return function(Qn) {
                            for (var Yn = arguments.length, ya = Array(Yn > 1 ? Yn - 1 : 0), sa = 1; sa < Yn; sa++)
                              ya[sa - 1] = arguments[sa];
                            return He({ style: qa })(ir.apply(void 0, [Qn].concat(ya)));
                          };
                      }
                    case "function":
                      switch (gr) {
                        case "string":
                          return function(Qn) {
                            for (var Yn = arguments.length, ya = Array(Yn > 1 ? Yn - 1 : 0), sa = 1; sa < Yn; sa++)
                              ya[sa - 1] = arguments[sa];
                            return qa.apply(void 0, [He(Qn)({ className: ir })].concat(ya));
                          };
                        case "object":
                          return function(Qn) {
                            for (var Yn = arguments.length, ya = Array(Yn > 1 ? Yn - 1 : 0), sa = 1; sa < Yn; sa++)
                              ya[sa - 1] = arguments[sa];
                            return qa.apply(void 0, [He(Qn)({ style: ir })].concat(ya));
                          };
                        case "function":
                          return function(Qn) {
                            for (var Yn = arguments.length, ya = Array(Yn > 1 ? Yn - 1 : 0), sa = 1; sa < Yn; sa++)
                              ya[sa - 1] = arguments[sa];
                            return qa.apply(void 0, [ir.apply(void 0, [Qn].concat(ya))].concat(ya));
                          };
                      }
                  }
                }(An[Xa], Nn[Xa]), bn;
              }, {});
            }, On = function(An, Nn) {
              for (var Ar = arguments.length, Jr = Array(Ar > 2 ? Ar - 2 : 0), bn = 2; bn < Ar; bn++)
                Jr[bn - 2] = arguments[bn];
              if (Nn === null)
                return An;
              Array.isArray(Nn) || (Nn = [Nn]);
              var Xa = Nn.map(function(ir) {
                return An[ir];
              }).filter(Boolean), qa = Xa.reduce(function(ir, Ai) {
                return typeof Ai == "string" ? ir.className = [ir.className, Ai].filter(Boolean).join(" ") : (Ai === void 0 ? "undefined" : (0, Ie.default)(Ai)) === "object" ? ir.style = (0, Le.default)({}, ir.style, Ai) : typeof Ai == "function" && (ir = (0, Le.default)({}, ir, Ai.apply(void 0, [ir].concat(Jr)))), ir;
              }, { className: "", style: {} });
              return qa.className || delete qa.className, (0, Ye.default)(qa.style).length === 0 && delete qa.style, qa;
            }, dr = te.invertTheme = function(An) {
              return (0, Ye.default)(An).reduce(function(Nn, Ar) {
                return Nn[Ar] = /^base/.test(Ar) ? aa(An[Ar]) : Ar === "scheme" ? An[Ar] + ":inverted" : An[Ar], Nn;
              }, {});
            }, ur = (te.createStyling = (0, Ke.default)(function(An) {
              for (var Nn = arguments.length, Ar = Array(Nn > 3 ? Nn - 3 : 0), Jr = 3; Jr < Nn; Jr++)
                Ar[Jr - 3] = arguments[Jr];
              var bn = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Xa = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, qa = bn.defaultBase16, ir = qa === void 0 ? yr : qa, Ai = bn.base16Themes, gr = Ai === void 0 ? null : Ai, Qn = ur(Xa, gr);
              Qn && (Xa = (0, Le.default)({}, Qn, Xa));
              var Yn = sr.reduce(function(xs, is) {
                return xs[is] = Xa[is] || ir[is], xs;
              }, {}), ya = (0, Ye.default)(Xa).reduce(function(xs, is) {
                return sr.indexOf(is) === -1 && (xs[is] = Xa[is]), xs;
              }, {}), sa = An(Yn), Wi = Cn(ya, sa);
              return (0, Ke.default)(On, 2).apply(void 0, [Wi].concat(Ar));
            }, 3), te.getBase16Theme = function(An, Nn) {
              if (An && An.extend && (An = An.extend), typeof An == "string") {
                var Ar = An.split(":"), Jr = (0, De.default)(Ar, 2), bn = Jr[0], Xa = Jr[1];
                An = (Nn || {})[bn] || pt[bn], Xa === "inverted" && (An = dr(An));
              }
              return An && An.hasOwnProperty("base00") ? An : void 0;
            });
          }, function(ee, te, ce) {
            var Ie, Le = typeof Reflect == "object" ? Reflect : null, De = Le && typeof Le.apply == "function" ? Le.apply : function(He, Cn, On) {
              return Function.prototype.apply.call(He, Cn, On);
            };
            Ie = Le && typeof Le.ownKeys == "function" ? Le.ownKeys : Object.getOwnPropertySymbols ? function(He) {
              return Object.getOwnPropertyNames(He).concat(Object.getOwnPropertySymbols(He));
            } : function(He) {
              return Object.getOwnPropertyNames(He);
            };
            var Ye = Number.isNaN || function(He) {
              return He != He;
            };
            function Ke() {
              Ke.init.call(this);
            }
            ee.exports = Ke, ee.exports.once = function(He, Cn) {
              return new Promise(function(On, dr) {
                function ur() {
                  An !== void 0 && He.removeListener("error", An), On([].slice.call(arguments));
                }
                var An;
                Cn !== "error" && (An = function(Nn) {
                  He.removeListener(Cn, ur), dr(Nn);
                }, He.once("error", An)), He.once(Cn, ur);
              });
            }, Ke.EventEmitter = Ke, Ke.prototype._events = void 0, Ke.prototype._eventsCount = 0, Ke.prototype._maxListeners = void 0;
            var pt = 10;
            function Bt(He) {
              if (typeof He != "function")
                throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof He);
            }
            function qt(He) {
              return He._maxListeners === void 0 ? Ke.defaultMaxListeners : He._maxListeners;
            }
            function Yt(He, Cn, On, dr) {
              var ur, An, Nn, Ar;
              if (Bt(On), (An = He._events) === void 0 ? (An = He._events = /* @__PURE__ */ Object.create(null), He._eventsCount = 0) : (An.newListener !== void 0 && (He.emit("newListener", Cn, On.listener ? On.listener : On), An = He._events), Nn = An[Cn]), Nn === void 0)
                Nn = An[Cn] = On, ++He._eventsCount;
              else if (typeof Nn == "function" ? Nn = An[Cn] = dr ? [On, Nn] : [Nn, On] : dr ? Nn.unshift(On) : Nn.push(On), (ur = qt(He)) > 0 && Nn.length > ur && !Nn.warned) {
                Nn.warned = true;
                var Jr = new Error("Possible EventEmitter memory leak detected. " + Nn.length + " " + String(Cn) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                Jr.name = "MaxListenersExceededWarning", Jr.emitter = He, Jr.type = Cn, Jr.count = Nn.length, Ar = Jr, console && console.warn && console.warn(Ar);
              }
              return He;
            }
            function nn() {
              if (!this.fired)
                return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
            }
            function ln(He, Cn, On) {
              var dr = { fired: false, wrapFn: void 0, target: He, type: Cn, listener: On }, ur = nn.bind(dr);
              return ur.listener = On, dr.wrapFn = ur, ur;
            }
            function yr(He, Cn, On) {
              var dr = He._events;
              if (dr === void 0)
                return [];
              var ur = dr[Cn];
              return ur === void 0 ? [] : typeof ur == "function" ? On ? [ur.listener || ur] : [ur] : On ? function(An) {
                for (var Nn = new Array(An.length), Ar = 0; Ar < Nn.length; ++Ar)
                  Nn[Ar] = An[Ar].listener || An[Ar];
                return Nn;
              }(ur) : aa(ur, ur.length);
            }
            function sr(He) {
              var Cn = this._events;
              if (Cn !== void 0) {
                var On = Cn[He];
                if (typeof On == "function")
                  return 1;
                if (On !== void 0)
                  return On.length;
              }
              return 0;
            }
            function aa(He, Cn) {
              for (var On = new Array(Cn), dr = 0; dr < Cn; ++dr)
                On[dr] = He[dr];
              return On;
            }
            Object.defineProperty(Ke, "defaultMaxListeners", { enumerable: true, get: function() {
              return pt;
            }, set: function(He) {
              if (typeof He != "number" || He < 0 || Ye(He))
                throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + He + ".");
              pt = He;
            } }), Ke.init = function() {
              this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
            }, Ke.prototype.setMaxListeners = function(He) {
              if (typeof He != "number" || He < 0 || Ye(He))
                throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + He + ".");
              return this._maxListeners = He, this;
            }, Ke.prototype.getMaxListeners = function() {
              return qt(this);
            }, Ke.prototype.emit = function(He) {
              for (var Cn = [], On = 1; On < arguments.length; On++)
                Cn.push(arguments[On]);
              var dr = He === "error", ur = this._events;
              if (ur !== void 0)
                dr = dr && ur.error === void 0;
              else if (!dr)
                return false;
              if (dr) {
                var An;
                if (Cn.length > 0 && (An = Cn[0]), An instanceof Error)
                  throw An;
                var Nn = new Error("Unhandled error." + (An ? " (" + An.message + ")" : ""));
                throw Nn.context = An, Nn;
              }
              var Ar = ur[He];
              if (Ar === void 0)
                return false;
              if (typeof Ar == "function")
                De(Ar, this, Cn);
              else {
                var Jr = Ar.length, bn = aa(Ar, Jr);
                for (On = 0; On < Jr; ++On)
                  De(bn[On], this, Cn);
              }
              return true;
            }, Ke.prototype.addListener = function(He, Cn) {
              return Yt(this, He, Cn, false);
            }, Ke.prototype.on = Ke.prototype.addListener, Ke.prototype.prependListener = function(He, Cn) {
              return Yt(this, He, Cn, true);
            }, Ke.prototype.once = function(He, Cn) {
              return Bt(Cn), this.on(He, ln(this, He, Cn)), this;
            }, Ke.prototype.prependOnceListener = function(He, Cn) {
              return Bt(Cn), this.prependListener(He, ln(this, He, Cn)), this;
            }, Ke.prototype.removeListener = function(He, Cn) {
              var On, dr, ur, An, Nn;
              if (Bt(Cn), (dr = this._events) === void 0)
                return this;
              if ((On = dr[He]) === void 0)
                return this;
              if (On === Cn || On.listener === Cn)
                --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete dr[He], dr.removeListener && this.emit("removeListener", He, On.listener || Cn));
              else if (typeof On != "function") {
                for (ur = -1, An = On.length - 1; An >= 0; An--)
                  if (On[An] === Cn || On[An].listener === Cn) {
                    Nn = On[An].listener, ur = An;
                    break;
                  }
                if (ur < 0)
                  return this;
                ur === 0 ? On.shift() : function(Ar, Jr) {
                  for (; Jr + 1 < Ar.length; Jr++)
                    Ar[Jr] = Ar[Jr + 1];
                  Ar.pop();
                }(On, ur), On.length === 1 && (dr[He] = On[0]), dr.removeListener !== void 0 && this.emit("removeListener", He, Nn || Cn);
              }
              return this;
            }, Ke.prototype.off = Ke.prototype.removeListener, Ke.prototype.removeAllListeners = function(He) {
              var Cn, On, dr;
              if ((On = this._events) === void 0)
                return this;
              if (On.removeListener === void 0)
                return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : On[He] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete On[He]), this;
              if (arguments.length === 0) {
                var ur, An = Object.keys(On);
                for (dr = 0; dr < An.length; ++dr)
                  (ur = An[dr]) !== "removeListener" && this.removeAllListeners(ur);
                return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
              }
              if (typeof (Cn = On[He]) == "function")
                this.removeListener(He, Cn);
              else if (Cn !== void 0)
                for (dr = Cn.length - 1; dr >= 0; dr--)
                  this.removeListener(He, Cn[dr]);
              return this;
            }, Ke.prototype.listeners = function(He) {
              return yr(this, He, true);
            }, Ke.prototype.rawListeners = function(He) {
              return yr(this, He, false);
            }, Ke.listenerCount = function(He, Cn) {
              return typeof He.listenerCount == "function" ? He.listenerCount(Cn) : sr.call(He, Cn);
            }, Ke.prototype.listenerCount = sr, Ke.prototype.eventNames = function() {
              return this._eventsCount > 0 ? Ie(this._events) : [];
            };
          }, function(ee, te, ce) {
            ee.exports.Dispatcher = ce(140);
          }, function(ee, te, ce) {
            ee.exports = ce(142);
          }, function(ee, te, ce) {
            te.__esModule = true;
            var Ie = Ye(ce(50)), Le = Ye(ce(65)), De = typeof Le.default == "function" && typeof Ie.default == "symbol" ? function(Ke) {
              return typeof Ke;
            } : function(Ke) {
              return Ke && typeof Le.default == "function" && Ke.constructor === Le.default && Ke !== Le.default.prototype ? "symbol" : typeof Ke;
            };
            function Ye(Ke) {
              return Ke && Ke.__esModule ? Ke : { default: Ke };
            }
            te.default = typeof Le.default == "function" && De(Ie.default) === "symbol" ? function(Ke) {
              return Ke === void 0 ? "undefined" : De(Ke);
            } : function(Ke) {
              return Ke && typeof Le.default == "function" && Ke.constructor === Le.default && Ke !== Le.default.prototype ? "symbol" : Ke === void 0 ? "undefined" : De(Ke);
            };
          }, function(ee, te, ce) {
            ee.exports = { default: ce(51), __esModule: true };
          }, function(ee, te, ce) {
            ce(20), ce(29), ee.exports = ce(30).f("iterator");
          }, function(ee, te, ce) {
            var Ie = ce(21), Le = ce(22);
            ee.exports = function(De) {
              return function(Ye, Ke) {
                var pt, Bt, qt = String(Le(Ye)), Yt = Ie(Ke), nn = qt.length;
                return Yt < 0 || Yt >= nn ? De ? "" : void 0 : (pt = qt.charCodeAt(Yt)) < 55296 || pt > 56319 || Yt + 1 === nn || (Bt = qt.charCodeAt(Yt + 1)) < 56320 || Bt > 57343 ? De ? qt.charAt(Yt) : pt : De ? qt.slice(Yt, Yt + 2) : Bt - 56320 + (pt - 55296 << 10) + 65536;
              };
            };
          }, function(ee, te, ce) {
            var Ie = ce(54);
            ee.exports = function(Le, De, Ye) {
              if (Ie(Le), De === void 0)
                return Le;
              switch (Ye) {
                case 1:
                  return function(Ke) {
                    return Le.call(De, Ke);
                  };
                case 2:
                  return function(Ke, pt) {
                    return Le.call(De, Ke, pt);
                  };
                case 3:
                  return function(Ke, pt, Bt) {
                    return Le.call(De, Ke, pt, Bt);
                  };
              }
              return function() {
                return Le.apply(De, arguments);
              };
            };
          }, function(ee, te) {
            ee.exports = function(ce) {
              if (typeof ce != "function")
                throw TypeError(ce + " is not a function!");
              return ce;
            };
          }, function(ee, te, ce) {
            var Ie = ce(38), Le = ce(16), De = ce(28), Ye = {};
            ce(6)(Ye, ce(2)("iterator"), function() {
              return this;
            }), ee.exports = function(Ke, pt, Bt) {
              Ke.prototype = Ie(Ye, { next: Le(1, Bt) }), De(Ke, pt + " Iterator");
            };
          }, function(ee, te, ce) {
            var Ie = ce(7), Le = ce(10), De = ce(13);
            ee.exports = ce(4) ? Object.defineProperties : function(Ye, Ke) {
              Le(Ye);
              for (var pt, Bt = De(Ke), qt = Bt.length, Yt = 0; qt > Yt; )
                Ie.f(Ye, pt = Bt[Yt++], Ke[pt]);
              return Ye;
            };
          }, function(ee, te, ce) {
            var Ie = ce(9), Le = ce(58), De = ce(59);
            ee.exports = function(Ye) {
              return function(Ke, pt, Bt) {
                var qt, Yt = Ie(Ke), nn = Le(Yt.length), ln = De(Bt, nn);
                if (Ye && pt != pt) {
                  for (; nn > ln; )
                    if ((qt = Yt[ln++]) != qt)
                      return true;
                } else
                  for (; nn > ln; ln++)
                    if ((Ye || ln in Yt) && Yt[ln] === pt)
                      return Ye || ln || 0;
                return !Ye && -1;
              };
            };
          }, function(ee, te, ce) {
            var Ie = ce(21), Le = Math.min;
            ee.exports = function(De) {
              return De > 0 ? Le(Ie(De), 9007199254740991) : 0;
            };
          }, function(ee, te, ce) {
            var Ie = ce(21), Le = Math.max, De = Math.min;
            ee.exports = function(Ye, Ke) {
              return (Ye = Ie(Ye)) < 0 ? Le(Ye + Ke, 0) : De(Ye, Ke);
            };
          }, function(ee, te, ce) {
            var Ie = ce(3).document;
            ee.exports = Ie && Ie.documentElement;
          }, function(ee, te, ce) {
            var Ie = ce(5), Le = ce(18), De = ce(25)("IE_PROTO"), Ye = Object.prototype;
            ee.exports = Object.getPrototypeOf || function(Ke) {
              return Ke = Le(Ke), Ie(Ke, De) ? Ke[De] : typeof Ke.constructor == "function" && Ke instanceof Ke.constructor ? Ke.constructor.prototype : Ke instanceof Object ? Ye : null;
            };
          }, function(ee, te, ce) {
            var Ie = ce(63), Le = ce(64), De = ce(12), Ye = ce(9);
            ee.exports = ce(34)(Array, "Array", function(Ke, pt) {
              this._t = Ye(Ke), this._i = 0, this._k = pt;
            }, function() {
              var Ke = this._t, pt = this._k, Bt = this._i++;
              return !Ke || Bt >= Ke.length ? (this._t = void 0, Le(1)) : Le(0, pt == "keys" ? Bt : pt == "values" ? Ke[Bt] : [Bt, Ke[Bt]]);
            }, "values"), De.Arguments = De.Array, Ie("keys"), Ie("values"), Ie("entries");
          }, function(ee, te) {
            ee.exports = function() {
            };
          }, function(ee, te) {
            ee.exports = function(ce, Ie) {
              return { value: Ie, done: !!ce };
            };
          }, function(ee, te, ce) {
            ee.exports = { default: ce(66), __esModule: true };
          }, function(ee, te, ce) {
            ce(67), ce(73), ce(74), ce(75), ee.exports = ce(1).Symbol;
          }, function(ee, te, ce) {
            var Ie = ce(3), Le = ce(5), De = ce(4), Ye = ce(15), Ke = ce(37), pt = ce(68).KEY, Bt = ce(8), qt = ce(26), Yt = ce(28), nn = ce(17), ln = ce(2), yr = ce(30), sr = ce(31), aa = ce(69), He = ce(70), Cn = ce(10), On = ce(11), dr = ce(18), ur = ce(9), An = ce(23), Nn = ce(16), Ar = ce(38), Jr = ce(71), bn = ce(72), Xa = ce(32), qa = ce(7), ir = ce(13), Ai = bn.f, gr = qa.f, Qn = Jr.f, Yn = Ie.Symbol, ya = Ie.JSON, sa = ya && ya.stringify, Wi = ln("_hidden"), xs = ln("toPrimitive"), is = {}.propertyIsEnumerable, io = qt("symbol-registry"), Ol = qt("symbols"), os = qt("op-symbols"), rl = Object.prototype, Cu = typeof Yn == "function" && !!Xa.f, wd = Ie.QObject, cp = !wd || !wd.prototype || !wd.prototype.findChild, tc = De && Bt(function() {
              return Ar(gr({}, "a", { get: function() {
                return gr(this, "a", { value: 7 }).a;
              } })).a != 7;
            }) ? function(jn, Or, Ea) {
              var pi = Ai(rl, Or);
              pi && delete rl[Or], gr(jn, Or, Ea), pi && jn !== rl && gr(rl, Or, pi);
            } : gr, cc = function(jn) {
              var Or = Ol[jn] = Ar(Yn.prototype);
              return Or._k = jn, Or;
            }, uh = Cu && typeof Yn.iterator == "symbol" ? function(jn) {
              return typeof jn == "symbol";
            } : function(jn) {
              return jn instanceof Yn;
            }, fp = function(jn, Or, Ea) {
              return jn === rl && fp(os, Or, Ea), Cn(jn), Or = An(Or, true), Cn(Ea), Le(Ol, Or) ? (Ea.enumerable ? (Le(jn, Wi) && jn[Wi][Or] && (jn[Wi][Or] = false), Ea = Ar(Ea, { enumerable: Nn(0, false) })) : (Le(jn, Wi) || gr(jn, Wi, Nn(1, {})), jn[Wi][Or] = true), tc(jn, Or, Ea)) : gr(jn, Or, Ea);
            }, ef = function(jn, Or) {
              Cn(jn);
              for (var Ea, pi = aa(Or = ur(Or)), To = 0, Do = pi.length; Do > To; )
                fp(jn, Ea = pi[To++], Or[Ea]);
              return jn;
            }, Sd = function(jn) {
              var Or = is.call(this, jn = An(jn, true));
              return !(this === rl && Le(Ol, jn) && !Le(os, jn)) && (!(Or || !Le(this, jn) || !Le(Ol, jn) || Le(this, Wi) && this[Wi][jn]) || Or);
            }, Ei = function(jn, Or) {
              if (jn = ur(jn), Or = An(Or, true), jn !== rl || !Le(Ol, Or) || Le(os, Or)) {
                var Ea = Ai(jn, Or);
                return !Ea || !Le(Ol, Or) || Le(jn, Wi) && jn[Wi][Or] || (Ea.enumerable = true), Ea;
              }
            }, ch = function(jn) {
              for (var Or, Ea = Qn(ur(jn)), pi = [], To = 0; Ea.length > To; )
                Le(Ol, Or = Ea[To++]) || Or == Wi || Or == pt || pi.push(Or);
              return pi;
            }, nc = function(jn) {
              for (var Or, Ea = jn === rl, pi = Qn(Ea ? os : ur(jn)), To = [], Do = 0; pi.length > Do; )
                !Le(Ol, Or = pi[Do++]) || Ea && !Le(rl, Or) || To.push(Ol[Or]);
              return To;
            };
            Cu || (Ke((Yn = function() {
              if (this instanceof Yn)
                throw TypeError("Symbol is not a constructor!");
              var jn = nn(arguments.length > 0 ? arguments[0] : void 0), Or = function(Ea) {
                this === rl && Or.call(os, Ea), Le(this, Wi) && Le(this[Wi], jn) && (this[Wi][jn] = false), tc(this, jn, Nn(1, Ea));
              };
              return De && cp && tc(rl, jn, { configurable: true, set: Or }), cc(jn);
            }).prototype, "toString", function() {
              return this._k;
            }), bn.f = Ei, qa.f = fp, ce(41).f = Jr.f = ch, ce(19).f = Sd, Xa.f = nc, De && !ce(14) && Ke(rl, "propertyIsEnumerable", Sd, true), yr.f = function(jn) {
              return cc(ln(jn));
            }), Ye(Ye.G + Ye.W + Ye.F * !Cu, { Symbol: Yn });
            for (var ju = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), fc = 0; ju.length > fc; )
              ln(ju[fc++]);
            for (var Xp = ir(ln.store), kr = 0; Xp.length > kr; )
              sr(Xp[kr++]);
            Ye(Ye.S + Ye.F * !Cu, "Symbol", { for: function(jn) {
              return Le(io, jn += "") ? io[jn] : io[jn] = Yn(jn);
            }, keyFor: function(jn) {
              if (!uh(jn))
                throw TypeError(jn + " is not a symbol!");
              for (var Or in io)
                if (io[Or] === jn)
                  return Or;
            }, useSetter: function() {
              cp = true;
            }, useSimple: function() {
              cp = false;
            } }), Ye(Ye.S + Ye.F * !Cu, "Object", { create: function(jn, Or) {
              return Or === void 0 ? Ar(jn) : ef(Ar(jn), Or);
            }, defineProperty: fp, defineProperties: ef, getOwnPropertyDescriptor: Ei, getOwnPropertyNames: ch, getOwnPropertySymbols: nc });
            var kn = Bt(function() {
              Xa.f(1);
            });
            Ye(Ye.S + Ye.F * kn, "Object", { getOwnPropertySymbols: function(jn) {
              return Xa.f(dr(jn));
            } }), ya && Ye(Ye.S + Ye.F * (!Cu || Bt(function() {
              var jn = Yn();
              return sa([jn]) != "[null]" || sa({ a: jn }) != "{}" || sa(Object(jn)) != "{}";
            })), "JSON", { stringify: function(jn) {
              for (var Or, Ea, pi = [jn], To = 1; arguments.length > To; )
                pi.push(arguments[To++]);
              if (Ea = Or = pi[1], (On(Or) || jn !== void 0) && !uh(jn))
                return He(Or) || (Or = function(Do, hl) {
                  if (typeof Ea == "function" && (hl = Ea.call(this, Do, hl)), !uh(hl))
                    return hl;
                }), pi[1] = Or, sa.apply(ya, pi);
            } }), Yn.prototype[xs] || ce(6)(Yn.prototype, xs, Yn.prototype.valueOf), Yt(Yn, "Symbol"), Yt(Math, "Math", true), Yt(Ie.JSON, "JSON", true);
          }, function(ee, te, ce) {
            var Ie = ce(17)("meta"), Le = ce(11), De = ce(5), Ye = ce(7).f, Ke = 0, pt = Object.isExtensible || function() {
              return true;
            }, Bt = !ce(8)(function() {
              return pt(Object.preventExtensions({}));
            }), qt = function(nn) {
              Ye(nn, Ie, { value: { i: "O" + ++Ke, w: {} } });
            }, Yt = ee.exports = { KEY: Ie, NEED: false, fastKey: function(nn, ln) {
              if (!Le(nn))
                return typeof nn == "symbol" ? nn : (typeof nn == "string" ? "S" : "P") + nn;
              if (!De(nn, Ie)) {
                if (!pt(nn))
                  return "F";
                if (!ln)
                  return "E";
                qt(nn);
              }
              return nn[Ie].i;
            }, getWeak: function(nn, ln) {
              if (!De(nn, Ie)) {
                if (!pt(nn))
                  return true;
                if (!ln)
                  return false;
                qt(nn);
              }
              return nn[Ie].w;
            }, onFreeze: function(nn) {
              return Bt && Yt.NEED && pt(nn) && !De(nn, Ie) && qt(nn), nn;
            } };
          }, function(ee, te, ce) {
            var Ie = ce(13), Le = ce(32), De = ce(19);
            ee.exports = function(Ye) {
              var Ke = Ie(Ye), pt = Le.f;
              if (pt)
                for (var Bt, qt = pt(Ye), Yt = De.f, nn = 0; qt.length > nn; )
                  Yt.call(Ye, Bt = qt[nn++]) && Ke.push(Bt);
              return Ke;
            };
          }, function(ee, te, ce) {
            var Ie = ce(24);
            ee.exports = Array.isArray || function(Le) {
              return Ie(Le) == "Array";
            };
          }, function(ee, te, ce) {
            var Ie = ce(9), Le = ce(41).f, De = {}.toString, Ye = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
            ee.exports.f = function(Ke) {
              return Ye && De.call(Ke) == "[object Window]" ? function(pt) {
                try {
                  return Le(pt);
                } catch {
                  return Ye.slice();
                }
              }(Ke) : Le(Ie(Ke));
            };
          }, function(ee, te, ce) {
            var Ie = ce(19), Le = ce(16), De = ce(9), Ye = ce(23), Ke = ce(5), pt = ce(35), Bt = Object.getOwnPropertyDescriptor;
            te.f = ce(4) ? Bt : function(qt, Yt) {
              if (qt = De(qt), Yt = Ye(Yt, true), pt)
                try {
                  return Bt(qt, Yt);
                } catch {
                }
              if (Ke(qt, Yt))
                return Le(!Ie.f.call(qt, Yt), qt[Yt]);
            };
          }, function(ee, te) {
          }, function(ee, te, ce) {
            ce(31)("asyncIterator");
          }, function(ee, te, ce) {
            ce(31)("observable");
          }, function(ee, te, ce) {
            te.__esModule = true;
            var Ie, Le = ce(77), De = (Ie = Le) && Ie.__esModule ? Ie : { default: Ie };
            te.default = De.default || function(Ye) {
              for (var Ke = 1; Ke < arguments.length; Ke++) {
                var pt = arguments[Ke];
                for (var Bt in pt)
                  Object.prototype.hasOwnProperty.call(pt, Bt) && (Ye[Bt] = pt[Bt]);
              }
              return Ye;
            };
          }, function(ee, te, ce) {
            ee.exports = { default: ce(78), __esModule: true };
          }, function(ee, te, ce) {
            ce(79), ee.exports = ce(1).Object.assign;
          }, function(ee, te, ce) {
            var Ie = ce(15);
            Ie(Ie.S + Ie.F, "Object", { assign: ce(80) });
          }, function(ee, te, ce) {
            var Ie = ce(4), Le = ce(13), De = ce(32), Ye = ce(19), Ke = ce(18), pt = ce(40), Bt = Object.assign;
            ee.exports = !Bt || ce(8)(function() {
              var qt = {}, Yt = {}, nn = Symbol(), ln = "abcdefghijklmnopqrst";
              return qt[nn] = 7, ln.split("").forEach(function(yr) {
                Yt[yr] = yr;
              }), Bt({}, qt)[nn] != 7 || Object.keys(Bt({}, Yt)).join("") != ln;
            }) ? function(qt, Yt) {
              for (var nn = Ke(qt), ln = arguments.length, yr = 1, sr = De.f, aa = Ye.f; ln > yr; )
                for (var He, Cn = pt(arguments[yr++]), On = sr ? Le(Cn).concat(sr(Cn)) : Le(Cn), dr = On.length, ur = 0; dr > ur; )
                  He = On[ur++], Ie && !aa.call(Cn, He) || (nn[He] = Cn[He]);
              return nn;
            } : Bt;
          }, function(ee, te, ce) {
            te.__esModule = true;
            var Ie = De(ce(82)), Le = De(ce(85));
            function De(Ye) {
              return Ye && Ye.__esModule ? Ye : { default: Ye };
            }
            te.default = function(Ye, Ke) {
              if (Array.isArray(Ye))
                return Ye;
              if ((0, Ie.default)(Object(Ye)))
                return function(pt, Bt) {
                  var qt = [], Yt = true, nn = false, ln = void 0;
                  try {
                    for (var yr, sr = (0, Le.default)(pt); !(Yt = (yr = sr.next()).done) && (qt.push(yr.value), !Bt || qt.length !== Bt); Yt = true)
                      ;
                  } catch (aa) {
                    nn = true, ln = aa;
                  } finally {
                    try {
                      !Yt && sr.return && sr.return();
                    } finally {
                      if (nn)
                        throw ln;
                    }
                  }
                  return qt;
                }(Ye, Ke);
              throw new TypeError("Invalid attempt to destructure non-iterable instance");
            };
          }, function(ee, te, ce) {
            ee.exports = { default: ce(83), __esModule: true };
          }, function(ee, te, ce) {
            ce(29), ce(20), ee.exports = ce(84);
          }, function(ee, te, ce) {
            var Ie = ce(42), Le = ce(2)("iterator"), De = ce(12);
            ee.exports = ce(1).isIterable = function(Ye) {
              var Ke = Object(Ye);
              return Ke[Le] !== void 0 || "@@iterator" in Ke || De.hasOwnProperty(Ie(Ke));
            };
          }, function(ee, te, ce) {
            ee.exports = { default: ce(86), __esModule: true };
          }, function(ee, te, ce) {
            ce(29), ce(20), ee.exports = ce(87);
          }, function(ee, te, ce) {
            var Ie = ce(10), Le = ce(88);
            ee.exports = ce(1).getIterator = function(De) {
              var Ye = Le(De);
              if (typeof Ye != "function")
                throw TypeError(De + " is not iterable!");
              return Ie(Ye.call(De));
            };
          }, function(ee, te, ce) {
            var Ie = ce(42), Le = ce(2)("iterator"), De = ce(12);
            ee.exports = ce(1).getIteratorMethod = function(Ye) {
              if (Ye != null)
                return Ye[Le] || Ye["@@iterator"] || De[Ie(Ye)];
            };
          }, function(ee, te, ce) {
            ee.exports = { default: ce(90), __esModule: true };
          }, function(ee, te, ce) {
            ce(91), ee.exports = ce(1).Object.keys;
          }, function(ee, te, ce) {
            var Ie = ce(18), Le = ce(13);
            ce(92)("keys", function() {
              return function(De) {
                return Le(Ie(De));
              };
            });
          }, function(ee, te, ce) {
            var Ie = ce(15), Le = ce(1), De = ce(8);
            ee.exports = function(Ye, Ke) {
              var pt = (Le.Object || {})[Ye] || Object[Ye], Bt = {};
              Bt[Ye] = Ke(pt), Ie(Ie.S + Ie.F * De(function() {
                pt(1);
              }), "Object", Bt);
            };
          }, function(ee, te, ce) {
            (function(Ie) {
              var Le = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], De = /^\s+|\s+$/g, Ye = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Ke = /\{\n\/\* \[wrapped with (.+)\] \*/, pt = /,? & /, Bt = /^[-+]0x[0-9a-f]+$/i, qt = /^0b[01]+$/i, Yt = /^\[object .+?Constructor\]$/, nn = /^0o[0-7]+$/i, ln = /^(?:0|[1-9]\d*)$/, yr = parseInt, sr = typeof Ie == "object" && Ie && Ie.Object === Object && Ie, aa = typeof self == "object" && self && self.Object === Object && self, He = sr || aa || Function("return this")();
              function Cn(kr, kn, jn) {
                switch (jn.length) {
                  case 0:
                    return kr.call(kn);
                  case 1:
                    return kr.call(kn, jn[0]);
                  case 2:
                    return kr.call(kn, jn[0], jn[1]);
                  case 3:
                    return kr.call(kn, jn[0], jn[1], jn[2]);
                }
                return kr.apply(kn, jn);
              }
              function On(kr, kn) {
                return !!(kr && kr.length) && function(jn, Or, Ea) {
                  if (Or != Or)
                    return function(Do, hl, Mu, qs) {
                      for (var Os = Do.length, Rl = Mu + (qs ? 1 : -1); qs ? Rl-- : ++Rl < Os; )
                        if (hl(Do[Rl], Rl, Do))
                          return Rl;
                      return -1;
                    }(jn, dr, Ea);
                  for (var pi = Ea - 1, To = jn.length; ++pi < To; )
                    if (jn[pi] === Or)
                      return pi;
                  return -1;
                }(kr, kn, 0) > -1;
              }
              function dr(kr) {
                return kr != kr;
              }
              function ur(kr, kn) {
                for (var jn = kr.length, Or = 0; jn--; )
                  kr[jn] === kn && Or++;
                return Or;
              }
              function An(kr, kn) {
                for (var jn = -1, Or = kr.length, Ea = 0, pi = []; ++jn < Or; ) {
                  var To = kr[jn];
                  To !== kn && To !== "__lodash_placeholder__" || (kr[jn] = "__lodash_placeholder__", pi[Ea++] = jn);
                }
                return pi;
              }
              var Nn, Ar, Jr, bn = Function.prototype, Xa = Object.prototype, qa = He["__core-js_shared__"], ir = (Nn = /[^.]+$/.exec(qa && qa.keys && qa.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Nn : "", Ai = bn.toString, gr = Xa.hasOwnProperty, Qn = Xa.toString, Yn = RegExp("^" + Ai.call(gr).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ya = Object.create, sa = Math.max, Wi = Math.min, xs = (Ar = cc(Object, "defineProperty"), (Jr = cc.name) && Jr.length > 2 ? Ar : void 0);
              function is(kr) {
                return ju(kr) ? ya(kr) : {};
              }
              function io(kr) {
                return !(!ju(kr) || function(kn) {
                  return !!ir && ir in kn;
                }(kr)) && (function(kn) {
                  var jn = ju(kn) ? Qn.call(kn) : "";
                  return jn == "[object Function]" || jn == "[object GeneratorFunction]";
                }(kr) || function(kn) {
                  var jn = false;
                  if (kn != null && typeof kn.toString != "function")
                    try {
                      jn = !!(kn + "");
                    } catch {
                    }
                  return jn;
                }(kr) ? Yn : Yt).test(function(kn) {
                  if (kn != null) {
                    try {
                      return Ai.call(kn);
                    } catch {
                    }
                    try {
                      return kn + "";
                    } catch {
                    }
                  }
                  return "";
                }(kr));
              }
              function Ol(kr, kn, jn, Or) {
                for (var Ea = -1, pi = kr.length, To = jn.length, Do = -1, hl = kn.length, Mu = sa(pi - To, 0), qs = Array(hl + Mu), Os = !Or; ++Do < hl; )
                  qs[Do] = kn[Do];
                for (; ++Ea < To; )
                  (Os || Ea < pi) && (qs[jn[Ea]] = kr[Ea]);
                for (; Mu--; )
                  qs[Do++] = kr[Ea++];
                return qs;
              }
              function os(kr, kn, jn, Or) {
                for (var Ea = -1, pi = kr.length, To = -1, Do = jn.length, hl = -1, Mu = kn.length, qs = sa(pi - Do, 0), Os = Array(qs + Mu), Rl = !Or; ++Ea < qs; )
                  Os[Ea] = kr[Ea];
                for (var Vf = Ea; ++hl < Mu; )
                  Os[Vf + hl] = kn[hl];
                for (; ++To < Do; )
                  (Rl || Ea < pi) && (Os[Vf + jn[To]] = kr[Ea++]);
                return Os;
              }
              function rl(kr) {
                return function() {
                  var kn = arguments;
                  switch (kn.length) {
                    case 0:
                      return new kr();
                    case 1:
                      return new kr(kn[0]);
                    case 2:
                      return new kr(kn[0], kn[1]);
                    case 3:
                      return new kr(kn[0], kn[1], kn[2]);
                    case 4:
                      return new kr(kn[0], kn[1], kn[2], kn[3]);
                    case 5:
                      return new kr(kn[0], kn[1], kn[2], kn[3], kn[4]);
                    case 6:
                      return new kr(kn[0], kn[1], kn[2], kn[3], kn[4], kn[5]);
                    case 7:
                      return new kr(kn[0], kn[1], kn[2], kn[3], kn[4], kn[5], kn[6]);
                  }
                  var jn = is(kr.prototype), Or = kr.apply(jn, kn);
                  return ju(Or) ? Or : jn;
                };
              }
              function Cu(kr, kn, jn, Or, Ea, pi, To, Do, hl, Mu) {
                var qs = 128 & kn, Os = 1 & kn, Rl = 2 & kn, Vf = 24 & kn, zf = 512 & kn, Kp = Rl ? void 0 : rl(kr);
                return function Fh() {
                  for (var su = arguments.length, hs = Array(su), Nc = su; Nc--; )
                    hs[Nc] = arguments[Nc];
                  if (Vf)
                    var Bf = tc(Fh), Cd = ur(hs, Bf);
                  if (Or && (hs = Ol(hs, Or, Ea, Vf)), pi && (hs = os(hs, pi, To, Vf)), su -= Cd, Vf && su < Mu) {
                    var Nh = An(hs, Bf);
                    return wd(kr, kn, Cu, Fh.placeholder, jn, hs, Nh, Do, hl, Mu - su);
                  }
                  var Vh = Os ? jn : this, Md = Rl ? Vh[kr] : kr;
                  return su = hs.length, Do ? hs = Sd(hs, Do) : zf && su > 1 && hs.reverse(), qs && hl < su && (hs.length = hl), this && this !== He && this instanceof Fh && (Md = Kp || rl(Md)), Md.apply(Vh, hs);
                };
              }
              function wd(kr, kn, jn, Or, Ea, pi, To, Do, hl, Mu) {
                var qs = 8 & kn;
                kn |= qs ? 32 : 64, 4 & (kn &= ~(qs ? 64 : 32)) || (kn &= -4);
                var Os = jn(kr, kn, Ea, qs ? pi : void 0, qs ? To : void 0, qs ? void 0 : pi, qs ? void 0 : To, Do, hl, Mu);
                return Os.placeholder = Or, Ei(Os, kr, kn);
              }
              function cp(kr, kn, jn, Or, Ea, pi, To, Do) {
                var hl = 2 & kn;
                if (!hl && typeof kr != "function")
                  throw new TypeError("Expected a function");
                var Mu = Or ? Or.length : 0;
                if (Mu || (kn &= -97, Or = Ea = void 0), To = To === void 0 ? To : sa(Xp(To), 0), Do = Do === void 0 ? Do : Xp(Do), Mu -= Ea ? Ea.length : 0, 64 & kn) {
                  var qs = Or, Os = Ea;
                  Or = Ea = void 0;
                }
                var Rl = [kr, kn, jn, Or, Ea, qs, Os, pi, To, Do];
                if (kr = Rl[0], kn = Rl[1], jn = Rl[2], Or = Rl[3], Ea = Rl[4], !(Do = Rl[9] = Rl[9] == null ? hl ? 0 : kr.length : sa(Rl[9] - Mu, 0)) && 24 & kn && (kn &= -25), kn && kn != 1)
                  Vf = kn == 8 || kn == 16 ? function(zf, Kp, Fh) {
                    var su = rl(zf);
                    return function hs() {
                      for (var Nc = arguments.length, Bf = Array(Nc), Cd = Nc, Nh = tc(hs); Cd--; )
                        Bf[Cd] = arguments[Cd];
                      var Vh = Nc < 3 && Bf[0] !== Nh && Bf[Nc - 1] !== Nh ? [] : An(Bf, Nh);
                      if ((Nc -= Vh.length) < Fh)
                        return wd(zf, Kp, Cu, hs.placeholder, void 0, Bf, Vh, void 0, void 0, Fh - Nc);
                      var Md = this && this !== He && this instanceof hs ? su : zf;
                      return Cn(Md, this, Bf);
                    };
                  }(kr, kn, Do) : kn != 32 && kn != 33 || Ea.length ? Cu.apply(void 0, Rl) : function(zf, Kp, Fh, su) {
                    var hs = 1 & Kp, Nc = rl(zf);
                    return function Bf() {
                      for (var Cd = -1, Nh = arguments.length, Vh = -1, Md = su.length, E0 = Array(Md + Nh), I0 = this && this !== He && this instanceof Bf ? Nc : zf; ++Vh < Md; )
                        E0[Vh] = su[Vh];
                      for (; Nh--; )
                        E0[Vh++] = arguments[++Cd];
                      return Cn(I0, hs ? Fh : this, E0);
                    };
                  }(kr, kn, jn, Or);
                else
                  var Vf = function(zf, Kp, Fh) {
                    var su = 1 & Kp, hs = rl(zf);
                    return function Nc() {
                      var Bf = this && this !== He && this instanceof Nc ? hs : zf;
                      return Bf.apply(su ? Fh : this, arguments);
                    };
                  }(kr, kn, jn);
                return Ei(Vf, kr, kn);
              }
              function tc(kr) {
                return kr.placeholder;
              }
              function cc(kr, kn) {
                var jn = function(Or, Ea) {
                  return Or == null ? void 0 : Or[Ea];
                }(kr, kn);
                return io(jn) ? jn : void 0;
              }
              function uh(kr) {
                var kn = kr.match(Ke);
                return kn ? kn[1].split(pt) : [];
              }
              function fp(kr, kn) {
                var jn = kn.length, Or = jn - 1;
                return kn[Or] = (jn > 1 ? "& " : "") + kn[Or], kn = kn.join(jn > 2 ? ", " : " "), kr.replace(Ye, `{
/* [wrapped with ` + kn + `] */
`);
              }
              function ef(kr, kn) {
                return !!(kn = kn == null ? 9007199254740991 : kn) && (typeof kr == "number" || ln.test(kr)) && kr > -1 && kr % 1 == 0 && kr < kn;
              }
              function Sd(kr, kn) {
                for (var jn = kr.length, Or = Wi(kn.length, jn), Ea = function(To, Do) {
                  var hl = -1, Mu = To.length;
                  for (Do || (Do = Array(Mu)); ++hl < Mu; )
                    Do[hl] = To[hl];
                  return Do;
                }(kr); Or--; ) {
                  var pi = kn[Or];
                  kr[Or] = ef(pi, jn) ? Ea[pi] : void 0;
                }
                return kr;
              }
              var Ei = xs ? function(kr, kn, jn) {
                var Or, Ea = kn + "";
                return xs(kr, "toString", { configurable: true, enumerable: false, value: (Or = fp(Ea, ch(uh(Ea), jn)), function() {
                  return Or;
                }) });
              } : function(kr) {
                return kr;
              };
              function ch(kr, kn) {
                return function(jn, Or) {
                  for (var Ea = -1, pi = jn ? jn.length : 0; ++Ea < pi && Or(jn[Ea], Ea, jn) !== false; )
                    ;
                }(Le, function(jn) {
                  var Or = "_." + jn[0];
                  kn & jn[1] && !On(kr, Or) && kr.push(Or);
                }), kr.sort();
              }
              function nc(kr, kn, jn) {
                var Or = cp(kr, 8, void 0, void 0, void 0, void 0, void 0, kn = jn ? void 0 : kn);
                return Or.placeholder = nc.placeholder, Or;
              }
              function ju(kr) {
                var kn = typeof kr;
                return !!kr && (kn == "object" || kn == "function");
              }
              function fc(kr) {
                return kr ? (kr = function(kn) {
                  if (typeof kn == "number")
                    return kn;
                  if (function(Ea) {
                    return typeof Ea == "symbol" || function(pi) {
                      return !!pi && typeof pi == "object";
                    }(Ea) && Qn.call(Ea) == "[object Symbol]";
                  }(kn))
                    return NaN;
                  if (ju(kn)) {
                    var jn = typeof kn.valueOf == "function" ? kn.valueOf() : kn;
                    kn = ju(jn) ? jn + "" : jn;
                  }
                  if (typeof kn != "string")
                    return kn === 0 ? kn : +kn;
                  kn = kn.replace(De, "");
                  var Or = qt.test(kn);
                  return Or || nn.test(kn) ? yr(kn.slice(2), Or ? 2 : 8) : Bt.test(kn) ? NaN : +kn;
                }(kr)) === 1 / 0 || kr === -1 / 0 ? 17976931348623157e292 * (kr < 0 ? -1 : 1) : kr == kr ? kr : 0 : kr === 0 ? kr : 0;
              }
              function Xp(kr) {
                var kn = fc(kr), jn = kn % 1;
                return kn == kn ? jn ? kn - jn : kn : 0;
              }
              nc.placeholder = {}, ee.exports = nc;
            }).call(this, ce(43));
          }, function(ee, te, ce) {
            function Ie(os) {
              return os && os.__esModule ? os.default : os;
            }
            te.__esModule = true;
            var Le = ce(95);
            te.threezerotwofour = Ie(Le);
            var De = ce(96);
            te.apathy = Ie(De);
            var Ye = ce(97);
            te.ashes = Ie(Ye);
            var Ke = ce(98);
            te.atelierDune = Ie(Ke);
            var pt = ce(99);
            te.atelierForest = Ie(pt);
            var Bt = ce(100);
            te.atelierHeath = Ie(Bt);
            var qt = ce(101);
            te.atelierLakeside = Ie(qt);
            var Yt = ce(102);
            te.atelierSeaside = Ie(Yt);
            var nn = ce(103);
            te.bespin = Ie(nn);
            var ln = ce(104);
            te.brewer = Ie(ln);
            var yr = ce(105);
            te.bright = Ie(yr);
            var sr = ce(106);
            te.chalk = Ie(sr);
            var aa = ce(107);
            te.codeschool = Ie(aa);
            var He = ce(108);
            te.colors = Ie(He);
            var Cn = ce(109);
            te.default = Ie(Cn);
            var On = ce(110);
            te.eighties = Ie(On);
            var dr = ce(111);
            te.embers = Ie(dr);
            var ur = ce(112);
            te.flat = Ie(ur);
            var An = ce(113);
            te.google = Ie(An);
            var Nn = ce(114);
            te.grayscale = Ie(Nn);
            var Ar = ce(115);
            te.greenscreen = Ie(Ar);
            var Jr = ce(116);
            te.harmonic = Ie(Jr);
            var bn = ce(117);
            te.hopscotch = Ie(bn);
            var Xa = ce(118);
            te.isotope = Ie(Xa);
            var qa = ce(119);
            te.marrakesh = Ie(qa);
            var ir = ce(120);
            te.mocha = Ie(ir);
            var Ai = ce(121);
            te.monokai = Ie(Ai);
            var gr = ce(122);
            te.ocean = Ie(gr);
            var Qn = ce(123);
            te.paraiso = Ie(Qn);
            var Yn = ce(124);
            te.pop = Ie(Yn);
            var ya = ce(125);
            te.railscasts = Ie(ya);
            var sa = ce(126);
            te.shapeshifter = Ie(sa);
            var Wi = ce(127);
            te.solarized = Ie(Wi);
            var xs = ce(128);
            te.summerfruit = Ie(xs);
            var is = ce(129);
            te.tomorrow = Ie(is);
            var io = ce(130);
            te.tube = Ie(io);
            var Ol = ce(131);
            te.twilight = Ie(Ol);
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            te.__esModule = true, te.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, ee.exports = te.default;
          }, function(ee, te, ce) {
            var Ie = ce(33);
            function Le(De) {
              var Ye = Math.round(Ie(De, 0, 255)).toString(16);
              return Ye.length == 1 ? "0" + Ye : Ye;
            }
            ee.exports = function(De) {
              var Ye = De.length === 4 ? Le(255 * De[3]) : "";
              return "#" + Le(De[0]) + Le(De[1]) + Le(De[2]) + Ye;
            };
          }, function(ee, te, ce) {
            var Ie = ce(134), Le = ce(135), De = ce(136), Ye = ce(137), Ke = { "#": Le, hsl: function(Bt) {
              var qt = Ie(Bt), Yt = Ye(qt);
              return qt.length === 4 && Yt.push(qt[3]), Yt;
            }, rgb: De };
            function pt(Bt) {
              for (var qt in Ke)
                if (Bt.indexOf(qt) === 0)
                  return Ke[qt](Bt);
            }
            pt.rgb = De, pt.hsl = Ie, pt.hex = Le, ee.exports = pt;
          }, function(ee, te, ce) {
            var Ie = ce(44), Le = ce(33);
            function De(Ye, Ke) {
              switch (Ye = parseFloat(Ye), Ke) {
                case 0:
                  return Le(Ye, 0, 360);
                case 1:
                case 2:
                  return Le(Ye, 0, 100);
                case 3:
                  return Le(Ye, 0, 1);
              }
            }
            ee.exports = function(Ye) {
              return Ie(Ye).map(De);
            };
          }, function(ee, te) {
            ee.exports = function(ce) {
              ce.length !== 4 && ce.length !== 5 || (ce = function(De) {
                for (var Ye = "#", Ke = 1; Ke < De.length; Ke++) {
                  var pt = De.charAt(Ke);
                  Ye += pt + pt;
                }
                return Ye;
              }(ce));
              var Ie = [parseInt(ce.substring(1, 3), 16), parseInt(ce.substring(3, 5), 16), parseInt(ce.substring(5, 7), 16)];
              if (ce.length === 9) {
                var Le = parseFloat((parseInt(ce.substring(7, 9), 16) / 255).toFixed(2));
                Ie.push(Le);
              }
              return Ie;
            };
          }, function(ee, te, ce) {
            var Ie = ce(44), Le = ce(33);
            function De(Ye, Ke) {
              return Ke < 3 ? Ye.indexOf("%") != -1 ? Math.round(255 * Le(parseInt(Ye, 10), 0, 100) / 100) : Le(parseInt(Ye, 10), 0, 255) : Le(parseFloat(Ye), 0, 1);
            }
            ee.exports = function(Ye) {
              return Ie(Ye).map(De);
            };
          }, function(ee, te) {
            ee.exports = function(ce) {
              var Ie, Le, De, Ye, Ke, pt = ce[0] / 360, Bt = ce[1] / 100, qt = ce[2] / 100;
              if (Bt == 0)
                return [Ke = 255 * qt, Ke, Ke];
              Ie = 2 * qt - (Le = qt < 0.5 ? qt * (1 + Bt) : qt + Bt - qt * Bt), Ye = [0, 0, 0];
              for (var Yt = 0; Yt < 3; Yt++)
                (De = pt + 1 / 3 * -(Yt - 1)) < 0 && De++, De > 1 && De--, Ke = 6 * De < 1 ? Ie + 6 * (Le - Ie) * De : 2 * De < 1 ? Le : 3 * De < 2 ? Ie + (Le - Ie) * (2 / 3 - De) * 6 : Ie, Ye[Yt] = 255 * Ke;
              return Ye;
            };
          }, function(ee, te, ce) {
            (function(Ie) {
              var Le = typeof Ie == "object" && Ie && Ie.Object === Object && Ie, De = typeof self == "object" && self && self.Object === Object && self, Ye = Le || De || Function("return this")();
              function Ke(An, Nn, Ar) {
                switch (Ar.length) {
                  case 0:
                    return An.call(Nn);
                  case 1:
                    return An.call(Nn, Ar[0]);
                  case 2:
                    return An.call(Nn, Ar[0], Ar[1]);
                  case 3:
                    return An.call(Nn, Ar[0], Ar[1], Ar[2]);
                }
                return An.apply(Nn, Ar);
              }
              function pt(An, Nn) {
                for (var Ar = -1, Jr = Nn.length, bn = An.length; ++Ar < Jr; )
                  An[bn + Ar] = Nn[Ar];
                return An;
              }
              var Bt = Object.prototype, qt = Bt.hasOwnProperty, Yt = Bt.toString, nn = Ye.Symbol, ln = Bt.propertyIsEnumerable, yr = nn ? nn.isConcatSpreadable : void 0, sr = Math.max;
              function aa(An) {
                return He(An) || function(Nn) {
                  return function(Ar) {
                    return function(Jr) {
                      return !!Jr && typeof Jr == "object";
                    }(Ar) && function(Jr) {
                      return Jr != null && function(bn) {
                        return typeof bn == "number" && bn > -1 && bn % 1 == 0 && bn <= 9007199254740991;
                      }(Jr.length) && !function(bn) {
                        var Xa = function(qa) {
                          var ir = typeof qa;
                          return !!qa && (ir == "object" || ir == "function");
                        }(bn) ? Yt.call(bn) : "";
                        return Xa == "[object Function]" || Xa == "[object GeneratorFunction]";
                      }(Jr);
                    }(Ar);
                  }(Nn) && qt.call(Nn, "callee") && (!ln.call(Nn, "callee") || Yt.call(Nn) == "[object Arguments]");
                }(An) || !!(yr && An && An[yr]);
              }
              var He = Array.isArray, Cn, On, dr, ur = (On = function(An) {
                var Nn = (An = function Jr(bn, Xa, qa, ir, Ai) {
                  var gr = -1, Qn = bn.length;
                  for (qa || (qa = aa), Ai || (Ai = []); ++gr < Qn; ) {
                    var Yn = bn[gr];
                    Xa > 0 && qa(Yn) ? Xa > 1 ? Jr(Yn, Xa - 1, qa, ir, Ai) : pt(Ai, Yn) : ir || (Ai[Ai.length] = Yn);
                  }
                  return Ai;
                }(An, 1)).length, Ar = Nn;
                for (Cn; Ar--; )
                  if (typeof An[Ar] != "function")
                    throw new TypeError("Expected a function");
                return function() {
                  for (var Jr = 0, bn = Nn ? An[Jr].apply(this, arguments) : arguments[0]; ++Jr < Nn; )
                    bn = An[Jr].call(this, bn);
                  return bn;
                };
              }, dr = sr(dr === void 0 ? On.length - 1 : dr, 0), function() {
                for (var An = arguments, Nn = -1, Ar = sr(An.length - dr, 0), Jr = Array(Ar); ++Nn < Ar; )
                  Jr[Nn] = An[dr + Nn];
                Nn = -1;
                for (var bn = Array(dr + 1); ++Nn < dr; )
                  bn[Nn] = An[Nn];
                return bn[dr] = Jr, Ke(On, this, bn);
              });
              ee.exports = ur;
            }).call(this, ce(43));
          }, function(ee, te, ce) {
            Object.defineProperty(te, "__esModule", { value: true }), te.yuv2rgb = function(Ie) {
              var Le, De, Ye, Ke = Ie[0], pt = Ie[1], Bt = Ie[2];
              return Le = 1 * Ke + 0 * pt + 1.13983 * Bt, De = 1 * Ke + -0.39465 * pt + -0.5806 * Bt, Ye = 1 * Ke + 2.02311 * pt + 0 * Bt, Le = Math.min(Math.max(0, Le), 1), De = Math.min(Math.max(0, De), 1), Ye = Math.min(Math.max(0, Ye), 1), [255 * Le, 255 * De, 255 * Ye];
            }, te.rgb2yuv = function(Ie) {
              var Le = Ie[0] / 255, De = Ie[1] / 255, Ye = Ie[2] / 255;
              return [0.299 * Le + 0.587 * De + 0.114 * Ye, -0.14713 * Le + -0.28886 * De + 0.436 * Ye, 0.615 * Le + -0.51499 * De + -0.10001 * Ye];
            };
          }, function(ee, te, ce) {
            function Ie(Ye, Ke, pt) {
              return Ke in Ye ? Object.defineProperty(Ye, Ke, { value: pt, enumerable: true, configurable: true, writable: true }) : Ye[Ke] = pt, Ye;
            }
            var Le = ce(141), De = function() {
              function Ye() {
                Ie(this, "_callbacks", void 0), Ie(this, "_isDispatching", void 0), Ie(this, "_isHandled", void 0), Ie(this, "_isPending", void 0), Ie(this, "_lastID", void 0), Ie(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
              }
              var Ke = Ye.prototype;
              return Ke.register = function(pt) {
                var Bt = "ID_" + this._lastID++;
                return this._callbacks[Bt] = pt, Bt;
              }, Ke.unregister = function(pt) {
                this._callbacks[pt] || Le(false), delete this._callbacks[pt];
              }, Ke.waitFor = function(pt) {
                this._isDispatching || Le(false);
                for (var Bt = 0; Bt < pt.length; Bt++) {
                  var qt = pt[Bt];
                  this._isPending[qt] ? this._isHandled[qt] || Le(false) : (this._callbacks[qt] || Le(false), this._invokeCallback(qt));
                }
              }, Ke.dispatch = function(pt) {
                this._isDispatching && Le(false), this._startDispatching(pt);
                try {
                  for (var Bt in this._callbacks)
                    this._isPending[Bt] || this._invokeCallback(Bt);
                } finally {
                  this._stopDispatching();
                }
              }, Ke.isDispatching = function() {
                return this._isDispatching;
              }, Ke._invokeCallback = function(pt) {
                this._isPending[pt] = true, this._callbacks[pt](this._pendingPayload), this._isHandled[pt] = true;
              }, Ke._startDispatching = function(pt) {
                for (var Bt in this._callbacks)
                  this._isPending[Bt] = false, this._isHandled[Bt] = false;
                this._pendingPayload = pt, this._isDispatching = true;
              }, Ke._stopDispatching = function() {
                delete this._pendingPayload, this._isDispatching = false;
              }, Ye;
            }();
            ee.exports = De;
          }, function(ee, te, ce) {
            ee.exports = function(Ie, Le) {
              for (var De = arguments.length, Ye = new Array(De > 2 ? De - 2 : 0), Ke = 2; Ke < De; Ke++)
                Ye[Ke - 2] = arguments[Ke];
              if (!Ie) {
                var pt;
                if (Le === void 0)
                  pt = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                else {
                  var Bt = 0;
                  (pt = new Error(Le.replace(/%s/g, function() {
                    return String(Ye[Bt++]);
                  }))).name = "Invariant Violation";
                }
                throw pt.framesToPop = 1, pt;
              }
            };
          }, function(ee, te, ce) {
            function Ie(St, Rt, Xe) {
              return Rt in St ? Object.defineProperty(St, Rt, { value: Xe, enumerable: true, configurable: true, writable: true }) : St[Rt] = Xe, St;
            }
            function Le(St, Rt) {
              var Xe = Object.keys(St);
              if (Object.getOwnPropertySymbols) {
                var Ct = Object.getOwnPropertySymbols(St);
                Rt && (Ct = Ct.filter(function(Tt) {
                  return Object.getOwnPropertyDescriptor(St, Tt).enumerable;
                })), Xe.push.apply(Xe, Ct);
              }
              return Xe;
            }
            function De(St) {
              for (var Rt = 1; Rt < arguments.length; Rt++) {
                var Xe = arguments[Rt] != null ? arguments[Rt] : {};
                Rt % 2 ? Le(Object(Xe), true).forEach(function(Ct) {
                  Ie(St, Ct, Xe[Ct]);
                }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(St, Object.getOwnPropertyDescriptors(Xe)) : Le(Object(Xe)).forEach(function(Ct) {
                  Object.defineProperty(St, Ct, Object.getOwnPropertyDescriptor(Xe, Ct));
                });
              }
              return St;
            }
            function Ye(St, Rt) {
              if (!(St instanceof Rt))
                throw new TypeError("Cannot call a class as a function");
            }
            function Ke(St, Rt) {
              for (var Xe = 0; Xe < Rt.length; Xe++) {
                var Ct = Rt[Xe];
                Ct.enumerable = Ct.enumerable || false, Ct.configurable = true, "value" in Ct && (Ct.writable = true), Object.defineProperty(St, Ct.key, Ct);
              }
            }
            function pt(St, Rt, Xe) {
              return Rt && Ke(St.prototype, Rt), Xe && Ke(St, Xe), St;
            }
            function Bt(St, Rt) {
              return (Bt = Object.setPrototypeOf || function(Xe, Ct) {
                return Xe.__proto__ = Ct, Xe;
              })(St, Rt);
            }
            function qt(St, Rt) {
              if (typeof Rt != "function" && Rt !== null)
                throw new TypeError("Super expression must either be null or a function");
              St.prototype = Object.create(Rt && Rt.prototype, { constructor: { value: St, writable: true, configurable: true } }), Rt && Bt(St, Rt);
            }
            function Yt(St) {
              return (Yt = Object.setPrototypeOf ? Object.getPrototypeOf : function(Rt) {
                return Rt.__proto__ || Object.getPrototypeOf(Rt);
              })(St);
            }
            function nn(St) {
              return (nn = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Rt) {
                return typeof Rt;
              } : function(Rt) {
                return Rt && typeof Symbol == "function" && Rt.constructor === Symbol && Rt !== Symbol.prototype ? "symbol" : typeof Rt;
              })(St);
            }
            function ln(St) {
              if (St === void 0)
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return St;
            }
            function yr(St, Rt) {
              return !Rt || nn(Rt) !== "object" && typeof Rt != "function" ? ln(St) : Rt;
            }
            function sr(St) {
              var Rt = function() {
                if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                  return false;
                if (typeof Proxy == "function")
                  return true;
                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                  })), true;
                } catch {
                  return false;
                }
              }();
              return function() {
                var Xe, Ct = Yt(St);
                if (Rt) {
                  var Tt = Yt(this).constructor;
                  Xe = Reflect.construct(Ct, arguments, Tt);
                } else
                  Xe = Ct.apply(this, arguments);
                return yr(this, Xe);
              };
            }
            ce.r(te);
            var aa = ce(0), He = ce.n(aa);
            function Cn() {
              var St = this.constructor.getDerivedStateFromProps(this.props, this.state);
              St != null && this.setState(St);
            }
            function On(St) {
              this.setState(function(Rt) {
                var Xe = this.constructor.getDerivedStateFromProps(St, Rt);
                return Xe != null ? Xe : null;
              }.bind(this));
            }
            function dr(St, Rt) {
              try {
                var Xe = this.props, Ct = this.state;
                this.props = St, this.state = Rt, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Xe, Ct);
              } finally {
                this.props = Xe, this.state = Ct;
              }
            }
            function ur(St) {
              var Rt = St.prototype;
              if (!Rt || !Rt.isReactComponent)
                throw new Error("Can only polyfill class components");
              if (typeof St.getDerivedStateFromProps != "function" && typeof Rt.getSnapshotBeforeUpdate != "function")
                return St;
              var Xe = null, Ct = null, Tt = null;
              if (typeof Rt.componentWillMount == "function" ? Xe = "componentWillMount" : typeof Rt.UNSAFE_componentWillMount == "function" && (Xe = "UNSAFE_componentWillMount"), typeof Rt.componentWillReceiveProps == "function" ? Ct = "componentWillReceiveProps" : typeof Rt.UNSAFE_componentWillReceiveProps == "function" && (Ct = "UNSAFE_componentWillReceiveProps"), typeof Rt.componentWillUpdate == "function" ? Tt = "componentWillUpdate" : typeof Rt.UNSAFE_componentWillUpdate == "function" && (Tt = "UNSAFE_componentWillUpdate"), Xe !== null || Ct !== null || Tt !== null) {
                var Ln = St.displayName || St.name, Cr = typeof St.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Ln + " uses " + Cr + " but also contains the following legacy lifecycles:" + (Xe !== null ? `
  ` + Xe : "") + (Ct !== null ? `
  ` + Ct : "") + (Tt !== null ? `
  ` + Tt : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
              }
              if (typeof St.getDerivedStateFromProps == "function" && (Rt.componentWillMount = Cn, Rt.componentWillReceiveProps = On), typeof Rt.getSnapshotBeforeUpdate == "function") {
                if (typeof Rt.componentDidUpdate != "function")
                  throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                Rt.componentWillUpdate = dr;
                var or = Rt.componentDidUpdate;
                Rt.componentDidUpdate = function(cn, na, ni) {
                  var Ho = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : ni;
                  or.call(this, cn, na, Ho);
                };
              }
              return St;
            }
            function An(St, Rt) {
              if (St == null)
                return {};
              var Xe, Ct, Tt = function(Cr, or) {
                if (Cr == null)
                  return {};
                var cn, na, ni = {}, Ho = Object.keys(Cr);
                for (na = 0; na < Ho.length; na++)
                  cn = Ho[na], or.indexOf(cn) >= 0 || (ni[cn] = Cr[cn]);
                return ni;
              }(St, Rt);
              if (Object.getOwnPropertySymbols) {
                var Ln = Object.getOwnPropertySymbols(St);
                for (Ct = 0; Ct < Ln.length; Ct++)
                  Xe = Ln[Ct], Rt.indexOf(Xe) >= 0 || Object.prototype.propertyIsEnumerable.call(St, Xe) && (Tt[Xe] = St[Xe]);
              }
              return Tt;
            }
            function Nn(St) {
              var Rt = function(Xe) {
                return {}.toString.call(Xe).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
              }(St);
              return Rt === "number" && (Rt = isNaN(St) ? "nan" : (0 | St) != St ? "float" : "integer"), Rt;
            }
            Cn.__suppressDeprecationWarning = true, On.__suppressDeprecationWarning = true, dr.__suppressDeprecationWarning = true;
            var Ar = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, Jr = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, bn = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Xa = ce(45), qa = function(St) {
              var Rt = function(Xe) {
                return { backgroundColor: Xe.base00, ellipsisColor: Xe.base09, braceColor: Xe.base07, expandedIcon: Xe.base0D, collapsedIcon: Xe.base0E, keyColor: Xe.base07, arrayKeyColor: Xe.base0C, objectSize: Xe.base04, copyToClipboard: Xe.base0F, copyToClipboardCheck: Xe.base0D, objectBorder: Xe.base02, dataTypes: { boolean: Xe.base0E, date: Xe.base0D, float: Xe.base0B, function: Xe.base0D, integer: Xe.base0F, string: Xe.base09, nan: Xe.base08, null: Xe.base0A, undefined: Xe.base05, regexp: Xe.base0A, background: Xe.base02 }, editVariable: { editIcon: Xe.base0E, cancelIcon: Xe.base09, removeIcon: Xe.base09, addIcon: Xe.base0E, checkIcon: Xe.base0E, background: Xe.base01, color: Xe.base0A, border: Xe.base07 }, addKeyModal: { background: Xe.base05, border: Xe.base04, color: Xe.base0A, labelColor: Xe.base01 }, validationFailure: { background: Xe.base09, iconColor: Xe.base01, fontColor: Xe.base01 } };
              }(St);
              return { "app-container": { fontFamily: bn.globalFontFamily, cursor: bn.globalCursor, backgroundColor: Rt.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Rt.ellipsisColor, fontSize: bn.ellipsisFontSize, lineHeight: bn.ellipsisLineHeight, cursor: bn.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: bn.braceCursor, fontWeight: bn.braceFontWeight, color: Rt.braceColor }, "expanded-icon": { color: Rt.expandedIcon }, "collapsed-icon": { color: Rt.collapsedIcon }, colon: { display: "inline-block", margin: bn.keyMargin, color: Rt.keyColor, verticalAlign: "top" }, objectKeyVal: function(Xe, Ct) {
                return { style: De({ paddingTop: bn.keyValPaddingTop, paddingRight: bn.keyValPaddingRight, paddingBottom: bn.keyValPaddingBottom, borderLeft: bn.keyValBorderLeft + " " + Rt.objectBorder, ":hover": { paddingLeft: Ct.paddingLeft - 1 + "px", borderLeft: bn.keyValBorderHover + " " + Rt.objectBorder } }, Ct) };
              }, "object-key-val-no-border": { padding: bn.keyValPadding }, "pushed-content": { marginLeft: bn.pushedContentMarginLeft }, variableValue: function(Xe, Ct) {
                return { style: De({ display: "inline-block", paddingRight: bn.variableValuePaddingRight, position: "relative" }, Ct) };
              }, "object-name": { display: "inline-block", color: Rt.keyColor, letterSpacing: bn.keyLetterSpacing, fontStyle: bn.keyFontStyle, verticalAlign: bn.keyVerticalAlign, opacity: bn.keyOpacity, ":hover": { opacity: bn.keyOpacityHover } }, "array-key": { display: "inline-block", color: Rt.arrayKeyColor, letterSpacing: bn.keyLetterSpacing, fontStyle: bn.keyFontStyle, verticalAlign: bn.keyVerticalAlign, opacity: bn.keyOpacity, ":hover": { opacity: bn.keyOpacityHover } }, "object-size": { color: Rt.objectSize, borderRadius: bn.objectSizeBorderRadius, fontStyle: bn.objectSizeFontStyle, margin: bn.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: bn.dataTypeFontSize, marginRight: bn.dataTypeMarginRight, opacity: bn.datatypeOpacity }, boolean: { display: "inline-block", color: Rt.dataTypes.boolean }, date: { display: "inline-block", color: Rt.dataTypes.date }, "date-value": { marginLeft: bn.dateValueMarginLeft }, float: { display: "inline-block", color: Rt.dataTypes.float }, function: { display: "inline-block", color: Rt.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Rt.dataTypes.integer }, string: { display: "inline-block", color: Rt.dataTypes.string }, nan: { display: "inline-block", color: Rt.dataTypes.nan, fontSize: bn.nanFontSize, fontWeight: bn.nanFontWeight, backgroundColor: Rt.dataTypes.background, padding: bn.nanPadding, borderRadius: bn.nanBorderRadius }, null: { display: "inline-block", color: Rt.dataTypes.null, fontSize: bn.nullFontSize, fontWeight: bn.nullFontWeight, backgroundColor: Rt.dataTypes.background, padding: bn.nullPadding, borderRadius: bn.nullBorderRadius }, undefined: { display: "inline-block", color: Rt.dataTypes.undefined, fontSize: bn.undefinedFontSize, padding: bn.undefinedPadding, borderRadius: bn.undefinedBorderRadius, backgroundColor: Rt.dataTypes.background }, regexp: { display: "inline-block", color: Rt.dataTypes.regexp }, "copy-to-clipboard": { cursor: bn.clipboardCursor }, "copy-icon": { color: Rt.copyToClipboard, fontSize: bn.iconFontSize, marginRight: bn.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Rt.copyToClipboardCheck, marginLeft: bn.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: bn.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: bn.metaDataPadding }, "icon-container": { display: "inline-block", width: bn.iconContainerWidth }, tooltip: { padding: bn.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Rt.editVariable.removeIcon, cursor: bn.iconCursor, fontSize: bn.iconFontSize, marginRight: bn.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Rt.editVariable.addIcon, cursor: bn.iconCursor, fontSize: bn.iconFontSize, marginRight: bn.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Rt.editVariable.editIcon, cursor: bn.iconCursor, fontSize: bn.iconFontSize, marginRight: bn.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: bn.iconCursor, color: Rt.editVariable.checkIcon, fontSize: bn.iconFontSize, paddingRight: bn.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: bn.iconCursor, color: Rt.editVariable.cancelIcon, fontSize: bn.iconFontSize, paddingRight: bn.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: bn.editInputMinWidth, borderRadius: bn.editInputBorderRadius, backgroundColor: Rt.editVariable.background, color: Rt.editVariable.color, padding: bn.editInputPadding, marginRight: bn.editInputMarginRight, fontFamily: bn.editInputFontFamily }, "detected-row": { paddingTop: bn.detectedRowPaddingTop }, "key-modal-request": { position: bn.addKeyCoverPosition, top: bn.addKeyCoverPositionPx, left: bn.addKeyCoverPositionPx, right: bn.addKeyCoverPositionPx, bottom: bn.addKeyCoverPositionPx, backgroundColor: bn.addKeyCoverBackground }, "key-modal": { width: bn.addKeyModalWidth, backgroundColor: Rt.addKeyModal.background, marginLeft: bn.addKeyModalMargin, marginRight: bn.addKeyModalMargin, padding: bn.addKeyModalPadding, borderRadius: bn.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Rt.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Rt.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Rt.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Rt.addKeyModal.labelColor, fontSize: bn.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Rt.editVariable.addIcon, fontSize: bn.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Rt.ellipsisColor, fontSize: bn.ellipsisFontSize, lineHeight: bn.ellipsisLineHeight, cursor: bn.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Rt.validationFailure.fontColor, backgroundColor: Rt.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Rt.validationFailure.iconColor, fontSize: bn.iconFontSize, transform: "rotate(45deg)" } };
            };
            function ir(St, Rt, Xe) {
              return St || console.error("theme has not been set"), function(Ct) {
                var Tt = Ar;
                return Ct !== false && Ct !== "none" || (Tt = Jr), Object(Xa.createStyling)(qa, { defaultBase16: Tt })(Ct);
              }(St)(Rt, Xe);
            }
            var Ai = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = (Ct.rjvId, Ct.type_name), Ln = Ct.displayDataTypes, Cr = Ct.theme;
                return Ln ? He.a.createElement("span", Object.assign({ className: "data-type-label" }, ir(Cr, "data-type-label")), Tt) : null;
              } }]), Xe;
            }(He.a.PureComponent), gr = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props;
                return He.a.createElement("div", ir(Ct.theme, "boolean"), He.a.createElement(Ai, Object.assign({ type_name: "bool" }, Ct)), Ct.value ? "true" : "false");
              } }]), Xe;
            }(He.a.PureComponent), Qn = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props;
                return He.a.createElement("div", ir(Ct.theme, "date"), He.a.createElement(Ai, Object.assign({ type_name: "date" }, Ct)), He.a.createElement("span", Object.assign({ className: "date-value" }, ir(Ct.theme, "date-value")), Ct.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
              } }]), Xe;
            }(He.a.PureComponent), Yn = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props;
                return He.a.createElement("div", ir(Ct.theme, "float"), He.a.createElement(Ai, Object.assign({ type_name: "float" }, Ct)), this.props.value);
              } }]), Xe;
            }(He.a.PureComponent);
            function ya(St, Rt) {
              (Rt == null || Rt > St.length) && (Rt = St.length);
              for (var Xe = 0, Ct = new Array(Rt); Xe < Rt; Xe++)
                Ct[Xe] = St[Xe];
              return Ct;
            }
            function sa(St, Rt) {
              if (St) {
                if (typeof St == "string")
                  return ya(St, Rt);
                var Xe = Object.prototype.toString.call(St).slice(8, -1);
                return Xe === "Object" && St.constructor && (Xe = St.constructor.name), Xe === "Map" || Xe === "Set" ? Array.from(St) : Xe === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Xe) ? ya(St, Rt) : void 0;
              }
            }
            function Wi(St, Rt) {
              var Xe;
              if (typeof Symbol == "undefined" || St[Symbol.iterator] == null) {
                if (Array.isArray(St) || (Xe = sa(St)) || Rt && St && typeof St.length == "number") {
                  Xe && (St = Xe);
                  var Ct = 0, Tt = function() {
                  };
                  return { s: Tt, n: function() {
                    return Ct >= St.length ? { done: true } : { done: false, value: St[Ct++] };
                  }, e: function(cn) {
                    throw cn;
                  }, f: Tt };
                }
                throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }
              var Ln, Cr = true, or = false;
              return { s: function() {
                Xe = St[Symbol.iterator]();
              }, n: function() {
                var cn = Xe.next();
                return Cr = cn.done, cn;
              }, e: function(cn) {
                or = true, Ln = cn;
              }, f: function() {
                try {
                  Cr || Xe.return == null || Xe.return();
                } finally {
                  if (or)
                    throw Ln;
                }
              } };
            }
            function xs(St) {
              return function(Rt) {
                if (Array.isArray(Rt))
                  return ya(Rt);
              }(St) || function(Rt) {
                if (typeof Symbol != "undefined" && Symbol.iterator in Object(Rt))
                  return Array.from(Rt);
              }(St) || sa(St) || function() {
                throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }();
            }
            var is = ce(46), io = new (ce(47)).Dispatcher(), Ol = new (function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                var Ct;
                Ye(this, Xe);
                for (var Tt = arguments.length, Ln = new Array(Tt), Cr = 0; Cr < Tt; Cr++)
                  Ln[Cr] = arguments[Cr];
                return (Ct = Rt.call.apply(Rt, [this].concat(Ln))).objects = {}, Ct.set = function(or, cn, na, ni) {
                  Ct.objects[or] === void 0 && (Ct.objects[or] = {}), Ct.objects[or][cn] === void 0 && (Ct.objects[or][cn] = {}), Ct.objects[or][cn][na] = ni;
                }, Ct.get = function(or, cn, na, ni) {
                  return Ct.objects[or] === void 0 || Ct.objects[or][cn] === void 0 || Ct.objects[or][cn][na] == null ? ni : Ct.objects[or][cn][na];
                }, Ct.handleAction = function(or) {
                  var cn = or.rjvId, na = or.data;
                  switch (or.name) {
                    case "RESET":
                      Ct.emit("reset-" + cn);
                      break;
                    case "VARIABLE_UPDATED":
                      or.data.updated_src = Ct.updateSrc(cn, na), Ct.set(cn, "action", "variable-update", De(De({}, na), {}, { type: "variable-edited" })), Ct.emit("variable-update-" + cn);
                      break;
                    case "VARIABLE_REMOVED":
                      or.data.updated_src = Ct.updateSrc(cn, na), Ct.set(cn, "action", "variable-update", De(De({}, na), {}, { type: "variable-removed" })), Ct.emit("variable-update-" + cn);
                      break;
                    case "VARIABLE_ADDED":
                      or.data.updated_src = Ct.updateSrc(cn, na), Ct.set(cn, "action", "variable-update", De(De({}, na), {}, { type: "variable-added" })), Ct.emit("variable-update-" + cn);
                      break;
                    case "ADD_VARIABLE_KEY_REQUEST":
                      Ct.set(cn, "action", "new-key-request", na), Ct.emit("add-key-request-" + cn);
                  }
                }, Ct.updateSrc = function(or, cn) {
                  var na = cn.name, ni = cn.namespace, Ho = cn.new_value, Fo = (cn.existing_value, cn.variable_removed);
                  ni.shift();
                  var _o, ji = Ct.get(or, "global", "src"), Cl = Ct.deepCopy(ji, xs(ni)), Au = Cl, oo = Wi(ni);
                  try {
                    for (oo.s(); !(_o = oo.n()).done; )
                      Au = Au[_o.value];
                  } catch (Eu) {
                    oo.e(Eu);
                  } finally {
                    oo.f();
                  }
                  return Fo ? Nn(Au) == "array" ? Au.splice(na, 1) : delete Au[na] : na !== null ? Au[na] = Ho : Cl = Ho, Ct.set(or, "global", "src", Cl), Cl;
                }, Ct.deepCopy = function(or, cn) {
                  var na, ni = Nn(or), Ho = cn.shift();
                  return ni == "array" ? na = xs(or) : ni == "object" && (na = De({}, or)), Ho !== void 0 && (na[Ho] = Ct.deepCopy(or[Ho], cn)), na;
                }, Ct;
              }
              return Xe;
            }(is.EventEmitter))();
            io.register(Ol.handleAction.bind(Ol));
            var os = Ol, rl = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).toggleCollapsed = function() {
                  Tt.setState({ collapsed: !Tt.state.collapsed }, function() {
                    os.set(Tt.props.rjvId, Tt.props.namespace, "collapsed", Tt.state.collapsed);
                  });
                }, Tt.getFunctionDisplay = function(Ln) {
                  var Cr = ln(Tt).props;
                  return Ln ? He.a.createElement("span", null, Tt.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), He.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, He.a.createElement("span", null, "{"), He.a.createElement("span", ir(Cr.theme, "ellipsis"), "..."), He.a.createElement("span", null, "}"))) : Tt.props.value.toString().slice(9, -1);
                }, Tt.state = { collapsed: os.get(Ct.rjvId, Ct.namespace, "collapsed", true) }, Tt;
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = this.state.collapsed;
                return He.a.createElement("div", ir(Ct.theme, "function"), He.a.createElement(Ai, Object.assign({ type_name: "function" }, Ct)), He.a.createElement("span", Object.assign({}, ir(Ct.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Tt)));
              } }]), Xe;
            }(He.a.PureComponent), Cu = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                return He.a.createElement("div", ir(this.props.theme, "nan"), "NaN");
              } }]), Xe;
            }(He.a.PureComponent), wd = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                return He.a.createElement("div", ir(this.props.theme, "null"), "NULL");
              } }]), Xe;
            }(He.a.PureComponent), cp = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props;
                return He.a.createElement("div", ir(Ct.theme, "integer"), He.a.createElement(Ai, Object.assign({ type_name: "int" }, Ct)), this.props.value);
              } }]), Xe;
            }(He.a.PureComponent), tc = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props;
                return He.a.createElement("div", ir(Ct.theme, "regexp"), He.a.createElement(Ai, Object.assign({ type_name: "regexp" }, Ct)), this.props.value.toString());
              } }]), Xe;
            }(He.a.PureComponent), cc = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).toggleCollapsed = function() {
                  Tt.setState({ collapsed: !Tt.state.collapsed }, function() {
                    os.set(Tt.props.rjvId, Tt.props.namespace, "collapsed", Tt.state.collapsed);
                  });
                }, Tt.state = { collapsed: os.get(Ct.rjvId, Ct.namespace, "collapsed", true) }, Tt;
              }
              return pt(Xe, [{ key: "render", value: function() {
                this.state.collapsed;
                var Ct = this.props, Tt = Ct.collapseStringsAfterLength, Ln = Ct.theme, Cr = Ct.value, or = { style: { cursor: "default" } };
                return Nn(Tt) === "integer" && Cr.length > Tt && (or.style.cursor = "pointer", this.state.collapsed && (Cr = He.a.createElement("span", null, Cr.substring(0, Tt), He.a.createElement("span", ir(Ln, "ellipsis"), " ...")))), He.a.createElement("div", ir(Ln, "string"), He.a.createElement(Ai, Object.assign({ type_name: "string" }, Ct)), He.a.createElement("span", Object.assign({ className: "string-value" }, or, { onClick: this.toggleCollapsed }), '"', Cr, '"'));
              } }]), Xe;
            }(He.a.PureComponent), uh = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                return He.a.createElement("div", ir(this.props.theme, "undefined"), "undefined");
              } }]), Xe;
            }(He.a.PureComponent);
            function fp() {
              return (fp = Object.assign || function(St) {
                for (var Rt = 1; Rt < arguments.length; Rt++) {
                  var Xe = arguments[Rt];
                  for (var Ct in Xe)
                    Object.prototype.hasOwnProperty.call(Xe, Ct) && (St[Ct] = Xe[Ct]);
                }
                return St;
              }).apply(this, arguments);
            }
            var ef = aa.useLayoutEffect, Sd = function(St) {
              var Rt = Object(aa.useRef)(St);
              return ef(function() {
                Rt.current = St;
              }), Rt;
            }, Ei = function(St, Rt) {
              typeof St != "function" ? St.current = Rt : St(Rt);
            }, ch = function(St, Rt) {
              var Xe = Object(aa.useRef)();
              return Object(aa.useCallback)(function(Ct) {
                St.current = Ct, Xe.current && Ei(Xe.current, null), Xe.current = Rt, Rt && Ei(Rt, Ct);
              }, [Rt]);
            }, nc = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, ju = function(St) {
              Object.keys(nc).forEach(function(Rt) {
                St.style.setProperty(Rt, nc[Rt], "important");
              });
            }, fc = null, Xp = function() {
            }, kr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], kn = !!document.documentElement.currentStyle, jn = function(St, Rt) {
              var Xe = St.cacheMeasurements, Ct = St.maxRows, Tt = St.minRows, Ln = St.onChange, Cr = Ln === void 0 ? Xp : Ln, or = St.onHeightChange, cn = or === void 0 ? Xp : or, na = function(oo, Eu) {
                if (oo == null)
                  return {};
                var jf, Nv, Jm = {}, Jp = Object.keys(oo);
                for (Nv = 0; Nv < Jp.length; Nv++)
                  jf = Jp[Nv], Eu.indexOf(jf) >= 0 || (Jm[jf] = oo[jf]);
                return Jm;
              }(St, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), ni, Ho = na.value !== void 0, Fo = Object(aa.useRef)(null), _o = ch(Fo, Rt), ji = Object(aa.useRef)(0), Cl = Object(aa.useRef)(), Au = function() {
                var oo = Fo.current, Eu = Xe && Cl.current ? Cl.current : function(Jp) {
                  var C1 = window.getComputedStyle(Jp);
                  if (C1 === null)
                    return null;
                  var D0, tf = (D0 = C1, kr.reduce(function(nf, wg) {
                    return nf[wg] = D0[wg], nf;
                  }, {})), Vv = tf.boxSizing;
                  return Vv === "" ? null : (kn && Vv === "border-box" && (tf.width = parseFloat(tf.width) + parseFloat(tf.borderRightWidth) + parseFloat(tf.borderLeftWidth) + parseFloat(tf.paddingRight) + parseFloat(tf.paddingLeft) + "px"), { sizingStyle: tf, paddingSize: parseFloat(tf.paddingBottom) + parseFloat(tf.paddingTop), borderSize: parseFloat(tf.borderBottomWidth) + parseFloat(tf.borderTopWidth) });
                }(oo);
                if (Eu) {
                  Cl.current = Eu;
                  var jf = function(Jp, C1, D0, tf) {
                    D0 === void 0 && (D0 = 1), tf === void 0 && (tf = 1 / 0), fc || ((fc = document.createElement("textarea")).setAttribute("tab-index", "-1"), fc.setAttribute("aria-hidden", "true"), ju(fc)), fc.parentNode === null && document.body.appendChild(fc);
                    var Vv = Jp.paddingSize, nf = Jp.borderSize, wg = Jp.sizingStyle, hc = wg.boxSizing;
                    Object.keys(wg).forEach(function(P0) {
                      var xf = P0;
                      fc.style[xf] = wg[xf];
                    }), ju(fc), fc.value = C1;
                    var M1 = function(P0, xf) {
                      var mw = P0.scrollHeight;
                      return xf.sizingStyle.boxSizing === "border-box" ? mw + xf.borderSize : mw - xf.paddingSize;
                    }(fc, Jp);
                    fc.value = "x";
                    var gw = fc.scrollHeight - Vv, hp = gw * D0;
                    hc === "border-box" && (hp = hp + Vv + nf), M1 = Math.max(hp, M1);
                    var k0 = gw * tf;
                    return hc === "border-box" && (k0 = k0 + Vv + nf), [M1 = Math.min(k0, M1), gw];
                  }(Eu, oo.value || oo.placeholder || "x", Tt, Ct), Nv = jf[0], Jm = jf[1];
                  ji.current !== Nv && (ji.current = Nv, oo.style.setProperty("height", Nv + "px", "important"), cn(Nv, { rowHeight: Jm }));
                }
              };
              return Object(aa.useLayoutEffect)(Au), ni = Sd(Au), Object(aa.useLayoutEffect)(function() {
                var oo = function(Eu) {
                  ni.current(Eu);
                };
                return window.addEventListener("resize", oo), function() {
                  window.removeEventListener("resize", oo);
                };
              }, []), Object(aa.createElement)("textarea", fp({}, na, { onChange: function(oo) {
                Ho || Au(), Cr(oo);
              }, ref: _o }));
            }, Or = Object(aa.forwardRef)(jn);
            function Ea(St) {
              St = St.trim();
              try {
                if ((St = JSON.stringify(JSON.parse(St)))[0] === "[")
                  return pi("array", JSON.parse(St));
                if (St[0] === "{")
                  return pi("object", JSON.parse(St));
                if (St.match(/\-?\d+\.\d+/) && St.match(/\-?\d+\.\d+/)[0] === St)
                  return pi("float", parseFloat(St));
                if (St.match(/\-?\d+e-\d+/) && St.match(/\-?\d+e-\d+/)[0] === St)
                  return pi("float", Number(St));
                if (St.match(/\-?\d+/) && St.match(/\-?\d+/)[0] === St)
                  return pi("integer", parseInt(St));
                if (St.match(/\-?\d+e\+\d+/) && St.match(/\-?\d+e\+\d+/)[0] === St)
                  return pi("integer", Number(St));
              } catch {
              }
              switch (St = St.toLowerCase()) {
                case "undefined":
                  return pi("undefined", void 0);
                case "nan":
                  return pi("nan", NaN);
                case "null":
                  return pi("null", null);
                case "true":
                  return pi("boolean", true);
                case "false":
                  return pi("boolean", false);
                default:
                  if (St = Date.parse(St))
                    return pi("date", new Date(St));
              }
              return pi(false, null);
            }
            function pi(St, Rt) {
              return { type: St, value: Rt };
            }
            var To = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
              } }]), Xe;
            }(He.a.PureComponent), Do = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
              } }]), Xe;
            }(He.a.PureComponent), hl = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]), Cr = hs(Tt).style;
                return He.a.createElement("span", Ln, He.a.createElement("svg", { fill: Cr.color, width: Cr.height, height: Cr.width, style: Cr, viewBox: "0 0 1792 1792" }, He.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Xe;
            }(He.a.PureComponent), Mu = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]), Cr = hs(Tt).style;
                return He.a.createElement("span", Ln, He.a.createElement("svg", { fill: Cr.color, width: Cr.height, height: Cr.width, style: Cr, viewBox: "0 0 1792 1792" }, He.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Xe;
            }(He.a.PureComponent), qs = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", { style: De(De({}, hs(Tt).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, He.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
              } }]), Xe;
            }(He.a.PureComponent), Os = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", { style: De(De({}, hs(Tt).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, He.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
              } }]), Xe;
            }(He.a.PureComponent), Rl = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("g", null, He.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
              } }]), Xe;
            }(He.a.PureComponent), Vf = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("g", null, He.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Xe;
            }(He.a.PureComponent), zf = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("g", null, He.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Xe;
            }(He.a.PureComponent), Kp = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("g", null, He.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
              } }]), Xe;
            }(He.a.PureComponent), Fh = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("g", null, He.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
              } }]), Xe;
            }(He.a.PureComponent), su = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.style, Ln = An(Ct, ["style"]);
                return He.a.createElement("span", Ln, He.a.createElement("svg", Object.assign({}, hs(Tt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), He.a.createElement("g", null, He.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Xe;
            }(He.a.PureComponent);
            function hs(St) {
              return St || (St = {}), { style: De(De({ verticalAlign: "middle" }, St), {}, { color: St.color ? St.color : "#000000", height: "1em", width: "1em" }) };
            }
            var Nc = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).copiedTimer = null, Tt.handleCopy = function() {
                  var Ln = document.createElement("textarea"), Cr = Tt.props, or = Cr.clickCallback, cn = Cr.src, na = Cr.namespace;
                  Ln.innerHTML = JSON.stringify(Tt.clipboardValue(cn), null, "  "), document.body.appendChild(Ln), Ln.select(), document.execCommand("copy"), document.body.removeChild(Ln), Tt.copiedTimer = setTimeout(function() {
                    Tt.setState({ copied: false });
                  }, 5500), Tt.setState({ copied: true }, function() {
                    typeof or == "function" && or({ src: cn, namespace: na, name: na[na.length - 1] });
                  });
                }, Tt.getClippyIcon = function() {
                  var Ln = Tt.props.theme;
                  return Tt.state.copied ? He.a.createElement("span", null, He.a.createElement(Rl, Object.assign({ className: "copy-icon" }, ir(Ln, "copy-icon"))), He.a.createElement("span", ir(Ln, "copy-icon-copied"), "\u2714")) : He.a.createElement(Rl, Object.assign({ className: "copy-icon" }, ir(Ln, "copy-icon")));
                }, Tt.clipboardValue = function(Ln) {
                  switch (Nn(Ln)) {
                    case "function":
                    case "regexp":
                      return Ln.toString();
                    default:
                      return Ln;
                  }
                }, Tt.state = { copied: false }, Tt;
              }
              return pt(Xe, [{ key: "componentWillUnmount", value: function() {
                this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
              } }, { key: "render", value: function() {
                var Ct = this.props, Tt = (Ct.src, Ct.theme), Ln = Ct.hidden, Cr = Ct.rowHovered, or = ir(Tt, "copy-to-clipboard").style, cn = "inline";
                return Ln && (cn = "none"), He.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Cr ? "inline-block" : "none" } }, He.a.createElement("span", { style: De(De({}, or), {}, { display: cn }), onClick: this.handleCopy }, this.getClippyIcon()));
              } }]), Xe;
            }(He.a.PureComponent), Bf = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).getEditIcon = function() {
                  var Ln = Tt.props, Cr = Ln.variable, or = Ln.theme;
                  return He.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Tt.state.hovered ? "inline-block" : "none" } }, He.a.createElement(Fh, Object.assign({ className: "click-to-edit-icon" }, ir(or, "editVarIcon"), { onClick: function() {
                    Tt.prepopInput(Cr);
                  } })));
                }, Tt.prepopInput = function(Ln) {
                  if (Tt.props.onEdit !== false) {
                    var Cr = function(cn) {
                      var na;
                      switch (Nn(cn)) {
                        case "undefined":
                          na = "undefined";
                          break;
                        case "nan":
                          na = "NaN";
                          break;
                        case "string":
                          na = cn;
                          break;
                        case "date":
                        case "function":
                        case "regexp":
                          na = cn.toString();
                          break;
                        default:
                          try {
                            na = JSON.stringify(cn, null, "  ");
                          } catch {
                            na = "";
                          }
                      }
                      return na;
                    }(Ln.value), or = Ea(Cr);
                    Tt.setState({ editMode: true, editValue: Cr, parsedInput: { type: or.type, value: or.value } });
                  }
                }, Tt.getRemoveIcon = function() {
                  var Ln = Tt.props, Cr = Ln.variable, or = Ln.namespace, cn = Ln.theme, na = Ln.rjvId;
                  return He.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Tt.state.hovered ? "inline-block" : "none" } }, He.a.createElement(Vf, Object.assign({ className: "click-to-remove-icon" }, ir(cn, "removeVarIcon"), { onClick: function() {
                    io.dispatch({ name: "VARIABLE_REMOVED", rjvId: na, data: { name: Cr.name, namespace: or, existing_value: Cr.value, variable_removed: true } });
                  } })));
                }, Tt.getValue = function(Ln, Cr) {
                  var or = !Cr && Ln.type, cn = ln(Tt).props;
                  switch (or) {
                    case false:
                      return Tt.getEditInput();
                    case "string":
                      return He.a.createElement(cc, Object.assign({ value: Ln.value }, cn));
                    case "integer":
                      return He.a.createElement(cp, Object.assign({ value: Ln.value }, cn));
                    case "float":
                      return He.a.createElement(Yn, Object.assign({ value: Ln.value }, cn));
                    case "boolean":
                      return He.a.createElement(gr, Object.assign({ value: Ln.value }, cn));
                    case "function":
                      return He.a.createElement(rl, Object.assign({ value: Ln.value }, cn));
                    case "null":
                      return He.a.createElement(wd, cn);
                    case "nan":
                      return He.a.createElement(Cu, cn);
                    case "undefined":
                      return He.a.createElement(uh, cn);
                    case "date":
                      return He.a.createElement(Qn, Object.assign({ value: Ln.value }, cn));
                    case "regexp":
                      return He.a.createElement(tc, Object.assign({ value: Ln.value }, cn));
                    default:
                      return He.a.createElement("div", { className: "object-value" }, JSON.stringify(Ln.value));
                  }
                }, Tt.getEditInput = function() {
                  var Ln = Tt.props.theme, Cr = Tt.state.editValue;
                  return He.a.createElement("div", null, He.a.createElement(Or, Object.assign({ type: "text", inputRef: function(or) {
                    return or && or.focus();
                  }, value: Cr, className: "variable-editor", onChange: function(or) {
                    var cn = or.target.value, na = Ea(cn);
                    Tt.setState({ editValue: cn, parsedInput: { type: na.type, value: na.value } });
                  }, onKeyDown: function(or) {
                    switch (or.key) {
                      case "Escape":
                        Tt.setState({ editMode: false, editValue: "" });
                        break;
                      case "Enter":
                        (or.ctrlKey || or.metaKey) && Tt.submitEdit(true);
                    }
                    or.stopPropagation();
                  }, placeholder: "update this value", minRows: 2 }, ir(Ln, "edit-input"))), He.a.createElement("div", ir(Ln, "edit-icon-container"), He.a.createElement(Vf, Object.assign({ className: "edit-cancel" }, ir(Ln, "cancel-icon"), { onClick: function() {
                    Tt.setState({ editMode: false, editValue: "" });
                  } })), He.a.createElement(su, Object.assign({ className: "edit-check string-value" }, ir(Ln, "check-icon"), { onClick: function() {
                    Tt.submitEdit();
                  } })), He.a.createElement("div", null, Tt.showDetected())));
                }, Tt.submitEdit = function(Ln) {
                  var Cr = Tt.props, or = Cr.variable, cn = Cr.namespace, na = Cr.rjvId, ni = Tt.state, Ho = ni.editValue, Fo = ni.parsedInput, _o = Ho;
                  Ln && Fo.type && (_o = Fo.value), Tt.setState({ editMode: false }), io.dispatch({ name: "VARIABLE_UPDATED", rjvId: na, data: { name: or.name, namespace: cn, existing_value: or.value, new_value: _o, variable_removed: false } });
                }, Tt.showDetected = function() {
                  var Ln = Tt.props, Cr = Ln.theme, or = (Ln.variable, Ln.namespace, Ln.rjvId, Tt.state.parsedInput), cn = (or.type, or.value, Tt.getDetectedInput());
                  if (cn)
                    return He.a.createElement("div", null, He.a.createElement("div", ir(Cr, "detected-row"), cn, He.a.createElement(su, { className: "edit-check detected", style: De({ verticalAlign: "top", paddingLeft: "3px" }, ir(Cr, "check-icon").style), onClick: function() {
                      Tt.submitEdit(true);
                    } })));
                }, Tt.getDetectedInput = function() {
                  var Ln = Tt.state.parsedInput, Cr = Ln.type, or = Ln.value, cn = ln(Tt).props, na = cn.theme;
                  if (Cr !== false)
                    switch (Cr.toLowerCase()) {
                      case "object":
                        return He.a.createElement("span", null, He.a.createElement("span", { style: De(De({}, ir(na, "brace").style), {}, { cursor: "default" }) }, "{"), He.a.createElement("span", { style: De(De({}, ir(na, "ellipsis").style), {}, { cursor: "default" }) }, "..."), He.a.createElement("span", { style: De(De({}, ir(na, "brace").style), {}, { cursor: "default" }) }, "}"));
                      case "array":
                        return He.a.createElement("span", null, He.a.createElement("span", { style: De(De({}, ir(na, "brace").style), {}, { cursor: "default" }) }, "["), He.a.createElement("span", { style: De(De({}, ir(na, "ellipsis").style), {}, { cursor: "default" }) }, "..."), He.a.createElement("span", { style: De(De({}, ir(na, "brace").style), {}, { cursor: "default" }) }, "]"));
                      case "string":
                        return He.a.createElement(cc, Object.assign({ value: or }, cn));
                      case "integer":
                        return He.a.createElement(cp, Object.assign({ value: or }, cn));
                      case "float":
                        return He.a.createElement(Yn, Object.assign({ value: or }, cn));
                      case "boolean":
                        return He.a.createElement(gr, Object.assign({ value: or }, cn));
                      case "function":
                        return He.a.createElement(rl, Object.assign({ value: or }, cn));
                      case "null":
                        return He.a.createElement(wd, cn);
                      case "nan":
                        return He.a.createElement(Cu, cn);
                      case "undefined":
                        return He.a.createElement(uh, cn);
                      case "date":
                        return He.a.createElement(Qn, Object.assign({ value: new Date(or) }, cn));
                    }
                }, Tt.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Tt;
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this, Tt = this.props, Ln = Tt.variable, Cr = Tt.singleIndent, or = Tt.type, cn = Tt.theme, na = Tt.namespace, ni = Tt.indentWidth, Ho = Tt.enableClipboard, Fo = Tt.onEdit, _o = Tt.onDelete, ji = Tt.onSelect, Cl = Tt.displayArrayKey, Au = Tt.quotesOnKeys, oo = this.state.editMode;
                return He.a.createElement("div", Object.assign({}, ir(cn, "objectKeyVal", { paddingLeft: ni * Cr }), { onMouseEnter: function() {
                  return Ct.setState(De(De({}, Ct.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return Ct.setState(De(De({}, Ct.state), {}, { hovered: false }));
                }, className: "variable-row", key: Ln.name }), or == "array" ? Cl ? He.a.createElement("span", Object.assign({}, ir(cn, "array-key"), { key: Ln.name + "_" + na }), Ln.name, He.a.createElement("div", ir(cn, "colon"), ":")) : null : He.a.createElement("span", null, He.a.createElement("span", Object.assign({}, ir(cn, "object-name"), { className: "object-key", key: Ln.name + "_" + na }), !!Au && He.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), He.a.createElement("span", { style: { display: "inline-block" } }, Ln.name), !!Au && He.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), He.a.createElement("span", ir(cn, "colon"), ":")), He.a.createElement("div", Object.assign({ className: "variable-value", onClick: ji === false && Fo === false ? null : function(Eu) {
                  var jf = xs(na);
                  (Eu.ctrlKey || Eu.metaKey) && Fo !== false ? Ct.prepopInput(Ln) : ji !== false && (jf.shift(), ji(De(De({}, Ln), {}, { namespace: jf })));
                } }, ir(cn, "variableValue", { cursor: ji === false ? "default" : "pointer" })), this.getValue(Ln, oo)), Ho ? He.a.createElement(Nc, { rowHovered: this.state.hovered, hidden: oo, src: Ln.value, clickCallback: Ho, theme: cn, namespace: [].concat(xs(na), [Ln.name]) }) : null, Fo !== false && oo == 0 ? this.getEditIcon() : null, _o !== false && oo == 0 ? this.getRemoveIcon() : null);
              } }]), Xe;
            }(He.a.PureComponent), Cd = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                var Ct;
                Ye(this, Xe);
                for (var Tt = arguments.length, Ln = new Array(Tt), Cr = 0; Cr < Tt; Cr++)
                  Ln[Cr] = arguments[Cr];
                return (Ct = Rt.call.apply(Rt, [this].concat(Ln))).getObjectSize = function() {
                  var or = Ct.props, cn = or.size, na = or.theme;
                  if (or.displayObjectSize)
                    return He.a.createElement("span", Object.assign({ className: "object-size" }, ir(na, "object-size")), cn, " item", cn === 1 ? "" : "s");
                }, Ct.getAddAttribute = function(or) {
                  var cn = Ct.props, na = cn.theme, ni = cn.namespace, Ho = cn.name, Fo = cn.src, _o = cn.rjvId, ji = cn.depth;
                  return He.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: or ? "inline-block" : "none" } }, He.a.createElement(zf, Object.assign({ className: "click-to-add-icon" }, ir(na, "addVarIcon"), { onClick: function() {
                    var Cl = { name: ji > 0 ? Ho : null, namespace: ni.splice(0, ni.length - 1), existing_value: Fo, variable_removed: false, key_name: null };
                    Nn(Fo) === "object" ? io.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: _o, data: Cl }) : io.dispatch({ name: "VARIABLE_ADDED", rjvId: _o, data: De(De({}, Cl), {}, { new_value: [].concat(xs(Fo), [null]) }) });
                  } })));
                }, Ct.getRemoveObject = function(or) {
                  var cn = Ct.props, na = cn.theme, ni = (cn.hover, cn.namespace), Ho = cn.name, Fo = cn.src, _o = cn.rjvId;
                  if (ni.length !== 1)
                    return He.a.createElement("span", { className: "click-to-remove", style: { display: or ? "inline-block" : "none" } }, He.a.createElement(Vf, Object.assign({ className: "click-to-remove-icon" }, ir(na, "removeVarIcon"), { onClick: function() {
                      io.dispatch({ name: "VARIABLE_REMOVED", rjvId: _o, data: { name: Ho, namespace: ni.splice(0, ni.length - 1), existing_value: Fo, variable_removed: true } });
                    } })));
                }, Ct.render = function() {
                  var or = Ct.props, cn = or.theme, na = or.onDelete, ni = or.onAdd, Ho = or.enableClipboard, Fo = or.src, _o = or.namespace, ji = or.rowHovered;
                  return He.a.createElement("div", Object.assign({}, ir(cn, "object-meta-data"), { className: "object-meta-data", onClick: function(Cl) {
                    Cl.stopPropagation();
                  } }), Ct.getObjectSize(), Ho ? He.a.createElement(Nc, { rowHovered: ji, clickCallback: Ho, src: Fo, theme: cn, namespace: _o }) : null, ni !== false ? Ct.getAddAttribute(ji) : null, na !== false ? Ct.getRemoveObject(ji) : null);
                }, Ct;
              }
              return Xe;
            }(He.a.PureComponent);
            function Nh(St) {
              var Rt = St.parent_type, Xe = St.namespace, Ct = St.quotesOnKeys, Tt = St.theme, Ln = St.jsvRoot, Cr = St.name, or = St.displayArrayKey, cn = St.name ? St.name : "";
              return !Ln || Cr !== false && Cr !== null ? Rt == "array" ? or ? He.a.createElement("span", Object.assign({}, ir(Tt, "array-key"), { key: Xe }), He.a.createElement("span", { className: "array-key" }, cn), He.a.createElement("span", ir(Tt, "colon"), ":")) : He.a.createElement("span", null) : He.a.createElement("span", Object.assign({}, ir(Tt, "object-name"), { key: Xe }), He.a.createElement("span", { className: "object-key" }, Ct && He.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), He.a.createElement("span", null, cn), Ct && He.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), He.a.createElement("span", ir(Tt, "colon"), ":")) : He.a.createElement("span", null);
            }
            function Vh(St) {
              var Rt = St.theme;
              switch (St.iconStyle) {
                case "triangle":
                  return He.a.createElement(Os, Object.assign({}, ir(Rt, "expanded-icon"), { className: "expanded-icon" }));
                case "square":
                  return He.a.createElement(hl, Object.assign({}, ir(Rt, "expanded-icon"), { className: "expanded-icon" }));
                default:
                  return He.a.createElement(To, Object.assign({}, ir(Rt, "expanded-icon"), { className: "expanded-icon" }));
              }
            }
            function Md(St) {
              var Rt = St.theme;
              switch (St.iconStyle) {
                case "triangle":
                  return He.a.createElement(qs, Object.assign({}, ir(Rt, "collapsed-icon"), { className: "collapsed-icon" }));
                case "square":
                  return He.a.createElement(Mu, Object.assign({}, ir(Rt, "collapsed-icon"), { className: "collapsed-icon" }));
                default:
                  return He.a.createElement(Do, Object.assign({}, ir(Rt, "collapsed-icon"), { className: "collapsed-icon" }));
              }
            }
            var E0 = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).toggleCollapsed = function(Ln) {
                  var Cr = [];
                  for (var or in Tt.state.expanded)
                    Cr.push(Tt.state.expanded[or]);
                  Cr[Ln] = !Cr[Ln], Tt.setState({ expanded: Cr });
                }, Tt.state = { expanded: [] }, Tt;
              }
              return pt(Xe, [{ key: "getExpandedIcon", value: function(Ct) {
                var Tt = this.props, Ln = Tt.theme, Cr = Tt.iconStyle;
                return this.state.expanded[Ct] ? He.a.createElement(Vh, { theme: Ln, iconStyle: Cr }) : He.a.createElement(Md, { theme: Ln, iconStyle: Cr });
              } }, { key: "render", value: function() {
                var Ct = this, Tt = this.props, Ln = Tt.src, Cr = Tt.groupArraysAfterLength, or = (Tt.depth, Tt.name), cn = Tt.theme, na = Tt.jsvRoot, ni = Tt.namespace, Ho = (Tt.parent_type, An(Tt, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Fo = 0, _o = 5 * this.props.indentWidth;
                na || (Fo = 5 * this.props.indentWidth);
                var ji = Cr, Cl = Math.ceil(Ln.length / ji);
                return He.a.createElement("div", Object.assign({ className: "object-key-val" }, ir(cn, na ? "jsv-root" : "objectKeyVal", { paddingLeft: Fo })), He.a.createElement(Nh, this.props), He.a.createElement("span", null, He.a.createElement(Cd, Object.assign({ size: Ln.length }, this.props))), xs(Array(Cl)).map(function(Au, oo) {
                  return He.a.createElement("div", Object.assign({ key: oo, className: "object-key-val array-group" }, ir(cn, "objectKeyVal", { marginLeft: 6, paddingLeft: _o })), He.a.createElement("span", ir(cn, "brace-row"), He.a.createElement("div", Object.assign({ className: "icon-container" }, ir(cn, "icon-container"), { onClick: function(Eu) {
                    Ct.toggleCollapsed(oo);
                  } }), Ct.getExpandedIcon(oo)), Ct.state.expanded[oo] ? He.a.createElement(T0, Object.assign({ key: or + oo, depth: 0, name: false, collapsed: false, groupArraysAfterLength: ji, index_offset: oo * ji, src: Ln.slice(oo * ji, oo * ji + ji), namespace: ni, type: "array", parent_type: "array_group", theme: cn }, Ho)) : He.a.createElement("span", Object.assign({}, ir(cn, "brace"), { onClick: function(Eu) {
                    Ct.toggleCollapsed(oo);
                  }, className: "array-group-brace" }), "[", He.a.createElement("div", Object.assign({}, ir(cn, "array-group-meta-data"), { className: "array-group-meta-data" }), He.a.createElement("span", Object.assign({ className: "object-size" }, ir(cn, "object-size")), oo * ji, " - ", oo * ji + ji > Ln.length ? Ln.length : oo * ji + ji)), "]")));
                }));
              } }]), Xe;
            }(He.a.PureComponent), I0 = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                Ye(this, Xe), (Tt = Rt.call(this, Ct)).toggleCollapsed = function() {
                  Tt.setState({ expanded: !Tt.state.expanded }, function() {
                    os.set(Tt.props.rjvId, Tt.props.namespace, "expanded", Tt.state.expanded);
                  });
                }, Tt.getObjectContent = function(Cr, or, cn) {
                  return He.a.createElement("div", { className: "pushed-content object-container" }, He.a.createElement("div", Object.assign({ className: "object-content" }, ir(Tt.props.theme, "pushed-content")), Tt.renderObjectContents(or, cn)));
                }, Tt.getEllipsis = function() {
                  return Tt.state.size === 0 ? null : He.a.createElement("div", Object.assign({}, ir(Tt.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Tt.toggleCollapsed }), "...");
                }, Tt.getObjectMetaData = function(Cr) {
                  var or = Tt.props, cn = (or.rjvId, or.theme, Tt.state), na = cn.size, ni = cn.hovered;
                  return He.a.createElement(Cd, Object.assign({ rowHovered: ni, size: na }, Tt.props));
                }, Tt.renderObjectContents = function(Cr, or) {
                  var cn, na = Tt.props, ni = na.depth, Ho = na.parent_type, Fo = na.index_offset, _o = na.groupArraysAfterLength, ji = na.namespace, Cl = Tt.state.object_type, Au = [], oo = Object.keys(Cr || {});
                  return Tt.props.sortKeys && Cl !== "array" && (oo = oo.sort()), oo.forEach(function(Eu) {
                    if (cn = new pw(Eu, Cr[Eu]), Ho === "array_group" && Fo && (cn.name = parseInt(cn.name) + Fo), Cr.hasOwnProperty(Eu))
                      if (cn.type === "object")
                        Au.push(He.a.createElement(T0, Object.assign({ key: cn.name, depth: ni + 1, name: cn.name, src: cn.value, namespace: ji.concat(cn.name), parent_type: Cl }, or)));
                      else if (cn.type === "array") {
                        var jf = T0;
                        _o && cn.value.length > _o && (jf = E0), Au.push(He.a.createElement(jf, Object.assign({ key: cn.name, depth: ni + 1, name: cn.name, src: cn.value, namespace: ji.concat(cn.name), type: "array", parent_type: Cl }, or)));
                      } else
                        Au.push(He.a.createElement(Bf, Object.assign({ key: cn.name + "_" + ji, variable: cn, singleIndent: 5, namespace: ji, type: Tt.props.type }, or)));
                  }), Au;
                };
                var Ln = Xe.getState(Ct);
                return Tt.state = De(De({}, Ln), {}, { prevProps: {} }), Tt;
              }
              return pt(Xe, [{ key: "getBraceStart", value: function(Ct, Tt) {
                var Ln = this, Cr = this.props, or = Cr.src, cn = Cr.theme, na = Cr.iconStyle;
                if (Cr.parent_type === "array_group")
                  return He.a.createElement("span", null, He.a.createElement("span", ir(cn, "brace"), Ct === "array" ? "[" : "{"), Tt ? this.getObjectMetaData(or) : null);
                var ni = Tt ? Vh : Md;
                return He.a.createElement("span", null, He.a.createElement("span", Object.assign({ onClick: function(Ho) {
                  Ln.toggleCollapsed();
                } }, ir(cn, "brace-row")), He.a.createElement("div", Object.assign({ className: "icon-container" }, ir(cn, "icon-container")), He.a.createElement(ni, { theme: cn, iconStyle: na })), He.a.createElement(Nh, this.props), He.a.createElement("span", ir(cn, "brace"), Ct === "array" ? "[" : "{")), Tt ? this.getObjectMetaData(or) : null);
              } }, { key: "render", value: function() {
                var Ct = this, Tt = this.props, Ln = Tt.depth, Cr = Tt.src, or = (Tt.namespace, Tt.name, Tt.type, Tt.parent_type), cn = Tt.theme, na = Tt.jsvRoot, ni = Tt.iconStyle, Ho = An(Tt, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Fo = this.state, _o = Fo.object_type, ji = Fo.expanded, Cl = {};
                return na || or === "array_group" ? or === "array_group" && (Cl.borderLeft = 0, Cl.display = "inline") : Cl.paddingLeft = 5 * this.props.indentWidth, He.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                  return Ct.setState(De(De({}, Ct.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return Ct.setState(De(De({}, Ct.state), {}, { hovered: false }));
                } }, ir(cn, na ? "jsv-root" : "objectKeyVal", Cl)), this.getBraceStart(_o, ji), ji ? this.getObjectContent(Ln, Cr, De({ theme: cn, iconStyle: ni }, Ho)) : this.getEllipsis(), He.a.createElement("span", { className: "brace-row" }, He.a.createElement("span", { style: De(De({}, ir(cn, "brace").style), {}, { paddingLeft: ji ? "3px" : "0px" }) }, _o === "array" ? "]" : "}"), ji ? null : this.getObjectMetaData(Cr)));
              } }], [{ key: "getDerivedStateFromProps", value: function(Ct, Tt) {
                var Ln = Tt.prevProps;
                return Ct.src !== Ln.src || Ct.collapsed !== Ln.collapsed || Ct.name !== Ln.name || Ct.namespace !== Ln.namespace || Ct.rjvId !== Ln.rjvId ? De(De({}, Xe.getState(Ct)), {}, { prevProps: Ct }) : null;
              } }]), Xe;
            }(He.a.PureComponent);
            I0.getState = function(St) {
              var Rt = Object.keys(St.src).length, Xe = (St.collapsed === false || St.collapsed !== true && St.collapsed > St.depth) && (!St.shouldCollapse || St.shouldCollapse({ name: St.name, src: St.src, type: Nn(St.src), namespace: St.namespace }) === false) && Rt !== 0;
              return { expanded: os.get(St.rjvId, St.namespace, "expanded", Xe), object_type: St.type === "array" ? "array" : "object", parent_type: St.type === "array" ? "array" : "object", size: Rt, hovered: false };
            };
            var pw = function St(Rt, Xe) {
              Ye(this, St), this.name = Rt, this.value = Xe, this.type = Nn(Xe);
            };
            ur(I0);
            var T0 = I0, S1 = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                var Ct;
                Ye(this, Xe);
                for (var Tt = arguments.length, Ln = new Array(Tt), Cr = 0; Cr < Tt; Cr++)
                  Ln[Cr] = arguments[Cr];
                return (Ct = Rt.call.apply(Rt, [this].concat(Ln))).render = function() {
                  var or = ln(Ct).props, cn = [or.name], na = T0;
                  return Array.isArray(or.src) && or.groupArraysAfterLength && or.src.length > or.groupArraysAfterLength && (na = E0), He.a.createElement("div", { className: "pretty-json-container object-container" }, He.a.createElement("div", { className: "object-content" }, He.a.createElement(na, Object.assign({ namespace: cn, depth: 0, jsvRoot: true }, or))));
                }, Ct;
              }
              return Xe;
            }(He.a.PureComponent), vw = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).closeModal = function() {
                  io.dispatch({ rjvId: Tt.props.rjvId, name: "RESET" });
                }, Tt.submit = function() {
                  Tt.props.submit(Tt.state.input);
                }, Tt.state = { input: Ct.input ? Ct.input : "" }, Tt;
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this, Tt = this.props, Ln = Tt.theme, Cr = Tt.rjvId, or = Tt.isValid, cn = this.state.input, na = or(cn);
                return He.a.createElement("div", Object.assign({ className: "key-modal-request" }, ir(Ln, "key-modal-request"), { onClick: this.closeModal }), He.a.createElement("div", Object.assign({}, ir(Ln, "key-modal"), { onClick: function(ni) {
                  ni.stopPropagation();
                } }), He.a.createElement("div", ir(Ln, "key-modal-label"), "Key Name:"), He.a.createElement("div", { style: { position: "relative" } }, He.a.createElement("input", Object.assign({}, ir(Ln, "key-modal-input"), { className: "key-modal-input", ref: function(ni) {
                  return ni && ni.focus();
                }, spellCheck: false, value: cn, placeholder: "...", onChange: function(ni) {
                  Ct.setState({ input: ni.target.value });
                }, onKeyPress: function(ni) {
                  na && ni.key === "Enter" ? Ct.submit() : ni.key === "Escape" && Ct.closeModal();
                } })), na ? He.a.createElement(su, Object.assign({}, ir(Ln, "key-modal-submit"), { className: "key-modal-submit", onClick: function(ni) {
                  return Ct.submit();
                } })) : null), He.a.createElement("span", ir(Ln, "key-modal-cancel"), He.a.createElement(Kp, Object.assign({}, ir(Ln, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                  io.dispatch({ rjvId: Cr, name: "RESET" });
                } })))));
              } }]), Xe;
            }(He.a.PureComponent), i_ = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                var Ct;
                Ye(this, Xe);
                for (var Tt = arguments.length, Ln = new Array(Tt), Cr = 0; Cr < Tt; Cr++)
                  Ln[Cr] = arguments[Cr];
                return (Ct = Rt.call.apply(Rt, [this].concat(Ln))).isValid = function(or) {
                  var cn = Ct.props.rjvId, na = os.get(cn, "action", "new-key-request");
                  return or != "" && Object.keys(na.existing_value).indexOf(or) === -1;
                }, Ct.submit = function(or) {
                  var cn = Ct.props.rjvId, na = os.get(cn, "action", "new-key-request");
                  na.new_value = De({}, na.existing_value), na.new_value[or] = Ct.props.defaultValue, io.dispatch({ name: "VARIABLE_ADDED", rjvId: cn, data: na });
                }, Ct;
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.active, Ln = Ct.theme, Cr = Ct.rjvId;
                return Tt ? He.a.createElement(vw, { rjvId: Cr, theme: Ln, isValid: this.isValid, submit: this.submit }) : null;
              } }]), Xe;
            }(He.a.PureComponent), OS = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe() {
                return Ye(this, Xe), Rt.apply(this, arguments);
              }
              return pt(Xe, [{ key: "render", value: function() {
                var Ct = this.props, Tt = Ct.message, Ln = Ct.active, Cr = Ct.theme, or = Ct.rjvId;
                return Ln ? He.a.createElement("div", Object.assign({ className: "validation-failure" }, ir(Cr, "validation-failure"), { onClick: function() {
                  io.dispatch({ rjvId: or, name: "RESET" });
                } }), He.a.createElement("span", ir(Cr, "validation-failure-label"), Tt), He.a.createElement(Kp, ir(Cr, "validation-failure-clear"))) : null;
              } }]), Xe;
            }(He.a.PureComponent), xg = function(St) {
              qt(Xe, St);
              var Rt = sr(Xe);
              function Xe(Ct) {
                var Tt;
                return Ye(this, Xe), (Tt = Rt.call(this, Ct)).rjvId = Date.now().toString(), Tt.getListeners = function() {
                  return { reset: Tt.resetState, "variable-update": Tt.updateSrc, "add-key-request": Tt.addKeyRequest };
                }, Tt.updateSrc = function() {
                  var Ln, Cr = os.get(Tt.rjvId, "action", "variable-update"), or = Cr.name, cn = Cr.namespace, na = Cr.new_value, ni = Cr.existing_value, Ho = (Cr.variable_removed, Cr.updated_src), Fo = Cr.type, _o = Tt.props, ji = _o.onEdit, Cl = _o.onDelete, Au = _o.onAdd, oo = { existing_src: Tt.state.src, new_value: na, updated_src: Ho, name: or, namespace: cn, existing_value: ni };
                  switch (Fo) {
                    case "variable-added":
                      Ln = Au(oo);
                      break;
                    case "variable-edited":
                      Ln = ji(oo);
                      break;
                    case "variable-removed":
                      Ln = Cl(oo);
                  }
                  Ln !== false ? (os.set(Tt.rjvId, "global", "src", Ho), Tt.setState({ src: Ho })) : Tt.setState({ validationFailure: true });
                }, Tt.addKeyRequest = function() {
                  Tt.setState({ addKeyRequest: true });
                }, Tt.resetState = function() {
                  Tt.setState({ validationFailure: false, addKeyRequest: false });
                }, Tt.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Xe.defaultProps.src, name: Xe.defaultProps.name, theme: Xe.defaultProps.theme, validationMessage: Xe.defaultProps.validationMessage, prevSrc: Xe.defaultProps.src, prevName: Xe.defaultProps.name, prevTheme: Xe.defaultProps.theme }, Tt;
              }
              return pt(Xe, [{ key: "componentDidMount", value: function() {
                os.set(this.rjvId, "global", "src", this.state.src);
                var Ct = this.getListeners();
                for (var Tt in Ct)
                  os.on(Tt + "-" + this.rjvId, Ct[Tt]);
                this.setState({ addKeyRequest: false, editKeyRequest: false });
              } }, { key: "componentDidUpdate", value: function(Ct, Tt) {
                Tt.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Tt.editKeyRequest !== false && this.setState({ editKeyRequest: false }), Ct.src !== this.state.src && os.set(this.rjvId, "global", "src", this.state.src);
              } }, { key: "componentWillUnmount", value: function() {
                var Ct = this.getListeners();
                for (var Tt in Ct)
                  os.removeListener(Tt + "-" + this.rjvId, Ct[Tt]);
              } }, { key: "render", value: function() {
                var Ct = this.state, Tt = Ct.validationFailure, Ln = Ct.validationMessage, Cr = Ct.addKeyRequest, or = Ct.theme, cn = Ct.src, na = Ct.name, ni = this.props, Ho = ni.style, Fo = ni.defaultValue;
                return He.a.createElement("div", { className: "react-json-view", style: De(De({}, ir(or, "app-container").style), Ho) }, He.a.createElement(OS, { message: Ln, active: Tt, theme: or, rjvId: this.rjvId }), He.a.createElement(S1, Object.assign({}, this.props, { src: cn, name: na, theme: or, type: Nn(cn), rjvId: this.rjvId })), He.a.createElement(i_, { active: Cr, theme: or, rjvId: this.rjvId, defaultValue: Fo }));
              } }], [{ key: "getDerivedStateFromProps", value: function(Ct, Tt) {
                if (Ct.src !== Tt.prevSrc || Ct.name !== Tt.prevName || Ct.theme !== Tt.prevTheme) {
                  var Ln = { src: Ct.src, name: Ct.name, theme: Ct.theme, validationMessage: Ct.validationMessage, prevSrc: Ct.src, prevName: Ct.name, prevTheme: Ct.theme };
                  return Xe.validateState(Ln);
                }
                return null;
              } }]), Xe;
            }(He.a.PureComponent);
            xg.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, xg.validateState = function(St) {
              var Rt = {};
              return Nn(St.theme) !== "object" || function(Xe) {
                var Ct = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                if (Nn(Xe) === "object") {
                  for (var Tt = 0; Tt < Ct.length; Tt++)
                    if (!(Ct[Tt] in Xe))
                      return false;
                  return true;
                }
                return false;
              }(St.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Rt.theme = "rjv-default"), Nn(St.src) !== "object" && Nn(St.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Rt.name = "ERROR", Rt.src = { message: "src property must be a valid json object" }), De(De({}, St), Rt);
            }, ur(xg), te.default = xg;
          }]);
        });
      })(xk);
      var _j = F(xk.exports);
      const E6 = ({ id: Z, title: ve, chart: J, option: ee }) => {
        const { tool: te } = Nt({}), ce = U({ global: true }), [Ie, { set: Le }] = _e(true);
        console.log("option", ee);
        const De = (Ye) => {
          const { updated_src: Ke } = Ye;
          J == null || J.setOption(Ke), te == null || te.add(Z, J, Ke, ve), ce.emit("list");
        };
        return C6("div", { children: [dw(Oee, { children: dw(mj, { children: dw(A62, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (Ye) => {
          Le(!Ye);
        } }) }) }), dw("br", {}), ee && dw(_j, { src: ee, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: Ie, iconStyle: "triangle", enableClipboard: true, onEdit: De, onAdd: De, onDelete: De })] });
      };
      a.EchartTool = bj, a.ReactEchartsJson = E6, a.useEchartsTool = Nt, a.useEventEmitter = U;
    })(oQe);
    const sQe = () => {
      const a = Qz({ global: true }), r6 = g4.useRef(0), { tool: t2 } = $J({});
      g4.useState(false), g4.useState("right");
      const [s, u] = g4.useState([]), [f6, d6] = g4.useState();
      return a.useSubscription("list", () => {
        var v6;
        t2 != null && t2.list().length && (d6((v6 = t2 == null ? void 0 : t2.list()) == null ? void 0 : v6[r6.current]), u(t2 == null ? void 0 : t2.list()));
      }), B5("div", { className: iQe.container, children: false });
    };
    var d_e = { exports: {} };
    (function(a, r6) {
      (function(t2, s) {
        a.exports = s(w4.default);
      })(ze, function(t2) {
        return function(s) {
          var u = {};
          function f6(d6) {
            if (u[d6])
              return u[d6].exports;
            var v6 = u[d6] = { i: d6, l: false, exports: {} };
            return s[d6].call(v6.exports, v6, v6.exports, f6), v6.l = true, v6.exports;
          }
          return f6.m = s, f6.c = u, f6.d = function(d6, v6, m6) {
            f6.o(d6, v6) || Object.defineProperty(d6, v6, { enumerable: true, get: m6 });
          }, f6.r = function(d6) {
            typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(d6, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(d6, "__esModule", { value: true });
          }, f6.t = function(d6, v6) {
            if (1 & v6 && (d6 = f6(d6)), 8 & v6 || 4 & v6 && typeof d6 == "object" && d6 && d6.__esModule)
              return d6;
            var m6 = /* @__PURE__ */ Object.create(null);
            if (f6.r(m6), Object.defineProperty(m6, "default", { enumerable: true, value: d6 }), 2 & v6 && typeof d6 != "string")
              for (var b6 in d6)
                f6.d(m6, b6, function(x6) {
                  return d6[x6];
                }.bind(null, b6));
            return m6;
          }, f6.n = function(d6) {
            var v6 = d6 && d6.__esModule ? function() {
              return d6.default;
            } : function() {
              return d6;
            };
            return f6.d(v6, "a", v6), v6;
          }, f6.o = function(d6, v6) {
            return Object.prototype.hasOwnProperty.call(d6, v6);
          }, f6.p = "", f6(f6.s = 48);
        }([function(s, u) {
          s.exports = t2;
        }, function(s, u) {
          var f6 = s.exports = { version: "2.6.12" };
          typeof __e == "number" && (__e = f6);
        }, function(s, u, f6) {
          var d6 = f6(26)("wks"), v6 = f6(17), m6 = f6(3).Symbol, b6 = typeof m6 == "function";
          (s.exports = function(x6) {
            return d6[x6] || (d6[x6] = b6 && m6[x6] || (b6 ? m6 : v6)("Symbol." + x6));
          }).store = d6;
        }, function(s, u) {
          var f6 = s.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
          typeof __g == "number" && (__g = f6);
        }, function(s, u, f6) {
          s.exports = !f6(8)(function() {
            return Object.defineProperty({}, "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(s, u) {
          var f6 = {}.hasOwnProperty;
          s.exports = function(d6, v6) {
            return f6.call(d6, v6);
          };
        }, function(s, u, f6) {
          var d6 = f6(7), v6 = f6(16);
          s.exports = f6(4) ? function(m6, b6, x6) {
            return d6.f(m6, b6, v6(1, x6));
          } : function(m6, b6, x6) {
            return m6[b6] = x6, m6;
          };
        }, function(s, u, f6) {
          var d6 = f6(10), v6 = f6(35), m6 = f6(23), b6 = Object.defineProperty;
          u.f = f6(4) ? Object.defineProperty : function(x6, S, M) {
            if (d6(x6), S = m6(S, true), d6(M), v6)
              try {
                return b6(x6, S, M);
              } catch {
              }
            if ("get" in M || "set" in M)
              throw TypeError("Accessors not supported!");
            return "value" in M && (x6[S] = M.value), x6;
          };
        }, function(s, u) {
          s.exports = function(f6) {
            try {
              return !!f6();
            } catch {
              return true;
            }
          };
        }, function(s, u, f6) {
          var d6 = f6(40), v6 = f6(22);
          s.exports = function(m6) {
            return d6(v6(m6));
          };
        }, function(s, u, f6) {
          var d6 = f6(11);
          s.exports = function(v6) {
            if (!d6(v6))
              throw TypeError(v6 + " is not an object!");
            return v6;
          };
        }, function(s, u) {
          s.exports = function(f6) {
            return typeof f6 == "object" ? f6 !== null : typeof f6 == "function";
          };
        }, function(s, u) {
          s.exports = {};
        }, function(s, u, f6) {
          var d6 = f6(39), v6 = f6(27);
          s.exports = Object.keys || function(m6) {
            return d6(m6, v6);
          };
        }, function(s, u) {
          s.exports = true;
        }, function(s, u, f6) {
          var d6 = f6(3), v6 = f6(1), m6 = f6(53), b6 = f6(6), x6 = f6(5), S = function(M, A6, I) {
            var R, F, j, $ = M & S.F, K = M & S.G, U = M & S.S, he = M & S.P, ue = M & S.B, pe = M & S.W, _e = K ? v6 : v6[A6] || (v6[A6] = {}), xe = _e.prototype, Ae = K ? d6 : U ? d6[A6] : (d6[A6] || {}).prototype;
            for (R in K && (I = A6), I)
              (F = !$ && Ae && Ae[R] !== void 0) && x6(_e, R) || (j = F ? Ae[R] : I[R], _e[R] = K && typeof Ae[R] != "function" ? I[R] : ue && F ? m6(j, d6) : pe && Ae[R] == j ? function(ke) {
                var je = function(Fe, at, ht) {
                  if (this instanceof ke) {
                    switch (arguments.length) {
                      case 0:
                        return new ke();
                      case 1:
                        return new ke(Fe);
                      case 2:
                        return new ke(Fe, at);
                    }
                    return new ke(Fe, at, ht);
                  }
                  return ke.apply(this, arguments);
                };
                return je.prototype = ke.prototype, je;
              }(j) : he && typeof j == "function" ? m6(Function.call, j) : j, he && ((_e.virtual || (_e.virtual = {}))[R] = j, M & S.R && xe && !xe[R] && b6(xe, R, j)));
          };
          S.F = 1, S.G = 2, S.S = 4, S.P = 8, S.B = 16, S.W = 32, S.U = 64, S.R = 128, s.exports = S;
        }, function(s, u) {
          s.exports = function(f6, d6) {
            return { enumerable: !(1 & f6), configurable: !(2 & f6), writable: !(4 & f6), value: d6 };
          };
        }, function(s, u) {
          var f6 = 0, d6 = Math.random();
          s.exports = function(v6) {
            return "Symbol(".concat(v6 === void 0 ? "" : v6, ")_", (++f6 + d6).toString(36));
          };
        }, function(s, u, f6) {
          var d6 = f6(22);
          s.exports = function(v6) {
            return Object(d6(v6));
          };
        }, function(s, u) {
          u.f = {}.propertyIsEnumerable;
        }, function(s, u, f6) {
          var d6 = f6(52)(true);
          f6(34)(String, "String", function(v6) {
            this._t = String(v6), this._i = 0;
          }, function() {
            var v6, m6 = this._t, b6 = this._i;
            return b6 >= m6.length ? { value: void 0, done: true } : (v6 = d6(m6, b6), this._i += v6.length, { value: v6, done: false });
          });
        }, function(s, u) {
          var f6 = Math.ceil, d6 = Math.floor;
          s.exports = function(v6) {
            return isNaN(v6 = +v6) ? 0 : (v6 > 0 ? d6 : f6)(v6);
          };
        }, function(s, u) {
          s.exports = function(f6) {
            if (f6 == null)
              throw TypeError("Can't call method on  " + f6);
            return f6;
          };
        }, function(s, u, f6) {
          var d6 = f6(11);
          s.exports = function(v6, m6) {
            if (!d6(v6))
              return v6;
            var b6, x6;
            if (m6 && typeof (b6 = v6.toString) == "function" && !d6(x6 = b6.call(v6)) || typeof (b6 = v6.valueOf) == "function" && !d6(x6 = b6.call(v6)) || !m6 && typeof (b6 = v6.toString) == "function" && !d6(x6 = b6.call(v6)))
              return x6;
            throw TypeError("Can't convert object to primitive value");
          };
        }, function(s, u) {
          var f6 = {}.toString;
          s.exports = function(d6) {
            return f6.call(d6).slice(8, -1);
          };
        }, function(s, u, f6) {
          var d6 = f6(26)("keys"), v6 = f6(17);
          s.exports = function(m6) {
            return d6[m6] || (d6[m6] = v6(m6));
          };
        }, function(s, u, f6) {
          var d6 = f6(1), v6 = f6(3), m6 = v6["__core-js_shared__"] || (v6["__core-js_shared__"] = {});
          (s.exports = function(b6, x6) {
            return m6[b6] || (m6[b6] = x6 !== void 0 ? x6 : {});
          })("versions", []).push({ version: d6.version, mode: f6(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
        }, function(s, u) {
          s.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
        }, function(s, u, f6) {
          var d6 = f6(7).f, v6 = f6(5), m6 = f6(2)("toStringTag");
          s.exports = function(b6, x6, S) {
            b6 && !v6(b6 = S ? b6 : b6.prototype, m6) && d6(b6, m6, { configurable: true, value: x6 });
          };
        }, function(s, u, f6) {
          f6(62);
          for (var d6 = f6(3), v6 = f6(6), m6 = f6(12), b6 = f6(2)("toStringTag"), x6 = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), S = 0; S < x6.length; S++) {
            var M = x6[S], A6 = d6[M], I = A6 && A6.prototype;
            I && !I[b6] && v6(I, b6, M), m6[M] = m6.Array;
          }
        }, function(s, u, f6) {
          u.f = f6(2);
        }, function(s, u, f6) {
          var d6 = f6(3), v6 = f6(1), m6 = f6(14), b6 = f6(30), x6 = f6(7).f;
          s.exports = function(S) {
            var M = v6.Symbol || (v6.Symbol = m6 ? {} : d6.Symbol || {});
            S.charAt(0) == "_" || S in M || x6(M, S, { value: b6.f(S) });
          };
        }, function(s, u) {
          u.f = Object.getOwnPropertySymbols;
        }, function(s, u) {
          s.exports = function(f6, d6, v6) {
            return Math.min(Math.max(f6, d6), v6);
          };
        }, function(s, u, f6) {
          var d6 = f6(14), v6 = f6(15), m6 = f6(37), b6 = f6(6), x6 = f6(12), S = f6(55), M = f6(28), A6 = f6(61), I = f6(2)("iterator"), R = !([].keys && "next" in [].keys()), F = function() {
            return this;
          };
          s.exports = function(j, $, K, U, he, ue, pe) {
            S(K, $, U);
            var _e, xe, Ae, ke = function(Ft) {
              if (!R && Ft in ht)
                return ht[Ft];
              switch (Ft) {
                case "keys":
                case "values":
                  return function() {
                    return new K(this, Ft);
                  };
              }
              return function() {
                return new K(this, Ft);
              };
            }, je = $ + " Iterator", Fe = he == "values", at = false, ht = j.prototype, Qe = ht[I] || ht["@@iterator"] || he && ht[he], en = Qe || ke(he), bt = he ? Fe ? ke("entries") : en : void 0, wt = $ == "Array" && ht.entries || Qe;
            if (wt && (Ae = A6(wt.call(new j()))) !== Object.prototype && Ae.next && (M(Ae, je, true), d6 || typeof Ae[I] == "function" || b6(Ae, I, F)), Fe && Qe && Qe.name !== "values" && (at = true, en = function() {
              return Qe.call(this);
            }), d6 && !pe || !R && !at && ht[I] || b6(ht, I, en), x6[$] = en, x6[je] = F, he)
              if (_e = { values: Fe ? en : ke("values"), keys: ue ? en : ke("keys"), entries: bt }, pe)
                for (xe in _e)
                  xe in ht || m6(ht, xe, _e[xe]);
              else
                v6(v6.P + v6.F * (R || at), $, _e);
            return _e;
          };
        }, function(s, u, f6) {
          s.exports = !f6(4) && !f6(8)(function() {
            return Object.defineProperty(f6(36)("div"), "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(s, u, f6) {
          var d6 = f6(11), v6 = f6(3).document, m6 = d6(v6) && d6(v6.createElement);
          s.exports = function(b6) {
            return m6 ? v6.createElement(b6) : {};
          };
        }, function(s, u, f6) {
          s.exports = f6(6);
        }, function(s, u, f6) {
          var d6 = f6(10), v6 = f6(56), m6 = f6(27), b6 = f6(25)("IE_PROTO"), x6 = function() {
          }, S = function() {
            var M, A6 = f6(36)("iframe"), I = m6.length;
            for (A6.style.display = "none", f6(60).appendChild(A6), A6.src = "javascript:", (M = A6.contentWindow.document).open(), M.write("<script>document.F=Object<\/script>"), M.close(), S = M.F; I--; )
              delete S.prototype[m6[I]];
            return S();
          };
          s.exports = Object.create || function(M, A6) {
            var I;
            return M !== null ? (x6.prototype = d6(M), I = new x6(), x6.prototype = null, I[b6] = M) : I = S(), A6 === void 0 ? I : v6(I, A6);
          };
        }, function(s, u, f6) {
          var d6 = f6(5), v6 = f6(9), m6 = f6(57)(false), b6 = f6(25)("IE_PROTO");
          s.exports = function(x6, S) {
            var M, A6 = v6(x6), I = 0, R = [];
            for (M in A6)
              M != b6 && d6(A6, M) && R.push(M);
            for (; S.length > I; )
              d6(A6, M = S[I++]) && (~m6(R, M) || R.push(M));
            return R;
          };
        }, function(s, u, f6) {
          var d6 = f6(24);
          s.exports = Object("z").propertyIsEnumerable(0) ? Object : function(v6) {
            return d6(v6) == "String" ? v6.split("") : Object(v6);
          };
        }, function(s, u, f6) {
          var d6 = f6(39), v6 = f6(27).concat("length", "prototype");
          u.f = Object.getOwnPropertyNames || function(m6) {
            return d6(m6, v6);
          };
        }, function(s, u, f6) {
          var d6 = f6(24), v6 = f6(2)("toStringTag"), m6 = d6(function() {
            return arguments;
          }()) == "Arguments";
          s.exports = function(b6) {
            var x6, S, M;
            return b6 === void 0 ? "Undefined" : b6 === null ? "Null" : typeof (S = function(A6, I) {
              try {
                return A6[I];
              } catch {
              }
            }(x6 = Object(b6), v6)) == "string" ? S : m6 ? d6(x6) : (M = d6(x6)) == "Object" && typeof x6.callee == "function" ? "Arguments" : M;
          };
        }, function(s, u) {
          var f6;
          f6 = function() {
            return this;
          }();
          try {
            f6 = f6 || new Function("return this")();
          } catch {
            typeof window == "object" && (f6 = window);
          }
          s.exports = f6;
        }, function(s, u) {
          var f6 = /-?\d+(\.\d+)?%?/g;
          s.exports = function(d6) {
            return d6.match(f6);
          };
        }, function(s, u, f6) {
          Object.defineProperty(u, "__esModule", { value: true }), u.getBase16Theme = u.createStyling = u.invertTheme = void 0;
          var d6 = F(f6(49)), v6 = F(f6(76)), m6 = F(f6(81)), b6 = F(f6(89)), x6 = F(f6(93)), S = function(xe) {
            if (xe && xe.__esModule)
              return xe;
            var Ae = {};
            if (xe != null)
              for (var ke in xe)
                Object.prototype.hasOwnProperty.call(xe, ke) && (Ae[ke] = xe[ke]);
            return Ae.default = xe, Ae;
          }(f6(94)), M = F(f6(132)), A6 = F(f6(133)), I = F(f6(138)), R = f6(139);
          function F(xe) {
            return xe && xe.__esModule ? xe : { default: xe };
          }
          var j = S.default, $ = (0, b6.default)(j), K = (0, I.default)(A6.default, R.rgb2yuv, function(xe) {
            var Ae, ke = (0, m6.default)(xe, 3), je = ke[0], Fe = ke[1], at = ke[2];
            return [(Ae = je, Ae < 0.25 ? 1 : Ae < 0.5 ? 0.9 - Ae : 1.1 - Ae), Fe, at];
          }, R.yuv2rgb, M.default), U = function(xe) {
            return function(Ae) {
              return { className: [Ae.className, xe.className].filter(Boolean).join(" "), style: (0, v6.default)({}, Ae.style || {}, xe.style || {}) };
            };
          }, he = function(xe, Ae) {
            var ke = (0, b6.default)(Ae);
            for (var je in xe)
              ke.indexOf(je) === -1 && ke.push(je);
            return ke.reduce(function(Fe, at) {
              return Fe[at] = function(ht, Qe) {
                if (ht === void 0)
                  return Qe;
                if (Qe === void 0)
                  return ht;
                var en = ht === void 0 ? "undefined" : (0, d6.default)(ht), bt = Qe === void 0 ? "undefined" : (0, d6.default)(Qe);
                switch (en) {
                  case "string":
                    switch (bt) {
                      case "string":
                        return [Qe, ht].filter(Boolean).join(" ");
                      case "object":
                        return U({ className: ht, style: Qe });
                      case "function":
                        return function(wt) {
                          for (var Ft = arguments.length, fn = Array(Ft > 1 ? Ft - 1 : 0), gn = 1; gn < Ft; gn++)
                            fn[gn - 1] = arguments[gn];
                          return U({ className: ht })(Qe.apply(void 0, [wt].concat(fn)));
                        };
                    }
                  case "object":
                    switch (bt) {
                      case "string":
                        return U({ className: Qe, style: ht });
                      case "object":
                        return (0, v6.default)({}, Qe, ht);
                      case "function":
                        return function(wt) {
                          for (var Ft = arguments.length, fn = Array(Ft > 1 ? Ft - 1 : 0), gn = 1; gn < Ft; gn++)
                            fn[gn - 1] = arguments[gn];
                          return U({ style: ht })(Qe.apply(void 0, [wt].concat(fn)));
                        };
                    }
                  case "function":
                    switch (bt) {
                      case "string":
                        return function(wt) {
                          for (var Ft = arguments.length, fn = Array(Ft > 1 ? Ft - 1 : 0), gn = 1; gn < Ft; gn++)
                            fn[gn - 1] = arguments[gn];
                          return ht.apply(void 0, [U(wt)({ className: Qe })].concat(fn));
                        };
                      case "object":
                        return function(wt) {
                          for (var Ft = arguments.length, fn = Array(Ft > 1 ? Ft - 1 : 0), gn = 1; gn < Ft; gn++)
                            fn[gn - 1] = arguments[gn];
                          return ht.apply(void 0, [U(wt)({ style: Qe })].concat(fn));
                        };
                      case "function":
                        return function(wt) {
                          for (var Ft = arguments.length, fn = Array(Ft > 1 ? Ft - 1 : 0), gn = 1; gn < Ft; gn++)
                            fn[gn - 1] = arguments[gn];
                          return ht.apply(void 0, [Qe.apply(void 0, [wt].concat(fn))].concat(fn));
                        };
                    }
                }
              }(xe[at], Ae[at]), Fe;
            }, {});
          }, ue = function(xe, Ae) {
            for (var ke = arguments.length, je = Array(ke > 2 ? ke - 2 : 0), Fe = 2; Fe < ke; Fe++)
              je[Fe - 2] = arguments[Fe];
            if (Ae === null)
              return xe;
            Array.isArray(Ae) || (Ae = [Ae]);
            var at = Ae.map(function(Qe) {
              return xe[Qe];
            }).filter(Boolean), ht = at.reduce(function(Qe, en) {
              return typeof en == "string" ? Qe.className = [Qe.className, en].filter(Boolean).join(" ") : (en === void 0 ? "undefined" : (0, d6.default)(en)) === "object" ? Qe.style = (0, v6.default)({}, Qe.style, en) : typeof en == "function" && (Qe = (0, v6.default)({}, Qe, en.apply(void 0, [Qe].concat(je)))), Qe;
            }, { className: "", style: {} });
            return ht.className || delete ht.className, (0, b6.default)(ht.style).length === 0 && delete ht.style, ht;
          }, pe = u.invertTheme = function(xe) {
            return (0, b6.default)(xe).reduce(function(Ae, ke) {
              return Ae[ke] = /^base/.test(ke) ? K(xe[ke]) : ke === "scheme" ? xe[ke] + ":inverted" : xe[ke], Ae;
            }, {});
          }, _e = (u.createStyling = (0, x6.default)(function(xe) {
            for (var Ae = arguments.length, ke = Array(Ae > 3 ? Ae - 3 : 0), je = 3; je < Ae; je++)
              ke[je - 3] = arguments[je];
            var Fe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, at = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, ht = Fe.defaultBase16, Qe = ht === void 0 ? j : ht, en = Fe.base16Themes, bt = en === void 0 ? null : en, wt = _e(at, bt);
            wt && (at = (0, v6.default)({}, wt, at));
            var Ft = $.reduce(function(Ma, Ua) {
              return Ma[Ua] = at[Ua] || Qe[Ua], Ma;
            }, {}), fn = (0, b6.default)(at).reduce(function(Ma, Ua) {
              return $.indexOf(Ua) === -1 && (Ma[Ua] = at[Ua]), Ma;
            }, {}), gn = xe(Ft), Zr = he(fn, gn);
            return (0, x6.default)(ue, 2).apply(void 0, [Zr].concat(ke));
          }, 3), u.getBase16Theme = function(xe, Ae) {
            if (xe && xe.extend && (xe = xe.extend), typeof xe == "string") {
              var ke = xe.split(":"), je = (0, m6.default)(ke, 2), Fe = je[0], at = je[1];
              xe = (Ae || {})[Fe] || S[Fe], at === "inverted" && (xe = pe(xe));
            }
            return xe && xe.hasOwnProperty("base00") ? xe : void 0;
          });
        }, function(s, u, f6) {
          var d6, v6 = typeof Reflect == "object" ? Reflect : null, m6 = v6 && typeof v6.apply == "function" ? v6.apply : function(U, he, ue) {
            return Function.prototype.apply.call(U, he, ue);
          };
          d6 = v6 && typeof v6.ownKeys == "function" ? v6.ownKeys : Object.getOwnPropertySymbols ? function(U) {
            return Object.getOwnPropertyNames(U).concat(Object.getOwnPropertySymbols(U));
          } : function(U) {
            return Object.getOwnPropertyNames(U);
          };
          var b6 = Number.isNaN || function(U) {
            return U != U;
          };
          function x6() {
            x6.init.call(this);
          }
          s.exports = x6, s.exports.once = function(U, he) {
            return new Promise(function(ue, pe) {
              function _e() {
                xe !== void 0 && U.removeListener("error", xe), ue([].slice.call(arguments));
              }
              var xe;
              he !== "error" && (xe = function(Ae) {
                U.removeListener(he, _e), pe(Ae);
              }, U.once("error", xe)), U.once(he, _e);
            });
          }, x6.EventEmitter = x6, x6.prototype._events = void 0, x6.prototype._eventsCount = 0, x6.prototype._maxListeners = void 0;
          var S = 10;
          function M(U) {
            if (typeof U != "function")
              throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof U);
          }
          function A6(U) {
            return U._maxListeners === void 0 ? x6.defaultMaxListeners : U._maxListeners;
          }
          function I(U, he, ue, pe) {
            var _e, xe, Ae, ke;
            if (M(ue), (xe = U._events) === void 0 ? (xe = U._events = /* @__PURE__ */ Object.create(null), U._eventsCount = 0) : (xe.newListener !== void 0 && (U.emit("newListener", he, ue.listener ? ue.listener : ue), xe = U._events), Ae = xe[he]), Ae === void 0)
              Ae = xe[he] = ue, ++U._eventsCount;
            else if (typeof Ae == "function" ? Ae = xe[he] = pe ? [ue, Ae] : [Ae, ue] : pe ? Ae.unshift(ue) : Ae.push(ue), (_e = A6(U)) > 0 && Ae.length > _e && !Ae.warned) {
              Ae.warned = true;
              var je = new Error("Possible EventEmitter memory leak detected. " + Ae.length + " " + String(he) + " listeners added. Use emitter.setMaxListeners() to increase limit");
              je.name = "MaxListenersExceededWarning", je.emitter = U, je.type = he, je.count = Ae.length, ke = je, console && console.warn && console.warn(ke);
            }
            return U;
          }
          function R() {
            if (!this.fired)
              return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
          }
          function F(U, he, ue) {
            var pe = { fired: false, wrapFn: void 0, target: U, type: he, listener: ue }, _e = R.bind(pe);
            return _e.listener = ue, pe.wrapFn = _e, _e;
          }
          function j(U, he, ue) {
            var pe = U._events;
            if (pe === void 0)
              return [];
            var _e = pe[he];
            return _e === void 0 ? [] : typeof _e == "function" ? ue ? [_e.listener || _e] : [_e] : ue ? function(xe) {
              for (var Ae = new Array(xe.length), ke = 0; ke < Ae.length; ++ke)
                Ae[ke] = xe[ke].listener || xe[ke];
              return Ae;
            }(_e) : K(_e, _e.length);
          }
          function $(U) {
            var he = this._events;
            if (he !== void 0) {
              var ue = he[U];
              if (typeof ue == "function")
                return 1;
              if (ue !== void 0)
                return ue.length;
            }
            return 0;
          }
          function K(U, he) {
            for (var ue = new Array(he), pe = 0; pe < he; ++pe)
              ue[pe] = U[pe];
            return ue;
          }
          Object.defineProperty(x6, "defaultMaxListeners", { enumerable: true, get: function() {
            return S;
          }, set: function(U) {
            if (typeof U != "number" || U < 0 || b6(U))
              throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + U + ".");
            S = U;
          } }), x6.init = function() {
            this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
          }, x6.prototype.setMaxListeners = function(U) {
            if (typeof U != "number" || U < 0 || b6(U))
              throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + U + ".");
            return this._maxListeners = U, this;
          }, x6.prototype.getMaxListeners = function() {
            return A6(this);
          }, x6.prototype.emit = function(U) {
            for (var he = [], ue = 1; ue < arguments.length; ue++)
              he.push(arguments[ue]);
            var pe = U === "error", _e = this._events;
            if (_e !== void 0)
              pe = pe && _e.error === void 0;
            else if (!pe)
              return false;
            if (pe) {
              var xe;
              if (he.length > 0 && (xe = he[0]), xe instanceof Error)
                throw xe;
              var Ae = new Error("Unhandled error." + (xe ? " (" + xe.message + ")" : ""));
              throw Ae.context = xe, Ae;
            }
            var ke = _e[U];
            if (ke === void 0)
              return false;
            if (typeof ke == "function")
              m6(ke, this, he);
            else {
              var je = ke.length, Fe = K(ke, je);
              for (ue = 0; ue < je; ++ue)
                m6(Fe[ue], this, he);
            }
            return true;
          }, x6.prototype.addListener = function(U, he) {
            return I(this, U, he, false);
          }, x6.prototype.on = x6.prototype.addListener, x6.prototype.prependListener = function(U, he) {
            return I(this, U, he, true);
          }, x6.prototype.once = function(U, he) {
            return M(he), this.on(U, F(this, U, he)), this;
          }, x6.prototype.prependOnceListener = function(U, he) {
            return M(he), this.prependListener(U, F(this, U, he)), this;
          }, x6.prototype.removeListener = function(U, he) {
            var ue, pe, _e, xe, Ae;
            if (M(he), (pe = this._events) === void 0)
              return this;
            if ((ue = pe[U]) === void 0)
              return this;
            if (ue === he || ue.listener === he)
              --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete pe[U], pe.removeListener && this.emit("removeListener", U, ue.listener || he));
            else if (typeof ue != "function") {
              for (_e = -1, xe = ue.length - 1; xe >= 0; xe--)
                if (ue[xe] === he || ue[xe].listener === he) {
                  Ae = ue[xe].listener, _e = xe;
                  break;
                }
              if (_e < 0)
                return this;
              _e === 0 ? ue.shift() : function(ke, je) {
                for (; je + 1 < ke.length; je++)
                  ke[je] = ke[je + 1];
                ke.pop();
              }(ue, _e), ue.length === 1 && (pe[U] = ue[0]), pe.removeListener !== void 0 && this.emit("removeListener", U, Ae || he);
            }
            return this;
          }, x6.prototype.off = x6.prototype.removeListener, x6.prototype.removeAllListeners = function(U) {
            var he, ue, pe;
            if ((ue = this._events) === void 0)
              return this;
            if (ue.removeListener === void 0)
              return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : ue[U] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete ue[U]), this;
            if (arguments.length === 0) {
              var _e, xe = Object.keys(ue);
              for (pe = 0; pe < xe.length; ++pe)
                (_e = xe[pe]) !== "removeListener" && this.removeAllListeners(_e);
              return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
            }
            if (typeof (he = ue[U]) == "function")
              this.removeListener(U, he);
            else if (he !== void 0)
              for (pe = he.length - 1; pe >= 0; pe--)
                this.removeListener(U, he[pe]);
            return this;
          }, x6.prototype.listeners = function(U) {
            return j(this, U, true);
          }, x6.prototype.rawListeners = function(U) {
            return j(this, U, false);
          }, x6.listenerCount = function(U, he) {
            return typeof U.listenerCount == "function" ? U.listenerCount(he) : $.call(U, he);
          }, x6.prototype.listenerCount = $, x6.prototype.eventNames = function() {
            return this._eventsCount > 0 ? d6(this._events) : [];
          };
        }, function(s, u, f6) {
          s.exports.Dispatcher = f6(140);
        }, function(s, u, f6) {
          s.exports = f6(142);
        }, function(s, u, f6) {
          u.__esModule = true;
          var d6 = b6(f6(50)), v6 = b6(f6(65)), m6 = typeof v6.default == "function" && typeof d6.default == "symbol" ? function(x6) {
            return typeof x6;
          } : function(x6) {
            return x6 && typeof v6.default == "function" && x6.constructor === v6.default && x6 !== v6.default.prototype ? "symbol" : typeof x6;
          };
          function b6(x6) {
            return x6 && x6.__esModule ? x6 : { default: x6 };
          }
          u.default = typeof v6.default == "function" && m6(d6.default) === "symbol" ? function(x6) {
            return x6 === void 0 ? "undefined" : m6(x6);
          } : function(x6) {
            return x6 && typeof v6.default == "function" && x6.constructor === v6.default && x6 !== v6.default.prototype ? "symbol" : x6 === void 0 ? "undefined" : m6(x6);
          };
        }, function(s, u, f6) {
          s.exports = { default: f6(51), __esModule: true };
        }, function(s, u, f6) {
          f6(20), f6(29), s.exports = f6(30).f("iterator");
        }, function(s, u, f6) {
          var d6 = f6(21), v6 = f6(22);
          s.exports = function(m6) {
            return function(b6, x6) {
              var S, M, A6 = String(v6(b6)), I = d6(x6), R = A6.length;
              return I < 0 || I >= R ? m6 ? "" : void 0 : (S = A6.charCodeAt(I)) < 55296 || S > 56319 || I + 1 === R || (M = A6.charCodeAt(I + 1)) < 56320 || M > 57343 ? m6 ? A6.charAt(I) : S : m6 ? A6.slice(I, I + 2) : M - 56320 + (S - 55296 << 10) + 65536;
            };
          };
        }, function(s, u, f6) {
          var d6 = f6(54);
          s.exports = function(v6, m6, b6) {
            if (d6(v6), m6 === void 0)
              return v6;
            switch (b6) {
              case 1:
                return function(x6) {
                  return v6.call(m6, x6);
                };
              case 2:
                return function(x6, S) {
                  return v6.call(m6, x6, S);
                };
              case 3:
                return function(x6, S, M) {
                  return v6.call(m6, x6, S, M);
                };
            }
            return function() {
              return v6.apply(m6, arguments);
            };
          };
        }, function(s, u) {
          s.exports = function(f6) {
            if (typeof f6 != "function")
              throw TypeError(f6 + " is not a function!");
            return f6;
          };
        }, function(s, u, f6) {
          var d6 = f6(38), v6 = f6(16), m6 = f6(28), b6 = {};
          f6(6)(b6, f6(2)("iterator"), function() {
            return this;
          }), s.exports = function(x6, S, M) {
            x6.prototype = d6(b6, { next: v6(1, M) }), m6(x6, S + " Iterator");
          };
        }, function(s, u, f6) {
          var d6 = f6(7), v6 = f6(10), m6 = f6(13);
          s.exports = f6(4) ? Object.defineProperties : function(b6, x6) {
            v6(b6);
            for (var S, M = m6(x6), A6 = M.length, I = 0; A6 > I; )
              d6.f(b6, S = M[I++], x6[S]);
            return b6;
          };
        }, function(s, u, f6) {
          var d6 = f6(9), v6 = f6(58), m6 = f6(59);
          s.exports = function(b6) {
            return function(x6, S, M) {
              var A6, I = d6(x6), R = v6(I.length), F = m6(M, R);
              if (b6 && S != S) {
                for (; R > F; )
                  if ((A6 = I[F++]) != A6)
                    return true;
              } else
                for (; R > F; F++)
                  if ((b6 || F in I) && I[F] === S)
                    return b6 || F || 0;
              return !b6 && -1;
            };
          };
        }, function(s, u, f6) {
          var d6 = f6(21), v6 = Math.min;
          s.exports = function(m6) {
            return m6 > 0 ? v6(d6(m6), 9007199254740991) : 0;
          };
        }, function(s, u, f6) {
          var d6 = f6(21), v6 = Math.max, m6 = Math.min;
          s.exports = function(b6, x6) {
            return (b6 = d6(b6)) < 0 ? v6(b6 + x6, 0) : m6(b6, x6);
          };
        }, function(s, u, f6) {
          var d6 = f6(3).document;
          s.exports = d6 && d6.documentElement;
        }, function(s, u, f6) {
          var d6 = f6(5), v6 = f6(18), m6 = f6(25)("IE_PROTO"), b6 = Object.prototype;
          s.exports = Object.getPrototypeOf || function(x6) {
            return x6 = v6(x6), d6(x6, m6) ? x6[m6] : typeof x6.constructor == "function" && x6 instanceof x6.constructor ? x6.constructor.prototype : x6 instanceof Object ? b6 : null;
          };
        }, function(s, u, f6) {
          var d6 = f6(63), v6 = f6(64), m6 = f6(12), b6 = f6(9);
          s.exports = f6(34)(Array, "Array", function(x6, S) {
            this._t = b6(x6), this._i = 0, this._k = S;
          }, function() {
            var x6 = this._t, S = this._k, M = this._i++;
            return !x6 || M >= x6.length ? (this._t = void 0, v6(1)) : v6(0, S == "keys" ? M : S == "values" ? x6[M] : [M, x6[M]]);
          }, "values"), m6.Arguments = m6.Array, d6("keys"), d6("values"), d6("entries");
        }, function(s, u) {
          s.exports = function() {
          };
        }, function(s, u) {
          s.exports = function(f6, d6) {
            return { value: d6, done: !!f6 };
          };
        }, function(s, u, f6) {
          s.exports = { default: f6(66), __esModule: true };
        }, function(s, u, f6) {
          f6(67), f6(73), f6(74), f6(75), s.exports = f6(1).Symbol;
        }, function(s, u, f6) {
          var d6 = f6(3), v6 = f6(5), m6 = f6(4), b6 = f6(15), x6 = f6(37), S = f6(68).KEY, M = f6(8), A6 = f6(26), I = f6(28), R = f6(17), F = f6(2), j = f6(30), $ = f6(31), K = f6(69), U = f6(70), he = f6(10), ue = f6(11), pe = f6(18), _e = f6(9), xe = f6(23), Ae = f6(16), ke = f6(38), je = f6(71), Fe = f6(72), at = f6(32), ht = f6(7), Qe = f6(13), en = Fe.f, bt = ht.f, wt = je.f, Ft = d6.Symbol, fn = d6.JSON, gn = fn && fn.stringify, Zr = F("_hidden"), Ma = F("toPrimitive"), Ua = {}.propertyIsEnumerable, ja = A6("symbol-registry"), Ga = A6("symbols"), pa = A6("op-symbols"), Fa = Object.prototype, Ha = typeof Ft == "function" && !!at.f, Sa = d6.QObject, oi = !Sa || !Sa.prototype || !Sa.prototype.findChild, bs = m6 && M(function() {
            return ke(bt({}, "a", { get: function() {
              return bt(this, "a", { value: 7 }).a;
            } })).a != 7;
          }) ? function(Wn, zr, La) {
            var _i = en(Fa, zr);
            _i && delete Fa[zr], bt(Wn, zr, La), _i && Wn !== Fa && bt(Fa, zr, _i);
          } : bt, Si = function(Wn) {
            var zr = Ga[Wn] = ke(Ft.prototype);
            return zr._k = Wn, zr;
          }, Ls = Ha && typeof Ft.iterator == "symbol" ? function(Wn) {
            return typeof Wn == "symbol";
          } : function(Wn) {
            return Wn instanceof Ft;
          }, tl = function(Wn, zr, La) {
            return Wn === Fa && tl(pa, zr, La), he(Wn), zr = xe(zr, true), he(La), v6(Ga, zr) ? (La.enumerable ? (v6(Wn, Zr) && Wn[Zr][zr] && (Wn[Zr][zr] = false), La = ke(La, { enumerable: Ae(0, false) })) : (v6(Wn, Zr) || bt(Wn, Zr, Ae(1, {})), Wn[Zr][zr] = true), bs(Wn, zr, La)) : bt(Wn, zr, La);
          }, Hs = function(Wn, zr) {
            he(Wn);
            for (var La, _i = K(zr = _e(zr)), Jo = 0, Wo = _i.length; Wo > Jo; )
              tl(Wn, La = _i[Jo++], zr[La]);
            return Wn;
          }, Of = function(Wn) {
            var zr = Ua.call(this, Wn = xe(Wn, true));
            return !(this === Fa && v6(Ga, Wn) && !v6(pa, Wn)) && (!(zr || !v6(this, Wn) || !v6(Ga, Wn) || v6(this, Zr) && this[Zr][Wn]) || zr);
          }, Xu = function(Wn, zr) {
            if (Wn = _e(Wn), zr = xe(zr, true), Wn !== Fa || !v6(Ga, zr) || v6(pa, zr)) {
              var La = en(Wn, zr);
              return !La || !v6(Ga, zr) || v6(Wn, Zr) && Wn[Zr][zr] || (La.enumerable = true), La;
            }
          }, kh = function(Wn) {
            for (var zr, La = wt(_e(Wn)), _i = [], Jo = 0; La.length > Jo; )
              v6(Ga, zr = La[Jo++]) || zr == Zr || zr == S || _i.push(zr);
            return _i;
          }, ou = function(Wn) {
            for (var zr, La = Wn === Fa, _i = wt(La ? pa : _e(Wn)), Jo = [], Wo = 0; _i.length > Wo; )
              !v6(Ga, zr = _i[Wo++]) || La && !v6(Fa, zr) || Jo.push(Ga[zr]);
            return Jo;
          };
          Ha || (x6((Ft = function() {
            if (this instanceof Ft)
              throw TypeError("Symbol is not a constructor!");
            var Wn = R(arguments.length > 0 ? arguments[0] : void 0), zr = function(La) {
              this === Fa && zr.call(pa, La), v6(this, Zr) && v6(this[Zr], Wn) && (this[Zr][Wn] = false), bs(this, Wn, Ae(1, La));
            };
            return m6 && oi && bs(Fa, Wn, { configurable: true, set: zr }), Si(Wn);
          }).prototype, "toString", function() {
            return this._k;
          }), Fe.f = Xu, ht.f = tl, f6(41).f = je.f = kh, f6(19).f = Of, at.f = ou, m6 && !f6(14) && x6(Fa, "propertyIsEnumerable", Of, true), j.f = function(Wn) {
            return Si(F(Wn));
          }), b6(b6.G + b6.W + b6.F * !Ha, { Symbol: Ft });
          for (var lc = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Ku = 0; lc.length > Ku; )
            F(lc[Ku++]);
          for (var _0 = Qe(F.store), Vr = 0; _0.length > Vr; )
            $(_0[Vr++]);
          b6(b6.S + b6.F * !Ha, "Symbol", { for: function(Wn) {
            return v6(ja, Wn += "") ? ja[Wn] : ja[Wn] = Ft(Wn);
          }, keyFor: function(Wn) {
            if (!Ls(Wn))
              throw TypeError(Wn + " is not a symbol!");
            for (var zr in ja)
              if (ja[zr] === Wn)
                return zr;
          }, useSetter: function() {
            oi = true;
          }, useSimple: function() {
            oi = false;
          } }), b6(b6.S + b6.F * !Ha, "Object", { create: function(Wn, zr) {
            return zr === void 0 ? ke(Wn) : Hs(ke(Wn), zr);
          }, defineProperty: tl, defineProperties: Hs, getOwnPropertyDescriptor: Xu, getOwnPropertyNames: kh, getOwnPropertySymbols: ou });
          var Un = M(function() {
            at.f(1);
          });
          b6(b6.S + b6.F * Un, "Object", { getOwnPropertySymbols: function(Wn) {
            return at.f(pe(Wn));
          } }), fn && b6(b6.S + b6.F * (!Ha || M(function() {
            var Wn = Ft();
            return gn([Wn]) != "[null]" || gn({ a: Wn }) != "{}" || gn(Object(Wn)) != "{}";
          })), "JSON", { stringify: function(Wn) {
            for (var zr, La, _i = [Wn], Jo = 1; arguments.length > Jo; )
              _i.push(arguments[Jo++]);
            if (La = zr = _i[1], (ue(zr) || Wn !== void 0) && !Ls(Wn))
              return U(zr) || (zr = function(Wo, wl) {
                if (typeof La == "function" && (wl = La.call(this, Wo, wl)), !Ls(wl))
                  return wl;
              }), _i[1] = zr, gn.apply(fn, _i);
          } }), Ft.prototype[Ma] || f6(6)(Ft.prototype, Ma, Ft.prototype.valueOf), I(Ft, "Symbol"), I(Math, "Math", true), I(d6.JSON, "JSON", true);
        }, function(s, u, f6) {
          var d6 = f6(17)("meta"), v6 = f6(11), m6 = f6(5), b6 = f6(7).f, x6 = 0, S = Object.isExtensible || function() {
            return true;
          }, M = !f6(8)(function() {
            return S(Object.preventExtensions({}));
          }), A6 = function(R) {
            b6(R, d6, { value: { i: "O" + ++x6, w: {} } });
          }, I = s.exports = { KEY: d6, NEED: false, fastKey: function(R, F) {
            if (!v6(R))
              return typeof R == "symbol" ? R : (typeof R == "string" ? "S" : "P") + R;
            if (!m6(R, d6)) {
              if (!S(R))
                return "F";
              if (!F)
                return "E";
              A6(R);
            }
            return R[d6].i;
          }, getWeak: function(R, F) {
            if (!m6(R, d6)) {
              if (!S(R))
                return true;
              if (!F)
                return false;
              A6(R);
            }
            return R[d6].w;
          }, onFreeze: function(R) {
            return M && I.NEED && S(R) && !m6(R, d6) && A6(R), R;
          } };
        }, function(s, u, f6) {
          var d6 = f6(13), v6 = f6(32), m6 = f6(19);
          s.exports = function(b6) {
            var x6 = d6(b6), S = v6.f;
            if (S)
              for (var M, A6 = S(b6), I = m6.f, R = 0; A6.length > R; )
                I.call(b6, M = A6[R++]) && x6.push(M);
            return x6;
          };
        }, function(s, u, f6) {
          var d6 = f6(24);
          s.exports = Array.isArray || function(v6) {
            return d6(v6) == "Array";
          };
        }, function(s, u, f6) {
          var d6 = f6(9), v6 = f6(41).f, m6 = {}.toString, b6 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
          s.exports.f = function(x6) {
            return b6 && m6.call(x6) == "[object Window]" ? function(S) {
              try {
                return v6(S);
              } catch {
                return b6.slice();
              }
            }(x6) : v6(d6(x6));
          };
        }, function(s, u, f6) {
          var d6 = f6(19), v6 = f6(16), m6 = f6(9), b6 = f6(23), x6 = f6(5), S = f6(35), M = Object.getOwnPropertyDescriptor;
          u.f = f6(4) ? M : function(A6, I) {
            if (A6 = m6(A6), I = b6(I, true), S)
              try {
                return M(A6, I);
              } catch {
              }
            if (x6(A6, I))
              return v6(!d6.f.call(A6, I), A6[I]);
          };
        }, function(s, u) {
        }, function(s, u, f6) {
          f6(31)("asyncIterator");
        }, function(s, u, f6) {
          f6(31)("observable");
        }, function(s, u, f6) {
          u.__esModule = true;
          var d6, v6 = f6(77), m6 = (d6 = v6) && d6.__esModule ? d6 : { default: d6 };
          u.default = m6.default || function(b6) {
            for (var x6 = 1; x6 < arguments.length; x6++) {
              var S = arguments[x6];
              for (var M in S)
                Object.prototype.hasOwnProperty.call(S, M) && (b6[M] = S[M]);
            }
            return b6;
          };
        }, function(s, u, f6) {
          s.exports = { default: f6(78), __esModule: true };
        }, function(s, u, f6) {
          f6(79), s.exports = f6(1).Object.assign;
        }, function(s, u, f6) {
          var d6 = f6(15);
          d6(d6.S + d6.F, "Object", { assign: f6(80) });
        }, function(s, u, f6) {
          var d6 = f6(4), v6 = f6(13), m6 = f6(32), b6 = f6(19), x6 = f6(18), S = f6(40), M = Object.assign;
          s.exports = !M || f6(8)(function() {
            var A6 = {}, I = {}, R = Symbol(), F = "abcdefghijklmnopqrst";
            return A6[R] = 7, F.split("").forEach(function(j) {
              I[j] = j;
            }), M({}, A6)[R] != 7 || Object.keys(M({}, I)).join("") != F;
          }) ? function(A6, I) {
            for (var R = x6(A6), F = arguments.length, j = 1, $ = m6.f, K = b6.f; F > j; )
              for (var U, he = S(arguments[j++]), ue = $ ? v6(he).concat($(he)) : v6(he), pe = ue.length, _e = 0; pe > _e; )
                U = ue[_e++], d6 && !K.call(he, U) || (R[U] = he[U]);
            return R;
          } : M;
        }, function(s, u, f6) {
          u.__esModule = true;
          var d6 = m6(f6(82)), v6 = m6(f6(85));
          function m6(b6) {
            return b6 && b6.__esModule ? b6 : { default: b6 };
          }
          u.default = function(b6, x6) {
            if (Array.isArray(b6))
              return b6;
            if ((0, d6.default)(Object(b6)))
              return function(S, M) {
                var A6 = [], I = true, R = false, F = void 0;
                try {
                  for (var j, $ = (0, v6.default)(S); !(I = (j = $.next()).done) && (A6.push(j.value), !M || A6.length !== M); I = true)
                    ;
                } catch (K) {
                  R = true, F = K;
                } finally {
                  try {
                    !I && $.return && $.return();
                  } finally {
                    if (R)
                      throw F;
                  }
                }
                return A6;
              }(b6, x6);
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          };
        }, function(s, u, f6) {
          s.exports = { default: f6(83), __esModule: true };
        }, function(s, u, f6) {
          f6(29), f6(20), s.exports = f6(84);
        }, function(s, u, f6) {
          var d6 = f6(42), v6 = f6(2)("iterator"), m6 = f6(12);
          s.exports = f6(1).isIterable = function(b6) {
            var x6 = Object(b6);
            return x6[v6] !== void 0 || "@@iterator" in x6 || m6.hasOwnProperty(d6(x6));
          };
        }, function(s, u, f6) {
          s.exports = { default: f6(86), __esModule: true };
        }, function(s, u, f6) {
          f6(29), f6(20), s.exports = f6(87);
        }, function(s, u, f6) {
          var d6 = f6(10), v6 = f6(88);
          s.exports = f6(1).getIterator = function(m6) {
            var b6 = v6(m6);
            if (typeof b6 != "function")
              throw TypeError(m6 + " is not iterable!");
            return d6(b6.call(m6));
          };
        }, function(s, u, f6) {
          var d6 = f6(42), v6 = f6(2)("iterator"), m6 = f6(12);
          s.exports = f6(1).getIteratorMethod = function(b6) {
            if (b6 != null)
              return b6[v6] || b6["@@iterator"] || m6[d6(b6)];
          };
        }, function(s, u, f6) {
          s.exports = { default: f6(90), __esModule: true };
        }, function(s, u, f6) {
          f6(91), s.exports = f6(1).Object.keys;
        }, function(s, u, f6) {
          var d6 = f6(18), v6 = f6(13);
          f6(92)("keys", function() {
            return function(m6) {
              return v6(d6(m6));
            };
          });
        }, function(s, u, f6) {
          var d6 = f6(15), v6 = f6(1), m6 = f6(8);
          s.exports = function(b6, x6) {
            var S = (v6.Object || {})[b6] || Object[b6], M = {};
            M[b6] = x6(S), d6(d6.S + d6.F * m6(function() {
              S(1);
            }), "Object", M);
          };
        }, function(s, u, f6) {
          (function(d6) {
            var v6 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], m6 = /^\s+|\s+$/g, b6 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, x6 = /\{\n\/\* \[wrapped with (.+)\] \*/, S = /,? & /, M = /^[-+]0x[0-9a-f]+$/i, A6 = /^0b[01]+$/i, I = /^\[object .+?Constructor\]$/, R = /^0o[0-7]+$/i, F = /^(?:0|[1-9]\d*)$/, j = parseInt, $ = typeof d6 == "object" && d6 && d6.Object === Object && d6, K = typeof self == "object" && self && self.Object === Object && self, U = $ || K || Function("return this")();
            function he(Vr, Un, Wn) {
              switch (Wn.length) {
                case 0:
                  return Vr.call(Un);
                case 1:
                  return Vr.call(Un, Wn[0]);
                case 2:
                  return Vr.call(Un, Wn[0], Wn[1]);
                case 3:
                  return Vr.call(Un, Wn[0], Wn[1], Wn[2]);
              }
              return Vr.apply(Un, Wn);
            }
            function ue(Vr, Un) {
              return !!(Vr && Vr.length) && function(Wn, zr, La) {
                if (zr != zr)
                  return function(Wo, wl, Ju, wu) {
                    for (var Kc = Wo.length, Su = Ju + (wu ? 1 : -1); wu ? Su-- : ++Su < Kc; )
                      if (wl(Wo[Su], Su, Wo))
                        return Su;
                    return -1;
                  }(Wn, pe, La);
                for (var _i = La - 1, Jo = Wn.length; ++_i < Jo; )
                  if (Wn[_i] === zr)
                    return _i;
                return -1;
              }(Vr, Un, 0) > -1;
            }
            function pe(Vr) {
              return Vr != Vr;
            }
            function _e(Vr, Un) {
              for (var Wn = Vr.length, zr = 0; Wn--; )
                Vr[Wn] === Un && zr++;
              return zr;
            }
            function xe(Vr, Un) {
              for (var Wn = -1, zr = Vr.length, La = 0, _i = []; ++Wn < zr; ) {
                var Jo = Vr[Wn];
                Jo !== Un && Jo !== "__lodash_placeholder__" || (Vr[Wn] = "__lodash_placeholder__", _i[La++] = Wn);
              }
              return _i;
            }
            var Ae, ke, je, Fe = Function.prototype, at = Object.prototype, ht = U["__core-js_shared__"], Qe = (Ae = /[^.]+$/.exec(ht && ht.keys && ht.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Ae : "", en = Fe.toString, bt = at.hasOwnProperty, wt = at.toString, Ft = RegExp("^" + en.call(bt).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), fn = Object.create, gn = Math.max, Zr = Math.min, Ma = (ke = Si(Object, "defineProperty"), (je = Si.name) && je.length > 2 ? ke : void 0);
            function Ua(Vr) {
              return lc(Vr) ? fn(Vr) : {};
            }
            function ja(Vr) {
              return !(!lc(Vr) || function(Un) {
                return !!Qe && Qe in Un;
              }(Vr)) && (function(Un) {
                var Wn = lc(Un) ? wt.call(Un) : "";
                return Wn == "[object Function]" || Wn == "[object GeneratorFunction]";
              }(Vr) || function(Un) {
                var Wn = false;
                if (Un != null && typeof Un.toString != "function")
                  try {
                    Wn = !!(Un + "");
                  } catch {
                  }
                return Wn;
              }(Vr) ? Ft : I).test(function(Un) {
                if (Un != null) {
                  try {
                    return en.call(Un);
                  } catch {
                  }
                  try {
                    return Un + "";
                  } catch {
                  }
                }
                return "";
              }(Vr));
            }
            function Ga(Vr, Un, Wn, zr) {
              for (var La = -1, _i = Vr.length, Jo = Wn.length, Wo = -1, wl = Un.length, Ju = gn(_i - Jo, 0), wu = Array(wl + Ju), Kc = !zr; ++Wo < wl; )
                wu[Wo] = Un[Wo];
              for (; ++La < Jo; )
                (Kc || La < _i) && (wu[Wn[La]] = Vr[La]);
              for (; Ju--; )
                wu[Wo++] = Vr[La++];
              return wu;
            }
            function pa(Vr, Un, Wn, zr) {
              for (var La = -1, _i = Vr.length, Jo = -1, Wo = Wn.length, wl = -1, Ju = Un.length, wu = gn(_i - Wo, 0), Kc = Array(wu + Ju), Su = !zr; ++La < wu; )
                Kc[La] = Vr[La];
              for (var pd = La; ++wl < Ju; )
                Kc[pd + wl] = Un[wl];
              for (; ++Jo < Wo; )
                (Su || La < _i) && (Kc[pd + Wn[Jo]] = Vr[La++]);
              return Kc;
            }
            function Fa(Vr) {
              return function() {
                var Un = arguments;
                switch (Un.length) {
                  case 0:
                    return new Vr();
                  case 1:
                    return new Vr(Un[0]);
                  case 2:
                    return new Vr(Un[0], Un[1]);
                  case 3:
                    return new Vr(Un[0], Un[1], Un[2]);
                  case 4:
                    return new Vr(Un[0], Un[1], Un[2], Un[3]);
                  case 5:
                    return new Vr(Un[0], Un[1], Un[2], Un[3], Un[4]);
                  case 6:
                    return new Vr(Un[0], Un[1], Un[2], Un[3], Un[4], Un[5]);
                  case 7:
                    return new Vr(Un[0], Un[1], Un[2], Un[3], Un[4], Un[5], Un[6]);
                }
                var Wn = Ua(Vr.prototype), zr = Vr.apply(Wn, Un);
                return lc(zr) ? zr : Wn;
              };
            }
            function Ha(Vr, Un, Wn, zr, La, _i, Jo, Wo, wl, Ju) {
              var wu = 128 & Un, Kc = 1 & Un, Su = 2 & Un, pd = 24 & Un, ip = 512 & Un, kv = Su ? void 0 : Fa(Vr);
              return function op() {
                for (var Ac = arguments.length, $s = Array(Ac), Rf = Ac; Rf--; )
                  $s[Rf] = arguments[Rf];
                if (pd)
                  var Ph = bs(op), pg = _e($s, Ph);
                if (zr && ($s = Ga($s, zr, La, pd)), _i && ($s = pa($s, _i, Jo, pd)), Ac -= pg, pd && Ac < Ju) {
                  var Up = xe($s, Ph);
                  return Sa(Vr, Un, Ha, op.placeholder, Wn, $s, Up, Wo, wl, Ju - Ac);
                }
                var sp = Kc ? Wn : this, Pv = Su ? sp[Vr] : Vr;
                return Ac = $s.length, Wo ? $s = Of($s, Wo) : ip && Ac > 1 && $s.reverse(), wu && wl < Ac && ($s.length = wl), this && this !== U && this instanceof op && (Pv = kv || Fa(Pv)), Pv.apply(sp, $s);
              };
            }
            function Sa(Vr, Un, Wn, zr, La, _i, Jo, Wo, wl, Ju) {
              var wu = 8 & Un;
              Un |= wu ? 32 : 64, 4 & (Un &= ~(wu ? 64 : 32)) || (Un &= -4);
              var Kc = Wn(Vr, Un, La, wu ? _i : void 0, wu ? Jo : void 0, wu ? void 0 : _i, wu ? void 0 : Jo, Wo, wl, Ju);
              return Kc.placeholder = zr, Xu(Kc, Vr, Un);
            }
            function oi(Vr, Un, Wn, zr, La, _i, Jo, Wo) {
              var wl = 2 & Un;
              if (!wl && typeof Vr != "function")
                throw new TypeError("Expected a function");
              var Ju = zr ? zr.length : 0;
              if (Ju || (Un &= -97, zr = La = void 0), Jo = Jo === void 0 ? Jo : gn(_0(Jo), 0), Wo = Wo === void 0 ? Wo : _0(Wo), Ju -= La ? La.length : 0, 64 & Un) {
                var wu = zr, Kc = La;
                zr = La = void 0;
              }
              var Su = [Vr, Un, Wn, zr, La, wu, Kc, _i, Jo, Wo];
              if (Vr = Su[0], Un = Su[1], Wn = Su[2], zr = Su[3], La = Su[4], !(Wo = Su[9] = Su[9] == null ? wl ? 0 : Vr.length : gn(Su[9] - Ju, 0)) && 24 & Un && (Un &= -25), Un && Un != 1)
                pd = Un == 8 || Un == 16 ? function(ip, kv, op) {
                  var Ac = Fa(ip);
                  return function $s() {
                    for (var Rf = arguments.length, Ph = Array(Rf), pg = Rf, Up = bs($s); pg--; )
                      Ph[pg] = arguments[pg];
                    var sp = Rf < 3 && Ph[0] !== Up && Ph[Rf - 1] !== Up ? [] : xe(Ph, Up);
                    if ((Rf -= sp.length) < op)
                      return Sa(ip, kv, Ha, $s.placeholder, void 0, Ph, sp, void 0, void 0, op - Rf);
                    var Pv = this && this !== U && this instanceof $s ? Ac : ip;
                    return he(Pv, this, Ph);
                  };
                }(Vr, Un, Wo) : Un != 32 && Un != 33 || La.length ? Ha.apply(void 0, Su) : function(ip, kv, op, Ac) {
                  var $s = 1 & kv, Rf = Fa(ip);
                  return function Ph() {
                    for (var pg = -1, Up = arguments.length, sp = -1, Pv = Ac.length, $m = Array(Pv + Up), Um = this && this !== U && this instanceof Ph ? Rf : ip; ++sp < Pv; )
                      $m[sp] = Ac[sp];
                    for (; Up--; )
                      $m[sp++] = arguments[++pg];
                    return he(Um, $s ? op : this, $m);
                  };
                }(Vr, Un, Wn, zr);
              else
                var pd = function(ip, kv, op) {
                  var Ac = 1 & kv, $s = Fa(ip);
                  return function Rf() {
                    var Ph = this && this !== U && this instanceof Rf ? $s : ip;
                    return Ph.apply(Ac ? op : this, arguments);
                  };
                }(Vr, Un, Wn);
              return Xu(pd, Vr, Un);
            }
            function bs(Vr) {
              return Vr.placeholder;
            }
            function Si(Vr, Un) {
              var Wn = function(zr, La) {
                return zr == null ? void 0 : zr[La];
              }(Vr, Un);
              return ja(Wn) ? Wn : void 0;
            }
            function Ls(Vr) {
              var Un = Vr.match(x6);
              return Un ? Un[1].split(S) : [];
            }
            function tl(Vr, Un) {
              var Wn = Un.length, zr = Wn - 1;
              return Un[zr] = (Wn > 1 ? "& " : "") + Un[zr], Un = Un.join(Wn > 2 ? ", " : " "), Vr.replace(b6, `{
/* [wrapped with ` + Un + `] */
`);
            }
            function Hs(Vr, Un) {
              return !!(Un = Un == null ? 9007199254740991 : Un) && (typeof Vr == "number" || F.test(Vr)) && Vr > -1 && Vr % 1 == 0 && Vr < Un;
            }
            function Of(Vr, Un) {
              for (var Wn = Vr.length, zr = Zr(Un.length, Wn), La = function(Jo, Wo) {
                var wl = -1, Ju = Jo.length;
                for (Wo || (Wo = Array(Ju)); ++wl < Ju; )
                  Wo[wl] = Jo[wl];
                return Wo;
              }(Vr); zr--; ) {
                var _i = Un[zr];
                Vr[zr] = Hs(_i, Wn) ? La[_i] : void 0;
              }
              return Vr;
            }
            var Xu = Ma ? function(Vr, Un, Wn) {
              var zr, La = Un + "";
              return Ma(Vr, "toString", { configurable: true, enumerable: false, value: (zr = tl(La, kh(Ls(La), Wn)), function() {
                return zr;
              }) });
            } : function(Vr) {
              return Vr;
            };
            function kh(Vr, Un) {
              return function(Wn, zr) {
                for (var La = -1, _i = Wn ? Wn.length : 0; ++La < _i && zr(Wn[La], La, Wn) !== false; )
                  ;
              }(v6, function(Wn) {
                var zr = "_." + Wn[0];
                Un & Wn[1] && !ue(Vr, zr) && Vr.push(zr);
              }), Vr.sort();
            }
            function ou(Vr, Un, Wn) {
              var zr = oi(Vr, 8, void 0, void 0, void 0, void 0, void 0, Un = Wn ? void 0 : Un);
              return zr.placeholder = ou.placeholder, zr;
            }
            function lc(Vr) {
              var Un = typeof Vr;
              return !!Vr && (Un == "object" || Un == "function");
            }
            function Ku(Vr) {
              return Vr ? (Vr = function(Un) {
                if (typeof Un == "number")
                  return Un;
                if (function(La) {
                  return typeof La == "symbol" || function(_i) {
                    return !!_i && typeof _i == "object";
                  }(La) && wt.call(La) == "[object Symbol]";
                }(Un))
                  return NaN;
                if (lc(Un)) {
                  var Wn = typeof Un.valueOf == "function" ? Un.valueOf() : Un;
                  Un = lc(Wn) ? Wn + "" : Wn;
                }
                if (typeof Un != "string")
                  return Un === 0 ? Un : +Un;
                Un = Un.replace(m6, "");
                var zr = A6.test(Un);
                return zr || R.test(Un) ? j(Un.slice(2), zr ? 2 : 8) : M.test(Un) ? NaN : +Un;
              }(Vr)) === 1 / 0 || Vr === -1 / 0 ? 17976931348623157e292 * (Vr < 0 ? -1 : 1) : Vr == Vr ? Vr : 0 : Vr === 0 ? Vr : 0;
            }
            function _0(Vr) {
              var Un = Ku(Vr), Wn = Un % 1;
              return Un == Un ? Wn ? Un - Wn : Un : 0;
            }
            ou.placeholder = {}, s.exports = ou;
          }).call(this, f6(43));
        }, function(s, u, f6) {
          function d6(pa) {
            return pa && pa.__esModule ? pa.default : pa;
          }
          u.__esModule = true;
          var v6 = f6(95);
          u.threezerotwofour = d6(v6);
          var m6 = f6(96);
          u.apathy = d6(m6);
          var b6 = f6(97);
          u.ashes = d6(b6);
          var x6 = f6(98);
          u.atelierDune = d6(x6);
          var S = f6(99);
          u.atelierForest = d6(S);
          var M = f6(100);
          u.atelierHeath = d6(M);
          var A6 = f6(101);
          u.atelierLakeside = d6(A6);
          var I = f6(102);
          u.atelierSeaside = d6(I);
          var R = f6(103);
          u.bespin = d6(R);
          var F = f6(104);
          u.brewer = d6(F);
          var j = f6(105);
          u.bright = d6(j);
          var $ = f6(106);
          u.chalk = d6($);
          var K = f6(107);
          u.codeschool = d6(K);
          var U = f6(108);
          u.colors = d6(U);
          var he = f6(109);
          u.default = d6(he);
          var ue = f6(110);
          u.eighties = d6(ue);
          var pe = f6(111);
          u.embers = d6(pe);
          var _e = f6(112);
          u.flat = d6(_e);
          var xe = f6(113);
          u.google = d6(xe);
          var Ae = f6(114);
          u.grayscale = d6(Ae);
          var ke = f6(115);
          u.greenscreen = d6(ke);
          var je = f6(116);
          u.harmonic = d6(je);
          var Fe = f6(117);
          u.hopscotch = d6(Fe);
          var at = f6(118);
          u.isotope = d6(at);
          var ht = f6(119);
          u.marrakesh = d6(ht);
          var Qe = f6(120);
          u.mocha = d6(Qe);
          var en = f6(121);
          u.monokai = d6(en);
          var bt = f6(122);
          u.ocean = d6(bt);
          var wt = f6(123);
          u.paraiso = d6(wt);
          var Ft = f6(124);
          u.pop = d6(Ft);
          var fn = f6(125);
          u.railscasts = d6(fn);
          var gn = f6(126);
          u.shapeshifter = d6(gn);
          var Zr = f6(127);
          u.solarized = d6(Zr);
          var Ma = f6(128);
          u.summerfruit = d6(Ma);
          var Ua = f6(129);
          u.tomorrow = d6(Ua);
          var ja = f6(130);
          u.tube = d6(ja);
          var Ga = f6(131);
          u.twilight = d6(Ga);
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, s.exports = u.default;
        }, function(s, u, f6) {
          u.__esModule = true, u.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, s.exports = u.default;
        }, function(s, u, f6) {
          var d6 = f6(33);
          function v6(m6) {
            var b6 = Math.round(d6(m6, 0, 255)).toString(16);
            return b6.length == 1 ? "0" + b6 : b6;
          }
          s.exports = function(m6) {
            var b6 = m6.length === 4 ? v6(255 * m6[3]) : "";
            return "#" + v6(m6[0]) + v6(m6[1]) + v6(m6[2]) + b6;
          };
        }, function(s, u, f6) {
          var d6 = f6(134), v6 = f6(135), m6 = f6(136), b6 = f6(137), x6 = { "#": v6, hsl: function(M) {
            var A6 = d6(M), I = b6(A6);
            return A6.length === 4 && I.push(A6[3]), I;
          }, rgb: m6 };
          function S(M) {
            for (var A6 in x6)
              if (M.indexOf(A6) === 0)
                return x6[A6](M);
          }
          S.rgb = m6, S.hsl = d6, S.hex = v6, s.exports = S;
        }, function(s, u, f6) {
          var d6 = f6(44), v6 = f6(33);
          function m6(b6, x6) {
            switch (b6 = parseFloat(b6), x6) {
              case 0:
                return v6(b6, 0, 360);
              case 1:
              case 2:
                return v6(b6, 0, 100);
              case 3:
                return v6(b6, 0, 1);
            }
          }
          s.exports = function(b6) {
            return d6(b6).map(m6);
          };
        }, function(s, u) {
          s.exports = function(f6) {
            f6.length !== 4 && f6.length !== 5 || (f6 = function(m6) {
              for (var b6 = "#", x6 = 1; x6 < m6.length; x6++) {
                var S = m6.charAt(x6);
                b6 += S + S;
              }
              return b6;
            }(f6));
            var d6 = [parseInt(f6.substring(1, 3), 16), parseInt(f6.substring(3, 5), 16), parseInt(f6.substring(5, 7), 16)];
            if (f6.length === 9) {
              var v6 = parseFloat((parseInt(f6.substring(7, 9), 16) / 255).toFixed(2));
              d6.push(v6);
            }
            return d6;
          };
        }, function(s, u, f6) {
          var d6 = f6(44), v6 = f6(33);
          function m6(b6, x6) {
            return x6 < 3 ? b6.indexOf("%") != -1 ? Math.round(255 * v6(parseInt(b6, 10), 0, 100) / 100) : v6(parseInt(b6, 10), 0, 255) : v6(parseFloat(b6), 0, 1);
          }
          s.exports = function(b6) {
            return d6(b6).map(m6);
          };
        }, function(s, u) {
          s.exports = function(f6) {
            var d6, v6, m6, b6, x6, S = f6[0] / 360, M = f6[1] / 100, A6 = f6[2] / 100;
            if (M == 0)
              return [x6 = 255 * A6, x6, x6];
            d6 = 2 * A6 - (v6 = A6 < 0.5 ? A6 * (1 + M) : A6 + M - A6 * M), b6 = [0, 0, 0];
            for (var I = 0; I < 3; I++)
              (m6 = S + 1 / 3 * -(I - 1)) < 0 && m6++, m6 > 1 && m6--, x6 = 6 * m6 < 1 ? d6 + 6 * (v6 - d6) * m6 : 2 * m6 < 1 ? v6 : 3 * m6 < 2 ? d6 + (v6 - d6) * (2 / 3 - m6) * 6 : d6, b6[I] = 255 * x6;
            return b6;
          };
        }, function(s, u, f6) {
          (function(d6) {
            var v6 = typeof d6 == "object" && d6 && d6.Object === Object && d6, m6 = typeof self == "object" && self && self.Object === Object && self, b6 = v6 || m6 || Function("return this")();
            function x6(xe, Ae, ke) {
              switch (ke.length) {
                case 0:
                  return xe.call(Ae);
                case 1:
                  return xe.call(Ae, ke[0]);
                case 2:
                  return xe.call(Ae, ke[0], ke[1]);
                case 3:
                  return xe.call(Ae, ke[0], ke[1], ke[2]);
              }
              return xe.apply(Ae, ke);
            }
            function S(xe, Ae) {
              for (var ke = -1, je = Ae.length, Fe = xe.length; ++ke < je; )
                xe[Fe + ke] = Ae[ke];
              return xe;
            }
            var M = Object.prototype, A6 = M.hasOwnProperty, I = M.toString, R = b6.Symbol, F = M.propertyIsEnumerable, j = R ? R.isConcatSpreadable : void 0, $ = Math.max;
            function K(xe) {
              return U(xe) || function(Ae) {
                return function(ke) {
                  return function(je) {
                    return !!je && typeof je == "object";
                  }(ke) && function(je) {
                    return je != null && function(Fe) {
                      return typeof Fe == "number" && Fe > -1 && Fe % 1 == 0 && Fe <= 9007199254740991;
                    }(je.length) && !function(Fe) {
                      var at = function(ht) {
                        var Qe = typeof ht;
                        return !!ht && (Qe == "object" || Qe == "function");
                      }(Fe) ? I.call(Fe) : "";
                      return at == "[object Function]" || at == "[object GeneratorFunction]";
                    }(je);
                  }(ke);
                }(Ae) && A6.call(Ae, "callee") && (!F.call(Ae, "callee") || I.call(Ae) == "[object Arguments]");
              }(xe) || !!(j && xe && xe[j]);
            }
            var U = Array.isArray, he, ue, pe, _e = (ue = function(xe) {
              var Ae = (xe = function je(Fe, at, ht, Qe, en) {
                var bt = -1, wt = Fe.length;
                for (ht || (ht = K), en || (en = []); ++bt < wt; ) {
                  var Ft = Fe[bt];
                  at > 0 && ht(Ft) ? at > 1 ? je(Ft, at - 1, ht, Qe, en) : S(en, Ft) : Qe || (en[en.length] = Ft);
                }
                return en;
              }(xe, 1)).length, ke = Ae;
              for (he; ke--; )
                if (typeof xe[ke] != "function")
                  throw new TypeError("Expected a function");
              return function() {
                for (var je = 0, Fe = Ae ? xe[je].apply(this, arguments) : arguments[0]; ++je < Ae; )
                  Fe = xe[je].call(this, Fe);
                return Fe;
              };
            }, pe = $(pe === void 0 ? ue.length - 1 : pe, 0), function() {
              for (var xe = arguments, Ae = -1, ke = $(xe.length - pe, 0), je = Array(ke); ++Ae < ke; )
                je[Ae] = xe[pe + Ae];
              Ae = -1;
              for (var Fe = Array(pe + 1); ++Ae < pe; )
                Fe[Ae] = xe[Ae];
              return Fe[pe] = je, x6(ue, this, Fe);
            });
            s.exports = _e;
          }).call(this, f6(43));
        }, function(s, u, f6) {
          Object.defineProperty(u, "__esModule", { value: true }), u.yuv2rgb = function(d6) {
            var v6, m6, b6, x6 = d6[0], S = d6[1], M = d6[2];
            return v6 = 1 * x6 + 0 * S + 1.13983 * M, m6 = 1 * x6 + -0.39465 * S + -0.5806 * M, b6 = 1 * x6 + 2.02311 * S + 0 * M, v6 = Math.min(Math.max(0, v6), 1), m6 = Math.min(Math.max(0, m6), 1), b6 = Math.min(Math.max(0, b6), 1), [255 * v6, 255 * m6, 255 * b6];
          }, u.rgb2yuv = function(d6) {
            var v6 = d6[0] / 255, m6 = d6[1] / 255, b6 = d6[2] / 255;
            return [0.299 * v6 + 0.587 * m6 + 0.114 * b6, -0.14713 * v6 + -0.28886 * m6 + 0.436 * b6, 0.615 * v6 + -0.51499 * m6 + -0.10001 * b6];
          };
        }, function(s, u, f6) {
          function d6(b6, x6, S) {
            return x6 in b6 ? Object.defineProperty(b6, x6, { value: S, enumerable: true, configurable: true, writable: true }) : b6[x6] = S, b6;
          }
          var v6 = f6(141), m6 = function() {
            function b6() {
              d6(this, "_callbacks", void 0), d6(this, "_isDispatching", void 0), d6(this, "_isHandled", void 0), d6(this, "_isPending", void 0), d6(this, "_lastID", void 0), d6(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
            }
            var x6 = b6.prototype;
            return x6.register = function(S) {
              var M = "ID_" + this._lastID++;
              return this._callbacks[M] = S, M;
            }, x6.unregister = function(S) {
              this._callbacks[S] || v6(false), delete this._callbacks[S];
            }, x6.waitFor = function(S) {
              this._isDispatching || v6(false);
              for (var M = 0; M < S.length; M++) {
                var A6 = S[M];
                this._isPending[A6] ? this._isHandled[A6] || v6(false) : (this._callbacks[A6] || v6(false), this._invokeCallback(A6));
              }
            }, x6.dispatch = function(S) {
              this._isDispatching && v6(false), this._startDispatching(S);
              try {
                for (var M in this._callbacks)
                  this._isPending[M] || this._invokeCallback(M);
              } finally {
                this._stopDispatching();
              }
            }, x6.isDispatching = function() {
              return this._isDispatching;
            }, x6._invokeCallback = function(S) {
              this._isPending[S] = true, this._callbacks[S](this._pendingPayload), this._isHandled[S] = true;
            }, x6._startDispatching = function(S) {
              for (var M in this._callbacks)
                this._isPending[M] = false, this._isHandled[M] = false;
              this._pendingPayload = S, this._isDispatching = true;
            }, x6._stopDispatching = function() {
              delete this._pendingPayload, this._isDispatching = false;
            }, b6;
          }();
          s.exports = m6;
        }, function(s, u, f6) {
          s.exports = function(d6, v6) {
            for (var m6 = arguments.length, b6 = new Array(m6 > 2 ? m6 - 2 : 0), x6 = 2; x6 < m6; x6++)
              b6[x6 - 2] = arguments[x6];
            if (!d6) {
              var S;
              if (v6 === void 0)
                S = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
              else {
                var M = 0;
                (S = new Error(v6.replace(/%s/g, function() {
                  return String(b6[M++]);
                }))).name = "Invariant Violation";
              }
              throw S.framesToPop = 1, S;
            }
          };
        }, function(s, u, f6) {
          function d6(Ot, Nt, ct) {
            return Nt in Ot ? Object.defineProperty(Ot, Nt, { value: ct, enumerable: true, configurable: true, writable: true }) : Ot[Nt] = ct, Ot;
          }
          function v6(Ot, Nt) {
            var ct = Object.keys(Ot);
            if (Object.getOwnPropertySymbols) {
              var Mt = Object.getOwnPropertySymbols(Ot);
              Nt && (Mt = Mt.filter(function(_t) {
                return Object.getOwnPropertyDescriptor(Ot, _t).enumerable;
              })), ct.push.apply(ct, Mt);
            }
            return ct;
          }
          function m6(Ot) {
            for (var Nt = 1; Nt < arguments.length; Nt++) {
              var ct = arguments[Nt] != null ? arguments[Nt] : {};
              Nt % 2 ? v6(Object(ct), true).forEach(function(Mt) {
                d6(Ot, Mt, ct[Mt]);
              }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Ot, Object.getOwnPropertyDescriptors(ct)) : v6(Object(ct)).forEach(function(Mt) {
                Object.defineProperty(Ot, Mt, Object.getOwnPropertyDescriptor(ct, Mt));
              });
            }
            return Ot;
          }
          function b6(Ot, Nt) {
            if (!(Ot instanceof Nt))
              throw new TypeError("Cannot call a class as a function");
          }
          function x6(Ot, Nt) {
            for (var ct = 0; ct < Nt.length; ct++) {
              var Mt = Nt[ct];
              Mt.enumerable = Mt.enumerable || false, Mt.configurable = true, "value" in Mt && (Mt.writable = true), Object.defineProperty(Ot, Mt.key, Mt);
            }
          }
          function S(Ot, Nt, ct) {
            return Nt && x6(Ot.prototype, Nt), ct && x6(Ot, ct), Ot;
          }
          function M(Ot, Nt) {
            return (M = Object.setPrototypeOf || function(ct, Mt) {
              return ct.__proto__ = Mt, ct;
            })(Ot, Nt);
          }
          function A6(Ot, Nt) {
            if (typeof Nt != "function" && Nt !== null)
              throw new TypeError("Super expression must either be null or a function");
            Ot.prototype = Object.create(Nt && Nt.prototype, { constructor: { value: Ot, writable: true, configurable: true } }), Nt && M(Ot, Nt);
          }
          function I(Ot) {
            return (I = Object.setPrototypeOf ? Object.getPrototypeOf : function(Nt) {
              return Nt.__proto__ || Object.getPrototypeOf(Nt);
            })(Ot);
          }
          function R(Ot) {
            return (R = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Nt) {
              return typeof Nt;
            } : function(Nt) {
              return Nt && typeof Symbol == "function" && Nt.constructor === Symbol && Nt !== Symbol.prototype ? "symbol" : typeof Nt;
            })(Ot);
          }
          function F(Ot) {
            if (Ot === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return Ot;
          }
          function j(Ot, Nt) {
            return !Nt || R(Nt) !== "object" && typeof Nt != "function" ? F(Ot) : Nt;
          }
          function $(Ot) {
            var Nt = function() {
              if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                return false;
              if (typeof Proxy == "function")
                return true;
              try {
                return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                })), true;
              } catch {
                return false;
              }
            }();
            return function() {
              var ct, Mt = I(Ot);
              if (Nt) {
                var _t = I(this).constructor;
                ct = Reflect.construct(Mt, arguments, _t);
              } else
                ct = Mt.apply(this, arguments);
              return j(this, ct);
            };
          }
          f6.r(u);
          var K = f6(0), U = f6.n(K);
          function he() {
            var Ot = this.constructor.getDerivedStateFromProps(this.props, this.state);
            Ot != null && this.setState(Ot);
          }
          function ue(Ot) {
            this.setState(function(Nt) {
              var ct = this.constructor.getDerivedStateFromProps(Ot, Nt);
              return ct != null ? ct : null;
            }.bind(this));
          }
          function pe(Ot, Nt) {
            try {
              var ct = this.props, Mt = this.state;
              this.props = Ot, this.state = Nt, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(ct, Mt);
            } finally {
              this.props = ct, this.state = Mt;
            }
          }
          function _e(Ot) {
            var Nt = Ot.prototype;
            if (!Nt || !Nt.isReactComponent)
              throw new Error("Can only polyfill class components");
            if (typeof Ot.getDerivedStateFromProps != "function" && typeof Nt.getSnapshotBeforeUpdate != "function")
              return Ot;
            var ct = null, Mt = null, _t = null;
            if (typeof Nt.componentWillMount == "function" ? ct = "componentWillMount" : typeof Nt.UNSAFE_componentWillMount == "function" && (ct = "UNSAFE_componentWillMount"), typeof Nt.componentWillReceiveProps == "function" ? Mt = "componentWillReceiveProps" : typeof Nt.UNSAFE_componentWillReceiveProps == "function" && (Mt = "UNSAFE_componentWillReceiveProps"), typeof Nt.componentWillUpdate == "function" ? _t = "componentWillUpdate" : typeof Nt.UNSAFE_componentWillUpdate == "function" && (_t = "UNSAFE_componentWillUpdate"), ct !== null || Mt !== null || _t !== null) {
              var Rn = Ot.displayName || Ot.name, Pn = typeof Ot.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Rn + " uses " + Pn + " but also contains the following legacy lifecycles:" + (ct !== null ? `
  ` + ct : "") + (Mt !== null ? `
  ` + Mt : "") + (_t !== null ? `
  ` + _t : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
            }
            if (typeof Ot.getDerivedStateFromProps == "function" && (Nt.componentWillMount = he, Nt.componentWillReceiveProps = ue), typeof Nt.getSnapshotBeforeUpdate == "function") {
              if (typeof Nt.componentDidUpdate != "function")
                throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
              Nt.componentWillUpdate = pe;
              var lr = Nt.componentDidUpdate;
              Nt.componentDidUpdate = function(Mn, ta, di) {
                var as = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : di;
                lr.call(this, Mn, ta, as);
              };
            }
            return Ot;
          }
          function xe(Ot, Nt) {
            if (Ot == null)
              return {};
            var ct, Mt, _t = function(Pn, lr) {
              if (Pn == null)
                return {};
              var Mn, ta, di = {}, as = Object.keys(Pn);
              for (ta = 0; ta < as.length; ta++)
                Mn = as[ta], lr.indexOf(Mn) >= 0 || (di[Mn] = Pn[Mn]);
              return di;
            }(Ot, Nt);
            if (Object.getOwnPropertySymbols) {
              var Rn = Object.getOwnPropertySymbols(Ot);
              for (Mt = 0; Mt < Rn.length; Mt++)
                ct = Rn[Mt], Nt.indexOf(ct) >= 0 || Object.prototype.propertyIsEnumerable.call(Ot, ct) && (_t[ct] = Ot[ct]);
            }
            return _t;
          }
          function Ae(Ot) {
            var Nt = function(ct) {
              return {}.toString.call(ct).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
            }(Ot);
            return Nt === "number" && (Nt = isNaN(Ot) ? "nan" : (0 | Ot) != Ot ? "float" : "integer"), Nt;
          }
          he.__suppressDeprecationWarning = true, ue.__suppressDeprecationWarning = true, pe.__suppressDeprecationWarning = true;
          var ke = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, je = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Fe = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, at = f6(45), ht = function(Ot) {
            var Nt = function(ct) {
              return { backgroundColor: ct.base00, ellipsisColor: ct.base09, braceColor: ct.base07, expandedIcon: ct.base0D, collapsedIcon: ct.base0E, keyColor: ct.base07, arrayKeyColor: ct.base0C, objectSize: ct.base04, copyToClipboard: ct.base0F, copyToClipboardCheck: ct.base0D, objectBorder: ct.base02, dataTypes: { boolean: ct.base0E, date: ct.base0D, float: ct.base0B, function: ct.base0D, integer: ct.base0F, string: ct.base09, nan: ct.base08, null: ct.base0A, undefined: ct.base05, regexp: ct.base0A, background: ct.base02 }, editVariable: { editIcon: ct.base0E, cancelIcon: ct.base09, removeIcon: ct.base09, addIcon: ct.base0E, checkIcon: ct.base0E, background: ct.base01, color: ct.base0A, border: ct.base07 }, addKeyModal: { background: ct.base05, border: ct.base04, color: ct.base0A, labelColor: ct.base01 }, validationFailure: { background: ct.base09, iconColor: ct.base01, fontColor: ct.base01 } };
            }(Ot);
            return { "app-container": { fontFamily: Fe.globalFontFamily, cursor: Fe.globalCursor, backgroundColor: Nt.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Nt.ellipsisColor, fontSize: Fe.ellipsisFontSize, lineHeight: Fe.ellipsisLineHeight, cursor: Fe.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Fe.braceCursor, fontWeight: Fe.braceFontWeight, color: Nt.braceColor }, "expanded-icon": { color: Nt.expandedIcon }, "collapsed-icon": { color: Nt.collapsedIcon }, colon: { display: "inline-block", margin: Fe.keyMargin, color: Nt.keyColor, verticalAlign: "top" }, objectKeyVal: function(ct, Mt) {
              return { style: m6({ paddingTop: Fe.keyValPaddingTop, paddingRight: Fe.keyValPaddingRight, paddingBottom: Fe.keyValPaddingBottom, borderLeft: Fe.keyValBorderLeft + " " + Nt.objectBorder, ":hover": { paddingLeft: Mt.paddingLeft - 1 + "px", borderLeft: Fe.keyValBorderHover + " " + Nt.objectBorder } }, Mt) };
            }, "object-key-val-no-border": { padding: Fe.keyValPadding }, "pushed-content": { marginLeft: Fe.pushedContentMarginLeft }, variableValue: function(ct, Mt) {
              return { style: m6({ display: "inline-block", paddingRight: Fe.variableValuePaddingRight, position: "relative" }, Mt) };
            }, "object-name": { display: "inline-block", color: Nt.keyColor, letterSpacing: Fe.keyLetterSpacing, fontStyle: Fe.keyFontStyle, verticalAlign: Fe.keyVerticalAlign, opacity: Fe.keyOpacity, ":hover": { opacity: Fe.keyOpacityHover } }, "array-key": { display: "inline-block", color: Nt.arrayKeyColor, letterSpacing: Fe.keyLetterSpacing, fontStyle: Fe.keyFontStyle, verticalAlign: Fe.keyVerticalAlign, opacity: Fe.keyOpacity, ":hover": { opacity: Fe.keyOpacityHover } }, "object-size": { color: Nt.objectSize, borderRadius: Fe.objectSizeBorderRadius, fontStyle: Fe.objectSizeFontStyle, margin: Fe.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Fe.dataTypeFontSize, marginRight: Fe.dataTypeMarginRight, opacity: Fe.datatypeOpacity }, boolean: { display: "inline-block", color: Nt.dataTypes.boolean }, date: { display: "inline-block", color: Nt.dataTypes.date }, "date-value": { marginLeft: Fe.dateValueMarginLeft }, float: { display: "inline-block", color: Nt.dataTypes.float }, function: { display: "inline-block", color: Nt.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Nt.dataTypes.integer }, string: { display: "inline-block", color: Nt.dataTypes.string }, nan: { display: "inline-block", color: Nt.dataTypes.nan, fontSize: Fe.nanFontSize, fontWeight: Fe.nanFontWeight, backgroundColor: Nt.dataTypes.background, padding: Fe.nanPadding, borderRadius: Fe.nanBorderRadius }, null: { display: "inline-block", color: Nt.dataTypes.null, fontSize: Fe.nullFontSize, fontWeight: Fe.nullFontWeight, backgroundColor: Nt.dataTypes.background, padding: Fe.nullPadding, borderRadius: Fe.nullBorderRadius }, undefined: { display: "inline-block", color: Nt.dataTypes.undefined, fontSize: Fe.undefinedFontSize, padding: Fe.undefinedPadding, borderRadius: Fe.undefinedBorderRadius, backgroundColor: Nt.dataTypes.background }, regexp: { display: "inline-block", color: Nt.dataTypes.regexp }, "copy-to-clipboard": { cursor: Fe.clipboardCursor }, "copy-icon": { color: Nt.copyToClipboard, fontSize: Fe.iconFontSize, marginRight: Fe.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Nt.copyToClipboardCheck, marginLeft: Fe.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Fe.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Fe.metaDataPadding }, "icon-container": { display: "inline-block", width: Fe.iconContainerWidth }, tooltip: { padding: Fe.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Nt.editVariable.removeIcon, cursor: Fe.iconCursor, fontSize: Fe.iconFontSize, marginRight: Fe.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Nt.editVariable.addIcon, cursor: Fe.iconCursor, fontSize: Fe.iconFontSize, marginRight: Fe.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Nt.editVariable.editIcon, cursor: Fe.iconCursor, fontSize: Fe.iconFontSize, marginRight: Fe.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Fe.iconCursor, color: Nt.editVariable.checkIcon, fontSize: Fe.iconFontSize, paddingRight: Fe.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Fe.iconCursor, color: Nt.editVariable.cancelIcon, fontSize: Fe.iconFontSize, paddingRight: Fe.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Fe.editInputMinWidth, borderRadius: Fe.editInputBorderRadius, backgroundColor: Nt.editVariable.background, color: Nt.editVariable.color, padding: Fe.editInputPadding, marginRight: Fe.editInputMarginRight, fontFamily: Fe.editInputFontFamily }, "detected-row": { paddingTop: Fe.detectedRowPaddingTop }, "key-modal-request": { position: Fe.addKeyCoverPosition, top: Fe.addKeyCoverPositionPx, left: Fe.addKeyCoverPositionPx, right: Fe.addKeyCoverPositionPx, bottom: Fe.addKeyCoverPositionPx, backgroundColor: Fe.addKeyCoverBackground }, "key-modal": { width: Fe.addKeyModalWidth, backgroundColor: Nt.addKeyModal.background, marginLeft: Fe.addKeyModalMargin, marginRight: Fe.addKeyModalMargin, padding: Fe.addKeyModalPadding, borderRadius: Fe.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Nt.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Nt.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Nt.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Nt.addKeyModal.labelColor, fontSize: Fe.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Nt.editVariable.addIcon, fontSize: Fe.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Nt.ellipsisColor, fontSize: Fe.ellipsisFontSize, lineHeight: Fe.ellipsisLineHeight, cursor: Fe.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Nt.validationFailure.fontColor, backgroundColor: Nt.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Nt.validationFailure.iconColor, fontSize: Fe.iconFontSize, transform: "rotate(45deg)" } };
          };
          function Qe(Ot, Nt, ct) {
            return Ot || console.error("theme has not been set"), function(Mt) {
              var _t = ke;
              return Mt !== false && Mt !== "none" || (_t = je), Object(at.createStyling)(ht, { defaultBase16: _t })(Mt);
            }(Ot)(Nt, ct);
          }
          var en = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = (Mt.rjvId, Mt.type_name), Rn = Mt.displayDataTypes, Pn = Mt.theme;
              return Rn ? U.a.createElement("span", Object.assign({ className: "data-type-label" }, Qe(Pn, "data-type-label")), _t) : null;
            } }]), ct;
          }(U.a.PureComponent), bt = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props;
              return U.a.createElement("div", Qe(Mt.theme, "boolean"), U.a.createElement(en, Object.assign({ type_name: "bool" }, Mt)), Mt.value ? "true" : "false");
            } }]), ct;
          }(U.a.PureComponent), wt = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props;
              return U.a.createElement("div", Qe(Mt.theme, "date"), U.a.createElement(en, Object.assign({ type_name: "date" }, Mt)), U.a.createElement("span", Object.assign({ className: "date-value" }, Qe(Mt.theme, "date-value")), Mt.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
            } }]), ct;
          }(U.a.PureComponent), Ft = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props;
              return U.a.createElement("div", Qe(Mt.theme, "float"), U.a.createElement(en, Object.assign({ type_name: "float" }, Mt)), this.props.value);
            } }]), ct;
          }(U.a.PureComponent);
          function fn(Ot, Nt) {
            (Nt == null || Nt > Ot.length) && (Nt = Ot.length);
            for (var ct = 0, Mt = new Array(Nt); ct < Nt; ct++)
              Mt[ct] = Ot[ct];
            return Mt;
          }
          function gn(Ot, Nt) {
            if (Ot) {
              if (typeof Ot == "string")
                return fn(Ot, Nt);
              var ct = Object.prototype.toString.call(Ot).slice(8, -1);
              return ct === "Object" && Ot.constructor && (ct = Ot.constructor.name), ct === "Map" || ct === "Set" ? Array.from(Ot) : ct === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ct) ? fn(Ot, Nt) : void 0;
            }
          }
          function Zr(Ot, Nt) {
            var ct;
            if (typeof Symbol == "undefined" || Ot[Symbol.iterator] == null) {
              if (Array.isArray(Ot) || (ct = gn(Ot)) || Nt && Ot && typeof Ot.length == "number") {
                ct && (Ot = ct);
                var Mt = 0, _t = function() {
                };
                return { s: _t, n: function() {
                  return Mt >= Ot.length ? { done: true } : { done: false, value: Ot[Mt++] };
                }, e: function(Mn) {
                  throw Mn;
                }, f: _t };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            var Rn, Pn = true, lr = false;
            return { s: function() {
              ct = Ot[Symbol.iterator]();
            }, n: function() {
              var Mn = ct.next();
              return Pn = Mn.done, Mn;
            }, e: function(Mn) {
              lr = true, Rn = Mn;
            }, f: function() {
              try {
                Pn || ct.return == null || ct.return();
              } finally {
                if (lr)
                  throw Rn;
              }
            } };
          }
          function Ma(Ot) {
            return function(Nt) {
              if (Array.isArray(Nt))
                return fn(Nt);
            }(Ot) || function(Nt) {
              if (typeof Symbol != "undefined" && Symbol.iterator in Object(Nt))
                return Array.from(Nt);
            }(Ot) || gn(Ot) || function() {
              throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }();
          }
          var Ua = f6(46), ja = new (f6(47)).Dispatcher(), Ga = new (function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              var Mt;
              b6(this, ct);
              for (var _t = arguments.length, Rn = new Array(_t), Pn = 0; Pn < _t; Pn++)
                Rn[Pn] = arguments[Pn];
              return (Mt = Nt.call.apply(Nt, [this].concat(Rn))).objects = {}, Mt.set = function(lr, Mn, ta, di) {
                Mt.objects[lr] === void 0 && (Mt.objects[lr] = {}), Mt.objects[lr][Mn] === void 0 && (Mt.objects[lr][Mn] = {}), Mt.objects[lr][Mn][ta] = di;
              }, Mt.get = function(lr, Mn, ta, di) {
                return Mt.objects[lr] === void 0 || Mt.objects[lr][Mn] === void 0 || Mt.objects[lr][Mn][ta] == null ? di : Mt.objects[lr][Mn][ta];
              }, Mt.handleAction = function(lr) {
                var Mn = lr.rjvId, ta = lr.data;
                switch (lr.name) {
                  case "RESET":
                    Mt.emit("reset-" + Mn);
                    break;
                  case "VARIABLE_UPDATED":
                    lr.data.updated_src = Mt.updateSrc(Mn, ta), Mt.set(Mn, "action", "variable-update", m6(m6({}, ta), {}, { type: "variable-edited" })), Mt.emit("variable-update-" + Mn);
                    break;
                  case "VARIABLE_REMOVED":
                    lr.data.updated_src = Mt.updateSrc(Mn, ta), Mt.set(Mn, "action", "variable-update", m6(m6({}, ta), {}, { type: "variable-removed" })), Mt.emit("variable-update-" + Mn);
                    break;
                  case "VARIABLE_ADDED":
                    lr.data.updated_src = Mt.updateSrc(Mn, ta), Mt.set(Mn, "action", "variable-update", m6(m6({}, ta), {}, { type: "variable-added" })), Mt.emit("variable-update-" + Mn);
                    break;
                  case "ADD_VARIABLE_KEY_REQUEST":
                    Mt.set(Mn, "action", "new-key-request", ta), Mt.emit("add-key-request-" + Mn);
                }
              }, Mt.updateSrc = function(lr, Mn) {
                var ta = Mn.name, di = Mn.namespace, as = Mn.new_value, fo = (Mn.existing_value, Mn.variable_removed);
                di.shift();
                var Gl, So = Mt.get(lr, "global", "src"), kl = Mt.deepCopy(So, Ma(di)), Jl = kl, Mi = Zr(di);
                try {
                  for (Mi.s(); !(Gl = Mi.n()).done; )
                    Jl = Jl[Gl.value];
                } catch (Sl) {
                  Mi.e(Sl);
                } finally {
                  Mi.f();
                }
                return fo ? Ae(Jl) == "array" ? Jl.splice(ta, 1) : delete Jl[ta] : ta !== null ? Jl[ta] = as : kl = as, Mt.set(lr, "global", "src", kl), kl;
              }, Mt.deepCopy = function(lr, Mn) {
                var ta, di = Ae(lr), as = Mn.shift();
                return di == "array" ? ta = Ma(lr) : di == "object" && (ta = m6({}, lr)), as !== void 0 && (ta[as] = Mt.deepCopy(lr[as], Mn)), ta;
              }, Mt;
            }
            return ct;
          }(Ua.EventEmitter))();
          ja.register(Ga.handleAction.bind(Ga));
          var pa = Ga, Fa = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).toggleCollapsed = function() {
                _t.setState({ collapsed: !_t.state.collapsed }, function() {
                  pa.set(_t.props.rjvId, _t.props.namespace, "collapsed", _t.state.collapsed);
                });
              }, _t.getFunctionDisplay = function(Rn) {
                var Pn = F(_t).props;
                return Rn ? U.a.createElement("span", null, _t.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), U.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, U.a.createElement("span", null, "{"), U.a.createElement("span", Qe(Pn.theme, "ellipsis"), "..."), U.a.createElement("span", null, "}"))) : _t.props.value.toString().slice(9, -1);
              }, _t.state = { collapsed: pa.get(Mt.rjvId, Mt.namespace, "collapsed", true) }, _t;
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = this.state.collapsed;
              return U.a.createElement("div", Qe(Mt.theme, "function"), U.a.createElement(en, Object.assign({ type_name: "function" }, Mt)), U.a.createElement("span", Object.assign({}, Qe(Mt.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(_t)));
            } }]), ct;
          }(U.a.PureComponent), Ha = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              return U.a.createElement("div", Qe(this.props.theme, "nan"), "NaN");
            } }]), ct;
          }(U.a.PureComponent), Sa = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              return U.a.createElement("div", Qe(this.props.theme, "null"), "NULL");
            } }]), ct;
          }(U.a.PureComponent), oi = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props;
              return U.a.createElement("div", Qe(Mt.theme, "integer"), U.a.createElement(en, Object.assign({ type_name: "int" }, Mt)), this.props.value);
            } }]), ct;
          }(U.a.PureComponent), bs = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props;
              return U.a.createElement("div", Qe(Mt.theme, "regexp"), U.a.createElement(en, Object.assign({ type_name: "regexp" }, Mt)), this.props.value.toString());
            } }]), ct;
          }(U.a.PureComponent), Si = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).toggleCollapsed = function() {
                _t.setState({ collapsed: !_t.state.collapsed }, function() {
                  pa.set(_t.props.rjvId, _t.props.namespace, "collapsed", _t.state.collapsed);
                });
              }, _t.state = { collapsed: pa.get(Mt.rjvId, Mt.namespace, "collapsed", true) }, _t;
            }
            return S(ct, [{ key: "render", value: function() {
              this.state.collapsed;
              var Mt = this.props, _t = Mt.collapseStringsAfterLength, Rn = Mt.theme, Pn = Mt.value, lr = { style: { cursor: "default" } };
              return Ae(_t) === "integer" && Pn.length > _t && (lr.style.cursor = "pointer", this.state.collapsed && (Pn = U.a.createElement("span", null, Pn.substring(0, _t), U.a.createElement("span", Qe(Rn, "ellipsis"), " ...")))), U.a.createElement("div", Qe(Rn, "string"), U.a.createElement(en, Object.assign({ type_name: "string" }, Mt)), U.a.createElement("span", Object.assign({ className: "string-value" }, lr, { onClick: this.toggleCollapsed }), '"', Pn, '"'));
            } }]), ct;
          }(U.a.PureComponent), Ls = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              return U.a.createElement("div", Qe(this.props.theme, "undefined"), "undefined");
            } }]), ct;
          }(U.a.PureComponent);
          function tl() {
            return (tl = Object.assign || function(Ot) {
              for (var Nt = 1; Nt < arguments.length; Nt++) {
                var ct = arguments[Nt];
                for (var Mt in ct)
                  Object.prototype.hasOwnProperty.call(ct, Mt) && (Ot[Mt] = ct[Mt]);
              }
              return Ot;
            }).apply(this, arguments);
          }
          var Hs = K.useLayoutEffect, Of = function(Ot) {
            var Nt = Object(K.useRef)(Ot);
            return Hs(function() {
              Nt.current = Ot;
            }), Nt;
          }, Xu = function(Ot, Nt) {
            typeof Ot != "function" ? Ot.current = Nt : Ot(Nt);
          }, kh = function(Ot, Nt) {
            var ct = Object(K.useRef)();
            return Object(K.useCallback)(function(Mt) {
              Ot.current = Mt, ct.current && Xu(ct.current, null), ct.current = Nt, Nt && Xu(Nt, Mt);
            }, [Nt]);
          }, ou = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, lc = function(Ot) {
            Object.keys(ou).forEach(function(Nt) {
              Ot.style.setProperty(Nt, ou[Nt], "important");
            });
          }, Ku = null, _0 = function() {
          }, Vr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Un = !!document.documentElement.currentStyle, Wn = function(Ot, Nt) {
            var ct = Ot.cacheMeasurements, Mt = Ot.maxRows, _t = Ot.minRows, Rn = Ot.onChange, Pn = Rn === void 0 ? _0 : Rn, lr = Ot.onHeightChange, Mn = lr === void 0 ? _0 : lr, ta = function(Mi, Sl) {
              if (Mi == null)
                return {};
              var lp, x0, bS = {}, qp = Object.keys(Mi);
              for (x0 = 0; x0 < qp.length; x0++)
                lp = qp[x0], Sl.indexOf(lp) >= 0 || (bS[lp] = Mi[lp]);
              return bS;
            }(Ot, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), di, as = ta.value !== void 0, fo = Object(K.useRef)(null), Gl = kh(fo, Nt), So = Object(K.useRef)(0), kl = Object(K.useRef)(), Jl = function() {
              var Mi = fo.current, Sl = ct && kl.current ? kl.current : function(qp) {
                var p1 = window.getComputedStyle(qp);
                if (p1 === null)
                  return null;
                var v12, Jc = (v12 = p1, Vr.reduce(function(Qx, g1) {
                  return Qx[g1] = v12[g1], Qx;
                }, {})), qm = Jc.boxSizing;
                return qm === "" ? null : (Un && qm === "border-box" && (Jc.width = parseFloat(Jc.width) + parseFloat(Jc.borderRightWidth) + parseFloat(Jc.borderLeftWidth) + parseFloat(Jc.paddingRight) + parseFloat(Jc.paddingLeft) + "px"), { sizingStyle: Jc, paddingSize: parseFloat(Jc.paddingBottom) + parseFloat(Jc.paddingTop), borderSize: parseFloat(Jc.borderBottomWidth) + parseFloat(Jc.borderTopWidth) });
              }(Mi);
              if (Sl) {
                kl.current = Sl;
                var lp = function(qp, p1, v12, Jc) {
                  v12 === void 0 && (v12 = 1), Jc === void 0 && (Jc = 1 / 0), Ku || ((Ku = document.createElement("textarea")).setAttribute("tab-index", "-1"), Ku.setAttribute("aria-hidden", "true"), lc(Ku)), Ku.parentNode === null && document.body.appendChild(Ku);
                  var qm = qp.paddingSize, Qx = qp.borderSize, g1 = qp.sizingStyle, ew = g1.boxSizing;
                  Object.keys(g1).forEach(function(nw) {
                    var Yb = nw;
                    Ku.style[Yb] = g1[Yb];
                  }), lc(Ku), Ku.value = p1;
                  var qb = function(nw, Yb) {
                    var vg = nw.scrollHeight;
                    return Yb.sizingStyle.boxSizing === "border-box" ? vg + Yb.borderSize : vg - Yb.paddingSize;
                  }(Ku, qp);
                  Ku.value = "x";
                  var Lh = Ku.scrollHeight - qm, tw = Lh * v12;
                  ew === "border-box" && (tw = tw + qm + Qx), qb = Math.max(tw, qb);
                  var Ym = Lh * Jc;
                  return ew === "border-box" && (Ym = Ym + qm + Qx), [qb = Math.min(Ym, qb), Lh];
                }(Sl, Mi.value || Mi.placeholder || "x", _t, Mt), x0 = lp[0], bS = lp[1];
                So.current !== x0 && (So.current = x0, Mi.style.setProperty("height", x0 + "px", "important"), Mn(x0, { rowHeight: bS }));
              }
            };
            return Object(K.useLayoutEffect)(Jl), di = Of(Jl), Object(K.useLayoutEffect)(function() {
              var Mi = function(Sl) {
                di.current(Sl);
              };
              return window.addEventListener("resize", Mi), function() {
                window.removeEventListener("resize", Mi);
              };
            }, []), Object(K.createElement)("textarea", tl({}, ta, { onChange: function(Mi) {
              as || Jl(), Pn(Mi);
            }, ref: Gl }));
          }, zr = Object(K.forwardRef)(Wn);
          function La(Ot) {
            Ot = Ot.trim();
            try {
              if ((Ot = JSON.stringify(JSON.parse(Ot)))[0] === "[")
                return _i("array", JSON.parse(Ot));
              if (Ot[0] === "{")
                return _i("object", JSON.parse(Ot));
              if (Ot.match(/\-?\d+\.\d+/) && Ot.match(/\-?\d+\.\d+/)[0] === Ot)
                return _i("float", parseFloat(Ot));
              if (Ot.match(/\-?\d+e-\d+/) && Ot.match(/\-?\d+e-\d+/)[0] === Ot)
                return _i("float", Number(Ot));
              if (Ot.match(/\-?\d+/) && Ot.match(/\-?\d+/)[0] === Ot)
                return _i("integer", parseInt(Ot));
              if (Ot.match(/\-?\d+e\+\d+/) && Ot.match(/\-?\d+e\+\d+/)[0] === Ot)
                return _i("integer", Number(Ot));
            } catch {
            }
            switch (Ot = Ot.toLowerCase()) {
              case "undefined":
                return _i("undefined", void 0);
              case "nan":
                return _i("nan", NaN);
              case "null":
                return _i("null", null);
              case "true":
                return _i("boolean", true);
              case "false":
                return _i("boolean", false);
              default:
                if (Ot = Date.parse(Ot))
                  return _i("date", new Date(Ot));
            }
            return _i(false, null);
          }
          function _i(Ot, Nt) {
            return { type: Ot, value: Nt };
          }
          var Jo = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
            } }]), ct;
          }(U.a.PureComponent), Wo = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
            } }]), ct;
          }(U.a.PureComponent), wl = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]), Pn = $s(_t).style;
              return U.a.createElement("span", Rn, U.a.createElement("svg", { fill: Pn.color, width: Pn.height, height: Pn.width, style: Pn, viewBox: "0 0 1792 1792" }, U.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), ct;
          }(U.a.PureComponent), Ju = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]), Pn = $s(_t).style;
              return U.a.createElement("span", Rn, U.a.createElement("svg", { fill: Pn.color, width: Pn.height, height: Pn.width, style: Pn, viewBox: "0 0 1792 1792" }, U.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), ct;
          }(U.a.PureComponent), wu = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", { style: m6(m6({}, $s(_t).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, U.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
            } }]), ct;
          }(U.a.PureComponent), Kc = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", { style: m6(m6({}, $s(_t).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, U.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
            } }]), ct;
          }(U.a.PureComponent), Su = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("g", null, U.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
            } }]), ct;
          }(U.a.PureComponent), pd = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("g", null, U.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), ct;
          }(U.a.PureComponent), ip = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("g", null, U.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), ct;
          }(U.a.PureComponent), kv = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("g", null, U.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
            } }]), ct;
          }(U.a.PureComponent), op = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("g", null, U.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
            } }]), ct;
          }(U.a.PureComponent), Ac = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.style, Rn = xe(Mt, ["style"]);
              return U.a.createElement("span", Rn, U.a.createElement("svg", Object.assign({}, $s(_t), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), U.a.createElement("g", null, U.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), ct;
          }(U.a.PureComponent);
          function $s(Ot) {
            return Ot || (Ot = {}), { style: m6(m6({ verticalAlign: "middle" }, Ot), {}, { color: Ot.color ? Ot.color : "#000000", height: "1em", width: "1em" }) };
          }
          var Rf = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).copiedTimer = null, _t.handleCopy = function() {
                var Rn = document.createElement("textarea"), Pn = _t.props, lr = Pn.clickCallback, Mn = Pn.src, ta = Pn.namespace;
                Rn.innerHTML = JSON.stringify(_t.clipboardValue(Mn), null, "  "), document.body.appendChild(Rn), Rn.select(), document.execCommand("copy"), document.body.removeChild(Rn), _t.copiedTimer = setTimeout(function() {
                  _t.setState({ copied: false });
                }, 5500), _t.setState({ copied: true }, function() {
                  typeof lr == "function" && lr({ src: Mn, namespace: ta, name: ta[ta.length - 1] });
                });
              }, _t.getClippyIcon = function() {
                var Rn = _t.props.theme;
                return _t.state.copied ? U.a.createElement("span", null, U.a.createElement(Su, Object.assign({ className: "copy-icon" }, Qe(Rn, "copy-icon"))), U.a.createElement("span", Qe(Rn, "copy-icon-copied"), "\u2714")) : U.a.createElement(Su, Object.assign({ className: "copy-icon" }, Qe(Rn, "copy-icon")));
              }, _t.clipboardValue = function(Rn) {
                switch (Ae(Rn)) {
                  case "function":
                  case "regexp":
                    return Rn.toString();
                  default:
                    return Rn;
                }
              }, _t.state = { copied: false }, _t;
            }
            return S(ct, [{ key: "componentWillUnmount", value: function() {
              this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
            } }, { key: "render", value: function() {
              var Mt = this.props, _t = (Mt.src, Mt.theme), Rn = Mt.hidden, Pn = Mt.rowHovered, lr = Qe(_t, "copy-to-clipboard").style, Mn = "inline";
              return Rn && (Mn = "none"), U.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Pn ? "inline-block" : "none" } }, U.a.createElement("span", { style: m6(m6({}, lr), {}, { display: Mn }), onClick: this.handleCopy }, this.getClippyIcon()));
            } }]), ct;
          }(U.a.PureComponent), Ph = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).getEditIcon = function() {
                var Rn = _t.props, Pn = Rn.variable, lr = Rn.theme;
                return U.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: _t.state.hovered ? "inline-block" : "none" } }, U.a.createElement(op, Object.assign({ className: "click-to-edit-icon" }, Qe(lr, "editVarIcon"), { onClick: function() {
                  _t.prepopInput(Pn);
                } })));
              }, _t.prepopInput = function(Rn) {
                if (_t.props.onEdit !== false) {
                  var Pn = function(Mn) {
                    var ta;
                    switch (Ae(Mn)) {
                      case "undefined":
                        ta = "undefined";
                        break;
                      case "nan":
                        ta = "NaN";
                        break;
                      case "string":
                        ta = Mn;
                        break;
                      case "date":
                      case "function":
                      case "regexp":
                        ta = Mn.toString();
                        break;
                      default:
                        try {
                          ta = JSON.stringify(Mn, null, "  ");
                        } catch {
                          ta = "";
                        }
                    }
                    return ta;
                  }(Rn.value), lr = La(Pn);
                  _t.setState({ editMode: true, editValue: Pn, parsedInput: { type: lr.type, value: lr.value } });
                }
              }, _t.getRemoveIcon = function() {
                var Rn = _t.props, Pn = Rn.variable, lr = Rn.namespace, Mn = Rn.theme, ta = Rn.rjvId;
                return U.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: _t.state.hovered ? "inline-block" : "none" } }, U.a.createElement(pd, Object.assign({ className: "click-to-remove-icon" }, Qe(Mn, "removeVarIcon"), { onClick: function() {
                  ja.dispatch({ name: "VARIABLE_REMOVED", rjvId: ta, data: { name: Pn.name, namespace: lr, existing_value: Pn.value, variable_removed: true } });
                } })));
              }, _t.getValue = function(Rn, Pn) {
                var lr = !Pn && Rn.type, Mn = F(_t).props;
                switch (lr) {
                  case false:
                    return _t.getEditInput();
                  case "string":
                    return U.a.createElement(Si, Object.assign({ value: Rn.value }, Mn));
                  case "integer":
                    return U.a.createElement(oi, Object.assign({ value: Rn.value }, Mn));
                  case "float":
                    return U.a.createElement(Ft, Object.assign({ value: Rn.value }, Mn));
                  case "boolean":
                    return U.a.createElement(bt, Object.assign({ value: Rn.value }, Mn));
                  case "function":
                    return U.a.createElement(Fa, Object.assign({ value: Rn.value }, Mn));
                  case "null":
                    return U.a.createElement(Sa, Mn);
                  case "nan":
                    return U.a.createElement(Ha, Mn);
                  case "undefined":
                    return U.a.createElement(Ls, Mn);
                  case "date":
                    return U.a.createElement(wt, Object.assign({ value: Rn.value }, Mn));
                  case "regexp":
                    return U.a.createElement(bs, Object.assign({ value: Rn.value }, Mn));
                  default:
                    return U.a.createElement("div", { className: "object-value" }, JSON.stringify(Rn.value));
                }
              }, _t.getEditInput = function() {
                var Rn = _t.props.theme, Pn = _t.state.editValue;
                return U.a.createElement("div", null, U.a.createElement(zr, Object.assign({ type: "text", inputRef: function(lr) {
                  return lr && lr.focus();
                }, value: Pn, className: "variable-editor", onChange: function(lr) {
                  var Mn = lr.target.value, ta = La(Mn);
                  _t.setState({ editValue: Mn, parsedInput: { type: ta.type, value: ta.value } });
                }, onKeyDown: function(lr) {
                  switch (lr.key) {
                    case "Escape":
                      _t.setState({ editMode: false, editValue: "" });
                      break;
                    case "Enter":
                      (lr.ctrlKey || lr.metaKey) && _t.submitEdit(true);
                  }
                  lr.stopPropagation();
                }, placeholder: "update this value", minRows: 2 }, Qe(Rn, "edit-input"))), U.a.createElement("div", Qe(Rn, "edit-icon-container"), U.a.createElement(pd, Object.assign({ className: "edit-cancel" }, Qe(Rn, "cancel-icon"), { onClick: function() {
                  _t.setState({ editMode: false, editValue: "" });
                } })), U.a.createElement(Ac, Object.assign({ className: "edit-check string-value" }, Qe(Rn, "check-icon"), { onClick: function() {
                  _t.submitEdit();
                } })), U.a.createElement("div", null, _t.showDetected())));
              }, _t.submitEdit = function(Rn) {
                var Pn = _t.props, lr = Pn.variable, Mn = Pn.namespace, ta = Pn.rjvId, di = _t.state, as = di.editValue, fo = di.parsedInput, Gl = as;
                Rn && fo.type && (Gl = fo.value), _t.setState({ editMode: false }), ja.dispatch({ name: "VARIABLE_UPDATED", rjvId: ta, data: { name: lr.name, namespace: Mn, existing_value: lr.value, new_value: Gl, variable_removed: false } });
              }, _t.showDetected = function() {
                var Rn = _t.props, Pn = Rn.theme, lr = (Rn.variable, Rn.namespace, Rn.rjvId, _t.state.parsedInput), Mn = (lr.type, lr.value, _t.getDetectedInput());
                if (Mn)
                  return U.a.createElement("div", null, U.a.createElement("div", Qe(Pn, "detected-row"), Mn, U.a.createElement(Ac, { className: "edit-check detected", style: m6({ verticalAlign: "top", paddingLeft: "3px" }, Qe(Pn, "check-icon").style), onClick: function() {
                    _t.submitEdit(true);
                  } })));
              }, _t.getDetectedInput = function() {
                var Rn = _t.state.parsedInput, Pn = Rn.type, lr = Rn.value, Mn = F(_t).props, ta = Mn.theme;
                if (Pn !== false)
                  switch (Pn.toLowerCase()) {
                    case "object":
                      return U.a.createElement("span", null, U.a.createElement("span", { style: m6(m6({}, Qe(ta, "brace").style), {}, { cursor: "default" }) }, "{"), U.a.createElement("span", { style: m6(m6({}, Qe(ta, "ellipsis").style), {}, { cursor: "default" }) }, "..."), U.a.createElement("span", { style: m6(m6({}, Qe(ta, "brace").style), {}, { cursor: "default" }) }, "}"));
                    case "array":
                      return U.a.createElement("span", null, U.a.createElement("span", { style: m6(m6({}, Qe(ta, "brace").style), {}, { cursor: "default" }) }, "["), U.a.createElement("span", { style: m6(m6({}, Qe(ta, "ellipsis").style), {}, { cursor: "default" }) }, "..."), U.a.createElement("span", { style: m6(m6({}, Qe(ta, "brace").style), {}, { cursor: "default" }) }, "]"));
                    case "string":
                      return U.a.createElement(Si, Object.assign({ value: lr }, Mn));
                    case "integer":
                      return U.a.createElement(oi, Object.assign({ value: lr }, Mn));
                    case "float":
                      return U.a.createElement(Ft, Object.assign({ value: lr }, Mn));
                    case "boolean":
                      return U.a.createElement(bt, Object.assign({ value: lr }, Mn));
                    case "function":
                      return U.a.createElement(Fa, Object.assign({ value: lr }, Mn));
                    case "null":
                      return U.a.createElement(Sa, Mn);
                    case "nan":
                      return U.a.createElement(Ha, Mn);
                    case "undefined":
                      return U.a.createElement(Ls, Mn);
                    case "date":
                      return U.a.createElement(wt, Object.assign({ value: new Date(lr) }, Mn));
                  }
              }, _t.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, _t;
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this, _t = this.props, Rn = _t.variable, Pn = _t.singleIndent, lr = _t.type, Mn = _t.theme, ta = _t.namespace, di = _t.indentWidth, as = _t.enableClipboard, fo = _t.onEdit, Gl = _t.onDelete, So = _t.onSelect, kl = _t.displayArrayKey, Jl = _t.quotesOnKeys, Mi = this.state.editMode;
              return U.a.createElement("div", Object.assign({}, Qe(Mn, "objectKeyVal", { paddingLeft: di * Pn }), { onMouseEnter: function() {
                return Mt.setState(m6(m6({}, Mt.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return Mt.setState(m6(m6({}, Mt.state), {}, { hovered: false }));
              }, className: "variable-row", key: Rn.name }), lr == "array" ? kl ? U.a.createElement("span", Object.assign({}, Qe(Mn, "array-key"), { key: Rn.name + "_" + ta }), Rn.name, U.a.createElement("div", Qe(Mn, "colon"), ":")) : null : U.a.createElement("span", null, U.a.createElement("span", Object.assign({}, Qe(Mn, "object-name"), { className: "object-key", key: Rn.name + "_" + ta }), !!Jl && U.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), U.a.createElement("span", { style: { display: "inline-block" } }, Rn.name), !!Jl && U.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), U.a.createElement("span", Qe(Mn, "colon"), ":")), U.a.createElement("div", Object.assign({ className: "variable-value", onClick: So === false && fo === false ? null : function(Sl) {
                var lp = Ma(ta);
                (Sl.ctrlKey || Sl.metaKey) && fo !== false ? Mt.prepopInput(Rn) : So !== false && (lp.shift(), So(m6(m6({}, Rn), {}, { namespace: lp })));
              } }, Qe(Mn, "variableValue", { cursor: So === false ? "default" : "pointer" })), this.getValue(Rn, Mi)), as ? U.a.createElement(Rf, { rowHovered: this.state.hovered, hidden: Mi, src: Rn.value, clickCallback: as, theme: Mn, namespace: [].concat(Ma(ta), [Rn.name]) }) : null, fo !== false && Mi == 0 ? this.getEditIcon() : null, Gl !== false && Mi == 0 ? this.getRemoveIcon() : null);
            } }]), ct;
          }(U.a.PureComponent), pg = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              var Mt;
              b6(this, ct);
              for (var _t = arguments.length, Rn = new Array(_t), Pn = 0; Pn < _t; Pn++)
                Rn[Pn] = arguments[Pn];
              return (Mt = Nt.call.apply(Nt, [this].concat(Rn))).getObjectSize = function() {
                var lr = Mt.props, Mn = lr.size, ta = lr.theme;
                if (lr.displayObjectSize)
                  return U.a.createElement("span", Object.assign({ className: "object-size" }, Qe(ta, "object-size")), Mn, " item", Mn === 1 ? "" : "s");
              }, Mt.getAddAttribute = function(lr) {
                var Mn = Mt.props, ta = Mn.theme, di = Mn.namespace, as = Mn.name, fo = Mn.src, Gl = Mn.rjvId, So = Mn.depth;
                return U.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: lr ? "inline-block" : "none" } }, U.a.createElement(ip, Object.assign({ className: "click-to-add-icon" }, Qe(ta, "addVarIcon"), { onClick: function() {
                  var kl = { name: So > 0 ? as : null, namespace: di.splice(0, di.length - 1), existing_value: fo, variable_removed: false, key_name: null };
                  Ae(fo) === "object" ? ja.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Gl, data: kl }) : ja.dispatch({ name: "VARIABLE_ADDED", rjvId: Gl, data: m6(m6({}, kl), {}, { new_value: [].concat(Ma(fo), [null]) }) });
                } })));
              }, Mt.getRemoveObject = function(lr) {
                var Mn = Mt.props, ta = Mn.theme, di = (Mn.hover, Mn.namespace), as = Mn.name, fo = Mn.src, Gl = Mn.rjvId;
                if (di.length !== 1)
                  return U.a.createElement("span", { className: "click-to-remove", style: { display: lr ? "inline-block" : "none" } }, U.a.createElement(pd, Object.assign({ className: "click-to-remove-icon" }, Qe(ta, "removeVarIcon"), { onClick: function() {
                    ja.dispatch({ name: "VARIABLE_REMOVED", rjvId: Gl, data: { name: as, namespace: di.splice(0, di.length - 1), existing_value: fo, variable_removed: true } });
                  } })));
              }, Mt.render = function() {
                var lr = Mt.props, Mn = lr.theme, ta = lr.onDelete, di = lr.onAdd, as = lr.enableClipboard, fo = lr.src, Gl = lr.namespace, So = lr.rowHovered;
                return U.a.createElement("div", Object.assign({}, Qe(Mn, "object-meta-data"), { className: "object-meta-data", onClick: function(kl) {
                  kl.stopPropagation();
                } }), Mt.getObjectSize(), as ? U.a.createElement(Rf, { rowHovered: So, clickCallback: as, src: fo, theme: Mn, namespace: Gl }) : null, di !== false ? Mt.getAddAttribute(So) : null, ta !== false ? Mt.getRemoveObject(So) : null);
              }, Mt;
            }
            return ct;
          }(U.a.PureComponent);
          function Up(Ot) {
            var Nt = Ot.parent_type, ct = Ot.namespace, Mt = Ot.quotesOnKeys, _t = Ot.theme, Rn = Ot.jsvRoot, Pn = Ot.name, lr = Ot.displayArrayKey, Mn = Ot.name ? Ot.name : "";
            return !Rn || Pn !== false && Pn !== null ? Nt == "array" ? lr ? U.a.createElement("span", Object.assign({}, Qe(_t, "array-key"), { key: ct }), U.a.createElement("span", { className: "array-key" }, Mn), U.a.createElement("span", Qe(_t, "colon"), ":")) : U.a.createElement("span", null) : U.a.createElement("span", Object.assign({}, Qe(_t, "object-name"), { key: ct }), U.a.createElement("span", { className: "object-key" }, Mt && U.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), U.a.createElement("span", null, Mn), Mt && U.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), U.a.createElement("span", Qe(_t, "colon"), ":")) : U.a.createElement("span", null);
          }
          function sp(Ot) {
            var Nt = Ot.theme;
            switch (Ot.iconStyle) {
              case "triangle":
                return U.a.createElement(Kc, Object.assign({}, Qe(Nt, "expanded-icon"), { className: "expanded-icon" }));
              case "square":
                return U.a.createElement(wl, Object.assign({}, Qe(Nt, "expanded-icon"), { className: "expanded-icon" }));
              default:
                return U.a.createElement(Jo, Object.assign({}, Qe(Nt, "expanded-icon"), { className: "expanded-icon" }));
            }
          }
          function Pv(Ot) {
            var Nt = Ot.theme;
            switch (Ot.iconStyle) {
              case "triangle":
                return U.a.createElement(wu, Object.assign({}, Qe(Nt, "collapsed-icon"), { className: "collapsed-icon" }));
              case "square":
                return U.a.createElement(Ju, Object.assign({}, Qe(Nt, "collapsed-icon"), { className: "collapsed-icon" }));
              default:
                return U.a.createElement(Wo, Object.assign({}, Qe(Nt, "collapsed-icon"), { className: "collapsed-icon" }));
            }
          }
          var $m = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).toggleCollapsed = function(Rn) {
                var Pn = [];
                for (var lr in _t.state.expanded)
                  Pn.push(_t.state.expanded[lr]);
                Pn[Rn] = !Pn[Rn], _t.setState({ expanded: Pn });
              }, _t.state = { expanded: [] }, _t;
            }
            return S(ct, [{ key: "getExpandedIcon", value: function(Mt) {
              var _t = this.props, Rn = _t.theme, Pn = _t.iconStyle;
              return this.state.expanded[Mt] ? U.a.createElement(sp, { theme: Rn, iconStyle: Pn }) : U.a.createElement(Pv, { theme: Rn, iconStyle: Pn });
            } }, { key: "render", value: function() {
              var Mt = this, _t = this.props, Rn = _t.src, Pn = _t.groupArraysAfterLength, lr = (_t.depth, _t.name), Mn = _t.theme, ta = _t.jsvRoot, di = _t.namespace, as = (_t.parent_type, xe(_t, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), fo = 0, Gl = 5 * this.props.indentWidth;
              ta || (fo = 5 * this.props.indentWidth);
              var So = Pn, kl = Math.ceil(Rn.length / So);
              return U.a.createElement("div", Object.assign({ className: "object-key-val" }, Qe(Mn, ta ? "jsv-root" : "objectKeyVal", { paddingLeft: fo })), U.a.createElement(Up, this.props), U.a.createElement("span", null, U.a.createElement(pg, Object.assign({ size: Rn.length }, this.props))), Ma(Array(kl)).map(function(Jl, Mi) {
                return U.a.createElement("div", Object.assign({ key: Mi, className: "object-key-val array-group" }, Qe(Mn, "objectKeyVal", { marginLeft: 6, paddingLeft: Gl })), U.a.createElement("span", Qe(Mn, "brace-row"), U.a.createElement("div", Object.assign({ className: "icon-container" }, Qe(Mn, "icon-container"), { onClick: function(Sl) {
                  Mt.toggleCollapsed(Mi);
                } }), Mt.getExpandedIcon(Mi)), Mt.state.expanded[Mi] ? U.a.createElement(Ub, Object.assign({ key: lr + Mi, depth: 0, name: false, collapsed: false, groupArraysAfterLength: So, index_offset: Mi * So, src: Rn.slice(Mi * So, Mi * So + So), namespace: di, type: "array", parent_type: "array_group", theme: Mn }, as)) : U.a.createElement("span", Object.assign({}, Qe(Mn, "brace"), { onClick: function(Sl) {
                  Mt.toggleCollapsed(Mi);
                }, className: "array-group-brace" }), "[", U.a.createElement("div", Object.assign({}, Qe(Mn, "array-group-meta-data"), { className: "array-group-meta-data" }), U.a.createElement("span", Object.assign({ className: "object-size" }, Qe(Mn, "object-size")), Mi * So, " - ", Mi * So + So > Rn.length ? Rn.length : Mi * So + So)), "]")));
              }));
            } }]), ct;
          }(U.a.PureComponent), Um = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              b6(this, ct), (_t = Nt.call(this, Mt)).toggleCollapsed = function() {
                _t.setState({ expanded: !_t.state.expanded }, function() {
                  pa.set(_t.props.rjvId, _t.props.namespace, "expanded", _t.state.expanded);
                });
              }, _t.getObjectContent = function(Pn, lr, Mn) {
                return U.a.createElement("div", { className: "pushed-content object-container" }, U.a.createElement("div", Object.assign({ className: "object-content" }, Qe(_t.props.theme, "pushed-content")), _t.renderObjectContents(lr, Mn)));
              }, _t.getEllipsis = function() {
                return _t.state.size === 0 ? null : U.a.createElement("div", Object.assign({}, Qe(_t.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: _t.toggleCollapsed }), "...");
              }, _t.getObjectMetaData = function(Pn) {
                var lr = _t.props, Mn = (lr.rjvId, lr.theme, _t.state), ta = Mn.size, di = Mn.hovered;
                return U.a.createElement(pg, Object.assign({ rowHovered: di, size: ta }, _t.props));
              }, _t.renderObjectContents = function(Pn, lr) {
                var Mn, ta = _t.props, di = ta.depth, as = ta.parent_type, fo = ta.index_offset, Gl = ta.groupArraysAfterLength, So = ta.namespace, kl = _t.state.object_type, Jl = [], Mi = Object.keys(Pn || {});
                return _t.props.sortKeys && kl !== "array" && (Mi = Mi.sort()), Mi.forEach(function(Sl) {
                  if (Mn = new j4(Sl, Pn[Sl]), as === "array_group" && fo && (Mn.name = parseInt(Mn.name) + fo), Pn.hasOwnProperty(Sl))
                    if (Mn.type === "object")
                      Jl.push(U.a.createElement(Ub, Object.assign({ key: Mn.name, depth: di + 1, name: Mn.name, src: Mn.value, namespace: So.concat(Mn.name), parent_type: kl }, lr)));
                    else if (Mn.type === "array") {
                      var lp = Ub;
                      Gl && Mn.value.length > Gl && (lp = $m), Jl.push(U.a.createElement(lp, Object.assign({ key: Mn.name, depth: di + 1, name: Mn.name, src: Mn.value, namespace: So.concat(Mn.name), type: "array", parent_type: kl }, lr)));
                    } else
                      Jl.push(U.a.createElement(Ph, Object.assign({ key: Mn.name + "_" + So, variable: Mn, singleIndent: 5, namespace: So, type: _t.props.type }, lr)));
                }), Jl;
              };
              var Rn = ct.getState(Mt);
              return _t.state = m6(m6({}, Rn), {}, { prevProps: {} }), _t;
            }
            return S(ct, [{ key: "getBraceStart", value: function(Mt, _t) {
              var Rn = this, Pn = this.props, lr = Pn.src, Mn = Pn.theme, ta = Pn.iconStyle;
              if (Pn.parent_type === "array_group")
                return U.a.createElement("span", null, U.a.createElement("span", Qe(Mn, "brace"), Mt === "array" ? "[" : "{"), _t ? this.getObjectMetaData(lr) : null);
              var di = _t ? sp : Pv;
              return U.a.createElement("span", null, U.a.createElement("span", Object.assign({ onClick: function(as) {
                Rn.toggleCollapsed();
              } }, Qe(Mn, "brace-row")), U.a.createElement("div", Object.assign({ className: "icon-container" }, Qe(Mn, "icon-container")), U.a.createElement(di, { theme: Mn, iconStyle: ta })), U.a.createElement(Up, this.props), U.a.createElement("span", Qe(Mn, "brace"), Mt === "array" ? "[" : "{")), _t ? this.getObjectMetaData(lr) : null);
            } }, { key: "render", value: function() {
              var Mt = this, _t = this.props, Rn = _t.depth, Pn = _t.src, lr = (_t.namespace, _t.name, _t.type, _t.parent_type), Mn = _t.theme, ta = _t.jsvRoot, di = _t.iconStyle, as = xe(_t, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), fo = this.state, Gl = fo.object_type, So = fo.expanded, kl = {};
              return ta || lr === "array_group" ? lr === "array_group" && (kl.borderLeft = 0, kl.display = "inline") : kl.paddingLeft = 5 * this.props.indentWidth, U.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                return Mt.setState(m6(m6({}, Mt.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return Mt.setState(m6(m6({}, Mt.state), {}, { hovered: false }));
              } }, Qe(Mn, ta ? "jsv-root" : "objectKeyVal", kl)), this.getBraceStart(Gl, So), So ? this.getObjectContent(Rn, Pn, m6({ theme: Mn, iconStyle: di }, as)) : this.getEllipsis(), U.a.createElement("span", { className: "brace-row" }, U.a.createElement("span", { style: m6(m6({}, Qe(Mn, "brace").style), {}, { paddingLeft: So ? "3px" : "0px" }) }, Gl === "array" ? "]" : "}"), So ? null : this.getObjectMetaData(Pn)));
            } }], [{ key: "getDerivedStateFromProps", value: function(Mt, _t) {
              var Rn = _t.prevProps;
              return Mt.src !== Rn.src || Mt.collapsed !== Rn.collapsed || Mt.name !== Rn.name || Mt.namespace !== Rn.namespace || Mt.rjvId !== Rn.rjvId ? m6(m6({}, ct.getState(Mt)), {}, { prevProps: Mt }) : null;
            } }]), ct;
          }(U.a.PureComponent);
          Um.getState = function(Ot) {
            var Nt = Object.keys(Ot.src).length, ct = (Ot.collapsed === false || Ot.collapsed !== true && Ot.collapsed > Ot.depth) && (!Ot.shouldCollapse || Ot.shouldCollapse({ name: Ot.name, src: Ot.src, type: Ae(Ot.src), namespace: Ot.namespace }) === false) && Nt !== 0;
            return { expanded: pa.get(Ot.rjvId, Ot.namespace, "expanded", ct), object_type: Ot.type === "array" ? "array" : "object", parent_type: Ot.type === "array" ? "array" : "object", size: Nt, hovered: false };
          };
          var j4 = function Ot(Nt, ct) {
            b6(this, Ot), this.name = Nt, this.value = ct, this.type = Ae(ct);
          };
          _e(Um);
          var Ub = Um, G4 = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              var Mt;
              b6(this, ct);
              for (var _t = arguments.length, Rn = new Array(_t), Pn = 0; Pn < _t; Pn++)
                Rn[Pn] = arguments[Pn];
              return (Mt = Nt.call.apply(Nt, [this].concat(Rn))).render = function() {
                var lr = F(Mt).props, Mn = [lr.name], ta = Ub;
                return Array.isArray(lr.src) && lr.groupArraysAfterLength && lr.src.length > lr.groupArraysAfterLength && (ta = $m), U.a.createElement("div", { className: "pretty-json-container object-container" }, U.a.createElement("div", { className: "object-content" }, U.a.createElement(ta, Object.assign({ namespace: Mn, depth: 0, jsvRoot: true }, lr))));
              }, Mt;
            }
            return ct;
          }(U.a.PureComponent), W4 = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).closeModal = function() {
                ja.dispatch({ rjvId: _t.props.rjvId, name: "RESET" });
              }, _t.submit = function() {
                _t.props.submit(_t.state.input);
              }, _t.state = { input: Mt.input ? Mt.input : "" }, _t;
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this, _t = this.props, Rn = _t.theme, Pn = _t.rjvId, lr = _t.isValid, Mn = this.state.input, ta = lr(Mn);
              return U.a.createElement("div", Object.assign({ className: "key-modal-request" }, Qe(Rn, "key-modal-request"), { onClick: this.closeModal }), U.a.createElement("div", Object.assign({}, Qe(Rn, "key-modal"), { onClick: function(di) {
                di.stopPropagation();
              } }), U.a.createElement("div", Qe(Rn, "key-modal-label"), "Key Name:"), U.a.createElement("div", { style: { position: "relative" } }, U.a.createElement("input", Object.assign({}, Qe(Rn, "key-modal-input"), { className: "key-modal-input", ref: function(di) {
                return di && di.focus();
              }, spellCheck: false, value: Mn, placeholder: "...", onChange: function(di) {
                Mt.setState({ input: di.target.value });
              }, onKeyPress: function(di) {
                ta && di.key === "Enter" ? Mt.submit() : di.key === "Escape" && Mt.closeModal();
              } })), ta ? U.a.createElement(Ac, Object.assign({}, Qe(Rn, "key-modal-submit"), { className: "key-modal-submit", onClick: function(di) {
                return Mt.submit();
              } })) : null), U.a.createElement("span", Qe(Rn, "key-modal-cancel"), U.a.createElement(kv, Object.assign({}, Qe(Rn, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                ja.dispatch({ rjvId: Pn, name: "RESET" });
              } })))));
            } }]), ct;
          }(U.a.PureComponent), H4 = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              var Mt;
              b6(this, ct);
              for (var _t = arguments.length, Rn = new Array(_t), Pn = 0; Pn < _t; Pn++)
                Rn[Pn] = arguments[Pn];
              return (Mt = Nt.call.apply(Nt, [this].concat(Rn))).isValid = function(lr) {
                var Mn = Mt.props.rjvId, ta = pa.get(Mn, "action", "new-key-request");
                return lr != "" && Object.keys(ta.existing_value).indexOf(lr) === -1;
              }, Mt.submit = function(lr) {
                var Mn = Mt.props.rjvId, ta = pa.get(Mn, "action", "new-key-request");
                ta.new_value = m6({}, ta.existing_value), ta.new_value[lr] = Mt.props.defaultValue, ja.dispatch({ name: "VARIABLE_ADDED", rjvId: Mn, data: ta });
              }, Mt;
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.active, Rn = Mt.theme, Pn = Mt.rjvId;
              return _t ? U.a.createElement(W4, { rjvId: Pn, theme: Rn, isValid: this.isValid, submit: this.submit }) : null;
            } }]), ct;
          }(U.a.PureComponent), $4 = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct() {
              return b6(this, ct), Nt.apply(this, arguments);
            }
            return S(ct, [{ key: "render", value: function() {
              var Mt = this.props, _t = Mt.message, Rn = Mt.active, Pn = Mt.theme, lr = Mt.rjvId;
              return Rn ? U.a.createElement("div", Object.assign({ className: "validation-failure" }, Qe(Pn, "validation-failure"), { onClick: function() {
                ja.dispatch({ rjvId: lr, name: "RESET" });
              } }), U.a.createElement("span", Qe(Pn, "validation-failure-label"), _t), U.a.createElement(kv, Qe(Pn, "validation-failure-clear"))) : null;
            } }]), ct;
          }(U.a.PureComponent), yS = function(Ot) {
            A6(ct, Ot);
            var Nt = $(ct);
            function ct(Mt) {
              var _t;
              return b6(this, ct), (_t = Nt.call(this, Mt)).rjvId = Date.now().toString(), _t.getListeners = function() {
                return { reset: _t.resetState, "variable-update": _t.updateSrc, "add-key-request": _t.addKeyRequest };
              }, _t.updateSrc = function() {
                var Rn, Pn = pa.get(_t.rjvId, "action", "variable-update"), lr = Pn.name, Mn = Pn.namespace, ta = Pn.new_value, di = Pn.existing_value, as = (Pn.variable_removed, Pn.updated_src), fo = Pn.type, Gl = _t.props, So = Gl.onEdit, kl = Gl.onDelete, Jl = Gl.onAdd, Mi = { existing_src: _t.state.src, new_value: ta, updated_src: as, name: lr, namespace: Mn, existing_value: di };
                switch (fo) {
                  case "variable-added":
                    Rn = Jl(Mi);
                    break;
                  case "variable-edited":
                    Rn = So(Mi);
                    break;
                  case "variable-removed":
                    Rn = kl(Mi);
                }
                Rn !== false ? (pa.set(_t.rjvId, "global", "src", as), _t.setState({ src: as })) : _t.setState({ validationFailure: true });
              }, _t.addKeyRequest = function() {
                _t.setState({ addKeyRequest: true });
              }, _t.resetState = function() {
                _t.setState({ validationFailure: false, addKeyRequest: false });
              }, _t.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: ct.defaultProps.src, name: ct.defaultProps.name, theme: ct.defaultProps.theme, validationMessage: ct.defaultProps.validationMessage, prevSrc: ct.defaultProps.src, prevName: ct.defaultProps.name, prevTheme: ct.defaultProps.theme }, _t;
            }
            return S(ct, [{ key: "componentDidMount", value: function() {
              pa.set(this.rjvId, "global", "src", this.state.src);
              var Mt = this.getListeners();
              for (var _t in Mt)
                pa.on(_t + "-" + this.rjvId, Mt[_t]);
              this.setState({ addKeyRequest: false, editKeyRequest: false });
            } }, { key: "componentDidUpdate", value: function(Mt, _t) {
              _t.addKeyRequest !== false && this.setState({ addKeyRequest: false }), _t.editKeyRequest !== false && this.setState({ editKeyRequest: false }), Mt.src !== this.state.src && pa.set(this.rjvId, "global", "src", this.state.src);
            } }, { key: "componentWillUnmount", value: function() {
              var Mt = this.getListeners();
              for (var _t in Mt)
                pa.removeListener(_t + "-" + this.rjvId, Mt[_t]);
            } }, { key: "render", value: function() {
              var Mt = this.state, _t = Mt.validationFailure, Rn = Mt.validationMessage, Pn = Mt.addKeyRequest, lr = Mt.theme, Mn = Mt.src, ta = Mt.name, di = this.props, as = di.style, fo = di.defaultValue;
              return U.a.createElement("div", { className: "react-json-view", style: m6(m6({}, Qe(lr, "app-container").style), as) }, U.a.createElement($4, { message: Rn, active: _t, theme: lr, rjvId: this.rjvId }), U.a.createElement(G4, Object.assign({}, this.props, { src: Mn, name: ta, theme: lr, type: Ae(Mn), rjvId: this.rjvId })), U.a.createElement(H4, { active: Pn, theme: lr, rjvId: this.rjvId, defaultValue: fo }));
            } }], [{ key: "getDerivedStateFromProps", value: function(Mt, _t) {
              if (Mt.src !== _t.prevSrc || Mt.name !== _t.prevName || Mt.theme !== _t.prevTheme) {
                var Rn = { src: Mt.src, name: Mt.name, theme: Mt.theme, validationMessage: Mt.validationMessage, prevSrc: Mt.src, prevName: Mt.name, prevTheme: Mt.theme };
                return ct.validateState(Rn);
              }
              return null;
            } }]), ct;
          }(U.a.PureComponent);
          yS.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, yS.validateState = function(Ot) {
            var Nt = {};
            return Ae(Ot.theme) !== "object" || function(ct) {
              var Mt = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
              if (Ae(ct) === "object") {
                for (var _t = 0; _t < Mt.length; _t++)
                  if (!(Mt[_t] in ct))
                    return false;
                return true;
              }
              return false;
            }(Ot.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Nt.theme = "rjv-default"), Ae(Ot.src) !== "object" && Ae(Ot.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Nt.name = "ERROR", Nt.src = { message: "src property must be a valid json object" }), m6(m6({}, Ot), Nt);
          }, _e(yS), u.default = yS;
        }]);
      });
    })(d_e);
    var lQe = Re(d_e.exports);
    const uQe = ({ id: a, title: r6, chart: t2, option: s }) => {
      const { tool: u } = $J({}), f6 = Qz({ global: true }), [d6, { set: v6 }] = N(true);
      console.log("option", s);
      const m6 = (b6) => {
        const { updated_src: x6 } = b6;
        t2 == null || t2.setOption(x6), u == null || u.add(a, t2, x6, r6), f6.emit("list");
      };
      return UJe("div", { children: [B5(JJe, { children: B5(nQe, { children: B5(aQe, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (b6) => {
        v6(!b6);
      } }) }) }), B5("br", {}), s && B5(lQe, { src: s, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: d6, iconStyle: "triangle", enableClipboard: true, onEdit: m6, onAdd: m6, onDelete: m6 })] });
    };
    i.EchartTool = sQe, i.ReactEchartsJson = uQe, i.useEcharts = SXe, i.useEchartsTool = $J, i.useEventEmitter = Qz;
  })(ODt);
  const RDt = () => {
    const i = tU({ global: true }), n2 = il.useRef(0), { tool: e2 } = kue({});
    il.useState(false), il.useState("right");
    const [o, l4] = il.useState([]), [c4, h] = il.useState();
    return i.useSubscription("list", () => {
      var p4;
      e2 != null && e2.list().length && (h((p4 = e2 == null ? void 0 : e2.list()) == null ? void 0 : p4[n2.current]), l4(e2 == null ? void 0 : e2.list()));
    }), m3("div", { className: LDt.container, children: false });
  };
  var oOe = { exports: {} };
  (function(i, n2) {
    (function(e2, o) {
      i.exports = o(P3.default);
    })(Dy, function(e2) {
      return function(o) {
        var l4 = {};
        function c4(h) {
          if (l4[h])
            return l4[h].exports;
          var p4 = l4[h] = { i: h, l: false, exports: {} };
          return o[h].call(p4.exports, p4, p4.exports, c4), p4.l = true, p4.exports;
        }
        return c4.m = o, c4.c = l4, c4.d = function(h, p4, g4) {
          c4.o(h, p4) || Object.defineProperty(h, p4, { enumerable: true, get: g4 });
        }, c4.r = function(h) {
          typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(h, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(h, "__esModule", { value: true });
        }, c4.t = function(h, p4) {
          if (1 & p4 && (h = c4(h)), 8 & p4 || 4 & p4 && typeof h == "object" && h && h.__esModule)
            return h;
          var g4 = /* @__PURE__ */ Object.create(null);
          if (c4.r(g4), Object.defineProperty(g4, "default", { enumerable: true, value: h }), 2 & p4 && typeof h != "string")
            for (var y4 in h)
              c4.d(g4, y4, function(_) {
                return h[_];
              }.bind(null, y4));
          return g4;
        }, c4.n = function(h) {
          var p4 = h && h.__esModule ? function() {
            return h.default;
          } : function() {
            return h;
          };
          return c4.d(p4, "a", p4), p4;
        }, c4.o = function(h, p4) {
          return Object.prototype.hasOwnProperty.call(h, p4);
        }, c4.p = "", c4(c4.s = 48);
      }([function(o, l4) {
        o.exports = e2;
      }, function(o, l4) {
        var c4 = o.exports = { version: "2.6.12" };
        typeof __e == "number" && (__e = c4);
      }, function(o, l4, c4) {
        var h = c4(26)("wks"), p4 = c4(17), g4 = c4(3).Symbol, y4 = typeof g4 == "function";
        (o.exports = function(_) {
          return h[_] || (h[_] = y4 && g4[_] || (y4 ? g4 : p4)("Symbol." + _));
        }).store = h;
      }, function(o, l4) {
        var c4 = o.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
        typeof __g == "number" && (__g = c4);
      }, function(o, l4, c4) {
        o.exports = !c4(8)(function() {
          return Object.defineProperty({}, "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(o, l4) {
        var c4 = {}.hasOwnProperty;
        o.exports = function(h, p4) {
          return c4.call(h, p4);
        };
      }, function(o, l4, c4) {
        var h = c4(7), p4 = c4(16);
        o.exports = c4(4) ? function(g4, y4, _) {
          return h.f(g4, y4, p4(1, _));
        } : function(g4, y4, _) {
          return g4[y4] = _, g4;
        };
      }, function(o, l4, c4) {
        var h = c4(10), p4 = c4(35), g4 = c4(23), y4 = Object.defineProperty;
        l4.f = c4(4) ? Object.defineProperty : function(_, w4, C) {
          if (h(_), w4 = g4(w4, true), h(C), p4)
            try {
              return y4(_, w4, C);
            } catch {
            }
          if ("get" in C || "set" in C)
            throw TypeError("Accessors not supported!");
          return "value" in C && (_[w4] = C.value), _;
        };
      }, function(o, l4) {
        o.exports = function(c4) {
          try {
            return !!c4();
          } catch {
            return true;
          }
        };
      }, function(o, l4, c4) {
        var h = c4(40), p4 = c4(22);
        o.exports = function(g4) {
          return h(p4(g4));
        };
      }, function(o, l4, c4) {
        var h = c4(11);
        o.exports = function(p4) {
          if (!h(p4))
            throw TypeError(p4 + " is not an object!");
          return p4;
        };
      }, function(o, l4) {
        o.exports = function(c4) {
          return typeof c4 == "object" ? c4 !== null : typeof c4 == "function";
        };
      }, function(o, l4) {
        o.exports = {};
      }, function(o, l4, c4) {
        var h = c4(39), p4 = c4(27);
        o.exports = Object.keys || function(g4) {
          return h(g4, p4);
        };
      }, function(o, l4) {
        o.exports = true;
      }, function(o, l4, c4) {
        var h = c4(3), p4 = c4(1), g4 = c4(53), y4 = c4(6), _ = c4(5), w4 = function(C, E, T) {
          var O, N, V, H = C & w4.F, X = C & w4.G, q2 = C & w4.S, de = C & w4.P, le = C & w4.B, me = C & w4.W, ye = X ? p4 : p4[E] || (p4[E] = {}), be = ye.prototype, we = X ? h : q2 ? h[E] : (h[E] || {}).prototype;
          for (O in X && (T = E), T)
            (N = !H && we && we[O] !== void 0) && _(ye, O) || (V = N ? we[O] : T[O], ye[O] = X && typeof we[O] != "function" ? T[O] : le && N ? g4(V, h) : me && we[O] == V ? function(Pe) {
              var ze = function(Re, rt2, ft) {
                if (this instanceof Pe) {
                  switch (arguments.length) {
                    case 0:
                      return new Pe();
                    case 1:
                      return new Pe(Re);
                    case 2:
                      return new Pe(Re, rt2);
                  }
                  return new Pe(Re, rt2, ft);
                }
                return Pe.apply(this, arguments);
              };
              return ze.prototype = Pe.prototype, ze;
            }(V) : de && typeof V == "function" ? g4(Function.call, V) : V, de && ((ye.virtual || (ye.virtual = {}))[O] = V, C & w4.R && be && !be[O] && y4(be, O, V)));
        };
        w4.F = 1, w4.G = 2, w4.S = 4, w4.P = 8, w4.B = 16, w4.W = 32, w4.U = 64, w4.R = 128, o.exports = w4;
      }, function(o, l4) {
        o.exports = function(c4, h) {
          return { enumerable: !(1 & c4), configurable: !(2 & c4), writable: !(4 & c4), value: h };
        };
      }, function(o, l4) {
        var c4 = 0, h = Math.random();
        o.exports = function(p4) {
          return "Symbol(".concat(p4 === void 0 ? "" : p4, ")_", (++c4 + h).toString(36));
        };
      }, function(o, l4, c4) {
        var h = c4(22);
        o.exports = function(p4) {
          return Object(h(p4));
        };
      }, function(o, l4) {
        l4.f = {}.propertyIsEnumerable;
      }, function(o, l4, c4) {
        var h = c4(52)(true);
        c4(34)(String, "String", function(p4) {
          this._t = String(p4), this._i = 0;
        }, function() {
          var p4, g4 = this._t, y4 = this._i;
          return y4 >= g4.length ? { value: void 0, done: true } : (p4 = h(g4, y4), this._i += p4.length, { value: p4, done: false });
        });
      }, function(o, l4) {
        var c4 = Math.ceil, h = Math.floor;
        o.exports = function(p4) {
          return isNaN(p4 = +p4) ? 0 : (p4 > 0 ? h : c4)(p4);
        };
      }, function(o, l4) {
        o.exports = function(c4) {
          if (c4 == null)
            throw TypeError("Can't call method on  " + c4);
          return c4;
        };
      }, function(o, l4, c4) {
        var h = c4(11);
        o.exports = function(p4, g4) {
          if (!h(p4))
            return p4;
          var y4, _;
          if (g4 && typeof (y4 = p4.toString) == "function" && !h(_ = y4.call(p4)) || typeof (y4 = p4.valueOf) == "function" && !h(_ = y4.call(p4)) || !g4 && typeof (y4 = p4.toString) == "function" && !h(_ = y4.call(p4)))
            return _;
          throw TypeError("Can't convert object to primitive value");
        };
      }, function(o, l4) {
        var c4 = {}.toString;
        o.exports = function(h) {
          return c4.call(h).slice(8, -1);
        };
      }, function(o, l4, c4) {
        var h = c4(26)("keys"), p4 = c4(17);
        o.exports = function(g4) {
          return h[g4] || (h[g4] = p4(g4));
        };
      }, function(o, l4, c4) {
        var h = c4(1), p4 = c4(3), g4 = p4["__core-js_shared__"] || (p4["__core-js_shared__"] = {});
        (o.exports = function(y4, _) {
          return g4[y4] || (g4[y4] = _ !== void 0 ? _ : {});
        })("versions", []).push({ version: h.version, mode: c4(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
      }, function(o, l4) {
        o.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
      }, function(o, l4, c4) {
        var h = c4(7).f, p4 = c4(5), g4 = c4(2)("toStringTag");
        o.exports = function(y4, _, w4) {
          y4 && !p4(y4 = w4 ? y4 : y4.prototype, g4) && h(y4, g4, { configurable: true, value: _ });
        };
      }, function(o, l4, c4) {
        c4(62);
        for (var h = c4(3), p4 = c4(6), g4 = c4(12), y4 = c4(2)("toStringTag"), _ = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), w4 = 0; w4 < _.length; w4++) {
          var C = _[w4], E = h[C], T = E && E.prototype;
          T && !T[y4] && p4(T, y4, C), g4[C] = g4.Array;
        }
      }, function(o, l4, c4) {
        l4.f = c4(2);
      }, function(o, l4, c4) {
        var h = c4(3), p4 = c4(1), g4 = c4(14), y4 = c4(30), _ = c4(7).f;
        o.exports = function(w4) {
          var C = p4.Symbol || (p4.Symbol = g4 ? {} : h.Symbol || {});
          w4.charAt(0) == "_" || w4 in C || _(C, w4, { value: y4.f(w4) });
        };
      }, function(o, l4) {
        l4.f = Object.getOwnPropertySymbols;
      }, function(o, l4) {
        o.exports = function(c4, h, p4) {
          return Math.min(Math.max(c4, h), p4);
        };
      }, function(o, l4, c4) {
        var h = c4(14), p4 = c4(15), g4 = c4(37), y4 = c4(6), _ = c4(12), w4 = c4(55), C = c4(28), E = c4(61), T = c4(2)("iterator"), O = !([].keys && "next" in [].keys()), N = function() {
          return this;
        };
        o.exports = function(V, H, X, q2, de, le, me) {
          w4(X, H, q2);
          var ye, be, we, Pe = function(Wt) {
            if (!O && Wt in ft)
              return ft[Wt];
            switch (Wt) {
              case "keys":
              case "values":
                return function() {
                  return new X(this, Wt);
                };
            }
            return function() {
              return new X(this, Wt);
            };
          }, ze = H + " Iterator", Re = de == "values", rt2 = false, ft = V.prototype, et = ft[T] || ft["@@iterator"] || de && ft[de], Jt = et || Pe(de), xt = de ? Re ? Pe("entries") : Jt : void 0, It = H == "Array" && ft.entries || et;
          if (It && (we = E(It.call(new V()))) !== Object.prototype && we.next && (C(we, ze, true), h || typeof we[T] == "function" || y4(we, T, N)), Re && et && et.name !== "values" && (rt2 = true, Jt = function() {
            return et.call(this);
          }), h && !me || !O && !rt2 && ft[T] || y4(ft, T, Jt), _[H] = Jt, _[ze] = N, de)
            if (ye = { values: Re ? Jt : Pe("values"), keys: le ? Jt : Pe("keys"), entries: xt }, me)
              for (be in ye)
                be in ft || g4(ft, be, ye[be]);
            else
              p4(p4.P + p4.F * (O || rt2), H, ye);
          return ye;
        };
      }, function(o, l4, c4) {
        o.exports = !c4(4) && !c4(8)(function() {
          return Object.defineProperty(c4(36)("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(o, l4, c4) {
        var h = c4(11), p4 = c4(3).document, g4 = h(p4) && h(p4.createElement);
        o.exports = function(y4) {
          return g4 ? p4.createElement(y4) : {};
        };
      }, function(o, l4, c4) {
        o.exports = c4(6);
      }, function(o, l4, c4) {
        var h = c4(10), p4 = c4(56), g4 = c4(27), y4 = c4(25)("IE_PROTO"), _ = function() {
        }, w4 = function() {
          var C, E = c4(36)("iframe"), T = g4.length;
          for (E.style.display = "none", c4(60).appendChild(E), E.src = "javascript:", (C = E.contentWindow.document).open(), C.write("<script>document.F=Object<\/script>"), C.close(), w4 = C.F; T--; )
            delete w4.prototype[g4[T]];
          return w4();
        };
        o.exports = Object.create || function(C, E) {
          var T;
          return C !== null ? (_.prototype = h(C), T = new _(), _.prototype = null, T[y4] = C) : T = w4(), E === void 0 ? T : p4(T, E);
        };
      }, function(o, l4, c4) {
        var h = c4(5), p4 = c4(9), g4 = c4(57)(false), y4 = c4(25)("IE_PROTO");
        o.exports = function(_, w4) {
          var C, E = p4(_), T = 0, O = [];
          for (C in E)
            C != y4 && h(E, C) && O.push(C);
          for (; w4.length > T; )
            h(E, C = w4[T++]) && (~g4(O, C) || O.push(C));
          return O;
        };
      }, function(o, l4, c4) {
        var h = c4(24);
        o.exports = Object("z").propertyIsEnumerable(0) ? Object : function(p4) {
          return h(p4) == "String" ? p4.split("") : Object(p4);
        };
      }, function(o, l4, c4) {
        var h = c4(39), p4 = c4(27).concat("length", "prototype");
        l4.f = Object.getOwnPropertyNames || function(g4) {
          return h(g4, p4);
        };
      }, function(o, l4, c4) {
        var h = c4(24), p4 = c4(2)("toStringTag"), g4 = h(function() {
          return arguments;
        }()) == "Arguments";
        o.exports = function(y4) {
          var _, w4, C;
          return y4 === void 0 ? "Undefined" : y4 === null ? "Null" : typeof (w4 = function(E, T) {
            try {
              return E[T];
            } catch {
            }
          }(_ = Object(y4), p4)) == "string" ? w4 : g4 ? h(_) : (C = h(_)) == "Object" && typeof _.callee == "function" ? "Arguments" : C;
        };
      }, function(o, l4) {
        var c4;
        c4 = function() {
          return this;
        }();
        try {
          c4 = c4 || new Function("return this")();
        } catch {
          typeof window == "object" && (c4 = window);
        }
        o.exports = c4;
      }, function(o, l4) {
        var c4 = /-?\d+(\.\d+)?%?/g;
        o.exports = function(h) {
          return h.match(c4);
        };
      }, function(o, l4, c4) {
        Object.defineProperty(l4, "__esModule", { value: true }), l4.getBase16Theme = l4.createStyling = l4.invertTheme = void 0;
        var h = N(c4(49)), p4 = N(c4(76)), g4 = N(c4(81)), y4 = N(c4(89)), _ = N(c4(93)), w4 = function(be) {
          if (be && be.__esModule)
            return be;
          var we = {};
          if (be != null)
            for (var Pe in be)
              Object.prototype.hasOwnProperty.call(be, Pe) && (we[Pe] = be[Pe]);
          return we.default = be, we;
        }(c4(94)), C = N(c4(132)), E = N(c4(133)), T = N(c4(138)), O = c4(139);
        function N(be) {
          return be && be.__esModule ? be : { default: be };
        }
        var V = w4.default, H = (0, y4.default)(V), X = (0, T.default)(E.default, O.rgb2yuv, function(be) {
          var we, Pe = (0, g4.default)(be, 3), ze = Pe[0], Re = Pe[1], rt2 = Pe[2];
          return [(we = ze, we < 0.25 ? 1 : we < 0.5 ? 0.9 - we : 1.1 - we), Re, rt2];
        }, O.yuv2rgb, C.default), q2 = function(be) {
          return function(we) {
            return { className: [we.className, be.className].filter(Boolean).join(" "), style: (0, p4.default)({}, we.style || {}, be.style || {}) };
          };
        }, de = function(be, we) {
          var Pe = (0, y4.default)(we);
          for (var ze in be)
            Pe.indexOf(ze) === -1 && Pe.push(ze);
          return Pe.reduce(function(Re, rt2) {
            return Re[rt2] = function(ft, et) {
              if (ft === void 0)
                return et;
              if (et === void 0)
                return ft;
              var Jt = ft === void 0 ? "undefined" : (0, h.default)(ft), xt = et === void 0 ? "undefined" : (0, h.default)(et);
              switch (Jt) {
                case "string":
                  switch (xt) {
                    case "string":
                      return [et, ft].filter(Boolean).join(" ");
                    case "object":
                      return q2({ className: ft, style: et });
                    case "function":
                      return function(It) {
                        for (var Wt = arguments.length, sn = Array(Wt > 1 ? Wt - 1 : 0), vn = 1; vn < Wt; vn++)
                          sn[vn - 1] = arguments[vn];
                        return q2({ className: ft })(et.apply(void 0, [It].concat(sn)));
                      };
                  }
                case "object":
                  switch (xt) {
                    case "string":
                      return q2({ className: et, style: ft });
                    case "object":
                      return (0, p4.default)({}, et, ft);
                    case "function":
                      return function(It) {
                        for (var Wt = arguments.length, sn = Array(Wt > 1 ? Wt - 1 : 0), vn = 1; vn < Wt; vn++)
                          sn[vn - 1] = arguments[vn];
                        return q2({ style: ft })(et.apply(void 0, [It].concat(sn)));
                      };
                  }
                case "function":
                  switch (xt) {
                    case "string":
                      return function(It) {
                        for (var Wt = arguments.length, sn = Array(Wt > 1 ? Wt - 1 : 0), vn = 1; vn < Wt; vn++)
                          sn[vn - 1] = arguments[vn];
                        return ft.apply(void 0, [q2(It)({ className: et })].concat(sn));
                      };
                    case "object":
                      return function(It) {
                        for (var Wt = arguments.length, sn = Array(Wt > 1 ? Wt - 1 : 0), vn = 1; vn < Wt; vn++)
                          sn[vn - 1] = arguments[vn];
                        return ft.apply(void 0, [q2(It)({ style: et })].concat(sn));
                      };
                    case "function":
                      return function(It) {
                        for (var Wt = arguments.length, sn = Array(Wt > 1 ? Wt - 1 : 0), vn = 1; vn < Wt; vn++)
                          sn[vn - 1] = arguments[vn];
                        return ft.apply(void 0, [et.apply(void 0, [It].concat(sn))].concat(sn));
                      };
                  }
              }
            }(be[rt2], we[rt2]), Re;
          }, {});
        }, le = function(be, we) {
          for (var Pe = arguments.length, ze = Array(Pe > 2 ? Pe - 2 : 0), Re = 2; Re < Pe; Re++)
            ze[Re - 2] = arguments[Re];
          if (we === null)
            return be;
          Array.isArray(we) || (we = [we]);
          var rt2 = we.map(function(et) {
            return be[et];
          }).filter(Boolean), ft = rt2.reduce(function(et, Jt) {
            return typeof Jt == "string" ? et.className = [et.className, Jt].filter(Boolean).join(" ") : (Jt === void 0 ? "undefined" : (0, h.default)(Jt)) === "object" ? et.style = (0, p4.default)({}, et.style, Jt) : typeof Jt == "function" && (et = (0, p4.default)({}, et, Jt.apply(void 0, [et].concat(ze)))), et;
          }, { className: "", style: {} });
          return ft.className || delete ft.className, (0, y4.default)(ft.style).length === 0 && delete ft.style, ft;
        }, me = l4.invertTheme = function(be) {
          return (0, y4.default)(be).reduce(function(we, Pe) {
            return we[Pe] = /^base/.test(Pe) ? X(be[Pe]) : Pe === "scheme" ? be[Pe] + ":inverted" : be[Pe], we;
          }, {});
        }, ye = (l4.createStyling = (0, _.default)(function(be) {
          for (var we = arguments.length, Pe = Array(we > 3 ? we - 3 : 0), ze = 3; ze < we; ze++)
            Pe[ze - 3] = arguments[ze];
          var Re = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, rt2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, ft = Re.defaultBase16, et = ft === void 0 ? V : ft, Jt = Re.base16Themes, xt = Jt === void 0 ? null : Jt, It = ye(rt2, xt);
          It && (rt2 = (0, p4.default)({}, It, rt2));
          var Wt = H.reduce(function(ga, Za) {
            return ga[Za] = rt2[Za] || et[Za], ga;
          }, {}), sn = (0, y4.default)(rt2).reduce(function(ga, Za) {
            return H.indexOf(Za) === -1 && (ga[Za] = rt2[Za]), ga;
          }, {}), vn = be(Wt), $r = de(sn, vn);
          return (0, _.default)(le, 2).apply(void 0, [$r].concat(Pe));
        }, 3), l4.getBase16Theme = function(be, we) {
          if (be && be.extend && (be = be.extend), typeof be == "string") {
            var Pe = be.split(":"), ze = (0, g4.default)(Pe, 2), Re = ze[0], rt2 = ze[1];
            be = (we || {})[Re] || w4[Re], rt2 === "inverted" && (be = me(be));
          }
          return be && be.hasOwnProperty("base00") ? be : void 0;
        });
      }, function(o, l4, c4) {
        var h, p4 = typeof Reflect == "object" ? Reflect : null, g4 = p4 && typeof p4.apply == "function" ? p4.apply : function(q2, de, le) {
          return Function.prototype.apply.call(q2, de, le);
        };
        h = p4 && typeof p4.ownKeys == "function" ? p4.ownKeys : Object.getOwnPropertySymbols ? function(q2) {
          return Object.getOwnPropertyNames(q2).concat(Object.getOwnPropertySymbols(q2));
        } : function(q2) {
          return Object.getOwnPropertyNames(q2);
        };
        var y4 = Number.isNaN || function(q2) {
          return q2 != q2;
        };
        function _() {
          _.init.call(this);
        }
        o.exports = _, o.exports.once = function(q2, de) {
          return new Promise(function(le, me) {
            function ye() {
              be !== void 0 && q2.removeListener("error", be), le([].slice.call(arguments));
            }
            var be;
            de !== "error" && (be = function(we) {
              q2.removeListener(de, ye), me(we);
            }, q2.once("error", be)), q2.once(de, ye);
          });
        }, _.EventEmitter = _, _.prototype._events = void 0, _.prototype._eventsCount = 0, _.prototype._maxListeners = void 0;
        var w4 = 10;
        function C(q2) {
          if (typeof q2 != "function")
            throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof q2);
        }
        function E(q2) {
          return q2._maxListeners === void 0 ? _.defaultMaxListeners : q2._maxListeners;
        }
        function T(q2, de, le, me) {
          var ye, be, we, Pe;
          if (C(le), (be = q2._events) === void 0 ? (be = q2._events = /* @__PURE__ */ Object.create(null), q2._eventsCount = 0) : (be.newListener !== void 0 && (q2.emit("newListener", de, le.listener ? le.listener : le), be = q2._events), we = be[de]), we === void 0)
            we = be[de] = le, ++q2._eventsCount;
          else if (typeof we == "function" ? we = be[de] = me ? [le, we] : [we, le] : me ? we.unshift(le) : we.push(le), (ye = E(q2)) > 0 && we.length > ye && !we.warned) {
            we.warned = true;
            var ze = new Error("Possible EventEmitter memory leak detected. " + we.length + " " + String(de) + " listeners added. Use emitter.setMaxListeners() to increase limit");
            ze.name = "MaxListenersExceededWarning", ze.emitter = q2, ze.type = de, ze.count = we.length, Pe = ze, console && console.warn && console.warn(Pe);
          }
          return q2;
        }
        function O() {
          if (!this.fired)
            return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
        }
        function N(q2, de, le) {
          var me = { fired: false, wrapFn: void 0, target: q2, type: de, listener: le }, ye = O.bind(me);
          return ye.listener = le, me.wrapFn = ye, ye;
        }
        function V(q2, de, le) {
          var me = q2._events;
          if (me === void 0)
            return [];
          var ye = me[de];
          return ye === void 0 ? [] : typeof ye == "function" ? le ? [ye.listener || ye] : [ye] : le ? function(be) {
            for (var we = new Array(be.length), Pe = 0; Pe < we.length; ++Pe)
              we[Pe] = be[Pe].listener || be[Pe];
            return we;
          }(ye) : X(ye, ye.length);
        }
        function H(q2) {
          var de = this._events;
          if (de !== void 0) {
            var le = de[q2];
            if (typeof le == "function")
              return 1;
            if (le !== void 0)
              return le.length;
          }
          return 0;
        }
        function X(q2, de) {
          for (var le = new Array(de), me = 0; me < de; ++me)
            le[me] = q2[me];
          return le;
        }
        Object.defineProperty(_, "defaultMaxListeners", { enumerable: true, get: function() {
          return w4;
        }, set: function(q2) {
          if (typeof q2 != "number" || q2 < 0 || y4(q2))
            throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + q2 + ".");
          w4 = q2;
        } }), _.init = function() {
          this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
        }, _.prototype.setMaxListeners = function(q2) {
          if (typeof q2 != "number" || q2 < 0 || y4(q2))
            throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + q2 + ".");
          return this._maxListeners = q2, this;
        }, _.prototype.getMaxListeners = function() {
          return E(this);
        }, _.prototype.emit = function(q2) {
          for (var de = [], le = 1; le < arguments.length; le++)
            de.push(arguments[le]);
          var me = q2 === "error", ye = this._events;
          if (ye !== void 0)
            me = me && ye.error === void 0;
          else if (!me)
            return false;
          if (me) {
            var be;
            if (de.length > 0 && (be = de[0]), be instanceof Error)
              throw be;
            var we = new Error("Unhandled error." + (be ? " (" + be.message + ")" : ""));
            throw we.context = be, we;
          }
          var Pe = ye[q2];
          if (Pe === void 0)
            return false;
          if (typeof Pe == "function")
            g4(Pe, this, de);
          else {
            var ze = Pe.length, Re = X(Pe, ze);
            for (le = 0; le < ze; ++le)
              g4(Re[le], this, de);
          }
          return true;
        }, _.prototype.addListener = function(q2, de) {
          return T(this, q2, de, false);
        }, _.prototype.on = _.prototype.addListener, _.prototype.prependListener = function(q2, de) {
          return T(this, q2, de, true);
        }, _.prototype.once = function(q2, de) {
          return C(de), this.on(q2, N(this, q2, de)), this;
        }, _.prototype.prependOnceListener = function(q2, de) {
          return C(de), this.prependListener(q2, N(this, q2, de)), this;
        }, _.prototype.removeListener = function(q2, de) {
          var le, me, ye, be, we;
          if (C(de), (me = this._events) === void 0)
            return this;
          if ((le = me[q2]) === void 0)
            return this;
          if (le === de || le.listener === de)
            --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete me[q2], me.removeListener && this.emit("removeListener", q2, le.listener || de));
          else if (typeof le != "function") {
            for (ye = -1, be = le.length - 1; be >= 0; be--)
              if (le[be] === de || le[be].listener === de) {
                we = le[be].listener, ye = be;
                break;
              }
            if (ye < 0)
              return this;
            ye === 0 ? le.shift() : function(Pe, ze) {
              for (; ze + 1 < Pe.length; ze++)
                Pe[ze] = Pe[ze + 1];
              Pe.pop();
            }(le, ye), le.length === 1 && (me[q2] = le[0]), me.removeListener !== void 0 && this.emit("removeListener", q2, we || de);
          }
          return this;
        }, _.prototype.off = _.prototype.removeListener, _.prototype.removeAllListeners = function(q2) {
          var de, le, me;
          if ((le = this._events) === void 0)
            return this;
          if (le.removeListener === void 0)
            return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : le[q2] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete le[q2]), this;
          if (arguments.length === 0) {
            var ye, be = Object.keys(le);
            for (me = 0; me < be.length; ++me)
              (ye = be[me]) !== "removeListener" && this.removeAllListeners(ye);
            return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
          }
          if (typeof (de = le[q2]) == "function")
            this.removeListener(q2, de);
          else if (de !== void 0)
            for (me = de.length - 1; me >= 0; me--)
              this.removeListener(q2, de[me]);
          return this;
        }, _.prototype.listeners = function(q2) {
          return V(this, q2, true);
        }, _.prototype.rawListeners = function(q2) {
          return V(this, q2, false);
        }, _.listenerCount = function(q2, de) {
          return typeof q2.listenerCount == "function" ? q2.listenerCount(de) : H.call(q2, de);
        }, _.prototype.listenerCount = H, _.prototype.eventNames = function() {
          return this._eventsCount > 0 ? h(this._events) : [];
        };
      }, function(o, l4, c4) {
        o.exports.Dispatcher = c4(140);
      }, function(o, l4, c4) {
        o.exports = c4(142);
      }, function(o, l4, c4) {
        l4.__esModule = true;
        var h = y4(c4(50)), p4 = y4(c4(65)), g4 = typeof p4.default == "function" && typeof h.default == "symbol" ? function(_) {
          return typeof _;
        } : function(_) {
          return _ && typeof p4.default == "function" && _.constructor === p4.default && _ !== p4.default.prototype ? "symbol" : typeof _;
        };
        function y4(_) {
          return _ && _.__esModule ? _ : { default: _ };
        }
        l4.default = typeof p4.default == "function" && g4(h.default) === "symbol" ? function(_) {
          return _ === void 0 ? "undefined" : g4(_);
        } : function(_) {
          return _ && typeof p4.default == "function" && _.constructor === p4.default && _ !== p4.default.prototype ? "symbol" : _ === void 0 ? "undefined" : g4(_);
        };
      }, function(o, l4, c4) {
        o.exports = { default: c4(51), __esModule: true };
      }, function(o, l4, c4) {
        c4(20), c4(29), o.exports = c4(30).f("iterator");
      }, function(o, l4, c4) {
        var h = c4(21), p4 = c4(22);
        o.exports = function(g4) {
          return function(y4, _) {
            var w4, C, E = String(p4(y4)), T = h(_), O = E.length;
            return T < 0 || T >= O ? g4 ? "" : void 0 : (w4 = E.charCodeAt(T)) < 55296 || w4 > 56319 || T + 1 === O || (C = E.charCodeAt(T + 1)) < 56320 || C > 57343 ? g4 ? E.charAt(T) : w4 : g4 ? E.slice(T, T + 2) : C - 56320 + (w4 - 55296 << 10) + 65536;
          };
        };
      }, function(o, l4, c4) {
        var h = c4(54);
        o.exports = function(p4, g4, y4) {
          if (h(p4), g4 === void 0)
            return p4;
          switch (y4) {
            case 1:
              return function(_) {
                return p4.call(g4, _);
              };
            case 2:
              return function(_, w4) {
                return p4.call(g4, _, w4);
              };
            case 3:
              return function(_, w4, C) {
                return p4.call(g4, _, w4, C);
              };
          }
          return function() {
            return p4.apply(g4, arguments);
          };
        };
      }, function(o, l4) {
        o.exports = function(c4) {
          if (typeof c4 != "function")
            throw TypeError(c4 + " is not a function!");
          return c4;
        };
      }, function(o, l4, c4) {
        var h = c4(38), p4 = c4(16), g4 = c4(28), y4 = {};
        c4(6)(y4, c4(2)("iterator"), function() {
          return this;
        }), o.exports = function(_, w4, C) {
          _.prototype = h(y4, { next: p4(1, C) }), g4(_, w4 + " Iterator");
        };
      }, function(o, l4, c4) {
        var h = c4(7), p4 = c4(10), g4 = c4(13);
        o.exports = c4(4) ? Object.defineProperties : function(y4, _) {
          p4(y4);
          for (var w4, C = g4(_), E = C.length, T = 0; E > T; )
            h.f(y4, w4 = C[T++], _[w4]);
          return y4;
        };
      }, function(o, l4, c4) {
        var h = c4(9), p4 = c4(58), g4 = c4(59);
        o.exports = function(y4) {
          return function(_, w4, C) {
            var E, T = h(_), O = p4(T.length), N = g4(C, O);
            if (y4 && w4 != w4) {
              for (; O > N; )
                if ((E = T[N++]) != E)
                  return true;
            } else
              for (; O > N; N++)
                if ((y4 || N in T) && T[N] === w4)
                  return y4 || N || 0;
            return !y4 && -1;
          };
        };
      }, function(o, l4, c4) {
        var h = c4(21), p4 = Math.min;
        o.exports = function(g4) {
          return g4 > 0 ? p4(h(g4), 9007199254740991) : 0;
        };
      }, function(o, l4, c4) {
        var h = c4(21), p4 = Math.max, g4 = Math.min;
        o.exports = function(y4, _) {
          return (y4 = h(y4)) < 0 ? p4(y4 + _, 0) : g4(y4, _);
        };
      }, function(o, l4, c4) {
        var h = c4(3).document;
        o.exports = h && h.documentElement;
      }, function(o, l4, c4) {
        var h = c4(5), p4 = c4(18), g4 = c4(25)("IE_PROTO"), y4 = Object.prototype;
        o.exports = Object.getPrototypeOf || function(_) {
          return _ = p4(_), h(_, g4) ? _[g4] : typeof _.constructor == "function" && _ instanceof _.constructor ? _.constructor.prototype : _ instanceof Object ? y4 : null;
        };
      }, function(o, l4, c4) {
        var h = c4(63), p4 = c4(64), g4 = c4(12), y4 = c4(9);
        o.exports = c4(34)(Array, "Array", function(_, w4) {
          this._t = y4(_), this._i = 0, this._k = w4;
        }, function() {
          var _ = this._t, w4 = this._k, C = this._i++;
          return !_ || C >= _.length ? (this._t = void 0, p4(1)) : p4(0, w4 == "keys" ? C : w4 == "values" ? _[C] : [C, _[C]]);
        }, "values"), g4.Arguments = g4.Array, h("keys"), h("values"), h("entries");
      }, function(o, l4) {
        o.exports = function() {
        };
      }, function(o, l4) {
        o.exports = function(c4, h) {
          return { value: h, done: !!c4 };
        };
      }, function(o, l4, c4) {
        o.exports = { default: c4(66), __esModule: true };
      }, function(o, l4, c4) {
        c4(67), c4(73), c4(74), c4(75), o.exports = c4(1).Symbol;
      }, function(o, l4, c4) {
        var h = c4(3), p4 = c4(5), g4 = c4(4), y4 = c4(15), _ = c4(37), w4 = c4(68).KEY, C = c4(8), E = c4(26), T = c4(28), O = c4(17), N = c4(2), V = c4(30), H = c4(31), X = c4(69), q2 = c4(70), de = c4(10), le = c4(11), me = c4(18), ye = c4(9), be = c4(23), we = c4(16), Pe = c4(38), ze = c4(71), Re = c4(72), rt2 = c4(32), ft = c4(7), et = c4(13), Jt = Re.f, xt = ft.f, It = ze.f, Wt = h.Symbol, sn = h.JSON, vn = sn && sn.stringify, $r = N("_hidden"), ga = N("toPrimitive"), Za = {}.propertyIsEnumerable, $a = E("symbol-registry"), Pa = E("symbols"), da = E("op-symbols"), Ra = Object.prototype, Wa = typeof Wt == "function" && !!rt2.f, wa = h.QObject, li = !wa || !wa.prototype || !wa.prototype.findChild, Ts = g4 && C(function() {
          return Pe(xt({}, "a", { get: function() {
            return xt(this, "a", { value: 7 }).a;
          } })).a != 7;
        }) ? function(Bn, Fr, Oa) {
          var yi = Jt(Ra, Fr);
          yi && delete Ra[Fr], xt(Bn, Fr, Oa), yi && Bn !== Ra && xt(Ra, Fr, yi);
        } : xt, wi = function(Bn) {
          var Fr = Pa[Bn] = Pe(Wt.prototype);
          return Fr._k = Bn, Fr;
        }, ps = Wa && typeof Wt.iterator == "symbol" ? function(Bn) {
          return typeof Bn == "symbol";
        } : function(Bn) {
          return Bn instanceof Wt;
        }, Bs = function(Bn, Fr, Oa) {
          return Bn === Ra && Bs(da, Fr, Oa), de(Bn), Fr = be(Fr, true), de(Oa), p4(Pa, Fr) ? (Oa.enumerable ? (p4(Bn, $r) && Bn[$r][Fr] && (Bn[$r][Fr] = false), Oa = Pe(Oa, { enumerable: we(0, false) })) : (p4(Bn, $r) || xt(Bn, $r, we(1, {})), Bn[$r][Fr] = true), Ts(Bn, Fr, Oa)) : xt(Bn, Fr, Oa);
        }, vl = function(Bn, Fr) {
          de(Bn);
          for (var Oa, yi = X(Fr = ye(Fr)), Bo = 0, jo = yi.length; jo > Bo; )
            Bs(Bn, Oa = yi[Bo++], Fr[Oa]);
          return Bn;
        }, If = function(Bn) {
          var Fr = Za.call(this, Bn = be(Bn, true));
          return !(this === Ra && p4(Pa, Bn) && !p4(da, Bn)) && (!(Fr || !p4(this, Bn) || !p4(Pa, Bn) || p4(this, $r) && this[$r][Bn]) || Fr);
        }, Xl = function(Bn, Fr) {
          if (Bn = ye(Bn), Fr = be(Fr, true), Bn !== Ra || !p4(Pa, Fr) || p4(da, Fr)) {
            var Oa = Jt(Bn, Fr);
            return !Oa || !p4(Pa, Fr) || p4(Bn, $r) && Bn[$r][Fr] || (Oa.enumerable = true), Oa;
          }
        }, _h = function(Bn) {
          for (var Fr, Oa = It(ye(Bn)), yi = [], Bo = 0; Oa.length > Bo; )
            p4(Pa, Fr = Oa[Bo++]) || Fr == $r || Fr == w4 || yi.push(Fr);
          return yi;
        }, Nl = function(Bn) {
          for (var Fr, Oa = Bn === Ra, yi = It(Oa ? da : ye(Bn)), Bo = [], jo = 0; yi.length > jo; )
            !p4(Pa, Fr = yi[jo++]) || Oa && !p4(Ra, Fr) || Bo.push(Pa[Fr]);
          return Bo;
        };
        Wa || (_((Wt = function() {
          if (this instanceof Wt)
            throw TypeError("Symbol is not a constructor!");
          var Bn = O(arguments.length > 0 ? arguments[0] : void 0), Fr = function(Oa) {
            this === Ra && Fr.call(da, Oa), p4(this, $r) && p4(this[$r], Bn) && (this[$r][Bn] = false), Ts(this, Bn, we(1, Oa));
          };
          return g4 && li && Ts(Ra, Bn, { configurable: true, set: Fr }), wi(Bn);
        }).prototype, "toString", function() {
          return this._k;
        }), Re.f = Xl, ft.f = Bs, c4(41).f = ze.f = _h, c4(19).f = If, rt2.f = Nl, g4 && !c4(14) && _(Ra, "propertyIsEnumerable", If, true), V.f = function(Bn) {
          return wi(N(Bn));
        }), y4(y4.G + y4.W + y4.F * !Wa, { Symbol: Wt });
        for (var Uc = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Nu = 0; Uc.length > Nu; )
          N(Uc[Nu++]);
        for (var om = et(N.store), Rr = 0; om.length > Rr; )
          H(om[Rr++]);
        y4(y4.S + y4.F * !Wa, "Symbol", { for: function(Bn) {
          return p4($a, Bn += "") ? $a[Bn] : $a[Bn] = Wt(Bn);
        }, keyFor: function(Bn) {
          if (!ps(Bn))
            throw TypeError(Bn + " is not a symbol!");
          for (var Fr in $a)
            if ($a[Fr] === Bn)
              return Fr;
        }, useSetter: function() {
          li = true;
        }, useSimple: function() {
          li = false;
        } }), y4(y4.S + y4.F * !Wa, "Object", { create: function(Bn, Fr) {
          return Fr === void 0 ? Pe(Bn) : vl(Pe(Bn), Fr);
        }, defineProperty: Bs, defineProperties: vl, getOwnPropertyDescriptor: Xl, getOwnPropertyNames: _h, getOwnPropertySymbols: Nl });
        var $n = C(function() {
          rt2.f(1);
        });
        y4(y4.S + y4.F * $n, "Object", { getOwnPropertySymbols: function(Bn) {
          return rt2.f(me(Bn));
        } }), sn && y4(y4.S + y4.F * (!Wa || C(function() {
          var Bn = Wt();
          return vn([Bn]) != "[null]" || vn({ a: Bn }) != "{}" || vn(Object(Bn)) != "{}";
        })), "JSON", { stringify: function(Bn) {
          for (var Fr, Oa, yi = [Bn], Bo = 1; arguments.length > Bo; )
            yi.push(arguments[Bo++]);
          if (Oa = Fr = yi[1], (le(Fr) || Bn !== void 0) && !ps(Bn))
            return q2(Fr) || (Fr = function(jo, xl) {
              if (typeof Oa == "function" && (xl = Oa.call(this, jo, xl)), !ps(xl))
                return xl;
            }), yi[1] = Fr, vn.apply(sn, yi);
        } }), Wt.prototype[ga] || c4(6)(Wt.prototype, ga, Wt.prototype.valueOf), T(Wt, "Symbol"), T(Math, "Math", true), T(h.JSON, "JSON", true);
      }, function(o, l4, c4) {
        var h = c4(17)("meta"), p4 = c4(11), g4 = c4(5), y4 = c4(7).f, _ = 0, w4 = Object.isExtensible || function() {
          return true;
        }, C = !c4(8)(function() {
          return w4(Object.preventExtensions({}));
        }), E = function(O) {
          y4(O, h, { value: { i: "O" + ++_, w: {} } });
        }, T = o.exports = { KEY: h, NEED: false, fastKey: function(O, N) {
          if (!p4(O))
            return typeof O == "symbol" ? O : (typeof O == "string" ? "S" : "P") + O;
          if (!g4(O, h)) {
            if (!w4(O))
              return "F";
            if (!N)
              return "E";
            E(O);
          }
          return O[h].i;
        }, getWeak: function(O, N) {
          if (!g4(O, h)) {
            if (!w4(O))
              return true;
            if (!N)
              return false;
            E(O);
          }
          return O[h].w;
        }, onFreeze: function(O) {
          return C && T.NEED && w4(O) && !g4(O, h) && E(O), O;
        } };
      }, function(o, l4, c4) {
        var h = c4(13), p4 = c4(32), g4 = c4(19);
        o.exports = function(y4) {
          var _ = h(y4), w4 = p4.f;
          if (w4)
            for (var C, E = w4(y4), T = g4.f, O = 0; E.length > O; )
              T.call(y4, C = E[O++]) && _.push(C);
          return _;
        };
      }, function(o, l4, c4) {
        var h = c4(24);
        o.exports = Array.isArray || function(p4) {
          return h(p4) == "Array";
        };
      }, function(o, l4, c4) {
        var h = c4(9), p4 = c4(41).f, g4 = {}.toString, y4 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
        o.exports.f = function(_) {
          return y4 && g4.call(_) == "[object Window]" ? function(w4) {
            try {
              return p4(w4);
            } catch {
              return y4.slice();
            }
          }(_) : p4(h(_));
        };
      }, function(o, l4, c4) {
        var h = c4(19), p4 = c4(16), g4 = c4(9), y4 = c4(23), _ = c4(5), w4 = c4(35), C = Object.getOwnPropertyDescriptor;
        l4.f = c4(4) ? C : function(E, T) {
          if (E = g4(E), T = y4(T, true), w4)
            try {
              return C(E, T);
            } catch {
            }
          if (_(E, T))
            return p4(!h.f.call(E, T), E[T]);
        };
      }, function(o, l4) {
      }, function(o, l4, c4) {
        c4(31)("asyncIterator");
      }, function(o, l4, c4) {
        c4(31)("observable");
      }, function(o, l4, c4) {
        l4.__esModule = true;
        var h, p4 = c4(77), g4 = (h = p4) && h.__esModule ? h : { default: h };
        l4.default = g4.default || function(y4) {
          for (var _ = 1; _ < arguments.length; _++) {
            var w4 = arguments[_];
            for (var C in w4)
              Object.prototype.hasOwnProperty.call(w4, C) && (y4[C] = w4[C]);
          }
          return y4;
        };
      }, function(o, l4, c4) {
        o.exports = { default: c4(78), __esModule: true };
      }, function(o, l4, c4) {
        c4(79), o.exports = c4(1).Object.assign;
      }, function(o, l4, c4) {
        var h = c4(15);
        h(h.S + h.F, "Object", { assign: c4(80) });
      }, function(o, l4, c4) {
        var h = c4(4), p4 = c4(13), g4 = c4(32), y4 = c4(19), _ = c4(18), w4 = c4(40), C = Object.assign;
        o.exports = !C || c4(8)(function() {
          var E = {}, T = {}, O = Symbol(), N = "abcdefghijklmnopqrst";
          return E[O] = 7, N.split("").forEach(function(V) {
            T[V] = V;
          }), C({}, E)[O] != 7 || Object.keys(C({}, T)).join("") != N;
        }) ? function(E, T) {
          for (var O = _(E), N = arguments.length, V = 1, H = g4.f, X = y4.f; N > V; )
            for (var q2, de = w4(arguments[V++]), le = H ? p4(de).concat(H(de)) : p4(de), me = le.length, ye = 0; me > ye; )
              q2 = le[ye++], h && !X.call(de, q2) || (O[q2] = de[q2]);
          return O;
        } : C;
      }, function(o, l4, c4) {
        l4.__esModule = true;
        var h = g4(c4(82)), p4 = g4(c4(85));
        function g4(y4) {
          return y4 && y4.__esModule ? y4 : { default: y4 };
        }
        l4.default = function(y4, _) {
          if (Array.isArray(y4))
            return y4;
          if ((0, h.default)(Object(y4)))
            return function(w4, C) {
              var E = [], T = true, O = false, N = void 0;
              try {
                for (var V, H = (0, p4.default)(w4); !(T = (V = H.next()).done) && (E.push(V.value), !C || E.length !== C); T = true)
                  ;
              } catch (X) {
                O = true, N = X;
              } finally {
                try {
                  !T && H.return && H.return();
                } finally {
                  if (O)
                    throw N;
                }
              }
              return E;
            }(y4, _);
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        };
      }, function(o, l4, c4) {
        o.exports = { default: c4(83), __esModule: true };
      }, function(o, l4, c4) {
        c4(29), c4(20), o.exports = c4(84);
      }, function(o, l4, c4) {
        var h = c4(42), p4 = c4(2)("iterator"), g4 = c4(12);
        o.exports = c4(1).isIterable = function(y4) {
          var _ = Object(y4);
          return _[p4] !== void 0 || "@@iterator" in _ || g4.hasOwnProperty(h(_));
        };
      }, function(o, l4, c4) {
        o.exports = { default: c4(86), __esModule: true };
      }, function(o, l4, c4) {
        c4(29), c4(20), o.exports = c4(87);
      }, function(o, l4, c4) {
        var h = c4(10), p4 = c4(88);
        o.exports = c4(1).getIterator = function(g4) {
          var y4 = p4(g4);
          if (typeof y4 != "function")
            throw TypeError(g4 + " is not iterable!");
          return h(y4.call(g4));
        };
      }, function(o, l4, c4) {
        var h = c4(42), p4 = c4(2)("iterator"), g4 = c4(12);
        o.exports = c4(1).getIteratorMethod = function(y4) {
          if (y4 != null)
            return y4[p4] || y4["@@iterator"] || g4[h(y4)];
        };
      }, function(o, l4, c4) {
        o.exports = { default: c4(90), __esModule: true };
      }, function(o, l4, c4) {
        c4(91), o.exports = c4(1).Object.keys;
      }, function(o, l4, c4) {
        var h = c4(18), p4 = c4(13);
        c4(92)("keys", function() {
          return function(g4) {
            return p4(h(g4));
          };
        });
      }, function(o, l4, c4) {
        var h = c4(15), p4 = c4(1), g4 = c4(8);
        o.exports = function(y4, _) {
          var w4 = (p4.Object || {})[y4] || Object[y4], C = {};
          C[y4] = _(w4), h(h.S + h.F * g4(function() {
            w4(1);
          }), "Object", C);
        };
      }, function(o, l4, c4) {
        (function(h) {
          var p4 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], g4 = /^\s+|\s+$/g, y4 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, _ = /\{\n\/\* \[wrapped with (.+)\] \*/, w4 = /,? & /, C = /^[-+]0x[0-9a-f]+$/i, E = /^0b[01]+$/i, T = /^\[object .+?Constructor\]$/, O = /^0o[0-7]+$/i, N = /^(?:0|[1-9]\d*)$/, V = parseInt, H = typeof h == "object" && h && h.Object === Object && h, X = typeof self == "object" && self && self.Object === Object && self, q2 = H || X || Function("return this")();
          function de(Rr, $n, Bn) {
            switch (Bn.length) {
              case 0:
                return Rr.call($n);
              case 1:
                return Rr.call($n, Bn[0]);
              case 2:
                return Rr.call($n, Bn[0], Bn[1]);
              case 3:
                return Rr.call($n, Bn[0], Bn[1], Bn[2]);
            }
            return Rr.apply($n, Bn);
          }
          function le(Rr, $n) {
            return !!(Rr && Rr.length) && function(Bn, Fr, Oa) {
              if (Fr != Fr)
                return function(jo, xl, Uu, vu) {
                  for (var qc = jo.length, gu = Uu + (vu ? 1 : -1); vu ? gu-- : ++gu < qc; )
                    if (xl(jo[gu], gu, jo))
                      return gu;
                  return -1;
                }(Bn, me, Oa);
              for (var yi = Oa - 1, Bo = Bn.length; ++yi < Bo; )
                if (Bn[yi] === Fr)
                  return yi;
              return -1;
            }(Rr, $n, 0) > -1;
          }
          function me(Rr) {
            return Rr != Rr;
          }
          function ye(Rr, $n) {
            for (var Bn = Rr.length, Fr = 0; Bn--; )
              Rr[Bn] === $n && Fr++;
            return Fr;
          }
          function be(Rr, $n) {
            for (var Bn = -1, Fr = Rr.length, Oa = 0, yi = []; ++Bn < Fr; ) {
              var Bo = Rr[Bn];
              Bo !== $n && Bo !== "__lodash_placeholder__" || (Rr[Bn] = "__lodash_placeholder__", yi[Oa++] = Bn);
            }
            return yi;
          }
          var we, Pe, ze, Re = Function.prototype, rt2 = Object.prototype, ft = q2["__core-js_shared__"], et = (we = /[^.]+$/.exec(ft && ft.keys && ft.keys.IE_PROTO || "")) ? "Symbol(src)_1." + we : "", Jt = Re.toString, xt = rt2.hasOwnProperty, It = rt2.toString, Wt = RegExp("^" + Jt.call(xt).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), sn = Object.create, vn = Math.max, $r = Math.min, ga = (Pe = wi(Object, "defineProperty"), (ze = wi.name) && ze.length > 2 ? Pe : void 0);
          function Za(Rr) {
            return Uc(Rr) ? sn(Rr) : {};
          }
          function $a(Rr) {
            return !(!Uc(Rr) || function($n) {
              return !!et && et in $n;
            }(Rr)) && (function($n) {
              var Bn = Uc($n) ? It.call($n) : "";
              return Bn == "[object Function]" || Bn == "[object GeneratorFunction]";
            }(Rr) || function($n) {
              var Bn = false;
              if ($n != null && typeof $n.toString != "function")
                try {
                  Bn = !!($n + "");
                } catch {
                }
              return Bn;
            }(Rr) ? Wt : T).test(function($n) {
              if ($n != null) {
                try {
                  return Jt.call($n);
                } catch {
                }
                try {
                  return $n + "";
                } catch {
                }
              }
              return "";
            }(Rr));
          }
          function Pa(Rr, $n, Bn, Fr) {
            for (var Oa = -1, yi = Rr.length, Bo = Bn.length, jo = -1, xl = $n.length, Uu = vn(yi - Bo, 0), vu = Array(xl + Uu), qc = !Fr; ++jo < xl; )
              vu[jo] = $n[jo];
            for (; ++Oa < Bo; )
              (qc || Oa < yi) && (vu[Bn[Oa]] = Rr[Oa]);
            for (; Uu--; )
              vu[jo++] = Rr[Oa++];
            return vu;
          }
          function da(Rr, $n, Bn, Fr) {
            for (var Oa = -1, yi = Rr.length, Bo = -1, jo = Bn.length, xl = -1, Uu = $n.length, vu = vn(yi - jo, 0), qc = Array(vu + Uu), gu = !Fr; ++Oa < vu; )
              qc[Oa] = Rr[Oa];
            for (var td = Oa; ++xl < Uu; )
              qc[td + xl] = $n[xl];
            for (; ++Bo < jo; )
              (gu || Oa < yi) && (qc[td + Bn[Bo]] = Rr[Oa++]);
            return qc;
          }
          function Ra(Rr) {
            return function() {
              var $n = arguments;
              switch ($n.length) {
                case 0:
                  return new Rr();
                case 1:
                  return new Rr($n[0]);
                case 2:
                  return new Rr($n[0], $n[1]);
                case 3:
                  return new Rr($n[0], $n[1], $n[2]);
                case 4:
                  return new Rr($n[0], $n[1], $n[2], $n[3]);
                case 5:
                  return new Rr($n[0], $n[1], $n[2], $n[3], $n[4]);
                case 6:
                  return new Rr($n[0], $n[1], $n[2], $n[3], $n[4], $n[5]);
                case 7:
                  return new Rr($n[0], $n[1], $n[2], $n[3], $n[4], $n[5], $n[6]);
              }
              var Bn = Za(Rr.prototype), Fr = Rr.apply(Bn, $n);
              return Uc(Fr) ? Fr : Bn;
            };
          }
          function Wa(Rr, $n, Bn, Fr, Oa, yi, Bo, jo, xl, Uu) {
            var vu = 128 & $n, qc = 1 & $n, gu = 2 & $n, td = 24 & $n, jd = 512 & $n, Qv = gu ? void 0 : Ra(Rr);
            return function Gd() {
              for (var xc = arguments.length, js = Array(xc), vf = xc; vf--; )
                js[vf] = arguments[vf];
              if (td)
                var xh = Ts(Gd), eg = ye(js, xh);
              if (Fr && (js = Pa(js, Fr, Oa, td)), yi && (js = da(js, yi, Bo, td)), xc -= eg, td && xc < Uu) {
                var Ep = be(js, xh);
                return wa(Rr, $n, Wa, Gd.placeholder, Bn, js, Ep, jo, xl, Uu - xc);
              }
              var Wd = qc ? Bn : this, bv = gu ? Wd[Rr] : Rr;
              return xc = js.length, jo ? js = If(js, jo) : jd && xc > 1 && js.reverse(), vu && xl < xc && (js.length = xl), this && this !== q2 && this instanceof Gd && (bv = Qv || Ra(bv)), bv.apply(Wd, js);
            };
          }
          function wa(Rr, $n, Bn, Fr, Oa, yi, Bo, jo, xl, Uu) {
            var vu = 8 & $n;
            $n |= vu ? 32 : 64, 4 & ($n &= ~(vu ? 64 : 32)) || ($n &= -4);
            var qc = Bn(Rr, $n, Oa, vu ? yi : void 0, vu ? Bo : void 0, vu ? void 0 : yi, vu ? void 0 : Bo, jo, xl, Uu);
            return qc.placeholder = Fr, Xl(qc, Rr, $n);
          }
          function li(Rr, $n, Bn, Fr, Oa, yi, Bo, jo) {
            var xl = 2 & $n;
            if (!xl && typeof Rr != "function")
              throw new TypeError("Expected a function");
            var Uu = Fr ? Fr.length : 0;
            if (Uu || ($n &= -97, Fr = Oa = void 0), Bo = Bo === void 0 ? Bo : vn(om(Bo), 0), jo = jo === void 0 ? jo : om(jo), Uu -= Oa ? Oa.length : 0, 64 & $n) {
              var vu = Fr, qc = Oa;
              Fr = Oa = void 0;
            }
            var gu = [Rr, $n, Bn, Fr, Oa, vu, qc, yi, Bo, jo];
            if (Rr = gu[0], $n = gu[1], Bn = gu[2], Fr = gu[3], Oa = gu[4], !(jo = gu[9] = gu[9] == null ? xl ? 0 : Rr.length : vn(gu[9] - Uu, 0)) && 24 & $n && ($n &= -25), $n && $n != 1)
              td = $n == 8 || $n == 16 ? function(jd, Qv, Gd) {
                var xc = Ra(jd);
                return function js() {
                  for (var vf = arguments.length, xh = Array(vf), eg = vf, Ep = Ts(js); eg--; )
                    xh[eg] = arguments[eg];
                  var Wd = vf < 3 && xh[0] !== Ep && xh[vf - 1] !== Ep ? [] : be(xh, Ep);
                  if ((vf -= Wd.length) < Gd)
                    return wa(jd, Qv, Wa, js.placeholder, void 0, xh, Wd, void 0, void 0, Gd - vf);
                  var bv = this && this !== q2 && this instanceof js ? xc : jd;
                  return de(bv, this, xh);
                };
              }(Rr, $n, jo) : $n != 32 && $n != 33 || Oa.length ? Wa.apply(void 0, gu) : function(jd, Qv, Gd, xc) {
                var js = 1 & Qv, vf = Ra(jd);
                return function xh() {
                  for (var eg = -1, Ep = arguments.length, Wd = -1, bv = xc.length, ub = Array(bv + Ep), Gy = this && this !== q2 && this instanceof xh ? vf : jd; ++Wd < bv; )
                    ub[Wd] = xc[Wd];
                  for (; Ep--; )
                    ub[Wd++] = arguments[++eg];
                  return de(Gy, js ? Gd : this, ub);
                };
              }(Rr, $n, Bn, Fr);
            else
              var td = function(jd, Qv, Gd) {
                var xc = 1 & Qv, js = Ra(jd);
                return function vf() {
                  var xh = this && this !== q2 && this instanceof vf ? js : jd;
                  return xh.apply(xc ? Gd : this, arguments);
                };
              }(Rr, $n, Bn);
            return Xl(td, Rr, $n);
          }
          function Ts(Rr) {
            return Rr.placeholder;
          }
          function wi(Rr, $n) {
            var Bn = function(Fr, Oa) {
              return Fr == null ? void 0 : Fr[Oa];
            }(Rr, $n);
            return $a(Bn) ? Bn : void 0;
          }
          function ps(Rr) {
            var $n = Rr.match(_);
            return $n ? $n[1].split(w4) : [];
          }
          function Bs(Rr, $n) {
            var Bn = $n.length, Fr = Bn - 1;
            return $n[Fr] = (Bn > 1 ? "& " : "") + $n[Fr], $n = $n.join(Bn > 2 ? ", " : " "), Rr.replace(y4, `{
/* [wrapped with ` + $n + `] */
`);
          }
          function vl(Rr, $n) {
            return !!($n = $n == null ? 9007199254740991 : $n) && (typeof Rr == "number" || N.test(Rr)) && Rr > -1 && Rr % 1 == 0 && Rr < $n;
          }
          function If(Rr, $n) {
            for (var Bn = Rr.length, Fr = $r($n.length, Bn), Oa = function(Bo, jo) {
              var xl = -1, Uu = Bo.length;
              for (jo || (jo = Array(Uu)); ++xl < Uu; )
                jo[xl] = Bo[xl];
              return jo;
            }(Rr); Fr--; ) {
              var yi = $n[Fr];
              Rr[Fr] = vl(yi, Bn) ? Oa[yi] : void 0;
            }
            return Rr;
          }
          var Xl = ga ? function(Rr, $n, Bn) {
            var Fr, Oa = $n + "";
            return ga(Rr, "toString", { configurable: true, enumerable: false, value: (Fr = Bs(Oa, _h(ps(Oa), Bn)), function() {
              return Fr;
            }) });
          } : function(Rr) {
            return Rr;
          };
          function _h(Rr, $n) {
            return function(Bn, Fr) {
              for (var Oa = -1, yi = Bn ? Bn.length : 0; ++Oa < yi && Fr(Bn[Oa], Oa, Bn) !== false; )
                ;
            }(p4, function(Bn) {
              var Fr = "_." + Bn[0];
              $n & Bn[1] && !le(Rr, Fr) && Rr.push(Fr);
            }), Rr.sort();
          }
          function Nl(Rr, $n, Bn) {
            var Fr = li(Rr, 8, void 0, void 0, void 0, void 0, void 0, $n = Bn ? void 0 : $n);
            return Fr.placeholder = Nl.placeholder, Fr;
          }
          function Uc(Rr) {
            var $n = typeof Rr;
            return !!Rr && ($n == "object" || $n == "function");
          }
          function Nu(Rr) {
            return Rr ? (Rr = function($n) {
              if (typeof $n == "number")
                return $n;
              if (function(Oa) {
                return typeof Oa == "symbol" || function(yi) {
                  return !!yi && typeof yi == "object";
                }(Oa) && It.call(Oa) == "[object Symbol]";
              }($n))
                return NaN;
              if (Uc($n)) {
                var Bn = typeof $n.valueOf == "function" ? $n.valueOf() : $n;
                $n = Uc(Bn) ? Bn + "" : Bn;
              }
              if (typeof $n != "string")
                return $n === 0 ? $n : +$n;
              $n = $n.replace(g4, "");
              var Fr = E.test($n);
              return Fr || O.test($n) ? V($n.slice(2), Fr ? 2 : 8) : C.test($n) ? NaN : +$n;
            }(Rr)) === 1 / 0 || Rr === -1 / 0 ? 17976931348623157e292 * (Rr < 0 ? -1 : 1) : Rr == Rr ? Rr : 0 : Rr === 0 ? Rr : 0;
          }
          function om(Rr) {
            var $n = Nu(Rr), Bn = $n % 1;
            return $n == $n ? Bn ? $n - Bn : $n : 0;
          }
          Nl.placeholder = {}, o.exports = Nl;
        }).call(this, c4(43));
      }, function(o, l4, c4) {
        function h(da) {
          return da && da.__esModule ? da.default : da;
        }
        l4.__esModule = true;
        var p4 = c4(95);
        l4.threezerotwofour = h(p4);
        var g4 = c4(96);
        l4.apathy = h(g4);
        var y4 = c4(97);
        l4.ashes = h(y4);
        var _ = c4(98);
        l4.atelierDune = h(_);
        var w4 = c4(99);
        l4.atelierForest = h(w4);
        var C = c4(100);
        l4.atelierHeath = h(C);
        var E = c4(101);
        l4.atelierLakeside = h(E);
        var T = c4(102);
        l4.atelierSeaside = h(T);
        var O = c4(103);
        l4.bespin = h(O);
        var N = c4(104);
        l4.brewer = h(N);
        var V = c4(105);
        l4.bright = h(V);
        var H = c4(106);
        l4.chalk = h(H);
        var X = c4(107);
        l4.codeschool = h(X);
        var q2 = c4(108);
        l4.colors = h(q2);
        var de = c4(109);
        l4.default = h(de);
        var le = c4(110);
        l4.eighties = h(le);
        var me = c4(111);
        l4.embers = h(me);
        var ye = c4(112);
        l4.flat = h(ye);
        var be = c4(113);
        l4.google = h(be);
        var we = c4(114);
        l4.grayscale = h(we);
        var Pe = c4(115);
        l4.greenscreen = h(Pe);
        var ze = c4(116);
        l4.harmonic = h(ze);
        var Re = c4(117);
        l4.hopscotch = h(Re);
        var rt2 = c4(118);
        l4.isotope = h(rt2);
        var ft = c4(119);
        l4.marrakesh = h(ft);
        var et = c4(120);
        l4.mocha = h(et);
        var Jt = c4(121);
        l4.monokai = h(Jt);
        var xt = c4(122);
        l4.ocean = h(xt);
        var It = c4(123);
        l4.paraiso = h(It);
        var Wt = c4(124);
        l4.pop = h(Wt);
        var sn = c4(125);
        l4.railscasts = h(sn);
        var vn = c4(126);
        l4.shapeshifter = h(vn);
        var $r = c4(127);
        l4.solarized = h($r);
        var ga = c4(128);
        l4.summerfruit = h(ga);
        var Za = c4(129);
        l4.tomorrow = h(Za);
        var $a = c4(130);
        l4.tube = h($a);
        var Pa = c4(131);
        l4.twilight = h(Pa);
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        l4.__esModule = true, l4.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, o.exports = l4.default;
      }, function(o, l4, c4) {
        var h = c4(33);
        function p4(g4) {
          var y4 = Math.round(h(g4, 0, 255)).toString(16);
          return y4.length == 1 ? "0" + y4 : y4;
        }
        o.exports = function(g4) {
          var y4 = g4.length === 4 ? p4(255 * g4[3]) : "";
          return "#" + p4(g4[0]) + p4(g4[1]) + p4(g4[2]) + y4;
        };
      }, function(o, l4, c4) {
        var h = c4(134), p4 = c4(135), g4 = c4(136), y4 = c4(137), _ = { "#": p4, hsl: function(C) {
          var E = h(C), T = y4(E);
          return E.length === 4 && T.push(E[3]), T;
        }, rgb: g4 };
        function w4(C) {
          for (var E in _)
            if (C.indexOf(E) === 0)
              return _[E](C);
        }
        w4.rgb = g4, w4.hsl = h, w4.hex = p4, o.exports = w4;
      }, function(o, l4, c4) {
        var h = c4(44), p4 = c4(33);
        function g4(y4, _) {
          switch (y4 = parseFloat(y4), _) {
            case 0:
              return p4(y4, 0, 360);
            case 1:
            case 2:
              return p4(y4, 0, 100);
            case 3:
              return p4(y4, 0, 1);
          }
        }
        o.exports = function(y4) {
          return h(y4).map(g4);
        };
      }, function(o, l4) {
        o.exports = function(c4) {
          c4.length !== 4 && c4.length !== 5 || (c4 = function(g4) {
            for (var y4 = "#", _ = 1; _ < g4.length; _++) {
              var w4 = g4.charAt(_);
              y4 += w4 + w4;
            }
            return y4;
          }(c4));
          var h = [parseInt(c4.substring(1, 3), 16), parseInt(c4.substring(3, 5), 16), parseInt(c4.substring(5, 7), 16)];
          if (c4.length === 9) {
            var p4 = parseFloat((parseInt(c4.substring(7, 9), 16) / 255).toFixed(2));
            h.push(p4);
          }
          return h;
        };
      }, function(o, l4, c4) {
        var h = c4(44), p4 = c4(33);
        function g4(y4, _) {
          return _ < 3 ? y4.indexOf("%") != -1 ? Math.round(255 * p4(parseInt(y4, 10), 0, 100) / 100) : p4(parseInt(y4, 10), 0, 255) : p4(parseFloat(y4), 0, 1);
        }
        o.exports = function(y4) {
          return h(y4).map(g4);
        };
      }, function(o, l4) {
        o.exports = function(c4) {
          var h, p4, g4, y4, _, w4 = c4[0] / 360, C = c4[1] / 100, E = c4[2] / 100;
          if (C == 0)
            return [_ = 255 * E, _, _];
          h = 2 * E - (p4 = E < 0.5 ? E * (1 + C) : E + C - E * C), y4 = [0, 0, 0];
          for (var T = 0; T < 3; T++)
            (g4 = w4 + 1 / 3 * -(T - 1)) < 0 && g4++, g4 > 1 && g4--, _ = 6 * g4 < 1 ? h + 6 * (p4 - h) * g4 : 2 * g4 < 1 ? p4 : 3 * g4 < 2 ? h + (p4 - h) * (2 / 3 - g4) * 6 : h, y4[T] = 255 * _;
          return y4;
        };
      }, function(o, l4, c4) {
        (function(h) {
          var p4 = typeof h == "object" && h && h.Object === Object && h, g4 = typeof self == "object" && self && self.Object === Object && self, y4 = p4 || g4 || Function("return this")();
          function _(be, we, Pe) {
            switch (Pe.length) {
              case 0:
                return be.call(we);
              case 1:
                return be.call(we, Pe[0]);
              case 2:
                return be.call(we, Pe[0], Pe[1]);
              case 3:
                return be.call(we, Pe[0], Pe[1], Pe[2]);
            }
            return be.apply(we, Pe);
          }
          function w4(be, we) {
            for (var Pe = -1, ze = we.length, Re = be.length; ++Pe < ze; )
              be[Re + Pe] = we[Pe];
            return be;
          }
          var C = Object.prototype, E = C.hasOwnProperty, T = C.toString, O = y4.Symbol, N = C.propertyIsEnumerable, V = O ? O.isConcatSpreadable : void 0, H = Math.max;
          function X(be) {
            return q2(be) || function(we) {
              return function(Pe) {
                return function(ze) {
                  return !!ze && typeof ze == "object";
                }(Pe) && function(ze) {
                  return ze != null && function(Re) {
                    return typeof Re == "number" && Re > -1 && Re % 1 == 0 && Re <= 9007199254740991;
                  }(ze.length) && !function(Re) {
                    var rt2 = function(ft) {
                      var et = typeof ft;
                      return !!ft && (et == "object" || et == "function");
                    }(Re) ? T.call(Re) : "";
                    return rt2 == "[object Function]" || rt2 == "[object GeneratorFunction]";
                  }(ze);
                }(Pe);
              }(we) && E.call(we, "callee") && (!N.call(we, "callee") || T.call(we) == "[object Arguments]");
            }(be) || !!(V && be && be[V]);
          }
          var q2 = Array.isArray, de, le, me, ye = (le = function(be) {
            var we = (be = function ze(Re, rt2, ft, et, Jt) {
              var xt = -1, It = Re.length;
              for (ft || (ft = X), Jt || (Jt = []); ++xt < It; ) {
                var Wt = Re[xt];
                rt2 > 0 && ft(Wt) ? rt2 > 1 ? ze(Wt, rt2 - 1, ft, et, Jt) : w4(Jt, Wt) : et || (Jt[Jt.length] = Wt);
              }
              return Jt;
            }(be, 1)).length, Pe = we;
            for (de; Pe--; )
              if (typeof be[Pe] != "function")
                throw new TypeError("Expected a function");
            return function() {
              for (var ze = 0, Re = we ? be[ze].apply(this, arguments) : arguments[0]; ++ze < we; )
                Re = be[ze].call(this, Re);
              return Re;
            };
          }, me = H(me === void 0 ? le.length - 1 : me, 0), function() {
            for (var be = arguments, we = -1, Pe = H(be.length - me, 0), ze = Array(Pe); ++we < Pe; )
              ze[we] = be[me + we];
            we = -1;
            for (var Re = Array(me + 1); ++we < me; )
              Re[we] = be[we];
            return Re[me] = ze, _(le, this, Re);
          });
          o.exports = ye;
        }).call(this, c4(43));
      }, function(o, l4, c4) {
        Object.defineProperty(l4, "__esModule", { value: true }), l4.yuv2rgb = function(h) {
          var p4, g4, y4, _ = h[0], w4 = h[1], C = h[2];
          return p4 = 1 * _ + 0 * w4 + 1.13983 * C, g4 = 1 * _ + -0.39465 * w4 + -0.5806 * C, y4 = 1 * _ + 2.02311 * w4 + 0 * C, p4 = Math.min(Math.max(0, p4), 1), g4 = Math.min(Math.max(0, g4), 1), y4 = Math.min(Math.max(0, y4), 1), [255 * p4, 255 * g4, 255 * y4];
        }, l4.rgb2yuv = function(h) {
          var p4 = h[0] / 255, g4 = h[1] / 255, y4 = h[2] / 255;
          return [0.299 * p4 + 0.587 * g4 + 0.114 * y4, -0.14713 * p4 + -0.28886 * g4 + 0.436 * y4, 0.615 * p4 + -0.51499 * g4 + -0.10001 * y4];
        };
      }, function(o, l4, c4) {
        function h(y4, _, w4) {
          return _ in y4 ? Object.defineProperty(y4, _, { value: w4, enumerable: true, configurable: true, writable: true }) : y4[_] = w4, y4;
        }
        var p4 = c4(141), g4 = function() {
          function y4() {
            h(this, "_callbacks", void 0), h(this, "_isDispatching", void 0), h(this, "_isHandled", void 0), h(this, "_isPending", void 0), h(this, "_lastID", void 0), h(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
          }
          var _ = y4.prototype;
          return _.register = function(w4) {
            var C = "ID_" + this._lastID++;
            return this._callbacks[C] = w4, C;
          }, _.unregister = function(w4) {
            this._callbacks[w4] || p4(false), delete this._callbacks[w4];
          }, _.waitFor = function(w4) {
            this._isDispatching || p4(false);
            for (var C = 0; C < w4.length; C++) {
              var E = w4[C];
              this._isPending[E] ? this._isHandled[E] || p4(false) : (this._callbacks[E] || p4(false), this._invokeCallback(E));
            }
          }, _.dispatch = function(w4) {
            this._isDispatching && p4(false), this._startDispatching(w4);
            try {
              for (var C in this._callbacks)
                this._isPending[C] || this._invokeCallback(C);
            } finally {
              this._stopDispatching();
            }
          }, _.isDispatching = function() {
            return this._isDispatching;
          }, _._invokeCallback = function(w4) {
            this._isPending[w4] = true, this._callbacks[w4](this._pendingPayload), this._isHandled[w4] = true;
          }, _._startDispatching = function(w4) {
            for (var C in this._callbacks)
              this._isPending[C] = false, this._isHandled[C] = false;
            this._pendingPayload = w4, this._isDispatching = true;
          }, _._stopDispatching = function() {
            delete this._pendingPayload, this._isDispatching = false;
          }, y4;
        }();
        o.exports = g4;
      }, function(o, l4, c4) {
        o.exports = function(h, p4) {
          for (var g4 = arguments.length, y4 = new Array(g4 > 2 ? g4 - 2 : 0), _ = 2; _ < g4; _++)
            y4[_ - 2] = arguments[_];
          if (!h) {
            var w4;
            if (p4 === void 0)
              w4 = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
            else {
              var C = 0;
              (w4 = new Error(p4.replace(/%s/g, function() {
                return String(y4[C++]);
              }))).name = "Invariant Violation";
            }
            throw w4.framesToPop = 1, w4;
          }
        };
      }, function(o, l4, c4) {
        function h(Lt, zt, lt2) {
          return zt in Lt ? Object.defineProperty(Lt, zt, { value: lt2, enumerable: true, configurable: true, writable: true }) : Lt[zt] = lt2, Lt;
        }
        function p4(Lt, zt) {
          var lt2 = Object.keys(Lt);
          if (Object.getOwnPropertySymbols) {
            var Et = Object.getOwnPropertySymbols(Lt);
            zt && (Et = Et.filter(function(kt) {
              return Object.getOwnPropertyDescriptor(Lt, kt).enumerable;
            })), lt2.push.apply(lt2, Et);
          }
          return lt2;
        }
        function g4(Lt) {
          for (var zt = 1; zt < arguments.length; zt++) {
            var lt2 = arguments[zt] != null ? arguments[zt] : {};
            zt % 2 ? p4(Object(lt2), true).forEach(function(Et) {
              h(Lt, Et, lt2[Et]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Lt, Object.getOwnPropertyDescriptors(lt2)) : p4(Object(lt2)).forEach(function(Et) {
              Object.defineProperty(Lt, Et, Object.getOwnPropertyDescriptor(lt2, Et));
            });
          }
          return Lt;
        }
        function y4(Lt, zt) {
          if (!(Lt instanceof zt))
            throw new TypeError("Cannot call a class as a function");
        }
        function _(Lt, zt) {
          for (var lt2 = 0; lt2 < zt.length; lt2++) {
            var Et = zt[lt2];
            Et.enumerable = Et.enumerable || false, Et.configurable = true, "value" in Et && (Et.writable = true), Object.defineProperty(Lt, Et.key, Et);
          }
        }
        function w4(Lt, zt, lt2) {
          return zt && _(Lt.prototype, zt), lt2 && _(Lt, lt2), Lt;
        }
        function C(Lt, zt) {
          return (C = Object.setPrototypeOf || function(lt2, Et) {
            return lt2.__proto__ = Et, lt2;
          })(Lt, zt);
        }
        function E(Lt, zt) {
          if (typeof zt != "function" && zt !== null)
            throw new TypeError("Super expression must either be null or a function");
          Lt.prototype = Object.create(zt && zt.prototype, { constructor: { value: Lt, writable: true, configurable: true } }), zt && C(Lt, zt);
        }
        function T(Lt) {
          return (T = Object.setPrototypeOf ? Object.getPrototypeOf : function(zt) {
            return zt.__proto__ || Object.getPrototypeOf(zt);
          })(Lt);
        }
        function O(Lt) {
          return (O = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(zt) {
            return typeof zt;
          } : function(zt) {
            return zt && typeof Symbol == "function" && zt.constructor === Symbol && zt !== Symbol.prototype ? "symbol" : typeof zt;
          })(Lt);
        }
        function N(Lt) {
          if (Lt === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return Lt;
        }
        function V(Lt, zt) {
          return !zt || O(zt) !== "object" && typeof zt != "function" ? N(Lt) : zt;
        }
        function H(Lt) {
          var zt = function() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }();
          return function() {
            var lt2, Et = T(Lt);
            if (zt) {
              var kt = T(this).constructor;
              lt2 = Reflect.construct(Et, arguments, kt);
            } else
              lt2 = Et.apply(this, arguments);
            return V(this, lt2);
          };
        }
        c4.r(l4);
        var X = c4(0), q2 = c4.n(X);
        function de() {
          var Lt = this.constructor.getDerivedStateFromProps(this.props, this.state);
          Lt != null && this.setState(Lt);
        }
        function le(Lt) {
          this.setState(function(zt) {
            var lt2 = this.constructor.getDerivedStateFromProps(Lt, zt);
            return lt2 != null ? lt2 : null;
          }.bind(this));
        }
        function me(Lt, zt) {
          try {
            var lt2 = this.props, Et = this.state;
            this.props = Lt, this.state = zt, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(lt2, Et);
          } finally {
            this.props = lt2, this.state = Et;
          }
        }
        function ye(Lt) {
          var zt = Lt.prototype;
          if (!zt || !zt.isReactComponent)
            throw new Error("Can only polyfill class components");
          if (typeof Lt.getDerivedStateFromProps != "function" && typeof zt.getSnapshotBeforeUpdate != "function")
            return Lt;
          var lt2 = null, Et = null, kt = null;
          if (typeof zt.componentWillMount == "function" ? lt2 = "componentWillMount" : typeof zt.UNSAFE_componentWillMount == "function" && (lt2 = "UNSAFE_componentWillMount"), typeof zt.componentWillReceiveProps == "function" ? Et = "componentWillReceiveProps" : typeof zt.UNSAFE_componentWillReceiveProps == "function" && (Et = "UNSAFE_componentWillReceiveProps"), typeof zt.componentWillUpdate == "function" ? kt = "componentWillUpdate" : typeof zt.UNSAFE_componentWillUpdate == "function" && (kt = "UNSAFE_componentWillUpdate"), lt2 !== null || Et !== null || kt !== null) {
            var tt = Lt.displayName || Lt.name, Ir = typeof Lt.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
            throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + tt + " uses " + Ir + " but also contains the following legacy lifecycles:" + (lt2 !== null ? `
  ` + lt2 : "") + (Et !== null ? `
  ` + Et : "") + (kt !== null ? `
  ` + kt : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
          }
          if (typeof Lt.getDerivedStateFromProps == "function" && (zt.componentWillMount = de, zt.componentWillReceiveProps = le), typeof zt.getSnapshotBeforeUpdate == "function") {
            if (typeof zt.componentDidUpdate != "function")
              throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
            zt.componentWillUpdate = me;
            var hr = zt.componentDidUpdate;
            zt.componentDidUpdate = function(hn, oa, ha) {
              var Zo = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : ha;
              hr.call(this, hn, oa, Zo);
            };
          }
          return Lt;
        }
        function be(Lt, zt) {
          if (Lt == null)
            return {};
          var lt2, Et, kt = function(Ir, hr) {
            if (Ir == null)
              return {};
            var hn, oa, ha = {}, Zo = Object.keys(Ir);
            for (oa = 0; oa < Zo.length; oa++)
              hn = Zo[oa], hr.indexOf(hn) >= 0 || (ha[hn] = Ir[hn]);
            return ha;
          }(Lt, zt);
          if (Object.getOwnPropertySymbols) {
            var tt = Object.getOwnPropertySymbols(Lt);
            for (Et = 0; Et < tt.length; Et++)
              lt2 = tt[Et], zt.indexOf(lt2) >= 0 || Object.prototype.propertyIsEnumerable.call(Lt, lt2) && (kt[lt2] = Lt[lt2]);
          }
          return kt;
        }
        function we(Lt) {
          var zt = function(lt2) {
            return {}.toString.call(lt2).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
          }(Lt);
          return zt === "number" && (zt = isNaN(Lt) ? "nan" : (0 | Lt) != Lt ? "float" : "integer"), zt;
        }
        de.__suppressDeprecationWarning = true, le.__suppressDeprecationWarning = true, me.__suppressDeprecationWarning = true;
        var Pe = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, ze = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Re = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, rt2 = c4(45), ft = function(Lt) {
          var zt = function(lt2) {
            return { backgroundColor: lt2.base00, ellipsisColor: lt2.base09, braceColor: lt2.base07, expandedIcon: lt2.base0D, collapsedIcon: lt2.base0E, keyColor: lt2.base07, arrayKeyColor: lt2.base0C, objectSize: lt2.base04, copyToClipboard: lt2.base0F, copyToClipboardCheck: lt2.base0D, objectBorder: lt2.base02, dataTypes: { boolean: lt2.base0E, date: lt2.base0D, float: lt2.base0B, function: lt2.base0D, integer: lt2.base0F, string: lt2.base09, nan: lt2.base08, null: lt2.base0A, undefined: lt2.base05, regexp: lt2.base0A, background: lt2.base02 }, editVariable: { editIcon: lt2.base0E, cancelIcon: lt2.base09, removeIcon: lt2.base09, addIcon: lt2.base0E, checkIcon: lt2.base0E, background: lt2.base01, color: lt2.base0A, border: lt2.base07 }, addKeyModal: { background: lt2.base05, border: lt2.base04, color: lt2.base0A, labelColor: lt2.base01 }, validationFailure: { background: lt2.base09, iconColor: lt2.base01, fontColor: lt2.base01 } };
          }(Lt);
          return { "app-container": { fontFamily: Re.globalFontFamily, cursor: Re.globalCursor, backgroundColor: zt.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: zt.ellipsisColor, fontSize: Re.ellipsisFontSize, lineHeight: Re.ellipsisLineHeight, cursor: Re.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Re.braceCursor, fontWeight: Re.braceFontWeight, color: zt.braceColor }, "expanded-icon": { color: zt.expandedIcon }, "collapsed-icon": { color: zt.collapsedIcon }, colon: { display: "inline-block", margin: Re.keyMargin, color: zt.keyColor, verticalAlign: "top" }, objectKeyVal: function(lt2, Et) {
            return { style: g4({ paddingTop: Re.keyValPaddingTop, paddingRight: Re.keyValPaddingRight, paddingBottom: Re.keyValPaddingBottom, borderLeft: Re.keyValBorderLeft + " " + zt.objectBorder, ":hover": { paddingLeft: Et.paddingLeft - 1 + "px", borderLeft: Re.keyValBorderHover + " " + zt.objectBorder } }, Et) };
          }, "object-key-val-no-border": { padding: Re.keyValPadding }, "pushed-content": { marginLeft: Re.pushedContentMarginLeft }, variableValue: function(lt2, Et) {
            return { style: g4({ display: "inline-block", paddingRight: Re.variableValuePaddingRight, position: "relative" }, Et) };
          }, "object-name": { display: "inline-block", color: zt.keyColor, letterSpacing: Re.keyLetterSpacing, fontStyle: Re.keyFontStyle, verticalAlign: Re.keyVerticalAlign, opacity: Re.keyOpacity, ":hover": { opacity: Re.keyOpacityHover } }, "array-key": { display: "inline-block", color: zt.arrayKeyColor, letterSpacing: Re.keyLetterSpacing, fontStyle: Re.keyFontStyle, verticalAlign: Re.keyVerticalAlign, opacity: Re.keyOpacity, ":hover": { opacity: Re.keyOpacityHover } }, "object-size": { color: zt.objectSize, borderRadius: Re.objectSizeBorderRadius, fontStyle: Re.objectSizeFontStyle, margin: Re.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Re.dataTypeFontSize, marginRight: Re.dataTypeMarginRight, opacity: Re.datatypeOpacity }, boolean: { display: "inline-block", color: zt.dataTypes.boolean }, date: { display: "inline-block", color: zt.dataTypes.date }, "date-value": { marginLeft: Re.dateValueMarginLeft }, float: { display: "inline-block", color: zt.dataTypes.float }, function: { display: "inline-block", color: zt.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: zt.dataTypes.integer }, string: { display: "inline-block", color: zt.dataTypes.string }, nan: { display: "inline-block", color: zt.dataTypes.nan, fontSize: Re.nanFontSize, fontWeight: Re.nanFontWeight, backgroundColor: zt.dataTypes.background, padding: Re.nanPadding, borderRadius: Re.nanBorderRadius }, null: { display: "inline-block", color: zt.dataTypes.null, fontSize: Re.nullFontSize, fontWeight: Re.nullFontWeight, backgroundColor: zt.dataTypes.background, padding: Re.nullPadding, borderRadius: Re.nullBorderRadius }, undefined: { display: "inline-block", color: zt.dataTypes.undefined, fontSize: Re.undefinedFontSize, padding: Re.undefinedPadding, borderRadius: Re.undefinedBorderRadius, backgroundColor: zt.dataTypes.background }, regexp: { display: "inline-block", color: zt.dataTypes.regexp }, "copy-to-clipboard": { cursor: Re.clipboardCursor }, "copy-icon": { color: zt.copyToClipboard, fontSize: Re.iconFontSize, marginRight: Re.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: zt.copyToClipboardCheck, marginLeft: Re.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Re.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Re.metaDataPadding }, "icon-container": { display: "inline-block", width: Re.iconContainerWidth }, tooltip: { padding: Re.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: zt.editVariable.removeIcon, cursor: Re.iconCursor, fontSize: Re.iconFontSize, marginRight: Re.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: zt.editVariable.addIcon, cursor: Re.iconCursor, fontSize: Re.iconFontSize, marginRight: Re.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: zt.editVariable.editIcon, cursor: Re.iconCursor, fontSize: Re.iconFontSize, marginRight: Re.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Re.iconCursor, color: zt.editVariable.checkIcon, fontSize: Re.iconFontSize, paddingRight: Re.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Re.iconCursor, color: zt.editVariable.cancelIcon, fontSize: Re.iconFontSize, paddingRight: Re.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Re.editInputMinWidth, borderRadius: Re.editInputBorderRadius, backgroundColor: zt.editVariable.background, color: zt.editVariable.color, padding: Re.editInputPadding, marginRight: Re.editInputMarginRight, fontFamily: Re.editInputFontFamily }, "detected-row": { paddingTop: Re.detectedRowPaddingTop }, "key-modal-request": { position: Re.addKeyCoverPosition, top: Re.addKeyCoverPositionPx, left: Re.addKeyCoverPositionPx, right: Re.addKeyCoverPositionPx, bottom: Re.addKeyCoverPositionPx, backgroundColor: Re.addKeyCoverBackground }, "key-modal": { width: Re.addKeyModalWidth, backgroundColor: zt.addKeyModal.background, marginLeft: Re.addKeyModalMargin, marginRight: Re.addKeyModalMargin, padding: Re.addKeyModalPadding, borderRadius: Re.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: zt.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: zt.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: zt.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: zt.addKeyModal.labelColor, fontSize: Re.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: zt.editVariable.addIcon, fontSize: Re.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: zt.ellipsisColor, fontSize: Re.ellipsisFontSize, lineHeight: Re.ellipsisLineHeight, cursor: Re.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: zt.validationFailure.fontColor, backgroundColor: zt.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: zt.validationFailure.iconColor, fontSize: Re.iconFontSize, transform: "rotate(45deg)" } };
        };
        function et(Lt, zt, lt2) {
          return Lt || console.error("theme has not been set"), function(Et) {
            var kt = Pe;
            return Et !== false && Et !== "none" || (kt = ze), Object(rt2.createStyling)(ft, { defaultBase16: kt })(Et);
          }(Lt)(zt, lt2);
        }
        var Jt = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = (Et.rjvId, Et.type_name), tt = Et.displayDataTypes, Ir = Et.theme;
            return tt ? q2.a.createElement("span", Object.assign({ className: "data-type-label" }, et(Ir, "data-type-label")), kt) : null;
          } }]), lt2;
        }(q2.a.PureComponent), xt = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props;
            return q2.a.createElement("div", et(Et.theme, "boolean"), q2.a.createElement(Jt, Object.assign({ type_name: "bool" }, Et)), Et.value ? "true" : "false");
          } }]), lt2;
        }(q2.a.PureComponent), It = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props;
            return q2.a.createElement("div", et(Et.theme, "date"), q2.a.createElement(Jt, Object.assign({ type_name: "date" }, Et)), q2.a.createElement("span", Object.assign({ className: "date-value" }, et(Et.theme, "date-value")), Et.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
          } }]), lt2;
        }(q2.a.PureComponent), Wt = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props;
            return q2.a.createElement("div", et(Et.theme, "float"), q2.a.createElement(Jt, Object.assign({ type_name: "float" }, Et)), this.props.value);
          } }]), lt2;
        }(q2.a.PureComponent);
        function sn(Lt, zt) {
          (zt == null || zt > Lt.length) && (zt = Lt.length);
          for (var lt2 = 0, Et = new Array(zt); lt2 < zt; lt2++)
            Et[lt2] = Lt[lt2];
          return Et;
        }
        function vn(Lt, zt) {
          if (Lt) {
            if (typeof Lt == "string")
              return sn(Lt, zt);
            var lt2 = Object.prototype.toString.call(Lt).slice(8, -1);
            return lt2 === "Object" && Lt.constructor && (lt2 = Lt.constructor.name), lt2 === "Map" || lt2 === "Set" ? Array.from(Lt) : lt2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(lt2) ? sn(Lt, zt) : void 0;
          }
        }
        function $r(Lt, zt) {
          var lt2;
          if (typeof Symbol == "undefined" || Lt[Symbol.iterator] == null) {
            if (Array.isArray(Lt) || (lt2 = vn(Lt)) || zt && Lt && typeof Lt.length == "number") {
              lt2 && (Lt = lt2);
              var Et = 0, kt = function() {
              };
              return { s: kt, n: function() {
                return Et >= Lt.length ? { done: true } : { done: false, value: Lt[Et++] };
              }, e: function(hn) {
                throw hn;
              }, f: kt };
            }
            throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          var tt, Ir = true, hr = false;
          return { s: function() {
            lt2 = Lt[Symbol.iterator]();
          }, n: function() {
            var hn = lt2.next();
            return Ir = hn.done, hn;
          }, e: function(hn) {
            hr = true, tt = hn;
          }, f: function() {
            try {
              Ir || lt2.return == null || lt2.return();
            } finally {
              if (hr)
                throw tt;
            }
          } };
        }
        function ga(Lt) {
          return function(zt) {
            if (Array.isArray(zt))
              return sn(zt);
          }(Lt) || function(zt) {
            if (typeof Symbol != "undefined" && Symbol.iterator in Object(zt))
              return Array.from(zt);
          }(Lt) || vn(Lt) || function() {
            throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }();
        }
        var Za = c4(46), $a = new (c4(47)).Dispatcher(), Pa = new (function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            var Et;
            y4(this, lt2);
            for (var kt = arguments.length, tt = new Array(kt), Ir = 0; Ir < kt; Ir++)
              tt[Ir] = arguments[Ir];
            return (Et = zt.call.apply(zt, [this].concat(tt))).objects = {}, Et.set = function(hr, hn, oa, ha) {
              Et.objects[hr] === void 0 && (Et.objects[hr] = {}), Et.objects[hr][hn] === void 0 && (Et.objects[hr][hn] = {}), Et.objects[hr][hn][oa] = ha;
            }, Et.get = function(hr, hn, oa, ha) {
              return Et.objects[hr] === void 0 || Et.objects[hr][hn] === void 0 || Et.objects[hr][hn][oa] == null ? ha : Et.objects[hr][hn][oa];
            }, Et.handleAction = function(hr) {
              var hn = hr.rjvId, oa = hr.data;
              switch (hr.name) {
                case "RESET":
                  Et.emit("reset-" + hn);
                  break;
                case "VARIABLE_UPDATED":
                  hr.data.updated_src = Et.updateSrc(hn, oa), Et.set(hn, "action", "variable-update", g4(g4({}, oa), {}, { type: "variable-edited" })), Et.emit("variable-update-" + hn);
                  break;
                case "VARIABLE_REMOVED":
                  hr.data.updated_src = Et.updateSrc(hn, oa), Et.set(hn, "action", "variable-update", g4(g4({}, oa), {}, { type: "variable-removed" })), Et.emit("variable-update-" + hn);
                  break;
                case "VARIABLE_ADDED":
                  hr.data.updated_src = Et.updateSrc(hn, oa), Et.set(hn, "action", "variable-update", g4(g4({}, oa), {}, { type: "variable-added" })), Et.emit("variable-update-" + hn);
                  break;
                case "ADD_VARIABLE_KEY_REQUEST":
                  Et.set(hn, "action", "new-key-request", oa), Et.emit("add-key-request-" + hn);
              }
            }, Et.updateSrc = function(hr, hn) {
              var oa = hn.name, ha = hn.namespace, Zo = hn.new_value, Ds = (hn.existing_value, hn.variable_removed);
              ha.shift();
              var Gs, ns = Et.get(hr, "global", "src"), Vl = Et.deepCopy(ns, ga(ha)), ac = Vl, yo = $r(ha);
              try {
                for (yo.s(); !(Gs = yo.n()).done; )
                  ac = ac[Gs.value];
              } catch (Yc) {
                yo.e(Yc);
              } finally {
                yo.f();
              }
              return Ds ? we(ac) == "array" ? ac.splice(oa, 1) : delete ac[oa] : oa !== null ? ac[oa] = Zo : Vl = Zo, Et.set(hr, "global", "src", Vl), Vl;
            }, Et.deepCopy = function(hr, hn) {
              var oa, ha = we(hr), Zo = hn.shift();
              return ha == "array" ? oa = ga(hr) : ha == "object" && (oa = g4({}, hr)), Zo !== void 0 && (oa[Zo] = Et.deepCopy(hr[Zo], hn)), oa;
            }, Et;
          }
          return lt2;
        }(Za.EventEmitter))();
        $a.register(Pa.handleAction.bind(Pa));
        var da = Pa, Ra = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).toggleCollapsed = function() {
              kt.setState({ collapsed: !kt.state.collapsed }, function() {
                da.set(kt.props.rjvId, kt.props.namespace, "collapsed", kt.state.collapsed);
              });
            }, kt.getFunctionDisplay = function(tt) {
              var Ir = N(kt).props;
              return tt ? q2.a.createElement("span", null, kt.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), q2.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, q2.a.createElement("span", null, "{"), q2.a.createElement("span", et(Ir.theme, "ellipsis"), "..."), q2.a.createElement("span", null, "}"))) : kt.props.value.toString().slice(9, -1);
            }, kt.state = { collapsed: da.get(Et.rjvId, Et.namespace, "collapsed", true) }, kt;
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = this.state.collapsed;
            return q2.a.createElement("div", et(Et.theme, "function"), q2.a.createElement(Jt, Object.assign({ type_name: "function" }, Et)), q2.a.createElement("span", Object.assign({}, et(Et.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(kt)));
          } }]), lt2;
        }(q2.a.PureComponent), Wa = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            return q2.a.createElement("div", et(this.props.theme, "nan"), "NaN");
          } }]), lt2;
        }(q2.a.PureComponent), wa = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            return q2.a.createElement("div", et(this.props.theme, "null"), "NULL");
          } }]), lt2;
        }(q2.a.PureComponent), li = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props;
            return q2.a.createElement("div", et(Et.theme, "integer"), q2.a.createElement(Jt, Object.assign({ type_name: "int" }, Et)), this.props.value);
          } }]), lt2;
        }(q2.a.PureComponent), Ts = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props;
            return q2.a.createElement("div", et(Et.theme, "regexp"), q2.a.createElement(Jt, Object.assign({ type_name: "regexp" }, Et)), this.props.value.toString());
          } }]), lt2;
        }(q2.a.PureComponent), wi = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).toggleCollapsed = function() {
              kt.setState({ collapsed: !kt.state.collapsed }, function() {
                da.set(kt.props.rjvId, kt.props.namespace, "collapsed", kt.state.collapsed);
              });
            }, kt.state = { collapsed: da.get(Et.rjvId, Et.namespace, "collapsed", true) }, kt;
          }
          return w4(lt2, [{ key: "render", value: function() {
            this.state.collapsed;
            var Et = this.props, kt = Et.collapseStringsAfterLength, tt = Et.theme, Ir = Et.value, hr = { style: { cursor: "default" } };
            return we(kt) === "integer" && Ir.length > kt && (hr.style.cursor = "pointer", this.state.collapsed && (Ir = q2.a.createElement("span", null, Ir.substring(0, kt), q2.a.createElement("span", et(tt, "ellipsis"), " ...")))), q2.a.createElement("div", et(tt, "string"), q2.a.createElement(Jt, Object.assign({ type_name: "string" }, Et)), q2.a.createElement("span", Object.assign({ className: "string-value" }, hr, { onClick: this.toggleCollapsed }), '"', Ir, '"'));
          } }]), lt2;
        }(q2.a.PureComponent), ps = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            return q2.a.createElement("div", et(this.props.theme, "undefined"), "undefined");
          } }]), lt2;
        }(q2.a.PureComponent);
        function Bs() {
          return (Bs = Object.assign || function(Lt) {
            for (var zt = 1; zt < arguments.length; zt++) {
              var lt2 = arguments[zt];
              for (var Et in lt2)
                Object.prototype.hasOwnProperty.call(lt2, Et) && (Lt[Et] = lt2[Et]);
            }
            return Lt;
          }).apply(this, arguments);
        }
        var vl = X.useLayoutEffect, If = function(Lt) {
          var zt = Object(X.useRef)(Lt);
          return vl(function() {
            zt.current = Lt;
          }), zt;
        }, Xl = function(Lt, zt) {
          typeof Lt != "function" ? Lt.current = zt : Lt(zt);
        }, _h = function(Lt, zt) {
          var lt2 = Object(X.useRef)();
          return Object(X.useCallback)(function(Et) {
            Lt.current = Et, lt2.current && Xl(lt2.current, null), lt2.current = zt, zt && Xl(zt, Et);
          }, [zt]);
        }, Nl = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Uc = function(Lt) {
          Object.keys(Nl).forEach(function(zt) {
            Lt.style.setProperty(zt, Nl[zt], "important");
          });
        }, Nu = null, om = function() {
        }, Rr = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], $n = !!document.documentElement.currentStyle, Bn = function(Lt, zt) {
          var lt2 = Lt.cacheMeasurements, Et = Lt.maxRows, kt = Lt.minRows, tt = Lt.onChange, Ir = tt === void 0 ? om : tt, hr = Lt.onHeightChange, hn = hr === void 0 ? om : hr, oa = function(yo, Yc) {
            if (yo == null)
              return {};
            var Tc, tg, tx = {}, nd = Object.keys(yo);
            for (tg = 0; tg < nd.length; tg++)
              Tc = nd[tg], Yc.indexOf(Tc) >= 0 || (tx[Tc] = yo[Tc]);
            return tx;
          }(Lt, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), ha, Zo = oa.value !== void 0, Ds = Object(X.useRef)(null), Gs = _h(Ds, zt), ns = Object(X.useRef)(0), Vl = Object(X.useRef)(), ac = function() {
            var yo = Ds.current, Yc = lt2 && Vl.current ? Vl.current : function(nd) {
              var sm = window.getComputedStyle(nd);
              if (sm === null)
                return null;
              var Hy, Tf = (Hy = sm, Rr.reduce(function(nx, lm) {
                return nx[lm] = Hy[lm], nx;
              }, {})), ng = Tf.boxSizing;
              return ng === "" ? null : ($n && ng === "border-box" && (Tf.width = parseFloat(Tf.width) + parseFloat(Tf.borderRightWidth) + parseFloat(Tf.borderLeftWidth) + parseFloat(Tf.paddingRight) + parseFloat(Tf.paddingLeft) + "px"), { sizingStyle: Tf, paddingSize: parseFloat(Tf.paddingBottom) + parseFloat(Tf.paddingTop), borderSize: parseFloat(Tf.borderBottomWidth) + parseFloat(Tf.borderTopWidth) });
            }(yo);
            if (Yc) {
              Vl.current = Yc;
              var Tc = function(nd, sm, Hy, Tf) {
                Hy === void 0 && (Hy = 1), Tf === void 0 && (Tf = 1 / 0), Nu || ((Nu = document.createElement("textarea")).setAttribute("tab-index", "-1"), Nu.setAttribute("aria-hidden", "true"), Uc(Nu)), Nu.parentNode === null && document.body.appendChild(Nu);
                var ng = nd.paddingSize, nx = nd.borderSize, lm = nd.sizingStyle, um = lm.boxSizing;
                Object.keys(lm).forEach(function(Qa) {
                  var Di = Qa;
                  Nu.style[Di] = lm[Di];
                }), Uc(Nu), Nu.value = sm;
                var $y = function(Qa, Di) {
                  var ax = Qa.scrollHeight;
                  return Di.sizingStyle.boxSizing === "border-box" ? ax + Di.borderSize : ax - Di.paddingSize;
                }(Nu, nd);
                Nu.value = "x";
                var cM = Nu.scrollHeight - ng, rx = cM * Hy;
                um === "border-box" && (rx = rx + ng + nx), $y = Math.max(rx, $y);
                var cb = cM * Tf;
                return um === "border-box" && (cb = cb + ng + nx), [$y = Math.min(cb, $y), cM];
              }(Yc, yo.value || yo.placeholder || "x", kt, Et), tg = Tc[0], tx = Tc[1];
              ns.current !== tg && (ns.current = tg, yo.style.setProperty("height", tg + "px", "important"), hn(tg, { rowHeight: tx }));
            }
          };
          return Object(X.useLayoutEffect)(ac), ha = If(ac), Object(X.useLayoutEffect)(function() {
            var yo = function(Yc) {
              ha.current(Yc);
            };
            return window.addEventListener("resize", yo), function() {
              window.removeEventListener("resize", yo);
            };
          }, []), Object(X.createElement)("textarea", Bs({}, oa, { onChange: function(yo) {
            Zo || ac(), Ir(yo);
          }, ref: Gs }));
        }, Fr = Object(X.forwardRef)(Bn);
        function Oa(Lt) {
          Lt = Lt.trim();
          try {
            if ((Lt = JSON.stringify(JSON.parse(Lt)))[0] === "[")
              return yi("array", JSON.parse(Lt));
            if (Lt[0] === "{")
              return yi("object", JSON.parse(Lt));
            if (Lt.match(/\-?\d+\.\d+/) && Lt.match(/\-?\d+\.\d+/)[0] === Lt)
              return yi("float", parseFloat(Lt));
            if (Lt.match(/\-?\d+e-\d+/) && Lt.match(/\-?\d+e-\d+/)[0] === Lt)
              return yi("float", Number(Lt));
            if (Lt.match(/\-?\d+/) && Lt.match(/\-?\d+/)[0] === Lt)
              return yi("integer", parseInt(Lt));
            if (Lt.match(/\-?\d+e\+\d+/) && Lt.match(/\-?\d+e\+\d+/)[0] === Lt)
              return yi("integer", Number(Lt));
          } catch {
          }
          switch (Lt = Lt.toLowerCase()) {
            case "undefined":
              return yi("undefined", void 0);
            case "nan":
              return yi("nan", NaN);
            case "null":
              return yi("null", null);
            case "true":
              return yi("boolean", true);
            case "false":
              return yi("boolean", false);
            default:
              if (Lt = Date.parse(Lt))
                return yi("date", new Date(Lt));
          }
          return yi(false, null);
        }
        function yi(Lt, zt) {
          return { type: Lt, value: zt };
        }
        var Bo = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
          } }]), lt2;
        }(q2.a.PureComponent), jo = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
          } }]), lt2;
        }(q2.a.PureComponent), xl = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]), Ir = js(kt).style;
            return q2.a.createElement("span", tt, q2.a.createElement("svg", { fill: Ir.color, width: Ir.height, height: Ir.width, style: Ir, viewBox: "0 0 1792 1792" }, q2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), lt2;
        }(q2.a.PureComponent), Uu = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]), Ir = js(kt).style;
            return q2.a.createElement("span", tt, q2.a.createElement("svg", { fill: Ir.color, width: Ir.height, height: Ir.width, style: Ir, viewBox: "0 0 1792 1792" }, q2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), lt2;
        }(q2.a.PureComponent), vu = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", { style: g4(g4({}, js(kt).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, q2.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
          } }]), lt2;
        }(q2.a.PureComponent), qc = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", { style: g4(g4({}, js(kt).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, q2.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
          } }]), lt2;
        }(q2.a.PureComponent), gu = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("g", null, q2.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
          } }]), lt2;
        }(q2.a.PureComponent), td = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("g", null, q2.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), lt2;
        }(q2.a.PureComponent), jd = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("g", null, q2.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), lt2;
        }(q2.a.PureComponent), Qv = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("g", null, q2.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
          } }]), lt2;
        }(q2.a.PureComponent), Gd = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("g", null, q2.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
          } }]), lt2;
        }(q2.a.PureComponent), xc = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.style, tt = be(Et, ["style"]);
            return q2.a.createElement("span", tt, q2.a.createElement("svg", Object.assign({}, js(kt), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), q2.a.createElement("g", null, q2.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), lt2;
        }(q2.a.PureComponent);
        function js(Lt) {
          return Lt || (Lt = {}), { style: g4(g4({ verticalAlign: "middle" }, Lt), {}, { color: Lt.color ? Lt.color : "#000000", height: "1em", width: "1em" }) };
        }
        var vf = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).copiedTimer = null, kt.handleCopy = function() {
              var tt = document.createElement("textarea"), Ir = kt.props, hr = Ir.clickCallback, hn = Ir.src, oa = Ir.namespace;
              tt.innerHTML = JSON.stringify(kt.clipboardValue(hn), null, "  "), document.body.appendChild(tt), tt.select(), document.execCommand("copy"), document.body.removeChild(tt), kt.copiedTimer = setTimeout(function() {
                kt.setState({ copied: false });
              }, 5500), kt.setState({ copied: true }, function() {
                typeof hr == "function" && hr({ src: hn, namespace: oa, name: oa[oa.length - 1] });
              });
            }, kt.getClippyIcon = function() {
              var tt = kt.props.theme;
              return kt.state.copied ? q2.a.createElement("span", null, q2.a.createElement(gu, Object.assign({ className: "copy-icon" }, et(tt, "copy-icon"))), q2.a.createElement("span", et(tt, "copy-icon-copied"), "\u2714")) : q2.a.createElement(gu, Object.assign({ className: "copy-icon" }, et(tt, "copy-icon")));
            }, kt.clipboardValue = function(tt) {
              switch (we(tt)) {
                case "function":
                case "regexp":
                  return tt.toString();
                default:
                  return tt;
              }
            }, kt.state = { copied: false }, kt;
          }
          return w4(lt2, [{ key: "componentWillUnmount", value: function() {
            this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
          } }, { key: "render", value: function() {
            var Et = this.props, kt = (Et.src, Et.theme), tt = Et.hidden, Ir = Et.rowHovered, hr = et(kt, "copy-to-clipboard").style, hn = "inline";
            return tt && (hn = "none"), q2.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Ir ? "inline-block" : "none" } }, q2.a.createElement("span", { style: g4(g4({}, hr), {}, { display: hn }), onClick: this.handleCopy }, this.getClippyIcon()));
          } }]), lt2;
        }(q2.a.PureComponent), xh = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).getEditIcon = function() {
              var tt = kt.props, Ir = tt.variable, hr = tt.theme;
              return q2.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: kt.state.hovered ? "inline-block" : "none" } }, q2.a.createElement(Gd, Object.assign({ className: "click-to-edit-icon" }, et(hr, "editVarIcon"), { onClick: function() {
                kt.prepopInput(Ir);
              } })));
            }, kt.prepopInput = function(tt) {
              if (kt.props.onEdit !== false) {
                var Ir = function(hn) {
                  var oa;
                  switch (we(hn)) {
                    case "undefined":
                      oa = "undefined";
                      break;
                    case "nan":
                      oa = "NaN";
                      break;
                    case "string":
                      oa = hn;
                      break;
                    case "date":
                    case "function":
                    case "regexp":
                      oa = hn.toString();
                      break;
                    default:
                      try {
                        oa = JSON.stringify(hn, null, "  ");
                      } catch {
                        oa = "";
                      }
                  }
                  return oa;
                }(tt.value), hr = Oa(Ir);
                kt.setState({ editMode: true, editValue: Ir, parsedInput: { type: hr.type, value: hr.value } });
              }
            }, kt.getRemoveIcon = function() {
              var tt = kt.props, Ir = tt.variable, hr = tt.namespace, hn = tt.theme, oa = tt.rjvId;
              return q2.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: kt.state.hovered ? "inline-block" : "none" } }, q2.a.createElement(td, Object.assign({ className: "click-to-remove-icon" }, et(hn, "removeVarIcon"), { onClick: function() {
                $a.dispatch({ name: "VARIABLE_REMOVED", rjvId: oa, data: { name: Ir.name, namespace: hr, existing_value: Ir.value, variable_removed: true } });
              } })));
            }, kt.getValue = function(tt, Ir) {
              var hr = !Ir && tt.type, hn = N(kt).props;
              switch (hr) {
                case false:
                  return kt.getEditInput();
                case "string":
                  return q2.a.createElement(wi, Object.assign({ value: tt.value }, hn));
                case "integer":
                  return q2.a.createElement(li, Object.assign({ value: tt.value }, hn));
                case "float":
                  return q2.a.createElement(Wt, Object.assign({ value: tt.value }, hn));
                case "boolean":
                  return q2.a.createElement(xt, Object.assign({ value: tt.value }, hn));
                case "function":
                  return q2.a.createElement(Ra, Object.assign({ value: tt.value }, hn));
                case "null":
                  return q2.a.createElement(wa, hn);
                case "nan":
                  return q2.a.createElement(Wa, hn);
                case "undefined":
                  return q2.a.createElement(ps, hn);
                case "date":
                  return q2.a.createElement(It, Object.assign({ value: tt.value }, hn));
                case "regexp":
                  return q2.a.createElement(Ts, Object.assign({ value: tt.value }, hn));
                default:
                  return q2.a.createElement("div", { className: "object-value" }, JSON.stringify(tt.value));
              }
            }, kt.getEditInput = function() {
              var tt = kt.props.theme, Ir = kt.state.editValue;
              return q2.a.createElement("div", null, q2.a.createElement(Fr, Object.assign({ type: "text", inputRef: function(hr) {
                return hr && hr.focus();
              }, value: Ir, className: "variable-editor", onChange: function(hr) {
                var hn = hr.target.value, oa = Oa(hn);
                kt.setState({ editValue: hn, parsedInput: { type: oa.type, value: oa.value } });
              }, onKeyDown: function(hr) {
                switch (hr.key) {
                  case "Escape":
                    kt.setState({ editMode: false, editValue: "" });
                    break;
                  case "Enter":
                    (hr.ctrlKey || hr.metaKey) && kt.submitEdit(true);
                }
                hr.stopPropagation();
              }, placeholder: "update this value", minRows: 2 }, et(tt, "edit-input"))), q2.a.createElement("div", et(tt, "edit-icon-container"), q2.a.createElement(td, Object.assign({ className: "edit-cancel" }, et(tt, "cancel-icon"), { onClick: function() {
                kt.setState({ editMode: false, editValue: "" });
              } })), q2.a.createElement(xc, Object.assign({ className: "edit-check string-value" }, et(tt, "check-icon"), { onClick: function() {
                kt.submitEdit();
              } })), q2.a.createElement("div", null, kt.showDetected())));
            }, kt.submitEdit = function(tt) {
              var Ir = kt.props, hr = Ir.variable, hn = Ir.namespace, oa = Ir.rjvId, ha = kt.state, Zo = ha.editValue, Ds = ha.parsedInput, Gs = Zo;
              tt && Ds.type && (Gs = Ds.value), kt.setState({ editMode: false }), $a.dispatch({ name: "VARIABLE_UPDATED", rjvId: oa, data: { name: hr.name, namespace: hn, existing_value: hr.value, new_value: Gs, variable_removed: false } });
            }, kt.showDetected = function() {
              var tt = kt.props, Ir = tt.theme, hr = (tt.variable, tt.namespace, tt.rjvId, kt.state.parsedInput), hn = (hr.type, hr.value, kt.getDetectedInput());
              if (hn)
                return q2.a.createElement("div", null, q2.a.createElement("div", et(Ir, "detected-row"), hn, q2.a.createElement(xc, { className: "edit-check detected", style: g4({ verticalAlign: "top", paddingLeft: "3px" }, et(Ir, "check-icon").style), onClick: function() {
                  kt.submitEdit(true);
                } })));
            }, kt.getDetectedInput = function() {
              var tt = kt.state.parsedInput, Ir = tt.type, hr = tt.value, hn = N(kt).props, oa = hn.theme;
              if (Ir !== false)
                switch (Ir.toLowerCase()) {
                  case "object":
                    return q2.a.createElement("span", null, q2.a.createElement("span", { style: g4(g4({}, et(oa, "brace").style), {}, { cursor: "default" }) }, "{"), q2.a.createElement("span", { style: g4(g4({}, et(oa, "ellipsis").style), {}, { cursor: "default" }) }, "..."), q2.a.createElement("span", { style: g4(g4({}, et(oa, "brace").style), {}, { cursor: "default" }) }, "}"));
                  case "array":
                    return q2.a.createElement("span", null, q2.a.createElement("span", { style: g4(g4({}, et(oa, "brace").style), {}, { cursor: "default" }) }, "["), q2.a.createElement("span", { style: g4(g4({}, et(oa, "ellipsis").style), {}, { cursor: "default" }) }, "..."), q2.a.createElement("span", { style: g4(g4({}, et(oa, "brace").style), {}, { cursor: "default" }) }, "]"));
                  case "string":
                    return q2.a.createElement(wi, Object.assign({ value: hr }, hn));
                  case "integer":
                    return q2.a.createElement(li, Object.assign({ value: hr }, hn));
                  case "float":
                    return q2.a.createElement(Wt, Object.assign({ value: hr }, hn));
                  case "boolean":
                    return q2.a.createElement(xt, Object.assign({ value: hr }, hn));
                  case "function":
                    return q2.a.createElement(Ra, Object.assign({ value: hr }, hn));
                  case "null":
                    return q2.a.createElement(wa, hn);
                  case "nan":
                    return q2.a.createElement(Wa, hn);
                  case "undefined":
                    return q2.a.createElement(ps, hn);
                  case "date":
                    return q2.a.createElement(It, Object.assign({ value: new Date(hr) }, hn));
                }
            }, kt.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, kt;
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this, kt = this.props, tt = kt.variable, Ir = kt.singleIndent, hr = kt.type, hn = kt.theme, oa = kt.namespace, ha = kt.indentWidth, Zo = kt.enableClipboard, Ds = kt.onEdit, Gs = kt.onDelete, ns = kt.onSelect, Vl = kt.displayArrayKey, ac = kt.quotesOnKeys, yo = this.state.editMode;
            return q2.a.createElement("div", Object.assign({}, et(hn, "objectKeyVal", { paddingLeft: ha * Ir }), { onMouseEnter: function() {
              return Et.setState(g4(g4({}, Et.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return Et.setState(g4(g4({}, Et.state), {}, { hovered: false }));
            }, className: "variable-row", key: tt.name }), hr == "array" ? Vl ? q2.a.createElement("span", Object.assign({}, et(hn, "array-key"), { key: tt.name + "_" + oa }), tt.name, q2.a.createElement("div", et(hn, "colon"), ":")) : null : q2.a.createElement("span", null, q2.a.createElement("span", Object.assign({}, et(hn, "object-name"), { className: "object-key", key: tt.name + "_" + oa }), !!ac && q2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), q2.a.createElement("span", { style: { display: "inline-block" } }, tt.name), !!ac && q2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), q2.a.createElement("span", et(hn, "colon"), ":")), q2.a.createElement("div", Object.assign({ className: "variable-value", onClick: ns === false && Ds === false ? null : function(Yc) {
              var Tc = ga(oa);
              (Yc.ctrlKey || Yc.metaKey) && Ds !== false ? Et.prepopInput(tt) : ns !== false && (Tc.shift(), ns(g4(g4({}, tt), {}, { namespace: Tc })));
            } }, et(hn, "variableValue", { cursor: ns === false ? "default" : "pointer" })), this.getValue(tt, yo)), Zo ? q2.a.createElement(vf, { rowHovered: this.state.hovered, hidden: yo, src: tt.value, clickCallback: Zo, theme: hn, namespace: [].concat(ga(oa), [tt.name]) }) : null, Ds !== false && yo == 0 ? this.getEditIcon() : null, Gs !== false && yo == 0 ? this.getRemoveIcon() : null);
          } }]), lt2;
        }(q2.a.PureComponent), eg = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            var Et;
            y4(this, lt2);
            for (var kt = arguments.length, tt = new Array(kt), Ir = 0; Ir < kt; Ir++)
              tt[Ir] = arguments[Ir];
            return (Et = zt.call.apply(zt, [this].concat(tt))).getObjectSize = function() {
              var hr = Et.props, hn = hr.size, oa = hr.theme;
              if (hr.displayObjectSize)
                return q2.a.createElement("span", Object.assign({ className: "object-size" }, et(oa, "object-size")), hn, " item", hn === 1 ? "" : "s");
            }, Et.getAddAttribute = function(hr) {
              var hn = Et.props, oa = hn.theme, ha = hn.namespace, Zo = hn.name, Ds = hn.src, Gs = hn.rjvId, ns = hn.depth;
              return q2.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: hr ? "inline-block" : "none" } }, q2.a.createElement(jd, Object.assign({ className: "click-to-add-icon" }, et(oa, "addVarIcon"), { onClick: function() {
                var Vl = { name: ns > 0 ? Zo : null, namespace: ha.splice(0, ha.length - 1), existing_value: Ds, variable_removed: false, key_name: null };
                we(Ds) === "object" ? $a.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Gs, data: Vl }) : $a.dispatch({ name: "VARIABLE_ADDED", rjvId: Gs, data: g4(g4({}, Vl), {}, { new_value: [].concat(ga(Ds), [null]) }) });
              } })));
            }, Et.getRemoveObject = function(hr) {
              var hn = Et.props, oa = hn.theme, ha = (hn.hover, hn.namespace), Zo = hn.name, Ds = hn.src, Gs = hn.rjvId;
              if (ha.length !== 1)
                return q2.a.createElement("span", { className: "click-to-remove", style: { display: hr ? "inline-block" : "none" } }, q2.a.createElement(td, Object.assign({ className: "click-to-remove-icon" }, et(oa, "removeVarIcon"), { onClick: function() {
                  $a.dispatch({ name: "VARIABLE_REMOVED", rjvId: Gs, data: { name: Zo, namespace: ha.splice(0, ha.length - 1), existing_value: Ds, variable_removed: true } });
                } })));
            }, Et.render = function() {
              var hr = Et.props, hn = hr.theme, oa = hr.onDelete, ha = hr.onAdd, Zo = hr.enableClipboard, Ds = hr.src, Gs = hr.namespace, ns = hr.rowHovered;
              return q2.a.createElement("div", Object.assign({}, et(hn, "object-meta-data"), { className: "object-meta-data", onClick: function(Vl) {
                Vl.stopPropagation();
              } }), Et.getObjectSize(), Zo ? q2.a.createElement(vf, { rowHovered: ns, clickCallback: Zo, src: Ds, theme: hn, namespace: Gs }) : null, ha !== false ? Et.getAddAttribute(ns) : null, oa !== false ? Et.getRemoveObject(ns) : null);
            }, Et;
          }
          return lt2;
        }(q2.a.PureComponent);
        function Ep(Lt) {
          var zt = Lt.parent_type, lt2 = Lt.namespace, Et = Lt.quotesOnKeys, kt = Lt.theme, tt = Lt.jsvRoot, Ir = Lt.name, hr = Lt.displayArrayKey, hn = Lt.name ? Lt.name : "";
          return !tt || Ir !== false && Ir !== null ? zt == "array" ? hr ? q2.a.createElement("span", Object.assign({}, et(kt, "array-key"), { key: lt2 }), q2.a.createElement("span", { className: "array-key" }, hn), q2.a.createElement("span", et(kt, "colon"), ":")) : q2.a.createElement("span", null) : q2.a.createElement("span", Object.assign({}, et(kt, "object-name"), { key: lt2 }), q2.a.createElement("span", { className: "object-key" }, Et && q2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), q2.a.createElement("span", null, hn), Et && q2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), q2.a.createElement("span", et(kt, "colon"), ":")) : q2.a.createElement("span", null);
        }
        function Wd(Lt) {
          var zt = Lt.theme;
          switch (Lt.iconStyle) {
            case "triangle":
              return q2.a.createElement(qc, Object.assign({}, et(zt, "expanded-icon"), { className: "expanded-icon" }));
            case "square":
              return q2.a.createElement(xl, Object.assign({}, et(zt, "expanded-icon"), { className: "expanded-icon" }));
            default:
              return q2.a.createElement(Bo, Object.assign({}, et(zt, "expanded-icon"), { className: "expanded-icon" }));
          }
        }
        function bv(Lt) {
          var zt = Lt.theme;
          switch (Lt.iconStyle) {
            case "triangle":
              return q2.a.createElement(vu, Object.assign({}, et(zt, "collapsed-icon"), { className: "collapsed-icon" }));
            case "square":
              return q2.a.createElement(Uu, Object.assign({}, et(zt, "collapsed-icon"), { className: "collapsed-icon" }));
            default:
              return q2.a.createElement(jo, Object.assign({}, et(zt, "collapsed-icon"), { className: "collapsed-icon" }));
          }
        }
        var ub = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).toggleCollapsed = function(tt) {
              var Ir = [];
              for (var hr in kt.state.expanded)
                Ir.push(kt.state.expanded[hr]);
              Ir[tt] = !Ir[tt], kt.setState({ expanded: Ir });
            }, kt.state = { expanded: [] }, kt;
          }
          return w4(lt2, [{ key: "getExpandedIcon", value: function(Et) {
            var kt = this.props, tt = kt.theme, Ir = kt.iconStyle;
            return this.state.expanded[Et] ? q2.a.createElement(Wd, { theme: tt, iconStyle: Ir }) : q2.a.createElement(bv, { theme: tt, iconStyle: Ir });
          } }, { key: "render", value: function() {
            var Et = this, kt = this.props, tt = kt.src, Ir = kt.groupArraysAfterLength, hr = (kt.depth, kt.name), hn = kt.theme, oa = kt.jsvRoot, ha = kt.namespace, Zo = (kt.parent_type, be(kt, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Ds = 0, Gs = 5 * this.props.indentWidth;
            oa || (Ds = 5 * this.props.indentWidth);
            var ns = Ir, Vl = Math.ceil(tt.length / ns);
            return q2.a.createElement("div", Object.assign({ className: "object-key-val" }, et(hn, oa ? "jsv-root" : "objectKeyVal", { paddingLeft: Ds })), q2.a.createElement(Ep, this.props), q2.a.createElement("span", null, q2.a.createElement(eg, Object.assign({ size: tt.length }, this.props))), ga(Array(Vl)).map(function(ac, yo) {
              return q2.a.createElement("div", Object.assign({ key: yo, className: "object-key-val array-group" }, et(hn, "objectKeyVal", { marginLeft: 6, paddingLeft: Gs })), q2.a.createElement("span", et(hn, "brace-row"), q2.a.createElement("div", Object.assign({ className: "icon-container" }, et(hn, "icon-container"), { onClick: function(Yc) {
                Et.toggleCollapsed(yo);
              } }), Et.getExpandedIcon(yo)), Et.state.expanded[yo] ? q2.a.createElement(Wy, Object.assign({ key: hr + yo, depth: 0, name: false, collapsed: false, groupArraysAfterLength: ns, index_offset: yo * ns, src: tt.slice(yo * ns, yo * ns + ns), namespace: ha, type: "array", parent_type: "array_group", theme: hn }, Zo)) : q2.a.createElement("span", Object.assign({}, et(hn, "brace"), { onClick: function(Yc) {
                Et.toggleCollapsed(yo);
              }, className: "array-group-brace" }), "[", q2.a.createElement("div", Object.assign({}, et(hn, "array-group-meta-data"), { className: "array-group-meta-data" }), q2.a.createElement("span", Object.assign({ className: "object-size" }, et(hn, "object-size")), yo * ns, " - ", yo * ns + ns > tt.length ? tt.length : yo * ns + ns)), "]")));
            }));
          } }]), lt2;
        }(q2.a.PureComponent), Gy = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            y4(this, lt2), (kt = zt.call(this, Et)).toggleCollapsed = function() {
              kt.setState({ expanded: !kt.state.expanded }, function() {
                da.set(kt.props.rjvId, kt.props.namespace, "expanded", kt.state.expanded);
              });
            }, kt.getObjectContent = function(Ir, hr, hn) {
              return q2.a.createElement("div", { className: "pushed-content object-container" }, q2.a.createElement("div", Object.assign({ className: "object-content" }, et(kt.props.theme, "pushed-content")), kt.renderObjectContents(hr, hn)));
            }, kt.getEllipsis = function() {
              return kt.state.size === 0 ? null : q2.a.createElement("div", Object.assign({}, et(kt.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: kt.toggleCollapsed }), "...");
            }, kt.getObjectMetaData = function(Ir) {
              var hr = kt.props, hn = (hr.rjvId, hr.theme, kt.state), oa = hn.size, ha = hn.hovered;
              return q2.a.createElement(eg, Object.assign({ rowHovered: ha, size: oa }, kt.props));
            }, kt.renderObjectContents = function(Ir, hr) {
              var hn, oa = kt.props, ha = oa.depth, Zo = oa.parent_type, Ds = oa.index_offset, Gs = oa.groupArraysAfterLength, ns = oa.namespace, Vl = kt.state.object_type, ac = [], yo = Object.keys(Ir || {});
              return kt.props.sortKeys && Vl !== "array" && (yo = yo.sort()), yo.forEach(function(Yc) {
                if (hn = new uM(Yc, Ir[Yc]), Zo === "array_group" && Ds && (hn.name = parseInt(hn.name) + Ds), Ir.hasOwnProperty(Yc))
                  if (hn.type === "object")
                    ac.push(q2.a.createElement(Wy, Object.assign({ key: hn.name, depth: ha + 1, name: hn.name, src: hn.value, namespace: ns.concat(hn.name), parent_type: Vl }, hr)));
                  else if (hn.type === "array") {
                    var Tc = Wy;
                    Gs && hn.value.length > Gs && (Tc = ub), ac.push(q2.a.createElement(Tc, Object.assign({ key: hn.name, depth: ha + 1, name: hn.name, src: hn.value, namespace: ns.concat(hn.name), type: "array", parent_type: Vl }, hr)));
                  } else
                    ac.push(q2.a.createElement(xh, Object.assign({ key: hn.name + "_" + ns, variable: hn, singleIndent: 5, namespace: ns, type: kt.props.type }, hr)));
              }), ac;
            };
            var tt = lt2.getState(Et);
            return kt.state = g4(g4({}, tt), {}, { prevProps: {} }), kt;
          }
          return w4(lt2, [{ key: "getBraceStart", value: function(Et, kt) {
            var tt = this, Ir = this.props, hr = Ir.src, hn = Ir.theme, oa = Ir.iconStyle;
            if (Ir.parent_type === "array_group")
              return q2.a.createElement("span", null, q2.a.createElement("span", et(hn, "brace"), Et === "array" ? "[" : "{"), kt ? this.getObjectMetaData(hr) : null);
            var ha = kt ? Wd : bv;
            return q2.a.createElement("span", null, q2.a.createElement("span", Object.assign({ onClick: function(Zo) {
              tt.toggleCollapsed();
            } }, et(hn, "brace-row")), q2.a.createElement("div", Object.assign({ className: "icon-container" }, et(hn, "icon-container")), q2.a.createElement(ha, { theme: hn, iconStyle: oa })), q2.a.createElement(Ep, this.props), q2.a.createElement("span", et(hn, "brace"), Et === "array" ? "[" : "{")), kt ? this.getObjectMetaData(hr) : null);
          } }, { key: "render", value: function() {
            var Et = this, kt = this.props, tt = kt.depth, Ir = kt.src, hr = (kt.namespace, kt.name, kt.type, kt.parent_type), hn = kt.theme, oa = kt.jsvRoot, ha = kt.iconStyle, Zo = be(kt, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Ds = this.state, Gs = Ds.object_type, ns = Ds.expanded, Vl = {};
            return oa || hr === "array_group" ? hr === "array_group" && (Vl.borderLeft = 0, Vl.display = "inline") : Vl.paddingLeft = 5 * this.props.indentWidth, q2.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
              return Et.setState(g4(g4({}, Et.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return Et.setState(g4(g4({}, Et.state), {}, { hovered: false }));
            } }, et(hn, oa ? "jsv-root" : "objectKeyVal", Vl)), this.getBraceStart(Gs, ns), ns ? this.getObjectContent(tt, Ir, g4({ theme: hn, iconStyle: ha }, Zo)) : this.getEllipsis(), q2.a.createElement("span", { className: "brace-row" }, q2.a.createElement("span", { style: g4(g4({}, et(hn, "brace").style), {}, { paddingLeft: ns ? "3px" : "0px" }) }, Gs === "array" ? "]" : "}"), ns ? null : this.getObjectMetaData(Ir)));
          } }], [{ key: "getDerivedStateFromProps", value: function(Et, kt) {
            var tt = kt.prevProps;
            return Et.src !== tt.src || Et.collapsed !== tt.collapsed || Et.name !== tt.name || Et.namespace !== tt.namespace || Et.rjvId !== tt.rjvId ? g4(g4({}, lt2.getState(Et)), {}, { prevProps: Et }) : null;
          } }]), lt2;
        }(q2.a.PureComponent);
        Gy.getState = function(Lt) {
          var zt = Object.keys(Lt.src).length, lt2 = (Lt.collapsed === false || Lt.collapsed !== true && Lt.collapsed > Lt.depth) && (!Lt.shouldCollapse || Lt.shouldCollapse({ name: Lt.name, src: Lt.src, type: we(Lt.src), namespace: Lt.namespace }) === false) && zt !== 0;
          return { expanded: da.get(Lt.rjvId, Lt.namespace, "expanded", lt2), object_type: Lt.type === "array" ? "array" : "object", parent_type: Lt.type === "array" ? "array" : "object", size: zt, hovered: false };
        };
        var uM = function Lt(zt, lt2) {
          y4(this, Lt), this.name = zt, this.value = lt2, this.type = we(lt2);
        };
        ye(Gy);
        var Wy = Gy, oL = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            var Et;
            y4(this, lt2);
            for (var kt = arguments.length, tt = new Array(kt), Ir = 0; Ir < kt; Ir++)
              tt[Ir] = arguments[Ir];
            return (Et = zt.call.apply(zt, [this].concat(tt))).render = function() {
              var hr = N(Et).props, hn = [hr.name], oa = Wy;
              return Array.isArray(hr.src) && hr.groupArraysAfterLength && hr.src.length > hr.groupArraysAfterLength && (oa = ub), q2.a.createElement("div", { className: "pretty-json-container object-container" }, q2.a.createElement("div", { className: "object-content" }, q2.a.createElement(oa, Object.assign({ namespace: hn, depth: 0, jsvRoot: true }, hr))));
            }, Et;
          }
          return lt2;
        }(q2.a.PureComponent), sL = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).closeModal = function() {
              $a.dispatch({ rjvId: kt.props.rjvId, name: "RESET" });
            }, kt.submit = function() {
              kt.props.submit(kt.state.input);
            }, kt.state = { input: Et.input ? Et.input : "" }, kt;
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this, kt = this.props, tt = kt.theme, Ir = kt.rjvId, hr = kt.isValid, hn = this.state.input, oa = hr(hn);
            return q2.a.createElement("div", Object.assign({ className: "key-modal-request" }, et(tt, "key-modal-request"), { onClick: this.closeModal }), q2.a.createElement("div", Object.assign({}, et(tt, "key-modal"), { onClick: function(ha) {
              ha.stopPropagation();
            } }), q2.a.createElement("div", et(tt, "key-modal-label"), "Key Name:"), q2.a.createElement("div", { style: { position: "relative" } }, q2.a.createElement("input", Object.assign({}, et(tt, "key-modal-input"), { className: "key-modal-input", ref: function(ha) {
              return ha && ha.focus();
            }, spellCheck: false, value: hn, placeholder: "...", onChange: function(ha) {
              Et.setState({ input: ha.target.value });
            }, onKeyPress: function(ha) {
              oa && ha.key === "Enter" ? Et.submit() : ha.key === "Escape" && Et.closeModal();
            } })), oa ? q2.a.createElement(xc, Object.assign({}, et(tt, "key-modal-submit"), { className: "key-modal-submit", onClick: function(ha) {
              return Et.submit();
            } })) : null), q2.a.createElement("span", et(tt, "key-modal-cancel"), q2.a.createElement(Qv, Object.assign({}, et(tt, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
              $a.dispatch({ rjvId: Ir, name: "RESET" });
            } })))));
          } }]), lt2;
        }(q2.a.PureComponent), lL = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            var Et;
            y4(this, lt2);
            for (var kt = arguments.length, tt = new Array(kt), Ir = 0; Ir < kt; Ir++)
              tt[Ir] = arguments[Ir];
            return (Et = zt.call.apply(zt, [this].concat(tt))).isValid = function(hr) {
              var hn = Et.props.rjvId, oa = da.get(hn, "action", "new-key-request");
              return hr != "" && Object.keys(oa.existing_value).indexOf(hr) === -1;
            }, Et.submit = function(hr) {
              var hn = Et.props.rjvId, oa = da.get(hn, "action", "new-key-request");
              oa.new_value = g4({}, oa.existing_value), oa.new_value[hr] = Et.props.defaultValue, $a.dispatch({ name: "VARIABLE_ADDED", rjvId: hn, data: oa });
            }, Et;
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.active, tt = Et.theme, Ir = Et.rjvId;
            return kt ? q2.a.createElement(sL, { rjvId: Ir, theme: tt, isValid: this.isValid, submit: this.submit }) : null;
          } }]), lt2;
        }(q2.a.PureComponent), uL = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2() {
            return y4(this, lt2), zt.apply(this, arguments);
          }
          return w4(lt2, [{ key: "render", value: function() {
            var Et = this.props, kt = Et.message, tt = Et.active, Ir = Et.theme, hr = Et.rjvId;
            return tt ? q2.a.createElement("div", Object.assign({ className: "validation-failure" }, et(Ir, "validation-failure"), { onClick: function() {
              $a.dispatch({ rjvId: hr, name: "RESET" });
            } }), q2.a.createElement("span", et(Ir, "validation-failure-label"), kt), q2.a.createElement(Qv, et(Ir, "validation-failure-clear"))) : null;
          } }]), lt2;
        }(q2.a.PureComponent), E2 = function(Lt) {
          E(lt2, Lt);
          var zt = H(lt2);
          function lt2(Et) {
            var kt;
            return y4(this, lt2), (kt = zt.call(this, Et)).rjvId = Date.now().toString(), kt.getListeners = function() {
              return { reset: kt.resetState, "variable-update": kt.updateSrc, "add-key-request": kt.addKeyRequest };
            }, kt.updateSrc = function() {
              var tt, Ir = da.get(kt.rjvId, "action", "variable-update"), hr = Ir.name, hn = Ir.namespace, oa = Ir.new_value, ha = Ir.existing_value, Zo = (Ir.variable_removed, Ir.updated_src), Ds = Ir.type, Gs = kt.props, ns = Gs.onEdit, Vl = Gs.onDelete, ac = Gs.onAdd, yo = { existing_src: kt.state.src, new_value: oa, updated_src: Zo, name: hr, namespace: hn, existing_value: ha };
              switch (Ds) {
                case "variable-added":
                  tt = ac(yo);
                  break;
                case "variable-edited":
                  tt = ns(yo);
                  break;
                case "variable-removed":
                  tt = Vl(yo);
              }
              tt !== false ? (da.set(kt.rjvId, "global", "src", Zo), kt.setState({ src: Zo })) : kt.setState({ validationFailure: true });
            }, kt.addKeyRequest = function() {
              kt.setState({ addKeyRequest: true });
            }, kt.resetState = function() {
              kt.setState({ validationFailure: false, addKeyRequest: false });
            }, kt.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: lt2.defaultProps.src, name: lt2.defaultProps.name, theme: lt2.defaultProps.theme, validationMessage: lt2.defaultProps.validationMessage, prevSrc: lt2.defaultProps.src, prevName: lt2.defaultProps.name, prevTheme: lt2.defaultProps.theme }, kt;
          }
          return w4(lt2, [{ key: "componentDidMount", value: function() {
            da.set(this.rjvId, "global", "src", this.state.src);
            var Et = this.getListeners();
            for (var kt in Et)
              da.on(kt + "-" + this.rjvId, Et[kt]);
            this.setState({ addKeyRequest: false, editKeyRequest: false });
          } }, { key: "componentDidUpdate", value: function(Et, kt) {
            kt.addKeyRequest !== false && this.setState({ addKeyRequest: false }), kt.editKeyRequest !== false && this.setState({ editKeyRequest: false }), Et.src !== this.state.src && da.set(this.rjvId, "global", "src", this.state.src);
          } }, { key: "componentWillUnmount", value: function() {
            var Et = this.getListeners();
            for (var kt in Et)
              da.removeListener(kt + "-" + this.rjvId, Et[kt]);
          } }, { key: "render", value: function() {
            var Et = this.state, kt = Et.validationFailure, tt = Et.validationMessage, Ir = Et.addKeyRequest, hr = Et.theme, hn = Et.src, oa = Et.name, ha = this.props, Zo = ha.style, Ds = ha.defaultValue;
            return q2.a.createElement("div", { className: "react-json-view", style: g4(g4({}, et(hr, "app-container").style), Zo) }, q2.a.createElement(uL, { message: tt, active: kt, theme: hr, rjvId: this.rjvId }), q2.a.createElement(oL, Object.assign({}, this.props, { src: hn, name: oa, theme: hr, type: we(hn), rjvId: this.rjvId })), q2.a.createElement(lL, { active: Ir, theme: hr, rjvId: this.rjvId, defaultValue: Ds }));
          } }], [{ key: "getDerivedStateFromProps", value: function(Et, kt) {
            if (Et.src !== kt.prevSrc || Et.name !== kt.prevName || Et.theme !== kt.prevTheme) {
              var tt = { src: Et.src, name: Et.name, theme: Et.theme, validationMessage: Et.validationMessage, prevSrc: Et.src, prevName: Et.name, prevTheme: Et.theme };
              return lt2.validateState(tt);
            }
            return null;
          } }]), lt2;
        }(q2.a.PureComponent);
        E2.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, E2.validateState = function(Lt) {
          var zt = {};
          return we(Lt.theme) !== "object" || function(lt2) {
            var Et = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
            if (we(lt2) === "object") {
              for (var kt = 0; kt < Et.length; kt++)
                if (!(Et[kt] in lt2))
                  return false;
              return true;
            }
            return false;
          }(Lt.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), zt.theme = "rjv-default"), we(Lt.src) !== "object" && we(Lt.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), zt.name = "ERROR", zt.src = { message: "src property must be a valid json object" }), g4(g4({}, Lt), zt);
        }, ye(E2), l4.default = E2;
      }]);
    });
  })(oOe);
  var FDt = vat(oOe.exports);
  const NDt = ({ id: i, title: n2, chart: e2, option: o }) => {
    const { tool: l4 } = kue({}), c4 = tU({ global: true }), [h, { set: p4 }] = sat(true);
    console.log("option", o);
    const g4 = (y4) => {
      const { updated_src: _ } = y4;
      e2 == null || e2.setOption(_), l4 == null || l4.add(i, e2, _, n2), c4.emit("list");
    };
    return bDt("div", { children: [m3(MDt, { children: m3(TDt, { children: m3(kDt, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (y4) => {
      p4(!y4);
    } }) }) }), m3("br", {}), o && m3(FDt, { src: o, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: h, iconStyle: "triangle", enableClipboard: true, onEdit: g4, onAdd: g4, onDelete: g4 })] });
  };
  exports.EchartTool = RDt;
  exports.ReactEchartsJson = NDt;
  exports.useEcharts = qEt;
  exports.useEchartsTool = kue;
  exports.useEventEmitter = tU;
})(reactEchartsJson_cjs);
const EchartTool = () => {
  const event = reactEchartsJson_cjs.useEventEmitter({
    global: true
  });
  const currentIndex = useRef(0);
  const {
    tool
  } = reactEchartsJson_cjs.useEchartsTool({});
  useState(false);
  useState("right");
  const [chartList, setChartList] = useState([]);
  const [currentChart, setCurrentChart] = useState();
  event.useSubscription("list", () => {
    var _a2;
    if (tool == null ? void 0 : tool.list().length) {
      setCurrentChart((_a2 = tool == null ? void 0 : tool.list()) == null ? void 0 : _a2[currentIndex.current]);
      setChartList(tool == null ? void 0 : tool.list());
    }
  });
  return /* @__PURE__ */ jsx("div", {
    className: styles.container,
    children: false
  });
};
var index = "";
var main = { exports: {} };
(function(module, exports) {
  !function(e2, t2) {
    module.exports = t2(React__default);
  }(commonjsGlobal, function(e2) {
    return function(e3) {
      var t2 = {};
      function n2(a) {
        if (t2[a])
          return t2[a].exports;
        var r2 = t2[a] = { i: a, l: false, exports: {} };
        return e3[a].call(r2.exports, r2, r2.exports, n2), r2.l = true, r2.exports;
      }
      return n2.m = e3, n2.c = t2, n2.d = function(e4, t3, a) {
        n2.o(e4, t3) || Object.defineProperty(e4, t3, { enumerable: true, get: a });
      }, n2.r = function(e4) {
        typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(e4, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(e4, "__esModule", { value: true });
      }, n2.t = function(e4, t3) {
        if (1 & t3 && (e4 = n2(e4)), 8 & t3)
          return e4;
        if (4 & t3 && typeof e4 == "object" && e4 && e4.__esModule)
          return e4;
        var a = /* @__PURE__ */ Object.create(null);
        if (n2.r(a), Object.defineProperty(a, "default", { enumerable: true, value: e4 }), 2 & t3 && typeof e4 != "string")
          for (var r2 in e4)
            n2.d(a, r2, function(t4) {
              return e4[t4];
            }.bind(null, r2));
        return a;
      }, n2.n = function(e4) {
        var t3 = e4 && e4.__esModule ? function() {
          return e4.default;
        } : function() {
          return e4;
        };
        return n2.d(t3, "a", t3), t3;
      }, n2.o = function(e4, t3) {
        return Object.prototype.hasOwnProperty.call(e4, t3);
      }, n2.p = "", n2(n2.s = 48);
    }([function(t2, n2) {
      t2.exports = e2;
    }, function(e3, t2) {
      var n2 = e3.exports = { version: "2.6.12" };
      typeof __e == "number" && (__e = n2);
    }, function(e3, t2, n2) {
      var a = n2(26)("wks"), r2 = n2(17), o = n2(3).Symbol, i = typeof o == "function";
      (e3.exports = function(e4) {
        return a[e4] || (a[e4] = i && o[e4] || (i ? o : r2)("Symbol." + e4));
      }).store = a;
    }, function(e3, t2) {
      var n2 = e3.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
      typeof __g == "number" && (__g = n2);
    }, function(e3, t2, n2) {
      e3.exports = !n2(8)(function() {
        return Object.defineProperty({}, "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2) {
      var n2 = {}.hasOwnProperty;
      e3.exports = function(e4, t3) {
        return n2.call(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(16);
      e3.exports = n2(4) ? function(e4, t3, n3) {
        return a.f(e4, t3, r2(1, n3));
      } : function(e4, t3, n3) {
        return e4[t3] = n3, e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(35), o = n2(23), i = Object.defineProperty;
      t2.f = n2(4) ? Object.defineProperty : function(e4, t3, n3) {
        if (a(e4), t3 = o(t3, true), a(n3), r2)
          try {
            return i(e4, t3, n3);
          } catch (e5) {
          }
        if ("get" in n3 || "set" in n3)
          throw TypeError("Accessors not supported!");
        return "value" in n3 && (e4[t3] = n3.value), e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        try {
          return !!e4();
        } catch (e5) {
          return true;
        }
      };
    }, function(e3, t2, n2) {
      var a = n2(40), r2 = n2(22);
      e3.exports = function(e4) {
        return a(r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4) {
        if (!a(e4))
          throw TypeError(e4 + " is not an object!");
        return e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        return typeof e4 == "object" ? e4 !== null : typeof e4 == "function";
      };
    }, function(e3, t2) {
      e3.exports = {};
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27);
      e3.exports = Object.keys || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2) {
      e3.exports = true;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(53), i = n2(6), s = n2(5), c2 = function(e4, t3, n3) {
        var l2, u, f2, p2 = e4 & c2.F, d2 = e4 & c2.G, b2 = e4 & c2.S, h = e4 & c2.P, v4 = e4 & c2.B, m2 = e4 & c2.W, y2 = d2 ? r2 : r2[t3] || (r2[t3] = {}), g2 = y2.prototype, E = d2 ? a : b2 ? a[t3] : (a[t3] || {}).prototype;
        for (l2 in d2 && (n3 = t3), n3)
          (u = !p2 && E && E[l2] !== void 0) && s(y2, l2) || (f2 = u ? E[l2] : n3[l2], y2[l2] = d2 && typeof E[l2] != "function" ? n3[l2] : v4 && u ? o(f2, a) : m2 && E[l2] == f2 ? function(e5) {
            var t4 = function(t5, n4, a2) {
              if (this instanceof e5) {
                switch (arguments.length) {
                  case 0:
                    return new e5();
                  case 1:
                    return new e5(t5);
                  case 2:
                    return new e5(t5, n4);
                }
                return new e5(t5, n4, a2);
              }
              return e5.apply(this, arguments);
            };
            return t4.prototype = e5.prototype, t4;
          }(f2) : h && typeof f2 == "function" ? o(Function.call, f2) : f2, h && ((y2.virtual || (y2.virtual = {}))[l2] = f2, e4 & c2.R && g2 && !g2[l2] && i(g2, l2, f2)));
      };
      c2.F = 1, c2.G = 2, c2.S = 4, c2.P = 8, c2.B = 16, c2.W = 32, c2.U = 64, c2.R = 128, e3.exports = c2;
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { enumerable: !(1 & e4), configurable: !(2 & e4), writable: !(4 & e4), value: t3 };
      };
    }, function(e3, t2) {
      var n2 = 0, a = Math.random();
      e3.exports = function(e4) {
        return "Symbol(".concat(e4 === void 0 ? "" : e4, ")_", (++n2 + a).toString(36));
      };
    }, function(e3, t2, n2) {
      var a = n2(22);
      e3.exports = function(e4) {
        return Object(a(e4));
      };
    }, function(e3, t2) {
      t2.f = {}.propertyIsEnumerable;
    }, function(e3, t2, n2) {
      var a = n2(52)(true);
      n2(34)(String, "String", function(e4) {
        this._t = String(e4), this._i = 0;
      }, function() {
        var e4, t3 = this._t, n3 = this._i;
        return n3 >= t3.length ? { value: void 0, done: true } : (e4 = a(t3, n3), this._i += e4.length, { value: e4, done: false });
      });
    }, function(e3, t2) {
      var n2 = Math.ceil, a = Math.floor;
      e3.exports = function(e4) {
        return isNaN(e4 = +e4) ? 0 : (e4 > 0 ? a : n2)(e4);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (e4 == null)
          throw TypeError("Can't call method on  " + e4);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4, t3) {
        if (!a(e4))
          return e4;
        var n3, r2;
        if (t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (typeof (n3 = e4.valueOf) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (!t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        throw TypeError("Can't convert object to primitive value");
      };
    }, function(e3, t2) {
      var n2 = {}.toString;
      e3.exports = function(e4) {
        return n2.call(e4).slice(8, -1);
      };
    }, function(e3, t2, n2) {
      var a = n2(26)("keys"), r2 = n2(17);
      e3.exports = function(e4) {
        return a[e4] || (a[e4] = r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(1), r2 = n2(3), o = r2["__core-js_shared__"] || (r2["__core-js_shared__"] = {});
      (e3.exports = function(e4, t3) {
        return o[e4] || (o[e4] = t3 !== void 0 ? t3 : {});
      })("versions", []).push({ version: a.version, mode: n2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
    }, function(e3, t2) {
      e3.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
    }, function(e3, t2, n2) {
      var a = n2(7).f, r2 = n2(5), o = n2(2)("toStringTag");
      e3.exports = function(e4, t3, n3) {
        e4 && !r2(e4 = n3 ? e4 : e4.prototype, o) && a(e4, o, { configurable: true, value: t3 });
      };
    }, function(e3, t2, n2) {
      n2(62);
      for (var a = n2(3), r2 = n2(6), o = n2(12), i = n2(2)("toStringTag"), s = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), c2 = 0; c2 < s.length; c2++) {
        var l2 = s[c2], u = a[l2], f2 = u && u.prototype;
        f2 && !f2[i] && r2(f2, i, l2), o[l2] = o.Array;
      }
    }, function(e3, t2, n2) {
      t2.f = n2(2);
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(14), i = n2(30), s = n2(7).f;
      e3.exports = function(e4) {
        var t3 = r2.Symbol || (r2.Symbol = o ? {} : a.Symbol || {});
        e4.charAt(0) == "_" || e4 in t3 || s(t3, e4, { value: i.f(e4) });
      };
    }, function(e3, t2) {
      t2.f = Object.getOwnPropertySymbols;
    }, function(e3, t2) {
      e3.exports = function(e4, t3, n2) {
        return Math.min(Math.max(e4, t3), n2);
      };
    }, function(e3, t2, n2) {
      var a = n2(14), r2 = n2(15), o = n2(37), i = n2(6), s = n2(12), c2 = n2(55), l2 = n2(28), u = n2(61), f2 = n2(2)("iterator"), p2 = !([].keys && "next" in [].keys()), d2 = function() {
        return this;
      };
      e3.exports = function(e4, t3, n3, b2, h, v4, m2) {
        c2(n3, t3, b2);
        var y2, g2, E, j = function(e5) {
          if (!p2 && e5 in O)
            return O[e5];
          switch (e5) {
            case "keys":
            case "values":
              return function() {
                return new n3(this, e5);
              };
          }
          return function() {
            return new n3(this, e5);
          };
        }, x2 = t3 + " Iterator", _ = h == "values", k2 = false, O = e4.prototype, C = O[f2] || O["@@iterator"] || h && O[h], S = C || j(h), w2 = h ? _ ? j("entries") : S : void 0, A2 = t3 == "Array" && O.entries || C;
        if (A2 && (E = u(A2.call(new e4()))) !== Object.prototype && E.next && (l2(E, x2, true), a || typeof E[f2] == "function" || i(E, f2, d2)), _ && C && C.name !== "values" && (k2 = true, S = function() {
          return C.call(this);
        }), a && !m2 || !p2 && !k2 && O[f2] || i(O, f2, S), s[t3] = S, s[x2] = d2, h)
          if (y2 = { values: _ ? S : j("values"), keys: v4 ? S : j("keys"), entries: w2 }, m2)
            for (g2 in y2)
              g2 in O || o(O, g2, y2[g2]);
          else
            r2(r2.P + r2.F * (p2 || k2), t3, y2);
        return y2;
      };
    }, function(e3, t2, n2) {
      e3.exports = !n2(4) && !n2(8)(function() {
        return Object.defineProperty(n2(36)("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2, n2) {
      var a = n2(11), r2 = n2(3).document, o = a(r2) && a(r2.createElement);
      e3.exports = function(e4) {
        return o ? r2.createElement(e4) : {};
      };
    }, function(e3, t2, n2) {
      e3.exports = n2(6);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(56), o = n2(27), i = n2(25)("IE_PROTO"), s = function() {
      }, c2 = function() {
        var e4, t3 = n2(36)("iframe"), a2 = o.length;
        for (t3.style.display = "none", n2(60).appendChild(t3), t3.src = "javascript:", (e4 = t3.contentWindow.document).open(), e4.write("<script>document.F=Object<\/script>"), e4.close(), c2 = e4.F; a2--; )
          delete c2.prototype[o[a2]];
        return c2();
      };
      e3.exports = Object.create || function(e4, t3) {
        var n3;
        return e4 !== null ? (s.prototype = a(e4), n3 = new s(), s.prototype = null, n3[i] = e4) : n3 = c2(), t3 === void 0 ? n3 : r2(n3, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(9), o = n2(57)(false), i = n2(25)("IE_PROTO");
      e3.exports = function(e4, t3) {
        var n3, s = r2(e4), c2 = 0, l2 = [];
        for (n3 in s)
          n3 != i && a(s, n3) && l2.push(n3);
        for (; t3.length > c2; )
          a(s, n3 = t3[c2++]) && (~o(l2, n3) || l2.push(n3));
        return l2;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Object("z").propertyIsEnumerable(0) ? Object : function(e4) {
        return a(e4) == "String" ? e4.split("") : Object(e4);
      };
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27).concat("length", "prototype");
      t2.f = Object.getOwnPropertyNames || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2, n2) {
      var a = n2(24), r2 = n2(2)("toStringTag"), o = a(function() {
        return arguments;
      }()) == "Arguments";
      e3.exports = function(e4) {
        var t3, n3, i;
        return e4 === void 0 ? "Undefined" : e4 === null ? "Null" : typeof (n3 = function(e5, t4) {
          try {
            return e5[t4];
          } catch (e6) {
          }
        }(t3 = Object(e4), r2)) == "string" ? n3 : o ? a(t3) : (i = a(t3)) == "Object" && typeof t3.callee == "function" ? "Arguments" : i;
      };
    }, function(e3, t2) {
      var n2;
      n2 = function() {
        return this;
      }();
      try {
        n2 = n2 || new Function("return this")();
      } catch (e4) {
        typeof window == "object" && (n2 = window);
      }
      e3.exports = n2;
    }, function(e3, t2) {
      var n2 = /-?\d+(\.\d+)?%?/g;
      e3.exports = function(e4) {
        return e4.match(n2);
      };
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.getBase16Theme = t2.createStyling = t2.invertTheme = void 0;
      var a = d2(n2(49)), r2 = d2(n2(76)), o = d2(n2(81)), i = d2(n2(89)), s = d2(n2(93)), c2 = function(e4) {
        if (e4 && e4.__esModule)
          return e4;
        var t3 = {};
        if (e4 != null)
          for (var n3 in e4)
            Object.prototype.hasOwnProperty.call(e4, n3) && (t3[n3] = e4[n3]);
        return t3.default = e4, t3;
      }(n2(94)), l2 = d2(n2(132)), u = d2(n2(133)), f2 = d2(n2(138)), p2 = n2(139);
      function d2(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      var b2 = c2.default, h = (0, i.default)(b2), v4 = (0, f2.default)(u.default, p2.rgb2yuv, function(e4) {
        var t3, n3 = (0, o.default)(e4, 3), a2 = n3[0], r3 = n3[1], i2 = n3[2];
        return [(t3 = a2, t3 < 0.25 ? 1 : t3 < 0.5 ? 0.9 - t3 : 1.1 - t3), r3, i2];
      }, p2.yuv2rgb, l2.default), m2 = function(e4) {
        return function(t3) {
          return { className: [t3.className, e4.className].filter(Boolean).join(" "), style: (0, r2.default)({}, t3.style || {}, e4.style || {}) };
        };
      }, y2 = function(e4, t3) {
        var n3 = (0, i.default)(t3);
        for (var o2 in e4)
          n3.indexOf(o2) === -1 && n3.push(o2);
        return n3.reduce(function(n4, o3) {
          return n4[o3] = function(e5, t4) {
            if (e5 === void 0)
              return t4;
            if (t4 === void 0)
              return e5;
            var n5 = e5 === void 0 ? "undefined" : (0, a.default)(e5), o4 = t4 === void 0 ? "undefined" : (0, a.default)(t4);
            switch (n5) {
              case "string":
                switch (o4) {
                  case "string":
                    return [t4, e5].filter(Boolean).join(" ");
                  case "object":
                    return m2({ className: e5, style: t4 });
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ className: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "object":
                switch (o4) {
                  case "string":
                    return m2({ className: t4, style: e5 });
                  case "object":
                    return (0, r2.default)({}, t4, e5);
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ style: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "function":
                switch (o4) {
                  case "string":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ className: t4 })].concat(r3));
                    };
                  case "object":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ style: t4 })].concat(r3));
                    };
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [t4.apply(void 0, [n6].concat(r3))].concat(r3));
                    };
                }
            }
          }(e4[o3], t3[o3]), n4;
        }, {});
      }, g2 = function(e4, t3) {
        for (var n3 = arguments.length, o2 = Array(n3 > 2 ? n3 - 2 : 0), s2 = 2; s2 < n3; s2++)
          o2[s2 - 2] = arguments[s2];
        if (t3 === null)
          return e4;
        Array.isArray(t3) || (t3 = [t3]);
        var c3 = t3.map(function(t4) {
          return e4[t4];
        }).filter(Boolean), l3 = c3.reduce(function(e5, t4) {
          return typeof t4 == "string" ? e5.className = [e5.className, t4].filter(Boolean).join(" ") : (t4 === void 0 ? "undefined" : (0, a.default)(t4)) === "object" ? e5.style = (0, r2.default)({}, e5.style, t4) : typeof t4 == "function" && (e5 = (0, r2.default)({}, e5, t4.apply(void 0, [e5].concat(o2)))), e5;
        }, { className: "", style: {} });
        return l3.className || delete l3.className, (0, i.default)(l3.style).length === 0 && delete l3.style, l3;
      }, E = t2.invertTheme = function(e4) {
        return (0, i.default)(e4).reduce(function(t3, n3) {
          return t3[n3] = /^base/.test(n3) ? v4(e4[n3]) : n3 === "scheme" ? e4[n3] + ":inverted" : e4[n3], t3;
        }, {});
      }, j = (t2.createStyling = (0, s.default)(function(e4) {
        for (var t3 = arguments.length, n3 = Array(t3 > 3 ? t3 - 3 : 0), a2 = 3; a2 < t3; a2++)
          n3[a2 - 3] = arguments[a2];
        var o2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, c3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, l3 = o2.defaultBase16, u2 = l3 === void 0 ? b2 : l3, f3 = o2.base16Themes, p3 = f3 === void 0 ? null : f3, d3 = j(c3, p3);
        d3 && (c3 = (0, r2.default)({}, d3, c3));
        var v5 = h.reduce(function(e5, t4) {
          return e5[t4] = c3[t4] || u2[t4], e5;
        }, {}), m3 = (0, i.default)(c3).reduce(function(e5, t4) {
          return h.indexOf(t4) === -1 ? (e5[t4] = c3[t4], e5) : e5;
        }, {}), E2 = e4(v5), x2 = y2(m3, E2);
        return (0, s.default)(g2, 2).apply(void 0, [x2].concat(n3));
      }, 3), t2.getBase16Theme = function(e4, t3) {
        if (e4 && e4.extend && (e4 = e4.extend), typeof e4 == "string") {
          var n3 = e4.split(":"), a2 = (0, o.default)(n3, 2), r3 = a2[0], i2 = a2[1];
          e4 = (t3 || {})[r3] || c2[r3], i2 === "inverted" && (e4 = E(e4));
        }
        return e4 && e4.hasOwnProperty("base00") ? e4 : void 0;
      });
    }, function(e3, t2, n2) {
      var a, r2 = typeof Reflect == "object" ? Reflect : null, o = r2 && typeof r2.apply == "function" ? r2.apply : function(e4, t3, n3) {
        return Function.prototype.apply.call(e4, t3, n3);
      };
      a = r2 && typeof r2.ownKeys == "function" ? r2.ownKeys : Object.getOwnPropertySymbols ? function(e4) {
        return Object.getOwnPropertyNames(e4).concat(Object.getOwnPropertySymbols(e4));
      } : function(e4) {
        return Object.getOwnPropertyNames(e4);
      };
      var i = Number.isNaN || function(e4) {
        return e4 != e4;
      };
      function s() {
        s.init.call(this);
      }
      e3.exports = s, e3.exports.once = function(e4, t3) {
        return new Promise(function(n3, a2) {
          function r3() {
            o2 !== void 0 && e4.removeListener("error", o2), n3([].slice.call(arguments));
          }
          var o2;
          t3 !== "error" && (o2 = function(n4) {
            e4.removeListener(t3, r3), a2(n4);
          }, e4.once("error", o2)), e4.once(t3, r3);
        });
      }, s.EventEmitter = s, s.prototype._events = void 0, s.prototype._eventsCount = 0, s.prototype._maxListeners = void 0;
      var c2 = 10;
      function l2(e4) {
        if (typeof e4 != "function")
          throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof e4);
      }
      function u(e4) {
        return e4._maxListeners === void 0 ? s.defaultMaxListeners : e4._maxListeners;
      }
      function f2(e4, t3, n3, a2) {
        var r3, o2, i2, s2;
        if (l2(n3), (o2 = e4._events) === void 0 ? (o2 = e4._events = /* @__PURE__ */ Object.create(null), e4._eventsCount = 0) : (o2.newListener !== void 0 && (e4.emit("newListener", t3, n3.listener ? n3.listener : n3), o2 = e4._events), i2 = o2[t3]), i2 === void 0)
          i2 = o2[t3] = n3, ++e4._eventsCount;
        else if (typeof i2 == "function" ? i2 = o2[t3] = a2 ? [n3, i2] : [i2, n3] : a2 ? i2.unshift(n3) : i2.push(n3), (r3 = u(e4)) > 0 && i2.length > r3 && !i2.warned) {
          i2.warned = true;
          var c3 = new Error("Possible EventEmitter memory leak detected. " + i2.length + " " + String(t3) + " listeners added. Use emitter.setMaxListeners() to increase limit");
          c3.name = "MaxListenersExceededWarning", c3.emitter = e4, c3.type = t3, c3.count = i2.length, s2 = c3, console && console.warn && console.warn(s2);
        }
        return e4;
      }
      function p2() {
        if (!this.fired)
          return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
      }
      function d2(e4, t3, n3) {
        var a2 = { fired: false, wrapFn: void 0, target: e4, type: t3, listener: n3 }, r3 = p2.bind(a2);
        return r3.listener = n3, a2.wrapFn = r3, r3;
      }
      function b2(e4, t3, n3) {
        var a2 = e4._events;
        if (a2 === void 0)
          return [];
        var r3 = a2[t3];
        return r3 === void 0 ? [] : typeof r3 == "function" ? n3 ? [r3.listener || r3] : [r3] : n3 ? function(e5) {
          for (var t4 = new Array(e5.length), n4 = 0; n4 < t4.length; ++n4)
            t4[n4] = e5[n4].listener || e5[n4];
          return t4;
        }(r3) : v4(r3, r3.length);
      }
      function h(e4) {
        var t3 = this._events;
        if (t3 !== void 0) {
          var n3 = t3[e4];
          if (typeof n3 == "function")
            return 1;
          if (n3 !== void 0)
            return n3.length;
        }
        return 0;
      }
      function v4(e4, t3) {
        for (var n3 = new Array(t3), a2 = 0; a2 < t3; ++a2)
          n3[a2] = e4[a2];
        return n3;
      }
      Object.defineProperty(s, "defaultMaxListeners", { enumerable: true, get: function() {
        return c2;
      }, set: function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        c2 = e4;
      } }), s.init = function() {
        this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
      }, s.prototype.setMaxListeners = function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        return this._maxListeners = e4, this;
      }, s.prototype.getMaxListeners = function() {
        return u(this);
      }, s.prototype.emit = function(e4) {
        for (var t3 = [], n3 = 1; n3 < arguments.length; n3++)
          t3.push(arguments[n3]);
        var a2 = e4 === "error", r3 = this._events;
        if (r3 !== void 0)
          a2 = a2 && r3.error === void 0;
        else if (!a2)
          return false;
        if (a2) {
          var i2;
          if (t3.length > 0 && (i2 = t3[0]), i2 instanceof Error)
            throw i2;
          var s2 = new Error("Unhandled error." + (i2 ? " (" + i2.message + ")" : ""));
          throw s2.context = i2, s2;
        }
        var c3 = r3[e4];
        if (c3 === void 0)
          return false;
        if (typeof c3 == "function")
          o(c3, this, t3);
        else {
          var l3 = c3.length, u2 = v4(c3, l3);
          for (n3 = 0; n3 < l3; ++n3)
            o(u2[n3], this, t3);
        }
        return true;
      }, s.prototype.addListener = function(e4, t3) {
        return f2(this, e4, t3, false);
      }, s.prototype.on = s.prototype.addListener, s.prototype.prependListener = function(e4, t3) {
        return f2(this, e4, t3, true);
      }, s.prototype.once = function(e4, t3) {
        return l2(t3), this.on(e4, d2(this, e4, t3)), this;
      }, s.prototype.prependOnceListener = function(e4, t3) {
        return l2(t3), this.prependListener(e4, d2(this, e4, t3)), this;
      }, s.prototype.removeListener = function(e4, t3) {
        var n3, a2, r3, o2, i2;
        if (l2(t3), (a2 = this._events) === void 0)
          return this;
        if ((n3 = a2[e4]) === void 0)
          return this;
        if (n3 === t3 || n3.listener === t3)
          --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete a2[e4], a2.removeListener && this.emit("removeListener", e4, n3.listener || t3));
        else if (typeof n3 != "function") {
          for (r3 = -1, o2 = n3.length - 1; o2 >= 0; o2--)
            if (n3[o2] === t3 || n3[o2].listener === t3) {
              i2 = n3[o2].listener, r3 = o2;
              break;
            }
          if (r3 < 0)
            return this;
          r3 === 0 ? n3.shift() : function(e5, t4) {
            for (; t4 + 1 < e5.length; t4++)
              e5[t4] = e5[t4 + 1];
            e5.pop();
          }(n3, r3), n3.length === 1 && (a2[e4] = n3[0]), a2.removeListener !== void 0 && this.emit("removeListener", e4, i2 || t3);
        }
        return this;
      }, s.prototype.off = s.prototype.removeListener, s.prototype.removeAllListeners = function(e4) {
        var t3, n3, a2;
        if ((n3 = this._events) === void 0)
          return this;
        if (n3.removeListener === void 0)
          return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : n3[e4] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete n3[e4]), this;
        if (arguments.length === 0) {
          var r3, o2 = Object.keys(n3);
          for (a2 = 0; a2 < o2.length; ++a2)
            (r3 = o2[a2]) !== "removeListener" && this.removeAllListeners(r3);
          return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
        }
        if (typeof (t3 = n3[e4]) == "function")
          this.removeListener(e4, t3);
        else if (t3 !== void 0)
          for (a2 = t3.length - 1; a2 >= 0; a2--)
            this.removeListener(e4, t3[a2]);
        return this;
      }, s.prototype.listeners = function(e4) {
        return b2(this, e4, true);
      }, s.prototype.rawListeners = function(e4) {
        return b2(this, e4, false);
      }, s.listenerCount = function(e4, t3) {
        return typeof e4.listenerCount == "function" ? e4.listenerCount(t3) : h.call(e4, t3);
      }, s.prototype.listenerCount = h, s.prototype.eventNames = function() {
        return this._eventsCount > 0 ? a(this._events) : [];
      };
    }, function(e3, t2, n2) {
      e3.exports.Dispatcher = n2(140);
    }, function(e3, t2, n2) {
      e3.exports = n2(142);
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = i(n2(50)), r2 = i(n2(65)), o = typeof r2.default == "function" && typeof a.default == "symbol" ? function(e4) {
        return typeof e4;
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : typeof e4;
      };
      function i(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = typeof r2.default == "function" && o(a.default) === "symbol" ? function(e4) {
        return e4 === void 0 ? "undefined" : o(e4);
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : e4 === void 0 ? "undefined" : o(e4);
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(51), __esModule: true };
    }, function(e3, t2, n2) {
      n2(20), n2(29), e3.exports = n2(30).f("iterator");
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = n2(22);
      e3.exports = function(e4) {
        return function(t3, n3) {
          var o, i, s = String(r2(t3)), c2 = a(n3), l2 = s.length;
          return c2 < 0 || c2 >= l2 ? e4 ? "" : void 0 : (o = s.charCodeAt(c2)) < 55296 || o > 56319 || c2 + 1 === l2 || (i = s.charCodeAt(c2 + 1)) < 56320 || i > 57343 ? e4 ? s.charAt(c2) : o : e4 ? s.slice(c2, c2 + 2) : i - 56320 + (o - 55296 << 10) + 65536;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(54);
      e3.exports = function(e4, t3, n3) {
        if (a(e4), t3 === void 0)
          return e4;
        switch (n3) {
          case 1:
            return function(n4) {
              return e4.call(t3, n4);
            };
          case 2:
            return function(n4, a2) {
              return e4.call(t3, n4, a2);
            };
          case 3:
            return function(n4, a2, r2) {
              return e4.call(t3, n4, a2, r2);
            };
        }
        return function() {
          return e4.apply(t3, arguments);
        };
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (typeof e4 != "function")
          throw TypeError(e4 + " is not a function!");
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(38), r2 = n2(16), o = n2(28), i = {};
      n2(6)(i, n2(2)("iterator"), function() {
        return this;
      }), e3.exports = function(e4, t3, n3) {
        e4.prototype = a(i, { next: r2(1, n3) }), o(e4, t3 + " Iterator");
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(10), o = n2(13);
      e3.exports = n2(4) ? Object.defineProperties : function(e4, t3) {
        r2(e4);
        for (var n3, i = o(t3), s = i.length, c2 = 0; s > c2; )
          a.f(e4, n3 = i[c2++], t3[n3]);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(58), o = n2(59);
      e3.exports = function(e4) {
        return function(t3, n3, i) {
          var s, c2 = a(t3), l2 = r2(c2.length), u = o(i, l2);
          if (e4 && n3 != n3) {
            for (; l2 > u; )
              if ((s = c2[u++]) != s)
                return true;
          } else
            for (; l2 > u; u++)
              if ((e4 || u in c2) && c2[u] === n3)
                return e4 || u || 0;
          return !e4 && -1;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.min;
      e3.exports = function(e4) {
        return e4 > 0 ? r2(a(e4), 9007199254740991) : 0;
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.max, o = Math.min;
      e3.exports = function(e4, t3) {
        return (e4 = a(e4)) < 0 ? r2(e4 + t3, 0) : o(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(3).document;
      e3.exports = a && a.documentElement;
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(18), o = n2(25)("IE_PROTO"), i = Object.prototype;
      e3.exports = Object.getPrototypeOf || function(e4) {
        return e4 = r2(e4), a(e4, o) ? e4[o] : typeof e4.constructor == "function" && e4 instanceof e4.constructor ? e4.constructor.prototype : e4 instanceof Object ? i : null;
      };
    }, function(e3, t2, n2) {
      var a = n2(63), r2 = n2(64), o = n2(12), i = n2(9);
      e3.exports = n2(34)(Array, "Array", function(e4, t3) {
        this._t = i(e4), this._i = 0, this._k = t3;
      }, function() {
        var e4 = this._t, t3 = this._k, n3 = this._i++;
        return !e4 || n3 >= e4.length ? (this._t = void 0, r2(1)) : r2(0, t3 == "keys" ? n3 : t3 == "values" ? e4[n3] : [n3, e4[n3]]);
      }, "values"), o.Arguments = o.Array, a("keys"), a("values"), a("entries");
    }, function(e3, t2) {
      e3.exports = function() {
      };
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { value: t3, done: !!e4 };
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(66), __esModule: true };
    }, function(e3, t2, n2) {
      n2(67), n2(73), n2(74), n2(75), e3.exports = n2(1).Symbol;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(5), o = n2(4), i = n2(15), s = n2(37), c2 = n2(68).KEY, l2 = n2(8), u = n2(26), f2 = n2(28), p2 = n2(17), d2 = n2(2), b2 = n2(30), h = n2(31), v4 = n2(69), m2 = n2(70), y2 = n2(10), g2 = n2(11), E = n2(18), j = n2(9), x2 = n2(23), _ = n2(16), k2 = n2(38), O = n2(71), C = n2(72), S = n2(32), w2 = n2(7), A2 = n2(13), M = C.f, P = w2.f, F = O.f, D = a.Symbol, I = a.JSON, R = I && I.stringify, L = d2("_hidden"), B = d2("toPrimitive"), N = {}.propertyIsEnumerable, z2 = u("symbol-registry"), T = u("symbols"), q2 = u("op-symbols"), V = Object.prototype, K = typeof D == "function" && !!S.f, W = a.QObject, H = !W || !W.prototype || !W.prototype.findChild, U = o && l2(function() {
        return k2(P({}, "a", { get: function() {
          return P(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e4, t3, n3) {
        var a2 = M(V, t3);
        a2 && delete V[t3], P(e4, t3, n3), a2 && e4 !== V && P(V, t3, a2);
      } : P, G = function(e4) {
        var t3 = T[e4] = k2(D.prototype);
        return t3._k = e4, t3;
      }, J = K && typeof D.iterator == "symbol" ? function(e4) {
        return typeof e4 == "symbol";
      } : function(e4) {
        return e4 instanceof D;
      }, Y = function(e4, t3, n3) {
        return e4 === V && Y(q2, t3, n3), y2(e4), t3 = x2(t3, true), y2(n3), r2(T, t3) ? (n3.enumerable ? (r2(e4, L) && e4[L][t3] && (e4[L][t3] = false), n3 = k2(n3, { enumerable: _(0, false) })) : (r2(e4, L) || P(e4, L, _(1, {})), e4[L][t3] = true), U(e4, t3, n3)) : P(e4, t3, n3);
      }, $ = function(e4, t3) {
        y2(e4);
        for (var n3, a2 = v4(t3 = j(t3)), r3 = 0, o2 = a2.length; o2 > r3; )
          Y(e4, n3 = a2[r3++], t3[n3]);
        return e4;
      }, Q = function(e4) {
        var t3 = N.call(this, e4 = x2(e4, true));
        return !(this === V && r2(T, e4) && !r2(q2, e4)) && (!(t3 || !r2(this, e4) || !r2(T, e4) || r2(this, L) && this[L][e4]) || t3);
      }, Z = function(e4, t3) {
        if (e4 = j(e4), t3 = x2(t3, true), e4 !== V || !r2(T, t3) || r2(q2, t3)) {
          var n3 = M(e4, t3);
          return !n3 || !r2(T, t3) || r2(e4, L) && e4[L][t3] || (n3.enumerable = true), n3;
        }
      }, X = function(e4) {
        for (var t3, n3 = F(j(e4)), a2 = [], o2 = 0; n3.length > o2; )
          r2(T, t3 = n3[o2++]) || t3 == L || t3 == c2 || a2.push(t3);
        return a2;
      }, ee = function(e4) {
        for (var t3, n3 = e4 === V, a2 = F(n3 ? q2 : j(e4)), o2 = [], i2 = 0; a2.length > i2; )
          !r2(T, t3 = a2[i2++]) || n3 && !r2(V, t3) || o2.push(T[t3]);
        return o2;
      };
      K || (s((D = function() {
        if (this instanceof D)
          throw TypeError("Symbol is not a constructor!");
        var e4 = p2(arguments.length > 0 ? arguments[0] : void 0), t3 = function(n3) {
          this === V && t3.call(q2, n3), r2(this, L) && r2(this[L], e4) && (this[L][e4] = false), U(this, e4, _(1, n3));
        };
        return o && H && U(V, e4, { configurable: true, set: t3 }), G(e4);
      }).prototype, "toString", function() {
        return this._k;
      }), C.f = Z, w2.f = Y, n2(41).f = O.f = X, n2(19).f = Q, S.f = ee, o && !n2(14) && s(V, "propertyIsEnumerable", Q, true), b2.f = function(e4) {
        return G(d2(e4));
      }), i(i.G + i.W + i.F * !K, { Symbol: D });
      for (var te = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), ne = 0; te.length > ne; )
        d2(te[ne++]);
      for (var ae = A2(d2.store), re = 0; ae.length > re; )
        h(ae[re++]);
      i(i.S + i.F * !K, "Symbol", { for: function(e4) {
        return r2(z2, e4 += "") ? z2[e4] : z2[e4] = D(e4);
      }, keyFor: function(e4) {
        if (!J(e4))
          throw TypeError(e4 + " is not a symbol!");
        for (var t3 in z2)
          if (z2[t3] === e4)
            return t3;
      }, useSetter: function() {
        H = true;
      }, useSimple: function() {
        H = false;
      } }), i(i.S + i.F * !K, "Object", { create: function(e4, t3) {
        return t3 === void 0 ? k2(e4) : $(k2(e4), t3);
      }, defineProperty: Y, defineProperties: $, getOwnPropertyDescriptor: Z, getOwnPropertyNames: X, getOwnPropertySymbols: ee });
      var oe = l2(function() {
        S.f(1);
      });
      i(i.S + i.F * oe, "Object", { getOwnPropertySymbols: function(e4) {
        return S.f(E(e4));
      } }), I && i(i.S + i.F * (!K || l2(function() {
        var e4 = D();
        return R([e4]) != "[null]" || R({ a: e4 }) != "{}" || R(Object(e4)) != "{}";
      })), "JSON", { stringify: function(e4) {
        for (var t3, n3, a2 = [e4], r3 = 1; arguments.length > r3; )
          a2.push(arguments[r3++]);
        if (n3 = t3 = a2[1], (g2(t3) || e4 !== void 0) && !J(e4))
          return m2(t3) || (t3 = function(e5, t4) {
            if (typeof n3 == "function" && (t4 = n3.call(this, e5, t4)), !J(t4))
              return t4;
          }), a2[1] = t3, R.apply(I, a2);
      } }), D.prototype[B] || n2(6)(D.prototype, B, D.prototype.valueOf), f2(D, "Symbol"), f2(Math, "Math", true), f2(a.JSON, "JSON", true);
    }, function(e3, t2, n2) {
      var a = n2(17)("meta"), r2 = n2(11), o = n2(5), i = n2(7).f, s = 0, c2 = Object.isExtensible || function() {
        return true;
      }, l2 = !n2(8)(function() {
        return c2(Object.preventExtensions({}));
      }), u = function(e4) {
        i(e4, a, { value: { i: "O" + ++s, w: {} } });
      }, f2 = e3.exports = { KEY: a, NEED: false, fastKey: function(e4, t3) {
        if (!r2(e4))
          return typeof e4 == "symbol" ? e4 : (typeof e4 == "string" ? "S" : "P") + e4;
        if (!o(e4, a)) {
          if (!c2(e4))
            return "F";
          if (!t3)
            return "E";
          u(e4);
        }
        return e4[a].i;
      }, getWeak: function(e4, t3) {
        if (!o(e4, a)) {
          if (!c2(e4))
            return true;
          if (!t3)
            return false;
          u(e4);
        }
        return e4[a].w;
      }, onFreeze: function(e4) {
        return l2 && f2.NEED && c2(e4) && !o(e4, a) && u(e4), e4;
      } };
    }, function(e3, t2, n2) {
      var a = n2(13), r2 = n2(32), o = n2(19);
      e3.exports = function(e4) {
        var t3 = a(e4), n3 = r2.f;
        if (n3)
          for (var i, s = n3(e4), c2 = o.f, l2 = 0; s.length > l2; )
            c2.call(e4, i = s[l2++]) && t3.push(i);
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Array.isArray || function(e4) {
        return a(e4) == "Array";
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(41).f, o = {}.toString, i = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
      e3.exports.f = function(e4) {
        return i && o.call(e4) == "[object Window]" ? function(e5) {
          try {
            return r2(e5);
          } catch (e6) {
            return i.slice();
          }
        }(e4) : r2(a(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(19), r2 = n2(16), o = n2(9), i = n2(23), s = n2(5), c2 = n2(35), l2 = Object.getOwnPropertyDescriptor;
      t2.f = n2(4) ? l2 : function(e4, t3) {
        if (e4 = o(e4), t3 = i(t3, true), c2)
          try {
            return l2(e4, t3);
          } catch (e5) {
          }
        if (s(e4, t3))
          return r2(!a.f.call(e4, t3), e4[t3]);
      };
    }, function(e3, t2) {
    }, function(e3, t2, n2) {
      n2(31)("asyncIterator");
    }, function(e3, t2, n2) {
      n2(31)("observable");
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a, r2 = n2(77), o = (a = r2) && a.__esModule ? a : { default: a };
      t2.default = o.default || function(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3];
          for (var a2 in n3)
            Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
        }
        return e4;
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(78), __esModule: true };
    }, function(e3, t2, n2) {
      n2(79), e3.exports = n2(1).Object.assign;
    }, function(e3, t2, n2) {
      var a = n2(15);
      a(a.S + a.F, "Object", { assign: n2(80) });
    }, function(e3, t2, n2) {
      var a = n2(4), r2 = n2(13), o = n2(32), i = n2(19), s = n2(18), c2 = n2(40), l2 = Object.assign;
      e3.exports = !l2 || n2(8)(function() {
        var e4 = {}, t3 = {}, n3 = Symbol(), a2 = "abcdefghijklmnopqrst";
        return e4[n3] = 7, a2.split("").forEach(function(e5) {
          t3[e5] = e5;
        }), l2({}, e4)[n3] != 7 || Object.keys(l2({}, t3)).join("") != a2;
      }) ? function(e4, t3) {
        for (var n3 = s(e4), l3 = arguments.length, u = 1, f2 = o.f, p2 = i.f; l3 > u; )
          for (var d2, b2 = c2(arguments[u++]), h = f2 ? r2(b2).concat(f2(b2)) : r2(b2), v4 = h.length, m2 = 0; v4 > m2; )
            d2 = h[m2++], a && !p2.call(b2, d2) || (n3[d2] = b2[d2]);
        return n3;
      } : l2;
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = o(n2(82)), r2 = o(n2(85));
      function o(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = function(e4, t3) {
        if (Array.isArray(e4))
          return e4;
        if ((0, a.default)(Object(e4)))
          return function(e5, t4) {
            var n3 = [], a2 = true, o2 = false, i = void 0;
            try {
              for (var s, c2 = (0, r2.default)(e5); !(a2 = (s = c2.next()).done) && (n3.push(s.value), !t4 || n3.length !== t4); a2 = true)
                ;
            } catch (e6) {
              o2 = true, i = e6;
            } finally {
              try {
                !a2 && c2.return && c2.return();
              } finally {
                if (o2)
                  throw i;
              }
            }
            return n3;
          }(e4, t3);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(83), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(84);
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).isIterable = function(e4) {
        var t3 = Object(e4);
        return t3[r2] !== void 0 || "@@iterator" in t3 || o.hasOwnProperty(a(t3));
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(86), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(87);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(88);
      e3.exports = n2(1).getIterator = function(e4) {
        var t3 = r2(e4);
        if (typeof t3 != "function")
          throw TypeError(e4 + " is not iterable!");
        return a(t3.call(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).getIteratorMethod = function(e4) {
        if (e4 != null)
          return e4[r2] || e4["@@iterator"] || o[a(e4)];
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(90), __esModule: true };
    }, function(e3, t2, n2) {
      n2(91), e3.exports = n2(1).Object.keys;
    }, function(e3, t2, n2) {
      var a = n2(18), r2 = n2(13);
      n2(92)("keys", function() {
        return function(e4) {
          return r2(a(e4));
        };
      });
    }, function(e3, t2, n2) {
      var a = n2(15), r2 = n2(1), o = n2(8);
      e3.exports = function(e4, t3) {
        var n3 = (r2.Object || {})[e4] || Object[e4], i = {};
        i[e4] = t3(n3), a(a.S + a.F * o(function() {
          n3(1);
        }), "Object", i);
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], a = /^\s+|\s+$/g, r2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, o = /\{\n\/\* \[wrapped with (.+)\] \*/, i = /,? & /, s = /^[-+]0x[0-9a-f]+$/i, c2 = /^0b[01]+$/i, l2 = /^\[object .+?Constructor\]$/, u = /^0o[0-7]+$/i, f2 = /^(?:0|[1-9]\d*)$/, p2 = parseInt, d2 = typeof t3 == "object" && t3 && t3.Object === Object && t3, b2 = typeof self == "object" && self && self.Object === Object && self, h = d2 || b2 || Function("return this")();
        function v4(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function m2(e4, t4) {
          return !!(e4 ? e4.length : 0) && function(e5, t5, n4) {
            if (t5 != t5)
              return function(e6, t6, n5, a3) {
                var r4 = e6.length, o2 = n5 + (a3 ? 1 : -1);
                for (; a3 ? o2-- : ++o2 < r4; )
                  if (t6(e6[o2], o2, e6))
                    return o2;
                return -1;
              }(e5, y2, n4);
            var a2 = n4 - 1, r3 = e5.length;
            for (; ++a2 < r3; )
              if (e5[a2] === t5)
                return a2;
            return -1;
          }(e4, t4, 0) > -1;
        }
        function y2(e4) {
          return e4 != e4;
        }
        function g2(e4, t4) {
          for (var n4 = e4.length, a2 = 0; n4--; )
            e4[n4] === t4 && a2++;
          return a2;
        }
        function E(e4, t4) {
          for (var n4 = -1, a2 = e4.length, r3 = 0, o2 = []; ++n4 < a2; ) {
            var i2 = e4[n4];
            i2 !== t4 && i2 !== "__lodash_placeholder__" || (e4[n4] = "__lodash_placeholder__", o2[r3++] = n4);
          }
          return o2;
        }
        var j, x2, _, k2 = Function.prototype, O = Object.prototype, C = h["__core-js_shared__"], S = (j = /[^.]+$/.exec(C && C.keys && C.keys.IE_PROTO || "")) ? "Symbol(src)_1." + j : "", w2 = k2.toString, A2 = O.hasOwnProperty, M = O.toString, P = RegExp("^" + w2.call(A2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), F = Object.create, D = Math.max, I = Math.min, R = (x2 = H(Object, "defineProperty"), (_ = H.name) && _.length > 2 ? x2 : void 0);
        function L(e4) {
          return X(e4) ? F(e4) : {};
        }
        function B(e4) {
          return !(!X(e4) || function(e5) {
            return !!S && S in e5;
          }(e4)) && (function(e5) {
            var t4 = X(e5) ? M.call(e5) : "";
            return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
          }(e4) || function(e5) {
            var t4 = false;
            if (e5 != null && typeof e5.toString != "function")
              try {
                t4 = !!(e5 + "");
              } catch (e6) {
              }
            return t4;
          }(e4) ? P : l2).test(function(e5) {
            if (e5 != null) {
              try {
                return w2.call(e5);
              } catch (e6) {
              }
              try {
                return e5 + "";
              } catch (e6) {
              }
            }
            return "";
          }(e4));
        }
        function N(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = n4.length, s2 = -1, c3 = t4.length, l3 = D(o2 - i2, 0), u2 = Array(c3 + l3), f3 = !a2; ++s2 < c3; )
            u2[s2] = t4[s2];
          for (; ++r3 < i2; )
            (f3 || r3 < o2) && (u2[n4[r3]] = e4[r3]);
          for (; l3--; )
            u2[s2++] = e4[r3++];
          return u2;
        }
        function z2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = -1, s2 = n4.length, c3 = -1, l3 = t4.length, u2 = D(o2 - s2, 0), f3 = Array(u2 + l3), p3 = !a2; ++r3 < u2; )
            f3[r3] = e4[r3];
          for (var d3 = r3; ++c3 < l3; )
            f3[d3 + c3] = t4[c3];
          for (; ++i2 < s2; )
            (p3 || r3 < o2) && (f3[d3 + n4[i2]] = e4[r3++]);
          return f3;
        }
        function T(e4) {
          return function() {
            var t4 = arguments;
            switch (t4.length) {
              case 0:
                return new e4();
              case 1:
                return new e4(t4[0]);
              case 2:
                return new e4(t4[0], t4[1]);
              case 3:
                return new e4(t4[0], t4[1], t4[2]);
              case 4:
                return new e4(t4[0], t4[1], t4[2], t4[3]);
              case 5:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4]);
              case 6:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5]);
              case 7:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5], t4[6]);
            }
            var n4 = L(e4.prototype), a2 = e4.apply(n4, t4);
            return X(a2) ? a2 : n4;
          };
        }
        function q2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 128 & t4, f3 = 1 & t4, p3 = 2 & t4, d3 = 24 & t4, b3 = 512 & t4, v5 = p3 ? void 0 : T(e4);
          return function m3() {
            for (var y3 = arguments.length, j2 = Array(y3), x3 = y3; x3--; )
              j2[x3] = arguments[x3];
            if (d3)
              var _2 = W(m3), k3 = g2(j2, _2);
            if (a2 && (j2 = N(j2, a2, r3, d3)), o2 && (j2 = z2(j2, o2, i2, d3)), y3 -= k3, d3 && y3 < l3) {
              var O2 = E(j2, _2);
              return V(e4, t4, q2, m3.placeholder, n4, j2, O2, s2, c3, l3 - y3);
            }
            var C2 = f3 ? n4 : this, S2 = p3 ? C2[e4] : e4;
            return y3 = j2.length, s2 ? j2 = Y(j2, s2) : b3 && y3 > 1 && j2.reverse(), u2 && c3 < y3 && (j2.length = c3), this && this !== h && this instanceof m3 && (S2 = v5 || T(S2)), S2.apply(C2, j2);
          };
        }
        function V(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 8 & t4;
          t4 |= u2 ? 32 : 64, 4 & (t4 &= ~(u2 ? 64 : 32)) || (t4 &= -4);
          var f3 = n4(e4, t4, r3, u2 ? o2 : void 0, u2 ? i2 : void 0, u2 ? void 0 : o2, u2 ? void 0 : i2, s2, c3, l3);
          return f3.placeholder = a2, $(f3, e4, t4);
        }
        function K(e4, t4, n4, a2, r3, o2, i2, s2) {
          var c3 = 2 & t4;
          if (!c3 && typeof e4 != "function")
            throw new TypeError("Expected a function");
          var l3 = a2 ? a2.length : 0;
          if (l3 || (t4 &= -97, a2 = r3 = void 0), i2 = i2 === void 0 ? i2 : D(te(i2), 0), s2 = s2 === void 0 ? s2 : te(s2), l3 -= r3 ? r3.length : 0, 64 & t4) {
            var u2 = a2, f3 = r3;
            a2 = r3 = void 0;
          }
          var p3 = [e4, t4, n4, a2, r3, u2, f3, o2, i2, s2];
          if (e4 = p3[0], t4 = p3[1], n4 = p3[2], a2 = p3[3], r3 = p3[4], !(s2 = p3[9] = p3[9] == null ? c3 ? 0 : e4.length : D(p3[9] - l3, 0)) && 24 & t4 && (t4 &= -25), t4 && t4 != 1)
            d3 = t4 == 8 || t4 == 16 ? function(e5, t5, n5) {
              var a3 = T(e5);
              return function r4() {
                for (var o3 = arguments.length, i3 = Array(o3), s3 = o3, c4 = W(r4); s3--; )
                  i3[s3] = arguments[s3];
                var l4 = o3 < 3 && i3[0] !== c4 && i3[o3 - 1] !== c4 ? [] : E(i3, c4);
                if ((o3 -= l4.length) < n5)
                  return V(e5, t5, q2, r4.placeholder, void 0, i3, l4, void 0, void 0, n5 - o3);
                var u3 = this && this !== h && this instanceof r4 ? a3 : e5;
                return v4(u3, this, i3);
              };
            }(e4, t4, s2) : t4 != 32 && t4 != 33 || r3.length ? q2.apply(void 0, p3) : function(e5, t5, n5, a3) {
              var r4 = 1 & t5, o3 = T(e5);
              return function t6() {
                for (var i3 = -1, s3 = arguments.length, c4 = -1, l4 = a3.length, u3 = Array(l4 + s3), f4 = this && this !== h && this instanceof t6 ? o3 : e5; ++c4 < l4; )
                  u3[c4] = a3[c4];
                for (; s3--; )
                  u3[c4++] = arguments[++i3];
                return v4(f4, r4 ? n5 : this, u3);
              };
            }(e4, t4, n4, a2);
          else
            var d3 = function(e5, t5, n5) {
              var a3 = 1 & t5, r4 = T(e5);
              return function t6() {
                var o3 = this && this !== h && this instanceof t6 ? r4 : e5;
                return o3.apply(a3 ? n5 : this, arguments);
              };
            }(e4, t4, n4);
          return $(d3, e4, t4);
        }
        function W(e4) {
          return e4.placeholder;
        }
        function H(e4, t4) {
          var n4 = function(e5, t5) {
            return e5 == null ? void 0 : e5[t5];
          }(e4, t4);
          return B(n4) ? n4 : void 0;
        }
        function U(e4) {
          var t4 = e4.match(o);
          return t4 ? t4[1].split(i) : [];
        }
        function G(e4, t4) {
          var n4 = t4.length, a2 = n4 - 1;
          return t4[a2] = (n4 > 1 ? "& " : "") + t4[a2], t4 = t4.join(n4 > 2 ? ", " : " "), e4.replace(r2, "{\n/* [wrapped with " + t4 + "] */\n");
        }
        function J(e4, t4) {
          return !!(t4 = t4 == null ? 9007199254740991 : t4) && (typeof e4 == "number" || f2.test(e4)) && e4 > -1 && e4 % 1 == 0 && e4 < t4;
        }
        function Y(e4, t4) {
          for (var n4 = e4.length, a2 = I(t4.length, n4), r3 = function(e5, t5) {
            var n5 = -1, a3 = e5.length;
            for (t5 || (t5 = Array(a3)); ++n5 < a3; )
              t5[n5] = e5[n5];
            return t5;
          }(e4); a2--; ) {
            var o2 = t4[a2];
            e4[a2] = J(o2, n4) ? r3[o2] : void 0;
          }
          return e4;
        }
        var $ = R ? function(e4, t4, n4) {
          var a2, r3 = t4 + "";
          return R(e4, "toString", { configurable: true, enumerable: false, value: (a2 = G(r3, Q(U(r3), n4)), function() {
            return a2;
          }) });
        } : function(e4) {
          return e4;
        };
        function Q(e4, t4) {
          return function(e5, t5) {
            for (var n4 = -1, a2 = e5 ? e5.length : 0; ++n4 < a2 && t5(e5[n4], n4, e5) !== false; )
              ;
          }(n3, function(n4) {
            var a2 = "_." + n4[0];
            t4 & n4[1] && !m2(e4, a2) && e4.push(a2);
          }), e4.sort();
        }
        function Z(e4, t4, n4) {
          var a2 = K(e4, 8, void 0, void 0, void 0, void 0, void 0, t4 = n4 ? void 0 : t4);
          return a2.placeholder = Z.placeholder, a2;
        }
        function X(e4) {
          var t4 = typeof e4;
          return !!e4 && (t4 == "object" || t4 == "function");
        }
        function ee(e4) {
          return e4 ? (e4 = function(e5) {
            if (typeof e5 == "number")
              return e5;
            if (function(e6) {
              return typeof e6 == "symbol" || function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && M.call(e6) == "[object Symbol]";
            }(e5))
              return NaN;
            if (X(e5)) {
              var t4 = typeof e5.valueOf == "function" ? e5.valueOf() : e5;
              e5 = X(t4) ? t4 + "" : t4;
            }
            if (typeof e5 != "string")
              return e5 === 0 ? e5 : +e5;
            e5 = e5.replace(a, "");
            var n4 = c2.test(e5);
            return n4 || u.test(e5) ? p2(e5.slice(2), n4 ? 2 : 8) : s.test(e5) ? NaN : +e5;
          }(e4)) === 1 / 0 || e4 === -1 / 0 ? 17976931348623157e292 * (e4 < 0 ? -1 : 1) : e4 == e4 ? e4 : 0 : e4 === 0 ? e4 : 0;
        }
        function te(e4) {
          var t4 = ee(e4), n4 = t4 % 1;
          return t4 == t4 ? n4 ? t4 - n4 : t4 : 0;
        }
        Z.placeholder = {}, e3.exports = Z;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      function a(e4) {
        return e4 && e4.__esModule ? e4.default : e4;
      }
      t2.__esModule = true;
      var r2 = n2(95);
      t2.threezerotwofour = a(r2);
      var o = n2(96);
      t2.apathy = a(o);
      var i = n2(97);
      t2.ashes = a(i);
      var s = n2(98);
      t2.atelierDune = a(s);
      var c2 = n2(99);
      t2.atelierForest = a(c2);
      var l2 = n2(100);
      t2.atelierHeath = a(l2);
      var u = n2(101);
      t2.atelierLakeside = a(u);
      var f2 = n2(102);
      t2.atelierSeaside = a(f2);
      var p2 = n2(103);
      t2.bespin = a(p2);
      var d2 = n2(104);
      t2.brewer = a(d2);
      var b2 = n2(105);
      t2.bright = a(b2);
      var h = n2(106);
      t2.chalk = a(h);
      var v4 = n2(107);
      t2.codeschool = a(v4);
      var m2 = n2(108);
      t2.colors = a(m2);
      var y2 = n2(109);
      t2.default = a(y2);
      var g2 = n2(110);
      t2.eighties = a(g2);
      var E = n2(111);
      t2.embers = a(E);
      var j = n2(112);
      t2.flat = a(j);
      var x2 = n2(113);
      t2.google = a(x2);
      var _ = n2(114);
      t2.grayscale = a(_);
      var k2 = n2(115);
      t2.greenscreen = a(k2);
      var O = n2(116);
      t2.harmonic = a(O);
      var C = n2(117);
      t2.hopscotch = a(C);
      var S = n2(118);
      t2.isotope = a(S);
      var w2 = n2(119);
      t2.marrakesh = a(w2);
      var A2 = n2(120);
      t2.mocha = a(A2);
      var M = n2(121);
      t2.monokai = a(M);
      var P = n2(122);
      t2.ocean = a(P);
      var F = n2(123);
      t2.paraiso = a(F);
      var D = n2(124);
      t2.pop = a(D);
      var I = n2(125);
      t2.railscasts = a(I);
      var R = n2(126);
      t2.shapeshifter = a(R);
      var L = n2(127);
      t2.solarized = a(L);
      var B = n2(128);
      t2.summerfruit = a(B);
      var N = n2(129);
      t2.tomorrow = a(N);
      var z2 = n2(130);
      t2.tube = a(z2);
      var T = n2(131);
      t2.twilight = a(T);
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      var a = n2(33);
      function r2(e4) {
        var t3 = Math.round(a(e4, 0, 255)).toString(16);
        return t3.length == 1 ? "0" + t3 : t3;
      }
      e3.exports = function(e4) {
        var t3 = e4.length === 4 ? r2(255 * e4[3]) : "";
        return "#" + r2(e4[0]) + r2(e4[1]) + r2(e4[2]) + t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(134), r2 = n2(135), o = n2(136), i = n2(137);
      var s = { "#": r2, hsl: function(e4) {
        var t3 = a(e4), n3 = i(t3);
        return t3.length === 4 && n3.push(t3[3]), n3;
      }, rgb: o };
      function c2(e4) {
        for (var t3 in s)
          if (e4.indexOf(t3) === 0)
            return s[t3](e4);
      }
      c2.rgb = o, c2.hsl = a, c2.hex = r2, e3.exports = c2;
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        switch (e4 = parseFloat(e4), t3) {
          case 0:
            return r2(e4, 0, 360);
          case 1:
          case 2:
            return r2(e4, 0, 100);
          case 3:
            return r2(e4, 0, 1);
        }
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        e4.length !== 4 && e4.length !== 5 || (e4 = function(e5) {
          for (var t4 = "#", n3 = 1; n3 < e5.length; n3++) {
            var a = e5.charAt(n3);
            t4 += a + a;
          }
          return t4;
        }(e4));
        var t3 = [parseInt(e4.substring(1, 3), 16), parseInt(e4.substring(3, 5), 16), parseInt(e4.substring(5, 7), 16)];
        if (e4.length === 9) {
          var n2 = parseFloat((parseInt(e4.substring(7, 9), 16) / 255).toFixed(2));
          t3.push(n2);
        }
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        return t3 < 3 ? e4.indexOf("%") != -1 ? Math.round(255 * r2(parseInt(e4, 10), 0, 100) / 100) : r2(parseInt(e4, 10), 0, 255) : r2(parseFloat(e4), 0, 1);
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        var t3, n2, a, r2, o, i = e4[0] / 360, s = e4[1] / 100, c2 = e4[2] / 100;
        if (s == 0)
          return [o = 255 * c2, o, o];
        t3 = 2 * c2 - (n2 = c2 < 0.5 ? c2 * (1 + s) : c2 + s - c2 * s), r2 = [0, 0, 0];
        for (var l2 = 0; l2 < 3; l2++)
          (a = i + 1 / 3 * -(l2 - 1)) < 0 && a++, a > 1 && a--, o = 6 * a < 1 ? t3 + 6 * (n2 - t3) * a : 2 * a < 1 ? n2 : 3 * a < 2 ? t3 + (n2 - t3) * (2 / 3 - a) * 6 : t3, r2[l2] = 255 * o;
        return r2;
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = typeof t3 == "object" && t3 && t3.Object === Object && t3, a = typeof self == "object" && self && self.Object === Object && self, r2 = n3 || a || Function("return this")();
        function o(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function i(e4, t4) {
          for (var n4 = -1, a2 = t4.length, r3 = e4.length; ++n4 < a2; )
            e4[r3 + n4] = t4[n4];
          return e4;
        }
        var s = Object.prototype, c2 = s.hasOwnProperty, l2 = s.toString, u = r2.Symbol, f2 = s.propertyIsEnumerable, p2 = u ? u.isConcatSpreadable : void 0, d2 = Math.max;
        function b2(e4) {
          return h(e4) || function(e5) {
            return function(e6) {
              return function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && function(e7) {
                return e7 != null && function(e8) {
                  return typeof e8 == "number" && e8 > -1 && e8 % 1 == 0 && e8 <= 9007199254740991;
                }(e7.length) && !function(e8) {
                  var t4 = function(e9) {
                    var t5 = typeof e9;
                    return !!e9 && (t5 == "object" || t5 == "function");
                  }(e8) ? l2.call(e8) : "";
                  return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
                }(e7);
              }(e6);
            }(e5) && c2.call(e5, "callee") && (!f2.call(e5, "callee") || l2.call(e5) == "[object Arguments]");
          }(e4) || !!(p2 && e4 && e4[p2]);
        }
        var h = Array.isArray;
        var v4, m2, y2, g2 = (m2 = function(e4) {
          var t4 = (e4 = function e5(t5, n5, a2, r3, o2) {
            var s2 = -1, c3 = t5.length;
            for (a2 || (a2 = b2), o2 || (o2 = []); ++s2 < c3; ) {
              var l3 = t5[s2];
              n5 > 0 && a2(l3) ? n5 > 1 ? e5(l3, n5 - 1, a2, r3, o2) : i(o2, l3) : r3 || (o2[o2.length] = l3);
            }
            return o2;
          }(e4, 1)).length, n4 = t4;
          for (v4; n4--; )
            if (typeof e4[n4] != "function")
              throw new TypeError("Expected a function");
          return function() {
            for (var n5 = 0, a2 = t4 ? e4[n5].apply(this, arguments) : arguments[0]; ++n5 < t4; )
              a2 = e4[n5].call(this, a2);
            return a2;
          };
        }, y2 = d2(y2 === void 0 ? m2.length - 1 : y2, 0), function() {
          for (var e4 = arguments, t4 = -1, n4 = d2(e4.length - y2, 0), a2 = Array(n4); ++t4 < n4; )
            a2[t4] = e4[y2 + t4];
          t4 = -1;
          for (var r3 = Array(y2 + 1); ++t4 < y2; )
            r3[t4] = e4[t4];
          return r3[y2] = a2, o(m2, this, r3);
        });
        e3.exports = g2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.yuv2rgb = function(e4) {
        var t3, n3, a, r2 = e4[0], o = e4[1], i = e4[2];
        return t3 = 1 * r2 + 0 * o + 1.13983 * i, n3 = 1 * r2 + -0.39465 * o + -0.5806 * i, a = 1 * r2 + 2.02311 * o + 0 * i, t3 = Math.min(Math.max(0, t3), 1), n3 = Math.min(Math.max(0, n3), 1), a = Math.min(Math.max(0, a), 1), [255 * t3, 255 * n3, 255 * a];
      }, t2.rgb2yuv = function(e4) {
        var t3 = e4[0] / 255, n3 = e4[1] / 255, a = e4[2] / 255;
        return [0.299 * t3 + 0.587 * n3 + 0.114 * a, -0.14713 * t3 + -0.28886 * n3 + 0.436 * a, 0.615 * t3 + -0.51499 * n3 + -0.10001 * a];
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      var r2 = n2(141), o = function() {
        function e4() {
          a(this, "_callbacks", void 0), a(this, "_isDispatching", void 0), a(this, "_isHandled", void 0), a(this, "_isPending", void 0), a(this, "_lastID", void 0), a(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
        }
        var t3 = e4.prototype;
        return t3.register = function(e5) {
          var t4 = "ID_" + this._lastID++;
          return this._callbacks[t4] = e5, t4;
        }, t3.unregister = function(e5) {
          this._callbacks[e5] || r2(false), delete this._callbacks[e5];
        }, t3.waitFor = function(e5) {
          this._isDispatching || r2(false);
          for (var t4 = 0; t4 < e5.length; t4++) {
            var n3 = e5[t4];
            this._isPending[n3] ? this._isHandled[n3] || r2(false) : (this._callbacks[n3] || r2(false), this._invokeCallback(n3));
          }
        }, t3.dispatch = function(e5) {
          this._isDispatching && r2(false), this._startDispatching(e5);
          try {
            for (var t4 in this._callbacks)
              this._isPending[t4] || this._invokeCallback(t4);
          } finally {
            this._stopDispatching();
          }
        }, t3.isDispatching = function() {
          return this._isDispatching;
        }, t3._invokeCallback = function(e5) {
          this._isPending[e5] = true, this._callbacks[e5](this._pendingPayload), this._isHandled[e5] = true;
        }, t3._startDispatching = function(e5) {
          for (var t4 in this._callbacks)
            this._isPending[t4] = false, this._isHandled[t4] = false;
          this._pendingPayload = e5, this._isDispatching = true;
        }, t3._stopDispatching = function() {
          delete this._pendingPayload, this._isDispatching = false;
        }, e4;
      }();
      e3.exports = o;
    }, function(e3, t2, n2) {
      e3.exports = function(e4, t3) {
        for (var n3 = arguments.length, r2 = new Array(n3 > 2 ? n3 - 2 : 0), o = 2; o < n3; o++)
          r2[o - 2] = arguments[o];
        if (!e4) {
          var i;
          if (t3 === void 0)
            i = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
          else {
            var s = 0;
            (i = new Error(t3.replace(/%s/g, function() {
              return String(r2[s++]);
            }))).name = "Invariant Violation";
          }
          throw i.framesToPop = 1, i;
        }
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      function r2(e4, t3) {
        var n3 = Object.keys(e4);
        if (Object.getOwnPropertySymbols) {
          var a2 = Object.getOwnPropertySymbols(e4);
          t3 && (a2 = a2.filter(function(t4) {
            return Object.getOwnPropertyDescriptor(e4, t4).enumerable;
          })), n3.push.apply(n3, a2);
        }
        return n3;
      }
      function o(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3] != null ? arguments[t3] : {};
          t3 % 2 ? r2(Object(n3), true).forEach(function(t4) {
            a(e4, t4, n3[t4]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e4, Object.getOwnPropertyDescriptors(n3)) : r2(Object(n3)).forEach(function(t4) {
            Object.defineProperty(e4, t4, Object.getOwnPropertyDescriptor(n3, t4));
          });
        }
        return e4;
      }
      function i(e4, t3) {
        if (!(e4 instanceof t3))
          throw new TypeError("Cannot call a class as a function");
      }
      function s(e4, t3) {
        for (var n3 = 0; n3 < t3.length; n3++) {
          var a2 = t3[n3];
          a2.enumerable = a2.enumerable || false, a2.configurable = true, "value" in a2 && (a2.writable = true), Object.defineProperty(e4, a2.key, a2);
        }
      }
      function c2(e4, t3, n3) {
        return t3 && s(e4.prototype, t3), n3 && s(e4, n3), e4;
      }
      function l2(e4, t3) {
        return (l2 = Object.setPrototypeOf || function(e5, t4) {
          return e5.__proto__ = t4, e5;
        })(e4, t3);
      }
      function u(e4, t3) {
        if (typeof t3 != "function" && t3 !== null)
          throw new TypeError("Super expression must either be null or a function");
        e4.prototype = Object.create(t3 && t3.prototype, { constructor: { value: e4, writable: true, configurable: true } }), t3 && l2(e4, t3);
      }
      function f2(e4) {
        return (f2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(e5) {
          return e5.__proto__ || Object.getPrototypeOf(e5);
        })(e4);
      }
      function p2(e4) {
        return (p2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e5) {
          return typeof e5;
        } : function(e5) {
          return e5 && typeof Symbol == "function" && e5.constructor === Symbol && e5 !== Symbol.prototype ? "symbol" : typeof e5;
        })(e4);
      }
      function d2(e4) {
        if (e4 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return e4;
      }
      function b2(e4, t3) {
        return !t3 || p2(t3) !== "object" && typeof t3 != "function" ? d2(e4) : t3;
      }
      function h(e4) {
        var t3 = function() {
          if (typeof Reflect == "undefined" || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (e5) {
            return false;
          }
        }();
        return function() {
          var n3, a2 = f2(e4);
          if (t3) {
            var r3 = f2(this).constructor;
            n3 = Reflect.construct(a2, arguments, r3);
          } else
            n3 = a2.apply(this, arguments);
          return b2(this, n3);
        };
      }
      n2.r(t2);
      var v4 = n2(0), m2 = n2.n(v4);
      function y2() {
        var e4 = this.constructor.getDerivedStateFromProps(this.props, this.state);
        e4 != null && this.setState(e4);
      }
      function g2(e4) {
        this.setState(function(t3) {
          var n3 = this.constructor.getDerivedStateFromProps(e4, t3);
          return n3 != null ? n3 : null;
        }.bind(this));
      }
      function E(e4, t3) {
        try {
          var n3 = this.props, a2 = this.state;
          this.props = e4, this.state = t3, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(n3, a2);
        } finally {
          this.props = n3, this.state = a2;
        }
      }
      function j(e4) {
        var t3 = e4.prototype;
        if (!t3 || !t3.isReactComponent)
          throw new Error("Can only polyfill class components");
        if (typeof e4.getDerivedStateFromProps != "function" && typeof t3.getSnapshotBeforeUpdate != "function")
          return e4;
        var n3 = null, a2 = null, r3 = null;
        if (typeof t3.componentWillMount == "function" ? n3 = "componentWillMount" : typeof t3.UNSAFE_componentWillMount == "function" && (n3 = "UNSAFE_componentWillMount"), typeof t3.componentWillReceiveProps == "function" ? a2 = "componentWillReceiveProps" : typeof t3.UNSAFE_componentWillReceiveProps == "function" && (a2 = "UNSAFE_componentWillReceiveProps"), typeof t3.componentWillUpdate == "function" ? r3 = "componentWillUpdate" : typeof t3.UNSAFE_componentWillUpdate == "function" && (r3 = "UNSAFE_componentWillUpdate"), n3 !== null || a2 !== null || r3 !== null) {
          var o2 = e4.displayName || e4.name, i2 = typeof e4.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
          throw Error("Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n" + o2 + " uses " + i2 + " but also contains the following legacy lifecycles:" + (n3 !== null ? "\n  " + n3 : "") + (a2 !== null ? "\n  " + a2 : "") + (r3 !== null ? "\n  " + r3 : "") + "\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://fb.me/react-async-component-lifecycle-hooks");
        }
        if (typeof e4.getDerivedStateFromProps == "function" && (t3.componentWillMount = y2, t3.componentWillReceiveProps = g2), typeof t3.getSnapshotBeforeUpdate == "function") {
          if (typeof t3.componentDidUpdate != "function")
            throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
          t3.componentWillUpdate = E;
          var s2 = t3.componentDidUpdate;
          t3.componentDidUpdate = function(e5, t4, n4) {
            var a3 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : n4;
            s2.call(this, e5, t4, a3);
          };
        }
        return e4;
      }
      function x2(e4, t3) {
        if (e4 == null)
          return {};
        var n3, a2, r3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, t3);
        if (Object.getOwnPropertySymbols) {
          var o2 = Object.getOwnPropertySymbols(e4);
          for (a2 = 0; a2 < o2.length; a2++)
            n3 = o2[a2], t3.indexOf(n3) >= 0 || Object.prototype.propertyIsEnumerable.call(e4, n3) && (r3[n3] = e4[n3]);
        }
        return r3;
      }
      function _(e4) {
        var t3 = function(e5) {
          return {}.toString.call(e5).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
        }(e4);
        return t3 === "number" && (t3 = isNaN(e4) ? "nan" : (0 | e4) != e4 ? "float" : "integer"), t3;
      }
      y2.__suppressDeprecationWarning = true, g2.__suppressDeprecationWarning = true, E.__suppressDeprecationWarning = true;
      var k2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, O = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, C = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, S = n2(45), w2 = function(e4) {
        var t3 = function(e5) {
          return { backgroundColor: e5.base00, ellipsisColor: e5.base09, braceColor: e5.base07, expandedIcon: e5.base0D, collapsedIcon: e5.base0E, keyColor: e5.base07, arrayKeyColor: e5.base0C, objectSize: e5.base04, copyToClipboard: e5.base0F, copyToClipboardCheck: e5.base0D, objectBorder: e5.base02, dataTypes: { boolean: e5.base0E, date: e5.base0D, float: e5.base0B, function: e5.base0D, integer: e5.base0F, string: e5.base09, nan: e5.base08, null: e5.base0A, undefined: e5.base05, regexp: e5.base0A, background: e5.base02 }, editVariable: { editIcon: e5.base0E, cancelIcon: e5.base09, removeIcon: e5.base09, addIcon: e5.base0E, checkIcon: e5.base0E, background: e5.base01, color: e5.base0A, border: e5.base07 }, addKeyModal: { background: e5.base05, border: e5.base04, color: e5.base0A, labelColor: e5.base01 }, validationFailure: { background: e5.base09, iconColor: e5.base01, fontColor: e5.base01 } };
        }(e4);
        return { "app-container": { fontFamily: C.globalFontFamily, cursor: C.globalCursor, backgroundColor: t3.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: C.braceCursor, fontWeight: C.braceFontWeight, color: t3.braceColor }, "expanded-icon": { color: t3.expandedIcon }, "collapsed-icon": { color: t3.collapsedIcon }, colon: { display: "inline-block", margin: C.keyMargin, color: t3.keyColor, verticalAlign: "top" }, objectKeyVal: function(e5, n3) {
          return { style: o({ paddingTop: C.keyValPaddingTop, paddingRight: C.keyValPaddingRight, paddingBottom: C.keyValPaddingBottom, borderLeft: C.keyValBorderLeft + " " + t3.objectBorder, ":hover": { paddingLeft: n3.paddingLeft - 1 + "px", borderLeft: C.keyValBorderHover + " " + t3.objectBorder } }, n3) };
        }, "object-key-val-no-border": { padding: C.keyValPadding }, "pushed-content": { marginLeft: C.pushedContentMarginLeft }, variableValue: function(e5, t4) {
          return { style: o({ display: "inline-block", paddingRight: C.variableValuePaddingRight, position: "relative" }, t4) };
        }, "object-name": { display: "inline-block", color: t3.keyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "array-key": { display: "inline-block", color: t3.arrayKeyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "object-size": { color: t3.objectSize, borderRadius: C.objectSizeBorderRadius, fontStyle: C.objectSizeFontStyle, margin: C.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: C.dataTypeFontSize, marginRight: C.dataTypeMarginRight, opacity: C.datatypeOpacity }, boolean: { display: "inline-block", color: t3.dataTypes.boolean }, date: { display: "inline-block", color: t3.dataTypes.date }, "date-value": { marginLeft: C.dateValueMarginLeft }, float: { display: "inline-block", color: t3.dataTypes.float }, function: { display: "inline-block", color: t3.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: t3.dataTypes.integer }, string: { display: "inline-block", color: t3.dataTypes.string }, nan: { display: "inline-block", color: t3.dataTypes.nan, fontSize: C.nanFontSize, fontWeight: C.nanFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nanPadding, borderRadius: C.nanBorderRadius }, null: { display: "inline-block", color: t3.dataTypes.null, fontSize: C.nullFontSize, fontWeight: C.nullFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nullPadding, borderRadius: C.nullBorderRadius }, undefined: { display: "inline-block", color: t3.dataTypes.undefined, fontSize: C.undefinedFontSize, padding: C.undefinedPadding, borderRadius: C.undefinedBorderRadius, backgroundColor: t3.dataTypes.background }, regexp: { display: "inline-block", color: t3.dataTypes.regexp }, "copy-to-clipboard": { cursor: C.clipboardCursor }, "copy-icon": { color: t3.copyToClipboard, fontSize: C.iconFontSize, marginRight: C.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: t3.copyToClipboardCheck, marginLeft: C.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: C.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: C.metaDataPadding }, "icon-container": { display: "inline-block", width: C.iconContainerWidth }, tooltip: { padding: C.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.removeIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.addIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.editIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.checkIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.cancelIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: C.editInputMinWidth, borderRadius: C.editInputBorderRadius, backgroundColor: t3.editVariable.background, color: t3.editVariable.color, padding: C.editInputPadding, marginRight: C.editInputMarginRight, fontFamily: C.editInputFontFamily }, "detected-row": { paddingTop: C.detectedRowPaddingTop }, "key-modal-request": { position: C.addKeyCoverPosition, top: C.addKeyCoverPositionPx, left: C.addKeyCoverPositionPx, right: C.addKeyCoverPositionPx, bottom: C.addKeyCoverPositionPx, backgroundColor: C.addKeyCoverBackground }, "key-modal": { width: C.addKeyModalWidth, backgroundColor: t3.addKeyModal.background, marginLeft: C.addKeyModalMargin, marginRight: C.addKeyModalMargin, padding: C.addKeyModalPadding, borderRadius: C.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: t3.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: t3.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: t3.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: t3.addKeyModal.labelColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: t3.editVariable.addIcon, fontSize: C.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: t3.validationFailure.fontColor, backgroundColor: t3.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: t3.validationFailure.iconColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" } };
      };
      function A2(e4, t3, n3) {
        return e4 || console.error("theme has not been set"), function(e5) {
          var t4 = k2;
          return e5 !== false && e5 !== "none" || (t4 = O), Object(S.createStyling)(w2, { defaultBase16: t4 })(e5);
        }(e4)(t3, n3);
      }
      var M = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = (e5.rjvId, e5.type_name), n4 = e5.displayDataTypes, a2 = e5.theme;
          return n4 ? m2.a.createElement("span", Object.assign({ className: "data-type-label" }, A2(a2, "data-type-label")), t4) : null;
        } }]), n3;
      }(m2.a.PureComponent), P = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "boolean"), m2.a.createElement(M, Object.assign({ type_name: "bool" }, e5)), e5.value ? "true" : "false");
        } }]), n3;
      }(m2.a.PureComponent), F = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "date"), m2.a.createElement(M, Object.assign({ type_name: "date" }, e5)), m2.a.createElement("span", Object.assign({ className: "date-value" }, A2(e5.theme, "date-value")), e5.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
        } }]), n3;
      }(m2.a.PureComponent), D = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "float"), m2.a.createElement(M, Object.assign({ type_name: "float" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent);
      function I(e4, t3) {
        (t3 == null || t3 > e4.length) && (t3 = e4.length);
        for (var n3 = 0, a2 = new Array(t3); n3 < t3; n3++)
          a2[n3] = e4[n3];
        return a2;
      }
      function R(e4, t3) {
        if (e4) {
          if (typeof e4 == "string")
            return I(e4, t3);
          var n3 = Object.prototype.toString.call(e4).slice(8, -1);
          return n3 === "Object" && e4.constructor && (n3 = e4.constructor.name), n3 === "Map" || n3 === "Set" ? Array.from(e4) : n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3) ? I(e4, t3) : void 0;
        }
      }
      function L(e4, t3) {
        var n3;
        if (typeof Symbol == "undefined" || e4[Symbol.iterator] == null) {
          if (Array.isArray(e4) || (n3 = R(e4)) || t3 && e4 && typeof e4.length == "number") {
            n3 && (e4 = n3);
            var a2 = 0, r3 = function() {
            };
            return { s: r3, n: function() {
              return a2 >= e4.length ? { done: true } : { done: false, value: e4[a2++] };
            }, e: function(e5) {
              throw e5;
            }, f: r3 };
          }
          throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }
        var o2, i2 = true, s2 = false;
        return { s: function() {
          n3 = e4[Symbol.iterator]();
        }, n: function() {
          var e5 = n3.next();
          return i2 = e5.done, e5;
        }, e: function(e5) {
          s2 = true, o2 = e5;
        }, f: function() {
          try {
            i2 || n3.return == null || n3.return();
          } finally {
            if (s2)
              throw o2;
          }
        } };
      }
      function B(e4) {
        return function(e5) {
          if (Array.isArray(e5))
            return I(e5);
        }(e4) || function(e5) {
          if (typeof Symbol != "undefined" && Symbol.iterator in Object(e5))
            return Array.from(e5);
        }(e4) || R(e4) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }();
      }
      var N = n2(46), z2 = new (n2(47)).Dispatcher(), T = new (function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).objects = {}, e5.set = function(t4, n4, a3, r4) {
            e5.objects[t4] === void 0 && (e5.objects[t4] = {}), e5.objects[t4][n4] === void 0 && (e5.objects[t4][n4] = {}), e5.objects[t4][n4][a3] = r4;
          }, e5.get = function(t4, n4, a3, r4) {
            return e5.objects[t4] === void 0 || e5.objects[t4][n4] === void 0 || e5.objects[t4][n4][a3] == null ? r4 : e5.objects[t4][n4][a3];
          }, e5.handleAction = function(t4) {
            var n4 = t4.rjvId, a3 = t4.data;
            switch (t4.name) {
              case "RESET":
                e5.emit("reset-" + n4);
                break;
              case "VARIABLE_UPDATED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-edited" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_REMOVED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-removed" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_ADDED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-added" })), e5.emit("variable-update-" + n4);
                break;
              case "ADD_VARIABLE_KEY_REQUEST":
                e5.set(n4, "action", "new-key-request", a3), e5.emit("add-key-request-" + n4);
            }
          }, e5.updateSrc = function(t4, n4) {
            var a3 = n4.name, r4 = n4.namespace, o2 = n4.new_value, i2 = (n4.existing_value, n4.variable_removed);
            r4.shift();
            var s3, c3 = e5.get(t4, "global", "src"), l3 = e5.deepCopy(c3, B(r4)), u2 = l3, f3 = L(r4);
            try {
              for (f3.s(); !(s3 = f3.n()).done; ) {
                u2 = u2[s3.value];
              }
            } catch (e6) {
              f3.e(e6);
            } finally {
              f3.f();
            }
            return i2 ? _(u2) == "array" ? u2.splice(a3, 1) : delete u2[a3] : a3 !== null ? u2[a3] = o2 : l3 = o2, e5.set(t4, "global", "src", l3), l3;
          }, e5.deepCopy = function(t4, n4) {
            var a3, r4 = _(t4), i2 = n4.shift();
            return r4 == "array" ? a3 = B(t4) : r4 == "object" && (a3 = o({}, t4)), i2 !== void 0 && (a3[i2] = e5.deepCopy(t4[i2], n4)), a3;
          }, e5;
        }
        return n3;
      }(N.EventEmitter))();
      z2.register(T.handleAction.bind(T));
      var q2 = T, V = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.getFunctionDisplay = function(e6) {
            var t4 = d2(a2).props;
            return e6 ? m2.a.createElement("span", null, a2.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), m2.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, m2.a.createElement("span", null, "{"), m2.a.createElement("span", A2(t4.theme, "ellipsis"), "..."), m2.a.createElement("span", null, "}"))) : a2.props.value.toString().slice(9, -1);
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = this.state.collapsed;
          return m2.a.createElement("div", A2(e5.theme, "function"), m2.a.createElement(M, Object.assign({ type_name: "function" }, e5)), m2.a.createElement("span", Object.assign({}, A2(e5.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(t4)));
        } }]), n3;
      }(m2.a.PureComponent), K = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "nan"), "NaN");
        } }]), n3;
      }(m2.a.PureComponent), W = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "null"), "NULL");
        } }]), n3;
      }(m2.a.PureComponent), H = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "integer"), m2.a.createElement(M, Object.assign({ type_name: "int" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent), U = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "regexp"), m2.a.createElement(M, Object.assign({ type_name: "regexp" }, e5)), this.props.value.toString());
        } }]), n3;
      }(m2.a.PureComponent), G = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          this.state.collapsed;
          var e5 = this.props, t4 = e5.collapseStringsAfterLength, n4 = e5.theme, a2 = e5.value, r3 = { style: { cursor: "default" } };
          return _(t4) === "integer" && a2.length > t4 && (r3.style.cursor = "pointer", this.state.collapsed && (a2 = m2.a.createElement("span", null, a2.substring(0, t4), m2.a.createElement("span", A2(n4, "ellipsis"), " ...")))), m2.a.createElement("div", A2(n4, "string"), m2.a.createElement(M, Object.assign({ type_name: "string" }, e5)), m2.a.createElement("span", Object.assign({ className: "string-value" }, r3, { onClick: this.toggleCollapsed }), '"', a2, '"'));
        } }]), n3;
      }(m2.a.PureComponent), J = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "undefined"), "undefined");
        } }]), n3;
      }(m2.a.PureComponent);
      function Y() {
        return (Y = Object.assign || function(e4) {
          for (var t3 = 1; t3 < arguments.length; t3++) {
            var n3 = arguments[t3];
            for (var a2 in n3)
              Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
          }
          return e4;
        }).apply(this, arguments);
      }
      var $ = v4.useLayoutEffect, Q = function(e4) {
        var t3 = Object(v4.useRef)(e4);
        return $(function() {
          t3.current = e4;
        }), t3;
      }, Z = function(e4, t3) {
        typeof e4 != "function" ? e4.current = t3 : e4(t3);
      }, X = function(e4, t3) {
        var n3 = Object(v4.useRef)();
        return Object(v4.useCallback)(function(a2) {
          e4.current = a2, n3.current && Z(n3.current, null), n3.current = t3, t3 && Z(t3, a2);
        }, [t3]);
      }, ee = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, te = function(e4) {
        Object.keys(ee).forEach(function(t3) {
          e4.style.setProperty(t3, ee[t3], "important");
        });
      }, ne = null;
      var ae = function() {
      }, re = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], oe = !!document.documentElement.currentStyle, ie = function(e4, t3) {
        var n3 = e4.cacheMeasurements, a2 = e4.maxRows, r3 = e4.minRows, o2 = e4.onChange, i2 = o2 === void 0 ? ae : o2, s2 = e4.onHeightChange, c3 = s2 === void 0 ? ae : s2, l3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]);
        var u2, f3 = l3.value !== void 0, p3 = Object(v4.useRef)(null), d3 = X(p3, t3), b3 = Object(v4.useRef)(0), h2 = Object(v4.useRef)(), m3 = function() {
          var e5 = p3.current, t4 = n3 && h2.current ? h2.current : function(e6) {
            var t5 = window.getComputedStyle(e6);
            if (t5 === null)
              return null;
            var n4, a3 = (n4 = t5, re.reduce(function(e7, t6) {
              return e7[t6] = n4[t6], e7;
            }, {})), r4 = a3.boxSizing;
            return r4 === "" ? null : (oe && r4 === "border-box" && (a3.width = parseFloat(a3.width) + parseFloat(a3.borderRightWidth) + parseFloat(a3.borderLeftWidth) + parseFloat(a3.paddingRight) + parseFloat(a3.paddingLeft) + "px"), { sizingStyle: a3, paddingSize: parseFloat(a3.paddingBottom) + parseFloat(a3.paddingTop), borderSize: parseFloat(a3.borderBottomWidth) + parseFloat(a3.borderTopWidth) });
          }(e5);
          if (t4) {
            h2.current = t4;
            var o3 = function(e6, t5, n4, a3) {
              n4 === void 0 && (n4 = 1), a3 === void 0 && (a3 = 1 / 0), ne || ((ne = document.createElement("textarea")).setAttribute("tab-index", "-1"), ne.setAttribute("aria-hidden", "true"), te(ne)), ne.parentNode === null && document.body.appendChild(ne);
              var r4 = e6.paddingSize, o4 = e6.borderSize, i4 = e6.sizingStyle, s4 = i4.boxSizing;
              Object.keys(i4).forEach(function(e7) {
                var t6 = e7;
                ne.style[t6] = i4[t6];
              }), te(ne), ne.value = t5;
              var c4 = function(e7, t6) {
                var n5 = e7.scrollHeight;
                return t6.sizingStyle.boxSizing === "border-box" ? n5 + t6.borderSize : n5 - t6.paddingSize;
              }(ne, e6);
              ne.value = "x";
              var l4 = ne.scrollHeight - r4, u3 = l4 * n4;
              s4 === "border-box" && (u3 = u3 + r4 + o4), c4 = Math.max(u3, c4);
              var f4 = l4 * a3;
              return s4 === "border-box" && (f4 = f4 + r4 + o4), [c4 = Math.min(f4, c4), l4];
            }(t4, e5.value || e5.placeholder || "x", r3, a2), i3 = o3[0], s3 = o3[1];
            b3.current !== i3 && (b3.current = i3, e5.style.setProperty("height", i3 + "px", "important"), c3(i3, { rowHeight: s3 }));
          }
        };
        return Object(v4.useLayoutEffect)(m3), u2 = Q(m3), Object(v4.useLayoutEffect)(function() {
          var e5 = function(e6) {
            u2.current(e6);
          };
          return window.addEventListener("resize", e5), function() {
            window.removeEventListener("resize", e5);
          };
        }, []), Object(v4.createElement)("textarea", Y({}, l3, { onChange: function(e5) {
          f3 || m3(), i2(e5);
        }, ref: d3 }));
      }, se = Object(v4.forwardRef)(ie);
      function ce(e4) {
        e4 = e4.trim();
        try {
          if ((e4 = JSON.stringify(JSON.parse(e4)))[0] === "[")
            return le("array", JSON.parse(e4));
          if (e4[0] === "{")
            return le("object", JSON.parse(e4));
          if (e4.match(/\-?\d+\.\d+/) && e4.match(/\-?\d+\.\d+/)[0] === e4)
            return le("float", parseFloat(e4));
          if (e4.match(/\-?\d+e-\d+/) && e4.match(/\-?\d+e-\d+/)[0] === e4)
            return le("float", Number(e4));
          if (e4.match(/\-?\d+/) && e4.match(/\-?\d+/)[0] === e4)
            return le("integer", parseInt(e4));
          if (e4.match(/\-?\d+e\+\d+/) && e4.match(/\-?\d+e\+\d+/)[0] === e4)
            return le("integer", Number(e4));
        } catch (e5) {
        }
        switch (e4 = e4.toLowerCase()) {
          case "undefined":
            return le("undefined", void 0);
          case "nan":
            return le("nan", NaN);
          case "null":
            return le("null", null);
          case "true":
            return le("boolean", true);
          case "false":
            return le("boolean", false);
          default:
            if (e4 = Date.parse(e4))
              return le("date", new Date(e4));
        }
        return le(false, null);
      }
      function le(e4, t3) {
        return { type: e4, value: t3 };
      }
      var ue = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
        } }]), n3;
      }(m2.a.PureComponent), fe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
        } }]), n3;
      }(m2.a.PureComponent), pe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), de = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), be = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), he = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), ve = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), me = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ye = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ge = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
        } }]), n3;
      }(m2.a.PureComponent), Ee = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), je = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent);
      function xe(e4) {
        return e4 || (e4 = {}), { style: o(o({ verticalAlign: "middle" }, e4), {}, { color: e4.color ? e4.color : "#000000", height: "1em", width: "1em" }) };
      }
      var _e = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).copiedTimer = null, a2.handleCopy = function() {
            var e6 = document.createElement("textarea"), t4 = a2.props, n4 = t4.clickCallback, r3 = t4.src, o2 = t4.namespace;
            e6.innerHTML = JSON.stringify(a2.clipboardValue(r3), null, "  "), document.body.appendChild(e6), e6.select(), document.execCommand("copy"), document.body.removeChild(e6), a2.copiedTimer = setTimeout(function() {
              a2.setState({ copied: false });
            }, 5500), a2.setState({ copied: true }, function() {
              typeof n4 == "function" && n4({ src: r3, namespace: o2, name: o2[o2.length - 1] });
            });
          }, a2.getClippyIcon = function() {
            var e6 = a2.props.theme;
            return a2.state.copied ? m2.a.createElement("span", null, m2.a.createElement(ve, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon"))), m2.a.createElement("span", A2(e6, "copy-icon-copied"), "\u2714")) : m2.a.createElement(ve, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon")));
          }, a2.clipboardValue = function(e6) {
            switch (_(e6)) {
              case "function":
              case "regexp":
                return e6.toString();
              default:
                return e6;
            }
          }, a2.state = { copied: false }, a2;
        }
        return c2(n3, [{ key: "componentWillUnmount", value: function() {
          this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
        } }, { key: "render", value: function() {
          var e5 = this.props, t4 = (e5.src, e5.theme), n4 = e5.hidden, a2 = e5.rowHovered, r3 = A2(t4, "copy-to-clipboard").style, i2 = "inline";
          return n4 && (i2 = "none"), m2.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: a2 ? "inline-block" : "none" } }, m2.a.createElement("span", { style: o(o({}, r3), {}, { display: i2 }), onClick: this.handleCopy }, this.getClippyIcon()));
        } }]), n3;
      }(m2.a.PureComponent), ke = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).getEditIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.theme;
            return m2.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(Ee, Object.assign({ className: "click-to-edit-icon" }, A2(n4, "editVarIcon"), { onClick: function() {
              a2.prepopInput(t4);
            } })));
          }, a2.prepopInput = function(e6) {
            if (a2.props.onEdit !== false) {
              var t4 = function(e7) {
                var t5;
                switch (_(e7)) {
                  case "undefined":
                    t5 = "undefined";
                    break;
                  case "nan":
                    t5 = "NaN";
                    break;
                  case "string":
                    t5 = e7;
                    break;
                  case "date":
                  case "function":
                  case "regexp":
                    t5 = e7.toString();
                    break;
                  default:
                    try {
                      t5 = JSON.stringify(e7, null, "  ");
                    } catch (e8) {
                      t5 = "";
                    }
                }
                return t5;
              }(e6.value), n4 = ce(t4);
              a2.setState({ editMode: true, editValue: t4, parsedInput: { type: n4.type, value: n4.value } });
            }
          }, a2.getRemoveIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.namespace, r3 = e6.theme, o2 = e6.rjvId;
            return m2.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(me, Object.assign({ className: "click-to-remove-icon" }, A2(r3, "removeVarIcon"), { onClick: function() {
              z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: o2, data: { name: t4.name, namespace: n4, existing_value: t4.value, variable_removed: true } });
            } })));
          }, a2.getValue = function(e6, t4) {
            var n4 = !t4 && e6.type, r3 = d2(a2).props;
            switch (n4) {
              case false:
                return a2.getEditInput();
              case "string":
                return m2.a.createElement(G, Object.assign({ value: e6.value }, r3));
              case "integer":
                return m2.a.createElement(H, Object.assign({ value: e6.value }, r3));
              case "float":
                return m2.a.createElement(D, Object.assign({ value: e6.value }, r3));
              case "boolean":
                return m2.a.createElement(P, Object.assign({ value: e6.value }, r3));
              case "function":
                return m2.a.createElement(V, Object.assign({ value: e6.value }, r3));
              case "null":
                return m2.a.createElement(W, r3);
              case "nan":
                return m2.a.createElement(K, r3);
              case "undefined":
                return m2.a.createElement(J, r3);
              case "date":
                return m2.a.createElement(F, Object.assign({ value: e6.value }, r3));
              case "regexp":
                return m2.a.createElement(U, Object.assign({ value: e6.value }, r3));
              default:
                return m2.a.createElement("div", { className: "object-value" }, JSON.stringify(e6.value));
            }
          }, a2.getEditInput = function() {
            var e6 = a2.props.theme, t4 = a2.state.editValue;
            return m2.a.createElement("div", null, m2.a.createElement(se, Object.assign({ type: "text", inputRef: function(e7) {
              return e7 && e7.focus();
            }, value: t4, className: "variable-editor", onChange: function(e7) {
              var t5 = e7.target.value, n4 = ce(t5);
              a2.setState({ editValue: t5, parsedInput: { type: n4.type, value: n4.value } });
            }, onKeyDown: function(e7) {
              switch (e7.key) {
                case "Escape":
                  a2.setState({ editMode: false, editValue: "" });
                  break;
                case "Enter":
                  (e7.ctrlKey || e7.metaKey) && a2.submitEdit(true);
              }
              e7.stopPropagation();
            }, placeholder: "update this value", minRows: 2 }, A2(e6, "edit-input"))), m2.a.createElement("div", A2(e6, "edit-icon-container"), m2.a.createElement(me, Object.assign({ className: "edit-cancel" }, A2(e6, "cancel-icon"), { onClick: function() {
              a2.setState({ editMode: false, editValue: "" });
            } })), m2.a.createElement(je, Object.assign({ className: "edit-check string-value" }, A2(e6, "check-icon"), { onClick: function() {
              a2.submitEdit();
            } })), m2.a.createElement("div", null, a2.showDetected())));
          }, a2.submitEdit = function(e6) {
            var t4 = a2.props, n4 = t4.variable, r3 = t4.namespace, o2 = t4.rjvId, i2 = a2.state, s2 = i2.editValue, c3 = i2.parsedInput, l3 = s2;
            e6 && c3.type && (l3 = c3.value), a2.setState({ editMode: false }), z2.dispatch({ name: "VARIABLE_UPDATED", rjvId: o2, data: { name: n4.name, namespace: r3, existing_value: n4.value, new_value: l3, variable_removed: false } });
          }, a2.showDetected = function() {
            var e6 = a2.props, t4 = e6.theme, n4 = (e6.variable, e6.namespace, e6.rjvId, a2.state.parsedInput), r3 = (n4.type, n4.value, a2.getDetectedInput());
            if (r3)
              return m2.a.createElement("div", null, m2.a.createElement("div", A2(t4, "detected-row"), r3, m2.a.createElement(je, { className: "edit-check detected", style: o({ verticalAlign: "top", paddingLeft: "3px" }, A2(t4, "check-icon").style), onClick: function() {
                a2.submitEdit(true);
              } })));
          }, a2.getDetectedInput = function() {
            var e6 = a2.state.parsedInput, t4 = e6.type, n4 = e6.value, r3 = d2(a2).props, i2 = r3.theme;
            if (t4 !== false)
              switch (t4.toLowerCase()) {
                case "object":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "{"), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "}"));
                case "array":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "["), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "]"));
                case "string":
                  return m2.a.createElement(G, Object.assign({ value: n4 }, r3));
                case "integer":
                  return m2.a.createElement(H, Object.assign({ value: n4 }, r3));
                case "float":
                  return m2.a.createElement(D, Object.assign({ value: n4 }, r3));
                case "boolean":
                  return m2.a.createElement(P, Object.assign({ value: n4 }, r3));
                case "function":
                  return m2.a.createElement(V, Object.assign({ value: n4 }, r3));
                case "null":
                  return m2.a.createElement(W, r3);
                case "nan":
                  return m2.a.createElement(K, r3);
                case "undefined":
                  return m2.a.createElement(J, r3);
                case "date":
                  return m2.a.createElement(F, Object.assign({ value: new Date(n4) }, r3));
              }
          }, a2.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.variable, a2 = t4.singleIndent, r3 = t4.type, i2 = t4.theme, s2 = t4.namespace, c3 = t4.indentWidth, l3 = t4.enableClipboard, u2 = t4.onEdit, f3 = t4.onDelete, p3 = t4.onSelect, d3 = t4.displayArrayKey, b3 = t4.quotesOnKeys, h2 = this.state.editMode;
          return m2.a.createElement("div", Object.assign({}, A2(i2, "objectKeyVal", { paddingLeft: c3 * a2 }), { onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          }, className: "variable-row", key: n4.name }), r3 == "array" ? d3 ? m2.a.createElement("span", Object.assign({}, A2(i2, "array-key"), { key: n4.name + "_" + s2 }), n4.name, m2.a.createElement("div", A2(i2, "colon"), ":")) : null : m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({}, A2(i2, "object-name"), { className: "object-key", key: n4.name + "_" + s2 }), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", { style: { display: "inline-block" } }, n4.name), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(i2, "colon"), ":")), m2.a.createElement("div", Object.assign({ className: "variable-value", onClick: p3 === false && u2 === false ? null : function(t5) {
            var a3 = B(s2);
            (t5.ctrlKey || t5.metaKey) && u2 !== false ? e5.prepopInput(n4) : p3 !== false && (a3.shift(), p3(o(o({}, n4), {}, { namespace: a3 })));
          } }, A2(i2, "variableValue", { cursor: p3 === false ? "default" : "pointer" })), this.getValue(n4, h2)), l3 ? m2.a.createElement(_e, { rowHovered: this.state.hovered, hidden: h2, src: n4.value, clickCallback: l3, theme: i2, namespace: [].concat(B(s2), [n4.name]) }) : null, u2 !== false && h2 == 0 ? this.getEditIcon() : null, f3 !== false && h2 == 0 ? this.getRemoveIcon() : null);
        } }]), n3;
      }(m2.a.PureComponent), Oe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).getObjectSize = function() {
            var t4 = e5.props, n4 = t4.size, a3 = t4.theme;
            if (t4.displayObjectSize)
              return m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(a3, "object-size")), n4, " item", n4 === 1 ? "" : "s");
          }, e5.getAddAttribute = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = n4.namespace, i2 = n4.name, s3 = n4.src, c3 = n4.rjvId, l3 = n4.depth;
            return m2.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: t4 ? "inline-block" : "none" } }, m2.a.createElement(ye, Object.assign({ className: "click-to-add-icon" }, A2(a3, "addVarIcon"), { onClick: function() {
              var e6 = { name: l3 > 0 ? i2 : null, namespace: r4.splice(0, r4.length - 1), existing_value: s3, variable_removed: false, key_name: null };
              _(s3) === "object" ? z2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: c3, data: e6 }) : z2.dispatch({ name: "VARIABLE_ADDED", rjvId: c3, data: o(o({}, e6), {}, { new_value: [].concat(B(s3), [null]) }) });
            } })));
          }, e5.getRemoveObject = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = (n4.hover, n4.namespace), o2 = n4.name, i2 = n4.src, s3 = n4.rjvId;
            if (r4.length !== 1)
              return m2.a.createElement("span", { className: "click-to-remove", style: { display: t4 ? "inline-block" : "none" } }, m2.a.createElement(me, Object.assign({ className: "click-to-remove-icon" }, A2(a3, "removeVarIcon"), { onClick: function() {
                z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: s3, data: { name: o2, namespace: r4.splice(0, r4.length - 1), existing_value: i2, variable_removed: true } });
              } })));
          }, e5.render = function() {
            var t4 = e5.props, n4 = t4.theme, a3 = t4.onDelete, r4 = t4.onAdd, o2 = t4.enableClipboard, i2 = t4.src, s3 = t4.namespace, c3 = t4.rowHovered;
            return m2.a.createElement("div", Object.assign({}, A2(n4, "object-meta-data"), { className: "object-meta-data", onClick: function(e6) {
              e6.stopPropagation();
            } }), e5.getObjectSize(), o2 ? m2.a.createElement(_e, { rowHovered: c3, clickCallback: o2, src: i2, theme: n4, namespace: s3 }) : null, r4 !== false ? e5.getAddAttribute(c3) : null, a3 !== false ? e5.getRemoveObject(c3) : null);
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent);
      function Ce(e4) {
        var t3 = e4.parent_type, n3 = e4.namespace, a2 = e4.quotesOnKeys, r3 = e4.theme, o2 = e4.jsvRoot, i2 = e4.name, s2 = e4.displayArrayKey, c3 = e4.name ? e4.name : "";
        return !o2 || i2 !== false && i2 !== null ? t3 == "array" ? s2 ? m2.a.createElement("span", Object.assign({}, A2(r3, "array-key"), { key: n3 }), m2.a.createElement("span", { className: "array-key" }, c3), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null) : m2.a.createElement("span", Object.assign({}, A2(r3, "object-name"), { key: n3 }), m2.a.createElement("span", { className: "object-key" }, a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", null, c3), a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null);
      }
      function Se(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(he, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          case "square":
            return m2.a.createElement(pe, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          default:
            return m2.a.createElement(ue, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
        }
      }
      function we(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(be, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          case "square":
            return m2.a.createElement(de, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          default:
            return m2.a.createElement(fe, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
        }
      }
      var Ae = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function(e6) {
            var t4 = [];
            for (var n4 in a2.state.expanded)
              t4.push(a2.state.expanded[n4]);
            t4[e6] = !t4[e6], a2.setState({ expanded: t4 });
          }, a2.state = { expanded: [] }, a2;
        }
        return c2(n3, [{ key: "getExpandedIcon", value: function(e5) {
          var t4 = this.props, n4 = t4.theme, a2 = t4.iconStyle;
          return this.state.expanded[e5] ? m2.a.createElement(Se, { theme: n4, iconStyle: a2 }) : m2.a.createElement(we, { theme: n4, iconStyle: a2 });
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.src, a2 = t4.groupArraysAfterLength, r3 = (t4.depth, t4.name), o2 = t4.theme, i2 = t4.jsvRoot, s2 = t4.namespace, c3 = (t4.parent_type, x2(t4, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), l3 = 0, u2 = 5 * this.props.indentWidth;
          i2 || (l3 = 5 * this.props.indentWidth);
          var f3 = a2, p3 = Math.ceil(n4.length / f3);
          return m2.a.createElement("div", Object.assign({ className: "object-key-val" }, A2(o2, i2 ? "jsv-root" : "objectKeyVal", { paddingLeft: l3 })), m2.a.createElement(Ce, this.props), m2.a.createElement("span", null, m2.a.createElement(Oe, Object.assign({ size: n4.length }, this.props))), B(Array(p3)).map(function(t5, a3) {
            return m2.a.createElement("div", Object.assign({ key: a3, className: "object-key-val array-group" }, A2(o2, "objectKeyVal", { marginLeft: 6, paddingLeft: u2 })), m2.a.createElement("span", A2(o2, "brace-row"), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            } }), e5.getExpandedIcon(a3)), e5.state.expanded[a3] ? m2.a.createElement(Fe, Object.assign({ key: r3 + a3, depth: 0, name: false, collapsed: false, groupArraysAfterLength: f3, index_offset: a3 * f3, src: n4.slice(a3 * f3, a3 * f3 + f3), namespace: s2, type: "array", parent_type: "array_group", theme: o2 }, c3)) : m2.a.createElement("span", Object.assign({}, A2(o2, "brace"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            }, className: "array-group-brace" }), "[", m2.a.createElement("div", Object.assign({}, A2(o2, "array-group-meta-data"), { className: "array-group-meta-data" }), m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(o2, "object-size")), a3 * f3, " - ", a3 * f3 + f3 > n4.length ? n4.length : a3 * f3 + f3)), "]")));
          }));
        } }]), n3;
      }(m2.a.PureComponent), Me = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ expanded: !a2.state.expanded }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "expanded", a2.state.expanded);
            });
          }, a2.getObjectContent = function(e6, t4, n4) {
            return m2.a.createElement("div", { className: "pushed-content object-container" }, m2.a.createElement("div", Object.assign({ className: "object-content" }, A2(a2.props.theme, "pushed-content")), a2.renderObjectContents(t4, n4)));
          }, a2.getEllipsis = function() {
            return a2.state.size === 0 ? null : m2.a.createElement("div", Object.assign({}, A2(a2.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: a2.toggleCollapsed }), "...");
          }, a2.getObjectMetaData = function(e6) {
            var t4 = a2.props, n4 = (t4.rjvId, t4.theme, a2.state), r4 = n4.size, o2 = n4.hovered;
            return m2.a.createElement(Oe, Object.assign({ rowHovered: o2, size: r4 }, a2.props));
          }, a2.renderObjectContents = function(e6, t4) {
            var n4, r4 = a2.props, o2 = r4.depth, i2 = r4.parent_type, s2 = r4.index_offset, c3 = r4.groupArraysAfterLength, l3 = r4.namespace, u2 = a2.state.object_type, f3 = [], p3 = Object.keys(e6 || {});
            return a2.props.sortKeys && u2 !== "array" && (p3 = p3.sort()), p3.forEach(function(r5) {
              if (n4 = new Pe(r5, e6[r5]), i2 === "array_group" && s2 && (n4.name = parseInt(n4.name) + s2), e6.hasOwnProperty(r5))
                if (n4.type === "object")
                  f3.push(m2.a.createElement(Fe, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), parent_type: u2 }, t4)));
                else if (n4.type === "array") {
                  var p4 = Fe;
                  c3 && n4.value.length > c3 && (p4 = Ae), f3.push(m2.a.createElement(p4, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), type: "array", parent_type: u2 }, t4)));
                } else
                  f3.push(m2.a.createElement(ke, Object.assign({ key: n4.name + "_" + l3, variable: n4, singleIndent: 5, namespace: l3, type: a2.props.type }, t4)));
            }), f3;
          };
          var r3 = n3.getState(e5);
          return a2.state = o(o({}, r3), {}, { prevProps: {} }), a2;
        }
        return c2(n3, [{ key: "getBraceStart", value: function(e5, t4) {
          var n4 = this, a2 = this.props, r3 = a2.src, o2 = a2.theme, i2 = a2.iconStyle;
          if (a2.parent_type === "array_group")
            return m2.a.createElement("span", null, m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{"), t4 ? this.getObjectMetaData(r3) : null);
          var s2 = t4 ? Se : we;
          return m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({ onClick: function(e6) {
            n4.toggleCollapsed();
          } }, A2(o2, "brace-row")), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container")), m2.a.createElement(s2, { theme: o2, iconStyle: i2 })), m2.a.createElement(Ce, this.props), m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{")), t4 ? this.getObjectMetaData(r3) : null);
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.depth, a2 = t4.src, r3 = (t4.namespace, t4.name, t4.type, t4.parent_type), i2 = t4.theme, s2 = t4.jsvRoot, c3 = t4.iconStyle, l3 = x2(t4, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), u2 = this.state, f3 = u2.object_type, p3 = u2.expanded, d3 = {};
          return s2 || r3 === "array_group" ? r3 === "array_group" && (d3.borderLeft = 0, d3.display = "inline") : d3.paddingLeft = 5 * this.props.indentWidth, m2.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          } }, A2(i2, s2 ? "jsv-root" : "objectKeyVal", d3)), this.getBraceStart(f3, p3), p3 ? this.getObjectContent(n4, a2, o({ theme: i2, iconStyle: c3 }, l3)) : this.getEllipsis(), m2.a.createElement("span", { className: "brace-row" }, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { paddingLeft: p3 ? "3px" : "0px" }) }, f3 === "array" ? "]" : "}"), p3 ? null : this.getObjectMetaData(a2)));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          var a2 = t4.prevProps;
          return e5.src !== a2.src || e5.collapsed !== a2.collapsed || e5.name !== a2.name || e5.namespace !== a2.namespace || e5.rjvId !== a2.rjvId ? o(o({}, n3.getState(e5)), {}, { prevProps: e5 }) : null;
        } }]), n3;
      }(m2.a.PureComponent);
      Me.getState = function(e4) {
        var t3 = Object.keys(e4.src).length, n3 = (e4.collapsed === false || e4.collapsed !== true && e4.collapsed > e4.depth) && (!e4.shouldCollapse || e4.shouldCollapse({ name: e4.name, src: e4.src, type: _(e4.src), namespace: e4.namespace }) === false) && t3 !== 0;
        return { expanded: q2.get(e4.rjvId, e4.namespace, "expanded", n3), object_type: e4.type === "array" ? "array" : "object", parent_type: e4.type === "array" ? "array" : "object", size: t3, hovered: false };
      };
      var Pe = function e4(t3, n3) {
        i(this, e4), this.name = t3, this.value = n3, this.type = _(n3);
      };
      j(Me);
      var Fe = Me, De = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), o2 = 0; o2 < a2; o2++)
            r3[o2] = arguments[o2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).render = function() {
            var t4 = d2(e5).props, n4 = [t4.name], a3 = Fe;
            return Array.isArray(t4.src) && t4.groupArraysAfterLength && t4.src.length > t4.groupArraysAfterLength && (a3 = Ae), m2.a.createElement("div", { className: "pretty-json-container object-container" }, m2.a.createElement("div", { className: "object-content" }, m2.a.createElement(a3, Object.assign({ namespace: n4, depth: 0, jsvRoot: true }, t4))));
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent), Ie = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).closeModal = function() {
            z2.dispatch({ rjvId: a2.props.rjvId, name: "RESET" });
          }, a2.submit = function() {
            a2.props.submit(a2.state.input);
          }, a2.state = { input: e5.input ? e5.input : "" }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.theme, a2 = t4.rjvId, r3 = t4.isValid, o2 = this.state.input, i2 = r3(o2);
          return m2.a.createElement("div", Object.assign({ className: "key-modal-request" }, A2(n4, "key-modal-request"), { onClick: this.closeModal }), m2.a.createElement("div", Object.assign({}, A2(n4, "key-modal"), { onClick: function(e6) {
            e6.stopPropagation();
          } }), m2.a.createElement("div", A2(n4, "key-modal-label"), "Key Name:"), m2.a.createElement("div", { style: { position: "relative" } }, m2.a.createElement("input", Object.assign({}, A2(n4, "key-modal-input"), { className: "key-modal-input", ref: function(e6) {
            return e6 && e6.focus();
          }, spellCheck: false, value: o2, placeholder: "...", onChange: function(t5) {
            e5.setState({ input: t5.target.value });
          }, onKeyPress: function(t5) {
            i2 && t5.key === "Enter" ? e5.submit() : t5.key === "Escape" && e5.closeModal();
          } })), i2 ? m2.a.createElement(je, Object.assign({}, A2(n4, "key-modal-submit"), { className: "key-modal-submit", onClick: function(t5) {
            return e5.submit();
          } })) : null), m2.a.createElement("span", A2(n4, "key-modal-cancel"), m2.a.createElement(ge, Object.assign({}, A2(n4, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
            z2.dispatch({ rjvId: a2, name: "RESET" });
          } })))));
        } }]), n3;
      }(m2.a.PureComponent), Re = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).isValid = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            return t4 != "" && Object.keys(a3.existing_value).indexOf(t4) === -1;
          }, e5.submit = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            a3.new_value = o({}, a3.existing_value), a3.new_value[t4] = e5.props.defaultValue, z2.dispatch({ name: "VARIABLE_ADDED", rjvId: n4, data: a3 });
          }, e5;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.active, n4 = e5.theme, a2 = e5.rjvId;
          return t4 ? m2.a.createElement(Ie, { rjvId: a2, theme: n4, isValid: this.isValid, submit: this.submit }) : null;
        } }]), n3;
      }(m2.a.PureComponent), Le = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.message, n4 = e5.active, a2 = e5.theme, r3 = e5.rjvId;
          return n4 ? m2.a.createElement("div", Object.assign({ className: "validation-failure" }, A2(a2, "validation-failure"), { onClick: function() {
            z2.dispatch({ rjvId: r3, name: "RESET" });
          } }), m2.a.createElement("span", A2(a2, "validation-failure-label"), t4), m2.a.createElement(ge, A2(a2, "validation-failure-clear"))) : null;
        } }]), n3;
      }(m2.a.PureComponent), Be = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).rjvId = Date.now().toString(), a2.getListeners = function() {
            return { reset: a2.resetState, "variable-update": a2.updateSrc, "add-key-request": a2.addKeyRequest };
          }, a2.updateSrc = function() {
            var e6, t4 = q2.get(a2.rjvId, "action", "variable-update"), n4 = t4.name, r3 = t4.namespace, o2 = t4.new_value, i2 = t4.existing_value, s2 = (t4.variable_removed, t4.updated_src), c3 = t4.type, l3 = a2.props, u2 = l3.onEdit, f3 = l3.onDelete, p3 = l3.onAdd, d3 = { existing_src: a2.state.src, new_value: o2, updated_src: s2, name: n4, namespace: r3, existing_value: i2 };
            switch (c3) {
              case "variable-added":
                e6 = p3(d3);
                break;
              case "variable-edited":
                e6 = u2(d3);
                break;
              case "variable-removed":
                e6 = f3(d3);
            }
            e6 !== false ? (q2.set(a2.rjvId, "global", "src", s2), a2.setState({ src: s2 })) : a2.setState({ validationFailure: true });
          }, a2.addKeyRequest = function() {
            a2.setState({ addKeyRequest: true });
          }, a2.resetState = function() {
            a2.setState({ validationFailure: false, addKeyRequest: false });
          }, a2.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: n3.defaultProps.src, name: n3.defaultProps.name, theme: n3.defaultProps.theme, validationMessage: n3.defaultProps.validationMessage, prevSrc: n3.defaultProps.src, prevName: n3.defaultProps.name, prevTheme: n3.defaultProps.theme }, a2;
        }
        return c2(n3, [{ key: "componentDidMount", value: function() {
          q2.set(this.rjvId, "global", "src", this.state.src);
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.on(t4 + "-" + this.rjvId, e5[t4]);
          this.setState({ addKeyRequest: false, editKeyRequest: false });
        } }, { key: "componentDidUpdate", value: function(e5, t4) {
          t4.addKeyRequest !== false && this.setState({ addKeyRequest: false }), t4.editKeyRequest !== false && this.setState({ editKeyRequest: false }), e5.src !== this.state.src && q2.set(this.rjvId, "global", "src", this.state.src);
        } }, { key: "componentWillUnmount", value: function() {
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.removeListener(t4 + "-" + this.rjvId, e5[t4]);
        } }, { key: "render", value: function() {
          var e5 = this.state, t4 = e5.validationFailure, n4 = e5.validationMessage, a2 = e5.addKeyRequest, r3 = e5.theme, i2 = e5.src, s2 = e5.name, c3 = this.props, l3 = c3.style, u2 = c3.defaultValue;
          return m2.a.createElement("div", { className: "react-json-view", style: o(o({}, A2(r3, "app-container").style), l3) }, m2.a.createElement(Le, { message: n4, active: t4, theme: r3, rjvId: this.rjvId }), m2.a.createElement(De, Object.assign({}, this.props, { src: i2, name: s2, theme: r3, type: _(i2), rjvId: this.rjvId })), m2.a.createElement(Re, { active: a2, theme: r3, rjvId: this.rjvId, defaultValue: u2 }));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          if (e5.src !== t4.prevSrc || e5.name !== t4.prevName || e5.theme !== t4.prevTheme) {
            var a2 = { src: e5.src, name: e5.name, theme: e5.theme, validationMessage: e5.validationMessage, prevSrc: e5.src, prevName: e5.name, prevTheme: e5.theme };
            return n3.validateState(a2);
          }
          return null;
        } }]), n3;
      }(m2.a.PureComponent);
      Be.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Be.validateState = function(e4) {
        var t3 = {};
        return _(e4.theme) !== "object" || function(e5) {
          var t4 = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
          if (_(e5) === "object") {
            for (var n3 = 0; n3 < t4.length; n3++)
              if (!(t4[n3] in e5))
                return false;
            return true;
          }
          return false;
        }(e4.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), t3.theme = "rjv-default"), _(e4.src) !== "object" && _(e4.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), t3.name = "ERROR", t3.src = { message: "src property must be a valid json object" }), o(o({}, e4), t3);
      }, j(Be);
      t2.default = Be;
    }]);
  });
})(main);
var ReactJson = /* @__PURE__ */ getDefaultExportFromCjs(main.exports);
const OptionView = ({
  id: id2,
  title,
  chart,
  option
}) => {
  const {
    tool
  } = useEchartsTool({});
  const event = reactEchartsJson_cjs.useEventEmitter({
    global: true
  });
  const [collapsed, {
    set: toggleCollapsed
  }] = useBoolean(true);
  const optionChange = (ctrl) => {
    const {
      updated_src
    } = ctrl;
    chart == null ? void 0 : chart.setOption(updated_src);
    tool == null ? void 0 : tool.add(id2, chart, updated_src, title);
    event.emit("list");
  };
  return /* @__PURE__ */ jsxs("div", {
    children: [/* @__PURE__ */ jsx(Row$1, {
      children: /* @__PURE__ */ jsx(Col$1, {
        children: /* @__PURE__ */ jsx(Switch$1, {
          checkedChildren: "\u5C55\u5F00\u914D\u7F6E",
          unCheckedChildren: "\u6298\u53E0\u914D\u7F6E",
          defaultChecked: false,
          onChange: (e2) => {
            toggleCollapsed(!e2);
          }
        })
      })
    }), /* @__PURE__ */ jsx("br", {}), option && /* @__PURE__ */ jsx(ReactJson, {
      src: option,
      theme: "pop",
      displayObjectSize: false,
      displayDataTypes: false,
      collapsed,
      iconStyle: "triangle",
      enableClipboard: true,
      onEdit: optionChange,
      onAdd: optionChange,
      onDelete: optionChange
    })]
  });
};
export { EchartTool, OptionView as ReactEchartsJson, useEcharts, useEchartsTool, useEventEmitter };
